--
-- PostgreSQL database dump
--

-- Dumped from database version 16.1
-- Dumped by pg_dump version 16.1

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

SET default_tablespace = '';

SET default_table_access_method = heap;

--
-- Name: failed_jobs; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.failed_jobs (
    id bigint NOT NULL,
    uuid character varying(255) NOT NULL,
    connection text NOT NULL,
    queue text NOT NULL,
    payload text NOT NULL,
    exception text NOT NULL,
    failed_at timestamp(0) without time zone DEFAULT CURRENT_TIMESTAMP NOT NULL
);


ALTER TABLE public.failed_jobs OWNER TO postgres;

--
-- Name: failed_jobs_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.failed_jobs_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.failed_jobs_id_seq OWNER TO postgres;

--
-- Name: failed_jobs_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE public.failed_jobs_id_seq OWNED BY public.failed_jobs.id;


--
-- Name: item_loans; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.item_loans (
    id integer NOT NULL,
    loans_codigo integer NOT NULL,
    itemloans_cuota double precision NOT NULL,
    itemloans_valor_cuota double precision NOT NULL,
    itemloans_iteres double precision NOT NULL,
    itemloans_status character varying(100) NOT NULL,
    itemloass_observacion character varying(100),
    itemloans_fecha_pago timestamp(0) without time zone,
    itemloans_aprobador bigint,
    created_at timestamp(0) without time zone,
    updated_at timestamp(0) without time zone,
    deleted_at timestamp(0) without time zone,
    item_loans_cuando_pago timestamp(0) without time zone,
    itemloans_interes_canelado double precision,
    itemloans_cuota_cancelada double precision
);


ALTER TABLE public.item_loans OWNER TO postgres;

--
-- Name: item_loans_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.item_loans_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.item_loans_id_seq OWNER TO postgres;

--
-- Name: item_loans_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE public.item_loans_id_seq OWNED BY public.item_loans.id;


--
-- Name: item_menu; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.item_menu (
    id bigint NOT NULL,
    item_menu_profile bigint NOT NULL,
    item_menu_menu bigint NOT NULL,
    created_at timestamp(0) without time zone,
    updated_at timestamp(0) without time zone,
    deleted_at timestamp(0) without time zone
);


ALTER TABLE public.item_menu OWNER TO postgres;

--
-- Name: item_menu_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.item_menu_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.item_menu_id_seq OWNER TO postgres;

--
-- Name: item_menu_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE public.item_menu_id_seq OWNED BY public.item_menu.id;


--
-- Name: loans; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.loans (
    id integer NOT NULL,
    loans_nombre character varying(100) NOT NULL,
    loans_apellido_uno character varying(100) NOT NULL,
    loans_apellido_dos character varying(100),
    loans_tipo_documento character varying(100) NOT NULL,
    loans_documento integer NOT NULL,
    loans_fecha_nacimiento character varying(100) NOT NULL,
    loans_ciudad character varying(100) NOT NULL,
    loans_barrio character varying(100) NOT NULL,
    loans_direccion character varying(100) NOT NULL,
    loans_intereses integer NOT NULL,
    loans_cuotas integer NOT NULL,
    loans_cuando character varying(100) NOT NULL,
    loans_observacion character varying(300),
    loans_fecha character varying(100) NOT NULL,
    loans_estado character varying(100) NOT NULL,
    user_creador integer NOT NULL,
    user_recomendacion integer,
    loans_valor_prestado integer NOT NULL,
    user_customer integer,
    user_cobrador integer,
    created_at timestamp(0) without time zone,
    updated_at timestamp(0) without time zone,
    deleted_at timestamp(0) without time zone,
    loans_celular integer,
    loans_inicio_pago timestamp without time zone,
    loans_fecha_ultimo_pago character varying(100),
    loans_pago_interes double precision,
    loans_pago_prestado double precision,
    loans_intereses_recaudar double precision
);


ALTER TABLE public.loans OWNER TO postgres;

--
-- Name: loans_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.loans_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.loans_id_seq OWNER TO postgres;

--
-- Name: loans_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE public.loans_id_seq OWNED BY public.loans.id;


--
-- Name: menu; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.menu (
    id bigint NOT NULL,
    menu_name character varying(255) NOT NULL,
    menu_prefix character varying(255) NOT NULL,
    menu_url character varying(255) NOT NULL,
    created_at timestamp(0) without time zone,
    updated_at timestamp(0) without time zone,
    deleted_at timestamp(0) without time zone,
    menu_orden bigint
);


ALTER TABLE public.menu OWNER TO postgres;

--
-- Name: menu_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.menu_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.menu_id_seq OWNER TO postgres;

--
-- Name: menu_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE public.menu_id_seq OWNED BY public.menu.id;


--
-- Name: migrations; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.migrations (
    id integer NOT NULL,
    migration character varying(255) NOT NULL,
    batch integer NOT NULL
);


ALTER TABLE public.migrations OWNER TO postgres;

--
-- Name: migrations_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.migrations_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.migrations_id_seq OWNER TO postgres;

--
-- Name: migrations_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE public.migrations_id_seq OWNED BY public.migrations.id;


--
-- Name: password_reset_tokens; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.password_reset_tokens (
    email character varying(255) NOT NULL,
    token character varying(255) NOT NULL,
    created_at timestamp(0) without time zone
);


ALTER TABLE public.password_reset_tokens OWNER TO postgres;

--
-- Name: personal_access_tokens; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.personal_access_tokens (
    id bigint NOT NULL,
    tokenable_type character varying(255) NOT NULL,
    tokenable_id bigint NOT NULL,
    name character varying(255) NOT NULL,
    token character varying(64) NOT NULL,
    abilities text,
    last_used_at timestamp(0) without time zone,
    expires_at timestamp(0) without time zone,
    created_at timestamp(0) without time zone,
    updated_at timestamp(0) without time zone
);


ALTER TABLE public.personal_access_tokens OWNER TO postgres;

--
-- Name: personal_access_tokens_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.personal_access_tokens_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.personal_access_tokens_id_seq OWNER TO postgres;

--
-- Name: personal_access_tokens_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE public.personal_access_tokens_id_seq OWNED BY public.personal_access_tokens.id;


--
-- Name: profile; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.profile (
    id bigint NOT NULL,
    profile_name character varying(255) NOT NULL,
    profile_prefix character varying(255) NOT NULL,
    created_at timestamp(0) without time zone,
    updated_at timestamp(0) without time zone,
    deleted_at timestamp(0) without time zone
);


ALTER TABLE public.profile OWNER TO postgres;

--
-- Name: profile_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.profile_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.profile_id_seq OWNER TO postgres;

--
-- Name: profile_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE public.profile_id_seq OWNED BY public.profile.id;


--
-- Name: telescope_entries; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.telescope_entries (
    sequence bigint NOT NULL,
    uuid uuid NOT NULL,
    batch_id uuid NOT NULL,
    family_hash character varying(255),
    should_display_on_index boolean DEFAULT true NOT NULL,
    type character varying(20) NOT NULL,
    content text NOT NULL,
    created_at timestamp(0) without time zone
);


ALTER TABLE public.telescope_entries OWNER TO postgres;

--
-- Name: telescope_entries_sequence_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.telescope_entries_sequence_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.telescope_entries_sequence_seq OWNER TO postgres;

--
-- Name: telescope_entries_sequence_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE public.telescope_entries_sequence_seq OWNED BY public.telescope_entries.sequence;


--
-- Name: telescope_entries_tags; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.telescope_entries_tags (
    entry_uuid uuid NOT NULL,
    tag character varying(255) NOT NULL
);


ALTER TABLE public.telescope_entries_tags OWNER TO postgres;

--
-- Name: telescope_monitoring; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.telescope_monitoring (
    tag character varying(255) NOT NULL
);


ALTER TABLE public.telescope_monitoring OWNER TO postgres;

--
-- Name: users; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.users (
    id bigint NOT NULL,
    name character varying(255) NOT NULL,
    email character varying(255) NOT NULL,
    email_verified_at timestamp(0) without time zone,
    password character varying(255) NOT NULL,
    user_last_name_one character varying(255) NOT NULL,
    user_last_name_two character varying(255) NOT NULL,
    user_document_type character varying(255) NOT NULL,
    user_document character varying(255) NOT NULL,
    user_birth character varying(255) NOT NULL,
    user_city character varying(255) NOT NULL,
    user_neighborhood character varying(255) NOT NULL,
    user_address character varying(255) NOT NULL,
    user_cellphone character varying(255) NOT NULL,
    user_age double precision NOT NULL,
    profile_code bigint,
    remember_token character varying(100),
    verified character varying(255) DEFAULT '0'::character varying NOT NULL,
    verification_token character varying(255),
    created_at timestamp(0) without time zone,
    updated_at timestamp(0) without time zone,
    deleted_at timestamp(0) without time zone,
    user_alias character varying
);


ALTER TABLE public.users OWNER TO postgres;

--
-- Name: users_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.users_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.users_id_seq OWNER TO postgres;

--
-- Name: users_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE public.users_id_seq OWNED BY public.users.id;


--
-- Name: failed_jobs id; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.failed_jobs ALTER COLUMN id SET DEFAULT nextval('public.failed_jobs_id_seq'::regclass);


--
-- Name: item_loans id; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.item_loans ALTER COLUMN id SET DEFAULT nextval('public.item_loans_id_seq'::regclass);


--
-- Name: item_menu id; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.item_menu ALTER COLUMN id SET DEFAULT nextval('public.item_menu_id_seq'::regclass);


--
-- Name: loans id; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.loans ALTER COLUMN id SET DEFAULT nextval('public.loans_id_seq'::regclass);


--
-- Name: menu id; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.menu ALTER COLUMN id SET DEFAULT nextval('public.menu_id_seq'::regclass);


--
-- Name: migrations id; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.migrations ALTER COLUMN id SET DEFAULT nextval('public.migrations_id_seq'::regclass);


--
-- Name: personal_access_tokens id; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.personal_access_tokens ALTER COLUMN id SET DEFAULT nextval('public.personal_access_tokens_id_seq'::regclass);


--
-- Name: profile id; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.profile ALTER COLUMN id SET DEFAULT nextval('public.profile_id_seq'::regclass);


--
-- Name: telescope_entries sequence; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.telescope_entries ALTER COLUMN sequence SET DEFAULT nextval('public.telescope_entries_sequence_seq'::regclass);


--
-- Name: users id; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.users ALTER COLUMN id SET DEFAULT nextval('public.users_id_seq'::regclass);


--
-- Data for Name: failed_jobs; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.failed_jobs (id, uuid, connection, queue, payload, exception, failed_at) FROM stdin;
\.


--
-- Data for Name: item_loans; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.item_loans (id, loans_codigo, itemloans_cuota, itemloans_valor_cuota, itemloans_iteres, itemloans_status, itemloass_observacion, itemloans_fecha_pago, itemloans_aprobador, created_at, updated_at, deleted_at, item_loans_cuando_pago, itemloans_interes_canelado, itemloans_cuota_cancelada) FROM stdin;
106	30	1	100000	25000	0	N/A	2024-11-13 00:00:00	12	2024-10-29 13:26:20	2024-10-29 13:26:20	\N	\N	\N	\N
107	30	2	100000	25000	0	N/A	2024-11-28 00:00:00	12	2024-10-29 13:26:20	2024-10-29 13:26:20	\N	\N	\N	\N
108	30	3	100000	25000	0	N/A	2024-12-13 00:00:00	12	2024-10-29 13:26:20	2024-10-29 13:26:20	\N	\N	\N	\N
109	30	4	100000	25000	0	N/A	2024-12-28 00:00:00	12	2024-10-29 13:26:20	2024-10-29 13:26:20	\N	\N	\N	\N
110	30	5	100000	25000	0	N/A	2025-01-12 00:00:00	12	2024-10-29 13:26:20	2024-10-29 13:26:20	\N	\N	\N	\N
111	30	6	100000	25000	0	N/A	2025-01-27 00:00:00	12	2024-10-29 13:26:20	2024-10-29 13:26:20	\N	\N	\N	\N
112	30	7	100000	25000	0	N/A	2025-02-11 00:00:00	12	2024-10-29 13:26:20	2024-10-29 13:26:20	\N	\N	\N	\N
113	30	8	100000	25000	0	N/A	2025-02-26 00:00:00	12	2024-10-29 13:26:20	2024-10-29 13:26:20	\N	\N	\N	\N
114	30	9	100000	25000	0	N/A	2025-03-13 00:00:00	12	2024-10-29 13:26:20	2024-10-29 13:26:20	\N	\N	\N	\N
115	30	10	100000	25000	0	N/A	2025-03-28 00:00:00	12	2024-10-29 13:26:20	2024-10-29 13:26:20	\N	\N	\N	\N
129	39	1	71428.571428571	10416.666666667	Pendiente	N/A	2024-11-13 00:00:00	12	2024-10-29 13:50:51	2024-10-29 13:50:51	\N	\N	\N	\N
130	39	2	71428.571428571	10416.666666667	Pendiente	N/A	2024-11-28 00:00:00	12	2024-10-29 13:50:51	2024-10-29 13:50:51	\N	\N	\N	\N
131	39	3	71428.571428571	10416.666666667	Pendiente	N/A	2024-12-13 00:00:00	12	2024-10-29 13:50:51	2024-10-29 13:50:51	\N	\N	\N	\N
132	39	4	71428.571428571	10416.666666667	Pendiente	N/A	2024-12-28 00:00:00	12	2024-10-29 13:50:51	2024-10-29 13:50:51	\N	\N	\N	\N
133	39	5	71428.571428571	10416.666666667	Pendiente	N/A	2025-01-12 00:00:00	12	2024-10-29 13:50:51	2024-10-29 13:50:51	\N	\N	\N	\N
134	39	6	71428.571428571	10416.666666667	Pendiente	N/A	2025-01-27 00:00:00	12	2024-10-29 13:50:51	2024-10-29 13:50:51	\N	\N	\N	\N
135	39	7	71428.571428571	10416.666666667	Pendiente	N/A	2025-02-11 00:00:00	12	2024-10-29 13:50:51	2024-10-29 13:50:51	\N	\N	\N	\N
143	54	1	85714.285714286	15000	Pendiente	N/A	2024-11-27 00:00:00	12	2024-10-29 14:49:08	2024-10-29 14:49:08	\N	\N	\N	\N
144	54	2	85714.285714286	15000	Pendiente	N/A	2024-12-12 00:00:00	12	2024-10-29 14:49:08	2024-10-29 14:49:08	\N	\N	\N	\N
145	54	3	85714.285714286	15000	Pendiente	N/A	2024-12-27 00:00:00	12	2024-10-29 14:49:08	2024-10-29 14:49:08	\N	\N	\N	\N
146	54	4	85714.285714286	15000	Pendiente	N/A	2025-01-11 00:00:00	12	2024-10-29 14:49:08	2024-10-29 14:49:08	\N	\N	\N	\N
147	54	5	85714.285714286	15000	Pendiente	N/A	2025-01-26 00:00:00	12	2024-10-29 14:49:08	2024-10-29 14:49:08	\N	\N	\N	\N
148	54	6	85714.285714286	15000	Pendiente	N/A	2025-02-10 00:00:00	12	2024-10-29 14:49:08	2024-10-29 14:49:08	\N	\N	\N	\N
149	54	7	85714.285714286	15000	Pendiente	N/A	2025-02-25 00:00:00	12	2024-10-29 14:49:08	2024-10-29 14:49:08	\N	\N	\N	\N
157	56	1	100000	20833.333333333	Pendiente	N/A	2024-11-13 00:00:00	12	2024-10-30 10:42:30	2024-10-30 10:42:30	\N	\N	\N	\N
158	56	2	100000	20833.333333333	Pendiente	N/A	2024-11-20 00:00:00	12	2024-10-30 10:42:30	2024-10-30 10:42:30	\N	\N	\N	\N
159	56	3	100000	20833.333333333	Pendiente	N/A	2024-11-27 00:00:00	12	2024-10-30 10:42:30	2024-10-30 10:42:30	\N	\N	\N	\N
160	56	4	100000	20833.333333333	Pendiente	N/A	2024-12-04 00:00:00	12	2024-10-30 10:42:30	2024-10-30 10:42:30	\N	\N	\N	\N
161	56	5	100000	20833.333333333	Pendiente	N/A	2024-12-11 00:00:00	12	2024-10-30 10:42:30	2024-10-30 10:42:30	\N	\N	\N	\N
168	58	2	100000	50000	Pendiente	N/A	2024-11-13 00:00:00	12	2024-10-30 10:54:34	2024-10-30 10:54:34	\N	\N	\N	\N
169	58	3	100000	50000	Pendiente	N/A	2024-11-20 00:00:00	12	2024-10-30 10:54:34	2024-10-30 10:54:34	\N	\N	\N	\N
170	58	4	100000	50000	Pendiente	N/A	2024-11-27 00:00:00	12	2024-10-30 10:54:34	2024-10-30 10:54:34	\N	\N	\N	\N
171	58	5	100000	50000	Pendiente	N/A	2024-12-04 00:00:00	12	2024-10-30 10:54:34	2024-10-30 10:54:34	\N	\N	\N	\N
175	59	4	100000	50000	Pendiente	N/A	2024-11-27 00:00:00	12	2024-10-30 10:54:38	2024-10-30 10:54:38	\N	\N	\N	\N
176	59	5	100000	50000	Pendiente	N/A	2024-12-04 00:00:00	12	2024-10-30 10:54:38	2024-10-30 10:54:38	\N	\N	\N	\N
187	62	1	100000	50000	Pagada	N/A	2024-11-29 00:00:00	12	2024-10-30 11:00:56	2024-11-02 11:06:20	\N	2024-11-02 00:00:00	50000	100000
188	62	2	100000	50000	Pagada	N/A	2024-12-29 00:00:00	12	2024-10-30 11:00:56	2024-11-02 11:09:38	\N	2024-11-02 00:00:00	50000	100000
189	62	3	100000	50000	Pagada	N/A	2025-01-28 00:00:00	12	2024-10-30 11:00:56	2024-11-02 11:13:57	\N	2024-11-02 00:00:00	50000	100000
190	62	4	100000	50000	Pagada	N/A	2025-02-27 00:00:00	12	2024-10-30 11:00:56	2024-11-02 11:16:19	\N	2024-11-02 00:00:00	50000	100000
191	62	5	100000	50000	Pagada	N/A	2025-03-29 00:00:00	12	2024-10-30 11:00:56	2024-11-02 11:34:31	\N	2024-11-02 00:00:00	50000	100000
167	58	1	100000	50000	Pagada	N/A	2024-11-06 00:00:00	12	2024-10-30 10:54:34	2024-11-02 17:39:28	\N	2024-11-02 00:00:00	50000	100000
150	55	1	7142.8571428571	1250	Pagada	N/A	2024-11-30 00:00:00	12	2024-10-29 14:49:54	2024-11-02 17:43:49	\N	2024-11-02 00:00:00	1250	7142.8571428571
136	52	1	71428.571428571	10416.666666667	Pagada	N/A	2024-11-28 00:00:00	12	2024-10-29 14:16:11	2024-11-02 17:46:46	\N	2024-11-02 00:00:00	10416.666666667	71428.571428571
186	61	5	100000	50000	Pagada	N/A	2024-12-09 00:00:00	12	2024-10-30 10:59:22	2024-11-03 12:53:12	\N	2024-11-03 00:00:00	50000	100000
177	60	1	100000	50000	Pagada	N/A	2024-11-06 00:00:00	12	2024-10-30 10:56:57	2024-11-03 07:50:23	\N	2024-11-03 00:00:00	50000	100000
178	60	2	100000	50000	Pagada	N/A	2024-11-06 00:00:00	12	2024-10-30 10:56:57	2024-11-03 07:50:38	\N	2024-11-03 00:00:00	50000	100000
179	60	3	100000	50000	Pagada	N/A	2024-11-06 00:00:00	12	2024-10-30 10:56:57	2024-11-03 07:50:42	\N	2024-11-03 00:00:00	50000	100000
180	60	4	100000	50000	Pagada	N/A	2024-11-06 00:00:00	12	2024-10-30 10:56:57	2024-11-03 07:50:46	\N	2024-11-03 00:00:00	50000	100000
181	60	5	100000	50000	Pagada	N/A	2024-11-06 00:00:00	12	2024-10-30 10:56:57	2024-11-03 07:50:54	\N	2024-11-03 00:00:00	50000	100000
182	61	1	100000	50000	Pagada	N/A	2024-11-07 00:00:00	12	2024-10-30 10:59:22	2024-11-03 11:12:21	\N	2024-11-03 00:00:00	50000	100000
183	61	2	100000	50000	Pagada	N/A	2024-11-15 00:00:00	12	2024-10-30 10:59:22	2024-11-03 11:58:12	\N	2024-11-03 00:00:00	50000	100000
185	61	4	100000	50000	Pagada	N/A	2024-12-01 00:00:00	12	2024-10-30 10:59:22	2024-11-03 12:40:42	\N	2024-11-03 00:00:00	50000	100000
193	63	2	200000	80000	Pendiente	N/A	2024-12-19 00:00:00	12	2024-11-03 12:54:51	2024-11-03 12:54:51	\N	\N	0	0
194	63	3	200000	80000	Pendiente	N/A	2025-01-04 00:00:00	12	2024-11-03 12:54:51	2024-11-03 12:54:51	\N	\N	0	0
195	63	4	200000	80000	Pendiente	N/A	2025-01-20 00:00:00	12	2024-11-03 12:54:51	2024-11-03 12:54:51	\N	\N	0	0
184	61	3	100000	50000	Pagada	N/A	2024-11-23 00:00:00	12	2024-10-30 10:59:22	2024-11-03 12:06:05	\N	2024-11-03 00:00:00	50000	100000
196	63	5	200000	80000	Pendiente	N/A	2025-02-05 00:00:00	12	2024-11-03 12:54:51	2024-11-03 12:54:51	\N	\N	0	0
198	64	2	200000	50000	Pendiente	N/A	2024-12-19 00:00:00	12	2024-11-03 13:00:24	2024-11-03 13:00:24	\N	\N	0	0
199	64	3	200000	50000	Pendiente	N/A	2025-01-04 00:00:00	12	2024-11-03 13:00:24	2024-11-03 13:00:24	\N	\N	0	0
200	64	4	200000	50000	Pendiente	N/A	2025-01-20 00:00:00	12	2024-11-03 13:00:24	2024-11-03 13:00:24	\N	\N	0	0
201	64	5	200000	50000	Pendiente	N/A	2025-02-05 00:00:00	12	2024-11-03 13:00:24	2024-11-03 13:00:24	\N	\N	0	0
202	64	6	200000	50000	Pendiente	N/A	2025-02-21 00:00:00	12	2024-11-03 13:00:24	2024-11-03 13:00:24	\N	\N	0	0
203	64	7	200000	50000	Pendiente	N/A	2025-03-09 00:00:00	12	2024-11-03 13:00:24	2024-11-03 13:00:24	\N	\N	0	0
192	63	1	200000	80000	Pagada	N/A	2024-12-03 00:00:00	12	2024-11-03 12:54:51	2024-11-03 15:47:33	\N	2024-11-03 00:00:00	80000	200000
116	31	1	83333.333333333	12500	Pendiente	N/A	2024-11-13 00:00:00	12	2024-10-29 13:32:49	2024-10-29 13:32:49	\N	\N	\N	\N
117	31	2	83333.333333333	12500	Pendiente	N/A	2024-11-28 00:00:00	12	2024-10-29 13:32:49	2024-10-29 13:32:49	\N	\N	\N	\N
118	31	3	83333.333333333	12500	Pendiente	N/A	2024-12-13 00:00:00	12	2024-10-29 13:32:49	2024-10-29 13:32:49	\N	\N	\N	\N
119	31	4	83333.333333333	12500	Pendiente	N/A	2024-12-28 00:00:00	12	2024-10-29 13:32:49	2024-10-29 13:32:49	\N	\N	\N	\N
120	31	5	83333.333333333	12500	Pendiente	N/A	2025-01-12 00:00:00	12	2024-10-29 13:32:49	2024-10-29 13:32:49	\N	\N	\N	\N
121	31	6	83333.333333333	12500	Pendiente	N/A	2025-01-27 00:00:00	12	2024-10-29 13:32:49	2024-10-29 13:32:49	\N	\N	\N	\N
151	55	2	7142.8571428571	1250	Pendiente	N/A	2024-12-15 00:00:00	12	2024-10-29 14:49:54	2024-10-29 14:49:54	\N	\N	\N	\N
152	55	3	7142.8571428571	1250	Pendiente	N/A	2024-12-30 00:00:00	12	2024-10-29 14:49:54	2024-10-29 14:49:54	\N	\N	\N	\N
153	55	4	7142.8571428571	1250	Pendiente	N/A	2025-01-14 00:00:00	12	2024-10-29 14:49:54	2024-10-29 14:49:54	\N	\N	\N	\N
154	55	5	7142.8571428571	1250	Pendiente	N/A	2025-01-29 00:00:00	12	2024-10-29 14:49:54	2024-10-29 14:49:54	\N	\N	\N	\N
155	55	6	7142.8571428571	1250	Pendiente	N/A	2025-02-13 00:00:00	12	2024-10-29 14:49:54	2024-10-29 14:49:54	\N	\N	\N	\N
156	55	7	7142.8571428571	1250	Pendiente	N/A	2025-02-28 00:00:00	12	2024-10-29 14:49:54	2024-10-29 14:49:54	\N	\N	\N	\N
162	57	1	100000	250000	Pendiente	N/A	2024-11-06 00:00:00	12	2024-10-30 10:52:35	2024-10-30 10:52:35	\N	\N	\N	\N
163	57	2	100000	250000	Pendiente	N/A	2024-11-13 00:00:00	12	2024-10-30 10:52:35	2024-10-30 10:52:35	\N	\N	\N	\N
164	57	3	100000	250000	Pendiente	N/A	2024-11-20 00:00:00	12	2024-10-30 10:52:35	2024-10-30 10:52:35	\N	\N	\N	\N
165	57	4	100000	250000	Pendiente	N/A	2024-11-27 00:00:00	12	2024-10-30 10:52:35	2024-10-30 10:52:35	\N	\N	\N	\N
166	57	5	100000	250000	Pendiente	N/A	2024-12-04 00:00:00	12	2024-10-30 10:52:35	2024-10-30 10:52:35	\N	\N	\N	\N
173	59	2	100000	50000	Pendiente	N/A	2024-11-13 00:00:00	12	2024-10-30 10:54:38	2024-10-30 10:54:38	\N	\N	\N	\N
174	59	3	100000	50000	Pendiente	N/A	2024-11-20 00:00:00	12	2024-10-30 10:54:38	2024-10-30 10:54:38	\N	\N	\N	\N
137	52	2	71428.571428571	10416.666666667	Pendiente	N/A	2024-11-28 00:00:00	12	2024-10-29 14:16:11	2024-10-29 14:16:11	\N	\N	\N	\N
1	1	1	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:33:55	2024-10-24 06:33:55	\N	\N	\N	\N
2	1	2	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:33:55	2024-10-24 06:33:55	\N	\N	\N	\N
3	1	3	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:33:55	2024-10-24 06:33:55	\N	\N	\N	\N
4	1	4	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:33:55	2024-10-24 06:33:55	\N	\N	\N	\N
5	1	5	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:33:55	2024-10-24 06:33:55	\N	\N	\N	\N
6	1	6	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:33:55	2024-10-24 06:33:55	\N	\N	\N	\N
7	2	1	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:42	2024-10-24 06:38:42	\N	\N	\N	\N
8	2	2	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:42	2024-10-24 06:38:42	\N	\N	\N	\N
9	2	3	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:42	2024-10-24 06:38:42	\N	\N	\N	\N
10	2	4	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:42	2024-10-24 06:38:42	\N	\N	\N	\N
11	2	5	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:42	2024-10-24 06:38:42	\N	\N	\N	\N
12	2	6	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:42	2024-10-24 06:38:42	\N	\N	\N	\N
13	3	1	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:44	2024-10-24 06:38:44	\N	\N	\N	\N
14	3	2	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:44	2024-10-24 06:38:44	\N	\N	\N	\N
15	3	3	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:44	2024-10-24 06:38:44	\N	\N	\N	\N
16	3	4	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:44	2024-10-24 06:38:44	\N	\N	\N	\N
17	3	5	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:44	2024-10-24 06:38:44	\N	\N	\N	\N
18	3	6	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:44	2024-10-24 06:38:44	\N	\N	\N	\N
19	4	1	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:45	2024-10-24 06:38:45	\N	\N	\N	\N
20	4	2	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:45	2024-10-24 06:38:45	\N	\N	\N	\N
21	4	3	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:45	2024-10-24 06:38:45	\N	\N	\N	\N
22	4	4	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:45	2024-10-24 06:38:45	\N	\N	\N	\N
23	4	5	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:45	2024-10-24 06:38:45	\N	\N	\N	\N
24	4	6	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:45	2024-10-24 06:38:45	\N	\N	\N	\N
25	5	1	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:46	2024-10-24 06:38:46	\N	\N	\N	\N
26	5	2	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:46	2024-10-24 06:38:46	\N	\N	\N	\N
27	5	3	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:46	2024-10-24 06:38:46	\N	\N	\N	\N
28	5	4	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:46	2024-10-24 06:38:46	\N	\N	\N	\N
29	5	5	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:46	2024-10-24 06:38:46	\N	\N	\N	\N
30	5	6	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:46	2024-10-24 06:38:46	\N	\N	\N	\N
31	6	1	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:47	2024-10-24 06:38:47	\N	\N	\N	\N
32	6	2	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:47	2024-10-24 06:38:47	\N	\N	\N	\N
34	6	4	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:47	2024-10-24 06:38:47	\N	\N	\N	\N
36	6	6	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:47	2024-10-24 06:38:47	\N	\N	\N	\N
37	7	1	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:48	2024-10-24 06:38:48	\N	\N	\N	\N
38	7	2	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:48	2024-10-24 06:38:48	\N	\N	\N	\N
39	7	3	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:48	2024-10-24 06:38:48	\N	\N	\N	\N
40	7	4	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:48	2024-10-24 06:38:48	\N	\N	\N	\N
41	7	5	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:48	2024-10-24 06:38:48	\N	\N	\N	\N
42	7	6	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:48	2024-10-24 06:38:48	\N	\N	\N	\N
43	8	1	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:49	2024-10-24 06:38:49	\N	\N	\N	\N
44	8	2	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:49	2024-10-24 06:38:49	\N	\N	\N	\N
138	52	3	71428.571428571	10416.666666667	Pendiente	N/A	2024-11-28 00:00:00	12	2024-10-29 14:16:11	2024-10-29 14:16:11	\N	\N	\N	\N
139	52	4	71428.571428571	10416.666666667	Pendiente	N/A	2024-11-28 00:00:00	12	2024-10-29 14:16:11	2024-10-29 14:16:11	\N	\N	\N	\N
140	52	5	71428.571428571	10416.666666667	Pendiente	N/A	2024-11-28 00:00:00	12	2024-10-29 14:16:11	2024-10-29 14:16:11	\N	\N	\N	\N
141	52	6	71428.571428571	10416.666666667	Pendiente	N/A	2024-11-28 00:00:00	12	2024-10-29 14:16:11	2024-10-29 14:16:11	\N	\N	\N	\N
142	52	7	71428.571428571	10416.666666667	Pendiente	N/A	2024-11-28 00:00:00	12	2024-10-29 14:16:11	2024-10-29 14:16:11	\N	\N	\N	\N
45	8	3	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:49	2024-10-24 06:38:49	\N	\N	\N	\N
46	8	4	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:49	2024-10-24 06:38:49	\N	\N	\N	\N
47	8	5	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:49	2024-10-24 06:38:49	\N	\N	\N	\N
48	8	6	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:49	2024-10-24 06:38:49	\N	\N	\N	\N
49	9	1	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:50	2024-10-24 06:38:50	\N	\N	\N	\N
50	9	2	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:50	2024-10-24 06:38:50	\N	\N	\N	\N
51	9	3	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:50	2024-10-24 06:38:50	\N	\N	\N	\N
52	9	4	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:50	2024-10-24 06:38:50	\N	\N	\N	\N
53	9	5	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:50	2024-10-24 06:38:50	\N	\N	\N	\N
54	9	6	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:50	2024-10-24 06:38:50	\N	\N	\N	\N
55	10	1	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:52	2024-10-24 06:38:52	\N	\N	\N	\N
56	10	2	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:52	2024-10-24 06:38:52	\N	\N	\N	\N
57	10	3	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:52	2024-10-24 06:38:52	\N	\N	\N	\N
58	10	4	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:52	2024-10-24 06:38:52	\N	\N	\N	\N
59	10	5	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:52	2024-10-24 06:38:52	\N	\N	\N	\N
60	10	6	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:52	2024-10-24 06:38:52	\N	\N	\N	\N
61	11	1	33333.333333333	3333.3333333333	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 07:14:59	2024-10-24 07:14:59	\N	\N	\N	\N
62	11	2	33333.333333333	3333.3333333333	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 07:14:59	2024-10-24 07:14:59	\N	\N	\N	\N
63	11	3	33333.333333333	3333.3333333333	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 07:14:59	2024-10-24 07:14:59	\N	\N	\N	\N
33	6	3	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:47	2024-10-24 06:38:47	\N	\N	\N	\N
35	6	5	83333.333333333	10416.666666667	PENDIENTE	N/A	2024-10-24 00:00:00	12	2024-10-24 06:38:47	2024-10-24 06:38:47	\N	\N	\N	\N
64	16	1	83333.333333333	10416.666666667	PENDIENTE	N/A	2025-01-28 00:00:00	12	2024-10-29 11:22:57	2024-10-29 11:22:57	\N	\N	\N	\N
65	16	2	83333.333333333	10416.666666667	PENDIENTE	N/A	2025-04-28 00:00:00	12	2024-10-29 11:22:58	2024-10-29 11:22:58	\N	\N	\N	\N
66	16	3	83333.333333333	10416.666666667	PENDIENTE	N/A	2025-07-27 00:00:00	12	2024-10-29 11:22:58	2024-10-29 11:22:58	\N	\N	\N	\N
67	16	4	83333.333333333	10416.666666667	PENDIENTE	N/A	2025-10-25 00:00:00	12	2024-10-29 11:22:58	2024-10-29 11:22:58	\N	\N	\N	\N
68	16	5	83333.333333333	10416.666666667	PENDIENTE	N/A	2026-01-23 00:00:00	12	2024-10-29 11:22:58	2024-10-29 11:22:58	\N	\N	\N	\N
69	16	6	83333.333333333	10416.666666667	PENDIENTE	N/A	2026-04-23 00:00:00	12	2024-10-29 11:22:58	2024-10-29 11:22:58	\N	\N	\N	\N
70	22	1	83333.333333333	10416.666666667	PENDIENTE	N/A	2025-01-27 00:00:00	12	2024-10-29 11:26:41	2024-10-29 11:26:41	\N	\N	\N	\N
71	22	2	83333.333333333	10416.666666667	PENDIENTE	N/A	2025-04-27 00:00:00	12	2024-10-29 11:26:41	2024-10-29 11:26:41	\N	\N	\N	\N
72	22	3	83333.333333333	10416.666666667	PENDIENTE	N/A	2025-07-26 00:00:00	12	2024-10-29 11:26:41	2024-10-29 11:26:41	\N	\N	\N	\N
73	22	4	83333.333333333	10416.666666667	PENDIENTE	N/A	2025-10-24 00:00:00	12	2024-10-29 11:26:41	2024-10-29 11:26:41	\N	\N	\N	\N
74	22	5	83333.333333333	10416.666666667	PENDIENTE	N/A	2026-01-22 00:00:00	12	2024-10-29 11:26:41	2024-10-29 11:26:41	\N	\N	\N	\N
75	22	6	83333.333333333	10416.666666667	PENDIENTE	N/A	2026-04-22 00:00:00	12	2024-10-29 11:26:41	2024-10-29 11:26:41	\N	\N	\N	\N
76	23	1	100000	12500	PENDIENTE	N/A	2025-01-27 00:00:00	12	2024-10-29 11:27:12	2024-10-29 11:27:12	\N	\N	\N	\N
77	23	2	100000	12500	PENDIENTE	N/A	2025-04-27 00:00:00	12	2024-10-29 11:27:12	2024-10-29 11:27:12	\N	\N	\N	\N
78	23	3	100000	12500	PENDIENTE	N/A	2025-07-26 00:00:00	12	2024-10-29 11:27:12	2024-10-29 11:27:12	\N	\N	\N	\N
79	23	4	100000	12500	PENDIENTE	N/A	2025-10-24 00:00:00	12	2024-10-29 11:27:12	2024-10-29 11:27:12	\N	\N	\N	\N
80	23	5	100000	12500	PENDIENTE	N/A	2026-01-22 00:00:00	12	2024-10-29 11:27:12	2024-10-29 11:27:12	\N	\N	\N	\N
81	23	6	100000	12500	PENDIENTE	N/A	2026-04-22 00:00:00	12	2024-10-29 11:27:12	2024-10-29 11:27:12	\N	\N	\N	\N
82	26	1	100000	12500	PENDIENTE	N/A	2024-11-05 00:00:00	12	2024-10-29 11:30:31	2024-10-29 11:30:31	\N	\N	\N	\N
83	26	2	100000	12500	PENDIENTE	N/A	2024-11-12 00:00:00	12	2024-10-29 11:30:31	2024-10-29 11:30:31	\N	\N	\N	\N
84	26	3	100000	12500	PENDIENTE	N/A	2024-11-19 00:00:00	12	2024-10-29 11:30:31	2024-10-29 11:30:31	\N	\N	\N	\N
85	26	4	100000	12500	PENDIENTE	N/A	2024-11-26 00:00:00	12	2024-10-29 11:30:31	2024-10-29 11:30:31	\N	\N	\N	\N
86	26	5	100000	12500	PENDIENTE	N/A	2024-12-03 00:00:00	12	2024-10-29 11:30:31	2024-10-29 11:30:31	\N	\N	\N	\N
87	26	6	100000	12500	PENDIENTE	N/A	2024-12-10 00:00:00	12	2024-10-29 11:30:31	2024-10-29 11:30:31	\N	\N	\N	\N
88	27	1	100000.16666667	12500.020833333	PENDIENTE	N/A	2024-10-30 00:00:00	12	2024-10-29 11:30:39	2024-10-29 11:30:39	\N	\N	\N	\N
89	27	2	100000.16666667	12500.020833333	PENDIENTE	N/A	2024-10-31 00:00:00	12	2024-10-29 11:30:39	2024-10-29 11:30:39	\N	\N	\N	\N
90	27	3	100000.16666667	12500.020833333	PENDIENTE	N/A	2024-11-01 00:00:00	12	2024-10-29 11:30:39	2024-10-29 11:30:39	\N	\N	\N	\N
91	27	4	100000.16666667	12500.020833333	PENDIENTE	N/A	2024-11-02 00:00:00	12	2024-10-29 11:30:39	2024-10-29 11:30:39	\N	\N	\N	\N
92	27	5	100000.16666667	12500.020833333	PENDIENTE	N/A	2024-11-03 00:00:00	12	2024-10-29 11:30:39	2024-10-29 11:30:39	\N	\N	\N	\N
93	27	6	100000.16666667	12500.020833333	PENDIENTE	N/A	2024-11-04 00:00:00	12	2024-10-29 11:30:39	2024-10-29 11:30:39	\N	\N	\N	\N
94	28	1	100013.5	12501.6875	PENDIENTE	N/A	2024-11-13 00:00:00	12	2024-10-29 11:30:53	2024-10-29 11:30:53	\N	\N	\N	\N
95	28	2	100013.5	12501.6875	PENDIENTE	N/A	2024-11-28 00:00:00	12	2024-10-29 11:30:53	2024-10-29 11:30:53	\N	\N	\N	\N
96	28	3	100013.5	12501.6875	PENDIENTE	N/A	2024-12-13 00:00:00	12	2024-10-29 11:30:53	2024-10-29 11:30:53	\N	\N	\N	\N
97	28	4	100013.5	12501.6875	PENDIENTE	N/A	2024-12-28 00:00:00	12	2024-10-29 11:30:53	2024-10-29 11:30:53	\N	\N	\N	\N
98	28	5	100013.5	12501.6875	PENDIENTE	N/A	2025-01-12 00:00:00	12	2024-10-29 11:30:53	2024-10-29 11:30:53	\N	\N	\N	\N
99	28	6	100013.5	12501.6875	PENDIENTE	N/A	2025-01-27 00:00:00	12	2024-10-29 11:30:53	2024-10-29 11:30:53	\N	\N	\N	\N
100	29	1	116666.66666667	14583.333333333	PENDIENTE	N/A	2024-11-29 00:00:00	12	2024-10-29 11:31:02	2024-10-29 11:31:02	\N	\N	\N	\N
101	29	2	116666.66666667	14583.333333333	PENDIENTE	N/A	2024-12-29 00:00:00	12	2024-10-29 11:31:02	2024-10-29 11:31:02	\N	\N	\N	\N
102	29	3	116666.66666667	14583.333333333	PENDIENTE	N/A	2025-01-29 00:00:00	12	2024-10-29 11:31:02	2024-10-29 11:31:02	\N	\N	\N	\N
103	29	4	116666.66666667	14583.333333333	PENDIENTE	N/A	2025-03-01 00:00:00	12	2024-10-29 11:31:02	2024-10-29 11:31:02	\N	\N	\N	\N
104	29	5	116666.66666667	14583.333333333	PENDIENTE	N/A	2025-03-29 00:00:00	12	2024-10-29 11:31:02	2024-10-29 11:31:02	\N	\N	\N	\N
105	29	6	116666.66666667	14583.333333333	PENDIENTE	N/A	2025-04-29 00:00:00	12	2024-10-29 11:31:02	2024-10-29 11:31:02	\N	\N	\N	\N
122	32	1	71428.571428571	10416.666666667	Pendiente	N/A	2024-11-13 00:00:00	12	2024-10-29 13:38:26	2024-10-29 13:38:26	\N	\N	\N	\N
123	32	2	71428.571428571	10416.666666667	Pendiente	N/A	2024-11-28 00:00:00	12	2024-10-29 13:38:26	2024-10-29 13:38:26	\N	\N	\N	\N
124	32	3	71428.571428571	10416.666666667	Pendiente	N/A	2024-12-13 00:00:00	12	2024-10-29 13:38:26	2024-10-29 13:38:26	\N	\N	\N	\N
125	32	4	71428.571428571	10416.666666667	Pendiente	N/A	2024-12-28 00:00:00	12	2024-10-29 13:38:26	2024-10-29 13:38:26	\N	\N	\N	\N
126	32	5	71428.571428571	10416.666666667	Pendiente	N/A	2025-01-12 00:00:00	12	2024-10-29 13:38:26	2024-10-29 13:38:26	\N	\N	\N	\N
127	32	6	71428.571428571	10416.666666667	Pendiente	N/A	2025-01-27 00:00:00	12	2024-10-29 13:38:26	2024-10-29 13:38:26	\N	\N	\N	\N
128	32	7	71428.571428571	10416.666666667	Pendiente	N/A	2025-02-11 00:00:00	12	2024-10-29 13:38:26	2024-10-29 13:38:26	\N	\N	\N	\N
204	64	8	200000	50000	Pendiente	N/A	2025-03-25 00:00:00	12	2024-11-03 13:00:24	2024-11-03 13:00:24	\N	\N	0	0
205	64	9	200000	50000	Pendiente	N/A	2025-04-10 00:00:00	12	2024-11-03 13:00:24	2024-11-03 13:00:24	\N	\N	0	0
206	64	10	200000	50000	Pendiente	N/A	2025-04-26 00:00:00	12	2024-11-03 13:00:24	2024-11-03 13:00:24	\N	\N	0	0
253	70	3	386666.66666667	96666.666666667	Pagada	Se realiza abono	2024-11-12 00:00:00	12	2024-11-04 07:35:02	2024-11-04 07:38:20	\N	2024-11-04 00:00:00	120000	480000
197	64	1	200000	50000	Pagada	N/A	2024-12-03 00:00:00	12	2024-11-03 13:00:24	2024-11-03 15:31:58	\N	\N	0	0
207	65	1	300000	90000	Pagada	N/A	2024-12-10 00:00:00	12	2024-11-03 13:06:27	2024-11-03 15:46:55	\N	2024-11-03 00:00:00	90000	300000
227	68	1	1000000	250000	Pagada	N/A	2024-11-19 00:00:00	12	2024-11-03 16:04:07	2024-11-03 16:05:05	\N	2024-11-03 00:00:00	250000	1000000
208	65	2	300000	90000	Pagada	N/A	2025-01-09 00:00:00	12	2024-11-03 13:06:27	2024-11-04 00:39:56	\N	2024-11-04 00:00:00	90000	300000
209	65	3	300000	90000	Pagada	N/A	2025-02-08 00:00:00	12	2024-11-03 13:06:27	2024-11-04 00:40:07	\N	2024-11-04 00:00:00	90000	300000
210	65	4	300000	90000	Pagada	N/A	2025-03-10 00:00:00	12	2024-11-03 13:06:27	2024-11-04 00:43:06	\N	2024-11-04 00:00:00	230769.23076923	769230.76923077
237	65	5	221794.87179487	-83461.538461538	Pendiente	Se realiza abono	2024-12-04 00:00:00	12	2024-11-04 00:43:06	2024-11-04 00:43:06	\N	\N	230769.23076923	769230.76923077
238	65	6	221794.87179487	-83461.538461538	Pendiente	Se realiza abono	2025-01-03 00:00:00	12	2024-11-04 00:43:06	2024-11-04 00:43:06	\N	\N	230769.23076923	769230.76923077
239	65	7	221794.87179487	-83461.538461538	Pendiente	Se realiza abono	2025-02-02 00:00:00	12	2024-11-04 00:43:06	2024-11-04 00:43:06	\N	\N	230769.23076923	769230.76923077
240	65	8	221794.87179487	-83461.538461538	Pendiente	Se realiza abono	2025-03-04 00:00:00	12	2024-11-04 00:43:06	2024-11-04 00:43:06	\N	\N	230769.23076923	769230.76923077
241	65	9	221794.87179487	-83461.538461538	Pendiente	Se realiza abono	2025-04-03 00:00:00	12	2024-11-04 00:43:06	2024-11-04 00:43:06	\N	\N	230769.23076923	769230.76923077
242	65	10	221794.87179487	-83461.538461538	Pendiente	Se realiza abono	2025-05-03 00:00:00	12	2024-11-04 00:43:06	2024-11-04 00:43:06	\N	\N	230769.23076923	769230.76923077
248	70	1	430000	107500	Pagada	N/A	2024-11-12 00:00:00	12	2024-11-04 00:51:54	2024-11-04 00:52:36	\N	2024-11-04 00:00:00	107500	430000
256	70	4	340000	85000	Pagada	Se realiza abono	2024-11-12 00:00:00	12	2024-11-04 07:38:20	2024-11-04 07:50:01	\N	2024-11-04 00:00:00	120000	480000
258	70	5	200000	50000	Pagada	Se realiza abono	2024-11-12 00:00:00	12	2024-11-04 07:50:01	2024-11-04 07:55:27	\N	2024-11-04 00:00:00	40000	160000
244	69	2	230000	57500	Pagada	N/A	2024-12-06 00:00:00	12	2024-11-04 00:49:09	2024-11-04 08:01:54	\N	2024-11-04 00:00:00	57500	230000
245	69	3	230000	57500	Pagada	N/A	2024-12-22 00:00:00	12	2024-11-04 00:49:09	2024-11-04 08:02:55	\N	2024-11-04 00:00:00	57500	230000
243	69	1	230000	57500	Pagada	N/A	2024-11-20 00:00:00	12	2024-11-04 00:49:09	2024-11-04 08:01:48	\N	2024-11-04 00:00:00	57500	230000
246	69	4	230000	57500	Pagada	N/A	2025-01-07 00:00:00	12	2024-11-04 00:49:09	2024-11-04 08:03:00	\N	2024-11-04 00:00:00	57500	230000
229	68	3	1000000	250000	Pagada	N/A	2024-12-21 00:00:00	12	2024-11-03 16:04:07	2024-11-04 08:14:43	\N	2024-11-04 00:00:00	250000	1000000
230	68	4	1000000	250000	Pagada	N/A	2025-01-06 00:00:00	12	2024-11-03 16:04:07	2024-11-04 08:14:49	\N	2024-11-04 00:00:00	250000	1000000
231	68	5	1000000	250000	Pagada	N/A	2025-01-22 00:00:00	12	2024-11-03 16:04:07	2024-11-04 08:15:21	\N	2024-11-04 00:00:00	250000	1000000
247	69	5	230000	57500	Pagada	N/A	2025-01-23 00:00:00	12	2024-11-04 00:49:09	2024-11-04 08:11:47	\N	2024-11-04 00:00:00	40000	160000
259	69	5	70000	-270000	Pendiente	Se realiza abono	2024-11-20 00:00:00	12	2024-11-04 08:11:47	2024-11-04 08:11:47	\N	\N	0	0
228	68	2	1000000	250000	Pagada	N/A	2024-12-05 00:00:00	12	2024-11-03 16:04:07	2024-11-04 08:14:40	\N	2024-11-04 00:00:00	250000	1000000
232	68	6	1000000	250000	Pagada	N/A	2025-02-07 00:00:00	12	2024-11-03 16:04:07	2024-11-04 08:15:25	\N	2024-11-04 00:00:00	250000	1000000
233	68	7	1000000	250000	Pagada	N/A	2025-02-23 00:00:00	12	2024-11-03 16:04:07	2024-11-04 08:15:28	\N	2024-11-04 00:00:00	250000	1000000
234	68	8	1000000	250000	Pagada	N/A	2025-03-11 00:00:00	12	2024-11-03 16:04:07	2024-11-04 08:15:31	\N	2024-11-04 00:00:00	250000	1000000
235	68	9	1000000	250000	Pagada	N/A	2025-03-27 00:00:00	12	2024-11-03 16:04:07	2024-11-04 08:15:34	\N	2024-11-04 00:00:00	250000	1000000
236	68	10	1000000	250000	Pagada	N/A	2025-04-12 00:00:00	12	2024-11-03 16:04:07	2024-11-04 08:20:22	\N	2024-11-04 00:00:00	250000	1000000
260	68	10	0	-2500000	Pendiente	Se realiza abono	2024-11-20 00:00:00	12	2024-11-04 08:20:22	2024-11-04 08:20:22	\N	\N	0	0
217	66	1	500000	125000	Pagada	N/A	2024-12-03 00:00:00	12	2024-11-03 15:50:04	2024-11-04 08:28:26	\N	2024-11-04 00:00:00	125000	500000
218	66	2	500000	125000	Pagada	N/A	2025-01-02 00:00:00	12	2024-11-03 15:50:04	2024-11-04 08:28:29	\N	2024-11-04 00:00:00	125000	500000
219	66	3	500000	125000	Pagada	N/A	2025-02-01 00:00:00	12	2024-11-03 15:50:04	2024-11-04 08:28:31	\N	2024-11-04 00:00:00	125000	500000
220	66	4	500000	125000	Pagada	N/A	2025-03-03 00:00:00	12	2024-11-03 15:50:04	2024-11-04 08:28:33	\N	2024-11-04 00:00:00	125000	500000
221	66	5	500000	125000	Pagada	N/A	2025-04-02 00:00:00	12	2024-11-03 15:50:04	2024-11-04 08:28:36	\N	2024-11-04 00:00:00	125000	500000
222	66	6	500000	125000	Pagada	N/A	2025-05-02 00:00:00	12	2024-11-03 15:50:04	2024-11-04 08:28:39	\N	2024-11-04 00:00:00	125000	500000
223	66	7	500000	125000	Pagada	N/A	2025-06-01 00:00:00	12	2024-11-03 15:50:04	2024-11-04 08:28:42	\N	2024-11-04 00:00:00	125000	500000
224	66	8	500000	125000	Pagada	N/A	2025-07-01 00:00:00	12	2024-11-03 15:50:04	2024-11-04 08:28:46	\N	2024-11-04 00:00:00	125000	500000
225	66	9	500000	125000	Pagada	N/A	2025-07-31 00:00:00	12	2024-11-03 15:50:04	2024-11-04 08:28:50	\N	2024-11-04 00:00:00	125000	500000
226	66	10	500000	125000	Pagada	N/A	2025-08-30 00:00:00	12	2024-11-03 15:50:04	2024-11-04 08:31:19	\N	2024-11-04 00:00:00	125000	500000
249	70	2	430000	107500	Pendiente	N/A	2024-11-20 00:00:00	12	2024-11-04 00:51:54	2024-11-04 07:35:02	\N	2024-11-04 00:00:00	140000	560000
261	71	1	220000	55000	Pendiente	N/A	2024-11-12 00:00:00	12	2024-11-04 09:18:25	2024-11-04 09:18:25	\N	\N	0	0
262	71	2	220000	55000	Pendiente	N/A	2024-11-20 00:00:00	12	2024-11-04 09:18:25	2024-11-04 09:18:25	\N	\N	0	0
263	71	3	220000	55000	Pendiente	N/A	2024-11-28 00:00:00	12	2024-11-04 09:18:25	2024-11-04 09:18:25	\N	\N	0	0
264	71	4	220000	55000	Pendiente	N/A	2024-12-06 00:00:00	12	2024-11-04 09:18:25	2024-11-04 09:18:25	\N	\N	0	0
265	71	5	220000	55000	Pendiente	N/A	2024-12-14 00:00:00	12	2024-11-04 09:18:25	2024-11-04 09:18:25	\N	\N	0	0
266	72	1	220000	55000	Pendiente	N/A	2024-11-12 00:00:00	12	2024-11-04 09:18:27	2024-11-04 09:18:27	\N	\N	0	0
267	72	2	220000	55000	Pendiente	N/A	2024-11-20 00:00:00	12	2024-11-04 09:18:27	2024-11-04 09:18:27	\N	\N	0	0
268	72	3	220000	55000	Pendiente	N/A	2024-11-28 00:00:00	12	2024-11-04 09:18:27	2024-11-04 09:18:27	\N	\N	0	0
269	72	4	220000	55000	Pendiente	N/A	2024-12-06 00:00:00	12	2024-11-04 09:18:27	2024-11-04 09:18:27	\N	\N	0	0
270	72	5	220000	55000	Pendiente	N/A	2024-12-14 00:00:00	12	2024-11-04 09:18:27	2024-11-04 09:18:27	\N	\N	0	0
271	73	1	220000	55000	Pendiente	N/A	2024-11-12 00:00:00	12	2024-11-04 09:18:28	2024-11-04 09:18:28	\N	\N	0	0
272	73	2	220000	55000	Pendiente	N/A	2024-11-20 00:00:00	12	2024-11-04 09:18:28	2024-11-04 09:18:28	\N	\N	0	0
273	73	3	220000	55000	Pendiente	N/A	2024-11-28 00:00:00	12	2024-11-04 09:18:28	2024-11-04 09:18:28	\N	\N	0	0
274	73	4	220000	55000	Pendiente	N/A	2024-12-06 00:00:00	12	2024-11-04 09:18:28	2024-11-04 09:18:28	\N	\N	0	0
275	73	5	220000	55000	Pendiente	N/A	2024-12-14 00:00:00	12	2024-11-04 09:18:28	2024-11-04 09:18:28	\N	\N	0	0
286	76	1	220000	55000	Pendiente	N/A	2024-11-12 00:00:00	12	2024-11-04 09:18:31	2024-11-04 09:18:31	\N	\N	0	0
287	76	2	220000	55000	Pendiente	N/A	2024-11-20 00:00:00	12	2024-11-04 09:18:31	2024-11-04 09:18:31	\N	\N	0	0
288	76	3	220000	55000	Pendiente	N/A	2024-11-28 00:00:00	12	2024-11-04 09:18:31	2024-11-04 09:18:31	\N	\N	0	0
289	76	4	220000	55000	Pendiente	N/A	2024-12-06 00:00:00	12	2024-11-04 09:18:31	2024-11-04 09:18:31	\N	\N	0	0
290	76	5	220000	55000	Pendiente	N/A	2024-12-14 00:00:00	12	2024-11-04 09:18:31	2024-11-04 09:18:31	\N	\N	0	0
291	77	1	220000	55000	Pendiente	N/A	2024-11-12 00:00:00	12	2024-11-04 09:18:32	2024-11-04 09:18:32	\N	\N	0	0
292	77	2	220000	55000	Pendiente	N/A	2024-11-20 00:00:00	12	2024-11-04 09:18:32	2024-11-04 09:18:32	\N	\N	0	0
293	77	3	220000	55000	Pendiente	N/A	2024-11-28 00:00:00	12	2024-11-04 09:18:32	2024-11-04 09:18:32	\N	\N	0	0
294	77	4	220000	55000	Pendiente	N/A	2024-12-06 00:00:00	12	2024-11-04 09:18:32	2024-11-04 09:18:32	\N	\N	0	0
295	77	5	220000	55000	Pendiente	N/A	2024-12-14 00:00:00	12	2024-11-04 09:18:32	2024-11-04 09:18:32	\N	\N	0	0
296	78	1	220000	55000	Pendiente	N/A	2024-11-12 00:00:00	12	2024-11-04 09:18:33	2024-11-04 09:18:33	\N	\N	0	0
297	78	2	220000	55000	Pendiente	N/A	2024-11-20 00:00:00	12	2024-11-04 09:18:33	2024-11-04 09:18:33	\N	\N	0	0
298	78	3	220000	55000	Pendiente	N/A	2024-11-28 00:00:00	12	2024-11-04 09:18:33	2024-11-04 09:18:33	\N	\N	0	0
299	78	4	220000	55000	Pendiente	N/A	2024-12-06 00:00:00	12	2024-11-04 09:18:33	2024-11-04 09:18:33	\N	\N	0	0
300	78	5	220000	55000	Pendiente	N/A	2024-12-14 00:00:00	12	2024-11-04 09:18:33	2024-11-04 09:18:33	\N	\N	0	0
301	79	1	220000	55000	Pendiente	N/A	2024-11-12 00:00:00	12	2024-11-04 09:18:34	2024-11-04 09:18:34	\N	\N	0	0
302	79	2	220000	55000	Pendiente	N/A	2024-11-20 00:00:00	12	2024-11-04 09:18:34	2024-11-04 09:18:34	\N	\N	0	0
303	79	3	220000	55000	Pendiente	N/A	2024-11-28 00:00:00	12	2024-11-04 09:18:34	2024-11-04 09:18:34	\N	\N	0	0
304	79	4	220000	55000	Pendiente	N/A	2024-12-06 00:00:00	12	2024-11-04 09:18:34	2024-11-04 09:18:34	\N	\N	0	0
305	79	5	220000	55000	Pendiente	N/A	2024-12-14 00:00:00	12	2024-11-04 09:18:34	2024-11-04 09:18:34	\N	\N	0	0
306	80	1	220000	55000	Pendiente	N/A	2024-11-12 00:00:00	12	2024-11-04 09:18:35	2024-11-04 09:18:35	\N	\N	0	0
307	80	2	220000	55000	Pendiente	N/A	2024-11-20 00:00:00	12	2024-11-04 09:18:35	2024-11-04 09:18:35	\N	\N	0	0
308	80	3	220000	55000	Pendiente	N/A	2024-11-28 00:00:00	12	2024-11-04 09:18:35	2024-11-04 09:18:35	\N	\N	0	0
309	80	4	220000	55000	Pendiente	N/A	2024-12-06 00:00:00	12	2024-11-04 09:18:35	2024-11-04 09:18:35	\N	\N	0	0
310	80	5	220000	55000	Pendiente	N/A	2024-12-14 00:00:00	12	2024-11-04 09:18:35	2024-11-04 09:18:35	\N	\N	0	0
311	81	1	220000	55000	Pendiente	N/A	2024-11-12 00:00:00	12	2024-11-04 09:18:36	2024-11-04 09:18:36	\N	\N	0	0
312	81	2	220000	55000	Pendiente	N/A	2024-11-20 00:00:00	12	2024-11-04 09:18:36	2024-11-04 09:18:36	\N	\N	0	0
313	81	3	220000	55000	Pendiente	N/A	2024-11-28 00:00:00	12	2024-11-04 09:18:36	2024-11-04 09:18:36	\N	\N	0	0
314	81	4	220000	55000	Pendiente	N/A	2024-12-06 00:00:00	12	2024-11-04 09:18:36	2024-11-04 09:18:36	\N	\N	0	0
315	81	5	220000	55000	Pendiente	N/A	2024-12-14 00:00:00	12	2024-11-04 09:18:36	2024-11-04 09:18:36	\N	\N	0	0
331	85	1	220000	55000	Pendiente	N/A	2024-11-12 00:00:00	12	2024-11-04 09:18:37	2024-11-04 09:18:37	\N	\N	0	0
332	85	2	220000	55000	Pendiente	N/A	2024-11-20 00:00:00	12	2024-11-04 09:18:37	2024-11-04 09:18:37	\N	\N	0	0
333	85	3	220000	55000	Pendiente	N/A	2024-11-28 00:00:00	12	2024-11-04 09:18:37	2024-11-04 09:18:37	\N	\N	0	0
334	85	4	220000	55000	Pendiente	N/A	2024-12-06 00:00:00	12	2024-11-04 09:18:37	2024-11-04 09:18:37	\N	\N	0	0
335	85	5	220000	55000	Pendiente	N/A	2024-12-14 00:00:00	12	2024-11-04 09:18:37	2024-11-04 09:18:37	\N	\N	0	0
326	84	1	220000	55000	Abono	N/A	2024-11-12 00:00:00	12	2024-11-04 09:18:37	2024-11-04 21:20:45	\N	2024-11-04 00:00:00	60000	240000
321	83	1	220000	55000	Abono	N/A	2024-11-12 00:00:00	12	2024-11-04 09:18:37	2024-11-04 21:25:56	\N	2024-11-04 00:00:00	60000	240000
316	82	1	220000	55000	Abono	N/A	2024-11-12 00:00:00	12	2024-11-04 09:18:36	2024-11-04 21:29:42	\N	2024-11-04 00:00:00	60000	240000
281	75	1	220000	55000	Abono	N/A	2024-11-12 00:00:00	12	2024-11-04 09:18:30	2024-11-04 21:35:08	\N	2024-11-04 00:00:00	60000	240000
276	74	1	220000	55000	Abono	N/A	2024-11-12 00:00:00	12	2024-11-04 09:18:29	2024-11-04 21:38:39	\N	2024-11-04 00:00:00	60000	240000
346	88	1	220000	55000	Pagada	N/A	2024-11-12 00:00:00	12	2024-11-04 09:18:38	2024-11-04 09:33:19	\N	2024-11-04 00:00:00	100000	400000
361	88	1	140000	35000	Pagada	Se realiza abono	2024-11-12 00:00:00	12	2024-11-04 09:33:19	2024-11-04 09:44:59	\N	2024-11-04 00:00:00	35000	140000
362	88	2	140000	35000	Pagada	Se realiza abono	2024-11-20 00:00:00	12	2024-11-04 09:33:19	2024-11-04 09:44:59	\N	2024-11-04 00:00:00	35000	140000
363	88	3	140000	35000	Pagada	Se realiza abono	2024-11-28 00:00:00	12	2024-11-04 09:33:19	2024-11-04 09:44:59	\N	2024-11-04 00:00:00	35000	140000
364	88	4	140000	35000	Pagada	Se realiza abono	2024-12-06 00:00:00	12	2024-11-04 09:33:19	2024-11-04 09:44:59	\N	2024-11-04 00:00:00	35000	140000
365	88	5	140000	35000	Pagada	Se realiza abono	2024-12-14 00:00:00	12	2024-11-04 09:33:19	2024-11-04 09:44:59	\N	2024-11-04 00:00:00	35000	140000
356	90	1	220000	55000	Pagada	N/A	2024-11-12 00:00:00	12	2024-11-04 09:18:39	2024-11-04 09:50:43	\N	2024-11-04 00:00:00	55000	220000
357	90	2	220000	55000	Pagada	N/A	2024-11-20 00:00:00	12	2024-11-04 09:18:39	2024-11-04 10:00:29	\N	2024-11-04 00:00:00	55000	220000
358	90	3	220000	55000	Pagada	N/A	2024-11-28 00:00:00	12	2024-11-04 09:18:39	2024-11-04 10:00:29	\N	2024-11-04 00:00:00	55000	220000
359	90	4	220000	55000	Pagada	N/A	2024-12-06 00:00:00	12	2024-11-04 09:18:39	2024-11-04 10:00:29	\N	2024-11-04 00:00:00	55000	220000
360	90	5	220000	55000	Pagada	N/A	2024-12-14 00:00:00	12	2024-11-04 09:18:39	2024-11-04 10:00:29	\N	2024-11-04 00:00:00	55000	220000
351	89	1	220000	55000	Abono	N/A	2024-11-12 00:00:00	12	2024-11-04 09:18:39	2024-11-04 10:36:27	\N	2024-11-04 00:00:00	60000	240000
366	89	1	172000	43000	Pagada	Se realiza abono	2024-11-12 00:00:00	12	2024-11-04 10:36:27	2024-11-04 10:39:58	\N	2024-11-04 00:00:00	43000	172000
367	89	2	172000	43000	Pagada	Se realiza abono	2024-11-20 00:00:00	12	2024-11-04 10:36:27	2024-11-04 13:14:01	\N	2024-11-04 00:00:00	43000	172000
384	92	6	533333.93333333	133333.48333333	Pagada	N/A	2024-12-22 00:00:00	12	2024-11-04 16:10:11	2024-11-04 17:35:00	\N	2024-11-04 00:00:00	133333.48333333	533333.93333333
380	92	2	533333.93333333	133333.48333333	Pagada	N/A	2024-11-20 00:00:00	12	2024-11-04 16:10:11	2024-11-04 17:30:27	\N	2024-11-04 00:00:00	133333.48333333	533333.93333333
385	92	7	533333.93333333	133333.48333333	Pagada	N/A	2024-12-30 00:00:00	12	2024-11-04 16:10:11	2024-11-04 17:35:00	\N	2024-11-04 00:00:00	133333.48333333	533333.93333333
386	92	8	533333.93333333	133333.48333333	Pagada	N/A	2025-01-07 00:00:00	12	2024-11-04 16:10:11	2024-11-04 17:35:00	\N	2024-11-04 00:00:00	133333.48333333	533333.93333333
371	91	1	625000	156250	Abono	N/A	2024-11-20 00:00:00	12	2024-11-04 16:04:19	2024-11-04 17:44:55	\N	2024-11-04 00:00:00	200000	800000
368	89	3	172000	43000	Abono	Se realiza abono	2024-11-28 00:00:00	12	2024-11-04 10:36:27	2024-11-04 20:47:05	\N	2024-11-04 00:00:00	120000	480000
341	87	1	220000	55000	Pagada	N/A	2024-11-12 00:00:00	12	2024-11-04 09:18:38	2024-11-04 20:50:52	\N	2024-11-04 00:00:00	55000	220000
337	86	2	220000	55000	Abono	N/A	2024-11-20 00:00:00	12	2024-11-04 09:18:38	2024-11-04 21:20:16	\N	2024-11-04 00:00:00	60000	240000
342	87	2	220000	55000	Abono	N/A	2024-11-20 00:00:00	12	2024-11-04 09:18:38	2024-11-04 21:01:12	\N	2024-11-04 00:00:00	60000	240000
381	92	3	533333.93333333	133333.48333333	Pagada	N/A	2024-11-28 00:00:00	12	2024-11-04 16:10:11	2024-11-04 17:31:00	\N	2024-11-04 00:00:00	133333.48333333	533333.93333333
379	92	1	533333.93333333	133333.48333333	Pagada	N/A	2024-11-12 00:00:00	12	2024-11-04 16:10:11	2024-11-04 16:13:07	\N	2024-11-04 00:00:00	133333.48333333	533333.93333333
387	92	9	533333.93333333	133333.48333333	Pagada	N/A	2025-01-15 00:00:00	12	2024-11-04 16:10:11	2024-11-04 17:35:00	\N	2024-11-04 00:00:00	133333.48333333	533333.93333333
388	92	10	533333.93333333	133333.48333333	Pagada	N/A	2025-01-23 00:00:00	12	2024-11-04 16:10:11	2024-11-04 17:35:00	\N	2024-11-04 00:00:00	133333.48333333	533333.93333333
382	92	4	533333.93333333	133333.48333333	Pagada	N/A	2024-12-06 00:00:00	12	2024-11-04 16:10:11	2024-11-04 17:31:11	\N	2024-11-04 00:00:00	133333.48333333	533333.93333333
383	92	5	533333.93333333	133333.48333333	Abono intereses	N/A	2024-12-14 00:00:00	12	2024-11-04 16:10:11	2024-11-04 17:33:17	\N	2024-11-04 00:00:00	133333.48333333	0
389	92	11	533333.93333333	133333.48333333	Pagada	N/A	2025-01-31 00:00:00	12	2024-11-04 16:10:11	2024-11-04 17:35:00	\N	2024-11-04 00:00:00	133333.48333333	533333.93333333
390	92	12	533333.93333333	133333.48333333	Pagada	N/A	2025-02-08 00:00:00	12	2024-11-04 16:10:11	2024-11-04 17:35:00	\N	2024-11-04 00:00:00	133333.48333333	533333.93333333
391	92	13	533333.93333333	133333.48333333	Pagada	N/A	2025-02-16 00:00:00	12	2024-11-04 16:10:11	2024-11-04 17:35:00	\N	2024-11-04 00:00:00	133333.48333333	533333.93333333
392	92	14	533333.93333333	133333.48333333	Pagada	N/A	2025-02-24 00:00:00	12	2024-11-04 16:10:11	2024-11-04 17:35:00	\N	2024-11-04 00:00:00	133333.48333333	533333.93333333
393	92	15	533333.93333333	133333.48333333	Pagada	N/A	2025-03-04 00:00:00	12	2024-11-04 16:10:11	2024-11-04 17:35:00	\N	2024-11-04 00:00:00	133333.48333333	533333.93333333
394	93	1	200000	50000	Pagada	N/A	2024-11-12 00:00:00	12	2024-11-04 17:17:55	2024-11-04 17:19:45	\N	2024-11-04 00:00:00	50000	200000
395	93	2	200000	50000	Abono	N/A	2024-11-20 00:00:00	12	2024-11-04 17:17:55	2024-11-04 17:22:30	\N	2024-11-04 00:00:00	100000	400000
399	93	2	100000	25000	Pagada	Se realiza abono	2024-11-12 00:00:00	12	2024-11-04 17:22:30	2024-11-04 17:27:01	\N	2024-11-04 00:00:00	25000	100000
400	93	3	100000	25000	Pagada	Se realiza abono	2024-11-20 00:00:00	12	2024-11-04 17:22:30	2024-11-04 17:27:01	\N	2024-11-04 00:00:00	25000	100000
401	93	4	100000	25000	Pagada	Se realiza abono	2024-11-28 00:00:00	12	2024-11-04 17:22:30	2024-11-04 17:27:01	\N	2024-11-04 00:00:00	25000	100000
402	93	5	100000	25000	Pagada	Se realiza abono	2024-12-06 00:00:00	12	2024-11-04 17:22:30	2024-11-04 17:27:01	\N	2024-11-04 00:00:00	25000	100000
403	91	1	525000	131250	Pagada	Se realiza abono	2024-11-20 00:00:00	12	2024-11-04 17:44:56	2024-11-04 20:42:05	\N	2024-11-04 00:00:00	131250	525000
404	91	2	525000	131250	Abono	Se realiza abono	2024-12-06 00:00:00	12	2024-11-04 17:44:56	2024-11-04 20:42:18	\N	2024-11-04 00:00:00	100000	400000
411	91	2	467857.14285714	116964.28571429	Abono	Se realiza abono	2024-11-20 00:00:00	12	2024-11-04 20:42:18	2024-11-04 20:43:20	\N	2024-11-04 00:00:00	100000	400000
418	91	1	410714.28571429	102678.57142857	Abono	Se realiza abono	2024-11-20 00:00:00	12	2024-11-04 20:43:20	2024-11-04 20:44:37	\N	2024-11-04 00:00:00	100000	400000
425	91	2	353571.42857143	88392.857142857	Abono	Se realiza abono	2024-11-20 00:00:00	12	2024-11-04 20:44:37	2024-11-04 20:44:51	\N	2024-11-04 00:00:00	100000	400000
432	91	2	296428.57142857	74107.142857143	Pagada	Se realiza abono	2024-11-20 00:00:00	12	2024-11-04 20:44:51	2024-11-04 20:45:02	\N	2024-11-04 00:00:00	74107.142857143	296428.57142857
433	91	3	296428.57142857	74107.142857143	Pagada	Se realiza abono	2024-12-06 00:00:00	12	2024-11-04 20:44:51	2024-11-04 20:45:02	\N	2024-11-04 00:00:00	74107.142857143	296428.57142857
434	91	4	296428.57142857	74107.142857143	Pagada	Se realiza abono	2024-12-22 00:00:00	12	2024-11-04 20:44:51	2024-11-04 20:45:02	\N	2024-11-04 00:00:00	74107.142857143	296428.57142857
435	91	5	296428.57142857	74107.142857143	Pagada	Se realiza abono	2025-01-07 00:00:00	12	2024-11-04 20:44:51	2024-11-04 20:45:02	\N	2024-11-04 00:00:00	74107.142857143	296428.57142857
436	91	6	296428.57142857	74107.142857143	Pagada	Se realiza abono	2025-01-23 00:00:00	12	2024-11-04 20:44:51	2024-11-04 20:45:02	\N	2024-11-04 00:00:00	74107.142857143	296428.57142857
437	91	7	296428.57142857	74107.142857143	Pagada	Se realiza abono	2025-02-08 00:00:00	12	2024-11-04 20:44:51	2024-11-04 20:45:02	\N	2024-11-04 00:00:00	74107.142857143	296428.57142857
438	91	8	296428.57142857	74107.142857143	Pagada	Se realiza abono	2025-02-24 00:00:00	12	2024-11-04 20:44:51	2024-11-04 20:45:02	\N	2024-11-04 00:00:00	74107.142857143	296428.57142857
439	89	3	12000	3000	Abono	Se realiza abono	2024-11-12 00:00:00	12	2024-11-04 20:47:05	2024-11-04 20:48:45	\N	2024-11-04 00:00:00	2400	9600
442	89	3	8800	2200	Pagada	Se realiza abono	2024-11-12 00:00:00	12	2024-11-04 20:48:45	2024-11-04 20:49:08	\N	2024-11-04 00:00:00	2200	8800
443	89	4	8800	2200	Pagada	Se realiza abono	2024-11-20 00:00:00	12	2024-11-04 20:48:45	2024-11-04 20:49:08	\N	2024-11-04 00:00:00	2200	8800
444	89	5	8800	2200	Pagada	Se realiza abono	2024-11-28 00:00:00	12	2024-11-04 20:48:45	2024-11-04 20:49:08	\N	2024-11-04 00:00:00	2200	8800
336	86	1	220000	55000	Pagada	N/A	2024-11-12 00:00:00	12	2024-11-04 09:18:38	2024-11-04 21:03:40	\N	2024-11-04 00:00:00	55000	220000
452	84	4	215000	53750	Abono	Se realiza abono	2024-11-12 00:00:00	12	2024-11-04 21:20:45	2024-11-04 21:21:49	\N	2024-11-04 00:00:00	60000	240000
456	84	3	206666.66666667	51666.666666667	Pendiente	Se realiza abono	2024-11-12 00:00:00	\N	2024-11-04 21:21:49	2024-11-04 21:21:49	\N	\N	0	0
457	84	4	206666.66666667	51666.666666667	Pendiente	Se realiza abono	2024-11-20 00:00:00	\N	2024-11-04 21:21:49	2024-11-04 21:21:49	\N	\N	0	0
458	84	5	206666.66666667	51666.666666667	Pendiente	Se realiza abono	2024-11-28 00:00:00	\N	2024-11-04 21:21:49	2024-11-04 21:21:49	\N	\N	0	0
459	83	1	172000	43000	Pagada	Se realiza abono	2024-11-12 00:00:00	12	2024-11-04 21:25:56	2024-11-04 21:26:21	\N	2024-11-04 00:00:00	43000	172000
460	83	2	172000	43000	Pagada	Se realiza abono	2024-11-20 00:00:00	12	2024-11-04 21:25:56	2024-11-04 21:26:21	\N	2024-11-04 00:00:00	43000	172000
461	83	3	172000	43000	Pagada	Se realiza abono	2024-11-28 00:00:00	12	2024-11-04 21:25:56	2024-11-04 21:26:21	\N	2024-11-04 00:00:00	43000	172000
462	83	4	172000	43000	Pagada	Se realiza abono	2024-12-06 00:00:00	12	2024-11-04 21:25:56	2024-11-04 21:26:21	\N	2024-11-04 00:00:00	43000	172000
463	83	5	172000	43000	Pagada	Se realiza abono	2024-12-14 00:00:00	12	2024-11-04 21:25:56	2024-11-04 21:26:21	\N	2024-11-04 00:00:00	43000	172000
464	82	2	215000	53750	Abono	Se realiza abono	2024-11-12 00:00:00	12	2024-11-04 21:29:42	2024-11-04 21:31:18	\N	2024-11-04 00:00:00	60000	240000
468	82	3	155000	38750	Abono	Se realiza abono	2024-11-12 00:00:00	12	2024-11-04 21:31:18	2024-11-04 21:34:26	\N	2024-11-04 00:00:00	60000	240000
472	82	4	190000	47500	Pendiente	Se realiza abono	2024-11-12 00:00:00	\N	2024-11-04 21:34:26	2024-11-04 21:34:26	\N	\N	0	0
473	82	5	190000	47500	Pendiente	Se realiza abono	2024-11-20 00:00:00	\N	2024-11-04 21:34:26	2024-11-04 21:34:26	\N	\N	0	0
474	75	2	215000	53750	Abono	Se realiza abono	2024-11-12 00:00:00	12	2024-11-04 21:35:08	2024-11-04 21:35:22	\N	2024-11-04 00:00:00	60000	240000
478	75	3	206666.66666667	51666.666666667	Pagada	Se realiza abono	2024-11-12 00:00:00	12	2024-11-04 21:35:22	2024-11-04 21:38:17	\N	2024-11-04 00:00:00	51666.666666667	206666.66666667
479	75	4	206666.66666667	51666.666666667	Pagada	Se realiza abono	2024-11-20 00:00:00	12	2024-11-04 21:35:22	2024-11-04 21:38:17	\N	2024-11-04 00:00:00	51666.666666667	206666.66666667
480	75	5	206666.66666667	51666.666666667	Pagada	Se realiza abono	2024-11-28 00:00:00	12	2024-11-04 21:35:22	2024-11-04 21:38:17	\N	2024-11-04 00:00:00	51666.666666667	206666.66666667
481	74	2	215000	53750	Pendiente	Se realiza abono	2024-11-12 00:00:00	\N	2024-11-04 21:38:39	2024-11-04 21:38:39	\N	\N	0	0
482	74	3	215000	53750	Pendiente	Se realiza abono	2024-11-20 00:00:00	\N	2024-11-04 21:38:39	2024-11-04 21:38:39	\N	\N	0	0
483	74	4	215000	53750	Pendiente	Se realiza abono	2024-11-28 00:00:00	\N	2024-11-04 21:38:39	2024-11-04 21:38:39	\N	\N	0	0
484	74	5	215000	53750	Pendiente	Se realiza abono	2024-12-06 00:00:00	\N	2024-11-04 21:38:39	2024-11-04 21:38:39	\N	\N	0	0
449	86	3	213333.33333333	53333.333333333	Pagada	Se realiza abono	2024-11-12 00:00:00	12	2024-11-04 21:20:16	2024-11-04 22:23:05	\N	2024-11-04 00:00:00	53333.333333333	213333.33333333
450	86	4	213333.33333333	53333.333333333	Pagada	Se realiza abono	2024-11-20 00:00:00	12	2024-11-04 21:20:16	2024-11-04 22:23:05	\N	2024-11-04 00:00:00	53333.333333333	213333.33333333
451	86	5	213333.33333333	53333.333333333	Pagada	Se realiza abono	2024-11-28 00:00:00	12	2024-11-04 21:20:16	2024-11-04 22:23:05	\N	2024-11-04 00:00:00	53333.333333333	213333.33333333
445	87	3	160000	40000	Abono	Se realiza abono	2024-11-12 00:00:00	12	2024-11-04 21:01:12	2024-11-05 16:23:50	\N	2024-11-05 00:00:00	40000	160000
485	87	4	240000	60000	Pendiente	Se realiza abono	2024-11-13 00:00:00	\N	2024-11-05 16:23:50	2024-11-05 16:23:50	\N	\N	0	0
486	87	5	240000	60000	Pendiente	Se realiza abono	2024-11-21 00:00:00	\N	2024-11-05 16:23:50	2024-11-05 16:23:50	\N	\N	0	0
172	59	1	100000	50000	Pagada	N/A	2024-11-06 00:00:00	12	2024-10-30 10:54:38	2024-11-05 22:13:39	\N	2024-11-05 00:00:00	50000	100000
488	94	2	333333.33333333	66666.666666667	Pendiente	N/A	2024-11-22 00:00:00	12	2024-11-06 11:10:20	2024-11-06 11:10:20	\N	\N	0	0
489	94	3	333333.33333333	66666.666666667	Pendiente	N/A	2024-11-30 00:00:00	12	2024-11-06 11:10:20	2024-11-06 11:10:20	\N	\N	0	0
490	94	4	333333.33333333	66666.666666667	Pendiente	N/A	2024-12-08 00:00:00	12	2024-11-06 11:10:20	2024-11-06 11:10:20	\N	\N	0	0
491	94	5	333333.33333333	66666.666666667	Pendiente	N/A	2024-12-16 00:00:00	12	2024-11-06 11:10:20	2024-11-06 11:10:20	\N	\N	0	0
492	94	6	333333.33333333	66666.666666667	Pendiente	N/A	2024-12-24 00:00:00	12	2024-11-06 11:10:20	2024-11-06 11:10:20	\N	\N	0	0
493	94	7	333333.33333333	66666.666666667	Pendiente	N/A	2025-01-01 00:00:00	12	2024-11-06 11:10:20	2024-11-06 11:10:20	\N	\N	0	0
494	94	8	333333.33333333	66666.666666667	Pendiente	N/A	2025-01-09 00:00:00	12	2024-11-06 11:10:20	2024-11-06 11:10:20	\N	\N	0	0
495	94	9	333333.33333333	66666.666666667	Pendiente	N/A	2025-01-17 00:00:00	12	2024-11-06 11:10:20	2024-11-06 11:10:20	\N	\N	0	0
496	94	10	333333.33333333	66666.666666667	Pendiente	N/A	2025-01-25 00:00:00	12	2024-11-06 11:10:20	2024-11-06 11:10:20	\N	\N	0	0
497	94	11	333333.33333333	66666.666666667	Pendiente	N/A	2025-02-02 00:00:00	12	2024-11-06 11:10:20	2024-11-06 11:10:20	\N	\N	0	0
498	94	12	333333.33333333	66666.666666667	Pendiente	N/A	2025-02-10 00:00:00	12	2024-11-06 11:10:20	2024-11-06 11:10:20	\N	\N	0	0
499	94	13	333333.33333333	66666.666666667	Pendiente	N/A	2025-02-18 00:00:00	12	2024-11-06 11:10:20	2024-11-06 11:10:20	\N	\N	0	0
500	94	14	333333.33333333	66666.666666667	Pendiente	N/A	2025-02-26 00:00:00	12	2024-11-06 11:10:20	2024-11-06 11:10:20	\N	\N	0	0
501	94	15	333333.33333333	66666.666666667	Pendiente	N/A	2025-03-06 00:00:00	12	2024-11-06 11:10:20	2024-11-06 11:10:20	\N	\N	0	0
502	94	16	333333.33333333	66666.666666667	Pendiente	N/A	2025-03-14 00:00:00	12	2024-11-06 11:10:20	2024-11-06 11:10:20	\N	\N	0	0
503	94	17	333333.33333333	66666.666666667	Pendiente	N/A	2025-03-22 00:00:00	12	2024-11-06 11:10:20	2024-11-06 11:10:20	\N	\N	0	0
504	94	18	333333.33333333	66666.666666667	Pendiente	N/A	2025-03-30 00:00:00	12	2024-11-06 11:10:20	2024-11-06 11:10:20	\N	\N	0	0
487	94	1	333333.33333333	66666.666666667	Pagada	N/A	2024-11-14 00:00:00	12	2024-11-06 11:10:20	2024-11-06 11:11:26	\N	2024-11-06 00:00:00	66666.666666667	333333.33333333
\.


--
-- Data for Name: item_menu; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.item_menu (id, item_menu_profile, item_menu_menu, created_at, updated_at, deleted_at) FROM stdin;
1	1	1	2024-10-21 16:45:48	2024-10-21 16:45:48	2024-10-21 16:45:48
2	1	2	2024-10-21 16:45:48	2024-10-21 16:45:48	2024-10-21 16:45:48
3	1	3	2024-10-21 16:45:48	2024-10-21 16:45:48	2024-10-21 16:45:48
4	1	4	2024-10-21 16:45:48	2024-10-21 16:45:48	2024-10-21 16:45:48
5	1	5	2024-10-21 16:45:48	2024-10-21 16:45:48	2024-10-21 16:45:48
6	1	6	2024-10-21 16:45:48	2024-10-21 16:45:48	2024-10-21 16:45:48
7	1	7	2024-10-21 16:45:48	2024-10-21 16:45:48	2024-10-21 16:45:48
8	2	1	2024-10-21 16:45:48	2024-10-21 16:45:48	2024-10-21 16:45:48
9	2	2	2024-10-21 16:45:48	2024-10-21 16:45:48	2024-10-21 16:45:48
10	2	3	2024-10-21 16:45:48	2024-10-21 16:45:48	2024-10-21 16:45:48
11	3	1	2024-10-21 16:45:48	2024-10-21 16:45:48	2024-10-21 16:45:48
12	3	2	2024-10-21 16:45:48	2024-10-21 16:45:48	2024-10-21 16:45:48
13	3	4	2024-10-21 16:45:48	2024-10-21 16:45:48	2024-10-21 16:45:48
14	4	1	2024-10-21 16:45:48	2024-10-21 16:45:48	2024-10-21 16:45:48
15	4	5	2024-10-21 16:45:48	2024-10-21 16:45:48	2024-10-21 16:45:48
16	1	8	2024-10-21 16:45:48	2024-10-21 16:45:48	2024-10-21 16:45:48
\.


--
-- Data for Name: loans; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.loans (id, loans_nombre, loans_apellido_uno, loans_apellido_dos, loans_tipo_documento, loans_documento, loans_fecha_nacimiento, loans_ciudad, loans_barrio, loans_direccion, loans_intereses, loans_cuotas, loans_cuando, loans_observacion, loans_fecha, loans_estado, user_creador, user_recomendacion, loans_valor_prestado, user_customer, user_cobrador, created_at, updated_at, deleted_at, loans_celular, loans_inicio_pago, loans_fecha_ultimo_pago, loans_pago_interes, loans_pago_prestado, loans_intereses_recaudar) FROM stdin;
59	Maria Antonieta	De las nieve	ds	CC	100465546	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	50	5	S	\N	30-10-2024	En curso	22	14	500000	18	14	2024-10-30 10:54:38	2024-11-05 22:13:39	\N	312596295	2024-10-30 00:00:00	05-11-2024	0	100000	\N
10	Luis andre	Herrera	MArtinez	CC	100465545	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	25	6	S	\N	Thu Oct 24 2024	Pendiente	22	\N	500000	14	14	2024-10-24 06:38:52	2024-10-24 06:38:52	\N	655465456	\N	02-10-2024	0	0	\N
16	Maria Antonieta	De las nieve	ds	CC	100465546	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	25	6	S	\N	Tue Oct 29 2024	Pendiente	22	14	500000	18	14	2024-10-29 11:22:57	2024-10-29 11:22:57	\N	312596295	2024-11-05 05:00:00	02-10-2024	0	0	\N
94	Maria Antonieta 2	De las nieve	ds	CC	1004655468	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon2	Calle 7505	20	18	S	\N	06-11-2024	En curso	12	18	6000000	19	14	2024-11-06 11:10:20	2024-11-06 11:11:26	\N	312596295	2024-11-06 00:00:00	06-11-2024	66666.666666667	333333.33333333	1200000
22	Maria Antonieta	De las nieve	ds	CC	100465546	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	25	6	S	\N	Tue Oct 29 2024	Pendiente	22	14	500000	18	14	2024-10-29 11:26:41	2024-10-29 11:26:41	\N	312596295	2024-11-05 05:00:00	02-10-2024	0	0	\N
23	Maria Antonieta	De las nieve	ds	CC	100465546	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	25	6	S	\N	Tue Oct 29 2024	Pendiente	22	14	600000	18	14	2024-10-29 11:27:12	2024-10-29 11:27:12	\N	312596295	2024-11-05 05:00:00	02-10-2024	0	0	\N
28	Maria Antonieta	De las nieve	ds	CC	100465546	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	25	6	Q	\N	Tue Oct 29 2024	Pendiente	22	14	600081	18	14	2024-10-29 11:30:53	2024-10-29 11:30:53	\N	312596295	2024-11-05 05:00:00	02-10-2024	0	0	\N
30	Maria Antonieta	De las nieve	ds	CC	100465546	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	30	10	Q	\N	Tue Oct 29 2024	Pendiente	22	14	1000000	18	14	2024-10-29 13:26:20	2024-10-29 13:26:20	\N	312596295	2024-11-14 05:00:00	02-10-2024	0	0	\N
31	Maria Antonieta	De las nieve	ds	CC	100465546	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	30	6	Q	\N	29-10-2024	Pendiente	22	14	500000	18	14	2024-10-29 13:32:49	2024-10-29 13:32:49	\N	312596295	2024-11-15 05:00:00	02-10-2024	0	0	\N
32	Maria Antonieta	De las nieve	ds	CC	100465546	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	25	7	Q	\N	29-10-2024	Pendiente	22	14	500000	18	14	2024-10-29 13:38:26	2024-10-29 13:38:26	\N	312596295	2024-11-12 05:00:00	02-10-2024	0	0	\N
39	Maria Antonieta	De las nieve	ds	CC	100465546	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	25	7	Q	\N	2024-11-12T05:00:00.000Z	Anulado	22	14	500000	18	14	2024-10-29 13:50:51	2024-10-29 13:50:51	\N	312596295	2024-11-12 05:00:00	02-10-2024	0	0	\N
26	Maria Antonieta	De las nieve	ds	CC	100465546	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	25	6	S	\N	Tue Oct 29 2024	Pendiente	22	14	600000	18	14	2024-10-29 11:30:31	2024-10-29 11:30:31	\N	312596295	2024-11-05 05:00:00	01-11-2024	0	0	\N
11	Maria Antonieta	De las nieve	ds	CC	100465546	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	40	3	D	\N	Thu Oct 24 2024	Pendiente	22	\N	100000	18	14	2024-10-24 07:14:59	2024-10-24 07:14:59	\N	655465456	\N	30-10-2024	0	0	\N
27	Maria Antonieta	De las nieve	ds	CC	100465546	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	25	6	D	\N	Tue Oct 29 2024	Pendiente	22	14	600001	18	14	2024-10-29 11:30:39	2024-10-29 11:30:39	\N	312596295	2024-11-05 05:00:00	30-10-2024	0	0	\N
3	Luis andre	Herrera	MArtinez	CC	100465545	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	25	6	S	\N	Thu Oct 24 2024	Pendiente	22	\N	500000	14	14	2024-10-24 06:38:44	2024-10-24 06:38:44	\N	655465456	\N	02-10-2024	0	0	\N
4	Luis andre	Herrera	MArtinez	CC	100465545	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	25	6	S	\N	Thu Oct 24 2024	Pendiente	22	\N	500000	14	14	2024-10-24 06:38:45	2024-10-24 06:38:45	\N	655465456	\N	02-10-2024	0	0	\N
5	Luis andre	Herrera	MArtinez	CC	100465545	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	25	6	S	\N	Thu Oct 24 2024	Pendiente	22	\N	500000	14	14	2024-10-24 06:38:46	2024-10-24 06:38:46	\N	655465456	\N	02-10-2024	0	0	\N
29	Maria Antonieta	De las nieve	ds	CC	100465546	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	25	6	M	\N	Tue Oct 29 2024	Pendiente	22	14	700000	18	14	2024-10-29 11:31:02	2024-10-29 11:31:02	\N	312596295	2024-11-05 05:00:00	09-10-2024	0	0	\N
56	Maria Antonieta 2	De las nieve	ds	CC	1004655468	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon2	Calle 7505	50	5	D	\N	06-11-2024	Pendiente	22	14	500000	19	14	2024-10-30 10:42:30	2024-10-30 10:42:30	\N	312596295	2024-11-06 00:00:00	01-11-2024	0	0	\N
54	Maria Antonieta	De las nieve	ds	CC	100465546	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	30	7	Q	\N	12-11-2024	Pendiente	22	14	600000	18	14	2024-10-29 14:49:08	2024-10-29 14:49:08	\N	312596295	2024-11-12 00:00:00	02-10-2024	0	0	\N
57	Maria Antonieta	De las nieve	ds	CC	100465546	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	50	5	S	\N	30-10-2024	Pendiente	22	14	500000	18	14	2024-10-30 10:52:35	2024-10-30 10:52:35	\N	312596295	2024-10-30 00:00:00	02-10-2024	0	0	\N
62	Maria Antonieta	De las nieve	ds	CC	100465546	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	50	5	M	\N	30-10-2024	Cancelado	22	14	500000	18	14	2024-10-30 11:00:56	2024-11-02 11:34:31	\N	312596295	2024-10-30 00:00:00	02-10-2024	0	0	\N
6	Luis andre	Herrera	MArtinez	CC	100465545	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	25	6	S	\N	Thu Oct 24 2024	Pendiente	22	\N	500000	14	14	2024-10-24 06:38:47	2024-10-24 06:38:47	\N	655465456	\N	02-10-2024	0	0	\N
7	Luis andre	Herrera	MArtinez	CC	100465545	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	25	6	S	\N	Thu Oct 24 2024	Pendiente	22	\N	500000	14	14	2024-10-24 06:38:48	2024-10-24 06:38:48	\N	655465456	\N	02-10-2024	0	0	\N
8	Luis andre	Herrera	MArtinez	CC	100465545	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	25	6	S	\N	Thu Oct 24 2024	Pendiente	22	\N	500000	14	14	2024-10-24 06:38:49	2024-10-24 06:38:49	\N	655465456	\N	02-10-2024	0	0	\N
9	Luis andre	Herrera	MArtinez	CC	100465545	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	25	6	S	\N	Thu Oct 24 2024	Pendiente	22	\N	500000	14	14	2024-10-24 06:38:50	2024-10-24 06:38:50	\N	655465456	\N	02-10-2024	0	0	\N
58	Maria Antonieta	De las nieve	ds	CC	100465546	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	50	5	S	\N	30-10-2024	Pendiente	22	14	500000	18	14	2024-10-30 10:54:34	2024-11-02 17:39:28	\N	312596295	2024-10-30 00:00:00	02-11-2024	0	0	\N
55	Maria Antonieta	De las nieve	ds	CC	100465546	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	30	7	Q	\N	15-11-2024	Pendiente	22	14	50000	18	14	2024-10-29 14:49:54	2024-11-02 17:43:49	\N	312596295	2024-11-15 00:00:00	02-11-2024	0	0	\N
52	Maria Antonieta	De las nieve	ds	CC	100465546	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	25	7	Q	\N	12-11-24	Pendiente	22	14	500000	18	14	2024-10-29 14:16:11	2024-11-02 17:46:46	\N	312596295	2024-11-12 05:00:00	02-11-2024	0	0	\N
60	Maria Antonieta	De las nieve	ds	CC	100465546	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	50	5	S	\N	30-10-2024	Cancelado	22	14	500000	18	14	2024-10-30 10:56:57	2024-11-03 07:50:54	\N	312596295	2024-10-30 00:00:00	03-11-2024	0	0	\N
63	Maria Antonieta 2	De las nieve	ds	CC	1004655468	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon2	Calle 7505	40	5	Q	\N	17-11-2024	Pendiente	22	14	1000000	19	14	2024-11-03 12:54:51	2024-11-03 15:47:33	\N	312596295	2024-11-17 00:00:00	03-11-2024	80000	200000	\N
61	Maria Antonieta	De las nieve	ds	CC	100465546	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	50	5	S	\N	30-10-2024	Cancelado	22	14	500000	18	14	2024-10-30 10:59:22	2024-11-03 12:53:12	\N	312596295	2024-10-30 00:00:00	03-11-2024	0	0	\N
1	Luis andre	Herrera	MArtinez	CC	100465545	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	25	6	S	\N	Thu Oct 24 2024	Pendiente	22	\N	500000	14	14	2024-10-24 06:33:55	2024-10-24 06:33:55	\N	655465456	\N	02-10-2024	0	0	\N
2	Luis andre	Herrera	MArtinez	CC	100465545	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	25	6	S	\N	Thu Oct 24 2024	Pendiente	22	\N	500000	14	14	2024-10-24 06:38:42	2024-10-24 06:38:42	\N	655465456	\N	02-10-2024	0	0	\N
69	Maria Antonieta 2	De las nieve	ds	CC	1004655468	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon2	Calle 7505	25	5	Q	\N	04-11-2024	Pendiente	22	14	1150000	19	14	2024-11-04 00:49:09	2024-11-04 08:11:47	\N	312596295	2024-11-04 00:00:00	04-11-2024	270000	1080000	\N
71	Maria Antonieta 2	De las nieve	ds	CC	1004655468	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon2	Calle 7505	25	5	S	\N	04-11-2024	Pendiente	22	14	1100000	19	14	2024-11-04 09:18:25	2024-11-04 09:18:25	\N	312596295	2024-11-04 00:00:00	04-11-2024	0	0	275000
72	Maria Antonieta 2	De las nieve	ds	CC	1004655468	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon2	Calle 7505	25	5	S	\N	04-11-2024	Pendiente	22	14	1100000	19	14	2024-11-04 09:18:27	2024-11-04 09:18:27	\N	312596295	2024-11-04 00:00:00	04-11-2024	0	0	275000
64	Maria Antonieta 2	De las nieve	ds	CC	1004655468	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon2	Calle 7505	25	10	Q	\N	17-11-2024	Pendiente	22	14	2000000	19	14	2024-11-03 13:00:24	2024-11-03 15:31:58	\N	312596295	2024-11-17 00:00:00	03-11-2024	0	0	\N
73	Maria Antonieta 2	De las nieve	ds	CC	1004655468	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon2	Calle 7505	25	5	S	\N	04-11-2024	Pendiente	22	14	1100000	19	14	2024-11-04 09:18:28	2024-11-04 09:18:28	\N	312596295	2024-11-04 00:00:00	04-11-2024	0	0	275000
76	Maria Antonieta 2	De las nieve	ds	CC	1004655468	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon2	Calle 7505	25	5	S	\N	04-11-2024	Pendiente	22	14	1100000	19	14	2024-11-04 09:18:31	2024-11-04 09:18:31	\N	312596295	2024-11-04 00:00:00	04-11-2024	0	0	275000
77	Maria Antonieta 2	De las nieve	ds	CC	1004655468	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon2	Calle 7505	25	5	S	\N	04-11-2024	Pendiente	22	14	1100000	19	14	2024-11-04 09:18:32	2024-11-04 09:18:32	\N	312596295	2024-11-04 00:00:00	04-11-2024	0	0	275000
78	Maria Antonieta 2	De las nieve	ds	CC	1004655468	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon2	Calle 7505	25	5	S	\N	04-11-2024	Pendiente	22	14	1100000	19	14	2024-11-04 09:18:33	2024-11-04 09:18:33	\N	312596295	2024-11-04 00:00:00	04-11-2024	0	0	275000
79	Maria Antonieta 2	De las nieve	ds	CC	1004655468	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon2	Calle 7505	25	5	S	\N	04-11-2024	Pendiente	22	14	1100000	19	14	2024-11-04 09:18:34	2024-11-04 09:18:34	\N	312596295	2024-11-04 00:00:00	04-11-2024	0	0	275000
68	Maria Antonieta 2	De las nieve	ds	CC	1004655468	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon2	Calle 7505	25	10	Q	\N	03-11-2024	Pendiente	22	14	10000000	19	14	2024-11-03 16:04:07	2024-11-04 08:20:22	\N	312596295	2024-11-03 00:00:00	04-11-2024	2500000	10000000	\N
80	Maria Antonieta 2	De las nieve	ds	CC	1004655468	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon2	Calle 7505	25	5	S	\N	04-11-2024	Pendiente	22	14	1100000	19	14	2024-11-04 09:18:35	2024-11-04 09:18:35	\N	312596295	2024-11-04 00:00:00	04-11-2024	0	0	275000
65	Maria Antonieta	De las nieve	ds	CC	100465546	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	30	10	M	\N	03-11-2024	Pendiente	22	14	3000000	18	14	2024-11-03 13:06:27	2024-11-04 00:43:06	\N	312596295	2024-11-10 00:00:00	04-11-2024	500769.23076923	1669230.7692308	\N
70	Maria Antonieta 2	De las nieve	ds	CC	1004655468	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon2	Calle 7505	25	5	S	\N	04-11-2024	Pendiente	22	14	2150000	19	14	2024-11-04 00:51:54	2024-11-04 07:55:27	\N	312596295	2024-11-04 00:00:00	04-11-2024	527500	2110000	537500
81	Maria Antonieta 2	De las nieve	ds	CC	1004655468	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon2	Calle 7505	25	5	S	\N	04-11-2024	Pendiente	22	14	1100000	19	14	2024-11-04 09:18:36	2024-11-04 09:18:36	\N	312596295	2024-11-04 00:00:00	04-11-2024	0	0	275000
85	Maria Antonieta 2	De las nieve	ds	CC	1004655468	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon2	Calle 7505	25	5	S	\N	04-11-2024	Pendiente	22	14	1100000	19	14	2024-11-04 09:18:37	2024-11-04 09:18:37	\N	312596295	2024-11-04 00:00:00	04-11-2024	0	0	275000
82	Maria Antonieta 2	De las nieve	ds	CC	1004655468	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon2	Calle 7505	25	5	S	\N	04-11-2024	En curso	22	14	1100000	19	14	2024-11-04 09:18:36	2024-11-04 21:34:26	\N	312596295	2024-11-04 00:00:00	04-11-2024	180000	720000	275000
90	Maria Antonieta 2	De las nieve	ds	CC	1004655468	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon2	Calle 7505	25	5	S	\N	04-11-2024	Cancelado	22	14	1100000	19	14	2024-11-04 09:18:39	2024-11-04 10:00:29	\N	312596295	2024-11-04 00:00:00	04-11-2024	275000	1100000	275000
66	Maria Antonieta	De las nieve	ds	CC	100465546	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	25	10	M	\N	03-11-2024	Cancelado	22	14	5000000	18	14	2024-11-03 15:50:04	2024-11-04 08:31:19	\N	312596295	2024-11-03 00:00:00	04-11-2024	1250000	5000000	\N
88	Maria Antonieta 2	De las nieve	ds	CC	1004655468	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon2	Calle 7505	25	5	S	\N	04-11-2024	Cancelado	22	14	1100000	19	14	2024-11-04 09:18:38	2024-11-04 09:44:59	\N	312596295	2024-11-04 00:00:00	04-11-2024	275000	1100000	275000
92	Maria Antonieta 2	De las nieve	ds	CC	1004655468	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon2	Calle 7505	25	15	S	\N	04-11-2024	Cancelado	22	14	8000009	19	14	2024-11-04 16:10:11	2024-11-04 17:35:00	\N	312596295	2024-11-04 00:00:00	04-11-2024	2000002.25	8000009	2000002.25
93	Maria Antonieta 2	De las nieve	ds	CC	1004655468	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon2	Calle 7505	25	5	S	\N	04-11-2024	Cancelado	22	18	1000000	19	22	2024-11-04 17:17:55	2024-11-04 17:27:01	\N	312596295	2024-11-04 00:00:00	04-11-2024	250000	1000000	250000
91	Maria Antonieta 2	De las nieve	ds	CC	1004655468	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon2	Calle 7505	25	8	Q	\N	04-11-2024	Cancelado	22	14	5000000	19	14	2024-11-04 16:04:19	2024-11-04 20:45:02	\N	312596295	2024-11-04 00:00:00	04-11-2024	1250000	5000000	1250000
89	Maria Antonieta 2	De las nieve	ds	CC	1004655468	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon2	Calle 7505	25	5	S	\N	04-11-2024	Cancelado	22	14	1100000	19	14	2024-11-04 09:18:39	2024-11-04 20:49:08	\N	312596295	2024-11-04 00:00:00	04-11-2024	275000	1100000	275000
84	Maria Antonieta 2	De las nieve	ds	CC	1004655468	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon2	Calle 7505	25	5	S	\N	04-11-2024	En curso	22	14	1100000	19	14	2024-11-04 09:18:37	2024-11-04 21:21:49	\N	312596295	2024-11-04 00:00:00	04-11-2024	120000	480000	275000
83	Maria Antonieta 2	De las nieve	ds	CC	1004655468	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon2	Calle 7505	25	5	S	\N	04-11-2024	Cancelado	22	14	1100000	19	14	2024-11-04 09:18:37	2024-11-04 21:26:21	\N	312596295	2024-11-04 00:00:00	04-11-2024	275000	1100000	275000
75	Maria Antonieta 2	De las nieve	ds	CC	1004655468	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon2	Calle 7505	25	5	S	\N	04-11-2024	Cancelado	22	14	1100000	19	14	2024-11-04 09:18:30	2024-11-04 21:38:17	\N	312596295	2024-11-04 00:00:00	04-11-2024	275000	1100000	275000
74	Maria Antonieta 2	De las nieve	ds	CC	1004655468	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon2	Calle 7505	25	5	S	\N	04-11-2024	En curso	22	14	1100000	19	14	2024-11-04 09:18:29	2024-11-04 21:38:39	\N	312596295	2024-11-04 00:00:00	04-11-2024	60000	240000	275000
86	Maria Antonieta 2	De las nieve	ds	CC	1004655468	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon2	Calle 7505	25	5	S	\N	04-11-2024	Cancelado	22	14	1100000	19	14	2024-11-04 09:18:38	2024-11-04 22:23:05	\N	312596295	2024-11-04 00:00:00	04-11-2024	275000	1100000	275000
87	Maria Antonieta 2	De las nieve	ds	CC	1004655468	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon2	Calle 7505	25	5	S	\N	04-11-2024	En curso	22	14	1100000	19	14	2024-11-04 09:18:38	2024-11-05 16:23:50	\N	312596295	2024-11-04 00:00:00	05-11-2024	155000	620000	275000
\.


--
-- Data for Name: menu; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.menu (id, menu_name, menu_prefix, menu_url, created_at, updated_at, deleted_at, menu_orden) FROM stdin;
7	Garantia	Gar	/dashboard/list-warranty	2024-10-21 16:45:48	2024-10-21 16:45:48	\N	7
8	Compañia	Com	/dashboard/company	2024-10-21 16:45:48	2024-10-21 16:45:48	\N	2
2	Usuarios	Usu	/dashboard/list-users	2024-10-21 16:45:48	2024-10-21 16:45:48	\N	6
3	Recaudos	Rec	/dashboard/list-precautions	2024-10-21 16:45:48	2024-10-21 16:45:48	\N	3
6	Barrios	Bor	/dashboard/list-neighborhood	2024-10-21 16:45:48	2024-10-21 16:45:48	\N	8
5	Cobrador	Cob	/dashboard/list-charge	2024-10-21 16:45:48	2024-10-21 16:45:48	\N	5
4	Prestamos	Pre	/dashboard/list-loans	2024-10-21 16:45:48	2024-10-21 16:45:48	\N	4
1	Inicio	Ini	/dashboard	2024-10-21 16:45:48	2024-10-21 16:45:48	\N	1
\.


--
-- Data for Name: migrations; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.migrations (id, migration, batch) FROM stdin;
1	2014_09_01_000000_create_menu_table	1
2	2014_09_02_000000_create_profile_table	1
3	2014_09_03_000000_create_menu_profile_table	1
4	2014_10_12_000000_create_users_table	1
5	2014_10_12_100000_create_password_reset_tokens_table	1
6	2018_08_08_100000_create_telescope_entries_table	1
7	2019_08_19_000000_create_failed_jobs_table	1
8	2019_12_14_000001_create_personal_access_tokens_table	1
\.


--
-- Data for Name: password_reset_tokens; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.password_reset_tokens (email, token, created_at) FROM stdin;
\.


--
-- Data for Name: personal_access_tokens; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.personal_access_tokens (id, tokenable_type, tokenable_id, name, token, abilities, last_used_at, expires_at, created_at, updated_at) FROM stdin;
1	App\\Models\\User	11	xxxxxxxxxxxx	9c7f2ff925aba175db4773ad323fba7e5a946d1e970723e6f9f1698215276c7f	["*"]	\N	\N	2024-10-21 16:43:39	2024-10-21 16:43:39
2	App\\Models\\User	11	xxxxxxxxxxxx	9fb66c4550b3c236db72dc82c89ae5e7d87a117ec8f5b794654fadd71ef88055	["*"]	\N	\N	2024-10-21 16:45:48	2024-10-21 16:45:48
3	App\\Models\\User	11	xxxxxxxxxxxx	2f7a025e419c693ee95c94bd3d0fc42e293fcaf2e52c11888cc84db8f2213805	["*"]	\N	\N	2024-10-21 16:51:08	2024-10-21 16:51:08
4	App\\Models\\User	11	xxxxxxxxxxxx	61ec6c0ce6acf485aab4c6574e13df1b104a2fc970200bdfb53de805432f40b0	["*"]	\N	\N	2024-10-21 16:52:00	2024-10-21 16:52:00
\.


--
-- Data for Name: profile; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.profile (id, profile_name, profile_prefix, created_at, updated_at, deleted_at) FROM stdin;
1	Administrador	Admi	2024-04-16 22:11:54	2024-04-16 22:11:54	2024-04-16 22:11:54
2	Recaudador	Recau	2024-04-16 22:11:54	2024-04-16 22:11:54	2024-04-16 22:11:54
3	Prestamista	Presta	2024-04-16 22:11:54	2024-04-16 22:11:54	2024-04-16 22:11:54
4	Cobrador	Cobra	2024-04-16 22:11:54	2024-04-16 22:11:54	2024-04-16 22:11:54
5	Cliente	Client	2024-04-16 22:11:54	2024-04-16 22:11:54	2024-04-16 22:11:54
\.


--
-- Data for Name: telescope_entries; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.telescope_entries (sequence, uuid, batch_id, family_hash, should_display_on_index, type, content, created_at) FROM stdin;
1	9d4cf071-b7a7-4582-9dfa-35011f53c8bd	9d4cf071-c08c-484a-bbc9-597995aa5922	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":254,"memory":18,"hostname":"EderCortes"}	2024-10-21 14:09:30
420	9d4f2820-6933-4bb7-b060-103ab4ce56e9	9d4f2820-9d1a-4dcc-a579-0d0b8b26bd47	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 16:36:51
3	9d4cf072-69d9-43c5-8f76-40fc66cd0ee6	9d4cf072-a6ba-4789-9d86-6dd367c14bf6	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-21 14:09:31
4	9d4cf072-a407-459c-89c9-0da5e649a039	9d4cf072-a6ba-4789-9d86-6dd367c14bf6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-21 14:09:31
5	9d4cf072-a54d-4c40-bce5-526c558653a8	9d4cf072-a6ba-4789-9d86-6dd367c14bf6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"387","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"name":"123456789","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":null,"user_city":"Cali","user_neighborhood":"Las orquideas","user_address":"Calle 107a No 28a 66","user_cellphone":"3152596295","user_photo":null,"user_state":null,"profile_code":1,"user_age":"29","password":null},"session":[],"response_status":500,"response":{"message":"SQLSTATE[23502]: Not null violation: 7 ERROR:  el valor nulo en la columna \\u00abpassword\\u00bb de la relaci\\u00f3n \\u00abusers\\u00bb viola la restricci\\u00f3n de no nulo\\nDETAIL:  La fila que falla contiene (1, 123456789, edercortez10@gmail.com, null, null, Cortes, Cabezas, CC, 1004608333, null, Cali, Las orquideas, Calle 107a No 28a 66, 3152596295, null, null, 29, 1, null, 0, null, 2024-10-21 14:09:31, 2024-10-21 14:09:31, null). (Connection: pgsql, SQL: insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"user_photo\\", \\"user_state\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"updated_at\\", \\"created_at\\") values (123456789, edercortez10@gmail.com, Cortes, Cabezas, CC, 1004608333, ?, Cali, Las orquideas, Calle 107a No 28a 66, 3152596295, ?, ?, 1, 29, ?, 2024-10-21 14:09:31, 2024-10-21 14:09:31) returning \\"id\\")","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":401,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor.php","line":24,"function":"selectFromWriteConnection","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3549,"function":"processInsertGetId","class":"Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":1982,"function":"insertGetId","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1334,"function":"__call","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1299,"function":"insertAndSetId","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1138,"function":"performInsert","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":35,"function":"save","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"store","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":402,"memory":22,"hostname":"EderCortes"}	2024-10-21 14:09:31
6	9d4cf147-f04e-4eb6-b69e-30451e56db4a	9d4cf147-f50e-41fb-9ee4-d0c063e67f05	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":232,"memory":18,"hostname":"EderCortes"}	2024-10-21 14:11:50
8	9d4cf148-4818-49d6-b87c-cae1c32f003d	9d4cf148-9716-41e2-9cef-8299123175d2	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-21 14:11:51
9	9d4cf148-94ff-4da1-9a90-bb3c1e1794e5	9d4cf148-9716-41e2-9cef-8299123175d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-21 14:11:51
10	9d4cf148-95e2-4f68-8c12-ed71d14dc461	9d4cf148-9716-41e2-9cef-8299123175d2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"411","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"name":"1994-12-30T05:00:00.000Z","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":null,"user_city":"Cali","user_neighborhood":"Las orquideas","user_address":"Calle 107a No 28a- 66","user_cellphone":"3152596295","user_photo":null,"user_state":null,"profile_code":1,"user_age":"29","password":"********"},"session":[],"response_status":500,"response":{"message":"SQLSTATE[23502]: Not null violation: 7 ERROR:  el valor nulo en la columna \\u00abuser_birth\\u00bb de la relaci\\u00f3n \\u00abusers\\u00bb viola la restricci\\u00f3n de no nulo\\nDETAIL:  La fila que falla contiene (2, 1994-12-30T05:00:00.000Z, edercortez10@gmail.com, null, 12345678, Cortes, Cabezas, CC, 1004608333, null, Cali, Las orquideas, Calle 107a No 28a- 66, 3152596295, null, null, 29, 1, null, 0, null, 2024-10-21 14:11:51, 2024-10-21 14:11:51, null). (Connection: pgsql, SQL: insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"user_photo\\", \\"user_state\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"updated_at\\", \\"created_at\\") values (1994-12-30T05:00:00.000Z, edercortez10@gmail.com, Cortes, Cabezas, CC, 1004608333, ?, Cali, Las orquideas, Calle 107a No 28a- 66, 3152596295, ?, ?, 1, 29, 12345678, 2024-10-21 14:11:51, 2024-10-21 14:11:51) returning \\"id\\")","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":401,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor.php","line":24,"function":"selectFromWriteConnection","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3549,"function":"processInsertGetId","class":"Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":1982,"function":"insertGetId","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1334,"function":"__call","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1299,"function":"insertAndSetId","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1138,"function":"performInsert","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":35,"function":"save","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"store","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":359,"memory":22,"hostname":"EderCortes"}	2024-10-21 14:11:51
11	9d4cf2a2-5ff4-4825-9047-2afadbe0596a	9d4cf2a2-6459-4933-ab1f-9f07203b1f30	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":203,"memory":20,"hostname":"EderCortes"}	2024-10-21 14:15:38
121	9d4e5c64-4787-425e-b3a0-5a739e85e89d	9d4e5c64-71a7-4ca5-be61-70a43aee655e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"59.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-22 07:07:10
13	9d4cf2a2-c033-4069-9238-bc8cecea9f6d	9d4cf2a2-e752-467f-8b8d-8626bb1b03ce	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-21 14:15:38
14	9d4cf2a2-e4df-4674-8f2d-dc610df8bbc1	9d4cf2a2-e752-467f-8b8d-8626bb1b03ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-21 14:15:38
15	9d4cf2a2-e5ec-4860-a79d-c9a17dde1e70	9d4cf2a2-e752-467f-8b8d-8626bb1b03ce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"307","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"name":"2024-10-09T05:00:00.000Z","email":null,"user_last_name_one":null,"user_last_name_two":null,"user_document_type":null,"user_document":null,"user_birth":null,"user_city":null,"user_neighborhood":null,"user_address":null,"user_cellphone":null,"user_photo":null,"user_state":null,"profile_code":null,"user_age":null,"password":null},"session":[],"response_status":500,"response":{"message":"SQLSTATE[23502]: Not null violation: 7 ERROR:  el valor nulo en la columna \\u00abemail\\u00bb de la relaci\\u00f3n \\u00abusers\\u00bb viola la restricci\\u00f3n de no nulo\\nDETAIL:  La fila que falla contiene (3, 2024-10-09T05:00:00.000Z, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, 0, null, 2024-10-21 14:15:38, 2024-10-21 14:15:38, null). (Connection: pgsql, SQL: insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"user_photo\\", \\"user_state\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"updated_at\\", \\"created_at\\") values (2024-10-09T05:00:00.000Z, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, 2024-10-21 14:15:38, 2024-10-21 14:15:38) returning \\"id\\")","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":401,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor.php","line":24,"function":"selectFromWriteConnection","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3549,"function":"processInsertGetId","class":"Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":1982,"function":"insertGetId","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1334,"function":"__call","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1299,"function":"insertAndSetId","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1138,"function":"performInsert","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":35,"function":"save","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"store","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":276,"memory":22,"hostname":"EderCortes"}	2024-10-21 14:15:38
16	9d4cf2e4-d544-44ba-9ad4-041a80abbe59	9d4cf2e4-d9be-479e-bfe6-e794117aeef8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":190,"memory":20,"hostname":"EderCortes"}	2024-10-21 14:16:21
122	9d4e5c64-483b-4ad5-b1b3-fc73afd8fad2	9d4e5c64-71a7-4ca5-be61-70a43aee655e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-22 07:07:10
123	9d4e5c64-6f1d-4a2f-b761-08ccd69ecf19	9d4e5c64-71a7-4ca5-be61-70a43aee655e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 07:07:10
124	9d4e5c64-6fb1-481d-a4ec-2c93785d139b	9d4e5c64-71a7-4ca5-be61-70a43aee655e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com"},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":631,"memory":24,"hostname":"EderCortes"}	2024-10-22 07:07:10
59	9d4d2647-cd89-414c-bfbc-9935261b437e	9d4d2648-0071-443b-8053-d5a3212e288e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"59.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-21 16:40:02
60	9d4d2647-cdf7-418b-8675-8214af0da350	9d4d2648-0071-443b-8053-d5a3212e288e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-21 16:40:02
61	9d4d2647-fe81-428e-8539-e6dfed9899c9	9d4d2648-0071-443b-8053-d5a3212e288e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-21 16:40:02
538	9d4f2b0c-6d57-4ba9-a900-c03836aa787f	9d4f2b0c-714d-4012-87a9-4107ca0c9126	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":180,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:45:02
421	9d4f2820-930f-4842-8d01-3ce8d9721364	9d4f2820-9d1a-4dcc-a579-0d0b8b26bd47	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = 2 and \\"menu\\".\\"deleted_at\\" is null","time":"56.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:36:52
18	9d4cf2e5-8f25-4b54-b4a4-72005ce78289	9d4cf2e5-acc4-417c-86f1-598c28a6ccaf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-21 14:16:22
19	9d4cf2e5-aaf6-40d6-915b-75c53982d083	9d4cf2e5-acc4-417c-86f1-598c28a6ccaf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-21 14:16:22
20	9d4cf2e5-abbb-4f9f-827a-d74a6a1c5540	9d4cf2e5-acc4-417c-86f1-598c28a6ccaf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"307","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"name":"2024-10-16T05:00:00.000Z","email":null,"user_last_name_one":null,"user_last_name_two":null,"user_document_type":null,"user_document":null,"user_birth":null,"user_city":null,"user_neighborhood":null,"user_address":null,"user_cellphone":null,"user_photo":null,"user_state":null,"profile_code":null,"user_age":null,"password":null},"session":[],"response_status":500,"response":{"message":"SQLSTATE[23502]: Not null violation: 7 ERROR:  el valor nulo en la columna \\u00abemail\\u00bb de la relaci\\u00f3n \\u00abusers\\u00bb viola la restricci\\u00f3n de no nulo\\nDETAIL:  La fila que falla contiene (4, 2024-10-16T05:00:00.000Z, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, 0, null, 2024-10-21 14:16:22, 2024-10-21 14:16:22, null). (Connection: pgsql, SQL: insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"user_photo\\", \\"user_state\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"updated_at\\", \\"created_at\\") values (2024-10-16T05:00:00.000Z, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, 2024-10-21 14:16:22, 2024-10-21 14:16:22) returning \\"id\\")","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":401,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor.php","line":24,"function":"selectFromWriteConnection","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3549,"function":"processInsertGetId","class":"Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":1982,"function":"insertGetId","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1334,"function":"__call","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1299,"function":"insertAndSetId","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1138,"function":"performInsert","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":35,"function":"save","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"store","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-10-21 14:16:22
21	9d4cf31c-cab3-4354-8b72-7c0b6ee39596	9d4cf31c-cdec-47b6-a7be-b6348847ba22	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":160,"memory":20,"hostname":"EderCortes"}	2024-10-21 14:16:58
1228	9d50c604-538c-492d-a1de-2da1461ef42d	9d50c604-9986-48a9-acef-12d32f0a8f55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 11:54:11
422	9d4f2820-93b8-4804-be2c-f3ff050653f6	9d4f2820-9d1a-4dcc-a579-0d0b8b26bd47	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":3,"hostname":"EderCortes"}	2024-10-22 16:36:52
75	9d4d2792-f93d-4183-903d-d6d0e9e02ca5	9d4d2792-fa6c-497a-802b-43120dcf7aa9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-21 16:43:39
76	9d4d2792-f984-4951-81fe-43d15e7b882a	9d4d2792-fa6c-497a-802b-43120dcf7aa9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":11,"name":"Eder Arley","email":"edercortez10@gmail.com"},"token":"1|Tq2EXj6ecrKqYxvbQ5mAxS1ELX1lhgwHRqqE8SLN85665dce"}},"duration":459,"memory":24,"hostname":"EderCortes"}	2024-10-21 16:43:39
127	9d4e69e4-3b56-41bd-9984-bcf6845e8843	9d4e69e5-8e8f-495d-be17-7d391d8f0756	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"95.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-22 07:44:55
128	9d4e69e4-3bf7-4708-840f-939fb78e660b	9d4e69e5-8e8f-495d-be17-7d391d8f0756	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-22 07:44:55
129	9d4e69e5-8c74-4680-99e5-98fe382c4a2c	9d4e69e5-8e8f-495d-be17-7d391d8f0756	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 07:44:56
423	9d4f2820-9b48-4870-b433-ce1c6c67d1fd	9d4f2820-9d1a-4dcc-a579-0d0b8b26bd47	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:36:52
424	9d4f2820-9bc7-482c-b7ce-29005ccb2ff6	9d4f2820-9d1a-4dcc-a579-0d0b8b26bd47	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"}]},"duration":377,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:36:52
1229	9d50c604-9453-4540-b6f0-bc981f0bce9d	9d50c604-9986-48a9-acef-12d32f0a8f55	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"143.98","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-23 11:54:11
1230	9d50c604-94a0-496c-8a06-e98b6faf8815	9d50c604-9986-48a9-acef-12d32f0a8f55	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":3,"hostname":"EderCortes"}	2024-10-23 11:54:11
1231	9d50c604-984e-47ad-8f9e-91264ec7e11c	9d50c604-9986-48a9-acef-12d32f0a8f55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 11:54:11
1375	9d50cd71-d4b1-4beb-9b44-c84ab6b99e8a	9d50cd71-e6f6-4aa1-a86f-cec893951bf1	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 12:14:57
1376	9d50cd71-e384-4e63-827c-ae7e30d08e26	9d50cd71-e6f6-4aa1-a86f-cec893951bf1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:14:57
1590	9d50d7b9-5f82-4818-9726-92dce592ab18	9d50d7b9-79c3-404d-aa9a-eaa23243ef25	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 12:43:41
2729	9d50fb66-9b4f-4e7c-b6e3-483c85fbf09b	9d50fb66-babb-4640-ae42-97060b2e4fe8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:23:27
3094	9d5101c6-8736-416c-88b0-20f563c703d2	9d5101c6-af0a-44b0-8d79-19c597fbb060	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 14:41:17
539	9d4f2b0c-d94f-49ad-bae9-67c180e56e8b	9d4f2b0d-230c-4e73-9257-375ab7ff691a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 16:45:02
425	9d4f2822-5276-4ae4-adaf-0cb6a36405e5	9d4f2822-79e3-4fc1-91d9-2d27992e7e73	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:36:53
23	9d4cf31d-809e-4e87-9df0-0843a8cde6fc	9d4cf31d-a405-42b9-9a20-95198d6d0186	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-21 14:16:58
24	9d4cf31d-a1e8-4032-b7b4-4ed2c7365572	9d4cf31d-a405-42b9-9a20-95198d6d0186	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-21 14:16:58
25	9d4cf31d-a2be-4d12-bd9f-ee0dad1f5087	9d4cf31d-a405-42b9-9a20-95198d6d0186	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"307","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"name":null,"email":null,"user_last_name_one":null,"user_last_name_two":null,"user_document_type":null,"user_document":null,"user_birth":"2024-10-18T05:00:00.000Z","user_city":null,"user_neighborhood":null,"user_address":null,"user_cellphone":null,"user_photo":null,"user_state":null,"profile_code":null,"user_age":null,"password":null},"session":[],"response_status":500,"response":{"message":"SQLSTATE[23502]: Not null violation: 7 ERROR:  el valor nulo en la columna \\u00abname\\u00bb de la relaci\\u00f3n \\u00abusers\\u00bb viola la restricci\\u00f3n de no nulo\\nDETAIL:  La fila que falla contiene (5, null, null, null, null, null, null, null, null, 2024-10-18T05:00:00.000Z, null, null, null, null, null, null, null, null, null, 0, null, 2024-10-21 14:16:58, 2024-10-21 14:16:58, null). (Connection: pgsql, SQL: insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"user_photo\\", \\"user_state\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"updated_at\\", \\"created_at\\") values (?, ?, ?, ?, ?, ?, 2024-10-18T05:00:00.000Z, ?, ?, ?, ?, ?, ?, ?, ?, ?, 2024-10-21 14:16:58, 2024-10-21 14:16:58) returning \\"id\\")","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":401,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor.php","line":24,"function":"selectFromWriteConnection","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3549,"function":"processInsertGetId","class":"Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":1982,"function":"insertGetId","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1334,"function":"__call","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1299,"function":"insertAndSetId","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1138,"function":"performInsert","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":35,"function":"save","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"store","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-10-21 14:16:58
26	9d4cf3a3-3605-4d90-9a5b-374f4694292a	9d4cf3a3-3a2d-4ad2-82c0-8ba35dcbf956	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":235,"memory":20,"hostname":"EderCortes"}	2024-10-21 14:18:26
426	9d4f2822-73bc-4ce6-aeb7-7b9323bab4a8	9d4f2822-79e3-4fc1-91d9-2d27992e7e73	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = 2 and \\"menu\\".\\"deleted_at\\" is null","time":"59.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:36:53
540	9d4f2b0d-12af-4cb7-b56e-6b1e3a8002cc	9d4f2b0d-230c-4e73-9257-375ab7ff691a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"verification_token\\", \\"updated_at\\", \\"created_at\\") values ('Luis andre', 'andre@gmail.com', 'Herrera', 'MArtinez', 'CC', '100465545', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '312596295', 4, '31', 'y$tFrw\\/q32bSzYW7YJXZ.ICOOhWYgMmCKEPl1mmu3DUr3bTadJmXiQK', 'kbyqw5OGzIHMi7nHZyqP7pygesxu9KJd2SThhDLgzCTEcPVrwXlnfFrCD0Ht', '2024-10-22 16:45:02', '2024-10-22 16:45:02') returning \\"id\\"","time":"46.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":39,"hash":"df77298d3271ba3a87b0b9c71897cb01","hostname":"EderCortes"}	2024-10-22 16:45:02
427	9d4f2822-7416-41b9-8612-e6d311b0be7b	9d4f2822-79e3-4fc1-91d9-2d27992e7e73	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":3,"hostname":"EderCortes"}	2024-10-22 16:36:53
319	9d4f2408-ff22-43d5-9727-1a8d9992eff4	9d4f2409-0535-412d-b021-05a2447e6f8c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"menu\\".\\"deleted_at\\" is null","time":"146.60","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":44,"hash":"33b93c5fee75486f80d53c40030734c7","hostname":"EderCortes"}	2024-10-22 16:25:25
320	9d4f2408-ff72-4d2d-b577-3429921926e0	9d4f2409-0535-412d-b021-05a2447e6f8c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":15,"hostname":"EderCortes"}	2024-10-22 16:25:25
428	9d4f2822-785d-4639-b6e7-9ce37d3a3370	9d4f2822-79e3-4fc1-91d9-2d27992e7e73	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:36:53
429	9d4f2822-78b6-44fe-ba83-aafc75e685cf	9d4f2822-79e3-4fc1-91d9-2d27992e7e73	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"}]},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:36:53
541	9d4f2b0d-1a7c-432b-abe3-1787d49c3eb7	9d4f2b0d-230c-4e73-9257-375ab7ff691a	\N	t	model	{"action":"created","model":"App\\\\Models\\\\User:14","hostname":"EderCortes"}	2024-10-22 16:45:02
542	9d4f2b0d-20c8-4c15-8e2c-20c05fbe7b4b	9d4f2b0d-230c-4e73-9257-375ab7ff691a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:45:02
543	9d4f2b0d-215e-4d9c-a345-622abe6a2d04	9d4f2b0d-230c-4e73-9257-375ab7ff691a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"405","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"name":"Luis andre","email":"andre@gmail.com","user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_photo":null,"user_state":null,"profile_code":4,"user_age":"31","password":"********","verification_token":"kbyqw5OGzIHMi7nHZyqP7pygesxu9KJd2SThhDLgzCTEcPVrwXlnfFrCD0Ht"},"session":[],"response_status":200,"response":{"user":{"name":"Luis andre","email":"andre@gmail.com","user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","profile_code":4,"user_age":"31","updated_at":"2024-10-22T21:45:02.000000Z","created_at":"2024-10-22T21:45:02.000000Z","id":14}},"duration":382,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:45:02
6311	9d52643c-4b6b-487e-a537-ed7b184be8d8	9d52643c-85c4-420f-bf92-361c9efb787a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 07:12:25
6363	9d5264f5-4650-4933-9b08-2145ff5f44df	9d5264f5-848b-42f1-b2b1-a3eb026a96e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 07:14:26
28	9d4cf3a3-9f3c-427a-a244-61c9b88760f8	9d4cf3a3-d113-4f9e-92af-fa36226e1d3e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-21 14:18:26
29	9d4cf3a3-ce10-412e-9d65-20978e691277	9d4cf3a3-d113-4f9e-92af-fa36226e1d3e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-21 14:18:26
30	9d4cf3a3-cf2d-4ff3-9810-e4d60cc43e35	9d4cf3a3-d113-4f9e-92af-fa36226e1d3e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"411","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"name":"Eder Arley","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-23T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"calle 107a","user_cellphone":"3152596295","user_photo":null,"user_state":null,"profile_code":1,"user_age":"29","password":"********"},"session":[],"response_status":500,"response":{"message":"SQLSTATE[23502]: Not null violation: 7 ERROR:  el valor nulo en la columna \\u00abuser_photo\\u00bb de la relaci\\u00f3n \\u00abusers\\u00bb viola la restricci\\u00f3n de no nulo\\nDETAIL:  La fila que falla contiene (6, Eder Arley, edercortez10@gmail.com, null, 123456789, Cortes, Cabezas, CC, 1004608333, 2024-10-23T05:00:00.000Z, Cali, Las Orquideas, calle 107a, 3152596295, null, null, 29, 1, null, 0, null, 2024-10-21 14:18:26, 2024-10-21 14:18:26, null). (Connection: pgsql, SQL: insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"user_photo\\", \\"user_state\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"updated_at\\", \\"created_at\\") values (Eder Arley, edercortez10@gmail.com, Cortes, Cabezas, CC, 1004608333, 2024-10-23T05:00:00.000Z, Cali, Las Orquideas, calle 107a, 3152596295, ?, ?, 1, 29, 123456789, 2024-10-21 14:18:26, 2024-10-21 14:18:26) returning \\"id\\")","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":401,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor.php","line":24,"function":"selectFromWriteConnection","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3549,"function":"processInsertGetId","class":"Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":1982,"function":"insertGetId","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1334,"function":"__call","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1299,"function":"insertAndSetId","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1138,"function":"performInsert","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":35,"function":"save","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"store","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":316,"memory":22,"hostname":"EderCortes"}	2024-10-21 14:18:26
31	9d4cf419-4b81-434b-a307-1df2a8412948	9d4cf419-4efe-4978-ad32-f49d174a7205	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":166,"memory":20,"hostname":"EderCortes"}	2024-10-21 14:19:43
4354	9d512a80-387a-4f41-a60e-918bb2e56d18	9d512a80-8448-4a1d-964a-9494cf6b4889	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 16:35:09
9143	9d52f445-29a6-443a-9f15-f0a3a493d715	9d52f445-5024-4961-bcc2-f27fe350d086	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:55:10
33	9d4cf419-acc4-4d32-8d23-63e66b8c25b3	9d4cf41a-00fb-49ac-b8fc-9eff7381b62d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-21 14:19:43
34	9d4cf419-fee2-4c3d-a70f-cb9e4737d5c3	9d4cf41a-00fb-49ac-b8fc-9eff7381b62d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-21 14:19:44
35	9d4cf419-ffa4-452b-8933-79f759cff2da	9d4cf41a-00fb-49ac-b8fc-9eff7381b62d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"411","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"name":"Eder Arley","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-23T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"calle 107a","user_cellphone":"3152596295","user_photo":null,"user_state":null,"profile_code":1,"user_age":"29","password":"********"},"session":[],"response_status":500,"response":{"message":"SQLSTATE[23502]: Not null violation: 7 ERROR:  el valor nulo en la columna \\u00abuser_photo\\u00bb de la relaci\\u00f3n \\u00abusers\\u00bb viola la restricci\\u00f3n de no nulo\\nDETAIL:  La fila que falla contiene (7, Eder Arley, edercortez10@gmail.com, null, 123456789, Cortes, Cabezas, CC, 1004608333, 2024-10-23T05:00:00.000Z, Cali, Las Orquideas, calle 107a, 3152596295, null, null, 29, 1, null, 0, null, 2024-10-21 14:19:44, 2024-10-21 14:19:44, null). (Connection: pgsql, SQL: insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"user_state\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"updated_at\\", \\"created_at\\") values (Eder Arley, edercortez10@gmail.com, Cortes, Cabezas, CC, 1004608333, 2024-10-23T05:00:00.000Z, Cali, Las Orquideas, calle 107a, 3152596295, ?, 1, 29, 123456789, 2024-10-21 14:19:44, 2024-10-21 14:19:44) returning \\"id\\")","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":401,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor.php","line":24,"function":"selectFromWriteConnection","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3549,"function":"processInsertGetId","class":"Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":1982,"function":"insertGetId","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1334,"function":"__call","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1299,"function":"insertAndSetId","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1138,"function":"performInsert","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":35,"function":"save","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"store","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":367,"memory":22,"hostname":"EderCortes"}	2024-10-21 14:19:44
36	9d4cf46b-cc34-4074-81de-c91fb05e62ba	9d4cf46b-cff1-448e-8183-7f02ddc8f565	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":196,"memory":20,"hostname":"EderCortes"}	2024-10-21 14:20:37
727	9d4f2e4e-f6a0-4381-9e56-b7136917d36b	9d4f2e4f-169f-4453-9182-036f307df842	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-22 16:54:09
321	9d4f2409-03c1-4649-98ec-59b10fc4a838	9d4f2409-0535-412d-b021-05a2447e6f8c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:25:25
77	9d4d2856-e7c3-4c70-8be2-9ca8953ecd80	9d4d2856-ebeb-47dd-896e-15a0d2cccc35	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":182,"memory":22,"hostname":"EderCortes"}	2024-10-21 16:45:48
85	9d4d2a3e-8b60-4d98-b418-4d3527c9d9a3	9d4d2a3e-8f6a-4e36-bc72-c492bbe308ef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":298,"memory":22,"hostname":"EderCortes"}	2024-10-21 16:51:07
119	9d4e5c63-4184-4a33-93e5-dc96dad3647f	9d4e5c63-51af-4d00-bec8-bd0b34b3b13d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":288,"memory":18,"hostname":"EderCortes"}	2024-10-22 07:07:10
125	9d4e69dc-b0b2-478c-bce5-ec457e7823fb	9d4e69de-5475-4fd3-aed7-7590fb8b79ac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":12027,"memory":18,"hostname":"EderCortes"}	2024-10-22 07:44:51
166	9d4f0ba9-f4c1-4450-898f-b6fcd6888200	9d4f0ba9-fa47-4c76-9388-5076fa98a65e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":197,"memory":20,"hostname":"EderCortes"}	2024-10-22 15:17:16
10743	9d57206e-ac37-4b0d-803e-46a41a867119	9d57206e-ca5d-4524-8dd2-015411f17582	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-26 15:41:58
41958	9d6cd174-b39b-4085-85a9-82aee88d8a6b	9d6cd174-ec0d-423d-92ab-60a18fc72d21	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:29:21
38	9d4cf46c-826d-421b-9991-66f3d7c1dc87	9d4cf46c-cc59-4e1c-90f0-3ab382f9e26f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-21 14:20:38
39	9d4cf46c-ca99-4e4a-b8d9-559ff7138723	9d4cf46c-cc59-4e1c-90f0-3ab382f9e26f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-21 14:20:38
40	9d4cf46c-cb2e-4797-9cfb-c10f71fc81f9	9d4cf46c-cc59-4e1c-90f0-3ab382f9e26f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"411","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"name":"Eder Arley","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-23T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"calle 107a","user_cellphone":"3152596295","user_photo":null,"user_state":null,"profile_code":1,"user_age":"29","password":"********"},"session":[],"response_status":500,"response":{"message":"SQLSTATE[23502]: Not null violation: 7 ERROR:  el valor nulo en la columna \\u00abuser_state\\u00bb de la relaci\\u00f3n \\u00abusers\\u00bb viola la restricci\\u00f3n de no nulo\\nDETAIL:  La fila que falla contiene (8, Eder Arley, edercortez10@gmail.com, null, 123456789, Cortes, Cabezas, CC, 1004608333, 2024-10-23T05:00:00.000Z, Cali, Las Orquideas, calle 107a, 3152596295, null, 29, 1, null, 0, null, 2024-10-21 14:20:38, 2024-10-21 14:20:38, null). (Connection: pgsql, SQL: insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"user_state\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"updated_at\\", \\"created_at\\") values (Eder Arley, edercortez10@gmail.com, Cortes, Cabezas, CC, 1004608333, 2024-10-23T05:00:00.000Z, Cali, Las Orquideas, calle 107a, 3152596295, ?, 1, 29, 123456789, 2024-10-21 14:20:38, 2024-10-21 14:20:38) returning \\"id\\")","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":401,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor.php","line":24,"function":"selectFromWriteConnection","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3549,"function":"processInsertGetId","class":"Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":1982,"function":"insertGetId","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1334,"function":"__call","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1299,"function":"insertAndSetId","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1138,"function":"performInsert","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":35,"function":"save","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"store","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":338,"memory":22,"hostname":"EderCortes"}	2024-10-21 14:20:38
41	9d4cf498-f873-4fc4-a850-8d2bd87b2cdb	9d4cf498-fbfa-446d-8201-c669dd9ef91d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":168,"memory":20,"hostname":"EderCortes"}	2024-10-21 14:21:07
78	9d4d2857-3a01-48e7-b186-14b2aa106122	9d4d2857-7aba-4a16-b5b6-b0f6f27e6f3d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-21 16:45:48
43	9d4cf499-ac2c-47f3-a5b3-8b28c7fba1b0	9d4cf499-d1d9-48f1-b24c-c874f6d73344	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-21 14:21:07
44	9d4cf499-cfc4-4d70-84eb-ba257f6cffee	9d4cf499-d1d9-48f1-b24c-c874f6d73344	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-21 14:21:07
45	9d4cf499-d099-4758-b917-29c52ff434e8	9d4cf499-d1d9-48f1-b24c-c874f6d73344	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"411","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"name":"Eder Arley","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-23T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"calle 107a","user_cellphone":"3152596295","user_photo":null,"user_state":null,"profile_code":1,"user_age":"29","password":"********"},"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abuser_state\\u00bb en la relaci\\u00f3n \\u00abusers\\u00bb\\nLINE 1: ..._neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"user_stat...\\n                                                             ^ (Connection: pgsql, SQL: insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"user_state\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"updated_at\\", \\"created_at\\") values (Eder Arley, edercortez10@gmail.com, Cortes, Cabezas, CC, 1004608333, 2024-10-23T05:00:00.000Z, Cali, Las Orquideas, calle 107a, 3152596295, ?, 1, 29, 123456789, 2024-10-21 14:21:07, 2024-10-21 14:21:07) returning \\"id\\")","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":401,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor.php","line":24,"function":"selectFromWriteConnection","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3549,"function":"processInsertGetId","class":"Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":1982,"function":"insertGetId","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1334,"function":"__call","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1299,"function":"insertAndSetId","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1138,"function":"performInsert","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":35,"function":"save","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"store","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-10-21 14:21:07
46	9d4cf4b8-6e7c-43cd-9d2d-1b3caf5ed457	9d4cf4b8-71a4-4ac9-bc80-a802a5effb58	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":172,"memory":20,"hostname":"EderCortes"}	2024-10-21 14:21:28
79	9d4d2857-5ce9-4e1d-8207-28b72ca61954	9d4d2857-7aba-4a16-b5b6-b0f6f27e6f3d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"41.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-21 16:45:48
80	9d4d2857-5d4f-487e-9260-b5d8a3c086dd	9d4d2857-7aba-4a16-b5b6-b0f6f27e6f3d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-21 16:45:48
81	9d4d2857-76f9-4ba4-bbc3-982d7abd8c9e	9d4d2857-7aba-4a16-b5b6-b0f6f27e6f3d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"personal_access_tokens\\" (\\"name\\", \\"token\\", \\"abilities\\", \\"expires_at\\", \\"tokenable_id\\", \\"tokenable_type\\", \\"updated_at\\", \\"created_at\\") values ('xxxxxxxxxxxx', '9fb66c4550b3c236db72dc82c89ae5e7d87a117ec8f5b794654fadd71ef88055', '[\\"*\\"]', null, 11, 'App\\\\Models\\\\User', '2024-10-21 16:45:48', '2024-10-21 16:45:48') returning \\"id\\"","time":"2.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":34,"hash":"437ad4d90957283a377277c82a195366","hostname":"EderCortes"}	2024-10-21 16:45:48
82	9d4d2857-7755-4b2c-ba97-2f6a5cb815ae	9d4d2857-7aba-4a16-b5b6-b0f6f27e6f3d	\N	t	model	{"action":"created","model":"Laravel\\\\Sanctum\\\\PersonalAccessToken:2","hostname":"EderCortes"}	2024-10-21 16:45:48
83	9d4d2857-792a-4027-b66e-b6a748c34a83	9d4d2857-7aba-4a16-b5b6-b0f6f27e6f3d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-21 16:45:48
84	9d4d2857-797f-4dd4-a113-6d5ed3823e66	9d4d2857-7aba-4a16-b5b6-b0f6f27e6f3d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":11,"name":"Eder Arley","email":"edercortez10@gmail.com"},"token":"2|WZinC7EVFPt52ijDsE6H3glKqPXlsqxth3sTLbIr39ceef2d"}},"duration":311,"memory":24,"hostname":"EderCortes"}	2024-10-21 16:45:48
86	9d4d2a3e-e0c1-42cf-b883-fc0df8b809d8	9d4d2a3f-4ba9-4e32-9b6d-b7e1378e80e3	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-21 16:51:08
87	9d4d2a3f-2b8c-4b19-b28f-edc280917c8f	9d4d2a3f-4ba9-4e32-9b6d-b7e1378e80e3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"144.09","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-21 16:51:08
88	9d4d2a3f-2c00-45de-8b79-f779c247ae45	9d4d2a3f-4ba9-4e32-9b6d-b7e1378e80e3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-21 16:51:08
89	9d4d2a3f-474a-41b5-af50-da63b29f701f	9d4d2a3f-4ba9-4e32-9b6d-b7e1378e80e3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"personal_access_tokens\\" (\\"name\\", \\"token\\", \\"abilities\\", \\"expires_at\\", \\"tokenable_id\\", \\"tokenable_type\\", \\"updated_at\\", \\"created_at\\") values ('xxxxxxxxxxxx', '2f7a025e419c693ee95c94bd3d0fc42e293fcaf2e52c11888cc84db8f2213805', '[\\"*\\"]', null, 11, 'App\\\\Models\\\\User', '2024-10-21 16:51:08', '2024-10-21 16:51:08') returning \\"id\\"","time":"2.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":34,"hash":"437ad4d90957283a377277c82a195366","hostname":"EderCortes"}	2024-10-21 16:51:08
90	9d4d2a3f-47ae-4068-8c11-de9f7f15efd9	9d4d2a3f-4ba9-4e32-9b6d-b7e1378e80e3	\N	t	model	{"action":"created","model":"Laravel\\\\Sanctum\\\\PersonalAccessToken:3","hostname":"EderCortes"}	2024-10-21 16:51:08
91	9d4d2a3f-49c2-40d1-9547-a82e693eac2a	9d4d2a3f-4ba9-4e32-9b6d-b7e1378e80e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-21 16:51:08
544	9d4f2b38-4245-4670-9baa-1789a1242411	9d4f2b38-462b-4759-929c-ea4acc5b324d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":195,"memory":20,"hostname":"EderCortes"}	2024-10-22 16:45:30
4355	9d512a80-7f71-48de-b9fe-878edba7f57f	9d512a80-8448-4a1d-964a-9494cf6b4889	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null","time":"153.96","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":28,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-23 16:35:09
48	9d4cf4b8-ee39-46b2-93af-8d1eea068151	9d4cf4b9-1169-4265-903b-1b27b910ce8c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-21 14:21:28
49	9d4cf4b9-0f87-4218-bd86-7e24200d01f1	9d4cf4b9-1169-4265-903b-1b27b910ce8c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-21 14:21:28
50	9d4cf4b9-1045-48eb-a6ab-193c4c4841fe	9d4cf4b9-1169-4265-903b-1b27b910ce8c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"411","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"name":"Eder Arley","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-23T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"calle 107a","user_cellphone":"3152596295","user_photo":null,"user_state":null,"profile_code":1,"user_age":"29","password":"********"},"session":[],"response_status":500,"response":{"message":"SQLSTATE[23503]: Foreign key violation: 7 ERROR:  inserci\\u00f3n o actualizaci\\u00f3n en la tabla \\u00abusers\\u00bb viola la llave for\\u00e1nea \\u00abusers_profile_code_foreign\\u00bb\\nDETAIL:  La llave (profile_code)=(1) no est\\u00e1 presente en la tabla \\u00abprofile\\u00bb. (Connection: pgsql, SQL: insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"updated_at\\", \\"created_at\\") values (Eder Arley, edercortez10@gmail.com, Cortes, Cabezas, CC, 1004608333, 2024-10-23T05:00:00.000Z, Cali, Las Orquideas, calle 107a, 3152596295, 1, 29, 123456789, 2024-10-21 14:21:28, 2024-10-21 14:21:28) returning \\"id\\")","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":401,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor.php","line":24,"function":"selectFromWriteConnection","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3549,"function":"processInsertGetId","class":"Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":1982,"function":"insertGetId","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1334,"function":"__call","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1299,"function":"insertAndSetId","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1138,"function":"performInsert","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":35,"function":"save","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"store","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-10-21 14:21:28
51	9d4cf5a5-9baf-47c3-93c3-4ce8ceed347f	9d4cf5a5-a016-4442-8816-798675db3bd3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":174,"memory":20,"hostname":"EderCortes"}	2024-10-21 14:24:03
52	9d4cf5a5-f117-43a8-a716-ce07de340540	9d4cf5a6-c110-4ba9-8673-39263ab5b906	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-21 14:24:03
53	9d4cf5a6-3b1b-4aca-827e-e60dda842657	9d4cf5a6-c110-4ba9-8673-39263ab5b906	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"updated_at\\", \\"created_at\\") values ('Eder Arley', 'edercortez10@gmail.com', 'Cortes', 'Cabezas', 'CC', '1004608333', '2024-10-23T05:00:00.000Z', 'Cali', 'Las Orquideas', 'calle 107a', '3152596295', 1, '29', '123456789', '2024-10-21 14:24:03', '2024-10-21 14:24:03') returning \\"id\\"","time":"152.19","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":35,"hash":"712c37832785788c2aab098e49ed5a48","hostname":"EderCortes"}	2024-10-21 14:24:03
54	9d4cf5a6-4248-44df-ba9f-fe394141f523	9d4cf5a6-c110-4ba9-8673-39263ab5b906	\N	t	model	{"action":"created","model":"App\\\\Models\\\\User:10","hostname":"EderCortes"}	2024-10-21 14:24:03
55	9d4cf5a6-bf67-4c60-92d2-a38fd7da4d6a	9d4cf5a6-c110-4ba9-8673-39263ab5b906	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-21 14:24:04
56	9d4cf5a6-bfc2-436e-b422-0a31b25289c4	9d4cf5a6-c110-4ba9-8673-39263ab5b906	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"411","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"name":"Eder Arley","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-23T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"calle 107a","user_cellphone":"3152596295","user_photo":null,"user_state":null,"profile_code":1,"user_age":"29","password":"********"},"session":[],"response_status":200,"response":{"user":{"name":"Eder Arley","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-23T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"calle 107a","user_cellphone":"3152596295","profile_code":1,"user_age":"29","updated_at":"2024-10-21T19:24:03.000000Z","created_at":"2024-10-21T19:24:03.000000Z","id":10}},"duration":678,"memory":22,"hostname":"EderCortes"}	2024-10-21 14:24:04
57	9d4d2645-e186-4489-b4e5-798963f91e8a	9d4d2645-e9c1-4abd-a0ab-5327bff1df4b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":348,"memory":20,"hostname":"EderCortes"}	2024-10-21 16:40:01
58	9d4d2646-7151-457e-8d23-b5cd7124ed90	9d4d2648-0071-443b-8053-d5a3212e288e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-21 16:40:01
43424	9d6ce848-1e63-429b-88dd-276678602882	9d6ce848-6d1b-491e-9db8-d37b55532bb6	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 11:33:10
728	9d4f2e4f-112c-4f44-88c1-94497b4783e6	9d4f2e4f-169f-4453-9182-036f307df842	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"42.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-22 16:54:09
729	9d4f2e4f-1194-40da-9bd2-f2533e11a2f3	9d4f2e4f-169f-4453-9182-036f307df842	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":3,"hostname":"EderCortes"}	2024-10-22 16:54:09
730	9d4f2e4f-154d-4e3c-a00a-9d2ed7306281	9d4f2e4f-169f-4453-9182-036f307df842	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-22 16:54:09
62	9d4d2647-ff10-4f55-80a7-97321a2b1202	9d4d2648-0071-443b-8053-d5a3212e288e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":1180,"memory":24,"hostname":"EderCortes"}	2024-10-21 16:40:02
63	9d4d276e-1b16-4703-a935-cc9c20e504bf	9d4d276e-1f98-439c-b738-18d50ae4830f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":375,"memory":22,"hostname":"EderCortes"}	2024-10-21 16:43:15
64	9d4d276e-84bb-49fa-ba9e-b2d7eb801dc5	9d4d276e-c8c3-4c21-87a0-3a9c503a152d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-21 16:43:15
65	9d4d276e-c128-498d-ba48-e1b6d2321ac6	9d4d276e-c8c3-4c21-87a0-3a9c503a152d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"updated_at\\", \\"created_at\\") values ('Eder Arley', 'edercortez10@gmail.com', 'Cortes', 'Cabezas', 'CC', '1004608333', '2024-10-09T05:00:00.000Z', 'Cali', 'LAs orquideas', 'Calle 107a No 28a - 66', '3152596295', 1, '29', 'y$n9Rrgv6cQuwI37IYxiud0OTP3tDaomrr5CmDnIc4ZIyVa.kfpqX8W', '2024-10-21 16:43:16', '2024-10-21 16:43:16') returning \\"id\\"","time":"52.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":39,"hash":"712c37832785788c2aab098e49ed5a48","hostname":"EderCortes"}	2024-10-21 16:43:16
66	9d4d276e-c209-4e0b-8674-fb7742b80ce4	9d4d276e-c8c3-4c21-87a0-3a9c503a152d	\N	t	model	{"action":"created","model":"App\\\\Models\\\\User:11","hostname":"EderCortes"}	2024-10-21 16:43:16
67	9d4d276e-c6f7-4662-ad19-e6ec4db4ebd0	9d4d276e-c8c3-4c21-87a0-3a9c503a152d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-21 16:43:16
68	9d4d276e-c75e-4c6b-a1c4-c0acdcb3ca45	9d4d276e-c8c3-4c21-87a0-3a9c503a152d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"424","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"name":"Eder Arley","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-09T05:00:00.000Z","user_city":"Cali","user_neighborhood":"LAs orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_photo":null,"user_state":null,"profile_code":1,"user_age":"29","password":"********"},"session":[],"response_status":200,"response":{"user":{"name":"Eder Arley","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-09T05:00:00.000Z","user_city":"Cali","user_neighborhood":"LAs orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","profile_code":1,"user_age":"29","updated_at":"2024-10-21T21:43:16.000000Z","created_at":"2024-10-21T21:43:16.000000Z","id":11}},"duration":367,"memory":22,"hostname":"EderCortes"}	2024-10-21 16:43:16
69	9d4d2792-2c69-4777-b44c-8a286c7afdb5	9d4d2792-2fb6-405f-bdd0-e6ba03cbc117	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":309,"memory":20,"hostname":"EderCortes"}	2024-10-21 16:43:39
70	9d4d2792-820f-47bd-a755-cf87bffa0c1f	9d4d2792-fa6c-497a-802b-43120dcf7aa9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-21 16:43:39
71	9d4d2792-a013-4e3c-b7ae-e4a94512bd10	9d4d2792-fa6c-497a-802b-43120dcf7aa9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"40.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-21 16:43:39
72	9d4d2792-a07b-4f72-a2e6-0cd8a7266512	9d4d2792-fa6c-497a-802b-43120dcf7aa9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-21 16:43:39
73	9d4d2792-efe5-4fda-a047-211c6342c623	9d4d2792-fa6c-497a-802b-43120dcf7aa9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"personal_access_tokens\\" (\\"name\\", \\"token\\", \\"abilities\\", \\"expires_at\\", \\"tokenable_id\\", \\"tokenable_type\\", \\"updated_at\\", \\"created_at\\") values ('xxxxxxxxxxxx', '9c7f2ff925aba175db4773ad323fba7e5a946d1e970723e6f9f1698215276c7f', '[\\"*\\"]', null, 11, 'App\\\\Models\\\\User', '2024-10-21 16:43:39', '2024-10-21 16:43:39') returning \\"id\\"","time":"4.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":34,"hash":"437ad4d90957283a377277c82a195366","hostname":"EderCortes"}	2024-10-21 16:43:39
74	9d4d2792-f032-409e-9896-afa073b8e5f8	9d4d2792-fa6c-497a-802b-43120dcf7aa9	\N	t	model	{"action":"created","model":"Laravel\\\\Sanctum\\\\PersonalAccessToken:1","hostname":"EderCortes"}	2024-10-21 16:43:39
92	9d4d2a3f-4a37-4ecd-814b-e74bf5034943	9d4d2a3f-4ba9-4e32-9b6d-b7e1378e80e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":11,"name":"Eder Arley","email":"edercortez10@gmail.com"},"token":"3|raIfRjI8hBT0wQ45Z3sXJGbDSJzvaru8DcqkovCwf3b381b1"}},"duration":424,"memory":24,"hostname":"EderCortes"}	2024-10-21 16:51:08
93	9d4d2a8d-c02b-4d60-b70d-fd9ef66a40a1	9d4d2a8d-c38d-4f48-aa5f-9409d09c4888	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":298,"memory":22,"hostname":"EderCortes"}	2024-10-21 16:51:59
94	9d4d2a8e-3d85-4e9c-b52c-13aa04dc5d24	9d4d2a8e-75d8-4a53-816e-2615eae89f32	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-21 16:52:00
95	9d4d2a8e-59ee-4c28-aa8a-703c9100a5e0	9d4d2a8e-75d8-4a53-816e-2615eae89f32	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"39.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-21 16:52:00
96	9d4d2a8e-5a49-4d0e-ba6a-e21df52455c5	9d4d2a8e-75d8-4a53-816e-2615eae89f32	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-21 16:52:00
97	9d4d2a8e-72fc-459c-8614-ce082d0e169b	9d4d2a8e-75d8-4a53-816e-2615eae89f32	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"personal_access_tokens\\" (\\"name\\", \\"token\\", \\"abilities\\", \\"expires_at\\", \\"tokenable_id\\", \\"tokenable_type\\", \\"updated_at\\", \\"created_at\\") values ('xxxxxxxxxxxx', '61ec6c0ce6acf485aab4c6574e13df1b104a2fc970200bdfb53de805432f40b0', '[\\"*\\"]', null, 11, 'App\\\\Models\\\\User', '2024-10-21 16:52:00', '2024-10-21 16:52:00') returning \\"id\\"","time":"3.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":34,"hash":"437ad4d90957283a377277c82a195366","hostname":"EderCortes"}	2024-10-21 16:52:00
98	9d4d2a8e-735b-4554-b1af-1a82337d174c	9d4d2a8e-75d8-4a53-816e-2615eae89f32	\N	t	model	{"action":"created","model":"Laravel\\\\Sanctum\\\\PersonalAccessToken:4","hostname":"EderCortes"}	2024-10-21 16:52:00
99	9d4d2a8e-74b3-44e3-b18a-75c598f440d4	9d4d2a8e-75d8-4a53-816e-2615eae89f32	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-21 16:52:00
100	9d4d2a8e-74fb-4b8f-9b43-cac2c3d5440d	9d4d2a8e-75d8-4a53-816e-2615eae89f32	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":11,"name":"Eder Arley","email":"edercortez10@gmail.com"},"token":"4|EzdfxNNtZQzyJzOjOJJXvuA8BXejzKgGjy1DiHNi41769381"}},"duration":284,"memory":24,"hostname":"EderCortes"}	2024-10-21 16:52:00
101	9d4d313c-33d8-495c-8148-ac952cd2ddd3	9d4d313c-3ac6-481e-bde0-72847ccecc69	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":294,"memory":22,"hostname":"EderCortes"}	2024-10-21 17:10:40
102	9d4d313c-c998-4924-8f0c-c67492bfe02d	9d4d313d-35cc-415d-b6a9-03f6829ba77a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-21 17:10:41
103	9d4d313d-2d5b-4352-942d-5f593d4ed572	9d4d313d-35cc-415d-b6a9-03f6829ba77a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"verification_token\\", \\"updated_at\\", \\"created_at\\") values ('Eder Arley', 'edercortez10@gmail.com', 'Cortes', 'Cabezas', 'CC', '1004608333', '2024-10-21T05:00:00.000Z', 'Cali', 'Las Orquideas', 'Calle 107a No 28a - 66', '3152596295', 1, '29', 'y$Lq1mSnDF1ElX8iDK7SRc6eKa54hNKd3glLh9aD0vPUsT0n2Eu7UQy', 'nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m', '2024-10-21 17:10:41', '2024-10-21 17:10:41') returning \\"id\\"","time":"156.81","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":40,"hash":"df77298d3271ba3a87b0b9c71897cb01","hostname":"EderCortes"}	2024-10-21 17:10:41
104	9d4d313d-2df8-4275-9085-c943231b663e	9d4d313d-35cc-415d-b6a9-03f6829ba77a	\N	t	model	{"action":"created","model":"App\\\\Models\\\\User:12","hostname":"EderCortes"}	2024-10-21 17:10:41
105	9d4d313d-3436-4be9-b96c-2e80e5928793	9d4d313d-35cc-415d-b6a9-03f6829ba77a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-21 17:10:41
4356	9d512a80-7fc3-4f4d-a3df-a200fb865a72	9d512a80-8448-4a1d-964a-9494cf6b4889	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 16:35:09
4357	9d512a80-8315-45de-acf3-2fa3ff2412c0	9d512a80-8448-4a1d-964a-9494cf6b4889	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 16:35:09
106	9d4d313d-348f-4f1f-a5d6-77653194b2ab	9d4d313d-35cc-415d-b6a9-03f6829ba77a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"423","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"name":"Eder Arley","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_photo":null,"user_state":null,"profile_code":1,"user_age":"29","password":"********","verification_token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"},"session":[],"response_status":200,"response":{"user":{"name":"Eder Arley","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","profile_code":1,"user_age":"29","updated_at":"2024-10-21T22:10:41.000000Z","created_at":"2024-10-21T22:10:41.000000Z","id":12}},"duration":451,"memory":22,"hostname":"EderCortes"}	2024-10-21 17:10:41
107	9d4d317b-3ab6-4407-8d58-0c52deb459fd	9d4d317b-3df3-43c9-a042-3ce1d756745d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":291,"memory":20,"hostname":"EderCortes"}	2024-10-21 17:11:22
108	9d4d317b-8e26-4734-8820-ab11d3158074	9d4d317b-cb51-41b0-955f-3cd119eebda0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-21 17:11:22
109	9d4d317b-b0c2-4313-bb6e-6b9ee95b6b22	9d4d317b-cb51-41b0-955f-3cd119eebda0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"40.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-21 17:11:22
110	9d4d317b-b110-47f2-b577-fcaae1b709bf	9d4d317b-cb51-41b0-955f-3cd119eebda0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-21 17:11:22
111	9d4d317b-ca0c-4bc8-9b1d-5147221c712a	9d4d317b-cb51-41b0-955f-3cd119eebda0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-21 17:11:22
112	9d4d317b-ca50-48b5-88aa-fa3344a68279	9d4d317b-cb51-41b0-955f-3cd119eebda0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com"},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":309,"memory":24,"hostname":"EderCortes"}	2024-10-21 17:11:22
113	9d4d33d2-974f-48df-aad4-53a053cc11a8	9d4d33d2-9b65-41a3-91c3-f3202f037d86	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":185,"memory":22,"hostname":"EderCortes"}	2024-10-21 17:17:54
114	9d4d33d3-1a2b-45ff-8e87-bd30ced2b6a4	9d4d33d3-5962-44c7-8638-defab94e2430	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-21 17:17:55
115	9d4d33d3-3e66-412e-b6cf-580b29f96acd	9d4d33d3-5962-44c7-8638-defab94e2430	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"42.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-21 17:17:55
116	9d4d33d3-3ece-43bc-a59f-e7a6834ca221	9d4d33d3-5962-44c7-8638-defab94e2430	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-21 17:17:55
117	9d4d33d3-5792-482e-8b35-14a4a2b69098	9d4d33d3-5962-44c7-8638-defab94e2430	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-21 17:17:55
118	9d4d33d3-57f6-4e87-b191-4bf399ad528b	9d4d33d3-5962-44c7-8638-defab94e2430	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com"},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":325,"memory":24,"hostname":"EderCortes"}	2024-10-21 17:17:55
120	9d4e5c64-04c8-4549-998b-210fdf384e2b	9d4e5c64-71a7-4ca5-be61-70a43aee655e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 07:07:10
126	9d4e69e1-597e-4b34-81bc-e292c7b90e36	9d4e69e5-8e8f-495d-be17-7d391d8f0756	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 07:44:53
10856	9d5ca538-6aa5-4ba5-817a-63a9d886089a	9d5ca538-b859-40b9-88e4-95fac15a2bb3	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 09:32:24
130	9d4e69e5-8d01-46d0-ae42-808ac0211665	9d4e69e5-8e8f-495d-be17-7d391d8f0756	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com"},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":3966,"memory":24,"hostname":"EderCortes"}	2024-10-22 07:44:56
131	9d4e69e6-3599-4882-922b-1a0207bc5e92	9d4e69e6-3a05-42aa-a34d-1beb208afe38	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":400,"memory":20,"hostname":"EderCortes"}	2024-10-22 07:44:57
132	9d4e69e7-00ba-49ae-9687-49893fd33ea6	9d4e69e7-4cfe-40d8-9459-f9d5268d261a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 07:44:57
133	9d4e69e7-2e70-4f74-9ac2-707abd3aa349	9d4e69e7-4cfe-40d8-9459-f9d5268d261a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"61.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-22 07:44:57
134	9d4e69e7-2f09-458f-8751-cdfecfad187b	9d4e69e7-4cfe-40d8-9459-f9d5268d261a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-22 07:44:57
135	9d4e69e7-4a40-4a2f-901a-c33aa6e8564c	9d4e69e7-4cfe-40d8-9459-f9d5268d261a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 07:44:57
136	9d4e69e7-4add-4db6-aa72-6341d48999f4	9d4e69e7-4cfe-40d8-9459-f9d5268d261a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com"},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":393,"memory":24,"hostname":"EderCortes"}	2024-10-22 07:44:57
137	9d4e6cc6-605d-4339-9647-cf1dce4ce911	9d4e6cc6-66bd-4dfc-8dc2-3023a6fe0252	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":219,"memory":22,"hostname":"EderCortes"}	2024-10-22 07:52:59
10966	9d5ca6df-d31b-4bc3-bb8b-9a720bb54217	9d5ca6df-f031-4cb7-8f3d-b674b2d9245d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 09:37:02
11297	9d5cb30d-7c53-455c-910c-5eb349b87b52	9d5cb30d-9a0c-4de3-9fd8-2b85634544f3	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 10:11:05
1232	9d50c604-9892-4b42-977c-a9a518c33dda	9d50c604-9986-48a9-acef-12d32f0a8f55	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-10-23 11:54:11
1377	9d50cd71-e49a-4233-a1a7-328d5a8b9215	9d50cd71-e6f6-4aa1-a86f-cec893951bf1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":"Empty Response","duration":418,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:14:57
1233	9d50c60f-1dcf-4ef8-8682-f21c17498231	9d50c60f-3abe-4376-9172-299204351806	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 11:54:18
139	9d4e6cc6-d96d-4b40-99e7-5710a4a55834	9d4e6cc8-423b-4854-ba1a-d8f7925ed65f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 07:52:59
140	9d4e6cc8-3de7-4d7c-b43a-6c66e9df2cb8	9d4e6cc8-423b-4854-ba1a-d8f7925ed65f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 07:53:00
141	9d4e6cc8-3f16-4ecc-adfd-160b1b99fb00	9d4e6cc8-423b-4854-ba1a-d8f7925ed65f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"283","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"name":null,"email":null,"user_last_name_one":null,"user_last_name_two":null,"user_document_type":null,"user_document":null,"user_birth":null,"user_city":null,"user_neighborhood":null,"user_address":null,"user_cellphone":null,"user_photo":null,"user_state":null,"profile_code":null,"user_age":null,"password":null},"session":[],"response_status":500,"response":{"message":"SQLSTATE[23502]: Not null violation: 7 ERROR:  el valor nulo en la columna \\u00abname\\u00bb de la relaci\\u00f3n \\u00abusers\\u00bb viola la restricci\\u00f3n de no nulo\\nDETAIL:  La fila que falla contiene (13, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, 0, null, 2024-10-22 07:52:59, 2024-10-22 07:52:59, null). (Connection: pgsql, SQL: insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"updated_at\\", \\"created_at\\") values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, 2024-10-22 07:52:59, 2024-10-22 07:52:59) returning \\"id\\")","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":401,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor.php","line":24,"function":"selectFromWriteConnection","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3549,"function":"processInsertGetId","class":"Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":1982,"function":"insertGetId","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1334,"function":"__call","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1299,"function":"insertAndSetId","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1138,"function":"performInsert","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":40,"function":"save","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"store","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1144,"memory":22,"hostname":"EderCortes"}	2024-10-22 07:53:00
142	9d4e750d-8f17-49cb-8c7d-d300ee663dc2	9d4e750d-9540-44c3-b550-b4ae6a0578fa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":237,"memory":18,"hostname":"EderCortes"}	2024-10-22 08:16:08
143	9d4e750e-348c-4817-999b-d69b6c21824d	9d4e750e-7c6e-457c-a9f9-f9429c621d3b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 08:16:08
144	9d4e750e-5ee8-4596-b069-7aed3c2110b1	9d4e750e-7c6e-457c-a9f9-f9429c621d3b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"44.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-22 08:16:08
145	9d4e750e-5f5d-4743-af1a-21589fa36c0e	9d4e750e-7c6e-457c-a9f9-f9429c621d3b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-22 08:16:08
146	9d4e750e-7ade-4bff-ab44-437557ef28ba	9d4e750e-7c6e-457c-a9f9-f9429c621d3b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 08:16:08
147	9d4e750e-7b3d-4e3c-a0cb-34cc5e5eefbb	9d4e750e-7c6e-457c-a9f9-f9429c621d3b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com"},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":393,"memory":24,"hostname":"EderCortes"}	2024-10-22 08:16:08
148	9d4e76b9-a0eb-4341-aee7-e5ae5c52d980	9d4e76b9-a5b6-4bef-9990-ade842d0f10c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":230,"memory":18,"hostname":"EderCortes"}	2024-10-22 08:20:48
149	9d4e76b9-f8e6-4432-8369-613f6cb0234f	9d4e76ba-3642-4d15-86c5-2b616d1ce01c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 08:20:49
150	9d4e76ba-1ba6-4a4c-a764-a6bdb1b33a6b	9d4e76ba-3642-4d15-86c5-2b616d1ce01c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"41.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-22 08:20:49
151	9d4e76ba-1c02-43a5-97e9-05af2b294357	9d4e76ba-3642-4d15-86c5-2b616d1ce01c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-22 08:20:49
152	9d4e76ba-34bb-441a-b24e-f520d05097ba	9d4e76ba-3642-4d15-86c5-2b616d1ce01c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 08:20:49
168	9d4f0baa-bb36-4e90-aae4-9ff118187d06	9d4f0baa-da2a-4a2a-8504-0d79feab53a8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"146.88","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-22 15:17:17
169	9d4f0baa-bbb1-42b0-a653-71fecf9e0e14	9d4f0baa-da2a-4a2a-8504-0d79feab53a8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-22 15:17:17
1234	9d50c60f-35e1-41f4-80bd-95fd32f114e5	9d50c60f-3abe-4376-9172-299204351806	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 11:54:18
1235	9d50c60f-363e-4020-a478-18de36dbcf80	9d50c60f-3abe-4376-9172-299204351806	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 11:54:18
1236	9d50c60f-398c-44af-bfd1-89758253470b	9d50c60f-3abe-4376-9172-299204351806	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 11:54:18
13129	9d5cf980-7c41-4dbd-a000-d3ee98087c2a	9d5cf980-cbdb-449c-a3d2-474eb541f3fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 13:28:04
14664	9d5ec060-f449-409b-bea2-c5a630b1a5a5	9d5ec061-1b3a-4d76-be32-c7689bde8ade	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-30 10:40:00
2730	9d50fb66-b579-46af-986f-d9d8dd5b07cd	9d50fb66-babb-4640-ae42-97060b2e4fe8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"46.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:23:27
153	9d4e76ba-351c-414c-80db-9c935fa6aae8	9d4e76ba-3642-4d15-86c5-2b616d1ce01c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com"},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":313,"memory":24,"hostname":"EderCortes"}	2024-10-22 08:20:49
154	9d4f0b05-e889-4eb0-88ff-688ca3a4eac9	9d4f0b07-a73f-4f72-b96e-595176225488	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":896,"memory":18,"hostname":"EderCortes"}	2024-10-22 15:15:29
155	9d4f0b0b-2ae6-4cfb-8ab2-3c656fdb5c25	9d4f0b0f-5ed8-4b0b-a650-1fb5c2a97515	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 15:15:32
156	9d4f0b0d-e9ca-4c89-bb2f-e78b5a66c63d	9d4f0b0f-5ed8-4b0b-a650-1fb5c2a97515	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"64.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-22 15:15:34
157	9d4f0b0d-ea6b-44e8-9475-ba4b046581e8	9d4f0b0f-5ed8-4b0b-a650-1fb5c2a97515	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-22 15:15:34
158	9d4f0b0f-5d31-44da-b794-8b20d0a58f6b	9d4f0b0f-5ed8-4b0b-a650-1fb5c2a97515	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 15:15:35
159	9d4f0b0f-5d96-48a4-87b0-259ee1678bf1	9d4f0b0f-5ed8-4b0b-a650-1fb5c2a97515	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com"},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":4161,"memory":24,"hostname":"EderCortes"}	2024-10-22 15:15:35
160	9d4f0b5c-1317-4edf-be28-467f6d56cdd6	9d4f0b5c-17d7-41e4-bcf3-5812fd9d8418	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":265,"memory":18,"hostname":"EderCortes"}	2024-10-22 15:16:25
161	9d4f0b5c-b153-419c-8ea8-b4ebb3f7263b	9d4f0b5c-fb88-4ba8-b897-f84e12365739	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 15:16:26
162	9d4f0b5c-d973-47dc-bbc4-04a6fee6bdb6	9d4f0b5c-fb88-4ba8-b897-f84e12365739	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"50.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-22 15:16:26
163	9d4f0b5c-d9db-44f2-906e-1daadea719b7	9d4f0b5c-fb88-4ba8-b897-f84e12365739	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-22 15:16:26
164	9d4f0b5c-f9cd-4129-af02-0ac79eeabba9	9d4f0b5c-fb88-4ba8-b897-f84e12365739	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 15:16:26
165	9d4f0b5c-fa2f-4e4f-a23d-c7645ece000d	9d4f0b5c-fb88-4ba8-b897-f84e12365739	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com"},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":403,"memory":24,"hostname":"EderCortes"}	2024-10-22 15:16:26
167	9d4f0baa-67e7-4bd8-a3ea-3d6313cad3f4	9d4f0baa-da2a-4a2a-8504-0d79feab53a8	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 15:17:16
170	9d4f0baa-d7b3-48e7-a907-cfaae21afe47	9d4f0baa-da2a-4a2a-8504-0d79feab53a8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 15:17:17
2731	9d50fb66-b5c3-4329-88ed-ffa690f18b7b	9d50fb66-babb-4640-ae42-97060b2e4fe8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:23:27
171	9d4f0baa-d83a-426d-b7a8-12cf1ff4afce	9d4f0baa-da2a-4a2a-8504-0d79feab53a8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com"},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":502,"memory":24,"hostname":"EderCortes"}	2024-10-22 15:17:17
172	9d4f0bde-b293-4e5c-97cc-18567269808d	9d4f0bde-b837-4137-b75a-b6d7960fc414	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":306,"memory":22,"hostname":"EderCortes"}	2024-10-22 15:17:51
173	9d4f0bdf-8617-4b5e-bbdc-58fdb88af698	9d4f0bdf-ccb4-480a-8812-8dffb3957b3b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 15:17:51
174	9d4f0bdf-ac93-4bbc-9015-502e77c5fd89	9d4f0bdf-ccb4-480a-8812-8dffb3957b3b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"53.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-22 15:17:51
175	9d4f0bdf-acf9-49bd-9288-01680eefde6e	9d4f0bdf-ccb4-480a-8812-8dffb3957b3b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-22 15:17:51
176	9d4f0bdf-caf9-4f0a-a60e-098840f22ef3	9d4f0bdf-ccb4-480a-8812-8dffb3957b3b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 15:17:51
177	9d4f0bdf-cb67-4474-8f47-00f6035a0c36	9d4f0bdf-ccb4-480a-8812-8dffb3957b3b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com"},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":401,"memory":24,"hostname":"EderCortes"}	2024-10-22 15:17:51
178	9d4f0c28-d29f-42da-bd07-e8ef8ef25e79	9d4f0c28-d8ae-4228-a2d0-596d3b4009b0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":217,"memory":22,"hostname":"EderCortes"}	2024-10-22 15:18:39
179	9d4f0c29-a534-470f-a47a-b0061a62891b	9d4f0c29-f3bb-4a0d-8a3c-5ebbcd11f47a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 15:18:40
180	9d4f0c29-d4b6-469e-b44c-124ff7ecb01f	9d4f0c29-f3bb-4a0d-8a3c-5ebbcd11f47a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"53.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-22 15:18:40
181	9d4f0c29-d522-4756-b087-e7bde326d330	9d4f0c29-f3bb-4a0d-8a3c-5ebbcd11f47a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-22 15:18:40
182	9d4f0c29-f18a-4872-8f1f-f1234ac8b9d1	9d4f0c29-f3bb-4a0d-8a3c-5ebbcd11f47a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 15:18:40
183	9d4f0c29-f225-4ba1-89c1-6907a58982fe	9d4f0c29-f3bb-4a0d-8a3c-5ebbcd11f47a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com"},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":420,"memory":24,"hostname":"EderCortes"}	2024-10-22 15:18:40
184	9d4f0da5-775c-4a8c-a8f9-7c12d40dfbd5	9d4f0da5-8743-44b4-b4ea-1bf25ab96f17	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 15:22:49
185	9d4f0da5-82bd-40ce-8154-d3a8d679334a	9d4f0da5-8743-44b4-b4ea-1bf25ab96f17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 15:22:49
209	9d4f105c-220f-457a-8ef5-e2ad327223db	9d4f105c-2362-4d50-b446-e6f53d490e14	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 15:30:24
186	9d4f0da5-839f-4c3c-8539-4a3f0fb0d19a	9d4f0da5-8743-44b4-b4ea-1bf25ab96f17	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":"Empty Response","duration":420,"memory":22,"hostname":"EderCortes"}	2024-10-22 15:22:49
187	9d4f0dc1-9ce2-45ec-ab2e-c10b166cad92	9d4f0dc1-a9e2-424e-99c8-ff791319de31	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 15:23:07
188	9d4f0dc1-a7a7-4826-9235-2ef044c5fe21	9d4f0dc1-a9e2-424e-99c8-ff791319de31	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 15:23:07
189	9d4f0dc1-a85f-4555-97d1-ca28d118b50e	9d4f0dc1-a9e2-424e-99c8-ff791319de31	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":"Empty Response","duration":574,"memory":22,"hostname":"EderCortes"}	2024-10-22 15:23:07
190	9d4f0e80-a2b7-4e04-b023-a6ee63c618c8	9d4f0e80-aa91-41e2-ba6a-ecc0c52de15d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 15:25:12
191	9d4f0e80-a896-4064-ae7c-0a62cb5ea948	9d4f0e80-aa91-41e2-ba6a-ecc0c52de15d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 15:25:12
192	9d4f0e80-a92b-47e9-8c59-35ba481885d1	9d4f0e80-aa91-41e2-ba6a-ecc0c52de15d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":"Empty Response","duration":428,"memory":20,"hostname":"EderCortes"}	2024-10-22 15:25:12
1237	9d50c60f-39cb-4802-9985-0368a59a0196	9d50c60f-3abe-4376-9172-299204351806	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":276,"memory":22,"hostname":"EderCortes"}	2024-10-23 11:54:18
2254	9d50e5e0-d598-4ef0-a016-a3a107dc65fc	9d50e5e0-d915-46bf-96db-8e639e944311	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":209,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:23:16
2732	9d50fb66-b952-467e-98b3-807430ed48e8	9d50fb66-babb-4640-ae42-97060b2e4fe8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:23:27
2733	9d50fb66-b9a3-4060-9da7-e17054c5b91c	9d50fb66-babb-4640-ae42-97060b2e4fe8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:23:27
605	9d4f2d2c-43f0-4cd9-8f5c-bc65a332e42c	9d4f2d2c-44ee-4e76-ba80-fc3b6f34b338	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:50:58
194	9d4f0eec-cf82-41e9-aa9e-ed7189a319b2	9d4f0eee-0853-4242-b7da-9bf06ac77eb7	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 15:26:23
195	9d4f0eee-05ce-409c-afa4-f63e2d2ff8f2	9d4f0eee-0853-4242-b7da-9bf06ac77eb7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 15:26:24
196	9d4f0eee-06ac-4f68-b7f8-62d7a75a6a49	9d4f0eee-0853-4242-b7da-9bf06ac77eb7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42P01]: Undefined table: 7 ERROR:  no existe la relaci\\u00f3n \\u00abitem_menu_menu\\u00bb\\nLINE 1: select * from \\"menu\\" inner join \\"item_menu_menu\\" on \\"menu\\".\\"...\\n                                        ^ (Connection: pgsql, SQL: select * from \\"menu\\" inner join \\"item_menu_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu_menu\\".\\"item_menu_menu\\" where \\"item_menu_menu\\".\\"item_menu_profile\\" = 12 and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":45,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":980,"memory":22,"hostname":"EderCortes"}	2024-10-22 15:26:24
197	9d4f0fa2-9e0b-4181-887f-96825e90657f	9d4f0fa2-cde1-4187-8e50-21cd96535622	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 15:28:22
198	9d4f0fa2-c4bf-452e-a5ba-06ac99c2dda1	9d4f0fa2-cde1-4187-8e50-21cd96535622	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '12' and \\"menu\\".\\"deleted_at\\" is null","time":"51.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":45,"hash":"7cc9da5523804d2dc9727d3475026e9a","hostname":"EderCortes"}	2024-10-22 15:28:23
199	9d4f0fa2-cb63-4200-8df4-cde4a0e3328a	9d4f0fa2-cde1-4187-8e50-21cd96535622	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 15:28:23
200	9d4f0fa2-cbf1-4c07-b544-003d30ce04a4	9d4f0fa2-cde1-4187-8e50-21cd96535622	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[]},"duration":383,"memory":22,"hostname":"EderCortes"}	2024-10-22 15:28:23
201	9d4f105a-23c7-488a-a831-03262d39e50c	9d4f105a-2b31-4561-a640-4151e9acd24c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":219,"memory":22,"hostname":"EderCortes"}	2024-10-22 15:30:23
202	9d4f105a-8e38-4c57-9741-1f708c643be0	9d4f105b-010f-4063-9c65-be2bed626169	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 15:30:23
203	9d4f105a-e433-4338-9509-e74de6fd215d	9d4f105b-010f-4063-9c65-be2bed626169	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"156.64","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-22 15:30:23
204	9d4f105a-e4b7-46d9-b05e-68c809dba935	9d4f105b-010f-4063-9c65-be2bed626169	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-22 15:30:23
205	9d4f105a-ff37-4dae-b50b-ebb7ed31b05d	9d4f105b-010f-4063-9c65-be2bed626169	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 15:30:23
206	9d4f105a-ff8f-4f96-bf2e-899c1b719412	9d4f105b-010f-4063-9c65-be2bed626169	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","profile":1},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":482,"memory":24,"hostname":"EderCortes"}	2024-10-22 15:30:23
207	9d4f105c-0356-47e1-9c09-0def76385cd7	9d4f105c-2362-4d50-b446-e6f53d490e14	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 15:30:24
208	9d4f105c-1dfd-4b92-be07-25945e25ff91	9d4f105c-2362-4d50-b446-e6f53d490e14	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"42.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":45,"hash":"7cc9da5523804d2dc9727d3475026e9a","hostname":"EderCortes"}	2024-10-22 15:30:24
1238	9d50c60f-7dda-421d-a292-97d1fd2b8f35	9d50c60f-99e2-4731-a123-fc6e5ce99e2c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 11:54:18
1239	9d50c60f-9579-4fda-87ac-ea6da7dee555	9d50c60f-99e2-4731-a123-fc6e5ce99e2c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 11:54:18
210	9d4f105c-2259-4b98-b56b-8114600009e6	9d4f105c-2362-4d50-b446-e6f53d490e14	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[]},"duration":300,"memory":22,"hostname":"EderCortes"}	2024-10-22 15:30:24
211	9d4f11dd-efcc-4c1b-8b7b-f49a1d9e7190	9d4f11de-187c-4ce5-817b-5b91f66c1420	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 15:34:37
212	9d4f11de-10bb-4b68-a0ad-f8f917370bf9	9d4f11de-187c-4ce5-817b-5b91f66c1420	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"45.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":45,"hash":"7cc9da5523804d2dc9727d3475026e9a","hostname":"EderCortes"}	2024-10-22 15:34:37
213	9d4f11de-169a-46fd-b2fb-2c327767cab8	9d4f11de-187c-4ce5-817b-5b91f66c1420	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 15:34:37
214	9d4f11de-16f7-48cd-bde7-ea7cceb4c567	9d4f11de-187c-4ce5-817b-5b91f66c1420	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[]},"duration":402,"memory":22,"hostname":"EderCortes"}	2024-10-22 15:34:37
215	9d4f12e4-fb3e-4b82-90cc-4b7ab9305a20	9d4f12e5-0970-4209-ba67-ccd28d6e70a8	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 15:37:29
216	9d4f12e5-0793-4444-89be-4ea2ae8d9b5c	9d4f12e5-0970-4209-ba67-ccd28d6e70a8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 15:37:29
217	9d4f12e5-07fb-478e-8d2c-53e786b7866a	9d4f12e5-0970-4209-ba67-ccd28d6e70a8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":"1"},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-10-22 15:37:29
218	9d4f130a-e69a-432a-b3c2-1152f8384b97	9d4f130b-089b-44db-b5b9-5363ef8c591f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 15:37:54
219	9d4f130b-02db-4442-9c12-a26da26bc998	9d4f130b-089b-44db-b5b9-5363ef8c591f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"41.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":48,"hash":"7cc9da5523804d2dc9727d3475026e9a","hostname":"EderCortes"}	2024-10-22 15:37:54
220	9d4f130b-073a-434b-b9d8-27c15d7bf9dd	9d4f130b-089b-44db-b5b9-5363ef8c591f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 15:37:54
221	9d4f130b-0782-4ef2-bbd0-2253a07b87c9	9d4f130b-089b-44db-b5b9-5363ef8c591f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[]},"duration":509,"memory":22,"hostname":"EderCortes"}	2024-10-22 15:37:54
222	9d4f1331-c3f0-4537-8f45-66356211258f	9d4f1331-e51c-49d7-84d3-2c1b675d7432	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 15:38:20
223	9d4f1331-df2b-48af-8b44-534e63030694	9d4f1331-e51c-49d7-84d3-2c1b675d7432	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"45.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":48,"hash":"7cc9da5523804d2dc9727d3475026e9a","hostname":"EderCortes"}	2024-10-22 15:38:20
224	9d4f1331-e2fb-4e28-bb15-68e242c4e0de	9d4f1331-e51c-49d7-84d3-2c1b675d7432	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 15:38:20
256	9d4f167d-c5f1-4f55-b7bd-3318b45eb7a1	9d4f167d-c830-4008-928e-c52f1e2e95bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 15:47:33
606	9d4f2d2e-387b-4e08-8ea9-e319e72f7f55	9d4f2d2e-5c7e-4857-96d8-4c8d8a44dc4a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:50:59
615	9d4f2d6a-230d-4547-aecb-c24af64daf93	9d4f2d6a-474e-4bfa-ba1e-f833248a96d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 16:51:39
1240	9d50c60f-95c0-4e5b-a81e-b0a92780d9a0	9d50c60f-99e2-4731-a123-fc6e5ce99e2c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 11:54:18
1241	9d50c60f-98ba-4244-95e3-f21f825d322e	9d50c60f-99e2-4731-a123-fc6e5ce99e2c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 11:54:18
225	9d4f1331-e343-44f0-a5d1-7d6e582a69af	9d4f1331-e51c-49d7-84d3-2c1b675d7432	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[]},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-10-22 15:38:20
226	9d4f1347-13d7-413f-9c6a-d76dd0922607	9d4f1347-3ea2-448a-80b5-26512cdf22b4	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 15:38:34
227	9d4f1347-368a-40c4-825a-daa53327ef2b	9d4f1347-3ea2-448a-80b5-26512cdf22b4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"47.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":48,"hash":"7cc9da5523804d2dc9727d3475026e9a","hostname":"EderCortes"}	2024-10-22 15:38:34
228	9d4f1347-3c28-4da3-8e33-9ea8a08cafab	9d4f1347-3ea2-448a-80b5-26512cdf22b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 15:38:34
229	9d4f1347-3c85-46ef-b2ea-c1ac2d751754	9d4f1347-3ea2-448a-80b5-26512cdf22b4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[]},"duration":321,"memory":22,"hostname":"EderCortes"}	2024-10-22 15:38:34
230	9d4f1358-4317-4b78-b522-c74a2f81f8d7	9d4f1358-9047-4d1e-a25c-8d2968847e24	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 15:38:45
231	9d4f1358-8a86-48f8-bdc8-707c5fe02d03	9d4f1358-9047-4d1e-a25c-8d2968847e24	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"menu\\".\\"deleted_at\\" is null","time":"157.84","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":48,"hash":"bdefc9b58d37074b07a32417cef13d0b","hostname":"EderCortes"}	2024-10-22 15:38:45
232	9d4f1358-8eaf-4393-8332-bfe8e03683a7	9d4f1358-9047-4d1e-a25c-8d2968847e24	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 15:38:45
233	9d4f1358-8ef8-4ac7-8ca0-81fc121c608d	9d4f1358-9047-4d1e-a25c-8d2968847e24	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[]},"duration":423,"memory":22,"hostname":"EderCortes"}	2024-10-22 15:38:45
234	9d4f1367-819d-4396-97e1-fb8e28fda431	9d4f1367-a419-41de-aa5d-d90add3e60b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 15:38:55
235	9d4f1367-9b52-4aa9-9a7e-17dd03876afa	9d4f1367-a419-41de-aa5d-d90add3e60b5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"menu\\" where \\"menu\\".\\"deleted_at\\" is null","time":"41.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":48,"hash":"3a4b6cfde043e8a7ddbcaa3bc6c21d82","hostname":"EderCortes"}	2024-10-22 15:38:55
236	9d4f1367-a28a-4276-8585-71b9fcc16179	9d4f1367-a419-41de-aa5d-d90add3e60b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 15:38:55
237	9d4f1367-a2e9-4cc7-9e55-a96491bea7ac	9d4f1367-a419-41de-aa5d-d90add3e60b5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[]},"duration":271,"memory":22,"hostname":"EderCortes"}	2024-10-22 15:38:55
238	9d4f1462-c2fb-4153-a2ac-bd43a32c0432	9d4f1462-ec87-433a-b5b5-18a51dbeb8e2	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 15:41:39
239	9d4f1462-e347-4034-9f2c-5c1eb0b9a5a7	9d4f1462-ec87-433a-b5b5-18a51dbeb8e2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"menu\\" where \\"menu\\".\\"deleted_at\\" is null","time":"43.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":48,"hash":"3a4b6cfde043e8a7ddbcaa3bc6c21d82","hostname":"EderCortes"}	2024-10-22 15:41:40
240	9d4f1462-eaab-4fb7-83cb-c3d908f23c01	9d4f1462-ec87-433a-b5b5-18a51dbeb8e2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 15:41:40
1318	9d50cb85-c833-4057-834b-c8e112a6b5d3	9d50cb85-efb8-437a-a95f-db5e2ba5a586	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:09:34
241	9d4f1462-eb0a-432c-b64c-e6487103c232	9d4f1462-ec87-433a-b5b5-18a51dbeb8e2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":"sdafkljsdf"},"duration":805,"memory":22,"hostname":"EderCortes"}	2024-10-22 15:41:40
2255	9d50e5e1-2c81-4486-9f4d-806e788f62fe	9d50e5e1-78dd-49ab-8262-fbf5974aca67	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 13:23:16
607	9d4f2d2e-56d1-4d3d-bc1d-523b1ebbba32	9d4f2d2e-5c7e-4857-96d8-4c8d8a44dc4a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"50.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:50:59
257	9d4f167d-c65d-4da4-873e-5d0026a6ff7c	9d4f167d-c830-4008-928e-c52f1e2e95bd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[]},"duration":300,"memory":22,"hostname":"EderCortes"}	2024-10-22 15:47:33
265	9d4f16bf-1c75-4fc3-b25d-edbff4c799e7	9d4f16bf-1e3e-4745-a4ab-000563995858	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":"HTML Response","duration":540,"memory":26,"hostname":"EderCortes"}	2024-10-22 15:48:16
608	9d4f2d2e-5734-4f54-b08a-d89564131d71	9d4f2d2e-5c7e-4857-96d8-4c8d8a44dc4a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:50:59
609	9d4f2d2e-5af6-4284-8283-bc96b2820a17	9d4f2d2e-5c7e-4857-96d8-4c8d8a44dc4a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 16:50:59
610	9d4f2d2e-5b53-4487-9cc7-d39b416bd5a6	9d4f2d2e-5c7e-4857-96d8-4c8d8a44dc4a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":319,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:50:59
616	9d4f2d6a-40ad-4d86-bbda-6abea09472dd	9d4f2d6a-474e-4bfa-ba1e-f833248a96d0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"47.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-22 16:51:39
617	9d4f2d6a-412e-41a7-b0e2-53f7cdb5898f	9d4f2d6a-474e-4bfa-ba1e-f833248a96d0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":3,"hostname":"EderCortes"}	2024-10-22 16:51:39
618	9d4f2d6a-460c-4656-b49c-9c968ac1e0a6	9d4f2d6a-474e-4bfa-ba1e-f833248a96d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-22 16:51:39
619	9d4f2d6a-4659-4bde-9417-c92e3991a8de	9d4f2d6a-474e-4bfa-ba1e-f833248a96d0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:51:39
731	9d4f2e4f-1593-42b0-a6ae-67d00ac8d4b8	9d4f2e4f-169f-4453-9182-036f307df842	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:54:09
243	9d4f1530-e37b-4fc6-8e63-1ef27c898383	9d4f1535-2c67-425e-a4c4-c5c0227a7c13	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 15:43:55
244	9d4f1535-29aa-424b-bdbb-71c8e84b1539	9d4f1535-2c67-425e-a4c4-c5c0227a7c13	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 15:43:57
245	9d4f1535-2a47-4612-9e30-f1dc9d8e7bbc	9d4f1535-2c67-425e-a4c4-c5c0227a7c13	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":"HTML Response","duration":3043,"memory":26,"hostname":"EderCortes"}	2024-10-22 15:43:57
246	9d4f1668-6581-41e4-ae0e-a2a0efb23b4a	9d4f1668-94c1-4def-94d7-51c0d1cf4cf7	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 15:47:19
247	9d4f1668-8c25-406d-a704-3a8a5ad84125	9d4f1668-94c1-4def-94d7-51c0d1cf4cf7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".* from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"menu\\".\\"deleted_at\\" is null","time":"51.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"d09e4bbe9c1ee8660339d5fa92e6356d","hostname":"EderCortes"}	2024-10-22 15:47:19
248	9d4f1668-92d9-4f4f-a514-eb263a4474a1	9d4f1668-94c1-4def-94d7-51c0d1cf4cf7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 15:47:19
249	9d4f1668-935f-4e1f-bedc-631652fc90d2	9d4f1668-94c1-4def-94d7-51c0d1cf4cf7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[]},"duration":418,"memory":22,"hostname":"EderCortes"}	2024-10-22 15:47:19
250	9d4f167a-97c1-4482-845c-47fd32345410	9d4f167a-e787-4dee-839e-2244c3bbdb91	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 15:47:31
251	9d4f167a-dfca-4060-b132-48e95ac66d0a	9d4f167a-e787-4dee-839e-2244c3bbdb91	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"menu_name\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"menu\\".\\"deleted_at\\" is null","time":"152.35","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"8fe92ed53b983d026fff97a9ced99a8b","hostname":"EderCortes"}	2024-10-22 15:47:31
252	9d4f167a-e599-47f7-8a81-372b4518d4d3	9d4f167a-e787-4dee-839e-2244c3bbdb91	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 15:47:31
253	9d4f167a-e604-40b5-923b-7eb11108ed8b	9d4f167a-e787-4dee-839e-2244c3bbdb91	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[]},"duration":498,"memory":22,"hostname":"EderCortes"}	2024-10-22 15:47:31
254	9d4f167d-9df8-4faa-9fe7-5db8e022faaf	9d4f167d-c830-4008-928e-c52f1e2e95bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 15:47:33
255	9d4f167d-be68-4fb0-9224-805a38fd8502	9d4f167d-c830-4008-928e-c52f1e2e95bd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"menu_name\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"menu\\".\\"deleted_at\\" is null","time":"53.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"8fe92ed53b983d026fff97a9ced99a8b","hostname":"EderCortes"}	2024-10-22 15:47:33
1319	9d50cb85-e776-4192-aeb1-403981f4ad22	9d50cb85-efb8-437a-a95f-db5e2ba5a586	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"56.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:09:34
1320	9d50cb85-e7db-4570-b1e6-5ad21b39f7bc	9d50cb85-efb8-437a-a95f-db5e2ba5a586	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 12:09:34
1321	9d50cb85-edfe-476b-83e6-117a3bd56382	9d50cb85-efb8-437a-a95f-db5e2ba5a586	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:09:34
1322	9d50cb85-ee74-441d-951d-468ffc71a2b0	9d50cb85-efb8-437a-a95f-db5e2ba5a586	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":326,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:09:34
732	9d4f2e50-7647-44e6-b37e-cb06a3335ebd	9d4f2e50-9f97-4ce0-8920-129676226d8d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-22 16:54:10
620	9d4f2d6b-cd03-42b8-a0c8-14cf005e05ab	9d4f2d6b-f4e3-44c9-bfbc-2092c661f815	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-22 16:51:40
282	9d4f1e18-11bb-4c15-a5b1-02c20de9b941	9d4f1e18-13b9-4317-bd1f-013c7ac67b37	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:08:48
283	9d4f1e18-1224-4112-9fca-cee6b980d834	9d4f1e18-13b9-4317-bd1f-013c7ac67b37	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_prefix":"Das","menu_url":"dashboard","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":null,"menu_orden":1},{"id":2,"menu_name":"Usuarios","menu_prefix":"Usu","menu_url":"dashboard\\/list-users","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":null,"menu_orden":2},{"id":3,"menu_name":"Recaudos","menu_prefix":"Rec","menu_url":"dashboard\\/list-precautions","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":null,"menu_orden":3},{"id":4,"menu_name":"Prestamista","menu_prefix":"Pre","menu_url":"dashboard\\/list-precautions","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":null,"menu_orden":4},{"id":5,"menu_name":"Cobrador","menu_prefix":"Cob","menu_url":"dashboard\\/list-charge","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":null,"menu_orden":5},{"id":6,"menu_name":"Barrios","menu_prefix":"Bor","menu_url":"dashboard\\/list-neighborhood","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":null,"menu_orden":6},{"id":7,"menu_name":"Garantia","menu_prefix":"Gar","menu_url":"dashboard\\/list-neighborhood","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":null,"menu_orden":7}]},"duration":484,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:08:48
621	9d4f2d6b-ed9f-4bf9-8088-9cf3426cdea6	9d4f2d6b-f4e3-44c9-bfbc-2092c661f815	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"54.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:51:40
622	9d4f2d6b-edf3-47ad-8d16-69fad29bc24a	9d4f2d6b-f4e3-44c9-bfbc-2092c661f815	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:51:40
623	9d4f2d6b-f36a-46c8-af3d-3a0f23d5d4b8	9d4f2d6b-f4e3-44c9-bfbc-2092c661f815	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-22 16:51:40
624	9d4f2d6b-f3c5-4634-9613-76f5e62e3d19	9d4f2d6b-f4e3-44c9-bfbc-2092c661f815	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":532,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:51:40
733	9d4f2e50-9633-4ecc-820b-5ae040602067	9d4f2e50-9f97-4ce0-8920-129676226d8d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"52.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:54:10
734	9d4f2e50-96b7-410a-b02a-423fc11b84c1	9d4f2e50-9f97-4ce0-8920-129676226d8d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:54:10
735	9d4f2e50-9d29-4492-b19b-f7ed956cbc65	9d4f2e50-9f97-4ce0-8920-129676226d8d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-22 16:54:10
736	9d4f2e50-9dc6-430a-8b0c-689c9a8fa0ec	9d4f2e50-9f97-4ce0-8920-129676226d8d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":462,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:54:10
15511	9d5edf6e-bca0-475c-80c9-3b4e71b3267b	9d5edf72-5788-4825-989a-e90647cdf65b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-30 12:06:51
259	9d4f168a-0ef2-4801-aba3-c8f5de26074c	9d4f168a-a681-44d0-bea0-0a7fb36e9b51	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 15:47:41
260	9d4f168a-a360-4942-966f-db3d978ef6d9	9d4f168a-a681-44d0-bea0-0a7fb36e9b51	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 15:47:41
261	9d4f168a-a408-4f6a-9f4c-afd6312a5fc6	9d4f168a-a681-44d0-bea0-0a7fb36e9b51	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":"HTML Response","duration":574,"memory":26,"hostname":"EderCortes"}	2024-10-22 15:47:41
1591	9d50d7b9-75dd-4110-a511-20bd08875dc5	9d50d7b9-79c3-404d-aa9a-eaa23243ef25	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"name\\", \\"users\\".\\"user_document\\", \\"users\\".\\"id\\" from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%1004%' or \\"users\\".\\"user_document\\"::text like '%1004%' order by \\"users\\".\\"user_document\\" asc","time":"41.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"71e2e94a1a5a1b5c9b9dc051aea4b922","hostname":"EderCortes"}	2024-10-23 12:43:42
1242	9d50c60f-98f8-4fdc-9afc-4137e2c4b1e5	9d50c60f-99e2-4731-a123-fc6e5ce99e2c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":206,"memory":22,"hostname":"EderCortes"}	2024-10-23 11:54:18
629	9d4f2d7c-c920-4a60-9615-08213893bd87	9d4f2d7c-ec73-4af7-a2be-a3048cb6e561	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-22 16:51:51
1323	9d50cb86-43e6-4a9b-a2ab-6b8820717ef3	9d50cb86-941f-4dd6-8f81-619715a7e05a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:09:35
284	9d4f22f1-8576-4a7f-85ef-c3fee598c541	9d4f22f1-d12e-4fec-8b33-5ef91c98ebca	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 16:22:22
285	9d4f22f1-c981-4d3f-aa38-5aa22a3cee03	9d4f22f1-d12e-4fec-8b33-5ef91c98ebca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"menu\\" where \\"menu\\".\\"deleted_at\\" is null","time":"140.01","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":43,"hash":"3a4b6cfde043e8a7ddbcaa3bc6c21d82","hostname":"EderCortes"}	2024-10-22 16:22:22
286	9d4f22f1-c9fb-4e73-9cf6-bb733d1328f5	9d4f22f1-d12e-4fec-8b33-5ef91c98ebca	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:22:22
287	9d4f22f1-cf66-4df4-90a0-d3ae7528cac1	9d4f22f1-d12e-4fec-8b33-5ef91c98ebca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:22:22
288	9d4f22f1-cfc9-4af4-9828-bd75d110772f	9d4f22f1-d12e-4fec-8b33-5ef91c98ebca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_prefix":"Das","menu_url":"dashboard","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":null,"menu_orden":1},{"id":2,"menu_name":"Usuarios","menu_prefix":"Usu","menu_url":"dashboard\\/list-users","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":null,"menu_orden":2},{"id":3,"menu_name":"Recaudos","menu_prefix":"Rec","menu_url":"dashboard\\/list-precautions","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":null,"menu_orden":3},{"id":4,"menu_name":"Prestamista","menu_prefix":"Pre","menu_url":"dashboard\\/list-precautions","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":null,"menu_orden":4},{"id":5,"menu_name":"Cobrador","menu_prefix":"Cob","menu_url":"dashboard\\/list-charge","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":null,"menu_orden":5},{"id":6,"menu_name":"Barrios","menu_prefix":"Bor","menu_url":"dashboard\\/list-neighborhood","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":null,"menu_orden":6},{"id":7,"menu_name":"Garantia","menu_prefix":"Gar","menu_url":"dashboard\\/list-neighborhood","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":null,"menu_orden":7}]},"duration":415,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:22:22
1592	9d50d7b9-7896-4175-9155-e0845a93d900	9d50d7b9-79c3-404d-aa9a-eaa23243ef25	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 12:43:42
1593	9d50d7b9-78d8-4961-9f69-16dcce2ccc05	9d50d7b9-79c3-404d-aa9a-eaa23243ef25	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"1004"},"session":[],"response_status":200,"response":{"data":[{"name":"Eder Arley","user_document":"1004608333","id":12},{"name":"Luis andre","user_document":"100465545","id":14},{"name":"Maria Antonieta","user_document":"100465546","id":18},{"name":"Maria Antonieta 2","user_document":"1004655468","id":19}]},"duration":211,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:43:42
15675	9d64900b-c7f1-443f-af0f-6682d5182fac	9d64900b-e1d7-4a78-8b24-547fc76e1c53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 07:59:49
2256	9d50e5e1-7312-42fd-8a24-0edbf46bb082	9d50e5e1-78dd-49ab-8262-fbf5974aca67	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder%' or \\"users\\".\\"user_document\\"::text like '%eder%' order by \\"users\\".\\"user_document\\" asc","time":"153.57","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:23:17
483	9d4f2945-dfaf-4301-af06-8585e1432802	9d4f2945-e0b2-4770-af59-aab4d545ec96	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:40:04
4187	9d512915-75c0-44ee-8ab4-49281bebc229	9d512916-e7bf-4980-9aa6-01d01715d511	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":11826,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:31:12
263	9d4f16be-95b6-4afa-b277-dfd4799c893c	9d4f16bf-1e3e-4745-a4ab-000563995858	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 15:48:15
264	9d4f16bf-1c08-4328-b54d-ab9ed750ce4d	9d4f16bf-1e3e-4745-a4ab-000563995858	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-22 15:48:16
289	9d4f2389-6dca-4ec5-9ac5-d872632093e9	9d4f2389-9b9c-421d-9ec0-b8dc7221dfbd	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 16:24:01
290	9d4f2389-91c5-430a-996c-2cb3c5d766ae	9d4f2389-9b9c-421d-9ec0-b8dc7221dfbd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"menu\\".\\"deleted_at\\" is null","time":"47.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":43,"hash":"bdefc9b58d37074b07a32417cef13d0b","hostname":"EderCortes"}	2024-10-22 16:24:01
291	9d4f2389-9268-4704-94e0-caca04e2152e	9d4f2389-9b9c-421d-9ec0-b8dc7221dfbd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":15,"hostname":"EderCortes"}	2024-10-22 16:24:01
292	9d4f2389-9990-46aa-8876-c425b79795ab	9d4f2389-9b9c-421d-9ec0-b8dc7221dfbd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:24:01
293	9d4f2389-9a0c-41dd-895a-7796bc76026a	9d4f2389-9b9c-421d-9ec0-b8dc7221dfbd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_prefix":"Das","menu_url":"dashboard","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":"2024-10-21T21:45:48.000000Z","menu_orden":1,"item_menu_profile":1,"item_menu_menu":1},{"id":2,"menu_name":"Usuarios","menu_prefix":"Usu","menu_url":"dashboard\\/list-users","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":"2024-10-21T21:45:48.000000Z","menu_orden":2,"item_menu_profile":1,"item_menu_menu":2},{"id":3,"menu_name":"Recaudos","menu_prefix":"Rec","menu_url":"dashboard\\/list-precautions","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":"2024-10-21T21:45:48.000000Z","menu_orden":3,"item_menu_profile":1,"item_menu_menu":3},{"id":4,"menu_name":"Prestamista","menu_prefix":"Pre","menu_url":"dashboard\\/list-precautions","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":"2024-10-21T21:45:48.000000Z","menu_orden":4,"item_menu_profile":1,"item_menu_menu":4},{"id":5,"menu_name":"Cobrador","menu_prefix":"Cob","menu_url":"dashboard\\/list-charge","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":"2024-10-21T21:45:48.000000Z","menu_orden":5,"item_menu_profile":1,"item_menu_menu":5},{"id":6,"menu_name":"Barrios","menu_prefix":"Bor","menu_url":"dashboard\\/list-neighborhood","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":"2024-10-21T21:45:48.000000Z","menu_orden":6,"item_menu_profile":1,"item_menu_menu":6},{"id":7,"menu_name":"Garantia","menu_prefix":"Gar","menu_url":"dashboard\\/list-neighborhood","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":"2024-10-21T21:45:48.000000Z","menu_orden":7,"item_menu_profile":1,"item_menu_menu":7},{"id":8,"menu_name":"Dashboard","menu_prefix":"Das","menu_url":"dashboard","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":"2024-10-21T21:45:48.000000Z","menu_orden":1,"item_menu_profile":2,"item_menu_menu":1},{"id":9,"menu_name":"Usuarios","menu_prefix":"Usu","menu_url":"dashboard\\/list-users","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":"2024-10-21T21:45:48.000000Z","menu_orden":2,"item_menu_profile":2,"item_menu_menu":2},{"id":10,"menu_name":"Recaudos","menu_prefix":"Rec","menu_url":"dashboard\\/list-precautions","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":"2024-10-21T21:45:48.000000Z","menu_orden":3,"item_menu_profile":2,"item_menu_menu":3},{"id":11,"menu_name":"Dashboard","menu_prefix":"Das","menu_url":"dashboard","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":"2024-10-21T21:45:48.000000Z","menu_orden":1,"item_menu_profile":3,"item_menu_menu":1},{"id":12,"menu_name":"Usuarios","menu_prefix":"Usu","menu_url":"dashboard\\/list-users","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":"2024-10-21T21:45:48.000000Z","menu_orden":2,"item_menu_profile":3,"item_menu_menu":2},{"id":13,"menu_name":"Prestamista","menu_prefix":"Pre","menu_url":"dashboard\\/list-precautions","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":"2024-10-21T21:45:48.000000Z","menu_orden":4,"item_menu_profile":3,"item_menu_menu":4},{"id":14,"menu_name":"Dashboard","menu_prefix":"Das","menu_url":"dashboard","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":"2024-10-21T21:45:48.000000Z","menu_orden":1,"item_menu_profile":4,"item_menu_menu":1},{"id":15,"menu_name":"Cobrador","menu_prefix":"Cob","menu_url":"dashboard\\/list-charge","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":"2024-10-21T21:45:48.000000Z","menu_orden":5,"item_menu_profile":4,"item_menu_menu":5}]},"duration":377,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:24:01
2257	9d50e5e1-7732-48a8-ab5d-ebccb88e1b9d	9d50e5e1-78dd-49ab-8262-fbf5974aca67	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 13:23:17
6312	9d52643c-7ffa-4c36-b91d-fce5b04c24ed	9d52643c-85c4-420f-bf92-361c9efb787a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"74.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 07:12:25
6313	9d52643c-8053-4448-a0fc-bbf0e3e53544	9d52643c-85c4-420f-bf92-361c9efb787a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 07:12:25
6314	9d52643c-842f-403a-bc1c-318861e3b1e7	9d52643c-85c4-420f-bf92-361c9efb787a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 07:12:25
3095	9d5101c6-a942-4f2f-9a5c-3ac1fb9942ef	9d5101c6-af0a-44b0-8d79-19c597fbb060	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"50.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:41:17
3096	9d5101c6-a99a-447f-8b65-1f9afbb41244	9d5101c6-af0a-44b0-8d79-19c597fbb060	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:41:17
3097	9d5101c6-adf5-4ce8-844c-19abe2a976ad	9d5101c6-af0a-44b0-8d79-19c597fbb060	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 14:41:17
2258	9d50e5e1-7785-44f9-97e0-2676dbb8f080	9d50e5e1-78dd-49ab-8262-fbf5974aca67	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:23:17
1602	9d50d7d7-6d19-4f3e-b227-7180258aff04	9d50d7d7-6e60-4375-b014-90966d3c5654	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:44:01
1324	9d50cb86-8bfc-4c88-87dd-b557810c8c8d	9d50cb86-941f-4dd6-8f81-619715a7e05a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"160.64","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:09:35
630	9d4f2d7c-e5cf-4c6c-b431-941a469542c2	9d4f2d7c-ec73-4af7-a2be-a3048cb6e561	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"44.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-22 16:51:51
294	9d4f238e-1552-4165-a1d1-d09e94e52bd6	9d4f238e-34be-44f0-a0b6-f0b3a0431621	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:24:04
295	9d4f238e-2e2a-4b8c-af71-ba139fead535	9d4f238e-34be-44f0-a0b6-f0b3a0431621	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"menu\\".\\"deleted_at\\" is null","time":"41.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":43,"hash":"bdefc9b58d37074b07a32417cef13d0b","hostname":"EderCortes"}	2024-10-22 16:24:04
631	9d4f2d7c-e62b-4582-86b1-83c5475e035d	9d4f2d7c-ec73-4af7-a2be-a3048cb6e561	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":3,"hostname":"EderCortes"}	2024-10-22 16:51:51
632	9d4f2d7c-eaed-4b60-9faa-2b6ef7d06769	9d4f2d7c-ec73-4af7-a2be-a3048cb6e561	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-22 16:51:51
633	9d4f2d7c-eb4c-4be2-81fc-7b21bfd07b49	9d4f2d7c-ec73-4af7-a2be-a3048cb6e561	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":273,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:51:51
1325	9d50cb86-8c63-4971-8aa1-cbfec96b7198	9d50cb86-941f-4dd6-8f81-619715a7e05a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 12:09:35
1326	9d50cb86-924a-46ff-a66a-41bc2ff68a5c	9d50cb86-941f-4dd6-8f81-619715a7e05a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:09:35
1327	9d50cb86-92f6-43a7-8a9e-d84864368711	9d50cb86-941f-4dd6-8f81-619715a7e05a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":398,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:09:35
6364	9d5264f5-789c-42af-9f53-fcf2dd8ec2f2	9d5264f5-848b-42f1-b2b1-a3eb026a96e1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"59.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 07:14:26
6365	9d5264f5-7912-4850-8000-63d841135189	9d5264f5-848b-42f1-b2b1-a3eb026a96e1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 07:14:26
1328	9d50cb88-3229-41e0-b45f-1e0b6fc4a636	9d50cb88-7a08-4fd0-a470-c529f98aa27e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:09:36
431	9d4f284c-8e42-4000-a1e2-e46585cdddc9	9d4f284c-d773-460f-8aee-9e6752cc2a64	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:37:20
267	9d4f1764-dc48-459e-ae15-6021cb83a4f5	9d4f1765-739c-4d0a-bef8-d365054768f6	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 15:50:04
268	9d4f1765-6e24-49a9-b46d-70ed33421fee	9d4f1765-739c-4d0a-bef8-d365054768f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 15:50:05
269	9d4f1765-7148-4da7-b881-67b8a1a0c147	9d4f1765-739c-4d0a-bef8-d365054768f6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":"HTML Response","duration":611,"memory":26,"hostname":"EderCortes"}	2024-10-22 15:50:05
741	9d4f2e5e-8f6a-4371-883f-f1873d3d1c65	9d4f2e5e-af0d-48e1-9e96-ac3b9293a141	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:54:19
296	9d4f238e-2e81-4487-a07f-a020342e5604	9d4f238e-34be-44f0-a0b6-f0b3a0431621	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":15,"hostname":"EderCortes"}	2024-10-22 16:24:04
297	9d4f238e-3329-4e23-b845-b2ee91003574	9d4f238e-34be-44f0-a0b6-f0b3a0431621	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:24:04
742	9d4f2e5e-a983-4fb5-a0d1-c16594f38d06	9d4f2e5e-af0d-48e1-9e96-ac3b9293a141	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"43.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-22 16:54:19
432	9d4f284c-d5b4-4d90-80c6-deeb89d431f9	9d4f284c-d773-460f-8aee-9e6752cc2a64	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 16:37:21
433	9d4f284c-d683-4225-9e49-61590101fd4d	9d4f284c-d773-460f-8aee-9e6752cc2a64	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:37:21
634	9d4f2d7e-bc10-45da-8519-dca97fc943aa	9d4f2d7e-dc0a-49ea-bfae-38dc977f81ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-22 16:51:52
635	9d4f2d7e-d6f2-478b-9716-2abcb3cd7d38	9d4f2d7e-dc0a-49ea-bfae-38dc977f81ba	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"45.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:51:52
636	9d4f2d7e-d743-4db2-9a41-722fea0c2d84	9d4f2d7e-dc0a-49ea-bfae-38dc977f81ba	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:51:52
637	9d4f2d7e-da96-41b7-827d-a45e5ed215ff	9d4f2d7e-dc0a-49ea-bfae-38dc977f81ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-22 16:51:52
638	9d4f2d7e-dae2-406d-96f0-a050fc27a5d9	9d4f2d7e-dc0a-49ea-bfae-38dc977f81ba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":320,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:51:52
743	9d4f2e5e-a9d2-4b2c-99dc-5c0537c5a8a7	9d4f2e5e-af0d-48e1-9e96-ac3b9293a141	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":3,"hostname":"EderCortes"}	2024-10-22 16:54:19
744	9d4f2e5e-adee-4a07-bb96-98f822416a5d	9d4f2e5e-af0d-48e1-9e96-ac3b9293a141	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:54:19
745	9d4f2e5e-ae36-4a5b-bc53-b2c0079aeb12	9d4f2e5e-af0d-48e1-9e96-ac3b9293a141	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":271,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:54:19
1329	9d50cb88-7502-4a16-9536-ea2f0ccdcfec	9d50cb88-7a08-4fd0-a470-c529f98aa27e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"151.77","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 12:09:36
1330	9d50cb88-7560-42f9-b033-d91ff6cfeaf2	9d50cb88-7a08-4fd0-a470-c529f98aa27e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 12:09:36
434	9d4f284e-4916-44ac-84e1-1411cce5e878	9d4f284e-66eb-4d59-b086-005b4b84234c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 16:37:21
435	9d4f284e-620e-4d86-9ee7-2a863a3410a3	9d4f284e-66eb-4d59-b086-005b4b84234c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"40.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:37:22
436	9d4f284e-625a-464a-8279-a9b64d631f24	9d4f284e-66eb-4d59-b086-005b4b84234c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:37:22
437	9d4f284e-659f-473a-8a29-bea603137ffb	9d4f284e-66eb-4d59-b086-005b4b84234c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 16:37:22
438	9d4f284e-65e9-41ad-870b-d8d910cdcde9	9d4f284e-66eb-4d59-b086-005b4b84234c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":482,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:37:22
1331	9d50cb88-78c0-4952-9881-83ec8ca8590d	9d50cb88-7a08-4fd0-a470-c529f98aa27e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 12:09:36
746	9d4f2e60-3849-41d0-aab6-bfe6cade1a88	9d4f2e60-641e-4261-a32e-1c9f45ded798	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:54:20
485	9d4f29c2-7482-4f6d-ad03-6479997df5aa	9d4f29c2-98bf-427c-9688-cf0aadada0a5	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 16:41:25
486	9d4f29c2-96bb-4a90-80a2-ea42000f4eb4	9d4f29c2-98bf-427c-9688-cf0aadada0a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:41:25
487	9d4f29c2-9787-4d3e-acea-cdf8b0aae28b	9d4f29c2-98bf-427c-9688-cf0aadada0a5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":294,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:41:25
643	9d4f2d8d-d413-47ef-a298-217b97ee29dd	9d4f2d8d-f772-461c-8f68-d81caf6d8abf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:52:02
644	9d4f2d8d-ef28-4da3-a8ea-fa6cfc6f93c7	9d4f2d8d-f772-461c-8f68-d81caf6d8abf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"44.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-22 16:52:02
645	9d4f2d8d-ef98-4a49-a675-beb7e8dd716d	9d4f2d8d-f772-461c-8f68-d81caf6d8abf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":3,"hostname":"EderCortes"}	2024-10-22 16:52:02
646	9d4f2d8d-f5f5-4847-be73-01b6f73aa967	9d4f2d8d-f772-461c-8f68-d81caf6d8abf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:52:02
647	9d4f2d8d-f64c-45de-af3b-98340d6d2c1e	9d4f2d8d-f772-461c-8f68-d81caf6d8abf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":280,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:52:02
747	9d4f2e60-5acf-41d7-a85c-d847f51bac00	9d4f2e60-641e-4261-a32e-1c9f45ded798	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"58.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:54:20
748	9d4f2e60-5b57-42cc-a9fb-943fd04bd977	9d4f2e60-641e-4261-a32e-1c9f45ded798	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:54:20
749	9d4f2e60-622e-468d-b476-ef1a07931701	9d4f2e60-641e-4261-a32e-1c9f45ded798	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 16:54:20
750	9d4f2e60-62b5-4307-b5eb-c440c9f266cc	9d4f2e60-641e-4261-a32e-1c9f45ded798	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":360,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:54:20
488	9d4f29c4-766e-4eca-a98a-10a308bd25f4	9d4f29c4-c092-4c85-9b87-d696c0f5de62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:41:27
489	9d4f29c4-bae8-472f-922d-0f930d4d8dde	9d4f29c4-c092-4c85-9b87-d696c0f5de62	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"152.26","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:41:27
271	9d4f178f-b698-4c91-bf07-c91f0285e094	9d4f1790-6774-472b-b09d-d41fae9c2791	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 15:50:32
272	9d4f1790-6467-49e6-ba3a-429cdcefc48e	9d4f1790-6774-472b-b09d-d41fae9c2791	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 15:50:33
273	9d4f1790-64c7-4eed-907b-ddbcf01377ce	9d4f1790-6774-472b-b09d-d41fae9c2791	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":"HTML Response","duration":672,"memory":26,"hostname":"EderCortes"}	2024-10-22 15:50:33
274	9d4f1a04-5537-4cdf-b022-14e23db9621d	9d4f1a04-a765-4d16-afdc-5d825d1dee2c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 15:57:24
275	9d4f1a04-9f59-4d8e-827a-2b628db4fe51	9d4f1a04-a765-4d16-afdc-5d825d1dee2c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"menu\\" where \\"menu\\".\\"deleted_at\\" is null","time":"151.69","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":43,"hash":"3a4b6cfde043e8a7ddbcaa3bc6c21d82","hostname":"EderCortes"}	2024-10-22 15:57:24
276	9d4f1a04-9fda-44cf-9956-441e10a0d3a4	9d4f1a04-a765-4d16-afdc-5d825d1dee2c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 15:57:24
277	9d4f1a04-a52c-42ab-ba03-eb9f494250c9	9d4f1a04-a765-4d16-afdc-5d825d1dee2c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 15:57:24
278	9d4f1a04-a593-4e65-8704-48da9c263050	9d4f1a04-a765-4d16-afdc-5d825d1dee2c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_prefix":"Das","menu_url":"dashboard","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":null,"menu_orden":1},{"id":2,"menu_name":"Usuarios","menu_prefix":"Usu","menu_url":"dashboard\\/list-users","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":null,"menu_orden":2},{"id":3,"menu_name":"Recaudos","menu_prefix":"Rec","menu_url":"dashboard\\/list-precautions","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":null,"menu_orden":3},{"id":4,"menu_name":"Prestamista","menu_prefix":"Pre","menu_url":"dashboard\\/list-precautions","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":null,"menu_orden":4},{"id":5,"menu_name":"Cobrador","menu_prefix":"Cob","menu_url":"dashboard\\/list-charge","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":null,"menu_orden":5},{"id":6,"menu_name":"Barrios","menu_prefix":"Bor","menu_url":"dashboard\\/list-neighborhood","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":null,"menu_orden":6},{"id":7,"menu_name":"Garantia","menu_prefix":"Gar","menu_url":"dashboard\\/list-neighborhood","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":null,"menu_orden":7}]},"duration":433,"memory":22,"hostname":"EderCortes"}	2024-10-22 15:57:24
279	9d4f1e17-c227-4128-b056-801d3bc51e54	9d4f1e18-13b9-4317-bd1f-013c7ac67b37	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 16:08:48
280	9d4f1e18-0b38-49e0-8efa-6a3a4586f1b1	9d4f1e18-13b9-4317-bd1f-013c7ac67b37	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"menu\\" where \\"menu\\".\\"deleted_at\\" is null","time":"146.28","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":43,"hash":"3a4b6cfde043e8a7ddbcaa3bc6c21d82","hostname":"EderCortes"}	2024-10-22 16:08:48
281	9d4f1e18-0bb4-4b06-8b05-81cb1798455a	9d4f1e18-13b9-4317-bd1f-013c7ac67b37	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:08:48
490	9d4f29c4-bb58-42c6-853e-a4956c1e1cc5	9d4f29c4-c092-4c85-9b87-d696c0f5de62	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:41:27
491	9d4f29c4-bf78-406e-97ea-b27ae148dfb9	9d4f29c4-c092-4c85-9b87-d696c0f5de62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:41:27
492	9d4f29c4-bfbb-42a1-8959-a2c0e8a00868	9d4f29c4-c092-4c85-9b87-d696c0f5de62	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":462,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:41:27
648	9d4f2d8f-8eaf-41d2-af31-e739b335e45b	9d4f2d8f-bfcd-45b3-bb4b-1d603585cc5e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:52:03
649	9d4f2d8f-ba0e-4a65-93f1-386ffcc0fa81	9d4f2d8f-bfcd-45b3-bb4b-1d603585cc5e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"68.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:52:03
650	9d4f2d8f-ba75-4f1a-a958-862706903338	9d4f2d8f-bfcd-45b3-bb4b-1d603585cc5e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:52:03
298	9d4f238e-3399-469e-956d-51fd20496b7a	9d4f238e-34be-44f0-a0b6-f0b3a0431621	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_prefix":"Das","menu_url":"dashboard","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":"2024-10-21T21:45:48.000000Z","menu_orden":1,"item_menu_profile":1,"item_menu_menu":1},{"id":2,"menu_name":"Usuarios","menu_prefix":"Usu","menu_url":"dashboard\\/list-users","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":"2024-10-21T21:45:48.000000Z","menu_orden":2,"item_menu_profile":1,"item_menu_menu":2},{"id":3,"menu_name":"Recaudos","menu_prefix":"Rec","menu_url":"dashboard\\/list-precautions","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":"2024-10-21T21:45:48.000000Z","menu_orden":3,"item_menu_profile":1,"item_menu_menu":3},{"id":4,"menu_name":"Prestamista","menu_prefix":"Pre","menu_url":"dashboard\\/list-precautions","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":"2024-10-21T21:45:48.000000Z","menu_orden":4,"item_menu_profile":1,"item_menu_menu":4},{"id":5,"menu_name":"Cobrador","menu_prefix":"Cob","menu_url":"dashboard\\/list-charge","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":"2024-10-21T21:45:48.000000Z","menu_orden":5,"item_menu_profile":1,"item_menu_menu":5},{"id":6,"menu_name":"Barrios","menu_prefix":"Bor","menu_url":"dashboard\\/list-neighborhood","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":"2024-10-21T21:45:48.000000Z","menu_orden":6,"item_menu_profile":1,"item_menu_menu":6},{"id":7,"menu_name":"Garantia","menu_prefix":"Gar","menu_url":"dashboard\\/list-neighborhood","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":"2024-10-21T21:45:48.000000Z","menu_orden":7,"item_menu_profile":1,"item_menu_menu":7},{"id":8,"menu_name":"Dashboard","menu_prefix":"Das","menu_url":"dashboard","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":"2024-10-21T21:45:48.000000Z","menu_orden":1,"item_menu_profile":2,"item_menu_menu":1},{"id":9,"menu_name":"Usuarios","menu_prefix":"Usu","menu_url":"dashboard\\/list-users","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":"2024-10-21T21:45:48.000000Z","menu_orden":2,"item_menu_profile":2,"item_menu_menu":2},{"id":10,"menu_name":"Recaudos","menu_prefix":"Rec","menu_url":"dashboard\\/list-precautions","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":"2024-10-21T21:45:48.000000Z","menu_orden":3,"item_menu_profile":2,"item_menu_menu":3},{"id":11,"menu_name":"Dashboard","menu_prefix":"Das","menu_url":"dashboard","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":"2024-10-21T21:45:48.000000Z","menu_orden":1,"item_menu_profile":3,"item_menu_menu":1},{"id":12,"menu_name":"Usuarios","menu_prefix":"Usu","menu_url":"dashboard\\/list-users","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":"2024-10-21T21:45:48.000000Z","menu_orden":2,"item_menu_profile":3,"item_menu_menu":2},{"id":13,"menu_name":"Prestamista","menu_prefix":"Pre","menu_url":"dashboard\\/list-precautions","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":"2024-10-21T21:45:48.000000Z","menu_orden":4,"item_menu_profile":3,"item_menu_menu":4},{"id":14,"menu_name":"Dashboard","menu_prefix":"Das","menu_url":"dashboard","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":"2024-10-21T21:45:48.000000Z","menu_orden":1,"item_menu_profile":4,"item_menu_menu":1},{"id":15,"menu_name":"Cobrador","menu_prefix":"Cob","menu_url":"dashboard\\/list-charge","created_at":"2024-10-21T21:45:48.000000Z","updated_at":"2024-10-21T21:45:48.000000Z","deleted_at":"2024-10-21T21:45:48.000000Z","menu_orden":5,"item_menu_profile":4,"item_menu_menu":5}]},"duration":290,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:24:04
299	9d4f2399-1515-45cc-8124-668171efaea9	9d4f2399-5f3e-43c8-b5e1-ce6564b38f09	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:24:12
300	9d4f2399-5b54-4d4a-9819-a401cabefba6	9d4f2399-5f3e-43c8-b5e1-ce6564b38f09	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"menu\\".\\"deleted_at\\" is null","time":"155.45","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":43,"hash":"bdefc9b58d37074b07a32417cef13d0b","hostname":"EderCortes"}	2024-10-22 16:24:12
301	9d4f2399-5bb7-4f3d-b70d-606798c1b3d2	9d4f2399-5f3e-43c8-b5e1-ce6564b38f09	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":15,"hostname":"EderCortes"}	2024-10-22 16:24:12
302	9d4f2399-5da9-4446-ae5f-b7c60cd39764	9d4f2399-5f3e-43c8-b5e1-ce6564b38f09	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 16:24:12
303	9d4f2399-5e14-459e-a4a4-4ef6cf778dff	9d4f2399-5f3e-43c8-b5e1-ce6564b38f09	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":"Empty Response","duration":352,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:24:12
304	9d4f23c9-745c-4447-8ced-75977061e139	9d4f23c9-a059-42a6-b65b-408b4d8cd89f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 16:24:43
305	9d4f23c9-966f-4f01-a1c8-f3891e7e4766	9d4f23c9-a059-42a6-b65b-408b4d8cd89f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_menu\\".\\"item_menu_menu\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"menu\\".\\"deleted_at\\" is null","time":"52.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":44,"hash":"44fc340504f42c15c4b45b598db51afe","hostname":"EderCortes"}	2024-10-22 16:24:43
306	9d4f23c9-9727-42ab-9709-8063f90f3948	9d4f23c9-a059-42a6-b65b-408b4d8cd89f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":15,"hostname":"EderCortes"}	2024-10-22 16:24:43
307	9d4f23c9-9e48-4828-8392-dfb51130470a	9d4f23c9-a059-42a6-b65b-408b4d8cd89f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 16:24:43
308	9d4f23c9-9ece-4c43-9ca6-f8d0a7b578ff	9d4f23c9-a059-42a6-b65b-408b4d8cd89f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"item_menu_menu":1},{"item_menu_menu":2},{"item_menu_menu":3},{"item_menu_menu":4},{"item_menu_menu":5},{"item_menu_menu":6},{"item_menu_menu":7},{"item_menu_menu":1},{"item_menu_menu":2},{"item_menu_menu":3},{"item_menu_menu":1},{"item_menu_menu":2},{"item_menu_menu":4},{"item_menu_menu":1},{"item_menu_menu":5}]},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:24:43
309	9d4f23da-113b-49b2-8acb-8913c049d945	9d4f23da-30d5-4050-8ef9-257f587f0676	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 16:24:54
310	9d4f23da-2ad2-400f-8e07-e5ff7a71bdee	9d4f23da-30d5-4050-8ef9-257f587f0676	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"menu\\".\\"deleted_at\\" is null","time":"42.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":44,"hash":"b1517f2dcf74e48f3275dd57be500b81","hostname":"EderCortes"}	2024-10-22 16:24:54
311	9d4f23da-2b25-4c34-bdcc-8d7da7151a72	9d4f23da-30d5-4050-8ef9-257f587f0676	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":15,"hostname":"EderCortes"}	2024-10-22 16:24:54
312	9d4f23da-2f67-4c02-85c5-19478bd7d153	9d4f23da-30d5-4050-8ef9-257f587f0676	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-22 16:24:54
651	9d4f2d8f-be2c-4611-af5f-4d47bd506665	9d4f2d8f-bfcd-45b3-bb4b-1d603585cc5e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 16:52:03
1603	9d50d7d7-b643-4ab5-840b-0fa0556476c1	9d50d7d8-0339-43eb-81ba-7d628b597b4d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 12:44:01
1604	9d50d7d7-fbbc-42fa-98db-f9c5d3622228	9d50d7d8-0339-43eb-81ba-7d628b597b4d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"156.26","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":65,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:44:02
313	9d4f23da-2fad-4d30-925f-fa5bc67f6186	9d4f23da-30d5-4050-8ef9-257f587f0676	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1},{"id":2},{"id":3},{"id":4},{"id":5},{"id":6},{"id":7},{"id":1},{"id":2},{"id":3},{"id":1},{"id":2},{"id":4},{"id":1},{"id":5}]},"duration":242,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:24:54
4188	9d512917-f2ec-457d-9058-4cd434083e01	9d512917-f619-4f87-9ea8-96bdf29da4bb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":150,"memory":20,"hostname":"EderCortes"}	2024-10-23 16:31:13
2259	9d50e5e4-8da1-4478-b59b-703f3e2ac739	9d50e5e4-90e1-4bb5-84b8-6b2eb09288cb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":173,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:23:19
4358	9d512a80-8355-4ee2-a176-6908872e4d33	9d512a80-8448-4a1d-964a-9494cf6b4889	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null}]},"duration":387,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:35:09
317	9d4f23f3-b14a-4bb3-9506-0d2a68060e22	9d4f23f3-b33b-496a-b21b-bf158265c7b0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":"HTML Response","duration":640,"memory":26,"hostname":"EderCortes"}	2024-10-22 16:25:11
6315	9d52643c-847f-43f4-93d2-1111d9613193	9d52643c-85c4-420f-bf92-361c9efb787a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":737,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:12:25
6366	9d5264f5-828e-4f0e-b777-1d5e0af27aa8	9d5264f5-848b-42f1-b2b1-a3eb026a96e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 07:14:26
9144	9d52f445-4a08-446f-bb6b-7d9ed0734874	9d52f445-5024-4961-bcc2-f27fe350d086	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"51.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:55:10
2260	9d50e5e5-43b9-4eaa-a519-cba61fb7e299	9d50e5e5-5ee2-4864-b1f0-9fd9d066bac9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 13:23:19
2261	9d50e5e5-5ae4-4352-9629-2409508b5ebf	9d50e5e5-5ee2-4864-b1f0-9fd9d066bac9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder%' or \\"users\\".\\"user_document\\"::text like '%eder%' order by \\"users\\".\\"user_document\\" asc","time":"43.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:23:19
2262	9d50e5e5-5db9-447e-81fc-68a39f26f156	9d50e5e5-5ee2-4864-b1f0-9fd9d066bac9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 13:23:19
546	9d4f2b38-f9a4-414e-b5ff-4a86180b48c1	9d4f2b39-30aa-4165-9ac1-815a165c89ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:45:31
315	9d4f23f2-fc6e-483a-921e-a71d2c432d79	9d4f23f3-b33b-496a-b21b-bf158265c7b0	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 16:25:11
316	9d4f23f3-b0c6-4736-bb0d-a112e0234845	9d4f23f3-b33b-496a-b21b-bf158265c7b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:25:11
318	9d4f2408-bccb-4657-b72e-e8b209eccb86	9d4f2409-0535-412d-b021-05a2447e6f8c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:25:25
547	9d4f2b39-2f13-4eae-a9ce-3c9298efe079	9d4f2b39-30aa-4165-9ac1-815a165c89ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:45:31
548	9d4f2b39-2fa5-48bd-80c4-6d5e77e45c00	9d4f2b39-30aa-4165-9ac1-815a165c89ac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"406","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"name":"Maria Antonieta","email":"andre@gmail.com","user_last_name_one":"De las nieve","user_last_name_two":null,"user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_photo":null,"user_state":null,"profile_code":4,"user_age":"31","password":"********","verification_token":"MQnxyy2e8hVMX82fMH8L5lw91COfcXE7n0nJL42hcV9jRUb18dHWaA5egH84"},"session":[],"response_status":500,"response":{"message":"SQLSTATE[23502]: Not null violation: 7 ERROR:  el valor nulo en la columna \\u00abuser_last_name_two\\u00bb de la relaci\\u00f3n \\u00abusers\\u00bb viola la restricci\\u00f3n de no nulo\\nDETAIL:  La fila que falla contiene (15, Maria Antonieta, andre@gmail.com, null, $2y$10$8PLpCn1mpoPC1fyXcKOn0eVFrfg3hmBGg9.Z6BcTxCkp07xT6TLWG, De las nieve, null, CC, 100465545, 1992-11-12T04:00:00.000Z, Cali, Bonilla aragon, Calle 750, 312596295, 31, 4, null, 0, MQnxyy2e8hVMX82fMH8L5lw91COfcXE7n0nJL42hcV9jRUb18dHWaA5egH84, 2024-10-22 16:45:31, 2024-10-22 16:45:31, null). (Connection: pgsql, SQL: insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"verification_token\\", \\"updated_at\\", \\"created_at\\") values (Maria Antonieta, andre@gmail.com, De las nieve, ?, CC, 100465545, 1992-11-12T04:00:00.000Z, Cali, Bonilla aragon, Calle 750, 312596295, 4, 31, $2y$10$8PLpCn1mpoPC1fyXcKOn0eVFrfg3hmBGg9.Z6BcTxCkp07xT6TLWG, MQnxyy2e8hVMX82fMH8L5lw91COfcXE7n0nJL42hcV9jRUb18dHWaA5egH84, 2024-10-22 16:45:31, 2024-10-22 16:45:31) returning \\"id\\")","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":401,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor.php","line":24,"function":"selectFromWriteConnection","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3549,"function":"processInsertGetId","class":"Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":1982,"function":"insertGetId","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1334,"function":"__call","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1299,"function":"insertAndSetId","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1138,"function":"performInsert","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":39,"function":"save","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"store","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":290,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:45:31
2263	9d50e5e5-5df8-4ee5-843f-e9225c0c6e56	9d50e5e5-5ee2-4864-b1f0-9fd9d066bac9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":216,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:23:19
16960	9d654664-ef5f-4cf9-b3b0-89fbb2125000	9d654665-0e86-49e8-935d-32aa0606a0f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 16:29:42
4189	9d512918-4df5-43a4-8af4-ede25d7457de	9d512918-5225-46d6-8478-55d6d74db518	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":157,"memory":20,"hostname":"EderCortes"}	2024-10-23 16:31:13
10857	9d5ca538-b0fc-41c0-8a16-5f3b6ae27bd0	9d5ca538-b859-40b9-88e4-95fac15a2bb3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"143.22","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-29 09:32:25
9145	9d52f445-4a5c-44a1-9812-a9f731b8d3b8	9d52f445-5024-4961-bcc2-f27fe350d086	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:55:10
1605	9d50d7d7-fe90-4f97-b2f1-6f1c09e32511	9d50d7d8-0339-43eb-81ba-7d628b597b4d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 12:44:02
1606	9d50d7d8-020e-44fd-b504-bcbbd154c1d6	9d50d7d8-0339-43eb-81ba-7d628b597b4d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 12:44:02
1607	9d50d7d8-0257-4b78-80e3-6f082c489b1e	9d50d7d8-0339-43eb-81ba-7d628b597b4d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":368,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:44:02
2184	9d50e4f2-5aef-452f-ab51-39c7b833563b	9d50e4f2-5df9-428a-ae4b-abc6444a9575	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":138,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:20:40
10858	9d5ca538-b15e-426e-af02-722978388a28	9d5ca538-b859-40b9-88e4-95fac15a2bb3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-10-29 09:32:25
9146	9d52f445-4f19-4d23-8352-77d65cfb4b96	9d52f445-5024-4961-bcc2-f27fe350d086	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 13:55:10
322	9d4f2409-0420-4490-a4c5-a2ac049a2fd1	9d4f2409-0535-412d-b021-05a2447e6f8c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard"},{"id":2,"menu_name":"Usuarios"},{"id":3,"menu_name":"Recaudos"},{"id":4,"menu_name":"Prestamista"},{"id":5,"menu_name":"Cobrador"},{"id":6,"menu_name":"Barrios"},{"id":7,"menu_name":"Garantia"},{"id":1,"menu_name":"Dashboard"},{"id":2,"menu_name":"Usuarios"},{"id":3,"menu_name":"Recaudos"},{"id":1,"menu_name":"Dashboard"},{"id":2,"menu_name":"Usuarios"},{"id":4,"menu_name":"Prestamista"},{"id":1,"menu_name":"Dashboard"},{"id":5,"menu_name":"Cobrador"}]},"duration":388,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:25:25
323	9d4f2422-e4f0-463f-b8a5-cee2fa28e00a	9d4f2423-2c28-4c94-9aa5-f3b58ba7f547	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:25:42
324	9d4f2423-26ea-4362-910c-f1fb7595c8dd	9d4f2423-2c28-4c94-9aa5-f3b58ba7f547	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"menu\\".\\"deleted_at\\" is null","time":"147.40","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":44,"hash":"c381bbeb990d4d4951c174da93c6042c","hostname":"EderCortes"}	2024-10-22 16:25:42
325	9d4f2423-274b-49e9-899b-57d67614effb	9d4f2423-2c28-4c94-9aa5-f3b58ba7f547	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":15,"hostname":"EderCortes"}	2024-10-22 16:25:42
326	9d4f2423-2abb-4d52-bfe1-9cf71d96f92c	9d4f2423-2c28-4c94-9aa5-f3b58ba7f547	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 16:25:42
327	9d4f2423-2b05-4e39-a523-86bce7e414d4	9d4f2423-2c28-4c94-9aa5-f3b58ba7f547	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"dashboard\\/list-neighborhood"},{"id":1,"menu_name":"Dashboard","menu_url":"dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"dashboard\\/list-precautions"},{"id":1,"menu_name":"Dashboard","menu_url":"dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"dashboard\\/list-users"},{"id":4,"menu_name":"Prestamista","menu_url":"dashboard\\/list-precautions"},{"id":1,"menu_name":"Dashboard","menu_url":"dashboard"},{"id":5,"menu_name":"Cobrador","menu_url":"dashboard\\/list-charge"}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:25:42
328	9d4f242d-a0e2-4843-bf09-b5cfcabac22e	9d4f242d-bfa1-4e7a-885f-6ec57e240356	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 16:25:49
329	9d4f242d-b9c8-4a12-8f20-1d8f0bd9433a	9d4f242d-bfa1-4e7a-885f-6ec57e240356	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"menu\\".\\"deleted_at\\" is null","time":"42.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":44,"hash":"c381bbeb990d4d4951c174da93c6042c","hostname":"EderCortes"}	2024-10-22 16:25:49
330	9d4f242d-ba2f-42ab-8155-e10431bc99bf	9d4f242d-bfa1-4e7a-885f-6ec57e240356	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":15,"hostname":"EderCortes"}	2024-10-22 16:25:49
331	9d4f242d-be47-4986-afd0-ca197566a9da	9d4f242d-bfa1-4e7a-885f-6ec57e240356	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 16:25:49
332	9d4f242d-be99-456b-bec3-af6e2482449e	9d4f242d-bfa1-4e7a-885f-6ec57e240356	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"dashboard\\/list-neighborhood"},{"id":1,"menu_name":"Dashboard","menu_url":"dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"dashboard\\/list-precautions"},{"id":1,"menu_name":"Dashboard","menu_url":"dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"dashboard\\/list-users"},{"id":4,"menu_name":"Prestamista","menu_url":"dashboard\\/list-precautions"},{"id":1,"menu_name":"Dashboard","menu_url":"dashboard"},{"id":5,"menu_name":"Cobrador","menu_url":"dashboard\\/list-charge"}]},"duration":269,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:25:49
333	9d4f2471-4707-4c3d-8298-1196863c9c4f	9d4f2471-7325-4802-9273-3582a1fbc7eb	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 16:26:33
334	9d4f2471-6b8b-408f-8338-0e35b3801157	9d4f2471-7325-4802-9273-3582a1fbc7eb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"51.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:26:33
335	9d4f2471-6c19-4d16-9d4d-7d872c004c5a	9d4f2471-7325-4802-9273-3582a1fbc7eb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:26:33
336	9d4f2471-714d-4d95-abb4-263311284e22	9d4f2471-7325-4802-9273-3582a1fbc7eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:26:33
549	9d4f2b3e-11a4-45f1-94ea-17b162658d08	9d4f2b3e-149e-488d-82e6-315fcf7fb695	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":148,"memory":20,"hostname":"EderCortes"}	2024-10-22 16:45:34
337	9d4f2471-71b5-4f45-8091-35c1991686d8	9d4f2471-7325-4802-9273-3582a1fbc7eb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"dashboard\\/list-neighborhood"}]},"duration":485,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:26:33
338	9d4f2582-bd07-472f-b9f5-7847a4321a8f	9d4f2582-f047-4741-bfd1-1302fd1819ae	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 16:29:33
339	9d4f2582-e4ee-48df-8a44-47b6c702b539	9d4f2582-f047-4741-bfd1-1302fd1819ae	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"58.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:29:33
340	9d4f2582-e5c0-451f-89fd-0203dbcb890b	9d4f2582-f047-4741-bfd1-1302fd1819ae	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:29:33
341	9d4f2582-edd6-41ac-a331-dbc75816813f	9d4f2582-f047-4741-bfd1-1302fd1819ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:29:33
342	9d4f2582-ee5f-46f5-ba58-aa1b3f77cb1a	9d4f2582-f047-4741-bfd1-1302fd1819ae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"dashboard\\/list-neighborhood"}]},"duration":440,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:29:33
1608	9d50d7d9-40f3-4eec-9e42-05ff1a74378c	9d50d7d9-60e8-4c4d-8e13-1a5b828f9693	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 12:44:02
551	9d4f2b3e-c43d-4549-83e7-a485daf3faa5	9d4f2b3f-26e8-42b5-8868-828e3259e024	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:45:35
552	9d4f2b3f-2574-4b7e-89e2-8dc252def465	9d4f2b3f-26e8-42b5-8868-828e3259e024	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 16:45:35
553	9d4f2b3f-25e4-49d1-9a49-a7d0dc71beb1	9d4f2b3f-26e8-42b5-8868-828e3259e024	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"408","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"name":"Maria Antonieta","email":"andre@gmail.com","user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_photo":null,"user_state":null,"profile_code":4,"user_age":"31","password":"********","verification_token":"0cYaU9SAmZqNBsHTC3UfW2ZMOEoBTX6uUGedogZGOfuqjklHc1qExKq2lR4a"},"session":[],"response_status":409,"response":{"error":"El paciente ya existe en el sistema.","code":409},"duration":396,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:45:35
550	9d4f2b3f-22ba-45df-8a75-df370627e2dd	9d4f2b3f-26e8-42b5-8868-828e3259e024	30c167a3366c3172219738ca61304b9a	f	exception	{"class":"Illuminate\\\\Database\\\\UniqueConstraintViolationException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":824,"message":"SQLSTATE[23505]: Unique violation: 7 ERROR:  llave duplicada viola restricci\\u00f3n de unicidad \\u00abusers_email_unique\\u00bb\\nDETAIL:  Ya existe la llave (email)=(andre@gmail.com). (Connection: pgsql, SQL: insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"verification_token\\", \\"updated_at\\", \\"created_at\\") values (Maria Antonieta, andre@gmail.com, De las nieve, ds, CC, 100465545, 1992-11-12T04:00:00.000Z, Cali, Bonilla aragon, Calle 750, 312596295, 4, 31, $2y$10$P1ilwsvNUi4dUexOSQ1PZ.hxgLbM.WIY9T4CyPiLtBZzGFKJzDMUy, 0cYaU9SAmZqNBsHTC3UfW2ZMOEoBTX6uUGedogZGOfuqjklHc1qExKq2lR4a, 2024-10-22 16:45:35, 2024-10-22 16:45:35) returning \\"id\\")","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":401},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor.php","line":24},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3549},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":1982},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1334},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1299},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1138},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"815":"        try {","816":"            return $callback($query, $bindings);","817":"        }","818":"","819":"        \\/\\/ If an exception occurs when attempting to run a query, we'll format the error","820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":""},"hostname":"EderCortes","occurrences":1}	2024-10-22 16:45:35
652	9d4f2d8f-be78-4abf-a2a2-23fe3462e2d2	9d4f2d8f-bfcd-45b3-bb4b-1d603585cc5e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":546,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:52:03
554	9d4f2b53-df02-4ac6-809a-2fc8ce717a65	9d4f2b53-e216-45df-a7cd-b11b24225078	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":169,"memory":20,"hostname":"EderCortes"}	2024-10-22 16:45:48
2264	9d50e5e8-c814-4bbc-bdb9-4f36fb8ef04f	9d50e5e8-cae7-473e-8ffc-31a37cf8da3f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":154,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:23:21
584	9d4f2ced-6f7b-4153-a129-c19f12caf81d	9d4f2ced-8e32-4d1f-8484-245dc274d23e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:50:17
585	9d4f2ced-8cac-4592-b179-500be2a8ac6a	9d4f2ced-8e32-4d1f-8484-245dc274d23e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 16:50:17
586	9d4f2ced-8d44-42f0-a4d1-87c5f4b5df25	9d4f2ced-8e32-4d1f-8484-245dc274d23e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:50:17
2870	9d50fca1-b958-4282-9875-f87118dda45b	9d50fca1-ba33-4916-a45f-d5abb240f174	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":262,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:26:54
2185	9d50e4f3-135d-40e8-8464-61fa1f090165	9d50e4f3-2e33-498a-bffd-4daa3b014e68	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 13:20:40
1609	9d50d7d9-5bc0-4195-b727-07111302b2a7	9d50d7d9-60e8-4c4d-8e13-1a5b828f9693	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 12:44:02
1610	9d50d7d9-5c09-4913-8dbd-d9661a370f0f	9d50d7d9-60e8-4c4d-8e13-1a5b828f9693	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 12:44:02
1611	9d50d7d9-5f9f-4a16-b8cb-7f8b1ca70220	9d50d7d9-60e8-4c4d-8e13-1a5b828f9693	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 12:44:02
1612	9d50d7d9-5fe4-407e-85bd-0306d57b6efa	9d50d7d9-60e8-4c4d-8e13-1a5b828f9693	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":395,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:44:02
2186	9d50e4f3-2a0f-4b33-8997-f9d613547ad0	9d50e4f3-2e33-498a-bffd-4daa3b014e68	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder c%' or \\"users\\".\\"user_document\\"::text like '%eder c%' order by \\"users\\".\\"user_document\\" asc","time":"41.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:20:40
2187	9d50e4f3-2d01-493e-aaa1-bfddcefb5566	9d50e4f3-2e33-498a-bffd-4daa3b014e68	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 13:20:40
2188	9d50e4f3-2d44-44dd-9323-5b177f61ea34	9d50e4f3-2e33-498a-bffd-4daa3b014e68	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"28","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder c"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":220,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:20:40
555	9d4f2b54-c699-4547-843f-5d70559257a1	9d4f2b54-caf0-46cd-ac00-06b4663971e5	30c167a3366c3172219738ca61304b9a	t	exception	{"class":"Illuminate\\\\Database\\\\UniqueConstraintViolationException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":824,"message":"SQLSTATE[23505]: Unique violation: 7 ERROR:  llave duplicada viola restricci\\u00f3n de unicidad \\u00abusers_email_unique\\u00bb\\nDETAIL:  Ya existe la llave (email)=(andre@gmail.com). (Connection: pgsql, SQL: insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"verification_token\\", \\"updated_at\\", \\"created_at\\") values (Maria Antonieta, andre@gmail.com, De las nieve, ds, CC, 100465546, 1992-11-12T04:00:00.000Z, Cali, Bonilla aragon, Calle 750, 312596295, 5, 31, $2y$10$bOsbuXCVrok0cR\\/uE8YRK.z6XGsdgOw9jB4ZJsWnzhTS46cQraGOq, nreHb2ICAqozegyGbqZEqpyUHhDFS97mlIboPWNOHRgGPHQuzOtZNqlJ5SDx, 2024-10-22 16:45:49, 2024-10-22 16:45:49) returning \\"id\\")","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":401},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor.php","line":24},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3549},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":1982},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1334},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1299},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1138},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"815":"        try {","816":"            return $callback($query, $bindings);","817":"        }","818":"","819":"        \\/\\/ If an exception occurs when attempting to run a query, we'll format the error","820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":""},"hostname":"EderCortes","occurrences":2}	2024-10-22 16:45:49
556	9d4f2b54-9441-4185-bd36-745d5e1c7d04	9d4f2b54-caf0-46cd-ac00-06b4663971e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 16:45:49
344	9d4f2596-1c41-48ad-8a3e-ce1709c1c0b8	9d4f2596-3dbd-4980-89e8-0b42d8e7f9d4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:29:45
345	9d4f2596-3c3a-45dc-b5cf-655e45f550b5	9d4f2596-3dbd-4980-89e8-0b42d8e7f9d4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:29:45
346	9d4f2596-3cd7-4b79-807c-73a37b300cd7	9d4f2596-3dbd-4980-89e8-0b42d8e7f9d4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":307,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:29:45
347	9d4f2597-9be9-4daa-be61-9111c1ff8b95	9d4f2597-bb08-412b-a973-4fdb8019a579	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:29:46
348	9d4f2597-b589-4f07-aff9-ae836c479c1c	9d4f2597-bb08-412b-a973-4fdb8019a579	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"42.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:29:46
349	9d4f2597-b60f-42a1-ba2d-5634d4e20d9c	9d4f2597-bb08-412b-a973-4fdb8019a579	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:29:46
350	9d4f2597-b996-401a-8d3b-1ce6fc515c6e	9d4f2597-bb08-412b-a973-4fdb8019a579	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 16:29:46
351	9d4f2597-b9e9-44a5-9e3c-9cf27f923bc0	9d4f2597-bb08-412b-a973-4fdb8019a579	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"dashboard\\/list-neighborhood"}]},"duration":501,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:29:46
557	9d4f2b54-c97e-4059-872d-e560f144ebc7	9d4f2b54-caf0-46cd-ac00-06b4663971e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 16:45:49
558	9d4f2b54-c9f5-4acf-8e11-459dd070b49a	9d4f2b54-caf0-46cd-ac00-06b4663971e5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"408","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"name":"Maria Antonieta","email":"andre@gmail.com","user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_photo":null,"user_state":null,"profile_code":5,"user_age":"31","password":"********","verification_token":"nreHb2ICAqozegyGbqZEqpyUHhDFS97mlIboPWNOHRgGPHQuzOtZNqlJ5SDx"},"session":[],"response_status":409,"response":{"error":"El paciente ya existe en el sistema.","code":409},"duration":291,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:45:49
587	9d4f2ced-d594-4a69-b887-df7d081d2639	9d4f2ced-f373-499f-afc0-0f44c5933ab8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 16:50:17
588	9d4f2ced-eea5-487c-9e9d-df0ad9d1fba5	9d4f2ced-f373-499f-afc0-0f44c5933ab8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"42.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-22 16:50:17
589	9d4f2ced-eeee-476b-8067-7a8e0820e78c	9d4f2ced-f373-499f-afc0-0f44c5933ab8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":3,"hostname":"EderCortes"}	2024-10-22 16:50:17
590	9d4f2ced-f25d-4e99-b82a-93754a8c6c20	9d4f2ced-f373-499f-afc0-0f44c5933ab8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 16:50:17
591	9d4f2ced-f2a0-45ad-a847-0ddc671daea3	9d4f2ced-f373-499f-afc0-0f44c5933ab8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:50:17
2265	9d50e5e9-8290-4745-a03f-37012b2a8b01	9d50e5e9-9d1e-4070-8690-af9e501b2114	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 13:23:22
2871	9d50fca2-03fd-4edb-8ff6-510e92d5f49f	9d50fca2-5001-4b4d-9dc4-5e4a134366cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 14:26:54
10859	9d5ca538-b68d-4e3a-92e4-d59957034785	9d5ca538-b859-40b9-88e4-95fac15a2bb3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 09:32:25
17249	9d65519f-b1a5-45ec-9f6c-f8befb79a47f	9d65519f-d448-4c3a-bd5c-6406954db587	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 17:01:06
559	9d4f2b66-2292-4af8-9d5a-6db302aaa10c	9d4f2b66-260e-4f8f-a87f-695931722f30	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":155,"memory":20,"hostname":"EderCortes"}	2024-10-22 16:46:00
592	9d4f2cef-5f2c-4aae-bf3a-21787f07f6df	9d4f2cef-86e4-4559-95cf-8caa82753c36	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 16:50:18
593	9d4f2cef-80e3-4cfc-8343-4e991f9cc138	9d4f2cef-86e4-4559-95cf-8caa82753c36	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"50.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:50:18
594	9d4f2cef-8151-469c-b293-c19d3c48576d	9d4f2cef-86e4-4559-95cf-8caa82753c36	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:50:18
440	9d4f28fa-2b41-43cd-85f1-a65308138099	9d4f28fa-5858-4c06-8c5e-c349a7be1fc8	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 16:39:14
441	9d4f28fa-55cb-452a-a87d-2ebf2fb5d2c8	9d4f28fa-5858-4c06-8c5e-c349a7be1fc8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:39:14
442	9d4f28fa-56cd-4edd-93fb-efd64dbf1b6a	9d4f28fa-5858-4c06-8c5e-c349a7be1fc8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":381,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:39:14
595	9d4f2cef-858a-42f6-aba7-9850c30260cf	9d4f2cef-86e4-4559-95cf-8caa82753c36	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-22 16:50:18
596	9d4f2cef-85dc-46da-b26e-0643f4d61f8e	9d4f2cef-86e4-4559-95cf-8caa82753c36	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":487,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:50:18
2266	9d50e5e9-9877-403e-bdce-5040e5afdcde	9d50e5e9-9d1e-4070-8690-af9e501b2114	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder%' or \\"users\\".\\"user_document\\"::text like '%eder%' order by \\"users\\".\\"user_document\\" asc","time":"40.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:23:22
2267	9d50e5e9-9bd0-4308-8919-e1225d3e18b3	9d50e5e9-9d1e-4070-8690-af9e501b2114	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 13:23:22
2268	9d50e5e9-9c17-45a8-9efe-cda391c3bedb	9d50e5e9-9d1e-4070-8690-af9e501b2114	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":219,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:23:22
4190	9d512918-a405-43e0-929f-13a8134b2bab	9d512918-a854-4d60-9196-6fd0b6c99f37	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":145,"memory":20,"hostname":"EderCortes"}	2024-10-23 16:31:13
7109	9d52dab9-24ba-4d13-87d2-aa27d5376e0b	9d52dab9-2594-46d8-b29c-a7d66d993d76	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":367,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:43:44
443	9d4f28fc-6f1a-48e4-b7af-811a0c48da46	9d4f28fc-9316-4312-a176-cf3b2979a90b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:39:16
444	9d4f28fc-8a92-421b-8f5d-d780f74e94b5	9d4f28fc-9316-4312-a176-cf3b2979a90b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"46.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:39:16
445	9d4f28fc-8b07-4b71-aa46-5e725bc2e6a1	9d4f28fc-9316-4312-a176-cf3b2979a90b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:39:16
446	9d4f28fc-9186-4d0e-837f-0da1911fae6b	9d4f28fc-9316-4312-a176-cf3b2979a90b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:39:16
447	9d4f28fc-91eb-4ea2-9b85-260a815fd19f	9d4f28fc-9316-4312-a176-cf3b2979a90b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":366,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:39:16
6367	9d5264f5-8301-4498-9645-50d2c503a19c	9d5264f5-848b-42f1-b2b1-a3eb026a96e1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":601,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:14:26
4191	9d51291a-7b7c-4543-a224-e9a84c9c1f2f	9d51291b-d7d9-4dea-9956-4a58c090b2b6	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 16:31:15
7110	9d52dab9-6d26-4e46-84a4-535316aa0068	9d52dab9-8e6e-4440-be16-2e72b28c65cb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-24 12:43:44
560	9d4f2b66-d553-46bb-a66a-d4acfdd59ad8	9d4f2b67-06ed-43d9-8e90-d694c5aae77a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 16:46:01
561	9d4f2b67-023a-4010-b13f-4afc3fab2682	9d4f2b67-06ed-43d9-8e90-d694c5aae77a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"verification_token\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta', 'andre_01@gmail.com', 'De las nieve', 'ds', 'CC', '100465546', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '312596295', 5, '31', 'y$J7iMqXyzt36uHw.oAkcpX.ohbyj\\/pDabyA14aLQKREmQO.MaV7ve.', 'kIjQivxy2DrF6h1ZN0cWyeQAdxrjRcDNgbu86LLFqAXAbslVrT9nfQ1Aigds', '2024-10-22 16:46:01', '2024-10-22 16:46:01') returning \\"id\\"","time":"41.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":39,"hash":"df77298d3271ba3a87b0b9c71897cb01","hostname":"EderCortes"}	2024-10-22 16:46:01
562	9d4f2b67-0292-4752-8b66-8f9851c0262b	9d4f2b67-06ed-43d9-8e90-d694c5aae77a	\N	t	model	{"action":"created","model":"App\\\\Models\\\\User:18","hostname":"EderCortes"}	2024-10-22 16:46:01
563	9d4f2b67-05be-4ada-bd61-6ecab23cbcef	9d4f2b67-06ed-43d9-8e90-d694c5aae77a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-22 16:46:01
4192	9d51291a-c231-4589-8d08-70462d7b1b4c	9d51291b-d7d9-4dea-9956-4a58c090b2b6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"59.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":46,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 16:31:15
4193	9d51291b-d666-47c6-9c30-dc7df1ac7893	9d51291b-d7d9-4dea-9956-4a58c090b2b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 16:31:16
7111	9d52dab9-8870-4a72-a6f5-cddc99f66d5b	9d52dab9-8e6e-4440-be16-2e72b28c65cb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:43:44
7112	9d52dab9-88c3-4257-8768-6a5cc3ef2d0c	9d52dab9-8e6e-4440-be16-2e72b28c65cb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:43:44
7113	9d52dab9-8d35-4cfa-b94d-d8e2d4fd735b	9d52dab9-8e6e-4440-be16-2e72b28c65cb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-24 12:43:44
17574	9d655e40-0079-4fa5-b7a4-a64f797fac59	9d655e40-260d-4be2-8727-a2598dea0340	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 17:36:25
564	9d4f2b67-0603-4742-9f95-eef002095e5c	9d4f2b67-06ed-43d9-8e90-d694c5aae77a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"411","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"name":"Maria Antonieta","email":"andre_01@gmail.com","user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_photo":null,"user_state":null,"profile_code":5,"user_age":"31","password":"********","verification_token":"kIjQivxy2DrF6h1ZN0cWyeQAdxrjRcDNgbu86LLFqAXAbslVrT9nfQ1Aigds"},"session":[],"response_status":200,"response":{"user":{"name":"Maria Antonieta","email":"andre_01@gmail.com","user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","profile_code":5,"user_age":"31","updated_at":"2024-10-22T21:46:01.000000Z","created_at":"2024-10-22T21:46:01.000000Z","id":18}},"duration":271,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:46:01
353	9d4f26bf-bb40-4449-8611-6c2185305ccc	9d4f26c0-02be-426e-b376-ce2cad679e01	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 16:33:00
354	9d4f26bf-ff2e-4311-9ec1-16b32c5c82bd	9d4f26c0-02be-426e-b376-ce2cad679e01	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:33:00
355	9d4f26c0-0116-4f82-8ee1-92aacf4ed4dd	9d4f26c0-02be-426e-b376-ce2cad679e01	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":526,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:33:00
356	9d4f26c1-d61b-432e-8695-abcea0c5ff13	9d4f26c1-fced-4a93-97f1-c2a6c146c2e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:33:02
357	9d4f26c1-f460-4566-8864-bb57e45985eb	9d4f26c1-fced-4a93-97f1-c2a6c146c2e3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"53.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:33:02
358	9d4f26c1-f4ce-4fad-bba3-5e6192623380	9d4f26c1-fced-4a93-97f1-c2a6c146c2e3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:33:02
359	9d4f26c1-fb79-43ed-b955-29b3b0665404	9d4f26c1-fced-4a93-97f1-c2a6c146c2e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:33:02
360	9d4f26c1-fbca-4d1b-8e27-dff6a07c7465	9d4f26c1-fced-4a93-97f1-c2a6c146c2e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"dashboard\\/list-neighborhood"}]},"duration":388,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:33:02
6368	9d5264f5-e34a-4d6a-920e-d523eb17c8e9	9d5264f6-0725-4441-a7c6-242695efe067	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 07:14:27
524	9d4f2a04-672d-4826-9f72-210c33e13948	9d4f2a04-83d8-4487-bd39-b3cd2f022baf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-22 16:42:09
525	9d4f2a04-7e8c-484a-98de-1eeeab18281e	9d4f2a04-83d8-4487-bd39-b3cd2f022baf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"38.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:42:09
526	9d4f2a04-7eee-4350-a00f-fe6b5e77e61d	9d4f2a04-83d8-4487-bd39-b3cd2f022baf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:42:09
527	9d4f2a04-8259-4dff-afb5-42ba7c2b6b17	9d4f2a04-83d8-4487-bd39-b3cd2f022baf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-22 16:42:09
528	9d4f2a04-82a8-41b7-9fd0-e8c36c42acdf	9d4f2a04-83d8-4487-bd39-b3cd2f022baf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":312,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:42:09
4194	9d51291b-d6c2-416c-a9a2-7837c955bfbf	9d51291b-d7d9-4dea-9956-4a58c090b2b6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":2019,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:31:16
494	9d4f29d2-dfb8-4dcd-9911-35a5b14f67b6	9d4f29d2-fd4c-4a68-9558-0ddb14daa6e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:41:36
495	9d4f29d2-fbb6-4f7a-9a16-a0f705b3595e	9d4f29d2-fd4c-4a68-9558-0ddb14daa6e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 16:41:36
496	9d4f29d2-fc5b-4be9-981c-d6a87c2e1a9a	9d4f29d2-fd4c-4a68-9558-0ddb14daa6e1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:41:36
6369	9d5264f6-015c-44aa-ac32-84a0e6f1ca1a	9d5264f6-0725-4441-a7c6-242695efe067	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"50.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 07:14:27
1613	9d50d7e3-eefa-4a47-9d32-920ff91ca6f4	9d50d7e3-f1e1-4e65-b51e-98a245469537	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":161,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:44:09
6370	9d5264f6-01b5-4fa3-a65f-907255e8846d	9d5264f6-0725-4441-a7c6-242695efe067	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 07:14:27
533	9d4f2a73-b1b2-406d-b30e-6774e6478a5e	9d4f2a73-d8f9-4b80-ba13-d5f2ba74b91b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:43:22
534	9d4f2a73-d097-4d37-b987-995481eee167	9d4f2a73-d8f9-4b80-ba13-d5f2ba74b91b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"48.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:43:22
535	9d4f2a73-d107-40da-9f22-bf6587d19abd	9d4f2a73-d8f9-4b80-ba13-d5f2ba74b91b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:43:22
536	9d4f2a73-d710-40bf-957c-5f8afb084a53	9d4f2a73-d8f9-4b80-ba13-d5f2ba74b91b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:43:22
537	9d4f2a73-d797-4875-8a53-0a7d4a4f314c	9d4f2a73-d8f9-4b80-ba13-d5f2ba74b91b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":372,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:43:22
6371	9d5264f6-0591-42d0-a056-e49a942817d7	9d5264f6-0725-4441-a7c6-242695efe067	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 07:14:27
6372	9d5264f6-05df-4987-bef3-ccde2a7efa43	9d5264f6-0725-4441-a7c6-242695efe067	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":305,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:14:27
10967	9d5ca6df-eb50-4012-90f6-a6682a9d4625	9d5ca6df-f031-4cb7-8f3d-b674b2d9245d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 09:37:02
497	9d4f29d4-7874-4e1a-b533-d594cfbdf566	9d4f29d4-984c-4f9b-bf3a-1761c1eb4fd5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 16:41:37
498	9d4f29d4-92e9-4c61-b945-71fa1b6a552c	9d4f29d4-984c-4f9b-bf3a-1761c1eb4fd5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"40.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:41:37
499	9d4f29d4-9337-43b8-80dd-58fffbc5094b	9d4f29d4-984c-4f9b-bf3a-1761c1eb4fd5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:41:37
500	9d4f29d4-96e3-4b10-b93e-63b5f98d0bcc	9d4f29d4-984c-4f9b-bf3a-1761c1eb4fd5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 16:41:37
501	9d4f29d4-972e-4f2a-ad81-b5d59ee6f349	9d4f29d4-984c-4f9b-bf3a-1761c1eb4fd5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":423,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:41:37
1741	9d50dd7e-82f0-4692-bbcc-730da5510044	9d50dd7e-83d8-4cc7-8197-9efa5e4d3f46	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":327,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:59:50
1332	9d50cb88-7904-4962-a476-b3dec74d43f4	9d50cb88-7a08-4fd0-a470-c529f98aa27e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:09:36
1614	9d50d7e4-6653-458b-ba47-38a09cd8ccd0	9d50d7e4-ac31-423f-bccf-388c07fa078e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 12:44:10
1615	9d50d7e4-a871-4c28-a8cb-07c0e3511d4e	9d50d7e4-ac31-423f-bccf-388c07fa078e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"name\\", \\"users\\".\\"user_document\\", \\"users\\".\\"id\\" from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%8333%' or \\"users\\".\\"user_document\\"::text like '%8333%' order by \\"users\\".\\"user_document\\" asc","time":"153.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"71e2e94a1a5a1b5c9b9dc051aea4b922","hostname":"EderCortes"}	2024-10-23 12:44:10
1616	9d50d7e4-ab15-4b96-af84-4a7e64bd4284	9d50d7e4-ac31-423f-bccf-388c07fa078e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 12:44:10
1617	9d50d7e4-ab54-4fa7-abc7-8e95d6d7e2b2	9d50d7e4-ac31-423f-bccf-388c07fa078e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"8333"},"session":[],"response_status":200,"response":{"data":[{"name":"Eder Arley","user_document":"1004608333","id":12},{"name":"Luis andre","user_document":"100465545","id":14}]},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:44:10
2189	9d50e4f6-c28d-4858-bc29-cec2d0266bdb	9d50e4f6-c5aa-42f6-85c3-15df1ec24853	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":168,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:20:43
362	9d4f26e3-851d-4e01-8b2f-dfbfa58cfe8c	9d4f26e3-a4c0-40a5-b247-fca2e21ceaae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:33:24
363	9d4f26e3-a306-4710-b62e-b9e1bcd838e3	9d4f26e3-a4c0-40a5-b247-fca2e21ceaae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 16:33:24
364	9d4f26e3-a3d6-46e2-885d-90691435646d	9d4f26e3-a4c0-40a5-b247-fca2e21ceaae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":262,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:33:24
365	9d4f26e4-f430-498f-a610-e803eaba6f77	9d4f26e5-3f2b-442d-a35e-6d4ab03af493	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 16:33:25
366	9d4f26e5-397f-4d3a-bf0c-41c2424a3109	9d4f26e5-3f2b-442d-a35e-6d4ab03af493	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"154.46","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:33:25
367	9d4f26e5-39cf-4d66-9cea-516a71a88d98	9d4f26e5-3f2b-442d-a35e-6d4ab03af493	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:33:25
368	9d4f26e5-3dc2-42bf-bd55-2b999a17cba8	9d4f26e5-3f2b-442d-a35e-6d4ab03af493	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 16:33:25
369	9d4f26e5-3e0e-4aa5-adf5-70a0428d55a0	9d4f26e5-3f2b-442d-a35e-6d4ab03af493	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"dashboard\\/list-neighborhood"}]},"duration":468,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:33:25
2872	9d50fca2-4b11-45d5-b709-ec0ecf30d1c4	9d50fca2-5001-4b4d-9dc4-5e4a134366cd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"158.66","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:26:54
1618	9d50d80f-4bc7-4950-a162-d2beb24ea048	9d50d80f-4ec2-4f0b-a8f0-5e4f527ed801	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":160,"memory":20,"hostname":"EderCortes"}	2024-10-23 12:44:38
1742	9d50dd7f-afe6-4129-97db-d0f010d047ff	9d50dd7f-dbcc-4173-a99a-3118aaf76d0f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 12:59:50
1743	9d50dd7f-d54f-40a7-89b4-b2472d44915d	9d50dd7f-dbcc-4173-a99a-3118aaf76d0f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"59.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 12:59:50
1744	9d50dd7f-d5cc-4f34-9261-98c7f5fb8a1f	9d50dd7f-dbcc-4173-a99a-3118aaf76d0f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 12:59:50
1745	9d50dd7f-da21-44f8-8b17-f61880e00ab5	9d50dd7f-dbcc-4173-a99a-3118aaf76d0f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 12:59:50
1746	9d50dd7f-daca-419c-ac6b-a71c8497a2a2	9d50dd7f-dbcc-4173-a99a-3118aaf76d0f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":452,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:59:50
6373	9d526503-21df-4102-b3f3-5b9b93e6286e	9d526503-25a7-4cb4-9044-7dd2f104ef70	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":164,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:14:35
4195	9d51291c-3888-4012-866b-f7b2aca919de	9d51291c-7ef7-438f-9c10-85554ed59e27	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 16:31:16
654	9d4f2d9d-87f4-481e-9e7a-79c1dc118b5c	9d4f2d9d-a661-44ff-ac3a-31cdee0807ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 16:52:12
655	9d4f2d9d-a4ed-41c7-9945-da02151de8dd	9d4f2d9d-a661-44ff-ac3a-31cdee0807ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 16:52:12
656	9d4f2d9d-a585-44b2-a774-2e874e0bc797	9d4f2d9d-a661-44ff-ac3a-31cdee0807ed	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":257,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:52:12
4196	9d51291c-79d7-4ac9-a1c4-f152965fa83e	9d51291c-7ef7-438f-9c10-85554ed59e27	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"149.18","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":46,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 16:31:16
9147	9d52f445-4f65-44c4-9aa8-e42e35b58dde	9d52f445-5024-4961-bcc2-f27fe350d086	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":524,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:55:10
9682	9d569f00-8fc6-44d5-a364-8431620dde8b	9d569f02-05e4-4325-85a2-888d3b02144e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":596,"memory":18,"hostname":"EderCortes"}	2024-10-26 09:40:04
10744	9d57206e-c57d-40f6-8fe5-e50fad743cf3	9d57206e-ca5d-4524-8dd2-015411f17582	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"48.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-26 15:41:58
1619	9d50d810-068e-4ec5-a357-63bbfc0b1d1b	9d50d810-26fb-48c7-966c-dc3656b02a7c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 12:44:38
4197	9d51291c-7dc9-44f6-8ef5-8ee3606e8fe1	9d51291c-7ef7-438f-9c10-85554ed59e27	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 16:31:16
4198	9d51291c-7e09-4854-ae0c-343631ab0098	9d51291c-7ef7-438f-9c10-85554ed59e27	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":418,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:31:16
10745	9d57206e-c907-40bc-b1f2-e1d27d8070dd	9d57206e-ca5d-4524-8dd2-015411f17582	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-26 15:41:58
10968	9d5ca6df-eba3-4e21-9819-823eb22a819e	9d5ca6df-f031-4cb7-8f3d-b674b2d9245d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 09:37:02
10969	9d5ca6df-eefc-4e6a-921d-cecb6c5dec06	9d5ca6df-f031-4cb7-8f3d-b674b2d9245d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 09:37:02
17790	9d65add9-f162-470c-93ce-03c469e57213	9d65adda-43f3-49ac-a969-d87d1058c27b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 21:18:59
657	9d4f2d9d-eda6-4b8a-b056-56bbf4aea2a4	9d4f2d9e-0d61-4474-89db-696135157ee1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 16:52:13
658	9d4f2d9e-07fc-427e-9bc4-4e79a7fdfe99	9d4f2d9e-0d61-4474-89db-696135157ee1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"42.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-22 16:52:13
659	9d4f2d9e-0850-412e-9c1f-289bf863fc90	9d4f2d9e-0d61-4474-89db-696135157ee1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":3,"hostname":"EderCortes"}	2024-10-22 16:52:13
660	9d4f2d9e-0c2e-47f4-8ac3-6eb128a908f5	9d4f2d9e-0d61-4474-89db-696135157ee1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-22 16:52:13
661	9d4f2d9e-0c7b-4e94-9fe5-3156e23a7e1b	9d4f2d9e-0d61-4474-89db-696135157ee1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:52:13
4199	9d51291c-d005-4a81-9f56-1bc50f90f117	9d51291c-edb2-44eb-9101-4a73c239dbcb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 16:31:16
2873	9d50fca2-4b5f-413e-a087-1b4213ea4dc9	9d50fca2-5001-4b4d-9dc4-5e4a134366cd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:26:54
780	9d4f2ef9-7ba1-4c6e-a234-fd81800ac3dc	9d4f2ef9-a9d1-46e8-b7a6-221c8d92c45c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 16:56:00
781	9d4f2ef9-a76f-48cd-b6f0-0a5cf3ab8d09	9d4f2ef9-a9d1-46e8-b7a6-221c8d92c45c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:56:00
782	9d4f2ef9-a84f-457e-bc8b-2400cd4d90d1	9d4f2ef9-a9d1-46e8-b7a6-221c8d92c45c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":344,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:56:00
1747	9d50dd84-d076-463a-8514-63d209b98d27	9d50dd84-d332-4a25-a4ae-bc50ad059c86	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":159,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:59:54
2190	9d50e4f7-820f-41b0-9f44-5526fe76917a	9d50e4f7-9de5-4942-b904-ff079ecb6685	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 13:20:43
2191	9d50e4f7-995f-452f-9f25-5ecee5027411	9d50e4f7-9de5-4942-b904-ff079ecb6685	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder%' or \\"users\\".\\"user_document\\"::text like '%eder%' order by \\"users\\".\\"user_document\\" asc","time":"43.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:20:43
2192	9d50e4f7-9c77-47f6-8e94-9b0bf3b45b0c	9d50e4f7-9de5-4942-b904-ff079ecb6685	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 13:20:43
2193	9d50e4f7-9cc3-40b2-aca1-0c8317208ed9	9d50e4f7-9de5-4942-b904-ff079ecb6685	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:20:43
2874	9d50fca2-4edd-422e-a1d3-de9099139d8d	9d50fca2-5001-4b4d-9dc4-5e4a134366cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 14:26:54
2875	9d50fca2-4f20-43da-9beb-da89a2cfefa8	9d50fca2-5001-4b4d-9dc4-5e4a134366cd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":369,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:26:54
6374	9d526503-8f57-44c2-9abe-5ce9d9b19aff	9d526503-d97b-4f42-a656-d05ed86ab3f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 07:14:36
662	9d4f2d9f-d86b-4446-8cec-73b2d2dd1eaf	9d4f2d9f-f9b2-432b-b1bc-877f3ab78986	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-22 16:52:14
371	9d4f26f1-2979-4660-9129-ea813f104c8f	9d4f26f1-471a-4a9a-81bb-703dfdacbf24	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 16:33:33
372	9d4f26f1-45a2-4d58-b46b-cc32308f2259	9d4f26f1-471a-4a9a-81bb-703dfdacbf24	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-22 16:33:33
373	9d4f26f1-463d-4ebe-91b1-2b65bbc9563c	9d4f26f1-471a-4a9a-81bb-703dfdacbf24	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":268,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:33:33
374	9d4f26f2-d840-48df-9d55-fdc9d99da481	9d4f26f3-21b9-4050-a3dc-27f9376347a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-22 16:33:34
375	9d4f26f3-1bc4-47bc-afb0-8ea9ca282035	9d4f26f3-21b9-4050-a3dc-27f9376347a1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"152.17","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:33:34
376	9d4f26f3-1c12-4fbe-a067-3bf73d83979d	9d4f26f3-21b9-4050-a3dc-27f9376347a1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:33:34
377	9d4f26f3-2060-4835-acd4-2dff6290d0f1	9d4f26f3-21b9-4050-a3dc-27f9376347a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-22 16:33:34
378	9d4f26f3-20aa-4466-8773-fbd5a0594bb0	9d4f26f3-21b9-4050-a3dc-27f9376347a1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"dashboard\\/list-neighborhood"}]},"duration":385,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:33:34
449	9d4f290c-43c7-4adb-9909-80029d159b8a	9d4f290c-62b1-4b54-963f-1c57b297eff5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:39:26
450	9d4f290c-6103-416c-9f30-829d1208604b	9d4f290c-62b1-4b54-963f-1c57b297eff5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 16:39:26
451	9d4f290c-61bb-4453-b7fb-02bb61162383	9d4f290c-62b1-4b54-963f-1c57b297eff5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":271,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:39:26
663	9d4f2d9f-f2ed-490e-8598-7cae4bfd0832	9d4f2d9f-f9b2-432b-b1bc-877f3ab78986	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"45.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:52:14
664	9d4f2d9f-f348-4119-8c27-bd5736d771e9	9d4f2d9f-f9b2-432b-b1bc-877f3ab78986	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:52:14
665	9d4f2d9f-f80a-4f1c-b77d-7fc02d9dfed6	9d4f2d9f-f9b2-432b-b1bc-877f3ab78986	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-22 16:52:14
666	9d4f2d9f-f879-4838-a671-0fcfb871e652	9d4f2d9f-f9b2-432b-b1bc-877f3ab78986	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":390,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:52:14
783	9d4f2efa-12ca-4d45-8f97-11ba50bd6055	9d4f2efa-3736-4bb6-a108-4728ff6f5972	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:56:01
784	9d4f2efa-2f3b-4a32-be76-e438b09f5785	9d4f2efa-3736-4bb6-a108-4728ff6f5972	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"46.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-22 16:56:01
785	9d4f2efa-2fb3-44da-9267-ba0dee298c45	9d4f2efa-3736-4bb6-a108-4728ff6f5972	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":3,"hostname":"EderCortes"}	2024-10-22 16:56:01
786	9d4f2efa-3579-4dca-ba3b-926c058170f4	9d4f2efa-3736-4bb6-a108-4728ff6f5972	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:56:01
1218	9d50c5e2-bd24-409a-88ca-c82c75d7d1df	9d50c5e2-dc56-4b91-9390-858eaca2f2e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 11:53:49
1219	9d50c5e2-d679-4445-b4d0-5f1a4b45f7be	9d50c5e2-dc56-4b91-9390-858eaca2f2e1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 11:53:49
452	9d4f290d-b976-4f4e-a0b1-74a5f85efb99	9d4f290d-dadf-40b0-8e94-b90202783d1d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 16:39:27
453	9d4f290d-d2b5-4cd1-8674-1662d7d8b186	9d4f290d-dadf-40b0-8e94-b90202783d1d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"42.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:39:27
454	9d4f290d-d305-4036-8d6c-8d0bb0e48382	9d4f290d-dadf-40b0-8e94-b90202783d1d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:39:27
455	9d4f290d-d956-4c09-8eda-ba24005d9805	9d4f290d-dadf-40b0-8e94-b90202783d1d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 16:39:27
456	9d4f290d-d9a7-4869-896a-384931a0ee57	9d4f290d-dadf-40b0-8e94-b90202783d1d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":491,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:39:27
787	9d4f2efa-35ef-40b2-bd8f-1e6b5809ab05	9d4f2efa-3736-4bb6-a108-4728ff6f5972	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":337,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:56:01
467	9d4f2934-405d-406a-ae53-adc984b813e6	9d4f2934-5e26-4011-be69-224bea2088e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-22 16:39:52
468	9d4f2934-5c34-458b-9383-ee202c19c649	9d4f2934-5e26-4011-be69-224bea2088e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-22 16:39:52
469	9d4f2934-5d15-4d9f-bf77-934df4c36f67	9d4f2934-5e26-4011-be69-224bea2088e7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:39:52
4200	9d51291c-e966-4840-ba7a-af64206f8f58	9d51291c-edb2-44eb-9101-4a73c239dbcb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"45.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":46,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 16:31:16
4201	9d51291c-ec8e-495d-8af3-9513cdda6fbd	9d51291c-edb2-44eb-9101-4a73c239dbcb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 16:31:16
4202	9d51291c-ecd2-4a2a-ba07-06eda1a2bfa8	9d51291c-edb2-44eb-9101-4a73c239dbcb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":263,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:31:16
6375	9d526503-d2d5-4ccb-86cd-43076e0609a5	9d526503-d97b-4f42-a656-d05ed86ab3f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Luis%' or \\"users\\".\\"user_document\\"::text like '%Luis%' order by \\"users\\".\\"user_document\\" asc","time":"148.74","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":71,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-24 07:14:36
6376	9d526503-d81b-4723-a71a-5ce9a140aa6e	9d526503-d97b-4f42-a656-d05ed86ab3f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 07:14:36
19533	9d66e029-82a9-4cef-baa5-9ccfaa6d3874	9d66e029-c3dd-4422-9a50-ed365acfddbf	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 11:35:30
18889	9d66a239-ebe8-4e18-a3a6-da43aaca206f	9d66a239-f031-4be5-a6b8-3529ea1e0689	\N	t	command	{"command":"make:command","exit_code":0,"arguments":{"command":"make:command","name":"UpdateLoanInterest"},"options":{"force":false,"command":null,"test":false,"pest":false,"help":false,"quiet":false,"verbose":false,"version":false,"ansi":null,"no-interaction":false,"env":null},"hostname":"EderCortes"}	2024-11-03 08:42:19
9683	9d569f04-5b69-4192-a43d-fa5477353145	9d569f08-3ecf-41c7-ab19-8d8015e32569	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 09:40:06
788	9d4f2efc-282a-442c-8fcd-57e03ebec13c	9d4f2efc-4e59-4ba1-8cbd-88b8fb6f723d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:56:02
789	9d4f2efc-455f-4693-88f6-c1a304f3c60f	9d4f2efc-4e59-4ba1-8cbd-88b8fb6f723d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"50.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:56:02
790	9d4f2efc-4600-4ea3-a66c-6630a60c237c	9d4f2efc-4e59-4ba1-8cbd-88b8fb6f723d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:56:02
791	9d4f2efc-4caa-451c-bb44-32b9717a167a	9d4f2efc-4e59-4ba1-8cbd-88b8fb6f723d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 16:56:02
470	9d4f2935-d284-44e4-b97a-fa90070472c8	9d4f2936-1c44-4af7-8889-a5f2f90f6435	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-22 16:39:53
792	9d4f2efc-4d21-4265-848a-51936f155b2b	9d4f2efc-4e59-4ba1-8cbd-88b8fb6f723d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:56:02
1748	9d50dd85-32c0-4949-9a8d-cbb7df2c4472	9d50dd85-4cf7-41ed-bc08-b9d4236efb2a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 12:59:54
1620	9d50d810-21ae-4d4d-ae36-de6932c35808	9d50d810-26fb-48c7-966c-dc3656b02a7c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"name\\", \\"users\\".\\"user_document\\", \\"users\\".\\"id\\" from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder%' or \\"users\\".\\"user_document\\"::text like '%eder%' order by \\"users\\".\\"user_document\\" asc","time":"40.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"71e2e94a1a5a1b5c9b9dc051aea4b922","hostname":"EderCortes"}	2024-10-23 12:44:38
1220	9d50c5e2-d6c8-4930-aeca-1784ac5bf4fe	9d50c5e2-dc56-4b91-9390-858eaca2f2e1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 11:53:49
1221	9d50c5e2-dabb-4b8b-8ccf-3b5371a19e8a	9d50c5e2-dc56-4b91-9390-858eaca2f2e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 11:53:49
1222	9d50c5e2-db02-4509-8766-ced03aae2c50	9d50c5e2-dc56-4b91-9390-858eaca2f2e1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":319,"memory":22,"hostname":"EderCortes"}	2024-10-23 11:53:49
1621	9d50d810-256f-460c-aaed-cb69cc538df3	9d50d810-26fb-48c7-966c-dc3656b02a7c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:44:38
1622	9d50d810-25c7-4ef8-8e4c-71fcfe950ba7	9d50d810-26fb-48c7-966c-dc3656b02a7c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder"},"session":[],"response_status":200,"response":{"data":[{"name":"Luis andre","user_document":"100465545","id":14}]},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:44:38
1749	9d50dd85-490d-456c-97c6-f63570fbdd33	9d50dd85-4cf7-41ed-bc08-b9d4236efb2a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"name\\", \\"users\\".\\"user_document\\", \\"users\\".\\"id\\" from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder%' or \\"users\\".\\"user_document\\"::text like '%eder%' order by \\"users\\".\\"user_document\\" asc","time":"40.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"71e2e94a1a5a1b5c9b9dc051aea4b922","hostname":"EderCortes"}	2024-10-23 12:59:54
1750	9d50dd85-4bcb-4ca0-9312-71518028423d	9d50dd85-4cf7-41ed-bc08-b9d4236efb2a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 12:59:54
1810	9d50df2f-d408-4df7-95d5-8b76b52d077e	9d50df2f-f37a-4ada-b0dc-ea5cfc579c99	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 13:04:33
2876	9d50fca3-e3c9-4434-88eb-244ee662151c	9d50fca4-192e-463a-9d4a-3eabb762b112	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 14:26:55
1623	9d50d81d-6c8b-4c91-92d4-1e18137571bc	9d50d81d-6f6f-4163-876d-774c8624a35f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":178,"memory":20,"hostname":"EderCortes"}	2024-10-23 12:44:47
1811	9d50df2f-ee3f-401c-aa10-18855a261f54	9d50df2f-f37a-4ada-b0dc-ea5cfc579c99	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:04:34
380	9d4f2737-2711-426c-a885-dee6f9a0bcd0	9d4f2737-54f1-4157-8f75-81a1983ff124	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 16:34:19
381	9d4f2737-5212-4e5d-806b-a4d04ce07d07	9d4f2737-54f1-4157-8f75-81a1983ff124	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:34:19
382	9d4f2737-5347-4edc-aafe-9da2301acf5b	9d4f2737-54f1-4157-8f75-81a1983ff124	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":343,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:34:19
383	9d4f2738-bf3b-4a53-90e6-a90469c8b3ac	9d4f2738-e6eb-489a-ae81-e8eeaf954f06	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:34:20
384	9d4f2738-de00-400e-b04a-34f2db9ff04b	9d4f2738-e6eb-489a-ae81-e8eeaf954f06	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"47.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:34:20
385	9d4f2738-de62-4a11-ae9c-2a5c847aa88a	9d4f2738-e6eb-489a-ae81-e8eeaf954f06	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:34:20
386	9d4f2738-e4f0-4a1d-89fb-0257e3cfb6f2	9d4f2738-e6eb-489a-ae81-e8eeaf954f06	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:34:20
387	9d4f2738-e566-42dd-9c70-eff6ef958fde	9d4f2738-e6eb-489a-ae81-e8eeaf954f06	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"dashboard\\/list-neighborhood"}]},"duration":487,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:34:20
471	9d4f2936-170e-4e02-b4f9-a73110c156e2	9d4f2936-1c44-4af7-8889-a5f2f90f6435	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"153.11","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:39:53
472	9d4f2936-176d-4aa7-80dd-78991ddb3781	9d4f2936-1c44-4af7-8889-a5f2f90f6435	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:39:53
473	9d4f2936-1b05-4ced-a990-efe091cf72a3	9d4f2936-1c44-4af7-8889-a5f2f90f6435	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-22 16:39:53
930	9d4f38b3-da37-49e1-83b1-3258ace229ca	9d4f38b4-0e61-4eb7-bbcd-814eaf5b3e21	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 17:23:12
1223	9d50c5f4-49b9-4f65-96c5-fb48497dd516	9d50c5f4-e276-47a5-a777-b8ed45fcdb28	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 11:54:00
1224	9d50c5f4-dca6-402d-9d57-7efafc688fe3	9d50c5f4-e276-47a5-a777-b8ed45fcdb28	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"40.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-23 11:54:01
1225	9d50c5f4-dcf5-4c71-8bd2-10ef6abc3f26	9d50c5f4-e276-47a5-a777-b8ed45fcdb28	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":3,"hostname":"EderCortes"}	2024-10-23 11:54:01
1226	9d50c5f4-e113-4566-9fa5-2c5b16e3bc45	9d50c5f4-e276-47a5-a777-b8ed45fcdb28	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 11:54:01
1227	9d50c5f4-e16b-4819-ba09-94b8e89667c1	9d50c5f4-e276-47a5-a777-b8ed45fcdb28	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":673,"memory":22,"hostname":"EderCortes"}	2024-10-23 11:54:01
4203	9d51291d-42ec-40c7-925b-c2e8d554c93c	9d51291d-8d05-4f9d-92c6-3f7fd7e37357	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 16:31:16
6377	9d526503-d868-4c75-9588-7d04a21e8ce1	9d526503-d97b-4f42-a656-d05ed86ab3f0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Luis"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":380,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:14:36
4204	9d51291d-88a7-4569-9f4e-15f1aa5a6cd9	9d51291d-8d05-4f9d-92c6-3f7fd7e37357	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"158.43","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":46,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 16:31:17
503	9d4f29e5-1b34-4e5e-bce4-09bbb16737a8	9d4f29e5-608e-41f9-bacd-9c5d3f779537	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 16:41:48
504	9d4f29e5-5f0f-4bd0-abf0-669accf81a51	9d4f29e5-608e-41f9-bacd-9c5d3f779537	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-22 16:41:48
505	9d4f29e5-5fab-4efe-8a52-8d278bd65a95	9d4f29e5-608e-41f9-bacd-9c5d3f779537	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":328,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:41:48
9684	9d569f06-f37e-4482-a7be-2aa025f6a2f1	9d569f08-3ecf-41c7-ab19-8d8015e32569	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"77.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-26 09:40:07
9685	9d569f06-f446-4ce2-8f25-493734e7da87	9d569f08-3ecf-41c7-ab19-8d8015e32569	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-26 09:40:07
566	9d4f2c5a-5ade-4946-ac46-2c18778da5fc	9d4f2c5a-931a-4b06-a737-42014a94632e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 16:48:40
9686	9d569f08-3d26-4bdf-87da-493a4f4b2a79	9d569f08-3ecf-41c7-ab19-8d8015e32569	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 09:40:08
4205	9d51291d-8baf-49a0-81d0-86beeadd116c	9d51291d-8d05-4f9d-92c6-3f7fd7e37357	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 16:31:17
4206	9d51291d-8bfd-4522-91f5-f8349e1d67c5	9d51291d-8d05-4f9d-92c6-3f7fd7e37357	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":398,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:31:17
9687	9d569f08-3d86-4ab9-a43c-e1492fb5b728	9d569f08-3ecf-41c7-ab19-8d8015e32569	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","profile":1},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":3801,"memory":24,"hostname":"EderCortes"}	2024-10-26 09:40:08
10300	9d56cd49-2b2f-4ad9-bfa1-ad3312c912d5	9d56cd49-3016-4d1f-9625-e0ec63f5e94d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"50.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:49:28
506	9d4f29e7-0bc6-47ec-aa36-e8a360b8f5f7	9d4f29e7-299e-4520-a2a2-9508606f933e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-22 16:41:49
507	9d4f29e7-24f4-4e99-aed7-2f0bd3aebc61	9d4f29e7-299e-4520-a2a2-9508606f933e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"41.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:41:49
508	9d4f29e7-254e-4912-bcbe-2aac2f05a0d7	9d4f29e7-299e-4520-a2a2-9508606f933e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:41:49
509	9d4f29e7-2875-40c4-b155-16089528bb1b	9d4f29e7-299e-4520-a2a2-9508606f933e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-22 16:41:49
510	9d4f29e7-28ba-4c11-90ad-c1018c618c3c	9d4f29e7-299e-4520-a2a2-9508606f933e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":303,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:41:49
567	9d4f2c5a-906c-4a5b-9c0e-cf7102db1d34	9d4f2c5a-931a-4b06-a737-42014a94632e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:48:41
568	9d4f2c5a-916d-4ccc-8819-9c76b92d467a	9d4f2c5a-931a-4b06-a737-42014a94632e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":461,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:48:41
931	9d4f38b4-0afc-4236-930a-1b1e877d8f67	9d4f38b4-0e61-4eb7-bbcd-814eaf5b3e21	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 17:23:13
932	9d4f38b4-0c96-46cf-b4bd-7be6ba0e3493	9d4f38b4-0e61-4eb7-bbcd-814eaf5b3e21	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":504,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:23:13
2194	9d50e4f7-e1ec-4eff-bef6-c6bd5e9e1fe8	9d50e4f7-e4e0-407b-9ad0-dbf93c6b99fe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":152,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:20:43
1812	9d50df2f-eea3-4f1b-a8a1-c203eefcc199	9d50df2f-f37a-4ada-b0dc-ea5cfc579c99	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 13:04:34
1624	9d50d81e-21a9-4194-a9f4-b4849f23fd81	9d50d81e-3c57-4d71-999e-05d7047e4bc5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:44:47
1625	9d50d81e-3850-4803-8ecc-385943a9eb9a	9d50d81e-3c57-4d71-999e-05d7047e4bc5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"name\\", \\"users\\".\\"user_document\\", \\"users\\".\\"id\\" from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"42.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"71e2e94a1a5a1b5c9b9dc051aea4b922","hostname":"EderCortes"}	2024-10-23 12:44:48
1626	9d50d81e-3b2f-4532-9eba-7f0d097d8ac9	9d50d81e-3c57-4d71-999e-05d7047e4bc5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:44:48
1627	9d50d81e-3b71-4848-aa79-0586a2ad7db2	9d50d81e-3c57-4d71-999e-05d7047e4bc5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"name":"Eder Arley","user_document":"1004608333","id":12},{"name":"Luis andre","user_document":"100465545","id":14}]},"duration":208,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:44:48
1813	9d50df2f-f220-4e28-843b-f637931b3633	9d50df2f-f37a-4ada-b0dc-ea5cfc579c99	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 13:04:34
1814	9d50df2f-f263-4e6b-b085-c728add377eb	9d50df2f-f37a-4ada-b0dc-ea5cfc579c99	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":228,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:04:34
4207	9d512923-799d-4310-ae32-7a15ab4ec3ed	9d512924-6e9b-41f0-ae31-3d119335c421	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 16:31:21
569	9d4f2c5c-bf3b-4733-a0e4-d0f89382635b	9d4f2c5c-e3b0-4ab1-b332-a7feff41551c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:48:42
570	9d4f2c5c-dc2b-4a00-9d8b-114682f02d6e	9d4f2c5c-e3b0-4ab1-b332-a7feff41551c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"47.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:48:42
571	9d4f2c5c-dc84-45ed-96c5-ee9d319294f7	9d4f2c5c-e3b0-4ab1-b332-a7feff41551c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:48:42
572	9d4f2c5c-e1eb-4837-a3ad-ebd91a096ad8	9d4f2c5c-e3b0-4ab1-b332-a7feff41551c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:48:42
389	9d4f278c-2de2-47f4-b6f7-0f79d7ee3d4e	9d4f278c-7bec-4a3e-b0f9-29e5dafec093	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:35:14
390	9d4f278c-7a46-4f48-83ee-64ef9b11f588	9d4f278c-7bec-4a3e-b0f9-29e5dafec093	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 16:35:14
391	9d4f278c-7ae9-4693-bc08-bed9d93b6761	9d4f278c-7bec-4a3e-b0f9-29e5dafec093	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":406,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:35:14
573	9d4f2c5c-e25b-40d3-94c5-3e675386cc68	9d4f2c5c-e3b0-4ab1-b332-a7feff41551c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":401,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:48:42
6378	9d526506-df8d-4cd6-8fc8-456652913b39	9d526507-2cf5-4244-a0ee-cae3d50cd992	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 07:14:38
862	9d4f3297-06bb-4785-97c2-27c5dadc15fc	9d4f3297-5cac-4b2f-96a4-a6b96a6e2ced	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 17:06:07
863	9d4f3297-5a49-4a79-a5f5-e8040542d62d	9d4f3297-5cac-4b2f-96a4-a6b96a6e2ced	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 17:06:07
864	9d4f3297-5b63-4511-96fe-462344368b79	9d4f3297-5cac-4b2f-96a4-a6b96a6e2ced	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":444,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:06:07
933	9d4f38b6-2eca-4c29-9a2b-95259f6e7c69	9d4f38b6-5a0a-4467-8c5b-d561d8994da0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 17:23:14
4208	9d512924-5267-42b5-91a2-1cb6c2c281b1	9d512924-6e9b-41f0-ae31-3d119335c421	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:31:21
912	9d4f3480-f615-4f26-ab6b-92f90cfd959c	9d4f3481-1a83-4a33-b630-ccba9aeff4a8	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 17:11:28
913	9d4f3481-18a4-4daf-8a64-8db850326658	9d4f3481-1a83-4a33-b630-ccba9aeff4a8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 17:11:28
914	9d4f3481-1967-4384-945f-d61ffd44b44c	9d4f3481-1a83-4a33-b630-ccba9aeff4a8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":271,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:11:28
6379	9d526507-26a3-4982-be89-977762f21365	9d526507-2cf5-4244-a0ee-cae3d50cd992	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '18' and \\"users\\".\\"deleted_at\\" is null","time":"151.71","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":53,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-24 07:14:38
4209	9d512924-52b9-4384-9534-56eb07ff639b	9d512924-6e9b-41f0-ae31-3d119335c421	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 16:31:21
4210	9d512924-6d5b-4f64-b77f-17c978dc74db	9d512924-6e9b-41f0-ae31-3d119335c421	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 16:31:21
6380	9d526507-2701-4416-8ca2-1f935bec756b	9d526507-2cf5-4244-a0ee-cae3d50cd992	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 07:14:38
6381	9d526507-2b92-4cf5-a5b3-d878c1724074	9d526507-2cf5-4244-a0ee-cae3d50cd992	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 07:14:38
6382	9d526507-2bfd-4cdb-a82c-9ff3b4f94618	9d526507-2cf5-4244-a0ee-cae3d50cd992	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/18","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}},"duration":427,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:14:38
9688	9d569f09-b3ab-4ce5-9f05-7509b064cce2	9d569f09-ee83-4d8a-ac4a-75438dab3249	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 09:40:09
10301	9d56cd49-2eaf-4983-84eb-8e2d41056efd	9d56cd49-3016-4d1f-9625-e0ec63f5e94d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 11:49:28
9689	9d569f09-e6e0-45cd-9629-9b8dbb52abb6	9d569f09-ee83-4d8a-ac4a-75438dab3249	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"59.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 09:40:09
4211	9d512924-6d9f-4320-ac4a-1a4cdcfb8a67	9d512924-6e9b-41f0-ae31-3d119335c421	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":820,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:31:21
6383	9d526526-7d1c-4e99-95c9-44885332a5ac	9d526526-834e-43c3-8a8d-b2a708e6a714	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":232,"memory":20,"hostname":"EderCortes"}	2024-10-24 07:14:59
458	9d4f291e-f929-4584-9580-ae516800196b	9d4f291f-1803-4209-863f-8d7ff5c61a9c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 16:39:38
459	9d4f291f-1683-4357-bdf0-796bf0fd3d06	9d4f291f-1803-4209-863f-8d7ff5c61a9c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-22 16:39:38
460	9d4f291f-1721-485e-b2fb-3a9c6d631f08	9d4f291f-1803-4209-863f-8d7ff5c61a9c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":248,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:39:38
9690	9d569f09-e733-4f50-b50f-f0accf1e500a	9d569f09-ee83-4d8a-ac4a-75438dab3249	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 09:40:09
9130	9d52f442-2364-47da-a7d0-58941f56a29b	9d52f442-2444-4ea9-8213-8cb6b4af1be2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:55:08
865	9d4f3299-620e-4db0-a084-b2d2ad3b7386	9d4f3299-923f-4683-9737-0e4b14d26e25	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 17:06:08
9691	9d569f09-ec3e-4e62-8082-356f019d0912	9d569f09-ee83-4d8a-ac4a-75438dab3249	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 09:40:09
9692	9d569f09-ecb2-41b2-a3a3-a6fe9bc3e21f	9d569f09-ee83-4d8a-ac4a-75438dab3249	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":595,"memory":22,"hostname":"EderCortes"}	2024-10-26 09:40:09
10302	9d56cd49-2f0c-492d-bdf9-033ee1582387	9d56cd49-3016-4d1f-9625-e0ec63f5e94d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:49:28
461	9d4f2920-b8a9-4703-98ec-a4c2ab2bb6bf	9d4f2920-fef1-41a7-896d-89603ec321aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-22 16:39:39
462	9d4f2920-f90c-4f40-9036-b921b5dd61f3	9d4f2920-fef1-41a7-896d-89603ec321aa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"141.16","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:39:40
463	9d4f2920-f96a-4517-aae9-355ae61be49e	9d4f2920-fef1-41a7-896d-89603ec321aa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:39:40
464	9d4f2920-fd59-46bb-8127-0b6bc5986c4f	9d4f2920-fef1-41a7-896d-89603ec321aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-22 16:39:40
465	9d4f2920-fdb6-481b-9574-d1259ec9766d	9d4f2920-fef1-41a7-896d-89603ec321aa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":408,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:39:40
474	9d4f2936-1b4a-4ec4-a8db-bf9dcee72a67	9d4f2936-1c44-4af7-8889-a5f2f90f6435	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":550,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:39:53
866	9d4f3299-892e-4918-9691-1c62e99ab178	9d4f3299-923f-4683-9737-0e4b14d26e25	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"59.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 17:06:09
867	9d4f3299-89b7-4c02-90a0-9cc7b6869981	9d4f3299-923f-4683-9737-0e4b14d26e25	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 17:06:09
868	9d4f3299-9019-431d-a253-52e49fa6add0	9d4f3299-923f-4683-9737-0e4b14d26e25	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 17:06:09
869	9d4f3299-90a0-4465-8c0c-5864e77c704a	9d4f3299-923f-4683-9737-0e4b14d26e25	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"}]},"duration":517,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:06:09
915	9d4f3482-d163-41d4-9b2e-999714543e08	9d4f3482-fd3d-44da-8bdc-a758254c680a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 17:11:29
916	9d4f3482-f4f8-42aa-aafe-d8cb1ce53a19	9d4f3482-fd3d-44da-8bdc-a758254c680a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"51.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-22 17:11:29
917	9d4f3482-f557-4136-8fcf-4ee2d3480dd9	9d4f3482-fd3d-44da-8bdc-a758254c680a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 17:11:29
918	9d4f3482-fb89-49c5-ada9-cac2f331484f	9d4f3482-fd3d-44da-8bdc-a758254c680a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 17:11:29
1632	9d50d844-9072-4512-b12f-1ca49e2b1c06	9d50d844-d86b-45da-a708-4d602e80d123	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:45:13
934	9d4f38b6-508e-47c8-8be6-e6bbe9b5c91c	9d4f38b6-5a0a-4467-8c5b-d561d8994da0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"54.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-22 17:23:14
935	9d4f38b6-50fe-4595-a527-60b30ec2fe87	9d4f38b6-5a0a-4467-8c5b-d561d8994da0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 17:23:14
936	9d4f38b6-584a-46fe-89c4-be9fab424b90	9d4f38b6-5a0a-4467-8c5b-d561d8994da0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 17:23:14
937	9d4f38b6-58bb-4749-8f6a-7ba9ca28da9d	9d4f38b6-5a0a-4467-8c5b-d561d8994da0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":547,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:23:14
479	9d4f2945-c29f-4119-9cf6-05c2ee8526bc	9d4f2945-e0b2-4770-af59-aab4d545ec96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-22 16:40:04
2195	9d50e4f8-5f37-4260-a2f0-b1be290d6178	9d50e4f8-6215-42cc-aec0-b8f65b7089c6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":145,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:20:44
1751	9d50dd85-4c0b-473b-bd7f-96fcff23c7f4	9d50dd85-4cf7-41ed-bc08-b9d4236efb2a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder"},"session":[],"response_status":200,"response":{"data":[{"name":"Luis andre","user_document":"100465545","id":14}]},"duration":213,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:59:54
1633	9d50d844-d28b-4273-babf-95a9f36cf2f1	9d50d844-d86b-45da-a708-4d602e80d123	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"146.03","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":65,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:45:13
1634	9d50d844-d2ee-47a0-a622-7de5a835b422	9d50d844-d86b-45da-a708-4d602e80d123	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 12:45:13
1635	9d50d844-d72e-4dc1-9d58-524557457a47	9d50d844-d86b-45da-a708-4d602e80d123	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 12:45:13
1636	9d50d844-d777-4eb0-baa4-837a532bd7f1	9d50d844-d86b-45da-a708-4d602e80d123	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":326,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:45:13
1815	9d50df30-3db6-45c1-bbc4-ffd81d8ae639	9d50df30-5ee6-4b2f-a9dd-6b52917a8770	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 13:04:34
1816	9d50df30-579e-48a2-b7bd-fa6d15c47934	9d50df30-5ee6-4b2f-a9dd-6b52917a8770	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:04:34
1817	9d50df30-580c-49d9-a78d-8744b7305a0f	9d50df30-5ee6-4b2f-a9dd-6b52917a8770	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 13:04:34
1818	9d50df30-5d9c-4e5a-a5e5-f90f054b374c	9d50df30-5ee6-4b2f-a9dd-6b52917a8770	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 13:04:34
6384	9d526526-fa11-4147-86aa-95886cbbc736	9d526527-501c-4590-b842-284f84901fc3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 07:14:59
9131	9d52f442-7118-44ce-b5c6-44b3fff3f9f4	9d52f442-90b9-40db-b672-083d5178da0f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:55:08
1752	9d50dd8e-1408-4211-8a0f-0bbccd44d8b8	9d50dd8e-170e-45c8-9530-0bd1e700f4b0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":169,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:00:00
1011	9d4f3cee-97cc-4880-8a60-0f719864db28	9d4f3cee-fba4-4c02-b60e-5da02a7a9681	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 17:35:02
393	9d4f278c-d059-4e1e-ac0a-f1e8d08da5cc	9d4f278d-1d67-48b4-b230-fae8eac84c6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 16:35:15
394	9d4f278d-1bde-4f43-bf79-98dc4409788f	9d4f278d-1d67-48b4-b230-fae8eac84c6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 16:35:15
395	9d4f278d-1c85-47a2-9212-a198dd407dfd	9d4f278d-1d67-48b4-b230-fae8eac84c6b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":393,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:35:15
396	9d4f278e-cbaf-426a-b816-7e094da95fdc	9d4f278e-ea39-44fb-83f2-0f8dff22f2d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 16:35:16
397	9d4f278e-e341-4284-91e3-605bcec96d77	9d4f278e-ea39-44fb-83f2-0f8dff22f2d5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"39.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:35:16
398	9d4f278e-e38e-48c3-a330-3aac86e1def7	9d4f278e-ea39-44fb-83f2-0f8dff22f2d5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:35:16
399	9d4f278e-e705-4aa1-8c3e-4de8d30aa83b	9d4f278e-ea39-44fb-83f2-0f8dff22f2d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-22 16:35:16
400	9d4f278e-e74e-47de-ad0c-bd02b11e848b	9d4f278e-ea39-44fb-83f2-0f8dff22f2d5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"dashboard\\/list-neighborhood"}]},"duration":268,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:35:16
480	9d4f2945-db4a-4010-b13f-23685f708c31	9d4f2945-e0b2-4770-af59-aab4d545ec96	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"42.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:40:04
481	9d4f2945-db95-4b39-9b23-f6edc1e4719f	9d4f2945-e0b2-4770-af59-aab4d545ec96	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:40:04
482	9d4f2945-df68-4a99-840e-d2e933de44d3	9d4f2945-e0b2-4770-af59-aab4d545ec96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-22 16:40:04
1012	9d4f3cee-f792-4e09-963b-c52067fc600e	9d4f3cee-fba4-4c02-b60e-5da02a7a9681	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 17:35:02
1013	9d4f3cee-f93e-4f37-bd52-298e29821e55	9d4f3cee-fba4-4c02-b60e-5da02a7a9681	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":598,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:35:02
1637	9d50d845-138b-41f7-9433-99a311a129a0	9d50d845-2fd7-4000-aec8-5068c2799a6c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 12:45:13
1638	9d50d845-2b05-4cf5-9bb0-9170751522d8	9d50d845-2fd7-4000-aec8-5068c2799a6c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":65,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:45:13
1639	9d50d845-2b52-44d1-91c2-304270f8fffa	9d50d845-2fd7-4000-aec8-5068c2799a6c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 12:45:13
1640	9d50d845-2e9c-41ce-a982-a2a453ffb69e	9d50d845-2fd7-4000-aec8-5068c2799a6c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 12:45:13
1641	9d50d845-2ede-40b5-906d-1eafbe520112	9d50d845-2fd7-4000-aec8-5068c2799a6c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":210,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:45:13
1014	9d4f3cef-e332-4eb1-96d7-4a532228d2c3	9d4f3cf0-340e-4884-8598-cd717066d6c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 17:35:03
1015	9d4f3cf0-2864-405f-b5c9-dfede2fa1e37	9d4f3cf0-340e-4884-8598-cd717066d6c8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"95.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-22 17:35:03
1016	9d4f3cf0-28ff-4e1f-a85d-b1cc1122b147	9d4f3cf0-340e-4884-8598-cd717066d6c8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-22 17:35:03
1017	9d4f3cf0-3198-47c7-a5bd-1590fd89f1bf	9d4f3cf0-340e-4884-8598-cd717066d6c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 17:35:03
1018	9d4f3cf0-3271-49a7-959b-583dfef2067b	9d4f3cf0-340e-4884-8598-cd717066d6c8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":761,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:35:03
2877	9d50fca4-0f53-4be8-9a63-4a6b791da4ae	9d50fca4-192e-463a-9d4a-3eabb762b112	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"73.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:26:55
1753	9d50dd8e-ca3b-4195-b270-b98ba91779c7	9d50dd8f-0d9d-420b-bac2-07aa4710cc3d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 13:00:00
1642	9d50d846-55e8-4d19-a3e3-7bc7248b87bc	9d50d846-7444-4923-9bee-09f77fa0c870	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 12:45:14
1096	9d4f3ed5-cbf6-4222-9dec-a531929decf5	9d4f3ed5-f9a9-4ec1-91cb-ab20cd8e3aca	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 17:40:21
1097	9d4f3ed5-f73d-4a7e-aa78-0ccde9a291dd	9d4f3ed5-f9a9-4ec1-91cb-ab20cd8e3aca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 17:40:21
1643	9d50d846-6fab-4cd0-8c93-dc91ae382fdb	9d50d846-7444-4923-9bee-09f77fa0c870	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 12:45:14
1644	9d50d846-6ff0-4e70-a6d1-fc7b2b86998c	9d50d846-7444-4923-9bee-09f77fa0c870	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 12:45:14
1645	9d50d846-72fd-4c53-9414-cbcded941294	9d50d846-7444-4923-9bee-09f77fa0c870	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 12:45:14
1646	9d50d846-733d-49dd-b84b-c35e8d641cc2	9d50d846-7444-4923-9bee-09f77fa0c870	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:45:14
1754	9d50dd8f-091d-46bf-acf4-87051ed97437	9d50dd8f-0d9d-420b-bac2-07aa4710cc3d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"name\\", \\"users\\".\\"user_document\\", \\"users\\".\\"id\\" from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder%' or \\"users\\".\\"user_document\\"::text like '%eder%' order by \\"users\\".\\"user_document\\" asc","time":"145.57","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"71e2e94a1a5a1b5c9b9dc051aea4b922","hostname":"EderCortes"}	2024-10-23 13:00:00
1755	9d50dd8f-0c73-44e3-9744-6b8c8454e677	9d50dd8f-0d9d-420b-bac2-07aa4710cc3d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 13:00:00
1756	9d50dd8f-0cb4-4e50-96c6-0d5e553bac4a	9d50dd8f-0d9d-420b-bac2-07aa4710cc3d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder"},"session":[],"response_status":200,"response":{"data":[{"name":"Luis andre","user_document":"100465545","id":14}]},"duration":320,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:00:00
6385	9d526527-440a-4cb4-8ad6-303301c2bcac	9d526527-501c-4590-b842-284f84901fc3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta', 'De las nieve', 'ds', 'CC', '100465546', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '100000', 40, 3, 'D', null, 'Thu Oct 24 2024', 'Pendiente', 12, 14, 18, '2024-10-24 07:14:59', '2024-10-24 07:14:59') returning \\"id\\"","time":"5.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"18efcd076c06e51570dcc83643e19328","hostname":"EderCortes"}	2024-10-24 07:14:59
1098	9d4f3ed5-f83b-4cc9-b61a-188eb50f4130	9d4f3ed5-f9a9-4ec1-91cb-ab20cd8e3aca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:40:21
1019	9d4f3cf0-cf86-4c6e-bc12-1890f66097fe	9d4f3cf0-fecc-4f1b-a844-e92d2f7d466e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 17:35:03
668	9d4f2dad-d05d-44f3-808d-b962d7b2b8a0	9d4f2dad-effa-4853-b883-9c97f01306b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-22 16:52:23
669	9d4f2dad-ee39-4f87-97e9-b1037a58df14	9d4f2dad-effa-4853-b883-9c97f01306b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-22 16:52:23
670	9d4f2dad-eee7-4a92-9648-ea2f044d3f76	9d4f2dad-effa-4853-b883-9c97f01306b4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":257,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:52:23
1020	9d4f3cf0-f66f-4194-877f-973400ccd50b	9d4f3cf0-fecc-4f1b-a844-e92d2f7d466e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"63.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-22 17:35:04
1021	9d4f3cf0-f6e4-4fe3-88dd-5a70611891ad	9d4f3cf0-fecc-4f1b-a844-e92d2f7d466e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-22 17:35:04
6386	9d526527-44c0-48c1-b9e1-a6d2f512fed3	9d526527-501c-4590-b842-284f84901fc3	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:11","hostname":"EderCortes"}	2024-10-24 07:14:59
1022	9d4f3cf0-fcd5-4e20-bb58-03bb8dcc7990	9d4f3cf0-fecc-4f1b-a844-e92d2f7d466e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 17:35:04
1023	9d4f3cf0-fd5c-4a26-86f4-9584cfdbf961	9d4f3cf0-fecc-4f1b-a844-e92d2f7d466e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":495,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:35:04
1757	9d50dd8f-a063-4c64-8be8-33a2bb353382	9d50dd8f-a3c7-4a65-9b69-54c13806a7b6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":143,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:00:01
2878	9d50fca4-0fce-4a05-b350-1c7165094c2b	9d50fca4-192e-463a-9d4a-3eabb762b112	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:26:55
2879	9d50fca4-172d-43f9-8a3a-8cab8c3e5f49	9d50fca4-192e-463a-9d4a-3eabb762b112	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 14:26:55
2880	9d50fca4-17b9-4dab-a30c-b4ecfb4d2ab9	9d50fca4-192e-463a-9d4a-3eabb762b112	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":405,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:26:55
6387	9d526527-46c8-472d-bf51-19f4634311d2	9d526527-501c-4590-b842-284f84901fc3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (11, 1, 33333.333333333, 3333.3333333333, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 07:14:59', '2024-10-24 07:14:59')","time":"2.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":121,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 07:14:59
6388	9d526527-4707-434b-8c6f-f1fe72d388e3	9d526527-501c-4590-b842-284f84901fc3	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 07:14:59
9132	9d52f442-8b1d-44a9-9849-dea732ce6054	9d52f442-90b9-40db-b672-083d5178da0f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:55:08
671	9d4f2dae-3af4-4aea-975c-6a5c7aa1b8a6	9d4f2dae-5a18-44b1-b2be-736d839f182d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-22 16:52:23
672	9d4f2dae-54d8-46b7-8c18-f3ae36951e5a	9d4f2dae-5a18-44b1-b2be-736d839f182d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"41.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-22 16:52:23
673	9d4f2dae-5527-453f-be0f-e2addfc04e0d	9d4f2dae-5a18-44b1-b2be-736d839f182d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":3,"hostname":"EderCortes"}	2024-10-22 16:52:23
512	9d4f29f4-3746-4dba-9c7b-e5ae871f5ef6	9d4f29f4-5a98-40b0-a6ec-e84c180560fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-22 16:41:58
513	9d4f29f4-5859-40c1-91e8-be91f73d3aef	9d4f29f4-5a98-40b0-a6ec-e84c180560fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-22 16:41:58
514	9d4f29f4-59a9-499d-8d30-d56873583cae	9d4f29f4-5a98-40b0-a6ec-e84c180560fa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":305,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:41:58
674	9d4f2dae-5907-4681-bb17-92a3ecde3dc7	9d4f2dae-5a18-44b1-b2be-736d839f182d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-22 16:52:23
675	9d4f2dae-5952-41b4-9899-3fd7854f9e83	9d4f2dae-5a18-44b1-b2be-736d839f182d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:52:23
1024	9d4f3cf2-ff9d-49e2-afb6-d05b97ef6573	9d4f3cf3-310c-4308-a55c-79061dfb6cab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 17:35:05
1025	9d4f3cf3-25cb-4cc8-98b7-c42d1328bd0f	9d4f3cf3-310c-4308-a55c-79061dfb6cab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"70.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-22 17:35:05
1026	9d4f3cf3-2652-44e8-a85d-a75581f8503b	9d4f3cf3-310c-4308-a55c-79061dfb6cab	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 17:35:05
1027	9d4f3cf3-2f61-48f2-933a-5b9998b5967a	9d4f3cf3-310c-4308-a55c-79061dfb6cab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 17:35:05
1028	9d4f3cf3-2fc4-41df-b85c-065225861ec4	9d4f3cf3-310c-4308-a55c-79061dfb6cab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":492,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:35:05
1099	9d4f3ed6-64df-49dd-bdf1-b0712f95462f	9d4f3ed6-86d8-42fa-9ef3-54f7bde72756	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 17:40:22
1100	9d4f3ed6-811e-47ef-b2c7-13c6e957f282	9d4f3ed6-86d8-42fa-9ef3-54f7bde72756	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-22 17:40:22
1101	9d4f3ed6-8177-4ea0-a062-a79f16eb8239	9d4f3ed6-86d8-42fa-9ef3-54f7bde72756	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-22 17:40:22
1102	9d4f3ed6-85a0-4a8d-8a74-b288941b02ff	9d4f3ed6-86d8-42fa-9ef3-54f7bde72756	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 17:40:22
1103	9d4f3ed6-85e9-4d07-97b2-b254987ebc11	9d4f3ed6-86d8-42fa-9ef3-54f7bde72756	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:40:22
1758	9d50dd90-5904-4887-8e5c-53c1581e698e	9d50dd90-73d1-49be-b08b-d7487b13fe78	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 13:00:01
9133	9d52f442-8b6d-48cc-9254-31f89c937115	9d52f442-90b9-40db-b672-083d5178da0f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:55:08
9134	9d52f442-8f90-4efb-a707-f8f695ff2470	9d52f442-90b9-40db-b672-083d5178da0f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:55:08
9693	9d569f1a-96c4-4a12-b734-2364740c88d9	9d569f1a-b5ee-47e6-8bc5-26c6575d5c1d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 09:40:20
515	9d4f29f5-e0bd-40c1-9bed-f26bc90cae2c	9d4f29f5-ff57-4f7a-add4-5c943ccfa613	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-22 16:41:59
516	9d4f29f5-f9cd-4f91-a64d-926c26fb7c91	9d4f29f5-ff57-4f7a-add4-5c943ccfa613	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"41.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:41:59
517	9d4f29f5-fa22-4244-b7e2-926209fa6a2f	9d4f29f5-ff57-4f7a-add4-5c943ccfa613	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:41:59
402	9d4f2799-7607-4a8b-a38f-1a4aef9d8371	9d4f2799-9ba9-41f6-968e-c7cbb29d588e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 16:35:23
403	9d4f2799-99b5-4479-bbd2-b4ab9e0d67b6	9d4f2799-9ba9-41f6-968e-c7cbb29d588e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:35:23
404	9d4f2799-9a8e-48b9-918d-07de1e21f52f	9d4f2799-9ba9-41f6-968e-c7cbb29d588e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":277,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:35:23
405	9d4f279a-d8bc-4127-a981-0b763f1a92c8	9d4f279b-1f1a-4537-8c4b-618715185ba0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:35:24
406	9d4f279b-1940-4da0-86ef-e1af4c8e12ac	9d4f279b-1f1a-4537-8c4b-618715185ba0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"142.59","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:35:24
407	9d4f279b-199c-4abd-a8b5-a3f84f4cb4ae	9d4f279b-1f1a-4537-8c4b-618715185ba0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:35:24
408	9d4f279b-1dc2-49e6-87c9-c26169bfee04	9d4f279b-1f1a-4537-8c4b-618715185ba0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:35:24
518	9d4f29f5-fde2-4876-8f15-7cb40df31ea8	9d4f29f5-ff57-4f7a-add4-5c943ccfa613	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-22 16:41:59
519	9d4f29f5-fe2d-401a-8c77-936163f1a81f	9d4f29f5-ff57-4f7a-add4-5c943ccfa613	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":528,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:41:59
676	9d4f2daf-abce-4ac3-92ed-53b3dd7ace0d	9d4f2db0-0c34-46e0-a1a7-c1391672e0b7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-22 16:52:24
677	9d4f2db0-0749-471f-8deb-97dcfa3abcdc	9d4f2db0-0c34-46e0-a1a7-c1391672e0b7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"145.36","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:52:24
678	9d4f2db0-07a2-4263-88d6-bba880e007cb	9d4f2db0-0c34-46e0-a1a7-c1391672e0b7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:52:24
679	9d4f2db0-0aea-4fba-aa63-ccfdce3e7342	9d4f2db0-0c34-46e0-a1a7-c1391672e0b7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-22 16:52:24
680	9d4f2db0-0b33-4495-9ca3-57e5a0a4174b	9d4f2db0-0c34-46e0-a1a7-c1391672e0b7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":642,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:52:24
794	9d4f2f26-9f89-432f-beee-dd5e05634b46	9d4f2f26-c0d5-41ff-ac76-464c625c239b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 16:56:30
795	9d4f2f26-bee7-444c-900e-5d5401ef2461	9d4f2f26-c0d5-41ff-ac76-464c625c239b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 16:56:30
796	9d4f2f26-bf8e-40fc-a2e9-15ab3713a794	9d4f2f26-c0d5-41ff-ac76-464c625c239b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":283,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:56:30
1104	9d4f3ed6-d79a-42f0-8499-7345d10a71d0	9d4f3ed7-2243-4aff-bb40-35149e3b4038	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 17:40:22
1105	9d4f3ed7-1ace-4925-a60d-b86c40ddbc30	9d4f3ed7-2243-4aff-bb40-35149e3b4038	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"148.07","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-22 17:40:22
409	9d4f279b-1e0c-4b75-a124-1c5bade16ec6	9d4f279b-1f1a-4537-8c4b-618715185ba0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"dashboard\\/list-neighborhood"}]},"duration":519,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:35:24
410	9d4f27b3-4450-46f4-b87f-a29b7a884bbc	9d4f27b3-61a8-46bd-b65e-88ec6fbdbb99	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:35:40
411	9d4f27b3-5c45-4b8c-aa34-47f410757cc4	9d4f27b3-61a8-46bd-b65e-88ec6fbdbb99	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = 2 and \\"menu\\".\\"deleted_at\\" is null","time":"42.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:35:40
412	9d4f27b3-5ca6-4566-bae0-c827958fee19	9d4f27b3-61a8-46bd-b65e-88ec6fbdbb99	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":3,"hostname":"EderCortes"}	2024-10-22 16:35:40
413	9d4f27b3-6054-4ff9-b471-713da7813b3c	9d4f27b3-61a8-46bd-b65e-88ec6fbdbb99	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 16:35:40
414	9d4f27b3-60a0-463e-9232-9c934c47d2b4	9d4f27b3-61a8-46bd-b65e-88ec6fbdbb99	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"dashboard\\/list-precautions"}]},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:35:40
415	9d4f27b4-c0d7-4d24-b510-31cb98f44c68	9d4f27b4-de3f-4c95-94a5-eb9ce9c544cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 16:35:41
416	9d4f27b4-d996-48b1-aca5-73310b1ab16a	9d4f27b4-de3f-4c95-94a5-eb9ce9c544cf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = 2 and \\"menu\\".\\"deleted_at\\" is null","time":"42.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:35:41
417	9d4f27b4-d9e3-4d86-aa0b-b3476d804835	9d4f27b4-de3f-4c95-94a5-eb9ce9c544cf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":3,"hostname":"EderCortes"}	2024-10-22 16:35:41
418	9d4f27b4-dd13-47d2-8a7e-25f7a16e3fba	9d4f27b4-de3f-4c95-94a5-eb9ce9c544cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 16:35:41
419	9d4f27b4-dd56-4cfe-98c5-0f75754e0c45	9d4f27b4-de3f-4c95-94a5-eb9ce9c544cf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"dashboard\\/list-precautions"}]},"duration":222,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:35:41
797	9d4f2f27-0d74-4cfa-afff-da84d6a9dd3a	9d4f2f27-591b-4089-a0ab-2b43af2f258d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 16:56:30
798	9d4f2f27-53bc-4ac1-9d70-afe0f026e899	9d4f2f27-591b-4089-a0ab-2b43af2f258d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"149.62","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-22 16:56:30
799	9d4f2f27-540b-483d-866b-b67c23010577	9d4f2f27-591b-4089-a0ab-2b43af2f258d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":3,"hostname":"EderCortes"}	2024-10-22 16:56:30
800	9d4f2f27-57b8-49ae-b323-d2470e8615b7	9d4f2f27-591b-4089-a0ab-2b43af2f258d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-22 16:56:30
801	9d4f2f27-581b-44f8-9732-eba5b04df9a1	9d4f2f27-591b-4089-a0ab-2b43af2f258d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":364,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:56:30
1106	9d4f3ed7-1b36-4d36-88dc-b7da17c4bf0e	9d4f3ed7-2243-4aff-bb40-35149e3b4038	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-22 17:40:22
802	9d4f2f28-74b4-4316-9d68-07577b484c54	9d4f2f28-9e29-4fc3-80d7-032c97f6614f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-22 16:56:31
803	9d4f2f28-957e-48b9-bf9e-c3b422d2e597	9d4f2f28-9e29-4fc3-80d7-032c97f6614f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"51.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:56:31
804	9d4f2f28-9609-441b-9299-4d0163b35cdc	9d4f2f28-9e29-4fc3-80d7-032c97f6614f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:56:31
805	9d4f2f28-9bce-4b4c-85f3-67de40c0a7da	9d4f2f28-9e29-4fc3-80d7-032c97f6614f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-22 16:56:31
575	9d4f2cc1-fcab-4007-a8f1-4608dc9e1226	9d4f2cc2-4fb2-4af4-9669-6d0218829174	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 16:49:48
576	9d4f2cc2-4ce1-4e7c-a11f-e80854950da9	9d4f2cc2-4fb2-4af4-9669-6d0218829174	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:49:49
577	9d4f2cc2-4e1b-4078-917e-9f0b16f393a0	9d4f2cc2-4fb2-4af4-9669-6d0218829174	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":451,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:49:49
806	9d4f2f28-9c45-418f-a3ba-de479dab855f	9d4f2f28-9e29-4fc3-80d7-032c97f6614f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":439,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:56:31
2196	9d50e4f8-adea-4865-a188-14cf19598b94	9d50e4f8-b12f-4a76-b767-3bdcd77dad7f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":131,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:20:44
1115	9d4f442c-7764-42ee-8c66-bc83ef67abb1	9d4f442c-d429-46df-b650-2afbcfdee067	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 17:55:17
1107	9d4f3ed7-207b-4e98-bb27-6b22c610124d	9d4f3ed7-2243-4aff-bb40-35149e3b4038	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 17:40:22
1108	9d4f3ed7-210e-491d-b63a-eaaa8b92633e	9d4f3ed7-2243-4aff-bb40-35149e3b4038	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":383,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:40:22
1116	9d4f442c-d0cf-4a4d-9644-1fc76f7d774a	9d4f442c-d429-46df-b650-2afbcfdee067	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 17:55:17
1117	9d4f442c-d273-4d1f-a86f-5ba570edcfef	9d4f442c-d429-46df-b650-2afbcfdee067	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":679,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:55:17
1759	9d50dd90-6fa2-4505-8610-ba4793e45f31	9d50dd90-73d1-49be-b08b-d7487b13fe78	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"name\\", \\"users\\".\\"user_document\\", \\"users\\".\\"id\\" from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder c%' or \\"users\\".\\"user_document\\"::text like '%eder c%' order by \\"users\\".\\"user_document\\" asc","time":"42.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"71e2e94a1a5a1b5c9b9dc051aea4b922","hostname":"EderCortes"}	2024-10-23 13:00:01
1760	9d50dd90-729f-4135-9e2b-810fad83dd5c	9d50dd90-73d1-49be-b08b-d7487b13fe78	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 13:00:01
1761	9d50dd90-72e3-43c7-ad9f-cf7c703af95d	9d50dd90-73d1-49be-b08b-d7487b13fe78	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"28","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder c"},"session":[],"response_status":200,"response":{"data":[{"name":"Luis andre","user_document":"100465545","id":14}]},"duration":217,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:00:01
10303	9d56cd4a-c73a-41de-a1bd-74417317517a	9d56cd4a-f024-45d1-b7d0-392da6cc8b6a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 11:49:29
20128	9d66ee86-0656-4746-b5e1-d10952c418f2	9d66ee86-4f66-4237-a146-78a94a0d3eba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 12:15:39
578	9d4f2cc4-413c-4aac-a4a6-5b0e9966d98e	9d4f2cc4-9229-4736-b79d-e2ac666a2039	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:49:50
579	9d4f2cc4-88a9-49ad-b557-e766d783f5b3	9d4f2cc4-9229-4736-b79d-e2ac666a2039	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"157.72","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:49:50
580	9d4f2cc4-892a-4afe-a47f-1bc7e2e91a59	9d4f2cc4-9229-4736-b79d-e2ac666a2039	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:49:50
581	9d4f2cc4-9082-4beb-8dbd-c4533e36bb1e	9d4f2cc4-9229-4736-b79d-e2ac666a2039	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:49:50
582	9d4f2cc4-90eb-43c7-b5cc-2b5328397fef	9d4f2cc4-9229-4736-b79d-e2ac666a2039	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":498,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:49:50
7114	9d52dab9-8d87-420a-bb88-39383e139327	9d52dab9-8e6e-4440-be16-2e72b28c65cb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:43:44
20231	9d66f057-7474-4ab1-86a7-3f3e928f2efd	9d66f057-9636-4bd8-9926-e97e0fe35c95	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:20:44
6389	9d526527-47a5-4b86-88b1-7096b75e9445	9d526527-501c-4590-b842-284f84901fc3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (11, 2, 33333.333333333, 3333.3333333333, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 07:14:59', '2024-10-24 07:14:59')","time":"0.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":121,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 07:14:59
1109	9d4f3ed8-e991-48f5-8770-8ef7d14aa68b	9d4f3ed9-36ed-4544-9d60-6a8863ccb426	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 17:40:23
1118	9d4f442d-5ea2-447d-ab13-0e632e1b524d	9d4f442d-84b5-404f-8373-32820095878c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 17:55:18
1110	9d4f3ed9-316e-4de4-8b21-f4fc17e7e42a	9d4f3ed9-36ed-4544-9d60-6a8863ccb426	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"163.23","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-22 17:40:23
1111	9d4f3ed9-31bf-42a6-b295-2eeee8544bcf	9d4f3ed9-36ed-4544-9d60-6a8863ccb426	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 17:40:23
1112	9d4f3ed9-3592-4717-a3a9-d7734d20239d	9d4f3ed9-36ed-4544-9d60-6a8863ccb426	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 17:40:23
1119	9d4f442d-7d14-42da-bcda-b316538f71f0	9d4f442d-84b5-404f-8373-32820095878c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"51.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-22 17:55:18
6390	9d526527-47d6-4f0b-b3de-122c93b27389	9d526527-501c-4590-b842-284f84901fc3	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 07:14:59
6391	9d526527-486a-49a2-90d0-434103cea68e	9d526527-501c-4590-b842-284f84901fc3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (11, 3, 33333.333333333, 3333.3333333333, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 07:14:59', '2024-10-24 07:14:59')","time":"0.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":121,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 07:14:59
6392	9d526527-48a9-4e56-9925-68a40379a381	9d526527-501c-4590-b842-284f84901fc3	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 07:14:59
1120	9d4f442d-7d8e-4137-803b-dfc269de76e1	9d4f442d-84b5-404f-8373-32820095878c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-22 17:55:18
1121	9d4f442d-8344-4589-8105-a390d0bd4307	9d4f442d-84b5-404f-8373-32820095878c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 17:55:18
1122	9d4f442d-83aa-41db-8c4f-f5cace2972d3	9d4f442d-84b5-404f-8373-32820095878c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":418,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:55:18
6393	9d526527-4e41-4136-97f8-e666d863a250	9d526527-501c-4590-b842-284f84901fc3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 07:14:59
601	9d4f2d2c-1f74-415b-abb7-dd16b81f7e54	9d4f2d2c-44ee-4e76-ba80-fc3b6f34b338	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:50:58
602	9d4f2d2c-3cba-4640-b33a-d7e896fba4a2	9d4f2d2c-44ee-4e76-ba80-fc3b6f34b338	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"47.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-22 16:50:58
6394	9d526527-4ea9-47c5-83c6-e89a67bf828c	9d526527-501c-4590-b842-284f84901fc3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"619","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"100465546","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"100000","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_cobrador":14,"user_customer":18},"detail":{"status":false,"observacion":"N\\/A","fecha_pago":"Thu Oct 24 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":11},"duration":435,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:14:59
9694	9d569f1a-b019-445e-ac56-82a9228517b2	9d569f1a-b5ee-47e6-8bc5-26c6575d5c1d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"42.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-26 09:40:20
9695	9d569f1a-b06b-486d-b422-4b0c735d10c3	9d569f1a-b5ee-47e6-8bc5-26c6575d5c1d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-10-26 09:40:20
7115	9d52dab9-d2fa-407d-aab7-9d64841d02ca	9d52dab9-f098-48f8-8cbc-367885f37edf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-24 12:43:44
7116	9d52dab9-ea11-4707-86db-53acc37c5799	9d52dab9-f098-48f8-8cbc-367885f37edf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"41.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:43:44
7117	9d52dab9-ea63-4d11-9584-f0d4045accd4	9d52dab9-f098-48f8-8cbc-367885f37edf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:43:44
7118	9d52dab9-ebe0-410c-8a38-6d1d225656e2	9d52dab9-f098-48f8-8cbc-367885f37edf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"1.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:43:44
7119	9d52dab9-ec19-4df7-85d6-da640d8c0b26	9d52dab9-f098-48f8-8cbc-367885f37edf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:43:44
7120	9d52dab9-ef5b-4906-aa09-8d0b906383b6	9d52dab9-f098-48f8-8cbc-367885f37edf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-24 12:43:44
7121	9d52dab9-ef9f-4afc-836e-688c90e7c9fe	9d52dab9-f098-48f8-8cbc-367885f37edf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:43:44
9696	9d569f1a-b413-4782-b525-3f198f7a17f2	9d569f1a-b5ee-47e6-8bc5-26c6575d5c1d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 09:40:20
13130	9d5cf980-c4f0-4bbf-803b-b6e64104ed2c	9d5cf980-cbdb-449c-a3d2-474eb541f3fe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"151.07","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 13:28:05
1123	9d4f442d-da50-4e78-9f03-b7d428f82de9	9d4f442e-23d7-4000-b418-94d26e8ac991	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 17:55:18
1124	9d4f442e-1f42-460d-b9bf-49536aab8ec6	9d4f442e-23d7-4000-b418-94d26e8ac991	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"150.74","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-22 17:55:18
919	9d4f3482-fbe9-4d19-8a48-f87ca1a47118	9d4f3482-fd3d-44da-8bdc-a758254c680a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":383,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:11:29
1125	9d4f442e-1f9d-433c-9d41-5ada7a7079e6	9d4f442e-23d7-4000-b418-94d26e8ac991	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-22 17:55:18
603	9d4f2d2c-3d2d-408b-828b-128e037eebb7	9d4f2d2c-44ee-4e76-ba80-fc3b6f34b338	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":3,"hostname":"EderCortes"}	2024-10-22 16:50:58
604	9d4f2d2c-439d-46ba-96e7-bd7b3d484461	9d4f2d2c-44ee-4e76-ba80-fc3b6f34b338	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:50:58
755	9d4f2e81-8dcb-4818-85d7-b05984a6caed	9d4f2e81-b03d-4a7b-8b62-2c3619e70e8c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 16:54:42
756	9d4f2e81-aa45-4e40-b57c-2abbcc4d536d	9d4f2e81-b03d-4a7b-8b62-2c3619e70e8c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"45.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-22 16:54:42
757	9d4f2e81-aaa7-4da9-8322-4782628cd058	9d4f2e81-b03d-4a7b-8b62-2c3619e70e8c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":3,"hostname":"EderCortes"}	2024-10-22 16:54:42
758	9d4f2e81-aeb7-4986-a8bc-53c72772762a	9d4f2e81-b03d-4a7b-8b62-2c3619e70e8c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-22 16:54:42
759	9d4f2e81-af07-46d6-acbf-842240dcb25f	9d4f2e81-b03d-4a7b-8b62-2c3619e70e8c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:54:42
1126	9d4f442e-22c1-476d-b300-833a20d3f6df	9d4f442e-23d7-4000-b418-94d26e8ac991	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 17:55:18
1127	9d4f442e-230c-44dd-8416-0e255b6c9cf0	9d4f442e-23d7-4000-b418-94d26e8ac991	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":392,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:55:18
6395	9d52653c-09d7-4ee1-9f82-af066b6d3b47	9d52653c-2c2f-405a-8e0b-d1bef938e04f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 07:15:13
6396	9d52653c-259f-432b-bd92-704c2c1a18ce	9d52653c-2c2f-405a-8e0b-d1bef938e04f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n    select l.id,\\n        l.loans_documento,\\n        l.loans_nombre,\\n        l.loans_apellido_uno,\\n        l.loans_fecha,\\n        l.loans_valor_prestado,\\n        l.loans_cuotas,\\n        l.loans_estado,\\n        l.loans_intereses,\\n        uco.name as cobrador,\\n        ure.name as recomendador\\n    from loans l\\n    join users ucl on l.user_customer = ucl.id\\n    join users uco on l.user_cobrador = uco.id\\n    left join users ure on l.user_recomendacion = ure.id\\n","time":"43.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23,"hash":"07791497a6f310e4570d0edecd8da1cd","hostname":"EderCortes"}	2024-10-24 07:15:13
6397	9d52653c-2a79-41b6-a1d5-ccdc2eaf7f70	9d52653c-2c2f-405a-8e0b-d1bef938e04f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 07:15:13
7122	9d52dabb-a164-42ea-b008-f986b52492c7	9d52dabb-c9a5-4640-a7b1-3a1d18b8997e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-24 12:43:46
7123	9d52dabb-c4b5-4b7e-8045-289aba0c4ada	9d52dabb-c9a5-4640-a7b1-3a1d18b8997e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"54.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:43:46
1128	9d4f442f-bfea-47b2-b745-4865e37c6f48	9d4f4430-113b-4e3c-af94-072a08ad2455	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 17:55:19
1129	9d4f4430-07c7-4d52-893f-89580bd10220	9d4f4430-113b-4e3c-af94-072a08ad2455	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"151.81","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-22 17:55:19
924	9d4f349a-87c8-4a38-a700-8a49faa4d4cf	9d4f349a-b1d0-41c9-b5e6-f6a2a6429c2e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 17:11:45
925	9d4f349a-a99f-4c64-8c7d-8d516fd28a15	9d4f349a-b1d0-41c9-b5e6-f6a2a6429c2e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"55.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-22 17:11:45
476	9d4f2944-000e-4112-8c04-0300d1a3109c	9d4f2944-1fb8-4188-956a-82ba6aa4b71e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-22 16:40:02
477	9d4f2944-1dfd-4e8c-99de-08193779efee	9d4f2944-1fb8-4188-956a-82ba6aa4b71e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-22 16:40:03
478	9d4f2944-1ec4-4f50-b2a7-d1ccce4b1e68	9d4f2944-1fb8-4188-956a-82ba6aa4b71e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":264,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:40:03
760	9d4f2e83-1b14-4108-9625-8d1b361517a5	9d4f2e83-4680-4655-93c4-559ba666189b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-22 16:54:43
761	9d4f2e83-3e46-4871-a085-54e34ff7a0bb	9d4f2e83-4680-4655-93c4-559ba666189b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"54.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:54:43
762	9d4f2e83-3ed0-4074-ab28-a6da111a9ba7	9d4f2e83-4680-4655-93c4-559ba666189b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:54:43
763	9d4f2e83-44c2-4952-8eba-66788fe71fdf	9d4f2e83-4680-4655-93c4-559ba666189b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-22 16:54:43
764	9d4f2e83-4551-45b2-9cbd-fbd13576767c	9d4f2e83-4680-4655-93c4-559ba666189b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":473,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:54:43
926	9d4f349a-a9f8-4c96-a41d-c5e94ae4d4f5	9d4f349a-b1d0-41c9-b5e6-f6a2a6429c2e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 17:11:45
927	9d4f349a-b01e-4d32-a414-d3e78820051e	9d4f349a-b1d0-41c9-b5e6-f6a2a6429c2e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 17:11:45
928	9d4f349a-b08c-4bf5-b13c-f4e1cce80bec	9d4f349a-b1d0-41c9-b5e6-f6a2a6429c2e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":445,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:11:45
1130	9d4f4430-0841-4764-81f3-4c013f1e1f39	9d4f4430-113b-4e3c-af94-072a08ad2455	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 17:55:19
1131	9d4f4430-0f36-4654-b8b1-e24018e59d58	9d4f4430-113b-4e3c-af94-072a08ad2455	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 17:55:19
1762	9d50dd90-b534-41ac-9781-36630880d6c1	9d50dd90-b80a-4077-87ae-e15400a59785	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":149,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:00:01
7124	9d52dabb-c505-4454-9489-44305512d0b5	9d52dabb-c9a5-4640-a7b1-3a1d18b8997e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:43:46
10304	9d56cd4a-eb32-48c7-ae2f-8204fddf1237	9d56cd4a-f024-45d1-b7d0-392da6cc8b6a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:49:29
7125	9d52dabb-c861-4934-b0a6-7e4f67700a68	9d52dabb-c9a5-4640-a7b1-3a1d18b8997e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-24 12:43:46
871	9d4f3363-1d73-47dd-90d4-dd4d29bedc43	9d4f3363-42e8-4eaf-b53e-cf6e05c74501	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 17:08:21
872	9d4f3363-406c-454d-8b73-c9aa57b1a784	9d4f3363-42e8-4eaf-b53e-cf6e05c74501	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 17:08:21
769	9d4f2e94-832a-4003-9265-33377af40cbe	9d4f2e94-c6f1-4a56-868a-291179a806ab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-22 16:54:54
770	9d4f2e94-c171-4435-bb3b-f6310a1f693d	9d4f2e94-c6f1-4a56-868a-291179a806ab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"137.34","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-22 16:54:54
771	9d4f2e94-c1c2-48d7-9097-16f3c9706d41	9d4f2e94-c6f1-4a56-868a-291179a806ab	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":3,"hostname":"EderCortes"}	2024-10-22 16:54:54
772	9d4f2e94-c5ce-4ad6-8749-4c6bfd88c936	9d4f2e94-c6f1-4a56-868a-291179a806ab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-22 16:54:54
773	9d4f2e94-c61a-49f5-9f62-c0c31fe1b773	9d4f2e94-c6f1-4a56-868a-291179a806ab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":344,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:54:54
873	9d4f3363-419d-4de3-bd31-ab0a111392b2	9d4f3363-42e8-4eaf-b53e-cf6e05c74501	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:08:21
6398	9d52653c-2ae1-4be9-8039-a481b0216b26	9d52653c-2c2f-405a-8e0b-d1bef938e04f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":280,"memory":20,"hostname":"EderCortes"}	2024-10-24 07:15:13
1113	9d4f3ed9-35e2-452b-89cf-da3584eeb1db	9d4f3ed9-36ed-4544-9d60-6a8863ccb426	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":378,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:40:23
1763	9d50dd91-032e-42da-8b36-fc5212f184d3	9d50dd91-1cdc-4514-8863-062abfc5c4c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 13:00:02
7126	9d52dabb-c8a9-4f4a-83ed-ceac23bbf9a7	9d52dabb-c9a5-4640-a7b1-3a1d18b8997e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":573,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:43:46
10305	9d56cd4a-eb77-4789-9721-5331dab1711e	9d56cd4a-f024-45d1-b7d0-392da6cc8b6a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:49:29
10306	9d56cd4a-eea9-4e69-bdca-25e73690c74b	9d56cd4a-f024-45d1-b7d0-392da6cc8b6a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 11:49:29
874	9d4f3365-0f45-4e7a-957c-ccd48346df4e	9d4f3365-36ab-4a5e-a730-03d5d0230eb1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 17:08:22
875	9d4f3365-2ebc-4072-97c1-b9974c043aed	9d4f3365-36ab-4a5e-a730-03d5d0230eb1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"54.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-22 17:08:22
876	9d4f3365-2f21-4916-91c4-c59522e5b48d	9d4f3365-36ab-4a5e-a730-03d5d0230eb1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 17:08:22
877	9d4f3365-3517-4d08-88b5-5b1d065fa633	9d4f3365-36ab-4a5e-a730-03d5d0230eb1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 17:08:22
774	9d4f2e96-65de-4537-9926-d06af71ec42b	9d4f2e96-858a-489c-8b12-e64da40d0392	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-22 16:54:55
775	9d4f2e96-8037-4105-b396-198ff47ad3cc	9d4f2e96-858a-489c-8b12-e64da40d0392	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"44.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:54:55
776	9d4f2e96-8089-4e89-8210-670b2c9cde37	9d4f2e96-858a-489c-8b12-e64da40d0392	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:54:55
777	9d4f2e96-840b-42d0-b029-4f65b28d74d7	9d4f2e96-858a-489c-8b12-e64da40d0392	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-22 16:54:55
778	9d4f2e96-8469-4569-9575-c741d33425ed	9d4f2e96-858a-489c-8b12-e64da40d0392	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":326,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:54:55
878	9d4f3365-3577-4a26-9881-ab06349cd4de	9d4f3365-36ab-4a5e-a730-03d5d0230eb1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":497,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:08:22
1132	9d4f4430-0fc3-47e9-b1e5-6ba1b5b37534	9d4f4430-113b-4e3c-af94-072a08ad2455	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":461,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:55:19
1764	9d50dd91-18a3-4f59-b1ef-21124e4a4945	9d50dd91-1cdc-4514-8863-062abfc5c4c0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"name\\", \\"users\\".\\"user_document\\", \\"users\\".\\"id\\" from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder co%' or \\"users\\".\\"user_document\\"::text like '%eder co%' order by \\"users\\".\\"user_document\\" asc","time":"39.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"71e2e94a1a5a1b5c9b9dc051aea4b922","hostname":"EderCortes"}	2024-10-23 13:00:02
1765	9d50dd91-1bab-416d-b7d8-980583eb881d	9d50dd91-1cdc-4514-8863-062abfc5c4c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 13:00:02
13131	9d5cf980-c563-4c49-9659-03205b0331cf	9d5cf980-cbdb-449c-a3d2-474eb541f3fe	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 13:28:05
13132	9d5cf980-ca30-4204-86d4-61ec9bd901d4	9d5cf980-cbdb-449c-a3d2-474eb541f3fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 13:28:05
9697	9d569f1a-b459-42dd-af7d-e9a12fc00a13	9d569f1a-b5ee-47e6-8bc5-26c6575d5c1d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":394,"memory":22,"hostname":"EderCortes"}	2024-10-26 09:40:20
10746	9d57206e-c960-48e9-aad1-0eff37fed16b	9d57206e-ca5d-4524-8dd2-015411f17582	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":320,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:41:58
1244	9d50c6d0-a37a-427d-ba27-62a0e9508af8	9d50c6d0-ce60-4a1e-ad1a-54638617d50f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 11:56:25
521	9d4f2a02-826b-4fee-9866-9a7cf505b354	9d4f2a02-cbab-461a-b044-8efbc3628ed2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-22 16:42:07
522	9d4f2a02-c9cd-410f-9642-b29fdb490508	9d4f2a02-cbab-461a-b044-8efbc3628ed2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-22 16:42:08
523	9d4f2a02-ca78-460b-9631-43aea41177a7	9d4f2a02-cbab-461a-b044-8efbc3628ed2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":369,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:42:08
1245	9d50c6d0-cc29-4a71-9170-326dab0432ec	9d50c6d0-ce60-4a1e-ad1a-54638617d50f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 11:56:25
879	9d4f3377-4afb-41a4-8f2d-21cce8ec0787	9d4f3377-9480-4923-93df-900f2dbb27cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 17:08:34
880	9d4f3377-8e09-4595-a63b-911717adb0fa	9d4f3377-9480-4923-93df-900f2dbb27cd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"144.14","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-22 17:08:34
881	9d4f3377-8e6f-47c9-958c-6a2c30db2d22	9d4f3377-9480-4923-93df-900f2dbb27cd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":3,"hostname":"EderCortes"}	2024-10-22 17:08:34
882	9d4f3377-9345-4746-9415-84e340eaf9d2	9d4f3377-9480-4923-93df-900f2dbb27cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 17:08:34
1246	9d50c6d0-cd09-4c05-ae3a-24c5d5edd695	9d50c6d0-ce60-4a1e-ad1a-54638617d50f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":405,"memory":22,"hostname":"EderCortes"}	2024-10-23 11:56:25
10970	9d5ca6df-ef3f-4588-8055-cfb973af12c9	9d5ca6df-f031-4cb7-8f3d-b674b2d9245d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":391,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:37:02
10860	9d5ca538-b718-4db4-80f6-bb5be4b49d00	9d5ca538-b859-40b9-88e4-95fac15a2bb3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":420,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:32:25
21096	9d6734b0-f07a-492e-9bcc-ac4eab0e947d	9d6734b1-209d-427c-b9f3-6bf09785ea6e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 15:31:52
25005	9d68befe-f2a3-4089-9985-daf3fcd1c6e8	9d68beff-22ca-4e68-84c5-048c21bd9cde	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 09:54:25
26122	9d68cdb8-6835-4101-9fa6-56af05d96e8b	9d68cdb8-bfc2-4399-a5f7-1c6dd326862b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 10:35:35
9698	9d569f1d-3528-4381-a27d-9107b4442f37	9d569f1d-4f25-4859-9426-89ec518e1397	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 09:40:22
682	9d4f2df6-e663-4ea1-adf3-5006b7fc3a91	9d4f2df7-160b-4298-acd5-29264b369787	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 16:53:11
683	9d4f2df7-1375-4552-8baa-5acdd3ec7102	9d4f2df7-160b-4298-acd5-29264b369787	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:53:11
684	9d4f2df7-1488-45d0-aec2-15f71fe93fee	9d4f2df7-160b-4298-acd5-29264b369787	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:53:11
10861	9d5ca556-2503-46d7-ac0a-8a366e1aef95	9d5ca556-66f8-45ab-ae3b-30d0fb33b5bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 09:32:44
10862	9d5ca556-5eaf-4e68-9b3f-7117e745f74b	9d5ca556-66f8-45ab-ae3b-30d0fb33b5bd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"79.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-29 09:32:44
1247	9d50c6d1-3d2f-4226-a96c-749f9f324049	9d50c6d1-628c-4d7f-9f14-942dda5488e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 11:56:25
883	9d4f3377-938d-41cf-aba2-01f7928c2f51	9d4f3377-9480-4923-93df-900f2dbb27cd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":424,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:08:34
1248	9d50c6d1-5bb7-4ada-9d46-68624301c45e	9d50c6d1-628c-4d7f-9f14-942dda5488e7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 11:56:25
1249	9d50c6d1-5c0e-464f-bffe-2ae4757f605c	9d50c6d1-628c-4d7f-9f14-942dda5488e7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 11:56:25
1250	9d50c6d1-610c-47fc-95b8-b74ffd832778	9d50c6d1-628c-4d7f-9f14-942dda5488e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 11:56:25
1251	9d50c6d1-6169-43f9-be45-1a9be36a3ac5	9d50c6d1-628c-4d7f-9f14-942dda5488e7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-10-23 11:56:25
9699	9d569f1d-4ae7-4cc6-84ba-109cb87b2067	9d569f1d-4f25-4859-9426-89ec518e1397	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"44.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-26 09:40:22
9700	9d569f1d-4ddd-4eb3-a67b-5af0e229d0e3	9d569f1d-4f25-4859-9426-89ec518e1397	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 09:40:22
10863	9d5ca556-64e9-4c79-adc6-cb284997beeb	9d5ca556-66f8-45ab-ae3b-30d0fb33b5bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 09:32:44
10971	9d5ca6e2-889f-4739-a4c3-bc2945208893	9d5ca6e2-a5fd-4cb4-bac4-34cf991df03c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 09:37:04
10972	9d5ca6e2-a0eb-43a9-b943-10ddac438ee3	9d5ca6e2-a5fd-4cb4-bac4-34cf991df03c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 09:37:04
10973	9d5ca6e2-a138-4fa7-8dbe-3069e045dc0a	9d5ca6e2-a5fd-4cb4-bac4-34cf991df03c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 09:37:04
685	9d4f2df7-73ad-44d0-87e6-032568fda81c	9d4f2df7-9943-4ac3-8aa6-e8ab1ebff5c1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:53:11
686	9d4f2df7-9239-4623-87ce-138c8327cb31	9d4f2df7-9943-4ac3-8aa6-e8ab1ebff5c1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"47.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-22 16:53:11
687	9d4f2df7-9296-4335-bdca-3a8ef3844938	9d4f2df7-9943-4ac3-8aa6-e8ab1ebff5c1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":3,"hostname":"EderCortes"}	2024-10-22 16:53:11
688	9d4f2df7-97b5-49a6-90a9-1e3587c9abac	9d4f2df7-9943-4ac3-8aa6-e8ab1ebff5c1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:53:11
689	9d4f2df7-9816-491c-9a2d-a91e52615dda	9d4f2df7-9943-4ac3-8aa6-e8ab1ebff5c1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":312,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:53:11
884	9d4f3388-2d67-4eeb-b218-cab1a7c74022	9d4f3388-528b-439e-8396-206c2fa021b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 17:08:45
885	9d4f3388-4b4e-46bb-8519-33c0311fe13d	9d4f3388-528b-439e-8396-206c2fa021b0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"46.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-22 17:08:45
886	9d4f3388-4bbc-4580-82e8-47f33d97ef4b	9d4f3388-528b-439e-8396-206c2fa021b0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":3,"hostname":"EderCortes"}	2024-10-22 17:08:45
887	9d4f3388-50f0-48b0-976c-e1b8995b4ec5	9d4f3388-528b-439e-8396-206c2fa021b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 17:08:45
888	9d4f3388-5154-4482-ab22-95706a5409ed	9d4f3388-528b-439e-8396-206c2fa021b0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":288,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:08:45
1252	9d50c6d1-b3d1-4c62-812f-237946fd29a3	9d50c6d1-fe05-41e2-8a6a-1a9a23830194	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 11:56:25
1253	9d50c6d1-f83a-46c6-b5c6-5d5bae78f166	9d50c6d1-fe05-41e2-8a6a-1a9a23830194	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"150.13","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 11:56:25
1254	9d50c6d1-f890-4902-a7ef-08d2525918aa	9d50c6d1-fe05-41e2-8a6a-1a9a23830194	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 11:56:25
1255	9d50c6d1-fc8d-4658-b608-b56e5770999e	9d50c6d1-fe05-41e2-8a6a-1a9a23830194	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 11:56:25
1256	9d50c6d1-fce6-41c4-bd24-8372e57802a7	9d50c6d1-fe05-41e2-8a6a-1a9a23830194	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-10-23 11:56:25
2197	9d50e4f9-2a3b-4460-b803-3addf40a18ed	9d50e4f9-2df7-4383-9939-b58ab735d527	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":134,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:20:44
690	9d4f2dfa-0773-48dd-a521-b0fd8e16f4c2	9d4f2dfa-557e-4d30-b11a-0ccef77401f8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 16:53:13
691	9d4f2dfa-4f2b-4f72-ae15-342f6f54ab86	9d4f2dfa-557e-4d30-b11a-0ccef77401f8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"155.50","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:53:13
692	9d4f2dfa-4fa0-4d97-ae76-93b7ca15fb4d	9d4f2dfa-557e-4d30-b11a-0ccef77401f8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:53:13
693	9d4f2dfa-53cd-4f1e-80ce-df965f83881a	9d4f2dfa-557e-4d30-b11a-0ccef77401f8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 16:53:13
694	9d4f2dfa-542f-4fdc-8dd0-1478c1acfb03	9d4f2dfa-557e-4d30-b11a-0ccef77401f8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":641,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:53:13
10864	9d5ca556-6579-4dda-b3f8-18b508b1ec6b	9d5ca556-66f8-45ab-ae3b-30d0fb33b5bd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":633,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:32:44
9701	9d569f1d-4e27-4bb4-b592-7a5303f10445	9d569f1d-4f25-4859-9426-89ec518e1397	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":261,"memory":20,"hostname":"EderCortes"}	2024-10-26 09:40:22
10974	9d5ca6e2-a4bb-445d-92d1-8bbf15f76a0d	9d5ca6e2-a5fd-4cb4-bac4-34cf991df03c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 09:37:04
1257	9d50c6d3-9db0-4f29-9ed5-a5727db7a967	9d50c6d3-bf62-4fb5-9950-e8419cb3d440	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 11:56:27
1258	9d50c6d3-b73b-4fb0-ae2f-9bcfcbfbb487	9d50c6d3-bf62-4fb5-9950-e8419cb3d440	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"46.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 11:56:27
1259	9d50c6d3-b78a-4b3a-9f8c-2b23cae8b763	9d50c6d3-bf62-4fb5-9950-e8419cb3d440	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 11:56:27
1260	9d50c6d3-bd22-4425-b22e-f8205183d318	9d50c6d3-bf62-4fb5-9950-e8419cb3d440	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 11:56:27
2198	9d50e4f9-7cb6-4bee-9a5b-7af89befb741	9d50e4f9-97b6-4bdb-abec-2022dd1806c1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 13:20:45
10975	9d5ca6e2-a50d-4486-8a15-aed7897a4d29	9d5ca6e2-a5fd-4cb4-bac4-34cf991df03c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":224,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:37:04
26900	9d68dd72-111a-472d-a30e-1ae2daf80bd0	9d68dd72-2db7-4c1d-a3d9-2191ae42cd6e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:19:34
9702	9d569fc6-d41e-4fbf-9111-3d155937c115	9d569fc7-20e5-4413-9350-5dfd15f3184c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 09:42:13
1261	9d50c6d3-bdbe-422d-bfbb-9964f46288db	9d50c6d3-bf62-4fb5-9950-e8419cb3d440	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-10-23 11:56:27
808	9d4f3105-8023-4c88-83cb-6e538b224243	9d4f3105-a6b1-489a-9ea7-620c149dc338	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 17:01:44
809	9d4f3105-a4f4-4e61-9b3c-c7fedca77aef	9d4f3105-a6b1-489a-9ea7-620c149dc338	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 17:01:44
810	9d4f3105-a5ad-420e-9cd2-81bc76796544	9d4f3105-a6b1-489a-9ea7-620c149dc338	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":301,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:01:44
9703	9d569fc7-1ab4-4cbf-802d-545052f832fe	9d569fc7-20e5-4413-9350-5dfd15f3184c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"155.38","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-26 09:42:13
9704	9d569fc7-1ef6-45cb-8dd2-c3a6d7f6fe3b	9d569fc7-20e5-4413-9350-5dfd15f3184c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 09:42:13
10976	9d5ca6e2-e446-4a45-939e-07b2ad866ae4	9d5ca6e3-2d46-4afd-a92d-ef45ce343bee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 09:37:04
9705	9d569fc7-1f75-4058-8518-d2bcb78ead5a	9d569fc7-20e5-4413-9350-5dfd15f3184c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":397,"memory":20,"hostname":"EderCortes"}	2024-10-26 09:42:13
10977	9d5ca6e3-283a-472e-978f-a756b48692e9	9d5ca6e3-2d46-4afd-a92d-ef45ce343bee	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"151.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 09:37:04
10978	9d5ca6e3-2888-4059-a712-426698f1b146	9d5ca6e3-2d46-4afd-a92d-ef45ce343bee	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 09:37:04
10979	9d5ca6e3-2be7-4d1c-a297-fa3b7fedb81f	9d5ca6e3-2d46-4afd-a92d-ef45ce343bee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-29 09:37:04
10980	9d5ca6e3-2c3d-46d3-b03c-1b20bcc93b45	9d5ca6e3-2d46-4afd-a92d-ef45ce343bee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:37:04
11589	9d5ccb02-0847-428c-8219-a57058bd0d12	9d5ccb02-0b26-441c-8206-d8476997571f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":145,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:18:04
9706	9d56ab7c-4d32-4eba-8bc1-1893ee22ebc9	9d56ab7c-7194-4ff9-b21c-5d35b5756ebf	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 10:14:57
10981	9d5ca6e3-70a8-42d7-8d41-9349f8a4e737	9d5ca6e3-8cc7-465e-8a16-1080008ba2d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-29 09:37:04
9707	9d56ab7c-6ac7-4160-98a0-9902b738c130	9d56ab7c-7194-4ff9-b21c-5d35b5756ebf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"48.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-26 10:14:58
9708	9d56ab7c-6fc4-49e9-9a0c-743499912191	9d56ab7c-7194-4ff9-b21c-5d35b5756ebf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 10:14:58
939	9d4f38be-2e42-49f2-875e-60bfd946363e	9d4f38be-552d-44bd-aba0-c28960e17b3c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 17:23:19
940	9d4f38be-52fa-4de9-8d66-d9a3ed386e87	9d4f38be-552d-44bd-aba0-c28960e17b3c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 17:23:19
941	9d4f38be-5415-49ac-91b7-72a539990093	9d4f38be-552d-44bd-aba0-c28960e17b3c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":261,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:23:19
9709	9d56ab7c-7039-47c1-a60f-097d404479b3	9d56ab7c-7194-4ff9-b21c-5d35b5756ebf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":322,"memory":20,"hostname":"EderCortes"}	2024-10-26 10:14:58
10982	9d5ca6e3-86a6-4404-b533-b26ab15bf18f	9d5ca6e3-8cc7-465e-8a16-1080008ba2d8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '1' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"37.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-29 09:37:04
10983	9d5ca6e3-86ee-4abd-85d7-c3e5953c4414	9d5ca6e3-8cc7-465e-8a16-1080008ba2d8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-29 09:37:04
10984	9d5ca6e3-8841-484d-bd2b-2a0969481604	9d5ca6e3-8cc7-465e-8a16-1080008ba2d8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1' order by \\"item_loans\\".\\"id\\" asc","time":"1.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 09:37:04
10985	9d5ca6e3-887d-478a-8ae6-7750d5649726	9d5ca6e3-8cc7-465e-8a16-1080008ba2d8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 09:37:04
10986	9d5ca6e3-8b9e-400a-a9c1-e9641577efd8	9d5ca6e3-8cc7-465e-8a16-1080008ba2d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-29 09:37:04
10987	9d5ca6e3-8bea-4349-b0f4-59010ff222e2	9d5ca6e3-8cc7-465e-8a16-1080008ba2d8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":1,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]}},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:37:04
11298	9d5cb30d-94e8-4a50-940f-722344e2aa0b	9d5cb30d-9a0c-4de3-9fd8-2b85634544f3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"39.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-29 10:11:05
11299	9d5cb30d-988f-4e4e-aa1e-6515031291a6	9d5cb30d-9a0c-4de3-9fd8-2b85634544f3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 10:11:05
11590	9d5ccb02-7dd8-40e5-90ea-3cbd36629a2c	9d5ccb02-9d10-48f9-a73b-d5a7ce516ab3	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 11:18:04
29115	9d690e9f-7196-47e7-99c3-09d25bb5d1a7	9d690e9f-a0d7-4790-a7e8-c754c9cb7eac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-04 13:37:04
10988	9d5ca6eb-989c-4580-8cd8-a3b0f0c97a5d	9d5ca6eb-b1bf-4caf-afde-22004f3678ad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-29 09:37:10
10989	9d5ca6eb-adba-4e1a-a0d0-876cad0fddf3	9d5ca6eb-b1bf-4caf-afde-22004f3678ad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"41.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-29 09:37:10
530	9d4f2a71-903a-40d0-ac62-37ee0cd14d20	9d4f2a71-c0bf-4196-8686-170310111d68	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 16:43:20
531	9d4f2a71-bd62-4ccc-870b-efd5078dd341	9d4f2a71-c0bf-4196-8686-170310111d68	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:43:20
532	9d4f2a71-bf1c-41f1-b7a6-41e222233be2	9d4f2a71-c0bf-4196-8686-170310111d68	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":329,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:43:20
942	9d4f38bf-ad9f-4f52-bbcb-cf2064120f2f	9d4f38bf-d7cf-424e-80fb-7825e1d314e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 17:23:20
943	9d4f38bf-cf37-411f-96ed-cabe874f7755	9d4f38bf-d7cf-424e-80fb-7825e1d314e8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-22 17:23:20
1379	9d50cf4d-5531-4e9a-947e-53e94af5c51b	9d50cf4d-c8f7-4d9f-b5ca-54a7223d45fa	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 12:20:08
944	9d4f38bf-cfa2-431f-a210-479c04b95f59	9d4f38bf-d7cf-424e-80fb-7825e1d314e8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 17:23:20
945	9d4f38bf-d5f2-4949-bdd2-03f5d9cea6b4	9d4f38bf-d7cf-424e-80fb-7825e1d314e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 17:23:20
1380	9d50cf4d-c5d1-447c-8c58-9e333af77fd9	9d50cf4d-c8f7-4d9f-b5ca-54a7223d45fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:20:09
1381	9d50cf4d-c730-42ae-943b-1dd0b0bd5c6e	9d50cf4d-c8f7-4d9f-b5ca-54a7223d45fa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":576,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:20:09
10990	9d5ca6eb-b085-4792-98a4-515ba3dbc065	9d5ca6eb-b1bf-4caf-afde-22004f3678ad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-29 09:37:10
10991	9d5ca6eb-b0d0-4b53-87ea-c5a512e55a01	9d5ca6eb-b1bf-4caf-afde-22004f3678ad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:37:10
11300	9d5cb30d-98eb-49f9-ac21-fdc2be62b7de	9d5cb30d-9a0c-4de3-9fd8-2b85634544f3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":274,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:11:05
11591	9d5ccb02-9838-454e-8f48-050b607aacc6	9d5ccb02-9d10-48f9-a73b-d5a7ce516ab3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"39.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 11:18:04
11592	9d5ccb02-9bb7-4152-8610-1ce6ce3539f7	9d5ccb02-9d10-48f9-a73b-d5a7ce516ab3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 11:18:04
12312	9d5ce213-e1c8-4e8f-a607-ae6dfa8fd5df	9d5ce213-e52a-446e-bd69-6feb44ff8b0c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":208,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:22:35
29311	9d69180d-98e4-4f78-880e-e4a3c912c9fa	9d691811-d71c-4f0a-a412-2ac78d5a38a2	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 14:03:27
946	9d4f38bf-d683-4740-b423-f8c6a2e89bea	9d4f38bf-d7cf-424e-80fb-7825e1d314e8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":462,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:23:20
1382	9d50cf4e-3c40-4032-bd89-b1a27b213bbb	9d50cf57-f572-4c3c-9c87-ee864ce4b849	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:20:09
1383	9d50cf57-f40e-4bc4-8d41-94e2ae0cce0f	9d50cf57-f572-4c3c-9c87-ee864ce4b849	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:20:15
1384	9d50cf57-f473-4674-8218-4ee7ee4468c6	9d50cf57-f572-4c3c-9c87-ee864ce4b849	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":"Empty Response","duration":6643,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:20:15
11301	9d5cb372-a66e-4001-90ee-883993a3a769	9d5cb372-f4bb-488f-968f-35dc1dc0a82a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 10:12:11
2199	9d50e4f9-930f-45b4-bc46-f3037a40240f	9d50e4f9-97b6-4bdb-abec-2022dd1806c1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder t%' or \\"users\\".\\"user_document\\"::text like '%eder t%' order by \\"users\\".\\"user_document\\" asc","time":"41.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:20:45
1766	9d50dd91-1bf1-4419-a757-63bf6d56dd09	9d50dd91-1cdc-4514-8863-062abfc5c4c0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"29","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder co"},"session":[],"response_status":200,"response":{"data":[{"name":"Luis andre","user_document":"100465545","id":14}]},"duration":204,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:00:02
1819	9d50df30-5df8-47c2-a9c8-6a4bc300b6f6	9d50df30-5ee6-4b2f-a9dd-6b52917a8770	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":260,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:04:34
2200	9d50e4f9-960e-4112-97af-ce3fa83b3db9	9d50e4f9-97b6-4bdb-abec-2022dd1806c1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 13:20:45
2201	9d50e4f9-96b4-4270-a547-7207f43e3336	9d50e4f9-97b6-4bdb-abec-2022dd1806c1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"28","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder t"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":215,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:20:45
29312	9d691810-487e-4e23-9b30-3ff868a5c503	9d691811-d71c-4f0a-a412-2ac78d5a38a2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"120.08","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-04 14:03:28
29313	9d691810-5004-461f-a978-a118606274da	9d691811-d71c-4f0a-a412-2ac78d5a38a2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 14:03:28
2202	9d50e4f9-e4ef-4cb8-a27e-1589374ad618	9d50e4fa-059c-4692-b921-4f912af46216	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 13:20:45
2203	9d50e4f9-feed-4f71-8c03-60538e6800c0	9d50e4fa-059c-4692-b921-4f912af46216	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder te%' or \\"users\\".\\"user_document\\"::text like '%eder te%' order by \\"users\\".\\"user_document\\" asc","time":"48.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:20:45
1767	9d50dd92-348a-4113-bc86-7333a7661a84	9d50dd92-37e6-4ddd-b178-da14b42a9b69	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":135,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:00:02
1030	9d4f3de4-f711-4c07-95e8-10612546da09	9d4f3de5-2b7b-4277-93a5-c840dd9cf468	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 17:37:43
1031	9d4f3de5-2837-48fc-bb18-0b482310e52e	9d4f3de5-2b7b-4277-93a5-c840dd9cf468	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 17:37:44
1032	9d4f3de5-29cf-4ae0-a611-4289d41eed52	9d4f3de5-2b7b-4277-93a5-c840dd9cf468	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":502,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:37:44
1385	9d50cf58-71e6-4701-a0f1-fe68a20a21e6	9d50cf58-c76e-491b-b770-a28e8471f56e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:20:16
1386	9d50cf58-b32c-474c-bc4d-49a8980f1a8a	9d50cf58-c76e-491b-b770-a28e8471f56e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"111.03","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:20:16
1387	9d50cf58-b3c7-4d45-b2c3-36f350e4e2f4	9d50cf58-c76e-491b-b770-a28e8471f56e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 12:20:16
1388	9d50cf58-c42b-4eb2-9965-83645321488c	9d50cf58-c76e-491b-b770-a28e8471f56e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:20:16
1389	9d50cf58-c530-423d-80dd-1811464d01fe	9d50cf58-c76e-491b-b770-a28e8471f56e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":470,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:20:16
1820	9d50df31-7e2d-4968-b7aa-979324a0be37	9d50df31-a5e9-4204-8076-e443643df21c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 13:04:35
1821	9d50df31-9f19-465c-8291-1bad3880e099	9d50df31-a5e9-4204-8076-e443643df21c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"52.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 13:04:35
1822	9d50df31-9f88-4294-97c2-d46bfd8e62d0	9d50df31-a5e9-4204-8076-e443643df21c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 13:04:35
1823	9d50df31-a3d2-4a57-91eb-36ead8e88821	9d50df31-a5e9-4204-8076-e443643df21c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 13:04:35
1824	9d50df31-a488-4af1-a4a2-037bcf6ef597	9d50df31-a5e9-4204-8076-e443643df21c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":365,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:04:35
2204	9d50e4fa-03c8-4092-8934-ffc4d0e2d72a	9d50e4fa-059c-4692-b921-4f912af46216	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 13:20:45
29314	9d691811-9f71-405a-a904-b62537a201c9	9d691811-d71c-4f0a-a412-2ac78d5a38a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 14:03:29
29460	9d692473-e578-46b3-ac3a-f5183fc46722	9d692474-1390-45f1-b3fa-762e14446921	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 14:38:07
1033	9d4f3de5-a80d-4b79-872c-73c1cf182f76	9d4f3de5-cf78-455c-aa34-51e0f2fe9d5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 17:37:44
1034	9d4f3de5-c857-4408-8739-e28164613c98	9d4f3de5-cf78-455c-aa34-51e0f2fe9d5c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-22 17:37:44
1035	9d4f3de5-c8a9-4b77-8090-9f0af6571737	9d4f3de5-cf78-455c-aa34-51e0f2fe9d5c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-22 17:37:44
1036	9d4f3de5-cdef-4fc8-afdc-0463f1a9e3ad	9d4f3de5-cf78-455c-aa34-51e0f2fe9d5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 17:37:44
598	9d4f2d2b-85b7-4db3-91ba-279126de3581	9d4f2d2b-b4ad-4d31-8991-b2728beb66c6	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 16:50:58
599	9d4f2d2b-b278-403f-94b9-4b5e0e0a6840	9d4f2d2b-b4ad-4d31-8991-b2728beb66c6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:50:58
600	9d4f2d2b-b36b-4519-ad71-c0b8558e4d37	9d4f2d2b-b4ad-4d31-8991-b2728beb66c6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":317,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:50:58
1037	9d4f3de5-ce52-4986-864e-0dbe44afbe66	9d4f3de5-cf78-455c-aa34-51e0f2fe9d5c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":391,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:37:44
1390	9d50cf5c-a125-4664-9d72-2d1b8afe2dd9	9d50cf5d-2c86-4e62-b16e-38600d427132	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:20:19
1391	9d50cf5d-1ee3-4441-97f4-e55d2146e922	9d50cf5d-2c86-4e62-b16e-38600d427132	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"262.62","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 12:20:19
1392	9d50cf5d-1f7a-4301-8b88-4a0991443dfb	9d50cf5d-2c86-4e62-b16e-38600d427132	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 12:20:19
1393	9d50cf5d-2960-4e77-8aea-66533bda8c28	9d50cf5d-2c86-4e62-b16e-38600d427132	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 12:20:19
1394	9d50cf5d-2a04-40c3-97ba-d5a47e0b3ddf	9d50cf5d-2c86-4e62-b16e-38600d427132	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":1029,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:20:19
12313	9d5ce214-87b3-4ba3-9867-566ae3be41df	9d5ce214-8b17-4ee7-8f01-5f33d3fdaaff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":165,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:22:35
1768	9d50dd92-8803-4061-9fa5-43f333362996	9d50dd92-8b08-446f-b9e5-ee829e239085	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":135,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:00:03
1825	9d50df37-a18d-4332-acda-b26c4d383e4b	9d50df37-a4d0-40ae-bfe1-7ee7d54e3341	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":165,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:04:39
1038	9d4f3de6-2b63-4423-adf4-39ee5b725496	9d4f3de6-4c5d-46d8-aba9-5ed9122b914b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 17:37:44
1039	9d4f3de6-479e-4496-b1fa-91d38ade4b40	9d4f3de6-4c5d-46d8-aba9-5ed9122b914b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-22 17:37:44
1040	9d4f3de6-47f4-4338-a73f-9140cc7ad168	9d4f3de6-4c5d-46d8-aba9-5ed9122b914b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-22 17:37:44
1041	9d4f3de6-4b3e-4e52-afd2-184719826e3f	9d4f3de6-4c5d-46d8-aba9-5ed9122b914b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 17:37:44
1042	9d4f3de6-4b87-4cca-8cfe-c733835040ac	9d4f3de6-4c5d-46d8-aba9-5ed9122b914b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":302,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:37:44
12314	9d5ce214-db7e-4bf9-a591-e40e4365b397	9d5ce214-f496-4b5a-93d2-cddc2388cce8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 12:22:35
1495	9d50d2f8-15ed-4984-95dd-95f81a24fa9b	9d50d2f8-6ca0-44e3-af9b-565a77f1f5a8	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 12:30:24
1496	9d50d2f8-67b4-42d7-946f-ba52b0c169e6	9d50d2f8-6ca0-44e3-af9b-565a77f1f5a8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:30:24
1497	9d50d2f8-68be-410d-83e5-79800195f57c	9d50d2f8-6ca0-44e3-af9b-565a77f1f5a8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":460,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:30:24
12315	9d5ce214-f0ce-478e-a610-5850af5447b7	9d5ce214-f496-4b5a-93d2-cddc2388cce8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and \\"users\\".\\"name\\"::text like '%MAri%' or \\"users\\".\\"user_document\\"::text like '%MAri%' order by \\"users\\".\\"user_document\\" asc","time":"38.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"346e96d5b86098f6cea2c4bc11d5ca30","hostname":"EderCortes"}	2024-10-29 12:22:35
1769	9d50dd93-0e98-4175-9fd4-cad2200e8d54	9d50dd93-29ee-427e-a834-70128a786baa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 13:00:03
1770	9d50dd93-25b7-42f9-b6cd-b89a703e556d	9d50dd93-29ee-427e-a834-70128a786baa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"name\\", \\"users\\".\\"user_document\\", \\"users\\".\\"id\\" from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder c%' or \\"users\\".\\"user_document\\"::text like '%eder c%' order by \\"users\\".\\"user_document\\" asc","time":"42.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"71e2e94a1a5a1b5c9b9dc051aea4b922","hostname":"EderCortes"}	2024-10-23 13:00:03
1771	9d50dd93-28ad-4284-abc5-940ea19f218e	9d50dd93-29ee-427e-a834-70128a786baa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 13:00:03
1772	9d50dd93-2905-46e4-a772-cfe0464d6840	9d50dd93-29ee-427e-a834-70128a786baa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"28","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder c"},"session":[],"response_status":200,"response":{"data":[{"name":"Luis andre","user_document":"100465545","id":14}]},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:00:03
1826	9d50df37-fc1e-4390-8eca-e496379bcdd3	9d50df38-2393-4507-9330-766affc04bae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 13:04:39
1827	9d50df38-1f1c-42fe-93fa-c34cba173a27	9d50df38-2393-4507-9330-766affc04bae	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, ' ', (users.user_document)) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder%' or \\"users\\".\\"user_document\\"::text like '%eder%' order by \\"users\\".\\"user_document\\" asc","time":"43.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"8e8d2f1f6030d01848bc971840ab08d0","hostname":"EderCortes"}	2024-10-23 13:04:39
1828	9d50df38-2268-4ac3-b8bf-bf377addf265	9d50df38-2393-4507-9330-766affc04bae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 13:04:39
1829	9d50df38-22ad-4936-8b19-71dbeeae35c0	9d50df38-2393-4507-9330-766affc04bae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre 100465545"}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:04:39
12316	9d5ce214-f370-4ad3-b200-e8c3132864a9	9d5ce214-f496-4b5a-93d2-cddc2388cce8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 12:22:35
1498	9d50d2f8-d193-4388-8824-e53056e8863b	9d50d2f8-f748-4366-90f8-3291fc90a67a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:30:24
1499	9d50d2f8-eeea-49f5-bf6a-bfb13d0ef008	9d50d2f8-f748-4366-90f8-3291fc90a67a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":61,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:30:24
696	9d4f2e09-bd30-4338-bff8-c5a9235157a4	9d4f2e0a-06d4-4815-97a8-f3dba8d68a11	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 16:53:23
697	9d4f2e0a-0540-47cc-8438-35b977712540	9d4f2e0a-06d4-4815-97a8-f3dba8d68a11	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 16:53:23
698	9d4f2e0a-05dc-4559-b963-e0c5443ca658	9d4f2e0a-06d4-4815-97a8-f3dba8d68a11	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:53:23
1500	9d50d2f8-ef87-4966-bb86-fb610a9c4ef2	9d50d2f8-f748-4366-90f8-3291fc90a67a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 12:30:24
1501	9d50d2f8-f615-4bd7-b537-6980db0c6d95	9d50d2f8-f748-4366-90f8-3291fc90a67a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:30:24
1502	9d50d2f8-f660-4475-8508-e622856b54a3	9d50d2f8-f748-4366-90f8-3291fc90a67a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":329,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:30:24
16961	9d654665-0895-4637-a177-280a29fa18d9	9d654665-0e86-49e8-935d-32aa0606a0f5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 16:29:42
2144	9d50e3bc-ec76-443f-b76f-bf07e5c01504	9d50e3bc-ed78-4c08-b414-8b87110a14c0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":346,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:17:17
1830	9d50df40-61d4-43af-ac5e-68e8a18abd0b	9d50df40-64c1-48ec-9ef2-b6ecbaa38c55	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":148,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:04:44
1773	9d50dd93-6fe4-4b67-9405-9c4f4081fb2f	9d50dd93-8a93-4aad-b925-356eecbea1f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 13:00:03
2205	9d50e4fa-0435-4a3b-912c-04f3e9fdf19e	9d50e4fa-059c-4692-b921-4f912af46216	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"29","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder te"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":268,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:20:45
1774	9d50dd93-867f-4c03-97b0-29b39ee562fa	9d50dd93-8a93-4aad-b925-356eecbea1f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"name\\", \\"users\\".\\"user_document\\", \\"users\\".\\"id\\" from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder%' or \\"users\\".\\"user_document\\"::text like '%eder%' order by \\"users\\".\\"user_document\\" asc","time":"42.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"71e2e94a1a5a1b5c9b9dc051aea4b922","hostname":"EderCortes"}	2024-10-23 13:00:03
1775	9d50dd93-8944-472e-814b-19d57f46b5a8	9d50dd93-8a93-4aad-b925-356eecbea1f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 13:00:03
16962	9d654665-090b-4dab-b2da-2437bce0c9ef	9d654665-0e86-49e8-935d-32aa0606a0f5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 16:29:42
699	9d4f2e0a-5b04-4e5f-890d-fd0b4c7cbdb6	9d4f2e0a-7b0d-4c58-986f-6960e44280a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 16:53:24
700	9d4f2e0a-75d1-4a90-bc1d-c837bea5ac34	9d4f2e0a-7b0d-4c58-986f-6960e44280a4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"42.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-22 16:53:24
701	9d4f2e0a-761e-4084-9293-7bc97f8b7846	9d4f2e0a-7b0d-4c58-986f-6960e44280a4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":3,"hostname":"EderCortes"}	2024-10-22 16:53:24
702	9d4f2e0a-79cb-429e-9fc0-0d8f3420a7e8	9d4f2e0a-7b0d-4c58-986f-6960e44280a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-22 16:53:24
703	9d4f2e0a-7a19-4b58-bc35-e3672c39ec06	9d4f2e0a-7b0d-4c58-986f-6960e44280a4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":278,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:53:24
1503	9d50d2f9-4a24-4349-8d36-71c388dc34b4	9d50d2f9-6f92-44fc-87c4-7596a72d0865	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:30:24
1504	9d50d2f9-69a8-432a-8bde-f896b808b5d0	9d50d2f9-6f92-44fc-87c4-7596a72d0865	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"51.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":61,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:30:25
1505	9d50d2f9-6a13-4689-9f55-3dede33cb793	9d50d2f9-6f92-44fc-87c4-7596a72d0865	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 12:30:25
812	9d4f3106-0f29-4ed9-b0f3-f9a63607c459	9d4f3106-2d58-4cec-a2ae-c3cd1fc181c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 17:01:44
813	9d4f3106-2bfb-4732-87e0-b936ea137cc6	9d4f3106-2d58-4cec-a2ae-c3cd1fc181c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 17:01:44
814	9d4f3106-2c87-4d51-8b98-a5d8ce0e2454	9d4f3106-2d58-4cec-a2ae-c3cd1fc181c0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":326,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:01:44
1506	9d50d2f9-6e51-414d-99f0-09e633ba0987	9d50d2f9-6f92-44fc-87c4-7596a72d0865	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:30:25
1507	9d50d2f9-6e9c-4452-825d-0138d6c53bbf	9d50d2f9-6f92-44fc-87c4-7596a72d0865	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":287,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:30:25
2145	9d50e3be-1807-4b10-8202-733cf50f1246	9d50e3be-6076-49d4-97b7-9b58e6a8447f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 13:17:18
1831	9d50df41-152b-4dc0-b38c-8b8903a6f224	9d50df41-58fd-44d9-a97c-68da41bafcca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 13:04:45
1832	9d50df41-54b0-4b37-ac41-6e5abd672552	9d50df41-58fd-44d9-a97c-68da41bafcca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, ' ', (users.user_document)) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"147.65","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"8e8d2f1f6030d01848bc971840ab08d0","hostname":"EderCortes"}	2024-10-23 13:04:45
1833	9d50df41-57d2-4d38-a8e8-8be7a3aeaa65	9d50df41-58fd-44d9-a97c-68da41bafcca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 13:04:45
1834	9d50df41-5815-422e-9788-fb756f54396f	9d50df41-58fd-44d9-a97c-68da41bafcca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley 1004608333"},{"id":14,"name_customer":"Luis andre 100465545"}]},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:04:45
2206	9d50e4fa-5552-4f6f-9e68-8a10c1f405c2	9d50e4fa-74a8-4d42-9acd-2814ce812459	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 13:20:45
16963	9d654665-0d15-41b1-95e9-dc2f13704216	9d654665-0e86-49e8-935d-32aa0606a0f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 16:29:42
704	9d4f2e0c-6ce2-46e6-a718-e982d79c6015	9d4f2e0c-97e6-4501-9b79-aa0564026afd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-22 16:53:25
705	9d4f2e0c-91c9-4b1d-884b-faa389937743	9d4f2e0c-97e6-4501-9b79-aa0564026afd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"49.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:53:25
706	9d4f2e0c-922e-40e3-a623-d31479d3e474	9d4f2e0c-97e6-4501-9b79-aa0564026afd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:53:25
707	9d4f2e0c-967d-4f49-bd78-31027d5a4cbb	9d4f2e0c-97e6-4501-9b79-aa0564026afd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-22 16:53:25
708	9d4f2e0c-96c6-431a-8261-a428c50c32f4	9d4f2e0c-97e6-4501-9b79-aa0564026afd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":526,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:53:25
11593	9d5ccb02-9c07-4c46-9eb5-2f43aa544237	9d5ccb02-9d10-48f9-a73b-d5a7ce516ab3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":219,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:18:04
11302	9d5cb372-ea1b-427f-8ede-c297d472738c	9d5cb372-f4bb-488f-968f-35dc1dc0a82a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 1\\n                        ","time":"146.87","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"2bd5a29c69f6bbb290fc49b79286632e","hostname":"EderCortes"}	2024-10-29 10:12:12
1508	9d50d2fa-e629-4205-9577-750c248e030c	9d50d2fb-187e-43c6-9dd1-f77cd8603aa9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:30:26
29461	9d692474-09c5-49b4-8a0a-52b5f97ea533	9d692474-1390-45f1-b3fa-762e14446921	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"58.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-04 14:38:07
1509	9d50d2fb-1099-470e-9f35-3c9201f34a29	9d50d2fb-187e-43c6-9dd1-f77cd8603aa9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"56.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 12:30:26
1510	9d50d2fb-1120-427c-8841-2c9a5697000b	9d50d2fb-187e-43c6-9dd1-f77cd8603aa9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 12:30:26
1511	9d50d2fb-1667-4bfe-980d-6d636048f096	9d50d2fb-187e-43c6-9dd1-f77cd8603aa9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 12:30:26
2146	9d50e3be-5902-4d19-aceb-0ae3f0b3aee0	9d50e3be-6076-49d4-97b7-9b58e6a8447f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"65.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 13:17:18
815	9d4f3107-ba31-471e-9670-4949b09155dc	9d4f3107-fb52-48c0-88a2-3875a15de1d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 17:01:45
816	9d4f3107-efa7-49bb-b599-2562608e4dfe	9d4f3107-fb52-48c0-88a2-3875a15de1d6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"71.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 17:01:45
817	9d4f3107-f01f-4ce5-affa-43be199933aa	9d4f3107-fb52-48c0-88a2-3875a15de1d6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 17:01:45
818	9d4f3107-f8e2-49d9-a474-f59eac4c9170	9d4f3107-fb52-48c0-88a2-3875a15de1d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 17:01:45
819	9d4f3107-f9b1-4972-901b-6725502dd1d9	9d4f3107-fb52-48c0-88a2-3875a15de1d6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":413,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:01:45
1512	9d50d2fb-16e4-42f5-b042-f50e99865ee4	9d50d2fb-187e-43c6-9dd1-f77cd8603aa9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":460,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:30:26
11303	9d5cb372-ee19-4940-b81d-bc38075c490e	9d5cb372-f4bb-488f-968f-35dc1dc0a82a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1' order by \\"item_loans\\".\\"id\\" asc","time":"1.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 10:12:12
11304	9d5cb372-ee48-49d6-8fe3-72ecc51ee200	9d5cb372-f4bb-488f-968f-35dc1dc0a82a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 10:12:12
11305	9d5cb372-f342-4007-892d-f5bf052099cf	9d5cb372-f4bb-488f-968f-35dc1dc0a82a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 10:12:12
11306	9d5cb372-f3a2-49c1-8047-f1ff7fef1a46	9d5cb372-f4bb-488f-968f-35dc1dc0a82a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":1,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]}},"duration":398,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:12:12
11594	9d5ccb04-f83a-40ec-b314-7d9753429bf5	9d5ccb05-410c-4562-b2d0-e1c967995578	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 11:18:06
11595	9d5ccb05-3bc2-4a84-a48a-9cc6a591d2ba	9d5ccb05-410c-4562-b2d0-e1c967995578	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '18' and \\"users\\".\\"deleted_at\\" is null","time":"149.15","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":54,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-29 11:18:06
11596	9d5ccb05-3c19-48c3-967d-77a618b3de31	9d5ccb05-410c-4562-b2d0-e1c967995578	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 11:18:06
11597	9d5ccb05-3faf-44d6-adcb-6bcc3a368c16	9d5ccb05-410c-4562-b2d0-e1c967995578	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 11:18:06
19534	9d66e029-bc22-4190-98b1-28643927b719	9d66e029-c3dd-4422-9a50-ed365acfddbf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"95.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:35:30
820	9d4f311d-5c96-4ffe-aa1c-292fd7bb77d3	9d4f311d-96bc-4a86-aad5-99f7ba91f7c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 17:01:59
821	9d4f311d-8baa-4856-842c-25d5070615e8	9d4f311d-96bc-4a86-aad5-99f7ba91f7c8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"70.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-22 17:01:59
822	9d4f311d-8c6c-4aaf-ac5b-a565634d2925	9d4f311d-96bc-4a86-aad5-99f7ba91f7c8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":3,"hostname":"EderCortes"}	2024-10-22 17:01:59
823	9d4f311d-9468-440a-93b8-9a69d33836d9	9d4f311d-96bc-4a86-aad5-99f7ba91f7c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 17:01:59
824	9d4f311d-9500-4db2-8695-7b9620b4c38e	9d4f311d-96bc-4a86-aad5-99f7ba91f7c8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":638,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:01:59
1513	9d50d312-1229-42c5-b458-169ab544f474	9d50d312-158c-4ad0-b4a5-e13922d363fd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":154,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:30:41
12552	9d5ceae3-3089-444c-b996-7fb45b6a98cf	9d5ceae3-33a5-4db6-bac0-cf8efc052166	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":168,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:47:13
2147	9d50e3be-5966-4643-9fce-10901ac012b0	9d50e3be-6076-49d4-97b7-9b58e6a8447f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 13:17:18
2148	9d50e3be-5ee9-4035-aa61-dbc10d26c293	9d50e3be-6076-49d4-97b7-9b58e6a8447f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 13:17:18
2149	9d50e3be-5f35-4f27-a8c3-e1a650071363	9d50e3be-6076-49d4-97b7-9b58e6a8447f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":459,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:17:18
2207	9d50e4fa-6f84-41fa-8c5c-0b9dc8ad73a8	9d50e4fa-74a8-4d42-9acd-2814ce812459	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder tes%' or \\"users\\".\\"user_document\\"::text like '%eder tes%' order by \\"users\\".\\"user_document\\" asc","time":"44.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:20:45
2208	9d50e4fa-7321-43c8-8e2d-d933097e4f2a	9d50e4fa-74a8-4d42-9acd-2814ce812459	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 13:20:45
2209	9d50e4fa-737e-497e-a5ba-da89697ef339	9d50e4fa-74a8-4d42-9acd-2814ce812459	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"30","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder tes"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":267,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:20:45
11598	9d5ccb05-3ffd-4969-8c5d-0bf2ac302dd5	9d5ccb05-410c-4562-b2d0-e1c967995578	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/18","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}},"duration":392,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:18:06
11307	9d5cb51f-903c-4754-911d-41ae1f7cdda7	9d5cb51f-92ca-44b1-b0b7-2ea2d75f43e5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/_ignition\\/health-check","method":"GET","controller_action":"Spatie\\\\LaravelIgnition\\\\Http\\\\Controllers\\\\HealthCheckController","middleware":["Spatie\\\\LaravelIgnition\\\\Http\\\\Middleware\\\\RunnableSolutionsEnabled"],"headers":{"host":"127.0.0.1:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","accept":"*\\/*","sec-fetch-site":"same-origin","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/127.0.0.1:8000\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-ES,es;q=0.9"},"payload":[],"session":[],"response_status":200,"response":{"can_execute_commands":true},"duration":579,"memory":26,"hostname":"EderCortes"}	2024-10-29 10:16:52
12317	9d5ce214-f3b0-4dfe-92f8-5af9bf2e05df	9d5ce214-f496-4b5a-93d2-cddc2388cce8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAri"},"session":[],"response_status":200,"response":{"data":[]},"duration":208,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:22:35
612	9d4f2d69-b71f-4078-b50d-f703e9ac632f	9d4f2d69-d623-4035-9241-475b65746ce0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 16:51:38
613	9d4f2d69-d488-4490-9054-881302933b68	9d4f2d69-d623-4035-9241-475b65746ce0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 16:51:38
614	9d4f2d69-d529-4e52-8de5-62e806620294	9d4f2d69-d623-4035-9241-475b65746ce0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":272,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:51:38
12553	9d5ceae3-d3ca-4522-9f2a-485245ac52c0	9d5ceae3-d6c8-4255-a75a-0c743e5a2eab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":146,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:47:13
12851	9d5ced4a-0d6e-40a0-a5a2-88849f3b66d8	9d5ced4a-1109-465c-acba-f0951b02e599	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":155,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:53:56
13133	9d5cf980-ca90-460f-ac4d-805197531c15	9d5cf980-cbdb-449c-a3d2-474eb541f3fe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":472,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:28:05
19535	9d66e029-bd02-47f3-bb7a-f2522ed1e1e8	9d66e029-c3dd-4422-9a50-ed365acfddbf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:35:30
19536	9d66e029-c23d-4434-9f1a-d5b2a9712f8d	9d66e029-c3dd-4422-9a50-ed365acfddbf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:35:30
29462	9d692474-0a6d-41e3-9cad-f7cbd0af8b90	9d692474-1390-45f1-b3fa-762e14446921	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 14:38:07
1514	9d50d312-95a0-4349-b452-4b6ccc0641f3	9d50d312-9e3f-4f9e-983e-d01adb060c22	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 12:30:41
1134	9d4fbd18-c78d-43e5-a454-46aaee5bfc9e	9d4fbd1d-42f3-4459-bd23-ce8f81c373e0	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 23:33:25
1135	9d4fbd1c-e5b4-41ef-9105-5d1741594723	9d4fbd1d-42f3-4459-bd23-ce8f81c373e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 23:33:27
1136	9d4fbd1d-0c02-417d-a2fc-6ac6923dcc81	9d4fbd1d-42f3-4459-bd23-ce8f81c373e0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":23345,"memory":22,"hostname":"EderCortes"}	2024-10-22 23:33:27
890	9d4f33ec-d85b-47bc-a3c4-2d7ea8347e6a	9d4f33ed-03a2-4bae-9a61-aaf5ec9f9d55	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 17:09:51
891	9d4f33ed-00e8-4834-a2ee-ae6f340dd732	9d4f33ed-03a2-4bae-9a61-aaf5ec9f9d55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 17:09:51
892	9d4f33ed-0212-435b-92bf-0ef39bdfa4c4	9d4f33ed-03a2-4bae-9a61-aaf5ec9f9d55	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":337,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:09:51
1515	9d50d312-9cd7-485a-b4f6-04d1b048bc18	9d50d312-9e3f-4f9e-983e-d01adb060c22	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 12:30:41
1516	9d50d312-9d1d-46c0-a7fb-0133a8e26719	9d50d312-9e3f-4f9e-983e-d01adb060c22	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"mier"},"session":[],"response_status":200,"response":{"code":4,"search":"mier"},"duration":178,"memory":20,"hostname":"EderCortes"}	2024-10-23 12:30:41
11599	9d5ccb32-a8ec-41cc-9108-374e266db34c	9d5ccb32-abc4-4f86-94b2-867b97518aba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":148,"memory":20,"hostname":"EderCortes"}	2024-10-29 11:18:36
12318	9d5ce215-3ea2-4caf-ac67-3c2141f0385a	9d5ce215-5909-4115-b680-c3eb1586900a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 12:22:35
11308	9d5cb526-d9db-4b21-be8d-d6f792e68830	9d5cb526-dc3f-4838-9920-0fdda3fbd049	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/barrio","method":"GET","controller_action":null,"middleware":[],"headers":{"host":"127.0.0.1:8000","connection":"keep-alive","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-ES,es;q=0.9"},"payload":[],"session":[],"response_status":404,"response":{"error":"No se encontro la url especificada","code":404},"duration":237,"memory":20,"hostname":"EderCortes"}	2024-10-29 10:16:57
12319	9d5ce215-54da-492a-90e5-744521ba5ac2	9d5ce215-5909-4115-b680-c3eb1586900a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and \\"users\\".\\"name\\"::text like '%MAria%' or \\"users\\".\\"user_document\\"::text like '%MAria%' order by \\"users\\".\\"user_document\\" asc","time":"41.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"346e96d5b86098f6cea2c4bc11d5ca30","hostname":"EderCortes"}	2024-10-29 12:22:36
12320	9d5ce215-57aa-4711-9174-a2ecc1dda071	9d5ce215-5909-4115-b680-c3eb1586900a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 12:22:36
12321	9d5ce215-57eb-4989-baf7-c01b4947d05a	9d5ce215-5909-4115-b680-c3eb1586900a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAria"},"session":[],"response_status":200,"response":{"data":[]},"duration":221,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:22:36
12554	9d5ceae4-4beb-476c-bc0b-d5015da75461	9d5ceae4-9552-4ffc-9a89-d47f4acb216b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 12:47:13
12555	9d5ceae4-8fdd-4ca0-8a74-8995c9d61d97	9d5ceae4-9552-4ffc-9a89-d47f4acb216b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"145.64","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:47:13
12556	9d5ceae4-93e8-4f5a-80f1-468987a5458a	9d5ceae4-9552-4ffc-9a89-d47f4acb216b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:47:14
13134	9d5cf981-b278-45df-9840-eaf2af4c2f81	9d5cf981-f126-40e6-a327-79e90b8121df	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 13:28:05
29463	9d692474-1160-4f69-9f28-21f4b9476f49	9d692474-1390-45f1-b3fa-762e14446921	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 14:38:07
30710	9d69427e-d4bd-4e78-8bbd-375383e39df8	9d69427e-f4d4-424c-8d5e-ebd61d36a4d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 16:02:07
1137	9d4fbd1d-bbf0-4ae0-9d9d-861e1858a20d	9d4fbd1f-8211-4b79-a000-754415fcdbcd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 23:33:28
1138	9d4fbd1e-6e87-48a7-8748-ad5bac127cc8	9d4fbd1f-8211-4b79-a000-754415fcdbcd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-22 23:33:28
1139	9d4fbd1e-6ee0-4950-9fc8-dcec72a57eea	9d4fbd1f-8211-4b79-a000-754415fcdbcd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-22 23:33:28
1140	9d4fbd1f-7fd4-49fa-b066-05f0ad6256f4	9d4fbd1f-8211-4b79-a000-754415fcdbcd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 23:33:29
1141	9d4fbd1f-8044-427a-8dbf-92505dfc1f79	9d4fbd1f-8211-4b79-a000-754415fcdbcd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":1396,"memory":22,"hostname":"EderCortes"}	2024-10-22 23:33:29
11309	9d5cb534-3b4d-4df1-824d-60e02fa3bd83	9d5cb534-89b0-4d3b-9985-4d4b122c307d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 10:17:06
1206	9d50c533-0a68-4c8c-ad4a-fe2e0cf17780	9d50c534-6beb-4a0d-891f-4ec342a2f4f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 11:51:54
1207	9d50c534-69e6-46b0-aadc-d68597e5ea8c	9d50c534-6beb-4a0d-891f-4ec342a2f4f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 11:51:54
1208	9d50c534-6abb-43b5-aa9c-b1f3bcfc3092	9d50c534-6beb-4a0d-891f-4ec342a2f4f9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1131,"memory":22,"hostname":"EderCortes"}	2024-10-23 11:51:54
11310	9d5cb534-82d0-496d-b31e-e2168fdcf572	9d5cb534-89b0-4d3b-9985-4d4b122c307d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"151.20","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 10:17:06
1776	9d50dd93-898f-4717-8843-b006e6e3e894	9d50dd93-8a93-4aad-b925-356eecbea1f0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder"},"session":[],"response_status":200,"response":{"data":[{"name":"Luis andre","user_document":"100465545","id":14}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:00:03
2210	9d50e4fa-bd93-4df1-8a33-90d1c6cbcfbf	9d50e4fa-d996-4b62-94a4-88f8f3363327	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 13:20:45
2211	9d50e4fa-d506-442f-becb-bb9bb15f6eb5	9d50e4fa-d996-4b62-94a4-88f8f3363327	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder test%' or \\"users\\".\\"user_document\\"::text like '%eder test%' order by \\"users\\".\\"user_document\\" asc","time":"43.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:20:45
2212	9d50e4fa-d838-410d-a742-9012d2d744ca	9d50e4fa-d996-4b62-94a4-88f8f3363327	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 13:20:45
2213	9d50e4fa-d87b-4040-a0c6-a2be1694b81e	9d50e4fa-d996-4b62-94a4-88f8f3363327	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"31","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder test"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":248,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:20:45
11311	9d5cb534-8350-4dea-a0b7-6a93497e0041	9d5cb534-89b0-4d3b-9985-4d4b122c307d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 10:17:06
11312	9d5cb534-87fb-49af-9f76-08631716acc2	9d5cb534-89b0-4d3b-9985-4d4b122c307d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 10:17:06
12322	9d5ce21c-2876-49a8-bd3f-38e36bee96d4	9d5ce21c-2ba6-4ecd-b739-7868454541f6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":156,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:22:40
1142	9d4fbd1f-de4f-49fd-8df3-9bf8b647fde2	9d4fbd1f-fe77-4775-accf-cc008d1ccbe1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 23:33:29
1143	9d4fbd1f-f8d9-4ebe-93fd-95824504ed8c	9d4fbd1f-fe77-4775-accf-cc008d1ccbe1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-22 23:33:29
1144	9d4fbd1f-f92b-4274-8202-ed5e6d3acc9f	9d4fbd1f-fe77-4775-accf-cc008d1ccbe1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-22 23:33:29
1145	9d4fbd1f-fd2c-49f5-ada4-962fe5718922	9d4fbd1f-fe77-4775-accf-cc008d1ccbe1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 23:33:29
1146	9d4fbd1f-fd7c-4050-8bd8-69a63e29499c	9d4fbd1f-fe77-4775-accf-cc008d1ccbe1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":299,"memory":22,"hostname":"EderCortes"}	2024-10-22 23:33:29
1209	9d50c535-acf4-41c7-9867-3911e47f66de	9d50c535-cde8-4a49-a11f-48518138c40c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 11:51:55
1210	9d50c535-c7f4-45bd-b7b5-795ff71ee794	9d50c535-cde8-4a49-a11f-48518138c40c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 11:51:55
1211	9d50c535-c841-4696-ac1d-0ddccb942c43	9d50c535-cde8-4a49-a11f-48518138c40c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 11:51:55
1212	9d50c535-cb9d-48d4-8014-50f2bce7ec15	9d50c535-cde8-4a49-a11f-48518138c40c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 11:51:55
1213	9d50c535-cc43-4fe8-a007-b6055ae19098	9d50c535-cde8-4a49-a11f-48518138c40c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-10-23 11:51:55
11313	9d5cb534-8850-4e91-b138-735a35b37e56	9d5cb534-89b0-4d3b-9985-4d4b122c307d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":368,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:17:06
1777	9d50dd93-ca13-4978-bec3-5969244c2ae5	9d50dd93-ccf7-4806-a446-2ea650e205ea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":143,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:00:03
12323	9d5ce21c-8daa-4d53-b63a-e83d1e8aa713	9d5ce21c-cff6-4204-9c27-cc6668bc0345	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 12:22:40
30711	9d69427e-ef88-4094-9ee9-c96bb17b2eaa	9d69427e-f4d4-424c-8d5e-ebd61d36a4d5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '19' and \\"users\\".\\"deleted_at\\" is null","time":"42.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":55,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-11-04 16:02:07
30712	9d69427e-efe5-46e8-85d6-f61fbc363604	9d69427e-f4d4-424c-8d5e-ebd61d36a4d5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 16:02:07
11314	9d5cb545-3254-44c8-83e0-c66891268e1f	9d5cb545-3b27-427d-811e-5b8b81e93eea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 10:17:17
1648	9d50d9c8-fdce-4a60-9b8c-bc3ef978ed03	9d50d9c9-50de-4929-b628-897110d1aee0	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 12:49:27
948	9d4f3969-5111-492b-95a3-7dc40bb43457	9d4f3969-79ba-4135-a681-b39706f61e46	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 17:25:11
949	9d4f3969-779d-4997-a314-b0daaea0dcee	9d4f3969-79ba-4135-a681-b39706f61e46	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 17:25:11
950	9d4f3969-7890-4488-89db-f7991f764ada	9d4f3969-79ba-4135-a681-b39706f61e46	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":324,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:25:11
1649	9d50d9c9-4e61-4ede-8dbd-a63c333451d5	9d50d9c9-50de-4929-b628-897110d1aee0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:49:27
1650	9d50d9c9-4f79-4f56-9070-17b6b9597b62	9d50d9c9-50de-4929-b628-897110d1aee0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":508,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:49:27
11315	9d5cb545-39e4-452b-ba67-7a02eab09b84	9d5cb545-3b27-427d-811e-5b8b81e93eea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 10:17:17
11316	9d5cb545-3a3b-41c6-a63e-431e14f448d3	9d5cb545-3b27-427d-811e-5b8b81e93eea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/barrio","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\barrio\\\\BarrioController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":"Empty Response","duration":251,"memory":20,"hostname":"EderCortes"}	2024-10-29 10:17:17
1147	9d4fbd21-afbf-4518-8ac8-23bdc147775e	9d4fbd21-dd9a-4e74-944c-63e63b4dcd7e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 23:33:30
12324	9d5ce21c-ca72-4be0-9b57-3c54e4b0ef83	9d5ce21c-cff6-4204-9c27-cc6668bc0345	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and \\"users\\".\\"name\\"::text like '%MAri%' or \\"users\\".\\"user_document\\"::text like '%MAri%' order by \\"users\\".\\"user_document\\" asc","time":"138.72","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"346e96d5b86098f6cea2c4bc11d5ca30","hostname":"EderCortes"}	2024-10-29 12:22:40
12325	9d5ce21c-ce97-4726-9c10-3523f4f3c3cb	9d5ce21c-cff6-4204-9c27-cc6668bc0345	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 12:22:40
1778	9d50dd94-4d7a-4691-aad7-80efa1b45d27	9d50dd94-9328-4327-be4d-1619802a201f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 13:00:04
1779	9d50dd94-8ec2-4137-8cf7-5c4d278ec2de	9d50dd94-9328-4327-be4d-1619802a201f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"name\\", \\"users\\".\\"user_document\\", \\"users\\".\\"id\\" from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder%' or \\"users\\".\\"user_document\\"::text like '%eder%' order by \\"users\\".\\"user_document\\" asc","time":"151.60","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"71e2e94a1a5a1b5c9b9dc051aea4b922","hostname":"EderCortes"}	2024-10-23 13:00:04
1780	9d50dd94-91b8-49d0-ae5d-596f62f89d0d	9d50dd94-9328-4327-be4d-1619802a201f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 13:00:04
12326	9d5ce21c-ceee-473f-8ba4-ba51357581a0	9d5ce21c-cff6-4204-9c27-cc6668bc0345	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAri"},"session":[],"response_status":200,"response":{"data":[]},"duration":321,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:22:40
12557	9d5ceae4-943f-4171-ba3a-1db90914ecdb	9d5ceae4-9552-4ffc-9a89-d47f4acb216b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":334,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:47:14
12852	9d5ced4a-8b94-4469-8239-7ba48e178c0a	9d5ced4a-8eaa-4efa-822d-f01d1af32525	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":142,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:53:56
30713	9d69427e-f395-42c1-9f62-4a5fa9a0f114	9d69427e-f4d4-424c-8d5e-ebd61d36a4d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 16:02:07
32086	9d695a41-b1bd-4780-b4d4-c677be19888b	9d695a41-e0b1-4bfe-a521-24d6d815e3b1	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 17:08:33
1651	9d50d9c9-b4a7-407c-ace1-c07cb139dd7d	9d50d9c9-d9f0-4c59-8f2f-8b6c18aa22c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:49:28
710	9d4f2e22-6c26-4e23-af6c-7a53d6334c94	9d4f2e22-b97f-47fc-af04-1546572dc40b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-22 16:53:39
711	9d4f2e22-b727-481d-aac5-48c5a74fe040	9d4f2e22-b97f-47fc-af04-1546572dc40b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-22 16:53:40
712	9d4f2e22-b81d-4eef-8cf1-555e3deb0360	9d4f2e22-b97f-47fc-af04-1546572dc40b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":361,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:53:40
1652	9d50d9c9-d2cf-4c77-a280-b6be75ba69c1	9d50d9c9-d9f0-4c59-8f2f-8b6c18aa22c3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":65,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:49:28
1653	9d50d9c9-d331-4e80-b6d5-5defac47f2af	9d50d9c9-d9f0-4c59-8f2f-8b6c18aa22c3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 12:49:28
1654	9d50d9c9-d89c-43b4-b642-2aa0c1d0f04f	9d50d9c9-d9f0-4c59-8f2f-8b6c18aa22c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:49:28
951	9d4f396b-7650-4150-946d-856a22d001b3	9d4f396b-cd4d-4e1e-a938-fa44305da404	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 17:25:13
1148	9d4fbd21-d2fa-4dfa-9eee-ccc89ce4ecb7	9d4fbd21-dd9a-4e74-944c-63e63b4dcd7e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"56.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-22 23:33:30
1149	9d4fbd21-d37c-4425-a4ef-dec6b8e0f57f	9d4fbd21-dd9a-4e74-944c-63e63b4dcd7e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 23:33:30
1150	9d4fbd21-db6c-47f9-8559-27ce03014ce6	9d4fbd21-dd9a-4e74-944c-63e63b4dcd7e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 23:33:30
1655	9d50d9c9-d900-4eb7-8e84-ab12f6290fbd	9d50d9c9-d9f0-4c59-8f2f-8b6c18aa22c3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":327,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:49:28
11317	9d5cb71b-a13a-4216-8dcc-8b960d3637bc	9d5cb71b-ab89-4be6-bfaa-f8f29ae2813c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 10:22:25
11318	9d5cb71b-a9ad-4b20-91f4-b784998dc593	9d5cb71b-ab89-4be6-bfaa-f8f29ae2813c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 10:22:25
11319	9d5cb71b-aa20-461f-a495-1b2c3ba76297	9d5cb71b-ab89-4be6-bfaa-f8f29ae2813c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/barrio","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\barrio\\\\BarrioController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":"Empty Response","duration":261,"memory":20,"hostname":"EderCortes"}	2024-10-29 10:22:25
11606	9d5ccbbf-8654-46a9-9e01-3d033394cf8b	9d5ccbbf-8b2a-4d3c-b086-a7e50828e410	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":218,"memory":20,"hostname":"EderCortes"}	2024-10-29 11:20:08
12327	9d5ce21e-f944-478d-a7de-94c00af5508b	9d5ce21e-fcc8-4fd2-9611-6803da9f8abf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":149,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:22:42
12558	9d5ceae4-e75c-406e-954d-d716f7441742	9d5ceae5-2a93-410c-af3d-287f1d61a862	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:47:14
12559	9d5ceae5-24d3-4f72-83f7-6c2a261872e2	9d5ceae5-2a93-410c-af3d-287f1d61a862	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"141.73","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:47:14
12560	9d5ceae5-291b-47bd-95c4-0a1a7a595291	9d5ceae5-2a93-410c-af3d-287f1d61a862	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:47:14
713	9d4f2e23-1491-4b38-839e-9459e235d6f3	9d4f2e23-3f98-43e3-9df5-747e692038d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-22 16:53:40
714	9d4f2e23-37b6-4439-81d4-4b3bf4bdf84b	9d4f2e23-3f98-43e3-9df5-747e692038d2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"52.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-22 16:53:40
715	9d4f2e23-3844-4fb7-8065-8ee784335ad7	9d4f2e23-3f98-43e3-9df5-747e692038d2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":3,"hostname":"EderCortes"}	2024-10-22 16:53:40
716	9d4f2e23-3dac-4ce7-927a-75cbd09c1fae	9d4f2e23-3f98-43e3-9df5-747e692038d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-22 16:53:40
717	9d4f2e23-3e10-4697-813d-eb8dc76b38f9	9d4f2e23-3f98-43e3-9df5-747e692038d2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":320,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:53:40
952	9d4f396b-c418-4844-91b1-2ef3224f061b	9d4f396b-cd4d-4e1e-a938-fa44305da404	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"166.78","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-22 17:25:13
953	9d4f396b-c487-499c-890f-046dec6a0106	9d4f396b-cd4d-4e1e-a938-fa44305da404	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 17:25:13
954	9d4f396b-cb96-4cfc-a6e7-ec807ca0310a	9d4f396b-cd4d-4e1e-a938-fa44305da404	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 17:25:13
955	9d4f396b-cc01-48c6-b93e-250b7d66db8c	9d4f396b-cd4d-4e1e-a938-fa44305da404	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":669,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:25:13
1151	9d4fbd21-dbf7-4262-857a-4e4ff8a2e935	9d4fbd21-dd9a-4e74-944c-63e63b4dcd7e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":422,"memory":22,"hostname":"EderCortes"}	2024-10-22 23:33:30
1656	9d50d9ca-26d5-4e53-9500-37678096b079	9d50d9ca-4c7e-42e3-8908-dd686ec08b19	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:49:28
1657	9d50d9ca-43e6-43e6-af3d-e7243ad47ff0	9d50d9ca-4c7e-42e3-8908-dd686ec08b19	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"50.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":65,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:49:28
1658	9d50d9ca-4476-49fc-8312-12daccd4c97e	9d50d9ca-4c7e-42e3-8908-dd686ec08b19	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 12:49:28
1659	9d50d9ca-4ab4-424b-97e4-811e1e0d2874	9d50d9ca-4c7e-42e3-8908-dd686ec08b19	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:49:28
2150	9d50e3c4-2dc4-4eab-8126-c876bedce2e9	9d50e3c4-308e-4733-9562-0d29afe47a30	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":144,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:17:22
718	9d4f2e25-13be-4129-ae49-164d0dfa6bc5	9d4f2e25-3520-42d9-9bde-d3cfd75335c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-22 16:53:41
719	9d4f2e25-2dc1-47e5-a282-29c29c4ac510	9d4f2e25-3520-42d9-9bde-d3cfd75335c5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"46.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 16:53:41
720	9d4f2e25-2e48-43ad-980a-c18c7516540c	9d4f2e25-3520-42d9-9bde-d3cfd75335c5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 16:53:41
721	9d4f2e25-3394-40c1-9ee4-7691193daf9d	9d4f2e25-3520-42d9-9bde-d3cfd75335c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-22 16:53:41
626	9d4f2d7c-53be-40d2-bfa2-46a864c54ff1	9d4f2d7c-7829-4f10-a64b-ce89764247ad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-22 16:51:51
627	9d4f2d7c-761e-4546-8001-447f5efff1aa	9d4f2d7c-7829-4f10-a64b-ce89764247ad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-22 16:51:51
628	9d4f2d7c-76df-42c2-aed5-07f19e774891	9d4f2d7c-7829-4f10-a64b-ce89764247ad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":277,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:51:51
722	9d4f2e25-33f9-43d8-a4e7-061c526e157e	9d4f2e25-3520-42d9-9bde-d3cfd75335c5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":371,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:53:41
1660	9d50d9ca-4b3e-4bb2-a245-1321910c382a	9d50d9ca-4c7e-42e3-8908-dd686ec08b19	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":277,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:49:28
11320	9d5cb7b9-04a4-4292-be31-ae2a27b3da45	9d5cb7b9-0f55-42bf-9a09-b89d223a6413	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 10:24:09
1781	9d50dd94-9218-4f15-8ddd-e9dc99d4f6a5	9d50dd94-9328-4327-be4d-1619802a201f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder"},"session":[],"response_status":200,"response":{"data":[{"name":"Luis andre","user_document":"100465545","id":14}]},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:00:04
2151	9d50e3c4-88a7-4649-ab98-271b888c1767	9d50e3c4-a205-4d35-9213-e1610ad5cf5e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 13:17:22
2152	9d50e3c4-9e25-4f84-8723-8d11846a9a3e	9d50e3c4-a205-4d35-9213-e1610ad5cf5e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder%' or \\"users\\".\\"user_document\\"::text like '%eder%' order by \\"users\\".\\"user_document\\" asc","time":"40.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:17:22
2153	9d50e3c4-a0e6-4a58-a5bd-7fa20b32b833	9d50e3c4-a205-4d35-9213-e1610ad5cf5e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 13:17:22
2214	9d50e500-5656-481f-9fb0-377c3251a2d7	9d50e500-5973-4529-924a-8c93a3812c37	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":155,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:20:49
3098	9d5101c6-ae3f-4af0-85a3-2fcf1f21c161	9d5101c6-af0a-44b0-8d79-19c597fbb060	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":389,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:41:17
826	9d4f311f-e1ab-4271-8d96-588e159678f9	9d4f3120-03c3-46cd-bb57-df099b9ae334	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 17:02:01
827	9d4f3120-0148-4717-92d2-9cfe10cb0b6a	9d4f3120-03c3-46cd-bb57-df099b9ae334	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-22 17:02:01
828	9d4f3120-0269-4250-a3fc-5ee5a889cb95	9d4f3120-03c3-46cd-bb57-df099b9ae334	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":272,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:02:01
11321	9d5cb7b9-0d89-4c4f-8126-1940ec21070f	9d5cb7b9-0f55-42bf-9a09-b89d223a6413	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 10:24:09
1661	9d50d9cc-0712-4f24-a2f7-32ba6529817d	9d50d9cc-244b-4ac8-acd5-b4deeb9fc481	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:49:29
1662	9d50d9cc-1f6f-495b-b648-ee9babfd45ea	9d50d9cc-244b-4ac8-acd5-b4deeb9fc481	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 12:49:29
1663	9d50d9cc-1fbe-4ea3-aec4-c233460e0cd7	9d50d9cc-244b-4ac8-acd5-b4deeb9fc481	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 12:49:29
1664	9d50d9cc-230d-4b3d-97d5-c85ca96623a7	9d50d9cc-244b-4ac8-acd5-b4deeb9fc481	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 12:49:29
2215	9d50e500-d1d7-4420-804a-dbd524ac72dd	9d50e500-ec2b-445f-a925-c0704160a903	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 13:20:49
1665	9d50d9cc-2350-4b7f-99d5-59a32c8ec2da	9d50d9cc-244b-4ac8-acd5-b4deeb9fc481	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:49:29
1782	9d50dd96-01e1-4f40-966b-2109941afca5	9d50dd96-04b0-4b6f-8656-e03a4e3225f9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":134,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:00:05
2216	9d50e500-e860-4df0-b12a-9d25a6d0670e	9d50e500-ec2b-445f-a925-c0704160a903	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%test%' or \\"users\\".\\"user_document\\"::text like '%test%' order by \\"users\\".\\"user_document\\" asc","time":"42.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:20:49
2217	9d50e500-eb11-452c-b2bb-97060d949259	9d50e500-ec2b-445f-a925-c0704160a903	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 13:20:49
2218	9d50e500-eb53-4e68-b8a6-0278811fae0d	9d50e500-ec2b-445f-a925-c0704160a903	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"test"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":208,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:20:49
829	9d4f3121-8955-4a43-bf4a-cd278512b7a0	9d4f3121-d9a8-4219-8231-861ee2efa92f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-22 17:02:02
830	9d4f3121-d2ac-40d8-b036-4f305d00f6a5	9d4f3121-d9a8-4219-8231-861ee2efa92f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"157.37","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 17:02:02
831	9d4f3121-d30c-45c8-9f04-56fd80c1cc89	9d4f3121-d9a8-4219-8231-861ee2efa92f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 17:02:02
832	9d4f3121-d829-43fe-9668-29d0d21d0ac0	9d4f3121-d9a8-4219-8231-861ee2efa92f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-22 17:02:02
833	9d4f3121-d887-4f14-ba76-0d17a295b3eb	9d4f3121-d9a8-4219-8231-861ee2efa92f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":487,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:02:02
3099	9d5101c7-4a56-4bd6-988f-81a8d409f604	9d5101c7-8dd4-4ad8-b695-5f18f3778c2a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 14:41:17
848	9d4f320b-5048-4fda-a761-5d528592f105	9d4f320b-9c8c-4256-a38a-06bdd44fbc49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 17:04:35
849	9d4f320b-984e-4671-8d91-36e3772ec63c	9d4f320b-9c8c-4256-a38a-06bdd44fbc49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 17:04:35
850	9d4f320b-98eb-4f85-99b3-d6ecf8abc6ac	9d4f320b-9c8c-4256-a38a-06bdd44fbc49	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":370,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:04:35
2719	9d50fb38-184f-4b18-9291-74406d80bab3	9d50fb38-402c-4dd2-a8f6-12c13b816923	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:22:57
1783	9d50dd96-6d52-4589-90c1-1540df65a4a4	9d50dd96-86e8-40ae-8458-fb9a21b82ee6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 13:00:05
1784	9d50dd96-82b5-4e19-9049-8c1814d1fe3f	9d50dd96-86e8-40ae-8458-fb9a21b82ee6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"name\\", \\"users\\".\\"user_document\\", \\"users\\".\\"id\\" from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"40.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"71e2e94a1a5a1b5c9b9dc051aea4b922","hostname":"EderCortes"}	2024-10-23 13:00:05
1785	9d50dd96-85ad-4487-931a-ce897c2cb207	9d50dd96-86e8-40ae-8458-fb9a21b82ee6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-23 13:00:05
1786	9d50dd96-85f8-4722-9ea0-59408eec5074	9d50dd96-86e8-40ae-8458-fb9a21b82ee6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"name":"Eder Arley","user_document":"1004608333","id":12},{"name":"Luis andre","user_document":"100465545","id":14}]},"duration":214,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:00:05
2720	9d50fb38-3865-47d0-8efe-84b0c8ac6e84	9d50fb38-402c-4dd2-a8f6-12c13b816923	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"50.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:22:57
2721	9d50fb38-38c4-4a47-a3d9-41754f4332ed	9d50fb38-402c-4dd2-a8f6-12c13b816923	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:22:57
2722	9d50fb38-3ec7-45a9-85a7-31b81934c040	9d50fb38-402c-4dd2-a8f6-12c13b816923	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:22:57
2723	9d50fb38-3f23-45a4-bf4b-b5bced56d85d	9d50fb38-402c-4dd2-a8f6-12c13b816923	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":360,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:22:57
32087	9d695a41-d6ed-4c00-9a8e-762921cd9f82	9d695a41-e0b1-4bfe-a521-24d6d815e3b1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"49.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":19,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-04 17:08:33
11443	9d5cbe75-035b-43ce-9482-2954bd3dc798	9d5cbe75-0d3d-42d0-b467-f3c44299c8ab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 1\\n                        ","time":"50.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"2bd5a29c69f6bbb290fc49b79286632e","hostname":"EderCortes"}	2024-10-29 10:42:58
32088	9d695a41-d75b-43fd-ac22-be033df74737	9d695a41-e0b1-4bfe-a521-24d6d815e3b1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 17:08:33
32089	9d695a41-ded0-496f-a56f-58fe921986e0	9d695a41-e0b1-4bfe-a521-24d6d815e3b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 17:08:33
11322	9d5cb7b9-0e03-4031-8bab-9c08cf52b076	9d5cb7b9-0f55-42bf-9a09-b89d223a6413	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/barrio","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\barrio\\\\BarrioController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":"Empty Response","duration":248,"memory":20,"hostname":"EderCortes"}	2024-10-29 10:24:09
851	9d4f320c-f20b-43b5-8779-49057827b02b	9d4f320d-4297-4bd3-ae33-287b6fb101bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 17:04:36
852	9d4f320d-3c1c-4998-ace5-70865954fe87	9d4f320d-4297-4bd3-ae33-287b6fb101bb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"159.20","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 17:04:37
853	9d4f320d-3c99-4795-953f-868fb2f57fb6	9d4f320d-4297-4bd3-ae33-287b6fb101bb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 17:04:37
854	9d4f320d-412f-4aa5-8a40-60b306cfeba3	9d4f320d-4297-4bd3-ae33-287b6fb101bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-22 17:04:37
855	9d4f320d-417f-4661-b891-98e784c658b9	9d4f320d-4297-4bd3-ae33-287b6fb101bb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":642,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:04:37
11444	9d5cbe75-07af-42d9-8928-8d5725a6160e	9d5cbe75-0d3d-42d0-b467-f3c44299c8ab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1' order by \\"item_loans\\".\\"id\\" asc","time":"2.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 10:42:58
11445	9d5cbe75-07e6-4909-8eb6-7d6eb7169629	9d5cbe75-0d3d-42d0-b467-f3c44299c8ab	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 10:42:58
11446	9d5cbe75-0c21-4da6-b8f3-5b72582e5b24	9d5cbe75-0d3d-42d0-b467-f3c44299c8ab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 10:42:58
11447	9d5cbe75-0c71-4b76-ac65-46d44c693411	9d5cbe75-0d3d-42d0-b467-f3c44299c8ab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":1,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]}},"duration":268,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:42:58
34834	9d69c033-83fa-42cd-a76a-27c5f3209ad8	9d69c033-ce7d-4a12-b43c-ea66213a7a7b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 21:53:37
11323	9d5cb87c-1c12-480e-a1a6-7192fe537534	9d5cb87c-26f4-4012-9a0e-6ff23bab87ee	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 10:26:16
1263	9d50c9be-e002-4d59-8129-82599c9f7d21	9d50c9bf-318d-49f1-98fd-f47f3ef21554	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 12:04:36
1264	9d50c9bf-2f30-478e-af23-570554debed9	9d50c9bf-318d-49f1-98fd-f47f3ef21554	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:04:36
1265	9d50c9bf-3040-4dff-a79c-b8a2dac0ce13	9d50c9bf-318d-49f1-98fd-f47f3ef21554	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":452,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:04:36
856	9d4f3219-a654-438b-97bb-f631ac90826a	9d4f3219-d31c-4914-a894-5f4eb4396ba9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-22 17:04:45
857	9d4f3219-cb80-4bc9-bad9-b4fda54c3a45	9d4f3219-d31c-4914-a894-5f4eb4396ba9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"57.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-22 17:04:45
858	9d4f3219-cc04-4c55-8626-b5a32df4ad21	9d4f3219-d31c-4914-a894-5f4eb4396ba9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":3,"hostname":"EderCortes"}	2024-10-22 17:04:45
859	9d4f3219-d130-4014-a21e-e509c6627ae1	9d4f3219-d31c-4914-a894-5f4eb4396ba9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-22 17:04:45
860	9d4f3219-d196-4107-8eb9-f1234f24c3e9	9d4f3219-d31c-4914-a894-5f4eb4396ba9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:04:45
2724	9d50fb38-951f-4289-a84d-74a40853dc25	9d50fb38-bbad-4212-b88b-eb28b58e3aab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:22:57
2154	9d50e3c4-a125-4e18-aee1-a27c723e0548	9d50e3c4-a205-4d35-9213-e1610ad5cf5e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":194,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:17:22
2219	9d50e50a-79bd-44b0-b7bb-8299fda9a42f	9d50e50a-7d1b-46d8-bc3f-8dc0dde04843	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":195,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:20:56
2725	9d50fb38-b4ee-4261-b550-8c92835d0f85	9d50fb38-bbad-4212-b88b-eb28b58e3aab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"52.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:22:57
2726	9d50fb38-b558-4a60-9714-2ca884926a2d	9d50fb38-bbad-4212-b88b-eb28b58e3aab	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:22:57
2727	9d50fb38-ba50-43d0-b0b8-4c16f97acc35	9d50fb38-bbad-4212-b88b-eb28b58e3aab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:22:57
2728	9d50fb38-baa9-42af-ab63-0e4f9aa429f6	9d50fb38-bbad-4212-b88b-eb28b58e3aab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":299,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:22:57
11324	9d5cb87c-24e2-4b76-bdf4-53fcdb28fd36	9d5cb87c-26f4-4012-9a0e-6ff23bab87ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 10:26:16
11448	9d5cbe76-dc2f-4ac6-abcf-193e488e406d	9d5cbe76-fa3c-4294-ac68-b8cb0fdd5994	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 10:43:00
11325	9d5cb87c-256d-47d8-82e6-164ce24d9fad	9d5cb87c-26f4-4012-9a0e-6ff23bab87ee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/barrio","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\barrio\\\\BarrioController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":"Empty Response","duration":235,"memory":20,"hostname":"EderCortes"}	2024-10-29 10:26:16
12561	9d5ceae5-2977-44f7-b76e-04234b45343c	9d5ceae5-2a93-410c-af3d-287f1d61a862	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":363,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:47:14
12328	9d5ce21f-99c1-4d8d-b97e-97e082273745	9d5ce21f-9ca4-4fb7-9935-f7da8a778ded	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":132,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:22:42
894	9d4f33ed-7143-4ffa-b243-4cc7c825b91b	9d4f33ed-925f-4f0a-912b-dc9778a27d2a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 17:09:51
895	9d4f33ed-90b4-465e-9935-c1cd0c18b9e2	9d4f33ed-925f-4f0a-912b-dc9778a27d2a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 17:09:51
896	9d4f33ed-9158-40a9-8c5c-65e1aa55ec9a	9d4f33ed-925f-4f0a-912b-dc9778a27d2a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":342,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:09:51
12853	9d5ced4a-da1f-4de7-b4b9-541e9a55b3ea	9d5ced4a-dd29-49da-a10b-e83e64a1f8ef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":134,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:53:56
13135	9d5cf981-e74f-4804-acf0-041adce96f28	9d5cf981-f126-40e6-a327-79e90b8121df	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"90.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 13:28:05
13136	9d5cf981-e805-404e-a0fe-ea03f0e98500	9d5cf981-f126-40e6-a327-79e90b8121df	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 13:28:05
1044	9d4f3de6-c625-4e22-a7e5-047c6a7572c5	9d4f3de7-253b-42f8-ade9-ae1f258f0f82	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 17:37:45
11449	9d5cbe76-f550-40bc-aef9-134eae75c439	9d5cbe76-fa3c-4294-ac68-b8cb0fdd5994	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 10:43:00
13137	9d5cf981-ef66-46b9-80b2-e5dee9ee72e7	9d5cf981-f126-40e6-a327-79e90b8121df	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 13:28:05
13138	9d5cf981-eff5-4371-a883-d9f5e8702c2a	9d5cf981-f126-40e6-a327-79e90b8121df	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":731,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:28:05
897	9d4f33ef-7ac2-427e-ba8b-7089752cf9a3	9d4f33ef-bd26-4e36-b54b-8e602ed34e58	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 17:09:53
898	9d4f33ef-b398-4fd4-b678-814e46f92194	9d4f33ef-bd26-4e36-b54b-8e602ed34e58	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"103.26","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-22 17:09:53
899	9d4f33ef-b413-401f-a4ef-2438e5b0905d	9d4f33ef-bd26-4e36-b54b-8e602ed34e58	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 17:09:53
900	9d4f33ef-bb2a-49b5-82d3-c3385745a405	9d4f33ef-bd26-4e36-b54b-8e602ed34e58	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 17:09:53
901	9d4f33ef-bba8-4e1f-ad96-d1810a087cf4	9d4f33ef-bd26-4e36-b54b-8e602ed34e58	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":545,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:09:53
1045	9d4f3de7-2243-4951-b110-74931bc29fa1	9d4f3de7-253b-42f8-ade9-ae1f258f0f82	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 17:37:45
1046	9d4f3de7-237c-4251-9b00-f09e4c61346d	9d4f3de7-253b-42f8-ade9-ae1f258f0f82	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":538,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:37:45
1266	9d50c9bf-9caf-496c-8cbe-7f4856c5b38e	9d50c9bf-ea01-4b71-b09d-7a2207e0c984	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:04:37
1267	9d50c9bf-e22e-4395-984c-3085a3de338c	9d50c9bf-ea01-4b71-b09d-7a2207e0c984	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"151.55","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:04:37
1268	9d50c9bf-e2f2-4434-8143-c46741065b88	9d50c9bf-ea01-4b71-b09d-7a2207e0c984	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 12:04:37
1269	9d50c9bf-e856-4c40-acaa-012d240015e3	9d50c9bf-ea01-4b71-b09d-7a2207e0c984	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:04:37
1270	9d50c9bf-e8ba-4b42-ae1b-2dc3903fdc3d	9d50c9bf-ea01-4b71-b09d-7a2207e0c984	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":450,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:04:37
3100	9d5101c7-8289-47e1-951b-41bc67d07c12	9d5101c7-8dd4-4ad8-b695-5f18f3778c2a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"92.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:41:17
1474	9d50d296-b7ce-43af-adc0-e5eb1cd489d1	9d50d296-de03-4e7b-9fd0-c36dd4c8a8c1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:29:20
1475	9d50d296-d6a0-4809-8d05-a170680112e6	9d50d296-de03-4e7b-9fd0-c36dd4c8a8c1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":55,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:29:20
1476	9d50d296-d727-4a3c-8954-5bbe3dbf0bf9	9d50d296-de03-4e7b-9fd0-c36dd4c8a8c1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 12:29:20
1477	9d50d296-dc84-4ec9-9192-0f529cfac419	9d50d296-de03-4e7b-9fd0-c36dd4c8a8c1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:29:20
1478	9d50d296-dce7-4778-b7fc-9fe5a7ef0d46	9d50d296-de03-4e7b-9fd0-c36dd4c8a8c1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":353,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:29:20
3101	9d5101c7-8333-41ff-99d5-c0faea651926	9d5101c7-8dd4-4ad8-b695-5f18f3778c2a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:41:17
1047	9d4f3de7-9deb-4a2a-8c21-b7f89d641095	9d4f3de7-c17e-4162-94aa-f52741c244d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 17:37:45
1048	9d4f3de7-bad2-47bc-b68c-da50e3cf2fff	9d4f3de7-c17e-4162-94aa-f52741c244d2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-22 17:37:45
1049	9d4f3de7-bb4d-4fa2-9eef-dbebc55ebf0c	9d4f3de7-c17e-4162-94aa-f52741c244d2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-22 17:37:45
1050	9d4f3de7-c009-4378-8e32-bf5d3d810984	9d4f3de7-c17e-4162-94aa-f52741c244d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-22 17:37:45
1051	9d4f3de7-c05e-42df-af19-540e3ad151e9	9d4f3de7-c17e-4162-94aa-f52741c244d2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":329,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:37:45
1271	9d50c9c0-41ff-41e2-83b2-83a1d636effd	9d50c9c0-6c45-4b4d-9cb1-ff29bf9e99b7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:04:37
1272	9d50c9c0-64c9-4698-99c9-f5293d806caa	9d50c9c0-6c45-4b4d-9cb1-ff29bf9e99b7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"63.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:04:37
1273	9d50c9c0-653e-459f-a8b9-0e40182d882c	9d50c9c0-6c45-4b4d-9cb1-ff29bf9e99b7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 12:04:37
1274	9d50c9c0-6afe-4656-900d-dc53cf52f200	9d50c9c0-6c45-4b4d-9cb1-ff29bf9e99b7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:04:37
1275	9d50c9c0-6b51-41b8-ac2a-1a2b5c135627	9d50c9c0-6c45-4b4d-9cb1-ff29bf9e99b7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":320,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:04:37
3102	9d5101c7-8bad-4b98-b2cc-53a40a0ae1b1	9d5101c7-8dd4-4ad8-b695-5f18f3778c2a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 14:41:17
1479	9d50d297-3794-41e7-b4dd-f7f04ea91df4	9d50d297-5bbf-448a-a8f2-88b746ee93b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:29:20
1480	9d50d297-5396-4f1d-9b0d-740701c62453	9d50d297-5bbf-448a-a8f2-88b746ee93b0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":55,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:29:20
1481	9d50d297-5410-4733-8891-c65e0c15226f	9d50d297-5bbf-448a-a8f2-88b746ee93b0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 12:29:20
1482	9d50d297-5a43-4524-a6e7-1b83fc544b3d	9d50d297-5bbf-448a-a8f2-88b746ee93b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:29:20
1483	9d50d297-5a9b-4361-aca3-c5b6fc405536	9d50d297-5bbf-448a-a8f2-88b746ee93b0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":303,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:29:20
11450	9d5cbe76-f59f-443e-9487-07a70d25dc02	9d5cbe76-fa3c-4294-ac68-b8cb0fdd5994	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 10:43:00
11451	9d5cbe76-f901-4d74-b007-7afbf21dcdce	9d5cbe76-fa3c-4294-ac68-b8cb0fdd5994	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 10:43:00
11613	9d5ccc11-0551-4892-838a-c23db03582eb	9d5ccc11-0af1-45c3-8b33-52ae159b5b0d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":235,"memory":20,"hostname":"EderCortes"}	2024-10-29 11:21:02
640	9d4f2d8d-5dfe-4a08-8905-8bf087e31942	9d4f2d8d-819e-420e-863c-321f2d943e02	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 16:52:02
641	9d4f2d8d-7fa6-4847-a771-7c18c5bc3012	9d4f2d8d-819e-420e-863c-321f2d943e02	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:52:02
642	9d4f2d8d-8088-4dc3-a8a1-7dacf057db6f	9d4f2d8d-819e-420e-863c-321f2d943e02	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:52:02
12329	9d5ce21f-e8e4-421f-b5aa-5ecea2f09df9	9d5ce220-2ab6-4d36-a670-fa55c0bbc533	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 12:22:42
12330	9d5ce220-2690-4737-bdda-c7fcfab16765	9d5ce220-2ab6-4d36-a670-fa55c0bbc533	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and \\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%' order by \\"users\\".\\"user_document\\" asc","time":"141.93","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"346e96d5b86098f6cea2c4bc11d5ca30","hostname":"EderCortes"}	2024-10-29 12:22:43
1484	9d50d299-0a5a-49f6-8d0c-4b7823cb92e2	9d50d299-5177-4211-a7c0-d68ed7ff2aee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:29:21
1276	9d50c9c7-ff5e-44fe-af25-41cce73b6d9b	9d50c9c8-1d90-484e-82b1-a9662a61d582	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:04:42
1277	9d50c9c8-181c-4780-933a-5f4f3e9e47a7	9d50c9c8-1d90-484e-82b1-a9662a61d582	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 12:04:42
1278	9d50c9c8-1869-4dff-bbfc-f0e3851f1150	9d50c9c8-1d90-484e-82b1-a9662a61d582	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 12:04:42
1279	9d50c9c8-1c17-46f9-8315-c4ba113598fe	9d50c9c8-1d90-484e-82b1-a9662a61d582	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 12:04:42
1485	9d50d299-4c3c-4b5f-a0d8-9818ab9e1806	9d50d299-5177-4211-a7c0-d68ed7ff2aee	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"150.00","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 12:29:22
1486	9d50d299-4c87-462e-abab-bdd6f2f79423	9d50d299-5177-4211-a7c0-d68ed7ff2aee	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 12:29:22
1487	9d50d299-502e-48e9-8527-c252198ac9e6	9d50d299-5177-4211-a7c0-d68ed7ff2aee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 12:29:22
1488	9d50d299-5075-4692-bf2d-db5b2bc23cd8	9d50d299-5177-4211-a7c0-d68ed7ff2aee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":338,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:29:22
11327	9d5cb8ff-39e4-4c1b-b239-1c90b8c23643	9d5cb8ff-acd6-4dba-a122-e2a0b8e19eb1	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 10:27:42
11328	9d5cb8ff-aa39-49c6-a9ee-e9eb7535840c	9d5cb8ff-acd6-4dba-a122-e2a0b8e19eb1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 10:27:43
12331	9d5ce220-2996-44db-ab81-e0bb6f2e55d2	9d5ce220-2ab6-4d36-a670-fa55c0bbc533	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 12:22:43
12332	9d5ce220-29d7-428e-be9b-905681412f15	9d5ce220-2ab6-4d36-a670-fa55c0bbc533	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":311,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:22:43
12854	9d5ced4b-2a58-422e-9ddd-5d22af9557a2	9d5ced4b-4a04-4d6f-926a-d1898f3945cf	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 12:53:56
11329	9d5cb8ff-aaca-43a5-9d5b-2ce4c2400db7	9d5cb8ff-acd6-4dba-a122-e2a0b8e19eb1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/barrio","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\barrio\\\\BarrioController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":"HTML Response","duration":502,"memory":24,"hostname":"EderCortes"}	2024-10-29 10:27:43
724	9d4f2e4e-6798-4ca1-ad24-cf78e44cd2cf	9d4f2e4e-ade9-41c5-bb10-88c46f4a818e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-22 16:54:08
725	9d4f2e4e-ac36-4e26-a37b-445537237106	9d4f2e4e-ade9-41c5-bb10-88c46f4a818e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-22 16:54:08
726	9d4f2e4e-acd7-4291-9f61-aaeef18ed245	9d4f2e4e-ade9-41c5-bb10-88c46f4a818e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":358,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:54:08
12333	9d5ce220-6e56-4e10-bdca-c1031a116b3b	9d5ce220-8993-451d-8389-0d713f74adbf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 12:22:43
12334	9d5ce220-8563-4350-9d26-48693f161e24	9d5ce220-8993-451d-8389-0d713f74adbf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and \\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%' order by \\"users\\".\\"user_document\\" asc","time":"41.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"346e96d5b86098f6cea2c4bc11d5ca30","hostname":"EderCortes"}	2024-10-29 12:22:43
12335	9d5ce220-884b-412a-a093-63a672fba1ff	9d5ce220-8993-451d-8389-0d713f74adbf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 12:22:43
12336	9d5ce220-888e-42d8-a34f-0b7a0990008e	9d5ce220-8993-451d-8389-0d713f74adbf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:22:43
12855	9d5ced4b-4479-4078-b74a-d6ba89a22a90	9d5ced4b-4a04-4d6f-926a-d1898f3945cf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ma%' or \\"users\\".\\"user_document\\"::text like '%Ma%') order by \\"users\\".\\"user_document\\" asc","time":"40.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:53:56
12856	9d5ced4b-48a0-4498-b147-5060bf4e3184	9d5ced4b-4a04-4d6f-926a-d1898f3945cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:53:56
12857	9d5ced4b-48f2-4f57-a541-20dba9e01793	9d5ced4b-4a04-4d6f-926a-d1898f3945cf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ma"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:53:56
13139	9d5cf982-b3f5-4b81-850d-dd3749ad59bd	9d5cf982-d9db-4eb1-8542-f4eda191f011	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 13:28:06
13140	9d5cf982-d364-45ea-8bfa-b954fdb23621	9d5cf982-d9db-4eb1-8542-f4eda191f011	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"53.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 13:28:06
13141	9d5cf982-d3c2-46ea-ba6b-2522d9203961	9d5cf982-d9db-4eb1-8542-f4eda191f011	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 13:28:06
13142	9d5cf982-d857-4317-8fee-2b0de74d7b19	9d5cf982-d9db-4eb1-8542-f4eda191f011	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 13:28:06
13784	9d5d0ec4-b000-41d3-b22b-fa3374835a32	9d5d0ec4-b303-434f-a73c-cd5dd3dbb1f6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":164,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:27:32
1052	9d4f3de8-12e6-46ea-9f38-7f5708ef8097	9d4f3de8-5940-4f58-9340-887fe6292566	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-22 17:37:45
1053	9d4f3de8-547f-49ff-86ea-228820368fa7	9d4f3de8-5940-4f58-9340-887fe6292566	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"147.37","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-22 17:37:46
1054	9d4f3de8-54df-477b-8bbb-9efaf9cf5ff2	9d4f3de8-5940-4f58-9340-887fe6292566	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-22 17:37:46
1055	9d4f3de8-5832-4690-af6b-3437ed365295	9d4f3de8-5940-4f58-9340-887fe6292566	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-22 17:37:46
835	9d4f31f0-2523-45a9-9310-cd848d8b31e3	9d4f31f0-5608-4ffa-9342-9c34dabd3035	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 17:04:17
836	9d4f31f0-52c4-4146-9b67-d64bc11a5957	9d4f31f0-5608-4ffa-9342-9c34dabd3035	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 17:04:18
837	9d4f31f0-545d-4170-8b67-5e9c850b1c1c	9d4f31f0-5608-4ffa-9342-9c34dabd3035	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":400,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:04:18
1056	9d4f3de8-587c-4fce-9500-0cefbdab1182	9d4f3de8-5940-4f58-9340-887fe6292566	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":368,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:37:46
1280	9d50c9c8-1c60-4808-84ef-a1ab1d5ff427	9d50c9c8-1d90-484e-82b1-a9662a61d582	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":265,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:04:42
11620	9d5ccc74-dc2f-4f3a-a21e-f109052273db	9d5ccc74-df3d-494c-bfbb-775ac53c44c5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":169,"memory":20,"hostname":"EderCortes"}	2024-10-29 11:22:07
12337	9d5ce239-5a8b-493c-b194-20a55eb0e219	9d5ce239-5daf-43bb-a808-cecfd8dfe6aa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":198,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:22:59
11331	9d5cb91c-0702-4996-abbb-07bbe2412fae	9d5cb91c-74f4-4dfc-9316-4fafb312633b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 10:28:01
11332	9d5cb91c-7218-4919-98e9-4f7ab6c1b10b	9d5cb91c-74f4-4dfc-9316-4fafb312633b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 10:28:02
12858	9d5ced4b-9880-4531-b16c-54470751efe2	9d5ced4b-9bfc-42a2-9f46-599a2e0eb711	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":181,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:53:57
13785	9d5d0ec5-2829-4ca8-b410-cef34a9bcb9a	9d5d0ec5-2b18-4590-a1ad-aba97b312c30	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":130,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:27:33
1057	9d4f3dea-5e9e-44c5-a6b8-b732d10d5ef2	9d4f3dea-aa5e-4ca9-90fb-cac8d629b9ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-22 17:37:47
1058	9d4f3dea-a2b8-4282-a4a4-674fcf87bb1a	9d4f3dea-aa5e-4ca9-90fb-cac8d629b9ea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"152.35","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-22 17:37:47
1059	9d4f3dea-a312-436b-a193-83aae6635208	9d4f3dea-aa5e-4ca9-90fb-cac8d629b9ea	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 17:37:47
1060	9d4f3dea-a8ad-4443-852a-0d1acc20586d	9d4f3dea-aa5e-4ca9-90fb-cac8d629b9ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-22 17:37:47
1061	9d4f3dea-a940-4df8-b479-d003b15386ff	9d4f3dea-aa5e-4ca9-90fb-cac8d629b9ea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":426,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:37:47
11333	9d5cb91c-729c-48e4-a610-3418cc46b52b	9d5cb91c-74f4-4dfc-9316-4fafb312633b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/barrio","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\barrio\\\\BarrioController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":"HTML Response","duration":511,"memory":24,"hostname":"EderCortes"}	2024-10-29 10:28:02
12338	9d5ce239-da7b-4402-a9ed-bc05f515ddd8	9d5ce239-fb7e-426a-814e-cc7b9437acd8	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 12:22:59
1489	9d50d29e-9663-4505-93dc-a34889209de8	9d50d29e-9960-44a3-a026-fb6c6396ab4c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":135,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:29:25
11452	9d5cbe76-f94c-4327-a0f6-12bf1475eb45	9d5cbe76-fa3c-4294-ac68-b8cb0fdd5994	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":261,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:43:00
12339	9d5ce239-f584-4e07-b8e5-808eb1563bf4	9d5ce239-fb7e-426a-814e-cc7b9437acd8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"41.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"346e96d5b86098f6cea2c4bc11d5ca30","hostname":"EderCortes"}	2024-10-29 12:23:00
12340	9d5ce239-f9f3-4013-87dc-632113085d4a	9d5ce239-fb7e-426a-814e-cc7b9437acd8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:23:00
12859	9d5ced4c-175b-4d3d-98c8-6e9775acd239	9d5ced4c-31eb-4768-b579-3c4e60077480	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:53:57
12860	9d5ced4c-2d6b-4176-a07d-eac557500fca	9d5ced4c-31eb-4768-b579-3c4e60077480	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mar%' or \\"users\\".\\"user_document\\"::text like '%Mar%') order by \\"users\\".\\"user_document\\" asc","time":"39.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:53:57
12341	9d5ce239-fa50-41da-89ef-0ccc6a4d0563	9d5ce239-fb7e-426a-814e-cc7b9437acd8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[]},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:23:00
13143	9d5cf982-d8a9-4d65-8a42-088d38e58092	9d5cf982-d9db-4eb1-8542-f4eda191f011	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":574,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:28:06
13786	9d5d0ec5-a55f-4053-ac26-a26f347408d2	9d5d0ec5-a860-4470-b48d-9e2a16b56fea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":133,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:27:33
12861	9d5ced4c-3096-4c3f-a741-130b43dfa212	9d5ced4c-31eb-4768-b579-3c4e60077480	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:53:57
957	9d4f39e6-21c2-4a5b-adb6-d826f0581210	9d4f39e6-7184-411f-a024-0e1442e41ba1	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 17:26:33
958	9d4f39e6-6f9f-495b-b476-7bb670d35173	9d4f39e6-7184-411f-a024-0e1442e41ba1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 17:26:33
959	9d4f39e6-707b-4abd-8733-31541fb47c5f	9d4f39e6-7184-411f-a024-0e1442e41ba1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":368,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:26:33
1396	9d50d09f-8648-4b22-92c6-22191b68f36e	9d50d09f-f573-4335-bee1-916f2be17d8c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 12:23:50
12862	9d5ced4c-30e9-4f78-aae4-c0aae855e02a	9d5ced4c-31eb-4768-b579-3c4e60077480	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mar"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:53:57
14039	9d5d14be-5a33-48c6-a576-48af7cd2da85	9d5d14be-5d81-4f55-9b64-48f9529db717	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":156,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:44:15
14471	9d5eb880-4913-4570-9959-9fb656f4efa3	9d5eb881-d1c5-46e7-a24e-b7e2804a095d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":12309,"memory":18,"hostname":"EderCortes"}	2024-10-30 10:17:59
20129	9d66ee86-4615-4cf5-85b2-55c696b41da1	9d66ee86-4f66-4237-a146-78a94a0d3eba	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"67.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:15:40
960	9d4f39e8-24cb-41e7-b821-71be159a2af4	9d4f39e8-712e-4966-99c3-232ca915952e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 17:26:34
961	9d4f39e8-6811-4dc1-b201-f9c34850cd48	9d4f39e8-712e-4966-99c3-232ca915952e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"146.81","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-22 17:26:35
962	9d4f39e8-68a8-44de-a3d4-93c001a7046d	9d4f39e8-712e-4966-99c3-232ca915952e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 17:26:35
963	9d4f39e8-6fac-42bd-a2fd-36394672a664	9d4f39e8-712e-4966-99c3-232ca915952e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 17:26:35
964	9d4f39e8-7012-423a-ae1f-ead9d681f121	9d4f39e8-712e-4966-99c3-232ca915952e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":522,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:26:35
11627	9d5cccc0-d857-4039-9ac5-54fc9daecac2	9d5cccc0-de48-4c25-93c7-3d423725bce4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":253,"memory":20,"hostname":"EderCortes"}	2024-10-29 11:22:57
12342	9d5ce242-1476-4b89-983c-59c7c035f13d	9d5ce242-1798-46e3-9a70-438784a75a06	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":174,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:23:05
12863	9d5ced4c-71d6-4af4-92a9-6cb805668bc8	9d5ced4c-b8b3-402f-8734-46b779a2eb98	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:53:57
11335	9d5cb932-5474-4161-a166-5364e1cb5d08	9d5cb932-c435-401a-9ead-6a1a7af9c3e2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 10:28:16
11336	9d5cb932-c26f-4475-a486-eadf9468d436	9d5cb932-c435-401a-9ead-6a1a7af9c3e2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 10:28:16
11337	9d5cb932-c2ca-4417-931f-fbeaad50b07f	9d5cb932-c435-401a-9ead-6a1a7af9c3e2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/barrio","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\barrio\\\\BarrioController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":"HTML Response","duration":454,"memory":24,"hostname":"EderCortes"}	2024-10-29 10:28:16
12864	9d5ced4c-b480-408c-b6c8-61d096377d22	9d5ced4c-b8b3-402f-8734-46b779a2eb98	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"151.54","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:53:57
12865	9d5ced4c-b76c-41ff-ab8f-69c7d7a5cc2b	9d5ced4c-b8b3-402f-8734-46b779a2eb98	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 12:53:57
13787	9d5d0ec5-f88a-430d-b5d0-adf498e3c4c2	9d5d0ec6-1906-4ab2-9721-966a40f61dab	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 14:27:33
13788	9d5d0ec6-12dc-4674-81bc-98c2c6aaa3c5	9d5d0ec6-1906-4ab2-9721-966a40f61dab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ma%' or \\"users\\".\\"user_document\\"::text like '%Ma%') order by \\"users\\".\\"user_document\\" asc","time":"38.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 14:27:33
13789	9d5d0ec6-1783-483a-b4df-bb758ddee6c0	9d5d0ec6-1906-4ab2-9721-966a40f61dab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 14:27:33
1397	9d50d09f-f2ea-4c02-b661-f5a741073db1	9d50d09f-f573-4335-bee1-916f2be17d8c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:23:50
1398	9d50d09f-f3be-41a2-83d7-d3bd70799f16	9d50d09f-f573-4335-bee1-916f2be17d8c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":583,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:23:50
11628	9d5cccc1-9ae5-4f6b-9d93-eab802efa6c5	9d5cccc1-d236-42c8-ac11-431c1ec596f3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 11:22:57
1836	9d50df6b-d23b-43ce-bbd8-a1493049d9ec	9d50df6b-f8f1-404a-9a31-706dfcfd829f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 13:05:13
1837	9d50df6b-f713-4fb8-b1cf-66c286eef399	9d50df6b-f8f1-404a-9a31-706dfcfd829f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 13:05:13
1838	9d50df6b-f7d7-440e-b825-7472be6aaa81	9d50df6b-f8f1-404a-9a31-706dfcfd829f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":282,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:05:13
11629	9d5cccc1-b73b-4ca7-80d8-ace76089c0fc	9d5cccc1-d236-42c8-ac11-431c1ec596f3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta', 'De las nieve', 'ds', 'CC', '100465546', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '500000', 25, 6, 'S', null, 'Tue Oct 29 2024', 'Pendiente', '312596295', 12, 14, 18, 14, '2024-11-05T05:00:00.000Z', '2024-10-29 11:22:57', '2024-10-29 11:22:57') returning \\"id\\"","time":"4.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":99,"hash":"bfad4cea82a73099ff0b3164dd496ca0","hostname":"EderCortes"}	2024-10-29 11:22:57
11630	9d5cccc1-b79f-474b-8028-5eec237f9b68	9d5cccc1-d236-42c8-ac11-431c1ec596f3	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:16","hostname":"EderCortes"}	2024-10-29 11:22:57
11631	9d5cccc1-b9b4-4aea-9311-1c7b8cf3791f	9d5cccc1-d236-42c8-ac11-431c1ec596f3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (16, 1, 83333.333333333, 10416.666666667, 0, 'N\\/A', '28-01-2025', 12, '2024-10-29 11:22:57', '2024-10-29 11:22:57')","time":"3.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":151,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:22:58
11339	9d5cb96b-208f-47a3-9e16-c2b140e8f254	9d5cb96b-93ef-43f1-835e-5cd7182222bf	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 10:28:53
1970	9d50e245-f5e4-4146-85c9-bde6839d7abd	9d50e246-12a8-4756-8658-e1fd811d11eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 13:13:11
1971	9d50e246-0da0-4226-9fe8-f0033a65e143	9d50e246-12a8-4756-8658-e1fd811d11eb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:13:11
1972	9d50e246-0dea-4ac1-bda8-c7221995d1d0	9d50e246-12a8-4756-8658-e1fd811d11eb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 13:13:11
1973	9d50e246-117b-47fc-88e4-5b86b849b6ee	9d50e246-12a8-4756-8658-e1fd811d11eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 13:13:11
11340	9d5cb96b-917e-4fc4-977b-cbc486aa8ae3	9d5cb96b-93ef-43f1-835e-5cd7182222bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 10:28:53
11632	9d5cccc1-b9e1-4680-8319-ccb15d2b6584	9d5cccc1-d236-42c8-ac11-431c1ec596f3	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:22:58
11633	9d5cccc1-ba7c-419f-aa0e-1e3b1296be17	9d5cccc1-d236-42c8-ac11-431c1ec596f3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (16, 2, 83333.333333333, 10416.666666667, 0, 'N\\/A', '28-04-2025', 12, '2024-10-29 11:22:58', '2024-10-29 11:22:58')","time":"0.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":151,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:22:58
11634	9d5cccc1-babd-4e09-a9b0-22b9da047d74	9d5cccc1-d236-42c8-ac11-431c1ec596f3	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:22:58
11635	9d5cccc1-bb4a-4387-b37c-389776028d42	9d5cccc1-d236-42c8-ac11-431c1ec596f3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (16, 3, 83333.333333333, 10416.666666667, 0, 'N\\/A', '27-07-2025', 12, '2024-10-29 11:22:58', '2024-10-29 11:22:58')","time":"0.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":151,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:22:58
11636	9d5cccc1-bb7a-4bbd-ab42-55cf399b2a2b	9d5cccc1-d236-42c8-ac11-431c1ec596f3	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:22:58
11637	9d5cccc1-bc0e-4e37-abf8-9aa2647a709c	9d5cccc1-d236-42c8-ac11-431c1ec596f3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (16, 4, 83333.333333333, 10416.666666667, 0, 'N\\/A', '25-10-2025', 12, '2024-10-29 11:22:58', '2024-10-29 11:22:58')","time":"0.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":151,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:22:58
11638	9d5cccc1-bc3d-43ad-af52-0af7ffcff047	9d5cccc1-d236-42c8-ac11-431c1ec596f3	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:22:58
11639	9d5cccc1-bcc9-4809-bf2a-db179a30286b	9d5cccc1-d236-42c8-ac11-431c1ec596f3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (16, 5, 83333.333333333, 10416.666666667, 0, 'N\\/A', '23-01-2026', 12, '2024-10-29 11:22:58', '2024-10-29 11:22:58')","time":"0.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":151,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:22:58
11640	9d5cccc1-bcf8-41c2-b28f-baa5f61b12e3	9d5cccc1-d236-42c8-ac11-431c1ec596f3	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:22:58
1839	9d50df6c-4cda-4b6d-a7a3-212452fb9f7e	9d50df6c-9833-4946-ae1f-e3b68afcc609	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 13:05:13
1840	9d50df6c-92ce-4a9f-bfb0-b0372c46e17d	9d50df6c-9833-4946-ae1f-e3b68afcc609	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"156.22","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:05:13
1841	9d50df6c-931e-497b-8081-be6da45f9a0a	9d50df6c-9833-4946-ae1f-e3b68afcc609	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 13:05:13
738	9d4f2e5e-14d8-47e9-bda8-cb86f837afca	9d4f2e5e-3b02-4cb5-995e-78a474da7b63	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 16:54:18
739	9d4f2e5e-3866-4ebd-b145-a3002c7cac58	9d4f2e5e-3b02-4cb5-995e-78a474da7b63	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 16:54:19
740	9d4f2e5e-3976-4f96-a08c-54b756e66c6d	9d4f2e5e-3b02-4cb5-995e-78a474da7b63	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":265,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:54:19
1399	9d50d0a0-6bc9-4fa6-8e9e-fb7acb900c0a	9d50d0a8-248a-4008-ae93-dc7e5a853906	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:23:51
1400	9d50d0a8-22d9-4feb-b553-5c71e3644905	9d50d0a8-248a-4008-ae93-dc7e5a853906	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:23:56
1842	9d50df6c-96f7-4778-989f-fda4f5694e96	9d50df6c-9833-4946-ae1f-e3b68afcc609	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 13:05:13
1401	9d50d0a8-2399-4848-b4f9-49c5b9d8b0cb	9d50d0a8-248a-4008-ae93-dc7e5a853906	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":"Empty Response","duration":5314,"memory":20,"hostname":"EderCortes"}	2024-10-23 12:23:56
1843	9d50df6c-9758-4273-9396-2ce7f413ee0f	9d50df6c-9833-4946-ae1f-e3b68afcc609	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":386,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:05:13
11341	9d5cb96b-9213-45de-b0fb-dd2eef25f938	9d5cb96b-93ef-43f1-835e-5cd7182222bf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/barrio","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\barrio\\\\BarrioController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":"HTML Response","duration":525,"memory":24,"hostname":"EderCortes"}	2024-10-29 10:28:53
11641	9d5cccc1-bdb6-4013-8983-631f98d741d4	9d5cccc1-d236-42c8-ac11-431c1ec596f3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (16, 6, 83333.333333333, 10416.666666667, 0, 'N\\/A', '23-04-2026', 12, '2024-10-29 11:22:58', '2024-10-29 11:22:58')","time":"0.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":151,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:22:58
2036	9d50e2f8-4a26-4176-b854-0aff404cb9ab	9d50e2f8-9d14-4f03-a93a-49d822213b5a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 13:15:08
2037	9d50e2f8-9b05-4e4c-a325-62d2ca89d53c	9d50e2f8-9d14-4f03-a93a-49d822213b5a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 13:15:08
2038	9d50e2f8-9bc1-4456-b7d4-c48ca6390d5a	9d50e2f8-9d14-4f03-a93a-49d822213b5a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":413,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:15:08
11642	9d5cccc1-bdf2-481a-b975-0a51a69f257e	9d5cccc1-d236-42c8-ac11-431c1ec596f3	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:22:58
11643	9d5cccc1-d0be-412b-b208-504d0a98a3e8	9d5cccc1-d236-42c8-ac11-431c1ec596f3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 11:22:58
12343	9d5ce242-c42f-4f53-becf-fe38898a4f06	9d5ce242-dcfd-467b-bf1a-8fbbc411a4f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:23:05
12344	9d5ce242-d931-4b1c-a3e8-a5e169a651c8	9d5ce242-dcfd-467b-bf1a-8fbbc411a4f6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and \\"users\\".\\"name\\"::text like '%1004%' or \\"users\\".\\"user_document\\"::text like '%1004%' order by \\"users\\".\\"user_document\\" asc","time":"39.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"346e96d5b86098f6cea2c4bc11d5ca30","hostname":"EderCortes"}	2024-10-29 12:23:05
12345	9d5ce242-dbde-45f7-97a3-564ec07a2e6d	9d5ce242-dcfd-467b-bf1a-8fbbc411a4f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:23:05
20130	9d66ee86-46a0-4383-b356-4e39de87b875	9d66ee86-4f66-4237-a146-78a94a0d3eba	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:15:40
20131	9d66ee86-4d41-4e39-a193-8d77a76c7fdc	9d66ee86-4f66-4237-a146-78a94a0d3eba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 12:15:40
35355	9d69c404-7106-457b-823a-3355adcfc8e0	9d69c404-c770-4e61-a5cd-90eaf722e29b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-11-04 22:04:17
37376	9d6b4924-f483-428a-8e69-c636b99b9c4d	9d6b4925-1e7e-474d-a655-a100617edead	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 16:12:22
2039	9d50e2f8-f656-4dab-a617-847be081a74d	9d50e2f9-3ea0-4222-861a-7254721c1776	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 13:15:09
903	9d4f33fa-2750-4cd3-9ef1-9e940c3d0e36	9d4f33fa-47e4-4877-9e29-e76a9b5a0477	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 17:10:00
904	9d4f33fa-462f-43c9-b0ad-9d88ccc5fb37	9d4f33fa-47e4-4877-9e29-e76a9b5a0477	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 17:10:00
905	9d4f33fa-46eb-49e8-86c0-e51b5ca25e7a	9d4f33fa-47e4-4877-9e29-e76a9b5a0477	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":261,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:10:00
2040	9d50e2f9-394b-41fd-99f2-1077bc2b404f	9d50e2f9-3ea0-4222-861a-7254721c1776	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"147.56","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:15:09
2041	9d50e2f9-3993-44d0-902a-6bee6a64ce1b	9d50e2f9-3ea0-4222-861a-7254721c1776	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 13:15:09
1844	9d50df6c-d632-4688-b9c0-5f3ca6120247	9d50df6c-f2f5-4bb7-a883-87142ac13e78	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 13:05:13
1845	9d50df6c-ee88-4291-ada6-aaeb34faf042	9d50df6c-f2f5-4bb7-a883-87142ac13e78	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:05:14
1846	9d50df6c-eed8-4022-b162-451ef82ded9c	9d50df6c-f2f5-4bb7-a883-87142ac13e78	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 13:05:14
1402	9d50d0a8-a821-4ee3-99cd-974a66acca5a	9d50d0a8-d446-4285-ab46-a9178a2e8e52	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:23:56
1847	9d50df6c-f1e7-4e9d-88c8-2651d6a019e6	9d50df6c-f2f5-4bb7-a883-87142ac13e78	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 13:05:14
1848	9d50df6c-f22d-4f8e-8ce9-d21f7fc88b7f	9d50df6c-f2f5-4bb7-a883-87142ac13e78	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":219,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:05:14
2042	9d50e2f9-3d68-495f-92fa-4dccb5dab80b	9d50e2f9-3ea0-4222-861a-7254721c1776	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 13:15:09
2043	9d50e2f9-3daf-4754-8141-19d71000513b	9d50e2f9-3ea0-4222-861a-7254721c1776	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":386,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:15:09
11644	9d5cccc1-d116-424a-abd0-45e6b2087ea8	9d5cccc1-d236-42c8-ac11-431c1ec596f3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"766","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"100465546","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"500000","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":18,"user_recomendacion":14,"loans_inicio_pago":"2024-11-05T05:00:00.000Z","created_at":null,"updated_at":null,"deleted_at":null},"detail":{"status":false,"observacion":"N\\/A","fecha_pago":"Tue Oct 29 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":16},"duration":320,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:22:58
11961	9d5cd8dd-f9ca-4ed4-ade9-935cbeae1ed0	9d5cd8de-5529-43cf-9679-5c9148f0af96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 11:56:49
38457	9d6b64e5-68e9-4da5-a679-ddb1c3749c78	9d6b64e5-b0da-4113-a216-5ad1ea7ab128	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:29:58
40140	9d6cc121-2bc3-4bb0-8f37-a2fcd710aa54	9d6cc121-4b7e-42fb-b2a7-dd800e870164	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 09:43:42
906	9d4f33fb-5618-4a9f-8863-1e633b5a4208	9d4f33fb-83ad-4ffe-9b1d-7cda6589d2bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 17:10:00
907	9d4f33fb-79cc-4a17-8c35-48119ece8da2	9d4f33fb-83ad-4ffe-9b1d-7cda6589d2bb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"58.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-22 17:10:00
908	9d4f33fb-7a56-43c4-9fa0-a9ae52246c40	9d4f33fb-83ad-4ffe-9b1d-7cda6589d2bb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 17:10:00
909	9d4f33fb-818b-4af0-914d-eac73b8ad8d0	9d4f33fb-83ad-4ffe-9b1d-7cda6589d2bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-22 17:10:00
910	9d4f33fb-820b-4628-bab3-e059c4bd26f5	9d4f33fb-83ad-4ffe-9b1d-7cda6589d2bb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":412,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:10:00
1403	9d50d0a8-ca62-46c8-a32b-96325a74a21e	9d50d0a8-d446-4285-ab46-a9178a2e8e52	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"51.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":50,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:23:56
1404	9d50d0a8-cabf-403e-af43-5ac34e13c051	9d50d0a8-d446-4285-ab46-a9178a2e8e52	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 12:23:56
1405	9d50d0a8-d2cf-4830-adfb-156bb9b34290	9d50d0a8-d446-4285-ab46-a9178a2e8e52	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:23:56
1406	9d50d0a8-d36d-4c60-a0cf-9dc57801885e	9d50d0a8-d446-4285-ab46-a9178a2e8e52	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":390,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:23:56
1849	9d50df6e-50e9-430d-bfa8-b55473f022e1	9d50df6e-788e-431d-bff7-04d26aea6dec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 13:05:14
1791	9d50df03-01ab-407a-a307-17d739165258	9d50df03-4f59-401c-a683-9a1cf83a7b6f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 13:04:04
1792	9d50df03-48c0-454d-9ac8-7130933bdf97	9d50df03-4f59-401c-a683-9a1cf83a7b6f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"152.75","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":67,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:04:04
1793	9d50df03-4910-452c-bc4b-d14981673769	9d50df03-4f59-401c-a683-9a1cf83a7b6f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 13:04:04
1794	9d50df03-4e32-41f6-afbd-19344d68dcdc	9d50df03-4f59-401c-a683-9a1cf83a7b6f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 13:04:04
1795	9d50df03-4e77-403b-89d2-f8486130bac0	9d50df03-4f59-401c-a683-9a1cf83a7b6f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":413,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:04:04
2044	9d50e2f9-816d-42b4-b2ac-f5483017b2ab	9d50e2f9-a15a-4a82-b93c-7b3066df12e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 13:15:09
41959	9d6cd174-e171-4ea2-bff3-ff6649dd71fb	9d6cd174-ec0d-423d-92ab-60a18fc72d21	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '14' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"53.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":74,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-06 10:29:21
1850	9d50df6e-7201-4cbe-b10c-66dab6ef8e79	9d50df6e-788e-431d-bff7-04d26aea6dec	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"51.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 13:05:15
839	9d4f31f0-c6eb-4cc5-a806-3fb152ee674c	9d4f31f0-ed47-46b1-ac7d-f5029b309269	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 17:04:18
840	9d4f31f0-ea65-4101-a8bf-7308164b97f2	9d4f31f0-ed47-46b1-ac7d-f5029b309269	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 17:04:18
841	9d4f31f0-ebb3-417c-890f-b61c2a073b11	9d4f31f0-ed47-46b1-ac7d-f5029b309269	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:04:18
1851	9d50df6e-726a-4318-8dd8-a57822eacd8b	9d50df6e-788e-431d-bff7-04d26aea6dec	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 13:05:15
1852	9d50df6e-76e4-49c4-86ad-eb512d423d61	9d50df6e-788e-431d-bff7-04d26aea6dec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 13:05:15
1407	9d50d0ac-17bf-4403-af82-e9fa7bf105ae	9d50d0ac-7475-465c-a93b-bd79b5ae59d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:23:58
1408	9d50d0ac-6c1a-43c7-a18e-2c2d10847219	9d50d0ac-7475-465c-a93b-bd79b5ae59d7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"169.41","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 12:23:59
1796	9d50df03-91ee-450c-a074-c34f9f3b7acd	9d50df03-b1ce-4b88-bccf-0075b7343d8d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 13:04:04
1409	9d50d0ac-6c86-41ed-8db6-f35162bbf2a7	9d50d0ac-7475-465c-a93b-bd79b5ae59d7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 12:23:59
1410	9d50d0ac-7290-48b7-bc49-e2618e771596	9d50d0ac-7475-465c-a93b-bd79b5ae59d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 12:23:59
1797	9d50df03-acc0-4156-91ef-bdef07b18c78	9d50df03-b1ce-4b88-bccf-0075b7343d8d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":67,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:04:05
1798	9d50df03-ad1a-4ffd-bc0d-93162b0a9900	9d50df03-b1ce-4b88-bccf-0075b7343d8d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 13:04:05
1799	9d50df03-b0b4-4581-9a85-ea85d97e559b	9d50df03-b1ce-4b88-bccf-0075b7343d8d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 13:04:05
1800	9d50df03-b0f7-4040-b6ca-0c5a742addec	9d50df03-b1ce-4b88-bccf-0075b7343d8d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:04:05
1853	9d50df6e-7743-4134-9c3c-59be787da7aa	9d50df6e-788e-431d-bff7-04d26aea6dec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":455,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:05:15
2045	9d50e2f9-9c57-4c5d-9466-8ca499441729	9d50e2f9-a15a-4a82-b93c-7b3066df12e4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:15:09
2046	9d50e2f9-9ca6-45f3-855e-bf454d478e76	9d50e2f9-a15a-4a82-b93c-7b3066df12e4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 13:15:09
2047	9d50e2f9-a020-423f-92bb-6dec78670219	9d50e2f9-a15a-4a82-b93c-7b3066df12e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 13:15:09
41960	9d6cd174-e219-4ca8-99fb-af63d2050518	9d6cd174-ec0d-423d-92ab-60a18fc72d21	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:29:21
41961	9d6cd174-e9f1-44b4-8bff-742f2c8b29dd	9d6cd174-ec0d-423d-92ab-60a18fc72d21	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:29:21
842	9d4f31f2-c597-4200-b8aa-5d5e3dd831ec	9d4f31f3-0725-4c70-aa60-db859356bdf8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 17:04:19
843	9d4f31f2-fb8a-45af-8935-bb38f624ff46	9d4f31f3-0725-4c70-aa60-db859356bdf8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null","time":"87.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"hash":"6a6d0d402783832946ffa508e6a6b452","hostname":"EderCortes"}	2024-10-22 17:04:19
844	9d4f31f2-fc14-4eb4-a8da-625d9b0c97c9	9d4f31f3-0725-4c70-aa60-db859356bdf8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 17:04:19
845	9d4f31f3-0523-4325-b539-f13942a81247	9d4f31f3-0725-4c70-aa60-db859356bdf8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 17:04:19
846	9d4f31f3-05bc-451f-a895-a1f98821d6c8	9d4f31f3-0725-4c70-aa60-db859356bdf8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":455,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:04:19
1411	9d50d0ac-7306-4e3e-93a8-ebb108f6ab9b	9d50d0ac-7475-465c-a93b-bd79b5ae59d7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":450,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:23:59
1854	9d50df74-ad44-4cad-be14-7fd0ca28ea85	9d50df74-b065-48dc-ac55-d0272d2e44fe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":161,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:05:19
1801	9d50df05-6cbb-4dcf-afc9-bb0fe28cd67b	9d50df05-bb89-460d-8188-f376cddc36a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 13:04:06
1802	9d50df05-b0bd-4f93-b8b4-00f285e479b8	9d50df05-bb89-460d-8188-f376cddc36a5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"135.23","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 13:04:06
1803	9d50df05-b164-44eb-9653-1cb835fcb20c	9d50df05-bb89-460d-8188-f376cddc36a5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 13:04:06
1804	9d50df05-b954-43b3-a204-0e89e667d887	9d50df05-bb89-460d-8188-f376cddc36a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 13:04:06
1805	9d50df05-b9e6-4365-84ef-824adf306c9e	9d50df05-bb89-460d-8188-f376cddc36a5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":490,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:04:06
1412	9d50d0ba-2a52-4ccf-a23a-29f27e8c4b68	9d50d0ba-2d9f-4bdf-8109-765a03a9645b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":159,"memory":20,"hostname":"EderCortes"}	2024-10-23 12:24:08
1855	9d50df75-0dad-46b0-bfbf-13957027aa48	9d50df75-278d-42f2-9f9c-2fb561810ea8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 13:05:19
1856	9d50df75-235b-4161-b0dc-90ea78672718	9d50df75-278d-42f2-9f9c-2fb561810ea8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, ' ', (users.user_document)) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"39.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"8e8d2f1f6030d01848bc971840ab08d0","hostname":"EderCortes"}	2024-10-23 13:05:19
1857	9d50df75-265d-41a9-9cb6-65644d5c20fa	9d50df75-278d-42f2-9f9c-2fb561810ea8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 13:05:19
995	9d4f3be0-9455-4584-94a7-7144ea3478be	9d4f3be0-b6b8-405d-98c3-a8da9139cc1c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 17:32:05
996	9d4f3be0-afb0-4ba5-a620-181fd762e379	9d4f3be0-b6b8-405d-98c3-a8da9139cc1c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"48.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-22 17:32:05
997	9d4f3be0-b01a-43ea-acba-c2f6f4265889	9d4f3be0-b6b8-405d-98c3-a8da9139cc1c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 17:32:05
998	9d4f3be0-b513-4f2b-88d0-215a80170a55	9d4f3be0-b6b8-405d-98c3-a8da9139cc1c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 17:32:05
999	9d4f3be0-b56b-4bf7-b6f1-c9cf76a4f9b5	9d4f3be0-b6b8-405d-98c3-a8da9139cc1c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:32:05
1858	9d50df75-269d-4a34-a772-d664ce8ec00d	9d50df75-278d-42f2-9f9c-2fb561810ea8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley 1004608333"},{"id":14,"name_customer":"Luis andre 100465545"}]},"duration":211,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:05:19
2048	9d50e2f9-a062-480d-88f5-aba4e34ec86b	9d50e2f9-a15a-4a82-b93c-7b3066df12e4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:15:09
29116	9d690e9f-99ac-4b28-a1a6-99ad321426cc	9d690e9f-a0d7-4790-a7e8-c754c9cb7eac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"57.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:37:04
2049	9d50e2fb-3bc6-44b9-99cf-2b6b4cec8069	9d50e2fb-65eb-4f4a-9eab-3f7973cb173b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 13:15:10
2050	9d50e2fb-5cee-4961-a29c-5e72b5e7be44	9d50e2fb-65eb-4f4a-9eab-3f7973cb173b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"54.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 13:15:10
752	9d4f2e81-1d35-447c-ad4c-d65c80267138	9d4f2e81-3b7f-45b1-aebb-924f162964ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 16:54:41
753	9d4f2e81-39c4-4e1a-8d1a-76b751a9e096	9d4f2e81-3b7f-45b1-aebb-924f162964ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 16:54:41
754	9d4f2e81-3a9d-45e3-b561-ca5e9297df84	9d4f2e81-3b7f-45b1-aebb-924f162964ff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:54:41
2051	9d50e2fb-5d77-457d-bb19-f796d934021d	9d50e2fb-65eb-4f4a-9eab-3f7973cb173b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 13:15:10
2052	9d50e2fb-63c6-4dd8-b372-1261367facec	9d50e2fb-65eb-4f4a-9eab-3f7973cb173b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 13:15:10
2053	9d50e2fb-6452-482a-8fee-1dd52fc1a0be	9d50e2fb-65eb-4f4a-9eab-3f7973cb173b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:15:10
11645	9d5ccd19-a7ad-4195-a661-5687eee06dba	9d5ccd19-abff-427f-9e8a-e8618e859a43	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":188,"memory":20,"hostname":"EderCortes"}	2024-10-29 11:23:55
3103	9d5101c7-8c49-4b56-a982-8edd1095af8c	9d5101c7-8dd4-4ad8-b695-5f18f3778c2a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":554,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:41:17
1000	9d4f3be1-0b8c-46a5-9a0c-5dcc13fdfb95	9d4f3be1-2fb4-4012-a09c-c179188929d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 17:32:05
2220	9d50e50b-2884-4a54-8c52-4dfa47af0e3b	9d50e50b-2b6c-4c62-9ef7-3514e59e2bc5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":143,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:20:56
12346	9d5ce242-dc1d-48ab-b911-f233c12b8863	9d5ce242-dcfd-467b-bf1a-8fbbc411a4f6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"1004"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":14,"name_customer":"Luis andre  Herrera - 100465545"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":199,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:23:05
1337	9d50ccce-af0e-4ac1-af15-6996df5ee750	9d50ccce-fdd6-4bde-b149-2e171a982530	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:13:10
1153	9d4fc28b-3b14-4e8b-90a4-ca23b2fe207b	9d4fc28b-ac5d-4751-9d6f-55db696bc087	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 23:48:38
1154	9d4fc28b-a81e-4b7e-aa3b-d6ae563f6ba0	9d4fc28b-ac5d-4751-9d6f-55db696bc087	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 23:48:39
1155	9d4fc28b-aa3d-41a3-8557-3d7fb55f80e8	9d4fc28b-ac5d-4751-9d6f-55db696bc087	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":896,"memory":22,"hostname":"EderCortes"}	2024-10-22 23:48:39
1001	9d4f3be1-2802-4082-a86e-05ebc15eaab6	9d4f3be1-2fb4-4012-a09c-c179188929d1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-22 17:32:05
1002	9d4f3be1-2884-4984-81a7-2f276693216a	9d4f3be1-2fb4-4012-a09c-c179188929d1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-22 17:32:05
1003	9d4f3be1-2ddd-4341-8e9a-5ea70376a77c	9d4f3be1-2fb4-4012-a09c-c179188929d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 17:32:05
1004	9d4f3be1-2e55-463e-842d-0a0d2a6c30df	9d4f3be1-2fb4-4012-a09c-c179188929d1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":289,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:32:05
1338	9d50ccce-f485-44ec-81ff-911684bbb60a	9d50ccce-fdd6-4bde-b149-2e171a982530	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"155.22","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:13:10
3104	9d5101c8-134f-472c-9054-c93fa07a5460	9d5101c8-4609-4fdd-b1f4-310d212ecd89	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 14:41:18
2221	9d50e50b-7f2d-4c13-844a-b43df4ee623c	9d50e50b-9a8a-461c-a8e1-bdd21a08fa0e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 13:20:56
1339	9d50ccce-f4d0-4a8c-abf0-410d95cb2bcf	9d50ccce-fdd6-4bde-b149-2e171a982530	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 12:13:10
1340	9d50ccce-fc44-4726-aaa4-8cdcfab36db6	9d50ccce-fdd6-4bde-b149-2e171a982530	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:13:10
1341	9d50ccce-fcaa-4391-95a6-ee47c50b1f90	9d50ccce-fdd6-4bde-b149-2e171a982530	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":391,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:13:10
2222	9d50e50b-965b-426d-8aa4-58d5e5dd5988	9d50e50b-9a8a-461c-a8e1-bdd21a08fa0e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%1004%' or \\"users\\".\\"user_document\\"::text like '%1004%' order by \\"users\\".\\"user_document\\" asc","time":"43.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:20:56
2223	9d50e50b-9966-4e46-b8c8-a48bf9645123	9d50e50b-9a8a-461c-a8e1-bdd21a08fa0e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 13:20:56
2224	9d50e50b-99a8-4d4b-908f-95140d56b6b1	9d50e50b-9a8a-461c-a8e1-bdd21a08fa0e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"1004"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":14,"name_customer":"Luis andre  Herrera - 100465545"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":222,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:20:56
29117	9d690e9f-9a25-4d48-a680-a747276f8d68	9d690e9f-a0d7-4790-a7e8-c754c9cb7eac	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:37:04
29118	9d690e9f-9ed2-44a7-9864-ca1cf0759f5b	9d690e9f-a0d7-4790-a7e8-c754c9cb7eac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-04 13:37:04
1156	9d4fc28c-4c47-40db-accf-6665b3e0cb42	9d4fc28c-80cb-4227-b0bd-d278a89df5bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 23:48:39
1157	9d4fc28c-7677-4b9e-a4be-139b16e74927	9d4fc28c-80cb-4227-b0bd-d278a89df5bf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"66.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-22 23:48:39
1158	9d4fc28c-7708-48d4-9c51-84fcb5f1ba33	9d4fc28c-80cb-4227-b0bd-d278a89df5bf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-22 23:48:39
1159	9d4fc28c-7ead-452b-b923-55f05db7998f	9d4fc28c-80cb-4227-b0bd-d278a89df5bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 23:48:39
1005	9d4f3be1-8163-40f0-8c59-61a01a1ef47d	9d4f3be1-a1b1-4f78-926c-a47dc00ab5e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 17:32:06
1006	9d4f3be1-9d0b-4365-b06d-84f6947127d5	9d4f3be1-a1b1-4f78-926c-a47dc00ab5e8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-22 17:32:06
1007	9d4f3be1-9d59-4223-8be5-b1cebe2896ab	9d4f3be1-a1b1-4f78-926c-a47dc00ab5e8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-22 17:32:06
1008	9d4f3be1-a06e-4ec8-85cd-f7b00005dd87	9d4f3be1-a1b1-4f78-926c-a47dc00ab5e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 17:32:06
1009	9d4f3be1-a0b1-41f7-a993-44cb1efcf382	9d4f3be1-a1b1-4f78-926c-a47dc00ab5e8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":276,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:32:06
1160	9d4fc28c-7f38-43d8-a325-dddcc46feeaa	9d4fc28c-80cb-4227-b0bd-d278a89df5bf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":507,"memory":22,"hostname":"EderCortes"}	2024-10-22 23:48:39
3105	9d5101c8-3dd8-4446-a035-be8bbdf41aab	9d5101c8-4609-4fdd-b1f4-310d212ecd89	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"69.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:41:18
1342	9d50cccf-4acb-4428-9a2c-41fabf986cad	9d50cccf-6868-4724-8b69-c0be440a5b37	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:13:10
1343	9d50cccf-63ba-4168-8e40-144474964701	9d50cccf-6868-4724-8b69-c0be440a5b37	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:13:10
1344	9d50cccf-6403-4472-9436-c6a118da7bd6	9d50cccf-6868-4724-8b69-c0be440a5b37	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 12:13:10
1345	9d50cccf-672d-4c86-9a66-c2d202f8fc70	9d50cccf-6868-4724-8b69-c0be440a5b37	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:13:10
1346	9d50cccf-6781-4a60-95c0-b2bf9ade74a5	9d50cccf-6868-4724-8b69-c0be440a5b37	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:13:10
1161	9d4fc28d-04b9-4b6c-9b49-c4a4cb669fd7	9d4fc28d-5df5-42ca-95f8-0839a711286f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 23:48:39
1162	9d4fc28d-562b-47de-b16f-f89d061e122c	9d4fc28d-5df5-42ca-95f8-0839a711286f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"167.36","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-22 23:48:40
1163	9d4fc28d-56c3-49b8-b15f-b94ff417f0fb	9d4fc28d-5df5-42ca-95f8-0839a711286f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-22 23:48:40
1164	9d4fc28d-5c4f-405d-aded-5a84b15869e8	9d4fc28d-5df5-42ca-95f8-0839a711286f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 23:48:40
1165	9d4fc28d-5cb3-4a0a-be10-50d1db367790	9d4fc28d-5df5-42ca-95f8-0839a711286f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":544,"memory":22,"hostname":"EderCortes"}	2024-10-22 23:48:40
1974	9d50e246-11bc-48f1-aab9-61b4ddf06871	9d50e246-12a8-4756-8658-e1fd811d11eb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":311,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:13:11
1490	9d50d29f-4c6a-4ad6-a0bc-96460ded5406	9d50d29f-4f65-4c4b-b9e6-3f97136054f9	af953bfd4057e7ea32f1d2ea6ea20dbe	t	exception	{"class":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":29,"message":"Undefined variable $id","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":29},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"20":"","21":"    \\/**","22":"     * Show the form for creating a new resource.","23":"     *\\/","24":"","25":"    public function getCustomerFilters(Request $request)","26":"    {","27":"","28":"        var_dump($request->all());","29":"        $data = User::where('users.profile_code', $id)","30":"            ->orderBy('users.created_at')","31":"            ->get();","32":"","33":"    }","34":"    public function create()","35":"    {","36":"        var_dump('ksadjbkasjbdkbjaskjbd');","37":"    }","38":"","39":"    \\/**"},"hostname":"EderCortes","occurrences":1}	2024-10-23 12:29:25
1491	9d50d29f-467c-4470-a1fd-829520502aac	9d50d29f-4f65-4c4b-b9e6-3f97136054f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 12:29:25
1347	9d50ccd1-0b9e-4b03-96cf-5cdaa1b1b71c	9d50ccd1-2927-45ae-a486-221992d2e332	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:13:11
1348	9d50ccd1-2434-4940-a7b7-1ca052368299	9d50ccd1-2927-45ae-a486-221992d2e332	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 12:13:12
1349	9d50ccd1-247b-44da-9580-ac2749079796	9d50ccd1-2927-45ae-a486-221992d2e332	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 12:13:12
1350	9d50ccd1-27e7-4655-b7f9-d60ffc5c976d	9d50ccd1-2927-45ae-a486-221992d2e332	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 12:13:12
1351	9d50ccd1-2831-4bdf-9d83-aaf51cf3b22b	9d50ccd1-2927-45ae-a486-221992d2e332	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:13:12
1492	9d50d29f-4d95-45ee-91be-8ae54f3ebb3f	9d50d29f-4f65-4c4b-b9e6-3f97136054f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 12:29:25
1166	9d4fc28f-3d6a-4d77-93ca-cc8ae09e6f43	9d4fc28f-682f-4f6d-ab26-b894ff2b336d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 23:48:41
1167	9d4fc28f-603e-423b-93f7-89382a371d40	9d4fc28f-682f-4f6d-ab26-b894ff2b336d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"57.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-22 23:48:41
1168	9d4fc28f-60b3-46f5-ba11-fbdbceb7df5b	9d4fc28f-682f-4f6d-ab26-b894ff2b336d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 23:48:41
1169	9d4fc28f-6667-40de-a00e-50501336e617	9d4fc28f-682f-4f6d-ab26-b894ff2b336d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 23:48:41
966	9d4f3b74-5bd5-433f-95ce-9a1993d7fff1	9d4f3b74-8c86-4d03-8e64-da59eafc1fe1	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 17:30:54
967	9d4f3b74-89d2-4d7a-93d7-8018d613e44a	9d4f3b74-8c86-4d03-8e64-da59eafc1fe1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 17:30:54
968	9d4f3b74-8b17-4a8c-93ea-40e843b34ce1	9d4f3b74-8c86-4d03-8e64-da59eafc1fe1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":453,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:30:54
1063	9d4f3e6e-f52f-4fb2-b372-f3261310f158	9d4f3e6f-2420-451a-974b-e566c85c018c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 17:39:14
1170	9d4fc28f-66cf-4d42-a46e-2c7cfb46f2cb	9d4fc28f-682f-4f6d-ab26-b894ff2b336d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":395,"memory":22,"hostname":"EderCortes"}	2024-10-22 23:48:41
2225	9d50e50b-dda3-4aa2-8400-3c09021a3e15	9d50e50b-e055-4634-aa37-b247e586b491	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":153,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:20:57
1975	9d50e246-5278-460d-960c-7c76070a360d	9d50e246-9c3e-4d10-a12e-2f6810e78155	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 13:13:12
1352	9d50ccd1-9068-429b-a4e7-902aa17cef02	9d50ccd1-976a-49cd-bd9d-9968c3e727ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 12:13:12
1353	9d50ccd1-962b-4d06-9d8b-710c97543f74	9d50ccd1-976a-49cd-bd9d-9968c3e727ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 12:13:12
1354	9d50ccd1-967c-43dc-b0c1-c98d8b8ac109	9d50ccd1-976a-49cd-bd9d-9968c3e727ff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":"Empty Response","duration":239,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:13:12
1976	9d50e246-9734-409c-b87e-192c113d3293	9d50e246-9c3e-4d10-a12e-2f6810e78155	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"154.79","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:13:12
1977	9d50e246-978c-4d7b-ac9a-fe7ce98695d2	9d50e246-9c3e-4d10-a12e-2f6810e78155	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 13:13:12
1978	9d50e246-9af3-4957-ae8f-a620482aa603	9d50e246-9c3e-4d10-a12e-2f6810e78155	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 13:13:12
1979	9d50e246-9b3a-42c7-89a6-c391f3c4fbb2	9d50e246-9c3e-4d10-a12e-2f6810e78155	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":338,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:13:12
3106	9d5101c8-3e72-4964-a469-e677b47c6699	9d5101c8-4609-4fdd-b1f4-310d212ecd89	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:41:18
969	9d4f3b76-98d7-45eb-8195-03bca6c0a688	9d4f3b76-ebac-4560-a0fc-82b0c349bed8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 17:30:56
970	9d4f3b76-e33e-42fb-b143-46710dd6cb3d	9d4f3b76-ebac-4560-a0fc-82b0c349bed8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"160.87","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-22 17:30:56
971	9d4f3b76-e3cd-4d94-8175-20b390869fb4	9d4f3b76-ebac-4560-a0fc-82b0c349bed8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 17:30:56
972	9d4f3b76-e9f9-4fab-8e89-effc49192a93	9d4f3b76-ebac-4560-a0fc-82b0c349bed8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 17:30:56
973	9d4f3b76-ea70-420c-b5ea-3006602bee95	9d4f3b76-ebac-4560-a0fc-82b0c349bed8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":632,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:30:56
1064	9d4f3e6f-20e8-4d6e-97c2-596e7784fb22	9d4f3e6f-2420-451a-974b-e566c85c018c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 17:39:14
1065	9d4f3e6f-226c-40f1-858f-03e0444b7e88	9d4f3e6f-2420-451a-974b-e566c85c018c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":319,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:39:14
12866	9d5ced4c-b7b7-44fc-bed1-cabfba335e56	9d5ced4c-b8b3-402f-8734-46b779a2eb98	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:53:57
14472	9d5eb89c-4d74-4bfa-89f6-8b89e4f3a630	9d5eb89c-52ec-41b7-9643-d3ab2e7defd9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":184,"memory":18,"hostname":"EderCortes"}	2024-10-30 10:18:17
1359	9d50cd0c-592c-45fd-94de-30712aa23b6b	9d50cd0c-6124-4f3a-8f49-9298a470c53b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 12:13:50
1360	9d50cd0c-5f29-4957-b891-246ac2d71c9b	9d50cd0c-6124-4f3a-8f49-9298a470c53b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 12:13:50
1361	9d50cd0c-5fc6-4c99-9dfc-227679e9d5a0	9d50cd0c-6124-4f3a-8f49-9298a470c53b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":"Empty Response","duration":216,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:13:50
3107	9d5101c8-43e5-48d3-8098-16bbdadfba24	9d5101c8-4609-4fdd-b1f4-310d212ecd89	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-23 14:41:18
3108	9d5101c8-4443-4de5-893a-f29783a352db	9d5101c8-4609-4fdd-b1f4-310d212ecd89	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":444,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:41:18
1066	9d4f3e6f-8d5b-4ae6-87d2-d017e622adeb	9d4f3e6f-b465-4bc7-ac1a-8c830af14d9a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 17:39:14
1067	9d4f3e6f-ade4-41da-93c0-43aea9f4fe18	9d4f3e6f-b465-4bc7-ac1a-8c830af14d9a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"53.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-22 17:39:14
1068	9d4f3e6f-ae52-4a5e-b7a2-5aa60ee90846	9d4f3e6f-b465-4bc7-ac1a-8c830af14d9a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-22 17:39:14
1069	9d4f3e6f-b318-48b4-9a66-e8c6d35a2231	9d4f3e6f-b465-4bc7-ac1a-8c830af14d9a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 17:39:14
978	9d4f3b9b-e3ed-43ce-aae4-9a71962d2f57	9d4f3b9c-3d64-4f17-9bf0-949d335bc791	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 17:31:20
979	9d4f3b9c-33ca-4eb4-9ae1-3edebe0f0618	9d4f3b9c-3d64-4f17-9bf0-949d335bc791	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"173.17","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-22 17:31:20
1070	9d4f3e6f-b36b-44cb-9746-e772aad9b4e8	9d4f3e6f-b465-4bc7-ac1a-8c830af14d9a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:39:14
12867	9d5ced4c-f6e3-41b6-ab34-e1a2630693a8	9d5ced4d-37b1-4375-93f6-ee0d1508949a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 12:53:57
12868	9d5ced4d-33db-465b-b813-f76a6482c086	9d5ced4d-37b1-4375-93f6-ee0d1508949a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"140.22","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:53:58
1362	9d50cd0c-c9c9-48f5-8c5f-e04b51943b39	9d50cd0c-ed7c-4d48-8d30-add96fb5db98	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 12:13:51
1363	9d50cd0c-e7a4-441b-b1f1-e68928d4e200	9d50cd0c-ed7c-4d48-8d30-add96fb5db98	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:13:51
1364	9d50cd0c-e7f9-4b1f-89af-886890912b54	9d50cd0c-ed7c-4d48-8d30-add96fb5db98	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 12:13:51
1365	9d50cd0c-ec48-4064-8f54-22ea229acb07	9d50cd0c-ed7c-4d48-8d30-add96fb5db98	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 12:13:51
1366	9d50cd0c-ec96-4258-8fa6-4acb00518c27	9d50cd0c-ed7c-4d48-8d30-add96fb5db98	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":298,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:13:51
12869	9d5ced4d-3691-41ab-8efd-e7bec8fce153	9d5ced4d-37b1-4375-93f6-ee0d1508949a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 12:53:58
12870	9d5ced4d-36d0-4386-80e9-67a67bdc5d30	9d5ced4d-37b1-4375-93f6-ee0d1508949a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":306,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:53:58
14473	9d5eb89e-2d46-429e-9b8d-1fbe7c1cdfcd	9d5eb8a1-7dd4-43fe-851a-ed3355ead13a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-30 10:18:18
11651	9d5ccd52-e226-4629-b4bd-a62993606bd7	9d5ccd52-e7b1-4763-ae85-53eaf94483c3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":240,"memory":20,"hostname":"EderCortes"}	2024-10-29 11:24:33
766	9d4f2e93-eedf-4b28-8a96-96c59eac259e	9d4f2e94-3768-4d55-80cb-4d0a1f322000	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-22 16:54:54
767	9d4f2e94-3574-4378-8ce6-a03809638014	9d4f2e94-3768-4d55-80cb-4d0a1f322000	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-22 16:54:54
768	9d4f2e94-3628-4cb1-8af0-aa1b2b4c5428	9d4f2e94-3768-4d55-80cb-4d0a1f322000	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":353,"memory":22,"hostname":"EderCortes"}	2024-10-22 16:54:54
1071	9d4f3e70-039b-4080-a11d-0785b52a025b	9d4f3e70-295c-4394-ace2-21e20350195f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 17:39:15
1072	9d4f3e70-2397-4307-80e2-3199582af8cf	9d4f3e70-295c-4394-ace2-21e20350195f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-22 17:39:15
1073	9d4f3e70-23f6-4ff7-b27f-448ea067484c	9d4f3e70-295c-4394-ace2-21e20350195f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-22 17:39:15
1074	9d4f3e70-280d-4cc6-adb9-eb91713c0e07	9d4f3e70-295c-4394-ace2-21e20350195f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 17:39:15
1075	9d4f3e70-285c-4265-b0c8-1c664dd003b6	9d4f3e70-295c-4394-ace2-21e20350195f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":284,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:39:15
1980	9d50e252-7d76-47b3-b9d6-470ce6c9ec87	9d50e252-802f-4e6d-b19a-fd5ff46de5f2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":164,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:13:20
1367	9d50cd0e-6668-4f1d-9202-d5c0ef4e4c1a	9d50cd0e-8b19-46c4-a081-c7f42157865a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 12:13:52
1368	9d50cd0e-85f5-41c3-b880-f5629ecf66de	9d50cd0e-8b19-46c4-a081-c7f42157865a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"51.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 12:13:52
1369	9d50cd0e-8647-4669-9837-e9d52089a66e	9d50cd0e-8b19-46c4-a081-c7f42157865a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 12:13:52
1370	9d50cd0e-89b0-47a3-bbe0-1c02ddbc1921	9d50cd0e-8b19-46c4-a081-c7f42157865a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 12:13:52
1371	9d50cd0e-89ff-4d30-a2bf-3e818b68b0c6	9d50cd0e-8b19-46c4-a081-c7f42157865a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":433,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:13:52
11343	9d5cb982-a607-4fcf-a21c-2d0b7c977d88	9d5cb983-1220-4fa4-8417-7e3f486ce823	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 10:29:08
11344	9d5cb983-103f-42fa-ace4-272e790ab7d8	9d5cb983-1220-4fa4-8417-7e3f486ce823	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 10:29:09
12871	9d5ced4e-a383-487d-92cd-6431abebd223	9d5ced4e-c1de-472d-a0d4-0bad9fc476d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 12:53:59
12872	9d5ced4e-bc8b-4ab2-897f-72d42aa1d726	9d5ced4e-c1de-472d-a0d4-0bad9fc476d1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '18' and \\"users\\".\\"deleted_at\\" is null","time":"41.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":54,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-29 12:53:59
11345	9d5cb983-109f-4007-a7ff-f2e23e67c054	9d5cb983-1220-4fa4-8417-7e3f486ce823	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/barrio","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\barrio\\\\BarrioController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":"HTML Response","duration":475,"memory":24,"hostname":"EderCortes"}	2024-10-29 10:29:09
12873	9d5ced4e-bcd8-4cd3-99e0-d87ab5fc7b59	9d5ced4e-c1de-472d-a0d4-0bad9fc476d1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 12:53:59
1981	9d50e252-dbba-4c19-b269-2e54b210f387	9d50e253-23bc-4bc2-ba75-3526c8f6b7d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 13:13:20
1372	9d50cd0e-cde0-4120-98de-eacfc7e07943	9d50cd0e-d526-458e-957e-5525ad683838	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 12:13:52
980	9d4f3b9c-345c-47cd-99d8-b8bbc54494f9	9d4f3b9c-3d64-4f17-9bf0-949d335bc791	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 17:31:20
981	9d4f3b9c-3b6e-47cd-815b-85a71a9ebcbf	9d4f3b9c-3d64-4f17-9bf0-949d335bc791	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 17:31:20
982	9d4f3b9c-3bfc-4cc2-9a79-4dd302c5631d	9d4f3b9c-3d64-4f17-9bf0-949d335bc791	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":565,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:31:20
1373	9d50cd0e-d351-420d-ba27-04e370111753	9d50cd0e-d526-458e-957e-5525ad683838	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 12:13:52
1374	9d50cd0e-d3da-47b1-a3b2-06659f85266b	9d50cd0e-d526-458e-957e-5525ad683838	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":"Empty Response","duration":177,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:13:52
1982	9d50e253-1e2f-45f2-b30e-c7c422760a30	9d50e253-23bc-4bc2-ba75-3526c8f6b7d0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder%' or \\"users\\".\\"user_document\\"::text like '%eder%' order by \\"users\\".\\"user_document\\" asc","time":"152.71","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:13:20
1983	9d50e253-2222-42bf-891b-5b2c50e9982a	9d50e253-23bc-4bc2-ba75-3526c8f6b7d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 13:13:20
1984	9d50e253-227b-4f3d-9219-1b9dca2f5d36	9d50e253-23bc-4bc2-ba75-3526c8f6b7d0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":327,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:13:20
12874	9d5ced4e-c089-4549-9ff3-cefdd6388ca9	9d5ced4e-c1de-472d-a0d4-0bad9fc476d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 12:53:59
14474	9d5eb8a0-78fe-4fb2-9b28-4f51a9360e72	9d5eb8a1-7dd4-43fe-851a-ed3355ead13a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortes10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"66.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-30 10:18:20
14475	9d5eb8a1-7c11-40a9-b77b-0d57202f29f1	9d5eb8a1-7dd4-43fe-851a-ed3355ead13a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 10:18:20
38458	9d6b64e5-ab47-4802-bb48-5abb9b970bf4	9d6b64e5-b0da-4113-a216-5ad1ea7ab128	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"144.02","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:29:58
12875	9d5ced4e-c0db-4e63-9fc2-bcce9a5711cb	9d5ced4e-c1de-472d-a0d4-0bad9fc476d1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/18","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}},"duration":228,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:53:59
1518	9d50d61d-11b6-473a-80d3-999f9cb12f5d	9d50d61d-377b-4c18-90a5-4625c0c65507	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 12:39:11
1519	9d50d61d-351f-4653-88c8-31e86cbaee18	9d50d61d-377b-4c18-90a5-4625c0c65507	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:39:11
1520	9d50d61d-35d7-45df-885e-c9fe294bb1d3	9d50d61d-377b-4c18-90a5-4625c0c65507	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":312,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:39:11
11326	9d5cb8ff-443b-4335-8819-a500255524d6	9d5cb8ff-acd6-4dba-a122-e2a0b8e19eb1	28fbd310438901f3c075cd8c37c6399f	f	exception	{"class":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\barrio\\\\BarrioController.php","line":37,"message":"DateTime::modify(): Failed to parse time string (+0 * 15 days ) at position 3 (*): Unexpected character","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255},[],{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\barrio\\\\BarrioController.php","line":37},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"28":"        $fecha_inicio = \\"30-10-2024\\";","29":"","30":"        $fecha_inicio_obj = DateTime::createFromFormat('d-m-Y', $fecha_inicio);","31":"","32":"        $pagos = [];","33":"","34":"","35":"        for ($i = 0; $i < $num_cuotas; $i++) {","36":"            $fecha_pago = clone $fecha_inicio_obj;","37":"            $fecha_pago->modify(\\"+$i * 15 days \\");","38":"","39":"            $pagos[] = [","40":"                \\"fecha\\" => $fecha_pago->format('d-m-Y'),","41":"                \\"monto\\" => $monto_cuota","42":"            ];","43":"        }","44":"","45":"        foreach ($pagos as $pago) {","46":"            echo \\"Fecha de pago: \\" . $pago['fecha'] . \\", Monto de la cuota: \\" . $pago['monto'] . \\"\\\\n\\";","47":"        }"},"hostname":"EderCortes","occurrences":1}	2024-10-29 10:27:42
12981	9d5cefb2-4a07-4c1b-9a34-55004c821042	9d5cefb2-4e68-4078-aed0-c017a23be10a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"143.59","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-29 13:00:39
11330	9d5cb91c-0d1c-4ed6-af90-8ee1c03ba156	9d5cb91c-74f4-4dfc-9316-4fafb312633b	28fbd310438901f3c075cd8c37c6399f	f	exception	{"class":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\barrio\\\\BarrioController.php","line":37,"message":"DateTime::modify(): Failed to parse time string (+0 * 15 days) at position 3 (*): Unexpected character","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255},[],{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\barrio\\\\BarrioController.php","line":37},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"28":"        $fecha_inicio = \\"30-10-2024\\";","29":"","30":"        $fecha_inicio_obj = DateTime::createFromFormat('d-m-Y', $fecha_inicio);","31":"","32":"        $pagos = [];","33":"","34":"","35":"        for ($i = 0; $i < $num_cuotas; $i++) {","36":"            $fecha_pago = clone $fecha_inicio_obj;","37":"            $fecha_pago->modify(\\"+$i * 15 days\\");","38":"","39":"            $pagos[] = [","40":"                \\"fecha\\" => $fecha_pago->format('d-m-Y'),","41":"                \\"monto\\" => $monto_cuota","42":"            ];","43":"        }","44":"","45":"        foreach ($pagos as $pago) {","46":"            echo \\"Fecha de pago: \\" . $pago['fecha'] . \\", Monto de la cuota: \\" . $pago['monto'] . \\"\\\\n\\";","47":"        }"},"hostname":"EderCortes","occurrences":2}	2024-10-29 10:28:01
11334	9d5cb932-5a6a-4768-9b19-28c2f96d9812	9d5cb932-c435-401a-9ead-6a1a7af9c3e2	28fbd310438901f3c075cd8c37c6399f	f	exception	{"class":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\barrio\\\\BarrioController.php","line":37,"message":"DateTime::modify(): Failed to parse time string (+1 * 15 days) at position 3 (*): Unexpected character","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255},[],{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\barrio\\\\BarrioController.php","line":37},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"28":"        $fecha_inicio = \\"30-10-2024\\";","29":"","30":"        $fecha_inicio_obj = DateTime::createFromFormat('d-m-Y', $fecha_inicio);","31":"","32":"        $pagos = [];","33":"","34":"","35":"        for ($i = 1; $i < $num_cuotas; $i++) {","36":"            $fecha_pago = clone $fecha_inicio_obj;","37":"            $fecha_pago->modify(\\"+$i * 15 days\\");","38":"","39":"            $pagos[] = [","40":"                \\"fecha\\" => $fecha_pago->format('d-m-Y'),","41":"                \\"monto\\" => $monto_cuota","42":"            ];","43":"        }","44":"","45":"        foreach ($pagos as $pago) {","46":"            echo \\"Fecha de pago: \\" . $pago['fecha'] . \\", Monto de la cuota: \\" . $pago['monto'] . \\"\\\\n\\";","47":"        }"},"hostname":"EderCortes","occurrences":3}	2024-10-29 10:28:16
12982	9d5cefb2-4d4c-4030-bc52-ba9b17a85202	9d5cefb2-4e68-4078-aed0-c017a23be10a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 13:00:39
38459	9d6b64e5-aba7-4ceb-a672-db46a49099fa	9d6b64e5-b0da-4113-a216-5ad1ea7ab128	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:29:58
1521	9d50d61d-8d0c-47b4-8dcd-9975f2dfa5b7	9d50d61d-add0-4763-998f-f62ddf714214	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:39:12
1522	9d50d61d-a7cf-481b-add6-910a8548a860	9d50d61d-add0-4763-998f-f62ddf714214	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":64,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:39:12
1523	9d50d61d-a820-4de7-bb76-6652d610ef75	9d50d61d-add0-4763-998f-f62ddf714214	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 12:39:12
1524	9d50d61d-ac84-429d-9872-a48d409fc263	9d50d61d-add0-4763-998f-f62ddf714214	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:39:12
921	9d4f3499-5849-4a81-b832-0840eec34403	9d4f3499-7654-4ba0-b55b-834fd88ab62f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 17:11:44
922	9d4f3499-74e6-45ae-8934-db0d46b7cf8f	9d4f3499-7654-4ba0-b55b-834fd88ab62f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 17:11:44
923	9d4f3499-7582-4ddb-9150-229b8d9feb78	9d4f3499-7654-4ba0-b55b-834fd88ab62f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:11:44
1525	9d50d61d-acd6-4448-87ff-0b8be8287c5a	9d50d61d-add0-4763-998f-f62ddf714214	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":278,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:39:12
11338	9d5cb96b-2af1-4e03-9546-c2173d5a0660	9d5cb96b-93ef-43f1-835e-5cd7182222bf	28fbd310438901f3c075cd8c37c6399f	f	exception	{"class":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\barrio\\\\BarrioController.php","line":37,"message":"DateTime::modify(): Failed to parse time string (+0 * 2 week ) at position 3 (*): Unexpected character","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255},[],{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\barrio\\\\BarrioController.php","line":37},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"28":"        $fecha_inicio = \\"30-10-2024\\";","29":"","30":"        $fecha_inicio_obj = DateTime::createFromFormat('d-m-Y', $fecha_inicio);","31":"","32":"        $pagos = [];","33":"","34":"","35":"        for ($i = 0; $i < $num_cuotas; $i++) {","36":"            $fecha_pago = clone $fecha_inicio_obj;","37":"            $fecha_pago->modify(\\"+$i * 2 week \\");","38":"","39":"            $pagos[] = [","40":"                \\"fecha\\" => $fecha_pago->format('d-m-Y'),","41":"                \\"monto\\" => $monto_cuota","42":"            ];","43":"        }","44":"","45":"        foreach ($pagos as $pago) {","46":"            echo \\"Fecha de pago: \\" . $pago['fecha'] . \\", Monto de la cuota: \\" . $pago['monto'] . \\"\\\\n\\";","47":"        }"},"hostname":"EderCortes","occurrences":4}	2024-10-29 10:28:53
9135	9d52f442-8fdc-4b50-999f-baa385237b1a	9d52f442-90b9-40db-b672-083d5178da0f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":263,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:55:08
1985	9d50e257-8445-4aaf-8c4f-fff4397512fe	9d50e257-87d7-46e9-9aae-36f39f33863b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":177,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:13:23
2226	9d50e50c-5adf-4b0a-93fd-0f5f78bae2e5	9d50e50c-5dc0-4519-a107-f828ae372ee7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":139,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:20:57
12876	9d5ced7b-4888-4f7c-ae95-7c3b6d036b68	9d5ced7b-8e08-4864-8b1e-45a21cd3ac66	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 12:54:28
38460	9d6b64e5-af9d-4dcf-800e-4aa4a0d6f758	9d6b64e5-b0da-4113-a216-5ad1ea7ab128	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:29:58
8764	9d52eec7-6e7b-4a64-997c-b8e0db0b3e9e	9d52eec7-8bb3-4b2f-935d-97715d594a6d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 13:39:49
1282	9d50cad6-7379-41c7-b154-cae4bc0b9340	9d50cad6-9808-4a19-bb28-d0751329e5e1	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 12:07:39
1283	9d50cad6-9605-4078-b6fd-d2f5ee93f53a	9d50cad6-9808-4a19-bb28-d0751329e5e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:07:40
1284	9d50cad6-96c2-4291-86b1-3467d4c262e8	9d50cad6-9808-4a19-bb28-d0751329e5e1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":285,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:07:40
3559	9d5108de-10fc-4011-92fa-db6a37615924	9d5108de-4b46-442b-a0d6-b3f7621b209e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 15:01:06
2515	9d50fa05-9b0a-4b46-8a8a-64e29b5ed082	9d50fa05-d849-42f0-a230-4525e0e93471	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:19:36
2227	9d50e50c-da16-4f18-8cb4-5d0607938977	9d50e50d-1ee3-4e78-884f-a38ed5530200	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 13:20:57
2228	9d50e50d-19f5-43be-a6a0-87fea295897d	9d50e50d-1ee3-4e78-884f-a38ed5530200	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%10046%' or \\"users\\".\\"user_document\\"::text like '%10046%' order by \\"users\\".\\"user_document\\" asc","time":"147.36","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:20:57
2229	9d50e50d-1db5-4fc3-a763-c16fe13ab02c	9d50e50d-1ee3-4e78-884f-a38ed5530200	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 13:20:57
1526	9d50d61d-f233-45aa-8717-bc2c9fde6977	9d50d61e-0fc5-4662-be6c-baee08cf5538	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:39:12
2230	9d50e50d-1dfa-41a5-bcb4-cc52617b4261	9d50e50d-1ee3-4e78-884f-a38ed5530200	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"10046"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":14,"name_customer":"Luis andre  Herrera - 100465545"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":326,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:20:57
2516	9d50fa05-cbd5-45d6-b267-f985d8c0099b	9d50fa05-d849-42f0-a230-4525e0e93471	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"81.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:19:36
2517	9d50fa05-cc7d-4e7c-a016-692ff6148a3e	9d50fa05-d849-42f0-a230-4525e0e93471	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:19:36
2518	9d50fa05-d5b1-4c0f-ad19-5293e571bfbf	9d50fa05-d849-42f0-a230-4525e0e93471	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:19:36
2519	9d50fa05-d63c-4fd7-95dd-acf5d20a3d83	9d50fa05-d849-42f0-a230-4525e0e93471	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":545,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:19:36
3560	9d5108de-40e4-4093-a3de-9a3d8b944376	9d5108de-4b46-442b-a0d6-b3f7621b209e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"81.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:01:06
3561	9d5108de-4195-4c3e-8a47-5d4f79ac10ab	9d5108de-4b46-442b-a0d6-b3f7621b209e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 15:01:06
3562	9d5108de-48e8-4870-9f47-728874d9d4f5	9d5108de-4b46-442b-a0d6-b3f7621b209e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 15:01:06
3563	9d5108de-498d-42e9-9dbd-5431a99db785	9d5108de-4b46-442b-a0d6-b3f7621b209e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":528,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:01:06
1285	9d50cad6-ea33-42ba-ad76-a42c992ed1b5	9d50cad7-2fbf-4d7f-87aa-96c37cb6a7dc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:07:40
1286	9d50cad7-2aa5-4c69-b6d0-171ceb69c072	9d50cad7-2fbf-4d7f-87aa-96c37cb6a7dc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"143.11","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:07:40
1287	9d50cad7-2af0-4ca9-b2ef-d6f86df7b785	9d50cad7-2fbf-4d7f-87aa-96c37cb6a7dc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 12:07:40
1288	9d50cad7-2e88-4188-9b34-71ca395c3113	9d50cad7-2fbf-4d7f-87aa-96c37cb6a7dc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:07:40
1289	9d50cad7-2ec7-453f-8f21-4f2f2ba44cdb	9d50cad7-2fbf-4d7f-87aa-96c37cb6a7dc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":366,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:07:40
1527	9d50d61e-0a52-4123-b61c-2d33668c2ebb	9d50d61e-0fc5-4662-be6c-baee08cf5538	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":64,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:39:12
1528	9d50d61e-0ab1-40c6-98f1-1e80057c0c2f	9d50d61e-0fc5-4662-be6c-baee08cf5538	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 12:39:12
1529	9d50d61e-0ea8-407c-b8ea-5be9b29c392a	9d50d61e-0fc5-4662-be6c-baee08cf5538	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:39:12
1530	9d50d61e-0eed-4e7b-9983-2a6bd3334e5a	9d50d61e-0fc5-4662-be6c-baee08cf5538	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:39:12
2231	9d50e50d-5a51-45e7-a4fd-5d9c2ed42bb4	9d50e50d-5d2b-4e0e-80fa-d2d77b844ed9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":133,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:20:58
1986	9d50e258-39d2-4366-88d5-4598fab05341	9d50e258-55f5-4e38-8686-d698351da37d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 13:13:23
1987	9d50e258-51a2-4f52-ba76-9d38c33719c2	9d50e258-55f5-4e38-8686-d698351da37d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder%' or \\"users\\".\\"user_document\\"::text like '%eder%' order by \\"users\\".\\"user_document\\" asc","time":"39.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:13:23
1988	9d50e258-54b7-440f-b577-b7cda0c1ff41	9d50e258-55f5-4e38-8686-d698351da37d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 13:13:23
1989	9d50e258-54fd-4974-bcb9-f9f781b9714c	9d50e258-55f5-4e38-8686-d698351da37d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":217,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:13:23
2520	9d50fa06-544d-4fd0-947a-8c00583ba44b	9d50fa06-8342-4747-85d3-7f0cb178493c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:19:36
3564	9d5108de-c8b9-4a80-a7e7-b969b9cca315	9d5108de-fb51-4bc5-818d-107a72d7af80	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 15:01:07
11657	9d5ccd6f-3c7d-445f-a2ca-353defed8bca	9d5ccd6f-3fc9-4704-b0b2-221487d25a84	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":157,"memory":20,"hostname":"EderCortes"}	2024-10-29 11:24:51
975	9d4f3b9a-aaec-4855-b1a9-6d2cf9942e1b	9d4f3b9a-cb3f-432b-bf27-464aeeee505f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-22 17:31:19
976	9d4f3b9a-c9d3-40b2-835f-26addf6bf734	9d4f3b9a-cb3f-432b-bf27-464aeeee505f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 17:31:19
977	9d4f3b9a-ca68-49b0-a36c-434f707c2432	9d4f3b9a-cb3f-432b-bf27-464aeeee505f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":257,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:31:19
11342	9d5cb982-abb5-43ef-add0-44d707752385	9d5cb983-1220-4fa4-8417-7e3f486ce823	28fbd310438901f3c075cd8c37c6399f	f	exception	{"class":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\barrio\\\\BarrioController.php","line":37,"message":"DateTime::modify(): Failed to parse time string (+1 * 2 week ) at position 3 (*): Unexpected character","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255},[],{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\barrio\\\\BarrioController.php","line":37},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"28":"        $fecha_inicio = \\"30-10-2024\\";","29":"","30":"        $fecha_inicio_obj = DateTime::createFromFormat('d-m-Y', $fecha_inicio);","31":"","32":"        $pagos = [];","33":"","34":"","35":"        for ($i = 1; $i < $num_cuotas; $i++) {","36":"            $fecha_pago = clone $fecha_inicio_obj;","37":"            $fecha_pago->modify(\\"+$i * 2 week \\");","38":"","39":"            $pagos[] = [","40":"                \\"fecha\\" => $fecha_pago->format('d-m-Y'),","41":"                \\"monto\\" => $monto_cuota","42":"            ];","43":"        }","44":"","45":"        foreach ($pagos as $pago) {","46":"            echo \\"Fecha de pago: \\" . $pago['fecha'] . \\", Monto de la cuota: \\" . $pago['monto'] . \\"\\\\n\\";","47":"        }"},"hostname":"EderCortes","occurrences":5}	2024-10-29 10:29:09
12877	9d5ced7b-89f3-4c10-b6b9-bcf60d98fb63	9d5ced7b-8e08-4864-8b1e-45a21cd3ac66	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"155.12","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-29 12:54:28
12878	9d5ced7b-8cb6-4713-8aa3-71bb25501be5	9d5ced7b-8e08-4864-8b1e-45a21cd3ac66	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 12:54:28
1290	9d50cad7-7394-496d-afc6-91cde3c32568	9d50cad7-bc37-4340-aa48-935102dce9cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:07:40
1531	9d50d61f-a32c-483d-89b0-04a45b27240f	9d50d61f-c0bf-4376-b20e-87238ca464ad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:39:13
1532	9d50d61f-bc0e-460e-bf6d-c49f5e197a50	9d50d61f-c0bf-4376-b20e-87238ca464ad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 12:39:13
1533	9d50d61f-bc59-45c2-bf2c-1794de7192d4	9d50d61f-c0bf-4376-b20e-87238ca464ad	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 12:39:13
1534	9d50d61f-bf70-49b4-bc3f-36b54d94ac91	9d50d61f-c0bf-4376-b20e-87238ca464ad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 12:39:13
2521	9d50fa06-7a3a-4a1e-9691-fc3bb34290c2	9d50fa06-8342-4747-85d3-7f0cb178493c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"67.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:19:36
2522	9d50fa06-7acb-4902-a85d-11c85c1d1728	9d50fa06-8342-4747-85d3-7f0cb178493c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:19:36
2523	9d50fa06-8154-4c74-882e-71330daae2fd	9d50fa06-8342-4747-85d3-7f0cb178493c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:19:36
2524	9d50fa06-81d5-414b-8871-140cd28b38aa	9d50fa06-8342-4747-85d3-7f0cb178493c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":412,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:19:36
1291	9d50cad7-b76d-4662-9dfd-08bceab84113	9d50cad7-bc37-4340-aa48-935102dce9cd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"151.75","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:07:40
1292	9d50cad7-b7b6-4ab7-a686-959e06533b9e	9d50cad7-bc37-4340-aa48-935102dce9cd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 12:07:40
1293	9d50cad7-bb0c-4881-89ad-248084c53163	9d50cad7-bc37-4340-aa48-935102dce9cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:07:40
1294	9d50cad7-bb4f-4b19-b10c-ad738d416335	9d50cad7-bc37-4340-aa48-935102dce9cd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:07:40
1535	9d50d61f-bfb2-4d23-8ef8-20d20d822aae	9d50d61f-c0bf-4376-b20e-87238ca464ad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":220,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:39:13
12879	9d5ced7b-8d16-4384-af03-de890cddcf7b	9d5ced7b-8e08-4864-8b1e-45a21cd3ac66	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":324,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:54:28
9136	9d52f442-dd21-44a1-af87-d4cbca3392d3	9d52f442-fdf0-42a9-b090-0749ea752798	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:55:09
9137	9d52f442-f5d7-4c92-9882-8dfee5501056	9d52f442-fdf0-42a9-b090-0749ea752798	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"43.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-24 13:55:09
9138	9d52f442-f63c-4ed1-9414-38006ac4e4ab	9d52f442-fdf0-42a9-b090-0749ea752798	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:55:09
9139	9d52f442-f807-40b1-81e5-183e34d12771	9d52f442-fdf0-42a9-b090-0749ea752798	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"2.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 13:55:09
9140	9d52f442-f844-4d79-b803-8a4d7f64e489	9d52f442-fdf0-42a9-b090-0749ea752798	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:55:09
9141	9d52f442-fc58-43c4-b9ea-7035ddea45a6	9d52f442-fdf0-42a9-b090-0749ea752798	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:55:09
9142	9d52f442-fcbc-4733-9ab6-9b3a01c1a047	9d52f442-fdf0-42a9-b090-0749ea752798	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":262,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:55:09
1536	9d50d62a-9615-4ea7-af0b-da1993832332	9d50d62a-993e-4885-924f-52324ed04f9a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":161,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:39:20
11346	9d5cb9bd-f0c6-41b8-96c2-8fd95303fb84	9d5cb9be-55d3-4df2-bb85-cbb13c12b4f9	28fbd310438901f3c075cd8c37c6399f	t	exception	{"class":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\barrio\\\\BarrioController.php","line":37,"message":"DateTime::modify(): Failed to parse time string (+1 * 15 days) at position 3 (*): Unexpected character","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255},[],{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\barrio\\\\BarrioController.php","line":37},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"28":"        $fecha_inicio = \\"30-10-2024\\";","29":"","30":"        $fecha_inicio_obj = DateTime::createFromFormat('d-m-Y', $fecha_inicio);","31":"","32":"        $pagos = [];","33":"","34":"","35":"        for ($i = 1; $i < $num_cuotas; $i++) {","36":"            $fecha_pago = clone $fecha_inicio_obj;","37":"            $fecha_pago->modify(\\"+$i * 15 days\\");","38":"","39":"            $pagos[] = [","40":"                \\"fecha\\" => $fecha_pago->format('d-m-Y'),","41":"                \\"monto\\" => $monto_cuota","42":"            ];","43":"        }","44":"","45":"        foreach ($pagos as $pago) {","46":"            echo \\"Fecha de pago: \\" . $pago['fecha'] . \\", Monto de la cuota: \\" . $pago['monto'] . \\"\\\\n\\";","47":"        }"},"hostname":"EderCortes","occurrences":6}	2024-10-29 10:29:47
11347	9d5cb9bd-ea2b-488f-9a83-633f693fb4e2	9d5cb9be-55d3-4df2-bb85-cbb13c12b4f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 10:29:47
11348	9d5cb9be-53e7-41ac-a76f-2dd1ee754d6c	9d5cb9be-55d3-4df2-bb85-cbb13c12b4f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 10:29:48
1990	9d50e25b-f390-49af-94fe-66eada97c099	9d50e25b-f6de-402f-ae9a-e42eaf43e86a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":170,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:13:26
2408	9d50e7a8-9f17-4a98-91f4-e0805f86f957	9d50e7a8-e5ae-4020-a0c3-47a12cbe3c5a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 13:28:15
2409	9d50e7a8-e42c-49ed-a4e0-856e527e2779	9d50e7a8-e5ae-4020-a0c3-47a12cbe3c5a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 13:28:15
2410	9d50e7a8-e4b9-4583-9c1b-870ec6931b26	9d50e7a8-e5ae-4020-a0c3-47a12cbe3c5a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":338,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:28:15
11349	9d5cb9be-5449-4fe9-8ec6-65f3d821ce39	9d5cb9be-55d3-4df2-bb85-cbb13c12b4f9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/barrio","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\barrio\\\\BarrioController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":"HTML Response","duration":448,"memory":24,"hostname":"EderCortes"}	2024-10-29 10:29:48
13790	9d5d0ec6-17d9-41b0-bd64-338d9609d32c	9d5d0ec6-1906-4ab2-9721-966a40f61dab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ma"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:27:33
12983	9d5cefb2-4da0-4cce-8b5e-909297d56781	9d5cefb2-4e68-4078-aed0-c017a23be10a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":320,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:00:39
35356	9d69c404-b9ee-4e10-bfcc-5cb2945fbfd1	9d69c404-c770-4e61-a5cd-90eaf722e29b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"121.88","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:04:17
13791	9d5d0ec6-68fb-40c1-b292-38712f86e970	9d5d0ec6-8405-4722-9b66-fa6b5816be24	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 14:27:34
13792	9d5d0ec6-7faa-4abd-b363-39e1e3855c51	9d5d0ec6-8405-4722-9b66-fa6b5816be24	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mar%' or \\"users\\".\\"user_document\\"::text like '%Mar%') order by \\"users\\".\\"user_document\\" asc","time":"42.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 14:27:34
1172	9d507d9f-c29b-44a6-b0c1-e62dced07836	9d507da0-972e-4a2a-a1d7-93fba8c4e49e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 08:31:45
1173	9d507da0-89bc-4595-b650-46c3d9656874	9d507da0-972e-4a2a-a1d7-93fba8c4e49e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 08:31:46
1174	9d507da0-9439-4c4e-a33d-f0edcdf15ed6	9d507da0-972e-4a2a-a1d7-93fba8c4e49e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":8373,"memory":22,"hostname":"EderCortes"}	2024-10-23 08:31:46
12984	9d5cefb3-c3c9-4226-97c7-6c712be3cf99	9d5cefb4-0ae5-48cb-8c34-40aa1618b288	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 13:00:40
11350	9d5cba15-ce73-42e1-bfa0-06b07b00cae9	9d5cba15-d865-4ac9-9c39-709792fd50ab	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 10:30:45
13793	9d5d0ec6-82a8-43b7-9b35-a3a6a43650ea	9d5d0ec6-8405-4722-9b66-fa6b5816be24	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 14:27:34
11351	9d5cba15-d6b8-46c1-a9ca-b59d1bd8e911	9d5cba15-d865-4ac9-9c39-709792fd50ab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 10:30:45
11352	9d5cba15-d72e-4afa-a72a-2040e455c102	9d5cba15-d865-4ac9-9c39-709792fd50ab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/barrio","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\barrio\\\\BarrioController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","cache-control":"max-age=0","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","sec-ch-ua-platform":"\\"Windows\\"","upgrade-insecure-requests":"1","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"text\\/html,application\\/xhtml+xml,application\\/xml;q=0.9,image\\/avif,image\\/webp,image\\/apng,*\\/*;q=0.8,application\\/signed-exchange;v=b3;q=0.7","sec-fetch-site":"none","sec-fetch-mode":"navigate","sec-fetch-user":"?1","sec-fetch-dest":"document","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":"Empty Response","duration":197,"memory":20,"hostname":"EderCortes"}	2024-10-29 10:30:45
13794	9d5d0ec6-8304-4c89-bf77-680317eb5bee	9d5d0ec6-8405-4722-9b66-fa6b5816be24	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mar"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":263,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:27:34
1991	9d50e25c-adf2-4785-9250-2a9318dd7fe6	9d50e25c-f3b4-47f9-9161-6fed4a468719	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 13:13:26
12985	9d5cefb4-0649-4b48-88ed-9d57bfbeaa0e	9d5cefb4-0ae5-48cb-8c34-40aa1618b288	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"151.83","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 13:00:41
12986	9d5cefb4-0691-4d63-958d-adeef6ecb611	9d5cefb4-0ae5-48cb-8c34-40aa1618b288	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 13:00:41
12987	9d5cefb4-09b3-4f25-b771-2c1c24ed1f0f	9d5cefb4-0ae5-48cb-8c34-40aa1618b288	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 13:00:41
14476	9d5eb8a1-7c7f-4656-bcc9-216a42db143e	9d5eb8a1-7dd4-43fe-851a-ed3355ead13a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"78","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortes10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":3319,"memory":24,"hostname":"EderCortes"}	2024-10-30 10:18:20
14665	9d5ec061-1550-498e-97ae-c3a2c42ee5fa	9d5ec061-1b3a-4d76-be32-c7689bde8ade	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"59.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-30 10:40:00
13795	9d5d0ec6-c3f5-4fe0-8819-b0700fb6d63f	9d5d0ec7-08df-4459-809f-c5d40708e149	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 14:27:34
13796	9d5d0ec7-04f0-46c1-b7a1-2f1501cf5ace	9d5d0ec7-08df-4459-809f-c5d40708e149	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"151.21","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 14:27:34
1077	9d4f3e70-81d2-45e7-aa7c-beeaf6529662	9d4f3e70-a92e-4d63-8136-c17f98a7e3eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-22 17:39:15
1078	9d4f3e70-a752-4f69-825e-d0501e71f182	9d4f3e70-a92e-4d63-8136-c17f98a7e3eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 17:39:15
1079	9d4f3e70-a80c-4422-b278-b9afbe8c9aad	9d4f3e70-a92e-4d63-8136-c17f98a7e3eb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":313,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:39:15
11663	9d5ccd91-0b25-4389-9c05-0119b81149e6	9d5ccd91-0ec2-47a9-93e1-abb5737e8fc3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":158,"memory":20,"hostname":"EderCortes"}	2024-10-29 11:25:13
13797	9d5d0ec7-07b5-4827-a3b1-d41027284f10	9d5d0ec7-08df-4459-809f-c5d40708e149	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 14:27:34
13798	9d5d0ec7-07fd-43a4-b52e-ceff7bb2a488	9d5d0ec7-08df-4459-809f-c5d40708e149	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":331,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:27:34
14044	9d5d1509-4c6b-451b-911b-57dedec22451	9d5d1509-52a8-443a-be1c-054c6eb17280	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":239,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:45:04
14477	9d5eb8b0-27cf-4fff-afff-d0272acd5eb9	9d5eb8b0-2cd4-475c-a30b-2e496a0d754f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":283,"memory":18,"hostname":"EderCortes"}	2024-10-30 10:18:30
14666	9d5ec061-198c-4e76-bc7a-c90dc1dc3c14	9d5ec061-1b3a-4d76-be32-c7689bde8ade	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 10:40:00
14667	9d5ec061-19f2-4ec5-89e4-ada2f5a7fe23	9d5ec061-1b3a-4d76-be32-c7689bde8ade	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":316,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:40:00
16500	9d64cd74-668b-475e-81b7-3c5cc88da8e6	9d64cd74-6a37-4a10-85d1-e5537773dd75	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":172,"memory":20,"hostname":"EderCortes"}	2024-11-02 10:51:32
35357	9d69c404-ba8e-4e31-a12f-f993b0540e25	9d69c404-c770-4e61-a5cd-90eaf722e29b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:04:17
1080	9d4f3e70-eba4-4946-bf03-63ac45d11ebb	9d4f3e71-0867-44ec-b66c-6936d85598bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 17:39:15
1081	9d4f3e71-03d9-4187-8abe-06e8cb3064ca	9d4f3e71-0867-44ec-b66c-6936d85598bf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-22 17:39:15
1082	9d4f3e71-0432-488c-b30c-70317aa7353a	9d4f3e71-0867-44ec-b66c-6936d85598bf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-22 17:39:15
1083	9d4f3e71-0750-4963-aa74-90eb94b219a3	9d4f3e71-0867-44ec-b66c-6936d85598bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-22 17:39:15
1084	9d4f3e71-079f-494c-90aa-202980cca594	9d4f3e71-0867-44ec-b66c-6936d85598bf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":219,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:39:15
1175	9d507da1-648d-44a1-847d-118e884ce745	9d507da1-b041-4a5c-9cf5-4f231c2c5d4a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 08:31:46
1176	9d507da1-a021-4d7d-8aac-09c388a0712d	9d507da1-b041-4a5c-9cf5-4f231c2c5d4a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"73.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 08:31:46
1177	9d507da1-a0b5-4cc1-b5e0-954af40631f7	9d507da1-b041-4a5c-9cf5-4f231c2c5d4a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 08:31:46
1178	9d507da1-ae50-4c2a-9ee1-4906db284b23	9d507da1-b041-4a5c-9cf5-4f231c2c5d4a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 08:31:46
1179	9d507da1-aee1-4e10-a44a-4b8a296305ce	9d507da1-b041-4a5c-9cf5-4f231c2c5d4a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":669,"memory":22,"hostname":"EderCortes"}	2024-10-23 08:31:46
13799	9d5d0ec8-1326-4366-a29d-40b4fce7db62	9d5d0ec8-15db-4bdc-bc46-c55b40d62b88	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":139,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:27:35
1538	9d50d62b-55f8-45ca-9032-96bf24557b51	9d50d62b-640c-488e-a568-b9180e8b8d76	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 12:39:21
1539	9d50d62b-622d-4007-bab3-163303802f94	9d50d62b-640c-488e-a568-b9180e8b8d76	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 12:39:21
1540	9d50d62b-62c8-4786-b8d0-42d549d4a6f8	9d50d62b-640c-488e-a568-b9180e8b8d76	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"prue"},"session":[],"response_status":500,"response":{"message":"Call to undefined method App\\\\Models\\\\User::table()","exception":"BadMethodCallException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Traits\\\\ForwardsCalls.php","line":67,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Traits\\\\ForwardsCalls.php","line":36,"function":"throwBadMethodCallException","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":2335,"function":"forwardCallTo","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":2347,"function":"__call","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":32,"function":"__callStatic","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getCustomerFilters","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":202,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:39:21
2411	9d50e7a9-2d3c-43ec-bc83-236ad55c2001	9d50e7a9-4ac6-424f-93b8-0c2cb98312d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 13:28:15
2270	9d50e6b3-cf86-4dc7-ba9b-4eb5dfc0c046	9d50e6b3-f663-44e0-8f5a-761ce8130f17	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 13:25:34
2412	9d50e7a9-45bd-488d-9410-bc2349b06eae	9d50e7a9-4ac6-424f-93b8-0c2cb98312d5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:28:15
2413	9d50e7a9-461e-4cf9-bf59-00183953ec66	9d50e7a9-4ac6-424f-93b8-0c2cb98312d5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 13:28:15
2414	9d50e7a9-4982-4f2e-a47c-8ab7ca1a0706	9d50e7a9-4ac6-424f-93b8-0c2cb98312d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 13:28:15
3565	9d5108de-f499-47af-89cc-2204c20f2d20	9d5108de-fb51-4bc5-818d-107a72d7af80	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"70.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:01:07
3566	9d5108de-f519-471b-85c3-53c218c7c29d	9d5108de-fb51-4bc5-818d-107a72d7af80	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 15:01:07
3567	9d5108de-f9cd-4fd0-86e8-1819ecd3dac9	9d5108de-fb51-4bc5-818d-107a72d7af80	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 15:01:07
14478	9d5eb8b0-e572-4ac7-9ad1-9eebb8a795ac	9d5eb8b1-0ec0-409e-a721-6d1d2525cadd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 10:18:30
14668	9d5ec063-e17b-47e1-94c1-36b66bc44cb4	9d5ec064-003a-44a6-80b8-6056486a35aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 10:40:02
1085	9d4f3e71-4a41-4e96-978e-404572dc194b	9d4f3e71-683c-4d88-ab1b-61ece1b46778	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-22 17:39:15
1086	9d4f3e71-634d-48a9-ab10-e56e7132471e	9d4f3e71-683c-4d88-ab1b-61ece1b46778	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-22 17:39:15
1087	9d4f3e71-639d-4133-9afa-c3e414f1b147	9d4f3e71-683c-4d88-ab1b-61ece1b46778	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-22 17:39:15
1088	9d4f3e71-671a-4531-b8bb-95832f8bf81f	9d4f3e71-683c-4d88-ab1b-61ece1b46778	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-22 17:39:15
1089	9d4f3e71-6764-446d-89af-c8e14e224dd8	9d4f3e71-683c-4d88-ab1b-61ece1b46778	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:39:15
1180	9d507da2-779c-46c5-8564-bc1f0d9f2c58	9d507da2-b6a0-480d-86b9-d7344b875fe1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 08:31:47
1181	9d507da2-ad4d-4b24-8c58-29f4cafa6c05	9d507da2-b6a0-480d-86b9-d7344b875fe1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"81.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 08:31:47
1182	9d507da2-add9-427e-acfa-e42d6446205e	9d507da2-b6a0-480d-86b9-d7344b875fe1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 08:31:47
1183	9d507da2-b48e-44a3-a842-3054c1e9e0b0	9d507da2-b6a0-480d-86b9-d7344b875fe1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 08:31:47
1184	9d507da2-b51a-494e-95d6-876b86a9e298	9d507da2-b6a0-480d-86b9-d7344b875fe1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":639,"memory":22,"hostname":"EderCortes"}	2024-10-23 08:31:47
2232	9d50e50d-db2f-481e-9919-90ccb184f215	9d50e50d-df2b-4fc7-b5ad-5204fb11b3e8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":154,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:20:58
1667	9d50dab3-a3bd-4449-bc84-c6235ecb2fa3	9d50dab3-d334-4417-908a-2eb2fb4f590a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 12:52:01
1668	9d50dab3-cfcd-4c10-8b6b-d300ad634ed1	9d50dab3-d334-4417-908a-2eb2fb4f590a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:52:01
1669	9d50dab3-d172-4e3c-a6f3-73548f04a938	9d50dab3-d334-4417-908a-2eb2fb4f590a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":437,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:52:01
1992	9d50e25c-ef92-49ee-8c76-70ba00736518	9d50e25c-f3b4-47f9-9161-6fed4a468719	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder c%' or \\"users\\".\\"user_document\\"::text like '%eder c%' order by \\"users\\".\\"user_document\\" asc","time":"152.31","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:13:26
1993	9d50e25c-f28d-4ac7-af7d-5804a2d1e42a	9d50e25c-f3b4-47f9-9161-6fed4a468719	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 13:13:26
1994	9d50e25c-f2d0-407a-a014-3aa3e5bc3ac6	9d50e25c-f3b4-47f9-9161-6fed4a468719	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"28","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder c"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":338,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:13:26
2271	9d50e6b3-f45b-4763-8582-e6ea372db867	9d50e6b3-f663-44e0-8f5a-761ce8130f17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 13:25:34
2272	9d50e6b3-f538-466f-8b19-80dd1012d2d8	9d50e6b3-f663-44e0-8f5a-761ce8130f17	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":298,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:25:34
1090	9d4f3e73-3fa3-4f34-abe0-bffd82a16134	9d4f3e73-8c59-41e8-b060-25e82b15ac4e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-22 17:39:17
1091	9d4f3e73-85c9-493e-b189-63dc2f8f879d	9d4f3e73-8c59-41e8-b060-25e82b15ac4e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"153.57","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-22 17:39:17
1092	9d4f3e73-8635-4c11-9b5b-e3d0a51a19dc	9d4f3e73-8c59-41e8-b060-25e82b15ac4e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-22 17:39:17
1093	9d4f3e73-8a7a-49dd-bb3d-e6232428ca72	9d4f3e73-8c59-41e8-b060-25e82b15ac4e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-22 17:39:17
984	9d4f3b9c-9a6b-4b54-b3f3-61e181424fca	9d4f3b9c-ee2b-46ea-8618-3bb17b8512bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-22 17:31:20
985	9d4f3b9c-ec18-44be-8b68-1140205d1b3d	9d4f3b9c-ee2b-46ea-8618-3bb17b8512bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-22 17:31:21
986	9d4f3b9c-ed0d-4766-b826-ecee46ca7515	9d4f3b9c-ee2b-46ea-8618-3bb17b8512bd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42P01]: Undefined table: 7 ERROR:  falta una entrada para la tabla \\u00abuser\\u00bb en la cl\\u00e1usula FROM\\nLINE 1: select * from \\"users\\" where \\"user\\".\\"profile_code\\" = $1 and \\"...\\n                                    ^ (Connection: pgsql, SQL: select * from \\"users\\" where \\"user\\".\\"profile_code\\" = 4 and \\"users\\".\\"deleted_at\\" is null order by \\"menu\\".\\"created_at\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":429,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:31:21
1094	9d4f3e73-8aff-43f5-a315-6bddcbde4704	9d4f3e73-8c59-41e8-b060-25e82b15ac4e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":468,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:39:17
1185	9d507da5-0f13-4035-8234-c0b10600c80e	9d507da5-8c8c-4f9f-a49b-85732eab67d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 08:31:49
1186	9d507da5-8206-4487-93d9-f640bfc4c41f	9d507da5-8c8c-4f9f-a49b-85732eab67d2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"238.72","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 08:31:49
1187	9d507da5-828c-4cef-8b19-db790a05e03f	9d507da5-8c8c-4f9f-a49b-85732eab67d2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 08:31:49
1188	9d507da5-8a51-44e5-ad5b-3f58ca901bcc	9d507da5-8c8c-4f9f-a49b-85732eab67d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 08:31:49
1189	9d507da5-8ad7-4bfc-997f-d10cf5d52a39	9d507da5-8c8c-4f9f-a49b-85732eab67d2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":762,"memory":22,"hostname":"EderCortes"}	2024-10-23 08:31:49
1670	9d50dab4-3934-4bae-a4bd-e72c2a4e1651	9d50dab4-5d6f-4202-b9db-69e3baeaf926	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:52:01
1671	9d50dab4-560a-4e1c-9e29-199bd53b783f	9d50dab4-5d6f-4202-b9db-69e3baeaf926	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":65,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:52:01
1672	9d50dab4-5679-456e-b677-d3ca6d95d091	9d50dab4-5d6f-4202-b9db-69e3baeaf926	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 12:52:01
1673	9d50dab4-5bf6-4b62-8231-3683fc860dcd	9d50dab4-5d6f-4202-b9db-69e3baeaf926	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:52:01
1674	9d50dab4-5c51-46a9-bc79-4c6d1f6c6a92	9d50dab4-5d6f-4202-b9db-69e3baeaf926	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":329,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:52:01
1675	9d50dab4-afe7-4292-9ce8-b18158fdcb6d	9d50dab5-0181-4b47-8def-29e7fafe5f26	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:52:02
1676	9d50dab4-fa2e-4ea3-8a26-d9c3bbd733b1	9d50dab5-0181-4b47-8def-29e7fafe5f26	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"159.58","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":65,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:52:02
1677	9d50dab4-fa99-41a9-9999-dc9ff110ce94	9d50dab5-0181-4b47-8def-29e7fafe5f26	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 12:52:02
1678	9d50dab4-ffc9-4822-a9fc-02cc1c3e9cd6	9d50dab5-0181-4b47-8def-29e7fafe5f26	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:52:02
1190	9d507f02-c4b6-433b-99d5-47a3734f7caa	9d507f02-fc9f-41f1-a43b-59d535ecad1b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 08:35:38
1191	9d507f02-ee37-4f39-88ef-2c176dcf4ab9	9d507f02-fc9f-41f1-a43b-59d535ecad1b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"59.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-23 08:35:38
1192	9d507f02-ef1b-4845-801b-06fc7bb372a0	9d507f02-fc9f-41f1-a43b-59d535ecad1b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":3,"hostname":"EderCortes"}	2024-10-23 08:35:38
1193	9d507f02-fa11-4a36-8920-fca408a6ac1a	9d507f02-fc9f-41f1-a43b-59d535ecad1b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 08:35:38
1194	9d507f02-faa9-4e73-90a2-82b544104bb0	9d507f02-fc9f-41f1-a43b-59d535ecad1b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":489,"memory":22,"hostname":"EderCortes"}	2024-10-23 08:35:38
1679	9d50dab5-003f-443f-a8e1-084c15f1559e	9d50dab5-0181-4b47-8def-29e7fafe5f26	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":397,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:52:02
2273	9d50e6b4-5c76-47c5-95b4-6d6e505a727d	9d50e6b4-aa5d-4bea-ab88-23e1c9461db3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 13:25:35
1995	9d50e25f-0925-43b9-80cd-8a5a1e69afd6	9d50e25f-0c81-4ede-9fb2-542ce9dd0050	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":150,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:13:28
2233	9d50e50e-67e6-4a27-ada6-d63210151faa	9d50e50e-ac42-4427-b0ec-b8b55618fc1e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 13:20:58
2234	9d50e50e-a855-4f53-82f6-cb204afdf0c9	9d50e50e-ac42-4427-b0ec-b8b55618fc1e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%100460%' or \\"users\\".\\"user_document\\"::text like '%100460%' order by \\"users\\".\\"user_document\\" asc","time":"149.35","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:20:58
2235	9d50e50e-ab21-4b6d-8df5-f84828cb5999	9d50e50e-ac42-4427-b0ec-b8b55618fc1e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-23 13:20:58
2274	9d50e6b4-a3f5-4092-bcb3-2549f5d0da3d	9d50e6b4-aa5d-4bea-ab88-23e1c9461db3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"157.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:25:35
2275	9d50e6b4-a4d0-4fa0-8cf6-3a9c37296dea	9d50e6b4-aa5d-4bea-ab88-23e1c9461db3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 13:25:35
2276	9d50e6b4-a925-42d4-be7b-3a6a7d62a665	9d50e6b4-aa5d-4bea-ab88-23e1c9461db3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 13:25:35
1680	9d50dab6-c991-422e-98e8-28a982f70f70	9d50dab6-ef96-4c33-9ab3-98a538544a45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:52:03
1681	9d50dab6-e93e-4b49-82de-bbe663b76d21	9d50dab6-ef96-4c33-9ab3-98a538544a45	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"49.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 12:52:03
1682	9d50dab6-e9a4-4bb9-a799-2ca64393ac0c	9d50dab6-ef96-4c33-9ab3-98a538544a45	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 12:52:03
1683	9d50dab6-ee0e-4bd2-a870-dd8ae49f1b59	9d50dab6-ef96-4c33-9ab3-98a538544a45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 12:52:03
1195	9d507f05-cdbb-4f09-9adf-db6fcda33eae	9d507f05-f0a2-4615-af85-8c9c221a1c97	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 08:35:40
1196	9d507f05-eaa2-4db0-99f2-fd983446a40c	9d507f05-f0a2-4615-af85-8c9c221a1c97	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"45.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-23 08:35:40
1197	9d507f05-eafa-4dec-a9b1-e3a8376df8b6	9d507f05-f0a2-4615-af85-8c9c221a1c97	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":3,"hostname":"EderCortes"}	2024-10-23 08:35:40
1198	9d507f05-ef3c-4f1f-9fc4-e30cacf62639	9d507f05-f0a2-4615-af85-8c9c221a1c97	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 08:35:40
1199	9d507f05-ef8f-486d-8d4a-511b72ab8dee	9d507f05-f0a2-4615-af85-8c9c221a1c97	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":462,"memory":22,"hostname":"EderCortes"}	2024-10-23 08:35:40
1684	9d50dab6-ee76-4f7e-a1f3-603eb28058e4	9d50dab6-ef96-4c33-9ab3-98a538544a45	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":377,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:52:03
8765	9d52eec7-86ca-4ed6-8317-2324f69a8106	9d52eec7-8bb3-4b2f-935d-97715d594a6d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:39:49
1996	9d50e25f-b985-4b00-88d6-a8b4ee9465f6	9d50e25f-d57b-4512-bbbb-c2554f9b09c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 13:13:28
1997	9d50e25f-d0a4-401a-9e4a-d1d661112b3e	9d50e25f-d57b-4512-bbbb-c2554f9b09c5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder co%' or \\"users\\".\\"user_document\\"::text like '%eder co%' order by \\"users\\".\\"user_document\\" asc","time":"44.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:13:28
1998	9d50e25f-d3ff-4a57-82ae-6a0ce0465856	9d50e25f-d57b-4512-bbbb-c2554f9b09c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 13:13:28
1999	9d50e25f-d463-49fa-8d40-4d8616ec5dcd	9d50e25f-d57b-4512-bbbb-c2554f9b09c5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"29","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder co"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":209,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:13:28
8766	9d52eec7-8711-4dc9-8b85-b85bd326bfea	9d52eec7-8bb3-4b2f-935d-97715d594a6d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:39:49
8767	9d52eec7-8a73-4a71-96bc-3c21bff553bb	9d52eec7-8bb3-4b2f-935d-97715d594a6d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 13:39:49
2277	9d50e6b4-a985-4694-914f-2036e0f62ca5	9d50e6b4-aa5d-4bea-ab88-23e1c9461db3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":428,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:25:35
2415	9d50e7a9-49c6-4dae-ad18-34cc2a988088	9d50e7a9-4ac6-424f-93b8-0c2cb98312d5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:28:15
2000	9d50e260-1516-4252-8bbb-f5054465b6ba	9d50e260-1847-4fd5-9325-7d5fabea8c6d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":144,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:13:28
13800	9d5d0ec8-7a54-4741-8c46-1f3d370b946c	9d5d0ec8-971d-4a88-af9b-413526e2cb35	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 14:27:35
1200	9d50c52e-9342-4d3d-96d8-fa6945dd49e4	9d50c532-a0c9-4f17-9929-83eb14dabb50	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 11:51:51
1201	9d50c531-16e3-4fcd-9c36-7412137c8d63	9d50c532-a0c9-4f17-9929-83eb14dabb50	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"172.13","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 11:51:52
1202	9d50c531-1faa-4441-a21b-825a628522be	9d50c532-a0c9-4f17-9929-83eb14dabb50	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 11:51:52
1203	9d50c532-6c2e-4a94-878f-fd88e0e714dc	9d50c532-a0c9-4f17-9929-83eb14dabb50	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 11:51:53
1204	9d50c532-723f-45bc-9e8e-ae70fcd46024	9d50c532-a0c9-4f17-9929-83eb14dabb50	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":16298,"memory":22,"hostname":"EderCortes"}	2024-10-23 11:51:53
13801	9d5d0ec8-922e-4c63-b042-e2f0a388e851	9d5d0ec8-971d-4a88-af9b-413526e2cb35	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"45.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 14:27:35
13802	9d5d0ec8-95b3-4b47-ba2a-d8c5c9ee82b1	9d5d0ec8-971d-4a88-af9b-413526e2cb35	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 14:27:35
13803	9d5d0ec8-9608-40c5-8dfb-4bd97efe712e	9d5d0ec8-971d-4a88-af9b-413526e2cb35	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":216,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:27:35
2278	9d50e6b4-eeb5-4197-b5ba-e9e9eb6a7e0f	9d50e6b5-3b48-4b04-9045-8c4e75da1e6c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 13:25:35
2279	9d50e6b5-34f6-4452-883e-f4d212d47136	9d50e6b5-3b48-4b04-9045-8c4e75da1e6c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"154.34","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:25:35
2280	9d50e6b5-356d-4a00-ba76-0ced24a32d71	9d50e6b5-3b48-4b04-9045-8c4e75da1e6c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 13:25:35
2281	9d50e6b5-39d5-463e-8a52-8bbd94b110b5	9d50e6b5-3b48-4b04-9045-8c4e75da1e6c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 13:25:35
2001	9d50e260-8cf6-4a08-a6c1-98f5e765aa7d	9d50e260-d229-4649-a6a7-bc1b36f1a3e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 13:13:29
2002	9d50e260-cd00-4e14-a2bc-714970191029	9d50e260-d229-4649-a6a7-bc1b36f1a3e7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder cor%' or \\"users\\".\\"user_document\\"::text like '%eder cor%' order by \\"users\\".\\"user_document\\" asc","time":"143.09","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:13:29
2003	9d50e260-d0dc-4bbc-97e3-d18c287df61f	9d50e260-d229-4649-a6a7-bc1b36f1a3e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 13:13:29
2004	9d50e260-d133-44c5-91d7-6c31b63b8731	9d50e260-d229-4649-a6a7-bc1b36f1a3e7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"30","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder cor"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":315,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:13:29
2282	9d50e6b5-3a37-4067-8aae-fc3a0e8c3417	9d50e6b5-3b48-4b04-9045-8c4e75da1e6c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:25:35
2416	9d50e7a9-8c4d-4d1e-859b-06571360347c	9d50e7a9-a96f-4e94-a606-6584ee5ac415	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 13:28:15
2417	9d50e7a9-a49a-4cf1-9af6-27b26b8b99c2	9d50e7a9-a96f-4e94-a606-6584ee5ac415	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:28:15
2418	9d50e7a9-a4e1-44b3-b1df-6fc486c33e8f	9d50e7a9-a96f-4e94-a606-6584ee5ac415	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 13:28:15
2419	9d50e7a9-a83f-4330-97b0-44b6e72064db	9d50e7a9-a96f-4e94-a606-6584ee5ac415	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 13:28:16
2420	9d50e7a9-a881-4465-8c76-04ded5bc1357	9d50e7a9-a96f-4e94-a606-6584ee5ac415	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":223,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:28:16
13804	9d5d0ec8-de84-4088-912d-6e6c6898a18f	9d5d0ec9-2614-4c69-9ffb-47b9f35215d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 14:27:35
35358	9d69c404-c4f4-40ab-be6c-489875650909	9d69c404-c770-4e61-a5cd-90eaf722e29b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-11-04 22:04:17
2421	9d50e7aa-dfe5-4356-a1d2-d0d8854e222b	9d50e7ab-1534-4b7d-9a11-b57b2f0caedb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 13:28:16
2422	9d50e7ab-0e67-4b4e-86b5-881e55d62ac5	9d50e7ab-1534-4b7d-9a11-b57b2f0caedb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"60.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 13:28:16
2283	9d50e6b7-03f8-4c03-8f92-112fd25b7e41	9d50e6b7-26a5-4b01-8e95-b84f953ace0c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 13:25:36
1414	9d50d0d8-8987-4245-a6b8-de8f38c2558d	9d50d0d8-d1a7-44fb-be40-2d692847d129	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 12:24:27
1415	9d50d0d8-d00f-4e84-938b-bf714955d9e4	9d50d0d8-d1a7-44fb-be40-2d692847d129	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 12:24:28
1416	9d50d0d8-d0a7-483e-b003-348396790f63	9d50d0d8-d1a7-44fb-be40-2d692847d129	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:24:28
2284	9d50e6b7-21b5-4db2-930e-95a0a2585bbb	9d50e6b7-26a5-4b01-8e95-b84f953ace0c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"47.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 13:25:37
2285	9d50e6b7-221d-4cd8-af85-cc2d62c32675	9d50e6b7-26a5-4b01-8e95-b84f953ace0c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 13:25:37
2286	9d50e6b7-2556-4a93-9fc5-d77b582085c2	9d50e6b7-26a5-4b01-8e95-b84f953ace0c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 13:25:37
2423	9d50e7ab-0ed4-4bdf-b783-54cbe7c3ccf3	9d50e7ab-1534-4b7d-9a11-b57b2f0caedb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 13:28:16
2287	9d50e6b7-2597-4d7f-8ab4-05b4cc876da3	9d50e6b7-26a5-4b01-8e95-b84f953ace0c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":306,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:25:37
2424	9d50e7ab-1365-4ccd-bb4d-1a375241a35a	9d50e7ab-1534-4b7d-9a11-b57b2f0caedb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 13:28:16
2425	9d50e7ab-1402-4d8d-a673-21c695adc61e	9d50e7ab-1534-4b7d-9a11-b57b2f0caedb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":430,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:28:16
13805	9d5d0ec9-2110-4188-9155-290a9f60294a	9d5d0ec9-2614-4c69-9ffb-47b9f35215d9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '18' and \\"users\\".\\"deleted_at\\" is null","time":"144.58","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":55,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-29 14:27:35
13806	9d5d0ec9-215f-4269-b1e7-4a4d90c24cf4	9d5d0ec9-2614-4c69-9ffb-47b9f35215d9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 14:27:35
13807	9d5d0ec9-24e6-4406-9502-8e00067227ca	9d5d0ec9-2614-4c69-9ffb-47b9f35215d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 14:27:35
14479	9d5eb8b1-07c0-4d2c-96e1-3d8cbce51413	9d5eb8b1-0ec0-409e-a721-6d1d2525cadd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortes10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"44.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-30 10:18:30
14480	9d5eb8b1-0d22-4763-830d-5e72f0574d0c	9d5eb8b1-0ec0-409e-a721-6d1d2525cadd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 10:18:30
43425	9d6ce848-6645-44d8-900a-a6e7d2b24c25	9d6ce848-6d1b-491e-9db8-d37b55532bb6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"141.02","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":19,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-06 11:33:10
43426	9d6ce848-66ab-48bc-a8e6-86995b81ab42	9d6ce848-6d1b-491e-9db8-d37b55532bb6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":5,"hostname":"EderCortes"}	2024-11-06 11:33:10
43427	9d6ce848-6bb1-4216-859e-aa1c76afea26	9d6ce848-6d1b-491e-9db8-d37b55532bb6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:33:10
1417	9d50d0d9-2105-45f7-b72c-b64035a7ad15	9d50d0df-da28-4115-bd74-9e82b2aab4b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 12:24:28
1418	9d50d0df-d904-49a7-a0fc-f5f439a7bd1d	9d50d0df-da28-4115-bd74-9e82b2aab4b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 12:24:32
1419	9d50d0df-d95d-40a4-9eeb-836cf0a7306b	9d50d0df-da28-4115-bd74-9e82b2aab4b2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":"Empty Response","duration":4589,"memory":20,"hostname":"EderCortes"}	2024-10-23 12:24:32
1452	9d50d223-3423-4d54-b7e9-899bf8193f8f	9d50d223-5927-4856-83ab-942099221554	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 12:28:04
1453	9d50d223-5737-4bd0-8811-a72331588acb	9d50d223-5927-4856-83ab-942099221554	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:28:04
1454	9d50d223-57ec-4b28-8c25-d8eeea140e2d	9d50d223-5927-4856-83ab-942099221554	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":325,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:28:04
11669	9d5ccdcb-b1a4-492e-8ac3-67a607eb9bbf	9d5ccdcb-b5ee-41fc-8d49-8fec7b75c199	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":316,"memory":20,"hostname":"EderCortes"}	2024-10-29 11:25:52
11962	9d5cd8de-48a9-40de-ab21-f028ea04507b	9d5cd8de-5529-43cf-9679-5c9148f0af96	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 28\\n                        ","time":"177.05","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"618a8b500e46ad393f7c65ceec660399","hostname":"EderCortes"}	2024-10-29 11:56:49
10391	9d56cf09-f6bc-4847-b0de-4391f01b3999	9d56cf09-fa92-4e7e-85ec-d84b333f8939	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"44.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:54:22
2005	9d50e261-1581-45b3-9aa5-60e91f367fef	9d50e261-18d7-4be7-b583-a25ad1044d38	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":153,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:13:29
10392	9d56cf09-f988-4cd1-9b0b-013cb0af4c2d	9d56cf09-fa92-4e7e-85ec-d84b333f8939	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-26 11:54:22
10393	9d56cf09-f9c6-4b5a-921a-747f20068cb6	9d56cf09-fa92-4e7e-85ec-d84b333f8939	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":213,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:54:22
1420	9d50d0e0-6b77-469f-8924-934761a1f9ed	9d50d0e0-9769-44a1-a94e-e3a106ae3bba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 12:24:33
1421	9d50d0e0-9122-4469-b4f9-ba61c6a7e367	9d50d0e0-9769-44a1-a94e-e3a106ae3bba	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"56.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":50,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:24:33
1422	9d50d0e0-9189-454b-b2d8-65d88acb56f1	9d50d0e0-9769-44a1-a94e-e3a106ae3bba	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 12:24:33
1423	9d50d0e0-9612-4645-96e6-5924302dc1b8	9d50d0e0-9769-44a1-a94e-e3a106ae3bba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 12:24:33
1424	9d50d0e0-9674-4eb3-8156-8a24a3fb966a	9d50d0e0-9769-44a1-a94e-e3a106ae3bba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":421,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:24:33
1455	9d50d223-b332-40ec-8eb9-2a71a4ed0bb7	9d50d223-fc80-4d5a-8953-99a5a6166d2c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:28:04
1456	9d50d223-f4f6-428e-ba3e-cf53e75d5bce	9d50d223-fc80-4d5a-8953-99a5a6166d2c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"144.45","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":50,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:28:05
1457	9d50d223-f569-44ff-a2c7-7eaa793b3f34	9d50d223-fc80-4d5a-8953-99a5a6166d2c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 12:28:05
1458	9d50d223-faf7-43ba-8a82-55ea87e96e79	9d50d223-fc80-4d5a-8953-99a5a6166d2c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:28:05
1459	9d50d223-fb53-475f-a53a-41d97a559db7	9d50d223-fc80-4d5a-8953-99a5a6166d2c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":397,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:28:05
2564	9d50fad0-40e6-4d56-827e-0cd250efc752	9d50fad0-6af7-44de-ae27-cafd2a2b8aba	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 14:21:48
2006	9d50e261-9530-4d59-840a-58ddd127cf55	9d50e261-9828-4430-af5f-9f2779f22a23	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":149,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:13:29
2565	9d50fad0-68a3-4d85-8361-8c1ad50b5a98	9d50fad0-6af7-44de-ae27-cafd2a2b8aba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:21:49
2566	9d50fad0-69c2-4b6f-bb16-83d668412a68	9d50fad0-6af7-44de-ae27-cafd2a2b8aba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":361,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:21:49
13808	9d5d0ec9-2527-4a17-9c47-b064f7671290	9d5d0ec9-2614-4c69-9ffb-47b9f35215d9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/18","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:27:35
13809	9d5d0eef-c49e-4d53-ac97-1b6a08707da4	9d5d0eef-c81a-4d0e-b07b-10b52631c582	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":138,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:28:01
14481	9d5eb8b1-0d6b-4b1a-96eb-a58ab5226a4a	9d5eb8b1-0ec0-409e-a721-6d1d2525cadd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortes10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":263,"memory":24,"hostname":"EderCortes"}	2024-10-30 10:18:30
2567	9d50fad0-d281-4c2a-b088-19e67affb094	9d50fad0-f76c-48c7-9b29-c0457bf9cc39	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:21:49
988	9d4f3b9d-5840-4244-b490-812a6aec67f5	9d4f3b9d-b964-4377-b8bd-f3a3a5fdcd66	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-22 17:31:21
989	9d4f3b9d-b71d-4e8d-b5dd-9ebcae084efc	9d4f3b9d-b964-4377-b8bd-f3a3a5fdcd66	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-22 17:31:21
990	9d4f3b9d-b826-4e7d-824d-3edf45c58e8c	9d4f3b9d-b964-4377-b8bd-f3a3a5fdcd66	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42P01]: Undefined table: 7 ERROR:  falta una entrada para la tabla \\u00abuser\\u00bb en la cl\\u00e1usula FROM\\nLINE 1: select * from \\"users\\" where \\"user\\".\\"profile_code\\" = $1 and \\"...\\n                                    ^ (Connection: pgsql, SQL: select * from \\"users\\" where \\"user\\".\\"profile_code\\" = 5 and \\"users\\".\\"deleted_at\\" is null order by \\"menu\\".\\"created_at\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":495,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:31:21
2568	9d50fad0-f11f-4e4e-81a1-1ab9aff1558d	9d50fad0-f76c-48c7-9b29-c0457bf9cc39	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"51.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:21:49
2569	9d50fad0-f194-4f0f-a44c-d25f2ca01e85	9d50fad0-f76c-48c7-9b29-c0457bf9cc39	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:21:49
3459	9d5105e6-63b6-49cd-803d-5a794153b371	9d5105e6-65d9-4929-be3e-6f84fcbcbac1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":650,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:52:48
1425	9d50d0e2-2931-46ca-9b65-4c71f1c23321	9d50d0e2-72ec-4faa-89b0-b7314d1a34c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 12:24:34
2570	9d50fad0-f5c0-48fc-8b7b-d369bfbb99b0	9d50fad0-f76c-48c7-9b29-c0457bf9cc39	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:21:49
2571	9d50fad0-f630-452f-a403-53e8adfff036	9d50fad0-f76c-48c7-9b29-c0457bf9cc39	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":329,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:21:49
14669	9d5ec063-f6d5-45ea-a11f-86be83728f8b	9d5ec064-003a-44a6-80b8-6056486a35aa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 54\\n                        ","time":"42.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"ab6e1bb800c68cf11d4fa07c2fd4bfc1","hostname":"EderCortes"}	2024-10-30 10:40:02
1426	9d50d0e2-6d7a-45ba-b671-83e707d1946f	9d50d0e2-72ec-4faa-89b0-b7314d1a34c4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"151.72","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 12:24:34
1427	9d50d0e2-6dd5-4a75-a3df-22e8dc881bff	9d50d0e2-72ec-4faa-89b0-b7314d1a34c4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 12:24:34
1428	9d50d0e2-71ba-4b8e-a126-719b49f2ce84	9d50d0e2-72ec-4faa-89b0-b7314d1a34c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 12:24:34
1429	9d50d0e2-71ff-48d9-9795-2fe7183e8352	9d50d0e2-72ec-4faa-89b0-b7314d1a34c4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:24:34
1460	9d50d224-552a-4977-8845-0adee1f33cbd	9d50d224-7396-4b69-acc7-e623a3f7613f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:28:05
1461	9d50d224-6f10-4147-96f5-d148d52ec5ee	9d50d224-7396-4b69-acc7-e623a3f7613f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":50,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:28:05
1462	9d50d224-6f59-4ad6-b55e-2563e5f88373	9d50d224-7396-4b69-acc7-e623a3f7613f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 12:28:05
1463	9d50d224-727d-4e94-8288-1918247ec12f	9d50d224-7396-4b69-acc7-e623a3f7613f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:28:05
1464	9d50d224-72bd-44d8-90f5-2d4e132437a9	9d50d224-7396-4b69-acc7-e623a3f7613f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":289,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:28:05
2572	9d50fad1-4cd6-469f-b690-af0370a5454e	9d50fad1-741a-40d8-8943-b6a42c3008db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:21:49
2007	9d50e261-e848-4735-ba16-0e930c80e96f	9d50e261-eb14-495f-b075-1f4d936f5e5e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":135,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:13:30
2573	9d50fad1-6df8-42d0-a4fb-a0f548c55f53	9d50fad1-741a-40d8-8943-b6a42c3008db	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"56.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:21:49
2574	9d50fad1-6e48-4a6a-998c-ff195f04808b	9d50fad1-741a-40d8-8943-b6a42c3008db	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:21:49
2575	9d50fad1-728e-4159-a585-8fa3a9405421	9d50fad1-741a-40d8-8943-b6a42c3008db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:21:49
3460	9d5105e7-25d7-4c43-80c7-1a027489957d	9d5105e7-667f-4625-9152-b9fefb79bf06	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 14:52:49
3461	9d5105e7-5a1b-4c2c-9736-9fb1d7cb3ce9	9d5105e7-667f-4625-9152-b9fefb79bf06	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"82.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:52:49
3462	9d5105e7-5ae5-4306-8224-aa4b9045deeb	9d5105e7-667f-4625-9152-b9fefb79bf06	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:52:49
1430	9d50d142-0027-4b25-a6c4-0779d410fff1	9d50d142-040c-48c4-b604-f59ea6aed4a3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":172,"memory":20,"hostname":"EderCortes"}	2024-10-23 12:25:37
1465	9d50d226-1db0-4fba-86d4-c7a4f4aa50e7	9d50d226-399d-413f-a047-9106fede4a0b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:28:06
1466	9d50d226-3505-4837-95ae-d86ac60ca240	9d50d226-399d-413f-a047-9106fede4a0b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 12:28:06
1467	9d50d226-3548-43d4-8cdb-ab4e526ddffe	9d50d226-399d-413f-a047-9106fede4a0b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 12:28:06
1468	9d50d226-3853-4359-8035-64a9667af1dd	9d50d226-399d-413f-a047-9106fede4a0b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 12:28:06
1469	9d50d226-3894-4f9e-86e4-ff4957167369	9d50d226-399d-413f-a047-9106fede4a0b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:28:06
2576	9d50fad1-730b-4b20-8c7b-011c0b9f2c95	9d50fad1-741a-40d8-8943-b6a42c3008db	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":296,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:21:49
3463	9d5105e7-6458-4368-af48-79b3e741347f	9d5105e7-667f-4625-9152-b9fefb79bf06	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 14:52:49
2008	9d50e262-4190-43aa-a809-5eb729418665	9d50e262-864f-4a18-aa6c-3f5abcae754d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 13:13:30
2009	9d50e262-8282-41f2-9ba0-222373f98182	9d50e262-864f-4a18-aa6c-3f5abcae754d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder co%' or \\"users\\".\\"user_document\\"::text like '%eder co%' order by \\"users\\".\\"user_document\\" asc","time":"149.04","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:13:30
2010	9d50e262-853a-467f-af4b-d28410fc1571	9d50e262-864f-4a18-aa6c-3f5abcae754d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 13:13:30
2011	9d50e262-857c-461b-a64c-78c4272189d5	9d50e262-864f-4a18-aa6c-3f5abcae754d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"29","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder co"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":337,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:13:30
10394	9d56cf0b-5cc1-4118-8cd9-dd7ce0a64d71	9d56cf0b-791e-47f3-88ad-7cbfa6ecb13e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-26 11:54:23
1431	9d50d142-9894-4656-8234-3baad4ad7c65	9d50d142-a7e1-46bc-9419-8924493cee95	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 12:25:37
1432	9d50d142-a593-4edb-948a-c95c38000517	9d50d142-a7e1-46bc-9419-8924493cee95	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:25:37
1433	9d50d142-a61e-486a-9aaf-821c0bbe454d	9d50d142-a7e1-46bc-9419-8924493cee95	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"prue"},"session":[],"response_status":200,"response":"Empty Response","duration":240,"memory":20,"hostname":"EderCortes"}	2024-10-23 12:25:37
11675	9d5cce15-b998-43a1-aac1-31c04a05249c	9d5cce15-bcb4-4f3c-b5ea-0f7c3b9f4458	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":209,"memory":20,"hostname":"EderCortes"}	2024-10-29 11:26:40
1296	9d50cad7-fe6b-4b7b-aaaa-1b8f80ceea9e	9d50cad8-427f-4585-a99a-0147e249cd75	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:07:40
1297	9d50cad8-40f6-4ea2-a191-0ccdac3750d6	9d50cad8-427f-4585-a99a-0147e249cd75	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 12:07:41
1298	9d50cad8-418d-4cb9-a1f9-5172fc67dcc5	9d50cad8-427f-4585-a99a-0147e249cd75	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":325,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:07:41
14482	9d5eb8b7-451a-4e4b-b5bc-7160cf76204e	9d5eb8b7-4879-44a5-bd70-428690510959	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":170,"memory":20,"hostname":"EderCortes"}	2024-10-30 10:18:35
14670	9d5ec063-fab0-48d2-98be-9437e5fad61e	9d5ec064-003a-44a6-80b8-6056486a35aa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '54' order by \\"item_loans\\".\\"id\\" asc","time":"2.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-30 10:40:02
11963	9d5cd8de-4d22-495e-b83b-693b045799a2	9d5cd8de-5529-43cf-9679-5c9148f0af96	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '28' order by \\"item_loans\\".\\"id\\" asc","time":"2.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 11:56:49
11964	9d5cd8de-4d8b-479f-bed7-b5928c652246	9d5cd8de-5529-43cf-9679-5c9148f0af96	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 11:56:49
11965	9d5cd8de-530b-4dfc-b982-216d090b6c5c	9d5cd8de-5529-43cf-9679-5c9148f0af96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 11:56:50
14671	9d5ec063-fae2-4629-a62c-54ff0ad9856c	9d5ec064-003a-44a6-80b8-6056486a35aa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":7,"hostname":"EderCortes"}	2024-10-30 10:40:02
14672	9d5ec063-fece-49d2-956b-ee707b42cb33	9d5ec064-003a-44a6-80b8-6056486a35aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 10:40:02
14673	9d5ec063-ff28-463d-bf29-a24c20438502	9d5ec064-003a-44a6-80b8-6056486a35aa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/54","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":54,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":7,"loans_valor_prestado":600000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"12-11-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":143,"loans_codigo":54,"itemloans_cuota":"1","itemloans_valor_cuota":"85714.285714286","itemloans_iteres":"15000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:08.000000Z","updated_at":"2024-10-29T19:49:08.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":144,"loans_codigo":54,"itemloans_cuota":"2","itemloans_valor_cuota":"85714.285714286","itemloans_iteres":"15000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:08.000000Z","updated_at":"2024-10-29T19:49:08.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":145,"loans_codigo":54,"itemloans_cuota":"3","itemloans_valor_cuota":"85714.285714286","itemloans_iteres":"15000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:08.000000Z","updated_at":"2024-10-29T19:49:08.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":146,"loans_codigo":54,"itemloans_cuota":"4","itemloans_valor_cuota":"85714.285714286","itemloans_iteres":"15000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:08.000000Z","updated_at":"2024-10-29T19:49:08.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":147,"loans_codigo":54,"itemloans_cuota":"5","itemloans_valor_cuota":"85714.285714286","itemloans_iteres":"15000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:08.000000Z","updated_at":"2024-10-29T19:49:08.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":148,"loans_codigo":54,"itemloans_cuota":"6","itemloans_valor_cuota":"85714.285714286","itemloans_iteres":"15000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:08.000000Z","updated_at":"2024-10-29T19:49:08.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":149,"loans_codigo":54,"itemloans_cuota":"7","itemloans_valor_cuota":"85714.285714286","itemloans_iteres":"15000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-25 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:08.000000Z","updated_at":"2024-10-29T19:49:08.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":418,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:40:02
16817	9d64d6ee-819d-4b64-bd98-beb19596aacf	9d64d6ee-8505-4d1f-8e36-65e0b4072daa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":148,"memory":20,"hostname":"EderCortes"}	2024-11-02 11:18:02
1299	9d50cad8-83b1-492d-83df-3dc5221dada7	9d50cad8-caad-4f6d-affd-9a64784428c7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 12:07:41
1300	9d50cad8-c55b-4422-80d2-72ac2e880651	9d50cad8-caad-4f6d-affd-9a64784428c7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"147.39","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:07:41
1301	9d50cad8-c5d5-40bd-a280-0ee0e42eabb9	9d50cad8-caad-4f6d-affd-9a64784428c7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 12:07:41
1302	9d50cad8-c96e-4e6b-876f-8a053c3596f6	9d50cad8-caad-4f6d-affd-9a64784428c7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 12:07:41
1303	9d50cad8-c9bc-42f9-8594-5ee666984604	9d50cad8-caad-4f6d-affd-9a64784428c7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":329,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:07:41
11676	9d5cce16-71fb-4a69-89c0-50089990e137	9d5cce16-9995-4e9e-93bf-547657bb2767	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 11:26:41
11677	9d5cce16-8ddb-481d-8573-10a28bd61b87	9d5cce16-9995-4e9e-93bf-547657bb2767	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta', 'De las nieve', 'ds', 'CC', '100465546', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '500000', 25, 6, 'S', null, 'Tue Oct 29 2024', 'Pendiente', '312596295', 12, 14, 18, 14, '2024-11-05T05:00:00.000Z', '2024-10-29 11:26:41', '2024-10-29 11:26:41') returning \\"id\\"","time":"4.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":99,"hash":"bfad4cea82a73099ff0b3164dd496ca0","hostname":"EderCortes"}	2024-10-29 11:26:41
11678	9d5cce16-8e52-4148-baed-5770e474be3f	9d5cce16-9995-4e9e-93bf-547657bb2767	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:22","hostname":"EderCortes"}	2024-10-29 11:26:41
11679	9d5cce16-8faa-4176-8c3a-e1fedbd5b338	9d5cce16-9995-4e9e-93bf-547657bb2767	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (22, 1, 83333.333333333, 10416.666666667, 0, 'N\\/A', '27-01-2025', 12, '2024-10-29 11:26:41', '2024-10-29 11:26:41')","time":"2.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:26:41
11680	9d5cce16-8fd5-472f-a740-af2431fe34c5	9d5cce16-9995-4e9e-93bf-547657bb2767	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:26:41
11681	9d5cce16-9081-4a14-84a8-d18cc8690a31	9d5cce16-9995-4e9e-93bf-547657bb2767	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (22, 2, 83333.333333333, 10416.666666667, 0, 'N\\/A', '27-04-2025', 12, '2024-10-29 11:26:41', '2024-10-29 11:26:41')","time":"0.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:26:41
11682	9d5cce16-90b0-4553-96c3-08669a1ed4ef	9d5cce16-9995-4e9e-93bf-547657bb2767	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:26:41
11683	9d5cce16-914a-45b8-b036-a87925dabf04	9d5cce16-9995-4e9e-93bf-547657bb2767	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (22, 3, 83333.333333333, 10416.666666667, 0, 'N\\/A', '26-07-2025', 12, '2024-10-29 11:26:41', '2024-10-29 11:26:41')","time":"0.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:26:41
11684	9d5cce16-9176-4e7b-8bfd-0a14bf82ef99	9d5cce16-9995-4e9e-93bf-547657bb2767	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:26:41
11685	9d5cce16-91f2-4ca2-9f73-198aef7f25bd	9d5cce16-9995-4e9e-93bf-547657bb2767	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (22, 4, 83333.333333333, 10416.666666667, 0, 'N\\/A', '24-10-2025', 12, '2024-10-29 11:26:41', '2024-10-29 11:26:41')","time":"0.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:26:41
11686	9d5cce16-9214-4521-919c-1c4667078db4	9d5cce16-9995-4e9e-93bf-547657bb2767	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:26:41
11687	9d5cce16-927e-4953-97fc-fe080f0781c6	9d5cce16-9995-4e9e-93bf-547657bb2767	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (22, 5, 83333.333333333, 10416.666666667, 0, 'N\\/A', '22-01-2026', 12, '2024-10-29 11:26:41', '2024-10-29 11:26:41')","time":"0.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:26:41
11688	9d5cce16-929f-4d81-8089-2740f8727fc9	9d5cce16-9995-4e9e-93bf-547657bb2767	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:26:41
1304	9d50cad9-0cc9-4971-94d0-853fcba204d7	9d50cad9-29b5-484d-86db-d9626b3a4bb3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 12:07:41
1305	9d50cad9-2502-4659-8204-0141811bee83	9d50cad9-29b5-484d-86db-d9626b3a4bb3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:07:41
1306	9d50cad9-2550-4145-bc6d-6b190b62686a	9d50cad9-29b5-484d-86db-d9626b3a4bb3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 12:07:41
1307	9d50cad9-2894-47d1-aed7-dc26ddb1094c	9d50cad9-29b5-484d-86db-d9626b3a4bb3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 12:07:41
1308	9d50cad9-28d7-48b9-90f8-67f8949c3e31	9d50cad9-29b5-484d-86db-d9626b3a4bb3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":223,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:07:41
11689	9d5cce16-9311-4c48-97bb-30217704147a	9d5cce16-9995-4e9e-93bf-547657bb2767	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (22, 6, 83333.333333333, 10416.666666667, 0, 'N\\/A', '22-04-2026', 12, '2024-10-29 11:26:41', '2024-10-29 11:26:41')","time":"0.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:26:41
11690	9d5cce16-9333-441f-9252-ba8aee6a6b61	9d5cce16-9995-4e9e-93bf-547657bb2767	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:26:41
2012	9d50e262-c2ed-4470-844b-e1d3e2fdcb31	9d50e262-c5d0-4e27-9244-71c524f54af7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":139,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:13:30
2735	9d50fbbe-3340-4574-b797-7d253022daf4	9d50fbbe-8396-4629-a034-6541ca62a607	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 14:24:24
2736	9d50fbbe-815d-4b15-a41c-9a9f1bde0cc1	9d50fbbe-8396-4629-a034-6541ca62a607	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:24:25
2737	9d50fbbe-8265-4494-aa02-f372b2789052	9d50fbbe-8396-4629-a034-6541ca62a607	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":381,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:24:25
11691	9d5cce16-97ec-446d-84b6-7498007b45bb	9d5cce16-9995-4e9e-93bf-547657bb2767	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 11:26:41
11692	9d5cce16-9845-47e4-a580-b7fa41a01c9e	9d5cce16-9995-4e9e-93bf-547657bb2767	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"766","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"100465546","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"500000","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":18,"user_recomendacion":14,"loans_inicio_pago":"2024-11-05T05:00:00.000Z","created_at":null,"updated_at":null,"deleted_at":null},"detail":{"status":false,"observacion":"N\\/A","fecha_pago":"Tue Oct 29 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":22},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:26:41
13814	9d5d0f6f-02bc-488a-b3f6-f30f44d8168d	9d5d0f6f-05e1-4bf2-a41e-9c3592fb8c0c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":153,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:29:24
14483	9d5eb8b7-f5f4-4f13-9afe-037c03ea1355	9d5eb8b8-1537-4df6-b44e-a23dc91eb8e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 10:18:35
1309	9d50cada-e931-453b-9b6c-e0cb8407b05f	9d50cadb-05a4-4f03-af51-3dd1b702b27a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 12:07:42
1310	9d50cadb-0026-445f-8f7b-c457b7d72a64	9d50cadb-05a4-4f03-af51-3dd1b702b27a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"38.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 12:07:42
1311	9d50cadb-0076-4d77-b212-4da9b7a99a8d	9d50cadb-05a4-4f03-af51-3dd1b702b27a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 12:07:42
1312	9d50cadb-0453-4ffb-92c8-fbb94096cd2c	9d50cadb-05a4-4f03-af51-3dd1b702b27a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 12:07:42
1313	9d50cadb-049f-4abc-a726-d4846df2f435	9d50cadb-05a4-4f03-af51-3dd1b702b27a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:07:42
2738	9d50fbbe-db11-4895-b846-7fa505d4a2e9	9d50fbbe-fe59-430e-82e3-05a177f0d915	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:24:25
2236	9d50e50e-ab66-4169-93b0-dae2b6841372	9d50e50e-ac42-4427-b0ec-b8b55618fc1e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"28","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"100460"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:20:58
2013	9d50e263-1708-4dcd-a96d-c54d3c79ea05	9d50e263-60f9-47dc-b3ef-db43a3764ffd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 13:13:30
2014	9d50e263-5b63-4b7a-9743-a73afb446128	9d50e263-60f9-47dc-b3ef-db43a3764ffd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder c%' or \\"users\\".\\"user_document\\"::text like '%eder c%' order by \\"users\\".\\"user_document\\" asc","time":"158.75","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:13:31
2015	9d50e263-5f5c-4c1b-a23e-0b2b1d429a00	9d50e263-60f9-47dc-b3ef-db43a3764ffd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 13:13:31
2016	9d50e263-5fa1-48a4-8abd-728fbb5d6f41	9d50e263-60f9-47dc-b3ef-db43a3764ffd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"28","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder c"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:13:31
2739	9d50fbbe-f7b7-47c3-b34e-171b5cd9bdd8	9d50fbbe-fe59-430e-82e3-05a177f0d915	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:24:25
2740	9d50fbbe-f803-444a-b334-ff8571b84866	9d50fbbe-fe59-430e-82e3-05a177f0d915	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:24:25
2741	9d50fbbe-fd01-4bea-9121-8bd05d17a8c4	9d50fbbe-fe59-430e-82e3-05a177f0d915	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:24:25
10395	9d56cf0b-743a-4e64-a6f3-82bbd8249133	9d56cf0b-791e-47f3-88ad-7cbfa6ecb13e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:54:23
10396	9d56cf0b-7483-45b5-a636-c5f238c00bde	9d56cf0b-791e-47f3-88ad-7cbfa6ecb13e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:54:23
2742	9d50fbbe-fd6d-4173-9819-bf136aafa90f	9d50fbbe-fe59-430e-82e3-05a177f0d915	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":291,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:24:25
11693	9d5cce24-b582-4a99-8288-cf9f9a96bcef	9d5cce24-d3df-49e2-b792-c852509f652a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 11:26:50
11694	9d5cce24-ce7d-4e26-b85a-bbfa727972a1	9d5cce24-d3df-49e2-b792-c852509f652a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 11:26:50
10397	9d56cf0b-77f5-4175-95a0-e4e3a7d3fbf2	9d56cf0b-791e-47f3-88ad-7cbfa6ecb13e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-26 11:54:23
2017	9d50e263-aa18-4fdf-81cb-c326eee9b0bd	9d50e263-f1e5-4789-ad78-761c8ab230e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 13:13:31
2018	9d50e263-ecbf-480c-a6d8-4fd836c4cef4	9d50e263-f1e5-4789-ad78-761c8ab230e3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder%' or \\"users\\".\\"user_document\\"::text like '%eder%' order by \\"users\\".\\"user_document\\" asc","time":"154.19","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:13:31
2019	9d50e263-f06f-4cde-8513-faaa42b16506	9d50e263-f1e5-4789-ad78-761c8ab230e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 13:13:31
2020	9d50e263-f0ba-4cc6-ade4-b43bd854787a	9d50e263-f1e5-4789-ad78-761c8ab230e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":350,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:13:31
10398	9d56cf0b-783b-4347-ac34-54aabc9a0272	9d56cf0b-791e-47f3-88ad-7cbfa6ecb13e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":221,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:54:23
11695	9d5cce24-cecb-4da3-b041-3d8b2694fc92	9d5cce24-d3df-49e2-b792-c852509f652a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 11:26:50
11696	9d5cce24-d28a-42cc-ac0e-7659befd4365	9d5cce24-d3df-49e2-b792-c852509f652a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 11:26:50
11697	9d5cce24-d2d2-4074-af80-000db70ecf30	9d5cce24-d3df-49e2-b792-c852509f652a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:26:50
14674	9d5ec0ee-6f73-4344-851a-f9c2d87d96ea	9d5ec0ee-923f-4a1f-8b7b-87e3b40edaa0	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-30 10:41:33
2743	9d50fbbf-4366-413e-bebc-ac2269693bc9	9d50fbbf-8c70-46c5-99e4-a6c5f0f94a8a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:24:25
2744	9d50fbbf-8729-43ac-9158-ff7df60ae4c0	9d50fbbf-8c70-46c5-99e4-a6c5f0f94a8a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"150.03","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:24:25
1860	9d50e00f-1d51-4c10-af4a-75fd0eb5b228	9d50e00f-4a98-471d-9c3a-ce561d04a44e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 13:07:00
1861	9d50e00f-4820-44e9-8838-46bab5b18b7d	9d50e00f-4a98-471d-9c3a-ce561d04a44e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 13:07:00
1862	9d50e00f-4949-44b0-be17-a3f8f3c55eb5	9d50e00f-4a98-471d-9c3a-ce561d04a44e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":352,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:07:00
2745	9d50fbbf-8772-49f4-aeb2-5eb11e241cf1	9d50fbbf-8c70-46c5-99e4-a6c5f0f94a8a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:24:25
2746	9d50fbbf-8b15-4c09-8218-16f8de7b81d3	9d50fbbf-8c70-46c5-99e4-a6c5f0f94a8a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:24:25
2747	9d50fbbf-8b5a-4aaf-8597-2aea3c43a5b5	9d50fbbf-8c70-46c5-99e4-a6c5f0f94a8a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:24:25
11698	9d5cce27-6acd-4fb9-8a75-37109f93a0f9	9d5cce27-83f1-44e9-af08-5c93c03db2dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 11:26:52
11699	9d5cce27-7fcf-43b1-ae04-03eb6ed47b7a	9d5cce27-83f1-44e9-af08-5c93c03db2dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"41.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-29 11:26:52
8768	9d52eec7-8ac1-41e6-bb54-2b3b8c5001cb	9d52eec7-8bb3-4b2f-935d-97715d594a6d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":217,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:39:49
11700	9d5cce27-82bf-4d65-a36d-501325e2188c	9d5cce27-83f1-44e9-af08-5c93c03db2dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 11:26:52
11701	9d5cce27-830f-4010-9b7d-3ee1f2d53c5c	9d5cce27-83f1-44e9-af08-5c93c03db2dd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":222,"memory":20,"hostname":"EderCortes"}	2024-10-29 11:26:52
14484	9d5eb8b8-10b3-40aa-9fd3-b4d6e19271b1	9d5eb8b8-1537-4df6-b44e-a23dc91eb8e5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortes10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"40.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-30 10:18:35
14485	9d5eb8b8-13cb-4398-a74f-be7ba362f483	9d5eb8b8-1537-4df6-b44e-a23dc91eb8e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 10:18:35
2237	9d50e50e-ee0a-4142-9382-c5183af55bfe	9d50e50e-f0db-4af7-8b30-22396889c0fa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":145,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:20:59
992	9d4f3bde-4479-49d9-a1ea-5392967fc1e7	9d4f3bde-9c95-4783-83d6-1e80ca5574d1	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-22 17:32:04
993	9d4f3bde-9a62-469c-b41c-1e238f5ff8c4	9d4f3bde-9c95-4783-83d6-1e80ca5574d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-22 17:32:04
994	9d4f3bde-9b59-4fb7-bf43-4fad529e600e	9d4f3bde-9c95-4783-83d6-1e80ca5574d1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":436,"memory":22,"hostname":"EderCortes"}	2024-10-22 17:32:04
14486	9d5eb8b8-1420-473e-bf0b-95925018cc3b	9d5eb8b8-1537-4df6-b44e-a23dc91eb8e5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortes10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":211,"memory":24,"hostname":"EderCortes"}	2024-10-30 10:18:35
11702	9d5cce45-341a-41ee-ab70-fe31ed3ab0fc	9d5cce45-37d1-4685-a718-d34dae797102	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":169,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:27:11
2387	9d50e782-6517-4177-89cf-0ad2f4e56de3	9d50e782-aa93-4418-9580-457fea4f18fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 13:27:50
2388	9d50e782-a553-4a45-8fc3-32a2e244496a	9d50e782-aa93-4418-9580-457fea4f18fb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"144.08","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:27:50
1863	9d50e00f-ce93-410b-be85-107c1e33b564	9d50e010-2357-4ef4-887a-246db788a895	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 13:07:00
2389	9d50e782-a5a9-4507-bd3f-60d501272ab6	9d50e782-aa93-4418-9580-457fea4f18fb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 13:27:50
2390	9d50e782-a97a-4758-860e-3d00a3872b89	9d50e782-aa93-4418-9580-457fea4f18fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 13:27:50
2391	9d50e782-a9ba-47c0-9374-40c54e91fc08	9d50e782-aa93-4418-9580-457fea4f18fb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":368,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:27:50
20232	9d66f057-91bc-45bf-8cff-5f49605030ef	9d66f057-9636-4bd8-9926-e97e0fe35c95	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"54.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 12:20:44
11966	9d5cd8de-53ca-40e2-aed0-69b628d1b14d	9d5cd8de-5529-43cf-9679-5c9148f0af96	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/28","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":28,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":600081,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":94,"loans_codigo":28,"itemloans_cuota":"1","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":95,"loans_codigo":28,"itemloans_cuota":"2","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":96,"loans_codigo":28,"itemloans_cuota":"3","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":97,"loans_codigo":28,"itemloans_cuota":"4","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":98,"loans_codigo":28,"itemloans_cuota":"5","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":99,"loans_codigo":28,"itemloans_cuota":"6","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null}]}},"duration":567,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:56:50
1864	9d50e010-1abe-4a5e-a6b7-cb69c6e62139	9d50e010-2357-4ef4-887a-246db788a895	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"157.86","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:07:00
1865	9d50e010-1b33-4a81-9440-ba25a7155960	9d50e010-2357-4ef4-887a-246db788a895	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 13:07:00
1866	9d50e010-21af-4488-9cc5-1fee95aff20c	9d50e010-2357-4ef4-887a-246db788a895	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 13:07:00
1867	9d50e010-2215-4636-a0b7-4f1fc429fdd8	9d50e010-2357-4ef4-887a-246db788a895	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":528,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:07:00
13819	9d5d100f-0961-4820-bf6f-93469ed97cd6	9d5d100f-0f18-484d-b582-13e8a5b7cebf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":223,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:31:09
11703	9d5cce45-ea3f-47ed-a46e-10b6168357c8	9d5cce46-0e74-46e4-9274-9444e70e7819	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 11:27:12
1932	9d50e0f8-4578-4fa2-8152-e2e64ccadb10	9d50e0f8-9674-4241-bd4a-fd023a5ba192	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 13:09:33
1933	9d50e0f8-945a-439f-996e-c8218c234035	9d50e0f8-9674-4241-bd4a-fd023a5ba192	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 13:09:33
1934	9d50e0f8-9539-428b-96df-427f8108ebaa	9d50e0f8-9674-4241-bd4a-fd023a5ba192	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":483,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:09:33
11967	9d5cd8df-0292-4283-a92a-db0c34926b65	9d5cd8df-6c5a-474e-a54f-268ea0a34d3a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 11:56:50
11704	9d5cce46-025c-499c-89c9-388f6c8fcb0a	9d5cce46-0e74-46e4-9274-9444e70e7819	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta', 'De las nieve', 'ds', 'CC', '100465546', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '600000', 25, 6, 'S', null, 'Tue Oct 29 2024', 'Pendiente', '312596295', 12, 14, 18, 14, '2024-11-05T05:00:00.000Z', '2024-10-29 11:27:12', '2024-10-29 11:27:12') returning \\"id\\"","time":"4.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":99,"hash":"bfad4cea82a73099ff0b3164dd496ca0","hostname":"EderCortes"}	2024-10-29 11:27:12
11705	9d5cce46-02b0-4f8c-8bcf-ed4cf605ec94	9d5cce46-0e74-46e4-9274-9444e70e7819	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:23","hostname":"EderCortes"}	2024-10-29 11:27:12
11706	9d5cce46-06b2-4a00-94cc-38881545aed9	9d5cce46-0e74-46e4-9274-9444e70e7819	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (23, 1, 100000, 12500, 0, 'N\\/A', '27-01-2025', 12, '2024-10-29 11:27:12', '2024-10-29 11:27:12')","time":"9.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:27:12
11707	9d5cce46-06da-4aa9-8c89-c8f7287633a6	9d5cce46-0e74-46e4-9274-9444e70e7819	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:27:12
11708	9d5cce46-0749-4d72-a087-eea9455f3e8c	9d5cce46-0e74-46e4-9274-9444e70e7819	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (23, 2, 100000, 12500, 0, 'N\\/A', '27-04-2025', 12, '2024-10-29 11:27:12', '2024-10-29 11:27:12')","time":"0.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:27:12
11709	9d5cce46-076b-408d-9dfc-87f75c6add0a	9d5cce46-0e74-46e4-9274-9444e70e7819	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:27:12
11968	9d5cd8df-60ac-4b0e-849c-0d9cd504820e	9d5cd8df-6c5a-474e-a54f-268ea0a34d3a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"113.93","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 11:56:50
11969	9d5cd8df-613b-4ef2-b6b7-6855e5cbe9c4	9d5cd8df-6c5a-474e-a54f-268ea0a34d3a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 11:56:50
11970	9d5cd8df-6a10-4ecb-af42-f5d94edf8668	9d5cd8df-6c5a-474e-a54f-268ea0a34d3a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 11:56:50
20233	9d66f057-94f0-4c7c-ac31-e8eadd98b868	9d66f057-9636-4bd8-9926-e97e0fe35c95	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:20:44
1868	9d50e010-99ea-479b-83f8-c368121838b4	9d50e010-ebdc-4ef7-ba2b-2fea97b3d1d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 13:07:01
1869	9d50e010-e4d3-4dcf-971c-e387a8d4eddd	9d50e010-ebdc-4ef7-ba2b-2fea97b3d1d1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"152.96","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:07:01
1870	9d50e010-e528-4aed-b051-cabfd25330e3	9d50e010-ebdc-4ef7-ba2b-2fea97b3d1d1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 13:07:01
1871	9d50e010-ea28-4818-af21-b48d6cbe7c24	9d50e010-ebdc-4ef7-ba2b-2fea97b3d1d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 13:07:01
1872	9d50e010-ea93-46e0-9397-7c00008cb36f	9d50e010-ebdc-4ef7-ba2b-2fea97b3d1d1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":481,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:07:01
1935	9d50e0f8-fef3-4f08-ab5c-d810128c6e67	9d50e0f9-240a-4ba0-b3e7-1a3a3dec973f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 13:09:33
1936	9d50e0f9-1ccc-41da-a6a4-fbef09127ada	9d50e0f9-240a-4ba0-b3e7-1a3a3dec973f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:09:33
1937	9d50e0f9-1d39-4968-bf87-5b9acc1610b5	9d50e0f9-240a-4ba0-b3e7-1a3a3dec973f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 13:09:33
1938	9d50e0f9-22b1-478d-8b33-30b2d2368023	9d50e0f9-240a-4ba0-b3e7-1a3a3dec973f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 13:09:33
1939	9d50e0f9-22ff-4070-9d38-533cc0091ac7	9d50e0f9-240a-4ba0-b3e7-1a3a3dec973f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:09:33
2021	9d50e264-3e64-40e5-89b7-1f8525660678	9d50e264-836a-4696-a1d0-e810b6b71d26	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 13:13:31
2022	9d50e264-7f08-4cf7-91d8-e7d9bd78f385	9d50e264-836a-4696-a1d0-e810b6b71d26	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder%' or \\"users\\".\\"user_document\\"::text like '%eder%' order by \\"users\\".\\"user_document\\" asc","time":"147.87","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:13:31
2023	9d50e264-8218-4587-ac66-f79a6b85a8b4	9d50e264-836a-4696-a1d0-e810b6b71d26	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 13:13:31
2238	9d50e50f-46ba-4280-af9c-656777c24be5	9d50e50f-8ab5-4609-abc1-b98168e5a10f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-23 13:20:59
2239	9d50e50f-849a-4d5a-acf6-8b5e099f938b	9d50e50f-8ab5-4609-abc1-b98168e5a10f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%1004608%' or \\"users\\".\\"user_document\\"::text like '%1004608%' order by \\"users\\".\\"user_document\\" asc","time":"140.78","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:20:59
2240	9d50e50f-88e8-4695-9604-da00c1952072	9d50e50f-8ab5-4609-abc1-b98168e5a10f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-23 13:20:59
2241	9d50e50f-8959-4877-9c38-34946bd59e21	9d50e50f-8ab5-4609-abc1-b98168e5a10f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"29","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"1004608"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:20:59
1873	9d50e013-0bc1-4ac3-8db4-a40dcc91f360	9d50e013-46cd-45c9-bcd7-3685e17b5973	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 13:07:02
1874	9d50e013-3cdc-4120-88ed-8e221f9be2a1	9d50e013-46cd-45c9-bcd7-3685e17b5973	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"91.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 13:07:03
1875	9d50e013-3da8-4c94-99bd-3f5306ee1d3f	9d50e013-46cd-45c9-bcd7-3685e17b5973	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 13:07:03
1876	9d50e013-4477-497d-8169-8e69ae5ce2c5	9d50e013-46cd-45c9-bcd7-3685e17b5973	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 13:07:03
1877	9d50e013-44fe-46a3-b33a-3da8310098d9	9d50e013-46cd-45c9-bcd7-3685e17b5973	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":490,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:07:03
1940	9d50e0f9-7dc3-4fe5-8b08-34c00733cf71	9d50e0f9-c8ac-48c2-8b48-c223fec7cc10	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 13:09:33
1941	9d50e0f9-c21e-44b3-911d-22362883948b	9d50e0f9-c8ac-48c2-8b48-c223fec7cc10	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"145.74","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:09:34
1942	9d50e0f9-c289-404d-89bb-46d015a5eaea	9d50e0f9-c8ac-48c2-8b48-c223fec7cc10	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 13:09:34
1943	9d50e0f9-c735-45ce-a835-62ba61e4f377	9d50e0f9-c8ac-48c2-8b48-c223fec7cc10	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 13:09:34
1944	9d50e0f9-c795-4b9a-be49-3fdcf164c397	9d50e0f9-c8ac-48c2-8b48-c223fec7cc10	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":401,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:09:34
2392	9d50e782-ee9c-42d6-b596-231f987d990f	9d50e783-0cd1-4262-9887-55bb0aa46158	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 13:27:50
2242	9d50e50f-d2d6-4caa-bae7-c5f332702acd	9d50e50f-ec83-476a-bf51-4c2f9fb93525	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-23 13:20:59
2243	9d50e50f-e865-4245-99d3-02ee7aa731ab	9d50e50f-ec83-476a-bf51-4c2f9fb93525	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%10046083%' or \\"users\\".\\"user_document\\"::text like '%10046083%' order by \\"users\\".\\"user_document\\" asc","time":"39.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:20:59
2244	9d50e50f-eb4c-4baf-97f1-279e5c86a46a	9d50e50f-ec83-476a-bf51-4c2f9fb93525	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-23 13:20:59
2245	9d50e50f-eb94-4f71-995a-bf5605475ede	9d50e50f-ec83-476a-bf51-4c2f9fb93525	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"30","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"10046083"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:20:59
8769	9d52eec7-ccec-490b-ace1-26bd465bcdc9	9d52eec8-1419-472c-acc8-92e6fb8e369b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 13:39:49
8770	9d52eec8-0f8d-4cee-b1ee-f87b84f8ff74	9d52eec8-1419-472c-acc8-92e6fb8e369b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"151.05","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:39:49
2393	9d50e783-0817-4a2e-9c44-e441f832c8aa	9d50e783-0cd1-4262-9887-55bb0aa46158	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:27:50
2246	9d50e510-2970-4dc5-97fb-e4d049bd1f29	9d50e510-4520-4122-86b6-13d1a0f14efe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-23 13:20:59
2247	9d50e510-40ba-4fa1-bc01-b38bdcaed22c	9d50e510-4520-4122-86b6-13d1a0f14efe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%100460833%' or \\"users\\".\\"user_document\\"::text like '%100460833%' order by \\"users\\".\\"user_document\\" asc","time":"42.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:20:59
1945	9d50e0fb-6f96-4eb2-b94f-cf699d4a7d13	9d50e0fb-8d4a-4c96-885a-de365522f973	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 13:09:35
1946	9d50e0fb-888c-4a21-8aee-7a892773b802	9d50e0fb-8d4a-4c96-885a-de365522f973	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 13:09:35
1947	9d50e0fb-88d7-414f-945d-e2fc4972a9a2	9d50e0fb-8d4a-4c96-885a-de365522f973	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 13:09:35
1948	9d50e0fb-8c09-4fe2-a080-a256975693a8	9d50e0fb-8d4a-4c96-885a-de365522f973	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 13:09:35
1949	9d50e0fb-8c4e-44f1-adda-d1b4da7bcf53	9d50e0fb-8d4a-4c96-885a-de365522f973	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":248,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:09:35
2248	9d50e510-43f0-4264-aeab-6a5966f1c6dd	9d50e510-4520-4122-86b6-13d1a0f14efe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-23 13:20:59
2249	9d50e510-4436-49fc-9c3a-6bd8196f3e4a	9d50e510-4520-4122-86b6-13d1a0f14efe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"31","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"100460833"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":219,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:20:59
2394	9d50e783-0864-4490-8e93-e721c3fe9e6a	9d50e783-0cd1-4262-9887-55bb0aa46158	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 13:27:50
2395	9d50e783-0bae-4672-8e36-6f2cbb4d0126	9d50e783-0cd1-4262-9887-55bb0aa46158	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 13:27:50
2396	9d50e783-0bf0-4bbc-81ac-848c19779bdb	9d50e783-0cd1-4262-9887-55bb0aa46158	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:27:50
8771	9d52eec8-0fd6-49ac-8c06-4a173d5d8e61	9d52eec8-1419-472c-acc8-92e6fb8e369b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:39:49
11710	9d5cce46-07e1-450f-baa4-9f6d8aaa1b46	9d5cce46-0e74-46e4-9274-9444e70e7819	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (23, 3, 100000, 12500, 0, 'N\\/A', '26-07-2025', 12, '2024-10-29 11:27:12', '2024-10-29 11:27:12')","time":"0.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:27:12
8772	9d52eec8-130f-4db7-b8a9-34443fcb4ef2	9d52eec8-1419-472c-acc8-92e6fb8e369b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 13:39:49
8773	9d52eec8-134f-4f38-9c23-93ff348d0584	9d52eec8-1419-472c-acc8-92e6fb8e369b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":328,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:39:49
2397	9d50e784-858e-41c8-ad7a-8566fc50fd28	9d50e784-cb81-4cd0-ad3b-6079c9006a17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 13:27:51
2250	9d50e510-a34f-45aa-bac7-39cfa935c232	9d50e510-e75d-418c-a5d0-16fc68295b3e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-23 13:21:00
2251	9d50e510-e313-4954-abb7-5c0582d2144f	9d50e510-e75d-418c-a5d0-16fc68295b3e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%1004608333%' or \\"users\\".\\"user_document\\"::text like '%1004608333%' order by \\"users\\".\\"user_document\\" asc","time":"145.05","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:21:00
2252	9d50e510-e620-4efc-b609-df43305b4abd	9d50e510-e75d-418c-a5d0-16fc68295b3e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-23 13:21:00
2253	9d50e510-e660-4c26-ae95-de0dd53ec89f	9d50e510-e75d-418c-a5d0-16fc68295b3e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"32","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"1004608333"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":401,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:21:00
2398	9d50e784-c6ef-42a1-9337-874ce8883ecf	9d50e784-cb81-4cd0-ad3b-6079c9006a17	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"148.06","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 13:27:51
2399	9d50e784-c747-4f47-8340-fbe3f1595b64	9d50e784-cb81-4cd0-ad3b-6079c9006a17	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 13:27:51
2400	9d50e784-ca59-4b7c-bbb4-65a1cd0dd18e	9d50e784-cb81-4cd0-ad3b-6079c9006a17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 13:27:51
2401	9d50e784-ca9a-4093-8711-70e61d18566d	9d50e784-cb81-4cd0-ad3b-6079c9006a17	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":363,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:27:51
11711	9d5cce46-0816-4c5e-9c7a-9045ef5b1734	9d5cce46-0e74-46e4-9274-9444e70e7819	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:27:12
11712	9d5cce46-088e-4da6-afdd-242d447879f6	9d5cce46-0e74-46e4-9274-9444e70e7819	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (23, 4, 100000, 12500, 0, 'N\\/A', '24-10-2025', 12, '2024-10-29 11:27:12', '2024-10-29 11:27:12')","time":"0.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:27:12
1215	9d50c5e0-efd9-405d-bcd0-4a093a05459f	9d50c5e1-1643-4102-98f4-a20b78179872	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 11:53:47
1216	9d50c5e1-138a-4bb0-871c-086339ef32a3	9d50c5e1-1643-4102-98f4-a20b78179872	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 11:53:48
1217	9d50c5e1-14b7-4bda-972b-4496717e453d	9d50c5e1-1643-4102-98f4-a20b78179872	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":291,"memory":22,"hostname":"EderCortes"}	2024-10-23 11:53:48
11713	9d5cce46-08af-47c5-9b60-657cd6309e22	9d5cce46-0e74-46e4-9274-9444e70e7819	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:27:12
10307	9d56cd4a-ef13-44fc-b058-c31681e18eae	9d56cd4a-f024-45d1-b7d0-392da6cc8b6a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":429,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:49:29
8774	9d52eec8-5403-4a5a-a2c9-bebf2886a802	9d52eec8-6f85-4d01-aed8-cf4e21c9e7dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 13:39:49
2996	9d5100bb-9cc4-4a34-b36c-6222bdffb9d8	9d5100bf-acaf-4718-9e95-b8bf82a6605d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 14:38:22
2997	9d5100bf-58eb-4370-a73c-b2d20112783f	9d5100bf-acaf-4718-9e95-b8bf82a6605d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:38:24
2998	9d5100bf-7c44-4b9a-991f-d9b67156b019	9d5100bf-acaf-4718-9e95-b8bf82a6605d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":16269,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:38:24
8775	9d52eec8-6aa5-4101-ba58-78d7c8c73dd1	9d52eec8-6f85-4d01-aed8-cf4e21c9e7dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"40.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 13:39:49
8776	9d52eec8-6aec-44ca-b2ba-d96229f33413	9d52eec8-6f85-4d01-aed8-cf4e21c9e7dd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:39:49
8777	9d52eec8-6e5f-47fb-8884-1bb85ac0e9ba	9d52eec8-6f85-4d01-aed8-cf4e21c9e7dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 13:39:49
8778	9d52eec8-6ea6-4636-8f72-a2e0ddc03749	9d52eec8-6f85-4d01-aed8-cf4e21c9e7dd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"item":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]},"duration":216,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:39:49
11714	9d5cce46-091c-4d07-8cdb-4df794a9fdaf	9d5cce46-0e74-46e4-9274-9444e70e7819	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (23, 5, 100000, 12500, 0, 'N\\/A', '22-01-2026', 12, '2024-10-29 11:27:12', '2024-10-29 11:27:12')","time":"0.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:27:12
11715	9d5cce46-093c-4d5f-811b-9a9161e19865	9d5cce46-0e74-46e4-9274-9444e70e7819	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:27:12
11716	9d5cce46-09a4-4229-a8e0-6970be2a508a	9d5cce46-0e74-46e4-9274-9444e70e7819	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (23, 6, 100000, 12500, 0, 'N\\/A', '22-04-2026', 12, '2024-10-29 11:27:12', '2024-10-29 11:27:12')","time":"0.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:27:12
11717	9d5cce46-09c4-4511-a9c6-87232f95bcfa	9d5cce46-0e74-46e4-9274-9444e70e7819	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:27:12
11718	9d5cce46-0d3e-4198-bdbb-473a7d5e10bc	9d5cce46-0e74-46e4-9274-9444e70e7819	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 11:27:12
14487	9d5eb91c-cf96-4b3a-9307-b5538c5ea856	9d5eb91c-d325-4adf-900d-9c606cca267c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":140,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:19:41
14488	9d5eb91d-38df-42d7-a836-074a9548ceb4	9d5eb91d-b836-414c-a879-b05f769ce79d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-30 10:19:41
14489	9d5eb91d-8326-47bd-8e36-3f08a7cdbb1f	9d5eb91d-b836-414c-a879-b05f769ce79d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"143.31","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-30 10:19:42
1542	9d50d67b-0c5d-46d9-bbab-b7a312013829	9d50d67b-5d60-45cc-9cc4-2d3e79371cbf	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 12:40:13
1543	9d50d67b-5b5b-4d39-a383-d6e2c44f6dd9	9d50d67b-5d60-45cc-9cc4-2d3e79371cbf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:40:13
1544	9d50d67b-5c36-4e00-b9c2-f33267f5f2e8	9d50d67b-5d60-45cc-9cc4-2d3e79371cbf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":375,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:40:13
11719	9d5cce46-0d80-4196-88f9-1256ac114787	9d5cce46-0e74-46e4-9274-9444e70e7819	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"766","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"100465546","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"600000","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":18,"user_recomendacion":14,"loans_inicio_pago":"2024-11-05T05:00:00.000Z","created_at":null,"updated_at":null,"deleted_at":null},"detail":{"status":false,"observacion":"N\\/A","fecha_pago":"Tue Oct 29 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":23},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:27:12
12988	9d5cefb4-09f5-41f0-92c8-d387d9f4e0e6	9d5cefb4-0ae5-48cb-8c34-40aa1618b288	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":552,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:00:41
14490	9d5eb91d-8397-405c-807f-08e9a2ac9ac4	9d5eb91d-b836-414c-a879-b05f769ce79d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-30 10:19:42
14491	9d5eb91d-b6d7-4d3b-98cb-4569092e73a5	9d5eb91d-b836-414c-a879-b05f769ce79d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 10:19:42
2999	9d5100c0-2ce0-4784-88fb-15b7b7bf7ee6	9d5100c1-c046-42ed-a1db-fe21320091a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:38:25
14492	9d5eb91d-b727-4808-b863-a8dd0c8947de	9d5eb91d-b836-414c-a879-b05f769ce79d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"78","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":475,"memory":24,"hostname":"EderCortes"}	2024-10-30 10:19:42
14675	9d5ec0ee-8bf2-48a9-86ec-0223f62395c4	9d5ec0ee-923f-4a1f-8b7b-87e3b40edaa0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"45.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-10-30 10:41:33
14676	9d5ec0ee-9080-4b48-bfb4-086491c82fdb	9d5ec0ee-923f-4a1f-8b7b-87e3b40edaa0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 10:41:33
1545	9d50d67b-b001-4155-9731-6a2e33c9727d	9d50d67b-fa7a-415d-83d1-62822af7bd48	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:40:13
1546	9d50d67b-f546-4557-a230-9718356cd278	9d50d67b-fa7a-415d-83d1-62822af7bd48	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"154.58","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":65,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:40:13
1547	9d50d67b-f5a6-4dbb-9452-31272dcc9bc3	9d50d67b-fa7a-415d-83d1-62822af7bd48	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 12:40:13
1548	9d50d67b-f95f-4dfb-96eb-421f6f646919	9d50d67b-fa7a-415d-83d1-62822af7bd48	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:40:13
1315	9d50cb85-39ce-4140-8605-cfefa496f257	9d50cb85-66b2-4c08-8d96-25bd414bd1d5	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 12:09:34
1316	9d50cb85-63fa-422b-8456-a2ab054143c9	9d50cb85-66b2-4c08-8d96-25bd414bd1d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:09:34
1317	9d50cb85-6536-422e-9559-c28f251bed89	9d50cb85-66b2-4c08-8d96-25bd414bd1d5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":355,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:09:34
1549	9d50d67b-f9a1-41aa-aeac-90901943f3f0	9d50d67b-fa7a-415d-83d1-62822af7bd48	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":379,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:40:13
3000	9d5100c0-ebf3-4a7f-8264-e29aabec71fc	9d5100c1-c046-42ed-a1db-fe21320091a1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"148.95","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:38:25
2402	9d50e789-de10-40c5-bacf-db5db3c52ef7	9d50e789-e0c8-4478-bea3-a3d46031c7de	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":146,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:27:55
1950	9d50e0fe-8a17-41d4-a4fb-13286216eea9	9d50e0fe-8ddc-498c-9c10-8d63ba4204cc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":139,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:09:37
2024	9d50e264-825a-42ff-9ca5-6fa20bb69e23	9d50e264-836a-4696-a1d0-e810b6b71d26	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:13:31
3001	9d5100c0-ec65-4326-8574-864e7581bd7c	9d5100c1-c046-42ed-a1db-fe21320091a1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:38:25
3002	9d5100c1-bf28-479c-a459-cb817718bc1d	9d5100c1-c046-42ed-a1db-fe21320091a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:38:26
3003	9d5100c1-bf6d-4ebb-932e-5e14e1e55461	9d5100c1-c046-42ed-a1db-fe21320091a1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":1277,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:38:26
3203	9d510364-2901-4432-b2aa-c8d4035b7ce5	9d510364-8fd8-48de-b529-cb06c405b563	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:45:48
7131	9d52dad2-bffe-4712-a6fa-442024fc542b	9d52dad2-deec-46e4-839f-3cac60111873	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-24 12:44:01
8779	9d52eec9-e303-47d3-819d-2772a76fb57a	9d52eeca-0921-4620-8b5f-b2f577b335bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 13:39:50
3004	9d5100c2-090d-4426-915e-15b2a72b7237	9d5100c2-5423-4d21-a050-1dda9501af6d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:38:26
1686	9d50db8d-ebaf-478f-9799-3f557522ba25	9d50db8e-3a73-443d-95b9-8f45613307c0	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 12:54:24
1687	9d50db8e-3881-442c-a98e-ca44c80c9816	9d50db8e-3a73-443d-95b9-8f45613307c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:54:24
1688	9d50db8e-394a-491b-b50b-db27f3d5abe2	9d50db8e-3a73-443d-95b9-8f45613307c0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":408,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:54:24
1435	9d50d153-c09e-452e-bcac-ad30528d9996	9d50d153-df55-45b1-9f5b-03521cd6a3e2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:25:48
1436	9d50d153-ddc4-419c-afe2-1083081e87db	9d50d153-df55-45b1-9f5b-03521cd6a3e2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:25:48
1437	9d50d153-de5e-4d69-ba47-692cafdb8721	9d50d153-df55-45b1-9f5b-03521cd6a3e2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":300,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:25:48
3005	9d5100c2-4f06-4f6a-a635-fb4aa351c487	9d5100c2-5423-4d21-a050-1dda9501af6d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"155.73","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:38:26
2403	9d50e78a-95d2-4443-8dde-5da477868a75	9d50e78a-b160-4e99-98e8-655763b43250	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 13:27:55
1951	9d50e0ff-40f4-4344-a149-d04691cc7c40	9d50e0ff-5b6e-41ba-806d-edead0f4fb84	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 13:09:37
1952	9d50e0ff-5791-4a01-820b-863bb774e43c	9d50e0ff-5b6e-41ba-806d-edead0f4fb84	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder%' or \\"users\\".\\"user_document\\"::text like '%eder%' order by \\"users\\".\\"user_document\\" asc","time":"41.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:09:37
1953	9d50e0ff-5a3f-426e-aea6-645d1676e0f8	9d50e0ff-5b6e-41ba-806d-edead0f4fb84	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 13:09:37
1954	9d50e0ff-5a7e-4e0e-a6be-52d38914f76c	9d50e0ff-5b6e-41ba-806d-edead0f4fb84	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":217,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:09:37
2025	9d50e26d-97c8-4419-8e43-f47d47d779c6	9d50e26d-9a97-45d8-aa14-30a1dbe1c668	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":132,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:13:37
2404	9d50e78a-ad5a-4bdb-9553-274d8770c6e6	9d50e78a-b160-4e99-98e8-655763b43250	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"42.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:27:55
2405	9d50e78a-b012-4960-b171-4e511b8f7fe3	9d50e78a-b160-4e99-98e8-655763b43250	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 13:27:55
2406	9d50e78a-b055-4f78-8d78-3e372f21248b	9d50e78a-b160-4e99-98e8-655763b43250	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":214,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:27:55
3006	9d5100c2-4f52-41ee-8c3d-c5db40319962	9d5100c2-5423-4d21-a050-1dda9501af6d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:38:26
3007	9d5100c2-5318-4435-a403-2c0a3df025b8	9d5100c2-5423-4d21-a050-1dda9501af6d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:38:26
3204	9d510364-853f-476e-a8d7-814ab0fca3db	9d510364-8fd8-48de-b529-cb06c405b563	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"187.06","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:45:48
3205	9d510364-85ca-45da-b820-00a3f5deeed6	9d510364-8fd8-48de-b529-cb06c405b563	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:45:48
1438	9d50d154-252e-45aa-b83a-fa6aedcabd7a	9d50d15c-0c81-441a-94fc-cc7472e71d1e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:25:48
1439	9d50d15c-0b80-4aad-9a9a-e67737a446c2	9d50d15c-0c81-441a-94fc-cc7472e71d1e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:25:54
1440	9d50d15c-0bd1-4d79-a9ec-6145e47f324b	9d50d15c-0c81-441a-94fc-cc7472e71d1e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":"Empty Response","duration":5335,"memory":20,"hostname":"EderCortes"}	2024-10-23 12:25:54
1689	9d50db8e-8ef8-44b8-b5f1-d77c3a21a3d8	9d50db8e-b037-4547-825f-dc6342096584	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:54:24
1690	9d50db8e-aa7d-4325-8dd9-dfd39269102e	9d50db8e-b037-4547-825f-dc6342096584	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":65,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:54:25
1691	9d50db8e-aada-425e-ba29-b2b03842ec9f	9d50db8e-b037-4547-825f-dc6342096584	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 12:54:25
1550	9d50d67c-3d9a-4c23-b896-6a628229becf	9d50d67c-5abc-4b4a-8cb2-0d8f4e65c7b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:40:14
1551	9d50d67c-55e7-4f19-91c2-d136e2258150	9d50d67c-5abc-4b4a-8cb2-0d8f4e65c7b0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":65,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:40:14
1552	9d50d67c-5630-4b86-8cd8-058276f364fb	9d50d67c-5abc-4b4a-8cb2-0d8f4e65c7b0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 12:40:14
1553	9d50d67c-599e-45e6-80f5-f9220308e6cf	9d50d67c-5abc-4b4a-8cb2-0d8f4e65c7b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:40:14
1554	9d50d67c-59e1-45d5-a529-ee9b6d47c950	9d50d67c-5abc-4b4a-8cb2-0d8f4e65c7b0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:40:14
1692	9d50db8e-af1b-4d9f-9cac-763b81539667	9d50db8e-b037-4547-825f-dc6342096584	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:54:25
1693	9d50db8e-af5c-4f1c-96b2-09f5d3c58f6c	9d50db8e-b037-4547-825f-dc6342096584	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":280,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:54:25
2026	9d50e26e-125f-4264-9e20-f966116a1f8d	9d50e26e-2de2-4f21-a6a8-30f0c7ee131b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 13:13:38
2027	9d50e26e-292d-49bb-90fc-eb1bc0f6f495	9d50e26e-2de2-4f21-a6a8-30f0c7ee131b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder%' or \\"users\\".\\"user_document\\"::text like '%eder%' order by \\"users\\".\\"user_document\\" asc","time":"42.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:13:38
2028	9d50e26e-2c84-443a-8b9f-d304a8b86f0b	9d50e26e-2de2-4f21-a6a8-30f0c7ee131b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 13:13:38
2029	9d50e26e-2cd1-49d2-b832-23160a5d46d6	9d50e26e-2de2-4f21-a6a8-30f0c7ee131b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":214,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:13:38
1441	9d50d15c-93b8-4dcf-ab8a-5820bb3ae0ee	9d50d15c-c076-45fb-b777-712147cc6145	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:25:54
1442	9d50d15c-b8d5-43d3-97ba-d8f816d7c953	9d50d15c-c076-45fb-b777-712147cc6145	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"57.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":50,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:25:54
1443	9d50d15c-b94a-4fd7-925d-a33e202ceb2b	9d50d15c-c076-45fb-b777-712147cc6145	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 12:25:54
1444	9d50d15c-bf09-4497-a4b2-52bfbd189c53	9d50d15c-c076-45fb-b777-712147cc6145	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 12:25:54
1445	9d50d15c-bf6d-485a-b76d-4f5e85fa35ad	9d50d15c-c076-45fb-b777-712147cc6145	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":398,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:25:54
1694	9d50db8e-ef38-496e-89d6-ba5c47ba4eae	9d50db8f-3497-4ac6-bb13-f4678bb14ce9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:54:25
1695	9d50db8f-2fd3-46a8-b763-92302e6b1f57	9d50db8f-3497-4ac6-bb13-f4678bb14ce9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"144.08","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":65,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:54:25
1555	9d50d67d-c877-46ff-b8b5-d44f621c123e	9d50d67d-e6f5-4d42-9510-83e9f7efe415	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:40:15
1556	9d50d67d-e1ea-47cb-990a-fc87c73f0aaf	9d50d67d-e6f5-4d42-9510-83e9f7efe415	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 12:40:15
1557	9d50d67d-e232-435a-a917-00b7b9843738	9d50d67d-e6f5-4d42-9510-83e9f7efe415	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 12:40:15
1558	9d50d67d-e5bb-4c24-99e7-b38f7ef83cbe	9d50d67d-e6f5-4d42-9510-83e9f7efe415	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 12:40:15
1559	9d50d67d-e602-48ef-9f0a-68b935ba8858	9d50d67d-e6f5-4d42-9510-83e9f7efe415	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":387,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:40:15
1696	9d50db8f-302b-4eca-844e-031abf147850	9d50db8f-3497-4ac6-bb13-f4678bb14ce9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 12:54:25
1697	9d50db8f-3377-4eb5-88eb-d619e9ecc03b	9d50db8f-3497-4ac6-bb13-f4678bb14ce9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:54:25
1698	9d50db8f-33ba-4867-8fbc-41e0504f3e97	9d50db8f-3497-4ac6-bb13-f4678bb14ce9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":319,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:54:25
1446	9d50d15e-3db2-4fe4-8254-5d40435895e7	9d50d15e-6d19-40f4-9eb6-b840243acb23	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 12:25:55
1447	9d50d15e-6667-41b1-89c1-168246a1d2b6	9d50d15e-6d19-40f4-9eb6-b840243acb23	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"69.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 12:25:55
1448	9d50d15e-66ca-4c6f-a92c-3f988fe43cfb	9d50d15e-6d19-40f4-9eb6-b840243acb23	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 12:25:55
1449	9d50d15e-6b63-4799-b597-6522d2013c45	9d50d15e-6d19-40f4-9eb6-b840243acb23	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 12:25:55
1450	9d50d15e-6bc2-4613-9e79-a91aa8e0f90a	9d50d15e-6d19-40f4-9eb6-b840243acb23	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":432,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:25:55
1699	9d50db90-fd41-4116-b81e-71f16d11b24d	9d50db91-23f4-4b81-be9a-a8c1e11ac3d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:54:26
1700	9d50db91-1d46-4819-8de8-6453eee50c2a	9d50db91-23f4-4b81-be9a-a8c1e11ac3d2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"51.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 12:54:26
1560	9d50d686-b676-46a9-9abf-aabd7bc53576	9d50d686-ba0b-4c1c-b2f8-ea1800e1bf41	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":156,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:40:20
1701	9d50db91-1da7-4cf5-95b2-9ff71db91cea	9d50db91-23f4-4b81-be9a-a8c1e11ac3d2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 12:54:26
1702	9d50db91-2275-438b-81b5-3aa591b818a1	9d50db91-23f4-4b81-be9a-a8c1e11ac3d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 12:54:26
1703	9d50db91-22d9-4832-af05-f66913f7bfb5	9d50db91-23f4-4b81-be9a-a8c1e11ac3d2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":397,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:54:26
1955	9d50e105-538c-41fd-ae60-03ef5d7e405f	9d50e105-563e-4aed-ad87-221e4791c2f2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":162,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:09:41
2030	9d50e271-95f0-489c-af0b-3b127392e916	9d50e271-98fb-4c0b-958e-28178c29ca03	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":147,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:13:40
1561	9d50d687-2ecb-4852-811f-387bb018e66e	9d50d687-4ea4-4c46-a57d-fb1853d1a618	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 12:40:21
1562	9d50d687-49c7-4733-a735-e1be4ef1a7ac	9d50d687-4ea4-4c46-a57d-fb1853d1a618	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"name\\", \\"users\\".\\"user_document\\", \\"users\\".\\"id\\" from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%1004%' or \\"users\\".\\"user_document\\"::text like '%1004%' order by \\"users\\".\\"user_document\\" asc","time":"52.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"71e2e94a1a5a1b5c9b9dc051aea4b922","hostname":"EderCortes"}	2024-10-23 12:40:21
1563	9d50d687-4d73-4183-93c3-ff8b923d4159	9d50d687-4ea4-4c46-a57d-fb1853d1a618	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 12:40:21
1564	9d50d687-4db6-4c7b-b991-b1bfd5af7c68	9d50d687-4ea4-4c46-a57d-fb1853d1a618	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"1004"},"session":[],"response_status":200,"response":{"data":[{"name":"Eder Arley","user_document":"1004608333","id":12},{"name":"Luis andre","user_document":"100465545","id":14},{"name":"Maria Antonieta","user_document":"100465546","id":18},{"name":"Maria Antonieta 2","user_document":"1004655468","id":19}]},"duration":221,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:40:21
1704	9d50dcca-6c57-45b3-9a76-8a5be0652b99	9d50dcca-7070-411e-97f6-dcf2f7c25b17	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":183,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:57:51
3206	9d510364-8cd2-470b-9a81-f09448f71765	9d510364-8fd8-48de-b529-cb06c405b563	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:45:48
1956	9d50e106-0691-4682-972d-ab9324603e68	9d50e106-204d-4dc1-b2e0-1ee0b62b54e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 13:09:42
1957	9d50e106-1c18-42bb-bf68-61c5991eb597	9d50e106-204d-4dc1-b2e0-1ee0b62b54e4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"39.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:09:42
1958	9d50e106-1f11-4f5c-87b9-65502c120617	9d50e106-204d-4dc1-b2e0-1ee0b62b54e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 13:09:42
1959	9d50e106-1f5f-486a-b0e8-ee99cc454523	9d50e106-204d-4dc1-b2e0-1ee0b62b54e4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":212,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:09:42
2031	9d50e272-4fca-4ffe-b7ab-9a82192a74bd	9d50e272-6a09-4e33-abab-888fc92cc2b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 13:13:40
2032	9d50e272-65de-471f-a0c8-99c81733bd48	9d50e272-6a09-4e33-abab-888fc92cc2b6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"41.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:13:40
2033	9d50e272-68d9-47c8-909f-62642380927d	9d50e272-6a09-4e33-abab-888fc92cc2b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 13:13:40
2034	9d50e272-691c-4f04-8f70-7979ed4facce	9d50e272-6a09-4e33-abab-888fc92cc2b6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":219,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:13:40
1565	9d50d69a-5d69-4bba-bd4a-8dd6ba60affc	9d50d69a-612c-4bcd-951e-480d543b1ed6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":165,"memory":20,"hostname":"EderCortes"}	2024-10-23 12:40:33
1705	9d50dcca-ce75-4e09-b164-3b5df4dca7d9	9d50dccb-1b98-43cf-a45b-ee2990a599c1	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 12:57:52
1706	9d50dccb-1593-4333-b712-9231580fa3e5	9d50dccb-1b98-43cf-a45b-ee2990a599c1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"name\\", \\"users\\".\\"user_document\\", \\"users\\".\\"id\\" from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder%' or \\"users\\".\\"user_document\\"::text like '%eder%' order by \\"users\\".\\"user_document\\" asc","time":"153.21","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"71e2e94a1a5a1b5c9b9dc051aea4b922","hostname":"EderCortes"}	2024-10-23 12:57:52
1707	9d50dccb-19ee-4682-b7cf-9c240c6d87cc	9d50dccb-1b98-43cf-a45b-ee2990a599c1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:57:52
1708	9d50dccb-1a4b-472e-a0ec-ba89f4c1b39b	9d50dccb-1b98-43cf-a45b-ee2990a599c1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder"},"session":[],"response_status":200,"response":{"data":[{"name":"Luis andre","user_document":"100465545","id":14}]},"duration":370,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:57:52
3008	9d5100c2-5366-4f05-ab67-7cafb1c7ff02	9d5100c2-5423-4d21-a050-1dda9501af6d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":363,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:38:26
7132	9d52dad2-d901-4852-af95-176e521ae6a0	9d52dad2-deec-46e4-839f-3cac60111873	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:44:01
1960	9d50e220-0cea-4df6-a34f-89a790a04eec	9d50e220-33e0-4533-b03b-06e9e54ead9f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 13:12:46
1961	9d50e220-2d48-4ff5-8cb7-42798a884da0	9d50e220-33e0-4533-b03b-06e9e54ead9f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"41.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-23 13:12:47
1962	9d50e220-2dae-45b7-af2c-e58378f719cc	9d50e220-33e0-4533-b03b-06e9e54ead9f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-10-23 13:12:47
1963	9d50e220-324e-4441-aa27-20515f5dcce9	9d50e220-33e0-4533-b03b-06e9e54ead9f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 13:12:47
1964	9d50e220-32bb-4d03-81a4-e916b353d727	9d50e220-33e0-4533-b03b-06e9e54ead9f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":305,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:12:47
7133	9d52dad2-d952-483b-9fca-1892751326f1	9d52dad2-deec-46e4-839f-3cac60111873	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:44:01
7134	9d52dad2-ddd0-4a20-a299-65abb28155bd	9d52dad2-deec-46e4-839f-3cac60111873	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-24 12:44:01
1566	9d50d69b-15c3-4ce6-ba93-9187d1d913cf	9d50d69b-313f-4c8d-b7f3-988f37f44b92	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 12:40:34
1567	9d50d69b-2ce3-4ac4-b12c-b99fb80f6d5f	9d50d69b-313f-4c8d-b7f3-988f37f44b92	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"name\\", \\"users\\".\\"user_document\\", \\"users\\".\\"id\\" from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%8333%' or \\"users\\".\\"user_document\\"::text like '%8333%' order by \\"users\\".\\"user_document\\" asc","time":"42.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"71e2e94a1a5a1b5c9b9dc051aea4b922","hostname":"EderCortes"}	2024-10-23 12:40:34
1568	9d50d69b-2ff0-4d3d-80d6-009fe66d9c85	9d50d69b-313f-4c8d-b7f3-988f37f44b92	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 12:40:34
1569	9d50d69b-303c-412a-b050-4c0328165619	9d50d69b-313f-4c8d-b7f3-988f37f44b92	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"8333"},"session":[],"response_status":200,"response":{"data":[{"name":"Eder Arley","user_document":"1004608333","id":12},{"name":"Luis andre","user_document":"100465545","id":14}]},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:40:34
13824	9d5d101f-ce8f-4aa0-b2f4-da6febd5ec3c	9d5d101f-d195-4fec-aae4-166b53909134	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":187,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:31:20
14493	9d5eb935-b67f-4508-b82f-4d101d508ff3	9d5eb935-ba82-4dfe-a310-6edb0bbaa4a7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":226,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:19:57
2882	9d50fd53-b8e1-421f-b711-583a53dcb01e	9d50fd53-dfd4-461e-9a6a-6ae9b9db3bf8	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 14:28:50
2883	9d50fd53-ddc9-4efe-b04d-287e0e54e58a	9d50fd53-dfd4-461e-9a6a-6ae9b9db3bf8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:28:50
2884	9d50fd53-de9c-4157-99e4-b615b5f2c6a6	9d50fd53-dfd4-461e-9a6a-6ae9b9db3bf8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":274,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:28:50
3207	9d510364-8da7-48e3-90b7-8e8698a351c8	9d510364-8fd8-48de-b529-cb06c405b563	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":559,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:45:48
14677	9d5ec0ee-90f5-4683-811e-32b635a7b04f	9d5ec0ee-923f-4a1f-8b7b-87e3b40edaa0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":261,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:41:33
20601	9d66f84e-3096-4ac4-b5a2-93b30edb1010	9d66f84e-356f-4ab9-951d-ad6f5fa95347	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":214,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:43:00
14494	9d5eb936-6e0e-41ed-b7d1-c721c657d45c	9d5eb936-ccf4-4a59-a528-b9ca4659329a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 10:19:58
8780	9d52eeca-031f-4887-9860-969cdd579fcd	9d52eeca-0921-4620-8b5f-b2f577b335bb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"49.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:39:50
2885	9d50fd54-3894-4e80-962a-fb60a1c71340	9d50fd54-5a37-49f7-ab40-c2237d5320e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:28:51
2055	9d50e313-c98b-44c9-848d-a209dd653e76	9d50e314-114b-43e7-b88d-b2ef1a6f020b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 13:15:26
2056	9d50e314-0fb8-4f36-ae3d-312c33fe7826	9d50e314-114b-43e7-b88d-b2ef1a6f020b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 13:15:26
2057	9d50e314-1052-4b44-a966-bd7435a583af	9d50e314-114b-43e7-b88d-b2ef1a6f020b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":377,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:15:26
2886	9d50fd54-5439-4c13-9be2-5af3cc8a332a	9d50fd54-5a37-49f7-ab40-c2237d5320e1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:28:51
3208	9d510364-e82c-4a8c-8869-8ccff58fd40f	9d510365-09a3-4f1a-9d18-9f007e78cef0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:45:48
2887	9d50fd54-5489-4316-83b8-790e855e5f0c	9d50fd54-5a37-49f7-ab40-c2237d5320e1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:28:51
2888	9d50fd54-58ef-47e9-a0ed-331d357bf60c	9d50fd54-5a37-49f7-ab40-c2237d5320e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:28:51
2889	9d50fd54-5952-4279-b187-33575aebbf07	9d50fd54-5a37-49f7-ab40-c2237d5320e1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":291,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:28:51
3209	9d510365-03ce-4d8e-8af7-a646cdfc93c4	9d510365-09a3-4f1a-9d18-9f007e78cef0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:45:48
3210	9d510365-0438-4997-8254-de73d2f84065	9d510365-09a3-4f1a-9d18-9f007e78cef0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:45:48
3211	9d510365-0855-49c8-95ff-b61d30f2cb8d	9d510365-09a3-4f1a-9d18-9f007e78cef0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 14:45:48
3212	9d510365-089b-4d1b-be97-859577c7ad25	9d510365-09a3-4f1a-9d18-9f007e78cef0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":280,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:45:48
8781	9d52eeca-0379-4379-bcf2-28abe5983164	9d52eeca-0921-4620-8b5f-b2f577b335bb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:39:50
8782	9d52eeca-07be-47ed-a096-87a30e48318c	9d52eeca-0921-4620-8b5f-b2f577b335bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-24 13:39:50
8783	9d52eeca-080a-47a1-bade-3d073dc91372	9d52eeca-0921-4620-8b5f-b2f577b335bb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":485,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:39:50
2058	9d50e314-5303-403f-b9f8-8263c8aec13a	9d50e314-9de3-4caf-a417-f4b800e2596f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 13:15:27
2059	9d50e314-990d-46ee-9992-6c41b2fdb9bd	9d50e314-9de3-4caf-a417-f4b800e2596f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"157.87","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:15:27
2060	9d50e314-995b-44f5-a1b8-5929cfc182ab	9d50e314-9de3-4caf-a417-f4b800e2596f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 13:15:27
2061	9d50e314-9cc0-4e8b-ae96-87d589f3c270	9d50e314-9de3-4caf-a417-f4b800e2596f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 13:15:27
2062	9d50e314-9d05-4a0a-8978-0fd3ed1f9775	9d50e314-9de3-4caf-a417-f4b800e2596f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":338,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:15:27
2890	9d50fd54-a475-46b3-87e8-baaa47cb57c5	9d50fd54-c536-48bd-9563-0d913a4f6647	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:28:51
2891	9d50fd54-bff8-420c-9744-125684947e2d	9d50fd54-c536-48bd-9563-0d913a4f6647	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:28:51
2892	9d50fd54-c055-4bf5-9456-01c6f2dd2bfd	9d50fd54-c536-48bd-9563-0d913a4f6647	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:28:51
2893	9d50fd54-c40e-42d4-bea4-b2bb60bfb7ed	9d50fd54-c536-48bd-9563-0d913a4f6647	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:28:51
2894	9d50fd54-c458-49f3-90a1-9d42d7c1d62f	9d50fd54-c536-48bd-9563-0d913a4f6647	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":260,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:28:51
14495	9d5eb936-b467-4e6f-83a5-14f339a905af	9d5eb936-ccf4-4a59-a528-b9ca4659329a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"148.03","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-30 10:19:58
3213	9d510365-c1f5-41dd-baf3-8a2e729c23ca	9d510366-01fa-47c8-9ae1-c7acf1aa3143	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 14:45:49
3214	9d510365-f50f-4f14-9c47-09736f3f9c02	9d510366-01fa-47c8-9ae1-c7acf1aa3143	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"86.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:45:49
3215	9d510365-f5b3-4275-90f7-a3ca78616166	9d510366-01fa-47c8-9ae1-c7acf1aa3143	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:45:49
3216	9d510365-febb-49ba-ae94-4f7a9d8acc81	9d510366-01fa-47c8-9ae1-c7acf1aa3143	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 14:45:49
3217	9d510365-ff60-4fe0-a9c9-9ad8e1c10234	9d510366-01fa-47c8-9ae1-c7acf1aa3143	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":617,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:45:49
14496	9d5eb936-b4c0-4cea-bec4-620da5840356	9d5eb936-ccf4-4a59-a528-b9ca4659329a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-30 10:19:58
2063	9d50e314-e23d-4d99-b997-4417de84f5f4	9d50e315-029c-4039-a9c6-abf150858b94	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 13:15:27
2064	9d50e314-fd37-47ed-bd9c-9bf8226caf02	9d50e315-029c-4039-a9c6-abf150858b94	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:15:27
2065	9d50e314-fd95-46da-97b0-0d9c83c723cb	9d50e315-029c-4039-a9c6-abf150858b94	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 13:15:27
2066	9d50e315-0164-4b72-81ea-bb052c104042	9d50e315-029c-4039-a9c6-abf150858b94	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 13:15:27
1334	9d50ccce-0d17-4da8-8738-b423290e10d4	9d50ccce-5bed-476a-9f77-105067140ba1	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 12:13:10
1335	9d50ccce-59d7-42ff-b3bd-8bea8db2e4ce	9d50ccce-5bed-476a-9f77-105067140ba1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:13:10
1336	9d50ccce-5aa5-4845-910f-eed5f926e546	9d50ccce-5bed-476a-9f77-105067140ba1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":429,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:13:10
2067	9d50e315-01b8-4172-8794-de96ff3c60ad	9d50e315-029c-4039-a9c6-abf150858b94	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:15:27
14497	9d5eb936-cbb4-4314-9643-2005e658d596	9d5eb936-ccf4-4a59-a528-b9ca4659329a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 10:19:58
3218	9d510366-9b59-47cb-997c-e5826f48731c	9d510366-e97f-4945-b8a6-2e4576eb54b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 14:45:49
3219	9d510366-e464-496f-b3c4-8d3698ee3d37	9d510366-e97f-4945-b8a6-2e4576eb54b3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"149.17","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:45:49
3220	9d510366-e4e6-4d9e-9fa8-fe5ef0947319	9d510366-e97f-4945-b8a6-2e4576eb54b3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:45:49
3221	9d510366-e859-48b2-a4ca-4611cc33b314	9d510366-e97f-4945-b8a6-2e4576eb54b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 14:45:49
3222	9d510366-e899-4c24-be4e-55fe9bff8c69	9d510366-e97f-4945-b8a6-2e4576eb54b3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":563,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:45:49
14498	9d5eb936-cbfb-4746-9e6f-9fd56798f76c	9d5eb936-ccf4-4a59-a528-b9ca4659329a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"78","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":389,"memory":24,"hostname":"EderCortes"}	2024-10-30 10:19:58
14678	9d5ec0f2-2e23-4341-9351-a90345098f62	9d5ec0f2-7f1e-4157-a82e-1e85f912b624	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 10:41:35
14679	9d5ec0f2-792b-4572-b166-f44ab6955718	9d5ec0f2-7f1e-4157-a82e-1e85f912b624	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"156.69","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":179,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 10:41:36
2068	9d50e316-3915-4866-94ec-9a92fc257dd5	9d50e316-611b-449e-9998-eb41ef918cdc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 13:15:28
2069	9d50e316-5a27-42e8-a562-36f4fdf87fb4	9d50e316-611b-449e-9998-eb41ef918cdc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"57.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 13:15:28
2070	9d50e316-5aa1-4e8d-9884-ae5555465121	9d50e316-611b-449e-9998-eb41ef918cdc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 13:15:28
2071	9d50e316-5fb4-4b9d-91b6-b7b9f8955440	9d50e316-611b-449e-9998-eb41ef918cdc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 13:15:28
2072	9d50e316-5ffe-4462-9adf-c8600dbbfc52	9d50e316-611b-449e-9998-eb41ef918cdc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":397,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:15:28
14499	9d5eb944-24db-485f-b757-077733647bca	9d5eb944-27fe-4dab-8454-9f977e7613ae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":166,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:20:07
3110	9d5102cb-37f2-400e-b154-6d09c402ef2c	9d5102cb-608b-458d-839f-95bffa05899b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 14:44:07
3111	9d5102cb-5e94-4b9f-a16b-fcafba196b62	9d5102cb-608b-458d-839f-95bffa05899b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:44:07
3112	9d5102cb-5f61-4615-af77-9d4152efbb0f	9d5102cb-608b-458d-839f-95bffa05899b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:44:07
14680	9d5ec0f2-7992-40ce-bcd2-48ebedac7885	9d5ec0f2-7f1e-4157-a82e-1e85f912b624	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-30 10:41:36
7135	9d52dad2-de16-4e58-9636-8495b9bf86ed	9d52dad2-deec-46e4-839f-3cac60111873	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:44:01
13828	9d5d1056-a304-48f1-9209-5be5541a6093	9d5d1056-a71d-4717-bd00-b8945e03cac2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":155,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:31:56
14681	9d5ec0f2-7dcd-467e-9172-b3aa785722f9	9d5ec0f2-7f1e-4157-a82e-1e85f912b624	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 10:41:36
14682	9d5ec0f2-7e1d-46ce-9f92-1c5bc0e41e6c	9d5ec0f2-7f1e-4157-a82e-1e85f912b624	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":567,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:41:36
2073	9d50e31e-46b2-4ff6-897e-b953c31395b5	9d50e31e-495e-43d8-a23e-4d3ee1759c5f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":162,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:15:33
3113	9d5102cb-c521-4a84-8af4-0200d36b473f	9d5102cc-123b-4f17-9c5e-eb734a539e3f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:44:08
3114	9d5102cc-0c6d-4ce2-931b-794948d6a8a3	9d5102cc-123b-4f17-9c5e-eb734a539e3f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"158.42","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:44:08
3115	9d5102cc-0cbb-4e51-9e46-027ca49fc9e0	9d5102cc-123b-4f17-9c5e-eb734a539e3f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:44:08
3116	9d5102cc-10cf-4aea-a53a-471e730d2838	9d5102cc-123b-4f17-9c5e-eb734a539e3f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:44:08
3117	9d5102cc-1127-49c7-a296-4d5d3d8661e3	9d5102cc-123b-4f17-9c5e-eb734a539e3f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":423,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:44:08
14500	9d5eb944-dc95-4a79-9a17-6342fe2efad0	9d5eb945-1274-4c98-afbb-38ebf145cfe6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 10:20:07
14501	9d5eb944-f884-4e07-bb90-e7d0813d4032	9d5eb945-1274-4c98-afbb-38ebf145cfe6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"40.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-30 10:20:07
7136	9d52dad3-2098-4c16-b167-a1acd24cb07b	9d52dad3-4256-4782-9ced-5535909d7bc7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-24 12:44:01
7137	9d52dad3-3cfd-4c3f-9b1e-38e202509c4f	9d52dad3-4256-4782-9ced-5535909d7bc7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:44:01
7138	9d52dad3-3d45-46d8-accd-2d2cd6c88e0f	9d52dad3-4256-4782-9ced-5535909d7bc7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:44:01
7139	9d52dad3-40ff-46b9-a883-77078ad62734	9d52dad3-4256-4782-9ced-5535909d7bc7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-10-24 12:44:01
7140	9d52dad3-4142-4a28-800f-63e2f06a9223	9d52dad3-4256-4782-9ced-5535909d7bc7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:44:01
14502	9d5eb944-f8dd-4bf4-bfc8-9636b20bc69d	9d5eb945-1274-4c98-afbb-38ebf145cfe6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-30 10:20:07
14503	9d5eb945-1128-428b-b64a-4716985d2f63	9d5eb945-1274-4c98-afbb-38ebf145cfe6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 10:20:07
14504	9d5eb945-1171-443b-ae73-0a6a35a2a43f	9d5eb945-1274-4c98-afbb-38ebf145cfe6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"78","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":285,"memory":24,"hostname":"EderCortes"}	2024-10-30 10:20:07
14683	9d5ec0f2-c504-434a-a579-623654a1d742	9d5ec0f2-e452-49e2-b869-35f1eb5e3a82	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 10:41:36
2074	9d50e31e-a59f-441c-b586-d9485e846f38	9d50e31e-e938-4a61-9d85-be65b833fa86	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 13:15:33
2075	9d50e31e-e513-4151-8c83-b8706133636d	9d50e31e-e938-4a61-9d85-be65b833fa86	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%HOLA%' or \\"users\\".\\"user_document\\"::text like '%HOLA%' order by \\"users\\".\\"user_document\\" asc","time":"145.04","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:15:33
2076	9d50e31e-e80a-4279-a7f3-6f2e21b18bbb	9d50e31e-e938-4a61-9d85-be65b833fa86	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 13:15:33
2077	9d50e31e-e84b-4956-ac04-2370f4e17e91	9d50e31e-e938-4a61-9d85-be65b833fa86	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"HOLA"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":319,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:15:33
3118	9d5102cc-5ab9-4ec3-a459-f1b7587e4072	9d5102cc-a29f-41bf-8981-4a19df727725	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:44:08
3119	9d5102cc-9d3b-4091-adec-01797f114b11	9d5102cc-a29f-41bf-8981-4a19df727725	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"145.35","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:44:08
3120	9d5102cc-9d8b-43b3-8ed7-bd7e0c5ff08a	9d5102cc-a29f-41bf-8981-4a19df727725	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:44:08
3121	9d5102cc-a182-49f9-947c-49ca3f11d60e	9d5102cc-a29f-41bf-8981-4a19df727725	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:44:08
3122	9d5102cc-a1d7-4c4c-a30a-ed74503a2085	9d5102cc-a29f-41bf-8981-4a19df727725	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:44:08
14684	9d5ec0f2-dea8-4337-b78e-92fbb46e121a	9d5ec0f2-e452-49e2-b869-35f1eb5e3a82	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":179,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 10:41:36
7141	9d52dad3-8afa-4da1-a006-816e94121dad	9d52dad3-d212-41d2-a1b0-db77596251d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-10-24 12:44:01
7142	9d52dad3-cb35-47a5-b732-3ffc4204d1b1	9d52dad3-d212-41d2-a1b0-db77596251d9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"143.00","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:44:01
7143	9d52dad3-cb92-496b-8adb-7de7274e6a68	9d52dad3-d212-41d2-a1b0-db77596251d9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:44:01
7144	9d52dad3-cd39-4e66-b5d9-f70e0b274697	9d52dad3-d212-41d2-a1b0-db77596251d9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"1.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:44:01
7145	9d52dad3-cd66-4353-85d5-985e9071453b	9d52dad3-d212-41d2-a1b0-db77596251d9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:44:01
7146	9d52dad3-d0bc-4dc3-9b5a-905718d7fe5f	9d52dad3-d212-41d2-a1b0-db77596251d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-10-24 12:44:01
7147	9d52dad3-d121-466c-bae7-0b1b904a76bb	9d52dad3-d212-41d2-a1b0-db77596251d9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:44:01
2078	9d50e331-dc63-4985-89a9-6951eea8c76b	9d50e331-dfea-489f-a566-875e35e4dcfc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":173,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:15:46
14685	9d5ec0f2-df0b-4de6-a71f-fdf080705b3c	9d5ec0f2-e452-49e2-b869-35f1eb5e3a82	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-30 10:41:36
13833	9d5d1074-17de-4863-89ac-a0453a64d679	9d5d1074-1bb3-4a3c-8e7d-98a40d1dd81f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":163,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:32:15
14686	9d5ec0f2-e2fa-4268-82cf-5622e89ea6df	9d5ec0f2-e452-49e2-b869-35f1eb5e3a82	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 10:41:36
3464	9d5105e7-64e9-4d6a-b51c-ad054aa210f2	9d5105e7-667f-4625-9152-b9fefb79bf06	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":627,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:52:49
14687	9d5ec0f2-e354-461e-a23f-a8e61362e896	9d5ec0f2-e452-49e2-b869-35f1eb5e3a82	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:41:36
15512	9d5edf70-eced-4e4a-a6b6-18332c25473a	9d5edf72-5788-4825-989a-e90647cdf65b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"240.19","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":24,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-30 12:06:52
15513	9d5edf72-205c-4479-926e-b26cf8b32925	9d5edf72-5788-4825-989a-e90647cdf65b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 12:06:52
15514	9d5edf72-270e-467b-9237-aad4a11e88a3	9d5edf72-5788-4825-989a-e90647cdf65b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":16065,"memory":22,"hostname":"EderCortes"}	2024-10-30 12:06:52
2079	9d50e332-8fc7-45d3-ac6d-b9880d75939f	9d50e332-d436-4cf8-87f6-102ab85560fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 13:15:46
2080	9d50e332-cfec-4eef-8d79-955787cde7c7	9d50e332-d436-4cf8-87f6-102ab85560fe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%EDER%' or \\"users\\".\\"user_document\\"::text like '%EDER%' order by \\"users\\".\\"user_document\\" asc","time":"148.18","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:15:47
2081	9d50e332-d302-46c6-b029-127020591954	9d50e332-d436-4cf8-87f6-102ab85560fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 13:15:47
2082	9d50e332-d342-4b39-9aee-eec5fe45f993	9d50e332-d436-4cf8-87f6-102ab85560fe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"EDER"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":321,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:15:47
14688	9d5ec0f7-69d6-4661-ac73-f8de36d9d4f4	9d5ec0f7-6cec-4ac9-ab90-31e5ed14b8ea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":156,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:41:39
3352	9d510493-4dc4-4183-bf46-775d7e48125a	9d510493-6db2-41cc-a384-196624692afa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-23 14:49:06
3353	9d510493-6be5-4b25-b7c7-027180a65d59	9d510493-6db2-41cc-a384-196624692afa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-23 14:49:06
3354	9d510493-6cb5-42ae-bb66-b8eaf9321527	9d510493-6db2-41cc-a384-196624692afa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:49:06
15515	9d5edf72-dded-4513-9509-1dccbdb8fc50	9d5edf72-f8c7-44fa-8e8a-305b0dd15f55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 12:06:53
3568	9d5108de-fa48-4f5a-a2d6-09a9d5a3207a	9d5108de-fb51-4bc5-818d-107a72d7af80	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":433,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:01:07
15516	9d5edf72-f437-4f98-8ab7-b93f2a2b162b	9d5edf72-f8c7-44fa-8e8a-305b0dd15f55	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"42.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-10-30 12:06:53
15517	9d5edf72-f785-4bc5-8409-af296bb25304	9d5edf72-f8c7-44fa-8e8a-305b0dd15f55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 12:06:53
15676	9d64900b-dd6e-4132-a7b5-204b30ded496	9d64900b-e1d7-4a78-8b24-547fc76e1c53	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"40.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-02 07:59:49
7148	9d52dad5-8ebc-46b6-955d-aa7f1e1a10cc	9d52dad5-d68b-443b-a3fc-3c27a462c67d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-10-24 12:44:03
3355	9d510493-b914-4eba-9862-2f24f98e2d9c	9d510493-d9a2-49a2-8934-ee2ffb2b24ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-23 14:49:07
3224	9d510390-e0d3-43a5-857c-84d13b9d489a	9d510390-ff7c-453a-ba15-d457fc99d069	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 14:46:17
3225	9d510390-fdc0-4e5a-af08-f14723a01fd4	9d510390-ff7c-453a-ba15-d457fc99d069	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 14:46:17
3226	9d510390-fe51-46c0-a6c3-cc319b008ed5	9d510390-ff7c-453a-ba15-d457fc99d069	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:46:17
3356	9d510493-d3c4-480f-8497-0d7311765074	9d510493-d9a2-49a2-8934-ee2ffb2b24ae	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:49:07
3357	9d510493-d43b-4218-b102-c8bab5b50c65	9d510493-d9a2-49a2-8934-ee2ffb2b24ae	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:49:07
3358	9d510493-d89f-44c5-a7a4-ae67b43d8eb2	9d510493-d9a2-49a2-8934-ee2ffb2b24ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-10-23 14:49:07
3569	9d5108df-9bdb-44ba-893f-ce0309e45c23	9d5108df-e616-4798-930e-5b7c9ea41a44	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 15:01:07
3359	9d510493-d8e3-4622-9358-e16427eb0fce	9d510493-d9a2-49a2-8934-ee2ffb2b24ae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":255,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:49:07
3570	9d5108df-d9f5-4e7d-a2e5-e01d59160318	9d5108df-e616-4798-930e-5b7c9ea41a44	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"100.95","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 15:01:07
3571	9d5108df-da85-471c-ab6a-e9f0b528ea4f	9d5108df-e616-4798-930e-5b7c9ea41a44	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 15:01:08
3572	9d5108df-e31c-4b50-8832-4c47458015d2	9d5108df-e616-4798-930e-5b7c9ea41a44	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 15:01:08
3573	9d5108df-e3e1-4633-b0e9-3eb797da7061	9d5108df-e616-4798-930e-5b7c9ea41a44	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":581,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:01:08
7149	9d52dad5-d1b1-40d3-8daa-a7c7418f1829	9d52dad5-d68b-443b-a3fc-3c27a462c67d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"149.69","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:44:03
7150	9d52dad5-d1f7-477a-8679-191ed98a91b6	9d52dad5-d68b-443b-a3fc-3c27a462c67d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:44:03
7151	9d52dad5-d551-43ee-9c68-cbb75213dbc8	9d52dad5-d68b-443b-a3fc-3c27a462c67d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-10-24 12:44:03
7152	9d52dad5-d594-4305-84c1-f96c98918bea	9d52dad5-d68b-443b-a3fc-3c27a462c67d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":442,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:44:03
3227	9d510391-48ce-4543-a8c1-829d5a168b32	9d510391-90d1-47aa-8ab8-a14b8ab17c07	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 14:46:17
3228	9d510391-8bc9-47c8-9731-166539358db3	9d510391-90d1-47aa-8ab8-a14b8ab17c07	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"145.16","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:46:17
3229	9d510391-8c34-40c6-983a-4af855c56b49	9d510391-90d1-47aa-8ab8-a14b8ab17c07	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:46:17
3230	9d510391-8fbe-4dff-973f-48c495a54bc8	9d510391-90d1-47aa-8ab8-a14b8ab17c07	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 14:46:17
3231	9d510391-8ffe-4463-9342-e73296be2be0	9d510391-90d1-47aa-8ab8-a14b8ab17c07	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":351,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:46:17
3360	9d510494-2599-4d81-9e9f-40da874be2ae	9d510494-72f2-497e-a8bb-eb23e253cf72	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-10-23 14:49:07
3361	9d510494-6d96-46bd-8950-72387f086c41	9d510494-72f2-497e-a8bb-eb23e253cf72	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"157.63","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:49:07
3362	9d510494-6dfc-4288-9639-573690809971	9d510494-72f2-497e-a8bb-eb23e253cf72	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:49:07
3363	9d510494-7193-40fc-8255-37644332139f	9d510494-72f2-497e-a8bb-eb23e253cf72	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-10-23 14:49:07
3364	9d510494-71eb-4397-a1a8-986954b4a05b	9d510494-72f2-497e-a8bb-eb23e253cf72	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":379,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:49:07
15677	9d64900b-e072-4d15-b0dd-025673f0b852	9d64900b-e1d7-4a78-8b24-547fc76e1c53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 07:59:49
3574	9d5108e0-8faa-44dc-be86-dcb488d40f21	9d5108e0-c75c-4f9a-ad4c-673c7908b7a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 15:01:08
3575	9d5108e0-bcfb-4a9c-bd9a-a02fe7a9dd59	9d5108e0-c75c-4f9a-ad4c-673c7908b7a7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"83.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 15:01:08
3576	9d5108e0-bd8f-4bb3-8b81-c33d5347187c	9d5108e0-c75c-4f9a-ad4c-673c7908b7a7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 15:01:08
3577	9d5108e0-c557-433e-88df-f3f75cb67ccd	9d5108e0-c75c-4f9a-ad4c-673c7908b7a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 15:01:08
3578	9d5108e0-c5d6-43fe-852b-d1bca2a9fed0	9d5108e0-c75c-4f9a-ad4c-673c7908b7a7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":550,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:01:08
3232	9d510391-d71c-4c2b-8390-333b4f4ee30d	9d510392-1d51-43e8-8c26-be7e0617b71f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 14:46:18
3233	9d510392-17c3-4d6f-8b1f-a9a4074edcfd	9d510392-1d51-43e8-8c26-be7e0617b71f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"142.09","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:46:18
3234	9d510392-1816-4b26-aaec-9d838a62a3e6	9d510392-1d51-43e8-8c26-be7e0617b71f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:46:18
1879	9d50e014-5f8d-4009-baad-188f41cb219d	9d50e014-7d0c-405d-a2f1-f59073a445da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 13:07:03
1880	9d50e014-7b5a-44c7-b041-8cb620131260	9d50e014-7d0c-405d-a2f1-f59073a445da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 13:07:03
1881	9d50e014-7bef-4e28-bbf6-fdcfb1b0be81	9d50e014-7d0c-405d-a2f1-f59073a445da	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:07:03
1965	9d50e23b-b952-41f6-b211-3000b24ce82f	9d50e23b-bc99-432a-96b2-7678097f84ec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":181,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:13:05
3235	9d510392-1bf1-40c1-8417-030ffad19871	9d510392-1d51-43e8-8c26-be7e0617b71f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 14:46:18
3236	9d510392-1c55-4ef6-b498-788a02f682b5	9d510392-1d51-43e8-8c26-be7e0617b71f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":341,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:46:18
13838	9d5d11c6-7f72-41d3-9aae-0576cc06116b	9d5d11c6-8345-4af9-aff9-61da9e5fb8e9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":180,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:35:57
3466	9d5106d3-31e5-4dc8-9d54-cd6f3d3be0be	9d5106d3-8c41-46b5-b69a-7fd204c50c53	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 14:55:24
3467	9d5106d3-8962-454c-94b8-6053d133dadc	9d5106d3-8c41-46b5-b69a-7fd204c50c53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:55:24
3468	9d5106d3-8a94-4e25-8292-30c46c89dbfd	9d5106d3-8c41-46b5-b69a-7fd204c50c53	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":473,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:55:24
14689	9d5ec0f7-e667-46ef-a6df-ca2152b70c44	9d5ec0f7-e958-4e90-8f61-028171fa1d6b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":150,"memory":20,"hostname":"EderCortes"}	2024-10-30 10:41:39
3579	9d5108e7-c6e1-4bf3-bb1e-296f916307fa	9d5108e8-18da-46a6-90cf-29e9ef18a88e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 15:01:13
3580	9d5108e8-0b97-4aaf-a97e-832052011ca6	9d5108e8-18da-46a6-90cf-29e9ef18a88e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"135.70","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:01:13
3581	9d5108e8-0c1e-4198-a59f-1f5305ea6a23	9d5108e8-18da-46a6-90cf-29e9ef18a88e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 15:01:13
3582	9d5108e8-1654-4c69-b1e4-d0a1bb930412	9d5108e8-18da-46a6-90cf-29e9ef18a88e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 15:01:13
20794	9d66fc26-8bf3-48ec-b265-cff43002b807	9d66fc26-8ef1-4488-a473-0f20fde0a1e4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":172,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:53:46
1882	9d50e014-db5a-4220-870b-0d88be5b4de2	9d50e015-0379-4b2d-9af8-f7f060a9bf51	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 13:07:04
1883	9d50e014-fc04-4e25-b685-db9e7ebc3d3e	9d50e015-0379-4b2d-9af8-f7f060a9bf51	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"54.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:07:04
1884	9d50e014-fc7a-4078-9113-a31d548fcc63	9d50e015-0379-4b2d-9af8-f7f060a9bf51	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 13:07:04
1885	9d50e015-0219-481c-811a-1f2491c8434f	9d50e015-0379-4b2d-9af8-f7f060a9bf51	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 13:07:04
1886	9d50e015-0277-4ae2-899a-2d6ba897a2d4	9d50e015-0379-4b2d-9af8-f7f060a9bf51	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:07:04
3469	9d5106d3-ee9d-4b89-9006-d951ed244fbe	9d5106d4-11a5-4c2f-a9b6-7ddbcb58ab77	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:55:24
3470	9d5106d4-0bfb-46e7-8e6f-fecdb7f3cd9a	9d5106d4-11a5-4c2f-a9b6-7ddbcb58ab77	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:55:24
3471	9d5106d4-0c5a-4f27-92d6-5527be20448d	9d5106d4-11a5-4c2f-a9b6-7ddbcb58ab77	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:55:24
3472	9d5106d4-1091-4539-921c-b5546985be22	9d5106d4-11a5-4c2f-a9b6-7ddbcb58ab77	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:55:24
3473	9d5106d4-10d6-453b-97f1-f478539b1125	9d5106d4-11a5-4c2f-a9b6-7ddbcb58ab77	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":316,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:55:24
14690	9d5ec0f8-3b6a-462d-95a0-14f7ce5e1e8a	9d5ec0f8-3e30-4307-89b4-b880abe70e6c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":143,"memory":20,"hostname":"EderCortes"}	2024-10-30 10:41:39
15518	9d5edf72-f7dd-43a2-9f3e-0421217d47a5	9d5edf72-f8c7-44fa-8e8a-305b0dd15f55	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":310,"memory":22,"hostname":"EderCortes"}	2024-10-30 12:06:53
16501	9d64cd75-0cdd-4456-b63e-8c45433a7d4f	9d64cd75-11d8-4413-a3e1-443094b7d9d1	bc389897f2b737862c250c2eb230953a	t	exception	{"class":"ArgumentCountError","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":317,"message":"DateTime::createFromFormat() expects at least 2 arguments, 1 given","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":317},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"308":"     * Remove the specified resource from storage.","309":"     *\\/","310":"    public function destroy(string $id)","311":"    {","312":"        \\/\\/","313":"    }","314":"","315":"    public function payCuota(Request $request)","316":"    {","317":"        $fechaInicio = DateTime::createFromFormat('d-m-Y');","318":"        return response()->json([","319":"            \\"result\\" => $fechaInicio","320":"        ]);","321":"    }","322":"","323":"    public function payInterese(Request $request)","324":"    {","325":"","326":"    }","327":""},"hostname":"EderCortes","occurrences":1}	2024-11-02 10:51:32
16502	9d64cd74-ff90-4a96-b528-0e7463869422	9d64cd75-11d8-4413-a3e1-443094b7d9d1	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 10:51:32
1887	9d50e015-4ce8-46ca-8106-7afdb7e9657e	9d50e015-9564-4f24-bcb6-8e63dc49499d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 13:07:04
1888	9d50e015-907c-4203-be42-40ad26e2fe55	9d50e015-9564-4f24-bcb6-8e63dc49499d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"150.30","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:07:04
1889	9d50e015-90c7-4a62-a570-3d1aa23f865b	9d50e015-9564-4f24-bcb6-8e63dc49499d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 13:07:04
1890	9d50e015-93ff-41e8-92a9-a8f82a077ee3	9d50e015-9564-4f24-bcb6-8e63dc49499d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 13:07:04
1891	9d50e015-9443-49ba-a373-ddaed950f084	9d50e015-9564-4f24-bcb6-8e63dc49499d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:07:04
3474	9d5106d4-62d4-4b77-8e25-e72fba8cd23f	9d5106d4-85c0-40ac-aaf1-e3c7c19516a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:55:24
3475	9d5106d4-80de-4730-bf86-c88087bf525d	9d5106d4-85c0-40ac-aaf1-e3c7c19516a7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:55:25
3476	9d5106d4-8127-4579-ab5f-a8bd43614958	9d5106d4-85c0-40ac-aaf1-e3c7c19516a7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:55:25
3477	9d5106d4-84b1-4da8-90ad-d90002ff760c	9d5106d4-85c0-40ac-aaf1-e3c7c19516a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:55:25
3478	9d5106d4-84f1-4093-a452-07a4df21c714	9d5106d4-85c0-40ac-aaf1-e3c7c19516a7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":281,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:55:25
13843	9d5d11d0-f668-43cc-ac62-6d588afc294a	9d5d11d0-fa9a-497f-91df-e1301583eeb4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":201,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:36:04
14691	9d5ec0f8-9219-4ede-9bfc-6e51ff4b1b56	9d5ec0f8-ed23-498f-b904-3d0fb341f389	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 10:41:40
14692	9d5ec0f8-e8b0-40da-9b30-918638347acc	9d5ec0f8-ed23-498f-b904-3d0fb341f389	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"172.15","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-30 10:41:40
14693	9d5ec0f8-ec01-4527-8d9d-8fe426238862	9d5ec0f8-ed23-498f-b904-3d0fb341f389	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-30 10:41:40
15519	9d5edf73-3cd5-4990-be53-f11da9849fe9	9d5edf74-2dc3-483c-a1a5-13b458badbf6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 12:06:53
15520	9d5edf74-125d-4b40-8fce-d8b1604a34fc	9d5edf74-2dc3-483c-a1a5-13b458badbf6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 12:06:54
15521	9d5edf74-12a6-4c1a-bea8-2d9c2d63a64c	9d5edf74-2dc3-483c-a1a5-13b458badbf6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-30 12:06:54
14694	9d5ec0f8-ec42-467e-b73f-dd3775777fe5	9d5ec0f8-ed23-498f-b904-3d0fb341f389	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":385,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:41:40
3583	9d5108e8-16e7-465d-9fac-09140e520f3b	9d5108e8-18da-46a6-90cf-29e9ef18a88e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":450,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:01:13
15522	9d5edf74-2ca2-4e5c-a865-4fd944d24105	9d5edf74-2dc3-483c-a1a5-13b458badbf6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 12:06:54
1356	9d50cd0b-b481-4c46-858d-2ad097fab2fb	9d50cd0c-040f-4571-8bde-446ac6a2cd29	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 12:13:50
1357	9d50cd0c-0260-4bc0-9500-727d6bc412dc	9d50cd0c-040f-4571-8bde-446ac6a2cd29	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 12:13:50
1358	9d50cd0c-0309-48e1-bdd5-2cb291bda41a	9d50cd0c-040f-4571-8bde-446ac6a2cd29	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":467,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:13:50
15523	9d5edf74-2ce9-4cb9-aee5-e33f98427677	9d5edf74-2dc3-483c-a1a5-13b458badbf6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":778,"memory":22,"hostname":"EderCortes"}	2024-10-30 12:06:54
15678	9d64900b-e0cc-467e-be30-ace8a869910c	9d64900b-e1d7-4a78-8b24-547fc76e1c53	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-11-02 07:59:49
1571	9d50d7ac-97d3-4878-8336-84b39827e929	9d50d7ac-f641-4bc9-95b9-28d85cdc799d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 12:43:33
16503	9d64cd75-0edb-4c47-9b3e-93bec54a4af1	9d64cd75-11d8-4413-a3e1-443094b7d9d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 10:51:32
16964	9d654665-0d76-4d2c-ab40-920c41a91595	9d654665-0e86-49e8-935d-32aa0606a0f5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:29:42
15524	9d5edf74-6fc2-4ea7-aa5f-ff9846ecd713	9d5edf74-8e6f-45df-8711-1d605647eced	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 12:06:54
1710	9d50dd60-7053-4005-9687-ff86412b412b	9d50dd60-bfea-4078-b90c-3818cf2fe59d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 12:59:30
1711	9d50dd60-bdfd-4371-bcd1-3e38122e76cf	9d50dd60-bfea-4078-b90c-3818cf2fe59d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:59:30
1712	9d50dd60-bec1-42a5-b9c4-94bd325a0bde	9d50dd60-bfea-4078-b90c-3818cf2fe59d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":433,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:59:30
1572	9d50d7ac-f2e4-4ec5-97c4-8229b1eab2bb	9d50d7ac-f641-4bc9-95b9-28d85cdc799d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:43:33
1573	9d50d7ac-f432-4dac-99e1-ec3325ac960b	9d50d7ac-f641-4bc9-95b9-28d85cdc799d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":550,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:43:33
2289	9d50e6cd-ed44-461b-ac76-790c317c049a	9d50e6ce-3654-493a-9b06-f2d9fd4d5158	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 13:25:52
2290	9d50e6ce-34d5-4fda-8a34-3ccbea5e4206	9d50e6ce-3654-493a-9b06-f2d9fd4d5158	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 13:25:52
1892	9d50e016-cb1a-4331-bfcb-dc4ad0f7fa04	9d50e016-f34f-4b94-9d38-64098cb34ec8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 13:07:05
2291	9d50e6ce-3561-404c-b898-017308552fab	9d50e6ce-3654-493a-9b06-f2d9fd4d5158	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:25:52
1893	9d50e016-ee06-4ebb-b2fe-7adcae346296	9d50e016-f34f-4b94-9d38-64098cb34ec8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"53.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 13:07:05
1894	9d50e016-ee62-4a74-b9ec-0a202f785dad	9d50e016-f34f-4b94-9d38-64098cb34ec8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 13:07:05
1895	9d50e016-f200-4dc5-8afd-2aa75b131d16	9d50e016-f34f-4b94-9d38-64098cb34ec8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 13:07:05
15525	9d5edf74-8936-41da-92f1-bf74fec2a905	9d5edf74-8e6f-45df-8711-1d605647eced	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 12:06:54
14695	9d5ec0f9-2dec-4851-a247-e81c4f53bd52	9d5ec0f9-30f6-42d4-bd5b-d52b722e0938	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":146,"memory":20,"hostname":"EderCortes"}	2024-10-30 10:41:40
15526	9d5edf74-8989-4b58-9c1b-fa6446a1897a	9d5edf74-8e6f-45df-8711-1d605647eced	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-30 12:06:54
15527	9d5edf74-8d1e-440c-a19b-2d61d0f3207d	9d5edf74-8e6f-45df-8711-1d605647eced	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-30 12:06:54
15528	9d5edf74-8d78-4a18-a1f4-882e582b8d0d	9d5edf74-8e6f-45df-8711-1d605647eced	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-10-30 12:06:54
15679	9d64902d-a0a2-4af0-ad12-ad967587e644	9d64902d-be83-42bc-a68e-8e75c9b6fce6	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 08:00:12
15680	9d64902d-b967-436d-99bd-7be0adc507b4	9d64902d-be83-42bc-a68e-8e75c9b6fce6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"40.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-02 08:00:12
15681	9d64902d-bcfa-490b-a7ee-e3a5b8aad336	9d64902d-be83-42bc-a68e-8e75c9b6fce6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 08:00:12
16823	9d64d6ef-6d98-4022-aba7-0ce2ac90554d	9d64d6ef-b7a4-449a-93d7-77fa761487e9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-02 11:18:03
1713	9d50dd61-14ab-43f5-b4a6-a7e522330bba	9d50dd61-33b7-4eef-9afb-c487ae74d018	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:59:30
1714	9d50dd61-2e0a-450f-b947-1cd37a84fc07	9d50dd61-33b7-4eef-9afb-c487ae74d018	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":65,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:59:30
1715	9d50dd61-2e56-493f-a2c7-f2c220c804ac	9d50dd61-33b7-4eef-9afb-c487ae74d018	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 12:59:30
1716	9d50dd61-327b-44e7-bf2b-ec7a098fda68	9d50dd61-33b7-4eef-9afb-c487ae74d018	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:59:30
1574	9d50d7ad-6361-41cd-87c0-17fea4144c2e	9d50d7ad-8a4d-47b1-92d3-bddfb1377134	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:43:34
1575	9d50d7ad-830c-42ac-a986-85ccce330a94	9d50d7ad-8a4d-47b1-92d3-bddfb1377134	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"50.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":65,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:43:34
1576	9d50d7ad-8375-463c-90b2-2df35a1ad46b	9d50d7ad-8a4d-47b1-92d3-bddfb1377134	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 12:43:34
1577	9d50d7ad-88cf-45d9-94b2-db9fea7d704a	9d50d7ad-8a4d-47b1-92d3-bddfb1377134	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:43:34
1578	9d50d7ad-892d-4b83-af60-5e48c951e54d	9d50d7ad-8a4d-47b1-92d3-bddfb1377134	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":350,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:43:34
1717	9d50dd61-32c0-448d-a349-b764dfe553f9	9d50dd61-33b7-4eef-9afb-c487ae74d018	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":274,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:59:30
1896	9d50e016-f247-44df-9cde-3283c9d6db6f	9d50e016-f34f-4b94-9d38-64098cb34ec8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":401,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:07:05
2292	9d50e6ce-77b3-4e0b-9dc9-5d5501c1990e	9d50e6ce-957f-4dae-84ff-cbe8c05cbf49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 13:25:52
2293	9d50e6ce-9086-47e5-ab6b-c421fbc8c68b	9d50e6ce-957f-4dae-84ff-cbe8c05cbf49	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:25:52
2294	9d50e6ce-90d3-4b50-8a86-2acf257faf64	9d50e6ce-957f-4dae-84ff-cbe8c05cbf49	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 13:25:52
2295	9d50e6ce-9455-4a89-a9fe-60586236d8cc	9d50e6ce-957f-4dae-84ff-cbe8c05cbf49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 13:25:52
2296	9d50e6ce-949a-4171-844a-c50005bf707c	9d50e6ce-957f-4dae-84ff-cbe8c05cbf49	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":222,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:25:52
2529	9d50fa2a-728b-4774-8465-dff3887c5e12	9d50fa2a-9302-4ea9-8dd1-6f696e82308a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:20:00
1718	9d50dd61-79e9-4f09-a2fe-b36146c505c8	9d50dd61-9ac1-43ef-936b-94edac82e89e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:59:30
1719	9d50dd61-9480-4ed7-a89a-23709e00f935	9d50dd61-9ac1-43ef-936b-94edac82e89e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":65,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:59:31
1720	9d50dd61-94f4-4e59-9df6-a019b5aab3db	9d50dd61-9ac1-43ef-936b-94edac82e89e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 12:59:31
1721	9d50dd61-9984-47f7-bed3-8dc0164d9a76	9d50dd61-9ac1-43ef-936b-94edac82e89e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:59:31
1579	9d50d7ad-de34-486c-a552-70ef56f92faf	9d50d7ae-2f9b-4851-b788-d19c9bb99256	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:43:34
1580	9d50d7ae-296a-4f1f-997b-dff284afeb0e	9d50d7ae-2f9b-4851-b788-d19c9bb99256	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"165.48","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":65,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:43:34
1581	9d50d7ae-29ca-45d6-9ae9-e6be2fd63ca6	9d50d7ae-2f9b-4851-b788-d19c9bb99256	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 12:43:34
1582	9d50d7ae-2e3e-4c01-bc05-c9742cb52121	9d50d7ae-2f9b-4851-b788-d19c9bb99256	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:43:34
1583	9d50d7ae-2e93-41b7-8a95-e3f8e9a86bf7	9d50d7ae-2f9b-4851-b788-d19c9bb99256	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":402,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:43:34
1722	9d50dd61-99cc-46a3-9046-2d58850f8975	9d50dd61-9ac1-43ef-936b-94edac82e89e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:59:31
1897	9d50e01b-ea63-4dcf-8dc9-4097c8485534	9d50e01b-ed1c-44a8-8e7c-acb1efd12f59	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":162,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:07:08
2297	9d50e6ce-d9e1-450a-bd56-256f53f3e646	9d50e6ce-f8a9-47b0-9f34-1eabba79b128	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 13:25:52
2298	9d50e6ce-f3cf-43d6-8a59-259a54eea7ac	9d50e6ce-f8a9-47b0-9f34-1eabba79b128	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:25:52
2299	9d50e6ce-f41b-4003-a998-cb18dc7a3ee4	9d50e6ce-f8a9-47b0-9f34-1eabba79b128	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 13:25:52
2300	9d50e6ce-f773-404b-b663-5a096056c881	9d50e6ce-f8a9-47b0-9f34-1eabba79b128	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 13:25:52
2530	9d50fa2a-8dca-4d15-84c7-7001d634d214	9d50fa2a-9302-4ea9-8dd1-6f696e82308a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:20:00
2531	9d50fa2a-8e27-4537-8cdb-72fb74eea602	9d50fa2a-9302-4ea9-8dd1-6f696e82308a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:20:00
2532	9d50fa2a-91f7-4966-b409-8d500791cc5e	9d50fa2a-9302-4ea9-8dd1-6f696e82308a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 14:20:00
1723	9d50dd63-261a-402e-85c2-ac6a7bd4796f	9d50dd63-4922-49b0-ae7a-637e728bb32b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:59:32
1724	9d50dd63-4229-4c57-9a0a-5c52ededd67a	9d50dd63-4922-49b0-ae7a-637e728bb32b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"49.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 12:59:32
1725	9d50dd63-428d-4ea6-a81d-9291a5ec475e	9d50dd63-4922-49b0-ae7a-637e728bb32b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 12:59:32
1726	9d50dd63-47a2-4575-af36-f55b34816eb1	9d50dd63-4922-49b0-ae7a-637e728bb32b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 12:59:32
1584	9d50d7af-da54-4ea2-99ee-1c8fc90e952f	9d50d7af-f9e1-46db-b681-0b4fdd1a689d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:43:35
1585	9d50d7af-f469-4ce5-bf6e-eb7c369128fc	9d50d7af-f9e1-46db-b681-0b4fdd1a689d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"46.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 12:43:35
1586	9d50d7af-f4dd-4531-8df0-424c3f7d850a	9d50d7af-f9e1-46db-b681-0b4fdd1a689d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 12:43:35
1587	9d50d7af-f873-4bb2-a237-c1da78af8e85	9d50d7af-f9e1-46db-b681-0b4fdd1a689d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 12:43:35
1588	9d50d7af-f8be-4083-977f-a3ac389c0871	9d50d7af-f9e1-46db-b681-0b4fdd1a689d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:43:35
1727	9d50dd63-4806-4f19-9c80-c7236d473d98	9d50dd63-4922-49b0-ae7a-637e728bb32b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":295,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:59:32
1898	9d50e01c-4589-4beb-977d-8639234d5a64	9d50e01c-88d0-43b8-b013-74535ef63a74	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 13:07:08
1899	9d50e01c-849e-4838-8987-979adbb7cbad	9d50e01c-88d0-43b8-b013-74535ef63a74	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, ' ', (users.user_document)) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"146.34","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"8e8d2f1f6030d01848bc971840ab08d0","hostname":"EderCortes"}	2024-10-23 13:07:09
1900	9d50e01c-87b0-4cfa-804d-01e4bc0f225f	9d50e01c-88d0-43b8-b013-74535ef63a74	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 13:07:09
1901	9d50e01c-87f4-43b5-b957-c258c62acdc4	9d50e01c-88d0-43b8-b013-74535ef63a74	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley 1004608333"},{"id":14,"name_customer":"Luis andre 100465545"}]},"duration":304,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:07:09
3317	9d510480-f385-4729-9ffa-57eb6553d389	9d510481-13f1-4894-8624-71b6a2fa81b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 14:48:54
15529	9d5edf74-d76d-4491-988d-b868fac73feb	9d5edf75-1d59-4111-b69c-5de77e26bc46	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-30 12:06:54
1902	9d50e026-3ca2-40bc-949e-fb0e561c4f24	9d50e026-4034-467a-b81d-ab2d3830b263	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":163,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:07:15
2301	9d50e6ce-f7b8-44c7-bb00-52dd213e1cd0	9d50e6ce-f8a9-47b0-9f34-1eabba79b128	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:25:52
14696	9d5ec0f9-ad47-4b44-a872-9bcf4cb300d1	9d5ec0f9-b08a-49fa-92e5-fd3a860b80e0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":145,"memory":20,"hostname":"EderCortes"}	2024-10-30 10:41:40
15530	9d5edf75-18aa-4dab-950e-63a76894fca4	9d5edf75-1d59-4111-b69c-5de77e26bc46	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"150.05","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":24,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-30 12:06:54
1732	9d50dd7d-e165-4529-825a-97e1680b8c1a	9d50dd7d-ff0e-4208-be64-13a626e4d4fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 12:59:49
2533	9d50fa2a-9236-4c65-9b2c-918dc9a4f841	9d50fa2a-9302-4ea9-8dd1-6f696e82308a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":265,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:20:00
3318	9d510481-0eac-4978-8f1d-3f36b066af1c	9d510481-13f1-4894-8624-71b6a2fa81b6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:48:54
3319	9d510481-0f09-4d70-bb48-11890f9aabff	9d510481-13f1-4894-8624-71b6a2fa81b6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:48:54
3320	9d510481-12cf-498d-94b8-788720bad11c	9d510481-13f1-4894-8624-71b6a2fa81b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 14:48:54
3321	9d510481-1314-43ca-b944-1f3d61ab2ee2	9d510481-13f1-4894-8624-71b6a2fa81b6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:48:54
15531	9d5edf75-1bb7-428d-b987-53df9730c074	9d5edf75-1d59-4111-b69c-5de77e26bc46	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-30 12:06:54
1903	9d50e026-fb78-43e9-b0e7-9ad9797c79a7	9d50e027-1622-465b-8012-9f34da624585	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 13:07:15
1904	9d50e027-11fe-411a-a388-403d78b20a5c	9d50e027-1622-465b-8012-9f34da624585	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, ' ', (users.user_document)) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%1004%' or \\"users\\".\\"user_document\\"::text like '%1004%' order by \\"users\\".\\"user_document\\" asc","time":"42.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"8e8d2f1f6030d01848bc971840ab08d0","hostname":"EderCortes"}	2024-10-23 13:07:16
1905	9d50e027-1501-4c8f-8712-ac4017d8dd88	9d50e027-1622-465b-8012-9f34da624585	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 13:07:16
1906	9d50e027-1542-42fe-a8b5-3576beb02a4e	9d50e027-1622-465b-8012-9f34da624585	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"1004"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley 1004608333"},{"id":14,"name_customer":"Luis andre 100465545"},{"id":18,"name_customer":"Maria Antonieta 100465546"},{"id":19,"name_customer":"Maria Antonieta 2 1004655468"}]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:07:16
1733	9d50dd7d-fa26-4e51-877f-6db0528060ce	9d50dd7d-ff0e-4208-be64-13a626e4d4fc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":65,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:59:49
1734	9d50dd7d-fa87-4aab-9906-046242f4bb95	9d50dd7d-ff0e-4208-be64-13a626e4d4fc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 12:59:49
2302	9d50e6d0-3ee7-41cd-852f-c2ffb7bb7754	9d50e6d0-91de-4848-bb01-cef53289e0a9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 13:25:53
2303	9d50e6d0-8ca1-4c25-ab81-0ead84e3d04d	9d50e6d0-91de-4848-bb01-cef53289e0a9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"161.43","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 13:25:53
2304	9d50e6d0-8cee-4102-b20c-77f161dcde00	9d50e6d0-91de-4848-bb01-cef53289e0a9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 13:25:53
2305	9d50e6d0-9081-4d74-83b6-7e4ef7b99c9b	9d50e6d0-91de-4848-bb01-cef53289e0a9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 13:25:53
2306	9d50e6d0-90cb-486f-8a3a-02102267c2eb	9d50e6d0-91de-4848-bb01-cef53289e0a9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":596,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:25:53
3322	9d510481-5e62-4f9b-a666-6b44888827d7	9d510481-81ef-49b8-b55e-c77a61cd918c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 14:48:54
2534	9d50fa2a-d553-4eb6-853c-e3d4d43233e2	9d50fa2a-f5c9-47ea-81de-4fe40903ca74	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 14:20:00
2535	9d50fa2a-f06a-464a-ab51-138174167fa1	9d50fa2a-f5c9-47ea-81de-4fe40903ca74	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:20:00
2536	9d50fa2a-f0b3-4cf4-8baa-e93ac9021c89	9d50fa2a-f5c9-47ea-81de-4fe40903ca74	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:20:00
2537	9d50fa2a-f499-465d-b681-ee0da124b055	9d50fa2a-f5c9-47ea-81de-4fe40903ca74	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 14:20:00
3323	9d510481-7c38-4fbc-ab36-8392f745367e	9d510481-81ef-49b8-b55e-c77a61cd918c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:48:55
3324	9d510481-7c86-454b-8a62-3a4202e455c3	9d510481-81ef-49b8-b55e-c77a61cd918c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:48:55
3325	9d510481-800e-42fd-abdb-ef49dd13b906	9d510481-81ef-49b8-b55e-c77a61cd918c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 14:48:55
14697	9d5ec0fa-054d-458a-8a60-b16ef69e840f	9d5ec0fa-2079-4c16-82b5-64858f339917	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-30 10:41:40
14698	9d5ec0fa-1c3c-4e16-a407-9d55e771847c	9d5ec0fa-2079-4c16-82b5-64858f339917	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"41.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-30 10:41:41
14699	9d5ec0fa-1f60-4197-be4b-08d52f13e281	9d5ec0fa-2079-4c16-82b5-64858f339917	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-30 10:41:41
2427	9d50e7ba-98ce-4ae3-97ff-6ca3e0754819	9d50e7ba-de46-40ee-8a12-69fc0183d967	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 13:28:27
1471	9d50d295-eb92-43d7-b96f-6c9cd66f0236	9d50d296-4900-438a-a6aa-0c2c7f187d6c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 12:29:19
1472	9d50d296-46ec-46fa-89d8-a78376a69212	9d50d296-4900-438a-a6aa-0c2c7f187d6c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 12:29:20
1473	9d50d296-47cd-4637-b560-edec7d83f35b	9d50d296-4900-438a-a6aa-0c2c7f187d6c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":498,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:29:20
2428	9d50e7ba-dcb8-4fce-b82b-57c0585ce461	9d50e7ba-de46-40ee-8a12-69fc0183d967	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 13:28:27
2429	9d50e7ba-dd4d-4e02-b98a-fc3f7ade34a0	9d50e7ba-de46-40ee-8a12-69fc0183d967	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":353,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:28:27
1735	9d50dd7d-fdf8-4aa9-9a7f-74240e5700e5	9d50dd7d-ff0e-4208-be64-13a626e4d4fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 12:59:49
14700	9d5ec0fa-1fa1-4507-9589-cec229cfbd2f	9d5ec0fa-2079-4c16-82b5-64858f339917	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:41:41
15532	9d5edf75-1c2d-457f-b9d7-fe6c19afbc91	9d5edf75-1d59-4111-b69c-5de77e26bc46	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":346,"memory":22,"hostname":"EderCortes"}	2024-10-30 12:06:54
15682	9d64902d-bd63-4dc4-8208-cfa5dc49c07f	9d64902d-be83-42bc-a68e-8e75c9b6fce6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":308,"memory":22,"hostname":"EderCortes"}	2024-11-02 08:00:12
16504	9d64cd75-0fe8-4ed4-95d1-b53cd8afab0a	9d64cd75-11d8-4413-a3e1-443094b7d9d1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"157","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000","id":187,"loans_codigo":62,"item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":500,"response":{"message":"DateTime::createFromFormat() expects at least 2 arguments, 1 given","exception":"ArgumentCountError","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":317,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":317,"function":"createFromFormat","class":"DateTime","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"payCuota","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":255,"memory":20,"hostname":"EderCortes"}	2024-11-02 10:51:32
1493	9d50d29f-4e6a-40ac-b2b9-e9b60a94ee90	9d50d29f-4f65-4c4b-b9e6-3f97136054f9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"data"},"session":[],"response_status":500,"response":{"message":"Undefined variable $id","exception":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":29,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255,"function":"handleError","class":"Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":29,"function":"Illuminate\\\\Foundation\\\\Bootstrap\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getCustomerFilters","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":155,"memory":20,"hostname":"EderCortes"}	2024-10-23 12:29:26
1589	9d50d7b8-a971-4387-b796-a7ea232f9df3	9d50d7b8-ad6f-400b-aa2d-73795176ea16	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":175,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:43:41
2430	9d50e7bb-2045-4e1a-b8b1-f9328bfb6916	9d50e7bb-6868-45ee-abfe-ceddd4aea9d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 13:28:27
2431	9d50e7bb-6398-4150-98bf-269c9454f706	9d50e7bb-6868-45ee-abfe-ceddd4aea9d3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"151.47","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:28:27
1736	9d50dd7d-fe39-4a01-a539-b6a1f8066e13	9d50dd7d-ff0e-4208-be64-13a626e4d4fc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:59:49
2159	9d50e4e1-9bb3-47e3-a56c-3c6d8df05118	9d50e4e1-ea76-4bd2-9db6-f4eac012b94b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 13:20:29
2160	9d50e4e1-e3a4-41ed-a40a-39da9a0e706f	9d50e4e1-ea76-4bd2-9db6-f4eac012b94b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"156.82","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:20:29
2161	9d50e4e1-e3ff-4ab3-92bc-e83e424076ac	9d50e4e1-ea76-4bd2-9db6-f4eac012b94b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 13:20:29
2162	9d50e4e1-e8ba-47bd-96cb-f2571e88783e	9d50e4e1-ea76-4bd2-9db6-f4eac012b94b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 13:20:29
2163	9d50e4e1-e925-42e6-aa16-025cf7fc6f1e	9d50e4e1-ea76-4bd2-9db6-f4eac012b94b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":428,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:20:29
2432	9d50e7bb-63ea-4048-ae98-d4f4c2105e83	9d50e7bb-6868-45ee-abfe-ceddd4aea9d3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 13:28:27
2433	9d50e7bb-674f-4f11-871b-da1681bec331	9d50e7bb-6868-45ee-abfe-ceddd4aea9d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 13:28:27
14701	9d5ec0fa-6314-49ad-b081-bed7d4c05d1a	9d5ec0fa-a6cf-439f-b311-f299ca58fc4d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-30 10:41:41
14702	9d5ec0fa-a238-4e81-ba71-038fed516cf8	9d5ec0fa-a6cf-439f-b311-f299ca58fc4d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAr%' or \\"users\\".\\"user_document\\"::text like '%MAr%') order by \\"users\\".\\"user_document\\" asc","time":"146.13","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-30 10:41:41
14703	9d5ec0fa-a551-4de0-990a-29a5e7365f66	9d5ec0fa-a6cf-439f-b311-f299ca58fc4d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-30 10:41:41
2434	9d50e7bb-6792-496c-930c-8e049778b144	9d50e7bb-6868-45ee-abfe-ceddd4aea9d3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:28:27
14704	9d5ec0fa-a5af-4c1e-ad98-a38b8d8f999a	9d5ec0fa-a6cf-439f-b311-f299ca58fc4d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAr"},"session":[],"response_status":200,"response":{"data":[]},"duration":328,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:41:41
3694	9d510989-76cc-45bc-9401-bf0878cf7db5	9d510989-b783-4007-bd9a-4176ce487308	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 15:02:59
3695	9d510989-b4eb-4d55-9614-dc3cebc4aa70	9d510989-b783-4007-bd9a-4176ce487308	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 15:02:59
1598	9d50d7d7-4f37-4a99-a737-bca1a0b991a2	9d50d7d7-6e60-4375-b014-90966d3c5654	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 12:44:01
1737	9d50dd7e-3d9d-4923-8feb-5147b2735c24	9d50dd7e-83d8-4cc7-8197-9efa5e4d3f46	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 12:59:49
2164	9d50e4e2-3bbd-4382-a4d4-8f597e3a6080	9d50e4e2-60d5-4299-b8ae-75e0b0175128	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 13:20:29
2165	9d50e4e2-59d1-4e1a-b550-f31d5310f0e6	9d50e4e2-60d5-4299-b8ae-75e0b0175128	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:20:29
2166	9d50e4e2-5a3e-4f26-9931-cc8147ba101a	9d50e4e2-60d5-4299-b8ae-75e0b0175128	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 13:20:29
2167	9d50e4e2-5f4b-4125-a2ba-e0bd562b7f0c	9d50e4e2-60d5-4299-b8ae-75e0b0175128	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 13:20:29
2168	9d50e4e2-5fba-4468-b78d-efaf4b680d8d	9d50e4e2-60d5-4299-b8ae-75e0b0175128	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":286,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:20:29
3696	9d510989-b617-4277-97e2-ff2f7a2e4352	9d510989-b783-4007-bd9a-4176ce487308	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":397,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:02:59
11971	9d5cd8df-6aaa-48ac-9974-a4e0995f55eb	9d5cd8df-6c5a-474e-a54f-268ea0a34d3a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":693,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:56:50
15533	9d5edf75-6f34-4262-b195-653c98d8f341	9d5edf75-b3f6-41ef-b5e3-2ba5e60e0c9e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-30 12:06:55
15683	9d649039-a0a8-4279-86f2-e686cf01e690	9d649039-c0a6-4e0e-b977-c8a8305c8a62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 08:00:19
15684	9d649039-bbc5-4975-8b76-aac372045429	9d649039-c0a6-4e0e-b977-c8a8305c8a62	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-02 08:00:19
2435	9d50e7bb-a6d8-45fd-9668-b7a86336ad8f	9d50e7bb-c301-4500-88ed-f4bda3160676	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 13:28:27
2436	9d50e7bb-be37-4b72-a7f8-2b5d31232889	9d50e7bb-c301-4500-88ed-f4bda3160676	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"38.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:28:27
2437	9d50e7bb-be85-485b-9323-a6ce056ba046	9d50e7bb-c301-4500-88ed-f4bda3160676	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 13:28:27
1738	9d50dd7e-7ea9-4953-8b86-54d0dcfeab08	9d50dd7e-83d8-4cc7-8197-9efa5e4d3f46	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"147.21","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":65,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:59:49
1599	9d50d7d7-6933-4ccd-89da-337b4792e4de	9d50d7d7-6e60-4375-b014-90966d3c5654	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":65,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 12:44:01
1600	9d50d7d7-698c-4376-a40c-a60d964a3412	9d50d7d7-6e60-4375-b014-90966d3c5654	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 12:44:01
1739	9d50dd7e-7ef2-4a79-931a-f0b7ead74f48	9d50dd7e-83d8-4cc7-8197-9efa5e4d3f46	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 12:59:49
1740	9d50dd7e-8294-42c6-9e38-976ea6f61683	9d50dd7e-83d8-4cc7-8197-9efa5e4d3f46	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 12:59:50
2169	9d50e4e4-0c6b-4270-807a-2b914bd12c7c	9d50e4e4-2a61-44ba-b7ee-fafcbfbd4a60	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 13:20:30
2170	9d50e4e4-2591-486d-ae2c-4c13d66eea72	9d50e4e4-2a61-44ba-b7ee-fafcbfbd4a60	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 13:20:31
2171	9d50e4e4-25dd-433b-964a-0e21fbd1bd47	9d50e4e4-2a61-44ba-b7ee-fafcbfbd4a60	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 13:20:31
2172	9d50e4e4-290c-40d9-b951-3f465b4b91a9	9d50e4e4-2a61-44ba-b7ee-fafcbfbd4a60	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 13:20:31
2173	9d50e4e4-295a-47fe-b53a-dc7e2e962565	9d50e4e4-2a61-44ba-b7ee-fafcbfbd4a60	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:20:31
2438	9d50e7bb-c1dd-4324-8e14-f28a46a74968	9d50e7bb-c301-4500-88ed-f4bda3160676	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 13:28:27
2439	9d50e7bb-c21f-4d1e-9ce9-c949bdffc26c	9d50e7bb-c301-4500-88ed-f4bda3160676	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":218,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:28:27
3697	9d51098a-1f4e-4424-b133-d30b750d3e57	9d51098a-42bd-4123-a476-e4a621fec084	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 15:02:59
3698	9d51098a-3bfd-4e5c-99f3-da1d71181a74	9d51098a-42bd-4123-a476-e4a621fec084	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:02:59
3699	9d51098a-3c5b-4015-a8e7-78ee5ec42dc5	9d51098a-42bd-4123-a476-e4a621fec084	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 15:02:59
3700	9d51098a-414f-4970-bc69-6f3451c42ad1	9d51098a-42bd-4123-a476-e4a621fec084	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 15:02:59
11972	9d5cd8df-df13-42f7-ad15-d6a5a08d163f	9d5cd8e0-09c2-4db8-b817-87c09836976d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 11:56:51
2440	9d50e7bd-443b-4873-a34d-9edd88475716	9d50e7bd-610a-4e19-bba4-a58b198e0e8b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 13:28:28
2441	9d50e7bd-5be3-4ed2-9932-76d742da923c	9d50e7bd-610a-4e19-bba4-a58b198e0e8b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 13:28:28
2442	9d50e7bd-5c43-4849-8e5e-fba765277477	9d50e7bd-610a-4e19-bba4-a58b198e0e8b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 13:28:28
2443	9d50e7bd-5fc2-4515-ac3a-3df267b8043e	9d50e7bd-610a-4e19-bba4-a58b198e0e8b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 13:28:28
1601	9d50d7d7-6cd7-4014-bf75-c9445f59225a	9d50d7d7-6e60-4375-b014-90966d3c5654	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 12:44:01
2444	9d50e7bd-6005-4268-b428-de4837cbe080	9d50e7bd-610a-4e19-bba4-a58b198e0e8b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":287,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:28:28
3701	9d51098a-41d8-4771-a5d4-d4093be2fd45	9d51098a-42bd-4123-a476-e4a621fec084	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":327,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:02:59
14705	9d5ec0fa-ec93-4cde-a42b-a36b830ffb79	9d5ec0fb-08e2-468e-9acf-93e87f9ea339	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-30 10:41:41
14706	9d5ec0fb-041a-401b-9b98-bacdd53c6226	9d5ec0fb-08e2-468e-9acf-93e87f9ea339	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAri%' or \\"users\\".\\"user_document\\"::text like '%MAri%') order by \\"users\\".\\"user_document\\" asc","time":"42.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-30 10:41:41
14707	9d5ec0fb-07a7-4583-9a16-77062cdc9b84	9d5ec0fb-08e2-468e-9acf-93e87f9ea339	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-30 10:41:41
14708	9d5ec0fb-07f4-4c24-b850-fb9839fa009b	9d5ec0fb-08e2-468e-9acf-93e87f9ea339	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAri"},"session":[],"response_status":200,"response":{"data":[]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:41:41
15534	9d5edf75-afb7-4c04-9a0c-5227ee1236a3	9d5edf75-b3f6-41ef-b5e3-2ba5e60e0c9e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"151.87","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-10-30 12:06:55
15535	9d5edf75-b2b7-4804-b935-1f6a38c2924a	9d5edf75-b3f6-41ef-b5e3-2ba5e60e0c9e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-30 12:06:55
15685	9d649039-bc21-4c20-b84d-16b528d68b37	9d649039-c0a6-4e0e-b977-c8a8305c8a62	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-02 08:00:19
15686	9d649039-bf66-4b43-8ab5-ac21d5bcca84	9d649039-c0a6-4e0e-b977-c8a8305c8a62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 08:00:19
2445	9d50f8c6-8a21-4799-9d37-725afb843805	9d50f8ca-abb1-4e55-8b4d-3d3e5ecd51f9	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 14:16:07
2446	9d50f8c9-3d5c-4a75-a39c-2901e5f3b4f1	9d50f8ca-abb1-4e55-8b4d-3d3e5ecd51f9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"244.54","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:16:08
2447	9d50f8c9-4590-41b2-b3ad-c98511c3afb7	9d50f8ca-abb1-4e55-8b4d-3d3e5ecd51f9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:16:08
2448	9d50f8ca-757c-4e5c-9696-d6cfc07a63e2	9d50f8ca-abb1-4e55-8b4d-3d3e5ecd51f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:16:09
2449	9d50f8ca-7bf2-4ac6-9448-d8b19f152901	9d50f8ca-abb1-4e55-8b4d-3d3e5ecd51f9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":18046,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:16:09
3702	9d51098a-921e-4c45-889b-ec9060520276	9d51098a-b5ef-4648-9a39-27061ddf764d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 15:02:59
3703	9d51098a-b060-4e56-9608-94e1c38cf5c5	9d51098a-b5ef-4648-9a39-27061ddf764d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"50.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:02:59
2538	9d50fa2a-f4e4-405e-9d96-8247261ebb07	9d50fa2a-f5c9-47ea-81de-4fe40903ca74	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:20:00
3704	9d51098a-b0b7-401d-b46d-3d0d787c39aa	9d51098a-b5ef-4648-9a39-27061ddf764d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 15:02:59
3705	9d51098a-b4a6-4524-bc14-a141ae01b84a	9d51098a-b5ef-4648-9a39-27061ddf764d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 15:02:59
3706	9d51098a-b4ef-4f46-8cc8-692705d9c823	9d51098a-b5ef-4648-9a39-27061ddf764d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":274,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:02:59
11973	9d5cd8e0-0469-4ee9-b601-f8782e37e469	9d5cd8e0-09c2-4db8-b817-87c09836976d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 11:56:51
11974	9d5cd8e0-04b3-43c5-b078-193f32771fb8	9d5cd8e0-09c2-4db8-b817-87c09836976d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 11:56:51
11975	9d5cd8e0-0804-4eb3-be69-ee3a91d7c651	9d5cd8e0-09c2-4db8-b817-87c09836976d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-29 11:56:51
2578	9d50fad2-6718-4fab-8181-10105e8254f0	9d50fad2-a315-4421-85ab-cc59065fd659	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:21:50
2579	9d50fad2-9f46-4462-a253-af36296b5472	9d50fad2-a315-4421-85ab-cc59065fd659	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:21:50
2580	9d50fad2-a124-4956-af6a-bc47686fab02	9d50fad2-a315-4421-85ab-cc59065fd659	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":585,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:21:50
14709	9d5ec0fb-4c45-4242-ad1c-b509bbc039bb	9d5ec0fb-674a-4dc4-bc84-4adcd0d44a48	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-30 10:41:41
14710	9d5ec0fb-62fe-4e35-9699-f6711acd60c6	9d5ec0fb-674a-4dc4-bc84-4adcd0d44a48	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAria%' or \\"users\\".\\"user_document\\"::text like '%MAria%') order by \\"users\\".\\"user_document\\" asc","time":"41.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-30 10:41:41
3808	9d511a4a-7e77-4351-bf8a-e0a9fdb612c7	9d511a4a-a9d6-4902-8992-1032afc02dd1	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 15:49:50
3809	9d511a4a-a793-4afe-8f23-ab730db206a3	9d511a4a-a9d6-4902-8992-1032afc02dd1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 15:49:50
3810	9d511a4a-a8ac-4fc4-b0c2-90ac8fe9ccf3	9d511a4a-a9d6-4902-8992-1032afc02dd1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":331,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:49:50
14711	9d5ec0fb-65cb-4f2e-af39-d2a7f03d5f9e	9d5ec0fb-674a-4dc4-bc84-4adcd0d44a48	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-30 10:41:41
11976	9d5cd8e0-086c-414c-9362-b6c52d2a2c16	9d5cd8e0-09c2-4db8-b817-87c09836976d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:56:51
14712	9d5ec0fb-6613-4c92-b32a-3370a8937efb	9d5ec0fb-674a-4dc4-bc84-4adcd0d44a48	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAria"},"session":[],"response_status":200,"response":{"data":[]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:41:41
15536	9d5edf75-b310-4d89-ac10-74997f887131	9d5edf75-b3f6-41ef-b5e3-2ba5e60e0c9e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":369,"memory":22,"hostname":"EderCortes"}	2024-10-30 12:06:55
15687	9d649039-bfab-4f34-91ab-11bf3d71fca9	9d649039-c0a6-4e0e-b977-c8a8305c8a62	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-11-02 08:00:19
3811	9d511a4b-0514-4d4a-a34a-b28863fb27d4	9d511a4b-2e95-403e-9f27-f7a56dddce5a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 15:49:50
1595	9d50d7d6-c1e8-46ed-9489-48346cda8374	9d50d7d7-0adf-442a-ab76-8c2eb62cbb06	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 12:44:01
1596	9d50d7d7-0921-4bfe-92c1-f67b6b38e300	9d50d7d7-0adf-442a-ab76-8c2eb62cbb06	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 12:44:01
1597	9d50d7d7-09b9-4394-a859-eba6e50bfaed	9d50d7d7-0adf-442a-ab76-8c2eb62cbb06	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":344,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:44:01
3812	9d511a4b-296f-4e40-b637-254c31ab03f8	9d511a4b-2e95-403e-9f27-f7a56dddce5a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"60.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:49:50
3813	9d511a4b-29c7-4e58-bd1a-ba1225a0608d	9d511a4b-2e95-403e-9f27-f7a56dddce5a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 15:49:50
3814	9d511a4b-2d72-4465-bcba-64ec2c771a7e	9d511a4b-2e95-403e-9f27-f7a56dddce5a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 15:49:50
2581	9d50fad3-1e74-4b18-b18a-00065d80ea01	9d50fad3-7888-478d-98fb-b3121b60a21d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:21:50
2582	9d50fad3-6ffd-47ab-b9ef-49c88350ebd9	9d50fad3-7888-478d-98fb-b3121b60a21d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"167.28","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:21:51
2583	9d50fad3-706f-4119-932c-be86bbf7c73d	9d50fad3-7888-478d-98fb-b3121b60a21d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:21:51
2584	9d50fad3-76a8-4229-995a-01b4f5c3704b	9d50fad3-7888-478d-98fb-b3121b60a21d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:21:51
3815	9d511a4b-2db5-46fc-a3bd-0eeb77fec55c	9d511a4b-2e95-403e-9f27-f7a56dddce5a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":314,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:49:50
14713	9d5ec0fc-d5c7-4b3d-bbbc-ae3a84ce3db6	9d5ec0fc-d917-466d-964c-fe46cec3c123	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":137,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:41:42
15537	9d5edf78-2527-4e06-9530-1bbb9f9411f7	9d5edf78-799c-4d9a-99d3-3135b336f1de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-30 12:06:56
4069	9d511d15-016d-4307-9f59-5adcad717d51	9d511d15-216e-4c86-b7fe-bb682bcd7baf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 15:57:38
4070	9d511d15-1f7c-4fcd-8493-75c9f0a69836	9d511d15-216e-4c86-b7fe-bb682bcd7baf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 15:57:38
4071	9d511d15-207b-40b7-9fd4-6a465a022b48	9d511d15-216e-4c86-b7fe-bb682bcd7baf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:57:38
15538	9d5edf78-68b6-430b-a6bc-e1713e6346ec	9d5edf78-799c-4d9a-99d3-3135b336f1de	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"159.68","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"088d1fdbe045a08c3b0073ef22c7da32","hostname":"EderCortes"}	2024-10-30 12:06:56
15539	9d5edf78-742c-44c9-9a8f-d856b093c898	9d5edf78-799c-4d9a-99d3-3135b336f1de	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-30 12:06:56
15540	9d5edf78-746a-454c-af40-12f4d24bc5dc	9d5edf78-799c-4d9a-99d3-3135b336f1de	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-10-30 12:06:56
15541	9d5edf78-7851-41e0-9ede-1206547724e2	9d5edf78-799c-4d9a-99d3-3135b336f1de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-30 12:06:57
15688	9d64903a-0354-49ed-8098-b068fa3d8781	9d64903a-2130-404a-9f19-0a5e999db1eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 08:00:20
2585	9d50fad3-772f-4b22-b85b-fe30d73400cd	9d50fad3-7888-478d-98fb-b3121b60a21d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":514,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:21:51
3816	9d511a4b-7e01-474b-be4f-65959fe9b1b7	9d511a4b-a388-4217-86bd-c0fb867b977a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 15:49:50
3817	9d511a4b-9e3b-43c2-93b1-6342c70cbb58	9d511a4b-a388-4217-86bd-c0fb867b977a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"53.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:49:50
3818	9d511a4b-9e9e-4cec-981d-ef57c76c95fb	9d511a4b-a388-4217-86bd-c0fb867b977a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 15:49:50
3819	9d511a4b-a23f-4ff2-b37a-435a0bb888ed	9d511a4b-a388-4217-86bd-c0fb867b977a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 15:49:50
3820	9d511a4b-a295-4b34-bf13-5d4048802288	9d511a4b-a388-4217-86bd-c0fb867b977a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":285,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:49:50
4072	9d511d15-6ecf-4aeb-ba9c-780d87fbe440	9d511d15-922e-43d0-b8ad-42d0b8d17c86	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 15:57:38
4073	9d511d15-8c45-4acf-a08d-e12275136360	9d511d15-922e-43d0-b8ad-42d0b8d17c86	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:57:38
4074	9d511d15-8c95-4548-8821-ce5a1ad58e12	9d511d15-922e-43d0-b8ad-42d0b8d17c86	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 15:57:38
4075	9d511d15-9105-4cf2-8a25-23461f270374	9d511d15-922e-43d0-b8ad-42d0b8d17c86	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 15:57:38
4076	9d511d15-9150-46e2-9578-601bb527d90c	9d511d15-922e-43d0-b8ad-42d0b8d17c86	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:57:38
14714	9d5ec0fd-50c1-4fba-b85a-8d3eb6f1a1d2	9d5ec0fd-53fa-48f7-9e62-c54cabfb0c00	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":139,"memory":20,"hostname":"EderCortes"}	2024-10-30 10:41:43
15689	9d64903a-1b8d-49a4-b456-68b3b6d29d2e	9d64903a-2130-404a-9f19-0a5e999db1eb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-02 08:00:20
15690	9d64903a-1be9-4831-899d-7c15ee87c12c	9d64903a-2130-404a-9f19-0a5e999db1eb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-02 08:00:20
15691	9d64903a-1fdd-48e1-b4e1-91f9a309be02	9d64903a-2130-404a-9f19-0a5e999db1eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 08:00:20
2586	9d50fad3-f141-496f-b944-d97cc7bd53fa	9d50fad4-2656-47d6-83b4-b27bc941ccd7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:21:51
2587	9d50fad4-1c50-4d89-92b0-e90b8bd15abc	9d50fad4-2656-47d6-83b4-b27bc941ccd7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"66.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:21:51
2588	9d50fad4-1ccc-4d45-b06c-ffecba20d8fd	9d50fad4-2656-47d6-83b4-b27bc941ccd7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:21:51
2589	9d50fad4-2467-4e2e-ac1c-eab240a66686	9d50fad4-2656-47d6-83b4-b27bc941ccd7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 14:21:51
2590	9d50fad4-250a-41db-8057-4b89c3441ab9	9d50fad4-2656-47d6-83b4-b27bc941ccd7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":419,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:21:51
4077	9d511d15-db7a-423a-b897-a9672fc027d2	9d511d16-2703-47bd-bba5-eeee957b9d64	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 15:57:38
3936	9d511b20-eee2-4fd4-9031-fe5696c05b36	9d511b21-40dc-4369-9e65-bd28fccfe3dc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-23 15:52:10
3326	9d510481-807f-434b-96ad-60a63cd7328d	9d510481-81ef-49b8-b55e-c77a61cd918c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:48:55
3937	9d511b21-3d75-47aa-adb0-3876bd8f8595	9d511b21-40dc-4369-9e65-bd28fccfe3dc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-23 15:52:10
3938	9d511b21-3e82-4724-8ea5-ef3b5a8fac0e	9d511b21-40dc-4369-9e65-bd28fccfe3dc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":388,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:52:10
4078	9d511d16-21df-4d97-8854-ef0cf8d976f5	9d511d16-2703-47bd-bba5-eeee957b9d64	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"155.44","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:57:39
4079	9d511d16-2228-452a-9542-50616392b04a	9d511d16-2703-47bd-bba5-eeee957b9d64	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 15:57:39
4080	9d511d16-25e7-4571-b465-ddfc4ae62e4d	9d511d16-2703-47bd-bba5-eeee957b9d64	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 15:57:39
4081	9d511d16-263f-4815-bc79-9ee1e15d19ac	9d511d16-2703-47bd-bba5-eeee957b9d64	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":366,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:57:39
14715	9d5ec0fd-a9f9-4dc6-a6da-41f495135559	9d5ec0fd-f226-4296-93f7-7f50240b329b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-30 10:41:43
2591	9d50fad4-cc1b-4756-9f6b-0b43a4656206	9d50fad5-31dc-4708-a346-5f9162206aca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 14:21:51
2592	9d50fad5-25da-4a9d-8773-96bae1e56de3	9d50fad5-31dc-4708-a346-5f9162206aca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"176.92","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:21:52
2593	9d50fad5-2665-4700-853a-d884af65e34e	9d50fad5-31dc-4708-a346-5f9162206aca	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:21:52
2594	9d50fad5-2f40-449a-b07f-0f8c14b10df3	9d50fad5-31dc-4708-a346-5f9162206aca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 14:21:52
2595	9d50fad5-302d-48ac-8305-6b370823c6b8	9d50fad5-31dc-4708-a346-5f9162206aca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":664,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:21:52
3939	9d511b21-bf90-40e3-bbab-d075a1411233	9d511b22-1131-466d-b467-a7c9bb33589e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-23 15:52:11
3940	9d511b22-0ae9-4038-8a7f-7beed454ab30	9d511b22-1131-466d-b467-a7c9bb33589e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"154.47","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:52:11
3941	9d511b22-0b43-4727-9f22-9fba2edf8ab0	9d511b22-1131-466d-b467-a7c9bb33589e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 15:52:11
3942	9d511b22-0fab-45b1-b740-6f4c2ae0a688	9d511b22-1131-466d-b467-a7c9bb33589e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-23 15:52:11
3943	9d511b22-100d-4830-8fd5-b8bbd099995f	9d511b22-1131-466d-b467-a7c9bb33589e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":499,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:52:11
14716	9d5ec0fd-ede0-4d11-b901-dd5981328339	9d5ec0fd-f226-4296-93f7-7f50240b329b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mria%' or \\"users\\".\\"user_document\\"::text like '%Mria%') order by \\"users\\".\\"user_document\\" asc","time":"155.42","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-30 10:41:43
14717	9d5ec0fd-f0c9-4988-9799-f149d62382ef	9d5ec0fd-f226-4296-93f7-7f50240b329b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-30 10:41:43
14718	9d5ec0fd-f10f-4e25-a646-592a72a49685	9d5ec0fd-f226-4296-93f7-7f50240b329b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mria"},"session":[],"response_status":200,"response":{"data":[]},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:41:43
15692	9d64903a-2039-4a2a-a6de-a80930c5565f	9d64903a-2130-404a-9f19-0a5e999db1eb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-11-02 08:00:20
2596	9d50fad5-d4d1-40ef-9e75-5072f383719c	9d50fad6-1053-46db-870d-6596f7c5d493	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 14:21:52
2597	9d50fad6-04c4-47a4-88af-bf5fce925672	9d50fad6-1053-46db-870d-6596f7c5d493	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"80.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:21:52
2598	9d50fad6-0597-4937-bd36-2ba862b6768a	9d50fad6-1053-46db-870d-6596f7c5d493	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:21:52
2599	9d50fad6-0e26-452c-8016-9cf4e9a3e61b	9d50fad6-1053-46db-870d-6596f7c5d493	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 14:21:52
2600	9d50fad6-0eba-4279-bfea-bdda382866ba	9d50fad6-1053-46db-870d-6596f7c5d493	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":537,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:21:52
3944	9d511b22-7998-4d3b-a8d4-fd9848ae8eda	9d511b22-a1d0-43a6-bfa7-a7b43712878d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-23 15:52:11
3945	9d511b22-9a6c-49c2-9169-15ba589d2cd8	9d511b22-a1d0-43a6-bfa7-a7b43712878d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"51.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:52:11
3946	9d511b22-9ac6-49de-aeb0-b9cec62cde6f	9d511b22-a1d0-43a6-bfa7-a7b43712878d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 15:52:11
3947	9d511b22-a029-4adb-978f-0ae2752893fc	9d511b22-a1d0-43a6-bfa7-a7b43712878d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-23 15:52:11
3948	9d511b22-a08a-45bd-9c7d-7b2700e5da77	9d511b22-a1d0-43a6-bfa7-a7b43712878d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":355,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:52:11
14719	9d5ec0fe-3904-4884-8b15-161abc01804a	9d5ec0fe-57ea-4ecf-b7ef-e7db519f45e2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-30 10:41:43
14720	9d5ec0fe-5340-4852-9bf8-4cd9d742444e	9d5ec0fe-57ea-4ecf-b7ef-e7db519f45e2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"50.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-30 10:41:43
14721	9d5ec0fe-56a2-4df5-a30b-ecf81edf130e	9d5ec0fe-57ea-4ecf-b7ef-e7db519f45e2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-30 10:41:43
14722	9d5ec0fe-56eb-4c1c-a267-47d88eec054f	9d5ec0fe-57ea-4ecf-b7ef-e7db519f45e2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":245,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:41:43
15542	9d5edf78-78a1-4dae-a7f2-1397126db937	9d5edf78-799c-4d9a-99d3-3135b336f1de	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":372,"memory":22,"hostname":"EderCortes"}	2024-10-30 12:06:57
16505	9d64cde0-60a6-4397-bdcd-d89320d791f2	9d64cde0-6503-410d-895d-ca80fac676cb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":216,"memory":20,"hostname":"EderCortes"}	2024-11-02 10:52:43
16824	9d64d6ef-aea0-4703-b050-6fb1a151c63f	9d64d6ef-b7a4-449a-93d7-77fa761487e9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"151.83","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 11:18:03
2749	9d50fbc0-4006-47b1-ab34-61457c2eb922	9d50fbc0-6b9d-415b-969a-8d388933c1fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:24:26
2750	9d50fbc0-6954-44df-b8a8-cdcfbac314bf	9d50fbc0-6b9d-415b-969a-8d388933c1fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:24:26
2751	9d50fbc0-6a37-46ea-b986-eb1caf5946ff	9d50fbc0-6b9d-415b-969a-8d388933c1fc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":459,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:24:26
16825	9d64d6ef-b288-4fbc-950b-3678968d9996	9d64d6ef-b7a4-449a-93d7-77fa761487e9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 11:18:03
14723	9d5ec101-fdd3-430c-b4ae-6efd63a060e4	9d5ec102-1d42-4188-9362-b4544d05b854	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-30 10:41:46
14724	9d5ec102-17e2-4fc2-bced-c75dd8dab1cc	9d5ec102-1d42-4188-9362-b4544d05b854	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '19' and \\"users\\".\\"deleted_at\\" is null","time":"43.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":55,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-30 10:41:46
14725	9d5ec102-1840-4fb9-89da-b9d310fc6f58	9d5ec102-1d42-4188-9362-b4544d05b854	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-30 10:41:46
14726	9d5ec102-1c0b-4b32-aa73-28371559b551	9d5ec102-1d42-4188-9362-b4544d05b854	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-30 10:41:46
14727	9d5ec102-1c53-4bfe-a8f5-da1907fc8854	9d5ec102-1d42-4188-9362-b4544d05b854	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/19","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:41:46
16826	9d64d6ef-b2bf-4593-a61e-89ee8aea67dd	9d64d6ef-b7a4-449a-93d7-77fa761487e9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 11:18:03
16827	9d64d6ef-b655-48c0-940d-c89b54fa936b	9d64d6ef-b7a4-449a-93d7-77fa761487e9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-02 11:18:03
2752	9d50fbc0-cc3e-453d-a55c-5122abab78a8	9d50fbc0-edb1-4c18-852d-f87bb9e455e6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:24:26
2753	9d50fbc0-e862-4b43-893d-51bb7e3aac99	9d50fbc0-edb1-4c18-852d-f87bb9e455e6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:24:26
2754	9d50fbc0-e8af-4554-8218-3a0d73894e70	9d50fbc0-edb1-4c18-852d-f87bb9e455e6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:24:26
2755	9d50fbc0-ec58-4b7e-b859-4bf19e081f71	9d50fbc0-edb1-4c18-852d-f87bb9e455e6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:24:26
2756	9d50fbc0-eca9-4b2d-92ff-24f58f151897	9d50fbc0-edb1-4c18-852d-f87bb9e455e6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":298,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:24:26
15543	9d5ee0bf-1aa8-422c-93e3-004904400b5d	9d5ee0c3-6c04-4e0c-af8a-d8f0a8bc7f8d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-30 12:10:31
15544	9d5ee0c1-ed78-480b-85de-d567acbb8667	9d5ee0c3-6c04-4e0c-af8a-d8f0a8bc7f8d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"123.94","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-30 12:10:32
14728	9d5ec144-b0ec-4350-9e76-47ac25bc1a9f	9d5ec144-b448-40a3-87e1-7309f868df38	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":199,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:42:29
15545	9d5ee0c1-f578-4ee1-8f60-f474234e955e	9d5ee0c3-6c04-4e0c-af8a-d8f0a8bc7f8d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-10-30 12:10:32
15546	9d5ee0c3-38a4-4038-ad7f-6f7251692358	9d5ee0c3-6c04-4e0c-af8a-d8f0a8bc7f8d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 12:10:33
15547	9d5ee0c3-3e21-42ac-b8f1-8615b86fd182	9d5ee0c3-6c04-4e0c-af8a-d8f0a8bc7f8d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":16129,"memory":22,"hostname":"EderCortes"}	2024-10-30 12:10:33
16506	9d64cde0-cf4d-4317-8d16-398d16b7ea3f	9d64cde0-df77-45c4-9ddd-1b3200a66422	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 10:52:43
16507	9d64cde0-dd2d-4ca0-95b0-4ce45d483b74	9d64cde0-df77-45c4-9ddd-1b3200a66422	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 10:52:43
16508	9d64cde0-ddc7-4c5f-aa3d-3e02b1d2c8cd	9d64cde0-df77-45c4-9ddd-1b3200a66422	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"157","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000","id":187,"loans_codigo":62,"item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"result":"02-11-2024"},"duration":230,"memory":20,"hostname":"EderCortes"}	2024-11-02 10:52:43
20795	9d66fc26-dc77-4ffe-a026-6f4bb3eb8705	9d66fc26-df56-4aac-8040-d7a625bc2a15	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":133,"memory":20,"hostname":"EderCortes"}	2024-11-03 12:53:46
2757	9d50fbc1-36c3-4aa1-86b0-de0dd98a0681	9d50fbc1-56e5-4275-aba0-e7903f3709fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:24:26
2758	9d50fbc1-5126-499a-a78a-7abc0ce00300	9d50fbc1-56e5-4275-aba0-e7903f3709fe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:24:26
2759	9d50fbc1-5170-41f4-8ff6-da86993c6934	9d50fbc1-56e5-4275-aba0-e7903f3709fe	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:24:26
2760	9d50fbc1-55d0-4657-9b00-81f09b82c379	9d50fbc1-56e5-4275-aba0-e7903f3709fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 14:24:26
2761	9d50fbc1-5614-4266-a00c-f834edc0a4ea	9d50fbc1-56e5-4275-aba0-e7903f3709fe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:24:26
15548	9d5ee0ca-42c9-4c95-8837-115ba98f1e55	9d5ee0cb-dd04-47fb-b861-85041c393ef6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 12:10:38
15549	9d5ee0cb-1913-451f-9e4c-a9880a1fa1f2	9d5ee0cb-dd04-47fb-b861-85041c393ef6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"64.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":24,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-30 12:10:38
14729	9d5ec145-6a48-48f6-93e7-6f7ca46ff8f3	9d5ec145-e722-40f7-897d-37f1d5dc3cab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-30 10:42:30
14730	9d5ec145-c727-4524-828d-047a06262be2	9d5ec145-e722-40f7-897d-37f1d5dc3cab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta 2', 'De las nieve', 'ds', 'CC', '1004655468', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon2', 'Calle 7505', '500000', 50, 5, 'S', null, '06-11-2024', 'Pendiente', '312596295', 12, 14, 19, 14, '06-11-2024', '2024-10-30 10:42:30', '2024-10-30 10:42:30') returning \\"id\\"","time":"12.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":104,"hash":"bfad4cea82a73099ff0b3164dd496ca0","hostname":"EderCortes"}	2024-10-30 10:42:30
14731	9d5ec145-cda4-4672-ad19-7a698085a5be	9d5ec145-e722-40f7-897d-37f1d5dc3cab	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:56","hostname":"EderCortes"}	2024-10-30 10:42:30
14732	9d5ec145-d398-4c12-9f57-7e3da6f40bae	9d5ec145-e722-40f7-897d-37f1d5dc3cab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (56, 1, 100000, 20833.333333333, 'Pendiente', 'N\\/A', '13-11-2024', 12, '2024-10-30 10:42:30', '2024-10-30 10:42:30')","time":"3.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 10:42:30
14733	9d5ec145-d3c8-405a-ae7c-60b515272162	9d5ec145-e722-40f7-897d-37f1d5dc3cab	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 10:42:30
14734	9d5ec145-d464-4a65-8a6a-84571dbe6d9e	9d5ec145-e722-40f7-897d-37f1d5dc3cab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (56, 2, 100000, 20833.333333333, 'Pendiente', 'N\\/A', '20-11-2024', 12, '2024-10-30 10:42:30', '2024-10-30 10:42:30')","time":"0.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 10:42:30
14735	9d5ec145-d48e-4aca-b1e9-642c03f76a70	9d5ec145-e722-40f7-897d-37f1d5dc3cab	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 10:42:30
15550	9d5ee0cb-b5c5-40a8-872f-4d1ad4d31e2d	9d5ee0cb-dd04-47fb-b861-85041c393ef6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 12:10:39
2762	9d50fbf3-d5f6-4d74-b817-7eddf9a3ca15	9d50fbf4-0768-4b14-8b7a-ee3ae29c22f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 14:25:00
2763	9d50fbf3-fe4f-4833-8fbf-4b743fe10e9f	9d50fbf4-0768-4b14-8b7a-ee3ae29c22f2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"72.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:25:00
2764	9d50fbf3-fef5-467a-b2a5-b44c6680ba94	9d50fbf4-0768-4b14-8b7a-ee3ae29c22f2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:25:00
2765	9d50fbf4-0540-4a8d-b3f9-ed4f7a805b4f	9d50fbf4-0768-4b14-8b7a-ee3ae29c22f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 14:25:00
2766	9d50fbf4-05df-42f9-8421-97244d541139	9d50fbf4-0768-4b14-8b7a-ee3ae29c22f2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":500,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:25:00
10208	9d56cb26-0da2-47f8-8231-4276c306e2bb	9d56cb26-2896-452b-be18-0cc4c0572fb9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:43:30
9485	9d53006c-77ee-432a-b8f1-9c0453bccfe3	9d53006c-9aa8-4a58-a3ea-f1ce338044fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 14:29:09
9486	9d53006c-9243-4673-a27d-0f812183dac1	9d53006c-9aa8-4a58-a3ea-f1ce338044fb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 14:29:09
9487	9d53006c-9295-4d25-b684-690451d7f203	9d53006c-9aa8-4a58-a3ea-f1ce338044fb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 14:29:09
9488	9d53006c-998f-4a33-8160-cc85f79e84e6	9d53006c-9aa8-4a58-a3ea-f1ce338044fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 14:29:09
9489	9d53006c-99d7-4c53-9e0e-4b995ced89c9	9d53006c-9aa8-4a58-a3ea-f1ce338044fb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:29:09
10209	9d56cb26-23c4-4e1e-b713-5f903a9a0e96	9d56cb26-2896-452b-be18-0cc4c0572fb9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"42.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:43:30
10210	9d56cb26-2794-493e-b3ae-7192f4a0f07e	9d56cb26-2896-452b-be18-0cc4c0572fb9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:43:30
10211	9d56cb26-27db-43a7-9b67-94304200168e	9d56cb26-2896-452b-be18-0cc4c0572fb9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":263,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:43:30
14736	9d5ec145-d523-4f38-bf7d-7ba16a94f769	9d5ec145-e722-40f7-897d-37f1d5dc3cab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (56, 3, 100000, 20833.333333333, 'Pendiente', 'N\\/A', '27-11-2024', 12, '2024-10-30 10:42:30', '2024-10-30 10:42:30')","time":"0.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 10:42:30
14737	9d5ec145-d54a-4c8a-8ed8-ad57b504ea29	9d5ec145-e722-40f7-897d-37f1d5dc3cab	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 10:42:30
10212	9d56cb27-8ee4-47b4-8fd6-2ff5ac617c91	9d56cb27-abc5-4677-8a51-3d4a0b8eeb42	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:43:31
2084	9d50e354-19c0-4c41-8944-a8b7f8b83d54	9d50e354-3eab-4d8e-8365-a8df1c4e5d62	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 13:16:08
2085	9d50e354-3c8f-427d-9141-c7c42c4797f3	9d50e354-3eab-4d8e-8365-a8df1c4e5d62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 13:16:08
2086	9d50e354-3d5b-46ba-9dc3-8ba011d0cda0	9d50e354-3eab-4d8e-8365-a8df1c4e5d62	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:16:08
4360	9d512da5-32ca-4d99-a0c1-dabe1eb22ca1	9d512da5-70a5-41e3-a8a3-b0744698d4ad	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 16:43:57
4361	9d512da5-6cb5-4a68-840a-0dae9c5a8877	9d512da5-70a5-41e3-a8a3-b0744698d4ad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 16:43:57
4362	9d512da5-6e69-4f19-b7b4-c0655d29669e	9d512da5-70a5-41e3-a8a3-b0744698d4ad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":471,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:43:57
9490	9d53006c-d713-4f12-b50b-e655c4950caf	9d53006d-1d29-4bb4-941b-e79bcd3bea4d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 14:29:09
9491	9d53006d-1852-48a9-b515-5315b2e3a334	9d53006d-1d29-4bb4-941b-e79bcd3bea4d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"145.86","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 14:29:09
9492	9d53006d-18a1-4bbe-9248-f8e33e9fc2d0	9d53006d-1d29-4bb4-941b-e79bcd3bea4d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 14:29:09
9493	9d53006d-1bfb-4105-8017-4d110709551b	9d53006d-1d29-4bb4-941b-e79bcd3bea4d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 14:29:09
9494	9d53006d-1c50-40b3-9db3-6b3bffc2fa97	9d53006d-1d29-4bb4-941b-e79bcd3bea4d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:29:09
10213	9d56cb27-a6ee-4ee7-8296-f86f3745e01b	9d56cb27-abc5-4677-8a51-3d4a0b8eeb42	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:43:31
10214	9d56cb27-a736-4303-baa0-402cd0c22fd2	9d56cb27-abc5-4677-8a51-3d4a0b8eeb42	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:43:31
10215	9d56cb27-aa76-4c3d-8e0b-163ef9c0b405	9d56cb27-abc5-4677-8a51-3d4a0b8eeb42	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 11:43:31
10216	9d56cb27-aac9-4dc0-9eb8-669eb668dcae	9d56cb27-abc5-4677-8a51-3d4a0b8eeb42	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:43:31
14738	9d5ec145-d5c0-4be4-b56a-7852dce59e88	9d5ec145-e722-40f7-897d-37f1d5dc3cab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (56, 4, 100000, 20833.333333333, 'Pendiente', 'N\\/A', '04-12-2024', 12, '2024-10-30 10:42:30', '2024-10-30 10:42:30')","time":"0.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 10:42:30
14739	9d5ec145-d5e1-49b8-864f-d54b6f3409da	9d5ec145-e722-40f7-897d-37f1d5dc3cab	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 10:42:30
2087	9d50e354-9205-48b4-943b-dd6033065d99	9d50e354-b130-4bb3-a2e9-dba3d01807a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 13:16:09
2088	9d50e354-ab33-43fd-8d6e-11c129aa0fff	9d50e354-b130-4bb3-a2e9-dba3d01807a4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:16:09
2089	9d50e354-ab7e-4b66-bf7e-58d59c34e806	9d50e354-b130-4bb3-a2e9-dba3d01807a4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 13:16:09
2090	9d50e354-aff8-4011-9da3-dd20bdc36ebe	9d50e354-b130-4bb3-a2e9-dba3d01807a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 13:16:09
2091	9d50e354-b04b-489c-9b38-7f8d75681a9a	9d50e354-b130-4bb3-a2e9-dba3d01807a4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:16:09
2767	9d50fbf4-5b2b-441b-a399-0b63ae2a7c84	9d50fbf4-7a72-4c46-a675-5e03d8577d5e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 14:25:00
2768	9d50fbf4-7504-43d9-ac11-724e0b618b74	9d50fbf4-7a72-4c46-a675-5e03d8577d5e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:25:00
2769	9d50fbf4-755d-4636-9b78-773d5630150b	9d50fbf4-7a72-4c46-a675-5e03d8577d5e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:25:00
2349	9d50e72d-7dad-450a-a36e-460d298c1465	9d50e72d-9c9e-4991-8bc4-3dc853095d2c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 13:26:54
2350	9d50e72d-96e5-41e8-a5a5-454e826ce11f	9d50e72d-9c9e-4991-8bc4-3dc853095d2c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:26:54
2351	9d50e72d-973a-4283-b5a9-39daba0fd486	9d50e72d-9c9e-4991-8bc4-3dc853095d2c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 13:26:54
2352	9d50e72d-9b67-4465-a9ae-891a94f9ff8a	9d50e72d-9c9e-4991-8bc4-3dc853095d2c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 13:26:54
2353	9d50e72d-9bac-4125-9465-6573672bdec7	9d50e72d-9c9e-4991-8bc4-3dc853095d2c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:26:54
2770	9d50fbf4-78f8-4f4e-871c-f9b4eb66e180	9d50fbf4-7a72-4c46-a675-5e03d8577d5e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 14:25:00
2771	9d50fbf4-793d-4ae3-abd6-6822d8665f9a	9d50fbf4-7a72-4c46-a675-5e03d8577d5e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":267,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:25:00
4363	9d512da6-1e54-48e2-b9f6-1d08979aae52	9d512da6-5c28-4929-a8eb-28229f0f46ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 16:43:57
4364	9d512da6-5244-4116-bb10-4c69788090ff	9d512da6-5c28-4929-a8eb-28229f0f46ec	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"77.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:43:57
4365	9d512da6-52b0-4019-a611-28ff7969df66	9d512da6-5c28-4929-a8eb-28229f0f46ec	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 16:43:57
4366	9d512da6-5a74-4864-976d-f770942cb5b7	9d512da6-5c28-4929-a8eb-28229f0f46ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 16:43:57
4367	9d512da6-5ada-4fb0-9246-11e4309ba6d7	9d512da6-5c28-4929-a8eb-28229f0f46ec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":570,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:43:57
4213	9d512996-1800-4d0c-87f6-bf09962b856f	9d512997-92a3-426d-994c-3d54d1821895	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 16:32:36
1908	9d50e059-8163-4d89-acea-e2826ae3d542	9d50e059-aa37-412b-82f5-036be1b1bb4d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 13:07:49
1909	9d50e059-a871-4fb4-9e3c-d998cacf3134	9d50e059-aa37-412b-82f5-036be1b1bb4d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 13:07:49
1910	9d50e059-a941-4308-9419-34a2229ad12e	9d50e059-aa37-412b-82f5-036be1b1bb4d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":338,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:07:49
4214	9d512997-907f-4068-8565-b0288c12601f	9d512997-92a3-426d-994c-3d54d1821895	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 16:32:37
4215	9d512997-9175-404a-804e-37c782e11c5a	9d512997-92a3-426d-994c-3d54d1821895	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1231,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:32:37
14740	9d5ec145-d648-4df9-a5bd-13b48eeca53f	9d5ec145-e722-40f7-897d-37f1d5dc3cab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (56, 5, 100000, 20833.333333333, 'Pendiente', 'N\\/A', '11-12-2024', 12, '2024-10-30 10:42:30', '2024-10-30 10:42:30')","time":"0.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 10:42:30
14741	9d5ec145-d666-4b04-852b-bde1e8e6cd19	9d5ec145-e722-40f7-897d-37f1d5dc3cab	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 10:42:30
14742	9d5ec145-e5d5-40ff-b875-d03012e7ea62	9d5ec145-e722-40f7-897d-37f1d5dc3cab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-30 10:42:30
4474	9d5130c5-f06d-4139-952b-221fec8ee737	9d5130c6-4a9c-42b9-a9ba-b5fe7ab7887c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 16:52:41
4475	9d5130c6-47d8-428a-a95e-dee9f7c61be8	9d5130c6-4a9c-42b9-a9ba-b5fe7ab7887c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 16:52:42
14743	9d5ec145-e61d-4840-afb6-2b78dbaf63ce	9d5ec145-e722-40f7-897d-37f1d5dc3cab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"748","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"1004655468","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_valor_prestado":"500000","loans_intereses":50,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":19,"user_recomendacion":14,"loans_inicio_pago":"06-11-2024","created_at":null,"updated_at":null,"deleted_at":null},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Wed Oct 30 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":56},"duration":479,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:42:30
15551	9d5ee0cb-bb20-4eb9-b06e-3c9a50ae7800	9d5ee0cb-dd04-47fb-b861-85041c393ef6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":5406,"memory":22,"hostname":"EderCortes"}	2024-10-30 12:10:39
16509	9d64ce2a-a61b-486d-ac0b-1b74b4751413	9d64ce2a-aa47-44fb-87ed-f5f53152a116	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":311,"memory":20,"hostname":"EderCortes"}	2024-11-02 10:53:31
1911	9d50e05a-05f2-40b1-aef3-08ba3fa86655	9d50e05a-2ac7-40cb-93b4-712edbceb613	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 13:07:49
1912	9d50e05a-227c-4858-9c82-d9a2b3a370a4	9d50e05a-2ac7-40cb-93b4-712edbceb613	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:07:49
1913	9d50e05a-22df-4e63-9733-96d44a91731e	9d50e05a-2ac7-40cb-93b4-712edbceb613	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 13:07:49
1914	9d50e05a-28ed-44ac-80d9-85fe4632386b	9d50e05a-2ac7-40cb-93b4-712edbceb613	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 13:07:49
1915	9d50e05a-2976-48c4-9915-ac9c01523815	9d50e05a-2ac7-40cb-93b4-712edbceb613	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":301,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:07:49
2772	9d50fc02-9422-4a36-865d-e5bda5d6ea8d	9d50fc02-b5a7-4d10-8e43-f039337696c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 14:25:09
2354	9d50e72d-dda6-4580-a376-63d92e9d74f2	9d50e72e-2562-42d1-959c-c68dcd5fe358	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 13:26:54
2355	9d50e72e-1fbf-490b-8f94-20a77b940b33	9d50e72e-2562-42d1-959c-c68dcd5fe358	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"147.36","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:26:55
2092	9d50e354-f05f-4baf-a57d-e8c76ca8e28e	9d50e355-0e3f-4ef6-8e3e-c67357388244	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 13:16:09
2093	9d50e355-08d2-4631-9cb6-5848407fc3d8	9d50e355-0e3f-4ef6-8e3e-c67357388244	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:16:09
2094	9d50e355-0922-4faa-8c1b-9d9850c6f69b	9d50e355-0e3f-4ef6-8e3e-c67357388244	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 13:16:09
2095	9d50e355-0d08-4e32-b52e-3d471a0a8410	9d50e355-0e3f-4ef6-8e3e-c67357388244	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 13:16:09
2096	9d50e355-0d53-4e21-b9f8-d5f79293198a	9d50e355-0e3f-4ef6-8e3e-c67357388244	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":223,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:16:09
2356	9d50e72e-2025-4c70-9b53-06e54e99b474	9d50e72e-2562-42d1-959c-c68dcd5fe358	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 13:26:55
2357	9d50e72e-2422-46d9-9a10-cd55381c82bb	9d50e72e-2562-42d1-959c-c68dcd5fe358	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 13:26:55
2358	9d50e72e-2466-4af7-916f-87d7cc7d8eb7	9d50e72e-2562-42d1-959c-c68dcd5fe358	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:26:55
2773	9d50fc02-b01a-4cfc-8d39-fbf48b076d48	9d50fc02-b5a7-4d10-8e43-f039337696c3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"46.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-23 14:25:09
1916	9d50e05a-79fc-4c7f-92b5-ef1b3ecd9801	9d50e05a-c7cf-4a10-9176-b0bf32e448c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 13:07:49
1917	9d50e05a-c15a-4c39-95cc-bbc2a4ca1427	9d50e05a-c7cf-4a10-9176-b0bf32e448c4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"158.00","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:07:49
1918	9d50e05a-c1c6-41b1-a381-12d8171c8c96	9d50e05a-c7cf-4a10-9176-b0bf32e448c4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 13:07:49
1919	9d50e05a-c692-463f-8a68-16b43b168b96	9d50e05a-c7cf-4a10-9176-b0bf32e448c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 13:07:49
1920	9d50e05a-c6e3-43c8-98ce-004a9ed4b7f6	9d50e05a-c7cf-4a10-9176-b0bf32e448c4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":382,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:07:49
2774	9d50fc02-b073-4a8c-9879-f8b1b331bee6	9d50fc02-b5a7-4d10-8e43-f039337696c3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-10-23 14:25:09
2775	9d50fc02-b45c-41a5-b93f-f9377ad49772	9d50fc02-b5a7-4d10-8e43-f039337696c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 14:25:09
2097	9d50e356-4aa5-4b33-8853-79251de5dd2d	9d50e356-9264-4e7d-bbba-a208b1affe7e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 13:16:10
2098	9d50e356-8d50-452e-b990-e703dc250310	9d50e356-9264-4e7d-bbba-a208b1affe7e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"145.95","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 13:16:10
2099	9d50e356-8d95-4974-9c25-5aa633134f9b	9d50e356-9264-4e7d-bbba-a208b1affe7e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 13:16:10
2100	9d50e356-9122-4978-82d8-c3ebc72766f6	9d50e356-9264-4e7d-bbba-a208b1affe7e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 13:16:10
2101	9d50e356-9162-4f93-9e88-0cac5be5fa47	9d50e356-9264-4e7d-bbba-a208b1affe7e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":500,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:16:10
2174	9d50e4e9-e6e7-49bb-913c-60c937ffe4e4	9d50e4e9-ea4f-4d71-91f4-2fe0093bc0e0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":152,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:20:34
2776	9d50fc02-b4ae-4d8d-b991-87413cb15c59	9d50fc02-b5a7-4d10-8e43-f039337696c3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":289,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:25:09
1921	9d50e05c-2f80-4378-acc2-c38161e307ee	9d50e05c-5a52-4594-893d-2da718761d64	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 13:07:50
1922	9d50e05c-50b9-4317-8a56-9441eccd9f08	9d50e05c-5a52-4594-893d-2da718761d64	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"53.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 13:07:50
1629	9d50d844-2e83-4f05-845c-4c6b77bb6c38	9d50d844-504a-48e7-adf4-b90bdefdc3d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 12:45:12
1630	9d50d844-4c3f-4552-87ca-fe78f0ed61a2	9d50d844-504a-48e7-adf4-b90bdefdc3d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 12:45:12
1631	9d50d844-4f36-49a0-a5ed-dd33b3262c3a	9d50d844-504a-48e7-adf4-b90bdefdc3d2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:45:12
2102	9d50e35e-44ec-4667-b8d0-46dea1e40b03	9d50e35e-486f-4f34-9fe7-594cde6750b1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":161,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:16:15
1923	9d50e05c-512a-47e8-b88e-a6b9387c0cc3	9d50e05c-5a52-4594-893d-2da718761d64	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 13:07:50
1924	9d50e05c-58c7-4686-8a23-7a53925797fc	9d50e05c-5a52-4594-893d-2da718761d64	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 13:07:50
1925	9d50e05c-591e-4ed9-a5b6-9d48bb38e6f2	9d50e05c-5a52-4594-893d-2da718761d64	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":436,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:07:50
2359	9d50e72f-9b2b-4670-8cf0-56ca11f9ea3d	9d50e72f-e7d9-464e-a9eb-b689e8267df2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 13:26:56
2360	9d50e72f-e0ef-4e3a-971c-00d7fcec8a2d	9d50e72f-e7d9-464e-a9eb-b689e8267df2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"151.52","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 13:26:56
2175	9d50e4ea-9d8f-43dc-83fc-1fb0f04fc0ba	9d50e4ea-b841-44eb-a33f-c5eb68b3b227	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 13:20:35
2176	9d50e4ea-b410-4f20-9001-a07a4e673980	9d50e4ea-b841-44eb-a33f-c5eb68b3b227	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder%' or \\"users\\".\\"user_document\\"::text like '%eder%' order by \\"users\\".\\"user_document\\" asc","time":"42.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:20:35
2177	9d50e4ea-b6fd-4271-bd56-82818c6f1836	9d50e4ea-b841-44eb-a33f-c5eb68b3b227	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 13:20:35
2178	9d50e4ea-b74d-4832-99f4-ace68efd1b7f	9d50e4ea-b841-44eb-a33f-c5eb68b3b227	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":216,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:20:35
2361	9d50e72f-e182-4ed7-8d16-a42b15a6c76d	9d50e72f-e7d9-464e-a9eb-b689e8267df2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 13:26:56
2362	9d50e72f-e68b-4e72-9bc9-f5e5af62b961	9d50e72f-e7d9-464e-a9eb-b689e8267df2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 13:26:56
4216	9d512998-0865-46fd-b3f1-b6de0ecc7954	9d512998-58ce-42fe-8f30-6185ba985969	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 16:32:37
4217	9d512998-535f-4e23-afb0-039d06cbd9c2	9d512998-58ce-42fe-8f30-6185ba985969	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"160.72","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:32:37
2103	9d50e35e-a6bd-478e-a2a5-df8eece3adbf	9d50e35e-ed36-4cc9-a873-94aad9229d47	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 13:16:15
1926	9d50e061-094e-4dd1-85c7-af2025e57488	9d50e061-0c2e-46dc-980e-f9c3f8e6d6f9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":135,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:07:54
2104	9d50e35e-e8f6-46cb-86a1-63aa03ac5172	9d50e35e-ed36-4cc9-a873-94aad9229d47	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder%' or \\"users\\".\\"user_document\\"::text like '%eder%' order by \\"users\\".\\"user_document\\" asc","time":"153.88","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:16:15
1729	9d50dd7d-73b5-4609-9230-0019be26eb8e	9d50dd7d-9307-4ee9-a888-fbc80ea2ada7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 12:59:49
1730	9d50dd7d-912e-4b71-9199-55674cbc441d	9d50dd7d-9307-4ee9-a888-fbc80ea2ada7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 12:59:49
1731	9d50dd7d-91e4-4fe5-8c3f-66c5ea3f9970	9d50dd7d-9307-4ee9-a888-fbc80ea2ada7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-10-23 12:59:49
2105	9d50e35e-ebfb-4f22-aed8-343625fcfaef	9d50e35e-ed36-4cc9-a873-94aad9229d47	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 13:16:15
2106	9d50e35e-ec3e-4665-aa27-269781392586	9d50e35e-ed36-4cc9-a873-94aad9229d47	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:16:15
4218	9d512998-53aa-41a8-af56-569a682fd701	9d512998-58ce-42fe-8f30-6185ba985969	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 16:32:37
4219	9d512998-57b3-4d01-88a4-543db9db2413	9d512998-58ce-42fe-8f30-6185ba985969	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 16:32:37
4220	9d512998-57f5-4c7e-a940-12b67a27390a	9d512998-58ce-42fe-8f30-6185ba985969	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":477,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:32:37
4368	9d512da6-b516-47d2-91c8-0a8705a9368c	9d512da6-d76a-4eeb-ae1c-d355b5188f64	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 16:43:58
4369	9d512da6-d24f-486e-ae27-d3005264b9d6	9d512da6-d76a-4eeb-ae1c-d355b5188f64	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"50.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:43:58
4370	9d512da6-d2d3-4a5d-91da-b86d5757bbc9	9d512da6-d76a-4eeb-ae1c-d355b5188f64	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 16:43:58
4371	9d512da6-d64f-4c34-962e-194f540aa5e5	9d512da6-d76a-4eeb-ae1c-d355b5188f64	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 16:43:58
4372	9d512da6-d697-431e-896b-a3db73081226	9d512da6-d76a-4eeb-ae1c-d355b5188f64	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":292,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:43:58
4476	9d5130c6-4933-4eb4-9bb2-0320acc3f8b8	9d5130c6-4a9c-42b9-a9ba-b5fe7ab7887c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":551,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:52:42
9495	9d53006d-6fdb-49c3-9f38-96d89260063a	9d53006d-923f-42af-ac43-2750df8963b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 14:29:10
1927	9d50e061-73d2-4f4e-b2a4-0c73c221ccfc	9d50e061-b73e-4168-8018-3c3e2e11f5f3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 13:07:54
1928	9d50e061-b33b-49e7-bcc3-267e3e01b62f	9d50e061-b73e-4168-8018-3c3e2e11f5f3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, ' - ', users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"144.94","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"a0ee15a70acbc36269a3707722ae9859","hostname":"EderCortes"}	2024-10-23 13:07:54
1929	9d50e061-b617-4da7-abec-099af3b4f434	9d50e061-b73e-4168-8018-3c3e2e11f5f3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 13:07:54
1930	9d50e061-b658-4fc0-925c-e5ad3d3f0972	9d50e061-b73e-4168-8018-3c3e2e11f5f3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley - 1004608333"},{"id":14,"name_customer":"Luis andre - 100465545"}]},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:07:54
4221	9d512998-a198-41f6-9c89-3e0d0254d666	9d512998-ee59-42a9-bf9c-af74bcb6164b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 16:32:37
4222	9d512998-e95e-4338-a2b0-eb84b3a52cd7	9d512998-ee59-42a9-bf9c-af74bcb6164b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"147.56","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:32:37
4223	9d512998-e9bb-4883-8cee-1542ca5fff46	9d512998-ee59-42a9-bf9c-af74bcb6164b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 16:32:37
4224	9d512998-ed3d-4cb2-a644-dc7c113b4aaa	9d512998-ee59-42a9-bf9c-af74bcb6164b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 16:32:37
4225	9d512998-ed85-4eb2-a8ee-de1ea88b0dbf	9d512998-ee59-42a9-bf9c-af74bcb6164b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":368,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:32:37
4477	9d5130c6-b94e-4aeb-b808-7734d3073c67	9d5130c6-e037-4784-b61a-2dcd25b1b985	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 16:52:42
4478	9d5130c6-d9c1-417a-bdbb-0ff2a5f1b564	9d5130c6-e037-4784-b61a-2dcd25b1b985	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:52:42
4479	9d5130c6-da1e-4fae-a502-f49c0baf1873	9d5130c6-e037-4784-b61a-2dcd25b1b985	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 16:52:42
4480	9d5130c6-defd-4a4b-bd08-d1259e19fcb5	9d5130c6-e037-4784-b61a-2dcd25b1b985	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 16:52:42
4481	9d5130c6-df50-4d61-8cd2-1a3bae1f4d7e	9d5130c6-e037-4784-b61a-2dcd25b1b985	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:52:42
9496	9d53006d-8985-4dd8-9d53-abd436083686	9d53006d-923f-42af-ac43-2750df8963b1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"45.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-24 14:29:10
9497	9d53006d-8a0a-49e4-b908-e564a5039225	9d53006d-923f-42af-ac43-2750df8963b1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 14:29:10
9498	9d53006d-8bf1-4c11-89cf-3ce1455926c8	9d53006d-923f-42af-ac43-2750df8963b1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"1.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 14:29:10
4482	9d5130c7-33fc-41c2-9655-b57299f02b8d	9d5130c7-5a29-483d-8744-1376b9b778de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 16:52:42
4483	9d5130c7-5302-478b-938e-d56bda1c1690	9d5130c7-5a29-483d-8744-1376b9b778de	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"55.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:52:42
4484	9d5130c7-5384-4807-bbcb-2c24e42aeb05	9d5130c7-5a29-483d-8744-1376b9b778de	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 16:52:42
4485	9d5130c7-5903-4920-a481-f7212c5e9fed	9d5130c7-5a29-483d-8744-1376b9b778de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 16:52:42
4486	9d5130c7-594d-4692-a9bd-698920ba7aaf	9d5130c7-5a29-483d-8744-1376b9b778de	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":297,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:52:42
15552	9d5ee0cf-fb3c-43a6-9494-4c52c94f45c6	9d5ee0d0-3f8b-4f04-ba25-e1056895909a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 12:10:42
14744	9d5ec14a-103b-4a5e-9bb4-4a838d81a459	9d5ec14a-59b2-4a54-bac6-2265832cad14	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-30 10:42:33
9499	9d53006d-8c24-4097-a11a-896582788ac0	9d53006d-923f-42af-ac43-2750df8963b1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 14:29:10
9500	9d53006d-90ad-4016-8728-ac8f83b0a86f	9d53006d-923f-42af-ac43-2750df8963b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 14:29:10
9501	9d53006d-9120-45d1-a638-70ff0855640d	9d53006d-923f-42af-ac43-2750df8963b1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":286,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:29:10
15553	9d5ee0d0-3ba6-43ab-bf29-5288f36ec4a4	9d5ee0d0-3f8b-4f04-ba25-e1056895909a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"153.08","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-10-30 12:10:42
14745	9d5ec14a-532a-4cb0-bd80-8986d9b20a36	9d5ec14a-59b2-4a54-bac6-2265832cad14	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"147.50","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-30 10:42:33
14746	9d5ec14a-57e6-4d20-b8fd-b7e5edb1b190	9d5ec14a-59b2-4a54-bac6-2265832cad14	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 10:42:33
15554	9d5ee0d0-3e35-4b48-bf4f-86ff3619f805	9d5ee0d0-3f8b-4f04-ba25-e1056895909a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 12:10:42
16510	9d64ce2b-7d4e-4d0c-ba77-4a13b397276d	9d64ce2b-8842-42ba-8aca-776228c6423e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 10:53:32
16511	9d64ce2b-85ed-41ec-a06c-07e11d2cad1e	9d64ce2b-8842-42ba-8aca-776228c6423e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 10:53:32
16512	9d64ce2b-8678-4f95-875e-2e7bc14db725	9d64ce2b-8842-42ba-8aca-776228c6423e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"157","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000","id":187,"loans_codigo":62,"item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"result":187},"duration":248,"memory":20,"hostname":"EderCortes"}	2024-11-02 10:53:32
4598	9d5133c1-dd38-4a6e-9b21-dc477e416d18	9d5133c2-3d48-40c2-b9c1-9b598c582d9a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 17:01:02
4599	9d5133c2-3911-4bbf-8931-fa8e2b1a6388	9d5133c2-3d48-40c2-b9c1-9b598c582d9a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 17:01:02
4600	9d5133c2-3ae8-4070-9ca1-19117ec22512	9d5133c2-3d48-40c2-b9c1-9b598c582d9a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":541,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:01:02
16828	9d64d6ef-b6a7-48b8-92be-58c5d9836f62	9d64d6ef-b7a4-449a-93d7-77fa761487e9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":369,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:18:03
14747	9d5ec14a-5873-4971-b559-1c53bc061444	9d5ec14a-59b2-4a54-bac6-2265832cad14	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":374,"memory":20,"hostname":"EderCortes"}	2024-10-30 10:42:33
15555	9d5ee0d0-3e8c-44a9-8e72-5081d426d7b7	9d5ee0d0-3f8b-4f04-ba25-e1056895909a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":2774,"memory":22,"hostname":"EderCortes"}	2024-10-30 12:10:42
17250	9d65519f-ceed-4d2f-adee-a74859c7b964	9d65519f-d448-4c3a-bd5c-6406954db587	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"43.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":46,"hash":"fb4ded687569d92428336ceae5c6ffcd","hostname":"EderCortes"}	2024-11-02 17:01:06
17251	9d65519f-d2c5-4b12-9723-996d175c1c95	9d65519f-d448-4c3a-bd5c-6406954db587	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:01:06
4601	9d5133c2-ce23-4e41-827e-474d94fdb5ce	9d5133c2-f8a9-4b1e-9a74-40d015a8ba7d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 17:01:03
4602	9d5133c2-f115-4950-9e02-1bad71436d19	9d5133c2-f8a9-4b1e-9a74-40d015a8ba7d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"56.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:01:03
4603	9d5133c2-f17b-490e-812a-cb0011c4daf3	9d5133c2-f8a9-4b1e-9a74-40d015a8ba7d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:01:03
4604	9d5133c2-f713-4331-bed6-75a1434376c4	9d5133c2-f8a9-4b1e-9a74-40d015a8ba7d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 17:01:03
4605	9d5133c2-f773-4b2b-9543-9f030f964c32	9d5133c2-f8a9-4b1e-9a74-40d015a8ba7d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":437,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:01:03
14748	9d5ec159-9312-48d6-a946-93bf1a8ef321	9d5ec159-dde3-4a7d-9432-a16a9fa83ce7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 10:42:43
11282	9d5cb233-7bab-4dc3-becd-1e242fa1021e	9d5cb233-c0dd-44e7-94c2-816db6452159	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 10:08:42
11283	9d5cb233-bbf5-4fff-86f2-a5d4225c6383	9d5cb233-c0dd-44e7-94c2-816db6452159	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"143.36","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 10:08:42
9502	9d53006f-c53e-4f31-9a07-e2f0dec64268	9d530070-0af0-4e81-8558-f8b643ba4ccc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 14:29:11
9503	9d530070-063f-4c56-8827-8186c1226c51	9d530070-0af0-4e81-8558-f8b643ba4ccc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"147.40","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 14:29:11
9504	9d530070-0685-445f-bd25-7f7332694daa	9d530070-0af0-4e81-8558-f8b643ba4ccc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 14:29:11
9505	9d530070-09a9-4de9-906e-752536b2f4d2	9d530070-0af0-4e81-8558-f8b643ba4ccc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 14:29:11
9506	9d530070-09ea-47d3-9d58-0ccac7859cd2	9d530070-0af0-4e81-8558-f8b643ba4ccc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":413,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:29:11
11284	9d5cb233-bc45-4442-9bf4-03007eddefab	9d5cb233-c0dd-44e7-94c2-816db6452159	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 10:08:42
11285	9d5cb233-bfc0-40ce-be7d-4fff1312c987	9d5cb233-c0dd-44e7-94c2-816db6452159	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 10:08:42
11286	9d5cb233-c001-4187-abce-a4121878daa2	9d5cb233-c0dd-44e7-94c2-816db6452159	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":334,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:08:42
15556	9d5ee187-0cbf-46a7-a9f4-7841102663ce	9d5ee187-6384-4456-8537-daae92a6e7c6	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-30 12:12:42
15557	9d5ee187-5c5e-4687-b78a-d4ee01c4253a	9d5ee187-6384-4456-8537-daae92a6e7c6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"174.14","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-10-30 12:12:42
15558	9d5ee187-61cf-482a-8586-da0e01761e0f	9d5ee187-6384-4456-8537-daae92a6e7c6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 12:12:42
2308	9d50e6ed-d273-4dcb-bfe1-85170fe3f021	9d50e6ed-f047-42eb-ae46-fcb48c99e33d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 13:26:12
2309	9d50e6ed-ee9e-431c-b010-b2ea60bc5f4d	9d50e6ed-f047-42eb-ae46-fcb48c99e33d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 13:26:12
2310	9d50e6ed-ef2c-41d1-a000-4fdda518daef	9d50e6ed-f047-42eb-ae46-fcb48c99e33d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:26:12
15559	9d5ee187-6260-4e9c-a329-d741e35b8dd9	9d5ee187-6384-4456-8537-daae92a6e7c6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":465,"memory":22,"hostname":"EderCortes"}	2024-10-30 12:12:42
14749	9d5ec159-d46f-4d5d-9fa5-1f32545ddbbc	9d5ec159-dde3-4a7d-9432-a16a9fa83ce7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 56\\n                        ","time":"154.51","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"49618c9c61809bcc9178d61955ea8e18","hostname":"EderCortes"}	2024-10-30 10:42:43
16513	9d64cf10-b888-4ec0-bea5-6918dc8b4d02	9d64cf10-bdac-46af-8cac-255e6cc7f3ea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":306,"memory":20,"hostname":"EderCortes"}	2024-11-02 10:56:02
14750	9d5ec159-d85b-4234-a778-604891d2f557	9d5ec159-dde3-4a7d-9432-a16a9fa83ce7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '56' order by \\"item_loans\\".\\"id\\" asc","time":"2.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-30 10:42:43
14751	9d5ec159-d892-4a8c-bb12-c353374498de	9d5ec159-dde3-4a7d-9432-a16a9fa83ce7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-10-30 10:42:43
14752	9d5ec159-dc85-4eb2-8aaf-afe6366cb118	9d5ec159-dde3-4a7d-9432-a16a9fa83ce7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 10:42:43
16829	9d64d6f3-46c9-48e0-a65c-e9208bab56b4	9d64d6f3-4a11-4bf2-a7d6-f08a6b20fa8f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":138,"memory":20,"hostname":"EderCortes"}	2024-11-02 11:18:05
2311	9d50e6ee-331f-4085-8768-5d84652809df	9d50e6ee-50ea-46c3-b118-da983a060009	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 13:26:13
2312	9d50e6ee-4c5e-4ac6-95ca-663f5b0fb686	9d50e6ee-50ea-46c3-b118-da983a060009	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:26:13
2313	9d50e6ee-4caa-4be1-8967-0965b7da7f5d	9d50e6ee-50ea-46c3-b118-da983a060009	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 13:26:13
2314	9d50e6ee-4fd7-439a-b9bd-f6f776001e77	9d50e6ee-50ea-46c3-b118-da983a060009	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 13:26:13
2315	9d50e6ee-5018-46d0-b23a-b37091442d97	9d50e6ee-50ea-46c3-b118-da983a060009	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":219,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:26:13
4606	9d5133c3-4854-4d1e-95ab-13ee5ea1d33d	9d5133c3-95ab-4434-b9a5-023219d32e86	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 17:01:03
3010	9d5100c3-ab4c-4b22-9a44-9fc75a863cc0	9d5100c3-db09-4df7-8c18-b2d55a5e2999	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:38:27
3011	9d5100c3-d93e-4803-a9be-f86f024d9c9b	9d5100c3-db09-4df7-8c18-b2d55a5e2999	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:38:27
3012	9d5100c3-da15-40b0-9a78-018a084490b5	9d5100c3-db09-4df7-8c18-b2d55a5e2999	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":839,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:38:27
4607	9d5133c3-8e5a-42a1-9513-5a28bb1a58f1	9d5133c3-95ab-4434-b9a5-023219d32e86	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"155.39","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:01:03
4608	9d5133c3-8eef-4d86-8ea2-69661f0302c9	9d5133c3-95ab-4434-b9a5-023219d32e86	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:01:03
4609	9d5133c3-943a-496d-ae11-23fa0b1f147a	9d5133c3-95ab-4434-b9a5-023219d32e86	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 17:01:03
4610	9d5133c3-949b-49d3-98af-43fe664b6dcd	9d5133c3-95ab-4434-b9a5-023219d32e86	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":380,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:01:03
15560	9d5ee187-c2be-4b1a-a130-4c4f9e6ff6c9	9d5ee187-e1e7-4e8c-a5ff-51cfca20b95c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 12:12:42
11287	9d5cb234-0352-4e4f-b255-bd07873d442b	9d5cb234-20d3-435e-9977-876ca88a8d5f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 10:08:43
11288	9d5cb234-1bf5-46d3-af54-f8f4a3b4c9c9	9d5cb234-20d3-435e-9977-876ca88a8d5f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 10:08:43
11289	9d5cb234-1c50-4064-9d38-35d80aeef687	9d5cb234-20d3-435e-9977-876ca88a8d5f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 10:08:43
11290	9d5cb234-1fb9-4c94-a63e-a6f9d61b00f1	9d5cb234-20d3-435e-9977-876ca88a8d5f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 10:08:43
11291	9d5cb234-1ffd-412c-a3fa-9cf40e00b21f	9d5cb234-20d3-435e-9977-876ca88a8d5f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:08:43
2316	9d50e6ee-9681-456b-9ec8-24766ee6bcaf	9d50e6ee-b410-4503-b8ad-0ef8f484ae7f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 13:26:13
2317	9d50e6ee-af90-49ba-b4d4-db6371684082	9d50e6ee-b410-4503-b8ad-0ef8f484ae7f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:26:13
2318	9d50e6ee-afd7-47d9-a745-6b265348ad12	9d50e6ee-b410-4503-b8ad-0ef8f484ae7f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 13:26:13
2319	9d50e6ee-b2cf-46ea-aae4-176cf252a8af	9d50e6ee-b410-4503-b8ad-0ef8f484ae7f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 13:26:13
2320	9d50e6ee-b310-4ab0-89c8-2b795e530dc6	9d50e6ee-b410-4503-b8ad-0ef8f484ae7f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:26:13
3013	9d5100c4-38d4-44f4-880f-800d69aa9d52	9d5100c4-5abf-4c8d-969a-de4c5f4abd6c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:38:27
3014	9d5100c4-54c0-4ce6-a81c-260db5f03ebb	9d5100c4-5abf-4c8d-969a-de4c5f4abd6c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:38:27
2363	9d50e72f-e6d0-41a2-ba73-d58ef86911bc	9d50e72f-e7d9-464e-a9eb-b689e8267df2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":452,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:26:56
3015	9d5100c4-5536-4d63-8b35-ff8ced4b86ca	9d5100c4-5abf-4c8d-969a-de4c5f4abd6c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:38:27
3016	9d5100c4-5952-4d0a-8f86-774606d60888	9d5100c4-5abf-4c8d-969a-de4c5f4abd6c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:38:27
3017	9d5100c4-59ab-471f-8393-1c24bfeff5fa	9d5100c4-5abf-4c8d-969a-de4c5f4abd6c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":301,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:38:27
11292	9d5cb235-9763-4153-89dc-fd6734adee2f	9d5cb235-c74f-49ce-95b4-5f760f725e28	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 10:08:44
11293	9d5cb235-c20d-42d3-b903-6185f62bcf75	9d5cb235-c74f-49ce-95b4-5f760f725e28	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"75.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 10:08:44
11294	9d5cb235-c25a-49bf-999c-8a4aeb7c1959	9d5cb235-c74f-49ce-95b4-5f760f725e28	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 10:08:44
11295	9d5cb235-c600-4b2a-8be5-2c66a194e2af	9d5cb235-c74f-49ce-95b4-5f760f725e28	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 10:08:44
2321	9d50e6f0-4490-4893-806a-21326a3d6f66	9d50e6f0-6262-4fd4-a3a4-b2b94f966e3f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 13:26:14
2322	9d50e6f0-5ce1-4fa0-932e-191e59caf093	9d50e6f0-6262-4fd4-a3a4-b2b94f966e3f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 13:26:14
2323	9d50e6f0-5d26-4a30-bfcb-f4c1da48e760	9d50e6f0-6262-4fd4-a3a4-b2b94f966e3f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 13:26:14
2324	9d50e6f0-60d0-4785-9568-f48ba5573ae3	9d50e6f0-6262-4fd4-a3a4-b2b94f966e3f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 13:26:14
2325	9d50e6f0-6131-4d5a-9475-a0c6e3ff5129	9d50e6f0-6262-4fd4-a3a4-b2b94f966e3f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:26:14
3018	9d5100c4-a479-4ee1-bfd0-d401e7f6086a	9d5100c4-ee64-431d-a0c9-e43b63688f6e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:38:27
3019	9d5100c4-e8c0-4067-a0d0-94d459af15f4	9d5100c4-ee64-431d-a0c9-e43b63688f6e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"150.40","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:38:28
3020	9d5100c4-e91b-49e6-b005-98ca3a1aeeae	9d5100c4-ee64-431d-a0c9-e43b63688f6e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:38:28
3021	9d5100c4-ed2d-4c90-bc44-115510eff37a	9d5100c4-ee64-431d-a0c9-e43b63688f6e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 14:38:28
3022	9d5100c4-ed83-49e3-9d1e-d5db28238007	9d5100c4-ee64-431d-a0c9-e43b63688f6e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":358,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:38:28
14753	9d5ec159-dce0-4b5a-ad4b-2229a60c34f0	9d5ec159-dde3-4a7d-9432-a16a9fa83ce7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/56","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":56,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"06-11-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":157,"loans_codigo":56,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"20833.333333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:42:30.000000Z","updated_at":"2024-10-30T15:42:30.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":158,"loans_codigo":56,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"20833.333333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:42:30.000000Z","updated_at":"2024-10-30T15:42:30.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":159,"loans_codigo":56,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"20833.333333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:42:30.000000Z","updated_at":"2024-10-30T15:42:30.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":160,"loans_codigo":56,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"20833.333333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:42:30.000000Z","updated_at":"2024-10-30T15:42:30.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":161,"loans_codigo":56,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"20833.333333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:42:30.000000Z","updated_at":"2024-10-30T15:42:30.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":392,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:42:43
17252	9d65519f-d325-4a4e-8320-e051af8fdbbc	9d65519f-d448-4c3a-bd5c-6406954db587	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:01:06
14754	9d5ec276-9657-49f7-afef-2d5696390503	9d5ec276-deb4-4caa-a998-503a25af679d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-30 10:45:50
14755	9d5ec276-d94b-46d4-bf90-e76ae6f4d7ce	9d5ec276-deb4-4caa-a998-503a25af679d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"144.42","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-30 10:45:50
14756	9d5ec276-dd04-4022-a851-039e30cbf119	9d5ec276-deb4-4caa-a998-503a25af679d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 10:45:50
2896	9d50fd55-8ed8-452a-9269-f6653c4decad	9d50fd55-c986-4aee-ad86-9cc30222e306	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:28:51
2897	9d50fd55-c5b9-49e3-b145-644fdc2f9708	9d50fd55-c986-4aee-ad86-9cc30222e306	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:28:52
2898	9d50fd55-c79d-4490-b7a8-c0dfadda40e9	9d50fd55-c986-4aee-ad86-9cc30222e306	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":541,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:28:52
3023	9d5100c5-6459-4228-b1a6-4e49253deece	9d5100c5-a296-4a90-90a8-3435d961a02e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 14:38:28
3024	9d5100c5-9817-4709-9248-66e5f3b56dc3	9d5100c5-a296-4a90-90a8-3435d961a02e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"84.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:38:28
3025	9d5100c5-98a7-4712-bb82-4b4e2a44ae69	9d5100c5-a296-4a90-90a8-3435d961a02e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:38:28
14757	9d5ec276-dd75-4bdf-a1a4-ef22eca2b8ec	9d5ec276-deb4-4caa-a998-503a25af679d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":400,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:45:50
3026	9d5100c5-a066-4430-a3a5-5130b0a0a4ff	9d5100c5-a296-4a90-90a8-3435d961a02e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 14:38:28
15561	9d5ee187-dcc2-40be-90b1-cc279602b0d2	9d5ee187-e1e7-4e8c-a5ff-51cfca20b95c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"50.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":24,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-30 12:12:42
15562	9d5ee187-e07a-41da-ace9-fa9c79ae4243	9d5ee187-e1e7-4e8c-a5ff-51cfca20b95c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 12:12:42
15563	9d5ee187-e0db-445a-acba-365fa0839379	9d5ee187-e1e7-4e8c-a5ff-51cfca20b95c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":302,"memory":22,"hostname":"EderCortes"}	2024-10-30 12:12:42
2899	9d50fd56-4da5-4a2b-9df2-34b54c8edeae	9d50fd56-a9fc-4497-9453-d4639c73df62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:28:52
2900	9d50fd56-a0bc-4404-9af3-2070157496ea	9d50fd56-a9fc-4497-9453-d4639c73df62	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"167.47","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:28:52
2901	9d50fd56-a13f-44ce-b36e-197c9e0ba432	9d50fd56-a9fc-4497-9453-d4639c73df62	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:28:52
2902	9d50fd56-a7e4-4313-b40a-ff3f7b8bfcfd	9d50fd56-a9fc-4497-9453-d4639c73df62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:28:52
2903	9d50fd56-a84d-460d-a82e-d28b1cd85526	9d50fd56-a9fc-4497-9453-d4639c73df62	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":534,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:28:52
3027	9d5100c5-a0ff-42f2-b001-379466b41563	9d5100c5-a296-4a90-90a8-3435d961a02e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":440,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:38:28
14758	9d5ec2d7-31fd-4e71-ab10-6653d0e5af00	9d5ec2d7-4ffa-4e66-bc81-45b6f5d44a01	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-30 10:46:53
14759	9d5ec2d7-4a55-4253-8753-77c583e60824	9d5ec2d7-4ffa-4e66-bc81-45b6f5d44a01	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"38.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-10-30 10:46:53
4900	9d51364c-4d27-4c15-94bb-53339f0cea32	9d51364c-748e-4f1d-8a7e-7dcb56b94ce5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 17:08:08
4901	9d51364c-7174-4f99-975e-f6b101fb5bd0	9d51364c-748e-4f1d-8a7e-7dcb56b94ce5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 17:08:08
4902	9d51364c-72d0-4517-99c6-1a0a750c0b32	9d51364c-748e-4f1d-8a7e-7dcb56b94ce5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:08
14760	9d5ec2d7-4e53-4de4-8cbd-b001a13229d7	9d5ec2d7-4ffa-4e66-bc81-45b6f5d44a01	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 10:46:53
14761	9d5ec2d7-4eb9-4af5-a2e1-068afc4b1a07	9d5ec2d7-4ffa-4e66-bc81-45b6f5d44a01	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":280,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:46:53
15564	9d5ee18c-e3f9-4eff-ab09-48ff28aa2763	9d5ee18d-385d-4ce3-a5b6-7788a39ec6f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 12:12:45
2904	9d50fd57-1849-425d-b7e1-941b62003fd6	9d50fd57-3ad4-429c-aa41-3bae01a22c9d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:28:52
2905	9d50fd57-3530-4f1e-97b6-c1e67e1b9ac0	9d50fd57-3ad4-429c-aa41-3bae01a22c9d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:28:52
2451	9d50f8cb-10fb-46f1-b548-017fbc4446d3	9d50f8cc-296e-4031-886d-d228e1fe26a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:16:10
2452	9d50f8cc-27e8-4ad6-9925-c85507654483	9d50f8cc-296e-4031-886d-d228e1fe26a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:16:10
2453	9d50f8cc-288c-42d3-979f-e54952c613c2	9d50f8cc-296e-4031-886d-d228e1fe26a2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":941,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:16:10
2906	9d50fd57-358f-4a42-8454-112435bef925	9d50fd57-3ad4-429c-aa41-3bae01a22c9d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:28:52
2907	9d50fd57-39a1-4569-94d2-f91dcc363156	9d50fd57-3ad4-429c-aa41-3bae01a22c9d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 14:28:52
2908	9d50fd57-39eb-4f1d-9cdb-f4a388c81f31	9d50fd57-3ad4-429c-aa41-3bae01a22c9d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:28:52
3028	9d5100c6-37a6-4200-af6e-ba488c6fee57	9d5100c6-6ae8-4ca5-a662-06fef22f5dad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 14:38:29
3029	9d5100c6-5f05-4a10-a8b9-db4adaee0eff	9d5100c6-6ae8-4ca5-a662-06fef22f5dad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"59.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:38:29
3030	9d5100c6-5fbb-4b59-bf70-98872a2f30bf	9d5100c6-6ae8-4ca5-a662-06fef22f5dad	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:38:29
3031	9d5100c6-6817-47d1-a5e8-5dd30e5d065f	9d5100c6-6ae8-4ca5-a662-06fef22f5dad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 14:38:29
3032	9d5100c6-68a3-430a-9875-5e2bbddc5b28	9d5100c6-6ae8-4ca5-a662-06fef22f5dad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":481,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:38:29
4903	9d51364c-ce1b-4876-bb3e-7b529e45baca	9d51364d-1a9a-493b-9082-b5eb988c7ee4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 17:08:09
4746	9d5134fc-8290-4e11-982a-09b3835941ef	9d5134fc-cb5f-4d7a-b3dc-d4c567f3be03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 17:04:28
4747	9d5134fc-c9af-4eb6-9f37-a1667d1b4067	9d5134fc-cb5f-4d7a-b3dc-d4c567f3be03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 17:04:28
4904	9d51364d-13ca-4c05-aca9-53268597d56c	9d51364d-1a9a-493b-9082-b5eb988c7ee4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"153.40","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:08:09
4905	9d51364d-1416-4b47-a030-071dfdfbc971	9d51364d-1a9a-493b-9082-b5eb988c7ee4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:08:09
4906	9d51364d-1912-4aba-af14-05fcfdc561da	9d51364d-1a9a-493b-9082-b5eb988c7ee4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 17:08:09
14762	9d5ec2e1-4edf-450b-89b3-e76954753c12	9d5ec2e1-6d59-462f-9bad-8b8ae5701a62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 10:47:00
14763	9d5ec2e1-6828-44dc-bcf4-c21d00a6b459	9d5ec2e1-6d59-462f-9bad-8b8ae5701a62	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":179,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 10:47:00
14764	9d5ec2e1-6874-4aad-9d36-c74ef199b945	9d5ec2e1-6d59-462f-9bad-8b8ae5701a62	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-30 10:47:00
2454	9d50f8cd-6d1c-4e52-b938-13988a728152	9d50f8cd-b858-4a24-84b8-0cd9e5c9dc01	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:16:11
2455	9d50f8cd-b39a-4b0c-9cd2-f021f4c06ce1	9d50f8cd-b858-4a24-84b8-0cd9e5c9dc01	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"156.74","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:16:11
2456	9d50f8cd-b3e4-4c05-adb5-809a7beb07bd	9d50f8cd-b858-4a24-84b8-0cd9e5c9dc01	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:16:11
2457	9d50f8cd-b701-4d82-9240-3a256e4b27ed	9d50f8cd-b858-4a24-84b8-0cd9e5c9dc01	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:16:11
2458	9d50f8cd-b745-46da-803f-81f7d2979443	9d50f8cd-b858-4a24-84b8-0cd9e5c9dc01	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":487,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:16:11
2909	9d50fd58-29be-4a9b-9182-c8e47d9eb57c	9d50fd58-7202-48f9-8f91-c4590c7f00c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 14:28:53
2910	9d50fd58-656f-4d93-96da-165c5c12d4ef	9d50fd58-7202-48f9-8f91-c4590c7f00c8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"82.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:28:53
2911	9d50fd58-65f0-49a2-85bc-e8e63fe6981b	9d50fd58-7202-48f9-8f91-c4590c7f00c8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:28:53
2912	9d50fd58-6f24-4809-ac0a-0b023e1a4c1d	9d50fd58-7202-48f9-8f91-c4590c7f00c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 14:28:53
2913	9d50fd58-6fbd-4142-8083-90b7991f3919	9d50fd58-7202-48f9-8f91-c4590c7f00c8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":778,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:28:53
4748	9d5134fc-ca60-40ff-aefa-32963160bedb	9d5134fc-cb5f-4d7a-b3dc-d4c567f3be03	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:04:28
4907	9d51364d-1971-4525-9381-efcebd55a7f7	9d51364d-1a9a-493b-9082-b5eb988c7ee4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":383,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:09
14765	9d5ec2e1-6bfa-4623-a4d1-54761833f824	9d5ec2e1-6d59-462f-9bad-8b8ae5701a62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 10:47:00
20796	9d66fc27-2941-44de-8c9f-c8dbe10011fc	9d66fc27-2c27-4d89-af2a-569dc07da6cb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":130,"memory":20,"hostname":"EderCortes"}	2024-11-03 12:53:46
2459	9d50f8e0-4288-46f4-b859-dbda6519761a	9d50f8e0-e0a5-4bf0-90f8-add9d031eb55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:16:23
2460	9d50f8e0-db0c-428d-b635-5459ed4f0fdf	9d50f8e0-e0a5-4bf0-90f8-add9d031eb55	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:16:24
2461	9d50f8e0-db6b-4dc2-9077-b8a700decd6e	9d50f8e0-e0a5-4bf0-90f8-add9d031eb55	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:16:24
2462	9d50f8e0-df1d-4ffa-a37a-fc7496f7b379	9d50f8e0-e0a5-4bf0-90f8-add9d031eb55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:16:24
2463	9d50f8e0-df6a-4293-ba49-14597b377249	9d50f8e0-e0a5-4bf0-90f8-add9d031eb55	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":600,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:16:24
2914	9d50fd58-d76e-4915-b563-d1e9d00c2046	9d50fd59-2362-4d66-bf30-c671e57d72e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 14:28:54
2915	9d50fd59-1df1-45e4-a92f-73ee6cc9c3e6	9d50fd59-2362-4d66-bf30-c671e57d72e8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"160.58","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:28:54
2916	9d50fd59-1e4e-40f7-b3c9-65bd77d524d1	9d50fd59-2362-4d66-bf30-c671e57d72e8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:28:54
2917	9d50fd59-2227-4b48-9ac5-8de879740ca3	9d50fd59-2362-4d66-bf30-c671e57d72e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 14:28:54
2918	9d50fd59-226d-44bb-9397-c58877423a2b	9d50fd59-2362-4d66-bf30-c671e57d72e8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":424,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:28:54
4749	9d5134fd-13f0-4bd2-a79d-857d3e661bb5	9d5134fd-3344-45c6-bf02-ed562caae096	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 17:04:29
4750	9d5134fd-2e0d-4f6e-a22d-e4530cdd2914	9d5134fd-3344-45c6-bf02-ed562caae096	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:04:29
4751	9d5134fd-2e5f-44a0-8184-ec2cb456fcd6	9d5134fd-3344-45c6-bf02-ed562caae096	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:04:29
4752	9d5134fd-324c-44a5-9bbb-a9455cb314ea	9d5134fd-3344-45c6-bf02-ed562caae096	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 17:04:29
4753	9d5134fd-3288-49a9-8f80-96e924ed07de	9d5134fd-3344-45c6-bf02-ed562caae096	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:04:29
4908	9d51364d-6d9e-45d1-948b-3e9761a7ddbd	9d51364d-8ed6-43b1-b2e5-c2db952c33a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 17:08:09
4909	9d51364d-88e9-46ca-82d2-1ccbe0ba3942	9d51364d-8ed6-43b1-b2e5-c2db952c33a5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:08:09
2464	9d50f8e1-2332-4c46-a329-da83032e172c	9d50f8e1-67d9-46b3-894b-f1ef30570370	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:16:24
2465	9d50f8e1-636b-48c9-9fef-92f9d4c9d04d	9d50f8e1-67d9-46b3-894b-f1ef30570370	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"144.61","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:16:24
2466	9d50f8e1-63b6-4904-9e69-62a77083efa1	9d50f8e1-67d9-46b3-894b-f1ef30570370	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:16:24
2467	9d50f8e1-66b3-471f-95dd-4e81bec5e70f	9d50f8e1-67d9-46b3-894b-f1ef30570370	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:16:24
2468	9d50f8e1-66f1-4413-8c9e-e4ff6f73d470	9d50f8e1-67d9-46b3-894b-f1ef30570370	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":332,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:16:24
4754	9d5134fd-7ef1-4d97-9db3-70ca43fbe4bf	9d5134fd-c363-4cec-bc3c-49f3e5ac62ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 17:04:29
4755	9d5134fd-bef8-426e-8e27-efeab7f7f5fb	9d5134fd-c363-4cec-bc3c-49f3e5ac62ec	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"143.31","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:04:29
4756	9d5134fd-bf5c-4911-859c-57a7491238d7	9d5134fd-c363-4cec-bc3c-49f3e5ac62ec	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:04:29
4757	9d5134fd-c26d-45db-865b-06414f393e9f	9d5134fd-c363-4cec-bc3c-49f3e5ac62ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 17:04:29
4758	9d5134fd-c2ab-4d8e-aecb-715ff17a32f3	9d5134fd-c363-4cec-bc3c-49f3e5ac62ec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":351,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:04:29
4910	9d51364d-8953-4e6a-990a-0cf540341165	9d51364d-8ed6-43b1-b2e5-c2db952c33a5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:08:09
4911	9d51364d-8d85-43be-a4cd-1268084977dc	9d51364d-8ed6-43b1-b2e5-c2db952c33a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 17:08:09
4912	9d51364d-8de0-4ffe-860b-419f495a3071	9d51364d-8ed6-43b1-b2e5-c2db952c33a5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:09
20797	9d66fc27-7cc4-41db-867a-d6777dc0814e	9d66fc27-9699-4b9a-bc77-b79b97e10371	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:53:46
20798	9d66fc27-927b-462f-adf9-88b8f39bf010	9d66fc27-9699-4b9a-bc77-b79b97e10371	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Lu%' or \\"users\\".\\"user_document\\"::text like '%Lu%') order by \\"users\\".\\"user_document\\" asc","time":"40.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 12:53:46
20799	9d66fc27-9564-45e6-98ca-52df24fdb13e	9d66fc27-9699-4b9a-bc77-b79b97e10371	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:53:46
4913	9d51364f-635c-48ee-9259-f73130ad4dac	9d51364f-a24c-40e0-a9e0-2271ca3fd51c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 17:08:10
4914	9d51364f-96a7-41a1-a7f6-ea5803678c9e	9d51364f-a24c-40e0-a9e0-2271ca3fd51c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"82.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:08:10
4915	9d51364f-9738-49b4-9f53-9fab5c899b2f	9d51364f-a24c-40e0-a9e0-2271ca3fd51c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:08:10
4916	9d51364f-a036-4fcf-9e9d-112c853d3204	9d51364f-a24c-40e0-a9e0-2271ca3fd51c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 17:08:10
2543	9d50fa2c-aa9b-4036-bfd3-ec41811e2ec1	9d50fa2c-de8f-477d-8d9c-f1d81167f519	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 14:20:01
2544	9d50fa2c-d611-49ef-9aff-167a93eab450	9d50fa2c-de8f-477d-8d9c-f1d81167f519	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"68.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:20:01
2545	9d50fa2c-d69e-4c36-9d93-b5b560518640	9d50fa2c-de8f-477d-8d9c-f1d81167f519	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:20:01
2546	9d50fa2c-dcbf-4de0-bf8e-574e5212399f	9d50fa2c-de8f-477d-8d9c-f1d81167f519	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 14:20:01
2547	9d50fa2c-dd3b-40fb-8f73-48e54282217f	9d50fa2c-de8f-477d-8d9c-f1d81167f519	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":422,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:20:01
4917	9d51364f-a0c6-4a42-9c48-4ba8eab21a4a	9d51364f-a24c-40e0-a9e0-2271ca3fd51c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":608,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:10
15565	9d5ee18c-fda2-412e-8227-dc077d468d9e	9d5ee18d-385d-4ce3-a5b6-7788a39ec6f4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"49.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"088d1fdbe045a08c3b0073ef22c7da32","hostname":"EderCortes"}	2024-10-30 12:12:46
15566	9d5ee18d-212d-4bc2-aad4-7610716848a3	9d5ee18d-385d-4ce3-a5b6-7788a39ec6f4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-30 12:12:46
14766	9d5ec2e1-6c4e-43e5-9b8e-01fd3aa18c09	9d5ec2e1-6d59-462f-9bad-8b8ae5701a62	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:47:00
14767	9d5ec2e1-b16d-408d-8512-82f74290868a	9d5ec2e1-cf76-4cbe-be41-865e970c0abf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 10:47:00
14768	9d5ec2e1-ca29-4877-89b1-e5ffe736115c	9d5ec2e1-cf76-4cbe-be41-865e970c0abf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":179,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 10:47:00
1788	9d50df02-7cd8-45dd-a3fb-e8f9affafa78	9d50df02-a4de-4be9-ac58-d2c20c5f1624	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 13:04:04
1789	9d50df02-a269-4d56-a36f-f0f54f27e524	9d50df02-a4de-4be9-ac58-d2c20c5f1624	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 13:04:04
1790	9d50df02-a34f-4b14-bf99-a0b62615c21f	9d50df02-a4de-4be9-ac58-d2c20c5f1624	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:04:04
14769	9d5ec2e1-ca7a-4b64-af7b-dcc30d5fc2ae	9d5ec2e1-cf76-4cbe-be41-865e970c0abf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-30 10:47:00
14770	9d5ec2e1-ce4a-48dc-897f-e3060d07bdf0	9d5ec2e1-cf76-4cbe-be41-865e970c0abf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 10:47:00
14771	9d5ec2e1-ce95-462b-a2f0-2805af904bb9	9d5ec2e1-cf76-4cbe-be41-865e970c0abf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:47:00
15567	9d5ee18d-2164-44e9-8d92-52b3b7e35b09	9d5ee18d-385d-4ce3-a5b6-7788a39ec6f4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-10-30 12:12:46
15568	9d5ee18d-3716-452c-bac6-bc6d0f60ee37	9d5ee18d-385d-4ce3-a5b6-7788a39ec6f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 12:12:46
15569	9d5ee18d-375f-46d7-b005-9e5b89dbaaf8	9d5ee18d-385d-4ce3-a5b6-7788a39ec6f4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":381,"memory":22,"hostname":"EderCortes"}	2024-10-30 12:12:46
17575	9d655e40-1f84-4232-b2f7-06df274db3f8	9d655e40-260d-4be2-8727-a2598dea0340	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"48.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":57,"hash":"2cc591e3eaf2792109e07ba331bc077f","hostname":"EderCortes"}	2024-11-02 17:36:25
17576	9d655e40-2448-444e-bc92-737533f6c41b	9d655e40-260d-4be2-8727-a2598dea0340	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:36:25
17577	9d655e40-24bc-4776-a9c3-cf5a5dcbcfd3	9d655e40-260d-4be2-8727-a2598dea0340	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"}]},"duration":287,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:36:25
15570	9d648c8f-2fac-4bf7-90b1-8a43098351b0	9d648c93-6aba-4116-8a6f-9f0a0fb70e46	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 07:50:05
15571	9d648c91-3f8a-4676-93f6-e95d9e64bfb8	9d648c93-6aba-4116-8a6f-9f0a0fb70e46	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"192.69","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 07:50:06
14772	9d5ec2e2-1112-4536-93d9-7bdf9b54577e	9d5ec2e2-2ed0-451d-b2f2-d03e81366ae0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 10:47:00
14773	9d5ec2e2-27fa-4fa4-8518-e13b9515f95e	9d5ec2e2-2ed0-451d-b2f2-d03e81366ae0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '56' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"40.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":193,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-30 10:47:00
2548	9d50fa2d-2834-45ea-8c42-faf022e4b560	9d50fa2d-485f-4ba9-8ca6-7ac0367c38bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 14:20:02
2549	9d50fa2d-4350-4aae-b0fc-182b694f1bde	9d50fa2d-485f-4ba9-8ca6-7ac0367c38bd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:20:02
2550	9d50fa2d-43b4-48dd-99aa-e0ebe3ddb017	9d50fa2d-485f-4ba9-8ca6-7ac0367c38bd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:20:02
2551	9d50fa2d-4731-4b72-873b-df83213fafa3	9d50fa2d-485f-4ba9-8ca6-7ac0367c38bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 14:20:02
2552	9d50fa2d-4774-4516-b426-d0f102954160	9d50fa2d-485f-4ba9-8ca6-7ac0367c38bd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:20:02
14774	9d5ec2e2-2854-49d0-b803-8fb6790f3c09	9d5ec2e2-2ed0-451d-b2f2-d03e81366ae0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-30 10:47:00
14775	9d5ec2e2-29fe-4402-b216-598c5781e1c6	9d5ec2e2-2ed0-451d-b2f2-d03e81366ae0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '56' order by \\"item_loans\\".\\"id\\" asc","time":"1.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":194,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-30 10:47:00
14776	9d5ec2e2-2a30-405b-acde-d4b956bb4c4c	9d5ec2e2-2ed0-451d-b2f2-d03e81366ae0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-10-30 10:47:00
14777	9d5ec2e2-2d6f-4769-8d8c-c6034a599ab5	9d5ec2e2-2ed0-451d-b2f2-d03e81366ae0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-30 10:47:00
14778	9d5ec2e2-2dc1-43bf-b4ab-f1adcc111fbd	9d5ec2e2-2ed0-451d-b2f2-d03e81366ae0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/56","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":56,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":50,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"06-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":500000,"user_customer":19,"user_cobrador":14,"created_at":"2024-10-30T15:42:30.000000Z","updated_at":"2024-10-30T15:42:30.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-06 00:00:00"},"items":[{"id":157,"loans_codigo":56,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"20833.333333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:42:30.000000Z","updated_at":"2024-10-30T15:42:30.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":158,"loans_codigo":56,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"20833.333333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:42:30.000000Z","updated_at":"2024-10-30T15:42:30.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":159,"loans_codigo":56,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"20833.333333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:42:30.000000Z","updated_at":"2024-10-30T15:42:30.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":160,"loans_codigo":56,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"20833.333333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:42:30.000000Z","updated_at":"2024-10-30T15:42:30.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":161,"loans_codigo":56,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"20833.333333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:42:30.000000Z","updated_at":"2024-10-30T15:42:30.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:47:00
15572	9d648c91-4b3c-4eeb-971d-7c16d6a764c2	9d648c93-6aba-4116-8a6f-9f0a0fb70e46	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-11-02 07:50:06
15573	9d648c93-296f-4b41-8834-7200b52c7391	9d648c93-6aba-4116-8a6f-9f0a0fb70e46	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 07:50:07
16835	9d64d6f4-4936-413a-ab18-738eebc25271	9d64d6f4-9324-4ea8-acd7-fcebeee32e92	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-02 11:18:06
22762	9d67fb1d-b11c-495c-90b6-12e6fb177ed6	9d67fb1d-b4da-4ab7-a8d4-07058e4d4dc0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":181,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:46:42
14779	9d5ec2e5-8c89-4bac-a1ae-3ec20dcb189d	9d5ec2e5-a8f7-45e7-9100-09f9eecbde96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-30 10:47:03
14780	9d5ec2e5-a34c-4f26-bbb1-3dd956ee58db	9d5ec2e5-a8f7-45e7-9100-09f9eecbde96	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"44.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-10-30 10:47:03
5174	9d5136a3-f8f9-4265-8355-f2c17fd167f4	9d5136a4-3069-4d7e-a027-67a111aab3c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-10-23 17:09:06
5175	9d5136a4-2d7c-4d7f-ab3f-81ee2835f360	9d5136a4-3069-4d7e-a027-67a111aab3c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-10-23 17:09:06
2553	9d50fa2e-0d46-4639-9231-4f9679dc7794	9d50fa2e-6c1e-418f-a7fa-c0ca4b41aabb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 14:20:02
2554	9d50fa2e-5b16-40e3-b1d3-0a354edc6d58	9d50fa2e-6c1e-418f-a7fa-c0ca4b41aabb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"132.63","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:20:02
2555	9d50fa2e-5be6-4ec6-a7b0-096e0d118b8f	9d50fa2e-6c1e-418f-a7fa-c0ca4b41aabb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:20:02
2556	9d50fa2e-68eb-4079-b1a3-2770c3bf5632	9d50fa2e-6c1e-418f-a7fa-c0ca4b41aabb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 14:20:02
2557	9d50fa2e-69c7-422b-a87d-832f1632f233	9d50fa2e-6c1e-418f-a7fa-c0ca4b41aabb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":725,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:20:02
5176	9d5136a4-2ed4-4ef5-8281-442b9a318c95	9d5136a4-3069-4d7e-a027-67a111aab3c3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":524,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:09:06
14781	9d5ec2e5-a76a-4cb0-a682-41e01f79a2e1	9d5ec2e5-a8f7-45e7-9100-09f9eecbde96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-30 10:47:03
14782	9d5ec2e5-a7df-48d1-a69f-7c90c66efb16	9d5ec2e5-a8f7-45e7-9100-09f9eecbde96	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:47:03
15574	9d648c93-310a-412d-ad02-66a75a107796	9d648c93-6aba-4116-8a6f-9f0a0fb70e46	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":5449,"memory":22,"hostname":"EderCortes"}	2024-11-02 07:50:07
5177	9d5136a4-b650-4ae2-87e0-413a54e6c733	9d5136a5-141c-4660-b758-5b28807436b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-10-23 17:09:06
3124	9d5102cd-7686-4328-9819-6a69a89f8ab7	9d5102cd-b03b-415d-ae20-4a403bc6ccb8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:44:09
3125	9d5102cd-acf9-4566-845b-d16496a81734	9d5102cd-b03b-415d-ae20-4a403bc6ccb8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:44:09
3126	9d5102cd-aea4-4b4b-8f78-b3c77d205c68	9d5102cd-b03b-415d-ae20-4a403bc6ccb8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":537,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:44:09
2558	9d50fa2f-0522-4df2-b94d-e1cb3bd5131c	9d50fa2f-3078-4965-85d2-4449c5437734	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 14:20:03
2559	9d50fa2f-2802-4d7c-af25-072e3142eea9	9d50fa2f-3078-4965-85d2-4449c5437734	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"55.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:20:03
2560	9d50fa2f-2876-4ed8-8fe6-72c7728548dc	9d50fa2f-3078-4965-85d2-4449c5437734	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:20:03
2561	9d50fa2f-2ed6-4f3d-b59b-1c8483c7072b	9d50fa2f-3078-4965-85d2-4449c5437734	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 14:20:03
2562	9d50fa2f-2f2f-41a6-b64b-cab1ef615ffc	9d50fa2f-3078-4965-85d2-4449c5437734	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":469,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:20:03
5178	9d5136a5-0b0b-481a-a9c2-1b099924be40	9d5136a5-141c-4660-b758-5b28807436b5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"179.94","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:09:06
5179	9d5136a5-0b8b-48f5-be8b-560599ad62ce	9d5136a5-141c-4660-b758-5b28807436b5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:09:06
5180	9d5136a5-125c-486b-90e5-49f827996bd2	9d5136a5-141c-4660-b758-5b28807436b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-10-23 17:09:06
5181	9d5136a5-12e0-48f1-8806-fe1daa917ca5	9d5136a5-141c-4660-b758-5b28807436b5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":546,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:09:06
14783	9d5ec2f1-2cac-45b0-a295-7c6a6e8151e1	9d5ec2f1-477b-4a20-9929-6909c5e4d98e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-30 10:47:10
14784	9d5ec2f1-42a4-448d-bcc6-54b17bd67643	9d5ec2f1-477b-4a20-9929-6909c5e4d98e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"43.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-30 10:47:10
14785	9d5ec2f1-45e8-4796-a252-98d39e133591	9d5ec2f1-477b-4a20-9929-6909c5e4d98e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-30 10:47:10
20800	9d66fc27-95a5-466a-a74d-5ff7e66f7c27	9d66fc27-9699-4b9a-bc77-b79b97e10371	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Lu"},"session":[],"response_status":200,"response":{"data":[]},"duration":218,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:53:46
5182	9d5136a5-9896-4fae-a2e8-d663ff1ed6d8	9d5136a5-d0d4-481a-b2a1-7f5af1f4aa49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-10-23 17:09:07
2108	9d50e382-18fd-448d-bdc5-106c37a7a3b0	9d50e382-3aee-4a7e-8fb3-87b943a7b631	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 13:16:38
2109	9d50e382-3951-4352-94dd-fdabbd99ff2a	9d50e382-3aee-4a7e-8fb3-87b943a7b631	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 13:16:39
2110	9d50e382-39f3-461c-b333-49c565b8d1ca	9d50e382-3aee-4a7e-8fb3-87b943a7b631	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":256,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:16:39
5183	9d5136a5-c521-4888-bc1a-542de938b7c5	9d5136a5-d0d4-481a-b2a1-7f5af1f4aa49	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"69.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:09:07
5184	9d5136a5-c5bb-41c1-8c87-985c8c4adcf0	9d5136a5-d0d4-481a-b2a1-7f5af1f4aa49	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:09:07
5185	9d5136a5-ce97-4b38-a268-5ad1d26be555	9d5136a5-d0d4-481a-b2a1-7f5af1f4aa49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-10-23 17:09:07
3127	9d5102ce-291d-4d53-92d6-c2cf845c52e5	9d5102ce-5d43-4cee-87c4-9ef3b392453f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:44:09
3128	9d5102ce-5340-49c8-88f4-8b70666d6ddf	9d5102ce-5d43-4cee-87c4-9ef3b392453f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"72.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:44:09
3129	9d5102ce-53bf-440a-82a1-c43afd1e7037	9d5102ce-5d43-4cee-87c4-9ef3b392453f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:44:09
3130	9d5102ce-5afc-4552-9965-e9490adc74b1	9d5102ce-5d43-4cee-87c4-9ef3b392453f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:44:09
5186	9d5136a5-cf34-468e-b9df-08d5b26f07bb	9d5136a5-d0d4-481a-b2a1-7f5af1f4aa49	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":461,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:09:07
14786	9d5ec2f1-465d-4222-808f-bfff87ae54e9	9d5ec2f1-477b-4a20-9929-6909c5e4d98e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:47:10
16836	9d64d6f4-8a59-4332-91b5-7ee7fe8ce62e	9d64d6f4-9324-4ea8-acd7-fcebeee32e92	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"152.81","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 11:18:06
16837	9d64d6f4-8e17-4449-8a81-841b1261c49b	9d64d6f4-9324-4ea8-acd7-fcebeee32e92	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 11:18:06
16838	9d64d6f4-8e5b-4577-8230-702ed835d9fe	9d64d6f4-9324-4ea8-acd7-fcebeee32e92	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 11:18:06
2111	9d50e382-9aaf-4e39-926a-f1920b875312	9d50e382-e716-4e4e-b99e-4c7543f77285	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 13:16:39
2112	9d50e382-e1b0-480f-9968-a15631449f47	9d50e382-e716-4e4e-b99e-4c7543f77285	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"152.92","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:16:39
2113	9d50e382-e1fb-402d-9b19-bf15a96916cf	9d50e382-e716-4e4e-b99e-4c7543f77285	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 13:16:39
2114	9d50e382-e5da-4332-ad5b-44fb96c1137b	9d50e382-e716-4e4e-b99e-4c7543f77285	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 13:16:39
2115	9d50e382-e61f-435b-bb89-a9aad67c6e81	9d50e382-e716-4e4e-b99e-4c7543f77285	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":416,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:16:39
3131	9d5102ce-5b94-4725-a12a-72885017f2f1	9d5102ce-5d43-4cee-87c4-9ef3b392453f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":403,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:44:09
5187	9d5136a6-7cff-4657-870e-7e845aa2cdc9	9d5136a6-d28b-4c22-ae3a-8a9eeec51de8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-10-23 17:09:07
5188	9d5136a6-c83c-4bf0-b1d6-4721d57b2c6f	9d5136a6-d28b-4c22-ae3a-8a9eeec51de8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"112.76","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:09:08
5189	9d5136a6-c8dd-4236-8589-d895dc1f9547	9d5136a6-d28b-4c22-ae3a-8a9eeec51de8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:09:08
5190	9d5136a6-d05a-4e3e-8129-e96c87aa80db	9d5136a6-d28b-4c22-ae3a-8a9eeec51de8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-10-23 17:09:08
5191	9d5136a6-d104-488d-be83-c073726e4069	9d5136a6-d28b-4c22-ae3a-8a9eeec51de8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":635,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:09:08
14787	9d5ec304-8489-4c52-924a-bb272071191b	9d5ec304-a31a-4a45-8fb1-824cac169ed0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-30 10:47:23
5332	9d513837-3fbd-4bce-aa85-f077212de7ea	9d513837-95f8-4bef-96af-197e4964f10d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 17:13:30
14788	9d5ec304-9a34-4429-ac72-151d8adbf56c	9d5ec304-a31a-4a45-8fb1-824cac169ed0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 56\\n                        ","time":"42.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"49618c9c61809bcc9178d61955ea8e18","hostname":"EderCortes"}	2024-10-30 10:47:23
2116	9d50e383-351b-4a6e-8960-97b84b0a149a	9d50e383-7f0f-4fff-9cda-d8ffee675e9a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 13:16:39
2117	9d50e383-7983-47bf-9813-0288ba0ac307	9d50e383-7f0f-4fff-9cda-d8ffee675e9a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"152.07","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:16:39
2118	9d50e383-79cf-4518-a051-2b67b48fdc7d	9d50e383-7f0f-4fff-9cda-d8ffee675e9a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 13:16:39
2119	9d50e383-7d88-433b-a41d-fe60d40d963f	9d50e383-7f0f-4fff-9cda-d8ffee675e9a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 13:16:39
2120	9d50e383-7dda-40fb-a3a3-b8e74db8fcec	9d50e383-7f0f-4fff-9cda-d8ffee675e9a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":375,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:16:39
3132	9d5102ce-d543-429a-8caa-c5499e075a7a	9d5102ce-f96d-43d1-bcfc-c92adb2d0ebd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:44:10
3133	9d5102ce-f389-4c46-b346-86df99cb13ff	9d5102ce-f96d-43d1-bcfc-c92adb2d0ebd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:44:10
2179	9d50e4ef-9eea-4d95-9a99-82dafcf10779	9d50e4ef-a226-4765-87ee-c6faa7137b34	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":170,"memory":20,"hostname":"EderCortes"}	2024-10-23 13:20:38
3134	9d5102ce-f3dc-4b5a-9de8-cb3409a53022	9d5102ce-f96d-43d1-bcfc-c92adb2d0ebd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:44:10
3135	9d5102ce-f7e4-41b0-a10e-a50c76489106	9d5102ce-f96d-43d1-bcfc-c92adb2d0ebd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 14:44:10
3136	9d5102ce-f850-439a-8c2e-9d239b0ef5cb	9d5102ce-f96d-43d1-bcfc-c92adb2d0ebd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:44:10
5192	9d5136a7-7354-45fc-84ef-4d5967822b36	9d5136a7-d021-4f57-b165-1c9e2ecb6e47	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-10-23 17:09:08
5193	9d5136a7-c644-45e8-90b3-e2a29a7a21b0	9d5136a7-d021-4f57-b165-1c9e2ecb6e47	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"171.33","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:09:08
5194	9d5136a7-c6df-4484-99b9-d2db44636cb1	9d5136a7-d021-4f57-b165-1c9e2ecb6e47	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:09:08
5195	9d5136a7-ce2b-47ea-b465-b789c942503e	9d5136a7-d021-4f57-b165-1c9e2ecb6e47	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":29,"hostname":"EderCortes"}	2024-10-23 17:09:08
5333	9d513837-93b5-4ad2-b56d-910e680e7e01	9d513837-95f8-4bef-96af-197e4964f10d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 17:13:30
5334	9d513837-94cb-4a01-9ea2-90fbedeb2d54	9d513837-95f8-4bef-96af-197e4964f10d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":481,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:13:30
16839	9d64d6f4-91e6-4bea-a568-9cae8796e95c	9d64d6f4-9324-4ea8-acd7-fcebeee32e92	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-02 11:18:06
20801	9d66fc27-dcb9-437f-a0c8-a5a566e6b8ab	9d66fc28-2038-4289-a57a-6cb382467f80	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:53:46
2121	9d50e384-8587-4857-a6ae-165f8ae0a191	9d50e384-d64d-477b-91e4-041135d97e63	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 13:16:40
2122	9d50e384-d0a4-484d-88cf-1c143066c413	9d50e384-d64d-477b-91e4-041135d97e63	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"163.89","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 13:16:40
2123	9d50e384-d121-47eb-ae83-f39374405418	9d50e384-d64d-477b-91e4-041135d97e63	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 13:16:40
2124	9d50e384-d4cd-4831-b5ef-da4f8a2730fb	9d50e384-d64d-477b-91e4-041135d97e63	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 13:16:40
2125	9d50e384-d52a-4f99-b276-253e9d2308cd	9d50e384-d64d-477b-91e4-041135d97e63	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":488,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:16:40
3137	9d5102cf-c2b8-49de-969b-2ea1c591a677	9d5102d0-3d7d-4ab1-8eae-b6910a86c175	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 14:44:10
3138	9d5102d0-338e-4c8b-bab3-147a6aafc5ac	9d5102d0-3d7d-4ab1-8eae-b6910a86c175	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"208.18","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:44:11
2180	9d50e4f0-5466-41c4-a57e-cbb70fca2893	9d50e4f0-97e3-478d-9161-8c317ca754ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 13:20:39
2181	9d50e4f0-9355-48f7-9df8-c5f422c93a27	9d50e4f0-97e3-478d-9161-8c317ca754ac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%eder%' or \\"users\\".\\"user_document\\"::text like '%eder%' order by \\"users\\".\\"user_document\\" asc","time":"141.14","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:20:39
2182	9d50e4f0-96bc-4ec4-a55a-2ee0b3ccf77e	9d50e4f0-97e3-478d-9161-8c317ca754ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 13:20:39
3139	9d5102d0-3433-4303-ab3a-dd3df70cbe30	9d5102d0-3d7d-4ab1-8eae-b6910a86c175	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:44:11
3140	9d5102d0-3b8f-444c-8ac2-944a64fc0516	9d5102d0-3d7d-4ab1-8eae-b6910a86c175	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 14:44:11
3141	9d5102d0-3bf2-469d-a503-1cc7dedeb5e9	9d5102d0-3d7d-4ab1-8eae-b6910a86c175	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":812,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:44:11
5196	9d5136a7-cead-44d9-b841-56ec9637cf57	9d5136a7-d021-4f57-b165-1c9e2ecb6e47	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":616,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:09:08
5335	9d513837-effa-42ea-9c31-27cee0d5596d	9d513838-1473-478a-897f-b331baa6afac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 17:13:31
2126	9d50e39c-27ff-473b-a20f-0590c83f9cf7	9d50e39c-2b06-4342-ae9d-273c3f8ac4d1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":152,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:16:56
3142	9d5102d0-bab6-4d82-9568-2b55a32816d4	9d5102d0-e0f1-4676-be19-19495d10e47c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 14:44:11
3143	9d5102d0-db47-4e89-95af-cd62bb0134e6	9d5102d0-e0f1-4676-be19-19495d10e47c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"49.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:44:11
2132	9d50e3bb-81c8-4f20-8b3d-2584bfcca2ab	9d50e3bb-af10-4405-bbe4-99c6daf93ce7	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 13:17:16
2133	9d50e3bb-ace9-4da4-aaab-753392100494	9d50e3bb-af10-4405-bbe4-99c6daf93ce7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 13:17:16
2134	9d50e3bb-add2-4277-aa8a-9778573be74b	9d50e3bb-af10-4405-bbe4-99c6daf93ce7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:17:16
3144	9d5102d0-db96-4773-b046-9f0d67c579b8	9d5102d0-e0f1-4676-be19-19495d10e47c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:44:11
2602	9d50faea-84e3-4089-88a9-8e22a1d16060	9d50faea-d1d3-42eb-930e-03b1392a01b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 14:22:06
2603	9d50faea-cfe6-47b7-ae15-7344dbee672f	9d50faea-d1d3-42eb-930e-03b1392a01b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 14:22:06
2604	9d50faea-d0d2-4234-89e0-41e76f72d7f7	9d50faea-d1d3-42eb-930e-03b1392a01b1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":363,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:22:06
3145	9d5102d0-df47-4476-8223-74f0338489ab	9d5102d0-e0f1-4676-be19-19495d10e47c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 14:44:11
3146	9d5102d0-df8e-427b-be45-4e2cb55a3d5a	9d5102d0-e0f1-4676-be19-19495d10e47c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":393,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:44:11
16840	9d64d6f4-922f-4bff-9493-2701391684c7	9d64d6f4-9324-4ea8-acd7-fcebeee32e92	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":334,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:18:06
14789	9d5ec304-9da0-4d27-b083-44cc486da104	9d5ec304-a31a-4a45-8fb1-824cac169ed0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '56' order by \\"item_loans\\".\\"id\\" asc","time":"1.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-30 10:47:23
20802	9d66fc28-1c36-473b-a714-66df2c90fc57	9d66fc28-2038-4289-a57a-6cb382467f80	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Lui%' or \\"users\\".\\"user_document\\"::text like '%Lui%') order by \\"users\\".\\"user_document\\" asc","time":"146.60","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 12:53:47
14790	9d5ec304-9dd4-4908-9d23-924da191214c	9d5ec304-a31a-4a45-8fb1-824cac169ed0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-10-30 10:47:23
14791	9d5ec304-a1b6-49d1-bef7-754f5a261105	9d5ec304-a31a-4a45-8fb1-824cac169ed0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-30 10:47:23
20803	9d66fc28-1f13-4e56-aa3c-2a8c149419d0	9d66fc28-2038-4289-a57a-6cb382467f80	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:53:47
2127	9d50e39c-8c7b-49f8-81c7-a3ee1e3e5e32	9d50e39c-d11d-486e-8f15-fa58f30de52f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 13:16:56
2128	9d50e39c-cce0-4729-8a49-ff006e24a21e	9d50e39c-d11d-486e-8f15-fa58f30de52f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%hola%' or \\"users\\".\\"user_document\\"::text like '%hola%' order by \\"users\\".\\"user_document\\" asc","time":"149.66","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 13:16:56
2129	9d50e39c-cff7-460b-8bec-d2406d509cf5	9d50e39c-d11d-486e-8f15-fa58f30de52f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 13:16:56
2130	9d50e39c-d03b-4ccd-b528-5d94adf5d408	9d50e39c-d11d-486e-8f15-fa58f30de52f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"hola"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":320,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:16:56
2135	9d50e3bc-16f6-4935-b0c9-08e833043a9b	9d50e3bc-60e5-4f3b-8c23-a953268e0b70	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 13:17:16
2136	9d50e3bc-5bd8-4ea2-8125-9cefc0a6ad6d	9d50e3bc-60e5-4f3b-8c23-a953268e0b70	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"150.54","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:17:17
2137	9d50e3bc-5c29-4373-aede-9b1062dfeabe	9d50e3bc-60e5-4f3b-8c23-a953268e0b70	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 13:17:17
2138	9d50e3bc-5fcc-4d2a-ac29-77101dd99ed8	9d50e3bc-60e5-4f3b-8c23-a953268e0b70	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 13:17:17
2139	9d50e3bc-6022-4859-9789-51d90ec627a0	9d50e3bc-60e5-4f3b-8c23-a953268e0b70	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":424,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:17:17
14792	9d5ec304-a210-414e-a618-bf8e4b65124a	9d5ec304-a31a-4a45-8fb1-824cac169ed0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/56","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":56,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"06-11-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":157,"loans_codigo":56,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"20833.333333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:42:30.000000Z","updated_at":"2024-10-30T15:42:30.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":158,"loans_codigo":56,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"20833.333333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:42:30.000000Z","updated_at":"2024-10-30T15:42:30.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":159,"loans_codigo":56,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"20833.333333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:42:30.000000Z","updated_at":"2024-10-30T15:42:30.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":160,"loans_codigo":56,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"20833.333333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:42:30.000000Z","updated_at":"2024-10-30T15:42:30.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":161,"loans_codigo":56,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"20833.333333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:42:30.000000Z","updated_at":"2024-10-30T15:42:30.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:47:23
16841	9d64d955-fd01-4563-909a-e65386f367ce	9d64d956-2007-43c2-9e89-75fe5533e048	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 11:24:45
16842	9d64d956-19cf-45fe-ae6b-386662138554	9d64d956-2007-43c2-9e89-75fe5533e048	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"47.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":24,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-11-02 11:24:45
16843	9d64d956-1dfc-4d6c-bd6a-75d2c88eb209	9d64d956-2007-43c2-9e89-75fe5533e048	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 11:24:45
2605	9d50faeb-1e94-44f3-8836-906467954713	9d50faeb-408b-4f0a-8c1e-54e7b84c6d1d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 14:22:06
2606	9d50faeb-3b13-4d92-9bd0-053a0dbc0deb	9d50faeb-408b-4f0a-8c1e-54e7b84c6d1d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:22:06
2607	9d50faeb-3b5d-4ce8-8876-ae844ff5a1ff	9d50faeb-408b-4f0a-8c1e-54e7b84c6d1d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:22:06
2608	9d50faeb-3f70-4a87-9181-bc6a68580aa5	9d50faeb-408b-4f0a-8c1e-54e7b84c6d1d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 14:22:06
2140	9d50e3bc-a7b2-4c04-990c-9ea88cf98f8b	9d50e3bc-ed78-4c08-b414-8b87110a14c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 13:17:17
2609	9d50faeb-3fb3-4ce1-854e-77885cc7defa	9d50faeb-408b-4f0a-8c1e-54e7b84c6d1d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":260,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:22:06
5336	9d513838-0e45-4eeb-9464-92ad98c71096	9d513838-1473-478a-897f-b331baa6afac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"51.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:13:31
5337	9d513838-0eb4-41f9-96da-93ab8a404c7f	9d513838-1473-478a-897f-b331baa6afac	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:13:31
5338	9d513838-1314-4a44-9db6-b62695919404	9d513838-1473-478a-897f-b331baa6afac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 17:13:31
5339	9d513838-1371-4af4-99db-54e265fe7a6c	9d513838-1473-478a-897f-b331baa6afac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":298,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:13:31
16844	9d64d956-1e74-4c04-ba5a-3e5572e12c87	9d64d956-2007-43c2-9e89-75fe5533e048	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":296,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:24:45
14793	9d5ec4ae-7ede-4d45-91c4-93c7df9db9d3	9d5ec4ae-c085-4ef9-a78d-f319bc81444c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-30 10:52:02
14794	9d5ec4ae-b1c3-4b8d-9994-ade53f590ac6	9d5ec4ae-c085-4ef9-a78d-f319bc81444c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"66.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-10-30 10:52:02
14795	9d5ec4ae-bd84-44ad-815a-bc7ff464a4de	9d5ec4ae-c085-4ef9-a78d-f319bc81444c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 10:52:02
2610	9d50faeb-88b8-4ed7-a657-079acf963aa7	9d50faeb-a925-4f0f-a9f2-198246cddeea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 14:22:06
2611	9d50faeb-a365-40fb-93c9-79e755f8a6a6	9d50faeb-a925-4f0f-a9f2-198246cddeea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:22:06
2612	9d50faeb-a3af-4245-a7e9-c4f8fccdf718	9d50faeb-a925-4f0f-a9f2-198246cddeea	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:22:06
2613	9d50faeb-a7bd-49bd-b3b1-bddc58b55574	9d50faeb-a925-4f0f-a9f2-198246cddeea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 14:22:06
2141	9d50e3bc-e786-4412-867d-e2e78aec0692	9d50e3bc-ed78-4c08-b414-8b87110a14c0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"142.70","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:17:17
2142	9d50e3bc-e7d2-4522-bb18-7f47ff204ae0	9d50e3bc-ed78-4c08-b414-8b87110a14c0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 13:17:17
2614	9d50faeb-a831-4f02-bcc5-fdc006ea8a55	9d50faeb-a925-4f0f-a9f2-198246cddeea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:22:06
5340	9d513838-65d2-440d-aee5-c9d0d64c3b7f	9d513838-86b0-4484-b691-6f99d700c15d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 17:13:31
5341	9d513838-8110-4da8-9303-a389c63aaa89	9d513838-86b0-4484-b691-6f99d700c15d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:13:31
5342	9d513838-817b-47fe-a30d-e4a076f68786	9d513838-86b0-4484-b691-6f99d700c15d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:13:31
5343	9d513838-8591-47e2-961e-3901494924c2	9d513838-86b0-4484-b691-6f99d700c15d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 17:13:31
5344	9d513838-85d4-4e71-a284-5953d4878bdc	9d513838-86b0-4484-b691-6f99d700c15d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":276,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:13:31
5475	9d5220ec-9334-4db5-b7c5-261122844fb2	9d5220ed-87d5-4dd3-a55a-253a030f333e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 04:04:12
5476	9d5220ed-7e29-4901-9037-f636aa390492	9d5220ed-87d5-4dd3-a55a-253a030f333e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 04:04:13
5477	9d5220ed-829f-43c5-8fed-a25d0fb42e32	9d5220ed-87d5-4dd3-a55a-253a030f333e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":2370,"memory":22,"hostname":"EderCortes"}	2024-10-24 04:04:13
11296	9d5cb235-c648-4347-a477-e2235b406e73	9d5cb235-c74f-49ce-95b4-5f760f725e28	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":434,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:08:44
5478	9d5220ef-4a45-4949-bfd0-0ff4f6aa4b8d	9d5220ef-f12c-4ac0-94d4-1ee25b858098	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 04:04:14
5479	9d5220ef-d09b-4165-9a5f-05cd9c7de6fa	9d5220ef-f12c-4ac0-94d4-1ee25b858098	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"227.06","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 04:04:14
5480	9d5220ef-d186-4de7-8479-33a5233dc11f	9d5220ef-f12c-4ac0-94d4-1ee25b858098	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 04:04:14
5481	9d5220ef-ecb8-4a5c-aeb4-64cde13ac69d	9d5220ef-f12c-4ac0-94d4-1ee25b858098	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 04:04:14
2143	9d50e3bc-ec27-494b-bc92-15d0761eca90	9d50e3bc-ed78-4c08-b414-8b87110a14c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 13:17:17
2368	9d50e765-1d5a-430a-a6c3-6d844ac2b95b	9d50e765-3a87-45f2-b610-534068850d71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 13:27:31
2369	9d50e765-35a6-41c3-bcfa-6806fdfb0a71	9d50e765-3a87-45f2-b610-534068850d71	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:27:31
2370	9d50e765-35fc-4358-99ea-db52f0d0e811	9d50e765-3a87-45f2-b610-534068850d71	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 13:27:31
2371	9d50e765-3934-4042-b1e2-99e9d83a709d	9d50e765-3a87-45f2-b610-534068850d71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 13:27:31
2372	9d50e765-397a-4651-95a8-79df4dcd5326	9d50e765-3a87-45f2-b610-534068850d71	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:27:31
5482	9d5220ef-ee60-4cb5-ab9c-110cd4fc660c	9d5220ef-f12c-4ac0-94d4-1ee25b858098	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":1442,"memory":22,"hostname":"EderCortes"}	2024-10-24 04:04:14
14796	9d5ec4ae-be40-4277-ab72-75d1d0915178	9d5ec4ae-c085-4ef9-a78d-f319bc81444c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":830,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:52:02
16845	9d64dbd1-6533-44c8-aa77-c0574dc10a9a	9d64dbd5-0366-4568-a98d-6fc95dac7730	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 11:31:42
16846	9d64dbd3-7f30-479f-9b6a-79e18cbfbd4e	9d64dbd5-0366-4568-a98d-6fc95dac7730	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"134.14","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":24,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-11-02 11:31:43
16847	9d64dbd4-ca2f-4ac6-bcd5-012db182598f	9d64dbd5-0366-4568-a98d-6fc95dac7730	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 11:31:44
5483	9d5220f0-b4dd-4a5c-97f1-3d1de0d54d37	9d5220f1-0e57-4b7a-8f34-0fc43b21fcf0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 04:04:15
5484	9d5220f1-0305-43e6-bea5-a167c89ded9a	9d5220f1-0e57-4b7a-8f34-0fc43b21fcf0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"111.08","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 04:04:15
5485	9d5220f1-03aa-4462-ae3c-d9e0a44be134	9d5220f1-0e57-4b7a-8f34-0fc43b21fcf0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 04:04:15
5486	9d5220f1-0c47-4dc5-9f19-0704752eb638	9d5220f1-0e57-4b7a-8f34-0fc43b21fcf0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 04:04:15
2373	9d50e765-7b9a-4999-b8c2-4cce8d55aa96	9d50e765-c6b0-4778-9fc2-d5a272971d53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 13:27:31
2374	9d50e765-c1d7-45ba-8971-aa889128121f	9d50e765-c6b0-4778-9fc2-d5a272971d53	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"158.53","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:27:31
2375	9d50e765-c222-4e35-8af2-ebb19137a6d7	9d50e765-c6b0-4778-9fc2-d5a272971d53	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 13:27:31
2376	9d50e765-c577-4d19-8f3d-3c023010cc61	9d50e765-c6b0-4778-9fc2-d5a272971d53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 13:27:31
2377	9d50e765-c5ba-47a7-bf3f-5f220b3dc40c	9d50e765-c6b0-4778-9fc2-d5a272971d53	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:27:31
5487	9d5220f1-0ccf-42be-990c-e6e02970eb88	9d5220f1-0e57-4b7a-8f34-0fc43b21fcf0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":699,"memory":22,"hostname":"EderCortes"}	2024-10-24 04:04:15
14797	9d5ec4b0-aaf9-4451-8080-531a0437f4fb	9d5ec4b1-011a-4278-8901-126ef30aa5fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 10:52:03
5610	9d524742-1ce5-45dd-85ef-b305a7682b56	9d524742-3d16-4df6-ba68-e5f7c7607b52	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 05:51:23
5611	9d524742-3b33-402c-ad87-fa882be23e30	9d524742-3d16-4df6-ba68-e5f7c7607b52	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 05:51:24
5612	9d524742-3bdb-4e7a-8b37-b8e3364cb4a0	9d524742-3d16-4df6-ba68-e5f7c7607b52	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":256,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:51:24
14798	9d5ec4b0-f9a5-4436-a176-518d1f1b061f	9d5ec4b1-011a-4278-8901-126ef30aa5fa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"162.76","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":179,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 10:52:04
14799	9d5ec4b0-fa0a-4779-bf53-8ee78c533c8b	9d5ec4b1-011a-4278-8901-126ef30aa5fa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-30 10:52:04
14800	9d5ec4b0-ffaf-4201-9dd5-524cfc98a0ab	9d5ec4b1-011a-4278-8901-126ef30aa5fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 10:52:04
20804	9d66fc28-1f53-4422-829b-88edd2a1cf73	9d66fc28-2038-4289-a57a-6cb382467f80	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Lui"},"session":[],"response_status":200,"response":{"data":[]},"duration":344,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:53:47
5613	9d524742-8911-49fa-a5d3-f764b8e837d3	9d524742-a732-45a1-af02-522f27f8565f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 05:51:24
5614	9d524742-a256-477b-9264-a5cc56efcb77	9d524742-a732-45a1-af02-522f27f8565f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":120,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 05:51:24
5615	9d524742-a2ab-440c-ba6a-f58f9bd08d46	9d524742-a732-45a1-af02-522f27f8565f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 05:51:24
5616	9d524742-a635-41bf-b429-0a82c56c9c2f	9d524742-a732-45a1-af02-522f27f8565f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 05:51:24
2378	9d50e767-0957-429d-a05f-705ab499d8af	9d50e767-2db3-4f2b-b74d-9c0f8c12b8db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 13:27:32
2379	9d50e767-286c-4e6b-8751-29961707c53a	9d50e767-2db3-4f2b-b74d-9c0f8c12b8db	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"51.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 13:27:32
2380	9d50e767-28b4-422e-99cc-39bca4e74e41	9d50e767-2db3-4f2b-b74d-9c0f8c12b8db	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 13:27:32
2381	9d50e767-2c66-48ab-8064-8025f584a45a	9d50e767-2db3-4f2b-b74d-9c0f8c12b8db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 13:27:32
2382	9d50e767-2cab-4f2e-93a3-092f998a14e5	9d50e767-2db3-4f2b-b74d-9c0f8c12b8db	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":384,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:27:32
5617	9d524742-a675-452d-9846-ea800522ca72	9d524742-a732-45a1-af02-522f27f8565f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":248,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:51:24
14801	9d5ec4b1-0007-4f80-850d-aa310cdef561	9d5ec4b1-011a-4278-8901-126ef30aa5fa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":555,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:52:04
16848	9d64dbd4-cfdf-4e19-bde2-ee4cc748d65d	9d64dbd5-0366-4568-a98d-6fc95dac7730	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":16096,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:31:44
20805	9d66fc28-6682-465e-96d6-769ff69fb281	9d66fc28-adee-49a2-afce-5437589e7ae0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:53:47
5618	9d524742-ea65-4d6c-9401-4164b040d4cc	9d524743-347e-4db9-b580-f1beb70ee246	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 05:51:24
3366	9d510495-68b8-4b7c-9777-fa5a9b68ae96	9d510495-a806-4eb1-8888-32c1cb65ce9c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-10-23 14:49:08
2327	9d50e70d-5dd0-44a2-b237-d827763bfd78	9d50e70d-7b67-439f-84f8-b9d64183ae32	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 13:26:33
2328	9d50e70d-7997-4df6-a592-9bf32d256286	9d50e70d-7b67-439f-84f8-b9d64183ae32	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 13:26:33
1807	9d50df2f-4a6a-4632-b254-69d51389cbcf	9d50df2f-9229-4065-a4d6-314936dba548	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 13:04:33
1808	9d50df2f-9090-44c8-bad3-1ddb37bc913e	9d50df2f-9229-4065-a4d6-314936dba548	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 13:04:33
1809	9d50df2f-9133-4f5a-87a0-2383f6d9a07b	9d50df2f-9229-4065-a4d6-314936dba548	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":350,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:04:33
2329	9d50e70d-7a3c-4a9f-bde3-6516c2985a81	9d50e70d-7b67-439f-84f8-b9d64183ae32	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:26:33
3367	9d510495-a47e-4205-8ea2-6528632f02c5	9d510495-a806-4eb1-8888-32c1cb65ce9c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-10-23 14:49:08
3368	9d510495-a5f4-42b3-b742-0956af18ff35	9d510495-a806-4eb1-8888-32c1cb65ce9c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":643,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:49:08
5619	9d524743-2f82-411b-9b55-e484413936b0	9d524743-347e-4db9-b580-f1beb70ee246	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"155.74","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":120,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 05:51:24
5620	9d524743-2fd4-4756-9603-cf3df010a579	9d524743-347e-4db9-b580-f1beb70ee246	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 05:51:24
5621	9d524743-334b-408b-8728-0e06e2e4f891	9d524743-347e-4db9-b580-f1beb70ee246	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 05:51:24
5622	9d524743-3397-4cd2-b08f-71744bb7ab7c	9d524743-347e-4db9-b580-f1beb70ee246	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:51:24
14802	9d5ec4b1-62d0-4471-8943-b8c7c0f9adc2	9d5ec4b1-b56f-46d0-9348-6af5cebc5a1e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 10:52:04
14803	9d5ec4b1-afcd-41d9-979c-e3cb794479be	9d5ec4b1-b56f-46d0-9348-6af5cebc5a1e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"155.36","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":179,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 10:52:04
14804	9d5ec4b1-b01d-4cd5-a2c5-cef1315f9280	9d5ec4b1-b56f-46d0-9348-6af5cebc5a1e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-30 10:52:04
14805	9d5ec4b1-b3de-46d2-bb8a-4f13e4625c83	9d5ec4b1-b56f-46d0-9348-6af5cebc5a1e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 10:52:04
14806	9d5ec4b1-b455-4c13-a3e8-36f02f3db901	9d5ec4b1-b56f-46d0-9348-6af5cebc5a1e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":434,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:52:04
19537	9d66e029-c29b-49a4-955d-aa1a6386cc6b	9d66e029-c3dd-4422-9a50-ed365acfddbf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":585,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:35:30
2330	9d50e70d-c0aa-43eb-82af-c4dac677db0d	9d50e70e-08ef-4cdd-8f06-b9ad59ff53aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 13:26:33
2331	9d50e70e-02f7-4f8e-8291-14b1aad6e0fd	9d50e70e-08ef-4cdd-8f06-b9ad59ff53aa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"147.11","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:26:33
2332	9d50e70e-034b-4d69-833a-8dfcc96b8a46	9d50e70e-08ef-4cdd-8f06-b9ad59ff53aa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 13:26:33
2333	9d50e70e-073c-41fd-b07f-a157ead7a0ce	9d50e70e-08ef-4cdd-8f06-b9ad59ff53aa	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 13:26:34
2334	9d50e70e-07cf-4aae-93d7-a61bceeaa6bc	9d50e70e-08ef-4cdd-8f06-b9ad59ff53aa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":341,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:26:34
3369	9d510496-32e2-48a1-912c-f3d126eb2de3	9d510496-6b1e-4197-b8a1-27ae7cc626f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-10-23 14:49:08
3370	9d510496-6240-440d-a296-5b48b0465ee6	9d510496-6b1e-4197-b8a1-27ae7cc626f5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"67.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:49:08
3371	9d510496-62b9-4605-8ab3-7edfcad54aaf	9d510496-6b1e-4197-b8a1-27ae7cc626f5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:49:08
3372	9d510496-6897-49e3-99c3-49394e99988f	9d510496-6b1e-4197-b8a1-27ae7cc626f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-10-23 14:49:08
3373	9d510496-693a-4447-ad4e-295351233661	9d510496-6b1e-4197-b8a1-27ae7cc626f5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":460,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:49:08
5623	9d524745-1df6-4bd6-a802-9eb4fc5c1aff	9d524745-4289-4c36-b26f-3b8911956b3a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 05:51:25
5624	9d524745-3bd8-44bb-971d-1d0f06333d67	9d524745-4289-4c36-b26f-3b8911956b3a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"51.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 05:51:25
5625	9d524745-3c78-4b16-a530-4a7281ee47bb	9d524745-4289-4c36-b26f-3b8911956b3a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 05:51:25
5626	9d524745-40ef-4328-8f03-eb417da939a6	9d524745-4289-4c36-b26f-3b8911956b3a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 05:51:26
5627	9d524745-414e-4da0-be6f-950f070be364	9d524745-4289-4c36-b26f-3b8911956b3a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:51:26
14807	9d5ec4b4-c14b-4dd1-a0e7-43f75b033cf6	9d5ec4b4-c460-4d96-8fe9-f1d89c97f60a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":129,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:52:06
19538	9d66e02a-3e60-46a2-a047-008419c7eb31	9d66e02a-9951-4d69-8a98-a2406363ad8c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:35:30
2335	9d50e70e-591a-4544-b1db-2cf6b0507051	9d50e70e-a410-473f-b140-9bc16ffa69e5	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 13:26:34
2336	9d50e70e-9d97-4418-8251-2a5879a13984	9d50e70e-a410-473f-b140-9bc16ffa69e5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"141.48","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 13:26:34
2337	9d50e70e-9e38-4b33-8c50-7240478f5a79	9d50e70e-a410-473f-b140-9bc16ffa69e5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 13:26:34
2338	9d50e70e-a2e1-4dae-9c27-cd32de39dcb0	9d50e70e-a410-473f-b140-9bc16ffa69e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 13:26:34
2339	9d50e70e-a325-40f3-9a91-baef145ef06a	9d50e70e-a410-473f-b140-9bc16ffa69e5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":377,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:26:34
14808	9d5ec4b5-2bea-460f-a866-de6a3c330c65	9d5ec4b5-485e-479e-871d-ba842d7f1af1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 10:52:06
14809	9d5ec4b5-447d-4e3b-8a0f-c68446e5414a	9d5ec4b5-485e-479e-871d-ba842d7f1af1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ma%' or \\"users\\".\\"user_document\\"::text like '%Ma%') order by \\"users\\".\\"user_document\\" asc","time":"39.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-30 10:52:07
14810	9d5ec4b5-473a-4b4f-b4fa-aeb1dac80c34	9d5ec4b5-485e-479e-871d-ba842d7f1af1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-30 10:52:07
5628	9d524756-89d7-4564-a9c6-ef1885c4c42d	9d524756-8d3e-4a91-88d9-d2eaef124f5e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":142,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:51:37
14811	9d5ec4b5-477d-4ce2-bf7a-ba99569cf5ce	9d5ec4b5-485e-479e-871d-ba842d7f1af1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ma"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":213,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:52:07
17791	9d65adda-39b8-4fba-9d60-a28d1b6f3a46	9d65adda-43f3-49ac-a969-d87d1058c27b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"155.91","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 21:19:00
17792	9d65adda-3de5-457c-9371-ea794167c1fd	9d65adda-43f3-49ac-a969-d87d1058c27b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:19:00
2340	9d50e710-0e58-4624-aabe-07c9fce4ada9	9d50e710-3302-45e7-a08b-f36adb0f22c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 13:26:35
2341	9d50e710-2bc8-4e89-8aa8-276f42b8b247	9d50e710-3302-45e7-a08b-f36adb0f22c5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 13:26:35
2342	9d50e710-2c14-4436-9c53-d2fa67bd9d28	9d50e710-3302-45e7-a08b-f36adb0f22c5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 13:26:35
2343	9d50e710-3164-4169-93b0-b77bc3f0b5ae	9d50e710-3302-45e7-a08b-f36adb0f22c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 13:26:35
2344	9d50e710-31d3-40ba-85cc-01610d23d4b1	9d50e710-3302-45e7-a08b-f36adb0f22c5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":481,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:26:35
3374	9d510496-db1c-4fe4-a81e-c8c33b2c6822	9d510496-fd0f-479a-b733-34d892a899c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-10-23 14:49:09
2778	9d50fc3a-717c-4969-9c89-af5d0405124d	9d50fc3a-c443-4939-bd10-59c89af5010c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 14:25:46
2779	9d50fc3a-c23e-4944-9800-d4d103ed2435	9d50fc3a-c443-4939-bd10-59c89af5010c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:25:46
2780	9d50fc3a-c32a-42d3-9c49-c6060cc11280	9d50fc3a-c443-4939-bd10-59c89af5010c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":379,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:25:46
3375	9d510496-f72f-4451-bbba-ef0eeb1e7ee4	9d510496-fd0f-479a-b733-34d892a899c9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:49:09
3238	9d510392-ea7f-4246-92ac-6325449035d1	9d510393-31da-44ec-aaa9-862cf79de5db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 14:46:18
3239	9d510393-2f2d-4152-b1ad-2d09ffc40d44	9d510393-31da-44ec-aaa9-862cf79de5db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 14:46:18
3240	9d510393-304e-45d5-a4b1-e0fcab3ed1dc	9d510393-31da-44ec-aaa9-862cf79de5db	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":566,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:46:18
3376	9d510496-f7a6-43cc-ab36-a376adab023c	9d510496-fd0f-479a-b733-34d892a899c9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:49:09
3377	9d510496-fbc9-4f73-a5d1-69fb98d45d75	9d510496-fd0f-479a-b733-34d892a899c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-10-23 14:49:09
3378	9d510496-fc0c-4333-8a09-3b623d78fc37	9d510496-fd0f-479a-b733-34d892a899c9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:49:09
5629	9d524756-f4ce-4ebb-9841-b5a718613acc	9d524757-3852-408a-a014-c200f0c1573c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 05:51:37
5630	9d524757-33bb-4ce0-a4c0-7f78ec67b7e5	9d524757-3852-408a-a014-c200f0c1573c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Luis%' or \\"users\\".\\"user_document\\"::text like '%Luis%' order by \\"users\\".\\"user_document\\" asc","time":"142.32","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":49,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-24 05:51:37
5631	9d524757-36f8-4a24-8a09-43655a6798e0	9d524757-3852-408a-a014-c200f0c1573c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 05:51:37
17793	9d65adda-3e2d-4bb8-90a6-2857d7ef15cb	9d65adda-43f3-49ac-a969-d87d1058c27b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:19:00
17794	9d65adda-427a-4042-af4b-d03e08cb41e1	9d65adda-43f3-49ac-a969-d87d1058c27b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:19:00
3241	9d510393-a706-40e4-808b-2993dfd11bd2	9d510393-db31-4f4b-afa8-e7903fe83c6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 14:46:19
3242	9d510393-d256-4590-b1a1-08369dfb1540	9d510393-db31-4f4b-afa8-e7903fe83c6b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"69.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:46:19
3243	9d510393-d2ff-4633-9e8f-68c3cc5eb4d1	9d510393-db31-4f4b-afa8-e7903fe83c6b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:46:19
3244	9d510393-d92e-4a50-81cc-e8db6f273907	9d510393-db31-4f4b-afa8-e7903fe83c6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 14:46:19
3245	9d510393-d9a7-4241-bf75-4ffec94041f6	9d510393-db31-4f4b-afa8-e7903fe83c6b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":398,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:46:19
3379	9d510497-95f7-40cc-b765-837cce43b886	9d510497-d334-452b-bbfa-a5bf0aea8238	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-10-23 14:49:09
3380	9d510497-c88a-4c95-9251-b65236a4ad29	9d510497-d334-452b-bbfa-a5bf0aea8238	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"77.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:49:09
3381	9d510497-c91e-42b6-9751-205d296bb8c1	9d510497-d334-452b-bbfa-a5bf0aea8238	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:49:09
3382	9d510497-d11f-437b-a161-6be1d7eee6f1	9d510497-d334-452b-bbfa-a5bf0aea8238	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-10-23 14:49:09
3383	9d510497-d1b9-44f9-b99f-daf5e18db889	9d510497-d334-452b-bbfa-a5bf0aea8238	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":531,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:49:09
5026	9d513667-0bfb-4e59-9adb-aa8507dd8f50	9d513667-303d-43ed-acad-2847acc0455f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":37,"hostname":"EderCortes"}	2024-10-23 17:08:26
3588	9d5108e9-c4c5-49fa-80e1-b2c7eeb08fd6	9d5108e9-ea75-42a4-bba7-87ab76f513b7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 15:01:14
3589	9d5108e9-e1a6-4d43-b3c7-ddecd7036b11	9d5108e9-ea75-42a4-bba7-87ab76f513b7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:01:14
3590	9d5108e9-e233-4f8e-826a-f0f5f9980041	9d5108e9-ea75-42a4-bba7-87ab76f513b7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 15:01:14
3591	9d5108e9-e85c-4ac6-b40f-6c0383841942	9d5108e9-ea75-42a4-bba7-87ab76f513b7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 15:01:14
3592	9d5108e9-e8d9-4885-a082-2f97ca1ac039	9d5108e9-ea75-42a4-bba7-87ab76f513b7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:01:14
3246	9d510394-465a-4f0c-b96d-846df522b17f	9d510394-952f-4eec-ab73-54040da1f4c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 14:46:19
3247	9d510394-8f41-4625-8898-5b89b6a13b03	9d510394-952f-4eec-ab73-54040da1f4c0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"163.80","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:46:19
3248	9d510394-8fa5-4f6a-b10e-ff2da8168191	9d510394-952f-4eec-ab73-54040da1f4c0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:46:19
3249	9d510394-9416-4d8d-ae72-4b733ff921ad	9d510394-952f-4eec-ab73-54040da1f4c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 14:46:19
3250	9d510394-945c-41e7-9c1b-85f9b0141a19	9d510394-952f-4eec-ab73-54040da1f4c0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":459,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:46:19
3384	9d510498-6191-4ac6-bcce-d6ec6b60c734	9d510498-8efa-4c79-ae7d-dd15d14ee3e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-10-23 14:49:10
3385	9d510498-87b9-4bb9-a1a7-44ef46a78012	9d510498-8efa-4c79-ae7d-dd15d14ee3e4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"60.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:49:10
3386	9d510498-8819-49b4-967e-de646d153464	9d510498-8efa-4c79-ae7d-dd15d14ee3e4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:49:10
3387	9d510498-8d20-49a4-9fc2-b0b04420ef96	9d510498-8efa-4c79-ae7d-dd15d14ee3e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-10-23 14:49:10
3388	9d510498-8d9e-4a31-993e-88a5405b9c2d	9d510498-8efa-4c79-ae7d-dd15d14ee3e4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":451,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:49:10
20806	9d66fc28-a964-4ff3-ba8a-2bc92baa8830	9d66fc28-adee-49a2-afce-5437589e7ae0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Luis%' or \\"users\\".\\"user_document\\"::text like '%Luis%') order by \\"users\\".\\"user_document\\" asc","time":"153.64","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 12:53:47
5027	9d513667-2948-4500-ace6-f7358821cda9	9d513667-303d-43ed-acad-2847acc0455f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"50.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:08:26
5028	9d513667-29bc-4c14-819c-35e88fc9466f	9d513667-303d-43ed-acad-2847acc0455f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:08:26
5029	9d513667-2ea7-4388-abd5-3f4a93d5d4f7	9d513667-303d-43ed-acad-2847acc0455f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":38,"hostname":"EderCortes"}	2024-10-23 17:08:26
5030	9d513667-2f09-4a80-8612-d85493c5b70c	9d513667-303d-43ed-acad-2847acc0455f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":287,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:26
3251	9d510395-344b-46c9-9cf6-b375f69d106d	9d510395-a596-465a-8a63-06beabf348eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 14:46:20
3252	9d510395-9c8e-4f17-94c1-3d4040e6a8aa	9d510395-a596-465a-8a63-06beabf348eb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"121.43","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:46:20
3253	9d510395-9d0d-4e94-96b0-d52d4f9ad849	9d510395-a596-465a-8a63-06beabf348eb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:46:20
3254	9d510395-a35b-470c-b3dd-9f2a343fbceb	9d510395-a596-465a-8a63-06beabf348eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 14:46:20
3255	9d510395-a3cd-479a-bf2d-9fe878efe787	9d510395-a596-465a-8a63-06beabf348eb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":681,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:46:20
5632	9d524757-3742-445c-9a91-ea4f610812ed	9d524757-3852-408a-a014-c200f0c1573c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Luis"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":338,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:51:37
14812	9d5ec4b6-2185-4c58-b2cd-f63ff5b87aee	9d5ec4b6-2452-47b2-8f4b-c56a228641ec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":131,"memory":20,"hostname":"EderCortes"}	2024-10-30 10:52:07
5031	9d513667-86c8-4a02-a3cc-f6f1abcac00e	9d513668-798c-4002-9c2e-55c3525ae63c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":38,"hostname":"EderCortes"}	2024-10-23 17:08:26
5032	9d513668-6b6e-444d-9c9e-8128ed367a8c	9d513668-798c-4002-9c2e-55c3525ae63c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"563.79","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:08:27
5033	9d513668-6bf3-4698-b146-cd4e4d3c64e8	9d513668-798c-4002-9c2e-55c3525ae63c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:08:27
5034	9d513668-778a-4a26-b306-caa30730307f	9d513668-798c-4002-9c2e-55c3525ae63c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":39,"hostname":"EderCortes"}	2024-10-23 17:08:27
5035	9d513668-7812-4455-9639-4eb2aaba74ae	9d513668-798c-4002-9c2e-55c3525ae63c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":824,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:27
20807	9d66fc28-ac88-4fe4-8cca-d74a3c1f28d1	9d66fc28-adee-49a2-afce-5437589e7ae0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:53:47
3256	9d510396-1291-4c25-b898-60082842ea87	9d510396-314c-4c62-a3c5-7057904ee80d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 14:46:20
3257	9d510396-2c29-4232-9c62-b65cc568f7a8	9d510396-314c-4c62-a3c5-7057904ee80d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:46:20
3258	9d510396-2c75-45fa-8d95-14616a0b02df	9d510396-314c-4c62-a3c5-7057904ee80d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:46:20
3259	9d510396-3005-4b1b-9e36-208b86ffbc8d	9d510396-314c-4c62-a3c5-7057904ee80d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-23 14:46:20
3260	9d510396-304f-4571-8b67-a85f6331986f	9d510396-314c-4c62-a3c5-7057904ee80d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:46:20
5633	9d52475a-d24d-442e-9d85-441ea1909c4b	9d52475a-f1cc-4f1a-8df9-6f5d075d4c1f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 05:51:40
5634	9d52475a-ebc3-4aaf-97db-35875913fba6	9d52475a-f1cc-4f1a-8df9-6f5d075d4c1f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '18' and \\"users\\".\\"deleted_at\\" is null","time":"43.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":31,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-24 05:51:40
5040	9d51366a-c862-4e9c-997e-7cd82ee3735f	9d51366a-ffea-42e6-901f-48a49562c594	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":40,"hostname":"EderCortes"}	2024-10-23 17:08:28
5041	9d51366a-f5bc-4e72-9a7e-957dec54428e	9d51366a-ffea-42e6-901f-48a49562c594	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"69.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:08:28
5042	9d51366a-f671-4da8-a89c-ce7817a092f6	9d51366a-ffea-42e6-901f-48a49562c594	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:08:28
5043	9d51366a-fdeb-4d80-8d01-23c1c6698328	9d51366a-ffea-42e6-901f-48a49562c594	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":41,"hostname":"EderCortes"}	2024-10-23 17:08:28
5044	9d51366a-fe72-44ae-9d7d-4059ac21945e	9d51366a-ffea-42e6-901f-48a49562c594	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":552,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:28
5635	9d52475a-ec17-421f-bb5e-f08be9b2b4f8	9d52475a-f1cc-4f1a-8df9-6f5d075d4c1f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 05:51:40
5636	9d52475a-f00b-49a5-bef8-8aa44bc31385	9d52475a-f1cc-4f1a-8df9-6f5d075d4c1f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 05:51:40
5637	9d52475a-f069-496e-afe1-a3d796b3785a	9d52475a-f1cc-4f1a-8df9-6f5d075d4c1f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/18","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}},"duration":248,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:51:40
14813	9d5ec4b6-d347-4f0e-9193-a7ac3e4d75b0	9d5ec4b7-183a-4946-9981-9734e3cf1d7a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-30 10:52:08
14814	9d5ec4b7-13f1-4bc5-b230-62cd41ab5731	9d5ec4b7-183a-4946-9981-9734e3cf1d7a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mar%' or \\"users\\".\\"user_document\\"::text like '%Mar%') order by \\"users\\".\\"user_document\\" asc","time":"151.19","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-30 10:52:08
3480	9d5106d5-5be3-4c02-88ed-bd3713d17bf0	9d5106d5-9773-42bb-886a-97075bfa5c5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:55:25
3481	9d5106d5-934d-49ea-ba34-1ecce110ebf1	9d5106d5-9773-42bb-886a-97075bfa5c5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:55:25
3482	9d5106d5-957b-40f3-848d-5ed374c97b85	9d5106d5-9773-42bb-886a-97075bfa5c5c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":549,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:55:25
14815	9d5ec4b7-1706-46b5-9348-aed92e840319	9d5ec4b7-183a-4946-9981-9734e3cf1d7a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-30 10:52:08
5638	9d52477b-5000-4f8b-9c76-2b86d1bd43bd	9d52477b-536f-49e2-8723-1f701cc3ad7e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":231,"memory":20,"hostname":"EderCortes"}	2024-10-24 05:52:01
14816	9d5ec4b7-174c-4db7-9d73-f7511124f544	9d5ec4b7-183a-4946-9981-9734e3cf1d7a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mar"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":316,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:52:08
17795	9d65adda-42d5-4cee-9241-884c8a2fe2bb	9d65adda-43f3-49ac-a969-d87d1058c27b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:34:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"}]}},"duration":371,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:19:00
19539	9d66e02a-8b5a-484d-a3a3-f4772b9fe1b5	9d66e02a-9951-4d69-8a98-a2406363ad8c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"180.41","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 11:35:31
19540	9d66e02a-9082-4591-8ea1-40beb26e78bc	9d66e02a-9951-4d69-8a98-a2406363ad8c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:35:31
19541	9d66e02a-90d0-4604-b71c-dcc21ef8426b	9d66e02a-9951-4d69-8a98-a2406363ad8c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:35:31
19542	9d66e02a-978f-4be0-a84a-6b4756ced175	9d66e02a-9951-4d69-8a98-a2406363ad8c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:35:31
3483	9d5106d6-2560-4ee8-a367-fadb7f07cad5	9d5106d6-666f-4e6d-81bf-6dda112c80d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:55:26
3484	9d5106d6-5b26-4118-b77c-3f27e1a7ea72	9d5106d6-666f-4e6d-81bf-6dda112c80d3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"90.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:55:26
3485	9d5106d6-5b9d-433a-af66-a22eb42ea905	9d5106d6-666f-4e6d-81bf-6dda112c80d3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:55:26
3486	9d5106d6-640a-4d7d-be5e-912e5950083b	9d5106d6-666f-4e6d-81bf-6dda112c80d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:55:26
3487	9d5106d6-649d-4948-bf90-3159488bc192	9d5106d6-666f-4e6d-81bf-6dda112c80d3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":488,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:55:26
14817	9d5ec4b7-5980-4303-9c2a-4c2739109d6b	9d5ec4b7-78af-4b89-ad8f-3f885389ee38	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-30 10:52:08
14818	9d5ec4b7-7253-426c-90b3-06f786783245	9d5ec4b7-78af-4b89-ad8f-3f885389ee38	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '18' and \\"users\\".\\"deleted_at\\" is null","time":"42.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":55,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-30 10:52:08
14819	9d5ec4b7-72b9-4db7-b1f9-a2337bf6d711	9d5ec4b7-78af-4b89-ad8f-3f885389ee38	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-30 10:52:08
5045	9d51366b-8648-496f-9c55-181d75e40907	9d51366b-bee8-41df-8f41-1d9c907f35fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":41,"hostname":"EderCortes"}	2024-10-23 17:08:29
5046	9d51366b-b53f-4aa1-bfe7-dac3bf9e7750	9d51366b-bee8-41df-8f41-1d9c907f35fe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"73.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:08:29
5047	9d51366b-b5c3-420e-a0cd-74c1c88ba865	9d51366b-bee8-41df-8f41-1d9c907f35fe	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:08:29
5048	9d51366b-bc7d-4a80-a072-7574a2d95443	9d51366b-bee8-41df-8f41-1d9c907f35fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":42,"hostname":"EderCortes"}	2024-10-23 17:08:29
5049	9d51366b-bd13-41e8-b2fc-8a50375d2c32	9d51366b-bee8-41df-8f41-1d9c907f35fe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":464,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:29
14820	9d5ec4b7-7700-4000-a518-3ee757762148	9d5ec4b7-78af-4b89-ad8f-3f885389ee38	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-30 10:52:08
14821	9d5ec4b7-7771-4e7d-841f-53fa018f2b06	9d5ec4b7-78af-4b89-ad8f-3f885389ee38	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/18","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:52:08
20808	9d66fc28-acd6-4220-b68b-aadf7be68fc1	9d66fc28-adee-49a2-afce-5437589e7ae0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Luis"},"session":[],"response_status":200,"response":{"data":[]},"duration":344,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:53:47
5642	9d5247b8-3c02-45ea-b2e6-5c18f4d6559c	9d5247b8-3f87-483d-8417-2c27a41c5a21	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":172,"memory":20,"hostname":"EderCortes"}	2024-10-24 05:52:41
1967	9d50e23c-779a-48db-acc6-1160c643341f	9d50e23c-d74c-48af-b88e-d2bc0d65f2e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 13:13:05
1968	9d50e23c-d574-47eb-8d7e-92301eecda14	9d50e23c-d74c-48af-b88e-d2bc0d65f2e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 13:13:05
1969	9d50e23c-d617-4d81-9e48-db64e9bb85ee	9d50e23c-d74c-48af-b88e-d2bc0d65f2e4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"283","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"name":null,"email":null,"user_last_name_one":null,"user_last_name_two":null,"user_document_type":null,"user_document":null,"user_birth":null,"user_city":null,"user_neighborhood":null,"user_address":null,"user_cellphone":null,"user_photo":null,"user_state":null,"profile_code":null,"user_age":null,"password":"********","verification_token":"CGfCqUBTtAyBGCPNWEyi86QCwhuAuAULe9TAqMP7SlXWatSWda7rzbL5mhxv"},"session":[],"response_status":500,"response":{"message":"SQLSTATE[23502]: Not null violation: 7 ERROR:  el valor nulo en la columna \\u00abname\\u00bb de la relaci\\u00f3n \\u00abusers\\u00bb viola la restricci\\u00f3n de no nulo\\nDETAIL:  La fila que falla contiene (19, null, null, null, $2y$10$vHtQSog81Q7OOnqYWBaQK.RJNQvRuJmpei7jaJQ2ph2s1BducDB22, null, null, null, null, null, null, null, null, null, null, null, null, 0, CGfCqUBTtAyBGCPNWEyi86QCwhuAuAULe9TAqMP7SlXWatSWda7rzbL5mhxv, 2024-10-23 13:13:05, 2024-10-23 13:13:05, null). (Connection: pgsql, SQL: insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"verification_token\\", \\"updated_at\\", \\"created_at\\") values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, $2y$10$vHtQSog81Q7OOnqYWBaQK.RJNQvRuJmpei7jaJQ2ph2s1BducDB22, CGfCqUBTtAyBGCPNWEyi86QCwhuAuAULe9TAqMP7SlXWatSWda7rzbL5mhxv, 2024-10-23 13:13:05, 2024-10-23 13:13:05) returning \\"id\\")","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":401,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor.php","line":24,"function":"selectFromWriteConnection","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3549,"function":"processInsertGetId","class":"Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":1982,"function":"insertGetId","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1334,"function":"__call","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1299,"function":"insertAndSetId","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1138,"function":"performInsert","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":44,"function":"save","class":"Illuminate\\\\Database\\\\Eloquent\\\\Model","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"store","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":404,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:13:05
14822	9d5ec4e0-7888-48db-9d39-62eb7aea2167	9d5ec4e0-7b33-4040-be5c-81127bf40fef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":136,"memory":20,"hostname":"EderCortes"}	2024-10-30 10:52:35
3488	9d5106d6-ddd3-4946-a6d2-bd583b921025	9d5106d7-104d-48a3-a0ae-d78a070cd7a0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:55:26
3489	9d5106d7-0614-476a-a540-c175d6f64647	9d5106d7-104d-48a3-a0ae-d78a070cd7a0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"61.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:55:26
3490	9d5106d7-069a-47a8-b0cb-028e6e19a8dc	9d5106d7-104d-48a3-a0ae-d78a070cd7a0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:55:26
2470	9d50f991-599e-422c-a09f-82f15ffca261	9d50f991-af2f-45aa-8232-5f0ac885f53b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 14:18:19
2471	9d50f991-ac85-4bf3-a05c-b05ae38c173f	9d50f991-af2f-45aa-8232-5f0ac885f53b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:18:20
2472	9d50f991-adef-497e-bc47-6c7f548f6b3f	9d50f991-af2f-45aa-8232-5f0ac885f53b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":466,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:18:20
2183	9d50e4f0-96ff-4c56-95bd-75292c9c1636	9d50e4f0-97e3-478d-9161-8c317ca754ac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"eder"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":315,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:20:39
3491	9d5106d7-0eb3-49a2-90b8-d51e5e7fbbc0	9d5106d7-104d-48a3-a0ae-d78a070cd7a0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 14:55:26
3492	9d5106d7-0f2c-466d-a549-f5830b5fee08	9d5106d7-104d-48a3-a0ae-d78a070cd7a0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":413,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:55:26
1966	9d50e23c-d426-46e9-9c9d-057d6b284298	9d50e23c-d74c-48af-b88e-d2bc0d65f2e4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[23502]: Not null violation: 7 ERROR:  el valor nulo en la columna \\u00abname\\u00bb de la relaci\\u00f3n \\u00abusers\\u00bb viola la restricci\\u00f3n de no nulo\\nDETAIL:  La fila que falla contiene (19, null, null, null, $2y$10$vHtQSog81Q7OOnqYWBaQK.RJNQvRuJmpei7jaJQ2ph2s1BducDB22, null, null, null, null, null, null, null, null, null, null, null, null, 0, CGfCqUBTtAyBGCPNWEyi86QCwhuAuAULe9TAqMP7SlXWatSWda7rzbL5mhxv, 2024-10-23 13:13:05, 2024-10-23 13:13:05, null). (Connection: pgsql, SQL: insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"verification_token\\", \\"updated_at\\", \\"created_at\\") values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, $2y$10$vHtQSog81Q7OOnqYWBaQK.RJNQvRuJmpei7jaJQ2ph2s1BducDB22, CGfCqUBTtAyBGCPNWEyi86QCwhuAuAULe9TAqMP7SlXWatSWda7rzbL5mhxv, 2024-10-23 13:13:05, 2024-10-23 13:13:05) returning \\"id\\")","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":401},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor.php","line":24},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3549},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":1982},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1334},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1299},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1138},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":44},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":123}	2024-10-23 13:13:05
5050	9d51366c-482e-4a52-8502-5863ef4a12d1	9d51366c-80d7-4d17-9e19-6cd3c5da972e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":42,"hostname":"EderCortes"}	2024-10-23 17:08:29
5051	9d51366c-78cd-423e-9e64-88212ca3dcf0	9d51366c-80d7-4d17-9e19-6cd3c5da972e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"80.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:08:29
5052	9d51366c-7951-40b1-88e6-344c4c1817ec	9d51366c-80d7-4d17-9e19-6cd3c5da972e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:08:29
5053	9d51366c-7f4f-4fb9-a8bb-62ec4e9b8541	9d51366c-80d7-4d17-9e19-6cd3c5da972e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":43,"hostname":"EderCortes"}	2024-10-23 17:08:29
2473	9d50f992-18e5-4b39-830e-a56fbeeb4454	9d50f992-6456-4a92-bf60-1b299724161e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:18:20
2474	9d50f992-5dce-4724-bbf7-16744b71745d	9d50f992-6456-4a92-bf60-1b299724161e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"149.66","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:18:20
2475	9d50f992-5e25-4d87-bee7-93dee57d547c	9d50f992-6456-4a92-bf60-1b299724161e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:18:20
2476	9d50f992-6294-49fe-b4cc-5ddee2304826	9d50f992-6456-4a92-bf60-1b299724161e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:18:20
2477	9d50f992-62dc-4e78-ac6e-c9c3f32afb52	9d50f992-6456-4a92-bf60-1b299724161e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":436,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:18:20
3493	9d5106d7-a78b-449e-8cfd-5d059d8f8fbd	9d5106d7-e73b-4b07-ad86-77c734faf5d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 14:55:27
3494	9d5106d7-db57-420d-a98d-aec68b92345d	9d5106d7-e73b-4b07-ad86-77c734faf5d0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"82.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:55:27
3495	9d5106d7-dbf6-4982-8d3f-eaea0bbcddbc	9d5106d7-e73b-4b07-ad86-77c734faf5d0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:55:27
3496	9d5106d7-e4c8-4249-a708-db5a6fb6feea	9d5106d7-e73b-4b07-ad86-77c734faf5d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 14:55:27
3497	9d5106d7-e57d-4e0b-bc17-b9fcc52c35fd	9d5106d7-e73b-4b07-ad86-77c734faf5d0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":530,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:55:27
14823	9d5ec4e0-f7e1-4592-9f44-eba6676f3f5a	9d5ec4e1-1da8-46c5-8ba7-cd357d6041db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-30 10:52:35
14824	9d5ec4e1-12e7-40e3-aed9-ade64e8401cf	9d5ec4e1-1da8-46c5-8ba7-cd357d6041db	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta', 'De las nieve', 'ds', 'CC', '100465546', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '500000', 50, 5, 'S', null, '30-10-2024', 'Pendiente', '312596295', 12, 14, 18, 14, '30-10-2024', '2024-10-30 10:52:35', '2024-10-30 10:52:35') returning \\"id\\"","time":"10.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":104,"hash":"bfad4cea82a73099ff0b3164dd496ca0","hostname":"EderCortes"}	2024-10-30 10:52:35
14825	9d5ec4e1-1376-4d13-885f-18283405c3f9	9d5ec4e1-1da8-46c5-8ba7-cd357d6041db	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:57","hostname":"EderCortes"}	2024-10-30 10:52:35
14826	9d5ec4e1-1578-4079-9186-9e02a5dab1db	9d5ec4e1-1da8-46c5-8ba7-cd357d6041db	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (57, 1, 100000, 250000, 'Pendiente', 'N\\/A', '06-11-2024', 12, '2024-10-30 10:52:35', '2024-10-30 10:52:35')","time":"3.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 10:52:35
14827	9d5ec4e1-15a8-4666-9f4d-34f311eca48e	9d5ec4e1-1da8-46c5-8ba7-cd357d6041db	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 10:52:35
14828	9d5ec4e1-162a-48a6-b235-5bceb578a158	9d5ec4e1-1da8-46c5-8ba7-cd357d6041db	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (57, 2, 100000, 250000, 'Pendiente', 'N\\/A', '13-11-2024', 12, '2024-10-30 10:52:35', '2024-10-30 10:52:35')","time":"0.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 10:52:35
14829	9d5ec4e1-164b-42cd-a4ed-e5e04ea28599	9d5ec4e1-1da8-46c5-8ba7-cd357d6041db	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 10:52:35
2478	9d50f992-b84e-4953-9d8e-d97cecc29693	9d50f992-d9a8-4e93-8ea2-23da19bd2cb0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:18:20
2479	9d50f992-d3f7-41e1-a9dd-cd632a95927c	9d50f992-d9a8-4e93-8ea2-23da19bd2cb0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:18:20
2480	9d50f992-d446-426f-8f1e-6d304ae4d901	9d50f992-d9a8-4e93-8ea2-23da19bd2cb0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:18:20
2481	9d50f992-d7e9-4630-b84e-5e60abebc21a	9d50f992-d9a8-4e93-8ea2-23da19bd2cb0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:18:20
2482	9d50f992-d84b-4c9e-a95d-fdd0012a356a	9d50f992-d9a8-4e93-8ea2-23da19bd2cb0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":279,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:18:20
3498	9d5106d8-9da0-4ff5-b39b-f4595eb19695	9d5106d8-d5da-4de9-bde2-c70ea2f8d0b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 14:55:27
3499	9d5106d8-cb6e-4ed8-a738-18e8fda74e65	9d5106d8-d5da-4de9-bde2-c70ea2f8d0b1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"71.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:55:27
3500	9d5106d8-cc15-4c6c-8398-e8c6d7d77c77	9d5106d8-d5da-4de9-bde2-c70ea2f8d0b1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:55:27
3501	9d5106d8-d38b-4b67-9e3c-de2bfb8ebd61	9d5106d8-d5da-4de9-bde2-c70ea2f8d0b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 14:55:27
3502	9d5106d8-d425-446e-95c7-058dcbc327fc	9d5106d8-d5da-4de9-bde2-c70ea2f8d0b1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":575,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:55:27
14830	9d5ec4e1-16bd-4b97-8d47-2573a36554dc	9d5ec4e1-1da8-46c5-8ba7-cd357d6041db	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (57, 3, 100000, 250000, 'Pendiente', 'N\\/A', '20-11-2024', 12, '2024-10-30 10:52:35', '2024-10-30 10:52:35')","time":"0.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 10:52:35
5926	9d52548b-f984-4015-b642-0094e751aaf8	9d52548c-19b1-48fc-9639-2f21855ca2db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 06:28:33
5927	9d52548c-17dc-418b-ac19-988ab570c4a3	9d52548c-19b1-48fc-9639-2f21855ca2db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 06:28:33
5928	9d52548c-188b-4883-adf8-86b5d2600121	9d52548c-19b1-48fc-9639-2f21855ca2db	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:28:33
14831	9d5ec4e1-16e4-48e0-8e1a-8fea09c78f3e	9d5ec4e1-1da8-46c5-8ba7-cd357d6041db	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 10:52:35
14832	9d5ec4e1-1760-4adf-acc6-4d5cb93978b4	9d5ec4e1-1da8-46c5-8ba7-cd357d6041db	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (57, 4, 100000, 250000, 'Pendiente', 'N\\/A', '27-11-2024', 12, '2024-10-30 10:52:35', '2024-10-30 10:52:35')","time":"0.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 10:52:35
14833	9d5ec4e1-1782-427a-b9b2-4dfce8176ecf	9d5ec4e1-1da8-46c5-8ba7-cd357d6041db	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 10:52:35
5929	9d52548c-6173-477f-b77a-dde2f30ffbdd	9d52548c-af2a-4d44-901f-d50ad7151b9e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 06:28:33
5930	9d52548c-a88d-405f-9468-4f9fcd12918e	9d52548c-af2a-4d44-901f-d50ad7151b9e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"160.42","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":130,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 06:28:33
5931	9d52548c-a904-4d55-b5e2-11d9f748217d	9d52548c-af2a-4d44-901f-d50ad7151b9e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 06:28:33
5932	9d52548c-ad7a-47f6-9f66-70435652c235	9d52548c-af2a-4d44-901f-d50ad7151b9e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 06:28:33
5933	9d52548c-adea-4d56-a909-51d78e87af2f	9d52548c-af2a-4d44-901f-d50ad7151b9e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":353,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:28:33
14834	9d5ec4e1-1803-46bd-bf3a-7288bcea77f8	9d5ec4e1-1da8-46c5-8ba7-cd357d6041db	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (57, 5, 100000, 250000, 'Pendiente', 'N\\/A', '04-12-2024', 12, '2024-10-30 10:52:35', '2024-10-30 10:52:35')","time":"0.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 10:52:35
14835	9d5ec4e1-182e-47b1-a306-4182702fef55	9d5ec4e1-1da8-46c5-8ba7-cd357d6041db	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 10:52:35
14836	9d5ec4e1-1c48-420a-9b39-c79ed2434120	9d5ec4e1-1da8-46c5-8ba7-cd357d6041db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-30 10:52:35
14837	9d5ec4e1-1cab-47f9-b6d5-57481afbef81	9d5ec4e1-1da8-46c5-8ba7-cd357d6041db	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"743","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"100465546","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"500000","loans_intereses":50,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":18,"user_recomendacion":14,"loans_inicio_pago":"30-10-2024","created_at":null,"updated_at":null,"deleted_at":null},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Wed Oct 30 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":57},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:52:35
19543	9d66e02a-97f7-49fc-9a2a-de887a0707ba	9d66e02a-9951-4d69-8a98-a2406363ad8c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":530,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:35:31
20809	9d66fc2e-6e01-4689-a4db-35de7955b574	9d66fc2e-71e3-422b-a3b9-17fd6c6f53fb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":260,"memory":20,"hostname":"EderCortes"}	2024-11-03 12:53:51
5934	9d52548c-f509-4c1d-8ae8-4563c3eac3ce	9d52548d-3d3a-49b6-bdef-0a842f5772d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 06:28:34
5935	9d52548d-3828-4205-ac30-7b0bdb28baba	9d52548d-3d3a-49b6-bdef-0a842f5772d9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"148.59","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":130,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 06:28:34
5936	9d52548d-387f-46ff-9176-dddc852fddac	9d52548d-3d3a-49b6-bdef-0a842f5772d9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 06:28:34
5937	9d52548d-3c14-4ad1-bf1e-eced039509c3	9d52548d-3d3a-49b6-bdef-0a842f5772d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 06:28:34
5938	9d52548d-3c5f-464d-b83a-68f15462330b	9d52548d-3d3a-49b6-bdef-0a842f5772d9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:28:34
14838	9d5ec4eb-fbac-44e0-a6a7-37bda79093b6	9d5ec4ec-1584-436b-87bc-415c5764e1fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-30 10:52:42
14839	9d5ec4ec-10bf-416f-9871-31883642c8b8	9d5ec4ec-1584-436b-87bc-415c5764e1fe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"42.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-10-30 10:52:42
14840	9d5ec4ec-13f7-4bd7-82fd-f841ffc68bd9	9d5ec4ec-1584-436b-87bc-415c5764e1fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-30 10:52:42
14841	9d5ec4ec-1469-4c6d-b54f-ec26a5822b81	9d5ec4ec-1584-436b-87bc-415c5764e1fe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":227,"memory":20,"hostname":"EderCortes"}	2024-10-30 10:52:42
20132	9d66ee86-4dd7-4167-989d-38fe3e69d26d	9d66ee86-4f66-4237-a146-78a94a0d3eba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":433,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:15:40
5939	9d52548e-ad0c-422a-a1f3-f8a5ac52a302	9d52548f-20a6-450f-9520-4451f2fa1b24	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 06:28:35
5940	9d52548f-1b4d-44fc-8043-472025e1bcf3	9d52548f-20a6-450f-9520-4451f2fa1b24	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"195.94","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 06:28:35
3708	9d51098c-23e2-4648-9bd1-dc77835b668b	9d51098c-74a6-4628-a2fa-f2c13bcb0eb0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 15:03:00
3709	9d51098c-71f3-44e1-80e6-450d504bed31	9d51098c-74a6-4628-a2fa-f2c13bcb0eb0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 15:03:01
3710	9d51098c-72fc-45bf-a9ed-e36d99a5e477	9d51098c-74a6-4628-a2fa-f2c13bcb0eb0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":868,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:03:01
5941	9d52548f-1b9e-4883-9037-ec7dd8dadf0c	9d52548f-20a6-450f-9520-4451f2fa1b24	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 06:28:35
5942	9d52548f-1f47-4ab9-9850-888439ffec0d	9d52548f-20a6-450f-9520-4451f2fa1b24	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 06:28:35
5943	9d52548f-1f96-46b1-9ede-4d3c38ed43cc	9d52548f-20a6-450f-9520-4451f2fa1b24	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":617,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:28:35
14842	9d5ec4ed-5bd1-41f7-97f0-ded7650f971e	9d5ec4ed-74b3-4cd3-9f6b-8000ca7925ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-30 10:52:43
14843	9d5ec4ed-7088-4581-b6c3-89cf962f525f	9d5ec4ed-74b3-4cd3-9f6b-8000ca7925ff	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"41.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-30 10:52:43
14844	9d5ec4ed-7366-4550-bf17-3dce0c2bb8ab	9d5ec4ed-74b3-4cd3-9f6b-8000ca7925ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-30 10:52:43
14845	9d5ec4ed-73bc-456d-a45e-851793b538a7	9d5ec4ed-74b3-4cd3-9f6b-8000ca7925ff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":213,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:52:43
20234	9d66f057-9545-40c2-9d56-bf9ddd6692b0	9d66f057-9636-4bd8-9926-e97e0fe35c95	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":273,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:20:44
3711	9d51098c-f00e-4ece-be7f-fb5bb11864e2	9d51098d-1641-40a1-b0e3-3422aad2c319	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 15:03:01
3712	9d51098d-0fee-4655-9dee-450cdaff0ce5	9d51098d-1641-40a1-b0e3-3422aad2c319	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"54.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:03:01
3713	9d51098d-1058-4168-b634-34634bc6939f	9d51098d-1641-40a1-b0e3-3422aad2c319	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 15:03:01
3714	9d51098d-14f2-493c-a82f-572afa36e245	9d51098d-1641-40a1-b0e3-3422aad2c319	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 15:03:01
3715	9d51098d-1542-4745-a8b1-cb9c9bbdadb7	9d51098d-1641-40a1-b0e3-3422aad2c319	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:03:01
5944	9d525501-47f8-4b9b-b994-23b4ff2377aa	9d525501-4c2a-4c55-b8ee-859b698533af	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":153,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:29:50
14846	9d5ec4f1-50d9-4a34-b2f0-5b2ba89da3a4	9d5ec4f1-9b4e-4250-a746-c4d0721ee886	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-30 10:52:46
6223	9d5262b0-3202-4c11-acb1-43c9db0bf2f7	9d5262b0-7b35-435f-9506-c3c46c303c44	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 07:08:05
6224	9d5262b0-77be-439d-8727-8d2fb87f31e5	9d5262b0-7b35-435f-9506-c3c46c303c44	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 07:08:06
6225	9d5262b0-790d-4d4a-88f7-4625ab3bb720	9d5262b0-7b35-435f-9506-c3c46c303c44	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":775,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:08:06
14847	9d5ec4f1-925c-4de5-bd4b-f58e9a5a418b	9d5ec4f1-9b4e-4250-a746-c4d0721ee886	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 57\\n                        ","time":"156.10","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"eb9645b1db1f5e642b7b4e4bc0dcc776","hostname":"EderCortes"}	2024-10-30 10:52:46
6270	9d526408-c4d9-4818-b7d8-34bdc12dd03b	9d526408-ec75-4c2c-9e79-21761ff9b412	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 07:11:51
6271	9d526408-ea17-4851-a803-1ee2531756c6	9d526408-ec75-4c2c-9e79-21761ff9b412	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 07:11:51
6272	9d526408-eb10-40cf-a412-ddcb71d586c1	9d526408-ec75-4c2c-9e79-21761ff9b412	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":288,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:11:51
14848	9d5ec4f1-9642-4a00-a957-47f7bdc43d29	9d5ec4f1-9b4e-4250-a746-c4d0721ee886	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '57' order by \\"item_loans\\".\\"id\\" asc","time":"3.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-30 10:52:46
14849	9d5ec4f1-9674-4ec6-9c63-d9607e329db0	9d5ec4f1-9b4e-4250-a746-c4d0721ee886	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-10-30 10:52:46
14850	9d5ec4f1-99fa-4659-9dd3-60402b9c2cd7	9d5ec4f1-9b4e-4250-a746-c4d0721ee886	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-30 10:52:46
18792	9d669bee-985b-4f4d-a200-7eef02ff8010	9d669bee-e2bc-47d3-a248-1809bced13c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:24:43
18793	9d669bee-dc10-4021-836d-56b84fac90df	9d669bee-e2bc-47d3-a248-1809bced13c9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"151.04","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 08:24:43
18794	9d669bee-dc66-4d12-9c5c-6f33e09c18bf	9d669bee-e2bc-47d3-a248-1809bced13c9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 08:24:43
18795	9d669bee-e120-4913-99ee-329aae8375d9	9d669bee-e2bc-47d3-a248-1809bced13c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 08:24:43
20235	9d66f05c-a539-4a6a-ad9b-539361f8db2b	9d66f05c-c80a-45c1-b733-2b2914b0d1b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:20:48
5945	9d525501-adeb-435c-85c9-cceefcdecd87	9d525501-f738-4cea-ba0e-fe2854f620a6	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 06:29:50
2920	9d50fdaa-ae12-4aff-a5cb-f770c1fcd2d7	9d50fdaa-f92c-4426-97bb-49483417c56e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 14:29:47
2921	9d50fdaa-f77d-46fa-bb0d-69e31b12ce19	9d50fdaa-f92c-4426-97bb-49483417c56e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 14:29:47
2922	9d50fdaa-f82b-425b-9ab2-0b89c5d0ce15	9d50fdaa-f92c-4426-97bb-49483417c56e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":387,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:29:47
5946	9d525501-f133-4869-b77e-9991a127d703	9d525501-f738-4cea-ba0e-fe2854f620a6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Luis%' or \\"users\\".\\"user_document\\"::text like '%Luis%' order by \\"users\\".\\"user_document\\" asc","time":"143.54","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":49,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-24 06:29:50
5947	9d525501-f5b1-430a-840c-19a5e0819029	9d525501-f738-4cea-ba0e-fe2854f620a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 06:29:50
5948	9d525501-f60a-4363-9aaf-c0040cf30f71	9d525501-f738-4cea-ba0e-fe2854f620a6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Luis"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":355,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:29:50
3716	9d51098d-6c5e-4afa-8069-574d16c205ca	9d51098d-c187-4368-9923-20b6debb0394	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 15:03:01
3717	9d51098d-bab8-476a-a272-af3c95344605	9d51098d-c187-4368-9923-20b6debb0394	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"155.70","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:03:01
3718	9d51098d-bb27-4f44-8e71-766fe1a9fb33	9d51098d-c187-4368-9923-20b6debb0394	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 15:03:01
3719	9d51098d-bffa-4b82-8f54-7c09a9550fcd	9d51098d-c187-4368-9923-20b6debb0394	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 15:03:01
6226	9d5262b0-ec2c-42ea-96cf-e9ebd923896d	9d5262b1-0b57-477b-bdf1-3c60e084ee2c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 07:08:06
6227	9d5262b1-03d1-4a0e-acb3-46c90d154544	9d5262b1-0b57-477b-bdf1-3c60e084ee2c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n    select l.id,\\n        l.loans_documento,\\n        l.loans_nombre,\\n        l.loans_apellido_uno,\\n        l.loans_fecha,\\n        l.loans_valor_prestado,\\n        l.loans_cuotas,\\n        loans_intereses,\\n        ucl.name as cliente,\\n        uco.name as cobrador,\\n        ure.name as recomendador\\n    from loans l\\n    join users ucl on l.user_customer = ucl.id\\n    join users uco on l.user_cobrador = uco.id\\n    left join users ure on l.user_recomendacion = ure.id\\n","time":"45.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23,"hash":"4a29eecc7f0e29116a12840a44c5fe9b","hostname":"EderCortes"}	2024-10-24 07:08:06
6228	9d5262b1-09a9-4407-961a-f66dfc853a81	9d5262b1-0b57-477b-bdf1-3c60e084ee2c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 07:08:06
6229	9d5262b1-0a1e-48a6-b264-cbd628ee2f25	9d5262b1-0b57-477b-bdf1-3c60e084ee2c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_intereses":25,"cliente":"Luis andre","cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_intereses":25,"cliente":"Luis andre","cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_intereses":25,"cliente":"Luis andre","cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_intereses":25,"cliente":"Luis andre","cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_intereses":25,"cliente":"Luis andre","cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_intereses":25,"cliente":"Luis andre","cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_intereses":25,"cliente":"Luis andre","cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_intereses":25,"cliente":"Luis andre","cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_intereses":25,"cliente":"Luis andre","cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_intereses":25,"cliente":"Luis andre","cobrador":"Luis andre","recomendador":null}]},"duration":309,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:08:06
14851	9d5ec4f1-9a57-422e-83ba-bde336917d1e	9d5ec4f1-9b4e-4250-a746-c4d0721ee886	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/57","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":57,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":162,"loans_codigo":57,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:52:35.000000Z","updated_at":"2024-10-30T15:52:35.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":163,"loans_codigo":57,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:52:35.000000Z","updated_at":"2024-10-30T15:52:35.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":164,"loans_codigo":57,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:52:35.000000Z","updated_at":"2024-10-30T15:52:35.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":165,"loans_codigo":57,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:52:35.000000Z","updated_at":"2024-10-30T15:52:35.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":166,"loans_codigo":57,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:52:35.000000Z","updated_at":"2024-10-30T15:52:35.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":332,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:52:46
2923	9d50fdab-4799-4dd2-8097-fb2e3fb416ca	9d50fdab-916f-4dc2-8f95-40013e9ec793	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 14:29:48
2924	9d50fdab-8b09-445a-9a30-7de30fd48db7	9d50fdab-916f-4dc2-8f95-40013e9ec793	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"148.20","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:29:48
2925	9d50fdab-8b61-413d-907f-23b1edcd94c9	9d50fdab-916f-4dc2-8f95-40013e9ec793	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:29:48
2926	9d50fdab-8fc6-4953-93f1-0338899279db	9d50fdab-916f-4dc2-8f95-40013e9ec793	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 14:29:48
2927	9d50fdab-9044-43f7-9b4c-70f0a4cccdae	9d50fdab-916f-4dc2-8f95-40013e9ec793	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":362,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:29:48
3720	9d51098d-c06b-48dd-8859-19e2bafb1c75	9d51098d-c187-4368-9923-20b6debb0394	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":422,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:03:01
5949	9d525506-c5f6-4e40-9426-5762aae631cb	9d525506-e6e8-45d9-a329-b62c1b6edb25	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 06:29:53
3034	9d5101a6-5b7d-4f82-a522-0c7fc1e13367	9d5101a6-84d0-47af-82a2-a8c0e7265934	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 14:40:55
3035	9d5101a6-825f-4ff8-8ff5-8ea7bdca9181	9d5101a6-84d0-47af-82a2-a8c0e7265934	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:40:56
3036	9d5101a6-8364-4171-9b98-a2b35ae668f2	9d5101a6-84d0-47af-82a2-a8c0e7265934	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:40:56
5950	9d525506-e0fe-46bc-8921-fdccb649c463	9d525506-e6e8-45d9-a329-b62c1b6edb25	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '14' and \\"users\\".\\"deleted_at\\" is null","time":"43.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":31,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-24 06:29:53
5951	9d525506-e159-4dd4-bdce-b0cfdce2a39d	9d525506-e6e8-45d9-a329-b62c1b6edb25	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 06:29:53
5952	9d525506-e575-4878-876f-1294b8f1c099	9d525506-e6e8-45d9-a329-b62c1b6edb25	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 06:29:53
5953	9d525506-e5cc-4a46-8316-4dcd366d1860	9d525506-e6e8-45d9-a329-b62c1b6edb25	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/14","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}},"duration":317,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:29:53
6230	9d5262b3-2192-4ddf-b27d-b2e11cf32c05	9d5262b3-5f88-4107-a265-40dd565e7b61	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 07:08:07
6231	9d5262b3-5454-43b5-be58-22c3cb23055e	9d5262b3-5f88-4107-a265-40dd565e7b61	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"102.48","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 07:08:07
6232	9d5262b3-54ee-41fc-9683-62d406f833c7	9d5262b3-5f88-4107-a265-40dd565e7b61	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 07:08:07
6233	9d5262b3-5d77-4f09-94fc-6858a6553c98	9d5262b3-5f88-4107-a265-40dd565e7b61	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 07:08:08
14852	9d5ec566-d89a-4194-a0d3-ca26e130c86b	9d5ec566-fa42-48ee-9426-7f9ea10cf73d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-30 10:54:03
2928	9d50fdab-d972-400d-b884-5bfe0f962abd	9d50fdab-fb10-4c63-9ed7-3346e2e86cae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 14:29:48
2929	9d50fdab-f567-482c-be23-9a738ba2ab59	9d50fdab-fb10-4c63-9ed7-3346e2e86cae	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:29:48
2930	9d50fdab-f5b9-4ad5-bad2-ea42c2fb15a6	9d50fdab-fb10-4c63-9ed7-3346e2e86cae	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:29:48
2931	9d50fdab-f9cf-4105-a6c1-159eb5f97e63	9d50fdab-fb10-4c63-9ed7-3346e2e86cae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 14:29:48
2932	9d50fdab-fa1a-46ca-98ce-7812732ebd9c	9d50fdab-fb10-4c63-9ed7-3346e2e86cae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":248,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:29:48
3037	9d5101a6-e8d1-4a36-83ad-ae704332ec1c	9d5101a7-0b8f-483f-ac2f-b6a25c0c78be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:40:56
3038	9d5101a7-0569-4f4d-89a3-eb3c0cfd82d0	9d5101a7-0b8f-483f-ac2f-b6a25c0c78be	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:40:56
3039	9d5101a7-05b2-43a9-b9ee-638c1445726a	9d5101a7-0b8f-483f-ac2f-b6a25c0c78be	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:40:56
3040	9d5101a7-0a5e-4869-ae1f-a8b1e4c82d1d	9d5101a7-0b8f-483f-ac2f-b6a25c0c78be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:40:56
3041	9d5101a7-0ab4-46db-89c5-f3d988329cb0	9d5101a7-0b8f-483f-ac2f-b6a25c0c78be	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:40:56
3721	9d51098e-4c94-4c1d-97a0-62386aa6ad01	9d51098e-934f-4f88-a1c4-9c3269ae17d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 15:03:02
3722	9d51098e-86f6-4870-b48e-2824470f8962	9d51098e-934f-4f88-a1c4-9c3269ae17d3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"91.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 15:03:02
3723	9d51098e-8798-4ae1-8bb9-f368d8d37c8a	9d51098e-934f-4f88-a1c4-9c3269ae17d3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 15:03:02
3724	9d51098e-90e5-4b68-9ed0-87d5f36fca29	9d51098e-934f-4f88-a1c4-9c3269ae17d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 15:03:02
3725	9d51098e-918d-40c2-8a2f-4dec8fcb6da6	9d51098e-934f-4f88-a1c4-9c3269ae17d3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":516,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:03:02
3042	9d5101a7-51f7-4308-91f5-0ef33a230764	9d5101a7-731c-49a9-980f-2ff13983111a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:40:56
3043	9d5101a7-6d68-4837-8fb6-9fff3efe43c2	9d5101a7-731c-49a9-980f-2ff13983111a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:40:56
3044	9d5101a7-6db6-466a-a8e4-f6258a3b735d	9d5101a7-731c-49a9-980f-2ff13983111a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:40:56
3045	9d5101a7-720d-4b00-9702-e306d44d115e	9d5101a7-731c-49a9-980f-2ff13983111a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:40:56
3046	9d5101a7-7250-4ec2-8e86-9ae6618f3beb	9d5101a7-731c-49a9-980f-2ff13983111a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:40:56
3726	9d51098f-32de-4302-a9e5-65757fc25de5	9d51098f-6d55-474a-abf5-4dca41852fc6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 15:03:02
3727	9d51098f-6277-4040-8ab4-5b5ff498f82e	9d51098f-6d55-474a-abf5-4dca41852fc6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"80.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 15:03:03
3728	9d51098f-6305-48cc-84bc-14736650695d	9d51098f-6d55-474a-abf5-4dca41852fc6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 15:03:03
3729	9d51098f-6a33-478a-a4e1-abb17452f97f	9d51098f-6d55-474a-abf5-4dca41852fc6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 15:03:03
3730	9d51098f-6b78-4a3e-aa67-19e1417e5a38	9d51098f-6d55-474a-abf5-4dca41852fc6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":527,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:03:03
5954	9d525522-4bf1-4a51-b432-e25ac36acc39	9d525522-4f21-44bc-a70a-80982b015d74	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":150,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:30:11
6234	9d5262b3-5e0c-4971-ac18-679efaadab3f	9d5262b3-5f88-4107-a265-40dd565e7b61	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":381,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:08:08
5955	9d525522-d2f5-4256-ad09-e5b5e76163a2	9d525523-253e-4290-a8cb-1032485cd9eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 06:30:12
5956	9d525523-1a74-4758-8180-e337c23b13d5	9d525523-253e-4290-a8cb-1032485cd9eb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"updated_at\\", \\"created_at\\") values ('Luis andre', 'Herrera', 'MArtinez', 'CC', '100465545', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '500000', 25, 6, 'S', null, 'Thu Oct 24 2024', 'Pendiente', 12, 14, 14, '2024-10-24 06:30:12', '2024-10-24 06:30:12') returning \\"id\\"","time":"5.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":77,"hash":"18efcd076c06e51570dcc83643e19328","hostname":"EderCortes"}	2024-10-24 06:30:12
2616	9d50faec-8a7d-470b-a7d3-cb7be2f9f5c9	9d50faec-ccc4-445d-a19f-f0e91587317b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 14:22:07
2617	9d50faec-c96d-439f-b73a-7c835ffb0003	9d50faec-ccc4-445d-a19f-f0e91587317b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 14:22:07
2618	9d50faec-cb09-4ce6-86c9-6bd8b9689219	9d50faec-ccc4-445d-a19f-f0e91587317b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":584,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:22:07
3822	9d511a4b-ea91-4660-8e28-f47aa1913a3d	9d511a4c-0a11-40e6-bb0c-2e4188b1f38b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 15:49:50
3823	9d511a4c-0874-4bce-acb3-ce34b4174e67	9d511a4c-0a11-40e6-bb0c-2e4188b1f38b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 15:49:51
3824	9d511a4c-090d-4837-b3ae-8239d1868856	9d511a4c-0a11-40e6-bb0c-2e4188b1f38b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:49:51
5957	9d525523-1ade-44ac-93d1-c582d7ba3f09	9d525523-253e-4290-a8cb-1032485cd9eb	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:1","hostname":"EderCortes"}	2024-10-24 06:30:12
5958	9d525523-1c27-4463-9b87-a23de0e6ac92	9d525523-253e-4290-a8cb-1032485cd9eb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (1, 1, 83333.333333333, 125000, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:30:12', '2024-10-24 06:30:12')","time":"2.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:30:12
5959	9d525523-1c59-4fae-af8c-8b4a7d86447e	9d525523-253e-4290-a8cb-1032485cd9eb	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:30:12
5960	9d525523-1d3d-406d-b901-c8d94ea91b09	9d525523-253e-4290-a8cb-1032485cd9eb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (1, 2, 83333.333333333, 125000, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:30:12', '2024-10-24 06:30:12')","time":"0.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:30:12
5961	9d525523-1d6f-4020-bce2-bab6749f0a34	9d525523-253e-4290-a8cb-1032485cd9eb	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:30:12
5962	9d525523-1df9-46d5-bed1-6ab47b6a4c39	9d525523-253e-4290-a8cb-1032485cd9eb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (1, 3, 83333.333333333, 125000, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:30:12', '2024-10-24 06:30:12')","time":"0.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:30:12
5963	9d525523-1e23-4ecc-8b89-a694a4449ae6	9d525523-253e-4290-a8cb-1032485cd9eb	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:30:12
5964	9d525523-1e8e-4e16-bda9-f5856cd4d290	9d525523-253e-4290-a8cb-1032485cd9eb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (1, 4, 83333.333333333, 125000, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:30:12', '2024-10-24 06:30:12')","time":"0.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:30:12
5965	9d525523-1eb1-419b-8736-ee0d31d425d4	9d525523-253e-4290-a8cb-1032485cd9eb	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:30:12
5966	9d525523-1f33-4806-8281-d81ba11303da	9d525523-253e-4290-a8cb-1032485cd9eb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (1, 5, 83333.333333333, 125000, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:30:12', '2024-10-24 06:30:12')","time":"0.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:30:12
5967	9d525523-1f67-41aa-9fac-ea087065a3b1	9d525523-253e-4290-a8cb-1032485cd9eb	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:30:12
5968	9d525523-1ff8-48d0-81c2-dc3535bd43bd	9d525523-253e-4290-a8cb-1032485cd9eb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (1, 6, 83333.333333333, 125000, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:30:12', '2024-10-24 06:30:12')","time":"0.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:30:12
5969	9d525523-2020-4c29-9197-46b266216b99	9d525523-253e-4290-a8cb-1032485cd9eb	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:30:12
5970	9d525523-23fe-441c-a4bd-01b1f562124e	9d525523-253e-4290-a8cb-1032485cd9eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 06:30:12
2619	9d50faed-4fab-422f-85a1-9544b49f0429	9d50faed-826e-422c-8a41-b55891f139de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 14:22:08
2620	9d50faed-7acd-4aba-8f6c-731b5824488c	9d50faed-826e-422c-8a41-b55891f139de	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"71.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:22:08
2621	9d50faed-7b59-41a7-befb-004d83ca571e	9d50faed-826e-422c-8a41-b55891f139de	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:22:08
2622	9d50faed-80ac-4bf6-99f7-427dceefa2a1	9d50faed-826e-422c-8a41-b55891f139de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 14:22:08
2623	9d50faed-8176-42fa-b2b6-aa8a64c27e04	9d50faed-826e-422c-8a41-b55891f139de	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":429,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:22:08
3825	9d511a4c-597f-4f0c-b707-c16f3202519d	9d511a4c-a4aa-4f59-b216-5959606dffb7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 15:49:51
3826	9d511a4c-9ff5-46c2-a34b-cc474d4b6cb3	9d511a4c-a4aa-4f59-b216-5959606dffb7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"155.83","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:49:51
3827	9d511a4c-a042-497e-92e6-24abcd029bee	9d511a4c-a4aa-4f59-b216-5959606dffb7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 15:49:51
3828	9d511a4c-a3ad-484b-b6a2-cd5c6fc7fc6f	9d511a4c-a4aa-4f59-b216-5959606dffb7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 15:49:51
3829	9d511a4c-a3ee-4674-ac3e-694244ac2ed4	9d511a4c-a4aa-4f59-b216-5959606dffb7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:49:51
5971	9d525523-2442-40ab-95f7-d77011242796	9d525523-253e-4290-a8cb-1032485cd9eb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"615","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":"100465545","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"500000","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_cobrador":14,"user_customer":14},"detail":{"status":false,"observacion":"N\\/A","fecha_pago":"Thu Oct 24 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":1},"duration":369,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:30:12
14853	9d5ec566-f42a-4ad1-95ef-95183315c070	9d5ec566-fa42-48ee-9426-7f9ea10cf73d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"44.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-10-30 10:54:03
14854	9d5ec566-f898-4196-8231-e80d547f959f	9d5ec566-fa42-48ee-9426-7f9ea10cf73d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 10:54:03
2624	9d50faed-ed4f-4fa3-a5a4-ffc6fee05598	9d50faee-4241-4039-97b5-d633bd86ae90	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 14:22:08
2625	9d50faee-3b5d-4622-8275-7860b9522370	9d50faee-4241-4039-97b5-d633bd86ae90	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"160.90","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:22:08
2626	9d50faee-3bca-4b3c-a56b-fc2599698959	9d50faee-4241-4039-97b5-d633bd86ae90	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:22:08
2627	9d50faee-40e4-49a6-8a0e-7bdad99a0106	9d50faee-4241-4039-97b5-d633bd86ae90	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 14:22:08
2628	9d50faee-4136-40ec-b353-4405e32db450	9d50faee-4241-4039-97b5-d633bd86ae90	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":468,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:22:08
3830	9d511a4c-f340-4bae-984d-8761ca2a0e06	9d511a4d-3c35-45e5-b848-69ebac88821e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 15:49:51
3831	9d511a4d-3678-492d-9803-790747ea542b	9d511a4d-3c35-45e5-b848-69ebac88821e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"148.20","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:49:51
3832	9d511a4d-36eb-4f93-ae9d-c27689689104	9d511a4d-3c35-45e5-b848-69ebac88821e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 15:49:51
3833	9d511a4d-3b16-461a-9da7-292907c54234	9d511a4d-3c35-45e5-b848-69ebac88821e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 15:49:51
3834	9d511a4d-3b5a-47f8-acfc-d232e802c52c	9d511a4d-3c35-45e5-b848-69ebac88821e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":368,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:49:51
5972	9d525650-4b75-4120-9ff7-c974f1b518ce	9d525650-507d-4c96-a8b2-69e0c218b554	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":236,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:33:29
14855	9d5ec566-f908-4eae-834f-712088c7ec32	9d5ec566-fa42-48ee-9426-7f9ea10cf73d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:54:03
2629	9d50faee-cb9a-42e6-ac5b-ae38bf01fe8e	9d50faef-1bec-42ff-a700-29847e38fb8a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 14:22:08
2630	9d50faef-0f0a-4bb1-9b43-8aee9d02c813	9d50faef-1bec-42ff-a700-29847e38fb8a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"107.62","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:22:09
2631	9d50faef-0ff1-449a-83ec-b71c71f253a1	9d50faef-1bec-42ff-a700-29847e38fb8a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:22:09
2632	9d50faef-196c-4a32-bc3b-9810f694c234	9d50faef-1bec-42ff-a700-29847e38fb8a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 14:22:09
2633	9d50faef-1a2c-4699-b2d8-404d2c499502	9d50faef-1bec-42ff-a700-29847e38fb8a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":535,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:22:09
5973	9d525676-45eb-4f5d-800b-44952addebd7	9d525676-49a2-4b90-8f25-5bb2755bb78a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":198,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:33:54
14856	9d5ec569-2f44-42bb-a7db-027593f5f133	9d5ec569-7929-4e11-98ee-ffbf2447fe3e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 10:54:04
4083	9d511d17-127b-4198-a396-3b33bcf24071	9d511d17-4e90-43bb-957d-f6f6551d571e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 15:57:39
4084	9d511d17-4bcf-4c9a-afe4-ac0928ee664e	9d511d17-4e90-43bb-957d-f6f6551d571e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 15:57:39
4085	9d511d17-4d2b-49b5-a192-e652c5f399e0	9d511d17-4e90-43bb-957d-f6f6551d571e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":567,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:57:39
14857	9d5ec569-73dd-4ac6-90c0-6d45eb9c619e	9d5ec569-7929-4e11-98ee-ffbf2447fe3e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"153.06","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":179,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 10:54:05
14858	9d5ec569-7429-4c98-80be-2c27c08e7eb6	9d5ec569-7929-4e11-98ee-ffbf2447fe3e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-30 10:54:05
14859	9d5ec569-77c8-4327-85a6-1857bc33819a	9d5ec569-7929-4e11-98ee-ffbf2447fe3e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 10:54:05
14860	9d5ec569-780e-4043-ac6c-a6f470d176d8	9d5ec569-7929-4e11-98ee-ffbf2447fe3e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":458,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:54:05
20810	9d66fc2f-0a0e-4917-8ab3-6b753022da4a	9d66fc2f-0da2-407f-89ed-607ff77d1cd5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":211,"memory":20,"hostname":"EderCortes"}	2024-11-03 12:53:51
2634	9d50faef-a77a-4e9a-b947-10fd7051732a	9d50faef-e1b0-440a-a025-fbbfe6bd0ae0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 14:22:09
2635	9d50faef-d5bc-4b76-9888-3753f5b54f4b	9d50faef-e1b0-440a-a025-fbbfe6bd0ae0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"80.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:22:09
2636	9d50faef-d653-4b31-9178-8742d9866478	9d50faef-e1b0-440a-a025-fbbfe6bd0ae0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:22:09
2637	9d50faef-df36-4288-b7c9-8ad88ad4be21	9d50faef-e1b0-440a-a025-fbbfe6bd0ae0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-23 14:22:09
2638	9d50faef-dfeb-4054-9af1-cc33fe7b1a70	9d50faef-e1b0-440a-a025-fbbfe6bd0ae0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":474,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:22:09
4086	9d511d17-ef5a-480a-996f-b7f8d4f7c757	9d511d18-4f76-4983-ac13-16ad907226c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 15:57:40
4087	9d511d18-4452-42a8-9ab2-0d8baaf3d3ed	9d511d18-4f76-4983-ac13-16ad907226c0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"171.90","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:57:40
4088	9d511d18-44e0-4d6f-8817-0388088bdcef	9d511d18-4f76-4983-ac13-16ad907226c0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 15:57:40
4089	9d511d18-4cda-47e0-a2da-d2b9479493a6	9d511d18-4f76-4983-ac13-16ad907226c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 15:57:40
4090	9d511d18-4d70-4c2d-b97e-cf8c0b3f86be	9d511d18-4f76-4983-ac13-16ad907226c0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":614,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:57:40
5974	9d525676-c95f-4b3e-9261-4fa580428c4e	9d525677-17d6-4062-a5a7-e615ff321bc2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 06:33:55
5975	9d525677-0c41-451e-a904-89e9185d799d	9d525677-17d6-4062-a5a7-e615ff321bc2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"updated_at\\", \\"created_at\\") values ('Luis andre', 'Herrera', 'MArtinez', 'CC', '100465545', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '500000', 25, 6, 'S', null, 'Thu Oct 24 2024', 'Pendiente', 12, 14, 14, '2024-10-24 06:33:55', '2024-10-24 06:33:55') returning \\"id\\"","time":"5.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":77,"hash":"18efcd076c06e51570dcc83643e19328","hostname":"EderCortes"}	2024-10-24 06:33:55
5976	9d525677-0ca8-438a-b426-f5c04686e0a7	9d525677-17d6-4062-a5a7-e615ff321bc2	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:1","hostname":"EderCortes"}	2024-10-24 06:33:55
5977	9d525677-0e17-4ec6-bb01-63a1b55fe8bc	9d525677-17d6-4062-a5a7-e615ff321bc2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (1, 1, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:33:55', '2024-10-24 06:33:55')","time":"2.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:33:55
5978	9d525677-0e49-4410-b953-93ff1f35c354	9d525677-17d6-4062-a5a7-e615ff321bc2	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:33:55
5979	9d525677-0ec1-48c9-a521-8400ace9875d	9d525677-17d6-4062-a5a7-e615ff321bc2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (1, 2, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:33:55', '2024-10-24 06:33:55')","time":"0.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:33:55
5980	9d525677-0ee5-4405-95b9-ee52c9c3feb9	9d525677-17d6-4062-a5a7-e615ff321bc2	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:33:55
5981	9d525677-0f5f-436f-8dd4-42b26b3f9e64	9d525677-17d6-4062-a5a7-e615ff321bc2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (1, 3, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:33:55', '2024-10-24 06:33:55')","time":"0.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:33:55
5982	9d525677-0f98-4e7d-8f78-1b5b968fa670	9d525677-17d6-4062-a5a7-e615ff321bc2	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:33:55
5983	9d525677-1032-496f-b01a-6277a825e0ad	9d525677-17d6-4062-a5a7-e615ff321bc2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (1, 4, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:33:55', '2024-10-24 06:33:55')","time":"0.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:33:55
2156	9d50e4e1-0e62-44d7-aff2-0396c53ba30b	9d50e4e1-38b6-44f6-a354-1cf8e9f73674	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 13:20:28
2157	9d50e4e1-3668-4e6e-839b-f90313bd7e36	9d50e4e1-38b6-44f6-a354-1cf8e9f73674	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 13:20:29
2158	9d50e4e1-3758-43bb-b946-4fa2862d1572	9d50e4e1-38b6-44f6-a354-1cf8e9f73674	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":405,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:20:29
5984	9d525677-1073-4623-a1f2-3e1c5c905681	9d525677-17d6-4062-a5a7-e615ff321bc2	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:33:55
4091	9d511d18-cbff-483b-bb4e-866df4b17ef9	9d511d19-1e0e-4b58-8171-113e31970b5e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 15:57:40
4092	9d511d19-17ca-4830-972c-9e3ad6ed039e	9d511d19-1e0e-4b58-8171-113e31970b5e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"150.23","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:57:40
4093	9d511d19-184d-4f46-9bcf-7cbf8efb45ce	9d511d19-1e0e-4b58-8171-113e31970b5e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 15:57:40
4094	9d511d19-1c75-4882-9d41-c218dbc55b51	9d511d19-1e0e-4b58-8171-113e31970b5e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 15:57:40
5985	9d525677-1114-4ed7-a01a-5dd2935779f6	9d525677-17d6-4062-a5a7-e615ff321bc2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (1, 5, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:33:55', '2024-10-24 06:33:55')","time":"0.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:33:55
5986	9d525677-1141-49ff-92a8-57d3ab49c814	9d525677-17d6-4062-a5a7-e615ff321bc2	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:33:55
5987	9d525677-11a9-4f71-a659-02433db4bab1	9d525677-17d6-4062-a5a7-e615ff321bc2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (1, 6, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:33:55', '2024-10-24 06:33:55')","time":"0.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:33:55
5988	9d525677-11ce-46b7-aaa3-6a7b9f11102a	9d525677-17d6-4062-a5a7-e615ff321bc2	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:33:55
5989	9d525677-167e-4f82-950d-c60a32752949	9d525677-17d6-4062-a5a7-e615ff321bc2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 06:33:55
5990	9d525677-16cc-4b26-af6a-8d06a573eef7	9d525677-17d6-4062-a5a7-e615ff321bc2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"615","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":"100465545","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"500000","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_cobrador":14,"user_customer":14},"detail":{"status":false,"observacion":"N\\/A","fecha_pago":"Thu Oct 24 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":1},"duration":358,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:33:55
14861	9d5ec569-bdb0-498e-95eb-0d9d85743c67	9d5ec56a-0622-48c7-ba53-21a2da1e5c40	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 10:54:05
14862	9d5ec56a-007b-4f1c-aeed-fbbb16c30a9d	9d5ec56a-0622-48c7-ba53-21a2da1e5c40	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"150.06","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":179,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 10:54:05
14863	9d5ec56a-00c7-42d2-b07e-957fa77b8055	9d5ec56a-0622-48c7-ba53-21a2da1e5c40	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-30 10:54:05
14864	9d5ec56a-0499-4fde-8f39-fac86b6731a3	9d5ec56a-0622-48c7-ba53-21a2da1e5c40	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 10:54:05
20236	9d66f05c-bd6a-4d0d-b05a-eb2a3e9d9f94	9d66f05c-c80a-45c1-b733-2b2914b0d1b5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"48.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:20:48
20811	9d66fc2f-62ed-4593-9864-a7160ebb900a	9d66fc2f-7d5b-4230-b744-8fcfa7ec71e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:53:51
3950	9d511b24-7288-4fac-b395-6ea4565a6160	9d511b24-b776-4359-aa2a-0f8ecaef6772	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-23 15:52:12
3951	9d511b24-b3f3-4a9f-b702-a964a8998311	9d511b24-b776-4359-aa2a-0f8ecaef6772	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-23 15:52:13
3952	9d511b24-b58e-4c6c-b329-3ea9e96c340a	9d511b24-b776-4359-aa2a-0f8ecaef6772	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1066,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:52:13
14865	9d5ec56a-04ea-4617-ada7-156d06e546dc	9d5ec56a-0622-48c7-ba53-21a2da1e5c40	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":343,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:54:05
20812	9d66fc2f-7963-40e0-aa5c-54e0709c80fd	9d66fc2f-7d5b-4230-b744-8fcfa7ec71e7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"40.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 12:53:51
20237	9d66f05c-c18b-44a6-b568-a71a58b1f32c	9d66f05c-c80a-45c1-b733-2b2914b0d1b5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:20:48
20238	9d66f05c-c1c0-42fb-aa1f-123a7179edb7	9d66f05c-c80a-45c1-b733-2b2914b0d1b5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:20:48
20239	9d66f05c-c66b-4489-a88d-4ebd1b1df1b1	9d66f05c-c80a-45c1-b733-2b2914b0d1b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:20:48
20240	9d66f05c-c6db-4db9-b5d6-ee6bab92e4ef	9d66f05c-c80a-45c1-b733-2b2914b0d1b5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":398,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:20:48
20813	9d66fc2f-7c34-4bdd-9fd1-084a1e1aa92b	9d66fc2f-7d5b-4230-b744-8fcfa7ec71e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 12:53:51
23336	9d689472-d295-4b16-8484-ab875c246c0d	9d689472-d650-4a0d-bd36-0abdcc380257	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":155,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:55:27
3953	9d511b25-1aa0-4125-aab4-a4b35e1ae76b	9d511b25-45ea-4ebb-83bf-2e63e26457f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-23 15:52:13
3954	9d511b25-3d86-494f-8e35-4886655d4570	9d511b25-45ea-4ebb-83bf-2e63e26457f5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"60.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:52:13
3955	9d511b25-3e3b-4a94-9b1f-6fef6c1781b3	9d511b25-45ea-4ebb-83bf-2e63e26457f5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 15:52:13
3956	9d511b25-4449-4c01-85a0-530e0185bd72	9d511b25-45ea-4ebb-83bf-2e63e26457f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-10-23 15:52:13
3957	9d511b25-44ab-4a39-9fe4-a917741f61af	9d511b25-45ea-4ebb-83bf-2e63e26457f5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":327,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:52:13
4095	9d511d19-1ccd-4cf3-b1fe-ae6d011fe504	9d511d19-1e0e-4b58-8171-113e31970b5e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":501,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:57:40
5991	9d52582d-2e6b-4463-934d-402afb681c5d	9d52582d-347e-4a06-890d-b7115e976cd6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":222,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:38:42
14866	9d5ec56c-c4fd-4aaa-a99d-bdb7ef32dfbd	9d5ec56c-c829-4f9b-90c1-0ee8580cbaa6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":174,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:54:07
6317	9d52643c-d706-4f86-9722-a21fb9bc0f1b	9d52643c-f437-4e46-ab9c-e423b411703c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 07:12:25
6318	9d52643c-f1fb-49ff-be12-69cb4731b15b	9d52643c-f437-4e46-ab9c-e423b411703c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 07:12:25
6319	9d52643c-f311-4ef5-856a-49ce36a33c62	9d52643c-f437-4e46-ab9c-e423b411703c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abfrom\\u00bb\\nLINE 14:     from loans l\\n             ^ (Connection: pgsql, SQL: \\n    select l.id,\\n        l.loans_documento,\\n        l.loans_nombre,\\n        l.loans_apellido_uno,\\n        l.loans_fecha,\\n        l.loans_valor_prestado,\\n        l.loans_cuotas,\\n        l.loans_estado,\\n        l.loans_intereses,\\n        ucl.name as cliente,\\n        uco.name as cobrador,\\n        ure.name as recomendador,\\n    from loans l\\n    join users ucl on l.user_customer = ucl.id\\n    join users uco on l.user_cobrador = uco.id\\n    left join users ure on l.user_recomendacion = ure.id\\n)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":267,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:12:25
20609	9d66f84f-33fe-400c-946a-faec78b93e3b	9d66f84f-827c-40dc-8040-c760d6e35a87	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:43:01
20610	9d66f84f-76d7-4afe-8311-685735dbc8a0	9d66f84f-827c-40dc-8040-c760d6e35a87	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"154.08","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:43:01
4096	9d511d1a-33ec-4282-8bae-ecb3c5086e02	9d511d1a-84cb-425b-a9fe-f4c16d4f5110	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 15:57:41
2782	9d50fc3b-d794-448a-b317-2d358c21822e	9d50fc3c-1384-4df5-9150-01c162fd8c6c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:25:47
2783	9d50fc3c-10ca-4ab7-ae2c-11458d1d81ca	9d50fc3c-1384-4df5-9150-01c162fd8c6c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:25:47
2784	9d50fc3c-11f1-480c-9b85-376a6d150d90	9d50fc3c-1384-4df5-9150-01c162fd8c6c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":833,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:25:47
4097	9d511d1a-7b2f-41ca-b938-ed62fb7d2d84	9d511d1a-84cb-425b-a9fe-f4c16d4f5110	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"90.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 15:57:41
4098	9d511d1a-7bb4-49bf-b7b4-fb11c36acfa6	9d511d1a-84cb-425b-a9fe-f4c16d4f5110	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 15:57:41
3958	9d511b25-8a45-4fed-8a34-32a987f2f603	9d511b25-d451-4f4b-a491-3fa8056083cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-10-23 15:52:13
3959	9d511b25-cf48-4303-b373-206f4697bb0c	9d511b25-d451-4f4b-a491-3fa8056083cf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"151.27","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:52:13
4099	9d511d1a-8281-4615-8784-e6ce601bd71b	9d511d1a-84cb-425b-a9fe-f4c16d4f5110	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 15:57:41
3960	9d511b25-cfae-4eed-b6b6-004e548cd34a	9d511b25-d451-4f4b-a491-3fa8056083cf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 15:52:13
3961	9d511b25-d301-4219-8aef-9ef856be8393	9d511b25-d451-4f4b-a491-3fa8056083cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-10-23 15:52:13
4100	9d511d1a-831a-4b00-994c-282eb935134d	9d511d1a-84cb-425b-a9fe-f4c16d4f5110	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":902,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:57:41
5992	9d52582d-c651-4959-991f-6e7b8d1a578d	9d52582d-fcd8-464a-949d-3a6c56b4ee31	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 06:38:42
5993	9d52582d-ec1b-48a7-9f36-fb456fc40079	9d52582d-fcd8-464a-949d-3a6c56b4ee31	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"updated_at\\", \\"created_at\\") values ('Luis andre', 'Herrera', 'MArtinez', 'CC', '100465545', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '500000', 25, 6, 'S', null, 'Thu Oct 24 2024', 'Pendiente', 12, 14, 14, '2024-10-24 06:38:42', '2024-10-24 06:38:42') returning \\"id\\"","time":"6.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":77,"hash":"18efcd076c06e51570dcc83643e19328","hostname":"EderCortes"}	2024-10-24 06:38:42
5994	9d52582d-ecd3-4279-92c0-a98c2bee1a51	9d52582d-fcd8-464a-949d-3a6c56b4ee31	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:2","hostname":"EderCortes"}	2024-10-24 06:38:42
5995	9d52582d-ee66-44e8-876a-747f3f80c289	9d52582d-fcd8-464a-949d-3a6c56b4ee31	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (2, 1, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:42', '2024-10-24 06:38:42')","time":"2.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:42
5996	9d52582d-ee99-487c-a6a5-e1e7b734d72d	9d52582d-fcd8-464a-949d-3a6c56b4ee31	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:42
5997	9d52582d-ef2d-44ce-9313-80b2621a1871	9d52582d-fcd8-464a-949d-3a6c56b4ee31	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (2, 2, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:42', '2024-10-24 06:38:42')","time":"0.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:42
5998	9d52582d-ef70-4b62-9eb5-be802ac5a93b	9d52582d-fcd8-464a-949d-3a6c56b4ee31	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:42
5999	9d52582d-f01e-4258-92e4-d8c4f104190d	9d52582d-fcd8-464a-949d-3a6c56b4ee31	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (2, 3, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:42', '2024-10-24 06:38:42')","time":"0.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:42
2785	9d50fc3c-7bb1-4570-896e-4be1e94f7ddc	9d50fc3c-a2d7-45d8-a6da-f36a2199de93	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:25:47
2786	9d50fc3c-9b27-4283-a0c2-ccc92f66ccb5	9d50fc3c-a2d7-45d8-a6da-f36a2199de93	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"50.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:25:47
2787	9d50fc3c-9b78-4f51-a787-8b6936ca9c28	9d50fc3c-a2d7-45d8-a6da-f36a2199de93	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:25:47
2788	9d50fc3c-a17b-4ae3-8bb9-d84931f25768	9d50fc3c-a2d7-45d8-a6da-f36a2199de93	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:25:47
2789	9d50fc3c-a1cb-4338-bc57-597ee8e7b0d2	9d50fc3c-a2d7-45d8-a6da-f36a2199de93	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:25:47
3962	9d511b25-d375-4e86-a82e-77ec2440cc7c	9d511b25-d451-4f4b-a491-3fa8056083cf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":350,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:52:13
4101	9d511d1a-fac9-4860-b529-a98239f42cf0	9d511d1b-18ff-4a4e-b332-a8137195e71e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 15:57:42
4102	9d511d1b-1453-4ba9-b4a4-983b6c6d553e	9d511d1b-18ff-4a4e-b332-a8137195e71e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 15:57:42
4103	9d511d1b-149d-4fdc-b7ff-cb7665bc264c	9d511d1b-18ff-4a4e-b332-a8137195e71e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 15:57:42
4104	9d511d1b-17b9-4a05-8850-7bb58b59289a	9d511d1b-18ff-4a4e-b332-a8137195e71e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-23 15:57:42
4105	9d511d1b-17fa-4ae6-9b16-da084eedc748	9d511d1b-18ff-4a4e-b332-a8137195e71e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":353,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:57:42
5054	9d51366c-7fbc-47fa-883c-0de538c68194	9d51366c-80d7-4d17-9e19-6cd3c5da972e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":475,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:29
3963	9d511b26-767d-47a5-aa2c-f12831a9b427	9d511b26-b3cb-4ba8-9062-2473995b22a9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-10-23 15:52:14
2346	9d50e72d-161d-4d98-ba8a-1c482ac8778f	9d50e72d-35a2-4e01-8c6b-78f8b63c9e17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 13:26:54
2347	9d50e72d-3433-4135-a9c1-272d52ee8313	9d50e72d-35a2-4e01-8c6b-78f8b63c9e17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 13:26:54
2348	9d50e72d-34ce-4ca2-a5ad-617154b26a31	9d50e72d-35a2-4e01-8c6b-78f8b63c9e17	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":433,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:26:54
3964	9d511b26-a7ed-4c46-a663-d5f1fc1d14d2	9d511b26-b3cb-4ba8-9062-2473995b22a9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"79.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 15:52:14
2790	9d50fc3c-ee75-416a-b7c0-5ba859ff1f45	9d50fc3d-1333-469e-896e-12da57652237	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:25:47
3965	9d511b26-a869-4cf3-9acb-b0ab4bc81806	9d511b26-b3cb-4ba8-9062-2473995b22a9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 15:52:14
2791	9d50fc3d-0d5a-4442-be6c-909eda6d7f7e	9d50fc3d-1333-469e-896e-12da57652237	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"53.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:25:48
2792	9d50fc3d-0dc1-406f-8465-5dd750d8b098	9d50fc3d-1333-469e-896e-12da57652237	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:25:48
2793	9d50fc3d-11fb-4a8a-a5bd-77ac0611bec7	9d50fc3d-1333-469e-896e-12da57652237	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:25:48
2794	9d50fc3d-1257-4b93-9bec-836b7187df7f	9d50fc3d-1333-469e-896e-12da57652237	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:25:48
3966	9d511b26-b138-4960-b027-68080fc8a929	9d511b26-b3cb-4ba8-9062-2473995b22a9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-10-23 15:52:14
3967	9d511b26-b1fe-436f-9924-0a3c7ac0a9ae	9d511b26-b3cb-4ba8-9062-2473995b22a9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":548,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:52:14
4106	9d511d95-e4c8-4119-bf82-25544ba3468e	9d511d95-e9c1-43de-9c19-57be7a6f5d72	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":214,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:59:02
5059	9d51366e-9233-4053-90c7-7bae05a04aa4	9d51366e-baab-4a2b-90be-1dce9d1772a5	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 17:08:31
5060	9d51366e-b39c-4d6f-b829-64277a1c4fb4	9d51366e-baab-4a2b-90be-1dce9d1772a5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:08:31
5061	9d51366e-b40b-442a-b87d-73d122d10d3e	9d51366e-baab-4a2b-90be-1dce9d1772a5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:08:31
5062	9d51366e-b902-467e-8833-64b0505cab8f	9d51366e-baab-4a2b-90be-1dce9d1772a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 17:08:31
6000	9d52582d-f059-4280-8b04-5511622324ae	9d52582d-fcd8-464a-949d-3a6c56b4ee31	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:42
23337	9d689473-887e-4ae9-b070-0950ab1bcfae	9d689473-aae9-41d3-b239-6d4cfb988d2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 07:55:27
14867	9d5ec56d-1ae8-4521-8a3f-24015f46879d	9d5ec56d-1e01-49e1-aed6-446991a92432	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":145,"memory":20,"hostname":"EderCortes"}	2024-10-30 10:54:07
20611	9d66f84f-7b09-42f0-9745-1443c1ee05eb	9d66f84f-827c-40dc-8040-c760d6e35a87	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:43:01
2484	9d50f993-e1d3-4323-bff1-99d4a65b80f1	9d50f994-9475-4209-a29f-d9fa3a3a7963	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:18:21
2485	9d50f994-8f52-49d5-9d91-65acfe7ef6f2	9d50f994-9475-4209-a29f-d9fa3a3a7963	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:18:22
2486	9d50f994-911a-4076-8487-9cd52a00cfe8	9d50f994-9475-4209-a29f-d9fa3a3a7963	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":971,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:18:22
20612	9d66f84f-7b41-40a0-9e01-be76363ad62b	9d66f84f-827c-40dc-8040-c760d6e35a87	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:43:01
20613	9d66f84f-809a-45b3-843e-7a171c1a0625	9d66f84f-827c-40dc-8040-c760d6e35a87	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:43:01
20614	9d66f84f-810a-450b-a50c-488d874311d2	9d66f84f-827c-40dc-8040-c760d6e35a87	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"400000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:40:42.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":null,"itemloans_cuota_cancelada":"100000"},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":455,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:43:01
21097	9d6734b1-0e5f-424e-8b17-528fd67d8a72	9d6734b1-209d-427c-b9f3-6bf09785ea6e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 64\\n                        ","time":"50.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"45dfab6b4f68d5c2aab17cd8432b9cbd","hostname":"EderCortes"}	2024-11-03 15:31:52
21098	9d6734b1-19dc-4d5e-b967-4db874f74c60	9d6734b1-209d-427c-b9f3-6bf09785ea6e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '64' order by \\"item_loans\\".\\"id\\" asc","time":"2.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 15:31:52
21099	9d6734b1-1a13-42f1-944a-59d7feeec120	9d6734b1-209d-427c-b9f3-6bf09785ea6e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 15:31:52
21100	9d6734b1-1f01-4ea2-8ad7-0287189f0743	9d6734b1-209d-427c-b9f3-6bf09785ea6e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:31:52
21702	9d673db5-733f-4dfa-89ca-7f2db341ac3f	9d673db5-741b-4146-9785-0563ac81bab8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":337,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:57:04
23338	9d689473-a086-4153-a1c3-f84e0cce82bd	9d689473-aae9-41d3-b239-6d4cfb988d2b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 70 limit 1","time":"2.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":498,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 07:55:27
2487	9d50f995-2b30-4f87-96aa-678be2b271c0	9d50f995-654c-4ac7-8f3e-5e11a001425a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:18:22
2488	9d50f995-5b01-4725-9cbb-77b7cfc3c516	9d50f995-654c-4ac7-8f3e-5e11a001425a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"77.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:18:22
2489	9d50f995-5b65-428e-891c-27b8c2ad7870	9d50f995-654c-4ac7-8f3e-5e11a001425a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:18:22
2490	9d50f995-6349-4003-a20e-4efcc47f79c7	9d50f995-654c-4ac7-8f3e-5e11a001425a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:18:22
2491	9d50f995-63e4-4539-9028-a6c4b9b7f035	9d50f995-654c-4ac7-8f3e-5e11a001425a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":487,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:18:22
2795	9d50fc3d-a338-4d97-9d33-2f53904f8678	9d50fc3d-e8fd-4be1-860c-7c5314959e9b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:25:48
2796	9d50fc3d-e032-42e6-889f-a26c05623a6f	9d50fc3d-e8fd-4be1-860c-7c5314959e9b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"97.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:25:48
2797	9d50fc3d-e09f-4c23-9b3c-777e29eb84b9	9d50fc3d-e8fd-4be1-860c-7c5314959e9b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:25:48
2798	9d50fc3d-e6a5-420a-9171-5fea9d32d2a2	9d50fc3d-e8fd-4be1-860c-7c5314959e9b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:25:48
2799	9d50fc3d-e72e-4386-98f6-a4f79cdf2065	9d50fc3d-e8fd-4be1-860c-7c5314959e9b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":531,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:25:48
3968	9d511b27-4163-40a0-a084-8e35ec859266	9d511b27-74b4-4e1d-92c5-cfd12e8f08e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-10-23 15:52:14
3148	9d510311-c8b0-4f70-8dc0-4560077639fa	9d510312-17e9-4ea7-82a0-0f0c8ab55720	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 14:44:54
3149	9d510312-15b9-416d-8de2-8545fca89e07	9d510312-17e9-4ea7-82a0-0f0c8ab55720	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 14:44:54
3150	9d510312-16ac-49df-9739-4c5b5de3ab01	9d510312-17e9-4ea7-82a0-0f0c8ab55720	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":391,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:44:54
3969	9d511b27-6ab0-4c16-bd53-9cec06ae9e5a	9d511b27-74b4-4e1d-92c5-cfd12e8f08e8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"66.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 15:52:14
3970	9d511b27-6b41-4cd1-a4dd-0130f29f9805	9d511b27-74b4-4e1d-92c5-cfd12e8f08e8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 15:52:14
3971	9d511b27-723c-4321-8d55-f87d6b550a02	9d511b27-74b4-4e1d-92c5-cfd12e8f08e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-10-23 15:52:14
3972	9d511b27-7304-47fc-806d-5dd4448d8c3e	9d511b27-74b4-4e1d-92c5-cfd12e8f08e8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":465,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:52:14
2492	9d50f995-de95-4a52-b037-78024dea272e	9d50f996-0e19-47c2-8fbb-9346d9e7a28a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:18:22
2493	9d50f996-0633-4845-a307-ce4abfd75e09	9d50f996-0e19-47c2-8fbb-9346d9e7a28a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"64.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:18:23
2494	9d50f996-06cd-4d51-b0a6-3a0a21a673ec	9d50f996-0e19-47c2-8fbb-9346d9e7a28a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:18:23
2495	9d50f996-0c4d-4a74-8569-b39172b29e8a	9d50f996-0e19-47c2-8fbb-9346d9e7a28a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 14:18:23
2496	9d50f996-0cc5-4622-b6a7-5225989b1e72	9d50f996-0e19-47c2-8fbb-9346d9e7a28a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":407,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:18:23
2800	9d50fc3e-cf13-4452-b2fc-705f442dd1f6	9d50fc3f-1e5e-4057-8ef3-c7136b9a41b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:25:49
2801	9d50fc3f-1939-4788-98c7-19cc9a4f7c71	9d50fc3f-1e5e-4057-8ef3-c7136b9a41b2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"156.14","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:25:49
2508	9d50fa02-d61f-4345-ae3c-9d5af833e5b4	9d50fa03-2838-48f3-b3d2-c54ae28601cc	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 14:19:34
2509	9d50fa03-264f-40cc-bed2-ab07366fe9ee	9d50fa03-2838-48f3-b3d2-c54ae28601cc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:19:34
2510	9d50fa03-271d-4a4b-a383-8cfa47674d74	9d50fa03-2838-48f3-b3d2-c54ae28601cc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":436,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:19:34
2802	9d50fc3f-1985-4f3d-964a-2217c250d313	9d50fc3f-1e5e-4057-8ef3-c7136b9a41b2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:25:49
2803	9d50fc3f-1d39-4033-9c61-3ab31c8f5c61	9d50fc3f-1e5e-4057-8ef3-c7136b9a41b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 14:25:49
2804	9d50fc3f-1d7d-438d-aaa0-33d9f51fcea0	9d50fc3f-1e5e-4057-8ef3-c7136b9a41b2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":480,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:25:49
3151	9d510312-6964-4e03-8086-7eb53a6046ef	9d510312-8b55-4e71-87d9-67d565d732f7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 14:44:54
3152	9d510312-8579-4d28-8025-b1b335b32943	9d510312-8b55-4e71-87d9-67d565d732f7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:44:54
3153	9d510312-85c4-4dd9-9e88-546675789f1d	9d510312-8b55-4e71-87d9-67d565d732f7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:44:54
3154	9d510312-8a14-4fa1-9bd0-b5d73068ef19	9d510312-8b55-4e71-87d9-67d565d732f7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 14:44:54
3155	9d510312-8a54-404b-b267-e8a705f2f2cd	9d510312-8b55-4e71-87d9-67d565d732f7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":271,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:44:54
2497	9d50f996-a3a8-4605-9d2f-58e425ca67e5	9d50f996-e615-49b8-ae9f-f10ad55b7c24	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 14:18:23
2498	9d50f996-d74b-4197-97a3-2bbbf12a5c38	9d50f996-e615-49b8-ae9f-f10ad55b7c24	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"85.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:18:23
2499	9d50f996-d7f2-4596-b9f4-886749c3aaa0	9d50f996-e615-49b8-ae9f-f10ad55b7c24	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:18:23
2500	9d50f996-e2b9-491d-bb52-eedbf1c01309	9d50f996-e615-49b8-ae9f-f10ad55b7c24	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 14:18:23
2501	9d50f996-e35a-486b-a63b-abbe1c40f2fa	9d50f996-e615-49b8-ae9f-f10ad55b7c24	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":526,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:18:23
2805	9d50fc4d-8f43-487e-b638-3ad8d70fbed1	9d50fc4d-d7f0-4742-a545-a15d9ef565b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 14:25:58
2806	9d50fc4d-d22b-4ada-a5af-1be29cb266ab	9d50fc4d-d7f0-4742-a545-a15d9ef565b3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"145.13","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:25:59
2807	9d50fc4d-d279-4adc-b8b3-430bdec454ac	9d50fc4d-d7f0-4742-a545-a15d9ef565b3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:25:59
2808	9d50fc4d-d67d-4555-9f5a-a868b7feced0	9d50fc4d-d7f0-4742-a545-a15d9ef565b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 14:25:59
2809	9d50fc4d-d6f4-4ee3-ae61-50c22cebb863	9d50fc4d-d7f0-4742-a545-a15d9ef565b3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:25:59
3156	9d510312-d806-47e6-9752-e29409913fb7	9d510312-fd14-41e0-be71-e0e521fac63a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 14:44:54
3157	9d510312-f70c-4ac5-a6e8-b45fb7eadec5	9d510312-fd14-41e0-be71-e0e521fac63a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"54.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:44:54
3158	9d510312-f770-4649-a260-3e380f5fe907	9d510312-fd14-41e0-be71-e0e521fac63a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:44:54
3159	9d510312-fbcf-49b2-b46c-5d9ae0e17a1b	9d510312-fd14-41e0-be71-e0e521fac63a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 14:44:54
3160	9d510312-fc26-41a5-89b0-9686873f6114	9d510312-fd14-41e0-be71-e0e521fac63a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":277,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:44:54
4107	9d511d96-550b-418d-929a-acbdaedf39b9	9d511d96-9938-4627-b697-60cfdcce8ab6	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 15:59:03
2502	9d50f997-98b1-4017-b1b4-477a329eb3d9	9d50f997-cd2d-4b0c-9824-164ec3ab6b42	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 14:18:24
2503	9d50f997-c5dc-4c52-b4d8-7352048219cc	9d50f997-cd2d-4b0c-9824-164ec3ab6b42	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"81.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:18:24
2504	9d50f997-c65c-4381-9383-d89b45b81001	9d50f997-cd2d-4b0c-9824-164ec3ab6b42	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:18:24
2505	9d50f997-cb90-4b79-8e0d-a4113d47892e	9d50f997-cd2d-4b0c-9824-164ec3ab6b42	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 14:18:24
2506	9d50f997-cbfa-4e87-8aee-5f84022c65a6	9d50f997-cd2d-4b0c-9824-164ec3ab6b42	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":515,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:18:24
2810	9d50fc4e-2781-4424-985f-17de68982fec	9d50fc4e-4758-4f06-9a17-81a48c0ff869	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 14:25:59
2811	9d50fc4e-41b5-4436-82b5-9b7c0735ed68	9d50fc4e-4758-4f06-9a17-81a48c0ff869	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:25:59
2812	9d50fc4e-420f-49c6-be5b-d0efa58e0dab	9d50fc4e-4758-4f06-9a17-81a48c0ff869	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:25:59
2813	9d50fc4e-4620-45e5-baf7-cf8d6081f49d	9d50fc4e-4758-4f06-9a17-81a48c0ff869	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 14:25:59
2814	9d50fc4e-4664-4c5e-b088-e546a1153c88	9d50fc4e-4758-4f06-9a17-81a48c0ff869	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:25:59
4108	9d511d96-92ab-4c1f-b381-d5af673d6d21	9d511d96-9938-4627-b697-60cfdcce8ab6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"72.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":38,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 15:59:03
4109	9d511d96-9797-4d38-a85e-2507ae855f9c	9d511d96-9938-4627-b697-60cfdcce8ab6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 15:59:03
4110	9d511d96-97fc-48cf-86ec-ccdbcead9969	9d511d96-9938-4627-b697-60cfdcce8ab6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":377,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:59:03
6001	9d52582d-f0fd-4c2e-a7b8-5b9911977988	9d52582d-fcd8-464a-949d-3a6c56b4ee31	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (2, 4, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:42', '2024-10-24 06:38:42')","time":"0.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:42
6002	9d52582d-f13a-4b66-9bb0-7e7e565a2fcf	9d52582d-fcd8-464a-949d-3a6c56b4ee31	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:42
6003	9d52582d-f1eb-4228-ab32-da75a04055a2	9d52582d-fcd8-464a-949d-3a6c56b4ee31	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (2, 5, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:42', '2024-10-24 06:38:42')","time":"0.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:42
6004	9d52582d-f225-43ed-b5fe-32c6c108c230	9d52582d-fcd8-464a-949d-3a6c56b4ee31	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:42
6005	9d52582d-f2d7-4c8b-ac07-267b970def3e	9d52582d-fcd8-464a-949d-3a6c56b4ee31	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (2, 6, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:42', '2024-10-24 06:38:42')","time":"0.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:42
6006	9d52582d-f315-48e2-8338-74d833cf9c92	9d52582d-fcd8-464a-949d-3a6c56b4ee31	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:42
6007	9d52582d-faed-48f6-b6f3-d2e98e6ee31f	9d52582d-fcd8-464a-949d-3a6c56b4ee31	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 06:38:42
6008	9d52582d-fb5c-496b-a25c-c6b292065dd1	9d52582d-fcd8-464a-949d-3a6c56b4ee31	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"615","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":"100465545","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"500000","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_cobrador":14,"user_customer":14},"detail":{"status":false,"observacion":"N\\/A","fecha_pago":"Thu Oct 24 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":2},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:38:42
14868	9d5ec56d-6bdc-486c-b950-8e2c8e1d86d1	9d5ec56d-6f0d-45c2-a180-03219c7c2212	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":131,"memory":20,"hostname":"EderCortes"}	2024-10-30 10:54:07
20814	9d66fc2f-7c76-46fe-9311-96c640251955	9d66fc2f-7d5b-4230-b744-8fcfa7ec71e7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":222,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:53:51
18796	9d669bee-e187-48a7-92bd-96e9ab1c1f8e	9d669bee-e2bc-47d3-a248-1809bced13c9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":384,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:24:43
21703	9d673db5-b570-4161-a08f-c29cfe062f0c	9d673db5-da74-4169-a38c-7e3c2a6c86af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 15:57:05
21704	9d673db5-d48c-45e1-afa4-150c798ac400	9d673db5-da74-4169-a38c-7e3c2a6c86af	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"50.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 15:57:05
6009	9d52582e-fc85-4615-a392-ba2766eb3b5d	9d52582f-018d-419a-95bc-346f8f1b75c2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":250,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:38:43
14869	9d5ec56d-eb96-4932-a031-3f03230b25a8	9d5ec56e-315a-48bb-961d-48d071fbf89e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 10:54:08
14870	9d5ec56e-2cf8-4470-a53d-9bab6a94ce83	9d5ec56e-315a-48bb-961d-48d071fbf89e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ma%' or \\"users\\".\\"user_document\\"::text like '%Ma%') order by \\"users\\".\\"user_document\\" asc","time":"150.96","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-30 10:54:08
14871	9d5ec56e-302a-4333-ae8e-8a40795d6593	9d5ec56e-315a-48bb-961d-48d071fbf89e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-30 10:54:08
14872	9d5ec56e-306e-48c5-89c1-0133137afb48	9d5ec56e-315a-48bb-961d-48d071fbf89e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ma"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":341,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:54:08
20815	9d66fc2f-b687-4253-a1e9-03fec0dc1e7e	9d66fc2f-b966-47a5-a387-fb623fb8f99e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":133,"memory":20,"hostname":"EderCortes"}	2024-11-03 12:53:52
21101	9d6734b1-1f6d-4d66-8d7b-435037da5b2a	9d6734b1-209d-427c-b9f3-6bf09785ea6e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/64","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":64,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":2000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"17-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-17 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":197,"loans_codigo":64,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:00:24.000000Z","updated_at":"2024-11-03T18:00:24.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":198,"loans_codigo":64,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:00:24.000000Z","updated_at":"2024-11-03T18:00:24.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":199,"loans_codigo":64,"itemloans_cuota":"3","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:00:24.000000Z","updated_at":"2024-11-03T18:00:24.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":200,"loans_codigo":64,"itemloans_cuota":"4","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:00:24.000000Z","updated_at":"2024-11-03T18:00:24.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":201,"loans_codigo":64,"itemloans_cuota":"5","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:00:24.000000Z","updated_at":"2024-11-03T18:00:24.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":202,"loans_codigo":64,"itemloans_cuota":"6","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:00:24.000000Z","updated_at":"2024-11-03T18:00:24.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":203,"loans_codigo":64,"itemloans_cuota":"7","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:00:24.000000Z","updated_at":"2024-11-03T18:00:24.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":204,"loans_codigo":64,"itemloans_cuota":"8","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-25 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:00:24.000000Z","updated_at":"2024-11-03T18:00:24.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":205,"loans_codigo":64,"itemloans_cuota":"9","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:00:24.000000Z","updated_at":"2024-11-03T18:00:24.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":206,"loans_codigo":64,"itemloans_cuota":"10","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:00:24.000000Z","updated_at":"2024-11-03T18:00:24.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":297,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:31:52
23339	9d689473-a0d7-4ad7-8b03-8e176b662bdf	9d689473-aae9-41d3-b239-6d4cfb988d2b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":2,"hostname":"EderCortes"}	2024-11-04 07:55:27
21705	9d673db5-d4f2-43fd-8a28-cbc84941e607	9d673db5-da74-4169-a38c-7e3c2a6c86af	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-03 15:57:05
21706	9d673db5-d910-4c41-9349-32eef7bcb2f0	9d673db5-da74-4169-a38c-7e3c2a6c86af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 15:57:05
21707	9d673db5-d976-4b49-82b3-df35dcf2d7a2	9d673db5-da74-4169-a38c-7e3c2a6c86af	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":248,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:57:05
6010	9d52582f-b663-4683-ba7e-620c1084e093	9d52582f-db31-4a79-a8ed-2cfc4b33d44b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 06:38:44
6011	9d52582f-d161-4205-a5f9-d81ba8753d24	9d52582f-db31-4a79-a8ed-2cfc4b33d44b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"updated_at\\", \\"created_at\\") values ('Luis andre', 'Herrera', 'MArtinez', 'CC', '100465545', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '500000', 25, 6, 'S', null, 'Thu Oct 24 2024', 'Pendiente', 12, 14, 14, '2024-10-24 06:38:44', '2024-10-24 06:38:44') returning \\"id\\"","time":"4.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":77,"hash":"18efcd076c06e51570dcc83643e19328","hostname":"EderCortes"}	2024-10-24 06:38:44
6012	9d52582f-d1be-409b-b111-929b7abe2217	9d52582f-db31-4a79-a8ed-2cfc4b33d44b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:3","hostname":"EderCortes"}	2024-10-24 06:38:44
6013	9d52582f-d30d-468b-96f7-b1c96bc2ad12	9d52582f-db31-4a79-a8ed-2cfc4b33d44b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (3, 1, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:44', '2024-10-24 06:38:44')","time":"2.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:44
6014	9d52582f-d33c-4543-939a-c5ae238b33d4	9d52582f-db31-4a79-a8ed-2cfc4b33d44b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:44
6015	9d52582f-d3a6-454e-8700-ea8cff6f0f2c	9d52582f-db31-4a79-a8ed-2cfc4b33d44b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (3, 2, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:44', '2024-10-24 06:38:44')","time":"0.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:44
6016	9d52582f-d3c8-4ba0-a48c-81ef63ea78f3	9d52582f-db31-4a79-a8ed-2cfc4b33d44b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:44
6017	9d52582f-d443-4fcf-a552-e9d7fa1edee0	9d52582f-db31-4a79-a8ed-2cfc4b33d44b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (3, 3, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:44', '2024-10-24 06:38:44')","time":"0.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:44
6018	9d52582f-d472-4acb-9a07-b15ba91a65e3	9d52582f-db31-4a79-a8ed-2cfc4b33d44b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:44
6019	9d52582f-d4ea-48d1-bcf9-55648f10943e	9d52582f-db31-4a79-a8ed-2cfc4b33d44b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (3, 4, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:44', '2024-10-24 06:38:44')","time":"0.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:44
6020	9d52582f-d50f-4610-8856-7afbeef56faf	9d52582f-db31-4a79-a8ed-2cfc4b33d44b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:44
6021	9d52582f-d574-4c1a-b432-7e1b4d06c5a8	9d52582f-db31-4a79-a8ed-2cfc4b33d44b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (3, 5, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:44', '2024-10-24 06:38:44')","time":"0.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:44
6022	9d52582f-d598-4d76-82ed-45a48f3d1c7c	9d52582f-db31-4a79-a8ed-2cfc4b33d44b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:44
6023	9d52582f-d5f8-413a-93be-cb21130ab633	9d52582f-db31-4a79-a8ed-2cfc4b33d44b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (3, 6, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:44', '2024-10-24 06:38:44')","time":"0.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:44
6024	9d52582f-d61c-440f-ae85-bfe1117630b6	9d52582f-db31-4a79-a8ed-2cfc4b33d44b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:44
6025	9d52582f-d9cf-4780-bc2b-5c7cf1dae9eb	9d52582f-db31-4a79-a8ed-2cfc4b33d44b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 06:38:44
14873	9d5ec56e-7032-4245-af55-b5f0689b6bab	9d5ec56e-735d-49d1-b4b1-c8bd16837927	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":140,"memory":20,"hostname":"EderCortes"}	2024-10-30 10:54:08
21708	9d673db8-50b6-4655-889b-466d257b1734	9d673db8-9e70-4801-a100-91613d4ae63d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 15:57:06
6026	9d52582f-da17-414c-9be0-69ffd4f209f1	9d52582f-db31-4a79-a8ed-2cfc4b33d44b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"615","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":"100465545","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"500000","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_cobrador":14,"user_customer":14},"detail":{"status":false,"observacion":"N\\/A","fecha_pago":"Thu Oct 24 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":3},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:38:44
20816	9d66fc30-025b-4f00-b662-5c1bcdd786fe	9d66fc30-051b-4a8e-8c0c-de3b034e53e8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":129,"memory":20,"hostname":"EderCortes"}	2024-11-03 12:53:52
20761	9d66fbe6-6521-4c20-8ee9-de2856e52ce5	9d66fbe6-66e5-4af1-bb56-961d5661ff74	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":514,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:53:04
6748	9d52d53e-f14b-4566-a970-9bfe00fd5dec	9d52d53f-41eb-47d4-b2a1-a5087cc35602	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 12:28:25
6749	9d52d53f-3f8a-4279-bffb-4e5ac0e65189	9d52d53f-41eb-47d4-b2a1-a5087cc35602	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:28:25
6750	9d52d53f-40a1-4ae9-98b6-10b6d75c9ffb	9d52d53f-41eb-47d4-b2a1-a5087cc35602	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":422,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:28:25
14874	9d5ec56e-c9de-4785-84be-9fd8f70354c5	9d5ec56e-e7e9-43b8-b0a3-78325f93d919	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-30 10:54:08
14875	9d5ec56e-e350-4290-82fb-c6d0f2763715	9d5ec56e-e7e9-43b8-b0a3-78325f93d919	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mar%' or \\"users\\".\\"user_document\\"::text like '%Mar%') order by \\"users\\".\\"user_document\\" asc","time":"48.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-30 10:54:08
14876	9d5ec56e-e68f-430a-b9c0-d64e9922a286	9d5ec56e-e7e9-43b8-b0a3-78325f93d919	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-30 10:54:08
14877	9d5ec56e-e6d7-4756-bd2b-d85af73bb771	9d5ec56e-e7e9-43b8-b0a3-78325f93d919	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mar"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:54:08
21102	9d6734ba-1aee-4ec0-905d-99e902ded458	9d6734ba-1e9b-4a32-b1e0-f2c278743c53	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":214,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:31:58
14878	9d5ec56f-2a1f-41ad-a8e3-e8b9849743f4	9d5ec56f-6e80-4463-ad15-c82842fc8200	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-30 10:54:08
6571	9d52d31a-116f-45fc-8655-b2e234af7785	9d52d31a-3a8a-4ac1-bb18-a7b5e3427b42	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 12:22:25
6027	9d525830-c2ec-4579-9855-e73150fa2ee6	9d525830-c836-4e70-8934-358585b1b6bf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":171,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:38:44
4227	9d512999-d997-4714-b3ad-eee6bca3302c	9d51299a-2500-4f85-81ce-296026692877	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 16:32:38
4228	9d51299a-2237-4216-ba2b-b28ef67aa4cd	9d51299a-2500-4f85-81ce-296026692877	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 16:32:38
4229	9d51299a-2364-4fc1-a260-3da924c28590	9d51299a-2500-4f85-81ce-296026692877	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":625,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:32:38
6572	9d52d31a-3884-4ccd-b965-107b7e7f4237	9d52d31a-3a8a-4ac1-bb18-a7b5e3427b42	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:22:25
6573	9d52d31a-395b-48fc-b465-6fd1c90e3b7e	9d52d31a-3a8a-4ac1-bb18-a7b5e3427b42	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:22:25
20817	9d66fc30-7d3f-4fd5-af38-07c6659ec81e	9d66fc30-9653-4544-b1d8-90d56099d9f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 12:53:52
20818	9d66fc30-925a-49b9-a86c-469b42f23053	9d66fc30-9653-4544-b1d8-90d56099d9f5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"37.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 12:53:52
6751	9d52d53f-a693-496d-9b0e-b3c00d91fec5	9d52d53f-ca85-4325-9948-8894a1f19109	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:28:25
6752	9d52d53f-c412-475a-868a-936207b97084	9d52d53f-ca85-4325-9948-8894a1f19109	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:28:26
6753	9d52d53f-c473-4176-87ae-fe3c81306b33	9d52d53f-ca85-4325-9948-8894a1f19109	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:28:26
6754	9d52d53f-c95b-401c-945e-847d717117a7	9d52d53f-ca85-4325-9948-8894a1f19109	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:28:26
6755	9d52d53f-c9a5-499c-856c-ea6265601061	9d52d53f-ca85-4325-9948-8894a1f19109	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":322,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:28:26
14879	9d5ec56f-6970-47af-abeb-c376dc312aee	9d5ec56f-6e80-4463-ad15-c82842fc8200	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"145.86","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-30 10:54:08
14880	9d5ec56f-6d0d-455a-bb14-04bc40dd8672	9d5ec56f-6e80-4463-ad15-c82842fc8200	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-30 10:54:09
14881	9d5ec56f-6d5d-4c1a-91cb-9dc00c8523c7	9d5ec56f-6e80-4463-ad15-c82842fc8200	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:54:09
20819	9d66fc30-952a-4889-850c-ba07b11502da	9d66fc30-9653-4544-b1d8-90d56099d9f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 12:53:52
21103	9d6734ba-d305-48fe-903a-7a8acf84f6f2	9d6734bb-3c2f-4d98-a76d-490d85e0d90f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:31:58
21104	9d6734bb-20dc-440e-8473-f873e7472a54	9d6734bb-3c2f-4d98-a76d-490d85e0d90f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 197 limit 1","time":"3.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-03 15:31:58
21105	9d6734bb-212a-4b6c-ae42-885a5b667e05	9d6734bb-3c2f-4d98-a76d-490d85e0d90f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-03 15:31:58
4230	9d51299a-dc5c-42aa-9bde-1e78035f4dad	9d51299b-3fa8-43bf-9a96-d03828aaa69d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 16:32:39
4231	9d51299b-359d-4a82-aaa4-c32cbe7061d8	9d51299b-3fa8-43bf-9a96-d03828aaa69d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"184.56","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:32:39
4232	9d51299b-362b-4566-9b5f-f6c97e21570b	9d51299b-3fa8-43bf-9a96-d03828aaa69d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 16:32:39
4233	9d51299b-3d84-4e44-aea1-8211305a4e76	9d51299b-3fa8-43bf-9a96-d03828aaa69d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 16:32:39
4234	9d51299b-3e07-43ef-8d2f-f8363bc2e05c	9d51299b-3fa8-43bf-9a96-d03828aaa69d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":684,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:32:39
6028	9d525831-849e-452e-9ef5-b76ae3944461	9d525831-adb8-4cd7-b315-68f99d08a8de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 06:38:45
4374	9d512da7-f5e0-4c62-8561-4652fc577f53	9d512da8-319f-47eb-85a8-27dfec0153c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 16:43:58
4375	9d512da8-2e71-4252-8528-a1b13ec87f91	9d512da8-319f-47eb-85a8-27dfec0153c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 16:43:59
4376	9d512da8-2fe7-4dbb-8224-b3e51083ff2c	9d512da8-319f-47eb-85a8-27dfec0153c4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":681,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:43:59
6029	9d525831-a361-4999-8d68-33cbbb3522f8	9d525831-adb8-4cd7-b315-68f99d08a8de	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"updated_at\\", \\"created_at\\") values ('Luis andre', 'Herrera', 'MArtinez', 'CC', '100465545', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '500000', 25, 6, 'S', null, 'Thu Oct 24 2024', 'Pendiente', 12, 14, 14, '2024-10-24 06:38:45', '2024-10-24 06:38:45') returning \\"id\\"","time":"5.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":77,"hash":"18efcd076c06e51570dcc83643e19328","hostname":"EderCortes"}	2024-10-24 06:38:45
5063	9d51366e-b95a-4b84-ada7-1dda61c55ed7	9d51366e-baab-4a2b-90be-1dce9d1772a5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":389,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:31
6030	9d525831-a3d8-4cb2-a8e5-5bbc15a73a26	9d525831-adb8-4cd7-b315-68f99d08a8de	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:4","hostname":"EderCortes"}	2024-10-24 06:38:45
6031	9d525831-a547-4d24-b4e1-b23dab384bdf	9d525831-adb8-4cd7-b315-68f99d08a8de	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (4, 1, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:45', '2024-10-24 06:38:45')","time":"2.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:45
6032	9d525831-a577-429a-a2b0-7810ba304948	9d525831-adb8-4cd7-b315-68f99d08a8de	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:45
6033	9d525831-a60d-44d7-acb4-0a008d48defe	9d525831-adb8-4cd7-b315-68f99d08a8de	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (4, 2, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:45', '2024-10-24 06:38:45')","time":"0.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:45
6034	9d525831-a63f-4fda-a265-9b2119d39daf	9d525831-adb8-4cd7-b315-68f99d08a8de	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:45
6035	9d525831-a6c7-4dac-91a3-914c60146390	9d525831-adb8-4cd7-b315-68f99d08a8de	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (4, 3, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:45', '2024-10-24 06:38:45')","time":"0.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:45
6036	9d525831-a6fb-4ad1-a906-b2a37e455474	9d525831-adb8-4cd7-b315-68f99d08a8de	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:45
6574	9d52d31a-a8f9-4762-ba10-2fdbf6fcaaac	9d52d31a-cf3b-4c22-ac12-9b6084487ee7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:22:26
4235	9d51299b-c9f8-4c1e-80c4-b478e4655b1b	9d51299b-f49a-4fec-8e11-2258f9a4df17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 16:32:39
4236	9d51299b-eed1-4066-ab10-88db3d42a589	9d51299b-f49a-4fec-8e11-2258f9a4df17	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"63.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:32:39
4237	9d51299b-ef30-421f-88cc-34422c2c7652	9d51299b-f49a-4fec-8e11-2258f9a4df17	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 16:32:39
4238	9d51299b-f369-41f5-b341-d7366396d5c8	9d51299b-f49a-4fec-8e11-2258f9a4df17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 16:32:39
4239	9d51299b-f3b3-4339-87fd-b04a5b5dadd2	9d51299b-f49a-4fec-8e11-2258f9a4df17	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":439,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:32:39
4377	9d512da8-cc1a-4759-bdbf-fa64781bade3	9d512da9-2b9c-44a3-b9f8-cc680e6b78a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 16:43:59
4378	9d512da9-2181-4202-b8e9-0ded71ee4e0e	9d512da9-2b9c-44a3-b9f8-cc680e6b78a1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"179.15","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:43:59
4379	9d512da9-21fe-4504-8d03-73f643759f37	9d512da9-2b9c-44a3-b9f8-cc680e6b78a1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 16:43:59
4380	9d512da9-29b7-406d-895a-025122767fdb	9d512da9-2b9c-44a3-b9f8-cc680e6b78a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 16:43:59
4381	9d512da9-2a4b-46e4-8fff-cea9c282db01	9d512da9-2b9c-44a3-b9f8-cc680e6b78a1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":599,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:43:59
6575	9d52d31a-c7b2-48c2-a930-bb340985e0d5	9d52d31a-cf3b-4c22-ac12-9b6084487ee7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"50.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:22:26
5064	9d51366f-4925-478e-8ed4-ef85c998e96d	9d51366f-7de8-4654-aa10-f25346736152	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 17:08:31
5065	9d51366f-7505-4010-b46d-b4757620421c	9d51366f-7de8-4654-aa10-f25346736152	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"76.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:08:31
5066	9d51366f-7594-4224-bd90-e19524635668	9d51366f-7de8-4654-aa10-f25346736152	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:08:31
5067	9d51366f-7c08-4d8e-979d-37ab6384fa4f	9d51366f-7de8-4654-aa10-f25346736152	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 17:08:31
5068	9d51366f-7c85-4f19-b809-3b6613cd7d78	9d51366f-7de8-4654-aa10-f25346736152	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":481,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:31
6576	9d52d31a-c81c-45ec-87af-e8f005ebbcf1	9d52d31a-cf3b-4c22-ac12-9b6084487ee7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:22:26
4240	9d51299c-a419-4bc9-bacd-29d96843ac28	9d51299d-0569-47dc-aa95-05c55903d256	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 16:32:40
4241	9d51299c-f80c-4180-a400-fcecc30d9f9d	9d51299d-0569-47dc-aa95-05c55903d256	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"129.92","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 16:32:40
4242	9d51299c-f8c2-4f59-b35a-bf1683e5e6f1	9d51299d-0569-47dc-aa95-05c55903d256	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 16:32:40
4243	9d51299d-0266-4a2c-865f-99478c3348ee	9d51299d-0569-47dc-aa95-05c55903d256	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 16:32:40
4244	9d51299d-0332-4d01-8cbf-dc1470a97898	9d51299d-0569-47dc-aa95-05c55903d256	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":674,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:32:40
4382	9d512da9-9d1e-46e8-90cc-13ce748086ac	9d512da9-caac-444e-ac7d-e1e419a08ed2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 16:44:00
4383	9d512da9-c4ff-47ec-aa86-164a557090a9	9d512da9-caac-444e-ac7d-e1e419a08ed2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"53.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:44:00
4384	9d512da9-c594-4c65-955d-4cc88de3984f	9d512da9-caac-444e-ac7d-e1e419a08ed2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 16:44:00
4385	9d512da9-c945-4021-9e58-dc60a98aca5c	9d512da9-caac-444e-ac7d-e1e419a08ed2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 16:44:00
4386	9d512da9-c98e-4e55-b41f-7408cc650bbb	9d512da9-caac-444e-ac7d-e1e419a08ed2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":386,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:44:00
6577	9d52d31a-cdaa-4bba-9655-4cd27847a440	9d52d31a-cf3b-4c22-ac12-9b6084487ee7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:22:26
5073	9d513671-577a-4a98-a0b7-9296759f299c	9d513671-91eb-4dc8-996e-4e0e63848426	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 17:08:33
5074	9d513671-878f-4b86-a849-52b2e9428fa4	9d513671-91eb-4dc8-996e-4e0e63848426	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"79.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:08:33
5075	9d513671-883f-4fb2-97c6-9fce5b4b38c9	9d513671-91eb-4dc8-996e-4e0e63848426	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:08:33
5076	9d513671-8f82-4170-9169-02e2eb545397	9d513671-91eb-4dc8-996e-4e0e63848426	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 17:08:33
5077	9d513671-9058-4258-965e-01f214e009cf	9d513671-91eb-4dc8-996e-4e0e63848426	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":496,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:33
6756	9d52d540-1d2f-4a24-b8ee-f32f9bd62b21	9d52d540-6d95-4b3f-bd82-8ec37d86f2ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:28:26
14882	9d5ec56f-aeab-4bfc-99b0-c45c6ee01c44	9d5ec56f-c9a5-4c3d-b0c8-8d17800f2f91	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-30 10:54:09
4245	9d51299d-ccc4-4157-8bd6-755dbea28efb	9d51299d-ee34-40ef-85d2-f1c913069a2a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 16:32:41
4246	9d51299d-e899-43c8-a273-72705d7838a9	9d51299d-ee34-40ef-85d2-f1c913069a2a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"49.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 16:32:41
4247	9d51299d-e8f1-4600-8b32-26ad91d2ad1a	9d51299d-ee34-40ef-85d2-f1c913069a2a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 16:32:41
4248	9d51299d-ecdc-4901-96e5-ba3e28f5fe1b	9d51299d-ee34-40ef-85d2-f1c913069a2a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 16:32:41
3390	9d510522-bd85-42c0-a57b-bb931cf566fe	9d510522-ec7f-4dfb-a61f-9dea1cd60993	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 14:50:40
3391	9d510522-e9b2-4ce5-951c-bcd443700de9	9d510522-ec7f-4dfb-a61f-9dea1cd60993	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:50:40
3392	9d510522-eae2-462c-8a78-f8b551156ee9	9d510522-ec7f-4dfb-a61f-9dea1cd60993	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":408,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:50:40
4249	9d51299d-ed32-46a5-b4e0-dbed7191a72e	9d51299d-ee34-40ef-85d2-f1c913069a2a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":477,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:32:41
4387	9d512daa-60b9-455d-a0ce-804d48bea133	9d512daa-9daf-43a5-8abe-da29198ba0bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 16:44:00
4388	9d512daa-9202-46bf-a55a-e07d3f8cc3c3	9d512daa-9daf-43a5-8abe-da29198ba0bf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"82.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 16:44:00
4389	9d512daa-929e-4d45-8bab-3ef97806460e	9d512daa-9daf-43a5-8abe-da29198ba0bf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 16:44:00
4390	9d512daa-9b75-4ef2-9224-c3fbca840c35	9d512daa-9daf-43a5-8abe-da29198ba0bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 16:44:00
4391	9d512daa-9c20-4131-9e7d-c4fa056471ed	9d512daa-9daf-43a5-8abe-da29198ba0bf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":520,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:44:00
6037	9d525831-a774-4d4e-b915-aa4a7bdf686e	9d525831-adb8-4cd7-b315-68f99d08a8de	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (4, 4, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:45', '2024-10-24 06:38:45')","time":"0.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:45
5078	9d513672-2c11-462a-862a-fec70f0334d0	9d513672-ecab-4f90-8fa5-a353e057bcc3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 17:08:33
5079	9d513672-c76c-48ac-bb67-7558391a6c6f	9d513672-ecab-4f90-8fa5-a353e057bcc3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"354.95","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:08:34
5080	9d513672-c84b-4e7b-9e56-19fc28a3c517	9d513672-ecab-4f90-8fa5-a353e057bcc3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:08:34
5081	9d513672-d31e-435e-87ed-5a10a8888a82	9d513672-ecab-4f90-8fa5-a353e057bcc3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 17:08:34
6038	9d525831-a7a2-4676-a011-968b335b5628	9d525831-adb8-4cd7-b315-68f99d08a8de	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:45
3393	9d510523-4c2d-472c-ae3b-32eb48196121	9d510523-6e7b-4ba9-ad68-b7fa76f6ab85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:50:41
3394	9d510523-67f9-4cd7-8441-b2921e4abba7	9d510523-6e7b-4ba9-ad68-b7fa76f6ab85	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:50:41
3395	9d510523-6868-4757-9068-c7ecb23b22cb	9d510523-6e7b-4ba9-ad68-b7fa76f6ab85	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:50:41
3396	9d510523-6d3a-4bca-a72c-6e152b5052f6	9d510523-6e7b-4ba9-ad68-b7fa76f6ab85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:50:41
3262	9d510457-bf9f-43a0-9e18-d76d628783fc	9d510457-f80d-4736-9198-7278365bbc0c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 14:48:27
3263	9d510457-f45b-4c38-819c-e1f4012b2624	9d510457-f80d-4736-9198-7278365bbc0c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:48:27
3264	9d510457-f607-44ab-b540-9908b607b65e	9d510457-f80d-4736-9198-7278365bbc0c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":485,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:48:27
3397	9d510523-6d8e-4c2c-9eca-78b6784adea6	9d510523-6e7b-4ba9-ad68-b7fa76f6ab85	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":304,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:50:41
4250	9d5129a5-b342-4744-9f41-8053389cf426	9d5129a5-b65f-46db-9ed4-51d3b49dbf87	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":135,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:32:46
4392	9d512dab-4d9e-4250-83f7-1f2a7e82827e	9d512dab-a21d-4b83-9725-8f4540bb4d74	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 16:44:01
4393	9d512dab-9a53-4ab0-907c-b7310ca490ff	9d512dab-a21d-4b83-9725-8f4540bb4d74	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"165.61","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 16:44:01
4394	9d512dab-9ab6-4d27-86a8-a07c27f4da4e	9d512dab-a21d-4b83-9725-8f4540bb4d74	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 16:44:01
4395	9d512dab-a095-4f47-a84d-7dfd13d25ac6	9d512dab-a21d-4b83-9725-8f4540bb4d74	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 16:44:01
4396	9d512dab-a107-4f0a-845a-1acf22a4301a	9d512dab-a21d-4b83-9725-8f4540bb4d74	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":561,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:44:01
6039	9d525831-a826-4498-9cb1-0110c43533c6	9d525831-adb8-4cd7-b315-68f99d08a8de	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (4, 5, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:45', '2024-10-24 06:38:45')","time":"0.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:45
6040	9d525831-a855-499b-9bb3-252d2aa1369e	9d525831-adb8-4cd7-b315-68f99d08a8de	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:45
6041	9d525831-a904-42d9-97b0-316c13a8c01a	9d525831-adb8-4cd7-b315-68f99d08a8de	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (4, 6, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:45', '2024-10-24 06:38:45')","time":"0.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:45
6042	9d525831-a92f-4125-802b-ca4f2de1d81c	9d525831-adb8-4cd7-b315-68f99d08a8de	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:45
3265	9d510458-7e1c-49d6-89c6-42e113c81197	9d510458-ab56-4097-80d1-131b81c3eaf9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:48:28
3266	9d510458-a172-4625-b865-0ad68cedad51	9d510458-ab56-4097-80d1-131b81c3eaf9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"57.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:48:28
3267	9d510458-a1f6-4a5d-baa4-52a5d527d815	9d510458-ab56-4097-80d1-131b81c3eaf9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:48:28
3268	9d510458-a960-4caf-9c44-17f7506d911f	9d510458-ab56-4097-80d1-131b81c3eaf9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:48:28
3269	9d510458-a9c3-4231-a85b-5740e75d582a	9d510458-ab56-4097-80d1-131b81c3eaf9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":424,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:48:28
3398	9d510523-bd3b-4874-831d-dee818b5e36c	9d510523-de58-4ace-9583-063f0551dc0f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:50:41
3399	9d510523-d954-4d3e-b629-ba20659dd2f5	9d510523-de58-4ace-9583-063f0551dc0f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:50:41
3400	9d510523-d9a8-4a12-878c-04b74fc6bfdd	9d510523-de58-4ace-9583-063f0551dc0f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:50:41
3401	9d510523-dd55-4df6-8f79-c3ac4f6c542e	9d510523-de58-4ace-9583-063f0551dc0f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:50:41
3402	9d510523-dd99-49c2-8d9e-a9223d2b751c	9d510523-de58-4ace-9583-063f0551dc0f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":273,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:50:41
4251	9d5129a6-3315-4daa-a90f-38a6b6051eac	9d5129a6-7d7d-42ac-aac3-c3b4d5671d2e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 16:32:46
4252	9d5129a6-7967-4268-8dc5-fab0ec264df9	9d5129a6-7d7d-42ac-aac3-c3b4d5671d2e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"164.36","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":46,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 16:32:46
4253	9d5129a6-7c5b-444a-aa42-5d669bf0b5ed	9d5129a6-7d7d-42ac-aac3-c3b4d5671d2e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 16:32:46
4254	9d5129a6-7c99-4331-8e7a-c2f3ed293914	9d5129a6-7d7d-42ac-aac3-c3b4d5671d2e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:32:46
6043	9d525831-ac8d-4d2a-895f-2ff5accbc9db	9d525831-adb8-4cd7-b315-68f99d08a8de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 06:38:45
6757	9d52d540-6787-44af-a401-e255e7a7e414	9d52d540-6d95-4b3f-bd82-8ec37d86f2ef	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"155.83","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:28:26
6758	9d52d540-67db-47df-83f8-a7c0cb320edd	9d52d540-6d95-4b3f-bd82-8ec37d86f2ef	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:28:26
6759	9d52d540-6bf5-41e3-92c7-84d3f2ea9f90	9d52d540-6d95-4b3f-bd82-8ec37d86f2ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:28:26
6760	9d52d540-6c78-4b6b-9495-5786c9c79fa0	9d52d540-6d95-4b3f-bd82-8ec37d86f2ef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":393,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:28:26
14883	9d5ec56f-c578-4944-bb49-81487929dad8	9d5ec56f-c9a5-4c3d-b0c8-8d17800f2f91	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"42.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-30 10:54:09
6044	9d525831-acce-4c83-8e44-2e2ecc2c84d7	9d525831-adb8-4cd7-b315-68f99d08a8de	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"615","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":"100465545","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"500000","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_cobrador":14,"user_customer":14},"detail":{"status":false,"observacion":"N\\/A","fecha_pago":"Thu Oct 24 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":4},"duration":274,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:38:45
2365	9d50e764-9271-460d-a0ac-a52f92a04dc5	9d50e764-d781-4b31-949d-8868ebbab522	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 13:27:30
2366	9d50e764-d5e8-4ba9-a851-48dae497c784	9d50e764-d781-4b31-949d-8868ebbab522	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 13:27:30
2367	9d50e764-d681-42e7-a243-da139531d96b	9d50e764-d781-4b31-949d-8868ebbab522	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":334,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:27:30
14884	9d5ec56f-c86e-402e-9001-5a363db50493	9d5ec56f-c9a5-4c3d-b0c8-8d17800f2f91	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-30 10:54:09
3270	9d510459-0d0a-41bb-8fa3-0d644de0ccb2	9d510459-2cf3-4c6e-a874-485b8d132228	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:48:28
6578	9d52d31a-cdfe-4cf7-ba45-00f3e982e801	9d52d31a-cf3b-4c22-ac12-9b6084487ee7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:22:26
14885	9d5ec56f-c8b2-4107-95e0-8178051515fb	9d5ec56f-c9a5-4c3d-b0c8-8d17800f2f91	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":219,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:54:09
21106	9d6734bb-2be5-4c7d-8d4c-759d466e9fd6	9d6734bb-3c2f-4d98-a76d-490d85e0d90f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 64 limit 1","time":"2.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 15:31:58
21107	9d6734bb-2c14-492b-abdf-a0eab17e020a	9d6734bb-3c2f-4d98-a76d-490d85e0d90f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 15:31:58
3271	9d510459-27a4-4b57-bcfa-7c621c779bf6	9d510459-2cf3-4c6e-a874-485b8d132228	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:48:28
3272	9d510459-27fa-4371-923b-b17f872df695	9d510459-2cf3-4c6e-a874-485b8d132228	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:48:28
3273	9d510459-2bc3-43b1-8f83-37bee4925b4d	9d510459-2cf3-4c6e-a874-485b8d132228	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:48:28
3274	9d510459-2c1c-419c-a411-02289c43fc6a	9d510459-2cf3-4c6e-a874-485b8d132228	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":309,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:48:28
6045	9d525832-77e4-46e2-a382-f0cb79b86bbe	9d525832-7bfd-4a69-b6a9-86a7d84e9fde	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":153,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:38:45
6579	9d52d31b-2ab0-4371-9813-5552dd5748c2	9d52d31b-4ecb-43cc-949b-f368558f502d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:22:26
6580	9d52d31b-4936-48bf-90fd-daef825195a3	9d52d31b-4ecb-43cc-949b-f368558f502d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:22:26
6400	9d526c6e-bb6f-45f9-8b6b-75d53783ae5b	9d526c6f-117a-43fb-ae2b-358bc2604c68	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 07:35:20
6401	9d526c6f-0d20-4d61-9c58-4652438296eb	9d526c6f-117a-43fb-ae2b-358bc2604c68	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 07:35:20
6402	9d526c6f-0e8d-4543-9116-2e98fedbb761	9d526c6f-117a-43fb-ae2b-358bc2604c68	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1066,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:35:20
6581	9d52d31b-498d-4192-adcb-1e0f0eb2561d	9d52d31b-4ecb-43cc-949b-f368558f502d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:22:26
6582	9d52d31b-4d74-42e1-b22b-a4ccfc460ddb	9d52d31b-4ecb-43cc-949b-f368558f502d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:22:26
6583	9d52d31b-4dd6-42e8-9f89-f1806d007deb	9d52d31b-4ecb-43cc-949b-f368558f502d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":306,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:22:26
6761	9d52d540-cdda-4e57-9253-440248d14f7d	9d52d540-efae-4267-bb1a-1dae108eacfe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:28:26
6762	9d52d540-e8b8-4c6a-9d26-c70a170e8a66	9d52d540-efae-4267-bb1a-1dae108eacfe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"44.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:28:26
6763	9d52d540-e906-448f-b416-55dc20573664	9d52d540-efae-4267-bb1a-1dae108eacfe	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:28:26
6764	9d52d540-ea8b-4160-bb99-3cbbead592f3	9d52d540-efae-4267-bb1a-1dae108eacfe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"1.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:28:26
6765	9d52d540-eabc-499a-ad5b-a94da9708f59	9d52d540-efae-4267-bb1a-1dae108eacfe	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:28:26
6766	9d52d540-ee76-4e60-a786-af109d18398d	9d52d540-efae-4267-bb1a-1dae108eacfe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:28:26
6046	9d525833-3170-4632-a623-e17cf3d67a18	9d525833-80c5-48a5-81cd-1b7d2680ff93	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 06:38:46
2640	9d50fb05-b509-47d8-b384-ca0063e53cfd	9d50fb06-0ae7-4868-977b-fecc6fc8ef8f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-23 14:22:24
2641	9d50fb06-087c-497f-aa6d-1ea9b53329f2	9d50fb06-0ae7-4868-977b-fecc6fc8ef8f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-23 14:22:24
2642	9d50fb06-0990-40b4-8d03-9e186296dd39	9d50fb06-0ae7-4868-977b-fecc6fc8ef8f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":447,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:22:24
6047	9d525833-7599-4fb7-bee2-11987c70ef73	9d525833-80c5-48a5-81cd-1b7d2680ff93	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"updated_at\\", \\"created_at\\") values ('Luis andre', 'Herrera', 'MArtinez', 'CC', '100465545', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '500000', 25, 6, 'S', null, 'Thu Oct 24 2024', 'Pendiente', 12, 14, 14, '2024-10-24 06:38:46', '2024-10-24 06:38:46') returning \\"id\\"","time":"4.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":77,"hash":"18efcd076c06e51570dcc83643e19328","hostname":"EderCortes"}	2024-10-24 06:38:46
6048	9d525833-7603-4522-bca5-578d31ea72d0	9d525833-80c5-48a5-81cd-1b7d2680ff93	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:5","hostname":"EderCortes"}	2024-10-24 06:38:46
6049	9d525833-778f-418a-a81e-bc9f79c19769	9d525833-80c5-48a5-81cd-1b7d2680ff93	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (5, 1, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:46', '2024-10-24 06:38:46')","time":"2.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:46
6050	9d525833-77c2-457c-a1d8-121aa6fbb1fa	9d525833-80c5-48a5-81cd-1b7d2680ff93	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:46
6051	9d525833-7842-4b54-94bb-8d976ac5d4a4	9d525833-80c5-48a5-81cd-1b7d2680ff93	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (5, 2, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:46', '2024-10-24 06:38:46')","time":"0.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:46
6052	9d525833-7876-418d-8adb-64e7b7e02377	9d525833-80c5-48a5-81cd-1b7d2680ff93	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:46
6053	9d525833-7905-40be-8e30-5d8699b7158d	9d525833-80c5-48a5-81cd-1b7d2680ff93	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (5, 3, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:46', '2024-10-24 06:38:46')","time":"0.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:46
6054	9d525833-7933-4595-8fcb-564a4a8ffe1a	9d525833-80c5-48a5-81cd-1b7d2680ff93	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:46
6055	9d525833-79a7-457b-9a09-a65ccce4ed1c	9d525833-80c5-48a5-81cd-1b7d2680ff93	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (5, 4, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:46', '2024-10-24 06:38:46')","time":"0.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:46
6056	9d525833-79c8-4afc-adce-4532df5ef074	9d525833-80c5-48a5-81cd-1b7d2680ff93	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:46
6057	9d525833-7a2c-4b4f-8d02-2176e646d5c0	9d525833-80c5-48a5-81cd-1b7d2680ff93	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (5, 5, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:46', '2024-10-24 06:38:46')","time":"0.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:46
6058	9d525833-7a50-468b-bc97-52b4e9cea86a	9d525833-80c5-48a5-81cd-1b7d2680ff93	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:46
6059	9d525833-7abc-455b-8a05-28d87431d10d	9d525833-80c5-48a5-81cd-1b7d2680ff93	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (5, 6, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:46', '2024-10-24 06:38:46')","time":"0.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:46
6060	9d525833-7ae3-48fe-b63c-2ec82b9e9159	9d525833-80c5-48a5-81cd-1b7d2680ff93	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:46
6061	9d525833-7f80-438b-942c-9687921cb1ba	9d525833-80c5-48a5-81cd-1b7d2680ff93	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 06:38:46
6403	9d526c6f-9e03-489c-8703-7660141d6e4b	9d526c6f-c15a-4111-812a-c32bc19837d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 07:35:21
6584	9d52d31b-a3c1-4890-8db0-e0e9fc18a9ad	9d52d31b-c991-4a64-9e16-f5b5b5c44a11	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:22:26
14886	9d5ec573-d02c-4a66-a72c-17fcb15b72a6	9d5ec574-1537-49f2-bdc2-fdd8b03a8404	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-30 10:54:11
2643	9d50fb06-8fe6-4307-a42d-97ce5d49e838	9d50fb06-e932-4797-8297-ab13a9b1cf1e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-23 14:22:24
2644	9d50fb06-dfd6-4aae-92a2-96883328cf51	9d50fb06-e932-4797-8297-ab13a9b1cf1e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"109.52","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:22:24
2645	9d50fb06-e043-41be-a7be-77cef9864a6c	9d50fb06-e932-4797-8297-ab13a9b1cf1e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:22:24
2646	9d50fb06-e707-4e9b-bb43-f5af6251a7f9	9d50fb06-e932-4797-8297-ab13a9b1cf1e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-23 14:22:24
2647	9d50fb06-e780-44d7-808d-c718f2635755	9d50fb06-e932-4797-8297-ab13a9b1cf1e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":532,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:22:24
4488	9d5130c8-c168-48a7-8d64-2be97e23f466	9d5130c8-fd02-4501-b25e-a0fcc727ca99	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 16:52:43
4489	9d5130c8-fa8c-4b54-ad7b-86e595ca9e15	9d5130c8-fd02-4501-b25e-a0fcc727ca99	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 16:52:43
4490	9d5130c8-fb73-4031-bfc4-c43bd3d2c300	9d5130c8-fd02-4501-b25e-a0fcc727ca99	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":853,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:52:43
6062	9d525833-7fcb-45c3-8126-052cf0a6dd77	9d525833-80c5-48a5-81cd-1b7d2680ff93	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"615","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":"100465545","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"500000","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_cobrador":14,"user_customer":14},"detail":{"status":false,"observacion":"N\\/A","fecha_pago":"Thu Oct 24 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":5},"duration":352,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:38:46
6404	9d526c6f-b7e6-407f-a9c7-530f27493141	9d526c6f-c15a-4111-812a-c32bc19837d6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"48.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-24 07:35:21
5082	9d513672-d3dc-4026-8f2b-8e77245afe6e	9d513672-ecab-4f90-8fa5-a353e057bcc3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":805,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:34
6405	9d526c6f-bfb4-447d-b271-940cea9dfe93	9d526c6f-c15a-4111-812a-c32bc19837d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 07:35:21
6585	9d52d31b-c176-44a0-b25d-8ef9087c68fe	9d52d31b-c991-4a64-9e16-f5b5b5c44a11	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '1' order by \\"id\\" asc","time":"49.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:22:26
6586	9d52d31b-c1d4-4055-832b-e746354a8f45	9d52d31b-c991-4a64-9e16-f5b5b5c44a11	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:22:26
2648	9d50fb07-6dda-4d61-adff-1ea33da762be	9d50fb07-a427-4630-ba54-c9b6e87f744c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-23 14:22:25
2649	9d50fb07-9afc-4b02-895f-fb7fde446bca	9d50fb07-a427-4630-ba54-c9b6e87f744c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"75.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:22:25
2650	9d50fb07-9bd5-4c13-ada5-d717dc712a0f	9d50fb07-a427-4630-ba54-c9b6e87f744c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:22:25
2651	9d50fb07-a22d-4214-bf7c-6b469ed651b7	9d50fb07-a427-4630-ba54-c9b6e87f744c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-23 14:22:25
2652	9d50fb07-a2dd-4df4-b4fd-46f3d547903a	9d50fb07-a427-4630-ba54-c9b6e87f744c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":452,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:22:25
4491	9d5130c9-4b2b-4c46-b3a7-4c79378dfd57	9d5130c9-683d-49f7-9bb6-77a1b22d38f1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 16:52:44
4492	9d5130c9-6380-45cb-b01f-9ade66b68cf0	9d5130c9-683d-49f7-9bb6-77a1b22d38f1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:52:44
4493	9d5130c9-63cf-4078-a956-3e6c76a48d82	9d5130c9-683d-49f7-9bb6-77a1b22d38f1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 16:52:44
4494	9d5130c9-672b-4bc5-a480-f05269ec5680	9d5130c9-683d-49f7-9bb6-77a1b22d38f1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 16:52:44
4495	9d5130c9-676b-4abe-810c-983fb10cc453	9d5130c9-683d-49f7-9bb6-77a1b22d38f1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:52:44
6587	9d52d31b-c40c-4307-9b7f-10283870b79e	9d52d31b-c991-4a64-9e16-f5b5b5c44a11	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1'","time":"2.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:22:26
5083	9d513673-a6a1-4011-a97a-35af9b36868e	9d513673-db0f-413f-8834-94057e36655c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 17:08:34
5084	9d513673-d2b5-4712-b89f-53f1bbad1dd4	9d513673-db0f-413f-8834-94057e36655c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"74.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:08:34
5085	9d513673-d354-4a23-b665-dec95c9387b8	9d513673-db0f-413f-8834-94057e36655c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:08:34
5086	9d513673-d96c-4b94-9061-9cc4d4e1e0cf	9d513673-db0f-413f-8834-94057e36655c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 17:08:34
5087	9d513673-d9db-45e8-b7cb-37278aa5b536	9d513673-db0f-413f-8834-94057e36655c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":585,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:34
6588	9d52d31b-c450-4c29-a763-e53b6bd3541d	9d52d31b-c991-4a64-9e16-f5b5b5c44a11	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 12:22:26
4496	9d5130c9-bef2-487e-bd7d-0d036f7f23e7	9d5130c9-e870-4e51-bf87-68dad3ed3b2e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 16:52:44
4497	9d5130c9-df94-4940-8285-92263c77e5dd	9d5130c9-e870-4e51-bf87-68dad3ed3b2e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"52.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:52:44
4498	9d5130c9-e00a-404d-a7a6-a97557f9900a	9d5130c9-e870-4e51-bf87-68dad3ed3b2e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 16:52:44
4499	9d5130c9-e678-4dee-bc9c-07c5bdd22830	9d5130c9-e870-4e51-bf87-68dad3ed3b2e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 16:52:44
4500	9d5130c9-e702-4f40-8cae-9f571221ef13	9d5130c9-e870-4e51-bf87-68dad3ed3b2e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":306,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:52:44
6063	9d525833-d365-4ed6-9ed6-031c28fd2c39	9d525833-d631-4fbb-a955-98f066f92876	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":147,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:38:46
6406	9d526c6f-c01e-4990-bc8d-0d1a52f1fc0b	9d526c6f-c15a-4111-812a-c32bc19837d6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":387,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:35:21
5092	9d513674-e5fe-4a0f-903c-9b3d9c7ee649	9d513675-2ddd-4435-84fa-1c48efa63a54	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 17:08:35
5093	9d513675-28e4-4373-a499-be9e2f63f0e6	9d513675-2ddd-4435-84fa-1c48efa63a54	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"149.33","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:08:35
5094	9d513675-2931-4d08-b67d-eea3e02b9c5f	9d513675-2ddd-4435-84fa-1c48efa63a54	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:08:35
5095	9d513675-2cc5-4e5d-b2d0-a9c3600dffa0	9d513675-2ddd-4435-84fa-1c48efa63a54	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 17:08:35
5096	9d513675-2d11-4514-a8a4-e38633e26afa	9d513675-2ddd-4435-84fa-1c48efa63a54	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":422,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:35
6589	9d52d31b-c80b-4149-acd6-023cf12c3c67	9d52d31b-c991-4a64-9e16-f5b5b5c44a11	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:22:26
6590	9d52d31b-c85b-4536-a1af-00fff34ab306	9d52d31b-c991-4a64-9e16-f5b5b5c44a11	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":1,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]},"duration":299,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:22:26
4501	9d5130ca-6903-46e2-82f5-afa08ecb9ec1	9d5130ca-a7a4-4244-b218-9ff999516aaa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 16:52:44
4502	9d5130ca-9c47-4eb2-b18d-08864297f3ad	9d5130ca-a7a4-4244-b218-9ff999516aaa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"86.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 16:52:44
4503	9d5130ca-9ce6-494d-825e-1ad14b321932	9d5130ca-a7a4-4244-b218-9ff999516aaa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 16:52:44
4504	9d5130ca-a56a-4020-9f99-3809ab32cb37	9d5130ca-a7a4-4244-b218-9ff999516aaa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 16:52:44
2934	9d50fdac-b928-4cec-9b91-5b9e51c42fed	9d50fdad-169d-4080-8370-54075ae3e906	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 14:29:49
2935	9d50fdad-13bd-4bc4-9c81-b8eec861226c	9d50fdad-169d-4080-8370-54075ae3e906	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 14:29:49
2936	9d50fdad-1516-402d-ace7-c95c929bde76	9d50fdad-169d-4080-8370-54075ae3e906	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":609,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:29:49
4505	9d5130ca-a605-46c4-b94c-98dcfaafa3cc	9d5130ca-a7a4-4244-b218-9ff999516aaa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":472,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:52:44
6064	9d525834-8b7a-4f9b-a620-29984a15e0e9	9d525834-da2c-4b14-a933-6c21c7b8442c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 06:38:47
6065	9d525834-cd60-4cd6-a67f-8924fde8f7b6	9d525834-da2c-4b14-a933-6c21c7b8442c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"updated_at\\", \\"created_at\\") values ('Luis andre', 'Herrera', 'MArtinez', 'CC', '100465545', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '500000', 25, 6, 'S', null, 'Thu Oct 24 2024', 'Pendiente', 12, 14, 14, '2024-10-24 06:38:47', '2024-10-24 06:38:47') returning \\"id\\"","time":"4.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":77,"hash":"18efcd076c06e51570dcc83643e19328","hostname":"EderCortes"}	2024-10-24 06:38:47
5097	9d513675-6e42-4900-8025-ee33383f25cf	9d513675-8ba2-44eb-8848-541f95f94e30	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 17:08:35
5098	9d513675-8713-4027-804a-df4f95fe7116	9d513675-8ba2-44eb-8848-541f95f94e30	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:08:35
5099	9d513675-8761-4220-b4fb-ade9f98001bd	9d513675-8ba2-44eb-8848-541f95f94e30	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:08:35
5100	9d513675-8a76-4f2f-aa84-41c131ed6bcc	9d513675-8ba2-44eb-8848-541f95f94e30	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 17:08:35
5101	9d513675-8ad0-456d-97ea-359a105ed434	9d513675-8ba2-44eb-8848-541f95f94e30	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":228,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:35
6066	9d525834-cdbe-4808-80ee-c82ccb5f01d1	9d525834-da2c-4b14-a933-6c21c7b8442c	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:6","hostname":"EderCortes"}	2024-10-24 06:38:47
6067	9d525834-cf0b-4af6-87c2-a0813ab33687	9d525834-da2c-4b14-a933-6c21c7b8442c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (6, 1, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:47', '2024-10-24 06:38:47')","time":"2.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:47
6068	9d525834-cf3d-46d4-b4f6-d634937385d2	9d525834-da2c-4b14-a933-6c21c7b8442c	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:47
2937	9d50fdad-9542-4302-9404-2138e95b4a5d	9d50fdad-f199-4812-ad56-b19965a643ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 14:29:49
2938	9d50fdad-e975-4f29-9c75-ef636469d025	9d50fdad-f199-4812-ad56-b19965a643ae	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"165.14","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:29:49
2939	9d50fdad-e9e4-42a8-bc95-e0c75355fc5e	9d50fdad-f199-4812-ad56-b19965a643ae	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:29:49
2940	9d50fdad-f045-4a0b-9fb9-1ba4af613049	9d50fdad-f199-4812-ad56-b19965a643ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 14:29:49
2941	9d50fdad-f098-49e6-8799-3ad11477973d	9d50fdad-f199-4812-ad56-b19965a643ae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":515,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:29:49
4506	9d5130cb-59fe-45b6-8024-288444ba06f5	9d5130cb-915c-47cc-8765-00bfedd34bc4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 16:52:45
3048	9d5101a8-2c64-4e72-b4a1-0693b3cd8e53	9d5101a8-8827-4b1f-bcda-34fdacb7eca5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:40:57
3049	9d5101a8-85b8-417c-98b9-ca37cf844416	9d5101a8-8827-4b1f-bcda-34fdacb7eca5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:40:57
3050	9d5101a8-86ac-4864-bbf2-fbb88de5e70d	9d5101a8-8827-4b1f-bcda-34fdacb7eca5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":574,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:40:57
4507	9d5130cb-84e0-43cc-91d6-e8fb038863e9	9d5130cb-915c-47cc-8765-00bfedd34bc4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"75.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 16:52:45
4508	9d5130cb-856a-433e-98dc-51c5c8660136	9d5130cb-915c-47cc-8765-00bfedd34bc4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 16:52:45
4509	9d5130cb-8f24-4871-bf81-f29723a3e156	9d5130cb-915c-47cc-8765-00bfedd34bc4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 16:52:45
4510	9d5130cb-8fb2-4564-990b-07cbfb3c6614	9d5130cb-915c-47cc-8765-00bfedd34bc4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":510,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:52:45
6069	9d525834-cfb6-4e24-9784-d81faa7dd2e9	9d525834-da2c-4b14-a933-6c21c7b8442c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (6, 2, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:47', '2024-10-24 06:38:47')","time":"0.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:47
6070	9d525834-cfdc-4fe4-b0c1-6351e6500e19	9d525834-da2c-4b14-a933-6c21c7b8442c	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:47
6071	9d525834-d059-4a97-b5e8-91da7bea786e	9d525834-da2c-4b14-a933-6c21c7b8442c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (6, 3, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:47', '2024-10-24 06:38:47')","time":"0.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:47
6072	9d525834-d08f-4095-b79a-3bb8f214fbb3	9d525834-da2c-4b14-a933-6c21c7b8442c	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:47
6073	9d525834-d11b-4bca-9574-672e5c905295	9d525834-da2c-4b14-a933-6c21c7b8442c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (6, 4, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:47', '2024-10-24 06:38:47')","time":"0.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:47
6074	9d525834-d14b-41bb-a9cf-17fa9370dfaa	9d525834-da2c-4b14-a933-6c21c7b8442c	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:47
2942	9d50fdae-355f-4182-bf54-feec40d44fee	9d50fdae-56e9-498f-a024-401c69df5b33	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 14:29:49
2943	9d50fdae-5114-488f-8b20-d6d18a8590b0	9d50fdae-56e9-498f-a024-401c69df5b33	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:29:50
2944	9d50fdae-515e-42c2-b82c-ebb4f5ec9190	9d50fdae-56e9-498f-a024-401c69df5b33	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:29:50
2945	9d50fdae-54dc-4111-af90-a974bdf7cd17	9d50fdae-56e9-498f-a024-401c69df5b33	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 14:29:50
2946	9d50fdae-5582-4043-bf56-caf3b4cf2356	9d50fdae-56e9-498f-a024-401c69df5b33	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:29:50
3051	9d5101a9-03ab-4a8a-a126-6d66322eacd5	9d5101a9-5b0c-4c5e-afba-0f984244fcdb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:40:57
3052	9d5101a9-53ba-44fb-b152-2344f19a4553	9d5101a9-5b0c-4c5e-afba-0f984244fcdb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"163.49","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:40:57
3053	9d5101a9-544b-4ad7-909d-861153829095	9d5101a9-5b0c-4c5e-afba-0f984244fcdb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:40:57
3054	9d5101a9-598d-442f-98fa-e3c3bfaa4ff8	9d5101a9-5b0c-4c5e-afba-0f984244fcdb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:40:57
3055	9d5101a9-59e2-4e73-82f7-6b1ae6f143d9	9d5101a9-5b0c-4c5e-afba-0f984244fcdb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":503,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:40:57
6075	9d525834-d1d7-440e-9d6a-c3f0c3357a77	9d525834-da2c-4b14-a933-6c21c7b8442c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (6, 5, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:47', '2024-10-24 06:38:47')","time":"0.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:47
6076	9d525834-d205-40bf-bbc4-6decba203afa	9d525834-da2c-4b14-a933-6c21c7b8442c	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:47
6077	9d525834-d27b-41ae-a19e-b4ae3a419766	9d525834-da2c-4b14-a933-6c21c7b8442c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (6, 6, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:47', '2024-10-24 06:38:47')","time":"0.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:47
6078	9d525834-d2a2-4eda-a129-1bc56338b3e2	9d525834-da2c-4b14-a933-6c21c7b8442c	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:47
6079	9d525834-d8e7-4db2-9f11-cb39ed85706c	9d525834-da2c-4b14-a933-6c21c7b8442c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 06:38:47
6407	9d526c70-5b5f-47ad-b084-5049389f8ebc	9d526c70-b177-4bfd-8dbc-10bbec35960c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 07:35:21
6408	9d526c70-a5b7-462c-96a4-1a7b37008755	9d526c70-b177-4bfd-8dbc-10bbec35960c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"112.76","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 07:35:22
6409	9d526c70-a64b-4c48-962f-7865c1316868	9d526c70-b177-4bfd-8dbc-10bbec35960c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 07:35:22
6410	9d526c70-af6a-45fb-bfda-7a84d4edfedb	9d526c70-b177-4bfd-8dbc-10bbec35960c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 07:35:22
6591	9d52d31d-9f0e-4b3b-b1ed-ef217f29aca3	9d52d31d-bc42-4cec-89c4-1ba46d6450d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:22:28
2947	9d50fdaf-541a-4198-9c8c-02e40ff3c2d7	9d50fdaf-970b-409d-9c3b-38d8c26bf634	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 14:29:50
2948	9d50fdaf-8b9c-47a3-a36d-e619b9413178	9d50fdaf-970b-409d-9c3b-38d8c26bf634	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"80.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:29:50
2949	9d50fdaf-8c41-42fb-a852-da75d9951a80	9d50fdaf-970b-409d-9c3b-38d8c26bf634	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:29:50
2950	9d50fdaf-9543-4c61-a1bc-c4246a86fdf2	9d50fdaf-970b-409d-9c3b-38d8c26bf634	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:29:50
2951	9d50fdaf-95ac-4774-84d4-1da42c96a0ec	9d50fdaf-970b-409d-9c3b-38d8c26bf634	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":795,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:29:50
3056	9d5101a9-9f8d-45d4-81ac-ee69ffff5328	9d5101a9-c018-4b89-8cd5-9d0769dda7b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:40:58
3057	9d5101a9-bb36-468c-8a4c-123ddfdf4f57	9d5101a9-c018-4b89-8cd5-9d0769dda7b0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:40:58
3058	9d5101a9-bb81-494a-ac8e-586385077c76	9d5101a9-c018-4b89-8cd5-9d0769dda7b0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:40:58
3059	9d5101a9-bedd-4cb3-9fd7-13e62f5754b3	9d5101a9-c018-4b89-8cd5-9d0769dda7b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 14:40:58
3060	9d5101a9-bf35-4234-8e30-d3d491627cff	9d5101a9-c018-4b89-8cd5-9d0769dda7b0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:40:58
6080	9d525834-d92a-4e97-9738-8b84e9fc52d5	9d525834-da2c-4b14-a933-6c21c7b8442c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"615","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":"100465545","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"500000","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_cobrador":14,"user_customer":14},"detail":{"status":false,"observacion":"N\\/A","fecha_pago":"Thu Oct 24 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":6},"duration":355,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:38:47
6592	9d52d31d-b731-48d1-be2c-8b41cc39373c	9d52d31d-bc42-4cec-89c4-1ba46d6450d7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:22:28
6593	9d52d31d-b798-410e-9b73-8cf5fd9afc70	9d52d31d-bc42-4cec-89c4-1ba46d6450d7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:22:28
6594	9d52d31d-baf9-4275-8823-d9c07ad8e0ff	9d52d31d-bc42-4cec-89c4-1ba46d6450d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:22:28
2952	9d50fdaf-f06f-4c7d-b13b-14e8bc99253d	9d50fdb0-1144-4b47-98b9-0494c660b702	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:29:51
2953	9d50fdb0-0be1-40fc-a6fa-daa4331f5a29	9d50fdb0-1144-4b47-98b9-0494c660b702	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"48.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:29:51
2954	9d50fdb0-0c2d-4924-8da7-f13b3f34d0b0	9d50fdb0-1144-4b47-98b9-0494c660b702	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:29:51
2955	9d50fdb0-0fe4-4a0e-87b0-c0f98975f92a	9d50fdb0-1144-4b47-98b9-0494c660b702	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:29:51
2956	9d50fdb0-102c-4666-af6a-2faa4a4fe90f	9d50fdb0-1144-4b47-98b9-0494c660b702	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":288,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:29:51
3061	9d5101aa-4bab-4060-a3b5-31d9460b71bb	9d5101aa-8969-4ac7-838a-284df9cf9b6f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 14:40:58
3062	9d5101aa-7fc9-4c98-936d-a37873e4c4b5	9d5101aa-8969-4ac7-838a-284df9cf9b6f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"82.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:40:58
3063	9d5101aa-804c-48fe-be91-b0c097bd191e	9d5101aa-8969-4ac7-838a-284df9cf9b6f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:40:58
3064	9d5101aa-874d-4d19-8c54-82d68e1cf59f	9d5101aa-8969-4ac7-838a-284df9cf9b6f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 14:40:58
3065	9d5101aa-87d2-4bf6-a3ec-dc87ffd8395f	9d5101aa-8969-4ac7-838a-284df9cf9b6f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":494,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:40:58
6081	9d525835-36ee-49bc-81b5-cb5b6ebc9085	9d525835-3a75-4fa5-a53d-50fac164ddec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":150,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:38:47
6411	9d526c70-aff6-4582-834d-bb63784bb7bf	9d526c70-b177-4bfd-8dbc-10bbec35960c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":600,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:35:22
3066	9d5101ab-2044-463f-8bcf-c56e156c0cb8	9d5101ab-4f8c-4a96-88b7-fc76d0773256	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 14:40:59
3067	9d5101ab-47a4-4458-9ba2-94a8d1cd637e	9d5101ab-4f8c-4a96-88b7-fc76d0773256	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"61.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:40:59
3068	9d5101ab-481d-4810-a246-8826ebb6f00a	9d5101ab-4f8c-4a96-88b7-fc76d0773256	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:40:59
3069	9d5101ab-4dbe-43e7-90b1-2694f2211163	9d5101ab-4f8c-4a96-88b7-fc76d0773256	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 14:40:59
2816	9d50fc9b-64e2-4d32-bcb2-5ce65f5e868a	9d50fc9b-8bdc-4c6f-8cfe-e7b9875087b6	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 14:26:49
2817	9d50fc9b-89dc-42f7-b3fb-e6f74d3c0d3b	9d50fc9b-8bdc-4c6f-8cfe-e7b9875087b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:26:49
2818	9d50fc9b-8abc-4bc7-9ec8-1682bcf6b4c8	9d50fc9b-8bdc-4c6f-8cfe-e7b9875087b6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":276,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:26:49
3070	9d5101ab-4e30-4245-a7c2-5296c7209b1c	9d5101ab-4f8c-4a96-88b7-fc76d0773256	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":483,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:40:59
6082	9d525835-ed44-43f8-93fc-dd9f3c41a18a	9d525836-3a23-428d-b08b-ae95e3afa74a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 06:38:48
6083	9d525836-2fff-4744-aa34-671768084f5b	9d525836-3a23-428d-b08b-ae95e3afa74a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"updated_at\\", \\"created_at\\") values ('Luis andre', 'Herrera', 'MArtinez', 'CC', '100465545', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '500000', 25, 6, 'S', null, 'Thu Oct 24 2024', 'Pendiente', 12, 14, 14, '2024-10-24 06:38:48', '2024-10-24 06:38:48') returning \\"id\\"","time":"4.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":77,"hash":"18efcd076c06e51570dcc83643e19328","hostname":"EderCortes"}	2024-10-24 06:38:48
6084	9d525836-3067-4e7c-a047-7e66ecf10070	9d525836-3a23-428d-b08b-ae95e3afa74a	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:7","hostname":"EderCortes"}	2024-10-24 06:38:48
6085	9d525836-31bd-4f1f-a6fe-617435feae7b	9d525836-3a23-428d-b08b-ae95e3afa74a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (7, 1, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:48', '2024-10-24 06:38:48')","time":"2.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:48
6086	9d525836-31fd-413d-8cc1-ca3372953c18	9d525836-3a23-428d-b08b-ae95e3afa74a	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:48
6087	9d525836-3297-4975-a006-0d5331f23352	9d525836-3a23-428d-b08b-ae95e3afa74a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (7, 2, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:48', '2024-10-24 06:38:48')","time":"0.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:48
6088	9d525836-32c2-47f1-88e7-2cd01a2d919e	9d525836-3a23-428d-b08b-ae95e3afa74a	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:48
6089	9d525836-3347-450b-b52d-0ae3fb07837c	9d525836-3a23-428d-b08b-ae95e3afa74a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (7, 3, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:48', '2024-10-24 06:38:48')","time":"0.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:48
6090	9d525836-336b-4609-a1d2-66fba01d31a0	9d525836-3a23-428d-b08b-ae95e3afa74a	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:48
6091	9d525836-33da-4a16-a7e1-fcfe1b57a1de	9d525836-3a23-428d-b08b-ae95e3afa74a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (7, 4, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:48', '2024-10-24 06:38:48')","time":"0.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:48
2819	9d50fc9b-e322-4aaf-91ba-43ee9f168d8e	9d50fc9c-2bf2-4e08-a6a5-5a0186a7b70c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:26:50
2820	9d50fc9c-2610-4327-84cf-168453583a37	9d50fc9c-2bf2-4e08-a6a5-5a0186a7b70c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"146.96","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:26:50
2821	9d50fc9c-2659-4cca-a257-1feb174b519d	9d50fc9c-2bf2-4e08-a6a5-5a0186a7b70c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:26:50
2822	9d50fc9c-2a9f-426c-a09d-cc40567006c4	9d50fc9c-2bf2-4e08-a6a5-5a0186a7b70c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:26:50
2823	9d50fc9c-2b06-456d-b479-da872be1b8d2	9d50fc9c-2bf2-4e08-a6a5-5a0186a7b70c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":387,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:26:50
6092	9d525836-33fe-4bc8-a4e2-e0bd2cd25611	9d525836-3a23-428d-b08b-ae95e3afa74a	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:48
3504	9d5106e2-2c13-41e5-80b3-85a57555a9fb	9d5106e2-773f-4b74-adb2-af7d0182bfb6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 14:55:33
3505	9d5106e2-75a2-454f-a6c2-b43414c11aa1	9d5106e2-773f-4b74-adb2-af7d0182bfb6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 14:55:34
3506	9d5106e2-763b-4989-84c4-2c31ba0acfc6	9d5106e2-773f-4b74-adb2-af7d0182bfb6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":398,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:55:34
4612	9d5133c4-6c9e-4148-a7d8-8b39e80e86cd	9d5133c4-a6a6-4a01-814d-21b11dae786d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 17:01:04
4613	9d5133c4-a3da-4970-9e37-d26af13ade19	9d5133c4-a6a6-4a01-814d-21b11dae786d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 17:01:04
4614	9d5133c4-a52a-4e99-add5-9fc14c390f20	9d5133c4-a6a6-4a01-814d-21b11dae786d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":510,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:01:04
6093	9d525836-3467-4d2c-8e36-226f5ac7f5ec	9d525836-3a23-428d-b08b-ae95e3afa74a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (7, 5, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:48', '2024-10-24 06:38:48')","time":"0.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:48
6094	9d525836-348a-4dc7-adcf-23a8674200ba	9d525836-3a23-428d-b08b-ae95e3afa74a	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:48
6095	9d525836-34f2-49f9-80ef-9556e92c2589	9d525836-3a23-428d-b08b-ae95e3afa74a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (7, 6, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:48', '2024-10-24 06:38:48')","time":"0.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:48
6096	9d525836-3515-4de5-a730-fda94796b77d	9d525836-3a23-428d-b08b-ae95e3afa74a	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:48
6097	9d525836-38d9-4799-bce1-2f736c413b53	9d525836-3a23-428d-b08b-ae95e3afa74a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 06:38:48
6098	9d525836-391d-4357-8034-101da7daa3fe	9d525836-3a23-428d-b08b-ae95e3afa74a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"615","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":"100465545","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"500000","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_cobrador":14,"user_customer":14},"detail":{"status":false,"observacion":"N\\/A","fecha_pago":"Thu Oct 24 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":7},"duration":346,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:38:48
6412	9d526c71-b534-4918-9d0f-5c9daba63bb8	9d526c71-f0a1-4eb2-b7b6-aa426fc8fed1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 07:35:22
6413	9d526c71-e4a4-4430-85ca-c653e0ba42c1	9d526c71-f0a1-4eb2-b7b6-aa426fc8fed1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"74.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 07:35:22
6414	9d526c71-e535-42fe-947f-d3f669b383cd	9d526c71-f0a1-4eb2-b7b6-aa426fc8fed1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 07:35:22
6415	9d526c71-ee78-461b-b7af-e5977fc4ecfe	9d526c71-f0a1-4eb2-b7b6-aa426fc8fed1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 07:35:22
2824	9d50fc9c-6f56-4df2-85cb-d582b9f64077	9d50fc9c-91d1-4a15-a6a6-f16a806be01e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:26:50
2825	9d50fc9c-8c2d-4903-b2eb-c00626e4b36d	9d50fc9c-91d1-4a15-a6a6-f16a806be01e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:26:50
2826	9d50fc9c-8c8c-415f-8da0-98cf1cce9082	9d50fc9c-91d1-4a15-a6a6-f16a806be01e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:26:50
2827	9d50fc9c-905b-41a0-abb5-e8f5ea0d1f3b	9d50fc9c-91d1-4a15-a6a6-f16a806be01e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:26:50
2828	9d50fc9c-90be-46e8-b317-51945fe1da07	9d50fc9c-91d1-4a15-a6a6-f16a806be01e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:26:50
3507	9d5106e2-c7b3-4d48-abeb-2224b10562e2	9d5106e2-ec7e-4484-b48b-197de658cb47	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 14:55:34
3508	9d5106e2-e724-4177-821a-c946726bd564	9d5106e2-ec7e-4484-b48b-197de658cb47	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"51.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:55:34
3509	9d5106e2-e784-4e9c-97d2-02f50bc57c04	9d5106e2-ec7e-4484-b48b-197de658cb47	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:55:34
3510	9d5106e2-eb61-4afc-b8d6-3cbce6c88468	9d5106e2-ec7e-4484-b48b-197de658cb47	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 14:55:34
3511	9d5106e2-eba7-411c-a1c9-592ad0a7ce99	9d5106e2-ec7e-4484-b48b-197de658cb47	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:55:34
4615	9d5133c5-43bf-4b77-81a8-bc335ad66b5b	9d5133c5-9b79-4d6f-b50b-f1bda1440e32	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 17:01:04
4616	9d5133c5-923c-4250-85e2-a513e847e53a	9d5133c5-9b79-4d6f-b50b-f1bda1440e32	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"163.00","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:01:04
4617	9d5133c5-92be-44fe-a1bf-88f0bde99481	9d5133c5-9b79-4d6f-b50b-f1bda1440e32	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:01:04
4618	9d5133c5-995a-4556-9e27-179a422df24d	9d5133c5-9b79-4d6f-b50b-f1bda1440e32	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 17:01:04
4619	9d5133c5-9a19-40a3-bb62-2deec0b2408b	9d5133c5-9b79-4d6f-b50b-f1bda1440e32	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":582,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:01:04
6099	9d525836-f187-4550-8ee8-b9dd87fcc9e4	9d525836-f52e-46da-9d44-7df2fb9ded35	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":163,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:38:48
3512	9d5106e3-3652-479b-9b02-0dcee71479dc	9d5106e3-86cb-4cb3-a02c-d3416f3cbcd0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 14:55:34
3513	9d5106e3-7f69-492c-9241-d2df5c0213da	9d5106e3-86cb-4cb3-a02c-d3416f3cbcd0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"162.98","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:55:34
3514	9d5106e3-7fcd-4e15-9084-5a5a3d370f46	9d5106e3-86cb-4cb3-a02c-d3416f3cbcd0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:55:34
3515	9d5106e3-8592-477f-b7d7-8f3ae2a16e6d	9d5106e3-86cb-4cb3-a02c-d3416f3cbcd0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 14:55:34
3516	9d5106e3-85ee-4052-a3df-687334efa167	9d5106e3-86cb-4cb3-a02c-d3416f3cbcd0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":374,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:55:34
4620	9d5133c5-fd0c-4fbe-8551-a9282abda835	9d5133c6-522c-4708-9952-f14d8cfdfa19	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 17:01:05
4621	9d5133c6-4ad8-4c5c-848b-866ac838d671	9d5133c6-522c-4708-9952-f14d8cfdfa19	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"162.59","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:01:05
4622	9d5133c6-4b3c-4605-9625-d1cc896f1b4c	9d5133c6-522c-4708-9952-f14d8cfdfa19	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:01:05
4623	9d5133c6-502e-48c7-9eda-fa92dd25109d	9d5133c6-522c-4708-9952-f14d8cfdfa19	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 17:01:05
4624	9d5133c6-50a4-4d95-b736-8b0fbd8a831d	9d5133c6-522c-4708-9952-f14d8cfdfa19	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":446,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:01:05
6100	9d525837-a7ca-42a5-952a-c6734ac4b50c	9d525837-f1ee-465e-89b0-6cfc08023480	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 06:38:49
6101	9d525837-e866-4ab6-b122-594576bd4693	9d525837-f1ee-465e-89b0-6cfc08023480	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"updated_at\\", \\"created_at\\") values ('Luis andre', 'Herrera', 'MArtinez', 'CC', '100465545', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '500000', 25, 6, 'S', null, 'Thu Oct 24 2024', 'Pendiente', 12, 14, 14, '2024-10-24 06:38:49', '2024-10-24 06:38:49') returning \\"id\\"","time":"4.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":77,"hash":"18efcd076c06e51570dcc83643e19328","hostname":"EderCortes"}	2024-10-24 06:38:49
6102	9d525837-e8c2-4750-a768-9132083c72e9	9d525837-f1ee-465e-89b0-6cfc08023480	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:8","hostname":"EderCortes"}	2024-10-24 06:38:49
6103	9d525837-ea18-4055-9c8a-6729e3b49dbc	9d525837-f1ee-465e-89b0-6cfc08023480	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (8, 1, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:49', '2024-10-24 06:38:49')","time":"2.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:49
6104	9d525837-ea47-40b9-b97a-e44786c1b570	9d525837-f1ee-465e-89b0-6cfc08023480	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:49
14887	9d5ec574-101a-44d3-94d1-45afbb909c2e	9d5ec574-1537-49f2-bdc2-fdd8b03a8404	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '18' and \\"users\\".\\"deleted_at\\" is null","time":"142.25","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":55,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-30 10:54:12
4625	9d5133c7-df55-4284-a5b8-91bea309906e	9d5133c8-7a5d-4e76-b2c4-fad34f76605d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 17:01:06
4626	9d5133c8-6fc7-4fb0-a305-47d253132b05	9d5133c8-7a5d-4e76-b2c4-fad34f76605d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"269.29","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:01:06
4627	9d5133c8-705f-4883-9579-a3a75ca84238	9d5133c8-7a5d-4e76-b2c4-fad34f76605d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:01:06
4628	9d5133c8-7851-4831-90a8-8ea7b61c27f6	9d5133c8-7a5d-4e76-b2c4-fad34f76605d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 17:01:06
4629	9d5133c8-78eb-42e1-8b8e-a6d9fb659d30	9d5133c8-7a5d-4e76-b2c4-fad34f76605d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":1393,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:01:06
6105	9d525837-eac1-4f55-869f-aed717df5453	9d525837-f1ee-465e-89b0-6cfc08023480	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (8, 2, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:49', '2024-10-24 06:38:49')","time":"0.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:49
6106	9d525837-eaea-42e6-87d6-b55dbd47bd7d	9d525837-f1ee-465e-89b0-6cfc08023480	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:49
6107	9d525837-eb5b-458a-aeec-a8e603997c49	9d525837-f1ee-465e-89b0-6cfc08023480	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (8, 3, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:49', '2024-10-24 06:38:49')","time":"0.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:49
6108	9d525837-eb7c-4197-b127-1fbd4a3d4393	9d525837-f1ee-465e-89b0-6cfc08023480	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:49
6109	9d525837-ebdd-479a-8014-2ecaee8b25bf	9d525837-f1ee-465e-89b0-6cfc08023480	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (8, 4, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:49', '2024-10-24 06:38:49')","time":"0.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:49
6110	9d525837-ec00-490a-b631-5e7dff449ce1	9d525837-f1ee-465e-89b0-6cfc08023480	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:49
6111	9d525837-ec83-48ed-b62d-a40c69a94ec4	9d525837-f1ee-465e-89b0-6cfc08023480	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (8, 5, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:49', '2024-10-24 06:38:49')","time":"0.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:49
6112	9d525837-eca6-4514-bc11-d64a8bac5149	9d525837-f1ee-465e-89b0-6cfc08023480	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:49
6113	9d525837-ed08-48e1-95e9-78a7ec043d5a	9d525837-f1ee-465e-89b0-6cfc08023480	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (8, 6, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:49', '2024-10-24 06:38:49')","time":"0.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:49
6114	9d525837-ed26-4675-8da6-7ad557658d0c	9d525837-f1ee-465e-89b0-6cfc08023480	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:49
6115	9d525837-f09a-476f-a3f8-9ec66279d41d	9d525837-f1ee-465e-89b0-6cfc08023480	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 06:38:49
14888	9d5ec574-1074-4f53-a571-7e77e9192cfe	9d5ec574-1537-49f2-bdc2-fdd8b03a8404	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-30 10:54:12
14889	9d5ec574-1414-4a79-a231-52db0efbc5a6	9d5ec574-1537-49f2-bdc2-fdd8b03a8404	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-30 10:54:12
4630	9d5133c8-ea32-4221-bb42-6321bc9c7fce	9d5133c9-182d-4680-8f12-72d4d5593a2a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 17:01:07
4631	9d5133c9-103c-4ab7-a5e1-53908676edcf	9d5133c9-182d-4680-8f12-72d4d5593a2a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"62.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:01:07
4632	9d5133c9-10b2-4f4a-a6ba-a2d96254b2d1	9d5133c9-182d-4680-8f12-72d4d5593a2a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:01:07
4633	9d5133c9-1693-478b-91f8-7e89941ee523	9d5133c9-182d-4680-8f12-72d4d5593a2a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 17:01:07
4634	9d5133c9-1711-4dea-b6f8-faf59bf3b9a3	9d5133c9-182d-4680-8f12-72d4d5593a2a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":379,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:01:07
6116	9d525837-f0dc-48eb-bf5a-f80e02cbcccc	9d525837-f1ee-465e-89b0-6cfc08023480	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"615","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":"100465545","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"500000","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_cobrador":14,"user_customer":14},"detail":{"status":false,"observacion":"N\\/A","fecha_pago":"Thu Oct 24 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":8},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:38:49
6416	9d526c71-eeff-4bbd-8e24-8d4e24106b4d	9d526c71-f0a1-4eb2-b7b6-aa426fc8fed1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":552,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:35:22
6595	9d52d31d-bb42-4a2e-b351-d45247620606	9d52d31d-bc42-4cec-89c4-1ba46d6450d7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":257,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:22:28
21108	9d6734bb-312f-4675-b9f7-7d89e76bcb87	9d6734bb-3c2f-4d98-a76d-490d85e0d90f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '03-11-2024', \\"itemloans_cuota_cancelada\\" = '200000', \\"updated_at\\" = '2024-11-03 15:31:58' where \\"id\\" = 197","time":"8.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":395,"hash":"35b67f849e4a0ba5090d9c1eb8abfe94","hostname":"EderCortes"}	2024-11-03 15:31:58
6417	9d526c74-8888-4b92-aa49-bd36e0029c13	9d526c74-b564-4110-a39f-931f4c481f42	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 07:35:24
6418	9d526c74-abec-4f1a-b5e4-e66c5af2c4d5	9d526c74-b564-4110-a39f-931f4c481f42	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"53.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-24 07:35:24
6117	9d525839-3f0d-413d-8103-da7851353a46	9d525839-41da-4c3b-8d0c-9de5d638b7f6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":161,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:38:50
2384	9d50e781-c219-4594-8d80-1d11a3115931	9d50e782-11cf-4c53-8e12-c1a57db65477	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 13:27:49
2385	9d50e782-0fec-454e-a5c5-c4f03adfc29a	9d50e782-11cf-4c53-8e12-c1a57db65477	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 13:27:50
2386	9d50e782-10a1-4a54-bcde-9e1cb02f1927	9d50e782-11cf-4c53-8e12-c1a57db65477	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":363,"memory":22,"hostname":"EderCortes"}	2024-10-23 13:27:50
6419	9d526c74-ac7d-4f18-ad53-13c00da4c0a6	9d526c74-b564-4110-a39f-931f4c481f42	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-10-24 07:35:24
6420	9d526c74-b36e-4bda-90b3-8bbdd102c754	9d526c74-b564-4110-a39f-931f4c481f42	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 07:35:24
6421	9d526c74-b3ef-474d-b653-72b17b5b933e	9d526c74-b564-4110-a39f-931f4c481f42	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":317,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:35:24
6767	9d52d540-eec9-4973-a3ae-c7943e35cb56	9d52d540-efae-4267-bb1a-1dae108eacfe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":[{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}],"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":319,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:28:26
14890	9d5ec574-1458-4985-bbdc-9b5a17d3a382	9d5ec574-1537-49f2-bdc2-fdd8b03a8404	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/18","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}},"duration":326,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:54:12
20762	9d66fbf2-a1dd-48bc-bcd3-e56d854554c8	9d66fbf2-a48d-4d65-b8e9-afb5ed7dfcf8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":140,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:53:12
21109	9d6734bb-36ae-4ef5-b344-e5c03b9564c2	9d6734bb-3c2f-4d98-a76d-490d85e0d90f	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:197","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-03 15:31:58","item_loans_cuando_pago":"03-11-2024","itemloans_cuota_cancelada":"200000"},"hostname":"EderCortes"}	2024-11-03 15:31:58
6118	9d525839-f691-4254-a56c-a984831a3238	9d52583a-4178-4fd6-bc6b-a15a79f5e0a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 06:38:50
6119	9d52583a-3742-4bdf-9115-528c7a091399	9d52583a-4178-4fd6-bc6b-a15a79f5e0a2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"updated_at\\", \\"created_at\\") values ('Luis andre', 'Herrera', 'MArtinez', 'CC', '100465545', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '500000', 25, 6, 'S', null, 'Thu Oct 24 2024', 'Pendiente', 12, 14, 14, '2024-10-24 06:38:50', '2024-10-24 06:38:50') returning \\"id\\"","time":"4.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":77,"hash":"18efcd076c06e51570dcc83643e19328","hostname":"EderCortes"}	2024-10-24 06:38:50
6120	9d52583a-379b-40e9-8044-9d3edadeb29d	9d52583a-4178-4fd6-bc6b-a15a79f5e0a2	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:9","hostname":"EderCortes"}	2024-10-24 06:38:50
6121	9d52583a-38f0-4dbd-8255-177b07cd659c	9d52583a-4178-4fd6-bc6b-a15a79f5e0a2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (9, 1, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:50', '2024-10-24 06:38:50')","time":"2.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:50
6122	9d52583a-392d-4d47-9b6a-a4462f534ada	9d52583a-4178-4fd6-bc6b-a15a79f5e0a2	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:50
6123	9d52583a-3991-41b9-9493-199313c5f3ad	9d52583a-4178-4fd6-bc6b-a15a79f5e0a2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (9, 2, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:50', '2024-10-24 06:38:50')","time":"0.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:50
6124	9d52583a-39b4-460a-820a-716f2669e9c6	9d52583a-4178-4fd6-bc6b-a15a79f5e0a2	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:50
6125	9d52583a-3a19-40b5-824e-e83797ede3d8	9d52583a-4178-4fd6-bc6b-a15a79f5e0a2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (9, 3, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:50', '2024-10-24 06:38:50')","time":"0.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:50
6126	9d52583a-3a38-41fe-9f19-b5003c057a2e	9d52583a-4178-4fd6-bc6b-a15a79f5e0a2	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:50
6127	9d52583a-3aa4-4806-b27c-1e8bdbc3595a	9d52583a-4178-4fd6-bc6b-a15a79f5e0a2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (9, 4, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:50', '2024-10-24 06:38:50')","time":"0.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:50
6128	9d52583a-3ac8-498b-a3e9-e023d24fbb7d	9d52583a-4178-4fd6-bc6b-a15a79f5e0a2	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:50
6129	9d52583a-3b40-4d40-840f-21db56769952	9d52583a-4178-4fd6-bc6b-a15a79f5e0a2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (9, 5, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:50', '2024-10-24 06:38:50')","time":"0.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:50
6130	9d52583a-3b6b-4715-8af2-f25b2c3857b1	9d52583a-4178-4fd6-bc6b-a15a79f5e0a2	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:50
6131	9d52583a-3bd6-4818-b8cd-f24affce33e3	9d52583a-4178-4fd6-bc6b-a15a79f5e0a2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (9, 6, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:50', '2024-10-24 06:38:50')","time":"0.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:50
6132	9d52583a-3bf7-48a1-9b29-29d3561c2878	9d52583a-4178-4fd6-bc6b-a15a79f5e0a2	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:50
6133	9d52583a-3ffc-42d2-be68-ca7fed0ac6f9	9d52583a-4178-4fd6-bc6b-a15a79f5e0a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 06:38:50
6422	9d526c82-6fec-496c-81f1-bb9f6635c4a4	9d526c82-9336-41aa-a89a-220e20be2b33	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 07:35:33
6768	9d52d542-ce5a-45d1-b419-457f467ad0d1	9d52d542-ed5c-4d1a-923a-e6d133135f9e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:28:28
6769	9d52d542-e860-4be1-87ff-60e8c10d6a04	9d52d542-ed5c-4d1a-923a-e6d133135f9e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:28:28
6770	9d52d542-e8a8-4d0f-ade7-0925be5e385f	9d52d542-ed5c-4d1a-923a-e6d133135f9e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:28:28
14891	9d5ec595-a6ad-40b8-9684-5338eb81b20a	9d5ec595-aa3d-401c-8fe0-3c34e3404526	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":174,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:54:34
6134	9d52583a-404c-43df-9a74-5fe058cb538b	9d52583a-4178-4fd6-bc6b-a15a79f5e0a2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"615","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":"100465545","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"500000","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_cobrador":14,"user_customer":14},"detail":{"status":false,"observacion":"N\\/A","fecha_pago":"Thu Oct 24 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":9},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:38:50
3732	9d511764-1bf3-4971-a49d-6c62b1bc9f85	9d511764-8797-43d3-9275-53039c7dd241	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 15:41:43
3733	9d511764-8397-42f0-913d-7f27ece4159b	9d511764-8797-43d3-9275-53039c7dd241	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 15:41:43
3734	9d511764-8512-4adb-bde4-a5b50e66e6eb	9d511764-8797-43d3-9275-53039c7dd241	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":868,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:41:43
6771	9d52d542-ec2c-4e70-94df-6f6ed1feb9e4	9d52d542-ed5c-4d1a-923a-e6d133135f9e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:28:28
6423	9d526c82-8b97-4334-9e25-f6eb8d5c3cca	9d526c82-9336-41aa-a89a-220e20be2b33	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"51.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-24 07:35:33
6424	9d526c82-90c7-4259-8013-d63a432be0b9	9d526c82-9336-41aa-a89a-220e20be2b33	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 07:35:33
20763	9d66fbf3-5692-4792-866e-ebd76eeeab37	9d66fbf3-a16a-4478-a69b-4939bf6ec993	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-03 12:53:12
20764	9d66fbf3-9666-4ac3-891e-2005cacf2c1f	9d66fbf3-a16a-4478-a69b-4939bf6ec993	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 186 limit 1","time":"2.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-03 12:53:12
20765	9d66fbf3-96ac-49f6-a37b-a0b8747a1945	9d66fbf3-a16a-4478-a69b-4939bf6ec993	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-03 12:53:12
20766	9d66fbf3-9832-4335-90c0-f118a2c22090	9d66fbf3-a16a-4478-a69b-4939bf6ec993	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 61 limit 1","time":"2.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 12:53:12
20767	9d66fbf3-9860-4a1f-a579-bd46c8431279	9d66fbf3-a16a-4478-a69b-4939bf6ec993	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 12:53:12
20768	9d66fbf3-9c61-4806-9998-f5f328cb675a	9d66fbf3-a16a-4478-a69b-4939bf6ec993	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '03-11-2024', \\"updated_at\\" = '2024-11-03 12:53:12' where \\"id\\" = 186","time":"8.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":395,"hash":"cb8c905b1add33801ee8a8e2c18e7fc3","hostname":"EderCortes"}	2024-11-03 12:53:12
20769	9d66fbf3-9cc8-4658-abce-c678aa23e704	9d66fbf3-a16a-4478-a69b-4939bf6ec993	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:186","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-03 12:53:12","item_loans_cuando_pago":"03-11-2024"},"hostname":"EderCortes"}	2024-11-03 12:53:12
20770	9d66fbf3-9d66-4feb-8cfa-1228864c06e5	9d66fbf3-a16a-4478-a69b-4939bf6ec993	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_estado\\" = 'Cancelado', \\"loans_pago_prestado\\" = 500000, \\"updated_at\\" = '2024-11-03 12:53:12' where \\"id\\" = 61","time":"0.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":403,"hash":"172897c81be4f4581f2a5ef11a457edb","hostname":"EderCortes"}	2024-11-03 12:53:12
20771	9d66fbf3-9d9a-41f7-b408-5b20068d5676	9d66fbf3-a16a-4478-a69b-4939bf6ec993	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:61","changes":{"loans_estado":"Cancelado","updated_at":"2024-11-03 12:53:12","loans_pago_prestado":500000},"hostname":"EderCortes"}	2024-11-03 12:53:12
20772	9d66fbf3-a041-471d-8175-338bc28464b1	9d66fbf3-a16a-4478-a69b-4939bf6ec993	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-03 12:53:12
6135	9d52583b-d053-4823-bc71-4bca326155ea	9d52583b-d41e-487a-b6e9-b1c0c7227bbb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":157,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:38:51
3162	9d510313-eade-453c-a7cc-f872b69dd1ab	9d510314-5c6e-4514-928d-1d82d1a43570	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 14:44:55
3163	9d510314-5927-4d42-88f4-fd334a99cbca	9d510314-5c6e-4514-928d-1d82d1a43570	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 14:44:55
3164	9d510314-5ac3-4462-84ca-511632e130ab	9d510314-5c6e-4514-928d-1d82d1a43570	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":694,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:44:55
6425	9d526c82-913f-453e-932c-f2c7ccdc5700	9d526c82-9336-41aa-a89a-220e20be2b33	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":306,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:35:33
6772	9d52d542-ec6f-4c19-b58c-b7cb093016ce	9d52d542-ed5c-4d1a-923a-e6d133135f9e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:28:28
14892	9d5ec596-600b-4f90-b069-348074ccb781	9d5ec596-8881-4a4f-8471-cbb00d9b9c31	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-30 10:54:34
14893	9d5ec596-78ff-4b56-9303-ddb75859605d	9d5ec596-8881-4a4f-8471-cbb00d9b9c31	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta', 'De las nieve', 'ds', 'CC', '100465546', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '500000', 50, 5, 'S', null, '30-10-2024', 'Pendiente', '312596295', 12, 14, 18, 14, '30-10-2024', '2024-10-30 10:54:34', '2024-10-30 10:54:34') returning \\"id\\"","time":"5.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":104,"hash":"bfad4cea82a73099ff0b3164dd496ca0","hostname":"EderCortes"}	2024-10-30 10:54:34
14894	9d5ec596-796d-4f9d-88a2-141b23dd747c	9d5ec596-8881-4a4f-8471-cbb00d9b9c31	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:58","hostname":"EderCortes"}	2024-10-30 10:54:34
14895	9d5ec596-7acc-4fb3-96de-a0ed4b056c58	9d5ec596-8881-4a4f-8471-cbb00d9b9c31	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (58, 1, 100000, 50000, 'Pendiente', 'N\\/A', '06-11-2024', 12, '2024-10-30 10:54:34', '2024-10-30 10:54:34')","time":"2.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 10:54:34
14896	9d5ec596-7af9-44be-ade8-044aa8a239bf	9d5ec596-8881-4a4f-8471-cbb00d9b9c31	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 10:54:34
14897	9d5ec596-7b81-4f1d-9ad0-43959c80c3a1	9d5ec596-8881-4a4f-8471-cbb00d9b9c31	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (58, 2, 100000, 50000, 'Pendiente', 'N\\/A', '13-11-2024', 12, '2024-10-30 10:54:34', '2024-10-30 10:54:34')","time":"0.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 10:54:34
14898	9d5ec596-7bba-419f-9dab-3d2af206f0de	9d5ec596-8881-4a4f-8471-cbb00d9b9c31	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 10:54:34
14899	9d5ec596-7c2b-4ee9-a91c-e14194a6825d	9d5ec596-8881-4a4f-8471-cbb00d9b9c31	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (58, 3, 100000, 50000, 'Pendiente', 'N\\/A', '20-11-2024', 12, '2024-10-30 10:54:34', '2024-10-30 10:54:34')","time":"0.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 10:54:34
3165	9d510314-fe7b-45d8-8230-8dfc7b8205c5	9d510315-445c-4d73-a5a8-f712066baf19	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 14:44:56
3166	9d510315-3aa1-44b4-b713-8fc333f2bae6	9d510315-445c-4d73-a5a8-f712066baf19	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"70.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:44:56
3167	9d510315-3b33-4616-9095-ea66848e08dc	9d510315-445c-4d73-a5a8-f712066baf19	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:44:56
3168	9d510315-4277-48ba-8d76-648848c76280	9d510315-445c-4d73-a5a8-f712066baf19	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 14:44:56
3169	9d510315-42f2-40af-b023-0a8fde183ae1	9d510315-445c-4d73-a5a8-f712066baf19	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":553,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:44:56
3735	9d511764-f0ba-4469-b88c-61abe3584e65	9d511765-442d-4fc0-850a-08649b46ca58	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 15:41:44
3736	9d511765-3b59-4230-b9ae-3ae0d0ccfb9f	9d511765-442d-4fc0-850a-08649b46ca58	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"162.45","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:41:44
3737	9d511765-3ba8-4a9d-944a-6097e5b74aec	9d511765-442d-4fc0-850a-08649b46ca58	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 15:41:44
3738	9d511765-42a8-41a3-ba95-4a0c2f30841c	9d511765-442d-4fc0-850a-08649b46ca58	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 15:41:44
3739	9d511765-42e9-47d4-b051-2cf32e00cde9	9d511765-442d-4fc0-850a-08649b46ca58	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":419,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:41:44
6136	9d52583c-8933-4442-8c75-c31a35714d98	9d52583c-d434-488d-878a-161f2b352bea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 06:38:52
6137	9d52583c-ca24-409a-b1ee-5a11c459d121	9d52583c-d434-488d-878a-161f2b352bea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"updated_at\\", \\"created_at\\") values ('Luis andre', 'Herrera', 'MArtinez', 'CC', '100465545', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '500000', 25, 6, 'S', null, 'Thu Oct 24 2024', 'Pendiente', 12, 14, 14, '2024-10-24 06:38:52', '2024-10-24 06:38:52') returning \\"id\\"","time":"4.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":77,"hash":"18efcd076c06e51570dcc83643e19328","hostname":"EderCortes"}	2024-10-24 06:38:52
6138	9d52583c-ca7c-4427-aa8d-1483b612175b	9d52583c-d434-488d-878a-161f2b352bea	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:10","hostname":"EderCortes"}	2024-10-24 06:38:52
6139	9d52583c-cbba-475e-8ffd-ab8c6ab522e9	9d52583c-d434-488d-878a-161f2b352bea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (10, 1, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:52', '2024-10-24 06:38:52')","time":"2.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:52
6140	9d52583c-cbe6-48f7-aec1-1c83d96ed628	9d52583c-d434-488d-878a-161f2b352bea	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:52
6141	9d52583c-cc55-4a34-986d-a282cfcfec0b	9d52583c-d434-488d-878a-161f2b352bea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (10, 2, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:52', '2024-10-24 06:38:52')","time":"0.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:52
6142	9d52583c-cc78-4b34-8699-3711aafd3129	9d52583c-d434-488d-878a-161f2b352bea	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:52
14900	9d5ec596-7c4f-44b5-9513-43a7b7a2da48	9d5ec596-8881-4a4f-8471-cbb00d9b9c31	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 10:54:34
3170	9d510315-d32a-4ae2-8d05-1a1d0460daf7	9d510316-1a39-4df0-9b08-eb88f95a9433	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 14:44:56
3171	9d510316-0f5c-4cd5-85e7-9c1b72a45c79	9d510316-1a39-4df0-9b08-eb88f95a9433	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"89.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:44:56
3172	9d510316-0ff8-4af2-b90d-e70d71199f54	9d510316-1a39-4df0-9b08-eb88f95a9433	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:44:56
3173	9d510316-17e4-4cd0-9402-b5818e54151f	9d510316-1a39-4df0-9b08-eb88f95a9433	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 14:44:56
3174	9d510316-1871-4b65-ae54-bda41dff2c6e	9d510316-1a39-4df0-9b08-eb88f95a9433	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":525,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:44:56
3740	9d511765-89eb-408e-bf89-721804f647db	9d511765-a898-4683-9139-f92c21371294	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 15:41:44
3741	9d511765-a335-49bd-89f3-ff255f17e8e9	9d511765-a898-4683-9139-f92c21371294	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:41:44
3742	9d511765-a380-48e3-941f-6284bb691f08	9d511765-a898-4683-9139-f92c21371294	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 15:41:44
3743	9d511765-a790-4771-99d4-6d196af1db1b	9d511765-a898-4683-9139-f92c21371294	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 15:41:44
3744	9d511765-a7d5-43eb-9c0a-142e789a7ac6	9d511765-a898-4683-9139-f92c21371294	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:41:44
6143	9d52583c-ccf6-466c-96ba-a759adbacb36	9d52583c-d434-488d-878a-161f2b352bea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (10, 3, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:52', '2024-10-24 06:38:52')","time":"0.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:52
6144	9d52583c-cd2b-441f-87d3-ac86c6033438	9d52583c-d434-488d-878a-161f2b352bea	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:52
6145	9d52583c-cdc6-4220-ad79-3fb9d762db1b	9d52583c-d434-488d-878a-161f2b352bea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (10, 4, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:52', '2024-10-24 06:38:52')","time":"0.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:52
6146	9d52583c-cdfb-431c-9a2c-95dcec373cef	9d52583c-d434-488d-878a-161f2b352bea	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:52
6147	9d52583c-ce96-4dda-b909-c6b2494ce6b1	9d52583c-d434-488d-878a-161f2b352bea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (10, 5, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:52', '2024-10-24 06:38:52')","time":"0.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:52
6148	9d52583c-cec5-470c-bea7-0c660b5a0dd7	9d52583c-d434-488d-878a-161f2b352bea	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:52
3175	9d510316-d64e-4ac5-89d9-de6fddc917f9	9d510317-4ba1-464f-8f58-6c5a9f9f4460	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 14:44:57
3176	9d510317-3e92-4b88-884b-2f1280ba5619	9d510317-4ba1-464f-8f58-6c5a9f9f4460	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"215.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:44:57
3177	9d510317-3f20-446f-8afc-bdce3ec2b1c1	9d510317-4ba1-464f-8f58-6c5a9f9f4460	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:44:57
3178	9d510317-4909-4d13-b1d1-65174f94f881	9d510317-4ba1-464f-8f58-6c5a9f9f4460	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 14:44:57
3179	9d510317-49aa-40eb-b4dc-18e423c0515c	9d510317-4ba1-464f-8f58-6c5a9f9f4460	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":760,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:44:57
6149	9d52583c-cf41-46f1-b0c1-196585abc8aa	9d52583c-d434-488d-878a-161f2b352bea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (10, 6, 83333.333333333, 10416.666666667, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:38:52', '2024-10-24 06:38:52')","time":"0.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:38:52
6150	9d52583c-cf66-4948-8b8b-2519bf2298bb	9d52583c-d434-488d-878a-161f2b352bea	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:38:52
6151	9d52583c-d2dc-488a-aebe-c882923e0ab3	9d52583c-d434-488d-878a-161f2b352bea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 06:38:52
6152	9d52583c-d31f-44d4-97a8-f3233c491979	9d52583c-d434-488d-878a-161f2b352bea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"615","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":"100465545","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"500000","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_cobrador":14,"user_customer":14},"detail":{"status":false,"observacion":"N\\/A","fecha_pago":"Thu Oct 24 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":10},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:38:52
6426	9d52d08a-2366-4c4d-8868-eaa996cd859a	9d52d08b-b93a-4188-a87e-59ff7424de93	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":12636,"memory":18,"hostname":"EderCortes"}	2024-10-24 12:15:16
14901	9d5ec596-7cbb-4f4d-9f1f-63f93dae5900	9d5ec596-8881-4a4f-8471-cbb00d9b9c31	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (58, 4, 100000, 50000, 'Pendiente', 'N\\/A', '27-11-2024', 12, '2024-10-30 10:54:34', '2024-10-30 10:54:34')","time":"0.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 10:54:34
14902	9d5ec596-7cdf-47ce-89b9-efec657e8647	9d5ec596-8881-4a4f-8471-cbb00d9b9c31	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 10:54:34
14903	9d5ec596-7d4d-4985-9ffb-66d310e9a263	9d5ec596-8881-4a4f-8471-cbb00d9b9c31	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (58, 5, 100000, 50000, 'Pendiente', 'N\\/A', '04-12-2024', 12, '2024-10-30 10:54:34', '2024-10-30 10:54:34')","time":"0.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 10:54:34
14904	9d5ec596-7d71-4e43-aff5-3eae91229495	9d5ec596-8881-4a4f-8471-cbb00d9b9c31	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 10:54:34
3180	9d510318-1ca6-4fb4-8487-6f0ac0ca566d	9d510318-971f-4728-8692-f0f95c0bd87d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 14:44:58
3181	9d510318-8914-4f0c-8588-2f13c391ec0f	9d510318-971f-4728-8692-f0f95c0bd87d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"201.81","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:44:58
3182	9d510318-89d4-418e-a31c-80cba2d98932	9d510318-971f-4728-8692-f0f95c0bd87d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:44:58
3183	9d510318-93ff-4c0f-9787-6a2f0a335262	9d510318-971f-4728-8692-f0f95c0bd87d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-23 14:44:58
3184	9d510318-94db-4d34-833e-e13dc76811ef	9d510318-971f-4728-8692-f0f95c0bd87d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":817,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:44:58
6427	9d52d08d-43d1-4a59-abae-13dfcf218334	9d52d08d-473f-41b6-8540-f27580662541	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":166,"memory":18,"hostname":"EderCortes"}	2024-10-24 12:15:17
14905	9d5ec596-8654-4946-b54a-6580c1126537	9d5ec596-8881-4a4f-8471-cbb00d9b9c31	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-30 10:54:34
14906	9d5ec596-86d7-4653-8385-441e3e201e1c	9d5ec596-8881-4a4f-8471-cbb00d9b9c31	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"743","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"100465546","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"500000","loans_intereses":50,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":18,"user_recomendacion":14,"loans_inicio_pago":"30-10-2024","created_at":null,"updated_at":null,"deleted_at":null},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Wed Oct 30 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":58},"duration":257,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:54:34
6904	9d52d747-2fbf-4e28-8b14-291f87f62e4d	9d52d747-5611-4d4a-a699-2705485dd28b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 12:34:06
6905	9d52d747-5453-4d6b-8524-5259d9d293f5	9d52d747-5611-4d4a-a699-2705485dd28b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:34:06
6906	9d52d747-550c-4460-92bd-6b50cf05a504	9d52d747-5611-4d4a-a699-2705485dd28b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":327,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:34:06
20820	9d66fc30-956c-45c0-a21c-1d6bed13dc1d	9d66fc30-9653-4544-b1d8-90d56099d9f5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":207,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:53:52
21110	9d6734bb-37c2-4709-a7b4-ce73fe2b965c	9d6734bb-3c2f-4d98-a76d-490d85e0d90f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_fecha_ultimo_pago\\" = '03-11-2024', \\"loans_pago_prestado\\" = 200000, \\"updated_at\\" = '2024-11-03 15:31:58' where \\"id\\" = 64","time":"1.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":403,"hash":"2651c9628a20198b0b14e62296a9274e","hostname":"EderCortes"}	2024-11-03 15:31:58
21111	9d6734bb-37f6-47b4-833f-c99f80ea43d8	9d6734bb-3c2f-4d98-a76d-490d85e0d90f	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:64","changes":{"updated_at":"2024-11-03 15:31:58","loans_fecha_ultimo_pago":"03-11-2024","loans_pago_prestado":200000},"hostname":"EderCortes"}	2024-11-03 15:31:58
6428	9d52d09d-fd5c-4f49-928b-033f23389cfb	9d52d09e-00a7-414c-8c88-ca21de052992	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":153,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:15:28
6907	9d52d747-af8d-4c3e-aa51-b6363e39bc51	9d52d747-cded-4fc2-9334-5402129f2527	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:34:06
4760	9d5134fe-909e-4a7f-874d-741b3ba3886f	9d5134fe-c415-4465-9688-2bebb65cda24	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 17:04:30
4761	9d5134fe-c195-47ce-ae19-9d1ede44679d	9d5134fe-c415-4465-9688-2bebb65cda24	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 17:04:30
2654	9d50fb08-d771-4191-96f6-ab8b51313ff0	9d50fb09-98d1-464a-98db-87dc51d06eda	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-23 14:22:26
2655	9d50fb09-961f-491b-b6d3-ff754d76922c	9d50fb09-98d1-464a-98db-87dc51d06eda	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-23 14:22:26
2656	9d50fb09-972b-44e0-962c-c6bb5a1826c8	9d50fb09-98d1-464a-98db-87dc51d06eda	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1025,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:22:26
4762	9d5134fe-c2a7-4a97-ac33-b6801749fda8	9d5134fe-c415-4465-9688-2bebb65cda24	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":484,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:04:30
4919	9d513650-1335-41cd-bf0a-c484a521c770	9d513650-4119-4630-8ecf-4933833b0ba5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 17:08:11
4920	9d513650-3ec0-45b2-a0b4-5ac6049bf403	9d513650-4119-4630-8ecf-4933833b0ba5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 17:08:11
4921	9d513650-3fbc-495c-bb97-0a393bc337a1	9d513650-4119-4630-8ecf-4933833b0ba5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":383,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:11
6908	9d52d747-c873-4370-98ec-81be92de00f3	9d52d747-cded-4fc2-9334-5402129f2527	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:34:06
6909	9d52d747-c8c4-452c-9bb6-e82ccf6918c0	9d52d747-cded-4fc2-9334-5402129f2527	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:34:06
6910	9d52d747-ccd1-4da5-aace-84a861aa959d	9d52d747-cded-4fc2-9334-5402129f2527	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:34:06
6911	9d52d747-cd18-4dd9-8c41-cadb7ce8f0e5	9d52d747-cded-4fc2-9334-5402129f2527	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":277,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:34:06
20821	9d66fc30-d5eb-4680-ab00-9bfa0d5a75e5	9d66fc31-1d04-47d4-ad85-8cf82d42814d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 12:53:52
20822	9d66fc31-18fd-4169-8e11-241015a0219e	9d66fc31-1d04-47d4-ad85-8cf82d42814d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAr%' or \\"users\\".\\"user_document\\"::text like '%MAr%') order by \\"users\\".\\"user_document\\" asc","time":"155.04","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 12:53:53
14907	9d5ec59b-4b7b-48bc-a8cd-e0f254629dda	9d5ec59b-4f5f-4172-8475-fbb129b39b68	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":206,"memory":20,"hostname":"EderCortes"}	2024-10-30 10:54:37
20823	9d66fc31-1bd7-4c22-b395-e1e0e9b39632	9d66fc31-1d04-47d4-ad85-8cf82d42814d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 12:53:53
20824	9d66fc31-1c1a-47af-b071-f49866f11e2f	9d66fc31-1d04-47d4-ad85-8cf82d42814d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAr"},"session":[],"response_status":200,"response":{"data":[]},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:53:53
21112	9d6734bb-3ae7-4e5f-80dd-e520dff20e4c	9d6734bb-3c2f-4d98-a76d-490d85e0d90f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:31:58
23340	9d689473-a1eb-4259-90b2-d8f9bc492520	9d689473-aae9-41d3-b239-6d4cfb988d2b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 527500, \\"loans_pago_prestado\\" = 2110000, \\"updated_at\\" = '2024-11-04 07:55:27' where \\"id\\" = 70","time":"0.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":556,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 07:55:27
2657	9d50fb0a-3bc6-49d2-94e9-6739918d6512	9d50fb0a-7462-446f-8893-3dab0bad918d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-23 14:22:26
2658	9d50fb0a-6a7b-40d3-b4c8-27ea8a9e7da3	9d50fb0a-7462-446f-8893-3dab0bad918d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"75.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:22:27
2659	9d50fb0a-6b27-4d4a-b04f-df16b6cc6aa5	9d50fb0a-7462-446f-8893-3dab0bad918d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:22:27
2660	9d50fb0a-7220-4dd7-9c17-9cd6636b3de8	9d50fb0a-7462-446f-8893-3dab0bad918d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-10-23 14:22:27
2661	9d50fb0a-72d9-405b-99e9-b8d48a565ff5	9d50fb0a-7462-446f-8893-3dab0bad918d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":519,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:22:27
4763	9d5134ff-48c0-492a-9143-6cfa5d4318f2	9d5134ff-a1b2-44fa-b7d1-31eae2569637	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 17:04:30
4764	9d5134ff-984a-4e59-8062-7b8d214765f7	9d5134ff-a1b2-44fa-b7d1-31eae2569637	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"168.88","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:04:30
4765	9d5134ff-98db-40c5-89dd-845ef45c7061	9d5134ff-a1b2-44fa-b7d1-31eae2569637	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:04:30
3836	9d511a4e-17a4-477d-aea1-46ad2d0ce344	9d511a4e-5ac9-40cb-a889-b183f0cf8179	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 15:49:52
4766	9d5134ff-9f95-44c7-a9b1-52c0dd800538	9d5134ff-a1b2-44fa-b7d1-31eae2569637	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 17:04:30
4767	9d5134ff-a055-4712-a0ce-3e635491b9cf	9d5134ff-a1b2-44fa-b7d1-31eae2569637	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":530,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:04:30
4922	9d513650-c1c4-4c61-81fd-53fd302e92ec	9d513650-f3db-4627-ad0b-ce7ccce53bb3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 17:08:11
4923	9d513650-eb3a-4516-9866-6b531c9cc2a7	9d513650-f3db-4627-ad0b-ce7ccce53bb3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"66.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:08:11
4924	9d513650-ebd9-4c73-94aa-f41587974a62	9d513650-f3db-4627-ad0b-ce7ccce53bb3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:08:11
4925	9d513650-f1e8-4ba6-80e2-67eae3089f69	9d513650-f3db-4627-ad0b-ce7ccce53bb3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-23 17:08:11
4926	9d513650-f277-4df7-8255-6a80c44b1758	9d513650-f3db-4627-ad0b-ce7ccce53bb3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":421,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:11
6429	9d52d09e-5cf1-4112-99b4-b09194758aa7	9d52d09e-984d-4fb9-a622-b5ffcbe0ac81	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:15:29
6430	9d52d09e-7cf1-4b3d-b2d3-cf37365e2dad	9d52d09e-984d-4fb9-a622-b5ffcbe0ac81	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"45.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-24 12:15:29
6431	9d52d09e-7d49-447b-ac0a-716bdc34ba37	9d52d09e-984d-4fb9-a622-b5ffcbe0ac81	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:15:29
6432	9d52d09e-9695-4927-b205-676ebcddfcf0	9d52d09e-984d-4fb9-a622-b5ffcbe0ac81	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:15:29
2662	9d50fb0a-ed58-4ad4-a578-150dbbd38718	9d50fb0b-2691-48b0-a422-c57e4386e082	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-10-23 14:22:27
2663	9d50fb0b-1f29-4d9e-95c5-dc526f84bb5e	9d50fb0b-2691-48b0-a422-c57e4386e082	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"68.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:22:27
2664	9d50fb0b-1fab-4e65-94f2-0861def93ccb	9d50fb0b-2691-48b0-a422-c57e4386e082	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:22:27
2665	9d50fb0b-24af-4d78-85e4-ee18ecd025f3	9d50fb0b-2691-48b0-a422-c57e4386e082	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-10-23 14:22:27
2666	9d50fb0b-2540-4326-9dc1-22fdfd2bc8d3	9d50fb0b-2691-48b0-a422-c57e4386e082	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":432,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:22:27
3837	9d511a4e-5790-4ba0-af6a-06b3a5d986bf	9d511a4e-5ac9-40cb-a889-b183f0cf8179	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 15:49:52
3838	9d511a4e-5922-4abb-8fb3-7718771e1d0d	9d511a4e-5ac9-40cb-a889-b183f0cf8179	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":561,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:49:52
4768	9d513500-1497-46b1-b2e7-e52e8f5d3e12	9d513500-62d3-4ba9-b144-ed868386b2f3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 17:04:31
4769	9d513500-5c96-45c5-bdea-4137f9fbf6ae	9d513500-62d3-4ba9-b144-ed868386b2f3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"147.98","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:04:31
4770	9d513500-5cfd-4817-ba5a-1edbd4e643a3	9d513500-62d3-4ba9-b144-ed868386b2f3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:04:31
4771	9d513500-6127-42e9-8fd1-21cf8e9ad85c	9d513500-62d3-4ba9-b144-ed868386b2f3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 17:04:31
4772	9d513500-6193-45d4-86aa-5d044ee85c34	9d513500-62d3-4ba9-b144-ed868386b2f3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":472,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:04:31
4927	9d513651-e4ba-41f4-a741-78732c0de774	9d513652-2edb-4e0a-ad2c-45af203f32f8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-23 17:08:12
4928	9d513652-24c0-4d2b-b29b-5a55cd896e55	9d513652-2edb-4e0a-ad2c-45af203f32f8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"92.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:08:12
4929	9d513652-2555-41ba-b824-cd891accc6ec	9d513652-2edb-4e0a-ad2c-45af203f32f8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:08:12
4930	9d513652-2ccb-499e-9ba8-26c20c6e62cd	9d513652-2edb-4e0a-ad2c-45af203f32f8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-23 17:08:12
6433	9d52d09e-96f3-4c1b-b773-0f211cb3c481	9d52d09e-984d-4fb9-a622-b5ffcbe0ac81	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"78","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":302,"memory":24,"hostname":"EderCortes"}	2024-10-24 12:15:29
2667	9d50fb0b-cb58-497c-9a0f-11df328f0862	9d50fb0c-1e32-4b4d-8289-f21b6267a88e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-10-23 14:22:28
2668	9d50fb0c-10df-4265-bc2f-02b2a1417047	9d50fb0c-1e32-4b4d-8289-f21b6267a88e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"121.92","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:22:28
2669	9d50fb0c-1185-4535-9cac-d204a3017d12	9d50fb0c-1e32-4b4d-8289-f21b6267a88e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:22:28
2670	9d50fb0c-1c00-494b-810a-34f7e22f89fe	9d50fb0c-1e32-4b4d-8289-f21b6267a88e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-10-23 14:22:28
2671	9d50fb0c-1cae-4363-9502-c03b7d15176d	9d50fb0c-1e32-4b4d-8289-f21b6267a88e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":614,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:22:28
3839	9d511a4e-dd4b-4c9b-aa01-89e38036f296	9d511a4f-3697-4fdb-9892-68c386aba0c7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 15:49:52
3840	9d511a4f-2f4a-4f04-a388-85c4f20f0a14	9d511a4f-3697-4fdb-9892-68c386aba0c7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"169.20","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:49:53
3841	9d511a4f-2fc4-4cbe-83a6-4f19a3d8cedf	9d511a4f-3697-4fdb-9892-68c386aba0c7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 15:49:53
3842	9d511a4f-3501-4793-8ade-199604ecd7ed	9d511a4f-3697-4fdb-9892-68c386aba0c7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 15:49:53
3843	9d511a4f-356d-4af0-a86f-b7e6c4ce84b3	9d511a4f-3697-4fdb-9892-68c386aba0c7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":520,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:49:53
4773	9d513501-2ff0-488a-a3b5-6bd8d518ce7c	9d513501-b7cf-4541-bb49-04dbdf954cc2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 17:04:31
4774	9d513501-b05b-4641-8a50-0f7ce7b11ee9	9d513501-b7cf-4541-bb49-04dbdf954cc2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"194.56","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:04:32
4775	9d513501-b0e5-476d-bef4-9e88d8cb408b	9d513501-b7cf-4541-bb49-04dbdf954cc2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:04:32
4776	9d513501-b5f8-4636-9795-42f8ed8c4b2a	9d513501-b7cf-4541-bb49-04dbdf954cc2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 17:04:32
4777	9d513501-b673-46e1-aa01-a36092a93921	9d513501-b7cf-4541-bb49-04dbdf954cc2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":858,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:04:32
6912	9d52d748-1095-49d3-ad0c-0ccb54503d51	9d52d748-5b34-4593-882c-4d18eef202fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:34:07
14908	9d5ec59c-02c2-4549-97f4-159ef7c90fd4	9d5ec59c-4d9e-4f9c-887b-0dc867a3a6e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-30 10:54:38
20825	9d66fc31-6142-44f7-a68f-7d06007f8927	9d66fc31-7c67-4e1a-977a-35d32070912a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 12:53:53
2672	9d50fb0c-c840-4a3a-bcde-a3a9ee4d86ed	9d50fb0c-fffc-4bce-be72-ddf35aa20cf1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-10-23 14:22:28
2673	9d50fb0c-f7ec-46b2-b1d7-3eeba4650a32	9d50fb0c-fffc-4bce-be72-ddf35aa20cf1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"84.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:22:28
2674	9d50fb0c-f877-4a1d-b554-e33535c920a0	9d50fb0c-fffc-4bce-be72-ddf35aa20cf1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:22:28
2675	9d50fb0c-fe12-44e8-abdb-79d16ec900fd	9d50fb0c-fffc-4bce-be72-ddf35aa20cf1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-10-23 14:22:28
2676	9d50fb0c-fe8c-4e6e-99a0-02ea72e578ff	9d50fb0c-fffc-4bce-be72-ddf35aa20cf1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":547,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:22:28
3844	9d511a4f-9eb7-43e1-85f9-98b4c104d253	9d511a4f-c06a-4ef4-aff4-7d07e7be69af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 15:49:53
3845	9d511a4f-baa1-41ef-aa6d-0fb5d92935ec	9d511a4f-c06a-4ef4-aff4-7d07e7be69af	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:49:53
3846	9d511a4f-baec-4599-a6a6-87d5fc8431e6	9d511a4f-c06a-4ef4-aff4-7d07e7be69af	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 15:49:53
3847	9d511a4f-bf20-423c-a1b7-e65638032d35	9d511a4f-c06a-4ef4-aff4-7d07e7be69af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 15:49:53
3848	9d511a4f-bf63-4f92-9f94-04c0d549375b	9d511a4f-c06a-4ef4-aff4-7d07e7be69af	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:49:53
4778	9d513502-3838-4785-945a-a2d6b086a001	9d513502-58e2-436b-a409-7ba59b58f7cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 17:04:32
4779	9d513502-536a-4ea0-aeec-9e184bac5895	9d513502-58e2-436b-a409-7ba59b58f7cd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"49.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:04:32
4780	9d513502-53ca-4a38-9588-073e27daa5c7	9d513502-58e2-436b-a409-7ba59b58f7cd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:04:32
4781	9d513502-5791-4d28-aa73-d22775fe059f	9d513502-58e2-436b-a409-7ba59b58f7cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 17:04:32
4782	9d513502-57d7-4e9f-a376-1831aa9f871e	9d513502-58e2-436b-a409-7ba59b58f7cd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":395,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:04:32
3849	9d511a50-52d9-4f01-b647-784140fddb65	9d511a50-9439-49f2-a8c0-404964e1533f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 15:49:53
3850	9d511a50-8915-46b3-aa87-a9f6da9fa563	9d511a50-9439-49f2-a8c0-404964e1533f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"83.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 15:49:53
3851	9d511a50-89ac-4d0c-94b1-cb1981515ba5	9d511a50-9439-49f2-a8c0-404964e1533f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 15:49:53
3852	9d511a50-91e5-4e6c-99f3-049188dd40e0	9d511a50-9439-49f2-a8c0-404964e1533f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 15:49:53
3853	9d511a50-9271-48bc-ad77-28487935abb8	9d511a50-9439-49f2-a8c0-404964e1533f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":524,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:49:53
4783	9d513516-a90e-41f2-bb68-31a8d2f2a666	9d513516-ac48-41bb-a826-f306fc75581d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":154,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:04:45
4931	9d513652-2d65-4754-a4d7-2172c3fb6fb1	9d513652-2edb-4e0a-ad2c-45af203f32f8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":780,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:12
6434	9d52d0a9-3145-4336-8eae-2f6add12902a	9d52d0a9-3466-408c-86b2-a11f633e28c7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":145,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:15:36
6913	9d52d748-55be-45c2-b76c-618db2de257f	9d52d748-5b34-4593-882c-4d18eef202fb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"154.55","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:34:07
6914	9d52d748-5617-4788-85a0-1faec45d9661	9d52d748-5b34-4593-882c-4d18eef202fb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:34:07
6915	9d52d748-5a23-4f08-bf1f-bb956918b9ff	9d52d748-5b34-4593-882c-4d18eef202fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:34:07
14909	9d5ec59c-43da-4bf3-bfa1-06065b46fca2	9d5ec59c-4d9e-4f9c-887b-0dc867a3a6e1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta', 'De las nieve', 'ds', 'CC', '100465546', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '500000', 50, 5, 'S', null, '30-10-2024', 'Pendiente', '312596295', 12, 14, 18, 14, '30-10-2024', '2024-10-30 10:54:38', '2024-10-30 10:54:38') returning \\"id\\"","time":"4.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":104,"hash":"bfad4cea82a73099ff0b3164dd496ca0","hostname":"EderCortes"}	2024-10-30 10:54:38
3854	9d511a51-28a5-4164-b6fe-2e92a3c05060	9d511a51-5c70-41ba-a0d3-19bfb13b7154	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 15:49:54
3855	9d511a51-516e-4f23-8016-e65674dd3b86	9d511a51-5c70-41ba-a0d3-19bfb13b7154	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"69.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 15:49:54
3856	9d511a51-51f7-426c-8da3-6885223a3f0f	9d511a51-5c70-41ba-a0d3-19bfb13b7154	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 15:49:54
3857	9d511a51-59f2-4931-92ae-a01be7679c99	9d511a51-5c70-41ba-a0d3-19bfb13b7154	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 15:49:54
3858	9d511a51-5a88-4949-8fec-d6349f6b62cf	9d511a51-5c70-41ba-a0d3-19bfb13b7154	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":484,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:49:54
4784	9d513517-0f16-4a5d-90f0-005f70d29afa	9d513517-2c43-4491-ba87-5887ba208d54	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 17:04:46
4785	9d513517-27b3-48f8-a5cd-a626e4b4be35	9d513517-2c43-4491-ba87-5887ba208d54	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"46.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":46,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 17:04:46
4786	9d513517-2ae9-4943-aa67-7559a55e0038	9d513517-2c43-4491-ba87-5887ba208d54	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 17:04:46
4787	9d513517-2b36-47e8-a429-58c9470be0ce	9d513517-2c43-4491-ba87-5887ba208d54	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:04:46
4932	9d513652-c821-4fe1-b12d-9e2d4672b8e4	9d513653-015f-4958-9b2b-10f1c0584d9c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-23 17:08:13
4933	9d513652-f732-4748-8bd4-59fb4af91761	9d513653-015f-4958-9b2b-10f1c0584d9c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"80.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:08:13
4934	9d513652-f7b9-4205-adc9-04651912e97e	9d513653-015f-4958-9b2b-10f1c0584d9c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:08:13
4935	9d513652-ff6e-4a3e-a6a0-bb5715f8323c	9d513653-015f-4958-9b2b-10f1c0584d9c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-23 17:08:13
4936	9d513652-fff9-4fed-8f3f-abae39ad05cd	9d513653-015f-4958-9b2b-10f1c0584d9c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":503,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:13
6435	9d52d0a9-e4cc-4fef-8b1c-ae4f3d302925	9d52d0aa-1b78-4d52-a895-2cbb933e44e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:15:36
14910	9d5ec59c-4435-4bdf-89d4-2554cbcbec6d	9d5ec59c-4d9e-4f9c-887b-0dc867a3a6e1	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:59","hostname":"EderCortes"}	2024-10-30 10:54:38
4788	9d51351a-6677-4d11-a955-8bada9948b1f	9d51351a-b241-4f7b-b10f-c7430961f20c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 17:04:48
4789	9d51351a-ac13-4562-86fd-2e751ee34ce9	9d51351a-b241-4f7b-b10f-c7430961f20c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null","time":"142.92","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":28,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-23 17:04:48
4790	9d51351a-ac8a-4e84-a630-fe1a56f3b0f9	9d51351a-b241-4f7b-b10f-c7430961f20c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:04:48
4791	9d51351a-b08c-43d1-be47-0ad02682ccf2	9d51351a-b241-4f7b-b10f-c7430961f20c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 17:04:48
4792	9d51351a-b0da-4690-9dc0-7b2cbd54bad1	9d51351a-b241-4f7b-b10f-c7430961f20c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null}]},"duration":375,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:04:48
6436	9d52d0aa-015f-40a2-93e2-7d5af71c3405	9d52d0aa-1b78-4d52-a895-2cbb933e44e3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"41.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-24 12:15:36
6437	9d52d0aa-01b2-4c3b-9bf3-3f8ee42a634e	9d52d0aa-1b78-4d52-a895-2cbb933e44e3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:15:36
6438	9d52d0aa-19dc-4e3c-9cfa-5567766beb23	9d52d0aa-1b78-4d52-a895-2cbb933e44e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:15:36
6439	9d52d0aa-1a23-412a-8476-57d92d155ca8	9d52d0aa-1b78-4d52-a895-2cbb933e44e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","profile":1},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":280,"memory":24,"hostname":"EderCortes"}	2024-10-24 12:15:36
6916	9d52d748-5a69-4494-a58e-2b301532b4b7	9d52d748-5b34-4593-882c-4d18eef202fb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:34:07
14911	9d5ec59c-45c4-4e04-8356-469fffdbcf49	9d5ec59c-4d9e-4f9c-887b-0dc867a3a6e1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (59, 1, 100000, 50000, 'Pendiente', 'N\\/A', '06-11-2024', 12, '2024-10-30 10:54:38', '2024-10-30 10:54:38')","time":"2.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 10:54:38
14912	9d5ec59c-45f1-4c0c-be80-e4826088b93d	9d5ec59c-4d9e-4f9c-887b-0dc867a3a6e1	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 10:54:38
14913	9d5ec59c-4664-485d-ab22-97624fb63824	9d5ec59c-4d9e-4f9c-887b-0dc867a3a6e1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (59, 2, 100000, 50000, 'Pendiente', 'N\\/A', '13-11-2024', 12, '2024-10-30 10:54:38', '2024-10-30 10:54:38')","time":"0.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 10:54:38
14914	9d5ec59c-4689-4813-b594-067e0fd86d97	9d5ec59c-4d9e-4f9c-887b-0dc867a3a6e1	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 10:54:38
6440	9d52d0aa-ce46-4d99-afe5-96b18ca8c30c	9d52d0ab-0d50-4f06-9075-c39d8d2524f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:15:37
6441	9d52d0ab-079b-4cee-84d5-cb932ba13e52	9d52d0ab-0d50-4f06-9075-c39d8d2524f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"73.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:15:37
6442	9d52d0ab-07e7-4dac-a8bb-0116d6ab6ddd	9d52d0ab-0d50-4f06-9075-c39d8d2524f0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:15:37
6443	9d52d0ab-0be4-4d11-8fc9-999fe04c71b4	9d52d0ab-0d50-4f06-9075-c39d8d2524f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:15:37
5106	9d513677-5727-4dc4-babf-9975879e580b	9d513677-9043-4457-b603-98591bcf4194	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 17:08:37
5107	9d513677-8622-4a3c-9604-3dcbfd2147f7	9d513677-9043-4457-b603-98591bcf4194	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"78.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:08:37
5108	9d513677-86a7-44ca-bd81-1e3f39ad22b8	9d513677-9043-4457-b603-98591bcf4194	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:08:37
5109	9d513677-8e02-4cc9-8829-f4742af49863	9d513677-9043-4457-b603-98591bcf4194	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 17:08:37
5110	9d513677-8e8e-4338-86e2-3e9f60c6eeea	9d513677-9043-4457-b603-98591bcf4194	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":539,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:37
6444	9d52d0ab-0c2f-42ee-9513-80ed29d11952	9d52d0ab-0d50-4f06-9075-c39d8d2524f0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":457,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:15:37
6917	9d52d748-a1b0-4059-b09b-3c69347bf14f	9d52d748-c349-410d-901c-0ac2574e16ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:34:07
6918	9d52d748-bb04-4ff4-ac87-56d21b326d72	9d52d748-c349-410d-901c-0ac2574e16ef	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"42.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:34:07
6919	9d52d748-bb77-4fd6-b294-9857c88b60e6	9d52d748-c349-410d-901c-0ac2574e16ef	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:34:07
6920	9d52d748-bd10-4461-9f94-40d69f57ea09	9d52d748-c349-410d-901c-0ac2574e16ef	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"1.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:34:07
6921	9d52d748-bd40-4a9c-8cb0-772906410cde	9d52d748-c349-410d-901c-0ac2574e16ef	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:34:07
6922	9d52d748-c202-42ff-95d0-6ad800b97529	9d52d748-c349-410d-901c-0ac2574e16ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:34:07
6923	9d52d748-c259-4c7d-bb64-8fcdbe40f640	9d52d748-c349-410d-901c-0ac2574e16ef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:34:07
9648	9d54874d-480a-4db5-9a9c-0f3022acfb41	9d54874e-50a4-4922-ae06-d0aa21ead14b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-25 08:42:08
12732	9d5cecba-1690-45a0-976f-f849345e1de5	9d5cecba-442d-4895-a8ab-65af61c31212	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-10-29 12:52:21
6445	9d52d0d8-5a85-4018-bb50-7faa388f2d6d	9d52d0d8-a491-4b74-8ecf-3d0e81c5ff20	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:16:07
6446	9d52d0d8-9f7d-4bf3-b4e6-d2d91004a456	9d52d0d8-a491-4b74-8ecf-3d0e81c5ff20	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"161.54","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-24 12:16:07
6447	9d52d0d8-a322-410e-ad0b-ee3c0b9552c9	9d52d0d8-a491-4b74-8ecf-3d0e81c5ff20	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:16:07
6448	9d52d0d8-a37e-4509-b2cb-61b6715193ad	9d52d0d8-a491-4b74-8ecf-3d0e81c5ff20	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:16:07
5111	9d513678-19a1-45f1-8f51-14ce519d9087	9d513678-4fae-4f3b-8349-5559edb9f36d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 17:08:37
5112	9d513678-4602-42da-8193-709b01abd6a7	9d513678-4fae-4f3b-8349-5559edb9f36d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"73.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:08:37
5113	9d513678-468f-4b0a-b36e-25ec48f6959e	9d513678-4fae-4f3b-8349-5559edb9f36d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:08:37
5114	9d513678-4dac-4a1b-8a17-d23358b50420	9d513678-4fae-4f3b-8349-5559edb9f36d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 17:08:37
5115	9d513678-4e35-4bdc-bba3-9ccd122957ae	9d513678-4fae-4f3b-8349-5559edb9f36d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":468,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:37
6924	9d52d74a-d274-4414-bd54-5dc4d2abcc8e	9d52d74b-1740-46ed-aa64-91e4b076b0ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:34:08
6925	9d52d74b-12cc-40e0-8e88-59ab34442c3b	9d52d74b-1740-46ed-aa64-91e4b076b0ed	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"144.85","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:34:09
6926	9d52d74b-132e-4351-8b93-4d9455aa98e8	9d52d74b-1740-46ed-aa64-91e4b076b0ed	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:34:09
6927	9d52d74b-1622-4791-8b63-e71fa5f31031	9d52d74b-1740-46ed-aa64-91e4b076b0ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:34:09
6928	9d52d74b-166d-46a9-9cae-a33c48b79efb	9d52d74b-1740-46ed-aa64-91e4b076b0ed	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":386,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:34:09
14915	9d5ec59c-4719-4e9b-aaba-fd2339f9fb8e	9d5ec59c-4d9e-4f9c-887b-0dc867a3a6e1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (59, 3, 100000, 50000, 'Pendiente', 'N\\/A', '20-11-2024', 12, '2024-10-30 10:54:38', '2024-10-30 10:54:38')","time":"0.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 10:54:38
14916	9d5ec59c-474d-4c88-8388-d8d4c8c37c8a	9d5ec59c-4d9e-4f9c-887b-0dc867a3a6e1	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 10:54:38
2512	9d50fa04-c614-4e81-880a-651d59cef1ac	9d50fa04-f49a-4cfa-9044-35514ec0750f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:19:35
2513	9d50fa04-f245-4cbb-a45f-ad9d52c0d2ba	9d50fa04-f49a-4cfa-9044-35514ec0750f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:19:35
2514	9d50fa04-f398-48b7-80f2-4217f4e9cf0d	9d50fa04-f49a-4cfa-9044-35514ec0750f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1062,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:19:35
14917	9d5ec59c-47ca-4bce-8aa4-0ed56da82036	9d5ec59c-4d9e-4f9c-887b-0dc867a3a6e1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (59, 4, 100000, 50000, 'Pendiente', 'N\\/A', '27-11-2024', 12, '2024-10-30 10:54:38', '2024-10-30 10:54:38')","time":"0.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 10:54:38
14918	9d5ec59c-4800-48be-a2a5-f6a78bb864c1	9d5ec59c-4d9e-4f9c-887b-0dc867a3a6e1	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 10:54:38
14919	9d5ec59c-486f-4c62-91d9-61bbafee32d9	9d5ec59c-4d9e-4f9c-887b-0dc867a3a6e1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (59, 5, 100000, 50000, 'Pendiente', 'N\\/A', '04-12-2024', 12, '2024-10-30 10:54:38', '2024-10-30 10:54:38')","time":"0.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 10:54:38
14920	9d5ec59c-4894-45e2-9291-a10e59c0d9b4	9d5ec59c-4d9e-4f9c-887b-0dc867a3a6e1	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 10:54:38
14921	9d5ec59c-4c6a-4e61-ab09-13981b7cca0a	9d5ec59c-4d9e-4f9c-887b-0dc867a3a6e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-30 10:54:38
14922	9d5ec59c-4cad-48ee-823e-31e3f54a4bc4	9d5ec59c-4d9e-4f9c-887b-0dc867a3a6e1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"743","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"100465546","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"500000","loans_intereses":50,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":18,"user_recomendacion":14,"loans_inicio_pago":"30-10-2024","created_at":null,"updated_at":null,"deleted_at":null},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Wed Oct 30 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":59},"duration":338,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:54:38
20826	9d66fc31-781d-48ad-b4af-e7f7337b5f51	9d66fc31-7c67-4e1a-977a-35d32070912a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAri%' or \\"users\\".\\"user_document\\"::text like '%MAri%') order by \\"users\\".\\"user_document\\" asc","time":"42.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 12:53:53
20827	9d66fc31-7b3f-497c-86cf-ed1fd74d09ec	9d66fc31-7c67-4e1a-977a-35d32070912a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-03 12:53:53
20828	9d66fc31-7b7f-4249-aeed-5e5f0b8555d1	9d66fc31-7c67-4e1a-977a-35d32070912a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAri"},"session":[],"response_status":200,"response":{"data":[]},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:53:53
21709	9d673db8-995b-4841-a9ec-985fb1ce57d4	9d673db8-9e70-4801-a100-91613d4ae63d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"155.40","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 15:57:07
21710	9d673db8-99b8-4a87-81cd-e2de15486f9f	9d673db8-9e70-4801-a100-91613d4ae63d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 15:57:07
21711	9d673db8-9d13-43e4-b9db-a3b45a8183dd	9d673db8-9e70-4801-a100-91613d4ae63d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 15:57:07
14923	9d5ec5a5-d3a1-4d96-a657-a3e6d7af21e4	9d5ec5a5-ed54-4522-b201-4819681421b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-30 10:54:44
12733	9d5cecba-3bfb-4438-946e-98099f9a2cff	9d5cecba-442d-4895-a8ab-65af61c31212	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"58.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":180,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 12:52:21
9649	9d54874d-c574-410f-b433-2d6938355f7f	9d54874e-50a4-4922-ae06-d0aa21ead14b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"93.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-25 08:42:08
9650	9d54874d-c602-4b01-8240-6a8af8a6a08e	9d54874e-50a4-4922-ae06-d0aa21ead14b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-25 08:42:08
5116	9d513678-d939-4dbd-b993-69e2937e6ad5	9d513679-3658-41c7-a914-2909b5760e6f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 17:08:38
5117	9d513679-2c53-4e11-95fc-cca5e103caca	9d513679-3658-41c7-a914-2909b5760e6f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"174.44","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:08:38
5118	9d513679-2cb7-4879-8b68-5294fbe73f1e	9d513679-3658-41c7-a914-2909b5760e6f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:08:38
5119	9d513679-3441-496a-a581-f5d3a5908e1b	9d513679-3658-41c7-a914-2909b5760e6f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 17:08:38
5120	9d513679-34cc-41b8-ae8e-caf787e32861	9d513679-3658-41c7-a914-2909b5760e6f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":568,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:38
9651	9d54874e-4f76-43c7-8108-ef75d1ac8bd2	9d54874e-50a4-4922-ae06-d0aa21ead14b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-25 08:42:08
9652	9d54874e-4fcd-4351-8dc7-8d64efde3fe6	9d54874e-50a4-4922-ae06-d0aa21ead14b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":1548,"memory":22,"hostname":"EderCortes"}	2024-10-25 08:42:08
12734	9d5cecba-3c76-4a51-a8bb-a611e2b5c8de	9d5cecba-442d-4895-a8ab-65af61c31212	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 12:52:21
12735	9d5cecba-421b-48dd-a95a-a9b8136f7e55	9d5cecba-442d-4895-a8ab-65af61c31212	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-10-29 12:52:21
12736	9d5cecba-42a8-49e1-913e-29fef3d1ac13	9d5cecba-442d-4895-a8ab-65af61c31212	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":429,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:21
14924	9d5ec5a5-e971-481e-ba39-a601506dc856	9d5ec5a5-ed54-4522-b201-4819681421b2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"42.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-30 10:54:44
14925	9d5ec5a5-ec10-40bb-b161-b75c49bb6349	9d5ec5a5-ed54-4522-b201-4819681421b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-30 10:54:44
14926	9d5ec5a5-ec6f-48d4-8061-fa6fafe8a4a9	9d5ec5a5-ed54-4522-b201-4819681421b2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":245,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:54:44
3974	9d511b28-b654-4909-9e1c-6227d53f1a0c	9d511b28-dd65-4842-a554-c110426b96bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-10-23 15:52:15
3975	9d511b28-dc01-4c8f-bfde-d84535d34fd3	9d511b28-dd65-4842-a554-c110426b96bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-10-23 15:52:15
3976	9d511b28-dc8f-48d6-b665-5b1e8e0b700f	9d511b28-dd65-4842-a554-c110426b96bf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":408,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:52:15
21113	9d6734bb-3b3a-4fd7-a693-17fa7ac9fe04	9d6734bb-3c2f-4d98-a76d-490d85e0d90f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"179","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000","id":197,"loans_codigo":64,"itemloans_cuota":"1","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":419,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:31:58
23341	9d689473-a248-4605-9beb-fdd2fe62d612	9d689473-aae9-41d3-b239-6d4cfb988d2b	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:70","changes":{"updated_at":"2024-11-04 07:55:27","loans_pago_interes":527500,"loans_pago_prestado":2110000},"hostname":"EderCortes"}	2024-11-04 07:55:27
20829	9d66fc31-c1eb-41e2-a7a3-22a489591c21	9d66fc31-c615-413f-9d88-2d0b77f1fa03	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":142,"memory":20,"hostname":"EderCortes"}	2024-11-03 12:53:53
23342	9d689473-a375-485e-a2f7-75503679e543	9d689473-aae9-41d3-b239-6d4cfb988d2b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 70 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"1.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":563,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 07:55:27
23343	9d689473-a3a6-4366-9eb3-06981ba59286	9d689473-aae9-41d3-b239-6d4cfb988d2b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 07:55:27
23344	9d689473-a427-42fa-8c1f-81eeb62db938	9d689473-aae9-41d3-b239-6d4cfb988d2b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = 40000, \\"itemloans_cuota_cancelada\\" = 160000, \\"updated_at\\" = '2024-11-04 07:55:27' where \\"id\\" = 258","time":"0.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":570,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 07:55:27
23345	9d689473-a45c-4ebd-9c74-9e2468dae062	9d689473-aae9-41d3-b239-6d4cfb988d2b	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:258","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 07:55:27","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":40000,"itemloans_cuota_cancelada":160000},"hostname":"EderCortes"}	2024-11-04 07:55:27
23346	9d689473-a4c9-427a-a865-3070027f9540	9d689473-aae9-41d3-b239-6d4cfb988d2b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select count(*) as aggregate from \\"item_loans\\" where \\"loans_codigo\\" = 70 and \\"itemloans_status\\" = 'Pagada'","time":"0.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":578,"hash":"60bd91eaa209a639fc2e8afc20430a4b","hostname":"EderCortes"}	2024-11-04 07:55:27
23347	9d689473-a521-43c4-94a6-3cc9af2c65a2	9d689473-aae9-41d3-b239-6d4cfb988d2b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"delete from \\"item_loans\\" where \\"loans_codigo\\" = 70 and \\"itemloans_status\\" = 'Pendiente'","time":"0.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":609,"hash":"89bf3c496a8b0746ff5d1219b8dc29e3","hostname":"EderCortes"}	2024-11-04 07:55:27
23348	9d689473-a57b-4a2d-b32f-a0b1e3f43846	9d689473-aae9-41d3-b239-6d4cfb988d2b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 70 limit 1","time":"0.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":612,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 07:55:27
23349	9d689473-a998-4ef8-883d-cb78daac1c35	9d689473-aae9-41d3-b239-6d4cfb988d2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 07:55:27
3977	9d511b29-2d24-49b4-a5f8-9b8c86372b85	9d511b29-50c4-4aa5-904f-361713a72865	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-10-23 15:52:15
3978	9d511b29-48b9-41a2-853f-d20e94f8406e	9d511b29-50c4-4aa5-904f-361713a72865	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:52:16
3404	9d510525-1f42-4fd7-9848-d682e8504e01	9d510525-5823-4e22-9982-b731df87e057	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:50:42
3405	9d510525-54a2-4694-9972-2386fda23326	9d510525-5823-4e22-9982-b731df87e057	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:50:42
2830	9d50fc9c-ddfc-40d6-b4e0-e78de63e9891	9d50fc9c-fdac-4408-b2dd-04e02343dab7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:26:50
2831	9d50fc9c-fc29-419d-a4f7-0f5220ab6b69	9d50fc9c-fdac-4408-b2dd-04e02343dab7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:26:50
2832	9d50fc9c-fccf-4528-a75d-c512d33ba579	9d50fc9c-fdac-4408-b2dd-04e02343dab7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":263,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:26:50
3406	9d510525-567a-47cf-a031-9d5576c24242	9d510525-5823-4e22-9982-b731df87e057	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":776,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:50:42
3979	9d511b29-491e-4e51-b8d4-ac47cfaa7b36	9d511b29-50c4-4aa5-904f-361713a72865	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 15:52:16
3980	9d511b29-4f8e-4279-b25e-fccca6939994	9d511b29-50c4-4aa5-904f-361713a72865	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-10-23 15:52:16
3981	9d511b29-4ff6-4a42-b7b6-b4d99011bc95	9d511b29-50c4-4aa5-904f-361713a72865	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:52:16
14927	9d5ec5be-2a29-42e1-a0e8-d23b9aa17502	9d5ec5be-785c-4260-8bdf-5671320afac6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-30 10:55:00
4112	9d511de6-2f04-4b3e-b5ba-94df203a5c47	9d511de6-51af-496f-b5a6-f3d26f532262	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 15:59:55
4113	9d511de6-5013-4cb0-a0e0-42e73c20f14b	9d511de6-51af-496f-b5a6-f3d26f532262	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 15:59:55
4114	9d511de6-50a0-4756-8935-5bef03339d9c	9d511de6-51af-496f-b5a6-f3d26f532262	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:59:55
14928	9d5ec5be-72c1-48d7-a123-ab8b0f7e7a54	9d5ec5be-785c-4260-8bdf-5671320afac6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"157.99","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-30 10:55:00
9653	9d54874f-4e59-43a2-81e1-75f3b43e0363	9d54874f-e714-4a65-8934-b54d29135ac9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-25 08:42:09
9654	9d54874f-dfa0-46e8-a825-72c86127c440	9d54874f-e714-4a65-8934-b54d29135ac9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"246.90","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-25 08:42:09
9655	9d54874f-e016-4b59-b791-bedf97861dc6	9d54874f-e714-4a65-8934-b54d29135ac9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-25 08:42:09
9656	9d54874f-e5bf-4a76-bf0b-aeef83e6dc4f	9d54874f-e714-4a65-8934-b54d29135ac9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-25 08:42:09
9657	9d54874f-e60b-47ac-bda5-e6ed6d6a1faa	9d54874f-e714-4a65-8934-b54d29135ac9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":884,"memory":22,"hostname":"EderCortes"}	2024-10-25 08:42:09
14929	9d5ec5be-76bb-4071-990d-d68c5735e573	9d5ec5be-785c-4260-8bdf-5671320afac6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-30 10:55:00
21114	9d6734bb-82cc-4eb6-b5b7-715102b9f868	9d6734bb-c9ee-47e1-8a20-4e8125aeb557	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:31:58
2833	9d50fc9d-4701-4cfd-858f-2d0f692c72a8	9d50fc9d-686a-4192-903f-efdd33ca65aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:26:51
2834	9d50fc9d-62f3-4040-911a-d7657aa47f6a	9d50fc9d-686a-4192-903f-efdd33ca65aa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:26:51
2835	9d50fc9d-6353-4f25-b380-6304f9f26750	9d50fc9d-686a-4192-903f-efdd33ca65aa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:26:51
2836	9d50fc9d-6733-4fc6-825b-3f368e8c629a	9d50fc9d-686a-4192-903f-efdd33ca65aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:26:51
2837	9d50fc9d-6779-491e-b29a-2b3e2461a8f9	9d50fc9d-686a-4192-903f-efdd33ca65aa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:26:51
3407	9d510525-c3ab-4c82-a295-0e6050e72dea	9d510526-0b40-4fe6-a6be-6573134d3232	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:50:42
3408	9d510526-05a2-499f-8e6a-5e16235b784f	9d510526-0b40-4fe6-a6be-6573134d3232	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"145.45","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:50:42
3409	9d510526-0601-447f-83f7-1a86b1e23cf9	9d510526-0b40-4fe6-a6be-6573134d3232	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:50:42
3410	9d510526-09df-4c15-8049-83371631b8c7	9d510526-0b40-4fe6-a6be-6573134d3232	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:50:42
3411	9d510526-0a21-4e5c-8bd2-788340444022	9d510526-0b40-4fe6-a6be-6573134d3232	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":418,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:50:42
3982	9d511b29-95cf-4ac8-8db5-84f60afb56d8	9d511b29-dc40-4838-925f-6baff356f493	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-10-23 15:52:16
3983	9d511b29-d721-4782-8314-7fe42dbc35bb	9d511b29-dc40-4838-925f-6baff356f493	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"145.30","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:52:16
3984	9d511b29-d76d-4f71-bfb3-b8af5f2e031b	9d511b29-dc40-4838-925f-6baff356f493	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 15:52:16
3985	9d511b29-db13-4178-a40a-d0884443045b	9d511b29-dc40-4838-925f-6baff356f493	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-10-23 15:52:16
3986	9d511b29-db55-46aa-9fb1-94bdac1e0461	9d511b29-dc40-4838-925f-6baff356f493	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":342,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:52:16
4115	9d511de6-a486-47d6-8f86-0c4c857a13f4	9d511de6-c91f-42b2-b017-1941c58ad303	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 15:59:55
4116	9d511de6-c2bc-4a00-87a1-ba37a564269e	9d511de6-c91f-42b2-b017-1941c58ad303	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:59:55
4117	9d511de6-c31e-453d-a5b6-5d4b46636b31	9d511de6-c91f-42b2-b017-1941c58ad303	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 15:59:55
4118	9d511de6-c7e8-41ea-8f2d-e0e623f66c6a	9d511de6-c91f-42b2-b017-1941c58ad303	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 15:59:55
2838	9d50fc9d-b3a1-4b2f-91f9-d2ed33bf4caf	9d50fc9d-d5ba-46b7-8427-d87af3e811b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:26:51
2839	9d50fc9d-cf96-4342-8d6d-98f5c1a74391	9d50fc9d-d5ba-46b7-8427-d87af3e811b3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:26:51
2840	9d50fc9d-d00d-4948-a55a-ec414b588132	9d50fc9d-d5ba-46b7-8427-d87af3e811b3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:26:51
2841	9d50fc9d-d499-4b7e-95a0-c79a79705fc5	9d50fc9d-d5ba-46b7-8427-d87af3e811b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 14:26:51
2842	9d50fc9d-d4dd-4950-ae8f-4ebf270c84d6	9d50fc9d-d5ba-46b7-8427-d87af3e811b3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":259,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:26:51
3412	9d510526-5743-4dee-82f8-6080d22687cc	9d510526-7964-4532-a9e4-4820b918de90	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:50:43
3072	9d5101c2-f9da-47ad-b6e1-da8317666df3	9d5101c3-40c6-4638-8272-4f90eceb89d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 14:41:14
3073	9d5101c3-3f6c-4d26-b75b-928026b12651	9d5101c3-40c6-4638-8272-4f90eceb89d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 14:41:14
3074	9d5101c3-3ff9-4f33-8f89-6e415849395f	9d5101c3-40c6-4638-8272-4f90eceb89d0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":344,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:41:14
3413	9d510526-73b1-4321-b802-e7c91e248305	9d510526-7964-4532-a9e4-4820b918de90	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:50:43
3414	9d510526-740d-4af5-9e6f-5582ceb0e3a0	9d510526-7964-4532-a9e4-4820b918de90	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:50:43
3415	9d510526-781c-4cb4-979e-fc2d8e4d2794	9d510526-7964-4532-a9e4-4820b918de90	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 14:50:43
3416	9d510526-7873-4f1c-b6f1-5239621d78f2	9d510526-7964-4532-a9e4-4820b918de90	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":268,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:50:43
3987	9d511b2b-4d4f-4036-b7fe-1b02fa1f7bf4	9d511b2b-6b45-4f1e-8ca5-f8e9d19ed66b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-10-23 15:52:17
3988	9d511b2b-6676-4cc5-8319-5ea318dd8e1c	9d511b2b-6b45-4f1e-8ca5-f8e9d19ed66b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 15:52:17
3989	9d511b2b-66bf-4dc1-b607-7be93de82188	9d511b2b-6b45-4f1e-8ca5-f8e9d19ed66b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 15:52:17
3990	9d511b2b-69fb-4a01-b3c6-22d924cde171	9d511b2b-6b45-4f1e-8ca5-f8e9d19ed66b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-10-23 15:52:17
4119	9d511de6-c830-4103-8632-0a4af0957147	9d511de6-c91f-42b2-b017-1941c58ad303	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:59:55
3075	9d5101c3-874d-4e96-a18d-b10032c144b1	9d5101c3-d1a7-417d-abe9-ef6588cb3e0e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 14:41:15
3076	9d5101c3-cd3d-4366-b911-b7694d5518a3	9d5101c3-d1a7-417d-abe9-ef6588cb3e0e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"154.02","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:41:15
3077	9d5101c3-cd8d-4e20-91a2-947ca3206c2e	9d5101c3-d1a7-417d-abe9-ef6588cb3e0e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:41:15
3078	9d5101c3-d0a4-414e-802b-ef3ce1fd1d24	9d5101c3-d1a7-417d-abe9-ef6588cb3e0e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 14:41:15
3079	9d5101c3-d0e4-49a4-b6e2-13c111f14d16	9d5101c3-d1a7-417d-abe9-ef6588cb3e0e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:41:15
3417	9d510527-0b9f-42dc-8d52-7b7cafd03af8	9d510527-4acb-4f0c-a3ea-a25ecd921d13	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 14:50:43
3418	9d510527-3f1b-4517-9c29-6bd1e3765442	9d510527-4acb-4f0c-a3ea-a25ecd921d13	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"85.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:50:43
3419	9d510527-3fa9-4749-a945-e129f989cb0a	9d510527-4acb-4f0c-a3ea-a25ecd921d13	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:50:43
3420	9d510527-47f6-4878-a2e0-f5e4cf729bf6	9d510527-4acb-4f0c-a3ea-a25ecd921d13	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 14:50:43
3421	9d510527-48e1-497f-8582-1c6f5b8a6955	9d510527-4acb-4f0c-a3ea-a25ecd921d13	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":519,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:50:43
3991	9d511b2b-6a43-480e-9b1e-1d2f3f0d7b24	9d511b2b-6b45-4f1e-8ca5-f8e9d19ed66b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:52:17
4120	9d511de7-1420-478c-8939-0d2e190f5b97	9d511de7-36df-4a15-a17e-e73ecf3806d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 15:59:55
4121	9d511de7-3046-46cf-9524-18d3be77b0cd	9d511de7-36df-4a15-a17e-e73ecf3806d9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:59:56
4122	9d511de7-30b2-404c-9b30-70bee61ec5ce	9d511de7-36df-4a15-a17e-e73ecf3806d9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 15:59:56
4123	9d511de7-357e-474b-9c91-3ad6bce12fcf	9d511de7-36df-4a15-a17e-e73ecf3806d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 15:59:56
9658	9d548753-ec04-4f0a-ad66-c445934952d6	9d548754-62bb-49c5-9ec1-05254310c0b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-25 08:42:12
12737	9d5cecba-b56c-4671-947a-7f0edc2a821e	9d5cecbb-0d80-4794-84d1-472b017df5d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-10-29 12:52:22
14930	9d5ec5be-7723-4da1-84c1-04639b408584	9d5ec5be-785c-4260-8bdf-5671320afac6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":459,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:55:00
3276	9d510459-743d-4039-b12c-bc4e28c26436	9d510459-c33f-47e4-ad01-6a17d0f668c7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:48:28
3277	9d510459-c129-4127-9bb1-3ab15c280e79	9d510459-c33f-47e4-ad01-6a17d0f668c7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:48:29
2958	9d50fddd-240a-4b45-a740-78aa9a2845cf	9d50fddd-4363-4c26-bfb1-4576daeae1fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:30:20
2959	9d50fddd-418f-4b7e-bd54-bce69b20ccfa	9d50fddd-4363-4c26-bfb1-4576daeae1fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:30:20
2960	9d50fddd-4254-4fbf-ad38-e7e0b6ffadd4	9d50fddd-4363-4c26-bfb1-4576daeae1fa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":257,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:30:20
3080	9d5101c4-1bec-4ddc-9dbc-456f218b91d7	9d5101c4-3a3e-4f4b-9d77-545a5623505b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 14:41:15
3278	9d510459-c1ea-4f40-a73c-dd7792aea34c	9d510459-c33f-47e4-ad01-6a17d0f668c7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":369,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:48:29
3081	9d5101c4-35a6-46c4-9c42-4e35c80dbcfb	9d5101c4-3a3e-4f4b-9d77-545a5623505b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:41:15
3082	9d5101c4-35ff-45a4-92ed-f01e1c8b0c50	9d5101c4-3a3e-4f4b-9d77-545a5623505b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:41:15
3083	9d5101c4-3931-4368-ab80-1836bf176d91	9d5101c4-3a3e-4f4b-9d77-545a5623505b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 14:41:15
20830	9d66fc32-1653-41a2-95fe-c3e16c1ed2d2	9d66fc32-1923-4752-b5da-499aa78a0eab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":137,"memory":20,"hostname":"EderCortes"}	2024-11-03 12:53:53
22775	9d67fb87-f741-4764-9d03-28e257967ffd	9d67fb87-fbec-4eb9-8e73-50ebf28a191a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":227,"memory":20,"hostname":"EderCortes"}	2024-11-04 00:47:51
4124	9d511de7-35d9-41b8-9839-336faab79f58	9d511de7-36df-4a15-a17e-e73ecf3806d9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":265,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:59:56
3422	9d510527-fae7-4518-9aa0-c67c6072b1c9	9d510528-5c09-4d71-9a24-3a444fa749e9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 14:50:44
12738	9d5cecbb-065b-433a-bba4-c3baecfe2f41	9d5cecbb-0d80-4794-84d1-472b017df5d2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"163.28","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":180,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 12:52:22
2961	9d50fddd-8d68-47c6-89a5-28c09686f91d	9d50fddd-ae7a-4c44-bfd1-b9b1647451b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:30:21
2962	9d50fddd-a921-4a7a-a19d-e2491fc32e2a	9d50fddd-ae7a-4c44-bfd1-b9b1647451b2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:30:21
2963	9d50fddd-a96d-4bbe-9d91-58043f2e44fb	9d50fddd-ae7a-4c44-bfd1-b9b1647451b2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:30:21
2964	9d50fddd-ad22-41ca-ac5b-2889f3b075ec	9d50fddd-ae7a-4c44-bfd1-b9b1647451b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:30:21
2965	9d50fddd-ad93-425d-ab0e-3e08d81d9580	9d50fddd-ae7a-4c44-bfd1-b9b1647451b2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:30:21
3084	9d5101c4-3974-4092-86c5-b6749ab3a7a8	9d5101c4-3a3e-4f4b-9d77-545a5623505b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:41:15
3279	9d51045a-1e55-4e0a-a1bd-cb852d7f311f	9d51045a-6757-40f4-9ac8-12fdd6dd8820	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:48:29
3280	9d51045a-615a-4ae2-bae8-6e793069d99c	9d51045a-6757-40f4-9ac8-12fdd6dd8820	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"147.82","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:48:29
3281	9d51045a-61a7-4c93-8619-b5597cbce9e8	9d51045a-6757-40f4-9ac8-12fdd6dd8820	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:48:29
3282	9d51045a-65f2-404a-a828-8e4d92d85d7d	9d51045a-6757-40f4-9ac8-12fdd6dd8820	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:48:29
3283	9d51045a-6639-4121-8438-3842ddb22f94	9d51045a-6757-40f4-9ac8-12fdd6dd8820	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":394,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:48:29
3423	9d510528-5005-485c-88bc-4f6b54ef3de9	9d510528-5c09-4d71-9a24-3a444fa749e9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"186.90","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:50:44
3424	9d510528-5089-4c37-a58d-d95b63b6714c	9d510528-5c09-4d71-9a24-3a444fa749e9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:50:44
3425	9d510528-5964-4032-aaec-034bf06391a1	9d510528-5c09-4d71-9a24-3a444fa749e9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 14:50:44
9659	9d548754-59c3-413c-96c1-50e0a04c552e	9d548754-62bb-49c5-9ec1-05254310c0b4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"256.56","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-25 08:42:12
9660	9d548754-5a2d-48d6-8336-0bccfc6b4e94	9d548754-62bb-49c5-9ec1-05254310c0b4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-25 08:42:12
9661	9d548754-6119-469e-9f51-3b2cf6168836	9d548754-62bb-49c5-9ec1-05254310c0b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-25 08:42:12
12739	9d5cecbb-06c5-4be8-8d9c-4ebaa0ef5918	9d5cecbb-0d80-4794-84d1-472b017df5d2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 12:52:22
2966	9d50fddd-f57e-4ac9-9d7d-bd947e574c7a	9d50fdde-15cc-4866-a206-69312cc4a00f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:30:21
2967	9d50fdde-102a-4619-a973-2a74054b22d5	9d50fdde-15cc-4866-a206-69312cc4a00f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:30:21
2968	9d50fdde-1086-49b9-95ac-206826638a10	9d50fdde-15cc-4866-a206-69312cc4a00f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:30:21
2969	9d50fdde-146c-459f-99ef-6602e3c7f2a5	9d50fdde-15cc-4866-a206-69312cc4a00f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:30:21
2970	9d50fdde-14d9-4ccd-8b9f-c60911215940	9d50fdde-15cc-4866-a206-69312cc4a00f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:30:21
3284	9d51045a-b8c6-42b4-9a2e-2608cb1b2421	9d51045a-dbbb-427a-9251-d382c01713ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:48:29
3285	9d51045a-d5ac-4ec3-88c6-0ca185791d22	9d51045a-dbbb-427a-9251-d382c01713ea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:48:29
3286	9d51045a-d613-4793-a82f-2d0144c3938b	9d51045a-dbbb-427a-9251-d382c01713ea	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:48:29
3287	9d51045a-da94-4018-ae58-45247fed5d9e	9d51045a-dbbb-427a-9251-d382c01713ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 14:48:29
3288	9d51045a-dad9-47f2-bcd9-c8b93fb4d2ab	9d51045a-dbbb-427a-9251-d382c01713ea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":277,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:48:29
3426	9d510528-5a0b-49b9-b16c-40926d3762f6	9d510528-5c09-4d71-9a24-3a444fa749e9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":669,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:50:44
12740	9d5cecbb-0be9-42a2-8c89-6c79b90858e5	9d5cecbb-0d80-4794-84d1-472b017df5d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-10-29 12:52:22
14931	9d5ec5c0-66d6-4f43-982d-d163a003cb9f	9d5ec5c0-892a-462b-9dda-8dbf2f01e193	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-30 10:55:02
20831	9d66fc32-7a32-4747-aaca-1b290271f580	9d66fc32-9411-4052-a980-27c771d90122	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-03 12:53:53
20832	9d66fc32-8fab-4c02-9851-a82af4a2d536	9d66fc32-9411-4052-a980-27c771d90122	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAr%' or \\"users\\".\\"user_document\\"::text like '%MAr%') order by \\"users\\".\\"user_document\\" asc","time":"39.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 12:53:53
14932	9d5ec5c0-7eb7-474c-b2ad-609e5ca3e342	9d5ec5c0-892a-462b-9dda-8dbf2f01e193	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"48.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"565fc855a1b9f5a9fda212d6b0600d59","hostname":"EderCortes"}	2024-10-30 10:55:02
14933	9d5ec5c0-8333-412a-80b7-99d9e61841d7	9d5ec5c0-892a-462b-9dda-8dbf2f01e193	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"2.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-30 10:55:02
14934	9d5ec5c0-836f-438e-8371-f4cf6bb703c4	9d5ec5c0-892a-462b-9dda-8dbf2f01e193	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-10-30 10:55:02
14935	9d5ec5c0-87a2-4d39-ab42-bc7b9b288f9f	9d5ec5c0-892a-462b-9dda-8dbf2f01e193	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-30 10:55:02
14936	9d5ec5c0-8808-4a76-8789-7aef67dbe256	9d5ec5c0-892a-462b-9dda-8dbf2f01e193	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:55:02
20833	9d66fc32-92e4-4811-823e-168f56e45bfa	9d66fc32-9411-4052-a980-27c771d90122	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-03 12:53:53
20834	9d66fc32-9326-43b0-8bbc-b76ea935b3c7	9d66fc32-9411-4052-a980-27c771d90122	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAr"},"session":[],"response_status":200,"response":{"data":[]},"duration":211,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:53:53
21115	9d6734bb-c103-4c07-8d24-9c040e4c064d	9d6734bb-c9ee-47e1-8a20-4e8125aeb557	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 64\\n                        ","time":"147.39","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"45dfab6b4f68d5c2aab17cd8432b9cbd","hostname":"EderCortes"}	2024-11-03 15:31:59
21116	9d6734bb-c4a7-490b-821d-86369e4b6b9f	9d6734bb-c9ee-47e1-8a20-4e8125aeb557	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '64' order by \\"item_loans\\".\\"id\\" asc","time":"1.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 15:31:59
21117	9d6734bb-c4da-4cfd-a701-de4ae7d97171	9d6734bb-c9ee-47e1-8a20-4e8125aeb557	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 15:31:59
21118	9d6734bb-c894-4337-a0e5-e44d15b04a3e	9d6734bb-c9ee-47e1-8a20-4e8125aeb557	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 15:31:59
14937	9d5ec66f-2804-446b-9bd9-3e11c2ae9b7e	9d5ec66f-2bdf-4bd2-a5c8-ef029f7db6cc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":176,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:56:56
20835	9d66fc32-d3bb-48b4-9ff2-c5dc4ea9ab95	9d66fc32-d68f-4441-a42d-bd7b81a4726d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":150,"memory":20,"hostname":"EderCortes"}	2024-11-03 12:53:54
21119	9d6734bb-c8ea-4013-b935-a68df86b651f	9d6734bb-c9ee-47e1-8a20-4e8125aeb557	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/64","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":64,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":2000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"17-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-17 00:00:00","loans_pago_prestado":"200000","loans_pago_interes":"0"},"items":[{"id":197,"loans_codigo":64,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:00:24.000000Z","updated_at":"2024-11-03T20:31:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"200000"},{"id":198,"loans_codigo":64,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:00:24.000000Z","updated_at":"2024-11-03T18:00:24.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":199,"loans_codigo":64,"itemloans_cuota":"3","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:00:24.000000Z","updated_at":"2024-11-03T18:00:24.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":200,"loans_codigo":64,"itemloans_cuota":"4","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:00:24.000000Z","updated_at":"2024-11-03T18:00:24.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":201,"loans_codigo":64,"itemloans_cuota":"5","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:00:24.000000Z","updated_at":"2024-11-03T18:00:24.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":202,"loans_codigo":64,"itemloans_cuota":"6","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:00:24.000000Z","updated_at":"2024-11-03T18:00:24.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":203,"loans_codigo":64,"itemloans_cuota":"7","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:00:24.000000Z","updated_at":"2024-11-03T18:00:24.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":204,"loans_codigo":64,"itemloans_cuota":"8","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-25 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:00:24.000000Z","updated_at":"2024-11-03T18:00:24.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":205,"loans_codigo":64,"itemloans_cuota":"9","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:00:24.000000Z","updated_at":"2024-11-03T18:00:24.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":206,"loans_codigo":64,"itemloans_cuota":"10","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:00:24.000000Z","updated_at":"2024-11-03T18:00:24.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":344,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:31:59
23350	9d689473-a9df-4c1a-bfc7-20485398fe5d	9d689473-aae9-41d3-b239-6d4cfb988d2b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"51","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"200000","idLoans":70,"idCreador":12},"session":[],"response_status":200,"response":{"message":"El abono fue aplicado exitosamente","status":true},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:55:27
20773	9d66fbf3-a07d-4ca5-9970-05b8c783719d	9d66fbf3-a16a-4478-a69b-4939bf6ec993	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"179","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000","id":186,"loans_codigo":61,"itemloans_cuota":"5","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:53:12
25317	9d68c129-d308-4875-9e96-17471e9139c6	9d68c129-d692-46ef-be40-116a23808a64	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-total-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":159,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:00:29
26123	9d68cdb8-b85e-4ba3-a760-dafddeeef3a5	9d68cdb8-bfc2-4399-a5f7-1c6dd326862b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"162.98","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 10:35:35
26124	9d68cdb8-bd50-4df5-ae34-4637c05b8969	9d68cdb8-bfc2-4399-a5f7-1c6dd326862b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:35:35
14938	9d5ec66f-a71f-4599-a739-75e8d30a0816	9d5ec66f-d0e7-49c9-826d-3c38347f468b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-30 10:56:56
14939	9d5ec66f-c63f-42ab-97e7-686d5285b73f	9d5ec66f-d0e7-49c9-826d-3c38347f468b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta', 'De las nieve', 'ds', 'CC', '100465546', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '500000', 50, 5, 'S', null, '30-10-2024', 'Pendiente', '312596295', 12, 14, 18, 14, '30-10-2024', '2024-10-30 10:56:57', '2024-10-30 10:56:57') returning \\"id\\"","time":"4.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":104,"hash":"bfad4cea82a73099ff0b3164dd496ca0","hostname":"EderCortes"}	2024-10-30 10:56:57
14940	9d5ec66f-c6d1-4dce-8ecd-4eb7d807bad0	9d5ec66f-d0e7-49c9-826d-3c38347f468b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:60","hostname":"EderCortes"}	2024-10-30 10:56:57
14941	9d5ec66f-c8b3-400e-8bf8-81fa2cb0d493	9d5ec66f-d0e7-49c9-826d-3c38347f468b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (60, 1, 100000, 50000, 'Pendiente', 'N\\/A', '06-11-2024', 12, '2024-10-30 10:56:57', '2024-10-30 10:56:57')","time":"2.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 10:56:57
14942	9d5ec66f-c8de-4efd-9821-b341fd6319bf	9d5ec66f-d0e7-49c9-826d-3c38347f468b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 10:56:57
14943	9d5ec66f-c958-4411-a5a8-ae2e33cb54b8	9d5ec66f-d0e7-49c9-826d-3c38347f468b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (60, 2, 100000, 50000, 'Pendiente', 'N\\/A', '06-11-2024', 12, '2024-10-30 10:56:57', '2024-10-30 10:56:57')","time":"0.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 10:56:57
14944	9d5ec66f-c97c-42e1-a462-07ec83d2f2e5	9d5ec66f-d0e7-49c9-826d-3c38347f468b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 10:56:57
14945	9d5ec66f-c9e2-4f64-b26f-e66c092a80cd	9d5ec66f-d0e7-49c9-826d-3c38347f468b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (60, 3, 100000, 50000, 'Pendiente', 'N\\/A', '06-11-2024', 12, '2024-10-30 10:56:57', '2024-10-30 10:56:57')","time":"0.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 10:56:57
14946	9d5ec66f-ca08-408d-a179-1b43ce5dd76d	9d5ec66f-d0e7-49c9-826d-3c38347f468b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 10:56:57
14947	9d5ec66f-ca78-49f3-ba2a-21498e784ae0	9d5ec66f-d0e7-49c9-826d-3c38347f468b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (60, 4, 100000, 50000, 'Pendiente', 'N\\/A', '06-11-2024', 12, '2024-10-30 10:56:57', '2024-10-30 10:56:57')","time":"0.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 10:56:57
14948	9d5ec66f-ca9a-46c1-829a-4f834f66c8e7	9d5ec66f-d0e7-49c9-826d-3c38347f468b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 10:56:57
14949	9d5ec66f-caf7-4aef-b2ee-84ba8642ec9f	9d5ec66f-d0e7-49c9-826d-3c38347f468b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (60, 5, 100000, 50000, 'Pendiente', 'N\\/A', '06-11-2024', 12, '2024-10-30 10:56:57', '2024-10-30 10:56:57')","time":"0.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 10:56:57
14950	9d5ec66f-cb15-4c3d-88bd-d45039a4b184	9d5ec66f-d0e7-49c9-826d-3c38347f468b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 10:56:57
14951	9d5ec66f-cf6d-4f37-82fb-2bf150a712aa	9d5ec66f-d0e7-49c9-826d-3c38347f468b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 10:56:57
14952	9d5ec66f-cfc2-45c9-9ac6-bb2886055ac7	9d5ec66f-d0e7-49c9-826d-3c38347f468b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"743","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"100465546","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"500000","loans_intereses":50,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":18,"user_recomendacion":14,"loans_inicio_pago":"30-10-2024","created_at":null,"updated_at":null,"deleted_at":null},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Wed Oct 30 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":60},"duration":260,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:56:57
20774	9d66fbf3-e0e5-4af3-adb2-259202f3c283	9d66fbf3-fe77-4e73-b624-e570c874e69c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-03 12:53:12
20836	9d66fc33-26df-4752-a631-d53e76f6edc2	9d66fc33-410f-4950-8665-a55b14b81636	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-03 12:53:54
14953	9d5ec676-d1a5-4caa-9187-43d114c468fd	9d5ec677-143a-4880-9723-fb9edb119e2d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 10:57:01
7154	9d52db67-2b5a-46b2-a38a-d71cab918ca0	9d52db67-8612-4b4f-9c1f-06f04ce8a68b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 12:45:38
7155	9d52db67-82d0-49a6-9e2d-c101cdc4c293	9d52db67-8612-4b4f-9c1f-06f04ce8a68b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:45:38
7156	9d52db67-8486-41d2-accd-2be9bbc3906c	9d52db67-8612-4b4f-9c1f-06f04ce8a68b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":450,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:45:38
20837	9d66fc33-3cef-4cbf-a7d2-62aedac53044	9d66fc33-410f-4950-8665-a55b14b81636	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"41.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 12:53:54
20780	9d66fc1c-2743-4d46-9c62-9f2cad0aef91	9d66fc1c-4708-46ff-a3d2-741b5bf6e129	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 12:53:39
14954	9d5ec677-0f85-463e-8456-8fcc68ef5502	9d5ec677-143a-4880-9723-fb9edb119e2d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"146.65","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-30 10:57:01
20781	9d66fc1c-4159-49d8-8126-33341028cca6	9d66fc1c-4708-46ff-a3d2-741b5bf6e129	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"42.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-03 12:53:39
14955	9d5ec677-12ed-4bad-9185-1fd648cb94dc	9d5ec677-143a-4880-9723-fb9edb119e2d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 10:57:01
14956	9d5ec677-1345-4188-a9ff-809c5e520a87	9d5ec677-143a-4880-9723-fb9edb119e2d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":372,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:57:01
20782	9d66fc1c-4579-4b6f-8849-687bf56b7308	9d66fc1c-4708-46ff-a3d2-741b5bf6e129	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:53:39
20783	9d66fc1c-45e0-4702-b06e-851e53615d7e	9d66fc1c-4708-46ff-a3d2-741b5bf6e129	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":248,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:53:39
20838	9d66fc33-3feb-4b24-b185-b38a8ff8a6f3	9d66fc33-410f-4950-8665-a55b14b81636	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-03 12:53:54
21120	9d6734cb-ef12-4727-8b5b-ea11bd7cb780	9d6734cc-0a7d-4c3f-b2db-53a3ca55d488	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 15:32:09
23351	9d6894e2-57ee-45de-9b81-40add35ec4dc	9d6894e2-7a6d-4e5f-91fb-8006d9812296	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 07:56:40
7157	9d52db67-f96e-435c-bb8b-c0584fded9aa	9d52db68-264d-4de9-8bd2-5339e777b3e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:45:39
7158	9d52db68-1f0c-410a-a7cb-0df0b8fc4bff	9d52db68-264d-4de9-8bd2-5339e777b3e3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"63.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:45:39
7159	9d52db68-1f73-4341-8a46-e3490c90abea	9d52db68-264d-4de9-8bd2-5339e777b3e3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:45:39
7160	9d52db68-24f6-4979-b67a-5d060d3e6d4e	9d52db68-264d-4de9-8bd2-5339e777b3e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:45:39
7161	9d52db68-2547-4da2-8dd8-517d2dfe5844	9d52db68-264d-4de9-8bd2-5339e777b3e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":380,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:45:39
14957	9d5ec67d-af7a-4729-9fe9-5ac970318793	9d5ec67d-ce99-479c-b082-71f015c442ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 10:57:06
14958	9d5ec67d-c52d-4bfa-9011-212851f161e6	9d5ec67d-ce99-479c-b082-71f015c442ef	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 60\\n                        ","time":"43.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"151d26c2814245960c9912d03004e459","hostname":"EderCortes"}	2024-10-30 10:57:06
7310	9d52dd0f-c926-4e1a-ab4b-13e94e13059d	9d52dd0f-e80d-402d-b8fc-d6936ebb4c5e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 12:50:16
7311	9d52dd0f-e686-4728-a736-59486ba8e47f	9d52dd0f-e80d-402d-b8fc-d6936ebb4c5e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 12:50:16
7312	9d52dd0f-e714-47e0-9260-a448dcd2a6e7	9d52dd0f-e80d-402d-b8fc-d6936ebb4c5e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:50:16
9662	9d548754-6190-4c93-99d9-ca65cb89393f	9d548754-62bb-49c5-9ec1-05254310c0b4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":1118,"memory":22,"hostname":"EderCortes"}	2024-10-25 08:42:12
14959	9d5ec67d-c8eb-4fe5-8568-d0853b58c7fe	9d5ec67d-ce99-479c-b082-71f015c442ef	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '60' order by \\"item_loans\\".\\"id\\" asc","time":"1.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-30 10:57:06
14960	9d5ec67d-c91e-4ddb-9c67-3a09282bee32	9d5ec67d-ce99-479c-b082-71f015c442ef	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-10-30 10:57:06
14961	9d5ec67d-cd34-4cf5-a67a-50de0632e58d	9d5ec67d-ce99-479c-b082-71f015c442ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 10:57:06
20784	9d66fc1e-69fc-47f2-b8b7-82a859c0aeba	9d66fc1f-0223-4f79-ba90-25857e7055b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:53:40
20785	9d66fc1e-fcfa-45a6-bfe9-843843cd77a3	9d66fc1f-0223-4f79-ba90-25857e7055b4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":183,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 12:53:41
20786	9d66fc1e-fd5e-431c-b5a8-b6dd8214e09b	9d66fc1f-0223-4f79-ba90-25857e7055b4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 12:53:41
20787	9d66fc1f-00c5-4e75-8a90-9e7976a5c496	9d66fc1f-0223-4f79-ba90-25857e7055b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:53:41
25318	9d68c12a-bce2-45fd-adc9-ef3fb5866bdf	9d68c12a-e04c-4af6-9391-a4ac079af3f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:00:29
7162	9d52db68-7998-4fdd-b7dc-e7904ca87238	9d52db68-9b00-437e-ac21-528859913d3e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:45:39
5198	9d513708-fe18-488b-b162-79b828e2a976	9d513709-4bc6-470e-81fe-72a0627dd780	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 17:10:12
5199	9d513709-4a04-4c81-8255-a394832dd028	9d513709-4bc6-470e-81fe-72a0627dd780	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 17:10:12
5200	9d513709-4ac1-41e4-9f62-7369d53c6c33	9d513709-4bc6-470e-81fe-72a0627dd780	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":365,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:10:12
7163	9d52db68-9488-40d7-8e14-e3f1c5637c1e	9d52db68-9b00-437e-ac21-528859913d3e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:45:39
7164	9d52db68-94df-4f13-ab1b-3b5fc93e3c41	9d52db68-9b00-437e-ac21-528859913d3e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:45:39
7165	9d52db68-995b-4503-b769-392cb1e52ea2	9d52db68-9b00-437e-ac21-528859913d3e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:45:39
7166	9d52db68-99ba-460b-a4ac-91257451ea49	9d52db68-9b00-437e-ac21-528859913d3e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":281,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:45:39
7313	9d52dd10-37d9-4405-8a7f-2e87d5b83bd0	9d52dd10-5f2f-4101-8bc1-33c52aea40f4	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 12:50:17
7314	9d52dd10-58a3-4c37-9e00-ad43cd8bfd63	9d52dd10-5f2f-4101-8bc1-33c52aea40f4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:50:17
7315	9d52dd10-5906-401d-bb1c-ce5a19b92167	9d52dd10-5f2f-4101-8bc1-33c52aea40f4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:50:17
7316	9d52dd10-5d63-493e-9f70-949becfe1f55	9d52dd10-5f2f-4101-8bc1-33c52aea40f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:50:17
7317	9d52dd10-5de8-4a5c-b113-326b2103afa2	9d52dd10-5f2f-4101-8bc1-33c52aea40f4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":274,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:50:17
14962	9d5ec67d-cd93-446c-90ac-d3d03cf9f4a1	9d5ec67d-ce99-479c-b082-71f015c442ef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/60","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":60,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":177,"loans_codigo":60,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-10-30T15:56:57.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":178,"loans_codigo":60,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-10-30T15:56:57.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":179,"loans_codigo":60,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-10-30T15:56:57.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":180,"loans_codigo":60,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-10-30T15:56:57.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":181,"loans_codigo":60,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-10-30T15:56:57.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:57:06
20839	9d66fc33-402c-4fbc-8b27-3f2fda0b7b2a	9d66fc33-410f-4950-8665-a55b14b81636	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":213,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:53:54
7167	9d52db68-fed6-4e08-ad47-e4c6fe67d514	9d52db69-4a68-48c0-b9ce-398766e0bd80	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:45:39
7168	9d52db69-441e-475d-afae-b85ddee8bd35	9d52db69-4a68-48c0-b9ce-398766e0bd80	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"153.71","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:45:39
2678	9d50fb23-48b0-4b3f-9cc9-bb5688c12170	9d50fb23-9323-4ddc-ae59-e129191298db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-10-23 14:22:43
2679	9d50fb23-916e-460c-be70-cc131a400bbe	9d50fb23-9323-4ddc-ae59-e129191298db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-10-23 14:22:43
2680	9d50fb23-922d-4553-bbad-e2b63f6d2ffa	9d50fb23-9323-4ddc-ae59-e129191298db	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":367,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:22:43
7169	9d52db69-4477-408f-a559-49a4245dfe6e	9d52db69-4a68-48c0-b9ce-398766e0bd80	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:45:39
7170	9d52db69-45f6-4e9d-9e29-2975a3034dc6	9d52db69-4a68-48c0-b9ce-398766e0bd80	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"1.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:45:39
5201	9d513709-9f60-4796-9fe4-eca08c839cd9	9d513709-be3f-4a9a-87f1-c285984293ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 17:10:12
5202	9d513709-b931-47dd-a6c7-161c61f1f9ff	9d513709-be3f-4a9a-87f1-c285984293ff	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:10:12
5203	9d513709-b986-43b2-b1d6-7ca84094812c	9d513709-be3f-4a9a-87f1-c285984293ff	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:10:12
5204	9d513709-bd3e-4174-8099-37678f3ef1f7	9d513709-be3f-4a9a-87f1-c285984293ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 17:10:12
7171	9d52db69-4625-458f-814c-209579e862cc	9d52db69-4a68-48c0-b9ce-398766e0bd80	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:45:39
7172	9d52db69-494d-48da-919f-0013e78076e2	9d52db69-4a68-48c0-b9ce-398766e0bd80	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:45:39
7173	9d52db69-4992-4ca9-aa58-b321ffb44c27	9d52db69-4a68-48c0-b9ce-398766e0bd80	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":434,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:45:39
7318	9d52dd10-b028-4d47-9d41-564097dd0d62	9d52dd10-ce27-4867-941b-79f7b616ee62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:50:17
7319	9d52dd10-c952-4293-b866-8f5f4c1a8b54	9d52dd10-ce27-4867-941b-79f7b616ee62	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:50:17
7320	9d52dd10-c99d-4c19-bb87-55dbe0f9e04e	9d52dd10-ce27-4867-941b-79f7b616ee62	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:50:17
7321	9d52dd10-cd0e-42bc-82f7-8f574231131b	9d52dd10-ce27-4867-941b-79f7b616ee62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:50:17
7322	9d52dd10-cd51-4fcc-bbb5-855d2221d09e	9d52dd10-ce27-4867-941b-79f7b616ee62	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:50:17
14963	9d5ec6e2-482a-47cd-b308-42bd465834b3	9d5ec6e2-939b-47fc-82de-f4dbb30bdf36	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-30 10:58:12
20840	9d66fc33-8ecf-41b2-911b-6ddd60e8ce5b	9d66fc33-d5c3-487c-b555-bcbdda96f269	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-03 12:53:54
20841	9d66fc33-d1e3-4550-9a8d-7a78f6eb1937	9d66fc33-d5c3-487c-b555-bcbdda96f269	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ma%' or \\"users\\".\\"user_document\\"::text like '%Ma%') order by \\"users\\".\\"user_document\\" asc","time":"155.60","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 12:53:54
20842	9d66fc33-d4a4-4040-a379-984790e10857	9d66fc33-d5c3-487c-b555-bcbdda96f269	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-03 12:53:54
2681	9d50fb23-d9ef-4369-a472-902f4d37335f	9d50fb23-fa00-4aca-aecd-3b9b7e0c0ad9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-10-23 14:22:43
2682	9d50fb23-f4ed-4b68-85d4-70e6e2c5ee4e	9d50fb23-fa00-4aca-aecd-3b9b7e0c0ad9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:22:43
2683	9d50fb23-f553-4e9e-a470-26d0ecb05f7c	9d50fb23-fa00-4aca-aecd-3b9b7e0c0ad9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:22:43
2684	9d50fb23-f8c6-4ebe-a628-9b26d490df29	9d50fb23-fa00-4aca-aecd-3b9b7e0c0ad9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-10-23 14:22:43
2685	9d50fb23-f908-4685-8c06-ea9b5ed46235	9d50fb23-fa00-4aca-aecd-3b9b7e0c0ad9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:22:43
5205	9d513709-bd80-4a9f-9f22-d3e05139df88	9d513709-be3f-4a9a-87f1-c285984293ff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":268,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:10:12
7174	9d52db6b-d12e-48f6-8437-71d404b0929a	9d52db6c-2425-4652-95d6-7fae45b846fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:45:41
7175	9d52db6c-1d4a-4ffd-b333-a64a3f895078	9d52db6c-2425-4652-95d6-7fae45b846fb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"170.30","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:45:41
3597	9d5108ec-0220-4537-8d88-5145944762d4	9d5108ec-3992-4107-8476-483ccf134c4b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 15:01:15
3598	9d5108ec-2f4d-4fa7-93b7-09ce10ec57ad	9d5108ec-3992-4107-8476-483ccf134c4b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"72.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:01:16
3599	9d5108ec-2fca-4a8f-b0e9-8f5252276a83	9d5108ec-3992-4107-8476-483ccf134c4b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 15:01:16
3600	9d5108ec-377e-48ec-ba62-9dae01c6c0b2	9d5108ec-3992-4107-8476-483ccf134c4b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 15:01:16
3601	9d5108ec-3803-43ce-8fc1-20f724a1886c	9d5108ec-3992-4107-8476-483ccf134c4b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":561,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:01:16
7176	9d52db6c-1daa-48bf-94b5-fa15c9231a41	9d52db6c-2425-4652-95d6-7fae45b846fb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:45:41
7177	9d52db6c-226c-48ad-aba4-e8e4246296d3	9d52db6c-2425-4652-95d6-7fae45b846fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:45:41
7178	9d52db6c-22da-47e9-950d-bec31779e8db	9d52db6c-2425-4652-95d6-7fae45b846fb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":511,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:45:41
2686	9d50fb24-4464-404e-a2b2-4d668b26148a	9d50fb24-6696-4d53-b852-aaff9cc81dc0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-10-23 14:22:44
2687	9d50fb24-5fab-4cda-b103-a123c31b3fd0	9d50fb24-6696-4d53-b852-aaff9cc81dc0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:22:44
2688	9d50fb24-5ffb-4f3c-8e70-83926aa347d8	9d50fb24-6696-4d53-b852-aaff9cc81dc0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:22:44
2689	9d50fb24-6517-4daa-bacf-65963684c05c	9d50fb24-6696-4d53-b852-aaff9cc81dc0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-10-23 14:22:44
2690	9d50fb24-6576-40a6-bd0b-29a66777cb74	9d50fb24-6696-4d53-b852-aaff9cc81dc0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":257,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:22:44
5206	9d51370a-020b-4f2b-9ff1-92852e2cd196	9d51370a-20ca-46c2-bac7-47ff35f7282d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 17:10:13
5207	9d51370a-1c6d-4830-b4cb-5ce581269df3	9d51370a-20ca-46c2-bac7-47ff35f7282d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:10:13
3602	9d5108ec-c109-4fb1-9101-a1a1fcfe1e56	9d5108ec-e606-440a-a310-e2a5c4a5b70d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 15:01:16
3603	9d5108ec-df8b-4dc1-98e3-02856721607c	9d5108ec-e606-440a-a310-e2a5c4a5b70d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:01:16
3604	9d5108ec-dfe0-41d1-8541-6eb2a4c772e6	9d5108ec-e606-440a-a310-e2a5c4a5b70d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 15:01:16
3605	9d5108ec-e4ae-4e7e-80e7-915c16d45598	9d5108ec-e606-440a-a310-e2a5c4a5b70d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 15:01:16
3606	9d5108ec-e505-4fb8-a08f-84ea8b5785c0	9d5108ec-e606-440a-a310-e2a5c4a5b70d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":417,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:01:16
5208	9d51370a-1cb6-4f28-95a9-62d4657821d1	9d51370a-20ca-46c2-bac7-47ff35f7282d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:10:13
5209	9d51370a-1fd1-4728-a8f2-f675d7f4564a	9d51370a-20ca-46c2-bac7-47ff35f7282d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 17:10:13
5210	9d51370a-2012-4201-bcfe-13d892fbedb3	9d51370a-20ca-46c2-bac7-47ff35f7282d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:10:13
14964	9d5ec6e2-8df0-4533-a449-37ee06b4861a	9d5ec6e2-939b-47fc-82de-f4dbb30bdf36	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"154.08","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-30 10:58:12
14965	9d5ec6e2-91fd-428d-a788-b5c39883bcda	9d5ec6e2-939b-47fc-82de-f4dbb30bdf36	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 10:58:12
7323	9d52dd11-2b25-414e-9c90-3013cb6f5788	9d52dd11-4d80-4a1c-b9d5-5e1cb8bee373	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:50:17
2526	9d50fa29-d5e0-40a5-b505-82214d7994bb	9d50fa2a-2331-4c2f-8e4a-85484e055dde	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:19:59
2527	9d50fa2a-216c-4042-aa70-4c09920a1e90	9d50fa2a-2331-4c2f-8e4a-85484e055dde	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:20:00
2528	9d50fa2a-221c-4f2a-ae1e-d7bf1f37d69b	9d50fa2a-2331-4c2f-8e4a-85484e055dde	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":363,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:20:00
7324	9d52dd11-45d5-481f-9e67-e2f8f46cf425	9d52dd11-4d80-4a1c-b9d5-5e1cb8bee373	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"43.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:50:17
7325	9d52dd11-462e-4e81-9e1f-ea0e9c1c854b	9d52dd11-4d80-4a1c-b9d5-5e1cb8bee373	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:50:17
2695	9d50fb25-e955-4abd-bd9c-f9166c1fc82f	9d50fb26-1e42-412b-8405-6989f9af4a82	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-10-23 14:22:45
7326	9d52dd11-481f-4740-9183-fd56cff69fd9	9d52dd11-4d80-4a1c-b9d5-5e1cb8bee373	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"2.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:50:17
7492	9d52df51-3321-42b3-90d9-cadf32a4741d	9d52df51-5965-4feb-a5ff-3593e70b0c5d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 12:56:35
7327	9d52dd11-4859-4812-bcb0-be3c871369e5	9d52dd11-4d80-4a1c-b9d5-5e1cb8bee373	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:50:17
7328	9d52dd11-4bd7-458b-a5b7-419c1114f064	9d52dd11-4d80-4a1c-b9d5-5e1cb8bee373	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:50:17
7329	9d52dd11-4c25-4e6b-a66e-dcf3e9c5f629	9d52dd11-4d80-4a1c-b9d5-5e1cb8bee373	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":304,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:50:17
7493	9d52df51-5769-495e-b207-4b447e39b693	9d52df51-5965-4feb-a5ff-3593e70b0c5d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:56:35
7494	9d52df51-5831-4505-8c55-c7936cfa66c9	9d52df51-5965-4feb-a5ff-3593e70b0c5d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":311,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:56:35
14966	9d5ec6e2-926e-4e2e-ad17-33811ea25335	9d5ec6e2-939b-47fc-82de-f4dbb30bdf36	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":355,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:58:12
20843	9d66fc33-d4ea-4d92-a17b-d04c4a559838	9d66fc33-d5c3-487c-b555-bcbdda96f269	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ma"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:53:54
14967	9d5ec6e5-b513-4629-8662-715966b99a26	9d5ec6e5-d5cf-4be7-8bd5-330cbedcf5fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 10:58:14
20788	9d66fc1f-0112-4d25-b298-5badc17b6360	9d66fc1f-0223-4f79-ba90-25857e7055b4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":676,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:53:41
3518	9d5106e4-7a3c-421b-b1bc-f12617c52e5b	9d5106e4-b99f-4da5-b1b2-4b637cc36ba2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 14:55:35
3331	9d510483-42dc-4341-b688-8863dac511a9	9d510483-820d-4696-a38f-4a977fe9045f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 14:48:56
2696	9d50fb26-1216-48f1-87db-c4ee5b4dc3d0	9d50fb26-1e42-412b-8405-6989f9af4a82	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"75.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:22:45
2697	9d50fb26-12f9-4e15-90bd-260d087a791e	9d50fb26-1e42-412b-8405-6989f9af4a82	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:22:45
2698	9d50fb26-1c01-4218-a51e-217397534955	9d50fb26-1e42-412b-8405-6989f9af4a82	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":29,"hostname":"EderCortes"}	2024-10-23 14:22:45
2699	9d50fb26-1ca2-4881-bc26-6985de3593cb	9d50fb26-1e42-412b-8405-6989f9af4a82	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":417,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:22:45
3332	9d510483-76c1-4107-9563-6e5d937e284a	9d510483-820d-4696-a38f-4a977fe9045f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"80.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:48:56
3333	9d510483-77af-48de-83e9-c2dc99016de1	9d510483-820d-4696-a38f-4a977fe9045f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:48:56
3334	9d510483-7fab-4d46-b91e-9492d6bc7faf	9d510483-820d-4696-a38f-4a977fe9045f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-23 14:48:56
3335	9d510483-805b-43b8-a331-fb635766d0d9	9d510483-820d-4696-a38f-4a977fe9045f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":533,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:48:56
14968	9d5ec6e5-cbe5-4cf4-87ad-250d6f6970de	9d5ec6e5-d5cf-4be7-8bd5-330cbedcf5fd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"46.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"565fc855a1b9f5a9fda212d6b0600d59","hostname":"EderCortes"}	2024-10-30 10:58:14
3519	9d5106e4-b64b-4839-9b86-ab03e63a50fb	9d5106e4-b99f-4da5-b1b2-4b637cc36ba2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 14:55:35
3520	9d5106e4-b803-4510-8f29-faf4bc631049	9d5106e4-b99f-4da5-b1b2-4b637cc36ba2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":588,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:55:35
3336	9d510483-e8f6-4ad9-9a13-e32ad5914e88	9d510484-0c96-49a3-a7ec-7824e6b756bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-23 14:48:56
3337	9d510484-05fd-457b-9b6c-b6e9b10f3ff9	9d510484-0c96-49a3-a7ec-7824e6b756bd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"50.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:48:56
2700	9d50fb26-8b83-4353-bc75-b3ef61fd8b68	9d50fb26-e5b7-4b0b-936a-21e6cba5a469	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":29,"hostname":"EderCortes"}	2024-10-23 14:22:45
2701	9d50fb26-de71-4bca-984d-60cef816569d	9d50fb26-e5b7-4b0b-936a-21e6cba5a469	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"170.72","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:22:45
2702	9d50fb26-ded4-442f-95a5-ef535ba79755	9d50fb26-e5b7-4b0b-936a-21e6cba5a469	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:22:45
2703	9d50fb26-e42c-4d16-bfe3-83aa070ca238	9d50fb26-e5b7-4b0b-936a-21e6cba5a469	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":30,"hostname":"EderCortes"}	2024-10-23 14:22:45
2704	9d50fb26-e489-4e12-b4d4-87470b548eed	9d50fb26-e5b7-4b0b-936a-21e6cba5a469	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":486,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:22:45
3338	9d510484-066b-442d-9804-e758844d118a	9d510484-0c96-49a3-a7ec-7824e6b756bd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:48:56
3339	9d510484-0af7-49f6-a7ea-1f71e46965a4	9d510484-0c96-49a3-a7ec-7824e6b756bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-23 14:48:56
3340	9d510484-0b50-4b80-bc13-13ee0ecad637	9d510484-0c96-49a3-a7ec-7824e6b756bd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":332,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:48:56
7330	9d52dd13-ed2a-4f89-b60b-504a739eaaf4	9d52dd14-4ac3-4fd7-b37a-8f4714fcf68b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:50:19
3607	9d5108ed-a0a8-4010-9db0-173dc3b116ae	9d5108ee-5768-49f8-9f1e-74efd6b6051b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 15:01:17
3608	9d5108ee-45e7-4c54-9672-ca90c7a26e87	9d5108ee-5768-49f8-9f1e-74efd6b6051b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"366.86","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 15:01:17
3609	9d5108ee-4690-4e4a-b632-299b5531d47c	9d5108ee-5768-49f8-9f1e-74efd6b6051b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 15:01:17
3610	9d5108ee-534e-45a5-a499-2f2833de0051	9d5108ee-5768-49f8-9f1e-74efd6b6051b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 15:01:17
7331	9d52dd14-3fc4-42c1-8626-bd22b5054ae9	9d52dd14-4ac3-4fd7-b37a-8f4714fcf68b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"105.40","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:50:19
7332	9d52dd14-4034-46f4-8468-d1fc5975a359	9d52dd14-4ac3-4fd7-b37a-8f4714fcf68b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:50:19
7333	9d52dd14-4811-49a4-a708-ca81c5ffee6c	9d52dd14-4ac3-4fd7-b37a-8f4714fcf68b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:50:19
3521	9d5106e5-5a9a-401e-8219-3b5ecef4c863	9d5106e5-8b56-4909-8f71-dd5ae352c494	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 14:55:36
3522	9d5106e5-830e-47af-90a2-fccbeb43a8f5	9d5106e5-8b56-4909-8f71-dd5ae352c494	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"66.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:55:36
3341	9d510484-a450-487b-a39f-915b4e3f3eeb	9d510484-f346-4c2c-8a3c-d5b147239e4e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-23 14:48:57
3342	9d510484-e7e4-4517-a8e0-ede3d3079aac	9d510484-f346-4c2c-8a3c-d5b147239e4e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"102.74","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:48:57
2705	9d50fb27-81a0-48d6-a7bf-3d5b93b98c95	9d50fb27-c2f4-43dc-95ce-d11c3a723caf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":30,"hostname":"EderCortes"}	2024-10-23 14:22:46
2706	9d50fb27-b82b-47eb-b6f0-57481f78688d	9d50fb27-c2f4-43dc-95ce-d11c3a723caf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"85.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:22:46
2707	9d50fb27-b8dd-4f7b-b03e-92e8173bc981	9d50fb27-c2f4-43dc-95ce-d11c3a723caf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:22:46
2708	9d50fb27-c0b9-4bb4-932d-793d07e8fa45	9d50fb27-c2f4-43dc-95ce-d11c3a723caf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":31,"hostname":"EderCortes"}	2024-10-23 14:22:46
2709	9d50fb27-c143-44c8-86fa-7085253f7c4c	9d50fb27-c2f4-43dc-95ce-d11c3a723caf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":546,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:22:46
3343	9d510484-e87c-4d23-80e1-3def911dfd1f	9d510484-f346-4c2c-8a3c-d5b147239e4e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:48:57
3344	9d510484-f112-4579-8468-c6a0c366a0c0	9d510484-f346-4c2c-8a3c-d5b147239e4e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-23 14:48:57
3345	9d510484-f18a-47ff-bad3-bad7de56050c	9d510484-f346-4c2c-8a3c-d5b147239e4e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":573,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:48:57
3523	9d5106e5-8385-4885-ae05-4f9a40c585d1	9d5106e5-8b56-4909-8f71-dd5ae352c494	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:55:36
3524	9d5106e5-89cc-4d75-ab68-049ec3d26d0d	9d5106e5-8b56-4909-8f71-dd5ae352c494	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 14:55:36
3525	9d5106e5-8a2e-4aa9-a91e-8969f7c0c593	9d5106e5-8b56-4909-8f71-dd5ae352c494	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":496,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:55:36
7495	9d52df51-b8fc-4a26-8b20-fd387fc86cb9	9d52df51-d6a4-456a-bdfb-dfa460584c1c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:56:35
20789	9d66fc1f-4229-46d2-8873-d9aa43e2ffc7	9d66fc1f-8ef4-406f-ab82-a6b5507ca0e9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:53:41
3526	9d5106e6-0f62-426c-8dba-4dadc2f0a59f	9d5106e6-4385-4445-99aa-3ce37e12f4fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 14:55:36
3186	9d510361-3b2a-46ed-b67f-215e4aada340	9d510361-61f7-42bf-9ecc-b35c70692aa7	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 14:45:46
3187	9d510361-5f71-4398-93f8-b4714efad8fe	9d510361-61f7-42bf-9ecc-b35c70692aa7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:45:46
3188	9d510361-60be-496f-8390-c4411a984d52	9d510361-61f7-42bf-9ecc-b35c70692aa7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":273,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:45:46
2710	9d50fb28-5a14-44be-ad96-74e26343633b	9d50fb28-b999-41af-80f5-9f257cd47760	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":31,"hostname":"EderCortes"}	2024-10-23 14:22:46
2711	9d50fb28-b0e4-4e56-9e42-6ca8d198de30	9d50fb28-b999-41af-80f5-9f257cd47760	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"179.28","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:22:46
2712	9d50fb28-b177-4e0a-9a1b-1c447c5bf557	9d50fb28-b999-41af-80f5-9f257cd47760	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:22:46
2713	9d50fb28-b740-44fa-9c70-a6c331803234	9d50fb28-b999-41af-80f5-9f257cd47760	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":32,"hostname":"EderCortes"}	2024-10-23 14:22:46
2714	9d50fb28-b7ed-4504-984b-df132fca6237	9d50fb28-b999-41af-80f5-9f257cd47760	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":599,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:22:46
3527	9d5106e6-39a0-4699-bcd1-8478d65d870f	9d5106e6-4385-4445-99aa-3ce37e12f4fa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"69.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:55:36
3528	9d5106e6-3a47-408d-aa62-a150972c78fb	9d5106e6-4385-4445-99aa-3ce37e12f4fa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:55:36
3346	9d510485-9bd0-4607-aa02-266c33a8bed1	9d510485-d103-4ead-9d7a-4d87d3aefd7d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-23 14:48:57
3347	9d510485-c9aa-4d3a-bdbe-1a21c05b8c72	9d510485-d103-4ead-9d7a-4d87d3aefd7d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"70.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:48:57
3348	9d510485-ca16-4cf4-a1c0-f2ac915823b1	9d510485-d103-4ead-9d7a-4d87d3aefd7d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:48:57
3349	9d510485-ceeb-4fe2-b727-6a6e5dc98f62	9d510485-d103-4ead-9d7a-4d87d3aefd7d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-23 14:48:57
3350	9d510485-cf68-4214-a33c-24e61fc65335	9d510485-d103-4ead-9d7a-4d87d3aefd7d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":544,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:48:57
3529	9d5106e6-414e-4b28-81b2-82c649687b37	9d5106e6-4385-4445-99aa-3ce37e12f4fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 14:55:36
7496	9d52df51-d0ef-4d90-b75e-6aeacdb3179d	9d52df51-d6a4-456a-bdfb-dfa460584c1c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:56:35
7497	9d52df51-d159-47a3-830c-08f07ccd2346	9d52df51-d6a4-456a-bdfb-dfa460584c1c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:56:35
7498	9d52df51-d564-4b03-9fc9-4619fa6d8660	9d52df51-d6a4-456a-bdfb-dfa460584c1c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:56:35
3189	9d510361-bcb9-43ef-8a85-d583d6e40a33	9d510362-0246-426c-b739-b7c072d02e77	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:45:46
3190	9d510361-fc10-4cad-88cf-1910178c3d49	9d510362-0246-426c-b739-b7c072d02e77	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"139.77","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:45:46
3191	9d510361-fc6d-4605-84e7-f675f6da3007	9d510362-0246-426c-b739-b7c072d02e77	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:45:46
3192	9d510362-012a-4df6-919c-beec5433b4bc	9d510362-0246-426c-b739-b7c072d02e77	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:45:46
3193	9d510362-016d-4ca2-a0a2-b5040fd09587	9d510362-0246-426c-b739-b7c072d02e77	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":387,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:45:46
3530	9d5106e6-41d1-4c63-ae06-09c1cb8293e3	9d5106e6-4385-4445-99aa-3ce37e12f4fa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":445,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:55:36
14969	9d5ec6e5-d008-4373-a352-5c0d0b23a5e1	9d5ec6e5-d5cf-4be7-8bd5-330cbedcf5fd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"2.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-30 10:58:14
5346	9d513839-5be1-45e6-98a1-04edd8f66335	9d513839-95ba-41e1-9e51-c2b7312e72ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 17:13:31
5347	9d513839-935f-4594-920f-029584e0f109	9d513839-95ba-41e1-9e51-c2b7312e72ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 17:13:32
5348	9d513839-945c-4bbf-be5a-82435ab50177	9d513839-95ba-41e1-9e51-c2b7312e72ff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":533,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:13:32
20790	9d66fc1f-8516-4eb8-9c3e-b6d7a6e5e4ce	9d66fc1f-8ef4-406f-ab82-a6b5507ca0e9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"152.03","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":183,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 12:53:41
20791	9d66fc1f-85a3-4c75-9d63-7cc53887ec59	9d66fc1f-8ef4-406f-ab82-a6b5507ca0e9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-03 12:53:41
14970	9d5ec6e5-d03c-4d5f-8a99-6489fcef51df	9d5ec6e5-d5cf-4be7-8bd5-330cbedcf5fd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-10-30 10:58:14
14971	9d5ec6e5-d467-423e-b636-cc85b73c646f	9d5ec6e5-d5cf-4be7-8bd5-330cbedcf5fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 10:58:14
20792	9d66fc1f-8c96-409b-a618-bb50d23a5f4e	9d66fc1f-8ef4-406f-ab82-a6b5507ca0e9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:53:41
20793	9d66fc1f-8d48-495f-9dba-05c4ab315e35	9d66fc1f-8ef4-406f-ab82-a6b5507ca0e9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":342,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:53:41
20844	9d66fc34-317c-4ae9-a9f3-6547f7206d59	9d66fc34-3442-4d4b-9fdb-c4bd2c9b3f88	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":127,"memory":20,"hostname":"EderCortes"}	2024-11-03 12:53:55
3194	9d510362-4eaa-41eb-a4b4-2a62b5b3ab2a	9d510362-95e4-4533-8227-224a74078d4c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:45:46
3195	9d510362-903d-45ee-9d18-ed919353a3ce	9d510362-95e4-4533-8227-224a74078d4c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"146.00","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:45:47
3196	9d510362-908b-43ea-91ef-4d3c99195ef0	9d510362-95e4-4533-8227-224a74078d4c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:45:47
3197	9d510362-949e-44ae-9d50-4d50afe960a6	9d510362-95e4-4533-8227-224a74078d4c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:45:47
3198	9d510362-9514-45b5-b76b-2520e1dbb42a	9d510362-95e4-4533-8227-224a74078d4c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":363,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:45:47
3531	9d5106e6-e41e-4b8f-903e-b80f5e41bd92	9d5106e7-21e8-471b-ab69-726dd088e1f7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 14:55:37
3532	9d5106e7-1686-4b4e-919f-24a43ce719c2	9d5106e7-21e8-471b-ab69-726dd088e1f7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"80.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:55:37
3533	9d5106e7-1709-4271-acc9-a408231c58c4	9d5106e7-21e8-471b-ab69-726dd088e1f7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:55:37
3534	9d5106e7-1f8e-41ea-b6ea-a3822ac171b1	9d5106e7-21e8-471b-ab69-726dd088e1f7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 14:55:37
3535	9d5106e7-2011-4fa0-86ca-a7827f468fa8	9d5106e7-21e8-471b-ab69-726dd088e1f7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":545,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:55:37
5349	9d51383a-1dd4-4079-af7b-346b99de8e59	9d51383a-560b-43f8-8908-88b2bcc93302	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 17:13:32
5350	9d51383a-4d4f-4ded-8525-99505f6bc55a	9d51383a-560b-43f8-8908-88b2bcc93302	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"76.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:13:32
5351	9d51383a-4dce-443b-b6c3-fc7166dad56f	9d51383a-560b-43f8-8908-88b2bcc93302	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:13:32
5352	9d51383a-5427-43de-9a41-bd8c51f24a7a	9d51383a-560b-43f8-8908-88b2bcc93302	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 17:13:32
5353	9d51383a-54a5-4af2-a5bd-afd854da0ec3	9d51383a-560b-43f8-8908-88b2bcc93302	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":449,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:13:32
20845	9d66fc34-e7c4-42d2-b54a-c6125fe67367	9d66fc35-2bdf-4883-b58e-b588928513f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-03 12:53:55
25319	9d68c12a-d78c-4d86-b2fe-bd4c2bc66b0d	9d68c12a-e04c-4af6-9391-a4ac079af3f5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 90 limit 1","time":"2.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":708,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 10:00:29
3536	9d5106e7-a624-45fa-9165-25639b148973	9d5106e7-d8fb-4049-bbfa-42e90f0bc892	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 14:55:37
3537	9d5106e7-ce73-431c-ac82-1dad7ffb73f9	9d5106e7-d8fb-4049-bbfa-42e90f0bc892	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"68.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:55:37
3538	9d5106e7-ced0-4233-ba1b-1662cdaa9546	9d5106e7-d8fb-4049-bbfa-42e90f0bc892	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:55:37
3539	9d5106e7-d671-4398-b8bb-4b9befc54901	9d5106e7-d8fb-4049-bbfa-42e90f0bc892	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-23 14:55:37
3540	9d5106e7-d705-4536-8faf-ccf39dcadc46	9d5106e7-d8fb-4049-bbfa-42e90f0bc892	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":440,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:55:37
5354	9d51383a-c833-4ecc-88df-7eaf26b3fe79	9d51383b-1fab-42d7-a38f-798028e2df2d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 17:13:32
5355	9d51383b-16e2-4cfa-82ed-c4e8137ffb77	9d51383b-1fab-42d7-a38f-798028e2df2d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"166.55","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:13:33
3611	9d5108ee-5582-42e2-b340-189fbfc885cc	9d5108ee-5768-49f8-9f1e-74efd6b6051b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":925,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:01:17
5356	9d51383b-1764-4071-977c-266c5e6d2ee0	9d51383b-1fab-42d7-a38f-798028e2df2d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:13:33
5357	9d51383b-1dee-4ca5-90fd-e6416c4e71d2	9d51383b-1fab-42d7-a38f-798028e2df2d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 17:13:33
5358	9d51383b-1e5e-4489-a9eb-fb22f06ffc23	9d51383b-1fab-42d7-a38f-798028e2df2d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":490,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:13:33
7499	9d52df51-d5a8-4460-ac42-9629810beaf6	9d52df51-d6a4-456a-bdfb-dfa460584c1c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":291,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:56:35
5359	9d51383c-240d-44f7-b840-920bcca360e5	9d51383c-6a90-49ae-bb75-59fca9e77bca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 17:13:33
5360	9d51383c-60ed-489f-8109-8b35dea8abca	9d51383c-6a90-49ae-bb75-59fca9e77bca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"86.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:13:33
5361	9d51383c-617a-4cab-af6b-0bda3ef4e885	9d51383c-6a90-49ae-bb75-59fca9e77bca	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:13:33
5362	9d51383c-6871-4d88-a018-6d2dbbc76244	9d51383c-6a90-49ae-bb75-59fca9e77bca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 17:13:33
3612	9d5108ef-4163-4c21-b078-a0b40622542a	9d5108ef-7882-4985-97cd-0d3423a9de98	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 15:01:18
3613	9d5108ef-6f82-4be8-a23a-c8f44c7590d0	9d5108ef-7882-4985-97cd-0d3423a9de98	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"73.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 15:01:18
3614	9d5108ef-7036-410a-9fb3-2388a477893b	9d5108ef-7882-4985-97cd-0d3423a9de98	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 15:01:18
3615	9d5108ef-7672-4153-88f4-438678d225ba	9d5108ef-7882-4985-97cd-0d3423a9de98	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-23 15:01:18
3616	9d5108ef-7705-4d37-bc0a-c01c28f9d14b	9d5108ef-7882-4985-97cd-0d3423a9de98	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":516,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:01:18
5363	9d51383c-68e4-48a9-80ce-e231d1b66b8f	9d51383c-6a90-49ae-bb75-59fca9e77bca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":824,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:13:33
7334	9d52dd14-489a-43fc-b7c4-a8a8366633a9	9d52dd14-4ac3-4fd7-b37a-8f4714fcf68b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":1110,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:50:19
7500	9d52df52-19e6-4552-a3eb-747b5dc2efc3	9d52df52-3668-4856-91fd-53e1659c06c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:56:35
7501	9d52df52-3192-4055-a7bf-2d1a9b96f33b	9d52df52-3668-4856-91fd-53e1659c06c2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:56:35
7502	9d52df52-31dc-49c2-bd4a-7bd79b8b52d6	9d52df52-3668-4856-91fd-53e1659c06c2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:56:35
7503	9d52df52-3563-41c5-b71d-8afcf8b21627	9d52df52-3668-4856-91fd-53e1659c06c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:56:35
5364	9d51383c-fff4-4fe7-acc5-62a2b1ba8f12	9d51383d-2664-4f09-a92b-7adad203ead2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 17:13:34
5365	9d51383d-1d1a-45fc-af19-f11b37b0e112	9d51383d-2664-4f09-a92b-7adad203ead2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:13:34
5366	9d51383d-1d75-4cad-8316-42b62ccee81e	9d51383d-2664-4f09-a92b-7adad203ead2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:13:34
5367	9d51383d-248a-4300-aea6-a265ad3d2ce9	9d51383d-2664-4f09-a92b-7adad203ead2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 17:13:34
3621	9d5108f8-c455-41a9-b886-8fd6d1bba0af	9d5108f8-e784-47ae-9ecb-acd124a69d61	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-23 15:01:24
3622	9d5108f8-e1e1-4043-94fd-398cb8b5ec9b	9d5108f8-e784-47ae-9ecb-acd124a69d61	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:01:24
3623	9d5108f8-e231-4369-aad6-56dc129ffe4a	9d5108f8-e784-47ae-9ecb-acd124a69d61	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 15:01:24
3624	9d5108f8-e66b-4389-bc11-ef895a29e33e	9d5108f8-e784-47ae-9ecb-acd124a69d61	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-23 15:01:24
3625	9d5108f8-e6af-45b4-a374-b008bebb37a2	9d5108f8-e784-47ae-9ecb-acd124a69d61	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:01:24
5368	9d51383d-2501-468e-9b54-0b9b13795034	9d51383d-2664-4f09-a92b-7adad203ead2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":450,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:13:34
7504	9d52df52-35a3-4677-9e7a-e1d8690bce11	9d52df52-3668-4856-91fd-53e1659c06c2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:56:35
12741	9d5cecbb-0c58-481b-9ac1-b30679963501	9d5cecbb-0d80-4794-84d1-472b017df5d2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":490,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:22
7505	9d52df52-7943-4cc1-9570-9a36f33be524	9d52df52-97b6-42a7-8860-8e7e1d2c5df8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:56:36
7506	9d52df52-9131-48fe-b0c7-274cdc06d683	9d52df52-97b6-42a7-8860-8e7e1d2c5df8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"42.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:56:36
7507	9d52df52-917c-4251-8d19-f49e5d39ae40	9d52df52-97b6-42a7-8860-8e7e1d2c5df8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:56:36
7508	9d52df52-92ff-4f2a-b46d-d022445d166a	9d52df52-97b6-42a7-8860-8e7e1d2c5df8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"1.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:56:36
3626	9d5108f9-447e-4438-b140-9b256b3f6a5d	9d5108f9-6baf-4eee-aec1-890a50aa20df	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-23 15:01:24
3627	9d5108f9-6566-471c-a891-3298305da3b0	9d5108f9-6baf-4eee-aec1-890a50aa20df	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"53.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:01:24
3628	9d5108f9-65b6-4136-82ae-61002d1e28a8	9d5108f9-6baf-4eee-aec1-890a50aa20df	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 15:01:24
3629	9d5108f9-6a3b-4540-a23e-6ecc35ba6c9d	9d5108f9-6baf-4eee-aec1-890a50aa20df	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-23 15:01:24
3630	9d5108f9-6a9b-408c-92e8-30a96358dbe8	9d5108f9-6baf-4eee-aec1-890a50aa20df	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":319,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:01:24
7509	9d52df52-9340-4725-ad6a-73e0f59608d2	9d52df52-97b6-42a7-8860-8e7e1d2c5df8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:56:36
7510	9d52df52-9691-4506-a9f2-3eca72e4f41b	9d52df52-97b6-42a7-8860-8e7e1d2c5df8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:56:36
7511	9d52df52-96d8-4a2d-9513-e13706056e1d	9d52df52-97b6-42a7-8860-8e7e1d2c5df8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:56:36
20846	9d66fc35-27bc-4701-9423-6db5f12de32a	9d66fc35-2bdf-4883-b58e-b588928513f6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mar%' or \\"users\\".\\"user_document\\"::text like '%Mar%') order by \\"users\\".\\"user_document\\" asc","time":"146.75","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 12:53:55
7643	9d52df9d-2fb5-4969-9385-2f0bdb131255	9d52df9d-512c-4224-b111-54bdd901bf3f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":29,"hostname":"EderCortes"}	2024-10-24 12:57:25
7644	9d52df9d-4f2a-4633-be47-f3956dfb0cbd	9d52df9d-512c-4224-b111-54bdd901bf3f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":30,"hostname":"EderCortes"}	2024-10-24 12:57:25
7645	9d52df9d-4fe2-4885-91e9-e954c3bb0e45	9d52df9d-512c-4224-b111-54bdd901bf3f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:57:25
12742	9d5cecbb-ae35-4ff4-8126-a455001eebef	9d5cecbb-f601-46c5-a4fd-9ea85a938e4f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-10-29 12:52:22
12743	9d5cecbb-ebd8-4a9b-b8ba-16fea40614eb	9d5cecbb-f601-46c5-a4fd-9ea85a938e4f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"102.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 12:52:22
12744	9d5cecbb-ec57-420b-a600-1819c47147a2	9d5cecbb-f601-46c5-a4fd-9ea85a938e4f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 12:52:22
12745	9d5cecbb-f3cf-4fd8-a76a-b2ae8627da7a	9d5cecbb-f601-46c5-a4fd-9ea85a938e4f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":29,"hostname":"EderCortes"}	2024-10-29 12:52:22
20847	9d66fc35-2abf-4bc1-a49f-39f4d95ef716	9d66fc35-2bdf-4883-b58e-b588928513f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-03 12:53:55
25320	9d68c12a-d7d9-4906-b7a4-28a51a0ec856	9d68c12a-e04c-4af6-9391-a4ac079af3f5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 10:00:29
7646	9d52df9d-a744-4bcd-96ef-ad2d551cc953	9d52df9d-cb01-46e1-83bb-5a2230fb6b31	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":30,"hostname":"EderCortes"}	2024-10-24 12:57:25
4256	9d5129d5-0edb-43d5-9a39-db48dcde42d8	9d5129d5-32fd-448c-96ae-339b7945a595	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 16:33:17
4257	9d5129d5-3125-4d17-ae3e-775687644885	9d5129d5-32fd-448c-96ae-339b7945a595	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 16:33:17
4258	9d5129d5-31ed-46b1-a498-0054c47e74a9	9d5129d5-32fd-448c-96ae-339b7945a595	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":306,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:33:17
3635	9d5108fb-64bd-48c2-94bb-841ca19c7d3f	9d5108fb-a089-4fb7-be30-6b9f1fc74f8d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-23 15:01:26
3636	9d5108fb-9518-4c40-a4eb-13bcdcd821da	9d5108fb-a089-4fb7-be30-6b9f1fc74f8d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"80.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:01:26
3637	9d5108fb-95bd-41cc-8da1-87e560a8e53a	9d5108fb-a089-4fb7-be30-6b9f1fc74f8d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 15:01:26
3638	9d5108fb-9e16-4c2a-b879-94ad94696a84	9d5108fb-a089-4fb7-be30-6b9f1fc74f8d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-10-23 15:01:26
3639	9d5108fb-9eb1-4240-b6e7-2d81e7656b52	9d5108fb-a089-4fb7-be30-6b9f1fc74f8d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":588,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:01:26
7647	9d52df9d-c448-448b-a9c6-bf3fb737d7ff	9d52df9d-cb01-46e1-83bb-5a2230fb6b31	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:57:25
7648	9d52df9d-c4ea-48f9-bd57-a36e37d4ec23	9d52df9d-cb01-46e1-83bb-5a2230fb6b31	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:57:25
7649	9d52df9d-c99d-4c61-802c-39ecc7036e64	9d52df9d-cb01-46e1-83bb-5a2230fb6b31	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":31,"hostname":"EderCortes"}	2024-10-24 12:57:25
7650	9d52df9d-c9ea-4f6d-be2a-a0d8bf5e9409	9d52df9d-cb01-46e1-83bb-5a2230fb6b31	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":282,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:57:25
14972	9d5ec6e5-d4bf-4e74-9144-962b34227a59	9d5ec6e5-d5cf-4be7-8bd5-330cbedcf5fd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:58:14
7820	9d52e1c3-41af-408a-a646-408668f3f7fc	9d52e1c3-6cd0-4297-b195-fa03650cc100	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 13:03:25
7821	9d52e1c3-6afb-4e5a-a89c-2c3e679d3fa2	9d52e1c3-6cd0-4297-b195-fa03650cc100	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:03:25
7822	9d52e1c3-6bc4-41a6-8805-8f6296541136	9d52e1c3-6cd0-4297-b195-fa03650cc100	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":300,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:03:25
20848	9d66fc35-2b00-4caa-9563-4f978be7c5f3	9d66fc35-2bdf-4883-b58e-b588928513f6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mar"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:53:55
7823	9d52e1c3-d275-4ba4-ba49-55a420e13a2c	9d52e1c3-f8fa-49ac-b46a-2ae8022eb91a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:03:25
2844	9d50fc9e-1d8e-41dc-8d7e-548385e7fd50	9d50fc9e-64e1-4c1b-ae59-da2cb7b3b56d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 14:26:51
2845	9d50fc9e-62dd-4802-8416-0b5a28f9069c	9d50fc9e-64e1-4c1b-ae59-da2cb7b3b56d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 14:26:51
2846	9d50fc9e-639f-45e5-b4c9-6c9d35435d99	9d50fc9e-64e1-4c1b-ae59-da2cb7b3b56d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":346,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:26:51
7824	9d52e1c3-f1ec-4a34-883f-c1ec2d3c7f6b	9d52e1c3-f8fa-49ac-b46a-2ae8022eb91a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"52.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:03:25
7651	9d52df9e-1ba8-454c-8ee0-c1a7f399c63c	9d52df9e-3bb2-494b-a2d2-cbddcd399498	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":31,"hostname":"EderCortes"}	2024-10-24 12:57:25
7652	9d52df9e-35c5-483f-bdf8-8557806ac1d5	9d52df9e-3bb2-494b-a2d2-cbddcd399498	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:57:25
7653	9d52df9e-3628-44ca-8e2d-3456167477f2	9d52df9e-3bb2-494b-a2d2-cbddcd399498	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:57:25
7654	9d52df9e-3a90-465d-a4fc-ff431a62908d	9d52df9e-3bb2-494b-a2d2-cbddcd399498	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":32,"hostname":"EderCortes"}	2024-10-24 12:57:25
7825	9d52e1c3-f25f-4b24-bddc-4bcec6441ada	9d52e1c3-f8fa-49ac-b46a-2ae8022eb91a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:03:25
7655	9d52df9e-3ae2-4ff6-ae0d-3cf6d8880951	9d52df9e-3bb2-494b-a2d2-cbddcd399498	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":273,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:57:25
7826	9d52e1c3-f7b1-4dd1-a016-ea324fe2c01f	9d52e1c3-f8fa-49ac-b46a-2ae8022eb91a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:03:25
7827	9d52e1c3-f806-4c7d-ba5a-4067f754b807	9d52e1c3-f8fa-49ac-b46a-2ae8022eb91a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":328,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:03:25
14973	9d5ec74d-1265-4b05-96cc-f78ec9a23c18	9d5ec74d-15cc-4442-8e04-b4d429601168	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":144,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:59:22
21121	9d6734cc-05fc-4cc4-89bf-fafbdd26c7aa	9d6734cc-0a7d-4c3f-b2db-53a3ca55d488	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"41.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 15:32:09
21122	9d6734cc-08fc-4f2d-9306-1df2af063786	9d6734cc-0a7d-4c3f-b2db-53a3ca55d488	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 15:32:09
25321	9d68c12a-d908-498d-9756-210fb15d2c96	9d68c12a-e04c-4af6-9391-a4ac079af3f5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_estado\\" = 'Cancelado', \\"loans_pago_interes\\" = 275000, \\"loans_pago_prestado\\" = 1100000, \\"updated_at\\" = '2024-11-04 10:00:29' where \\"id\\" = 90","time":"1.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":733,"hash":"acfe32aea56c9ca6bdbb917f944a78d1","hostname":"EderCortes"}	2024-11-04 10:00:29
2847	9d50fc9e-adc5-43b1-b307-ba4d3b93b57b	9d50fc9e-cdc5-42bb-aac8-4fb1fb3c7b89	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 14:26:52
2848	9d50fc9e-c826-4384-8cd0-d5ab4b30728d	9d50fc9e-cdc5-42bb-aac8-4fb1fb3c7b89	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:26:52
2849	9d50fc9e-c87f-4727-a9df-fcc566c0e54c	9d50fc9e-cdc5-42bb-aac8-4fb1fb3c7b89	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:26:52
2850	9d50fc9e-cca2-4fb4-8d0d-2cb2506d3f06	9d50fc9e-cdc5-42bb-aac8-4fb1fb3c7b89	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 14:26:52
2851	9d50fc9e-cce4-4379-b003-03c1b71269e8	9d50fc9e-cdc5-42bb-aac8-4fb1fb3c7b89	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:26:52
4259	9d5129d5-8225-4117-8c79-a6453fc82628	9d5129d5-de93-4c04-a076-afdf60a9b1dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 16:33:17
2858	9d50fca0-5d35-4867-ac95-dc2f7b08b214	9d50fca0-a44b-4cee-9ccc-baf7ab5da84c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 14:26:53
2859	9d50fca0-a1f5-4880-ab62-800bf3a260b7	9d50fca0-a44b-4cee-9ccc-baf7ab5da84c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 14:26:53
2860	9d50fca0-a2ec-4d34-9423-eead18831ef4	9d50fca0-a44b-4cee-9ccc-baf7ab5da84c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":774,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:26:53
4260	9d5129d5-d701-4797-8e24-e7e56b210230	9d5129d5-de93-4c04-a076-afdf60a9b1dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"193.37","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:33:17
3640	9d5108fc-214e-4a9d-9901-512e849f7198	9d5108fc-54a7-4cdb-8ea2-05efde24f8b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-10-23 15:01:26
3641	9d5108fc-4c84-4078-a92f-97ffc65bf503	9d5108fc-54a7-4cdb-8ea2-05efde24f8b9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"73.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:01:26
3642	9d5108fc-4d27-4c18-be0b-c1774087ce73	9d5108fc-54a7-4cdb-8ea2-05efde24f8b9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 15:01:26
3643	9d5108fc-52d6-4f94-b6b4-dd3a424812be	9d5108fc-54a7-4cdb-8ea2-05efde24f8b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-10-23 15:01:26
3644	9d5108fc-5375-407e-a2fc-e11084611103	9d5108fc-54a7-4cdb-8ea2-05efde24f8b9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":436,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:01:26
4261	9d5129d5-d764-4f90-a6b3-4e51284a9300	9d5129d5-de93-4c04-a076-afdf60a9b1dd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 16:33:17
4262	9d5129d5-dcf6-4f58-a79d-5cde72344ca5	9d5129d5-de93-4c04-a076-afdf60a9b1dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 16:33:17
4263	9d5129d5-dd62-4875-a420-8f798e380f93	9d5129d5-de93-4c04-a076-afdf60a9b1dd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":409,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:33:17
7656	9d52df9e-8ada-4517-af95-bb6977c0b2a8	9d52df9e-ad89-466c-978b-78f70ed6641a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":32,"hostname":"EderCortes"}	2024-10-24 12:57:25
7657	9d52df9e-a5cb-4516-8342-6413ba40241c	9d52df9e-ad89-466c-978b-78f70ed6641a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"46.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:57:25
2852	9d50fc9f-1608-46f0-a232-330901911c6e	9d50fc9f-37d7-4ac3-b328-a8edf116dfed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 14:26:52
2853	9d50fc9f-3185-4e57-ab5c-a11f376e0bfd	9d50fc9f-37d7-4ac3-b328-a8edf116dfed	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:26:52
2854	9d50fc9f-31e9-405a-b384-cabc5232f2a1	9d50fc9f-37d7-4ac3-b328-a8edf116dfed	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:26:52
2855	9d50fc9f-3699-455b-adab-ccc1818f7dcb	9d50fc9f-37d7-4ac3-b328-a8edf116dfed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 14:26:52
2856	9d50fc9f-36e5-4d98-92ab-927010bf0cea	9d50fc9f-37d7-4ac3-b328-a8edf116dfed	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":256,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:26:52
2861	9d50fca0-fe0c-45cf-b7b3-936ffb24a65a	9d50fca1-4c27-43a8-ab04-9c9af60f0aa8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 14:26:53
2862	9d50fca1-465e-4835-88e2-d8c7e35ed830	9d50fca1-4c27-43a8-ab04-9c9af60f0aa8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"162.76","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:26:53
2863	9d50fca1-46a7-4cf2-a513-f23371374930	9d50fca1-4c27-43a8-ab04-9c9af60f0aa8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:26:53
2864	9d50fca1-4ae8-421b-86aa-960f8d07f381	9d50fca1-4c27-43a8-ab04-9c9af60f0aa8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 14:26:53
2865	9d50fca1-4b2f-4167-a355-b58532606ca8	9d50fca1-4c27-43a8-ab04-9c9af60f0aa8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":392,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:26:53
3645	9d5108fd-3204-4f73-8ef4-f1a1a5027fea	9d5108fd-8e3b-4d89-b139-49978c176ce1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-10-23 15:01:27
3646	9d5108fd-843f-41f4-9a3b-fc2af2d1fed8	9d5108fd-8e3b-4d89-b139-49978c176ce1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"121.52","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 15:01:27
3647	9d5108fd-8530-4ce4-a4ff-f04405a57c37	9d5108fd-8e3b-4d89-b139-49978c176ce1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 15:01:27
3648	9d5108fd-8c20-4f85-b102-facd5475ddbd	9d5108fd-8e3b-4d89-b139-49978c176ce1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-10-23 15:01:27
3649	9d5108fd-8cc7-4c02-b780-7e6ebf0495d8	9d5108fd-8e3b-4d89-b139-49978c176ce1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":780,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:01:27
4264	9d5129d6-5f93-4028-954f-76c5d023d342	9d5129d6-ac6c-423a-940a-b27aa617c474	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 16:33:18
4265	9d5129d6-a63f-4713-a5dc-0b4d334dddcd	9d5129d6-ac6c-423a-940a-b27aa617c474	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"153.71","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:33:18
4266	9d5129d6-a6b2-4df9-8d51-fa7e17ca30f0	9d5129d6-ac6c-423a-940a-b27aa617c474	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 16:33:18
4267	9d5129d6-ab15-46f9-a0d3-b959f48cde7e	9d5129d6-ac6c-423a-940a-b27aa617c474	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 16:33:18
2866	9d50fca1-9a0e-47a1-af37-8f2e9fc9c7f0	9d50fca1-ba33-4916-a45f-d5abb240f174	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 14:26:53
3650	9d5108fe-1272-4fe8-8176-5d0adf62fa04	9d5108fe-3511-4390-82e3-e88e9e7f95a9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-10-23 15:01:27
3651	9d5108fe-2f82-42ad-a428-fe9038b742f0	9d5108fe-3511-4390-82e3-e88e9e7f95a9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 15:01:27
3652	9d5108fe-2fec-40c3-978d-3b9c672f1302	9d5108fe-3511-4390-82e3-e88e9e7f95a9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 15:01:27
3653	9d5108fe-3376-48ec-9cb7-6809194b5b1e	9d5108fe-3511-4390-82e3-e88e9e7f95a9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-10-23 15:01:27
3654	9d5108fe-33bb-4aac-84de-dc707274f4bc	9d5108fe-3511-4390-82e3-e88e9e7f95a9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":389,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:01:27
4268	9d5129d6-ab75-41cf-b8ec-2651386c8793	9d5129d6-ac6c-423a-940a-b27aa617c474	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":487,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:33:18
7658	9d52df9e-a620-43c3-a903-8929004cafaa	9d52df9e-ad89-466c-978b-78f70ed6641a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:57:25
4398	9d512e71-f48e-4a3f-903f-3a25c82d5e55	9d512e72-4f6f-43ef-9a9c-5b0e62e81e5b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 16:46:11
4399	9d512e72-4d0b-49db-9c2f-797a8b0a87f5	9d512e72-4f6f-43ef-9a9c-5b0e62e81e5b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 16:46:11
4400	9d512e72-4e01-4abf-b8dc-4b9ce8af5c9d	9d512e72-4f6f-43ef-9a9c-5b0e62e81e5b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":475,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:46:11
5489	9d5220f4-7f5e-4bc2-8031-368827ec8e25	9d5220f5-a050-4cdd-a561-0af184fa4c8c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 04:04:17
7659	9d52df9e-a7cf-44d8-841d-393fd7fff2b7	9d52df9e-ad89-466c-978b-78f70ed6641a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"1.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:57:25
7660	9d52df9e-a806-4e87-bb97-4524ac4087b0	9d52df9e-ad89-466c-978b-78f70ed6641a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:57:25
7661	9d52df9e-ac26-4ef9-8646-2eeb72a73095	9d52df9e-ad89-466c-978b-78f70ed6641a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":33,"hostname":"EderCortes"}	2024-10-24 12:57:25
7828	9d52e1c4-483a-42a8-86ee-4f90d27615a7	9d52e1c4-6b41-4998-85b1-39382def1493	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:03:26
7829	9d52e1c4-654b-4d40-9369-ddfb794324c3	9d52e1c4-6b41-4998-85b1-39382def1493	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:03:26
7830	9d52e1c4-65a4-4e48-a6bc-46cb2a33e790	9d52e1c4-6b41-4998-85b1-39382def1493	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:03:26
7662	9d52df9e-ac77-4e0f-921b-111718671407	9d52df9e-ad89-466c-978b-78f70ed6641a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:57:25
7831	9d52e1c4-69f9-48a1-90c7-80595d2566a3	9d52e1c4-6b41-4998-85b1-39382def1493	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:03:26
7832	9d52e1c4-6a4f-4300-8984-97470fa8fea9	9d52e1c4-6b41-4998-85b1-39382def1493	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:03:26
5490	9d5220f5-998a-474e-9e17-455bc2699b60	9d5220f5-a050-4cdd-a561-0af184fa4c8c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 04:04:18
2867	9d50fca1-b4eb-46a4-9cdb-7a9d404ff335	9d50fca1-ba33-4916-a45f-d5abb240f174	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:26:54
5491	9d5220f5-9cfc-4465-b667-a19e92c16f93	9d5220f5-a050-4cdd-a561-0af184fa4c8c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1391,"memory":22,"hostname":"EderCortes"}	2024-10-24 04:04:18
14974	9d5ec74d-943a-41e0-9e03-f93a3c3749be	9d5ec74d-bb61-481e-9ff4-bea766cb4f6e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-30 10:59:22
14975	9d5ec74d-b0ed-4c29-8024-e61ee9494a73	9d5ec74d-bb61-481e-9ff4-bea766cb4f6e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta', 'De las nieve', 'ds', 'CC', '100465546', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '500000', 50, 5, 'S', null, '30-10-2024', 'Pendiente', '312596295', 12, 14, 18, 14, '30-10-2024', '2024-10-30 10:59:22', '2024-10-30 10:59:22') returning \\"id\\"","time":"4.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":104,"hash":"bfad4cea82a73099ff0b3164dd496ca0","hostname":"EderCortes"}	2024-10-30 10:59:22
14976	9d5ec74d-b162-46fa-bb84-606fd7880962	9d5ec74d-bb61-481e-9ff4-bea766cb4f6e	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:61","hostname":"EderCortes"}	2024-10-30 10:59:22
14977	9d5ec74d-b2d7-48ca-8e29-3da4d33de0bc	9d5ec74d-bb61-481e-9ff4-bea766cb4f6e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (61, 1, 100000, 50000, 'Pendiente', 'N\\/A', '07-11-2024', 12, '2024-10-30 10:59:22', '2024-10-30 10:59:22')","time":"2.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":153,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 10:59:22
14978	9d5ec74d-b303-45d6-8cfb-46ffd92ecef1	9d5ec74d-bb61-481e-9ff4-bea766cb4f6e	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 10:59:22
14979	9d5ec74d-b38c-44f3-829e-8f700c8df146	9d5ec74d-bb61-481e-9ff4-bea766cb4f6e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (61, 2, 100000, 50000, 'Pendiente', 'N\\/A', '15-11-2024', 12, '2024-10-30 10:59:22', '2024-10-30 10:59:22')","time":"0.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":153,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 10:59:22
14980	9d5ec74d-b3b3-41b8-8702-39daeef21fc3	9d5ec74d-bb61-481e-9ff4-bea766cb4f6e	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 10:59:22
14981	9d5ec74d-b424-424e-a4eb-2000c8faac1a	9d5ec74d-bb61-481e-9ff4-bea766cb4f6e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (61, 3, 100000, 50000, 'Pendiente', 'N\\/A', '23-11-2024', 12, '2024-10-30 10:59:22', '2024-10-30 10:59:22')","time":"0.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":153,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 10:59:22
14982	9d5ec74d-b448-45e1-81f6-7004965ba9dc	9d5ec74d-bb61-481e-9ff4-bea766cb4f6e	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 10:59:22
4401	9d512e72-b8d4-40dd-9e2c-14c12d4dcb37	9d512e73-0928-410f-8285-906e17888083	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 16:46:11
4402	9d512e73-0053-4601-81f8-2690b9e02359	9d512e73-0928-410f-8285-906e17888083	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"158.88","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:46:12
4403	9d512e73-00cf-4a81-a71f-f7fec358887b	9d512e73-0928-410f-8285-906e17888083	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 16:46:12
4404	9d512e73-0743-43e2-91c1-8b5a8094d45d	9d512e73-0928-410f-8285-906e17888083	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 16:46:12
2868	9d50fca1-b53c-4ed7-8a09-de8a60fee023	9d50fca1-ba33-4916-a45f-d5abb240f174	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:26:54
2869	9d50fca1-b916-494e-9dad-1a2bb34465f4	9d50fca1-ba33-4916-a45f-d5abb240f174	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 14:26:54
3659	9d51092d-71fb-4d1e-8b05-bfdc460e995f	9d51092d-97d5-4588-9b62-a1e752f84687	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-10-23 15:01:58
3660	9d51092d-9148-4617-a707-d97b6376b70b	9d51092d-97d5-4588-9b62-a1e752f84687	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"56.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:01:58
3661	9d51092d-91bd-49b5-a57c-078528a1ffdf	9d51092d-97d5-4588-9b62-a1e752f84687	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 15:01:58
3662	9d51092d-9631-435e-bf9b-073d2fc42474	9d51092d-97d5-4588-9b62-a1e752f84687	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-10-23 15:01:58
3663	9d51092d-96a8-4c60-92d0-31d55e11a623	9d51092d-97d5-4588-9b62-a1e752f84687	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":322,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:01:58
4405	9d512e73-07bf-40ae-833a-f35ed3996900	9d512e73-0928-410f-8285-906e17888083	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":442,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:46:12
5492	9d5220f6-7b15-4449-870d-890804c3450c	9d5220f6-cb1e-444b-835e-c2e36414282e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 04:04:19
5493	9d5220f6-b861-41d3-a21c-449f78f5baa3	9d5220f6-cb1e-444b-835e-c2e36414282e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"85.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 04:04:19
5494	9d5220f6-b8e7-48ef-a880-a5e67e758f62	9d5220f6-cb1e-444b-835e-c2e36414282e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 04:04:19
5495	9d5220f6-c913-41fa-acbc-920311a07d6a	9d5220f6-cb1e-444b-835e-c2e36414282e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 04:04:19
5496	9d5220f6-c9d1-4a08-bf0c-ac444f76b7df	9d5220f6-cb1e-444b-835e-c2e36414282e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":616,"memory":22,"hostname":"EderCortes"}	2024-10-24 04:04:19
7663	9d52df9f-ddb6-409f-bd4d-72a2ee877510	9d52dfa0-1171-4fc2-a744-3fc3593024fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":33,"hostname":"EderCortes"}	2024-10-24 12:57:26
7664	9d52dfa0-0919-44db-ab5d-322fe37cd326	9d52dfa0-1171-4fc2-a744-3fc3593024fd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"69.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:57:26
7665	9d52dfa0-0997-4289-bc80-e0e19deb2186	9d52dfa0-1171-4fc2-a744-3fc3593024fd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:57:26
7666	9d52dfa0-0fae-4784-9189-278f4ba3248d	9d52dfa0-1171-4fc2-a744-3fc3593024fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":34,"hostname":"EderCortes"}	2024-10-24 12:57:26
5497	9d5220f8-6dcd-40cb-964d-eaa2f9fc0c4e	9d5220f9-31f7-48ed-8e87-031b9603f7b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 04:04:20
5498	9d5220f9-2805-49ac-82a6-02c68b4876a9	9d5220f9-31f7-48ed-8e87-031b9603f7b1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"211.30","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 04:04:20
5499	9d5220f9-28ba-4466-bcf8-2eb22f5b619a	9d5220f9-31f7-48ed-8e87-031b9603f7b1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 04:04:20
4406	9d512e73-788c-4ceb-ae34-7d092b71264e	9d512e73-c904-4fa7-aa5c-7d8d5c6619a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 16:46:12
3664	9d51092d-e5f2-4257-a1e3-874d19448df1	9d51092e-0893-4e43-9eb6-2c59d6642a27	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-10-23 15:01:59
3665	9d51092e-02bd-408b-8a69-df2cfbe05c90	9d51092e-0893-4e43-9eb6-2c59d6642a27	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:01:59
3666	9d51092e-0331-4ef7-8a62-5634cdafd14b	9d51092e-0893-4e43-9eb6-2c59d6642a27	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 15:01:59
3667	9d51092e-0761-41b0-ad73-0017b9d95653	9d51092e-0893-4e43-9eb6-2c59d6642a27	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-10-23 15:01:59
3668	9d51092e-07a5-44e5-8051-047360c906f7	9d51092e-0893-4e43-9eb6-2c59d6642a27	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":265,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:01:59
4407	9d512e73-c3c9-4638-afd0-456560c51e26	9d512e73-c904-4fa7-aa5c-7d8d5c6619a6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"157.96","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:46:12
4408	9d512e73-c415-43c1-9dc6-4b626cc1ef11	9d512e73-c904-4fa7-aa5c-7d8d5c6619a6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 16:46:12
4409	9d512e73-c7b7-4629-b7e9-c39f87dad062	9d512e73-c904-4fa7-aa5c-7d8d5c6619a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 16:46:12
5500	9d5220f9-3005-4ae7-95f9-b9c5d8ac5f62	9d5220f9-31f7-48ed-8e87-031b9603f7b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 04:04:20
5501	9d5220f9-3082-4626-822a-bd60b7e38aee	9d5220f9-31f7-48ed-8e87-031b9603f7b1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":1548,"memory":22,"hostname":"EderCortes"}	2024-10-24 04:04:20
7667	9d52dfa0-1022-4b27-9b33-f67b7942ae79	9d52dfa0-1171-4fc2-a744-3fc3593024fd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":479,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:57:26
7833	9d52e1c4-bda6-43aa-943b-d5f155177d01	9d52e1c4-e3e2-40d0-95ab-bfd840cc676a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:03:26
7834	9d52e1c4-dbf8-4b59-be0d-66d68e5f1bd7	9d52e1c4-e3e2-40d0-95ab-bfd840cc676a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"51.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 13:03:26
7835	9d52e1c4-dc68-4adc-8602-3466f2440e99	9d52e1c4-e3e2-40d0-95ab-bfd840cc676a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:03:26
2540	9d50fa2b-c51a-4682-8be1-528783a033bf	9d50fa2c-2b36-4329-b372-6383727e70de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 14:20:01
2541	9d50fa2c-285a-4d18-8af6-1240727175c0	9d50fa2c-2b36-4329-b372-6383727e70de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 14:20:01
2542	9d50fa2c-2980-47fa-b32b-054d006e2720	9d50fa2c-2b36-4329-b372-6383727e70de	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":643,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:20:01
7836	9d52e1c4-de9a-43b2-aedb-6a499e2c3202	9d52e1c4-e3e2-40d0-95ab-bfd840cc676a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"2.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 13:03:26
5502	9d5220fa-a4b1-40dd-856d-5ef064002b0b	9d5220fb-47c6-408f-b9b2-195e6735bd6c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 04:04:21
5503	9d5220fb-3cb6-41ef-84ce-5471522e008b	9d5220fb-47c6-408f-b9b2-195e6735bd6c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"214.51","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 04:04:22
7837	9d52e1c4-dee9-44b2-92a5-9ed5cd008f19	9d52e1c4-e3e2-40d0-95ab-bfd840cc676a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 13:03:26
5504	9d5220fb-3d34-40d2-b658-f45e77b1752f	9d5220fb-47c6-408f-b9b2-195e6735bd6c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 04:04:22
5505	9d5220fb-45ae-4962-b671-67681ca219cd	9d5220fb-47c6-408f-b9b2-195e6735bd6c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 04:04:22
7838	9d52e1c4-e28f-43cf-a691-e04b54e371ec	9d52e1c4-e3e2-40d0-95ab-bfd840cc676a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:03:26
7839	9d52e1c4-e2f5-4995-88f9-fe1d629b0981	9d52e1c4-e3e2-40d0-95ab-bfd840cc676a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":289,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:03:26
14983	9d5ec74d-b4ad-49b0-9e92-93a968ddf2e0	9d5ec74d-bb61-481e-9ff4-bea766cb4f6e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (61, 4, 100000, 50000, 'Pendiente', 'N\\/A', '01-12-2024', 12, '2024-10-30 10:59:22', '2024-10-30 10:59:22')","time":"0.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":153,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 10:59:22
12746	9d5cecbb-f467-421e-abca-d755e6b5c5be	9d5cecbb-f601-46c5-a4fd-9ea85a938e4f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":576,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:22
7997	9d52e5c8-852f-4fc7-9d31-35fee30d8f48	9d52e5c8-d8d2-41a5-bdc2-ae1ecdd93c66	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 13:14:40
14984	9d5ec74d-b4ce-42b7-9408-8034ce79b6b6	9d5ec74d-bb61-481e-9ff4-bea766cb4f6e	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 10:59:22
14985	9d5ec74d-b531-42c4-a512-a2ee88722691	9d5ec74d-bb61-481e-9ff4-bea766cb4f6e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (61, 5, 100000, 50000, 'Pendiente', 'N\\/A', '09-12-2024', 12, '2024-10-30 10:59:22', '2024-10-30 10:59:22')","time":"0.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":153,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 10:59:22
14986	9d5ec74d-b551-44d4-bf9f-a8059e806bef	9d5ec74d-bb61-481e-9ff4-bea766cb4f6e	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 10:59:22
14987	9d5ec74d-b9df-426e-b5ae-0ee0ae363f60	9d5ec74d-bb61-481e-9ff4-bea766cb4f6e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 10:59:22
4410	9d512e73-c812-45db-84f0-ca7860bc68e9	9d512e73-c904-4fa7-aa5c-7d8d5c6619a6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":471,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:46:12
5506	9d5220fb-4648-48cd-aadd-400a582bb825	9d5220fb-47c6-408f-b9b2-195e6735bd6c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":1340,"memory":22,"hostname":"EderCortes"}	2024-10-24 04:04:22
7840	9d52e1c6-fe09-45fb-a254-04577a779555	9d52e1c7-2e94-4ec6-a6f1-a10b0ee7a4e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:03:27
7841	9d52e1c7-2660-4157-a194-57a9c82e06eb	9d52e1c7-2e94-4ec6-a6f1-a10b0ee7a4e8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"58.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:03:28
3673	9d510930-4276-438c-9e81-be7e7fcbb1b4	9d510930-6538-49e9-aaec-81a505530277	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-10-23 15:02:00
3674	9d510930-5e78-4228-998c-d1f13a68ffe2	9d510930-6538-49e9-aaec-81a505530277	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:02:00
3675	9d510930-5ecd-4af8-99e9-1bfc697b525e	9d510930-6538-49e9-aaec-81a505530277	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 15:02:00
3676	9d510930-634c-40ea-b671-4c64a73e1dea	9d510930-6538-49e9-aaec-81a505530277	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":29,"hostname":"EderCortes"}	2024-10-23 15:02:00
3677	9d510930-63e6-4727-9de7-27c270d6db6d	9d510930-6538-49e9-aaec-81a505530277	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":269,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:02:00
7842	9d52e1c7-26b9-4e0c-b13c-b80d8f5daaf6	9d52e1c7-2e94-4ec6-a6f1-a10b0ee7a4e8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:03:28
7843	9d52e1c7-2cd9-4290-b2dc-5e84c3d53d8a	9d52e1c7-2e94-4ec6-a6f1-a10b0ee7a4e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:03:28
7844	9d52e1c7-2d4d-460c-aa53-d335a87ac190	9d52e1c7-2e94-4ec6-a6f1-a10b0ee7a4e8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:03:28
5507	9d5220fd-4afd-4cc0-a2d3-82d6e7a074f0	9d5220fd-9898-490f-804d-63b504b104ad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 04:04:23
3746	9d511767-388c-4f06-8c42-ef1f0d8d4403	9d511767-6e67-4019-9dc3-2b8b20f3bc7b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 15:41:45
3747	9d511767-6ab4-439f-847f-b62afca60f9d	9d511767-6e67-4019-9dc3-2b8b20f3bc7b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 15:41:45
3748	9d511767-6c3b-44d9-9f52-17b02cc5a2ba	9d511767-6e67-4019-9dc3-2b8b20f3bc7b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":824,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:41:45
3678	9d510930-b503-487d-8bc6-a2350a1200ac	9d510930-da7d-4793-9743-b951e329065d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":29,"hostname":"EderCortes"}	2024-10-23 15:02:00
3679	9d510930-d465-4598-8bd6-00402389b16e	9d510930-da7d-4793-9743-b951e329065d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"52.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:02:01
3680	9d510930-d4db-49ab-b3be-79f3fa2f2ea8	9d510930-da7d-4793-9743-b951e329065d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 15:02:01
3681	9d510930-d8ac-412f-ad3b-4b5a9585cac0	9d510930-da7d-4793-9743-b951e329065d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":30,"hostname":"EderCortes"}	2024-10-23 15:02:01
3682	9d510930-d93f-4780-a670-b55104a59058	9d510930-da7d-4793-9743-b951e329065d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":282,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:02:01
5508	9d5220fd-8f01-4c10-bf74-d0ca3b2d93c3	9d5220fd-9898-490f-804d-63b504b104ad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"87.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 04:04:23
5509	9d5220fd-8f80-48ff-a9ed-5c5a3d3f6633	9d5220fd-9898-490f-804d-63b504b104ad	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 04:04:23
5510	9d5220fd-96a8-4e2f-801c-41dd06af594e	9d5220fd-9898-490f-804d-63b504b104ad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 04:04:23
5511	9d5220fd-972e-436e-b3f7-93c4a6e063d8	9d5220fd-9898-490f-804d-63b504b104ad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":703,"memory":22,"hostname":"EderCortes"}	2024-10-24 04:04:23
7845	9d52e239-832e-4547-bfef-1fdf99a869ee	9d52e239-aab9-432e-9b08-a682ade1d07c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 13:04:42
7846	9d52e239-a427-4011-8abe-9ddd090de317	9d52e239-aab9-432e-9b08-a682ade1d07c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"52.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-24 13:04:43
7847	9d52e239-a8da-48e9-9e09-650de67fcd23	9d52e239-aab9-432e-9b08-a682ade1d07c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:04:43
7998	9d52e5c8-d662-4ba8-a730-835fb75a3167	9d52e5c8-d8d2-41a5-bdc2-ae1ecdd93c66	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:14:40
7999	9d52e5c8-d77f-4ee5-8415-2c6b9c532318	9d52e5c8-d8d2-41a5-bdc2-ae1ecdd93c66	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":418,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:14:40
12747	9d5cecbc-b30f-4f1e-a05d-0a61c83cbfa6	9d5cecbd-0202-4cc8-b48f-4d4612896646	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":29,"hostname":"EderCortes"}	2024-10-29 12:52:23
3749	9d511767-f6ad-44e2-aa1d-19abe45af7e3	9d511768-507a-4816-8874-2cd1881cb283	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 15:41:46
3750	9d511768-4afc-4e8f-bde8-2a6831e6c35b	9d511768-507a-4816-8874-2cd1881cb283	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"160.55","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:41:46
3751	9d511768-4b59-4665-8490-35aee0279611	9d511768-507a-4816-8874-2cd1881cb283	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 15:41:46
3752	9d511768-4ecb-44fc-9158-691aab921de8	9d511768-507a-4816-8874-2cd1881cb283	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 15:41:46
3683	9d510931-59dd-41e8-8128-39844447d4e8	9d510931-9c76-4e58-834e-7d10749a8b63	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":30,"hostname":"EderCortes"}	2024-10-23 15:02:01
3684	9d510931-9135-477d-8437-b617460ab6c9	9d510931-9c76-4e58-834e-7d10749a8b63	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"84.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 15:02:01
3685	9d510931-91b5-40b6-87be-844decbaa0fc	9d510931-9c76-4e58-834e-7d10749a8b63	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 15:02:01
3686	9d510931-9a14-45e1-9d82-621397f4c3bc	9d510931-9c76-4e58-834e-7d10749a8b63	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":31,"hostname":"EderCortes"}	2024-10-23 15:02:01
3687	9d510931-9aad-4587-9031-3cc880eb709e	9d510931-9c76-4e58-834e-7d10749a8b63	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":481,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:02:01
3753	9d511768-4f34-4bcf-a67f-53f5cf746cd6	9d511768-507a-4816-8874-2cd1881cb283	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":541,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:41:46
7848	9d52e239-a942-44c8-a4c7-c2602ec05e91	9d52e239-aab9-432e-9b08-a682ade1d07c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":311,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:04:43
8000	9d52e5c9-4af0-45a4-b876-fecd99b602ad	9d52e5c9-77ec-4b3c-a9b9-4921e84f05e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:14:40
8001	9d52e5c9-6e6f-431f-8742-d9e1de2698f8	9d52e5c9-77ec-4b3c-a9b9-4921e84f05e8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"51.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:14:40
8002	9d52e5c9-6ef5-4ae8-bc47-91d2cdb88faf	9d52e5c9-77ec-4b3c-a9b9-4921e84f05e8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:14:40
8003	9d52e5c9-7610-4c7a-b6c8-3f267f0a6ad2	9d52e5c9-77ec-4b3c-a9b9-4921e84f05e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:14:40
12748	9d5cecbc-fb8e-4afd-aaa2-1f272bba5e25	9d5cecbd-0202-4cc8-b48f-4d4612896646	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"149.94","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 12:52:23
12749	9d5cecbc-fc04-44c9-a82b-490f2a76ee4b	9d5cecbd-0202-4cc8-b48f-4d4612896646	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 12:52:23
12750	9d5cecbd-0062-4c6c-8c0e-c68b9c1ef592	9d5cecbd-0202-4cc8-b48f-4d4612896646	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":30,"hostname":"EderCortes"}	2024-10-29 12:52:23
3754	9d511768-9122-45d1-8552-83b5ac878d22	9d511768-b0a1-4ece-bb8d-ba32fecf3094	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 15:41:46
3755	9d511768-abe3-463c-9e70-96ebe6fd6f39	9d511768-b0a1-4ece-bb8d-ba32fecf3094	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:41:46
3756	9d511768-ac45-4926-ae02-848b96e97b3a	9d511768-b0a1-4ece-bb8d-ba32fecf3094	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 15:41:46
3757	9d511768-af87-45fc-87ab-1fc409f6936c	9d511768-b0a1-4ece-bb8d-ba32fecf3094	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 15:41:46
3688	9d510932-4253-4c2a-85f5-465cecbdcc1c	9d510932-7032-4316-84c9-c30e6de32627	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":31,"hostname":"EderCortes"}	2024-10-23 15:02:02
3689	9d510932-685f-4831-b332-bc1714ac05f4	9d510932-7032-4316-84c9-c30e6de32627	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"62.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 15:02:02
3690	9d510932-68fb-4d34-8eb2-079e29e20970	9d510932-7032-4316-84c9-c30e6de32627	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 15:02:02
3691	9d510932-6eb1-408e-8ec8-ed95e1285179	9d510932-7032-4316-84c9-c30e6de32627	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":32,"hostname":"EderCortes"}	2024-10-23 15:02:02
3692	9d510932-6f15-4bed-913a-2bd5db2f45d3	9d510932-7032-4316-84c9-c30e6de32627	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":510,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:02:02
3758	9d511768-afc6-4d59-903e-b92bdb7cf356	9d511768-b0a1-4ece-bb8d-ba32fecf3094	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:41:46
7849	9d52e241-59ae-4493-8e9b-b6ea3bdbd924	9d52e241-7a44-454f-ac11-61dc1513a631	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:04:48
7850	9d52e241-7548-4a67-b332-59f3c2ec2b75	9d52e241-7a44-454f-ac11-61dc1513a631	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:04:48
7851	9d52e241-7598-42a1-83ec-6b3324c2f346	9d52e241-7a44-454f-ac11-61dc1513a631	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:04:48
7852	9d52e241-7905-41da-b6b3-dcc493924eba	9d52e241-7a44-454f-ac11-61dc1513a631	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:04:48
7853	9d52e241-7948-4137-bb2d-e8b01eb54260	9d52e241-7a44-454f-ac11-61dc1513a631	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":408,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:04:48
3759	9d511769-3556-48f1-acbe-9d7d3c0649ef	9d511769-6d9b-4437-b392-3c19144e4cbd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 15:41:46
3760	9d511769-6113-4f87-822e-33d0010126a9	9d511769-6d9b-4437-b392-3c19144e4cbd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"75.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 15:41:46
3761	9d511769-61b0-404a-9030-ba18d9e58137	9d511769-6d9b-4437-b392-3c19144e4cbd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 15:41:46
3762	9d511769-6b3a-42a3-917b-0ac043c11959	9d511769-6d9b-4437-b392-3c19144e4cbd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 15:41:46
3763	9d511769-6bd9-4049-a075-32912c3458c0	9d511769-6d9b-4437-b392-3c19144e4cbd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":466,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:41:46
7854	9d52e241-bbbd-4eac-a8f2-a922feed5246	9d52e242-0395-418b-84a2-ba888f76e1dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:04:48
7855	9d52e241-fdfb-4777-96b7-488d9624e0e2	9d52e242-0395-418b-84a2-ba888f76e1dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"149.49","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:04:48
7856	9d52e241-fe45-4ac7-a8bd-2825e12ccfb7	9d52e242-0395-418b-84a2-ba888f76e1dd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:04:48
7857	9d52e242-026d-4ab4-a492-32446ca27bca	9d52e242-0395-418b-84a2-ba888f76e1dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:04:48
7858	9d52e242-02ae-4f73-8abe-329ab9adb077	9d52e242-0395-418b-84a2-ba888f76e1dd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":332,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:04:48
8004	9d52e5c9-7692-4b07-9684-75b65ef6ac96	9d52e5c9-77ec-4b3c-a9b9-4921e84f05e8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":371,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:14:40
14988	9d5ec74d-ba3a-4bee-b8f7-d25567cf9236	9d5ec74d-bb61-481e-9ff4-bea766cb4f6e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"743","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"100465546","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"500000","loans_intereses":50,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":18,"user_recomendacion":14,"loans_inicio_pago":"30-10-2024","created_at":null,"updated_at":null,"deleted_at":null},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Wed Oct 30 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":61},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:59:22
8005	9d52e5c9-cbb4-41bb-b40e-95d648cee63c	9d52e5ca-1a22-4862-b8bf-1e3be70021ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:14:40
8006	9d52e5ca-1303-46b0-961e-c599ed3405c9	9d52e5ca-1a22-4862-b8bf-1e3be70021ed	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"155.27","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:14:41
8007	9d52e5ca-136b-45fd-9ef3-ba7e8fbff4bd	9d52e5ca-1a22-4862-b8bf-1e3be70021ed	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:14:41
2692	9d50fb25-36b0-4646-8016-d12fe095bf9b	9d50fb25-6c34-4242-b67e-f0dfdac0a9f7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-10-23 14:22:44
2693	9d50fb25-6937-426c-8984-96f427df3c70	9d50fb25-6c34-4242-b67e-f0dfdac0a9f7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-10-23 14:22:44
2694	9d50fb25-6aba-4e45-8e95-4d45ad0efe9b	9d50fb25-6c34-4242-b67e-f0dfdac0a9f7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":526,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:22:44
7859	9d52e242-41d6-4688-bdfe-b5924bfa6f31	9d52e242-5fc8-46e4-9fa1-92a270f06943	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:04:48
7860	9d52e242-58d9-4a70-acbc-0388fc1da885	9d52e242-5fc8-46e4-9fa1-92a270f06943	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc","time":"41.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 13:04:48
7861	9d52e242-591f-438c-bbe5-2c2cf46dd2fa	9d52e242-5fc8-46e4-9fa1-92a270f06943	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:04:48
7862	9d52e242-5a82-4faa-8d06-9735cd21a0eb	9d52e242-5fc8-46e4-9fa1-92a270f06943	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6'","time":"1.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 13:04:48
7863	9d52e242-5ab1-4746-b2e3-528b141c6f02	9d52e242-5fc8-46e4-9fa1-92a270f06943	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:04:48
7864	9d52e242-5e89-421e-a748-cfee5487fac5	9d52e242-5fc8-46e4-9fa1-92a270f06943	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:04:48
7865	9d52e242-5ed5-4667-af78-e086c03415e8	9d52e242-5fc8-46e4-9fa1-92a270f06943	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":223,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:04:48
8008	9d52e5ca-18a8-42dc-9779-991c9868f13d	9d52e5ca-1a22-4862-b8bf-1e3be70021ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:14:41
8009	9d52e5ca-1907-4f9e-997e-9a5b4846668d	9d52e5ca-1a22-4862-b8bf-1e3be70021ed	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":397,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:14:41
14989	9d5ec752-7237-4a35-98d0-2dabccbd7ffc	9d5ec752-8bc4-4aa3-a40d-1f86a47044b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 10:59:25
14990	9d5ec752-8763-4eb6-9260-f3242fd2b386	9d5ec752-8bc4-4aa3-a40d-1f86a47044b3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"41.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-30 10:59:25
14991	9d5ec752-8a69-4cce-ad7a-cf25c455fd5c	9d5ec752-8bc4-4aa3-a40d-1f86a47044b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 10:59:25
25322	9d68c12a-d9b8-4405-9930-14a8a0d9d8bb	9d68c12a-e04c-4af6-9391-a4ac079af3f5	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:90","changes":{"loans_estado":"Cancelado","updated_at":"2024-11-04 10:00:29","loans_pago_interes":275000,"loans_pago_prestado":1100000},"hostname":"EderCortes"}	2024-11-04 10:00:29
8010	9d52e5ca-6242-4cc9-b99c-7d25a71f2781	9d52e5ca-8462-451f-88bd-99ab450f1ccf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:14:41
3428	9d5105e1-57a1-4ebf-85fd-807455bf7b23	9d5105e1-aa31-4ff3-8b7a-6c8bac69419b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 14:52:45
3429	9d5105e1-a838-490e-a443-646faa746314	9d5105e1-aa31-4ff3-8b7a-6c8bac69419b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:52:45
3430	9d5105e1-a904-4fc0-b45a-e10c05e53906	9d5105e1-aa31-4ff3-8b7a-6c8bac69419b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":449,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:52:45
8011	9d52e5ca-7b96-4c17-a6d3-c6f0aec03d7c	9d52e5ca-8462-451f-88bd-99ab450f1ccf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc","time":"43.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 13:14:41
3764	9d51176a-921b-4184-978e-b2b012b771de	9d51176a-bf3b-472a-8627-19f3ea7ba2a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 15:41:47
8012	9d52e5ca-7be1-4332-8118-f0bd7b7a69b3	9d52e5ca-8462-451f-88bd-99ab450f1ccf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:14:41
3765	9d51176a-b592-484a-998a-b66064818634	9d51176a-bf3b-472a-8627-19f3ea7ba2a1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"62.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 15:41:47
3766	9d51176a-b622-49ee-81f9-274f6e82d40b	9d51176a-bf3b-472a-8627-19f3ea7ba2a1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 15:41:47
3767	9d51176a-bd7c-4886-a14b-4cb23e773520	9d51176a-bf3b-472a-8627-19f3ea7ba2a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 15:41:47
3768	9d51176a-bde4-4a66-ab4f-da3f1fa60584	9d51176a-bf3b-472a-8627-19f3ea7ba2a1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:41:47
8013	9d52e5ca-7e01-4dd7-9065-4dd3dc6138ef	9d52e5ca-8462-451f-88bd-99ab450f1ccf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6'","time":"2.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 13:14:41
8014	9d52e5ca-7e36-4ae5-953b-feaf87a69915	9d52e5ca-8462-451f-88bd-99ab450f1ccf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:14:41
8015	9d52e5ca-82b9-488b-b8ca-ce7cd6c549b2	9d52e5ca-8462-451f-88bd-99ab450f1ccf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:14:41
8016	9d52e5ca-832c-445c-b0d4-19e83aed50fe	9d52e5ca-8462-451f-88bd-99ab450f1ccf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:14:41
14992	9d5ec752-8ac2-4bcf-8a3b-c07bed113650	9d5ec752-8bc4-4aa3-a40d-1f86a47044b3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:59:25
25323	9d68c12a-db00-4c12-a11b-5d79a05392a1	9d68c12a-e04c-4af6-9391-a4ac079af3f5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 90 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"2.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":738,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 10:00:29
25324	9d68c12a-db31-48f9-9c29-e97e14e20277	9d68c12a-e04c-4af6-9391-a4ac079af3f5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 10:00:29
3431	9d5105e2-0fa7-4a8b-96e9-9a2aba07eed4	9d5105e2-36d5-4dd8-90e6-eec1a1d2f0af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:52:46
3432	9d5105e2-2fa3-49e1-904f-9caba3d6ddcc	9d5105e2-36d5-4dd8-90e6-eec1a1d2f0af	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"54.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:52:46
3433	9d5105e2-3018-40a1-8baa-5c4681becdef	9d5105e2-36d5-4dd8-90e6-eec1a1d2f0af	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:52:46
3434	9d5105e2-352c-4b1e-9d04-e6558dd9f18d	9d5105e2-36d5-4dd8-90e6-eec1a1d2f0af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:52:46
3435	9d5105e2-3592-4fa8-9544-a8fc7287ed6e	9d5105e2-36d5-4dd8-90e6-eec1a1d2f0af	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:52:46
8017	9d52e5cc-5eab-407d-9727-338d724f0213	9d52e5cc-99eb-4dba-876a-0b0b7d55f247	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:14:42
8018	9d52e5cc-933b-4de0-80ca-a48320ce7acf	9d52e5cc-99eb-4dba-876a-0b0b7d55f247	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"89.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:14:42
8019	9d52e5cc-93b5-4088-9750-3d93deff562c	9d52e5cc-99eb-4dba-876a-0b0b7d55f247	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:14:42
8020	9d52e5cc-983e-4608-a41c-c1de06c7c536	9d52e5cc-99eb-4dba-876a-0b0b7d55f247	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:14:42
8021	9d52e5cc-988c-42f0-bec9-2b9f5c1cb4ae	9d52e5cc-99eb-4dba-876a-0b0b7d55f247	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":570,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:14:42
14993	9d5ec759-975c-4ce5-a05c-ae2a45d3cf68	9d5ec759-b4ce-4a63-89fb-c23d4d7432d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 10:59:30
8153	9d52e76d-19dd-4fdb-9578-81905c2bb8a9	9d52e76d-70ba-41a7-9646-02788d3712c2	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 13:19:15
8154	9d52e76d-6ee5-4191-b217-87e5f7844cfb	9d52e76d-70ba-41a7-9646-02788d3712c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:19:15
8155	9d52e76d-6fa6-49a3-8a83-18310266e443	9d52e76d-70ba-41a7-9646-02788d3712c2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":423,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:19:15
8309	9d52e832-7096-438b-8f1c-24bb59975831	9d52e832-b9fa-4e1a-be09-791b346804de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 13:21:24
8310	9d52e832-b870-4a84-b49f-33cbc96a238e	9d52e832-b9fa-4e1a-be09-791b346804de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 13:21:25
8311	9d52e832-b907-4083-be73-88a6f0f41561	9d52e832-b9fa-4e1a-be09-791b346804de	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":346,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:21:25
14994	9d5ec759-ac60-46d2-8a11-452fb08d4426	9d5ec759-b4ce-4a63-89fb-c23d4d7432d8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"42.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"0f4c36bf5d35305401eb74fea5df15be","hostname":"EderCortes"}	2024-10-30 10:59:30
8156	9d52e76d-dd4c-41b9-bb88-0097c51aa3c7	9d52e76e-037a-454b-aca6-7967fbd44155	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:19:16
2972	9d50fddf-24e4-469d-ae46-fa0efce2b282	9d50fddf-5e1c-4460-858e-0c01bc424830	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:30:22
2973	9d50fddf-5c16-4a9a-b05e-c13bb04bd8c8	9d50fddf-5e1c-4460-858e-0c01bc424830	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 14:30:22
2974	9d50fddf-5cdc-4be7-8ae7-500637b93a6f	9d50fddf-5e1c-4460-858e-0c01bc424830	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":700,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:30:22
5644	9d524841-d830-42c3-8bb9-cf965b7f81e5	9d524842-04a0-4edc-ba87-b4aec0925f0e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 05:54:11
5645	9d524842-0289-4c63-a705-7dfb1b74941c	9d524842-04a0-4edc-ba87-b4aec0925f0e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 05:54:11
5646	9d524842-0362-46ab-a4de-24c7729eef54	9d524842-04a0-4edc-ba87-b4aec0925f0e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":378,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:54:11
8157	9d52e76d-fc21-4b4e-a566-125b0cef08fb	9d52e76e-037a-454b-aca6-7967fbd44155	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:19:16
8158	9d52e76d-fcaa-4ecd-8a8e-778a63b4c469	9d52e76e-037a-454b-aca6-7967fbd44155	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:19:16
8159	9d52e76e-0257-4b5d-a032-b6055412e272	9d52e76e-037a-454b-aca6-7967fbd44155	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:19:16
8160	9d52e76e-02a3-48e6-867c-2789a894ee7f	9d52e76e-037a-454b-aca6-7967fbd44155	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:19:16
8312	9d52e832-ffd5-4f30-b2f2-8ad799afc0f7	9d52e833-1e42-4dda-a426-1a71988a0c00	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 13:21:25
8313	9d52e833-1907-4353-a86a-67d4851fe58c	9d52e833-1e42-4dda-a426-1a71988a0c00	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:21:25
8314	9d52e833-195a-469d-bf94-a516520cf6a1	9d52e833-1e42-4dda-a426-1a71988a0c00	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:21:25
8315	9d52e833-1d18-4cfb-8cfe-1716bdfaf30f	9d52e833-1e42-4dda-a426-1a71988a0c00	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 13:21:25
8316	9d52e833-1d5e-4b14-acfd-e476d8e3892a	9d52e833-1e42-4dda-a426-1a71988a0c00	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:21:25
14995	9d5ec759-afd2-48ec-a272-23a4cb7f40aa	9d5ec759-b4ce-4a63-89fb-c23d4d7432d8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-30 10:59:30
14996	9d5ec759-b01d-4253-8a52-82d43db50e13	9d5ec759-b4ce-4a63-89fb-c23d4d7432d8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-10-30 10:59:30
14997	9d5ec759-b399-45fc-8aa8-384a54a6cdad	9d5ec759-b4ce-4a63-89fb-c23d4d7432d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 10:59:30
14998	9d5ec759-b3dd-4109-b9b2-0d1e2bcee68f	9d5ec759-b4ce-4a63-89fb-c23d4d7432d8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":209,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:59:30
2975	9d50fddf-c60d-4984-9903-4a3da93c03c2	9d50fddf-e8bd-4eb1-bbc2-0e6878e20ab8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 14:30:22
2976	9d50fddf-e230-4537-850d-29cee5618b0b	9d50fddf-e8bd-4eb1-bbc2-0e6878e20ab8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:30:22
2977	9d50fddf-e29d-41cd-b333-3b29e4919e47	9d50fddf-e8bd-4eb1-bbc2-0e6878e20ab8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:30:22
2978	9d50fddf-e743-4fe5-9f24-886f10fbee04	9d50fddf-e8bd-4eb1-bbc2-0e6878e20ab8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 14:30:22
2979	9d50fddf-e7ae-486b-9654-ebdda2817240	9d50fddf-e8bd-4eb1-bbc2-0e6878e20ab8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":319,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:30:22
3436	9d5105e2-8d95-468d-a887-975646204ad3	9d5105e2-d892-4b5e-b2d5-03b3688a8f89	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 14:52:46
3437	9d5105e2-d307-47c0-ab87-b2b1e0b62418	9d5105e2-d892-4b5e-b2d5-03b3688a8f89	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"153.22","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:52:46
3438	9d5105e2-d370-4513-8d57-56a8686dfb64	9d5105e2-d892-4b5e-b2d5-03b3688a8f89	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:52:46
3439	9d5105e2-d713-4d50-ab0a-1106a8967725	9d5105e2-d892-4b5e-b2d5-03b3688a8f89	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:52:46
3440	9d5105e2-d76d-446d-bc8e-7c56ce30fe43	9d5105e2-d892-4b5e-b2d5-03b3688a8f89	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":396,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:52:46
5647	9d524842-7682-43a6-9495-59bd88e58632	9d524842-c7a4-4b90-aa79-6de523a60393	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 05:54:11
5648	9d524842-c0b5-4429-be23-941b35b5ad70	9d524842-c7a4-4b90-aa79-6de523a60393	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"162.58","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":123,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 05:54:12
5649	9d524842-c114-4dca-b248-78f08b68a465	9d524842-c7a4-4b90-aa79-6de523a60393	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 05:54:12
5650	9d524842-c642-40ef-9fc7-e46dda59ba8b	9d524842-c7a4-4b90-aa79-6de523a60393	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 05:54:12
5651	9d524842-c698-4da0-bfad-019da9211dd4	9d524842-c7a4-4b90-aa79-6de523a60393	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":464,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:54:12
8161	9d52e76e-5174-40b5-a398-b445ef292f95	9d52e76e-76f6-4bd0-9829-68f1b8cd2e5e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:19:16
8162	9d52e76e-6ee7-4458-aa90-6431e81239f6	9d52e76e-76f6-4bd0-9829-68f1b8cd2e5e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"50.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:19:16
8163	9d52e76e-6f5a-4f6f-900b-739b5d2681a4	9d52e76e-76f6-4bd0-9829-68f1b8cd2e5e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:19:16
8164	9d52e76e-752c-4184-8886-7d951327dab9	9d52e76e-76f6-4bd0-9829-68f1b8cd2e5e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:19:16
2980	9d50fde0-3560-4602-a11e-2e5b7d93eb14	9d50fde0-639f-4c19-a80a-d7c6c92094fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 14:30:22
2981	9d50fde0-5c79-4f72-94f3-0ac49ab4026f	9d50fde0-639f-4c19-a80a-d7c6c92094fc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"52.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:30:22
2982	9d50fde0-5cd4-4108-bc4f-fce78ad0547c	9d50fde0-639f-4c19-a80a-d7c6c92094fc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:30:22
2983	9d50fde0-6205-4353-ab93-c613c6bb59ee	9d50fde0-639f-4c19-a80a-d7c6c92094fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 14:30:22
2984	9d50fde0-6270-4d72-959f-b88406854354	9d50fde0-639f-4c19-a80a-d7c6c92094fc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":289,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:30:22
5652	9d524843-17bc-4f85-942c-57d85461f573	9d524843-6138-4dc4-832a-5dd0d46edc51	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 05:54:12
5653	9d524843-5b41-40ca-9008-219d9862873c	9d524843-6138-4dc4-832a-5dd0d46edc51	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"149.73","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":123,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 05:54:12
5654	9d524843-5ba7-4606-9913-4b450d46383d	9d524843-6138-4dc4-832a-5dd0d46edc51	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 05:54:12
5655	9d524843-5fd3-42af-a367-6f6c3715b412	9d524843-6138-4dc4-832a-5dd0d46edc51	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 05:54:12
5656	9d524843-6030-48df-bede-19d30a90cfc8	9d524843-6138-4dc4-832a-5dd0d46edc51	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:54:12
8165	9d52e76e-759b-434c-8601-77d1bac991e2	9d52e76e-76f6-4bd0-9829-68f1b8cd2e5e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":279,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:19:16
8317	9d52e833-6194-4ac3-9cea-beafe6c1d42b	9d52e833-7fd4-4e4c-a6e4-11bf1c7581cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 13:21:25
8318	9d52e833-7ac5-476f-9486-189a4b20ce08	9d52e833-7fd4-4e4c-a6e4-11bf1c7581cd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:21:25
8319	9d52e833-7b15-4f66-99a5-42ae61f53f0a	9d52e833-7fd4-4e4c-a6e4-11bf1c7581cd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:21:25
8320	9d52e833-7ea4-42a1-be5f-4ffc19721193	9d52e833-7fd4-4e4c-a6e4-11bf1c7581cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 13:21:25
2985	9d50fde1-1de8-4e57-8e27-5f70b4793e85	9d50fde1-61f6-48c3-9fae-30547bacfdd1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 14:30:23
2986	9d50fde1-5700-415c-bb3c-23ec36e1787d	9d50fde1-61f6-48c3-9fae-30547bacfdd1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"88.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:30:23
2987	9d50fde1-57b3-4973-9ce0-963bed3b6011	9d50fde1-61f6-48c3-9fae-30547bacfdd1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:30:23
2988	9d50fde1-5fac-46f5-8fd5-86ae8995f23b	9d50fde1-61f6-48c3-9fae-30547bacfdd1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 14:30:23
2989	9d50fde1-603f-4290-b584-bc823de2376f	9d50fde1-61f6-48c3-9fae-30547bacfdd1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":632,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:30:23
5657	9d524845-6c76-4b7b-bf58-350e86170d7f	9d524845-d470-4488-8e16-22a22b4bbc0a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 05:54:13
5658	9d524845-c7a3-4e67-9311-0c7a4ba62c72	9d524845-d470-4488-8e16-22a22b4bbc0a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"186.20","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 05:54:14
5659	9d524845-c843-4e8d-b991-620825358220	9d524845-d470-4488-8e16-22a22b4bbc0a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 05:54:14
5660	9d524845-d155-48fb-bea7-03429e25a01a	9d524845-d470-4488-8e16-22a22b4bbc0a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 05:54:14
5661	9d524845-d1f7-4e40-90f8-9c90cdaef756	9d524845-d470-4488-8e16-22a22b4bbc0a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":485,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:54:14
8166	9d52e76e-c80e-4145-8f77-bd7467321c26	9d52e76f-1339-4cec-bbd5-93fa0c643d5e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:19:16
8167	9d52e76f-0bf5-4602-bee2-4dd85cff039e	9d52e76f-1339-4cec-bbd5-93fa0c643d5e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc","time":"153.83","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 13:19:16
8168	9d52e76f-0c6f-4627-9a63-b9c5b3c4228c	9d52e76f-1339-4cec-bbd5-93fa0c643d5e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:19:16
8169	9d52e76f-0e24-4426-a020-76dcbdcce194	9d52e76f-1339-4cec-bbd5-93fa0c643d5e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6'","time":"1.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 13:19:16
8170	9d52e76f-0e60-4c5b-b0dd-9ad92a03c56c	9d52e76f-1339-4cec-bbd5-93fa0c643d5e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:19:16
8171	9d52e76f-120d-40b2-a45e-a52a0795caba	9d52e76f-1339-4cec-bbd5-93fa0c643d5e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:19:16
14999	9d5ec7dc-667c-4041-94cd-dc77fdc96f2a	9d5ec7dc-69fd-4eb1-825a-ac3b082eaad8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":144,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:00:55
2990	9d50fde1-f734-422c-9d39-51028b8415a0	9d50fde2-34c9-40cf-b763-529610dd6445	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 14:30:23
2991	9d50fde2-2b2d-43dc-aa4e-cd3020631095	9d50fde2-34c9-40cf-b763-529610dd6445	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"81.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:30:24
2992	9d50fde2-2bc3-4301-a39b-7b0e8405e00b	9d50fde2-34c9-40cf-b763-529610dd6445	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:30:24
2993	9d50fde2-32b2-44d1-ab2f-ae60c2dafaf7	9d50fde2-34c9-40cf-b763-529610dd6445	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 14:30:24
2994	9d50fde2-337a-4982-8982-0ff235a5dde1	9d50fde2-34c9-40cf-b763-529610dd6445	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":513,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:30:24
5662	9d524849-d9a0-4e7d-87f9-022d90c521e8	9d524849-dd25-4b26-815a-887424612df0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":150,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:54:16
8172	9d52e76f-1269-4a55-b900-83c43c3bb578	9d52e76f-1339-4cec-bbd5-93fa0c643d5e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":382,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:19:16
4512	9d5131cf-e645-445e-b013-1c4b395937fc	9d5131d0-118b-4b22-8bf1-b319dcd2dd0c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 16:55:36
4513	9d5131d0-0f7d-4cfd-af7c-188802cd2214	9d5131d0-118b-4b22-8bf1-b319dcd2dd0c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 16:55:36
4514	9d5131d0-105b-47ba-adee-bde8e611c7c5	9d5131d0-118b-4b22-8bf1-b319dcd2dd0c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":377,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:55:36
8321	9d52e833-7eef-43f3-b807-7300699d5b3b	9d52e833-7fd4-4e4c-a6e4-11bf1c7581cd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:21:25
15000	9d5ec7dc-cb7d-44aa-b5a8-c6aa4629717f	9d5ec7dc-f45b-48b7-a553-3cfc55aaf3f0	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-30 11:00:56
20849	9d66fc36-18f9-44b4-9d51-9fc331177dc4	9d66fc36-1bd0-4805-a7d4-89beecdbb8c2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":136,"memory":20,"hostname":"EderCortes"}	2024-11-03 12:53:56
4515	9d5131d0-7e9d-425c-9e65-40b390c05546	9d5131d0-a7b3-45c1-8c22-2b7bd176dd8a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 16:55:36
4516	9d5131d0-a116-4405-9229-8113fe6e23a0	9d5131d0-a7b3-45c1-8c22-2b7bd176dd8a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"56.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:55:36
4517	9d5131d0-a18a-4aac-bdcc-8f5fcff410d1	9d5131d0-a7b3-45c1-8c22-2b7bd176dd8a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 16:55:36
4518	9d5131d0-a653-4212-a851-461787d113af	9d5131d0-a7b3-45c1-8c22-2b7bd176dd8a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 16:55:36
4519	9d5131d0-a6a5-4a29-9bfa-0d7187125459	9d5131d0-a7b3-45c1-8c22-2b7bd176dd8a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":351,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:55:36
5663	9d52484a-9227-46d4-b7ed-e8fcbeb54cc0	9d52484a-d742-4a7d-af3d-3dc630f376b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 05:54:17
5664	9d52484a-d2e8-4e20-aa7d-be9c17574411	9d52484a-d742-4a7d-af3d-3dc630f376b0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"149.23","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":49,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-24 05:54:17
5665	9d52484a-d5ce-42e9-a1ac-ef8b7c0ba128	9d52484a-d742-4a7d-af3d-3dc630f376b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 05:54:17
5666	9d52484a-d626-4acd-aef3-587a87a4cc86	9d52484a-d742-4a7d-af3d-3dc630f376b0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:54:17
8173	9d52e771-6355-4114-99e6-2d68156ec181	9d52e771-8c8f-412b-8a52-9c8500151ce6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:19:18
8174	9d52e771-845d-4d31-af14-84f85bc9b23f	9d52e771-8c8f-412b-8a52-9c8500151ce6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"53.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:19:18
8175	9d52e771-84ea-4960-9e35-eb764973caf5	9d52e771-8c8f-412b-8a52-9c8500151ce6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:19:18
8176	9d52e771-8ad1-444c-a364-52680b30cd63	9d52e771-8c8f-412b-8a52-9c8500151ce6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:19:18
8177	9d52e771-8b41-4004-bdbb-984e2bd2938b	9d52e771-8c8f-412b-8a52-9c8500151ce6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":404,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:19:18
8322	9d52e833-c117-4672-87ec-4d01639a24b1	9d52e833-e1ba-49a4-93b2-c588f9997377	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 13:21:25
8323	9d52e833-da43-45a9-81b0-a6259978c9c4	9d52e833-e1ba-49a4-93b2-c588f9997377	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc","time":"42.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 13:21:25
8324	9d52e833-dabe-44e5-8b54-5a081c10ecd4	9d52e833-e1ba-49a4-93b2-c588f9997377	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:21:25
4520	9d5131d0-f3cb-408f-8f81-3ca28dd5e398	9d5131d1-18bf-4e03-aa16-efdf37a450e2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 16:55:36
4521	9d5131d1-1215-47d2-bdde-13163bebba8a	9d5131d1-18bf-4e03-aa16-efdf37a450e2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"50.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:55:36
4522	9d5131d1-128f-462b-b707-04b61fe6007e	9d5131d1-18bf-4e03-aa16-efdf37a450e2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 16:55:36
4523	9d5131d1-1757-46f8-ad1d-4f4827225e1a	9d5131d1-18bf-4e03-aa16-efdf37a450e2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 16:55:36
4524	9d5131d1-17b0-40e5-94a3-a37aee208b0e	9d5131d1-18bf-4e03-aa16-efdf37a450e2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":274,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:55:36
5667	9d524852-fb3f-4fbc-ad4d-bbcab5601d5b	9d524853-1b46-4448-918a-2783dd4df756	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 05:54:22
5668	9d524853-1528-439b-8736-826b2dba2011	9d524853-1b46-4448-918a-2783dd4df756	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '19' and \\"users\\".\\"deleted_at\\" is null","time":"41.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":31,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-24 05:54:22
5669	9d524853-157b-41e0-86a2-a4b348f33290	9d524853-1b46-4448-918a-2783dd4df756	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 05:54:22
5670	9d524853-19b1-4877-9406-0fe306cf4481	9d524853-1b46-4448-918a-2783dd4df756	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 05:54:22
5671	9d524853-1a03-435f-8b50-fa87e8b86618	9d524853-1b46-4448-918a-2783dd4df756	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/19","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:54:22
8325	9d52e833-dc2a-4fdb-9457-add6f0cd2a77	9d52e833-e1ba-49a4-93b2-c588f9997377	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6'","time":"1.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 13:21:25
8326	9d52e833-dc60-420f-b4a5-73a29ad64ec4	9d52e833-e1ba-49a4-93b2-c588f9997377	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:21:25
8327	9d52e833-e07e-41c7-8b9a-8ab2e8d0fc6b	9d52e833-e1ba-49a4-93b2-c588f9997377	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 13:21:25
8328	9d52e833-e0cf-42ed-a185-40c658d77911	9d52e833-e1ba-49a4-93b2-c588f9997377	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:21:25
20850	9d66fc36-cf8a-4a1e-a5d0-56a201480ea5	9d66fc37-142f-482a-bf36-2dfcc6f4eb7d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-03 12:53:56
20851	9d66fc37-1002-4742-8bdc-e302d2fda9ec	9d66fc37-142f-482a-bf36-2dfcc6f4eb7d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"149.63","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 12:53:56
8329	9d52e835-e73e-4605-960f-c431e45e6432	9d52e836-07f6-4fde-b137-da25adca9cfd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 13:21:27
8330	9d52e836-0269-4e2a-be11-3bb3e77d6876	9d52e836-07f6-4fde-b137-da25adca9cfd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:21:27
3290	9d51045b-bc32-442b-abdb-134b54c1499b	9d51045c-0221-404b-b12b-ceda1361c03d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 14:48:30
3291	9d51045b-fed3-4588-9f1e-a93e5bc96a89	9d51045c-0221-404b-b12b-ceda1361c03d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 14:48:30
3292	9d51045c-007e-4c4c-a095-4fdcc8ea03e6	9d51045c-0221-404b-b12b-ceda1361c03d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":603,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:48:30
8331	9d52e836-02c0-48a9-a6b6-1db5a634ac3f	9d52e836-07f6-4fde-b137-da25adca9cfd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:21:27
8332	9d52e836-069b-4cb8-b51a-7afa96bb5795	9d52e836-07f6-4fde-b137-da25adca9cfd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-24 13:21:27
8333	9d52e836-06e4-4e56-93f5-ec712b6623c3	9d52e836-07f6-4fde-b137-da25adca9cfd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:21:27
15001	9d5ec7dc-e8b0-408c-bace-0abc3f6bc182	9d5ec7dc-f45b-48b7-a553-3cfc55aaf3f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta', 'De las nieve', 'ds', 'CC', '100465546', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '500000', 50, 5, 'M', null, '30-10-2024', 'Pendiente', '312596295', 12, 14, 18, 14, '30-10-2024', '2024-10-30 11:00:56', '2024-10-30 11:00:56') returning \\"id\\"","time":"4.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":104,"hash":"bfad4cea82a73099ff0b3164dd496ca0","hostname":"EderCortes"}	2024-10-30 11:00:56
15002	9d5ec7dc-e94f-49a3-95d5-233471663611	9d5ec7dc-f45b-48b7-a553-3cfc55aaf3f0	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:62","hostname":"EderCortes"}	2024-10-30 11:00:56
15003	9d5ec7dc-eaac-4771-a519-ca9f30e02a37	9d5ec7dc-f45b-48b7-a553-3cfc55aaf3f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (62, 1, 100000, 50000, 'Pendiente', 'N\\/A', '29-11-2024', 12, '2024-10-30 11:00:56', '2024-10-30 11:00:56')","time":"2.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":154,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 11:00:56
15004	9d5ec7dc-eada-48bb-b765-1aeff550b40e	9d5ec7dc-f45b-48b7-a553-3cfc55aaf3f0	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 11:00:56
15005	9d5ec7dc-eb42-4aff-9d7d-264ab068eef3	9d5ec7dc-f45b-48b7-a553-3cfc55aaf3f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (62, 2, 100000, 50000, 'Pendiente', 'N\\/A', '29-12-2024', 12, '2024-10-30 11:00:56', '2024-10-30 11:00:56')","time":"0.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":154,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 11:00:56
15006	9d5ec7dc-eb63-4e9f-8e66-579d14458b85	9d5ec7dc-f45b-48b7-a553-3cfc55aaf3f0	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 11:00:56
15007	9d5ec7dc-ebc3-44fb-a89c-70fec72d5115	9d5ec7dc-f45b-48b7-a553-3cfc55aaf3f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (62, 3, 100000, 50000, 'Pendiente', 'N\\/A', '28-01-2025', 12, '2024-10-30 11:00:56', '2024-10-30 11:00:56')","time":"0.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":154,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 11:00:56
15008	9d5ec7dc-ebe2-4906-8ac1-7a7bf955ad48	9d5ec7dc-f45b-48b7-a553-3cfc55aaf3f0	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 11:00:56
15009	9d5ec7dc-ec44-4a05-b471-f5349e329b8e	9d5ec7dc-f45b-48b7-a553-3cfc55aaf3f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (62, 4, 100000, 50000, 'Pendiente', 'N\\/A', '27-02-2025', 12, '2024-10-30 11:00:56', '2024-10-30 11:00:56')","time":"0.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":154,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 11:00:56
15010	9d5ec7dc-ec66-4c31-ba7d-2c16027e4ad6	9d5ec7dc-f45b-48b7-a553-3cfc55aaf3f0	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 11:00:56
3293	9d51045c-9eb6-4aa6-a2c9-f5bcbecc0791	9d51045c-cead-4545-9d30-670b18795dff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 14:48:30
3294	9d51045c-c787-46b8-a364-da4de2a6c3f2	9d51045c-cead-4545-9d30-670b18795dff	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"66.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:48:31
3295	9d51045c-c803-4839-a4d8-b81c048cf085	9d51045c-cead-4545-9d30-670b18795dff	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:48:31
3296	9d51045c-cc00-4f1d-a086-9c81e03d7ad0	9d51045c-cead-4545-9d30-670b18795dff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 14:48:31
3297	9d51045c-cc94-4a26-a6ca-566955795468	9d51045c-cead-4545-9d30-670b18795dff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":478,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:48:31
5672	9d524870-f8b7-4ee9-94aa-937ef8f016dc	9d524870-fbd1-4160-8203-d6d0b5debc0e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":145,"memory":20,"hostname":"EderCortes"}	2024-10-24 05:54:42
15011	9d5ec7dc-ecd0-4e51-b2fd-0a3a0044c9d0	9d5ec7dc-f45b-48b7-a553-3cfc55aaf3f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (62, 5, 100000, 50000, 'Pendiente', 'N\\/A', '29-03-2025', 12, '2024-10-30 11:00:56', '2024-10-30 11:00:56')","time":"0.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":154,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-30 11:00:56
3860	9d511ad6-808b-41c2-b053-5689cde2c4bd	9d511ad6-a88a-4366-960a-3ee584310e7e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 15:51:21
3861	9d511ad6-a695-475b-bc4b-9a77fe7595bf	9d511ad6-a88a-4366-960a-3ee584310e7e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 15:51:21
3862	9d511ad6-a753-4f29-ad7f-5e75fa056684	9d511ad6-a88a-4366-960a-3ee584310e7e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":274,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:51:21
15012	9d5ec7dc-ecf1-442e-b434-cec39731e4ee	9d5ec7dc-f45b-48b7-a553-3cfc55aaf3f0	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-30 11:00:56
15013	9d5ec7dc-f292-4528-a571-a872a5400c18	9d5ec7dc-f45b-48b7-a553-3cfc55aaf3f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 11:00:56
15014	9d5ec7dc-f316-4af2-99fb-4a41201df316	9d5ec7dc-f45b-48b7-a553-3cfc55aaf3f0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"743","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"100465546","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"500000","loans_intereses":50,"loans_cuotas":5,"loans_cuando":"M","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":18,"user_recomendacion":14,"loans_inicio_pago":"30-10-2024","created_at":null,"updated_at":null,"deleted_at":null},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Wed Oct 30 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":62},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:00:56
20852	9d66fc37-1303-4b04-bd3f-6468ca647d68	9d66fc37-142f-482a-bf36-2dfcc6f4eb7d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-03 12:53:56
20853	9d66fc37-1347-4038-a191-71748d4891df	9d66fc37-142f-482a-bf36-2dfcc6f4eb7d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":319,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:53:56
3298	9d51045d-28eb-4d6f-b87a-7a74641a4d0f	9d51045d-78b2-478d-bb0f-a7033966063c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 14:48:31
3299	9d51045d-7171-49af-ae59-d40670963bb7	9d51045d-78b2-478d-bb0f-a7033966063c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"161.86","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:48:31
3300	9d51045d-71ce-459c-85fe-0ce1ec5023ee	9d51045d-78b2-478d-bb0f-a7033966063c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:48:31
3301	9d51045d-7653-4ad0-a06d-6f25de192938	9d51045d-78b2-478d-bb0f-a7033966063c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 14:48:31
3302	9d51045d-7718-4ea6-91cd-3708fab86169	9d51045d-78b2-478d-bb0f-a7033966063c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":416,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:48:31
3863	9d511ad7-0a0a-4020-baff-53362c2b6260	9d511ad7-53dd-4da9-b468-150b8efc5743	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 15:51:22
3864	9d511ad7-4d93-4385-a4d3-a8188b72a56c	9d511ad7-53dd-4da9-b468-150b8efc5743	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"145.38","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:51:22
3865	9d511ad7-4ddd-4590-897e-8b744b79be71	9d511ad7-53dd-4da9-b468-150b8efc5743	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 15:51:22
3866	9d511ad7-5274-433a-9b9f-2b91860b7fe6	9d511ad7-53dd-4da9-b468-150b8efc5743	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 15:51:22
3867	9d511ad7-52cd-48b2-82bb-7057327a4638	9d511ad7-53dd-4da9-b468-150b8efc5743	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":409,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:51:22
15015	9d5ec7e2-68c4-48d2-b207-daa70d9e210f	9d5ec7e2-833d-41b9-ae3c-5602234fb051	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 11:00:59
8470	9d52ec1d-59a7-467f-b92d-e7cb8b6bf56e	9d52ec1d-7754-47b7-8020-73d598cf5742	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:32:22
8471	9d52ec1d-75c9-4889-b693-4a971e46e495	9d52ec1d-7754-47b7-8020-73d598cf5742	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:32:22
8472	9d52ec1d-7666-4cab-aa06-89895ff0d21d	9d52ec1d-7754-47b7-8020-73d598cf5742	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:32:22
15016	9d5ec7e2-7e83-4dd7-9f68-a629be81fd63	9d5ec7e2-833d-41b9-ae3c-5602234fb051	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"44.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-30 11:00:59
15017	9d5ec7e2-8167-405b-af29-70b6c91bfa4e	9d5ec7e2-833d-41b9-ae3c-5602234fb051	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 11:00:59
20854	9d66fc3c-045e-49c3-b4b3-f708257701f4	9d66fc3c-52a8-4885-b076-f13a22dce661	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-03 12:54:00
20855	9d66fc3c-4c7a-428d-bd4c-e9985daa8aeb	9d66fc3c-52a8-4885-b076-f13a22dce661	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '19' and \\"users\\".\\"deleted_at\\" is null","time":"159.04","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":55,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-11-03 12:54:00
20856	9d66fc3c-4cce-4427-8606-984ccca0f1ce	9d66fc3c-52a8-4885-b076-f13a22dce661	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 12:54:00
20857	9d66fc3c-5154-4edf-a272-2bd594ef06ee	9d66fc3c-52a8-4885-b076-f13a22dce661	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-03 12:54:00
3303	9d51045e-2ad5-4bae-8e8c-e18ecd5753ae	9d51045e-73ed-464d-ac94-a94975aa3bd6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 14:48:31
3304	9d51045e-6910-43a9-ac8b-a79d85286fed	9d51045e-73ed-464d-ac94-a94975aa3bd6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"76.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:48:32
3305	9d51045e-69e5-4df4-8075-e33034c27b66	9d51045e-73ed-464d-ac94-a94975aa3bd6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:48:32
3306	9d51045e-71dc-41ea-b850-4f046301094d	9d51045e-73ed-464d-ac94-a94975aa3bd6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 14:48:32
3307	9d51045e-7257-4dd9-b4fd-d86b9e388925	9d51045e-73ed-464d-ac94-a94975aa3bd6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":622,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:48:32
3868	9d511ad7-9c2a-41d9-95b1-3c668cb63821	9d511ad7-be58-4f47-a4a2-5596c943d0da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 15:51:22
3869	9d511ad7-b776-46a6-9bcb-3f0913be45e8	9d511ad7-be58-4f47-a4a2-5596c943d0da	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:51:22
3870	9d511ad7-b7d6-436a-9286-42994a6741d6	9d511ad7-be58-4f47-a4a2-5596c943d0da	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 15:51:22
3871	9d511ad7-bc81-4750-b0af-2e68a52379a7	9d511ad7-be58-4f47-a4a2-5596c943d0da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 15:51:22
3872	9d511ad7-bd1c-4443-9a74-e6838d68f0c0	9d511ad7-be58-4f47-a4a2-5596c943d0da	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":257,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:51:22
8473	9d52ec1d-c3ec-47d7-8f8a-9ef23b296461	9d52ec1e-1148-45c7-9609-3d4d8a02bd57	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:32:22
8474	9d52ec1e-0bad-4374-81ea-e47847d0d0cc	9d52ec1e-1148-45c7-9609-3d4d8a02bd57	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"158.83","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:32:22
8475	9d52ec1e-0bf6-4da1-8a0d-a5273de916d2	9d52ec1e-1148-45c7-9609-3d4d8a02bd57	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:32:22
8476	9d52ec1e-0ff1-4891-b42d-ea778db340ff	9d52ec1e-1148-45c7-9609-3d4d8a02bd57	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:32:22
8477	9d52ec1e-1052-4d20-81b0-c7276827c309	9d52ec1e-1148-45c7-9609-3d4d8a02bd57	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":362,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:32:22
3308	9d51045f-0a21-43d1-93e5-f3e338768498	9d51045f-4af1-48df-83cd-e1d2b0898a88	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 14:48:32
3309	9d51045f-3f97-41c3-b617-34feacf690c0	9d51045f-4af1-48df-83cd-e1d2b0898a88	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"81.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:48:32
3310	9d51045f-405c-4774-9fd8-94d9bff03e7b	9d51045f-4af1-48df-83cd-e1d2b0898a88	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:48:32
3311	9d51045f-48b8-4dbf-a636-4d1bf03fc625	9d51045f-4af1-48df-83cd-e1d2b0898a88	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 14:48:32
3312	9d51045f-4957-44b4-9048-4ae756802b0a	9d51045f-4af1-48df-83cd-e1d2b0898a88	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":525,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:48:32
8478	9d52ec1e-5426-489e-941e-0da346a7d282	9d52ec1e-70a1-48e0-baf5-8c065c8c7a6f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:32:22
8479	9d52ec1e-6be2-4343-87da-a14a9d2f33fb	9d52ec1e-70a1-48e0-baf5-8c065c8c7a6f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:32:22
8480	9d52ec1e-6c2e-4a0a-9e9e-db9fb3fca96b	9d52ec1e-70a1-48e0-baf5-8c065c8c7a6f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:32:22
8481	9d52ec1e-6f87-4b5e-9f2c-7d84ed4bcd2c	9d52ec1e-70a1-48e0-baf5-8c065c8c7a6f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:32:22
8482	9d52ec1e-6fca-4246-98c1-60c9dd9d7e71	9d52ec1e-70a1-48e0-baf5-8c065c8c7a6f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:32:22
15018	9d5ec7e2-81f7-4cd8-836a-2a14043acffb	9d5ec7e2-833d-41b9-ae3c-5602234fb051	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":313,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:00:59
23352	9d6894e2-74aa-4ae6-8107-5a24ce7f2976	9d6894e2-7a6d-4e5f-91fb-8006d9812296	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"43.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 07:56:40
23353	9d6894e2-7877-49b2-9101-4e03f5a72b55	9d6894e2-7a6d-4e5f-91fb-8006d9812296	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 07:56:40
8483	9d52ec1e-b3db-4195-a97b-e0773674b1f9	9d52ec1e-f9ab-4f71-b336-8784b396516c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:32:23
8484	9d52ec1e-f333-4723-b34a-2bf9e3a8362d	9d52ec1e-f9ab-4f71-b336-8784b396516c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"id\\" asc limit 1","time":"141.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"2ea0673dfe095ca1a57c47f95899a75f","hostname":"EderCortes"}	2024-10-24 13:32:23
8485	9d52ec1e-f387-4c72-b6f1-5c0812d14a21	9d52ec1e-f9ab-4f71-b336-8784b396516c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:32:23
8486	9d52ec1e-f547-4ea6-8e6b-7ab8c9f102c7	9d52ec1e-f9ab-4f71-b336-8784b396516c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"id\\" asc","time":"2.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"c160639e0dc4ff44f5d5d21affd614e2","hostname":"EderCortes"}	2024-10-24 13:32:23
8487	9d52ec1e-f576-4d24-847a-04b55c10b4d4	9d52ec1e-f9ab-4f71-b336-8784b396516c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:32:23
8488	9d52ec1e-f88e-4a1d-9351-f58a153c952f	9d52ec1e-f9ab-4f71-b336-8784b396516c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 13:32:23
8489	9d52ec1e-f8d2-408f-adeb-4853cbd2ee87	9d52ec1e-f9ab-4f71-b336-8784b396516c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":null,"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":337,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:32:23
15019	9d5ec7e8-ce38-4293-a276-914a7d111ff5	9d5ec7e9-1810-49a5-ba47-5d89b22475aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 11:01:04
15020	9d5ec7e9-0e98-44f9-9f3c-00ea14272b74	9d5ec7e9-1810-49a5-ba47-5d89b22475aa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"152.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"088d1fdbe045a08c3b0073ef22c7da32","hostname":"EderCortes"}	2024-10-30 11:01:04
8617	9d52eddd-c815-433b-8fdb-3fdcd92d922a	9d52eddd-e88c-4ca8-a8d2-c37b39aac223	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 13:37:16
8618	9d52eddd-e6de-463f-9893-dc7ffb6f79d3	9d52eddd-e88c-4ca8-a8d2-c37b39aac223	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 13:37:16
8619	9d52eddd-e7b6-4d5d-aa20-8e1f4853e1f0	9d52eddd-e88c-4ca8-a8d2-c37b39aac223	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":260,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:37:16
15021	9d5ec7e9-126c-4a6f-bedd-7052b3dbb4c6	9d5ec7e9-1810-49a5-ba47-5d89b22475aa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-30 11:01:04
15022	9d5ec7e9-12ad-47da-b27c-95adbf82af45	9d5ec7e9-1810-49a5-ba47-5d89b22475aa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-10-30 11:01:04
15023	9d5ec7e9-16ad-4d22-9906-26fdcb9644f9	9d5ec7e9-1810-49a5-ba47-5d89b22475aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 11:01:04
15024	9d5ec7e9-1706-4206-bfeb-945f44f502ea	9d5ec7e9-1810-49a5-ba47-5d89b22475aa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:01:04
23708	9d689b96-3226-4b08-b0bc-4a04914a9038	9d689b96-3576-42ba-aaf2-cefaf16bac5c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":126,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:15:24
8490	9d52ec20-f757-4a85-bc25-b8eb01a29062	9d52ec21-1d6f-4d65-92e3-78628173a6ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 13:32:24
8491	9d52ec21-1820-4531-bbd5-8e676236af6b	9d52ec21-1d6f-4d65-92e3-78628173a6ce	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"52.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:32:24
8492	9d52ec21-186b-46e4-b40b-0f4425440cce	9d52ec21-1d6f-4d65-92e3-78628173a6ce	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:32:24
8493	9d52ec21-1c02-4fef-be37-806d81279f59	9d52ec21-1d6f-4d65-92e3-78628173a6ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 13:32:24
8494	9d52ec21-1c4a-450d-b430-d286b902b3c7	9d52ec21-1d6f-4d65-92e3-78628173a6ce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":396,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:32:24
8620	9d52edde-31c8-49d5-b9e0-7771042e953f	9d52edde-511c-4cab-beb7-1990c3e5a469	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 13:37:16
8621	9d52edde-4b2d-4b85-a404-177d347644bc	9d52edde-511c-4cab-beb7-1990c3e5a469	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:37:16
8622	9d52edde-4b7b-4950-9fe0-439748fa7be1	9d52edde-511c-4cab-beb7-1990c3e5a469	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:37:16
8623	9d52edde-4fd3-41ae-b623-010f9a11cf4b	9d52edde-511c-4cab-beb7-1990c3e5a469	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 13:37:16
8624	9d52edde-5025-4a76-9e6c-39fc0c3b3e91	9d52edde-511c-4cab-beb7-1990c3e5a469	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:37:16
20858	9d66fc3c-519f-4fbc-b638-f02a838972bf	9d66fc3c-52a8-4885-b076-f13a22dce661	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/19","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}},"duration":398,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:54:00
21712	9d673db8-9d5d-4526-a6d6-0d83064e3cd5	9d673db8-9e70-4801-a100-91613d4ae63d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":572,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:57:07
8625	9d52edde-9418-4894-b6d6-ec91acbbfcd1	9d52edde-dde6-40c5-ba7a-c12a1879f8f1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 13:37:16
4636	9d51345e-ce37-4a5b-8ed4-9f56ef2d5de8	9d51345e-f61e-482f-bcc8-ae872c9611e5	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 17:02:45
4637	9d51345e-f420-4fda-8d55-0dde19046fde	9d51345e-f61e-482f-bcc8-ae872c9611e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 17:02:45
4638	9d51345e-f4f3-4c9b-8017-97e78063b8ca	9d51345e-f61e-482f-bcc8-ae872c9611e5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":273,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:02:45
8626	9d52edde-d89d-404b-ae14-4cc2abeca5f9	9d52edde-dde6-40c5-ba7a-c12a1879f8f1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"150.85","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:37:16
8627	9d52edde-d8fd-4b20-9d4f-0c2ebb21b2ea	9d52edde-dde6-40c5-ba7a-c12a1879f8f1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:37:16
8628	9d52edde-dc9c-4c87-bcba-1ef2d7eb028c	9d52edde-dde6-40c5-ba7a-c12a1879f8f1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 13:37:16
8629	9d52edde-dcef-4b39-901c-5fc97b0d8f18	9d52edde-dde6-40c5-ba7a-c12a1879f8f1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:37:16
20859	9d66fc8a-2508-4f2b-87fa-097abff52aa9	9d66fc8a-2874-46f5-b004-66746669a663	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":179,"memory":20,"hostname":"EderCortes"}	2024-11-03 12:54:51
21123	9d6734cc-0966-4d18-8c28-2dc7b881143c	9d6734cc-0a7d-4c3f-b2db-53a3ca55d488	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"37","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"10-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":null,"loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":220,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:32:09
23354	9d6894e2-78e4-4104-bbb9-f3d68f21a989	9d6894e2-7a6d-4e5f-91fb-8006d9812296	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":262,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:56:40
23709	9d689b96-a147-4878-8f9b-64eec6b354eb	9d689b96-f8b1-49c8-8539-13323aafdfad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 08:15:25
4639	9d51345f-502b-4ad5-98d7-2bea644a68fd	9d51345f-7101-42ae-bedc-364f4e817bb4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 17:02:45
4640	9d51345f-6b4d-473d-ae44-7a3277f9080e	9d51345f-7101-42ae-bedc-364f4e817bb4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:02:45
4641	9d51345f-6ba3-4599-8413-61dda8eafa13	9d51345f-7101-42ae-bedc-364f4e817bb4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:02:45
4642	9d51345f-6fcf-4fb7-972f-cfa3f65b2433	9d51345f-7101-42ae-bedc-364f4e817bb4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 17:02:45
4643	9d51345f-7014-4743-9958-b1db550363ac	9d51345f-7101-42ae-bedc-364f4e817bb4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":286,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:02:45
8630	9d52eddf-21a2-4e26-b329-d86ee5e40c03	9d52eddf-40b3-41e2-89c2-d4f317727595	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 13:37:17
8631	9d52eddf-3b69-4ff4-b1e5-e88854191b07	9d52eddf-40b3-41e2-89c2-d4f317727595	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"42.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 13:37:17
8632	9d52eddf-3bb4-44d2-ac77-546efb3adf26	9d52eddf-40b3-41e2-89c2-d4f317727595	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:37:17
8633	9d52eddf-3f60-4948-a955-c5da392954c5	9d52eddf-40b3-41e2-89c2-d4f317727595	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 13:37:17
8634	9d52eddf-3fb5-4f66-b9dd-839e647cba55	9d52eddf-40b3-41e2-89c2-d4f317727595	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:37:17
20860	9d66fc8a-9073-4e65-898d-f5c51924325b	9d66fc8a-c287-483b-bebf-40d5d6e4e7c7	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 12:54:51
20861	9d66fc8a-b1f7-4bed-9ecd-33a0212171af	9d66fc8a-c287-483b-bebf-40d5d6e4e7c7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta 2', 'De las nieve', 'ds', 'CC', '1004655468', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon2', 'Calle 7505', '1000000', 40, 5, 'Q', null, '17-11-2024', 'Pendiente', '312596295', 12, 14, 19, 14, '17-11-2024', 0, 0, '2024-11-03 12:54:51', '2024-11-03 12:54:51') returning \\"id\\"","time":"5.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":104,"hash":"3bcc7378af96f7253706305bd249413f","hostname":"EderCortes"}	2024-11-03 12:54:51
20862	9d66fc8a-b286-41d9-95c3-2ca0b6117838	9d66fc8a-c287-483b-bebf-40d5d6e4e7c7	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:63","hostname":"EderCortes"}	2024-11-03 12:54:51
20863	9d66fc8a-b805-4240-9bcd-3adaab650226	9d66fc8a-c287-483b-bebf-40d5d6e4e7c7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (63, 1, 200000, 80000, 'Pendiente', 'N\\/A', '03-12-2024', 12, 0, 0, '2024-11-03 12:54:51', '2024-11-03 12:54:51')","time":"3.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":156,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 12:54:51
20864	9d66fc8a-b832-4bcc-a5e3-24fe585e2e7c	9d66fc8a-c287-483b-bebf-40d5d6e4e7c7	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 12:54:51
20865	9d66fc8a-b8be-421f-86b2-8fa0c7aecd6c	9d66fc8a-c287-483b-bebf-40d5d6e4e7c7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (63, 2, 200000, 80000, 'Pendiente', 'N\\/A', '19-12-2024', 12, 0, 0, '2024-11-03 12:54:51', '2024-11-03 12:54:51')","time":"0.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":156,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 12:54:51
20866	9d66fc8a-b8f5-482f-b3dd-b137acbe39d3	9d66fc8a-c287-483b-bebf-40d5d6e4e7c7	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 12:54:51
21124	9d6734d2-43f3-48d5-bb10-07fcb1c0abff	9d6734d2-613c-4c3e-9783-2819765a68d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 15:32:13
23355	9d68951b-9b33-4f22-9727-ef6a6e943646	9d68951b-e67b-41b0-9bbf-57ca8f40421c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 07:57:17
4644	9d51345f-b67e-4098-96d2-21839892afc5	9d51345f-d583-4c54-a546-64b5da66f41d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 17:02:46
4645	9d51345f-d017-425c-8d9f-98002a0a4231	9d51345f-d583-4c54-a546-64b5da66f41d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:02:46
3086	9d5101c5-1764-4081-beb5-57a61f1024d4	9d5101c5-57b7-479f-8bfb-9d2d5de5c87b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 14:41:16
3087	9d5101c5-5459-480d-84ca-efe74cf19c12	9d5101c5-57b7-479f-8bfb-9d2d5de5c87b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 14:41:16
3088	9d5101c5-55e3-4a3f-adde-6f6d7129eacc	9d5101c5-57b7-479f-8bfb-9d2d5de5c87b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":581,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:41:16
4646	9d51345f-d069-409d-a836-edd369bb748a	9d51345f-d583-4c54-a546-64b5da66f41d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:02:46
4647	9d51345f-d476-473d-aed8-7a7c8a166573	9d51345f-d583-4c54-a546-64b5da66f41d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 17:02:46
4648	9d51345f-d4b8-4161-adb3-1bc9e46bb956	9d51345f-d583-4c54-a546-64b5da66f41d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:02:46
8635	9d52ede0-f602-41ec-810b-dcc5118a81f7	9d52ede1-201c-463c-b5ea-edfd25a21b29	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 13:37:18
8636	9d52ede1-1951-456a-8d39-6b9c7c682a40	9d52ede1-201c-463c-b5ea-edfd25a21b29	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:37:18
8637	9d52ede1-19be-4cb6-b96b-60b66ebe1766	9d52ede1-201c-463c-b5ea-edfd25a21b29	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:37:18
8638	9d52ede1-1e71-4c7f-823d-0c671508803a	9d52ede1-201c-463c-b5ea-edfd25a21b29	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:37:18
8639	9d52ede1-1ed7-4772-9455-915b017eb677	9d52ede1-201c-463c-b5ea-edfd25a21b29	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":328,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:37:18
20867	9d66fc8a-b984-4e72-af8b-6de22cc0f686	9d66fc8a-c287-483b-bebf-40d5d6e4e7c7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (63, 3, 200000, 80000, 'Pendiente', 'N\\/A', '04-01-2025', 12, 0, 0, '2024-11-03 12:54:51', '2024-11-03 12:54:51')","time":"0.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":156,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 12:54:51
20868	9d66fc8a-b9ab-4e73-9654-a535f606deb7	9d66fc8a-c287-483b-bebf-40d5d6e4e7c7	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 12:54:51
20869	9d66fc8a-ba31-450e-9678-f89200eb844a	9d66fc8a-c287-483b-bebf-40d5d6e4e7c7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (63, 4, 200000, 80000, 'Pendiente', 'N\\/A', '20-01-2025', 12, 0, 0, '2024-11-03 12:54:51', '2024-11-03 12:54:51')","time":"0.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":156,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 12:54:51
20870	9d66fc8a-ba6a-495f-b06b-cc5ebe74752d	9d66fc8a-c287-483b-bebf-40d5d6e4e7c7	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 12:54:51
3089	9d5101c5-d557-4d6b-9643-55ce6f7da40b	9d5101c6-0ed7-4945-a831-49e5bb56d828	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 14:41:16
3090	9d5101c6-05a2-427b-b8f8-f7167ec907c4	9d5101c6-0ed7-4945-a831-49e5bb56d828	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"74.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:41:16
3091	9d5101c6-060a-405b-a92b-094dafef96d9	9d5101c6-0ed7-4945-a831-49e5bb56d828	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:41:16
3092	9d5101c6-0d09-4cd1-9bd9-867d30f4432d	9d5101c6-0ed7-4945-a831-49e5bb56d828	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 14:41:16
2716	9d50fb37-79ef-43a1-ba30-36d5b50062ec	9d50fb37-a831-4c3a-9781-6f2932514bbd	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 14:22:56
2717	9d50fb37-a5ec-4f3d-b772-1f2395bf9449	9d50fb37-a831-4c3a-9781-6f2932514bbd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 14:22:56
2718	9d50fb37-a6f4-4873-a153-f935659e739a	9d50fb37-a831-4c3a-9781-6f2932514bbd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":332,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:22:56
3093	9d5101c6-0d65-4a4e-9ce6-d04e1f6c872c	9d5101c6-0ed7-4945-a831-49e5bb56d828	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":429,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:41:16
20871	9d66fc8a-baec-41ce-b633-00ba7214e4cc	9d66fc8a-c287-483b-bebf-40d5d6e4e7c7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (63, 5, 200000, 80000, 'Pendiente', 'N\\/A', '05-02-2025', 12, 0, 0, '2024-11-03 12:54:51', '2024-11-03 12:54:51')","time":"0.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":156,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 12:54:51
20872	9d66fc8a-bb14-4fa7-afd9-a00206e6dca3	9d66fc8a-c287-483b-bebf-40d5d6e4e7c7	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 12:54:51
12751	9d5cecbd-00bf-42a0-bc78-199887c5b602	9d5cecbd-0202-4cc8-b48f-4d4612896646	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":612,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:23
20873	9d66fc8a-c090-48b3-8b78-a1edff32e066	9d66fc8a-c287-483b-bebf-40d5d6e4e7c7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:54:51
20874	9d66fc8a-c113-4def-8965-7e528e27a100	9d66fc8a-c287-483b-bebf-40d5d6e4e7c7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"796","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"1004655468","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_valor_prestado":"1000000","loans_intereses":40,"loans_cuotas":5,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":19,"user_recomendacion":14,"loans_inicio_pago":"17-11-2024","created_at":null,"updated_at":null,"deleted_at":null,"loans_pago_prestado":0,"loans_pago_interes":0},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Sun Nov 03 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":63},"duration":323,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:54:51
21713	9d673dbb-0fe7-4f12-be40-d24ccd1347bd	9d673dbb-12c8-4e11-ad90-b077679c6fad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":147,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:57:08
20875	9d66fc91-cb77-4d4b-9f44-a52dcaa8fe19	9d66fc91-e89e-45d7-9af1-abdfb1e5a0eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:54:56
21125	9d6734d2-5879-4388-9af1-afbe5a1eedec	9d6734d2-613c-4c3e-9783-2819765a68d3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 65\\n                        ","time":"40.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6768d7067397538897aacf4d73c43049","hostname":"EderCortes"}	2024-11-03 15:32:13
8967	9d52f346-05d6-46a6-8272-a1d622bcfbd2	9d52f346-2d35-4227-8ebb-31af2342d87a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 13:52:23
8968	9d52f346-2b98-400c-bfde-125ee86b0bba	9d52f346-2d35-4227-8ebb-31af2342d87a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:52:23
8969	9d52f346-2c44-412c-9505-1bc9517532b5	9d52f346-2d35-4227-8ebb-31af2342d87a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":309,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:52:23
21126	9d6734d2-5bec-4e10-865d-94b92d40de6e	9d6734d2-613c-4c3e-9783-2819765a68d3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '65' order by \\"item_loans\\".\\"id\\" asc","time":"2.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 15:32:13
20876	9d66fc91-e469-4b0d-97d8-58423176e608	9d66fc91-e89e-45d7-9af1-abdfb1e5a0eb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"48.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 12:54:56
21127	9d6734d2-5c2a-410a-b778-982b29352eee	9d6734d2-613c-4c3e-9783-2819765a68d3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 15:32:13
21128	9d6734d2-5fff-4d9a-ac54-543ea57ddc95	9d6734d2-613c-4c3e-9783-2819765a68d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 15:32:13
20877	9d66fc91-e752-4d4b-aa8a-8aabb03e920a	9d66fc91-e89e-45d7-9af1-abdfb1e5a0eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:54:56
20878	9d66fc91-e7a4-4c5f-80d8-48ac49557adb	9d66fc91-e89e-45d7-9af1-abdfb1e5a0eb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":null,"loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":293,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:54:56
21129	9d6734d2-604d-402a-914f-a642b2c4d995	9d6734d2-613c-4c3e-9783-2819765a68d3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/65","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":65,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":3000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-10 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":207,"loans_codigo":65,"itemloans_cuota":"1","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":208,"loans_codigo":65,"itemloans_cuota":"2","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":209,"loans_codigo":65,"itemloans_cuota":"3","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":210,"loans_codigo":65,"itemloans_cuota":"4","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":211,"loans_codigo":65,"itemloans_cuota":"5","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":212,"loans_codigo":65,"itemloans_cuota":"6","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":213,"loans_codigo":65,"itemloans_cuota":"7","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":214,"loans_codigo":65,"itemloans_cuota":"8","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":215,"loans_codigo":65,"itemloans_cuota":"9","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":216,"loans_codigo":65,"itemloans_cuota":"10","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-09-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":303,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:32:13
21714	9d673dbb-cce3-4c22-8e7e-22b5c14a1b02	9d673dbb-e708-4070-930b-a9b2f434350e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 15:57:09
8970	9d52f346-8acf-447e-b2c8-c1d3902652c9	9d52f346-aa47-469f-b3cf-8e21f22125d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:52:23
8785	9d52ef0a-87ff-4933-89dd-cfb3df4c0b95	9d52ef0a-ad8f-4f75-97b0-c609cb07f415	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 13:40:33
3993	9d511bf8-f9de-4218-ad8c-115949577c00	9d511bf9-1f91-42f3-aecc-dbba2ecb5e1b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 15:54:32
3994	9d511bf9-1d33-478d-b2bc-6440640a1e69	9d511bf9-1f91-42f3-aecc-dbba2ecb5e1b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 15:54:32
3995	9d511bf9-1e65-47eb-b750-7b93f10ae96b	9d511bf9-1f91-42f3-aecc-dbba2ecb5e1b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:54:32
8786	9d52ef0a-abb2-49c0-86e1-c8b0ab234f2e	9d52ef0a-ad8f-4f75-97b0-c609cb07f415	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:40:33
8787	9d52ef0a-ac8b-459f-8478-1a9533132362	9d52ef0a-ad8f-4f75-97b0-c609cb07f415	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":256,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:40:33
8971	9d52f346-a475-46da-9232-95e8197afa0c	9d52f346-aa47-469f-b3cf-8e21f22125d3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:52:23
21130	9d673577-6a79-4585-878a-3507b86d9bd2	9d673577-6f04-4d47-a500-fba3a45faff3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":220,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:34:02
23356	9d68951b-dc6a-4bff-8548-3c2dbcaaca9d	9d68951b-e67b-41b0-9bbf-57ca8f40421c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 69\\n                        ","time":"151.52","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"28d3d4f6fe6eff992a986b780c628d2e","hostname":"EderCortes"}	2024-11-04 07:57:17
23357	9d68951b-e08b-4380-805e-ac23b6cd2de6	9d68951b-e67b-41b0-9bbf-57ca8f40421c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '69' order by \\"item_loans\\".\\"id\\" asc","time":"2.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 07:57:17
8972	9d52f346-a4c1-4f37-b9a6-dea949c825e6	9d52f346-aa47-469f-b3cf-8e21f22125d3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:52:23
8973	9d52f346-a8f2-46a5-b69b-3b17dc6bd195	9d52f346-aa47-469f-b3cf-8e21f22125d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:52:23
21715	9d673dbb-e2bd-40ef-b8c9-465c99ee80c2	9d673dbb-e708-4070-930b-a9b2f434350e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ma%' or \\"users\\".\\"user_document\\"::text like '%Ma%') order by \\"users\\".\\"user_document\\" asc","time":"39.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 15:57:09
21716	9d673dbb-e5bc-4156-bbad-29e508105c5c	9d673dbb-e708-4070-930b-a9b2f434350e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 15:57:09
21717	9d673dbb-e602-4c2d-aca5-cdbb719cf52d	9d673dbb-e708-4070-930b-a9b2f434350e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ma"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:57:09
23358	9d68951b-e0bc-4f05-950d-1bbb3c268c14	9d68951b-e67b-41b0-9bbf-57ca8f40421c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 07:57:17
23359	9d68951b-e4eb-43a8-b78b-e70a22199e82	9d68951b-e67b-41b0-9bbf-57ca8f40421c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 07:57:17
23710	9d689b96-e9b1-46e1-96ad-fc1467a0cd6e	9d689b96-f8b1-49c8-8539-13323aafdfad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 232 limit 1","time":"2.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 08:15:25
3996	9d511bf9-7b87-4ea2-a5ec-caac027cc1b9	9d511bf9-a290-43f3-8b67-3ba835399a94	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 15:54:32
3997	9d511bf9-9950-4b27-a45c-c22099c94826	9d511bf9-a290-43f3-8b67-3ba835399a94	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"50.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:54:32
3998	9d511bf9-99d8-4439-b208-d07e88085a98	9d511bf9-a290-43f3-8b67-3ba835399a94	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 15:54:32
3999	9d511bf9-a0c5-45cf-abd0-71bfa1c6e565	9d511bf9-a290-43f3-8b67-3ba835399a94	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 15:54:32
4000	9d511bf9-a13c-4e44-842f-4a552e58a4a5	9d511bf9-a290-43f3-8b67-3ba835399a94	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":305,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:54:32
8788	9d52ef0b-04f0-4f94-bdaf-5f55d648be9e	9d52ef0b-235c-43ba-ba50-6374a36af5d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:40:33
8789	9d52ef0b-1e75-477b-b19c-a4c2adae2c2f	9d52ef0b-235c-43ba-ba50-6374a36af5d5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:40:33
4126	9d511de8-28ae-4fac-960c-cc4483684492	9d511de8-6268-4137-a424-494a0f7596bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 15:59:56
4127	9d511de8-5f6a-452d-850b-601ea9675008	9d511de8-6268-4137-a424-494a0f7596bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 15:59:56
4128	9d511de8-60c2-4dd2-a1e9-b39cf862a175	9d511de8-6268-4137-a424-494a0f7596bb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":582,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:59:56
8790	9d52ef0b-1ec0-4628-aa78-e44a3198423a	9d52ef0b-235c-43ba-ba50-6374a36af5d5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:40:33
8791	9d52ef0b-2260-40c7-84ac-27f8463a9a69	9d52ef0b-235c-43ba-ba50-6374a36af5d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:40:33
8792	9d52ef0b-22a1-47b3-96bc-27366e72d9b8	9d52ef0b-235c-43ba-ba50-6374a36af5d5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:40:33
21131	9d673577-d5de-4581-a943-3551b775ee5f	9d673578-31b9-4a28-86dd-e671b412e7f4	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 15:34:02
8974	9d52f346-a94c-448c-922c-b3a64fe72d97	9d52f346-aa47-469f-b3cf-8e21f22125d3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":289,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:52:23
21132	9d673578-2389-4b53-ae3e-1349c23bde6c	9d673578-31b9-4a28-86dd-e671b412e7f4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 207 limit 1","time":"4.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-03 15:34:02
21133	9d673578-240a-498d-89a1-f3c2c104ec72	9d673578-31b9-4a28-86dd-e671b412e7f4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-03 15:34:02
21134	9d673578-2658-4537-88a0-f08bc91892a6	9d673578-31b9-4a28-86dd-e671b412e7f4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 65 limit 1","time":"2.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 15:34:02
21135	9d673578-26a4-42a1-992e-e0f6f366aa5c	9d673578-31b9-4a28-86dd-e671b412e7f4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 15:34:02
21136	9d673578-288e-4ae5-9dda-a67c1da1fd23	9d673578-31b9-4a28-86dd-e671b412e7f4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '03-11-2024', \\"itemloans_cuota_cancelada\\" = '300000', \\"updated_at\\" = '2024-11-03 15:34:02' where \\"id\\" = 207","time":"2.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":395,"hash":"35b67f849e4a0ba5090d9c1eb8abfe94","hostname":"EderCortes"}	2024-11-03 15:34:02
21137	9d673578-291b-4702-8b5d-8c6bf8b9264c	9d673578-31b9-4a28-86dd-e671b412e7f4	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:207","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-03 15:34:02","item_loans_cuando_pago":"03-11-2024","itemloans_cuota_cancelada":"300000"},"hostname":"EderCortes"}	2024-11-03 15:34:02
4001	9d511bf9-f36f-4965-ab78-fbac60b29c34	9d511bfa-1632-48b9-a64f-17e69783378d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 15:54:32
4002	9d511bfa-0fda-4937-8892-0a3a707f4570	9d511bfa-1632-48b9-a64f-17e69783378d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:54:32
4003	9d511bfa-108d-4d49-868d-27dfbd15e517	9d511bfa-1632-48b9-a64f-17e69783378d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 15:54:32
4004	9d511bfa-14c8-4a59-ab35-fa7e86406b1e	9d511bfa-1632-48b9-a64f-17e69783378d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 15:54:32
4005	9d511bfa-1531-4402-bca1-4cfe90659e00	9d511bfa-1632-48b9-a64f-17e69783378d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":274,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:54:32
4129	9d511de8-ff8a-4605-8209-feb41c9851a3	9d511de9-33d3-450b-b752-0c3be39400f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 15:59:57
4130	9d511de9-2b0e-403f-a79b-57c1dd8d03f9	9d511de9-33d3-450b-b752-0c3be39400f6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"71.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:59:57
4131	9d511de9-2b97-4ff6-82ef-509c1c7d151d	9d511de9-33d3-450b-b752-0c3be39400f6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 15:59:57
4132	9d511de9-31b6-4644-b210-1fac07ec5f45	9d511de9-33d3-450b-b752-0c3be39400f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 15:59:57
4133	9d511de9-3251-4bf2-b5d4-81fbe9a34b89	9d511de9-33d3-450b-b752-0c3be39400f6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":495,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:59:57
8793	9d52ef0b-62a5-4b11-884f-d16f6a9ec1c6	9d52ef0b-806f-4465-b8c9-d14d65781d71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:40:33
8794	9d52ef0b-7abf-4e29-b70e-69dd6c4eee7a	9d52ef0b-806f-4465-b8c9-d14d65781d71	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:40:33
8795	9d52ef0b-7b07-4cec-a37e-c171c907fcd9	9d52ef0b-806f-4465-b8c9-d14d65781d71	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:40:33
8796	9d52ef0b-7f77-41b6-9a19-bc82b0a3f9a8	9d52ef0b-806f-4465-b8c9-d14d65781d71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:40:33
8797	9d52ef0b-7fbd-464d-b382-cbd57eee0048	9d52ef0b-806f-4465-b8c9-d14d65781d71	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":220,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:40:33
8975	9d52f346-f858-44fa-ae4a-6c5ee4b42f61	9d52f347-1b0f-4b1b-be95-269ecd5ead61	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:52:23
8976	9d52f347-146d-42ea-ac54-627cb037bc0f	9d52f347-1b0f-4b1b-be95-269ecd5ead61	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:52:24
4134	9d511de9-ac75-4496-a3ec-81b90fd100d4	9d511de9-d7ee-4a1f-81ef-dbe8b5d15737	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 15:59:57
4135	9d511de9-cf3c-460c-9d11-ac4f6be0109a	9d511de9-d7ee-4a1f-81ef-dbe8b5d15737	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"59.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:59:57
4136	9d511de9-cfed-4bbd-b7e2-3f737ae4ab13	9d511de9-d7ee-4a1f-81ef-dbe8b5d15737	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 15:59:57
4137	9d511de9-d684-4f31-b339-699c69c04f79	9d511de9-d7ee-4a1f-81ef-dbe8b5d15737	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 15:59:57
4138	9d511de9-d6f3-46a2-bf8d-8870a4c5f454	9d511de9-d7ee-4a1f-81ef-dbe8b5d15737	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":398,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:59:57
8798	9d52ef0b-cfb7-4403-b2d1-66a3ab565305	9d52ef0b-f35a-4e0f-bfea-71906813a3e6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:40:34
8799	9d52ef0b-ece8-4bd0-afe5-035b10b986a0	9d52ef0b-f35a-4e0f-bfea-71906813a3e6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"48.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-24 13:40:34
8800	9d52ef0b-ed34-4fbf-80fd-442eee4e6351	9d52ef0b-f35a-4e0f-bfea-71906813a3e6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:40:34
8801	9d52ef0b-ee99-4b6d-94a2-3c277f4bf7ad	9d52ef0b-f35a-4e0f-bfea-71906813a3e6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"1.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 13:40:34
8802	9d52ef0b-eeca-402a-924c-184bbf0ed502	9d52ef0b-f35a-4e0f-bfea-71906813a3e6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:40:34
8803	9d52ef0b-f246-47b6-a82a-3cf7b39fb974	9d52ef0b-f35a-4e0f-bfea-71906813a3e6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:40:34
8804	9d52ef0b-f297-4f68-aef5-951b6e465f12	9d52ef0b-f35a-4e0f-bfea-71906813a3e6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"item":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]},"duration":280,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:40:34
21138	9d673578-29fc-4161-a32d-70ef5850e784	9d673578-31b9-4a28-86dd-e671b412e7f4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_fecha_ultimo_pago\\" = '03-11-2024', \\"loans_pago_interes\\" = 90000, \\"loans_pago_prestado\\" = 300000, \\"updated_at\\" = '2024-11-03 15:34:02' where \\"id\\" = 65","time":"1.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":403,"hash":"138ffd5a6aae2847ac945cb6fb277db0","hostname":"EderCortes"}	2024-11-03 15:34:02
8977	9d52f347-14db-4ff4-aa89-f08a349a4dce	9d52f347-1b0f-4b1b-be95-269ecd5ead61	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:52:24
8978	9d52f347-19b2-4a78-91c3-a64cc66f3354	9d52f347-1b0f-4b1b-be95-269ecd5ead61	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:52:24
21139	9d673578-2a31-4351-8f17-a4b1e67aeeae	9d673578-31b9-4a28-86dd-e671b412e7f4	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:65","changes":{"updated_at":"2024-11-03 15:34:02","loans_fecha_ultimo_pago":"03-11-2024","loans_pago_interes":90000,"loans_pago_prestado":300000},"hostname":"EderCortes"}	2024-11-03 15:34:02
21140	9d673578-2f7a-42cc-9c87-edbd6e4950a1	9d673578-31b9-4a28-86dd-e671b412e7f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:34:02
21141	9d673578-3001-4145-9d31-b585fe328e74	9d673578-31b9-4a28-86dd-e671b412e7f4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"179","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"90000","itemloans_cuota_cancelada":"300000","id":207,"loans_codigo":65,"itemloans_cuota":"1","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":426,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:34:02
23711	9d689b96-ea03-4319-a258-f9d3a21b5cbf	9d689b96-f8b1-49c8-8539-13323aafdfad	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 08:15:25
4139	9d511dea-8210-4a37-89f0-8975d686286e	9d511dea-f049-42f9-95da-7be2ef2c3b52	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 15:59:58
4140	9d511dea-e500-4406-8db7-3149aade9253	9d511dea-f049-42f9-95da-7be2ef2c3b52	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"193.46","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 15:59:58
4141	9d511dea-e5a8-49fb-b415-066636a34595	9d511dea-f049-42f9-95da-7be2ef2c3b52	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 15:59:58
4142	9d511dea-ede0-4275-9e13-fbdb3b617929	9d511dea-f049-42f9-95da-7be2ef2c3b52	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 15:59:58
4143	9d511dea-ee9a-4b0c-818a-43f4888e8936	9d511dea-f049-42f9-95da-7be2ef2c3b52	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":692,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:59:58
8805	9d52ef0d-a1c5-4445-849d-e21b36f33871	9d52ef0d-c2d8-4777-b3e2-091eb58bb656	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:40:35
8806	9d52ef0d-bdad-4d4e-8c9f-3b1d45ddb654	9d52ef0d-c2d8-4777-b3e2-091eb58bb656	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:40:35
8807	9d52ef0d-be0b-4413-ba37-404812d278a8	9d52ef0d-c2d8-4777-b3e2-091eb58bb656	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:40:35
8808	9d52ef0d-c19a-485e-a5d7-633f0c383535	9d52ef0d-c2d8-4777-b3e2-091eb58bb656	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:40:35
8809	9d52ef0d-c1da-43ae-a256-b8363a553d11	9d52ef0d-c2d8-4777-b3e2-091eb58bb656	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":314,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:40:35
21142	9d673578-9c87-4439-9df3-579ad3e3e104	9d673578-c31e-46be-9985-a37e3b3bb9d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:34:02
21143	9d673578-b5be-4cbb-a957-5d53689a67da	9d673578-c31e-46be-9985-a37e3b3bb9d5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 65\\n                        ","time":"46.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6768d7067397538897aacf4d73c43049","hostname":"EderCortes"}	2024-11-03 15:34:02
21144	9d673578-bab3-4f0e-bd9c-d87f02319d44	9d673578-c31e-46be-9985-a37e3b3bb9d5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '65' order by \\"item_loans\\".\\"id\\" asc","time":"2.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 15:34:02
21145	9d673578-bb06-4377-a638-6c8092edf94a	9d673578-c31e-46be-9985-a37e3b3bb9d5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 15:34:02
4144	9d511dec-0951-4c74-9bcc-fb6bfbe6aab0	9d511dec-4f35-4ff3-89cb-6c1652392552	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 15:59:59
4145	9d511dec-43d5-442a-97fa-8e2f2198dc39	9d511dec-4f35-4ff3-89cb-6c1652392552	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"99.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 15:59:59
4146	9d511dec-446a-40a3-8d61-cdc8e0e1e37d	9d511dec-4f35-4ff3-89cb-6c1652392552	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 15:59:59
4147	9d511dec-4d07-4240-8f9a-5bd3f73ac495	9d511dec-4f35-4ff3-89cb-6c1652392552	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 15:59:59
4148	9d511dec-4d96-480a-8892-53e85a49480e	9d511dec-4f35-4ff3-89cb-6c1652392552	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":563,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:59:59
8979	9d52f347-1a0f-4ae3-bfe9-5d17e6231fd0	9d52f347-1b0f-4b1b-be95-269ecd5ead61	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":276,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:52:24
23712	9d689b96-ebe9-41e9-805c-70762531dc4d	9d689b96-f8b1-49c8-8539-13323aafdfad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 68 limit 1","time":"2.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 08:15:25
21146	9d673578-c133-435f-88d8-c291c3a5a1b0	9d673578-c31e-46be-9985-a37e3b3bb9d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:34:02
23713	9d689b96-ec37-41d6-ac04-9bfaeb86e7a9	9d689b96-f8b1-49c8-8539-13323aafdfad	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 08:15:25
21147	9d673578-c1ac-454c-ba9b-d8514dc95cee	9d673578-c31e-46be-9985-a37e3b3bb9d5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/65","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":65,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":3000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-10 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"90000"},"items":[{"id":207,"loans_codigo":65,"itemloans_cuota":"1","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:02.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"300000"},{"id":208,"loans_codigo":65,"itemloans_cuota":"2","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":209,"loans_codigo":65,"itemloans_cuota":"3","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":210,"loans_codigo":65,"itemloans_cuota":"4","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":211,"loans_codigo":65,"itemloans_cuota":"5","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":212,"loans_codigo":65,"itemloans_cuota":"6","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":213,"loans_codigo":65,"itemloans_cuota":"7","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":214,"loans_codigo":65,"itemloans_cuota":"8","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":215,"loans_codigo":65,"itemloans_cuota":"9","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":216,"loans_codigo":65,"itemloans_cuota":"10","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-09-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":343,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:34:02
23714	9d689b96-f03d-4501-9fc3-428e3985fc1f	9d689b96-f8b1-49c8-8539-13323aafdfad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '250000', \\"itemloans_cuota_cancelada\\" = '1000000', \\"updated_at\\" = '2024-11-04 08:15:25' where \\"id\\" = 232","time":"7.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":400,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 08:15:25
23715	9d689b96-f0aa-4987-95a9-e90bc0ba9acf	9d689b96-f8b1-49c8-8539-13323aafdfad	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:232","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 08:15:25","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},"hostname":"EderCortes"}	2024-11-04 08:15:25
8980	9d52f347-6a61-4201-87c1-c98192b3f973	9d52f347-8b8a-4fc9-b6a0-5dc7d1032248	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:52:24
8981	9d52f347-83e9-4611-a89b-adeed5cf6a5d	9d52f347-8b8a-4fc9-b6a0-5dc7d1032248	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"43.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-24 13:52:24
8982	9d52f347-8437-4a72-b5a7-dd37c0900ece	9d52f347-8b8a-4fc9-b6a0-5dc7d1032248	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:52:24
8983	9d52f347-860d-4a96-ad00-1bf78e30fe31	9d52f347-8b8a-4fc9-b6a0-5dc7d1032248	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"2.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 13:52:24
8984	9d52f347-864e-470b-8148-2a2e59f9036d	9d52f347-8b8a-4fc9-b6a0-5dc7d1032248	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:52:24
8985	9d52f347-8a2c-419e-8431-51fbf9c73ffc	9d52f347-8b8a-4fc9-b6a0-5dc7d1032248	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:52:24
8986	9d52f347-8a8f-40b3-a8ce-9a08d9ed8345	9d52f347-8b8a-4fc9-b6a0-5dc7d1032248	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:52:24
21148	9d67359e-4ca3-459e-b271-33e275882f5f	9d67359e-4f9f-40be-a1bb-802cf094a984	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":137,"memory":20,"hostname":"EderCortes"}	2024-11-03 15:34:27
23360	9d68951b-e53d-4975-9891-68128a3767fa	9d68951b-e67b-41b0-9bbf-57ca8f40421c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/69","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":69,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1150000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":243,"loans_codigo":69,"itemloans_cuota":"1","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T05:49:09.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":244,"loans_codigo":69,"itemloans_cuota":"2","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T05:49:09.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":245,"loans_codigo":69,"itemloans_cuota":"3","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T05:49:09.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":246,"loans_codigo":69,"itemloans_cuota":"4","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T05:49:09.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":247,"loans_codigo":69,"itemloans_cuota":"5","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T05:49:09.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":570,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:57:17
12752	9d5cecc1-33bf-43dc-9d4d-760bfe5edca4	9d5cecc1-36aa-4c74-8ad6-e6f3c455e21a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":124,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:26
21718	9d673dbc-2334-4c5b-9de1-61cb37cfc1fd	9d673dbc-2706-4bea-ade8-0d8bd17d554c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":139,"memory":20,"hostname":"EderCortes"}	2024-11-03 15:57:09
23716	9d689b96-f161-4b8e-b6cf-530247739191	9d689b96-f8b1-49c8-8539-13323aafdfad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 1500000, \\"loans_pago_prestado\\" = 6000000, \\"updated_at\\" = '2024-11-04 08:15:25' where \\"id\\" = 68","time":"0.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":408,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 08:15:25
23717	9d689b96-f19e-4b06-a4e8-12d2579880da	9d689b96-f8b1-49c8-8539-13323aafdfad	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:68","changes":{"updated_at":"2024-11-04 08:15:25","loans_pago_interes":1500000,"loans_pago_prestado":6000000},"hostname":"EderCortes"}	2024-11-04 08:15:25
23718	9d689b96-f690-41a1-a676-54985f00027c	9d689b96-f8b1-49c8-8539-13323aafdfad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 08:15:25
21149	9d67359e-caf5-4720-b026-eeac39acd426	9d67359e-ede3-4686-869f-03d7cc282d60	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:34:27
21150	9d67359e-e2bd-4f42-a13c-f10e4a499d9e	9d67359e-ede3-4686-869f-03d7cc282d60	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 208 limit 1","time":"2.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-03 15:34:27
3200	9d510363-6846-4889-a1e6-81efe9396bd0	9d510363-a565-4e3e-bf57-f5eae8ed5761	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:45:47
3201	9d510363-a1de-4af9-bfaa-763b82063348	9d510363-a565-4e3e-bf57-f5eae8ed5761	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:45:47
3202	9d510363-a357-4b91-8b39-3bfa0e4b9067	9d510363-a565-4e3e-bf57-f5eae8ed5761	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":544,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:45:47
23361	9d689592-c6ff-4daa-ab93-46bc26dc32f0	9d689592-cae2-419c-86a0-1b423430d185	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":179,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:58:35
25325	9d68c12a-db94-429b-9037-943259385754	9d68c12a-e04c-4af6-9391-a4ac079af3f5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_interes_canelado\\" = '55000', \\"itemloans_cuota_cancelada\\" = '220000', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_status\\" = 'Pagada', \\"itemloans_aprobador\\" = 12, \\"updated_at\\" = '2024-11-04 10:00:29' where \\"loans_codigo\\" = 90 and \\"itemloans_status\\" = 'Pendiente'","time":"0.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":747,"hash":"87a64c6113219082cd85f391b598ec7f","hostname":"EderCortes"}	2024-11-04 10:00:29
23719	9d689b96-f711-42b5-80a2-02c84895bb5a	9d689b96-f8b1-49c8-8539-13323aafdfad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"181","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000","id":232,"loans_codigo":68,"itemloans_cuota":"6","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":370,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:15:25
25326	9d68c12a-defa-42d2-8e05-0bfd7045222f	9d68c12a-e04c-4af6-9391-a4ac079af3f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 10:00:29
21151	9d67359e-e303-4fba-8647-8183cd16ced4	9d67359e-ede3-4686-869f-03d7cc282d60	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-03 15:34:27
21152	9d67359e-e474-4881-adcd-746520df61aa	9d67359e-ede3-4686-869f-03d7cc282d60	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 65 limit 1","time":"1.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 15:34:27
21153	9d67359e-e4b4-4701-aed2-4028aac777fb	9d67359e-ede3-4686-869f-03d7cc282d60	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 15:34:27
21154	9d67359e-e862-4160-9963-9c25fa7d3033	9d67359e-ede3-4686-869f-03d7cc282d60	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '03-11-2024', \\"itemloans_cuota_cancelada\\" = '300000', \\"updated_at\\" = '2024-11-03 15:34:27' where \\"id\\" = 208","time":"7.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":395,"hash":"35b67f849e4a0ba5090d9c1eb8abfe94","hostname":"EderCortes"}	2024-11-03 15:34:27
21155	9d67359e-e8b5-423c-ab95-6575e4127993	9d67359e-ede3-4686-869f-03d7cc282d60	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:208","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-03 15:34:27","item_loans_cuando_pago":"03-11-2024","itemloans_cuota_cancelada":"300000"},"hostname":"EderCortes"}	2024-11-03 15:34:27
21156	9d67359e-e955-45e1-91a9-75e814f5c1b5	9d67359e-ede3-4686-869f-03d7cc282d60	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 180000, \\"loans_pago_prestado\\" = 600000, \\"updated_at\\" = '2024-11-03 15:34:27' where \\"id\\" = 65","time":"0.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":403,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-03 15:34:27
21157	9d67359e-e986-4739-9c49-ab41f5287d57	9d67359e-ede3-4686-869f-03d7cc282d60	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:65","changes":{"updated_at":"2024-11-03 15:34:27","loans_pago_interes":180000,"loans_pago_prestado":600000},"hostname":"EderCortes"}	2024-11-03 15:34:27
21158	9d67359e-ec96-42f8-9718-bc16a5b1cb82	9d67359e-ede3-4686-869f-03d7cc282d60	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 15:34:28
25327	9d68c12a-df3f-4814-bade-1bab0e65fb59	9d68c12a-e04c-4af6-9391-a4ac079af3f5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-total-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payTotal","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"29","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"idLoans":90,"idCreador":12},"session":[],"response_status":200,"response":{"message":"Se ha realizado el pago total del credito","status":true},"duration":374,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:00:29
8987	9d52f34a-49e5-4299-b82f-0845e0196f7b	9d52f34a-7a79-45b8-bcd1-743837d85404	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:52:26
8988	9d52f34a-71c4-44b8-8414-db13af2c7925	9d52f34a-7a79-45b8-bcd1-743837d85404	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"64.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:52:26
8989	9d52f34a-7233-4668-b170-a9089cadfec5	9d52f34a-7a79-45b8-bcd1-743837d85404	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:52:26
8990	9d52f34a-786f-4875-afc8-b93fb14af173	9d52f34a-7a79-45b8-bcd1-743837d85404	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:52:26
8991	9d52f34a-78fd-44a9-a956-ed58ab51fc3c	9d52f34a-7a79-45b8-bcd1-743837d85404	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":462,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:52:26
21159	9d67359e-ecd8-4bf6-b0c1-3a77ff539e7d	9d67359e-ede3-4686-869f-03d7cc282d60	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"179","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"90000","itemloans_cuota_cancelada":"300000","id":208,"loans_codigo":65,"itemloans_cuota":"2","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:34:28
21719	9d673dbc-7d1f-400d-8e70-34bf7ceba82f	9d673dbc-800b-46cc-94b2-c5afbda1011e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":154,"memory":20,"hostname":"EderCortes"}	2024-11-03 15:57:09
12753	9d5cecc1-9e05-4286-8fbb-26d809099976	9d5cecc1-b7ae-4595-979e-023f678957d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":30,"hostname":"EderCortes"}	2024-10-29 12:52:26
12754	9d5cecc1-b39c-4c24-9fbb-f03c95da6976	9d5cecc1-b7ae-4595-979e-023f678957d5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ma%' or \\"users\\".\\"user_document\\"::text like '%Ma%') order by \\"users\\".\\"user_document\\" asc","time":"40.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:52:26
12755	9d5cecc1-b65c-4341-ae47-b21399d638a4	9d5cecc1-b7ae-4595-979e-023f678957d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":31,"hostname":"EderCortes"}	2024-10-29 12:52:26
12756	9d5cecc1-b6a9-4121-a734-b88d30e37378	9d5cecc1-b7ae-4595-979e-023f678957d5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ma"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":198,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:26
23720	9d689b97-4481-457f-ab41-b59570541166	9d689b97-6641-4c71-bfd4-8fa1060fde03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 08:15:25
25328	9d68c12b-53f2-4f4b-9dbc-75de2511f5b8	9d68c12b-9912-4446-a0bd-3ad46262ad7a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 10:00:30
21160	9d67359f-3179-47b2-b7f9-e9869689ae2d	9d67359f-50aa-48bb-a363-87fd74d80db0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 15:34:28
21161	9d67359f-4761-43d3-902d-59479eb5390f	9d67359f-50aa-48bb-a363-87fd74d80db0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 65\\n                        ","time":"43.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6768d7067397538897aacf4d73c43049","hostname":"EderCortes"}	2024-11-03 15:34:28
21162	9d67359f-4b11-4ee8-8b34-59e9fc628b59	9d67359f-50aa-48bb-a363-87fd74d80db0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '65' order by \\"item_loans\\".\\"id\\" asc","time":"2.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 15:34:28
21163	9d67359f-4b40-4c48-9e9c-a5e0bb830d55	9d67359f-50aa-48bb-a363-87fd74d80db0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 15:34:28
21164	9d67359f-4f5e-461c-b442-ff0dac042e38	9d67359f-50aa-48bb-a363-87fd74d80db0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 15:34:28
21165	9d67359f-4faa-4f13-8303-03e4db65e75d	9d67359f-50aa-48bb-a363-87fd74d80db0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/65","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":65,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":3000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-10 00:00:00","loans_pago_prestado":"600000","loans_pago_interes":"180000"},"items":[{"id":207,"loans_codigo":65,"itemloans_cuota":"1","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:02.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"300000"},{"id":208,"loans_codigo":65,"itemloans_cuota":"2","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"300000"},{"id":209,"loans_codigo":65,"itemloans_cuota":"3","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":210,"loans_codigo":65,"itemloans_cuota":"4","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":211,"loans_codigo":65,"itemloans_cuota":"5","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":212,"loans_codigo":65,"itemloans_cuota":"6","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":213,"loans_codigo":65,"itemloans_cuota":"7","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":214,"loans_codigo":65,"itemloans_cuota":"8","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":215,"loans_codigo":65,"itemloans_cuota":"9","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":216,"loans_codigo":65,"itemloans_cuota":"10","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-09-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:34:28
23721	9d689b97-5bb9-4dce-a9e8-66e5244c8a7b	9d689b97-6641-4c71-bfd4-8fa1060fde03	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 68\\n                        ","time":"45.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"7d9994d55cb8dde82ff4185920c79043","hostname":"EderCortes"}	2024-11-04 08:15:25
21720	9d673dbc-c807-4c38-9882-34ceddcb8152	9d673dbc-cac1-41f4-b1b6-5f1909a509fc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":126,"memory":20,"hostname":"EderCortes"}	2024-11-03 15:57:09
23722	9d689b97-6008-4202-87b6-671103900f2a	9d689b97-6641-4c71-bfd4-8fa1060fde03	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '68' order by \\"item_loans\\".\\"id\\" asc","time":"2.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:15:25
23723	9d689b97-603c-410e-a879-d9a14af21431	9d689b97-6641-4c71-bfd4-8fa1060fde03	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 08:15:25
23724	9d689b97-64e9-4758-afe0-ab0361008292	9d689b97-6641-4c71-bfd4-8fa1060fde03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 08:15:25
9149	9d52f57e-b169-426d-a697-b862864e0a9d	9d52f57e-df43-43e0-b04f-fb42dda30dce	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 13:58:36
9150	9d52f57e-dcc9-4a04-bc9f-46364986166b	9d52f57e-df43-43e0-b04f-fb42dda30dce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:58:36
9151	9d52f57e-de0f-4d0f-ae56-59b1a151f9e4	9d52f57e-df43-43e0-b04f-fb42dda30dce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":381,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:58:36
23725	9d689b97-6538-4eb6-94fb-4f7fc44c1c4d	9d689b97-6641-4c71-bfd4-8fa1060fde03	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/68","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":68,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":10000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"6000000","loans_pago_interes":"1500000"},"items":[{"id":227,"loans_codigo":68,"itemloans_cuota":"1","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":228,"loans_codigo":68,"itemloans_cuota":"2","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:14:40.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":229,"loans_codigo":68,"itemloans_cuota":"3","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:14:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":230,"loans_codigo":68,"itemloans_cuota":"4","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:14:49.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":231,"loans_codigo":68,"itemloans_cuota":"5","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:15:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":232,"loans_codigo":68,"itemloans_cuota":"6","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:15:25.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":233,"loans_codigo":68,"itemloans_cuota":"7","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":234,"loans_codigo":68,"itemloans_cuota":"8","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":235,"loans_codigo":68,"itemloans_cuota":"9","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":236,"loans_codigo":68,"itemloans_cuota":"10","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":259,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:15:25
21166	9d6735f7-b391-42b1-933b-1c71b16aab13	9d6735f7-b823-4269-a81c-ff45513792ee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":180,"memory":20,"hostname":"EderCortes"}	2024-11-03 15:35:26
25329	9d68c12b-9057-4b15-bc9b-b29b4d3eb0e3	9d68c12b-9912-4446-a0bd-3ad46262ad7a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 90\\n                        ","time":"142.72","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"93c10371e33ace24260de21c3ff3890d","hostname":"EderCortes"}	2024-11-04 10:00:30
21721	9d673dbd-21e7-4f60-9524-c3be65900afa	9d673dbd-3dbe-40cb-9f17-bbeab9e577ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 15:57:09
21722	9d673dbd-392b-448f-b0a0-6c78470c0a33	9d673dbd-3dbe-40cb-9f17-bbeab9e577ff	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mar%' or \\"users\\".\\"user_document\\"::text like '%Mar%') order by \\"users\\".\\"user_document\\" asc","time":"41.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 15:57:10
21723	9d673dbd-3c59-420f-b078-ea173a92d132	9d673dbd-3dbe-40cb-9f17-bbeab9e577ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 15:57:10
21724	9d673dbd-3cab-45f9-948e-bcfd625b22f5	9d673dbd-3dbe-40cb-9f17-bbeab9e577ff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mar"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:57:10
25330	9d68c12b-93da-44ab-b83f-361ade62b7c6	9d68c12b-9912-4446-a0bd-3ad46262ad7a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"1.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:00:30
25331	9d68c12b-940f-41ee-9e63-6c8a7d5844ed	9d68c12b-9912-4446-a0bd-3ad46262ad7a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 10:00:30
9152	9d52f57f-59f1-4dae-9175-2f71b4712609	9d52f57f-83d9-487f-91fe-d55d7532d424	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:58:36
9153	9d52f57f-78ea-436c-8a86-b5816885dc03	9d52f57f-83d9-487f-91fe-d55d7532d424	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:58:36
9154	9d52f57f-7971-4edb-8d1a-d318f5933db0	9d52f57f-83d9-487f-91fe-d55d7532d424	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:58:36
9155	9d52f57f-8207-4ba0-a331-9a1fcb038ec3	9d52f57f-83d9-487f-91fe-d55d7532d424	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:58:36
9156	9d52f57f-8272-4a33-aa23-637d98e3f0d7	9d52f57f-83d9-487f-91fe-d55d7532d424	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":388,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:58:36
23726	9d689b9b-e8d1-47c6-a7a2-b03a095d1632	9d689b9b-ec8a-45bd-ae79-b9f84368ae7c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":151,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:15:28
25332	9d68c12b-97bd-47eb-b2f3-3142f38f2f05	9d68c12b-9912-4446-a0bd-3ad46262ad7a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 10:00:30
25333	9d68c12b-9807-4fb8-9088-de336052d375	9d68c12b-9912-4446-a0bd-3ad46262ad7a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"}]}},"duration":452,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:00:30
9326	9d52f725-a6c3-4fd1-8caf-98dc17a1c618	9d52f725-c3f9-4800-bf48-d837dba9060f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 14:03:13
26125	9d68cdb8-be03-4f56-9aa3-efff8ddf1029	9d68cdb8-bfc2-4399-a5f7-1c6dd326862b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":628,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:35:35
28646	9d690660-0dac-4217-8a59-9a8504731a9e	9d690660-12f3-449e-a50f-9d10635e08a9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":251,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:14:00
9157	9d52f57f-d714-4d56-9ed6-188e367872a4	9d52f580-222c-4c4d-90a4-932b5ee25d69	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:58:36
9158	9d52f580-1bb0-478b-b076-d79b78811569	9d52f580-222c-4c4d-90a4-932b5ee25d69	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"149.25","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:58:36
9159	9d52f580-1c05-44d3-a6d9-b1d27ceeb547	9d52f580-222c-4c4d-90a4-932b5ee25d69	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:58:36
9160	9d52f580-209e-4c1f-bb56-f58f0bb4c7e4	9d52f580-222c-4c4d-90a4-932b5ee25d69	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:58:36
9161	9d52f580-2107-4fc8-80ff-be994a18b62e	9d52f580-222c-4c4d-90a4-932b5ee25d69	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":387,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:58:36
21174	9d6735f8-eaac-4645-a239-335a12d511e8	9d6735f9-37be-4199-9ca9-d314a3dc90ab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:35:26
21175	9d6735f9-2ac8-47a6-8901-741b1a1606b7	9d6735f9-37be-4199-9ca9-d314a3dc90ab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 65\\n                        ","time":"148.65","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6768d7067397538897aacf4d73c43049","hostname":"EderCortes"}	2024-11-03 15:35:27
9327	9d52f725-c26f-4a59-9891-2f52cfbe98fd	9d52f725-c3f9-4800-bf48-d837dba9060f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 14:03:13
9328	9d52f725-c313-40d1-b6ce-705b6ab1de83	9d52f725-c3f9-4800-bf48-d837dba9060f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:03:13
12757	9d5cecc3-7dab-4615-8aca-da69f8e6ddef	9d5cecc3-8088-48f4-bc3f-504cd87e9e1e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":135,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:52:27
21176	9d6735f9-310f-4f1d-858f-3d87cf4a0227	9d6735f9-37be-4199-9ca9-d314a3dc90ab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '65' order by \\"item_loans\\".\\"id\\" asc","time":"3.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 15:35:27
21177	9d6735f9-314d-47ed-81d6-7dadefa68fa2	9d6735f9-37be-4199-9ca9-d314a3dc90ab	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 15:35:27
21178	9d6735f9-3630-4c4d-8d72-320a2e5fe30b	9d6735f9-37be-4199-9ca9-d314a3dc90ab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:35:27
21725	9d673dbd-7a90-4d31-bca9-0cfec4b017b3	9d673dbd-7d81-4693-ba3c-c5899065d6ff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":137,"memory":20,"hostname":"EderCortes"}	2024-11-03 15:57:10
23727	9d689b9c-4c7c-4e96-86b6-fcb6c4c060ef	9d689b9c-7212-4e38-abc9-897a4e78989b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 08:15:28
25334	9d68c134-dc98-48e3-a499-59a41ce8beb0	9d68c134-f945-4462-bd01-f1f96e2d5fc7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 10:00:36
9162	9d52f580-753a-4fb6-a5ae-4d991a9ab291	9d52f580-94d4-424b-800e-dfabff7f159e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:58:37
9163	9d52f580-8cf5-40e0-ab78-ae17a1b47432	9d52f580-94d4-424b-800e-dfabff7f159e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"40.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-24 13:58:37
4794	9d51353b-8f2a-4703-adae-6869c4f84972	9d51353b-dc47-41b0-9443-8f7102c03a48	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 17:05:10
4795	9d51353b-da58-4f4f-af1e-e8be3c65e057	9d51353b-dc47-41b0-9443-8f7102c03a48	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 17:05:10
4796	9d51353b-db1a-4182-80f1-38c3c4050783	9d51353b-dc47-41b0-9443-8f7102c03a48	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":594,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:05:10
9164	9d52f580-8d3e-4cb6-8c70-153fbc280b5f	9d52f580-94d4-424b-800e-dfabff7f159e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:58:37
9165	9d52f580-8f49-478d-a6e3-6fc31680e6cb	9d52f580-94d4-424b-800e-dfabff7f159e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"2.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 13:58:37
9166	9d52f580-8f86-482d-a06e-f9216d784a93	9d52f580-94d4-424b-800e-dfabff7f159e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:58:37
9167	9d52f580-936e-41cd-8e50-846a6f3b8695	9d52f580-94d4-424b-800e-dfabff7f159e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:58:37
9168	9d52f580-93c3-4303-870f-11b67457315f	9d52f580-94d4-424b-800e-dfabff7f159e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":268,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:58:37
21179	9d6735f9-3690-4227-8917-015d8cb1eb2c	9d6735f9-37be-4199-9ca9-d314a3dc90ab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/65","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":65,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":3000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-10 00:00:00","loans_pago_prestado":"600000","loans_pago_interes":"180000"},"items":[{"id":207,"loans_codigo":65,"itemloans_cuota":"1","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:02.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"300000"},{"id":208,"loans_codigo":65,"itemloans_cuota":"2","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"300000"},{"id":209,"loans_codigo":65,"itemloans_cuota":"3","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":210,"loans_codigo":65,"itemloans_cuota":"4","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":211,"loans_codigo":65,"itemloans_cuota":"5","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":212,"loans_codigo":65,"itemloans_cuota":"6","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":213,"loans_codigo":65,"itemloans_cuota":"7","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":214,"loans_codigo":65,"itemloans_cuota":"8","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":215,"loans_codigo":65,"itemloans_cuota":"9","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":216,"loans_codigo":65,"itemloans_cuota":"10","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-09-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":475,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:35:27
23728	9d689b9c-662e-4152-8eb1-d82cc9e523f8	9d689b9c-7212-4e38-abc9-897a4e78989b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 233 limit 1","time":"3.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 08:15:28
9329	9d52f726-0b11-4a1a-8e3c-6f382ca891a6	9d52f726-2953-4f96-8fb5-b5f2c71cd015	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 14:03:13
9330	9d52f726-2491-4789-80cd-8609e4adb404	9d52f726-2953-4f96-8fb5-b5f2c71cd015	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 14:03:13
9331	9d52f726-24df-449e-a148-6f1bd752cb1a	9d52f726-2953-4f96-8fb5-b5f2c71cd015	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 14:03:13
9332	9d52f726-283b-42b7-9950-98b140eee7c4	9d52f726-2953-4f96-8fb5-b5f2c71cd015	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 14:03:13
21726	9d673dbd-ca87-4a6c-abf0-03e14e0bdcd1	9d673dbd-e6a5-4727-a4f8-56f401eb2394	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 15:57:10
21727	9d673dbd-e283-4a2b-87e5-16424d6ffd8c	9d673dbd-e6a5-4727-a4f8-56f401eb2394	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"44.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 15:57:10
21728	9d673dbd-e559-45ef-9410-190dc5122f7c	9d673dbd-e6a5-4727-a4f8-56f401eb2394	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-03 15:57:10
23729	9d689b9c-667c-4918-b898-f09a0c0181db	9d689b9c-7212-4e38-abc9-897a4e78989b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 08:15:28
23730	9d689b9c-6816-43fc-af15-3c7ab722d415	9d689b9c-7212-4e38-abc9-897a4e78989b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 68 limit 1","time":"2.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 08:15:28
4797	9d51353c-363a-480c-a6b0-d7cc73b76d39	9d51353c-5b5c-4f70-9658-68c75d2921bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 17:05:10
4798	9d51353c-5296-4007-819e-66ba2c7644e4	9d51353c-5b5c-4f70-9658-68c75d2921bd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:05:10
4799	9d51353c-52e9-472e-8694-cd139398f42e	9d51353c-5b5c-4f70-9658-68c75d2921bd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:05:10
4800	9d51353c-59f5-4307-b297-2a2320391636	9d51353c-5b5c-4f70-9658-68c75d2921bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 17:05:10
4801	9d51353c-5a50-4ea8-b7c1-a9432344fc27	9d51353c-5b5c-4f70-9658-68c75d2921bd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}},"duration":300,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:05:10
9333	9d52f726-287b-4afd-bc15-3dbc674e540d	9d52f726-2953-4f96-8fb5-b5f2c71cd015	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:03:13
23731	9d689b9c-684d-483a-b3ce-755bf5957f8b	9d689b9c-7212-4e38-abc9-897a4e78989b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 08:15:28
4938	9d513654-0eb4-4bf3-bec5-fbedb115c8bf	9d513654-3e97-4326-9c26-c463d4252b15	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-23 17:08:13
4939	9d513654-3c54-497e-8f3e-f44695e33dce	9d513654-3e97-4326-9c26-c463d4252b15	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-23 17:08:14
4940	9d513654-3d49-4adf-995a-4e7a7a4cd334	9d513654-3e97-4326-9c26-c463d4252b15	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":406,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:14
23732	9d689b9c-6be5-44bf-82ac-09c324dbe466	9d689b9c-7212-4e38-abc9-897a4e78989b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '250000', \\"itemloans_cuota_cancelada\\" = '1000000', \\"updated_at\\" = '2024-11-04 08:15:28' where \\"id\\" = 233","time":"7.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":400,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 08:15:28
12758	9d5cecc4-2fd3-4bc6-9fd0-bb9208e211ca	9d5cecc4-71b2-4f98-92ec-86610b7d321b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":31,"hostname":"EderCortes"}	2024-10-29 12:52:28
12759	9d5cecc4-6dd2-43b5-b93a-35c989c9ffa7	9d5cecc4-71b2-4f98-92ec-86610b7d321b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mar%' or \\"users\\".\\"user_document\\"::text like '%Mar%') order by \\"users\\".\\"user_document\\" asc","time":"143.80","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:52:28
12760	9d5cecc4-7096-4afa-8d94-3e6835690ffc	9d5cecc4-71b2-4f98-92ec-86610b7d321b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":32,"hostname":"EderCortes"}	2024-10-29 12:52:28
12761	9d5cecc4-70d3-44cd-a7d1-a769674d9e19	9d5cecc4-71b2-4f98-92ec-86610b7d321b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mar"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":303,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:28
23733	9d689b9c-6c4c-4660-99ac-d406de415ee6	9d689b9c-7212-4e38-abc9-897a4e78989b	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:233","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 08:15:28","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},"hostname":"EderCortes"}	2024-11-04 08:15:28
23734	9d689b9c-6cfd-4665-bca7-9dd2135c1b61	9d689b9c-7212-4e38-abc9-897a4e78989b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 1750000, \\"loans_pago_prestado\\" = 7000000, \\"updated_at\\" = '2024-11-04 08:15:28' where \\"id\\" = 68","time":"0.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":408,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 08:15:28
23735	9d689b9c-6d36-4f29-a75f-d3e5281496f8	9d689b9c-7212-4e38-abc9-897a4e78989b	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:68","changes":{"updated_at":"2024-11-04 08:15:28","loans_pago_interes":1750000,"loans_pago_prestado":7000000},"hostname":"EderCortes"}	2024-11-04 08:15:28
23736	9d689b9c-7096-4246-b714-f8c88cab9d1c	9d689b9c-7212-4e38-abc9-897a4e78989b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 08:15:28
23737	9d689b9c-70ea-414a-be40-b7c63f3a2558	9d689b9c-7212-4e38-abc9-897a4e78989b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"181","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000","id":233,"loans_codigo":68,"itemloans_cuota":"7","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:15:28
3442	9d5105e3-aeed-479d-baea-2ec21b2c6815	9d5105e3-ee49-4313-8044-261bf13b0ab4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 14:52:47
3443	9d5105e3-eab4-42ff-8c16-2c2837e3c7a3	9d5105e3-ee49-4313-8044-261bf13b0ab4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:52:47
3444	9d5105e3-ec98-4415-b4fa-913292329773	9d5105e3-ee49-4313-8044-261bf13b0ab4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":568,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:52:47
25335	9d68c134-f44e-44af-86f6-047b8d49973b	9d68c134-f945-4462-bd01-f1f96e2d5fc7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"44.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 10:00:36
12762	9d5ceccb-cde4-428d-bdeb-7498680de4ec	9d5ceccb-d11b-4932-b5d0-a50d02fdca1d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":158,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:52:33
9334	9d52f726-70f4-4bc4-ad3e-90401b83b849	9d52f726-b9ff-43d6-9a37-45fc9e6be217	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 14:03:13
9335	9d52f726-b524-4a36-986f-2e7840cedd92	9d52f726-b9ff-43d6-9a37-45fc9e6be217	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"151.51","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 14:03:13
9336	9d52f726-b56c-49df-be57-203126371838	9d52f726-b9ff-43d6-9a37-45fc9e6be217	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 14:03:13
9337	9d52f726-b8f5-4ba0-bd5a-c2aa76f1a51a	9d52f726-b9ff-43d6-9a37-45fc9e6be217	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 14:03:13
9338	9d52f726-b933-421b-8f8e-30d5c2ad3524	9d52f726-b9ff-43d6-9a37-45fc9e6be217	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":355,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:03:13
25336	9d68c134-f7a4-4133-903c-58b424cf5329	9d68c134-f945-4462-bd01-f1f96e2d5fc7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 10:00:36
26126	9d68cdbc-5863-4138-a9ed-bee0e8d0d253	9d68cdbc-76ea-4087-a840-01015116e512	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:35:38
26901	9d68dd72-285d-44c7-b9e8-0db3b2c7ee7c	9d68dd72-2db7-4c1d-a3d9-2191ae42cd6e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"42.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 11:19:34
26902	9d68dd72-2bfa-41db-945f-01dbc33e293f	9d68dd72-2db7-4c1d-a3d9-2191ae42cd6e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:19:34
3445	9d5105e4-784b-468c-9259-52b0c68dff60	9d5105e4-b26f-42e0-a31c-c992924675dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 14:52:47
3446	9d5105e4-a6e1-4cee-99a5-5e85b525fb51	9d5105e4-b26f-42e0-a31c-c992924675dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"69.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:52:47
3447	9d5105e4-a785-4ed3-adb5-74de243fe961	9d5105e4-b26f-42e0-a31c-c992924675dd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 14:52:47
3448	9d5105e4-b0bb-42cd-b9f0-65032ba13a81	9d5105e4-b26f-42e0-a31c-c992924675dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:52:47
3449	9d5105e4-b130-4aeb-8a03-31540492e22f	9d5105e4-b26f-42e0-a31c-c992924675dd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":462,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:52:47
4802	9d51353c-b2d5-4dd8-83e9-00661715d397	9d51353c-fe65-4473-9d32-f30ae1a28906	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 17:05:10
4803	9d51353c-f8ee-450a-86d1-c0e6b4d3b8c1	9d51353c-fe65-4473-9d32-f30ae1a28906	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"155.73","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:05:11
4804	9d51353c-f95a-42f2-88d7-fdc1e5a4e057	9d51353c-fe65-4473-9d32-f30ae1a28906	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:05:11
4805	9d51353c-fd3f-43e1-b514-7f005bb607bb	9d51353c-fe65-4473-9d32-f30ae1a28906	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 17:05:11
4806	9d51353c-fd8a-4829-83cf-c47fc803632b	9d51353c-fe65-4473-9d32-f30ae1a28906	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}},"duration":400,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:05:11
4941	9d513654-bbde-4114-a152-69d706444d4d	9d513654-efa9-4308-bbb6-b59b39451fd1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-23 17:08:14
4942	9d513654-e546-41f0-a356-b380319ba890	9d513654-efa9-4308-bbb6-b59b39451fd1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"66.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:08:14
4943	9d513654-e5d5-4317-87de-67fef5f745ab	9d513654-efa9-4308-bbb6-b59b39451fd1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:08:14
4944	9d513654-edfe-4d58-b1f3-4a8abcdc22b5	9d513654-efa9-4308-bbb6-b59b39451fd1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-23 17:08:14
4945	9d513654-ee76-4532-a67d-d876eb3e10f7	9d513654-efa9-4308-bbb6-b59b39451fd1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":416,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:14
9339	9d52f726-fd15-4165-b0a4-727e255fad21	9d52f727-4988-4479-a06a-d67582fc74aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 14:03:14
9340	9d52f727-40d2-4d15-8728-2399b242a37b	9d52f727-4988-4479-a06a-d67582fc74aa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"152.43","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-24 14:03:14
9341	9d52f727-4145-4c09-bb1a-6ee417d49e27	9d52f727-4988-4479-a06a-d67582fc74aa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 14:03:14
9342	9d52f727-4307-44de-8473-ae3a902cf0c9	9d52f727-4988-4479-a06a-d67582fc74aa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"1.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 14:03:14
9343	9d52f727-433c-44cc-b14b-5abd45f90132	9d52f727-4988-4479-a06a-d67582fc74aa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 14:03:14
9344	9d52f727-46f5-4f8b-adc3-d2baf4c83efe	9d52f727-4988-4479-a06a-d67582fc74aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 14:03:14
3450	9d5105e5-344b-4491-89ad-c7c533dd5325	9d5105e5-5ebc-4498-b29d-6729e43f74f1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 14:52:48
3451	9d5105e5-553c-4313-826d-3e6600d9e729	9d5105e5-5ebc-4498-b29d-6729e43f74f1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"56.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 14:52:48
3452	9d5105e5-55bf-4a48-86a5-53e5dc0f0d83	9d5105e5-5ebc-4498-b29d-6729e43f74f1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 14:52:48
3453	9d5105e5-5cd0-4b69-8665-be319a677699	9d5105e5-5ebc-4498-b29d-6729e43f74f1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 14:52:48
3454	9d5105e5-5d45-48b4-b537-45981e033540	9d5105e5-5ebc-4498-b29d-6729e43f74f1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":416,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:52:48
4807	9d51353f-793d-4814-a187-6199f724a20a	9d51353f-9f5c-4b8c-9c54-3ef5966d9473	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 17:05:12
4808	9d51353f-98a7-4ade-83f5-b88f5e98af70	9d51353f-9f5c-4b8c-9c54-3ef5966d9473	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"58.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:05:12
4809	9d51353f-98fd-477a-a310-688b99034233	9d51353f-9f5c-4b8c-9c54-3ef5966d9473	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:05:12
4810	9d51353f-9d88-449c-a051-831a436e74d8	9d51353f-9f5c-4b8c-9c54-3ef5966d9473	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 17:05:12
4811	9d51353f-9e12-4e8e-a558-738e6c054fd6	9d51353f-9f5c-4b8c-9c54-3ef5966d9473	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":287,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:05:12
4946	9d513655-5e4e-464e-8b6d-70fef9b866da	9d513655-be5a-4d09-88e5-f928a30f19d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-23 17:08:14
4947	9d513655-7cbb-4ac0-a1bf-c0b2c46d92b6	9d513655-be5a-4d09-88e5-f928a30f19d2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"51.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:08:14
4948	9d513655-7d31-4bae-9886-b34e92400296	9d513655-be5a-4d09-88e5-f928a30f19d2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:08:14
4949	9d513655-bbd8-4fd2-95e8-55f5226bb503	9d513655-be5a-4d09-88e5-f928a30f19d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-10-23 17:08:15
4950	9d513655-bc70-4cb7-b738-6f19e9b4b418	9d513655-be5a-4d09-88e5-f928a30f19d2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":503,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:15
9345	9d52f727-4776-4c4f-8354-11873a13826a	9d52f727-4988-4479-a06a-d67582fc74aa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":350,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:03:14
3314	9d510480-5f8c-41ca-b56f-e192842cb090	9d510480-ab7d-4538-adec-d0804ffc7f8b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 14:48:54
3315	9d510480-a961-4618-b7d7-ede0e79a2688	9d510480-ab7d-4538-adec-d0804ffc7f8b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 14:48:54
3316	9d510480-aa59-4ee8-aaf9-e31d4381c616	9d510480-ab7d-4538-adec-d0804ffc7f8b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":378,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:48:54
3770	9d511874-8ba8-4b01-b989-6e8962b1e95f	9d511874-c524-48f7-abbc-2b4aa26d583c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 15:44:42
3771	9d511874-c338-41e0-baa2-799a0b6014ea	9d511874-c524-48f7-abbc-2b4aa26d583c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 15:44:42
3772	9d511874-c426-4b5a-b357-2faa569c6946	9d511874-c524-48f7-abbc-2b4aa26d583c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":412,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:44:42
23738	9d689b9c-b724-490a-9a18-655aadcf9135	9d689b9d-01df-4002-a396-7273b255449f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 08:15:28
3455	9d5105e6-1244-44b4-abdf-09bf8457b1bc	9d5105e6-65d9-4929-be3e-6f84fcbcbac1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 14:52:48
23739	9d689b9c-f841-4158-bd29-ee6a08f1f562	9d689b9d-01df-4002-a396-7273b255449f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 68\\n                        ","time":"149.72","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"7d9994d55cb8dde82ff4185920c79043","hostname":"EderCortes"}	2024-11-04 08:15:29
3456	9d5105e6-58f2-46f2-86e6-3aad2459d4ac	9d5105e6-65d9-4929-be3e-6f84fcbcbac1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"127.59","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 14:52:48
3457	9d5105e6-59dc-4c98-b96e-1b5f11332111	9d5105e6-65d9-4929-be3e-6f84fcbcbac1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 14:52:48
3458	9d5105e6-632c-4243-bd89-76550ca0a86d	9d5105e6-65d9-4929-be3e-6f84fcbcbac1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 14:52:48
4812	9d513543-23d4-458f-a89e-6eb44325f967	9d513543-2742-421e-b330-64e45eef8289	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":150,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:05:15
23740	9d689b9c-fc22-4be3-92bf-c6f64f740605	9d689b9d-01df-4002-a396-7273b255449f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '68' order by \\"item_loans\\".\\"id\\" asc","time":"2.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:15:29
23741	9d689b9c-fc59-4f7c-827c-35f4f6d4f906	9d689b9d-01df-4002-a396-7273b255449f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 08:15:29
23742	9d689b9d-006a-4df8-a6e4-fc6d4e6e0f6e	9d689b9d-01df-4002-a396-7273b255449f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 08:15:29
28647	9d690660-fa2b-4e61-a111-6380d0f1ce8c	9d690661-6960-4f1d-9bec-86057f3cadf5	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 13:14:01
28648	9d690661-44d6-44cc-ae23-a41a9968744b	9d690661-6960-4f1d-9bec-86057f3cadf5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 367 limit 1","time":"4.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 13:14:01
28649	9d690661-455a-4629-b2cb-386c238edd09	9d690661-6960-4f1d-9bec-86057f3cadf5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 13:14:01
3773	9d511875-52a2-40e9-8227-98713ca287e1	9d511875-84d5-4f3c-9522-b044f2ba3311	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 15:44:42
3774	9d511875-7b72-4e93-855a-965563528bea	9d511875-84d5-4f3c-9522-b044f2ba3311	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"63.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:44:42
3775	9d511875-7be4-46e2-82c6-2a2bce0f4ab0	9d511875-84d5-4f3c-9522-b044f2ba3311	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 15:44:42
3776	9d511875-8319-4ad1-a9c5-559d66f4f210	9d511875-84d5-4f3c-9522-b044f2ba3311	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 15:44:42
3777	9d511875-838b-469e-ac46-1884f8cecbdc	9d511875-84d5-4f3c-9522-b044f2ba3311	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":452,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:44:42
4813	9d513543-de1f-4572-9563-a60cbd33d782	9d513543-fbd6-4330-97dd-01411236dc26	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 17:05:15
4814	9d513543-f708-444f-a3f3-2f9a4d1603d6	9d513543-fbd6-4330-97dd-01411236dc26	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"46.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":46,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 17:05:15
4815	9d513543-fa93-4942-90aa-c2674a1102bd	9d513543-fbd6-4330-97dd-01411236dc26	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 17:05:15
4816	9d513543-fad6-4b18-90fb-cc00a12db228	9d513543-fbd6-4330-97dd-01411236dc26	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:05:15
26127	9d68cdbc-6da5-4875-818d-a64e85dba04a	9d68cdbc-76ea-4087-a840-01015116e512	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"41.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 10:35:38
23743	9d689b9d-00bb-4337-9917-6be7ce545892	9d689b9d-01df-4002-a396-7273b255449f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/68","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":68,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":10000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"7000000","loans_pago_interes":"1750000"},"items":[{"id":227,"loans_codigo":68,"itemloans_cuota":"1","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":228,"loans_codigo":68,"itemloans_cuota":"2","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:14:40.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":229,"loans_codigo":68,"itemloans_cuota":"3","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:14:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":230,"loans_codigo":68,"itemloans_cuota":"4","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:14:49.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":231,"loans_codigo":68,"itemloans_cuota":"5","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:15:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":232,"loans_codigo":68,"itemloans_cuota":"6","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:15:25.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":233,"loans_codigo":68,"itemloans_cuota":"7","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:15:28.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":234,"loans_codigo":68,"itemloans_cuota":"8","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":235,"loans_codigo":68,"itemloans_cuota":"9","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":236,"loans_codigo":68,"itemloans_cuota":"10","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:15:29
3778	9d511875-d5e1-4831-bf42-f26334bd9ecc	9d511876-2186-4b72-9478-e43d9ae01df7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 15:44:42
3779	9d511876-187c-41c1-ac31-1d5f1244f03e	9d511876-2186-4b72-9478-e43d9ae01df7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"131.56","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:44:43
3780	9d511876-18f0-4f64-bacc-0aac0e8745a0	9d511876-2186-4b72-9478-e43d9ae01df7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 15:44:43
3781	9d511876-1f07-4528-9447-dbc05f0e4ef7	9d511876-2186-4b72-9478-e43d9ae01df7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 15:44:43
3782	9d511876-1fd3-43c1-a2ae-d5bed60fa679	9d511876-2186-4b72-9478-e43d9ae01df7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:44:43
4817	9d513545-f54a-4d8e-9871-4acfcf564546	9d513546-3dd7-4470-ba23-3e985216d76b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 17:05:16
4818	9d513546-3893-420a-a404-5890db207e25	9d513546-3dd7-4470-ba23-3e985216d76b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null","time":"147.46","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":28,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-23 17:05:17
4819	9d513546-38e6-47cf-aa0e-f4ef6064123f	9d513546-3dd7-4470-ba23-3e985216d76b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:05:17
4820	9d513546-3c80-40ca-88a1-82946f60c5ee	9d513546-3dd7-4470-ba23-3e985216d76b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 17:05:17
4821	9d513546-3cca-453f-85f6-c1003fabc359	9d513546-3dd7-4470-ba23-3e985216d76b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null}]},"duration":366,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:05:17
9346	9d52f729-010c-44b1-9fec-41286986fa6b	9d52f729-34b3-48ef-8c7e-dadc6f20b3a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 14:03:15
5125	9d51367a-1f7c-4145-99ff-dc7801068995	9d51367a-6b44-4781-b5f5-f22ca2b3c7b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 17:08:38
5126	9d51367a-6646-4ded-b0a0-ce45f4c42f4f	9d51367a-6b44-4781-b5f5-f22ca2b3c7b9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"158.15","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:08:39
5127	9d51367a-6690-4d68-a9bf-cefd974c6b95	9d51367a-6b44-4781-b5f5-f22ca2b3c7b9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:08:39
5128	9d51367a-6a25-464d-8fdb-73c38a119c46	9d51367a-6b44-4781-b5f5-f22ca2b3c7b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 17:08:39
5129	9d51367a-6a67-4c2b-bea9-aacac5950856	9d51367a-6b44-4781-b5f5-f22ca2b3c7b9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":384,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:39
12763	9d5ceccc-944b-4aac-ac97-04afc16529c4	9d5ceccc-b5d1-4973-ba87-f6b83383e7d4	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 12:52:33
24149	9d68a8e4-e7e3-4af7-9b97-88fbaf7abf11	9d68a8e5-313f-45ff-9057-9a05dc704c06	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 08:52:37
9347	9d52f729-2ce5-4e5a-b154-bdbffd5968c5	9d52f729-34b3-48ef-8c7e-dadc6f20b3a1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"63.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 14:03:15
9348	9d52f729-2d4c-4f49-9802-788b34c7f2ee	9d52f729-34b3-48ef-8c7e-dadc6f20b3a1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 14:03:15
9349	9d52f729-32c8-4b3a-b6f2-4d5332da292d	9d52f729-34b3-48ef-8c7e-dadc6f20b3a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 14:03:15
9350	9d52f729-333d-4387-a28d-a0380ad21b1d	9d52f729-34b3-48ef-8c7e-dadc6f20b3a1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":585,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:03:15
5130	9d51367a-ad6e-47ba-a90a-14a2cd2017c1	9d51367a-ce8f-4aa3-8ad5-c110a25f948e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 17:08:39
5131	9d51367a-c91e-429d-ac64-05783db6078f	9d51367a-ce8f-4aa3-8ad5-c110a25f948e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:08:39
5132	9d51367a-c979-4295-8797-f06b68408633	9d51367a-ce8f-4aa3-8ad5-c110a25f948e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:08:39
5133	9d51367a-ccc0-4e4a-81a1-3f110d7ca65c	9d51367a-ce8f-4aa3-8ad5-c110a25f948e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-23 17:08:39
5134	9d51367a-cd4d-401d-8622-a1fe14e84bcd	9d51367a-ce8f-4aa3-8ad5-c110a25f948e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:39
23744	9d689ba0-5038-42df-a4cf-dc73a035120c	9d689ba0-5358-4ae7-bfa0-266c6ffb3408	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":132,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:15:31
12764	9d5ceccc-afda-45e2-9475-a23e7b114019	9d5ceccc-b5d1-4973-ba87-f6b83383e7d4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ed%' or \\"users\\".\\"user_document\\"::text like '%Ed%') order by \\"users\\".\\"user_document\\" asc","time":"40.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:52:33
12765	9d5ceccc-b43f-4f3a-b684-89f00b642a9e	9d5ceccc-b5d1-4973-ba87-f6b83383e7d4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:52:33
12766	9d5ceccc-b4a1-42a8-becf-64d578a62159	9d5ceccc-b5d1-4973-ba87-f6b83383e7d4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ed"},"session":[],"response_status":200,"response":{"data":[]},"duration":269,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:33
25337	9d68c134-f828-4f1c-8845-e29a0aff27fa	9d68c134-f945-4462-bd01-f1f96e2d5fc7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":353,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:00:36
26128	9d68cdbc-7170-4b89-affa-7fa4f9f713cf	9d68cdbc-76ea-4087-a840-01015116e512	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:35:38
6236	9d526316-2a1b-40cd-b000-40e744357cd6	9d526316-7fe2-4400-bb58-701f7efcdda8	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 07:09:12
6237	9d526316-7d31-4c1c-b595-2e178e9152fe	9d526316-7fe2-4400-bb58-701f7efcdda8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 07:09:12
6238	9d526316-7e38-41a1-9f17-7b7f81ed68e4	9d526316-7fe2-4400-bb58-701f7efcdda8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":463,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:09:12
23745	9d689ba0-bf96-44e5-85a7-d78abe7de326	9d689ba0-e59b-4bfe-9ef5-5d0173ea8d5b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 08:15:31
23746	9d689ba0-d91a-4489-8576-4a42811ac70b	9d689ba0-e59b-4bfe-9ef5-5d0173ea8d5b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 234 limit 1","time":"3.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 08:15:31
26129	9d68cdbc-71a7-45c4-a2ef-bc1e1953c633	9d68cdbc-76ea-4087-a840-01015116e512	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 10:35:38
26130	9d68cdbc-757d-4365-9ec2-e580cb8a0898	9d68cdbc-76ea-4087-a840-01015116e512	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:35:38
23747	9d689ba0-d987-4538-9b0c-9654127c4c54	9d689ba0-e59b-4bfe-9ef5-5d0173ea8d5b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 08:15:31
23748	9d689ba0-db8e-42b6-bd0e-9c742d5d5854	9d689ba0-e59b-4bfe-9ef5-5d0173ea8d5b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 68 limit 1","time":"2.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 08:15:31
23749	9d689ba0-dbc9-42f6-be03-80f8b888f45e	9d689ba0-e59b-4bfe-9ef5-5d0173ea8d5b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 08:15:31
23750	9d689ba0-df8a-4d9c-98a0-265598e8b35f	9d689ba0-e59b-4bfe-9ef5-5d0173ea8d5b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '250000', \\"itemloans_cuota_cancelada\\" = '1000000', \\"updated_at\\" = '2024-11-04 08:15:31' where \\"id\\" = 234","time":"7.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":400,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 08:15:31
23751	9d689ba0-dff6-4966-b47c-402816673145	9d689ba0-e59b-4bfe-9ef5-5d0173ea8d5b	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:234","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 08:15:31","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},"hostname":"EderCortes"}	2024-11-04 08:15:31
23752	9d689ba0-e0bb-4600-ae24-1a7baec8f7ab	9d689ba0-e59b-4bfe-9ef5-5d0173ea8d5b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 2000000, \\"loans_pago_prestado\\" = 8000000, \\"updated_at\\" = '2024-11-04 08:15:31' where \\"id\\" = 68","time":"0.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":408,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 08:15:31
23753	9d689ba0-e0f5-489d-943b-fab06731550e	9d689ba0-e59b-4bfe-9ef5-5d0173ea8d5b	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:68","changes":{"updated_at":"2024-11-04 08:15:31","loans_pago_interes":2000000,"loans_pago_prestado":8000000},"hostname":"EderCortes"}	2024-11-04 08:15:31
23754	9d689ba0-e41c-48e7-9b17-149e47b9998b	9d689ba0-e59b-4bfe-9ef5-5d0173ea8d5b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 08:15:31
28650	9d690661-47de-483d-b6a3-0a04aabfed20	9d690661-6960-4f1d-9bec-86057f3cadf5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 89 limit 1","time":"2.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 13:14:01
28651	9d690661-4819-4768-a791-4caab02a8038	9d690661-6960-4f1d-9bec-86057f3cadf5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 13:14:01
28652	9d690661-5754-4d0f-8c14-3b73fb4d9f24	9d690661-6960-4f1d-9bec-86057f3cadf5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '43000', \\"itemloans_cuota_cancelada\\" = '172000', \\"updated_at\\" = '2024-11-04 13:14:01' where \\"id\\" = 367","time":"2.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":400,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 13:14:01
26131	9d68cdbc-75cf-4bc8-bc91-688a39e41c09	9d68cdbc-76ea-4087-a840-01015116e512	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":352,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":353,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":354,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":355,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":495,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:35:38
4270	9d5129d7-9377-4bd1-8cbb-7debeb3c1790	9d5129d7-cd6b-402f-bc54-7fcc8145c1fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 16:33:19
4271	9d5129d7-ca2f-4403-892b-e44a55d668af	9d5129d7-cd6b-402f-bc54-7fcc8145c1fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 16:33:19
4272	9d5129d7-cb9e-4e20-8223-a35448b2700d	9d5129d7-cd6b-402f-bc54-7fcc8145c1fd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":581,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:33:19
25338	9d68c1f4-a198-4053-8f0c-e51d7021ba2b	9d68c1f4-c768-4512-a409-fd70f3a56f64	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 10:02:41
23755	9d689ba0-e47f-4ffc-88c1-708ee5b85028	9d689ba0-e59b-4bfe-9ef5-5d0173ea8d5b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"181","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000","id":234,"loans_codigo":68,"itemloans_cuota":"8","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":265,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:15:31
28653	9d690661-5f8d-4063-ad1a-3dd8c925215f	9d690661-6960-4f1d-9bec-86057f3cadf5	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:367","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 13:14:01","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},"hostname":"EderCortes"}	2024-11-04 13:14:01
25339	9d68c1f4-bd3d-428d-8574-1c7b0f2ef7e7	9d68c1f4-c768-4512-a409-fd70f3a56f64	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"46.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 10:02:42
9508	9d531cd9-0b8d-4085-83fa-4f8bb0c6f443	9d531cd9-5b4b-48aa-a188-438488bfad23	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 15:48:38
25340	9d68c1f4-c0f7-4e14-b48f-07ac8b4c43eb	9d68c1f4-c768-4512-a409-fd70f3a56f64	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:02:42
25341	9d68c1f4-c132-4efe-a923-ee144caac86a	9d68c1f4-c768-4512-a409-fd70f3a56f64	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 10:02:42
25342	9d68c1f4-c5c6-4488-a361-bcb18896ab9f	9d68c1f4-c768-4512-a409-fd70f3a56f64	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:02:42
28654	9d690661-605f-4eec-9912-769cf7aecb5e	9d690661-6960-4f1d-9bec-86057f3cadf5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_estado\\" = 'En curso', \\"loans_pago_interes\\" = 146000, \\"loans_pago_prestado\\" = 584000, \\"updated_at\\" = '2024-11-04 13:14:01' where \\"id\\" = 89","time":"1.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":408,"hash":"acfe32aea56c9ca6bdbb917f944a78d1","hostname":"EderCortes"}	2024-11-04 13:14:01
28655	9d690661-60a1-4446-b66f-525be0443c57	9d690661-6960-4f1d-9bec-86057f3cadf5	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:89","changes":{"loans_estado":"En curso","updated_at":"2024-11-04 13:14:01","loans_pago_interes":146000,"loans_pago_prestado":584000},"hostname":"EderCortes"}	2024-11-04 13:14:01
28656	9d690661-6735-414f-b87c-5d1003d3a06d	9d690661-6960-4f1d-9bec-86057f3cadf5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 13:14:01
4273	9d5129d8-5e23-4fa7-8d03-ea97b5b989ba	9d5129d8-921f-415c-9877-45e6bee83827	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 16:33:19
4274	9d5129d8-8993-4b2a-a78b-94a31cde98e5	9d5129d8-921f-415c-9877-45e6bee83827	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"69.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 16:33:19
4275	9d5129d8-8a15-430c-a45a-d2fd2bbd0595	9d5129d8-921f-415c-9877-45e6bee83827	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 16:33:19
4276	9d5129d8-9067-46b4-aa0e-4d5c861ff428	9d5129d8-921f-415c-9877-45e6bee83827	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 16:33:19
4277	9d5129d8-90e6-4de9-a4b7-2edc44dc6c8b	9d5129d8-921f-415c-9877-45e6bee83827	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":458,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:33:19
9509	9d531cd9-568e-4424-821c-a5b42bcc151b	9d531cd9-5b4b-48aa-a188-438488bfad23	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 15:48:38
6274	9d526409-4795-4a73-8e9e-725f6d843e81	9d526409-62ff-4d16-8331-016cdfe66584	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 07:11:52
6275	9d526409-613a-4616-8e4a-f816bc0a2dc3	9d526409-62ff-4d16-8331-016cdfe66584	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 07:11:52
6276	9d526409-61e7-45ea-9a5b-94e200d5804f	9d526409-62ff-4d16-8331-016cdfe66584	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abfrom\\u00bb\\nLINE 14:     from loans l\\n             ^ (Connection: pgsql, SQL: \\n    select l.id,\\n        l.loans_documento,\\n        l.loans_nombre,\\n        l.loans_apellido_uno,\\n        l.loans_fecha,\\n        l.loans_valor_prestado,\\n        l.loans_cuotas,\\n        l.loans_estado,\\n        l.loans_intereses,\\n        ucl.name as cliente,\\n        uco.name as cobrador,\\n        ure.name as recomendador,\\n    from loans l\\n    join users ucl on l.user_customer = ucl.id\\n    join users uco on l.user_cobrador = uco.id\\n    left join users ure on l.user_recomendacion = ure.id\\n)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":277,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:11:52
9510	9d531cd9-58ab-47a5-9982-3f15c085512b	9d531cd9-5b4b-48aa-a188-438488bfad23	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":921,"memory":22,"hostname":"EderCortes"}	2024-10-24 15:48:38
25343	9d68c1f4-c61d-43f7-a342-3986e7a198cc	9d68c1f4-c768-4512-a409-fd70f3a56f64	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":352,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":353,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":354,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":355,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":436,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:02:42
23756	9d689ba1-2641-4920-8d3d-d92eeeb67844	9d689ba1-494f-4f1a-a1cc-655ca7ae86ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 08:15:31
12767	9d5ceccd-032a-439e-a279-6aba58ee39e9	9d5ceccd-064c-4d56-8a89-6da78879e4f4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":185,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:52:34
26132	9d68ce06-0a8c-4aac-8c70-33a0c63cae29	9d68ce06-0e05-4a2c-b53d-c7d1ef539a53	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":153,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:36:26
30169	9d69348e-0d7e-446c-8262-cde578b5102d	9d69348e-1111-40d3-8f05-63ef7b38b6d9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"PUT","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":181,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:23:08
4278	9d5129d9-0979-4a57-8674-dcfa465b5833	9d5129d9-3e94-4226-b9a5-fa561526d409	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 16:33:20
4279	9d5129d9-33f2-41a4-be32-97a2ea4f9c4f	9d5129d9-3e94-4226-b9a5-fa561526d409	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"71.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:33:20
4280	9d5129d9-347a-4b41-925d-697a37545eae	9d5129d9-3e94-4226-b9a5-fa561526d409	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 16:33:20
4281	9d5129d9-3c20-4ff0-8903-8f6904a42534	9d5129d9-3e94-4226-b9a5-fa561526d409	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 16:33:20
4282	9d5129d9-3ca7-4da7-8d8c-b98de7c02450	9d5129d9-3e94-4226-b9a5-fa561526d409	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":415,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:33:20
6277	9d52640b-5144-47d7-84cc-f7d051c82bd6	9d52640b-830a-41a9-8ddb-fa32553583e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 07:11:53
6278	9d52640b-7658-462c-b8d8-2cea2e89bc6d	9d52640b-830a-41a9-8ddb-fa32553583e5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"57.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 07:11:53
6279	9d52640b-76dd-4327-b8e8-fa6345f5f46f	9d52640b-830a-41a9-8ddb-fa32553583e5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 07:11:53
6280	9d52640b-8022-477d-9bed-73ee50c6317f	9d52640b-830a-41a9-8ddb-fa32553583e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 07:11:53
6281	9d52640b-80b6-4363-9fea-48b7bda608c0	9d52640b-830a-41a9-8ddb-fa32553583e5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":420,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:11:53
9511	9d531cda-49a1-422c-9396-6ac3e4f18fc5	9d531cda-ba40-4755-9d4e-e629bbe236d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 15:48:39
9512	9d531cda-b001-4fe4-90ed-6db1da013f44	9d531cda-ba40-4755-9d4e-e629bbe236d7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"98.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 15:48:39
9513	9d531cda-b0a7-407d-8982-ba30c8d54e46	9d531cda-ba40-4755-9d4e-e629bbe236d7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 15:48:39
9514	9d531cda-b86c-4b5a-a52e-fb2166ad38f8	9d531cda-ba40-4755-9d4e-e629bbe236d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 15:48:39
9515	9d531cda-b8eb-4586-b4dd-b79e4d5df40e	9d531cda-ba40-4755-9d4e-e629bbe236d7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":847,"memory":22,"hostname":"EderCortes"}	2024-10-24 15:48:39
12768	9d5ceccd-5481-4ac5-80eb-ff2f429aabeb	9d5ceccd-575e-47da-bf3a-ca5466c0be6e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":138,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:52:34
25344	9d68c1fc-45d1-4b4f-aff9-bdf33d1066d5	9d68c1fc-8e88-47db-8c21-3ad9b101cf10	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:02:46
4283	9d5129d9-a9a8-4043-a35e-eed1770ca7ce	9d5129d9-f55a-4424-a3c5-39459dc8a2ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 16:33:20
4284	9d5129d9-f03d-4779-a906-2274f0b80b67	9d5129d9-f55a-4424-a3c5-39459dc8a2ce	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"155.53","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:33:20
4285	9d5129d9-f09e-4cc4-81fb-a5cdaac04b34	9d5129d9-f55a-4424-a3c5-39459dc8a2ce	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 16:33:20
4286	9d5129d9-f420-4072-9849-c602dd24e225	9d5129d9-f55a-4424-a3c5-39459dc8a2ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-23 16:33:20
4287	9d5129d9-f489-47fa-afaf-e5a93c743384	9d5129d9-f55a-4424-a3c5-39459dc8a2ce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":445,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:33:20
9516	9d531cdb-5a9c-4e7b-bf7f-46cee649ce57	9d531cdb-8f2e-4d9f-81e6-93adcc14d87c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 15:48:39
9517	9d531cdb-8497-4660-b9d3-38a81044c7f1	9d531cdb-8f2e-4d9f-81e6-93adcc14d87c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"61.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 15:48:39
9518	9d531cdb-8534-4457-b8be-d9736ba3a099	9d531cdb-8f2e-4d9f-81e6-93adcc14d87c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 15:48:39
9519	9d531cdb-8d3c-4feb-8f3e-1b2026c3a93c	9d531cdb-8f2e-4d9f-81e6-93adcc14d87c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 15:48:39
9520	9d531cdb-8dc8-4592-8b88-a69c912df69e	9d531cdb-8f2e-4d9f-81e6-93adcc14d87c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":521,"memory":22,"hostname":"EderCortes"}	2024-10-24 15:48:39
26133	9d68ce06-bcf1-45d7-bfb9-feb5cc6c7478	9d68ce06-e4ad-4249-863f-2f6cd615927e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:36:27
12769	9d5ceccd-b0d4-4c88-88ec-c37b15728531	9d5ceccd-ccc9-4cda-84ef-eda5470ee724	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:52:34
12770	9d5ceccd-c812-4dd6-a1e0-b390dfe03fba	9d5ceccd-ccc9-4cda-84ef-eda5470ee724	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ede%' or \\"users\\".\\"user_document\\"::text like '%Ede%') order by \\"users\\".\\"user_document\\" asc","time":"42.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:52:34
12771	9d5ceccd-cb50-42b4-a0fb-f3db9f0b8415	9d5ceccd-ccc9-4cda-84ef-eda5470ee724	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:52:34
12772	9d5ceccd-cbb1-4b59-a738-402967bb452c	9d5ceccd-ccc9-4cda-84ef-eda5470ee724	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ede"},"session":[],"response_status":200,"response":{"data":[]},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:34
26134	9d68ce06-d782-41c7-9287-3e25afda8a77	9d68ce06-e4ad-4249-863f-2f6cd615927e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 89 limit 1","time":"2.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":498,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 10:36:27
4288	9d5129db-b32a-4e24-be63-d4ea0e20a404	9d5129db-fbd3-4ef7-9a39-4997adf3c78b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-23 16:33:21
4289	9d5129db-f644-4d7f-a755-0b7fa9e2dc3b	9d5129db-fbd3-4ef7-9a39-4997adf3c78b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"149.46","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 16:33:21
4290	9d5129db-f690-42cb-82e3-52b8226d7f0b	9d5129db-fbd3-4ef7-9a39-4997adf3c78b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 16:33:21
4291	9d5129db-fa5c-44c2-b188-fcef785d2e49	9d5129db-fbd3-4ef7-9a39-4997adf3c78b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-23 16:33:21
4292	9d5129db-fab7-4fd0-8340-546bb3af90dc	9d5129db-fbd3-4ef7-9a39-4997adf3c78b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":418,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:33:21
9521	9d531cdc-2209-4757-91e4-7a06ce85eeec	9d531cdc-565d-4d7d-91c9-7d08e8b4b91f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 15:48:40
9522	9d531cdc-493b-4113-90e8-71c48978105c	9d531cdc-565d-4d7d-91c9-7d08e8b4b91f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"60.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-24 15:48:40
9523	9d531cdc-49c9-4953-b024-2c258b31845e	9d531cdc-565d-4d7d-91c9-7d08e8b4b91f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 15:48:40
9524	9d531cdc-4ce3-46f9-94cc-0353350f3297	9d531cdc-565d-4d7d-91c9-7d08e8b4b91f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"3.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 15:48:40
9525	9d531cdc-4d31-4395-a51b-c2e71c953b0d	9d531cdc-565d-4d7d-91c9-7d08e8b4b91f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 15:48:40
9526	9d531cdc-5471-421e-8411-4b45027e2a65	9d531cdc-565d-4d7d-91c9-7d08e8b4b91f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 15:48:40
9527	9d531cdc-54f6-4565-9b0a-8ff4ff56b0bd	9d531cdc-565d-4d7d-91c9-7d08e8b4b91f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":488,"memory":22,"hostname":"EderCortes"}	2024-10-24 15:48:40
26135	9d68ce06-d7c9-4e1c-87ea-b24329156422	9d68ce06-e4ad-4249-863f-2f6cd615927e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":2,"hostname":"EderCortes"}	2024-11-04 10:36:27
12773	9d5cecce-1116-4fd9-ae4c-80d5bb62898b	9d5cecce-2dd1-478d-b47d-b0cd08ae0d19	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:52:34
12774	9d5cecce-298e-4641-bc6b-f97765f33e01	9d5cecce-2dd1-478d-b47d-b0cd08ae0d19	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%') order by \\"users\\".\\"user_document\\" asc","time":"46.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:52:34
12775	9d5cecce-2c76-4d96-b6ed-8d9d3703f337	9d5cecce-2dd1-478d-b47d-b0cd08ae0d19	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 12:52:34
12776	9d5cecce-2cc8-4903-a623-d62c56b1725b	9d5cecce-2dd1-478d-b47d-b0cd08ae0d19	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[]},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:34
4293	9d5129f3-eb1e-4421-bd3e-9eeddd11c70b	9d5129f3-edf8-4754-9662-fee9e1b402c6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":147,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:33:37
9528	9d531cde-b4f3-4eb1-99db-c86aac49d713	9d531cdf-116d-4cae-a6bc-c235bda45223	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 15:48:42
9529	9d531cdf-0813-4189-a925-f77ba02d7452	9d531cdf-116d-4cae-a6bc-c235bda45223	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"176.74","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 15:48:42
4412	9d512e75-3504-4ac1-ae7a-007fb301d3e3	9d512e75-9f12-477a-bbfe-c485ee06411c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 16:46:13
4413	9d512e75-9ada-4494-af0e-87035099ee97	9d512e75-9f12-477a-bbfe-c485ee06411c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 16:46:13
4414	9d512e75-9cbd-47dd-894d-bb3a4b75ef4e	9d512e75-9f12-477a-bbfe-c485ee06411c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":988,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:46:13
9530	9d531cdf-089f-4e1f-b1e6-c4c718ca4cc2	9d531cdf-116d-4cae-a6bc-c235bda45223	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 15:48:42
9531	9d531cdf-0efb-4cd7-9569-875feb755873	9d531cdf-116d-4cae-a6bc-c235bda45223	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 15:48:42
9532	9d531cdf-0f8f-4e2d-a51e-d0818bdffc71	9d531cdf-116d-4cae-a6bc-c235bda45223	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":625,"memory":22,"hostname":"EderCortes"}	2024-10-24 15:48:42
23757	9d689ba1-3f13-4456-a21b-8abbe9844b9f	9d689ba1-494f-4f1a-a1cc-655ca7ae86ec	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 68\\n                        ","time":"49.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"7d9994d55cb8dde82ff4185920c79043","hostname":"EderCortes"}	2024-11-04 08:15:31
23758	9d689ba1-4329-4fb9-b491-60a1cf86db4c	9d689ba1-494f-4f1a-a1cc-655ca7ae86ec	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '68' order by \\"item_loans\\".\\"id\\" asc","time":"2.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:15:31
23759	9d689ba1-4360-4b77-b17c-87fe378f645d	9d689ba1-494f-4f1a-a1cc-655ca7ae86ec	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 08:15:31
23760	9d689ba1-474f-4091-90b9-1ad0a8876362	9d689ba1-494f-4f1a-a1cc-655ca7ae86ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 08:15:31
25345	9d68c1fc-8a71-4a4f-9578-852fd9473c88	9d68c1fc-8e88-47db-8c21-3ad9b101cf10	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"157.12","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 10:02:47
25346	9d68c1fc-8d08-4426-a7a3-78f14047e27f	9d68c1fc-8e88-47db-8c21-3ad9b101cf10	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:02:47
25347	9d68c1fc-8d6e-441f-b0e1-def419694aac	9d68c1fc-8e88-47db-8c21-3ad9b101cf10	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":521,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:02:47
26903	9d68dd72-2c82-4ac0-bbdc-2bd99aca7a23	9d68dd72-2db7-4c1d-a3d9-2191ae42cd6e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":455,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:19:34
3542	9d5108da-bb65-47f8-9e05-71e1ccee773c	9d5108db-0e08-4275-9250-2fe4c3b7bbbd	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 15:01:04
3543	9d5108db-0c01-41c5-9dcb-b0de8fd43cd7	9d5108db-0e08-4275-9250-2fe4c3b7bbbd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 15:01:04
3544	9d5108db-0cd5-4708-8382-5132ff8433f5	9d5108db-0e08-4275-9250-2fe4c3b7bbbd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":436,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:01:04
26136	9d68ce06-d958-4d85-bb07-ec3812ae9390	9d68ce06-e4ad-4249-863f-2f6cd615927e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select count(*) as aggregate from \\"item_loans\\" where \\"loans_codigo\\" = 89 and \\"itemloans_status\\" = 'Pagada'","time":"2.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":556,"hash":"60bd91eaa209a639fc2e8afc20430a4b","hostname":"EderCortes"}	2024-11-04 10:36:27
23761	9d689ba1-47c8-430a-ac99-fd3564583d9c	9d689ba1-494f-4f1a-a1cc-655ca7ae86ec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/68","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":68,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":10000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"8000000","loans_pago_interes":"2000000"},"items":[{"id":227,"loans_codigo":68,"itemloans_cuota":"1","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":228,"loans_codigo":68,"itemloans_cuota":"2","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:14:40.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":229,"loans_codigo":68,"itemloans_cuota":"3","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:14:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":230,"loans_codigo":68,"itemloans_cuota":"4","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:14:49.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":231,"loans_codigo":68,"itemloans_cuota":"5","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:15:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":232,"loans_codigo":68,"itemloans_cuota":"6","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:15:25.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":233,"loans_codigo":68,"itemloans_cuota":"7","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:15:28.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":234,"loans_codigo":68,"itemloans_cuota":"8","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:15:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":235,"loans_codigo":68,"itemloans_cuota":"9","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":236,"loans_codigo":68,"itemloans_cuota":"10","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:15:31
26137	9d68ce06-da01-43a6-9adb-2bae83058fae	9d68ce06-e4ad-4249-863f-2f6cd615927e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 60000, \\"loans_pago_prestado\\" = 240000, \\"updated_at\\" = '2024-11-04 10:36:27' where \\"id\\" = 89","time":"0.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":593,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 10:36:27
26138	9d68ce06-da80-4d3a-ae70-272ad320b222	9d68ce06-e4ad-4249-863f-2f6cd615927e	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:89","changes":{"updated_at":"2024-11-04 10:36:27","loans_pago_interes":60000,"loans_pago_prestado":240000},"hostname":"EderCortes"}	2024-11-04 10:36:27
26139	9d68ce06-dafc-4d40-8b66-42eeeda2d480	9d68ce06-e4ad-4249-863f-2f6cd615927e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 89 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"0.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":600,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 10:36:27
26140	9d68ce06-db25-4558-953a-aea429c1dc76	9d68ce06-e4ad-4249-863f-2f6cd615927e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 10:36:27
3545	9d5108db-6c9f-4f52-a25c-d9cd1e91f67a	9d5108db-8f93-4307-846f-d077482add1d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 15:01:05
3546	9d5108db-8909-4109-bf81-d9d0d16126a3	9d5108db-8f93-4307-846f-d077482add1d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:01:05
3547	9d5108db-8956-4066-8799-4a21f5da0bb8	9d5108db-8f93-4307-846f-d077482add1d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 15:01:05
3548	9d5108db-8e69-421b-90a4-159da33a1fb5	9d5108db-8f93-4307-846f-d077482add1d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 15:01:05
3549	9d5108db-8eae-4019-ba78-31a2db9149e0	9d5108db-8f93-4307-846f-d077482add1d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":303,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:01:05
4294	9d5129f4-a7c8-4431-85ea-33e62d942669	9d5129f4-f582-4d79-a6c2-8058f78e7d77	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 16:33:38
4295	9d5129f4-f076-4f9a-b0cd-107e9a9b88c8	9d5129f4-f582-4d79-a6c2-8058f78e7d77	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"159.25","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":46,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 16:33:38
4296	9d5129f4-f414-4d0f-a07b-e4f630434faa	9d5129f4-f582-4d79-a6c2-8058f78e7d77	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 16:33:38
4297	9d5129f4-f464-4e76-8e1c-be428de3d41d	9d5129f4-f582-4d79-a6c2-8058f78e7d77	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":355,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:33:38
4415	9d512e76-1fae-4edc-8135-c3fcb98e9ef8	9d512e76-6c21-4532-b49e-5e1f13e65b03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 16:46:14
4416	9d512e76-64a8-44f5-b7ee-d93df543ccec	9d512e76-6c21-4532-b49e-5e1f13e65b03	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"152.98","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:46:14
4417	9d512e76-651d-4932-baa1-929b7af0e5d9	9d512e76-6c21-4532-b49e-5e1f13e65b03	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 16:46:14
4418	9d512e76-6a36-465a-a94e-6026753b1f62	9d512e76-6c21-4532-b49e-5e1f13e65b03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 16:46:14
4419	9d512e76-6aba-4839-b9c8-7316b106f96e	9d512e76-6c21-4532-b49e-5e1f13e65b03	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":479,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:46:14
12777	9d5cecd3-1406-40cd-a7d9-8693e4443888	9d5cecd3-16de-4739-89db-8e27121b55ad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":125,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:52:38
26141	9d68ce06-db89-41d5-a978-5229157374a8	9d68ce06-e4ad-4249-863f-2f6cd615927e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Abono', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = 60000, \\"itemloans_cuota_cancelada\\" = 240000, \\"updated_at\\" = '2024-11-04 10:36:27' where \\"id\\" = 351","time":"0.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":607,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 10:36:27
3550	9d5108db-dd2d-4cae-ab06-fb31bb4c56ff	9d5108dc-2734-4b95-8705-d6fef3b9ed1c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 15:01:05
3551	9d5108dc-216e-4dc4-99a6-6334e633119d	9d5108dc-2734-4b95-8705-d6fef3b9ed1c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"149.80","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:01:05
3552	9d5108dc-21c1-4511-9b4e-5d135f1b6f22	9d5108dc-2734-4b95-8705-d6fef3b9ed1c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 15:01:05
3553	9d5108dc-255c-4ed9-80f6-773ad7d8cb1c	9d5108dc-2734-4b95-8705-d6fef3b9ed1c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 15:01:05
3554	9d5108dc-25d2-4786-8c1b-d117c7e13954	9d5108dc-2734-4b95-8705-d6fef3b9ed1c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":365,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:01:05
4298	9d5129f8-32df-4652-b112-d4d724a591a0	9d5129f8-361d-46b1-9d90-aaf6a2af4738	86bf4992bfe7dd22b0226e11aca82b87	t	exception	{"class":"ArgumentCountError","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":443,"message":"Too few arguments to function Illuminate\\\\Database\\\\Eloquent\\\\Builder::find(), 0 passed in C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php on line 28 and at least 1 expected","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":28},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"434":"    }","435":"","436":"    \\/**","437":"     * Find a model by its primary key.","438":"     *","439":"     * @param  mixed  $id","440":"     * @param  array|string  $columns","441":"     * @return \\\\Illuminate\\\\Database\\\\Eloquent\\\\Model|\\\\Illuminate\\\\Database\\\\Eloquent\\\\Collection|static[]|static|null","442":"     *\\/","443":"    public function find($id, $columns = ['*'])","444":"    {","445":"        if (is_array($id) || $id instanceof Arrayable) {","446":"            return $this->findMany($id, $columns);","447":"        }","448":"","449":"        return $this->whereKey($id)->first($columns);","450":"    }","451":"","452":"    \\/**","453":"     * Find multiple models by their primary keys."},"hostname":"EderCortes","occurrences":1}	2024-10-23 16:33:40
4299	9d5129f8-257f-45af-9671-45118bf94b60	9d5129f8-361d-46b1-9d90-aaf6a2af4738	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 16:33:40
4300	9d5129f8-3431-4536-a469-7df2eb6ca815	9d5129f8-361d-46b1-9d90-aaf6a2af4738	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 16:33:40
4301	9d5129f8-34cc-4e20-a50d-cb6db3bc7c98	9d5129f8-361d-46b1-9d90-aaf6a2af4738	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"Too few arguments to function Illuminate\\\\Database\\\\Eloquent\\\\Builder::find(), 0 passed in C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php on line 28 and at least 1 expected","exception":"ArgumentCountError","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":443,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":28,"function":"find","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserCustomer","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:33:40
4420	9d512e76-c0fd-450e-a0a8-82bd03e0e323	9d512e76-e23f-4ed2-8b39-a10709d9d3ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 16:46:14
4421	9d512e76-dcb1-4329-9317-6186de6d6ae2	9d512e76-e23f-4ed2-8b39-a10709d9d3ef	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:46:14
4422	9d512e76-dd26-434f-b17f-f75806edc06c	9d512e76-e23f-4ed2-8b39-a10709d9d3ef	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 16:46:14
4423	9d512e76-e0ef-4c64-8bed-34f04f99f550	9d512e76-e23f-4ed2-8b39-a10709d9d3ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 16:46:14
26142	9d68ce06-dbb5-49f0-a808-f6a4891fda3d	9d68ce06-e4ad-4249-863f-2f6cd615927e	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:351","changes":{"itemloans_status":"Abono","updated_at":"2024-11-04 10:36:27","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":60000,"itemloans_cuota_cancelada":240000},"hostname":"EderCortes"}	2024-11-04 10:36:27
4424	9d512e76-e142-4870-940b-2dc149e4e390	9d512e76-e23f-4ed2-8b39-a10709d9d3ef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":282,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:46:14
23762	9d689ba5-552b-4511-a8de-8dae55705c93	9d689ba5-585d-4633-b108-6b1c43a36d88	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":150,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:15:34
6321	9d526477-28ff-41f2-ae96-b863512ccdd4	9d526477-7899-45ad-9fb4-3f95b0a60a6b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 07:13:04
6322	9d526477-761d-4d66-a76a-03bef0a53d79	9d526477-7899-45ad-9fb4-3f95b0a60a6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 07:13:04
6323	9d526477-775a-4153-bcc3-49f9d80acbb8	9d526477-7899-45ad-9fb4-3f95b0a60a6b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":410,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:13:04
26143	9d68ce06-dc25-4b86-979a-961f259693ea	9d68ce06-e4ad-4249-863f-2f6cd615927e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"delete from \\"item_loans\\" where \\"loans_codigo\\" = 89 and \\"itemloans_status\\" = 'Pendiente'","time":"0.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":614,"hash":"89bf3c496a8b0746ff5d1219b8dc29e3","hostname":"EderCortes"}	2024-11-04 10:36:27
26144	9d68ce06-dc90-48e5-9bb6-e019ba3ec407	9d68ce06-e4ad-4249-863f-2f6cd615927e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 89 limit 1","time":"0.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":617,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 10:36:27
26145	9d68ce06-dd8b-4561-a097-27e13bfec3d2	9d68ce06-e4ad-4249-863f-2f6cd615927e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (89, 1, 172000, 43000, 'Pendiente', 'Se realiza abono', '12-11-2024', 12, 0, 0, '2024-11-04 10:36:27', '2024-11-04 10:36:27')","time":"1.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":668,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 10:36:27
26146	9d68ce06-ddb2-4353-8910-e93e40740888	9d68ce06-e4ad-4249-863f-2f6cd615927e	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 10:36:27
26147	9d68ce06-de13-4f9d-b2da-ab065cf0c4f9	9d68ce06-e4ad-4249-863f-2f6cd615927e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (89, 2, 172000, 43000, 'Pendiente', 'Se realiza abono', '20-11-2024', 12, 0, 0, '2024-11-04 10:36:27', '2024-11-04 10:36:27')","time":"0.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":668,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 10:36:27
26148	9d68ce06-de33-4597-bbc9-b0af8370841c	9d68ce06-e4ad-4249-863f-2f6cd615927e	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 10:36:27
26149	9d68ce06-deb3-4087-8bd5-07a1cd7a5505	9d68ce06-e4ad-4249-863f-2f6cd615927e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (89, 3, 172000, 43000, 'Pendiente', 'Se realiza abono', '28-11-2024', 12, 0, 0, '2024-11-04 10:36:27', '2024-11-04 10:36:27')","time":"0.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":668,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 10:36:27
26150	9d68ce06-ded5-4f94-90d5-2cb9818792ee	9d68ce06-e4ad-4249-863f-2f6cd615927e	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 10:36:27
26151	9d68ce06-df30-485d-8eb6-ac22ab278e72	9d68ce06-e4ad-4249-863f-2f6cd615927e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (89, 4, 172000, 43000, 'Pendiente', 'Se realiza abono', '06-12-2024', 12, 0, 0, '2024-11-04 10:36:27', '2024-11-04 10:36:27')","time":"0.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":668,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 10:36:27
26152	9d68ce06-df4c-4d86-bf7f-cce9038f1ceb	9d68ce06-e4ad-4249-863f-2f6cd615927e	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 10:36:27
4425	9d512e77-5f29-490c-b0fa-94a3fe62ce97	9d512e77-9cf6-4dfd-9581-c9136af96fea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 16:46:14
4426	9d512e77-92b0-4183-84db-be3cfa6f1a2e	9d512e77-9cf6-4dfd-9581-c9136af96fea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"77.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 16:46:15
4427	9d512e77-933d-4bab-afb2-f3d5ad164795	9d512e77-9cf6-4dfd-9581-c9136af96fea	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 16:46:15
4428	9d512e77-9abf-4df6-bae7-dd247acc6033	9d512e77-9cf6-4dfd-9581-c9136af96fea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 16:46:15
4429	9d512e77-9b52-4182-9093-60f082029fb1	9d512e77-9cf6-4dfd-9581-c9136af96fea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":460,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:46:15
23763	9d689ba5-bfbc-44df-9352-f47a19e28957	9d689ba5-e7d4-49db-a435-26487cd4d48c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 08:15:34
23764	9d689ba5-da8d-4eb9-88af-0e78c18bbea0	9d689ba5-e7d4-49db-a435-26487cd4d48c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 235 limit 1","time":"2.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 08:15:34
12778	9d5cecd3-8a23-46d2-bac0-4bdf264317c1	9d5cecd3-8d3d-40f3-bcdf-d601a875d3d0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":125,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:52:38
23765	9d689ba5-dada-4d40-b088-64d4dbc9bc67	9d689ba5-e7d4-49db-a435-26487cd4d48c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 08:15:34
23766	9d689ba5-dcb0-4b69-a70a-f7a92f4f4771	9d689ba5-e7d4-49db-a435-26487cd4d48c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 68 limit 1","time":"2.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 08:15:34
23767	9d689ba5-dce9-4632-9d21-de4c946827c6	9d689ba5-e7d4-49db-a435-26487cd4d48c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 08:15:34
23768	9d689ba5-de6f-4f6d-8742-8612d4f7bfe0	9d689ba5-e7d4-49db-a435-26487cd4d48c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '250000', \\"itemloans_cuota_cancelada\\" = '1000000', \\"updated_at\\" = '2024-11-04 08:15:34' where \\"id\\" = 235","time":"1.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":400,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 08:15:34
23769	9d689ba5-deeb-48ee-84e4-32fb2fffa98b	9d689ba5-e7d4-49db-a435-26487cd4d48c	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:235","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 08:15:34","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},"hostname":"EderCortes"}	2024-11-04 08:15:34
23770	9d689ba5-dfe0-4e02-9fbc-2c79abd1b492	9d689ba5-e7d4-49db-a435-26487cd4d48c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 2250000, \\"loans_pago_prestado\\" = 9000000, \\"updated_at\\" = '2024-11-04 08:15:34' where \\"id\\" = 68","time":"1.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":408,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 08:15:34
23771	9d689ba5-e035-45e5-8fa7-562b4444ac3b	9d689ba5-e7d4-49db-a435-26487cd4d48c	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:68","changes":{"updated_at":"2024-11-04 08:15:34","loans_pago_interes":2250000,"loans_pago_prestado":9000000},"hostname":"EderCortes"}	2024-11-04 08:15:34
23772	9d689ba5-e5c5-4405-8fde-02b833c0a730	9d689ba5-e7d4-49db-a435-26487cd4d48c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 08:15:35
26153	9d68ce06-dfa3-4154-9c4a-9a4cea53a53c	9d68ce06-e4ad-4249-863f-2f6cd615927e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (89, 5, 172000, 43000, 'Pendiente', 'Se realiza abono', '14-12-2024', 12, 0, 0, '2024-11-04 10:36:27', '2024-11-04 10:36:27')","time":"0.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":668,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 10:36:27
26154	9d68ce06-dfbe-45f5-b6ea-68433b690cd3	9d68ce06-e4ad-4249-863f-2f6cd615927e	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 10:36:27
26155	9d68ce06-e35a-44b6-aac1-eab68b646bd7	9d68ce06-e4ad-4249-863f-2f6cd615927e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:36:27
4430	9d512e78-36a8-4acc-9f2d-1076ecc8f120	9d512e78-64cb-4367-948d-4a1e1eac8dd9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 16:46:15
4431	9d512e78-5b88-44a9-bbc5-2a42af1ae72f	9d512e78-64cb-4367-948d-4a1e1eac8dd9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"62.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 16:46:15
4432	9d512e78-5c07-4aca-ab05-b0909fd35304	9d512e78-64cb-4367-948d-4a1e1eac8dd9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 16:46:15
4433	9d512e78-62f1-41a6-a632-98ceb836b5a8	9d512e78-64cb-4367-948d-4a1e1eac8dd9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 16:46:15
4434	9d512e78-6363-4ea4-86d8-e001e2e5801f	9d512e78-64cb-4367-948d-4a1e1eac8dd9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":461,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:46:15
23773	9d689ba5-e641-493f-ad05-c4f9f4962633	9d689ba5-e7d4-49db-a435-26487cd4d48c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"181","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000","id":235,"loans_codigo":68,"itemloans_cuota":"9","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":260,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:15:35
6154	9d52598a-1abf-4ce3-a943-68287ea2a097	9d52598a-4903-493b-ba61-37d8b2dcb2cd	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 06:42:31
6155	9d52598a-4692-44f4-a08d-bb5ec4138f8a	9d52598a-4903-493b-ba61-37d8b2dcb2cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 06:42:31
6156	9d52598a-478b-4496-b4a1-c8489f43379a	9d52598a-4903-493b-ba61-37d8b2dcb2cd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":440,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:42:31
26156	9d68ce06-e39a-4ecb-af86-79202cc90b08	9d68ce06-e4ad-4249-863f-2f6cd615927e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"51","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"300000","idLoans":89,"idCreador":12},"session":[],"response_status":200,"response":{"message":"El abono fue aplicado exitosamente","status":true},"duration":382,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:36:27
12779	9d5cecd3-fd18-421e-aaee-db864635a5c0	9d5cecd4-168c-4702-ab29-07bd72811639	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 12:52:38
12780	9d5cecd4-126d-461e-86fb-d7b19ca4de72	9d5cecd4-168c-4702-ab29-07bd72811639	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ma%' or \\"users\\".\\"user_document\\"::text like '%Ma%') order by \\"users\\".\\"user_document\\" asc","time":"39.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:52:38
12781	9d5cecd4-156a-49c1-9fed-fc041afe5bb7	9d5cecd4-168c-4702-ab29-07bd72811639	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 12:52:38
12782	9d5cecd4-15aa-445f-8d68-2da2fee95cd0	9d5cecd4-168c-4702-ab29-07bd72811639	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ma"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":199,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:38
6157	9d52598c-8d82-48d1-a8a0-ea05eb45a7d3	9d52598c-b9ec-4c49-9abb-f2cd27e1f7a8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 06:42:32
6158	9d52598c-b0c6-4eb9-8e94-839236838e7b	9d52598c-b9ec-4c49-9abb-f2cd27e1f7a8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"63.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 06:42:32
6159	9d52598c-b12b-45b7-94d2-dd1f73439ab0	9d52598c-b9ec-4c49-9abb-f2cd27e1f7a8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 06:42:32
6160	9d52598c-b832-4cf2-bcee-e284d433277a	9d52598c-b9ec-4c49-9abb-f2cd27e1f7a8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 06:42:32
6161	9d52598c-b895-42fe-8b5b-80b7ed95d149	9d52598c-b9ec-4c49-9abb-f2cd27e1f7a8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":458,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:42:32
23774	9d689ba6-391d-4cea-9db5-e2795196974e	9d689ba6-59d8-4a7c-a121-0ac3697dc102	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 08:15:35
23775	9d689ba6-4fc2-407d-bd34-a8d15ed24bf8	9d689ba6-59d8-4a7c-a121-0ac3697dc102	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 68\\n                        ","time":"43.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"7d9994d55cb8dde82ff4185920c79043","hostname":"EderCortes"}	2024-11-04 08:15:35
12783	9d5cecd4-5270-4b7b-85e3-4d9079cc15d7	9d5cecd4-6c3b-4491-b7cc-7757a3191353	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 12:52:38
12784	9d5cecd4-67ec-4406-a9a3-9129ceb6a315	9d5cecd4-6c3b-4491-b7cc-7757a3191353	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mar%' or \\"users\\".\\"user_document\\"::text like '%Mar%') order by \\"users\\".\\"user_document\\" asc","time":"39.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:52:38
12785	9d5cecd4-6af7-41eb-ab43-cf396ea9fdaf	9d5cecd4-6c3b-4491-b7cc-7757a3191353	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 12:52:38
12786	9d5cecd4-6b3d-4b5e-86b8-54e1e38db4db	9d5cecd4-6c3b-4491-b7cc-7757a3191353	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mar"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":205,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:38
23776	9d689ba6-53d8-45c1-b97f-f92fbfb76f39	9d689ba6-59d8-4a7c-a121-0ac3697dc102	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '68' order by \\"item_loans\\".\\"id\\" asc","time":"2.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:15:35
23777	9d689ba6-5414-49ce-925f-9cb553241466	9d689ba6-59d8-4a7c-a121-0ac3697dc102	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 08:15:35
23778	9d689ba6-5853-4941-b162-0050da45038e	9d689ba6-59d8-4a7c-a121-0ac3697dc102	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-04 08:15:35
26157	9d68ce07-5a99-40b9-9546-9eb00db80af0	9d68ce07-7836-44f4-9446-dcc414c04c01	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:36:27
28657	9d690661-67bc-443c-bcb2-2cc21f2b05a6	9d690661-6960-4f1d-9bec-86057f3cadf5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"179","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000","id":367,"loans_codigo":89,"itemloans_cuota":"2","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":797,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:14:01
26158	9d68ce07-6fce-428f-8375-8bba9db61c2e	9d68ce07-7836-44f4-9446-dcc414c04c01	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"41.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 10:36:27
23779	9d689ba6-58c2-4bc8-87a2-d0606ef8c1ea	9d689ba6-59d8-4a7c-a121-0ac3697dc102	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/68","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":68,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":10000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"9000000","loans_pago_interes":"2250000"},"items":[{"id":227,"loans_codigo":68,"itemloans_cuota":"1","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":228,"loans_codigo":68,"itemloans_cuota":"2","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:14:40.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":229,"loans_codigo":68,"itemloans_cuota":"3","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:14:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":230,"loans_codigo":68,"itemloans_cuota":"4","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:14:49.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":231,"loans_codigo":68,"itemloans_cuota":"5","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:15:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":232,"loans_codigo":68,"itemloans_cuota":"6","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:15:25.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":233,"loans_codigo":68,"itemloans_cuota":"7","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:15:28.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":234,"loans_codigo":68,"itemloans_cuota":"8","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:15:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":235,"loans_codigo":68,"itemloans_cuota":"9","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:15:34.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":236,"loans_codigo":68,"itemloans_cuota":"10","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":268,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:15:35
9836	9d56ad44-7b95-4989-af79-43042138c429	9d56ad44-c829-4f6e-9687-46b4f55453d5	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 10:19:56
9837	9d56ad44-c623-4c19-9714-d2fd1453c7ad	9d56ad44-c829-4f6e-9687-46b4f55453d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 10:19:57
9838	9d56ad44-c6fe-4ce9-97dd-a8058cc22fb9	9d56ad44-c829-4f6e-9687-46b4f55453d5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:19:57
26159	9d68ce07-7366-4e7c-9276-d0330d88f6b4	9d68ce07-7836-44f4-9446-dcc414c04c01	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"1.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:36:27
26160	9d68ce07-7397-4c08-9abd-71de3c43e527	9d68ce07-7836-44f4-9446-dcc414c04c01	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:36:27
29119	9d690e9f-9f50-42da-8338-98a014658e1d	9d690e9f-a0d7-4790-a7e8-c754c9cb7eac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":710,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:37:04
26161	9d68ce07-76f9-47ea-bcd7-61a56b6efca6	9d68ce07-7836-44f4-9446-dcc414c04c01	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:36:27
23780	9d689bb8-d08c-4229-a63f-f231a50648a4	9d689bb8-d380-4d49-864d-63530d0877f2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":146,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:15:47
9711	9d56abb5-f96f-486c-ae4f-c10a30285c4f	9d56abb7-1656-4de0-9b7f-7ca32789ed49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 10:15:35
9712	9d56abb7-1447-4c82-80ab-f8f7832b4eeb	9d56abb7-1656-4de0-9b7f-7ca32789ed49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 10:15:36
9713	9d56abb7-14f3-44a2-a6f1-c72f1ffc79d1	9d56abb7-1656-4de0-9b7f-7ca32789ed49	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":948,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:15:36
26162	9d68ce07-773e-48a5-b8d4-3e8fa5a9158c	9d68ce07-7836-44f4-9446-dcc414c04c01	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"240000","loans_pago_interes":"60000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:36:27
9839	9d56ad45-224e-4c61-a8af-5fc8e3cbc19b	9d56ad45-3df7-4249-ba69-ba1b5349670a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 10:19:57
9840	9d56ad45-3879-4d1e-a987-4a3036c62977	9d56ad45-3df7-4249-ba69-ba1b5349670a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"43.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-26 10:19:57
21729	9d673dbd-e59e-415c-96cf-878c2ae144fc	9d673dbd-e6a5-4727-a4f8-56f401eb2394	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":217,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:57:10
9841	9d56ad45-3c82-41cb-828f-930ad88c77d6	9d56ad45-3df7-4249-ba69-ba1b5349670a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 10:19:57
9842	9d56ad45-3cf5-4da7-abee-f8d08aff5860	9d56ad45-3df7-4249-ba69-ba1b5349670a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":274,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:19:57
28658	9d690662-7550-4807-80a6-7fc59370afd5	9d690662-94dc-48a0-9235-b0bd080f0fe3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 13:14:02
29120	9d691292-e5d7-4b67-8d56-c12177606462	9d691293-468c-48ee-8c55-b6b71c504031	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 13:48:07
29121	9d691293-407a-409d-b1d5-e79d1b11c9b0	9d691293-468c-48ee-8c55-b6b71c504031	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"158.42","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 13:48:07
9714	9d56abb7-862f-43c7-af1a-f51c0c10f3e0	9d56abb7-c905-4c7e-a963-ac29e18a8056	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 10:15:36
9715	9d56abb7-c48f-4578-806e-0d07924e7852	9d56abb7-c905-4c7e-a963-ac29e18a8056	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"147.66","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-26 10:15:36
9716	9d56abb7-c7e4-4887-b8c8-d33d708c13bd	9d56abb7-c905-4c7e-a963-ac29e18a8056	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 10:15:36
9717	9d56abb7-c832-4fd0-bdea-a1c849d83cd0	9d56abb7-c905-4c7e-a963-ac29e18a8056	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:15:36
9843	9d56ad46-e671-464b-9dd2-3a9f5839d326	9d56ad47-2c01-423a-9a7b-77028fba75c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 10:19:58
9844	9d56ad47-2719-4a4e-b93e-0c35bb5af4b0	9d56ad47-2c01-423a-9a7b-77028fba75c8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"146.95","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 10:19:58
9845	9d56ad47-275f-4c7a-82f1-81e30fadffdf	9d56ad47-2c01-423a-9a7b-77028fba75c8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 10:19:58
9846	9d56ad47-2acd-487b-ad4c-17cb0bcf59d4	9d56ad47-2c01-423a-9a7b-77028fba75c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 10:19:58
9847	9d56ad47-2b0e-4f96-9920-1515b1ec2356	9d56ad47-2c01-423a-9a7b-77028fba75c8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:19:58
29122	9d691293-44b0-41bc-b8d6-504765eeb845	9d691293-468c-48ee-8c55-b6b71c504031	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 13:48:07
21730	9d673dbe-25ad-4311-a5a2-97fffeba9b82	9d673dbe-6aec-4af4-82f8-5dc9ec3eeceb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-03 15:57:10
21731	9d673dbe-66f0-4749-bc23-383ffd3043ef	9d673dbe-6aec-4af4-82f8-5dc9ec3eeceb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"150.75","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 15:57:10
21732	9d673dbe-69bc-4a38-90e1-2dcbcb763b92	9d673dbe-6aec-4af4-82f8-5dc9ec3eeceb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-03 15:57:10
21733	9d673dbe-6a03-4c80-a0e0-2717dcbd2e8d	9d673dbe-6aec-4af4-82f8-5dc9ec3eeceb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:57:10
28659	9d690662-8b56-4eb8-9f14-4841cbd894bb	9d690662-94dc-48a0-9235-b0bd080f0fe3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"43.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 13:14:02
4007	9d511bfb-1715-400c-adfc-468a3465440f	9d511bfb-53f7-448d-ba0e-478494a5655c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 15:54:33
4008	9d511bfb-511a-4827-8086-a390505450e6	9d511bfb-53f7-448d-ba0e-478494a5655c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 15:54:33
4009	9d511bfb-525d-4e79-b73c-2bd423ed73ea	9d511bfb-53f7-448d-ba0e-478494a5655c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":620,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:54:33
9922	9d56b8c7-d235-485c-8449-886073469e95	9d56b8c8-1ee8-4e1c-a5a9-64ac47d3ecad	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 10:52:08
9718	9d56abb9-ae13-4109-8ab0-c359dc9de834	9d56abb9-cddb-4383-9b17-c951a4214cfd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 10:15:38
9719	9d56abb9-c8a3-48d6-bd14-3c66b5c586e7	9d56abb9-cddb-4383-9b17-c951a4214cfd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 10:15:38
9720	9d56abb9-c8fd-4e94-9cad-43f33161bef1	9d56abb9-cddb-4383-9b17-c951a4214cfd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 10:15:38
9721	9d56abb9-cc87-4faf-a8d9-8a5a1c3338a1	9d56abb9-cddb-4383-9b17-c951a4214cfd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 10:15:38
9722	9d56abb9-ccd1-4868-ab26-1a12b303fd18	9d56abb9-cddb-4383-9b17-c951a4214cfd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":413,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:15:38
9923	9d56b8c8-1cdf-451e-a64a-9052f6981e08	9d56b8c8-1ee8-4e1c-a5a9-64ac47d3ecad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 10:52:08
9924	9d56b8c8-1dbd-48ae-9c7e-7e2ac207f359	9d56b8c8-1ee8-4e1c-a5a9-64ac47d3ecad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":429,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:52:08
21734	9d673dbe-ac4c-49e2-a4ac-781476c29976	9d673dbe-c985-415b-89f0-19ae52a96d94	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-03 15:57:10
21735	9d673dbe-c541-43c4-b1ba-b76c3be29296	9d673dbe-c985-415b-89f0-19ae52a96d94	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"44.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 15:57:11
21736	9d673dbe-c84c-4b79-9715-c7710ca44031	9d673dbe-c985-415b-89f0-19ae52a96d94	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-03 15:57:11
21737	9d673dbe-c895-47fc-9b5d-a31cddc526bc	9d673dbe-c985-415b-89f0-19ae52a96d94	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"28","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":223,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:57:11
4010	9d511bfb-db69-4d3c-92f5-ffc56d8d5d48	9d511bfc-1238-4a74-b7c9-34cefb93c01c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 15:54:34
4011	9d511bfc-0373-4fb2-8312-118a04e3166f	9d511bfc-1238-4a74-b7c9-34cefb93c01c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"64.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:54:34
4012	9d511bfc-043c-476b-9730-607a1dd70608	9d511bfc-1238-4a74-b7c9-34cefb93c01c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 15:54:34
4013	9d511bfc-0f70-4970-9129-b24341189950	9d511bfc-1238-4a74-b7c9-34cefb93c01c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 15:54:34
4014	9d511bfc-1021-4ebd-a972-980f61d8ca96	9d511bfc-1238-4a74-b7c9-34cefb93c01c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":446,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:54:34
5212	9d51370a-d657-48d3-8da4-46e1c394ebe8	9d51370b-0bdf-4a52-87b4-2f6b9b63fc03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 17:10:13
5213	9d51370b-08c2-4432-804d-bfcce2e7e967	9d51370b-0bdf-4a52-87b4-2f6b9b63fc03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 17:10:13
5214	9d51370b-0a2f-45e9-ab28-a78bab25cce4	9d51370b-0bdf-4a52-87b4-2f6b9b63fc03	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":451,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:10:13
9925	9d56b8c9-c161-4f9c-9e05-348d77e76823	9d56b8c9-e0f2-4124-be87-b24ab0823aeb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 10:52:09
9926	9d56b8c9-db70-434d-abc7-94c2d159c108	9d56b8c9-e0f2-4124-be87-b24ab0823aeb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 10:52:09
9927	9d56b8c9-dbba-4ad2-8ba2-a41e522c1f9e	9d56b8c9-e0f2-4124-be87-b24ab0823aeb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 10:52:09
9928	9d56b8c9-dfaa-4d42-9fff-1355cb059182	9d56b8c9-e0f2-4124-be87-b24ab0823aeb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 10:52:09
9929	9d56b8c9-dfef-4ae2-b696-0516ebfb2275	9d56b8c9-e0f2-4124-be87-b24ab0823aeb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":278,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:52:09
21738	9d673dbf-bdde-4b15-867c-985e0da3a2e5	9d673dbf-dd0b-4599-9f8e-a440cc7bc4d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-03 15:57:11
21739	9d673dbf-d7da-46bc-8e29-18b42f53496a	9d673dbf-dd0b-4599-9f8e-a440cc7bc4d7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '19' and \\"users\\".\\"deleted_at\\" is null","time":"42.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":55,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-11-03 15:57:11
21740	9d673dbf-d843-4bad-8c62-923995bc7d5c	9d673dbf-dd0b-4599-9f8e-a440cc7bc4d7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 15:57:11
21741	9d673dbf-dbc4-446e-a5e0-7c4a822bd08b	9d673dbf-dd0b-4599-9f8e-a440cc7bc4d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-03 15:57:11
21742	9d673dbf-dc0b-4053-95aa-070255022a4e	9d673dbf-dd0b-4599-9f8e-a440cc7bc4d7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/19","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:57:11
4015	9d511bfc-9b32-486f-8efb-e2e762d6aae3	9d511bfc-e19e-48ff-ad7e-b653499b2210	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 15:54:34
4016	9d511bfc-dc3c-4222-bd1b-7ae39a60586f	9d511bfc-e19e-48ff-ad7e-b653499b2210	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"143.17","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:54:34
4017	9d511bfc-dc97-4549-a0ce-98cf4a8fa6b2	9d511bfc-e19e-48ff-ad7e-b653499b2210	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 15:54:34
4018	9d511bfc-e03d-4548-bfe5-0deda8d0a27d	9d511bfc-e19e-48ff-ad7e-b653499b2210	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 15:54:34
4019	9d511bfc-e085-425d-b07d-6a1d04311a0f	9d511bfc-e19e-48ff-ad7e-b653499b2210	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":506,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:54:34
5215	9d51370b-8ef6-4f8a-b69e-be3d8e2d4964	9d51370b-bf41-4ae5-ac1d-6ed5ed8f1f3f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 17:10:14
5216	9d51370b-b732-45b0-8927-19dddc6c4273	9d51370b-bf41-4ae5-ac1d-6ed5ed8f1f3f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"67.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:10:14
4526	9d5131d1-dee5-40ae-8afc-f3c6f16e2179	9d5131d2-1921-43f3-962e-f020f6bcf61e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 16:55:37
4527	9d5131d2-164e-4998-b825-7b70e3946003	9d5131d2-1921-43f3-962e-f020f6bcf61e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 16:55:37
4528	9d5131d2-17a6-45ce-b986-3e1ffe2662bc	9d5131d2-1921-43f3-962e-f020f6bcf61e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":517,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:55:37
5217	9d51370b-b7bb-4f8c-bffc-033f036398c3	9d51370b-bf41-4ae5-ac1d-6ed5ed8f1f3f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:10:14
5218	9d51370b-bd63-44d5-9e6e-4bf9b592f2f4	9d51370b-bf41-4ae5-ac1d-6ed5ed8f1f3f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 17:10:14
5219	9d51370b-bdfa-457c-8317-96d0a09f7718	9d51370b-bf41-4ae5-ac1d-6ed5ed8f1f3f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":418,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:10:14
23787	9d689c72-b5e6-4d27-8597-35808fac3af9	9d689c72-b9a0-4ee4-8a11-c9948a2e003c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":188,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:17:49
28660	9d690662-8f51-4433-97d4-23cd3e669ca2	9d690662-94dc-48a0-9235-b0bd080f0fe3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"1.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:14:02
28661	9d690662-8f8c-4eb8-8240-f5de7fc0a05c	9d690662-94dc-48a0-9235-b0bd080f0fe3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:14:02
28662	9d690662-939c-44fe-806e-e9d9521c74fd	9d690662-94dc-48a0-9235-b0bd080f0fe3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 13:14:02
30270	9d69395b-bb4e-475c-bb5a-b4a938ff60da	9d69395b-bff6-484f-a257-1def02575eea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/actualizar-users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"PUT","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":200,"memory":20,"hostname":"EderCortes"}	2024-11-04 15:36:34
4020	9d511bfd-918b-45d2-a338-ffab1e0ed9f3	9d511bfd-fcc4-4e91-a7bf-d36b10b3003a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 15:54:35
4021	9d511bfd-f198-4251-9d83-5ba6b6143b25	9d511bfd-fcc4-4e91-a7bf-d36b10b3003a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"185.31","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 15:54:35
4022	9d511bfd-f223-405e-be40-b53922895130	9d511bfd-fcc4-4e91-a7bf-d36b10b3003a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 15:54:35
4023	9d511bfd-fa84-433d-b937-20b501b74464	9d511bfd-fcc4-4e91-a7bf-d36b10b3003a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 15:54:35
4024	9d511bfd-fb23-4ea4-9756-04935df87be3	9d511bfd-fcc4-4e91-a7bf-d36b10b3003a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":710,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:54:35
4529	9d5131d2-9c87-4570-8a7b-a6efdd0f1970	9d5131d2-d00f-4fd8-93f5-627882422a0f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 16:55:37
4530	9d5131d2-c5b8-4b2c-adaa-a17b8aa3f8bc	9d5131d2-d00f-4fd8-93f5-627882422a0f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"68.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:55:38
4531	9d5131d2-c652-4104-b0da-5fd84a48c3b3	9d5131d2-d00f-4fd8-93f5-627882422a0f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 16:55:38
4532	9d5131d2-cdd5-4b17-8dc3-7e5fa8b5a5a9	9d5131d2-d00f-4fd8-93f5-627882422a0f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 16:55:38
4533	9d5131d2-ce56-4b8a-8dca-9278e0773b10	9d5131d2-d00f-4fd8-93f5-627882422a0f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":427,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:55:38
5220	9d51370c-2882-4745-996f-9134e4fa047e	9d51370c-5912-484a-8fbf-756bba4982a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 17:10:14
5221	9d51370c-4fb3-445f-94cb-2f1e7459f72f	9d51370c-5912-484a-8fbf-756bba4982a5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"63.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:10:14
5222	9d51370c-5034-4058-9a52-a281847532a7	9d51370c-5912-484a-8fbf-756bba4982a5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:10:14
5223	9d51370c-56d3-41b1-9675-84901b34b585	9d51370c-5912-484a-8fbf-756bba4982a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 17:10:14
5224	9d51370c-577f-4fe0-b9af-b1b7c628a072	9d51370c-5912-484a-8fbf-756bba4982a5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":369,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:10:14
5225	9d51370d-5db7-4d27-91e6-435a5051a068	9d51370d-a60b-4d64-af51-3bc7b6649b52	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 17:10:15
3328	9d510482-5e60-4964-9dc1-7b0e57806494	9d510482-a03f-4cd3-997e-85738a5a6aa0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 14:48:55
3329	9d510482-9d39-4847-9316-f99c8ad7861c	9d510482-a03f-4cd3-997e-85738a5a6aa0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 14:48:55
3330	9d510482-9e65-456a-b725-9f605d329983	9d510482-a03f-4cd3-997e-85738a5a6aa0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":562,"memory":22,"hostname":"EderCortes"}	2024-10-23 14:48:55
4534	9d5131d3-44fa-4ab1-b843-500755639524	9d5131d3-9012-4560-85a9-683dcb2b2901	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 16:55:38
4535	9d5131d3-8b4f-4833-ace0-97f33c71c40d	9d5131d3-9012-4560-85a9-683dcb2b2901	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"148.48","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:55:38
5226	9d51370d-9c8d-41b0-821f-867b70f87676	9d51370d-a60b-4d64-af51-3bc7b6649b52	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"81.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:10:15
5227	9d51370d-9d4a-4c40-b4c8-d1d3ed811638	9d51370d-a60b-4d64-af51-3bc7b6649b52	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:10:15
4536	9d5131d3-8ba3-4898-a52a-bac210bf758a	9d5131d3-9012-4560-85a9-683dcb2b2901	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 16:55:38
4537	9d5131d3-8efc-41ad-b987-99c9740b39c3	9d5131d3-9012-4560-85a9-683dcb2b2901	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 16:55:38
4538	9d5131d3-8f3f-4f48-8fe7-7147d4ab8962	9d5131d3-9012-4560-85a9-683dcb2b2901	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":469,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:55:38
5228	9d51370d-a428-4808-865c-23293aa49c03	9d51370d-a60b-4d64-af51-3bc7b6649b52	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 17:10:15
5229	9d51370d-a497-40e0-b993-b0865fc02b99	9d51370d-a60b-4d64-af51-3bc7b6649b52	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":828,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:10:15
28663	9d690662-93e9-451b-9c84-989b5aa8c775	9d690662-94dc-48a0-9235-b0bd080f0fe3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":428,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:14:02
4025	9d511bfe-770b-402a-a8b9-c7a94228acbc	9d511bfe-a66b-4e99-8331-6dd35cefb88f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 15:54:35
4026	9d511bfe-9d20-48e3-991b-7b7a92ac4e64	9d511bfe-a66b-4e99-8331-6dd35cefb88f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"62.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 15:54:35
4027	9d511bfe-9d94-45da-861d-3012027ba054	9d511bfe-a66b-4e99-8331-6dd35cefb88f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 15:54:35
4028	9d511bfe-a4a6-4c7c-9d66-1bd42066c068	9d511bfe-a66b-4e99-8331-6dd35cefb88f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 15:54:35
4029	9d511bfe-a52b-4568-bdfe-27af28a7ea7a	9d511bfe-a66b-4e99-8331-6dd35cefb88f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":410,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:54:35
4539	9d5131d4-2d6d-4f19-b8c4-7b69e04caa8e	9d5131d4-95eb-490c-a866-b73b7e9a6505	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 16:55:39
4540	9d5131d4-89ea-4f11-955c-dea4195bfa98	9d5131d4-95eb-490c-a866-b73b7e9a6505	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"129.78","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 16:55:39
4541	9d5131d4-8ab5-4917-a6e1-8c60af522cbb	9d5131d4-95eb-490c-a866-b73b7e9a6505	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 16:55:39
4542	9d5131d4-93d7-45ef-9082-e53deb376b5b	9d5131d4-95eb-490c-a866-b73b7e9a6505	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 16:55:39
4543	9d5131d4-9485-48f2-98cc-a85990c569f0	9d5131d4-95eb-490c-a866-b73b7e9a6505	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":654,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:55:39
5230	9d51370e-60db-4e81-948d-462544f112d7	9d51370e-aa5f-44d7-aa09-d1b3658b4083	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 17:10:16
5231	9d51370e-a5e9-461a-ba6c-66bf302ea10a	9d51370e-aa5f-44d7-aa09-d1b3658b4083	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"157.07","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:10:16
5232	9d51370e-a633-47cf-a0c1-4744d60db4db	9d51370e-aa5f-44d7-aa09-d1b3658b4083	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:10:16
5233	9d51370e-a91a-453d-b824-af5306d0cebc	9d51370e-aa5f-44d7-aa09-d1b3658b4083	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 17:10:16
5234	9d51370e-a95b-43cb-be7c-3d24aab193d5	9d51370e-aa5f-44d7-aa09-d1b3658b4083	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":362,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:10:16
4544	9d5131d5-56e5-4a2b-b369-4fdddad1fea8	9d5131d5-89ba-4d98-9a1b-dc88fa544244	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 16:55:39
4545	9d5131d5-814e-4670-901b-41577422f037	9d5131d5-89ba-4d98-9a1b-dc88fa544244	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"73.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 16:55:39
4546	9d5131d5-81da-4ba8-b5c4-9d66b7ee061f	9d5131d5-89ba-4d98-9a1b-dc88fa544244	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 16:55:39
4547	9d5131d5-87d1-4962-ac4d-016e95b0eb89	9d5131d5-89ba-4d98-9a1b-dc88fa544244	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 16:55:39
4150	9d51214e-9aff-4dbe-bc72-a096ac029b10	9d51214f-0454-484f-a068-a328e3e2ee75	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 16:09:27
4151	9d51214f-00d5-4d34-80ba-64d91c8c423e	9d51214f-0454-484f-a068-a328e3e2ee75	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 16:09:27
4152	9d51214f-0234-4263-bad0-61fdf1162291	9d51214f-0454-484f-a068-a328e3e2ee75	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":806,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:09:27
4548	9d5131d5-885b-449b-b0aa-8b31c5cab687	9d5131d5-89ba-4d98-9a1b-dc88fa544244	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":536,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:55:39
23794	9d689c96-90e0-4de1-b005-38adad5a3ce7	9d689c96-94be-40b0-9fd1-ae58fc3793f9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":193,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:18:12
29123	9d691293-4528-445f-b03a-82746e4ed076	9d691293-468c-48ee-8c55-b6b71c504031	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":465,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:48:07
29315	9d691811-a50b-4aa3-9321-f275d5e6df8a	9d691811-d71c-4f0a-a412-2ac78d5a38a2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":15025,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:03:29
4153	9d51214f-7ff6-49ef-82c6-00790a5df4a9	9d51214f-d970-4acb-99fb-6d4f2e973415	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 16:09:27
4154	9d51214f-ce3c-4dff-9333-c3ae45b8c7dc	9d51214f-d970-4acb-99fb-6d4f2e973415	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"160.49","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":71,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:09:27
4155	9d51214f-ce9a-4353-b7c7-1e6a2e10d8d9	9d51214f-d970-4acb-99fb-6d4f2e973415	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 16:09:27
4156	9d51214f-d812-4936-b7a9-d4d1041dcda0	9d51214f-d970-4acb-99fb-6d4f2e973415	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 16:09:27
4157	9d51214f-d868-49c1-b545-c266baa0135c	9d51214f-d970-4acb-99fb-6d4f2e973415	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":480,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:09:27
29124	9d691297-b450-4f72-be12-ee092a3501c5	9d691297-d3cd-4d34-862c-f5533e8929fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 13:48:10
30403	9d693d4f-aab7-46cd-9f54-4b9fe31d97c1	9d693d4f-ae3e-4857-b1e2-7f769fa843fd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/updateUser","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":194,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:47:37
9993	9d56c609-99ef-408d-958e-44f0f1650b08	9d56c609-bd16-4000-bb55-b2019e1755b4	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 11:29:12
9994	9d56c609-bb61-4f67-aeb8-ab5ee48a978e	9d56c609-bd16-4000-bb55-b2019e1755b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:29:12
29125	9d691297-ce2b-4d54-867e-44eb121490bb	9d691297-d3cd-4d34-862c-f5533e8929fe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"41.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-04 13:48:10
29126	9d691297-ce99-4f0a-9c3e-26e627c0d6dd	9d691297-d3cd-4d34-862c-f5533e8929fe	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 13:48:10
29127	9d691297-d2a4-4e48-af59-0577fded9c4c	9d691297-d3cd-4d34-862c-f5533e8929fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 13:48:10
29128	9d691297-d2ea-43a8-b7b5-fbfb6ac62b80	9d691297-d3cd-4d34-862c-f5533e8929fe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:48:10
29464	9d692474-11f9-4263-bb3f-b7308910f979	9d692474-1390-45f1-b3fa-762e14446921	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":398,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:38:07
42	9d4cf499-cde3-4577-8382-cc75b8a9f2d3	9d4cf499-d1d9-48f1-b24c-c874f6d73344	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abuser_state\\u00bb en la relaci\\u00f3n \\u00abusers\\u00bb\\nLINE 1: ..._neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"user_stat...\\n                                                             ^ (Connection: pgsql, SQL: insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"user_state\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"updated_at\\", \\"created_at\\") values (Eder Arley, edercortez10@gmail.com, Cortes, Cabezas, CC, 1004608333, 2024-10-23T05:00:00.000Z, Cali, Las Orquideas, calle 107a, 3152596295, ?, 1, 29, 123456789, 2024-10-21 14:21:07, 2024-10-21 14:21:07) returning \\"id\\")","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":401},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor.php","line":24},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3549},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":1982},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1334},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1299},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1138},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":35},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":9}	2024-10-21 14:21:07
4158	9d512150-2348-4b4d-85b2-50b74d4b7c6d	9d512150-4378-4b36-b71e-2ba1c5ef4d23	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 16:09:28
4159	9d512150-3e1c-4e69-832b-75cbccfedf10	9d512150-4378-4b36-b71e-2ba1c5ef4d23	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":71,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:09:28
4160	9d512150-3e87-4a1d-bc87-091b2922517b	9d512150-4378-4b36-b71e-2ba1c5ef4d23	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 16:09:28
4161	9d512150-4262-4f8d-af4d-a15fd97a367a	9d512150-4378-4b36-b71e-2ba1c5ef4d23	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 16:09:28
4162	9d512150-42b1-435e-b653-326f775d5e3d	9d512150-4378-4b36-b71e-2ba1c5ef4d23	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:09:28
9995	9d56c609-bc1f-4303-bb10-03f75b89c0b0	9d56c609-bd16-4000-bb55-b2019e1755b4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":296,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:29:12
23801	9d689cc7-ce11-4cfc-a69a-630d1194f459	9d689cc7-d1a0-49c3-ae36-721834bd12de	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":189,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:18:45
29465	9d6926ca-3d24-4549-9c94-9580d5ee9780	9d6926ca-66d3-40bc-8c82-7f33c9c2b228	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 14:44:39
29466	9d6926ca-5f5d-47ef-acd6-e1cd723e270d	9d6926ca-66d3-40bc-8c82-7f33c9c2b228	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"46.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-04 14:44:39
29467	9d6926ca-5fda-4c9f-a686-aa26d40e92c5	9d6926ca-66d3-40bc-8c82-7f33c9c2b228	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 14:44:39
29468	9d6926ca-6523-4760-988b-c71960fba4a8	9d6926ca-66d3-40bc-8c82-7f33c9c2b228	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 14:44:39
29469	9d6926ca-6581-45ed-87ea-f07384c27269	9d6926ca-66d3-40bc-8c82-7f33c9c2b228	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:44:39
30170	9d69348e-6fec-47da-86bb-ded16bf67244	9d69348e-72ce-4072-b1ed-3e9cf6b14f94	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"PUT","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"547","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","profile_code":1,"user_age":"29","user_alias":"eder_cortes","email_verified_at":null,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},"session":[],"response_status":404,"response":{"error":"El m\\u00e9todo especificado en la petici\\u00f3n no es val\\u00eddo","code":404},"duration":170,"memory":20,"hostname":"EderCortes"}	2024-11-04 15:23:08
30404	9d693d50-16ab-41bb-959d-91c7646dc619	9d693d50-82d9-4b87-8cee-0b4d76140d22	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 15:47:37
9996	9d56c60a-02f9-4512-9b7a-5c1f08258ba1	9d56c60a-4752-4745-b6e7-72565d884203	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:29:12
9997	9d56c60a-425d-4c9f-ba0a-4d5afdc6761e	9d56c60a-4752-4745-b6e7-72565d884203	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"149.81","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"506e02f3eef5434bb2733e3b812ec785","hostname":"EderCortes"}	2024-10-26 11:29:13
9998	9d56c60a-45b6-49f7-bd5d-f538e869c6be	9d56c60a-4752-4745-b6e7-72565d884203	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:29:13
9999	9d56c60a-463e-4674-8364-222b6e62af15	9d56c60a-4752-4745-b6e7-72565d884203	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":327,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:29:13
30171	9d693547-85b7-4e44-a5e7-b7c28186085e	9d69354b-e39d-41c6-a7e6-30ea4cda6d41	26079b74e1969c621dc919e440904e4d	t	exception	{"class":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ResourceRegistrar.php","line":616,"message":"Array to string conversion","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ResourceRegistrar.php","line":616},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ResourceRegistrar.php","line":275},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ResourceRegistrar.php","line":107},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\PendingResourceRegistration.php","line":252},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\PendingResourceRegistration.php","line":265},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\routes\\\\api_v1.php","line":13},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":465},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\RouteRegistrar.php","line":194},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\routes\\\\api_v1.php","line":10},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\routes\\\\api.php","line":12},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\RouteFileRegistrar.php","line":35},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":511},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":465},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\RouteRegistrar.php","line":194},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Providers\\\\RouteServiceProvider.php","line":32},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Container\\\\BoundMethod.php","line":36},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Container\\\\Util.php","line":41},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Container\\\\BoundMethod.php","line":81},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Container\\\\BoundMethod.php","line":35},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Container\\\\Container.php","line":662},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Support\\\\Providers\\\\RouteServiceProvider.php","line":120},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Support\\\\Providers\\\\RouteServiceProvider.php","line":45},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Container\\\\BoundMethod.php","line":36},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Container\\\\Util.php","line":41},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Container\\\\BoundMethod.php","line":81},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Container\\\\BoundMethod.php","line":35},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Container\\\\Container.php","line":662},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\ServiceProvider.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Application.php","line":1037},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Application.php","line":1015},[],{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Application.php","line":1014},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\BootProviders.php","line":17},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Application.php","line":263},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":186},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":170},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"607":"     * @param  string  $controller","608":"     * @param  string  $method","609":"     * @param  array  $options","610":"     * @return array","611":"     *\\/","612":"    protected function getResourceAction($resource, $controller, $method, $options)","613":"    {","614":"        $name = $this->getResourceRouteName($resource, $method, $options);","615":"","616":"        $action = ['as' => $name, 'uses' => $controller.'@'.$method];","617":"","618":"        if (isset($options['middleware'])) {","619":"            $action['middleware'] = $options['middleware'];","620":"        }","621":"","622":"        if (isset($options['excluded_middleware'])) {","623":"            $action['excluded_middleware'] = $options['excluded_middleware'];","624":"        }","625":"","626":"        if (isset($options['wheres'])) {"},"hostname":"EderCortes","occurrences":1}	2024-11-04 15:25:10
30271	9d69395c-19c2-4b45-8915-b23a6b38161d	9d69395c-1cb1-447b-9c0e-91e2e450a424	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/actualizar-users","method":"PUT","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"547","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","profile_code":1,"user_age":"29","user_alias":"eder_cortes","email_verified_at":null,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},"session":[],"response_status":404,"response":{"error":"No se encontro la url especificada","code":404},"duration":164,"memory":20,"hostname":"EderCortes"}	2024-11-04 15:36:34
30172	9d69354b-df9c-43d0-9c14-272bcb76b565	9d69354b-e39d-41c6-a7e6-30ea4cda6d41	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"PUT","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":"HTML Response","duration":3078,"memory":24,"hostname":"EderCortes"}	2024-11-04 15:25:12
30405	9d693d50-6436-4aed-990f-697bd9674305	9d693d50-82d9-4b87-8cee-0b4d76140d22	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = 12 and \\"users\\".\\"deleted_at\\" is null limit 1","time":"3.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":89,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 15:47:38
30406	9d693d50-64ce-4a1f-9486-f890a435941d	9d693d50-82d9-4b87-8cee-0b4d76140d22	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 15:47:38
30407	9d693d50-666d-4c05-acc1-004eaa535678	9d693d50-82d9-4b87-8cee-0b4d76140d22	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"users\\" set \\"user_last_name_two\\" = 'Cabezas', \\"updated_at\\" = '2024-11-04 15:47:38' where \\"id\\" = 12","time":"0.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":91,"hash":"6c5f5292e9aba11e11618efb64995341","hostname":"EderCortes"}	2024-11-04 15:47:38
30408	9d693d50-66ed-4a88-969d-866939dbcdfc	9d693d50-82d9-4b87-8cee-0b4d76140d22	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\User:12","changes":{"user_last_name_two":"Cabezas","updated_at":"2024-11-04 15:47:38"},"hostname":"EderCortes"}	2024-11-04 15:47:38
30409	9d693d50-8096-477b-be1f-639822d2427f	9d693d50-82d9-4b87-8cee-0b4d76140d22	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:47:38
5370	9d513886-fa2a-4fe6-818d-593f417bd823	9d513887-1985-425d-bc63-d7d2d44f6fa6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 17:14:22
5371	9d513887-17b4-408d-bfa0-62fb0b855d14	9d513887-1985-425d-bc63-d7d2d44f6fa6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 17:14:22
5372	9d513887-18a0-4dcb-9630-623f76427072	9d513887-1985-425d-bc63-d7d2d44f6fa6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:14:22
28583	9d6901fc-10f9-4e7c-8965-e83fd971c3ef	9d6901fc-5f95-4ca3-9b87-0a0794804ae5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":33,"hostname":"EderCortes"}	2024-11-04 13:01:44
28584	9d6901fc-59e3-442f-ad20-132fc5a69d9b	9d6901fc-5f95-4ca3-9b87-0a0794804ae5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"146.26","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:01:44
24963	9d68bee4-afbd-45b0-955f-a916992ed8ec	9d68bee4-cca4-4e53-a6ba-7e05a60df0fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 09:54:08
23808	9d689cee-7010-44bf-b07f-f0b7c8b87d48	9d689cee-7306-406d-b868-0d281e1fc4e5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":152,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:19:10
24964	9d68bee4-c487-446e-a48b-e275fbb0dd3a	9d68bee4-cca4-4e53-a6ba-7e05a60df0fe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"41.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 09:54:08
24965	9d68bee4-c7d0-4989-b296-8aeb716b852a	9d68bee4-cca4-4e53-a6ba-7e05a60df0fe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"1.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:54:08
24966	9d68bee4-c824-4b3c-b07e-3e8297ede81a	9d68bee4-cca4-4e53-a6ba-7e05a60df0fe	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 09:54:08
24967	9d68bee4-cb80-4bdb-a930-e46008319218	9d68bee4-cca4-4e53-a6ba-7e05a60df0fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 09:54:08
24968	9d68bee4-cbc7-4ce5-9ff8-f1196a49e629	9d68bee4-cca4-4e53-a6ba-7e05a60df0fe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":352,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":353,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":354,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":355,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:54:08
28585	9d6901fc-5a46-46c9-9574-15769a2a6738	9d6901fc-5f95-4ca3-9b87-0a0794804ae5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 13:01:44
28586	9d6901fc-5e43-4402-941e-e6035e8fab1b	9d6901fc-5f95-4ca3-9b87-0a0794804ae5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":34,"hostname":"EderCortes"}	2024-11-04 13:01:44
28587	9d6901fc-5e9b-4334-ada5-133e3e3f464e	9d6901fc-5f95-4ca3-9b87-0a0794804ae5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":603,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:01:44
5373	9d513887-6284-422c-a653-c280a4b1ad5a	9d513887-823f-4827-96a0-c0b5788cdc02	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 17:14:23
5374	9d513887-7d33-4ea8-9662-f4aae0f903e5	9d513887-823f-4827-96a0-c0b5788cdc02	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:14:23
5375	9d513887-7d99-43c7-82f9-802af8e29787	9d513887-823f-4827-96a0-c0b5788cdc02	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:14:23
5376	9d513887-8132-4b91-9f79-a5ab9812677d	9d513887-823f-4827-96a0-c0b5788cdc02	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 17:14:23
5377	9d513887-8172-4a7c-a386-6d9c8b455e51	9d513887-823f-4827-96a0-c0b5788cdc02	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:14:23
6597	9d52d33e-01f2-4a51-9cb7-fa1accd69d46	9d52d33e-4492-40ea-93f9-d81da10d762e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:22:49
6598	9d52d33e-433a-43b3-bbde-188714878ebd	9d52d33e-4492-40ea-93f9-d81da10d762e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:22:49
6599	9d52d33e-43c8-4bfb-ae89-8e40bd999356	9d52d33e-4492-40ea-93f9-d81da10d762e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":317,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:22:49
10000	9d56c60b-c3e8-410f-ab94-e05d5f981ad4	9d56c60c-0b3a-4571-8e42-bb38e515e6f1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:29:14
10001	9d56c60c-051e-4315-b51d-9ee65e506c51	9d56c60c-0b3a-4571-8e42-bb38e515e6f1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"146.74","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:29:14
10002	9d56c60c-059b-4067-9d22-cbcb94a8bb94	9d56c60c-0b3a-4571-8e42-bb38e515e6f1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:29:14
10003	9d56c60c-09cd-4356-a61e-d14cce3aaa7f	9d56c60c-0b3a-4571-8e42-bb38e515e6f1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 11:29:14
10004	9d56c60c-0a1e-4a69-b298-3aa522a26d1e	9d56c60c-0b3a-4571-8e42-bb38e515e6f1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:29:14
28588	9d6901fc-db98-496a-bb1e-267418ab748e	9d6901fc-fa63-4b0e-aa47-b3192118a632	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":34,"hostname":"EderCortes"}	2024-11-04 13:01:44
28589	9d6901fc-f4fa-4ab1-b2f9-ff6b7fced3b3	9d6901fc-fa63-4b0e-aa47-b3192118a632	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:01:44
28590	9d6901fc-f54d-48b5-aaf0-24031ce1601c	9d6901fc-fa63-4b0e-aa47-b3192118a632	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 13:01:44
28591	9d6901fc-f8e4-4a3c-836e-37c16ebf4b65	9d6901fc-fa63-4b0e-aa47-b3192118a632	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":35,"hostname":"EderCortes"}	2024-11-04 13:01:44
28592	9d6901fc-f94d-4a7b-8338-f9df668c19ca	9d6901fc-fa63-4b0e-aa47-b3192118a632	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":377,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:01:44
5378	9d513887-c316-4bef-80fd-9d34fbd1d02a	9d513887-e216-4e90-8932-aa7780825c0e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 17:14:23
5379	9d513887-dcdb-4271-8900-ac6dd2a85f87	9d513887-e216-4e90-8932-aa7780825c0e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:14:23
5380	9d513887-dd26-4aa1-abb2-d8c91b093894	9d513887-e216-4e90-8932-aa7780825c0e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:14:23
5381	9d513887-e0e4-4d72-9a5f-447f0e8a9f0b	9d513887-e216-4e90-8932-aa7780825c0e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 17:14:23
5382	9d513887-e12e-4365-994e-72a41e4bd4bf	9d513887-e216-4e90-8932-aa7780825c0e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:14:23
6600	9d52d33e-88de-48f1-8dc5-c7f8b0f6fff9	9d52d33e-a5ce-4d1c-bb1a-70310ff3b70e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:22:49
6601	9d52d33e-a11b-4451-a5ba-8f194161a7fd	9d52d33e-a5ce-4d1c-bb1a-70310ff3b70e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:22:49
6602	9d52d33e-a166-4693-b3c5-20636f898c1c	9d52d33e-a5ce-4d1c-bb1a-70310ff3b70e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:22:49
6603	9d52d33e-a4d8-4bed-a615-492532f40e96	9d52d33e-a5ce-4d1c-bb1a-70310ff3b70e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 12:22:49
6604	9d52d33e-a516-4b37-90cc-11686d91f95d	9d52d33e-a5ce-4d1c-bb1a-70310ff3b70e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":223,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:22:49
23815	9d689d28-6a10-4933-bca1-8866a2c626d5	9d689d28-6ebe-40be-bd31-fd68b8d53421	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":286,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:19:48
6774	9d52d55f-d17b-40f6-bcf5-742e9290eb53	9d52d55f-f199-4c00-9ef5-66260805b3f1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:28:47
6775	9d52d55f-efc9-41e9-8d41-764553a90397	9d52d55f-f199-4c00-9ef5-66260805b3f1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:28:47
6776	9d52d55f-f06e-44a5-9f61-ec0d66c4091d	9d52d55f-f199-4c00-9ef5-66260805b3f1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":268,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:28:47
10049	9d56c7d8-3035-46b1-bd4c-94c23b39e35f	9d56c7d8-5322-4f46-8b90-22e3ce16df06	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 11:34:15
10050	9d56c7d8-515f-4ef0-86dd-b4772004d86c	9d56c7d8-5322-4f46-8b90-22e3ce16df06	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:34:15
10051	9d56c7d8-5211-4488-b025-e045318abcb3	9d56c7d8-5322-4f46-8b90-22e3ce16df06	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:34:15
28593	9d6901fd-7631-450a-9b73-05e6b586895b	9d6901fd-97ee-48a6-9cfe-6b26f4ce6421	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":35,"hostname":"EderCortes"}	2024-11-04 13:01:45
28594	9d6901fd-9101-4a1f-8ea2-9d8b4e8e3395	9d6901fd-97ee-48a6-9cfe-6b26f4ce6421	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '81' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"45.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 13:01:45
28595	9d6901fd-9157-4ad7-8aad-9cb4dcff04b4	9d6901fd-97ee-48a6-9cfe-6b26f4ce6421	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 13:01:45
28596	9d6901fd-92e0-4abc-96d3-3f587aa8b929	9d6901fd-97ee-48a6-9cfe-6b26f4ce6421	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '81' order by \\"item_loans\\".\\"id\\" asc","time":"1.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:01:45
28597	9d6901fd-9315-45f1-9559-0149c54a4171	9d6901fd-97ee-48a6-9cfe-6b26f4ce6421	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 13:01:45
6605	9d52d33e-eb94-458b-b24d-2d3b9c9af55c	9d52d33f-3474-4441-bb41-5714cc0407c1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 12:22:49
4650	9d513460-1710-4b06-9a5e-1fac6df13070	9d513460-6032-4867-8fcf-4c0bbf7072a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 17:02:46
4651	9d513460-5e46-4b74-adbf-431506962f12	9d513460-6032-4867-8fcf-4c0bbf7072a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 17:02:46
4652	9d513460-5f22-4adb-a875-566db728708e	9d513460-6032-4867-8fcf-4c0bbf7072a6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":341,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:02:46
6606	9d52d33f-2f97-4f07-8c80-e3976f840da2	9d52d33f-3474-4441-bb41-5714cc0407c1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"148.74","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:22:50
6450	9d52d143-2f60-43d4-97d8-85452051a992	9d52d144-9085-4e69-b691-d70e75abcaad	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 12:17:17
6451	9d52d144-8e4e-43e2-a905-e6791bf2a367	9d52d144-9085-4e69-b691-d70e75abcaad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:17:18
6452	9d52d144-8f2e-444c-8f8f-571f306c95e6	9d52d144-9085-4e69-b691-d70e75abcaad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1122,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:17:18
6607	9d52d33f-2fe4-4c1f-9410-14cec33d6935	9d52d33f-3474-4441-bb41-5714cc0407c1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:22:50
6608	9d52d33f-336f-4bd4-b19a-0036fd1f80e4	9d52d33f-3474-4441-bb41-5714cc0407c1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 12:22:50
6609	9d52d33f-33b1-46ab-b2c0-e91bd1002ec4	9d52d33f-3474-4441-bb41-5714cc0407c1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":352,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:22:50
6777	9d52d560-3f89-4b69-9e0c-53438171621c	9d52d560-5c93-4aab-8c83-5fa45883a011	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:28:47
6778	9d52d560-5830-4d33-91d8-4c7c59cff50a	9d52d560-5c93-4aab-8c83-5fa45883a011	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:28:47
6779	9d52d560-5878-4ac8-8426-37edf27debbc	9d52d560-5c93-4aab-8c83-5fa45883a011	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:28:47
6780	9d52d560-5b8e-485c-900e-2470f969b9dd	9d52d560-5c93-4aab-8c83-5fa45883a011	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 12:28:47
6781	9d52d560-5bcd-4978-958c-fea16eccbdf0	9d52d560-5c93-4aab-8c83-5fa45883a011	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":248,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:28:47
10052	9d56c7d8-ab44-46d5-9c9c-6a2f6278c619	9d56c7d8-c574-47c3-8ed5-4273e12e61ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:34:16
10053	9d56c7d8-c10b-44d2-85b1-459201879c4e	9d56c7d8-c574-47c3-8ed5-4273e12e61ea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"43.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:34:16
10054	9d56c7d8-c465-4d55-9481-e9c7d78983c8	9d56c7d8-c574-47c3-8ed5-4273e12e61ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:34:16
28598	9d6901fd-9688-4afa-8a44-8a0c8ef95e77	9d6901fd-97ee-48a6-9cfe-6b26f4ce6421	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":36,"hostname":"EderCortes"}	2024-11-04 13:01:45
4653	9d513460-a4e3-445d-9afc-af9fd9d8fd58	9d513460-c377-4933-bc92-0bdd2303c7fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 17:02:46
3784	9d511877-a7a3-4698-b803-0d480c1ea989	9d511877-da78-482d-a695-162d0f057cee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 15:44:44
3785	9d511877-d7cb-4930-9401-f854d360cbde	9d511877-da78-482d-a695-162d0f057cee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 15:44:44
3786	9d511877-d8eb-4fb4-b838-f80ae726243e	9d511877-da78-482d-a695-162d0f057cee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":680,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:44:44
3556	9d5108dd-2818-4f3b-ae57-5054c6b4a226	9d5108dd-6cf0-4cfd-8f56-89ed22005f7f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 15:01:06
3557	9d5108dd-68f9-422b-adc5-17721c04dcc8	9d5108dd-6cf0-4cfd-8f56-89ed22005f7f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 15:01:06
3558	9d5108dd-6a6c-4767-8d93-0fe933ab1467	9d5108dd-6cf0-4cfd-8f56-89ed22005f7f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":675,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:01:06
4654	9d513460-be7e-4e5b-b4ec-7a8cf6559fda	9d513460-c377-4933-bc92-0bdd2303c7fa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:02:46
4655	9d513460-becf-4435-8663-ebfd7905325a	9d513460-c377-4933-bc92-0bdd2303c7fa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:02:46
4656	9d513460-c264-4f99-b861-26e95423272b	9d513460-c377-4933-bc92-0bdd2303c7fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 17:02:46
4657	9d513460-c2a7-49e2-a47c-e0b6b7c00be5	9d513460-c377-4933-bc92-0bdd2303c7fa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:02:46
6453	9d52d144-fe75-4e31-b592-1395bfcf1465	9d52d145-196a-4d40-8bc2-383ddbf710d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:17:18
6454	9d52d145-1504-4b14-ba6a-c12daa706b90	9d52d145-196a-4d40-8bc2-383ddbf710d8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"46.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-24 12:17:18
6455	9d52d145-1858-4b41-a6dd-4f82ec34bdae	9d52d145-196a-4d40-8bc2-383ddbf710d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:17:18
6456	9d52d145-189e-4b26-8477-9e07e40d2ce1	9d52d145-196a-4d40-8bc2-383ddbf710d8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":284,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:17:18
6610	9d52d33f-755a-491b-bb9f-a5084d29edcb	9d52d33f-9300-4470-8a92-a733cb2f39a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 12:22:50
6611	9d52d33f-8cbb-4fdb-964d-cb56f03431e6	9d52d33f-9300-4470-8a92-a733cb2f39a7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '1' order by \\"id\\" asc","time":"42.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:22:50
6612	9d52d33f-8d06-4bb2-9e03-d04d4d83d566	9d52d33f-9300-4470-8a92-a733cb2f39a7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:22:50
6613	9d52d33f-8e67-4642-aaa6-6f2ddc360a20	9d52d33f-9300-4470-8a92-a733cb2f39a7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1'","time":"1.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:22:50
6614	9d52d33f-8e98-4c3b-95e8-50cc5f5d77cd	9d52d33f-9300-4470-8a92-a733cb2f39a7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 12:22:50
6615	9d52d33f-9199-4343-aaa1-228f128112ce	9d52d33f-9300-4470-8a92-a733cb2f39a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 12:22:50
6782	9d52d560-9c83-4eb9-a0f4-fb19c7336aee	9d52d560-b984-40d4-bdf2-054cc52f4f71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 12:28:47
6783	9d52d560-b4eb-4156-aa3a-b9c23d505607	9d52d560-b984-40d4-bdf2-054cc52f4f71	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:28:47
6784	9d52d560-b533-4ff2-84d3-451c9356af48	9d52d560-b984-40d4-bdf2-054cc52f4f71	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:28:47
6785	9d52d560-b881-42b8-bc88-260aa5b3860c	9d52d560-b984-40d4-bdf2-054cc52f4f71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 12:28:47
3787	9d511878-7adc-4107-9c81-d8ea89260676	9d511878-b037-4368-ab25-1841b4466dd6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 15:44:44
3788	9d511878-a5bf-48c0-83aa-cfb387d818bc	9d511878-b037-4368-ab25-1841b4466dd6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"65.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:44:44
3789	9d511878-a654-44e0-afc4-abd4ac0ef1cd	9d511878-b037-4368-ab25-1841b4466dd6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 15:44:44
3790	9d511878-addf-4207-9654-222a20e13011	9d511878-b037-4368-ab25-1841b4466dd6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 15:44:44
3791	9d511878-ae91-4988-9afb-1b15f0e4f3e0	9d511878-b037-4368-ab25-1841b4466dd6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":509,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:44:44
4658	9d513461-022a-4536-9021-26b9151a8ca5	9d513461-21be-49c5-beaa-e939e3dbf985	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 17:02:46
4659	9d513461-1c43-49db-9b84-1bd1f190f299	9d513461-21be-49c5-beaa-e939e3dbf985	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:02:46
4660	9d513461-1c96-4719-ae9c-c72f2e1c492a	9d513461-21be-49c5-beaa-e939e3dbf985	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:02:46
4661	9d513461-2041-4b19-a1c8-cfce7bc61715	9d513461-21be-49c5-beaa-e939e3dbf985	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 17:02:46
4662	9d513461-20a4-428f-ab73-7de0b719057c	9d513461-21be-49c5-beaa-e939e3dbf985	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":228,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:02:46
6457	9d52d147-35d5-4039-9d1e-4cad1dee6e53	9d52d147-85a9-4b53-b5cb-ce9add309a99	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:17:19
6458	9d52d147-803c-4c4a-980f-c7001ad29378	9d52d147-85a9-4b53-b5cb-ce9add309a99	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"159.53","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:17:20
6459	9d52d147-8093-4058-a842-d6d9a0e6aee7	9d52d147-85a9-4b53-b5cb-ce9add309a99	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:17:20
6460	9d52d147-8442-4a3a-bfcf-4ecf47138f79	9d52d147-85a9-4b53-b5cb-ce9add309a99	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:17:20
6461	9d52d147-8491-4d42-ab3f-e68a4f2b13ef	9d52d147-85a9-4b53-b5cb-ce9add309a99	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":434,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:17:20
3792	9d511879-36fa-40d9-abfb-22e8e7b0595a	9d511879-7017-44de-8553-8814f0346ce2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 15:44:45
3793	9d511879-65ba-4795-b4b7-25cfcc3880cd	9d511879-7017-44de-8553-8814f0346ce2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"73.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:44:45
3794	9d511879-6644-4301-99d0-caeb3c88ee77	9d511879-7017-44de-8553-8814f0346ce2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 15:44:45
3795	9d511879-6dcb-4669-b37a-f7ecdaa79ba4	9d511879-7017-44de-8553-8814f0346ce2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 15:44:45
3796	9d511879-6e62-4664-887a-d403675c2026	9d511879-7017-44de-8553-8814f0346ce2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":460,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:44:45
6616	9d52d33f-91e1-4e94-a3ea-96a7d8d0c75f	9d52d33f-9300-4470-8a92-a733cb2f39a7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":1,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]},"duration":223,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:22:50
6786	9d52d560-b8c0-4c4a-aa4c-ddbb2f8912c5	9d52d560-b984-40d4-bdf2-054cc52f4f71	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:28:47
10055	9d56c7d8-c4ab-45b2-9f61-ddab943732a2	9d56c7d8-c574-47c3-8ed5-4273e12e61ea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":263,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:34:16
28599	9d6901fd-96f4-4943-8b04-9d954d2507ee	9d6901fd-97ee-48a6-9cfe-6b26f4ce6421	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/81","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":81,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"0","loans_pago_prestado":"0","loans_intereses_recaudar":"275000"},"items":[{"id":311,"loans_codigo":81,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":312,"loans_codigo":81,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":313,"loans_codigo":81,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":314,"loans_codigo":81,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":315,"loans_codigo":81,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":384,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:01:45
3797	9d51187a-65a3-4328-8f49-53bd5769b7dc	9d51187a-b356-4a05-a167-1fffaafd0933	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 15:44:45
3798	9d51187a-a6b0-4241-80a4-0e681dfb63f4	9d51187a-b356-4a05-a167-1fffaafd0933	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"116.58","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 15:44:46
3799	9d51187a-a749-4b1d-9c5b-6694f327df4c	9d51187a-b356-4a05-a167-1fffaafd0933	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 15:44:46
3800	9d51187a-b13a-4129-bfcf-6d8b4214b05d	9d51187a-b356-4a05-a167-1fffaafd0933	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 15:44:46
3801	9d51187a-b1e7-4300-8762-f0815f38ae4a	9d51187a-b356-4a05-a167-1fffaafd0933	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":807,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:44:46
6617	9d52d340-e936-461d-a8b1-8b5bd6f8a9ff	9d52d341-06dd-4e38-b481-f31981c98b42	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 12:22:51
6618	9d52d341-0216-4170-88f4-e6870c10dc0a	9d52d341-06dd-4e38-b481-f31981c98b42	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:22:51
6619	9d52d341-0260-4093-bfe6-22a1fa05f7a6	9d52d341-06dd-4e38-b481-f31981c98b42	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:22:51
6620	9d52d341-0578-49c3-8586-15d261300f1c	9d52d341-06dd-4e38-b481-f31981c98b42	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 12:22:51
6621	9d52d341-05c8-404f-ac5d-a66534c83306	9d52d341-06dd-4e38-b481-f31981c98b42	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":449,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:22:51
6787	9d52d560-f96f-4a87-a32d-86f61fafa367	9d52d561-1860-4ee0-932b-7ad6bf3d1c23	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 12:28:47
6788	9d52d561-1297-477c-a604-103a114bf414	9d52d561-1860-4ee0-932b-7ad6bf3d1c23	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"42.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:28:47
6789	9d52d561-12e3-4768-9ab5-79ae443b6a1d	9d52d561-1860-4ee0-932b-7ad6bf3d1c23	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:28:47
6790	9d52d561-1456-48d5-94a2-72feb7a261d6	9d52d561-1860-4ee0-932b-7ad6bf3d1c23	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"1.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:28:47
6791	9d52d561-1486-4deb-8eee-af87b8fe1f14	9d52d561-1860-4ee0-932b-7ad6bf3d1c23	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:28:47
6792	9d52d561-1760-47b1-bc17-c917ff1ec40b	9d52d561-1860-4ee0-932b-7ad6bf3d1c23	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 12:28:47
6793	9d52d561-17a1-4a23-bf16-6b30325e386c	9d52d561-1860-4ee0-932b-7ad6bf3d1c23	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:28:47
3802	9d51187b-a75f-4dd4-b3c8-78a248013f65	9d51187b-e353-4aa6-a40e-6475cf1cc18b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 15:44:46
3803	9d51187b-d868-405a-91e9-ee6cda7a63b3	9d51187b-e353-4aa6-a40e-6475cf1cc18b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"72.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 15:44:46
3804	9d51187b-d90d-482d-8cc7-fb16ee628894	9d51187b-e353-4aa6-a40e-6475cf1cc18b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 15:44:46
3805	9d51187b-e19c-490c-80bc-c1ef72c6fc1e	9d51187b-e353-4aa6-a40e-6475cf1cc18b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 15:44:46
3806	9d51187b-e228-4116-89e3-05cbed2b5ed2	9d51187b-e353-4aa6-a40e-6475cf1cc18b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":750,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:44:46
6622	9d52d384-41b7-4892-892d-fec4d9386a5d	9d52d384-6588-4a86-a81d-654162c5ae18	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 12:23:35
6623	9d52d384-5fce-48c9-b219-c383c119f72f	9d52d384-6588-4a86-a81d-654162c5ae18	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"47.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-24 12:23:35
6624	9d52d384-63fd-4536-8117-5459fc8de7a9	9d52d384-6588-4a86-a81d-654162c5ae18	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:23:35
6625	9d52d384-6459-461e-82f1-51ed82a83947	9d52d384-6588-4a86-a81d-654162c5ae18	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":291,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:23:35
6794	9d52d562-72a5-4bbd-a01e-ea9fedbd1454	9d52d562-beeb-45dd-9123-dcbf5ae833f1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 12:28:48
6795	9d52d562-ba53-4f49-92af-1addeb45220d	9d52d562-beeb-45dd-9123-dcbf5ae833f1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"153.83","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:28:48
6796	9d52d562-bab5-4285-ad14-b126d63e6000	9d52d562-beeb-45dd-9123-dcbf5ae833f1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:28:48
6797	9d52d562-bdc7-47e8-bdd9-731d4af84298	9d52d562-beeb-45dd-9123-dcbf5ae833f1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 12:28:48
10056	9d56c7da-35cd-4c2f-96e1-237a712b2358	9d56c7da-5348-4dac-b09c-4b4265e387f7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:34:17
10057	9d56c7da-4e3a-41c5-a111-02551c0473fd	9d56c7da-5348-4dac-b09c-4b4265e387f7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:34:17
10058	9d56c7da-4e92-4727-83c2-3f357f04287e	9d56c7da-5348-4dac-b09c-4b4265e387f7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:34:17
10059	9d56c7da-522d-4df8-b8a3-55be0949330b	9d56c7da-5348-4dac-b09c-4b4265e387f7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 11:34:17
28604	9d6901ff-37e0-4ce6-bf26-bfabde70c46e	9d6901ff-8b5e-49bb-bc27-cd340c943bcd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":37,"hostname":"EderCortes"}	2024-11-04 13:01:46
6798	9d52d562-be07-407f-ba0c-4cca0e4d1451	9d52d562-beeb-45dd-9123-dcbf5ae833f1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":560,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:28:48
10060	9d56c7da-526f-423d-b3bf-40081eee1019	9d56c7da-5348-4dac-b09c-4b4265e387f7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:34:17
23821	9d689d5b-703b-4995-998f-0a602ace0eee	9d689d5b-7497-4842-b7ee-fead85f7aaaf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":209,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:20:21
5513	9d522175-45fc-444f-97cc-7f6d882d8681	9d522175-7297-4e1f-9b58-16c13044820d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 04:05:42
5514	9d522175-7088-418b-b677-cd439001cab0	9d522175-7297-4e1f-9b58-16c13044820d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 04:05:42
5515	9d522175-7152-49d8-8018-f9c284cfc7da	9d522175-7297-4e1f-9b58-16c13044820d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":315,"memory":22,"hostname":"EderCortes"}	2024-10-24 04:05:42
30173	9d693567-15ee-47ae-9b89-d1d2c13ffa67	9d693567-19ab-4223-b9cf-3baa74dc30da	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"PUT","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":153,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:25:30
6626	9d52d392-dcc4-4ada-abcc-68068ca49d54	9d52d392-fdab-4cd3-af8b-6cf72277e218	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:23:44
6627	9d52d392-f7ed-4e3b-a2d3-5b6744a56057	9d52d392-fdab-4cd3-af8b-6cf72277e218	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:23:45
6628	9d52d392-f84d-4988-9b05-483e9a1befe0	9d52d392-fdab-4cd3-af8b-6cf72277e218	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:23:45
6629	9d52d392-fc44-411f-85a8-830b332b889d	9d52d392-fdab-4cd3-af8b-6cf72277e218	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:23:45
28610	9d690200-6601-4fc0-a238-f97c879ccbdd	9d690200-bb55-4c20-a8e9-b2f0276393ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":38,"hostname":"EderCortes"}	2024-11-04 13:01:47
28611	9d690200-b10d-44ab-a219-d6969a6e5af7	9d690200-bb55-4c20-a8e9-b2f0276393ff	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"142.09","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:01:47
28612	9d690200-b1ca-4d00-9228-8043e711b306	9d690200-bb55-4c20-a8e9-b2f0276393ff	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:01:47
28613	9d690200-b955-4256-a926-a9c81958b318	9d690200-bb55-4c20-a8e9-b2f0276393ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":39,"hostname":"EderCortes"}	2024-11-04 13:01:47
5516	9d522175-d2b2-409b-98ab-2f18f2fd5e32	9d522175-f3b6-45b1-b82d-be537b9bf628	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 04:05:42
5517	9d522175-eded-4e15-8c45-6ea9f488e350	9d522175-f3b6-45b1-b82d-be537b9bf628	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 04:05:42
5518	9d522175-ee41-42a2-8979-d49376779316	9d522175-f3b6-45b1-b82d-be537b9bf628	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 04:05:42
5519	9d522175-f27b-4b0f-a89a-aa771e661e5e	9d522175-f3b6-45b1-b82d-be537b9bf628	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 04:05:42
5520	9d522175-f2c1-4d1b-a13c-f3d6d2cd89cb	9d522175-f3b6-45b1-b82d-be537b9bf628	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":301,"memory":22,"hostname":"EderCortes"}	2024-10-24 04:05:42
6630	9d52d392-fc94-4985-9b17-0898d064310d	9d52d392-fdab-4cd3-af8b-6cf72277e218	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":312,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:23:45
23822	9d689d5c-3950-4f7a-a613-1b337e0e090a	9d689d5c-6d88-429a-a44c-e08060caaac5	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 08:20:22
23823	9d689d5c-5c49-4b6d-b406-b680efe25b28	9d689d5c-6d88-429a-a44c-e08060caaac5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 68 limit 1","time":"3.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":498,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 08:20:22
23824	9d689d5c-5cc0-4ce6-8d1a-09e0bd3f1660	9d689d5c-6d88-429a-a44c-e08060caaac5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":2,"hostname":"EderCortes"}	2024-11-04 08:20:22
23825	9d689d5c-5ede-4465-8c6a-def06d9849ee	9d689d5c-6d88-429a-a44c-e08060caaac5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select count(*) as aggregate from \\"item_loans\\" where \\"loans_codigo\\" = 68 and \\"itemloans_status\\" = 'Pagada'","time":"2.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":545,"hash":"60bd91eaa209a639fc2e8afc20430a4b","hostname":"EderCortes"}	2024-11-04 08:20:22
23826	9d689d5c-5fac-4907-baf2-2d7760de84d5	9d689d5c-6d88-429a-a44c-e08060caaac5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 2500000, \\"loans_pago_prestado\\" = 10000000, \\"updated_at\\" = '2024-11-04 08:20:22' where \\"id\\" = 68","time":"0.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":589,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 08:20:22
23827	9d689d5c-600e-4de0-aa39-be1384d5cbac	9d689d5c-6d88-429a-a44c-e08060caaac5	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:68","changes":{"updated_at":"2024-11-04 08:20:22","loans_pago_interes":2500000,"loans_pago_prestado":10000000},"hostname":"EderCortes"}	2024-11-04 08:20:22
23828	9d689d5c-60a5-444c-b15a-3607addc00cb	9d689d5c-6d88-429a-a44c-e08060caaac5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 68 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"0.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":596,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 08:20:22
23829	9d689d5c-60d7-4043-9f53-bdb45f590f58	9d689d5c-6d88-429a-a44c-e08060caaac5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 08:20:22
23830	9d689d5c-6161-44d4-b3df-0d72113755e6	9d689d5c-6d88-429a-a44c-e08060caaac5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = 250000, \\"itemloans_cuota_cancelada\\" = 1000000, \\"updated_at\\" = '2024-11-04 08:20:22' where \\"id\\" = 236","time":"0.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":603,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 08:20:22
23831	9d689d5c-61a2-45d7-a9a4-1250b05c21d3	9d689d5c-6d88-429a-a44c-e08060caaac5	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:236","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 08:20:22","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":250000,"itemloans_cuota_cancelada":1000000},"hostname":"EderCortes"}	2024-11-04 08:20:22
23832	9d689d5c-620c-499b-a036-79ec3f39db08	9d689d5c-6d88-429a-a44c-e08060caaac5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"delete from \\"item_loans\\" where \\"loans_codigo\\" = 68 and \\"itemloans_status\\" = 'Pendiente'","time":"0.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":610,"hash":"89bf3c496a8b0746ff5d1219b8dc29e3","hostname":"EderCortes"}	2024-11-04 08:20:22
5521	9d522176-3ceb-408c-a0ef-675562a97586	9d522176-8344-4ca7-a117-10148d8813be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 04:05:42
5522	9d522176-7d51-4a4f-89fb-87c3d838f307	9d522176-8344-4ca7-a117-10148d8813be	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"142.61","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 04:05:42
5523	9d522176-7dba-46e1-859f-6d1aeda3f522	9d522176-8344-4ca7-a117-10148d8813be	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 04:05:42
5524	9d522176-81f4-45bd-b921-0be2ce2b5d90	9d522176-8344-4ca7-a117-10148d8813be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 04:05:42
5525	9d522176-8247-45da-a7b4-5b5ce7a20faf	9d522176-8344-4ca7-a117-10148d8813be	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":353,"memory":22,"hostname":"EderCortes"}	2024-10-24 04:05:42
6631	9d52d393-47f5-4019-a6a2-e7eb348be794	9d52d393-8c03-4485-9fc1-225a84617c65	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:23:45
6632	9d52d393-877e-4557-a98b-f6c1655c686e	9d52d393-8c03-4485-9fc1-225a84617c65	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"141.75","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:23:45
6633	9d52d393-87c6-40ed-b86c-b4f21153b0a8	9d52d393-8c03-4485-9fc1-225a84617c65	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:23:45
6634	9d52d393-8ade-4433-adcf-7ed2ddcb9779	9d52d393-8c03-4485-9fc1-225a84617c65	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:23:45
6635	9d52d393-8b20-4049-bb6a-60890ce013e9	9d52d393-8c03-4485-9fc1-225a84617c65	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:23:45
23833	9d689d5c-6292-4c4b-9587-5b0559875f43	9d689d5c-6d88-429a-a44c-e08060caaac5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 68 limit 1","time":"0.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":613,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 08:20:22
23834	9d689d5c-639e-422f-afee-4a0b5a26f8fa	9d689d5c-6d88-429a-a44c-e08060caaac5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (68, 10, 0, -2500000, 'Pendiente', 'Se realiza abono', '20-11-2024', 12, 0, 0, '2024-11-04 08:20:22', '2024-11-04 08:20:22')","time":"1.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":665,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 08:20:22
23835	9d689d5c-63c8-4ff8-af69-5e622c727905	9d689d5c-6d88-429a-a44c-e08060caaac5	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 08:20:22
23836	9d689d5c-6b9c-4a5d-b840-4c2fcd0d6597	9d689d5c-6d88-429a-a44c-e08060caaac5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 08:20:22
23837	9d689d5c-6c13-4a4e-8841-04fc6a8e3c8d	9d689d5c-6d88-429a-a44c-e08060caaac5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"52","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"1250000","idLoans":68,"idCreador":12},"session":[],"response_status":200,"response":{"message":"El abono fue aplicado exitosamente","status":true},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:20:22
30714	9d69427e-f3e0-43d9-a163-0f32e2e3e748	9d69427e-f4d4-424c-8d5e-ebd61d36a4d5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/19","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:02:07
30174	9d693567-d17d-49a8-97c2-cb9611bbef38	9d693567-d4a7-4b7e-b7e3-4ce31b763a35	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"PUT","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"547","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","profile_code":1,"user_age":"29","user_alias":"eder_cortes","email_verified_at":null,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},"session":[],"response_status":404,"response":{"error":"El m\\u00e9todo especificado en la petici\\u00f3n no es val\\u00eddo","code":404},"duration":158,"memory":20,"hostname":"EderCortes"}	2024-11-04 15:25:31
30410	9d693d50-8135-432f-9ce6-139530fdcc40	9d693d50-82d9-4b87-8cee-0b4d76140d22	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/updateUser","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@updateUser","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"547","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","profile_code":1,"user_age":"29","user_alias":"eder_cortes","email_verified_at":null,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:44:39.000000Z","deleted_at":null},"session":[],"response_status":200,"response":{"response":"El registro fue actualizado exitosamente"},"duration":474,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:47:38
3874	9d511ad8-cb69-43c1-a434-8fc148213e18	9d511ad9-04f1-4d62-9903-39961d2cd6c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 15:51:23
3875	9d511ad9-0188-45e4-8f7c-f52cbf7fc60c	9d511ad9-04f1-4d62-9903-39961d2cd6c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 15:51:23
3876	9d511ad9-0335-43be-9609-06b7ce6229d7	9d511ad9-04f1-4d62-9903-39961d2cd6c3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":629,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:51:23
6636	9d52d393-c820-432a-943a-b9bed6d8a021	9d52d393-e4dc-427b-9220-77a195d6df71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:23:45
6637	9d52d393-de45-4030-b5b7-12a11f495946	9d52d393-e4dc-427b-9220-77a195d6df71	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"40.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:23:45
6638	9d52d393-de8c-4aca-8bea-b34782c76144	9d52d393-e4dc-427b-9220-77a195d6df71	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:23:45
6639	9d52d393-dffa-4e0e-a54e-0f95e5d79cfa	9d52d393-e4dc-427b-9220-77a195d6df71	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"1.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:23:45
6640	9d52d393-e02a-4c52-abd4-d522daed8aaf	9d52d393-e4dc-427b-9220-77a195d6df71	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:23:45
6641	9d52d393-e362-4cf9-a877-30ac1ef75f71	9d52d393-e4dc-427b-9220-77a195d6df71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:23:45
10127	9d56c906-3b85-4242-81eb-a52251718416	9d56c906-8284-4839-836c-f841d8dac3c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 11:37:33
10128	9d56c906-8115-414d-882b-6a2bbc599ffb	9d56c906-8284-4839-836c-f841d8dac3c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 11:37:33
10129	9d56c906-81ab-4f56-a0ac-b5bf38da2a9f	9d56c906-8284-4839-836c-f841d8dac3c8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":363,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:37:33
3877	9d511ad9-a2b9-4cb3-9fd4-d1de89443ccf	9d511ad9-d45c-4e9e-8503-f1c09a14594d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 15:51:23
3878	9d511ad9-cb82-4086-9460-7be82972a5d9	9d511ad9-d45c-4e9e-8503-f1c09a14594d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"64.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:51:23
3879	9d511ad9-cbfe-4edd-a0b2-e4764ba081f7	9d511ad9-d45c-4e9e-8503-f1c09a14594d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 15:51:23
3880	9d511ad9-d23d-41f1-ab9d-23eb24a444d8	9d511ad9-d45c-4e9e-8503-f1c09a14594d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 15:51:23
3881	9d511ad9-d299-490b-ad18-ecedfed3f0e6	9d511ad9-d45c-4e9e-8503-f1c09a14594d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":485,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:51:23
6642	9d52d393-e3c1-408c-822e-99c9bb03a18d	9d52d393-e4dc-427b-9220-77a195d6df71	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]},"duration":208,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:23:45
10130	9d56c906-c9ab-46c7-ad55-27344b6e3cdc	9d56c906-e3c1-407c-a2bd-1a440f5520f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 11:37:34
10131	9d56c906-dfc9-4c33-a33a-51852751870c	9d56c906-e3c1-407c-a2bd-1a440f5520f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"43.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:37:34
10132	9d56c906-e2bd-4fbe-a942-c21699f74c10	9d56c906-e3c1-407c-a2bd-1a440f5520f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 11:37:34
10133	9d56c906-e300-450d-88be-44bba9e05b3f	9d56c906-e3c1-407c-a2bd-1a440f5520f0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":223,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:37:34
30715	9d6942bd-d0a9-4e23-9d03-1d8cff35b54a	9d6942bd-d4f0-4a03-9fa4-1ff71d108ccd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":190,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:02:48
3882	9d511ada-469f-4aad-a6ac-60317c5eb3d8	9d511ada-7a2a-402d-9298-cbd102a2e404	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 15:51:24
3883	9d511ada-707c-442d-950c-386e064024f8	9d511ada-7a2a-402d-9298-cbd102a2e404	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"71.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:51:24
3884	9d511ada-710a-423e-85ac-ab073173bb0c	9d511ada-7a2a-402d-9298-cbd102a2e404	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 15:51:24
3885	9d511ada-782b-465b-8558-5136bb1e9a6c	9d511ada-7a2a-402d-9298-cbd102a2e404	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 15:51:24
3886	9d511ada-78ae-4882-9d7e-6ee932e8bd7d	9d511ada-7a2a-402d-9298-cbd102a2e404	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":399,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:51:24
10134	9d56c908-52d3-49e5-aa3b-85e5aa8a1e2b	9d56c908-9854-4388-9ec7-f231c7620350	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 11:37:35
10135	9d56c908-92df-4257-a4b2-b6f6aa0b1d75	9d56c908-9854-4388-9ec7-f231c7620350	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"143.27","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:37:35
10136	9d56c908-9328-4c9c-87d7-527b68488912	9d56c908-9854-4388-9ec7-f231c7620350	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:37:35
10137	9d56c908-9702-46a7-ae6d-c965b4e9928c	9d56c908-9854-4388-9ec7-f231c7620350	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 11:37:35
10138	9d56c908-974b-44ce-8407-88dfe9abb98e	9d56c908-9854-4388-9ec7-f231c7620350	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:37:35
31152	9d69466d-b4ac-4a4e-b6af-8eefd1b10ef0	9d69466d-b898-4569-a1e0-0dc37e786c9e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":165,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:13:07
32090	9d695a41-df4a-4cc6-bfb7-a3169f8f8735	9d695a41-e0b1-4bfe-a521-24d6d815e3b1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:55:01.000000Z","deleted_at":null,"user_alias":"eder.cortes"}]},"duration":393,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:08:33
3887	9d511adb-1ee2-4922-8a27-e20937333431	9d511adb-5d6b-4679-98fa-53714b78d9d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 15:51:24
3888	9d511adb-5188-4bb0-83e6-b6cc330e1bab	9d511adb-5d6b-4679-98fa-53714b78d9d6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"83.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 15:51:24
3889	9d511adb-5230-40f9-aa34-293a44782211	9d511adb-5d6b-4679-98fa-53714b78d9d6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 15:51:24
3890	9d511adb-5b3a-4fef-8e54-7c89dcaba4dc	9d511adb-5d6b-4679-98fa-53714b78d9d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 15:51:24
3891	9d511adb-5bd6-471e-b9f3-8fc0bea843e0	9d511adb-5d6b-4679-98fa-53714b78d9d6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":557,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:51:24
31153	9d69466e-1385-47e1-aaad-49c31110ee9c	9d69466e-3679-487b-b71d-76a049e99722	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 16:13:07
31154	9d69466e-2c8d-419d-9fa6-4d808995a797	9d69466e-3679-487b-b71d-76a049e99722	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 379 limit 1","time":"2.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":358,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 16:13:07
28614	9d690200-b9df-4eff-91ab-f8184ad3c950	9d690200-bb55-4c20-a8e9-b2f0276393ff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":756,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:01:47
31155	9d69466e-2cd8-4f5a-a9ca-3a9bcd062ec0	9d69466e-3679-487b-b71d-76a049e99722	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 16:13:07
31156	9d69466e-2e7b-4dfa-aa72-b7224f34eaad	9d69466e-3679-487b-b71d-76a049e99722	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 92 limit 1","time":"1.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":359,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 16:13:07
31157	9d69466e-2eb4-4821-b479-8a1ce5af7f19	9d69466e-3679-487b-b71d-76a049e99722	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 16:13:07
31158	9d69466e-304b-482a-9142-6106d46d3203	9d69466e-3679-487b-b71d-76a049e99722	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '133333.48333333', \\"itemloans_cuota_cancelada\\" = '533333.93333333', \\"updated_at\\" = '2024-11-04 16:13:07' where \\"id\\" = 379","time":"2.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":402,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 16:13:07
31159	9d69466e-30b3-4281-941a-5b23ae4b3fb1	9d69466e-3679-487b-b71d-76a049e99722	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:379","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 16:13:07","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333"},"hostname":"EderCortes"}	2024-11-04 16:13:07
31160	9d69466e-3163-4aa0-8626-7e8d6fa3bfef	9d69466e-3679-487b-b71d-76a049e99722	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_estado\\" = 'En curso', \\"loans_pago_interes\\" = 133333.48333333, \\"loans_pago_prestado\\" = 533333.93333333, \\"updated_at\\" = '2024-11-04 16:13:07' where \\"id\\" = 92","time":"0.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":410,"hash":"acfe32aea56c9ca6bdbb917f944a78d1","hostname":"EderCortes"}	2024-11-04 16:13:07
31161	9d69466e-31a1-41e2-8ae9-a85b4fbccffa	9d69466e-3679-487b-b71d-76a049e99722	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:92","changes":{"loans_estado":"En curso","updated_at":"2024-11-04 16:13:07","loans_pago_interes":133333.48333333,"loans_pago_prestado":533333.93333333},"hostname":"EderCortes"}	2024-11-04 16:13:07
31162	9d69466e-3508-4a56-9fe1-6328ea0b636b	9d69466e-3679-487b-b71d-76a049e99722	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 16:13:07
3892	9d511adb-eee4-4e4c-8250-828777287176	9d511adc-4002-4515-9c1e-9446f111e96e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 15:51:25
3893	9d511adc-3985-4b60-b65a-5ace517864e1	9d511adc-4002-4515-9c1e-9446f111e96e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"161.32","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 15:51:25
3894	9d511adc-39e4-4027-851e-8218ba6ff518	9d511adc-4002-4515-9c1e-9446f111e96e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 15:51:25
3895	9d511adc-3e80-4ac8-a6d0-ca450fdeb922	9d511adc-4002-4515-9c1e-9446f111e96e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 15:51:25
3896	9d511adc-3ee6-489a-a0df-987b40307b00	9d511adc-4002-4515-9c1e-9446f111e96e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":551,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:51:25
31163	9d69466e-3563-4388-8e1c-d01543d1eafa	9d69466e-3679-487b-b71d-76a049e99722	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"198","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","id":379,"loans_codigo":92,"itemloans_cuota":"1","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:13:07
6930	9d52d81c-4d31-437e-9839-e500e35d3094	9d52d81c-8819-4b77-82c7-dd13fba6c77f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 12:36:26
6931	9d52d81c-846c-412a-8dc1-3871e4259e66	9d52d81c-8819-4b77-82c7-dd13fba6c77f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:36:26
6932	9d52d81c-860b-4dc1-b9c8-3c91e49ce2be	9d52d81c-8819-4b77-82c7-dd13fba6c77f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":469,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:36:26
39734	9d6cb404-15c6-40cf-a4ac-832e949dff7d	9d6cb404-24f1-49f5-b749-7f9d8ba492bb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":206,"memory":18,"hostname":"EderCortes"}	2024-11-06 09:07:01
28615	9d690201-87e7-4ee5-84af-56d87b17c817	9d690201-bca6-4da6-959d-8875d0f2c56b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":39,"hostname":"EderCortes"}	2024-11-04 13:01:47
28616	9d690201-b61a-414e-bcb5-1c70ed00ca92	9d690201-bca6-4da6-959d-8875d0f2c56b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"74.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:01:47
28617	9d690201-b68b-47d4-a2b2-133ed5113959	9d690201-bca6-4da6-959d-8875d0f2c56b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:01:47
28618	9d690201-bb47-43aa-ace5-ecbe491af297	9d690201-bca6-4da6-959d-8875d0f2c56b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":40,"hostname":"EderCortes"}	2024-11-04 13:01:47
28619	9d690201-bb9c-442c-998a-8cee6cd9c478	9d690201-bca6-4da6-959d-8875d0f2c56b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":637,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:01:47
6933	9d52d81d-7911-483b-8df6-437c38b81005	9d52d81d-a9b2-4c4a-a2e4-d73922ae2ede	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:36:26
6934	9d52d81d-9efd-4561-8b4a-40192eeb5e8c	9d52d81d-a9b2-4c4a-a2e4-d73922ae2ede	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"65.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:36:26
6935	9d52d81d-9f7f-4ced-a0e5-70ffae19e359	9d52d81d-a9b2-4c4a-a2e4-d73922ae2ede	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:36:26
6936	9d52d81d-a7de-44ad-9895-25bd7639104a	9d52d81d-a9b2-4c4a-a2e4-d73922ae2ede	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:36:27
6937	9d52d81d-a85a-49e1-8a98-d7e9385cf0ea	9d52d81d-a9b2-4c4a-a2e4-d73922ae2ede	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":697,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:36:27
31164	9d69466e-8946-4363-9167-60c6b45d2aab	9d69466e-aa30-4121-b3e8-b8f6aa23ee2d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 16:13:07
31165	9d69466e-9f9f-4319-b267-51e346ef0295	9d69466e-aa30-4121-b3e8-b8f6aa23ee2d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"43.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 16:13:07
31166	9d69466e-a392-49ea-9817-b4d4648ca9dd	9d69466e-aa30-4121-b3e8-b8f6aa23ee2d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '92' order by \\"item_loans\\".\\"id\\" asc","time":"1.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 16:13:07
10309	9d56cd4f-e2ab-43ca-a943-9f11b512b3a8	9d56cd50-02a7-4276-8301-6cd6d29d89d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 11:49:33
10310	9d56cd50-012b-468f-b2e2-df949eb630bc	9d56cd50-02a7-4276-8301-6cd6d29d89d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-26 11:49:33
31167	9d69466e-a3d0-45e8-ad32-bbe79f511632	9d69466e-aa30-4121-b3e8-b8f6aa23ee2d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":15,"hostname":"EderCortes"}	2024-11-04 16:13:07
31168	9d69466e-a8af-47c9-970d-c6e1aff83638	9d69466e-aa30-4121-b3e8-b8f6aa23ee2d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 16:13:07
31169	9d69466e-a90e-4644-a291-c82dc702aa28	9d69466e-aa30-4121-b3e8-b8f6aa23ee2d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":92,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":15,"loans_valor_prestado":8000009,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"533333.93333333","loans_pago_interes":"133333.48333333","user_alias":"eder.cortes"},"items":[{"id":379,"loans_codigo":92,"itemloans_cuota":"1","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:13:07.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333"},{"id":380,"loans_codigo":92,"itemloans_cuota":"2","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":381,"loans_codigo":92,"itemloans_cuota":"3","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":382,"loans_codigo":92,"itemloans_cuota":"4","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":383,"loans_codigo":92,"itemloans_cuota":"5","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":384,"loans_codigo":92,"itemloans_cuota":"6","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":385,"loans_codigo":92,"itemloans_cuota":"7","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":386,"loans_codigo":92,"itemloans_cuota":"8","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":387,"loans_codigo":92,"itemloans_cuota":"9","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":388,"loans_codigo":92,"itemloans_cuota":"10","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":389,"loans_codigo":92,"itemloans_cuota":"11","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-31 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":390,"loans_codigo":92,"itemloans_cuota":"12","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":391,"loans_codigo":92,"itemloans_cuota":"13","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-16 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":392,"loans_codigo":92,"itemloans_cuota":"14","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":393,"loans_codigo":92,"itemloans_cuota":"15","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:13:07
39735	9d6cb404-c080-4d85-b745-dec5daebd913	9d6cb406-5e83-475b-9f37-73ab2a91f60b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 09:07:02
39736	9d6cb406-29c0-4635-8aa1-7723b34337df	9d6cb406-5e83-475b-9f37-73ab2a91f60b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"59.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 09:07:03
39737	9d6cb406-2a2c-4f68-844d-da0bb47f2591	9d6cb406-5e83-475b-9f37-73ab2a91f60b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 09:07:03
6938	9d52d81e-0dd7-46d0-b862-64b1ec5c0ca3	9d52d81e-3284-432b-bb63-de744ab4bd0c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:36:27
6939	9d52d81e-2bfe-47b0-91d7-13f21c7b780a	9d52d81e-3284-432b-bb63-de744ab4bd0c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:36:27
6940	9d52d81e-2c62-4234-a2e2-891196a5a666	9d52d81e-3284-432b-bb63-de744ab4bd0c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:36:27
6941	9d52d81e-3121-44e2-af4f-08f6264bd0f5	9d52d81e-3284-432b-bb63-de744ab4bd0c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:36:27
6942	9d52d81e-3186-4fd0-8f10-fd3ebb458785	9d52d81e-3284-432b-bb63-de744ab4bd0c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":329,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:36:27
10311	9d56cd50-01d0-49ea-8f8e-78d7d1340682	9d56cd50-02a7-4276-8301-6cd6d29d89d0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":256,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:49:33
31170	9d694693-5f32-48fd-b91b-2fc736070cbc	9d694693-632c-4583-a97e-8aa52c829940	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":159,"memory":20,"hostname":"EderCortes"}	2024-11-04 16:13:31
39738	9d6cb406-5d07-43f8-a41b-8e575816c0f9	9d6cb406-5e83-475b-9f37-73ab2a91f60b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:07:03
14441	9d5d1e2d-7d9c-4907-a2e8-2b616f1b8610	9d5d1e2d-c942-43d6-b556-fbb1c6621e26	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-10-29 15:10:38
14442	9d5d1e2d-bf84-473e-a71f-45cd33ffb465	9d5d1e2d-c942-43d6-b556-fbb1c6621e26	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 55\\n                        ","time":"155.10","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"ff7240abed4441475e0acd0c74a5f6aa","hostname":"EderCortes"}	2024-10-29 15:10:38
14443	9d5d1e2d-c386-4815-ac41-451d6ee8469b	9d5d1e2d-c942-43d6-b556-fbb1c6621e26	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '55' order by \\"item_loans\\".\\"id\\" asc","time":"2.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 15:10:38
14444	9d5d1e2d-c3b6-4633-b483-9e73305e16db	9d5d1e2d-c942-43d6-b556-fbb1c6621e26	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":7,"hostname":"EderCortes"}	2024-10-29 15:10:38
14445	9d5d1e2d-c822-4186-b95c-1eb5bcc658da	9d5d1e2d-c942-43d6-b556-fbb1c6621e26	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":29,"hostname":"EderCortes"}	2024-10-29 15:10:38
14446	9d5d1e2d-c874-4100-bcc5-7d22d738fd5a	9d5d1e2d-c942-43d6-b556-fbb1c6621e26	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/55","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":55,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":7,"loans_valor_prestado":50000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"15-11-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":150,"loans_codigo":55,"itemloans_cuota":"1","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":151,"loans_codigo":55,"itemloans_cuota":"2","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":152,"loans_codigo":55,"itemloans_cuota":"3","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":153,"loans_codigo":55,"itemloans_cuota":"4","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":154,"loans_codigo":55,"itemloans_cuota":"5","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":155,"loans_codigo":55,"itemloans_cuota":"6","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":156,"loans_codigo":55,"itemloans_cuota":"7","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:10:38
6943	9d52d81e-78c5-4f88-b0db-8d6bf18b4ab9	9d52d81e-c34a-47ae-aeb6-ab86596831d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:36:27
6944	9d52d81e-bd03-4ad3-ab36-e95d25fc6ea0	9d52d81e-c34a-47ae-aeb6-ab86596831d8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"157.00","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:36:27
6945	9d52d81e-bd71-4de2-a4ee-da4ab9d6f5ec	9d52d81e-c34a-47ae-aeb6-ab86596831d8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:36:27
6946	9d52d81e-bed2-45e2-a0e8-a1ebf07b40b0	9d52d81e-c34a-47ae-aeb6-ab86596831d8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"1.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:36:27
5674	9d5248d2-629b-43b2-81fb-0c654f626f9a	9d5248d2-9186-49c2-9c9a-66e98f3df8ae	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 05:55:46
5675	9d5248d2-8e10-43a3-99f8-50842140e102	9d5248d2-9186-49c2-9c9a-66e98f3df8ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 05:55:46
5676	9d5248d2-8fd3-4eec-a73d-62384a03fb80	9d5248d2-9186-49c2-9c9a-66e98f3df8ae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":362,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:55:46
6947	9d52d81e-bf00-4904-87e8-c25fd80fc6bf	9d52d81e-c34a-47ae-aeb6-ab86596831d8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:36:27
6948	9d52d81e-c22f-48f6-8bad-a10e236a37bb	9d52d81e-c34a-47ae-aeb6-ab86596831d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:36:27
6949	9d52d81e-c276-49af-9ff3-1406d86ffae2	9d52d81e-c34a-47ae-aeb6-ab86596831d8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":355,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:36:27
10312	9d56cd50-4e65-4257-86b4-4ecadbe7bd22	9d56cd50-68d5-46cc-a041-74045c89f5a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-26 11:49:33
32091	9d695bdb-076c-4a32-9c22-50ab86782e10	9d695bdb-0be0-4dfb-84a8-6ce5d90ce5e9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":231,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:13:02
10218	9d56cb32-46c1-4d59-aee5-6d050e8c9a9a	9d56cb32-6633-4f0a-8c82-ccdbd46f8af2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 11:43:38
10219	9d56cb32-64b8-42ee-afca-5794ea529eb1	9d56cb32-6633-4f0a-8c82-ccdbd46f8af2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 11:43:38
10220	9d56cb32-6559-4fcf-b9a4-284954023ae4	9d56cb32-6633-4f0a-8c82-ccdbd46f8af2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":315,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:43:38
32857	9d69a69d-f8be-439f-9458-dfbf528edc3e	9d69a69d-fce3-47de-8089-6c8ca153c5bb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":168,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:42:04
34835	9d69c033-c925-4b5e-8d70-170bbfaeac8f	9d69c033-ce7d-4a12-b43c-ea66213a7a7b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"147.71","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 21:53:37
34836	9d69c033-ccca-4f86-8aa9-aa7f9d334bd0	9d69c033-ce7d-4a12-b43c-ea66213a7a7b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:53:37
34837	9d69c033-cd49-4881-b3eb-14f6bdd51ecb	9d69c033-ce7d-4a12-b43c-ea66213a7a7b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":338,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:53:37
38461	9d6b64e5-afde-49a7-b9ad-7cd056fe077a	9d6b64e5-b0da-4113-a216-5ad1ea7ab128	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":367,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:29:58
5677	9d5248d3-03a3-4681-b4db-6ead0eb89a96	9d5248d3-2d78-4e1b-a830-3b2c1a013055	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 05:55:46
5678	9d5248d3-2508-48be-8a6e-7655774338fb	9d5248d3-2d78-4e1b-a830-3b2c1a013055	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"50.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":123,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 05:55:46
5679	9d5248d3-2562-4b3f-bc6a-059b4792f9b5	9d5248d3-2d78-4e1b-a830-3b2c1a013055	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 05:55:46
5680	9d5248d3-2bc1-4865-9033-5630529623e2	9d5248d3-2d78-4e1b-a830-3b2c1a013055	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 05:55:46
5681	9d5248d3-2c3d-4dd7-b01d-cfcd8f435a51	9d5248d3-2d78-4e1b-a830-3b2c1a013055	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":366,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:55:46
6950	9d52d820-9704-46a5-b270-717889c6c0bb	9d52d820-de9d-4893-8803-b043692d67fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:36:28
6951	9d52d820-d9af-4449-a455-3dab16cdb82f	9d52d820-de9d-4893-8803-b043692d67fc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"147.36","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:36:29
6952	9d52d820-d9f8-4268-98b6-0b832bd48d1d	9d52d820-de9d-4893-8803-b043692d67fc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:36:29
6953	9d52d820-dd5b-457a-8070-1e6aa6b96877	9d52d820-de9d-4893-8803-b043692d67fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:36:29
6954	9d52d820-dda0-4023-aba2-522a4a65ed9c	9d52d820-de9d-4893-8803-b043692d67fc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:36:29
10221	9d56cb32-b14e-4ce4-9cca-7d4cffae11ce	9d56cb32-cb73-4ed0-a67c-2664afe513b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 11:43:38
10222	9d56cb32-c710-4ce9-a875-a2f4b7757473	9d56cb32-cb73-4ed0-a67c-2664afe513b9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"40.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:43:38
10223	9d56cb32-ca34-44ce-a69c-246a8b0e583e	9d56cb32-cb73-4ed0-a67c-2664afe513b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 11:43:38
10224	9d56cb32-ca95-4905-9d40-f717e0948d4c	9d56cb32-cb73-4ed0-a67c-2664afe513b9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:43:38
5682	9d5248d3-8617-4d4b-99ce-dc2aacb215fc	9d5248d3-d25b-4497-9ae1-c1c3e83f5b0b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 05:55:47
5683	9d5248d3-cc47-490d-8728-e4debf0d16a0	9d5248d3-d25b-4497-9ae1-c1c3e83f5b0b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"148.57","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":123,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 05:55:47
5684	9d5248d3-cc9d-4d05-a74f-e0374d7998f8	9d5248d3-d25b-4497-9ae1-c1c3e83f5b0b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 05:55:47
5685	9d5248d3-d0da-439a-91ba-a3f20cb10862	9d5248d3-d25b-4497-9ae1-c1c3e83f5b0b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 05:55:47
5686	9d5248d3-d12f-4f74-abba-b0f98e32779f	9d5248d3-d25b-4497-9ae1-c1c3e83f5b0b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":396,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:55:47
10225	9d56cb33-f29c-40fa-8afc-fee228195da5	9d56cb34-3a58-4485-8bd6-de8e9e043f9a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 11:43:39
10226	9d56cb34-353c-4db0-83c3-d7b3d616202e	9d56cb34-3a58-4485-8bd6-de8e9e043f9a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"147.72","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:43:39
10227	9d56cb34-35aa-4963-8677-234015476cfb	9d56cb34-3a58-4485-8bd6-de8e9e043f9a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:43:39
10228	9d56cb34-392c-43ea-b2ac-c2b3ce03ddc6	9d56cb34-3a58-4485-8bd6-de8e9e043f9a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 11:43:39
10229	9d56cb34-396e-4324-a777-b872baeafbdb	9d56cb34-3a58-4485-8bd6-de8e9e043f9a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":485,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:43:39
31178	9d694694-311a-45ac-97e2-51719a6b4ef2	9d694694-7fea-47e7-aea7-400721998c94	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 16:13:32
31179	9d694694-757f-42ce-9a71-4b9939fab74f	9d694694-7fea-47e7-aea7-400721998c94	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"161.35","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 16:13:32
31180	9d694694-79bc-4a18-9826-635a6a6a6d0a	9d694694-7fea-47e7-aea7-400721998c94	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '92' order by \\"item_loans\\".\\"id\\" asc","time":"3.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 16:13:32
5687	9d5248d5-e190-417f-87ab-d66573f47797	9d5248d6-2bb1-4506-8e76-b08cbd451be2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 05:55:48
5688	9d5248d6-26bc-4385-8447-ce4b29028bed	9d5248d6-2bb1-4506-8e76-b08cbd451be2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"154.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 05:55:48
5689	9d5248d6-270c-4df4-8721-469105070dd9	9d5248d6-2bb1-4506-8e76-b08cbd451be2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 05:55:48
5690	9d5248d6-2a64-48c8-9d0b-05a6541f4fca	9d5248d6-2bb1-4506-8e76-b08cbd451be2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 05:55:48
5691	9d5248d6-2aac-4352-88ec-a02909a92cdf	9d5248d6-2bb1-4506-8e76-b08cbd451be2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":445,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:55:48
10313	9d56cd50-643d-4b10-9b82-0ab4b700c4a4	9d56cd50-68d5-46cc-a041-74045c89f5a5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"45.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:49:33
10314	9d56cd50-67aa-4762-9347-f11b01906bc8	9d56cd50-68d5-46cc-a041-74045c89f5a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-26 11:49:33
10315	9d56cd50-67fc-4b61-b808-61f3999a6bb7	9d56cd50-68d5-46cc-a041-74045c89f5a5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:49:33
31181	9d694694-79f6-4d8c-a312-fe572f9b8dbe	9d694694-7fea-47e7-aea7-400721998c94	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":15,"hostname":"EderCortes"}	2024-11-04 16:13:32
31182	9d694694-7e50-4489-b562-fbe07adcc379	9d694694-7fea-47e7-aea7-400721998c94	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 16:13:32
31183	9d694694-7ea2-4135-b3b0-7944ec9e5078	9d694694-7fea-47e7-aea7-400721998c94	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":92,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":15,"loans_valor_prestado":8000009,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"533333.93333333","loans_pago_interes":"133333.48333333","user_alias":"eder.cortes"},"items":[{"id":379,"loans_codigo":92,"itemloans_cuota":"1","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:13:07.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333"},{"id":380,"loans_codigo":92,"itemloans_cuota":"2","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":381,"loans_codigo":92,"itemloans_cuota":"3","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":382,"loans_codigo":92,"itemloans_cuota":"4","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":383,"loans_codigo":92,"itemloans_cuota":"5","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":384,"loans_codigo":92,"itemloans_cuota":"6","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":385,"loans_codigo":92,"itemloans_cuota":"7","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":386,"loans_codigo":92,"itemloans_cuota":"8","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":387,"loans_codigo":92,"itemloans_cuota":"9","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":388,"loans_codigo":92,"itemloans_cuota":"10","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":389,"loans_codigo":92,"itemloans_cuota":"11","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-31 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":390,"loans_codigo":92,"itemloans_cuota":"12","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":391,"loans_codigo":92,"itemloans_cuota":"13","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-16 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":392,"loans_codigo":92,"itemloans_cuota":"14","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":393,"loans_codigo":92,"itemloans_cuota":"15","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":375,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:13:32
32858	9d69a69e-7a75-40dc-b96c-ccd0b95857ef	9d69a69e-d4cc-4093-9915-cc542beecbc2	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 20:42:05
10316	9d56cd51-cd7c-4853-a463-a60752cc7b85	9d56cd51-eae5-4cf2-9815-732d9ca5bdc6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-26 11:49:34
10317	9d56cd51-e5e0-4836-9d78-850bfb2f9939	9d56cd51-eae5-4cf2-9815-732d9ca5bdc6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:49:34
10318	9d56cd51-e638-4b59-ab74-8128e7e7414c	9d56cd51-eae5-4cf2-9815-732d9ca5bdc6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:49:34
10319	9d56cd51-e9cd-443b-bbc2-53261c2ddd62	9d56cd51-eae5-4cf2-9815-732d9ca5bdc6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-26 11:49:34
10320	9d56cd51-ea0d-433d-8e3f-d8018f223a65	9d56cd51-eae5-4cf2-9815-732d9ca5bdc6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:49:34
31184	9d6946ab-cefd-444c-b030-b1bc980ecfad	9d6946ab-d23b-4458-9fd3-02b217e294a0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-intereses","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":154,"memory":20,"hostname":"EderCortes"}	2024-11-04 16:13:47
32092	9d695bdc-cf24-43c6-96ac-a76d65c9bab8	9d695bdc-d298-4548-a8bd-6840a8f5bf8c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":216,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:13:03
32859	9d69a69e-ace1-43a9-9f6d-b032a852b6ea	9d69a69e-d4cc-4093-9915-cc542beecbc2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 403 limit 1","time":"2.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":362,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 20:42:05
32860	9d69a69e-ad56-412b-9b6d-85657de52af3	9d69a69e-d4cc-4093-9915-cc542beecbc2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 20:42:05
32861	9d69a69e-ba4b-4257-bc85-1ea2411ac187	9d69a69e-d4cc-4093-9915-cc542beecbc2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 91 limit 1","time":"2.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":363,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 20:42:05
32862	9d69a69e-ba86-4a97-b66e-e1d0bb0c089e	9d69a69e-d4cc-4093-9915-cc542beecbc2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 20:42:05
32863	9d69a69e-c7e2-4a30-8d54-7f2ae7f886d2	9d69a69e-d4cc-4093-9915-cc542beecbc2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"itemloans_aprobador\\" = 12, \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '131250', \\"itemloans_cuota_cancelada\\" = '525000', \\"updated_at\\" = '2024-11-04 20:42:05' where \\"id\\" = 403","time":"3.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":406,"hash":"6acd4a1714feb503cbc85629417266cf","hostname":"EderCortes"}	2024-11-04 20:42:05
32864	9d69a69e-cdb1-4acc-9d89-dc6d82e419f9	9d69a69e-d4cc-4093-9915-cc542beecbc2	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:403","changes":{"itemloans_status":"Pagada","itemloans_aprobador":12,"updated_at":"2024-11-04 20:42:05","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"131250","itemloans_cuota_cancelada":"525000"},"hostname":"EderCortes"}	2024-11-04 20:42:05
32865	9d69a69e-ce93-4e01-86ad-6f3d9f971c6e	9d69a69e-d4cc-4093-9915-cc542beecbc2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 331250, \\"loans_pago_prestado\\" = 1325000, \\"updated_at\\" = '2024-11-04 20:42:05' where \\"id\\" = 91","time":"1.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":414,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 20:42:05
32866	9d69a69e-cecc-4f9f-b5dd-53b0cbcac823	9d69a69e-d4cc-4093-9915-cc542beecbc2	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:91","changes":{"updated_at":"2024-11-04 20:42:05","loans_pago_interes":331250,"loans_pago_prestado":1325000},"hostname":"EderCortes"}	2024-11-04 20:42:05
32867	9d69a69e-d32c-4fee-b8e0-00a700176500	9d69a69e-d4cc-4093-9915-cc542beecbc2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 20:42:05
34838	9d69c038-cd6f-4ae2-947f-d3663b9ef55b	9d69c038-eabc-45d8-a697-9935ae5105eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:53:40
38462	9d6b64e5-fc64-48d8-8f92-550652d0dd01	9d6b64e6-1e6b-4553-9a73-3f6fa9c8ec6e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:29:58
32093	9d695c29-1555-4ce7-880f-457fe6a6e465	9d695c29-1952-4595-910b-7fd8762ad0a0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":465,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:13:53
10400	9d56cf68-6157-4f33-a9b3-ce51cc04ad7c	9d56cf68-b25b-4cc9-a8de-c0544983f855	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 11:55:24
10401	9d56cf68-b080-440d-95d4-12edaa74919e	9d56cf68-b25b-4cc9-a8de-c0544983f855	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:55:24
10402	9d56cf68-b13e-4e25-b1b0-310cab15cbbc	9d56cf68-b25b-4cc9-a8de-c0544983f855	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":375,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:55:24
32868	9d69a69e-d38c-4964-be13-f31370cf7ec6	9d69a69e-d4cc-4093-9915-cc542beecbc2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"180","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"131250","itemloans_cuota_cancelada":"525000","id":403,"loans_codigo":91,"itemloans_cuota":"1","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":390,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:42:05
34839	9d69c038-e3be-438c-93d1-8647b2975bf5	9d69c038-eabc-45d8-a697-9935ae5105eb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 87\\n                        ","time":"43.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"309a6eff5ebe9f2d91248732844dd9ed","hostname":"EderCortes"}	2024-11-04 21:53:40
34840	9d69c038-e681-4205-adf4-47ec8d66a3d9	9d69c038-eabc-45d8-a697-9935ae5105eb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '87' order by \\"item_loans\\".\\"id\\" asc","time":"2.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:53:40
33895	9d69b7fb-9381-46cd-a0c3-b52ae5f53a4c	9d69b7fb-974b-42f1-b9e2-354f6a060e38	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":159,"memory":20,"hostname":"EderCortes"}	2024-11-04 21:30:38
34841	9d69c038-e965-4bdc-aa53-a09140cf43e9	9d69c038-eabc-45d8-a697-9935ae5105eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:53:40
34842	9d69c038-e9b5-4fdf-80c1-75b2f27a0647	9d69c038-eabc-45d8-a697-9935ae5105eb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/87","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":87,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"460000","loans_pago_interes":"115000","user_alias":"eder.cortes"},"items":[{"id":341,"loans_codigo":87,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 20:50:52","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000","user_alias":"eder.cortes"},{"id":342,"loans_codigo":87,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 21:01:12","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":445,"loans_codigo":87,"itemloans_cuota":"3","itemloans_valor_cuota":"160000","itemloans_iteres":"40000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:01:12","updated_at":"2024-11-04 21:01:12","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":446,"loans_codigo":87,"itemloans_cuota":"4","itemloans_valor_cuota":"160000","itemloans_iteres":"40000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:01:12","updated_at":"2024-11-04 21:01:12","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":447,"loans_codigo":87,"itemloans_cuota":"5","itemloans_valor_cuota":"160000","itemloans_iteres":"40000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:01:12","updated_at":"2024-11-04 21:01:12","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":448,"loans_codigo":87,"itemloans_cuota":"6","itemloans_valor_cuota":"160000","itemloans_iteres":"40000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:01:12","updated_at":"2024-11-04 21:01:12","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":311,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:53:40
10403	9d56cf69-0f7d-4a1d-964f-bb2f0414cc0a	9d56cf69-2974-4ca3-8731-ca8fed6f9e9e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:55:25
10404	9d56cf69-24f8-4523-9687-ce35d71cdece	9d56cf69-2974-4ca3-8731-ca8fed6f9e9e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"41.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:55:25
10405	9d56cf69-280a-49ca-84b2-8f2ed6d71cda	9d56cf69-2974-4ca3-8731-ca8fed6f9e9e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:55:25
10406	9d56cf69-285f-4e82-8478-3499ffb6383a	9d56cf69-2974-4ca3-8731-ca8fed6f9e9e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":274,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:55:25
4952	9d513657-8404-4713-96fd-c7016d94d182	9d513657-c1ee-45e8-af9a-1774b8161a68	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-10-23 17:08:16
4953	9d513657-bf11-4f4a-9e71-dc4ca84d35ab	9d513657-c1ee-45e8-af9a-1774b8161a68	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-10-23 17:08:16
4954	9d513657-c084-458d-b1be-3219bd9ff449	9d513657-c1ee-45e8-af9a-1774b8161a68	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":781,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:16
31192	9d6946ac-a12b-480d-bd36-4ad0877b2c93	9d6946ac-c08b-4047-b4af-9006095c79d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 16:13:48
31193	9d6946ac-b66d-4160-8e2f-343af0c45427	9d6946ac-c08b-4047-b4af-9006095c79d1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"41.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 16:13:48
10478	9d56f8d5-f938-4afc-8688-1398d0e6fcad	9d56f8d7-2904-454a-8189-595461e574ec	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 13:51:15
10479	9d56f8d7-23c1-44b9-8c94-8acec7e7adb8	9d56f8d7-2904-454a-8189-595461e574ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 13:51:15
10480	9d56f8d7-2644-490a-8e44-58749f7c8a3a	9d56f8d7-2904-454a-8189-595461e574ec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":2476,"memory":22,"hostname":"EderCortes"}	2024-10-26 13:51:15
31194	9d6946ac-ba38-42b6-9a72-3983ef327869	9d6946ac-c08b-4047-b4af-9006095c79d1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '92' order by \\"item_loans\\".\\"id\\" asc","time":"2.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 16:13:48
31195	9d6946ac-ba74-41ab-bb1a-c3a26dfe4b09	9d6946ac-c08b-4047-b4af-9006095c79d1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":15,"hostname":"EderCortes"}	2024-11-04 16:13:48
31196	9d6946ac-bf2b-423c-9280-2658f354344d	9d6946ac-c08b-4047-b4af-9006095c79d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 16:13:48
32094	9d695c29-dc06-4a32-ba0d-9d94aaae489f	9d695c2a-44b1-486f-b682-849d1972245d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 17:13:53
32869	9d69a69f-34ba-41f2-bf44-e4494f8d3189	9d69a69f-7cb1-470d-b578-20bc22e79253	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 20:42:05
34843	9d69c04e-3261-4088-92a3-550374bede1c	9d69c04e-78e8-464a-8cdf-64c5c46afada	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:53:54
10407	9d56cf6a-a006-429e-af48-6d4636c826ef	9d56cf6a-e831-4953-a8f9-5c4eaaf165b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:55:26
4823	9d513596-7f22-46d4-a6d4-534ea5401270	9d513596-a702-484a-8613-43532f48531b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 17:06:09
4824	9d513596-a529-420e-8b99-3731d86f73d5	9d513596-a702-484a-8613-43532f48531b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 17:06:09
4825	9d513596-a605-411b-b083-a96da2cd450c	9d513596-a702-484a-8613-43532f48531b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:06:09
10408	9d56cf6a-e2ae-4dfe-b83f-5830aa0d7449	9d56cf6a-e831-4953-a8f9-5c4eaaf165b5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"150.62","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:55:26
4955	9d513658-674a-4a00-bd22-75c20bb1d7ce	9d513658-aa09-4d0b-9a4a-4b13992dfa6e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-10-23 17:08:16
4956	9d513658-9f8a-4cab-813b-bf2fe94cc25d	9d513658-aa09-4d0b-9a4a-4b13992dfa6e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"95.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:08:16
10409	9d56cf6a-e2f8-4ce2-8be2-44bf363ecc84	9d56cf6a-e831-4953-a8f9-5c4eaaf165b5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:55:26
4957	9d513658-a017-44db-ba43-e0092c576da4	9d513658-aa09-4d0b-9a4a-4b13992dfa6e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:08:16
4958	9d513658-a7d4-41c9-a207-fbae055b9f23	9d513658-aa09-4d0b-9a4a-4b13992dfa6e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-10-23 17:08:16
4959	9d513658-a860-4d58-9382-12ea006f5721	9d513658-aa09-4d0b-9a4a-4b13992dfa6e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":553,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:16
10410	9d56cf6a-e6cb-454e-8ac0-b2cd92c91255	9d56cf6a-e831-4953-a8f9-5c4eaaf165b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 11:55:26
10411	9d56cf6a-e716-450e-a2e1-e6bc2382abb8	9d56cf6a-e831-4953-a8f9-5c4eaaf165b5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:55:26
10481	9d56f8d8-bfcd-4737-851b-1da289d7cab5	9d56f8d9-1b59-4a65-8eb2-3316252b81dc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 13:51:17
10482	9d56f8d9-0f18-45e2-a5db-62b3edb05019	9d56f8d9-1b59-4a65-8eb2-3316252b81dc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"115.69","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 13:51:17
10483	9d56f8d9-18ff-451c-8775-53525977aae4	9d56f8d9-1b59-4a65-8eb2-3316252b81dc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 13:51:17
38463	9d6b64e6-1867-4ad8-9a37-c1b2507a5ee5	9d6b64e6-1e6b-4553-9a73-3f6fa9c8ec6e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:29:58
38464	9d6b64e6-18cb-4933-aec8-0e2c3d86a005	9d6b64e6-1e6b-4553-9a73-3f6fa9c8ec6e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:29:58
4826	9d513597-0292-41d5-bfef-d927233717e1	9d513597-207b-4a93-877f-df2c126cd2a3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 17:06:10
4827	9d513597-1b80-497d-b952-77bfb9e75b5a	9d513597-207b-4a93-877f-df2c126cd2a3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:06:10
4828	9d513597-1bce-424d-bc65-4bacef7da9ef	9d513597-207b-4a93-877f-df2c126cd2a3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:06:10
4829	9d513597-1f4b-4c62-9007-f8fb23dc3fab	9d513597-207b-4a93-877f-df2c126cd2a3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 17:06:10
4436	9d513000-dea5-4431-8644-3d2808a495fb	9d513001-09d2-4ac2-954c-d4c862bc5555	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 16:50:32
4437	9d513001-0749-456f-b6dc-ebe4a147c88b	9d513001-09d2-4ac2-954c-d4c862bc5555	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 16:50:32
4438	9d513001-087d-4040-bbfa-41f6262ec2ec	9d513001-09d2-4ac2-954c-d4c862bc5555	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":400,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:50:32
4830	9d513597-1f8f-4a25-aa9c-a76f11ef8091	9d513597-207b-4a93-877f-df2c126cd2a3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":282,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:06:10
4960	9d513659-3789-4283-b8fe-2e3302cbf9a9	9d513659-9b55-4d30-9942-1d510c134479	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-10-23 17:08:17
4961	9d513659-8c95-4db6-bb3e-44a244849a5a	9d513659-9b55-4d30-9942-1d510c134479	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"179.03","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:08:17
4962	9d513659-8d5d-4748-8d6e-bae0d5581552	9d513659-9b55-4d30-9942-1d510c134479	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:08:17
4963	9d513659-96bf-43ab-adbe-fd4cb9ff6746	9d513659-9b55-4d30-9942-1d510c134479	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-10-23 17:08:17
4964	9d513659-97a5-44d1-8959-e9607b755b44	9d513659-9b55-4d30-9942-1d510c134479	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":588,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:17
10484	9d56f8d9-1996-4b34-9b87-4a16fe3bf620	9d56f8d9-1b59-4a65-8eb2-3316252b81dc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":1209,"memory":22,"hostname":"EderCortes"}	2024-10-26 13:51:17
32095	9d695c2a-3d52-4537-9b20-30b4dbc148ed	9d695c2a-44b1-486f-b682-849d1972245d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"profile_code\\", \\"user_age\\", \\"user_alias\\", \\"verified\\", \\"password\\", \\"verification_token\\", \\"updated_at\\", \\"created_at\\") values ('Juan Carlos', 'juan@gmail.com', 'Jaramillo', 'Herrera', 'CC', '100458955', '2024-11-11T05:00:00.000Z', 'Cali', 'Manuela', 'Calle 108', '3152596298', 4, '28', 'juan_jaramillo', 0, 'y$a7LCQWtNh\\/tMulsmsgMJMOHkAx4ipb0ibJmR1fI8\\/luAAOGyehQJ2', 'OASgsQcnrw0dBDswOfNl3Yy5U5X06zKKyrZmcqKiUPUEmR4ZibJcyRiB6Nu1', '2024-11-04 17:13:53', '2024-11-04 17:13:53') returning \\"id\\"","time":"11.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":51,"hash":"5f56d84441166dbc5ad3d6166e5b57be","hostname":"EderCortes"}	2024-11-04 17:13:53
32096	9d695c2a-3dfd-4ea6-81c9-7ce92f792d1c	9d695c2a-44b1-486f-b682-849d1972245d	\N	t	model	{"action":"created","model":"App\\\\Models\\\\User:22","hostname":"EderCortes"}	2024-11-04 17:13:53
32097	9d695c2a-4347-43c7-b83f-aef820a0b0b4	9d695c2a-44b1-486f-b682-849d1972245d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 17:13:54
38465	9d6b64e6-1d12-4612-9f79-7dccb749bf60	9d6b64e6-1e6b-4553-9a73-3f6fa9c8ec6e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:29:58
4439	9d513001-736e-4f69-95fe-d3bb07f96259	9d513001-c56c-4c34-be27-81d01de4a490	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 16:50:33
4440	9d513001-bf07-4257-932e-b442ce0e5b5f	9d513001-c56c-4c34-be27-81d01de4a490	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"164.75","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:50:33
4441	9d513001-bf6e-46eb-98db-cdb2bfe611c6	9d513001-c56c-4c34-be27-81d01de4a490	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 16:50:33
4442	9d513001-c437-4e21-982c-b8d13fbf2a69	9d513001-c56c-4c34-be27-81d01de4a490	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 16:50:33
4443	9d513001-c481-4bc7-8bd9-6d68d4b6dfc3	9d513001-c56c-4c34-be27-81d01de4a490	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":448,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:50:33
4831	9d513597-648d-48e3-ac1b-c702ba614706	9d513597-878f-446c-ad52-c55a465132fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 17:06:10
4832	9d513597-81d8-4648-83c1-8d496bbdb17a	9d513597-878f-446c-ad52-c55a465132fd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:06:10
4833	9d513597-8238-4133-bfc9-63b4b4eba572	9d513597-878f-446c-ad52-c55a465132fd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:06:10
4834	9d513597-85ec-42ae-9784-825d4952bf8f	9d513597-878f-446c-ad52-c55a465132fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 17:06:10
4835	9d513597-865c-4b56-b1a6-30794336b497	9d513597-878f-446c-ad52-c55a465132fd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:06:10
4965	9d51365a-3f15-4cf9-9ace-046bcfa38c57	9d51365a-aa0b-4907-a57f-97b3c3f994b7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-10-23 17:08:17
4966	9d51365a-a06a-4883-a914-01ff5171fa8e	9d51365a-aa0b-4907-a57f-97b3c3f994b7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"86.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:08:18
4967	9d51365a-a0eb-4b30-a3ed-f6ad06881b32	9d51365a-aa0b-4907-a57f-97b3c3f994b7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:08:18
4968	9d51365a-a81d-4497-9cda-6943985d9329	9d51365a-aa0b-4907-a57f-97b3c3f994b7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-10-23 17:08:18
4969	9d51365a-a8a5-4c5a-832c-aa7c87c65fae	9d51365a-aa0b-4907-a57f-97b3c3f994b7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":655,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:18
10485	9d56f8db-ab1a-4650-badb-9370b4de52e8	9d56f8db-eb70-4f42-96a3-03bf1f634ba2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 13:51:18
4444	9d513002-19db-461c-b955-886cb00aae9b	9d513002-679a-428c-895b-38defc39969c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 16:50:33
4445	9d513002-6015-460a-b852-29fa5b5c977d	9d513002-679a-428c-895b-38defc39969c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"154.25","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:50:33
4446	9d513002-6081-4c5e-896f-059911c5a290	9d513002-679a-428c-895b-38defc39969c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 16:50:33
4447	9d513002-661d-409b-b657-7579f2b286cc	9d513002-679a-428c-895b-38defc39969c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 16:50:33
4448	9d513002-667c-4f87-8b93-29e78ef10e71	9d513002-679a-428c-895b-38defc39969c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":398,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:50:33
4836	9d513599-410a-416f-8d1c-646cb84de910	9d513599-863c-497e-abb3-ac7e35d68be4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 17:06:11
4837	9d513599-816f-4ba9-9e1e-e2f09600567a	9d513599-863c-497e-abb3-ac7e35d68be4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"146.46","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:06:11
4838	9d513599-81c7-4185-899e-951e231829c0	9d513599-863c-497e-abb3-ac7e35d68be4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:06:11
4839	9d513599-84ee-4d08-8ecb-ee38a388747a	9d513599-863c-497e-abb3-ac7e35d68be4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 17:06:11
4840	9d513599-8533-4721-8362-8a3eab4aacb2	9d513599-863c-497e-abb3-ac7e35d68be4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":323,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:06:11
10486	9d56f8db-dd3e-4c53-9f0b-69841fab7696	9d56f8db-eb70-4f42-96a3-03bf1f634ba2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"75.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 13:51:19
10487	9d56f8db-de0b-4466-b6fb-6aaa1285b4f6	9d56f8db-eb70-4f42-96a3-03bf1f634ba2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 13:51:19
10488	9d56f8db-e8a4-4b88-a075-4968c7d03891	9d56f8db-eb70-4f42-96a3-03bf1f634ba2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 13:51:19
10489	9d56f8db-e95a-45a5-b84d-8edc8d746f7f	9d56f8db-eb70-4f42-96a3-03bf1f634ba2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":610,"memory":22,"hostname":"EderCortes"}	2024-10-26 13:51:19
4841	9d5135a0-47e5-4ff1-a15e-3eb01ae37094	9d5135a0-4b34-4178-8975-712430a9f3e6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":141,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:06:16
31197	9d6946ac-bf85-4030-8528-34518b759754	9d6946ac-c08b-4047-b4af-9006095c79d1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":92,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":15,"loans_valor_prestado":8000009,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"533333.93333333","loans_pago_interes":"133333.48333333","user_alias":"eder.cortes"},"items":[{"id":379,"loans_codigo":92,"itemloans_cuota":"1","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:13:07.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333"},{"id":380,"loans_codigo":92,"itemloans_cuota":"2","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":381,"loans_codigo":92,"itemloans_cuota":"3","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":382,"loans_codigo":92,"itemloans_cuota":"4","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":383,"loans_codigo":92,"itemloans_cuota":"5","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":384,"loans_codigo":92,"itemloans_cuota":"6","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":385,"loans_codigo":92,"itemloans_cuota":"7","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":386,"loans_codigo":92,"itemloans_cuota":"8","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":387,"loans_codigo":92,"itemloans_cuota":"9","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":388,"loans_codigo":92,"itemloans_cuota":"10","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":389,"loans_codigo":92,"itemloans_cuota":"11","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-31 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":390,"loans_codigo":92,"itemloans_cuota":"12","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":391,"loans_codigo":92,"itemloans_cuota":"13","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-16 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":392,"loans_codigo":92,"itemloans_cuota":"14","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":393,"loans_codigo":92,"itemloans_cuota":"15","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:13:48
10556	9d571057-efb3-4e7f-bbd7-99ac4298b3f2	9d571058-1532-47d1-a171-906ba891412b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 14:56:59
10557	9d571058-12db-4fa6-8bf2-e83c7c4d2628	9d571058-1532-47d1-a171-906ba891412b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 14:56:59
10558	9d571058-13ce-4310-80ae-ad4044372509	9d571058-1532-47d1-a171-906ba891412b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":278,"memory":22,"hostname":"EderCortes"}	2024-10-26 14:56:59
32098	9d695c2a-4398-45d4-ae22-1e2f7ebf5557	9d695c2a-44b1-486f-b682-849d1972245d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"467","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"id":null,"name":"Juan Carlos","email":"juan@gmail.com","user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","profile_code":4,"user_age":"28","user_alias":"juan_jaramillo","email_verified_at":null,"verified":0,"created_at":null,"updated_at":null,"deleted_at":null,"password":"********","verification_token":"OASgsQcnrw0dBDswOfNl3Yy5U5X06zKKyrZmcqKiUPUEmR4ZibJcyRiB6Nu1"},"session":[],"response_status":200,"response":{"response":"El registro fue creado exitosamente"},"duration":455,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:13:54
32870	9d69a69f-74c1-4fab-903e-c2fbe845cbd2	9d69a69f-7cb1-470d-b578-20bc22e79253	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 91\\n                        ","time":"150.06","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"9ae30bc69b6b272f3f51ff48e54319f5","hostname":"EderCortes"}	2024-11-04 20:42:05
32871	9d69a69f-77bc-4771-97de-8c3b246fa122	9d69a69f-7cb1-470d-b578-20bc22e79253	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '91' order by \\"item_loans\\".\\"id\\" asc","time":"2.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 20:42:05
32872	9d69a69f-7b25-4a49-a352-b1687d52742e	9d69a69f-7cb1-470d-b578-20bc22e79253	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 20:42:05
10559	9d571058-7055-4d26-9688-0b37bfe419b5	9d571058-9a18-41f9-9904-0028e3d1438f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 14:56:59
4031	9d511cc8-3738-43cd-98b2-2ccddacbd28d	9d511cc8-8cfb-43e5-a997-2362d0f2ec4d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 15:56:47
4032	9d511cc8-8b26-4c85-beee-4fd911db9986	9d511cc8-8cfb-43e5-a997-2362d0f2ec4d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 15:56:48
4033	9d511cc8-8bf1-4563-8416-dbd67c3d5443	9d511cc8-8cfb-43e5-a997-2362d0f2ec4d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":474,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:56:48
10560	9d571058-85fc-4bbc-84da-81755ac03430	9d571058-9a18-41f9-9904-0028e3d1438f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"42.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 14:56:59
10561	9d571058-93b6-42c5-a0db-19d4e912cd87	9d571058-9a18-41f9-9904-0028e3d1438f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '5' order by \\"item_loans\\".\\"id\\" asc","time":"2.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-26 14:56:59
10562	9d571058-93e7-412b-83f2-ee44584e04ae	9d571058-9a18-41f9-9904-0028e3d1438f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-26 14:56:59
10563	9d571058-98fa-48fb-ad2e-82681a27e9ea	9d571058-9a18-41f9-9904-0028e3d1438f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 14:56:59
10564	9d571058-993f-43e2-bbb5-9053f91212b8	9d571058-9a18-41f9-9904-0028e3d1438f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"item":[{"id":25,"loans_codigo":5,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":26,"loans_codigo":5,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":27,"loans_codigo":5,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":28,"loans_codigo":5,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":29,"loans_codigo":5,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":30,"loans_codigo":5,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null}]},"duration":305,"memory":22,"hostname":"EderCortes"}	2024-10-26 14:56:59
4842	9d5135a0-fdef-41d0-a001-760b0b9400a2	9d5135a1-1b93-4903-be0a-070a270c10fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 17:06:16
32099	9d695c2a-95be-42d0-a362-9eff9b5bd3cf	9d695c2a-9a23-4af6-99ed-62000a7da6d4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":185,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:13:54
32873	9d69a69f-7b9d-4be2-9947-f61f9dcd45e9	9d69a69f-7cb1-470d-b578-20bc22e79253	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/91","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":91,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":8,"loans_valor_prestado":5000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1325000","loans_pago_interes":"331250","user_alias":"eder.cortes"},"items":[{"id":371,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 17:44:55","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"200000","itemloans_cuota_cancelada":"800000","user_alias":"eder.cortes"},{"id":403,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 20:42:05","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"131250","itemloans_cuota_cancelada":"525000","user_alias":"eder.cortes"},{"id":404,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":405,"loans_codigo":91,"itemloans_cuota":"3","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":406,"loans_codigo":91,"itemloans_cuota":"4","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":407,"loans_codigo":91,"itemloans_cuota":"5","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":408,"loans_codigo":91,"itemloans_cuota":"6","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":409,"loans_codigo":91,"itemloans_cuota":"7","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":410,"loans_codigo":91,"itemloans_cuota":"8","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-03-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":401,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:42:05
41456	9d6ccc9b-2eb3-49b8-97ae-403bacffce15	9d6ccc9b-3217-4483-bc02-84b794a8e3e6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":151,"memory":20,"hostname":"EderCortes"}	2024-11-06 10:15:47
4034	9d511cc8-eb8c-4098-b700-f5a19d27a375	9d511cc9-325a-4bb3-b89b-5bb348a3dbac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 15:56:48
4035	9d511cc9-2cd3-4f08-a142-0917c9449409	9d511cc9-325a-4bb3-b89b-5bb348a3dbac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"144.00","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:56:48
4036	9d511cc9-2d4e-4bbb-b551-7b7bfa52db28	9d511cc9-325a-4bb3-b89b-5bb348a3dbac	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 15:56:48
4037	9d511cc9-313c-4b6a-b236-af7ca3b85b2c	9d511cc9-325a-4bb3-b89b-5bb348a3dbac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 15:56:48
4038	9d511cc9-318e-4353-ba65-db8977a9bb3a	9d511cc9-325a-4bb3-b89b-5bb348a3dbac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":396,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:56:48
4843	9d5135a1-1742-470b-ab01-995be49ba78e	9d5135a1-1b93-4903-be0a-070a270c10fe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"48.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":46,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 17:06:16
4844	9d5135a1-1a3f-44cc-a567-b89d5db032ab	9d5135a1-1b93-4903-be0a-070a270c10fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 17:06:16
4845	9d5135a1-1a88-4292-b3b0-686517649886	9d5135a1-1b93-4903-be0a-070a270c10fe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:06:16
10565	9d57105a-2ef6-4a1a-b01e-5887bd51d311	9d57105a-4f00-42b1-a955-6f0461cfd733	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 14:57:00
10566	9d57105a-4710-419a-a947-c567cdc939b0	9d57105a-4f00-42b1-a955-6f0461cfd733	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 14:57:00
10567	9d57105a-4759-43a3-953a-64562c8166e3	9d57105a-4f00-42b1-a955-6f0461cfd733	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 14:57:00
10568	9d57105a-4cda-49de-ba8f-f8c6ce18eddc	9d57105a-4f00-42b1-a955-6f0461cfd733	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 14:57:00
10569	9d57105a-4d62-44a9-93df-cc74ec1b15ac	9d57105a-4f00-42b1-a955-6f0461cfd733	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":261,"memory":22,"hostname":"EderCortes"}	2024-10-26 14:57:00
32874	9d69a6b1-5417-4782-8d89-89306d1bf452	9d69a6b1-58ad-4cd7-b9f9-196f57898d15	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":154,"memory":20,"hostname":"EderCortes"}	2024-11-04 20:42:17
41457	9d6ccc9b-b13a-4f46-a75c-a30107960191	9d6ccc9b-faea-4b8e-a586-66ac5e1fc351	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 10:15:47
34844	9d69c04e-744d-47ea-920b-89d1cb28b021	9d69c04e-78e8-464a-8cdf-64c5c46afada	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"152.79","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 21:53:54
32875	9d69a6b1-c598-4177-a6b3-6476ef989947	9d69a6b2-1c1f-42ec-88a6-bf91b40b7462	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 20:42:17
3585	9d5108e9-1c9d-4d59-884f-7d228de891a0	9d5108e9-5496-44df-b912-5c3d13f811df	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 15:01:14
3586	9d5108e9-5288-4d91-b80e-08471ce5bf5c	9d5108e9-5496-44df-b912-5c3d13f811df	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 15:01:14
3587	9d5108e9-5375-4213-8cdb-599aa5712888	9d5108e9-5496-44df-b912-5c3d13f811df	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":507,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:01:14
34845	9d69c04e-7772-4845-b3d3-2e18d0f4be54	9d69c04e-78e8-464a-8cdf-64c5c46afada	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:53:54
34846	9d69c04e-77ed-4c86-b577-e95f6b24664d	9d69c04e-78e8-464a-8cdf-64c5c46afada	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":344,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:53:54
35359	9d69c404-c594-4030-b297-909d0419455f	9d69c404-c770-4e61-a5cd-90eaf722e29b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":603,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:04:17
32876	9d69a6b2-0897-425a-9f7d-349d0f7dd071	9d69a6b2-1c1f-42ec-88a6-bf91b40b7462	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 91 limit 1","time":"3.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":505,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 20:42:18
32877	9d69a6b2-0900-4cc4-b6a5-34aec7a621ae	9d69a6b2-1c1f-42ec-88a6-bf91b40b7462	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":2,"hostname":"EderCortes"}	2024-11-04 20:42:18
32878	9d69a6b2-0b6a-4ae2-a9b3-f5ae936c5c21	9d69a6b2-1c1f-42ec-88a6-bf91b40b7462	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select count(*) as aggregate from \\"item_loans\\" where \\"loans_codigo\\" = 91 and \\"itemloans_status\\" = 'Pagada'","time":"2.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":563,"hash":"60bd91eaa209a639fc2e8afc20430a4b","hostname":"EderCortes"}	2024-11-04 20:42:18
32879	9d69a6b2-0c66-4d37-8a95-12da27f2dbd1	9d69a6b2-1c1f-42ec-88a6-bf91b40b7462	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 431250, \\"loans_pago_prestado\\" = 1725000, \\"updated_at\\" = '2024-11-04 20:42:18' where \\"id\\" = 91","time":"1.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":602,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 20:42:18
32880	9d69a6b2-0ce1-4131-a81f-675af8f14628	9d69a6b2-1c1f-42ec-88a6-bf91b40b7462	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:91","changes":{"updated_at":"2024-11-04 20:42:18","loans_pago_interes":431250,"loans_pago_prestado":1725000},"hostname":"EderCortes"}	2024-11-04 20:42:18
32881	9d69a6b2-0daa-473d-99ed-ad5c0ada9943	9d69a6b2-1c1f-42ec-88a6-bf91b40b7462	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 91 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"0.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":609,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 20:42:18
32882	9d69a6b2-0ddf-48a2-919e-0ff7ef8926dc	9d69a6b2-1c1f-42ec-88a6-bf91b40b7462	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 20:42:18
32883	9d69a6b2-0f27-400e-bdce-2311e84769aa	9d69a6b2-1c1f-42ec-88a6-bf91b40b7462	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Abono', \\"itemloans_aprobador\\" = 12, \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = 100000, \\"itemloans_cuota_cancelada\\" = 400000, \\"updated_at\\" = '2024-11-04 20:42:18' where \\"id\\" = 404","time":"2.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":617,"hash":"6acd4a1714feb503cbc85629417266cf","hostname":"EderCortes"}	2024-11-04 20:42:18
32884	9d69a6b2-0f61-41db-9bcf-b6136cf82af6	9d69a6b2-1c1f-42ec-88a6-bf91b40b7462	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:404","changes":{"itemloans_status":"Abono","itemloans_aprobador":12,"updated_at":"2024-11-04 20:42:18","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":100000,"itemloans_cuota_cancelada":400000},"hostname":"EderCortes"}	2024-11-04 20:42:18
40141	9d6cc121-4720-4eaa-82d4-4bc193e6f30e	9d6cc121-4b7e-42fb-b2a7-dd800e870164	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"47.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 09:43:42
4039	9d511cc9-7c3d-42cd-b2de-5ce40f81c6dd	9d511cc9-9a1a-4a7c-a232-da6e152afca2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 15:56:48
4040	9d511cc9-950c-41c4-b04b-5f3a874fdd05	9d511cc9-9a1a-4a7c-a232-da6e152afca2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:56:48
4041	9d511cc9-9587-4e0f-82c9-d7615190bb17	9d511cc9-9a1a-4a7c-a232-da6e152afca2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 15:56:48
4042	9d511cc9-98fb-4467-a4c8-2bc1c05a383d	9d511cc9-9a1a-4a7c-a232-da6e152afca2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 15:56:48
4043	9d511cc9-993e-4c29-ae41-805883a30547	9d511cc9-9a1a-4a7c-a232-da6e152afca2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:56:48
4846	9d5135a3-b5df-4a3d-adc3-10cf1a52e936	9d5135a3-d7a4-4793-abb6-7c1024dd170a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 17:06:18
4847	9d5135a3-d27e-4070-a997-b58798ae935f	9d5135a3-d7a4-4793-abb6-7c1024dd170a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null","time":"46.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":28,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-23 17:06:18
4848	9d5135a3-d2cb-4bba-82b7-b3dc864f54eb	9d5135a3-d7a4-4793-abb6-7c1024dd170a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:06:18
4849	9d5135a3-d645-4bdb-b148-8ae755150fd4	9d5135a3-d7a4-4793-abb6-7c1024dd170a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 17:06:18
4850	9d5135a3-d685-4a22-af4c-8e2010c33188	9d5135a3-d7a4-4793-abb6-7c1024dd170a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null}},"duration":263,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:06:18
35360	9d69c405-fad1-4ad2-8452-1d7303cec53e	9d69c406-2859-4c33-a675-977cce7f9e84	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-11-04 22:04:18
5139	9d51367c-43c2-4ae2-b86c-922206009b47	9d51367c-71cd-4dbb-b26e-67616f36c09b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-23 17:08:40
5140	9d51367c-67d4-4fde-bdff-ba0cc0cd366f	9d51367c-71cd-4dbb-b26e-67616f36c09b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"63.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:08:40
5141	9d51367c-684b-425b-a91d-9e282f3e1e95	9d51367c-71cd-4dbb-b26e-67616f36c09b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:08:40
5142	9d51367c-6f71-4620-9f81-bf6dd6a0fa8f	9d51367c-71cd-4dbb-b26e-67616f36c09b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-23 17:08:40
5143	9d51367c-7022-4e5f-acc5-9bc0d0e9f3a8	9d51367c-71cd-4dbb-b26e-67616f36c09b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":387,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:40
32885	9d69a6b2-0fc6-42e4-82a8-e5bd6e3ee394	9d69a6b2-1c1f-42ec-88a6-bf91b40b7462	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"delete from \\"item_loans\\" where \\"loans_codigo\\" = 91 and \\"itemloans_status\\" = 'Pendiente'","time":"0.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":624,"hash":"89bf3c496a8b0746ff5d1219b8dc29e3","hostname":"EderCortes"}	2024-11-04 20:42:18
32886	9d69a6b2-1034-48ee-b2da-6d14484e86e1	9d69a6b2-1c1f-42ec-88a6-bf91b40b7462	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 91 limit 1","time":"0.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":627,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 20:42:18
35361	9d69c406-1f2d-40f5-9451-c897b679761d	9d69c406-2859-4c33-a675-977cce7f9e84	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"59.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:04:18
10646	9d5712dc-fc7e-4011-943b-759c65f94209	9d5712dd-4b83-4c1c-8f1b-56cb71b4d74c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 15:04:01
5144	9d51367c-de35-4427-919b-5f3a0ea7828b	9d51367d-0bc2-45c7-8ab6-8cef6161e059	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-23 17:08:40
5145	9d51367d-04ee-40a3-b5a3-7b693274fb3f	9d51367d-0bc2-45c7-8ab6-8cef6161e059	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"62.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:08:40
5146	9d51367d-055d-4afa-94fe-81a8c0fc120d	9d51367d-0bc2-45c7-8ab6-8cef6161e059	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:08:40
5147	9d51367d-0a02-4899-815e-a43c9344b7bf	9d51367d-0bc2-45c7-8ab6-8cef6161e059	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-23 17:08:40
5148	9d51367d-0a80-4112-a7ae-972d95846dd5	9d51367d-0bc2-45c7-8ab6-8cef6161e059	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":374,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:40
10647	9d5712dd-48c4-4a6f-b908-4884a35f63ce	9d5712dd-4b83-4c1c-8f1b-56cb71b4d74c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 15:04:02
32887	9d69a6b2-1102-44fa-9c15-10bf9d17d347	9d69a6b2-1c1f-42ec-88a6-bf91b40b7462	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 2, 467857.14285714, 116964.28571429, 'Pendiente', 'Se realiza abono', '20-11-2024', 0, 0, '2024-11-04 20:42:18', '2024-11-04 20:42:18')","time":"0.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:42:18
35362	9d69c406-1fb4-4d1c-9f89-816b78da4c5a	9d69c406-2859-4c33-a675-977cce7f9e84	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:04:18
32888	9d69a6b2-1135-489a-ad5a-33f9cef7822c	9d69a6b2-1c1f-42ec-88a6-bf91b40b7462	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:42:18
32889	9d69a6b2-11cc-4db8-b353-bfe9df11044c	9d69a6b2-1c1f-42ec-88a6-bf91b40b7462	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 3, 467857.14285714, 116964.28571429, 'Pendiente', 'Se realiza abono', '06-12-2024', 0, 0, '2024-11-04 20:42:18', '2024-11-04 20:42:18')","time":"0.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:42:18
32890	9d69a6b2-1200-4529-a46b-8c044505f08d	9d69a6b2-1c1f-42ec-88a6-bf91b40b7462	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:42:18
32891	9d69a6b2-1287-4135-b1ff-54de807738dc	9d69a6b2-1c1f-42ec-88a6-bf91b40b7462	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 4, 467857.14285714, 116964.28571429, 'Pendiente', 'Se realiza abono', '22-12-2024', 0, 0, '2024-11-04 20:42:18', '2024-11-04 20:42:18')","time":"0.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:42:18
35363	9d69c406-262b-4392-baf2-4c7de778df5c	9d69c406-2859-4c33-a675-977cce7f9e84	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-11-04 22:04:18
40142	9d6cc121-49da-4da6-b087-f780d16504d1	9d6cc121-4b7e-42fb-b2a7-dd800e870164	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 09:43:42
41458	9d6ccc9b-f558-47c0-95b4-1f0e7feafacf	9d6ccc9b-faea-4b8e-a586-66ac5e1fc351	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"151.04","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:15:48
41459	9d6ccc9b-f5a6-4d18-a28a-f107c8611e61	9d6ccc9b-faea-4b8e-a586-66ac5e1fc351	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:15:48
41460	9d6ccc9b-f9b0-490e-9448-97b58583a5b1	9d6ccc9b-faea-4b8e-a586-66ac5e1fc351	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 10:15:48
10648	9d5712dd-4a52-483e-b90b-9b52390c7213	9d5712dd-4b83-4c1c-8f1b-56cb71b4d74c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":450,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:04:02
32892	9d69a6b2-12b5-4d60-9bc3-0fea37a5c6f5	9d69a6b2-1c1f-42ec-88a6-bf91b40b7462	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:42:18
32893	9d69a6b2-133b-4e42-894f-723a2a74ddf1	9d69a6b2-1c1f-42ec-88a6-bf91b40b7462	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 5, 467857.14285714, 116964.28571429, 'Pendiente', 'Se realiza abono', '07-01-2025', 0, 0, '2024-11-04 20:42:18', '2024-11-04 20:42:18')","time":"0.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:42:18
32894	9d69a6b2-1372-4c49-a42a-6811049bb15b	9d69a6b2-1c1f-42ec-88a6-bf91b40b7462	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:42:18
5149	9d51367d-7bff-457d-a578-00e5f59dc76a	9d51367d-a0a8-48ef-ab42-25dd10ff3545	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-23 17:08:41
5150	9d51367d-9990-4d28-a6ab-a61520bff252	9d51367d-a0a8-48ef-ab42-25dd10ff3545	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"50.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:08:41
5151	9d51367d-9a0e-4ca4-af10-7992c0d3ecee	9d51367d-a0a8-48ef-ab42-25dd10ff3545	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:08:41
5152	9d51367d-9f1c-4eff-96de-7b544622b7d6	9d51367d-a0a8-48ef-ab42-25dd10ff3545	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-23 17:08:41
5153	9d51367d-9f93-4159-aba3-686d713d592a	9d51367d-a0a8-48ef-ab42-25dd10ff3545	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":365,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:41
32895	9d69a6b2-141c-49a5-86c4-dcf2b1db5793	9d69a6b2-1c1f-42ec-88a6-bf91b40b7462	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 6, 467857.14285714, 116964.28571429, 'Pendiente', 'Se realiza abono', '23-01-2025', 0, 0, '2024-11-04 20:42:18', '2024-11-04 20:42:18')","time":"0.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:42:18
32896	9d69a6b2-1453-4d52-918f-ca968e0a8b2e	9d69a6b2-1c1f-42ec-88a6-bf91b40b7462	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:42:18
32897	9d69a6b2-14f1-402e-895c-0c7bbc714547	9d69a6b2-1c1f-42ec-88a6-bf91b40b7462	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 7, 467857.14285714, 116964.28571429, 'Pendiente', 'Se realiza abono', '08-02-2025', 0, 0, '2024-11-04 20:42:18', '2024-11-04 20:42:18')","time":"0.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:42:18
32898	9d69a6b2-151e-4620-9cf6-05322af0eace	9d69a6b2-1c1f-42ec-88a6-bf91b40b7462	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:42:18
32899	9d69a6b2-159e-4b32-9902-f93aa7259742	9d69a6b2-1c1f-42ec-88a6-bf91b40b7462	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 8, 467857.14285714, 116964.28571429, 'Pendiente', 'Se realiza abono', '24-02-2025', 0, 0, '2024-11-04 20:42:18', '2024-11-04 20:42:18')","time":"0.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:42:18
32900	9d69a6b2-15d1-4a5c-9f63-9dcc193bea96	9d69a6b2-1c1f-42ec-88a6-bf91b40b7462	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:42:18
32901	9d69a6b2-1a94-4aeb-a92d-a850ae9733c2	9d69a6b2-1c1f-42ec-88a6-bf91b40b7462	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 20:42:18
33910	9d69b7fc-a1e0-4112-82ca-6d26b41c9d42	9d69b7fc-becf-42b9-9144-b565f65ca2b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:30:39
42040	9d6cd3bb-ddc3-46f7-af3e-e4b80f8cf49c	9d6cd3bb-e10d-4226-b0a0-299db8bcce36	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":140,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:35:43
10649	9d5712dd-ba62-4400-9239-6efc9792b9a0	9d5712de-030a-466c-8e31-abf9c3db87c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 15:04:02
10650	9d5712dd-f8b8-4fbe-be3f-5569be7ae294	9d5712de-030a-466c-8e31-abf9c3db87c8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"146.62","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 15:04:02
10651	9d5712dd-fcae-41e2-830a-08920cc58518	9d5712de-030a-466c-8e31-abf9c3db87c8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '5' order by \\"item_loans\\".\\"id\\" asc","time":"2.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-26 15:04:02
10652	9d5712dd-fce2-4cb2-8d65-6414a3f000e6	9d5712de-030a-466c-8e31-abf9c3db87c8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-26 15:04:02
5154	9d513680-0ef8-4d0e-ba0a-4987753ebe72	9d513680-3ac8-4580-a972-340b5498b69f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-23 17:08:42
5155	9d513680-3353-4516-a95d-e54714ac9280	9d513680-3ac8-4580-a972-340b5498b69f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"60.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:08:42
5156	9d513680-33d8-4262-806c-0db4ff2d02e8	9d513680-3ac8-4580-a972-340b5498b69f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:08:42
5157	9d513680-38ea-406b-a793-17bc37a2451f	9d513680-3ac8-4580-a972-340b5498b69f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-10-23 17:08:42
5158	9d513680-3953-44ed-9d4f-061ec1ec371e	9d513680-3ac8-4580-a972-340b5498b69f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":407,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:42
10653	9d5712de-01b5-4ef0-9add-b5a65b07a3f2	9d5712de-030a-466c-8e31-abf9c3db87c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 15:04:02
10654	9d5712de-01fc-4d1a-bddc-912f503ba880	9d5712de-030a-466c-8e31-abf9c3db87c8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":25,"loans_codigo":5,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":26,"loans_codigo":5,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":27,"loans_codigo":5,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":28,"loans_codigo":5,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":29,"loans_codigo":5,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":30,"loans_codigo":5,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null}]}},"duration":429,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:04:02
32902	9d69a6b2-1aea-41b3-a9f4-546e22a846a5	9d69a6b2-1c1f-42ec-88a6-bf91b40b7462	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"61","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"500000","idLoans":91,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El abono fue aplicado exitosamente","status":true},"duration":407,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:42:18
42041	9d6cd3bc-404b-408c-926a-e02643ab944c	9d6cd3bc-aa56-4c6c-aa4a-9fec97ec4ee1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:35:43
33911	9d69b7fc-b786-4458-8b15-cf2f54d56581	9d69b7fc-becf-42b9-9144-b565f65ca2b1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 82\\n                        ","time":"40.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"23238af5dc47e80ea555e80a08e2015d","hostname":"EderCortes"}	2024-11-04 21:30:39
32903	9d69a6b2-9b8e-4d9d-9669-66fb6359c36e	9d69a6b2-e458-4d2c-9926-7fa01289cfbe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 20:42:18
7180	9d52db73-75bf-4258-a82a-83c68ed55cff	9d52db73-b977-428f-a4a0-f2894add216a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:45:46
7181	9d52db73-b7fe-46c6-b9a3-921d3265095a	9d52db73-b977-428f-a4a0-f2894add216a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:45:46
7182	9d52db73-b891-4bbe-a7db-0787c11de4b5	9d52db73-b977-428f-a4a0-f2894add216a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:45:46
32904	9d69a6b2-dbe9-49b9-b1c6-ee1a0a53970d	9d69a6b2-e458-4d2c-9926-7fa01289cfbe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 91\\n                        ","time":"149.19","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"9ae30bc69b6b272f3f51ff48e54319f5","hostname":"EderCortes"}	2024-11-04 20:42:18
33912	9d69b7fc-ba5a-45a0-90ba-6d27f5fff5e9	9d69b7fc-becf-42b9-9144-b565f65ca2b1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '82' order by \\"item_loans\\".\\"id\\" asc","time":"2.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:30:39
33913	9d69b7fc-bd41-4766-81c1-a92974fa3907	9d69b7fc-becf-42b9-9144-b565f65ca2b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:30:39
33914	9d69b7fc-bd9a-4110-bfc2-6b8c051da022	9d69b7fc-becf-42b9-9144-b565f65ca2b1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/82","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":82,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"240000","loans_pago_interes":"60000","user_alias":"eder.cortes"},"items":[{"id":316,"loans_codigo":82,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:36","updated_at":"2024-11-04 21:29:42","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":464,"loans_codigo":82,"itemloans_cuota":"2","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:29:42","updated_at":"2024-11-04 21:29:42","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":465,"loans_codigo":82,"itemloans_cuota":"3","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:29:42","updated_at":"2024-11-04 21:29:42","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":466,"loans_codigo":82,"itemloans_cuota":"4","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:29:42","updated_at":"2024-11-04 21:29:42","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":467,"loans_codigo":82,"itemloans_cuota":"5","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:29:42","updated_at":"2024-11-04 21:29:42","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":300,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:30:39
32905	9d69a6b2-df22-4a0c-b310-c9ebd3af9c41	9d69a6b2-e458-4d2c-9926-7fa01289cfbe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '91' order by \\"item_loans\\".\\"id\\" asc","time":"2.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 20:42:18
32906	9d69a6b2-e2e1-429c-918b-003c0ea6b0fa	9d69a6b2-e458-4d2c-9926-7fa01289cfbe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 20:42:18
7183	9d52db74-01e6-40db-a846-15c20bd91900	9d52db74-21a2-43a3-bbcd-12b622bae1a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:45:46
7184	9d52db74-1cc5-4798-acb2-5acd1347eafa	9d52db74-21a2-43a3-bbcd-12b622bae1a7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:45:46
7185	9d52db74-1d10-436b-a645-7ad2862d945d	9d52db74-21a2-43a3-bbcd-12b622bae1a7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:45:46
7186	9d52db74-206d-421a-a83f-13ddad4e8e16	9d52db74-21a2-43a3-bbcd-12b622bae1a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 12:45:46
7187	9d52db74-20b6-4c7e-8086-24f14ae3ba59	9d52db74-21a2-43a3-bbcd-12b622bae1a7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:45:46
32907	9d69a6b2-e345-48e4-9de5-16708d09c10e	9d69a6b2-e458-4d2c-9926-7fa01289cfbe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/91","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":91,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":8,"loans_valor_prestado":5000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1725000","loans_pago_interes":"431250","user_alias":"eder.cortes"},"items":[{"id":371,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 17:44:55","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"200000","itemloans_cuota_cancelada":"800000","user_alias":"eder.cortes"},{"id":403,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 20:42:05","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"131250","itemloans_cuota_cancelada":"525000","user_alias":"eder.cortes"},{"id":404,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 20:42:18","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000","user_alias":"eder.cortes"},{"id":411,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"467857.14285714","itemloans_iteres":"116964.28571429","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:42:18","updated_at":"2024-11-04 20:42:18","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":412,"loans_codigo":91,"itemloans_cuota":"3","itemloans_valor_cuota":"467857.14285714","itemloans_iteres":"116964.28571429","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:42:18","updated_at":"2024-11-04 20:42:18","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":413,"loans_codigo":91,"itemloans_cuota":"4","itemloans_valor_cuota":"467857.14285714","itemloans_iteres":"116964.28571429","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:42:18","updated_at":"2024-11-04 20:42:18","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":414,"loans_codigo":91,"itemloans_cuota":"5","itemloans_valor_cuota":"467857.14285714","itemloans_iteres":"116964.28571429","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:42:18","updated_at":"2024-11-04 20:42:18","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":415,"loans_codigo":91,"itemloans_cuota":"6","itemloans_valor_cuota":"467857.14285714","itemloans_iteres":"116964.28571429","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:42:18","updated_at":"2024-11-04 20:42:18","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":416,"loans_codigo":91,"itemloans_cuota":"7","itemloans_valor_cuota":"467857.14285714","itemloans_iteres":"116964.28571429","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:42:18","updated_at":"2024-11-04 20:42:18","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":417,"loans_codigo":91,"itemloans_cuota":"8","itemloans_valor_cuota":"467857.14285714","itemloans_iteres":"116964.28571429","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:42:18","updated_at":"2024-11-04 20:42:18","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":484,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:42:18
38466	9d6b64e6-1d5d-44ce-b48d-f4300170d901	9d6b64e6-1e6b-4553-9a73-3f6fa9c8ec6e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:29:58
10748	9d5720ce-70bd-442d-b44e-6b5f3c953491	9d5720ce-a172-4edf-a600-344334ffae5b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 15:43:01
7336	9d52dd1f-81ad-4ef5-86b4-b5e4bdcf6930	9d52dd1f-ada5-43a0-adc4-d759ff72adcf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:50:27
10749	9d5720ce-9e49-4bba-8bb6-d4afe7a394dd	9d5720ce-a172-4edf-a600-344334ffae5b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 15:43:01
10750	9d5720ce-9f76-489f-bcfc-e8acecc04f49	9d5720ce-a172-4edf-a600-344334ffae5b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:43:01
42042	9d6cd3bc-9161-4eaf-80dc-0d6b90f41be7	9d6cd3bc-aa56-4c6c-aa4a-9fec97ec4ee1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"159.30","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 10:35:43
35364	9d69c406-26b2-4050-8f75-e0eff5b3c459	9d69c406-2859-4c33-a675-977cce7f9e84	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":698,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:04:18
42043	9d6cd3bc-91b2-462b-a882-277e5fdaa8a4	9d6cd3bc-aa56-4c6c-aa4a-9fec97ec4ee1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:35:43
7188	9d52db74-638a-40b7-928a-25a9d5d82565	9d52db74-80f0-40e8-aa99-2d5c7e1fcd0f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 12:45:47
7189	9d52db74-7b5c-4c41-8a44-68ecd65d6a7f	9d52db74-80f0-40e8-aa99-2d5c7e1fcd0f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:45:47
7190	9d52db74-7ba9-4ef7-bcf6-fd97b7bd4ba0	9d52db74-80f0-40e8-aa99-2d5c7e1fcd0f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:45:47
7191	9d52db74-7ff0-474e-a8db-d159f92451c3	9d52db74-80f0-40e8-aa99-2d5c7e1fcd0f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 12:45:47
7192	9d52db74-8030-4bd1-8289-8018150363ed	9d52db74-80f0-40e8-aa99-2d5c7e1fcd0f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:45:47
7337	9d52dd1f-aa82-4961-ab6c-42ad0901c02b	9d52dd1f-ada5-43a0-adc4-d759ff72adcf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:50:27
7338	9d52dd1f-ac11-4377-9914-f1313de9ce17	9d52dd1f-ada5-43a0-adc4-d759ff72adcf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":341,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:50:27
10751	9d5720cf-357f-4139-b5d0-266242d40e75	9d5720cf-51a2-4e1d-976d-5e8a0f5c76f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 15:43:01
10752	9d5720cf-4c55-45cf-9415-e47509895e55	9d5720cf-51a2-4e1d-976d-5e8a0f5c76f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"44.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-26 15:43:01
10753	9d5720cf-5050-4bb4-8f1e-f8e5498f455c	9d5720cf-51a2-4e1d-976d-5e8a0f5c76f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 15:43:01
10754	9d5720cf-50c3-4118-9711-52b50cf24bf2	9d5720cf-51a2-4e1d-976d-5e8a0f5c76f0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":408,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:43:01
37377	9d6b4925-1378-4807-aab8-07d0bd7e8dd4	9d6b4925-1e7e-474d-a655-a100617edead	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 93\\n                        ","time":"47.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9c742b70d7e4a1a77b260fd1a8993140","hostname":"EderCortes"}	2024-11-05 16:12:22
37378	9d6b4925-1910-4f1e-8272-27f526dc9002	9d6b4925-1e7e-474d-a655-a100617edead	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"8.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":304,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-05 16:12:22
7193	9d52db74-c7ad-4f1e-b852-f2d72113440c	9d52db74-e863-47fe-ac91-7c9c10aa7117	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 12:45:47
7194	9d52db74-e186-4c4f-8870-75231a034b78	9d52db74-e863-47fe-ac91-7c9c10aa7117	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"43.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:45:47
7195	9d52db74-e1d6-4516-bbca-0fd6ed1af662	9d52db74-e863-47fe-ac91-7c9c10aa7117	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:45:47
7196	9d52db74-e370-408c-890d-653d2a8fa07a	9d52db74-e863-47fe-ac91-7c9c10aa7117	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"2.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:45:47
7197	9d52db74-e3a7-426e-aa3d-e2cb45f21826	9d52db74-e863-47fe-ac91-7c9c10aa7117	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:45:47
7198	9d52db74-e73d-4f43-8c01-d11d8fcf9e31	9d52db74-e863-47fe-ac91-7c9c10aa7117	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 12:45:47
7199	9d52db74-e78a-40e8-b831-f64d5be544cb	9d52db74-e863-47fe-ac91-7c9c10aa7117	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:45:47
7339	9d52dd20-09de-4468-8375-b69e0718a1d8	9d52dd20-2996-4577-81c1-930a1936b3a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:50:27
7340	9d52dd20-23bf-4e12-9840-ba8aa97a8920	9d52dd20-2996-4577-81c1-930a1936b3a7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:50:27
7341	9d52dd20-241a-4564-8889-8aed5d767a2f	9d52dd20-2996-4577-81c1-930a1936b3a7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:50:27
7342	9d52dd20-2857-4ae8-ac53-13fde796ae95	9d52dd20-2996-4577-81c1-930a1936b3a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:50:27
7343	9d52dd20-28b7-4086-b058-3fa9ffda8ff6	9d52dd20-2996-4577-81c1-930a1936b3a7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":279,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:50:27
10755	9d5720d1-1f5c-42f6-9bfe-20a7a9333e8e	9d5720d1-66a5-4913-a929-cfe4f35d9b9d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 15:43:02
10756	9d5720d1-6073-4340-abf7-4a0a1a803477	9d5720d1-66a5-4913-a929-cfe4f35d9b9d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"146.87","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 15:43:03
10757	9d5720d1-60cf-4b37-8ef9-4bde91b117cc	9d5720d1-66a5-4913-a929-cfe4f35d9b9d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 15:43:03
10758	9d5720d1-6464-489a-8274-0fb4b8cb43ac	9d5720d1-66a5-4913-a929-cfe4f35d9b9d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 15:43:03
10759	9d5720d1-64f7-445c-b397-adecc050e0cd	9d5720d1-66a5-4913-a929-cfe4f35d9b9d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":379,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:43:03
37379	9d6b4925-1c9c-4d5e-8ae9-f9094f01e698	9d6b4925-1e7e-474d-a655-a100617edead	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 16:12:22
38467	9d6b64e7-c119-444e-abaa-d171085cc534	9d6b64e7-eb8a-4e04-b707-01ac9ef6639c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:29:59
42044	9d6cd3bc-a911-43bb-b755-25a3c1466fb0	9d6cd3bc-aa56-4c6c-aa4a-9fec97ec4ee1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:35:43
7200	9d52db76-5c9f-49bd-a16f-11a8a7da67a9	9d52db76-8abe-4606-a2f9-6701a5aca9c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 12:45:48
7201	9d52db76-8571-4cdb-b177-95fa258d4257	9d52db76-8abe-4606-a2f9-6701a5aca9c5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"55.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:45:48
7202	9d52db76-85bc-45f6-8860-3e56496c4a07	9d52db76-8abe-4606-a2f9-6701a5aca9c5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:45:48
7203	9d52db76-8989-41c8-9983-2aac8eb98d97	9d52db76-8abe-4606-a2f9-6701a5aca9c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 12:45:48
7204	9d52db76-89d1-46ac-b4f8-128090e55827	9d52db76-8abe-4606-a2f9-6701a5aca9c5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":529,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:45:48
7344	9d52dd20-6f2f-40fa-a96a-0e708a9c4474	9d52dd20-8d39-4055-8e31-0851fe4fff53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:50:27
7345	9d52dd20-8864-4393-a0d0-e1fdeefc5f6f	9d52dd20-8d39-4055-8e31-0851fe4fff53	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:50:27
7346	9d52dd20-88b5-48d2-a993-a6b323c428ac	9d52dd20-8d39-4055-8e31-0851fe4fff53	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:50:27
7347	9d52dd20-8c0f-4efa-8710-329a560d5a91	9d52dd20-8d39-4055-8e31-0851fe4fff53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 12:50:27
7348	9d52dd20-8c54-481f-b84d-e8b6ce1e1c4c	9d52dd20-8d39-4055-8e31-0851fe4fff53	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:50:27
37380	9d6b4925-1d2f-477b-a7d2-fb16f4a71e1d	9d6b4925-1e7e-474d-a655-a100617edead	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":93,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1000000","loans_pago_interes":"250000","user_alias":"juan_jaramillo"},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:19:45","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000","user_alias":"eder.cortes"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:22:30","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000","user_alias":"eder.cortes"},{"id":399,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:22:30","updated_at":"2024-11-04 17:27:01","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000","user_alias":"eder.cortes"},{"id":400,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:22:30","updated_at":"2024-11-04 17:27:01","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000","user_alias":"eder.cortes"},{"id":401,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:22:30","updated_at":"2024-11-04 17:27:01","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000","user_alias":"eder.cortes"},{"id":402,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:22:30","updated_at":"2024-11-04 17:27:01","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000","user_alias":"eder.cortes"}]}},"duration":265,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:12:22
38468	9d6b64e7-e5b5-4bca-8187-b570dfdcd3b1	9d6b64e7-eb8a-4e04-b707-01ac9ef6639c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:29:59
38469	9d6b64e7-e605-4d2c-b0bb-bc222e5e1df1	9d6b64e7-eb8a-4e04-b707-01ac9ef6639c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:29:59
38470	9d6b64e7-ea2e-4557-9626-edf7092fa34d	9d6b64e7-eb8a-4e04-b707-01ac9ef6639c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:29:59
7349	9d52dd20-e9be-4215-8a83-d2e360b2edc6	9d52dd21-0eed-48f2-9804-22b377a3c236	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 12:50:28
7350	9d52dd21-056f-45e5-88bd-d1ddb21a9524	9d52dd21-0eed-48f2-9804-22b377a3c236	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"45.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:50:28
7351	9d52dd21-05e7-4ad5-83ed-b4527e3b5bd7	9d52dd21-0eed-48f2-9804-22b377a3c236	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:50:28
7352	9d52dd21-07bd-4076-bcb8-bb2e15e7db25	9d52dd21-0eed-48f2-9804-22b377a3c236	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"2.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:50:28
7353	9d52dd21-080a-47a8-bc49-c9aef0486c81	9d52dd21-0eed-48f2-9804-22b377a3c236	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:50:28
7354	9d52dd21-0d19-4a66-a621-cdf5d15d059b	9d52dd21-0eed-48f2-9804-22b377a3c236	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 12:50:28
7355	9d52dd21-0d99-4048-98bd-9f07c5a821e3	9d52dd21-0eed-48f2-9804-22b377a3c236	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:50:28
37381	9d6b493a-39a8-4fb5-bcf4-8efdc817cb95	9d6b493a-5a7b-4bdc-b919-30b919d504f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 16:12:36
7513	9d52df52-dcab-495a-9ba4-286dfab43a10	9d52df52-faa7-46f7-b306-0ebc6e1eb0b8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:56:36
7514	9d52df52-f92e-4224-85ac-9c2e6209bc56	9d52df52-faa7-46f7-b306-0ebc6e1eb0b8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:56:36
7515	9d52df52-f9b6-4a49-a0b8-e5ae9d90295c	9d52df52-faa7-46f7-b306-0ebc6e1eb0b8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:56:36
37382	9d6b493a-54c7-40bf-8953-eb357989ae25	9d6b493a-5a7b-4bdc-b919-30b919d504f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"50.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 16:12:36
37383	9d6b493a-588f-43ff-ace6-01abc1811ccd	9d6b493a-5a7b-4bdc-b919-30b919d504f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 16:12:36
37384	9d6b493a-5910-4cf7-9e9f-8f9d3a191420	9d6b493a-5a7b-4bdc-b919-30b919d504f0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":409,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:12:36
38471	9d6b64e7-ea79-4438-bb21-0a566468238a	9d6b64e7-eb8a-4e04-b707-01ac9ef6639c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":563,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:29:59
39739	9d6cb406-5d62-4b41-b9ed-a4b45ef10c1c	9d6cb406-5e83-475b-9f37-73ab2a91f60b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","profile":1},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":1287,"memory":24,"hostname":"EderCortes"}	2024-11-06 09:07:03
7356	9d52dd22-8be1-4722-8677-782dd246ef34	9d52dd23-a44b-41a7-ae29-c3c0d20269ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 12:50:29
7357	9d52dd23-9aba-42f8-b859-656155838216	9d52dd23-a44b-41a7-ae29-c3c0d20269ef	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"655.02","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:50:29
7358	9d52dd23-9b63-4bc8-8ab3-796e87834a4f	9d52dd23-a44b-41a7-ae29-c3c0d20269ef	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:50:29
7359	9d52dd23-a274-481f-accc-37da184bb723	9d52dd23-a44b-41a7-ae29-c3c0d20269ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 12:50:29
7360	9d52dd23-a2f6-4956-8d64-92334e4c690b	9d52dd23-a44b-41a7-ae29-c3c0d20269ef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":1200,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:50:29
7516	9d52df53-49e1-454f-930d-6a1299582b4f	9d52df53-6930-434b-a125-e100c6627ed9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:56:36
7517	9d52df53-62c0-42c3-b627-b33c12c13149	9d52df53-6930-434b-a125-e100c6627ed9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:56:36
7518	9d52df53-631c-43cf-a21b-3f4545a496f2	9d52df53-6930-434b-a125-e100c6627ed9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:56:36
7519	9d52df53-67c9-4edf-9c83-6f34b4489ba5	9d52df53-6930-434b-a125-e100c6627ed9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:56:36
7520	9d52df53-6826-41f6-a035-69d79f4fb4d5	9d52df53-6930-434b-a125-e100c6627ed9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":257,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:56:36
37385	9d6b493a-ad19-4660-877b-a8bc9b54f534	9d6b493a-dd94-4968-9598-3fc587e3c04b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 16:12:36
37386	9d6b493a-d8bd-4a8a-b7ac-90cfab5e0459	9d6b493a-dd94-4968-9598-3fc587e3c04b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:12:36
37387	9d6b493a-d906-47d2-959b-68dd18659a1f	9d6b493a-dd94-4968-9598-3fc587e3c04b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:12:36
37388	9d6b493a-dc4d-4b58-8197-04dc6ba946a8	9d6b493a-dd94-4968-9598-3fc587e3c04b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 16:12:36
37389	9d6b493a-dc8f-4c1c-9b06-ef5e47fd148f	9d6b493a-dd94-4968-9598-3fc587e3c04b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":324,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:12:36
39740	9d6cb407-8a1d-4119-a0e1-ac8b61f6d12e	9d6cb407-d89f-4508-b9ca-aed9612cf5c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:07:04
7521	9d52df53-a9e5-4e85-be16-5a235689372e	9d52df53-f26c-42d2-aaad-f3ee286d553d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:56:36
7522	9d52df53-ed27-41ca-bb08-f13adff300ff	9d52df53-f26c-42d2-aaad-f3ee286d553d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"149.13","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:56:36
7523	9d52df53-ed95-405c-ad5f-57b2d567359f	9d52df53-f26c-42d2-aaad-f3ee286d553d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:56:36
7524	9d52df53-f15b-43a0-a008-8aba5c9a4ad0	9d52df53-f26c-42d2-aaad-f3ee286d553d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 12:56:36
7525	9d52df53-f19e-4195-9cac-d0b7219ab709	9d52df53-f26c-42d2-aaad-f3ee286d553d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":337,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:56:36
37390	9d6b493b-219e-4f2a-a5b6-1a0b5eecb86f	9d6b493b-3f6e-45c1-9dbb-126a7f2577e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 16:12:36
37391	9d6b493b-3a53-4331-bbf3-28484cc44220	9d6b493b-3f6e-45c1-9dbb-126a7f2577e5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:12:36
37392	9d6b493b-3ab0-408a-8716-253a8f99496e	9d6b493b-3f6e-45c1-9dbb-126a7f2577e5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:12:36
37393	9d6b493b-3de9-4d76-b27b-d2a3ee0ea459	9d6b493b-3f6e-45c1-9dbb-126a7f2577e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 16:12:36
37394	9d6b493b-3e58-4beb-bca6-7f0c594d263c	9d6b493b-3f6e-45c1-9dbb-126a7f2577e5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:12:36
39741	9d6cb407-d3ef-4ab7-bfdc-699a0a3812ff	9d6cb407-d89f-4508-b9ca-aed9612cf5c9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"167.45","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:07:04
39742	9d6cb407-d43f-4e2c-8342-3a17329b3d24	9d6cb407-d89f-4508-b9ca-aed9612cf5c9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:07:04
39743	9d6cb407-d775-43f9-b877-2b28c52e6c78	9d6cb407-d89f-4508-b9ca-aed9612cf5c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:07:04
39744	9d6cb407-d7b9-4f28-a800-363884a80be3	9d6cb407-d89f-4508-b9ca-aed9612cf5c9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":517,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:07:04
7526	9d52df54-326f-4617-b724-3006a66de74b	9d52df54-5067-4a9d-baac-f148ebfd5351	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 12:56:37
7527	9d52df54-4a15-4016-a4fc-8f2271130c11	9d52df54-5067-4a9d-baac-f148ebfd5351	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"39.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:56:37
7528	9d52df54-4a65-49ea-ac6a-f83654c0a767	9d52df54-5067-4a9d-baac-f148ebfd5351	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:56:37
7529	9d52df54-4bbc-4ede-918a-bd23bcc06462	9d52df54-5067-4a9d-baac-f148ebfd5351	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"1.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:56:37
7530	9d52df54-4beb-4f5c-b76a-581100b9dfd9	9d52df54-5067-4a9d-baac-f148ebfd5351	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:56:37
7531	9d52df54-4f0f-4438-8730-43ab1e060ce6	9d52df54-5067-4a9d-baac-f148ebfd5351	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 12:56:37
7532	9d52df54-4f6a-41da-80cc-a22fd4f393cc	9d52df54-5067-4a9d-baac-f148ebfd5351	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:56:37
37395	9d6b493f-3452-45e1-b506-d9fe5e2676c4	9d6b493f-7e3a-4147-b29b-29690ffdaec8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 16:12:39
37396	9d6b493f-745d-41a3-96ef-235b0377a4ba	9d6b493f-7e3a-4147-b29b-29690ffdaec8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 84\\n                        ","time":"150.78","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ab3bc7b9a0b897ddfe4287a88fc64c84","hostname":"EderCortes"}	2024-11-05 16:12:39
37397	9d6b493f-798a-4c32-877b-de306d5112eb	9d6b493f-7e3a-4147-b29b-29690ffdaec8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '84' order by \\"item_loans\\".\\"id\\" asc","time":"9.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":304,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-05 16:12:39
37398	9d6b493f-7ce7-4e2e-be06-e758607c88fe	9d6b493f-7e3a-4147-b29b-29690ffdaec8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 16:12:39
37399	9d6b493f-7d47-425c-b78a-df766b3e6f02	9d6b493f-7e3a-4147-b29b-29690ffdaec8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/84","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":84,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"480000","loans_pago_interes":"120000","user_alias":"juan_jaramillo"},"items":[{"id":326,"loans_codigo":84,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 21:20:45","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":452,"loans_codigo":84,"itemloans_cuota":"4","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 21:20:45","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":456,"loans_codigo":84,"itemloans_cuota":"3","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:21:49","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":457,"loans_codigo":84,"itemloans_cuota":"4","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:21:49","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":458,"loans_codigo":84,"itemloans_cuota":"5","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:21:49","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:12:39
7533	9d52df56-2191-412a-87de-38fbea37837e	9d52df56-51f3-40c5-9ab8-b3c1ce15c36a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 12:56:38
7534	9d52df56-4875-42c5-9249-0d2ce97f3b1c	9d52df56-51f3-40c5-9ab8-b3c1ce15c36a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"61.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:56:38
7535	9d52df56-48da-4f5e-a987-757302280dfa	9d52df56-51f3-40c5-9ab8-b3c1ce15c36a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:56:38
7536	9d52df56-4faf-4ca5-85fb-90c4e6a22386	9d52df56-51f3-40c5-9ab8-b3c1ce15c36a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 12:56:38
7537	9d52df56-5047-4e05-863e-fe408bf84f47	9d52df56-51f3-40c5-9ab8-b3c1ce15c36a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":361,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:56:38
40143	9d6cc121-4a56-4c36-a7d8-f0b47274aa1c	9d6cc121-4b7e-42fb-b2a7-dd800e870164	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:43:42
10866	9d5ca558-b7e9-40da-87e5-fbd013daeaaa	9d5ca558-e57e-426b-9a8e-a70b9a7deaf8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 09:32:46
10867	9d5ca558-e23a-4dff-a0c9-eed7f12d35bd	9d5ca558-e57e-426b-9a8e-a70b9a7deaf8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 09:32:46
10868	9d5ca558-e3cb-498b-b97c-78d9f84607b9	9d5ca558-e57e-426b-9a8e-a70b9a7deaf8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":378,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:32:46
41461	9d6ccc9b-f9f4-41e4-b4bf-721c282baacc	9d6ccc9b-faea-4b8e-a586-66ac5e1fc351	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:48
42045	9d6cd3bc-a965-4689-a0a4-4cd35825f63e	9d6cd3bc-aa56-4c6c-aa4a-9fec97ec4ee1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","profile":1},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":421,"memory":24,"hostname":"EderCortes"}	2024-11-06 10:35:43
10869	9d5ca559-4b88-4738-985f-49eed40bc672	9d5ca559-938b-4577-a654-7192f8c06584	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 09:32:46
10870	9d5ca559-8f2b-45f7-8ce6-4589d1378bba	9d5ca559-938b-4577-a654-7192f8c06584	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"159.49","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-29 09:32:46
7669	9d52dfad-6182-48ca-a16e-671362a086e4	9d52dfad-8826-48bb-ab20-e8af246918ca	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 12:57:35
4664	9d513461-ef7f-48c9-b938-2e2e97fd89c0	9d513462-285d-408e-bd48-e1e4e2e56d71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 17:02:47
3898	9d511aee-5aad-463c-8321-afa034a0458a	9d511aee-7af5-460a-b100-4a45092f651d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 15:51:37
3899	9d511aee-78fe-49ac-b2d0-01fe9f41ccff	9d511aee-7af5-460a-b100-4a45092f651d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 15:51:37
3900	9d511aee-79ba-4035-814d-42a8b1e77170	9d511aee-7af5-460a-b100-4a45092f651d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":268,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:51:37
4665	9d513462-251b-4f15-9ad7-5f75591f1c29	9d513462-285d-408e-bd48-e1e4e2e56d71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 17:02:47
4666	9d513462-2696-448c-a595-f91310c3c7d7	9d513462-285d-408e-bd48-e1e4e2e56d71	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":506,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:02:47
7670	9d52dfad-85f9-4ff4-baab-2715424d0cc4	9d52dfad-8826-48bb-ab20-e8af246918ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:57:35
7671	9d52dfad-86ce-4de7-a2ba-e8d4cd636227	9d52dfad-8826-48bb-ab20-e8af246918ca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":799,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:57:35
10871	9d5ca559-9241-4374-a718-45bdf8f164f1	9d5ca559-938b-4577-a654-7192f8c06584	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 09:32:46
10872	9d5ca559-9298-4108-9b41-93f905c24cbb	9d5ca559-938b-4577-a654-7192f8c06584	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":392,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:32:46
40144	9d6cc121-96b7-435c-98dc-0a7bd8f1e31f	9d6cc121-ba28-4c6a-a4dc-4a34982cc3bc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 09:43:42
40145	9d6cc121-b4d9-4259-a0cd-90b9bb5f5db9	9d6cc121-ba28-4c6a-a4dc-4a34982cc3bc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 09:43:42
40146	9d6cc121-b530-4964-84d7-aba7a4462e0c	9d6cc121-ba28-4c6a-a4dc-4a34982cc3bc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 09:43:42
40147	9d6cc121-b88a-4f1e-b41f-f9e5bc0c6b0c	9d6cc121-ba28-4c6a-a4dc-4a34982cc3bc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 09:43:42
40148	9d6cc121-b8fb-49cd-a9d8-cafb8525221f	9d6cc121-ba28-4c6a-a4dc-4a34982cc3bc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":274,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:43:42
41462	9d6ccc9c-3ffe-4e7b-8b9d-8c5857510cc7	9d6ccc9c-5e74-433f-8ba1-a1279cd8ed21	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 10:15:48
41463	9d6ccc9c-5935-4fb4-bc00-3c0d9121b970	9d6ccc9c-5e74-433f-8ba1-a1279cd8ed21	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:15:48
41464	9d6ccc9c-5984-4f38-83e0-0de03d1ccea6	9d6ccc9c-5e74-433f-8ba1-a1279cd8ed21	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:15:48
41465	9d6ccc9c-5d02-4eb8-ad35-8c7a164dfee6	9d6ccc9c-5e74-433f-8ba1-a1279cd8ed21	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 10:15:48
42046	9d6cd3bd-0306-4f23-bcb1-88e85c05e7bb	9d6cd3bd-4b88-4630-b9a5-716e2523dddd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:35:44
42047	9d6cd3bd-46cf-4b0e-9fc3-245afac2df7b	9d6cd3bd-4b88-4630-b9a5-716e2523dddd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"150.57","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:35:44
42048	9d6cd3bd-4718-4ecf-aa5f-819c149b2e35	9d6cd3bd-4b88-4630-b9a5-716e2523dddd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:35:44
3901	9d511aee-c3f8-4d31-be97-18bac7c25db6	9d511aee-e43a-4d7b-918f-491661e7defd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 15:51:37
3902	9d511aee-de76-4119-b58e-2e14956e7c08	9d511aee-e43a-4d7b-918f-491661e7defd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:51:37
3903	9d511aee-dec1-4f9a-bd4f-99ed27769a61	9d511aee-e43a-4d7b-918f-491661e7defd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 15:51:37
3904	9d511aee-e31e-457a-b784-b1d29c39bafc	9d511aee-e43a-4d7b-918f-491661e7defd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 15:51:37
3905	9d511aee-e369-4bbc-a17c-ee30d1996832	9d511aee-e43a-4d7b-918f-491661e7defd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:51:37
4667	9d513462-ae86-4bad-9689-4be50899d990	9d513462-e0d8-497c-9dd9-6174879a37c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 17:02:47
4668	9d513462-d6b3-450f-a2e3-9912dd853a41	9d513462-e0d8-497c-9dd9-6174879a37c9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"70.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:02:48
4669	9d513462-d758-42b3-af60-6bc09ffe6c84	9d513462-e0d8-497c-9dd9-6174879a37c9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:02:48
4670	9d513462-dedd-40f6-8ed2-65a34b216b37	9d513462-e0d8-497c-9dd9-6174879a37c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 17:02:48
4671	9d513462-df6a-428a-baad-c7ac3f70fdd3	9d513462-e0d8-497c-9dd9-6174879a37c9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":432,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:02:48
7672	9d52dfad-eb02-4e9c-a2c2-466af0c9d5dc	9d52dfae-38fe-4bdf-9b5a-8266823b71ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:57:35
7673	9d52dfae-318d-4396-bcd5-c3d8aa5e1f9f	9d52dfae-38fe-4bdf-9b5a-8266823b71ea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"89.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:57:36
7674	9d52dfae-3205-42d8-9c42-ac75075d8136	9d52dfae-38fe-4bdf-9b5a-8266823b71ea	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:57:36
7675	9d52dfae-3792-46b4-9540-470c1b3bdf96	9d52dfae-38fe-4bdf-9b5a-8266823b71ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:57:36
7676	9d52dfae-37f5-470f-8dd0-dba2729b7a61	9d52dfae-38fe-4bdf-9b5a-8266823b71ea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":423,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:57:36
10873	9d5ca55b-bc32-4017-b0cf-11485b740d84	9d5ca55b-da74-4fdc-9420-9d767d08d31f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 09:32:48
10874	9d5ca55b-d5fa-4ac5-b308-844bf3e430af	9d5ca55b-da74-4fdc-9420-9d767d08d31f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 09:32:48
10875	9d5ca55b-d649-497e-9b7a-98e1146f2980	9d5ca55b-da74-4fdc-9420-9d767d08d31f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 09:32:48
10876	9d5ca55b-d953-49cd-932f-3eaf1acdecdd	9d5ca55b-da74-4fdc-9420-9d767d08d31f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 09:32:48
40149	9d6cc121-fb63-4300-a844-8e849607c755	9d6cc122-1f6a-4c4d-ab84-b0316a9dbca1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 09:43:42
42049	9d6cd3bd-4a5a-42ca-9ff4-65c1cdde0927	9d6cd3bd-4b88-4630-b9a5-716e2523dddd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:35:44
3906	9d511aef-2852-47f5-92e6-5c2e41495d9a	9d511aef-4b82-4c33-8eea-182bc56c8cea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 15:51:37
3907	9d511aef-465c-466a-b192-adc93893355b	9d511aef-4b82-4c33-8eea-182bc56c8cea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:51:38
3908	9d511aef-46a7-4e37-822c-9af544bd4530	9d511aef-4b82-4c33-8eea-182bc56c8cea	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 15:51:38
3909	9d511aef-4a1c-4c58-976e-162857fc58f8	9d511aef-4b82-4c33-8eea-182bc56c8cea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 15:51:38
3910	9d511aef-4a94-4a90-ae31-d0c782d4d6a3	9d511aef-4b82-4c33-8eea-182bc56c8cea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:51:38
4672	9d513463-472d-4468-a3ea-d33b7ec320e4	9d513463-a02f-465f-b176-2a257fd2c036	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 17:02:48
4673	9d513463-99fb-4afe-bf77-4b4cafcfce67	9d513463-a02f-465f-b176-2a257fd2c036	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"165.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:02:48
4674	9d513463-9a55-4ad4-a140-19cf09953903	9d513463-a02f-465f-b176-2a257fd2c036	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:02:48
4675	9d513463-9ee8-4114-a0be-4d8cd4d69a8f	9d513463-a02f-465f-b176-2a257fd2c036	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 17:02:48
4676	9d513463-9f3b-4b22-88dc-77eee0210b04	9d513463-a02f-465f-b176-2a257fd2c036	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":468,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:02:48
7677	9d52dfae-909e-4a53-a27c-b4ca0cfed7b7	9d52dfae-b5fa-4320-bb74-abd69b72fd55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:57:36
7678	9d52dfae-af41-4512-a060-d94dc4e42fb9	9d52dfae-b5fa-4320-bb74-abd69b72fd55	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:57:36
7679	9d52dfae-afa4-4475-8ae3-ae5c09fc65ae	9d52dfae-b5fa-4320-bb74-abd69b72fd55	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:57:36
7680	9d52dfae-b42c-41b2-b2a3-061a1f4b1938	9d52dfae-b5fa-4320-bb74-abd69b72fd55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:57:36
7681	9d52dfae-b48b-406a-94d0-b05561f68343	9d52dfae-b5fa-4320-bb74-abd69b72fd55	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":297,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:57:36
4677	9d513464-73b1-4e6a-a47f-a1ea5ea24ff4	9d513464-c3a0-41b5-a9c2-dc3f19215bc3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 17:02:49
4678	9d513464-b97b-48bb-81d5-6821a59e4f1a	9d513464-c3a0-41b5-a9c2-dc3f19215bc3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"110.63","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:02:49
4679	9d513464-ba19-4c0d-82c6-7e21ba3026d1	9d513464-c3a0-41b5-a9c2-dc3f19215bc3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:02:49
4680	9d513464-c13b-4eb5-b94f-491ac4965e64	9d513464-c3a0-41b5-a9c2-dc3f19215bc3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 17:02:49
4681	9d513464-c201-4864-8eff-fbbdad0695e2	9d513464-c3a0-41b5-a9c2-dc3f19215bc3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":729,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:02:49
7682	9d52dfaf-0ef1-4d86-8f80-ea3a7cf2fd57	9d52dfaf-2dcb-42ee-ba2d-5eb3aa3e292a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:57:36
7683	9d52dfaf-2709-40a7-809e-807c37755115	9d52dfaf-2dcb-42ee-ba2d-5eb3aa3e292a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"40.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:57:36
7684	9d52dfaf-2758-46f1-ab9c-39c18fa3dbf1	9d52dfaf-2dcb-42ee-ba2d-5eb3aa3e292a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:57:36
7685	9d52dfaf-2908-44c7-8c82-467905b5ed16	9d52dfaf-2dcb-42ee-ba2d-5eb3aa3e292a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"1.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:57:36
7686	9d52dfaf-2937-4409-8e1e-4b357d885a6d	9d52dfaf-2dcb-42ee-ba2d-5eb3aa3e292a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:57:36
7687	9d52dfaf-2c8b-45a7-b8f9-f0e6aa4b2654	9d52dfaf-2dcb-42ee-ba2d-5eb3aa3e292a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:57:36
7688	9d52dfaf-2cd3-4d1b-b28e-1832f6f7fa47	9d52dfaf-2dcb-42ee-ba2d-5eb3aa3e292a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":284,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:57:36
10877	9d5ca55b-d99b-41ea-8520-d455184ae30f	9d5ca55b-da74-4fdc-9420-9d767d08d31f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:32:48
40150	9d6cc122-183d-4d1a-97e8-43909f09a7a6	9d6cc122-1f6a-4c4d-ab84-b0316a9dbca1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"52.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 09:43:42
40151	9d6cc122-18ba-4705-9dba-6369f4117db8	9d6cc122-1f6a-4c4d-ab84-b0316a9dbca1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 09:43:42
40152	9d6cc122-1e2b-4a2c-bf54-e0a9ba99c261	9d6cc122-1f6a-4c4d-ab84-b0316a9dbca1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 09:43:42
4682	9d513465-906b-4ec1-a300-f8e818ef1b1e	9d513465-dafd-4e70-8b34-219a0ab2e931	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 17:02:49
4683	9d513465-d591-497f-aac6-bc694eb7a402	9d513465-dafd-4e70-8b34-219a0ab2e931	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"156.91","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:02:50
4684	9d513465-d5f0-4be6-94f9-193d1f635446	9d513465-dafd-4e70-8b34-219a0ab2e931	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:02:50
4685	9d513465-d9a4-4dbd-943b-de0fda9c1e36	9d513465-dafd-4e70-8b34-219a0ab2e931	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 17:02:50
4686	9d513465-d9ea-46e9-90cb-60a1dfcf577d	9d513465-dafd-4e70-8b34-219a0ab2e931	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":368,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:02:50
7689	9d52dfb0-c3fd-45ce-b23c-3a623c56f9bb	9d52dfb1-1f3c-40ee-9b9f-05fda30e894c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:57:37
5236	9d513779-3dd6-4450-a004-27192f307028	9d513779-6491-4f1a-b8ea-d00f1a52fc06	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 17:11:26
5237	9d513779-629c-4a86-9235-a37b51a09470	9d513779-6491-4f1a-b8ea-d00f1a52fc06	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 17:11:26
5238	9d513779-6363-4150-ad97-4539c13b41cb	9d513779-6491-4f1a-b8ea-d00f1a52fc06	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":278,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:11:26
7690	9d52dfb1-165c-4f72-b57c-7fac80b36117	9d52dfb1-1f3c-40ee-9b9f-05fda30e894c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"178.43","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:57:38
7691	9d52dfb1-16ce-4092-89c8-daff6d15e4a0	9d52dfb1-1f3c-40ee-9b9f-05fda30e894c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:57:38
7692	9d52dfb1-1d6f-4462-a551-31a1f364bc50	9d52dfb1-1f3c-40ee-9b9f-05fda30e894c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:57:38
7693	9d52dfb1-1dec-44a5-80a3-c6ee53479b4b	9d52dfb1-1f3c-40ee-9b9f-05fda30e894c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":533,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:57:38
10878	9d5ca561-0f43-46fc-8750-391aded85cb2	9d5ca561-2dce-4840-8629-9189e9234dd1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 09:32:51
10879	9d5ca561-2864-4d8c-a1a3-f192e944e7d3	9d5ca561-2dce-4840-8629-9189e9234dd1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 09:32:51
10880	9d5ca561-28b1-419f-b899-1eccecf829a0	9d5ca561-2dce-4840-8629-9189e9234dd1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 09:32:51
10881	9d5ca561-2c43-49d5-9805-a60bf2b4ab80	9d5ca561-2dce-4840-8629-9189e9234dd1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 09:32:51
40153	9d6cc122-1e7c-4135-8e35-73f91cda609a	9d6cc122-1f6a-4c4d-ab84-b0316a9dbca1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":245,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:43:42
10882	9d5ca561-2ca6-4a90-a748-99ee33804f6d	9d5ca561-2dce-4840-8629-9189e9234dd1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":286,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:32:51
40154	9d6cc123-2a1a-4e76-a5b2-771e900c4a63	9d6cc123-46ae-499b-97d5-fd3d3fe7c304	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 09:43:43
4164	9d512151-fee5-4bdc-85e5-2520a5f85dd6	9d512152-5a59-47b5-baff-eb23cf62342a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 16:09:29
4165	9d512152-588c-4516-aa27-b9e999619607	9d512152-5a59-47b5-baff-eb23cf62342a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 16:09:29
4166	9d512152-595b-4465-b05c-1c7304975f26	9d512152-5a59-47b5-baff-eb23cf62342a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1118,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:09:29
40155	9d6cc123-41a6-45e9-a762-9c74dda8c7e0	9d6cc123-46ae-499b-97d5-fd3d3fe7c304	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:43:43
40156	9d6cc123-4209-4da2-9227-64cbf5cb126a	9d6cc123-46ae-499b-97d5-fd3d3fe7c304	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:43:43
40157	9d6cc123-456d-4bba-b7f3-b26a60a0743f	9d6cc123-46ae-499b-97d5-fd3d3fe7c304	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 09:43:43
40158	9d6cc123-45b6-424d-8ae6-14acd17ff2e3	9d6cc123-46ae-499b-97d5-fd3d3fe7c304	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":224,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:43:43
41466	9d6ccc9c-5d4e-4c29-9d0a-184b954b32d5	9d6ccc9c-5e74-433f-8ba1-a1279cd8ed21	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:48
41962	9d6cd174-ea94-4e20-bb42-e3b530f158ac	9d6cd174-ec0d-423d-92ab-60a18fc72d21	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/14","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}},"duration":564,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:29:21
4167	9d512152-a8b5-499b-b28f-b2c00ef16806	9d512152-cb21-4f91-a6d1-76e6d9af7c53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 16:09:29
4168	9d512152-c4d2-4b05-bf45-7faac99a9b6f	9d512152-cb21-4f91-a6d1-76e6d9af7c53	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":71,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:09:29
4169	9d512152-c52a-4f26-8bdd-32f2b7a7708b	9d512152-cb21-4f91-a6d1-76e6d9af7c53	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 16:09:29
4170	9d512152-c986-42c3-83dd-1e8dd6d0314c	9d512152-cb21-4f91-a6d1-76e6d9af7c53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 16:09:29
4171	9d512152-c9dd-459b-96da-5eb4c0223123	9d512152-cb21-4f91-a6d1-76e6d9af7c53	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:09:29
4687	9d51346a-8062-41f4-ad75-67675e8c2158	9d51346a-82fd-437b-a551-bfc7e6619082	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":144,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:02:53
5239	9d513779-bd1c-42c8-bcf2-cf83b8f1ae53	9d51377a-04f5-4330-b487-b3386005bcbb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 17:11:26
5240	9d513779-feb9-45f1-8e2d-d8cf2d994ce5	9d51377a-04f5-4330-b487-b3386005bcbb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"144.71","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:11:26
5241	9d513779-ff0f-43ce-8e76-b8baa1b4d9f8	9d51377a-04f5-4330-b487-b3386005bcbb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:11:26
5242	9d51377a-035c-4300-9f0c-db68e0c6a7eb	9d51377a-04f5-4330-b487-b3386005bcbb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 17:11:26
5243	9d51377a-03a4-4be2-8f71-34d3c6f76d19	9d51377a-04f5-4330-b487-b3386005bcbb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":383,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:11:26
10883	9d5ca561-6f22-4ce1-812b-7f32f3068361	9d5ca561-8b75-4890-9ca3-06eeb1c393b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 09:32:51
10884	9d5ca561-8695-420a-b685-5d60afe9ead0	9d5ca561-8b75-4890-9ca3-06eeb1c393b3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 09:32:51
10885	9d5ca561-86de-4b14-91b7-1b10f5240fde	9d5ca561-8b75-4890-9ca3-06eeb1c393b3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 09:32:51
10886	9d5ca561-8a77-4ffd-bb9d-1c2cbc864e52	9d5ca561-8b75-4890-9ca3-06eeb1c393b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 09:32:51
10887	9d5ca561-8abc-4a6d-a233-24957f21bd61	9d5ca561-8b75-4890-9ca3-06eeb1c393b3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":217,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:32:51
40159	9d6cc123-8723-49c0-b04c-9c7eccdbe040	9d6cc123-c6c6-43fe-9403-55441154b24d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 09:43:43
41467	9d6ccc9c-a4fc-4168-86b1-206d230d1f72	9d6ccc9c-c47c-4600-9c12-211c8ca1e69c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 10:15:48
4172	9d512153-191f-47a9-bb9c-4b97e9e4ecf9	9d512153-3fb0-402f-8897-7c78db47faa0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 16:09:30
4173	9d512153-37d0-4820-9220-99cd5a59d98b	9d512153-3fb0-402f-8897-7c78db47faa0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":71,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:09:30
4174	9d512153-3844-407c-b9de-abf57b2d2bb7	9d512153-3fb0-402f-8897-7c78db47faa0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 16:09:30
4175	9d512153-3dcf-4f98-89c0-baa1e0654c31	9d512153-3fb0-402f-8897-7c78db47faa0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 16:09:30
4176	9d512153-3e47-4ad9-baad-9469ac822197	9d512153-3fb0-402f-8897-7c78db47faa0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":284,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:09:30
4688	9d51346b-350c-4719-9385-5032bd2ef2fb	9d51346b-5318-4d5f-b6e5-e50c1a385435	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 17:02:53
4689	9d51346b-4eb4-4f3f-b462-5791d83ca831	9d51346b-5318-4d5f-b6e5-e50c1a385435	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"49.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":46,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 17:02:53
4690	9d51346b-51b2-4667-84e9-29449c7a6c5a	9d51346b-5318-4d5f-b6e5-e50c1a385435	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 17:02:53
4691	9d51346b-51f5-4793-bbd1-89198a70f58c	9d51346b-5318-4d5f-b6e5-e50c1a385435	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":221,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:02:53
5244	9d51377a-4a62-43ce-a818-c256ed62db08	9d51377a-6ba1-4346-bf4f-112c91aa7a96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 17:11:26
4712	9d5134b4-3b87-4469-acf6-82046e8d9d5f	9d5134b4-7c25-42b3-874f-4db37ea2577c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-23 17:03:41
4713	9d5134b4-791d-4575-a56f-4140c35f2488	9d5134b4-7c25-42b3-874f-4db37ea2577c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-23 17:03:41
4714	9d5134b4-7aa1-4de3-88c3-24f772925a9c	9d5134b4-7c25-42b3-874f-4db37ea2577c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":515,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:03:41
5245	9d51377a-65c6-43f3-bd51-a4dc1ae30340	9d51377a-6ba1-4346-bf4f-112c91aa7a96	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:11:26
5246	9d51377a-6621-4caf-bc6c-eabe53a5df5b	9d51377a-6ba1-4346-bf4f-112c91aa7a96	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:11:26
5247	9d51377a-6a8c-4818-b2a6-12342f0ddd29	9d51377a-6ba1-4346-bf4f-112c91aa7a96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 17:11:26
5248	9d51377a-6ace-4788-b626-b00bf376d38a	9d51377a-6ba1-4346-bf4f-112c91aa7a96	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:11:26
4177	9d512153-cb46-42a8-8732-b6e930f7cce1	9d512154-155a-4a7e-af22-9b71de998ca7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 16:09:30
4178	9d512154-0aae-4517-b997-1beebcb7788b	9d512154-155a-4a7e-af22-9b71de998ca7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"103.51","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 16:09:30
4179	9d512154-0b72-4e95-8aec-63f091fdc40b	9d512154-155a-4a7e-af22-9b71de998ca7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 16:09:30
4180	9d512154-1343-4935-9f69-52e8fd71d6ab	9d512154-155a-4a7e-af22-9b71de998ca7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 16:09:30
4181	9d512154-13ca-4bf8-8062-ecd697800e36	9d512154-155a-4a7e-af22-9b71de998ca7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":526,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:09:30
4692	9d51346e-b5ac-4d2d-9eca-200a4c0949e9	9d51346e-d477-4a7f-9893-ba60858d4c42	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 17:02:55
4693	9d51346e-ce22-438d-941b-2f2ddf5661de	9d51346e-d477-4a7f-9893-ba60858d4c42	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null","time":"42.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":28,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-23 17:02:55
4694	9d51346e-ce6f-4a8f-8dc4-f5448647c660	9d51346e-d477-4a7f-9893-ba60858d4c42	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:02:55
4695	9d51346e-d2ef-4c97-be54-197aafb06752	9d51346e-d477-4a7f-9893-ba60858d4c42	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 17:02:55
4696	9d51346e-d350-479b-85f0-392ddc1bbac0	9d51346e-d477-4a7f-9893-ba60858d4c42	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null}]},"duration":300,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:02:55
4715	9d5134b5-130d-42d1-9017-749847119914	9d5134b5-4c87-416b-86f1-8b79a081ada1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-23 17:03:41
4716	9d5134b5-4374-4f5e-baa4-946c277255e0	9d5134b5-4c87-416b-86f1-8b79a081ada1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"76.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:03:42
4717	9d5134b5-4401-4317-8b74-118704b09313	9d5134b5-4c87-416b-86f1-8b79a081ada1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:03:42
4718	9d5134b5-4aa4-4242-8be7-63098128063d	9d5134b5-4c87-416b-86f1-8b79a081ada1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-23 17:03:42
4719	9d5134b5-4b26-4da4-8c44-6ffa883e5194	9d5134b5-4c87-416b-86f1-8b79a081ada1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":491,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:03:42
10888	9d5ca561-d053-488c-9cc3-43fea468196a	9d5ca562-26d9-49ee-b71b-11dafcffbbac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 09:32:52
10889	9d5ca562-18ab-4832-ad04-5d5f5dbc76e7	9d5ca562-26d9-49ee-b71b-11dafcffbbac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '1' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"142.78","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-29 09:32:52
4182	9d512154-c6c6-41c3-8f1c-e4d89b7b3e3d	9d512154-fdd4-45de-925a-d8ba70e5dea5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 16:09:31
4183	9d512154-f2f7-4955-9cb8-ba557939a524	9d512154-fdd4-45de-925a-d8ba70e5dea5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"83.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 16:09:31
4184	9d512154-f394-4c34-b124-861e0a2dd054	9d512154-fdd4-45de-925a-d8ba70e5dea5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 16:09:31
4185	9d512154-fb9e-4782-b85a-7f38a99d8c38	9d512154-fdd4-45de-925a-d8ba70e5dea5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 16:09:31
4186	9d512154-fc2e-44b5-b0db-91cca7a57f5c	9d512154-fdd4-45de-925a-d8ba70e5dea5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":506,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:09:31
10890	9d5ca562-190f-47eb-a695-4f8d530c8c8c	9d5ca562-26d9-49ee-b71b-11dafcffbbac	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-29 09:32:52
6240	9d526316-f36f-436d-bdb7-c4e0e5f9a38d	9d526317-127b-480c-892b-668e4f4563a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 07:09:13
4720	9d5134b5-c2e7-44e8-8d4c-1f9f462f13c2	9d5134b5-ec81-45a7-8266-0e4202a3d93a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-23 17:03:42
4721	9d5134b5-e56d-42d3-b38b-5e61492c9474	9d5134b5-ec81-45a7-8266-0e4202a3d93a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"55.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:03:42
4722	9d5134b5-e5ee-4f75-b29c-a7e378082a28	9d5134b5-ec81-45a7-8266-0e4202a3d93a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:03:42
4723	9d5134b5-eadd-4c8b-80e2-7182ef2b48b8	9d5134b5-ec81-45a7-8266-0e4202a3d93a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-23 17:03:42
6241	9d526317-108d-4bde-811d-0dd78dcaf01e	9d526317-127b-480c-892b-668e4f4563a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 07:09:13
6242	9d526317-1171-40d3-b318-dc01932efc68	9d526317-127b-480c-892b-668e4f4563a6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abfrom\\u00bb\\nLINE 14:     from loans l\\n             ^ (Connection: pgsql, SQL: \\n    select l.id,\\n        l.loans_documento,\\n        l.loans_nombre,\\n        l.loans_apellido_uno,\\n        l.loans_fecha,\\n        l.loans_valor_prestado,\\n        l.loans_cuotas,\\n        l.loans_estado,\\n        l.loans_intereses,\\n        ucl.name as cliente,\\n        uco.name as cobrador,\\n        ure.name as recomendador,\\n    from loans l\\n    join users ucl on l.user_customer = ucl.id\\n    join users uco on l.user_cobrador = uco.id\\n    left join users ure on l.user_recomendacion = ure.id\\n)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":338,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:09:13
10891	9d5ca562-2200-47ef-bacc-128e255a31f0	9d5ca562-26d9-49ee-b71b-11dafcffbbac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1' order by \\"item_loans\\".\\"id\\" asc","time":"2.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 09:32:52
10892	9d5ca562-224b-43cb-87c3-234b6bfa3a8a	9d5ca562-26d9-49ee-b71b-11dafcffbbac	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 09:32:52
10893	9d5ca562-25cc-404e-ae5d-a9182c36d466	9d5ca562-26d9-49ee-b71b-11dafcffbbac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 09:32:52
10894	9d5ca562-2612-4e70-8782-2907ea8205b6	9d5ca562-26d9-49ee-b71b-11dafcffbbac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":1,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]}},"duration":383,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:32:52
40160	9d6cc123-c2ca-4b97-b65d-a7f1dabdcd9e	9d6cc123-c6c6-43fe-9403-55441154b24d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"140.37","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:43:43
40161	9d6cc123-c589-4baf-9c92-e7e1702d700e	9d6cc123-c6c6-43fe-9403-55441154b24d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 09:43:43
6243	9d526319-7c54-4de5-8e42-80377e204908	9d526319-d69c-41fb-9542-8edc8d78f595	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 07:09:14
6244	9d526319-c7b2-4552-b563-5799c61b883d	9d526319-d69c-41fb-9542-8edc8d78f595	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"139.50","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 07:09:15
6245	9d526319-c86f-4729-8ad0-aeacaada284e	9d526319-d69c-41fb-9542-8edc8d78f595	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 07:09:15
6246	9d526319-d385-4ef5-9d44-85e6bf186dda	9d526319-d69c-41fb-9542-8edc8d78f595	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 07:09:15
6247	9d526319-d430-4fd1-b49e-bb2fb3dbfa20	9d526319-d69c-41fb-9542-8edc8d78f595	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":602,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:09:15
10895	9d5ca56a-1839-4536-8761-b3092a5f7767	9d5ca56a-5a84-4c26-88df-a0ab5b16e483	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 09:32:57
10896	9d5ca56a-5670-43b5-9efe-7ea743492225	9d5ca56a-5a84-4c26-88df-a0ab5b16e483	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"146.15","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-29 09:32:57
10897	9d5ca56a-5940-4812-96df-0aeb00318857	9d5ca56a-5a84-4c26-88df-a0ab5b16e483	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 09:32:57
10898	9d5ca56a-5982-4b37-a327-1434fd26d175	9d5ca56a-5a84-4c26-88df-a0ab5b16e483	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:32:57
40162	9d6cc123-c5d1-41e9-bf8a-428b8b4c203a	9d6cc123-c6c6-43fe-9403-55441154b24d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":309,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:43:43
41468	9d6ccc9c-bf22-4c5e-8295-a8ed3e146707	9d6ccc9c-c47c-4600-9c12-211c8ca1e69c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"47.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 10:15:48
41469	9d6ccc9c-c2f2-4962-a4f8-ae8d39fc9c79	9d6ccc9c-c47c-4600-9c12-211c8ca1e69c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 10:15:48
41470	9d6ccc9c-c36b-4158-b1b6-8a5c7f3e7872	9d6ccc9c-c47c-4600-9c12-211c8ca1e69c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:48
40163	9d6cc124-05bb-4ae7-abd2-72b81be4a32e	9d6cc124-0898-467c-b1a9-42c3ad766888	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":141,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:43:43
11077	9d5caab3-07ed-43fc-8b3d-b2a4c2af48da	9d5caab3-2c27-4c07-be0a-25b29324b834	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 09:47:44
11078	9d5caab3-2a10-46c1-8e5e-550f356aa4dc	9d5caab3-2c27-4c07-be0a-25b29324b834	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 09:47:44
11079	9d5caab3-2ae9-4de7-90ea-7dfa2b66de5f	9d5caab3-2c27-4c07-be0a-25b29324b834	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":300,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:47:44
10993	9d5ca764-1338-49df-b57c-dcd5e8056f8c	9d5ca764-3880-4d14-a559-7a92526d2239	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 09:38:29
10994	9d5ca764-3655-4236-a00a-519384ea763c	9d5ca764-3880-4d14-a559-7a92526d2239	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 09:38:29
10995	9d5ca764-371c-4995-94b5-295bd0c9fbb0	9d5ca764-3880-4d14-a559-7a92526d2239	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":308,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:38:29
41471	9d6ccce3-ab0e-4257-9968-fcbc5c61958d	9d6ccce3-aee0-4400-bee0-85cd60dd6445	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":297,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:16:35
41963	9d6cd17b-03bc-40d9-a18b-c528452f40fa	9d6cd17b-0766-46c5-9a89-00a05dd09b42	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":347,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:29:25
42050	9d6cd3bd-4a9e-467d-8551-0a7422bf1a94	9d6cd3bd-4b88-4630-b9a5-716e2523dddd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":363,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:35:44
43428	9d6ce848-6c07-4c99-bb48-e1ab7be583ba	9d6ce848-6d1b-491e-9db8-d37b55532bb6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:55:01.000000Z","deleted_at":null,"user_alias":"eder.cortes"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":410,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:33:10
10996	9d5ca765-f85f-4478-b85a-cea078507ef9	9d5ca766-4226-428a-9e79-5224e292c15e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 09:38:30
10997	9d5ca766-3cda-4023-9a01-fe55c384b58f	9d5ca766-4226-428a-9e79-5224e292c15e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"153.56","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 09:38:30
10998	9d5ca766-3d23-488c-b99a-00b857df830b	9d5ca766-4226-428a-9e79-5224e292c15e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 09:38:30
7867	9d52e27b-1279-4d1c-a88c-5ad494c7461f	9d52e27b-395b-4c7e-9077-08e801db5c1c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:05:25
6283	9d52640c-04d6-445b-9a2e-3d07e0f9331f	9d52640c-21d6-4fb2-89d3-3c74f6a6f625	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 07:11:53
6284	9d52640c-1fe4-4027-92b2-5d3986c7c5d6	9d52640c-21d6-4fb2-89d3-3c74f6a6f625	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 07:11:53
6285	9d52640c-208b-4eb1-89bd-6cd9c093a3a7	9d52640c-21d6-4fb2-89d3-3c74f6a6f625	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abfrom\\u00bb\\nLINE 14:     from loans l\\n             ^ (Connection: pgsql, SQL: \\n    select l.id,\\n        l.loans_documento,\\n        l.loans_nombre,\\n        l.loans_apellido_uno,\\n        l.loans_fecha,\\n        l.loans_valor_prestado,\\n        l.loans_cuotas,\\n        l.loans_estado,\\n        l.loans_intereses,\\n        ucl.name as cliente,\\n        uco.name as cobrador,\\n        ure.name as recomendador,\\n    from loans l\\n    join users ucl on l.user_customer = ucl.id\\n    join users uco on l.user_cobrador = uco.id\\n    left join users ure on l.user_recomendacion = ure.id\\n)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":383,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:11:53
7868	9d52e27b-371a-43af-8cfa-8c33d277db71	9d52e27b-395b-4c7e-9077-08e801db5c1c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:05:26
7869	9d52e27b-3815-4bd3-b65c-2d1c0e02fcc1	9d52e27b-395b-4c7e-9077-08e801db5c1c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":302,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:05:26
10999	9d5ca766-40f5-4c6e-8965-6e1e9bcaaa28	9d5ca766-4226-428a-9e79-5224e292c15e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 09:38:30
11000	9d5ca766-4139-4fbe-ae62-88282cfcef0f	9d5ca766-4226-428a-9e79-5224e292c15e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":504,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:38:30
11080	9d5caab3-b07f-49ec-852c-c97a60efcd9f	9d5caab3-ce8a-4e7d-9e79-cc98ebbc595b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 09:47:44
11081	9d5caab3-c599-42ff-88e2-e1aa09ddbdee	9d5caab3-ce8a-4e7d-9e79-cc98ebbc595b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 1\\n                        ","time":"41.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"2bd5a29c69f6bbb290fc49b79286632e","hostname":"EderCortes"}	2024-10-29 09:47:44
11082	9d5caab3-c90a-44dd-ae2b-52c2b9d96de8	9d5caab3-ce8a-4e7d-9e79-cc98ebbc595b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1' order by \\"item_loans\\".\\"id\\" asc","time":"2.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 09:47:44
11083	9d5caab3-c93d-499a-b2f4-7b0f1b16118b	9d5caab3-ce8a-4e7d-9e79-cc98ebbc595b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 09:47:44
11084	9d5caab3-cd6a-40d0-92d3-cee9c31af2b9	9d5caab3-ce8a-4e7d-9e79-cc98ebbc595b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 09:47:44
11085	9d5caab3-cdaf-43a8-b80d-446d1130aace	9d5caab3-ce8a-4e7d-9e79-cc98ebbc595b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":1,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]}},"duration":380,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:47:44
40164	9d6cc124-5d60-4e09-b2f1-864fe4ac13cd	9d6cc124-7932-4cf8-8115-8500f198bd37	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 09:43:44
42051	9d6cd3bd-8ad0-47d2-9a0c-3d2274daea3b	9d6cd3bd-a36a-4c2f-acb7-f2057bedc854	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:35:44
7870	9d52e27b-9342-46b9-aab7-b107319928e4	9d52e27b-b8ab-4c4f-9cc9-f82e57b37f88	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:05:26
7871	9d52e27b-b17b-4609-98b5-e49d45b180ca	9d52e27b-b8ab-4c4f-9cc9-f82e57b37f88	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:05:26
7872	9d52e27b-b1e9-4f9a-81ca-b1ea86aa38fc	9d52e27b-b8ab-4c4f-9cc9-f82e57b37f88	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:05:26
3594	9d5108ea-fca9-43d8-b081-a9bb948f3204	9d5108eb-4d00-486b-b87e-c412f3cad1d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 15:01:15
3595	9d5108eb-498f-4b77-afa2-530d8af2d039	9d5108eb-4d00-486b-b87e-c412f3cad1d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 15:01:15
3596	9d5108eb-4b46-499e-b49f-264834364288	9d5108eb-4d00-486b-b87e-c412f3cad1d1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":725,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:01:15
7873	9d52e27b-b770-4d2c-8016-6b923c0c8028	9d52e27b-b8ab-4c4f-9cc9-f82e57b37f88	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:05:26
7874	9d52e27b-b7ba-4c29-a5f1-bed277ed9f28	9d52e27b-b8ab-4c4f-9cc9-f82e57b37f88	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":294,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:05:26
11086	9d5caab5-aa43-4978-a7c1-b7f7ca6c6b11	9d5caab5-c8ed-43a5-bc1d-2902bb8743d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 09:47:45
11087	9d5caab5-c341-4390-80e9-0fb8183b2736	9d5caab5-c8ed-43a5-bc1d-2902bb8743d7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 09:47:45
11088	9d5caab5-c3ae-45b9-ba2d-63ad49c459bd	9d5caab5-c8ed-43a5-bc1d-2902bb8743d7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 09:47:45
11089	9d5caab5-c794-4af9-b849-7918df562034	9d5caab5-c8ed-43a5-bc1d-2902bb8743d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 09:47:45
11090	9d5caab5-c7d9-470a-ac25-a424381b68f2	9d5caab5-c8ed-43a5-bc1d-2902bb8743d7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:47:45
40165	9d6cc124-749e-4181-ad5e-2e805397c694	9d6cc124-7932-4cf8-8115-8500f198bd37	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"41.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 09:43:44
40166	9d6cc124-77c6-4055-a2a4-d3d2e5b86b98	9d6cc124-7932-4cf8-8115-8500f198bd37	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-06 09:43:44
40167	9d6cc124-783c-4728-9be4-944a4501ed5e	9d6cc124-7932-4cf8-8115-8500f198bd37	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:43:44
42052	9d6cd3bd-9f74-4b2e-9b99-e8145ced1edd	9d6cd3bd-a36a-4c2f-acb7-f2057bedc854	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"41.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:35:44
42053	9d6cd3bd-a215-4794-98f8-2f11f50cc005	9d6cd3bd-a36a-4c2f-acb7-f2057bedc854	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:35:44
42054	9d6cd3bd-a264-4413-8287-b332b752a735	9d6cd3bd-a36a-4c2f-acb7-f2057bedc854	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":212,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:35:44
4303	9d512a48-c29e-4059-bd90-b6ac32e01a40	9d512a48-ed38-44d5-b4e3-ae92ecef612a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 16:34:33
4304	9d512a48-eb63-49cf-b2db-eda2fe0767c3	9d512a48-ed38-44d5-b4e3-ae92ecef612a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 16:34:33
4305	9d512a48-ec06-4092-a904-666d74fb3872	9d512a48-ed38-44d5-b4e3-ae92ecef612a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":302,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:34:33
4306	9d512a49-4216-49ac-bd90-8fba7815e1a9	9d512a49-6531-4087-b7fe-0b6e1b37ebee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 16:34:33
4307	9d512a49-5dfb-4c28-acf5-73607ccc7823	9d512a49-6531-4087-b7fe-0b6e1b37ebee	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:34:33
4308	9d512a49-5e56-4672-a061-8a016a9e7ac9	9d512a49-6531-4087-b7fe-0b6e1b37ebee	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 16:34:33
4309	9d512a49-6364-47a9-8e45-7f980290ff4a	9d512a49-6531-4087-b7fe-0b6e1b37ebee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 16:34:33
4310	9d512a49-63e0-40c6-9bbe-dd85ddfe10cc	9d512a49-6531-4087-b7fe-0b6e1b37ebee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":274,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:34:33
6163	9d5259b2-3eb7-443a-b121-c1dcaedd2c26	9d5259b2-8b83-423c-b154-f47fb564fec1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 06:42:57
6164	9d5259b2-89bd-462c-abff-d036b1a68112	9d5259b2-8b83-423c-b154-f47fb564fec1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 06:42:57
6165	9d5259b2-8a6a-40e6-8f9f-ed7da16d09c5	9d5259b2-8b83-423c-b154-f47fb564fec1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":371,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:42:57
983	9d4f3b9c-ea3f-42ea-b9a7-269ed27824a5	9d4f3b9c-ee2b-46ea-8618-3bb17b8512bd	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42P01]: Undefined table: 7 ERROR:  falta una entrada para la tabla \\u00abuser\\u00bb en la cl\\u00e1usula FROM\\nLINE 1: select * from \\"users\\" where \\"user\\".\\"profile_code\\" = $1 and \\"...\\n                                    ^ (Connection: pgsql, SQL: select * from \\"users\\" where \\"user\\".\\"profile_code\\" = 4 and \\"users\\".\\"deleted_at\\" is null order by \\"menu\\".\\"created_at\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":77}	2024-10-22 17:31:21
4311	9d512a49-bd73-4acb-8ce7-db44f9ae6a7c	9d512a49-e963-436a-bbf5-1a5bbf5bf648	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 16:34:33
4312	9d512a49-e0d6-4a57-ae01-0bc9590b4213	9d512a49-e963-436a-bbf5-1a5bbf5bf648	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"55.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:34:33
4313	9d512a49-e137-43bb-b2b3-9b4338127b7b	9d512a49-e963-436a-bbf5-1a5bbf5bf648	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 16:34:33
4314	9d512a49-e7a2-42b4-9295-7b4e04f22e85	9d512a49-e963-436a-bbf5-1a5bbf5bf648	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 16:34:33
4315	9d512a49-e81a-40a4-9ca4-be0b70dce21c	9d512a49-e963-436a-bbf5-1a5bbf5bf648	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":320,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:34:33
6166	9d5259b3-fb9f-462c-8901-310cfeee3316	9d5259b4-4679-4cf7-96d0-2fcbf6263770	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 06:42:58
6167	9d5259b4-3e26-40d4-918f-a1cb2701c376	9d5259b4-4679-4cf7-96d0-2fcbf6263770	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"139.26","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 06:42:58
4724	9d5134b5-eb40-4eff-a376-4eb2daab78a8	9d5134b5-ec81-45a7-8266-0e4202a3d93a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":392,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:03:42
6168	9d5259b4-3e8f-4ea1-aa70-9b722d7cac14	9d5259b4-4679-4cf7-96d0-2fcbf6263770	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 06:42:58
6169	9d5259b4-4497-4988-b6f5-8d4625c5af61	9d5259b4-4679-4cf7-96d0-2fcbf6263770	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 06:42:58
6170	9d5259b4-450b-4b67-a226-482298d90278	9d5259b4-4679-4cf7-96d0-2fcbf6263770	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":511,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:42:58
7875	9d52e27c-09e8-4c7c-9e4e-d2b742006373	9d52e27c-5967-4e26-ac6b-e2f40bc16b54	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:05:26
7876	9d52e27c-5293-4ca1-b6ad-40eb297d0bb5	9d52e27c-5967-4e26-ac6b-e2f40bc16b54	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"156.55","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:05:26
7877	9d52e27c-530c-4775-9dcf-a099f9889b94	9d52e27c-5967-4e26-ac6b-e2f40bc16b54	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:05:26
7878	9d52e27c-5840-4831-bf2b-d367b7c511f0	9d52e27c-5967-4e26-ac6b-e2f40bc16b54	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:05:26
4316	9d512a4b-ce7e-4582-b632-74e34cee12d8	9d512a4b-f5f0-4db6-82cd-4ec402a719f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 16:34:35
4317	9d512a4b-f08e-4002-8139-453c3c495305	9d512a4b-f5f0-4db6-82cd-4ec402a719f6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"61.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 16:34:35
4318	9d512a4b-f0db-4cd4-a521-bde74a3d7351	9d512a4b-f5f0-4db6-82cd-4ec402a719f6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 16:34:35
4319	9d512a4b-f496-4ef0-8c0f-40bc8330c505	9d512a4b-f5f0-4db6-82cd-4ec402a719f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 16:34:35
4320	9d512a4b-f4e2-4b89-9815-76222bb84451	9d512a4b-f5f0-4db6-82cd-4ec402a719f6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":295,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:34:35
4725	9d5134b6-98de-4254-b188-c4b704cec0ef	9d5134b6-fae3-45bb-94e5-c08bab7434bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-23 17:03:42
4726	9d5134b6-f03f-45a0-9518-54211563e7ec	9d5134b6-fae3-45bb-94e5-c08bab7434bf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"156.87","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:03:43
4727	9d5134b6-f0c3-4eca-9960-ecec86ab195f	9d5134b6-fae3-45bb-94e5-c08bab7434bf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:03:43
4728	9d5134b6-f884-4d11-9b9f-7aae63e6617c	9d5134b6-fae3-45bb-94e5-c08bab7434bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-23 17:03:43
5384	9d513888-304c-4e52-87be-d6b1f008c5c4	9d513888-4f4d-4ed2-9c50-3a63a269f013	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 17:14:23
5385	9d513888-4dbe-4abc-99c4-1d601b206a46	9d513888-4f4d-4ed2-9c50-3a63a269f013	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 17:14:23
5386	9d513888-4e64-4a6f-813b-10ef2205d1b6	9d513888-4f4d-4ed2-9c50-3a63a269f013	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":261,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:14:23
4321	9d512a51-6dca-4787-accb-28761048eb68	9d512a51-713b-4836-aae1-94b3908209e9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":141,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:34:38
5387	9d513888-965f-45a7-bce1-0beed005d6a2	9d513888-b583-4e1b-ba07-c15dfa62dd53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 17:14:23
5388	9d513888-b09c-4b83-8671-a70a738dae54	9d513888-b583-4e1b-ba07-c15dfa62dd53	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:14:23
5389	9d513888-b0e6-4001-8b35-7eefaf47dc19	9d513888-b583-4e1b-ba07-c15dfa62dd53	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:14:23
4729	9d5134b6-f92d-44ed-809e-4f612471a175	9d5134b6-fae3-45bb-94e5-c08bab7434bf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":672,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:03:43
5390	9d513888-b456-467b-9bca-fb8375cd14a4	9d513888-b583-4e1b-ba07-c15dfa62dd53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 17:14:23
5391	9d513888-b4b1-4f8f-b57b-5828c65ff004	9d513888-b583-4e1b-ba07-c15dfa62dd53	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:14:23
7879	9d52e27c-588a-4643-8615-cc2a933d57b4	9d52e27c-5967-4e26-ac6b-e2f40bc16b54	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":396,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:05:26
40168	9d6cc128-631b-465d-ac4d-5dd5b005d391	9d6cc128-65c6-4f53-aaf4-8d2d480462ec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":150,"memory":20,"hostname":"EderCortes"}	2024-11-06 09:43:46
4322	9d512a52-2685-421e-a9de-845a7ed1e0da	9d512a52-7391-4ffd-98b9-88be4187cdb8	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 16:34:39
4323	9d512a52-6e19-4a59-8be4-0ba54ddda09a	9d512a52-7391-4ffd-98b9-88be4187cdb8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"151.03","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":46,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 16:34:39
4324	9d512a52-71d4-4d1d-a348-e694d6c131b4	9d512a52-7391-4ffd-98b9-88be4187cdb8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 16:34:39
4325	9d512a52-7239-4a25-a254-0fbe5fc4e38a	9d512a52-7391-4ffd-98b9-88be4187cdb8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:34:39
5392	9d513888-fe50-47bf-b58e-051b61c1d57f	9d513889-1dad-476d-abf0-f58f7c1ab6cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 17:14:24
5393	9d513889-1842-45f0-9287-725322e92d6b	9d513889-1dad-476d-abf0-f58f7c1ab6cf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:14:24
5394	9d513889-189e-4835-b4b9-5c3017dde8a3	9d513889-1dad-476d-abf0-f58f7c1ab6cf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:14:24
4730	9d5134b7-dc54-47bf-8600-9a3fabe6c211	9d5134b8-29ba-41b9-a5ee-732ace02954c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-23 17:03:43
5395	9d513889-1c1b-417a-a39f-38e11e5d01c5	9d513889-1dad-476d-abf0-f58f7c1ab6cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 17:14:24
5396	9d513889-1c84-43e8-a1f3-06f039e010a5	9d513889-1dad-476d-abf0-f58f7c1ab6cf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:14:24
7880	9d52e27c-abbb-4d06-a1bf-75d10a1b9528	9d52e27c-d0a9-4bcf-ac9c-28590b051bd4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:05:27
7881	9d52e27c-c755-4349-b0a1-c261dff84d76	9d52e27c-d0a9-4bcf-ac9c-28590b051bd4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc","time":"46.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 13:05:27
7882	9d52e27c-c7b6-4a5e-92fc-c88c0de8c37b	9d52e27c-d0a9-4bcf-ac9c-28590b051bd4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:05:27
7883	9d52e27c-c9ca-43c2-839e-cd7590e9cf6e	9d52e27c-d0a9-4bcf-ac9c-28590b051bd4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6'","time":"2.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 13:05:27
7884	9d52e27c-ca0f-4df8-ae04-b2e528cbd536	9d52e27c-d0a9-4bcf-ac9c-28590b051bd4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:05:27
7885	9d52e27c-cf57-40f0-9c13-2252c1f65ff0	9d52e27c-d0a9-4bcf-ac9c-28590b051bd4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:05:27
7886	9d52e27c-cfb3-4bd8-8073-ca31137f8673	9d52e27c-d0a9-4bcf-ac9c-28590b051bd4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":289,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:05:27
15204	9d5ecf45-98c0-4c84-866a-8dd112bf297d	9d5ecf45-c82d-46da-b80c-e2e3cdfc18f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-30 11:21:39
4326	9d512a57-1882-4c57-ba65-88412e330015	9d512a57-6065-4026-9b44-f7f1ab579869	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 16:34:42
4327	9d512a57-5b4a-4b3c-8646-af9d3b000e38	9d512a57-6065-4026-9b44-f7f1ab579869	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '12' and \\"users\\".\\"deleted_at\\" is null","time":"146.25","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":28,"hash":"6a5e9ca54a4ff9f4974618718591b207","hostname":"EderCortes"}	2024-10-23 16:34:42
4328	9d512a57-5ee0-4883-8ad1-c01bb7f7e832	9d512a57-6065-4026-9b44-f7f1ab579869	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 16:34:42
4329	9d512a57-5f3b-4175-9261-881ae395330b	9d512a57-6065-4026-9b44-f7f1ab579869	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[]},"duration":401,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:34:42
7887	9d52e27e-d61c-4a10-991c-649b973fe573	9d52e27e-fbe2-495f-b586-7b2d093e1ca6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:05:28
7888	9d52e27e-f546-4a0a-abde-afea3bcea9f4	9d52e27e-fbe2-495f-b586-7b2d093e1ca6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"49.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:05:28
7889	9d52e27e-f59e-4578-bc80-7ca6fabebc08	9d52e27e-fbe2-495f-b586-7b2d093e1ca6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:05:28
7890	9d52e27e-f9b0-4a56-b2b5-bd524a7ccf25	9d52e27e-fbe2-495f-b586-7b2d093e1ca6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:05:28
7891	9d52e27e-fa26-46b2-b0bb-6a55b8cf8b5d	9d52e27e-fbe2-495f-b586-7b2d093e1ca6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":343,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:05:28
40169	9d6cc128-b535-499c-a872-a893f1f40bce	9d6cc128-d4cd-442b-bec5-9f55b74d342a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-06 09:43:46
11167	9d5cabf2-d355-44dd-ae75-772b04948692	9d5cabf3-295b-4997-ab66-f5abddb348be	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 09:51:13
11168	9d5cabf3-2646-41df-a6eb-2c3acd995618	9d5cabf3-295b-4997-ab66-f5abddb348be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 09:51:13
11169	9d5cabf3-27c8-458c-b7d1-f6efed2543a2	9d5cabf3-295b-4997-ab66-f5abddb348be	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":530,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:51:13
40170	9d6cc128-cf62-438b-8059-79ebdf7619d9	9d6cc128-d4cd-442b-bec5-9f55b74d342a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 09:43:47
40171	9d6cc128-cfb1-4e23-a3c0-dcceb2adc2dd	9d6cc128-d4cd-442b-bec5-9f55b74d342a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 09:43:47
40172	9d6cc128-d3a3-4ffe-a1bb-792f43b6c40f	9d6cc128-d4cd-442b-bec5-9f55b74d342a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-06 09:43:47
40173	9d6cc128-d3ea-4b90-9e1f-f8e12b7980ef	9d6cc128-d4cd-442b-bec5-9f55b74d342a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:43:47
11170	9d5cabf3-e07a-4f5d-acad-0c6197a13c5a	9d5cabf4-a30b-48ff-91a5-f22f5f0d99a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 09:51:14
11171	9d5cabf4-937e-45d9-87a0-5f51c75e28a5	9d5cabf4-a30b-48ff-91a5-f22f5f0d99a7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 1\\n                        ","time":"441.27","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"2bd5a29c69f6bbb290fc49b79286632e","hostname":"EderCortes"}	2024-10-29 09:51:14
11172	9d5cabf4-9931-4831-88a3-d156d6cb2e29	9d5cabf4-a30b-48ff-91a5-f22f5f0d99a7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1' order by \\"item_loans\\".\\"id\\" asc","time":"2.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 09:51:14
11173	9d5cabf4-998b-4051-b6d0-0a3417fa82b1	9d5cabf4-a30b-48ff-91a5-f22f5f0d99a7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 09:51:14
6325	9d526477-dd88-413f-8375-67751648633f	9d526478-2011-4394-a8f5-14c3a614043d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 07:13:04
6326	9d526478-1e5b-4b76-ac97-d043637a6d69	9d526478-2011-4394-a8f5-14c3a614043d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 07:13:04
8023	9d52e5fa-733a-4ef5-82aa-f3e2c41260d5	9d52e5fa-9342-4404-85d6-609cc3182a32	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:15:12
11174	9d5cabf4-a18c-460a-a718-643b27291a22	9d5cabf4-a30b-48ff-91a5-f22f5f0d99a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 09:51:14
11175	9d5cabf4-a1eb-4678-b3a7-307e5c84abf9	9d5cabf4-a30b-48ff-91a5-f22f5f0d99a7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":1,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]}},"duration":933,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:51:14
40174	9d6cc129-1776-434b-ba5b-a6e27ae521ec	9d6cc129-388b-4eda-906f-7f33ad7f1874	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-06 09:43:47
15205	9d5ecf45-b837-45ff-9100-bd2f4e6014a7	9d5ecf45-c82d-46da-b80c-e2e3cdfc18f5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"58.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"088d1fdbe045a08c3b0073ef22c7da32","hostname":"EderCortes"}	2024-10-30 11:21:39
15206	9d5ecf45-bec4-487a-ad90-c84d4934d362	9d5ecf45-c82d-46da-b80c-e2e3cdfc18f5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"3.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-30 11:21:39
15207	9d5ecf45-bf21-41cd-a63a-491cba95d1f2	9d5ecf45-c82d-46da-b80c-e2e3cdfc18f5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-10-30 11:21:39
15208	9d5ecf45-c642-471f-98d7-4e412323edae	9d5ecf45-c82d-46da-b80c-e2e3cdfc18f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-30 11:21:39
40175	9d6cc129-31af-4a75-bcdc-4e3ee9996054	9d6cc129-388b-4eda-906f-7f33ad7f1874	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 09:43:47
40176	9d6cc129-3205-4e70-b387-f42e7524c961	9d6cc129-388b-4eda-906f-7f33ad7f1874	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 09:43:47
40177	9d6cc129-36fd-40d2-9f22-511f36403774	9d6cc129-388b-4eda-906f-7f33ad7f1874	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-06 09:43:47
6327	9d526478-1f16-4f22-847c-13bb9cd3c989	9d526478-2011-4394-a8f5-14c3a614043d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abfrom\\u00bb\\nLINE 13:     from loans l\\n             ^ (Connection: pgsql, SQL: \\n    select l.id,\\n        l.loans_documento,\\n        l.loans_nombre,\\n        l.loans_apellido_uno,\\n        l.loans_fecha,\\n        l.loans_valor_prestado,\\n        l.loans_cuotas,\\n        l.loans_estado,\\n        l.loans_intereses,\\n        uco.name as cobrador,\\n        ure.name as recomendador,\\n    from loans l\\n    join users ucl on l.user_customer = ucl.id\\n    join users uco on l.user_cobrador = uco.id\\n    left join users ure on l.user_recomendacion = ure.id\\n)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":400,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:13:04
8024	9d52e5fa-91af-4149-bd14-b2b3f425d154	9d52e5fa-9342-4404-85d6-609cc3182a32	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:15:12
8025	9d52e5fa-9250-4706-9266-37a9d9fb61b2	9d52e5fa-9342-4404-85d6-609cc3182a32	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:15:12
11176	9d5cabf6-cf59-4755-afb3-3475e61d40cd	9d5cabf7-1595-4514-ba00-4712b6399d3b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 09:51:16
11177	9d5cabf7-1041-4db9-980c-d056af579cc5	9d5cabf7-1595-4514-ba00-4712b6399d3b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"145.80","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 09:51:16
11178	9d5cabf7-10a3-43b4-ba02-9ae490569954	9d5cabf7-1595-4514-ba00-4712b6399d3b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 09:51:16
11179	9d5cabf7-144a-43c8-b6cb-966acfcf9168	9d5cabf7-1595-4514-ba00-4712b6399d3b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 09:51:16
11180	9d5cabf7-148e-4dd2-88ff-a4b345748dc1	9d5cabf7-1595-4514-ba00-4712b6399d3b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":406,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:51:16
40178	9d6cc129-375f-410d-a880-16c8671b0920	9d6cc129-388b-4eda-906f-7f33ad7f1874	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:43:47
15209	9d5ecf45-c6d7-43a7-a517-8e0ab902595c	9d5ecf45-c82d-46da-b80c-e2e3cdfc18f5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":492,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:21:39
6328	9d526479-f615-4af1-9c0f-a56d27a16074	9d52647a-438f-4b3a-8493-2ff78889f7dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 07:13:05
6329	9d52647a-3ba5-4868-8b39-71ea50ba8e6d	9d52647a-438f-4b3a-8493-2ff78889f7dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"105.98","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 07:13:06
6330	9d52647a-3c18-4dd7-ac2a-cb837c2500ac	9d52647a-438f-4b3a-8493-2ff78889f7dd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 07:13:06
6331	9d52647a-41e4-4672-bf3e-d2ef6fc8f4b3	9d52647a-438f-4b3a-8493-2ff78889f7dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 07:13:06
6332	9d52647a-4246-4088-8ea1-1e812f2967e3	9d52647a-438f-4b3a-8493-2ff78889f7dd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":472,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:13:06
8026	9d52e5fa-da97-42ca-a2ae-f15c86ed608d	9d52e5fa-fb96-46f3-83eb-83ed513ad042	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:15:13
8027	9d52e5fa-f6f4-4d58-9fc0-6591385f6e33	9d52e5fa-fb96-46f3-83eb-83ed513ad042	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:15:13
8028	9d52e5fa-f749-4329-b068-eefc59b79964	9d52e5fa-fb96-46f3-83eb-83ed513ad042	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:15:13
8029	9d52e5fa-fa8e-4981-9a2b-c3ef53c7d246	9d52e5fa-fb96-46f3-83eb-83ed513ad042	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:15:13
8030	9d52e5fa-fad1-4afd-a3ee-a43462dbdc2c	9d52e5fa-fb96-46f3-83eb-83ed513ad042	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:15:13
40179	9d6cc129-73cb-47f9-8a2c-33529a850639	9d6cc129-b8a2-484d-95d4-628f0a365e8d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-06 09:43:47
15210	9d5ecf46-a529-42b1-bbe4-750f715627c6	9d5ecf46-f1da-4b1a-86cb-9aa9322ee49f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-30 11:21:40
15211	9d5ecf46-e634-48da-bd17-f870cdfa6ef9	9d5ecf46-f1da-4b1a-86cb-9aa9322ee49f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"119.30","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 11:21:40
15212	9d5ecf46-e6b8-4ab1-b3e5-b7ce1f96adcb	9d5ecf46-f1da-4b1a-86cb-9aa9322ee49f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 11:21:40
15213	9d5ecf46-ef07-4474-8341-76a52f45081e	9d5ecf46-f1da-4b1a-86cb-9aa9322ee49f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-30 11:21:40
15214	9d5ecf46-efb5-4459-9c73-d9735efdeff7	9d5ecf46-f1da-4b1a-86cb-9aa9322ee49f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":738,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:21:40
8031	9d52e5fb-3df9-491b-9096-042b7588d40b	9d52e5fb-5b08-4f94-b7f0-54d07ea8ec28	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:15:13
8032	9d52e5fb-55df-475a-9a29-4115060dde2c	9d52e5fb-5b08-4f94-b7f0-54d07ea8ec28	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:15:13
8033	9d52e5fb-562a-48b7-8087-79180ba41975	9d52e5fb-5b08-4f94-b7f0-54d07ea8ec28	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:15:13
8034	9d52e5fb-599b-472c-9335-0f2f10b066e0	9d52e5fb-5b08-4f94-b7f0-54d07ea8ec28	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:15:13
8035	9d52e5fb-59e0-4acf-a5d7-4b4a494beae9	9d52e5fb-5b08-4f94-b7f0-54d07ea8ec28	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":224,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:15:13
40180	9d6cc129-b4c5-4623-befa-7eed4c912389	9d6cc129-b8a2-484d-95d4-628f0a365e8d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"151.52","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 09:43:47
40181	9d6cc129-b764-44df-83fe-9410a71bd519	9d6cc129-b8a2-484d-95d4-628f0a365e8d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-06 09:43:47
15215	9d5ecf47-7085-49a6-bf39-db5712297e9b	9d5ecf47-a37c-4f81-b2ba-a6e1c3ecebb3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-30 11:21:40
15216	9d5ecf47-996b-43fe-a02a-a47ff791f3fc	9d5ecf47-a37c-4f81-b2ba-a6e1c3ecebb3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"65.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 11:21:40
15217	9d5ecf47-99eb-4b39-96d5-aecb4dab7c2b	9d5ecf47-a37c-4f81-b2ba-a6e1c3ecebb3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 11:21:40
15218	9d5ecf47-a1ab-40f2-9e11-fbac08f4356f	9d5ecf47-a37c-4f81-b2ba-a6e1c3ecebb3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-30 11:21:40
15219	9d5ecf47-a229-4341-80fe-eca88fe9bd35	9d5ecf47-a37c-4f81-b2ba-a6e1c3ecebb3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":429,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:21:40
40182	9d6cc129-b7cf-475f-8820-73e375f5c700	9d6cc129-b8a2-484d-95d4-628f0a365e8d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":314,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:43:47
8036	9d52e5fb-9e6a-4c99-a813-d450a748da07	9d52e5fb-e7b9-4eda-8489-f312778594c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:15:13
8037	9d52e5fb-e150-4698-8e8b-74fa05b19d84	9d52e5fb-e7b9-4eda-8489-f312778594c3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc","time":"152.94","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 13:15:13
8038	9d52e5fb-e1a3-4bc9-ac5d-ed1e9e17c047	9d52e5fb-e7b9-4eda-8489-f312778594c3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:15:13
8039	9d52e5fb-e325-49af-a709-1a38e7d9654a	9d52e5fb-e7b9-4eda-8489-f312778594c3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6'","time":"1.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 13:15:13
8040	9d52e5fb-e352-4c7e-8521-854b59a969b9	9d52e5fb-e7b9-4eda-8489-f312778594c3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:15:13
8041	9d52e5fb-e6af-4361-8ce2-8185b791bbc2	9d52e5fb-e7b9-4eda-8489-f312778594c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:15:13
8042	9d52e5fb-e6f2-4b75-9bdf-21525e49a0ec	9d52e5fb-e7b9-4eda-8489-f312778594c3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:15:13
40183	9d6cc12b-4594-499f-82d0-1dd4e8f62be7	9d6cc12b-4894-4ad9-9971-c3b8384d4154	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":146,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:43:48
15220	9d5ecf48-80db-46d8-a470-b19f2dcf7685	9d5ecf48-a8db-4927-8b77-b668f3620c68	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-30 11:21:41
15221	9d5ecf48-a103-4bde-9318-3c60a82b9c73	9d5ecf48-a8db-4927-8b77-b668f3620c68	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"49.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 11:21:41
15222	9d5ecf48-a15d-4d4b-8c8b-69de3d7b8f1c	9d5ecf48-a8db-4927-8b77-b668f3620c68	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 11:21:41
15223	9d5ecf48-a6ca-4925-bcfa-72cc8fd40015	9d5ecf48-a8db-4927-8b77-b668f3620c68	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-30 11:21:41
15224	9d5ecf48-a72c-4df4-bc24-da663ef52c06	9d5ecf48-a8db-4927-8b77-b668f3620c68	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":361,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:21:41
5527	9d522177-4147-4bf1-b00e-ec5d685e721b	9d522177-a851-4d85-945d-13916542f88c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 04:05:43
5528	9d522177-a4f0-400c-b3ea-a97d694e49f6	9d522177-a851-4d85-945d-13916542f88c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 04:05:43
5529	9d522177-a662-4eef-b4df-7cf788f5463a	9d522177-a851-4d85-945d-13916542f88c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":606,"memory":22,"hostname":"EderCortes"}	2024-10-24 04:05:43
343	9d4f2596-3a81-4d0c-b392-f15fc9b2bbe5	9d4f2596-3dbd-4980-89e8-0b42d8e7f9d4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":19}	2024-10-22 16:29:45
17275	9d6551eb-93b6-4eb6-9a70-762da296df16	9d6551eb-968a-4c8b-a939-d03b781d0b86	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":820}	2024-11-02 17:01:56
8043	9d52e5fe-209c-4665-b3dd-8a9fa0b50112	9d52e5fe-4bf8-4c06-9b0f-180e1477367b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:15:15
5530	9d522178-4e79-4edd-9dbe-c1e067f68f80	9d522178-a66b-4801-aaf7-d0acb1cc8c34	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 04:05:44
5531	9d522178-9ca9-4bfa-b647-68edcc6f882d	9d522178-a66b-4801-aaf7-d0acb1cc8c34	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"159.19","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 04:05:44
5532	9d522178-9d3a-490f-870a-0ced0078be17	9d522178-a66b-4801-aaf7-d0acb1cc8c34	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 04:05:44
5533	9d522178-a496-4c26-8a6b-14c86fe744f7	9d522178-a66b-4801-aaf7-d0acb1cc8c34	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 04:05:44
5534	9d522178-a504-4a23-9f9a-5e8eac74d99a	9d522178-a66b-4801-aaf7-d0acb1cc8c34	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":606,"memory":22,"hostname":"EderCortes"}	2024-10-24 04:05:44
8044	9d52e5fe-4516-4c45-a680-79165080e6e7	9d52e5fe-4bf8-4c06-9b0f-180e1477367b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"67.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:15:15
8045	9d52e5fe-4583-47ec-b146-0a7039c1763a	9d52e5fe-4bf8-4c06-9b0f-180e1477367b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:15:15
8046	9d52e5fe-4a73-404f-b5d9-2b5fe2176880	9d52e5fe-4bf8-4c06-9b0f-180e1477367b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 13:15:15
8047	9d52e5fe-4ad5-4174-bb62-0379771e2005	9d52e5fe-4bf8-4c06-9b0f-180e1477367b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":451,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:15:15
40184	9d6cc12b-bc24-4043-9985-701d231aad54	9d6cc12c-0197-4740-84d0-e89883d00467	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-06 09:43:48
10962	9d5ca6de-4fac-4cd1-948f-4d0812f9809a	9d5ca6de-69c6-4572-8e0e-0dc2866d0e58	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 09:37:01
10963	9d5ca6de-6595-4ad6-b581-dfb698ff3c3e	9d5ca6de-69c6-4572-8e0e-0dc2866d0e58	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"42.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-29 09:37:01
10964	9d5ca6de-6890-44af-ba5f-02234263214f	9d5ca6de-69c6-4572-8e0e-0dc2866d0e58	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 09:37:01
10965	9d5ca6de-68d9-4e19-8c8a-5a1a2fb9e303	9d5ca6de-69c6-4572-8e0e-0dc2866d0e58	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":228,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:37:01
40185	9d6cc12b-fcc9-4d07-99fc-7d6211444086	9d6cc12c-0197-4740-84d0-e89883d00467	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"142.37","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 09:43:49
40186	9d6cc12b-fd1a-41d7-9701-8c916f0ae3d7	9d6cc12c-0197-4740-84d0-e89883d00467	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 09:43:49
5535	9d522179-15b3-4dc2-88ed-7fe0b3930bd5	9d522179-40e7-4fcc-906e-eaa5592e65d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 04:05:44
5536	9d522179-3993-4eb1-8e79-ea762399c3c2	9d522179-40e7-4fcc-906e-eaa5592e65d3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"59.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 04:05:44
5537	9d522179-39fe-43bc-b940-2e91943d1cd0	9d522179-40e7-4fcc-906e-eaa5592e65d3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 04:05:44
5538	9d522179-3ee9-4a9d-9538-400e0bae128c	9d522179-40e7-4fcc-906e-eaa5592e65d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 04:05:44
4550	9d513313-91b2-4f8f-8f45-09501bf6c002	9d513313-c20a-4a17-9ba0-de56afab115a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 16:59:08
4551	9d513313-bfaa-4e61-bf12-cc39f636cefe	9d513313-c20a-4a17-9ba0-de56afab115a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 16:59:08
4552	9d513313-c0a9-465c-a09c-8f1650938c82	9d513313-c20a-4a17-9ba0-de56afab115a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":411,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:59:08
5539	9d522179-3f66-4089-bc53-580f11c95ff2	9d522179-40e7-4fcc-906e-eaa5592e65d3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":374,"memory":22,"hostname":"EderCortes"}	2024-10-24 04:05:44
40187	9d6cc12c-0069-46e6-b7c4-c4bc3fd3a61a	9d6cc12c-0197-4740-84d0-e89883d00467	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-06 09:43:49
8179	9d52e797-4b17-4e17-a0d9-11e73bca4a2f	9d52e797-6ffa-4007-a6e0-7416631bd020	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:19:43
8180	9d52e797-6d7d-4749-90d7-1764816dfe8c	9d52e797-6ffa-4007-a6e0-7416631bd020	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:19:43
8181	9d52e797-6e7e-4c99-a44e-e7d31d118a40	9d52e797-6ffa-4007-a6e0-7416631bd020	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":296,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:19:43
40188	9d6cc12c-00b3-4f22-9d41-a45658f2c02c	9d6cc12c-0197-4740-84d0-e89883d00467	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":323,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:43:49
4553	9d513314-484c-401d-b798-c0c606748f89	9d513314-771a-49fd-9d03-c28a89beff4a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 16:59:08
4554	9d513314-6dc9-46ab-a265-015ac74a38ba	9d513314-771a-49fd-9d03-c28a89beff4a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"66.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:59:08
4555	9d513314-6e67-431d-bdb4-4c05eb28ef52	9d513314-771a-49fd-9d03-c28a89beff4a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 16:59:08
4556	9d513314-75eb-4514-97df-4cffa10b8b4f	9d513314-771a-49fd-9d03-c28a89beff4a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 16:59:08
4557	9d513314-763f-4f19-b93e-da0581ca01cf	9d513314-771a-49fd-9d03-c28a89beff4a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":432,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:59:08
5540	9d522179-d60a-43b3-8fc0-aa30e1d5f5ca	9d52217a-1924-481a-a490-5777483fc96e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 04:05:45
5541	9d52217a-0de7-4b41-8da6-5cd3b0cbdafa	9d52217a-1924-481a-a490-5777483fc96e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"95.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 04:05:45
5542	9d52217a-0ea6-45c6-8064-8d65313d05fa	9d52217a-1924-481a-a490-5777483fc96e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 04:05:45
5543	9d52217a-16eb-4861-bbfc-4e96489ccaec	9d52217a-1924-481a-a490-5777483fc96e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 04:05:45
5544	9d52217a-177f-4f89-b170-d3c44763a3ed	9d52217a-1924-481a-a490-5777483fc96e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":531,"memory":22,"hostname":"EderCortes"}	2024-10-24 04:05:45
8182	9d52e797-cf34-4dbd-b554-f63bb9c4222f	9d52e797-f1e7-48a6-b5a2-b2cafc2cf4b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:19:43
8183	9d52e797-ebbf-4190-872e-eb4a5dabdd5f	9d52e797-f1e7-48a6-b5a2-b2cafc2cf4b2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:19:43
8184	9d52e797-ec12-496a-8958-b5bcadcc6cdb	9d52e797-f1e7-48a6-b5a2-b2cafc2cf4b2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:19:43
8185	9d52e797-f059-4fcd-b342-ba9279e827f4	9d52e797-f1e7-48a6-b5a2-b2cafc2cf4b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:19:43
8186	9d52e797-f0dc-49a4-bc03-b3d83e685673	9d52e797-f1e7-48a6-b5a2-b2cafc2cf4b2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":305,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:19:43
40189	9d6cc12c-4002-4e09-a792-2e9b7772a7af	9d6cc12c-5cea-45f1-bd0d-9e026d3265cc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-06 09:43:49
40190	9d6cc12c-580b-4438-9707-67aa3c0ef241	9d6cc12c-5cea-45f1-bd0d-9e026d3265cc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 09:43:49
40191	9d6cc12c-585e-426f-a84e-2269f66bea05	9d6cc12c-5cea-45f1-bd0d-9e026d3265cc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 09:43:49
40192	9d6cc12c-5bc7-4f22-97c0-c048c2dcc534	9d6cc12c-5cea-45f1-bd0d-9e026d3265cc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-06 09:43:49
4558	9d513314-f473-40ed-b5a3-44f31491d5fa	9d513315-2b88-4d9c-b4ca-00e093958b3d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 16:59:09
4559	9d513315-210b-44ef-b658-1731ca8e108d	9d513315-2b88-4d9c-b4ca-00e093958b3d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"65.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:59:09
4560	9d513315-2179-42d3-8b87-d96f526e8df0	9d513315-2b88-4d9c-b4ca-00e093958b3d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 16:59:09
4561	9d513315-29bb-49eb-9268-5454d6ea7125	9d513315-2b88-4d9c-b4ca-00e093958b3d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 16:59:09
4562	9d513315-2a37-4691-9543-9cdef1d366a3	9d513315-2b88-4d9c-b4ca-00e093958b3d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":440,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:59:09
5545	9d52217a-a46b-4af6-8805-8892bcefea73	9d52217a-ce7d-464e-b997-c1d346caee81	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 04:05:45
5546	9d52217a-c6d6-44fe-972a-55321f373b44	9d52217a-ce7d-464e-b997-c1d346caee81	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"57.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 04:05:45
4731	9d5134b8-2420-4d0e-893f-9495cdf4bc23	9d5134b8-29ba-41b9-a5ee-732ace02954c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"160.08","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:03:43
4732	9d5134b8-247c-4124-912f-cf2cc9a9cae0	9d5134b8-29ba-41b9-a5ee-732ace02954c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:03:43
4733	9d5134b8-287c-4dd4-adaf-147b85764c82	9d5134b8-29ba-41b9-a5ee-732ace02954c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-10-23 17:03:43
5547	9d52217a-c76e-4b91-b313-d84add0abd54	9d52217a-ce7d-464e-b997-c1d346caee81	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 04:05:45
5548	9d52217a-cc98-49ef-b2de-6e4d64dfc9d4	9d52217a-ce7d-464e-b997-c1d346caee81	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 04:05:45
5549	9d52217a-cd08-4898-932e-f0e61bc8c428	9d52217a-ce7d-464e-b997-c1d346caee81	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":439,"memory":22,"hostname":"EderCortes"}	2024-10-24 04:05:45
8187	9d52e798-3d7e-417d-9159-c3ba44a9251e	9d52e798-85a5-4a1a-8cca-f2e02b971cce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:19:43
8188	9d52e798-80e3-43c3-bc16-39b9c3bb4a6b	9d52e798-85a5-4a1a-8cca-f2e02b971cce	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"152.77","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:19:44
8189	9d52e798-8158-40cf-83e1-accd13407d50	9d52e798-85a5-4a1a-8cca-f2e02b971cce	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:19:44
8190	9d52e798-84a0-4356-8036-8ad379787d9b	9d52e798-85a5-4a1a-8cca-f2e02b971cce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:19:44
5550	9d522c62-d6c2-481b-9258-21aca8d4e5bc	9d522c62-db40-4593-a12f-c2544eaaa36c	\N	t	command	{"command":"vendor:publish","exit_code":0,"arguments":{"command":"vendor:publish"},"options":{"existing":false,"force":true,"all":false,"provider":null,"tag":["laravel-assets"],"help":false,"quiet":false,"verbose":false,"version":false,"ansi":true,"no-interaction":false,"env":null},"hostname":"EderCortes"}	2024-10-24 04:36:15
8191	9d52e798-84df-4fbd-8eb7-8a9abff2b775	9d52e798-85a5-4a1a-8cca-f2e02b971cce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":358,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:19:44
40193	9d6cc12c-5c0f-4805-8b66-8951b416dba6	9d6cc12c-5cea-45f1-bd0d-9e026d3265cc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":215,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:43:49
5551	9d522ce6-b72a-4dca-98eb-8ed34f6c1289	9d522ce6-bce4-481f-9349-3e2949372753	\N	t	command	{"command":"krlove:generate:model","exit_code":0,"arguments":{"command":"krlove:generate:model","class-name":"User_two"},"options":{"table-name":"users","output-path":null,"namespace":"App\\\\Models","base-class-name":"Illuminate\\\\Database\\\\Eloquent\\\\Model","no-timestamps":false,"date-format":null,"connection":null,"no-backup":false,"help":false,"quiet":false,"verbose":false,"version":false,"ansi":null,"no-interaction":false,"env":null},"hostname":"EderCortes"}	2024-10-24 04:37:41
40194	9d6cc12c-a2f9-42f2-bedb-1debdd84148e	9d6cc12c-bf5f-4e8a-a4d7-f2ff47dafdff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-06 09:43:49
8192	9d52e798-cd02-4eee-93c4-7cb75e5765bb	9d52e798-ebd0-476f-b536-5870e1584115	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:19:44
8193	9d52e798-e508-43f1-9f85-b6ddccb76a42	9d52e798-ebd0-476f-b536-5870e1584115	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc","time":"41.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 13:19:44
8194	9d52e798-e556-48bc-8161-99c6857a0879	9d52e798-ebd0-476f-b536-5870e1584115	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:19:44
8195	9d52e798-e6ee-4671-bc0e-7a9bd801f646	9d52e798-ebd0-476f-b536-5870e1584115	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6'","time":"1.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 13:19:44
8196	9d52e798-e71e-47e1-9767-0aa5c653018c	9d52e798-ebd0-476f-b536-5870e1584115	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:19:44
8197	9d52e798-ea8a-4a07-b048-31f5531ec796	9d52e798-ebd0-476f-b536-5870e1584115	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:19:44
38045	9d6b5f0c-a702-4f9b-bd14-ff806c013b33	9d6b5f0c-ab5b-4dff-bd80-25f05b2da9a5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1709}	2024-11-05 17:13:37
8198	9d52e798-ead9-4bd8-968c-3dbd016b6b93	9d52e798-ebd0-476f-b536-5870e1584115	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:19:44
4971	9d51365c-40df-4d2a-bd9c-95510e6a1b4f	9d51365c-8874-4909-ae76-dcc30721d5d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-10-23 17:08:19
4972	9d51365c-850c-46b4-a598-76028217ad7b	9d51365c-8874-4909-ae76-dcc30721d5d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-10-23 17:08:19
4973	9d51365c-8674-4149-ae2a-02e3626acaee	9d51365c-8874-4909-ae76-dcc30721d5d8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":603,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:19
40195	9d6cc12c-baf8-4f34-8217-254484f7c194	9d6cc12c-bf5f-4e8a-a4d7-f2ff47dafdff	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"44.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":89,"hash":"f9f3598e6ad2468770f89917d2ab916c","hostname":"EderCortes"}	2024-11-06 09:43:49
5552	9d522dea-824f-49be-89ce-e7a7b832c838	9d522dea-86d8-4c26-b21a-fa1e413e7fce	\N	t	command	{"command":"krlove:generate:model","exit_code":0,"arguments":{"command":"krlove:generate:model","class-name":"Loans"},"options":{"table-name":"loans","output-path":null,"namespace":"App\\\\Models","base-class-name":"Illuminate\\\\Database\\\\Eloquent\\\\Model","no-timestamps":false,"date-format":null,"connection":null,"no-backup":false,"help":false,"quiet":false,"verbose":false,"version":false,"ansi":null,"no-interaction":false,"env":null},"hostname":"EderCortes"}	2024-10-24 04:40:32
8335	9d52e8cc-832d-4c55-9c8c-8033000d7572	9d52e8cc-ae42-472b-af32-e249ed9a6598	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 13:23:05
8336	9d52e8cc-ac57-40da-a635-862d4e888e57	9d52e8cc-ae42-472b-af32-e249ed9a6598	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:23:06
8337	9d52e8cc-ad29-46f5-ada4-ec53274a5799	9d52e8cc-ae42-472b-af32-e249ed9a6598	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:23:06
40196	9d6cc12c-be0c-44c0-b151-f8338df8be49	9d6cc12c-bf5f-4e8a-a4d7-f2ff47dafdff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-06 09:43:49
40197	9d6cc12c-be74-40bf-993a-01478cac844a	9d6cc12c-bf5f-4e8a-a4d7-f2ff47dafdff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getLoansCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:43:49
8338	9d52e8cd-1283-4282-b0bb-a60cec572e3b	9d52e8cd-316f-4965-89eb-747a1ce0eac8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:23:06
8339	9d52e8cd-2c1d-45f1-bd4c-1a3b96d64f93	9d52e8cd-316f-4965-89eb-747a1ce0eac8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:23:06
8340	9d52e8cd-2c7c-433a-99b9-6eb4a52f98b7	9d52e8cd-316f-4965-89eb-747a1ce0eac8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:23:06
3912	9d511af0-2e17-496a-b26f-1576aff8c8c4	9d511af0-63fa-4815-b46c-56e726c7c12c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 15:51:38
3913	9d511af0-60e4-480f-b4e6-5923fcca327e	9d511af0-63fa-4815-b46c-56e726c7c12c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 15:51:38
3914	9d511af0-6247-4eb7-9871-7cc93ca2c480	9d511af0-63fa-4815-b46c-56e726c7c12c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":544,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:51:38
8199	9d52e79a-8b1c-42d0-a61c-26687374d607	9d52e79a-c0a2-4cff-937e-1910f4633960	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:19:45
8200	9d52e79a-b875-4b71-b99f-07cacca29776	9d52e79a-c0a2-4cff-937e-1910f4633960	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"71.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:19:45
8201	9d52e79a-b8ec-4edb-8976-2f2fdfe199ec	9d52e79a-c0a2-4cff-937e-1910f4633960	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:19:45
8341	9d52e8cd-303c-4688-9485-adb559d55c3d	9d52e8cd-316f-4965-89eb-747a1ce0eac8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:23:06
8202	9d52e79a-bf21-43ff-a95a-6f45a1abef4a	9d52e79a-c0a2-4cff-937e-1910f4633960	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 13:19:45
8342	9d52e8cd-307c-484d-8d66-29cf6b14c215	9d52e8cd-316f-4965-89eb-747a1ce0eac8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":299,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:23:06
40198	9d6cc131-8fd2-4f81-a48b-9220332edf15	9d6cc131-92ea-4da0-a1d1-6292abf29333	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":143,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:43:52
42636	9d6cdf70-42b2-4e56-b502-6f4ede1588d9	9d6cdf70-45f5-4c58-a2a6-3fb754daa53a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1964}	2024-11-06 11:08:27
3915	9d511af0-d4d1-4c44-a977-74b773b1d936	9d511af1-074c-425f-a806-d46c30ff0270	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 15:51:39
3916	9d511af0-ff11-4b56-804b-196b16fcad70	9d511af1-074c-425f-a806-d46c30ff0270	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"68.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:51:39
3917	9d511af0-ff82-4a44-8072-cf771aaff89a	9d511af1-074c-425f-a806-d46c30ff0270	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 15:51:39
3918	9d511af1-0591-4859-9c5f-7b5282f1347b	9d511af1-074c-425f-a806-d46c30ff0270	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 15:51:39
3919	9d511af1-0622-41e1-b6d8-a3974c2c0851	9d511af1-074c-425f-a806-d46c30ff0270	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":382,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:51:39
4974	9d51365d-2883-43d2-9ab5-91dd608f639a	9d51365d-623a-4d99-aeb0-04916ad7ebc7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-10-23 17:08:19
4975	9d51365d-5901-466a-9d0f-5d6a0a7042a5	9d51365d-623a-4d99-aeb0-04916ad7ebc7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"86.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:08:19
4976	9d51365d-59b6-4824-99cc-f02ae99bbf79	9d51365d-623a-4d99-aeb0-04916ad7ebc7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:08:19
4977	9d51365d-6057-4825-8289-8975d8778986	9d51365d-623a-4d99-aeb0-04916ad7ebc7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-10-23 17:08:20
4978	9d51365d-60df-4a41-8690-2cc6829503f3	9d51365d-623a-4d99-aeb0-04916ad7ebc7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":517,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:20
5553	9d522e05-8ed4-4c7d-a652-10ecd28f35cf	9d522e05-93b6-4058-988e-dfd58254e4ba	\N	t	command	{"command":"krlove:generate:model","exit_code":0,"arguments":{"command":"krlove:generate:model","class-name":"ItemLoans"},"options":{"table-name":"item_loans","output-path":null,"namespace":"App\\\\Models","base-class-name":"Illuminate\\\\Database\\\\Eloquent\\\\Model","no-timestamps":false,"date-format":null,"connection":null,"no-backup":false,"help":false,"quiet":false,"verbose":false,"version":false,"ansi":null,"no-interaction":false,"env":null},"hostname":"EderCortes"}	2024-10-24 04:40:49
8203	9d52e79a-bf81-4053-8d57-af600bc9932b	9d52e79a-c0a2-4cff-937e-1910f4633960	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":530,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:19:45
8343	9d52e8cd-784e-4d34-8f90-23a831eeb6d7	9d52e8cd-9915-495d-8b7d-61676f775a58	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:23:06
8344	9d52e8cd-93a6-4d68-b7c6-1fc56adc6cd8	9d52e8cd-9915-495d-8b7d-61676f775a58	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:23:06
8345	9d52e8cd-9404-4cd2-9776-e06e7a3ed3e7	9d52e8cd-9915-495d-8b7d-61676f775a58	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:23:06
8346	9d52e8cd-97df-4bbf-8892-c893160b4257	9d52e8cd-9915-495d-8b7d-61676f775a58	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:23:06
3920	9d511af1-71aa-458c-b7f4-c17fad569bf5	9d511af1-934f-4f11-a0fa-8a0a8749345d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 15:51:39
3921	9d511af1-8d36-4983-b4ce-758082ffcc81	9d511af1-934f-4f11-a0fa-8a0a8749345d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:51:39
3922	9d511af1-8d87-42d1-bfc1-737405881946	9d511af1-934f-4f11-a0fa-8a0a8749345d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 15:51:39
3923	9d511af1-920b-49cb-8b93-f985d9e65d46	9d511af1-934f-4f11-a0fa-8a0a8749345d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 15:51:39
3924	9d511af1-9257-49e7-9b58-da835551647f	9d511af1-934f-4f11-a0fa-8a0a8749345d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":331,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:51:39
4979	9d51365e-097e-4be9-ae2c-b41605fa3575	9d51365e-49ae-49cb-a5eb-22bc3bb0bd99	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-10-23 17:08:20
4980	9d51365e-3f52-4b88-9485-742401c13d33	9d51365e-49ae-49cb-a5eb-22bc3bb0bd99	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"86.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:08:20
4734	9d5134b8-28c1-4503-8826-02862c031801	9d5134b8-29ba-41b9-a5ee-732ace02954c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":618,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:03:43
4981	9d51365e-4011-4398-bf55-f4809e9466c2	9d51365e-49ae-49cb-a5eb-22bc3bb0bd99	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:08:20
4982	9d51365e-47cc-46cb-89cc-47d6920d9318	9d51365e-49ae-49cb-a5eb-22bc3bb0bd99	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-10-23 17:08:20
4983	9d51365e-485c-4fe5-a386-bcfb5642dfac	9d51365e-49ae-49cb-a5eb-22bc3bb0bd99	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":568,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:20
8347	9d52e8cd-982a-4c74-be99-fe54c08ea19f	9d52e8cd-9915-495d-8b7d-61676f775a58	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:23:06
3925	9d511af2-bc25-45be-a963-a254ccf45cdb	9d511af3-1c95-4419-9206-b8139688ecce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 15:51:40
3926	9d511af3-0d7b-405e-9d49-9bfc89004fed	9d511af3-1c95-4419-9206-b8139688ecce	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"117.31","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 15:51:40
3927	9d511af3-0e65-4003-84e8-151474de68be	9d511af3-1c95-4419-9206-b8139688ecce	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 15:51:40
3928	9d511af3-1927-4c71-ade9-c49ff0bf53fa	9d511af3-1c95-4419-9206-b8139688ecce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 15:51:40
3929	9d511af3-19ed-4f0e-bb26-b8524e2834fa	9d511af3-1c95-4419-9206-b8139688ecce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":985,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:51:40
4984	9d51365e-d816-4239-8525-7e16f2111eb9	9d51365f-1792-42eb-a401-05e9b9d68ba8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-10-23 17:08:20
4985	9d51365f-0c8f-41bb-906f-1787af8d5a42	9d51365f-1792-42eb-a401-05e9b9d68ba8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"90.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:08:21
4735	9d5134be-be8f-4951-adbb-674601d06a4b	9d5134be-c1c1-4590-9e20-5936e4a72556	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":143,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:03:48
4986	9d51365f-0d2b-4b50-a89d-af9a4a3eaf4b	9d51365f-1792-42eb-a401-05e9b9d68ba8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:08:21
4987	9d51365f-153d-47c9-b01e-eb62c85d245c	9d51365f-1792-42eb-a401-05e9b9d68ba8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":29,"hostname":"EderCortes"}	2024-10-23 17:08:21
4988	9d51365f-15dc-46be-96b5-f328fb30b7bd	9d51365f-1792-42eb-a401-05e9b9d68ba8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":503,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:21
8348	9d52e8cd-e296-4dbd-85e3-6f8438187bc1	9d52e8ce-02b2-4a32-9d78-f415c1ee43cc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:23:06
8349	9d52e8cd-fb87-4a57-a108-820942593c27	9d52e8ce-02b2-4a32-9d78-f415c1ee43cc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc","time":"41.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 13:23:06
8350	9d52e8cd-fbee-4a3b-91e9-ad51a54b7365	9d52e8ce-02b2-4a32-9d78-f415c1ee43cc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:23:06
8351	9d52e8cd-fdb3-422d-a5dc-c3db4aaba167	9d52e8ce-02b2-4a32-9d78-f415c1ee43cc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6'","time":"2.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 13:23:06
8352	9d52e8cd-fde2-4661-939b-1c51c5e0f0a7	9d52e8ce-02b2-4a32-9d78-f415c1ee43cc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:23:06
8353	9d52e8ce-017b-4ec4-ac60-a23c72ab4525	9d52e8ce-02b2-4a32-9d78-f415c1ee43cc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:23:06
40199	9d6cc131-f7e6-4af6-985f-482e10d628f1	9d6cc132-1360-4e43-9868-63be760c1392	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-06 09:43:53
3930	9d511af3-93f4-4f72-8d2b-145edb6dac19	9d511af3-bbb1-4c10-82e9-23b8a0439f4c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 15:51:40
3931	9d511af3-b330-4ed5-a5ba-4901a0659b94	9d511af3-bbb1-4c10-82e9-23b8a0439f4c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"49.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 15:51:40
3932	9d511af3-b392-46c6-b2af-1ddc9e6a35bf	9d511af3-bbb1-4c10-82e9-23b8a0439f4c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 15:51:40
3933	9d511af3-b9df-4817-a850-1a517c51580f	9d511af3-bbb1-4c10-82e9-23b8a0439f4c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-23 15:51:40
3934	9d511af3-ba5d-4c4b-8fea-79b62672cdf9	9d511af3-bbb1-4c10-82e9-23b8a0439f4c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":382,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:51:40
4993	9d513661-8806-4806-89a3-e52d896ce7ac	9d513661-e1a1-4978-83bc-8dff7e627aeb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":30,"hostname":"EderCortes"}	2024-10-23 17:08:22
4736	9d5134bf-4543-4d39-92a5-e19ba36da953	9d5134bf-8ee7-4d6b-9223-fbb6ca72a496	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 17:03:48
4737	9d5134bf-8957-4bab-8440-47194c24968c	9d5134bf-8ee7-4d6b-9223-fbb6ca72a496	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"144.22","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":46,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 17:03:48
4738	9d5134bf-8d23-457d-ac11-6bb429168010	9d5134bf-8ee7-4d6b-9223-fbb6ca72a496	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 17:03:48
4739	9d5134bf-8d84-4117-b613-843f101e9f01	9d5134bf-8ee7-4d6b-9223-fbb6ca72a496	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:03:48
4994	9d513661-d822-423e-8835-9a31901bf559	9d513661-e1a1-4978-83bc-8dff7e627aeb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"112.02","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:08:22
4995	9d513661-d8c6-4071-b6cf-08ff08c1883d	9d513661-e1a1-4978-83bc-8dff7e627aeb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:08:22
4996	9d513661-df98-4c68-98f2-7121b1b8a066	9d513661-e1a1-4978-83bc-8dff7e627aeb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":31,"hostname":"EderCortes"}	2024-10-23 17:08:22
5163	9d5136a2-90fd-441c-bd38-dc3702fb9611	9d5136a2-b099-4774-96e1-e162b4c79812	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-10-23 17:09:05
5164	9d5136a2-ab67-4fe0-ab37-823a17e47c43	9d5136a2-b099-4774-96e1-e162b4c79812	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:09:05
5165	9d5136a2-abb3-4c33-8e6a-65774995e2fe	9d5136a2-b099-4774-96e1-e162b4c79812	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:09:05
5166	9d5136a2-af51-4a9b-9ea1-ca999af4168b	9d5136a2-b099-4774-96e1-e162b4c79812	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-10-23 17:09:05
5167	9d5136a2-afb1-44f7-96ae-64a43a002f55	9d5136a2-b099-4774-96e1-e162b4c79812	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:09:05
8354	9d52e8ce-01cd-4fb0-9dd4-8f492ac07239	9d52e8ce-02b2-4a32-9d78-f415c1ee43cc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:23:06
4997	9d513661-e027-4372-a571-d1c6ba5f884f	9d513661-e1a1-4978-83bc-8dff7e627aeb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":849,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:22
5168	9d5136a3-0069-48bd-ba3c-784d459d2cfb	9d5136a3-2174-4050-9911-3b1ab9535c18	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-10-23 17:09:05
4740	9d5134c3-ce5a-4aa6-942c-520709ede99e	9d5134c4-14c1-4308-983b-3e69c25a4fd4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 17:03:51
4741	9d5134c4-0fd6-4056-aac5-7588731f4c7c	9d5134c4-14c1-4308-983b-3e69c25a4fd4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null","time":"146.50","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":28,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-23 17:03:51
4742	9d5134c4-1025-45fe-b0c0-b5cc132dfab1	9d5134c4-14c1-4308-983b-3e69c25a4fd4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:03:51
4743	9d5134c4-134e-483b-80e2-0d7cf5f4c643	9d5134c4-14c1-4308-983b-3e69c25a4fd4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 17:03:51
4744	9d5134c4-138f-4ba7-9ad6-950dfc53197a	9d5134c4-14c1-4308-983b-3e69c25a4fd4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null}]},"duration":377,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:03:51
5169	9d5136a3-1c06-4939-ad34-5fa23046ba9e	9d5136a3-2174-4050-9911-3b1ab9535c18	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:09:05
5170	9d5136a3-1c59-452f-aca9-3ba3acf9d3ef	9d5136a3-2174-4050-9911-3b1ab9535c18	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:09:05
5171	9d5136a3-202c-4b1f-a1e0-8c1c0373fb29	9d5136a3-2174-4050-9911-3b1ab9535c18	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-10-23 17:09:05
5172	9d5136a3-2084-401c-a725-2c8b83199b2e	9d5136a3-2174-4050-9911-3b1ab9535c18	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:09:05
40200	9d6cc132-0e03-4191-b1e6-a6ae502a8636	9d6cc132-1360-4e43-9868-63be760c1392	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" where \\"l\\".\\"user_cobrador\\" = 14 order by \\"l\\".\\"id\\" desc","time":"41.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":89,"hash":"16e7ca2a46d6db2eca0924d1509baaa1","hostname":"EderCortes"}	2024-11-06 09:43:53
40201	9d6cc132-11d0-476d-8160-f21cc34b594c	9d6cc132-1360-4e43-9868-63be760c1392	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-06 09:43:53
40202	9d6cc132-124f-4b1a-8f35-e6520dec1221	9d6cc132-1360-4e43-9868-63be760c1392	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getLoansCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":14,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":216,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:43:53
4852	9d513612-ad39-47ca-a4af-f22ea6d3c205	9d513612-d35a-427c-ae73-f3e16a1e4264	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 17:07:31
4853	9d513612-d13a-4f3c-9d51-8109cf21950f	9d513612-d35a-427c-ae73-f3e16a1e4264	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 17:07:31
4854	9d513612-d206-4dd4-b7c6-3aa139a82795	9d513612-d35a-427c-ae73-f3e16a1e4264	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":265,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:07:31
8355	9d52e8d0-8ac6-4a2c-95c3-eb19224b62f9	9d52e8d0-c120-420d-a65b-c0e2ed7d1ead	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:23:08
8356	9d52e8d0-b758-4663-ae90-36cbe613f5cc	9d52e8d0-c120-420d-a65b-c0e2ed7d1ead	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"66.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:23:08
8357	9d52e8d0-b7ed-46d0-82a6-eebb27efe34f	9d52e8d0-c120-420d-a65b-c0e2ed7d1ead	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:23:08
8358	9d52e8d0-bf30-4a8d-8316-e5d079df953f	9d52e8d0-c120-420d-a65b-c0e2ed7d1ead	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:23:08
41424	9d6ccc8f-cadf-42b8-b8ae-1bca84a8adc3	9d6ccc8f-cdf6-41a1-a04a-223ab9892011	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1900}	2024-11-06 10:15:40
4855	9d513613-2cfe-413c-ad4c-0f63c19c8fd9	9d513613-4c9e-4c2e-b3c0-50a24c2cba86	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 17:07:31
4856	9d513613-46ed-443f-afd9-be6f90c70d8c	9d513613-4c9e-4c2e-b3c0-50a24c2cba86	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:07:31
4857	9d513613-4741-43eb-94e5-395f46c942d2	9d513613-4c9e-4c2e-b3c0-50a24c2cba86	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:07:31
4858	9d513613-4b65-47de-ba91-7d53f7c2f002	9d513613-4c9e-4c2e-b3c0-50a24c2cba86	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 17:07:31
4859	9d513613-4bad-4aef-bdc5-f75aa2a32f41	9d513613-4c9e-4c2e-b3c0-50a24c2cba86	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":282,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:07:31
8359	9d52e8d0-bfc8-499f-a2e7-bccea2cefbc9	9d52e8d0-c120-420d-a65b-c0e2ed7d1ead	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":548,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:23:08
40203	9d6cc134-95e9-4d16-a241-5da7cbe9bc64	9d6cc134-9959-4082-a510-ffd3f1fa1008	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":156,"memory":20,"hostname":"EderCortes"}	2024-11-06 09:43:54
4998	9d513662-6a8a-4aa0-8490-101eec21aa2a	9d513662-8ec1-4660-83c0-a4e8dc0fe7f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":31,"hostname":"EderCortes"}	2024-10-23 17:08:23
3618	9d5108f8-5282-45e5-8f2e-24d1d99f9c6d	9d5108f8-75bc-485a-9355-767974f91c17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-23 15:01:24
3619	9d5108f8-73e8-4d0c-bda2-9bdd0556ee56	9d5108f8-75bc-485a-9355-767974f91c17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-23 15:01:24
3620	9d5108f8-748e-462c-b90f-b43affdf6f7f	9d5108f8-75bc-485a-9355-767974f91c17	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":280,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:01:24
4860	9d513613-943c-4656-97e1-d42d3ef6e89b	9d513613-b5d0-4845-a9c8-543c0aeac050	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 17:07:31
4861	9d513613-b03b-4679-86fa-937d0d2d584d	9d513613-b5d0-4845-a9c8-543c0aeac050	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:07:31
4862	9d513613-b09c-459b-935c-e21a953c66da	9d513613-b5d0-4845-a9c8-543c0aeac050	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:07:31
4863	9d513613-b48e-4abe-8222-1a13a8604566	9d513613-b5d0-4845-a9c8-543c0aeac050	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 17:07:31
4864	9d513613-b4d5-4a88-a668-dca14c195ac2	9d513613-b5d0-4845-a9c8-543c0aeac050	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:07:31
40204	9d6cc135-4c92-415a-bf25-73fd80dd8ae8	9d6cc135-678c-4767-806d-63d72793d7bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-06 09:43:55
40205	9d6cc135-6351-4d8e-8922-aef48352a526	9d6cc135-678c-4767-806d-63d72793d7bb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"41.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":89,"hash":"f9f3598e6ad2468770f89917d2ab916c","hostname":"EderCortes"}	2024-11-06 09:43:55
4999	9d513662-8878-4bc9-ad9f-c6b98f822828	9d513662-8ec1-4660-83c0-a4e8dc0fe7f9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:08:23
5000	9d513662-88ce-4d60-8881-0e5a1ff750ed	9d513662-8ec1-4660-83c0-a4e8dc0fe7f9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:08:23
5001	9d513662-8d58-495e-bfee-babb39506291	9d513662-8ec1-4660-83c0-a4e8dc0fe7f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":32,"hostname":"EderCortes"}	2024-10-23 17:08:23
40206	9d6cc135-6640-4f0d-b0a7-5e15dbd82240	9d6cc135-678c-4767-806d-63d72793d7bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-06 09:43:55
40207	9d6cc135-66a5-404d-aef4-2fc462e1f23f	9d6cc135-678c-4767-806d-63d72793d7bb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getLoansCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":215,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:43:55
40208	9d6cc1aa-04c9-4c4b-bff2-eb49961745c4	9d6cc1aa-08ab-4423-ab7a-438e78a6292f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":178,"memory":20,"hostname":"EderCortes"}	2024-11-06 09:45:11
40486	9d6cc3d2-05a2-40e0-8d5e-c5433f4fae30	9d6cc3d2-0a15-457c-aa7c-73563e2fe650	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1818}	2024-11-06 09:51:13
10760	9d5720fb-615e-42bf-8f08-9a4f3707cdef	9d5720fb-662c-4bb0-ae7f-a540c5619214	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":538}	2024-10-26 15:43:30
40209	9d6cc1aa-9a4b-4796-9eb5-75211814b025	9d6cc1aa-c2de-4184-932b-98d26349b0fd	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 09:45:12
40210	9d6cc1aa-ba91-4d82-a6ee-e406d2078e7b	9d6cc1aa-c2de-4184-932b-98d26349b0fd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" where \\"l\\".\\"loans_cuando\\" = 'S' order by \\"l\\".\\"id\\" desc","time":"50.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":89,"hash":"0c79d8e84fb7ae332adf13400a0d1890","hostname":"EderCortes"}	2024-11-06 09:45:12
40211	9d6cc1aa-c113-4105-be5b-506606e04fa9	9d6cc1aa-c2de-4184-932b-98d26349b0fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:45:12
40212	9d6cc1aa-c18e-4f8d-a3ed-5f6becce5037	9d6cc1aa-c2de-4184-932b-98d26349b0fd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getLoansCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"61","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":"S","estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":296,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:45:12
8496	9d52ec9b-392d-4f83-8a9a-ff6b1a65fdfe	9d52ec9b-5ee5-4075-b993-5b3e0c9f0610	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 13:33:44
8497	9d52ec9b-5ce2-46c7-af7e-94cc63bba634	9d52ec9b-5ee5-4075-b993-5b3e0c9f0610	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:33:44
8498	9d52ec9b-5db1-46c7-82a8-fd5e2b0b081e	9d52ec9b-5ee5-4075-b993-5b3e0c9f0610	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":322,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:33:44
8499	9d52ec9b-b9a6-4696-a557-e5face02a2c0	9d52ec9c-0174-46af-8104-8e125de8a8ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:33:45
8500	9d52ec9b-fbe6-4311-8557-58c1468d976a	9d52ec9c-0174-46af-8104-8e125de8a8ac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"146.51","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:33:45
8501	9d52ec9b-fc38-4239-8bad-1b7e4a7b89c1	9d52ec9c-0174-46af-8104-8e125de8a8ac	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:33:45
8502	9d52ec9c-0050-418b-921f-35275903dfb0	9d52ec9c-0174-46af-8104-8e125de8a8ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:33:45
8503	9d52ec9c-0094-426f-93b1-54e76e5c56cb	9d52ec9c-0174-46af-8104-8e125de8a8ac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":386,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:33:45
40213	9d6cc1b1-a8c6-4539-884d-94f548ec2692	9d6cc1b1-ac40-47ec-9b0a-fff2491bc735	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":203,"memory":20,"hostname":"EderCortes"}	2024-11-06 09:45:16
40214	9d6cc1b2-5ea2-4a5d-b66f-ccc91b58a4ce	9d6cc1b2-78ed-4774-aa9e-32faabdc5e67	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:45:17
40215	9d6cc1b2-74bc-4d0f-933c-32e728f96153	9d6cc1b2-78ed-4774-aa9e-32faabdc5e67	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" where \\"l\\".\\"loans_cuando\\" = 'D' order by \\"l\\".\\"id\\" desc","time":"41.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":89,"hash":"0c79d8e84fb7ae332adf13400a0d1890","hostname":"EderCortes"}	2024-11-06 09:45:17
5693	9d52492e-91f2-4f11-82b7-a50c1b4d510f	9d52492e-e6d1-474b-8784-de5eb770d900	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 05:56:46
5694	9d52492e-e4b7-4240-8650-70ffe40bd856	9d52492e-e6d1-474b-8784-de5eb770d900	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 05:56:46
5695	9d52492e-e5a3-479c-9081-6703a1c9c308	9d52492e-e6d1-474b-8784-de5eb770d900	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":453,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:56:46
40216	9d6cc1b2-77bc-423a-8e85-8c6f32fb421d	9d6cc1b2-78ed-4774-aa9e-32faabdc5e67	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:45:17
40217	9d6cc1b2-7807-4888-8599-ba4c2ec83b79	9d6cc1b2-78ed-4774-aa9e-32faabdc5e67	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getLoansCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"61","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":"D","estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":211,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:45:17
5696	9d52492f-4988-4baa-ae2e-887c394343ef	9d52492f-71c3-4399-804e-6bfdee97b90d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 05:56:47
5697	9d52492f-6bbc-4ab2-885a-7af3f9fac72d	9d52492f-71c3-4399-804e-6bfdee97b90d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":123,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 05:56:47
5698	9d52492f-6c34-4074-83d1-5add7a09910d	9d52492f-71c3-4399-804e-6bfdee97b90d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 05:56:47
5699	9d52492f-70ae-42cf-9216-746f0c6730bf	9d52492f-71c3-4399-804e-6bfdee97b90d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 05:56:47
5700	9d52492f-70f1-460a-bc50-39ac912d2107	9d52492f-71c3-4399-804e-6bfdee97b90d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":327,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:56:47
40218	9d6cc1bd-84c1-4c96-aefb-3adba84d24b2	9d6cc1bd-b2f9-4b97-ba63-875f5451e7e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:45:24
40219	9d6cc1bd-a4d1-4505-87cf-395d4c165d0f	9d6cc1bd-b2f9-4b97-ba63-875f5451e7e7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_valor_prestado\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\" from \\"loans\\" where \\"id\\" = '56' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"40.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":273,"hash":"f00e27e21a94f93c5c7a1d0cd56f9f13","hostname":"EderCortes"}	2024-11-06 09:45:24
6463	9d52d15a-96df-4fe4-9138-e8eac71bb4c5	9d52d15a-c189-46a4-ac72-874ff8c1de57	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:17:32
6464	9d52d15a-bfb1-435f-9098-cc4b15603742	9d52d15a-c189-46a4-ac72-874ff8c1de57	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:17:32
6465	9d52d15a-c078-4221-8ada-4e4c2332bc75	9d52d15a-c189-46a4-ac72-874ff8c1de57	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":311,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:17:32
40220	9d6cc1bd-a51e-4a5c-b437-ba16e34db1f8	9d6cc1bd-b2f9-4b97-ba63-875f5451e7e7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-06 09:45:24
11454	9d5cbe8a-9356-4ca1-91e0-e97cae7b5ccf	9d5cbe8a-b365-4694-8f41-f23e3a4c3ff0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 10:43:13
11455	9d5cbe8a-b1a6-402a-99a6-b08c0e4ff728	9d5cbe8a-b365-4694-8f41-f23e3a4c3ff0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 10:43:13
11456	9d5cbe8a-b234-4d44-90a1-9c26d1124d61	9d5cbe8a-b365-4694-8f41-f23e3a4c3ff0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:43:13
40221	9d6cc1bd-ae32-4dbe-a126-56c39b7eed42	9d6cc1bd-b2f9-4b97-ba63-875f5451e7e7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '56' order by \\"item_loans\\".\\"id\\" asc","time":"2.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":274,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-06 09:45:24
40222	9d6cc1bd-ae6a-475a-b936-4f53831e1eca	9d6cc1bd-b2f9-4b97-ba63-875f5451e7e7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-06 09:45:24
40223	9d6cc1bd-b1d2-478f-bd3b-c3bbed491be7	9d6cc1bd-b2f9-4b97-ba63-875f5451e7e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:45:24
40224	9d6cc1bd-b21d-419f-8828-65712d615b1a	9d6cc1bd-b2f9-4b97-ba63-875f5451e7e7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/56","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"06-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"user_creador":22,"user_cobrador":14,"user_customer":19,"user_recomendacion":14},"items":[{"id":157,"loans_codigo":56,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"20833.333333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":12,"created_at":"2024-10-30T15:42:30.000000Z","updated_at":"2024-10-30T15:42:30.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":158,"loans_codigo":56,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"20833.333333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-10-30T15:42:30.000000Z","updated_at":"2024-10-30T15:42:30.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":159,"loans_codigo":56,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"20833.333333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":12,"created_at":"2024-10-30T15:42:30.000000Z","updated_at":"2024-10-30T15:42:30.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":160,"loans_codigo":56,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"20833.333333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":12,"created_at":"2024-10-30T15:42:30.000000Z","updated_at":"2024-10-30T15:42:30.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":161,"loans_codigo":56,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"20833.333333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-11 00:00:00","itemloans_aprobador":12,"created_at":"2024-10-30T15:42:30.000000Z","updated_at":"2024-10-30T15:42:30.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":310,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:45:24
5701	9d52492f-ba1e-44c1-961e-d398870dfe59	9d524930-05f7-4c42-a7a2-8c4533be9e2e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 05:56:47
5702	9d524930-00e9-405f-8e18-25cf7b1e1341	9d524930-05f7-4c42-a7a2-8c4533be9e2e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"152.17","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":123,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 05:56:47
5703	9d524930-0134-4bb3-85f8-9d42db40192f	9d524930-05f7-4c42-a7a2-8c4533be9e2e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 05:56:47
5704	9d524930-04ce-49de-aac3-d73e87730b6b	9d524930-05f7-4c42-a7a2-8c4533be9e2e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 05:56:47
5705	9d524930-0520-4ce7-9215-9a99babf51df	9d524930-05f7-4c42-a7a2-8c4533be9e2e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":364,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:56:47
6466	9d52d15b-0a59-42a7-959c-f173bc3be350	9d52d15b-4f90-4ecb-8dac-9653d403640d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:17:32
6467	9d52d15b-4ba0-415f-a1a1-554126b4f8fd	9d52d15b-4f90-4ecb-8dac-9653d403640d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"154.71","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-24 12:17:33
6468	9d52d15b-4e6e-42f7-88f4-011d507a37e1	9d52d15b-4f90-4ecb-8dac-9653d403640d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:17:33
6469	9d52d15b-4eb9-47a8-a051-01114b2f382c	9d52d15b-4f90-4ecb-8dac-9653d403640d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:17:33
8504	9d52ec9c-493e-4506-9399-6c77056ee4ac	9d52ec9c-93a6-48b8-b56c-4e5468b1727c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:33:45
8505	9d52ec9c-8eb3-4af8-ad14-f6ea1e760921	9d52ec9c-93a6-48b8-b56c-4e5468b1727c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"154.33","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:33:45
8506	9d52ec9c-8eff-49bf-adc2-567bcacf5580	9d52ec9c-93a6-48b8-b56c-4e5468b1727c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:33:45
8507	9d52ec9c-927b-4553-88d3-926257f6df3f	9d52ec9c-93a6-48b8-b56c-4e5468b1727c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:33:45
8508	9d52ec9c-92c1-45f7-99fa-5e0b5c9cb91a	9d52ec9c-93a6-48b8-b56c-4e5468b1727c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":353,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:33:45
11457	9d5cbe8a-fd1a-4e98-8f9b-8f906a5debf2	9d5cbe8b-1cab-4c8c-8ccf-3214f6123ce5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 10:43:13
5706	9d524932-20ab-4726-9dc7-912d5a74b5ff	9d524932-4a51-4282-a53a-3b837ee2e473	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 05:56:49
5707	9d524932-43f8-4a59-8e95-da0af0075ed7	9d524932-4a51-4282-a53a-3b837ee2e473	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"56.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 05:56:49
5708	9d524932-4463-4fa9-b470-aacbaa155fc5	9d524932-4a51-4282-a53a-3b837ee2e473	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 05:56:49
5709	9d524932-48fe-4072-a658-c6ac459d861f	9d524932-4a51-4282-a53a-3b837ee2e473	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 05:56:49
5710	9d524932-494f-476c-ace1-7ac760a7a1ce	9d524932-4a51-4282-a53a-3b837ee2e473	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":419,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:56:49
6470	9d52d15d-0d4f-4e71-b447-1c877460c60b	9d52d15d-32e1-42a9-9cca-f9800e04aece	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:17:34
6471	9d52d15d-2bbd-4fd8-81df-2f557780d6eb	9d52d15d-32e1-42a9-9cca-f9800e04aece	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:17:34
6472	9d52d15d-2c11-457d-8ed4-9074a8e71761	9d52d15d-32e1-42a9-9cca-f9800e04aece	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:17:34
6473	9d52d15d-3125-4e05-80e9-187e04369ff7	9d52d15d-32e1-42a9-9cca-f9800e04aece	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:17:34
6474	9d52d15d-3193-4e23-8b8e-0065568a7863	9d52d15d-32e1-42a9-9cca-f9800e04aece	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:17:34
8509	9d52ec9c-d7c0-465d-9b3b-10f104adf058	9d52ec9d-2358-413b-a2c4-51233bb8a9b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:33:45
8510	9d52ec9d-1cd6-4a5a-ae19-bbfe93ad122a	9d52ec9d-2358-413b-a2c4-51233bb8a9b5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"id\\" desc limit 1","time":"156.04","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"4551821fd05c3815c0d2c7036687fb9f","hostname":"EderCortes"}	2024-10-24 13:33:45
8511	9d52ec9d-1d26-43da-bd5f-604715e00188	9d52ec9d-2358-413b-a2c4-51233bb8a9b5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:33:45
8512	9d52ec9d-1ea9-4d77-b413-37f1ed6ac1c1	9d52ec9d-2358-413b-a2c4-51233bb8a9b5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"id\\" asc","time":"1.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"c160639e0dc4ff44f5d5d21affd614e2","hostname":"EderCortes"}	2024-10-24 13:33:45
8513	9d52ec9d-1ed8-4f07-8a1e-e426415ce680	9d52ec9d-2358-413b-a2c4-51233bb8a9b5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:33:45
8514	9d52ec9d-21f3-4c31-8f37-71f48b1043eb	9d52ec9d-2358-413b-a2c4-51233bb8a9b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:33:45
8515	9d52ec9d-223d-4034-b789-09d9e5952d65	9d52ec9d-2358-413b-a2c4-51233bb8a9b5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":null,"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":352,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:33:46
40225	9d6cc1bd-fd1f-4f74-b816-ce3b1c9a2d1d	9d6cc1be-1c37-4aae-aef0-ce16b772455b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:45:24
5711	9d524936-5307-4625-b465-a525a64b0bf5	9d524936-569d-425c-8b08-76a13c7f3158	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":153,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:56:51
6475	9d52d15f-85db-465f-a360-897cb21dad57	9d52d15f-a4d2-46fb-a61f-2468b7878079	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:17:35
6476	9d52d15f-9f8b-43f8-bbc9-ecf18fbd66ed	9d52d15f-a4d2-46fb-a61f-2468b7878079	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:17:35
6477	9d52d15f-9fe1-4a02-8531-288a583f401c	9d52d15f-a4d2-46fb-a61f-2468b7878079	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:17:35
6478	9d52d15f-a37b-4033-8468-9e7a968a011c	9d52d15f-a4d2-46fb-a61f-2468b7878079	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 12:17:35
6479	9d52d15f-a3c5-4440-a7ed-206eaac6ae9e	9d52d15f-a4d2-46fb-a61f-2468b7878079	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":291,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:17:35
8516	9d52ec9e-bc19-4488-8665-f2c82f1ca91d	9d52ec9f-00d6-412a-a41e-d20536d42127	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:33:47
8517	9d52ec9e-fbc1-4081-8ff8-d6a272090d50	9d52ec9f-00d6-412a-a41e-d20536d42127	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"142.43","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:33:47
8518	9d52ec9e-fc12-4c72-800f-7f0097558aa8	9d52ec9f-00d6-412a-a41e-d20536d42127	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:33:47
8519	9d52ec9e-ff84-412e-a3ad-dbba91ad300d	9d52ec9f-00d6-412a-a41e-d20536d42127	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:33:47
8520	9d52ec9e-ffcb-4648-b6c8-cd8b785de39a	9d52ec9f-00d6-412a-a41e-d20536d42127	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":404,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:33:47
11458	9d5cbe8b-1387-4791-9a5e-33efb2680398	9d5cbe8b-1cab-4c8c-8ccf-3214f6123ce5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 1\\n                        ","time":"42.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"2bd5a29c69f6bbb290fc49b79286632e","hostname":"EderCortes"}	2024-10-29 10:43:13
11459	9d5cbe8b-174f-4423-a0d2-080e7ad9f72f	9d5cbe8b-1cab-4c8c-8ccf-3214f6123ce5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1' order by \\"item_loans\\".\\"id\\" asc","time":"1.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 10:43:13
11460	9d5cbe8b-1793-4829-8320-a153817dd77f	9d5cbe8b-1cab-4c8c-8ccf-3214f6123ce5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 10:43:13
4045	9d511cca-75ea-4197-8279-cacd840df1cb	9d511cca-aed8-4ce4-97aa-876fc28ddc9d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 15:56:49
4046	9d511cca-ab86-41c6-a278-9cd9a2f3656c	9d511cca-aed8-4ce4-97aa-876fc28ddc9d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 15:56:49
4047	9d511cca-ad2b-4279-a802-6ade69ecd76b	9d511cca-aed8-4ce4-97aa-876fc28ddc9d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":530,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:56:49
11461	9d5cbe8b-1b54-4ad1-8a47-355bd4ad7d54	9d5cbe8b-1cab-4c8c-8ccf-3214f6123ce5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 10:43:13
11462	9d5cbe8b-1bb5-4c6d-89e1-1f8a4b878077	9d5cbe8b-1cab-4c8c-8ccf-3214f6123ce5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":1,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]}},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:43:13
3584	9d5108e9-5124-415a-b7c8-7e328207118b	9d5108e9-5496-44df-b912-5c3d13f811df	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":200}	2024-10-23 15:01:14
4048	9d511ccb-3c42-4ee7-9360-791e448b8b7e	9d511ccb-6e63-4fa7-941a-ff6f8bfecc4c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 15:56:49
4049	9d511ccb-64cc-400c-b8c5-f52dbeb50d98	9d511ccb-6e63-4fa7-941a-ff6f8bfecc4c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"63.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:56:50
4050	9d511ccb-655d-475e-9823-c46c1840e9b6	9d511ccb-6e63-4fa7-941a-ff6f8bfecc4c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 15:56:50
4051	9d511ccb-6c83-42e3-9cc1-78d54d3e1c6c	9d511ccb-6e63-4fa7-941a-ff6f8bfecc4c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 15:56:50
4052	9d511ccb-6cfe-4d84-a4cb-188c1e2568bf	9d511ccb-6e63-4fa7-941a-ff6f8bfecc4c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":448,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:56:50
5712	9d524937-03b4-44eb-baf9-7f7be8fc54e8	9d524937-066e-44c8-9f0e-cdd97cdfca29	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":130,"memory":20,"hostname":"EderCortes"}	2024-10-24 05:56:52
6480	9d52d15f-eb62-4b1d-8b00-df549ed19275	9d52d160-06b1-4e41-91c1-bfc7d753d757	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 12:17:36
6481	9d52d160-0247-4dcf-b32b-52b6a4855a16	9d52d160-06b1-4e41-91c1-bfc7d753d757	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:17:36
6482	9d52d160-028f-422d-b977-3d55a45c210c	9d52d160-06b1-4e41-91c1-bfc7d753d757	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:17:36
6483	9d52d160-05a4-4bf6-ab08-7058a38beb0b	9d52d160-06b1-4e41-91c1-bfc7d753d757	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 12:17:36
6484	9d52d160-05e6-494d-951d-f8ae4dfcc8e9	9d52d160-06b1-4e41-91c1-bfc7d753d757	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:17:36
11463	9d5cbe8c-8cbc-4506-9021-c02526b91e8b	9d5cbe8c-b5d3-4b3a-b06e-025171faacd9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 10:43:14
11464	9d5cbe8c-ae31-42ac-a180-be95ab8082d6	9d5cbe8c-b5d3-4b3a-b06e-025171faacd9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"58.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 10:43:14
11465	9d5cbe8c-aeae-42e5-8672-87b02ceb77d6	9d5cbe8c-b5d3-4b3a-b06e-025171faacd9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 10:43:14
11466	9d5cbe8c-b3a4-490d-bd8d-c264c4256134	9d5cbe8c-b5d3-4b3a-b06e-025171faacd9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 10:43:14
11467	9d5cbe8c-b3f7-457f-a55a-f23d35c389f3	9d5cbe8c-b5d3-4b3a-b06e-025171faacd9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":256,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:43:14
4053	9d511ccb-e6f5-4200-b379-cfa4c8271b2f	9d511ccc-11ca-4f9f-affa-046bfd878b17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 15:56:50
4054	9d511ccc-09ff-4b8a-beda-6c6790697f6a	9d511ccc-11ca-4f9f-affa-046bfd878b17	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"53.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":66,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 15:56:50
4055	9d511ccc-0a7f-4841-8a70-277476f5ab09	9d511ccc-11ca-4f9f-affa-046bfd878b17	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 15:56:50
4056	9d511ccc-1078-4bfa-baa6-9620687cfd86	9d511ccc-11ca-4f9f-affa-046bfd878b17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 15:56:50
4057	9d511ccc-10cc-4716-9475-7b8a985a98d0	9d511ccc-11ca-4f9f-affa-046bfd878b17	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":394,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:56:50
5713	9d524937-7e9d-42ff-9df3-61e7df09d950	9d524937-9afd-441a-ad85-a1a967b08ff5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 05:56:52
5714	9d524937-9647-46e3-aa83-8e9664fcc09a	9d524937-9afd-441a-ad85-a1a967b08ff5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%' order by \\"users\\".\\"user_document\\" asc","time":"43.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":49,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-24 05:56:52
5002	9d513662-8db0-485d-93c3-91d9059d7729	9d513662-8ec1-4660-83c0-a4e8dc0fe7f9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":418,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:23
5715	9d524937-99a2-4fb0-b7ca-7a269be854a3	9d524937-9afd-441a-ad85-a1a967b08ff5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 05:56:52
5716	9d524937-99ee-4a33-96a6-db3211c7f815	9d524937-9afd-441a-ad85-a1a967b08ff5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:56:52
6485	9d52d160-4275-4a85-8688-d7cbc5cdd7d5	9d52d160-7175-413b-b0e0-639b34537931	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 12:17:36
6486	9d52d160-6367-4819-857b-946c60162b03	9d52d160-7175-413b-b0e0-639b34537931	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '1' order by \\"id\\" asc","time":"39.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:17:36
6487	9d52d160-63b1-4da6-8f50-c0a839854970	9d52d160-7175-413b-b0e0-639b34537931	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:17:36
6488	9d52d160-6cf1-4f40-bcdd-80bba0e99d43	9d52d160-7175-413b-b0e0-639b34537931	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1'","time":"3.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:17:36
6489	9d52d160-6d22-4500-b8f9-a499765beaf9	9d52d160-7175-413b-b0e0-639b34537931	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 12:17:36
6490	9d52d160-7040-4b0a-8f90-4fb0e172306b	9d52d160-7175-413b-b0e0-639b34537931	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 12:17:36
4058	9d511ccc-a4a3-49ed-afde-3629e5008141	9d511ccc-e7fd-4009-8032-8f1cb0aa8a70	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 15:56:50
4059	9d511ccc-dacb-4496-a53c-31a962c2c301	9d511ccc-e7fd-4009-8032-8f1cb0aa8a70	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"81.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 15:56:50
4060	9d511ccc-db65-4757-970e-955b7c1842b6	9d511ccc-e7fd-4009-8032-8f1cb0aa8a70	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 15:56:50
4061	9d511ccc-e4df-477f-91d3-690ae22531ae	9d511ccc-e7fd-4009-8032-8f1cb0aa8a70	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 15:56:51
4062	9d511ccc-e583-4f88-bc4c-5bda673f7815	9d511ccc-e7fd-4009-8032-8f1cb0aa8a70	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":526,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:56:51
5717	9d524937-e356-4c97-b166-0e0633331d57	9d524938-0068-486b-9360-74cb2eb6127e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 05:56:52
5718	9d524937-fb4e-4d88-8ae9-4cc149151f82	9d524938-0068-486b-9360-74cb2eb6127e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%' order by \\"users\\".\\"user_document\\" asc","time":"42.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":49,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-24 05:56:52
5007	9d513664-5f5d-4b61-9eae-b5e3e6fef57d	9d513664-9a7c-46ca-9da3-06efcdf23de7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":33,"hostname":"EderCortes"}	2024-10-23 17:08:24
5008	9d513664-908e-482d-834f-22fef3bf4605	9d513664-9a7c-46ca-9da3-06efcdf23de7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"88.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:08:24
5009	9d513664-910f-4616-be09-f58d996c032b	9d513664-9a7c-46ca-9da3-06efcdf23de7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:08:24
5010	9d513664-9879-42cb-9914-2b76db60395b	9d513664-9a7c-46ca-9da3-06efcdf23de7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":34,"hostname":"EderCortes"}	2024-10-23 17:08:24
5011	9d513664-98de-4d23-b3bf-c914171ae02e	9d513664-9a7c-46ca-9da3-06efcdf23de7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":484,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:24
5719	9d524937-fed8-4a80-b5c5-801d0c6adccb	9d524938-0068-486b-9360-74cb2eb6127e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 05:56:52
5720	9d524937-ff38-4ac0-9b29-6b873a734a69	9d524938-0068-486b-9360-74cb2eb6127e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:56:52
40226	9d6cc1be-1717-45c8-9423-2b89bf0279cb	9d6cc1be-1c37-4aae-aef0-ce16b772455b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 09:45:24
40227	9d6cc1be-1774-4da5-b4b0-1695fbdc8c81	9d6cc1be-1c37-4aae-aef0-ce16b772455b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 09:45:24
40228	9d6cc1be-1b07-49f3-bbaa-f100e4fbb79f	9d6cc1be-1c37-4aae-aef0-ce16b772455b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:45:24
4063	9d511ccd-72f8-42c7-a52f-b8490f4c796e	9d511ccd-a2cb-4070-84ac-92e31cf27ee4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 15:56:51
4064	9d511ccd-97c6-4cbc-866b-7f08d9108ef8	9d511ccd-a2cb-4070-84ac-92e31cf27ee4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"64.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 15:56:51
4065	9d511ccd-985b-4104-b311-5756df4bdba4	9d511ccd-a2cb-4070-84ac-92e31cf27ee4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 15:56:51
4066	9d511ccd-a0d2-45dc-ac66-53aea3bb829b	9d511ccd-a2cb-4070-84ac-92e31cf27ee4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 15:56:51
4067	9d511ccd-a15c-4cb6-a52d-7042d3789165	9d511ccd-a2cb-4070-84ac-92e31cf27ee4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":451,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:56:51
5721	9d52493c-73b2-4c49-a0fc-9d7c8d01cbf9	9d52493c-9426-434a-a6d9-6eaad3cd6ab4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 05:56:55
5722	9d52493c-8e4f-4ed5-8aaf-f6a8954f8f40	9d52493c-9426-434a-a6d9-6eaad3cd6ab4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '18' and \\"users\\".\\"deleted_at\\" is null","time":"41.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":31,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-24 05:56:55
5012	9d513665-2846-40c8-aef5-8a4990ab403c	9d513665-8a04-45de-90de-ea87b410ce80	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":34,"hostname":"EderCortes"}	2024-10-23 17:08:25
5013	9d513665-7fbc-4643-b11c-3cef4ea97209	9d513665-8a04-45de-90de-ea87b410ce80	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"177.82","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:08:25
5014	9d513665-8058-44f0-8e50-1a4a73c2bf28	9d513665-8a04-45de-90de-ea87b410ce80	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:08:25
5015	9d513665-87f6-43f9-bda0-5055ce35922c	9d513665-8a04-45de-90de-ea87b410ce80	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":35,"hostname":"EderCortes"}	2024-10-23 17:08:25
5016	9d513665-8880-4282-bf21-42dd35dd094b	9d513665-8a04-45de-90de-ea87b410ce80	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":582,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:25
5723	9d52493c-8ea4-434d-b484-831e68e04310	9d52493c-9426-434a-a6d9-6eaad3cd6ab4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 05:56:55
5724	9d52493c-928d-4d14-801b-7ad444e6434d	9d52493c-9426-434a-a6d9-6eaad3cd6ab4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 05:56:55
5725	9d52493c-92fe-455e-ae0b-63e2181f7bff	9d52493c-9426-434a-a6d9-6eaad3cd6ab4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/18","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:56:55
5726	9d524956-7e99-46d5-9b9a-762ab1303eb0	9d524956-81f2-4104-97c2-77a1b9757cf3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":134,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:57:12
6491	9d52d160-7086-4d66-93d5-3d58fc3f62e0	9d52d160-7175-413b-b0e0-639b34537931	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}],"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]},"duration":260,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:17:36
40229	9d6cc1be-1b55-4f37-bab4-4aaafedb5078	9d6cc1be-1c37-4aae-aef0-ce16b772455b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":255,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:45:24
11354	9d5cbd63-d8b1-4fab-8ba4-e85c5d4ed436	9d5cbd64-4e0f-46a7-a0de-1f9489400511	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 10:39:59
5017	9d513665-fcbc-4c61-b8c2-9ffb8da370b3	9d513666-2e55-49ce-8c1f-7cf14120fd8c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":35,"hostname":"EderCortes"}	2024-10-23 17:08:25
5018	9d513666-2416-43fe-b789-25699ada1959	9d513666-2e55-49ce-8c1f-7cf14120fd8c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"67.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:08:25
5019	9d513666-2494-496d-9d7d-0a0a45a06fda	9d513666-2e55-49ce-8c1f-7cf14120fd8c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:08:25
5020	9d513666-2c44-46d0-be3e-f7138df3a51a	9d513666-2e55-49ce-8c1f-7cf14120fd8c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":36,"hostname":"EderCortes"}	2024-10-23 17:08:25
5021	9d513666-2cce-40b4-9625-458808369738	9d513666-2e55-49ce-8c1f-7cf14120fd8c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":397,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:25
11355	9d5cbd64-4ade-40e9-ac0b-fb395c71fe07	9d5cbd64-4e0f-46a7-a0de-1f9489400511	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 10:40:00
11356	9d5cbd64-4c65-4720-adb5-8cd62de39e42	9d5cbd64-4e0f-46a7-a0de-1f9489400511	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":886,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:40:00
8641	9d52ee40-6248-468f-b204-9bc28e29724b	9d52ee40-8e16-4b96-8085-4111c668e2e7	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 13:38:20
8642	9d52ee40-8bbd-43b4-8230-f7f22ec2b03a	9d52ee40-8e16-4b96-8085-4111c668e2e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:38:20
8643	9d52ee40-8ccf-4fdb-b8c6-ad17e8302083	9d52ee40-8e16-4b96-8085-4111c668e2e7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":445,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:38:20
8644	9d52ee40-ff58-46f3-ae1f-922a719994f0	9d52ee41-2340-4bad-849a-525ded017234	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:38:21
8645	9d52ee41-1ce0-4d9b-ad27-db8ecee7338c	9d52ee41-2340-4bad-849a-525ded017234	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:38:21
8646	9d52ee41-1d36-49e3-92ae-d1e213b1e60c	9d52ee41-2340-4bad-849a-525ded017234	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:38:21
8647	9d52ee41-220d-4b29-b22a-d18db4472632	9d52ee41-2340-4bad-849a-525ded017234	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:38:21
4331	9d512a6d-0f1c-430c-9fe2-77e790206274	9d512a6d-33ee-4f2f-a307-f30f2d728dfd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 16:34:57
4332	9d512a6d-31f2-479e-a5e1-54a6c1656155	9d512a6d-33ee-4f2f-a307-f30f2d728dfd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 16:34:57
4333	9d512a6d-3310-4286-b6f2-652d43f1a45c	9d512a6d-33ee-4f2f-a307-f30f2d728dfd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":259,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:34:57
8648	9d52ee41-2255-40eb-8192-acb0de9e862f	9d52ee41-2340-4bad-849a-525ded017234	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":344,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:38:21
11357	9d5cbd64-a81f-4e80-89af-4398cd777d6a	9d5cbd64-f5c4-4ab5-b22a-8b1896d81e24	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 10:40:00
11358	9d5cbd64-e8b3-404d-8ae6-7933925d5933	9d5cbd64-f5c4-4ab5-b22a-8b1896d81e24	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 1\\n                        ","time":"150.42","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"2bd5a29c69f6bbb290fc49b79286632e","hostname":"EderCortes"}	2024-10-29 10:40:00
11359	9d5cbd64-ec99-4ddd-9375-805ec855e430	9d5cbd64-f5c4-4ab5-b22a-8b1896d81e24	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1' order by \\"item_loans\\".\\"id\\" asc","time":"2.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 10:40:00
11360	9d5cbd64-eccb-402c-866a-0287cd5a48ef	9d5cbd64-f5c4-4ab5-b22a-8b1896d81e24	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 10:40:00
11361	9d5cbd64-f44e-4c5e-800f-c099079a9164	9d5cbd64-f5c4-4ab5-b22a-8b1896d81e24	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 10:40:00
11362	9d5cbd64-f4ae-45b2-828d-2076667accdc	9d5cbd64-f5c4-4ab5-b22a-8b1896d81e24	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":1,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]}},"duration":386,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:40:00
40230	9d6cc1be-5b5e-47e6-8812-8913bcb4bec6	9d6cc1be-7793-40f6-ae1c-360353b68d92	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:45:25
40231	9d6cc1be-7295-4863-96d3-8717ef7170bc	9d6cc1be-7793-40f6-ae1c-360353b68d92	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":286,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-06 09:45:25
40232	9d6cc1be-72f7-4ee7-b665-f881a82e41b8	9d6cc1be-7793-40f6-ae1c-360353b68d92	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-06 09:45:25
40233	9d6cc1be-767c-4bd4-89f4-cf8b6f41e845	9d6cc1be-7793-40f6-ae1c-360353b68d92	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:45:25
4334	9d512a6d-7cfa-4750-a456-72cda15e8784	9d512a6d-c5de-41f2-8faf-b1ccdf953102	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 16:34:57
4335	9d512a6d-c0cf-4446-9b4f-5b6496919b18	9d512a6d-c5de-41f2-8faf-b1ccdf953102	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"152.07","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:34:57
4336	9d512a6d-c13e-48a0-973e-bc4d303e5445	9d512a6d-c5de-41f2-8faf-b1ccdf953102	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 16:34:57
4337	9d512a6d-c4ab-4ea0-816e-66cc620c16af	9d512a6d-c5de-41f2-8faf-b1ccdf953102	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 16:34:57
4338	9d512a6d-c4eb-4876-895a-0dc5801a7cb7	9d512a6d-c5de-41f2-8faf-b1ccdf953102	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:34:57
8649	9d52ee41-73bc-4405-94f7-455909e75095	9d52ee41-c2a7-42e1-898d-852b7ebc660b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:38:21
6800	9d52d587-358c-45b0-b4bb-10e4dc85bec4	9d52d587-7b8b-4583-ab61-ebf2d94517e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 12:29:12
6801	9d52d587-7a28-44c7-8fd9-6667b65e8dea	9d52d587-7b8b-4583-ab61-ebf2d94517e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 12:29:13
6802	9d52d587-7abb-4c31-80ce-88bec6fd0123	9d52d587-7b8b-4583-ab61-ebf2d94517e0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:29:13
8650	9d52ee41-bbfb-44c9-93df-34b6642ccdc8	9d52ee41-c2a7-42e1-898d-852b7ebc660b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"158.44","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:38:21
8651	9d52ee41-bc70-4d85-a6f1-24184b55d0bb	9d52ee41-c2a7-42e1-898d-852b7ebc660b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:38:21
8652	9d52ee41-c11d-4330-87e4-e4c04d3f57b0	9d52ee41-c2a7-42e1-898d-852b7ebc660b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:38:21
8653	9d52ee41-c18a-4d31-90a8-1ee92a2e5220	9d52ee41-c2a7-42e1-898d-852b7ebc660b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":393,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:38:21
11363	9d5cbd67-4d07-430a-8d2e-bf337429e416	9d5cbd67-8313-4f12-b70c-4444462a2ecf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 10:40:02
11364	9d5cbd67-7c86-4a6c-8682-63c9a1f8b6df	9d5cbd67-8313-4f12-b70c-4444462a2ecf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"57.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 10:40:02
11365	9d5cbd67-7cec-4368-8c05-49981e79f715	9d5cbd67-8313-4f12-b70c-4444462a2ecf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 10:40:02
11366	9d5cbd67-81b5-4b88-a3ed-8820aa69f83a	9d5cbd67-8313-4f12-b70c-4444462a2ecf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 10:40:02
11367	9d5cbd67-8209-492c-bdbd-d70251a52328	9d5cbd67-8313-4f12-b70c-4444462a2ecf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":401,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:40:02
4339	9d512a6e-0a19-47d6-85cb-63f5803ef324	9d512a6e-2ae6-44de-8cc0-7884881c5903	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 16:34:57
4340	9d512a6e-25b9-43e7-8efc-42f8302d0171	9d512a6e-2ae6-44de-8cc0-7884881c5903	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:34:57
4341	9d512a6e-2608-43c0-ac5b-3adb8d07d439	9d512a6e-2ae6-44de-8cc0-7884881c5903	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 16:34:57
4342	9d512a6e-2994-48b6-8abe-24622200b290	9d512a6e-2ae6-44de-8cc0-7884881c5903	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 16:34:57
4343	9d512a6e-29eb-4972-9ab2-ba4b84dc12b1	9d512a6e-2ae6-44de-8cc0-7884881c5903	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:34:57
6803	9d52d587-c3f2-4244-afeb-f6a3e7dc5d1d	9d52d587-e1ef-4518-8d79-d4160b1e8562	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 12:29:13
6804	9d52d587-dcb3-4d28-9970-e0557d611946	9d52d587-e1ef-4518-8d79-d4160b1e8562	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:29:13
6644	9d52d3a7-d996-4b87-bbcc-7c13652f26b8	9d52d3a8-20f3-4108-9a63-9d944640c906	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:23:58
6645	9d52d3a8-1f48-4575-94a1-8fe5543a9090	9d52d3a8-20f3-4108-9a63-9d944640c906	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:23:58
6646	9d52d3a8-1fd2-4e5f-a985-d1d690405f66	9d52d3a8-20f3-4108-9a63-9d944640c906	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":383,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:23:58
6805	9d52d587-dd05-4051-9ade-94d5b471c0e3	9d52d587-e1ef-4518-8d79-d4160b1e8562	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:29:13
6806	9d52d587-e08b-46c8-8f84-ae13036cc5ac	9d52d587-e1ef-4518-8d79-d4160b1e8562	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 12:29:13
6807	9d52d587-e0f2-4656-8d7a-0b01b747b07c	9d52d587-e1ef-4518-8d79-d4160b1e8562	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:29:13
8654	9d52ee42-0e70-48ca-a13e-6b74638ea335	9d52ee42-2ed7-4135-9406-e38d1f0c5c0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:38:21
8655	9d52ee42-292f-4995-936f-070903a94cbf	9d52ee42-2ed7-4135-9406-e38d1f0c5c0d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"41.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 13:38:21
8656	9d52ee42-2984-4243-aa93-24cbe3474d9f	9d52ee42-2ed7-4135-9406-e38d1f0c5c0d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:38:21
8657	9d52ee42-2d84-4f88-bbce-9182195300a6	9d52ee42-2ed7-4135-9406-e38d1f0c5c0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:38:21
8658	9d52ee42-2de3-41c4-afb5-d34ea561c331	9d52ee42-2ed7-4135-9406-e38d1f0c5c0d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[],"item":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]},"duration":256,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:38:21
4344	9d512a70-1718-426c-8b38-65373e715ad4	9d512a70-3c03-41d5-a006-957fd98d87d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 16:34:59
4345	9d512a70-35b9-4fec-8cf7-36ce24a8bd48	9d512a70-3c03-41d5-a006-957fd98d87d8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 16:34:59
4346	9d512a70-360b-4a0b-943a-9072206b3d4c	9d512a70-3c03-41d5-a006-957fd98d87d8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 16:34:59
4347	9d512a70-3a53-483b-abfe-c72ef0091f5f	9d512a70-3c03-41d5-a006-957fd98d87d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 16:34:59
4348	9d512a70-3aae-4499-80fa-46b4b6c438ed	9d512a70-3c03-41d5-a006-957fd98d87d8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":445,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:34:59
6647	9d52d3a8-68af-4e99-bd49-dc101cb1d86a	9d52d3a8-85f9-412e-aa29-75a351579ffb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:23:59
6648	9d52d3a8-8130-440a-bb6a-2ab520d67de0	9d52d3a8-85f9-412e-aa29-75a351579ffb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:23:59
6649	9d52d3a8-817a-464f-aed4-f19aa256908e	9d52d3a8-85f9-412e-aa29-75a351579ffb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:23:59
6650	9d52d3a8-84cf-4ac2-ae79-f3dd2cabb13a	9d52d3a8-85f9-412e-aa29-75a351579ffb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:23:59
6651	9d52d3a8-850c-4288-bb46-4ed0ea94d072	9d52d3a8-85f9-412e-aa29-75a351579ffb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:23:59
6808	9d52d588-2358-4a96-8045-bfcaa7800324	9d52d588-4186-40f1-bc4a-0fc3a149730d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 12:29:13
6809	9d52d588-3bdc-4762-a5cb-86f9b9140f01	9d52d588-4186-40f1-bc4a-0fc3a149730d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:29:13
6810	9d52d588-3c35-43c0-80eb-3319bbc61df7	9d52d588-4186-40f1-bc4a-0fc3a149730d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:29:13
6811	9d52d588-4064-4a47-8fdc-6576235bc315	9d52d588-4186-40f1-bc4a-0fc3a149730d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 12:29:13
6812	9d52d588-40b9-43cf-bd3a-786a7f2f77e2	9d52d588-4186-40f1-bc4a-0fc3a149730d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:29:13
8659	9d52ee44-2116-4630-ad2f-7acc4454b13e	9d52ee44-66f5-43c4-a9e6-2a9726bcb45a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:38:23
4349	9d512a78-7bb3-4ebe-a032-103d24120ffc	9d512a78-7eae-402c-8c5a-19ee92a377cf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":138,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:35:04
6652	9d52d3a8-ce41-451e-a833-f7c884e3ce0f	9d52d3a8-f0b9-42f9-a344-e0b8ae69b4e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:23:59
6653	9d52d3a8-ead4-412c-a673-ac1935d0aacf	9d52d3a8-f0b9-42f9-a344-e0b8ae69b4e1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:23:59
6654	9d52d3a8-eb2c-4856-8c03-b385d8388d27	9d52d3a8-f0b9-42f9-a344-e0b8ae69b4e1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:23:59
6655	9d52d3a8-ef5a-4cd1-aebe-cc6a4c6d7685	9d52d3a8-f0b9-42f9-a344-e0b8ae69b4e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 12:23:59
6656	9d52d3a8-efb1-456c-bc4e-b6446ff1a39e	9d52d3a8-f0b9-42f9-a344-e0b8ae69b4e1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:23:59
6813	9d52d588-87ee-4b1a-ace6-6542a28c7dba	9d52d588-a5cf-4470-a184-bd7518d4bc85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 12:29:13
6814	9d52d588-9f36-4f16-a547-1ce0b4529919	9d52d588-a5cf-4470-a184-bd7518d4bc85	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"40.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:29:13
6815	9d52d588-9f7f-4900-8ecd-624e7b3cfb35	9d52d588-a5cf-4470-a184-bd7518d4bc85	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:29:13
6816	9d52d588-a0d5-4375-b370-8d02868104b3	9d52d588-a5cf-4470-a184-bd7518d4bc85	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"1.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:29:13
6817	9d52d588-a106-413a-99c0-d79e2fe34ce4	9d52d588-a5cf-4470-a184-bd7518d4bc85	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:29:13
6818	9d52d588-a4bc-4354-b838-5ba6fc0c5379	9d52d588-a5cf-4470-a184-bd7518d4bc85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 12:29:13
6819	9d52d588-a50a-405b-8dc5-b0addfbf9b83	9d52d588-a5cf-4470-a184-bd7518d4bc85	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:29:13
8660	9d52ee44-61a0-401f-8caf-da160f225897	9d52ee44-66f5-43c4-a9e6-2a9726bcb45a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"144.01","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:38:23
8661	9d52ee44-61eb-4746-90e3-c62f4ad0adb5	9d52ee44-66f5-43c4-a9e6-2a9726bcb45a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:38:23
8662	9d52ee44-65af-489b-8288-c9c57da492ed	9d52ee44-66f5-43c4-a9e6-2a9726bcb45a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:38:23
4350	9d512a79-3370-4d4a-b82c-e61b0f7d1403	9d512a79-784d-4474-9e13-5648faca656a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 16:35:04
4351	9d512a79-7419-4298-ba9f-62bcfbf3a745	9d512a79-784d-4474-9e13-5648faca656a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"149.78","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":46,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 16:35:05
4352	9d512a79-770d-4075-9c91-924aea59337f	9d512a79-784d-4474-9e13-5648faca656a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 16:35:05
4353	9d512a79-7754-4d6a-b7b7-638d172c5280	9d512a79-784d-4474-9e13-5648faca656a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":326,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:35:05
6657	9d52d3a9-32c1-43b1-a48d-a7bd961f2610	9d52d3a9-79cf-4e22-b69d-9c494414b565	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 12:23:59
6658	9d52d3a9-741c-44e4-a164-a3d3cc47acec	9d52d3a9-79cf-4e22-b69d-9c494414b565	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"148.10","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:23:59
6659	9d52d3a9-7467-4ab1-9a77-56cd3064646c	9d52d3a9-79cf-4e22-b69d-9c494414b565	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:23:59
6660	9d52d3a9-75c5-46ae-8995-b06d2178ac2e	9d52d3a9-79cf-4e22-b69d-9c494414b565	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"1.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:23:59
6661	9d52d3a9-75f3-4644-a441-a02110ff807c	9d52d3a9-79cf-4e22-b69d-9c494414b565	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:23:59
6662	9d52d3a9-78ae-4671-badc-c48a7c1ec55f	9d52d3a9-79cf-4e22-b69d-9c494414b565	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 12:23:59
6663	9d52d3a9-78ed-4c29-aa6e-1e1339c78a9f	9d52d3a9-79cf-4e22-b69d-9c494414b565	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]},"duration":334,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:23:59
6820	9d52d58a-3d34-4b2e-abe8-6b04367f14bb	9d52d58a-5bcc-402b-b079-b6e7d22b0445	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 12:29:14
6821	9d52d58a-56e4-45e3-9ead-bbc2b675371f	9d52d58a-5bcc-402b-b079-b6e7d22b0445	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:29:14
6822	9d52d58a-572a-4e0b-87c2-c4c63020b260	9d52d58a-5bcc-402b-b079-b6e7d22b0445	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:29:14
6823	9d52d58a-5a91-418d-a654-4effd5017097	9d52d58a-5bcc-402b-b079-b6e7d22b0445	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-24 12:29:14
6664	9d52d3ab-4e98-477f-8f17-90b575a9ad0e	9d52d3ab-919b-4746-8240-345794996fc0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 12:24:00
6665	9d52d3ab-8d1e-47f6-b044-eebe2193beaa	9d52d3ab-919b-4746-8240-345794996fc0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"142.19","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:24:01
6666	9d52d3ab-8d6b-42bc-aa80-9018044d5a32	9d52d3ab-919b-4746-8240-345794996fc0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:24:01
6667	9d52d3ab-9061-49ee-8f62-841b89753241	9d52d3ab-919b-4746-8240-345794996fc0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 12:24:01
6668	9d52d3ab-90a6-486f-bd7d-201adf3d8bff	9d52d3ab-919b-4746-8240-345794996fc0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":322,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:24:01
6824	9d52d58a-5adb-4584-ac12-4a69fd2ccce7	9d52d58a-5bcc-402b-b079-b6e7d22b0445	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:29:14
8663	9d52ee44-65f6-4783-9fde-49c2c0590b39	9d52ee44-66f5-43c4-a9e6-2a9726bcb45a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":369,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:38:23
40234	9d6cc1be-76c8-461d-85b3-a737c8b38661	9d6cc1be-7793-40f6-ae1c-360353b68d92	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":216,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:45:25
40235	9d6cc1be-b3ad-473c-8887-1fe3ac35dd9d	9d6cc1be-fa92-4bf5-b2e9-a3c61846cad8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:45:25
40236	9d6cc1be-f4cd-4437-94f0-8cf9e34a4b23	9d6cc1be-fa92-4bf5-b2e9-a3c61846cad8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"143.60","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":235,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 09:45:25
40237	9d6cc1be-f51e-465d-b6c0-f1f84f295244	9d6cc1be-fa92-4bf5-b2e9-a3c61846cad8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-06 09:45:25
4450	9d513003-bb96-4b1a-9fb3-3978364dcb39	9d513004-0af9-4af5-aab3-0bd7f199c6ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 16:50:34
4451	9d513004-0897-4305-8b2f-09148dd54ccc	9d513004-0af9-4af5-aab3-0bd7f199c6ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 16:50:34
4452	9d513004-0997-4211-9350-d0f6f9782376	9d513004-0af9-4af5-aab3-0bd7f199c6ee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":891,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:50:34
40238	9d6cc1be-f93b-43d7-a535-bc6f49d579c0	9d6cc1be-fa92-4bf5-b2e9-a3c61846cad8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 09:45:25
40239	9d6cc1be-f99d-4ed8-939a-a14a9d557b81	9d6cc1be-fa92-4bf5-b2e9-a3c61846cad8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":321,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:45:25
40945	9d6cc8e0-73e2-4eb0-bbb3-7b00d0ae7d69	9d6cc8e0-76ad-4868-8c54-e9177325039e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1872}	2024-11-06 10:05:21
4453	9d513004-7b73-443a-95d9-c74102f858fc	9d513004-ae49-42a3-b65d-d59528f41415	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 16:50:35
4454	9d513004-a430-4bdc-9086-1f352e4070f4	9d513004-ae49-42a3-b65d-d59528f41415	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"75.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:50:35
4455	9d513004-a4c7-420c-8f03-c46f301d4b90	9d513004-ae49-42a3-b65d-d59528f41415	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 16:50:35
4456	9d513004-ac1e-46c7-9b8a-84a2067dc9e4	9d513004-ae49-42a3-b65d-d59528f41415	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 16:50:35
4457	9d513004-aca7-45aa-b3d0-bf53fd95ef86	9d513004-ae49-42a3-b65d-d59528f41415	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":378,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:50:35
40240	9d6cc1ce-5b03-45f5-879a-8ee22fda32fd	9d6cc1ce-5deb-4cf6-888c-a58c3f15eba2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":156,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:45:35
4458	9d513005-080a-4f22-a77b-498e7bf40dbc	9d513005-338b-4d61-9130-cac8eed9f3ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 16:50:35
4459	9d513005-2c6f-42cd-a2b9-7b306c635039	9d513005-338b-4d61-9130-cac8eed9f3ff	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"63.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:50:35
4460	9d513005-2cf0-49a0-b359-fef933a103d9	9d513005-338b-4d61-9130-cac8eed9f3ff	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 16:50:35
4461	9d513005-321a-4eef-b47f-2298ab3648fb	9d513005-338b-4d61-9130-cac8eed9f3ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 16:50:35
4462	9d513005-327b-4391-99d5-bcc08cb2149e	9d513005-338b-4d61-9130-cac8eed9f3ff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":319,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:50:35
262	9d4f16be-b46f-4a2b-9b73-afc6c0968095	9d4f16bf-1e3e-4745-a4ab-000563995858	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42P01]: Undefined table: 7 ERROR:  falta una entrada para la tabla \\u00abmenu_name, menu\\u00bb en la cl\\u00e1usula FROM\\nLINE 1: select \\"menu\\".\\"menu_name, menu\\".\\"menu_url\\" from \\"menu\\" inner...\\n               ^ (Connection: pgsql, SQL: select \\"menu\\".\\"menu_name, menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":15}	2024-10-22 15:48:15
4463	9d513005-b6ba-48d7-a975-919572305fcf	9d513005-f321-4aca-8e01-c342508a837b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 16:50:35
4464	9d513005-e6de-4f60-8227-5853dd68fc65	9d513005-f321-4aca-8e01-c342508a837b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"86.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 16:50:36
4465	9d513005-e796-4f53-be3d-0cb41d61d208	9d513005-f321-4aca-8e01-c342508a837b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 16:50:36
4466	9d513005-f0e7-4106-a323-be8ce756e919	9d513005-f321-4aca-8e01-c342508a837b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 16:50:36
4467	9d513005-f17d-4909-b5b3-d842c6b4fa62	9d513005-f321-4aca-8e01-c342508a837b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":474,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:50:36
40241	9d6cc1ce-ae97-4b97-b0b2-08a051073966	9d6cc1ce-cbb8-4775-85cc-83b1b9e5fb11	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 09:45:35
40242	9d6cc1ce-c6d5-4294-844b-a633386002a5	9d6cc1ce-cbb8-4775-85cc-83b1b9e5fb11	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 09:45:35
5250	9d51377b-341a-4465-8f19-3351a343d044	9d51377b-6e13-4ff9-85bf-fc1a88fbde25	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 17:11:27
5251	9d51377b-6aff-4854-bb0f-56f235ed36fe	9d51377b-6e13-4ff9-85bf-fc1a88fbde25	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 17:11:27
5252	9d51377b-6c4c-458a-9312-96ad03ca068d	9d51377b-6e13-4ff9-85bf-fc1a88fbde25	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":499,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:11:27
40243	9d6cc1ce-c72a-4316-bf6f-af99e668aa87	9d6cc1ce-cbb8-4775-85cc-83b1b9e5fb11	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 09:45:35
40244	9d6cc1ce-ca88-4d57-a859-a88c37ea9b88	9d6cc1ce-cbb8-4775-85cc-83b1b9e5fb11	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 09:45:35
40245	9d6cc1ce-cad4-45d7-9ef6-931f068432d5	9d6cc1ce-cbb8-4775-85cc-83b1b9e5fb11	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":222,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:45:35
4468	9d513006-a395-43ad-98fd-e5dc048d71dd	9d513007-01ba-4c97-9e66-f0f01bc3e004	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 16:50:36
4469	9d513006-f813-4601-b0ae-9df2a8857be2	9d513007-01ba-4c97-9e66-f0f01bc3e004	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"177.59","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 16:50:36
4470	9d513006-f8ad-420a-9eae-4ef7f6adbd9f	9d513007-01ba-4c97-9e66-f0f01bc3e004	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 16:50:36
4471	9d513006-ffb9-40aa-a129-8c2818162d93	9d513007-01ba-4c97-9e66-f0f01bc3e004	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 16:50:36
4472	9d513007-0053-46d5-b081-414e83d7aad9	9d513007-01ba-4c97-9e66-f0f01bc3e004	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":587,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:50:36
5253	9d51377b-f748-4372-b03e-8dda1a72ec4d	9d51377c-2d0e-4103-9820-2457e4bff0bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 17:11:27
5254	9d51377c-2571-4488-9f03-89bc7c2f0621	9d51377c-2d0e-4103-9820-2457e4bff0bd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"77.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:11:27
5255	9d51377c-25f5-49c3-9d8e-656a10cead7e	9d51377c-2d0e-4103-9820-2457e4bff0bd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:11:27
5256	9d51377c-2b4d-4b35-bf12-4721de8c2e91	9d51377c-2d0e-4103-9820-2457e4bff0bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 17:11:27
5257	9d51377c-2bb9-42d5-8e9e-d2960fd38934	9d51377c-2d0e-4103-9820-2457e4bff0bd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":447,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:11:27
40246	9d6cc1cf-079b-48c6-b50c-8a75a6111296	9d6cc1cf-2610-4f9a-90ba-f1119cc6f1ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 09:45:35
40247	9d6cc1cf-1fa7-44f5-bc83-1feba6d47c8b	9d6cc1cf-2610-4f9a-90ba-f1119cc6f1ce	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 09:45:36
40248	9d6cc1cf-1ff9-4137-9d9a-bb24f18cb376	9d6cc1cf-2610-4f9a-90ba-f1119cc6f1ce	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 09:45:36
40249	9d6cc1cf-2479-4be8-84eb-43bd407c1aa6	9d6cc1cf-2610-4f9a-90ba-f1119cc6f1ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 09:45:36
40250	9d6cc1cf-24eb-4a6f-b173-f7148d546f27	9d6cc1cf-2610-4f9a-90ba-f1119cc6f1ce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":217,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:45:36
3632	9d5108fa-45f3-4490-a464-f48ebbb63825	9d5108fa-a7d0-46c7-8b61-2e25e577c9ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-23 15:01:25
3633	9d5108fa-a4f8-4c0f-bd8e-45b854e16f98	9d5108fa-a7d0-46c7-8b61-2e25e577c9ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-23 15:01:25
3634	9d5108fa-a641-423c-89e5-bd999cfd6ffe	9d5108fa-a7d0-46c7-8b61-2e25e577c9ae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":660,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:01:25
5258	9d51377c-9eb9-4e34-acd7-4f6ea2dd8b09	9d51377c-cc2c-4d79-adbd-56e2a2657b47	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 17:11:28
5259	9d51377c-c3fa-40a9-aa3a-07b506ac41c4	9d51377c-cc2c-4d79-adbd-56e2a2657b47	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"61.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:11:28
5260	9d51377c-c47f-4759-b005-68d03e089b7e	9d51377c-cc2c-4d79-adbd-56e2a2657b47	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:11:28
5261	9d51377c-ca3c-450a-8fc8-fced1f66e43a	9d51377c-cc2c-4d79-adbd-56e2a2657b47	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 17:11:28
5262	9d51377c-cabb-4e6e-891b-66805754a9c1	9d51377c-cc2c-4d79-adbd-56e2a2657b47	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":379,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:11:28
40251	9d6cc1cf-6c8f-44c4-aaf1-67c3c84c43ff	9d6cc1cf-b3d5-475b-84ae-0740cca4fa6f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 09:45:36
5263	9d51377d-fe3c-4081-82ce-268f36c047b2	9d51377e-4810-4e9e-80f6-7ef41f04039c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 17:11:29
5264	9d51377e-3d3b-4655-93c9-7566d7025d6a	9d51377e-4810-4e9e-80f6-7ef41f04039c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"88.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:11:29
5265	9d51377e-3dd9-4181-9798-ad668b743c78	9d51377e-4810-4e9e-80f6-7ef41f04039c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:11:29
5266	9d51377e-45d2-4c6c-89d0-a733333fb7fd	9d51377e-4810-4e9e-80f6-7ef41f04039c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 17:11:29
5267	9d51377e-4669-4e1a-8c67-7d0047ff006e	9d51377e-4810-4e9e-80f6-7ef41f04039c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":949,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:11:29
40252	9d6cc1cf-af35-4a57-9376-2f43fc96d4da	9d6cc1cf-b3d5-475b-84ae-0740cca4fa6f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"154.44","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 09:45:36
40253	9d6cc1cf-b23b-4456-9c15-d1d272bb7a37	9d6cc1cf-b3d5-475b-84ae-0740cca4fa6f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 09:45:36
8811	9d52ef3c-f073-41ff-8de3-dea6b630ffe0	9d52ef3d-39ac-46db-804c-3ff57b943c21	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:41:06
8812	9d52ef3d-37f4-4b24-9671-bd6849ad3e96	9d52ef3d-39ac-46db-804c-3ff57b943c21	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:41:06
8813	9d52ef3d-3899-4db7-bdb5-140b8d6c626b	9d52ef3d-39ac-46db-804c-3ff57b943c21	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:41:06
40254	9d6cc1cf-b2ac-4ca2-a246-4422f704a81f	9d6cc1cf-b3d5-475b-84ae-0740cca4fa6f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":342,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:45:36
5268	9d51377e-e344-4f5e-8aef-250c9b531f81	9d51377f-1263-46a0-af77-a619b657fe79	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 17:11:29
5269	9d51377f-07b9-4cc6-b6eb-a1734203723d	9d51377f-1263-46a0-af77-a619b657fe79	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"61.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:11:29
5270	9d51377f-0830-4a91-82ba-bd4050d66899	9d51377f-1263-46a0-af77-a619b657fe79	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:11:29
5271	9d51377f-0fde-4204-8a97-697761e1d633	9d51377f-1263-46a0-af77-a619b657fe79	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 17:11:29
5272	9d51377f-106e-427d-9c28-00a83c483456	9d51377f-1263-46a0-af77-a619b657fe79	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":491,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:11:29
8814	9d52ef3d-84c3-40b2-be55-dea7e194f796	9d52ef3d-a212-4240-9660-074c0f464521	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:41:06
8815	9d52ef3d-9cfc-49f8-b7c9-b5b6135ea5a8	9d52ef3d-a212-4240-9660-074c0f464521	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:41:06
8816	9d52ef3d-9d5a-47d5-bcf8-0a16e2e54879	9d52ef3d-a212-4240-9660-074c0f464521	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:41:06
8817	9d52ef3d-a0fe-4875-b966-0624cea4ac24	9d52ef3d-a212-4240-9660-074c0f464521	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:41:06
8818	9d52ef3d-a13f-48ad-80f4-34e5a8abdaac	9d52ef3d-a212-4240-9660-074c0f464521	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:41:06
12563	9d5ceae8-676b-4ad7-a75f-e4176ae3c6ef	9d5ceae8-84bb-4d11-8889-6e229bedb4ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:47:16
12564	9d5ceae8-82cc-4522-aaee-233047522568	9d5ceae8-84bb-4d11-8889-6e229bedb4ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 12:47:16
12565	9d5ceae8-8389-4295-bcf1-f607df74320d	9d5ceae8-84bb-4d11-8889-6e229bedb4ea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:47:16
5273	9d5137a2-9581-4970-9aa3-8e03e29e22cf	9d5137a2-9891-4b73-9e6c-697ff3624970	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":141,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:11:53
8819	9d52ef3d-e616-4987-8913-7ffc8b8f7a71	9d52ef3e-2ba5-4603-836e-d19270176fca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:41:06
8820	9d52ef3e-26ea-4b2e-8582-e4cc94ccd5c7	9d52ef3e-2ba5-4603-836e-d19270176fca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"145.05","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:41:07
8821	9d52ef3e-275f-46fd-82ec-0f77c942c01e	9d52ef3e-2ba5-4603-836e-d19270176fca	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:41:07
8822	9d52ef3e-2aa5-4dba-bec1-4389efd2a42c	9d52ef3e-2ba5-4603-836e-d19270176fca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:41:07
8823	9d52ef3e-2ae6-4779-890f-787091be058e	9d52ef3e-2ba5-4603-836e-d19270176fca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:41:07
12566	9d5ceae8-c974-4522-a046-f653346e9ac7	9d5ceae8-e5ba-4aab-a6f7-a1f0ca814d57	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 12:47:16
12567	9d5ceae8-e13f-4def-8a12-84a502ac4d42	9d5ceae8-e5ba-4aab-a6f7-a1f0ca814d57	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":180,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 12:47:16
12348	9d5ce2c8-5285-4dd4-830a-3cd3866cd239	9d5ce2c8-7537-41b5-a01f-00573d955ace	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 12:24:33
12349	9d5ce2c8-735b-4df4-8d64-aa51c43a6be6	9d5ce2c8-7537-41b5-a01f-00573d955ace	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:24:33
12350	9d5ce2c8-7432-4fcf-ba8f-1607c37d1638	9d5ce2c8-7537-41b5-a01f-00573d955ace	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:24:33
12568	9d5ceae8-e192-472c-a47d-413fd687c068	9d5ceae8-e5ba-4aab-a6f7-a1f0ca814d57	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 12:47:16
12569	9d5ceae8-e4be-4244-ab93-4c15b13407ee	9d5ceae8-e5ba-4aab-a6f7-a1f0ca814d57	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 12:47:16
12570	9d5ceae8-e500-4593-bb04-47713e2345e5	9d5ceae8-e5ba-4aab-a6f7-a1f0ca814d57	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":215,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:47:16
5274	9d5137a3-13b7-475f-842a-5464ac872a0a	9d5137a3-2f5b-4e90-a7d0-95b4da63f074	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 17:11:53
5275	9d5137a3-2ad7-4f7f-9242-89066f24468c	9d5137a3-2f5b-4e90-a7d0-95b4da63f074	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"43.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":46,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 17:11:53
5276	9d5137a3-2e16-4828-8aa2-54976349c01e	9d5137a3-2f5b-4e90-a7d0-95b4da63f074	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 17:11:53
5277	9d5137a3-2e5e-4830-82fc-c50568484190	9d5137a3-2f5b-4e90-a7d0-95b4da63f074	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":222,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:11:53
8824	9d52ef3e-74dc-41be-86a7-7649962d25fe	9d52ef3e-c59a-4753-a886-0ed5d37bb497	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:41:07
8825	9d52ef3e-bdf0-4eac-a27a-3c44a5e6809c	9d52ef3e-c59a-4753-a886-0ed5d37bb497	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"165.71","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-24 13:41:07
8826	9d52ef3e-be44-4413-9a44-4c5321e11129	9d52ef3e-c59a-4753-a886-0ed5d37bb497	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:41:07
8827	9d52ef3e-c00e-41a7-a334-d371542f4dd3	9d52ef3e-c59a-4753-a886-0ed5d37bb497	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"2.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 13:41:07
8828	9d52ef3e-c063-4f5f-8599-c921a4f20b69	9d52ef3e-c59a-4753-a886-0ed5d37bb497	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:41:07
8829	9d52ef3e-c472-4568-b1d2-115ae07c6bfa	9d52ef3e-c59a-4753-a886-0ed5d37bb497	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:41:07
8830	9d52ef3e-c4cb-41b3-9ed7-04e6304cae6e	9d52ef3e-c59a-4753-a886-0ed5d37bb497	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"item":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}],"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456}},"duration":379,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:41:07
12351	9d5ce2c8-c73d-4f69-8920-09806324fba9	9d5ce2c9-1029-4a00-b4b2-7d7b487ee31c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:24:33
11978	9d5ce042-e490-478e-9397-6266a6617b25	9d5ce043-3858-4a63-9b33-6aaa3021f873	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 12:17:30
11979	9d5ce043-3609-4ad3-a221-d722f7e7c3a1	9d5ce043-3858-4a63-9b33-6aaa3021f873	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:17:30
11980	9d5ce043-3705-4931-97fb-1662708a4192	9d5ce043-3858-4a63-9b33-6aaa3021f873	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":416,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:17:30
12352	9d5ce2c9-0ad0-4efa-8659-84042826b58b	9d5ce2c9-1029-4a00-b4b2-7d7b487ee31c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"148.96","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":177,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 12:24:33
12353	9d5ce2c9-0b1c-463b-ad7d-094c59439223	9d5ce2c9-1029-4a00-b4b2-7d7b487ee31c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 12:24:33
12354	9d5ce2c9-0f2e-4a9f-ba57-cc306cc39212	9d5ce2c9-1029-4a00-b4b2-7d7b487ee31c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:24:33
12355	9d5ce2c9-0f6d-4573-8f7e-7975a2ede2e9	9d5ce2c9-1029-4a00-b4b2-7d7b487ee31c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":369,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:24:33
12571	9d5ceae9-2d04-4706-92b2-97ea33eaf352	9d5ceae9-720e-4601-8ff7-26bb0ba98c5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 12:47:17
5278	9d5137a7-1afb-4591-99b1-a5572ff05d10	9d5137a7-3be1-46c9-b8ea-10c4f409fe74	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 17:11:56
5279	9d5137a7-3639-40ba-a128-a14e09c21c80	9d5137a7-3be1-46c9-b8ea-10c4f409fe74	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null","time":"41.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":28,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-23 17:11:56
5280	9d5137a7-368c-428f-ad8f-6834133d2b23	9d5137a7-3be1-46c9-b8ea-10c4f409fe74	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:11:56
5281	9d5137a7-3aa9-4245-b8ca-ebd78a95076a	9d5137a7-3be1-46c9-b8ea-10c4f409fe74	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 17:11:56
5282	9d5137a7-3af1-4c5d-8804-29e37a909ef6	9d5137a7-3be1-46c9-b8ea-10c4f409fe74	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null}},"duration":261,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:11:56
8831	9d52ef40-60dd-4e35-9315-5e9be50b86e0	9d52ef40-8e27-4a74-a861-e0d310f28d07	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:41:08
8832	9d52ef40-8309-4cc5-acbf-0ac4d9597417	9d52ef40-8e27-4a74-a861-e0d310f28d07	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"56.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:41:08
8833	9d52ef40-83a5-4b5d-afac-f637980ce44f	9d52ef40-8e27-4a74-a861-e0d310f28d07	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:41:08
8834	9d52ef40-8c05-4ac7-8176-05948e840d81	9d52ef40-8e27-4a74-a861-e0d310f28d07	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 13:41:08
8835	9d52ef40-8c98-4bf1-a539-4371f0e6f2d4	9d52ef40-8e27-4a74-a861-e0d310f28d07	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":596,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:41:08
11981	9d5ce043-8df6-4de8-aa21-0e327a67beba	9d5ce043-ab5c-4f3c-acdf-b847c07bd3dc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:17:30
11982	9d5ce043-a21c-4931-b874-34f2c7fb650c	9d5ce043-ab5c-4f3c-acdf-b847c07bd3dc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 28\\n                        ","time":"39.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"618a8b500e46ad393f7c65ceec660399","hostname":"EderCortes"}	2024-10-29 12:17:30
11983	9d5ce043-a5aa-41b7-b398-105e8912f980	9d5ce043-ab5c-4f3c-acdf-b847c07bd3dc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '28' order by \\"item_loans\\".\\"id\\" asc","time":"2.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 12:17:30
11984	9d5ce043-a5db-490d-b3a6-d7b9af5d1971	9d5ce043-ab5c-4f3c-acdf-b847c07bd3dc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 12:17:30
11985	9d5ce043-aa10-4f18-8062-d42e14fcb483	9d5ce043-ab5c-4f3c-acdf-b847c07bd3dc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:17:30
11986	9d5ce043-aa76-4fa6-9d7f-92fa9bd32146	9d5ce043-ab5c-4f3c-acdf-b847c07bd3dc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/28","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":28,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":600081,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":94,"loans_codigo":28,"itemloans_cuota":"1","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":95,"loans_codigo":28,"itemloans_cuota":"2","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":96,"loans_codigo":28,"itemloans_cuota":"3","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":97,"loans_codigo":28,"itemloans_cuota":"4","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":98,"loans_codigo":28,"itemloans_cuota":"5","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":99,"loans_codigo":28,"itemloans_cuota":"6","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null}]}},"duration":255,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:17:30
12356	9d5ce2c9-57c6-446e-a857-18439aa1c74b	9d5ce2c9-9d2d-49a7-8aad-7d533de26d8b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:24:33
12357	9d5ce2c9-97c8-439b-b3d6-586450c3b00f	9d5ce2c9-9d2d-49a7-8aad-7d533de26d8b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"141.05","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":177,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 12:24:34
12358	9d5ce2c9-981b-43ea-bd46-e8dbd50a1fe4	9d5ce2c9-9d2d-49a7-8aad-7d533de26d8b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 12:24:34
12359	9d5ce2c9-9c08-44e1-b0f9-ebe57e0d6cfd	9d5ce2c9-9d2d-49a7-8aad-7d533de26d8b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 12:24:34
12360	9d5ce2c9-9c49-4711-af31-f896afac202a	9d5ce2c9-9d2d-49a7-8aad-7d533de26d8b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:24:34
12572	9d5ceae9-6cc4-4472-bf11-c3454ae3ad3d	9d5ceae9-720e-4601-8ff7-26bb0ba98c5c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"139.68","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":180,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 12:47:17
12573	9d5ceae9-6d10-4035-9e18-75881de00ba2	9d5ceae9-720e-4601-8ff7-26bb0ba98c5c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 12:47:17
12574	9d5ceae9-70f8-4db3-9d40-ebd3d41cd210	9d5ceae9-720e-4601-8ff7-26bb0ba98c5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 12:47:17
12575	9d5ceae9-714d-4406-b9a9-8a51bd336a60	9d5ceae9-720e-4601-8ff7-26bb0ba98c5c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":346,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:47:17
12361	9d5ce2cb-b890-46fc-b432-0ddc7fb88e7f	9d5ce2cb-d45b-4e77-ab62-213f0c1cdf4e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 12:24:35
12362	9d5ce2cb-cfa2-4b19-9031-2ed6695f70a1	9d5ce2cb-d45b-4e77-ab62-213f0c1cdf4e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"39.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 12:24:35
12363	9d5ce2cb-cfe8-4756-8043-6171819ad26e	9d5ce2cb-d45b-4e77-ab62-213f0c1cdf4e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 12:24:35
12364	9d5ce2cb-d312-4779-9442-3935ac2bc5d6	9d5ce2cb-d45b-4e77-ab62-213f0c1cdf4e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 12:24:35
6956	9d52d863-6456-4d89-8f9e-c79af31fa658	9d52d863-8df9-410a-84e7-3c8633045dd1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:37:12
6957	9d52d863-8be9-4bb4-b721-1bd7de5f7f9e	9d52d863-8df9-410a-84e7-3c8633045dd1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:37:12
6958	9d52d863-8cdb-4374-91d1-dba1b2ec773e	9d52d863-8df9-410a-84e7-3c8633045dd1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":408,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:37:12
12365	9d5ce2cb-d35d-450b-a2c9-bb2e223d1db4	9d5ce2cb-d45b-4e77-ab62-213f0c1cdf4e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":215,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:24:35
12576	9d5ceaeb-234a-428e-a3ef-c6daa6bc4b82	9d5ceaeb-40b3-4d5b-98cd-b80df90551f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 12:47:18
12577	9d5ceaeb-3b9d-46ad-92e6-00c93d853efe	9d5ceaeb-40b3-4d5b-98cd-b80df90551f5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 12:47:18
12578	9d5ceaeb-3be4-4a5a-83d9-644e2828065b	9d5ceaeb-40b3-4d5b-98cd-b80df90551f5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 12:47:18
12579	9d5ceaeb-3f7f-46ae-9bd0-07b3aecbea39	9d5ceaeb-40b3-4d5b-98cd-b80df90551f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 12:47:18
12580	9d5ceaeb-3fc2-46a9-bc03-3537de345c04	9d5ceaeb-40b3-4d5b-98cd-b80df90551f5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:47:18
6959	9d52d864-0d20-4bf3-899c-b94558468cee	9d52d864-346d-4c12-b455-8c34f6d08201	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:37:13
6960	9d52d864-2c0f-441c-bcd3-fdd7f6aa8e2b	9d52d864-346d-4c12-b455-8c34f6d08201	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:37:13
6961	9d52d864-2c87-4719-a820-1aec50b3863f	9d52d864-346d-4c12-b455-8c34f6d08201	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:37:13
6962	9d52d864-3334-4a1c-b91d-86fe61840e6e	9d52d864-346d-4c12-b455-8c34f6d08201	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 12:37:13
6963	9d52d864-3380-4057-8a70-6cbbcf491033	9d52d864-346d-4c12-b455-8c34f6d08201	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":397,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:37:13
11721	9d5cce4a-1305-4038-b9b5-314812890ebe	9d5cce4a-3103-4d53-a44f-90e6040b215c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 11:27:15
11722	9d5cce4a-2f7f-4d12-a2a6-e0879e8102b0	9d5cce4a-3103-4d53-a44f-90e6040b215c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 11:27:15
8993	9d52f39c-8767-4784-822d-0ef9995ee161	9d52f39c-abb2-49a1-af48-c14eb147b6e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:53:20
8994	9d52f39c-aa13-4494-b175-22c847e3db53	9d52f39c-abb2-49a1-af48-c14eb147b6e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:53:20
8995	9d52f39c-aab7-4c1e-a0f6-8649de2b0174	9d52f39c-abb2-49a1-af48-c14eb147b6e8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":288,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:53:20
11723	9d5cce4a-300c-4acd-932a-dd6c2bf83208	9d5cce4a-3103-4d53-a44f-90e6040b215c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:27:15
12366	9d5ce2d4-5550-42d5-81ad-03e15af7bdba	9d5ce2d4-5863-4f4e-a3ef-e40f94fd455a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":143,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:24:41
12581	9d5ceaf1-6990-4d7e-a95f-9be717f5b5b5	9d5ceaf1-6d9d-4dbf-af6a-cff0223692b2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":157,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:47:22
11724	9d5cce4a-7b20-4a8f-92cd-9642f83a5a30	9d5cce4a-9445-4802-9871-d711e65c9cdd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 11:27:15
11725	9d5cce4a-9035-4185-9ff0-579f799be961	9d5cce4a-9445-4802-9871-d711e65c9cdd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"42.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-29 11:27:15
4564	9d513316-afe9-4f10-92c7-9f630e2ca6b3	9d513317-01bd-4017-a28a-658e95389743	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 16:59:10
4565	9d513316-fe14-41d1-aacc-c61ee320d542	9d513317-01bd-4017-a28a-658e95389743	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 16:59:10
4566	9d513316-ffd6-4893-aad7-5416107b2d8c	9d513317-01bd-4017-a28a-658e95389743	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":980,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:59:10
11726	9d5cce4a-92fe-4f21-b357-25a03d2034bc	9d5cce4a-9445-4802-9871-d711e65c9cdd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 11:27:15
8996	9d52f39c-ffbb-4c75-bb52-75f927f1b4a3	9d52f39d-48c0-4a4e-85c8-7a626cedef69	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:53:20
8997	9d52f39d-431f-4de4-8bd4-b178f2a7887d	9d52f39d-48c0-4a4e-85c8-7a626cedef69	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"148.33","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:53:20
11727	9d5cce4a-935a-4328-83ec-173f68bfaf1c	9d5cce4a-9445-4802-9871-d711e65c9cdd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":215,"memory":20,"hostname":"EderCortes"}	2024-10-29 11:27:15
8998	9d52f39d-4371-4371-9385-670f3d6c6b9a	9d52f39d-48c0-4a4e-85c8-7a626cedef69	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:53:20
8999	9d52f39d-4751-4c01-a0a0-e890d72d6ef1	9d52f39d-48c0-4a4e-85c8-7a626cedef69	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:53:20
12367	9d5ce2d5-10df-475f-b65a-2683dbb33eb8	9d5ce2d5-2e9e-408b-965d-4e6f4666f862	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 12:24:41
12368	9d5ce2d5-29f7-40be-8bb5-977775a7a77d	9d5ce2d5-2e9e-408b-965d-4e6f4666f862	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and \\"users\\".\\"name\\"::text like '%Eder%' and \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"42.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"5973bbb71a429036e6736a6c34d9d0d3","hostname":"EderCortes"}	2024-10-29 12:24:41
12369	9d5ce2d5-2d30-4e19-8862-34230ca9a146	9d5ce2d5-2e9e-408b-965d-4e6f4666f862	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 12:24:41
12370	9d5ce2d5-2d87-46e6-896d-2a32669afd49	9d5ce2d5-2e9e-408b-965d-4e6f4666f862	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:24:41
12582	9d5ceaf2-1382-4aaa-a371-69b072c3a47b	9d5ceaf2-1692-47ea-b317-376f2e5cfb77	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":137,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:47:22
4567	9d513317-687b-4c71-96b2-64467dbaea89	9d513317-8ab2-4319-9335-915de441aa97	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 16:59:10
4568	9d513317-8517-4fc6-945e-815c5a45462d	9d513317-8ab2-4319-9335-915de441aa97	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:59:10
4569	9d513317-856c-4ed1-9ceb-cb68f883f418	9d513317-8ab2-4319-9335-915de441aa97	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 16:59:10
4570	9d513317-8999-4ba0-b8e7-332e04d1d113	9d513317-8ab2-4319-9335-915de441aa97	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 16:59:10
4571	9d513317-89d9-4a86-82dd-8cd20de01b64	9d513317-8ab2-4319-9335-915de441aa97	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":307,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:59:10
6964	9d52d864-82ee-4218-a14e-e38aad54d79d	9d52d864-a833-47b0-af38-6fb5286b275b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 12:37:13
6965	9d52d864-a237-4300-8358-81215fe7a3c3	9d52d864-a833-47b0-af38-6fb5286b275b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:37:13
6966	9d52d864-a28d-4aa2-b6d3-51ba87c33d2b	9d52d864-a833-47b0-af38-6fb5286b275b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:37:13
6967	9d52d864-a6ea-4c78-93e9-e6ab181c0f8c	9d52d864-a833-47b0-af38-6fb5286b275b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 12:37:13
6968	9d52d864-a73e-4b23-b0f7-aab9a48614bd	9d52d864-a833-47b0-af38-6fb5286b275b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":281,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:37:13
9000	9d52f39d-47af-49b2-9ff7-921669c8d921	9d52f39d-48c0-4a4e-85c8-7a626cedef69	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":372,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:53:20
11728	9d5cce4b-7080-4748-b0de-a7178e17e534	9d5cce4b-8d12-4821-8f15-d75530c76ce5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 11:27:16
11729	9d5cce4b-8850-47bb-a6c1-2b5544b02553	9d5cce4b-8d12-4821-8f15-d75530c76ce5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 11:27:16
11730	9d5cce4b-889a-4dd5-a7e0-d96a432fec56	9d5cce4b-8d12-4821-8f15-d75530c76ce5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 11:27:16
11731	9d5cce4b-8bf6-4767-83e6-06a88f79faf9	9d5cce4b-8d12-4821-8f15-d75530c76ce5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 11:27:16
12371	9d5ce2dc-d30d-4264-a599-6446ae259012	9d5ce2dc-d665-4971-a5e3-d1e3ba993775	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":146,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:24:46
4572	9d513317-cf03-4878-b95b-940cbfb21d69	9d513317-f1ea-4168-9f8e-72e4952e19ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 16:59:11
4573	9d513317-ecc6-41c9-9f7e-98971f949ae8	9d513317-f1ea-4168-9f8e-72e4952e19ea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 16:59:11
4574	9d513317-ed0f-45eb-bc6f-9803179fce3b	9d513317-f1ea-4168-9f8e-72e4952e19ea	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 16:59:11
4575	9d513317-f0dd-43d8-aac6-90084cb70ead	9d513317-f1ea-4168-9f8e-72e4952e19ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 16:59:11
4576	9d513317-f122-4732-9ba2-74fcd5d81794	9d513317-f1ea-4168-9f8e-72e4952e19ea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:59:11
6969	9d52d864-f001-4ad2-87bd-fc5500b2ce2b	9d52d865-169d-449e-98e3-3e4453dbe84d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 12:37:13
5398	9d513889-e077-4327-8bf5-20c2ff229220	9d51388a-185e-4b6f-b2ae-a0fe007cec0b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 17:14:24
5399	9d51388a-15a2-4fda-80ce-da8ccab1c11d	9d51388a-185e-4b6f-b2ae-a0fe007cec0b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 17:14:24
5400	9d51388a-1707-42d6-8084-9c891f27278a	9d51388a-185e-4b6f-b2ae-a0fe007cec0b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":476,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:14:24
6970	9d52d865-0fb6-4c20-9f2f-6f1b47affddf	9d52d865-169d-449e-98e3-3e4453dbe84d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"53.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:37:13
6971	9d52d865-1005-439e-bf85-4fa41262879f	9d52d865-169d-449e-98e3-3e4453dbe84d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:37:13
6972	9d52d865-1188-4bf0-8cfc-578c29c646d9	9d52d865-169d-449e-98e3-3e4453dbe84d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"1.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:37:13
6973	9d52d865-11ba-47f4-aa6f-53b94a1ba1d2	9d52d865-169d-449e-98e3-3e4453dbe84d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:37:13
6974	9d52d865-155c-4736-bcdf-460d07178df7	9d52d865-169d-449e-98e3-3e4453dbe84d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 12:37:13
6975	9d52d865-15b7-408e-aa15-f8ccd5881864	9d52d865-169d-449e-98e3-3e4453dbe84d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":268,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:37:13
9001	9d52f39d-984e-4be7-ba11-5f88c763b203	9d52f39d-bc78-45a1-8fde-c49bae333838	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:53:20
9002	9d52f39d-b507-4bb2-8246-e713852b848f	9d52f39d-bc78-45a1-8fde-c49bae333838	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:53:20
9003	9d52f39d-b562-4d6b-9dcb-cd6ba16c6238	9d52f39d-bc78-45a1-8fde-c49bae333838	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:53:20
9004	9d52f39d-baae-49c0-b9a6-632a8f9dadd0	9d52f39d-bc78-45a1-8fde-c49bae333838	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:53:20
12372	9d5ce2dd-8cce-40b2-842b-d7a356457635	9d5ce2dd-a7a9-4150-a680-571669922154	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 12:24:47
12373	9d5ce2dd-a336-414b-a147-33c7d7825a9f	9d5ce2dd-a7a9-4150-a680-571669922154	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and \\"users\\".\\"name\\"::text like '%1004%' and \\"users\\".\\"user_document\\"::text like '%1004%' order by \\"users\\".\\"user_document\\" asc","time":"40.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"5973bbb71a429036e6736a6c34d9d0d3","hostname":"EderCortes"}	2024-10-29 12:24:47
12374	9d5ce2dd-a681-403b-b514-b07dd33efc2f	9d5ce2dd-a7a9-4150-a680-571669922154	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 12:24:47
12583	9d5ceaf2-8ec8-4f2d-95ef-5c901a0bc074	9d5ceaf2-a921-4002-ae85-b53ce247329f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 12:47:23
4577	9d513318-6b17-455a-94d2-dae2f6a86213	9d513318-a9e2-4cf8-b04f-26d50ce681fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 16:59:11
4578	9d513318-a00c-4f21-8b5d-2a73b8e056dd	9d513318-a9e2-4cf8-b04f-26d50ce681fe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"95.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 16:59:11
4579	9d513318-a08e-46fa-8044-bd78c33c0d95	9d513318-a9e2-4cf8-b04f-26d50ce681fe	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 16:59:11
4580	9d513318-a7da-472c-abc8-165b666dc957	9d513318-a9e2-4cf8-b04f-26d50ce681fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 16:59:11
4581	9d513318-a85c-49bf-8532-3eff2e2e68bb	9d513318-a9e2-4cf8-b04f-26d50ce681fe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":456,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:59:11
5401	9d51388a-97a9-4390-a949-5d046b0a10d0	9d51388a-c896-4f90-8147-e12d7c543dd0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 17:14:25
5402	9d51388a-bf4b-42c3-a34d-8072cde5b8e8	9d51388a-c896-4f90-8147-e12d7c543dd0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"65.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:14:25
5403	9d51388a-bfd8-4754-b031-0a356721fa8d	9d51388a-c896-4f90-8147-e12d7c543dd0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:14:25
5404	9d51388a-c6f2-4872-a906-5c2412468aee	9d51388a-c896-4f90-8147-e12d7c543dd0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-23 17:14:25
5405	9d51388a-c763-4525-8792-6cc525f64d83	9d51388a-c896-4f90-8147-e12d7c543dd0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":410,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:14:25
6976	9d52d866-dd80-4e2d-8cd2-54d500cefe04	9d52d867-0459-4ef9-98eb-89f521780c7e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 12:37:14
6977	9d52d866-fc35-4141-ac4d-b5067c4b0ded	9d52d867-0459-4ef9-98eb-89f521780c7e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"54.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:37:15
6978	9d52d866-fca9-48e3-90e4-85fc09cef0ac	9d52d867-0459-4ef9-98eb-89f521780c7e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:37:15
6979	9d52d867-0284-4011-aca0-e3ea8f94d5de	9d52d867-0459-4ef9-98eb-89f521780c7e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 12:37:15
6980	9d52d867-02f5-43d5-9871-70941ef59df8	9d52d867-0459-4ef9-98eb-89f521780c7e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":279,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:37:15
4582	9d513319-5968-4fbd-b168-b8b20ddf90bd	9d513319-8ea7-4826-8c40-e785941722ad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 16:59:12
4583	9d513319-83cc-4f7b-966c-390d3cf15fe2	9d513319-8ea7-4826-8c40-e785941722ad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"68.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 16:59:12
4584	9d513319-845c-4571-8934-600952257d69	9d513319-8ea7-4826-8c40-e785941722ad	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 16:59:12
4585	9d513319-8c59-4e12-9269-70ee97854371	9d513319-8ea7-4826-8c40-e785941722ad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 16:59:12
4586	9d513319-8cfc-4d9e-9588-2f9bf3e9da32	9d513319-8ea7-4826-8c40-e785941722ad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":537,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:59:12
5406	9d51388b-30f1-49d1-aa0d-a390f99d0f02	9d51388b-7e67-46d6-be94-47fe823c713e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-23 17:14:25
5407	9d51388b-7928-4b72-841b-3f879e9b2017	9d51388b-7e67-46d6-be94-47fe823c713e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"152.31","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:14:25
5408	9d51388b-7993-46d8-9c0e-ecc716fad7c3	9d51388b-7e67-46d6-be94-47fe823c713e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:14:25
5409	9d51388b-7d5a-41bd-b497-6f0b8971f833	9d51388b-7e67-46d6-be94-47fe823c713e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-23 17:14:25
5410	9d51388b-7d9f-42a9-8f48-ed336ae4a38e	9d51388b-7e67-46d6-be94-47fe823c713e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":444,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:14:25
9005	9d52f39d-bb0d-4472-bca1-995219cc3431	9d52f39d-bc78-45a1-8fde-c49bae333838	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":280,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:53:20
12375	9d5ce2dd-a6c2-4de7-8080-2412fe467fd5	9d5ce2dd-a7a9-4150-a680-571669922154	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"1004"},"session":[],"response_status":200,"response":{"data":[]},"duration":228,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:24:47
4587	9d513342-37f9-4360-bb53-f151bb00333e	9d513342-3af1-43cb-bd94-2eb30b5533fa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":158,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:59:38
5411	9d51388c-0f85-4b74-bc8c-947bda54e688	9d51388c-960f-454f-8759-e9a8a1b3036a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-23 17:14:26
5412	9d51388c-8b2d-4bb4-9c07-4b81f7e78acd	9d51388c-960f-454f-8759-e9a8a1b3036a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"227.87","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:14:26
5413	9d51388c-8bad-4c3f-9fd8-bdaf5dc67f0c	9d51388c-960f-454f-8759-e9a8a1b3036a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:14:26
5414	9d51388c-93db-4aad-a4f4-d9cb252cb74d	9d51388c-960f-454f-8759-e9a8a1b3036a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-23 17:14:26
5415	9d51388c-9460-46d1-8ac3-66345e1188d6	9d51388c-960f-454f-8759-e9a8a1b3036a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":701,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:14:26
9006	9d52f39e-2e3f-4ab7-871d-9209aef826bd	9d52f39e-7beb-4cba-ba8f-bf1a30d70e17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:53:21
9007	9d52f39e-7492-4f06-bf87-0cee048b2f2e	9d52f39e-7beb-4cba-ba8f-bf1a30d70e17	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"153.60","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-24 13:53:21
9008	9d52f39e-7522-4f1a-8169-ab9425e502f5	9d52f39e-7beb-4cba-ba8f-bf1a30d70e17	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:53:21
9009	9d52f39e-76ce-4a08-8cbd-b41336077761	9d52f39e-7beb-4cba-ba8f-bf1a30d70e17	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"1.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 13:53:21
9010	9d52f39e-76fd-46fb-98fe-3c7864e3737f	9d52f39e-7beb-4cba-ba8f-bf1a30d70e17	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:53:21
9011	9d52f39e-7a8f-467f-be38-dd7865135ee3	9d52f39e-7beb-4cba-ba8f-bf1a30d70e17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:53:21
9012	9d52f39e-7ad7-48c5-903f-8ae0139fa019	9d52f39e-7beb-4cba-ba8f-bf1a30d70e17	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":468,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:53:21
11732	9d5cce4b-8c38-4c23-8799-c562dc6dde6d	9d5cce4b-8d12-4821-8f15-d75530c76ce5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":267,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:27:16
4588	9d513342-9d28-4737-8e53-8e61a24f8df3	9d513342-ba84-4578-a2fc-c908fa77a20c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 16:59:39
4589	9d513342-b66f-41e0-933e-ce229527a242	9d513342-ba84-4578-a2fc-c908fa77a20c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"46.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":46,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 16:59:39
4590	9d513342-b94d-4623-80aa-fb9b415f26ce	9d513342-ba84-4578-a2fc-c908fa77a20c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 16:59:39
4591	9d513342-b98f-4c3c-bc04-b8b832137fe1	9d513342-ba84-4578-a2fc-c908fa77a20c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":228,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:59:39
5416	9d51388d-1f5f-425c-8f90-d3d6839df9eb	9d51388d-3df0-497c-8886-139b73d51f44	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-23 17:14:26
5417	9d51388d-390e-41e6-b0f2-e5bdaf1ab717	9d51388d-3df0-497c-8886-139b73d51f44	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"46.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:14:26
5418	9d51388d-3958-4743-aa52-b089f16d994c	9d51388d-3df0-497c-8886-139b73d51f44	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:14:26
5419	9d51388d-3cae-48fa-9be2-a5dd735ed565	9d51388d-3df0-497c-8886-139b73d51f44	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-23 17:14:26
5420	9d51388d-3d07-4c29-a8c3-ae468757c387	9d51388d-3df0-497c-8886-139b73d51f44	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":407,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:14:26
9013	9d52f3a0-1bbf-4820-ab84-f1611a8293d6	9d52f3a0-5251-4e50-953c-d706fd582720	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:53:22
9014	9d52f3a0-4800-421b-a32d-57fe27565ba5	9d52f3a0-5251-4e50-953c-d706fd582720	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"71.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:53:22
9015	9d52f3a0-4886-463e-8ecd-0ed81ae2cb5a	9d52f3a0-5251-4e50-953c-d706fd582720	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:53:22
9016	9d52f3a0-4ff5-4a3d-9959-28f50cefe947	9d52f3a0-5251-4e50-953c-d706fd582720	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 13:53:22
9017	9d52f3a0-509c-48c9-b202-81fb88ad4579	9d52f3a0-5251-4e50-953c-d706fd582720	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":584,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:53:22
11733	9d5cce5b-e25e-4de3-aff5-c37a100213ec	9d5cce5c-2975-4566-87e3-6d550f748ba5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 11:27:26
4592	9d513349-2ab6-41f8-aa14-02aa45b346e5	9d513349-7288-4fe2-8937-a4725bc95e50	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 16:59:43
4593	9d513349-6d36-4616-992b-b9a3d77da767	9d513349-7288-4fe2-8937-a4725bc95e50	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null","time":"148.11","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":28,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-23 16:59:43
4594	9d513349-6d9c-48fc-be1c-009b047bd464	9d513349-7288-4fe2-8937-a4725bc95e50	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 16:59:43
4595	9d513349-713a-4153-ab83-61a95c34704d	9d513349-7288-4fe2-8937-a4725bc95e50	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 16:59:43
4596	9d513349-717c-4ee4-8847-adfd4360196a	9d513349-7288-4fe2-8937-a4725bc95e50	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null}]},"duration":381,"memory":22,"hostname":"EderCortes"}	2024-10-23 16:59:43
5421	9d51389b-2d9d-4d99-9a71-7d16c7115808	9d51389b-30d9-48e0-bb5f-b91d477e62bc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":145,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:14:36
11734	9d5cce5c-24b0-4dff-a589-ff602fb46803	9d5cce5c-2975-4566-87e3-6d550f748ba5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"147.23","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 11:27:26
11735	9d5cce5c-24fe-450b-935c-8d7f01805fc1	9d5cce5c-2975-4566-87e3-6d550f748ba5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 11:27:26
11736	9d5cce5c-284f-4ff7-85a1-655004cab6a4	9d5cce5c-2975-4566-87e3-6d550f748ba5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 11:27:26
11737	9d5cce5c-2891-4d04-87cb-12b6c5795e0b	9d5cce5c-2975-4566-87e3-6d550f748ba5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":334,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:27:26
12376	9d5ce2dd-e1f7-4128-a369-6e468d567f37	9d5ce2dd-e4c8-459d-ac97-da4ec1130e4f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":137,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:24:47
12584	9d5ceaf2-a538-4238-847b-417e01aca0f6	9d5ceaf2-a921-4002-ae85-b53ce247329f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAri%' or \\"users\\".\\"user_document\\"::text like '%MAri%') order by \\"users\\".\\"user_document\\" asc","time":"41.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:47:23
12585	9d5ceaf2-a7ff-4049-9722-486095f46693	9d5ceaf2-a921-4002-ae85-b53ce247329f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 12:47:23
5422	9d51389b-8e06-4141-b6d8-4b82afce1e94	9d51389b-ddc8-4052-ab30-68103f927518	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 17:14:36
5423	9d51389b-d6a5-4e8d-b7b9-68d7eb69b0fe	9d51389b-ddc8-4052-ab30-68103f927518	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"155.35","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":46,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 17:14:36
5424	9d51389b-dbeb-4260-9ebf-53cd0eedd7ee	9d51389b-ddc8-4052-ab30-68103f927518	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 17:14:36
5425	9d51389b-dc5d-47f7-bf15-df2dd941ffd8	9d51389b-ddc8-4052-ab30-68103f927518	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:14:36
11738	9d5cce5c-691a-4a0e-a07e-39a9508d3cce	9d5cce5c-b0a7-411d-8ec9-bfc293493e40	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 11:27:27
11739	9d5cce5c-abc7-4f4b-9e64-ddac86194a25	9d5cce5c-b0a7-411d-8ec9-bfc293493e40	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"150.41","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 11:27:27
11740	9d5cce5c-ac1a-45e6-85fd-c5fb7afb270f	9d5cce5c-b0a7-411d-8ec9-bfc293493e40	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 11:27:27
11741	9d5cce5c-af8c-4e3a-bac1-c32b7100182e	9d5cce5c-b0a7-411d-8ec9-bfc293493e40	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 11:27:27
11742	9d5cce5c-afd0-4ef3-92d3-b477386b0b0a	9d5cce5c-b0a7-411d-8ec9-bfc293493e40	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":327,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:27:27
12377	9d5ce2de-309b-4cbd-b257-ed9e476afbf0	9d5ce2de-3367-4b0a-9e1c-bae70bc3eb6a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":132,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:24:47
12586	9d5ceaf2-a83f-47cb-8525-4a3629b81ab7	9d5ceaf2-a921-4002-ae85-b53ce247329f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAri"},"session":[],"response_status":200,"response":{"data":[]},"duration":205,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:47:23
11743	9d5cce5c-ee98-47d7-9023-641b9ac1c2e9	9d5cce5d-0a2b-44a8-8f71-851b2bb88559	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 11:27:27
11744	9d5cce5d-03e5-4e89-a262-e7fab251e720	9d5cce5d-0a2b-44a8-8f71-851b2bb88559	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '23' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"37.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":199,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-29 11:27:27
11745	9d5cce5d-0431-4d45-bf3c-a830e483cbe5	9d5cce5d-0a2b-44a8-8f71-851b2bb88559	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-29 11:27:27
11746	9d5cce5d-05a8-4e5a-8baa-47ebf45b04d5	9d5cce5d-0a2b-44a8-8f71-851b2bb88559	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '23' order by \\"item_loans\\".\\"id\\" asc","time":"1.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":200,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 11:27:27
11747	9d5cce5d-05dc-4415-bc97-ed9bc53a2256	9d5cce5d-0a2b-44a8-8f71-851b2bb88559	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 11:27:27
11748	9d5cce5d-0902-474b-b125-9b4449bb5a5b	9d5cce5d-0a2b-44a8-8f71-851b2bb88559	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 11:27:27
11749	9d5cce5d-094a-40ed-b963-a5ffbbc1e104	9d5cce5d-0a2b-44a8-8f71-851b2bb88559	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/23","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":23,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":600000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-29T16:27:12.000000Z","updated_at":"2024-10-29T16:27:12.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-05 05:00:00"},"items":[{"id":76,"loans_codigo":23,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"12500","itemloans_status":0,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:27:12.000000Z","updated_at":"2024-10-29T16:27:12.000000Z","deleted_at":null},{"id":77,"loans_codigo":23,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"12500","itemloans_status":0,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:27:12.000000Z","updated_at":"2024-10-29T16:27:12.000000Z","deleted_at":null},{"id":78,"loans_codigo":23,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"12500","itemloans_status":0,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:27:12.000000Z","updated_at":"2024-10-29T16:27:12.000000Z","deleted_at":null},{"id":79,"loans_codigo":23,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"12500","itemloans_status":0,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:27:12.000000Z","updated_at":"2024-10-29T16:27:12.000000Z","deleted_at":null},{"id":80,"loans_codigo":23,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"12500","itemloans_status":0,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:27:12.000000Z","updated_at":"2024-10-29T16:27:12.000000Z","deleted_at":null},{"id":81,"loans_codigo":23,"itemloans_cuota":"6","itemloans_valor_cuota":"100000","itemloans_iteres":"12500","itemloans_status":0,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-04-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:27:12.000000Z","updated_at":"2024-10-29T16:27:12.000000Z","deleted_at":null}]}},"duration":210,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:27:27
12378	9d5ce2de-aa08-4608-9ee7-4a18570a91b0	9d5ce2de-ad54-4a58-947b-4006c40d298d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":130,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:24:47
12587	9d5ceaf2-eab1-4921-821c-afb4ea19e91f	9d5ceaf3-0993-4ba5-8c6d-a89111242b9c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 12:47:23
12588	9d5ceaf3-0401-4cdc-8401-50d4ff91606a	9d5ceaf3-0993-4ba5-8c6d-a89111242b9c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAria%' or \\"users\\".\\"user_document\\"::text like '%MAria%') order by \\"users\\".\\"user_document\\" asc","time":"47.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:47:23
12589	9d5ceaf3-0830-4b30-bf15-26099f5f933e	9d5ceaf3-0993-4ba5-8c6d-a89111242b9c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 12:47:23
12590	9d5ceaf3-0886-4a1d-bbf5-e80fc3a21371	9d5ceaf3-0993-4ba5-8c6d-a89111242b9c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAria"},"session":[],"response_status":200,"response":{"data":[]},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:47:23
11750	9d5cce63-837a-4bac-9690-dc4ac951edb3	9d5cce63-9d6f-4ff4-bf33-ea4988746d04	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 11:27:31
11751	9d5cce63-992f-48ab-aa18-4099ed5b7324	9d5cce63-9d6f-4ff4-bf33-ea4988746d04	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"42.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-29 11:27:31
11752	9d5cce63-9c58-4163-b40a-18f06bb19c57	9d5cce63-9d6f-4ff4-bf33-ea4988746d04	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 11:27:31
11753	9d5cce63-9c9f-4b12-a486-dc696f914bca	9d5cce63-9d6f-4ff4-bf33-ea4988746d04	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:27:31
12379	9d5ce2df-21e0-4848-8953-30e2f1ae8cf9	9d5ce2df-3cac-47d6-af80-c9f63252096b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 12:24:48
12380	9d5ce2df-3839-497a-9990-63871c03be6e	9d5ce2df-3cac-47d6-af80-c9f63252096b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and \\"users\\".\\"name\\"::text like '%10046%' and \\"users\\".\\"user_document\\"::text like '%10046%' order by \\"users\\".\\"user_document\\" asc","time":"41.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"5973bbb71a429036e6736a6c34d9d0d3","hostname":"EderCortes"}	2024-10-29 12:24:48
12381	9d5ce2df-3b53-4315-a174-c75582fab743	9d5ce2df-3cac-47d6-af80-c9f63252096b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 12:24:48
12382	9d5ce2df-3ba2-456b-8d72-420302d5b8ee	9d5ce2df-3cac-47d6-af80-c9f63252096b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"10046"},"session":[],"response_status":200,"response":{"data":[]},"duration":211,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:24:48
12591	9d5ceaf6-70b0-4a2b-9f54-e9228c063150	9d5ceaf6-7398-46e2-a399-7899bd2d7e48	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":139,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:47:25
11754	9d5cceb6-5dbc-4908-8f5b-af7c58127769	9d5cceb6-810b-4ec4-b587-981f066105b5	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 11:28:26
11755	9d5cceb6-7a7b-486c-a1b3-98907f0c5d3e	9d5cceb6-810b-4ec4-b587-981f066105b5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 11:28:26
11756	9d5cceb6-7af1-41fe-bb22-fc905f5053d2	9d5cceb6-810b-4ec4-b587-981f066105b5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 11:28:26
11757	9d5cceb6-7f60-42b0-93e6-cd06745071ed	9d5cceb6-810b-4ec4-b587-981f066105b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 11:28:26
4866	9d513614-8191-4133-84db-8771f7cb1918	9d513614-b6e5-4beb-a3b5-0e1919e97400	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 17:07:32
4867	9d513614-b45a-4396-8cb4-2f186e22eceb	9d513614-b6e5-4beb-a3b5-0e1919e97400	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 17:07:32
4868	9d513614-b58e-45a4-8899-6633d6c35a74	9d513614-b6e5-4beb-a3b5-0e1919e97400	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":500,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:07:32
11758	9d5cceb6-7fb6-47e0-a33b-90ba231f7a3d	9d5cceb6-810b-4ec4-b587-981f066105b5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:28:26
12383	9d5ce2df-8c73-4ed0-b9fe-afcc85d9117f	9d5ce2df-a5eb-41c3-9489-4dcb4f880661	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 12:24:48
12384	9d5ce2df-a1d6-4b14-9045-4c807e048de5	9d5ce2df-a5eb-41c3-9489-4dcb4f880661	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and \\"users\\".\\"name\\"::text like '%100460%' and \\"users\\".\\"user_document\\"::text like '%100460%' order by \\"users\\".\\"user_document\\" asc","time":"39.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"5973bbb71a429036e6736a6c34d9d0d3","hostname":"EderCortes"}	2024-10-29 12:24:48
12385	9d5ce2df-a4b5-4f42-846b-5464f3950197	9d5ce2df-a5eb-41c3-9489-4dcb4f880661	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 12:24:48
12386	9d5ce2df-a4f8-43aa-b231-b5c7064bad6a	9d5ce2df-a5eb-41c3-9489-4dcb4f880661	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"28","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"100460"},"session":[],"response_status":200,"response":{"data":[]},"duration":255,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:24:48
12592	9d5ceaf6-eb24-44a4-bf7d-1da2aafcec85	9d5ceaf7-05ce-4ea8-9685-fbd5ef765c35	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 12:47:26
12593	9d5ceaf7-01ab-438d-9ac3-5c8021fbb769	9d5ceaf7-05ce-4ea8-9685-fbd5ef765c35	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAri%' or \\"users\\".\\"user_document\\"::text like '%MAri%') order by \\"users\\".\\"user_document\\" asc","time":"39.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:47:26
12594	9d5ceaf7-0478-43c3-9821-b1b028182981	9d5ceaf7-05ce-4ea8-9685-fbd5ef765c35	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 12:47:26
12595	9d5ceaf7-04cd-48ef-b1de-01ce3c33c75c	9d5ceaf7-05ce-4ea8-9685-fbd5ef765c35	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAri"},"session":[],"response_status":200,"response":{"data":[]},"duration":209,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:47:26
4869	9d513615-388a-4de7-b6e7-6ef4af4b3f8e	9d513615-6d87-4f41-8d39-a75c51846d5a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 17:07:32
4870	9d513615-62fb-466e-9e18-63aeda18c122	9d513615-6d87-4f41-8d39-a75c51846d5a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"70.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:07:32
4871	9d513615-6381-4377-85c6-bcccf7ec2986	9d513615-6d87-4f41-8d39-a75c51846d5a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:07:32
4872	9d513615-6b97-45a4-8284-c54619d3b880	9d513615-6d87-4f41-8d39-a75c51846d5a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 17:07:32
4873	9d513615-6bf8-4d5f-98b2-b9fb80716ca7	9d513615-6d87-4f41-8d39-a75c51846d5a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":426,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:07:32
11759	9d5cceb6-d03e-445e-9e71-4c3ef7b975a8	9d5cceb6-ed07-402b-9525-e88d45512575	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 11:28:26
11760	9d5cceb6-e820-4dcf-9951-883069e1f677	9d5cceb6-ed07-402b-9525-e88d45512575	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 11:28:26
11761	9d5cceb6-e882-490f-a09c-063072827562	9d5cceb6-ed07-402b-9525-e88d45512575	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 11:28:26
9170	9d52f580-e342-441b-a2cb-6fa525287817	9d52f581-039c-491e-9d00-bdc659a17c7f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:58:37
9171	9d52f581-01bf-4d36-906d-47b3f2d69c9a	9d52f581-039c-491e-9d00-bdc659a17c7f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:58:37
11762	9d5cceb6-ebcf-4005-8891-697d07522b05	9d5cceb6-ed07-402b-9525-e88d45512575	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 11:28:26
11763	9d5cceb6-ec12-4db5-92eb-4e2930c5f47c	9d5cceb6-ed07-402b-9525-e88d45512575	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":256,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:28:26
12387	9d5ce2df-e639-44c5-98e6-1e655b00f147	9d5ce2e0-00da-4c14-abaf-f1e55f99256f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 12:24:48
12388	9d5ce2df-fcd6-4732-9b9d-a2a4e55c6e9a	9d5ce2e0-00da-4c14-abaf-f1e55f99256f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and \\"users\\".\\"name\\"::text like '%1004608%' and \\"users\\".\\"user_document\\"::text like '%1004608%' order by \\"users\\".\\"user_document\\" asc","time":"40.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"5973bbb71a429036e6736a6c34d9d0d3","hostname":"EderCortes"}	2024-10-29 12:24:48
12389	9d5ce2df-ffc0-427c-aa9a-60a09e6702f8	9d5ce2e0-00da-4c14-abaf-f1e55f99256f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 12:24:48
12390	9d5ce2df-ffff-470d-b820-38bea649c724	9d5ce2e0-00da-4c14-abaf-f1e55f99256f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"29","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"1004608"},"session":[],"response_status":200,"response":{"data":[]},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:24:48
12596	9d5ceaf8-9b2d-48c8-998e-2cc36c6f07d4	9d5ceaf8-9dd7-47ba-8c9e-5b2c26f0adeb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":139,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:47:27
4874	9d513615-d6f8-42fb-99ac-45052ba6daa8	9d513616-2e4d-4b0f-8b0a-38b500cc1550	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 17:07:33
4875	9d513616-24db-40e7-9397-14a413d8be27	9d513616-2e4d-4b0f-8b0a-38b500cc1550	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"171.77","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:07:33
4876	9d513616-255e-4061-83c7-2141323014bd	9d513616-2e4d-4b0f-8b0a-38b500cc1550	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:07:33
4877	9d513616-2c2d-4553-b233-cf6fa00ebd2d	9d513616-2e4d-4b0f-8b0a-38b500cc1550	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 17:07:33
4878	9d513616-2cae-4b31-990c-87189b0ba06b	9d513616-2e4d-4b0f-8b0a-38b500cc1550	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":467,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:07:33
9172	9d52f581-028a-4000-bc22-498c8c400bcb	9d52f581-039c-491e-9d00-bdc659a17c7f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":267,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:58:37
11764	9d5cceb7-2d32-4639-b0fe-c8f3cba31ec4	9d5cceb7-4974-4e29-b33e-cfb8b5ac10d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 11:28:26
11765	9d5cceb7-42aa-4fb7-97d9-01b518953915	9d5cceb7-4974-4e29-b33e-cfb8b5ac10d6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '22' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"38.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":199,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-29 11:28:26
11766	9d5cceb7-42ff-476f-b674-89813996285c	9d5cceb7-4974-4e29-b33e-cfb8b5ac10d6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-29 11:28:26
11767	9d5cceb7-449b-4b5c-a372-9172acf1bd4b	9d5cceb7-4974-4e29-b33e-cfb8b5ac10d6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '22' order by \\"item_loans\\".\\"id\\" asc","time":"1.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":200,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 11:28:26
11768	9d5cceb7-44ef-46c3-9134-b8bcc1043d90	9d5cceb7-4974-4e29-b33e-cfb8b5ac10d6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 11:28:26
11769	9d5cceb7-4837-4159-b0c3-7dcaa10acc22	9d5cceb7-4974-4e29-b33e-cfb8b5ac10d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 11:28:26
11770	9d5cceb7-487b-4ab1-aea4-30c7f8876c06	9d5cceb7-4974-4e29-b33e-cfb8b5ac10d6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/22","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":22,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":500000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-05 05:00:00"},"items":[{"id":70,"loans_codigo":22,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":0,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null},{"id":71,"loans_codigo":22,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":0,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null},{"id":72,"loans_codigo":22,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":0,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null},{"id":73,"loans_codigo":22,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":0,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null},{"id":74,"loans_codigo":22,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":0,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null},{"id":75,"loans_codigo":22,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":0,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-04-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null}]}},"duration":217,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:28:26
12391	9d5ce2e5-a9df-4b14-9d19-475118939eb4	9d5ce2e5-acbc-4125-9a21-c578b005edb6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":133,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:24:52
12597	9d5ceaf9-5407-4051-8a1b-5bc24b454b47	9d5ceaf9-6e5a-45bd-b025-ca0a88204d17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 12:47:27
12598	9d5ceaf9-6a8c-4585-9990-d2aade9e7622	9d5ceaf9-6e5a-45bd-b025-ca0a88204d17	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"40.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:47:27
12599	9d5ceaf9-6d39-4148-b3b7-b02103e49afa	9d5ceaf9-6e5a-45bd-b025-ca0a88204d17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 12:47:27
4879	9d513617-2afc-41a5-84e2-4f6630717238	9d513617-607a-4ded-a708-6f5b36cdc542	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 17:07:34
4880	9d513617-5753-440c-aa58-12b8bb700373	9d513617-607a-4ded-a708-6f5b36cdc542	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"67.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:07:34
4881	9d513617-57db-4ab9-ba85-7490feac832f	9d513617-607a-4ded-a708-6f5b36cdc542	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:07:34
4882	9d513617-5ea2-4371-b1f4-7842c67b1312	9d513617-607a-4ded-a708-6f5b36cdc542	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 17:07:34
4883	9d513617-5f2b-4db9-b9d9-c0676cfd4dab	9d513617-607a-4ded-a708-6f5b36cdc542	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":759,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:07:34
9173	9d52f581-5438-4c09-b052-c16dbe5c3179	9d52f581-9f60-40e7-9f9c-204be54f734e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:58:37
9174	9d52f581-9a36-419e-84e6-1dcd289cabe1	9d52f581-9f60-40e7-9f9c-204be54f734e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"156.55","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:58:37
6249	9d52631a-7a25-47ed-9cc3-7fadf062d682	9d52631a-c29b-4792-baf1-e63db2239501	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 07:09:15
6250	9d52631a-c027-42c5-9a82-6739c4575830	9d52631a-c29b-4792-baf1-e63db2239501	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 07:09:15
6251	9d52631a-c158-4538-b442-043483d9e29d	9d52631a-c29b-4792-baf1-e63db2239501	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abfrom\\u00bb\\nLINE 14:     from loans l\\n             ^ (Connection: pgsql, SQL: \\n    select l.id,\\n        l.loans_documento,\\n        l.loans_nombre,\\n        l.loans_apellido_uno,\\n        l.loans_fecha,\\n        l.loans_valor_prestado,\\n        l.loans_cuotas,\\n        l.loans_estado,\\n        l.loans_intereses,\\n        ucl.name as cliente,\\n        uco.name as cobrador,\\n        ure.name as recomendador,\\n    from loans l\\n    join users ucl on l.user_customer = ucl.id\\n    join users uco on l.user_cobrador = uco.id\\n    left join users ure on l.user_recomendacion = ure.id\\n)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":568,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:09:15
9175	9d52f581-9a96-436c-abe5-0420bf0b74ef	9d52f581-9f60-40e7-9f9c-204be54f734e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:58:37
9176	9d52f581-9e38-4702-9154-27c0d2eaa2dc	9d52f581-9f60-40e7-9f9c-204be54f734e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:58:37
9177	9d52f581-9e8a-4e0e-a751-757df266b3af	9d52f581-9f60-40e7-9f9c-204be54f734e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":369,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:58:37
11771	9d5ccebc-58f1-4c64-8593-6979c4f95426	9d5ccebc-71a1-408a-806b-80db2bb716d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 11:28:30
11772	9d5ccebc-6d90-41ba-a7b0-e8697f1cb4e0	9d5ccebc-71a1-408a-806b-80db2bb716d1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"40.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-29 11:28:30
11773	9d5ccebc-706d-4576-9064-fe5faef7daf5	9d5ccebc-71a1-408a-806b-80db2bb716d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 11:28:30
11774	9d5ccebc-70b5-4a7a-ab59-1f1be22aedc2	9d5ccebc-71a1-408a-806b-80db2bb716d1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:28:30
4884	9d513617-dafb-443f-a544-6154861e47a1	9d513618-26eb-4614-8b7e-b6053538d6a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 17:07:34
4885	9d513618-2139-4988-a882-6010dfd431e2	9d513618-26eb-4614-8b7e-b6053538d6a4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"158.49","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:07:34
4886	9d513618-2189-4183-a027-008effd84efd	9d513618-26eb-4614-8b7e-b6053538d6a4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:07:34
4887	9d513618-2581-4791-b77e-e44920c39781	9d513618-26eb-4614-8b7e-b6053538d6a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 17:07:34
4888	9d513618-25d3-424a-acf8-8009db09d5a6	9d513618-26eb-4614-8b7e-b6053538d6a4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":476,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:07:34
9178	9d52f581-f0dd-4789-8934-486afcc9bbea	9d52f582-3886-49d4-88d1-8a623b562f92	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:58:38
9179	9d52f582-3314-4d6c-a26b-83dc1e665e7f	9d52f582-3886-49d4-88d1-8a623b562f92	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"143.50","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:58:38
9180	9d52f582-3374-49d0-a295-128e2959eedb	9d52f582-3886-49d4-88d1-8a623b562f92	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:58:38
9181	9d52f582-36d6-4582-b4ab-a0909e47240f	9d52f582-3886-49d4-88d1-8a623b562f92	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:58:38
9182	9d52f582-371b-439a-934f-e4f2bc2b193f	9d52f582-3886-49d4-88d1-8a623b562f92	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":375,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:58:38
11775	9d5ccec2-41e9-4625-9abb-79fe309b415b	9d5ccec2-58ed-4d3f-9b75-882d4531e361	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 11:28:33
11776	9d5ccec2-54fd-45fd-9042-d9d8d06365c8	9d5ccec2-58ed-4d3f-9b75-882d4531e361	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"38.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-29 11:28:33
11777	9d5ccec2-57b2-476d-ad73-41cb091e253d	9d5ccec2-58ed-4d3f-9b75-882d4531e361	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 11:28:33
12392	9d5ce2e6-24c3-4d54-a5f1-ab3f9fce1d73	9d5ce2e6-3f12-4fa1-9e14-fac4e843369f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 12:24:52
12393	9d5ce2e6-3ac3-41e9-b774-070ce482d2db	9d5ce2e6-3f12-4fa1-9e14-fac4e843369f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and \\"users\\".\\"name\\"::text like '%1004%' and \\"users\\".\\"user_document\\"::text like '%1004%' order by \\"users\\".\\"user_document\\" asc","time":"38.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"5973bbb71a429036e6736a6c34d9d0d3","hostname":"EderCortes"}	2024-10-29 12:24:52
12394	9d5ce2e6-3dcd-4f90-ac25-516a42174727	9d5ce2e6-3f12-4fa1-9e14-fac4e843369f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 12:24:52
4889	9d513623-2921-4d43-98d4-0bd4884fba0e	9d513623-2c5f-46a1-b859-75adeb284e0b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":143,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:07:41
9183	9d52f582-974a-4c75-998c-7f024514b90c	9d52f582-bfab-40d1-9de3-07c2b2305251	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:58:38
9184	9d52f582-b7f7-4ebe-bb8f-913afc683960	9d52f582-bfab-40d1-9de3-07c2b2305251	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"57.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-24 13:58:38
9185	9d52f582-b851-4348-8f5a-af394a983449	9d52f582-bfab-40d1-9de3-07c2b2305251	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:58:38
9186	9d52f582-ba12-45a8-881c-a7899686fa04	9d52f582-bfab-40d1-9de3-07c2b2305251	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"2.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 13:58:38
9187	9d52f582-ba51-419f-a509-cee66e733f59	9d52f582-bfab-40d1-9de3-07c2b2305251	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:58:38
9188	9d52f582-be53-422f-9a02-b176a93833f2	9d52f582-bfab-40d1-9de3-07c2b2305251	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:58:38
9189	9d52f582-beab-4a5e-a953-acca8e2c083d	9d52f582-bfab-40d1-9de3-07c2b2305251	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":323,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:58:38
11778	9d5ccec2-57fc-4a33-bc1c-2f6150ae14f1	9d5ccec2-58ed-4d3f-9b75-882d4531e361	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":201,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:28:33
12395	9d5ce2e6-3e10-4d23-b107-dbe762cf05c4	9d5ce2e6-3f12-4fa1-9e14-fac4e843369f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"1004"},"session":[],"response_status":200,"response":{"data":[]},"duration":214,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:24:52
12600	9d5ceaf9-6d79-47b9-bd0a-d926213eecf8	9d5ceaf9-6e5a-45bd-b025-ca0a88204d17	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":215,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:47:27
11779	9d5cceca-d1b6-4243-b698-7bdfc264d95b	9d5cceca-f431-4792-b0d5-a2f1fc97aee6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 11:28:39
11780	9d5cceca-ea17-4428-9f0c-76232cabe2b2	9d5cceca-f431-4792-b0d5-a2f1fc97aee6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 23\\n                        ","time":"47.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"f15fad8a3c20ce06b5700c805ce2c9b9","hostname":"EderCortes"}	2024-10-29 11:28:39
11781	9d5cceca-ee37-4f12-8e49-74c8eb88987e	9d5cceca-f431-4792-b0d5-a2f1fc97aee6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '23' order by \\"item_loans\\".\\"id\\" asc","time":"2.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 11:28:39
4698	9d5134b2-908d-4e62-b388-f0b6f5a2f112	9d5134b2-aee0-41a1-b94f-d20354e92496	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 17:03:40
4699	9d5134b2-ad4b-49ac-84ef-06affc692b0a	9d5134b2-aee0-41a1-b94f-d20354e92496	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 17:03:40
4700	9d5134b2-addf-4f29-855c-16a78bf02350	9d5134b2-aee0-41a1-b94f-d20354e92496	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:03:40
9190	9d52f584-aac9-40e0-952b-25a2645ec326	9d52f584-d5a9-4fb2-a149-ffe0a507654d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:58:39
9191	9d52f584-cdfd-426e-a2af-6674849e4150	9d52f584-d5a9-4fb2-a149-ffe0a507654d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"56.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:58:40
11782	9d5cceca-ee71-44f7-bb65-5d506cc0a3d5	9d5cceca-f431-4792-b0d5-a2f1fc97aee6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 11:28:39
9192	9d52f584-ce79-48d8-8ddd-4a20c5ed6d55	9d52f584-d5a9-4fb2-a149-ffe0a507654d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:58:40
9193	9d52f584-d39e-4757-afd1-31fa3c406adc	9d52f584-d5a9-4fb2-a149-ffe0a507654d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:58:40
11783	9d5cceca-f297-4d00-b21a-76cefba76639	9d5cceca-f431-4792-b0d5-a2f1fc97aee6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 11:28:39
11784	9d5cceca-f2ee-4623-9613-6184b9d2e237	9d5cceca-f431-4792-b0d5-a2f1fc97aee6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/23","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":23,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":600000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":76,"loans_codigo":23,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"12500","itemloans_status":0,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:27:12.000000Z","updated_at":"2024-10-29T16:27:12.000000Z","deleted_at":null},{"id":77,"loans_codigo":23,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"12500","itemloans_status":0,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:27:12.000000Z","updated_at":"2024-10-29T16:27:12.000000Z","deleted_at":null},{"id":78,"loans_codigo":23,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"12500","itemloans_status":0,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:27:12.000000Z","updated_at":"2024-10-29T16:27:12.000000Z","deleted_at":null},{"id":79,"loans_codigo":23,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"12500","itemloans_status":0,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:27:12.000000Z","updated_at":"2024-10-29T16:27:12.000000Z","deleted_at":null},{"id":80,"loans_codigo":23,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"12500","itemloans_status":0,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:27:12.000000Z","updated_at":"2024-10-29T16:27:12.000000Z","deleted_at":null},{"id":81,"loans_codigo":23,"itemloans_cuota":"6","itemloans_valor_cuota":"100000","itemloans_iteres":"12500","itemloans_status":0,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-04-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:27:12.000000Z","updated_at":"2024-10-29T16:27:12.000000Z","deleted_at":null}]}},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:28:39
12396	9d5ce2ea-f9de-407f-8a0f-d14f32cd2726	9d5ce2ea-ff07-474c-a2c3-2e62bf1a5ac4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":153,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:24:56
12601	9d5ceaf9-adda-48ad-ad57-06315c7a02eb	9d5ceaf9-b141-4251-abed-8b6c5e620287	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":149,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:47:27
4701	9d5134b2-f3c1-452c-bf69-65c73d6443c9	9d5134b3-1572-4614-b58e-d60b9a5f2d49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 17:03:40
4702	9d5134b3-0e83-4cef-b46e-cc07210d62de	9d5134b3-1572-4614-b58e-d60b9a5f2d49	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:03:40
4703	9d5134b3-0ee4-4a05-b360-d4f04b18e821	9d5134b3-1572-4614-b58e-d60b9a5f2d49	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:03:40
4704	9d5134b3-1405-47c1-8975-135b8452aa22	9d5134b3-1572-4614-b58e-d60b9a5f2d49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 17:03:40
4705	9d5134b3-1460-4c7c-9eed-6c9a63bb712c	9d5134b3-1572-4614-b58e-d60b9a5f2d49	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:03:40
4890	9d513623-90e1-4d13-8522-9d67a047e452	9d513623-aed9-4120-be6b-e85105bbc566	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 17:07:42
4891	9d513623-a973-4510-a214-e719bae566db	9d513623-aed9-4120-be6b-e85105bbc566	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%Edde%' or \\"users\\".\\"user_document\\"::text like '%Edde%' order by \\"users\\".\\"user_document\\" asc","time":"43.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":46,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 17:07:42
4892	9d513623-ad82-4cd7-8eac-88e2564c914f	9d513623-aed9-4120-be6b-e85105bbc566	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 17:07:42
4893	9d513623-adcd-4409-8f1c-52c5c83245ca	9d513623-aed9-4120-be6b-e85105bbc566	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"Edde"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:07:42
9194	9d52f584-d420-4545-a96d-ee3b3212326b	9d52f584-d5a9-4fb2-a149-ffe0a507654d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":386,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:58:40
6172	9d5259d0-86b4-4ab6-a17a-555d5e1afbc3	9d5259d0-cba9-4950-9a6f-433bac79cd26	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 06:43:17
6173	9d5259d0-c9f1-4e37-ad17-b479dd92320f	9d5259d0-cba9-4950-9a6f-433bac79cd26	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 06:43:17
3656	9d51092c-e1e1-4ba3-b614-9ccff6cf4b08	9d51092d-0b1a-433c-a0ce-29c7deaf85d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-10-23 15:01:58
3657	9d51092d-0902-40ca-ac31-dcbf570fcde5	9d51092d-0b1a-433c-a0ce-29c7deaf85d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-10-23 15:01:58
3658	9d51092d-09e3-456b-a0ab-5eab7f579fe0	9d51092d-0b1a-433c-a0ce-29c7deaf85d8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":283,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:01:58
6174	9d5259d0-caa1-4219-85de-baab5eccde5c	9d5259d0-cba9-4950-9a6f-433bac79cd26	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":372,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:43:17
11785	9d5ccf28-1f0f-4eb7-a3a5-36ea62dbc910	9d5ccf28-225a-479f-908c-ae8f942a9d69	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":141,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:29:40
12397	9d5ce2eb-aaa9-493a-a695-97c898f05e86	9d5ce2eb-ada3-4391-b52c-b7ea7f2e1ec8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":133,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:24:56
12602	9d5ceafa-0718-4e71-be09-9d1464e4d994	9d5ceafa-4d5c-472d-94d3-d4876b31bd62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 12:47:28
12603	9d5ceafa-4934-4ffd-b8ae-51e51c031afd	9d5ceafa-4d5c-472d-94d3-d4876b31bd62	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"151.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:47:28
12604	9d5ceafa-4c13-46d4-9249-ba8286d4f289	9d5ceafa-4d5c-472d-94d3-d4876b31bd62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 12:47:28
12605	9d5ceafa-4c62-4ed0-bfa6-f1f046c012b3	9d5ceafa-4d5c-472d-94d3-d4876b31bd62	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":339,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:47:28
4706	9d5134b3-56d3-46f9-b1d0-d85a50f76556	9d5134b3-755b-460b-ad6a-782522bf8c31	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 17:03:40
4707	9d5134b3-702a-4d76-93d1-32ba8523581c	9d5134b3-755b-460b-ad6a-782522bf8c31	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:03:40
4708	9d5134b3-7084-491b-a182-f9fd3d1622ff	9d5134b3-755b-460b-ad6a-782522bf8c31	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:03:40
4709	9d5134b3-742e-47ca-90b8-8b0f4cc46872	9d5134b3-755b-460b-ad6a-782522bf8c31	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-23 17:03:40
4710	9d5134b3-7477-4aaa-9d3e-0b7a277bf2c9	9d5134b3-755b-460b-ad6a-782522bf8c31	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:03:40
4894	9d513626-5c7a-4838-b607-4cb80bc024e2	9d513626-7d57-4efd-b097-5fb2b94595d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 17:07:43
4895	9d513626-7631-4bd5-bee7-46bf825c01ce	9d513626-7d57-4efd-b097-5fb2b94595d6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '14' and \\"users\\".\\"deleted_at\\" is null","time":"44.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":28,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-23 17:07:44
4896	9d513626-7683-464f-9d65-43c38b16b2ac	9d513626-7d57-4efd-b097-5fb2b94595d6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:07:44
4897	9d513626-7bcb-4e4d-9ad7-0b92e442cc8f	9d513626-7d57-4efd-b097-5fb2b94595d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 17:07:44
4898	9d513626-7c2d-43aa-bffa-a53141115852	9d513626-7d57-4efd-b097-5fb2b94595d6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/14","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:07:44
6175	9d5259d1-193e-4178-82dd-696c845bf7ac	9d5259d1-1f66-4c04-b755-0735ee734128	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 06:43:17
6176	9d5259d1-1dc5-42c9-82eb-df8ca6628867	9d5259d1-1f66-4c04-b755-0735ee734128	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 06:43:17
6177	9d5259d1-1e6a-4e90-befb-536b13f32216	9d5259d1-1f66-4c04-b755-0735ee734128	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":"Empty Response","duration":190,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:43:17
12398	9d5ce2eb-fc73-4e89-ad30-ff937fa02fc1	9d5ce2ec-16b2-4cf7-ab8a-aa11b7fb5183	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 12:24:56
12399	9d5ce2ec-129c-489f-8819-9dc4fa5a21f4	9d5ce2ec-16b2-4cf7-ab8a-aa11b7fb5183	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and \\"users\\".\\"name\\"::text like '%MAri%' and \\"users\\".\\"user_document\\"::text like '%MAri%' order by \\"users\\".\\"user_document\\" asc","time":"41.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"5973bbb71a429036e6736a6c34d9d0d3","hostname":"EderCortes"}	2024-10-29 12:24:56
12400	9d5ce2ec-1586-434b-9a37-625c3e34e3c5	9d5ce2ec-16b2-4cf7-ab8a-aa11b7fb5183	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 12:24:56
6178	9d5259d3-0fef-4ea3-a8f3-21d710101fff	9d5259d3-2e2b-4480-9c62-d0aec82b845a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 06:43:18
6179	9d5259d3-28d8-4e88-82ec-cf0f844c32fe	9d5259d3-2e2b-4480-9c62-d0aec82b845a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 06:43:18
6180	9d5259d3-2924-42a6-a8e1-491c60f58e31	9d5259d3-2e2b-4480-9c62-d0aec82b845a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 06:43:18
6181	9d5259d3-2cc9-4541-9611-7b0ff943ac6d	9d5259d3-2e2b-4480-9c62-d0aec82b845a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 06:43:18
6182	9d5259d3-2d15-4d3d-a320-017a0d4fa403	9d5259d3-2e2b-4480-9c62-d0aec82b845a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":392,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:43:18
12401	9d5ce2ec-15c7-43f1-9232-8867e3d7dbec	9d5ce2ec-16b2-4cf7-ab8a-aa11b7fb5183	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAri"},"session":[],"response_status":200,"response":{"data":[]},"duration":210,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:24:56
12402	9d5ce2ec-612b-497b-9d14-1596ddc1391e	9d5ce2ec-7cc9-47a9-9b06-2b7555304208	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 12:24:56
6287	9d52641a-8c59-4fae-bc7f-79cb61fed931	9d52641a-b96a-4962-b37f-f6d9e47e680c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 07:12:03
6288	9d52641a-b742-4d05-bbb1-0383d16e5c1f	9d52641a-b96a-4962-b37f-f6d9e47e680c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 07:12:03
6289	9d52641a-b7fe-4d59-961d-49c60ca8a003	9d52641a-b96a-4962-b37f-f6d9e47e680c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":375,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:12:03
12403	9d5ce2ec-77a2-4703-99f6-993fc1cf0b92	9d5ce2ec-7cc9-47a9-9b06-2b7555304208	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and \\"users\\".\\"name\\"::text like '%MAria%' and \\"users\\".\\"user_document\\"::text like '%MAria%' order by \\"users\\".\\"user_document\\" asc","time":"42.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"5973bbb71a429036e6736a6c34d9d0d3","hostname":"EderCortes"}	2024-10-29 12:24:57
11791	9d5ccf56-5972-451b-b7a3-5f0f881a7a8d	9d5ccf56-5d38-4cd0-b612-cdf7ddf4ccee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":195,"memory":20,"hostname":"EderCortes"}	2024-10-29 11:30:10
12404	9d5ce2ec-7b42-451a-9d71-5c9121d53353	9d5ce2ec-7cc9-47a9-9b06-2b7555304208	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-29 12:24:57
12405	9d5ce2ec-7b9b-412f-bb1e-f933c7fbdf98	9d5ce2ec-7cc9-47a9-9b06-2b7555304208	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAria"},"session":[],"response_status":200,"response":{"data":[]},"duration":217,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:24:57
11797	9d5ccf75-3a72-4326-9e3d-a67dc7efcba1	9d5ccf75-3e08-4a25-9c04-5027cc042311	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":176,"memory":20,"hostname":"EderCortes"}	2024-10-29 11:30:31
9352	9d52f759-6c1a-441a-b8e6-5012cf10e75e	9d52f759-90e3-4e64-a20f-0b6b30855891	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 14:03:47
9353	9d52f759-8eb5-4a2d-ba3d-65c5e7a1bc15	9d52f759-90e3-4e64-a20f-0b6b30855891	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 14:03:47
5555	9d5243d8-4879-4e8b-8aa6-0c7e02de911f	9d5243d8-b7ff-4f63-bcc5-fdbc3d08ac17	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 05:41:51
5556	9d5243d8-b50a-4830-a664-763db088f407	9d5243d8-b7ff-4f63-bcc5-fdbc3d08ac17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 05:41:51
5557	9d5243d8-b63b-4bad-a9b4-3196a1b189ed	9d5243d8-b7ff-4f63-bcc5-fdbc3d08ac17	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":539,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:41:51
9354	9d52f759-8fe4-4f09-83f7-88a19584830d	9d52f759-90e3-4e64-a20f-0b6b30855891	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":280,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:03:47
5558	9d5243d9-1f29-4f13-97c0-f91e95975b48	9d5243d9-6cd0-49a7-9918-413ad1f605fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 05:41:51
5559	9d5243d9-6432-4870-8f5c-13153027079f	9d5243d9-6cd0-49a7-9918-413ad1f605fa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"147.68","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":112,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 05:41:51
5560	9d5243d9-6485-4921-a8f5-6b7725a8a963	9d5243d9-6cd0-49a7-9918-413ad1f605fa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 05:41:51
5561	9d5243d9-6bc6-4cb0-af48-bd4295e702da	9d5243d9-6cd0-49a7-9918-413ad1f605fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 05:41:52
5562	9d5243d9-6c06-46fa-93a3-5a6d4b23759e	9d5243d9-6cd0-49a7-9918-413ad1f605fa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":402,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:41:52
9355	9d52f759-ebc2-4cfc-89aa-01bce411e7e2	9d52f75a-119f-4eb6-bf49-016e0bd77c63	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 14:03:47
9356	9d52f75a-0a0f-4a8f-9550-f2ada76f9a91	9d52f75a-119f-4eb6-bf49-016e0bd77c63	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 14:03:47
9357	9d52f75a-0a8c-4071-a0e3-42f60c9587f0	9d52f75a-119f-4eb6-bf49-016e0bd77c63	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 14:03:47
7206	9d52db8e-227a-4337-8cc0-b531f3fa45fc	9d52db8e-6deb-48eb-aca4-97c87d7ea814	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 12:46:04
9358	9d52f75a-102f-4205-a584-aa83225bf320	9d52f75a-119f-4eb6-bf49-016e0bd77c63	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 14:03:47
9359	9d52f75a-1082-4667-9719-43a0d54b7a13	9d52f75a-119f-4eb6-bf49-016e0bd77c63	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":295,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:03:47
11798	9d5ccf75-f00d-40fa-9eb5-ec07464630f9	9d5ccf76-3d4f-44ca-9856-ef151e7fb0e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 11:30:31
11799	9d5ccf76-3143-406a-9343-d412dfc19a69	9d5ccf76-3d4f-44ca-9856-ef151e7fb0e5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta', 'De las nieve', 'ds', 'CC', '100465546', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '600000', 25, 6, 'S', null, 'Tue Oct 29 2024', 'Pendiente', '312596295', 12, 14, 18, 14, '2024-11-05T05:00:00.000Z', '2024-10-29 11:30:31', '2024-10-29 11:30:31') returning \\"id\\"","time":"4.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":99,"hash":"bfad4cea82a73099ff0b3164dd496ca0","hostname":"EderCortes"}	2024-10-29 11:30:31
11800	9d5ccf76-3199-4444-a374-97a2ee55b0ba	9d5ccf76-3d4f-44ca-9856-ef151e7fb0e5	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:26","hostname":"EderCortes"}	2024-10-29 11:30:31
11801	9d5ccf76-3303-4528-8cf3-d2de8c8c4930	9d5ccf76-3d4f-44ca-9856-ef151e7fb0e5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (26, 1, 100000, 12500, 0, 'N\\/A', '05-11-2024', 12, '2024-10-29 11:30:31', '2024-10-29 11:30:31')","time":"2.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":150,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:30:31
11802	9d5ccf76-332d-403d-aceb-5ecb2e566ea0	9d5ccf76-3d4f-44ca-9856-ef151e7fb0e5	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:30:31
11803	9d5ccf76-339d-45b1-8b31-982a432af03e	9d5ccf76-3d4f-44ca-9856-ef151e7fb0e5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (26, 2, 100000, 12500, 0, 'N\\/A', '12-11-2024', 12, '2024-10-29 11:30:31', '2024-10-29 11:30:31')","time":"0.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":150,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:30:31
11804	9d5ccf76-33be-434d-a0a3-548884bb6ab5	9d5ccf76-3d4f-44ca-9856-ef151e7fb0e5	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:30:31
5563	9d5243d9-b191-4650-9646-b1646f72aaf2	9d5243d9-cf59-4245-8003-67ce46a2a799	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 05:41:52
5564	9d5243d9-c9ef-4ff6-abff-d42bee655c8a	9d5243d9-cf59-4245-8003-67ce46a2a799	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":112,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 05:41:52
5565	9d5243d9-ca3b-4b44-880b-f8bce033ae17	9d5243d9-cf59-4245-8003-67ce46a2a799	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 05:41:52
5566	9d5243d9-ce2f-44b0-9b04-c626c12be637	9d5243d9-cf59-4245-8003-67ce46a2a799	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 05:41:52
5567	9d5243d9-ce7b-44b5-a9b8-1ee51ed83260	9d5243d9-cf59-4245-8003-67ce46a2a799	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:41:52
7207	9d52db8e-6c49-4e71-852a-958f246408a0	9d52db8e-6deb-48eb-aca4-97c87d7ea814	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 12:46:04
7208	9d52db8e-6ce3-4609-9c79-b656535b8f6d	9d52db8e-6deb-48eb-aca4-97c87d7ea814	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":351,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:46:04
9360	9d52f75a-6ae4-4a45-8fcf-721f298be7a6	9d52f75a-b9d5-4342-b977-69af32e51011	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 14:03:47
9361	9d52f75a-b407-4a80-95c1-75476daaa37f	9d52f75a-b9d5-4342-b977-69af32e51011	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"163.31","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 14:03:47
9362	9d52f75a-b47a-4b8e-a9e7-1fac3af21d06	9d52f75a-b9d5-4342-b977-69af32e51011	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 14:03:47
9363	9d52f75a-b8a5-4ec6-b8a8-4ce073a61b8f	9d52f75a-b9d5-4342-b977-69af32e51011	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 14:03:47
9364	9d52f75a-b8f1-4082-ba29-48677990f3e8	9d52f75a-b9d5-4342-b977-69af32e51011	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":408,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:03:47
11805	9d5ccf76-342a-4e9f-84a9-1482d503bdc5	9d5ccf76-3d4f-44ca-9856-ef151e7fb0e5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (26, 3, 100000, 12500, 0, 'N\\/A', '19-11-2024', 12, '2024-10-29 11:30:31', '2024-10-29 11:30:31')","time":"0.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":150,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:30:31
11806	9d5ccf76-344a-46b3-a530-a7ec0e9a4573	9d5ccf76-3d4f-44ca-9856-ef151e7fb0e5	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:30:31
11807	9d5ccf76-34b1-40e4-bf30-fc24a3236610	9d5ccf76-3d4f-44ca-9856-ef151e7fb0e5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (26, 4, 100000, 12500, 0, 'N\\/A', '26-11-2024', 12, '2024-10-29 11:30:31', '2024-10-29 11:30:31')","time":"0.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":150,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:30:31
11808	9d5ccf76-34d1-4219-8d42-c19fd671cd36	9d5ccf76-3d4f-44ca-9856-ef151e7fb0e5	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:30:31
11809	9d5ccf76-3554-4e61-b908-33d8324566b9	9d5ccf76-3d4f-44ca-9856-ef151e7fb0e5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (26, 5, 100000, 12500, 0, 'N\\/A', '03-12-2024', 12, '2024-10-29 11:30:31', '2024-10-29 11:30:31')","time":"0.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":150,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:30:31
5568	9d5243db-9177-41fb-a2ca-32ba711af019	9d5243db-b12a-4ed0-902b-a6c2c5323406	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 05:41:53
5569	9d5243db-abe4-48f0-b631-6ecf77f05c1f	9d5243db-b12a-4ed0-902b-a6c2c5323406	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 05:41:53
5570	9d5243db-ac3e-4a67-8ffa-b7815fc840b5	9d5243db-b12a-4ed0-902b-a6c2c5323406	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 05:41:53
5571	9d5243db-afd2-4202-9fa0-fe9ecb6fdd42	9d5243db-b12a-4ed0-902b-a6c2c5323406	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 05:41:53
5572	9d5243db-b019-4e6e-82b0-dab42bd39767	9d5243db-b12a-4ed0-902b-a6c2c5323406	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":287,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:41:53
7209	9d52db8e-b155-4bf3-8638-f644b975e4a8	9d52db8e-f7bc-4aa4-929c-3470a8e9625e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 12:46:04
7210	9d52db8e-f262-409f-8f01-329edf0ffce7	9d52db8e-f7bc-4aa4-929c-3470a8e9625e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"145.82","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:46:04
7211	9d52db8e-f2c1-41b7-9c90-70cb2a84422f	9d52db8e-f7bc-4aa4-929c-3470a8e9625e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:46:04
7212	9d52db8e-f69f-4d60-98a9-f1af19688cbd	9d52db8e-f7bc-4aa4-929c-3470a8e9625e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 12:46:04
7213	9d52db8e-f6e7-4472-9d83-7a6de5339ebd	9d52db8e-f7bc-4aa4-929c-3470a8e9625e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":328,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:46:04
9365	9d52f75b-0f24-4a96-9222-0855c9cc4eeb	9d52f75b-5722-4334-adc0-0aaeab6fa34c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 14:03:48
9366	9d52f75b-4f8e-40bb-bbef-c794559fdd05	9d52f75b-5722-4334-adc0-0aaeab6fa34c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"144.81","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-24 14:03:48
9367	9d52f75b-4fdb-4634-ac49-8d5a63a8c3b8	9d52f75b-5722-4334-adc0-0aaeab6fa34c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 14:03:48
9368	9d52f75b-51d4-42aa-95fc-b72e0a89af78	9d52f75b-5722-4334-adc0-0aaeab6fa34c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"1.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 14:03:48
9369	9d52f75b-5209-449e-ad39-300af0f48410	9d52f75b-5722-4334-adc0-0aaeab6fa34c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 14:03:48
9370	9d52f75b-5595-454e-8143-1b8e48d82123	9d52f75b-5722-4334-adc0-0aaeab6fa34c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 14:03:48
9371	9d52f75b-55de-4864-a834-035093ff987a	9d52f75b-5722-4334-adc0-0aaeab6fa34c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":386,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:03:48
11810	9d5ccf76-3589-4afa-a3dd-930682182db8	9d5ccf76-3d4f-44ca-9856-ef151e7fb0e5	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:30:31
5573	9d5243e9-0ed1-48fa-a43d-1c230e7284aa	9d5243e9-11f7-469a-9cc0-d87ec852dbef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":141,"memory":20,"hostname":"EderCortes"}	2024-10-24 05:42:02
7214	9d52db8f-3ed9-4853-ba1b-611eee07b21c	9d52db8f-5f07-4c37-9fe5-ca85cbe1e228	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 12:46:04
7215	9d52db8f-5a2b-4d46-94a5-d27fafad59bb	9d52db8f-5f07-4c37-9fe5-ca85cbe1e228	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:46:04
7216	9d52db8f-5a79-45a5-8147-590f896a9e84	9d52db8f-5f07-4c37-9fe5-ca85cbe1e228	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:46:04
7217	9d52db8f-5df2-4ff5-8563-9c2b8a60933e	9d52db8f-5f07-4c37-9fe5-ca85cbe1e228	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 12:46:04
7218	9d52db8f-5e34-498b-9569-9d695b3599ee	9d52db8f-5f07-4c37-9fe5-ca85cbe1e228	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":245,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:46:04
9372	9d52f75d-8996-4e8a-a61f-a4790fa15dfa	9d52f75d-da93-4db0-9e6c-e543ea00999a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 14:03:49
9373	9d52f75d-d449-4acc-9c80-728227508226	9d52f75d-da93-4db0-9e6c-e543ea00999a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"161.12","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 14:03:50
9374	9d52f75d-d4af-4e00-8271-7ff58edf03f0	9d52f75d-da93-4db0-9e6c-e543ea00999a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 14:03:50
9375	9d52f75d-d909-4b3a-a87b-f01798b1fe51	9d52f75d-da93-4db0-9e6c-e543ea00999a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-24 14:03:50
9376	9d52f75d-d960-4e0b-81ef-cbaa87cc6c34	9d52f75d-da93-4db0-9e6c-e543ea00999a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":517,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:03:50
11811	9d5ccf76-360a-4457-aa65-f5472f6dacda	9d5ccf76-3d4f-44ca-9856-ef151e7fb0e5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (26, 6, 100000, 12500, 0, 'N\\/A', '10-12-2024', 12, '2024-10-29 11:30:31', '2024-10-29 11:30:31')","time":"0.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":150,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:30:31
11812	9d5ccf76-363d-4a8d-9ee9-0a0e6d57f9b5	9d5ccf76-3d4f-44ca-9856-ef151e7fb0e5	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:30:31
11813	9d5ccf76-3c2a-4b72-adab-eb1bf9ff7015	9d5ccf76-3d4f-44ca-9856-ef151e7fb0e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 11:30:31
5574	9d5243e9-c43a-4589-b7bc-8b4c521fc535	9d5243e9-e2c7-4512-86d2-4976f2de61e6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 05:42:02
5575	9d5243e9-dd36-4c38-a674-0848cc2bd255	9d5243e9-e2c7-4512-86d2-4976f2de61e6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Luis%' or \\"users\\".\\"user_document\\"::text like '%Luis%' order by \\"users\\".\\"user_document\\" asc","time":"43.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":49,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-24 05:42:02
5576	9d5243e9-e175-4a94-ab6c-d41b825f0337	9d5243e9-e2c7-4512-86d2-4976f2de61e6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 05:42:02
5577	9d5243e9-e1bd-448e-aa08-d12e6c1f60d9	9d5243e9-e2c7-4512-86d2-4976f2de61e6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Luis"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":228,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:42:02
7219	9d52db8f-a1f8-456e-8848-8e7e470a695e	9d52db8f-e7d8-4887-a8a3-f6163eabd2f7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 12:46:05
7220	9d52db8f-e0fa-4c96-99be-e3438f47ac52	9d52db8f-e7d8-4887-a8a3-f6163eabd2f7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"142.20","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:46:05
7221	9d52db8f-e15d-404d-ac84-72372e13a50d	9d52db8f-e7d8-4887-a8a3-f6163eabd2f7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:46:05
7222	9d52db8f-e2dc-43f2-83c8-788ece574f71	9d52db8f-e7d8-4887-a8a3-f6163eabd2f7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"1.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:46:05
7223	9d52db8f-e310-4854-a95f-fad9fbbf8636	9d52db8f-e7d8-4887-a8a3-f6163eabd2f7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:46:05
7224	9d52db8f-e688-4882-a14f-6672e0134c3f	9d52db8f-e7d8-4887-a8a3-f6163eabd2f7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 12:46:05
7225	9d52db8f-e6d1-41f2-a4ae-0d08d79d8e35	9d52db8f-e7d8-4887-a8a3-f6163eabd2f7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:46:05
11814	9d5ccf76-3c6c-4e3d-b8e2-97806811a2b3	9d5ccf76-3d4f-44ca-9856-ef151e7fb0e5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"766","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"100465546","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"600000","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":18,"user_recomendacion":14,"loans_inicio_pago":"2024-11-05T05:00:00.000Z","created_at":null,"updated_at":null,"deleted_at":null},"detail":{"status":false,"observacion":"N\\/A","fecha_pago":"Tue Oct 29 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":26},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:30:31
5578	9d5243ef-4129-445c-8b03-0ac5624d1b27	9d5243ef-5f32-4f57-8d72-33a9a5cc3428	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 05:42:06
5579	9d5243ef-59cd-455c-a5cf-8b94c93aebfc	9d5243ef-5f32-4f57-8d72-33a9a5cc3428	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '18' and \\"users\\".\\"deleted_at\\" is null","time":"40.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":31,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-24 05:42:06
5580	9d5243ef-5a23-4da5-a3bf-e4fe45d945e8	9d5243ef-5f32-4f57-8d72-33a9a5cc3428	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 05:42:06
5581	9d5243ef-5db0-4a73-ba55-d1f898f8db45	9d5243ef-5f32-4f57-8d72-33a9a5cc3428	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 05:42:06
5582	9d5243ef-5e1f-4e62-9a79-414f2af289de	9d5243ef-5f32-4f57-8d72-33a9a5cc3428	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/18","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:42:06
7226	9d52db91-9ae4-45a0-be3c-a0d26fbdee42	9d52db91-bb0a-450c-b8af-5ac5c1048c8f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 12:46:06
7227	9d52db91-b5af-4d16-9c1d-233f82e05899	9d52db91-bb0a-450c-b8af-5ac5c1048c8f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"46.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:46:06
7228	9d52db91-b60d-4ccf-9ea4-19681b9dc31c	9d52db91-bb0a-450c-b8af-5ac5c1048c8f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:46:06
7229	9d52db91-b9cc-48e1-afee-a188bb8cf765	9d52db91-bb0a-450c-b8af-5ac5c1048c8f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-24 12:46:06
5583	9d52442a-6725-46bb-9dc0-5a25ae66452a	9d52442a-6acb-4bbc-b023-a88751fac837	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":185,"memory":20,"hostname":"EderCortes"}	2024-10-24 05:42:45
7230	9d52db91-ba0c-427f-9898-22dff89ed24f	9d52db91-bb0a-450c-b8af-5ac5c1048c8f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":256,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:46:06
11815	9d5ccf81-4975-4bc1-99af-2aa453ca4ce2	9d5ccf81-4cd3-47da-a3f0-c46e9b553226	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":158,"memory":20,"hostname":"EderCortes"}	2024-10-29 11:30:39
5584	9d5245cc-61e6-401a-bcb6-8a45ce985eb8	9d5245cc-65df-4406-8ec4-362cfd787354	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":186,"memory":20,"hostname":"EderCortes"}	2024-10-24 05:47:19
6334	9d52647a-9207-419c-84f8-ddd00c569202	9d52647a-af39-4978-97fd-0d396a0db1c6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 07:13:06
6335	9d52647a-ad15-457e-86bb-6363cb7d3601	9d52647a-af39-4978-97fd-0d396a0db1c6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 07:13:06
6336	9d52647a-adf6-450a-8172-c08eee4352ef	9d52647a-af39-4978-97fd-0d396a0db1c6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abfrom\\u00bb\\nLINE 13:     from loans l\\n             ^ (Connection: pgsql, SQL: \\n    select l.id,\\n        l.loans_documento,\\n        l.loans_nombre,\\n        l.loans_apellido_uno,\\n        l.loans_fecha,\\n        l.loans_valor_prestado,\\n        l.loans_cuotas,\\n        l.loans_estado,\\n        l.loans_intereses,\\n        uco.name as cobrador,\\n        ure.name as recomendador,\\n    from loans l\\n    join users ucl on l.user_customer = ucl.id\\n    join users uco on l.user_cobrador = uco.id\\n    left join users ure on l.user_recomendacion = ure.id\\n)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:13:06
9534	9d5322f5-0eac-496c-b13d-d3382f0a0723	9d5322f5-d4b6-43ae-bcae-81c48852c3f8	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 16:05:43
9535	9d5322f5-d182-47d8-9a62-cdd0787a42b9	9d5322f5-d4b6-43ae-bcae-81c48852c3f8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 16:05:43
9536	9d5322f5-d306-4f92-8c59-4dbdab95552c	9d5322f5-d4b6-43ae-bcae-81c48852c3f8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1449,"memory":22,"hostname":"EderCortes"}	2024-10-24 16:05:43
11816	9d5ccf81-fdf1-4a14-893f-ec129e111fb9	9d5ccf82-209b-49e8-9307-2e01b6feb14b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 11:30:39
11817	9d5ccf82-1687-4d36-ae04-2dbabd344932	9d5ccf82-209b-49e8-9307-2e01b6feb14b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta', 'De las nieve', 'ds', 'CC', '100465546', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '600001', 25, 6, 'D', null, 'Tue Oct 29 2024', 'Pendiente', '312596295', 12, 14, 18, 14, '2024-11-05T05:00:00.000Z', '2024-10-29 11:30:39', '2024-10-29 11:30:39') returning \\"id\\"","time":"4.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":99,"hash":"bfad4cea82a73099ff0b3164dd496ca0","hostname":"EderCortes"}	2024-10-29 11:30:39
11818	9d5ccf82-16f0-433c-b96d-d3e1d20b2fc9	9d5ccf82-209b-49e8-9307-2e01b6feb14b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:27","hostname":"EderCortes"}	2024-10-29 11:30:39
11819	9d5ccf82-1854-4a58-8f21-32e0d2dc0cec	9d5ccf82-209b-49e8-9307-2e01b6feb14b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (27, 1, 100000.16666667, 12500.020833333, 0, 'N\\/A', '30-10-2024', 12, '2024-10-29 11:30:39', '2024-10-29 11:30:39')","time":"2.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":150,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:30:39
11820	9d5ccf82-187c-4e3c-a665-d33645648f36	9d5ccf82-209b-49e8-9307-2e01b6feb14b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:30:39
5585	9d524670-f3c3-4951-8fed-4fc61abd1056	9d524670-fbef-4713-a54d-f12b89d6fee9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":337,"memory":20,"hostname":"EderCortes"}	2024-10-24 05:49:06
9537	9d5322f6-cd34-4952-bdb9-eec341297e1c	9d5322f7-0e07-4f06-a7ee-b2b192b5325a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 16:05:44
9538	9d5322f7-020c-40e5-8285-130e0e93d524	9d5322f7-0e07-4f06-a7ee-b2b192b5325a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"88.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 16:05:44
7362	9d52dd29-3607-44c4-bb12-282d93f7df51	9d52dd29-536f-481f-9a84-71115b64ba19	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 12:50:33
7363	9d52dd29-520e-4b5f-bd1a-dd3f192e5760	9d52dd29-536f-481f-9a84-71115b64ba19	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 12:50:33
7364	9d52dd29-529b-4365-afcb-3dc3fe726a89	9d52dd29-536f-481f-9a84-71115b64ba19	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":248,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:50:33
9539	9d5322f7-029d-4ed2-8bee-efc83c9b7964	9d5322f7-0e07-4f06-a7ee-b2b192b5325a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 16:05:44
9540	9d5322f7-0c2b-4bad-92d5-2db0531f606e	9d5322f7-0e07-4f06-a7ee-b2b192b5325a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 16:05:44
9541	9d5322f7-0ca2-4c93-be59-1bba2883c6fe	9d5322f7-0e07-4f06-a7ee-b2b192b5325a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":755,"memory":22,"hostname":"EderCortes"}	2024-10-24 16:05:44
11821	9d5ccf82-18e9-4c87-9e2b-2b64909896f1	9d5ccf82-209b-49e8-9307-2e01b6feb14b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (27, 2, 100000.16666667, 12500.020833333, 0, 'N\\/A', '31-10-2024', 12, '2024-10-29 11:30:39', '2024-10-29 11:30:39')","time":"0.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":150,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:30:39
11822	9d5ccf82-1910-434f-bccd-252fe879caa6	9d5ccf82-209b-49e8-9307-2e01b6feb14b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:30:39
11823	9d5ccf82-1979-4d77-a642-83a56e567966	9d5ccf82-209b-49e8-9307-2e01b6feb14b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (27, 3, 100000.16666667, 12500.020833333, 0, 'N\\/A', '01-11-2024', 12, '2024-10-29 11:30:39', '2024-10-29 11:30:39')","time":"0.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":150,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:30:39
11824	9d5ccf82-1999-42bf-8bef-c04662d878b0	9d5ccf82-209b-49e8-9307-2e01b6feb14b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:30:39
11825	9d5ccf82-19fe-466a-ad5a-58a425baf324	9d5ccf82-209b-49e8-9307-2e01b6feb14b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (27, 4, 100000.16666667, 12500.020833333, 0, 'N\\/A', '02-11-2024', 12, '2024-10-29 11:30:39', '2024-10-29 11:30:39')","time":"0.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":150,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:30:39
11826	9d5ccf82-1a1e-4410-a073-bc2286fad98d	9d5ccf82-209b-49e8-9307-2e01b6feb14b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:30:39
11827	9d5ccf82-1a87-4991-8d4f-b0ecf13b5316	9d5ccf82-209b-49e8-9307-2e01b6feb14b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (27, 5, 100000.16666667, 12500.020833333, 0, 'N\\/A', '03-11-2024', 12, '2024-10-29 11:30:39', '2024-10-29 11:30:39')","time":"0.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":150,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:30:39
11828	9d5ccf82-1aab-47e2-a9f3-689d92103d65	9d5ccf82-209b-49e8-9307-2e01b6feb14b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:30:39
11829	9d5ccf82-1b11-4639-bc0f-5c0629eb7665	9d5ccf82-209b-49e8-9307-2e01b6feb14b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (27, 6, 100000.16666667, 12500.020833333, 0, 'N\\/A', '04-11-2024', 12, '2024-10-29 11:30:39', '2024-10-29 11:30:39')","time":"0.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":150,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:30:39
11830	9d5ccf82-1b32-42e7-bbdc-22c081c90533	9d5ccf82-209b-49e8-9307-2e01b6feb14b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:30:39
11831	9d5ccf82-1f67-4275-a54e-12390d975751	9d5ccf82-209b-49e8-9307-2e01b6feb14b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 11:30:39
5586	9d5246b9-4faf-48bc-ba84-7a2374ba4ccf	9d5246b9-53c8-457f-b178-3339dfb0162a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":219,"memory":20,"hostname":"EderCortes"}	2024-10-24 05:49:54
7365	9d52dd29-a051-4f2d-9796-e8379c1a9474	9d52dd29-be7b-4d8c-b5c1-c7bd08dfe606	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 12:50:33
7366	9d52dd29-b96a-41f5-995d-dbe3ac1bdc65	9d52dd29-be7b-4d8c-b5c1-c7bd08dfe606	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:50:33
7367	9d52dd29-b9b6-4d14-bb38-cc7c36e3f499	9d52dd29-be7b-4d8c-b5c1-c7bd08dfe606	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:50:33
7368	9d52dd29-bd4d-4723-b643-a418bc00b7d1	9d52dd29-be7b-4d8c-b5c1-c7bd08dfe606	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 12:50:33
7369	9d52dd29-bd97-4c2d-9929-6b5b0745008c	9d52dd29-be7b-4d8c-b5c1-c7bd08dfe606	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:50:33
9542	9d5322f7-b052-4b3f-a61a-8d8b8f165033	9d5322f8-16d6-479a-9ee0-87d01695f5aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 16:05:45
9543	9d5322f8-0938-4df1-abb5-b6df4a8a2379	9d5322f8-16d6-479a-9ee0-87d01695f5aa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"118.21","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 16:05:45
9544	9d5322f8-0a22-4bbd-9413-e49c2c20dbcb	9d5322f8-16d6-479a-9ee0-87d01695f5aa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 16:05:45
9545	9d5322f8-135c-4fb7-847b-6b210f12c971	9d5322f8-16d6-479a-9ee0-87d01695f5aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 16:05:45
9546	9d5322f8-1411-4fa7-9492-5e939e0cc43b	9d5322f8-16d6-479a-9ee0-87d01695f5aa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":653,"memory":22,"hostname":"EderCortes"}	2024-10-24 16:05:45
11832	9d5ccf82-1fad-4680-bf9b-3caab02ef7cc	9d5ccf82-209b-49e8-9307-2e01b6feb14b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"766","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"100465546","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"600001","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":18,"user_recomendacion":14,"loans_inicio_pago":"2024-11-05T05:00:00.000Z","created_at":null,"updated_at":null,"deleted_at":null},"detail":{"status":false,"observacion":"N\\/A","fecha_pago":"Tue Oct 29 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":27},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:30:39
7370	9d52dd2a-0146-4369-93a7-e8adf0286dea	9d52dd2a-29dc-4768-9a4d-7f95fca7eb2a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 12:50:33
7371	9d52dd2a-22ef-4ba8-ae4f-caba7f5633b9	9d52dd2a-29dc-4768-9a4d-7f95fca7eb2a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"60.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:50:34
7372	9d52dd2a-2380-4532-9e54-5521c25ab8a5	9d52dd2a-29dc-4768-9a4d-7f95fca7eb2a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:50:34
7373	9d52dd2a-2847-43a1-98c8-10a71fcda98a	9d52dd2a-29dc-4768-9a4d-7f95fca7eb2a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 12:50:34
7374	9d52dd2a-28be-4e2a-b1ff-af02cb738992	9d52dd2a-29dc-4768-9a4d-7f95fca7eb2a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":261,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:50:34
9547	9d5322f9-3363-4382-aaae-0681208287b2	9d5322f9-8e9b-47c3-a58d-417ec09c1e17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 16:05:46
9548	9d5322f9-806f-4121-ae83-07ffa6354fb3	9d5322f9-8e9b-47c3-a58d-417ec09c1e17	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"147.71","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-24 16:05:46
9549	9d5322f9-8102-4cb3-89d8-bf49047aa448	9d5322f9-8e9b-47c3-a58d-417ec09c1e17	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 16:05:46
9550	9d5322f9-8502-453e-bb27-2f8253f1b36a	9d5322f9-8e9b-47c3-a58d-417ec09c1e17	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"5.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 16:05:46
9551	9d5322f9-8567-4a7e-97f3-6d477ec99e00	9d5322f9-8e9b-47c3-a58d-417ec09c1e17	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 16:05:46
9552	9d5322f9-8c6e-415f-9f20-77c80e617e2d	9d5322f9-8e9b-47c3-a58d-417ec09c1e17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 16:05:46
9553	9d5322f9-8cf9-45ad-b7ce-3a19dfad3e5e	9d5322f9-8e9b-47c3-a58d-417ec09c1e17	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":929,"memory":22,"hostname":"EderCortes"}	2024-10-24 16:05:46
11833	9d5ccf96-da62-4ea8-89d2-81f9ba0c8819	9d5ccf96-de01-432b-a1e7-1c69ca327066	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":176,"memory":20,"hostname":"EderCortes"}	2024-10-29 11:30:53
7375	9d52dd2a-767e-48a5-a2cc-bcb48639ff2c	9d52dd2a-9721-47a3-bd4c-68278f77d6ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 12:50:34
7376	9d52dd2a-9059-40c7-96c7-f2e7ffc23bfa	9d52dd2a-9721-47a3-bd4c-68278f77d6ae	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"46.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:50:34
7377	9d52dd2a-90af-430a-a0a8-fc1efaac32d9	9d52dd2a-9721-47a3-bd4c-68278f77d6ae	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:50:34
7378	9d52dd2a-92a1-46e6-a265-e37056f61aa4	9d52dd2a-9721-47a3-bd4c-68278f77d6ae	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"2.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:50:34
7379	9d52dd2a-92d9-496c-9a08-c5d7bc922b7d	9d52dd2a-9721-47a3-bd4c-68278f77d6ae	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:50:34
7380	9d52dd2a-95e0-469d-8198-6e83e1b680e1	9d52dd2a-9721-47a3-bd4c-68278f77d6ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 12:50:34
7381	9d52dd2a-963d-4ad4-9ef1-a809fcf4446e	9d52dd2a-9721-47a3-bd4c-68278f77d6ae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":260,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:50:34
9554	9d532300-3eed-42d9-b0a0-709fb5b1832d	9d532300-8e5d-4f01-a7af-eb19e616eb1f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 16:05:50
9555	9d532300-7fc4-48d9-b7dd-041a91749f5e	9d532300-8e5d-4f01-a7af-eb19e616eb1f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"93.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 16:05:50
9556	9d532300-804f-4269-b0b9-74256ad96452	9d532300-8e5d-4f01-a7af-eb19e616eb1f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 16:05:50
9557	9d532300-8b9a-4ac8-89eb-93679f1e9adf	9d532300-8e5d-4f01-a7af-eb19e616eb1f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 16:05:50
9558	9d532300-8c63-4475-8bc0-e3ab7b67b4be	9d532300-8e5d-4f01-a7af-eb19e616eb1f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":945,"memory":22,"hostname":"EderCortes"}	2024-10-24 16:05:50
11834	9d5ccf97-aa7c-4b64-9080-6ad6aec99137	9d5ccf97-d7f6-4957-8677-5c248ba2077f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 11:30:53
11835	9d5ccf97-ca83-4233-a868-7f953d139f0b	9d5ccf97-d7f6-4957-8677-5c248ba2077f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta', 'De las nieve', 'ds', 'CC', '100465546', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '600081', 25, 6, 'Q', null, 'Tue Oct 29 2024', 'Pendiente', '312596295', 12, 14, 18, 14, '2024-11-05T05:00:00.000Z', '2024-10-29 11:30:53', '2024-10-29 11:30:53') returning \\"id\\"","time":"5.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":99,"hash":"bfad4cea82a73099ff0b3164dd496ca0","hostname":"EderCortes"}	2024-10-29 11:30:53
11836	9d5ccf97-cb49-4998-a7a2-ae9a9ce2db92	9d5ccf97-d7f6-4957-8677-5c248ba2077f	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:28","hostname":"EderCortes"}	2024-10-29 11:30:53
11837	9d5ccf97-cd27-46c2-9855-0f21af9b45a4	9d5ccf97-d7f6-4957-8677-5c248ba2077f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (28, 1, 100013.5, 12501.6875, 0, 'N\\/A', '13-11-2024', 12, '2024-10-29 11:30:53', '2024-10-29 11:30:53')","time":"3.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":150,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:30:53
11838	9d5ccf97-cd64-4e0b-b37a-a049719f2d6f	9d5ccf97-d7f6-4957-8677-5c248ba2077f	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:30:53
7382	9d52dd2c-7eb1-42dc-a106-0b60beae3fc4	9d52dd2c-b3ce-4dd9-9a47-a79b37b218c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 12:50:35
7383	9d52dd2c-abb0-4db8-9049-a8f1a1f41956	9d52dd2c-b3ce-4dd9-9a47-a79b37b218c8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"80.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:50:35
7384	9d52dd2c-ac67-4d7d-b1aa-a270a4ce057b	9d52dd2c-b3ce-4dd9-9a47-a79b37b218c8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:50:35
7385	9d52dd2c-b1b4-48c1-8fd5-f243af493a7c	9d52dd2c-b3ce-4dd9-9a47-a79b37b218c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 12:50:35
7386	9d52dd2c-b245-4128-bb9b-dd7e55a781e1	9d52dd2c-b3ce-4dd9-9a47-a79b37b218c8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":486,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:50:35
9559	9d53231d-42c2-4d03-9d00-7f910be8618b	9d53231d-6ec2-46c9-bf15-b12d8e2e75b7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 16:06:09
9560	9d53231d-6501-460c-aeca-c2d8621871a1	9d53231d-6ec2-46c9-bf15-b12d8e2e75b7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"45.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-24 16:06:09
9561	9d53231d-656b-4847-91ef-54a16895b1f6	9d53231d-6ec2-46c9-bf15-b12d8e2e75b7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-10-24 16:06:09
9562	9d53231d-6ca8-4b7f-9cc3-f1993985e149	9d53231d-6ec2-46c9-bf15-b12d8e2e75b7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 16:06:09
9563	9d53231d-6d16-4789-aa53-89e52465a860	9d53231d-6ec2-46c9-bf15-b12d8e2e75b7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":489,"memory":22,"hostname":"EderCortes"}	2024-10-24 16:06:09
11839	9d5ccf97-ce07-4e38-89de-53e28f749705	9d5ccf97-d7f6-4957-8677-5c248ba2077f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (28, 2, 100013.5, 12501.6875, 0, 'N\\/A', '28-11-2024', 12, '2024-10-29 11:30:53', '2024-10-29 11:30:53')","time":"0.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":150,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:30:53
11840	9d5ccf97-ce43-40ee-8c72-33eada654c56	9d5ccf97-d7f6-4957-8677-5c248ba2077f	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:30:53
11841	9d5ccf97-cef0-4f3e-8c38-7d21cd62a30a	9d5ccf97-d7f6-4957-8677-5c248ba2077f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (28, 3, 100013.5, 12501.6875, 0, 'N\\/A', '13-12-2024', 12, '2024-10-29 11:30:53', '2024-10-29 11:30:53')","time":"0.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":150,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:30:53
11842	9d5ccf97-cf25-46f2-b417-1d30b0949ba4	9d5ccf97-d7f6-4957-8677-5c248ba2077f	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:30:53
11843	9d5ccf97-cfb4-41e8-b7e1-00ff413889b9	9d5ccf97-d7f6-4957-8677-5c248ba2077f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (28, 4, 100013.5, 12501.6875, 0, 'N\\/A', '28-12-2024', 12, '2024-10-29 11:30:53', '2024-10-29 11:30:53')","time":"0.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":150,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:30:53
11844	9d5ccf97-cfdd-4f41-88fb-5bd5917b5373	9d5ccf97-d7f6-4957-8677-5c248ba2077f	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:30:53
9564	9d5324cf-9727-4b41-9401-b20a524969c9	9d5324cf-bb02-4208-b446-c795657e7f0d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 16:10:54
9565	9d5324cf-b4d4-4a5d-935d-eaefa8f83b38	9d5324cf-bb02-4208-b446-c795657e7f0d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"46.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-24 16:10:54
9566	9d5324cf-b97f-468b-a176-d624a1259703	9d5324cf-bb02-4208-b446-c795657e7f0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 16:10:54
9567	9d5324cf-b9d9-4e18-8351-cdd056e1c08b	9d5324cf-bb02-4208-b446-c795657e7f0d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":329,"memory":22,"hostname":"EderCortes"}	2024-10-24 16:10:54
11845	9d5ccf97-d05d-449a-ae19-7636c2b7d00e	9d5ccf97-d7f6-4957-8677-5c248ba2077f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (28, 5, 100013.5, 12501.6875, 0, 'N\\/A', '12-01-2025', 12, '2024-10-29 11:30:53', '2024-10-29 11:30:53')","time":"0.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":150,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:30:53
11846	9d5ccf97-d084-4533-aa46-33ed74d0770d	9d5ccf97-d7f6-4957-8677-5c248ba2077f	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:30:53
11847	9d5ccf97-d0fe-4945-90ce-10958e5bd113	9d5ccf97-d7f6-4957-8677-5c248ba2077f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (28, 6, 100013.5, 12501.6875, 0, 'N\\/A', '27-01-2025', 12, '2024-10-29 11:30:53', '2024-10-29 11:30:53')","time":"0.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":150,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:30:53
11848	9d5ccf97-d123-4731-be01-77f9bbe9601f	9d5ccf97-d7f6-4957-8677-5c248ba2077f	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:30:53
11849	9d5ccf97-d639-4e24-9344-d3026d4507d7	9d5ccf97-d7f6-4957-8677-5c248ba2077f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 11:30:53
11850	9d5ccf97-d69d-452c-bd46-010d2d275580	9d5ccf97-d7f6-4957-8677-5c248ba2077f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"766","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"100465546","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"600081","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":18,"user_recomendacion":14,"loans_inicio_pago":"2024-11-05T05:00:00.000Z","created_at":null,"updated_at":null,"deleted_at":null},"detail":{"status":false,"observacion":"N\\/A","fecha_pago":"Tue Oct 29 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":28},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:30:53
11851	9d5ccfa4-d3db-4859-a7dc-ec932037b668	9d5ccfa4-d723-43b5-8dd8-43335ab948d1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":226,"memory":20,"hostname":"EderCortes"}	2024-10-29 11:31:02
7539	9d52df61-57ee-4f74-92fe-8e201d021d77	9d52df61-a4a0-4cea-893e-7cb4af0ee535	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 12:56:45
7540	9d52df61-a2a0-4e47-b7bf-eb46188e9bc7	9d52df61-a4a0-4cea-893e-7cb4af0ee535	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 12:56:45
7541	9d52df61-a379-4e64-8a50-25e704ac2379	9d52df61-a4a0-4cea-893e-7cb4af0ee535	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":405,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:56:45
9568	9d5324d3-410e-4114-910b-fe2a4cd2d331	9d5324d3-6002-4b4c-bb2b-0d5219c49856	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 16:10:56
9569	9d5324d3-5a82-47d3-a687-f7f1b011b4e3	9d5324d3-6002-4b4c-bb2b-0d5219c49856	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 16:10:56
9570	9d5324d3-5ae1-4055-90b1-3d28934793d9	9d5324d3-6002-4b4c-bb2b-0d5219c49856	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 16:10:56
9571	9d5324d3-5ea2-4f20-b253-a407b9128476	9d5324d3-6002-4b4c-bb2b-0d5219c49856	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 16:10:56
35426	9d69c494-c07f-4f51-8391-983fd05b6202	9d69c494-c627-401c-a04c-8c48fe9e1c2d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1606}	2024-11-04 22:05:52
7542	9d52df62-091b-4b83-a5fe-642aade95f0d	9d52df62-2ccc-4cb6-9201-d133b905c93d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 12:56:46
7543	9d52df62-267a-47f0-be46-01bb7efac312	9d52df62-2ccc-4cb6-9201-d133b905c93d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"50.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:56:46
7544	9d52df62-26d1-4f22-bd5d-1a059ca043d2	9d52df62-2ccc-4cb6-9201-d133b905c93d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:56:46
7545	9d52df62-2b38-4cfc-8c1a-c4d5d44f0753	9d52df62-2ccc-4cb6-9201-d133b905c93d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 12:56:46
7546	9d52df62-2b9e-4faf-9d62-d6ac6bb49cc5	9d52df62-2ccc-4cb6-9201-d133b905c93d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":316,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:56:46
9572	9d5324d3-5efc-4ad2-925f-d74aa3750291	9d5324d3-6002-4b4c-bb2b-0d5219c49856	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":343,"memory":22,"hostname":"EderCortes"}	2024-10-24 16:10:56
11852	9d5ccfa5-953f-4d6b-bf53-c775ef799bba	9d5ccfa5-ba6d-45eb-bbe3-e6773df9419f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 11:31:02
11853	9d5ccfa5-ae97-4314-addb-d52d8faec739	9d5ccfa5-ba6d-45eb-bbe3-e6773df9419f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta', 'De las nieve', 'ds', 'CC', '100465546', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '700000', 25, 6, 'M', null, 'Tue Oct 29 2024', 'Pendiente', '312596295', 12, 14, 18, 14, '2024-11-05T05:00:00.000Z', '2024-10-29 11:31:02', '2024-10-29 11:31:02') returning \\"id\\"","time":"4.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":99,"hash":"bfad4cea82a73099ff0b3164dd496ca0","hostname":"EderCortes"}	2024-10-29 11:31:02
11854	9d5ccfa5-aeef-4092-8079-34d938577e72	9d5ccfa5-ba6d-45eb-bbe3-e6773df9419f	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:29","hostname":"EderCortes"}	2024-10-29 11:31:02
11855	9d5ccfa5-b08a-4f36-902e-5be535e209a4	9d5ccfa5-ba6d-45eb-bbe3-e6773df9419f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (29, 1, 116666.66666667, 14583.333333333, 0, 'N\\/A', '29-11-2024', 12, '2024-10-29 11:31:02', '2024-10-29 11:31:02')","time":"2.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":150,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:31:02
11856	9d5ccfa5-b0b2-403a-96e1-b2de63cbc7bd	9d5ccfa5-ba6d-45eb-bbe3-e6773df9419f	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:31:02
11857	9d5ccfa5-b114-4ab6-b38f-cb23b64bb4ae	9d5ccfa5-ba6d-45eb-bbe3-e6773df9419f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (29, 2, 116666.66666667, 14583.333333333, 0, 'N\\/A', '29-12-2024', 12, '2024-10-29 11:31:02', '2024-10-29 11:31:02')","time":"0.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":150,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:31:02
11858	9d5ccfa5-b131-476a-a6c8-a4ff4dc84e91	9d5ccfa5-ba6d-45eb-bbe3-e6773df9419f	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:31:02
11859	9d5ccfa5-b18b-4446-ad22-8e0f445cd779	9d5ccfa5-ba6d-45eb-bbe3-e6773df9419f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (29, 3, 116666.66666667, 14583.333333333, 0, 'N\\/A', '29-01-2025', 12, '2024-10-29 11:31:02', '2024-10-29 11:31:02')","time":"0.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":150,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:31:02
11860	9d5ccfa5-b1a7-4163-be24-2a1db962974a	9d5ccfa5-ba6d-45eb-bbe3-e6773df9419f	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:31:02
7547	9d52df62-b7ea-43c9-9cb6-05e43754bf4a	9d52df63-0234-402f-88da-f0230938d08c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 12:56:46
7548	9d52df62-f89f-4362-b349-5c0b73f549bb	9d52df63-0234-402f-88da-f0230938d08c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"97.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:56:46
7549	9d52df62-f926-4907-91bc-0380a9b7b41d	9d52df63-0234-402f-88da-f0230938d08c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:56:46
7550	9d52df63-0056-41ea-8c8d-1986738637c0	9d52df63-0234-402f-88da-f0230938d08c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 12:56:46
7551	9d52df63-00d1-4b78-8e03-b0efe36e338e	9d52df63-0234-402f-88da-f0230938d08c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":525,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:56:46
9573	9d5324d3-9d69-4ba6-bab7-0af42275babf	9d5324d3-e870-4c20-8b92-b96f1eb384dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 16:10:56
9574	9d5324d3-e3fd-4f08-ae4a-eb4525eabe0c	9d5324d3-e870-4c20-8b92-b96f1eb384dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"155.30","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 16:10:57
9575	9d5324d3-e452-4b31-94f7-2b1ad223f127	9d5324d3-e870-4c20-8b92-b96f1eb384dd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 16:10:57
9576	9d5324d3-e752-4cce-b407-427b7760fc11	9d5324d3-e870-4c20-8b92-b96f1eb384dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 16:10:57
9577	9d5324d3-e7a1-454b-b91a-1ba875c63b11	9d5324d3-e870-4c20-8b92-b96f1eb384dd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-10-24 16:10:57
11861	9d5ccfa5-b206-4bc2-a4a4-1e6b6c33c179	9d5ccfa5-ba6d-45eb-bbe3-e6773df9419f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (29, 4, 116666.66666667, 14583.333333333, 0, 'N\\/A', '01-03-2025', 12, '2024-10-29 11:31:02', '2024-10-29 11:31:02')","time":"0.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":150,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:31:02
11862	9d5ccfa5-b223-4287-b3a9-e11d7773c103	9d5ccfa5-ba6d-45eb-bbe3-e6773df9419f	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:31:02
11863	9d5ccfa5-b290-4706-b51c-5df271a4af15	9d5ccfa5-ba6d-45eb-bbe3-e6773df9419f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (29, 5, 116666.66666667, 14583.333333333, 0, 'N\\/A', '29-03-2025', 12, '2024-10-29 11:31:02', '2024-10-29 11:31:02')","time":"0.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":150,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:31:02
11864	9d5ccfa5-b2b9-42a1-813c-9901d1575ec7	9d5ccfa5-ba6d-45eb-bbe3-e6773df9419f	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:31:02
11865	9d5ccfa5-b33b-439d-99df-5f1a7caf2739	9d5ccfa5-ba6d-45eb-bbe3-e6773df9419f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (29, 6, 116666.66666667, 14583.333333333, 0, 'N\\/A', '29-04-2025', 12, '2024-10-29 11:31:02', '2024-10-29 11:31:02')","time":"0.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":150,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 11:31:02
11866	9d5ccfa5-b360-4bbd-b21c-0a5c1452031a	9d5ccfa5-ba6d-45eb-bbe3-e6773df9419f	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 11:31:02
11867	9d5ccfa5-b92f-4e15-a153-63d63fe64ac2	9d5ccfa5-ba6d-45eb-bbe3-e6773df9419f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 11:31:02
7552	9d52df63-70d0-4980-a45d-a255f5a6951a	9d52df63-bc1a-42bc-b252-04543e9f53b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 12:56:47
7553	9d52df63-b53f-4785-beee-1577bbfe9b04	9d52df63-bc1a-42bc-b252-04543e9f53b6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"151.41","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:56:47
7554	9d52df63-b58e-4708-9490-c6c47671c925	9d52df63-bc1a-42bc-b252-04543e9f53b6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:56:47
7555	9d52df63-b72c-4d27-8c25-2d396a940172	9d52df63-bc1a-42bc-b252-04543e9f53b6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"1.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:56:47
7556	9d52df63-b75c-45af-94e6-313cab648d0f	9d52df63-bc1a-42bc-b252-04543e9f53b6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:56:47
7557	9d52df63-bac8-4cf6-97af-fc64ea3cd997	9d52df63-bc1a-42bc-b252-04543e9f53b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 12:56:47
7558	9d52df63-bb0c-40c1-8016-00a6d0a39ffe	9d52df63-bc1a-42bc-b252-04543e9f53b6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":450,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:56:47
11868	9d5ccfa5-b975-455f-82e7-2f3fb5b6be87	9d5ccfa5-ba6d-45eb-bbe3-e6773df9419f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"766","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"100465546","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"700000","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":18,"user_recomendacion":14,"loans_inicio_pago":"2024-11-05T05:00:00.000Z","created_at":null,"updated_at":null,"deleted_at":null},"detail":{"status":false,"observacion":"N\\/A","fecha_pago":"Tue Oct 29 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":29},"duration":265,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:31:02
7559	9d52df65-4d90-4d1f-9b54-304b9a1c58c8	9d52df65-900a-4491-87db-69f02e3779bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 12:56:48
7560	9d52df65-8609-4574-aecb-b5f62345c10f	9d52df65-900a-4491-87db-69f02e3779bb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"88.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:56:48
7561	9d52df65-8692-403a-8f9e-9702c3456ccc	9d52df65-900a-4491-87db-69f02e3779bb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:56:48
7562	9d52df65-8de2-4012-ac31-7119559965d6	9d52df65-900a-4491-87db-69f02e3779bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 12:56:48
7563	9d52df65-8e79-454d-a6ad-ceb445311816	9d52df65-900a-4491-87db-69f02e3779bb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":664,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:56:48
11869	9d5ccfae-b618-4795-949d-0fe785f9615c	9d5ccfae-fb97-4b08-a7c6-1b578f1a05fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 11:31:08
11870	9d5ccfae-f788-4bb6-8c3a-7aea689fa599	9d5ccfae-fb97-4b08-a7c6-1b578f1a05fe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"154.57","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-29 11:31:09
11871	9d5ccfae-fa5d-4bdc-8227-7edeb32fe8ea	9d5ccfae-fb97-4b08-a7c6-1b578f1a05fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 11:31:09
11872	9d5ccfae-faa8-4ae5-822a-d663504844ab	9d5ccfae-fb97-4b08-a7c6-1b578f1a05fe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":341,"memory":20,"hostname":"EderCortes"}	2024-10-29 11:31:09
11873	9d5ccfbe-81fe-4f1d-b735-86c1ebaa01cd	9d5ccfbe-9f02-43be-9c08-0d33177169ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 11:31:19
7695	9d52e035-819c-47f4-ad42-fdac3b98015f	9d52e035-b0aa-41de-acdf-50c2699e734d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 12:59:04
7696	9d52e035-adca-4601-a60f-82c504fe41a2	9d52e035-b0aa-41de-acdf-50c2699e734d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:59:04
7697	9d52e035-af1f-47f5-8b18-8b59a44d0d48	9d52e035-b0aa-41de-acdf-50c2699e734d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":368,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:59:04
11874	9d5ccfbe-9691-45f6-b870-3b29c5bb8694	9d5ccfbe-9f02-43be-9c08-0d33177169ea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 29\\n                        ","time":"40.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b62fe82803c00a97f9cf15afa22543b1","hostname":"EderCortes"}	2024-10-29 11:31:19
11875	9d5ccfbe-9a1a-44bd-b035-5ad511ff3011	9d5ccfbe-9f02-43be-9c08-0d33177169ea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '29' order by \\"item_loans\\".\\"id\\" asc","time":"2.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 11:31:19
11876	9d5ccfbe-9a4c-4504-9f0e-294d8c1920c1	9d5ccfbe-9f02-43be-9c08-0d33177169ea	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 11:31:19
11877	9d5ccfbe-9dcb-4754-b843-3d2b22b50bc4	9d5ccfbe-9f02-43be-9c08-0d33177169ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 11:31:19
7698	9d52e036-23cb-424a-8089-eeb8630dc46d	9d52e036-486e-4322-8f08-868245dfb18a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:59:05
7699	9d52e036-4130-422a-9ef6-d192c373f3ea	9d52e036-486e-4322-8f08-868245dfb18a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:59:05
7700	9d52e036-41a8-4b9f-b456-384cd0df48ff	9d52e036-486e-4322-8f08-868245dfb18a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:59:05
7701	9d52e036-4711-42ad-9f10-1c4b2c32974d	9d52e036-486e-4322-8f08-868245dfb18a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:59:05
7702	9d52e036-4762-407c-b234-2cfa0304fa94	9d52e036-486e-4322-8f08-868245dfb18a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:59:05
11878	9d5ccfbe-9e0c-4030-bc7e-ebf962bc3b89	9d5ccfbe-9f02-43be-9c08-0d33177169ea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/29","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":29,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":700000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":100,"loans_codigo":29,"itemloans_cuota":"1","itemloans_valor_cuota":"116666.66666667","itemloans_iteres":"14583.333333333","itemloans_status":0,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:31:02.000000Z","updated_at":"2024-10-29T16:31:02.000000Z","deleted_at":null},{"id":101,"loans_codigo":29,"itemloans_cuota":"2","itemloans_valor_cuota":"116666.66666667","itemloans_iteres":"14583.333333333","itemloans_status":0,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:31:02.000000Z","updated_at":"2024-10-29T16:31:02.000000Z","deleted_at":null},{"id":102,"loans_codigo":29,"itemloans_cuota":"3","itemloans_valor_cuota":"116666.66666667","itemloans_iteres":"14583.333333333","itemloans_status":0,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:31:02.000000Z","updated_at":"2024-10-29T16:31:02.000000Z","deleted_at":null},{"id":103,"loans_codigo":29,"itemloans_cuota":"4","itemloans_valor_cuota":"116666.66666667","itemloans_iteres":"14583.333333333","itemloans_status":0,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:31:02.000000Z","updated_at":"2024-10-29T16:31:02.000000Z","deleted_at":null},{"id":104,"loans_codigo":29,"itemloans_cuota":"5","itemloans_valor_cuota":"116666.66666667","itemloans_iteres":"14583.333333333","itemloans_status":0,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:31:02.000000Z","updated_at":"2024-10-29T16:31:02.000000Z","deleted_at":null},{"id":105,"loans_codigo":29,"itemloans_cuota":"6","itemloans_valor_cuota":"116666.66666667","itemloans_iteres":"14583.333333333","itemloans_status":0,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:31:02.000000Z","updated_at":"2024-10-29T16:31:02.000000Z","deleted_at":null}]}},"duration":205,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:31:19
12881	9d5ced80-47f3-4e25-a8ac-6eb763113c8b	9d5ced80-6443-4e83-a96f-04173152b226	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 12:54:31
12882	9d5ced80-62e6-432f-8325-1ca3a5df2798	9d5ced80-6443-4e83-a96f-04173152b226	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 12:54:31
12883	9d5ced80-636d-4721-9b13-58d51206f94b	9d5ced80-6443-4e83-a96f-04173152b226	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:54:31
5284	9d5137c0-103f-49bb-8407-751a569754e0	9d5137c0-33b0-4952-8f0c-8eebaafde2a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 17:12:12
5285	9d5137c0-31af-48c9-8d74-492191df970c	9d5137c0-33b0-4952-8f0c-8eebaafde2a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 17:12:12
5286	9d5137c0-3282-48c7-99cd-2658f5dd1aa1	9d5137c0-33b0-4952-8f0c-8eebaafde2a7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":267,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:12:12
5287	9d5137c0-8a39-4a74-805a-9c59b0ce43cd	9d5137c0-d88b-42af-9485-87f632a1bb59	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-23 17:12:12
5288	9d5137c0-d2c9-42b2-b42c-25e4bc4910de	9d5137c0-d88b-42af-9485-87f632a1bb59	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"159.46","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:12:12
5289	9d5137c0-d31d-4295-bce4-620a295eb98a	9d5137c0-d88b-42af-9485-87f632a1bb59	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:12:12
5290	9d5137c0-d6d3-402a-aa11-8b1b4f7a5861	9d5137c0-d88b-42af-9485-87f632a1bb59	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 17:12:12
5291	9d5137c0-d72d-4260-b223-f16ca72cba22	9d5137c0-d88b-42af-9485-87f632a1bb59	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":393,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:12:12
7703	9d52e036-9d69-4c1c-b684-633403f2cbe6	9d52e036-e5b3-42d9-a5f4-bc6a3de62e49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:59:05
7704	9d52e036-dff4-4376-b6af-daeb08b56383	9d52e036-e5b3-42d9-a5f4-bc6a3de62e49	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"149.02","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:59:05
7705	9d52e036-e05a-471c-9cb9-887b8fb8b576	9d52e036-e5b3-42d9-a5f4-bc6a3de62e49	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:59:05
7706	9d52e036-e441-49fe-9f5c-be85c70252a0	9d52e036-e5b3-42d9-a5f4-bc6a3de62e49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:59:05
7707	9d52e036-e497-4972-9b4d-11accfb4467f	9d52e036-e5b3-42d9-a5f4-bc6a3de62e49	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":386,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:59:05
11879	9d5cd041-da65-47fe-b2e2-a0d5b9262f61	9d5cd042-0027-405c-8631-483ea91204b7	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 11:32:45
9849	9d56ad63-86f8-4aad-ae80-58827439f474	9d56ad63-a743-4635-a1c1-a4ef9418b1ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 10:20:17
9850	9d56ad63-a5a3-4dfa-84f0-a65efb5a20d4	9d56ad63-a743-4635-a1c1-a4ef9418b1ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 10:20:17
9851	9d56ad63-a649-4ec6-8190-b946d7d52678	9d56ad63-a743-4635-a1c1-a4ef9418b1ce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":293,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:20:17
11880	9d5cd041-fa34-4724-8f36-e76575134139	9d5cd042-0027-405c-8631-483ea91204b7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"54.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-29 11:32:45
11881	9d5cd041-fe89-4cbd-9235-da1fc367e91f	9d5cd042-0027-405c-8631-483ea91204b7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 11:32:45
11882	9d5cd041-fee9-4710-8e09-82efe607b3f8	9d5cd042-0027-405c-8631-483ea91204b7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":274,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:32:45
9852	9d56ad63-f3ad-4e4e-9983-14715d306057	9d56ad64-0d80-41e5-bec6-0d0c151ab8fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 10:20:17
9853	9d56ad64-095e-49db-b4dd-25443ea0458c	9d56ad64-0d80-41e5-bec6-0d0c151ab8fa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"42.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-26 10:20:17
9854	9d56ad64-0c1e-4747-beb8-88d874b8d364	9d56ad64-0d80-41e5-bec6-0d0c151ab8fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 10:20:17
3670	9d51092f-8700-4efe-8836-21fe8539a9da	9d51092f-efe9-41be-813f-9188d667f838	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-10-23 15:02:00
3671	9d51092f-ed60-40ac-b49a-aa544000ea26	9d51092f-efe9-41be-813f-9188d667f838	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-10-23 15:02:00
3672	9d51092f-ee66-463c-b1c9-fda2e731281f	9d51092f-efe9-41be-813f-9188d667f838	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1047,"memory":22,"hostname":"EderCortes"}	2024-10-23 15:02:00
9855	9d56ad64-0c6a-4c6b-ac84-2c8d5c957765	9d56ad64-0d80-41e5-bec6-0d0c151ab8fa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:20:17
11883	9d5cd04d-722b-4b0c-b34d-8f4c882767fe	9d5cd04d-8f19-4d7e-8d91-940d4510a35a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 11:32:52
11884	9d5cd04d-866a-43c3-832e-9e167063d517	9d5cd04d-8f19-4d7e-8d91-940d4510a35a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 28\\n                        ","time":"39.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"618a8b500e46ad393f7c65ceec660399","hostname":"EderCortes"}	2024-10-29 11:32:52
7708	9d52e037-4a07-4f77-865f-60fa2ed466fc	9d52e037-68bc-4543-ac0d-1fc874dcac93	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:59:05
11885	9d5cd04d-8a22-4870-b6ff-0d69a7e6110a	9d5cd04d-8f19-4d7e-8d91-940d4510a35a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '28' order by \\"item_loans\\".\\"id\\" asc","time":"1.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 11:32:52
11886	9d5cd04d-8a53-41d8-853a-73fbbc0f47f1	9d5cd04d-8f19-4d7e-8d91-940d4510a35a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 11:32:52
11887	9d5cd04d-8de9-429d-b460-5a57f256b6b4	9d5cd04d-8f19-4d7e-8d91-940d4510a35a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 11:32:52
11888	9d5cd04d-8e30-4b86-8197-68867b6199c5	9d5cd04d-8f19-4d7e-8d91-940d4510a35a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/28","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":28,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":600081,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":94,"loans_codigo":28,"itemloans_cuota":"1","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":0,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":95,"loans_codigo":28,"itemloans_cuota":"2","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":0,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":96,"loans_codigo":28,"itemloans_cuota":"3","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":0,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":97,"loans_codigo":28,"itemloans_cuota":"4","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":0,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":98,"loans_codigo":28,"itemloans_cuota":"5","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":0,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":99,"loans_codigo":28,"itemloans_cuota":"6","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":0,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null}]}},"duration":296,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:32:52
12884	9d5ced80-a9d7-473f-aff2-6abfb36038d5	9d5ced80-f164-4372-a430-8ecef7cfa762	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 12:54:31
7709	9d52e037-61c0-4d71-8bb7-063ff3b85e0c	9d52e037-68bc-4543-ac0d-1fc874dcac93	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"41.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:59:06
7710	9d52e037-621d-443a-980a-cc2bc34e612e	9d52e037-68bc-4543-ac0d-1fc874dcac93	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:59:06
7711	9d52e037-63c4-4be5-9bef-848db30d7cfc	9d52e037-68bc-4543-ac0d-1fc874dcac93	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"1.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:59:06
4990	9d513660-1354-4849-a944-7c6ee4df47e5	9d513660-83e8-4101-b7c1-95401d6517fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":29,"hostname":"EderCortes"}	2024-10-23 17:08:21
4991	9d513660-80e1-4ff5-a479-108bf98ac8d9	9d513660-83e8-4101-b7c1-95401d6517fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":30,"hostname":"EderCortes"}	2024-10-23 17:08:22
4992	9d513660-824f-4ba6-9de9-1d3d3cc668f4	9d513660-83e8-4101-b7c1-95401d6517fe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":643,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:22
7712	9d52e037-63f9-454e-b005-f738ab3fe1cc	9d52e037-68bc-4543-ac0d-1fc874dcac93	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:59:06
7713	9d52e037-677a-4cba-bb12-5a04373c1746	9d52e037-68bc-4543-ac0d-1fc874dcac93	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:59:06
7714	9d52e037-67c1-4007-a82b-3ba95618e42a	9d52e037-68bc-4543-ac0d-1fc874dcac93	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":314,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:59:06
9856	9d56ad65-87b4-4314-ac1d-0705deeed12d	9d56ad65-d184-47e6-9eb3-d807488f986b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 10:20:18
9857	9d56ad65-cc6a-4f7e-a6d3-4e8ea2eed1ac	9d56ad65-d184-47e6-9eb3-d807488f986b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"155.08","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 10:20:18
9724	9d56ac00-4272-4296-803c-9160917810f6	9d56ac00-9088-4cf5-8fdd-afdb4366ed68	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 10:16:24
9725	9d56ac00-8e9b-4906-9dea-7915b1d64e4a	9d56ac00-9088-4cf5-8fdd-afdb4366ed68	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 10:16:24
9726	9d56ac00-8f6a-4924-9488-951dc4314bb9	9d56ac00-9088-4cf5-8fdd-afdb4366ed68	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":365,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:16:24
9858	9d56ad65-ccb3-4825-9fd4-d3a2dabe0b17	9d56ad65-d184-47e6-9eb3-d807488f986b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 10:20:18
9859	9d56ad65-d038-4da2-b199-7305c4aa53ec	9d56ad65-d184-47e6-9eb3-d807488f986b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 10:20:18
9860	9d56ad65-d07c-4b56-8a49-5682174de338	9d56ad65-d184-47e6-9eb3-d807488f986b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":521,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:20:18
545	9d4f2b39-2dcd-45d3-b151-e9c3d762ec29	9d4f2b39-30aa-4165-9ac1-815a165c89ac	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[23502]: Not null violation: 7 ERROR:  el valor nulo en la columna \\u00abuser_last_name_two\\u00bb de la relaci\\u00f3n \\u00abusers\\u00bb viola la restricci\\u00f3n de no nulo\\nDETAIL:  La fila que falla contiene (15, Maria Antonieta, andre@gmail.com, null, $2y$10$8PLpCn1mpoPC1fyXcKOn0eVFrfg3hmBGg9.Z6BcTxCkp07xT6TLWG, De las nieve, null, CC, 100465545, 1992-11-12T04:00:00.000Z, Cali, Bonilla aragon, Calle 750, 312596295, 31, 4, null, 0, MQnxyy2e8hVMX82fMH8L5lw91COfcXE7n0nJL42hcV9jRUb18dHWaA5egH84, 2024-10-22 16:45:31, 2024-10-22 16:45:31, null). (Connection: pgsql, SQL: insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"verification_token\\", \\"updated_at\\", \\"created_at\\") values (Maria Antonieta, andre@gmail.com, De las nieve, ?, CC, 100465545, 1992-11-12T04:00:00.000Z, Cali, Bonilla aragon, Calle 750, 312596295, 4, 31, $2y$10$8PLpCn1mpoPC1fyXcKOn0eVFrfg3hmBGg9.Z6BcTxCkp07xT6TLWG, MQnxyy2e8hVMX82fMH8L5lw91COfcXE7n0nJL42hcV9jRUb18dHWaA5egH84, 2024-10-22 16:45:31, 2024-10-22 16:45:31) returning \\"id\\")","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":401},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor.php","line":24},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3549},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":1982},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1334},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1299},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1138},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":39}	2024-10-22 16:45:31
12885	9d5ced80-eca3-42e8-9444-7d1d37b2c628	9d5ced80-f164-4372-a430-8ecef7cfa762	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"158.22","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-29 12:54:32
12886	9d5ced80-f04a-4a97-be06-f4bbc4891bb0	9d5ced80-f164-4372-a430-8ecef7cfa762	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 12:54:32
5292	9d5137c1-242f-4c1b-a3b2-074b6be5899e	9d5137c1-713b-4cf6-b1a5-59893f9aab3c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-23 17:12:13
5293	9d5137c1-6c10-4b9a-b484-bb029754c6ba	9d5137c1-713b-4cf6-b1a5-59893f9aab3c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"159.32","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:12:13
5294	9d5137c1-6c62-4cc2-9697-5a0ab97077d8	9d5137c1-713b-4cf6-b1a5-59893f9aab3c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:12:13
5295	9d5137c1-6ff7-42a3-a588-278c128f2764	9d5137c1-713b-4cf6-b1a5-59893f9aab3c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 17:12:13
5296	9d5137c1-703f-4e6c-a57f-d94d14c60d73	9d5137c1-713b-4cf6-b1a5-59893f9aab3c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:12:13
7715	9d52e039-319f-4e0f-a4bf-a9bb137fdfd6	9d52e039-600a-4500-b4de-c7fa7aad3e9a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:59:07
7716	9d52e039-57b5-4c35-a914-621bd28b5488	9d52e039-600a-4500-b4de-c7fa7aad3e9a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"62.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:59:07
7717	9d52e039-5829-447b-b6f7-8c4cb705b019	9d52e039-600a-4500-b4de-c7fa7aad3e9a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:59:07
7718	9d52e039-5e1a-4796-aaa7-6d1315d7a255	9d52e039-600a-4500-b4de-c7fa7aad3e9a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:59:07
7719	9d52e039-5e90-4c2e-99e2-187f97f2e2d2	9d52e039-600a-4500-b4de-c7fa7aad3e9a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":415,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:59:07
9727	9d56ac00-e7c1-49d7-9ff5-219472c5486c	9d56ac01-2962-4cab-bffc-e7ac77b654ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 10:16:24
9728	9d56ac01-2512-4abc-8d37-2e985d14d105	9d56ac01-2962-4cab-bffc-e7ac77b654ff	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"145.23","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-26 10:16:25
9729	9d56ac01-2845-4f66-9ca0-1d2148b4bd7b	9d56ac01-2962-4cab-bffc-e7ac77b654ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 10:16:25
9730	9d56ac01-288c-4176-83a5-82e0f6e15f9e	9d56ac01-2962-4cab-bffc-e7ac77b654ff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:16:25
9731	9d56ac02-ff19-49de-90f3-f3c14af612ee	9d56ac03-42ca-4bcd-9e58-0df177c95726	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 10:16:26
9732	9d56ac03-3dfb-4c7c-a5e8-2cd3453f3bff	9d56ac03-42ca-4bcd-9e58-0df177c95726	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"141.89","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 10:16:26
9733	9d56ac03-3e4f-4232-83db-1966cad369ba	9d56ac03-42ca-4bcd-9e58-0df177c95726	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 10:16:26
9734	9d56ac03-4185-45b6-b67e-6b92e5109b6d	9d56ac03-42ca-4bcd-9e58-0df177c95726	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 10:16:26
9735	9d56ac03-41c5-4ede-9faf-9febd050b83d	9d56ac03-42ca-4bcd-9e58-0df177c95726	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":320,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:16:26
12887	9d5ced80-f097-4d27-af61-2cfb4831d2a5	9d5ced80-f164-4372-a430-8ecef7cfa762	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:54:32
14049	9d5d153c-9bc4-40c0-990e-a61ac6646e3b	9d5d153c-c86b-440c-9aa6-e7d75e438df6	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 14:45:38
14050	9d5d153c-c589-47b2-9707-344ce29e0792	9d5d153c-c86b-440c-9aa6-e7d75e438df6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 14:45:38
14051	9d5d153c-c6c4-4fbd-bcb6-9818514e3e12	9d5d153c-c86b-440c-9aa6-e7d75e438df6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:45:38
14052	9d5d153d-4171-4562-9323-68c7e025aaad	9d5d153d-944a-4679-968c-2dac95697e9f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 14:45:38
14053	9d5d153d-8dcd-46bd-9424-8cfeb9b61d05	9d5d153d-944a-4679-968c-2dac95697e9f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"167.84","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":190,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 14:45:38
12888	9d5ced82-88a3-4754-a2a8-b76767a60788	9d5ced82-cd60-43ee-9188-7d0a34944c9b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 12:54:33
9931	9d56bffc-7fa5-4445-94a6-10a1ab9f4083	9d56bffc-a55c-43fe-8f60-4aa4db274054	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 11:12:17
9932	9d56bffc-a352-4076-a793-4d886053b84a	9d56bffc-a55c-43fe-8f60-4aa4db274054	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:12:17
9933	9d56bffc-a441-49c9-890d-ffd71d5f732c	9d56bffc-a55c-43fe-8f60-4aa4db274054	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":299,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:12:17
12889	9d5ced82-c681-4ccb-93bf-736383aab757	9d5ced82-cd60-43ee-9188-7d0a34944c9b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"128.92","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 12:54:33
12890	9d5ced82-c6f6-416b-b1b7-33903a3c0a54	9d5ced82-cd60-43ee-9188-7d0a34944c9b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 12:54:33
14054	9d5d153d-8e32-4168-b022-e48664f5f6c7	9d5d153d-944a-4679-968c-2dac95697e9f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 14:45:38
12891	9d5ced82-cbe9-4dfe-a3b6-8dc7030048e6	9d5ced82-cd60-43ee-9188-7d0a34944c9b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 12:54:33
12892	9d5ced82-cc51-4956-b858-4811680dd920	9d5ced82-cd60-43ee-9188-7d0a34944c9b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":514,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:54:33
14055	9d5d153d-9320-4591-938b-13ba47d60967	9d5d153d-944a-4679-968c-2dac95697e9f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 14:45:38
14056	9d5d153d-936b-42ff-a257-388cc6c1c3d4	9d5d153d-944a-4679-968c-2dac95697e9f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":463,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:45:38
14057	9d5d153d-e891-447a-9bfb-ef040dfcaa30	9d5d153e-0cba-40c4-9bdc-a6eddcb4a7b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 14:45:38
14058	9d5d153e-054c-4a82-800e-eaac5dc3eba0	9d5d153e-0cba-40c4-9bdc-a6eddcb4a7b9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":190,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 14:45:39
6493	9d52d22b-ed84-4e3e-bec8-f620781581bb	9d52d22c-3988-46dc-bf66-e1a8db22c1ab	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 12:19:49
6494	9d52d22c-3775-46e0-b2bb-b84a66e5d3d7	9d52d22c-3988-46dc-bf66-e1a8db22c1ab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:19:49
6495	9d52d22c-383d-4edf-9c9f-003151ea01f2	9d52d22c-3988-46dc-bf66-e1a8db22c1ab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":404,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:19:49
14059	9d5d153e-05ca-4a3a-b411-1a7d3b181cb0	9d5d153e-0cba-40c4-9bdc-a6eddcb4a7b9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 14:45:39
9934	9d56bffe-1427-4e1f-8e34-facacecf8976	9d56bffe-31d4-4eff-92f1-25e9a22610f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:12:18
9935	9d56bffe-2be2-45fa-a04a-33207a546ed9	9d56bffe-31d4-4eff-92f1-25e9a22610f4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:12:18
9936	9d56bffe-2c46-4c0d-bf64-968d604a7334	9d56bffe-31d4-4eff-92f1-25e9a22610f4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:12:18
9937	9d56bffe-304c-492d-b9c4-2733fff282bd	9d56bffe-31d4-4eff-92f1-25e9a22610f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:12:18
13848	9d5d12bb-88a0-4b06-ac59-60afaab1a105	9d5d12bb-adbf-4474-935b-ba2a65239d2d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 14:38:37
13849	9d5d12bb-abdf-4160-a7a8-423ca8682e5a	9d5d12bb-adbf-4474-935b-ba2a65239d2d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 14:38:38
13850	9d5d12bb-ac9e-4ab4-9986-bc4c7fc768a5	9d5d12bb-adbf-4474-935b-ba2a65239d2d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":325,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:38:38
14060	9d5d153e-0b4b-419f-bcbf-753979af3e82	9d5d153e-0cba-40c4-9bdc-a6eddcb4a7b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 14:45:39
14061	9d5d153e-0ba4-4475-b612-5a2a7c16248c	9d5d153e-0cba-40c4-9bdc-a6eddcb4a7b9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":288,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:45:39
6496	9d52d22c-8fd7-41ab-968d-9a988da95d96	9d52d22c-ae73-400d-bfa5-5dc2ff2330fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:19:50
6497	9d52d22c-a87c-45cd-9742-bef55f082979	9d52d22c-ae73-400d-bfa5-5dc2ff2330fe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:19:50
6498	9d52d22c-a8e6-419c-a6dd-af74dd6f5059	9d52d22c-ae73-400d-bfa5-5dc2ff2330fe	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:19:50
6499	9d52d22c-ad59-4f8d-89c1-f194e1c5a21b	9d52d22c-ae73-400d-bfa5-5dc2ff2330fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:19:50
6500	9d52d22c-ada0-444b-838c-dfff01025bd7	9d52d22c-ae73-400d-bfa5-5dc2ff2330fe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:19:50
9938	9d56bffe-30a7-471c-9aed-1d09e2c99cb7	9d56bffe-31d4-4eff-92f1-25e9a22610f4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":308,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:12:18
13851	9d5d12bc-0a59-4ec6-b164-9ae875f2c34e	9d5d12bc-52df-4622-a2c6-f9c2311ea941	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 14:38:38
13852	9d5d12bc-47e8-40d7-b75c-70fbeb2abd97	9d5d12bc-52df-4622-a2c6-f9c2311ea941	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 52\\n                        ","time":"144.24","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"b818d1825eff359c94d73944c3be2955","hostname":"EderCortes"}	2024-10-29 14:38:38
13853	9d5d12bc-4bf7-49b8-a62a-703df999f74e	9d5d12bc-52df-4622-a2c6-f9c2311ea941	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '52' order by \\"item_loans\\".\\"id\\" asc","time":"1.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 14:38:38
13854	9d5d12bc-4c29-4bb4-9687-94a201a00295	9d5d12bc-52df-4622-a2c6-f9c2311ea941	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":7,"hostname":"EderCortes"}	2024-10-29 14:38:38
13855	9d5d12bc-51a4-4c72-92b1-6592cebbdaed	9d5d12bc-52df-4622-a2c6-f9c2311ea941	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 14:38:38
13856	9d5d12bc-51fb-43a0-a427-43c37c8615f5	9d5d12bc-52df-4622-a2c6-f9c2311ea941	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/52","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":52,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":7,"loans_valor_prestado":500000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"12-11-24","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":136,"loans_codigo":52,"itemloans_cuota":"1","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":137,"loans_codigo":52,"itemloans_cuota":"2","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0024-12-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":138,"loans_codigo":52,"itemloans_cuota":"3","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0024-12-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":139,"loans_codigo":52,"itemloans_cuota":"4","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0025-01-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":140,"loans_codigo":52,"itemloans_cuota":"5","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0025-01-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":141,"loans_codigo":52,"itemloans_cuota":"6","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0025-02-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":142,"loans_codigo":52,"itemloans_cuota":"7","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0025-02-25 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":379,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:38:38
6501	9d52d22c-eafa-4d23-aa38-81c244072958	9d52d22d-3058-43a0-ae58-b26632f28b51	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:19:50
6502	9d52d22d-2b80-4ec6-81a7-8ce2a4ed3248	9d52d22d-3058-43a0-ae58-b26632f28b51	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"143.16","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:19:50
6503	9d52d22d-2bce-4d6e-98f8-865013a4f394	9d52d22d-3058-43a0-ae58-b26632f28b51	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:19:50
6504	9d52d22d-2f42-4892-a565-090b6feb4cfe	9d52d22d-3058-43a0-ae58-b26632f28b51	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:19:50
6505	9d52d22d-2f88-41bb-94fa-7d3bff4c4e83	9d52d22d-3058-43a0-ae58-b26632f28b51	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":320,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:19:50
12990	9d5cf2da-9f35-4778-978e-1d8881a4ebbb	9d5cf2da-dd58-444b-9eb2-46629a7703a7	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 13:09:29
12991	9d5cf2da-da23-437a-8088-cda1b716bc70	9d5cf2da-dd58-444b-9eb2-46629a7703a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 13:09:29
12992	9d5cf2da-db90-4d57-a64f-45cd5c9a9ad6	9d5cf2da-dd58-444b-9eb2-46629a7703a7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":606,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:09:29
6506	9d52d22d-76b6-4461-b38b-da2e018ecdcc	9d52d22d-93d4-48e7-9f35-6986b7def446	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:19:50
6507	9d52d22d-8da4-4dd7-b797-14918cd7bb0e	9d52d22d-93d4-48e7-9f35-6986b7def446	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '1' order by \\"id\\" asc","time":"40.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:19:50
6508	9d52d22d-8dec-40f6-a6ac-6bc67c59852f	9d52d22d-93d4-48e7-9f35-6986b7def446	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:19:50
6509	9d52d22d-8f56-46aa-a699-f99ce21b3444	9d52d22d-93d4-48e7-9f35-6986b7def446	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1'","time":"1.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:19:50
6510	9d52d22d-8f84-49f9-bc5f-921d61f6a040	9d52d22d-93d4-48e7-9f35-6986b7def446	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 12:19:50
6511	9d52d22d-92c9-4fef-86c5-b5f2f8018b0a	9d52d22d-93d4-48e7-9f35-6986b7def446	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:19:50
6512	9d52d22d-9310-43b4-a001-4640c2fbe1b3	9d52d22d-93d4-48e7-9f35-6986b7def446	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}],"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:19:50
12993	9d5cf2db-3bb8-42a1-9965-a04cf0ccdbe9	9d5cf2db-84b6-4c8f-9401-530e36cc4abf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 13:09:30
12994	9d5cf2db-7d74-46e0-84cb-f830f89e586f	9d5cf2db-84b6-4c8f-9401-530e36cc4abf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"155.11","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-29 13:09:30
12995	9d5cf2db-8361-49d8-ae40-226781f67bb6	9d5cf2db-84b6-4c8f-9401-530e36cc4abf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 13:09:30
12996	9d5cf2db-83b9-4d9d-a96e-dbb6cb4a235b	9d5cf2db-84b6-4c8f-9401-530e36cc4abf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:09:30
13145	9d5cf9cf-617c-4ed5-98c3-adb8cc5873c5	9d5cf9cf-8c20-4ea6-9268-34310c1b5f1a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 13:28:56
13146	9d5cf9cf-89ce-4224-b4c5-a372f39e14ff	9d5cf9cf-8c20-4ea6-9268-34310c1b5f1a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 13:28:56
13147	9d5cf9cf-8ad0-4f88-9b25-ba8508e614a6	9d5cf9cf-8c20-4ea6-9268-34310c1b5f1a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":417,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:28:56
14307	9d5d1de2-cd86-4ac0-8275-7cb8ab7c7c1a	9d5d1de3-562b-4c12-9da3-9ec1a3e468d3	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 15:09:49
14308	9d5d1de3-36f2-4daa-b0c6-9db3fcb26be3	9d5d1de3-562b-4c12-9da3-9ec1a3e468d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 15:09:49
6513	9d52d22f-5678-49e0-a1c3-89c174f23241	9d52d22f-76b7-4ec2-ab9d-43848ca0e4c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:19:51
6514	9d52d22f-7194-4a88-b9e4-79f8b69fb36e	9d52d22f-76b7-4ec2-ab9d-43848ca0e4c9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"46.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:19:52
6515	9d52d22f-71f2-4c2b-8e22-230962ad9535	9d52d22f-76b7-4ec2-ab9d-43848ca0e4c9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:19:52
6516	9d52d22f-7574-40e9-9a95-05568b33012a	9d52d22f-76b7-4ec2-ab9d-43848ca0e4c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:19:52
6517	9d52d22f-75bb-4882-b3a6-a183b169e2fc	9d52d22f-76b7-4ec2-ab9d-43848ca0e4c9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":248,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:19:52
13148	9d5cf9cf-f2fd-41be-a8a2-ebfc162cda54	9d5cf9d0-40e5-42a6-8397-52e71fbdef80	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 13:28:57
13149	9d5cf9d0-35b0-4bbb-a4b4-259bee81a149	9d5cf9d0-40e5-42a6-8397-52e71fbdef80	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 30\\n                        ","time":"152.58","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"b9ae622c33dd7e7f0bc512338acf8ed0","hostname":"EderCortes"}	2024-10-29 13:28:57
13150	9d5cf9d0-3a03-445c-a1fe-d95e727c6304	9d5cf9d0-40e5-42a6-8397-52e71fbdef80	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '30' order by \\"item_loans\\".\\"id\\" asc","time":"2.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 13:28:57
13151	9d5cf9d0-3a42-4cc1-b033-bebf303e9421	9d5cf9d0-40e5-42a6-8397-52e71fbdef80	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-10-29 13:28:57
13152	9d5cf9d0-3f35-40d1-a2aa-364b26164937	9d5cf9d0-40e5-42a6-8397-52e71fbdef80	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 13:28:57
13153	9d5cf9d0-3fac-4faf-9a25-c262f9bd30fe	9d5cf9d0-40e5-42a6-8397-52e71fbdef80	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/30","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":30,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":1000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":106,"loans_codigo":30,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":107,"loans_codigo":30,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":108,"loans_codigo":30,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":109,"loans_codigo":30,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":110,"loans_codigo":30,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":111,"loans_codigo":30,"itemloans_cuota":"6","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":112,"loans_codigo":30,"itemloans_cuota":"7","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":113,"loans_codigo":30,"itemloans_cuota":"8","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":114,"loans_codigo":30,"itemloans_cuota":"9","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":115,"loans_codigo":30,"itemloans_cuota":"10","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":421,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:28:57
14309	9d5d1de3-538e-4aeb-a1d7-c2ce4407b31c	9d5d1de3-562b-4c12-9da3-9ec1a3e468d3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":860,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:09:49
13337	9d5cfcfb-ce40-4682-85a7-4c620f762b04	9d5cfcfb-f220-44c4-9b67-4aecf55dc95c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 13:37:49
13338	9d5cfcfb-f025-4247-8b57-ee61a4ee40df	9d5cfcfb-f220-44c4-9b67-4aecf55dc95c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 13:37:49
13339	9d5cfcfb-f0ef-4f6b-aa4e-f0db30629e34	9d5cfcfb-f220-44c4-9b67-4aecf55dc95c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":302,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:37:49
14310	9d5d1de3-f666-40dd-8a36-994088694541	9d5d1de4-46a9-4064-9bed-a02f626a9443	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 15:09:49
14311	9d5d1de4-3de4-452a-a27f-796e84245be2	9d5d1de4-46a9-4064-9bed-a02f626a9443	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"149.01","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":179,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 15:09:50
14312	9d5d1de4-3e3f-4a20-b0ee-950540856504	9d5d1de4-46a9-4064-9bed-a02f626a9443	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 15:09:50
14313	9d5d1de4-456d-42cd-98f7-ed12d80d3d74	9d5d1de4-46a9-4064-9bed-a02f626a9443	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 15:09:50
14314	9d5d1de4-45ba-40c6-bee1-f7c92d4276ac	9d5d1de4-46a9-4064-9bed-a02f626a9443	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":512,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:09:50
14315	9d5d1de4-990e-4c79-9ac2-e0261840f332	9d5d1de4-be42-4d44-bead-7193f9c95664	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 15:09:50
14316	9d5d1de4-b615-48cc-8493-9060e2bad723	9d5d1de4-be42-4d44-bead-7193f9c95664	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":179,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 15:09:50
13340	9d5cfcfc-4961-40b8-9070-6ba4a14c8d97	9d5cfcfc-8b13-4dc8-8981-1c7ee44f8870	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 13:37:49
7893	9d52e299-0c21-4ab8-8241-97d61769477c	9d52e299-30a2-440f-8364-b0ca74b28427	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 13:05:45
7894	9d52e299-2eb7-45cc-98af-5012a2449617	9d52e299-30a2-440f-8364-b0ca74b28427	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:05:45
7895	9d52e299-2f84-467e-acaa-b4b76fd0a3ea	9d52e299-30a2-440f-8364-b0ca74b28427	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":261,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:05:45
13341	9d5cfcfc-8682-4b59-8a9d-b74198ed83a5	9d5cfcfc-8b13-4dc8-8981-1c7ee44f8870	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"145.29","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-29 13:37:49
13342	9d5cfcfc-89ed-4648-a180-87e643a4e033	9d5cfcfc-8b13-4dc8-8981-1c7ee44f8870	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 13:37:49
13343	9d5cfcfc-8a39-4efc-97fa-6276cbe8c460	9d5cfcfc-8b13-4dc8-8981-1c7ee44f8870	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:37:49
14317	9d5d1de4-b65f-4fde-9615-88961b9ba396	9d5d1de4-be42-4d44-bead-7193f9c95664	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 15:09:50
14318	9d5d1de4-bca3-4ee8-8929-d91e151a0ec1	9d5d1de4-be42-4d44-bead-7193f9c95664	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 15:09:50
14319	9d5d1de4-bd24-4eea-833e-21c86ecc3a0b	9d5d1de4-be42-4d44-bead-7193f9c95664	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":285,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:09:50
7896	9d52e299-8a35-474c-8677-aa26f2f53bbc	9d52e299-a97b-4222-94dd-97ec7c065241	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:05:45
7897	9d52e299-a45f-4f71-b6c0-6c39ce4ddad5	9d52e299-a97b-4222-94dd-97ec7c065241	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:05:45
7898	9d52e299-a4b1-4a10-8406-77912c0d5b79	9d52e299-a97b-4222-94dd-97ec7c065241	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:05:45
7899	9d52e299-a845-47b5-b065-732cd9208e2c	9d52e299-a97b-4222-94dd-97ec7c065241	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:05:46
7900	9d52e299-a885-457d-a1b0-bca701dca789	9d52e299-a97b-4222-94dd-97ec7c065241	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":279,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:05:46
7901	9d52e299-eed8-4886-b885-e9d2236c9749	9d52e29a-0b7f-4d2a-a931-53c688c316b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:05:46
7902	9d52e29a-06a5-4a94-9eaa-3103bca70522	9d52e29a-0b7f-4d2a-a931-53c688c316b9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:05:46
7903	9d52e29a-06f1-43e9-a7b3-3ca7ce9471d8	9d52e29a-0b7f-4d2a-a931-53c688c316b9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:05:46
7904	9d52e29a-0a48-4faa-a613-d66e69ff5e48	9d52e29a-0b7f-4d2a-a931-53c688c316b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:05:46
7905	9d52e29a-0a8b-42ab-b4f0-58bca6610208	9d52e29a-0b7f-4d2a-a931-53c688c316b9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:05:46
7906	9d52e29a-4b3d-4390-b70a-d656e2fc3e3b	9d52e29a-9465-4559-b9d5-02dd71e9f898	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:05:46
6826	9d52d5a5-407b-40a6-8c4a-f21e68594399	9d52d5a5-9c1b-4901-9b60-fdebdad5bc31	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 12:29:32
6827	9d52d5a5-9989-45b8-85f9-52a52679e44e	9d52d5a5-9c1b-4901-9b60-fdebdad5bc31	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:29:32
6828	9d52d5a5-9ac0-4f27-aa40-7f21566b7040	9d52d5a5-9c1b-4901-9b60-fdebdad5bc31	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":444,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:29:32
6670	9d52d3d0-071e-4196-95bc-0b0c001e6ac0	9d52d3d0-4aa5-46c9-9db7-10a42174a390	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 12:24:25
6671	9d52d3d0-494b-4271-962a-9d0c7396e3ee	9d52d3d0-4aa5-46c9-9db7-10a42174a390	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 12:24:25
6672	9d52d3d0-49d7-45c0-acde-1847d366274d	9d52d3d0-4aa5-46c9-9db7-10a42174a390	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":363,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:24:25
7907	9d52e29a-8c56-4acd-833a-c8cf6414cb31	9d52e29a-9465-4559-b9d5-02dd71e9f898	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc","time":"147.31","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 13:05:46
7908	9d52e29a-8ca1-428e-a26d-e701bba3b5ad	9d52e29a-9465-4559-b9d5-02dd71e9f898	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:05:46
7909	9d52e29a-8e4a-4e7d-9e5b-dd0ed4a3410a	9d52e29a-9465-4559-b9d5-02dd71e9f898	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6'","time":"1.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 13:05:46
7910	9d52e29a-8e85-423e-a32c-8740dad04e9b	9d52e29a-9465-4559-b9d5-02dd71e9f898	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:05:46
7911	9d52e29a-92c6-4694-a372-3484c8027815	9d52e29a-9465-4559-b9d5-02dd71e9f898	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:05:46
7912	9d52e29a-9325-4adf-9ebe-84050ccb9870	9d52e29a-9465-4559-b9d5-02dd71e9f898	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:05:46
6673	9d52d3d0-921d-45af-9f9c-7984e147576e	9d52d3d0-b00d-4ae6-b5c8-18d6a710ff19	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 12:24:25
6674	9d52d3d0-ab4a-46b7-bc90-3e0595bec938	9d52d3d0-b00d-4ae6-b5c8-18d6a710ff19	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:24:25
6675	9d52d3d0-ab99-40b5-8c1a-a82c37aa52f3	9d52d3d0-b00d-4ae6-b5c8-18d6a710ff19	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:24:25
6676	9d52d3d0-aee2-4985-9497-315c6e7dab5e	9d52d3d0-b00d-4ae6-b5c8-18d6a710ff19	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 12:24:25
6677	9d52d3d0-af34-4102-908b-67c27ea7ffcd	9d52d3d0-b00d-4ae6-b5c8-18d6a710ff19	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:24:25
6829	9d52d5a6-204b-4b21-a75a-861af10eae70	9d52d5a6-6662-40cd-95ee-86798954c3ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:29:33
6830	9d52d5a6-5a0f-41b3-9232-225f89d187b8	9d52d5a6-6662-40cd-95ee-86798954c3ac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"118.46","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:29:33
6831	9d52d5a6-5a79-4e3e-ae13-3cbe58779c5e	9d52d5a6-6662-40cd-95ee-86798954c3ac	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:29:33
6832	9d52d5a6-6441-43ff-aed2-1e827566a70a	9d52d5a6-6662-40cd-95ee-86798954c3ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:29:33
6833	9d52d5a6-64d5-4b5c-9ab9-eed1ab9a95f6	9d52d5a6-6662-40cd-95ee-86798954c3ac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":465,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:29:33
7913	9d52e29c-4294-4281-9e00-f968eabce68a	9d52e29c-67ef-4b64-ae45-e75e7885bfb6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:05:47
7914	9d52e29c-6223-490f-aaa8-7924ae30d90e	9d52e29c-67ef-4b64-ae45-e75e7885bfb6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:05:47
7915	9d52e29c-62a7-465c-bcfd-2c7928bce253	9d52e29c-67ef-4b64-ae45-e75e7885bfb6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:05:47
7916	9d52e29c-66a8-4aa0-8943-6cf3f65f45a9	9d52e29c-67ef-4b64-ae45-e75e7885bfb6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:05:47
7917	9d52e29c-66f1-4339-ac1f-df15a3a6d146	9d52e29c-67ef-4b64-ae45-e75e7885bfb6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":596,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:05:47
6678	9d52d3d0-ee6f-4ba0-8650-55627611dd15	9d52d3d1-35a1-4d12-8421-4f2c2c6c395f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 12:24:25
6679	9d52d3d1-30d4-446b-976c-b76a46c0ab47	9d52d3d1-35a1-4d12-8421-4f2c2c6c395f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"149.67","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:24:25
6680	9d52d3d1-311c-4c02-a1ff-9063d3259037	9d52d3d1-35a1-4d12-8421-4f2c2c6c395f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:24:25
6681	9d52d3d1-349c-4988-85c1-9d689ccdd5a1	9d52d3d1-35a1-4d12-8421-4f2c2c6c395f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 12:24:25
6682	9d52d3d1-34da-4d0d-895f-420411b98ca4	9d52d3d1-35a1-4d12-8421-4f2c2c6c395f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":323,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:24:25
6834	9d52d5a7-37d8-4323-8706-8f74d2abf781	9d52d5a7-54b5-4b9f-85db-7fd10339a027	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:29:33
6835	9d52d5a7-4f1f-4484-b1b2-a79235545013	9d52d5a7-54b5-4b9f-85db-7fd10339a027	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:29:33
6836	9d52d5a7-4f71-4740-be7a-f13e1cb44d6c	9d52d5a7-54b5-4b9f-85db-7fd10339a027	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:29:33
6837	9d52d5a7-5362-4751-abb6-073806511e72	9d52d5a7-54b5-4b9f-85db-7fd10339a027	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:29:33
6838	9d52d5a7-53bb-428b-b68a-f5f9a6753bb2	9d52d5a7-54b5-4b9f-85db-7fd10339a027	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":588,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:29:33
6683	9d52d3d1-74f5-4af0-a600-d756d4988e40	9d52d3d1-91c7-43da-ae45-721a47e1ad1c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 12:24:25
6684	9d52d3d1-8ba1-48d2-9d78-1fdd4b471c34	9d52d3d1-91c7-43da-ae45-721a47e1ad1c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"39.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:24:26
6685	9d52d3d1-8c05-4927-8250-a6df9777a8fe	9d52d3d1-91c7-43da-ae45-721a47e1ad1c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:24:26
6686	9d52d3d1-8d50-4d07-9dde-efdda68bb4f8	9d52d3d1-91c7-43da-ae45-721a47e1ad1c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"1.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:24:26
6687	9d52d3d1-8d80-4e1e-8cbc-5cc4030968dd	9d52d3d1-91c7-43da-ae45-721a47e1ad1c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:24:26
6688	9d52d3d1-90b5-45f9-8a3c-cecfcfb47275	9d52d3d1-91c7-43da-ae45-721a47e1ad1c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 12:24:26
6689	9d52d3d1-90f7-426a-a6b1-cd1958372d5c	9d52d3d1-91c7-43da-ae45-721a47e1ad1c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}],"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]},"duration":223,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:24:26
6839	9d52d5a7-dabf-4c5b-b60a-7abcca08182c	9d52d5a8-1f76-4f6c-8981-6746c2bb9fd3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:29:34
6840	9d52d5a8-13c8-4edb-a94d-7c0c796f61d0	9d52d5a8-1f76-4f6c-8981-6746c2bb9fd3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"111.38","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:29:34
6841	9d52d5a8-1468-4519-b0cc-f0d28e5e8c41	9d52d5a8-1f76-4f6c-8981-6746c2bb9fd3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:29:34
6842	9d52d5a8-1720-4eb3-b80f-7a49b6d41ab4	9d52d5a8-1f76-4f6c-8981-6746c2bb9fd3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"3.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:29:34
6843	9d52d5a8-1775-4fd0-a177-30b487c454d5	9d52d5a8-1f76-4f6c-8981-6746c2bb9fd3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:29:34
6844	9d52d5a8-1db1-49ab-89ca-a12bc989c275	9d52d5a8-1f76-4f6c-8981-6746c2bb9fd3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:29:34
6845	9d52d5a8-1e2b-4a11-8d3f-09fdf311be27	9d52d5a8-1f76-4f6c-8981-6746c2bb9fd3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":506,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:29:34
6690	9d52d3d2-f5da-4f08-8ba5-b4ad47ae9ba0	9d52d3d3-401b-4724-a990-82166d2db79f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 12:24:26
6691	9d52d3d3-3b71-4555-9cc5-74894136bc88	9d52d3d3-401b-4724-a990-82166d2db79f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"153.22","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:24:27
6692	9d52d3d3-3bbf-4694-9612-3d004aa7306d	9d52d3d3-401b-4724-a990-82166d2db79f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:24:27
6693	9d52d3d3-3ed9-421c-985f-d431d220c8a2	9d52d3d3-401b-4724-a990-82166d2db79f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 12:24:27
6694	9d52d3d3-3f1a-4c32-8d8c-1a988e072778	9d52d3d3-401b-4724-a990-82166d2db79f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":554,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:24:27
6846	9d52d5a9-f174-4f5c-a6ce-2066043ce2aa	9d52d5aa-1b97-414a-990f-b2c56e290484	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:29:35
6847	9d52d5aa-130f-48c3-9096-96b43d1fefee	9d52d5aa-1b97-414a-990f-b2c56e290484	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"56.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:29:35
6848	9d52d5aa-138c-413b-b0ea-1aae90619405	9d52d5aa-1b97-414a-990f-b2c56e290484	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:29:35
6849	9d52d5aa-19e9-40a0-93e8-87dd99ccbd3a	9d52d5aa-1b97-414a-990f-b2c56e290484	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:29:35
6850	9d52d5aa-1a63-4494-8a5c-d66f4491b452	9d52d5aa-1b97-414a-990f-b2c56e290484	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":591,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:29:35
10006	9d56c6b2-ed04-486c-82a0-bca7b4967e14	9d56c6b3-39df-4931-b912-9ed0f4a56ca3	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 11:31:03
10007	9d56c6b3-37d9-475c-b99a-201d532642b9	9d56c6b3-39df-4931-b912-9ed0f4a56ca3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:31:03
10008	9d56c6b3-38de-4b9e-85af-f00aff202c54	9d56c6b3-39df-4931-b912-9ed0f4a56ca3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":365,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:31:03
14506	9d5eb96c-3e74-4260-bb90-a7fe2746d7c7	9d5eb96d-55b9-4783-a9ac-1ec0fe63176c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 10:20:33
14507	9d5eb96d-53ea-4002-9211-e03addfce7ec	9d5eb96d-55b9-4783-a9ac-1ec0fe63176c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-30 10:20:34
14508	9d5eb96d-548c-41b0-be10-4ba610b66df1	9d5eb96d-55b9-4783-a9ac-1ec0fe63176c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":907,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:20:34
14509	9d5eb96d-c03f-4e51-95ea-7565bcb67023	9d5eb96d-ec0a-4ae6-9f91-2e41bdc76308	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-30 10:20:34
14510	9d5eb96d-d7b5-48c4-b76b-f1698dc61b7a	9d5eb96d-ec0a-4ae6-9f91-2e41bdc76308	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 30\\n                        ","time":"47.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"b9ae622c33dd7e7f0bc512338acf8ed0","hostname":"EderCortes"}	2024-10-30 10:20:34
10062	9d56c7f2-e335-441f-9486-be139bab5e10	9d56c7f3-0316-4bba-8958-7f07d3449028	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 11:34:33
10063	9d56c7f3-0188-4c56-8939-dddb6751d975	9d56c7f3-0316-4bba-8958-7f07d3449028	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 11:34:33
10064	9d56c7f3-0227-4ace-9ecc-c34db72ae03a	9d56c7f3-0316-4bba-8958-7f07d3449028	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":262,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:34:33
14511	9d5eb96d-e672-49ee-b5ac-50e719b37184	9d5eb96d-ec0a-4ae6-9f91-2e41bdc76308	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '30' order by \\"item_loans\\".\\"id\\" asc","time":"11.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-30 10:20:34
14512	9d5eb96d-e6aa-47ba-b4b7-dac9858a145a	9d5eb96d-ec0a-4ae6-9f91-2e41bdc76308	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-10-30 10:20:34
14513	9d5eb96d-eabe-47b0-93a5-2274493c4b26	9d5eb96d-ec0a-4ae6-9f91-2e41bdc76308	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-30 10:20:34
14514	9d5eb96d-eb06-4b4e-9c00-a199948e7313	9d5eb96d-ec0a-4ae6-9f91-2e41bdc76308	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/30","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":30,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":1000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":106,"loans_codigo":30,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":107,"loans_codigo":30,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":108,"loans_codigo":30,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":109,"loans_codigo":30,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":110,"loans_codigo":30,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":111,"loans_codigo":30,"itemloans_cuota":"6","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":112,"loans_codigo":30,"itemloans_cuota":"7","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":113,"loans_codigo":30,"itemloans_cuota":"8","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":114,"loans_codigo":30,"itemloans_cuota":"9","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":115,"loans_codigo":30,"itemloans_cuota":"10","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":301,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:20:34
8049	9d52e631-aa5c-40fc-afc5-d883d9ab145e	9d52e631-d132-4e14-9bc6-0407a3eea1a8	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 13:15:48
8050	9d52e631-cf71-4b04-ad4e-366451ffa767	9d52e631-d132-4e14-9bc6-0407a3eea1a8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:15:49
8051	9d52e631-d031-4f11-a193-70bdda4ebda8	9d52e631-d132-4e14-9bc6-0407a3eea1a8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":268,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:15:49
723	9d4f2e4e-aadc-4d32-b116-08f14bee8bb6	9d4f2e4e-ade9-41c5-bb10-88c46f4a818e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":52}	2024-10-22 16:54:08
10065	9d56c7f3-4975-4d35-bc33-bb6055293ab0	9d56c7f3-62f7-43af-bcd3-010def4f5e2e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 11:34:33
10066	9d56c7f3-5eb8-4a81-8e37-8d71daa41d4b	9d56c7f3-62f7-43af-bcd3-010def4f5e2e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"42.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:34:33
8052	9d52e632-2c67-4519-aea3-4626434a1702	9d52e632-78ec-4893-95bf-d6921a3687ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:15:49
8053	9d52e632-731d-4c65-8e4e-408afcb047fc	9d52e632-78ec-4893-95bf-d6921a3687ea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"158.40","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:15:49
8054	9d52e632-736a-45b1-94b9-3b41a8418c6f	9d52e632-78ec-4893-95bf-d6921a3687ea	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:15:49
8055	9d52e632-778a-4331-9da4-9454df94f619	9d52e632-78ec-4893-95bf-d6921a3687ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:15:49
8056	9d52e632-77ed-4c70-a784-c78c43db3bb9	9d52e632-78ec-4893-95bf-d6921a3687ea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":399,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:15:49
10067	9d56c7f3-619e-4403-bed4-c1840706c1d4	9d56c7f3-62f7-43af-bcd3-010def4f5e2e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 11:34:33
10068	9d56c7f3-6201-428a-b834-1ce6027e387b	9d56c7f3-62f7-43af-bcd3-010def4f5e2e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":217,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:34:33
6253	9d5263a5-c9a3-4e7a-87b4-83b1e24a4ae4	9d5263a6-4248-411c-8cc7-0336e6446cd2	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 07:10:46
6254	9d5263a6-3d2a-4c3b-8cc2-0f718e66e266	9d5263a6-4248-411c-8cc7-0336e6446cd2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 07:10:47
6255	9d5263a6-3ff5-48f4-a440-0b5349b633d7	9d5263a6-4248-411c-8cc7-0336e6446cd2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":781,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:10:47
811	9d4f3106-2ab3-4efc-ac82-4a025b23ec0a	9d4f3106-2d58-4cec-a2ae-c3cd1fc181c0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":59}	2024-10-22 17:01:44
8057	9d52e632-bdb1-44cc-bbf9-1efcb172891b	9d52e632-db3a-4718-baba-ae68dbb7ac8b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:15:49
10069	9d56c7f4-79d6-44d2-92e4-4cc105d9d60d	9d56c7f4-b348-4c2a-a32b-20ea3ca52793	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 11:34:34
10070	9d56c7f4-ad5d-4274-8b38-478f1f55a536	9d56c7f4-b348-4c2a-a32b-20ea3ca52793	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"60.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:34:34
10071	9d56c7f4-adac-4b60-a6fe-902cbf30282f	9d56c7f4-b348-4c2a-a32b-20ea3ca52793	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:34:34
10072	9d56c7f4-b1f2-4431-be5e-2949c829d312	9d56c7f4-b348-4c2a-a32b-20ea3ca52793	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 11:34:34
8058	9d52e632-d59e-4814-ba40-d271a5b315df	9d52e632-db3a-4718-baba-ae68dbb7ac8b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:15:49
8059	9d52e632-d5ed-4332-8a44-a5c7a9370585	9d52e632-db3a-4718-baba-ae68dbb7ac8b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:15:49
8060	9d52e632-d9dd-4832-b2f4-5d5004e05799	9d52e632-db3a-4718-baba-ae68dbb7ac8b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:15:49
8061	9d52e632-da34-443e-9522-c5c3c0fa8746	9d52e632-db3a-4718-baba-ae68dbb7ac8b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:15:49
10073	9d56c7f4-b23d-4b63-8c77-88d300402ba7	9d56c7f4-b348-4c2a-a32b-20ea3ca52793	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":391,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:34:34
6184	9d52605a-a894-46e3-ac0f-59d5f17af1f8	9d52605a-cf49-496f-9c59-4037820665ec	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 07:01:34
6185	9d52605a-ccf6-4072-93e8-3eac1afdcedf	9d52605a-cf49-496f-9c59-4037820665ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 07:01:34
6186	9d52605a-cdf4-411e-a8f1-52d0b22ff13f	9d52605a-cf49-496f-9c59-4037820665ec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:01:34
6187	9d52605b-2e03-468c-b555-f1b43eb681ba	9d52605b-4967-41e5-99ce-ab68f4626907	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 07:01:34
6188	9d52605b-44ca-44df-9fce-95acb2f04617	9d52605b-4967-41e5-99ce-ab68f4626907	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                select l.id,\\n                    l.loans_documento,\\n                    l.loans_nombre,\\n                    l.loans_apellido_uno,\\n                    l.loans_fecha,\\n                    l.loans_valor_prestado,\\n                    l.loans_cuotas,\\n                    loans_intereses,\\n                    ucl.name as cliente,\\n                    uco.name as cobrador,\\n                    ure.name as recomendador\\n                from loans l\\n                join users ucl on l.user_customer = ucl.id\\n                join users uco on l.user_cobrador = uco.id\\n                left join users ure on l.user_recomendacion = ure.id\\n","time":"45.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23,"hash":"9250fa65b3d81227138d7b5af818d563","hostname":"EderCortes"}	2024-10-24 07:01:34
6189	9d52605b-4821-4da5-8a1d-3247e908d083	9d52605b-4967-41e5-99ce-ab68f4626907	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 07:01:34
6190	9d52605b-4869-4c0c-af18-f469ab79126a	9d52605b-4967-41e5-99ce-ab68f4626907	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":"askdbsabjkdkbasbdkkbasbd"},"duration":276,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:01:34
8062	9d52e633-255c-4079-87fd-9b87f5f23674	9d52e633-71ec-4073-ad1a-7789f4b2415f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:15:49
8063	9d52e633-6a77-48a6-bb4a-88d373850cb1	9d52e633-71ec-4073-ad1a-7789f4b2415f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc","time":"153.31","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 13:15:50
8064	9d52e633-6ac1-46ba-acc6-ad8e4c277ee5	9d52e633-71ec-4073-ad1a-7789f4b2415f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:15:50
8065	9d52e633-6c7a-4740-8e6f-18d2ce7ff24b	9d52e633-71ec-4073-ad1a-7789f4b2415f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6'","time":"1.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 13:15:50
8066	9d52e633-6caf-42fb-8f71-8dcf1951786e	9d52e633-71ec-4073-ad1a-7789f4b2415f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:15:50
8067	9d52e633-7075-420d-bc9a-c047af76dc1b	9d52e633-71ec-4073-ad1a-7789f4b2415f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:15:50
8068	9d52e633-70c2-4471-8ccb-437c00bfe71b	9d52e633-71ec-4073-ad1a-7789f4b2415f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":366,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:15:50
10140	9d56c9b8-9506-4afd-9c37-1459aa88b0b5	9d56c9b8-e3bf-42ee-b789-0bac36c7be84	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 11:39:30
10141	9d56c9b8-e1bf-455a-a55a-ac887b246de2	9d56c9b8-e3bf-42ee-b789-0bac36c7be84	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:39:30
10142	9d56c9b8-e2a0-43de-aa47-ac59bf800dc8	9d56c9b8-e3bf-42ee-b789-0bac36c7be84	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":425,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:39:30
6191	9d52605d-437e-498e-a981-4db8d1a0b8fb	9d52605d-60f0-4b42-af0a-cf7fbfcc422b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 07:01:36
6192	9d52605d-5b6a-4ec5-9d10-c1beaf50d08b	9d52605d-60f0-4b42-af0a-cf7fbfcc422b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 07:01:36
6193	9d52605d-5bbd-4882-acfa-1c9960b88962	9d52605d-60f0-4b42-af0a-cf7fbfcc422b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 07:01:36
6194	9d52605d-5f9e-42ca-b287-70204cc68a3a	9d52605d-60f0-4b42-af0a-cf7fbfcc422b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 07:01:36
6195	9d52605d-5fe8-481f-9551-67188ac0f195	9d52605d-60f0-4b42-af0a-cf7fbfcc422b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":321,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:01:36
8069	9d52e635-10a1-4a3e-a684-5ad81e28e4d1	9d52e635-3b60-47e7-95cb-272f775ab046	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:15:51
8070	9d52e635-3556-4a8f-b517-ef9559ee2c0e	9d52e635-3b60-47e7-95cb-272f775ab046	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"52.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:15:51
8071	9d52e635-35a1-4eb6-81dd-40d046e29009	9d52e635-3b60-47e7-95cb-272f775ab046	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:15:51
8072	9d52e635-3a15-45ec-b4f6-fac5372ef5b5	9d52e635-3b60-47e7-95cb-272f775ab046	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:15:51
8073	9d52e635-3a67-4620-876d-6e413be3d030	9d52e635-3b60-47e7-95cb-272f775ab046	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":526,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:15:51
10143	9d56c9b9-3c52-43c0-b970-384794b55ace	9d56c9b9-5768-4335-9fc9-a241f708a5c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:39:31
10144	9d56c9b9-5232-4a51-a773-5e09cb932e53	9d56c9b9-5768-4335-9fc9-a241f708a5c9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"42.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:39:31
10145	9d56c9b9-5645-43a8-955d-d6e017495964	9d56c9b9-5768-4335-9fc9-a241f708a5c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:39:31
10146	9d56c9b9-568a-40f6-952d-0f0f9a289547	9d56c9b9-5768-4335-9fc9-a241f708a5c9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":264,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:39:31
8205	9d52e7aa-e672-4788-9793-d776b0f3b03b	9d52e7ab-2df0-4db0-bbbb-243ba1900d41	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 13:19:56
8206	9d52e7ab-2c64-4a50-886c-12afec36ed2e	9d52e7ab-2df0-4db0-bbbb-243ba1900d41	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 13:19:56
8207	9d52e7ab-2cfe-42d2-8c41-5e93ae19950b	9d52e7ab-2df0-4db0-bbbb-243ba1900d41	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:19:56
10147	9d56c9ba-d9cf-414d-b48c-db3cb18b6510	9d56c9bb-2c3e-4e8b-9791-0fe6ade380cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:39:32
10148	9d56c9bb-2470-4424-97e6-2150414d523e	9d56c9bb-2c3e-4e8b-9791-0fe6ade380cf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"163.63","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:39:32
10149	9d56c9bb-24e5-4e31-91c2-90007bf4cf05	9d56c9bb-2c3e-4e8b-9791-0fe6ade380cf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:39:32
10150	9d56c9bb-2ab3-4bad-9344-041c2662009d	9d56c9bb-2c3e-4e8b-9791-0fe6ade380cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 11:39:32
8208	9d52e7ab-73a0-49f1-8bc7-c9ed5b874204	9d52e7ab-91c4-43ab-971b-6a98c4d4085c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 13:19:56
8209	9d52e7ab-8d55-4509-af71-7811e1d1f43c	9d52e7ab-91c4-43ab-971b-6a98c4d4085c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:19:56
8210	9d52e7ab-8d9e-452f-b945-473aed76d9db	9d52e7ab-91c4-43ab-971b-6a98c4d4085c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:19:56
8211	9d52e7ab-90ae-47fc-af99-ef94b886efac	9d52e7ab-91c4-43ab-971b-6a98c4d4085c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 13:19:56
6982	9d52d99f-e079-49e9-94cf-b8e06271cb7a	9d52d9a0-0e38-4d81-a0ac-e9791d7d0558	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 12:40:40
6983	9d52d9a0-0b37-493c-83e9-8dcb466b11b2	9d52d9a0-0e38-4d81-a0ac-e9791d7d0558	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:40:40
6984	9d52d9a0-0c42-4cc5-9cfe-556a311c2449	9d52d9a0-0e38-4d81-a0ac-e9791d7d0558	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":448,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:40:40
8212	9d52e7ab-90ed-4bb0-9849-9f5c4712cfa6	9d52e7ab-91c4-43ab-971b-6a98c4d4085c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:19:56
10151	9d56c9bb-2b0d-47cf-9451-42d8699e92e0	9d56c9bb-2c3e-4e8b-9791-0fe6ade380cf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":439,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:39:32
8213	9d52e7ab-d871-4a65-9dc6-6500abf7b7ce	9d52e7ab-f54c-4a4e-95eb-8479f1763067	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 13:19:56
6291	9d52641b-1292-4916-aa06-e5e559e77991	9d52641b-34d7-4219-8c88-e2f212027d8e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 07:12:03
6292	9d52641b-330d-4ac2-a239-514f9d91e511	9d52641b-34d7-4219-8c88-e2f212027d8e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 07:12:03
6293	9d52641b-33af-4249-ab12-cbe15b4a444d	9d52641b-34d7-4219-8c88-e2f212027d8e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abfrom\\u00bb\\nLINE 14:     from loans l\\n             ^ (Connection: pgsql, SQL: \\n    select l.id,\\n        l.loans_documento,\\n        l.loans_nombre,\\n        l.loans_apellido_uno,\\n        l.loans_fecha,\\n        l.loans_valor_prestado,\\n        l.loans_cuotas,\\n        l.loans_estado,\\n        l.loans_intereses,\\n        ucl.name as cliente,\\n        uco.name as cobrador,\\n        ure.name as recomendador,\\n    from loans l\\n    join users ucl on l.user_customer = ucl.id\\n    join users uco on l.user_cobrador = uco.id\\n    left join users ure on l.user_recomendacion = ure.id\\n)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":284,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:12:03
8214	9d52e7ab-f03b-4c53-ad11-62adb9aee7b2	9d52e7ab-f54c-4a4e-95eb-8479f1763067	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:19:56
6985	9d52d9a0-840e-4bf8-9ff5-b0847e64a9a0	9d52d9a0-a806-4e34-9de4-8dddedc3c755	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:40:40
6986	9d52d9a0-a064-4247-8c67-e6344dec092c	9d52d9a0-a806-4e34-9de4-8dddedc3c755	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:40:40
8215	9d52e7ab-f08c-478b-a3c8-abcd315625ca	9d52e7ab-f54c-4a4e-95eb-8479f1763067	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:19:56
6987	9d52d9a0-a0c3-4c37-a63b-7fb610fc652d	9d52d9a0-a806-4e34-9de4-8dddedc3c755	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:40:40
6988	9d52d9a0-a667-4c4f-8b7c-ec745b322846	9d52d9a0-a806-4e34-9de4-8dddedc3c755	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:40:40
6989	9d52d9a0-a6d5-4fae-8fb1-d62241e33ce7	9d52d9a0-a806-4e34-9de4-8dddedc3c755	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":350,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:40:40
8216	9d52e7ab-f41a-4fa4-bb17-8e2734209c42	9d52e7ab-f54c-4a4e-95eb-8479f1763067	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 13:19:56
8217	9d52e7ab-f461-438e-bd94-a68e4240d7fb	9d52e7ab-f54c-4a4e-95eb-8479f1763067	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:19:56
5591	9d524730-3745-427b-8ec8-e957011834a4	9d524730-61b0-4b8a-99cb-e2e2d8631172	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 05:51:12
5592	9d524730-5f5c-4ea9-bc6b-c71f3d2fdcef	9d524730-61b0-4b8a-99cb-e2e2d8631172	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 05:51:12
5593	9d524730-607c-458b-8201-ac45e5bccf7f	9d524730-61b0-4b8a-99cb-e2e2d8631172	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":295,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:51:12
5594	9d524730-d7d9-4ee1-9110-033912306f34	9d524731-2429-476c-9fcb-0e856254f497	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 05:51:12
5595	9d524731-1cef-449a-b599-94ea3bacd966	9d524731-2429-476c-9fcb-0e856254f497	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"145.80","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":120,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 05:51:12
5596	9d524731-1d70-4c26-9d42-209daacf2f7b	9d524731-2429-476c-9fcb-0e856254f497	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 05:51:12
5597	9d524731-22ad-4baf-9fe0-76a78044350c	9d524731-2429-476c-9fcb-0e856254f497	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 05:51:12
5598	9d524731-2307-45b3-b3a3-0c2d55181d6f	9d524731-2429-476c-9fcb-0e856254f497	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":430,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:51:12
6294	9d52641d-1031-485b-843a-f5662b9f73d5	9d52641d-4568-4bf6-ac21-0a60a91c89f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 07:12:05
6295	9d52641d-3753-4abd-9848-aa5926b8e8de	9d52641d-4568-4bf6-ac21-0a60a91c89f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"68.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 07:12:05
6296	9d52641d-3845-4fb7-b77b-5c5ccab9d10c	9d52641d-4568-4bf6-ac21-0a60a91c89f0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 07:12:05
6297	9d52641d-42c4-44ba-ab22-98ae216f8751	9d52641d-4568-4bf6-ac21-0a60a91c89f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 07:12:05
6298	9d52641d-437d-4e38-8a17-4b4bef48b19d	9d52641d-4568-4bf6-ac21-0a60a91c89f0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":494,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:12:05
6990	9d52d9a0-fd32-4c1d-a1bc-049f58deb60b	9d52d9a1-2082-4cb4-8660-dfa87def29e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:40:40
6991	9d52d9a1-1966-4fb5-8759-62608edebe0a	9d52d9a1-2082-4cb4-8660-dfa87def29e4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:40:40
6992	9d52d9a1-19ca-471a-a22f-7cc967afa63b	9d52d9a1-2082-4cb4-8660-dfa87def29e4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:40:40
6993	9d52d9a1-1eb5-4b49-a951-f0a149c908cf	9d52d9a1-2082-4cb4-8660-dfa87def29e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:40:40
6994	9d52d9a1-1f34-4a74-ac77-4a04f7dfbcba	9d52d9a1-2082-4cb4-8660-dfa87def29e4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":285,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:40:40
8218	9d52e7ac-36d4-4fcf-9e6b-f13f6378ae1e	9d52e7ac-5489-4998-b59a-90c23aa56dc6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 13:19:57
8219	9d52e7ac-4e41-425e-b049-3ed253c05000	9d52e7ac-5489-4998-b59a-90c23aa56dc6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc","time":"41.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 13:19:57
5599	9d524731-7749-4695-bd19-d8cf7003a0dd	9d524731-c615-46f7-9cca-977b88092c6c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 05:51:13
5600	9d524731-bf74-42f2-a456-225cef2a91ac	9d524731-c615-46f7-9cca-977b88092c6c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"157.90","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":120,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 05:51:13
5601	9d524731-bfd2-49d9-9510-a0b508a8ab64	9d524731-c615-46f7-9cca-977b88092c6c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 05:51:13
5602	9d524731-c4a9-4cab-a636-d366cec5cdee	9d524731-c615-46f7-9cca-977b88092c6c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 05:51:13
5603	9d524731-c504-4a42-b029-3f6fe7785c1b	9d524731-c615-46f7-9cca-977b88092c6c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":398,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:51:13
6995	9d52d9a1-7002-44e6-aba3-774a9c31ff8c	9d52d9a1-95e3-4813-adeb-060449046338	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:40:41
6996	9d52d9a1-8e05-4a3b-b85d-4b6bf82aa948	9d52d9a1-95e3-4813-adeb-060449046338	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"51.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:40:41
6997	9d52d9a1-8e6d-4e03-8ef5-3660293fec2c	9d52d9a1-95e3-4813-adeb-060449046338	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:40:41
6998	9d52d9a1-90b5-4741-bc24-5daef2c8ff1b	9d52d9a1-95e3-4813-adeb-060449046338	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"2.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:40:41
6999	9d52d9a1-90f8-44f6-b34c-2c95ed2c7b9e	9d52d9a1-95e3-4813-adeb-060449046338	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:40:41
7000	9d52d9a1-94b7-49be-b1d9-bd37d3dd6fb2	9d52d9a1-95e3-4813-adeb-060449046338	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:40:41
7001	9d52d9a1-9504-48a4-8152-0b2d4be331aa	9d52d9a1-95e3-4813-adeb-060449046338	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":274,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:40:41
8220	9d52e7ac-4e8e-4fd0-884f-50312e5b7602	9d52e7ac-5489-4998-b59a-90c23aa56dc6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:19:57
8221	9d52e7ac-4ff4-4cef-9ba9-f500817c85eb	9d52e7ac-5489-4998-b59a-90c23aa56dc6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6'","time":"1.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 13:19:57
8222	9d52e7ac-5028-4390-a7a9-ad4bdda0252a	9d52e7ac-5489-4998-b59a-90c23aa56dc6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:19:57
8223	9d52e7ac-536c-4495-97ab-24337b0ed613	9d52e7ac-5489-4998-b59a-90c23aa56dc6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 13:19:57
8224	9d52e7ac-53b1-498f-a372-dceca723b8db	9d52e7ac-5489-4998-b59a-90c23aa56dc6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:19:57
5604	9d524735-2cd8-43ed-bc7f-1b6002400216	9d524735-60a3-46cd-80c0-c5db86f90226	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 05:51:15
5605	9d524735-5a50-49e1-97c1-073cd5a60c1f	9d524735-60a3-46cd-80c0-c5db86f90226	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"76.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 05:51:15
5606	9d524735-5aa5-4314-a118-d3b485d7ed18	9d524735-60a3-46cd-80c0-c5db86f90226	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 05:51:15
5607	9d524735-5f03-4f29-80fd-e663e403f71c	9d524735-60a3-46cd-80c0-c5db86f90226	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 05:51:15
5608	9d524735-5f66-4016-b00a-68c7a232413b	9d524735-60a3-46cd-80c0-c5db86f90226	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":1014,"memory":22,"hostname":"EderCortes"}	2024-10-24 05:51:15
7002	9d52d9a3-af25-45e3-b12b-a8500f806b2c	9d52d9a3-faca-4fd1-9722-4bdaf73a09ab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:40:42
7003	9d52d9a3-f57a-4535-b906-24d1d35ddd18	9d52d9a3-faca-4fd1-9722-4bdaf73a09ab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"158.38","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:40:42
7004	9d52d9a3-f5d6-4473-b3a4-f7e2c1de2e3d	9d52d9a3-faca-4fd1-9722-4bdaf73a09ab	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:40:42
7005	9d52d9a3-f979-4b2c-8c19-73c27948d84f	9d52d9a3-faca-4fd1-9722-4bdaf73a09ab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:40:42
7006	9d52d9a3-f9c0-46ee-bcff-386ab430b16d	9d52d9a3-faca-4fd1-9722-4bdaf73a09ab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":387,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:40:42
8225	9d52e7ae-188d-40d1-a917-69863a9b63a2	9d52e7ae-3635-44e0-bf79-f2d73152778a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 13:19:58
8226	9d52e7ae-3104-4ebe-b409-40c4814a75b6	9d52e7ae-3635-44e0-bf79-f2d73152778a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:19:58
8227	9d52e7ae-315f-4211-b1fd-1c6996fbe7f6	9d52e7ae-3635-44e0-bf79-f2d73152778a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:19:58
8228	9d52e7ae-34ec-4fc2-bf6e-cf9fdefc8cd8	9d52e7ae-3635-44e0-bf79-f2d73152778a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-24 13:19:58
8229	9d52e7ae-3532-44d4-ab2c-b8056569de62	9d52e7ae-3635-44e0-bf79-f2d73152778a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":317,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:19:58
8361	9d52e8f0-4501-46f8-8c48-7ee61a02b1e9	9d52e8f0-6551-41df-a552-7bdb14c4be71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:23:29
8362	9d52e8f0-63b7-4894-bf62-07ba9fcb07a1	9d52e8f0-6551-41df-a552-7bdb14c4be71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:23:29
8363	9d52e8f0-6452-4d8c-8b03-51c8ddbe88a3	9d52e8f0-6551-41df-a552-7bdb14c4be71	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":292,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:23:29
8364	9d52e8f0-d853-472d-98a9-582dbcf30ff7	9d52e8f1-341b-4c32-a381-e02263e7f483	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:23:29
8365	9d52e8f1-2be4-42b9-bdd7-ba95375d27ba	9d52e8f1-341b-4c32-a381-e02263e7f483	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"190.81","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:23:29
8366	9d52e8f1-2c65-42c5-b97c-ed8dd9816767	9d52e8f1-341b-4c32-a381-e02263e7f483	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:23:29
8367	9d52e8f1-327c-46f9-af38-111cc5c2d76a	9d52e8f1-341b-4c32-a381-e02263e7f483	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:23:30
5728	9d524a7e-6f95-4b5f-94d9-686749e6b709	9d524a7e-9ee5-456a-b8f6-dc425fd47b3c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 06:00:26
5729	9d524a7e-9c0d-406a-97db-f645acd47290	9d524a7e-9ee5-456a-b8f6-dc425fd47b3c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 06:00:26
5730	9d524a7e-9d41-48a1-8010-bf06f435e99f	9d524a7e-9ee5-456a-b8f6-dc425fd47b3c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":422,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:00:26
8368	9d52e8f1-32d8-4d4d-a466-c7e821dcbbe9	9d52e8f1-341b-4c32-a381-e02263e7f483	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":497,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:23:30
10322	9d56cd6f-d42d-40ad-83f3-0e8a775b0766	9d56cd70-2406-4942-8eda-d8a1d0bb5b09	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 11:49:54
10323	9d56cd70-220e-4d0b-b15d-7ee8c15e9113	9d56cd70-2406-4942-8eda-d8a1d0bb5b09	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:49:54
10324	9d56cd70-2304-4d06-9cb9-8185d31b0edf	9d56cd70-2406-4942-8eda-d8a1d0bb5b09	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":407,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:49:54
5731	9d524a7f-1486-44cd-bcf0-882b8351949a	9d524a7f-42ae-4c00-a391-877181046371	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 06:00:27
5732	9d524a7f-3749-4472-9ff4-9503a489cca6	9d524a7f-42ae-4c00-a391-877181046371	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"60.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":123,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 06:00:27
5733	9d524a7f-3810-4472-a9eb-9e64703364e2	9d524a7f-42ae-4c00-a391-877181046371	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 06:00:27
5734	9d524a7f-40c7-4c48-bef4-b1e6252c68a4	9d524a7f-42ae-4c00-a391-877181046371	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 06:00:27
5735	9d524a7f-4163-4f64-9538-a15a4ceb962c	9d524a7f-42ae-4c00-a391-877181046371	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":382,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:00:27
8369	9d52e8f1-ef2f-4a5a-a96e-b4739379510a	9d52e8f2-1f1a-4f66-b3bc-fd3f7cf295e9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:23:30
8370	9d52e8f2-17f3-4b5c-87ce-3f28741a7c7f	9d52e8f2-1f1a-4f66-b3bc-fd3f7cf295e9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"60.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:23:30
8371	9d52e8f2-185c-4bfe-b54c-e9b175838233	9d52e8f2-1f1a-4f66-b3bc-fd3f7cf295e9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:23:30
8372	9d52e8f2-1d32-4339-b95d-1ac59a97eb3a	9d52e8f2-1f1a-4f66-b3bc-fd3f7cf295e9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:23:30
8373	9d52e8f2-1dbe-46c6-a6f5-fd594d332800	9d52e8f2-1f1a-4f66-b3bc-fd3f7cf295e9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":576,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:23:30
10325	9d56cd70-8036-4c7c-aa79-35b654aa9da8	9d56cd70-c73c-4040-9e29-0c431b7660f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:49:54
10231	9d56cc14-3dc5-4598-9370-9d7b7947f623	9d56cc14-6a0b-421a-b2c8-f6efe0be8d97	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 11:46:06
10232	9d56cc14-6752-4e7c-be50-e1fed9430e94	9d56cc14-6a0b-421a-b2c8-f6efe0be8d97	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:46:06
10233	9d56cc14-68a1-4d54-988b-29c45e7a7639	9d56cc14-6a0b-421a-b2c8-f6efe0be8d97	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:46:06
10326	9d56cd70-c1a0-43a5-835c-9e9c4466df49	9d56cd70-c73c-4040-9e29-0c431b7660f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"152.94","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:49:54
10327	9d56cd70-c5fb-4c1c-b3fe-28c669164e30	9d56cd70-c73c-4040-9e29-0c431b7660f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:49:54
8374	9d52e8f2-67aa-4b4f-8f2a-69eb741f1e50	9d52e8f2-b1fb-4301-b62c-62fef17fdfe9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:23:30
5004	9d513663-914d-4389-9b78-3e348b3164fb	9d513663-cb08-443d-b82c-85c205b9dda4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":32,"hostname":"EderCortes"}	2024-10-23 17:08:24
5005	9d513663-c83c-477e-9436-61a2f995ee18	9d513663-cb08-443d-b82c-85c205b9dda4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":33,"hostname":"EderCortes"}	2024-10-23 17:08:24
5006	9d513663-c987-41be-a711-8d203d9fdcb6	9d513663-cb08-443d-b82c-85c205b9dda4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":633,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:24
8375	9d52e8f2-aa0e-4f00-ac4e-d4db2b58c09d	9d52e8f2-b1fb-4301-b62c-62fef17fdfe9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc","time":"151.69","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 13:23:30
8376	9d52e8f2-aa86-42f8-895c-5a267f09cec7	9d52e8f2-b1fb-4301-b62c-62fef17fdfe9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:23:30
5736	9d524a7f-9f63-4c80-8a68-c07f89d4edda	9d524a7f-c305-4f92-a68a-3bbff05c8f33	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 06:00:27
8377	9d52e8f2-ac74-41cf-a022-37374c9c158b	9d52e8f2-b1fb-4301-b62c-62fef17fdfe9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6'","time":"1.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 13:23:30
5737	9d524a7f-bc0f-4e71-ae1f-9188ef735c70	9d524a7f-c305-4f92-a68a-3bbff05c8f33	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":123,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 06:00:27
5738	9d524a7f-bc78-436e-a6e4-544c78070868	9d524a7f-c305-4f92-a68a-3bbff05c8f33	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 06:00:27
5739	9d524a7f-c159-400d-a21e-afab3112ba79	9d524a7f-c305-4f92-a68a-3bbff05c8f33	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 06:00:27
8378	9d52e8f2-aca7-4612-8d17-f9de864773e9	9d52e8f2-b1fb-4301-b62c-62fef17fdfe9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:23:30
8379	9d52e8f2-b0ac-4f0b-b0d8-64bff10377a9	9d52e8f2-b1fb-4301-b62c-62fef17fdfe9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:23:30
8380	9d52e8f2-b108-45ce-9a19-b5a5c6847776	9d52e8f2-b1fb-4301-b62c-62fef17fdfe9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":352,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:23:30
10234	9d56cc14-cfd1-426b-a6e1-bcd0b71038a0	9d56cc15-1fdf-4c22-aacb-66eb3577c7cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:46:06
10235	9d56cc15-16c1-43b9-bce3-b02f7b1137cb	9d56cc15-1fdf-4c22-aacb-66eb3577c7cd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"167.93","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:46:06
10236	9d56cc15-1e2a-467f-9b9f-25833ef4ac50	9d56cc15-1fdf-4c22-aacb-66eb3577c7cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:46:06
10237	9d56cc15-1e9f-43bd-b1fa-4b03d1f2fd08	9d56cc15-1fdf-4c22-aacb-66eb3577c7cd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":431,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:46:06
5740	9d524a7f-c1df-48d6-964d-906e274c784b	9d524a7f-c305-4f92-a68a-3bbff05c8f33	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":307,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:00:27
8381	9d52e8f4-2b6a-426b-8833-44ec1487e43c	9d52e8f4-585a-4a7f-9987-77d700a7cce4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:23:31
8382	9d52e8f4-51b3-496c-86b4-06db56387bf1	9d52e8f4-585a-4a7f-9987-77d700a7cce4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"56.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:23:32
8383	9d52e8f4-5222-418f-8a4a-2871aace77f7	9d52e8f4-585a-4a7f-9987-77d700a7cce4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:23:32
8384	9d52e8f4-56d5-4698-9c79-f74022769eed	9d52e8f4-585a-4a7f-9987-77d700a7cce4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 13:23:32
8385	9d52e8f4-5721-463b-9524-8fc1267d7abf	9d52e8f4-585a-4a7f-9987-77d700a7cce4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":489,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:23:32
5741	9d524a81-f63d-4fbc-8054-fe11ff731721	9d524a82-198e-4114-957c-a2f35bbb2e2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 06:00:29
5742	9d524a82-12d7-4b5a-85b9-6cf049e0e786	9d524a82-198e-4114-957c-a2f35bbb2e2b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"46.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 06:00:29
5743	9d524a82-134e-46f1-8ccf-e76016de9d31	9d524a82-198e-4114-957c-a2f35bbb2e2b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 06:00:29
5744	9d524a82-17df-4782-8722-df5cfef9592e	9d524a82-198e-4114-957c-a2f35bbb2e2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 06:00:29
5745	9d524a82-186b-4254-9a47-bfedefdc2f82	9d524a82-198e-4114-957c-a2f35bbb2e2b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":400,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:00:29
10238	9d56cc17-1779-4a52-9e65-ee73e4ce1ddf	9d56cc17-3814-4ffa-b7f3-3980b794a29a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:46:08
10239	9d56cc17-325c-4fab-87ba-cf6d7eaca2e7	9d56cc17-3814-4ffa-b7f3-3980b794a29a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:46:08
10240	9d56cc17-32c9-4f50-ad82-09f7e97ad9e0	9d56cc17-3814-4ffa-b7f3-3980b794a29a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:46:08
10241	9d56cc17-368e-43a8-810f-739a398c9147	9d56cc17-3814-4ffa-b7f3-3980b794a29a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 11:46:08
10242	9d56cc17-36d4-419a-af9c-6b7ae7507f35	9d56cc17-3814-4ffa-b7f3-3980b794a29a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":261,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:46:08
5298	9d5137c2-5b6a-4702-93b8-a3f7a5e3401b	9d5137c2-9ba0-4369-9d65-eea5f06ba16e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 17:12:13
5299	9d5137c2-98b1-4d2b-ab95-d732e32d7906	9d5137c2-9ba0-4369-9d65-eea5f06ba16e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 17:12:14
5300	9d5137c2-99ff-46e7-baca-79b535e6012c	9d5137c2-9ba0-4369-9d65-eea5f06ba16e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":543,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:12:14
17486	9d655bbc-9d7c-4174-aff9-7ac6f46c0a7a	9d655bbc-a2e6-404b-b5f0-9838b456380f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":837}	2024-11-02 17:29:23
25892	9d68cb46-af30-4e65-bb8b-edf0738c6af0	9d68cb46-b500-4275-9d1a-18bad95ac363	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1193}	2024-11-04 10:28:45
5301	9d5137c3-1d6c-4a8d-abf1-74979623890c	9d5137c3-7995-4258-ba32-14c15367b18e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 17:12:14
5302	9d5137c3-716b-4773-bc00-7b82aea6442f	9d5137c3-7995-4258-ba32-14c15367b18e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"176.63","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:12:14
5303	9d5137c3-71ea-47b4-be8c-cdf251f730b4	9d5137c3-7995-4258-ba32-14c15367b18e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:12:14
5304	9d5137c3-7772-45e2-a318-4a56728eebf7	9d5137c3-7995-4258-ba32-14c15367b18e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 17:12:14
5305	9d5137c3-77fc-497c-8ca3-1416d0b438b3	9d5137c3-7995-4258-ba32-14c15367b18e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":526,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:12:14
5746	9d524a86-673e-4657-acb3-a051bbfa3d25	9d524a86-6a90-44e1-9fab-91714f05382e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":153,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:00:32
10328	9d56cd70-c63e-4724-b238-5b7cc95061f3	9d56cd70-c73c-4040-9e29-0c431b7660f0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":385,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:49:54
5306	9d5137c3-e934-42ce-9484-4eeeb21349bd	9d5137c4-1621-4289-bb16-1d5af8a929a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-23 17:12:14
5307	9d5137c4-0ff9-44e1-8ed1-a0e7fbf26d29	9d5137c4-1621-4289-bb16-1d5af8a929a6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"64.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:12:15
5308	9d5137c4-1051-4173-9cc6-f13df2a573cf	9d5137c4-1621-4289-bb16-1d5af8a929a6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:12:15
5309	9d5137c4-147e-4f02-a96f-818a39dd3891	9d5137c4-1621-4289-bb16-1d5af8a929a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-23 17:12:15
5310	9d5137c4-14e0-424d-9554-3f0cfe367ee8	9d5137c4-1621-4289-bb16-1d5af8a929a6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":377,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:12:15
5747	9d524a87-246f-4b03-83ef-d9346d16bc64	9d524a87-417a-4634-8295-8d995d89d590	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 06:00:32
5748	9d524a87-3ce0-4059-b8ec-cdf74fe6a073	9d524a87-417a-4634-8295-8d995d89d590	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Luis%' or \\"users\\".\\"user_document\\"::text like '%Luis%' order by \\"users\\".\\"user_document\\" asc","time":"44.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":49,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-24 06:00:32
5749	9d524a87-4024-4805-9287-a5f90d2d2d9d	9d524a87-417a-4634-8295-8d995d89d590	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 06:00:32
5750	9d524a87-4070-4b04-ba84-1039fa077732	9d524a87-417a-4634-8295-8d995d89d590	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Luis"},"session":[],"response_status":200,"response":{"data":[{"id":14,"name_customer":"Luis andre  Herrera - 100465545"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:00:32
10329	9d56cd71-f97a-425e-9f14-b97b9d94092f	9d56cd72-18e7-47cf-a7aa-eded6f2f1b86	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:49:55
10330	9d56cd72-137b-4f8c-a506-118dde480169	9d56cd72-18e7-47cf-a7aa-eded6f2f1b86	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:49:55
10331	9d56cd72-13c5-4f3a-ac61-effd223521d5	9d56cd72-18e7-47cf-a7aa-eded6f2f1b86	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:49:55
10332	9d56cd72-179b-404f-bea2-bc451e212f78	9d56cd72-18e7-47cf-a7aa-eded6f2f1b86	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 11:49:55
10333	9d56cd72-17e0-48f2-a723-29f2861cbaeb	9d56cd72-18e7-47cf-a7aa-eded6f2f1b86	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":401,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:49:55
5311	9d5137c4-e9a8-467e-802c-4b4da0e6f010	9d5137c5-5731-48d2-baf4-42339ca6485b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-23 17:12:15
5312	9d5137c5-4c46-42d3-81f5-8270b3589544	9d5137c5-5731-48d2-baf4-42339ca6485b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"163.92","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:12:15
5313	9d5137c5-4caf-42f8-9e27-7943b3baa983	9d5137c5-5731-48d2-baf4-42339ca6485b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:12:15
5314	9d5137c5-54da-4532-a828-4beb0a389fa0	9d5137c5-5731-48d2-baf4-42339ca6485b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-23 17:12:15
5315	9d5137c5-5569-4651-b629-7bc1ddf03b0f	9d5137c5-5731-48d2-baf4-42339ca6485b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":799,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:12:15
5751	9d524a8b-7b93-4340-b66c-042e4a41b828	9d524a8b-9d5f-4de4-a747-80d677f68b43	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 06:00:35
5752	9d524a8b-976b-44f3-88af-f92a4a1c56bc	9d524a8b-9d5f-4de4-a747-80d677f68b43	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '14' and \\"users\\".\\"deleted_at\\" is null","time":"45.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":31,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-24 06:00:35
5753	9d524a8b-97c5-410e-b559-7b214c83bedb	9d524a8b-9d5f-4de4-a747-80d677f68b43	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 06:00:35
5754	9d524a8b-9c09-4f61-ad6f-4c5e8519bbed	9d524a8b-9d5f-4de4-a747-80d677f68b43	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 06:00:35
5755	9d524a8b-9c5c-4eeb-aa00-bd3bad31fb2b	9d524a8b-9d5f-4de4-a747-80d677f68b43	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/14","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:00:35
6338	9d526487-b4f0-4584-a711-2b21fcb2e895	9d526487-d645-47bd-9fe9-735016b31f6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 07:13:14
6339	9d526487-d46f-4fcf-9df4-cb4ccf8e63f9	9d526487-d645-47bd-9fe9-735016b31f6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 07:13:15
6340	9d526487-d517-4388-8a1e-2a3f069ca38d	9d526487-d645-47bd-9fe9-735016b31f6b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":295,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:13:15
5316	9d5137c5-f4ae-49a4-ba50-a7ec9684a705	9d5137c6-428e-47c5-9e8c-573e6982e0f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-23 17:12:16
5317	9d5137c6-3c89-4b45-8002-78628ea26a59	9d5137c6-428e-47c5-9e8c-573e6982e0f9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"159.04","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:12:16
5318	9d5137c6-3cdb-4f80-88d3-440afc06a796	9d5137c6-428e-47c5-9e8c-573e6982e0f9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:12:16
5319	9d5137c6-4127-40d9-95d5-f4f5142851eb	9d5137c6-428e-47c5-9e8c-573e6982e0f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-23 17:12:16
5320	9d5137c6-4170-4f52-9248-8388ab78a55e	9d5137c6-428e-47c5-9e8c-573e6982e0f9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":578,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:12:16
5756	9d524aae-a1b6-4e46-9be9-539a143936cd	9d524aae-a4bb-412c-9341-eb6d81589be7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":138,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:00:58
6341	9d526488-2519-4a66-ae9d-009fc12526b2	9d526488-422d-46a0-8835-abe1c368f3ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 07:13:15
6342	9d526488-3cc6-4050-94e7-e035bbb61cdc	9d526488-422d-46a0-8835-abe1c368f3ff	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n    select l.id,\\n        l.loans_documento,\\n        l.loans_nombre,\\n        l.loans_apellido_uno,\\n        l.loans_fecha,\\n        l.loans_valor_prestado,\\n        l.loans_cuotas,\\n        l.loans_estado,\\n        l.loans_intereses,\\n        uco.name as cobrador,\\n        ure.name as recomendador\\n    from loans l\\n    join users ucl on l.user_customer = ucl.id\\n    join users uco on l.user_cobrador = uco.id\\n    left join users ure on l.user_recomendacion = ure.id\\n","time":"46.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23,"hash":"07791497a6f310e4570d0edecd8da1cd","hostname":"EderCortes"}	2024-10-24 07:13:15
6343	9d526488-40a5-4c3c-81eb-fc0fdc6d23cb	9d526488-422d-46a0-8835-abe1c368f3ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 07:13:15
6344	9d526488-410d-4daf-82b6-4fa99839ccae	9d526488-422d-46a0-8835-abe1c368f3ff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:13:15
5321	9d5137cc-6b84-4f9a-b264-69a2374706e6	9d5137cc-6f21-48df-85fb-82688d06b267	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":155,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:12:20
6345	9d52648a-2d5d-4f77-845d-f66af2c89c31	9d52648a-67ff-4f80-9d43-fba96a33fde7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 07:13:16
6346	9d52648a-60bd-4555-95bc-00ee8eabea0b	9d52648a-67ff-4f80-9d43-fba96a33fde7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"64.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 07:13:16
6347	9d52648a-611a-4a2c-8041-3e91dc480a9e	9d52648a-67ff-4f80-9d43-fba96a33fde7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 07:13:16
6348	9d52648a-6639-497d-8857-8c07458bfc52	9d52648a-67ff-4f80-9d43-fba96a33fde7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 07:13:16
6349	9d52648a-66ae-4e0b-86f1-922104f868ec	9d52648a-67ff-4f80-9d43-fba96a33fde7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":473,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:13:16
5322	9d5137cc-d2a9-428b-92c7-26a8ae0e6da0	9d5137cc-f08a-414f-afc9-5f41f45d6138	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-23 17:12:20
5323	9d5137cc-ec31-4103-b21c-961b2b687071	9d5137cc-f08a-414f-afc9-5f41f45d6138	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 4 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"45.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":46,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 17:12:20
5324	9d5137cc-ef19-4191-b433-93f1dbaad692	9d5137cc-f08a-414f-afc9-5f41f45d6138	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-23 17:12:20
5325	9d5137cc-ef70-4e49-8edd-6d874a58eb8f	9d5137cc-f08a-414f-afc9-5f41f45d6138	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":4,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":14,"name_customer":"Luis andre  Herrera - 100465545"}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:12:20
5762	9d524b4c-a6b6-4f1a-a492-c45d4d9a85b4	9d524b4c-abf7-4c49-bd04-38220b3a06ce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":262,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:02:41
5326	9d5137cf-e1ea-4b53-8283-33c6142b4330	9d5137d0-0596-40c9-a780-3a6ad8aba25a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-23 17:12:22
5327	9d5137cf-ff53-4260-910a-8bdcb6e8cbee	9d5137d0-0596-40c9-a780-3a6ad8aba25a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '14' and \\"users\\".\\"deleted_at\\" is null","time":"47.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":28,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-23 17:12:22
5328	9d5137cf-ffad-494a-b11d-a5162308b22e	9d5137d0-0596-40c9-a780-3a6ad8aba25a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:12:22
5329	9d5137d0-041b-4b40-9dd6-dabfdd01fb19	9d5137d0-0596-40c9-a780-3a6ad8aba25a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-23 17:12:22
5330	9d5137d0-0474-43f3-86d6-c4f0f29dae9a	9d5137d0-0596-40c9-a780-3a6ad8aba25a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/14","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}},"duration":305,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:12:22
625	9d4f2d7c-742d-4ccc-b745-07aaf732c619	9d4f2d7c-7829-4f10-a64b-ce89764247ad	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":45}	2024-10-22 16:51:51
35036	9d69c169-3dec-441d-8886-623ff83789e0	9d69c169-5ba2-4150-8c3e-04c69ccd71a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 21:57:00
35037	9d69c169-5648-44c0-a2b4-8f7c1d52af22	9d69c169-5ba2-4150-8c3e-04c69ccd71a7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 21:57:00
35038	9d69c169-56a0-4301-bec6-0f3e4a72cc38	9d69c169-5ba2-4150-8c3e-04c69ccd71a7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 21:57:00
35039	9d69c169-5a60-4693-acdf-ba5659d89741	9d69c169-5ba2-4150-8c3e-04c69ccd71a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 21:57:00
35040	9d69c169-5ab9-4014-88cd-59839a84d4cf	9d69c169-5ba2-4150-8c3e-04c69ccd71a7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":248,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:57:00
5769	9d524c20-3230-4fac-801c-0ac8e61e878f	9d524c20-38fe-4072-ac6d-7b47f3d245b9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":226,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:05:00
10413	9d56cf88-141e-459d-bc19-9e9ce9febef6	9d56cf88-30e7-4d37-9b87-15685af8574f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 11:55:45
10414	9d56cf88-2f0d-4976-9f3a-03c6dbd5c6f7	9d56cf88-30e7-4d37-9b87-15685af8574f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 11:55:45
10415	9d56cf88-2fbe-4c1e-b7c2-3cd7800502ed	9d56cf88-30e7-4d37-9b87-15685af8574f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:55:45
10491	9d570e81-6667-4e15-a2c2-2e1a19cafd1e	9d570e85-9d4f-4126-8157-6a86b90e403a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 14:51:51
10492	9d570e85-4c44-43aa-9086-a7ea234c42ba	9d570e85-9d4f-4126-8157-6a86b90e403a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 14:51:53
10493	9d570e85-7058-4b36-89e3-8d798bded871	9d570e85-9d4f-4126-8157-6a86b90e403a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":17603,"memory":22,"hostname":"EderCortes"}	2024-10-26 14:51:53
35041	9d69c169-9e46-4b2a-95b8-fdcdaebe602d	9d69c169-bc40-464a-adbc-60712e55eaf0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 21:57:00
35042	9d69c169-b6d5-4778-bba5-c71484eb0125	9d69c169-bc40-464a-adbc-60712e55eaf0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:57:00
35043	9d69c169-b738-4899-9ccb-8617287ef370	9d69c169-bc40-464a-adbc-60712e55eaf0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:57:00
35044	9d69c169-bb09-430d-a255-acfe02cc67c2	9d69c169-bc40-464a-adbc-60712e55eaf0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 21:57:00
5427	9d51392b-6c39-4a04-9e4e-10a64cf8b584	9d51392b-be4f-4bf7-82dc-fbc1f416d7c2	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-23 17:16:10
5428	9d51392b-bbbc-4593-86cf-1ac2a830e458	9d51392b-be4f-4bf7-82dc-fbc1f416d7c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 17:16:10
5429	9d51392b-bd28-4298-9d26-e6e0b5db180c	9d51392b-be4f-4bf7-82dc-fbc1f416d7c2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":421,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:16:10
5430	9d51392c-181b-4527-a815-65846a892f47	9d51392c-61a1-4051-87a2-b8ec628be2f8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-23 17:16:11
5431	9d51392c-5b5c-4402-a49e-03afdb742b69	9d51392c-61a1-4051-87a2-b8ec628be2f8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"148.08","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:16:11
5432	9d51392c-5bb5-42c9-a50c-7c23f0f4f7b7	9d51392c-61a1-4051-87a2-b8ec628be2f8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:16:11
5433	9d51392c-6076-4928-b898-c7478ee6e871	9d51392c-61a1-4051-87a2-b8ec628be2f8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 17:16:11
5434	9d51392c-60c0-47c1-a5f8-68613b6c68c7	9d51392c-61a1-4051-87a2-b8ec628be2f8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":388,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:16:11
10416	9d56cf88-791b-4ca1-80de-06d8cfcc842f	9d56cf88-9234-41ad-a1df-c4877a95512c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 11:55:45
8522	9d52ecff-489d-47f8-81e3-1a5295a5c1ea	9d52ecff-74a1-4b95-8719-35769eb789df	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 13:34:50
8523	9d52ecff-7294-4990-b700-12e90d9a11b5	9d52ecff-74a1-4b95-8719-35769eb789df	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:34:50
8524	9d52ecff-736b-49f5-99d2-dbc9b7332137	9d52ecff-74a1-4b95-8719-35769eb789df	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":346,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:34:50
10417	9d56cf88-8e7a-4f43-b45a-e85edecca7db	9d56cf88-9234-41ad-a1df-c4877a95512c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"41.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:55:45
10418	9d56cf88-9137-4a3b-8038-7b5d001bab9e	9d56cf88-9234-41ad-a1df-c4877a95512c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 11:55:45
10419	9d56cf88-9178-40bb-adc6-a1b8d1d0afb6	9d56cf88-9234-41ad-a1df-c4877a95512c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":222,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:55:45
10494	9d570e86-3cc4-4e95-b54d-09a493e6bd3e	9d570e87-41a2-4631-a970-e9d5671a783a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 14:51:53
10495	9d570e86-5824-466d-aa85-562243b1af9f	9d570e87-41a2-4631-a970-e9d5671a783a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"55.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 14:51:54
10496	9d570e87-4013-4f7e-957f-9f230099d6a0	9d570e87-41a2-4631-a970-e9d5671a783a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 14:51:54
5435	9d51392c-b584-4a52-a25d-57c057134756	9d51392d-02c3-457b-a13e-3dfe2ef576f8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 17:16:11
5436	9d51392c-fc89-4bbd-be39-65ee6a61e5c7	9d51392d-02c3-457b-a13e-3dfe2ef576f8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"157.76","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:16:11
5437	9d51392c-fce8-4c4c-8a17-9a3d61dc0013	9d51392d-02c3-457b-a13e-3dfe2ef576f8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:16:11
5438	9d51392d-0169-4473-8e71-5ef06dfb6cfb	9d51392d-02c3-457b-a13e-3dfe2ef576f8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 17:16:11
5439	9d51392d-01bd-478b-b840-3681a83e3c2d	9d51392d-02c3-457b-a13e-3dfe2ef576f8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":386,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:16:11
5776	9d524c5b-3de0-45f7-8b15-800280952792	9d524c5b-4498-4ecf-99be-187042dc32a9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":239,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:05:39
8525	9d52ecff-d6bc-4328-8272-2bfb17a51389	9d52ed00-2218-4499-9a5b-728b8bc0ac33	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:34:50
8526	9d52ed00-1cab-42e0-962c-57bc34527af5	9d52ed00-2218-4499-9a5b-728b8bc0ac33	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"154.27","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:34:50
8527	9d52ed00-1cfe-4cf2-9ce4-e31c5cf8d908	9d52ed00-2218-4499-9a5b-728b8bc0ac33	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:34:50
8528	9d52ed00-20fc-4ff3-9625-fe6692c8de5f	9d52ed00-2218-4499-9a5b-728b8bc0ac33	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:34:50
8529	9d52ed00-213e-4a6a-9e62-d00f09a914ad	9d52ed00-2218-4499-9a5b-728b8bc0ac33	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":414,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:34:50
10420	9d56cf89-b6ea-430b-9950-0d0359ed39a1	9d56cf89-d5bb-458e-92bc-e924364a1ba2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 11:55:46
10421	9d56cf89-d0ba-4d7a-aa4e-a2f4bcbcd5be	9d56cf89-d5bb-458e-92bc-e924364a1ba2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:55:46
10422	9d56cf89-d10e-4c64-a11e-faadc1e36ae0	9d56cf89-d5bb-458e-92bc-e924364a1ba2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:55:46
10423	9d56cf89-d471-4498-a57e-bd8ae327e309	9d56cf89-d5bb-458e-92bc-e924364a1ba2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 11:55:46
10497	9d570e87-407d-4210-ab54-ffb7974a443d	9d570e87-41a2-4631-a970-e9d5671a783a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":929,"memory":22,"hostname":"EderCortes"}	2024-10-26 14:51:54
8530	9d52ed00-727a-4a6b-ad48-2874cd9a6c2a	9d52ed00-c025-4eb2-b886-013daf6194ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:34:51
8531	9d52ed00-b755-47dd-9c37-7f2aec2e0303	9d52ed00-c025-4eb2-b886-013daf6194ea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"147.55","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:34:51
8532	9d52ed00-b7e6-4b30-b692-16615f6ced00	9d52ed00-c025-4eb2-b886-013daf6194ea	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:34:51
8533	9d52ed00-beb6-49b1-96be-15a80991d5d9	9d52ed00-c025-4eb2-b886-013daf6194ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:34:51
8534	9d52ed00-bf1d-419f-ae11-cb37615c63d0	9d52ed00-c025-4eb2-b886-013daf6194ea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":390,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:34:51
10424	9d56cf89-d4b3-408a-8f4a-e90d93950ef2	9d56cf89-d5bb-458e-92bc-e924364a1ba2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":355,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:55:46
10498	9d570e89-7a0e-4068-928d-7eab883f6f62	9d570e89-e29b-4691-9d42-647b8fccc0fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 14:51:56
10499	9d570e89-a769-48e7-8940-c144117ca8b9	9d570e89-e29b-4691-9d42-647b8fccc0fc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"68.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 14:51:56
10500	9d570e89-a7e0-4233-a8c8-605c2007e49f	9d570e89-e29b-4691-9d42-647b8fccc0fc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 14:51:56
10501	9d570e89-e07d-477f-81a4-1f20511e1123	9d570e89-e29b-4691-9d42-647b8fccc0fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 14:51:56
10502	9d570e89-e128-4561-9c4a-469e16ecb092	9d570e89-e29b-4691-9d42-647b8fccc0fc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":709,"memory":22,"hostname":"EderCortes"}	2024-10-26 14:51:56
5782	9d524cc4-a731-45cc-a5fb-d1fc2e023ef3	9d524cc4-ab1b-4f61-bf10-926c8d2b53bd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":148,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:06:48
8536	9d52ed01-1927-47da-9b24-169429a4dfb5	9d52ed01-29f4-4eb2-8ffd-8985efc62b94	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:34:51
8537	9d52ed01-2860-411c-bdcb-830e83de1d74	9d52ed01-29f4-4eb2-8ffd-8985efc62b94	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:34:51
8538	9d52ed01-28fb-478c-bad7-575d391b94ef	9d52ed01-29f4-4eb2-8ffd-8985efc62b94	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"Cannot use object of type Illuminate\\\\Database\\\\Eloquent\\\\Builder as array","exception":"Error","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":170,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"edit","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:34:51
8535	9d52ed01-2728-4330-847b-f4d9b3f7e464	9d52ed01-29f4-4eb2-8ffd-8985efc62b94	11c76a5de2830fc2f59ae572481c145d	f	exception	{"class":"Error","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":170,"message":"Cannot use object of type Illuminate\\\\Database\\\\Eloquent\\\\Builder as array","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"161":"     * Show the form for editing the specified resource.","162":"     *\\/","163":"    public function edit(string $id)","164":"    {","165":"","166":"        $data = Loans::where('id', $id)->orderBy('id')->orderBy('id', 'DESC');","167":"        $item = ItemLoans::where('loans_codigo', $id)->orderBy('id', 'ASC');","168":"","169":"        return response()->json([","170":"            \\"result\\" => [\\"data\\" =>$data[0], \\"items\\" => $item],","171":"        ]);","172":"    }","173":"","174":"    \\/**","175":"     * Update the specified resource in storage.","176":"     *\\/","177":"    public function update(Request $request, string $id)","178":"    {","179":"        \\/\\/","180":"    }"},"hostname":"EderCortes","occurrences":1}	2024-10-24 13:34:51
8539	9d52ed03-1d84-42d1-8f06-d7b4c7cc07da	9d52ed03-675a-48b4-80bf-5e18eb4aaf0b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:34:52
8540	9d52ed03-5ed9-4020-b39c-1495caf6ffd0	9d52ed03-675a-48b4-80bf-5e18eb4aaf0b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"147.70","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:34:53
8541	9d52ed03-5f60-468d-8389-85d645a2943d	9d52ed03-675a-48b4-80bf-5e18eb4aaf0b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:34:53
8542	9d52ed03-65d3-4c1b-bb5b-43f3a0916cd2	9d52ed03-675a-48b4-80bf-5e18eb4aaf0b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:34:53
8543	9d52ed03-662d-4f57-ad73-f0dc8352bc57	9d52ed03-675a-48b4-80bf-5e18eb4aaf0b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":392,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:34:53
10571	9d57108a-ab29-4ad6-a3f3-6513156e988f	9d57108a-cb38-4d0b-a61c-4a5edbc4e7e9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 14:57:32
10572	9d57108a-c941-47cd-bb0e-dbd6c638f838	9d57108a-cb38-4d0b-a61c-4a5edbc4e7e9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 14:57:32
10573	9d57108a-c9df-4269-aefa-60e8afeb6f35	9d57108a-cb38-4d0b-a61c-4a5edbc4e7e9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":288,"memory":22,"hostname":"EderCortes"}	2024-10-26 14:57:32
5788	9d524cdf-33cf-4c01-aa0d-a22b1e4d4dfb	9d524cdf-37ca-4563-9bdc-616bbb90e05c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":213,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:07:05
8544	9d52ed03-bcd2-4b36-a268-b06d9cc37257	9d52ed03-bf64-49c2-a819-b50d6616c4fa	11c76a5de2830fc2f59ae572481c145d	t	exception	{"class":"Error","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":170,"message":"Cannot use object of type Illuminate\\\\Database\\\\Eloquent\\\\Builder as array","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"161":"     * Show the form for editing the specified resource.","162":"     *\\/","163":"    public function edit(string $id)","164":"    {","165":"","166":"        $data = Loans::where('id', $id)->orderBy('id')->orderBy('id', 'DESC');","167":"        $item = ItemLoans::where('loans_codigo', $id)->orderBy('id', 'ASC');","168":"","169":"        return response()->json([","170":"            \\"result\\" => [\\"data\\" =>$data[0], \\"items\\" => $item],","171":"        ]);","172":"    }","173":"","174":"    \\/**","175":"     * Update the specified resource in storage.","176":"     *\\/","177":"    public function update(Request $request, string $id)","178":"    {","179":"        \\/\\/","180":"    }"},"hostname":"EderCortes","occurrences":2}	2024-10-24 13:34:53
8545	9d52ed03-b256-40c2-9810-aa85dec4b793	9d52ed03-bf64-49c2-a819-b50d6616c4fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:34:53
8546	9d52ed03-be09-4c66-a365-bb9d7280713c	9d52ed03-bf64-49c2-a819-b50d6616c4fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:34:53
8547	9d52ed03-be7d-46ce-8a42-a0e928aa992f	9d52ed03-bf64-49c2-a819-b50d6616c4fa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"Cannot use object of type Illuminate\\\\Database\\\\Eloquent\\\\Builder as array","exception":"Error","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":170,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"edit","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":209,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:34:53
10574	9d57108b-176d-43b6-8ad8-dae18a622925	9d57108b-6140-4f53-ac87-5ef6a1f0b8d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 14:57:32
10575	9d57108b-5842-4999-b220-2f51f5d4f6c7	9d57108b-6140-4f53-ac87-5ef6a1f0b8d0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"151.33","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 14:57:32
10576	9d57108b-5bba-4da3-8a0a-721276bf93c2	9d57108b-6140-4f53-ac87-5ef6a1f0b8d0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '5' order by \\"item_loans\\".\\"id\\" asc","time":"1.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-26 14:57:32
10577	9d57108b-5bea-4ab2-b22a-205e95dfcdb1	9d57108b-6140-4f53-ac87-5ef6a1f0b8d0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-26 14:57:32
10578	9d57108b-5fc2-4586-bf3f-3abb48f53d4e	9d57108b-6140-4f53-ac87-5ef6a1f0b8d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 14:57:32
10579	9d57108b-600d-4414-9fd3-775902408c33	9d57108b-6140-4f53-ac87-5ef6a1f0b8d0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":25,"loans_codigo":5,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":26,"loans_codigo":5,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":27,"loans_codigo":5,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":28,"loans_codigo":5,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":29,"loans_codigo":5,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":30,"loans_codigo":5,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null}]}},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-10-26 14:57:32
5795	9d524d23-5c83-46ef-9314-c803c6d1ceae	9d524d23-61bb-40b7-8fcb-c1c0d623ca59	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":194,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:07:50
10580	9d57108c-9208-42d2-ac38-c680e7aa0b4f	9d57108c-dac3-475d-ba57-eaf71788b215	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 14:57:33
10581	9d57108c-d5df-43f0-b0df-20d290837cf7	9d57108c-dac3-475d-ba57-eaf71788b215	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"151.19","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 14:57:33
10582	9d57108c-d63c-4746-9014-8b9f263f30f3	9d57108c-dac3-475d-ba57-eaf71788b215	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 14:57:33
10583	9d57108c-d97b-4da0-96c6-3179c6eff0c1	9d57108c-dac3-475d-ba57-eaf71788b215	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 14:57:33
10584	9d57108c-d9c1-4578-b146-b0511f0f3f36	9d57108c-dac3-475d-ba57-eaf71788b215	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":465,"memory":22,"hostname":"EderCortes"}	2024-10-26 14:57:33
8665	9d52ee61-5d94-4b6f-b36a-87711fc1e511	9d52ee61-7a37-46f8-b651-d4d63ba1ea70	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:38:42
8666	9d52ee61-7874-4e7c-a071-c693950dbf65	9d52ee61-7a37-46f8-b651-d4d63ba1ea70	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:38:42
8667	9d52ee61-793c-4608-99de-ca41a5499707	9d52ee61-7a37-46f8-b651-d4d63ba1ea70	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:38:42
5801	9d524d3d-59b9-4cd9-9845-eecebef2e1fe	9d524d3d-5da8-44b1-b3ec-552146f55ea1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":198,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:08:07
8668	9d52ee61-c195-4ba0-8e64-cfbeee9307f1	9d52ee61-df26-4150-8cda-b2aac45ef241	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:38:42
7232	9d52dc3c-c22a-4478-a3d0-d007feffe389	9d52dc3c-eee0-4205-9c83-c35ccafd1eca	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 12:47:58
7233	9d52dc3c-ebf4-46fa-8850-bb93a5b3c423	9d52dc3c-eee0-4205-9c83-c35ccafd1eca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:47:58
7234	9d52dc3c-ed6a-44bf-90b6-e4c51f993d66	9d52dc3c-eee0-4205-9c83-c35ccafd1eca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":392,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:47:58
8669	9d52ee61-da42-49f5-9c5b-db665b88396f	9d52ee61-df26-4150-8cda-b2aac45ef241	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:38:42
8670	9d52ee61-daa0-4bd6-a375-808010756c71	9d52ee61-df26-4150-8cda-b2aac45ef241	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:38:42
8671	9d52ee61-de0c-42b8-a2f8-92fee83de7c2	9d52ee61-df26-4150-8cda-b2aac45ef241	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:38:42
8672	9d52ee61-de50-41ca-ac40-be1ba7cef9c1	9d52ee61-df26-4150-8cda-b2aac45ef241	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:38:42
7235	9d52dc3d-5d8b-4f43-929d-0ab61318f2c0	9d52dc3d-ae60-4456-8ed0-6cf9c3e6d415	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:47:58
7236	9d52dc3d-a762-4573-ab95-bfde4abf1bfe	9d52dc3d-ae60-4456-8ed0-6cf9c3e6d415	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"158.58","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:47:59
7237	9d52dc3d-a7c6-446b-a325-b30efb2c6fb1	9d52dc3d-ae60-4456-8ed0-6cf9c3e6d415	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:47:59
7238	9d52dc3d-ad05-4cc1-937e-c1702b579702	9d52dc3d-ae60-4456-8ed0-6cf9c3e6d415	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:47:59
7239	9d52dc3d-ad5a-4c03-807f-9738a038394e	9d52dc3d-ae60-4456-8ed0-6cf9c3e6d415	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":456,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:47:59
8673	9d52ee62-2777-4a8b-a7bf-77c2da9974e2	9d52ee62-713b-475b-b7f1-bd66be601860	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:38:42
8674	9d52ee62-6be0-4d8b-b2f0-a208cf3d9e3a	9d52ee62-713b-475b-b7f1-bd66be601860	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"149.71","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:38:43
8675	9d52ee62-6c30-4057-861c-de44e78f14c7	9d52ee62-713b-475b-b7f1-bd66be601860	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:38:43
8676	9d52ee62-7000-42d1-ab39-f4be5b4257c2	9d52ee62-713b-475b-b7f1-bd66be601860	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:38:43
8677	9d52ee62-7049-477c-82dc-32a948e8e46c	9d52ee62-713b-475b-b7f1-bd66be601860	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":355,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:38:43
5807	9d524d4e-56a1-4547-bb23-4a70ef1dd4d5	9d524d4e-5a62-4cdf-8dd3-f93c0e2ee67c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":177,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:08:18
7240	9d52dc3e-0522-4990-995c-1bdffbc5b68e	9d52dc3e-2ab5-42b5-a7bc-1b6b77e8fdf1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:47:59
7241	9d52dc3e-2488-4c4f-8298-ea5238e9b11a	9d52dc3e-2ab5-42b5-a7bc-1b6b77e8fdf1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:47:59
7242	9d52dc3e-24ed-43f7-802f-c76e75653890	9d52dc3e-2ab5-42b5-a7bc-1b6b77e8fdf1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:47:59
7243	9d52dc3e-292e-4326-b192-149650c19f4e	9d52dc3e-2ab5-42b5-a7bc-1b6b77e8fdf1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:47:59
7244	9d52dc3e-2985-4061-bba5-c951ba6183c3	9d52dc3e-2ab5-42b5-a7bc-1b6b77e8fdf1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":301,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:47:59
8678	9d52ee62-b720-4fcd-a6ce-1d31e92b77cd	9d52ee62-c219-451b-a918-223feb6b6f44	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:38:43
8679	9d52ee62-c0a6-4064-b86c-3c9c5d5ee414	9d52ee62-c219-451b-a918-223feb6b6f44	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:38:43
8680	9d52ee62-c0eb-482c-9f9c-6538f6ec1cff	9d52ee62-c219-451b-a918-223feb6b6f44	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[],"item":[]},"duration":191,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:38:43
35045	9d69c169-bb56-49cf-bac5-0aec595a6e44	9d69c169-bc40-464a-adbc-60712e55eaf0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:57:00
7245	9d52dc3e-8650-40b3-a308-3935908bf67b	9d52dc3e-abeb-4249-b0f0-fa2dccb0074d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:47:59
7246	9d52dc3e-a34b-4e90-8027-e4575a81f029	9d52dc3e-abeb-4249-b0f0-fa2dccb0074d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"51.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:47:59
7247	9d52dc3e-a3a6-4f4e-b6c1-99379c5b44bc	9d52dc3e-abeb-4249-b0f0-fa2dccb0074d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:47:59
7248	9d52dc3e-a57c-4f9f-a2fd-8898b515d5dc	9d52dc3e-abeb-4249-b0f0-fa2dccb0074d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"2.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:47:59
7249	9d52dc3e-a5af-4af4-b372-0404ae6128f0	9d52dc3e-abeb-4249-b0f0-fa2dccb0074d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:47:59
7250	9d52dc3e-aa84-4f66-bc49-8d87ee308492	9d52dc3e-abeb-4249-b0f0-fa2dccb0074d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:47:59
7251	9d52dc3e-aae9-4eea-aa4b-da684f516aea	9d52dc3e-abeb-4249-b0f0-fa2dccb0074d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":307,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:47:59
8681	9d52ee64-339c-4901-96d5-e79d37791aa1	9d52ee64-5b31-40df-b406-91aaf4deae82	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:38:44
8682	9d52ee64-552f-45a0-a302-4dc312f4abdd	9d52ee64-5b31-40df-b406-91aaf4deae82	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:38:44
8683	9d52ee64-558b-4a28-8014-14b3ce7afdbe	9d52ee64-5b31-40df-b406-91aaf4deae82	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:38:44
8684	9d52ee64-59e8-457d-9d17-633c6e78b6a9	9d52ee64-5b31-40df-b406-91aaf4deae82	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 13:38:44
8685	9d52ee64-5a31-4d92-b2b0-66e19594bc6f	9d52ee64-5b31-40df-b406-91aaf4deae82	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":474,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:38:44
35046	9d69c16a-0533-4211-914b-fd69bb408fa8	9d69c16a-4b2a-4ebf-bc09-831b2ab154f7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 21:57:00
35047	9d69c16a-4626-4273-9bd7-fadd072e40ba	9d69c16a-4b2a-4ebf-bc09-831b2ab154f7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"143.01","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:57:00
35048	9d69c16a-4687-49da-80ab-fffd7892823a	9d69c16a-4b2a-4ebf-bc09-831b2ab154f7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:57:00
35049	9d69c16a-4a01-4d8f-8e40-d15cea508cd8	9d69c16a-4b2a-4ebf-bc09-831b2ab154f7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 21:57:00
35050	9d69c16a-4a4c-476d-8efa-b69aee8a9b05	9d69c16a-4b2a-4ebf-bc09-831b2ab154f7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:57:00
5813	9d524d81-8064-496b-8d40-5857a3f94e13	9d524d81-8be6-4200-85ed-ccca0a6d829c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":397,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:08:52
7252	9d52dc41-2d8c-48d4-97c8-c0079f7714df	9d52dc41-6704-4183-aa5a-847aa855ae60	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:48:01
7253	9d52dc41-5d62-4ccc-b97f-3d433e622fb5	9d52dc41-6704-4183-aa5a-847aa855ae60	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"75.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:48:01
7254	9d52dc41-5de1-4112-8775-2b641ababc50	9d52dc41-6704-4183-aa5a-847aa855ae60	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:48:01
7255	9d52dc41-64a8-4e7f-a336-b52c40f5a42c	9d52dc41-6704-4183-aa5a-847aa855ae60	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:48:01
7256	9d52dc41-652d-4406-a550-7a6ecd294a88	9d52dc41-6704-4183-aa5a-847aa855ae60	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":663,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:48:01
10656	9d5712de-55fc-4995-a3f5-6ae3eb97ee14	9d5712de-74e5-40d5-bd6f-6e12e5617ad4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 15:04:02
10657	9d5712de-730c-4b6f-9ffe-69ef33841176	9d5712de-74e5-40d5-bd6f-6e12e5617ad4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 15:04:02
10658	9d5712de-739d-4749-b2cf-a2a772cf9d01	9d5712de-74e5-40d5-bd6f-6e12e5617ad4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":269,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:04:02
5819	9d524dae-d462-4d1d-810d-4fe618cb9d37	9d524dae-d9da-4bbe-94e7-40e95e9bc621	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":191,"memory":18,"hostname":"EderCortes"}	2024-10-24 06:09:21
10659	9d5712de-c4a8-4525-9011-28d4b86f2f30	9d5712df-0c80-4ef8-adb8-87d13b8584ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 15:04:03
10660	9d5712df-0296-4ad9-89e1-55726a037af0	9d5712df-0c80-4ef8-adb8-87d13b8584ea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"143.54","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 15:04:03
10661	9d5712df-06b1-4cf0-a9b5-223e3e985d7e	9d5712df-0c80-4ef8-adb8-87d13b8584ea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '5' order by \\"item_loans\\".\\"id\\" asc","time":"2.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-26 15:04:03
10662	9d5712df-06f7-485b-8a01-17c80eb0e3ed	9d5712df-0c80-4ef8-adb8-87d13b8584ea	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-26 15:04:03
10663	9d5712df-0b0a-4bfe-82e1-291fc1638672	9d5712df-0c80-4ef8-adb8-87d13b8584ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 15:04:03
10664	9d5712df-0b73-45e8-ae58-59284c97517a	9d5712df-0c80-4ef8-adb8-87d13b8584ea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":25,"loans_codigo":5,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":26,"loans_codigo":5,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":27,"loans_codigo":5,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":28,"loans_codigo":5,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":29,"loans_codigo":5,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":30,"loans_codigo":5,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null}]}},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:04:03
10665	9d5712e0-b52b-4cd4-8afc-6308456980c5	9d5712e0-d4a6-41ad-baee-187eaa87604b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 15:04:04
10666	9d5712e0-ceb9-42d1-9902-ad3303169a86	9d5712e0-d4a6-41ad-baee-187eaa87604b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 15:04:04
10667	9d5712e0-cf0a-4b50-ae7d-5aefd46e5110	9d5712e0-d4a6-41ad-baee-187eaa87604b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 15:04:04
10668	9d5712e0-d334-445b-9007-4849abaca78b	9d5712e0-d4a6-41ad-baee-187eaa87604b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 15:04:04
10669	9d5712e0-d379-4365-bf59-39963e7e5165	9d5712e0-d4a6-41ad-baee-187eaa87604b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:04:04
5825	9d524e23-43e1-46b0-931b-4eccda08ab6a	9d524e23-4781-4283-99a2-2a38a9776a15	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":176,"memory":18,"hostname":"EderCortes"}	2024-10-24 06:10:38
7388	9d52dd32-faaa-40ac-b33f-e867bc9891a9	9d52dd33-1a43-49da-b95a-28d326f47153	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 12:50:39
7389	9d52dd33-1898-4273-9116-476aafdb96ac	9d52dd33-1a43-49da-b95a-28d326f47153	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-24 12:50:39
7390	9d52dd33-194b-4bf8-90bb-4b81f39218ba	9d52dd33-1a43-49da-b95a-28d326f47153	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:50:39
7391	9d52dd33-6b4e-4b50-8050-004794e4a7da	9d52dd33-8d7c-4df3-a453-1596e0657a22	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-24 12:50:40
7392	9d52dd33-8724-42f7-b18c-210b7db1b664	9d52dd33-8d7c-4df3-a453-1596e0657a22	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:50:40
7393	9d52dd33-8774-42f8-9325-9ea25fa6b647	9d52dd33-8d7c-4df3-a453-1596e0657a22	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:50:40
7394	9d52dd33-8bab-429c-a3b6-e668430d6248	9d52dd33-8d7c-4df3-a453-1596e0657a22	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-24 12:50:40
7395	9d52dd33-8c23-4bfe-895d-377b2bb43148	9d52dd33-8d7c-4df3-a453-1596e0657a22	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:50:40
5831	9d524ec1-1dee-48dc-91f4-ef4efb06a0e4	9d524ec1-23ad-40e0-b2f7-54fd5933c782	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":211,"memory":18,"hostname":"EderCortes"}	2024-10-24 06:12:21
7396	9d52dd33-dfc0-414b-862b-0b95c6141227	9d52dd33-ffd7-4796-82b3-f6cc1f87e226	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-24 12:50:40
7397	9d52dd33-fa54-4dde-a8a4-baaeaed70b1e	9d52dd33-ffd7-4796-82b3-f6cc1f87e226	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:50:40
7398	9d52dd33-fabf-4287-b643-1be07380b42e	9d52dd33-ffd7-4796-82b3-f6cc1f87e226	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:50:40
7399	9d52dd33-fe97-4f3f-9e2b-5353997e4861	9d52dd33-ffd7-4796-82b3-f6cc1f87e226	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-24 12:50:40
7400	9d52dd33-fed8-4a7c-88fa-76d82f91cf58	9d52dd33-ffd7-4796-82b3-f6cc1f87e226	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:50:40
25922	9d68cb52-0e04-4216-8051-65bd0d301698	9d68cb52-13b9-466c-a3a6-be961e4bc805	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1195}	2024-11-04 10:28:53
10761	9d5720fb-3eb5-48f4-ad45-dc8624dff4bb	9d5720fb-662c-4bb0-ae7f-a540c5619214	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 15:43:30
10762	9d5720fb-63b1-40f7-83f2-91d3d5c3ac1d	9d5720fb-662c-4bb0-ae7f-a540c5619214	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 15:43:30
10763	9d5720fb-649e-4207-84ab-b2c575de8e06	9d5720fb-662c-4bb0-ae7f-a540c5619214	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":323,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:43:30
10839	9d5ca433-4114-4c0c-abee-a740b4563c42	9d5ca433-5ecb-4e28-8c69-84cad5ac3971	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 09:29:33
10840	9d5ca433-5d22-4198-8ec6-60ff4ed5d09b	9d5ca433-5ecb-4e28-8c69-84cad5ac3971	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 09:29:33
7401	9d52dd34-4c1f-4ba0-a341-aa8d1ffc83fa	9d52dd34-6f6d-4120-85d2-a32969e1ab10	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-24 12:50:40
7402	9d52dd34-665d-48d7-beac-e97fd58de7ea	9d52dd34-6f6d-4120-85d2-a32969e1ab10	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"45.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:50:40
7403	9d52dd34-66c7-434e-9b9a-ec8d151de4fa	9d52dd34-6f6d-4120-85d2-a32969e1ab10	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:50:40
7404	9d52dd34-691d-41f8-81eb-fba6ada4d25d	9d52dd34-6f6d-4120-85d2-a32969e1ab10	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"2.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:50:40
7405	9d52dd34-6963-4fc2-a9bc-9f165614646f	9d52dd34-6f6d-4120-85d2-a32969e1ab10	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:50:40
7406	9d52dd34-6d92-4d8c-bb68-8b0a77425f49	9d52dd34-6f6d-4120-85d2-a32969e1ab10	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-24 12:50:40
7407	9d52dd34-6dfd-4021-93e4-f9ab96bba7a2	9d52dd34-6f6d-4120-85d2-a32969e1ab10	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":271,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:50:40
10764	9d5720fb-d002-4752-9a70-6e5dc32d041b	9d5720fb-f134-40ff-a519-71ffff77fe5f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 15:43:30
10765	9d5720fb-eb55-40f3-894c-d86bc075f6cd	9d5720fb-f134-40ff-a519-71ffff77fe5f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"53.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-26 15:43:30
10766	9d5720fb-eff6-4407-9904-c272cb32c3c2	9d5720fb-f134-40ff-a519-71ffff77fe5f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 15:43:30
10767	9d5720fb-f049-40f2-9810-db69326b760e	9d5720fb-f134-40ff-a519-71ffff77fe5f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":319,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:43:30
10841	9d5ca433-5dc2-4fae-8cbb-48964200ae40	9d5ca433-5ecb-4e28-8c69-84cad5ac3971	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:29:33
5837	9d524f4c-30e9-42a0-b720-2dc030a7ae33	9d524f4c-34d9-45c9-b979-24580aa9746b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":192,"memory":18,"hostname":"EderCortes"}	2024-10-24 06:13:52
7408	9d52dd35-db7c-4001-bc00-cee8d4a8d550	9d52dd36-1c9f-4e45-8901-abe68d442d50	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-24 12:50:41
7409	9d52dd36-1205-4a56-ac0f-e9f5810db059	9d52dd36-1c9f-4e45-8901-abe68d442d50	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"79.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:50:41
7410	9d52dd36-128d-40b3-98d5-0aae897224be	9d52dd36-1c9f-4e45-8901-abe68d442d50	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:50:41
7411	9d52dd36-1a99-46b8-9611-f798b6b83c04	9d52dd36-1c9f-4e45-8901-abe68d442d50	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-24 12:50:41
7412	9d52dd36-1b15-45d0-8b2e-9aaf860dda7a	9d52dd36-1c9f-4e45-8901-abe68d442d50	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":556,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:50:41
8837	9d52ef61-98c7-4635-b35a-14cce046626a	9d52ef61-de4f-4b77-8905-42c2d83e9ea1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 13:41:30
8838	9d52ef61-dcd1-459a-a884-864ec3a172a9	9d52ef61-de4f-4b77-8905-42c2d83e9ea1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 13:41:30
8839	9d52ef61-dd65-4c2a-864a-32bfcba2be98	9d52ef61-de4f-4b77-8905-42c2d83e9ea1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":342,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:41:30
10768	9d5720fd-a20f-46cc-a3e3-c805ae6f1e01	9d5720fd-c137-4c25-9baa-7c13751e6e72	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 15:43:32
8840	9d52ef62-286f-47b1-a89a-fc6fc8d9222d	9d52ef62-722d-4f2b-a833-d513c26b9934	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 13:41:30
8841	9d52ef62-6d4b-47cb-8698-7580785322d0	9d52ef62-722d-4f2b-a833-d513c26b9934	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"155.67","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:41:30
8842	9d52ef62-6db4-49ac-a86e-4f9f204f01ef	9d52ef62-722d-4f2b-a833-d513c26b9934	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:41:30
8843	9d52ef62-7108-4812-bcc2-a918eba5b1a5	9d52ef62-722d-4f2b-a833-d513c26b9934	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 13:41:30
8844	9d52ef62-714e-4ac9-bca1-bb7181517b15	9d52ef62-722d-4f2b-a833-d513c26b9934	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":351,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:41:30
10769	9d5720fd-bbb1-47cf-8944-b1b2ce41c0a3	9d5720fd-c137-4c25-9baa-7c13751e6e72	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 15:43:32
10770	9d5720fd-bc0c-4099-9c7f-0048d21796d6	9d5720fd-c137-4c25-9baa-7c13751e6e72	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 15:43:32
10771	9d5720fd-bf99-4188-9c7c-29e7fa739f17	9d5720fd-c137-4c25-9baa-7c13751e6e72	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 15:43:32
10772	9d5720fd-bfde-4a40-8719-1494d16173f9	9d5720fd-c137-4c25-9baa-7c13751e6e72	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":451,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:43:32
10842	9d5ca433-a787-473e-9208-bfb5bdcb4d7e	9d5ca433-c3ca-4784-865c-5665a24e12e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 09:29:34
10843	9d5ca433-beaa-444a-b95d-6fd05f6e4604	9d5ca433-c3ca-4784-865c-5665a24e12e1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"40.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-29 09:29:34
10844	9d5ca433-bef7-43da-98f3-6e93b9507807	9d5ca433-c3ca-4784-865c-5665a24e12e1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-10-29 09:29:34
10845	9d5ca433-c283-4d0a-9916-4af0441eac11	9d5ca433-c3ca-4784-865c-5665a24e12e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 09:29:34
10846	9d5ca433-c2c7-4460-a256-5390d503fd8f	9d5ca433-c3ca-4784-865c-5665a24e12e1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":223,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:29:34
5843	9d524f6b-9d22-409e-baa9-3191c7a13a09	9d524f6b-a083-48b8-bb64-0751cba28887	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":183,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:14:13
8845	9d52ef62-b565-412c-8da8-ee240d7d3020	9d52ef62-d310-4d4e-b475-38c3eaf32685	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 13:41:31
8846	9d52ef62-cd81-4f2c-a091-fdab41563cc1	9d52ef62-d310-4d4e-b475-38c3eaf32685	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:41:31
8847	9d52ef62-cdcf-4b64-8343-61d84987b260	9d52ef62-d310-4d4e-b475-38c3eaf32685	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:41:31
8848	9d52ef62-d1bb-4eab-8adb-a57b0208f9c4	9d52ef62-d310-4d4e-b475-38c3eaf32685	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 13:41:31
8849	9d52ef62-d213-464c-8f6a-6bb8d356f12f	9d52ef62-d310-4d4e-b475-38c3eaf32685	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:41:31
10847	9d5ca435-380e-47f3-9d27-1063a4b3075b	9d5ca435-7d95-4af7-baa1-fab6a7bbd0b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 09:29:35
10848	9d5ca435-78d1-49c8-9fcf-18517154ef43	9d5ca435-7d95-4af7-baa1-fab6a7bbd0b3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"144.36","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 09:29:35
10849	9d5ca435-791b-4fa4-b9d7-cbef70ece12e	9d5ca435-7d95-4af7-baa1-fab6a7bbd0b3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 09:29:35
10850	9d5ca435-7c52-45d6-95d6-3a6babb85190	9d5ca435-7d95-4af7-baa1-fab6a7bbd0b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 09:29:35
10851	9d5ca435-7c98-48ae-a3a1-3b874541e3cf	9d5ca435-7d95-4af7-baa1-fab6a7bbd0b3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":501,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:29:35
8850	9d52ef63-1601-4c04-a158-8ac3d74db71d	9d52ef63-341f-4914-8efe-acef1d56073a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 13:41:31
8851	9d52ef63-2d31-4318-970b-d76b9b38b161	9d52ef63-341f-4914-8efe-acef1d56073a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"41.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-24 13:41:31
8852	9d52ef63-2d7e-4bb2-ab38-10b41e1835d0	9d52ef63-341f-4914-8efe-acef1d56073a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:41:31
8853	9d52ef63-2f00-47db-9c67-496b1cfe7927	9d52ef63-341f-4914-8efe-acef1d56073a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"1.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 13:41:31
5023	9d513666-8f43-4b82-a84e-c2dce0bc5ef9	9d513666-b320-4961-9064-46cfc9d09d0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":36,"hostname":"EderCortes"}	2024-10-23 17:08:26
5024	9d513666-b145-4dd1-9d73-9490a22e79fa	9d513666-b320-4961-9064-46cfc9d09d0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":37,"hostname":"EderCortes"}	2024-10-23 17:08:26
5025	9d513666-b21b-447c-a252-c2a4a3f37c16	9d513666-b320-4961-9064-46cfc9d09d0d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":321,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:26
8854	9d52ef63-2f35-42a0-b6c2-d3c8bdeb1914	9d52ef63-341f-4914-8efe-acef1d56073a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:41:31
8855	9d52ef63-3303-4a3a-bf80-4dc4e2e7d4e4	9d52ef63-341f-4914-8efe-acef1d56073a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 13:41:31
8856	9d52ef63-334e-4331-9ad0-3c6b3c4d942a	9d52ef63-341f-4914-8efe-acef1d56073a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":null,"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:41:31
10852	9d5ca43e-c8b0-4b1d-8909-61a7eba378bb	9d5ca43e-e139-46e4-a79c-f02e02d0bfdb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 09:29:41
10853	9d5ca43e-dd6a-4046-9d5e-eb081795b316	9d5ca43e-e139-46e4-a79c-f02e02d0bfdb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"42.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-29 09:29:41
10854	9d5ca43e-e01e-4e52-ada8-c21e24ec1028	9d5ca43e-e139-46e4-a79c-f02e02d0bfdb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 09:29:41
10855	9d5ca43e-e075-4f40-be26-54d6cc339ce9	9d5ca43e-e139-46e4-a79c-f02e02d0bfdb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:29:41
5849	9d524f8b-86fe-4b01-8278-7d046df5beb8	9d524f8b-8ae8-4afd-b8e1-db52ef48a89e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":157,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:14:34
8857	9d52ef64-ecdf-4691-837a-757da9018f9d	9d52ef65-3463-49d6-b2fd-b1253359f601	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 13:41:32
8858	9d52ef65-2fe2-4680-b8aa-e746acaa8407	9d52ef65-3463-49d6-b2fd-b1253359f601	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"145.91","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:41:32
8859	9d52ef65-302f-4688-a618-0923ca5c8a3c	9d52ef65-3463-49d6-b2fd-b1253359f601	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:41:32
8860	9d52ef65-3344-4fe9-a19b-d75e1285e734	9d52ef65-3463-49d6-b2fd-b1253359f601	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-24 13:41:32
8861	9d52ef65-3389-48e2-aa9d-ef1fef78a52c	9d52ef65-3463-49d6-b2fd-b1253359f601	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":435,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:41:32
7565	9d52df68-2abf-4e5a-96e5-dd8e2d9e9286	9d52df68-6e0f-476c-81bf-876e05d91bc4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 12:56:50
7566	9d52df68-6b75-4432-aa91-82caafd5701c	9d52df68-6e0f-476c-81bf-876e05d91bc4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-24 12:56:50
7567	9d52df68-6c7c-47a4-9096-5878d57a0d27	9d52df68-6e0f-476c-81bf-876e05d91bc4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":631,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:56:50
5856	9d524fcc-6533-43ee-9e39-ca0b37f0f959	9d524fcc-68cb-4c95-a891-c6c30e4bf376	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":154,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:15:16
7568	9d52df68-f3d6-4a3b-8ca9-c2e945c61321	9d52df69-4d8d-4796-b800-ed6b6b2f1c71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-24 12:56:50
7569	9d52df69-45a1-467a-a9de-85e163149492	9d52df69-4d8d-4796-b800-ed6b6b2f1c71	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"164.11","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:56:50
7570	9d52df69-462a-49a0-8436-a6613c596ea7	9d52df69-4d8d-4796-b800-ed6b6b2f1c71	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:56:50
7571	9d52df69-4b4d-4c37-8bae-ded4bbb09a8c	9d52df69-4d8d-4796-b800-ed6b6b2f1c71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-24 12:56:50
7572	9d52df69-4bd8-4df5-b517-765e54af8644	9d52df69-4d8d-4796-b800-ed6b6b2f1c71	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":523,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:56:50
7573	9d52df69-af1e-442c-8895-064562d3ead0	9d52df69-dcfc-49db-8e7d-c1ff0150e062	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-24 12:56:51
7574	9d52df69-d26c-42d6-b911-b982b01c20b2	9d52df69-dcfc-49db-8e7d-c1ff0150e062	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"64.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:56:51
7575	9d52df69-d2fd-4478-93ef-5c660c6b43f8	9d52df69-dcfc-49db-8e7d-c1ff0150e062	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:56:51
7576	9d52df69-dabc-478b-8044-f0626c5a4162	9d52df69-dcfc-49db-8e7d-c1ff0150e062	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-24 12:56:51
7577	9d52df69-db4d-4657-8e49-f27542df25e5	9d52df69-dcfc-49db-8e7d-c1ff0150e062	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":342,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:56:51
5863	9d524fef-85b1-4b9d-a5d0-f13fba50a1e3	9d524fef-8989-43c3-bddf-f2c4a3b8c660	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":200,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:15:39
7578	9d52df6a-27f1-422a-9205-44f069b11ba5	9d52df6a-467c-4295-9db0-a4d01b8d51ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-24 12:56:51
7579	9d52df6a-3fa7-41a5-b8ba-80bc3afefc43	9d52df6a-467c-4295-9db0-a4d01b8d51ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"42.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:56:51
7580	9d52df6a-3ff5-435a-ae83-0408a5ca7477	9d52df6a-467c-4295-9db0-a4d01b8d51ca	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:56:51
7581	9d52df6a-4165-4731-82e3-25d354247b7d	9d52df6a-467c-4295-9db0-a4d01b8d51ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"1.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:56:51
7582	9d52df6a-4197-4f5f-be73-1386a222552a	9d52df6a-467c-4295-9db0-a4d01b8d51ca	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:56:51
7583	9d52df6a-4507-45ea-8586-5df523365e7f	9d52df6a-467c-4295-9db0-a4d01b8d51ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-24 12:56:51
7584	9d52df6a-456e-4830-b71d-2799f9393a17	9d52df6a-467c-4295-9db0-a4d01b8d51ca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:56:51
15097	9d5ecee4-32d5-425a-b8f7-526aab02fa54	9d5ecee4-81bf-47e9-b285-e38fa58c6d46	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-30 11:20:35
15098	9d5ecee4-7f60-417b-82cf-c5fd06afa249	9d5ecee4-81bf-47e9-b285-e38fa58c6d46	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 11:20:35
15099	9d5ecee4-802a-4298-98c2-ec06a537542e	9d5ecee4-81bf-47e9-b285-e38fa58c6d46	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":479,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:20:35
7585	9d52df6b-ffe7-4a20-8c9a-3c23145a228f	9d52df6c-3025-46f4-a05c-2d23c6baba91	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-24 12:56:52
7586	9d52df6c-26cd-4b38-89e1-4bcb34f9350c	9d52df6c-3025-46f4-a05c-2d23c6baba91	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"65.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:56:52
7587	9d52df6c-2755-4ef9-aa4f-f1033ca56d29	9d52df6c-3025-46f4-a05c-2d23c6baba91	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:56:52
7588	9d52df6c-2e4e-4bdd-8e9b-44a7621062b9	9d52df6c-3025-46f4-a05c-2d23c6baba91	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-24 12:56:52
7589	9d52df6c-2ec1-4b60-bbac-62d77f3a7bf1	9d52df6c-3025-46f4-a05c-2d23c6baba91	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":505,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:56:52
41388	9d6ccc74-9179-492b-9d98-440277336d4a	9d6ccc74-9479-469d-b78e-1208c9547d43	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1898}	2024-11-06 10:15:22
5867	9d525010-9686-4d7a-81a8-210f5b839834	9d525010-9a1e-4c64-b937-06b30c133b40	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":159,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:16:01
6257	9d5263a6-c4fe-458d-bc05-7de4141869fb	9d5263a6-e826-4fc0-8308-c88fbb95f5ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 07:10:47
6258	9d5263a6-e554-4802-b2a5-09323a304602	9d5263a6-e826-4fc0-8308-c88fbb95f5ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 07:10:47
6259	9d5263a6-e681-453d-8d6d-5a7516aa91bd	9d5263a6-e826-4fc0-8308-c88fbb95f5ca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abfrom\\u00bb\\nLINE 14:     from loans l\\n             ^ (Connection: pgsql, SQL: \\n    select l.id,\\n        l.loans_documento,\\n        l.loans_nombre,\\n        l.loans_apellido_uno,\\n        l.loans_fecha,\\n        l.loans_valor_prestado,\\n        l.loans_cuotas,\\n        l.loans_estado,\\n        l.loans_intereses,\\n        ucl.name as cliente,\\n        uco.name as cobrador,\\n        ure.name as recomendador,\\n    from loans l\\n    join users ucl on l.user_customer = ucl.id\\n    join users uco on l.user_cobrador = uco.id\\n    left join users ure on l.user_recomendacion = ure.id\\n)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":370,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:10:47
15269	9d5ecf7f-bbcf-4fca-9e24-a8283c555bac	9d5ecf7f-e2c2-430f-a185-c9dbd467b970	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-30 11:22:17
15270	9d5ecf7f-e062-4659-973d-6a66e952ce8d	9d5ecf7f-e2c2-430f-a185-c9dbd467b970	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-30 11:22:17
15271	9d5ecf7f-e192-4b58-894d-50cb1a322e47	9d5ecf7f-e2c2-430f-a185-c9dbd467b970	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":342,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:22:17
5872	9d525025-e51a-4b1e-a2c7-c1153e7c670c	9d525025-e8c5-462b-8f02-1d6f5a1dd681	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":161,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:16:15
6260	9d5263a9-207a-4651-bd30-e9b33c5873d9	9d5263a9-601a-4120-b32e-d6f4e6730c8a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 07:10:49
6261	9d5263a9-528d-4f11-8cb1-4b437b3e6dda	9d5263a9-601a-4120-b32e-d6f4e6730c8a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"90.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 07:10:49
6262	9d5263a9-533a-4b3f-b5c7-cf57aecc7cb3	9d5263a9-601a-4120-b32e-d6f4e6730c8a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 07:10:49
6197	9d5261e1-6e91-4298-958a-fd767d3b100a	9d5261e1-98cf-424e-94dd-de44330f8edb	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 07:05:50
6198	9d5261e1-9654-4b8f-91c5-8f59ed118579	9d5261e1-98cf-424e-94dd-de44330f8edb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 07:05:50
6199	9d5261e1-978b-497a-9690-5a5922412127	9d5261e1-98cf-424e-94dd-de44330f8edb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":351,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:05:50
6263	9d5263a9-5e57-40e1-9bfc-2193c4aba693	9d5263a9-601a-4120-b32e-d6f4e6730c8a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 07:10:49
6264	9d5263a9-5eb9-4eea-a428-9976d4b8cc46	9d5263a9-601a-4120-b32e-d6f4e6730c8a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":540,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:10:49
15272	9d5ecf80-3f90-4cd5-a1a5-7ccd5fe1ab8c	9d5ecf80-6225-4dbb-a183-620a20cc25f7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-30 11:22:17
15273	9d5ecf80-5c5c-4701-9192-d03fe5e272ca	9d5ecf80-6225-4dbb-a183-620a20cc25f7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 11:22:17
15274	9d5ecf80-5cc4-46e1-8363-8805f9a76992	9d5ecf80-6225-4dbb-a183-620a20cc25f7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-30 11:22:17
15275	9d5ecf80-60d9-4ed1-bf1f-a4e45d65545b	9d5ecf80-6225-4dbb-a183-620a20cc25f7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-30 11:22:17
15276	9d5ecf80-6122-4ec9-ba1e-47917dbc162e	9d5ecf80-6225-4dbb-a183-620a20cc25f7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":274,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:22:17
6200	9d5261e1-f194-403a-bbfc-7779d32a9372	9d5261e2-37e9-49bc-86f4-7b3ebbb0f9a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 07:05:50
6201	9d5261e2-32a3-4693-b491-0aa20aed2a37	9d5261e2-37e9-49bc-86f4-7b3ebbb0f9a2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n    select l.id,\\n        l.loans_documento,\\n        l.loans_nombre,\\n        l.loans_apellido_uno,\\n        l.loans_fecha,\\n        l.loans_valor_prestado,\\n        l.loans_cuotas,\\n        loans_intereses,\\n        ucl.name as cliente,\\n        uco.name as cobrador,\\n        ure.name as recomendador\\n    from loans l\\n    join users ucl on l.user_customer = ucl.id\\n    join users uco on l.user_cobrador = uco.id\\n    left join users ure on l.user_recomendacion = ure.id\\n","time":"151.66","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23,"hash":"4a29eecc7f0e29116a12840a44c5fe9b","hostname":"EderCortes"}	2024-10-24 07:05:50
6202	9d5261e2-36a9-4cc0-86bd-8e80053dea4c	9d5261e2-37e9-49bc-86f4-7b3ebbb0f9a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 07:05:50
6203	9d5261e2-36f7-40e6-b4cf-b7108394189c	9d5261e2-37e9-49bc-86f4-7b3ebbb0f9a2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_intereses":25,"cliente":"Luis andre","cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_intereses":25,"cliente":"Luis andre","cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_intereses":25,"cliente":"Luis andre","cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_intereses":25,"cliente":"Luis andre","cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_intereses":25,"cliente":"Luis andre","cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_intereses":25,"cliente":"Luis andre","cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_intereses":25,"cliente":"Luis andre","cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_intereses":25,"cliente":"Luis andre","cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_intereses":25,"cliente":"Luis andre","cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_intereses":25,"cliente":"Luis andre","cobrador":"Luis andre","recomendador":null}]},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:05:50
6696	9d52d4ce-956c-43f4-9914-14bc135ea1cf	9d52d4ce-b9b8-4ff4-8d37-a339e2355c45	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 12:27:11
6697	9d52d4ce-b7d3-4e49-9641-7b54e2d4884d	9d52d4ce-b9b8-4ff4-8d37-a339e2355c45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:27:11
6698	9d52d4ce-b898-4d12-8a47-c6eaace8e059	9d52d4ce-b9b8-4ff4-8d37-a339e2355c45	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":293,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:27:11
15277	9d5ecf80-a9f8-425d-87cc-638d968f9b82	9d5ecf80-d1e3-4422-b2c6-3a26c4b09f33	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-30 11:22:18
15278	9d5ecf80-cc62-4218-8386-bf0a32167450	9d5ecf80-d1e3-4422-b2c6-3a26c4b09f33	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"53.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 11:22:18
15279	9d5ecf80-ccd0-472b-9dbf-dc98ad20015e	9d5ecf80-d1e3-4422-b2c6-3a26c4b09f33	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-30 11:22:18
15280	9d5ecf80-d0bf-4727-b62b-759d1344228d	9d5ecf80-d1e3-4422-b2c6-3a26c4b09f33	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-10-30 11:22:18
5876	9d525049-ca8f-432d-8d5f-fe3521f16bb3	9d525049-cdd6-4b58-9912-4f2150586b8e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":152,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:16:38
6204	9d5261e4-3d23-4f7d-bd73-15f74732f1a5	9d5261e4-5c18-4a51-a345-c4493bed7140	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 07:05:52
6205	9d5261e4-56f4-4162-94b0-c5a822583c83	9d5261e4-5c18-4a51-a345-c4493bed7140	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 07:05:52
6206	9d5261e4-5744-4793-8174-b9470eaaa4df	9d5261e4-5c18-4a51-a345-c4493bed7140	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 07:05:52
6207	9d5261e4-5ad8-43af-8db7-024afb369705	9d5261e4-5c18-4a51-a345-c4493bed7140	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 07:05:52
6208	9d5261e4-5b21-4638-a826-b84d9b90410f	9d5261e4-5c18-4a51-a345-c4493bed7140	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":314,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:05:52
6699	9d52d4cf-1560-4cdc-b125-5cab2fd3edec	9d52d4cf-607b-4a50-b8c5-5e8feaf54914	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:27:12
6700	9d52d4cf-5aee-4029-8b87-708e23cfc3c6	9d52d4cf-607b-4a50-b8c5-5e8feaf54914	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"155.45","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:27:12
6701	9d52d4cf-5b43-40ac-94bf-44517d1d9cdb	9d52d4cf-607b-4a50-b8c5-5e8feaf54914	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:27:12
6702	9d52d4cf-5f87-4985-b8cf-792839318482	9d52d4cf-607b-4a50-b8c5-5e8feaf54914	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:27:12
6703	9d52d4cf-5fc8-4b07-be29-c8530210528a	9d52d4cf-607b-4a50-b8c5-5e8feaf54914	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":399,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:27:12
9019	9d52f3b3-deb5-41ff-8e34-f18202637de5	9d52f3b4-31fa-48a4-bb3e-ab1fb99fb51c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 13:53:35
6852	9d52d5ab-2af7-4eea-9507-c9406a27278a	9d52d5ab-4b11-42e7-9e86-c416438292e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:29:36
6853	9d52d5ab-4999-4b66-99e0-2e443e0d8ad1	9d52d5ab-4b11-42e7-9e86-c416438292e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:29:36
6854	9d52d5ab-4a35-409c-9dd0-e4ae46e7a19e	9d52d5ab-4b11-42e7-9e86-c416438292e4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":255,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:29:36
9020	9d52f3b4-2f4e-4e80-8741-779fcef0922a	9d52f3b4-31fa-48a4-bb3e-ab1fb99fb51c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:53:35
9021	9d52f3b4-3065-4dbe-83df-526741c0b0bc	9d52f3b4-31fa-48a4-bb3e-ab1fb99fb51c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":407,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:53:35
9667	9d54875d-7c6f-49ba-9944-eaf88bbff61f	9d54875d-c2da-424b-a22c-81138c46942c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-25 08:42:18
9668	9d54875d-bc0c-4a01-be0d-8a3c629ff6d7	9d54875d-c2da-424b-a22c-81138c46942c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"140.36","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-25 08:42:18
9669	9d54875d-bc7c-4ba3-861d-bf3be2a5e27b	9d54875d-c2da-424b-a22c-81138c46942c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-25 08:42:18
9670	9d54875d-c070-4156-aedb-6c16509020c5	9d54875d-c2da-424b-a22c-81138c46942c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-25 08:42:18
6704	9d52d4cf-a283-4316-a089-56d447200aac	9d52d4cf-bd3e-4bdb-abc0-b8a27f4a4501	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:27:12
6705	9d52d4cf-b8fb-4918-801e-b28418ccdaac	9d52d4cf-bd3e-4bdb-abc0-b8a27f4a4501	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:27:12
6706	9d52d4cf-b941-48fe-9b28-f5bbaa2baf0c	9d52d4cf-bd3e-4bdb-abc0-b8a27f4a4501	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:27:12
6707	9d52d4cf-bc31-4f39-a3c5-6e064d24d77b	9d52d4cf-bd3e-4bdb-abc0-b8a27f4a4501	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:27:12
6708	9d52d4cf-bc71-4f51-9fba-bca2c8fe0371	9d52d4cf-bd3e-4bdb-abc0-b8a27f4a4501	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":219,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:27:12
6855	9d52d5ab-92b9-4796-9a1a-cd04ec34854f	9d52d5ab-b091-4d85-bc09-afbd4a869eba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:29:36
6856	9d52d5ab-aa5d-4998-b244-8344acd530e8	9d52d5ab-b091-4d85-bc09-afbd4a869eba	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:29:36
6857	9d52d5ab-aaaa-467b-87aa-6633ec2b8832	9d52d5ab-b091-4d85-bc09-afbd4a869eba	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:29:36
6858	9d52d5ab-aed9-4454-aca0-15123f23da3b	9d52d5ab-b091-4d85-bc09-afbd4a869eba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 12:29:36
6859	9d52d5ab-af4c-4be6-aa1d-c2789794e9ee	9d52d5ab-b091-4d85-bc09-afbd4a869eba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:29:36
9022	9d52f3b4-9b9d-453a-a0e0-609d837fcd17	9d52f3b4-e749-49e9-87ea-60552d00bcc1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:53:35
7721	9d52e045-fd33-455d-973f-8bf6d4944beb	9d52e046-1d5e-41df-9d47-de01a7644db2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:59:15
7722	9d52e046-1bb9-4577-bbbf-368828771758	9d52e046-1d5e-41df-9d47-de01a7644db2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:59:15
7723	9d52e046-1c4e-4668-b0c5-0b0baa818257	9d52e046-1d5e-41df-9d47-de01a7644db2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":305,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:59:15
9023	9d52f3b4-e19b-4f05-8a87-06cd3813e8b7	9d52f3b4-e749-49e9-87ea-60552d00bcc1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"149.39","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:53:35
9024	9d52f3b4-e1ea-42cf-91ad-2564d974d285	9d52f3b4-e749-49e9-87ea-60552d00bcc1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:53:35
9025	9d52f3b4-e5e8-47ab-bd43-67b7e456339c	9d52f3b4-e749-49e9-87ea-60552d00bcc1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:53:35
9026	9d52f3b4-e62e-4f6f-a6a9-9e51d59e828c	9d52f3b4-e749-49e9-87ea-60552d00bcc1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":430,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:53:35
5881	9d525072-b1bb-40d3-ba6a-5ef37dc2f463	9d525072-b5b8-495b-a382-eb4e2a23b74d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":192,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:17:05
6709	9d52d4cf-fd0e-44b0-a132-cfe259d82e0e	9d52d4d0-1a70-4126-8887-9b7ec3f2d89f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:27:12
6710	9d52d4d0-147e-4fdb-8a23-bd44becb2f1b	9d52d4d0-1a70-4126-8887-9b7ec3f2d89f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"41.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:27:12
6711	9d52d4d0-14c7-458b-9eb1-415c972df181	9d52d4d0-1a70-4126-8887-9b7ec3f2d89f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:27:12
6712	9d52d4d0-1641-4768-af88-2ae7b8955032	9d52d4d0-1a70-4126-8887-9b7ec3f2d89f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"1.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:27:12
6713	9d52d4d0-1685-43ba-9a07-302f00812f0a	9d52d4d0-1a70-4126-8887-9b7ec3f2d89f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:27:12
6714	9d52d4d0-1976-4f05-8e76-bb37ff681114	9d52d4d0-1a70-4126-8887-9b7ec3f2d89f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:27:12
6715	9d52d4d0-19b9-4303-a952-b296220cc0c5	9d52d4d0-1a70-4126-8887-9b7ec3f2d89f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}],"detail_data":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]},"duration":221,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:27:12
6860	9d52d5ab-f806-4e3f-b35e-e0ffe930fcbc	9d52d5ac-3f9a-4af4-98ac-2ff8ea5b2ae2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 12:29:36
6861	9d52d5ac-3b25-4ac6-983d-f77fcf2d4a2d	9d52d5ac-3f9a-4af4-98ac-2ff8ea5b2ae2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"149.57","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:29:37
6862	9d52d5ac-3b88-4213-98cf-35ec7b063908	9d52d5ac-3f9a-4af4-98ac-2ff8ea5b2ae2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:29:37
6863	9d52d5ac-3e9f-485a-8c20-4a500f920d35	9d52d5ac-3f9a-4af4-98ac-2ff8ea5b2ae2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 12:29:37
6864	9d52d5ac-3ee2-4e9f-a98c-c533cf5704bb	9d52d5ac-3f9a-4af4-98ac-2ff8ea5b2ae2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":351,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:29:37
7724	9d52e046-82a5-4415-8de2-3223246ac71b	9d52e046-a4fd-4303-8074-5e40c1ad3d8e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:59:15
7725	9d52e046-9eb9-4610-a787-038afcf6a4e6	9d52e046-a4fd-4303-8074-5e40c1ad3d8e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:59:16
7726	9d52e046-9f0b-417c-89b7-1fe10e3e4d3b	9d52e046-a4fd-4303-8074-5e40c1ad3d8e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:59:16
7727	9d52e046-a37b-4a6a-89b7-63317b0727b9	9d52e046-a4fd-4303-8074-5e40c1ad3d8e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 12:59:16
9027	9d52f3b5-3e9a-466b-948c-95d8bd4709cf	9d52f3b5-8d3e-46b4-9a53-eddfc8bf5667	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:53:36
9028	9d52f3b5-862d-46ed-adee-41edd9a2db7d	9d52f3b5-8d3e-46b4-9a53-eddfc8bf5667	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"154.07","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:53:36
9029	9d52f3b5-8688-470f-9c2f-956d3ca4fb67	9d52f3b5-8d3e-46b4-9a53-eddfc8bf5667	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:53:36
6716	9d52d4d1-dd35-4913-bf93-fe4928ce8a1c	9d52d4d1-feab-4402-86e4-385805d40d7b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:27:14
6717	9d52d4d1-f6c7-447e-8cfa-6597732f44f7	9d52d4d1-feab-4402-86e4-385805d40d7b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:27:14
6718	9d52d4d1-f71e-4c94-acf8-5ad23b785b7e	9d52d4d1-feab-4402-86e4-385805d40d7b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:27:14
6719	9d52d4d1-fd57-43bc-abc9-88cabda7b045	9d52d4d1-feab-4402-86e4-385805d40d7b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:27:14
6720	9d52d4d1-fda1-42bf-8a75-d04aecfee8b3	9d52d4d1-feab-4402-86e4-385805d40d7b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:27:14
6865	9d52d5ac-80c6-4e3f-ae4b-f60fe615be15	9d52d5ac-9ec3-4c96-aa35-5941b6f8aadf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 12:29:37
6866	9d52d5ac-9816-498c-a91a-fc041ee1cf4a	9d52d5ac-9ec3-4c96-aa35-5941b6f8aadf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"41.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:29:37
6867	9d52d5ac-986e-46f1-8526-41a71fcd771c	9d52d5ac-9ec3-4c96-aa35-5941b6f8aadf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:29:37
6868	9d52d5ac-9a11-407f-b05b-dc4f97adc330	9d52d5ac-9ec3-4c96-aa35-5941b6f8aadf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"1.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:29:37
6869	9d52d5ac-9a45-4930-a220-2b7c28ab811e	9d52d5ac-9ec3-4c96-aa35-5941b6f8aadf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:29:37
6870	9d52d5ac-9d99-49bf-a67d-cf945201ea9d	9d52d5ac-9ec3-4c96-aa35-5941b6f8aadf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 12:29:37
6871	9d52d5ac-9dec-4869-b877-4d254b5b356e	9d52d5ac-9ec3-4c96-aa35-5941b6f8aadf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":223,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:29:37
7728	9d52e046-a3db-4eb2-9dbc-c1891ec0d0a1	9d52e046-a4fd-4303-8074-5e40c1ad3d8e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":317,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:59:16
9030	9d52f3b5-8be1-4f0d-9ffc-5ea2e06dea26	9d52f3b5-8d3e-46b4-9a53-eddfc8bf5667	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:53:36
9671	9d54875d-c0de-46f7-8b3d-7d0e2589543b	9d54875d-c2da-424b-a22c-81138c46942c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":623,"memory":22,"hostname":"EderCortes"}	2024-10-25 08:42:18
5885	9d5250d6-0c89-43d0-8654-296b16931784	9d5250d6-1046-4ac4-88b2-10735854b04a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":144,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:18:10
7729	9d52e046-e6a8-41a6-8274-9ace397ab037	9d52e047-2a70-431e-ac82-c148c7e3bcfd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 12:59:16
7730	9d52e047-25c6-492d-b726-c8ccfaec9fca	9d52e047-2a70-431e-ac82-c148c7e3bcfd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"141.67","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:59:16
7731	9d52e047-2628-4239-a4c3-01aaf70d0c88	9d52e047-2a70-431e-ac82-c148c7e3bcfd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:59:16
6872	9d52d5ae-249e-49b7-94e4-49f835160052	9d52d5ae-6b04-4f92-a977-bc421feef8d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 12:29:38
6873	9d52d5ae-662c-4e5a-9afc-2c02fb048258	9d52d5ae-6b04-4f92-a977-bc421feef8d7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"147.31","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:29:38
6874	9d52d5ae-667b-4d68-9988-3a7cc9c577b0	9d52d5ae-6b04-4f92-a977-bc421feef8d7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:29:38
6875	9d52d5ae-69e4-42e5-8514-b21dd2c86c44	9d52d5ae-6b04-4f92-a977-bc421feef8d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 12:29:38
6876	9d52d5ae-6a26-4dd3-be26-1a76ef6f7998	9d52d5ae-6b04-4f92-a977-bc421feef8d7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":350,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:29:38
7732	9d52e047-2947-4021-8a38-277f8610b2ff	9d52e047-2a70-431e-ac82-c148c7e3bcfd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 12:59:16
7733	9d52e047-2984-422b-b1dc-e96b75ac48e2	9d52e047-2a70-431e-ac82-c148c7e3bcfd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":326,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:59:16
9031	9d52f3b5-8c3b-4398-9f61-490fc899eeb8	9d52f3b5-8d3e-46b4-9a53-eddfc8bf5667	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":409,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:53:36
9672	9d54875e-2d70-4b21-8880-574c20fafc33	9d54875e-4e46-4935-bc52-d19d99927e4d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-25 08:42:19
5886	9d52514b-8baa-47e1-b0ff-03cc516dd44a	9d52514b-91bc-43bf-ad64-c9ad4d64dcec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":244,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:19:27
7734	9d52e047-7216-46b1-b109-ba62e36f066c	9d52e047-b8c6-41dd-9e9b-db046c98664d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 12:59:16
7735	9d52e047-b2c9-49e1-90d3-76eabded362b	9d52e047-b8c6-41dd-9e9b-db046c98664d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"148.35","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:59:16
7736	9d52e047-b318-454b-bb88-1b430e262276	9d52e047-b8c6-41dd-9e9b-db046c98664d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:59:16
7737	9d52e047-b4c9-4ecc-81a8-0c63b03334c7	9d52e047-b8c6-41dd-9e9b-db046c98664d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"2.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:59:16
7738	9d52e047-b4f7-40ab-8489-48e3751ef0b8	9d52e047-b8c6-41dd-9e9b-db046c98664d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:59:16
7739	9d52e047-b7be-4ceb-b5d1-40cadc6756d8	9d52e047-b8c6-41dd-9e9b-db046c98664d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 12:59:16
7740	9d52e047-b7fd-4aff-a947-77f3b0e9faee	9d52e047-b8c6-41dd-9e9b-db046c98664d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:59:16
9032	9d52f3b5-e201-4249-bc77-b094fde635e4	9d52f3b6-2bae-4314-be23-b30d8f0400cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:53:36
9033	9d52f3b6-240a-4772-be4c-375c1bcf00a3	9d52f3b6-2bae-4314-be23-b30d8f0400cd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"145.39","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-24 13:53:36
9034	9d52f3b6-2479-4c5f-a593-74a4d3a5ddd3	9d52f3b6-2bae-4314-be23-b30d8f0400cd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:53:36
9035	9d52f3b6-2664-420f-80a2-9994e650c3b2	9d52f3b6-2bae-4314-be23-b30d8f0400cd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"2.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 13:53:36
9036	9d52f3b6-26a1-442a-bc5f-ce678eaffe5e	9d52f3b6-2bae-4314-be23-b30d8f0400cd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:53:36
9037	9d52f3b6-2a4f-4c89-9adc-315f0b5d73a0	9d52f3b6-2bae-4314-be23-b30d8f0400cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:53:36
9038	9d52f3b6-2ac9-4799-a02c-8c3cc94f9925	9d52f3b6-2bae-4314-be23-b30d8f0400cd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":387,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:53:36
9673	9d54875e-49e1-41d5-bec1-8cdb44502ac8	9d54875e-4e46-4935-bc52-d19d99927e4d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-25 08:42:19
9674	9d54875e-4a2f-4552-b12b-c16bcd27deda	9d54875e-4e46-4935-bc52-d19d99927e4d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-25 08:42:19
9675	9d54875e-4d4a-4669-a2e9-c35c245ed7c7	9d54875e-4e46-4935-bc52-d19d99927e4d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-25 08:42:19
5887	9d525236-8426-4b2d-ac57-3612735b3548	9d525236-886b-4a0c-aa5f-9e691ab52a4f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":186,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:22:01
7741	9d52e049-04d9-4684-8381-63ff9e3264e2	9d52e049-34bd-4762-93a8-a063aa354873	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 12:59:17
7742	9d52e049-2aeb-4501-b08a-8747e671a9ac	9d52e049-34bd-4762-93a8-a063aa354873	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"57.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:59:17
7743	9d52e049-2b6c-4c79-9266-b3fc6665ce42	9d52e049-34bd-4762-93a8-a063aa354873	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:59:17
7744	9d52e049-32a3-446c-8406-d3caf758e851	9d52e049-34bd-4762-93a8-a063aa354873	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 12:59:17
7745	9d52e049-336c-4f0b-9888-c0ba607a443b	9d52e049-34bd-4762-93a8-a063aa354873	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":529,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:59:17
9039	9d52f3b7-f317-4215-b497-ab5378b43038	9d52f3b8-2a4f-4eb2-b68b-3a3c52833070	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:53:37
9040	9d52f3b8-1f6d-479b-abba-bf06f177bbe1	9d52f3b8-2a4f-4eb2-b68b-3a3c52833070	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"65.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:53:38
9041	9d52f3b8-1ff1-4bb8-944b-1333485d2f00	9d52f3b8-2a4f-4eb2-b68b-3a3c52833070	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:53:38
9042	9d52f3b8-27de-4009-af32-9fa481e891c1	9d52f3b8-2a4f-4eb2-b68b-3a3c52833070	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:53:38
9043	9d52f3b8-2863-4a75-addc-99fa2e6c7d05	9d52f3b8-2a4f-4eb2-b68b-3a3c52833070	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":467,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:53:38
9676	9d54875e-4d8c-4426-bbd0-1fce950f6d71	9d54875e-4e46-4935-bc52-d19d99927e4d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-10-25 08:42:19
5888	9d525271-10c9-45d5-81ea-de305736fc5b	9d525271-14d2-4c2c-8285-da6743bf49c2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":216,"memory":20,"hostname":"EderCortes"}	2024-10-24 06:22:40
15281	9d5ecf80-d103-49b9-80b6-e5aaba155dc1	9d5ecf80-d1e3-4422-b2c6-3a26c4b09f33	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":271,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:22:18
9677	9d548761-6838-4d8b-8ac6-c12e4c7c0536	9d548761-cc47-432b-8b0f-ae184edd37f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-25 08:42:21
9678	9d548761-be2a-4628-acee-ed9b589b4c6a	9d548761-cc47-432b-8b0f-ae184edd37f4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"182.65","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-25 08:42:21
9679	9d548761-beaa-4f1f-8e73-dce34c4b16a0	9d548761-cc47-432b-8b0f-ae184edd37f4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-25 08:42:21
9680	9d548761-ca8a-4673-af7d-2c6f409cc5f1	9d548761-cc47-432b-8b0f-ae184edd37f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-25 08:42:21
9681	9d548761-cb02-49d8-9ef8-e47db624f2c7	9d548761-cc47-432b-8b0f-ae184edd37f4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":675,"memory":22,"hostname":"EderCortes"}	2024-10-25 08:42:21
15383	9d5ed10d-88da-4840-a4bf-c166b4ea8e69	9d5ed10d-d252-47fe-b5e9-488252d739d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-30 11:26:38
5441	9d51392d-d92c-4bc1-a0e6-5acb54d78ca5	9d51392e-3cc9-43a2-b9f4-ae5ff03e9957	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 17:16:12
5442	9d51392e-3a41-4f46-b8e1-e146c4409eea	9d51392e-3cc9-43a2-b9f4-ae5ff03e9957	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 17:16:12
5443	9d51392e-3b52-478f-b33f-8dfc9cfe9323	9d51392e-3cc9-43a2-b9f4-ae5ff03e9957	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":621,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:16:12
15384	9d5ed10d-d029-4d66-8a14-b03a1469cb4e	9d5ed10d-d252-47fe-b5e9-488252d739d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-30 11:26:38
15385	9d5ed10d-d141-4d4b-90d0-b5740a61fc89	9d5ed10d-d252-47fe-b5e9-488252d739d1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":392,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:26:38
5444	9d51392e-c711-4ba4-9b60-a9eb2ae57c25	9d51392f-216b-45e7-b289-ae1215b7b1fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-23 17:16:12
5445	9d51392f-1872-4bd3-a9ac-7257fc0e9f35	9d51392f-216b-45e7-b289-ae1215b7b1fa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"176.22","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:16:12
5446	9d51392f-1903-4577-89be-6dfe428b6081	9d51392f-216b-45e7-b289-ae1215b7b1fa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:16:12
5447	9d51392f-1fa0-4efa-b3e7-97b90f1febb9	9d51392f-216b-45e7-b289-ae1215b7b1fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 17:16:13
5448	9d51392f-201c-405a-bd7e-8a8df157a1a4	9d51392f-216b-45e7-b289-ae1215b7b1fa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":538,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:16:13
5889	9d525271-cf13-43f1-911a-9803b4072005	9d525271-f374-4f3f-92fb-bcf257f6b292	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 06:22:40
5890	9d525271-e892-4ed7-aee6-a3079a69dc5f	9d525271-f374-4f3f-92fb-bcf257f6b292	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"user_creador\\", \\"user_cobrador\\", \\"updated_at\\", \\"created_at\\") values ('Luis andre', 'Herrera', 'MArtinez', 'CC', '100465545', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '500000', 25, 6, 'S', null, 'Thu Oct 24 2024', 'Pendiente', 12, 14, '2024-10-24 06:22:40', '2024-10-24 06:22:40') returning \\"id\\"","time":"4.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":77,"hash":"f6268ba5ed8f5ccd7040ba10f8ed2560","hostname":"EderCortes"}	2024-10-24 06:22:40
5891	9d525271-e8ee-4c90-9580-00d6b48d48eb	9d525271-f374-4f3f-92fb-bcf257f6b292	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:24","hostname":"EderCortes"}	2024-10-24 06:22:40
5892	9d525271-ea67-4347-a26c-831f0c70b37e	9d525271-f374-4f3f-92fb-bcf257f6b292	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (24, 1, 83333.333333333, 125000, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:22:40', '2024-10-24 06:22:40')","time":"2.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:22:40
5893	9d525271-ea90-4f40-9169-4be352a27ba0	9d525271-f374-4f3f-92fb-bcf257f6b292	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:22:40
5894	9d525271-eafd-4f2a-b628-3ac13d986cf2	9d525271-f374-4f3f-92fb-bcf257f6b292	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (24, 2, 83333.333333333, 125000, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:22:40', '2024-10-24 06:22:40')","time":"0.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:22:40
5895	9d525271-eb1d-4a1b-a1ce-720e8bedd2ab	9d525271-f374-4f3f-92fb-bcf257f6b292	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:22:40
5896	9d525271-eb82-4bbe-a7b7-5570b41a3ebf	9d525271-f374-4f3f-92fb-bcf257f6b292	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (24, 3, 83333.333333333, 125000, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:22:40', '2024-10-24 06:22:40')","time":"0.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:22:40
5897	9d525271-eba4-4939-874c-260f08c80040	9d525271-f374-4f3f-92fb-bcf257f6b292	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:22:40
5898	9d525271-ec0b-4c1b-afb8-7596d1c25418	9d525271-f374-4f3f-92fb-bcf257f6b292	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (24, 4, 83333.333333333, 125000, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:22:40', '2024-10-24 06:22:40')","time":"0.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:22:40
5899	9d525271-ec2a-44bb-bf90-19eb5c7bdb9b	9d525271-f374-4f3f-92fb-bcf257f6b292	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:22:40
5900	9d525271-ec96-4be3-a972-6ed3666d271c	9d525271-f374-4f3f-92fb-bcf257f6b292	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (24, 5, 83333.333333333, 125000, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:22:40', '2024-10-24 06:22:40')","time":"0.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:22:40
5901	9d525271-ecc6-42b3-9912-481e396762c5	9d525271-f374-4f3f-92fb-bcf257f6b292	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:22:40
5449	9d51392f-7af9-4de9-843e-a4e67424a8c8	9d51392f-9aef-4d8c-b14b-ac47f0f5995c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-23 17:16:13
5450	9d51392f-957d-4ce3-89e6-bfaf4400b5e0	9d51392f-9aef-4d8c-b14b-ac47f0f5995c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":74,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-23 17:16:13
5451	9d51392f-95d0-48ba-84cc-3aa1ae4316de	9d51392f-9aef-4d8c-b14b-ac47f0f5995c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-23 17:16:13
5452	9d51392f-99ae-4b77-903a-25b5eda5acc4	9d51392f-9aef-4d8c-b14b-ac47f0f5995c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 17:16:13
5453	9d51392f-9a06-4ff9-906f-d9421d4935cd	9d51392f-9aef-4d8c-b14b-ac47f0f5995c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-charge\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":292,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:16:13
5902	9d525271-ed3e-4234-98dd-6b7b085bef6b	9d525271-f374-4f3f-92fb-bcf257f6b292	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (24, 6, 83333.333333333, 125000, 0, 'N\\/A', 'Thu Oct 24 2024', 12, '2024-10-24 06:22:40', '2024-10-24 06:22:40')","time":"0.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":99,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-24 06:22:40
5903	9d525271-ed64-4003-b0c3-15b59bc84db6	9d525271-f374-4f3f-92fb-bcf257f6b292	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-24 06:22:40
5904	9d525271-f20c-4882-9ae5-358f3d64a7bf	9d525271-f374-4f3f-92fb-bcf257f6b292	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 06:22:40
5905	9d525271-f255-4e42-8036-77c0e7533294	9d525271-f374-4f3f-92fb-bcf257f6b292	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"596","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":"100465545","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"500000","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_cobrador":14},"detail":{"status":false,"observacion":"N\\/A","fecha_pago":"Thu Oct 24 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":24},"duration":262,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:22:40
5454	9d513930-6d95-4c21-bfae-3f7d1f58e0c2	9d513930-c403-4562-bb20-02ae9929e04d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 17:16:13
5455	9d513930-b91d-4b78-945c-a05460d76178	9d513930-c403-4562-bb20-02ae9929e04d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"103.01","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:16:14
5456	9d513930-b9b4-44ed-a107-5a5fc4713e7f	9d513930-c403-4562-bb20-02ae9929e04d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:16:14
5457	9d513930-c1a2-4c5d-b4e2-456f63f5abab	9d513930-c403-4562-bb20-02ae9929e04d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 17:16:14
5458	9d513930-c233-40ff-b00c-6503a2a2bb56	9d513930-c403-4562-bb20-02ae9929e04d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":740,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:16:14
10900	9d5ca58f-72d5-4378-94cd-7a278ec9a3c1	9d5ca58f-9186-4ae3-912f-c1b78ef041d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 09:33:21
10901	9d5ca58f-8fbf-4659-b4a1-2cc291b03316	9d5ca58f-9186-4ae3-912f-c1b78ef041d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 09:33:22
10902	9d5ca58f-905b-4f4c-a2bd-344cf7d02e54	9d5ca58f-9186-4ae3-912f-c1b78ef041d3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:33:22
5459	9d513931-6576-4956-a8e5-b573d91ae863	9d513931-b29f-46db-90c1-43b58bdae66f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 17:16:14
5460	9d513931-adca-48d9-a78d-b0d05d5a4256	9d513931-b29f-46db-90c1-43b58bdae66f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"162.76","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-23 17:16:14
5461	9d513931-ae2e-48cd-ad1e-a6dbadb13405	9d513931-b29f-46db-90c1-43b58bdae66f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-23 17:16:14
5462	9d513931-b160-45ae-8cdd-e2e4b6cd9427	9d513931-b29f-46db-90c1-43b58bdae66f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 17:16:14
5463	9d513931-b1a5-4268-a282-d8364506feb4	9d513931-b29f-46db-90c1-43b58bdae66f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":587,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:16:14
10903	9d5ca591-0dd2-478f-b226-dbe85dbfabee	9d5ca591-2eb7-42d5-b0f6-718c4cce9677	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 09:33:22
10904	9d5ca591-291e-4804-876e-c63dbd8ca73b	9d5ca591-2eb7-42d5-b0f6-718c4cce9677	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"48.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 09:33:23
10905	9d5ca591-2979-48aa-a6f9-e230c8cfa36c	9d5ca591-2eb7-42d5-b0f6-718c4cce9677	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 09:33:23
10906	9d5ca591-2d7a-4774-8be9-b25424e5f24b	9d5ca591-2eb7-42d5-b0f6-718c4cce9677	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 09:33:23
10907	9d5ca591-2dbf-4c7a-b346-befe70fee56f	9d5ca591-2eb7-42d5-b0f6-718c4cce9677	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":437,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:33:23
5464	9d513942-3373-4cd2-989e-a8d137b3656e	9d513942-366c-44c6-a81c-bbfd5e37d449	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":140,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:16:25
5465	9d513942-9e32-4000-b3d6-68c7ecf3baf9	9d513942-bb60-453a-9125-4e32119feae5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-23 17:16:25
5466	9d513942-b63c-4ae7-a8b9-fb4931667e8e	9d513942-bb60-453a-9125-4e32119feae5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"44.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":46,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-23 17:16:25
5467	9d513942-ba20-4a75-9add-d80428cd5ff7	9d513942-bb60-453a-9125-4e32119feae5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 17:16:25
5468	9d513942-ba64-4979-b2ab-4b2a91d640a0	9d513942-bb60-453a-9125-4e32119feae5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":224,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:16:25
5469	9d51394e-4439-4117-8fe2-dc88ac936c49	9d51394e-6664-4047-b81b-7585bc398556	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 17:16:33
5470	9d51394e-5f56-4d16-9694-7c715a3b4d23	9d51394e-6664-4047-b81b-7585bc398556	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '19' and \\"users\\".\\"deleted_at\\" is null","time":"45.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":28,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-23 17:16:33
5471	9d51394e-5fba-4bd0-a60b-367ba622b3e2	9d51394e-6664-4047-b81b-7585bc398556	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-23 17:16:33
5472	9d51394e-650f-4b45-af35-c009d5cc3d26	9d51394e-6664-4047-b81b-7585bc398556	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 17:16:33
5473	9d51394e-655b-491c-9bc7-06c48e52cd6a	9d51394e-6664-4047-b81b-7585bc398556	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/19","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}},"duration":267,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:16:33
11092	9d5caac8-6b0d-4e4a-8cba-c6bc0d56b050	9d5caac8-af03-473e-87a3-e48b685b1181	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 09:47:58
11093	9d5caac8-ad7f-45b6-a2cb-9e934d181ded	9d5caac8-af03-473e-87a3-e48b685b1181	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 09:47:58
11094	9d5caac8-ae11-4d7e-a076-e474977315b5	9d5caac8-af03-473e-87a3-e48b685b1181	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":328,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:47:58
11002	9d5ca78e-b2f0-49a5-8707-d498f4ddc9c9	9d5ca78e-cf95-4ce2-a322-2574124286f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 09:38:56
11003	9d5ca78e-ce09-4aac-9888-e11662c99209	9d5ca78e-cf95-4ce2-a322-2574124286f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 09:38:57
11004	9d5ca78e-ce9d-459b-8d25-9c2c52292076	9d5ca78e-cf95-4ce2-a322-2574124286f5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:38:57
9196	9d52f59c-d8dc-49d2-8811-89a65d2aae62	9d52f59d-21e4-43db-82ab-fc7abc7e80d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:58:55
9197	9d52f59d-1da8-481e-ba2f-422e50ac285d	9d52f59d-21e4-43db-82ab-fc7abc7e80d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 13:58:55
9198	9d52f59d-20de-4db0-9cd1-1d4f3ad4ded3	9d52f59d-21e4-43db-82ab-fc7abc7e80d7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":352,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:58:55
11005	9d5ca78f-1668-43b9-ade5-943e0d0c57c8	9d5ca78f-5af5-4659-9027-6f947ae1756d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 09:38:57
11006	9d5ca78f-5661-4ea3-83f2-43628d043c6d	9d5ca78f-5af5-4659-9027-6f947ae1756d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"149.29","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-29 09:38:57
8836	9d52ef61-db85-4cf4-87b9-1a6ab81a016f	9d52ef61-de4f-4b77-8905-42c2d83e9ea1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":426}	2024-10-24 13:41:30
11007	9d5ca78f-59c3-41a8-aab0-7395f65aba6d	9d5ca78f-5af5-4659-9027-6f947ae1756d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 09:38:57
11095	9d5caac8-f565-43d1-989a-d055fa939539	9d5caac9-1348-4c26-8703-589d5e64166d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 09:47:58
9199	9d52f59d-6aec-49f5-b9af-a9576e70c715	9d52f59d-88b6-4752-8afd-1d0a4cd0133f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 13:58:56
9200	9d52f59d-838c-4eec-be57-a683a0d9a905	9d52f59d-88b6-4752-8afd-1d0a4cd0133f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:58:56
9201	9d52f59d-83e1-443d-9e27-fb017c11dc7a	9d52f59d-88b6-4752-8afd-1d0a4cd0133f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:58:56
9202	9d52f59d-8744-4ef9-ba05-f7d1c8a37e6e	9d52f59d-88b6-4752-8afd-1d0a4cd0133f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 13:58:56
9203	9d52f59d-8786-4c54-9c10-c5cd340a31da	9d52f59d-88b6-4752-8afd-1d0a4cd0133f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:58:56
11008	9d5ca78f-5a0d-49ee-b94b-9e808f17655e	9d5ca78f-5af5-4659-9027-6f947ae1756d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":328,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:38:57
11096	9d5caac9-0a2d-4f05-bc8c-61b7f5ceb4aa	9d5caac9-1348-4c26-8703-589d5e64166d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 1\\n                        ","time":"40.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"2bd5a29c69f6bbb290fc49b79286632e","hostname":"EderCortes"}	2024-10-29 09:47:58
11097	9d5caac9-0def-4c95-bc56-3d8f69075752	9d5caac9-1348-4c26-8703-589d5e64166d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1' order by \\"item_loans\\".\\"id\\" asc","time":"1.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 09:47:58
11098	9d5caac9-0e21-453e-81ae-dff2a7562dbf	9d5caac9-1348-4c26-8703-589d5e64166d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 09:47:58
11099	9d5caac9-1215-4675-b004-ad317cf06ba4	9d5caac9-1348-4c26-8703-589d5e64166d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 09:47:58
11100	9d5caac9-125c-4ac8-952a-a314868204f4	9d5caac9-1348-4c26-8703-589d5e64166d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":1,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]}},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:47:58
9204	9d52f59d-cc3f-422b-99fe-75194aead719	9d52f59d-eb0f-438c-9a4c-aafab1af59ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 13:58:56
9205	9d52f59d-e60d-4b7f-a49d-e77df759b281	9d52f59d-eb0f-438c-9a4c-aafab1af59ac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:58:56
9206	9d52f59d-e65b-499a-9f92-ed53c16aa286	9d52f59d-eb0f-438c-9a4c-aafab1af59ac	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:58:56
9207	9d52f59d-e9d7-46a9-94f0-70648b715d19	9d52f59d-eb0f-438c-9a4c-aafab1af59ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 13:58:56
9208	9d52f59d-ea1f-47be-8c47-ba3378c1d87d	9d52f59d-eb0f-438c-9a4c-aafab1af59ac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:58:56
11009	9d5ca790-dc3b-4cab-8753-2c55f4a0e81a	9d5ca790-f8f2-4ad4-8646-119d9450db4e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 09:38:58
11010	9d5ca790-f422-4870-a4b3-21f9717c2e51	9d5ca790-f8f2-4ad4-8646-119d9450db4e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 09:38:58
11011	9d5ca790-f46c-42a2-88cb-769e84c713bb	9d5ca790-f8f2-4ad4-8646-119d9450db4e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 09:38:58
11012	9d5ca790-f7bf-46a0-b970-ac3d8356ddd7	9d5ca790-f8f2-4ad4-8646-119d9450db4e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 09:38:58
11013	9d5ca790-f804-4ca2-b9f2-e489d96ce1a9	9d5ca790-f8f2-4ad4-8646-119d9450db4e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":398,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:38:58
11101	9d5caaca-2dfa-419a-8e3c-730dd69a67be	9d5caaca-57de-4451-9382-38f4f721f682	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 09:47:59
11102	9d5caaca-4e62-4fe8-ba5c-68dcc5679bcf	9d5caaca-57de-4451-9382-38f4f721f682	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"56.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 09:47:59
11103	9d5caaca-4ee0-499d-b75f-5e904d292d62	9d5caaca-57de-4451-9382-38f4f721f682	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 09:47:59
11104	9d5caaca-55fc-400a-8ac8-7d0de5e56c9d	9d5caaca-57de-4451-9382-38f4f721f682	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 09:47:59
11105	9d5caaca-5682-4fde-86c4-dc548db54583	9d5caaca-57de-4451-9382-38f4f721f682	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":360,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:47:59
7919	9d52e55c-ed8c-4fb8-a286-af2faf06c55e	9d52e55d-4cf7-4ceb-8b60-362acbd62476	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 13:13:29
7920	9d52e55d-49b8-48dc-ab08-5b3a9205914b	9d52e55d-4cf7-4ceb-8b60-362acbd62476	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:13:29
7921	9d52e55d-4ad6-4f24-911f-47a80e452013	9d52e55d-4cf7-4ceb-8b60-362acbd62476	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":477,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:13:29
7922	9d52e55d-b040-4a66-803e-303841f85497	9d52e55d-fa4a-4612-80a6-18abe61c5d1a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:13:30
7923	9d52e55d-f46a-4b70-a031-21f1bf3eb410	9d52e55d-fa4a-4612-80a6-18abe61c5d1a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"149.14","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:13:30
7924	9d52e55d-f4e7-4fe6-a542-10d781fe852a	9d52e55d-fa4a-4612-80a6-18abe61c5d1a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:13:30
7925	9d52e55d-f931-4b52-9c8c-1bdfc11f254a	9d52e55d-fa4a-4612-80a6-18abe61c5d1a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:13:30
7926	9d52e55d-f97d-4aa8-af69-503a12d5eb53	9d52e55d-fa4a-4612-80a6-18abe61c5d1a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":399,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:13:30
9209	9d52f59e-34a8-4595-9542-a95c834187c1	9d52f59e-5462-49d5-ae99-b34f701b4a54	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 13:58:56
9210	9d52f59e-4da3-4cc5-a429-dc9b1b9b1c36	9d52f59e-5462-49d5-ae99-b34f701b4a54	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"42.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-24 13:58:56
9211	9d52f59e-4ded-43ad-8013-1d3865bf4823	9d52f59e-5462-49d5-ae99-b34f701b4a54	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:58:56
9212	9d52f59e-4f63-4801-9fc0-0371414558d0	9d52f59e-5462-49d5-ae99-b34f701b4a54	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"1.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 13:58:56
9213	9d52f59e-4f92-4824-8e34-044419613d1b	9d52f59e-5462-49d5-ae99-b34f701b4a54	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:58:56
9214	9d52f59e-52d8-452b-bc0a-c5126be77580	9d52f59e-5462-49d5-ae99-b34f701b4a54	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 13:58:56
9215	9d52f59e-5351-443e-a493-9695d5321387	9d52f59e-5462-49d5-ae99-b34f701b4a54	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":256,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:58:56
6351	9d5264d0-b783-4241-90ce-7157e7a27ee6	9d5264d0-dd3a-4ee1-8d94-56d616ae3465	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 07:14:02
6352	9d5264d0-db8e-401f-b1ed-0545ff82974b	9d5264d0-dd3a-4ee1-8d94-56d616ae3465	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 07:14:02
6353	9d5264d0-dc44-4c9c-8c25-aa66f5246489	9d5264d0-dd3a-4ee1-8d94-56d616ae3465	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":327,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:14:02
6354	9d5264d1-3262-433d-a752-c3f380a53ffc	9d5264d1-7c48-4402-8cb5-747f73c97b49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 07:14:03
6355	9d5264d1-7784-440c-801e-cdb56bedf57f	9d5264d1-7c48-4402-8cb5-747f73c97b49	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n    select l.id,\\n        l.loans_documento,\\n        l.loans_nombre,\\n        l.loans_apellido_uno,\\n        l.loans_fecha,\\n        l.loans_valor_prestado,\\n        l.loans_cuotas,\\n        l.loans_estado,\\n        l.loans_intereses,\\n        uco.name as cobrador,\\n        ure.name as recomendador\\n    from loans l\\n    join users ucl on l.user_customer = ucl.id\\n    join users uco on l.user_cobrador = uco.id\\n    left join users ure on l.user_recomendacion = ure.id\\n","time":"163.27","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23,"hash":"07791497a6f310e4570d0edecd8da1cd","hostname":"EderCortes"}	2024-10-24 07:14:03
6356	9d5264d1-7af4-4b22-8325-917b19b28b80	9d5264d1-7c48-4402-8cb5-747f73c97b49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 07:14:03
6357	9d5264d1-7b47-4dbb-a73a-0d26b2ab89aa	9d5264d1-7c48-4402-8cb5-747f73c97b49	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":369,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:14:03
7927	9d52e55e-4123-465c-a3d2-6cb92e2b7fb2	9d52e55e-884d-40b7-b8af-84a6f0559ded	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:13:30
7928	9d52e55e-83d1-4f58-8c15-ea2ddc44464b	9d52e55e-884d-40b7-b8af-84a6f0559ded	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"148.14","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:13:30
7929	9d52e55e-841f-439a-b744-4908754e1c42	9d52e55e-884d-40b7-b8af-84a6f0559ded	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:13:30
7930	9d52e55e-8752-4f2f-8b0b-9812afade093	9d52e55e-884d-40b7-b8af-84a6f0559ded	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:13:30
7931	9d52e55e-8790-4c49-bbc5-0f0c97de7092	9d52e55e-884d-40b7-b8af-84a6f0559ded	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:13:30
9216	9d52f5a0-0498-49b4-9611-54af08d6100f	9d52f5a0-287e-4624-ae51-b4bcdae42fc1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 13:58:57
9217	9d52f5a0-2291-47a2-801d-7a81e33efc9c	9d52f5a0-287e-4624-ae51-b4bcdae42fc1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"47.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:58:57
9218	9d52f5a0-22dc-4213-87f1-b0de464d073a	9d52f5a0-287e-4624-ae51-b4bcdae42fc1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:58:57
9219	9d52f5a0-270d-4191-8b5b-85aa9b086caa	9d52f5a0-287e-4624-ae51-b4bcdae42fc1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 13:58:57
9220	9d52f5a0-2759-4cae-b9cc-ef9b813fad15	9d52f5a0-287e-4624-ae51-b4bcdae42fc1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":562,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:58:57
6358	9d5264d3-fb25-4ad6-97d0-54f1c283bd99	9d5264d4-633f-4185-96c0-aa0d223b3fea	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 07:14:04
6359	9d5264d4-5a61-4170-add3-e4b4de49fd13	9d5264d4-633f-4185-96c0-aa0d223b3fea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"179.50","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 07:14:05
6360	9d5264d4-5b1c-495d-bf3f-8c9fa812d426	9d5264d4-633f-4185-96c0-aa0d223b3fea	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 07:14:05
6361	9d5264d4-60fc-4c45-be2c-55b1f75acaf0	9d5264d4-633f-4185-96c0-aa0d223b3fea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 07:14:05
6362	9d5264d4-61ad-4997-a390-a4a27eec173c	9d5264d4-633f-4185-96c0-aa0d223b3fea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":782,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:14:05
7932	9d52e55e-cf19-4580-942c-ec1be9d4fe9c	9d52e55f-17ab-4934-8462-e6c0d1c397e2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:13:30
7933	9d52e55f-10a2-4a87-a188-a73f403d8fa2	9d52e55f-17ab-4934-8462-e6c0d1c397e2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc","time":"148.67","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 13:13:30
7008	9d52d9da-85ed-4e5a-abea-f41fb28e596e	9d52d9da-d3b5-4b7d-84cd-985722a01cd9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:41:18
7009	9d52d9da-d216-4d46-b43c-4712063f1183	9d52d9da-d3b5-4b7d-84cd-985722a01cd9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:41:18
7010	9d52d9da-d2c5-439e-b9ec-1456fec41029	9d52d9da-d3b5-4b7d-84cd-985722a01cd9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":398,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:41:18
7934	9d52e55f-10ed-4f92-b4c0-a788c0abd65a	9d52e55f-17ab-4934-8462-e6c0d1c397e2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:13:30
7935	9d52e55f-126e-46bc-8742-2787aa9041f0	9d52e55f-17ab-4934-8462-e6c0d1c397e2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6'","time":"1.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 13:13:30
7936	9d52e55f-129d-4f30-b353-9ba81efb7a3a	9d52e55f-17ab-4934-8462-e6c0d1c397e2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:13:30
7937	9d52e55f-1675-461c-91a1-2479161a8529	9d52e55f-17ab-4934-8462-e6c0d1c397e2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:13:30
7938	9d52e55f-16c3-4e1e-941a-f17ce5bb2067	9d52e55f-17ab-4934-8462-e6c0d1c397e2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":352,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:13:30
7011	9d52d9db-27d5-4d37-a5b3-4cb6a1936dd0	9d52d9db-4863-4c20-80d2-c11a581bddc4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:41:18
7012	9d52d9db-42dc-4496-801f-aa3924ece8b2	9d52d9db-4863-4c20-80d2-c11a581bddc4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:41:19
7013	9d52d9db-432e-4079-ac34-7ecdd4c1b335	9d52d9db-4863-4c20-80d2-c11a581bddc4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:41:19
7014	9d52d9db-4722-43ea-9753-447d271aeb1c	9d52d9db-4863-4c20-80d2-c11a581bddc4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 12:41:19
7015	9d52d9db-476c-45e9-8916-56d944a93cf5	9d52d9db-4863-4c20-80d2-c11a581bddc4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":269,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:41:19
7939	9d52e564-0940-4d51-b71a-d3c02b118dbd	9d52e564-2e77-4ffe-9a89-743cfb83da20	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:13:34
7940	9d52e564-2723-462d-846a-00b28ad11cf0	9d52e564-2e77-4ffe-9a89-743cfb83da20	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:13:34
7941	9d52e564-2785-4bc3-9ed8-665a1ee59d81	9d52e564-2e77-4ffe-9a89-743cfb83da20	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:13:34
7942	9d52e564-2cc3-48aa-b46d-cf1ada84f58a	9d52e564-2e77-4ffe-9a89-743cfb83da20	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:13:34
7943	9d52e564-2d20-495f-9ff6-e960c1c08d5d	9d52e564-2e77-4ffe-9a89-743cfb83da20	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":455,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:13:34
7016	9d52d9db-8ec0-4507-af4f-def89014997e	9d52d9db-d689-4fa5-ad7f-cc03d8c5da35	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 12:41:19
7017	9d52d9db-d1e0-4e5b-bccb-f617ae70b13f	9d52d9db-d689-4fa5-ad7f-cc03d8c5da35	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"149.68","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:41:19
7018	9d52d9db-d226-438c-a8bc-6790667b7b4d	9d52d9db-d689-4fa5-ad7f-cc03d8c5da35	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:41:19
7019	9d52d9db-d57e-4cd9-b61f-4bed04a5938d	9d52d9db-d689-4fa5-ad7f-cc03d8c5da35	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 12:41:19
7020	9d52d9db-d5c1-421c-a6fe-5fef08e4e720	9d52d9db-d689-4fa5-ad7f-cc03d8c5da35	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":350,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:41:19
7021	9d52d9dc-1dd4-487d-8960-36283de8d8de	9d52d9dc-3efd-40fe-988d-44d8b6c6d26e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 12:41:19
7022	9d52d9dc-37e6-45c0-9420-35056362ffcd	9d52d9dc-3efd-40fe-988d-44d8b6c6d26e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"44.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:41:19
7023	9d52d9dc-3833-43fd-954c-23cb622e04f8	9d52d9dc-3efd-40fe-988d-44d8b6c6d26e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:41:19
7024	9d52d9dc-39bf-4c3c-919a-79c697716f9f	9d52d9dc-3efd-40fe-988d-44d8b6c6d26e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"1.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:41:19
7025	9d52d9dc-39f4-434c-83ae-8396aaf68ab2	9d52d9dc-3efd-40fe-988d-44d8b6c6d26e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:41:19
7026	9d52d9dc-3dd6-4229-b36b-04aa3b560883	9d52d9dc-3efd-40fe-988d-44d8b6c6d26e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 12:41:19
7027	9d52d9dc-3e1d-410e-b5d6-ea04bf7347ee	9d52d9dc-3efd-40fe-988d-44d8b6c6d26e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:41:19
5037	9d513669-ce3e-4e06-865f-43b67a76f1c6	9d51366a-1726-47b4-897a-3b3287e6adb0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":39,"hostname":"EderCortes"}	2024-10-23 17:08:28
5038	9d51366a-14a2-4b1b-a606-28ae95649121	9d51366a-1726-47b4-897a-3b3287e6adb0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":40,"hostname":"EderCortes"}	2024-10-23 17:08:28
5039	9d51366a-15ce-4d56-b5f2-618ee32bb8ac	9d51366a-1726-47b4-897a-3b3287e6adb0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":670,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:28
7028	9d52d9de-5bf6-47d5-bf03-32729a225fba	9d52d9de-8bbf-4fb4-ab77-19ca816ed346	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 12:41:21
7029	9d52d9de-83fe-465f-b319-3f16c6fd60a0	9d52d9de-8bbf-4fb4-ab77-19ca816ed346	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"66.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:41:21
7030	9d52d9de-847d-4442-8705-436dfc095dbb	9d52d9de-8bbf-4fb4-ab77-19ca816ed346	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:41:21
7031	9d52d9de-8a1d-4f5b-b714-a5714095ad6b	9d52d9de-8bbf-4fb4-ab77-19ca816ed346	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 12:41:21
7032	9d52d9de-8a7e-4d4f-b26b-50c54ed66877	9d52d9de-8bbf-4fb4-ab77-19ca816ed346	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":516,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:41:21
11182	9d5cabfc-303f-4db4-affe-9161072e8d65	9d5cabfc-7a9a-4405-9146-4f0547605df2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 09:51:19
11183	9d5cabfc-78d1-4d71-8e4b-10979b11ad1d	9d5cabfc-7a9a-4405-9146-4f0547605df2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 09:51:20
11184	9d5cabfc-79a0-4d82-a12a-c537a26ca3eb	9d5cabfc-7a9a-4405-9146-4f0547605df2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":374,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:51:20
26233	9d68cf26-f8d1-412d-b353-6534ec9d7cec	9d68cf26-fd17-4365-835c-acc4829f158c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1213}	2024-11-04 10:39:35
26193	9d68cef7-d058-44fa-8a8e-0d298b6aaac0	9d68cef7-d3d1-4a30-979a-8226e7becd3c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1210}	2024-11-04 10:39:05
11185	9d5cabfc-c259-4e1a-90fe-3a40eedefe5b	9d5cabfd-060f-463a-8246-9351b8675375	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 09:51:20
11186	9d5cabfc-fdcb-48ed-a563-9230f6144fe1	9d5cabfd-060f-463a-8246-9351b8675375	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 1\\n                        ","time":"139.63","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"2bd5a29c69f6bbb290fc49b79286632e","hostname":"EderCortes"}	2024-10-29 09:51:20
11187	9d5cabfd-0141-4d0f-a8c4-9a08b6dfb215	9d5cabfd-060f-463a-8246-9351b8675375	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1' order by \\"item_loans\\".\\"id\\" asc","time":"2.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 09:51:20
11188	9d5cabfd-0171-4ba3-8b13-98c6cd02eb4e	9d5cabfd-060f-463a-8246-9351b8675375	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 09:51:20
11189	9d5cabfd-04da-4b26-af9e-783cc623ccc3	9d5cabfd-060f-463a-8246-9351b8675375	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 09:51:20
11190	9d5cabfd-0527-4df6-bcd5-ebf46f69029b	9d5cabfd-060f-463a-8246-9351b8675375	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":1,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]}},"duration":328,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:51:20
11191	9d5cabfe-1fe9-4228-be08-d592c12140c2	9d5cabfe-56bd-44ec-8f89-43b0b68e9422	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 09:51:21
11192	9d5cabfe-4f71-44c1-9363-150ab7858db1	9d5cabfe-56bd-44ec-8f89-43b0b68e9422	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"88.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 09:51:21
11193	9d5cabfe-4ff0-407d-949c-d2d2a0ab8c25	9d5cabfe-56bd-44ec-8f89-43b0b68e9422	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 09:51:21
11194	9d5cabfe-5527-4239-8641-16be87478671	9d5cabfe-56bd-44ec-8f89-43b0b68e9422	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 09:51:21
11195	9d5cabfe-558c-4414-8228-606d9dde4f36	9d5cabfe-56bd-44ec-8f89-43b0b68e9422	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":384,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:51:21
15694	9d64904d-eec0-4175-bdeb-a044c9c18033	9d64904e-0be8-46eb-a955-7e9549c748ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 08:00:33
15695	9d64904e-0a33-4e3a-845e-98cff1ef307c	9d64904e-0be8-46eb-a955-7e9549c748ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 08:00:33
15696	9d64904e-0ae4-40be-91f2-35b55ecf8786	9d64904e-0be8-46eb-a955-7e9549c748ae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":220,"memory":22,"hostname":"EderCortes"}	2024-11-02 08:00:33
15809	9d64affd-3e39-4a90-bc82-da172d8db549	9d64affd-672c-47ad-91ae-3294cb57c65e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 09:29:09
15810	9d64affd-6544-470c-8b45-1242b65ed5b1	9d64affd-672c-47ad-91ae-3294cb57c65e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:29:09
15811	9d64affd-6614-4d2b-87f9-e0bf4ca4dd13	9d64affd-672c-47ad-91ae-3294cb57c65e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":312,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:29:09
9378	9d52f78a-269e-49c3-ac4e-a3b66d5f15a2	9d52f78a-4ca9-4565-bcae-55575fca8053	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 14:04:19
9379	9d52f78a-4a9b-424a-94f9-89d52950a399	9d52f78a-4ca9-4565-bcae-55575fca8053	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 14:04:19
9380	9d52f78a-4b83-4eb5-9554-07cc21031974	9d52f78a-4ca9-4565-bcae-55575fca8053	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":279,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:04:19
9381	9d52f78a-ac3f-4629-9274-2fb63c74f89a	9d52f78a-cf3a-4cf8-a604-8c4b74ab28b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 14:04:19
9382	9d52f78a-c83f-44d0-aa1c-33a36714b582	9d52f78a-cf3a-4cf8-a604-8c4b74ab28b4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 14:04:19
9383	9d52f78a-c898-43e1-a5f2-ff556dd1adfe	9d52f78a-cf3a-4cf8-a604-8c4b74ab28b4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 14:04:19
9384	9d52f78a-cddd-4bdf-9428-217d02396e47	9d52f78a-cf3a-4cf8-a604-8c4b74ab28b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 14:04:19
9385	9d52f78a-ce27-44dc-9b31-cb50f9515c4f	9d52f78a-cf3a-4cf8-a604-8c4b74ab28b4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":301,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:04:19
15697	9d64904e-55d2-4578-b3eb-97465dbe82a1	9d64904e-73b9-40ef-863c-15dad735be3f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 08:00:33
15576	9d648d4e-023c-40ce-9b56-9a25b6b55c22	9d648d4f-50d6-4583-b478-9e7b1c4ce507	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 07:52:09
15577	9d648d4f-4e72-4a69-a51e-ffbd02d921b9	9d648d4f-50d6-4583-b478-9e7b1c4ce507	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 07:52:10
15578	9d648d4f-4f6c-42f0-98ff-c3bdb32b3883	9d648d4f-50d6-4583-b478-9e7b1c4ce507	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1156,"memory":22,"hostname":"EderCortes"}	2024-11-02 07:52:10
15698	9d64904e-6e7f-4264-a105-03e98e401981	9d64904e-73b9-40ef-863c-15dad735be3f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-02 08:00:33
15699	9d64904e-6ed7-4a84-b329-8dfd819a1047	9d64904e-73b9-40ef-863c-15dad735be3f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-02 08:00:33
15700	9d64904e-7294-4137-886d-a755c9b60bdb	9d64904e-73b9-40ef-863c-15dad735be3f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 08:00:33
15701	9d64904e-72de-4c50-be09-f3e497f6ec44	9d64904e-73b9-40ef-863c-15dad735be3f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":223,"memory":22,"hostname":"EderCortes"}	2024-11-02 08:00:33
15812	9d64affd-d21a-46ed-af04-2c5c88fbdf2e	9d64affd-f81c-4a69-838e-303dd5f6d669	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:29:09
15813	9d64affd-ebe0-4e61-9ea1-21aedeefd561	9d64affd-f81c-4a69-838e-303dd5f6d669	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"51.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"088d1fdbe045a08c3b0073ef22c7da32","hostname":"EderCortes"}	2024-11-02 09:29:09
15814	9d64affd-f128-4727-a6c0-fdced71a5996	9d64affd-f81c-4a69-838e-303dd5f6d669	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"3.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:29:09
15815	9d64affd-f17f-409a-b51e-bfc683cff2d7	9d64affd-f81c-4a69-838e-303dd5f6d669	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 09:29:09
15816	9d64affd-f678-41d4-bf41-373707c3319c	9d64affd-f81c-4a69-838e-303dd5f6d669	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:29:09
9386	9d52f78b-1e18-4d3b-9c31-336c229c7efb	9d52f78b-6891-4344-817d-8afff8f7299a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 14:04:19
9387	9d52f78b-6352-4520-82c6-6f6c8857b96c	9d52f78b-6891-4344-817d-8afff8f7299a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"149.43","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 14:04:19
9388	9d52f78b-63a7-4861-9fa8-80d7915c301d	9d52f78b-6891-4344-817d-8afff8f7299a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 14:04:19
9389	9d52f78b-674d-4ed2-8040-c56f1ba08e7a	9d52f78b-6891-4344-817d-8afff8f7299a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 14:04:19
9390	9d52f78b-67a8-4aee-a890-b2cd62a898db	9d52f78b-6891-4344-817d-8afff8f7299a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":375,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:04:19
15579	9d648d51-155b-4012-95e5-68148858a063	9d648d51-37b4-4f53-9c16-476a794e4eb2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 07:52:11
15580	9d648d51-2ed5-4457-affa-c9250b3d10ff	9d648d51-37b4-4f53-9c16-476a794e4eb2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 07:52:11
15581	9d648d51-2f5c-443d-a6d8-b11189f7659c	9d648d51-37b4-4f53-9c16-476a794e4eb2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-11-02 07:52:11
15582	9d648d51-35c1-480e-aaa7-96d3b4113336	9d648d51-37b4-4f53-9c16-476a794e4eb2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 07:52:12
15583	9d648d51-3633-4aee-9329-8a8378c29152	9d648d51-37b4-4f53-9c16-476a794e4eb2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":299,"memory":22,"hostname":"EderCortes"}	2024-11-02 07:52:12
15702	9d64904e-bf1a-475a-bd97-6c5d2412f3d9	9d64904e-dcb8-42b5-825e-e4f2224deddc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 08:00:33
15703	9d64904e-d765-403d-b425-456df11e0727	9d64904e-dcb8-42b5-825e-e4f2224deddc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-02 08:00:33
15704	9d64904e-d7db-43af-817e-30816dd62c44	9d64904e-dcb8-42b5-825e-e4f2224deddc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-02 08:00:33
15705	9d64904e-db8f-47b1-866e-4c9d0e9699e1	9d64904e-dcb8-42b5-825e-e4f2224deddc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 08:00:33
15706	9d64904e-dbd5-4fb6-a060-99891075c29d	9d64904e-dcb8-42b5-825e-e4f2224deddc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-11-02 08:00:33
15707	9d649050-41fe-447b-9248-0f163789c356	9d649050-5d3e-4d43-ae5c-dd1907a007b8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 08:00:34
15708	9d649050-588d-42d2-bc96-fcc8d3d67f91	9d649050-5d3e-4d43-ae5c-dd1907a007b8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"38.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 08:00:34
8075	9d52e697-ffa9-4028-8804-869838f4a205	9d52e698-28af-4514-ba2c-aaefc03392c6	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 13:16:56
8076	9d52e698-2685-4913-a071-2f668dd9ec28	9d52e698-28af-4514-ba2c-aaefc03392c6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:16:56
8077	9d52e698-2746-4b42-a632-c839596cf8a4	9d52e698-28af-4514-ba2c-aaefc03392c6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":282,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:16:56
15709	9d649050-58d9-4817-9233-3e937009dfc7	9d649050-5d3e-4d43-ae5c-dd1907a007b8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 08:00:34
15026	9d5ece86-e77a-4be2-9e08-471d1917bcdd	9d5ece87-4eb5-4cfb-bd54-c58895c35c1e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-30 11:19:34
15027	9d5ece87-4c40-4c30-81bf-30eb6c649df7	9d5ece87-4eb5-4cfb-bd54-c58895c35c1e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 11:19:34
15710	9d649050-5c09-4c56-bca5-d84536d0ade3	9d649050-5d3e-4d43-ae5c-dd1907a007b8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 08:00:34
9391	9d52f78b-b408-48d3-8afd-2a4aeca48930	9d52f78b-fe64-465c-9181-d41ebb2828d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 14:04:20
15028	9d5ece87-4d15-4533-a3ee-84ba417840a0	9d5ece87-4eb5-4cfb-bd54-c58895c35c1e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":523,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:19:34
15711	9d649050-5c4e-4bd6-b3ed-ea4f54074bc0	9d649050-5d3e-4d43-ae5c-dd1907a007b8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":413,"memory":22,"hostname":"EderCortes"}	2024-11-02 08:00:34
15817	9d64affd-f6ed-46f7-81ef-8e4fc98d6a73	9d64affd-f81c-4a69-838e-303dd5f6d669	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":329,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:29:09
8078	9d52e698-8031-4caf-b3df-732b5a129149	9d52e698-ce53-44d6-b2e2-8de1a2e53e01	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:16:56
8079	9d52e698-c62b-474e-a75c-9215e6aa01bc	9d52e698-ce53-44d6-b2e2-8de1a2e53e01	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"154.56","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:16:56
8080	9d52e698-c6a6-41b5-8f4b-7863bd7e4824	9d52e698-ce53-44d6-b2e2-8de1a2e53e01	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:16:56
8081	9d52e698-ccac-4dd2-ba62-a5f530dbf6c7	9d52e698-ce53-44d6-b2e2-8de1a2e53e01	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:16:56
8082	9d52e698-cd15-4031-bffa-246f3cef3612	9d52e698-ce53-44d6-b2e2-8de1a2e53e01	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":394,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:16:56
9392	9d52f78b-f76e-47eb-af80-34cf57bba47f	9d52f78b-fe64-465c-9181-d41ebb2828d6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"153.44","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-24 14:04:20
9393	9d52f78b-f7bb-491b-b1b1-6e08d11f2a76	9d52f78b-fe64-465c-9181-d41ebb2828d6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 14:04:20
9394	9d52f78b-f9a7-4e79-848f-2bffd57da75a	9d52f78b-fe64-465c-9181-d41ebb2828d6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"2.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 14:04:20
9395	9d52f78b-f9d6-42d0-8e5e-428ca0203f30	9d52f78b-fe64-465c-9181-d41ebb2828d6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 14:04:20
9396	9d52f78b-fd25-4a66-a439-6b153cf83bdd	9d52f78b-fe64-465c-9181-d41ebb2828d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 14:04:20
9397	9d52f78b-fd6c-4627-ab6a-34d97f9e1d25	9d52f78b-fe64-465c-9181-d41ebb2828d6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":363,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:04:20
15818	9d64afff-d2a3-45cd-8206-9e5ad0e0b56c	9d64b000-1d78-48b0-9bbe-9a38bbbe54cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:29:10
15819	9d64b000-178a-4048-a463-bff1e3a42ebd	9d64b000-1d78-48b0-9bbe-9a38bbbe54cf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"155.42","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 09:29:10
15820	9d64b000-17f6-4378-a5ea-4ff5988ad648	9d64b000-1d78-48b0-9bbe-9a38bbbe54cf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 09:29:10
15821	9d64b000-1b9f-43f4-b056-e4a487ae58bb	9d64b000-1d78-48b0-9bbe-9a38bbbe54cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 09:29:10
15822	9d64b000-1bff-4a3e-9001-8a50e01445ee	9d64b000-1d78-48b0-9bbe-9a38bbbe54cf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":346,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:29:10
8083	9d52e699-2ec8-4be1-9c8a-eb89b221ba24	9d52e699-5ab9-4fce-87ba-7b9a9b98e442	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:16:56
8084	9d52e699-54c8-4bfd-888d-869404462552	9d52e699-5ab9-4fce-87ba-7b9a9b98e442	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"53.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:16:56
8085	9d52e699-5522-44f2-acd6-a7c2986c7b2e	9d52e699-5ab9-4fce-87ba-7b9a9b98e442	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:16:56
8086	9d52e699-5924-4680-b247-b2d8884e8ebd	9d52e699-5ab9-4fce-87ba-7b9a9b98e442	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:16:56
8087	9d52e699-5973-4d95-b86c-e0407e64cc28	9d52e699-5ab9-4fce-87ba-7b9a9b98e442	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":339,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:16:56
9398	9d52f78d-b1e4-461b-a45d-52b6024296f9	9d52f78d-e378-4d04-9d76-1a3c64ec80e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 14:04:21
9399	9d52f78d-dc3e-48e5-8b65-00b1b1f10b3b	9d52f78d-e378-4d04-9d76-1a3c64ec80e0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"67.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 14:04:21
9400	9d52f78d-dcb8-471c-a1b6-6d3354736e5b	9d52f78d-e378-4d04-9d76-1a3c64ec80e0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 14:04:21
9401	9d52f78d-e1de-4d11-84f4-848d6ad08922	9d52f78d-e378-4d04-9d76-1a3c64ec80e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 14:04:21
9402	9d52f78d-e241-4b7d-a669-8f6bf13ce8a7	9d52f78d-e378-4d04-9d76-1a3c64ec80e0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":569,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:04:21
15904	9d64b2bb-fb18-4605-8bc2-c9c3d309b48d	9d64b2bc-2488-4bc6-8294-8bc6ee4de39f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 09:36:49
15905	9d64b2bc-2248-42b0-af21-56b161a8436e	9d64b2bc-2488-4bc6-8294-8bc6ee4de39f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:36:49
15906	9d64b2bc-232b-4585-8c6c-b5e2595ab70e	9d64b2bc-2488-4bc6-8294-8bc6ee4de39f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":331,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:36:49
8088	9d52e699-b02e-4b3f-bc25-755067d8d091	9d52e699-d615-41ab-9b5e-27bda8b403ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:16:57
8089	9d52e699-cccb-46e9-98fd-66ebba5aa7ee	9d52e699-d615-41ab-9b5e-27bda8b403ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc","time":"49.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 13:16:57
8090	9d52e699-cd12-4860-b289-9377462abc18	9d52e699-d615-41ab-9b5e-27bda8b403ca	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:16:57
8091	9d52e699-cef3-4c0a-be71-ded6a6cc0f63	9d52e699-d615-41ab-9b5e-27bda8b403ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6'","time":"2.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 13:16:57
8092	9d52e699-cf3f-424a-9c88-9d47954a3d67	9d52e699-d615-41ab-9b5e-27bda8b403ca	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:16:57
8093	9d52e699-d428-4ec8-a345-75770572b79a	9d52e699-d615-41ab-9b5e-27bda8b403ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:16:57
8094	9d52e699-d4a3-40f4-9896-58d309210f1a	9d52e699-d615-41ab-9b5e-27bda8b403ca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":300,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:16:57
15907	9d64b2bc-8fb9-4490-8ac3-dba16d57e136	9d64b2bc-b81d-43b0-bd05-0a21e4fb1587	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:36:49
15908	9d64b2bc-aab7-471d-9bc4-be716169d1b8	9d64b2bc-b81d-43b0-bd05-0a21e4fb1587	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 22\\n                        ","time":"54.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"f9344e277d181987f84c6dcddcb4342d","hostname":"EderCortes"}	2024-11-02 09:36:49
15909	9d64b2bc-ae92-4bfc-a925-180dfc41544c	9d64b2bc-b81d-43b0-bd05-0a21e4fb1587	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '22' order by \\"item_loans\\".\\"id\\" asc","time":"2.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:36:50
15910	9d64b2bc-aed0-40c2-a3f1-9b5c58b7e0c1	9d64b2bc-b81d-43b0-bd05-0a21e4fb1587	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-02 09:36:50
15911	9d64b2bc-b656-4e1c-8399-81a3cdf09378	9d64b2bc-b81d-43b0-bd05-0a21e4fb1587	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:36:50
15912	9d64b2bc-b6c3-441d-ab52-9782830fe1c8	9d64b2bc-b81d-43b0-bd05-0a21e4fb1587	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/22","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":22,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":70,"loans_codigo":22,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":71,"loans_codigo":22,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":72,"loans_codigo":22,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":73,"loans_codigo":22,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":74,"loans_codigo":22,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":75,"loans_codigo":22,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-04-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":313,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:36:50
8095	9d52e69c-1d38-4f69-a747-89403407a93d	9d52e69c-487d-4b14-a0b7-0c928a38853c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:16:58
8096	9d52e69c-4017-4f9d-9a3f-a2b6c6399b2f	9d52e69c-487d-4b14-a0b7-0c928a38853c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"56.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:16:58
8097	9d52e69c-40d0-4236-9d37-537d050f6466	9d52e69c-487d-4b14-a0b7-0c928a38853c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:16:58
8098	9d52e69c-4632-4e22-a9f9-d8c836e84d76	9d52e69c-487d-4b14-a0b7-0c928a38853c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:16:58
8099	9d52e69c-46c3-4158-8250-5d20ba380db8	9d52e69c-487d-4b14-a0b7-0c928a38853c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":491,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:16:58
15913	9d64b2be-8e58-4272-b498-9ac48d221112	9d64b2be-ac2e-4f51-bced-61db0ae65d4f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:36:51
15914	9d64b2be-a720-41e3-b347-8946e8db1d13	9d64b2be-ac2e-4f51-bced-61db0ae65d4f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 09:36:51
15915	9d64b2be-a772-4591-9f7a-13abfe2b7b2a	9d64b2be-ac2e-4f51-bced-61db0ae65d4f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 09:36:51
15916	9d64b2be-aac2-42dd-9275-4c15d2f73b77	9d64b2be-ac2e-4f51-bced-61db0ae65d4f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 09:36:51
15917	9d64b2be-ab0f-4b4a-af74-dd9e8a08f061	9d64b2be-ac2e-4f51-bced-61db0ae65d4f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","user-agent":"Mozilla\\/5.0 (iPhone; CPU iPhone OS 16_6 like Mac OS X) AppleWebKit\\/605.1.15 (KHTML, like Gecko) Version\\/16.6 Mobile\\/15E148 Safari\\/604.1","accept":"application\\/json, text\\/plain, *\\/*","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":242,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:36:51
15994	9d64b7e1-a6d5-4ccb-9097-1ddb89ef3fc6	9d64b7e1-cf71-4d30-adeb-9d3e7e845ac7	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 09:51:13
15995	9d64b7e1-cd67-421a-b07e-1dabcd221552	9d64b7e1-cf71-4d30-adeb-9d3e7e845ac7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:51:13
15996	9d64b7e1-ce41-483d-b072-1ef98f365694	9d64b7e1-cf71-4d30-adeb-9d3e7e845ac7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":325,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:51:13
15997	9d64b7e2-410a-4c4b-929f-027c031b054d	9d64b7e2-91b9-4e82-8924-d789ab25486d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:51:13
15998	9d64b7e2-8741-4a67-af3d-2001434bd281	9d64b7e2-91b9-4e82-8924-d789ab25486d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 22\\n                        ","time":"165.22","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"f9344e277d181987f84c6dcddcb4342d","hostname":"EderCortes"}	2024-11-02 09:51:13
15999	9d64b7e2-8b39-4048-b060-a2fe5e76bba5	9d64b7e2-91b9-4e82-8924-d789ab25486d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '22' order by \\"item_loans\\".\\"id\\" asc","time":"2.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:51:13
16000	9d64b7e2-8b76-4044-8c7a-4c3c167e226b	9d64b7e2-91b9-4e82-8924-d789ab25486d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-02 09:51:13
16001	9d64b7e2-9044-4fce-9dca-19e3812330c7	9d64b7e2-91b9-4e82-8924-d789ab25486d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:51:13
16002	9d64b7e2-90aa-4d37-a59b-b07103779f0f	9d64b7e2-91b9-4e82-8924-d789ab25486d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/22","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":22,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":70,"loans_codigo":22,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":71,"loans_codigo":22,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":72,"loans_codigo":22,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":73,"loans_codigo":22,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":74,"loans_codigo":22,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":75,"loans_codigo":22,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-04-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":446,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:51:13
16003	9d64b7e4-5f95-41fa-b12a-bd1204326891	9d64b7e4-7e57-4f36-8101-6411d8c2f891	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:51:14
16004	9d64b7e4-7979-4d59-8494-559e0c609634	9d64b7e4-7e57-4f36-8101-6411d8c2f891	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 09:51:14
16005	9d64b7e4-79d1-4859-a3de-f525d674878d	9d64b7e4-7e57-4f36-8101-6411d8c2f891	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 09:51:14
16006	9d64b7e4-7cfe-4498-b24d-6ad7e7e46875	9d64b7e4-7e57-4f36-8101-6411d8c2f891	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 09:51:14
8231	9d52e7c4-7295-405f-b2b1-4a186047ee77	9d52e7c4-90a0-49ef-a92b-e2d271a7ab8d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-24 13:20:12
8232	9d52e7c4-8f19-4746-8f92-b68279d7e59e	9d52e7c4-90a0-49ef-a92b-e2d271a7ab8d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-24 13:20:12
8233	9d52e7c4-8fb7-4521-afdc-f21fb7ee16b0	9d52e7c4-90a0-49ef-a92b-e2d271a7ab8d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:20:12
16007	9d64b7e4-7d4c-4827-84ce-0a0d477abb07	9d64b7e4-7e57-4f36-8101-6411d8c2f891	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:51:14
8234	9d52e7c4-dbc0-4331-ba1d-e1815672a937	9d52e7c5-2990-49cd-8cd4-1c56030ee903	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-24 13:20:13
8235	9d52e7c5-22e1-4cd4-a348-293395f679e9	9d52e7c5-2990-49cd-8cd4-1c56030ee903	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"158.40","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:20:13
8236	9d52e7c5-234f-41ce-958c-a358680342a6	9d52e7c5-2990-49cd-8cd4-1c56030ee903	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:20:13
8237	9d52e7c5-282c-41b0-8211-1aaac44ee00c	9d52e7c5-2990-49cd-8cd4-1c56030ee903	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-24 13:20:13
8238	9d52e7c5-2895-43f5-b8a4-52c7ed8b6553	9d52e7c5-2990-49cd-8cd4-1c56030ee903	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":360,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:20:13
16218	9d64bb76-759a-4074-aa02-f27f627c6848	9d64bb76-bd8d-4bbd-bb27-66be778bcebb	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 10:01:13
16219	9d64bb76-b966-4ca7-8092-e835d6d09190	9d64bb76-bd8d-4bbd-bb27-66be778bcebb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 10:01:14
19185	9d66d170-8c8c-44cd-802c-d1dfbeeae4fd	9d66d170-8f95-47ee-9c31-bcc4bc571775	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":938}	2024-11-03 10:54:20
8239	9d52e7c5-7466-4491-9145-8c4aa757e2c0	9d52e7c5-937a-4931-9ccd-c2394296fec6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-24 13:20:13
8240	9d52e7c5-8e39-4f02-a155-95f93e8ec647	9d52e7c5-937a-4931-9ccd-c2394296fec6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:20:13
8241	9d52e7c5-8e86-47b4-a08d-d6375f34c487	9d52e7c5-937a-4931-9ccd-c2394296fec6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:20:13
8242	9d52e7c5-925a-437c-a64d-153e569529eb	9d52e7c5-937a-4931-9ccd-c2394296fec6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-24 13:20:13
8243	9d52e7c5-929d-4117-a9b3-79dd8158b186	9d52e7c5-937a-4931-9ccd-c2394296fec6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:20:13
16220	9d64bb76-bb5a-40e6-92d4-4d6684b6f8ca	9d64bb76-bd8d-4bbd-bb27-66be778bcebb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":715,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:01:14
8244	9d52e7c5-d6a0-4648-a9a1-e1837601ca1d	9d52e7c5-f8af-4210-b463-b8ab88023f4d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-24 13:20:13
8245	9d52e7c5-efe2-41de-bab4-82f053f1eb3d	9d52e7c5-f8af-4210-b463-b8ab88023f4d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc","time":"42.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 13:20:13
8246	9d52e7c5-f02e-476b-8d6a-9dda13451af6	9d52e7c5-f8af-4210-b463-b8ab88023f4d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:20:13
8247	9d52e7c5-f222-432f-88b3-b73716dbfd8d	9d52e7c5-f8af-4210-b463-b8ab88023f4d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6'","time":"3.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 13:20:13
6519	9d52d279-6608-4218-88ae-2e5fb53f8eef	9d52d279-b72e-4888-9d2e-b82621ce6cff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:20:40
6520	9d52d279-b51f-4246-90bf-08db2a9c744c	9d52d279-b72e-4888-9d2e-b82621ce6cff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:20:40
6521	9d52d279-b5ec-49b9-be18-42abeb30d8af	9d52d279-b72e-4888-9d2e-b82621ce6cff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":413,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:20:40
8248	9d52e7c5-f264-4959-b984-07d2e8cd2e69	9d52e7c5-f8af-4210-b463-b8ab88023f4d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:20:13
8249	9d52e7c5-f711-49cd-9516-7b7be90e8132	9d52e7c5-f8af-4210-b463-b8ab88023f4d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-24 13:20:13
8250	9d52e7c5-f77e-4cde-8e6d-7642ea024651	9d52e7c5-f8af-4210-b463-b8ab88023f4d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:20:13
16114	9d64b999-fa30-4d32-a426-d209d27bf73f	9d64b99a-17e4-46bd-a61d-b2e0efe78c3c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-02 09:56:01
16115	9d64b99a-1677-40b4-92f3-d2c8289a8777	9d64b99a-17e4-46bd-a61d-b2e0efe78c3c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-02 09:56:01
16116	9d64b99a-1709-46ab-a868-c7005756efd9	9d64b99a-17e4-46bd-a61d-b2e0efe78c3c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":220,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:56:01
16221	9d64bb77-c581-4c86-997a-25d7ec9de1fa	9d64bb78-02cd-416c-80f6-fac2cb63d3fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 10:01:14
6522	9d52d27a-0dfd-453a-aca0-21e40ef7fabc	9d52d27a-3578-4e7e-a402-f22c5766415d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:20:40
6523	9d52d27a-2fcc-4fd5-a332-6add2a0b6f77	9d52d27a-3578-4e7e-a402-f22c5766415d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"59.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:20:41
6524	9d52d27a-3026-4c27-ab91-7f3f719a22e2	9d52d27a-3578-4e7e-a402-f22c5766415d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:20:41
6525	9d52d27a-345d-4ea8-a90f-60eaf636d5e9	9d52d27a-3578-4e7e-a402-f22c5766415d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 12:20:41
6526	9d52d27a-34a5-4712-ae23-bbfbe84b687f	9d52d27a-3578-4e7e-a402-f22c5766415d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":292,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:20:41
8251	9d52e7c7-90a2-4df1-8f50-6b08c95e844a	9d52e7c7-c73b-476a-8247-7ddcc8b27dee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-24 13:20:14
8252	9d52e7c7-c0ad-44f9-9b34-a393c6a89469	9d52e7c7-c73b-476a-8247-7ddcc8b27dee	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"73.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:20:15
8253	9d52e7c7-c113-462a-b2ea-cdc34acb3336	9d52e7c7-c73b-476a-8247-7ddcc8b27dee	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:20:15
8254	9d52e7c7-c4fd-47ee-b347-7595fc6cf514	9d52e7c7-c73b-476a-8247-7ddcc8b27dee	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 13:20:15
8255	9d52e7c7-c5a1-442f-8b96-11e3f8b9f92b	9d52e7c7-c73b-476a-8247-7ddcc8b27dee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":555,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:20:15
16117	9d64b99a-68be-4ec6-a835-ade8fe538f97	9d64b99a-8870-4070-94f5-78f37646028c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-02 09:56:01
16118	9d64b99a-7fe3-4d19-ae35-89b1b9ab567e	9d64b99a-8870-4070-94f5-78f37646028c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 22\\n                        ","time":"46.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"f9344e277d181987f84c6dcddcb4342d","hostname":"EderCortes"}	2024-11-02 09:56:02
16119	9d64b99a-8377-46e2-9f5a-6877261d2f43	9d64b99a-8870-4070-94f5-78f37646028c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '22' order by \\"item_loans\\".\\"id\\" asc","time":"2.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:56:02
16120	9d64b99a-83ac-427d-b3e3-9fa112688005	9d64b99a-8870-4070-94f5-78f37646028c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-02 09:56:02
16121	9d64b99a-873b-4c9e-9ee3-f1a894d09e3c	9d64b99a-8870-4070-94f5-78f37646028c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-02 09:56:02
6527	9d52d27a-8e0d-4df4-9e45-e189a9464a36	9d52d27a-afd5-4087-9487-1a4da30beacc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 12:20:41
6528	9d52d27a-aa43-43a3-891f-3cbeb9a4bc0a	9d52d27a-afd5-4087-9487-1a4da30beacc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:20:41
6529	9d52d27a-aa9c-4a44-bc6d-34c6cb7dbdae	9d52d27a-afd5-4087-9487-1a4da30beacc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:20:41
6530	9d52d27a-aeb5-4a5e-8d60-d03083e3376b	9d52d27a-afd5-4087-9487-1a4da30beacc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 12:20:41
6531	9d52d27a-af02-48ac-9f20-4bb76b8a1126	9d52d27a-afd5-4087-9487-1a4da30beacc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":292,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:20:41
16122	9d64b99a-8789-4468-85cf-947e833a0012	9d64b99a-8870-4070-94f5-78f37646028c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/22","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":22,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":70,"loans_codigo":22,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":71,"loans_codigo":22,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":72,"loans_codigo":22,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":73,"loans_codigo":22,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":74,"loans_codigo":22,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":75,"loans_codigo":22,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-04-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:56:02
16222	9d64bb77-eeb7-4742-ba26-f667131a8ae1	9d64bb78-02cd-416c-80f6-fac2cb63d3fd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"74.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"088d1fdbe045a08c3b0073ef22c7da32","hostname":"EderCortes"}	2024-11-02 10:01:14
16223	9d64bb77-f577-4d59-94bc-061aaae5dfff	9d64bb78-02cd-416c-80f6-fac2cb63d3fd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"3.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 10:01:14
16224	9d64bb77-f5d8-46d1-9601-9e690b78b583	9d64bb78-02cd-416c-80f6-fac2cb63d3fd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 10:01:14
16225	9d64bb78-0066-42c4-8d86-366738b93002	9d64bb78-02cd-416c-80f6-fac2cb63d3fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 10:01:14
16226	9d64bb78-010b-47b4-88c4-59ccca762ff6	9d64bb78-02cd-416c-80f6-fac2cb63d3fd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":636,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:01:14
6532	9d52d27b-0455-4c9e-b663-3eaec2faca03	9d52d27b-52c7-490d-b014-f0b53fba5492	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 12:20:41
6533	9d52d27b-4bde-4427-955c-4dd8d1cce731	9d52d27b-52c7-490d-b014-f0b53fba5492	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '1' order by \\"id\\" asc","time":"156.76","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:20:41
6534	9d52d27b-4c35-412f-91ec-db52bed3f773	9d52d27b-52c7-490d-b014-f0b53fba5492	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:20:41
6535	9d52d27b-4dbf-47c4-84c9-ad0d991eade9	9d52d27b-52c7-490d-b014-f0b53fba5492	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1'","time":"1.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:20:41
6536	9d52d27b-4dee-4946-8160-e638b0e65c22	9d52d27b-52c7-490d-b014-f0b53fba5492	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 12:20:41
6537	9d52d27b-5199-4d4d-87f7-4c2886271aa2	9d52d27b-52c7-490d-b014-f0b53fba5492	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 12:20:41
6538	9d52d27b-51ec-4c3f-bef4-d0524605e39c	9d52d27b-52c7-490d-b014-f0b53fba5492	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}],"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]},"duration":403,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:20:41
16123	9d64b99b-b005-4f2d-8b0c-a2cf41b44119	9d64b99b-d9d8-4a05-97f5-02757e676a0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-02 09:56:02
16124	9d64b99b-d177-4004-9b13-9d9ecf85ee0d	9d64b99b-d9d8-4a05-97f5-02757e676a0d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"57.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 09:56:02
16125	9d64b99b-d1f0-493c-8f19-63f72060e1f0	9d64b99b-d9d8-4a05-97f5-02757e676a0d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 09:56:02
16126	9d64b99b-d833-4eae-887a-6c149bde395c	9d64b99b-d9d8-4a05-97f5-02757e676a0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-02 09:56:02
16127	9d64b99b-d89e-41b1-9db6-1a0118d7f961	9d64b99b-d9d8-4a05-97f5-02757e676a0d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":450,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:56:02
16227	9d64bb7a-87cf-403c-852d-066d2e8bf83d	9d64bb7a-e0b0-4f2c-8a22-43467ff13f01	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 10:01:16
16228	9d64bb7a-d5f6-4b90-b917-6dd5cd02a78a	9d64bb7a-e0b0-4f2c-8a22-43467ff13f01	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"164.10","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 10:01:16
16229	9d64bb7a-d666-472d-bdd2-0d92469e58fa	9d64bb7a-e0b0-4f2c-8a22-43467ff13f01	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 10:01:16
16230	9d64bb7a-de8d-4359-b9c9-0bc0a04fa7c0	9d64bb7a-e0b0-4f2c-8a22-43467ff13f01	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 10:01:16
6539	9d52d27c-d2e9-4d42-bf32-d3361d90cce8	9d52d27c-f4bd-4c19-9c0e-7939e04b6f90	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 12:20:42
6540	9d52d27c-ef01-492d-a353-028553244444	9d52d27c-f4bd-4c19-9c0e-7939e04b6f90	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:20:42
6541	9d52d27c-ef62-4369-ae90-8459345c8790	9d52d27c-f4bd-4c19-9c0e-7939e04b6f90	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:20:42
6542	9d52d27c-f35c-458b-a5e3-5935903dbfbc	9d52d27c-f4bd-4c19-9c0e-7939e04b6f90	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 12:20:42
6543	9d52d27c-f3a7-4e5e-9d10-4371c72d19a3	9d52d27c-f4bd-4c19-9c0e-7939e04b6f90	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":402,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:20:42
16231	9d64bb7a-df18-4dc1-bf8e-8ea13fe1ab15	9d64bb7a-e0b0-4f2c-8a22-43467ff13f01	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":513,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:01:16
9579	9d53b6b7-5fe2-4fd8-962b-26f4145a2379	9d53b6bb-bc32-40f6-98d2-fff99a782352	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 22:58:53
9580	9d53b6bb-6a25-46c0-bb5b-851fa5aa71a3	9d53b6bb-bc32-40f6-98d2-fff99a782352	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 22:58:55
9581	9d53b6bb-8e4b-485e-816c-e726ed021f46	9d53b6bb-bc32-40f6-98d2-fff99a782352	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":19586642,"memory":22,"hostname":"EderCortes"}	2024-10-24 22:58:55
9582	9d53b6bc-54aa-454d-adb3-4f8d974c59be	9d53b6be-0b94-40bd-b80f-8259884bac80	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 22:58:56
9583	9d53b6bd-1bd1-457c-850a-39ed56a44671	9d53b6be-0b94-40bd-b80f-8259884bac80	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"150.26","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 22:58:56
9584	9d53b6bd-1c4f-41c1-ae04-dd7ab90ecd25	9d53b6be-0b94-40bd-b80f-8259884bac80	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 22:58:56
9585	9d53b6be-0a73-43ee-b270-b38cd3157359	9d53b6be-0b94-40bd-b80f-8259884bac80	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 22:58:57
9586	9d53b6be-0ab6-4f11-b8ac-bc3e1dad110e	9d53b6be-0b94-40bd-b80f-8259884bac80	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":1380,"memory":22,"hostname":"EderCortes"}	2024-10-24 22:58:57
16323	9d64c2ea-d4ef-4345-ba1f-109b3f560796	9d64c2ea-f96d-4af0-80f1-0998b0177d48	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 10:22:04
16324	9d64c2ea-f782-4dd4-9876-b1bf845c8e0f	9d64c2ea-f96d-4af0-80f1-0998b0177d48	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 10:22:04
16325	9d64c2ea-f83a-41cc-8eb1-165948594f31	9d64c2ea-f96d-4af0-80f1-0998b0177d48	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":308,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:22:04
9587	9d53b6be-4a15-460d-bf87-8ae9689f9f17	9d53b6be-9370-4133-be88-92c72d5b9446	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 22:58:57
9588	9d53b6be-8e76-4566-83a4-4951f0dfbbd6	9d53b6be-9370-4133-be88-92c72d5b9446	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"153.95","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 22:58:57
9589	9d53b6be-8ec2-4cf6-9065-fc1fa62fcf71	9d53b6be-9370-4133-be88-92c72d5b9446	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 22:58:57
9590	9d53b6be-924b-4966-ad89-2685e3b4674b	9d53b6be-9370-4133-be88-92c72d5b9446	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 22:58:57
9591	9d53b6be-9293-468e-aae4-64cc0212d22d	9d53b6be-9370-4133-be88-92c72d5b9446	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-10-24 22:58:57
16326	9d64c2eb-566e-4705-af0f-0df0c9f4db05	9d64c2eb-a433-4e47-a575-c33169483840	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 10:22:04
16327	9d64c2eb-9b14-49a2-8a27-a3ca2f45242d	9d64c2eb-a433-4e47-a575-c33169483840	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"162.40","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 10:22:05
7258	9d52dcb5-3cd9-4962-950e-a04a7071815e	9d52dcb5-6b4d-428e-a040-2ff0bf448152	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 12:49:17
7259	9d52dcb5-6948-4bfb-88b6-383889fafcce	9d52dcb5-6b4d-428e-a040-2ff0bf448152	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:49:17
7260	9d52dcb5-6a1e-4032-8b57-9c905b24a751	9d52dcb5-6b4d-428e-a040-2ff0bf448152	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":360,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:49:17
16328	9d64c2eb-9ede-4e75-809b-2a2974e83d55	9d64c2eb-a433-4e47-a575-c33169483840	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 10:22:05
16329	9d64c2eb-9f16-40b1-9b64-948151e0e7bd	9d64c2eb-a433-4e47-a575-c33169483840	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 10:22:05
8387	9d52eb5b-0461-42d0-9fd4-9a69e9a5cacb	9d52eb5b-4e12-4df5-9129-a5572858ff31	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 13:30:14
16330	9d64c2eb-a30a-4041-a47d-f05d5680397c	9d64c2eb-a433-4e47-a575-c33169483840	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 10:22:05
8388	9d52eb5b-4a61-4ff3-a9f9-c436bf020aa1	9d52eb5b-4e12-4df5-9129-a5572858ff31	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:30:15
8389	9d52eb5b-4bdb-4d8d-88bf-fd13a91cedaa	9d52eb5b-4e12-4df5-9129-a5572858ff31	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":684,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:30:15
16331	9d64c2eb-a357-4055-bf37-8c580caa1bdc	9d64c2eb-a433-4e47-a575-c33169483840	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":382,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:22:05
7261	9d52dcb5-dc1b-4503-be96-aee00675366a	9d52dcb6-0273-4229-bfe8-44001e37586a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:49:17
7262	9d52dcb5-fc3c-4e66-b9f1-749fa4b20a57	9d52dcb6-0273-4229-bfe8-44001e37586a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:49:17
7263	9d52dcb5-fc97-4ab3-9eb3-8509d02106c5	9d52dcb6-0273-4229-bfe8-44001e37586a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:49:17
7264	9d52dcb6-0157-4a52-9878-71560450ac9d	9d52dcb6-0273-4229-bfe8-44001e37586a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:49:17
7265	9d52dcb6-019b-4184-a3b6-9ed752f9d336	9d52dcb6-0273-4229-bfe8-44001e37586a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:49:17
8390	9d52eb5b-c0fb-4df1-ac9a-2e4a929416b3	9d52eb5b-ec0f-4cce-bbdd-76fa0fa0439e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:30:15
8391	9d52eb5b-e1d3-48e2-9450-a74e99cd29e4	9d52eb5b-ec0f-4cce-bbdd-76fa0fa0439e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:30:15
8392	9d52eb5b-e22a-43fb-bcd5-66cc58ff1a2a	9d52eb5b-ec0f-4cce-bbdd-76fa0fa0439e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:30:15
8393	9d52eb5b-eaac-4278-ba29-4c967d481477	9d52eb5b-ec0f-4cce-bbdd-76fa0fa0439e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:30:15
8394	9d52eb5b-eb18-431d-bd49-f9eff4f41c2f	9d52eb5b-ec0f-4cce-bbdd-76fa0fa0439e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:30:15
16332	9d64c2ed-8c41-43f0-be2e-306aa6bc94ca	9d64c2ed-e12c-4511-9e43-51c816e881e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 10:22:06
16333	9d64c2ed-db71-4f58-a540-6f4af02e91e7	9d64c2ed-e12c-4511-9e43-51c816e881e8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"168.78","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 10:22:06
16334	9d64c2ed-dbce-4a81-825e-4b1a8aa9144c	9d64c2ed-e12c-4511-9e43-51c816e881e8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 10:22:06
16335	9d64c2ed-dfa3-4937-930a-c69d4b4ba7a0	9d64c2ed-e12c-4511-9e43-51c816e881e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 10:22:06
16336	9d64c2ed-e00c-43b6-a722-9c68a46b863a	9d64c2ed-e12c-4511-9e43-51c816e881e8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":486,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:22:06
7266	9d52dcb6-5ae3-43a8-8233-bd640e2f44c2	9d52dcb6-802f-4ed4-bbdc-49e08f18b2ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:49:18
7267	9d52dcb6-7969-495d-87b8-955816dc38c4	9d52dcb6-802f-4ed4-bbdc-49e08f18b2ff	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:49:18
7268	9d52dcb6-79cf-4352-ab62-f92d3b3344b0	9d52dcb6-802f-4ed4-bbdc-49e08f18b2ff	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:49:18
7269	9d52dcb6-7e58-4a9d-a163-33a8c1e682cb	9d52dcb6-802f-4ed4-bbdc-49e08f18b2ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:49:18
7270	9d52dcb6-7ec8-47fd-9065-9f2dc996822c	9d52dcb6-802f-4ed4-bbdc-49e08f18b2ff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":303,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:49:18
8395	9d52eb5c-44d6-4e3a-8973-1706b114a25b	9d52eb5c-8cd0-44fd-b654-d3dfaf4b4855	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:30:15
8396	9d52eb5c-879d-4290-b35b-18c96f5849e6	9d52eb5c-8cd0-44fd-b654-d3dfaf4b4855	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"145.76","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:30:15
8397	9d52eb5c-87ec-4ccf-a130-75c1714dd56a	9d52eb5c-8cd0-44fd-b654-d3dfaf4b4855	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:30:15
8398	9d52eb5c-8b9d-4f45-be9a-b67629a04b69	9d52eb5c-8cd0-44fd-b654-d3dfaf4b4855	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:30:15
8399	9d52eb5c-8be1-4a2e-8b3d-a8f85147221d	9d52eb5c-8cd0-44fd-b654-d3dfaf4b4855	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":395,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:30:15
7271	9d52dcb6-d462-4177-854e-6d49ee37e047	9d52dcb6-fb93-4747-8b85-0fd6575ecc71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:49:18
7272	9d52dcb6-f0f2-4300-9cd7-4c61a37f4bce	9d52dcb6-fb93-4747-8b85-0fd6575ecc71	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"50.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:49:18
7273	9d52dcb6-f163-4a92-b3c3-23e4bd4b4f2c	9d52dcb6-fb93-4747-8b85-0fd6575ecc71	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:49:18
7274	9d52dcb6-f3cb-47f9-b8c6-2de633dba82d	9d52dcb6-fb93-4747-8b85-0fd6575ecc71	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"3.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:49:18
7275	9d52dcb6-f40e-4857-9c0d-74381e2045d5	9d52dcb6-fb93-4747-8b85-0fd6575ecc71	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:49:18
7276	9d52dcb6-f9a8-4a1c-a0db-f5b1893f7089	9d52dcb6-fb93-4747-8b85-0fd6575ecc71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:49:18
7277	9d52dcb6-fa15-40ca-9d98-4b38b47c10d7	9d52dcb6-fb93-4747-8b85-0fd6575ecc71	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":294,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:49:18
8400	9d52eb5c-d5cb-4566-aabd-c26a0e3c4cdd	9d52eb5c-f3de-4a50-a354-7a34d447615d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:30:16
8401	9d52eb5c-ed18-4f88-a82b-37187a00dd5e	9d52eb5c-f3de-4a50-a354-7a34d447615d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc","time":"39.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 13:30:16
8402	9d52eb5c-ed60-4922-8264-ce4da3181c75	9d52eb5c-f3de-4a50-a354-7a34d447615d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:30:16
8403	9d52eb5c-ef2b-4002-9a17-914d68601925	9d52eb5c-f3de-4a50-a354-7a34d447615d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6'","time":"2.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 13:30:16
8404	9d52eb5c-ef61-4e17-bdc3-0ef2ac9de8ab	9d52eb5c-f3de-4a50-a354-7a34d447615d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:30:16
8405	9d52eb5c-f2a2-4526-afad-f46b915acd2a	9d52eb5c-f3de-4a50-a354-7a34d447615d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:30:16
8406	9d52eb5c-f306-4a6c-a341-4714937b7ba5	9d52eb5c-f3de-4a50-a354-7a34d447615d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:30:16
7278	9d52dcb8-da7a-46ce-b2e5-7966d96ccb61	9d52dcb8-fe33-4043-89c7-5bca0d9ce131	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:49:19
7279	9d52dcb8-f76e-4f39-aa56-1a83d7110a29	9d52dcb8-fe33-4043-89c7-5bca0d9ce131	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"47.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:49:19
7280	9d52dcb8-f7f5-48ba-ae8e-4585065f7f2a	9d52dcb8-fe33-4043-89c7-5bca0d9ce131	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:49:19
7281	9d52dcb8-fca6-482f-93f1-4ddd8247efa6	9d52dcb8-fe33-4043-89c7-5bca0d9ce131	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:49:19
5907	9d52546f-188a-43b1-b59a-174115ca857c	9d52546f-4015-48bf-9367-c6b86da2d9ee	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 06:28:14
5908	9d52546f-3d7d-4fb8-853b-bb48464eae28	9d52546f-4015-48bf-9367-c6b86da2d9ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 06:28:14
5909	9d52546f-3ecd-4218-8524-f51baf957a92	9d52546f-4015-48bf-9367-c6b86da2d9ee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":327,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:28:14
7282	9d52dcb8-fcf4-4b7c-adc9-33b6efadb221	9d52dcb8-fe33-4043-89c7-5bca0d9ce131	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":367,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:49:19
8407	9d52eb5f-00cf-4e3e-b075-ed553a6ba923	9d52eb5f-23c3-479f-a848-4b830221ff02	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:30:17
8408	9d52eb5f-1cee-4470-b0e8-556b1c528bfa	9d52eb5f-23c3-479f-a848-4b830221ff02	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:30:17
8409	9d52eb5f-1d64-49a3-9de2-e229a54275ab	9d52eb5f-23c3-479f-a848-4b830221ff02	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:30:17
8410	9d52eb5f-21ed-4c1c-a5cf-390c2cd03c87	9d52eb5f-23c3-479f-a848-4b830221ff02	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:30:17
8411	9d52eb5f-226a-45d5-bd73-9bf96fc99c6b	9d52eb5f-23c3-479f-a848-4b830221ff02	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:30:17
5910	9d52546f-99ee-4cf3-904d-526d8f5a48bb	9d52546f-bbd0-4465-876f-e904bcf4e113	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 06:28:14
5911	9d52546f-b444-4cc2-9d38-9aa6788f6ce2	9d52546f-bbd0-4465-876f-e904bcf4e113	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":130,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 06:28:14
5912	9d52546f-b499-4af5-94bc-0a51393c1a3e	9d52546f-bbd0-4465-876f-e904bcf4e113	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 06:28:14
5913	9d52546f-ba82-43ac-a74e-a8e04c9377c4	9d52546f-bbd0-4465-876f-e904bcf4e113	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 06:28:14
5914	9d52546f-bae1-4f52-92ac-ff9a8d42e655	9d52546f-bbd0-4465-876f-e904bcf4e113	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":285,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:28:14
16413	9d64c98d-ed2d-4274-aa11-7cef21fbd23c	9d64c98e-1bd1-4f5d-b17b-53a4c2607614	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 10:40:38
16414	9d64c98e-1944-4830-8b4f-6b394da953d9	9d64c98e-1bd1-4f5d-b17b-53a4c2607614	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 10:40:38
11369	9d5cbdb9-1e5b-416b-a426-47a822f43fa9	9d5cbdb9-3a56-4594-9867-97646e880bf0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 10:40:55
11370	9d5cbdb9-38c5-45a0-a4e6-6a0182b47ebc	9d5cbdb9-3a56-4594-9867-97646e880bf0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 10:40:55
16415	9d64c98e-1a35-4356-8ffd-ed9cd2ea6bb5	9d64c98e-1bd1-4f5d-b17b-53a4c2607614	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":313,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:40:38
5915	9d525470-0333-4275-b4bf-a5bd3a46f282	9d525470-20e9-4b2c-b5c0-f01f65d75a4c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 06:28:15
5916	9d525470-1be1-4283-89a9-ab176a143307	9d525470-20e9-4b2c-b5c0-f01f65d75a4c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":130,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 06:28:15
5917	9d525470-1c2f-4c51-9d57-061aec591ccf	9d525470-20e9-4b2c-b5c0-f01f65d75a4c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 06:28:15
5918	9d525470-1fb2-429a-bfa7-94035c25395e	9d525470-20e9-4b2c-b5c0-f01f65d75a4c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 06:28:15
5919	9d525470-1ffe-4876-b938-5cbf17b5ae4f	9d525470-20e9-4b2c-b5c0-f01f65d75a4c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":245,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:28:15
11371	9d5cbdb9-3959-4de9-bba5-959d3d5fa4b2	9d5cbdb9-3a56-4594-9867-97646e880bf0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:40:55
16416	9d64c98e-8af4-4f65-be47-f8c51fb102e0	9d64c98e-b2e8-49ca-96f8-0b151b39dace	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 10:40:38
16417	9d64c98e-a474-4617-8e82-bc2b0fdeb1c3	9d64c98e-b2e8-49ca-96f8-0b151b39dace	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"51.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 10:40:38
12791	9d5cecde-795a-4466-a50d-56fa7fe1025a	9d5cecde-9bae-426c-be17-80c06e992fde	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 12:52:45
12792	9d5cecde-969f-47dd-bbe8-00422e0df786	9d5cecde-9bae-426c-be17-80c06e992fde	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"51.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":180,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 12:52:45
12793	9d5cecde-96e8-4b6e-b350-5a1c49132e0f	9d5cecde-9bae-426c-be17-80c06e992fde	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 12:52:45
12794	9d5cecde-9a74-4545-a9e9-50fee611b27a	9d5cecde-9bae-426c-be17-80c06e992fde	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 12:52:45
12795	9d5cecde-9ab5-49db-a8e3-dcbbf3332851	9d5cecde-9bae-426c-be17-80c06e992fde	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:45
16418	9d64c98e-aa17-4131-9083-2c5772527da9	9d64c98e-b2e8-49ca-96f8-0b151b39dace	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"3.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 10:40:38
16419	9d64c98e-aa5f-4846-a2da-1ebd370d1bc9	9d64c98e-b2e8-49ca-96f8-0b151b39dace	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 10:40:38
16420	9d64c98e-b14d-4616-a187-fa6375691f42	9d64c98e-b2e8-49ca-96f8-0b151b39dace	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 10:40:38
5920	9d525472-6032-4ef6-9b6e-8a0bfb3e52b0	9d525472-7f09-4c0e-a601-7eaebcd31b58	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 06:28:16
5921	9d525472-797d-4324-ad48-55b4345e054d	9d525472-7f09-4c0e-a601-7eaebcd31b58	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 06:28:16
5922	9d525472-79cd-4b54-a242-176bb6844e40	9d525472-7f09-4c0e-a601-7eaebcd31b58	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 06:28:16
5923	9d525472-7d6b-4706-840f-ae868d44bdcd	9d525472-7f09-4c0e-a601-7eaebcd31b58	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 06:28:16
5924	9d525472-7db3-4fb4-9183-ff7f3158cef3	9d525472-7f09-4c0e-a601-7eaebcd31b58	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-10-24 06:28:16
11372	9d5cbdb9-8174-41df-9161-1fd39f758a95	9d5cbdb9-9fbd-45b3-8969-7c171a821ddb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 10:40:56
11373	9d5cbdb9-9746-4342-9f67-057a2c17d265	9d5cbdb9-9fbd-45b3-8969-7c171a821ddb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 1\\n                        ","time":"44.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"2bd5a29c69f6bbb290fc49b79286632e","hostname":"EderCortes"}	2024-10-29 10:40:56
11374	9d5cbdb9-9adf-403c-88ce-59d6032d29c1	9d5cbdb9-9fbd-45b3-8969-7c171a821ddb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1' order by \\"item_loans\\".\\"id\\" asc","time":"2.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 10:40:56
11375	9d5cbdb9-9b0f-4728-b77b-50b9955cd3f9	9d5cbdb9-9fbd-45b3-8969-7c171a821ddb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 10:40:56
11376	9d5cbdb9-9e96-46b3-8f87-3de7d8c27526	9d5cbdb9-9fbd-45b3-8969-7c171a821ddb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 10:40:56
11377	9d5cbdb9-9eda-453f-96dd-62bce58ab83d	9d5cbdb9-9fbd-45b3-8969-7c171a821ddb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":1,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]}},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:40:56
12796	9d5cecde-e17a-4e4e-b8ef-1d1279d1f4cb	9d5cecde-fede-4176-8803-f90d68c7c081	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 12:52:45
12797	9d5cecde-fa3b-4458-877d-6af8102f0cf6	9d5cecde-fede-4176-8803-f90d68c7c081	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":180,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 12:52:45
12798	9d5cecde-fa83-4f26-a625-6a20cf8b6249	9d5cecde-fede-4176-8803-f90d68c7c081	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 12:52:45
12799	9d5cecde-fde3-4991-9b4b-896d1dff51d8	9d5cecde-fede-4176-8803-f90d68c7c081	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 12:52:45
6300	9d52641d-f4cf-422e-a22d-b2160fd7307a	9d52641e-2768-4680-9ade-89ffed605d05	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 07:12:05
6301	9d52641e-2431-4785-a606-c900bf41d06a	9d52641e-2768-4680-9ade-89ffed605d05	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 07:12:05
6302	9d52641e-25bc-4c08-af0f-6c3d64641827	9d52641e-2768-4680-9ade-89ffed605d05	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abfrom\\u00bb\\nLINE 14:     from loans l\\n             ^ (Connection: pgsql, SQL: \\n    select l.id,\\n        l.loans_documento,\\n        l.loans_nombre,\\n        l.loans_apellido_uno,\\n        l.loans_fecha,\\n        l.loans_valor_prestado,\\n        l.loans_cuotas,\\n        l.loans_estado,\\n        l.loans_intereses,\\n        ucl.name as cliente,\\n        uco.name as cobrador,\\n        ure.name as recomendador,\\n    from loans l\\n    join users ucl on l.user_customer = ucl.id\\n    join users uco on l.user_cobrador = uco.id\\n    left join users ure on l.user_recomendacion = ure.id\\n)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":550,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:12:05
11378	9d5cbdbb-5d10-4741-8a3d-d621a2195bea	9d5cbdbb-7be0-45f1-a014-40a786028c2d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 10:40:57
11379	9d5cbdbb-7661-4951-ba1b-123c61fd297f	9d5cbdbb-7be0-45f1-a014-40a786028c2d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 10:40:57
11380	9d5cbdbb-76ac-470b-b69c-4b5492c11841	9d5cbdbb-7be0-45f1-a014-40a786028c2d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 10:40:57
11381	9d5cbdbb-7a53-4e5a-9bc1-7f5a8205d8ee	9d5cbdbb-7be0-45f1-a014-40a786028c2d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 10:40:57
9862	9d56b48e-ab27-4040-a459-b7ff24f897f3	9d56b48e-d05c-4cd0-b19d-24f66f7b8ee7	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 10:40:19
9863	9d56b48e-cdfe-417b-a3ff-3543ca610f70	9d56b48e-d05c-4cd0-b19d-24f66f7b8ee7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 10:40:20
9864	9d56b48e-cf06-4d6e-af2b-fd451b63fece	9d56b48e-d05c-4cd0-b19d-24f66f7b8ee7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":339,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:40:20
11382	9d5cbdbb-7aa7-440a-a55b-bd9935daf2ba	9d5cbdbb-7be0-45f1-a014-40a786028c2d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:40:57
16421	9d64c98e-b1bb-4e20-a9cb-ef1804d04bf5	9d64c98e-b2e8-49ca-96f8-0b151b39dace	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":338,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:40:38
30574	9d693ff9-c2b3-4ed5-a0d0-f91d7a779c71	9d693ff9-e1b8-4400-b943-b5402549af89	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 15:55:04
9737	9d56ac40-b342-473d-b083-454dd4166802	9d56ac40-f8ee-4daf-a84d-56e5ae70e030	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 10:17:06
9738	9d56ac40-f76a-4af8-ad86-2e478683a489	9d56ac40-f8ee-4daf-a84d-56e5ae70e030	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 10:17:06
9739	9d56ac40-f7fe-47f2-8186-8bbe58940705	9d56ac40-f8ee-4daf-a84d-56e5ae70e030	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:17:06
41356	9d6ccc69-bedb-40b1-8279-433e9be0d07c	9d6ccc6a-0aad-4a06-a2cd-6e0f5a0553cc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-06 10:15:15
41357	9d6ccc6a-0484-4d43-b219-bac0d05849dc	9d6ccc6a-0aad-4a06-a2cd-6e0f5a0553cc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"159.82","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 10:15:15
30575	9d693ff9-dc71-4923-9e0e-3726dff80f04	9d693ff9-e1b8-4400-b943-b5402549af89	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"41.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":58,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 15:55:04
30576	9d693ff9-dcc1-47b4-876d-681668d0ab6d	9d693ff9-e1b8-4400-b943-b5402549af89	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 15:55:04
30577	9d693ff9-e08c-4b4e-9fdb-cf3d877fbdba	9d693ff9-e1b8-4400-b943-b5402549af89	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 15:55:04
30578	9d693ff9-e0d8-42ee-a707-6b9d38d8d3a3	9d693ff9-e1b8-4400-b943-b5402549af89	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:55:01.000000Z","deleted_at":null,"user_alias":"eder.cortes"}},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:55:04
41358	9d6ccc6a-094a-41e2-9400-f86461a33fb3	9d6ccc6a-0aad-4a06-a2cd-6e0f5a0553cc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-06 10:15:15
41359	9d6ccc6a-09be-49d0-9e46-d935f4962aed	9d6ccc6a-0aad-4a06-a2cd-6e0f5a0553cc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":358,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:15
9740	9d56ac41-3fa8-4b38-998e-9fa84f175d3b	9d56ac41-591b-4338-8ebf-bea6cd50c9a9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 10:17:07
9741	9d56ac41-5551-401c-abbe-9a00cebd5a12	9d56ac41-591b-4338-8ebf-bea6cd50c9a9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"43.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-26 10:17:07
9742	9d56ac41-57fe-4138-9c39-19431e206b76	9d56ac41-591b-4338-8ebf-bea6cd50c9a9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 10:17:07
9743	9d56ac41-5848-459f-96d4-3bc2e66e65dc	9d56ac41-591b-4338-8ebf-bea6cd50c9a9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":212,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:17:07
9865	9d56b48f-3595-4124-8dea-fe3b7ceb000e	9d56b48f-50f7-4729-8b0f-3f1f5ae37d3f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 10:40:20
9866	9d56b48f-4bee-429b-abd6-457a21eaf88f	9d56b48f-50f7-4729-8b0f-3f1f5ae37d3f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"43.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-26 10:40:20
9867	9d56b48f-4fde-49c8-98e8-40a67c560872	9d56b48f-50f7-4729-8b0f-3f1f5ae37d3f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 10:40:20
9868	9d56b48f-5028-420a-8c2f-7f5c4ccf5f5d	9d56b48f-50f7-4729-8b0f-3f1f5ae37d3f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":293,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:40:20
11469	9d5cbead-964f-4757-a850-eff599b6761f	9d5cbead-e711-4c30-8694-28225690c9be	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 10:43:35
11470	9d5cbead-e4e0-47a2-bfd8-8163b4d43380	9d5cbead-e711-4c30-8694-28225690c9be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 10:43:36
11471	9d5cbead-e59d-420f-8a44-c5247fd10642	9d5cbead-e711-4c30-8694-28225690c9be	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":362,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:43:36
25856	9d68c9fa-2d2d-4756-8ae3-da6dde3448f1	9d68c9fa-4e91-46c5-b74c-a54b59a9d205	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:25:07
25857	9d68c9fa-43c5-4d4b-a92a-35fd69bc75e3	9d68c9fa-4e91-46c5-b74c-a54b59a9d205	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"44.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:25:07
25858	9d68c9fa-47f9-48d2-8410-4cc848eb16bd	9d68c9fa-4e91-46c5-b74c-a54b59a9d205	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:25:07
9744	9d56ac42-b91a-4f4f-9ec4-d9e9855dfce9	9d56ac42-d798-45cb-98a5-a53e39ba697b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 10:17:08
9745	9d56ac42-d2ba-45ba-a0a9-d7762716b6e5	9d56ac42-d798-45cb-98a5-a53e39ba697b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 10:17:08
9746	9d56ac42-d304-46b5-91f2-660d59d0fd79	9d56ac42-d798-45cb-98a5-a53e39ba697b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 10:17:08
9747	9d56ac42-d682-49d1-859e-39db1108aa62	9d56ac42-d798-45cb-98a5-a53e39ba697b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 10:17:08
9748	9d56ac42-d6c1-42ea-9abd-75a79450c1ba	9d56ac42-d798-45cb-98a5-a53e39ba697b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":397,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:17:08
11472	9d5cbeae-3eef-4739-99a6-25784fbdc7dc	9d5cbeae-89a8-4d7e-8c39-06fab48c5778	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 10:43:36
11473	9d5cbeae-8014-456b-b027-16bf455279a9	9d5cbeae-89a8-4d7e-8c39-06fab48c5778	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 1\\n                        ","time":"152.99","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"2bd5a29c69f6bbb290fc49b79286632e","hostname":"EderCortes"}	2024-10-29 10:43:36
11474	9d5cbeae-83ff-45bf-b497-980e673521f7	9d5cbeae-89a8-4d7e-8c39-06fab48c5778	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1' order by \\"item_loans\\".\\"id\\" asc","time":"2.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 10:43:36
11475	9d5cbeae-8431-4cc9-b8f5-e33e37be5fcf	9d5cbeae-89a8-4d7e-8c39-06fab48c5778	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 10:43:36
11476	9d5cbeae-8884-4957-a06d-8ea58b88380b	9d5cbeae-89a8-4d7e-8c39-06fab48c5778	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 10:43:36
11477	9d5cbeae-88ca-4f37-9632-c1a857c7a1b5	9d5cbeae-89a8-4d7e-8c39-06fab48c5778	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":1,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]}},"duration":386,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:43:36
25859	9d68c9fa-482f-4aaa-b94f-23da614fe288	9d68c9fa-4e91-46c5-b74c-a54b59a9d205	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:25:07
25860	9d68c9fa-4cf4-48d5-ac3f-6cedd46fd881	9d68c9fa-4e91-46c5-b74c-a54b59a9d205	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 10:25:07
28624	9d690215-83c2-4226-aad6-62e0089b6f94	9d690215-a399-4a03-9355-c82d0e4fad41	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 13:02:00
28625	9d690215-9dac-4b5b-ac75-61dd15381cb2	9d690215-a399-4a03-9355-c82d0e4fad41	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:02:00
28626	9d690215-9e03-4e3f-a140-26491269ecd1	9d690215-a399-4a03-9355-c82d0e4fad41	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 13:02:00
28627	9d690215-a25e-423d-8146-fcdda21322ff	9d690215-a399-4a03-9355-c82d0e4fad41	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 13:02:00
9749	9d56ac79-6233-4bed-9a6d-33716f2181c2	9d56ac79-87be-4910-9520-72e7f9eff693	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 10:17:43
9750	9d56ac79-818d-4e6a-adb8-5991d991a3b0	9d56ac79-87be-4910-9520-72e7f9eff693	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-26 10:17:43
9751	9d56ac79-81f6-4f0f-b121-f654430b6c3b	9d56ac79-87be-4910-9520-72e7f9eff693	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-26 10:17:43
9752	9d56ac79-8629-495c-845f-8b0bac25ea95	9d56ac79-87be-4910-9520-72e7f9eff693	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 10:17:43
9753	9d56ac79-869b-4521-b8ca-cb5ae3f318fe	9d56ac79-87be-4910-9520-72e7f9eff693	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:17:43
11478	9d5cbeb0-304a-4c26-948d-d8dc40f3120f	9d5cbeb0-50b4-4a26-80d4-6aa63598dcc2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 10:43:37
11479	9d5cbeb0-498c-4f29-b946-52c9eafa8fe9	9d5cbeb0-50b4-4a26-80d4-6aa63598dcc2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 10:43:37
11480	9d5cbeb0-49dc-4b45-be54-19a994af5cd9	9d5cbeb0-50b4-4a26-80d4-6aa63598dcc2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 10:43:37
11481	9d5cbeb0-4f6b-4ade-af9e-dcddcf54d545	9d5cbeb0-50b4-4a26-80d4-6aa63598dcc2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 10:43:37
11482	9d5cbeb0-4fac-45aa-9dfe-8a472a76d821	9d5cbeb0-50b4-4a26-80d4-6aa63598dcc2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":313,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:43:37
30579	9d693ffb-5948-493f-84cd-6b591d87002b	9d693ffb-a5bc-40bb-82e7-33bf6908ead9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 15:55:05
30580	9d693ffb-a012-4cbb-a225-1a4f0df32f8e	9d693ffb-a5bc-40bb-82e7-33bf6908ead9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"151.58","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:55:05
30581	9d693ffb-a066-4144-9998-dfd092ad0600	9d693ffb-a5bc-40bb-82e7-33bf6908ead9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:55:05
30582	9d693ffb-a47a-4b9f-acbe-88fafd36adbe	9d693ffb-a5bc-40bb-82e7-33bf6908ead9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 15:55:05
30583	9d693ffb-a4c5-4f16-abb4-133d7f2ebae0	9d693ffb-a5bc-40bb-82e7-33bf6908ead9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":660,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:55:05
9754	9d56ac7a-085c-49f4-9f19-e2a37a3213b3	9d56ac7a-25d7-47f6-9203-09713e2de41f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 10:17:44
9755	9d56ac7a-2112-4ff7-bd62-70f7dc067316	9d56ac7a-25d7-47f6-9203-09713e2de41f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-26 10:17:44
9756	9d56ac7a-215d-4e1f-8cfd-233ac704a4b1	9d56ac7a-25d7-47f6-9203-09713e2de41f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-26 10:17:44
9757	9d56ac7a-24b1-4281-8998-210a395c58cd	9d56ac7a-25d7-47f6-9203-09713e2de41f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 10:17:44
9758	9d56ac7a-250a-4ccd-9025-fac27bc295d0	9d56ac7a-25d7-47f6-9203-09713e2de41f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":390,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:17:44
16515	9d64cf11-4410-4b0a-b86b-b4a7c2de7f99	9d64cf11-9a60-4a54-ada2-342b57c9ba54	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 10:56:03
16516	9d64cf11-97a7-407d-a8ed-cdf8803234a7	9d64cf11-9a60-4a54-ada2-342b57c9ba54	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 10:56:03
16517	9d64cf11-98c6-4b62-86ac-e5b3cd6ec569	9d64cf11-9a60-4a54-ada2-342b57c9ba54	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"157","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000","id":187,"loans_codigo":62,"item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00ab187\\u00bb\\nLINE 1: select * from \\"item_loans\\" where \\"187\\" is null\\n                                         ^ (Connection: pgsql, SQL: select * from \\"item_loans\\" where \\"187\\" is null)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"payCuota","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":481,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:56:03
43433	9d6cea00-4cea-4fe1-9a57-81c961e2e7bd	9d6cea00-4fb8-4fc5-88c7-e2d97839fa9f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2024}	2024-11-06 11:37:59
41360	9d6ccc6a-5e06-4530-b7cd-9b747b9efb0c	9d6ccc6a-7ecd-4c4c-aa42-28244c142937	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-06 10:15:15
9759	9d56ac7a-6463-4477-bde3-5a384bb3ebc1	9d56ac7a-be50-4014-a499-7d9d1d04ed3d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 10:17:44
9760	9d56ac7a-ae43-438a-9f85-042a155775de	9d56ac7a-be50-4014-a499-7d9d1d04ed3d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '1' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"144.27","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-26 10:17:44
9761	9d56ac7a-ae95-474e-bcd3-a4fc04458209	9d56ac7a-be50-4014-a499-7d9d1d04ed3d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-26 10:17:44
9762	9d56ac7a-b972-4f14-84c4-c81ab1589ee7	9d56ac7a-be50-4014-a499-7d9d1d04ed3d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1' order by \\"item_loans\\".\\"id\\" asc","time":"4.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-26 10:17:44
9763	9d56ac7a-b9a6-4495-81ad-317ad4058b5a	9d56ac7a-be50-4014-a499-7d9d1d04ed3d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-26 10:17:44
9764	9d56ac7a-bd04-4246-bd2f-43147b9f9c8e	9d56ac7a-be50-4014-a499-7d9d1d04ed3d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 10:17:44
9765	9d56ac7a-bd57-4c1a-8047-4ac43a900fcd	9d56ac7a-be50-4014-a499-7d9d1d04ed3d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":1,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]}},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:17:44
16518	9d64cf33-590a-44e6-81b1-d5d886afd2ae	9d64cf33-5d2b-455d-8d91-29cadd6f0b15	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":211,"memory":20,"hostname":"EderCortes"}	2024-11-02 10:56:25
41361	9d6ccc6a-795d-4b3a-82a6-6a8b51f6dd2f	9d6ccc6a-7ecd-4c4c-aa42-28244c142937	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:15:15
41362	9d6ccc6a-79b1-4eb3-8676-a9f67c5b5f9a	9d6ccc6a-7ecd-4c4c-aa42-28244c142937	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:15:15
35055	9d69c16b-96d4-4095-bc87-0424fff4d4bd	9d69c16b-c299-4c9b-9942-3d92a0372e1d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 21:57:01
35056	9d69c16b-bb3b-401c-a278-94eb3f632e93	9d69c16b-c299-4c9b-9942-3d92a0372e1d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"64.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 21:57:01
35057	9d69c16b-c05a-4154-9c77-b661d3290851	9d69c16b-c299-4c9b-9942-3d92a0372e1d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-04 21:57:01
35058	9d69c16b-c10e-4936-aa6a-606146eb3473	9d69c16b-c299-4c9b-9942-3d92a0372e1d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":394,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:57:01
41363	9d6ccc6a-7d27-406f-8c7a-53966e1b30be	9d6ccc6a-7ecd-4c4c-aa42-28244c142937	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-11-06 10:15:15
16519	9d64cf33-bb86-4f3f-bb17-fbb1f0a858db	9d64cf34-09eb-4a92-81eb-6c7e51fdf494	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 10:56:25
5056	9d51366d-c384-4e99-a9fc-04d345374951	9d51366e-1116-4e89-ab84-e39e78208eeb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":43,"hostname":"EderCortes"}	2024-10-23 17:08:30
5057	9d51366e-0f15-4f2a-8ccc-f11f99a4925a	9d51366e-1116-4e89-ab84-e39e78208eeb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":44,"hostname":"EderCortes"}	2024-10-23 17:08:30
5058	9d51366e-0fec-42e3-86e6-babbf9ccfc61	9d51366e-1116-4e89-ab84-e39e78208eeb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":861,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:30
16520	9d64cf34-02a5-4569-a6e8-f5b7a8a5d3e1	9d64cf34-09eb-4a92-81eb-6c7e51fdf494	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"id\\" = 187","time":"161.56","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"26ce1efa1531ea5c82b04659c0aa52cc","hostname":"EderCortes"}	2024-11-02 10:56:25
16521	9d64cf34-030a-4c27-b362-39ee957fffad	9d64cf34-09eb-4a92-81eb-6c7e51fdf494	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-02 10:56:25
16522	9d64cf34-07f6-4bc6-ab02-2029bb4319d3	9d64cf34-09eb-4a92-81eb-6c7e51fdf494	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 10:56:25
16523	9d64cf34-0872-44aa-be33-f67e0eeadb6e	9d64cf34-09eb-4a92-81eb-6c7e51fdf494	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"157","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000","id":187,"loans_codigo":62,"item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"result":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]},"duration":367,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:56:25
16646	9d64d470-43bc-4ffc-9aba-f4a5ce822739	9d64d470-9367-4eae-8935-d5586c1aba7e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 11:11:04
16647	9d64d470-9190-48a8-ba64-bcacc3143036	9d64d470-9367-4eae-8935-d5586c1aba7e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 11:11:04
16648	9d64d470-924a-43a4-ab4e-d787b770b307	9d64d470-9367-4eae-8935-d5586c1aba7e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":486,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:11:04
35059	9d69c16c-5332-4b02-9768-94df2d60a679	9d69c16c-9e3e-4612-9ff8-fbe36217773e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-04 21:57:02
16649	9d64d470-f08a-4762-ba74-714f357b109e	9d64d471-3ce3-4fdf-9a44-60b73a67e1ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 11:11:04
16650	9d64d471-32e8-4fd9-98c9-f3d08ba386dc	9d64d471-3ce3-4fdf-9a44-60b73a67e1ef	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"156.60","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 11:11:04
8549	9d52ed4a-c963-444f-b5db-bf78a013e553	9d52ed4b-1386-40bb-a651-4feae3a56063	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:35:39
8550	9d52ed4b-1237-4068-baf0-5059cc957ef4	9d52ed4b-1386-40bb-a651-4feae3a56063	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:35:39
8551	9d52ed4b-12bc-4b19-a599-ef67ddc86772	9d52ed4b-1386-40bb-a651-4feae3a56063	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":394,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:35:39
16524	9d64d182-1651-48ec-94e1-558c1f403983	9d64d182-1c72-4a6d-92d1-97ca7611b546	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":305,"memory":20,"hostname":"EderCortes"}	2024-11-02 11:02:52
16651	9d64d471-3700-4da5-9b7c-ad94e71e8211	9d64d471-3ce3-4fdf-9a44-60b73a67e1ef	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 11:11:04
16652	9d64d471-373f-496b-a952-461836c0fa0b	9d64d471-3ce3-4fdf-9a44-60b73a67e1ef	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 11:11:04
16653	9d64d471-3b7f-4219-8cbd-ddf9917c04b7	9d64d471-3ce3-4fdf-9a44-60b73a67e1ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 11:11:04
16654	9d64d471-3bf3-487b-87d5-cd11c0912397	9d64d471-3ce3-4fdf-9a44-60b73a67e1ef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":383,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:11:04
35060	9d69c16c-9192-43f8-8fb7-65f434300346	9d69c16c-9e3e-4612-9ff8-fbe36217773e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"108.50","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:57:02
35061	9d69c16c-9241-4ea1-be83-b9763e14cd49	9d69c16c-9e3e-4612-9ff8-fbe36217773e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:57:02
35062	9d69c16c-9b56-4de9-8c0b-c67d9ad2e5eb	9d69c16c-9e3e-4612-9ff8-fbe36217773e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-04 21:57:02
35063	9d69c16c-9bf8-4697-93a8-26761ec240ee	9d69c16c-9e3e-4612-9ff8-fbe36217773e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":541,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:57:02
8552	9d52ed4b-5eec-4d03-8c3a-fc9cae4f4536	9d52ed4b-7c02-4945-aea0-5caf5f0bb84a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:35:40
8553	9d52ed4b-76c0-4b19-9ca1-fa30a34f0ee1	9d52ed4b-7c02-4945-aea0-5caf5f0bb84a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:35:40
8554	9d52ed4b-7712-42fc-ab84-669d5aeab61b	9d52ed4b-7c02-4945-aea0-5caf5f0bb84a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:35:40
8555	9d52ed4b-7aad-415d-8c26-7ad594b427bb	9d52ed4b-7c02-4945-aea0-5caf5f0bb84a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:35:40
8556	9d52ed4b-7af1-4882-a684-5b7fe1ea5bff	9d52ed4b-7c02-4945-aea0-5caf5f0bb84a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:35:40
16655	9d64d473-33a3-4025-9039-078e0772f2a5	9d64d473-6389-48b2-b314-b20928d96cba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 11:11:06
16526	9d64d182-b638-47ac-a22e-adc505683894	9d64d183-4e4f-49ed-b254-33551da4f4cf	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 11:02:52
9940	9d56c2a0-f92f-4719-acad-615bf41509b5	9d56c2a1-1efb-4011-99d1-0d3f70e9094e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 11:19:40
9941	9d56c2a1-1d0f-43b2-a3b2-8dc6a6026d22	9d56c2a1-1efb-4011-99d1-0d3f70e9094e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:19:40
9942	9d56c2a1-1ddb-4475-9c05-58c3cf51dfb8	9d56c2a1-1efb-4011-99d1-0d3f70e9094e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":295,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:19:40
12800	9d5cecde-fe24-47a2-8bcd-e25a1a24e208	9d5cecde-fede-4176-8803-f90d68c7c081	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:45
16527	9d64d183-24be-4d5d-a8b7-5a912af4d14c	9d64d183-4e4f-49ed-b254-33551da4f4cf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"id\\" = 187","time":"3.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":325,"hash":"26ce1efa1531ea5c82b04659c0aa52cc","hostname":"EderCortes"}	2024-11-02 11:02:53
16528	9d64d183-254b-499c-90d3-40944f6d0454	9d64d183-4e4f-49ed-b254-33551da4f4cf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-02 11:02:53
16529	9d64d183-4bd3-4c9c-930d-b4fd7acd234d	9d64d183-4e4f-49ed-b254-33551da4f4cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 11:02:53
16530	9d64d183-4cb4-46fe-b032-b6fd5150493c	9d64d183-4e4f-49ed-b254-33551da4f4cf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"157","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000","id":187,"loans_codigo":62,"item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":500,"response":{"message":"Method Illuminate\\\\Database\\\\Eloquent\\\\Collection::save does not exist.","exception":"BadMethodCallException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Macroable\\\\Traits\\\\Macroable.php","line":112,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":341,"function":"__call","class":"Illuminate\\\\Support\\\\Collection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"payCuota","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":606,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:02:53
16525	9d64d183-4a0b-41ce-9fd3-fe0e9f70e68d	9d64d183-4e4f-49ed-b254-33551da4f4cf	2e4ad983d45f212ae5ffbaec9136a0df	f	exception	{"class":"BadMethodCallException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Macroable\\\\Traits\\\\Macroable.php","line":112,"message":"Method Illuminate\\\\Database\\\\Eloquent\\\\Collection::save does not exist.","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":341},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"103":"     * @param  string  $method","104":"     * @param  array  $parameters","105":"     * @return mixed","106":"     *","107":"     * @throws \\\\BadMethodCallException","108":"     *\\/","109":"    public function __call($method, $parameters)","110":"    {","111":"        if (! static::hasMacro($method)) {","112":"            throw new BadMethodCallException(sprintf(","113":"                'Method %s::%s does not exist.', static::class, $method","114":"            ));","115":"        }","116":"","117":"        $macro = static::$macros[$method];","118":"","119":"        if ($macro instanceof Closure) {","120":"            $macro = $macro->bindTo($this, static::class);","121":"        }","122":""},"hostname":"EderCortes","occurrences":3}	2024-11-02 11:02:53
16656	9d64d473-597a-4369-a80c-a28046aada12	9d64d473-6389-48b2-b314-b20928d96cba	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"58.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 11:11:06
16657	9d64d473-5a12-445c-a1d5-968b0cb36349	9d64d473-6389-48b2-b314-b20928d96cba	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 11:11:06
16658	9d64d473-6160-4098-b4af-8f004e123e6f	9d64d473-6389-48b2-b314-b20928d96cba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 11:11:06
35064	9d69c16d-fbe8-4cce-a362-6b2d27c5ea84	9d69c16e-2b41-427c-bf02-cbda101a8aa7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-04 21:57:03
8557	9d52ed4b-bf19-4dbb-8272-e6b2f937bf89	9d52ed4b-dda0-4a4a-b4ae-247402922a92	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:35:40
8558	9d52ed4b-d894-4f84-97ff-c29792e8876c	9d52ed4b-dda0-4a4a-b4ae-247402922a92	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:35:40
8559	9d52ed4b-d8e6-475b-8038-0d89901ded2d	9d52ed4b-dda0-4a4a-b4ae-247402922a92	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:35:40
8560	9d52ed4b-dc88-46de-9fbb-6bda507c211c	9d52ed4b-dda0-4a4a-b4ae-247402922a92	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:35:40
8561	9d52ed4b-dcce-481b-a255-4f2fa947801d	9d52ed4b-dda0-4a4a-b4ae-247402922a92	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:35:40
9943	9d56c2a2-a3ee-43bc-a246-28e16a5be679	9d56c2a2-e8af-47fc-8731-535a7acf2f81	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:19:41
9944	9d56c2a2-e29c-43b7-b6fc-afa37b3d1a8a	9d56c2a2-e8af-47fc-8731-535a7acf2f81	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"141.49","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:19:42
9945	9d56c2a2-e2e3-4d95-8dea-59f91d861931	9d56c2a2-e8af-47fc-8731-535a7acf2f81	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:19:42
9946	9d56c2a2-e758-4df0-a5dc-97ae868cb933	9d56c2a2-e8af-47fc-8731-535a7acf2f81	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:19:42
9947	9d56c2a2-e7b2-43aa-877a-4b38497e8dc1	9d56c2a2-e8af-47fc-8731-535a7acf2f81	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":371,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:19:42
12801	9d5cece0-b39f-4159-a35c-fa8954e578c2	9d5cece0-fc8f-4071-927e-70aadd5edd7e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 12:52:47
12802	9d5cece0-f7a0-47c4-aa5b-edda91c9e6c0	9d5cece0-fc8f-4071-927e-70aadd5edd7e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"154.45","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 12:52:47
12803	9d5cece0-f7e6-4b8c-a44b-dbd119656e3d	9d5cece0-fc8f-4071-927e-70aadd5edd7e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 12:52:47
12804	9d5cece0-fb58-48db-8c7c-41a16e6dd3a9	9d5cece0-fc8f-4071-927e-70aadd5edd7e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 12:52:47
12805	9d5cece0-fb9f-47dc-8650-46b80ff8a687	9d5cece0-fc8f-4071-927e-70aadd5edd7e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":352,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:47
8562	9d52ed4c-26be-476d-9888-9f57c8c652ae	9d52ed4c-32cc-43c9-93cc-f5105b05f99b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:35:40
8563	9d52ed4c-31b2-4fbf-a00e-0f95ead89f6b	9d52ed4c-32cc-43c9-93cc-f5105b05f99b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 13:35:40
8564	9d52ed4c-31f7-41bb-a0a6-28588b453e85	9d52ed4c-32cc-43c9-93cc-f5105b05f99b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[]},"duration":199,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:35:40
16531	9d64d1d4-9aef-4d97-9a71-287d765f53e7	9d64d1d4-9fe7-4f34-be4a-65d928a64b7e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":199,"memory":20,"hostname":"EderCortes"}	2024-11-02 11:03:46
16659	9d64d473-61f5-4841-bb6f-6dd88d78997c	9d64d473-6389-48b2-b314-b20928d96cba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":433,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:11:06
12806	9d5cece4-26f4-47f5-9de8-d1f39519701a	9d5cece4-2b6a-47c2-8f19-a0c0b5f8ce6a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":158,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:49
10451	9d56cfc5-148f-46e0-b38c-e12c1bbcc9de	9d56cfc5-1844-46a2-a09f-22e49af32c6e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":517}	2024-10-26 11:56:25
8565	9d52ed4d-e6c0-4676-805c-c789063a4e9b	9d52ed4e-0dc6-435c-a4b3-16cd50ed505f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 13:35:41
8566	9d52ed4e-07ee-416f-9ddc-4ce3b350fbe1	9d52ed4e-0dc6-435c-a4b3-16cd50ed505f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"57.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:35:41
8567	9d52ed4e-0861-4551-b78e-84ce035ca446	9d52ed4e-0dc6-435c-a4b3-16cd50ed505f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:35:41
8568	9d52ed4e-0c81-4190-ac7c-93a108f5a1ef	9d52ed4e-0dc6-435c-a4b3-16cd50ed505f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 13:35:41
7591	9d52df6e-a929-40a8-b383-389a00e1513f	9d52df6e-fed4-464a-9478-ecbde2e9f0c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-24 12:56:54
7592	9d52df6e-fc21-4dfe-bffb-f10ad09a2488	9d52df6e-fed4-464a-9478-ecbde2e9f0c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-24 12:56:54
7593	9d52df6e-fd6c-4fb2-8f27-f7c9082f5f75	9d52df6e-fed4-464a-9478-ecbde2e9f0c9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":468,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:56:54
8569	9d52ed4e-0cc9-43ff-b237-8260554d65a9	9d52ed4e-0dc6-435c-a4b3-16cd50ed505f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":504,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:35:41
16532	9d64d1d5-5081-4dc9-a2b6-4fc9da6bca01	9d64d1d5-54a9-49bb-9709-c2c5637c0849	2e4ad983d45f212ae5ffbaec9136a0df	t	exception	{"class":"BadMethodCallException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Macroable\\\\Traits\\\\Macroable.php","line":112,"message":"Method Illuminate\\\\Database\\\\Eloquent\\\\Collection::save does not exist.","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":342},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"103":"     * @param  string  $method","104":"     * @param  array  $parameters","105":"     * @return mixed","106":"     *","107":"     * @throws \\\\BadMethodCallException","108":"     *\\/","109":"    public function __call($method, $parameters)","110":"    {","111":"        if (! static::hasMacro($method)) {","112":"            throw new BadMethodCallException(sprintf(","113":"                'Method %s::%s does not exist.', static::class, $method","114":"            ));","115":"        }","116":"","117":"        $macro = static::$macros[$method];","118":"","119":"        if ($macro instanceof Closure) {","120":"            $macro = $macro->bindTo($this, static::class);","121":"        }","122":""},"hostname":"EderCortes","occurrences":4}	2024-11-02 11:03:47
16533	9d64d1d5-2f3a-4f29-ac76-784899ba1ebc	9d64d1d5-54a9-49bb-9709-c2c5637c0849	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 11:03:47
12807	9d5cece4-ac31-4efb-be71-469eedd8fb67	9d5cece4-af15-4cb0-ad3e-8a20c9284ff7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":142,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:52:49
16534	9d64d1d5-4bef-43c9-834a-16def8e4e488	9d64d1d5-54a9-49bb-9709-c2c5637c0849	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"id\\" = 187","time":"3.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":325,"hash":"26ce1efa1531ea5c82b04659c0aa52cc","hostname":"EderCortes"}	2024-11-02 11:03:47
16535	9d64d1d5-4c5e-4c22-ab8c-f43f3cc9b209	9d64d1d5-54a9-49bb-9709-c2c5637c0849	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-02 11:03:47
16536	9d64d1d5-525d-4ffe-b9d4-01b1cfa0fe47	9d64d1d5-54a9-49bb-9709-c2c5637c0849	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 11:03:47
16537	9d64d1d5-5327-4491-8213-fb49bcddb4cf	9d64d1d5-54a9-49bb-9709-c2c5637c0849	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"157","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000","id":187,"loans_codigo":62,"item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":500,"response":{"message":"Method Illuminate\\\\Database\\\\Eloquent\\\\Collection::save does not exist.","exception":"BadMethodCallException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Macroable\\\\Traits\\\\Macroable.php","line":112,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":342,"function":"__call","class":"Illuminate\\\\Support\\\\Collection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"payCuota","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":273,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:03:47
25861	9d68c9fa-4d6e-4f02-9469-c06c29aa8c16	9d68c9fa-4e91-46c5-b74c-a54b59a9d205	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":402,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:25:07
7594	9d52df6f-6e06-496f-b63c-0dbb0b69e41d	9d52df6f-9714-427e-869e-7145c0f3949e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-24 12:56:55
7595	9d52df6f-90e9-4317-aed8-e79a592af873	9d52df6f-9714-427e-869e-7145c0f3949e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"57.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:56:55
7596	9d52df6f-9168-4cb8-add9-d9b7c8f4b351	9d52df6f-9714-427e-869e-7145c0f3949e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:56:55
7597	9d52df6f-95c7-4385-8637-a99101e894a6	9d52df6f-9714-427e-869e-7145c0f3949e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-10-24 12:56:55
7598	9d52df6f-960f-4ea0-9ca6-619985f5b79d	9d52df6f-9714-427e-869e-7145c0f3949e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":353,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:56:55
16538	9d64d2be-5a78-4dab-92c3-fb8c00c4c8a9	9d64d2be-5f72-464d-9db8-9f608ec86ae5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":208,"memory":20,"hostname":"EderCortes"}	2024-11-02 11:06:19
35065	9d69c16e-225b-4449-bd99-9a4659d5f4f2	9d69c16e-2b41-427c-bf02-cbda101a8aa7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"61.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:57:03
12808	9d5cece4-fc4d-403d-8db8-278570edce76	9d5cece5-16a3-49b2-8208-65ee824bf644	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 12:52:49
12809	9d5cece5-1282-4e9a-bc0c-4d49189c0489	9d5cece5-16a3-49b2-8208-65ee824bf644	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"39.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:52:49
12810	9d5cece5-157e-4ff1-ad45-520b56ed1397	9d5cece5-16a3-49b2-8208-65ee824bf644	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 12:52:49
12811	9d5cece5-15c2-48ac-b3fc-e95c9a528407	9d5cece5-16a3-49b2-8208-65ee824bf644	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":213,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:49
35066	9d69c16e-22e5-45a9-a596-25266dd2a761	9d69c16e-2b41-427c-bf02-cbda101a8aa7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:57:03
35067	9d69c16e-2945-4b9f-828e-8e2ad99a12ca	9d69c16e-2b41-427c-bf02-cbda101a8aa7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-04 21:57:03
35068	9d69c16e-29ce-45a8-9f22-10a109363735	9d69c16e-2b41-427c-bf02-cbda101a8aa7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":594,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:57:03
7599	9d52df6f-fab0-4995-be47-d4dea163532f	9d52df70-230c-4a77-a96c-573b3fc2c5d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-10-24 12:56:55
7600	9d52df70-19fc-484c-b0f6-42335f539445	9d52df70-230c-4a77-a96c-573b3fc2c5d9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"54.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:56:55
7601	9d52df70-1a7f-4678-ba6c-41d988a7dd80	9d52df70-230c-4a77-a96c-573b3fc2c5d9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:56:55
7602	9d52df70-213c-424a-9f70-ebade75d5415	9d52df70-230c-4a77-a96c-573b3fc2c5d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-10-24 12:56:55
7603	9d52df70-21b4-461a-bf17-d828ae9bc186	9d52df70-230c-4a77-a96c-573b3fc2c5d9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":339,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:56:55
16539	9d64d2be-b9ca-4707-9618-cad293e98d06	9d64d2bf-1674-440c-bdf6-f5133b5f8d85	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 11:06:20
16540	9d64d2bf-04b8-4eff-bdfe-f9ae395d54eb	9d64d2bf-1674-440c-bdf6-f5133b5f8d85	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 187 limit 1","time":"3.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":325,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-02 11:06:20
12812	9d5cece5-530a-4c1d-a0d8-07de7c874870	9d5cece5-55f7-42cd-b371-c855abd7d4a0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":141,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:52:50
16541	9d64d2bf-053d-4299-8637-b10491c3057b	9d64d2bf-1674-440c-bdf6-f5133b5f8d85	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-02 11:06:20
16542	9d64d2bf-0796-44e1-b58d-76ea768c809a	9d64d2bf-1674-440c-bdf6-f5133b5f8d85	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '02-11-2024', \\"itemloans_interes_canelado\\" = '50000', \\"itemloans_cuota_cancelada\\" = '100000', \\"updated_at\\" = '2024-11-02 11:06:20' where \\"id\\" = 187","time":"2.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":342,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-02 11:06:20
16543	9d64d2bf-0fa0-4813-948a-bb0412825580	9d64d2bf-1674-440c-bdf6-f5133b5f8d85	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:187","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-02 11:06:20","item_loans_cuando_pago":"02-11-2024","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},"hostname":"EderCortes"}	2024-11-02 11:06:20
16544	9d64d2bf-13f7-4efe-b55b-7c8d31e8f901	9d64d2bf-1674-440c-bdf6-f5133b5f8d85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 11:06:20
16545	9d64d2bf-149b-468f-aac1-35997568522f	9d64d2bf-1674-440c-bdf6-f5133b5f8d85	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"157","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000","id":187,"loans_codigo":62,"item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":399,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:06:20
28628	9d690215-a2aa-4ebd-9d3d-48461032913c	9d690215-a399-4a03-9355-c82d0e4fad41	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":405,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:02:00
7604	9d52df70-8d43-41e7-bc07-265e5c80b14d	9d52df70-d78b-41af-9dbb-1580a46e8b35	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-10-24 12:56:55
7605	9d52df70-d10f-44b5-b289-f77350da1d31	9d52df70-d78b-41af-9dbb-1580a46e8b35	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"148.39","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:56:55
7606	9d52df70-d15a-4de2-bc80-3d8578c22586	9d52df70-d78b-41af-9dbb-1580a46e8b35	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:56:55
7607	9d52df70-d2fb-42ee-a66a-5a46ecbc6068	9d52df70-d78b-41af-9dbb-1580a46e8b35	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"2.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:56:55
7608	9d52df70-d32d-4791-b803-233c279710d5	9d52df70-d78b-41af-9dbb-1580a46e8b35	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:56:55
7609	9d52df70-d62c-414b-90e0-ae2e7f73754f	9d52df70-d78b-41af-9dbb-1580a46e8b35	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-10-24 12:56:55
7610	9d52df70-d671-441f-ab29-1caacb33e82d	9d52df70-d78b-41af-9dbb-1580a46e8b35	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":440,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:56:55
41364	9d6ccc6a-7da3-4341-a103-e29a28737762	9d6ccc6a-7ecd-4c4c-aa42-28244c142937	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":276,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:15
12813	9d5cece5-a1b6-4d13-bc7d-e6d8674327fd	9d5cece5-a4e9-4105-b90d-ac43e38a6fba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":132,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:52:50
28629	9d690216-3939-4958-92eb-0b7f45d13d88	9d690216-6475-4eab-b947-1f508944f4ab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 13:02:01
28630	9d690216-5c6d-464a-aa1b-9001db4cca62	9d690216-6475-4eab-b947-1f508944f4ab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"57.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:02:01
28631	9d690216-5ced-4435-aefb-e3db3b33d53d	9d690216-6475-4eab-b947-1f508944f4ab	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 13:02:01
28632	9d690216-62a2-469c-b70b-dfc9566e46c4	9d690216-6475-4eab-b947-1f508944f4ab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 13:02:01
28633	9d690216-6326-4898-99c7-a45da6acb3ec	9d690216-6475-4eab-b947-1f508944f4ab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":471,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:02:01
7611	9d52df72-071c-4fb9-8247-d50537cea4d7	9d52df72-39cd-438f-b0fc-fcca7d4acf0a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-10-24 12:56:56
7612	9d52df72-30f2-45f3-995e-1c41d2543505	9d52df72-39cd-438f-b0fc-fcca7d4acf0a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"64.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:56:56
7613	9d52df72-3185-4d4a-9869-ebbb71259630	9d52df72-39cd-438f-b0fc-fcca7d4acf0a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:56:56
7614	9d52df72-3804-46cc-9fd0-bc9773c25ca6	9d52df72-39cd-438f-b0fc-fcca7d4acf0a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-10-24 12:56:56
7615	9d52df72-3888-4264-bfe3-33b1b80c68e3	9d52df72-39cd-438f-b0fc-fcca7d4acf0a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":485,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:56:56
41365	9d6ccc6a-c274-48d7-bd34-416b7bb3ce36	9d6ccc6b-0915-496c-98c7-ded7e0e08fb6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-11-06 10:15:15
28634	9d690216-df89-4438-ab2d-6a56b3813e53	9d690217-019a-4eaa-b8b2-97441f562e33	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 13:02:01
12814	9d5cece5-f3c1-45b8-99c4-f98e730d034a	9d5cece6-3a98-4e09-800f-f86f174083f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 12:52:50
12815	9d5cece6-3657-459f-a960-c5af721911cd	9d5cece6-3a98-4e09-800f-f86f174083f6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"154.12","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:52:50
12816	9d5cece6-3972-47cc-a781-8714ab09e6ad	9d5cece6-3a98-4e09-800f-f86f174083f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 12:52:50
12817	9d5cece6-39b6-48fc-8112-4fd7ce5e7571	9d5cece6-3a98-4e09-800f-f86f174083f6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":329,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:50
28635	9d690216-fa4d-4f3b-81ca-39ea9f7bea3f	9d690217-019a-4eaa-b8b2-97441f562e33	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '89' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"40.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 13:02:01
28636	9d690216-fa98-45d4-9f61-7b7a4808a848	9d690217-019a-4eaa-b8b2-97441f562e33	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 13:02:01
28637	9d690216-fc56-4fa5-bec2-d56cb5423d08	9d690217-019a-4eaa-b8b2-97441f562e33	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:02:01
28638	9d690216-fc96-4190-a61f-10a628d4a9db	9d690217-019a-4eaa-b8b2-97441f562e33	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:02:01
28639	9d690217-002c-4ec2-84e2-04826cd43a4b	9d690217-019a-4eaa-b8b2-97441f562e33	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 13:02:01
28640	9d690217-0089-48c7-a393-92b38127000c	9d690217-019a-4eaa-b8b2-97441f562e33	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"103000","loans_pago_prestado":"412000","loans_intereses_recaudar":"275000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":385,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:02:01
28641	9d690219-3a2c-4245-b430-1ee92a60e981	9d690219-844c-4160-b2df-532eb5bd1d7b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 13:02:03
28642	9d690219-7e2c-4096-96f6-462e774f3e8a	9d690219-844c-4160-b2df-532eb5bd1d7b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"154.68","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:02:03
28643	9d690219-7e95-4c73-b432-7896e3981eb1	9d690219-844c-4160-b2df-532eb5bd1d7b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:02:03
28644	9d690219-82e3-4cd9-899f-8ec2b8e11a79	9d690219-844c-4160-b2df-532eb5bd1d7b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 13:02:03
12818	9d5cece6-7d53-4f08-9b16-0920fae162a1	9d5cece6-989a-49dc-a567-547540b6747c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 12:52:50
12819	9d5cece6-9454-48d9-8710-400a245650ce	9d5cece6-989a-49dc-a567-547540b6747c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAr%' or \\"users\\".\\"user_document\\"::text like '%MAr%') order by \\"users\\".\\"user_document\\" asc","time":"42.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:52:50
12820	9d5cece6-9756-4e71-97ee-20e3b84d651e	9d5cece6-989a-49dc-a567-547540b6747c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-29 12:52:50
12821	9d5cece6-9798-40a4-804b-d8c011cec128	9d5cece6-989a-49dc-a567-547540b6747c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAr"},"session":[],"response_status":200,"response":{"data":[]},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:50
28645	9d690219-833a-4d2c-85fd-aaeb1543c598	9d690219-844c-4160-b2df-532eb5bd1d7b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":601,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:02:03
41366	9d6ccc6b-03d5-40ec-ad41-da0423525e3f	9d6ccc6b-0915-496c-98c7-ded7e0e08fb6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"147.21","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:15:15
41367	9d6ccc6b-0424-4df8-8e51-12856be6a51e	9d6ccc6b-0915-496c-98c7-ded7e0e08fb6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:15:15
41368	9d6ccc6b-07d0-4aa1-95d6-ec091d6f28c5	9d6ccc6b-0915-496c-98c7-ded7e0e08fb6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-11-06 10:15:15
41369	9d6ccc6b-0818-48eb-ae2e-9e7f8e0d4d27	9d6ccc6b-0915-496c-98c7-ded7e0e08fb6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":332,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:15
8687	9d52ee7e-1337-4e3a-8e02-0d7623a8b63d	9d52ee7e-5c68-4d0c-a367-1881d3ecd4e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 13:39:01
8688	9d52ee7e-5ae2-4d56-95b1-156ba6d12522	9d52ee7e-5c68-4d0c-a367-1881d3ecd4e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 13:39:01
8689	9d52ee7e-5b7b-4687-8167-0d3c27c87961	9d52ee7e-5c68-4d0c-a367-1881d3ecd4e7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":353,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:39:01
8690	9d52ee7e-a571-42f8-9258-7677f1faf641	9d52ee7e-c39f-42b2-a1ce-e65163381e13	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 13:39:01
8691	9d52ee7e-be4f-4f76-b8e3-665ff42d95ad	9d52ee7e-c39f-42b2-a1ce-e65163381e13	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:39:01
8692	9d52ee7e-be98-465c-a238-89bce8832e6d	9d52ee7e-c39f-42b2-a1ce-e65163381e13	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:39:01
8693	9d52ee7e-c27e-4643-beb8-4e6ac6d317d8	9d52ee7e-c39f-42b2-a1ce-e65163381e13	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 13:39:01
8694	9d52ee7e-c2c2-4745-9d72-516845024f03	9d52ee7e-c39f-42b2-a1ce-e65163381e13	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:39:01
12822	9d5cece6-db45-4aae-b14c-1941e21fd0d8	9d5cece6-f492-421b-96a7-2a438f47ced1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-29 12:52:51
12823	9d5cece6-f09e-4b8e-9359-f8cd93254f49	9d5cece6-f492-421b-96a7-2a438f47ced1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAri%' or \\"users\\".\\"user_document\\"::text like '%MAri%') order by \\"users\\".\\"user_document\\" asc","time":"39.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:52:51
12824	9d5cece6-f354-4b01-8724-56b45b20989b	9d5cece6-f492-421b-96a7-2a438f47ced1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-29 12:52:51
12825	9d5cece6-f3a2-4b98-ae2f-afc10732f66b	9d5cece6-f492-421b-96a7-2a438f47ced1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAri"},"session":[],"response_status":200,"response":{"data":[]},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:51
8695	9d52ee7f-09f1-467f-8a98-d909b04f4bd7	9d52ee7f-2999-4b75-a525-3dea2ccc4451	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 13:39:01
8696	9d52ee7f-2491-4ff3-b5a4-f98404bb53f8	9d52ee7f-2999-4b75-a525-3dea2ccc4451	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:39:01
8697	9d52ee7f-24d9-4a1e-8c38-e622c791af57	9d52ee7f-2999-4b75-a525-3dea2ccc4451	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:39:01
8698	9d52ee7f-285a-4309-94b9-91f630c2199c	9d52ee7f-2999-4b75-a525-3dea2ccc4451	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 13:39:01
8699	9d52ee7f-28ad-43e4-9e77-d69c6a8743a7	9d52ee7f-2999-4b75-a525-3dea2ccc4451	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:39:01
12826	9d5cecea-db41-411f-ad23-04507a37e258	9d5cecea-dee9-4cea-89fa-5a1eb87a741f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":134,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:52:53
41370	9d6ccc6c-bbbc-45d2-8d0f-27e5676bd5c9	9d6ccc6c-e657-4445-8af2-1e8dbd622110	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-11-06 10:15:17
41371	9d6ccc6c-de94-403e-b7d1-b2af385eb0aa	9d6ccc6c-e657-4445-8af2-1e8dbd622110	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"54.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:15:17
41372	9d6ccc6c-df06-4717-b86a-6f25579652c7	9d6ccc6c-e657-4445-8af2-1e8dbd622110	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:15:17
41373	9d6ccc6c-e4bf-4d19-a376-a2a688e9c1b3	9d6ccc6c-e657-4445-8af2-1e8dbd622110	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-11-06 10:15:17
41374	9d6ccc6c-e523-41d6-bec8-aff61f0b1d78	9d6ccc6c-e657-4445-8af2-1e8dbd622110	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:17
8700	9d52ee7f-6d57-46f9-b438-da6957f7e6a6	9d52ee7f-791c-48d8-9b49-21a935ea63d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 13:39:02
8701	9d52ee7f-7810-4e6d-b74b-7095a11c9c68	9d52ee7f-791c-48d8-9b49-21a935ea63d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 13:39:02
8702	9d52ee7f-7851-4887-97c9-6fd1659221aa	9d52ee7f-791c-48d8-9b49-21a935ea63d3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[],"item":[]},"duration":191,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:39:02
16850	9d64dbd5-937a-4e53-ae73-42616077195c	9d64dbd6-f2a1-4251-ad57-801cd4d0863c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 11:31:44
16851	9d64dbd6-f0ef-4f27-a43b-5343399011c7	9d64dbd6-f2a1-4251-ad57-801cd4d0863c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 11:31:45
12827	9d5ceceb-2ced-456d-82c4-5a0280a44444	9d5ceceb-2ff9-4771-b290-91011a66c9e1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":138,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:52:53
16852	9d64dbd6-f18b-453b-a041-a5c7fcb07f92	9d64dbd6-f2a1-4251-ad57-801cd4d0863c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1154,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:31:45
16849	9d64dbd6-e0bd-4682-a781-80cef54b6005	9d64dbd6-f2a1-4251-ad57-801cd4d0863c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":783}	2024-11-02 11:31:45
8703	9d52ee81-4548-44ef-8a5e-20fa0adf6fb4	9d52ee81-8971-42b3-9726-80400077b0b8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 13:39:03
8704	9d52ee81-84ad-4ffe-8ca8-ab550214c377	9d52ee81-8971-42b3-9726-80400077b0b8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"141.79","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:39:03
8705	9d52ee81-8507-4ff1-9886-8bd15c516452	9d52ee81-8971-42b3-9726-80400077b0b8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:39:03
8706	9d52ee81-882f-41e1-beb4-f97718604419	9d52ee81-8971-42b3-9726-80400077b0b8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-24 13:39:03
8707	9d52ee81-8871-4c7e-8b2e-0224dece35f9	9d52ee81-8971-42b3-9726-80400077b0b8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":413,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:39:03
16853	9d64dbd7-4530-47c0-b659-dc0e2f2660cc	9d64dbd7-5f25-41b5-a34e-05aa28d2d493	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 11:31:46
16854	9d64dbd7-5b47-4645-9fd0-8f99727cba47	9d64dbd7-5f25-41b5-a34e-05aa28d2d493	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"44.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":24,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-11-02 11:31:46
12828	9d5ceceb-a440-47ee-8e3f-8c199fc5549e	9d5ceceb-ec03-44b9-a894-1194f9c29ee9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-29 12:52:54
12829	9d5ceceb-e64b-4cfa-999a-8d41529b5c57	9d5ceceb-ec03-44b9-a894-1194f9c29ee9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAr%' or \\"users\\".\\"user_document\\"::text like '%MAr%') order by \\"users\\".\\"user_document\\" asc","time":"153.18","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:52:54
12830	9d5ceceb-eab3-465a-bf8d-5d350e6b1127	9d5ceceb-ec03-44b9-a894-1194f9c29ee9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-29 12:52:54
12831	9d5ceceb-eb05-40e6-8f36-d6d0cb7af7a0	9d5ceceb-ec03-44b9-a894-1194f9c29ee9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAr"},"session":[],"response_status":200,"response":{"data":[]},"duration":325,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:54
16855	9d64dbd7-5df8-4fad-8c5b-ccbd0f9fc2ef	9d64dbd7-5f25-41b5-a34e-05aa28d2d493	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 11:31:46
16856	9d64dbd7-5e50-494f-ba62-e33c1bc2d8d5	9d64dbd7-5f25-41b5-a34e-05aa28d2d493	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:31:46
41375	9d6ccc6d-3fa8-4a7d-aaa9-7b755a6687c8	9d6ccc6d-6149-441c-997d-f1b0e90982bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-11-06 10:15:17
16857	9d64dbd9-23f1-432b-b0e1-d07649fa121a	9d64dbd9-a23e-40a2-af8c-156a564d4b8b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 11:31:47
10010	9d56c6b3-92d4-4b50-a52f-6c079050aec9	9d56c6b3-d7e6-4a95-a5e1-2a6e151c2e42	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:31:04
10011	9d56c6b3-d689-4afe-83d5-496f1dc4f7d4	9d56c6b3-d7e6-4a95-a5e1-2a6e151c2e42	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:31:04
10012	9d56c6b3-d717-4444-94b9-09b56cef5da4	9d56c6b3-d7e6-4a95-a5e1-2a6e151c2e42	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abl\\u00bb\\nLINE 13:                                 l.loans_nombre\\n                                         ^ (Connection: pgsql, SQL: \\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                                l.loans_nombre\\n                                l.loans_apellido_uno\\n                                l.loans_apellido_dos\\n                                l.loans_tipo_documento\\n                                l.loans_documento\\n                                l.loans_fecha_nacimiento\\n                                l.loans_ciudad\\n                                l.loans_barrio\\n                                l.loans_direccion\\n                                l.loans_intereses\\n                                l.loans_cuotas\\n                                l.loans_valor_prestado\\n                                l.loans_cuando\\n                                l.loans_observacion\\n                                l.loans_fecha\\n                                l.loans_estado\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":377,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:31:04
16858	9d64dbd9-7a0d-49dc-9fd7-b2b977544db2	9d64dbd9-a23e-40a2-af8c-156a564d4b8b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"180.60","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 11:31:47
16859	9d64dbd9-7a98-4fe2-90c7-6ac1be4cc8df	9d64dbd9-a23e-40a2-af8c-156a564d4b8b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 11:31:47
16860	9d64dbd9-a072-4d9b-8e19-c048a31b7ad5	9d64dbd9-a23e-40a2-af8c-156a564d4b8b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 11:31:47
16861	9d64dbd9-a0e4-463a-8516-36765d3a5894	9d64dbd9-a23e-40a2-af8c-156a564d4b8b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":715,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:31:47
16966	9d654665-56c0-457c-bd99-227d7a47a67d	9d654665-767d-4a8b-b036-0ce7f59a92a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 16:29:43
16967	9d654665-74a2-45dd-8131-5236e36be335	9d654665-767d-4a8b-b036-0ce7f59a92a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 16:29:43
16968	9d654665-755b-4da8-bf37-457b80166f17	9d654665-767d-4a8b-b036-0ce7f59a92a6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42P01]: Undefined table: 7 ERROR:  falta una entrada para la tabla \\u00abl\\u00bb en la cl\\u00e1usula FROM\\nLINE 1: select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", ...\\n               ^ (Connection: pgsql, SQL: select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" inner join \\"users\\" as \\"ucl\\" on \\"loans\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"loans\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"loans\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id \\" desc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":42,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:29:43
41376	9d6ccc6d-5ae2-4945-ac1b-27a6a0df9753	9d6ccc6d-6149-441c-997d-f1b0e90982bd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"53.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:15:17
41377	9d6ccc6d-5fc9-40bb-9bf0-e2874434fe10	9d6ccc6d-6149-441c-997d-f1b0e90982bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-11-06 10:15:17
41378	9d6ccc6d-6026-4fb7-9ae9-4c994842df1e	9d6ccc6d-6149-441c-997d-f1b0e90982bd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":297,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:17
10013	9d56c6b5-5c66-4119-821b-2b08222a1746	9d56c6b5-a71a-482e-8c7f-e0d384b34fd3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:31:05
10014	9d56c6b5-a197-45c6-af5c-1ad2d3ccc94d	9d56c6b5-a71a-482e-8c7f-e0d384b34fd3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"156.89","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:31:05
10015	9d56c6b5-a1e4-42e1-ac46-2d8cfee4b8ba	9d56c6b5-a71a-482e-8c7f-e0d384b34fd3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:31:05
10016	9d56c6b5-a5b0-4b6a-b491-a15ed5c09ad6	9d56c6b5-a71a-482e-8c7f-e0d384b34fd3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 11:31:05
10017	9d56c6b5-a5f2-49e3-8c3b-b0ee0c46e498	9d56c6b5-a71a-482e-8c7f-e0d384b34fd3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":353,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:31:05
41379	9d6ccc6d-af77-42db-8318-3b77c2c850d7	9d6ccc6d-b2f7-4807-8dce-c649adbc1da4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":178,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:17
12832	9d5cecec-4a08-44b2-a829-2e11c62e27a4	9d5cecec-6453-49e6-9ca7-fe92522529fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-29 12:52:54
12833	9d5cecec-607f-42b9-a10d-8df14079183f	9d5cecec-6453-49e6-9ca7-fe92522529fd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"40.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:52:54
12834	9d5cecec-6338-4670-b742-dec17c7d0c9c	9d5cecec-6453-49e6-9ca7-fe92522529fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-29 12:52:54
12835	9d5cecec-637c-4a1b-914a-c30e375ee7fd	9d5cecec-6453-49e6-9ca7-fe92522529fd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":290,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:54
1133	9d4fbd1c-6fe7-422f-96a8-1b62bd40eef7	9d4fbd1d-42f3-4459-bd23-ce8f81c373e0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":87}	2024-10-22 23:33:27
18659	9d669907-fa52-4920-a11d-f282c1cf8331	9d669907-fe08-4984-b79d-1c0e9bccb4eb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":900}	2024-11-03 08:16:36
17068	9d654928-00ae-4300-b143-5e2e459904c5	9d654928-4e63-407f-b234-b151fb1cbaa6	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 16:37:26
17069	9d654928-4c49-4e19-90be-85fd663e123c	9d654928-4e63-407f-b234-b151fb1cbaa6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:37:26
17070	9d654928-4d30-486d-b4bd-af0943e14aff	9d654928-4e63-407f-b234-b151fb1cbaa6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":365,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:37:26
17071	9d654928-d129-4cb0-8359-c897dd66c757	9d654928-f063-4621-a401-fdd281e0b703	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:37:26
17072	9d654928-ea0f-4531-9aa8-267295d31352	9d654928-f063-4621-a401-fdd281e0b703	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select (l.loans_fecha_ultimo_pago::date - '2024-11-02'::date) as dis_restantes, \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"46.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":32,"hash":"b870d711638eac4fca840e97c3785e38","hostname":"EderCortes"}	2024-11-02 16:37:26
17021	9d654742-94e9-4fb7-b55f-abb17a13ea46	9d654742-b8ee-4756-b462-33b1015831cf	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 16:32:08
17022	9d654742-b713-4d60-afd4-d9e8570907af	9d654742-b8ee-4756-b462-33b1015831cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:32:08
17023	9d654742-b7c9-4974-b17d-6ef71546f478	9d654742-b8ee-4756-b462-33b1015831cf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:32:08
17073	9d654928-eebe-4209-a77b-25f26b358dfe	9d654928-f063-4621-a401-fdd281e0b703	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 16:37:26
17074	9d654928-ef4f-41a1-8dc7-b9a1f35cc13a	9d654928-f063-4621-a401-fdd281e0b703	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dis_restantes":0,"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":380,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:37:26
41380	9d6ccc6e-77d7-4351-86cb-f02a07bb61df	9d6ccc6e-c166-4221-8a82-c06ca9beba22	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-11-06 10:15:18
41381	9d6ccc6e-bc66-46eb-a0a8-f203a9332c6a	9d6ccc6e-c166-4221-8a82-c06ca9beba22	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"156.40","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 10:15:18
41382	9d6ccc6e-bff5-4387-bbb5-5b61a8e01299	9d6ccc6e-c166-4221-8a82-c06ca9beba22	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":29,"hostname":"EderCortes"}	2024-11-06 10:15:18
41383	9d6ccc6e-c063-4d35-af37-267dd7e4831e	9d6ccc6e-c166-4221-8a82-c06ca9beba22	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":386,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:18
17075	9d65492b-0176-4e85-8054-26d06b301c87	9d65492b-4893-4184-aaa9-f8d118ed2250	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 16:37:28
17076	9d65492b-4372-4d33-8719-36a81f14795e	9d65492b-4893-4184-aaa9-f8d118ed2250	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"144.80","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 16:37:28
17077	9d65492b-43d1-48b2-aab8-f57057ae6604	9d65492b-4893-4184-aaa9-f8d118ed2250	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 16:37:28
17078	9d65492b-474c-4c6e-bda6-e4a01385c28d	9d65492b-4893-4184-aaa9-f8d118ed2250	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 16:37:28
17079	9d65492b-4795-4a66-8468-f3f66b24817b	9d65492b-4893-4184-aaa9-f8d118ed2250	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":358,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:37:28
17172	9d654f4c-e60b-4333-9fc3-508360a8a6f9	9d654f4d-1371-4e9e-98de-0f52e2114379	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 16:54:36
17173	9d654f4d-10dc-469b-85f1-fe355a9d9da4	9d654f4d-1371-4e9e-98de-0f52e2114379	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:54:37
17174	9d654f4d-1224-41a8-a3bd-d0999a51a8ff	9d654f4d-1371-4e9e-98de-0f52e2114379	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:54:37
17175	9d654f4d-a840-471a-b583-722732fe5973	9d654f4d-f3d2-41e8-8565-86f2a8e05624	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:54:37
17176	9d654f4d-ee72-434c-bd85-3fc32d7bb902	9d654f4d-f3d2-41e8-8565-86f2a8e05624	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"158.07","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":46,"hash":"fb4ded687569d92428336ceae5c6ffcd","hostname":"EderCortes"}	2024-11-02 16:54:37
10075	9d56c80a-3cc7-4dcc-94dd-53eb8082a3fc	9d56c80a-5ae3-48bc-a2c1-b0466ef7600e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 11:34:48
10076	9d56c80a-5896-4c33-bcf9-28f45177e4d4	9d56c80a-5ae3-48bc-a2c1-b0466ef7600e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-26 11:34:48
10077	9d56c80a-59b7-422c-b508-d3d9fb14603c	9d56c80a-5ae3-48bc-a2c1-b0466ef7600e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:34:48
17177	9d654f4d-f24c-48c6-b5ad-70c89615bbfd	9d654f4d-f3d2-41e8-8565-86f2a8e05624	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 16:54:37
17178	9d654f4d-f2b1-4c17-9f3e-43720594310e	9d654f4d-f3d2-41e8-8565-86f2a8e05624	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":541,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:54:37
10078	9d56c80a-a1f4-4d9b-9fd2-28f6de60dae8	9d56c80a-bc4b-4266-a631-a18cf893cd4f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-26 11:34:48
10079	9d56c80a-b868-4c82-9434-431468990bbc	9d56c80a-bc4b-4266-a631-a18cf893cd4f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"42.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:34:48
10080	9d56c80a-bb2b-4289-a41f-b564b54a1825	9d56c80a-bc4b-4266-a631-a18cf893cd4f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-26 11:34:48
10081	9d56c80a-bb6e-4853-8ab5-6076c521d8d1	9d56c80a-bc4b-4266-a631-a18cf893cd4f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":219,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:34:48
17179	9d654f4f-f810-4487-9b91-6cb63633875d	9d654f50-3f6d-4d36-81e1-fa25cfac3eb0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 16:54:38
17180	9d654f50-3a31-45e1-abe9-6125dc6b0ad6	9d654f50-3f6d-4d36-81e1-fa25cfac3eb0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"144.67","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 16:54:39
12836	9d5cecec-a3ec-48d4-92dc-9af41b34bd69	9d5cecec-a79e-4524-911e-6ee854979f83	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":149,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:52:54
17181	9d654f50-3a8a-4ce2-a03a-f2e6a598a9f4	9d654f50-3f6d-4d36-81e1-fa25cfac3eb0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 16:54:39
17182	9d654f50-3df7-4100-8fa8-36611a59ab76	9d654f50-3f6d-4d36-81e1-fa25cfac3eb0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 16:54:39
17183	9d654f50-3e44-444e-8fae-a66867cb738a	9d654f50-3f6d-4d36-81e1-fa25cfac3eb0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":341,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:54:39
10082	9d56c80c-1c59-4bba-aedd-2d61ed33cc0d	9d56c80c-6062-4fb7-879d-25fd28af7fc2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-26 11:34:49
10083	9d56c80c-5b71-436c-8f8f-1a87dd55ae10	9d56c80c-6062-4fb7-879d-25fd28af7fc2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"142.79","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:34:50
10084	9d56c80c-5bb9-4fbc-aaef-145ce14c67c9	9d56c80c-6062-4fb7-879d-25fd28af7fc2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:34:50
10085	9d56c80c-5f46-4495-8516-31e9e7e4d934	9d56c80c-6062-4fb7-879d-25fd28af7fc2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-26 11:34:50
10086	9d56c80c-5f86-4bbc-abbe-acf29f4c3f1c	9d56c80c-6062-4fb7-879d-25fd28af7fc2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":322,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:34:50
12837	9d5cecec-f3f7-42c9-a133-c0b4da384282	9d5cecec-f705-470c-af88-c8447cd1ac2c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":141,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:52:55
8863	9d52ef80-0a5c-4f35-8370-889a350da4fc	9d52ef80-2e06-4e6d-b9c3-7294758ded50	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 13:41:50
8864	9d52ef80-2c12-4649-b8c4-831018242db3	9d52ef80-2e06-4e6d-b9c3-7294758ded50	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:41:50
8865	9d52ef80-2ce0-4bdb-8326-855e2dccbe61	9d52ef80-2e06-4e6d-b9c3-7294758ded50	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":257,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:41:50
17254	9d6551a0-2239-4e98-b729-e88bad0ea835	9d6551a0-3fc5-4c18-be07-87149a8bee5b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:01:07
17255	9d6551a0-3dfc-4545-b993-aa1627f865f5	9d6551a0-3fc5-4c18-be07-87149a8bee5b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:01:07
17256	9d6551a0-3ecc-4c00-be2c-4d8816c570d3	9d6551a0-3fc5-4c18-be07-87149a8bee5b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":260,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:01:07
8866	9d52ef80-840d-4a96-8c6f-6da3d0181758	9d52ef80-cc12-4fad-ae13-2b78a6ea7016	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:41:50
8867	9d52ef80-c6ad-4131-8130-734be81052ad	9d52ef80-cc12-4fad-ae13-2b78a6ea7016	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"146.87","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:41:50
8868	9d52ef80-c700-4f6f-bcda-b55601ddb886	9d52ef80-cc12-4fad-ae13-2b78a6ea7016	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:41:50
8869	9d52ef80-caf9-471e-a9b1-e0496e6c8797	9d52ef80-cc12-4fad-ae13-2b78a6ea7016	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:41:50
7945	9d52e567-69fd-4f62-b7da-596942e90291	9d52e567-91a0-45f6-99c7-8467b5d80d04	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:13:36
7946	9d52e567-8f3c-4f4b-9a5b-7bb8e568990f	9d52e567-91a0-45f6-99c7-8467b5d80d04	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:13:36
7947	9d52e567-9043-4f16-b673-d4242bc53209	9d52e567-91a0-45f6-99c7-8467b5d80d04	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":395,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:13:36
8870	9d52ef80-cb3b-4b88-8979-d7d6a81d296e	9d52ef80-cc12-4fad-ae13-2b78a6ea7016	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":375,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:41:50
17257	9d6551a2-056b-48bb-8711-d084c74221b7	9d6551a2-3016-40cc-a291-e9b254514196	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:01:08
17258	9d6551a2-2539-4366-b906-37ca3465b828	9d6551a2-3016-40cc-a291-e9b254514196	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"58.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 17:01:08
12838	9d5ceced-497e-4656-b198-3e083f460c80	9d5ceced-4c70-469f-8264-deda2d8b43b7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":130,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:52:55
17259	9d6551a2-25e8-437f-8aff-113c8a22550e	9d6551a2-3016-40cc-a291-e9b254514196	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 17:01:08
17260	9d6551a2-2e03-4a37-81a4-68cf4a2f4d5e	9d6551a2-3016-40cc-a291-e9b254514196	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:01:08
17261	9d6551a2-2e97-46c1-b828-e16f73f8e314	9d6551a2-3016-40cc-a291-e9b254514196	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":420,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:01:08
7948	9d52e567-e6b2-4076-9171-dd0b62bf7772	9d52e568-3217-49e0-bca4-17de10a0ea65	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:13:36
7949	9d52e568-2d04-4259-a3f8-43066817c054	9d52e568-3217-49e0-bca4-17de10a0ea65	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"153.10","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:13:36
7950	9d52e568-2d55-4738-93da-b69ff511e3b9	9d52e568-3217-49e0-bca4-17de10a0ea65	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:13:36
7951	9d52e568-30f0-45ef-a39a-14e4b13ec68f	9d52e568-3217-49e0-bca4-17de10a0ea65	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:13:36
7952	9d52e568-3137-47b4-8c81-e08295e453d7	9d52e568-3217-49e0-bca4-17de10a0ea65	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":368,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:13:36
8871	9d52ef81-1247-487f-9f69-f885c5ff3608	9d52ef81-3249-40b1-889b-a1917b2788e6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:41:50
8872	9d52ef81-2cbb-43a4-9ecf-f6692e43da0a	9d52ef81-3249-40b1-889b-a1917b2788e6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:41:50
8873	9d52ef81-2d12-47ff-b706-f5d427c11f57	9d52ef81-3249-40b1-889b-a1917b2788e6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:41:50
8874	9d52ef81-30fc-43e7-b799-463c32db3298	9d52ef81-3249-40b1-889b-a1917b2788e6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:41:51
8875	9d52ef81-3154-4940-9811-0a21cf5321a2	9d52ef81-3249-40b1-889b-a1917b2788e6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:41:51
24973	9d68bee7-1770-45d1-8433-873cb8ae08ec	9d68bee7-6534-41d7-9edb-44ec017b89b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 09:54:09
12839	9d5ceced-9ceb-4433-a066-c5b32c0235b0	9d5ceced-e22d-4f57-9dc0-dc18bd259861	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-29 12:52:55
12840	9d5ceced-ddf7-4cfe-b0d2-fdd1dc40dd17	9d5ceced-e22d-4f57-9dc0-dc18bd259861	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ma%' or \\"users\\".\\"user_document\\"::text like '%Ma%') order by \\"users\\".\\"user_document\\" asc","time":"151.55","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:52:55
12841	9d5ceced-e10f-404f-8be5-a72871c6e3af	9d5ceced-e22d-4f57-9dc0-dc18bd259861	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-29 12:52:55
12842	9d5ceced-e152-4eb5-a6f6-b1528895ef1f	9d5ceced-e22d-4f57-9dc0-dc18bd259861	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ma"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":324,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:55
7953	9d52e568-7445-4ad8-b83e-288332b4fc4d	9d52e568-be7a-44e4-a9bf-99f30b398ffd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:13:37
7954	9d52e568-b96d-4188-9cb5-fd50aab9a51f	9d52e568-be7a-44e4-a9bf-99f30b398ffd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"154.80","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:13:37
7955	9d52e568-b9be-4b99-8f3a-a3b2cfd110ce	9d52e568-be7a-44e4-a9bf-99f30b398ffd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:13:37
7956	9d52e568-bd39-48f1-975d-ab54fed2c9ad	9d52e568-be7a-44e4-a9bf-99f30b398ffd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:13:37
7957	9d52e568-bd90-4c2e-94b2-7e4fe49622f8	9d52e568-be7a-44e4-a9bf-99f30b398ffd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:13:37
8876	9d52ef81-7920-409c-950a-339dc024ea8c	9d52ef81-993a-466a-b92a-02033bbffbe0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:41:51
8877	9d52ef81-9231-4578-a600-4ecdde601007	9d52ef81-993a-466a-b92a-02033bbffbe0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"41.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-24 13:41:51
8878	9d52ef81-927d-4ebd-8763-62ede00473e9	9d52ef81-993a-466a-b92a-02033bbffbe0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:41:51
8879	9d52ef81-9437-4be3-abef-35b4e2338668	9d52ef81-993a-466a-b92a-02033bbffbe0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"2.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 13:41:51
8880	9d52ef81-946c-4e96-b01b-71563dc298a6	9d52ef81-993a-466a-b92a-02033bbffbe0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:41:51
8881	9d52ef81-980f-4411-b77c-b206d40b47c9	9d52ef81-993a-466a-b92a-02033bbffbe0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:41:51
8882	9d52ef81-9861-4d97-a5bc-f9cf3702c3ac	9d52ef81-993a-466a-b92a-02033bbffbe0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:41:51
24979	9d68bee8-1e80-4486-9c14-8ccc0348e39d	9d68bee8-51b7-42a5-a5b3-4df4d6f4fcc9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 09:54:10
12843	9d5cecee-26d6-4f2d-8fca-1e13a779856e	9d5cecee-4010-4e73-808f-39f778a91bce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-29 12:52:55
12844	9d5cecee-3beb-4f5a-879a-b1309f70cd29	9d5cecee-4010-4e73-808f-39f778a91bce	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mar%' or \\"users\\".\\"user_document\\"::text like '%Mar%') order by \\"users\\".\\"user_document\\" asc","time":"38.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:52:55
12845	9d5cecee-3ee1-486e-a44f-309a28a968cb	9d5cecee-4010-4e73-808f-39f778a91bce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-29 12:52:55
12846	9d5cecee-3f21-409b-936b-ab16d34ff781	9d5cecee-4010-4e73-808f-39f778a91bce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mar"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":222,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:55
7958	9d52e569-035f-4ce7-985f-ce355569ef4e	9d52e569-24ad-407f-b106-545f956e51e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:13:37
7959	9d52e569-1b71-44e1-9492-8e8e03ebb13d	9d52e569-24ad-407f-b106-545f956e51e3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc","time":"43.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 13:13:37
7960	9d52e569-1bc9-43b0-96ba-db8a7282c056	9d52e569-24ad-407f-b106-545f956e51e3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:13:37
7961	9d52e569-1f9c-4f40-92af-5b145c6b99ba	9d52e569-24ad-407f-b106-545f956e51e3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6'","time":"1.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 13:13:37
6210	9d526207-0e7d-4e32-8793-d660fce86579	9d526207-5778-4c03-a37d-d56a214042ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 07:06:15
6211	9d526207-5566-4a82-a876-8ab368e7a980	9d526207-5778-4c03-a37d-d56a214042ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 07:06:15
6212	9d526207-5620-4029-a206-04347ce804b9	9d526207-5778-4c03-a37d-d56a214042ef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":359,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:06:15
7962	9d52e569-1fd2-4556-94e8-41e106193ec9	9d52e569-24ad-407f-b106-545f956e51e3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:13:37
7963	9d52e569-237e-4463-b528-b0186aab6794	9d52e569-24ad-407f-b106-545f956e51e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:13:37
7964	9d52e569-23ca-425c-87f7-f32f16e1d8e8	9d52e569-24ad-407f-b106-545f956e51e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:13:37
8883	9d52ef83-01c5-4d05-a8a5-3e5ab4d38e66	9d52ef83-4a33-4eff-ac9a-90582757bd59	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:41:52
8884	9d52ef83-44ef-4032-bd80-a9553629bf7e	9d52ef83-4a33-4eff-ac9a-90582757bd59	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"147.53","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:41:52
8885	9d52ef83-4547-4705-9dcc-2be255b1b1a3	9d52ef83-4a33-4eff-ac9a-90582757bd59	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:41:52
8886	9d52ef83-48ef-456e-9b2a-8f9958bb6f6c	9d52ef83-4a33-4eff-ac9a-90582757bd59	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:41:52
8887	9d52ef83-4937-4306-b594-d4bee879f443	9d52ef83-4a33-4eff-ac9a-90582757bd59	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":535,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:41:52
24980	9d68bee8-47d4-4757-84cc-a90b7f34cb7d	9d68bee8-51b7-42a5-a5b3-4df4d6f4fcc9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"68.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:54:10
12847	9d5cecee-7f92-4a6e-a705-d8a6dacdc206	9d5cecee-99d8-4b25-a4b1-1bb6ad6509f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-29 12:52:56
12848	9d5cecee-95db-4352-bccd-593fc0ebd819	9d5cecee-99d8-4b25-a4b1-1bb6ad6509f2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"41.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:52:56
12849	9d5cecee-98b1-4d11-a88b-38fd2106f427	9d5cecee-99d8-4b25-a4b1-1bb6ad6509f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-29 12:52:56
24981	9d68bee8-4863-4245-9fec-e2afb1485db9	9d68bee8-51b7-42a5-a5b3-4df4d6f4fcc9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:54:10
24982	9d68bee8-4f8b-45f5-b374-b26e2555ecaa	9d68bee8-51b7-42a5-a5b3-4df4d6f4fcc9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 09:54:10
6213	9d526207-a0f7-41c2-9433-9fe42a391a83	9d526207-bdc8-4210-8391-ff8c0980347d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 07:06:15
6214	9d526207-b6c9-4bbf-afa8-6ac586a83697	9d526207-bdc8-4210-8391-ff8c0980347d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n    select l.id,\\n        l.loans_documento,\\n        l.loans_nombre,\\n        l.loans_apellido_uno,\\n        l.loans_fecha,\\n        l.loans_valor_prestado,\\n        l.loans_cuotas,\\n        loans_intereses,\\n        ucl.name as cliente,\\n        uco.name as cobrador,\\n        ure.name as recomendador\\n    from loans l\\n    join users ucl on l.user_customer = ucl.id\\n    join users uco on l.user_cobrador = uco.id\\n    left join users ure on l.user_recomendacion = ure.id\\n","time":"43.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23,"hash":"4a29eecc7f0e29116a12840a44c5fe9b","hostname":"EderCortes"}	2024-10-24 07:06:15
6215	9d526207-bc9c-4b53-b64b-d6b7ea372646	9d526207-bdc8-4210-8391-ff8c0980347d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 07:06:15
6216	9d526207-bcea-4de8-a834-bd05859f4884	9d526207-bdc8-4210-8391-ff8c0980347d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_intereses":25,"cliente":"Luis andre","cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_intereses":25,"cliente":"Luis andre","cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_intereses":25,"cliente":"Luis andre","cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_intereses":25,"cliente":"Luis andre","cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_intereses":25,"cliente":"Luis andre","cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_intereses":25,"cliente":"Luis andre","cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_intereses":25,"cliente":"Luis andre","cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_intereses":25,"cliente":"Luis andre","cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_intereses":25,"cliente":"Luis andre","cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_intereses":25,"cliente":"Luis andre","cobrador":"Luis andre","recomendador":null}]},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:06:15
7965	9d52e56a-f16e-4ef8-815a-73eaf13bc28f	9d52e56b-21db-428a-9e47-03d700c248c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:13:38
7966	9d52e56b-17d8-414f-bfaa-d167a70ec788	9d52e56b-21db-428a-9e47-03d700c248c8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"69.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:13:38
7967	9d52e56b-183f-40dd-9028-59bf31d71c0d	9d52e56b-21db-428a-9e47-03d700c248c8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:13:38
7968	9d52e56b-1f9c-49d2-a9e5-0cb4b3d149af	9d52e56b-21db-428a-9e47-03d700c248c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 13:13:38
7969	9d52e56b-2037-4cf1-8a9f-c655436fdc96	9d52e56b-21db-428a-9e47-03d700c248c8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":393,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:13:38
10153	9d56c9e1-141f-44c6-8f0f-ecfc707f191f	9d56c9e1-6030-4461-b144-cb4320ee7aff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 11:39:57
10154	9d56c9e1-5ebc-495d-9286-fb38cd06a636	9d56c9e1-6030-4461-b144-cb4320ee7aff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 11:39:57
10155	9d56c9e1-5f58-4c11-9777-362e48b17c93	9d56c9e1-6030-4461-b144-cb4320ee7aff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":367,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:39:57
6217	9d526209-2bf6-4dd9-a92c-ee8a5dcc5016	9d526209-5a60-4e3e-8b87-0496cd1ae9f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 07:06:16
6218	9d526209-5133-4215-a00c-f0614158eca5	9d526209-5a60-4e3e-8b87-0496cd1ae9f9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"68.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 07:06:16
6219	9d526209-51bb-447c-a1e3-a6a0e20cfc6b	9d526209-5a60-4e3e-8b87-0496cd1ae9f9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 07:06:16
6220	9d526209-586f-49e2-b907-e3bfc19ec912	9d526209-5a60-4e3e-8b87-0496cd1ae9f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 07:06:16
6221	9d526209-58f4-404f-a175-136c5e611b0e	9d526209-5a60-4e3e-8b87-0496cd1ae9f9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":428,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:06:16
10156	9d56c9e1-ac8c-42a0-a781-cf0821cb5f26	9d56c9e1-f185-4f59-aa31-fec553cf414c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 11:39:57
10157	9d56c9e1-ed1f-4d98-b63a-f283130af699	9d56c9e1-f185-4f59-aa31-fec553cf414c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"152.10","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:39:57
6266	9d5263a9-d012-472a-aa2a-d9d6b76f4e15	9d5263a9-fd1c-4026-b3ff-0068e7331752	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 07:10:49
6267	9d5263a9-fa72-453f-8e8d-0a19acfcc077	9d5263a9-fd1c-4026-b3ff-0068e7331752	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 07:10:49
6268	9d5263a9-fb78-4bf9-8aab-8828015ebd11	9d5263a9-fd1c-4026-b3ff-0068e7331752	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abfrom\\u00bb\\nLINE 14:     from loans l\\n             ^ (Connection: pgsql, SQL: \\n    select l.id,\\n        l.loans_documento,\\n        l.loans_nombre,\\n        l.loans_apellido_uno,\\n        l.loans_fecha,\\n        l.loans_valor_prestado,\\n        l.loans_cuotas,\\n        l.loans_estado,\\n        l.loans_intereses,\\n        ucl.name as cliente,\\n        uco.name as cobrador,\\n        ure.name as recomendador,\\n    from loans l\\n    join users ucl on l.user_customer = ucl.id\\n    join users uco on l.user_cobrador = uco.id\\n    left join users ure on l.user_recomendacion = ure.id\\n)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":378,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:10:49
10158	9d56c9e1-f062-4804-8277-5d7258bfcdd3	9d56c9e1-f185-4f59-aa31-fec553cf414c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 11:39:57
10159	9d56c9e1-f0a9-426a-bdd1-e04201d2584c	9d56c9e1-f185-4f59-aa31-fec553cf414c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":341,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:39:57
12850	9d5cecee-98f1-480f-a731-9f007493e2c9	9d5cecee-99d8-4b25-a4b1-1bb6ad6509f2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":222,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:56
10160	9d56c9e3-0d6c-4092-85e9-44de91d61275	9d56c9e3-54be-494e-a203-89b5403d01c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 11:39:58
10161	9d56c9e3-4ed3-45bc-a4a4-31c00c08d4bd	9d56c9e3-54be-494e-a203-89b5403d01c9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"145.92","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:39:58
10162	9d56c9e3-4f23-4fe5-adda-091f62843e53	9d56c9e3-54be-494e-a203-89b5403d01c9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:39:58
10163	9d56c9e3-534a-4def-951e-2dbbf6d97cf4	9d56c9e3-54be-494e-a203-89b5403d01c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 11:39:58
10164	9d56c9e3-53a6-436c-baff-a0f500be8bf2	9d56c9e3-54be-494e-a203-89b5403d01c9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":462,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:39:58
24983	9d68bee8-501e-4a8a-aba3-b3c0e13492bc	9d68bee8-51b7-42a5-a5b3-4df4d6f4fcc9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":588,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:54:10
24984	9d68bee8-ecf6-432f-87ba-42348bdddc62	9d68bee9-4aef-445b-833c-e9d8229ae9fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 09:54:10
24985	9d68bee9-4126-4f6b-b06d-a1fb7c4304e1	9d68bee9-4aef-445b-833c-e9d8229ae9fc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"185.08","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:54:11
24986	9d68bee9-41a3-4e90-98e1-38e137c889d2	9d68bee9-4aef-445b-833c-e9d8229ae9fc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:54:11
24987	9d68bee9-48d9-4102-b431-308abace47b7	9d68bee9-4aef-445b-833c-e9d8229ae9fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 09:54:11
24988	9d68bee9-4962-4db2-a900-ed4b14732d7b	9d68bee9-4aef-445b-833c-e9d8229ae9fc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":612,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:54:11
17328	9d655515-8dde-4712-bdb0-a322ce259cf0	9d655515-ddf2-4264-82c6-cea11f598525	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 17:10:47
17329	9d655515-db60-4969-ba0b-f5c21140e218	9d655515-ddf2-4264-82c6-cea11f598525	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:10:47
17330	9d655515-dca5-4cce-a729-3df86b077674	9d655515-ddf2-4264-82c6-cea11f598525	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":482,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:10:47
9045	9d52f3d3-aa69-431e-806b-dbcc96de9d44	9d52f3d3-c98c-4713-8031-c0eaf3dc78a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:53:56
9046	9d52f3d3-c78d-4e22-a89f-c56c9963eea7	9d52f3d3-c98c-4713-8031-c0eaf3dc78a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:53:56
9047	9d52f3d3-c857-4b32-84d4-72bdd83dc9f8	9d52f3d3-c98c-4713-8031-c0eaf3dc78a4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:53:56
24989	9d68beec-187d-4aed-8974-4ac0cd0941b1	9d68beec-399e-4124-97c2-2f58adba2e40	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 09:54:13
24990	9d68beec-3498-4461-b5ab-85d84ff22067	9d68beec-399e-4124-97c2-2f58adba2e40	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"54.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 09:54:13
24991	9d68beec-3818-4578-9b7c-ce1325e53cc1	9d68beec-399e-4124-97c2-2f58adba2e40	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 09:54:13
24992	9d68beec-3880-4f53-b00b-4f4ceecf07e9	9d68beec-399e-4124-97c2-2f58adba2e40	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":380,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:54:13
9048	9d52f3d4-2087-4699-9c4a-757a916798cc	9d52f3d4-6d32-45c5-8345-dc2263127a37	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:53:56
9049	9d52f3d4-675a-4cd8-9c02-2a1ce69bb95a	9d52f3d4-6d32-45c5-8345-dc2263127a37	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"157.10","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:53:56
9050	9d52f3d4-67a7-4a02-a45f-de47a10bda4f	9d52f3d4-6d32-45c5-8345-dc2263127a37	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:53:56
9051	9d52f3d4-6bca-4ac0-91fe-58ee362ee8b8	9d52f3d4-6d32-45c5-8345-dc2263127a37	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:53:56
9052	9d52f3d4-6c33-4be9-bc6a-c26e8bd831f0	9d52f3d4-6d32-45c5-8345-dc2263127a37	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":390,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:53:56
17331	9d655516-68e6-4a86-936d-3d39b57c222a	9d655516-86c0-4b0c-9c73-accfad13f5f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:10:47
17332	9d655516-814a-4961-8771-efa6a5fc1b69	9d655516-86c0-4b0c-9c73-accfad13f5f5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"45.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":46,"hash":"fb4ded687569d92428336ceae5c6ffcd","hostname":"EderCortes"}	2024-11-02 17:10:47
17333	9d655516-856f-422e-a649-c08642102d99	9d655516-86c0-4b0c-9c73-accfad13f5f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:10:47
17334	9d655516-85c6-44fa-8b05-51366ca252cb	9d655516-86c0-4b0c-9c73-accfad13f5f5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":379,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:10:47
6545	9d52d28a-c8d0-4a9c-843e-38ff7fcf193b	9d52d28a-f2e6-4c55-9e6d-e5dcc40c7b59	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 12:20:51
6546	9d52d28a-f0e3-44c7-81a3-9e14a413c2c2	9d52d28a-f2e6-4c55-9e6d-e5dcc40c7b59	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:20:52
6547	9d52d28a-f1b0-4c1a-bdab-6f9b87051c1d	9d52d28a-f2e6-4c55-9e6d-e5dcc40c7b59	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":277,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:20:52
17409	9d6559b2-643c-4a43-8255-dc93c48a212f	9d6559b2-99fe-487f-8ba1-efbe8448dbd7	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 17:23:41
17410	9d6559b2-974f-40f9-af01-0549cde5e0c8	9d6559b2-99fe-487f-8ba1-efbe8448dbd7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:23:41
17411	9d6559b2-9882-4719-bd75-ce479cab6220	9d6559b2-99fe-487f-8ba1-efbe8448dbd7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":391,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:23:41
9053	9d52f3d4-b259-4408-95ec-356fb587d44d	9d52f3d4-fa1f-4bfb-900d-9a5f6dc85e2a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:53:56
6548	9d52d28b-5213-46d7-babc-e567ea7f5e2f	9d52d28b-9dcf-4865-a642-66db9264a75b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:20:52
6549	9d52d28b-9885-467f-a2d1-28bd5b8ebf16	9d52d28b-9dcf-4865-a642-66db9264a75b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"157.52","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:20:52
6550	9d52d28b-98df-4884-987b-e5bc5f15f731	9d52d28b-9dcf-4865-a642-66db9264a75b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:20:52
6551	9d52d28b-9cb3-49ba-bf1b-795da733a5c0	9d52d28b-9dcf-4865-a642-66db9264a75b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:20:52
6552	9d52d28b-9cf3-46c7-9e3f-019641248a2f	9d52d28b-9dcf-4865-a642-66db9264a75b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":407,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:20:52
9054	9d52f3d4-f50a-4f25-8d83-5036346ed293	9d52f3d4-fa1f-4bfb-900d-9a5f6dc85e2a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"148.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:53:56
9055	9d52f3d4-f555-4cd7-9177-7f2325721f3a	9d52f3d4-fa1f-4bfb-900d-9a5f6dc85e2a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:53:56
9056	9d52f3d4-f8be-4d57-926e-476583340940	9d52f3d4-fa1f-4bfb-900d-9a5f6dc85e2a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:53:56
9057	9d52f3d4-f901-4c79-bbbd-272ed1345251	9d52f3d4-fa1f-4bfb-900d-9a5f6dc85e2a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:53:56
17412	9d6559b3-3b74-4622-8d60-79d0d1ca4479	9d6559b3-5df7-4e6d-b420-8aa97cbafd59	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:23:41
12607	9d5cec6a-aa3e-4bdf-b8af-3ee545cc24ba	9d5cec6a-f56c-49f7-80cf-7967e6220970	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 12:51:29
12608	9d5cec6a-f34c-4aa9-8749-47fbb4bc84b7	9d5cec6a-f56c-49f7-80cf-7967e6220970	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:51:29
12609	9d5cec6a-f41b-4485-8366-42bf3771f526	9d5cec6a-f56c-49f7-80cf-7967e6220970	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":409,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:51:29
17413	9d6559b3-5608-4abd-a579-964a03c1e29f	9d6559b3-5df7-4e6d-b420-8aa97cbafd59	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"47.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":46,"hash":"fb4ded687569d92428336ceae5c6ffcd","hostname":"EderCortes"}	2024-11-02 17:23:41
17414	9d6559b3-5c40-4eaa-a357-9bc574954ab6	9d6559b3-5df7-4e6d-b420-8aa97cbafd59	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:23:41
5070	9d513670-621f-433a-8155-3cedec2f0172	9d513670-bff9-4245-9dc6-3737977e566c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-23 17:08:32
5071	9d513670-bd15-44b0-999b-68fb18bf239a	9d513670-bff9-4245-9dc6-3737977e566c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-23 17:08:32
5072	9d513670-be82-418e-a268-7a4116f6e520	9d513670-bff9-4245-9dc6-3737977e566c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":614,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:32
6553	9d52d28b-e5e0-49b0-b328-5ef63f72c26e	9d52d28c-2e20-4f81-83f9-fe9858be0ac5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:20:52
6554	9d52d28c-28f2-416a-a9ed-7fa4bcf25f0b	9d52d28c-2e20-4f81-83f9-fe9858be0ac5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"149.34","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:20:52
6555	9d52d28c-294d-4b00-a924-ebf50dd9e400	9d52d28c-2e20-4f81-83f9-fe9858be0ac5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:20:52
6556	9d52d28c-2cba-48c3-bb05-92a83b13f01a	9d52d28c-2e20-4f81-83f9-fe9858be0ac5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:20:52
6557	9d52d28c-2d0c-4b99-90a8-e32f141bbda7	9d52d28c-2e20-4f81-83f9-fe9858be0ac5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":350,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:20:52
9058	9d52f3d5-3e55-434b-a3e4-ce854a1281d6	9d52f3d5-89db-4551-ad60-9d4cf5275d32	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:53:57
9059	9d52f3d5-82d4-4540-a26a-32b0250f6721	9d52f3d5-89db-4551-ad60-9d4cf5275d32	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"154.54","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-24 13:53:57
9060	9d52f3d5-8337-4439-ad05-05beeb37440b	9d52f3d5-89db-4551-ad60-9d4cf5275d32	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:53:57
9061	9d52f3d5-84d7-4129-a6a3-f1aab4b7ba50	9d52f3d5-89db-4551-ad60-9d4cf5275d32	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"1.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 13:53:57
9062	9d52f3d5-850a-4a28-801a-de7dfcaeb11b	9d52f3d5-89db-4551-ad60-9d4cf5275d32	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:53:57
9063	9d52f3d5-8854-4545-b38c-a487ac6b1bfc	9d52f3d5-89db-4551-ad60-9d4cf5275d32	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:53:57
9064	9d52f3d5-88a3-4906-a19e-7efc5e2aab95	9d52f3d5-89db-4551-ad60-9d4cf5275d32	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":346,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:53:57
12610	9d5cec6b-4cf4-4a87-b259-ea1b6c7905ea	9d5cec6b-937a-4394-883c-d0d5840bbf88	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:51:30
12407	9d5ce48d-0a6e-48b5-a1ed-8666d1f8c577	9d5ce48d-2ec5-4281-824a-8a17030a35f1	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 12:29:30
12408	9d5ce48d-2ca8-49b5-8bdf-931dfb37be30	9d5ce48d-2ec5-4281-824a-8a17030a35f1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:29:30
12409	9d5ce48d-2d6e-4239-be70-37044904f5e0	9d5ce48d-2ec5-4281-824a-8a17030a35f1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":304,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:29:30
12611	9d5cec6b-8e4a-4c1b-8dc8-ce1fde5dfa67	9d5cec6b-937a-4394-883c-d0d5840bbf88	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"146.10","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":180,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 12:51:30
12612	9d5cec6b-8e96-4669-85e7-58263e6bc960	9d5cec6b-937a-4394-883c-d0d5840bbf88	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 12:51:30
12613	9d5cec6b-926a-4005-8f52-29a6674dc6ea	9d5cec6b-937a-4394-883c-d0d5840bbf88	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:51:30
12614	9d5cec6b-92aa-4fc6-9385-ec7267fbd32b	9d5cec6b-937a-4394-883c-d0d5840bbf88	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":366,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:51:30
6558	9d52d28c-6e32-4bc0-be43-6f5c0e8c0a8c	9d52d28c-8a8e-4017-8ae5-cfd63e5a2a88	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:20:52
6559	9d52d28c-8497-4c81-8b04-0b552bb7cba3	9d52d28c-8a8e-4017-8ae5-cfd63e5a2a88	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '1' order by \\"id\\" asc","time":"40.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:20:53
6560	9d52d28c-84df-47da-af9b-88fa92111935	9d52d28c-8a8e-4017-8ae5-cfd63e5a2a88	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:20:53
6561	9d52d28c-8647-4352-9549-0fdf10342df1	9d52d28c-8a8e-4017-8ae5-cfd63e5a2a88	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1'","time":"1.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:20:53
6562	9d52d28c-8679-4430-8c25-9b7e0d68d4e3	9d52d28c-8a8e-4017-8ae5-cfd63e5a2a88	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 12:20:53
6563	9d52d28c-8987-40a4-ba66-ed1b2a5354cf	9d52d28c-8a8e-4017-8ae5-cfd63e5a2a88	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:20:53
6564	9d52d28c-89cb-41f1-8d3f-9b69d2697f07	9d52d28c-8a8e-4017-8ae5-cfd63e5a2a88	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}],"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]},"duration":224,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:20:53
9065	9d52f3d6-cd26-4b31-a5a1-50f6230b8250	9d52f3d7-25c2-40e1-a10b-a47aad620eaa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:53:58
9066	9d52f3d7-1c70-40d3-882f-cf3fac18c55d	9d52f3d7-25c2-40e1-a10b-a47aad620eaa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"163.71","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:53:58
9067	9d52f3d7-1cf1-45e1-ad52-6a58269d19c1	9d52f3d7-25c2-40e1-a10b-a47aad620eaa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:53:58
9068	9d52f3d7-2413-47ed-a6b0-2fac881c0997	9d52f3d7-25c2-40e1-a10b-a47aad620eaa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 13:53:58
9069	9d52f3d7-2493-4012-be85-1d0c9804d951	9d52f3d7-25c2-40e1-a10b-a47aad620eaa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":575,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:53:58
12410	9d5ce48d-8eb0-4736-bf27-d985180bcd3a	9d5ce48d-d5fd-4b60-831c-0ed96b44349c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:29:30
12411	9d5ce48d-d076-469b-8804-3aac8ba6336f	9d5ce48d-d5fd-4b60-831c-0ed96b44349c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"142.60","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":179,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 12:29:30
12412	9d5ce48d-d0cf-426e-a4a5-db6bc0dcae16	9d5ce48d-d5fd-4b60-831c-0ed96b44349c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 12:29:30
12413	9d5ce48d-d4df-42f0-87d7-984649c883ff	9d5ce48d-d5fd-4b60-831c-0ed96b44349c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:29:30
12414	9d5ce48d-d520-4e70-9a67-b1f497bfac63	9d5ce48d-d5fd-4b60-831c-0ed96b44349c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":388,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:29:30
12615	9d5cec6b-dd98-42cc-9c7a-10257df76bd5	9d5cec6b-fe38-49d4-92b6-ab293b331a02	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:51:30
6565	9d52d28d-fd34-46af-a30c-ccd5621c6dd2	9d52d28e-1b15-43d9-a592-a56a640fd533	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:20:54
6566	9d52d28e-1618-476f-9929-d38d2e43befb	9d52d28e-1b15-43d9-a592-a56a640fd533	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:20:54
6567	9d52d28e-1662-41b2-ab90-dcbdc6694ef5	9d52d28e-1b15-43d9-a592-a56a640fd533	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:20:54
6568	9d52d28e-19db-4d78-b10c-37e6df471c67	9d52d28e-1b15-43d9-a592-a56a640fd533	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:20:54
6569	9d52d28e-1a24-4d6b-a166-a96d90b10f1f	9d52d28e-1b15-43d9-a592-a56a640fd533	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":224,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:20:54
12415	9d5ce48e-1541-4ddc-897d-6356ff6c0e49	9d5ce48e-31df-4dba-9987-95453a8a31d4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:29:30
12416	9d5ce48e-2d76-49b9-af01-cede74f9b1ee	9d5ce48e-31df-4dba-9987-95453a8a31d4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":179,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 12:29:30
12417	9d5ce48e-2dc0-4aba-ac14-f432512e2416	9d5ce48e-31df-4dba-9987-95453a8a31d4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 12:29:30
12418	9d5ce48e-30de-481e-8ec0-8fd61a1518e3	9d5ce48e-31df-4dba-9987-95453a8a31d4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 12:29:30
12419	9d5ce48e-3120-436f-8aa4-1aa77dbf9d48	9d5ce48e-31df-4dba-9987-95453a8a31d4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":218,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:29:30
12616	9d5cec6b-f965-4eb8-9d1e-c91abd032aff	9d5cec6b-fe38-49d4-92b6-ab293b331a02	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":180,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 12:51:30
12617	9d5cec6b-f9bc-4f76-8f74-a40c05e8f380	9d5cec6b-fe38-49d4-92b6-ab293b331a02	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 12:51:30
12618	9d5cec6b-fd32-4bed-8be9-1654400aa707	9d5cec6b-fe38-49d4-92b6-ab293b331a02	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 12:51:30
12619	9d5cec6b-fd76-47ff-9bb2-505808041759	9d5cec6b-fe38-49d4-92b6-ab293b331a02	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":255,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:51:30
17415	9d6559b3-5cf2-4851-b817-9c0add673f55	9d6559b3-5df7-4e6d-b420-8aa97cbafd59	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":457,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:23:41
10244	9d56cc1a-0f1c-4c83-b4cf-686b8afa5bbc	9d56cc1a-2b79-46f2-9cfd-93679e081f46	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 11:46:10
10245	9d56cc1a-2a14-4641-b45c-5b4cd0b77057	9d56cc1a-2b79-46f2-9cfd-93679e081f46	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 11:46:10
10246	9d56cc1a-2a9d-488e-84de-09490d638562	9d56cc1a-2b79-46f2-9cfd-93679e081f46	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:46:10
12420	9d5ce490-290e-4454-8301-df399dbab99e	9d5ce490-7292-4902-9a86-f8f104238ce6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 12:29:32
10247	9d56cc1a-6fd9-498c-b15c-058acd8b17a7	9d56cc1a-889f-42a6-a49f-2ef0797ad001	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 11:46:10
10248	9d56cc1a-84c3-4be1-be6c-a0de535d4164	9d56cc1a-889f-42a6-a49f-2ef0797ad001	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"42.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:46:10
10249	9d56cc1a-87a0-4aa3-aad5-90eaa0cdddab	9d56cc1a-889f-42a6-a49f-2ef0797ad001	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 11:46:10
10250	9d56cc1a-87e4-4309-8be0-c769285fd54c	9d56cc1a-889f-42a6-a49f-2ef0797ad001	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":209,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:46:10
6304	9d526439-8d85-4fb1-8a08-0c72b07bbc20	9d526439-b073-46e5-a038-7ea7714e9ad0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 07:12:23
6305	9d526439-ae23-4898-be2a-574640045f00	9d526439-b073-46e5-a038-7ea7714e9ad0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 07:12:23
6306	9d526439-af2e-4d75-8ce7-5f07424653d6	9d526439-b073-46e5-a038-7ea7714e9ad0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":280,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:12:23
12421	9d5ce490-6dee-4489-a448-6301b91d2a04	9d5ce490-7292-4902-9a86-f8f104238ce6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"155.79","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 12:29:32
12422	9d5ce490-6e34-478f-a092-be5affcd8ef3	9d5ce490-7292-4902-9a86-f8f104238ce6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 12:29:32
10335	9d56cd88-a140-4958-9fad-90f762e25fbf	9d56cd88-e94a-4fc6-a166-b16164ec37c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 11:50:10
10336	9d56cd88-e7df-41cc-9510-411ca2241661	9d56cd88-e94a-4fc6-a166-b16164ec37c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 11:50:10
10337	9d56cd88-e873-4a30-85ea-b2d09bd451e9	9d56cd88-e94a-4fc6-a166-b16164ec37c0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":379,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:50:10
12423	9d5ce490-716e-40dc-81c6-d745d791a63c	9d5ce490-7292-4902-9a86-f8f104238ce6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 12:29:32
12424	9d5ce490-71b3-44e5-8523-27ea6edc017d	9d5ce490-7292-4902-9a86-f8f104238ce6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:29:32
12620	9d5cec6d-b444-4e4b-aa7f-401f367712c2	9d5cec6d-d072-40db-9bda-fc9f1fbe5a2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 12:51:31
12621	9d5cec6d-cb90-4559-875f-1662654feb5e	9d5cec6d-d072-40db-9bda-fc9f1fbe5a2b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"38.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 12:51:31
12622	9d5cec6d-cbd8-4963-8cdf-11b9275192b0	9d5cec6d-d072-40db-9bda-fc9f1fbe5a2b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 12:51:31
12623	9d5cec6d-cf4a-4645-a2d9-bdae449c326e	9d5cec6d-d072-40db-9bda-fc9f1fbe5a2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 12:51:31
17416	9d6559b5-6afd-412b-a68a-7dee5cec54ed	9d6559b5-b140-4fe2-b7da-558f13bc9941	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:23:43
10251	9d56cc1b-9afd-4c96-a99a-d94907f894a4	9d56cc1b-e26b-493a-a5c4-68009c0539c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 11:46:11
10252	9d56cc1b-dd61-4531-acdf-b3dbf0e17270	9d56cc1b-e26b-493a-a5c4-68009c0539c4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"151.69","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:46:11
10253	9d56cc1b-ddaa-4581-858b-2f8492e2c9f4	9d56cc1b-e26b-493a-a5c4-68009c0539c4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:46:11
10254	9d56cc1b-e148-4829-bf67-02f358071536	9d56cc1b-e26b-493a-a5c4-68009c0539c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 11:46:11
10255	9d56cc1b-e18a-44e0-a734-c18fc7c8335a	9d56cc1b-e26b-493a-a5c4-68009c0539c4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":386,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:46:11
12425	9d5ce49b-5cca-4e73-bdaa-4e7c94cecc40	9d5ce49b-5fef-4e18-aa50-c8129f80d294	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":143,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:29:39
17417	9d6559b5-ac40-4bea-b24c-aaa890077746	9d6559b5-b140-4fe2-b7da-558f13bc9941	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"147.46","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 17:23:43
10338	9d56cd89-32a5-4013-b2a8-30701ce189b4	9d56cd89-52e1-4173-a3c2-5575a59f15ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 11:50:10
10339	9d56cd89-4da2-4d87-9ec5-647f4913fb33	9d56cd89-52e1-4173-a3c2-5575a59f15ee	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"51.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:50:10
10340	9d56cd89-5168-4955-9237-f6d92ec2dc47	9d56cd89-52e1-4173-a3c2-5575a59f15ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 11:50:10
10341	9d56cd89-51dc-4abf-890b-57e63750d6b8	9d56cd89-52e1-4173-a3c2-5575a59f15ee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:50:10
17418	9d6559b5-ac95-493c-9f05-cf2021f2b5ba	9d6559b5-b140-4fe2-b7da-558f13bc9941	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 17:23:43
17419	9d6559b5-afee-4f74-950d-fd290f5c6da9	9d6559b5-b140-4fe2-b7da-558f13bc9941	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:23:43
10342	9d56cd8a-dc1e-49df-9aba-1682d1dccb66	9d56cd8a-fe8b-4424-95de-d0bba7adb461	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 11:50:11
10343	9d56cd8a-f87e-49aa-977c-cca6167c04f8	9d56cd8a-fe8b-4424-95de-d0bba7adb461	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:50:11
10344	9d56cd8a-f8c8-4bf6-8cb9-6fe2094886ea	9d56cd8a-fe8b-4424-95de-d0bba7adb461	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:50:11
10345	9d56cd8a-fd14-4241-9bd2-9c60c589379f	9d56cd8a-fe8b-4424-95de-d0bba7adb461	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 11:50:11
10346	9d56cd8a-fd86-43ad-8256-3e5fd675c88f	9d56cd8a-fe8b-4424-95de-d0bba7adb461	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:50:11
12624	9d5cec6d-cf8c-4622-86c0-4be8bbeeb709	9d5cec6d-d072-40db-9bda-fc9f1fbe5a2b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:51:31
12427	9d5ce49c-1561-441b-a9b5-e1dfbf53c5f8	9d5ce49c-20d5-4085-af78-158e53ade560	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 12:29:39
12428	9d5ce49c-1edd-4120-9add-82313e89ce96	9d5ce49c-20d5-4085-af78-158e53ade560	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 12:29:39
12429	9d5ce49c-1fbf-49cc-9e38-07c31e7fcb45	9d5ce49c-20d5-4085-af78-158e53ade560	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":500,"response":{"message":"Call to undefined method Illuminate\\\\Database\\\\Query\\\\Builder::all()","exception":"BadMethodCallException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Traits\\\\ForwardsCalls.php","line":67,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":4160,"function":"throwBadMethodCallException","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":69,"function":"__call","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":1702,"function":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\{closure}","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":829,"function":"whereNested","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":68,"function":"where","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getCustomerFilters","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":175,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:29:39
1537	9d50d62b-60d7-4036-b0f8-e32c5dcbb123	9d50d62b-640c-488e-a568-b9180e8b8d76	196697d8cff0a9d6e03dbc1f96e130ef	f	exception	{"class":"BadMethodCallException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Traits\\\\ForwardsCalls.php","line":67,"message":"Call to undefined method App\\\\Models\\\\User::table()","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Traits\\\\ForwardsCalls.php","line":36},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":2335},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":2347},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":32},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"58":"     * Throw a bad method call exception for the given method.","59":"     *","60":"     * @param  string  $method","61":"     * @return void","62":"     *","63":"     * @throws \\\\BadMethodCallException","64":"     *\\/","65":"    protected static function throwBadMethodCallException($method)","66":"    {","67":"        throw new BadMethodCallException(sprintf(","68":"            'Call to undefined method %s::%s()', static::class, $method","69":"        ));","70":"    }","71":"}","72":""},"hostname":"EderCortes","occurrences":1}	2024-10-23 12:39:21
17420	9d6559b5-b042-46df-9957-7b13add2dc96	9d6559b5-b140-4fe2-b7da-558f13bc9941	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":372,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:23:43
11988	9d5ce044-2d19-44b5-9166-a5b0f6fc48d9	9d5ce044-74a4-4e72-a6a2-7e0b63556ee2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:17:31
11989	9d5ce044-718a-41e0-9322-53b092dceb93	9d5ce044-74a4-4e72-a6a2-7e0b63556ee2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 12:17:31
11990	9d5ce044-7313-4de6-b07a-f4eaa0e8daec	9d5ce044-74a4-4e72-a6a2-7e0b63556ee2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":501,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:17:31
11991	9d5ce045-0dcc-4ad4-8bd1-cc995fc08a65	9d5ce045-6268-4a41-be96-7fa0a5ddf286	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 12:17:31
11992	9d5ce045-5a58-4cea-9c50-85259e80308d	9d5ce045-6268-4a41-be96-7fa0a5ddf286	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"164.34","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":177,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 12:17:31
11993	9d5ce045-5ad8-4ac7-a7c9-441a8f37e15c	9d5ce045-6268-4a41-be96-7fa0a5ddf286	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 12:17:31
11994	9d5ce045-60c2-48ef-9a91-3f88970d2107	9d5ce045-6268-4a41-be96-7fa0a5ddf286	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 12:17:31
11995	9d5ce045-611d-4e3f-a1a2-69fb08de9bfc	9d5ce045-6268-4a41-be96-7fa0a5ddf286	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":552,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:17:31
12430	9d5ce49c-9f0e-46c5-9c78-726006f7ee3e	9d5ce49c-a2ee-456c-a406-01aea941a812	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":152,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:29:40
12625	9d5cec7a-fd84-479d-be0a-9d9aab2d8fde	9d5cec7b-00d9-4bd8-b3bc-de3aa955a084	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":154,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:51:40
12426	9d5ce49c-1da0-4d19-82cd-9fbe65d082fb	9d5ce49c-20d5-4085-af78-158e53ade560	196697d8cff0a9d6e03dbc1f96e130ef	f	exception	{"class":"BadMethodCallException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Traits\\\\ForwardsCalls.php","line":67,"message":"Call to undefined method Illuminate\\\\Database\\\\Query\\\\Builder::all()","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":4160},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":69},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":1702},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":829},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":68},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"58":"     * Throw a bad method call exception for the given method.","59":"     *","60":"     * @param  string  $method","61":"     * @return void","62":"     *","63":"     * @throws \\\\BadMethodCallException","64":"     *\\/","65":"    protected static function throwBadMethodCallException($method)","66":"    {","67":"        throw new BadMethodCallException(sprintf(","68":"            'Call to undefined method %s::%s()', static::class, $method","69":"        ));","70":"    }","71":"}","72":""},"hostname":"EderCortes","occurrences":2}	2024-10-29 12:29:39
12431	9d5ce49d-30cc-419d-8ad5-8379d904deb6	9d5ce49d-33fe-4c8c-8507-ffedea0cee81	196697d8cff0a9d6e03dbc1f96e130ef	t	exception	{"class":"BadMethodCallException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Traits\\\\ForwardsCalls.php","line":67,"message":"Call to undefined method Illuminate\\\\Database\\\\Query\\\\Builder::all()","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":4160},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":69},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":1702},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":829},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":68},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"58":"     * Throw a bad method call exception for the given method.","59":"     *","60":"     * @param  string  $method","61":"     * @return void","62":"     *","63":"     * @throws \\\\BadMethodCallException","64":"     *\\/","65":"    protected static function throwBadMethodCallException($method)","66":"    {","67":"        throw new BadMethodCallException(sprintf(","68":"            'Call to undefined method %s::%s()', static::class, $method","69":"        ));","70":"    }","71":"}","72":""},"hostname":"EderCortes","occurrences":3}	2024-10-29 12:29:40
12432	9d5ce49d-25b7-4dcc-9b12-a07b88654a90	9d5ce49d-33fe-4c8c-8507-ffedea0cee81	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 12:29:40
12433	9d5ce49d-3221-4316-a7b1-161baf6ce245	9d5ce49d-33fe-4c8c-8507-ffedea0cee81	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 12:29:40
11890	9d5cd82f-d6a3-4d47-a875-642a37e9c665	9d5cd834-0a80-48f1-972e-328ae02d77a9	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 11:54:56
11891	9d5cd833-bc5c-4c7e-a6ad-db8d5d287a16	9d5cd834-0a80-48f1-972e-328ae02d77a9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 11:54:58
11892	9d5cd833-ddcb-459a-ab0f-9d1533b23f53	9d5cd834-0a80-48f1-972e-328ae02d77a9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":16884,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:54:58
12434	9d5ce49d-32d2-45cb-9633-dc8f05acccce	9d5ce49d-33fe-4c8c-8507-ffedea0cee81	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":500,"response":{"message":"Call to undefined method Illuminate\\\\Database\\\\Query\\\\Builder::all()","exception":"BadMethodCallException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Traits\\\\ForwardsCalls.php","line":67,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":4160,"function":"throwBadMethodCallException","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":69,"function":"__call","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":1702,"function":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\{closure}","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":829,"function":"whereNested","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":68,"function":"where","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getCustomerFilters","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":198,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:29:40
12626	9d5cec7b-b430-4465-9c6e-80e9485ce902	9d5cec7b-fb59-4d10-99b1-16c27c8cde20	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 12:51:40
12627	9d5cec7b-f653-498f-b127-e5ad3b87338c	9d5cec7b-fb59-4d10-99b1-16c27c8cde20	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"153.51","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:51:40
12628	9d5cec7b-f9d7-4484-ab7e-f9b334c23109	9d5cec7b-fb59-4d10-99b1-16c27c8cde20	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 12:51:40
12629	9d5cec7b-fa30-4741-bdae-42c3becc5313	9d5cec7b-fb59-4d10-99b1-16c27c8cde20	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:51:41
17579	9d655ee5-7433-40ba-a586-ac666670f7a5	9d655ee5-9eeb-4352-a46d-7e95ffc6973c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 17:38:13
17580	9d655ee5-9c8b-4f3f-a055-e3794c98d7f1	9d655ee5-9eeb-4352-a46d-7e95ffc6973c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:38:13
11893	9d5cd834-8d9b-4aef-971e-954bd3d63691	9d5cd835-a363-452d-a440-c62ceb3dbb58	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 11:54:58
11894	9d5cd834-cb97-4469-a2b4-88718ad81cb7	9d5cd835-a363-452d-a440-c62ceb3dbb58	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 28\\n                        ","time":"146.78","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"618a8b500e46ad393f7c65ceec660399","hostname":"EderCortes"}	2024-10-29 11:54:58
11895	9d5cd834-d646-4b4e-8a50-24d1a41d9dac	9d5cd835-a363-452d-a440-c62ceb3dbb58	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '28' order by \\"item_loans\\".\\"id\\" asc","time":"2.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 11:54:58
11896	9d5cd834-d688-4580-82ad-94dffcb1b2cc	9d5cd835-a363-452d-a440-c62ceb3dbb58	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 11:54:58
10426	9d56cf98-a9bf-4294-9993-8f65c24f88dc	9d56cf98-c82f-4f3c-8817-6ccc9a024614	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 11:55:56
10427	9d56cf98-c64d-4fe8-b2d2-231c6a302d71	9d56cf98-c82f-4f3c-8817-6ccc9a024614	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-26 11:55:56
10428	9d56cf98-c713-43d2-9ff2-e908cd72e40f	9d56cf98-c82f-4f3c-8817-6ccc9a024614	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":263,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:55:56
11897	9d5cd835-9f76-4d86-9a5e-6adae745e195	9d5cd835-a363-452d-a440-c62ceb3dbb58	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 11:54:59
11898	9d5cd835-a1da-45a0-8cba-d2b47f4d4b24	9d5cd835-a363-452d-a440-c62ceb3dbb58	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/28","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":28,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":600081,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":94,"loans_codigo":28,"itemloans_cuota":"1","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":95,"loans_codigo":28,"itemloans_cuota":"2","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":96,"loans_codigo":28,"itemloans_cuota":"3","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":97,"loans_codigo":28,"itemloans_cuota":"4","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":98,"loans_codigo":28,"itemloans_cuota":"5","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":99,"loans_codigo":28,"itemloans_cuota":"6","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null}]}},"duration":929,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:54:59
12630	9d5cec7c-4eea-4630-a571-e63e0c7fb63c	9d5cec7c-5291-479b-9dab-6ce1e2066e31	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":183,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:51:41
11996	9d5ce045-b74b-4858-8644-380ab6a1f8ad	9d5ce045-d4e0-4f05-91d1-5db68231ce0b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 12:17:32
11997	9d5ce045-cfe6-47ed-9426-89d8e68449d7	9d5ce045-d4e0-4f05-91d1-5db68231ce0b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":177,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 12:17:32
11998	9d5ce045-d03f-423a-973e-ff0db11f8c0a	9d5ce045-d4e0-4f05-91d1-5db68231ce0b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 12:17:32
11999	9d5ce045-d388-4dfa-9347-d535f09f4231	9d5ce045-d4e0-4f05-91d1-5db68231ce0b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 12:17:32
12000	9d5ce045-d3c9-47b8-838c-030098790b25	9d5ce045-d4e0-4f05-91d1-5db68231ce0b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":276,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:17:32
17581	9d655ee5-9d8a-4418-b7d4-3eae4754a991	9d655ee5-9eeb-4352-a46d-7e95ffc6973c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":359,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:38:13
10429	9d56cf99-179b-4e9b-a6fe-e17cac60f554	9d56cf99-3244-41ab-801f-3c811dd1840b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-26 11:55:56
10430	9d56cf99-2df4-4dfa-860c-8ea60e2ac3de	9d56cf99-3244-41ab-801f-3c811dd1840b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"43.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:55:56
10431	9d56cf99-3137-4c9e-ab28-0fc2dc8d947e	9d56cf99-3244-41ab-801f-3c811dd1840b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-26 11:55:56
10432	9d56cf99-317b-4530-8c4d-5683993dbd9e	9d56cf99-3244-41ab-801f-3c811dd1840b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:55:56
11899	9d5cd837-83ac-4031-bcaf-a1aeb2c89a36	9d5cd837-cb97-4f74-aab6-6ece960ad466	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 11:55:00
11900	9d5cd837-c713-4f18-924d-70bbe0da0f5b	9d5cd837-cb97-4f74-aab6-6ece960ad466	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"147.57","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 11:55:00
10504	9d570eae-47ce-46a7-ae8b-464f9227c640	9d570eae-6e95-4b6f-b1fe-e9a282142a6f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 14:52:20
10505	9d570eae-6cc7-4f4d-8581-f719ed9213f4	9d570eae-6e95-4b6f-b1fe-e9a282142a6f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 14:52:20
10506	9d570eae-6d75-424b-9644-e2bac63c25fe	9d570eae-6e95-4b6f-b1fe-e9a282142a6f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-10-26 14:52:20
11901	9d5cd837-c769-4813-80ec-6f746a08afcf	9d5cd837-cb97-4f74-aab6-6ece960ad466	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 11:55:00
11902	9d5cd837-ca7c-4a98-9972-f2e5cd55e1f0	9d5cd837-cb97-4f74-aab6-6ece960ad466	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 11:55:00
11903	9d5cd837-cabf-411e-a28b-3510fe6d074e	9d5cd837-cb97-4f74-aab6-6ece960ad466	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":352,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:55:00
12001	9d5ce046-7e58-4af5-8aef-bebf32d8b185	9d5ce046-c000-4c72-86bf-aebb3bc58e10	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 12:17:32
12002	9d5ce046-b6f3-4eb0-9429-f9f4eb8f18fd	9d5ce046-c000-4c72-86bf-aebb3bc58e10	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"82.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 12:17:32
12003	9d5ce046-b77b-4fc5-af57-c61c0a312587	9d5ce046-c000-4c72-86bf-aebb3bc58e10	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 12:17:32
12004	9d5ce046-bdae-42c0-a9f7-ae374318ea3d	9d5ce046-c000-4c72-86bf-aebb3bc58e10	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 12:17:32
12631	9d5cec7c-b2b8-4d65-a6c2-758ef332e25c	9d5cec7c-cfd4-4910-bd45-9879efa6a37f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 12:51:41
17582	9d655ee6-413c-4b07-9d27-8152b9593c83	9d655ee6-8a7f-4f87-b9cd-9e23d804cafe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:38:14
17583	9d655ee6-8538-438c-93b1-e9b42b752074	9d655ee6-8a7f-4f87-b9cd-9e23d804cafe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"156.45","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":57,"hash":"2cc591e3eaf2792109e07ba331bc077f","hostname":"EderCortes"}	2024-11-02 17:38:14
17584	9d655ee6-8918-4675-a897-f21c1d40a10c	9d655ee6-8a7f-4f87-b9cd-9e23d804cafe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:38:14
17487	9d655bbc-66a6-4b5e-b64f-2ed811606bd1	9d655bbc-a2e6-404b-b5f0-9838b456380f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 17:29:23
7284	9d52dcd9-3491-4b21-aa9d-5777146d31d8	9d52dcd9-59bb-4db8-84a1-f2af9909043e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:49:41
7285	9d52dcd9-57bb-43a7-bbd3-993d46c59180	9d52dcd9-59bb-4db8-84a1-f2af9909043e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:49:41
7286	9d52dcd9-587c-4d60-95fa-a7253340cca5	9d52dcd9-59bb-4db8-84a1-f2af9909043e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":294,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:49:41
17488	9d655bbc-9f97-4600-b6ec-1e9e635665c7	9d655bbc-a2e6-404b-b5f0-9838b456380f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:29:23
17489	9d655bbc-a12e-4a3d-84ce-ca21c957c7c3	9d655bbc-a2e6-404b-b5f0-9838b456380f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":362,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:29:23
17585	9d655ee6-8972-4301-b6c1-0dc0f096c47e	9d655ee6-8a7f-4f87-b9cd-9e23d804cafe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"}]},"duration":536,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:38:14
7287	9d52dcd9-a7cf-4b26-a6ba-d55b1f7f4f54	9d52dcd9-c68f-4346-9cdd-fde7b09f0d95	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:49:41
7288	9d52dcd9-c05e-4ac1-b493-3c5fb7db9486	9d52dcd9-c68f-4346-9cdd-fde7b09f0d95	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:49:41
7289	9d52dcd9-c0ae-4ee9-a428-a760e1812ab0	9d52dcd9-c68f-4346-9cdd-fde7b09f0d95	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:49:41
7290	9d52dcd9-c503-4228-b60e-b817a099c9a7	9d52dcd9-c68f-4346-9cdd-fde7b09f0d95	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 12:49:41
7291	9d52dcd9-c59c-47e1-9193-10074694c774	9d52dcd9-c68f-4346-9cdd-fde7b09f0d95	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:49:41
10433	9d56cf9a-bd44-4414-b5d9-3963570b955c	9d56cf9a-dddd-46c6-9925-d63c53e8013d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-26 11:55:57
10434	9d56cf9a-d8a6-4391-b528-b06d881e21b5	9d56cf9a-dddd-46c6-9925-d63c53e8013d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:55:57
10435	9d56cf9a-d906-4a3f-9831-32f7cf004c6c	9d56cf9a-dddd-46c6-9925-d63c53e8013d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:55:57
10436	9d56cf9a-dc8c-4339-921b-0273a69cdf51	9d56cf9a-dddd-46c6-9925-d63c53e8013d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-26 11:55:57
10437	9d56cf9a-dcdc-4aee-bf26-235b83d00038	9d56cf9a-dddd-46c6-9925-d63c53e8013d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":242,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:55:57
10507	9d570eae-bb0b-4bdb-b21b-bbcf017f16b3	9d570eae-fde4-4fd1-8362-0a8f05b78c8f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 14:52:20
10508	9d570eae-f933-4f1e-815a-08130ce5cefe	9d570eae-fde4-4fd1-8362-0a8f05b78c8f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"146.38","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 14:52:20
10509	9d570eae-fc87-4a72-aca8-40dfd81538de	9d570eae-fde4-4fd1-8362-0a8f05b78c8f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 14:52:20
10510	9d570eae-fce1-431e-8ecb-7f9d6ba8ba09	9d570eae-fde4-4fd1-8362-0a8f05b78c8f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-10-26 14:52:20
12005	9d5ce046-be42-45b6-9d12-8ee3835f3c5f	9d5ce046-c000-4c72-86bf-aebb3bc58e10	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":580,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:17:32
12632	9d5cec7c-caa2-4f14-bd30-c09dc1ee66d2	9d5cec7c-cfd4-4910-bd45-9879efa6a37f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"41.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:51:41
6722	9d52d502-73c7-4f32-8eba-d32d8923e745	9d52d502-9384-4427-9816-7e707e7a49f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:27:45
6723	9d52d502-91ed-468d-ad48-d5a28ce9764d	9d52d502-9384-4427-9816-7e707e7a49f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:27:45
6724	9d52d502-9279-48a8-b9f7-b8b1ccfb1a60	9d52d502-9384-4427-9816-7e707e7a49f6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":279,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:27:45
12633	9d5cec7c-ce7f-4b2e-977a-02823ee44199	9d5cec7c-cfd4-4910-bd45-9879efa6a37f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 12:51:41
12634	9d5cec7c-cec3-448d-b961-e64b09fca6c8	9d5cec7c-cfd4-4910-bd45-9879efa6a37f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:51:41
17490	9d655bbd-6df8-4b9f-ab1c-91065526b9c5	9d655bbd-bcac-47c6-b1d2-815cf69bb6ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:29:23
17491	9d655bbd-b52e-4919-8784-936b67402771	9d655bbd-bcac-47c6-b1d2-815cf69bb6ba	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"164.44","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":46,"hash":"fb4ded687569d92428336ceae5c6ffcd","hostname":"EderCortes"}	2024-11-02 17:29:24
17492	9d655bbd-bb45-458e-af6e-034c14e7982b	9d655bbd-bcac-47c6-b1d2-815cf69bb6ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:29:24
17493	9d655bbd-bbb4-4225-96ef-9cc6095098bf	9d655bbd-bcac-47c6-b1d2-815cf69bb6ba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":668,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:29:24
17586	9d655ee8-d6b2-42ff-9c0b-d74d79745802	9d655ee8-ffcc-4bf5-851b-66b99a96f5b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:38:15
17587	9d655ee8-f817-461a-8a80-5f2a5280c453	9d655ee8-ffcc-4bf5-851b-66b99a96f5b3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"57.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 17:38:15
6725	9d52d502-dc4e-4cf6-9f4f-73aa1d87c74b	9d52d502-f9c9-4e87-9970-3f617d102272	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:27:46
6726	9d52d502-f4ec-4351-ad64-4d1feae7ab1d	9d52d502-f9c9-4e87-9970-3f617d102272	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:27:46
6727	9d52d502-f532-4d31-aef8-a36e22dbc684	9d52d502-f9c9-4e87-9970-3f617d102272	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:27:46
6728	9d52d502-f8a3-415f-b790-ad2276e4165b	9d52d502-f9c9-4e87-9970-3f617d102272	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 12:27:46
6729	9d52d502-f8ed-408c-8fb2-dc0c8c2346f4	9d52d502-f9c9-4e87-9970-3f617d102272	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:27:46
7292	9d52dcda-0f03-4b26-85e5-aaa06fba856a	9d52dcda-2ffa-4c70-a5d0-8f06497ecb88	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 12:49:41
7293	9d52dcda-2986-46d9-a989-f31e8c16ad79	9d52dcda-2ffa-4c70-a5d0-8f06497ecb88	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:49:41
7294	9d52dcda-29fc-4200-8e91-c5c86a065d64	9d52dcda-2ffa-4c70-a5d0-8f06497ecb88	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:49:41
7295	9d52dcda-2e3b-4690-89e0-4880926a0d47	9d52dcda-2ffa-4c70-a5d0-8f06497ecb88	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 12:49:41
7296	9d52dcda-2ea9-403c-b7ce-204b770ceed9	9d52dcda-2ffa-4c70-a5d0-8f06497ecb88	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":255,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:49:41
10511	9d570eb0-04ac-4a64-868b-7f70e839ca21	9d570eb0-2da9-45d5-ab57-741d6ff8d8f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 14:52:21
10512	9d570eb0-235b-440a-bf5d-fc38bdc77e30	9d570eb0-2da9-45d5-ab57-741d6ff8d8f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"52.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 14:52:21
10513	9d570eb0-23cf-4938-a210-66ab4aa36028	9d570eb0-2da9-45d5-ab57-741d6ff8d8f0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 14:52:21
10514	9d570eb0-2b68-4135-bf82-caf8a3daceeb	9d570eb0-2da9-45d5-ab57-741d6ff8d8f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 14:52:21
10515	9d570eb0-2c02-444a-982d-3d87a931f42d	9d570eb0-2da9-45d5-ab57-741d6ff8d8f0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":405,"memory":22,"hostname":"EderCortes"}	2024-10-26 14:52:21
12006	9d5ce047-9da2-4820-b70f-ae6bac0b3dc4	9d5ce047-c891-45de-9be9-5fbcbe38d018	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 12:17:33
17494	9d655bbf-d939-4c98-890a-6fd41236c8ac	9d655bc0-27fb-474a-b4d2-a973155adda4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:29:25
17588	9d655ee8-f881-4561-8734-218f82a91920	9d655ee8-ffcc-4bf5-851b-66b99a96f5b3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 17:38:15
6730	9d52d503-394e-43ce-8b6b-3b6e11b0be42	9d52d503-5684-4055-900f-5411465e8549	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 12:27:46
6731	9d52d503-50f8-4c76-9a37-458c63eb2fac	9d52d503-5684-4055-900f-5411465e8549	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:27:46
6732	9d52d503-5142-400a-bd5a-3611d6262438	9d52d503-5684-4055-900f-5411465e8549	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:27:46
6733	9d52d503-554f-4a43-8ef6-40ba7f21d16a	9d52d503-5684-4055-900f-5411465e8549	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 12:27:46
6734	9d52d503-55a5-4e37-8c49-afeab0985f4f	9d52d503-5684-4055-900f-5411465e8549	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:27:46
7297	9d52dcda-7330-4f19-acf7-70fc5e55f4d1	9d52dcda-920f-42d3-ad60-d168e60e5baa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 12:49:41
6878	9d52d5ef-36c0-4de0-bd0f-77b4f89bd4a7	9d52d5ef-66f0-4cce-8929-b54727da4565	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 12:30:21
6879	9d52d5ef-6522-4f68-9a9b-704fa0a0db78	9d52d5ef-66f0-4cce-8929-b54727da4565	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 12:30:21
6880	9d52d5ef-65e3-42af-8ad7-95f6919fcf76	9d52d5ef-66f0-4cce-8929-b54727da4565	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:30:21
7298	9d52dcda-8ba2-49d0-a005-44872ea052f7	9d52dcda-920f-42d3-ad60-d168e60e5baa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"42.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:49:41
7299	9d52dcda-8bf0-4655-a88f-d3333b7fa001	9d52dcda-920f-42d3-ad60-d168e60e5baa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:49:41
7300	9d52dcda-8d5f-4ec7-b99e-30e7fd24125a	9d52dcda-920f-42d3-ad60-d168e60e5baa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"1.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:49:41
7301	9d52dcda-8d93-4959-8892-2476284a5bc2	9d52dcda-920f-42d3-ad60-d168e60e5baa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:49:41
7302	9d52dcda-90d0-48ae-85a3-436b662dd51f	9d52dcda-920f-42d3-ad60-d168e60e5baa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 12:49:41
7303	9d52dcda-9124-47e0-a0f6-f8973b920b7e	9d52dcda-920f-42d3-ad60-d168e60e5baa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:49:41
12007	9d5ce047-c3ce-492e-83f8-7e658f50f997	9d5ce047-c891-45de-9be9-5fbcbe38d018	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 12:17:33
12008	9d5ce047-c41b-4f0f-a550-2228ce2c77ff	9d5ce047-c891-45de-9be9-5fbcbe38d018	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 12:17:33
12009	9d5ce047-c760-4d45-8c1c-c8e42dbd32dc	9d5ce047-c891-45de-9be9-5fbcbe38d018	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 12:17:33
17495	9d655bc0-1ea2-4b25-8288-0e21c2ae38c9	9d655bc0-27fb-474a-b4d2-a973155adda4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"152.75","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 17:29:25
17496	9d655bc0-1f26-4a87-9874-df9186b9aa90	9d655bc0-27fb-474a-b4d2-a973155adda4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 17:29:25
17497	9d655bc0-25f9-49a8-8e22-9704bdfc7542	9d655bc0-27fb-474a-b4d2-a973155adda4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:29:25
17589	9d655ee8-fe09-47f0-a54e-9e8401b1a31a	9d655ee8-ffcc-4bf5-851b-66b99a96f5b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:38:15
6735	9d52d503-997f-4fbd-b044-f14151cd391e	9d52d503-b6aa-4660-b4cc-edf4c29314b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 12:27:46
6736	9d52d503-b016-4f8e-b4e4-7a438530eef6	9d52d503-b6aa-4660-b4cc-edf4c29314b1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"39.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:27:46
6737	9d52d503-b091-489b-9a9b-9cd59b1afe58	9d52d503-b6aa-4660-b4cc-edf4c29314b1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:27:46
6738	9d52d503-b216-4286-ac45-d3d3cba88610	9d52d503-b6aa-4660-b4cc-edf4c29314b1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"1.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:27:46
6739	9d52d503-b246-4ab0-b47b-d0e68e804757	9d52d503-b6aa-4660-b4cc-edf4c29314b1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:27:46
6740	9d52d503-b547-4589-ad18-132584eae8b2	9d52d503-b6aa-4660-b4cc-edf4c29314b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 12:27:46
6741	9d52d503-b599-4f0d-bb7e-c0e0c702ab4c	9d52d503-b6aa-4660-b4cc-edf4c29314b1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[[{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}],[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]]},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:27:46
6881	9d52d5ef-fd9c-4ce4-8b96-f17e52d0f0e9	9d52d5f0-23fa-4121-9660-65740ce15953	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 12:30:21
6882	9d52d5f0-1e12-4eef-999a-a814d5b121ad	9d52d5f0-23fa-4121-9660-65740ce15953	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:30:21
6883	9d52d5f0-1e5f-4fd6-aa86-14ee323af1c3	9d52d5f0-23fa-4121-9660-65740ce15953	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:30:21
6884	9d52d5f0-2289-415b-90a0-731f6166799d	9d52d5f0-23fa-4121-9660-65740ce15953	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 12:30:21
6885	9d52d5f0-22ec-411a-91a7-6511a5294f28	9d52d5f0-23fa-4121-9660-65740ce15953	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":453,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:30:21
7304	9d52dcdb-fd6e-4c42-9c7f-87063a08d80f	9d52dcdc-2658-4171-b3d6-85cd486789fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 12:49:42
7305	9d52dcdc-20d7-4910-a034-4a66ffdd0c7f	9d52dcdc-2658-4171-b3d6-85cd486789fe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"52.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:49:42
7306	9d52dcdc-2128-4678-b933-7b52638e1602	9d52dcdc-2658-4171-b3d6-85cd486789fe	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:49:42
7307	9d52dcdc-24c2-4072-9503-3804d7abe13d	9d52dcdc-2658-4171-b3d6-85cd486789fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 12:49:42
7308	9d52dcdc-252c-4ec5-910b-4467aaf08abc	9d52dcdc-2658-4171-b3d6-85cd486789fe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":483,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:49:42
6742	9d52d505-26d9-4b2f-a36b-cdd282b367aa	9d52d505-43d7-4b43-a055-17bb5970ba4d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 12:27:47
6743	9d52d505-3f2e-451b-b182-6c013bd331d1	9d52d505-43d7-4b43-a055-17bb5970ba4d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:27:47
6744	9d52d505-3f75-4493-89f8-614c4bcecd0d	9d52d505-43d7-4b43-a055-17bb5970ba4d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:27:47
6745	9d52d505-42aa-42ce-9ab4-eb1dd3ded98e	9d52d505-43d7-4b43-a055-17bb5970ba4d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 12:27:47
6746	9d52d505-42ea-4199-ad2d-2ef40d949a05	9d52d505-43d7-4b43-a055-17bb5970ba4d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":434,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:27:47
6886	9d52d5f0-7019-44f5-a6f3-988658d6e3c3	9d52d5f0-baaf-48c2-b4b6-6e89a1f113c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 12:30:21
6887	9d52d5f0-b4ae-4b56-b0e8-5f728d76305c	9d52d5f0-baaf-48c2-b4b6-6e89a1f113c5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"147.24","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:30:22
6888	9d52d5f0-b500-410f-a21b-f28db601eacc	9d52d5f0-baaf-48c2-b4b6-6e89a1f113c5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:30:22
6889	9d52d5f0-b968-4f2f-af97-b4d66d6c308a	9d52d5f0-baaf-48c2-b4b6-6e89a1f113c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 12:30:22
6890	9d52d5f0-b9d4-4d2e-adb2-ca98d971486d	9d52d5f0-baaf-48c2-b4b6-6e89a1f113c5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":371,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:30:22
12010	9d5ce047-c7a0-4c65-b51d-557b9f0e207c	9d5ce047-c891-45de-9be9-5fbcbe38d018	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":559,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:17:33
6891	9d52d5f1-0b51-4108-abd1-765993b06dc8	9d52d5f1-30dc-4e0a-8da7-4f27133562f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 12:30:22
6892	9d52d5f1-29a5-4168-8ec0-591e58d80905	9d52d5f1-30dc-4e0a-8da7-4f27133562f9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"47.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:30:22
6893	9d52d5f1-29f3-442f-a1cc-8ef9d35564eb	9d52d5f1-30dc-4e0a-8da7-4f27133562f9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:30:22
6894	9d52d5f1-2bb9-46ac-8a93-452fffcdef2a	9d52d5f1-30dc-4e0a-8da7-4f27133562f9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"2.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:30:22
6895	9d52d5f1-2bef-4768-8ecb-7a43bd6d8ed2	9d52d5f1-30dc-4e0a-8da7-4f27133562f9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:30:22
6896	9d52d5f1-2f9d-4656-a124-313791622c8e	9d52d5f1-30dc-4e0a-8da7-4f27133562f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 12:30:22
6897	9d52d5f1-2fed-42ad-8545-e57dbc0b7277	9d52d5f1-30dc-4e0a-8da7-4f27133562f9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":283,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:30:22
12011	9d5ce053-1655-4fe3-9d7c-827f053b9ff0	9d5ce053-1995-4813-bc45-3083b039eee2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":127,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:17:40
17498	9d655bc0-2686-444b-9324-66037624354a	9d655bc0-27fb-474a-b4d2-a973155adda4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":415,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:29:25
8257	9d52e7e8-5306-430c-b3b7-7dd44fefcf6d	9d52e7e8-769b-485b-9330-54f58ba770c0	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 13:20:36
8258	9d52e7e8-74de-43fa-a8ba-e0bebe12b7b4	9d52e7e8-769b-485b-9330-54f58ba770c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:20:36
8259	9d52e7e8-759a-4fd5-a69d-f09c3e364fc7	9d52e7e8-769b-485b-9330-54f58ba770c0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":299,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:20:36
17590	9d655ee8-fe7a-4a51-9315-0dba01cbdcd7	9d655ee8-ffcc-4bf5-851b-66b99a96f5b3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":337,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:38:15
6898	9d52d5f2-e1d2-4bff-bd7c-14bd92d6fa77	9d52d5f3-0ba3-4a12-9dd2-0f23bc3b2868	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 12:30:23
6899	9d52d5f3-0652-4ee4-bb7a-f9fc8249be39	9d52d5f3-0ba3-4a12-9dd2-0f23bc3b2868	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"57.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:30:23
6900	9d52d5f3-06c2-4d1b-96b5-885f4139b83c	9d52d5f3-0ba3-4a12-9dd2-0f23bc3b2868	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:30:23
6901	9d52d5f3-0a3c-462a-b4e2-873e96bf245b	9d52d5f3-0ba3-4a12-9dd2-0f23bc3b2868	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-24 12:30:23
6902	9d52d5f3-0a83-4614-a6aa-2174d5ccca21	9d52d5f3-0ba3-4a12-9dd2-0f23bc3b2868	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":493,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:30:23
8260	9d52e7e8-c163-4247-9ecd-5ba32d3b3b74	9d52e7e8-df5c-4806-b880-8c42fbe25a9d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:20:36
8261	9d52e7e8-d9ae-4fc9-ad21-b2f2f494a0a6	9d52e7e8-df5c-4806-b880-8c42fbe25a9d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:20:36
8262	9d52e7e8-d9fe-458c-9f39-6e7aafbedbb8	9d52e7e8-df5c-4806-b880-8c42fbe25a9d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:20:36
8263	9d52e7e8-de3c-486a-8740-42eecb797fbd	9d52e7e8-df5c-4806-b880-8c42fbe25a9d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:20:36
8264	9d52e7e8-de85-4c62-bf00-f318f14c0d51	9d52e7e8-df5c-4806-b880-8c42fbe25a9d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:20:36
12012	9d5ce053-7a6b-4e55-9e9e-4cb4fa5b1886	9d5ce053-a00a-4f50-9082-ad7aae5584a3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 12:17:41
12013	9d5ce053-9c21-45e6-a8d4-7f21042f1386	9d5ce053-a00a-4f50-9082-ad7aae5584a3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%1004%' or \\"users\\".\\"user_document\\"::text like '%1004%' order by \\"users\\".\\"user_document\\" asc","time":"37.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:17:41
12014	9d5ce053-9ede-4856-97d5-1bbc5c7d2f77	9d5ce053-a00a-4f50-9082-ad7aae5584a3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 12:17:41
12015	9d5ce053-9f1d-4f75-ac4a-f66ac35473ff	9d5ce053-a00a-4f50-9082-ad7aae5584a3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"1004"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":14,"name_customer":"Luis andre  Herrera - 100465545"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:17:41
17591	9d655f07-9390-4476-8f08-a7f3075aeccc	9d655f07-e13a-4b22-b9c6-44006e60c7ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:38:35
8265	9d52e7e9-2201-433b-824e-544e240c9a09	9d52e7e9-4001-4a36-b719-7340fc2334a0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:20:36
8266	9d52e7e9-3ae8-4925-be02-cf9f831a533b	9d52e7e9-4001-4a36-b719-7340fc2334a0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:20:37
8267	9d52e7e9-3b3a-4fc0-b15b-297592f19fa2	9d52e7e9-4001-4a36-b719-7340fc2334a0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:20:37
8268	9d52e7e9-3ec8-4eb9-b47c-b85a5a1ea0c5	9d52e7e9-4001-4a36-b719-7340fc2334a0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:20:37
8269	9d52e7e9-3f11-4794-9cf7-bd0c8b7e7bcd	9d52e7e9-4001-4a36-b719-7340fc2334a0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:20:37
17592	9d655f07-d6a7-4014-a84b-65e8248b0710	9d655f07-e13a-4b22-b9c6-44006e60c7ee	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"153.04","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":292,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 17:38:36
17593	9d655f07-dab3-49f7-a05c-9c4aa8fae46d	9d655f07-e13a-4b22-b9c6-44006e60c7ee	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":321,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 17:38:36
9222	9d52f612-8d2c-4881-94d1-3392f496ed0b	9d52f612-b6dd-4950-852d-b9503d158a04	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 14:00:12
9223	9d52f612-b493-4732-8110-7cbd9d81ecaf	9d52f612-b6dd-4950-852d-b9503d158a04	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 14:00:13
9224	9d52f612-b595-4f87-87be-518541dbb6f8	9d52f612-b6dd-4950-852d-b9503d158a04	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":301,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:00:13
17594	9d655f07-dafc-4673-bd42-82a44267dc66	9d655f07-e13a-4b22-b9c6-44006e60c7ee	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 17:38:36
17595	9d655f07-df28-4866-9a71-67e4f6eba96b	9d655f07-e13a-4b22-b9c6-44006e60c7ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 17:38:36
17596	9d655f07-df87-49bd-a44d-a6e2e9996709	9d655f07-e13a-4b22-b9c6-44006e60c7ee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:34:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"}]}},"duration":433,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:38:36
8270	9d52e7e9-8ad7-473e-8b20-254b06b8a1e6	9d52e7e9-a984-47a5-a043-c566ef39493d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:20:37
8271	9d52e7e9-a26d-428d-99ed-e4378e2643a6	9d52e7e9-a984-47a5-a043-c566ef39493d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc","time":"41.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 13:20:37
8272	9d52e7e9-a2b9-495f-8264-d6e1ac778362	9d52e7e9-a984-47a5-a043-c566ef39493d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:20:37
8273	9d52e7e9-a44d-4e05-85f1-e50b453a5e36	9d52e7e9-a984-47a5-a043-c566ef39493d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6'","time":"1.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 13:20:37
8274	9d52e7e9-a482-4521-94d6-1f29dbbe0979	9d52e7e9-a984-47a5-a043-c566ef39493d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:20:37
8275	9d52e7e9-a841-490c-a339-aeddbe83da81	9d52e7e9-a984-47a5-a043-c566ef39493d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:20:37
8276	9d52e7e9-a89c-4465-a6c1-be0f4a297af0	9d52e7e9-a984-47a5-a043-c566ef39493d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:20:37
9225	9d52f613-2ec6-42cc-b8d2-60bbcc9f6382	9d52f613-56e0-40d0-9035-7723dc050a56	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 14:00:13
9226	9d52f613-4f6e-4153-85bc-9dc0e0e9bb06	9d52f613-56e0-40d0-9035-7723dc050a56	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"52.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 14:00:13
9227	9d52f613-4fc8-43f2-abc6-8343e01b9469	9d52f613-56e0-40d0-9035-7723dc050a56	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 14:00:13
9228	9d52f613-5579-4d25-9dc4-62b829de4875	9d52f613-56e0-40d0-9035-7723dc050a56	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 14:00:13
9229	9d52f613-55c6-4309-9d2e-7dd297aaf64f	9d52f613-56e0-40d0-9035-7723dc050a56	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":374,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:00:13
17597	9d655f0d-8259-4947-8234-dd19140cbd0b	9d655f0d-9f0a-4941-90be-013ca04d75f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 17:38:39
17598	9d655f0d-9a4d-4d5e-8480-f010377a5270	9d655f0d-9f0a-4941-90be-013ca04d75f4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"46.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-02 17:38:39
17599	9d655f0d-9da8-4547-8ce7-fc03aaf619fa	9d655f0d-9f0a-4941-90be-013ca04d75f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 17:38:39
17600	9d655f0d-9e09-4aef-a887-e7153d845a95	9d655f0d-9f0a-4941-90be-013ca04d75f4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":294,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:38:39
17601	9d655f30-01cd-4f98-a14f-71c31b3a97bc	9d655f30-1ee0-40ee-a442-dee4f5387b61	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 17:39:02
7414	9d52dd5e-c705-4b90-a87a-9514c2a89e32	9d52dd5e-f15f-4d55-9eaf-afde9610202c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-24 12:51:08
7415	9d52dd5e-eebc-4209-a06a-76dc93475ce8	9d52dd5e-f15f-4d55-9eaf-afde9610202c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-24 12:51:08
7416	9d52dd5e-f008-470c-b702-052fa2b2393d	9d52dd5e-f15f-4d55-9eaf-afde9610202c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:51:08
17602	9d655f30-18f8-43cf-ac41-ed1a36226f39	9d655f30-1ee0-40ee-a442-dee4f5387b61	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"42.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":57,"hash":"2cc591e3eaf2792109e07ba331bc077f","hostname":"EderCortes"}	2024-11-02 17:39:02
17603	9d655f30-1d65-421c-97f5-301033e3bea1	9d655f30-1ee0-40ee-a442-dee4f5387b61	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 17:39:02
17604	9d655f30-1dd6-4d64-a7fb-7f46cae7ecd3	9d655f30-1ee0-40ee-a442-dee4f5387b61	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"}]},"duration":282,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:39:02
7417	9d52dd5f-4a49-4994-8108-106ba0d970ed	9d52dd5f-713a-482d-8fc2-b6a8623ca1f3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-24 12:51:08
7418	9d52dd5f-69f4-4f9d-87f1-19d6183b6f5c	9d52dd5f-713a-482d-8fc2-b6a8623ca1f3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"53.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:51:08
7419	9d52dd5f-6a7a-4990-8914-4f82742a233c	9d52dd5f-713a-482d-8fc2-b6a8623ca1f3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:51:08
7420	9d52dd5f-6fa8-4dbc-b79e-d711257b10a8	9d52dd5f-713a-482d-8fc2-b6a8623ca1f3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-10-24 12:51:08
7421	9d52dd5f-7011-4582-aa14-a10aa0d89089	9d52dd5f-713a-482d-8fc2-b6a8623ca1f3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":296,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:51:08
8277	9d52e7eb-6a8b-4c67-abcf-62ce9d7aec03	9d52e7eb-88d1-4015-a436-0004a42d31a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:20:38
8278	9d52e7eb-8365-4c99-9771-93a6c8a7fb57	9d52e7eb-88d1-4015-a436-0004a42d31a2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:20:38
8279	9d52e7eb-83b7-41a0-954d-3354a19c8a66	9d52e7eb-88d1-4015-a436-0004a42d31a2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:20:38
8280	9d52e7eb-8791-41cc-8c6a-424d90cad25a	9d52e7eb-88d1-4015-a436-0004a42d31a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:20:38
8281	9d52e7eb-87d9-4fc5-8b27-bc7e3189e9d2	9d52e7eb-88d1-4015-a436-0004a42d31a2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":324,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:20:38
9230	9d52f613-afe2-4f3e-a0c4-bda5d5053b1b	9d52f613-d695-497a-9229-53713d4f8031	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 14:00:13
9231	9d52f613-d03c-486b-a742-55ad86082635	9d52f613-d695-497a-9229-53713d4f8031	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"55.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 14:00:13
9232	9d52f613-d09a-4fcc-b003-801f779e386a	9d52f613-d695-497a-9229-53713d4f8031	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 14:00:13
9233	9d52f613-d531-428f-b617-4aeaa278c722	9d52f613-d695-497a-9229-53713d4f8031	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 14:00:13
9234	9d52f613-d588-4314-a278-568309c581bc	9d52f613-d695-497a-9229-53713d4f8031	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":308,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:00:13
17605	9d655f35-28c1-4d6c-b1c2-f95a34156fb1	9d655f35-45ca-40ee-89f0-92f1b9660ce1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 17:39:05
7422	9d52dd5f-b3ec-4674-b2bc-6bea23c106df	9d52dd5f-d1f7-410f-87b6-018ccffd2fdc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-10-24 12:51:09
7423	9d52dd5f-cd7d-4fbf-b488-2d67b774666e	9d52dd5f-d1f7-410f-87b6-018ccffd2fdc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:51:09
7424	9d52dd5f-cdc4-4e9e-9aec-3ab4043cf721	9d52dd5f-d1f7-410f-87b6-018ccffd2fdc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:51:09
7425	9d52dd5f-d0e1-46d6-8eeb-76834d64341e	9d52dd5f-d1f7-410f-87b6-018ccffd2fdc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-10-24 12:51:09
7426	9d52dd5f-d123-4d7e-b18c-eb5ccf4e3920	9d52dd5f-d1f7-410f-87b6-018ccffd2fdc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:51:09
9235	9d52f614-26d2-4c37-b0f5-e36b0522e39d	9d52f614-70c5-4194-a921-56b5ce0c0341	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 14:00:13
9236	9d52f614-69b1-4ae8-afca-14efdae12efb	9d52f614-70c5-4194-a921-56b5ce0c0341	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"151.95","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-24 14:00:14
9237	9d52f614-6a06-49c4-a6ca-c1bf8bce34f0	9d52f614-70c5-4194-a921-56b5ce0c0341	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 14:00:14
9238	9d52f614-6bc9-41bf-b012-ae9ece6aa88b	9d52f614-70c5-4194-a921-56b5ce0c0341	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"2.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 14:00:14
9239	9d52f614-6bfe-47f9-9510-c6cc883060b5	9d52f614-70c5-4194-a921-56b5ce0c0341	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 14:00:14
9240	9d52f614-6f8a-4bc8-a614-339f3477ecaf	9d52f614-70c5-4194-a921-56b5ce0c0341	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 14:00:14
9241	9d52f614-6fd9-4284-bbd6-5aba6d70a18d	9d52f614-70c5-4194-a921-56b5ce0c0341	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":375,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:00:14
17606	9d655f35-3d98-4ed2-85f6-3b5854980a46	9d655f35-45ca-40ee-89f0-92f1b9660ce1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 58\\n                        ","time":"42.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":292,"hash":"1e43462788b70f0acacfffea2e1dedde","hostname":"EderCortes"}	2024-11-02 17:39:05
17607	9d655f35-40f2-43b8-aafc-659123a8c28f	9d655f35-45ca-40ee-89f0-92f1b9660ce1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '58' order by \\"item_loans\\".\\"id\\" asc","time":"1.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":321,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 17:39:05
17608	9d655f35-4147-4ea1-b270-95298bc2f7b9	9d655f35-45ca-40ee-89f0-92f1b9660ce1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 17:39:05
17609	9d655f35-4497-4da4-99b8-e2662c2f86b8	9d655f35-45ca-40ee-89f0-92f1b9660ce1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 17:39:05
7427	9d52dd60-149f-43e0-bb80-ba0b782f6985	9d52dd60-59eb-43e9-ae34-341c9eb5e9f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-10-24 12:51:09
7428	9d52dd60-53c8-4250-9f7f-09dd4679942e	9d52dd60-59eb-43e9-ae34-341c9eb5e9f6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"142.19","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:51:09
7429	9d52dd60-542e-4c9f-bb97-4b73eedcf0b1	9d52dd60-59eb-43e9-ae34-341c9eb5e9f6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:51:09
7430	9d52dd60-55ce-4a1b-bdf9-65c5b4fed73f	9d52dd60-59eb-43e9-ae34-341c9eb5e9f6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"1.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:51:09
7431	9d52dd60-55fc-42f5-a316-1cabced21470	9d52dd60-59eb-43e9-ae34-341c9eb5e9f6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:51:09
7432	9d52dd60-58d6-4d5d-b081-c4cd4591da91	9d52dd60-59eb-43e9-ae34-341c9eb5e9f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-10-24 12:51:09
7433	9d52dd60-5917-4142-84d3-332071ee2328	9d52dd60-59eb-43e9-ae34-341c9eb5e9f6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:51:09
9242	9d52f616-b6fc-4991-8b77-7f716f3d8528	9d52f617-0405-44e5-b1af-e58bb8d74c22	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 14:00:15
9243	9d52f616-fddb-4ba7-81ae-914505d2b321	9d52f617-0405-44e5-b1af-e58bb8d74c22	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"150.67","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 14:00:15
9244	9d52f616-fe49-42a0-bf6d-1cf027a9bdf8	9d52f617-0405-44e5-b1af-e58bb8d74c22	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 14:00:15
9245	9d52f617-0249-4fd4-b740-c5e3f9ebff39	9d52f617-0405-44e5-b1af-e58bb8d74c22	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 14:00:15
9246	9d52f617-02a0-4aac-9a07-2b6dbec470ba	9d52f617-0405-44e5-b1af-e58bb8d74c22	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":529,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:00:15
17610	9d655f35-44e1-44c3-ab46-6fd6be8bcca4	9d655f35-45ca-40ee-89f0-92f1b9660ce1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/58","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":58,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":167,"loans_codigo":58,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:34.000000Z","updated_at":"2024-10-30T15:54:34.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":168,"loans_codigo":58,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:34.000000Z","updated_at":"2024-10-30T15:54:34.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":169,"loans_codigo":58,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:34.000000Z","updated_at":"2024-10-30T15:54:34.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":170,"loans_codigo":58,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:34.000000Z","updated_at":"2024-10-30T15:54:34.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":171,"loans_codigo":58,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:34.000000Z","updated_at":"2024-10-30T15:54:34.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:39:05
7434	9d52dd61-fd5b-4ae3-8faa-21a2e6fb45cc	9d52dd62-2c41-4c32-acc3-62872f12a969	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-10-24 12:51:10
7435	9d52dd62-22fc-4487-8257-203288b8a35c	9d52dd62-2c41-4c32-acc3-62872f12a969	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"66.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:51:10
7436	9d52dd62-237d-4e54-b8fd-82d551cd6cb8	9d52dd62-2c41-4c32-acc3-62872f12a969	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:51:10
7437	9d52dd62-2a40-479c-8403-5b89a27a9c09	9d52dd62-2c41-4c32-acc3-62872f12a969	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-10-24 12:51:10
7438	9d52dd62-2ac3-4cbe-b0c0-27608e39f218	9d52dd62-2c41-4c32-acc3-62872f12a969	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":421,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:51:10
17611	9d655f56-3be8-4d42-858d-c382e1b9a8f2	9d655f56-3eb9-480a-a922-28ac6495d35c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":148,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:39:27
17797	9d65ae98-526d-4025-bcfa-c545465c480a	9d65ae98-aa99-4117-9f4c-9298ab52bf36	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 21:21:04
17798	9d65ae98-a822-42ec-a4ff-f565ac094934	9d65ae98-aa99-4117-9f4c-9298ab52bf36	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:21:04
17799	9d65ae98-a934-4e5c-98fd-e2c84d04f98e	9d65ae98-aa99-4117-9f4c-9298ab52bf36	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":503,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:21:04
17612	9d655f56-f0b8-42ba-a5ef-c27da8c4b5cd	9d655f57-3d5b-4e11-aa95-a97eb47fe90e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 17:39:27
10586	9d5710db-8ebd-4310-81e3-822091bda76a	9d5710db-b269-439f-bb19-01f2303c00d7	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 14:58:25
10587	9d5710db-b04a-4bb9-94fd-91943eb380e8	9d5710db-b269-439f-bb19-01f2303c00d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 14:58:25
10588	9d5710db-b14d-4254-93e4-b0391f1a2def	9d5710db-b269-439f-bb19-01f2303c00d7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":265,"memory":22,"hostname":"EderCortes"}	2024-10-26 14:58:25
17613	9d655f57-1966-494b-9524-95d1f7881ece	9d655f57-3d5b-4e11-aa95-a97eb47fe90e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 167 limit 1","time":"2.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":380,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-02 17:39:28
17614	9d655f57-19ca-4a6a-b9bb-c4e5ad9f2b25	9d655f57-3d5b-4e11-aa95-a97eb47fe90e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-02 17:39:28
17615	9d655f57-2465-4751-8eb6-788bae3ff4de	9d655f57-3d5b-4e11-aa95-a97eb47fe90e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 58 limit 1","time":"1.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":381,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-02 17:39:28
17616	9d655f57-2495-43a3-b3cb-63126bb7e036	9d655f57-3d5b-4e11-aa95-a97eb47fe90e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-02 17:39:28
17617	9d655f57-313d-43dd-9ba5-f10677291f6c	9d655f57-3d5b-4e11-aa95-a97eb47fe90e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '02-11-2024', \\"itemloans_interes_canelado\\" = '50000', \\"itemloans_cuota_cancelada\\" = '100000', \\"updated_at\\" = '2024-11-02 17:39:28' where \\"id\\" = 167","time":"2.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":402,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-02 17:39:28
17618	9d655f57-3711-40cf-916a-d54dd14a40a0	9d655f57-3d5b-4e11-aa95-a97eb47fe90e	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:167","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-02 17:39:28","item_loans_cuando_pago":"02-11-2024","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},"hostname":"EderCortes"}	2024-11-02 17:39:28
17619	9d655f57-3829-4afd-95a6-bbcc12d360f8	9d655f57-3d5b-4e11-aa95-a97eb47fe90e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_fecha_ultimo_pago\\" = '02-11-2024', \\"updated_at\\" = '2024-11-02 17:39:28' where \\"id\\" = 58","time":"1.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":410,"hash":"cf593c3f0d97e8454c5164f16511623d","hostname":"EderCortes"}	2024-11-02 17:39:28
17620	9d655f57-3871-4356-9bf2-ac6eeef39575	9d655f57-3d5b-4e11-aa95-a97eb47fe90e	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:58","changes":{"updated_at":"2024-11-02 17:39:28","loans_fecha_ultimo_pago":"02-11-2024"},"hostname":"EderCortes"}	2024-11-02 17:39:28
17621	9d655f57-3bee-4947-8a7a-47189871867d	9d655f57-3d5b-4e11-aa95-a97eb47fe90e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:39:28
17800	9d65ae99-1d97-47e0-9472-229a3c32ed4a	9d65ae99-42da-45b7-bb43-b82a3335b98e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:21:05
10589	9d5710dc-0d0e-4d3f-b191-1840ce2c3ea4	9d5710dc-537a-40c4-b9e9-fb30de4e6aa5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 14:58:25
10590	9d5710dc-497b-4bba-980a-cd78347db25e	9d5710dc-537a-40c4-b9e9-fb30de4e6aa5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"141.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 14:58:25
10591	9d5710dc-4d03-46ce-bd99-207888ab8664	9d5710dc-537a-40c4-b9e9-fb30de4e6aa5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '5' order by \\"item_loans\\".\\"id\\" asc","time":"1.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-26 14:58:25
10592	9d5710dc-4d33-4a91-851a-679cf222eb66	9d5710dc-537a-40c4-b9e9-fb30de4e6aa5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-26 14:58:25
10593	9d5710dc-525a-464a-ae1d-374881f21f86	9d5710dc-537a-40c4-b9e9-fb30de4e6aa5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 14:58:25
10594	9d5710dc-52a4-4ac6-80de-2c98419d1daf	9d5710dc-537a-40c4-b9e9-fb30de4e6aa5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":25,"loans_codigo":5,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":26,"loans_codigo":5,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":27,"loans_codigo":5,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":28,"loans_codigo":5,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":29,"loans_codigo":5,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":30,"loans_codigo":5,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null}]}},"duration":381,"memory":22,"hostname":"EderCortes"}	2024-10-26 14:58:25
17622	9d655f57-3c3f-42fb-8b47-cec47674e1d1	9d655f57-3d5b-4e11-aa95-a97eb47fe90e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"157","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000","id":167,"loans_codigo":58,"item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:39:28
17801	9d65ae99-35d0-4131-b607-ce56c75c2bf2	9d65ae99-42da-45b7-bb43-b82a3335b98e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"47.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 21:21:05
17802	9d65ae99-39da-4373-b3c2-03e65425ec4b	9d65ae99-42da-45b7-bb43-b82a3335b98e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:21:05
17803	9d65ae99-3a1d-495d-b34d-6519459b6a16	9d65ae99-42da-45b7-bb43-b82a3335b98e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:21:05
17804	9d65ae99-418a-4275-9a2f-cfebb59654c3	9d65ae99-42da-45b7-bb43-b82a3335b98e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:21:05
10595	9d5710dd-dcee-4f52-9b42-b665580024fd	9d5710dd-fbf3-4038-92c3-8deb06e872de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 14:58:26
10596	9d5710dd-f709-4bf7-bba3-a7a8e89c5324	9d5710dd-fbf3-4038-92c3-8deb06e872de	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 14:58:26
10597	9d5710dd-f76b-4cf6-a158-ce004977dd8c	9d5710dd-fbf3-4038-92c3-8deb06e872de	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 14:58:26
10598	9d5710dd-fab2-4b22-a4bd-543f53e35d8e	9d5710dd-fbf3-4038-92c3-8deb06e872de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 14:58:26
10599	9d5710dd-faf6-4950-9509-b23b2ebb6f2b	9d5710dd-fbf3-4038-92c3-8deb06e872de	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":242,"memory":22,"hostname":"EderCortes"}	2024-10-26 14:58:26
17623	9d655f57-8e85-4ce1-a6bf-c08021950ebf	9d655f57-abe1-441e-bc91-5be78cc569d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:39:28
17624	9d655f57-a399-4e69-8f68-6cec0ed5d706	9d655f57-abe1-441e-bc91-5be78cc569d6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 58\\n                        ","time":"43.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":292,"hash":"1e43462788b70f0acacfffea2e1dedde","hostname":"EderCortes"}	2024-11-02 17:39:28
17625	9d655f57-a72c-4635-a3bc-e17bcf4efacb	9d655f57-abe1-441e-bc91-5be78cc569d6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '58' order by \\"item_loans\\".\\"id\\" asc","time":"2.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":321,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 17:39:28
17626	9d655f57-a760-4c13-8bfb-c0d811d29a8f	9d655f57-abe1-441e-bc91-5be78cc569d6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 17:39:28
17627	9d655f57-aabe-4930-bb11-1f09eec819fc	9d655f57-abe1-441e-bc91-5be78cc569d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:39:28
17628	9d655f57-ab00-445c-ad5e-bfc7b801f09d	9d655f57-abe1-441e-bc91-5be78cc569d6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/58","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":58,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":167,"loans_codigo":58,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:34.000000Z","updated_at":"2024-11-02T22:39:28.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":168,"loans_codigo":58,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:34.000000Z","updated_at":"2024-10-30T15:54:34.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":169,"loans_codigo":58,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:34.000000Z","updated_at":"2024-10-30T15:54:34.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":170,"loans_codigo":58,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:34.000000Z","updated_at":"2024-10-30T15:54:34.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":171,"loans_codigo":58,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:34.000000Z","updated_at":"2024-10-30T15:54:34.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":261,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:39:28
17629	9d655fc9-f4e1-44df-959f-dba7213577d3	9d655fc9-f7d2-4b6f-8d0e-bfd0fb451e76	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":139,"memory":20,"hostname":"EderCortes"}	2024-11-02 17:40:43
17805	9d65ae99-41e5-4164-b303-d3e72637531c	9d65ae99-42da-45b7-bb43-b82a3335b98e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:34:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"}]}},"duration":350,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:21:05
17806	9d65ae9b-4c53-4cd7-b043-2373bc5f88e8	9d65ae9b-70a5-4b23-832c-ce7ceeee5cc3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:21:06
17807	9d65ae9b-68f2-4d9b-ac67-475a471f7e34	9d65ae9b-70a5-4b23-832c-ce7ceeee5cc3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"53.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 21:21:06
17808	9d65ae9b-6978-45ad-841b-cf9d4f0f0a45	9d65ae9b-70a5-4b23-832c-ce7ceeee5cc3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 21:21:06
17809	9d65ae9b-6f1f-4f4e-8c80-5f41651df8bb	9d65ae9b-70a5-4b23-832c-ce7ceeee5cc3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 21:21:06
17810	9d65ae9b-6f7b-4d09-9459-54217dd4fe07	9d65ae9b-70a5-4b23-832c-ce7ceeee5cc3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":248,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:21:06
17637	9d655fca-fa91-4b35-85fe-8ad7f7655caf	9d655fcb-42ac-4c0f-94c5-8efbe1b235c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:40:43
17638	9d655fcb-39c1-4dcb-8e4a-c269bde29de7	9d655fcb-42ac-4c0f-94c5-8efbe1b235c8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 58\\n                        ","time":"148.93","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":292,"hash":"1e43462788b70f0acacfffea2e1dedde","hostname":"EderCortes"}	2024-11-02 17:40:44
17639	9d655fcb-3d63-4d60-8cb8-4e1ea85f2e8c	9d655fcb-42ac-4c0f-94c5-8efbe1b235c8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '58' order by \\"item_loans\\".\\"id\\" asc","time":"2.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":321,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 17:40:44
17640	9d655fcb-3d93-418c-80ec-250396be6ddb	9d655fcb-42ac-4c0f-94c5-8efbe1b235c8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 17:40:44
17641	9d655fcb-415c-47f2-9815-5463e6e02ba6	9d655fcb-42ac-4c0f-94c5-8efbe1b235c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:40:44
17642	9d655fcb-41b7-4518-b574-9e1ae6cb1a3d	9d655fcb-42ac-4c0f-94c5-8efbe1b235c8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/58","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":58,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":167,"loans_codigo":58,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:34.000000Z","updated_at":"2024-11-02T22:39:28.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":168,"loans_codigo":58,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:34.000000Z","updated_at":"2024-10-30T15:54:34.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":169,"loans_codigo":58,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:34.000000Z","updated_at":"2024-10-30T15:54:34.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":170,"loans_codigo":58,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:34.000000Z","updated_at":"2024-10-30T15:54:34.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":171,"loans_codigo":58,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:34.000000Z","updated_at":"2024-10-30T15:54:34.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":372,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:40:44
17940	9d65b427-139d-4153-ae54-581c3ce8449c	9d65b427-356e-4306-9d5a-e2892b5547fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 21:36:37
17941	9d65b427-3380-49dc-a270-a92a808c6aa8	9d65b427-356e-4306-9d5a-e2892b5547fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 21:36:37
17942	9d65b427-3475-4b39-90f6-6ab2b9b07033	9d65b427-356e-4306-9d5a-e2892b5547fe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":274,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:36:37
17643	9d655fdf-7267-46e2-a9f3-388967be901f	9d655fdf-8cbc-4fc1-a929-fbe91a77debf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:40:57
17644	9d655fdf-88c6-4565-ac27-a7ad50bdcf4f	9d655fdf-8cbc-4fc1-a929-fbe91a77debf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"42.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":57,"hash":"2cc591e3eaf2792109e07ba331bc077f","hostname":"EderCortes"}	2024-11-02 17:40:57
17645	9d655fdf-8b78-4201-a19d-a675e12daebc	9d655fdf-8cbc-4fc1-a929-fbe91a77debf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:40:57
17646	9d655fdf-8bca-4bb6-94b8-2469d4263949	9d655fdf-8cbc-4fc1-a929-fbe91a77debf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"7","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"}]},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:40:57
17943	9d65b427-8b8d-4a1a-8970-250ae67dc3d9	9d65b427-ad79-4dd8-899d-d8baac8a07cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 21:36:37
17944	9d65b427-a3e6-4729-8cb8-48a6356436f7	9d65b427-ad79-4dd8-899d-d8baac8a07cf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"47.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"2b11ef88578e3c91c11800e110e490df","hostname":"EderCortes"}	2024-11-02 21:36:37
17945	9d65b427-a78b-4d8f-8911-1f05f2c52d09	9d65b427-ad79-4dd8-899d-d8baac8a07cf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"2.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:36:37
17946	9d65b427-a7c3-436d-9f0a-65488b51beba	9d65b427-ad79-4dd8-899d-d8baac8a07cf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:36:37
17947	9d65b427-ac09-4689-901c-095527b6d33b	9d65b427-ad79-4dd8-899d-d8baac8a07cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 21:36:37
17948	9d65b427-ac65-4c67-a0de-a37d79e2cb43	9d65b427-ad79-4dd8-899d-d8baac8a07cf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":265,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:36:37
17647	9d655fff-55e0-4843-9157-667b01161839	9d655fff-749f-4ad9-8f44-b776a1417ff8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:41:18
17648	9d655fff-6c0f-41fc-b68e-faab6acf4826	9d655fff-749f-4ad9-8f44-b776a1417ff8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 57\\n                        ","time":"43.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":292,"hash":"6660cb51adb047cbd50cb343a59bd34b","hostname":"EderCortes"}	2024-11-02 17:41:18
17649	9d655fff-6f9d-49d1-8bc1-f5bf09d7ced3	9d655fff-749f-4ad9-8f44-b776a1417ff8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '57' order by \\"item_loans\\".\\"id\\" asc","time":"2.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":321,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 17:41:18
17650	9d655fff-6fce-41d7-855e-4a459e39d02f	9d655fff-749f-4ad9-8f44-b776a1417ff8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 17:41:18
13858	9d5d12bc-d61f-405f-8f39-7e39ff6ef863	9d5d12bd-2f08-4094-ad56-d693d6b17ca8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 14:38:38
13859	9d5d12bd-2be2-48d7-8107-269a98382a5b	9d5d12bd-2f08-4094-ad56-d693d6b17ca8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 14:38:39
13860	9d5d12bd-2d40-4ff4-a6e6-ede4a1d165ae	9d5d12bd-2f08-4094-ad56-d693d6b17ca8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":547,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:38:39
17651	9d655fff-7367-431e-8b08-e552e13a4083	9d655fff-749f-4ad9-8f44-b776a1417ff8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 17:41:18
17652	9d655fff-73ac-44c2-8944-2ca6537760ee	9d655fff-749f-4ad9-8f44-b776a1417ff8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/57","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":57,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":162,"loans_codigo":57,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:52:35.000000Z","updated_at":"2024-10-30T15:52:35.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":163,"loans_codigo":57,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:52:35.000000Z","updated_at":"2024-10-30T15:52:35.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":164,"loans_codigo":57,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:52:35.000000Z","updated_at":"2024-10-30T15:52:35.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":165,"loans_codigo":57,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:52:35.000000Z","updated_at":"2024-10-30T15:52:35.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":166,"loans_codigo":57,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:52:35.000000Z","updated_at":"2024-10-30T15:52:35.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":274,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:41:18
17949	9d65b428-e695-4692-8ff9-e43012a61b59	9d65b429-158a-457f-8502-1f0686c263da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 21:36:38
17950	9d65b429-0c62-427c-970f-017fe570b647	9d65b429-158a-457f-8502-1f0686c263da	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"61.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 21:36:38
17951	9d65b429-0ce3-4635-a7f7-6728df9f1c84	9d65b429-158a-457f-8502-1f0686c263da	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 21:36:38
17952	9d65b429-138e-413a-9e54-82210a342a90	9d65b429-158a-457f-8502-1f0686c263da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 21:36:38
17953	9d65b429-1420-479a-beac-a1ed39f08842	9d65b429-158a-457f-8502-1f0686c263da	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":454,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:36:38
17653	9d656006-5ca5-430c-923f-a95defeb6d9f	9d656006-7987-45d4-9bcb-6901e7448b48	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 17:41:22
17654	9d656006-74eb-4183-8f2c-d62029f98e72	9d656006-7987-45d4-9bcb-6901e7448b48	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"45.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":57,"hash":"2cc591e3eaf2792109e07ba331bc077f","hostname":"EderCortes"}	2024-11-02 17:41:22
17655	9d656006-7822-44d8-a9d0-6aaa3971c20d	9d656006-7987-45d4-9bcb-6901e7448b48	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 17:41:22
10671	9d57130b-635c-48a1-adf5-b71343bde4b6	9d57130b-8722-40fc-ab3b-e7b20fce225a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 15:04:32
10672	9d57130b-8451-4cae-b5b3-5ad728f81d96	9d57130b-8722-40fc-ab3b-e7b20fce225a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 15:04:32
10673	9d57130b-85bc-42da-81f2-93a3918505dd	9d57130b-8722-40fc-ab3b-e7b20fce225a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":306,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:04:32
13861	9d5d12bd-cfad-4224-82eb-090d4c4ee4bc	9d5d12be-0b1a-44b9-89ed-f45ccc4bcc75	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 14:38:39
17656	9d656006-787a-4b9b-bd52-607fcef0f941	9d656006-7987-45d4-9bcb-6901e7448b48	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"7","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"}]},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:41:22
13862	9d5d12be-0144-45ff-b63d-b3b3bc26272b	9d5d12be-0b1a-44b9-89ed-f45ccc4bcc75	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"66.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":194,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 14:38:39
13863	9d5d12be-01e2-437e-be23-7808037377aa	9d5d12be-0b1a-44b9-89ed-f45ccc4bcc75	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 14:38:39
13864	9d5d12be-0938-4f42-9da3-241d917e534c	9d5d12be-0b1a-44b9-89ed-f45ccc4bcc75	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 14:38:39
10674	9d57130b-d5e0-40c0-8335-eb84c2dd02ea	9d57130c-1f96-4cc4-8bd1-1ec3815e4811	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 15:04:32
10675	9d57130c-1673-4691-a137-afb77fa3577f	9d57130c-1f96-4cc4-8bd1-1ec3815e4811	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"152.87","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 15:04:32
10676	9d57130c-1a47-44ed-8f4e-835152cf909c	9d57130c-1f96-4cc4-8bd1-1ec3815e4811	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '5' order by \\"item_loans\\".\\"id\\" asc","time":"2.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-26 15:04:32
9404	9d52f7a6-ee47-4b2d-abaf-1f867c44a1a5	9d52f7a7-0fc0-45cf-9f0a-8fd920b67989	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 14:04:37
9405	9d52f7a7-0d70-421b-8086-d2864249a430	9d52f7a7-0fc0-45cf-9f0a-8fd920b67989	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 14:04:37
9406	9d52f7a7-0e7b-4066-bb36-de20e1a525d5	9d52f7a7-0fc0-45cf-9f0a-8fd920b67989	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":289,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:04:37
10677	9d57130c-1a76-41e5-9fca-ea6f835ec23f	9d57130c-1f96-4cc4-8bd1-1ec3815e4811	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-26 15:04:32
10678	9d57130c-1e49-4534-b7ac-e85d1973a2f4	9d57130c-1f96-4cc4-8bd1-1ec3815e4811	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-26 15:04:32
10679	9d57130c-1ea5-4cad-ba9a-849fd277bedf	9d57130c-1f96-4cc4-8bd1-1ec3815e4811	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":25,"loans_codigo":5,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":26,"loans_codigo":5,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":27,"loans_codigo":5,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":28,"loans_codigo":5,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":29,"loans_codigo":5,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":30,"loans_codigo":5,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null}]}},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:04:32
9407	9d52f7a7-5cee-4bf0-bf26-745a6762ac55	9d52f7a7-7cf2-42a4-87ff-a89adf6392f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 14:04:38
9408	9d52f7a7-776e-4631-a879-c9e2a09669e8	9d52f7a7-7cf2-42a4-87ff-a89adf6392f5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 14:04:38
9409	9d52f7a7-77db-41f3-a840-1aa0351a25ce	9d52f7a7-7cf2-42a4-87ff-a89adf6392f5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 14:04:38
9410	9d52f7a7-7bb9-4eeb-b112-6b060ac2f74d	9d52f7a7-7cf2-42a4-87ff-a89adf6392f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 14:04:38
9411	9d52f7a7-7bfb-4f8b-9564-a6adb7b3166d	9d52f7a7-7cf2-42a4-87ff-a89adf6392f5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":248,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:04:38
10680	9d57130d-8779-4041-987b-05a970b3abb6	9d57130d-d46e-4ec8-b703-9f2d5bcae4d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-26 15:04:33
10681	9d57130d-cf06-42da-8ab2-2efc10c21506	9d57130d-d46e-4ec8-b703-9f2d5bcae4d1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"159.52","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 15:04:33
10682	9d57130d-cf5f-4088-965d-b7a604d9f397	9d57130d-d46e-4ec8-b703-9f2d5bcae4d1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 15:04:33
10683	9d57130d-d30a-47ac-b1f7-8883361c034d	9d57130d-d46e-4ec8-b703-9f2d5bcae4d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-26 15:04:33
10684	9d57130d-d34f-4861-8c00-d3744cb18319	9d57130d-d46e-4ec8-b703-9f2d5bcae4d1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":610,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:04:33
13865	9d5d12be-09bb-456c-9835-53bb3a8fbfe8	9d5d12be-0b1a-44b9-89ed-f45ccc4bcc75	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":507,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:38:39
5089	9d513674-485f-48a2-8e93-40367f7d9b44	9d513674-7962-4130-81b5-7666bac21727	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-23 17:08:35
5090	9d513674-7743-426c-af7e-00fdb333c010	9d513674-7962-4130-81b5-7666bac21727	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-23 17:08:35
5091	9d513674-782a-4037-ae57-1c6e915366ce	9d513674-7962-4130-81b5-7666bac21727	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":384,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:35
388	9d4f278c-789e-4416-aafd-a0e086e137e7	9d4f278c-7bec-4a3e-b0f9-29e5dafec093	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":24}	2024-10-22 16:35:14
31118	9d69465d-0397-400b-9070-dc8496a68cf4	9d69465d-078b-44ce-aaa4-3759040429d8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1481}	2024-11-04 16:12:56
13866	9d5d12be-8021-48ea-8668-6642821b0a33	9d5d12be-a896-4974-bbbe-b8465d96c8f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 14:38:39
9412	9d52f7a7-e6fd-4fcd-9498-ee5972bc03b2	9d52f7a8-0ebb-4ff6-ab49-ffcc3e7f9dc6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 14:04:38
9413	9d52f7a8-095a-46f3-9544-d7e8bef0eb7e	9d52f7a8-0ebb-4ff6-ab49-ffcc3e7f9dc6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 14:04:38
9414	9d52f7a8-09bd-45ce-a108-819485dafb61	9d52f7a8-0ebb-4ff6-ab49-ffcc3e7f9dc6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 14:04:38
9415	9d52f7a8-0d7c-4e8b-8f3a-57723515a275	9d52f7a8-0ebb-4ff6-ab49-ffcc3e7f9dc6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 14:04:38
7617	9d52df80-79f8-4667-a49f-0cfca2482fea	9d52df80-99da-42aa-b22d-3c81fa616a2e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-10-24 12:57:06
7618	9d52df80-9808-4cbb-9b87-761e976fe5d3	9d52df80-99da-42aa-b22d-3c81fa616a2e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-10-24 12:57:06
7619	9d52df80-98c3-4726-8af1-decd42ae8d3c	9d52df80-99da-42aa-b22d-3c81fa616a2e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":269,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:57:06
9416	9d52f7a8-0dd7-4bb3-b963-a9bbdfea4585	9d52f7a8-0ebb-4ff6-ab49-ffcc3e7f9dc6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":358,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:04:38
10685	9d571fb7-0546-4c9a-969a-aaddc92853a1	9d571fb7-ad1b-4032-bb62-a13966a8c504	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 15:39:58
10686	9d571fb7-a4e5-4c16-9ded-29c9716b91e2	9d571fb7-ad1b-4032-bb62-a13966a8c504	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"41.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-26 15:39:58
10687	9d571fb7-a54c-4f2f-b148-3f943b70a1a2	9d571fb7-ad1b-4032-bb62-a13966a8c504	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-10-26 15:39:58
10688	9d571fb7-aaf5-4a3f-9801-650a08d4a71d	9d571fb7-ad1b-4032-bb62-a13966a8c504	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 15:39:58
10689	9d571fb7-ab50-4c6e-9974-9ae07c10b35f	9d571fb7-ad1b-4032-bb62-a13966a8c504	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":734,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:39:58
13867	9d5d12be-a34a-4e79-aede-b53011e012ae	9d5d12be-a896-4974-bbbe-b8465d96c8f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":194,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 14:38:40
13868	9d5d12be-a399-4aa1-8b24-ab4e310acc0b	9d5d12be-a896-4974-bbbe-b8465d96c8f0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 14:38:40
13869	9d5d12be-a754-4957-9f90-51f3a9ecb1a9	9d5d12be-a896-4974-bbbe-b8465d96c8f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 14:38:40
13870	9d5d12be-a7b6-4dca-9b83-3bd0db58f756	9d5d12be-a896-4974-bbbe-b8465d96c8f0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":387,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:38:40
7620	9d52df80-ecbb-4020-b2ad-206370e6e8df	9d52df81-0bd7-49b5-b452-6294280bb6b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-10-24 12:57:06
7621	9d52df81-0638-4e9c-9321-5857f5791655	9d52df81-0bd7-49b5-b452-6294280bb6b4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:57:06
7622	9d52df81-069d-493d-acf7-6c0857f8c2a7	9d52df81-0bd7-49b5-b452-6294280bb6b4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:57:06
7623	9d52df81-0a89-4af7-ada9-8537865868f1	9d52df81-0bd7-49b5-b452-6294280bb6b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-10-24 12:57:06
7624	9d52df81-0ad1-49fd-b160-326c70dc5eee	9d52df81-0bd7-49b5-b452-6294280bb6b4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":263,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:57:06
9417	9d52f7a8-59ad-42d1-a21e-f29198eeb456	9d52f7a8-a2da-45a9-9ed4-baff634dc9f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 14:04:38
9418	9d52f7a8-9b22-4f99-86b5-2663685fe9f5	9d52f7a8-a2da-45a9-9ed4-baff634dc9f9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"145.53","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-24 14:04:39
9419	9d52f7a8-9b6f-495f-b364-aaf34845f887	9d52f7a8-a2da-45a9-9ed4-baff634dc9f9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 14:04:39
9420	9d52f7a8-9d5d-4cb1-bb2b-bfaee09a7049	9d52f7a8-a2da-45a9-9ed4-baff634dc9f9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"2.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 14:04:39
9421	9d52f7a8-9d92-439f-867a-f20cdee66617	9d52f7a8-a2da-45a9-9ed4-baff634dc9f9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 14:04:39
9422	9d52f7a8-a11e-44b5-a3df-c495a41a6765	9d52f7a8-a2da-45a9-9ed4-baff634dc9f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 14:04:39
9423	9d52f7a8-a169-45b1-b5c5-ca0a0cbed490	9d52f7a8-a2da-45a9-9ed4-baff634dc9f9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:04:39
10690	9d571fbb-d390-448a-9324-39b84021a1ac	9d571fbb-ec7a-4119-911d-735271dfc4ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 15:40:01
10691	9d571fbb-e87b-49b8-8e34-245bbf5c0fbd	9d571fbb-ec7a-4119-911d-735271dfc4ac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"42.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-26 15:40:01
10692	9d571fbb-eafd-495e-a281-cdc5f4b22e34	9d571fbb-ec7a-4119-911d-735271dfc4ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 15:40:01
10693	9d571fbb-eb41-4208-85bd-53a79be6f7f9	9d571fbb-ec7a-4119-911d-735271dfc4ac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":404,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:40:01
13871	9d5d12bf-39f9-45fa-ba6e-d4032bbb65b6	9d5d12bf-787d-4138-9ca0-f9aee491d910	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 14:38:40
24159	9d68a8e5-e0b6-49aa-ad89-f5e89d0e2297	9d68a8e6-2a15-41cb-abec-b85d9e807508	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 08:52:37
7625	9d52df81-53e7-4b47-8628-52d33e9874e4	9d52df81-9a53-4e88-b673-c1ed5183be6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-10-24 12:57:06
7626	9d52df81-94c2-492e-94fe-fa00235b3abb	9d52df81-9a53-4e88-b673-c1ed5183be6b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"141.92","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:57:06
7627	9d52df81-9519-4b52-bcb9-37e9768cd377	9d52df81-9a53-4e88-b673-c1ed5183be6b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:57:06
7628	9d52df81-993e-456a-a514-e4ae96ea53c5	9d52df81-9a53-4e88-b673-c1ed5183be6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-10-24 12:57:06
7034	9d52da96-c987-479c-a296-6e7c58e302d3	9d52da97-2075-43fd-9e0b-8543c1a61276	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 12:43:21
7035	9d52da97-1c6c-4fd0-adb3-5708bb7d6dc0	9d52da97-2075-43fd-9e0b-8543c1a61276	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:43:22
7036	9d52da97-1e2c-47f3-912c-94f0d9359490	9d52da97-2075-43fd-9e0b-8543c1a61276	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1082,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:43:22
7629	9d52df81-9981-4369-b10f-11547ffe2471	9d52df81-9a53-4e88-b673-c1ed5183be6b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":350,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:57:06
9424	9d52f7aa-e5f1-49db-baa1-a348a74f5d19	9d52f7ab-1336-444f-85d3-48bae15515cb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 14:04:40
9425	9d52f7ab-0a59-4131-bed8-0bd1a1a3a298	9d52f7ab-1336-444f-85d3-48bae15515cb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"63.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 14:04:40
9426	9d52f7ab-0acf-402f-9598-8198d32bc88b	9d52f7ab-1336-444f-85d3-48bae15515cb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 14:04:40
9427	9d52f7ab-1176-4d82-b595-99ae7ab15e2b	9d52f7ab-1336-444f-85d3-48bae15515cb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 14:04:40
9428	9d52f7ab-11eb-49c3-ac25-d7b3862416a5	9d52f7ab-1336-444f-85d3-48bae15515cb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":519,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:04:40
10694	9d571fd2-f746-488a-a58a-8cb1b9256d46	9d571fd3-1113-40ed-9f48-ba576bea4961	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 15:40:16
10695	9d571fd3-0d01-4700-9f18-8eb042ee58fb	9d571fd3-1113-40ed-9f48-ba576bea4961	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"43.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-26 15:40:16
10696	9d571fd3-0fa9-453b-bb76-a44fbe8f3f16	9d571fd3-1113-40ed-9f48-ba576bea4961	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 15:40:16
13872	9d5d12bf-6dc1-433f-a488-79b243d81bba	9d5d12bf-787d-4138-9ca0-f9aee491d910	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"87.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 14:38:40
7037	9d52da97-bfc3-4135-9775-0dcedb0bc78c	9d52da97-e9dd-429e-9eb2-93e8d0875838	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:43:22
7038	9d52da97-dff9-46ac-847c-9d01eb7acb18	9d52da97-e9dd-429e-9eb2-93e8d0875838	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"52.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:43:22
7039	9d52da97-e04f-4146-8d7d-fe38be3a328e	9d52da97-e9dd-429e-9eb2-93e8d0875838	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:43:22
7040	9d52da97-e8a6-462e-846e-c91b0c1d26a1	9d52da97-e9dd-429e-9eb2-93e8d0875838	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:43:22
7041	9d52da97-e8e6-46d6-b488-c8eda542c2e2	9d52da97-e9dd-429e-9eb2-93e8d0875838	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:43:22
7630	9d52df81-e23a-47b7-b4e1-5840c6c19c83	9d52df82-29f2-44a3-ac53-e06f90844999	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-10-24 12:57:07
7631	9d52df82-23a8-4492-b5af-d5671c3d30a0	9d52df82-29f2-44a3-ac53-e06f90844999	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"149.30","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:57:07
7632	9d52df82-23f3-4023-bed4-465f969e6ff9	9d52df82-29f2-44a3-ac53-e06f90844999	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:57:07
7633	9d52df82-25a2-41d1-b0ec-019cd1b9698d	9d52df82-29f2-44a3-ac53-e06f90844999	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"2.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:57:07
7634	9d52df82-25dd-427f-82bb-4d82e59bbca5	9d52df82-29f2-44a3-ac53-e06f90844999	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:57:07
7635	9d52df82-28d1-4eba-ad5a-5d9367a6fe82	9d52df82-29f2-44a3-ac53-e06f90844999	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-10-24 12:57:07
7636	9d52df82-2914-423f-b6e0-dc6712cfc743	9d52df82-29f2-44a3-ac53-e06f90844999	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:57:07
10697	9d571fd3-1013-4f7f-9304-e8abdc14a93a	9d571fd3-1113-40ed-9f48-ba576bea4961	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":215,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:40:16
13873	9d5d12bf-6e49-4471-9470-15eaa93e3fb0	9d5d12bf-787d-4138-9ca0-f9aee491d910	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 14:38:40
13874	9d5d12bf-764d-4b14-ab49-91f1b416e07b	9d5d12bf-787d-4138-9ca0-f9aee491d910	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 14:38:40
13875	9d5d12bf-76ea-4c58-be13-67817d4e2487	9d5d12bf-787d-4138-9ca0-f9aee491d910	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":510,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:38:40
24165	9d68a8e8-3c4d-482b-8a8c-cb9af03088e4	9d68a8e8-8ce6-4832-834c-cdeed4e4c158	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 08:52:39
7042	9d52da98-7ee7-4c3c-8513-dba6aea52820	9d52da98-a6bf-4845-b9aa-208808e2eace	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:43:23
7043	9d52da98-a16a-47a7-b1c9-6e780ece9768	9d52da98-a6bf-4845-b9aa-208808e2eace	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:43:23
7044	9d52da98-a1f8-427d-8df7-054deefd877e	9d52da98-a6bf-4845-b9aa-208808e2eace	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:43:23
7045	9d52da98-a5a2-4059-8f1c-163b419a43a9	9d52da98-a6bf-4845-b9aa-208808e2eace	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:43:23
7046	9d52da98-a5e8-4ce3-a164-3dcc10e610f1	9d52da98-a6bf-4845-b9aa-208808e2eace	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":468,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:43:23
7637	9d52df83-b443-4be5-bf0e-0f616eba7f0f	9d52df84-0a20-4255-8e19-cf26bbab424a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-10-24 12:57:08
7638	9d52df84-012d-4d97-a961-178f0e9fb814	9d52df84-0a20-4255-8e19-cf26bbab424a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"163.75","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:57:08
7639	9d52df84-01ac-49d5-a678-d880ced428c5	9d52df84-0a20-4255-8e19-cf26bbab424a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:57:08
7640	9d52df84-0842-4c0b-aa3a-c421851d8c57	9d52df84-0a20-4255-8e19-cf26bbab424a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":29,"hostname":"EderCortes"}	2024-10-24 12:57:08
7641	9d52df84-08c0-44cf-a331-fc1e36766ecd	9d52df84-0a20-4255-8e19-cf26bbab424a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":455,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:57:08
13876	9d5d12c0-0ffb-4e00-b96f-e44c3c496fc6	9d5d12c0-4374-4af4-9fda-971722c55502	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 14:38:40
13877	9d5d12c0-39f9-4dfa-8700-a20a4ae4d412	9d5d12c0-4374-4af4-9fda-971722c55502	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"67.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 14:38:41
13878	9d5d12c0-3aad-45d7-976d-33bb88395b59	9d5d12c0-4374-4af4-9fda-971722c55502	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 14:38:41
13879	9d5d12c0-4169-400a-b882-56a20e62254f	9d5d12c0-4374-4af4-9fda-971722c55502	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 14:38:41
13880	9d5d12c0-41d4-4fbb-ae35-218af59e100b	9d5d12c0-4374-4af4-9fda-971722c55502	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":494,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:38:41
7047	9d52da99-162d-4bd8-b203-64545f0b5a92	9d52da99-4d1c-4313-9c0c-2c51ca4987eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:43:23
7048	9d52da99-3e08-4040-b07b-56d163455088	9d52da99-4d1c-4313-9c0c-2c51ca4987eb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"64.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:43:23
7049	9d52da99-3e9a-44ad-8db0-ae12b910ec04	9d52da99-4d1c-4313-9c0c-2c51ca4987eb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:43:23
7050	9d52da99-45c8-4fee-81ec-38487faa3b6c	9d52da99-4d1c-4313-9c0c-2c51ca4987eb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"3.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:43:23
7051	9d52da99-461e-49c0-886c-6fb56c7812a3	9d52da99-4d1c-4313-9c0c-2c51ca4987eb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:43:23
7052	9d52da99-4b30-4415-8691-ef6020a1b6d8	9d52da99-4d1c-4313-9c0c-2c51ca4987eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:43:23
7053	9d52da99-4bba-4261-99c3-f1fa8c3e4380	9d52da99-4d1c-4313-9c0c-2c51ca4987eb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":412,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:43:23
14063	9d5d153f-10bd-47d7-a69c-cbcd348bb4d3	9d5d153f-5f08-4a50-bd1e-490bf55d97cc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 14:45:39
14064	9d5d153f-5a9d-4867-940a-44ea24885eeb	9d5d153f-5f08-4a50-bd1e-490bf55d97cc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 14:45:39
14065	9d5d153f-5cb7-40aa-9fe7-249b73abe40c	9d5d153f-5f08-4a50-bd1e-490bf55d97cc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":849,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:45:39
24166	9d68a8e8-862f-4122-b882-1ee640efe9cb	9d68a8e8-8ce6-4832-834c-cdeed4e4c158	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"163.91","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 08:52:39
24167	9d68a8e8-8695-47cc-a2e8-13e973b42b3b	9d68a8e8-8ce6-4832-834c-cdeed4e4c158	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 08:52:39
24168	9d68a8e8-8b78-45c4-a692-f281f20b6a50	9d68a8e8-8ce6-4832-834c-cdeed4e4c158	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 08:52:39
24169	9d68a8e8-8bcf-45d4-8222-4b1ecd0cdbe4	9d68a8e8-8ce6-4832-834c-cdeed4e4c158	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":490,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:52:39
14066	9d5d1540-2c97-48f7-ac4a-5f9cbb178f95	9d5d1540-5b9b-463d-8c13-6a69fa14519f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 14:45:40
12894	9d5cee09-9af6-45cb-91c9-8b3af65aeb35	9d5cee09-ed9f-404f-b872-00afad188dc2	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 12:56:01
7747	9d52e07e-6c14-4c32-bdbe-dd4dd0d970c2	9d52e07e-89cb-40ea-9d5e-5a650aec536c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 12:59:52
7748	9d52e07e-8845-4928-889e-accee082c71b	9d52e07e-89cb-40ea-9d5e-5a650aec536c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 12:59:52
7749	9d52e07e-88d2-4b19-ace5-74ddac080327	9d52e07e-89cb-40ea-9d5e-5a650aec536c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:59:52
12895	9d5cee09-eb8d-4f8d-9498-f2ec69a6435b	9d5cee09-ed9f-404f-b872-00afad188dc2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:56:01
12896	9d5cee09-ec75-42c0-bef0-b677d7f2ae91	9d5cee09-ed9f-404f-b872-00afad188dc2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":414,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:56:01
14067	9d5d1540-556a-428c-ba41-b7152cdd4174	9d5d1540-5b9b-463d-8c13-6a69fa14519f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"56.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 14:45:40
14068	9d5d1540-55c2-456e-889e-c7da092ea557	9d5d1540-5b9b-463d-8c13-6a69fa14519f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 14:45:40
14069	9d5d1540-5a15-4a38-808c-344027dded04	9d5d1540-5b9b-463d-8c13-6a69fa14519f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 14:45:40
14070	9d5d1540-5a83-4303-9436-7b26618cbd8d	9d5d1540-5b9b-463d-8c13-6a69fa14519f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":595,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:45:40
7750	9d52e07e-d2f2-4b29-a166-352e58ca3ef0	9d52e07e-f307-487e-8fbc-4382ee752fb4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 12:59:52
7751	9d52e07e-eb82-4c4b-95df-0aae34ea70f6	9d52e07e-f307-487e-8fbc-4382ee752fb4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:59:52
7752	9d52e07e-ec01-4e86-b4eb-6ccec645ef0e	9d52e07e-f307-487e-8fbc-4382ee752fb4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:59:52
7753	9d52e07e-f144-4a20-8375-7c3bea2ea16e	9d52e07e-f307-487e-8fbc-4382ee752fb4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 12:59:52
7754	9d52e07e-f19a-4c06-b5fe-82abdc1100a7	9d52e07e-f307-487e-8fbc-4382ee752fb4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:59:52
12897	9d5cee0a-4736-4a0c-8371-aafdfaf3a2d9	9d5cee0a-8b59-43c4-a458-011e848eb9b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:56:02
12898	9d5cee0a-8331-4436-909e-2078499cb0c4	9d5cee0a-8b59-43c4-a458-011e848eb9b1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"140.86","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-29 12:56:02
12899	9d5cee0a-8a28-4b3c-a51e-48eff19d8ea3	9d5cee0a-8b59-43c4-a458-011e848eb9b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:56:02
12900	9d5cee0a-8a7e-4fc7-9a5a-29bf80cd7b57	9d5cee0a-8b59-43c4-a458-011e848eb9b1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":367,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:56:02
14071	9d5d1540-a992-4e61-8a0d-68176a78f573	9d5d1540-c581-4a62-9238-9a9f8d393182	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 14:45:40
14072	9d5d1540-c164-4907-af50-1872ed6d0cd0	9d5d1540-c581-4a62-9238-9a9f8d393182	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"43.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-29 14:45:40
14073	9d5d1540-c428-4510-9ede-235a4f0a0904	9d5d1540-c581-4a62-9238-9a9f8d393182	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 14:45:40
14074	9d5d1540-c477-4d28-970f-d4507858dcf8	9d5d1540-c581-4a62-9238-9a9f8d393182	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":257,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:45:40
7755	9d52e07f-389a-4fc8-a30b-4d56c00f3ca5	9d52e07f-8207-4c54-8db6-5215f5d4b4ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 12:59:53
7756	9d52e07f-7cc0-45f7-a4f3-234e2c32e4c2	9d52e07f-8207-4c54-8db6-5215f5d4b4ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"148.04","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:59:53
7757	9d52e07f-7d0f-4cbc-a7b9-4550b385eb04	9d52e07f-8207-4c54-8db6-5215f5d4b4ca	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:59:53
7758	9d52e07f-80e5-4dc0-836b-3ee7a40aa17f	9d52e07f-8207-4c54-8db6-5215f5d4b4ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 12:59:53
7759	9d52e07f-8140-4e72-8daa-cad1eca042e7	9d52e07f-8207-4c54-8db6-5215f5d4b4ca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":344,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:59:53
12901	9d5cee0c-8af2-4b4e-9166-6b36d1533d55	9d5cee0c-d1e0-4fee-b55f-514fbd6855ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:56:03
12902	9d5cee0c-cc56-4c0d-b152-b3e3f7815a41	9d5cee0c-d1e0-4fee-b55f-514fbd6855ac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"145.76","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 12:56:03
12903	9d5cee0c-cc9f-4044-9d1f-a6f6e5d0bfd5	9d5cee0c-d1e0-4fee-b55f-514fbd6855ac	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 12:56:03
12904	9d5cee0c-d07b-4f2d-9419-17573adee95f	9d5cee0c-d1e0-4fee-b55f-514fbd6855ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 12:56:03
12905	9d5cee0c-d0c2-4a90-8a8a-b78a90f38ce4	9d5cee0c-d1e0-4fee-b55f-514fbd6855ac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":352,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:56:03
14075	9d5d1542-aa74-41d7-a749-f7807e533322	9d5d1542-d275-4feb-a25f-1c9acf6b1b55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 14:45:42
14076	9d5d1542-cc43-4b2e-86cc-553a4a42dfe3	9d5d1542-d275-4feb-a25f-1c9acf6b1b55	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"52.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 14:45:42
14077	9d5d1542-ccbb-4621-8341-7efe1a2e0da4	9d5d1542-d275-4feb-a25f-1c9acf6b1b55	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 14:45:42
14078	9d5d1542-d0e3-4ae7-a93c-13ae27e3b9ed	9d5d1542-d275-4feb-a25f-1c9acf6b1b55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 14:45:42
14079	9d5d1542-d139-4d2f-bc6c-b4ee69a65446	9d5d1542-d275-4feb-a25f-1c9acf6b1b55	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":435,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:45:42
7760	9d52e07f-c82a-41d5-98b0-176e5eacf30f	9d52e080-110d-4978-8f00-9b93f479652b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 12:59:53
7761	9d52e080-0aef-4e86-918f-2e70ad212621	9d52e080-110d-4978-8f00-9b93f479652b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"151.36","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:59:53
7762	9d52e080-0b37-4310-8ae1-259e0599d639	9d52e080-110d-4978-8f00-9b93f479652b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:59:53
7763	9d52e080-0c90-4dab-b826-20d73b683b2d	9d52e080-110d-4978-8f00-9b93f479652b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"1.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:59:53
7764	9d52e080-0cbf-4050-8ed8-d11ed7e64ff7	9d52e080-110d-4978-8f00-9b93f479652b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:59:53
7765	9d52e080-0fcc-4bb2-81bf-849f77011aa7	9d52e080-110d-4978-8f00-9b93f479652b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 12:59:53
7766	9d52e080-1012-4cc4-b509-8b5663a79b2f	9d52e080-110d-4978-8f00-9b93f479652b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":353,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:59:53
14080	9d5d1545-f9e2-48c1-8370-2928126b037e	9d5d1545-fcdc-4972-a7ea-0e23dec0ed40	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":138,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:45:44
7767	9d52e081-d028-4014-b293-ed734bc16d14	9d52e081-eea0-44c9-a911-9882406e1294	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 12:59:54
7768	9d52e081-e94c-473b-aa73-28deabfcfa25	9d52e081-eea0-44c9-a911-9882406e1294	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:59:54
7769	9d52e081-e995-4166-828f-53e36e66d312	9d52e081-eea0-44c9-a911-9882406e1294	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:59:54
7770	9d52e081-ed52-470f-95a3-c23c78dcbb12	9d52e081-eea0-44c9-a911-9882406e1294	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-24 12:59:54
7771	9d52e081-ed98-43cc-ba71-060c51d9158a	9d52e081-eea0-44c9-a911-9882406e1294	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":374,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:59:54
14081	9d5d1546-b135-43ff-9804-60d65d2539ab	9d5d1546-cb3d-4511-881a-9a37f13d57cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 14:45:44
14082	9d5d1546-c717-4316-b945-3435368ae360	9d5d1546-cb3d-4511-881a-9a37f13d57cf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ma%' or \\"users\\".\\"user_document\\"::text like '%Ma%') order by \\"users\\".\\"user_document\\" asc","time":"39.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 14:45:44
14083	9d5d1546-c9f3-47df-8b83-705a98c68491	9d5d1546-cb3d-4511-881a-9a37f13d57cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 14:45:44
14084	9d5d1546-ca34-4fb4-affa-fa0e5d078bf3	9d5d1546-cb3d-4511-881a-9a37f13d57cf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ma"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":213,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:45:44
25002	9d68befd-6e7d-473e-89b3-b3be21659ece	9d68befd-e425-437a-87b0-58d1f1b00f3e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 09:54:24
25003	9d68befd-dfd2-433f-ae67-605125369051	9d68befd-e425-437a-87b0-58d1f1b00f3e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 09:54:24
25004	9d68befd-e19e-47a9-9989-5760fb7bea2f	9d68befd-e425-437a-87b0-58d1f1b00f3e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":736,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:54:24
10774	9d572102-e923-4020-82c2-1b8f954ea158	9d572103-31b7-47cb-952c-1295fb77c86c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 15:43:35
10775	9d572103-3038-41ce-ac7c-a9c48661ec38	9d572103-31b7-47cb-952c-1295fb77c86c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-26 15:43:35
10776	9d572103-30cd-4ccd-a0e0-c6a9159e1208	9d572103-31b7-47cb-952c-1295fb77c86c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":368,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:43:35
10777	9d572103-7935-41f7-9bb5-0e3d6777dc4d	9d572103-9834-4c8c-9d92-3f8d27f05349	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-26 15:43:35
10778	9d572103-8f69-4213-962b-621640937e4b	9d572103-9834-4c8c-9d92-3f8d27f05349	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"41.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 15:43:35
10779	9d572103-9324-4067-8855-569e42e7af24	9d572103-9834-4c8c-9d92-3f8d27f05349	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '5' order by \\"item_loans\\".\\"id\\" asc","time":"2.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-26 15:43:35
10780	9d572103-9355-418b-978f-96b4c304847f	9d572103-9834-4c8c-9d92-3f8d27f05349	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-26 15:43:35
10781	9d572103-9737-4394-be85-748eae28b6a6	9d572103-9834-4c8c-9d92-3f8d27f05349	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-26 15:43:35
10782	9d572103-977a-4ca2-bd6a-0bfacd153f9a	9d572103-9834-4c8c-9d92-3f8d27f05349	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":25,"loans_codigo":5,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":26,"loans_codigo":5,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":27,"loans_codigo":5,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":28,"loans_codigo":5,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":29,"loans_codigo":5,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":30,"loans_codigo":5,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null}]}},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:43:35
14085	9d5d1547-5d34-41ac-ad30-f83889a7e773	9d5d1547-6032-4d0d-ad3f-bddc83358a07	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":139,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:45:45
25006	9d68beff-13f9-44e6-982b-d7d350ec62c6	9d68beff-22ca-4e68-84c5-048c21bd9cde	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"66.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 09:54:25
25007	9d68beff-19b7-4b42-b4ed-5668b0eb9cba	9d68beff-22ca-4e68-84c5-048c21bd9cde	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"3.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:54:25
25008	9d68beff-19ef-49c3-ad1b-1b0e86efe3f8	9d68beff-22ca-4e68-84c5-048c21bd9cde	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 09:54:25
25009	9d68beff-2114-4132-b28e-883e1ab49501	9d68beff-22ca-4e68-84c5-048c21bd9cde	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 09:54:25
25010	9d68beff-2186-48d2-82f2-ded728546532	9d68beff-22ca-4e68-84c5-048c21bd9cde	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":736,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:54:25
8571	9d52ed85-7e8e-44d8-93af-1a5ec58dc921	9d52ed85-c970-4112-8719-fb0dda9b3c57	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 13:36:18
8572	9d52ed85-c7b9-41dc-a071-9252cd64c0fc	9d52ed85-c970-4112-8719-fb0dda9b3c57	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:36:18
8573	9d52ed85-c86c-4c08-ab68-c6323b5e2515	9d52ed85-c970-4112-8719-fb0dda9b3c57	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:36:18
18235	9d65baba-889b-4c87-a585-a0106e58725e	9d65baba-d3ce-47d4-8447-433e0ffd5d0e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 21:55:00
18236	9d65baba-d188-4084-a359-5a22b2af557c	9d65baba-d3ce-47d4-8447-433e0ffd5d0e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:55:00
18237	9d65baba-d244-4377-b3e6-03f50a54ff5c	9d65baba-d3ce-47d4-8447-433e0ffd5d0e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":365,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:55:00
14086	9d5d1548-1025-40b3-8cf1-06d17d8020c1	9d5d1548-2a83-478c-80d7-2bbb2083768c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 14:45:45
29398	9d692449-3148-40d2-a0fd-c2df64f8bf2e	9d692449-390b-4a9b-83e7-c377b6293c9a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1381}	2024-11-04 14:37:39
6308	9d52643a-062f-485b-9945-0b68d8732b81	9d52643a-25b3-4847-a873-e2c56889f9fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 07:12:24
6309	9d52643a-2366-4d87-82a1-7d678fd08fd3	9d52643a-25b3-4847-a873-e2c56889f9fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 07:12:24
6310	9d52643a-2489-4ce1-8e95-5c344bd47164	9d52643a-25b3-4847-a873-e2c56889f9fc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abfrom\\u00bb\\nLINE 14:     from loans l\\n             ^ (Connection: pgsql, SQL: \\n    select l.id,\\n        l.loans_documento,\\n        l.loans_nombre,\\n        l.loans_apellido_uno,\\n        l.loans_fecha,\\n        l.loans_valor_prestado,\\n        l.loans_cuotas,\\n        l.loans_estado,\\n        l.loans_intereses,\\n        ucl.name as cliente,\\n        uco.name as cobrador,\\n        ure.name as recomendador,\\n    from loans l\\n    join users ucl on l.user_customer = ucl.id\\n    join users uco on l.user_cobrador = uco.id\\n    left join users ure on l.user_recomendacion = ure.id\\n)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":269,"memory":22,"hostname":"EderCortes"}	2024-10-24 07:12:24
18060	9d65b707-812d-44ec-a871-b309901743af	9d65b707-9e7b-4803-9dcc-2d1ad612a1d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 21:44:39
18061	9d65b707-9cec-42cf-8d75-a0633a6884a9	9d65b707-9e7b-4803-9dcc-2d1ad612a1d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 21:44:39
14087	9d5d1548-2650-4358-9c51-a32cb15fd9b5	9d5d1548-2a83-478c-80d7-2bbb2083768c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mar%' or \\"users\\".\\"user_document\\"::text like '%Mar%') order by \\"users\\".\\"user_document\\" asc","time":"40.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 14:45:45
14088	9d5d1548-292a-49d9-8e0b-233f3545a7b5	9d5d1548-2a83-478c-80d7-2bbb2083768c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 14:45:45
18062	9d65b707-9d82-4ae7-bef8-08a8a879bc7d	9d65b707-9e7b-4803-9dcc-2d1ad612a1d2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":255,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:44:39
18238	9d65babb-320d-48f6-9ddb-44f00ce94a44	9d65babb-4fad-441f-a2de-ab09580d2558	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:55:00
18150	9d65b968-c210-4309-a914-63d04728dee7	9d65b968-e8b2-4031-a25b-cbe1bb3292a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 21:51:19
18151	9d65b968-e6e1-4012-b65b-a97eff421c37	9d65b968-e8b2-4031-a25b-cbe1bb3292a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 21:51:19
18152	9d65b968-e792-4c70-8cde-e6eea422a708	9d65b968-e8b2-4031-a25b-cbe1bb3292a1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":346,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:51:19
18239	9d65babb-4654-4a87-9676-0cc77152596b	9d65babb-4fad-441f-a2de-ab09580d2558	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"37.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"2b11ef88578e3c91c11800e110e490df","hostname":"EderCortes"}	2024-11-02 21:55:00
8574	9d52ed86-1e56-43ee-9946-e74934ba92e8	9d52ed86-6940-4759-98b6-5df2976e41fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:36:18
8575	9d52ed86-632c-4981-bf9d-2254915d5717	9d52ed86-6940-4759-98b6-5df2976e41fe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"152.91","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:36:18
8576	9d52ed86-638c-4715-95dc-bfbb93107376	9d52ed86-6940-4759-98b6-5df2976e41fe	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:36:18
8577	9d52ed86-681b-4d2a-b6c3-f222f9ec93d6	9d52ed86-6940-4759-98b6-5df2976e41fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:36:18
8578	9d52ed86-685b-4cac-9b7d-5b6c6f687ee8	9d52ed86-6940-4759-98b6-5df2976e41fe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":381,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:36:18
10783	9d572105-3843-4bdb-a1d8-c7c8d665fd99	9d572105-8247-4ba6-bdc7-78a36e5686db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-26 15:43:37
10784	9d572105-7c9f-4747-9869-9fee18d0ed18	9d572105-8247-4ba6-bdc7-78a36e5686db	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"149.50","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 15:43:37
10785	9d572105-7cff-4c49-9ca2-17541aad4b86	9d572105-8247-4ba6-bdc7-78a36e5686db	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 15:43:37
10786	9d572105-80e3-4f26-9a8a-20a2223656e0	9d572105-8247-4ba6-bdc7-78a36e5686db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-26 15:43:37
10787	9d572105-813d-4010-b746-a3526f5b8a4e	9d572105-8247-4ba6-bdc7-78a36e5686db	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:43:37
14089	9d5d1548-2987-49da-9eea-8d5e9d3a32c4	9d5d1548-2a83-478c-80d7-2bbb2083768c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mar"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":213,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:45:45
12998	9d5cf2dc-0151-41d5-9e5a-269e7bf6c3ae	9d5cf2dc-43dd-4136-94cd-9827c6992da9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 13:09:30
12999	9d5cf2dc-4123-4aa6-8db8-db60fe3fa122	9d5cf2dc-43dd-4136-94cd-9827c6992da9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 13:09:30
13000	9d5cf2dc-4263-41e0-9f14-0ad888aef495	9d5cf2dc-43dd-4136-94cd-9827c6992da9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":467,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:09:30
18063	9d65b707-e9fa-4502-9fd3-66391256ad9e	9d65b708-30bc-4ac7-9644-52de3f46d839	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 21:44:40
18153	9d65b969-30e8-4880-bd09-63db88e640e5	9d65b969-512c-4e54-8bc2-18d45eef6e75	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 21:51:19
18240	9d65babb-49fd-4349-99bc-585d7e7253d8	9d65babb-4fad-441f-a2de-ab09580d2558	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"1.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:55:00
18241	9d65babb-4a30-48ec-9b53-5afa8465d08e	9d65babb-4fad-441f-a2de-ab09580d2558	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:55:00
18242	9d65babb-4e53-4a46-b5d8-d732fcc20353	9d65babb-4fad-441f-a2de-ab09580d2558	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:55:00
25011	9d68beff-f50f-49d6-aea4-24232256de5a	9d68bf00-2e76-40e8-99ea-9f8cebc55919	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 09:54:26
8579	9d52ed86-b1b1-4d86-9e67-bf4763e93162	9d52ed86-d1b2-4c92-a722-b8687489f5f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:36:19
8580	9d52ed86-cca2-4fe2-be37-2af918666e3a	9d52ed86-d1b2-4c92-a722-b8687489f5f9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:36:19
8581	9d52ed86-cceb-48b7-b6db-4d748bf59688	9d52ed86-d1b2-4c92-a722-b8687489f5f9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:36:19
8582	9d52ed86-d083-4ad5-9967-8d3599b967f4	9d52ed86-d1b2-4c92-a722-b8687489f5f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:36:19
8583	9d52ed86-d0c7-4901-8af2-c41d1b65b309	9d52ed86-d1b2-4c92-a722-b8687489f5f9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:36:19
13001	9d5cf2dc-f5a9-40ce-926f-a88a4e5fa0a0	9d5cf2dd-2ccf-491f-a70b-652d632bfdb1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 13:09:31
13002	9d5cf2dd-1af6-420f-937a-9115158b2cc9	9d5cf2dd-2ccf-491f-a70b-652d632bfdb1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 28\\n                        ","time":"69.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"618a8b500e46ad393f7c65ceec660399","hostname":"EderCortes"}	2024-10-29 13:09:31
13003	9d5cf2dd-20ca-4ef4-ad0c-36cd5d9e7fd9	9d5cf2dd-2ccf-491f-a70b-652d632bfdb1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '28' order by \\"item_loans\\".\\"id\\" asc","time":"2.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 13:09:31
13004	9d5cf2dd-210f-44e2-af0b-4c21a9fa3b9a	9d5cf2dd-2ccf-491f-a70b-652d632bfdb1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 13:09:31
13005	9d5cf2dd-2ad2-4722-a368-1646b2b5dad5	9d5cf2dd-2ccf-491f-a70b-652d632bfdb1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 13:09:31
13006	9d5cf2dd-2b6e-433b-8fe0-1e052b4c7bf4	9d5cf2dd-2ccf-491f-a70b-652d632bfdb1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/28","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":28,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":600081,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":94,"loans_codigo":28,"itemloans_cuota":"1","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":95,"loans_codigo":28,"itemloans_cuota":"2","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":96,"loans_codigo":28,"itemloans_cuota":"3","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":97,"loans_codigo":28,"itemloans_cuota":"4","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":98,"loans_codigo":28,"itemloans_cuota":"5","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":99,"loans_codigo":28,"itemloans_cuota":"6","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":547,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:09:31
14090	9d5d1548-68de-49f3-ba15-35439547e399	9d5d1548-6be3-401e-a5a1-5c5e8e1d5709	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":141,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:45:45
8584	9d52ed87-183f-44c3-abf9-430fa9ead5f9	9d52ed87-24b4-407a-9284-47f8e53d9948	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:36:19
8585	9d52ed87-2341-47cd-9d6e-b0f1a2f6532f	9d52ed87-24b4-407a-9284-47f8e53d9948	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:36:19
8586	9d52ed87-23a8-4d9d-abc3-e43af19a511c	9d52ed87-24b4-407a-9284-47f8e53d9948	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[]},"duration":198,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:36:19
13007	9d5cf2de-0b18-4fc5-aaa4-c78526b25307	9d5cf2de-5450-489d-8a87-ee818ab81188	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 13:09:31
13008	9d5cf2de-491a-455a-8dcc-f559bfdbc91c	9d5cf2de-5450-489d-8a87-ee818ab81188	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"103.22","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 13:09:32
13009	9d5cf2de-49b3-4811-8cfe-7ed7449db646	9d5cf2de-5450-489d-8a87-ee818ab81188	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 13:09:32
13010	9d5cf2de-51d9-413a-bcf5-8858e5bb8240	9d5cf2de-5450-489d-8a87-ee818ab81188	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 13:09:32
13011	9d5cf2de-5277-480e-89d4-308ab42fbcfc	9d5cf2de-5450-489d-8a87-ee818ab81188	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":732,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:09:32
14091	9d5d1548-bd34-487b-876c-de4a97e7bd3c	9d5d1548-d94a-4537-b5eb-4a9c21c97f10	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 14:45:46
14092	9d5d1548-d4d2-4623-b3ac-e5a3f598599d	9d5d1548-d94a-4537-b5eb-4a9c21c97f10	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"43.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 14:45:46
13155	9d5cf9d0-d934-490c-80f8-db37d8b43037	9d5cf9d1-0db1-4bd0-829e-1d2e74f16e0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 13:28:57
13156	9d5cf9d1-0acc-4751-afad-7e7c3f69a563	9d5cf9d1-0db1-4bd0-829e-1d2e74f16e0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 13:28:57
13157	9d5cf9d1-0c28-45b0-86ac-d241fd0784f5	9d5cf9d1-0db1-4bd0-829e-1d2e74f16e0d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":500,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:28:57
14093	9d5d1548-d800-4447-b890-6d99731848be	9d5d1548-d94a-4537-b5eb-4a9c21c97f10	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 14:45:46
14094	9d5d1548-d846-4396-9206-109f580420a7	9d5d1548-d94a-4537-b5eb-4a9c21c97f10	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:45:46
18243	9d65babb-4ea1-4597-b0cf-c50bd9db6dd6	9d65babb-4fad-441f-a2de-ab09580d2558	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":274,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:55:00
8587	9d52ed88-f7ac-4f63-a947-ccad7d0dec98	9d52ed89-41c4-4e29-8cbc-361eae2a1604	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:36:20
8588	9d52ed89-3b85-4288-a55d-9c5bb8a39f0e	9d52ed89-41c4-4e29-8cbc-361eae2a1604	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"134.38","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:36:20
8589	9d52ed89-3bf6-4bfd-be0c-60e6941f9064	9d52ed89-41c4-4e29-8cbc-361eae2a1604	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:36:20
8590	9d52ed89-406c-4cb1-870e-eece7623aff9	9d52ed89-41c4-4e29-8cbc-361eae2a1604	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:36:20
8591	9d52ed89-40bd-459d-bdd7-362602261b2f	9d52ed89-41c4-4e29-8cbc-361eae2a1604	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":424,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:36:20
13012	9d5cf2df-34a0-4450-8575-a4ed4d895bca	9d5cf2df-554f-4b98-b9b0-8ed8ad18bc53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 13:09:32
13013	9d5cf2df-5018-4682-a01f-20d17a1925dc	9d5cf2df-554f-4b98-b9b0-8ed8ad18bc53	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 13:09:32
9593	9d53b6be-d8a4-4955-b9dd-eb271574fa8b	9d53b6bf-1eb9-42e4-a5f5-a5aeab2e1152	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 22:58:58
9594	9d53b6bf-1d2b-498c-a473-f2f31096a78a	9d53b6bf-1eb9-42e4-a5f5-a5aeab2e1152	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 22:58:58
9595	9d53b6bf-1dcc-457e-a226-976c49ce16cc	9d53b6bf-1eb9-42e4-a5f5-a5aeab2e1152	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-10-24 22:58:58
13014	9d5cf2df-506d-455a-9fa4-cee1e4872f19	9d5cf2df-554f-4b98-b9b0-8ed8ad18bc53	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 13:09:32
13015	9d5cf2df-53f5-45c5-bed9-c0f5fc59d75e	9d5cf2df-554f-4b98-b9b0-8ed8ad18bc53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 13:09:32
13016	9d5cf2df-5443-483b-ac34-c57e86a05997	9d5cf2df-554f-4b98-b9b0-8ed8ad18bc53	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":324,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:09:32
13158	9d5cf9d1-afcc-4201-94e6-7b3ebdb671b9	9d5cf9d2-072c-4cf6-b4ed-6032d6b66063	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 13:28:58
13159	9d5cf9d1-ff29-430c-977a-ed6169790913	9d5cf9d2-072c-4cf6-b4ed-6032d6b66063	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"167.47","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":180,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 13:28:58
13160	9d5cf9d1-ffbd-46d8-ba1a-4bc71e8f0dee	9d5cf9d2-072c-4cf6-b4ed-6032d6b66063	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 13:28:58
13161	9d5cf9d2-0556-4a3b-9b23-5f1d13ea4703	9d5cf9d2-072c-4cf6-b4ed-6032d6b66063	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 13:28:58
13162	9d5cf9d2-05e0-49bd-bc39-33e950c4f045	9d5cf9d2-072c-4cf6-b4ed-6032d6b66063	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":575,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:28:58
9596	9d53b6bf-6037-447a-b63b-26b29818feea	9d53b6bf-a42b-4b0c-8a61-9fcae5613cfc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 22:58:58
9597	9d53b6bf-9f7e-4f82-9880-da5483fa0970	9d53b6bf-a42b-4b0c-8a61-9fcae5613cfc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"142.93","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 22:58:58
9598	9d53b6bf-9fc6-4026-80d8-699d61683db7	9d53b6bf-a42b-4b0c-8a61-9fcae5613cfc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 22:58:58
9599	9d53b6bf-a31a-4274-821a-ad9996f7a55b	9d53b6bf-a42b-4b0c-8a61-9fcae5613cfc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 22:58:58
9600	9d53b6bf-a35a-4150-91b9-27eed1fec643	9d53b6bf-a42b-4b0c-8a61-9fcae5613cfc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":313,"memory":22,"hostname":"EderCortes"}	2024-10-24 22:58:58
13163	9d5cf9d2-76f7-4131-bc63-26f85822a410	9d5cf9d2-c051-49de-836f-365470d2c27a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 13:28:58
13164	9d5cf9d2-bb80-4282-80e1-a4fbc4972284	9d5cf9d2-c051-49de-836f-365470d2c27a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"146.85","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":180,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 13:28:58
13165	9d5cf9d2-bbc9-4891-9d60-f6ef2956af3f	9d5cf9d2-c051-49de-836f-365470d2c27a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 13:28:58
13166	9d5cf9d2-bf3c-48f2-8eb3-1b3b5b0928c2	9d5cf9d2-c051-49de-836f-365470d2c27a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-29 13:28:58
13167	9d5cf9d2-bf7e-4980-95e4-1e516d0f15f5	9d5cf9d2-c051-49de-836f-365470d2c27a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":453,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:28:58
14095	9d5d154c-0422-45e7-9e16-d483dbb5068d	9d5d154c-4d82-45d0-aa5c-a2fa2c87da71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 14:45:48
14096	9d5d154c-48cc-458a-9c15-84965489adbb	9d5d154c-4d82-45d0-aa5c-a2fa2c87da71	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '18' and \\"users\\".\\"deleted_at\\" is null","time":"154.23","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":55,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-29 14:45:48
14097	9d5d154c-4916-4450-a53e-83454a24fdca	9d5d154c-4d82-45d0-aa5c-a2fa2c87da71	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 14:45:48
14098	9d5d154c-4c52-4807-9655-3655220d835b	9d5d154c-4d82-45d0-aa5c-a2fa2c87da71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 14:45:48
14099	9d5d154c-4c93-47b6-a38d-a2f798d7b796	9d5d154c-4d82-45d0-aa5c-a2fa2c87da71	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/18","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}},"duration":366,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:45:48
18244	9d65babd-4ed5-4d16-8795-ec1971f105de	9d65babd-73bb-4221-91e8-84dff7c2e821	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:55:02
9601	9d53b6bf-e0e5-4691-b9f3-31f50c6dfb80	9d53b6bf-fc3b-40e5-8008-da3ab02eef4b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 22:58:58
9602	9d53b6bf-f78e-48c5-9703-3220e78efad7	9d53b6bf-fc3b-40e5-8008-da3ab02eef4b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 22:58:58
9603	9d53b6bf-f7d8-46f5-93d6-00ac7a553843	9d53b6bf-fc3b-40e5-8008-da3ab02eef4b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 22:58:58
9604	9d53b6bf-fb24-4334-b875-6d864342e05c	9d53b6bf-fc3b-40e5-8008-da3ab02eef4b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 22:58:58
9605	9d53b6bf-fb66-477a-a6ea-76052bd344ba	9d53b6bf-fc3b-40e5-8008-da3ab02eef4b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":206,"memory":22,"hostname":"EderCortes"}	2024-10-24 22:58:58
18064	9d65b708-272c-432d-bb70-b426242ca5cc	9d65b708-30bc-4ac7-9644-52de3f46d839	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"141.46","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"2b11ef88578e3c91c11800e110e490df","hostname":"EderCortes"}	2024-11-02 21:44:40
9606	9d53b6c2-3d11-4b33-9dec-503cc079f051	9d53b6c2-680c-4034-b277-fa5874f440b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 22:59:00
9607	9d53b6c2-5e77-4974-9282-d3460433d8ed	9d53b6c2-680c-4034-b277-fa5874f440b9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"58.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 22:59:00
9608	9d53b6c2-5efb-42d9-8930-03c60f896514	9d53b6c2-680c-4034-b277-fa5874f440b9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 22:59:00
9609	9d53b6c2-65fc-4f74-bf0e-bb526480e71d	9d53b6c2-680c-4034-b277-fa5874f440b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 22:59:00
9610	9d53b6c2-6682-4191-aecb-a87239318bd0	9d53b6c2-680c-4034-b277-fa5874f440b9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":379,"memory":22,"hostname":"EderCortes"}	2024-10-24 22:59:00
13168	9d5cf9d3-4d17-41ed-bc3e-410930c57391	9d5cf9d3-b74c-43e5-991c-a7677e5f2d4a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-29 13:28:59
13169	9d5cf9d3-abb0-439a-b12d-5d9a309d4726	9d5cf9d3-b74c-43e5-991c-a7677e5f2d4a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"178.11","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 13:28:59
13170	9d5cf9d3-ac67-4069-993c-5d803c708bd5	9d5cf9d3-b74c-43e5-991c-a7677e5f2d4a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 13:28:59
13171	9d5cf9d3-b4de-4259-841a-09bc508827b4	9d5cf9d3-b74c-43e5-991c-a7677e5f2d4a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-29 13:28:59
13172	9d5cf9d3-b574-4621-a958-befeb69068e6	9d5cf9d3-b74c-43e5-991c-a7677e5f2d4a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":615,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:28:59
14100	9d5d1573-7262-41b6-9026-241bcbcec6c0	9d5d1573-75be-4d43-b581-dcaaf2d29c64	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":155,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:46:14
18065	9d65b708-2b35-4181-84b1-d3e767427c71	9d65b708-30bc-4ac7-9644-52de3f46d839	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"2.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:44:40
18066	9d65b708-2b6c-4bf6-9186-140031b0f7e1	9d65b708-30bc-4ac7-9644-52de3f46d839	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:44:40
18067	9d65b708-2f85-4322-bed9-f1308eb8faa0	9d65b708-30bc-4ac7-9644-52de3f46d839	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 21:44:40
18245	9d65babd-6b94-45f1-9761-6c97d68d536b	9d65babd-73bb-4221-91e8-84dff7c2e821	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"47.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 21:55:02
18246	9d65babd-6c14-43d6-912f-7628418dc73d	9d65babd-73bb-4221-91e8-84dff7c2e821	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 21:55:02
18247	9d65babd-7185-4ef2-b9a8-a6594914a6c4	9d65babd-73bb-4221-91e8-84dff7c2e821	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 21:55:02
13173	9d5cf9d4-6eb4-4b9f-b502-c6fcfca3eafa	9d5cf9d4-a1c1-4409-b2da-a47c8d651a5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-29 13:29:00
13174	9d5cf9d4-9b0b-4f4d-9e41-1bc43f388783	9d5cf9d4-a1c1-4409-b2da-a47c8d651a5c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"67.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 13:29:00
13175	9d5cf9d4-9b64-40d9-86b9-e0c6e5e9e8b8	9d5cf9d4-a1c1-4409-b2da-a47c8d651a5c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 13:29:00
13176	9d5cf9d4-9fcc-42ee-86a6-951fba9883c1	9d5cf9d4-a1c1-4409-b2da-a47c8d651a5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-29 13:29:00
13177	9d5cf9d4-a03b-4865-a0ec-f513d0070583	9d5cf9d4-a1c1-4409-b2da-a47c8d651a5c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":507,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:29:00
18068	9d65b708-2fd1-447c-9830-5ae43c3504f1	9d65b708-30bc-4ac7-9644-52de3f46d839	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:44:40
18154	9d65b969-477f-4d42-b991-be70011c7ec8	9d65b969-512c-4e54-8bc2-18d45eef6e75	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"45.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"2b11ef88578e3c91c11800e110e490df","hostname":"EderCortes"}	2024-11-02 21:51:19
18155	9d65b969-4b32-4d47-b517-8cfc43fd4433	9d65b969-512c-4e54-8bc2-18d45eef6e75	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"2.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:51:19
18156	9d65b969-4b67-478b-aa84-3f6065e5b6e8	9d65b969-512c-4e54-8bc2-18d45eef6e75	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:51:19
18157	9d65b969-4fe8-43b0-954c-dbaee127f6f1	9d65b969-512c-4e54-8bc2-18d45eef6e75	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 21:51:19
18158	9d65b969-5036-4134-bc66-1e152d998f51	9d65b969-512c-4e54-8bc2-18d45eef6e75	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:51:19
14104	9d5d1584-ae85-4d3e-93ef-e30f77308870	9d5d1584-b318-4337-9de6-fa73f3261815	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":168,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:46:25
18069	9d65b709-f7f8-4917-9cff-e59540dba1c2	9d65b70a-3d17-4b35-836f-81aa0d6f5f8a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 21:44:41
18070	9d65b70a-3820-4e8c-9079-c0f4d93c8ee5	9d65b70a-3d17-4b35-836f-81aa0d6f5f8a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"143.66","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 21:44:41
18071	9d65b70a-386d-47df-890a-4ef882610f82	9d65b70a-3d17-4b35-836f-81aa0d6f5f8a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 21:44:41
18072	9d65b70a-3bbc-47a2-9cf0-3700ef46e6c3	9d65b70a-3d17-4b35-836f-81aa0d6f5f8a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 21:44:41
18073	9d65b70a-3c06-4677-b93d-f6ec5463f839	9d65b70a-3d17-4b35-836f-81aa0d6f5f8a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":365,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:44:41
18159	9d65b96b-4aa3-4625-8b70-ffb4cba092d6	9d65b96b-73c8-4af3-b856-999dc8f207de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 21:51:20
18160	9d65b96b-6a32-4c45-a76a-05ce0ce100ac	9d65b96b-73c8-4af3-b856-999dc8f207de	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"55.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 21:51:20
18161	9d65b96b-6b58-4575-b559-8709456c8bea	9d65b96b-73c8-4af3-b856-999dc8f207de	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 21:51:20
18162	9d65b96b-71b7-4e1f-b81d-01f8ed8e7b90	9d65b96b-73c8-4af3-b856-999dc8f207de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-02 21:51:20
18163	9d65b96b-7243-4858-afa3-34b4a603103f	9d65b96b-73c8-4af3-b856-999dc8f207de	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":397,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:51:20
18248	9d65babd-720f-40f4-8227-783912e39f31	9d65babd-73bb-4221-91e8-84dff7c2e821	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:55:02
25012	9d68bf00-2285-4ac6-8f51-ac87a5aa50ee	9d68bf00-2e76-40e8-99ea-9f8cebc55919	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"66.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:54:26
25013	9d68bf00-232e-42dd-9564-173c72209cf4	9d68bf00-2e76-40e8-99ea-9f8cebc55919	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:54:26
25014	9d68bf00-2b81-47ca-86bb-3126b7206a0b	9d68bf00-2e76-40e8-99ea-9f8cebc55919	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 09:54:26
13345	9d5cfcfc-f5db-4f97-99ca-4d7a37f8e4ef	9d5cfcfd-2832-4473-9eb6-3193458ad930	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 13:37:49
13346	9d5cfcfd-23e5-4573-97e8-c1c5ceb95b61	9d5cfcfd-2832-4473-9eb6-3193458ad930	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 13:37:50
13347	9d5cfcfd-2635-4fd9-8bf8-ee0834ae22e4	9d5cfcfd-2832-4473-9eb6-3193458ad930	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":384,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:37:50
25015	9d68bf00-2c60-47fe-afa0-d418f996d4e6	9d68bf00-2e76-40e8-99ea-9f8cebc55919	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":660,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:54:26
18466	9d66921d-6b9d-40d6-9095-a21e9f1e32a7	9d66921d-99e1-4fc6-a04f-119ec7cbb520	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 07:57:16
18467	9d66921d-97bd-48d8-8956-3075105a4100	9d66921d-99e1-4fc6-a04f-119ec7cbb520	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 07:57:16
18468	9d66921d-989b-49c4-a856-c2293a6ff719	9d66921d-99e1-4fc6-a04f-119ec7cbb520	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":341,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:57:16
18469	9d66921e-03a4-4037-84c3-0ef19b6fe908	9d66921e-27ad-4443-84c9-d6009b9c7cc7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 07:57:16
10909	9d5ca5cd-492a-46b3-a0a2-536f69ce926e	9d5ca5cd-a06f-4a97-992b-4a4b6220ad0c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 09:34:02
10910	9d5ca5cd-9d34-47c4-bac5-aeaf5f2738de	9d5ca5cd-a06f-4a97-992b-4a4b6220ad0c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 09:34:02
10911	9d5ca5cd-9ea5-4539-9192-ddb5a8ce0e9a	9d5ca5cd-a06f-4a97-992b-4a4b6220ad0c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":386,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:34:02
18470	9d66921e-21b2-4240-aabc-30bcad4ba77b	9d66921e-27ad-4443-84c9-d6009b9c7cc7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"52.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58,"hash":"77f8314368b36a9393ec9c7735a91700","hostname":"EderCortes"}	2024-11-03 07:57:16
18471	9d66921e-2634-4987-81a8-68f354ce3a98	9d66921e-27ad-4443-84c9-d6009b9c7cc7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 07:57:16
18472	9d66921e-268f-4094-8597-05453717e5c6	9d66921e-27ad-4443-84c9-d6009b9c7cc7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":325,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:57:16
13348	9d5cfcfd-c036-420f-9ecb-d3303e880bb9	9d5cfcfd-f0c5-4a9c-9036-6477893e3a17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 13:37:50
13349	9d5cfcfd-e7fe-4d99-9367-cc66fb177628	9d5cfcfd-f0c5-4a9c-9036-6477893e3a17	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"59.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 13:37:50
13350	9d5cfcfd-e88a-43c1-b0ad-db7182fa4b79	9d5cfcfd-f0c5-4a9c-9036-6477893e3a17	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 13:37:50
13351	9d5cfcfd-ef4a-4a55-98f6-8adfde5a94c5	9d5cfcfd-f0c5-4a9c-9036-6477893e3a17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 13:37:50
25016	9d68bf01-3d4c-4df0-a38a-6f14fe90133d	9d68bf01-6ac8-4b0f-ba9f-efe01308e1bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 09:54:26
18673	9d669963-9b72-4954-9817-92ba8464af4d	9d669963-d07e-42a8-9ae7-095dcbc15ce3	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 08:17:36
18674	9d669963-cd26-413b-bc15-eb2c188ad439	9d669963-d07e-42a8-9ae7-095dcbc15ce3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:17:36
18675	9d669963-ce94-46a7-a768-392e3c9cd0e4	9d669963-d07e-42a8-9ae7-095dcbc15ce3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":399,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:17:36
25017	9d68bf01-61b6-4a07-9dbc-1639fff332bf	9d68bf01-6ac8-4b0f-ba9f-efe01308e1bd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"54.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:54:26
25018	9d68bf01-626e-49bb-bf02-4097f188e37f	9d68bf01-6ac8-4b0f-ba9f-efe01308e1bd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:54:26
25019	9d68bf01-68e6-43d2-a6d5-a251903f2f2c	9d68bf01-6ac8-4b0f-ba9f-efe01308e1bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 09:54:27
25020	9d68bf01-695e-46a7-85e3-df332c2df0f6	9d68bf01-6ac8-4b0f-ba9f-efe01308e1bd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":499,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:54:27
10912	9d5ca5cf-b0e5-4699-8d4f-9e0333a469f7	9d5ca5cf-f80e-4c36-83b7-89d5d2253439	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 09:34:04
10913	9d5ca5cf-f249-46bd-9872-e51e94c620c7	9d5ca5cf-f80e-4c36-83b7-89d5d2253439	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"147.05","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 09:34:04
10914	9d5ca5cf-f2ae-46b3-b5ec-968c59b4f254	9d5ca5cf-f80e-4c36-83b7-89d5d2253439	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 09:34:04
10915	9d5ca5cf-f69b-4150-9340-e682ff91c9cc	9d5ca5cf-f80e-4c36-83b7-89d5d2253439	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 09:34:04
10916	9d5ca5cf-f6ed-4b25-88c2-14fe6e009bde	9d5ca5cf-f80e-4c36-83b7-89d5d2253439	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":520,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:34:04
13352	9d5cfcfd-efa2-4d0a-b27f-f15184ce8b32	9d5cfcfd-f0c5-4a9c-9036-6477893e3a17	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":457,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:37:50
14108	9d5d15a5-db2e-4bfe-a46c-f577997eb742	9d5d15a5-def4-42b5-aca5-dcfb7098ddf5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":159,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:46:47
18473	9d669220-2bfe-40d5-a558-3b842dcbeb5e	9d669220-4a7f-446e-a018-4c3331833327	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 07:57:18
18474	9d669220-458f-4a19-85c3-9232f345d48f	9d669220-4a7f-446e-a018-4c3331833327	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 07:57:18
18475	9d669220-45df-4b2c-8aae-9e267cc17da8	9d669220-4a7f-446e-a018-4c3331833327	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 07:57:18
18476	9d669220-4937-4d04-a3c9-30786f727685	9d669220-4a7f-446e-a018-4c3331833327	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 07:57:18
18477	9d669220-497b-4655-b1ff-65948b9da850	9d669220-4a7f-446e-a018-4c3331833327	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:57:18
18676	9d669964-56d2-4cfa-becd-06db19d809b5	9d669964-7956-497f-b874-4d58b8bfd900	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:17:37
25021	9d68bf02-0432-4c45-a4eb-89f1781a93bf	9d68bf02-35b3-4593-9e26-a31607d5a4c6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 09:54:27
13353	9d5cfcfe-552a-42eb-8033-3405d4da402e	9d5cfcfe-7d17-4517-9249-24dfeab146fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 13:37:50
13354	9d5cfcfe-7816-4472-90e4-c62907e22d59	9d5cfcfe-7d17-4517-9249-24dfeab146fc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"52.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 13:37:50
13355	9d5cfcfe-786c-4355-9e11-e9878508af4b	9d5cfcfe-7d17-4517-9249-24dfeab146fc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 13:37:50
13356	9d5cfcfe-7bfa-4ac4-b9e7-5e46450de09f	9d5cfcfe-7d17-4517-9249-24dfeab146fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 13:37:50
13357	9d5cfcfe-7c41-4231-9927-0bb5c81c9309	9d5cfcfe-7d17-4517-9249-24dfeab146fc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:37:50
18544	9d66943b-0543-4d70-b94d-60a9f33e4344	9d66943b-3492-4d08-8a1c-d1a89e7c1cb0	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 08:03:11
18545	9d66943b-321c-4222-9d85-ee035c8e0706	9d66943b-3492-4d08-8a1c-d1a89e7c1cb0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:03:11
18546	9d66943b-3307-4f8b-a0ab-7e4d5db3e42e	9d66943b-3492-4d08-8a1c-d1a89e7c1cb0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":388,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:03:11
18617	9d6696f4-d090-43c0-8bfc-3e05f5b83902	9d6696f5-0702-4417-83ab-d412296e5615	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 08:10:48
18618	9d6696f5-0417-4050-aaf4-f7eca6cf457d	9d6696f5-0702-4417-83ab-d412296e5615	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:10:48
18619	9d6696f5-0514-48e8-8a6d-18ea4a536b16	9d6696f5-0702-4417-83ab-d412296e5615	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":441,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:10:48
13358	9d5cfcff-a8bb-46a9-aa0b-ca393a96e8f0	9d5cfcff-f73a-4e6b-82f2-996cf493ec77	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 13:37:51
13359	9d5cfcff-ec4e-4176-9440-9335361ebca0	9d5cfcff-f73a-4e6b-82f2-996cf493ec77	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"97.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 13:37:51
13360	9d5cfcff-ecd4-4c49-9b58-9a10a7d4de34	9d5cfcff-f73a-4e6b-82f2-996cf493ec77	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 13:37:51
13361	9d5cfcff-f512-4d70-b2e4-d4a73e25ef78	9d5cfcff-f73a-4e6b-82f2-996cf493ec77	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 13:37:51
13362	9d5cfcff-f59a-4c60-820e-1d372583fa4e	9d5cfcff-f73a-4e6b-82f2-996cf493ec77	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":952,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:37:51
14113	9d5d160f-09f1-44c0-9a63-1f39f0eb71bf	9d5d160f-0d25-447f-aac2-5795b716bad2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":170,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:47:56
18547	9d66943b-c285-4143-aa25-5b87874d6626	9d66943c-13f2-405f-b11c-d61872d05411	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:03:11
18548	9d66943c-0a80-4559-9d08-0e0f4d4e6934	9d66943c-13f2-405f-b11c-d61872d05411	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"165.16","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58,"hash":"77f8314368b36a9393ec9c7735a91700","hostname":"EderCortes"}	2024-11-03 08:03:11
18549	9d66943c-11bd-4540-b736-9e6e282ce0aa	9d66943c-13f2-405f-b11c-d61872d05411	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:03:11
18550	9d66943c-123c-4da4-a7c9-951a7408cad3	9d66943c-13f2-405f-b11c-d61872d05411	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":483,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:03:11
18677	9d669964-73c6-4f22-822b-86d1d709dd52	9d669964-7956-497f-b874-4d58b8bfd900	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"48.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c37ce191b53d9d62ae3ae483cb5ffa40","hostname":"EderCortes"}	2024-11-03 08:17:37
18678	9d669964-77d2-4765-9755-0cc525ced819	9d669964-7956-497f-b874-4d58b8bfd900	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:17:37
13363	9d5cfd00-a1ff-44d5-867e-a7e21508d2a7	9d5cfd00-c93b-4145-b62a-ebc8702b6cde	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 13:37:52
13364	9d5cfd00-c3fb-48bf-99be-b31d159683eb	9d5cfd00-c93b-4145-b62a-ebc8702b6cde	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"54.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 13:37:52
13365	9d5cfd00-c449-452e-914f-6e8f3c8f36c8	9d5cfd00-c93b-4145-b62a-ebc8702b6cde	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 13:37:52
13366	9d5cfd00-c7d0-4733-92f2-6bdb41c5018a	9d5cfd00-c93b-4145-b62a-ebc8702b6cde	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 13:37:52
9870	9d56b48f-9aa2-436c-8fd4-a13c8aefc961	9d56b48f-e4a3-43c5-8a24-fa6ede40023e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 10:40:20
9871	9d56b48f-e337-4376-9f1a-e72dd7c2340c	9d56b48f-e4a3-43c5-8a24-fa6ede40023e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 10:40:20
9872	9d56b48f-e3cf-41db-8966-810cfaec31e5	9d56b48f-e4a3-43c5-8a24-fa6ede40023e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":359,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:40:20
13367	9d5cfd00-c830-47ab-a77d-532768a0ae4c	9d5cfd00-c93b-4145-b62a-ebc8702b6cde	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":514,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:37:52
18679	9d669964-7836-4cb4-b22d-3a77bc703d57	9d669964-7956-497f-b874-4d58b8bfd900	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","frecuencia_pago":"-1","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"6","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"-25","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"6","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"-25","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"-1","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"13","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"13","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"6","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"-3","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"5","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"-25","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"-25","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"-25","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":359,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:17:37
25022	9d68bf02-26c6-435b-b50b-2f6f1dd19581	9d68bf02-35b3-4593-9e26-a31607d5a4c6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"66.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 09:54:27
14321	9d5d1de5-9124-41b7-a1e3-4dea0716a2cb	9d5d1de5-ffb4-4ef1-9eca-93dc795c5f99	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 15:09:51
14322	9d5d1de5-fc33-4478-9fb4-26fd1d29854a	9d5d1de5-ffb4-4ef1-9eca-93dc795c5f99	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 15:09:51
14323	9d5d1de5-fd9d-4f4a-bd1d-a5917b989722	9d5d1de5-ffb4-4ef1-9eca-93dc795c5f99	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":802,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:09:51
25023	9d68bf02-2d1d-43cf-8e75-98a4c084c1ea	9d68bf02-35b3-4593-9e26-a31607d5a4c6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"3.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:54:27
25024	9d68bf02-2d70-4be6-b402-a5ebc4aa437d	9d68bf02-35b3-4593-9e26-a31607d5a4c6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 09:54:27
25025	9d68bf02-33f3-4a73-abc5-9e58a78d1a56	9d68bf02-35b3-4593-9e26-a31607d5a4c6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 09:54:27
9873	9d56b490-2e13-475f-82be-1f5e2c9187c1	9d56b490-6fd8-4578-8044-9b2bc73aba1b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 10:40:20
9874	9d56b490-6c10-4b0f-ad03-d670b2ef77cc	9d56b490-6fd8-4578-8044-9b2bc73aba1b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"146.02","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-26 10:40:21
9875	9d56b490-6ecb-4fae-9530-24e5e01a56c0	9d56b490-6fd8-4578-8044-9b2bc73aba1b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 10:40:21
9876	9d56b490-6f17-46c9-a6d4-0656fe9090ee	9d56b490-6fd8-4578-8044-9b2bc73aba1b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":325,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:40:21
13368	9d5cfd06-0dc6-44cf-acf8-2000ae240836	9d5cfd06-10e1-4710-b012-9884ff813fd3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":159,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:37:55
14324	9d5d1de6-c4b9-4796-a7df-c7a123f812a6	9d5d1de7-2a80-42a5-998f-09ac59e92a49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 15:09:51
14325	9d5d1de7-1a41-4948-86af-b36b5b0d3958	9d5d1de7-2a80-42a5-998f-09ac59e92a49	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 55\\n                        ","time":"193.71","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"ff7240abed4441475e0acd0c74a5f6aa","hostname":"EderCortes"}	2024-10-29 15:09:52
14326	9d5d1de7-21a2-4c26-9ceb-ee49e3396b2a	9d5d1de7-2a80-42a5-998f-09ac59e92a49	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '55' order by \\"item_loans\\".\\"id\\" asc","time":"3.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 15:09:52
14327	9d5d1de7-21df-4bb5-aa79-9aa526c92336	9d5d1de7-2a80-42a5-998f-09ac59e92a49	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":7,"hostname":"EderCortes"}	2024-10-29 15:09:52
14328	9d5d1de7-2885-452a-a514-59269a0e4f29	9d5d1de7-2a80-42a5-998f-09ac59e92a49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 15:09:52
14329	9d5d1de7-292d-4e6e-b1d4-1ff6adbe62b0	9d5d1de7-2a80-42a5-998f-09ac59e92a49	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/55","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":55,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":7,"loans_valor_prestado":50000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"15-11-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":150,"loans_codigo":55,"itemloans_cuota":"1","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":151,"loans_codigo":55,"itemloans_cuota":"2","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":152,"loans_codigo":55,"itemloans_cuota":"3","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":153,"loans_codigo":55,"itemloans_cuota":"4","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":154,"loans_codigo":55,"itemloans_cuota":"5","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":155,"loans_codigo":55,"itemloans_cuota":"6","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":156,"loans_codigo":55,"itemloans_cuota":"7","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":689,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:09:52
18680	9d669966-09fc-4934-87dd-b5da4b55e411	9d669966-6add-4799-9c22-c88650dc9335	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:17:38
25026	9d68bf02-3472-407f-85af-c07fe6e6ca15	9d68bf02-35b3-4593-9e26-a31607d5a4c6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":352,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":353,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":354,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":355,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":499,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:54:27
18681	9d669966-63c4-432d-9bc3-2bfa8cf5906c	9d669966-6add-4799-9c22-c88650dc9335	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"165.03","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 08:17:38
7971	9d52e58a-39bf-4d93-8d45-0a512595f0cc	9d52e58a-5854-4712-837a-4cd9bf286316	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 13:13:59
7972	9d52e58a-5681-491f-b6da-de1f562d715b	9d52e58a-5854-4712-837a-4cd9bf286316	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 13:13:59
7973	9d52e58a-5744-4a98-ad25-827909dfa052	9d52e58a-5854-4712-837a-4cd9bf286316	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":248,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:13:59
18682	9d669966-6440-4c9b-bd96-34cdcbf1d2b7	9d669966-6add-4799-9c22-c88650dc9335	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 08:17:38
18683	9d669966-6971-48eb-bf47-dc9918fdf4b5	9d669966-6add-4799-9c22-c88650dc9335	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 08:17:38
18684	9d669966-69d9-497f-934d-8d0f6ad49119	9d669966-6add-4799-9c22-c88650dc9335	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":522,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:17:38
7974	9d52e58a-a3b0-4379-bc1f-6e9a839d1007	9d52e58a-c292-4249-aa4d-994e5a9ed628	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 13:13:59
7975	9d52e58a-bce4-4b3d-96ce-9935db4cfe10	9d52e58a-c292-4249-aa4d-994e5a9ed628	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:13:59
7976	9d52e58a-bd59-41cf-a8c9-79d2456c4a31	9d52e58a-c292-4249-aa4d-994e5a9ed628	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:13:59
7977	9d52e58a-c13a-4b06-adc0-95f49b606ac2	9d52e58a-c292-4249-aa4d-994e5a9ed628	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 13:13:59
7978	9d52e58a-c185-4387-8aef-9eebdac0e938	9d52e58a-c292-4249-aa4d-994e5a9ed628	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:13:59
9877	9d56b492-2d7f-47af-9639-38184afbc1e4	9d56b492-758c-4573-97b3-4b5cb478e998	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 10:40:22
9878	9d56b492-70a2-4c27-8cef-1d05bdc9bd1d	9d56b492-758c-4573-97b3-4b5cb478e998	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"153.01","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 10:40:22
9879	9d56b492-70f5-4da4-b87c-90882b174bda	9d56b492-758c-4573-97b3-4b5cb478e998	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 10:40:22
9767	9d56ac8f-0d1b-4543-8707-8b1b10417d7f	9d56ac8f-2c93-457c-a11c-c377fde5fb56	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 10:17:58
9880	9d56b492-7453-4579-a238-e76403fdc59d	9d56b492-758c-4573-97b3-4b5cb478e998	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 10:40:22
9881	9d56b492-749d-4f52-a3f4-90cbbe4aee2a	9d56b492-758c-4573-97b3-4b5cb478e998	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":334,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:40:22
13369	9d5cfd06-5ea9-44c0-89b9-353e985f7c8d	9d5cfd06-61a2-43a6-b10d-67a2ac9bacb5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":143,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:37:56
14330	9d5d1de8-398d-4608-bc23-63b9155e572a	9d5d1de9-0039-4797-9f2b-f0d7c028e2e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 15:09:52
14331	9d5d1de8-f6a5-4060-897f-124de8b2a6d6	9d5d1de9-0039-4797-9f2b-f0d7c028e2e4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"425.08","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 15:09:53
14332	9d5d1de8-f72d-4167-b763-d26a990779e1	9d5d1de9-0039-4797-9f2b-f0d7c028e2e4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 15:09:53
14333	9d5d1de8-fe3d-4a0e-b919-212347864e37	9d5d1de9-0039-4797-9f2b-f0d7c028e2e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 15:09:53
7979	9d52e58b-0db7-45df-9236-182f93d5f2be	9d52e58b-2d88-47b6-948c-7817d9e33edc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 13:13:59
7980	9d52e58b-281a-445b-b483-a91e4b3db96e	9d52e58b-2d88-47b6-948c-7817d9e33edc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:13:59
7981	9d52e58b-2871-4760-86c9-44fcd8e4157d	9d52e58b-2d88-47b6-948c-7817d9e33edc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:13:59
7982	9d52e58b-2c16-4279-9e1e-f80488b24ee5	9d52e58b-2d88-47b6-948c-7817d9e33edc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 13:13:59
7983	9d52e58b-2c60-438a-8511-bdbf912ee617	9d52e58b-2d88-47b6-948c-7817d9e33edc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:13:59
9768	9d56ac8f-2b36-494e-891f-6f646151ad35	9d56ac8f-2c93-457c-a11c-c377fde5fb56	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 10:17:58
9769	9d56ac8f-2bc7-4f58-b27a-777e3cbb6a07	9d56ac8f-2c93-457c-a11c-c377fde5fb56	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:17:58
13370	9d5cfd06-daa6-4855-8595-4cfa8e8088b9	9d5cfd06-dd65-4a0f-b74b-29be6c17fcc8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":132,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:37:56
14334	9d5d1de8-feb9-4b14-9adf-c70cdb8f85d3	9d5d1de9-0039-4797-9f2b-f0d7c028e2e4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":1177,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:09:53
7984	9d52e58b-6f7a-441b-afcf-90c9a9a949fc	9d52e58b-9206-4239-82fc-27d20fa02cc8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 13:13:59
7985	9d52e58b-8b10-485e-8f82-1cbb0612fce1	9d52e58b-9206-4239-82fc-27d20fa02cc8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc","time":"47.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 13:14:00
7986	9d52e58b-8b63-4274-a38f-f2e3a815d069	9d52e58b-9206-4239-82fc-27d20fa02cc8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:14:00
7987	9d52e58b-8cf6-4d7d-8a7c-a90a94a4e52b	9d52e58b-9206-4239-82fc-27d20fa02cc8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6'","time":"1.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 13:14:00
7988	9d52e58b-8d2e-4a41-b60d-b96dc9e26784	9d52e58b-9206-4239-82fc-27d20fa02cc8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:14:00
7989	9d52e58b-90e5-4848-8601-f4f76d4f2e2a	9d52e58b-9206-4239-82fc-27d20fa02cc8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 13:14:00
7990	9d52e58b-9130-4f57-8d98-8c3aa8062b8b	9d52e58b-9206-4239-82fc-27d20fa02cc8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:14:00
9770	9d56ac8f-78e2-4582-b021-4472dc2f8a5f	9d56ac8f-96cb-4353-8fe3-983eddef0874	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 10:17:58
9771	9d56ac8f-9223-41af-988c-287b89bba63d	9d56ac8f-96cb-4353-8fe3-983eddef0874	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-26 10:17:58
9772	9d56ac8f-926b-4f5b-a4bc-87ab58cbb4fa	9d56ac8f-96cb-4353-8fe3-983eddef0874	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-26 10:17:58
9773	9d56ac8f-95cd-4148-a6b1-10ea32348828	9d56ac8f-96cb-4353-8fe3-983eddef0874	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 10:17:58
9774	9d56ac8f-960c-45fa-aec4-499e887aad57	9d56ac8f-96cb-4353-8fe3-983eddef0874	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:17:58
13371	9d5cfd07-5776-4bf9-ac3e-f37d773d008b	9d5cfd07-72c0-4532-8258-55f50ed46f5d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 13:37:56
11015	9d5ca7d7-4e80-41ec-a673-e162732b6e5b	9d5ca7d7-9958-4f83-8194-36d4a9fa44ce	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 09:39:44
11016	9d5ca7d7-9758-4da8-bf80-83d625169cad	9d5ca7d7-9958-4f83-8194-36d4a9fa44ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 09:39:44
11017	9d5ca7d7-981b-4700-84f6-5f627f1deea7	9d5ca7d7-9958-4f83-8194-36d4a9fa44ce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":346,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:39:44
11107	9d5cab16-6755-477c-97ea-255251cb4d5c	9d5cab16-b76d-4c5d-971e-a27dc2481dbe	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 09:48:49
11108	9d5cab16-b549-4a5b-a3fb-3c18f77c4e2e	9d5cab16-b76d-4c5d-971e-a27dc2481dbe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 09:48:49
11109	9d5cab16-b660-43ee-8249-c49e7f07f419	9d5cab16-b76d-4c5d-971e-a27dc2481dbe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":378,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:48:49
13372	9d5cfd07-6ec9-47b3-9341-0a0eb053e20d	9d5cfd07-72c0-4532-8258-55f50ed46f5d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ma%' or \\"users\\".\\"user_document\\"::text like '%Ma%') order by \\"users\\".\\"user_document\\" asc","time":"41.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 13:37:56
13373	9d5cfd07-7196-4c66-9f8f-33b5f1681d08	9d5cfd07-72c0-4532-8258-55f50ed46f5d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 13:37:56
13374	9d5cfd07-71d7-4e9d-9293-c730242b9eb8	9d5cfd07-72c0-4532-8258-55f50ed46f5d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ma"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":219,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:37:56
7991	9d52e58d-7d9b-4cf4-bdf6-b63c8bb672c7	9d52e58d-c3db-4b2e-bce6-f746a4f2ae58	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 13:14:01
7992	9d52e58d-be1d-41c8-bfb8-06b9c12f361e	9d52e58d-c3db-4b2e-bce6-f746a4f2ae58	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"141.09","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:14:01
7993	9d52e58d-be87-4dda-8341-4047f50d55cc	9d52e58d-c3db-4b2e-bce6-f746a4f2ae58	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:14:01
7994	9d52e58d-c288-4507-a802-660a3ca0b844	9d52e58d-c3db-4b2e-bce6-f746a4f2ae58	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-24 13:14:01
7995	9d52e58d-c2cf-4e51-9e3c-2d18f8ce2b4f	9d52e58d-c3db-4b2e-bce6-f746a4f2ae58	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":414,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:14:01
9775	9d56ac8f-d7b2-4b9e-be23-8c22aa498971	9d56ac90-1bd1-40f8-8b2e-58f9a86021f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 10:17:58
9776	9d56ac90-1741-4ea7-9ae3-c8a0b0d92c52	9d56ac90-1bd1-40f8-8b2e-58f9a86021f6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"142.02","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-26 10:17:58
9777	9d56ac90-1799-482e-8401-3b2217cb08fa	9d56ac90-1bd1-40f8-8b2e-58f9a86021f6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-26 10:17:58
9778	9d56ac90-1ad9-4fd1-ae38-be8056422bfe	9d56ac90-1bd1-40f8-8b2e-58f9a86021f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 10:17:58
9779	9d56ac90-1b1a-4725-aca0-fe66837343e1	9d56ac90-1bd1-40f8-8b2e-58f9a86021f6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":327,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:17:58
11018	9d5ca7d8-1cf9-4ee9-98e1-e05608fd1520	9d5ca7d8-606b-4d33-8dff-fa73f064e9c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 09:39:45
11019	9d5ca7d8-5bdb-433e-9cb5-c6e143476e87	9d5ca7d8-606b-4d33-8dff-fa73f064e9c3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"148.75","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-29 09:39:45
11020	9d5ca7d8-5f11-4683-a037-dd515fca3e28	9d5ca7d8-606b-4d33-8dff-fa73f064e9c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 09:39:45
11021	9d5ca7d8-5f6d-415f-a300-8d8e618f09b4	9d5ca7d8-606b-4d33-8dff-fa73f064e9c3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":478,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:39:45
11110	9d5cab17-d1ee-4ac8-9cbd-42878cdf92eb	9d5cab17-fbc3-4693-9a7e-7faae749f204	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 09:48:50
9780	9d56ac90-5f26-4387-8b67-98fb81568970	9d56ac90-7c91-4355-a898-19b1c877e736	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 10:17:58
9781	9d56ac90-75db-413c-b49c-c1949bcfdc14	9d56ac90-7c91-4355-a898-19b1c877e736	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '1' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"39.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-26 10:17:58
9782	9d56ac90-7628-4f49-8482-59fefefa03e8	9d56ac90-7c91-4355-a898-19b1c877e736	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-26 10:17:58
9783	9d56ac90-779c-487f-be47-3671a49bb0c4	9d56ac90-7c91-4355-a898-19b1c877e736	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1' order by \\"item_loans\\".\\"id\\" asc","time":"1.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-26 10:17:58
9784	9d56ac90-77cc-4413-935e-5f25414889cb	9d56ac90-7c91-4355-a898-19b1c877e736	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-26 10:17:58
9785	9d56ac90-7b76-48f9-8d4e-087721c3b576	9d56ac90-7c91-4355-a898-19b1c877e736	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-26 10:17:58
9786	9d56ac90-7bc9-437b-9dba-826f135c4778	9d56ac90-7c91-4355-a898-19b1c877e736	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":1,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]}},"duration":228,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:17:58
11022	9d5ca7d9-fd3b-4492-a7b0-5ce5eebed2e6	9d5ca7da-1ba9-4c85-a63b-52f01c53c7bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 09:39:46
11023	9d5ca7da-1697-4078-a7f2-230d3a5552f0	9d5ca7da-1ba9-4c85-a63b-52f01c53c7bd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 09:39:46
11024	9d5ca7da-16e8-488e-80c4-09c0412b6be1	9d5ca7da-1ba9-4c85-a63b-52f01c53c7bd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 09:39:46
11025	9d5ca7da-1a68-4dcd-be8f-4504b1c6fffd	9d5ca7da-1ba9-4c85-a63b-52f01c53c7bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 09:39:46
11026	9d5ca7da-1aac-4ffd-85fc-f14b68de881d	9d5ca7da-1ba9-4c85-a63b-52f01c53c7bd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":220,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:39:46
11111	9d5cab17-ee95-447c-8c99-908b1434b476	9d5cab17-fbc3-4693-9a7e-7faae749f204	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 1\\n                        ","time":"53.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"2bd5a29c69f6bbb290fc49b79286632e","hostname":"EderCortes"}	2024-10-29 09:48:50
11112	9d5cab17-f2e9-4ed6-b5bf-fd3cb2e7973d	9d5cab17-fbc3-4693-9a7e-7faae749f204	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1' order by \\"item_loans\\".\\"id\\" asc","time":"2.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 09:48:50
11113	9d5cab17-f330-400e-be0a-a0632b0079c7	9d5cab17-fbc3-4693-9a7e-7faae749f204	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 09:48:50
11114	9d5cab17-f9e1-45bd-a017-27039aa7952a	9d5cab17-fbc3-4693-9a7e-7faae749f204	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 09:48:50
9787	9d56ac92-14c6-4888-8d1a-77fc10aa00ed	9d56ac92-469f-4841-82bf-752a4305293c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-26 10:18:00
9788	9d56ac92-3db1-4198-97b5-78be14afcd98	9d56ac92-469f-4841-82bf-752a4305293c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"62.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 10:18:00
9789	9d56ac92-3e16-40b2-9b64-a35eacd50cc4	9d56ac92-469f-4841-82bf-752a4305293c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 10:18:00
9790	9d56ac92-444f-4192-b5af-a3bccd65a350	9d56ac92-469f-4841-82bf-752a4305293c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-26 10:18:00
5103	9d513676-650c-4fda-b4d9-a68af14712a3	9d513676-a976-414f-af4e-2f61176ddd7f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-23 17:08:36
5104	9d513676-a63b-424d-9c66-a397801dc034	9d513676-a976-414f-af4e-2f61176ddd7f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-23 17:08:36
5105	9d513676-a791-40e7-983e-3064dce6d02e	9d513676-a976-414f-af4e-2f61176ddd7f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":551,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:36
9791	9d56ac92-44e0-4673-a0f8-72e3a25ad043	9d56ac92-469f-4841-82bf-752a4305293c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":450,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:18:00
11115	9d5cab17-fa62-4ccd-b425-a0f6086359bb	9d5cab17-fbc3-4693-9a7e-7faae749f204	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":1,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]}},"duration":793,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:48:50
13375	9d5cfd07-ace5-4414-b901-e8d551debdd7	9d5cfd07-b005-4596-8778-a80a49600d1b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":137,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:37:56
14335	9d5d1e02-2885-401f-87e3-a20df6c282f9	9d5d1e02-6e29-4d9c-94c8-bd1536e30a73	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 15:10:09
14336	9d5d1e02-5ba9-4013-a126-a204e0e5f9a9	9d5d1e02-6e29-4d9c-94c8-bd1536e30a73	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"75.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 15:10:09
14337	9d5d1e02-5c4f-442d-97ea-c621e6dbf540	9d5d1e02-6e29-4d9c-94c8-bd1536e30a73	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 15:10:09
14338	9d5d1e02-68cb-4eed-98e6-d8a7c02b9743	9d5d1e02-6e29-4d9c-94c8-bd1536e30a73	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 15:10:09
14339	9d5d1e02-697f-4bb0-a85c-2072e2c58848	9d5d1e02-6e29-4d9c-94c8-bd1536e30a73	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":724,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:10:09
11116	9d5cab19-ba1c-4283-ad7d-aa348d7e8bce	9d5cab19-dd6a-4629-9f8d-c2db9fdbbf41	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 09:48:51
11117	9d5cab19-d6e3-4d26-8fe7-8d86cb249179	9d5cab19-dd6a-4629-9f8d-c2db9fdbbf41	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 09:48:51
11118	9d5cab19-d735-4625-880a-d958330e19df	9d5cab19-dd6a-4629-9f8d-c2db9fdbbf41	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 09:48:51
11119	9d5cab19-dbab-4a7c-a62a-7d0c4f3dc859	9d5cab19-dd6a-4629-9f8d-c2db9fdbbf41	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 09:48:51
11120	9d5cab19-dc11-4e13-adc1-0eb48ac78112	9d5cab19-dd6a-4629-9f8d-c2db9fdbbf41	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:48:51
13376	9d5cfd08-00f8-4f32-9d08-3fff23074c4a	9d5cfd08-1c3a-4256-a5ac-ec9ff7b2742f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 13:37:57
13377	9d5cfd08-180f-4c11-a0f7-87e0ef0dba91	9d5cfd08-1c3a-4256-a5ac-ec9ff7b2742f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maa%' or \\"users\\".\\"user_document\\"::text like '%Maa%') order by \\"users\\".\\"user_document\\" asc","time":"42.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 13:37:57
13378	9d5cfd08-1b09-4be4-a8ad-2fe04d5a0de6	9d5cfd08-1c3a-4256-a5ac-ec9ff7b2742f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 13:37:57
13379	9d5cfd08-1b4a-4b74-9ab3-e4864dc1eb7d	9d5cfd08-1c3a-4256-a5ac-ec9ff7b2742f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maa"},"session":[],"response_status":200,"response":{"data":[]},"duration":223,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:37:57
13380	9d5cfd08-5d0d-46ef-af12-57f926adafcd	9d5cfd08-6019-48c8-b986-bc4dbc5cbca7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":147,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:37:57
14516	9d5eb96f-057c-479d-a7af-06b5e127529f	9d5eb96f-2461-4e72-8ba8-c8622271a142	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-30 10:20:35
14517	9d5eb96f-229b-4a0d-a5c8-aa8ac866acab	9d5eb96f-2461-4e72-8ba8-c8622271a142	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-30 10:20:35
14518	9d5eb96f-233d-4d68-bf47-ed440e9d42a4	9d5eb96f-2461-4e72-8ba8-c8622271a142	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":296,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:20:35
18751	9d669b7e-906d-45bf-b921-55cda4539a46	9d669b7e-be80-4604-aa87-3e3f5dc7e285	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 08:23:29
18752	9d669b7e-bc3e-4636-8196-738ef7ef5b8f	9d669b7e-be80-4604-aa87-3e3f5dc7e285	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:23:29
18753	9d669b7e-bd39-4a7b-a7f9-ecfa5efec2ff	9d669b7e-be80-4604-aa87-3e3f5dc7e285	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":413,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:23:29
14519	9d5eb980-bc23-42f4-a0ed-48bcdb9bcab2	9d5eb980-bf2c-48e5-9bbb-739a39024883	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":139,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:20:47
9949	9d56c462-17a7-437c-bc7f-ec7912f9be06	9d56c462-640b-4107-bf96-96b93c0c0b9c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 11:24:35
9950	9d56c462-624d-4a6a-aaa6-aed0a323ef7b	9d56c462-640b-4107-bf96-96b93c0c0b9c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:24:35
9951	9d56c462-6300-4401-95df-0d28c642b875	9d56c462-640b-4107-bf96-96b93c0c0b9c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":464,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:24:35
18802	9d669c23-2731-40b7-97e5-bbb6be471a60	9d669c23-74a1-4f97-8611-926f78925d35	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 08:25:17
18803	9d669c23-72e0-4bcc-af47-96ecd9d56d20	9d669c23-74a1-4f97-8611-926f78925d35	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 08:25:17
13381	9d5cfd08-d240-408e-a102-88ca362f3133	9d5cfd08-ebe9-4666-81a1-e697cdd891ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 13:37:57
13382	9d5cfd08-e828-4e14-91c2-efb49e2b5198	9d5cfd08-ebe9-4666-81a1-e697cdd891ae	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maar%' or \\"users\\".\\"user_document\\"::text like '%Maar%') order by \\"users\\".\\"user_document\\" asc","time":"40.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 13:37:57
13383	9d5cfd08-ead9-441c-acdf-1f93f3708eed	9d5cfd08-ebe9-4666-81a1-e697cdd891ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 13:37:57
18804	9d669c23-738f-4b91-bd72-5b42097d6572	9d669c23-74a1-4f97-8611-926f78925d35	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":416,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:25:17
13384	9d5cfd08-eb19-44bf-9425-29246a60d55e	9d5cfd08-ebe9-4666-81a1-e697cdd891ae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maar"},"session":[],"response_status":200,"response":{"data":[]},"duration":199,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:37:57
14520	9d5eb981-3ad0-40b7-9e7b-7d818d626565	9d5eb981-6453-4364-b66d-e634fcd88c1f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-30 10:20:47
9952	9d56c464-4c62-4aad-97db-6ac1c13fc031	9d56c464-975c-4abd-841f-f228e904a0d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:24:36
8889	9d52efdf-8c41-4c1f-984c-35d833474da4	9d52efdf-b504-498a-bcd1-cb2d9bc08bde	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 13:42:52
8890	9d52efdf-b29e-4fd7-b408-0e08bbacad49	9d52efdf-b504-498a-bcd1-cb2d9bc08bde	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:42:52
8891	9d52efdf-b3c1-4d97-8491-67ba9c5401ef	9d52efdf-b504-498a-bcd1-cb2d9bc08bde	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":308,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:42:52
14521	9d5eb981-5eaf-4ffc-ac2b-4c7c7d81cba1	9d5eb981-6453-4364-b66d-e634fcd88c1f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortes10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"44.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-30 10:20:47
9953	9d56c464-9146-40a3-b470-5611b6dd688b	9d56c464-975c-4abd-841f-f228e904a0d0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"152.58","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:24:36
9954	9d56c464-9192-4f44-9e9b-810945da39fa	9d56c464-975c-4abd-841f-f228e904a0d0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:24:36
9955	9d56c464-955b-464e-a360-16c55302e998	9d56c464-975c-4abd-841f-f228e904a0d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:24:36
9956	9d56c464-95f1-493d-84b2-c76d995864da	9d56c464-975c-4abd-841f-f228e904a0d0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":448,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:24:36
14522	9d5eb981-62e8-499c-94e1-70abd9b21655	9d5eb981-6453-4364-b66d-e634fcd88c1f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 10:20:47
14523	9d5eb981-6345-49e4-ab39-27a8457d5869	9d5eb981-6453-4364-b66d-e634fcd88c1f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"80","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortes10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":257,"memory":24,"hostname":"EderCortes"}	2024-10-30 10:20:47
18805	9d669c23-ce0f-4466-90c5-3d6869059dbd	9d669c23-f162-4ecd-8f64-fcda93e2ea1f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 08:25:18
18806	9d669c23-eaa1-400a-9028-1ab935013698	9d669c23-f162-4ecd-8f64-fcda93e2ea1f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"52.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 08:25:18
18807	9d669c23-efd4-4c6f-8e13-f03d7cd04e6d	9d669c23-f162-4ecd-8f64-fcda93e2ea1f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 08:25:18
8892	9d52efe0-266c-4eac-b023-764c9730a995	9d52efe0-4a92-4c42-ae6e-ec1738a69f8b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:42:53
8893	9d52efe0-43a9-4e40-ae70-ef27d6b3f747	9d52efe0-4a92-4c42-ae6e-ec1738a69f8b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:42:53
8894	9d52efe0-442a-4071-9d65-78e1ab1592b2	9d52efe0-4a92-4c42-ae6e-ec1738a69f8b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:42:53
8895	9d52efe0-4948-4752-9702-efa48763db64	9d52efe0-4a92-4c42-ae6e-ec1738a69f8b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:42:53
8896	9d52efe0-4996-4496-80e7-4ae39dbc6257	9d52efe0-4a92-4c42-ae6e-ec1738a69f8b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":346,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:42:53
13385	9d5cfd09-2b25-40eb-ac73-cdb16e617aac	9d5cfd09-7164-49d6-8745-56bc949ba070	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 13:37:57
13386	9d5cfd09-6bfc-4830-9265-7d20714e5259	9d5cfd09-7164-49d6-8745-56bc949ba070	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maari%' or \\"users\\".\\"user_document\\"::text like '%Maari%') order by \\"users\\".\\"user_document\\" asc","time":"148.48","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 13:37:58
13387	9d5cfd09-6ffc-4763-8edb-df58e381156a	9d5cfd09-7164-49d6-8745-56bc949ba070	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 13:37:58
13388	9d5cfd09-704f-4f57-a4b6-dcc66d00114e	9d5cfd09-7164-49d6-8745-56bc949ba070	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maari"},"session":[],"response_status":200,"response":{"data":[]},"duration":332,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:37:58
14524	9d5eb9ab-9e13-411d-84aa-4a9be151be08	9d5eb9ab-a3ce-444a-ba68-ea2d10034ef0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":260,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:21:15
15233	9d5ecf4f-90ff-4683-b0fa-22d86f798376	9d5ecf4f-ba65-42f4-89ac-2bdba96b037d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-30 11:21:45
15234	9d5ecf4f-b370-41a9-bcb0-076c77a686f7	9d5ecf4f-ba65-42f4-89ac-2bdba96b037d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"58.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 11:21:45
15235	9d5ecf4f-b3e3-40f6-9976-bfe7ec0e0e49	9d5ecf4f-ba65-42f4-89ac-2bdba96b037d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-30 11:21:45
15236	9d5ecf4f-b8ca-464c-b4bd-5fe56db786af	9d5ecf4f-ba65-42f4-89ac-2bdba96b037d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-30 11:21:45
15237	9d5ecf4f-b929-4b64-bf0d-939fcf608470	9d5ecf4f-ba65-42f4-89ac-2bdba96b037d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":381,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:21:45
8897	9d52efe0-9fed-4872-8881-54625dc8ad46	9d52efe0-c89f-4864-8db8-1057795b2401	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:42:53
8898	9d52efe0-c0fc-44e5-b402-f4c8bf22249d	9d52efe0-c89f-4864-8db8-1057795b2401	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"55.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:42:53
8899	9d52efe0-c178-4eae-9c36-57846ba4d877	9d52efe0-c89f-4864-8db8-1057795b2401	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:42:53
8900	9d52efe0-c6ea-4846-9973-0c3408081c6f	9d52efe0-c89f-4864-8db8-1057795b2401	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:42:53
8901	9d52efe0-c750-4eff-a052-2741c1748d31	9d52efe0-c89f-4864-8db8-1057795b2401	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":301,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:42:53
13389	9d5cfd09-cd1d-48be-80bd-2b864ba3cc62	9d5cfd0a-1087-4d11-a6d1-2f9638007a1c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 13:37:58
13390	9d5cfd0a-0c65-4ac8-99dd-c0b51d98534f	9d5cfd0a-1087-4d11-a6d1-2f9638007a1c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maaria%' or \\"users\\".\\"user_document\\"::text like '%Maaria%') order by \\"users\\".\\"user_document\\" asc","time":"141.13","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 13:37:58
13391	9d5cfd0a-0f48-41a6-a23f-506e576a9d62	9d5cfd0a-1087-4d11-a6d1-2f9638007a1c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-29 13:37:58
13392	9d5cfd0a-0f88-4ebc-986d-4161cfd85979	9d5cfd0a-1087-4d11-a6d1-2f9638007a1c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"28","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maaria"},"session":[],"response_status":200,"response":{"data":[]},"duration":390,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:37:58
14525	9d5eb9ac-658c-457e-b347-10b6d4b26b94	9d5eb9ac-b7fa-4135-8275-39af9a61f8ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 10:21:15
14526	9d5eb9ac-b2da-44bc-8b4e-a892be95e0e5	9d5eb9ac-b7fa-4135-8275-39af9a61f8ea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortes10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"149.81","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-30 10:21:15
14527	9d5eb9ac-b6b8-4c1f-b232-dce5907a75e1	9d5eb9ac-b7fa-4135-8275-39af9a61f8ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 10:21:15
14528	9d5eb9ac-b6fd-4931-9e1c-73dc130f2fe5	9d5eb9ac-b7fa-4135-8275-39af9a61f8ea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"78","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortes10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":400,"memory":24,"hostname":"EderCortes"}	2024-10-30 10:21:15
15238	9d5ecf50-11e5-4760-8f36-fcab9f0229a8	9d5ecf50-5b9d-4a25-8a24-1f59becff0b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-30 11:21:46
15239	9d5ecf50-55b8-4685-8fb9-f34e1891a473	9d5ecf50-5b9d-4a25-8a24-1f59becff0b3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"151.59","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 11:21:46
15240	9d5ecf50-561c-460b-94e4-f051677f4226	9d5ecf50-5b9d-4a25-8a24-1f59becff0b3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-30 11:21:46
15241	9d5ecf50-5a42-4c77-a76f-e5ad58f4d709	9d5ecf50-5b9d-4a25-8a24-1f59becff0b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-30 11:21:46
14529	9d5eb9b1-d44f-432d-abe7-683a3491ab2b	9d5eb9b1-d8bb-4b18-b544-e6dbc33be93c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":205,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:21:19
18808	9d669c23-f042-4bf9-9fb1-e34423a07238	9d669c23-f162-4ecd-8f64-fcda93e2ea1f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":278,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:25:18
8101	9d52e6f6-3658-4bc9-8792-ba3800e1448e	9d52e6f6-6589-409c-b0b0-bd386fb5be41	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 13:17:57
8102	9d52e6f6-62f1-431a-b02c-8258b7911c99	9d52e6f6-6589-409c-b0b0-bd386fb5be41	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:17:57
8103	9d52e6f6-642d-47bf-8af7-59bd64b770f6	9d52e6f6-6589-409c-b0b0-bd386fb5be41	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":312,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:17:57
13393	9d5cfd0b-2dfe-49b2-a401-9ca7c07d870f	9d5cfd0b-313d-4a10-a72b-0630da469417	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":133,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:37:59
8902	9d52efe1-20d5-43df-a1dd-920e29309f2f	9d52efe1-6abc-427f-a5d4-963bf3611d43	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:42:53
8104	9d52e6f6-df8a-4d1c-a941-6823ff7be0d7	9d52e6f7-082a-4c79-b76f-1408ede66f7a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:17:58
8105	9d52e6f6-fec1-4d0c-b26f-d4ed96785274	9d52e6f7-082a-4c79-b76f-1408ede66f7a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:17:58
8106	9d52e6f6-ff1e-47ff-9cc9-439f0e7333c6	9d52e6f7-082a-4c79-b76f-1408ede66f7a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:17:58
8107	9d52e6f7-0603-47d7-99e3-246cee6520cb	9d52e6f7-082a-4c79-b76f-1408ede66f7a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:17:58
8108	9d52e6f7-0693-4595-818f-089f70177aff	9d52e6f7-082a-4c79-b76f-1408ede66f7a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:17:58
8903	9d52efe1-63dd-4486-89d1-f4c73df20f0b	9d52efe1-6abc-427f-a5d4-963bf3611d43	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"146.19","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-24 13:42:54
8904	9d52efe1-6436-4be3-b250-fe474a2381ca	9d52efe1-6abc-427f-a5d4-963bf3611d43	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:42:54
8905	9d52efe1-65f4-461f-89fa-53db44dac8a7	9d52efe1-6abc-427f-a5d4-963bf3611d43	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"2.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 13:42:54
8906	9d52efe1-6624-4cb5-9910-ff50664ac2f8	9d52efe1-6abc-427f-a5d4-963bf3611d43	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:42:54
8907	9d52efe1-6971-4feb-b296-244bd673a705	9d52efe1-6abc-427f-a5d4-963bf3611d43	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:42:54
8908	9d52efe1-69b9-4dfd-a8d1-06e7ef93d31f	9d52efe1-6abc-427f-a5d4-963bf3611d43	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":398,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:42:54
13394	9d5cfd0b-9a04-4e8e-899e-d16943eb11c4	9d5cfd0b-b4e5-4928-b755-a167fe1c334f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-29 13:37:59
13395	9d5cfd0b-b097-4232-99dc-3c9bfd509922	9d5cfd0b-b4e5-4928-b755-a167fe1c334f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"40.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 13:37:59
13396	9d5cfd0b-b371-4e2d-b33f-98a701abfbdc	9d5cfd0b-b4e5-4928-b755-a167fe1c334f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-29 13:37:59
13397	9d5cfd0b-b3c7-4f91-9df3-d60a5e4fef36	9d5cfd0b-b4e5-4928-b755-a167fe1c334f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":220,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:37:59
14530	9d5eb9b2-9505-411a-92d6-dfc92b65b91f	9d5eb9b2-bd31-412b-bb3a-36cd9ed68513	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 10:21:19
14531	9d5eb9b2-b790-4329-883b-fb9bace2ae33	9d5eb9b2-bd31-412b-bb3a-36cd9ed68513	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortes10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"49.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-30 10:21:19
14532	9d5eb9b2-bbf0-492c-91a0-7f6a35f03468	9d5eb9b2-bd31-412b-bb3a-36cd9ed68513	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 10:21:19
18809	9d669c25-e90c-4937-9dcf-9f62d0d61327	9d669c26-10ab-4c42-98a4-62fb30f97660	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 08:25:19
8109	9d52e6f7-6b0d-42bd-b2c1-9445a3c61eb1	9d52e6f7-8e90-48b4-b9d7-552e910b2f79	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:17:58
8110	9d52e6f7-88bd-4380-a5de-665411bbecf2	9d52e6f7-8e90-48b4-b9d7-552e910b2f79	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:17:58
8111	9d52e6f7-8919-4ace-9aae-962d15c3223a	9d52e6f7-8e90-48b4-b9d7-552e910b2f79	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:17:58
8112	9d52e6f7-8d51-45c9-9100-e21a965aca98	9d52e6f7-8e90-48b4-b9d7-552e910b2f79	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:17:58
8113	9d52e6f7-8da0-48b5-bc50-0c6ec5c5b13b	9d52e6f7-8e90-48b4-b9d7-552e910b2f79	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":320,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:17:58
8909	9d52efe3-775b-4b76-9d3d-36e37d8cbfb7	9d52efe3-9c5c-4f51-9906-0985f0afd257	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:42:55
8910	9d52efe3-94a4-4818-b462-61034fe963d6	9d52efe3-9c5c-4f51-9906-0985f0afd257	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:42:55
8911	9d52efe3-9541-4fb6-a156-0ff6f00d77aa	9d52efe3-9c5c-4f51-9906-0985f0afd257	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:42:55
8912	9d52efe3-9a4a-42d0-8273-f070e9b5d3f5	9d52efe3-9c5c-4f51-9906-0985f0afd257	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:42:55
8913	9d52efe3-9adc-4fa8-9543-f67ede0cc99e	9d52efe3-9c5c-4f51-9906-0985f0afd257	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":355,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:42:55
13398	9d5cfd0d-5c38-4c50-ab28-c17643b83d73	9d5cfd0d-7951-4157-a974-958ea20ac81e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-29 13:38:00
13399	9d5cfd0d-7477-43c0-ad52-6cb848361d38	9d5cfd0d-7951-4157-a974-958ea20ac81e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '18' and \\"users\\".\\"deleted_at\\" is null","time":"40.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":55,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-29 13:38:00
13400	9d5cfd0d-74c8-40b9-9d0a-c515daaf013d	9d5cfd0d-7951-4157-a974-958ea20ac81e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 13:38:00
13401	9d5cfd0d-783a-47dc-ab63-14a7fe494607	9d5cfd0d-7951-4157-a974-958ea20ac81e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-29 13:38:00
13402	9d5cfd0d-7879-40a2-be82-62726c1d85f9	9d5cfd0d-7951-4157-a974-958ea20ac81e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/18","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:38:00
7440	9d52dd73-46cb-42b9-af0b-94a001b4b1ab	9d52dd73-940b-48e6-ae7f-d8ef796116e2	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 12:51:21
7441	9d52dd73-91e4-448d-86d0-0708c0a79f9e	9d52dd73-940b-48e6-ae7f-d8ef796116e2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:51:22
7442	9d52dd73-929c-45a0-853e-1eff0add8249	9d52dd73-940b-48e6-ae7f-d8ef796116e2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":377,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:51:22
18810	9d669c26-0a8d-4e9f-92cf-296a49763504	9d669c26-10ab-4c42-98a4-62fb30f97660	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"56.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 08:25:19
8114	9d52e6f7-e5fa-4b29-baa7-5680ce299a65	9d52e6f8-0af9-4920-9ee1-70b5462c3a41	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:17:58
18811	9d669c26-0ae8-4271-80f1-3d9338a31508	9d669c26-10ab-4c42-98a4-62fb30f97660	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 08:25:19
8115	9d52e6f8-0409-453b-b47d-53cefb5a1b32	9d52e6f8-0af9-4920-9ee1-70b5462c3a41	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc","time":"47.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 13:17:58
8116	9d52e6f8-0454-417b-93f2-512ecfc75157	9d52e6f8-0af9-4920-9ee1-70b5462c3a41	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:17:58
8117	9d52e6f8-0627-4f32-a75c-7741f019be09	9d52e6f8-0af9-4920-9ee1-70b5462c3a41	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6'","time":"2.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 13:17:58
8118	9d52e6f8-065b-443e-aec0-607f06231e59	9d52e6f8-0af9-4920-9ee1-70b5462c3a41	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:17:58
8119	9d52e6f8-09c8-42b9-865a-76035b9f0b1b	9d52e6f8-0af9-4920-9ee1-70b5462c3a41	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:17:58
18812	9d669c26-0f14-4622-a0cd-9b32d5ed54fe	9d669c26-10ab-4c42-98a4-62fb30f97660	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 08:25:19
7443	9d52dd73-e691-4841-a44a-f48725151e16	9d52dd74-0561-454f-911f-3b4299b52f40	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 12:51:22
7444	9d52dd74-002a-46cc-8050-c173c10349cf	9d52dd74-0561-454f-911f-3b4299b52f40	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:51:22
7445	9d52dd74-0076-479f-bd91-dc4c5b5ad77f	9d52dd74-0561-454f-911f-3b4299b52f40	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:51:22
7446	9d52dd74-0436-4d8c-bd21-675ef7ba6129	9d52dd74-0561-454f-911f-3b4299b52f40	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:51:22
7447	9d52dd74-0481-4bcc-8e67-0664786a804c	9d52dd74-0561-454f-911f-3b4299b52f40	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":262,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:51:22
8120	9d52e6f8-0a14-4de9-8f7d-d03717a73fb1	9d52e6f8-0af9-4920-9ee1-70b5462c3a41	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":299,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:17:58
13403	9d5cfd34-4748-4883-994e-790010908e7c	9d5cfd34-4a70-4b81-8f22-b377cd2199b4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":133,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:38:26
14533	9d5eb9b2-bc3c-4b2c-bb61-29f0bdccb746	9d5eb9b2-bd31-412b-bb3a-36cd9ed68513	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortes10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":281,"memory":24,"hostname":"EderCortes"}	2024-10-30 10:21:19
18813	9d669c26-0f6f-4c54-8e21-c11c76f5c7af	9d669c26-10ab-4c42-98a4-62fb30f97660	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":458,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:25:19
7448	9d52dd74-4a8e-454a-9b17-be3cd8e01020	9d52dd74-6891-4177-aebe-12443ab94cb3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 12:51:22
7449	9d52dd74-6387-4236-9193-c663381afd7d	9d52dd74-6891-4177-aebe-12443ab94cb3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:51:22
7450	9d52dd74-63d1-40aa-98f6-53fa8c3ce1c0	9d52dd74-6891-4177-aebe-12443ab94cb3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:51:22
7451	9d52dd74-674b-4205-9e6e-114595aeb38d	9d52dd74-6891-4177-aebe-12443ab94cb3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:51:22
7452	9d52dd74-678d-4a42-94f3-d924596aa2ce	9d52dd74-6891-4177-aebe-12443ab94cb3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:51:22
8121	9d52e6fa-28de-4930-a2f1-d12cab3a02ab	9d52e6fa-50f8-441d-a38c-931f73bf1873	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:18:00
8122	9d52e6fa-4ad6-4cd6-bd31-145b18c4511e	9d52e6fa-50f8-441d-a38c-931f73bf1873	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"54.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:18:00
8123	9d52e6fa-4b2b-4db1-be66-2bc32871a57d	9d52e6fa-50f8-441d-a38c-931f73bf1873	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:18:00
8124	9d52e6fa-4f18-46dd-87b1-ff112316d147	9d52e6fa-50f8-441d-a38c-931f73bf1873	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:18:00
8125	9d52e6fa-4f6e-4b99-ac70-27fbd1aac3da	9d52e6fa-50f8-441d-a38c-931f73bf1873	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":394,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:18:00
13404	9d5cfd34-ae13-441f-b30b-8736fde2008d	9d5cfd34-fa6f-4cac-84cc-5653517d1582	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-29 13:38:26
13405	9d5cfd34-f01e-4b2c-baf8-10d13bee61be	9d5cfd34-fa6f-4cac-84cc-5653517d1582	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta', 'De las nieve', 'ds', 'CC', '100465546', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '500000', 25, 7, 'Q', null, '29-10-2024', 'Pendiente', '312596295', 12, 14, 18, 14, '2024-11-12T05:00:00.000Z', '2024-10-29 13:38:26', '2024-10-29 13:38:26') returning \\"id\\"","time":"4.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":103,"hash":"bfad4cea82a73099ff0b3164dd496ca0","hostname":"EderCortes"}	2024-10-29 13:38:26
13406	9d5cfd34-f079-4749-a085-27f973328c32	9d5cfd34-fa6f-4cac-84cc-5653517d1582	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:32","hostname":"EderCortes"}	2024-10-29 13:38:26
13407	9d5cfd34-f20c-42d5-9aed-55893293b502	9d5cfd34-fa6f-4cac-84cc-5653517d1582	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (32, 1, 71428.571428571, 10416.666666667, 'Pendiente', 'N\\/A', '13-11-2024', 12, '2024-10-29 13:38:26', '2024-10-29 13:38:26')","time":"2.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":154,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 13:38:26
13408	9d5cfd34-f23d-4937-ada6-1cdae3d1e291	9d5cfd34-fa6f-4cac-84cc-5653517d1582	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 13:38:26
7453	9d52dd74-a9e5-4769-9096-82291909a6a7	9d52dd74-c7e3-4a85-aba0-fb55abd5d6a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 12:51:22
7454	9d52dd74-c101-4636-828a-aaa1d37d1c29	9d52dd74-c7e3-4a85-aba0-fb55abd5d6a2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"41.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:51:22
7455	9d52dd74-c166-4fa1-aa1a-e9360c6f6907	9d52dd74-c7e3-4a85-aba0-fb55abd5d6a2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:51:22
7456	9d52dd74-c30a-4409-8dd7-a54f171dc062	9d52dd74-c7e3-4a85-aba0-fb55abd5d6a2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"1.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:51:22
7457	9d52dd74-c33c-4e2b-864b-02697392846a	9d52dd74-c7e3-4a85-aba0-fb55abd5d6a2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:51:22
7458	9d52dd74-c6ae-412a-aef4-9aeb59ba54a0	9d52dd74-c7e3-4a85-aba0-fb55abd5d6a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:51:22
7459	9d52dd74-c6fe-4a5d-b8d6-fd5a00561b0f	9d52dd74-c7e3-4a85-aba0-fb55abd5d6a2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:51:22
13409	9d5cfd34-f2b0-436a-ad09-07c79cd739ae	9d5cfd34-fa6f-4cac-84cc-5653517d1582	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (32, 2, 71428.571428571, 10416.666666667, 'Pendiente', 'N\\/A', '28-11-2024', 12, '2024-10-29 13:38:26', '2024-10-29 13:38:26')","time":"0.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":154,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 13:38:26
13410	9d5cfd34-f2d1-47e9-a300-d3c179ad30d3	9d5cfd34-fa6f-4cac-84cc-5653517d1582	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 13:38:26
13411	9d5cfd34-f344-433f-b85b-e9ae3505ee04	9d5cfd34-fa6f-4cac-84cc-5653517d1582	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (32, 3, 71428.571428571, 10416.666666667, 'Pendiente', 'N\\/A', '13-12-2024', 12, '2024-10-29 13:38:26', '2024-10-29 13:38:26')","time":"0.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":154,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 13:38:26
13412	9d5cfd34-f367-4233-8849-a4c513297444	9d5cfd34-fa6f-4cac-84cc-5653517d1582	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 13:38:26
13413	9d5cfd34-f3cd-4d85-9254-960d05748e8b	9d5cfd34-fa6f-4cac-84cc-5653517d1582	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (32, 4, 71428.571428571, 10416.666666667, 'Pendiente', 'N\\/A', '28-12-2024', 12, '2024-10-29 13:38:26', '2024-10-29 13:38:26')","time":"0.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":154,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 13:38:26
13414	9d5cfd34-f3eb-478b-ad49-ddc25c5f063e	9d5cfd34-fa6f-4cac-84cc-5653517d1582	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 13:38:26
13415	9d5cfd34-f456-4e8f-9bcf-0b60580b1080	9d5cfd34-fa6f-4cac-84cc-5653517d1582	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (32, 5, 71428.571428571, 10416.666666667, 'Pendiente', 'N\\/A', '12-01-2025', 12, '2024-10-29 13:38:26', '2024-10-29 13:38:26')","time":"0.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":154,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 13:38:26
13416	9d5cfd34-f477-4489-af5f-c4e9b0419fef	9d5cfd34-fa6f-4cac-84cc-5653517d1582	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 13:38:26
13417	9d5cfd34-f4d8-4fbe-8da9-d53457b37afa	9d5cfd34-fa6f-4cac-84cc-5653517d1582	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (32, 6, 71428.571428571, 10416.666666667, 'Pendiente', 'N\\/A', '27-01-2025', 12, '2024-10-29 13:38:26', '2024-10-29 13:38:26')","time":"0.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":154,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 13:38:26
13418	9d5cfd34-f4f7-44bf-be9b-145e686304fb	9d5cfd34-fa6f-4cac-84cc-5653517d1582	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 13:38:26
13419	9d5cfd34-f54a-4c60-9530-d41c4877dab0	9d5cfd34-fa6f-4cac-84cc-5653517d1582	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (32, 7, 71428.571428571, 10416.666666667, 'Pendiente', 'N\\/A', '11-02-2025', 12, '2024-10-29 13:38:26', '2024-10-29 13:38:26')","time":"0.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":154,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 13:38:26
13420	9d5cfd34-f566-46de-81af-72d38ab09927	9d5cfd34-fa6f-4cac-84cc-5653517d1582	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 13:38:26
7460	9d52dd75-f41d-4b78-b92a-0c7793c24653	9d52dd76-4850-48cc-993a-b77cbfa797f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:51:23
7461	9d52dd76-3fde-4008-a339-39137feabc87	9d52dd76-4850-48cc-993a-b77cbfa797f9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"158.18","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:51:23
7462	9d52dd76-4050-4585-8e31-d7ada7febc7f	9d52dd76-4850-48cc-993a-b77cbfa797f9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:51:23
7463	9d52dd76-4650-4102-b2b9-e9d9eb74b4db	9d52dd76-4850-48cc-993a-b77cbfa797f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:51:23
7464	9d52dd76-46d0-44f2-ad93-18605de49efc	9d52dd76-4850-48cc-993a-b77cbfa797f9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":544,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:51:23
13421	9d5cfd34-f933-4916-bc78-3ca43d42fc1c	9d5cfd34-fa6f-4cac-84cc-5653517d1582	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-29 13:38:26
13422	9d5cfd34-f976-4d98-99cb-307cc30de65c	9d5cfd34-fa6f-4cac-84cc-5653517d1582	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"757","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"100465546","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"500000","loans_intereses":25,"loans_cuotas":7,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":18,"user_recomendacion":14,"loans_inicio_pago":"2024-11-12T05:00:00.000Z","created_at":null,"updated_at":null,"deleted_at":null},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Tue Oct 29 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":32},"duration":334,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:38:26
14534	9d5eb9c9-4931-48f3-bdbd-06b039e946a1	9d5eb9c9-4ce9-4026-9b55-797b1ab44346	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":159,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:21:34
14535	9d5eb9ca-0305-43bb-b018-a4c66b2d061c	9d5eb9ca-5f11-4c4f-9de1-26cdba800f23	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 10:21:35
14536	9d5eb9ca-4588-4451-860e-210712fc9534	9d5eb9ca-5f11-4c4f-9de1-26cdba800f23	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"139.39","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-30 10:21:35
14537	9d5eb9ca-45fb-49fa-94ae-eff1302e078b	9d5eb9ca-5f11-4c4f-9de1-26cdba800f23	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-30 10:21:35
14538	9d5eb9ca-5db7-4bcb-a320-c08356c85837	9d5eb9ca-5f11-4c4f-9de1-26cdba800f23	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-30 10:21:35
14539	9d5eb9ca-5dfc-4c30-a0ea-77da97e21c98	9d5eb9ca-5f11-4c4f-9de1-26cdba800f23	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"78","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":387,"memory":24,"hostname":"EderCortes"}	2024-10-30 10:21:35
18891	9d66caf1-c43b-4aac-bba0-56ea4d7c0be5	9d66caf2-3f6e-42d5-acc6-7c45abdb05bf	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 10:36:10
18892	9d66caf2-3c2c-4fd0-800d-33c6ef158ecd	9d66caf2-3f6e-42d5-acc6-7c45abdb05bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 10:36:10
18893	9d66caf2-3dd5-40d6-9964-673d4ec9d11b	9d66caf2-3f6e-42d5-acc6-7c45abdb05bf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":611,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:36:10
18894	9d66caf2-b808-41dd-bf93-1ebad84f9300	9d66caf3-04d9-4053-baee-9c95ff031f17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 10:36:11
18895	9d66caf2-fe56-4ad1-a51c-9802b8a9e930	9d66caf3-04d9-4053-baee-9c95ff031f17	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"161.47","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 10:36:11
18896	9d66caf3-03a6-4378-b3d1-ae7a14a13c19	9d66caf3-04d9-4053-baee-9c95ff031f17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 10:36:11
11197	9d5cac24-d753-45aa-b3d6-35560e23e6e0	9d5cac24-f5a8-4c01-a468-68343f51d234	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 09:51:46
11198	9d5cac24-f3ef-4bc8-81ba-157282b23dd9	9d5cac24-f5a8-4c01-a468-68343f51d234	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 09:51:46
11199	9d5cac24-f4af-45f2-b8dd-fe9bcdd9cd41	9d5cac24-f5a8-4c01-a468-68343f51d234	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:51:46
18897	9d66caf3-03fb-44c3-96df-47251afbcc7d	9d66caf3-04d9-4053-baee-9c95ff031f17	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":391,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:36:11
14540	9d5eb9d1-fa78-4ec3-91a6-471a088b59d4	9d5eb9d1-fecc-4d49-ab54-e2bdb862f3c4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":200,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:21:40
11200	9d5cac25-3cf2-4aff-8f11-0b43ac16e93e	9d5cac25-8519-416b-a59f-0ed5b5c9bf9c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 09:51:46
11201	9d5cac25-7c92-4885-ac4e-da0c36932de5	9d5cac25-8519-416b-a59f-0ed5b5c9bf9c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 1\\n                        ","time":"151.39","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"2bd5a29c69f6bbb290fc49b79286632e","hostname":"EderCortes"}	2024-10-29 09:51:46
11202	9d5cac25-7fe7-4151-adaa-91e88aa3d486	9d5cac25-8519-416b-a59f-0ed5b5c9bf9c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1' order by \\"item_loans\\".\\"id\\" asc","time":"1.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 09:51:46
11203	9d5cac25-8030-473e-8a49-80bbaf3b1ea8	9d5cac25-8519-416b-a59f-0ed5b5c9bf9c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 09:51:46
11204	9d5cac25-83ff-467f-81d0-c2955dd94bdb	9d5cac25-8519-416b-a59f-0ed5b5c9bf9c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 09:51:46
11205	9d5cac25-8445-4a20-8507-0d2506868fee	9d5cac25-8519-416b-a59f-0ed5b5c9bf9c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":1,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]}},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:51:46
14541	9d5eb9d2-b903-4d08-8df7-fc672166b057	9d5eb9d2-f289-4430-9215-899f7191d4ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-30 10:21:40
14542	9d5eb9d2-d7ab-49e8-b5cd-acadf4845864	9d5eb9d2-f289-4430-9215-899f7191d4ef	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"44.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-30 10:21:40
14543	9d5eb9d2-d816-4a2d-aea5-94faff32c15c	9d5eb9d2-f289-4430-9215-899f7191d4ef	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-30 10:21:40
14544	9d5eb9d2-f151-4b3e-ad0f-c826f713cc3b	9d5eb9d2-f289-4430-9215-899f7191d4ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-30 10:21:40
14545	9d5eb9d2-f196-4142-9154-875d1396bcb3	9d5eb9d2-f289-4430-9215-899f7191d4ef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","profile":1},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":310,"memory":24,"hostname":"EderCortes"}	2024-10-30 10:21:40
18898	9d66caf5-4ca7-4f4d-a630-1fbb68739579	9d66caf5-6ffc-42f2-9593-499eb3212548	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 10:36:12
18899	9d66caf5-6a0f-42b5-b88e-6a9ec210649d	9d66caf5-6ffc-42f2-9593-499eb3212548	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"48.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 10:36:13
18900	9d66caf5-6a5b-4930-b57d-abb25c6e388d	9d66caf5-6ffc-42f2-9593-499eb3212548	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 10:36:13
18901	9d66caf5-6e8c-49b8-8b25-3e4e93d6ae6b	9d66caf5-6ffc-42f2-9593-499eb3212548	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 10:36:13
11206	9d5cac27-028e-4eed-aac3-1265a523484b	9d5cac27-49f7-4f83-b3a3-5e40f76cc69a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 09:51:47
11207	9d5cac27-4542-467c-92cd-02980890a4ab	9d5cac27-49f7-4f83-b3a3-5e40f76cc69a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"151.01","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 09:51:48
11208	9d5cac27-4590-4969-bb93-674e962d2aab	9d5cac27-49f7-4f83-b3a3-5e40f76cc69a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 09:51:48
11209	9d5cac27-48b4-4fac-87d2-1bf4c3541153	9d5cac27-49f7-4f83-b3a3-5e40f76cc69a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 09:51:48
11210	9d5cac27-48f5-4efe-93b1-c3ee19c1931a	9d5cac27-49f7-4f83-b3a3-5e40f76cc69a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":350,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:51:48
14546	9d5eb9d3-6290-422d-b3dd-14afc84a4a10	9d5eb9d3-8799-4119-9624-1a8704a6ab96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-30 10:21:41
14547	9d5eb9d3-8065-4d80-be6e-c38a76baa5b6	9d5eb9d3-8799-4119-9624-1a8704a6ab96	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 10:21:41
14548	9d5eb9d3-80d9-4eb1-801f-08ff2afc4549	9d5eb9d3-8799-4119-9624-1a8704a6ab96	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 10:21:41
14549	9d5eb9d3-8641-427a-810f-408b73154447	9d5eb9d3-8799-4119-9624-1a8704a6ab96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-30 10:21:41
14550	9d5eb9d3-8696-4835-bd88-de7a7b991b31	9d5eb9d3-8799-4119-9624-1a8704a6ab96	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":316,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:21:41
18902	9d66caf5-6ed9-4dfa-9514-55f3c08b7323	9d66caf5-6ffc-42f2-9593-499eb3212548	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:36:13
18903	9d66cb49-afc0-412c-b7bc-5516f2e87120	9d66cb49-cf90-430a-9304-635e0ce3b5c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 10:37:08
8413	9d52eb90-77e3-4ae9-a4c2-b010ab8f3828	9d52eb90-98ea-438f-9312-6a20c5c0851b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:30:49
8414	9d52eb90-971c-4f71-8bb5-16c0da68d1a7	9d52eb90-98ea-438f-9312-6a20c5c0851b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:30:50
8415	9d52eb90-980a-49eb-8912-58640ee79e05	9d52eb90-98ea-438f-9312-6a20c5c0851b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":286,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:30:50
18904	9d66cb49-c54e-484c-8b30-4ba84fd21366	9d66cb49-cf90-430a-9304-635e0ce3b5c5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"41.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-03 10:37:08
18905	9d66cb49-c9dc-4b29-95fc-cceba7f5c0f7	9d66cb49-cf90-430a-9304-635e0ce3b5c5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 10:37:08
18906	9d66cb49-ca13-4453-a2ba-26fb713d3b07	9d66cb49-cf90-430a-9304-635e0ce3b5c5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 10:37:08
18907	9d66cb49-ce16-41ad-bcf7-297ec6d4f195	9d66cb49-cf90-430a-9304-635e0ce3b5c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 10:37:08
18908	9d66cb49-ce78-45b6-a2dd-720c44c2d694	9d66cb49-cf90-430a-9304-635e0ce3b5c5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:34:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"}]}},"duration":267,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:37:08
8416	9d52eb90-e9eb-48b9-b13e-676a8bec32db	9d52eb91-0c02-418f-8a72-ecd374be3a87	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:30:50
8417	9d52eb91-06eb-44bd-9bac-43312d29a854	9d52eb91-0c02-418f-8a72-ecd374be3a87	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:30:50
8418	9d52eb91-073c-438b-8f96-efbd8acaa5a0	9d52eb91-0c02-418f-8a72-ecd374be3a87	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:30:50
8419	9d52eb91-0adc-4758-b908-553f688fb87a	9d52eb91-0c02-418f-8a72-ecd374be3a87	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:30:50
8420	9d52eb91-0b22-4816-b4f0-a1d7dce89747	9d52eb91-0c02-418f-8a72-ecd374be3a87	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":263,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:30:50
14551	9d5eb9e3-d2b1-45cf-99d9-2c40d24b14d3	9d5eb9e4-1f8f-4431-a224-99caac864892	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-30 10:21:52
14552	9d5eb9e4-1a11-4e91-a301-04a6cbf8aa1c	9d5eb9e4-1f8f-4431-a224-99caac864892	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"158.28","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-30 10:21:52
10019	9d56c6b5-ed48-4f19-bc12-1b9a87081096	9d56c6b6-3213-408a-ac52-748715ca808d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 11:31:05
10020	9d56c6b6-3075-4c6a-a290-4f291315f336	9d56c6b6-3213-408a-ac52-748715ca808d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 11:31:05
10021	9d56c6b6-3121-4bb4-b8c9-688863c5d89c	9d56c6b6-3213-408a-ac52-748715ca808d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abl\\u00bb\\nLINE 13:                                 l.loans_nombre\\n                                         ^ (Connection: pgsql, SQL: \\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                                l.loans_nombre\\n                                l.loans_apellido_uno\\n                                l.loans_apellido_dos\\n                                l.loans_tipo_documento\\n                                l.loans_documento\\n                                l.loans_fecha_nacimiento\\n                                l.loans_ciudad\\n                                l.loans_barrio\\n                                l.loans_direccion\\n                                l.loans_intereses\\n                                l.loans_cuotas\\n                                l.loans_valor_prestado\\n                                l.loans_cuando\\n                                l.loans_observacion\\n                                l.loans_fecha\\n                                l.loans_estado\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":332,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:31:05
14553	9d5eb9e4-1df7-46f4-8b73-af754649357e	9d5eb9e4-1f8f-4431-a224-99caac864892	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 10:21:52
14554	9d5eb9e4-1e5b-4da2-beb2-56089ce13c25	9d5eb9e4-1f8f-4431-a224-99caac864892	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":359,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:21:52
18909	9d66cb4e-df16-4883-bb2d-5d6413fcd100	9d66cb4f-00bd-4d13-9fa0-09ff949ff2b2	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 10:37:11
18910	9d66cb4e-faef-4c7e-9701-e795ea49d7e7	9d66cb4f-00bd-4d13-9fa0-09ff949ff2b2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"41.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 10:37:11
18911	9d66cb4e-ff15-4633-8f5c-a8b839a750f1	9d66cb4f-00bd-4d13-9fa0-09ff949ff2b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 10:37:11
8421	9d52eb91-55ec-4682-80e4-af99c81dbda0	9d52eb91-a120-4134-a1ec-23829478ddb5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:30:50
8422	9d52eb91-9ab6-4100-9b52-16af67b4d118	9d52eb91-a120-4134-a1ec-23829478ddb5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"152.53","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:30:50
8423	9d52eb91-9b0e-4304-a33c-bee59ff5444a	9d52eb91-a120-4134-a1ec-23829478ddb5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:30:50
8424	9d52eb91-9fb4-45c0-9b43-59e885bf8e6c	9d52eb91-a120-4134-a1ec-23829478ddb5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:30:50
8425	9d52eb91-a015-4525-a203-4e77a77f098a	9d52eb91-a120-4134-a1ec-23829478ddb5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":359,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:30:50
14555	9d5eb9e6-9390-4836-b642-c3555c7f517d	9d5eb9e6-ac95-490b-9dc6-31e0161d47c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 10:21:53
14556	9d5eb9e6-a880-4f58-a791-e49760d82905	9d5eb9e6-ac95-490b-9dc6-31e0161d47c2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"40.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-10-30 10:21:53
14557	9d5eb9e6-ab52-4901-b6b0-9e06548c3742	9d5eb9e6-ac95-490b-9dc6-31e0161d47c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 10:21:53
14558	9d5eb9e6-aba4-4998-8374-4cff57481158	9d5eb9e6-ac95-490b-9dc6-31e0161d47c2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":418,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:21:53
18912	9d66cb4e-ff79-4e1e-907b-d696094df6bf	9d66cb4f-00bd-4d13-9fa0-09ff949ff2b2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":259,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:37:11
8426	9d52eb91-f17d-42eb-b8da-af95a000daa7	9d52eb92-3ff3-45c6-9914-6a216aee29c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:30:50
8427	9d52eb92-3879-4569-ae2c-38f269d04f71	9d52eb92-3ff3-45c6-9914-6a216aee29c0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc","time":"156.30","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 13:30:51
8428	9d52eb92-38d7-4dad-a81f-a5d0ab9aa2b8	9d52eb92-3ff3-45c6-9914-6a216aee29c0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:30:51
8429	9d52eb92-3a81-4cf4-b56a-577b764bd4b9	9d52eb92-3ff3-45c6-9914-6a216aee29c0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6'","time":"2.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 13:30:51
8430	9d52eb92-3ab4-423e-bccd-59a6b388413f	9d52eb92-3ff3-45c6-9914-6a216aee29c0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:30:51
8431	9d52eb92-3e8f-43b1-93b0-1cceedce4b91	9d52eb92-3ff3-45c6-9914-6a216aee29c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:30:51
8432	9d52eb92-3efa-483b-96db-2e67f1067c59	9d52eb92-3ff3-45c6-9914-6a216aee29c0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":386,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:30:51
14559	9d5eb9e9-d26f-42ff-b506-44557dad4329	9d5eb9ea-1783-4273-a230-3e801ec11cc7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 10:21:55
14560	9d5eb9ea-12eb-40bb-ba29-f64f82b5a4a6	9d5eb9ea-1783-4273-a230-3e801ec11cc7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"152.12","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-30 10:21:56
14561	9d5eb9ea-1617-4b74-a261-a838a8d8e8e0	9d5eb9ea-1783-4273-a230-3e801ec11cc7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 10:21:56
14562	9d5eb9ea-1682-4a42-b0db-9c6324d14c60	9d5eb9ea-1783-4273-a230-3e801ec11cc7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":342,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:21:56
27	9d4cf3a3-cb26-4649-b14b-532c233c7a13	9d4cf3a3-d113-4f9e-92af-fa36226e1d3e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[23502]: Not null violation: 7 ERROR:  el valor nulo en la columna \\u00abuser_photo\\u00bb de la relaci\\u00f3n \\u00abusers\\u00bb viola la restricci\\u00f3n de no nulo\\nDETAIL:  La fila que falla contiene (6, Eder Arley, edercortez10@gmail.com, null, 123456789, Cortes, Cabezas, CC, 1004608333, 2024-10-23T05:00:00.000Z, Cali, Las Orquideas, calle 107a, 3152596295, null, null, 29, 1, null, 0, null, 2024-10-21 14:18:26, 2024-10-21 14:18:26, null). (Connection: pgsql, SQL: insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"user_photo\\", \\"user_state\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"updated_at\\", \\"created_at\\") values (Eder Arley, edercortez10@gmail.com, Cortes, Cabezas, CC, 1004608333, 2024-10-23T05:00:00.000Z, Cali, Las Orquideas, calle 107a, 3152596295, ?, ?, 1, 29, 123456789, 2024-10-21 14:18:26, 2024-10-21 14:18:26) returning \\"id\\")","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":401},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor.php","line":24},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3549},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":1982},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1334},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1299},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1138},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":35},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":6}	2024-10-21 14:18:26
8433	9d52eb94-0d97-45f5-8bca-4e420bd0eb10	9d52eb94-3551-4ec6-ae20-f4de245de2e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:30:52
8434	9d52eb94-30b7-46b0-9ccf-2f8cf7fb6e65	9d52eb94-3551-4ec6-ae20-f4de245de2e1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"47.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:30:52
8435	9d52eb94-30fe-4df3-bfe0-07091b5fcf4d	9d52eb94-3551-4ec6-ae20-f4de245de2e1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:30:52
8436	9d52eb94-341d-42fb-95aa-5294dfd1620c	9d52eb94-3551-4ec6-ae20-f4de245de2e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 13:30:52
8437	9d52eb94-345d-4279-9a71-8694a8faedd1	9d52eb94-3551-4ec6-ae20-f4de245de2e1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":512,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:30:52
14563	9d5eb9ee-eff7-4fc4-972c-0c6710b3cb30	9d5eb9ef-0bae-4b9c-8924-331504ee6f2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 10:21:59
9071	9d52f403-25ae-4998-809c-613d78896759	9d52f403-4543-46c9-aba7-5521d942ab27	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 13:54:27
9072	9d52f403-436c-46a3-8839-a2e2e8be4a7e	9d52f403-4543-46c9-aba7-5521d942ab27	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 13:54:27
9073	9d52f403-43ff-4650-8095-dc330b6433e3	9d52f403-4543-46c9-aba7-5521d942ab27	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":262,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:54:27
14564	9d5eb9ef-0695-4f5e-b762-ea6f63060677	9d5eb9ef-0bae-4b9c-8924-331504ee6f2b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"44.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-30 10:21:59
14565	9d5eb9ef-0a22-4899-88ee-050c3548937b	9d5eb9ef-0bae-4b9c-8924-331504ee6f2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-30 10:21:59
14566	9d5eb9ef-0a94-4a82-91b0-02b117bcf279	9d5eb9ef-0bae-4b9c-8924-331504ee6f2b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":255,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:21:59
7055	9d52da99-df81-4e8c-8812-f123a7d80a1f	9d52da9a-4f66-4e6e-85c3-efcc959ec17c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 12:43:23
7056	9d52da9a-4b34-45d2-afcd-e8daf34f9736	9d52da9a-4f66-4e6e-85c3-efcc959ec17c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:43:24
7057	9d52da9a-4cc2-47ed-b3c9-79b36d9d14a7	9d52da9a-4f66-4e6e-85c3-efcc959ec17c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":637,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:43:24
14567	9d5eb9f1-3c27-4124-8229-c66f82b14e07	9d5eb9f1-5f72-4ec3-9bf3-35abdb5bf167	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-30 10:22:00
14568	9d5eb9f1-52f3-4b30-9b64-2d5e09231a74	9d5eb9f1-5f72-4ec3-9bf3-35abdb5bf167	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 55\\n                        ","time":"42.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"ff7240abed4441475e0acd0c74a5f6aa","hostname":"EderCortes"}	2024-10-30 10:22:00
15242	9d5ecf50-5a8a-489a-871b-41d84fc7d4d2	9d5ecf50-5b9d-4a25-8a24-1f59becff0b3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":394,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:21:46
9074	9d52f403-8ee2-4b29-b248-b028ee671b6a	9d52f403-b0f8-4c8f-9aa7-e3b6292a3a6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 13:54:27
7058	9d52da9b-0e85-4cdc-8e07-2f1595416736	9d52da9b-4788-4a45-b72e-3ff725a636d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:43:24
7059	9d52da9b-3ce0-4cb4-b729-53580cad359d	9d52da9b-4788-4a45-b72e-3ff725a636d9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"69.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:43:24
7060	9d52da9b-3d6d-4ce1-b8c5-b1b77ab22a15	9d52da9b-4788-4a45-b72e-3ff725a636d9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:43:24
7061	9d52da9b-454f-4a83-9ad3-ba9933360f8a	9d52da9b-4788-4a45-b72e-3ff725a636d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:43:24
7062	9d52da9b-4603-457f-9640-18c95ed5ea6c	9d52da9b-4788-4a45-b72e-3ff725a636d9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":561,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:43:24
9075	9d52f403-abd6-4f70-9301-898f6f95810d	9d52f403-b0f8-4c8f-9aa7-e3b6292a3a6b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"52.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:54:27
9076	9d52f403-ac25-4075-87f8-821a621c8f65	9d52f403-b0f8-4c8f-9aa7-e3b6292a3a6b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:54:27
9077	9d52f403-af9e-462b-8f9f-d585cbafaaa9	9d52f403-b0f8-4c8f-9aa7-e3b6292a3a6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 13:54:27
9078	9d52f403-afe1-4693-8c86-cb94960cd676	9d52f403-b0f8-4c8f-9aa7-e3b6292a3a6b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:54:27
14569	9d5eb9f1-599e-4b4d-8e08-57d82b24a998	9d5eb9f1-5f72-4ec3-9bf3-35abdb5bf167	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '55' order by \\"item_loans\\".\\"id\\" asc","time":"8.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-30 10:22:00
14570	9d5eb9f1-59f8-4e45-8601-91ae291ec659	9d5eb9f1-5f72-4ec3-9bf3-35abdb5bf167	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":7,"hostname":"EderCortes"}	2024-10-30 10:22:00
14571	9d5eb9f1-5e26-46e0-a5a2-1503bd3618d4	9d5eb9f1-5f72-4ec3-9bf3-35abdb5bf167	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-30 10:22:00
14572	9d5eb9f1-5e76-4177-b8db-441fa1661311	9d5eb9f1-5f72-4ec3-9bf3-35abdb5bf167	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/55","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":55,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":7,"loans_valor_prestado":50000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"15-11-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":150,"loans_codigo":55,"itemloans_cuota":"1","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":151,"loans_codigo":55,"itemloans_cuota":"2","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":152,"loans_codigo":55,"itemloans_cuota":"3","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":153,"loans_codigo":55,"itemloans_cuota":"4","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":154,"loans_codigo":55,"itemloans_cuota":"5","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":155,"loans_codigo":55,"itemloans_cuota":"6","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":156,"loans_codigo":55,"itemloans_cuota":"7","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":255,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:22:00
7063	9d52da9b-c05b-46a6-9a0d-80e83be173b2	9d52da9b-f6b1-4d5e-b3f8-5bbe344a603e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:43:25
7064	9d52da9b-ee51-4243-9dc3-dcbf4fb9526c	9d52da9b-f6b1-4d5e-b3f8-5bbe344a603e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"69.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:43:25
7065	9d52da9b-eebc-440c-b42b-251c99dd10a8	9d52da9b-f6b1-4d5e-b3f8-5bbe344a603e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:43:25
7066	9d52da9b-f508-4ebb-bc4e-c9afd8edb341	9d52da9b-f6b1-4d5e-b3f8-5bbe344a603e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 12:43:25
7067	9d52da9b-f576-4058-b5a8-9d156725d2fd	9d52da9b-f6b1-4d5e-b3f8-5bbe344a603e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":422,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:43:25
9079	9d52f403-f7a4-438a-bc06-aab6e108e01f	9d52f404-1676-4d8c-9203-6a834ba5becb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 13:54:27
9080	9d52f404-10ef-4338-aa8f-93ef0dbc0a3c	9d52f404-1676-4d8c-9203-6a834ba5becb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:54:27
9081	9d52f404-113c-4eb5-9cd7-e10d73fb63d3	9d52f404-1676-4d8c-9203-6a834ba5becb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:54:27
9082	9d52f404-1530-4534-98f3-c0df191f1b4d	9d52f404-1676-4d8c-9203-6a834ba5becb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 13:54:27
9083	9d52f404-1580-402b-b9d0-5418c30f7e0a	9d52f404-1676-4d8c-9203-6a834ba5becb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:54:27
7068	9d52da9c-68a3-41e0-bcd9-e043af24bf1b	9d52da9c-9446-43b3-9399-902541c4f6ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 12:43:25
7069	9d52da9c-88aa-4629-9528-7274f90822c7	9d52da9c-9446-43b3-9399-902541c4f6ed	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"50.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:43:25
7070	9d52da9c-8933-4b16-904e-79744f343398	9d52da9c-9446-43b3-9399-902541c4f6ed	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:43:25
7071	9d52da9c-8c3a-4161-b6ad-60b34d25711b	9d52da9c-9446-43b3-9399-902541c4f6ed	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"3.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:43:25
7072	9d52da9c-8cb0-4fe7-aeea-b958ea085647	9d52da9c-9446-43b3-9399-902541c4f6ed	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:43:25
7073	9d52da9c-91d0-4786-b147-f2f76c04e404	9d52da9c-9446-43b3-9399-902541c4f6ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 12:43:25
7074	9d52da9c-927c-492c-8e6d-d7a3eb259e1a	9d52da9c-9446-43b3-9399-902541c4f6ed	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":382,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:43:25
9084	9d52f404-5e09-4964-9ce7-8941ae817b8b	9d52f404-7c49-4f32-b44c-2abb9ad0129a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 13:54:28
9085	9d52f404-759e-442e-8e5b-3fd3a6fbd2c2	9d52f404-7c49-4f32-b44c-2abb9ad0129a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"42.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-24 13:54:28
9086	9d52f404-75eb-46bb-ab27-788985bdfa6a	9d52f404-7c49-4f32-b44c-2abb9ad0129a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:54:28
9087	9d52f404-7795-4474-8aba-e38d1635dda8	9d52f404-7c49-4f32-b44c-2abb9ad0129a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"1.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 13:54:28
9088	9d52f404-77c6-4e01-b596-ae94a6b7dff8	9d52f404-7c49-4f32-b44c-2abb9ad0129a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:54:28
9089	9d52f404-7b23-452a-8542-9e8d3184628d	9d52f404-7c49-4f32-b44c-2abb9ad0129a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 13:54:28
9090	9d52f404-7b72-4d97-ae82-fc5cf052d808	9d52f404-7c49-4f32-b44c-2abb9ad0129a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":245,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:54:28
19012	9d66ce7a-89a7-4956-bba4-feb23baa9f23	9d66ce7a-c34f-4a40-b62e-395eaa923e95	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 10:46:03
19013	9d66ce7a-c0e4-42a3-8e5e-6bd1913a4435	9d66ce7a-c34f-4a40-b62e-395eaa923e95	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 10:46:03
19014	9d66ce7a-c1e1-4889-b5dc-8ab2886f9b0d	9d66ce7a-c34f-4a40-b62e-395eaa923e95	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:46:03
9091	9d52f406-7150-4549-82cc-6e880e2761f2	9d52f406-8ee9-41ba-a104-c76962babb90	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 13:54:29
9092	9d52f406-89fb-4f04-87f1-780a0e842eaa	9d52f406-8ee9-41ba-a104-c76962babb90	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:54:29
9093	9d52f406-8a4c-4f7e-9aeb-4ff30cf862d1	9d52f406-8ee9-41ba-a104-c76962babb90	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:54:29
9094	9d52f406-8dad-40c9-9d70-3a7555cef03c	9d52f406-8ee9-41ba-a104-c76962babb90	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-24 13:54:29
9095	9d52f406-8dea-4ce1-8f62-163eedee3d87	9d52f406-8ee9-41ba-a104-c76962babb90	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":325,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:54:29
19015	9d66ce7b-7ba7-44ee-bfae-627a11ba1982	9d66ce7b-a424-4839-90f0-31f52a6f781e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 10:46:04
19016	9d66ce7b-9792-461d-8dc0-baeb1a27e428	9d66ce7b-a424-4839-90f0-31f52a6f781e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"56.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"2b11ef88578e3c91c11800e110e490df","hostname":"EderCortes"}	2024-11-03 10:46:04
19017	9d66ce7b-9c58-4fa6-970f-c66696f977af	9d66ce7b-a424-4839-90f0-31f52a6f781e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"2.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 10:46:04
19018	9d66ce7b-9c9c-43e9-b8df-5ba5c55c3a4a	9d66ce7b-a424-4839-90f0-31f52a6f781e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 10:46:04
19019	9d66ce7b-a2be-43e6-a93d-aad6540bb5b0	9d66ce7b-a424-4839-90f0-31f52a6f781e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 10:46:04
19020	9d66ce7b-a30e-44d3-ad52-37ee8a42f8d6	9d66ce7b-a424-4839-90f0-31f52a6f781e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":508,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:46:04
19021	9d66ce7d-9942-4c15-b91f-49197aa5df43	9d66ce7d-b5b3-448b-856f-7f572096c22e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 10:46:05
19022	9d66ce7d-b0b9-4c46-9fa5-d0c03a5406c4	9d66ce7d-b5b3-448b-856f-7f572096c22e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 10:46:05
19023	9d66ce7d-b102-42d6-9a0a-d7257e194d32	9d66ce7d-b5b3-448b-856f-7f572096c22e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 10:46:05
19024	9d66ce7d-b46c-42e1-b79c-cc5065e81834	9d66ce7d-b5b3-448b-856f-7f572096c22e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 10:46:05
19025	9d66ce7d-b4b0-42fd-b4db-a476ca247a11	9d66ce7d-b5b3-448b-856f-7f572096c22e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:46:05
19026	9d66ce81-63fd-4c60-98cb-6cc8752a6c4a	9d66ce81-7d41-4a8b-9811-889ce52a72e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 10:46:08
19027	9d66ce81-7917-4ea1-97a2-91dc215eb427	9d66ce81-7d41-4a8b-9811-889ce52a72e8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"41.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-03 10:46:08
19028	9d66ce81-7c08-4d34-86c8-621aca75774f	9d66ce81-7d41-4a8b-9811-889ce52a72e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 10:46:08
19029	9d66ce81-7c5a-4048-a42d-67c34723c25a	9d66ce81-7d41-4a8b-9811-889ce52a72e8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":282,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:46:08
19030	9d66ce86-afa7-4d23-a4d6-8a0b4aebc974	9d66ce86-f5b1-463e-9ef3-f03ffee488e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 10:46:11
19031	9d66ce86-f1c7-44a9-b8e0-b8ace7793c54	9d66ce86-f5b1-463e-9ef3-f03ffee488e7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"153.42","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 10:46:11
19032	9d66ce86-f486-46b0-b73e-d8356189595c	9d66ce86-f5b1-463e-9ef3-f03ffee488e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 10:46:11
19033	9d66ce86-f4d7-4179-9e11-3f0efa7e7d21	9d66ce86-f5b1-463e-9ef3-f03ffee488e7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:46:11
8709	9d52eea4-5a7d-434e-9fcd-e420fbc8599b	9d52eea4-81d5-496c-80c6-206772fe8383	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 13:39:26
8710	9d52eea4-7f67-45b7-bba2-ac696ff55b3e	9d52eea4-81d5-496c-80c6-206772fe8383	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:39:26
8711	9d52eea4-80b3-47d3-9d77-d3a758b0da8f	9d52eea4-81d5-496c-80c6-206772fe8383	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:39:26
19141	9d66d095-a65b-4e58-a741-3399c90e2dc9	9d66d095-c32a-49a8-a3ab-968308f29763	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 10:51:56
19142	9d66d095-c1a5-4587-9b08-af57ad245761	9d66d095-c32a-49a8-a3ab-968308f29763	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 10:51:57
19143	9d66d095-c236-4f57-84f0-f3d3ee6511bf	9d66d095-c32a-49a8-a3ab-968308f29763	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:51:57
8712	9d52eea4-da68-4ec3-a2b1-2639f9846fb2	9d52eea4-f9ef-4f1e-87af-3ae72c1a1e5e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:39:26
8713	9d52eea4-f4a5-4f8d-9000-0b27cd4e89bf	9d52eea4-f9ef-4f1e-87af-3ae72c1a1e5e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:39:26
8714	9d52eea4-f4f8-4cc9-9004-7ceb1facc4d5	9d52eea4-f9ef-4f1e-87af-3ae72c1a1e5e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:39:26
8715	9d52eea4-f8d7-4e7d-ba6d-0216b1e19ec2	9d52eea4-f9ef-4f1e-87af-3ae72c1a1e5e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:39:26
8716	9d52eea4-f918-484d-a26a-70780497430d	9d52eea4-f9ef-4f1e-87af-3ae72c1a1e5e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":277,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:39:26
19034	9d66ce8a-48eb-4049-a5de-9f286070950d	9d66ce8a-8f44-4880-9a8e-4b95c79eb596	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 10:46:13
19035	9d66ce8a-870a-4380-87cd-578c28f2250a	9d66ce8a-8f44-4880-9a8e-4b95c79eb596	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"146.48","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-03 10:46:14
19036	9d66ce8a-8a94-41a9-830c-42d44896f3cb	9d66ce8a-8f44-4880-9a8e-4b95c79eb596	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 10:46:14
19037	9d66ce8a-8ac9-4208-a633-a11341120ac1	9d66ce8a-8f44-4880-9a8e-4b95c79eb596	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 10:46:14
19038	9d66ce8a-8e07-48a7-add7-dc2a81834fd1	9d66ce8a-8f44-4880-9a8e-4b95c79eb596	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 10:46:14
19039	9d66ce8a-8e49-49d3-ba35-8a58a85af6ac	9d66ce8a-8f44-4880-9a8e-4b95c79eb596	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:34:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"}]}},"duration":329,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:46:14
19144	9d66d096-109c-453b-ba21-18878243f27b	9d66d096-3221-4b19-88db-d00cb587ac7e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 10:51:57
8717	9d52eea5-4000-4076-8e9b-1a053128e197	9d52eea5-8742-462f-a881-caf0774dea3e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:39:26
8718	9d52eea5-821b-4084-908d-da506615b10d	9d52eea5-8742-462f-a881-caf0774dea3e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"147.84","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:39:27
8719	9d52eea5-8265-446a-b0fd-e0f53e720bd2	9d52eea5-8742-462f-a881-caf0774dea3e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:39:27
8720	9d52eea5-863d-4f91-a1d8-8c1f919725eb	9d52eea5-8742-462f-a881-caf0774dea3e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:39:27
8721	9d52eea5-867e-4a5e-b57d-17d798e6cdd6	9d52eea5-8742-462f-a881-caf0774dea3e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:39:27
19040	9d66cebc-441d-471f-8a5c-2a2b8293d2c9	9d66cebc-5e94-44d0-ac25-39bf4a8c722b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 10:46:46
19041	9d66cebc-5a66-4c5d-aacd-3466d1cd2302	9d66cebc-5e94-44d0-ac25-39bf4a8c722b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"41.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 10:46:46
10088	9d56c853-d3cf-49a9-b72c-7f560cc98093	9d56c854-057f-448e-9a79-e512a9b72863	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 11:35:36
10089	9d56c854-02ab-46ce-ab2e-b02cbdc57ecc	9d56c854-057f-448e-9a79-e512a9b72863	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:35:36
10090	9d56c854-03d2-4138-ac95-e68f1645332d	9d56c854-057f-448e-9a79-e512a9b72863	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":339,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:35:36
19042	9d66cebc-5d66-493f-896d-48a1d40f6569	9d66cebc-5e94-44d0-ac25-39bf4a8c722b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 10:46:46
19043	9d66cebc-5db4-4184-917f-1f1fa95a99b0	9d66cebc-5e94-44d0-ac25-39bf4a8c722b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":222,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:46:46
19145	9d66d096-290b-4ce4-9c81-097fe2e2303d	9d66d096-3221-4b19-88db-d00cb587ac7e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"45.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 10:51:57
8722	9d52eea5-c7a5-4e58-8ddc-30f08f0a78a7	9d52eea6-0f7f-4bfb-aa88-5fa7c86cc96c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:39:27
8723	9d52eea6-08a7-4731-8f3b-917c7e432b40	9d52eea6-0f7f-4bfb-aa88-5fa7c86cc96c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc","time":"147.28","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"1c647a8d9ee2a83df3e977318f9d3347","hostname":"EderCortes"}	2024-10-24 13:39:27
8724	9d52eea6-08f7-48ef-b0ec-5fba886e69c1	9d52eea6-0f7f-4bfb-aa88-5fa7c86cc96c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:39:27
8725	9d52eea6-0a69-4fe6-b0ae-49718597841d	9d52eea6-0f7f-4bfb-aa88-5fa7c86cc96c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"1.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 13:39:27
8726	9d52eea6-0a9d-4a32-90b5-c07a998c2ffc	9d52eea6-0f7f-4bfb-aa88-5fa7c86cc96c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:39:27
8727	9d52eea6-0e59-4959-9731-397cbfa889ff	9d52eea6-0f7f-4bfb-aa88-5fa7c86cc96c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:39:27
8728	9d52eea6-0eaa-41d9-9dcb-284a0ca0d2d2	9d52eea6-0f7f-4bfb-aa88-5fa7c86cc96c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456}],"item":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]},"duration":331,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:39:27
10091	9d56c854-8041-4e92-bcd7-1e1ac88f7b2f	9d56c854-a45c-445c-8a88-0374996b290d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:35:37
10092	9d56c854-9e44-449a-aa3e-79fde1959999	9d56c854-a45c-445c-8a88-0374996b290d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"58.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:35:37
10093	9d56c854-a2f5-4cad-9e5d-d9c2e79bf01b	9d56c854-a45c-445c-8a88-0374996b290d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:35:37
10094	9d56c854-a354-4012-9c86-7bf3751a5b13	9d56c854-a45c-445c-8a88-0374996b290d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":366,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:35:37
19044	9d66cec0-4bf4-493b-83e0-63c1f1dde322	9d66cec0-9667-4dd2-8266-5e614ace7f80	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 10:46:49
19045	9d66cec0-8e3d-472d-8510-74ee488a2774	9d66cec0-9667-4dd2-8266-5e614ace7f80	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"155.04","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 10:46:49
8729	9d52eea7-a854-40a9-a062-41e6f22e20f8	9d52eea7-ce32-48c5-a879-0a383075e546	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:39:28
8730	9d52eea7-c750-4ffa-b5a1-d09a31704321	9d52eea7-ce32-48c5-a879-0a383075e546	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"49.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:39:28
8731	9d52eea7-c7b9-4f29-8aa1-d5486668fef9	9d52eea7-ce32-48c5-a879-0a383075e546	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:39:28
8732	9d52eea7-cc50-4f03-9ac8-118f993ac87d	9d52eea7-ce32-48c5-a879-0a383075e546	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:39:28
8733	9d52eea7-ccbc-4b12-a648-44c41d7d04db	9d52eea7-ce32-48c5-a879-0a383075e546	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":508,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:39:28
10095	9d56c855-d719-4879-8fcb-ed4fedf61361	9d56c855-f457-4d49-9302-b4e72049ef38	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:35:38
10096	9d56c855-ef3f-4cb8-839f-e0a9b479ee5c	9d56c855-f457-4d49-9302-b4e72049ef38	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:35:38
10097	9d56c855-ef9c-4614-b51f-a1031dd36101	9d56c855-f457-4d49-9302-b4e72049ef38	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:35:38
10098	9d56c855-f2c7-499f-913f-dc1c9ac80e97	9d56c855-f457-4d49-9302-b4e72049ef38	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 11:35:38
10099	9d56c855-f311-45b2-88e9-960490cd6a6a	9d56c855-f457-4d49-9302-b4e72049ef38	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":297,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:35:38
19046	9d66cec0-9198-438b-9558-6e2dab97a91f	9d66cec0-9667-4dd2-8266-5e614ace7f80	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"1.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 10:46:49
19047	9d66cec0-91c7-4a9c-8ac1-f1814bf68688	9d66cec0-9667-4dd2-8266-5e614ace7f80	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 10:46:49
19048	9d66cec0-9554-4487-9a0e-2540ec3a2026	9d66cec0-9667-4dd2-8266-5e614ace7f80	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 10:46:49
19049	9d66cec0-9598-4931-9ba3-295ffe674d52	9d66cec0-9667-4dd2-8266-5e614ace7f80	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T02:27:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"0"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":365,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:46:49
7773	9d52e159-1c8f-494b-94e1-208c7a8009ea	9d52e159-422b-4484-b883-fc981f712bdc	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 13:02:15
7774	9d52e159-4049-4db2-8ec6-d16f22d8f57f	9d52e159-422b-4484-b883-fc981f712bdc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:02:16
7775	9d52e159-4107-4d8e-afec-ac72a3133e16	9d52e159-422b-4484-b883-fc981f712bdc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":316,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:02:16
19231	9d66d266-267e-4368-9ee3-5513aa11ab6f	9d66d266-5889-4eab-a7ec-642c752a3be0	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 10:57:01
19232	9d66d266-5512-4957-9716-856fe925121b	9d66d266-5889-4eab-a7ec-642c752a3be0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 10:57:01
19146	9d66d096-2cae-430c-b101-f2ffc496202e	9d66d096-3221-4b19-88db-d00cb587ac7e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 10:51:57
19147	9d66d096-2ce0-461b-818f-9337aa7f9083	9d66d096-3221-4b19-88db-d00cb587ac7e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 10:51:57
19148	9d66d096-30f5-4e46-89ac-8c5d13d36105	9d66d096-3221-4b19-88db-d00cb587ac7e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 10:51:57
19149	9d66d096-313c-4b91-ab11-613bf50f0392	9d66d096-3221-4b19-88db-d00cb587ac7e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T02:27:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"0"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:51:57
19233	9d66d266-56a7-4a8e-bac8-4a5de278126c	9d66d266-5889-4eab-a7ec-642c752a3be0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":443,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:57:01
7776	9d52e159-a12d-4cd4-af3d-294b411353bc	9d52e159-e9ad-460c-a418-30e3af4111cc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:02:16
7777	9d52e159-e33d-4089-a10c-510cceba500f	9d52e159-e9ad-460c-a418-30e3af4111cc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"146.15","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:02:16
7778	9d52e159-e3b7-4e0b-9866-c4a6e0aee99a	9d52e159-e9ad-460c-a418-30e3af4111cc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:02:16
7779	9d52e159-e845-4c14-aee4-2eb07cc37df6	9d52e159-e9ad-460c-a418-30e3af4111cc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:02:16
7780	9d52e159-e8a1-4df4-82a4-f5f26a5a6544	9d52e159-e9ad-460c-a418-30e3af4111cc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":384,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:02:16
19150	9d66d097-d0b5-4098-a71a-457d9f21ba24	9d66d097-f5d0-4ac4-88a4-d299166a44b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 10:51:58
19151	9d66d097-eee4-427d-8ebf-bd7ff1e0c1fe	9d66d097-f5d0-4ac4-88a4-d299166a44b2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 10:51:58
19152	9d66d097-ef43-4966-9292-a97c3f51e44d	9d66d097-f5d0-4ac4-88a4-d299166a44b2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 10:51:58
19153	9d66d097-f432-4036-95a8-669d9b6d66d8	9d66d097-f5d0-4ac4-88a4-d299166a44b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 10:51:58
19154	9d66d097-f492-487a-99dd-63f9cebd5c4c	9d66d097-f5d0-4ac4-88a4-d299166a44b2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":397,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:51:58
19234	9d66d266-e352-4e37-99c3-3a0cf5fe6a0b	9d66d267-3a27-4c1a-96a3-fbcb2094d9bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 10:57:01
19235	9d66d267-292d-4a48-b156-dd37c35ef363	9d66d267-3a27-4c1a-96a3-fbcb2094d9bd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"156.13","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 10:57:02
19236	9d66d267-2f58-445d-b9bb-158609c519e6	9d66d267-3a27-4c1a-96a3-fbcb2094d9bd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"3.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 10:57:02
19237	9d66d267-2fa3-4675-bb30-1d83eca4fa5f	9d66d267-3a27-4c1a-96a3-fbcb2094d9bd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 10:57:02
19238	9d66d267-3856-4140-bb8a-164a57334661	9d66d267-3a27-4c1a-96a3-fbcb2094d9bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 10:57:02
7781	9d52e15a-2c59-4ac0-b54d-6f41c31ba1b6	9d52e15a-4a20-484e-8de6-18601688c280	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:02:16
7782	9d52e15a-4597-4470-93c8-0eef4899b193	9d52e15a-4a20-484e-8de6-18601688c280	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:02:16
7783	9d52e15a-45eb-4273-b6b6-822f06916a49	9d52e15a-4a20-484e-8de6-18601688c280	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:02:16
7784	9d52e15a-48f3-4bf0-9530-8dbf1181cc16	9d52e15a-4a20-484e-8de6-18601688c280	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:02:16
7785	9d52e15a-4936-4080-b323-d3bfeb50ce43	9d52e15a-4a20-484e-8de6-18601688c280	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:02:16
19239	9d66d267-38dd-4c57-b6b3-ec8735c23feb	9d66d267-3a27-4c1a-96a3-fbcb2094d9bd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T02:27:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"0"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":500,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:57:02
7786	9d52e15a-8dea-482a-b994-b4a229548e18	9d52e15a-ace2-4927-94ee-ca6c9f47e81f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:02:16
7787	9d52e15a-a5db-4870-bfd5-eaa36d8919f9	9d52e15a-ace2-4927-94ee-ca6c9f47e81f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"41.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 13:02:16
7788	9d52e15a-a629-4265-affa-21db044fc4d4	9d52e15a-ace2-4927-94ee-ca6c9f47e81f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:02:16
7789	9d52e15a-a7b6-44a9-8775-cc55fbddc153	9d52e15a-ace2-4927-94ee-ca6c9f47e81f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"1.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 13:02:16
5122	9d513679-a40e-44f4-83ab-5bb0191b4cb6	9d513679-c6d4-426c-acc5-a7695272216c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-23 17:08:38
5123	9d513679-c4f0-4ee9-8c5f-3fbdc6529861	9d513679-c6d4-426c-acc5-a7695272216c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-23 17:08:38
5124	9d513679-c5c8-42a5-892b-c14212ee3f43	9d513679-c6d4-426c-acc5-a7695272216c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:38
7790	9d52e15a-a7f0-45df-b3ff-c02ca3bc3774	9d52e15a-ace2-4927-94ee-ca6c9f47e81f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 13:02:16
7791	9d52e15a-ab8c-46c6-b9d7-33e972d86729	9d52e15a-ace2-4927-94ee-ca6c9f47e81f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:02:16
7792	9d52e15a-abed-451b-8393-71f0ddbac0ec	9d52e15a-ace2-4927-94ee-ca6c9f47e81f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:02:16
19240	9d66d26a-7efa-4790-ab1f-405834b5804e	9d66d26a-aed4-47c2-978c-656a761c3b04	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 10:57:04
19241	9d66d26a-a52b-45fd-b362-94f3b6ae59fc	9d66d26a-aed4-47c2-978c-656a761c3b04	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"68.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 10:57:04
19242	9d66d26a-a5a6-44f0-94d9-985d27fd25fd	9d66d26a-aed4-47c2-978c-656a761c3b04	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 10:57:04
19243	9d66d26a-ad1c-4b06-9587-6853b26b3d94	9d66d26a-aed4-47c2-978c-656a761c3b04	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 10:57:04
19244	9d66d26a-ad8a-4f8a-afd1-77eab29d8d5f	9d66d26a-aed4-47c2-978c-656a761c3b04	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":551,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:57:04
19321	9d66d571-7126-489c-b8dc-2f423e4a1134	9d66d571-9d6c-484a-94cb-5c0ad52deb7d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 11:05:32
19322	9d66d571-9a8b-477c-b5b6-dc2c09a696fe	9d66d571-9d6c-484a-94cb-5c0ad52deb7d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:05:32
19323	9d66d571-9c05-4641-93a7-3a2d187a84a3	9d66d571-9d6c-484a-94cb-5c0ad52deb7d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":386,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:05:32
19324	9d66d572-178e-403f-90f7-a2b3bfa846f8	9d66d572-3d85-42a6-8b92-c641194a5035	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:05:32
19325	9d66d572-32b2-4614-881d-af7f2e31b8d1	9d66d572-3d85-42a6-8b92-c641194a5035	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"49.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 11:05:32
19326	9d66d572-3690-45f7-ab37-604348224d3c	9d66d572-3d85-42a6-8b92-c641194a5035	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:05:32
19327	9d66d572-36d1-4c5b-82cb-b9169e4bc4ac	9d66d572-3d85-42a6-8b92-c641194a5035	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:05:32
19328	9d66d572-3c27-409b-8d14-64e49fad26ce	9d66d572-3d85-42a6-8b92-c641194a5035	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:05:32
19329	9d66d572-3c85-4d3f-9deb-b278ad5992e6	9d66d572-3d85-42a6-8b92-c641194a5035	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T02:27:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"0"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":368,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:05:32
19411	9d66d63c-2a1a-4d3b-9b66-41ebc1f5de46	9d66d63c-4d9d-4839-ad12-df27e960d78b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 11:07:44
19412	9d66d63c-4b92-4cab-b2f9-0d9703ebac40	9d66d63c-4d9d-4839-ad12-df27e960d78b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:07:45
19413	9d66d63c-4c51-4169-a1af-c067b154ca6c	9d66d63c-4d9d-4839-ad12-df27e960d78b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:07:45
10166	9d56ca38-6335-44f9-8df8-59da9a1946f3	9d56ca38-8bfb-45fe-a17e-2a5fbb3067c5	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 11:40:54
10167	9d56ca38-893f-4c4e-99d5-bd012f0c34dd	9d56ca38-8bfb-45fe-a17e-2a5fbb3067c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:40:54
10168	9d56ca38-8aaf-4850-85eb-e2a836744707	9d56ca38-8bfb-45fe-a17e-2a5fbb3067c5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":288,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:40:54
19330	9d66d574-4f5a-4eb8-9be5-f2c315cb3927	9d66d574-6c94-48b3-987e-e9e4489f0de7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:05:33
10169	9d56ca38-f51e-4571-89c6-2e78561f6ffc	9d56ca39-1329-4866-95f4-aba2eb4e9ec7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:40:54
9248	9d52f688-5a69-4ef2-951c-d46bae69c15f	9d52f688-7f86-4dc1-919e-368809427b6f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 14:01:30
9249	9d52f688-7d94-4d99-9d47-f9aea3950939	9d52f688-7f86-4dc1-919e-368809427b6f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 14:01:30
9250	9d52f688-7e79-43ea-9557-f34e08bc8fae	9d52f688-7f86-4dc1-919e-368809427b6f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":277,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:01:30
10170	9d56ca39-0d8b-4773-a984-e358a634e836	9d56ca39-1329-4866-95f4-aba2eb4e9ec7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"46.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:40:54
10171	9d56ca39-11d2-4aab-a655-8ac284ba0bc0	9d56ca39-1329-4866-95f4-aba2eb4e9ec7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:40:54
10172	9d56ca39-1238-4e67-9f91-5c1848859681	9d56ca39-1329-4866-95f4-aba2eb4e9ec7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":312,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:40:54
19414	9d66d63c-aee0-45be-8762-4f29bf40ec8b	9d66d63c-f5d6-4229-98f8-1ac74f340257	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:07:45
9251	9d52f688-d722-46d1-ae51-ad114a714832	9d52f689-22f5-4589-ae28-12653687129f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 14:01:30
9252	9d52f689-1d90-49e7-bd23-e5366ea14ab6	9d52f689-22f5-4589-ae28-12653687129f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"154.05","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 14:01:30
9253	9d52f689-1df4-4bd3-88e6-664bc705e6d6	9d52f689-22f5-4589-ae28-12653687129f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 14:01:30
9254	9d52f689-21e0-4773-8036-ec7d60371dc8	9d52f689-22f5-4589-ae28-12653687129f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 14:01:30
9255	9d52f689-2223-4ddc-af78-acd84ceda8b1	9d52f689-22f5-4589-ae28-12653687129f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":387,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:01:30
10173	9d56ca3a-9934-41c5-90a2-0b171adf0977	9d56ca3a-e0d9-41e3-8d95-d636b512f408	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:40:55
10174	9d56ca3a-dbb9-40fb-af63-150b2336c0b0	9d56ca3a-e0d9-41e3-8d95-d636b512f408	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"147.73","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:40:56
10175	9d56ca3a-dc08-4a08-a37b-a3e30166f876	9d56ca3a-e0d9-41e3-8d95-d636b512f408	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:40:56
10176	9d56ca3a-dfa4-48c1-9bd8-797c4ec681ef	9d56ca3a-e0d9-41e3-8d95-d636b512f408	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 11:40:56
10177	9d56ca3a-dfee-4094-8936-835384264eed	9d56ca3a-e0d9-41e3-8d95-d636b512f408	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":366,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:40:56
19331	9d66d574-6754-45bb-bd63-8da9eaecaf3f	9d66d574-6c94-48b3-987e-e9e4489f0de7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:05:34
19332	9d66d574-67ae-42c2-bb05-e3cbbdb62966	9d66d574-6c94-48b3-987e-e9e4489f0de7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:05:34
19333	9d66d574-6b71-46d6-ae8b-4e4bcea45042	9d66d574-6c94-48b3-987e-e9e4489f0de7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 11:05:34
19334	9d66d574-6bb3-4fc5-b4ff-3664e75de010	9d66d574-6c94-48b3-987e-e9e4489f0de7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":313,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:05:34
9256	9d52f689-6873-4f1e-9574-5bf20143a7c2	9d52f689-b14e-4979-9440-ff112afe75e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 14:01:30
9257	9d52f689-ac5d-4a0c-be80-e38a114c2e04	9d52f689-b14e-4979-9440-ff112afe75e0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"148.48","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 14:01:30
9258	9d52f689-acaf-4fa6-94c5-4f41c7d92614	9d52f689-b14e-4979-9440-ff112afe75e0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 14:01:30
9259	9d52f689-b037-4cd1-81b0-dbc0b6b78f15	9d52f689-b14e-4979-9440-ff112afe75e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 14:01:30
9260	9d52f689-b07c-44c6-81c0-17f0736f8a4a	9d52f689-b14e-4979-9440-ff112afe75e0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:01:30
19415	9d66d63c-ec3e-420a-84e1-ff89f08d753e	9d66d63c-f5d6-4229-98f8-1ac74f340257	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"145.23","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 11:07:45
19416	9d66d63c-f009-4e99-a586-b9782b4035f5	9d66d63c-f5d6-4229-98f8-1ac74f340257	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:07:45
19417	9d66d63c-f038-481c-85cd-948bec2bceba	9d66d63c-f5d6-4229-98f8-1ac74f340257	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:07:45
19418	9d66d63c-f490-472c-9b97-9e95cef6b6fe	9d66d63c-f5d6-4229-98f8-1ac74f340257	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:07:45
19419	9d66d63c-f4eb-447c-9998-b7bd67c25ebf	9d66d63c-f5d6-4229-98f8-1ac74f340257	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T02:27:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"0"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":389,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:07:45
9261	9d52f689-f3ed-430c-8bc4-8021fd9e4cb4	9d52f68a-13ae-4c8d-bb39-a67f958a5223	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 14:01:31
9262	9d52f68a-0d1a-4c42-a9de-961c819a894d	9d52f68a-13ae-4c8d-bb39-a67f958a5223	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"44.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-24 14:01:31
9263	9d52f68a-0d66-4c1a-af04-1e6c4529de65	9d52f68a-13ae-4c8d-bb39-a67f958a5223	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 14:01:31
9264	9d52f68a-0f08-4243-9ecf-115dd48b0538	9d52f68a-13ae-4c8d-bb39-a67f958a5223	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"2.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 14:01:31
9265	9d52f68a-0f41-4099-9e96-72159932ad20	9d52f68a-13ae-4c8d-bb39-a67f958a5223	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 14:01:31
9266	9d52f68a-12a8-4327-8715-daccb69e227f	9d52f68a-13ae-4c8d-bb39-a67f958a5223	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 14:01:31
9267	9d52f68a-12ed-4493-a5fc-4993bda22215	9d52f68a-13ae-4c8d-bb39-a67f958a5223	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:01:31
19420	9d66d63e-899a-49ec-8fe1-2be7bb876e95	9d66d63e-d229-4b9c-ad24-60607f5d935a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:07:46
19421	9d66d63e-cd25-43f7-9d8d-d0ae8f1cf074	9d66d63e-d229-4b9c-ad24-60607f5d935a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"154.33","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:07:46
19422	9d66d63e-cd77-4ce3-861c-99400b4cdde2	9d66d63e-d229-4b9c-ad24-60607f5d935a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:07:46
19423	9d66d63e-d0f1-48fa-b575-c2b395dbcb28	9d66d63e-d229-4b9c-ad24-60607f5d935a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 11:07:46
19424	9d66d63e-d135-4a3b-9e5f-cb6a377e20f7	9d66d63e-d229-4b9c-ad24-60607f5d935a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":371,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:07:46
9268	9d52f68c-1493-4d77-8d94-e2726abeed78	9d52f68c-3c4f-4e85-9b0c-41c223187591	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 14:01:32
9269	9d52f68c-362a-4979-b88a-df8abec4347f	9d52f68c-3c4f-4e85-9b0c-41c223187591	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"46.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 14:01:32
9270	9d52f68c-3681-4ebc-a2eb-30c35a8dd689	9d52f68c-3c4f-4e85-9b0c-41c223187591	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 14:01:32
9271	9d52f68c-3afb-459a-b3e7-3ccef6db7b68	9d52f68c-3c4f-4e85-9b0c-41c223187591	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 14:01:32
9272	9d52f68c-3b4d-4e1e-9adb-8dbe3c89738c	9d52f68c-3c4f-4e85-9b0c-41c223187591	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":328,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:01:32
11384	9d5cbdd6-34e5-4b5b-bf3a-eb29881a337c	9d5cbdd6-835f-4328-8f80-c21b8cc1774c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 10:41:14
11385	9d5cbdd6-8135-49ff-9168-853e3992ca9c	9d5cbdd6-835f-4328-8f80-c21b8cc1774c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 10:41:15
11386	9d5cbdd6-81fb-4442-9725-a2bf54a7237c	9d5cbdd6-835f-4328-8f80-c21b8cc1774c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":367,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:41:15
11387	9d5cbdd6-d60e-4c5b-b1e7-cc967b27c7e8	9d5cbdd7-1ea7-4d47-9638-f026a6a4553d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 10:41:15
11388	9d5cbdd7-15a5-49f4-bd81-d4ccb79bb9ea	9d5cbdd7-1ea7-4d47-9638-f026a6a4553d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 1\\n                        ","time":"149.62","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"2bd5a29c69f6bbb290fc49b79286632e","hostname":"EderCortes"}	2024-10-29 10:41:15
11389	9d5cbdd7-196f-4c53-9116-a4fbbb00309f	9d5cbdd7-1ea7-4d47-9638-f026a6a4553d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1' order by \\"item_loans\\".\\"id\\" asc","time":"2.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 10:41:15
11390	9d5cbdd7-19a6-42cc-be40-81c4f4d1358b	9d5cbdd7-1ea7-4d47-9638-f026a6a4553d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 10:41:15
11391	9d5cbdd7-1d92-4add-8f92-3a14a179d502	9d5cbdd7-1ea7-4d47-9638-f026a6a4553d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 10:41:15
11392	9d5cbdd7-1dd9-44c0-a1b3-b7aced5679c3	9d5cbdd7-1ea7-4d47-9638-f026a6a4553d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":1,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]}},"duration":365,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:41:15
19545	9d66e03c-8bad-479e-88ca-0eddc89d8ee6	9d66e03c-d3d5-4215-aaf8-2628d4fab2c6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:35:42
19546	9d66e03c-d218-43a2-b65b-086cb31580b5	9d66e03c-d3d5-4215-aaf8-2628d4fab2c6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 11:35:43
11393	9d5cbdd8-944a-4a9f-84e7-b37ff891655e	9d5cbdd8-b2f3-42d8-82df-28383800da35	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 10:41:16
11394	9d5cbdd8-ad3e-4bff-b2c6-c0e973b5ae93	9d5cbdd8-b2f3-42d8-82df-28383800da35	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 10:41:16
11395	9d5cbdd8-ad89-476d-b487-5f8185c7d051	9d5cbdd8-b2f3-42d8-82df-28383800da35	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 10:41:16
11396	9d5cbdd8-b1dc-45b6-b75b-a5ceace9213f	9d5cbdd8-b2f3-42d8-82df-28383800da35	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 10:41:16
11397	9d5cbdd8-b21d-46cb-a30e-27dc5613e3a7	9d5cbdd8-b2f3-42d8-82df-28383800da35	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":272,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:41:16
19547	9d66e03c-d2d4-4baf-9831-b81a9e1e8716	9d66e03c-d3d5-4215-aaf8-2628d4fab2c6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":341,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:35:43
19548	9d66e03d-1dcb-430e-a01e-aa95ae24bf13	9d66e03d-3cdf-46c6-b5de-92f0b71d13c7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 11:35:43
19549	9d66e03d-33bb-4c12-b2d8-c5c846fa278b	9d66e03d-3cdf-46c6-b5de-92f0b71d13c7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"41.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 11:35:43
19550	9d66e03d-3767-4cfb-a331-b9148deb0d9c	9d66e03d-3cdf-46c6-b5de-92f0b71d13c7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"3.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:35:43
19551	9d66e03d-379a-40e6-b8dc-159a390c7e52	9d66e03d-3cdf-46c6-b5de-92f0b71d13c7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:35:43
19552	9d66e03d-3b89-4b80-896d-c68f7e65a207	9d66e03d-3cdf-46c6-b5de-92f0b71d13c7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 11:35:43
19553	9d66e03d-3bd5-4790-ad02-c1c06ef19d6b	9d66e03d-3cdf-46c6-b5de-92f0b71d13c7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:35:43
11484	9d5cbec3-d414-4429-b70c-4a97582b2c23	9d5cbec4-1c4a-4931-a9cd-e10c897377b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 10:43:50
11485	9d5cbec4-1ae0-47bd-be97-be9c77addb50	9d5cbec4-1c4a-4931-a9cd-e10c897377b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 10:43:50
11486	9d5cbec4-1b79-410b-ae94-317bf02502a3	9d5cbec4-1c4a-4931-a9cd-e10c897377b4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":355,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:43:50
19554	9d66e03e-abb3-4deb-9e8c-45a93e605476	9d66e03e-d9eb-4df0-b6c0-23cbdde4bb3c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 11:35:44
19555	9d66e03e-d00f-47db-9572-30152a4f9342	9d66e03e-d9eb-4df0-b6c0-23cbdde4bb3c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"62.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:35:44
19556	9d66e03e-d08a-485d-8140-9008a245aa21	9d66e03e-d9eb-4df0-b6c0-23cbdde4bb3c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:35:44
19557	9d66e03e-d81d-4fe2-9947-9fc0184c8856	9d66e03e-d9eb-4df0-b6c0-23cbdde4bb3c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 11:35:44
19558	9d66e03e-d8a6-4884-bd3a-708b628b855a	9d66e03e-d9eb-4df0-b6c0-23cbdde4bb3c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":407,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:35:44
11487	9d5cbec4-62f9-4b42-b08b-9d01ea4297cf	9d5cbec4-804d-40d4-b7f2-621df6dae752	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 10:43:50
11488	9d5cbec4-7754-412d-975c-71b4ac3015b2	9d5cbec4-804d-40d4-b7f2-621df6dae752	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 1\\n                        ","time":"39.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"2bd5a29c69f6bbb290fc49b79286632e","hostname":"EderCortes"}	2024-10-29 10:43:50
11489	9d5cbec4-7ac3-41a6-a5b0-1a74e743aa01	9d5cbec4-804d-40d4-b7f2-621df6dae752	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1' order by \\"item_loans\\".\\"id\\" asc","time":"1.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 10:43:50
11490	9d5cbec4-7af2-43ff-8338-5fcf377f7d87	9d5cbec4-804d-40d4-b7f2-621df6dae752	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 10:43:50
11491	9d5cbec4-7ec4-4647-a3ef-0722c2266b5f	9d5cbec4-804d-40d4-b7f2-621df6dae752	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 10:43:51
11492	9d5cbec4-7f35-4e89-ba13-e25614c9af73	9d5cbec4-804d-40d4-b7f2-621df6dae752	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":1,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]}},"duration":223,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:43:51
10257	9d56cc30-fd0d-44c5-8c7d-80fb1b40ef9c	9d56cc31-1a9f-4a3f-b33c-7d2c1b5d0e71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 11:46:25
10258	9d56cc31-191b-4099-b2ff-157e78a01f78	9d56cc31-1a9f-4a3f-b33c-7d2c1b5d0e71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-26 11:46:25
10259	9d56cc31-19ac-4adf-b06d-a041835cbd27	9d56cc31-1a9f-4a3f-b33c-7d2c1b5d0e71	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:46:25
19635	9d66e27e-9216-4c45-ba01-d943d65b77cf	9d66e27e-af2d-42ef-b590-b24cab71b89b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 11:42:01
19636	9d66e27e-ad84-4445-8356-5162aa4d0d61	9d66e27e-af2d-42ef-b590-b24cab71b89b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 11:42:01
19637	9d66e27e-ae1f-4080-9430-b849d49a87fe	9d66e27e-af2d-42ef-b590-b24cab71b89b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:42:01
10260	9d56cc31-605a-46e6-bcbc-6181f392f236	9d56cc31-7a5e-492e-b4d1-248d53b65428	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-26 11:46:25
10261	9d56cc31-762b-4ac7-aad6-715e8902ae3e	9d56cc31-7a5e-492e-b4d1-248d53b65428	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"43.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:46:25
10262	9d56cc31-7955-49f1-973e-50c6664e7a5e	9d56cc31-7a5e-492e-b4d1-248d53b65428	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-26 11:46:25
10263	9d56cc31-7997-4479-bd34-9a0308c10efd	9d56cc31-7a5e-492e-b4d1-248d53b65428	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":214,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:46:25
11493	9d5cbec5-ee2a-4da7-99b5-2a291e661554	9d5cbec6-363c-49cd-8958-caaea83ae1f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 10:43:51
11494	9d5cbec6-3130-498d-b79b-faac82dd44b9	9d5cbec6-363c-49cd-8958-caaea83ae1f6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"152.34","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 10:43:52
11495	9d5cbec6-319d-4dfb-ba1c-b1d4aea9260e	9d5cbec6-363c-49cd-8958-caaea83ae1f6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 10:43:52
11496	9d5cbec6-3501-476e-b258-8f15adc281a6	9d5cbec6-363c-49cd-8958-caaea83ae1f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 10:43:52
11497	9d5cbec6-3543-46f9-98fd-430a6e601de5	9d5cbec6-363c-49cd-8958-caaea83ae1f6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:43:52
19638	9d66e27f-04b6-48bd-bc5e-09991126aeb6	9d66e27f-222f-42bd-8473-53048980182d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 11:42:02
19639	9d66e27f-19c6-4b47-a87a-5642140d048e	9d66e27f-222f-42bd-8473-53048980182d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"42.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 11:42:02
10264	9d56cc33-41dc-45ea-a52f-acd204f67398	9d56cc33-61fe-4d35-a4fd-8296b8aa75e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-26 11:46:26
10265	9d56cc33-5c4d-4706-b0b5-c504984b184a	9d56cc33-61fe-4d35-a4fd-8296b8aa75e3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"46.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:46:26
10266	9d56cc33-5c9e-4779-955e-719ba412c6d9	9d56cc33-61fe-4d35-a4fd-8296b8aa75e3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:46:26
10267	9d56cc33-6094-4eb5-93f5-14076a182a04	9d56cc33-61fe-4d35-a4fd-8296b8aa75e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-26 11:46:26
10268	9d56cc33-60ef-41d2-b03a-9f5e6c6cd50e	9d56cc33-61fe-4d35-a4fd-8296b8aa75e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":283,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:46:26
19640	9d66e27f-1d1c-4c86-957b-483c8a2d46bb	9d66e27f-222f-42bd-8473-53048980182d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:42:02
19641	9d66e27f-1d4f-48d8-9151-90b105b7d5e5	9d66e27f-222f-42bd-8473-53048980182d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:42:02
19642	9d66e27f-2111-4afb-8ae0-053214f363a1	9d66e27f-222f-42bd-8473-53048980182d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 11:42:02
19643	9d66e27f-215a-4f4f-87e6-2e9418b5e445	9d66e27f-222f-42bd-8473-53048980182d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:42:02
19644	9d66e280-7a74-43b0-a36e-78c80392327a	9d66e280-a17c-4245-b299-65043bfa67a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 11:42:02
10348	9d56cdb1-ad7a-46bd-b611-78aaf6c357b9	9d56cdb1-f956-4317-bac7-2ad475135951	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 11:50:37
10349	9d56cdb1-f736-431e-a4f5-ef0d61cfbef7	9d56cdb1-f956-4317-bac7-2ad475135951	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-26 11:50:37
10350	9d56cdb1-f81d-4426-9661-c4038cc1be85	9d56cdb1-f956-4317-bac7-2ad475135951	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":385,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:50:37
19645	9d66e280-9a68-4610-baae-c41c038cd800	9d66e280-a17c-4245-b299-65043bfa67a6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"56.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:42:03
19646	9d66e280-9ac0-4494-8843-1d78894dae22	9d66e280-a17c-4245-b299-65043bfa67a6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:42:03
19647	9d66e280-a013-4d35-8d7a-73e700831c02	9d66e280-a17c-4245-b299-65043bfa67a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 11:42:03
19648	9d66e280-a069-43d1-921a-8b90d989b92d	9d66e280-a17c-4245-b299-65043bfa67a6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":474,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:42:03
10351	9d56cdb2-43b7-4d0d-8696-da2f7d7b824e	9d56cdb2-5e6b-407b-bef9-9d0fc663bcc3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-26 11:50:37
10352	9d56cdb2-5a18-4ff3-8835-f7a93c8c4432	9d56cdb2-5e6b-407b-bef9-9d0fc663bcc3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"45.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:50:37
10353	9d56cdb2-5d63-45c5-8d21-ac81d64fa93b	9d56cdb2-5e6b-407b-bef9-9d0fc663bcc3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-26 11:50:37
10354	9d56cdb2-5da6-49b9-b8a9-35091194ea04	9d56cdb2-5e6b-407b-bef9-9d0fc663bcc3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:50:37
19725	9d66e522-7b27-4f1b-9d8f-5dea4f9251b9	9d66e522-d07d-4950-bb71-7c7bc8ac5a54	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 11:49:24
19726	9d66e522-cd06-49c7-9c6a-15a67d7eb7b4	9d66e522-d07d-4950-bb71-7c7bc8ac5a54	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:49:24
19727	9d66e522-ceeb-4eb8-bc79-ec001358de63	9d66e522-d07d-4950-bb71-7c7bc8ac5a54	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":487,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:49:24
19728	9d66e523-43e5-4f7f-b643-e43db7fc9164	9d66e523-9564-4469-b8ac-5e049c5f2ead	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:49:25
19729	9d66e523-88df-4eb2-bd73-9027ddbe79ac	9d66e523-9564-4469-b8ac-5e049c5f2ead	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"157.85","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 11:49:25
10355	9d56cdb3-748a-4b1f-ae93-de700278cc8c	9d56cdb3-9232-40f1-9cd6-f1743134aac5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-26 11:50:38
9430	9d52f7cb-c629-40ab-a5b1-9e1b40218527	9d52f7cc-127f-4e7f-8807-07cc533e756c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 14:05:02
9431	9d52f7cc-1073-4ff4-9884-f928dfd33d70	9d52f7cc-127f-4e7f-8807-07cc533e756c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 14:05:02
9432	9d52f7cc-112b-4823-8ff6-33851d943e24	9d52f7cc-127f-4e7f-8807-07cc533e756c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":437,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:05:02
10356	9d56cdb3-8d30-4e2a-8f5a-9d26e2553f7b	9d56cdb3-9232-40f1-9cd6-f1743134aac5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:50:38
19730	9d66e523-8da2-47b9-81bf-c5186acdba3f	9d66e523-9564-4469-b8ac-5e049c5f2ead	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:49:25
10357	9d56cdb3-8d80-4959-88ef-9d8ae3ff18d7	9d56cdb3-9232-40f1-9cd6-f1743134aac5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:50:38
10358	9d56cdb3-90c2-4318-8e0d-fbfb5e0bb7b2	9d56cdb3-9232-40f1-9cd6-f1743134aac5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-26 11:50:38
10359	9d56cdb3-9109-457d-8d6c-5c56c97d8d20	9d56cdb3-9232-40f1-9cd6-f1743134aac5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":334,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:50:38
19731	9d66e523-8ddd-4a29-91cc-5bf38296ba08	9d66e523-9564-4469-b8ac-5e049c5f2ead	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:49:25
19732	9d66e523-93aa-4620-bc0a-a0cfad6c4d32	9d66e523-9564-4469-b8ac-5e049c5f2ead	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:49:25
19733	9d66e523-9413-4037-a153-c7e560eaaa73	9d66e523-9564-4469-b8ac-5e049c5f2ead	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":null,"loans_pago_interes":null},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":454,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:49:25
9433	9d52f7cc-61ec-46bd-aa5f-eaa4b1703dd8	9d52f7cc-8256-4ee1-a623-068f84d28b9c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 14:05:02
9434	9d52f7cc-7cab-4c9f-89f5-f166ab260e9c	9d52f7cc-8256-4ee1-a623-068f84d28b9c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 14:05:02
9435	9d52f7cc-7cfd-474e-a122-99375a2d5873	9d52f7cc-8256-4ee1-a623-068f84d28b9c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 14:05:02
9436	9d52f7cc-80be-4016-b1fb-6be4e1a2c51d	9d52f7cc-8256-4ee1-a623-068f84d28b9c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 14:05:02
9437	9d52f7cc-810f-4eef-a461-1bc151eb4ac5	9d52f7cc-8256-4ee1-a623-068f84d28b9c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:05:02
19734	9d66e525-901f-40d1-a20a-3dd2158ef6d9	9d66e525-b760-49b2-9664-b0cedabab2ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:49:26
19735	9d66e525-b248-4471-96ec-960a4120eca8	9d66e525-b760-49b2-9664-b0cedabab2ee	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"54.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:49:26
19736	9d66e525-b294-449f-b925-41de751f0dcb	9d66e525-b760-49b2-9664-b0cedabab2ee	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:49:26
19737	9d66e525-b642-4226-8871-4b2f38d74539	9d66e525-b760-49b2-9664-b0cedabab2ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 11:49:26
19738	9d66e525-b684-4f3d-8371-3e9e59881be9	9d66e525-b760-49b2-9664-b0cedabab2ee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":314,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:49:26
9438	9d52f7cc-c977-4e41-ab91-63bbca486a74	9d52f7cd-16e1-4264-bdcc-0dfc348f974a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 14:05:02
9439	9d52f7cd-107a-4cb8-ade4-d2f74fdf5881	9d52f7cd-16e1-4264-bdcc-0dfc348f974a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"158.78","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 14:05:02
9440	9d52f7cd-10d7-4404-b52a-2eccd150db84	9d52f7cd-16e1-4264-bdcc-0dfc348f974a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 14:05:02
9441	9d52f7cd-1529-4855-bb27-9018ea099a68	9d52f7cd-16e1-4264-bdcc-0dfc348f974a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 14:05:02
9442	9d52f7cd-15cc-4770-91a2-083d040af8c7	9d52f7cd-16e1-4264-bdcc-0dfc348f974a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":365,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:05:02
19815	9d66e7f4-a136-408c-88e0-4bcb01111be6	9d66e7f4-f7d7-465f-b9b0-13af36e37e8b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 11:57:17
19816	9d66e7f4-f5bf-42ff-b0a3-e89bd4b11fb7	9d66e7f4-f7d7-465f-b9b0-13af36e37e8b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:57:18
19817	9d66e7f4-f686-470a-b779-b8cab8f305bb	9d66e7f4-f7d7-465f-b9b0-13af36e37e8b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":505,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:57:18
9443	9d52f7cd-6089-4a00-add8-7bdb747d5986	9d52f7cd-aac2-4348-9ee2-07dbff0d6c33	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 14:05:03
9444	9d52f7cd-a3d1-4f51-afcf-0a5af7294822	9d52f7cd-aac2-4348-9ee2-07dbff0d6c33	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"153.83","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-24 14:05:03
9445	9d52f7cd-a41e-45a8-b372-4d93012ee49a	9d52f7cd-aac2-4348-9ee2-07dbff0d6c33	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 14:05:03
9446	9d52f7cd-a635-4d07-bc55-08b1ef5bf1e9	9d52f7cd-aac2-4348-9ee2-07dbff0d6c33	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"2.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 14:05:03
9447	9d52f7cd-a664-4673-83ac-67eb213d5d04	9d52f7cd-aac2-4348-9ee2-07dbff0d6c33	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 14:05:03
9448	9d52f7cd-a9a0-4ac6-a97d-6575f4da21be	9d52f7cd-aac2-4348-9ee2-07dbff0d6c33	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 14:05:03
9449	9d52f7cd-a9e7-4286-a52c-941f0e350661	9d52f7cd-aac2-4348-9ee2-07dbff0d6c33	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":365,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:05:03
19818	9d66e7f5-785a-40ee-93f9-30b17638daf7	9d66e7f5-9db5-4421-ab55-c0095f89b348	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:57:18
19819	9d66e7f5-90cf-413c-b231-1850103c1ec4	9d66e7f5-9db5-4421-ab55-c0095f89b348	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"49.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 11:57:18
19820	9d66e7f5-965f-45f0-9ba5-423a872cbbb4	9d66e7f5-9db5-4421-ab55-c0095f89b348	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"3.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:57:18
19821	9d66e7f5-96cf-49f1-adb6-32ce683a5b4b	9d66e7f5-9db5-4421-ab55-c0095f89b348	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:57:18
19822	9d66e7f5-9c2f-4bce-8af1-4089024954c4	9d66e7f5-9db5-4421-ab55-c0095f89b348	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:57:18
19823	9d66e7f5-9c93-4ea7-bafd-73b4721be100	9d66e7f5-9db5-4421-ab55-c0095f89b348	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"100000","loans_pago_interes":"50000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:57:18
9450	9d52f7cf-3bc4-41b9-b617-e681cce6e2dd	9d52f7cf-6d7d-4be3-9ad1-69d15ffee295	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 14:05:04
9451	9d52f7cf-6494-47eb-a2df-f7c302497edc	9d52f7cf-6d7d-4be3-9ad1-69d15ffee295	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"66.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 14:05:04
9452	9d52f7cf-650c-4b34-ad6e-b899be1726d9	9d52f7cf-6d7d-4be3-9ad1-69d15ffee295	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 14:05:04
9453	9d52f7cf-6ba6-4a30-819d-40cad816684c	9d52f7cf-6d7d-4be3-9ad1-69d15ffee295	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-24 14:05:04
9454	9d52f7cf-6c0c-4833-a2e8-ce9263a85559	9d52f7cf-6d7d-4be3-9ad1-69d15ffee295	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":568,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:05:04
19824	9d66e7f7-a3a6-4d10-8cde-392710034fbf	9d66e7f7-c1aa-4155-a42a-8b06e50e0771	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:57:19
19825	9d66e7f7-bbf8-4e8d-b5e7-a4b8ef3b7479	9d66e7f7-c1aa-4155-a42a-8b06e50e0771	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:57:19
19826	9d66e7f7-bc51-4946-9049-df36dc43e835	9d66e7f7-c1aa-4155-a42a-8b06e50e0771	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:57:19
19827	9d66e7f7-c069-4863-8751-3fb9afe02858	9d66e7f7-c1aa-4155-a42a-8b06e50e0771	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 11:57:19
19828	9d66e7f7-c0ab-422f-8853-c37a15fc875e	9d66e7f7-c1aa-4155-a42a-8b06e50e0771	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":317,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:57:19
20049	9d66ede2-2436-4b1b-83a3-c50c74d154dc	9d66ede2-73bf-4bf5-a448-42a5ee87cc2d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:13:52
20050	9d66ede2-71a3-432c-93eb-009d386d7c84	9d66ede2-73bf-4bf5-a448-42a5ee87cc2d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:13:52
20051	9d66ede2-728c-4ff8-893a-4c997cbf0a03	9d66ede2-73bf-4bf5-a448-42a5ee87cc2d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":394,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:13:52
19829	9d66e846-773f-48b0-9fce-b65cb52d57af	9d66e846-7b47-403e-8259-6119ca417ab0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":192,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:58:11
20052	9d66ede2-cf95-4fa4-a311-5881321ceddd	9d66ede2-f2a5-4a7a-8d5a-7f59af64f5a3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:13:52
19959	9d66ec49-cef6-43cb-9a75-99eec3825560	9d66ec4a-0915-4439-a773-ac4d457ad010	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 12:09:24
19960	9d66ec4a-06ff-4949-b153-339ae9942fa8	9d66ec4a-0915-4439-a773-ac4d457ad010	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:09:24
19961	9d66ec4a-07e4-4f93-834f-04690c39f51d	9d66ec4a-0915-4439-a773-ac4d457ad010	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":389,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:09:24
20053	9d66ede2-e8a5-40b8-9364-fc2ca9bb02a0	9d66ede2-f2a5-4a7a-8d5a-7f59af64f5a3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"50.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:13:52
20054	9d66ede2-ecf3-4247-9364-862061fbb66d	9d66ede2-f2a5-4a7a-8d5a-7f59af64f5a3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:13:52
20055	9d66ede2-ed34-4c01-9f7d-75906da70ee0	9d66ede2-f2a5-4a7a-8d5a-7f59af64f5a3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:13:52
20056	9d66ede2-f17c-4557-8596-7d639482a016	9d66ede2-f2a5-4a7a-8d5a-7f59af64f5a3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:13:52
20057	9d66ede2-f1d0-4af7-a9de-592bb6ceb137	9d66ede2-f2a5-4a7a-8d5a-7f59af64f5a3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":279,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:13:52
19830	9d66e847-3ecd-48dc-ac64-351149febc4d	9d66e847-628b-4a11-8310-5531ecaddf52	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 11:58:12
19831	9d66e847-57c6-4a93-8005-2b2fb9b4c7e1	9d66e847-628b-4a11-8310-5531ecaddf52	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 183 limit 1","time":"2.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-03 11:58:12
19832	9d66e847-581e-49eb-8aea-a550a53696fe	9d66e847-628b-4a11-8310-5531ecaddf52	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-03 11:58:12
19833	9d66e847-5a03-4556-b143-00f83f992888	9d66e847-628b-4a11-8310-5531ecaddf52	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 61 limit 1","time":"2.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 11:58:12
19834	9d66e847-5a4a-47fd-b7f8-82d43d9f813a	9d66e847-628b-4a11-8310-5531ecaddf52	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 11:58:12
19835	9d66e847-5be5-45c5-8453-3a2795578685	9d66e847-628b-4a11-8310-5531ecaddf52	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '03-11-2024', \\"itemloans_interes_canelado\\" = '50000', \\"itemloans_cuota_cancelada\\" = '100000', \\"updated_at\\" = '2024-11-03 11:58:12' where \\"id\\" = 183","time":"1.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":386,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-03 11:58:12
19836	9d66e847-5c57-426c-9852-18e9c9d1666b	9d66e847-628b-4a11-8310-5531ecaddf52	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:183","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-03 11:58:12","item_loans_cuando_pago":"03-11-2024","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},"hostname":"EderCortes"}	2024-11-03 11:58:12
19837	9d66e847-5d19-403a-8f87-0b24ba72fc05	9d66e847-628b-4a11-8310-5531ecaddf52	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 100000, \\"loans_pago_prestado\\" = 200000, \\"updated_at\\" = '2024-11-03 11:58:12' where \\"id\\" = 61","time":"0.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":394,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-03 11:58:12
19838	9d66e847-5d64-4dff-ae03-41283d7e9046	9d66e847-628b-4a11-8310-5531ecaddf52	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:61","changes":{"updated_at":"2024-11-03 11:58:12","loans_pago_interes":100000,"loans_pago_prestado":200000},"hostname":"EderCortes"}	2024-11-03 11:58:12
19839	9d66e847-6114-42ae-a8aa-2c064f4687db	9d66e847-628b-4a11-8310-5531ecaddf52	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 11:58:12
19840	9d66e847-6164-49b5-8d88-8c930263a37c	9d66e847-628b-4a11-8310-5531ecaddf52	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"179","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000","id":183,"loans_codigo":61,"itemloans_cuota":"2","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":286,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:58:12
19962	9d66ec4a-7e61-4fee-b93f-f5da29001950	9d66ec4a-a772-4c3f-ae9c-2aaddaca4905	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:09:25
19963	9d66ec4a-994c-4063-9c20-c99ad57c9f04	9d66ec4a-a772-4c3f-ae9c-2aaddaca4905	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"52.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:09:25
19964	9d66ec4a-9daa-4308-826e-3ba897c12428	9d66ec4a-a772-4c3f-ae9c-2aaddaca4905	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:09:25
19965	9d66ec4a-9de8-4bfa-98d2-687ad5ce3289	9d66ec4a-a772-4c3f-ae9c-2aaddaca4905	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:09:25
19966	9d66ec4a-a581-4299-ab60-d9c3bae62de8	9d66ec4a-a772-4c3f-ae9c-2aaddaca4905	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:09:25
19841	9d66e847-bfa4-4694-b886-9f956f3b2b4d	9d66e848-0eb6-4f68-9212-1ad928a7b086	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 11:58:12
19842	9d66e848-0554-4e15-99d9-45b7b71d7245	9d66e848-0eb6-4f68-9212-1ad928a7b086	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"160.28","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 11:58:12
19843	9d66e848-0935-4c4f-9b41-fc578b98ee3a	9d66e848-0eb6-4f68-9212-1ad928a7b086	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:58:12
19844	9d66e848-096b-4844-bd23-a6d3ca83963c	9d66e848-0eb6-4f68-9212-1ad928a7b086	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:58:12
19845	9d66e848-0d57-43b2-b0ed-665760c9a78b	9d66e848-0eb6-4f68-9212-1ad928a7b086	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 11:58:12
19846	9d66e848-0daa-4246-a041-b9c642f35dce	9d66e848-0eb6-4f68-9212-1ad928a7b086	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"200000","loans_pago_interes":"100000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":418,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:58:12
19967	9d66ec4a-a5e8-433d-a98e-173d54b57fc1	9d66ec4a-a772-4c3f-ae9c-2aaddaca4905	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":361,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:09:25
19847	9d66e86d-ebb4-4771-9c12-ca84abcb1ca3	9d66e86d-eeb3-464d-bea2-128a89ff6f33	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-intereses","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":147,"memory":20,"hostname":"EderCortes"}	2024-11-03 11:58:37
19968	9d66ec4c-8fe1-4034-96a7-593cb7346145	9d66ec4c-ce3b-4af6-be06-bf9ad363d39f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:09:26
10517	9d570ede-e970-4473-93bd-bbe6160f077f	9d570edf-0e8a-4cd1-97ac-9c982c45f0f9	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 14:52:52
10518	9d570edf-0c79-45ce-b8a8-a44873c235ae	9d570edf-0e8a-4cd1-97ac-9c982c45f0f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 14:52:52
10439	9d56cfae-b58e-4d62-b833-52cdc9267640	9d56cfae-fc5a-4c8a-9d03-16fce105bf06	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-26 11:56:10
10440	9d56cfae-fae0-4201-a5da-528cfbc49a75	9d56cfae-fc5a-4c8a-9d03-16fce105bf06	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-26 11:56:10
10441	9d56cfae-fb83-4c17-bfe6-9be44f35f23f	9d56cfae-fc5a-4c8a-9d03-16fce105bf06	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:56:10
10519	9d570edf-0d6d-49d6-aba2-999971f681de	9d570edf-0e8a-4cd1-97ac-9c982c45f0f9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":290,"memory":22,"hostname":"EderCortes"}	2024-10-26 14:52:52
19969	9d66ec4c-c424-48e6-8abe-f586d44610a5	9d66ec4c-ce3b-4af6-be06-bf9ad363d39f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"87.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:09:26
19970	9d66ec4c-c4bb-4439-a339-a6aa76de2378	9d66ec4c-ce3b-4af6-be06-bf9ad363d39f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:09:26
19971	9d66ec4c-cc21-4bee-8ef6-30de6a575686	9d66ec4c-ce3b-4af6-be06-bf9ad363d39f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:09:26
19972	9d66ec4c-ccb0-40fb-af01-83391dcbf0bf	9d66ec4c-ce3b-4af6-be06-bf9ad363d39f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":581,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:09:26
10442	9d56cfaf-410f-451b-b4b6-db1fa1c16db0	9d56cfaf-5c7f-439f-a269-fb0026ae9023	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-26 11:56:11
10443	9d56cfaf-57b9-47fd-b3b6-19d199999613	9d56cfaf-5c7f-439f-a269-fb0026ae9023	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"46.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:56:11
10444	9d56cfaf-5b4c-4680-8bf6-bf5862a6444d	9d56cfaf-5c7f-439f-a269-fb0026ae9023	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-26 11:56:11
10445	9d56cfaf-5b8e-4665-b0f0-bf5882cc260e	9d56cfaf-5c7f-439f-a269-fb0026ae9023	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":215,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:56:11
10520	9d570edf-75ef-4c55-a00e-1e27f4ea26eb	9d570edf-9188-4254-8941-7fa02fd934a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 14:52:52
10521	9d570edf-8c42-4309-a4b9-4226673863c3	9d570edf-9188-4254-8941-7fa02fd934a5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"43.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 14:52:52
10522	9d570edf-9050-4bdb-aae9-490cc4e162d2	9d570edf-9188-4254-8941-7fa02fd934a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 14:52:52
10523	9d570edf-90a3-4871-9d26-c1d07badf137	9d570edf-9188-4254-8941-7fa02fd934a5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":302,"memory":22,"hostname":"EderCortes"}	2024-10-26 14:52:52
19848	9d66e86e-5127-4bdc-8851-75170e00dfb8	9d66e86e-794b-4494-87e5-80f77e9a915c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 11:58:37
19849	9d66e86e-6ce7-44dd-ad6e-25b7c7234031	9d66e86e-794b-4494-87e5-80f77e9a915c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 184 limit 1","time":"2.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":424,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-03 11:58:37
19850	9d66e86e-6d47-4c47-8160-662c132f9171	9d66e86e-794b-4494-87e5-80f77e9a915c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-03 11:58:37
19851	9d66e86e-6eee-4c48-9f6c-e244143e0883	9d66e86e-794b-4494-87e5-80f77e9a915c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 61 limit 1","time":"2.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":425,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 11:58:37
19852	9d66e86e-6f1c-435a-a03d-9dd244f85476	9d66e86e-794b-4494-87e5-80f77e9a915c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 11:58:37
10446	9d56cfb0-8763-4f4e-ac22-32c4c3130e88	9d56cfb0-d282-4dce-8d46-edc54dbec16b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-26 11:56:12
10447	9d56cfb0-cd62-4233-8884-c288e5ba8179	9d56cfb0-d282-4dce-8d46-edc54dbec16b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"156.17","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:56:12
10448	9d56cfb0-cdaf-47a3-8ba0-cc183cd10450	9d56cfb0-d282-4dce-8d46-edc54dbec16b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:56:12
10449	9d56cfb0-d12d-4d17-8bce-228c5d4875c5	9d56cfb0-d282-4dce-8d46-edc54dbec16b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-26 11:56:12
10450	9d56cfb0-d171-44b6-8a2f-22aeeed4d74a	9d56cfb0-d282-4dce-8d46-edc54dbec16b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":469,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:56:12
10524	9d570ee0-f94b-4f26-a2cb-8f9ca5058e77	9d570ee1-494e-4f10-89d6-10fc146dcf27	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 14:52:53
10525	9d570ee1-41a6-4fe5-a9ee-d1f5a13dd0e4	9d570ee1-494e-4f10-89d6-10fc146dcf27	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"159.09","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 14:52:53
10526	9d570ee1-4205-4ee1-b63f-04dab37b0a8e	9d570ee1-494e-4f10-89d6-10fc146dcf27	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 14:52:53
10527	9d570ee1-47a2-4964-980f-d23a24c681d7	9d570ee1-494e-4f10-89d6-10fc146dcf27	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 14:52:53
10528	9d570ee1-4806-4925-9c45-dfd7c60d2524	9d570ee1-494e-4f10-89d6-10fc146dcf27	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":442,"memory":22,"hostname":"EderCortes"}	2024-10-26 14:52:53
19853	9d66e86e-72c4-4d1a-9cef-3ed2420b7f7d	9d66e86e-794b-4494-87e5-80f77e9a915c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Abono intereses', \\"item_loans_cuando_pago\\" = '03-11-2024', \\"itemloans_interes_canelado\\" = '50000', \\"itemloans_cuota_cancelada\\" = 0, \\"updated_at\\" = '2024-11-03 11:58:37' where \\"id\\" = 184","time":"7.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":446,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-03 11:58:37
19854	9d66e86e-733c-42e0-8f61-bd8caf88f10b	9d66e86e-794b-4494-87e5-80f77e9a915c	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:184","changes":{"itemloans_status":"Abono intereses","updated_at":"2024-11-03 11:58:37","item_loans_cuando_pago":"03-11-2024","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":0},"hostname":"EderCortes"}	2024-11-03 11:58:37
19855	9d66e86e-73e2-4cd2-9c9e-e5ce47656b70	9d66e86e-794b-4494-87e5-80f77e9a915c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 150000, \\"updated_at\\" = '2024-11-03 11:58:37' where \\"id\\" = 61","time":"0.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":454,"hash":"2cc48cbe18727cffabd573a782a26616","hostname":"EderCortes"}	2024-11-03 11:58:37
19856	9d66e86e-7411-4b89-b41e-31e68f29b443	9d66e86e-794b-4494-87e5-80f77e9a915c	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:61","changes":{"updated_at":"2024-11-03 11:58:37","loans_pago_interes":150000},"hostname":"EderCortes"}	2024-11-03 11:58:37
19857	9d66e86e-77dc-4ba0-8881-7576f61ccbf4	9d66e86e-794b-4494-87e5-80f77e9a915c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:58:37
19858	9d66e86e-7831-4926-991a-bc9298667240	9d66e86e-794b-4494-87e5-80f77e9a915c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-intereses","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payInterese","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"150","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":0,"id":184,"loans_codigo":61,"item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El abono a intereses  de la cuota fue aplicado exitosamente","status":true},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:58:37
7466	9d52ddab-2d1e-4d01-91c2-480606bed380	9d52ddab-5268-48bd-be95-a57ff5f01431	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 12:51:58
7467	9d52ddab-5031-47ed-98ae-c8b1c21b89e7	9d52ddab-5268-48bd-be95-a57ff5f01431	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:51:58
7468	9d52ddab-512a-4188-b6ed-63ea1a48c32c	9d52ddab-5268-48bd-be95-a57ff5f01431	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":382,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:51:58
20134	9d66eeae-5cde-4555-93d5-d1232fa51f66	9d66eeae-7a27-4c1f-9230-a8d7b904d62a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 12:16:06
20135	9d66eeae-787a-4b05-b18f-e8d572496414	9d66eeae-7a27-4c1f-9230-a8d7b904d62a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-03 12:16:06
20136	9d66eeae-7912-408c-9c14-ec1f2dcdb42b	9d66eeae-7a27-4c1f-9230-a8d7b904d62a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":220,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:16:06
14635	9d5ebef2-973c-4bfa-8ef8-cc6c0a71a7a5	9d5ebef2-9d08-437a-b030-16e37577ad6b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":671}	2024-10-30 10:36:00
7469	9d52ddab-a868-4de0-b764-cc821273cc52	9d52ddab-cdb7-4467-97ed-2d59f99fcabf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 12:51:58
7470	9d52ddab-c7ba-4543-a18a-831fe1d173bd	9d52ddab-cdb7-4467-97ed-2d59f99fcabf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"51.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:51:59
7471	9d52ddab-c81a-4ae5-94d9-dcd9fe997179	9d52ddab-cdb7-4467-97ed-2d59f99fcabf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:51:59
7472	9d52ddab-cc43-4082-a5e9-bed72dc60ebc	9d52ddab-cdb7-4467-97ed-2d59f99fcabf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 12:51:59
7473	9d52ddab-cc94-408a-bce4-f5b728a608c6	9d52ddab-cdb7-4467-97ed-2d59f99fcabf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":281,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:51:59
19859	9d66e86e-d30f-46da-a3dc-8a168f677aea	9d66e86e-f209-4ae4-990a-ef4fc8dbcff1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:58:38
19860	9d66e86e-e866-4b5d-9d9d-cefb81085dc2	9d66e86e-f209-4ae4-990a-ef4fc8dbcff1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"42.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 11:58:38
19861	9d66e86e-ec8b-4cf2-8518-46b8e9845ab6	9d66e86e-f209-4ae4-990a-ef4fc8dbcff1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:58:38
19862	9d66e86e-ecbb-4d94-b849-153b2230873a	9d66e86e-f209-4ae4-990a-ef4fc8dbcff1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:58:38
19863	9d66e86e-f0a0-4048-b1a7-ab33a6fcd8dd	9d66e86e-f209-4ae4-990a-ef4fc8dbcff1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:58:38
19864	9d66e86e-f0fa-4348-9e64-274d93b28398	9d66e86e-f209-4ae4-990a-ef4fc8dbcff1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"200000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:37.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"0"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":289,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:58:38
20137	9d66eeae-c0e2-4153-8542-9889486a1cb8	9d66eeaf-09f1-4a88-bf14-5c42dc85f9cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-03 12:16:06
7474	9d52ddac-27d2-496a-9e34-5199e2321b39	9d52ddac-7889-42c7-9b39-765b10593529	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 12:51:59
7475	9d52ddac-724c-475b-8de1-5ef63ec95a28	9d52ddac-7889-42c7-9b39-765b10593529	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"163.36","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:51:59
7476	9d52ddac-72a3-4b75-a32e-267a2dde243c	9d52ddac-7889-42c7-9b39-765b10593529	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:51:59
7477	9d52ddac-770c-438f-9b76-2ced6947a915	9d52ddac-7889-42c7-9b39-765b10593529	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 12:51:59
7478	9d52ddac-7770-4eb5-b2ba-9257e4f1b9cb	9d52ddac-7889-42c7-9b39-765b10593529	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":415,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:51:59
20138	9d66eeaf-00e8-4e6d-9154-c6536a56b3d0	9d66eeaf-09f1-4a88-bf14-5c42dc85f9cd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"151.71","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:16:06
7479	9d52ddac-dbb2-49b8-8bf1-f20722258fa0	9d52ddad-03aa-4bcd-8d5e-d6ec2e40cb2c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 12:51:59
7480	9d52ddac-fa84-4581-b1f2-36dd4ad1384b	9d52ddad-03aa-4bcd-8d5e-d6ec2e40cb2c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"52.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:51:59
7481	9d52ddac-faf5-4be9-9fe8-6844c78a7f7b	9d52ddad-03aa-4bcd-8d5e-d6ec2e40cb2c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:51:59
7482	9d52ddac-fd0e-4d7d-a142-9d612cf5bd23	9d52ddad-03aa-4bcd-8d5e-d6ec2e40cb2c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"2.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:51:59
7483	9d52ddac-fd53-43d7-bfca-78f4fe038f30	9d52ddad-03aa-4bcd-8d5e-d6ec2e40cb2c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:51:59
7484	9d52ddad-0218-4b36-b3c9-d2bc925c73fa	9d52ddad-03aa-4bcd-8d5e-d6ec2e40cb2c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 12:51:59
7485	9d52ddad-028d-4f30-aaaf-01d559069478	9d52ddad-03aa-4bcd-8d5e-d6ec2e40cb2c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:51:59
20139	9d66eeaf-047f-475f-8d5e-625fe6aecb2e	9d66eeaf-09f1-4a88-bf14-5c42dc85f9cd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"1.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:16:06
20140	9d66eeaf-04af-4225-92eb-0b19dadbc411	9d66eeaf-09f1-4a88-bf14-5c42dc85f9cd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:16:06
20141	9d66eeaf-089f-421e-880f-907ccda5c7f0	9d66eeaf-09f1-4a88-bf14-5c42dc85f9cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-03 12:16:06
20142	9d66eeaf-0907-4f45-915c-b9c3dd4f869d	9d66eeaf-09f1-4a88-bf14-5c42dc85f9cd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:16:06
20242	9d66f0a5-795c-4e8a-bd9b-f4bd3244b2cc	9d66f0a5-c5bb-4759-86e0-6d2c3a408866	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 12:21:36
20243	9d66f0a5-c3d5-4794-80d2-71da42448f8b	9d66f0a5-c5bb-4759-86e0-6d2c3a408866	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:21:36
20244	9d66f0a5-c499-40b9-9dbb-6b62944a2453	9d66f0a5-c5bb-4759-86e0-6d2c3a408866	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":366,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:21:36
7486	9d52ddaf-1e4d-41d8-b5c5-9256cf64e8a6	9d52ddaf-49a7-42e1-8725-648de3c03e9b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 12:52:01
7487	9d52ddaf-43e5-427c-99b4-c6629534326a	9d52ddaf-49a7-42e1-8725-648de3c03e9b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"51.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:52:01
7488	9d52ddaf-4435-4692-a354-261c68d5c896	9d52ddaf-49a7-42e1-8725-648de3c03e9b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:52:01
7489	9d52ddaf-4818-4f2a-97aa-87f4f1fbc922	9d52ddaf-49a7-42e1-8725-648de3c03e9b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 12:52:01
7490	9d52ddaf-4889-4936-976b-770b65bf8b9c	9d52ddaf-49a7-42e1-8725-648de3c03e9b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":394,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:52:01
20143	9d66eeb0-4b10-4bbf-99ec-b294e25dd6e1	9d66eeb0-9050-4a0d-bdbe-e60125f2ffb2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-03 12:16:07
20144	9d66eeb0-8672-4f29-af21-42a59725bbcf	9d66eeb0-9050-4a0d-bdbe-e60125f2ffb2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"123.12","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:16:07
15101	9d5ecee5-5960-4907-8c23-d148d70af8c9	9d5ecee5-8ff9-48a9-bca3-5aa63218a251	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 11:20:36
15102	9d5ecee5-8d20-493f-a3ce-a648f879b45f	9d5ecee5-8ff9-48a9-bca3-5aa63218a251	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 11:20:36
15103	9d5ecee5-8e84-4223-8d45-391fb5603623	9d5ecee5-8ff9-48a9-bca3-5aa63218a251	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":658,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:20:36
20145	9d66eeb0-86fb-41af-a047-24eed730f9f2	9d66eeb0-9050-4a0d-bdbe-e60125f2ffb2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:16:07
20146	9d66eeb0-8e35-4f8b-8922-b7f74d8e6a22	9d66eeb0-9050-4a0d-bdbe-e60125f2ffb2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-03 12:16:07
20147	9d66eeb0-8edd-4425-a6a6-466b4fb5ef3c	9d66eeb0-9050-4a0d-bdbe-e60125f2ffb2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":486,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:16:07
20245	9d66f0a6-2c0e-410e-8af7-b91bc6e7a294	9d66f0a6-4cf6-4087-8716-a84436b3a9ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:21:36
20246	9d66f0a6-4399-4445-ab63-5180e2fa2847	9d66f0a6-4cf6-4087-8716-a84436b3a9ed	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"43.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:21:36
20247	9d66f0a6-4782-411c-9034-5e780d76b571	9d66f0a6-4cf6-4087-8716-a84436b3a9ed	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:21:36
20248	9d66f0a6-47b0-4b2c-a43e-3a4b5125be20	9d66f0a6-4cf6-4087-8716-a84436b3a9ed	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:21:36
20249	9d66f0a6-4bf0-42a9-be01-eacabeee789d	9d66f0a6-4cf6-4087-8716-a84436b3a9ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:21:36
5136	9d51367b-9073-4d3a-ab76-1d2a24b12e28	9d51367b-c974-44d1-9358-927c6931024b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-23 17:08:39
5137	9d51367b-c67f-45d1-a92c-f8a8da414d0a	9d51367b-c974-44d1-9358-927c6931024b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-23 17:08:39
5138	9d51367b-c7de-4841-80eb-af5a87addb52	9d51367b-c974-44d1-9358-927c6931024b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":499,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:08:39
15104	9d5ecee6-1693-4b6d-8fe9-c246da8c851c	9d5ecee6-3f7f-40b3-b348-c60df9412b7a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 11:20:36
15105	9d5ecee6-395a-4add-898c-afe15d72b2a9	9d5ecee6-3f7f-40b3-b348-c60df9412b7a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 11:20:36
15106	9d5ecee6-39c7-4ec6-98b8-42d143a1b4db	9d5ecee6-3f7f-40b3-b348-c60df9412b7a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-30 11:20:36
20250	9d66f0a6-4c34-47aa-b1b7-805f7ce51e29	9d66f0a6-4cf6-4087-8716-a84436b3a9ed	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:21:36
15107	9d5ecee6-3e5f-4a2e-b380-a184359e01df	9d5ecee6-3f7f-40b3-b348-c60df9412b7a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 11:20:36
15108	9d5ecee6-3ea5-4981-8001-7cec08e23524	9d5ecee6-3f7f-40b3-b348-c60df9412b7a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":402,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:20:36
20251	9d66f0a8-5753-4ce9-91b3-c6621e9398df	9d66f0a8-83a0-4e02-9281-214e29cbd8c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:21:37
20252	9d66f0a8-7cd0-470e-90d9-aee10350ad09	9d66f0a8-83a0-4e02-9281-214e29cbd8c0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"58.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:21:37
20253	9d66f0a8-7d3b-4f0e-9559-4b94546eb971	9d66f0a8-83a0-4e02-9281-214e29cbd8c0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:21:37
20254	9d66f0a8-81c0-4f16-ba59-22d67cdd44fb	9d66f0a8-83a0-4e02-9281-214e29cbd8c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:21:38
20255	9d66f0a8-824d-44d0-889e-e80722507bd9	9d66f0a8-83a0-4e02-9281-214e29cbd8c0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":384,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:21:38
15109	9d5ecee6-927f-41d7-a62a-88962dcf6a46	9d5ecee6-db02-4ece-bfb9-6ae32799dacc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 11:20:37
15110	9d5ecee6-d5d9-4581-8894-c0fe6422b753	9d5ecee6-db02-4ece-bfb9-6ae32799dacc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"145.40","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 11:20:37
15111	9d5ecee6-d65a-4837-9575-8d9492327b09	9d5ecee6-db02-4ece-bfb9-6ae32799dacc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-30 11:20:37
15112	9d5ecee6-d9af-4f5f-a3d5-c922d12946f3	9d5ecee6-db02-4ece-bfb9-6ae32799dacc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-30 11:20:37
8127	9d52e719-e4f7-4adf-8fb7-75109217abbe	9d52e71a-03a6-4eeb-994a-98c580e1f569	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:18:21
8128	9d52e71a-01f2-420f-9f65-38e8d743919f	9d52e71a-03a6-4eeb-994a-98c580e1f569	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:18:21
8129	9d52e71a-0296-4039-9ab0-66511cd71fc2	9d52e71a-03a6-4eeb-994a-98c580e1f569	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:18:21
15113	9d5ecee6-da09-4f76-8cfe-ab6a2376bb75	9d5ecee6-db02-4ece-bfb9-6ae32799dacc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":385,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:20:37
20347	9d66f176-fee9-4057-9e76-c59537bd3ed9	9d66f177-2357-47b7-a746-adf593e3e9c6	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 12:23:53
20348	9d66f177-2165-4607-86c6-e8a787075649	9d66f177-2357-47b7-a746-adf593e3e9c6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:23:53
20349	9d66f177-221b-4705-9363-9ea674dd90e5	9d66f177-2357-47b7-a746-adf593e3e9c6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:23:53
2	9d4cf072-a17a-4b93-ab01-c17db62ef4b0	9d4cf072-a6ba-4789-9d86-6dd367c14bf6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[23502]: Not null violation: 7 ERROR:  el valor nulo en la columna \\u00abpassword\\u00bb de la relaci\\u00f3n \\u00abusers\\u00bb viola la restricci\\u00f3n de no nulo\\nDETAIL:  La fila que falla contiene (1, 123456789, edercortez10@gmail.com, null, null, Cortes, Cabezas, CC, 1004608333, null, Cali, Las orquideas, Calle 107a No 28a 66, 3152596295, null, null, 29, 1, null, 0, null, 2024-10-21 14:09:31, 2024-10-21 14:09:31, null). (Connection: pgsql, SQL: insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"user_photo\\", \\"user_state\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"updated_at\\", \\"created_at\\") values (123456789, edercortez10@gmail.com, Cortes, Cabezas, CC, 1004608333, ?, Cali, Las orquideas, Calle 107a No 28a 66, 3152596295, ?, ?, 1, 29, ?, 2024-10-21 14:09:31, 2024-10-21 14:09:31) returning \\"id\\")","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":401},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor.php","line":24},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3549},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":1982},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1334},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1299},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1138},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":35},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1}	2024-10-21 14:09:31
8130	9d52e71a-4e8d-4df2-af4e-cb8439c29e37	9d52e71a-962f-42f9-85a2-35c1a2d49880	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:18:21
8131	9d52e71a-916a-45cf-8044-586d974b1c46	9d52e71a-962f-42f9-85a2-35c1a2d49880	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"149.26","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:18:21
8132	9d52e71a-91cb-4fbd-af39-9df5992c6732	9d52e71a-962f-42f9-85a2-35c1a2d49880	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:18:21
8133	9d52e71a-9522-4627-8722-9ba140b52d23	9d52e71a-962f-42f9-85a2-35c1a2d49880	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:18:21
8134	9d52e71a-9562-4764-87cd-90928fb71e2b	9d52e71a-962f-42f9-85a2-35c1a2d49880	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:18:21
9612	9d53c5d7-2516-45dc-b8f2-c8b6e3d7f899	9d53c5d7-6901-407a-a5b1-9092ea126388	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 23:41:10
9613	9d53c5d7-64cd-4fa6-bf31-6d8bece7ec7f	9d53c5d7-6901-407a-a5b1-9092ea126388	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 23:41:10
9614	9d53c5d7-66ae-42b4-b306-4c963236ed38	9d53c5d7-6901-407a-a5b1-9092ea126388	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":836,"memory":22,"hostname":"EderCortes"}	2024-10-24 23:41:10
20350	9d66f177-980f-4166-957d-f49c88480c4d	9d66f177-bb77-4cd4-ad06-c01dea8c2b7e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:23:53
10601	9d5710f8-a768-4c23-8506-2ebf9c30debd	9d5710f8-c770-4818-8242-9a847864b512	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 14:58:44
10602	9d5710f8-c58a-4f9d-b1fc-807ffeacaa44	9d5710f8-c770-4818-8242-9a847864b512	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 14:58:44
10603	9d5710f8-c64f-411a-b74e-78801b468bc9	9d5710f8-c770-4818-8242-9a847864b512	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":264,"memory":22,"hostname":"EderCortes"}	2024-10-26 14:58:44
20351	9d66f177-ae77-4066-b178-9f86aaf952eb	9d66f177-bb77-4cd4-ad06-c01dea8c2b7e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"44.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:23:53
20352	9d66f177-b31d-4346-b266-736b383d0d3a	9d66f177-bb77-4cd4-ad06-c01dea8c2b7e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"3.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:23:53
20353	9d66f177-b365-418c-817c-f5fd99ed326a	9d66f177-bb77-4cd4-ad06-c01dea8c2b7e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:23:53
20354	9d66f177-ba4a-4f14-bfc7-6eeeef90af7e	9d66f177-bb77-4cd4-ad06-c01dea8c2b7e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:23:53
20355	9d66f177-ba96-472b-845f-334115b9806c	9d66f177-bb77-4cd4-ad06-c01dea8c2b7e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:23:53
8135	9d52e71a-dc52-4490-9794-10866888727e	9d52e71b-23e8-4507-a0ac-20e52692f78f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:18:21
8136	9d52e71b-1f5e-4570-803a-9479c2de6255	9d52e71b-23e8-4507-a0ac-20e52692f78f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"149.09","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:18:21
8137	9d52e71b-1fab-4bc5-927d-9576c49809ea	9d52e71b-23e8-4507-a0ac-20e52692f78f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:18:21
8138	9d52e71b-22dc-449a-aab3-7ebee3c1472b	9d52e71b-23e8-4507-a0ac-20e52692f78f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:18:21
8139	9d52e71b-231b-436a-83b8-0390972719c8	9d52e71b-23e8-4507-a0ac-20e52692f78f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":344,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:18:21
9615	9d53c5d8-1063-42ef-aec2-93f8d98f4180	9d53c5d8-436b-4aff-9814-1f0d8b5693da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 23:41:11
9616	9d53c5d8-393d-4971-9740-435ec4cf3f1d	9d53c5d8-436b-4aff-9814-1f0d8b5693da	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"58.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 23:41:11
9617	9d53c5d8-39b7-4b2a-b90e-06fd507d3984	9d53c5d8-436b-4aff-9814-1f0d8b5693da	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 23:41:11
9618	9d53c5d8-41c2-4025-8c30-af1dc8c917cc	9d53c5d8-436b-4aff-9814-1f0d8b5693da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 23:41:11
9619	9d53c5d8-4231-4757-ae8e-dc669878df78	9d53c5d8-436b-4aff-9814-1f0d8b5693da	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":503,"memory":22,"hostname":"EderCortes"}	2024-10-24 23:41:11
10604	9d5710f9-12fe-4982-b7bd-3e599232c5a5	9d5710f9-3376-4e41-9a3b-aca031f527be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 14:58:44
10605	9d5710f9-29c1-442a-b5bb-010dd2a4847a	9d5710f9-3376-4e41-9a3b-aca031f527be	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"42.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 14:58:44
10606	9d5710f9-2d92-4a93-9d2b-e19fa6306446	9d5710f9-3376-4e41-9a3b-aca031f527be	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '5' order by \\"item_loans\\".\\"id\\" asc","time":"1.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-26 14:58:44
10607	9d5710f9-2dc7-4f5e-a12e-5823f9858071	9d5710f9-3376-4e41-9a3b-aca031f527be	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-26 14:58:44
10608	9d5710f9-31e0-49e2-8e13-743a6178fb6b	9d5710f9-3376-4e41-9a3b-aca031f527be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 14:58:44
20356	9d66f179-03f7-48ca-a298-e5726a12e410	9d66f179-32e2-444a-a922-afa82e81cfd8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:23:54
8140	9d52e71b-6641-4ec9-9ef4-efa59c29b85f	9d52e71b-86a4-4e99-8384-6c6bf15faaf3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:18:22
8141	9d52e71b-7fb0-49aa-9384-0f60021c4f1e	9d52e71b-86a4-4e99-8384-6c6bf15faaf3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc","time":"44.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 13:18:22
8142	9d52e71b-7ffd-494e-8ed0-c5360e07cab2	9d52e71b-86a4-4e99-8384-6c6bf15faaf3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:18:22
8143	9d52e71b-815f-4b9b-bab9-eba5dd782842	9d52e71b-86a4-4e99-8384-6c6bf15faaf3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6'","time":"1.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 13:18:22
7076	9d52da9d-32eb-4526-918c-e371d04787a7	9d52da9d-7e8f-4c90-bdb9-5c88068938cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 12:43:26
7077	9d52da9d-7c3f-4dda-8564-b7dfb49bd03c	9d52da9d-7e8f-4c90-bdb9-5c88068938cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 12:43:26
7078	9d52da9d-7d01-4a9a-adf3-16be5423a769	9d52da9d-7e8f-4c90-bdb9-5c88068938cf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":403,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:43:26
8144	9d52e71b-8195-4cc8-9ad8-82c28db855c2	9d52e71b-86a4-4e99-8384-6c6bf15faaf3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:18:22
8145	9d52e71b-8583-4784-9893-2a7b31b24e0a	9d52e71b-86a4-4e99-8384-6c6bf15faaf3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:18:22
8146	9d52e71b-85d0-443c-8ab1-3498654125ba	9d52e71b-86a4-4e99-8384-6c6bf15faaf3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:18:22
9620	9d53c5d8-a1a5-4a1f-a641-63624c7ce0e8	9d53c5d8-c62f-423b-a1b8-fcf620f66547	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 23:41:11
9621	9d53c5d8-bf28-4d76-989e-826e674a3eec	9d53c5d8-c62f-423b-a1b8-fcf620f66547	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 23:41:11
9622	9d53c5d8-bf8d-400f-aceb-b83d620d14d3	9d53c5d8-c62f-423b-a1b8-fcf620f66547	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 23:41:11
9623	9d53c5d8-c4c4-4489-bc11-7c233341fad0	9d53c5d8-c62f-423b-a1b8-fcf620f66547	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 23:41:11
9624	9d53c5d8-c523-4e30-bc8c-40e2e551f7d8	9d53c5d8-c62f-423b-a1b8-fcf620f66547	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":319,"memory":22,"hostname":"EderCortes"}	2024-10-24 23:41:11
10609	9d5710f9-3269-4204-b5f4-e4907d2e6cb2	9d5710f9-3376-4e41-9a3b-aca031f527be	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":25,"loans_codigo":5,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":26,"loans_codigo":5,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":27,"loans_codigo":5,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":28,"loans_codigo":5,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":29,"loans_codigo":5,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":30,"loans_codigo":5,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null}]}},"duration":242,"memory":22,"hostname":"EderCortes"}	2024-10-26 14:58:44
20357	9d66f179-29c1-4e6a-8231-6d577a87c39d	9d66f179-32e2-444a-a922-afa82e81cfd8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"63.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:23:54
20358	9d66f179-2a45-4853-a49d-d86f6e174258	9d66f179-32e2-444a-a922-afa82e81cfd8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:23:54
20359	9d66f179-311b-458c-ad21-f6af541305aa	9d66f179-32e2-444a-a922-afa82e81cfd8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:23:54
7079	9d52da9d-d73a-49a5-91d5-35341050a383	9d52da9d-f744-47ce-a2ba-3707c998bc0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 12:43:26
7080	9d52da9d-f1a2-46b7-9a58-4cb76aa71118	9d52da9d-f744-47ce-a2ba-3707c998bc0d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:43:26
7081	9d52da9d-f226-4675-ab29-543c1df8c89d	9d52da9d-f744-47ce-a2ba-3707c998bc0d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:43:26
7082	9d52da9d-f5f3-4dc5-b258-7c547247dfad	9d52da9d-f744-47ce-a2ba-3707c998bc0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 12:43:26
7083	9d52da9d-f64e-4017-8c4a-d8bc7364b0e1	9d52da9d-f744-47ce-a2ba-3707c998bc0d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:43:26
8147	9d52e71d-053f-408c-af68-d79fc1fb7fd1	9d52e71d-3c30-4512-b3a2-24a00bc12127	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:18:23
8148	9d52e71d-342f-47a1-9c1a-1db47dd7dd98	9d52e71d-3c30-4512-b3a2-24a00bc12127	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"71.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:18:23
8149	9d52e71d-34b8-4faa-a2aa-2f8dcff5cccc	9d52e71d-3c30-4512-b3a2-24a00bc12127	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:18:23
8150	9d52e71d-3a50-4e49-b1fa-9771f63e433f	9d52e71d-3c30-4512-b3a2-24a00bc12127	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 13:18:23
8151	9d52e71d-3aa1-4f20-8c12-d95d324b81c1	9d52e71d-3c30-4512-b3a2-24a00bc12127	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":495,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:18:23
9625	9d53c5da-b721-4d8b-a769-c7b2abc3acb5	9d53c5da-e57c-4e99-94c3-95e6f8e8bfe4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 23:41:12
9626	9d53c5da-dd98-41ea-9792-af5ac0fc6508	9d53c5da-e57c-4e99-94c3-95e6f8e8bfe4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"62.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 23:41:13
9627	9d53c5da-de03-4015-bda1-9682a22978c3	9d53c5da-e57c-4e99-94c3-95e6f8e8bfe4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 23:41:13
9628	9d53c5da-e3b7-47dd-a95b-6c3f695916a4	9d53c5da-e57c-4e99-94c3-95e6f8e8bfe4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 23:41:13
9629	9d53c5da-e424-439b-bb4d-7e644f9054f1	9d53c5da-e57c-4e99-94c3-95e6f8e8bfe4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":470,"memory":22,"hostname":"EderCortes"}	2024-10-24 23:41:13
10610	9d5710fa-52cd-42bd-90e6-dd9f52ceb65a	9d5710fa-707c-448c-b7de-9bf89dc93514	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 14:58:45
7084	9d52da9e-400c-4608-ad3f-c290db92fbdf	9d52da9e-5db5-4937-beeb-340f2c1d40d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 12:43:26
7085	9d52da9e-5882-4ecf-8e6f-2b5830c58963	9d52da9e-5db5-4937-beeb-340f2c1d40d7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:43:26
7086	9d52da9e-58cc-40a7-a5bd-f74f961d429e	9d52da9e-5db5-4937-beeb-340f2c1d40d7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 12:43:26
7087	9d52da9e-5c8a-41aa-a63d-ebada564dce7	9d52da9e-5db5-4937-beeb-340f2c1d40d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 12:43:26
7088	9d52da9e-5cdc-46be-9235-6ffb020bee0c	9d52da9e-5db5-4937-beeb-340f2c1d40d7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:43:26
10611	9d5710fa-6af1-482c-924b-9078b1ee2969	9d5710fa-707c-448c-b7de-9bf89dc93514	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 14:58:45
10612	9d5710fa-6b43-4768-b5dc-87fce47f4a55	9d5710fa-707c-448c-b7de-9bf89dc93514	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 14:58:45
10613	9d5710fa-6f35-4a77-845d-8acafccadc8c	9d5710fa-707c-448c-b7de-9bf89dc93514	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 14:58:45
10614	9d5710fa-6f83-484d-b808-76c843c59f06	9d5710fa-707c-448c-b7de-9bf89dc93514	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-10-26 14:58:45
20360	9d66f179-319e-485b-8664-f17b4ebcfd19	9d66f179-32e2-444a-a922-afa82e81cfd8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":452,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:23:54
7089	9d52da9e-a1f6-476e-a88c-467ec7d50a41	9d52da9e-c1a0-434d-88bc-214005edcc5b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 12:43:27
7090	9d52da9e-b9e3-4864-966c-b3f2928e2e9e	9d52da9e-c1a0-434d-88bc-214005edcc5b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"43.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 12:43:27
7091	9d52da9e-ba2c-496a-a017-e958b1ffc606	9d52da9e-c1a0-434d-88bc-214005edcc5b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 12:43:27
7092	9d52da9e-bbc3-4dd5-a607-b9f025561626	9d52da9e-c1a0-434d-88bc-214005edcc5b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"1.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 12:43:27
7093	9d52da9e-bc01-4c29-a51c-903a354c8f5f	9d52da9e-c1a0-434d-88bc-214005edcc5b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 12:43:27
7094	9d52da9e-c034-48e3-99d9-ab52668ee938	9d52da9e-c1a0-434d-88bc-214005edcc5b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 12:43:27
7095	9d52da9e-c0a0-43ae-b3f2-0bf9d429e8ce	9d52da9e-c1a0-434d-88bc-214005edcc5b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:43:27
7096	9d52daa0-ad92-4f33-ba86-03893c1d85aa	9d52daa0-f2e3-4c70-9252-938ad32a45e6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-24 12:43:28
7097	9d52daa0-edb5-4fab-b2fb-0c102a95a0c1	9d52daa0-f2e3-4c70-9252-938ad32a45e6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"142.41","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 12:43:28
7098	9d52daa0-ee14-4e15-9e47-e4b933812359	9d52daa0-f2e3-4c70-9252-938ad32a45e6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 12:43:28
7099	9d52daa0-f1a3-4588-a490-a8365aaede8c	9d52daa0-f2e3-4c70-9252-938ad32a45e6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 12:43:28
7100	9d52daa0-f1ec-4eb9-9c70-40253126eaf9	9d52daa0-f2e3-4c70-9252-938ad32a45e6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":353,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:43:28
15283	9d5ecf81-580f-4eec-9599-60532c112829	9d5ecf81-9b7b-4f78-b0cf-2c995a82a10c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-10-30 11:22:18
15284	9d5ecf81-98d1-4ae3-9606-4c35541411f7	9d5ecf81-9b7b-4f78-b0cf-2c995a82a10c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-10-30 11:22:18
7105	9d52dab8-d619-4a8b-b208-4e136e8883cb	9d52dab9-2594-46d8-b29c-a7d66d993d76	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 12:43:44
15285	9d5ecf81-9a14-48e1-9b06-cc9fde8af91b	9d5ecf81-9b7b-4f78-b0cf-2c995a82a10c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":502,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:22:18
7106	9d52dab9-1c5d-4d29-84e0-c24a44f3fb8c	9d52dab9-2594-46d8-b29c-a7d66d993d76	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"155.01","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 12:43:44
20452	9d66f3f7-5b9b-4a3d-964a-63b9318ab0a3	9d66f3f7-8ad9-456c-9296-7ff9f84194e1	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 12:30:52
20453	9d66f3f7-88ad-4337-91c6-1097daf5fc12	9d66f3f7-8ad9-456c-9296-7ff9f84194e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:30:53
7107	9d52dab9-1cc3-4280-ad48-08f685b6e7bc	9d52dab9-2594-46d8-b29c-a7d66d993d76	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 12:43:44
7108	9d52dab9-246e-46d6-93a0-af1c88fcddf4	9d52dab9-2594-46d8-b29c-a7d66d993d76	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-24 12:43:44
20454	9d66f3f7-899d-4511-9b54-5301c3feee13	9d66f3f7-8ad9-456c-9296-7ff9f84194e1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":411,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:30:53
15387	9d5ed10e-71f7-46a3-9203-af6623dc90b3	9d5ed10e-c366-4afd-b6cc-2f2fa14c3906	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-30 11:26:38
15388	9d5ed10e-c073-4a29-832d-6bf93d53ff34	9d5ed10e-c366-4afd-b6cc-2f2fa14c3906	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-30 11:26:38
15389	9d5ed10e-c1a7-4b7c-8b3b-82c3e679e582	9d5ed10e-c366-4afd-b6cc-2f2fa14c3906	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":580,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:26:38
20616	9d66f8a6-1984-4827-8da1-88a0bca8b209	9d66f8a6-64ec-45f5-a50f-1859fd41ee22	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:43:58
20455	9d66f3f8-029a-437a-9a0a-08e25f6326e5	9d66f3f8-4dc3-4375-802f-ff08e2b609c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:30:53
20456	9d66f3f8-438e-4cc3-935a-235064b99469	9d66f3f8-4dc3-4375-802f-ff08e2b609c3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                uco.name as cobrador,\\n                                ure.name as recomendado\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"152.65","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"cc4d841db3462595a77e794e4503c0df","hostname":"EderCortes"}	2024-11-03 12:30:53
20457	9d66f3f8-4783-42a2-ae0c-216fe7f089cc	9d66f3f8-4dc3-4375-802f-ff08e2b609c3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:30:53
20458	9d66f3f8-47cf-4b6c-a99a-d31a61e3642d	9d66f3f8-4dc3-4375-802f-ff08e2b609c3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:30:53
20459	9d66f3f8-4c6e-4550-a6c5-f7195021f429	9d66f3f8-4dc3-4375-802f-ff08e2b609c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:30:53
20617	9d66f8a6-634f-4725-bebf-6d70c7d1888f	9d66f8a6-64ec-45f5-a50f-1859fd41ee22	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:43:58
20618	9d66f8a6-63f5-4a20-aa0e-ef8f6a3ae7c6	9d66f8a6-64ec-45f5-a50f-1859fd41ee22	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":401,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:43:58
15390	9d5ed10f-4f33-406e-918d-4388d6b1901a	9d5ed10f-7bd8-48ce-820a-e8f0422ee2df	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-30 11:26:39
15391	9d5ed10f-75a9-4808-b50e-98d1ae0668e8	9d5ed10f-7bd8-48ce-820a-e8f0422ee2df	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"54.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 11:26:39
15392	9d5ed10f-75ff-474b-b2e0-7b8ef0433ff5	9d5ed10f-7bd8-48ce-820a-e8f0422ee2df	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-30 11:26:39
15393	9d5ed10f-7a6c-4739-828a-5cba80b5e19b	9d5ed10f-7bd8-48ce-820a-e8f0422ee2df	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-30 11:26:39
15394	9d5ed10f-7ad1-4fef-9996-36c63dd83dba	9d5ed10f-7bd8-48ce-820a-e8f0422ee2df	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":422,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:26:39
20460	9d66f3f8-4cbd-40cc-9dee-e1920352ecc6	9d66f3f8-4dc3-4375-802f-ff08e2b609c3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000","recomendado":"Luis andre"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":446,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:30:53
20619	9d66f8a6-bcca-4465-b767-e4df6a01d663	9d66f8a6-e1eb-4ee2-9709-82d6a601f659	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:43:59
20620	9d66f8a6-d784-4638-9f02-bff8aabd0f7f	9d66f8a6-e1eb-4ee2-9709-82d6a601f659	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"52.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:43:59
20621	9d66f8a6-dba3-4334-9edd-f10c2d10a233	9d66f8a6-e1eb-4ee2-9709-82d6a601f659	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"1.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:43:59
20622	9d66f8a6-dbf4-4c6b-b899-ed8b21cba694	9d66f8a6-e1eb-4ee2-9709-82d6a601f659	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:43:59
20623	9d66f8a6-e0c4-4062-856c-87a410245263	9d66f8a6-e1eb-4ee2-9709-82d6a601f659	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:43:59
20624	9d66f8a6-e10d-4766-a84a-0e7d65e46f73	9d66f8a6-e1eb-4ee2-9709-82d6a601f659	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"400000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:40:42.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":null,"itemloans_cuota_cancelada":"100000"},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":271,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:43:59
20461	9d66f3fa-a3eb-4573-978d-dbb3f108f15a	9d66f3fa-fdde-495b-ba8e-11af2eb180c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:30:55
20462	9d66f3fa-f38d-4a62-9413-cb5d4b5edeaa	9d66f3fa-fdde-495b-ba8e-11af2eb180c0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"161.63","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:30:55
8915	9d52f262-fa8a-4f86-aae6-38d5115980ab	9d52f263-20f6-4d80-bad3-2be83c3226d6	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 13:49:54
8916	9d52f263-1f1e-4a1b-b380-aeafbd3e5224	9d52f263-20f6-4d80-bad3-2be83c3226d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:49:54
8917	9d52f263-1fe2-4252-ad73-cff0f4c3a4fe	9d52f263-20f6-4d80-bad3-2be83c3226d6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":316,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:49:54
20463	9d66f3fa-f422-4f71-99a9-017123b95cfe	9d66f3fa-fdde-495b-ba8e-11af2eb180c0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:30:55
20464	9d66f3fa-fbd8-40fc-9b24-dc140fd90dc7	9d66f3fa-fdde-495b-ba8e-11af2eb180c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:30:55
15395	9d5ed10f-c2bf-4cae-920f-4f025f76aa7b	9d5ed10f-e0bc-434e-970d-66697b3f3a70	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-30 11:26:39
15396	9d5ed10f-dbfb-4d23-9e34-a8ff6e09d62f	9d5ed10f-e0bc-434e-970d-66697b3f3a70	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 11:26:39
15397	9d5ed10f-dc48-4b57-ad86-770c953e0c38	9d5ed10f-e0bc-434e-970d-66697b3f3a70	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-30 11:26:39
15398	9d5ed10f-df9d-4080-b2b6-3fb5a4be43e6	9d5ed10f-e0bc-434e-970d-66697b3f3a70	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-30 11:26:39
20465	9d66f3fa-fc5a-44e5-a963-b16ecc2f1f75	9d66f3fa-fdde-495b-ba8e-11af2eb180c0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":513,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:30:55
20625	9d66f8a9-2753-4d28-a529-93fd5cc28d2a	9d66f8a9-4ed8-4776-83de-ffcbfac6e736	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:44:00
20626	9d66f8a9-47ff-4659-818f-7856f95d0f6d	9d66f8a9-4ed8-4776-83de-ffcbfac6e736	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"56.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:44:00
20627	9d66f8a9-487f-48f0-9044-887af63e87a1	9d66f8a9-4ed8-4776-83de-ffcbfac6e736	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:44:00
20628	9d66f8a9-4d3e-4868-9a07-d4d4f9ea0d30	9d66f8a9-4ed8-4776-83de-ffcbfac6e736	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:44:00
20629	9d66f8a9-4d9e-4712-968a-0125929100ee	9d66f8a9-4ed8-4776-83de-ffcbfac6e736	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":358,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:44:00
8283	9d52e808-d886-4708-b354-715687104e73	9d52e809-2037-4ed1-87d2-f94fc120d784	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:20:57
8284	9d52e809-1e86-4042-8521-529d91a5fd4b	9d52e809-2037-4ed1-87d2-f94fc120d784	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:20:57
8285	9d52e809-1f42-40f3-bab4-755223044d48	9d52e809-2037-4ed1-87d2-f94fc120d784	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":343,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:20:57
20630	9d66f8c2-4b5e-4791-a1be-b5ee1d29e173	9d66f8c2-4eb2-4f27-bfcc-d6e9cab67cf5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":156,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:44:17
15399	9d5ed10f-dfe6-43ea-aca8-fa2daab6cd30	9d5ed10f-e0bc-434e-970d-66697b3f3a70	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:26:39
8286	9d52e809-6c6e-4c1e-a99f-c932d3c02602	9d52e809-8c92-43c5-b476-211c03de896d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:20:58
8287	9d52e809-8767-4eea-b3ac-8d544972c8a3	9d52e809-8c92-43c5-b476-211c03de896d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:20:58
8288	9d52e809-87ba-4264-bbc4-75f41d3808b7	9d52e809-8c92-43c5-b476-211c03de896d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:20:58
8289	9d52e809-8b62-4352-b416-e1309279e8dd	9d52e809-8c92-43c5-b476-211c03de896d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:20:58
8290	9d52e809-8bb9-4c41-ba1a-c571ea0cf604	9d52e809-8c92-43c5-b476-211c03de896d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":242,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:20:58
8918	9d52f263-7a5b-4904-85cd-23c1f5745e97	9d52f263-9a0b-48a7-a0d7-053a4afda455	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:49:54
8919	9d52f263-9520-43c7-8d6f-ec12b1e9f70e	9d52f263-9a0b-48a7-a0d7-053a4afda455	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:49:54
8920	9d52f263-9576-4c33-a8fd-579310061079	9d52f263-9a0b-48a7-a0d7-053a4afda455	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:49:54
8921	9d52f263-9900-452a-8f45-eaadbc818bf3	9d52f263-9a0b-48a7-a0d7-053a4afda455	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:49:54
8922	9d52f263-9940-4f46-bed2-e70ded9f7ac0	9d52f263-9a0b-48a7-a0d7-053a4afda455	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":280,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:49:54
8291	9d52e809-d837-4c43-bfec-62a89d6ff492	9d52e80a-1e59-4461-a840-dddd661c1644	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:20:58
8292	9d52e80a-18a6-4669-9579-bd919f9eabfd	9d52e80a-1e59-4461-a840-dddd661c1644	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"141.38","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:20:58
8293	9d52e80a-191a-4cba-866c-fd0f12bbe546	9d52e80a-1e59-4461-a840-dddd661c1644	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:20:58
8294	9d52e80a-1d1b-466e-a4a4-da4a459d372c	9d52e80a-1e59-4461-a840-dddd661c1644	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:20:58
8295	9d52e80a-1d71-4107-8341-989e5f452dc7	9d52e80a-1e59-4461-a840-dddd661c1644	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:20:58
8923	9d52f263-e673-41d9-bb79-9149665512d9	9d52f264-07b2-43f3-95e0-61581695668c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:49:55
8924	9d52f264-016f-4230-a361-2c918fa89cf2	9d52f264-07b2-43f3-95e0-61581695668c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:49:55
8925	9d52f264-01b8-4b75-a710-5cb75a6313e0	9d52f264-07b2-43f3-95e0-61581695668c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:49:55
8926	9d52f264-0661-465e-bc0e-fc0477c9a001	9d52f264-07b2-43f3-95e0-61581695668c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:49:55
8927	9d52f264-06ca-4ab2-9474-20677e69084c	9d52f264-07b2-43f3-95e0-61581695668c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:49:55
8296	9d52e80a-653c-47ce-aace-3264ac25515d	9d52e80a-8655-4ad9-a168-48228bab9565	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:20:58
8297	9d52e80a-7e95-46e8-9457-2b57c016fad1	9d52e80a-8655-4ad9-a168-48228bab9565	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc","time":"44.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 13:20:58
8298	9d52e80a-7ee8-4b0f-a8d6-13508a0c76b8	9d52e80a-8655-4ad9-a168-48228bab9565	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:20:58
8299	9d52e80a-80ce-4c56-9b95-c3eceba635a7	9d52e80a-8655-4ad9-a168-48228bab9565	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6'","time":"2.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 13:20:58
8300	9d52e80a-8105-41b0-8330-cbfccc4e0bb3	9d52e80a-8655-4ad9-a168-48228bab9565	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:20:58
8301	9d52e80a-84d8-41f0-a726-378d51a01610	9d52e80a-8655-4ad9-a168-48228bab9565	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:20:58
8302	9d52e80a-8544-4b37-8704-e36907057378	9d52e80a-8655-4ad9-a168-48228bab9565	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:20:58
8928	9d52f264-51f7-4b58-9ca3-9d04e33fe3bc	9d52f264-72ee-4cf0-902f-826ce85b36dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:49:55
8929	9d52f264-6c2c-43d3-82a2-d52c59c99a16	9d52f264-72ee-4cf0-902f-826ce85b36dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"42.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-24 13:49:55
8930	9d52f264-6c7c-4f4a-a600-55a86a94d5b3	9d52f264-72ee-4cf0-902f-826ce85b36dd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:49:55
8931	9d52f264-6e1e-4990-bd4f-64185b23a92e	9d52f264-72ee-4cf0-902f-826ce85b36dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"2.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 13:49:55
8932	9d52f264-6e52-4f3a-8d54-5c09b344f419	9d52f264-72ee-4cf0-902f-826ce85b36dd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:49:55
8933	9d52f264-7185-4f47-898d-1793414ef149	9d52f264-72ee-4cf0-902f-826ce85b36dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:49:55
8934	9d52f264-71f0-4013-8f89-374f70a36c70	9d52f264-72ee-4cf0-902f-826ce85b36dd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":260,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:49:55
8303	9d52e80c-334d-444b-995c-cfdf44b39624	9d52e80c-6286-4314-a945-c186f4e5ad63	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:20:59
8304	9d52e80c-5c99-46be-97c3-6193bbafd284	9d52e80c-6286-4314-a945-c186f4e5ad63	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"66.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:21:00
8305	9d52e80c-5cf6-4785-af43-c42529c17314	9d52e80c-6286-4314-a945-c186f4e5ad63	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:21:00
8306	9d52e80c-612b-446c-9e45-396a6b1f59ca	9d52e80c-6286-4314-a945-c186f4e5ad63	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 13:21:00
8307	9d52e80c-6187-402f-9609-27c204a7f92c	9d52e80c-6286-4314-a945-c186f4e5ad63	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":599,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:21:00
8935	9d52f266-5cbb-48e2-9fc5-2a0ef0313cc3	9d52f266-880c-49a3-8b5b-af47573649d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:49:56
8936	9d52f266-81b6-4a0b-8682-6353fc59c367	9d52f266-880c-49a3-8b5b-af47573649d0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"58.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:49:56
8937	9d52f266-8225-4cdf-ba03-2bb92f1e0121	9d52f266-880c-49a3-8b5b-af47573649d0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:49:56
8938	9d52f266-8684-4a3c-b5de-c77a09da9cf2	9d52f266-880c-49a3-8b5b-af47573649d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:49:56
8939	9d52f266-86d9-46ce-abcc-5cbf41fc110d	9d52f266-880c-49a3-8b5b-af47573649d0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":412,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:49:56
20638	9d66f8c3-b4b3-4f5f-ad54-b30529458d68	9d66f8c3-d305-4fc7-8977-8ee1310c642c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:44:18
20639	9d66f8c3-ca10-42fa-8984-0dc7819ca4ea	9d66f8c3-d305-4fc7-8977-8ee1310c642c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"41.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:44:18
20640	9d66f8c3-cda8-4e0b-8203-76810530c0aa	9d66f8c3-d305-4fc7-8977-8ee1310c642c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:44:18
20641	9d66f8c3-cdd8-423b-a0e9-881b03ddab12	9d66f8c3-d305-4fc7-8977-8ee1310c642c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:44:18
20642	9d66f8c3-d1af-4713-ba22-4147351cc18e	9d66f8c3-d305-4fc7-8977-8ee1310c642c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:44:18
20643	9d66f8c3-d207-4c01-9efc-b4aff076c138	9d66f8c3-d305-4fc7-8977-8ee1310c642c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"400000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:40:42.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":null,"itemloans_cuota_cancelada":"100000"},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":295,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:44:18
8944	9d52f26c-8702-4aff-a8f5-80750fd8f4c2	9d52f26c-aaa9-4863-bfbe-bc5667ee61fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:50:00
8945	9d52f26c-a4c3-491f-bb70-a75dfac42645	9d52f26c-aaa9-4863-bfbe-bc5667ee61fa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:50:00
10699	9d572015-a13b-48cc-9942-bc5c140f2cc8	9d572015-c5ba-4ae1-8acf-05cdcfe7f3fe	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 15:41:00
10700	9d572015-c329-4d97-9b54-12fd21b31037	9d572015-c5ba-4ae1-8acf-05cdcfe7f3fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 15:41:00
10701	9d572015-c4a7-42d7-8020-c882a792ba56	9d572015-c5ba-4ae1-8acf-05cdcfe7f3fe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":265,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:41:00
7794	9d52e15a-efca-400e-aa3a-23e5e0445d8d	9d52e15b-381c-46cd-a4dd-be0dc5f6fd52	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:02:17
7795	9d52e15b-368f-4ea4-98a8-c6df51c6584c	9d52e15b-381c-46cd-a4dd-be0dc5f6fd52	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:02:17
7796	9d52e15b-3730-41df-820d-0a68cb8efed4	9d52e15b-381c-46cd-a4dd-be0dc5f6fd52	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":342,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:02:17
15030	9d5ece87-bcc3-4bca-bf7e-5cf09fafee6b	9d5ece88-0692-4472-9ea8-1440c30dc4e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 11:19:34
15031	9d5ece88-04c9-4842-86a2-be9c9edc820f	9d5ece88-0692-4472-9ea8-1440c30dc4e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 11:19:35
15032	9d5ece88-0584-464b-96f0-f399fa284a06	9d5ece88-0692-4472-9ea8-1440c30dc4e8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":407,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:19:35
7797	9d52e15b-8195-4b7c-a55a-b5953cb2aab3	9d52e15b-a0c5-4d42-8001-fffee7f13474	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:02:17
7798	9d52e15b-9bc9-4618-ac92-4656f9c38b0a	9d52e15b-a0c5-4d42-8001-fffee7f13474	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:02:17
7799	9d52e15b-9c12-4b07-8633-79e481ab7246	9d52e15b-a0c5-4d42-8001-fffee7f13474	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:02:17
7800	9d52e15b-9f97-44b5-a1fb-4b42cdb956a2	9d52e15b-a0c5-4d42-8001-fffee7f13474	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:02:17
7801	9d52e15b-9feb-482c-a0f3-694c114b519b	9d52e15b-a0c5-4d42-8001-fffee7f13474	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:02:17
9883	9d56b5e1-36e1-49f4-85e6-e4ddd9d39c07	9d56b5e1-5d58-4dda-8a36-1e53e3b3e624	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 10:44:01
9884	9d56b5e1-5b67-4b80-bb82-909ddeeac9f2	9d56b5e1-5d58-4dda-8a36-1e53e3b3e624	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 10:44:01
9885	9d56b5e1-5c3c-4bfb-acfa-73a3ea76381d	9d56b5e1-5d58-4dda-8a36-1e53e3b3e624	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":317,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:44:01
8946	9d52f26c-a539-457a-aed9-b9ed45b6f0a3	9d52f26c-aaa9-4863-bfbe-bc5667ee61fa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:50:00
10702	9d572016-1b0a-4b83-90a6-795ea14a2949	9d572016-3509-4f1b-b46e-d47dc3cb243a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 15:41:00
10703	9d572016-3075-4733-ae95-0c28a615696e	9d572016-3509-4f1b-b46e-d47dc3cb243a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"43.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-26 15:41:00
10704	9d572016-3408-483a-86b5-42695bbba70c	9d572016-3509-4f1b-b46e-d47dc3cb243a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 15:41:00
10705	9d572016-344b-4ec9-a5aa-e708ee399092	9d572016-3509-4f1b-b46e-d47dc3cb243a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":248,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:41:00
7802	9d52e15b-e016-45a2-9fd4-dd17df4ccb39	9d52e15b-fed4-4d4e-80fb-c13d2329ffbd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:02:17
7803	9d52e15b-f9e9-4c03-98a7-673d7723b9bf	9d52e15b-fed4-4d4e-80fb-c13d2329ffbd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:02:17
7804	9d52e15b-fa3e-4e60-ba05-ff6748a21f55	9d52e15b-fed4-4d4e-80fb-c13d2329ffbd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:02:17
7805	9d52e15b-fdb7-45be-af9e-b437cc6f0651	9d52e15b-fed4-4d4e-80fb-c13d2329ffbd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:02:17
7806	9d52e15b-fdf8-42ae-b8b3-0c4f50f456f0	9d52e15b-fed4-4d4e-80fb-c13d2329ffbd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":228,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:02:17
9886	9d56b5e1-bb9f-494c-8dfa-f7189820ed07	9d56b5e2-021a-4794-bcf2-41257f5d2140	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 10:44:02
9887	9d56b5e1-fd05-47e6-a797-e4518d7e00e0	9d56b5e2-021a-4794-bcf2-41257f5d2140	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"155.04","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-26 10:44:02
8947	9d52f26c-a93d-45d0-b52f-d3a8f86a3bc6	9d52f26c-aaa9-4863-bfbe-bc5667ee61fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:50:00
8948	9d52f26c-a997-42a4-86c1-6e7ea945f37a	9d52f26c-aaa9-4863-bfbe-bc5667ee61fa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":311,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:50:00
9888	9d56b5e2-00e2-44d4-b5f4-e99d068fb249	9d56b5e2-021a-4794-bcf2-41257f5d2140	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 10:44:02
9889	9d56b5e2-0132-49c0-ae90-674396167f43	9d56b5e2-021a-4794-bcf2-41257f5d2140	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":386,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:44:02
10706	9d572018-5bfb-4021-8bf3-5a5346780747	9d572018-acf0-4458-957e-89b460b6718d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 15:41:01
10707	9d572018-a510-48f0-806f-65b2c4684dc9	9d572018-acf0-4458-957e-89b460b6718d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"154.62","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 15:41:02
10708	9d572018-a578-43e6-9de2-12cd24650ece	9d572018-acf0-4458-957e-89b460b6718d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 15:41:02
10709	9d572018-ab3b-411b-876b-b99c6a406882	9d572018-acf0-4458-957e-89b460b6718d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 15:41:02
7807	9d52e15c-4248-41a5-9bfd-e0988a843b62	9d52e15c-86f8-4f3a-b958-e411a22b9661	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:02:17
7808	9d52e15c-8086-497e-a85d-33e6f75af0b9	9d52e15c-86f8-4f3a-b958-e411a22b9661	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '11' order by \\"id\\" asc","time":"140.07","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 13:02:18
7809	9d52e15c-80f4-421e-8fc9-d3eef72cefdc	9d52e15c-86f8-4f3a-b958-e411a22b9661	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:02:18
7810	9d52e15c-8291-4dd5-b72e-c4e2b896fa38	9d52e15c-86f8-4f3a-b958-e411a22b9661	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '11'","time":"1.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"3fea593f24cb27f27a536f01d96d5aca","hostname":"EderCortes"}	2024-10-24 13:02:18
7811	9d52e15c-82c2-43b4-b7aa-2a1cf9f19a1f	9d52e15c-86f8-4f3a-b958-e411a22b9661	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":3,"hostname":"EderCortes"}	2024-10-24 13:02:18
7812	9d52e15c-85ad-4560-81f9-c64da69430cc	9d52e15c-86f8-4f3a-b958-e411a22b9661	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:02:18
7813	9d52e15c-85f2-417d-a6e3-13e2421234e5	9d52e15c-86f8-4f3a-b958-e411a22b9661	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/11","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":11,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":40,"loans_cuotas":3,"loans_cuando":"D","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":100000,"user_customer":18,"user_cobrador":14,"created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":61,"loans_codigo":11,"itemloans_cuota":"1","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":62,"loans_codigo":11,"itemloans_cuota":"2","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null},{"id":63,"loans_codigo":11,"itemloans_cuota":"3","itemloans_valor_cuota":"33333.333333333","itemloans_iteres":"3333.3333333333","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T12:14:59.000000Z","updated_at":"2024-10-24T12:14:59.000000Z","deleted_at":null}]}},"duration":329,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:02:18
9890	9d56b5e3-f779-4ca8-96f7-71ab1a5af81b	9d56b5e4-1794-4901-b976-c83fc5505349	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 10:44:03
9891	9d56b5e4-11d1-4578-ae9b-0dd5e7204524	9d56b5e4-1794-4901-b976-c83fc5505349	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 10:44:03
8949	9d52f26c-f58b-4005-866e-9a6ada0d5627	9d52f26d-167f-4925-80b5-468ae2a7aa72	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:50:01
8950	9d52f26d-114b-4438-859a-efef652ee7e9	9d52f26d-167f-4925-80b5-468ae2a7aa72	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:50:01
8951	9d52f26d-11a4-451f-91de-c3f5453cea6c	9d52f26d-167f-4925-80b5-468ae2a7aa72	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:50:01
8952	9d52f26d-1556-44bc-adf2-d24d60892984	9d52f26d-167f-4925-80b5-468ae2a7aa72	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:50:01
9793	9d56acbf-53b5-4218-b8af-c71a0c923213	9d56acbf-74f2-41fc-8d37-5dd3f5f28af5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-26 10:18:29
9794	9d56acbf-733e-4653-bb7e-ae3ba86b6fbe	9d56acbf-74f2-41fc-8d37-5dd3f5f28af5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-26 10:18:29
9795	9d56acbf-7414-46eb-b794-19e7bb7ba7e0	9d56acbf-74f2-41fc-8d37-5dd3f5f28af5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:18:29
9892	9d56b5e4-1226-4677-b6f0-835c6d1cd524	9d56b5e4-1794-4901-b976-c83fc5505349	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 10:44:03
9893	9d56b5e4-1631-4ade-957a-3bf1810df689	9d56b5e4-1794-4901-b976-c83fc5505349	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 10:44:03
9894	9d56b5e4-167a-459b-80e6-32dc51d629c3	9d56b5e4-1794-4901-b976-c83fc5505349	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:44:03
7814	9d52e15e-9dd2-480f-928c-f6cbf811b883	9d52e15e-bdcb-4c3a-9fb9-c91cd8eb57da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:02:19
7815	9d52e15e-b8a0-4386-9245-1ce99edf4ab6	9d52e15e-bdcb-4c3a-9fb9-c91cd8eb57da	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"49.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:02:19
7816	9d52e15e-b8ec-419b-9975-e818564ab55b	9d52e15e-bdcb-4c3a-9fb9-c91cd8eb57da	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:02:19
7817	9d52e15e-bc8d-4d19-8799-87ae28e1b06e	9d52e15e-bdcb-4c3a-9fb9-c91cd8eb57da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:02:19
7818	9d52e15e-bcd0-4179-972f-4b638dcc9137	9d52e15e-bdcb-4c3a-9fb9-c91cd8eb57da	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":272,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:02:19
9796	9d56acbf-c4a2-4cc6-b32c-f968ea1e063d	9d56acbf-e46e-4aa7-8030-372db10ea368	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-26 10:18:29
9797	9d56acbf-df4c-44cc-874e-5446b894fe34	9d56acbf-e46e-4aa7-8030-372db10ea368	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-26 10:18:30
8953	9d52f26d-15a5-4358-8587-9c44e08f1afd	9d52f26d-167f-4925-80b5-468ae2a7aa72	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":255,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:50:01
9798	9d56acbf-dfab-4e7c-931a-6d7c6918512e	9d56acbf-e46e-4aa7-8030-372db10ea368	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-26 10:18:30
9799	9d56acbf-e2fd-4b94-b351-0bb9ba926942	9d56acbf-e46e-4aa7-8030-372db10ea368	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-26 10:18:30
9800	9d56acbf-e33d-49e0-92d5-0f3b699d7c4f	9d56acbf-e46e-4aa7-8030-372db10ea368	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:18:30
10710	9d572018-ab9a-4204-986c-5e3f62d67b5e	9d572018-acf0-4458-957e-89b460b6718d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":766,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:41:02
9801	9d56acc0-2ddf-42e9-a194-8932413b42a8	9d56acc0-7743-4ed7-942b-bead8ea1dc2a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-26 10:18:30
9802	9d56acc0-716f-4999-8e45-3c07fb9daf47	9d56acc0-7743-4ed7-942b-bead8ea1dc2a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"150.30","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-26 10:18:30
9803	9d56acc0-71cb-4006-819b-84369a6317ed	9d56acc0-7743-4ed7-942b-bead8ea1dc2a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-26 10:18:30
9804	9d56acc0-761b-4109-971f-b698129aaa4b	9d56acc0-7743-4ed7-942b-bead8ea1dc2a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-26 10:18:30
8954	9d52f26d-5dc8-4915-895d-a05ee514ff4b	9d52f26d-7bef-4138-964a-01b645916f85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:50:01
9805	9d56acc0-766c-4a43-b0ae-330e0258f0bc	9d56acc0-7743-4ed7-942b-bead8ea1dc2a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":352,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:18:30
9806	9d56acc0-b993-41fd-9acd-b3fbb10cd845	9d56acc0-d776-4158-9eeb-bcb1009b5af6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-26 10:18:30
9807	9d56acc0-d0a9-4b8e-a508-ce10ec0116c2	9d56acc0-d776-4158-9eeb-bcb1009b5af6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '1' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"40.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-26 10:18:30
9808	9d56acc0-d0f0-4b16-a3bf-e84cabaadf7c	9d56acc0-d776-4158-9eeb-bcb1009b5af6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-26 10:18:30
9809	9d56acc0-d253-4521-aee9-a2433bf90f9b	9d56acc0-d776-4158-9eeb-bcb1009b5af6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1' order by \\"item_loans\\".\\"id\\" asc","time":"1.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-26 10:18:30
8955	9d52f26d-73fe-4ab3-b772-fa76087bb808	9d52f26d-7bef-4138-964a-01b645916f85	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"39.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-24 13:50:01
9810	9d56acc0-d282-4e5e-b312-d1ba8b80bb75	9d56acc0-d776-4158-9eeb-bcb1009b5af6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-26 10:18:30
9811	9d56acc0-d637-4ec7-ae8c-142ba110d395	9d56acc0-d776-4158-9eeb-bcb1009b5af6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-26 10:18:30
9812	9d56acc0-d68f-4a18-856b-a04fa2f4c194	9d56acc0-d776-4158-9eeb-bcb1009b5af6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":1,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]}},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:18:30
9813	9d56acc2-62de-4ed3-a9a8-063f5e74115a	9d56acc2-8e72-4a4e-bc56-6626a8738577	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-26 10:18:31
9814	9d56acc2-873e-4dd5-8847-980e16328865	9d56acc2-8e72-4a4e-bc56-6626a8738577	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"60.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 10:18:31
9815	9d56acc2-87da-4f29-b226-176010bcd577	9d56acc2-8e72-4a4e-bc56-6626a8738577	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 10:18:31
9816	9d56acc2-8d21-496b-a8cc-6df889637637	9d56acc2-8e72-4a4e-bc56-6626a8738577	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-26 10:18:31
8956	9d52f26d-7453-4fdb-96c4-9df84c782f7e	9d52f26d-7bef-4138-964a-01b645916f85	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:50:01
9817	9d56acc2-8d77-44fd-b00c-89b85727dfae	9d56acc2-8e72-4a4e-bc56-6626a8738577	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":423,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:18:31
9818	9d56acc5-dd99-4160-ae00-f3c304be2874	9d56acc5-f73a-42e6-9f9d-30cb45bc5653	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-26 10:18:33
9819	9d56acc5-f31d-4f06-8eec-f0b74df07ca2	9d56acc5-f73a-42e6-9f9d-30cb45bc5653	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"41.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-26 10:18:34
9820	9d56acc5-f612-4b44-a622-b609027b801c	9d56acc5-f73a-42e6-9f9d-30cb45bc5653	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-26 10:18:34
9821	9d56acc5-f656-49d9-ab8d-d58b743359e4	9d56acc5-f73a-42e6-9f9d-30cb45bc5653	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":206,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:18:34
8439	9d52ebdb-deb0-4a4e-80e0-8636eb414c52	9d52ebdc-03ac-48cf-ba00-d502dd0c8393	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 13:31:39
8440	9d52ebdc-01e1-4009-8c8c-b7f7a8d94621	9d52ebdc-03ac-48cf-ba00-d502dd0c8393	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:31:39
8441	9d52ebdc-02b1-413f-ad67-52ca3fed09a7	9d52ebdc-03ac-48cf-ba00-d502dd0c8393	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":311,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:31:39
8442	9d52ebdc-5b98-41d6-8885-62fb866b6710	9d52ebdc-7d9a-457d-9aaf-fad9a5f79bf3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:31:39
8443	9d52ebdc-7726-47fb-bc25-982c5a6abfe3	9d52ebdc-7d9a-457d-9aaf-fad9a5f79bf3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:31:39
8444	9d52ebdc-7779-466f-b034-288895722b1e	9d52ebdc-7d9a-457d-9aaf-fad9a5f79bf3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:31:39
8445	9d52ebdc-7c09-4f96-b234-c09d0296c810	9d52ebdc-7d9a-457d-9aaf-fad9a5f79bf3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:31:39
8446	9d52ebdc-7c63-447f-a22f-b85a70392200	9d52ebdc-7d9a-457d-9aaf-fad9a5f79bf3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":282,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:31:39
8447	9d52ebdc-beb2-4492-9be9-8f08cb25ee76	9d52ebdd-059a-4c1c-b6fe-bb0ad3c9c2fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:31:39
8448	9d52ebdd-0084-43a2-88ee-be871748c874	9d52ebdd-059a-4c1c-b6fe-bb0ad3c9c2fc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"147.06","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:31:40
8449	9d52ebdd-00d0-4a7f-a554-34d14f9595e8	9d52ebdd-059a-4c1c-b6fe-bb0ad3c9c2fc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:31:40
8450	9d52ebdd-046d-4f09-97bb-a3f5a1462a01	9d52ebdd-059a-4c1c-b6fe-bb0ad3c9c2fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:31:40
8451	9d52ebdd-04bb-4185-9388-6a0043d29a51	9d52ebdd-059a-4c1c-b6fe-bb0ad3c9c2fc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:31:40
8957	9d52f26d-760c-4ca5-99b0-8ffcbbe04f9d	9d52f26d-7bef-4138-964a-01b645916f85	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"1.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 13:50:01
8958	9d52f26d-7640-4b14-baad-fe2f8c9a6382	9d52f26d-7bef-4138-964a-01b645916f85	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:50:01
8959	9d52f26d-7a83-4480-9afe-0c42bdf54ad8	9d52f26d-7bef-4138-964a-01b645916f85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:50:01
8453	9d52ebdd-4a9e-4e6b-a7e0-1f6cc0eb3d80	9d52ebdd-6d60-48db-8da3-25c0768954a8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:31:40
8454	9d52ebdd-6649-4146-89bb-ce98ab588beb	9d52ebdd-6d60-48db-8da3-25c0768954a8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc","time":"44.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 13:31:40
8455	9d52ebdd-66a3-4d82-9590-b5b89d1cfb42	9d52ebdd-6d60-48db-8da3-25c0768954a8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:31:40
8456	9d52ebdd-6bd9-415b-83e6-ae9bfd38e57a	9d52ebdd-6d60-48db-8da3-25c0768954a8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:31:40
8457	9d52ebdd-6c78-4c0d-b166-5506a1fe0202	9d52ebdd-6d60-48db-8da3-25c0768954a8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"Method Illuminate\\\\Database\\\\Eloquent\\\\Collection::orderBy does not exist.","exception":"BadMethodCallException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Macroable\\\\Traits\\\\Macroable.php","line":112,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"function":"__call","class":"Illuminate\\\\Support\\\\Collection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"edit","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:31:40
8452	9d52ebdd-6a79-47ee-8510-5e1a2b9cba48	9d52ebdd-6d60-48db-8da3-25c0768954a8	2e4ad983d45f212ae5ffbaec9136a0df	f	exception	{"class":"BadMethodCallException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Macroable\\\\Traits\\\\Macroable.php","line":112,"message":"Method Illuminate\\\\Database\\\\Eloquent\\\\Collection::orderBy does not exist.","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"103":"     * @param  string  $method","104":"     * @param  array  $parameters","105":"     * @return mixed","106":"     *","107":"     * @throws \\\\BadMethodCallException","108":"     *\\/","109":"    public function __call($method, $parameters)","110":"    {","111":"        if (! static::hasMacro($method)) {","112":"            throw new BadMethodCallException(sprintf(","113":"                'Method %s::%s does not exist.', static::class, $method","114":"            ));","115":"        }","116":"","117":"        $macro = static::$macros[$method];","118":"","119":"        if ($macro instanceof Closure) {","120":"            $macro = $macro->bindTo($this, static::class);","121":"        }","122":""},"hostname":"EderCortes","occurrences":1}	2024-10-24 13:31:40
8458	9d52ebdf-10cf-4bcb-8045-62b1a8167469	9d52ebdf-5405-4b03-804a-3d470f510eb0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:31:41
8459	9d52ebdf-4f26-4f5c-8d38-5d6817579b21	9d52ebdf-5405-4b03-804a-3d470f510eb0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"140.69","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:31:41
8460	9d52ebdf-4f72-45c6-9cb9-559403b47c87	9d52ebdf-5405-4b03-804a-3d470f510eb0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:31:41
8461	9d52ebdf-52c4-464b-bcd4-7f4536fddfe4	9d52ebdf-5405-4b03-804a-3d470f510eb0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:31:41
8462	9d52ebdf-5305-495f-8ce4-78abf3804686	9d52ebdf-5405-4b03-804a-3d470f510eb0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:31:41
8960	9d52f26d-7aee-4fb5-9e44-b95b7db9b971	9d52f26d-7bef-4138-964a-01b645916f85	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:50:01
8464	9d52ebdf-a0e7-4836-b821-3b00b871f6dd	9d52ebdf-be60-4586-b98d-4c9c3081e836	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:31:41
8465	9d52ebdf-b861-48a7-8157-a58c419805d6	9d52ebdf-be60-4586-b98d-4c9c3081e836	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc","time":"41.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"c85c9d65d1d1f10f57369dde47dcb756","hostname":"EderCortes"}	2024-10-24 13:31:41
8466	9d52ebdf-b8e0-46d6-b773-6f1d62f3da96	9d52ebdf-be60-4586-b98d-4c9c3081e836	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:31:41
8467	9d52ebdf-bccd-4d1a-88f2-7e6dd35460b3	9d52ebdf-be60-4586-b98d-4c9c3081e836	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:31:41
8468	9d52ebdf-bd68-4601-9c28-6b9d6ec15747	9d52ebdf-be60-4586-b98d-4c9c3081e836	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"Method Illuminate\\\\Database\\\\Eloquent\\\\Collection::orderBy does not exist.","exception":"BadMethodCallException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Macroable\\\\Traits\\\\Macroable.php","line":112,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"function":"__call","class":"Illuminate\\\\Support\\\\Collection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"edit","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":256,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:31:41
8463	9d52ebdf-bb9b-4712-aff0-0ca556a28d1f	9d52ebdf-be60-4586-b98d-4c9c3081e836	2e4ad983d45f212ae5ffbaec9136a0df	f	exception	{"class":"BadMethodCallException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Macroable\\\\Traits\\\\Macroable.php","line":112,"message":"Method Illuminate\\\\Database\\\\Eloquent\\\\Collection::orderBy does not exist.","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"103":"     * @param  string  $method","104":"     * @param  array  $parameters","105":"     * @return mixed","106":"     *","107":"     * @throws \\\\BadMethodCallException","108":"     *\\/","109":"    public function __call($method, $parameters)","110":"    {","111":"        if (! static::hasMacro($method)) {","112":"            throw new BadMethodCallException(sprintf(","113":"                'Method %s::%s does not exist.', static::class, $method","114":"            ));","115":"        }","116":"","117":"        $macro = static::$macros[$method];","118":"","119":"        if ($macro instanceof Closure) {","120":"            $macro = $macro->bindTo($this, static::class);","121":"        }","122":""},"hostname":"EderCortes","occurrences":2}	2024-10-24 13:31:41
8961	9d52f26e-cba7-41d7-b405-5b34ffb85905	9d52f26e-fd93-4e9f-bdc9-6e492477ab65	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:50:02
9958	9d56c56f-3945-44a1-90ff-321707e52c3d	9d56c56f-85e9-4826-a120-9b3b38130818	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 11:27:31
9959	9d56c56f-841d-4b2a-a461-931dfd913a1d	9d56c56f-85e9-4826-a120-9b3b38130818	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:27:31
9960	9d56c56f-84dd-474c-acf6-13ce8cf9b43e	9d56c56f-85e9-4826-a120-9b3b38130818	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":424,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:27:31
9961	9d56c56f-e6cd-40c2-9c29-f021b4cb4a4f	9d56c570-07b7-4477-a164-4ba3493de3b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:27:31
9962	9d56c570-0163-487d-948b-af8a823da78b	9d56c570-07b7-4477-a164-4ba3493de3b9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-26 11:27:32
9963	9d56c570-01d3-47de-98d1-f21c9b6763eb	9d56c570-07b7-4477-a164-4ba3493de3b9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-26 11:27:32
9964	9d56c570-067c-4ca4-952f-0a0ae1eafc52	9d56c570-07b7-4477-a164-4ba3493de3b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:27:32
9965	9d56c570-06c1-4799-930b-251952bc9c34	9d56c570-07b7-4477-a164-4ba3493de3b9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":296,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:27:32
20880	9d66fca8-e3e1-436f-aabb-c8f6f34b67c9	9d66fca9-2eb7-40a1-8378-8363ea8f6166	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:55:11
10789	9d572157-2cf3-44fc-85a0-8676fef7ccc5	9d572157-5578-4538-b03a-34d1bf28b946	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 15:44:30
10790	9d572157-539d-4cbe-80aa-1c5ce7393176	9d572157-5578-4538-b03a-34d1bf28b946	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 15:44:30
10791	9d572157-5459-4c63-9d58-9be909d189b8	9d572157-5578-4538-b03a-34d1bf28b946	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":281,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:44:30
15585	9d648e7a-8658-4ff1-8d1d-d95eaac521ef	9d648e7a-aa0c-40e6-ab02-52f734301ce4	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 07:55:26
15586	9d648e7a-a7f0-4f82-bb39-f8f615462871	9d648e7a-aa0c-40e6-ab02-52f734301ce4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 07:55:26
15587	9d648e7a-a8e9-4b0a-bc07-2ec127428f50	9d648e7a-aa0c-40e6-ab02-52f734301ce4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":296,"memory":22,"hostname":"EderCortes"}	2024-11-02 07:55:26
20881	9d66fca9-2d60-4f38-92bd-17d4e85a7dd8	9d66fca9-2eb7-40a1-8378-8363ea8f6166	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:55:11
20882	9d66fca9-2dee-468d-9096-e998caf0d98f	9d66fca9-2eb7-40a1-8378-8363ea8f6166	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":374,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:55:11
20883	9d66fca9-763c-4b22-953c-d725be8c6591	9d66fca9-b908-4d2d-ac7a-d700b41ee6dc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:55:11
20884	9d66fca9-b464-4f3f-8858-20f07d89b793	9d66fca9-b908-4d2d-ac7a-d700b41ee6dc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"142.86","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 12:55:12
5160	9d5136a2-1f67-4863-90dc-4d4dbfe4e6f1	9d5136a2-419e-4d10-8b8b-b7e920ad6a9b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-10-23 17:09:05
5161	9d5136a2-3f63-4a3a-9eb5-32bd53e7e57a	9d5136a2-419e-4d10-8b8b-b7e920ad6a9b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-10-23 17:09:05
5162	9d5136a2-4025-4ba1-92c2-e5c7d2d9c554	9d5136a2-419e-4d10-8b8b-b7e920ad6a9b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":255,"memory":22,"hostname":"EderCortes"}	2024-10-23 17:09:05
20885	9d66fca9-b7b7-4111-86f6-6298858faccf	9d66fca9-b908-4d2d-ac7a-d700b41ee6dc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:55:12
20886	9d66fca9-b80b-472e-b77d-04edc3abb6ca	9d66fca9-b908-4d2d-ac7a-d700b41ee6dc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":null,"loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":319,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:55:12
15588	9d648e7c-6c3e-4917-999a-d8ce93e7957b	9d648e7c-8a0d-4f71-b9d7-55c326be85b7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 07:55:28
15589	9d648e7c-83a2-47d3-b5d0-e7a880c00b58	9d648e7c-8a0d-4f71-b9d7-55c326be85b7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 07:55:28
15590	9d648e7c-83fe-4baa-8d5e-d98bafbc82f0	9d648e7c-8a0d-4f71-b9d7-55c326be85b7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 07:55:28
15591	9d648e7c-8859-4370-8bea-f439bfb50ed0	9d648e7c-8a0d-4f71-b9d7-55c326be85b7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 07:55:28
10792	9d572157-b69d-4977-8f20-ca47f8bc015b	9d572157-d7d7-4ca9-ac72-3f4edf2764c6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 15:44:31
10793	9d572157-cdd6-49bc-8a0b-387607d5623f	9d572157-d7d7-4ca9-ac72-3f4edf2764c6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"44.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 15:44:31
10794	9d572157-d1b1-4382-831b-b8596ad05be0	9d572157-d7d7-4ca9-ac72-3f4edf2764c6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '5' order by \\"item_loans\\".\\"id\\" asc","time":"2.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-26 15:44:31
10795	9d572157-d200-4dbc-9ad8-2d787faa24cd	9d572157-d7d7-4ca9-ac72-3f4edf2764c6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-26 15:44:31
10796	9d572157-d657-48a9-91bf-24e7ee3db596	9d572157-d7d7-4ca9-ac72-3f4edf2764c6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 15:44:31
10797	9d572157-d6b9-475d-a3d8-b1da5d7351e2	9d572157-d7d7-4ca9-ac72-3f4edf2764c6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":25,"loans_codigo":5,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":26,"loans_codigo":5,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":27,"loans_codigo":5,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":28,"loans_codigo":5,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":29,"loans_codigo":5,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":30,"loans_codigo":5,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null}]}},"duration":299,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:44:31
15592	9d648e7c-88a8-4dc8-b000-c573e139efa8	9d648e7c-8a0d-4f71-b9d7-55c326be85b7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"}]},"duration":263,"memory":22,"hostname":"EderCortes"}	2024-11-02 07:55:28
20887	9d66fcac-153e-4481-a3e0-5f65770a1958	9d66fcac-439b-4792-8215-005f09ab8906	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:55:13
20888	9d66fcac-3e69-4535-8bfb-55b4ab7646cc	9d66fcac-439b-4792-8215-005f09ab8906	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"47.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:55:13
20889	9d66fcac-3eb8-4014-bf91-30a78a5d9533	9d66fcac-439b-4792-8215-005f09ab8906	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:55:13
20890	9d66fcac-4269-4959-8afc-56d3f998617b	9d66fcac-439b-4792-8215-005f09ab8906	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:55:13
25866	9d68c9fc-44de-4560-ae7c-7b370de6d019	9d68c9fc-6fed-45c6-ab2e-6cafe11f9345	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 10:25:09
10798	9d572159-2018-4ee6-ae57-e08875bb8f7c	9d572159-69ad-4784-aa29-3fb1082076b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 15:44:32
10799	9d572159-6456-48fd-88d1-296eb8aa4f32	9d572159-69ad-4784-aa29-3fb1082076b2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"154.33","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 15:44:32
10800	9d572159-64a0-4f4f-bfd0-74e33011431c	9d572159-69ad-4784-aa29-3fb1082076b2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 15:44:32
10801	9d572159-6858-46f8-8b77-0bf2370794e6	9d572159-69ad-4784-aa29-3fb1082076b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 15:44:32
10802	9d572159-689e-4d73-85cf-b7bd644603b1	9d572159-69ad-4784-aa29-3fb1082076b2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":498,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:44:32
20891	9d66fcac-42b1-40a6-b68a-a590dca3e9a3	9d66fcac-439b-4792-8215-005f09ab8906	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":442,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:55:13
15713	9d6496b5-707e-4e00-a471-1150043f4178	9d6496b5-987f-40ae-8a9b-27bd43eb1a49	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 08:18:27
15714	9d6496b5-9659-4036-b340-fa0f8f5a8ae1	9d6496b5-987f-40ae-8a9b-27bd43eb1a49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 08:18:27
15715	9d6496b5-9764-430a-b642-0c9b5819e7ac	9d6496b5-987f-40ae-8a9b-27bd43eb1a49	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":334,"memory":22,"hostname":"EderCortes"}	2024-11-02 08:18:27
25872	9d68c9fe-34c5-40b1-ba49-8a8a4acfd8ce	9d68c9fe-7860-44e3-808f-d67b40f3a159	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 10:25:10
25873	9d68c9fe-6abd-4d17-8086-ab30b986397e	9d68c9fe-7860-44e3-808f-d67b40f3a159	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"80.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:25:10
25874	9d68c9fe-6b42-4b19-a76b-9a11c6e8f2df	9d68c9fe-7860-44e3-808f-d67b40f3a159	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:25:10
25875	9d68c9fe-7599-45dc-ad77-93c714a83410	9d68c9fe-7860-44e3-808f-d67b40f3a159	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 10:25:10
25876	9d68c9fe-762a-41f4-bcfe-1ef2c57abbd2	9d68c9fe-7860-44e3-808f-d67b40f3a159	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1301,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:25:10
10803	9d5ca38b-44b2-4256-95c4-d5879bb150aa	9d5ca38c-bf1b-4185-ac4b-b0e8382f26da	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":591,"memory":18,"hostname":"EderCortes"}	2024-10-29 09:27:44
15716	9d6496b7-9734-4d4a-a91b-4fa3f433cce3	9d6496b7-c072-468f-88e2-ec241dde61b8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 08:18:29
15717	9d6496b7-b9d3-4a54-8f98-6b39efa943d0	9d6496b7-c072-468f-88e2-ec241dde61b8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"56.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 08:18:29
15718	9d6496b7-ba37-4e89-818c-4e310451aa25	9d6496b7-c072-468f-88e2-ec241dde61b8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 08:18:29
15719	9d6496b7-bf20-4b4c-a122-c54732a7b2c1	9d6496b7-c072-468f-88e2-ec241dde61b8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 08:18:29
15720	9d6496b7-bf77-4717-b52b-e9fa6329b36e	9d6496b7-c072-468f-88e2-ec241dde61b8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":418,"memory":22,"hostname":"EderCortes"}	2024-11-02 08:18:29
25877	9d68c9ff-5bc9-4cde-8e41-9fe278340ce4	9d68c9ff-80c8-4d73-b69e-df8747d8970e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 10:25:11
25878	9d68c9ff-79e1-4120-bb87-42992d32cbe9	9d68c9ff-80c8-4d73-b69e-df8747d8970e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"46.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:25:11
25879	9d68c9ff-7a45-4c04-af67-a99efde0e031	9d68c9ff-80c8-4d73-b69e-df8747d8970e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:25:11
25880	9d68c9ff-7f03-477b-b85b-b861e8d17569	9d68c9ff-80c8-4d73-b69e-df8747d8970e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 10:25:11
25881	9d68c9ff-7f78-4b0f-b679-6badcd31dd4d	9d68c9ff-80c8-4d73-b69e-df8747d8970e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":644,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:25:11
10804	9d5ca38e-d54e-4c92-90c4-64ffd31fe567	9d5ca392-4fa0-4a20-aee6-1db0efb37c9a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 09:27:45
10805	9d5ca391-1b34-4539-9925-10fd65155c78	9d5ca392-4fa0-4a20-aee6-1db0efb37c9a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"53.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-10-29 09:27:47
10806	9d5ca391-1b99-423d-81f2-5c1717e044d6	9d5ca392-4fa0-4a20-aee6-1db0efb37c9a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 09:27:47
10807	9d5ca392-4e28-4029-8817-638857903116	9d5ca392-4fa0-4a20-aee6-1db0efb37c9a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 09:27:48
10808	9d5ca392-4e89-4f02-b274-e92cffe79cfe	9d5ca392-4fa0-4a20-aee6-1db0efb37c9a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","profile":1},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":3427,"memory":24,"hostname":"EderCortes"}	2024-10-29 09:27:48
11905	9d5cd856-2ed3-4a06-b7e0-65103265b3f1	9d5cd856-510a-4d74-b613-1b76a112f7b8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 11:55:20
11906	9d5cd856-4f79-4557-b4c8-30b880c54c86	9d5cd856-510a-4d74-b613-1b76a112f7b8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 11:55:20
11907	9d5cd856-5011-4658-a8d1-16fe867779d2	9d5cd856-510a-4d74-b613-1b76a112f7b8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":248,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:55:20
10809	9d5ca393-5ea6-4fa3-b857-46fd17a9f180	9d5ca393-ce9a-48c7-9a07-5d4ce3dda5bc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 09:27:48
10810	9d5ca393-c680-4076-9f82-8e9a28dea1fe	9d5ca393-ce9a-48c7-9a07-5d4ce3dda5bc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"171.95","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 09:27:49
10811	9d5ca393-c6f1-4766-877d-2ba39ab9a532	9d5ca393-ce9a-48c7-9a07-5d4ce3dda5bc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 09:27:49
10812	9d5ca393-cce8-43cf-a16d-de9a6e95d908	9d5ca393-ce9a-48c7-9a07-5d4ce3dda5bc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 09:27:49
10813	9d5ca393-cd56-44e1-b88e-af55fa61d71c	9d5ca393-ce9a-48c7-9a07-5d4ce3dda5bc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":563,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:27:49
11908	9d5cd856-9f5c-4ea0-a888-18d6339c3b1d	9d5cd856-e99b-46a0-838b-c2abeeaed953	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 11:55:21
11909	9d5cd856-e0ce-43de-ad0b-e731d24ea1c4	9d5cd856-e99b-46a0-838b-c2abeeaed953	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 28\\n                        ","time":"153.34","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"618a8b500e46ad393f7c65ceec660399","hostname":"EderCortes"}	2024-10-29 11:55:21
11910	9d5cd856-e45d-4448-8926-8e112d71be77	9d5cd856-e99b-46a0-838b-c2abeeaed953	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '28' order by \\"item_loans\\".\\"id\\" asc","time":"1.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 11:55:21
11911	9d5cd856-e4a5-475d-ab10-a73ad6861bba	9d5cd856-e99b-46a0-838b-c2abeeaed953	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 11:55:21
11912	9d5cd856-e81e-4058-9a88-7c5428447297	9d5cd856-e99b-46a0-838b-c2abeeaed953	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 11:55:21
11913	9d5cd856-e866-416a-95c2-f1badf3b4223	9d5cd856-e99b-46a0-838b-c2abeeaed953	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/28","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":28,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":600081,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":94,"loans_codigo":28,"itemloans_cuota":"1","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":95,"loans_codigo":28,"itemloans_cuota":"2","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":96,"loans_codigo":28,"itemloans_cuota":"3","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":97,"loans_codigo":28,"itemloans_cuota":"4","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":98,"loans_codigo":28,"itemloans_cuota":"5","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":99,"loans_codigo":28,"itemloans_cuota":"6","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null}]}},"duration":359,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:55:21
10814	9d5ca3a5-e34c-4030-96f0-ca4f735b960b	9d5ca3a6-01f0-4a73-8970-f2c37167373b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 09:28:01
10815	9d5ca3a5-fca4-4d6d-9b8d-c91d158d8b3e	9d5ca3a6-01f0-4a73-8970-f2c37167373b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"40.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-29 09:28:01
10816	9d5ca3a5-fcfb-433e-8d7d-062d4284df50	9d5ca3a6-01f0-4a73-8970-f2c37167373b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-10-29 09:28:01
10817	9d5ca3a6-00da-4720-8cdb-8763a03ae048	9d5ca3a6-01f0-4a73-8970-f2c37167373b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 09:28:01
10818	9d5ca3a6-0124-41e2-99b7-0baf766cce31	9d5ca3a6-01f0-4a73-8970-f2c37167373b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":338,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:28:01
11914	9d5cd858-303e-44c9-800e-a501c1acdbca	9d5cd858-68e8-4a93-98af-31b4a732f658	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 11:55:22
11915	9d5cd858-63ec-4aac-b944-bcf077b84752	9d5cd858-68e8-4a93-98af-31b4a732f658	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"95.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 11:55:22
11916	9d5cd858-644c-4d4e-a2a9-3d506fe352e6	9d5cd858-68e8-4a93-98af-31b4a732f658	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 11:55:22
11917	9d5cd858-67bb-40b9-9c80-9683ff2ef356	9d5cd858-68e8-4a93-98af-31b4a732f658	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 11:55:22
11918	9d5cd858-67fc-4fa7-bf8f-617a3679e2a7	9d5cd858-68e8-4a93-98af-31b4a732f658	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":515,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:55:22
21312	9d6737f9-564b-4419-bacd-dd9f6a73ece6	9d6737f9-82de-4225-a043-41267732ea74	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 15:41:02
21313	9d6737f9-8073-4a07-805f-baafc4a5ba59	9d6737f9-82de-4225-a043-41267732ea74	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:41:02
21314	9d6737f9-81a8-4c37-8d7c-a7db470160e2	9d6737f9-82de-4225-a043-41267732ea74	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":328,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:41:02
10819	9d5ca3ab-a226-4a4a-8f95-5a816723e09a	9d5ca3ab-bdfa-41b7-ab1a-c0f74cc47d45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 09:28:04
10820	9d5ca3ab-b910-4c05-9556-7d65d1929632	9d5ca3ab-bdfa-41b7-ab1a-c0f74cc47d45	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"38.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-29 09:28:04
10821	9d5ca3ab-b968-477f-a7d3-8ac99e6a667c	9d5ca3ab-bdfa-41b7-ab1a-c0f74cc47d45	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-10-29 09:28:04
10822	9d5ca3ab-bcc3-4114-9a01-7d20da420df2	9d5ca3ab-bdfa-41b7-ab1a-c0f74cc47d45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 09:28:04
10823	9d5ca3ab-bd06-4629-98e8-4f85965024e8	9d5ca3ab-bdfa-41b7-ab1a-c0f74cc47d45	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":210,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:28:04
21315	9d6737fa-0da4-4d25-938e-9e0cab1d4ae3	9d6737fa-32a7-4ce5-b8b0-d32da50cae28	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:41:03
43517	9d6cea0b-36b6-4cc5-92e5-f70a300bda68	9d6cea0b-508a-40e4-b573-66ff8ab315a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-06 11:38:06
43518	9d6cea0b-4f2d-43a6-8fc5-4d91dff43a35	9d6cea0b-508a-40e4-b573-66ff8ab315a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-06 11:38:06
43519	9d6cea0b-4fbe-4ec0-9cc9-39dd37fbaefa	9d6cea0b-508a-40e4-b573-66ff8ab315a2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":220,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:06
21316	9d6737fa-26e2-40f7-8d12-458cb19b6cc3	9d6737fa-32a7-4ce5-b8b0-d32da50cae28	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 65\\n                        ","time":"48.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6768d7067397538897aacf4d73c43049","hostname":"EderCortes"}	2024-11-03 15:41:03
15824	9d64b0cc-1188-4026-aca2-a2e5d3bf6f9c	9d64b0cc-35bd-4fd7-a5be-58efdb47a577	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 09:31:24
15825	9d64b0cc-33b4-48a7-9637-848bafe406d9	9d64b0cc-35bd-4fd7-a5be-58efdb47a577	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:31:24
15826	9d64b0cc-3490-4928-ad7b-da31f18b3c50	9d64b0cc-35bd-4fd7-a5be-58efdb47a577	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":332,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:31:24
7102	9d52dab8-6898-41ec-9ccf-c6bba95daf86	9d52dab8-87b7-436f-8f7c-c79b023cbe44	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-24 12:43:43
7103	9d52dab8-85bb-4715-9750-9ea7ac0848b4	9d52dab8-87b7-436f-8f7c-c79b023cbe44	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-24 12:43:44
7104	9d52dab8-867c-4eac-9a76-e2b5bbbbe581	9d52dab8-87b7-436f-8f7c-c79b023cbe44	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":278,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:43:44
21317	9d6737fa-2b37-4691-b978-35222297c7a4	9d6737fa-32a7-4ce5-b8b0-d32da50cae28	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '65' order by \\"item_loans\\".\\"id\\" asc","time":"2.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 15:41:03
21318	9d6737fa-2b80-4665-af62-80ddac080c18	9d6737fa-32a7-4ce5-b8b0-d32da50cae28	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 15:41:03
21319	9d6737fa-3154-49b7-a224-8918cd489759	9d6737fa-32a7-4ce5-b8b0-d32da50cae28	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:41:03
21320	9d6737fa-31b5-4a77-aad9-3f080b42234b	9d6737fa-32a7-4ce5-b8b0-d32da50cae28	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/65","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":65,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":3000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-10 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"90000"},"items":[{"id":207,"loans_codigo":65,"itemloans_cuota":"1","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:40:03.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":208,"loans_codigo":65,"itemloans_cuota":"2","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":209,"loans_codigo":65,"itemloans_cuota":"3","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":210,"loans_codigo":65,"itemloans_cuota":"4","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":211,"loans_codigo":65,"itemloans_cuota":"5","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":212,"loans_codigo":65,"itemloans_cuota":"6","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":213,"loans_codigo":65,"itemloans_cuota":"7","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":214,"loans_codigo":65,"itemloans_cuota":"8","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":215,"loans_codigo":65,"itemloans_cuota":"9","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":216,"loans_codigo":65,"itemloans_cuota":"10","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-09-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":364,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:41:03
43520	9d6cea0b-bffa-49a2-81e7-38d85485397c	9d6cea0c-0aef-42c1-b1a1-5b29bb0f6eb2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-06 11:38:06
43521	9d6cea0c-05d3-4ca7-93d5-3a05a9a846c5	9d6cea0c-0aef-42c1-b1a1-5b29bb0f6eb2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"153.83","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 11:38:06
43522	9d6cea0c-062f-40cb-8807-36220c4e6c48	9d6cea0c-0aef-42c1-b1a1-5b29bb0f6eb2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 11:38:06
43523	9d6cea0c-098f-461c-b5d5-4f52a0346fea	9d6cea0c-0aef-42c1-b1a1-5b29bb0f6eb2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-06 11:38:06
43524	9d6cea0c-09ef-482d-87d4-c339a884abf3	9d6cea0c-0aef-42c1-b1a1-5b29bb0f6eb2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":343,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:06
15827	9d64b0cc-9bb8-4be6-bb2a-28de4f953611	9d64b0cc-bb41-4b54-a019-dbd657ec8943	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:31:24
12436	9d5ce527-a36a-49e1-bc8a-e8342822dfe0	9d5ce527-f246-4bc3-ba78-41f85604b1b5	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 12:31:11
12437	9d5ce527-f063-45d2-abba-62052f1b3d03	9d5ce527-f246-4bc3-ba78-41f85604b1b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:31:11
12438	9d5ce527-f119-42e4-8dd2-c55f5278db04	9d5ce527-f246-4bc3-ba78-41f85604b1b5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:31:11
12017	9d5ce07d-53f5-487d-b3ba-5f07127bbfdb	9d5ce07d-9a4f-4394-911e-843895e8bbbe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 12:18:08
12018	9d5ce07d-9846-40bd-ae98-4be0f77cb69f	9d5ce07d-9a4f-4394-911e-843895e8bbbe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 12:18:08
12019	9d5ce07d-990a-4f91-a1a3-b969ae20c09b	9d5ce07d-9a4f-4394-911e-843895e8bbbe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":366,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:08
15828	9d64b0cc-b0ec-4e2a-93bf-67ced271dfef	9d64b0cc-bb41-4b54-a019-dbd657ec8943	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"42.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"088d1fdbe045a08c3b0073ef22c7da32","hostname":"EderCortes"}	2024-11-02 09:31:24
15829	9d64b0cc-b53d-42b8-9ada-96bcdbc4f2fc	9d64b0cc-bb41-4b54-a019-dbd657ec8943	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:31:24
15830	9d64b0cc-b571-4626-80a5-c824830f34fc	9d64b0cc-bb41-4b54-a019-dbd657ec8943	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 09:31:24
15831	9d64b0cc-b9ce-4533-a645-e57a7442bc11	9d64b0cc-bb41-4b54-a019-dbd657ec8943	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:31:24
15832	9d64b0cc-ba33-48c6-b97b-40e7f5a7616e	9d64b0cc-bb41-4b54-a019-dbd657ec8943	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":284,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:31:24
21321	9d6737fc-4fa3-429a-8752-199d586dd99e	9d6737fc-a2c5-489c-9cc5-06491e410966	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:41:04
21322	9d6737fc-9916-4c72-aa6e-96b1eec62382	9d6737fc-a2c5-489c-9cc5-06491e410966	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"159.75","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 15:41:04
21323	9d6737fc-99ab-4328-80c9-f0c54acd0715	9d6737fc-a2c5-489c-9cc5-06491e410966	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 15:41:04
21324	9d6737fc-a0ed-4dee-ab7e-d30292231080	9d6737fc-a2c5-489c-9cc5-06491e410966	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 15:41:04
21325	9d6737fc-a15c-4400-91bd-9f40031b77c8	9d6737fc-a2c5-489c-9cc5-06491e410966	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":489,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:41:04
43525	9d6cea0c-4b7d-43c5-8cc0-d83aab6fa094	9d6cea0c-944e-41e2-a4b4-443eeb1038f8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-06 11:38:07
21326	9d673809-2e3b-4cfc-9c3b-24a23aaffaef	9d673809-319d-490d-a14c-3c412472daa9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":168,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:41:13
12636	9d5cec86-12b1-41fc-81fa-1764201851a6	9d5cec86-2fb7-403a-a41f-58fd88136c3b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 12:51:47
10023	9d56c740-4dfd-43b4-b61a-18b6f2bbc6f4	9d56c740-7267-4dea-ba5c-e7225eae8803	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 11:32:36
10024	9d56c740-7088-4abe-986d-82b0a823324b	9d56c740-7267-4dea-ba5c-e7225eae8803	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:32:36
10025	9d56c740-7159-47a8-bf93-1f5c1e4391e8	9d56c740-7267-4dea-ba5c-e7225eae8803	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:32:36
12439	9d5ce528-4a16-42e6-ab58-40181883b3d4	9d5ce528-90f5-45a9-830a-679adc1667da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:31:11
12637	9d5cec86-2e48-44dd-8962-de6bb0f06aed	9d5cec86-2fb7-403a-a41f-58fd88136c3b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 12:51:47
12638	9d5cec86-2ee4-4ae1-8f3d-57e35642fe57	9d5cec86-2fb7-403a-a41f-58fd88136c3b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":297,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:51:47
12020	9d5ce07d-ea76-4a75-b268-d1583192074a	9d5ce07e-08ea-4a18-a1a3-3c90bee16100	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 12:18:09
15919	9d64b462-3cff-4a99-93a2-1c271ab25a8e	9d64b462-61da-4381-88ac-18b87bb0820d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 09:41:26
15920	9d64b462-5fa6-46c2-847d-1bc233927dc8	9d64b462-61da-4381-88ac-18b87bb0820d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:41:26
15921	9d64b462-6095-4344-b6b8-afc21c3958df	9d64b462-61da-4381-88ac-18b87bb0820d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":352,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:41:26
43526	9d6cea0c-8f39-48f4-ae8e-17328df30c4d	9d6cea0c-944e-41e2-a4b4-443eeb1038f8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"150.65","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":286,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-06 11:38:07
43527	9d6cea0c-8f84-42ce-be16-fb28babc2557	9d6cea0c-944e-41e2-a4b4-443eeb1038f8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-06 11:38:07
43528	9d6cea0c-9326-4910-bb96-ef6bba19239a	9d6cea0c-944e-41e2-a4b4-443eeb1038f8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-06 11:38:07
43529	9d6cea0c-937c-4b39-adcd-9b4db8d52351	9d6cea0c-944e-41e2-a4b4-443eeb1038f8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":339,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:07
10026	9d56c740-c65c-4fff-8f9e-d3ebd797c8b5	9d56c740-e067-4c45-8f36-0ad704de2499	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:32:36
10027	9d56c740-dbe0-4247-a760-bb83fc4caa8c	9d56c740-e067-4c45-8f36-0ad704de2499	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"43.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:32:36
10028	9d56c740-df4c-4581-9787-6cb1459dbdb7	9d56c740-e067-4c45-8f36-0ad704de2499	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:32:36
10029	9d56c740-df98-4c1a-abc1-10a6e868076d	9d56c740-e067-4c45-8f36-0ad704de2499	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:32:36
12021	9d5ce07e-03b1-4e7c-9fe1-c446f8ad64eb	9d5ce07e-08ea-4a18-a1a3-3c90bee16100	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":177,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 12:18:09
12022	9d5ce07e-03fc-4dc9-9b5f-a9ad2eda8ff0	9d5ce07e-08ea-4a18-a1a3-3c90bee16100	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 12:18:09
12023	9d5ce07e-07ca-4e1d-9db7-c265a753d595	9d5ce07e-08ea-4a18-a1a3-3c90bee16100	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 12:18:09
12024	9d5ce07e-081a-445f-99af-f2b0348f054d	9d5ce07e-08ea-4a18-a1a3-3c90bee16100	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:09
12440	9d5ce528-87ea-40b9-9b45-b9a5c7c7c42d	9d5ce528-90f5-45a9-830a-679adc1667da	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 28\\n                        ","time":"146.84","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"618a8b500e46ad393f7c65ceec660399","hostname":"EderCortes"}	2024-10-29 12:31:11
12441	9d5ce528-8b93-4b25-a06c-b6d2254ca0c3	9d5ce528-90f5-45a9-830a-679adc1667da	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '28' order by \\"item_loans\\".\\"id\\" asc","time":"1.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 12:31:11
12442	9d5ce528-8bc5-41a0-9f1d-65be934d86f7	9d5ce528-90f5-45a9-830a-679adc1667da	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 12:31:11
12443	9d5ce528-8fc5-4a03-bc02-c1c3e470147a	9d5ce528-90f5-45a9-830a-679adc1667da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:31:11
12639	9d5cec86-73d5-4e3a-a0db-ae07282bcd38	9d5cec86-bbcf-4bd8-8796-c819eb8c6266	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 12:51:47
15922	9d64b462-ba0d-43ec-a581-44d57c5f9a31	9d64b462-d896-4888-b339-0c3f1c7232ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:41:26
10030	9d56c742-6fa3-474a-97da-16022d7537bb	9d56c742-900c-4a5c-b339-d2c61e964591	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:32:37
10031	9d56c742-8b2a-422b-9eec-0d21cf4ed93b	9d56c742-900c-4a5c-b339-d2c61e964591	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:32:37
10032	9d56c742-8b70-4533-9ac5-10bc88526249	9d56c742-900c-4a5c-b339-d2c61e964591	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:32:37
10033	9d56c742-8eac-48b2-9b4c-ffae674c2e4a	9d56c742-900c-4a5c-b339-d2c61e964591	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 11:32:37
10034	9d56c742-8ef9-4a02-ae18-4cb4f855eb3d	9d56c742-900c-4a5c-b339-d2c61e964591	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:32:37
12025	9d5ce07e-4e82-46c4-a30d-5be0e6a06969	9d5ce07e-7128-4950-b49c-5a8f262673d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 12:18:09
12026	9d5ce07e-69fa-4a2b-b6c2-bcdab70c7806	9d5ce07e-7128-4950-b49c-5a8f262673d8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":177,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 12:18:09
12027	9d5ce07e-6a73-4b4d-9ae2-cc5ec09e6db9	9d5ce07e-7128-4950-b49c-5a8f262673d8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 12:18:09
12028	9d5ce07e-6f5e-4b06-b64e-2d3d79b9897b	9d5ce07e-7128-4950-b49c-5a8f262673d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 12:18:09
12029	9d5ce07e-6fdc-4686-b0fe-719f053bde81	9d5ce07e-7128-4950-b49c-5a8f262673d8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:09
12444	9d5ce528-901c-48d4-b1bd-5664d033cc73	9d5ce528-90f5-45a9-830a-679adc1667da	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/28","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":28,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":600081,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":94,"loans_codigo":28,"itemloans_cuota":"1","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":95,"loans_codigo":28,"itemloans_cuota":"2","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":96,"loans_codigo":28,"itemloans_cuota":"3","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":97,"loans_codigo":28,"itemloans_cuota":"4","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":98,"loans_codigo":28,"itemloans_cuota":"5","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":99,"loans_codigo":28,"itemloans_cuota":"6","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null}]}},"duration":368,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:31:11
43530	9d6cea0c-e3d8-4ba5-ace8-12dbc2e09cf1	9d6cea0d-0d02-45f2-b19e-1f2e33fd4d50	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-06 11:38:07
43531	9d6cea0d-06c2-4ec5-a52e-18a6c4c5fe0c	9d6cea0d-0d02-45f2-b19e-1f2e33fd4d50	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"54.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":235,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 11:38:07
43532	9d6cea0d-0728-4e4f-a8b7-1d24bec5dd81	9d6cea0d-0d02-45f2-b19e-1f2e33fd4d50	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-06 11:38:07
43533	9d6cea0d-0b6d-423c-a9af-2754e993a269	9d6cea0d-0d02-45f2-b19e-1f2e33fd4d50	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-11-06 11:38:07
12030	9d5ce07f-ec52-42f5-8dcf-d4ac41386192	9d5ce080-540a-4658-aa31-d532ebbc1662	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 12:18:10
12031	9d5ce080-4ef7-4d19-a45d-ff5b47058e4c	9d5ce080-540a-4658-aa31-d532ebbc1662	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"162.71","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 12:18:10
12032	9d5ce080-4f44-4f57-870e-14692c8993cb	9d5ce080-540a-4658-aa31-d532ebbc1662	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 12:18:10
12033	9d5ce080-52cb-4f92-9cf7-adf7390e5785	9d5ce080-540a-4658-aa31-d532ebbc1662	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-29 12:18:10
9274	9d52f6ab-a4c7-4e61-b983-3940a20e43e5	9d52f6ab-eb37-4ed3-82ee-93e028987696	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 14:01:53
9275	9d52f6ab-e989-4ad1-b3bb-112ac5c2b831	9d52f6ab-eb37-4ed3-82ee-93e028987696	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 14:01:53
9276	9d52f6ab-ea45-4b42-8062-6c502653aaa7	9d52f6ab-eb37-4ed3-82ee-93e028987696	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":327,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:01:53
12034	9d5ce080-5310-4517-90a3-80f88bd1120d	9d5ce080-540a-4658-aa31-d532ebbc1662	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":630,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:10
12445	9d5ce52a-a013-417a-be19-48e9d7aa58b8	9d5ce52a-bce2-4652-a12e-734b463b9e29	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:31:13
12446	9d5ce52a-b758-4499-98ff-fab79e883d4d	9d5ce52a-bce2-4652-a12e-734b463b9e29	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 12:31:13
12447	9d5ce52a-b7a2-47b9-86b7-c7fa4b091344	9d5ce52a-bce2-4652-a12e-734b463b9e29	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 12:31:13
12448	9d5ce52a-bbad-471c-b466-1c1451e6fcb2	9d5ce52a-bce2-4652-a12e-734b463b9e29	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 12:31:13
12449	9d5ce52a-bbf5-404b-9d67-edab84cb0775	9d5ce52a-bce2-4652-a12e-734b463b9e29	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:31:13
12640	9d5cec86-b30d-423f-a9d7-1e55516c70af	9d5cec86-bbcf-4bd8-8796-c819eb8c6266	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 28\\n                        ","time":"150.42","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"618a8b500e46ad393f7c65ceec660399","hostname":"EderCortes"}	2024-10-29 12:51:48
12641	9d5cec86-b6f4-410c-8cb6-3f43ea418c35	9d5cec86-bbcf-4bd8-8796-c819eb8c6266	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '28' order by \\"item_loans\\".\\"id\\" asc","time":"1.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 12:51:48
9277	9d52f6ac-3220-4e29-aaee-2938bf644a19	9d52f6ac-4e6e-4399-be97-69ef80df5b65	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 14:01:53
9278	9d52f6ac-49bc-4cfb-b411-4143ea9797d3	9d52f6ac-4e6e-4399-be97-69ef80df5b65	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 14:01:53
9279	9d52f6ac-4a04-4883-91f9-be4551cc84a7	9d52f6ac-4e6e-4399-be97-69ef80df5b65	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 14:01:53
9280	9d52f6ac-4d71-412b-8bbb-3604c2d60f1f	9d52f6ac-4e6e-4399-be97-69ef80df5b65	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 14:01:53
8593	9d52edab-c91c-4864-b4a8-5f1f10ed3a13	9d52edac-1785-42f9-ac38-cfc73f967e91	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:36:43
8594	9d52edac-15b6-431a-a11e-9c5c73497b96	9d52edac-1785-42f9-ac38-cfc73f967e91	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:36:43
8595	9d52edac-1657-4f2c-b2c1-1b36747d3eb6	9d52edac-1785-42f9-ac38-cfc73f967e91	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":427,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:36:43
9281	9d52f6ac-4db0-48ca-9637-8a6b4ddde7c3	9d52f6ac-4e6e-4399-be97-69ef80df5b65	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:01:53
12035	9d5ce085-2d2e-4c13-a853-f64a68fb6b8e	9d5ce085-3001-4665-9baa-88bd04839fd2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":146,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:13
12642	9d5cec86-b722-4815-8a0f-c0ed0062cb94	9d5cec86-bbcf-4bd8-8796-c819eb8c6266	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 12:51:48
10918	9d5ca5d5-d40b-4ae4-9ea3-25fc79c7dfef	9d5ca5d5-f22a-4dd9-8bc1-736cadd539d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 09:34:08
10919	9d5ca5d5-f034-4522-8995-1a3d06e851ad	9d5ca5d5-f22a-4dd9-8bc1-736cadd539d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 09:34:08
10920	9d5ca5d5-f0fb-4b41-9345-425c8eb7960c	9d5ca5d5-f22a-4dd9-8bc1-736cadd539d8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:34:08
12643	9d5cec86-ba94-48a8-a742-d48c250d6387	9d5cec86-bbcf-4bd8-8796-c819eb8c6266	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 12:51:48
12644	9d5cec86-bae6-4ada-bb6b-942a04b22ef2	9d5cec86-bbcf-4bd8-8796-c819eb8c6266	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/28","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":28,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":600081,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":94,"loans_codigo":28,"itemloans_cuota":"1","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":95,"loans_codigo":28,"itemloans_cuota":"2","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":96,"loans_codigo":28,"itemloans_cuota":"3","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":97,"loans_codigo":28,"itemloans_cuota":"4","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":98,"loans_codigo":28,"itemloans_cuota":"5","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":99,"loans_codigo":28,"itemloans_cuota":"6","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null}]}},"duration":327,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:51:48
15923	9d64b462-cf2b-406a-8472-544d6fae1b99	9d64b462-d896-4888-b339-0c3f1c7232ce	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 22\\n                        ","time":"42.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"f9344e277d181987f84c6dcddcb4342d","hostname":"EderCortes"}	2024-11-02 09:41:26
15924	9d64b462-d2b9-4ab1-ac6a-e156396eb6d1	9d64b462-d896-4888-b339-0c3f1c7232ce	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '22' order by \\"item_loans\\".\\"id\\" asc","time":"2.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:41:26
15925	9d64b462-d2f2-475f-af49-9a98162b09bc	9d64b462-d896-4888-b339-0c3f1c7232ce	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-02 09:41:26
15926	9d64b462-d754-41e8-b5eb-17638bb1a25c	9d64b462-d896-4888-b339-0c3f1c7232ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:41:26
8596	9d52edac-618e-4bfb-b415-e1a4e9cebe36	9d52edac-a89f-495a-bd81-61ea890c0b1a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:36:43
8597	9d52edac-a406-4689-b242-00fe4efbc0b0	9d52edac-a89f-495a-bd81-61ea890c0b1a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"146.64","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:36:43
8598	9d52edac-a44e-4f2c-9f26-90cc697b4a8d	9d52edac-a89f-495a-bd81-61ea890c0b1a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:36:43
8599	9d52edac-a77a-46db-a26e-c92bcf27b8c6	9d52edac-a89f-495a-bd81-61ea890c0b1a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:36:43
8600	9d52edac-a7cf-41ee-af23-a522ca7599a1	9d52edac-a89f-495a-bd81-61ea890c0b1a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:36:43
9282	9d52f6ac-9143-4dde-8d91-c0f5a21b1961	9d52f6ac-ae9b-49fa-abda-5fdb92c24065	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 14:01:53
9283	9d52f6ac-a919-4d6b-909b-38f3aa3e75bb	9d52f6ac-ae9b-49fa-abda-5fdb92c24065	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"38.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 14:01:53
9284	9d52f6ac-a963-45fd-b08a-2696059343de	9d52f6ac-ae9b-49fa-abda-5fdb92c24065	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 14:01:53
9285	9d52f6ac-ad6f-4271-a43e-4577e80e115b	9d52f6ac-ae9b-49fa-abda-5fdb92c24065	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 14:01:53
9286	9d52f6ac-adbf-428a-a207-f1c56fba5645	9d52f6ac-ae9b-49fa-abda-5fdb92c24065	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:01:53
10921	9d5ca5d7-2e3a-4930-80c9-932c1a36315c	9d5ca5d7-73f9-41b5-8589-58fe0f57d0f1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 09:34:08
10922	9d5ca5d7-6e31-4e20-9a0c-74a6b7e8cc3a	9d5ca5d7-73f9-41b5-8589-58fe0f57d0f1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"144.71","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 09:34:09
10923	9d5ca5d7-6e80-4615-b08f-3bd0f68b6dfc	9d5ca5d7-73f9-41b5-8589-58fe0f57d0f1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 09:34:09
10924	9d5ca5d7-726b-4b5d-b8cf-cfe871ea0eec	9d5ca5d7-73f9-41b5-8589-58fe0f57d0f1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 09:34:09
10925	9d5ca5d7-72d6-46a6-a2b4-9e17a5fbfa0f	9d5ca5d7-73f9-41b5-8589-58fe0f57d0f1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":475,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:34:09
12036	9d5ce085-9453-479a-9ae3-5ef24b775895	9d5ce085-afb1-49ad-a585-e33c22a52b8e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-29 12:18:14
8601	9d52edac-ea0b-4ea6-9559-a77c5b683e29	9d52edad-0871-4ecf-8aff-0d40ba966660	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:36:44
8602	9d52edad-034d-4577-aa45-e2e1ae05fdcf	9d52edad-0871-4ecf-8aff-0d40ba966660	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:36:44
8603	9d52edad-039e-4502-af0c-f387733b4569	9d52edad-0871-4ecf-8aff-0d40ba966660	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:36:44
8604	9d52edad-0746-4398-a8ae-6b2b9c9f5dcd	9d52edad-0871-4ecf-8aff-0d40ba966660	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:36:44
8605	9d52edad-0793-4c58-9fee-2abdf95befb0	9d52edad-0871-4ecf-8aff-0d40ba966660	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:36:44
9287	9d52f6ac-f13d-4ee5-90d9-7863d7b680f9	9d52f6ad-0f50-46e8-9b6c-09d81b682f33	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 14:01:54
9288	9d52f6ad-0876-4788-9d7c-658e1768defc	9d52f6ad-0f50-46e8-9b6c-09d81b682f33	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"42.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-24 14:01:54
8962	9d52f26e-f40b-43fc-8866-03da41d6270a	9d52f26e-fd93-4e9f-bdc9-6e492477ab65	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"66.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:50:02
8963	9d52f26e-f48b-4aeb-8ecb-f547bfbed9a4	9d52f26e-fd93-4e9f-bdc9-6e492477ab65	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:50:02
8964	9d52f26e-fb5d-4d7e-8e7d-a0549427de9a	9d52f26e-fd93-4e9f-bdc9-6e492477ab65	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 13:50:02
9289	9d52f6ad-08f1-4ff0-a0d8-68cd853e6dfd	9d52f6ad-0f50-46e8-9b6c-09d81b682f33	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 14:01:54
9290	9d52f6ad-0a97-48e2-aa60-3063c487b828	9d52f6ad-0f50-46e8-9b6c-09d81b682f33	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"1.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 14:01:54
9291	9d52f6ad-0ac9-4abf-a703-ffecfb2ca566	9d52f6ad-0f50-46e8-9b6c-09d81b682f33	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 14:01:54
9292	9d52f6ad-0dcf-47c8-bf98-d9ed2ea4d070	9d52f6ad-0f50-46e8-9b6c-09d81b682f33	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 14:01:54
9293	9d52f6ad-0e15-49c1-b9c4-cf2323bebc23	9d52f6ad-0f50-46e8-9b6c-09d81b682f33	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:01:54
12037	9d5ce085-ab3c-4e32-9ef6-ac3ce4b9f55e	9d5ce085-afb1-49ad-a585-e33c22a52b8e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"40.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:14
12038	9d5ce085-ae58-4777-b9ba-788476cbfa4b	9d5ce085-afb1-49ad-a585-e33c22a52b8e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-29 12:18:14
8606	9d52edad-4a62-46bf-a425-c754f9fa024a	9d52edad-8e95-453f-afe3-3fd16757f54f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:36:44
8607	9d52edad-89f9-43c0-8a1e-5fed7d6cfcc5	9d52edad-8e95-453f-afe3-3fd16757f54f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"id\\" asc","time":"143.17","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"c160639e0dc4ff44f5d5d21affd614e2","hostname":"EderCortes"}	2024-10-24 13:36:44
8608	9d52edad-8a4b-4ce5-a525-0eb2e4c41810	9d52edad-8e95-453f-afe3-3fd16757f54f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:36:44
8609	9d52edad-8d89-49d4-8f5f-5a65f80cda63	9d52edad-8e95-453f-afe3-3fd16757f54f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:36:44
8610	9d52edad-8dcc-4dbd-ad8b-2663841c17e1	9d52edad-8e95-453f-afe3-3fd16757f54f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]},"duration":331,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:36:44
9294	9d52f6ae-aceb-40e8-ae7a-2436c05ca8aa	9d52f6ae-df9f-4915-bd9e-7c4fdc96233f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 14:01:55
9295	9d52f6ae-d90a-4adc-8798-5c8cb1c1155d	9d52f6ae-df9f-4915-bd9e-7c4fdc96233f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"70.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 14:01:55
9296	9d52f6ae-d96f-4315-ae51-8e16e3bad38f	9d52f6ae-df9f-4915-bd9e-7c4fdc96233f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 14:01:55
9297	9d52f6ae-de20-4923-94b3-02550b0a5d47	9d52f6ae-df9f-4915-bd9e-7c4fdc96233f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 14:01:55
9298	9d52f6ae-de8b-4edb-ab60-1163d7ed50cc	9d52f6ae-df9f-4915-bd9e-7c4fdc96233f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":533,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:01:55
12039	9d5ce085-ae9c-47c3-b2da-0dcc0364ff20	9d5ce085-afb1-49ad-a585-e33c22a52b8e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":222,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:14
15927	9d64b462-d7c6-43e6-a374-f40aded45cd2	9d64b462-d896-4888-b339-0c3f1c7232ce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/22","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":22,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":70,"loans_codigo":22,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":71,"loans_codigo":22,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":72,"loans_codigo":22,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":73,"loans_codigo":22,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":74,"loans_codigo":22,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":75,"loans_codigo":22,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-04-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:41:26
8611	9d52edaf-3219-4dfe-a3a6-560109d9c4ed	9d52edaf-5328-4d75-ad4b-21823478aa46	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:36:45
8612	9d52edaf-4e8a-4653-a705-87a3d8d4449a	9d52edaf-5328-4d75-ad4b-21823478aa46	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"46.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:36:45
8613	9d52edaf-4ed1-4b3b-9698-20d9188a4a4d	9d52edaf-5328-4d75-ad4b-21823478aa46	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:36:45
8614	9d52edaf-51ea-4e80-a343-e372a19aa62f	9d52edaf-5328-4d75-ad4b-21823478aa46	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 13:36:45
8615	9d52edaf-522c-4368-9aaf-7dbc124a2bce	9d52edaf-5328-4d75-ad4b-21823478aa46	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":288,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:36:45
15928	9d64b464-a2e0-48f3-b1f8-6006f29d001e	9d64b464-c75d-46c8-bf44-49b2bae712f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:41:27
15929	9d64b464-c015-40db-8f77-a20032a6274e	9d64b464-c75d-46c8-bf44-49b2bae712f6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"49.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 09:41:27
8965	9d52f26e-fbf3-44be-8702-af663ac6d94a	9d52f26e-fd93-4e9f-bdc9-6e492477ab65	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":495,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:50:02
15930	9d64b464-c073-4227-b454-fb18fb76fae0	9d64b464-c75d-46c8-bf44-49b2bae712f6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 09:41:27
15931	9d64b464-c5b3-4bd8-8c77-666988345d22	9d64b464-c75d-46c8-bf44-49b2bae712f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 09:41:27
15932	9d64b464-c618-4f0e-bade-1ad1d514e1fe	9d64b464-c75d-46c8-bf44-49b2bae712f6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","user-agent":"Mozilla\\/5.0 (iPhone; CPU iPhone OS 16_6 like Mac OS X) AppleWebKit\\/605.1.15 (KHTML, like Gecko) Version\\/16.6 Mobile\\/15E148 Safari\\/604.1","accept":"application\\/json, text\\/plain, *\\/*","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":310,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:41:27
21181	9d673685-a777-4f4c-85d2-aa5deb7d73c2	9d673686-98b4-4298-9849-4db1de94df08	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 15:36:59
21182	9d673686-959b-4e2e-a071-0bfc42d41680	9d673686-98b4-4298-9849-4db1de94df08	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:36:59
9303	9d52f706-c3c7-479c-96b4-fb5d8df5db3e	9d52f706-eeb5-4080-9261-733f656b1361	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 14:02:52
21183	9d673686-975c-4add-8c72-87e11990f580	9d673686-98b4-4298-9849-4db1de94df08	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":832,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:36:59
21334	9d67380a-80c9-4e35-bf3b-85bf77312572	9d67380a-9ddf-4b3e-bbf7-68ed16424deb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 15:41:14
21335	9d67380a-94e8-41d2-92c2-bfae2c05ab84	9d67380a-9ddf-4b3e-bbf7-68ed16424deb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 65\\n                        ","time":"39.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6768d7067397538897aacf4d73c43049","hostname":"EderCortes"}	2024-11-03 15:41:14
21184	9d673687-3ee9-4670-a26f-2f715a628fe2	9d673687-8fed-4826-a568-d27520acdebe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:37:00
21185	9d673687-8400-47d2-8d19-ed77d2ced154	9d673687-8fed-4826-a568-d27520acdebe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 65\\n                        ","time":"161.10","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6768d7067397538897aacf4d73c43049","hostname":"EderCortes"}	2024-11-03 15:37:00
9304	9d52f706-e6df-46fd-97cf-4d63dc7795dc	9d52f706-eeb5-4080-9261-733f656b1361	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"52.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 14:02:53
21186	9d673687-8900-4dd3-bf97-2102419dc529	9d673687-8fed-4826-a568-d27520acdebe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '65' order by \\"item_loans\\".\\"id\\" asc","time":"2.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 15:37:00
21187	9d673687-8938-410b-97d9-70382efea80d	9d673687-8fed-4826-a568-d27520acdebe	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 15:37:00
21336	9d67380a-988a-48b3-8911-0d5a857a28c3	9d67380a-9ddf-4b3e-bbf7-68ed16424deb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '65' order by \\"item_loans\\".\\"id\\" asc","time":"2.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 15:41:14
21188	9d673687-8e5e-4fed-a0c3-ee886b663bb7	9d673687-8fed-4826-a568-d27520acdebe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:37:00
21337	9d67380a-98cd-43a6-9181-1dad4921e218	9d67380a-9ddf-4b3e-bbf7-68ed16424deb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 15:41:14
21338	9d67380a-9c99-43fe-84a7-0d64ecc6be35	9d67380a-9ddf-4b3e-bbf7-68ed16424deb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 15:41:14
21339	9d67380a-9ce4-41c5-a5b6-bb15a2bd4a7d	9d67380a-9ddf-4b3e-bbf7-68ed16424deb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/65","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":65,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":3000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-10 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"90000"},"items":[{"id":207,"loans_codigo":65,"itemloans_cuota":"1","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:40:03.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":208,"loans_codigo":65,"itemloans_cuota":"2","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":209,"loans_codigo":65,"itemloans_cuota":"3","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":210,"loans_codigo":65,"itemloans_cuota":"4","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":211,"loans_codigo":65,"itemloans_cuota":"5","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":212,"loans_codigo":65,"itemloans_cuota":"6","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":213,"loans_codigo":65,"itemloans_cuota":"7","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":214,"loans_codigo":65,"itemloans_cuota":"8","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":215,"loans_codigo":65,"itemloans_cuota":"9","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":216,"loans_codigo":65,"itemloans_cuota":"10","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-09-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:41:14
21189	9d673687-8ecf-4bf2-9238-2c2abfad2334	9d673687-8fed-4826-a568-d27520acdebe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/65","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":65,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":3000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-10 00:00:00","loans_pago_prestado":"600000","loans_pago_interes":"180000"},"items":[{"id":207,"loans_codigo":65,"itemloans_cuota":"1","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:02.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":208,"loans_codigo":65,"itemloans_cuota":"2","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"300000"},{"id":209,"loans_codigo":65,"itemloans_cuota":"3","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":210,"loans_codigo":65,"itemloans_cuota":"4","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":211,"loans_codigo":65,"itemloans_cuota":"5","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":212,"loans_codigo":65,"itemloans_cuota":"6","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":213,"loans_codigo":65,"itemloans_cuota":"7","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":214,"loans_codigo":65,"itemloans_cuota":"8","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":215,"loans_codigo":65,"itemloans_cuota":"9","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":216,"loans_codigo":65,"itemloans_cuota":"10","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-09-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":531,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:37:00
16009	9d64b809-f5fb-4669-b63c-c7054b5ec72d	9d64b80a-3e03-4eef-b5ae-e7b7c275beee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 09:51:39
16010	9d64b80a-3bcf-4a88-8c96-9565bb5d0117	9d64b80a-3e03-4eef-b5ae-e7b7c275beee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 09:51:39
16011	9d64b80a-3c7e-4184-84dd-a3095fb05cd1	9d64b80a-3e03-4eef-b5ae-e7b7c275beee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:51:39
9305	9d52f706-e752-43c9-bdb8-90b9cd82bdf6	9d52f706-eeb5-4080-9261-733f656b1361	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 14:02:53
9306	9d52f706-ed1e-432b-92f2-5abc421fdbdf	9d52f706-eeb5-4080-9261-733f656b1361	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 14:02:53
21340	9d673881-1cea-4bba-bede-983b1879b508	9d673881-20ca-4b6e-8d6e-09e3799f6d7c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":171,"memory":20,"hostname":"EderCortes"}	2024-11-03 15:42:31
16012	9d64b80a-94df-4775-8987-89296c976479	9d64b80a-b781-441e-8efd-bd1f272528da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 09:51:39
16013	9d64b80a-aee2-4026-a61f-085dc28b4cc1	9d64b80a-b781-441e-8efd-bd1f272528da	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 22\\n                        ","time":"51.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"f9344e277d181987f84c6dcddcb4342d","hostname":"EderCortes"}	2024-11-02 09:51:39
16014	9d64b80a-b266-4ffb-befc-7d57dc108e8d	9d64b80a-b781-441e-8efd-bd1f272528da	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '22' order by \\"item_loans\\".\\"id\\" asc","time":"2.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:51:39
16015	9d64b80a-b2a2-432c-b932-841f2048ac22	9d64b80a-b781-441e-8efd-bd1f272528da	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-02 09:51:39
16016	9d64b80a-b64e-45ed-bdd1-87fbef0ef3b4	9d64b80a-b781-441e-8efd-bd1f272528da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 09:51:40
16017	9d64b80a-b6a6-4e58-bc21-f3d6e49a1b50	9d64b80a-b781-441e-8efd-bd1f272528da	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/22","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":22,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":70,"loans_codigo":22,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":71,"loans_codigo":22,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":72,"loans_codigo":22,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":73,"loans_codigo":22,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":74,"loans_codigo":22,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":75,"loans_codigo":22,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-04-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":271,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:51:40
21190	9d67368a-14b7-443b-9079-c05333232348	9d67368a-3c5b-4e51-aad1-80315815f24c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:37:02
21191	9d67368a-35e6-4b6c-9163-b08f7d1e76fb	9d67368a-3c5b-4e51-aad1-80315815f24c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"57.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 15:37:02
21192	9d67368a-3650-486e-bb32-a05ac79f17cc	9d67368a-3c5b-4e51-aad1-80315815f24c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 15:37:02
21193	9d67368a-3a9c-45e7-a2d3-25a941890543	9d67368a-3c5b-4e51-aad1-80315815f24c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 15:37:02
21194	9d67368a-3b11-43e6-a9fc-fb3485499f0b	9d67368a-3c5b-4e51-aad1-80315815f24c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":377,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:37:02
16018	9d64b80b-f214-4371-a5c0-ca255380d10c	9d64b80c-0f4d-4468-9148-b484210e1ba4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 09:51:40
16019	9d64b80c-0a0b-4b9c-960c-a8167d3055ff	9d64b80c-0f4d-4468-9148-b484210e1ba4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 09:51:40
16020	9d64b80c-0a5d-4cd4-8bcf-76abb80c226d	9d64b80c-0f4d-4468-9148-b484210e1ba4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 09:51:40
16021	9d64b80c-0df3-4beb-b655-e642796d59b9	9d64b80c-0f4d-4468-9148-b484210e1ba4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 09:51:40
16022	9d64b80c-0e3f-4663-bfdf-2a85b5ed7ca3	9d64b80c-0f4d-4468-9148-b484210e1ba4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":338,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:51:40
21348	9d673882-4770-455d-a045-21619f65955f	9d673882-6c0b-4e41-b39f-f71d97800b38	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:42:32
21349	9d673882-620c-4695-9d4c-5ad6390fe6a4	9d673882-6c0b-4e41-b39f-f71d97800b38	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 65\\n                        ","time":"51.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6768d7067397538897aacf4d73c43049","hostname":"EderCortes"}	2024-11-03 15:42:32
21350	9d673882-663a-4e26-9dba-a7117ad6aeb2	9d673882-6c0b-4e41-b39f-f71d97800b38	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '65' order by \\"item_loans\\".\\"id\\" asc","time":"2.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 15:42:32
11028	9d5ca7ec-7c6e-42e8-8f40-3543b236d466	9d5ca7ec-c369-4a1a-9c52-defdbe60a092	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 09:39:58
11029	9d5ca7ec-c1c3-4986-b2b3-0264d009e737	9d5ca7ec-c369-4a1a-9c52-defdbe60a092	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 09:39:58
11030	9d5ca7ec-c271-4647-93c2-47bf9b0b029f	9d5ca7ec-c369-4a1a-9c52-defdbe60a092	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:39:58
21351	9d673882-666d-438f-a869-f473e123b607	9d673882-6c0b-4e41-b39f-f71d97800b38	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 15:42:32
21352	9d673882-6aa4-4892-9e8f-b481ca4443cc	9d673882-6c0b-4e41-b39f-f71d97800b38	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:42:32
21353	9d673882-6af5-490a-b1ac-d5ee744eb36c	9d673882-6c0b-4e41-b39f-f71d97800b38	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/65","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":65,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":3000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-10 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"90000"},"items":[{"id":207,"loans_codigo":65,"itemloans_cuota":"1","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:40:03.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":208,"loans_codigo":65,"itemloans_cuota":"2","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":209,"loans_codigo":65,"itemloans_cuota":"3","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":210,"loans_codigo":65,"itemloans_cuota":"4","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":211,"loans_codigo":65,"itemloans_cuota":"5","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":212,"loans_codigo":65,"itemloans_cuota":"6","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":213,"loans_codigo":65,"itemloans_cuota":"7","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":214,"loans_codigo":65,"itemloans_cuota":"8","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":215,"loans_codigo":65,"itemloans_cuota":"9","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":216,"loans_codigo":65,"itemloans_cuota":"10","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-09-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":344,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:42:32
21986	9d674166-3d0f-414b-a8c2-997574a380f1	9d674166-5f08-497c-bc04-6122f2a959e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 16:07:24
21987	9d674166-5d4f-4aa7-a5e6-f6a65f68cf6d	9d674166-5f08-497c-bc04-6122f2a959e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 16:07:24
21988	9d674166-5e1e-4dc1-bb61-f1597b3b5017	9d674166-5f08-497c-bc04-6122f2a959e7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":312,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:07:24
11031	9d5ca7ed-149e-4139-affa-b4481d2e2192	9d5ca7ed-5985-4c78-9966-f02fcbd49708	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 09:39:58
11032	9d5ca7ed-5523-45ad-a51d-11ce3cd0f879	9d5ca7ed-5985-4c78-9966-f02fcbd49708	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"152.19","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-29 09:39:59
11033	9d5ca7ed-5843-4882-8e50-4c60a8d60688	9d5ca7ed-5985-4c78-9966-f02fcbd49708	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 09:39:59
11034	9d5ca7ed-588c-4c81-a28b-4821ca82299e	9d5ca7ed-5985-4c78-9966-f02fcbd49708	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":344,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:39:59
21989	9d674166-a765-4dd3-9cfa-3e20db906015	9d674166-c40e-49b3-b7f6-24abf56422ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 16:07:24
21990	9d674166-bf4a-4a58-afdd-186cdc67bf4d	9d674166-c40e-49b3-b7f6-24abf56422ce	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 16:07:24
21991	9d674166-bf99-4f25-94c1-8819af357835	9d674166-c40e-49b3-b7f6-24abf56422ce	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 16:07:24
21354	9d673916-6e12-4ae9-bf83-83f51ede8387	9d673916-71b8-4d0f-b8e6-512634da0b2b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":173,"memory":20,"hostname":"EderCortes"}	2024-11-03 15:44:09
21992	9d674166-c2d6-415a-b478-c6e572a6a75d	9d674166-c40e-49b3-b7f6-24abf56422ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 16:07:24
21993	9d674166-c32e-4618-81d0-57e13e776b2a	9d674166-c40e-49b3-b7f6-24abf56422ce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":218,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:07:24
11035	9d5ca7ee-e41d-441a-a8cc-c0377a925623	9d5ca7ef-29c4-434b-95b2-d44c48557cb1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 09:40:00
11036	9d5ca7ef-24d2-4bcf-8f7d-aa772f6c70c5	9d5ca7ef-29c4-434b-95b2-d44c48557cb1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"144.80","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 09:40:00
11037	9d5ca7ef-2522-4bb8-ac61-7fc916a5726f	9d5ca7ef-29c4-434b-95b2-d44c48557cb1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 09:40:00
11038	9d5ca7ef-286e-4488-b836-ba746883a5a1	9d5ca7ef-29c4-434b-95b2-d44c48557cb1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 09:40:00
11039	9d5ca7ef-28b6-4f8d-8496-c9015102439b	9d5ca7ef-29c4-434b-95b2-d44c48557cb1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":545,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:40:00
21355	9d673916-d71e-4a5a-bc23-da0b2f4ae583	9d673917-346c-4463-854d-28ffc2baf4d1	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 15:44:09
21356	9d673917-24b0-4519-8062-aef9ba81fd96	9d673917-346c-4463-854d-28ffc2baf4d1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 207 limit 1","time":"3.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-03 15:44:10
21357	9d673917-2530-41c5-81f1-46178f458879	9d673917-346c-4463-854d-28ffc2baf4d1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-03 15:44:10
21358	9d673917-2765-4de8-aa44-e01cefccbe0a	9d673917-346c-4463-854d-28ffc2baf4d1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 65 limit 1","time":"2.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 15:44:10
21359	9d673917-27a0-408b-9d76-e7cf5cd0877b	9d673917-346c-4463-854d-28ffc2baf4d1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 15:44:10
21360	9d673917-2b70-44e7-988b-e78c6f65ba3c	9d673917-346c-4463-854d-28ffc2baf4d1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '03-11-2024', \\"itemloans_interes_canelado\\" = '90000', \\"itemloans_cuota_cancelada\\" = '300000', \\"updated_at\\" = '2024-11-03 15:44:10' where \\"id\\" = 207","time":"7.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":400,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-03 15:44:10
21361	9d673917-2be2-4109-bdeb-edfb58aa670c	9d673917-346c-4463-854d-28ffc2baf4d1	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:207","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-03 15:44:10","item_loans_cuando_pago":"03-11-2024","itemloans_interes_canelado":"90000","itemloans_cuota_cancelada":"300000"},"hostname":"EderCortes"}	2024-11-03 15:44:10
21362	9d673917-2cd3-42bf-950c-6cc6b8f68732	9d673917-346c-4463-854d-28ffc2baf4d1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 180000, \\"loans_pago_prestado\\" = 600000, \\"updated_at\\" = '2024-11-03 15:44:10' where \\"id\\" = 65","time":"1.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":408,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-03 15:44:10
21363	9d673917-2d17-49cb-9b75-f08586245b62	9d673917-346c-4463-854d-28ffc2baf4d1	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:65","changes":{"updated_at":"2024-11-03 15:44:10","loans_pago_interes":180000,"loans_pago_prestado":600000},"hostname":"EderCortes"}	2024-11-03 15:44:10
21364	9d673917-3214-4dcf-9e4c-dfce96faa723	9d673917-346c-4463-854d-28ffc2baf4d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:44:10
21365	9d673917-32ae-4a5c-bbc0-ba89efa094ba	9d673917-346c-4463-854d-28ffc2baf4d1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"179","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"90000","itemloans_cuota_cancelada":"300000","id":207,"loans_codigo":65,"itemloans_cuota":"1","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":427,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:44:10
21994	9d674167-0a1a-423f-a97f-d60dbbe29e80	9d674167-2689-4c3d-86d6-d7dd460e06d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 16:07:24
21995	9d674167-219e-4bbe-bca0-a488193370df	9d674167-2689-4c3d-86d6-d7dd460e06d9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"38.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 16:07:24
21366	9d673917-a2eb-4c17-8672-39ee78b2d28e	9d673917-f40c-42dc-91d8-639173203176	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:44:10
21367	9d673917-e839-48e0-b0c1-e4825721be08	9d673917-f40c-42dc-91d8-639173203176	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 65\\n                        ","time":"160.45","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6768d7067397538897aacf4d73c43049","hostname":"EderCortes"}	2024-11-03 15:44:10
21368	9d673917-ecb0-4b3e-bd9d-53a904fe47ff	9d673917-f40c-42dc-91d8-639173203176	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '65' order by \\"item_loans\\".\\"id\\" asc","time":"2.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 15:44:10
8735	9d52eeb7-ca86-45c3-9654-c19d2a147eed	9d52eeb7-e973-408a-9eb5-36db055cb120	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:39:39
8736	9d52eeb7-e7ee-49e2-9989-96d3412bf079	9d52eeb7-e973-408a-9eb5-36db055cb120	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:39:39
8737	9d52eeb7-e88c-4b4d-b799-b369f9ba5e42	9d52eeb7-e973-408a-9eb5-36db055cb120	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:39:39
21369	9d673917-eced-47b7-9258-27ebc249bbf9	9d673917-f40c-42dc-91d8-639173203176	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 15:44:10
16129	9d64b9ac-d968-4e0f-8e23-5130b6145d16	9d64b9ac-fed3-4249-8a50-0a0eeb95350b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 09:56:14
21370	9d673917-f28f-4cb5-a05f-6edc70d98034	9d673917-f40c-42dc-91d8-639173203176	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:44:10
21371	9d673917-f2fd-43a7-85a7-b163cc74eed8	9d673917-f40c-42dc-91d8-639173203176	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/65","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":65,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":3000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-10 00:00:00","loans_pago_prestado":"600000","loans_pago_interes":"180000"},"items":[{"id":207,"loans_codigo":65,"itemloans_cuota":"1","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:44:10.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"90000","itemloans_cuota_cancelada":"300000"},{"id":208,"loans_codigo":65,"itemloans_cuota":"2","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":209,"loans_codigo":65,"itemloans_cuota":"3","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":210,"loans_codigo":65,"itemloans_cuota":"4","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":211,"loans_codigo":65,"itemloans_cuota":"5","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":212,"loans_codigo":65,"itemloans_cuota":"6","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":213,"loans_codigo":65,"itemloans_cuota":"7","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":214,"loans_codigo":65,"itemloans_cuota":"8","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":215,"loans_codigo":65,"itemloans_cuota":"9","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":216,"loans_codigo":65,"itemloans_cuota":"10","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-09-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":460,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:44:10
21996	9d674167-21ee-4489-9fff-04967230e6ba	9d674167-2689-4c3d-86d6-d7dd460e06d9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-03 16:07:24
21997	9d674167-254c-4581-a41e-9358c922e0d8	9d674167-2689-4c3d-86d6-d7dd460e06d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-03 16:07:24
21998	9d674167-2592-4e38-8d82-c37ea708b89d	9d674167-2689-4c3d-86d6-d7dd460e06d9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:07:24
8738	9d52eeb8-3148-4c4b-8ae9-ff44ad31ded3	9d52eeb8-7930-46d6-8618-f397ffb742c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:39:39
8739	9d52eeb8-74aa-4c4a-8153-d941029dbde3	9d52eeb8-7930-46d6-8618-f397ffb742c0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"150.45","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:39:39
8740	9d52eeb8-7507-4a14-9a51-57488ef514a4	9d52eeb8-7930-46d6-8618-f397ffb742c0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:39:39
8741	9d52eeb8-7832-4729-807f-5345297b9108	9d52eeb8-7930-46d6-8618-f397ffb742c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:39:39
8742	9d52eeb8-7870-47bc-a8ce-f213c0b3ea38	9d52eeb8-7930-46d6-8618-f397ffb742c0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":339,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:39:39
16130	9d64b9ac-fc9d-4548-ada4-2d0a919e08d9	9d64b9ac-fed3-4249-8a50-0a0eeb95350b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:56:14
11122	9d5cab46-8cbb-4488-8f63-462595f64860	9d5cab46-af1f-4a87-a069-415f6d2e47a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 09:49:20
11123	9d5cab46-ad00-44fb-aa56-2956a74a9d48	9d5cab46-af1f-4a87-a069-415f6d2e47a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 09:49:20
11124	9d5cab46-adc8-4f74-9d45-ae83de174fb1	9d5cab46-af1f-4a87-a069-415f6d2e47a1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:49:20
16131	9d64b9ac-fd98-4515-adf0-d1c1e5afb0bd	9d64b9ac-fed3-4249-8a50-0a0eeb95350b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:56:14
8743	9d52eeb8-b896-49b0-a9e9-453f215b52fb	9d52eeb8-d62b-41c2-8164-b7d33ee9daca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:39:39
8744	9d52eeb8-d178-4bc7-89f3-7017840c6904	9d52eeb8-d62b-41c2-8164-b7d33ee9daca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:39:39
8745	9d52eeb8-d1c4-4609-8ba3-ccb3bde8942d	9d52eeb8-d62b-41c2-8164-b7d33ee9daca	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:39:39
8746	9d52eeb8-d50e-4816-a5ad-250482a784d0	9d52eeb8-d62b-41c2-8164-b7d33ee9daca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:39:39
8747	9d52eeb8-d55a-4555-a986-daa12eb01b3b	9d52eeb8-d62b-41c2-8164-b7d33ee9daca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":219,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:39:39
11125	9d5cab46-f9ab-4c46-bedf-5aefacfcb916	9d5cab47-1d14-42e6-9abb-67742bd0b768	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 09:49:21
11126	9d5cab47-11e5-47bf-bd4b-4b0ebf6c7ccb	9d5cab47-1d14-42e6-9abb-67742bd0b768	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 1\\n                        ","time":"50.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"2bd5a29c69f6bbb290fc49b79286632e","hostname":"EderCortes"}	2024-10-29 09:49:21
9307	9d52f706-ed6c-4128-a41b-e5971f7ebc8f	9d52f706-eeb5-4080-9261-733f656b1361	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":390,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:02:53
11127	9d5cab47-16a0-4b07-a3a4-37c402745297	9d5cab47-1d14-42e6-9abb-67742bd0b768	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1' order by \\"item_loans\\".\\"id\\" asc","time":"2.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 09:49:21
11128	9d5cab47-16e5-4399-ac14-59bcef4bae01	9d5cab47-1d14-42e6-9abb-67742bd0b768	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 09:49:21
11129	9d5cab47-1b92-47f5-aa3e-a1dc44527181	9d5cab47-1d14-42e6-9abb-67742bd0b768	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 09:49:21
11130	9d5cab47-1bf3-48f6-8294-93b235ca3ff6	9d5cab47-1d14-42e6-9abb-67742bd0b768	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":1,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]}},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:49:21
16132	9d64b9ad-593a-4cd4-9ff1-e74dea6ce95b	9d64b9ad-7bea-43a6-a68d-efc17436349d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:56:14
8748	9d52eeb9-17e4-4739-9830-5e55727d7c41	9d52eeb9-5e68-4776-a69a-e8cbf02da8b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-24 13:39:39
8749	9d52eeb9-57f4-454b-beff-5158c16577f1	9d52eeb9-5e68-4776-a69a-e8cbf02da8b4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc","time":"146.63","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"1c647a8d9ee2a83df3e977318f9d3347","hostname":"EderCortes"}	2024-10-24 13:39:40
8750	9d52eeb9-584b-4518-817f-6fd5523137ac	9d52eeb9-5e68-4776-a69a-e8cbf02da8b4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:39:40
8751	9d52eeb9-59b8-4570-882d-326c960c7523	9d52eeb9-5e68-4776-a69a-e8cbf02da8b4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"1.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 13:39:40
8752	9d52eeb9-59f0-4b51-b1b0-2c2b2161d26b	9d52eeb9-5e68-4776-a69a-e8cbf02da8b4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:39:40
8753	9d52eeb9-5d0f-40cd-94e8-e06997d63609	9d52eeb9-5e68-4776-a69a-e8cbf02da8b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:39:40
8754	9d52eeb9-5d54-4875-b2e5-65bdd98382bd	9d52eeb9-5e68-4776-a69a-e8cbf02da8b4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"item":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:39:40
11131	9d5cab48-4626-438c-b3f6-6c9bda7529dc	9d5cab48-830f-4ba8-928b-58d2120f2a53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 09:49:21
11132	9d5cab48-7a0a-4f0c-868c-a157c64fd00e	9d5cab48-830f-4ba8-928b-58d2120f2a53	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"71.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 09:49:22
11133	9d5cab48-7a78-4cab-a471-a351c9e0bc3c	9d5cab48-830f-4ba8-928b-58d2120f2a53	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 09:49:22
11134	9d5cab48-8105-4757-b96a-cb3c727215ea	9d5cab48-830f-4ba8-928b-58d2120f2a53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 09:49:22
11135	9d5cab48-8189-47e9-954a-c82ffb94c233	9d5cab48-830f-4ba8-928b-58d2120f2a53	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":485,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:49:22
16133	9d64b9ad-7151-4057-82c7-16adde07b193	9d64b9ad-7bea-43a6-a68d-efc17436349d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 22\\n                        ","time":"46.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"f9344e277d181987f84c6dcddcb4342d","hostname":"EderCortes"}	2024-11-02 09:56:14
16134	9d64b9ad-753d-4c36-9e0f-bdaecbe9b898	9d64b9ad-7bea-43a6-a68d-efc17436349d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '22' order by \\"item_loans\\".\\"id\\" asc","time":"2.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:56:14
16135	9d64b9ad-7579-479a-8267-bdb40e5d4dce	9d64b9ad-7bea-43a6-a68d-efc17436349d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-02 09:56:14
16136	9d64b9ad-7a15-4a0e-b44b-419090893703	9d64b9ad-7bea-43a6-a68d-efc17436349d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:56:14
8755	9d52eebb-0e0a-46d5-ab38-11afe8596eba	9d52eebb-2e72-4f10-911b-120c35563906	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-24 13:39:41
8756	9d52eebb-2995-48dc-ae65-d671873f3fd6	9d52eebb-2e72-4f10-911b-120c35563906	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:39:41
8757	9d52eebb-29e2-4a71-98c8-2c9487c48987	9d52eebb-2e72-4f10-911b-120c35563906	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:39:41
8758	9d52eebb-2d4d-4e93-ae3c-bb0a8c320b65	9d52eebb-2e72-4f10-911b-120c35563906	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 13:39:41
8759	9d52eebb-2d8e-41f8-90cd-48fa62996668	9d52eebb-2e72-4f10-911b-120c35563906	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":304,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:39:41
16137	9d64b9ad-7a8f-4e74-a22c-cdddd2640263	9d64b9ad-7bea-43a6-a68d-efc17436349d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/22","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":22,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":70,"loans_codigo":22,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":71,"loans_codigo":22,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":72,"loans_codigo":22,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":73,"loans_codigo":22,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":74,"loans_codigo":22,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":75,"loans_codigo":22,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-04-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":282,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:56:14
9308	9d52f707-3b7f-470a-8c75-ace346ac165d	9d52f707-60ee-43fe-8365-25f23752f2e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 14:02:53
9309	9d52f707-5b18-42e4-b2e7-7e05f632eeba	9d52f707-60ee-43fe-8365-25f23752f2e0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"53.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 14:02:53
9310	9d52f707-5b7a-4dbc-9816-574255ae7103	9d52f707-60ee-43fe-8365-25f23752f2e0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 14:02:53
9311	9d52f707-5f80-41de-ac68-418c1996c9ec	9d52f707-60ee-43fe-8365-25f23752f2e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 14:02:53
16233	9d64bc72-01b4-4ffd-91e8-0f346893c4d7	9d64bc72-313b-4f5a-bd43-a7f2f10308cc	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 10:03:58
16234	9d64bc72-2e6a-467d-87c7-f07c635fcb87	9d64bc72-313b-4f5a-bd43-a7f2f10308cc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 10:03:58
16235	9d64bc72-2f9e-4f10-8438-f3838ec22700	9d64bc72-313b-4f5a-bd43-a7f2f10308cc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":370,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:03:58
16138	9d64b9af-186f-42e5-97c0-6630a1077acb	9d64b9af-6de9-4846-9f05-a10df108bd6f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:56:15
16139	9d64b9af-6619-479e-9d81-c26fc308d8c0	9d64b9af-6de9-4846-9f05-a10df108bd6f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"166.43","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 09:56:15
16140	9d64b9af-669c-4781-bc7c-59fbd2abbe8d	9d64b9af-6de9-4846-9f05-a10df108bd6f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 09:56:15
16141	9d64b9af-6c32-489b-b9a8-9d9d56af00fd	9d64b9af-6de9-4846-9f05-a10df108bd6f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 09:56:15
16142	9d64b9af-6c9c-449f-97a9-7c3397e050ee	9d64b9af-6de9-4846-9f05-a10df108bd6f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":473,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:56:15
16236	9d64bc72-a638-471f-b30f-4d1df9eb33ea	9d64bc72-d241-4dfe-82e6-3da7bf25d090	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 10:03:59
16237	9d64bc72-c4aa-4747-8779-358e3b9402a1	9d64bc72-d241-4dfe-82e6-3da7bf25d090	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"62.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 10:03:59
16238	9d64bc72-c9d2-4c17-837e-4e767dc9b8c8	9d64bc72-d241-4dfe-82e6-3da7bf25d090	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 10:03:59
16239	9d64bc72-ca25-43cd-a54c-f30bc00aa907	9d64bc72-d241-4dfe-82e6-3da7bf25d090	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 10:03:59
16240	9d64bc72-d0a6-4a3d-8daf-a13bdfa1a310	9d64bc72-d241-4dfe-82e6-3da7bf25d090	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 10:03:59
16241	9d64bc72-d113-4df8-8b3c-19e13ee29783	9d64bc72-d241-4dfe-82e6-3da7bf25d090	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":362,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:03:59
16242	9d64bc74-e9ab-411c-b69a-57aff7e8212e	9d64bc75-09a0-4075-85c8-c684bef97f18	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 10:04:00
16243	9d64bc75-04fe-4e9f-ae8a-ad401a9e87ce	9d64bc75-09a0-4075-85c8-c684bef97f18	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"48.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 10:04:00
16244	9d64bc75-0556-4768-8592-e13e104d8e1b	9d64bc75-09a0-4075-85c8-c684bef97f18	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 10:04:00
16245	9d64bc75-0854-4c16-bb99-468691757b2f	9d64bc75-09a0-4075-85c8-c684bef97f18	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 10:04:00
16246	9d64bc75-089b-434c-a418-c38db41b5f2a	9d64bc75-09a0-4075-85c8-c684bef97f18	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:04:00
22088	9d674251-03e6-4720-b9fc-a39a04367f73	9d674251-59b0-49af-8c9a-06704f7e49f1	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 16:09:57
22089	9d674251-574e-4ac6-a5fc-155febfc9c15	9d674251-59b0-49af-8c9a-06704f7e49f1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 16:09:58
22090	9d674251-5858-4501-a15d-2b11b04c5fd9	9d674251-59b0-49af-8c9a-06704f7e49f1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":482,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:09:58
22091	9d674251-e0ca-44af-b5c6-909dd051fd8c	9d674252-3246-4be2-94be-eb9f5a6328a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 16:09:58
22092	9d674252-2ae4-4e78-96ff-f0364c30c673	9d674252-3246-4be2-94be-eb9f5a6328a2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"156.26","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 16:09:58
22093	9d674252-2b50-4eab-96e9-e6ce7826eb50	9d674252-3246-4be2-94be-eb9f5a6328a2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 16:09:58
22094	9d674252-30f7-4f72-a3a9-bb094e222559	9d674252-3246-4be2-94be-eb9f5a6328a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 16:09:58
21744	9d673e08-6cd3-4759-ae35-d0667f20a86f	9d673e08-956b-48bb-841f-85ed06bbcb3b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-03 15:57:59
21745	9d673e08-9380-4775-b689-a61a26237a5a	9d673e08-956b-48bb-841f-85ed06bbcb3b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-03 15:57:59
21746	9d673e08-9425-4e41-a8b7-fdaaf4d7248c	9d673e08-956b-48bb-841f-85ed06bbcb3b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":352,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:57:59
22095	9d674252-3155-47e1-99cd-4dc19d193d1a	9d674252-3246-4be2-94be-eb9f5a6328a2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":506,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:09:58
43534	9d6cea0d-0bee-4dd5-97fd-e0ee1482fe8d	9d6cea0d-0d02-45f2-b19e-1f2e33fd4d50	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":288,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:07
21747	9d673e09-3dc2-448a-a6f9-8306bf04f846	9d673e09-6911-4b89-bf00-ce281ca8b1dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-03 15:57:59
21748	9d673e09-61b2-4b61-a886-5b03dd80c749	9d673e09-6911-4b89-bf00-ce281ca8b1dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"54.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 15:57:59
21749	9d673e09-6225-4b16-a8e8-d5368515fa80	9d673e09-6911-4b89-bf00-ce281ca8b1dd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 15:57:59
21750	9d673e09-676e-4f7d-bb43-e5cb475d5a67	9d673e09-6911-4b89-bf00-ce281ca8b1dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-03 15:57:59
21751	9d673e09-67cf-4f37-abc5-5b2dc6f14089	9d673e09-6911-4b89-bf00-ce281ca8b1dd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":498,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:57:59
22096	9d674252-861f-42b9-b82e-43fc2e490e9f	9d674252-d3a5-4aef-8e45-b1f2a7b355b8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 16:09:58
22097	9d674252-cd58-46c5-93ce-b58e6f3296bc	9d674252-d3a5-4aef-8e45-b1f2a7b355b8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"152.10","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 16:09:59
22098	9d674252-cda5-4839-9cce-09b298d2ab63	9d674252-d3a5-4aef-8e45-b1f2a7b355b8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-03 16:09:59
22099	9d674252-d227-4286-81aa-bc0f718a07c7	9d674252-d3a5-4aef-8e45-b1f2a7b355b8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 16:09:59
22100	9d674252-d278-4192-9a9a-8a89af764393	9d674252-d3a5-4aef-8e45-b1f2a7b355b8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":396,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:09:59
21752	9d673e09-c070-43a6-8ad2-fef8255ffb9c	9d673e0a-0f18-414a-9aa6-2a3438ad0583	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-03 15:58:00
21753	9d673e0a-08c4-4a01-82ae-d6e601fa4dac	9d673e0a-0f18-414a-9aa6-2a3438ad0583	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"157.51","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 15:58:00
21754	9d673e0a-0925-470b-99a0-0d56c823ec09	9d673e0a-0f18-414a-9aa6-2a3438ad0583	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-03 15:58:00
21755	9d673e0a-0d89-4509-a39c-c26ec1f069ef	9d673e0a-0f18-414a-9aa6-2a3438ad0583	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-03 15:58:00
21756	9d673e0a-0e04-4776-9ef5-8f1b40512e88	9d673e0a-0f18-414a-9aa6-2a3438ad0583	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":405,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:58:00
258	9d4f168a-3140-4cac-a90b-0f6da9b966ab	9d4f168a-a681-44d0-bea0-0a7fb36e9b51	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna menu.menu_name, menu_url\\nLINE 1: select \\"menu\\".\\"menu_name, menu_url\\" from \\"menu\\" inner join \\"...\\n               ^ (Connection: pgsql, SQL: select \\"menu\\".\\"menu_name, menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":14}	2024-10-22 15:47:41
21757	9d673e0c-34d9-4432-a6dd-036a5bd50fc6	9d673e0c-79b9-4303-9f8d-ea0bb6613dc3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-03 15:58:01
21758	9d673e0c-7024-4faf-8da6-538dfc651033	9d673e0c-79b9-4303-9f8d-ea0bb6613dc3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"75.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 15:58:01
21759	9d673e0c-70b8-4c7c-a003-e3549dafb47a	9d673e0c-79b9-4303-9f8d-ea0bb6613dc3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 15:58:01
21760	9d673e0c-778b-4f2c-86cf-2351267cd790	9d673e0c-79b9-4303-9f8d-ea0bb6613dc3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-03 15:58:01
9097	9d52f429-8866-4ff7-8d8a-51292496edc2	9d52f429-adfd-49c5-ae86-b5dfce0b808e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 13:54:52
9098	9d52f429-abca-422b-b3ca-02b2c7158888	9d52f429-adfd-49c5-ae86-b5dfce0b808e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:54:52
9099	9d52f429-acc4-44ea-b0ce-10bd22869bfc	9d52f429-adfd-49c5-ae86-b5dfce0b808e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":302,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:54:52
21761	9d673e0c-7801-471f-9a13-eec229171eb1	9d673e0c-79b9-4303-9f8d-ea0bb6613dc3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":611,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:58:01
22190	9d67439a-325a-46fc-8d81-87cddd45c91d	9d67439a-5cc3-4cbd-b456-72757923d90e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 16:13:33
22191	9d67439a-59c3-4072-bdc5-3f9e00c5e5b4	9d67439a-5cc3-4cbd-b456-72757923d90e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 16:13:33
22192	9d67439a-5b53-4402-a895-483ab70d49e0	9d67439a-5cc3-4cbd-b456-72757923d90e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":470,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:13:33
9100	9d52f42a-1241-436b-90e0-46962974222a	9d52f42a-3144-4fb5-aa07-616f75b2f4a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 13:54:52
9101	9d52f42a-2ba2-425a-8b6e-bc83c19f3817	9d52f42a-3144-4fb5-aa07-616f75b2f4a2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:54:52
9102	9d52f42a-2bf8-44ea-bd47-9c942f34434a	9d52f42a-3144-4fb5-aa07-616f75b2f4a2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:54:52
9103	9d52f42a-3011-4e25-a2e7-51ada41d5a07	9d52f42a-3144-4fb5-aa07-616f75b2f4a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:54:52
9104	9d52f42a-3055-4d4c-bcb4-2418650ed6f2	9d52f42a-3144-4fb5-aa07-616f75b2f4a2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":305,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:54:52
10179	9d56cabd-19db-4e50-beba-66f4e6f7929f	9d56cabd-6c9a-4576-9ad2-ff5faddcab0d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 11:42:21
10180	9d56cabd-6a07-48d6-b9e3-4c241a14f6c3	9d56cabd-6c9a-4576-9ad2-ff5faddcab0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:42:21
10181	9d56cabd-6b09-4a99-9ec6-d97d1da11f11	9d56cabd-6c9a-4576-9ad2-ff5faddcab0d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":384,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:42:21
12907	9d5cee6c-c1be-4db4-9050-d8764fd13650	9d5cee6c-e702-4fb3-b11f-7479c490664c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 12:57:06
12908	9d5cee6c-e526-4aa8-9560-fbd29eca6dd0	9d5cee6c-e702-4fb3-b11f-7479c490664c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:57:06
12909	9d5cee6c-e602-403d-9ed4-9b2deb350ff6	9d5cee6c-e702-4fb3-b11f-7479c490664c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:57:06
16338	9d64c311-8b19-4023-b74f-23f7a1d4ff5c	9d64c311-aa87-4e3d-b3f2-81b2873a1cbe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 10:22:29
16339	9d64c311-a8fa-4af3-bc39-c9a789cc384a	9d64c311-aa87-4e3d-b3f2-81b2873a1cbe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 10:22:30
16340	9d64c311-a994-44a5-b98d-d841e4a49cbf	9d64c311-aa87-4e3d-b3f2-81b2873a1cbe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:22:30
22193	9d67439a-d0f1-4269-9e4d-669f45af2b30	9d67439a-f566-4950-b4f2-8c80ee082cda	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 16:13:34
22194	9d67439a-eea6-4cc8-8801-5a30a7954a7c	9d67439a-f566-4950-b4f2-8c80ee082cda	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"51.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 16:13:34
22195	9d67439a-ef0b-4dae-9d82-d709cdb16ca4	9d67439a-f566-4950-b4f2-8c80ee082cda	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 16:13:34
22196	9d67439a-f3f9-464d-9d39-145dc73eb966	9d67439a-f566-4950-b4f2-8c80ee082cda	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 16:13:34
22197	9d67439a-f44d-4bf8-8363-34da6cbc531d	9d67439a-f566-4950-b4f2-8c80ee082cda	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:13:34
9105	9d52f42a-713c-44bf-b5da-12b0c12f7ce3	9d52f42a-8f0b-4095-8798-46c94809f189	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 13:54:53
9106	9d52f42a-89a8-49d0-a13f-9538a00a9f73	9d52f42a-8f0b-4095-8798-46c94809f189	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:54:53
9107	9d52f42a-8a0a-41ec-afbd-9174b2a95a9c	9d52f42a-8f0b-4095-8798-46c94809f189	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 13:54:53
9108	9d52f42a-8db8-4752-970c-943a9a6f7ac1	9d52f42a-8f0b-4095-8798-46c94809f189	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:54:53
9109	9d52f42a-8e0b-4fbe-b739-8225fed2349e	9d52f42a-8f0b-4095-8798-46c94809f189	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:54:53
10182	9d56cabd-caea-4ca1-9e40-ce578371ed7f	9d56cabe-0dd7-4cad-a2aa-15bcda08bed4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:42:21
10183	9d56cabe-090b-4cd4-b1c7-4c3ee6c1f4a3	9d56cabe-0dd7-4cad-a2aa-15bcda08bed4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"143.94","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:42:22
9312	9d52f707-5fd6-4149-ad86-305908f1a821	9d52f707-60ee-43fe-8365-25f23752f2e0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":272,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:02:53
10184	9d56cabe-0cca-4403-94c9-6dfe2e665a39	9d56cabe-0dd7-4cad-a2aa-15bcda08bed4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:42:22
10185	9d56cabe-0d0c-4729-9a41-d90340037298	9d56cabe-0dd7-4cad-a2aa-15bcda08bed4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:42:22
12910	9d5cee6d-38e6-4f4a-a18c-912d8c028dec	9d5cee6d-57bf-465f-9b5c-a0415de2a451	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:57:06
16341	9d64c312-1a9f-484e-a0f8-715378bdb178	9d64c312-4bdd-46dc-9d30-4d292163560d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 10:22:30
22198	9d67439b-46d6-4141-a011-f78a018d16dd	9d67439b-6c51-45d0-8379-ada090147373	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 16:13:34
9110	9d52f42a-d0b6-4585-99da-e8cb094ad64f	9d52f42a-ef1e-43c7-9232-f3ab9f836aaa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 13:54:53
9111	9d52f42a-e8a0-4895-98c8-a0b782985c57	9d52f42a-ef1e-43c7-9232-f3ab9f836aaa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"41.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-24 13:54:53
9112	9d52f42a-e90a-4dd2-b4e4-fca2eac0a515	9d52f42a-ef1e-43c7-9232-f3ab9f836aaa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 13:54:53
9113	9d52f42a-eaa3-4018-8602-b731184b9c8c	9d52f42a-ef1e-43c7-9232-f3ab9f836aaa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"1.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 13:54:53
9114	9d52f42a-eada-429f-9338-d492d96c4f77	9d52f42a-ef1e-43c7-9232-f3ab9f836aaa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 13:54:53
9115	9d52f42a-edf9-428e-bc6c-6fe41bab0606	9d52f42a-ef1e-43c7-9232-f3ab9f836aaa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:54:53
9116	9d52f42a-ee49-44b6-b835-47b8b6b89710	9d52f42a-ef1e-43c7-9232-f3ab9f836aaa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":true,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:54:53
10186	9d56cabf-88ba-4c49-8d12-f73a04080199	9d56cabf-d5d9-4920-9b4a-f86fb0ffb5e9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:42:22
10187	9d56cabf-cfee-4359-a20c-ce71704ea42f	9d56cabf-d5d9-4920-9b4a-f86fb0ffb5e9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"157.73","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:42:23
9313	9d52f707-bac5-46bc-a190-2946e83ae10d	9d52f708-0d32-4611-bec7-d690925b615a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 14:02:53
9314	9d52f708-02d4-49d6-a4db-9516e97ff05c	9d52f708-0d32-4611-bec7-d690925b615a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"160.56","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-24 14:02:53
9315	9d52f708-034f-48b6-bbf2-8d74fd704b29	9d52f708-0d32-4611-bec7-d690925b615a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 14:02:53
9316	9d52f708-057d-4341-924f-ee52eadc85e8	9d52f708-0d32-4611-bec7-d690925b615a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"2.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 14:02:53
9317	9d52f708-05c1-4b86-9a6f-e91e6e671e5a	9d52f708-0d32-4611-bec7-d690925b615a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 14:02:53
9318	9d52f708-0b19-4768-a1d4-5cf4debf8f00	9d52f708-0d32-4611-bec7-d690925b615a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 14:02:53
9319	9d52f708-0b8b-41c7-a072-d4c7ea901632	9d52f708-0d32-4611-bec7-d690925b615a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":419,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:02:53
10188	9d56cabf-d055-47dc-99ee-8251bc95f283	9d56cabf-d5d9-4920-9b4a-f86fb0ffb5e9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:42:23
10189	9d56cabf-d41d-4889-8dba-870c09b62ef8	9d56cabf-d5d9-4920-9b4a-f86fb0ffb5e9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 11:42:23
22199	9d67439b-63d1-444c-bff7-3bcbec56d08f	9d67439b-6c51-45d0-8379-ada090147373	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 16:13:34
22200	9d67439b-643b-439b-868d-454e37d4e051	9d67439b-6c51-45d0-8379-ada090147373	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-03 16:13:34
22201	9d67439b-6abf-43d0-8e4c-3160e20eb29c	9d67439b-6c51-45d0-8379-ada090147373	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 16:13:34
9117	9d52f42c-8d14-4000-b11d-808940559b30	9d52f42c-c748-4035-9076-3309aec1c842	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 13:54:54
9118	9d52f42c-bcb0-4678-ba0a-36fc6197bba7	9d52f42c-c748-4035-9076-3309aec1c842	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"63.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 13:54:54
9119	9d52f42c-bd4a-419f-88ae-0c5472d62c45	9d52f42c-c748-4035-9076-3309aec1c842	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 13:54:54
9120	9d52f42c-c50e-410e-aa23-05007913e669	9d52f42c-c748-4035-9076-3309aec1c842	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:54:54
9121	9d52f42c-c595-4762-9c04-96fbb6efe12b	9d52f42c-c748-4035-9076-3309aec1c842	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":596,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:54:54
10190	9d56cabf-d467-4c21-a75b-0b4aaeebf015	9d56cabf-d5d9-4920-9b4a-f86fb0ffb5e9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":368,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:42:23
9320	9d52f70a-322b-4647-b30a-c31d296873b8	9d52f70a-583d-47db-a9d6-d7b11161c99d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 14:02:55
9321	9d52f70a-51cd-4489-9101-ebcbf5622ba0	9d52f70a-583d-47db-a9d6-d7b11161c99d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"52.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 14:02:55
9322	9d52f70a-5229-4fd3-9869-4a4acc099f44	9d52f70a-583d-47db-a9d6-d7b11161c99d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 14:02:55
9323	9d52f70a-563f-4e04-982a-d091b3c923d1	9d52f70a-583d-47db-a9d6-d7b11161c99d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 14:02:55
9324	9d52f70a-56b5-4bc0-9e97-73c87dcccde7	9d52f70a-583d-47db-a9d6-d7b11161c99d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":344,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:02:55
12911	9d5cee6d-4e97-49de-9465-21e9e72f0ef4	9d5cee6d-57bf-465f-9b5c-a0415de2a451	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 28\\n                        ","time":"43.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"618a8b500e46ad393f7c65ceec660399","hostname":"EderCortes"}	2024-10-29 12:57:06
12912	9d5cee6d-5252-4c47-b3f7-2f980877bf77	9d5cee6d-57bf-465f-9b5c-a0415de2a451	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '28' order by \\"item_loans\\".\\"id\\" asc","time":"1.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 12:57:06
12913	9d5cee6d-5281-4b92-8493-c893ade2c16b	9d5cee6d-57bf-465f-9b5c-a0415de2a451	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 12:57:06
12914	9d5cee6d-56ac-482c-a688-5b89b1537d94	9d5cee6d-57bf-465f-9b5c-a0415de2a451	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:57:06
9126	9d52f441-de4a-47da-ace0-78560784104e	9d52f442-2444-4ea9-8213-8cb6b4af1be2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:55:08
12915	9d5cee6d-56f7-48a0-8e1e-6ab6f1d42ee2	9d5cee6d-57bf-465f-9b5c-a0415de2a451	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/28","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":28,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":600081,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":94,"loans_codigo":28,"itemloans_cuota":"1","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":95,"loans_codigo":28,"itemloans_cuota":"2","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":96,"loans_codigo":28,"itemloans_cuota":"3","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":97,"loans_codigo":28,"itemloans_cuota":"4","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":98,"loans_codigo":28,"itemloans_cuota":"5","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":99,"loans_codigo":28,"itemloans_cuota":"6","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null}]}},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:57:06
16342	9d64c312-3f22-42f6-816a-4c1137e97c5f	9d64c312-4bdd-46dc-9d30-4d292163560d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"59.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 10:22:30
16343	9d64c312-4446-4dfe-80f6-44cc1830d57d	9d64c312-4bdd-46dc-9d30-4d292163560d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"3.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 10:22:30
16344	9d64c312-448e-4438-b684-1a39fe8282d9	9d64c312-4bdd-46dc-9d30-4d292163560d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 10:22:30
16345	9d64c312-4a83-479d-8aff-c533f02c60fb	9d64c312-4bdd-46dc-9d30-4d292163560d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 10:22:30
16346	9d64c312-4adf-4fe5-ad41-fe53a585e164	9d64c312-4bdd-46dc-9d30-4d292163560d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:22:30
16347	9d64c313-7e15-4fdb-a8c4-6d6ee6a782df	9d64c313-aa96-407b-8292-753e102b2e14	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 10:22:31
12917	9d5cee6d-e03e-494f-b1df-42f9cf6027cb	9d5cee6e-1e7a-4963-aeb7-17521556869e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:57:07
12918	9d5cee6e-13b5-41bf-93bb-b8ca9f274921	9d5cee6e-1e7a-4963-aeb7-17521556869e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"84.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-29 12:57:07
12919	9d5cee6e-1bbb-4bef-afd1-43a848305a4a	9d5cee6e-1e7a-4963-aeb7-17521556869e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 12:57:07
9127	9d52f442-1f77-40c2-b81e-765a21309bf8	9d52f442-2444-4ea9-8213-8cb6b4af1be2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"141.01","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 13:55:08
12920	9d5cee6e-1cf7-40f4-b4c8-9472fed37da2	9d5cee6e-1e7a-4963-aeb7-17521556869e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"Call to a member function orderBy() on array","exception":"Error","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":39,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":487,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:57:07
12916	9d5cee6e-1947-4a25-9914-ee072db06899	9d5cee6e-1e7a-4963-aeb7-17521556869e	ca0a9c8dff28b69d94bcef0a9c9bc63e	f	exception	{"class":"Error","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":39,"message":"Call to a member function orderBy() on array","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"30":"                                l.loans_cuotas,","31":"                                l.loans_estado,","32":"                                l.loans_intereses,","33":"                                uco.name as cobrador,","34":"                                ure.name as recomendador","35":"                            from loans l","36":"                            join users ucl on l.user_customer = ucl.id","37":"                            join users uco on l.user_cobrador = uco.id","38":"                            left join users ure on l.user_recomendacion = ure.id","39":"                        \\")->orderBy('l.id', 'DESC');","40":"","41":"        return response()->json([","42":"            \\"data\\" => $data","43":"        ]);","44":"","45":"","46":"    }","47":"","48":"    \\/**","49":"     * Show the form for creating a new resource."},"hostname":"EderCortes","occurrences":1}	2024-10-29 12:57:07
16348	9d64c313-a1a4-4ba5-9e9a-17ec432a6cb5	9d64c313-aa96-407b-8292-753e102b2e14	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"63.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 10:22:31
16349	9d64c313-a22b-4d96-82a8-dcec92275dc0	9d64c313-aa96-407b-8292-753e102b2e14	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 10:22:31
16350	9d64c313-a8a6-474c-a4a0-85a25df716ad	9d64c313-aa96-407b-8292-753e102b2e14	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 10:22:31
16351	9d64c313-a92c-4cf4-b6e9-a6f36e35d9e2	9d64c313-aa96-407b-8292-753e102b2e14	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":406,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:22:31
16423	9d64c98f-0c39-4f89-b469-29a52dfd6562	9d64c98f-3130-4910-aea2-2c0b68b31dfd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 10:40:38
16424	9d64c98f-2f71-4f4c-9ebf-385d53ce1582	9d64c98f-3130-4910-aea2-2c0b68b31dfd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 10:40:38
9128	9d52f442-1fc5-490e-ae2b-a8c2b4e8ed62	9d52f442-2444-4ea9-8213-8cb6b4af1be2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 13:55:08
9129	9d52f442-2325-4690-8f4d-37994875806c	9d52f442-2444-4ea9-8213-8cb6b4af1be2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-24 13:55:08
16425	9d64c98f-302e-484c-a9d7-f7aadfa12ef5	9d64c98f-3130-4910-aea2-2c0b68b31dfd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":308,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:40:38
16426	9d64c98f-9228-47a8-b103-857678f15b7d	9d64c98f-b275-4bae-a815-a9c7c5bb6112	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 10:40:39
16427	9d64c98f-a991-4d92-acba-bff416c0d23d	9d64c98f-b275-4bae-a815-a9c7c5bb6112	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"46.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 10:40:39
16428	9d64c98f-acee-491d-928b-60caff66a983	9d64c98f-b275-4bae-a815-a9c7c5bb6112	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 10:40:39
16429	9d64c98f-ad2b-4e6e-9410-6944a74f545b	9d64c98f-b275-4bae-a815-a9c7c5bb6112	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 10:40:39
16430	9d64c98f-b0eb-43d2-a028-2d4c05e2327a	9d64c98f-b275-4bae-a815-a9c7c5bb6112	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 10:40:39
16431	9d64c98f-b154-486a-ac4c-ec918f4802da	9d64c98f-b275-4bae-a815-a9c7c5bb6112	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":292,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:40:39
22202	9d67439b-6b21-4db2-9359-4c1316990d77	9d67439b-6c51-45d0-8379-ada090147373	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":287,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:13:34
16432	9d64c991-c334-4b1c-9dcc-2db4fc6909ac	9d64c991-f095-4922-8f69-456a9f2db5bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 10:40:40
16433	9d64c991-e772-4546-8f8e-fe9d778dbba3	9d64c991-f095-4922-8f69-456a9f2db5bf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"60.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 10:40:40
16434	9d64c991-e808-41b0-a78a-be30ba70083f	9d64c991-f095-4922-8f69-456a9f2db5bf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 10:40:40
11212	9d5cac3c-99cb-4537-a233-6b3b70f6308e	9d5cac3c-b793-419a-8455-c564869eca71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 09:52:02
11213	9d5cac3c-b5fc-4025-b9a7-320451763fd9	9d5cac3c-b793-419a-8455-c564869eca71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 09:52:02
11214	9d5cac3c-b692-4b41-95be-ac28bf5e90f7	9d5cac3c-b793-419a-8455-c564869eca71	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:52:02
16435	9d64c991-eea3-4ca3-81b3-850faa991585	9d64c991-f095-4922-8f69-456a9f2db5bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 10:40:40
16436	9d64c991-ef24-4942-98e3-53cd5193a059	9d64c991-f095-4922-8f69-456a9f2db5bf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":464,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:40:40
22302	9d674a72-d991-4cb8-868f-57b19c47f590	9d674a73-06db-4dbf-b3fd-87dc68463501	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 16:32:42
22303	9d674a73-043d-4618-a9dd-9ee9271374c5	9d674a73-06db-4dbf-b3fd-87dc68463501	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 16:32:42
22304	9d674a73-055b-46c1-b177-5039bf188f10	9d674a73-06db-4dbf-b3fd-87dc68463501	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":488,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:32:42
11215	9d5cac3c-ff60-43e2-ae69-7b8844a7e1e5	9d5cac3d-1ef8-4e57-b0e1-cb2403b6c195	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 09:52:02
11216	9d5cac3d-1555-41d3-b057-1f6ca244ed2a	9d5cac3d-1ef8-4e57-b0e1-cb2403b6c195	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 1\\n                        ","time":"44.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"2bd5a29c69f6bbb290fc49b79286632e","hostname":"EderCortes"}	2024-10-29 09:52:02
11217	9d5cac3d-19c7-436d-956c-48cb6fbbda74	9d5cac3d-1ef8-4e57-b0e1-cb2403b6c195	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1' order by \\"item_loans\\".\\"id\\" asc","time":"2.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 09:52:02
11218	9d5cac3d-19f8-4f19-a1f8-64cc731d18e6	9d5cac3d-1ef8-4e57-b0e1-cb2403b6c195	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 09:52:02
11219	9d5cac3d-1da9-4fcb-8df1-e46ecefb6047	9d5cac3d-1ef8-4e57-b0e1-cb2403b6c195	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 09:52:02
11220	9d5cac3d-1df3-4f1c-818b-a286708fbe53	9d5cac3d-1ef8-4e57-b0e1-cb2403b6c195	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":1,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]}},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:52:02
22305	9d674a73-88d8-4d86-984f-39184ed77692	9d674a73-d6da-4eae-8ecb-3a53e670069b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 16:32:42
22306	9d674a73-ce63-494a-9a60-237e2a76599e	9d674a73-d6da-4eae-8ecb-3a53e670069b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"151.92","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 16:32:42
22307	9d674a73-ced0-4709-8861-a02f75f00053	9d674a73-d6da-4eae-8ecb-3a53e670069b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 16:32:42
22308	9d674a73-d5ad-4d6b-89e2-668a1303ac61	9d674a73-d6da-4eae-8ecb-3a53e670069b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 16:32:42
22309	9d674a73-d5fb-49f7-a7f7-b24ea0476e2d	9d674a73-d6da-4eae-8ecb-3a53e670069b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":449,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:32:42
11221	9d5cac3e-4327-4f7f-b3de-4bd336d4d99a	9d5cac3e-62ca-4551-941c-2f584556bcb9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 09:52:03
11222	9d5cac3e-5dda-4f8c-9416-910b8048d8cd	9d5cac3e-62ca-4551-941c-2f584556bcb9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 09:52:03
11223	9d5cac3e-5e35-4945-9975-7f1615014bde	9d5cac3e-62ca-4551-941c-2f584556bcb9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 09:52:03
11224	9d5cac3e-6192-44bd-99dd-a43b43c871b3	9d5cac3e-62ca-4551-941c-2f584556bcb9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-29 09:52:03
11225	9d5cac3e-61d5-46a6-8612-435bdab20cac	9d5cac3e-62ca-4551-941c-2f584556bcb9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:52:03
22310	9d674a74-2998-482f-b1ac-9761cdc44ffc	9d674a74-7886-4049-9d4e-89eeb3305748	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 16:32:43
22311	9d674a74-72c2-413f-95d5-8a027d0b997a	9d674a74-7886-4049-9d4e-89eeb3305748	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"159.93","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 16:32:43
22312	9d674a74-7314-44e2-b80d-8284eefdbfa8	9d674a74-7886-4049-9d4e-89eeb3305748	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-03 16:32:43
22313	9d674a74-76f2-442b-bbe4-f160c264fbbf	9d674a74-7886-4049-9d4e-89eeb3305748	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 16:32:43
22314	9d674a74-773e-4824-ba15-9a6ce43c8b63	9d674a74-7886-4049-9d4e-89eeb3305748	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":393,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:32:43
11226	9d5cb004-3d4a-40d0-8dad-8324be895eed	9d5cb004-5cbf-4c16-95be-32a8cff1ca85	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 10:02:36
11227	9d5cb004-5798-4e44-ba1a-bc8e836989d9	9d5cb004-5cbf-4c16-95be-32a8cff1ca85	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"42.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-29 10:02:36
11228	9d5cb004-5b2d-4653-8354-4bb0adc75ed9	9d5cb004-5cbf-4c16-95be-32a8cff1ca85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 10:02:36
11229	9d5cb004-5b9e-47ca-bb98-ec0cdfe14631	9d5cb004-5cbf-4c16-95be-32a8cff1ca85	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":257,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:02:36
11230	9d5cb009-cc32-4023-a52d-ae9ca6526455	9d5cb009-e93b-4860-9be4-f7bbc9f42f8b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 10:02:39
11231	9d5cb009-e486-43bc-9221-d4ba5df8c83b	9d5cb009-e93b-4860-9be4-f7bbc9f42f8b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 10:02:39
11232	9d5cb009-e4dd-4cd1-9ceb-c31ededcf6d7	9d5cb009-e93b-4860-9be4-f7bbc9f42f8b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 10:02:39
11233	9d5cb009-e805-4dce-9649-34cff727799b	9d5cb009-e93b-4860-9be4-f7bbc9f42f8b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 10:02:39
11234	9d5cb009-e844-4a50-b407-035ed7419d01	9d5cb009-e93b-4860-9be4-f7bbc9f42f8b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:02:39
22464	9d674f55-b22a-4de7-bfa8-8e8bad68fa4c	9d674f56-09fa-4e69-bea8-c507f8ff008e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 16:46:22
22465	9d674f56-07d6-484a-b1c5-dc32f3f885af	9d674f56-09fa-4e69-bea8-c507f8ff008e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 16:46:22
22466	9d674f56-08b9-49ba-b270-da8c00c0e4de	9d674f56-09fa-4e69-bea8-c507f8ff008e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":485,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:46:22
11235	9d5cb00a-26d7-4b58-92bc-db5ab806ecb4	9d5cb00a-4237-498c-af4e-4b73cd9a1ad5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 10:02:40
11236	9d5cb00a-3ddf-4bcb-aa52-e44489fb445f	9d5cb00a-4237-498c-af4e-4b73cd9a1ad5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 10:02:40
11237	9d5cb00a-3e25-4375-8844-4d7ba8270273	9d5cb00a-4237-498c-af4e-4b73cd9a1ad5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 10:02:40
11238	9d5cb00a-4117-4642-bb44-6806315e5076	9d5cb00a-4237-498c-af4e-4b73cd9a1ad5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 10:02:40
11239	9d5cb00a-4157-4ba6-b2ee-dea0c075e2ae	9d5cb00a-4237-498c-af4e-4b73cd9a1ad5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":208,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:02:40
22467	9d674f56-6840-4185-9b6e-db99f783ae25	9d674f56-86fc-4625-8903-7de2ca144106	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 16:46:22
22468	9d674f56-80c2-4d28-a3fe-2ddb2f9479fc	9d674f56-86fc-4625-8903-7de2ca144106	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 16:46:22
22469	9d674f56-811a-4e81-8b00-016d926bda8a	9d674f56-86fc-4625-8903-7de2ca144106	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 16:46:22
22470	9d674f56-859a-4913-b2c2-01a3905dbd73	9d674f56-86fc-4625-8903-7de2ca144106	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 16:46:22
22471	9d674f56-85f6-4535-9cd1-12b8abe5ef20	9d674f56-86fc-4625-8903-7de2ca144106	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":276,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:46:22
13018	9d5cf310-4187-465d-9617-b9417e5347ed	9d5cf310-60fd-40a8-b076-4859aa0f778f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 13:10:04
13019	9d5cf310-5f54-4acd-b721-6b114e668218	9d5cf310-60fd-40a8-b076-4859aa0f778f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 13:10:04
13020	9d5cf310-5ff8-4d89-b6f7-7bd46fcfd967	9d5cf310-60fd-40a8-b076-4859aa0f778f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":267,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:10:04
22472	9d674f56-cdad-46b9-8b52-2dd78cf8c562	9d674f56-ecf5-42da-b057-aae7c4900390	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 16:46:22
667	9d4f2dad-ecb8-4793-94d8-3dc1b7422758	9d4f2dad-effa-4853-b883-9c97f01306b4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":48}	2024-10-22 16:52:23
40907	9d6cc8a3-b99c-47f3-ada8-82d21b50fce7	9d6cc8a3-bdea-4691-adc7-bf624f75c7e0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1867}	2024-11-06 10:04:42
22473	9d674f56-e692-4110-b9e0-7cc33e849abf	9d674f56-ecf5-42da-b057-aae7c4900390	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 16:46:22
9631	9d53d1a2-7b58-4e54-ab0e-32938879afda	9d53d1a2-cd67-414a-abaf-e10dd7a3b21f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-25 00:14:09
9632	9d53d1a2-c8f1-49ce-ae6c-c7ae0a256861	9d53d1a2-cd67-414a-abaf-e10dd7a3b21f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-25 00:14:09
9633	9d53d1a2-cb3c-4032-8397-573886a74788	9d53d1a2-cd67-414a-abaf-e10dd7a3b21f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":826,"memory":22,"hostname":"EderCortes"}	2024-10-25 00:14:09
22474	9d674f56-e71a-42d8-9671-3fd806e5217a	9d674f56-ecf5-42da-b057-aae7c4900390	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-03 16:46:22
22475	9d674f56-ebc8-4810-9db5-8a95032a4a45	9d674f56-ecf5-42da-b057-aae7c4900390	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 16:46:22
22476	9d674f56-ec16-418a-a1dd-32f8827b77da	9d674f56-ecf5-42da-b057-aae7c4900390	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:46:22
9634	9d53d1a3-a14b-4de9-bd8b-c46164dc4495	9d53d1a3-d5e8-4659-a569-1ebb0ece8c9a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-25 00:14:10
9635	9d53d1a3-ca0c-498c-b9ed-bee3e52f509e	9d53d1a3-d5e8-4659-a569-1ebb0ece8c9a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"59.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-25 00:14:10
9636	9d53d1a3-ca94-4ac9-8c4f-875809798eae	9d53d1a3-d5e8-4659-a569-1ebb0ece8c9a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-25 00:14:10
9637	9d53d1a3-d3f5-420c-b1ae-953eb91ca548	9d53d1a3-d5e8-4659-a569-1ebb0ece8c9a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-25 00:14:10
9638	9d53d1a3-d474-4323-b5e6-f73e2d9d5ab6	9d53d1a3-d5e8-4659-a569-1ebb0ece8c9a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":630,"memory":22,"hostname":"EderCortes"}	2024-10-25 00:14:10
13021	9d5cf310-b27d-44b1-a192-d5819a8365d3	9d5cf310-f7d0-4131-8609-8c834d095c03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 13:10:05
13022	9d5cf310-f342-4980-94d5-5785296a7ad6	9d5cf310-f7d0-4131-8609-8c834d095c03	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"151.11","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-29 13:10:05
13023	9d5cf310-f688-4122-ae28-c3bba3b50758	9d5cf310-f7d0-4131-8609-8c834d095c03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 13:10:05
13024	9d5cf310-f6e5-4457-93bb-7530a9c1e2f2	9d5cf310-f7d0-4131-8609-8c834d095c03	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":342,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:10:05
9639	9d53d1a4-6486-449a-8961-288c0342f4b6	9d53d1a4-91e8-4514-bdef-24a3d03b61a8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-25 00:14:10
9640	9d53d1a4-88fc-40dc-ac5d-3dac909fc60e	9d53d1a4-91e8-4514-bdef-24a3d03b61a8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"53.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-25 00:14:10
9641	9d53d1a4-8975-4786-9c1f-1965792ab630	9d53d1a4-91e8-4514-bdef-24a3d03b61a8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-25 00:14:10
9642	9d53d1a4-9014-4243-a9f4-a2eed4e3d914	9d53d1a4-91e8-4514-bdef-24a3d03b61a8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-25 00:14:10
9643	9d53d1a4-908c-4a20-89fa-c09b1fc031ce	9d53d1a4-91e8-4514-bdef-24a3d03b61a8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":460,"memory":22,"hostname":"EderCortes"}	2024-10-25 00:14:10
22610	9d67f735-21f8-472b-af44-0c3cf12ce9af	9d67f739-ae34-4534-addb-d905ba7dd1bb	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 00:35:46
22611	9d67f739-5e9f-41a7-b712-440eeab14117	9d67f739-ae34-4534-addb-d905ba7dd1bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 00:35:49
22612	9d67f739-8080-4151-926a-70eb0f9e6452	9d67f739-ae34-4534-addb-d905ba7dd1bb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":17669,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:35:49
10270	9d56cc35-a040-4935-8e97-e901643ab65f	9d56cc35-bda1-4397-b16d-a5bb6b47a940	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-26 11:46:28
10271	9d56cc35-bc43-4f1e-b4f5-bde2fea1a87a	9d56cc35-bda1-4397-b16d-a5bb6b47a940	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-26 11:46:28
10272	9d56cc35-bcd8-4a2c-9f39-7d620bac5af7	9d56cc35-bda1-4397-b16d-a5bb6b47a940	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:46:28
10273	9d56cc36-0ba6-438d-b23f-62e396c67df7	9d56cc36-2533-465a-a33c-1ec963a7fd7f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-26 11:46:28
10274	9d56cc36-21a8-45fa-803b-63649a646c92	9d56cc36-2533-465a-a33c-1ec963a7fd7f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"42.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:46:28
10275	9d56cc36-2428-4806-b806-ba216ec123ce	9d56cc36-2533-465a-a33c-1ec963a7fd7f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-26 11:46:28
10276	9d56cc36-246e-44dc-b11d-18b1454a1412	9d56cc36-2533-465a-a33c-1ec963a7fd7f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:46:28
9456	9d52f803-673e-4d47-bc63-6f6d27e447bd	9d52f803-b462-49b5-8b42-9b82bc77d0b5	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 14:05:38
9457	9d52f803-af8a-4db5-8cff-816cd8e4210d	9d52f803-b462-49b5-8b42-9b82bc77d0b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 14:05:38
9458	9d52f803-b269-4b0d-baf0-3036d78749d3	9d52f803-b462-49b5-8b42-9b82bc77d0b5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":518,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:05:38
22613	9d67f73a-3d42-4e51-9b0d-397f53d1ebe9	9d67f73c-1582-4968-ba66-841b390a2d7b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 00:35:49
22614	9d67f73b-0440-4f5b-83de-646d9b4c0418	9d67f73c-1582-4968-ba66-841b390a2d7b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"156.83","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 00:35:50
22615	9d67f73b-0496-4644-a0dc-c19f29857f40	9d67f73c-1582-4968-ba66-841b390a2d7b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 00:35:50
22616	9d67f73c-144e-4769-893d-a8d2a49e07eb	9d67f73c-1582-4968-ba66-841b390a2d7b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 00:35:51
22617	9d67f73c-149d-448d-9b20-825a765f7dba	9d67f73c-1582-4968-ba66-841b390a2d7b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":1442,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:35:51
9459	9d52f804-5d53-4715-88a9-9d3d2462b8b2	9d52f804-8547-4212-ae21-8ce1cc433b32	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 14:05:39
9460	9d52f804-7d7f-4a09-8baa-db23b7a87e3b	9d52f804-8547-4212-ae21-8ce1cc433b32	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"50.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 14:05:39
9461	9d52f804-7e05-4755-9048-342dc741c92c	9d52f804-8547-4212-ae21-8ce1cc433b32	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-24 14:05:39
9462	9d52f804-8417-4a6c-845c-acf8a3f0726b	9d52f804-8547-4212-ae21-8ce1cc433b32	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 14:05:39
9463	9d52f804-8460-4210-ab28-d230b2d45792	9d52f804-8547-4212-ae21-8ce1cc433b32	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":482,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:05:39
10277	9d56cc37-5003-459c-a2f3-6a72ead5ac92	9d56cc37-7121-4b5f-8346-14b46a15460a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-26 11:46:29
10278	9d56cc37-6b2b-4427-8d1f-d2875950e409	9d56cc37-7121-4b5f-8346-14b46a15460a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:46:29
10279	9d56cc37-6b94-42ec-be7e-c9f9447c36dd	9d56cc37-7121-4b5f-8346-14b46a15460a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:46:29
10280	9d56cc37-6fd2-4825-bb28-6f2a56192ef1	9d56cc37-7121-4b5f-8346-14b46a15460a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-26 11:46:29
10281	9d56cc37-701a-4ecf-8100-bcb0c6229ba0	9d56cc37-7121-4b5f-8346-14b46a15460a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":415,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:46:29
22618	9d67f73c-5a16-4fd0-8a7a-8179228f19a9	9d67f73c-a1b0-4448-a48f-e47209bb5d1a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 00:35:51
22619	9d67f73c-9ca8-4fa6-939a-c1005b9316b2	9d67f73c-a1b0-4448-a48f-e47209bb5d1a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"147.45","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 00:35:51
22620	9d67f73c-9d16-4e74-b61d-9f62b717ee7e	9d67f73c-a1b0-4448-a48f-e47209bb5d1a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 00:35:51
22621	9d67f73c-a08b-4f53-b73f-6a82f2a3188e	9d67f73c-a1b0-4448-a48f-e47209bb5d1a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 00:35:51
22622	9d67f73c-a0cf-4f2f-8f8f-b9520eb65a29	9d67f73c-a1b0-4448-a48f-e47209bb5d1a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":339,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:35:51
9464	9d52f804-f7a8-408f-a636-d9fcd7c9ab67	9d52f805-1fc7-4b82-87d2-e33a53bbacd7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-24 14:05:39
9465	9d52f805-18dd-4676-a216-10930dcacd0a	9d52f805-1fc7-4b82-87d2-e33a53bbacd7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"56.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-24 14:05:39
9466	9d52f805-193f-422c-9e04-b75f3bb6f763	9d52f805-1fc7-4b82-87d2-e33a53bbacd7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-24 14:05:39
9467	9d52f805-1e22-4dd9-8b99-6db7d2ec1c27	9d52f805-1fc7-4b82-87d2-e33a53bbacd7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 14:05:39
9468	9d52f805-1e98-4759-bfa7-fec08ea3e78c	9d52f805-1fc7-4b82-87d2-e33a53bbacd7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":380,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:05:39
13882	9d5d13d3-0e26-4cfb-b661-651f6b9890ce	9d5d13d3-35e1-4b48-b45a-e25bd00ed9cc	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 14:41:41
13883	9d5d13d3-3373-4fc7-a607-9ba361e95a13	9d5d13d3-35e1-4b48-b45a-e25bd00ed9cc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 14:41:41
13884	9d5d13d3-3476-48fe-81b1-e822917f762a	9d5d13d3-35e1-4b48-b45a-e25bd00ed9cc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":381,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:41:41
9469	9d52f805-71b7-4633-b8e5-3b019003e46b	9d52f805-95d6-49f0-867e-1c5e4813c720	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-24 14:05:39
9470	9d52f805-8c80-4089-ab5c-29e6f4604ca3	9d52f805-95d6-49f0-867e-1c5e4813c720	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '6' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"46.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":166,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-10-24 14:05:39
9471	9d52f805-8ce9-4343-85fa-8ec4b591684d	9d52f805-95d6-49f0-867e-1c5e4813c720	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-10-24 14:05:39
9472	9d52f805-8f00-4130-ad51-d00b7a3fc34a	9d52f805-95d6-49f0-867e-1c5e4813c720	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '6' order by \\"item_loans\\".\\"id\\" asc","time":"2.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":167,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-24 14:05:39
9473	9d52f805-8f40-4ddd-a5f5-6b1111aeecb5	9d52f805-95d6-49f0-867e-1c5e4813c720	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-24 14:05:39
9474	9d52f805-9419-4132-9eb0-1aebb2bd3fb1	9d52f805-95d6-49f0-867e-1c5e4813c720	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 14:05:39
9475	9d52f805-94cd-4c59-94d7-a9d7a6a39741	9d52f805-95d6-49f0-867e-1c5e4813c720	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/6","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":6,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":null,"loans_valor_prestado":500000,"user_customer":14,"user_cobrador":14,"created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null,"loans_celular":655465456},"items":[{"id":31,"loans_codigo":6,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":32,"loans_codigo":6,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":33,"loans_codigo":6,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":34,"loans_codigo":6,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":35,"loans_codigo":6,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null},{"id":36,"loans_codigo":6,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:47.000000Z","updated_at":"2024-10-24T11:38:47.000000Z","deleted_at":null}]}},"duration":281,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:05:39
13885	9d5d13d3-a3e3-4873-8c4d-65d22b8cea46	9d5d13d3-c43d-487e-bc25-ec8db4d73606	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 14:41:41
13886	9d5d13d3-ba8a-4938-b44f-68fac47b89bc	9d5d13d3-c43d-487e-bc25-ec8db4d73606	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 52\\n                        ","time":"43.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"b818d1825eff359c94d73944c3be2955","hostname":"EderCortes"}	2024-10-29 14:41:41
13887	9d5d13d3-be9d-4f63-acd2-8b6c46cb26f7	9d5d13d3-c43d-487e-bc25-ec8db4d73606	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '52' order by \\"item_loans\\".\\"id\\" asc","time":"2.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 14:41:41
13888	9d5d13d3-bed6-4783-bc6f-c41b4cd339f6	9d5d13d3-c43d-487e-bc25-ec8db4d73606	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":7,"hostname":"EderCortes"}	2024-10-29 14:41:41
13889	9d5d13d3-c303-42b2-a86b-d57cf5593de3	9d5d13d3-c43d-487e-bc25-ec8db4d73606	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 14:41:41
13890	9d5d13d3-c34a-4726-a29d-7b30b8f647e2	9d5d13d3-c43d-487e-bc25-ec8db4d73606	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/52","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":52,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":7,"loans_valor_prestado":500000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"12-11-24","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":136,"loans_codigo":52,"itemloans_cuota":"1","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":137,"loans_codigo":52,"itemloans_cuota":"2","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0024-12-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":138,"loans_codigo":52,"itemloans_cuota":"3","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0024-12-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":139,"loans_codigo":52,"itemloans_cuota":"4","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0025-01-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":140,"loans_codigo":52,"itemloans_cuota":"5","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0025-01-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":141,"loans_codigo":52,"itemloans_cuota":"6","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0025-02-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":142,"loans_codigo":52,"itemloans_cuota":"7","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0025-02-25 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":319,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:41:41
9476	9d52f807-b567-41ad-8fa5-8a6c034fc481	9d52f807-dd06-4f7a-8c8b-aa1914e89eb0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-24 14:05:41
9477	9d52f807-d716-4840-bb5e-cace0a2f448d	9d52f807-dd06-4f7a-8c8b-aa1914e89eb0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"53.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-24 14:05:41
9478	9d52f807-d77c-4289-9989-2f255229c760	9d52f807-dd06-4f7a-8c8b-aa1914e89eb0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-24 14:05:41
9479	9d52f807-db6f-4ac9-b9c6-2c327033efae	9d52f807-dd06-4f7a-8c8b-aa1914e89eb0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 14:05:41
9480	9d52f807-dbd5-4124-a1e0-9fdece8645bb	9d52f807-dd06-4f7a-8c8b-aa1914e89eb0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/129.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Google Chrome\\";v=\\"129\\", \\"Not=A?Brand\\";v=\\"8\\", \\"Chromium\\";v=\\"129\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":385,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:05:41
13179	9d5cfa0b-9535-4b5a-a00a-a73f89178b4c	9d5cfa0b-b980-4a6c-b595-cc211bbf2151	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 13:29:36
13180	9d5cfa0b-b781-496f-9204-30246ef7dd21	9d5cfa0b-b980-4a6c-b595-cc211bbf2151	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 13:29:36
13181	9d5cfa0b-b84c-4e12-bc1d-d2f53f929260	9d5cfa0b-b980-4a6c-b595-cc211bbf2151	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:29:36
16661	9d64d53a-9670-407b-83a5-bb0fdbb3a1a8	9d64d53a-d812-4293-837b-e07ab723e433	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 11:13:16
16547	9d64d2ca-81f2-475f-84d9-48f71b2deb93	9d64d2ca-a8ab-4d58-a793-c3f98c1b4eef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 11:06:27
16548	9d64d2ca-a6c0-4ce4-9856-95cdcce83da3	9d64d2ca-a8ab-4d58-a793-c3f98c1b4eef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 11:06:27
16549	9d64d2ca-a78a-430b-b344-a3cacc62234e	9d64d2ca-a8ab-4d58-a793-c3f98c1b4eef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":328,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:06:27
16662	9d64d53a-d54e-45b2-b930-2703139dbf1a	9d64d53a-d812-4293-837b-e07ab723e433	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 11:13:16
16663	9d64d53a-d68e-4204-b1a9-c851fd7e81d0	9d64d53a-d812-4293-837b-e07ab723e433	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":495,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:13:16
13182	9d5cfa0c-0eaa-4387-a6d5-b68dc3f36714	9d5cfa0c-57bb-435c-8653-d35d168ea491	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 13:29:36
10361	9d56cee8-bd9e-4cac-ac26-da603d51e112	9d56cee9-196e-4fed-a290-c93210cad83d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 11:54:01
10362	9d56cee9-16f6-4393-b754-017ae9d57677	9d56cee9-196e-4fed-a290-c93210cad83d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:54:01
10363	9d56cee9-1818-4723-abd2-2c40077cbc3f	9d56cee9-196e-4fed-a290-c93210cad83d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":540,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:54:01
7128	9d52dad2-4646-43e0-93d3-55a1300f89ca	9d52dad2-6abe-42e0-9882-a69f8e158a8c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-24 12:44:00
7129	9d52dad2-68c8-4457-9193-5f8efcb4ffbe	9d52dad2-6abe-42e0-9882-a69f8e158a8c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-24 12:44:01
7130	9d52dad2-6996-4bf9-b4b6-3edb34b8596e	9d52dad2-6abe-42e0-9882-a69f8e158a8c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-10-24 12:44:01
13183	9d5cfa0c-4e7d-4f10-9cd6-d7b80c18ac7d	9d5cfa0c-57bb-435c-8653-d35d168ea491	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 30\\n                        ","time":"149.68","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"b9ae622c33dd7e7f0bc512338acf8ed0","hostname":"EderCortes"}	2024-10-29 13:29:36
13184	9d5cfa0c-5202-41c4-9ac9-0ac34d432cbd	9d5cfa0c-57bb-435c-8653-d35d168ea491	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '30' order by \\"item_loans\\".\\"id\\" asc","time":"2.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 13:29:36
13185	9d5cfa0c-5241-4cfd-ad22-aad173e83ead	9d5cfa0c-57bb-435c-8653-d35d168ea491	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-10-29 13:29:36
13186	9d5cfa0c-568f-4459-a2a1-071ba27d48df	9d5cfa0c-57bb-435c-8653-d35d168ea491	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 13:29:36
13187	9d5cfa0c-56db-4760-9513-e9fa28c76c0a	9d5cfa0c-57bb-435c-8653-d35d168ea491	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/30","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":30,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":1000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":106,"loans_codigo":30,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":107,"loans_codigo":30,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":108,"loans_codigo":30,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":109,"loans_codigo":30,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":110,"loans_codigo":30,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":111,"loans_codigo":30,"itemloans_cuota":"6","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":112,"loans_codigo":30,"itemloans_cuota":"7","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":113,"loans_codigo":30,"itemloans_cuota":"8","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":114,"loans_codigo":30,"itemloans_cuota":"9","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":115,"loans_codigo":30,"itemloans_cuota":"10","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":371,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:29:36
16550	9d64d2cb-04d2-4e14-bf5f-1d21e7811059	9d64d2cb-2cd0-432c-a407-c287c1b639a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 11:06:28
16551	9d64d2cb-20d3-490f-8d3e-a998bbc68c8d	9d64d2cb-2cd0-432c-a407-c287c1b639a2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"58.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 11:06:28
16552	9d64d2cb-25df-47d6-926a-0c186a58243f	9d64d2cb-2cd0-432c-a407-c287c1b639a2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 11:06:28
16553	9d64d2cb-2627-47b1-bbda-7d1b50f5d87c	9d64d2cb-2cd0-432c-a407-c287c1b639a2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 11:06:28
16554	9d64d2cb-2b3f-41b9-9b04-6bf9e45468ab	9d64d2cb-2cd0-432c-a407-c287c1b639a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 11:06:28
16664	9d64d53b-677a-4e75-aea0-e284b0823cfa	9d64d53b-8bf4-4499-8bab-a6c202a581e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 11:13:17
10364	9d56cee9-82af-4c14-8711-9cc4dcb9337b	9d56cee9-9d3e-4d90-a009-c8a777dd4613	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:54:01
10365	9d56cee9-988a-43a9-9901-2035c46bb59d	9d56cee9-9d3e-4d90-a009-c8a777dd4613	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"43.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:54:01
10366	9d56cee9-9bfe-4eac-b57d-9fc751c0f29e	9d56cee9-9d3e-4d90-a009-c8a777dd4613	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:54:01
10367	9d56cee9-9c43-47e6-af30-045d8af3e0d5	9d56cee9-9d3e-4d90-a009-c8a777dd4613	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":297,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:54:01
16555	9d64d2cb-2ba8-4109-98e1-d0bf68423b6f	9d64d2cb-2cd0-432c-a407-c287c1b639a2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:06:28
16665	9d64d53b-8056-4e67-b4d1-791469cadc19	9d64d53b-8bf4-4499-8bab-a6c202a581e3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"49.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 11:13:17
16666	9d64d53b-84ed-4ddc-87ee-698b4f3d81f9	9d64d53b-8bf4-4499-8bab-a6c202a581e3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 11:13:17
16667	9d64d53b-8529-446b-812f-98fdf6b343d1	9d64d53b-8bf4-4499-8bab-a6c202a581e3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 11:13:17
16668	9d64d53b-8a69-4e90-949d-bd06f761c239	9d64d53b-8bf4-4499-8bab-a6c202a581e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 11:13:17
10368	9d56ceeb-2ef8-4e98-a7d2-7b75fab7f85b	9d56ceeb-78de-4cf6-a3c7-65a6c4b5b1dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:54:02
10369	9d56ceeb-7386-4592-828a-3b23d454ac70	9d56ceeb-78de-4cf6-a3c7-65a6c4b5b1dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"155.90","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:54:02
10370	9d56ceeb-73cf-4ea5-ae07-a2171f90887c	9d56ceeb-78de-4cf6-a3c7-65a6c4b5b1dd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:54:02
10371	9d56ceeb-775a-49b0-9895-5fdc00cf3c57	9d56ceeb-78de-4cf6-a3c7-65a6c4b5b1dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 11:54:02
10372	9d56ceeb-77a1-4997-877d-f371d33b609b	9d56ceeb-78de-4cf6-a3c7-65a6c4b5b1dd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":342,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:54:02
16556	9d64d2cd-3a3c-4e87-9f06-a8446ef8537a	9d64d2cd-57f3-48e3-a74a-a1354657ed83	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 11:06:29
16557	9d64d2cd-529b-470e-9bd6-24d19289b0e0	9d64d2cd-57f3-48e3-a74a-a1354657ed83	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"39.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 11:06:29
16558	9d64d2cd-52ef-42b2-8303-e35d9ae6be49	9d64d2cd-57f3-48e3-a74a-a1354657ed83	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 11:06:29
16559	9d64d2cd-5662-4993-ac05-8a504236845c	9d64d2cd-57f3-48e3-a74a-a1354657ed83	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 11:06:29
16560	9d64d2cd-56b0-4b66-9683-23e68acd83ee	9d64d2cd-57f3-48e3-a74a-a1354657ed83	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":409,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:06:29
16669	9d64d53b-8ad9-4968-9e07-ee7e8362a3c4	9d64d53b-8bf4-4499-8bab-a6c202a581e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":411,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:13:17
16670	9d64d53d-85bf-4320-8e6a-5fd9b12c544b	9d64d53d-d7cc-43be-93f2-f5547ebe4343	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 11:13:18
16671	9d64d53d-cf55-4a91-822e-3ffab7f61253	9d64d53d-d7cc-43be-93f2-f5547ebe4343	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"165.68","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 11:13:18
16672	9d64d53d-cfcd-4d1b-a90c-84ad994b9cfb	9d64d53d-d7cc-43be-93f2-f5547ebe4343	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 11:13:18
16673	9d64d53d-d628-4b11-928a-dcf649ffcf5d	9d64d53d-d7cc-43be-93f2-f5547ebe4343	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 11:13:18
16674	9d64d53d-d68e-43e2-a062-2fceee43847d	9d64d53d-d7cc-43be-93f2-f5547ebe4343	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":405,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:13:18
22791	9d67fbb5-5903-464d-bad0-813f533464b2	9d67fbb5-a4a9-4f82-a237-820be3d1f0e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 00:48:21
22792	9d67fbb5-a2e0-452a-8eea-e80270e6352a	9d67fbb5-a4a9-4f82-a237-820be3d1f0e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 00:48:21
14121	9d5d163f-1d64-445f-8619-9f550acab78e	9d5d163f-62ea-4f1c-9d73-1ddaf246c40c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 14:48:27
14122	9d5d163f-6161-4c4d-9be2-703f8c03645a	9d5d163f-62ea-4f1c-9d73-1ddaf246c40c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 14:48:27
14123	9d5d163f-61f4-425f-8118-733e3c15fdba	9d5d163f-62ea-4f1c-9d73-1ddaf246c40c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":406,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:48:27
16675	9d64d563-6c46-40e9-8fd2-50f775acc58e	9d64d563-6fcf-402e-ab72-348b927db569	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":210,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:13:43
22793	9d67fbb5-a38a-4545-b1ea-712364abe577	9d67fbb5-a4a9-4f82-a237-820be3d1f0e8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":416,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:48:21
9630	9d53d1a2-c4de-4256-b245-6067f6cd6cfc	9d53d1a2-cd67-414a-abaf-e10dd7a3b21f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":457}	2024-10-25 00:14:09
14124	9d5d163f-aa96-4b65-93ed-e87dfb965fab	9d5d163f-c3dd-45aa-b52b-ebd024889792	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 14:48:27
14125	9d5d163f-bf2e-4bdf-a04e-5b1d1762bfe9	9d5d163f-c3dd-45aa-b52b-ebd024889792	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"39.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-29 14:48:27
14126	9d5d163f-c2a3-46f0-be78-96173b6bf3a0	9d5d163f-c3dd-45aa-b52b-ebd024889792	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 14:48:27
14127	9d5d163f-c2f2-4894-bc72-b54f80681804	9d5d163f-c3dd-45aa-b52b-ebd024889792	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":215,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:48:27
22794	9d67fbb6-03ab-4d80-9c43-bbd9cb3814e3	9d67fbb6-4be2-4b34-bace-a0799562d694	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 00:48:22
22795	9d67fbb6-4271-4172-8925-a744780333ab	9d67fbb6-4be2-4b34-bace-a0799562d694	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 65\\n                        ","time":"146.80","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6768d7067397538897aacf4d73c43049","hostname":"EderCortes"}	2024-11-04 00:48:22
22796	9d67fbb6-4661-49ea-a0bb-e46033bdfb96	9d67fbb6-4be2-4b34-bace-a0799562d694	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '65' order by \\"item_loans\\".\\"id\\" asc","time":"2.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 00:48:22
22797	9d67fbb6-4696-402b-b964-8b956a3a139e	9d67fbb6-4be2-4b34-bace-a0799562d694	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 00:48:22
22798	9d67fbb6-4aad-4fa5-b5ce-633efff4019d	9d67fbb6-4be2-4b34-bace-a0799562d694	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 00:48:22
22799	9d67fbb6-4afc-46c4-b64a-e06cc00d8fa2	9d67fbb6-4be2-4b34-bace-a0799562d694	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/65","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":65,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":3000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-10 00:00:00","loans_pago_prestado":"1669230.7692308","loans_pago_interes":"500769.23076923"},"items":[{"id":207,"loans_codigo":65,"itemloans_cuota":"1","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:46:55.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"90000","itemloans_cuota_cancelada":"300000"},{"id":208,"loans_codigo":65,"itemloans_cuota":"2","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-04T05:39:56.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"90000","itemloans_cuota_cancelada":"300000"},{"id":209,"loans_codigo":65,"itemloans_cuota":"3","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-04T05:40:07.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"90000","itemloans_cuota_cancelada":"300000"},{"id":210,"loans_codigo":65,"itemloans_cuota":"4","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-04T05:43:06.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"230769.23076923","itemloans_cuota_cancelada":"769230.76923077"},{"id":237,"loans_codigo":65,"itemloans_cuota":"5","itemloans_valor_cuota":"221794.87179487","itemloans_iteres":"-83461.538461538","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:43:06.000000Z","updated_at":"2024-11-04T05:43:06.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"230769.23076923","itemloans_cuota_cancelada":"769230.76923077"},{"id":238,"loans_codigo":65,"itemloans_cuota":"6","itemloans_valor_cuota":"221794.87179487","itemloans_iteres":"-83461.538461538","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:43:06.000000Z","updated_at":"2024-11-04T05:43:06.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"230769.23076923","itemloans_cuota_cancelada":"769230.76923077"},{"id":239,"loans_codigo":65,"itemloans_cuota":"7","itemloans_valor_cuota":"221794.87179487","itemloans_iteres":"-83461.538461538","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:43:06.000000Z","updated_at":"2024-11-04T05:43:06.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"230769.23076923","itemloans_cuota_cancelada":"769230.76923077"},{"id":240,"loans_codigo":65,"itemloans_cuota":"8","itemloans_valor_cuota":"221794.87179487","itemloans_iteres":"-83461.538461538","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:43:06.000000Z","updated_at":"2024-11-04T05:43:06.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"230769.23076923","itemloans_cuota_cancelada":"769230.76923077"},{"id":241,"loans_codigo":65,"itemloans_cuota":"9","itemloans_valor_cuota":"221794.87179487","itemloans_iteres":"-83461.538461538","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-04-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:43:06.000000Z","updated_at":"2024-11-04T05:43:06.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"230769.23076923","itemloans_cuota_cancelada":"769230.76923077"},{"id":242,"loans_codigo":65,"itemloans_cuota":"10","itemloans_valor_cuota":"221794.87179487","itemloans_iteres":"-83461.538461538","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-05-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:43:06.000000Z","updated_at":"2024-11-04T05:43:06.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"230769.23076923","itemloans_cuota_cancelada":"769230.76923077"}]}},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:48:22
16681	9d64d578-82a3-45ee-8304-ddcae20633d3	9d64d578-890d-40c0-950c-2cb6b310a991	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":304,"memory":20,"hostname":"EderCortes"}	2024-11-02 11:13:57
22800	9d67fbb8-1a32-40d3-a833-b06bc3873010	9d67fbb8-6118-408d-a7f4-775263c6f316	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 00:48:23
22801	9d67fbb8-5b72-497f-a74e-1255d6514dbd	9d67fbb8-6118-408d-a7f4-775263c6f316	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"144.90","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 00:48:23
22802	9d67fbb8-5bca-4b7c-afb0-47e5e32d7aff	9d67fbb8-6118-408d-a7f4-775263c6f316	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 00:48:23
22803	9d67fbb8-5fa8-4d10-922c-d54b44e2d706	9d67fbb8-6118-408d-a7f4-775263c6f316	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 00:48:23
22804	9d67fbb8-5ffa-4b93-b9e3-0eb56968e5a3	9d67fbb8-6118-408d-a7f4-775263c6f316	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":568,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:48:23
16682	9d64d579-42ab-4f20-93a3-60c52e4aeb08	9d64d579-6948-4517-8f06-d8b5db4ea50c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 11:13:57
16683	9d64d579-5f1c-4753-adbf-d78837cafd1b	9d64d579-6948-4517-8f06-d8b5db4ea50c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 189 limit 1","time":"3.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":326,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-02 11:13:57
16684	9d64d579-5f85-4523-9786-5346e4e9b73c	9d64d579-6948-4517-8f06-d8b5db4ea50c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-02 11:13:57
16685	9d64d579-6223-4d85-aa83-85556ecad2ea	9d64d579-6948-4517-8f06-d8b5db4ea50c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '02-11-2024', \\"itemloans_interes_canelado\\" = '50000', \\"itemloans_cuota_cancelada\\" = '100000', \\"updated_at\\" = '2024-11-02 11:13:57' where \\"id\\" = 189","time":"3.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":345,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-02 11:13:57
16686	9d64d579-62d0-4e0d-9eb8-ad081b22b4b9	9d64d579-6948-4517-8f06-d8b5db4ea50c	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:189","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-02 11:13:57","item_loans_cuando_pago":"02-11-2024","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},"hostname":"EderCortes"}	2024-11-02 11:13:57
16687	9d64d579-671e-41b7-8acc-04c1812cbc91	9d64d579-6948-4517-8f06-d8b5db4ea50c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 11:13:57
16688	9d64d579-67aa-472a-a6c7-f3d63a6868e6	9d64d579-6948-4517-8f06-d8b5db4ea50c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"157","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000","id":189,"loans_codigo":62,"item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":269,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:13:57
22805	9d67fbcf-c954-4880-897e-61557af8530f	9d67fbcf-cc36-4e24-ac4e-f5293fc44543	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":153,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:48:38
23070	9d6886b8-6f84-4d94-ab9f-e3be069a2ad4	9d6886b9-ce24-40b8-99b8-7d993fdf8a1d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 07:17:03
23071	9d6886b9-b0fd-4fd2-8ced-b50ab2d0676b	9d6886b9-ce24-40b8-99b8-7d993fdf8a1d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 07:17:04
23072	9d6886b9-c721-456b-9bdf-fb9f7c4d0060	9d6886b9-ce24-40b8-99b8-7d993fdf8a1d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":2349,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:17:04
22806	9d67fbd0-166e-4278-8dfc-3b9971eabb8d	9d67fbd0-1973-47cf-a536-5fd871be95fd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":133,"memory":20,"hostname":"EderCortes"}	2024-11-04 00:48:39
23073	9d6886bb-1479-4944-be34-b8f6b7638b5b	9d6886bb-5db8-4b3d-b6ea-722139ddb430	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 07:17:05
23074	9d6886bb-3917-4947-8489-08a5aec5c0c8	9d6886bb-5db8-4b3d-b6ea-722139ddb430	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 70\\n                        ","time":"69.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"40345ecc36d5b014fbb2cca663c7c347","hostname":"EderCortes"}	2024-11-04 07:17:05
23075	9d6886bb-4215-4eb9-923a-05f77aa75db2	9d6886bb-5db8-4b3d-b6ea-722139ddb430	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '70' order by \\"item_loans\\".\\"id\\" asc","time":"3.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 07:17:05
14341	9d5d1e07-a085-4797-b35a-01839b2be955	9d5d1e07-f192-4f86-a27a-0107210da488	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 15:10:13
14342	9d5d1e07-edce-45af-8c27-1ef7b9ed86bd	9d5d1e07-f192-4f86-a27a-0107210da488	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 15:10:13
14343	9d5d1e07-ef82-4932-9660-0f631b3c5db6	9d5d1e07-f192-4f86-a27a-0107210da488	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":541,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:10:13
23076	9d6886bb-426e-41d0-8c2e-804e58fc49b3	9d6886bb-5db8-4b3d-b6ea-722139ddb430	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 07:17:05
23077	9d6886bb-5b66-4d28-87f2-1c6503f3fce1	9d6886bb-5db8-4b3d-b6ea-722139ddb430	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 07:17:05
23078	9d6886bb-5c3e-48b5-a99f-709a3fd6289a	9d6886bb-5db8-4b3d-b6ea-722139ddb430	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/70","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":70,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":2150000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"430000","loans_pago_interes":"107500"},"items":[{"id":248,"loans_codigo":70,"itemloans_cuota":"1","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:52:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"107500","itemloans_cuota_cancelada":"430000"},{"id":249,"loans_codigo":70,"itemloans_cuota":"2","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":250,"loans_codigo":70,"itemloans_cuota":"3","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":251,"loans_codigo":70,"itemloans_cuota":"4","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":252,"loans_codigo":70,"itemloans_cuota":"5","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":880,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:17:05
14344	9d5d1e08-8fe2-48f8-93d7-b514384e06cc	9d5d1e08-cadd-4628-8696-455d9e55fd69	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 15:10:13
14345	9d5d1e08-b235-4ca9-8269-7db165e7c4e1	9d5d1e08-cadd-4628-8696-455d9e55fd69	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 55\\n                        ","time":"65.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"ff7240abed4441475e0acd0c74a5f6aa","hostname":"EderCortes"}	2024-10-29 15:10:14
14346	9d5d1e08-bf7e-4ce7-8b06-9e63bc718eb2	9d5d1e08-cadd-4628-8696-455d9e55fd69	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '55' order by \\"item_loans\\".\\"id\\" asc","time":"3.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 15:10:14
14347	9d5d1e08-bfdf-45bd-85b1-eb283024d0e5	9d5d1e08-cadd-4628-8696-455d9e55fd69	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":7,"hostname":"EderCortes"}	2024-10-29 15:10:14
14348	9d5d1e08-c8a7-4d1d-aca2-28ff4b09c6be	9d5d1e08-cadd-4628-8696-455d9e55fd69	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 15:10:14
14349	9d5d1e08-c93d-4fd7-8334-b5ba1e313542	9d5d1e08-cadd-4628-8696-455d9e55fd69	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/55","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":55,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":7,"loans_valor_prestado":50000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"15-11-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":150,"loans_codigo":55,"itemloans_cuota":"1","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":151,"loans_codigo":55,"itemloans_cuota":"2","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":152,"loans_codigo":55,"itemloans_cuota":"3","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":153,"loans_codigo":55,"itemloans_cuota":"4","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":154,"loans_codigo":55,"itemloans_cuota":"5","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":155,"loans_codigo":55,"itemloans_cuota":"6","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":156,"loans_codigo":55,"itemloans_cuota":"7","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":485,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:10:14
22807	9d67fbd0-64ac-41ae-ab70-fe6fde8e80d1	9d67fbd0-68a6-416c-afcd-980b8524a1de	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":132,"memory":20,"hostname":"EderCortes"}	2024-11-04 00:48:39
23079	9d6886c0-97a5-4e26-9f47-16ff3539917b	9d6886c0-cba6-4bb4-8cde-0ed777b56ffc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 07:17:09
23080	9d6886c0-bff1-4117-baaa-06eebc854acf	9d6886c0-cba6-4bb4-8cde-0ed777b56ffc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"62.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 07:17:09
23081	9d6886c0-c0b6-454e-b369-dda663323cfa	9d6886c0-cba6-4bb4-8cde-0ed777b56ffc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 07:17:09
23082	9d6886c0-c98e-4445-8d16-f948133e21fa	9d6886c0-cba6-4bb4-8cde-0ed777b56ffc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 07:17:09
23083	9d6886c0-c9f8-4641-ba42-e90e720fccb7	9d6886c0-cba6-4bb4-8cde-0ed777b56ffc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":457,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:17:09
22808	9d67fbd0-b7dc-4926-81bd-c8e5ecb396cc	9d67fbd0-df27-477f-a666-935ff9d898b8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 00:48:39
22809	9d67fbd0-dae4-41b6-b2bd-57c3e3c782d1	9d67fbd0-df27-477f-a666-935ff9d898b8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"40.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 00:48:39
22810	9d67fbd0-dde5-40a2-b167-2f38b01e12d5	9d67fbd0-df27-477f-a666-935ff9d898b8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 00:48:39
22811	9d67fbd0-de2b-4965-8095-34ebddfb5b32	9d67fbd0-df27-477f-a666-935ff9d898b8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:48:39
10452	9d56cfc4-c88e-4b92-a4ad-8298ebef5030	9d56cfc5-1844-46a2-a09f-22e49af32c6e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 11:56:25
10453	9d56cfc5-1662-4fd9-a139-22019d15056a	9d56cfc5-1844-46a2-a09f-22e49af32c6e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:56:25
10454	9d56cfc5-171a-48de-ba52-53fb63a58c6b	9d56cfc5-1844-46a2-a09f-22e49af32c6e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":370,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:56:25
10530	9d570f41-1287-455e-9aad-99e6ec3d94c0	9d570f41-380d-4a6c-bd1e-41ff1acf1903	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 14:53:56
23084	9d688799-4eee-4208-b17d-436c065faac0	9d688799-5728-4273-895b-6ebc550fb50b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":225,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:19:31
10455	9d56cfc5-6e3f-4d61-9863-5a9c474a0809	9d56cfc5-87cc-4da9-a94e-7fbaceda44b7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:56:25
10456	9d56cfc5-82f9-4135-94c5-1fc747a56e0f	9d56cfc5-87cc-4da9-a94e-7fbaceda44b7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"40.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:56:25
10457	9d56cfc5-86d1-4da9-a813-8c8b64cb8a07	9d56cfc5-87cc-4da9-a94e-7fbaceda44b7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:56:25
10458	9d56cfc5-8712-4fcb-b63e-622c2080aa7b	9d56cfc5-87cc-4da9-a94e-7fbaceda44b7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:56:25
10531	9d570f41-360b-4a94-80ba-3f7e6a109e52	9d570f41-380d-4a6c-bd1e-41ff1acf1903	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 14:53:56
10532	9d570f41-36df-4318-943e-1ca271030d43	9d570f41-380d-4a6c-bd1e-41ff1acf1903	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-10-26 14:53:56
22812	9d67fbd1-1cb0-4a51-b242-78b8643ff882	9d67fbd1-606c-49b7-910e-37c4516e34e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 00:48:39
22813	9d67fbd1-5bfc-407e-88a0-e397726f1aeb	9d67fbd1-606c-49b7-910e-37c4516e34e0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"146.74","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 00:48:39
22814	9d67fbd1-5f41-4c40-ade8-2cd95ed8e4d5	9d67fbd1-606c-49b7-910e-37c4516e34e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 00:48:39
22815	9d67fbd1-5f84-4c52-a0ac-d227b8983669	9d67fbd1-606c-49b7-910e-37c4516e34e0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":322,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:48:39
10459	9d56cfc6-f34c-4554-9baa-5d7b45d1ec3a	9d56cfc7-10c4-443b-8b8c-e43be75261a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:56:26
10460	9d56cfc7-0b9c-4349-bd1a-9cfed3591e4a	9d56cfc7-10c4-443b-8b8c-e43be75261a6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:56:26
10461	9d56cfc7-0bf3-4b9f-ad48-69bd29d5ffa2	9d56cfc7-10c4-443b-8b8c-e43be75261a6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:56:26
10462	9d56cfc7-0f7d-4ee9-bd75-15b4a77c4a64	9d56cfc7-10c4-443b-8b8c-e43be75261a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 11:56:26
10463	9d56cfc7-0fc3-4c5b-8f11-0a45ff49e3af	9d56cfc7-10c4-443b-8b8c-e43be75261a6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:56:26
10533	9d570f41-9297-4880-be92-2c55484f56e4	9d570f41-d6a1-4a63-8f3b-af802d2826d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 14:53:56
10534	9d570f41-d1fd-4735-b7fc-5485ff54c8ab	9d570f41-d6a1-4a63-8f3b-af802d2826d3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"149.56","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 14:53:56
10535	9d570f41-d587-4ae8-819d-9a97c2ba6a00	9d570f41-d6a1-4a63-8f3b-af802d2826d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 14:53:56
10536	9d570f41-d5ce-454f-928f-fce71954f40d	9d570f41-d6a1-4a63-8f3b-af802d2826d3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-10-26 14:53:56
22816	9d67fbd1-a4a5-499c-b3d7-8586cd928127	9d67fbd1-eac3-49df-a75b-72135d8a97ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 00:48:40
22817	9d67fbd1-e63b-4121-99fc-23c4e637bb65	9d67fbd1-eac3-49df-a75b-72135d8a97ce	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"152.07","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 00:48:40
22818	9d67fbd1-e987-454c-bc9a-0ced57f5d743	9d67fbd1-eac3-49df-a75b-72135d8a97ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 00:48:40
22819	9d67fbd1-e9cf-4745-bb94-23a8e2fb895f	9d67fbd1-eac3-49df-a75b-72135d8a97ce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:48:40
22820	9d67fbd2-2a17-4bd4-82e3-960ab790596e	9d67fbd2-2d3f-4dd1-b271-8fc5780fdec1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":146,"memory":20,"hostname":"EderCortes"}	2024-11-04 00:48:40
23090	9d6888a7-ee1a-485a-8d3e-b33b87a167ca	9d6888a7-f29f-4149-83e1-779c70a90940	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":211,"memory":20,"hostname":"EderCortes"}	2024-11-04 07:22:28
10537	9d570f43-6035-40ab-99f6-98984c0975e3	9d570f43-8a37-42dd-ab85-8c15ecb77c34	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 14:53:57
10538	9d570f43-8262-469f-8a8d-5c06f6dc13ad	9d570f43-8a37-42dd-ab85-8c15ecb77c34	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"54.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 14:53:57
10539	9d570f43-82c5-46ed-84e8-89b4f75db303	9d570f43-8a37-42dd-ab85-8c15ecb77c34	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 14:53:57
10540	9d570f43-8860-4ec3-9a34-b026f14bc0dd	9d570f43-8a37-42dd-ab85-8c15ecb77c34	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 14:53:57
10541	9d570f43-88da-44a7-a8fc-30357c5f481c	9d570f43-8a37-42dd-ab85-8c15ecb77c34	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":400,"memory":22,"hostname":"EderCortes"}	2024-10-26 14:53:57
9823	9d56acdf-6bb9-40df-98bf-715da5380efb	9d56acdf-bb0e-40c8-af1a-0a52742ff189	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 10:18:50
9824	9d56acdf-b917-474c-a42b-c1b5883654be	9d56acdf-bb0e-40c8-af1a-0a52742ff189	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 10:18:50
9825	9d56acdf-b9cf-41a8-9030-6b49dbcf8aae	9d56acdf-bb0e-40c8-af1a-0a52742ff189	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":382,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:18:50
22821	9d67fbd2-7cd0-44a1-b059-12d971ef4ebf	9d67fbd2-7f8b-4708-a882-28109deff306	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":137,"memory":20,"hostname":"EderCortes"}	2024-11-04 00:48:40
9826	9d56ace0-1773-499d-a0b2-9f3a887a37e7	9d56ace0-5c8d-41f7-880e-26cfd324a441	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 10:18:51
9827	9d56ace0-57de-44b2-b4e4-75a835540d6f	9d56ace0-5c8d-41f7-880e-26cfd324a441	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"150.84","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-26 10:18:51
9828	9d56ace0-5b87-40be-9e5d-2511cc0c1b32	9d56ace0-5c8d-41f7-880e-26cfd324a441	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 10:18:51
9829	9d56ace0-5bce-44e6-ae52-b15ee5397e25	9d56ace0-5c8d-41f7-880e-26cfd324a441	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":379,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:18:51
22822	9d67fbd2-fc37-46f3-8105-50dc74c5916d	9d67fbd3-155c-4f5c-b955-8386f94f15a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 00:48:41
16863	9d64dbea-3b80-46fe-b284-66efc3ccd68b	9d64dbea-7fd2-4067-a549-e6ac327e8f98	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 11:31:58
16864	9d64dbea-7e30-4bc3-b18b-8fcf22f118b4	9d64dbea-7fd2-4067-a549-e6ac327e8f98	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 11:31:58
16865	9d64dbea-7eeb-4f5a-84a7-beb36a873de4	9d64dbea-7fd2-4067-a549-e6ac327e8f98	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":351,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:31:58
22823	9d67fbd3-1123-474e-8c21-73bddb719316	9d67fbd3-155c-4f5c-b955-8386f94f15a5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ma%' or \\"users\\".\\"user_document\\"::text like '%Ma%') order by \\"users\\".\\"user_document\\" asc","time":"37.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 00:48:41
22824	9d67fbd3-141e-48df-bb53-1a1125cdf0da	9d67fbd3-155c-4f5c-b955-8386f94f15a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 00:48:41
22825	9d67fbd3-1468-4cc6-a7da-95494b9e9506	9d67fbd3-155c-4f5c-b955-8386f94f15a5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ma"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":223,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:48:41
23102	9d68892c-4521-4705-bac3-f9a817334007	9d68892c-49b3-46e0-865b-7d994abace10	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":232,"memory":20,"hostname":"EderCortes"}	2024-11-04 07:23:55
9830	9d56ace1-d3b1-4a91-9781-0c0310ee0f35	9d56ace2-1a4d-4576-b601-ce08e197fdbb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 10:18:52
9831	9d56ace2-14f2-4bda-86b2-a96085a7d952	9d56ace2-1a4d-4576-b601-ce08e197fdbb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"146.49","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 10:18:52
9832	9d56ace2-1545-4d16-b8cf-d2e80c8816fd	9d56ace2-1a4d-4576-b601-ce08e197fdbb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 10:18:52
9833	9d56ace2-18e0-4f1d-a9b4-a13c9f0e47b8	9d56ace2-1a4d-4576-b601-ce08e197fdbb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 10:18:52
9834	9d56ace2-1927-4c67-b623-a71c1f0bfd07	9d56ace2-1a4d-4576-b601-ce08e197fdbb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":519,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:18:52
16866	9d64dbea-cbb1-4c6b-87ba-67db6052fa8b	9d64dbeb-1cb3-48a5-ae56-33526880a9e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 11:31:58
16867	9d64dbeb-15ea-497b-9b09-cd78ba55efe3	9d64dbeb-1cb3-48a5-ae56-33526880a9e7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"178.13","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":24,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-11-02 11:31:59
16868	9d64dbeb-1b60-489e-ab40-7530b900b2d4	9d64dbeb-1cb3-48a5-ae56-33526880a9e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 11:31:59
16869	9d64dbeb-1bc9-4f86-b746-cc7548c974e9	9d64dbeb-1cb3-48a5-ae56-33526880a9e7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":364,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:31:59
22826	9d67fbd3-4fb1-4b9b-9b1f-1629fd974fb5	9d67fbd3-52b8-4139-834a-cdc3d43d72bb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":135,"memory":20,"hostname":"EderCortes"}	2024-11-04 00:48:41
16970	9d654683-eaa7-49a4-be96-37c5c7401e2f	9d654684-31d1-4415-9348-a17d1097ab86	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 16:30:03
16971	9d654684-3031-4963-944a-5eef9ef400e9	9d654684-31d1-4415-9348-a17d1097ab86	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 16:30:03
16972	9d654684-30c3-483e-9e2f-7e8b3208bc92	9d654684-31d1-4415-9348-a17d1097ab86	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":343,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:30:03
16870	9d64dbec-eccb-4d3b-b860-7b34ce764c29	9d64dbed-24eb-4504-bed0-75f67a50d864	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 11:32:00
16871	9d64dbed-19f2-490c-97b9-18cb2ff9d15b	9d64dbed-24eb-4504-bed0-75f67a50d864	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"72.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 11:32:00
8761	9d52eec7-0fa4-4da2-8f32-773cffb883c1	9d52eec7-2c05-42da-bfdf-386756ed5287	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-24 13:39:49
8762	9d52eec7-2a80-4665-bad5-f43379f5d924	9d52eec7-2c05-42da-bfdf-386756ed5287	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-24 13:39:49
8763	9d52eec7-2b23-45a8-9589-7d3178408c85	9d52eec7-2c05-42da-bfdf-386756ed5287	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:39:49
16872	9d64dbed-1a7f-4cf7-85b4-7c573cd84cdf	9d64dbed-24eb-4504-bed0-75f67a50d864	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 11:32:00
16873	9d64dbed-22b7-4288-b3c1-9e4529e0307b	9d64dbed-24eb-4504-bed0-75f67a50d864	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 11:32:00
16874	9d64dbed-234d-42e2-8ccf-b6f51772f167	9d64dbed-24eb-4504-bed0-75f67a50d864	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":439,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:32:00
22827	9d67fbd3-c8ff-4f62-a5e7-eb0ac11b99b7	9d67fbd3-e49c-41d0-95d8-b36dd0a86aad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 00:48:41
22828	9d67fbd3-e07b-4945-bd13-3564dc46d617	9d67fbd3-e49c-41d0-95d8-b36dd0a86aad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mar%' or \\"users\\".\\"user_document\\"::text like '%Mar%') order by \\"users\\".\\"user_document\\" asc","time":"39.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 00:48:41
22829	9d67fbd3-e369-4bd7-92f5-39d56c45c42c	9d67fbd3-e49c-41d0-95d8-b36dd0a86aad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 00:48:41
22830	9d67fbd3-e3b0-4fec-bd6c-5936c79c1f28	9d67fbd3-e49c-41d0-95d8-b36dd0a86aad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mar"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":217,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:48:41
16875	9d64dbff-859d-4840-8ba2-a705bf34a14d	9d64dbff-abb4-49cf-87e5-a6aff92dfa90	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 11:32:12
16876	9d64dbff-9b83-4fd1-86c8-95813c7e35ec	9d64dbff-abb4-49cf-87e5-a6aff92dfa90	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"43.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 11:32:12
16877	9d64dbff-a645-430e-8d44-9383a2ef0f0e	9d64dbff-abb4-49cf-87e5-a6aff92dfa90	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 11:32:12
16878	9d64dbff-a685-4d8d-b7f6-cf1f1c89160b	9d64dbff-abb4-49cf-87e5-a6aff92dfa90	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 11:32:12
16879	9d64dbff-aa2f-4c95-8ab9-cc217483800b	9d64dbff-abb4-49cf-87e5-a6aff92dfa90	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 11:32:12
16880	9d64dbff-aaa2-46fe-aa5a-c25e6f062190	9d64dbff-abb4-49cf-87e5-a6aff92dfa90	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":265,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:32:12
16881	9d64dc08-3820-4229-96dc-d93a39bce778	9d64dc08-3b26-4133-9312-2dd70fffac56	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":151,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:32:18
22831	9d67fbd4-22aa-4cd4-8c46-e219ae04776c	9d67fbd4-2587-445f-b989-8300153ceb34	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":146,"memory":20,"hostname":"EderCortes"}	2024-11-04 00:48:41
1114	9d4f442c-cdb4-4dd8-80bd-83046b07fce0	9d4f442c-d429-46df-b650-2afbcfdee067	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":86}	2024-10-22 17:55:17
16882	9d64dc09-9355-4fcf-9364-1293a46357bb	9d64dc09-d956-4fc5-a99d-a40027575fd9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-02 11:32:19
16883	9d64dc09-d0e4-4e65-adfd-969cb2cc5366	9d64dc09-d956-4fc5-a99d-a40027575fd9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"144.26","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 11:32:19
16884	9d64dc09-d461-4688-b3c4-17d623751aa9	9d64dc09-d956-4fc5-a99d-a40027575fd9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"1.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 11:32:19
16885	9d64dc09-d49b-4db0-9756-65a4c16e8a0c	9d64dc09-d956-4fc5-a99d-a40027575fd9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 11:32:19
13424	9d5cfd39-e2c4-4ba1-8a05-2a5becc74284	9d5cfd3a-013c-4da6-bfd8-24cd69c33083	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-29 13:38:29
13425	9d5cfd39-ff91-44b5-a8c2-e60ef105aa1e	9d5cfd3a-013c-4da6-bfd8-24cd69c33083	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-29 13:38:29
13426	9d5cfd3a-0029-442e-83d7-7ab0ca72c3be	9d5cfd3a-013c-4da6-bfd8-24cd69c33083	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:38:29
16886	9d64dc09-d816-4878-b564-6f6c687c85b3	9d64dc09-d956-4fc5-a99d-a40027575fd9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-02 11:32:19
16887	9d64dc09-d862-43a6-8428-2d31065c07bf	9d64dc09-d956-4fc5-a99d-a40027575fd9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:32:19
22832	9d67fbd4-9605-4770-b93f-ff045747d78a	9d67fbd4-990e-477c-9cbf-5fc8c6b6916a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":133,"memory":20,"hostname":"EderCortes"}	2024-11-04 00:48:42
23115	9d6889c2-5fa9-4fb5-967d-7d2ff2193ea2	9d6889c2-649a-4da8-98cd-c2128926b8e7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":297,"memory":20,"hostname":"EderCortes"}	2024-11-04 07:25:33
13427	9d5cfd3a-495e-48fd-8fad-3d00bfa88942	9d5cfd3a-8de6-4aba-a113-d80f971194cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-29 13:38:30
13428	9d5cfd3a-8989-49d5-a3a2-ba23834ba052	9d5cfd3a-8de6-4aba-a113-d80f971194cf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"151.66","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-29 13:38:30
13429	9d5cfd3a-8c74-47b4-84fd-c598d4109356	9d5cfd3a-8de6-4aba-a113-d80f971194cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-29 13:38:30
13430	9d5cfd3a-8cd2-4e96-b164-fcaca175e961	9d5cfd3a-8de6-4aba-a113-d80f971194cf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":327,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:38:30
16888	9d64dcd2-8362-4620-a258-f1a4df4b1b1c	9d64dcd2-88d4-4333-b2d0-267298abd30d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":220,"memory":20,"hostname":"EderCortes"}	2024-11-02 11:34:30
22833	9d67fbd4-eab1-4f7c-8c5a-202108e38d9d	9d67fbd5-044b-495a-b95d-b20641b332d4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 00:48:42
22834	9d67fbd5-0027-4168-b3e9-4d91cafb7e00	9d67fbd5-044b-495a-b95d-b20641b332d4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"37.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 00:48:42
22835	9d67fbd5-0310-41b5-83a6-f1f9adbe47cc	9d67fbd5-044b-495a-b95d-b20641b332d4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 00:48:42
22836	9d67fbd5-0359-46fe-a578-6eaad24fca39	9d67fbd5-044b-495a-b95d-b20641b332d4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":217,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:48:42
13431	9d5cfd3b-e34f-4ab7-96da-5ab15a034ebb	9d5cfd3c-055d-471e-b5cf-a9e48852da55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-29 13:38:31
10616	9d57116f-61e5-434e-b9d1-e8bb05db8d5f	9d57116f-98e6-4bea-8d64-d9027100f6b7	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 15:00:02
10617	9d57116f-9531-4138-a329-8d08b2f7efd5	9d57116f-98e6-4bea-8d64-d9027100f6b7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 15:00:02
10618	9d57116f-96db-4502-81f8-0d454cb2cf31	9d57116f-98e6-4bea-8d64-d9027100f6b7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:00:02
13432	9d5cfd3c-000f-4018-b349-4f3c30ff23b3	9d5cfd3c-055d-471e-b5cf-a9e48852da55	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 13:38:31
13433	9d5cfd3c-005b-4d4b-9174-874963295490	9d5cfd3c-055d-471e-b5cf-a9e48852da55	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 13:38:31
13434	9d5cfd3c-03f4-4753-890e-9c6dcd061f06	9d5cfd3c-055d-471e-b5cf-a9e48852da55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-29 13:38:31
13435	9d5cfd3c-043e-42b7-918d-5b701f61dcb4	9d5cfd3c-055d-471e-b5cf-a9e48852da55	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":420,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:38:31
16889	9d64dcd2-ead0-4970-bd28-ddd3df2d2809	9d64dcd3-2dd1-443d-bf8e-a988d6ff145c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 11:34:31
16890	9d64dcd3-0c39-4b08-89d6-6993db464f93	9d64dcd3-2dd1-443d-bf8e-a988d6ff145c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 191 limit 1","time":"2.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":328,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-02 11:34:31
16891	9d64dcd3-0ce5-4cd9-b4ca-c2544a821087	9d64dcd3-2dd1-443d-bf8e-a988d6ff145c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-02 11:34:31
16892	9d64dcd3-0ed4-43c4-82c7-5f0ea0e50633	9d64dcd3-2dd1-443d-bf8e-a988d6ff145c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 62 limit 1","time":"2.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":329,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-02 11:34:31
16893	9d64dcd3-0f09-490e-941d-adcac72cee3c	9d64dcd3-2dd1-443d-bf8e-a988d6ff145c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-02 11:34:31
16894	9d64dcd3-2061-4d60-8687-347120161d2c	9d64dcd3-2dd1-443d-bf8e-a988d6ff145c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '02-11-2024', \\"itemloans_interes_canelado\\" = '50000', \\"itemloans_cuota_cancelada\\" = '100000', \\"updated_at\\" = '2024-11-02 11:34:31' where \\"id\\" = 191","time":"1.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":350,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-02 11:34:31
16895	9d64dcd3-2684-4dde-b832-fa2b976a17f3	9d64dcd3-2dd1-443d-bf8e-a988d6ff145c	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:191","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-02 11:34:31","item_loans_cuando_pago":"02-11-2024","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},"hostname":"EderCortes"}	2024-11-02 11:34:31
16896	9d64dcd3-275e-430a-bbe6-d8173f3f88c9	9d64dcd3-2dd1-443d-bf8e-a988d6ff145c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_fecha_ultimo_pago\\" = '02-11-2024', \\"updated_at\\" = '2024-11-02 11:34:31' where \\"id\\" = 62","time":"0.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":358,"hash":"cf593c3f0d97e8454c5164f16511623d","hostname":"EderCortes"}	2024-11-02 11:34:31
16897	9d64dcd3-2794-4c7c-b4e4-ae02b81a04b6	9d64dcd3-2dd1-443d-bf8e-a988d6ff145c	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:62","changes":{"updated_at":"2024-11-02 11:34:31","loans_fecha_ultimo_pago":"02-11-2024"},"hostname":"EderCortes"}	2024-11-02 11:34:31
16898	9d64dcd3-2bd2-4468-adc4-fbef1dca8013	9d64dcd3-2dd1-443d-bf8e-a988d6ff145c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 11:34:31
16899	9d64dcd3-2c43-4fef-9c3d-6715bd12d40b	9d64dcd3-2dd1-443d-bf8e-a988d6ff145c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"157","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000","id":191,"loans_codigo":62,"item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":350,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:34:31
22837	9d67fbd5-4481-4529-877f-44ce81aed93f	9d67fbd5-610b-44d7-829f-fb7902a6d646	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 00:48:42
10619	9d571170-0033-4469-bdd8-e6eef3f9e885	9d571170-541d-49f2-8590-66a61c2b8b95	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 15:00:02
10620	9d571170-4405-4d4a-af6c-be7a707b3f79	9d571170-541d-49f2-8590-66a61c2b8b95	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"159.34","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 15:00:02
10621	9d571170-48e6-416c-8345-d353e2efb594	9d571170-541d-49f2-8590-66a61c2b8b95	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '5' order by \\"item_loans\\".\\"id\\" asc","time":"3.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-26 15:00:02
10622	9d571170-493a-4595-99ae-93af4743bcfa	9d571170-541d-49f2-8590-66a61c2b8b95	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-26 15:00:02
10623	9d571170-51d0-49ba-b2bf-a6ab07d4d7fa	9d571170-541d-49f2-8590-66a61c2b8b95	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 15:00:02
10624	9d571170-523c-418c-ab5b-a0a9b043ae9b	9d571170-541d-49f2-8590-66a61c2b8b95	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":25,"loans_codigo":5,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":26,"loans_codigo":5,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":27,"loans_codigo":5,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":28,"loans_codigo":5,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":29,"loans_codigo":5,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":30,"loans_codigo":5,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null}]}},"duration":437,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:00:02
13436	9d5cfd6c-7a3b-40bb-a016-f7e904df2025	9d5cfd6c-7d6c-428b-88cd-d62332337dc4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":140,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:39:02
16900	9d64dcd4-0344-4393-918d-a20183972801	9d64dcd4-2530-4d7e-b049-98b74ffe2c49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 11:34:31
16901	9d64dcd4-1c26-4b94-a78b-68e4d4ab3c6a	9d64dcd4-2530-4d7e-b049-98b74ffe2c49	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"48.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 11:34:31
16902	9d64dcd4-1fd6-42b1-a1bc-cfd7f66a923a	9d64dcd4-2530-4d7e-b049-98b74ffe2c49	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 11:34:31
16903	9d64dcd4-2019-453f-b6ea-1c72cba2d468	9d64dcd4-2530-4d7e-b049-98b74ffe2c49	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 11:34:31
16904	9d64dcd4-23ca-4fe6-9255-368c0dfeb358	9d64dcd4-2530-4d7e-b049-98b74ffe2c49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 11:34:31
10625	9d571172-26f5-4c9e-a3d4-40ff136f4929	9d571172-6d8b-4832-9d94-c4c782fe6d54	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 15:00:04
10626	9d571172-6874-46f1-934a-61a4b4b4c946	9d571172-6d8b-4832-9d94-c4c782fe6d54	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"145.59","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 15:00:04
10627	9d571172-68d0-4203-be3d-fe2606f7ca31	9d571172-6d8b-4832-9d94-c4c782fe6d54	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 15:00:04
10628	9d571172-6c3a-479a-a24b-a956a1d87db8	9d571172-6d8b-4832-9d94-c4c782fe6d54	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 15:00:04
9967	9d56c570-4e8d-49d4-b28f-a255eeb8cfe3	9d56c570-6a8a-4453-81dc-f364935f1068	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:27:32
9968	9d56c570-68d3-45c0-962b-de317473fde3	9d56c570-6a8a-4453-81dc-f364935f1068	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 11:27:32
9969	9d56c570-698f-4f04-af97-5d34f43af622	9d56c570-6a8a-4453-81dc-f364935f1068	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:27:32
10629	9d571172-6c7b-4ce8-af11-69c321539ad4	9d571172-6d8b-4832-9d94-c4c782fe6d54	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:00:04
16905	9d64dcd4-2419-4ef5-8f42-a3c3b0448304	9d64dcd4-2530-4d7e-b049-98b74ffe2c49	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:34:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"}]}},"duration":303,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:34:31
22838	9d67fbd5-5ca9-4227-9dc6-fe80709bc388	9d67fbd5-610b-44d7-829f-fb7902a6d646	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"39.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 00:48:42
22839	9d67fbd5-5fb0-4cf8-9dc8-3e960cab847e	9d67fbd5-610b-44d7-829f-fb7902a6d646	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 00:48:42
22840	9d67fbd5-6003-4f0e-9c54-cf9f84fa8e3a	9d67fbd5-610b-44d7-829f-fb7902a6d646	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:48:42
9970	9d56c570-b38c-4265-af85-356d5f5565ba	9d56c570-f962-485d-bba2-b2cc36f42ee9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 11:27:32
9971	9d56c570-f437-4b51-ab4f-4c11c6d39a4b	9d56c570-f962-485d-bba2-b2cc36f42ee9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"143.63","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-26 11:27:32
9972	9d56c570-f4a6-4369-a509-f0e3231f884d	9d56c570-f962-485d-bba2-b2cc36f42ee9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-26 11:27:32
9973	9d56c570-f853-498a-bd76-7b8c06b0bcc5	9d56c570-f962-485d-bba2-b2cc36f42ee9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 11:27:32
9974	9d56c570-f895-41fb-81d8-3ac76772b764	9d56c570-f962-485d-bba2-b2cc36f42ee9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:27:32
13440	9d5cfd9d-5e1d-4d51-898e-afd7348f078c	9d5cfd9d-6244-4ea7-a10c-46a05ab1d377	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":215,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:39:35
16906	9d64de64-0a84-4118-8cc2-85cd108b71b2	9d64de64-0e55-4eaf-8402-8d2eb3bac0bd	eb5cfca5f40b95e7d9b425f35720fed2	t	exception	{"class":"TypeError","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":423,"message":"PDO::prepare(): Argument #1 ($query) must be of type string, Illuminate\\\\Database\\\\Query\\\\Expression given","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":423},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":816},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":26},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"414":"        return $this->run($query, $bindings, function ($query, $bindings) use ($useReadPdo) {","415":"            if ($this->pretending()) {","416":"                return [];","417":"            }","418":"","419":"            \\/\\/ For select statements, we'll simply execute the query and return an array","420":"            \\/\\/ of the database result set. Each element in the array will be a single","421":"            \\/\\/ row from the database table, and will either be an array or objects.","422":"            $statement = $this->prepared(","423":"                $this->getPdoForSelect($useReadPdo)->prepare($query)","424":"            );","425":"","426":"            $this->bindValues($statement, $this->prepareBindings($bindings));","427":"","428":"            $statement->execute();","429":"","430":"            return $statement->fetchAll();","431":"        });","432":"    }","433":""},"hostname":"EderCortes","occurrences":1}	2024-11-02 11:38:53
16907	9d64de63-b2e2-4f95-b40e-b1233519d0d0	9d64de64-0e55-4eaf-8402-8d2eb3bac0bd	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 11:38:53
16908	9d64de64-0c24-49f5-88df-7827a1d2a9d4	9d64de64-0e55-4eaf-8402-8d2eb3bac0bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 11:38:53
16909	9d64de64-0ce6-4842-830c-68595b2c86fb	9d64de64-0e55-4eaf-8402-8d2eb3bac0bd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"PDO::prepare(): Argument #1 ($query) must be of type string, Illuminate\\\\Database\\\\Query\\\\Expression given","exception":"TypeError","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":423,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":423,"function":"prepare","class":"PDO","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":816,"function":"Illuminate\\\\Database\\\\{closure}","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":26,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":435,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:38:53
22841	9d67fbd5-a7bf-424c-a522-8c8e461f9b6a	9d67fbd5-e99e-4983-9423-19a383ce2a13	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 00:48:42
22842	9d67fbd5-e5a2-42a3-ae8b-e010cdd0d12a	9d67fbd5-e99e-4983-9423-19a383ce2a13	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"141.60","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 00:48:42
22843	9d67fbd5-e877-46e7-92bc-a927b4c110ad	9d67fbd5-e99e-4983-9423-19a383ce2a13	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 00:48:42
22844	9d67fbd5-e8ba-4b24-b455-ac19a5206e6f	9d67fbd5-e99e-4983-9423-19a383ce2a13	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"28","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:48:42
9975	9d56c572-6bc1-41ca-9ccb-ac32222d615a	9d56c572-b7ef-4947-8d6b-275c9833a674	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 11:27:33
9976	9d56c572-b279-4987-889c-6765c7c7dce7	9d56c572-b7ef-4947-8d6b-275c9833a674	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"158.26","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:27:33
9977	9d56c572-b2c7-4f1b-9a9b-a2b803b4fdbb	9d56c572-b7ef-4947-8d6b-275c9833a674	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:27:33
9978	9d56c572-b649-45f0-9aaf-20e8e735526b	9d56c572-b7ef-4947-8d6b-275c9833a674	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 11:27:33
9979	9d56c572-b6ab-4f55-91fd-c0909c7d39f9	9d56c572-b7ef-4947-8d6b-275c9833a674	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":371,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:27:33
22845	9d67fbd9-4f7b-45fa-9d6f-8600311cb960	9d67fbd9-978d-4738-af28-efb5ab84d7ab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 00:48:45
22846	9d67fbd9-9263-4310-b4f2-60e1352854f5	9d67fbd9-978d-4738-af28-efb5ab84d7ab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '19' and \\"users\\".\\"deleted_at\\" is null","time":"146.34","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":55,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-11-04 00:48:45
22847	9d67fbd9-92ae-4d89-af42-beaa023fd636	9d67fbd9-978d-4738-af28-efb5ab84d7ab	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 00:48:45
22848	9d67fbd9-962e-49c8-96b0-c8e35b5df4f2	9d67fbd9-978d-4738-af28-efb5ab84d7ab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 00:48:45
22849	9d67fbd9-9687-4743-920b-03b660e25637	9d67fbd9-978d-4738-af28-efb5ab84d7ab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/19","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}},"duration":366,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:48:45
13444	9d5cfdbf-7cb8-412c-8eab-e33ad0970e1d	9d5cfdbf-7f7c-4e51-9daa-e1752a32c8e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":142,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:39:57
23128	9d688a52-dbf6-4e94-aaa3-03e84cca613c	9d688a52-e112-4bd6-832d-2feffa868216	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":230,"memory":20,"hostname":"EderCortes"}	2024-11-04 07:27:08
11399	9d5cbdf6-b823-4dad-ad2b-ccf45843b3f9	9d5cbdf7-01cf-4dbe-9f96-bf8279e32f85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 10:41:36
11400	9d5cbdf6-ffef-42b5-a2bc-f8f68a4bf54b	9d5cbdf7-01cf-4dbe-9f96-bf8279e32f85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 10:41:36
11401	9d5cbdf7-0080-4625-8713-8ca942b07985	9d5cbdf7-01cf-4dbe-9f96-bf8279e32f85	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:41:36
17025	9d654743-3bc0-46b8-b4dc-c9a6d3d38b14	9d654743-58d1-4f08-b975-eeef6aa87bbb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:32:08
17026	9d654743-573a-424f-867f-3e4bdb32cb76	9d654743-58d1-4f08-b975-eeef6aa87bbb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 16:32:08
14574	9d5ebe99-e674-4e08-8e0c-4be46cfe9ade	9d5ebe9a-3278-4afb-b717-95b0cea5c4b5	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-30 10:35:02
14575	9d5ebe9a-2e77-41f7-a787-a109e6f02251	9d5ebe9a-3278-4afb-b717-95b0cea5c4b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 10:35:02
14576	9d5ebe9a-305b-49cd-82b1-f39b4c578968	9d5ebe9a-3278-4afb-b717-95b0cea5c4b5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":879,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:35:02
17027	9d654743-57d5-4760-a9b6-4408504c3764	9d654743-58d1-4f08-b975-eeef6aa87bbb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna l.id \\nLINE 1: ...on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id \\" ...\\n                                                             ^\\nHINT:  Probablemente quiera hacer referencia a la columna \\u00abl.id\\u00bb. (Connection: pgsql, SQL: select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id \\" desc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":42,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:32:08
22850	9d67fbfd-cc6d-4d44-94a6-1ff236dc0b4a	9d67fbfd-cfd1-47c5-aca2-bfe3c49ec604	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":182,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:49:09
11402	9d5cbdf7-49ee-4a4c-9e19-fc21e2b56634	9d5cbdf7-6984-4683-b552-f473465b6cf3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 10:41:36
11403	9d5cbdf7-5f29-42c4-948c-fc301607f814	9d5cbdf7-6984-4683-b552-f473465b6cf3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 1\\n                        ","time":"40.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"2bd5a29c69f6bbb290fc49b79286632e","hostname":"EderCortes"}	2024-10-29 10:41:36
11404	9d5cbdf7-6281-4e09-9f1a-68b94461c883	9d5cbdf7-6984-4683-b552-f473465b6cf3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1' order by \\"item_loans\\".\\"id\\" asc","time":"2.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 10:41:36
11405	9d5cbdf7-62b2-42be-a4a3-b44f61c0e092	9d5cbdf7-6984-4683-b552-f473465b6cf3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 10:41:36
11406	9d5cbdf7-680c-4448-ba66-c8861e124d1f	9d5cbdf7-6984-4683-b552-f473465b6cf3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 10:41:36
11407	9d5cbdf7-6874-48f3-915d-18c518c8150c	9d5cbdf7-6984-4683-b552-f473465b6cf3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":1,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]}},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:41:36
14577	9d5ebe9a-f3ea-4709-9b15-feeed8b9240c	9d5ebe9b-4cc0-4311-9882-e310c60e24cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 10:35:03
17028	9d654745-1d84-4e84-a149-cb4dd44185de	9d654745-3a30-4c45-a392-26d612b47e7f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 16:32:09
13448	9d5cfe08-f603-4f24-ab1b-0ba2ae41af97	9d5cfe08-f8fd-4a98-b13f-cfb2618c85f9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":139,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:40:45
14578	9d5ebe9b-3dbf-4ff1-be93-a3089ebcf948	9d5ebe9b-4cc0-4311-9882-e310c60e24cf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 55\\n                        ","time":"165.05","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"ff7240abed4441475e0acd0c74a5f6aa","hostname":"EderCortes"}	2024-10-30 10:35:03
14579	9d5ebe9b-43a0-410c-941b-92b8c336f6d8	9d5ebe9b-4cc0-4311-9882-e310c60e24cf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '55' order by \\"item_loans\\".\\"id\\" asc","time":"3.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-30 10:35:03
14580	9d5ebe9b-43ef-4c5c-89b7-23ff24b916b2	9d5ebe9b-4cc0-4311-9882-e310c60e24cf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":7,"hostname":"EderCortes"}	2024-10-30 10:35:03
8941	9d52f26c-0215-43b6-b6f4-1cdb7d95847e	9d52f26c-2489-4de3-882b-57af27010b49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:50:00
8942	9d52f26c-22fb-4995-831d-7346ab2402ea	9d52f26c-2489-4de3-882b-57af27010b49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:50:00
8943	9d52f26c-23a5-4bb8-b0a1-a08ccdb0e317	9d52f26c-2489-4de3-882b-57af27010b49	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":268,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:50:00
14581	9d5ebe9b-4ab6-4879-bdfc-b7b8e87d2d5d	9d5ebe9b-4cc0-4311-9882-e310c60e24cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 10:35:03
14582	9d5ebe9b-4b29-4ce0-903a-0e5402145813	9d5ebe9b-4cc0-4311-9882-e310c60e24cf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/55","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":55,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":7,"loans_valor_prestado":50000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"15-11-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":150,"loans_codigo":55,"itemloans_cuota":"1","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":151,"loans_codigo":55,"itemloans_cuota":"2","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":152,"loans_codigo":55,"itemloans_cuota":"3","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":153,"loans_codigo":55,"itemloans_cuota":"4","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":154,"loans_codigo":55,"itemloans_cuota":"5","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":155,"loans_codigo":55,"itemloans_cuota":"6","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":156,"loans_codigo":55,"itemloans_cuota":"7","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":655,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:35:03
17029	9d654745-34c3-464c-b62f-b63437f13e7a	9d654745-3a30-4c45-a392-26d612b47e7f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 16:32:09
17030	9d654745-3510-4e45-b340-6594b92a91ca	9d654745-3a30-4c45-a392-26d612b47e7f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 16:32:09
17031	9d654745-38e5-4368-9480-827db50ee523	9d654745-3a30-4c45-a392-26d612b47e7f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 16:32:09
17032	9d654745-392e-469f-b079-57db05aae81d	9d654745-3a30-4c45-a392-26d612b47e7f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":213,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:32:09
22851	9d67fbfe-81d7-42f5-addb-5133ca0a81a8	9d67fbfe-d491-4686-9d36-3dc5a5f5d3fa	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 00:49:09
11499	9d5cbf02-90f6-4405-a52d-b9199d1b4e91	9d5cbf02-add0-46d8-b344-5e6aaa1ab411	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 10:44:31
11500	9d5cbf02-ac21-45a5-8112-c90b74f37ed5	9d5cbf02-add0-46d8-b344-5e6aaa1ab411	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 10:44:31
11501	9d5cbf02-acb9-4c9c-bb82-6f6c6a4b4bc1	9d5cbf02-add0-46d8-b344-5e6aaa1ab411	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:44:31
22852	9d67fbfe-c816-4612-8379-12708d0bf5e9	9d67fbfe-d491-4686-9d36-3dc5a5f5d3fa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\", \\"loans_fecha_ultimo_pago\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta 2', 'De las nieve', 'ds', 'CC', '1004655468', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon2', 'Calle 7505', '1150000', 25, 5, 'Q', null, '04-11-2024', 'Pendiente', '312596295', 12, 14, 19, 14, '04-11-2024', 0, 0, '04-11-2024', '2024-11-04 00:49:09', '2024-11-04 00:49:09') returning \\"id\\"","time":"4.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":106,"hash":"627b53ca897e623c432f1126c69a0881","hostname":"EderCortes"}	2024-11-04 00:49:09
22853	9d67fbfe-c890-49ce-901d-f23e7a5ee042	9d67fbfe-d491-4686-9d36-3dc5a5f5d3fa	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:69","hostname":"EderCortes"}	2024-11-04 00:49:09
22854	9d67fbfe-c9fd-46f2-83dc-7a553c81b3e5	9d67fbfe-d491-4686-9d36-3dc5a5f5d3fa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (69, 1, 230000, 57500, 'Pendiente', 'N\\/A', '20-11-2024', 12, 0, 0, '2024-11-04 00:49:09', '2024-11-04 00:49:09')","time":"2.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 00:49:09
22855	9d67fbfe-ca25-43cd-9e2c-1957e320f666	9d67fbfe-d491-4686-9d36-3dc5a5f5d3fa	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 00:49:09
22856	9d67fbfe-ca95-4771-80db-5a9f42e647a6	9d67fbfe-d491-4686-9d36-3dc5a5f5d3fa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (69, 2, 230000, 57500, 'Pendiente', 'N\\/A', '06-12-2024', 12, 0, 0, '2024-11-04 00:49:09', '2024-11-04 00:49:09')","time":"0.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 00:49:09
22857	9d67fbfe-caba-4995-9d9b-365cdaa8fc0e	9d67fbfe-d491-4686-9d36-3dc5a5f5d3fa	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 00:49:09
11502	9d5cbf02-f6d9-418f-bf76-c71e0afd81fd	9d5cbf03-3e70-4fec-99f8-7db2f15672c6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 10:44:31
11503	9d5cbf03-35bb-46ae-a027-d5a1be0fb594	9d5cbf03-3e70-4fec-99f8-7db2f15672c6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 1\\n                        ","time":"148.48","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"2bd5a29c69f6bbb290fc49b79286632e","hostname":"EderCortes"}	2024-10-29 10:44:32
11504	9d5cbf03-3959-4ece-8d53-d03981a31236	9d5cbf03-3e70-4fec-99f8-7db2f15672c6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1' order by \\"item_loans\\".\\"id\\" asc","time":"2.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 10:44:32
11505	9d5cbf03-398c-4380-b9c4-86c8f246c66d	9d5cbf03-3e70-4fec-99f8-7db2f15672c6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 10:44:32
11506	9d5cbf03-3d3a-40c5-a587-53d90147c7a0	9d5cbf03-3e70-4fec-99f8-7db2f15672c6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 10:44:32
11507	9d5cbf03-3d89-4260-b9cb-028fbcfe8e92	9d5cbf03-3e70-4fec-99f8-7db2f15672c6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":1,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]}},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:44:32
22858	9d67fbfe-cb23-4de3-ae08-ea6e14649d04	9d67fbfe-d491-4686-9d36-3dc5a5f5d3fa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (69, 3, 230000, 57500, 'Pendiente', 'N\\/A', '22-12-2024', 12, 0, 0, '2024-11-04 00:49:09', '2024-11-04 00:49:09')","time":"0.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 00:49:09
22859	9d67fbfe-cb42-49ba-86b3-46a47008c878	9d67fbfe-d491-4686-9d36-3dc5a5f5d3fa	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 00:49:09
22860	9d67fbfe-cba6-4ffd-bba5-244cc555f6be	9d67fbfe-d491-4686-9d36-3dc5a5f5d3fa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (69, 4, 230000, 57500, 'Pendiente', 'N\\/A', '07-01-2025', 12, 0, 0, '2024-11-04 00:49:09', '2024-11-04 00:49:09')","time":"0.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 00:49:09
14583	9d5ebe9b-d3b9-4886-8972-a6c702557704	9d5ebe9c-025d-4d3b-a690-341e2c91a3e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 10:35:03
22861	9d67fbfe-cbc3-4a95-9b2d-e83cbed0a6e1	9d67fbfe-d491-4686-9d36-3dc5a5f5d3fa	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 00:49:09
22862	9d67fbfe-cc22-4c1e-9f97-f9406490bb6d	9d67fbfe-d491-4686-9d36-3dc5a5f5d3fa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (69, 5, 230000, 57500, 'Pendiente', 'N\\/A', '23-01-2025', 12, 0, 0, '2024-11-04 00:49:09', '2024-11-04 00:49:09')","time":"0.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 00:49:09
22863	9d67fbfe-cc3e-4172-bd42-7652fb106fa1	9d67fbfe-d491-4686-9d36-3dc5a5f5d3fa	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 00:49:09
22864	9d67fbfe-d310-4e4e-9e3b-0ed726575bec	9d67fbfe-d491-4686-9d36-3dc5a5f5d3fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 00:49:09
11508	9d5cbf04-b4ba-45ed-9f28-b0eed0c5842f	9d5cbf04-fc6f-4cc0-8120-bcd2c0ef62b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 10:44:33
11509	9d5cbf04-f750-4886-8c51-a1becb647bbe	9d5cbf04-fc6f-4cc0-8120-bcd2c0ef62b9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"152.90","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 10:44:33
11510	9d5cbf04-f7a3-4563-8130-dd8b3af90484	9d5cbf04-fc6f-4cc0-8120-bcd2c0ef62b9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 10:44:33
11511	9d5cbf04-fb23-427a-90d4-35b00ac83fb2	9d5cbf04-fc6f-4cc0-8120-bcd2c0ef62b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 10:44:33
11512	9d5cbf04-fb78-400d-9de3-790df859d9e7	9d5cbf04-fc6f-4cc0-8120-bcd2c0ef62b9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":322,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:44:33
13452	9d5cfeac-78c2-403b-8fe9-3e6d643c9893	9d5cfeac-7c7a-4a1f-a749-c8ad482f39b6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":178,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:42:32
14584	9d5ebe9b-f808-4a5f-ab76-303a10b629d2	9d5ebe9c-025d-4d3b-a690-341e2c91a3e7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"60.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 10:35:03
14585	9d5ebe9b-f89a-4ce4-a2f5-bd3fd8afd7b4	9d5ebe9c-025d-4d3b-a690-341e2c91a3e7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 10:35:03
14586	9d5ebe9c-0058-4b58-b0df-a734549f241b	9d5ebe9c-025d-4d3b-a690-341e2c91a3e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 10:35:03
14587	9d5ebe9c-00c5-4aeb-87ce-78071c0058ba	9d5ebe9c-025d-4d3b-a690-341e2c91a3e7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":445,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:35:03
22865	9d67fbfe-d361-41d3-afce-305a0a46fbea	9d67fbfe-d491-4686-9d36-3dc5a5f5d3fa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"801","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"1004655468","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_valor_prestado":"1150000","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":19,"user_recomendacion":14,"loans_inicio_pago":"Mon Nov 04 2024","created_at":null,"updated_at":null,"deleted_at":null,"loans_pago_prestado":0,"loans_pago_interes":0},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Mon Nov 04 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":69},"duration":363,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:49:09
22866	9d67fcf9-2ccc-446a-9a41-64d79c3090e7	9d67fcf9-31c7-44ef-a5d6-381c5bcc3015	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":221,"memory":20,"hostname":"EderCortes"}	2024-11-04 00:51:53
17081	9d654a1f-0b76-4365-9326-d31de7493e20	9d654a1f-5e78-4f6a-a07b-c399a1552325	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 16:40:08
17082	9d654a1f-5bf6-4ec5-b381-e4d3be0c7795	9d654a1f-5e78-4f6a-a07b-c399a1552325	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:40:08
17083	9d654a1f-5cca-48cd-8215-df8e6942c2e0	9d654a1f-5e78-4f6a-a07b-c399a1552325	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":505,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:40:08
13457	9d5cff04-0f1e-4a4d-b7b7-971c91348aae	9d5cff04-12a0-4e0e-903e-5795dc03d8a3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":170,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:43:30
14588	9d5ebe9c-aa5d-435f-a936-569bebbc617e	9d5ebe9c-d730-4a99-b72f-5f3e02ea762f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 10:35:04
14589	9d5ebe9c-cf2b-4e9c-be29-139da1a2ef5d	9d5ebe9c-d730-4a99-b72f-5f3e02ea762f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"53.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 10:35:04
14590	9d5ebe9c-cf97-4402-a5dc-b3d3b9ccb1b4	9d5ebe9c-d730-4a99-b72f-5f3e02ea762f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 10:35:04
14591	9d5ebe9c-d55c-4329-9486-67e8c7945bab	9d5ebe9c-d730-4a99-b72f-5f3e02ea762f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-30 10:35:04
14592	9d5ebe9c-d5d4-4594-a8a9-1a3135feb82b	9d5ebe9c-d730-4a99-b72f-5f3e02ea762f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":525,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:35:04
17084	9d654a1f-eeb5-4961-a020-15fcce073bb1	9d654a20-3a09-41fe-999f-03d40c703959	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:40:08
17085	9d654a20-327f-4547-a93d-7f3c4fe39d6e	9d654a20-3a09-41fe-999f-03d40c703959	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select (l.loans_fecha_ultimo_pago::date - '2024-11-02'::date) as dis_restantes, \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"149.27","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":32,"hash":"b870d711638eac4fca840e97c3785e38","hostname":"EderCortes"}	2024-11-02 16:40:08
17086	9d654a20-38a0-4b56-a4a0-7bc687b99382	9d654a20-3a09-41fe-999f-03d40c703959	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 16:40:08
17087	9d654a20-38fd-4b8e-bd39-638655a396f3	9d654a20-3a09-41fe-999f-03d40c703959	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dis_restantes":-31,"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":520,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:40:08
22867	9d67fcf9-9715-479c-86b0-ee45e1d88633	9d67fcf9-edac-4655-a15b-6aa451623bd1	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 00:51:54
22868	9d67fcf9-e036-4b2d-8ec6-9d8a0cafc8fa	9d67fcf9-edac-4655-a15b-6aa451623bd1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\", \\"loans_fecha_ultimo_pago\\", \\"loans_intereses_recaudar\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta 2', 'De las nieve', 'ds', 'CC', '1004655468', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon2', 'Calle 7505', '2150000', 25, 5, 'S', null, '04-11-2024', 'Pendiente', '312596295', 12, 14, 19, 14, '04-11-2024', 0, 0, '04-11-2024', 537500, '2024-11-04 00:51:54', '2024-11-04 00:51:54') returning \\"id\\"","time":"5.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":110,"hash":"f69b6b91ceb0fd9e0c386e94fcedc496","hostname":"EderCortes"}	2024-11-04 00:51:54
22869	9d67fcf9-e0d3-4792-ac3a-0a84932f11cb	9d67fcf9-edac-4655-a15b-6aa451623bd1	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:70","hostname":"EderCortes"}	2024-11-04 00:51:54
10101	9d56c89b-5c12-4952-963d-db8923f6ef23	9d56c89b-7947-4e6a-92a2-b4fefa1530b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 11:36:23
10102	9d56c89b-7772-4d00-902a-10c015797dd5	9d56c89b-7947-4e6a-92a2-b4fefa1530b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 11:36:23
10103	9d56c89b-7832-4f5f-ab64-7cc44c629b57	9d56c89b-7947-4e6a-92a2-b4fefa1530b0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:36:23
10104	9d56c89b-c159-4cf8-afb9-edfac2dea6b8	9d56c89c-088c-4002-a794-66a889a0d5e2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 11:36:23
10105	9d56c89c-0422-47c3-a9ab-60a37702e248	9d56c89c-088c-4002-a794-66a889a0d5e2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"156.27","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:36:24
10106	9d56c89c-0736-437b-8528-3808edfd029e	9d56c89c-088c-4002-a794-66a889a0d5e2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 11:36:24
10107	9d56c89c-078e-461e-b621-5c3f296130fb	9d56c89c-088c-4002-a794-66a889a0d5e2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":337,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:36:24
13461	9d5cff4e-c438-4af8-9030-5ed4780828f5	9d5cff4f-a88c-46fa-8325-1e98f8db1cbd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":138,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:44:19
14593	9d5ebe9d-cbf6-47a7-9517-e07c3a7ba8a3	9d5ebe9d-fda8-492d-a4cd-832af57fa8e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-30 10:35:04
14594	9d5ebe9d-f6bd-4155-bc2c-a7d7d85b5b60	9d5ebe9d-fda8-492d-a4cd-832af57fa8e3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"62.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 10:35:05
14595	9d5ebe9d-f71b-4c04-a7db-e3b1abcdcc8e	9d5ebe9d-fda8-492d-a4cd-832af57fa8e3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 10:35:05
14596	9d5ebe9d-fc28-44a7-add4-fab6eeeeade4	9d5ebe9d-fda8-492d-a4cd-832af57fa8e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-30 10:35:05
14597	9d5ebe9d-fc8a-4f47-bddd-1382eebc44df	9d5ebe9d-fda8-492d-a4cd-832af57fa8e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":441,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:35:05
17088	9d654a22-3e3f-4c89-880a-c373ddafb5b1	9d654a22-5cce-4771-a031-56456ce5774a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 16:40:10
17089	9d654a22-5770-4271-9615-7a52b7e52ba4	9d654a22-5cce-4771-a031-56456ce5774a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 16:40:10
17090	9d654a22-57be-42b3-b768-cbfe621302fa	9d654a22-5cce-4771-a031-56456ce5774a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 16:40:10
17091	9d654a22-5b6d-4ce9-ba44-df67d4044dca	9d654a22-5cce-4771-a031-56456ce5774a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 16:40:10
10108	9d56c89d-8e6e-4c12-bc1e-2926833c9fff	9d56c89d-d862-448b-9092-e9fb25fa822f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 11:36:25
10109	9d56c89d-d26a-4314-9bec-7bd5afaacfe9	9d56c89d-d862-448b-9092-e9fb25fa822f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"151.55","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:36:25
10110	9d56c89d-d2be-4f3a-a059-8add1ae6e520	9d56c89d-d862-448b-9092-e9fb25fa822f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:36:25
10111	9d56c89d-d6df-4813-abff-4a1ec521c419	9d56c89d-d862-448b-9092-e9fb25fa822f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 11:36:25
10112	9d56c89d-d734-4c79-9469-fd3db1694be7	9d56c89d-d862-448b-9092-e9fb25fa822f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":366,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:36:25
17092	9d654a22-5bca-4627-8333-74cc5a253242	9d654a22-5cce-4771-a031-56456ce5774a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:40:10
22870	9d67fcf9-e2c1-4a6e-82e1-c1768bfb154a	9d67fcf9-edac-4655-a15b-6aa451623bd1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (70, 1, 430000, 107500, 'Pendiente', 'N\\/A', '12-11-2024', 12, 0, 0, '2024-11-04 00:51:54', '2024-11-04 00:51:54')","time":"3.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 00:51:54
22871	9d67fcf9-e2f2-4370-a307-6e6f2edf4ec7	9d67fcf9-edac-4655-a15b-6aa451623bd1	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 00:51:54
22872	9d67fcf9-e382-431f-9903-ca578e81d71f	9d67fcf9-edac-4655-a15b-6aa451623bd1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (70, 2, 430000, 107500, 'Pendiente', 'N\\/A', '20-11-2024', 12, 0, 0, '2024-11-04 00:51:54', '2024-11-04 00:51:54')","time":"0.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 00:51:54
22873	9d67fcf9-e3b0-4ba5-af84-55a73efcf5dc	9d67fcf9-edac-4655-a15b-6aa451623bd1	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 00:51:54
22874	9d67fcf9-e435-4e73-917c-5911e63dfbe0	9d67fcf9-edac-4655-a15b-6aa451623bd1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (70, 3, 430000, 107500, 'Pendiente', 'N\\/A', '28-11-2024', 12, 0, 0, '2024-11-04 00:51:54', '2024-11-04 00:51:54')","time":"0.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 00:51:54
22875	9d67fcf9-e462-48d9-8dbc-9afa7e6dac64	9d67fcf9-edac-4655-a15b-6aa451623bd1	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 00:51:54
22876	9d67fcf9-e4e8-4344-810e-061c3edef591	9d67fcf9-edac-4655-a15b-6aa451623bd1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (70, 4, 430000, 107500, 'Pendiente', 'N\\/A', '06-12-2024', 12, 0, 0, '2024-11-04 00:51:54', '2024-11-04 00:51:54')","time":"0.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 00:51:54
22877	9d67fcf9-e51b-4c88-b31e-2d8ce6ae646c	9d67fcf9-edac-4655-a15b-6aa451623bd1	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 00:51:54
13468	9d5d0031-9fce-4a6b-97a3-cfc5ee4881cf	9d5d0031-a3ce-4efe-858a-e0dcced08874	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":182,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:46:47
22878	9d67fcf9-e5a9-4d14-94a1-2d857d3afc07	9d67fcf9-edac-4655-a15b-6aa451623bd1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (70, 5, 430000, 107500, 'Pendiente', 'N\\/A', '14-12-2024', 12, 0, 0, '2024-11-04 00:51:54', '2024-11-04 00:51:54')","time":"0.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 00:51:54
22879	9d67fcf9-e5d6-49ec-a47e-67b6122afd2b	9d67fcf9-edac-4655-a15b-6aa451623bd1	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 00:51:54
22880	9d67fcf9-eb8f-406b-9a86-cb29e40b000c	9d67fcf9-edac-4655-a15b-6aa451623bd1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 00:51:54
22881	9d67fcf9-ebfe-4f49-88d9-f9d7c6903843	9d67fcf9-edac-4655-a15b-6aa451623bd1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"801","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"1004655468","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_valor_prestado":"2150000","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":19,"user_recomendacion":14,"loans_inicio_pago":"Mon Nov 04 2024","created_at":null,"updated_at":null,"deleted_at":null,"loans_pago_prestado":0,"loans_pago_interes":0},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Mon Nov 04 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":70},"duration":414,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:51:54
23143	9d688b3a-f78b-4461-aa40-b376ca8f8e7f	9d688b3a-fc9f-4852-9bb0-72dfd46f8d28	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":238,"memory":20,"hostname":"EderCortes"}	2024-11-04 07:29:40
22882	9d67fd26-4aa4-4376-b077-0209c980b585	9d67fd26-8fb4-4435-a9b2-48676ece3b71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 00:52:23
13475	9d5d009d-4cff-42f0-b902-a3e009e1b3a5	9d5d009d-504f-4d44-9d95-e132c59d1aaf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":169,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:47:58
22883	9d67fd26-8b74-4ae9-852b-e811af39394d	9d67fd26-8fb4-4435-a9b2-48676ece3b71	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"146.83","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 00:52:23
22884	9d67fd26-8e6b-49bc-9f2a-c0f2e998c6f6	9d67fd26-8fb4-4435-a9b2-48676ece3b71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 00:52:23
22885	9d67fd26-8ec0-4ad9-a92c-fbb9a58c042e	9d67fd26-8fb4-4435-a9b2-48676ece3b71	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":418,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:52:23
22886	9d67fd29-c7b7-4f97-b735-f88b6949a976	9d67fd2a-0f8f-48a2-99c1-c772a7185acb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 00:52:25
13481	9d5d00d6-c4eb-4fa8-b8f7-c91e0f50a475	9d5d00d6-ca5a-4493-8e07-61ff48ca63f5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":249,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:48:35
22887	9d67fd2a-056e-468d-81b1-a867de299d54	9d67fd2a-0f8f-48a2-99c1-c772a7185acb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 70\\n                        ","time":"145.22","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"40345ecc36d5b014fbb2cca663c7c347","hostname":"EderCortes"}	2024-11-04 00:52:25
22888	9d67fd2a-0965-4f2c-a3d3-7fa92e1430c6	9d67fd2a-0f8f-48a2-99c1-c772a7185acb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '70' order by \\"item_loans\\".\\"id\\" asc","time":"2.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 00:52:25
22889	9d67fd2a-09a4-4333-8ae1-3e5261ad7fdb	9d67fd2a-0f8f-48a2-99c1-c772a7185acb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 00:52:25
22890	9d67fd2a-0e05-4cef-8044-66cfd6330136	9d67fd2a-0f8f-48a2-99c1-c772a7185acb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 00:52:25
22891	9d67fd2a-0e5b-469f-a088-17724ee57bdd	9d67fd2a-0f8f-48a2-99c1-c772a7185acb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/70","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":70,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":2150000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":248,"loans_codigo":70,"itemloans_cuota":"1","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":249,"loans_codigo":70,"itemloans_cuota":"2","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":250,"loans_codigo":70,"itemloans_cuota":"3","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":251,"loans_codigo":70,"itemloans_cuota":"4","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":252,"loans_codigo":70,"itemloans_cuota":"5","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":334,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:52:25
13487	9d5d0119-4d83-4cc1-86a2-fb13921f52a5	9d5d0119-517d-49a0-9085-dca3acd3cb0a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":275,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:49:19
22892	9d67fd39-c368-4acd-8030-1b0f6ee095dd	9d67fd39-c70c-4e8b-8f18-d729792e1d29	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":147,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:52:36
23158	9d688c87-37ab-4017-81e7-7a8a7680d705	9d688c87-3c35-45dd-bc93-8955ff113391	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":222,"memory":20,"hostname":"EderCortes"}	2024-11-04 07:33:18
17185	9d654fbd-80e7-418e-b6a1-d1d82df7c6f3	9d654fbd-ad24-48cf-b8a1-780c09255216	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 16:55:50
17186	9d654fbd-aa95-412b-9756-f47477d77083	9d654fbd-ad24-48cf-b8a1-780c09255216	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:55:50
17187	9d654fbd-abd8-4529-9787-6e00e7ec0de8	9d654fbd-ad24-48cf-b8a1-780c09255216	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":338,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:55:50
22893	9d67fd3a-7b81-461e-8b4b-d2a3463a95c0	9d67fd3a-9c9a-4ea6-90e1-64e6f5b5be77	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 00:52:36
17188	9d654fbe-465e-440f-adf9-0346ee5dac52	9d654fbe-66cb-44c2-af03-55f88797af28	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:55:51
9123	9d52f441-42bc-4a6c-84f0-0748f8a68c34	9d52f441-8c71-47e8-8440-32d4a7d5eb2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-24 13:55:07
9124	9d52f441-8aa9-428b-9672-20df5bd9addb	9d52f441-8c71-47e8-8440-32d4a7d5eb2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-24 13:55:08
9125	9d52f441-8b78-46f2-b574-f9fc8d2d361d	9d52f441-8c71-47e8-8440-32d4a7d5eb2b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":400,"memory":22,"hostname":"EderCortes"}	2024-10-24 13:55:08
13493	9d5d0145-a69f-4198-a5c5-43542b1e2964	9d5d0145-aae1-4024-83fe-81cb332adf9a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":189,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:49:48
17189	9d654fbe-60bc-432f-8327-145c63eee149	9d654fbe-66cb-44c2-af03-55f88797af28	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"49.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":46,"hash":"fb4ded687569d92428336ceae5c6ffcd","hostname":"EderCortes"}	2024-11-02 16:55:51
17190	9d654fbe-653f-4439-8fd6-16368946f9aa	9d654fbe-66cb-44c2-af03-55f88797af28	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 16:55:51
17191	9d654fbe-65b0-4c7d-9251-a245247a0edb	9d654fbe-66cb-44c2-af03-55f88797af28	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":434,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:55:51
22894	9d67fd3a-9190-457c-a978-ccd85eb97403	9d67fd3a-9c9a-4ea6-90e1-64e6f5b5be77	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 248 limit 1","time":"2.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 00:52:36
22895	9d67fd3a-91d7-4d4e-b0bb-acb6b88fa0ea	9d67fd3a-9c9a-4ea6-90e1-64e6f5b5be77	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 00:52:36
22896	9d67fd3a-9353-4c6b-abf3-84ae7e0b330d	9d67fd3a-9c9a-4ea6-90e1-64e6f5b5be77	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 70 limit 1","time":"1.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 00:52:36
22897	9d67fd3a-9383-4a6f-9d9c-a378659ab91b	9d67fd3a-9c9a-4ea6-90e1-64e6f5b5be77	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 00:52:36
22898	9d67fd3a-9734-4a6b-8c6a-e6ad4fc1a095	9d67fd3a-9c9a-4ea6-90e1-64e6f5b5be77	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '107500', \\"itemloans_cuota_cancelada\\" = '430000', \\"updated_at\\" = '2024-11-04 00:52:36' where \\"id\\" = 248","time":"7.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":400,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 00:52:36
22899	9d67fd3a-97a0-4078-983a-afd0cd7be2b8	9d67fd3a-9c9a-4ea6-90e1-64e6f5b5be77	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:248","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 00:52:36","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"107500","itemloans_cuota_cancelada":"430000"},"hostname":"EderCortes"}	2024-11-04 00:52:36
22900	9d67fd3a-9839-45b5-b9a9-94a61613dce8	9d67fd3a-9c9a-4ea6-90e1-64e6f5b5be77	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 107500, \\"loans_pago_prestado\\" = 430000, \\"updated_at\\" = '2024-11-04 00:52:36' where \\"id\\" = 70","time":"0.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":408,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 00:52:36
22901	9d67fd3a-9869-4fd2-8f9f-94649bff9d13	9d67fd3a-9c9a-4ea6-90e1-64e6f5b5be77	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:70","changes":{"updated_at":"2024-11-04 00:52:36","loans_pago_interes":107500,"loans_pago_prestado":430000},"hostname":"EderCortes"}	2024-11-04 00:52:36
22902	9d67fd3a-9b50-46ec-baf6-61099db87abf	9d67fd3a-9c9a-4ea6-90e1-64e6f5b5be77	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 00:52:36
17192	9d654fc0-7541-4d9a-940a-5c29869b7939	9d654fc0-bc37-4bf7-945c-c45c5a7f24d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 16:55:52
13500	9d5d01a5-9817-408c-97f3-78af08d50e8e	9d5d01a5-9ba5-4f24-a672-b472c87421ba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":152,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:50:51
17193	9d654fc0-b70e-4d05-9264-7db0ad88540c	9d654fc0-bc37-4bf7-945c-c45c5a7f24d9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"146.65","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 16:55:52
17194	9d654fc0-b75e-47c6-9a6b-440688f9c928	9d654fc0-bc37-4bf7-945c-c45c5a7f24d9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 16:55:52
17195	9d654fc0-babe-4002-99b7-a3995f5dc2d3	9d654fc0-bc37-4bf7-945c-c45c5a7f24d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 16:55:52
17196	9d654fc0-bb0a-444f-8769-afe434b949ee	9d654fc0-bc37-4bf7-945c-c45c5a7f24d9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":387,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:55:52
22903	9d67fd3a-9b92-4383-881f-49bc2cf8d0e9	9d67fd3a-9c9a-4ea6-90e1-64e6f5b5be77	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"180","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"107500","itemloans_cuota_cancelada":"430000","id":248,"loans_codigo":70,"itemloans_cuota":"1","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:52:36
13501	9d5d01a5-ff5f-435c-8e58-e1e119d03e36	9d5d01a6-5298-41ed-8614-2fc38b93ea98	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 13:50:51
13502	9d5d01a6-46c4-4765-aff1-1b3988d1bd06	9d5d01a6-5298-41ed-8614-2fc38b93ea98	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta', 'De las nieve', 'ds', 'CC', '100465546', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '500000', 25, 7, 'Q', null, '2024-11-12T05:00:00.000Z', 'Pendiente', '312596295', 12, 14, 18, 14, '2024-11-12T05:00:00.000Z', '2024-10-29 13:50:51', '2024-10-29 13:50:51') returning \\"id\\"","time":"4.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":111,"hash":"bfad4cea82a73099ff0b3164dd496ca0","hostname":"EderCortes"}	2024-10-29 13:50:51
13503	9d5d01a6-473c-4673-bffd-6bc1ec1e6dbd	9d5d01a6-5298-41ed-8614-2fc38b93ea98	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:39","hostname":"EderCortes"}	2024-10-29 13:50:51
13504	9d5d01a6-48fd-4693-8c5f-a97c14cd858f	9d5d01a6-5298-41ed-8614-2fc38b93ea98	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (39, 1, 71428.571428571, 10416.666666667, 'Pendiente', 'N\\/A', '13-11-2024', 12, '2024-10-29 13:50:51', '2024-10-29 13:50:51')","time":"2.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 13:50:51
13505	9d5d01a6-4926-46c5-8b65-c8865626a377	9d5d01a6-5298-41ed-8614-2fc38b93ea98	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 13:50:51
13506	9d5d01a6-499a-4b6f-afb9-dd603d24d7a7	9d5d01a6-5298-41ed-8614-2fc38b93ea98	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (39, 2, 71428.571428571, 10416.666666667, 'Pendiente', 'N\\/A', '28-11-2024', 12, '2024-10-29 13:50:51', '2024-10-29 13:50:51')","time":"0.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 13:50:51
13507	9d5d01a6-49bc-4e69-a2b2-d52f732feaae	9d5d01a6-5298-41ed-8614-2fc38b93ea98	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 13:50:51
13508	9d5d01a6-4a24-452e-a531-7da55f44f4e2	9d5d01a6-5298-41ed-8614-2fc38b93ea98	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (39, 3, 71428.571428571, 10416.666666667, 'Pendiente', 'N\\/A', '13-12-2024', 12, '2024-10-29 13:50:51', '2024-10-29 13:50:51')","time":"0.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 13:50:51
13509	9d5d01a6-4a43-45de-8187-fd2f2687c3b6	9d5d01a6-5298-41ed-8614-2fc38b93ea98	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 13:50:51
13510	9d5d01a6-4aa7-4984-9b6a-855ca4629e93	9d5d01a6-5298-41ed-8614-2fc38b93ea98	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (39, 4, 71428.571428571, 10416.666666667, 'Pendiente', 'N\\/A', '28-12-2024', 12, '2024-10-29 13:50:51', '2024-10-29 13:50:51')","time":"0.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 13:50:51
13511	9d5d01a6-4ac6-452f-8df8-2db0d021ddee	9d5d01a6-5298-41ed-8614-2fc38b93ea98	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 13:50:51
13512	9d5d01a6-4b32-4741-84a2-619935410f26	9d5d01a6-5298-41ed-8614-2fc38b93ea98	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (39, 5, 71428.571428571, 10416.666666667, 'Pendiente', 'N\\/A', '12-01-2025', 12, '2024-10-29 13:50:51', '2024-10-29 13:50:51')","time":"0.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 13:50:51
13513	9d5d01a6-4b52-401a-af9a-301bb357866e	9d5d01a6-5298-41ed-8614-2fc38b93ea98	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 13:50:51
13514	9d5d01a6-4bb5-40e0-a5b6-8b2415e42851	9d5d01a6-5298-41ed-8614-2fc38b93ea98	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (39, 6, 71428.571428571, 10416.666666667, 'Pendiente', 'N\\/A', '27-01-2025', 12, '2024-10-29 13:50:51', '2024-10-29 13:50:51')","time":"0.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 13:50:51
13515	9d5d01a6-4bd4-41a5-a260-1ba8ceeae184	9d5d01a6-5298-41ed-8614-2fc38b93ea98	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 13:50:51
13516	9d5d01a6-4c32-4323-bc8a-340b69276166	9d5d01a6-5298-41ed-8614-2fc38b93ea98	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (39, 7, 71428.571428571, 10416.666666667, 'Pendiente', 'N\\/A', '11-02-2025', 12, '2024-10-29 13:50:51', '2024-10-29 13:50:51')","time":"0.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 13:50:51
13517	9d5d01a6-4c51-4e4f-8422-6f428a220313	9d5d01a6-5298-41ed-8614-2fc38b93ea98	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 13:50:51
13518	9d5d01a6-5112-4d6a-9871-c227742bb0cd	9d5d01a6-5298-41ed-8614-2fc38b93ea98	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 13:50:51
13519	9d5d01a6-5164-48ca-926b-a4b385768489	9d5d01a6-5298-41ed-8614-2fc38b93ea98	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"757","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"100465546","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"500000","loans_intereses":25,"loans_cuotas":7,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":18,"user_recomendacion":14,"loans_inicio_pago":"2024-11-12T05:00:00.000Z","created_at":null,"updated_at":null,"deleted_at":null},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Tue Oct 29 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":39},"duration":366,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:50:51
22904	9d67fd3a-e2f0-4f0d-9e6a-ad63c5671dc1	9d67fd3b-00c8-40e2-9d6d-8f316721fdfc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 00:52:36
22905	9d67fd3a-f7cc-4fbb-9252-cca7a0de17a5	9d67fd3b-00c8-40e2-9d6d-8f316721fdfc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 70\\n                        ","time":"41.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"40345ecc36d5b014fbb2cca663c7c347","hostname":"EderCortes"}	2024-11-04 00:52:36
22906	9d67fd3a-fb6d-442c-b39d-4582f84bae12	9d67fd3b-00c8-40e2-9d6d-8f316721fdfc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '70' order by \\"item_loans\\".\\"id\\" asc","time":"2.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 00:52:36
22907	9d67fd3a-fb9d-44d9-a38e-c81fb4645d10	9d67fd3b-00c8-40e2-9d6d-8f316721fdfc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 00:52:36
22908	9d67fd3a-ff8a-45be-933e-2a6274439d5f	9d67fd3b-00c8-40e2-9d6d-8f316721fdfc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 00:52:36
22909	9d67fd3a-ffd5-4f4f-b77a-d89964087708	9d67fd3b-00c8-40e2-9d6d-8f316721fdfc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/70","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":70,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":2150000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"430000","loans_pago_interes":"107500"},"items":[{"id":248,"loans_codigo":70,"itemloans_cuota":"1","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:52:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"107500","itemloans_cuota_cancelada":"430000"},{"id":249,"loans_codigo":70,"itemloans_cuota":"2","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":250,"loans_codigo":70,"itemloans_cuota":"3","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":251,"loans_codigo":70,"itemloans_cuota":"4","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":252,"loans_codigo":70,"itemloans_cuota":"5","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:52:36
13520	9d5d01df-42e4-4d9c-809f-3aff2e4e6ef0	9d5d01df-46a0-412b-86a3-88c6ffa159e6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":185,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:51:29
22910	9d67fd5b-29a6-4b45-95d8-b14b78ba3a82	9d67fd5b-2d1d-46cb-a779-f15dd7a81f89	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":144,"memory":20,"hostname":"EderCortes"}	2024-11-04 00:52:58
19440	9d66d67d-4062-4b90-839f-5cc1abcadc04	9d66d67d-4333-4f1a-8979-cb0a03e56e98	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":955}	2024-11-03 11:08:27
23173	9d688cb8-316a-45a0-a867-e95b8fc571d1	9d688cb8-35f2-4f8d-8eca-e082e40b68da	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":230,"memory":20,"hostname":"EderCortes"}	2024-11-04 07:33:50
10825	9d5ca41c-106c-4ed6-9a00-fbb8ece8cec5	9d5ca41d-2aea-47d9-b82d-3ffdafd74bfb	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 09:29:18
10826	9d5ca41d-28d5-43b4-8440-14e61edaa1f9	9d5ca41d-2aea-47d9-b82d-3ffdafd74bfb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 09:29:19
10827	9d5ca41d-298e-4171-837c-62a6c7e72ddd	9d5ca41d-2aea-47d9-b82d-3ffdafd74bfb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":891,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:29:19
10828	9d5ca41d-c344-49c6-b74b-6e8eed06bf95	9d5ca41e-0efe-4fbd-a2bc-ff8bbbaa77e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 09:29:19
10829	9d5ca41e-0783-4d47-8111-77a18ec46fa6	9d5ca41e-0efe-4fbd-a2bc-ff8bbbaa77e3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"150.44","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-29 09:29:19
10830	9d5ca41e-07d0-4985-be36-e13ddfc503de	9d5ca41e-0efe-4fbd-a2bc-ff8bbbaa77e3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-10-29 09:29:19
10831	9d5ca41e-0d9e-42a7-8b76-b4763173f792	9d5ca41e-0efe-4fbd-a2bc-ff8bbbaa77e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 09:29:19
10832	9d5ca41e-0de5-42b9-80e0-ea83b7d91798	9d5ca41e-0efe-4fbd-a2bc-ff8bbbaa77e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":511,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:29:19
13526	9d5d0216-ba03-4080-9326-9c6ed8bb56df	9d5d0216-bed5-4265-90d5-b63c6d69d0e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":177,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:52:05
10833	9d5ca41f-ba9f-4411-b127-28973038bc31	9d5ca41f-d81c-4e19-87db-f623428f764d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 09:29:20
10834	9d5ca41f-d308-4f43-bc86-1659405ef1ba	9d5ca41f-d81c-4e19-87db-f623428f764d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 09:29:21
10835	9d5ca41f-d353-4caa-8694-eb9d4a7e6c31	9d5ca41f-d81c-4e19-87db-f623428f764d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 09:29:21
10836	9d5ca41f-d6d3-42d0-b3e6-e437a5b67fdf	9d5ca41f-d81c-4e19-87db-f623428f764d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 09:29:21
10837	9d5ca41f-d717-4e4b-9051-08422b1b7ad6	9d5ca41f-d81c-4e19-87db-f623428f764d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":228,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:29:21
17263	9d6551bf-1da1-4b2f-bfdd-e9f77f5afd2f	9d6551bf-3a34-450d-8e01-d97ba1fb9c94	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:01:27
17264	9d6551bf-388f-4573-8cbb-3ccf412b8638	9d6551bf-3a34-450d-8e01-d97ba1fb9c94	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 17:01:27
17265	9d6551bf-392a-4295-b198-beedaa3af320	9d6551bf-3a34-450d-8e01-d97ba1fb9c94	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:01:27
13532	9d5d027e-af40-4e66-9d9c-b8ec212b11fb	9d5d027e-beb4-4ea7-8b52-2f2311c08ee4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":203,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:53:13
17266	9d6551bf-849a-4d71-9be4-e4af3fa7468a	9d6551bf-a047-4f53-8bab-6f8007ba3350	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 17:01:27
17267	9d6551bf-9b44-41b3-9cfa-db953fec3d2c	9d6551bf-a047-4f53-8bab-6f8007ba3350	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"41.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":46,"hash":"fb4ded687569d92428336ceae5c6ffcd","hostname":"EderCortes"}	2024-11-02 17:01:27
17268	9d6551bf-9f1a-4a6a-bfd2-7987921f9f8b	9d6551bf-a047-4f53-8bab-6f8007ba3350	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 17:01:27
17269	9d6551bf-9f76-4fb9-a04b-e72055914ad4	9d6551bf-a047-4f53-8bab-6f8007ba3350	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:01:27
23375	9d6895ea-5f96-468d-8efa-39ff05b217c7	9d6895ea-b01e-469a-a241-d03e26aba242	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 07:59:33
23376	9d6895ea-ade0-4254-8e10-650e7af3cbd5	9d6895ea-b01e-469a-a241-d03e26aba242	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 07:59:33
23377	9d6895ea-ae94-4772-b641-08394293eeba	9d6895ea-b01e-469a-a241-d03e26aba242	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":486,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:59:33
23378	9d6895eb-1df7-44ab-b02e-82419c4f3a6c	9d6895eb-434b-4540-81d3-168d32c482c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 07:59:33
17270	9d6551c1-025b-4a99-a062-ffeec794c33c	9d6551c1-4d49-47fa-b574-e6998148896b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 17:01:28
13538	9d5d02e2-5ee2-43c8-885c-4cabf3aadf2a	9d5d02e2-629e-4d99-8b7c-b40111fb6ef4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":245,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:54:19
17271	9d6551c1-46de-430b-b5ea-b254605c35f7	9d6551c1-4d49-47fa-b574-e6998148896b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"150.30","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 17:01:28
17272	9d6551c1-475a-43f6-a4f4-9ad7eb75bd8a	9d6551c1-4d49-47fa-b574-e6998148896b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 17:01:28
17273	9d6551c1-4bb0-407f-a333-383d81f75fde	9d6551c1-4d49-47fa-b574-e6998148896b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 17:01:28
17274	9d6551c1-4c1a-41d0-9b41-752957ae4f78	9d6551c1-4d49-47fa-b574-e6998148896b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":534,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:01:28
23379	9d6895eb-36f3-432f-99b6-da873b4b7ab0	9d6895eb-434b-4540-81d3-168d32c482c5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 69\\n                        ","time":"48.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"28d3d4f6fe6eff992a986b780c628d2e","hostname":"EderCortes"}	2024-11-04 07:59:33
23380	9d6895eb-3bcb-4288-8bc5-f7ed48c20983	9d6895eb-434b-4540-81d3-168d32c482c5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '69' order by \\"item_loans\\".\\"id\\" asc","time":"2.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 07:59:33
23381	9d6895eb-3c1a-400b-8558-1fc6e765b7d9	9d6895eb-434b-4540-81d3-168d32c482c5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 07:59:33
23382	9d6895eb-4200-4310-a08d-8ca9a7451944	9d6895eb-434b-4540-81d3-168d32c482c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 07:59:33
23383	9d6895eb-4256-4a93-aed3-e9830d66e361	9d6895eb-434b-4540-81d3-168d32c482c5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/69","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":69,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1150000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":243,"loans_codigo":69,"itemloans_cuota":"1","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T05:49:09.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":244,"loans_codigo":69,"itemloans_cuota":"2","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T05:49:09.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":245,"loans_codigo":69,"itemloans_cuota":"3","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T05:49:09.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":246,"loans_codigo":69,"itemloans_cuota":"4","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T05:49:09.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":247,"loans_codigo":69,"itemloans_cuota":"5","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T05:49:09.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":301,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:59:33
23384	9d6895ed-088a-4807-b424-7afd1d1c3076	9d6895ed-5796-490a-a8dd-2f2466f10717	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 07:59:34
23385	9d6895ed-4f31-43f2-b9db-a817e29c0757	9d6895ed-5796-490a-a8dd-2f2466f10717	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"156.28","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 07:59:35
23386	9d6895ed-4fa8-4f59-bc0e-8233fb0ced2e	9d6895ed-5796-490a-a8dd-2f2466f10717	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 07:59:35
23387	9d6895ed-559f-4f7f-8bc9-c5d734f93735	9d6895ed-5796-490a-a8dd-2f2466f10717	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 07:59:35
23388	9d6895ed-5622-4b33-a439-b0a3441689dc	9d6895ed-5796-490a-a8dd-2f2466f10717	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":534,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:59:35
13542	9d5d0410-0613-4bb0-824a-7b06e489300d	9d5d0410-0a2b-4e43-a582-f505b7ccdf0e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":189,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:57:36
13546	9d5d044f-7a16-480a-801b-06984740091d	9d5d044f-7f32-4275-a13b-64436f7431e8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":236,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:58:18
13553	9d5d04a5-403d-41cc-8654-ebba2f92ff2b	9d5d04a5-44ab-424f-97b0-c582e8687466	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":188,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:59:14
17336	9d655516-d1ab-417b-a194-40b0cef8da76	9d655516-f0b7-4549-a26e-89e9e76a608d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:10:48
17337	9d655516-ef0e-4f62-9c73-1632539d2331	9d655516-f0b7-4549-a26e-89e9e76a608d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:10:48
17338	9d655516-efa6-4ee0-8a28-4a62b1e203ba	9d655516-f0b7-4549-a26e-89e9e76a608d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":256,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:10:48
24752	9d68bd25-1d04-477b-ae97-0986cea4eb27	9d68bd25-4d9b-4208-a2a0-58111e565e59	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 09:49:14
24753	9d68bd25-4b46-4316-85e4-d13f12260fae	9d68bd25-4d9b-4208-a2a0-58111e565e59	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 09:49:14
24754	9d68bd25-4c2c-4290-8718-11f259d04f3f	9d68bd25-4d9b-4208-a2a0-58111e565e59	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":549,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:49:14
17339	9d655517-4a2e-40ea-a807-bf00c035a14e	9d655517-9069-40c0-b210-518312def5f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:10:48
24755	9d68bd25-f2ca-4c9a-ac71-6a70a5a1035b	9d68bd26-1a97-4c48-a752-6f826ba21dc2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 09:49:15
13559	9d5d04d4-4603-41b8-9fe1-3d2c8c78c1b3	9d5d04d4-499c-4a4a-a8e2-5bb0b7e90a86	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":229,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:59:45
17340	9d655517-8bf7-47ce-8b14-f58afd7c7c95	9d655517-9069-40c0-b210-518312def5f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"147.89","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":46,"hash":"fb4ded687569d92428336ceae5c6ffcd","hostname":"EderCortes"}	2024-11-02 17:10:48
17341	9d655517-8f35-4722-8920-c6db50bf5d28	9d655517-9069-40c0-b210-518312def5f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 17:10:48
17342	9d655517-8f87-41cb-8990-4452a2f9b630	9d655517-9069-40c0-b210-518312def5f0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":366,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:10:48
24171	9d68ab41-1332-460a-8421-a6e58fa7db3d	9d68ab41-3e7b-49bd-b008-91034671baae	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 08:59:13
24172	9d68ab41-3c1d-49c5-9cf7-d273e95f1ec7	9d68ab41-3e7b-49bd-b008-91034671baae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 08:59:13
24173	9d68ab41-3d10-48d2-9bcf-7f1ef05e9b25	9d68ab41-3e7b-49bd-b008-91034671baae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":402,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:59:13
17343	9d655519-8e85-4234-930a-1f750cda17b4	9d655519-ae47-453f-bb70-4da380bd1f2e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 17:10:49
24174	9d68ab41-d53b-492b-971a-8df635dc6673	9d68ab42-0f8e-45f9-bbdb-6389ded17125	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 08:59:13
13565	9d5d04f3-b085-4d3d-af73-7196bc93a900	9d5d04f3-b520-4524-9889-aedc708fdaae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":148,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:00:05
17344	9d655519-a8bc-4569-9f6b-a001579ac883	9d655519-ae47-453f-bb70-4da380bd1f2e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 17:10:50
17345	9d655519-a913-4e55-9cba-db3bb51cc12d	9d655519-ae47-453f-bb70-4da380bd1f2e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 17:10:50
17346	9d655519-acec-406c-aa64-1ce537930e20	9d655519-ae47-453f-bb70-4da380bd1f2e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 17:10:50
17347	9d655519-ad38-4b1c-8eba-ec85f466883d	9d655519-ae47-453f-bb70-4da380bd1f2e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":310,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:10:50
24175	9d68ab42-0451-4ec2-91ed-bfeb225ea53e	9d68ab42-0f8e-45f9-bbdb-6389ded17125	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"68.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 08:59:13
24176	9d68ab42-04ce-4276-bd58-bd4f27a2a5af	9d68ab42-0f8e-45f9-bbdb-6389ded17125	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 08:59:13
24177	9d68ab42-0d8e-42cb-80dc-774ffecb23d6	9d68ab42-0f8e-45f9-bbdb-6389ded17125	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 08:59:13
24178	9d68ab42-0e0f-4fc7-9fb6-daf4c302f2ca	9d68ab42-0f8e-45f9-bbdb-6389ded17125	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":442,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:59:13
24756	9d68bd26-0eda-46f9-95ee-7ca8080a6f79	9d68bd26-1a97-4c48-a752-6f826ba21dc2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 66\\n                        ","time":"57.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"f5566f306d2be9466f2c4564ce0020bd","hostname":"EderCortes"}	2024-11-04 09:49:15
24757	9d68bd26-136a-46e4-9727-101eb7f9f8fb	9d68bd26-1a97-4c48-a752-6f826ba21dc2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '66' order by \\"item_loans\\".\\"id\\" asc","time":"2.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:49:15
24758	9d68bd26-13b4-4a78-b341-53cdf6bd7b5f	9d68bd26-1a97-4c48-a752-6f826ba21dc2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 09:49:15
24179	9d68ab42-5d32-429b-a300-1564b03bb14c	9d68ab42-acdb-4ad8-9e7d-8d00e9f08cbf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 08:59:14
24180	9d68ab42-a677-47b9-86d9-46811a57411d	9d68ab42-acdb-4ad8-9e7d-8d00e9f08cbf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"153.84","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 08:59:14
11041	9d5ca7fa-087c-498a-bb7e-e2b7245648f0	9d5ca7fa-251b-42d2-bbb1-d24d48e92f54	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 09:40:07
11042	9d5ca7fa-237d-400f-8aef-98db32d29798	9d5ca7fa-251b-42d2-bbb1-d24d48e92f54	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 09:40:07
11043	9d5ca7fa-242a-47f8-99c7-7dc102389c16	9d5ca7fa-251b-42d2-bbb1-d24d48e92f54	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:40:07
24181	9d68ab42-a6e3-4862-a23d-e8843adf1d55	9d68ab42-acdb-4ad8-9e7d-8d00e9f08cbf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 08:59:14
24182	9d68ab42-ab1f-4c73-80cf-2fc480d716b7	9d68ab42-acdb-4ad8-9e7d-8d00e9f08cbf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 08:59:14
24183	9d68ab42-ab9c-40c5-b0bb-7ec12b9c1d73	9d68ab42-acdb-4ad8-9e7d-8d00e9f08cbf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":384,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:59:14
24759	9d68bd26-1934-465c-a374-4be0ea53a96d	9d68bd26-1a97-4c48-a752-6f826ba21dc2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 09:49:15
24760	9d68bd26-1998-43bc-b29b-984792dc1e8a	9d68bd26-1a97-4c48-a752-6f826ba21dc2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/66","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":66,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":5000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"5000000","loans_pago_interes":"1250000"},"items":[{"id":217,"loans_codigo":66,"itemloans_cuota":"1","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:26.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":218,"loans_codigo":66,"itemloans_cuota":"2","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":219,"loans_codigo":66,"itemloans_cuota":"3","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":220,"loans_codigo":66,"itemloans_cuota":"4","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:33.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":221,"loans_codigo":66,"itemloans_cuota":"5","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":222,"loans_codigo":66,"itemloans_cuota":"6","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:39.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":223,"loans_codigo":66,"itemloans_cuota":"7","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:42.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":224,"loans_codigo":66,"itemloans_cuota":"8","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:46.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":225,"loans_codigo":66,"itemloans_cuota":"9","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-31 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:50.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":226,"loans_codigo":66,"itemloans_cuota":"10","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:31:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"}]}},"duration":474,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:49:15
11044	9d5ca7fa-6d42-4ca0-9ca4-ff79dbb63b37	9d5ca7fa-8667-44f3-ad95-5180b7355845	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 09:40:07
11045	9d5ca7fa-827e-4f63-bf93-4486f72860d7	9d5ca7fa-8667-44f3-ad95-5180b7355845	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"42.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-29 09:40:07
11046	9d5ca7fa-8529-41b9-9c56-666997ce63d6	9d5ca7fa-8667-44f3-ad95-5180b7355845	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 09:40:07
11047	9d5ca7fa-8588-4ecc-baef-f048c57a1497	9d5ca7fa-8667-44f3-ad95-5180b7355845	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":215,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:40:07
24184	9d68ab45-1a7e-4295-803b-4c9ee4291fff	9d68ab45-55c0-4628-ba81-fffa45e019ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 08:59:15
24185	9d68ab45-4b81-424e-b1e0-79a92aa38d03	9d68ab45-55c0-4628-ba81-fffa45e019ce	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"91.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 08:59:16
24186	9d68ab45-4c90-4604-adc9-f87b474d2ce4	9d68ab45-55c0-4628-ba81-fffa45e019ce	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 08:59:16
24187	9d68ab45-53e5-4268-8f72-80dbb5283c84	9d68ab45-55c0-4628-ba81-fffa45e019ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 08:59:16
24188	9d68ab45-5463-4ae5-b8ce-9fcff26b2a5b	9d68ab45-55c0-4628-ba81-fffa45e019ce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":505,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:59:16
24189	9d68b1d0-69db-4763-a5cd-fe5510173784	9d68b1d0-b70f-42d7-82eb-4c3cfe00e2fc	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 09:17:33
24190	9d68b1d0-b1f3-4e27-99b2-65b6ce76f29a	9d68b1d0-b70f-42d7-82eb-4c3cfe00e2fc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"150.42","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 09:17:34
9300	9d52f706-0b4d-4188-94dd-2ef0b5c5ca85	9d52f706-44a4-40d5-bbec-0b2812ac6aac	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 14:02:52
9301	9d52f706-41cb-47b4-a7dc-3e3162ad9dc6	9d52f706-44a4-40d5-bbec-0b2812ac6aac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 14:02:52
9302	9d52f706-4357-4189-b87f-72be09c2cfe1	9d52f706-44a4-40d5-bbec-0b2812ac6aac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":419,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:02:52
24191	9d68b1d0-b576-4a03-960b-27fdd009af92	9d68b1d0-b70f-42d7-82eb-4c3cfe00e2fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 09:17:34
24192	9d68b1d0-b5e4-40b7-994f-8260ffb6a61f	9d68b1d0-b70f-42d7-82eb-4c3cfe00e2fc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":401,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:17:34
24852	9d68bd9c-9bb6-4e59-9f43-2d257c4b2747	9d68bd9c-bffa-43e9-921d-86b892e55404	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 09:50:33
24853	9d68bd9c-bdfb-4091-b1d9-ba1b5856831e	9d68bd9c-bffa-43e9-921d-86b892e55404	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 09:50:33
24854	9d68bd9c-beba-463f-b66d-5c557d776f33	9d68bd9c-bffa-43e9-921d-86b892e55404	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":374,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:50:33
11048	9d5ca7fc-21cd-47e9-870c-2842ac2efbf9	9d5ca7fc-3eb8-4de9-afee-7e3c87ef9fee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 09:40:08
11049	9d5ca7fc-3991-4ec4-ba00-69a73e1e8366	9d5ca7fc-3eb8-4de9-afee-7e3c87ef9fee	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 09:40:08
11050	9d5ca7fc-39de-4cb1-9603-3d70818b7133	9d5ca7fc-3eb8-4de9-afee-7e3c87ef9fee	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 09:40:08
11051	9d5ca7fc-3d80-4660-9750-0abc6a788e41	9d5ca7fc-3eb8-4de9-afee-7e3c87ef9fee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 09:40:08
11052	9d5ca7fc-3dcc-41dc-8232-b227ae11c270	9d5ca7fc-3eb8-4de9-afee-7e3c87ef9fee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:40:08
13571	9d5d065e-4889-406f-a1f1-0b50814dc0c1	9d5d065e-4c6a-4e99-9b61-2e5d25525ed5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":237,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:04:03
24193	9d68b1d4-6083-4bb6-9055-60d5eaf8acbf	9d68b1d4-7eec-4226-9c3a-19b07610c167	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 09:17:36
24194	9d68b1d4-75fa-49b2-b03c-56b073e54953	9d68b1d4-7eec-4226-9c3a-19b07610c167	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 69\\n                        ","time":"42.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"28d3d4f6fe6eff992a986b780c628d2e","hostname":"EderCortes"}	2024-11-04 09:17:36
24195	9d68b1d4-79a9-485d-a6b8-3d866fc292b2	9d68b1d4-7eec-4226-9c3a-19b07610c167	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '69' order by \\"item_loans\\".\\"id\\" asc","time":"1.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:17:36
24196	9d68b1d4-79e0-4e11-9dd4-c7bcb583c9b5	9d68b1d4-7eec-4226-9c3a-19b07610c167	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 09:17:36
24197	9d68b1d4-7daf-4b8b-9adb-3ec5afbc40d7	9d68b1d4-7eec-4226-9c3a-19b07610c167	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 09:17:36
24855	9d68bd9d-4593-4936-b9f0-af3894b3c842	9d68bd9d-64c8-4b60-b5d5-1a913de8224d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 09:50:33
17422	9d655a1f-8023-4012-876d-55d7edef5947	9d655a1f-ac0c-42fa-869d-32b0f033638c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 17:24:52
17423	9d655a1f-a9a4-4462-842a-b583f089825e	9d655a1f-ac0c-42fa-869d-32b0f033638c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:24:52
17424	9d655a1f-aaaa-4876-9b94-d01faaabb527	9d655a1f-ac0c-42fa-869d-32b0f033638c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":329,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:24:52
13576	9d5d069a-de10-4548-b21b-eec33d3fd312	9d5d069a-e186-4423-b401-069b7c51cf8b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":196,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:04:43
17425	9d655a20-4dd0-4f60-8611-c7b204c9125c	9d655a20-9cfa-4dae-8034-51113a3a70e6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:24:53
17426	9d655a20-96d1-4861-9884-50405e647100	9d655a20-9cfa-4dae-8034-51113a3a70e6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"166.37","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":46,"hash":"fb4ded687569d92428336ceae5c6ffcd","hostname":"EderCortes"}	2024-11-02 17:24:53
17427	9d655a20-9b6e-40bf-8d2f-9722ea990d72	9d655a20-9cfa-4dae-8034-51113a3a70e6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:24:53
17428	9d655a20-9be2-4471-be98-9c34909dd5d8	9d655a20-9cfa-4dae-8034-51113a3a70e6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":578,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:24:53
24198	9d68b1d4-7e00-4623-b8bd-43fdd28f887f	9d68b1d4-7eec-4226-9c3a-19b07610c167	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/69","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":69,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1150000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1080000","loans_pago_interes":"270000"},"items":[{"id":243,"loans_codigo":69,"itemloans_cuota":"1","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T13:01:48.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000"},{"id":244,"loans_codigo":69,"itemloans_cuota":"2","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T13:01:54.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000"},{"id":245,"loans_codigo":69,"itemloans_cuota":"3","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T13:02:55.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000"},{"id":246,"loans_codigo":69,"itemloans_cuota":"4","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T13:03:00.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000"},{"id":247,"loans_codigo":69,"itemloans_cuota":"5","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T13:11:47.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"40000","itemloans_cuota_cancelada":"160000"},{"id":259,"loans_codigo":69,"itemloans_cuota":"5","itemloans_valor_cuota":"70000","itemloans_iteres":"-270000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T13:11:47.000000Z","updated_at":"2024-11-04T13:11:47.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":308,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:17:36
24856	9d68bd9d-5bc8-4b53-ab62-8217262c65b6	9d68bd9d-64c8-4b60-b5d5-1a913de8224d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 90\\n                        ","time":"44.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"93c10371e33ace24260de21c3ff3890d","hostname":"EderCortes"}	2024-11-04 09:50:33
24857	9d68bd9d-5f6a-46f9-b86f-9f2e6208b317	9d68bd9d-64c8-4b60-b5d5-1a913de8224d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"2.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:50:33
24199	9d68b1d8-efb5-4670-88ab-5ebf70628fa1	9d68b1d9-3729-4ce3-921e-7bfa8093ea95	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 09:17:39
23839	9d689d6b-e3e0-4c93-bb7c-79576699c7a8	9d689d6c-2abe-46b0-a492-13dd7469c297	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 08:20:32
23840	9d689d6c-2918-40aa-b27d-9263650e5afd	9d689d6c-2abe-46b0-a492-13dd7469c297	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 08:20:32
11920	9d5cd8d6-cb94-438f-8541-7961d449e20a	9d5cd8d7-2907-42bf-9b56-c7866844fcc0	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 11:56:45
11921	9d5cd8d7-2669-437b-9108-b90dcc3675ab	9d5cd8d7-2907-42bf-9b56-c7866844fcc0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 11:56:45
11922	9d5cd8d7-27d0-4005-ba19-f145d2579b1e	9d5cd8d7-2907-42bf-9b56-c7866844fcc0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":427,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:56:45
23841	9d689d6c-29ba-4999-a8a7-6ce13fc06faf	9d689d6c-2abe-46b0-a492-13dd7469c297	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":395,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:20:32
24200	9d68b1d9-3329-4807-b2a7-6b097123273f	9d68b1d9-3729-4ce3-921e-7bfa8093ea95	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"155.69","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 09:17:39
24201	9d68b1d9-35cb-40cf-9205-46a4b384553f	9d68b1d9-3729-4ce3-921e-7bfa8093ea95	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 09:17:39
24202	9d68b1d9-3629-45d5-996d-1dbece70b989	9d68b1d9-3729-4ce3-921e-7bfa8093ea95	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":337,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:17:39
24858	9d68bd9d-5fb2-4616-a38e-d4e504f78b08	9d68bd9d-64c8-4b60-b5d5-1a913de8224d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 09:50:33
24859	9d68bd9d-63ba-464b-b60c-0ae5fa8f807b	9d68bd9d-64c8-4b60-b5d5-1a913de8224d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 09:50:33
24860	9d68bd9d-6402-4911-9cf2-23674b8a13f7	9d68bd9d-64c8-4b60-b5d5-1a913de8224d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":379,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:50:33
11923	9d5cd8d8-33e5-4653-a1e3-26b51e10f584	9d5cd8d9-94d1-402e-90ec-d2e7340cb2f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 11:56:46
11924	9d5cd8d9-8ec5-4a1c-b168-3156d0bb45c4	9d5cd8d9-94d1-402e-90ec-d2e7340cb2f5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"151.44","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":177,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 11:56:46
11925	9d5cd8d9-8f27-4ce5-8a8f-f886188a1f15	9d5cd8d9-94d1-402e-90ec-d2e7340cb2f5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 11:56:46
11926	9d5cd8d9-93bd-45be-bd8b-ca380506b56f	9d5cd8d9-94d1-402e-90ec-d2e7340cb2f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 11:56:46
11927	9d5cd8d9-9407-4be9-acd4-39024686b1f9	9d5cd8d9-94d1-402e-90ec-d2e7340cb2f5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":1549,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:56:46
17429	9d655a22-b52c-47e7-96f1-e782c1ae1b2a	9d655a22-d24f-4522-9e7c-8bbd2f0303a8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:24:54
17430	9d655a22-cd4f-4fc8-9d36-0b7b0f30e230	9d655a22-d24f-4522-9e7c-8bbd2f0303a8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 17:24:54
17431	9d655a22-cd9d-4e59-acb0-d60571cc8d17	9d655a22-d24f-4522-9e7c-8bbd2f0303a8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 17:24:54
17432	9d655a22-d10e-4c6c-93a0-7d19ff6e1d38	9d655a22-d24f-4522-9e7c-8bbd2f0303a8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:24:54
17433	9d655a22-d155-49d9-87ca-5a00f9002530	9d655a22-d24f-4522-9e7c-8bbd2f0303a8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":222,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:24:54
23842	9d689d6c-84f4-4f4e-8787-dafc693f2fb2	9d689d6c-a447-443e-bb9d-20f5dc385652	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 08:20:32
23843	9d689d6c-9b19-4c3d-b1b3-a9331ecab96c	9d689d6c-a447-443e-bb9d-20f5dc385652	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 68\\n                        ","time":"44.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"7d9994d55cb8dde82ff4185920c79043","hostname":"EderCortes"}	2024-11-04 08:20:33
23844	9d689d6c-9ede-47f5-b408-037b303a0b33	9d689d6c-a447-443e-bb9d-20f5dc385652	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '68' order by \\"item_loans\\".\\"id\\" asc","time":"2.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:20:33
11928	9d5cd8d9-e5a5-4380-9c3a-46afac478870	9d5cd8da-3420-4bb3-b9fb-0d3ffca3a3dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 11:56:47
11929	9d5cd8da-2f33-4398-aab7-0ee21a1d0fe8	9d5cd8da-3420-4bb3-b9fb-0d3ffca3a3dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"156.27","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":177,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 11:56:47
11930	9d5cd8da-2f91-4dbf-bcd3-0f875fa47123	9d5cd8da-3420-4bb3-b9fb-0d3ffca3a3dd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 11:56:47
11931	9d5cd8da-32ef-4413-95ec-c4df479e54c4	9d5cd8da-3420-4bb3-b9fb-0d3ffca3a3dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 11:56:47
11932	9d5cd8da-3334-44f3-9b9d-8b96d89b7071	9d5cd8da-3420-4bb3-b9fb-0d3ffca3a3dd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":394,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:56:47
13581	9d5d070f-e4c6-414a-af84-54ca905d9c44	9d5d070f-e883-434c-965d-5fb3cb983a70	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":157,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:06:00
23845	9d689d6c-9f13-496c-b345-4657a94f13f4	9d689d6c-a447-443e-bb9d-20f5dc385652	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":11,"hostname":"EderCortes"}	2024-11-04 08:20:33
23846	9d689d6c-a316-4e1a-a821-092164e018c1	9d689d6c-a447-443e-bb9d-20f5dc385652	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 08:20:33
23847	9d689d6c-a36d-48b5-8c64-c46dc27f016c	9d689d6c-a447-443e-bb9d-20f5dc385652	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/68","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":68,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":10000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"10000000","loans_pago_interes":"2500000"},"items":[{"id":227,"loans_codigo":68,"itemloans_cuota":"1","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":228,"loans_codigo":68,"itemloans_cuota":"2","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:14:40.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":229,"loans_codigo":68,"itemloans_cuota":"3","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:14:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":230,"loans_codigo":68,"itemloans_cuota":"4","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:14:49.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":231,"loans_codigo":68,"itemloans_cuota":"5","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:15:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":232,"loans_codigo":68,"itemloans_cuota":"6","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:15:25.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":233,"loans_codigo":68,"itemloans_cuota":"7","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:15:28.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":234,"loans_codigo":68,"itemloans_cuota":"8","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:15:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":235,"loans_codigo":68,"itemloans_cuota":"9","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:15:34.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":236,"loans_codigo":68,"itemloans_cuota":"10","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:20:22.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":260,"loans_codigo":68,"itemloans_cuota":"10","itemloans_valor_cuota":"0","itemloans_iteres":"-2500000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T13:20:22.000000Z","updated_at":"2024-11-04T13:20:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:20:33
24203	9d68b1de-0ac5-41ca-9f26-a7a36563e344	9d68b1de-2aac-4c35-9d07-a2d99ef98799	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 09:17:42
24204	9d68b1de-21c1-46c7-ab67-e567542aa3c6	9d68b1de-2aac-4c35-9d07-a2d99ef98799	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 65\\n                        ","time":"45.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6768d7067397538897aacf4d73c43049","hostname":"EderCortes"}	2024-11-04 09:17:42
24205	9d68b1de-2585-4f32-bba1-2cd6943e2686	9d68b1de-2aac-4c35-9d07-a2d99ef98799	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '65' order by \\"item_loans\\".\\"id\\" asc","time":"2.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:17:42
24206	9d68b1de-25c2-4a8c-a50d-ed3a0ea205f2	9d68b1de-2aac-4c35-9d07-a2d99ef98799	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 09:17:42
24207	9d68b1de-2971-4abe-86f7-c1c42076362c	9d68b1de-2aac-4c35-9d07-a2d99ef98799	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 09:17:42
24208	9d68b1de-29c0-4a93-8742-b1f77276a967	9d68b1de-2aac-4c35-9d07-a2d99ef98799	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/65","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":65,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":3000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-10 00:00:00","loans_pago_prestado":"1669230.7692308","loans_pago_interes":"500769.23076923"},"items":[{"id":207,"loans_codigo":65,"itemloans_cuota":"1","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:46:55.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"90000","itemloans_cuota_cancelada":"300000"},{"id":208,"loans_codigo":65,"itemloans_cuota":"2","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-04T05:39:56.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"90000","itemloans_cuota_cancelada":"300000"},{"id":209,"loans_codigo":65,"itemloans_cuota":"3","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-04T05:40:07.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"90000","itemloans_cuota_cancelada":"300000"},{"id":210,"loans_codigo":65,"itemloans_cuota":"4","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-04T05:43:06.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"230769.23076923","itemloans_cuota_cancelada":"769230.76923077"},{"id":237,"loans_codigo":65,"itemloans_cuota":"5","itemloans_valor_cuota":"221794.87179487","itemloans_iteres":"-83461.538461538","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:43:06.000000Z","updated_at":"2024-11-04T05:43:06.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"230769.23076923","itemloans_cuota_cancelada":"769230.76923077"},{"id":238,"loans_codigo":65,"itemloans_cuota":"6","itemloans_valor_cuota":"221794.87179487","itemloans_iteres":"-83461.538461538","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:43:06.000000Z","updated_at":"2024-11-04T05:43:06.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"230769.23076923","itemloans_cuota_cancelada":"769230.76923077"},{"id":239,"loans_codigo":65,"itemloans_cuota":"7","itemloans_valor_cuota":"221794.87179487","itemloans_iteres":"-83461.538461538","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:43:06.000000Z","updated_at":"2024-11-04T05:43:06.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"230769.23076923","itemloans_cuota_cancelada":"769230.76923077"},{"id":240,"loans_codigo":65,"itemloans_cuota":"8","itemloans_valor_cuota":"221794.87179487","itemloans_iteres":"-83461.538461538","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:43:06.000000Z","updated_at":"2024-11-04T05:43:06.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"230769.23076923","itemloans_cuota_cancelada":"769230.76923077"},{"id":241,"loans_codigo":65,"itemloans_cuota":"9","itemloans_valor_cuota":"221794.87179487","itemloans_iteres":"-83461.538461538","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-04-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:43:06.000000Z","updated_at":"2024-11-04T05:43:06.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"230769.23076923","itemloans_cuota_cancelada":"769230.76923077"},{"id":242,"loans_codigo":65,"itemloans_cuota":"10","itemloans_valor_cuota":"221794.87179487","itemloans_iteres":"-83461.538461538","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-05-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:43:06.000000Z","updated_at":"2024-11-04T05:43:06.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"230769.23076923","itemloans_cuota_cancelada":"769230.76923077"}]}},"duration":325,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:17:42
23848	9d689d6e-895d-4538-915c-baccbb749700	9d689d6e-adae-43cd-941a-307d1f47fdb7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 08:20:34
23849	9d689d6e-a6fa-4c87-821b-8788b8fd16d9	9d689d6e-adae-43cd-941a-307d1f47fdb7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"48.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 08:20:34
23850	9d689d6e-a75d-45e2-8238-f5070c02d8ca	9d689d6e-adae-43cd-941a-307d1f47fdb7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 08:20:34
23851	9d689d6e-ac18-498d-ac89-162447035cd9	9d689d6e-adae-43cd-941a-307d1f47fdb7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 08:20:34
23852	9d689d6e-ac76-4717-a3c0-6571fe0f5d2c	9d689d6e-adae-43cd-941a-307d1f47fdb7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":405,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:20:34
13586	9d5d0804-a539-4355-afdb-0e561c5d7efd	9d5d0804-aafc-4632-a767-b2f551a4ba26	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":258,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:08:40
23853	9d68a028-1258-46c1-a3b2-37f14f6f043c	9d68a028-3b46-42be-a016-15da75c3fccb	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 08:28:11
23854	9d68a028-325c-4976-ab09-a12ad2f0bca3	9d68a028-3b46-42be-a016-15da75c3fccb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"50.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 08:28:11
23855	9d68a028-38e2-4450-902c-427c279e1b60	9d68a028-3b46-42be-a016-15da75c3fccb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 08:28:11
23856	9d68a028-399e-4609-bb4b-4c478187ad27	9d68a028-3b46-42be-a016-15da75c3fccb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":346,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:28:11
24209	9d68b1fb-41e0-4d7a-b641-a2642bea60f4	9d68b1fb-4545-4220-a4ff-1653f8b8f161	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":195,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:18:01
10283	9d56cd15-a440-479f-b652-aafce7e39841	9d56cd15-c919-4f89-8968-308aa4fefce3	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 11:48:54
10284	9d56cd15-c700-47e9-bafc-1cc8e81f3675	9d56cd15-c919-4f89-8968-308aa4fefce3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:48:55
10285	9d56cd15-c7f3-452c-8fbb-8c53aae7b69e	9d56cd15-c919-4f89-8968-308aa4fefce3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":305,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:48:55
23857	9d68a02d-0da7-452d-af4f-559809b8ff3b	9d68a02d-2d77-4f3c-a96c-fdd5cba7a52b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 08:28:14
6273	9d526409-5fe6-4684-ae72-adfae82535e0	9d526409-62ff-4d16-8331-016cdfe66584	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abfrom\\u00bb\\nLINE 14:     from loans l\\n             ^ (Connection: pgsql, SQL: \\n    select l.id,\\n        l.loans_documento,\\n        l.loans_nombre,\\n        l.loans_apellido_uno,\\n        l.loans_fecha,\\n        l.loans_valor_prestado,\\n        l.loans_cuotas,\\n        l.loans_estado,\\n        l.loans_intereses,\\n        ucl.name as cliente,\\n        uco.name as cobrador,\\n        ure.name as recomendador,\\n    from loans l\\n    join users ucl on l.user_customer = ucl.id\\n    join users uco on l.user_cobrador = uco.id\\n    left join users ure on l.user_recomendacion = ure.id\\n)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":320}	2024-10-24 07:11:52
10286	9d56cd16-3099-4f00-b3f5-4c4e8fad5aaf	9d56cd16-7367-4aff-b27f-d6a5640fecb5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:48:55
10287	9d56cd16-6ec7-4ba7-ac6b-4b088f7b85bc	9d56cd16-7367-4aff-b27f-d6a5640fecb5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"145.81","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:48:55
10288	9d56cd16-7269-471c-bc1a-2f5dace91b3e	9d56cd16-7367-4aff-b27f-d6a5640fecb5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:48:55
10289	9d56cd16-72aa-4931-a2c7-6332af50ac80	9d56cd16-7367-4aff-b27f-d6a5640fecb5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":399,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:48:55
23858	9d68a02d-2425-4af9-9f63-28714b40f272	9d68a02d-2d77-4f3c-a96c-fdd5cba7a52b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 66\\n                        ","time":"44.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"f5566f306d2be9466f2c4564ce0020bd","hostname":"EderCortes"}	2024-11-04 08:28:14
23859	9d68a02d-27ea-48ea-aa9e-a0237858f9d3	9d68a02d-2d77-4f3c-a96c-fdd5cba7a52b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '66' order by \\"item_loans\\".\\"id\\" asc","time":"2.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:28:14
23860	9d68a02d-281a-45a7-adc2-03d59a4e7e8c	9d68a02d-2d77-4f3c-a96c-fdd5cba7a52b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 08:28:14
23861	9d68a02d-2c31-4938-9e7c-d558e2ac629a	9d68a02d-2d77-4f3c-a96c-fdd5cba7a52b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 08:28:14
23862	9d68a02d-2c83-4733-968c-f3e5b717469a	9d68a02d-2d77-4f3c-a96c-fdd5cba7a52b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/66","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":66,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":5000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":217,"loans_codigo":66,"itemloans_cuota":"1","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":218,"loans_codigo":66,"itemloans_cuota":"2","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":219,"loans_codigo":66,"itemloans_cuota":"3","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":220,"loans_codigo":66,"itemloans_cuota":"4","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":221,"loans_codigo":66,"itemloans_cuota":"5","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":222,"loans_codigo":66,"itemloans_cuota":"6","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":223,"loans_codigo":66,"itemloans_cuota":"7","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":224,"loans_codigo":66,"itemloans_cuota":"8","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":225,"loans_codigo":66,"itemloans_cuota":"9","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-31 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":226,"loans_codigo":66,"itemloans_cuota":"10","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":329,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:28:14
10290	9d56cd17-ec66-4f65-b534-4027dc21c8bf	9d56cd18-0969-4001-a251-56f2fd5aecb8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:48:56
10291	9d56cd18-04a7-4acc-b803-29393f06c7f7	9d56cd18-0969-4001-a251-56f2fd5aecb8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:48:56
10292	9d56cd18-04ed-4a37-bdbd-822735c000a3	9d56cd18-0969-4001-a251-56f2fd5aecb8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:48:56
10293	9d56cd18-084c-45ae-abb9-396bc6814ca6	9d56cd18-0969-4001-a251-56f2fd5aecb8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 11:48:56
10294	9d56cd18-088e-42fb-93c1-7e5906eacc00	9d56cd18-0969-4001-a251-56f2fd5aecb8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":223,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:48:56
13593	9d5d0841-6ded-4fee-a20d-e2ebea2dec0e	9d5d0841-727a-4e33-9f87-a524a21d6edb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":263,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:09:20
23863	9d68a03f-210a-4276-8ce3-addd886ac65f	9d68a03f-245a-4501-9293-25bd63c53347	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":140,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:28:26
24210	9d68b1fb-97ad-4d04-b42d-b16ad984fcf6	9d68b1fb-9af4-47b5-b35a-45563d36b37d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":140,"memory":20,"hostname":"EderCortes"}	2024-11-04 09:18:02
23864	9d68a03f-92dc-4edd-88f7-faa55a5570d1	9d68a03f-bcf6-4298-a418-db4054d8bd01	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 08:28:26
10299	9d56cd49-11ef-41a5-8881-8a47b69153e5	9d56cd49-3016-4d1f-9625-e0ec63f5e94d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 11:49:28
12451	9d5ce530-1f09-4cfe-93f3-227e67d2e04a	9d5ce530-3c70-40e3-8939-325b4eadd56d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 12:31:16
12452	9d5ce530-3b11-4c81-9db2-285018980580	9d5ce530-3c70-40e3-8939-325b4eadd56d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 12:31:16
12453	9d5ce530-3ba6-48ee-8449-a2c20fbe856f	9d5ce530-3c70-40e3-8939-325b4eadd56d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":257,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:31:16
23865	9d68a03f-b22c-47f1-b6df-56dc5d8774d2	9d68a03f-bcf6-4298-a418-db4054d8bd01	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 217 limit 1","time":"2.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 08:28:26
23866	9d68a03f-b274-4554-bbe0-d4265f00cae1	9d68a03f-bcf6-4298-a418-db4054d8bd01	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 08:28:26
23867	9d68a03f-b3fc-407d-9e89-df7c8cecd52f	9d68a03f-bcf6-4298-a418-db4054d8bd01	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 66 limit 1","time":"1.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 08:28:26
23868	9d68a03f-b42b-443f-84bb-d4dd4d6bb06f	9d68a03f-bcf6-4298-a418-db4054d8bd01	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 08:28:26
23869	9d68a03f-b637-46c3-afe7-3ee673c02725	9d68a03f-bcf6-4298-a418-db4054d8bd01	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '125000', \\"itemloans_cuota_cancelada\\" = '500000', \\"updated_at\\" = '2024-11-04 08:28:26' where \\"id\\" = 217","time":"3.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":400,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 08:28:26
23870	9d68a03f-b6c7-409e-8f76-87ed7a20d740	9d68a03f-bcf6-4298-a418-db4054d8bd01	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:217","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 08:28:26","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},"hostname":"EderCortes"}	2024-11-04 08:28:26
23871	9d68a03f-b7c5-41a1-8b22-4a7f06d9d0e8	9d68a03f-bcf6-4298-a418-db4054d8bd01	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_fecha_ultimo_pago\\" = '04-11-2024', \\"loans_pago_interes\\" = 125000, \\"loans_pago_prestado\\" = 500000, \\"updated_at\\" = '2024-11-04 08:28:26' where \\"id\\" = 66","time":"1.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":408,"hash":"138ffd5a6aae2847ac945cb6fb277db0","hostname":"EderCortes"}	2024-11-04 08:28:26
23872	9d68a03f-b815-4ece-87a5-623a5ab123b2	9d68a03f-bcf6-4298-a418-db4054d8bd01	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:66","changes":{"updated_at":"2024-11-04 08:28:26","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":125000,"loans_pago_prestado":500000},"hostname":"EderCortes"}	2024-11-04 08:28:26
23873	9d68a03f-bb2d-4768-bf29-2567044d0e52	9d68a03f-bcf6-4298-a418-db4054d8bd01	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 08:28:26
13599	9d5d0877-df1a-491d-b922-1a4d6e26157d	9d5d0877-e39b-44f3-a41a-05b73e7295eb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":208,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:09:55
23874	9d68a03f-bb8f-4bb0-abbb-3f45c6e420c6	9d68a03f-bcf6-4298-a418-db4054d8bd01	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"180","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000","id":217,"loans_codigo":66,"itemloans_cuota":"1","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":274,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:28:26
12454	9d5ce530-88b7-4aaa-889b-5cd2d61a26ce	9d5ce530-a568-4bbe-b814-32978ce9ed37	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 12:31:17
12041	9d5ce097-6aa6-4d99-aa14-0034f1a822a2	9d5ce097-8f48-42f2-8f16-cadbc06a8b79	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-29 12:18:25
12042	9d5ce097-8d79-4824-9ec6-1bf65e116e87	9d5ce097-8f48-42f2-8f16-cadbc06a8b79	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-29 12:18:25
12043	9d5ce097-8e2b-4865-899f-2b707dca3264	9d5ce097-8f48-42f2-8f16-cadbc06a8b79	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:25
12646	9d5cec87-40d4-4330-a223-4cd291a1f651	9d5cec87-76a8-4575-ab83-aca5138b5ce7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 12:51:48
12455	9d5ce530-a0c9-4cea-a304-20bc84725f9a	9d5ce530-a568-4bbe-b814-32978ce9ed37	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":180,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 12:31:17
12456	9d5ce530-a11a-4383-aa43-7f6b4ae8d2ec	9d5ce530-a568-4bbe-b814-32978ce9ed37	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 12:31:17
12457	9d5ce530-a458-46e4-9785-229d83e95332	9d5ce530-a568-4bbe-b814-32978ce9ed37	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 12:31:17
12458	9d5ce530-a496-41fc-a0f7-eda28c4d0f7f	9d5ce530-a568-4bbe-b814-32978ce9ed37	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:31:17
12647	9d5cec87-7458-41dc-a0ab-ea5ee4b4aff0	9d5cec87-76a8-4575-ab83-aca5138b5ce7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 12:51:48
12648	9d5cec87-7576-49da-ae56-40b238db34ef	9d5cec87-76a8-4575-ab83-aca5138b5ce7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":463,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:51:48
24211	9d68b1fb-f073-4fad-8027-a14c450e386b	9d68b1fb-f315-4473-974e-f6b92651ae43	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":157,"memory":20,"hostname":"EderCortes"}	2024-11-04 09:18:02
9896	9d56b608-4868-467d-a73d-65a88566e9c5	9d56b608-93a6-4ec6-a535-9bc452715590	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 10:44:27
9897	9d56b608-91cb-4000-bdf4-43877b4c2d48	9d56b608-93a6-4ec6-a535-9bc452715590	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 10:44:27
9898	9d56b608-9266-4806-9df0-30b4ab668ea6	9d56b608-93a6-4ec6-a535-9bc452715590	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":365,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:44:27
9899	9d56b608-e07b-4eb5-84e9-978035b96e1b	9d56b609-2333-48a4-8093-8c05e111ae4c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 10:44:27
9900	9d56b609-1e81-47e6-8555-14d1ef23c48a	9d56b609-2333-48a4-8093-8c05e111ae4c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"146.58","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-26 10:44:27
9901	9d56b609-21cd-44a4-9332-7dc23bcb226a	9d56b609-2333-48a4-8093-8c05e111ae4c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 10:44:28
9902	9d56b609-223d-4753-93b3-f32e56f3fa10	9d56b609-2333-48a4-8093-8c05e111ae4c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:44:28
12044	9d5ce097-e8a0-45cc-ad56-376392dba5fb	9d5ce098-0da7-4624-b9f6-61c30186d44a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-29 12:18:26
12045	9d5ce098-0633-4207-85db-32499bce12ee	9d5ce098-0da7-4624-b9f6-61c30186d44a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":177,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 12:18:26
12046	9d5ce098-0696-4dd8-8ee1-b740d5938180	9d5ce098-0da7-4624-b9f6-61c30186d44a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 12:18:26
12047	9d5ce098-0bc7-4422-9544-e10cee7ac4ac	9d5ce098-0da7-4624-b9f6-61c30186d44a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-29 12:18:26
12048	9d5ce098-0c3e-4bd0-a428-d0c71ed960d6	9d5ce098-0da7-4624-b9f6-61c30186d44a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":286,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:26
12459	9d5ce530-e962-4bb8-8a2d-aebfae32ae5b	9d5ce531-046b-4d9e-9338-7d73b8e85e93	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 12:31:17
12460	9d5ce531-0008-40b3-a0a4-a9b6dd4530fe	9d5ce531-046b-4d9e-9338-7d73b8e85e93	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"37.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":180,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 12:31:17
12461	9d5ce531-0054-48f1-8049-15504ac5d0c7	9d5ce531-046b-4d9e-9338-7d73b8e85e93	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 12:31:17
12462	9d5ce531-037d-4217-9ba6-73d3adc1eae6	9d5ce531-046b-4d9e-9338-7d73b8e85e93	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 12:31:17
12463	9d5ce531-03bb-454b-a35f-b45bebf41705	9d5ce531-046b-4d9e-9338-7d73b8e85e93	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:31:17
12649	9d5cec87-ef90-4c47-8013-c5eae1b5afeb	9d5cec88-1acb-41b6-a302-8fd9fcf7737f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 12:51:48
12650	9d5cec88-1328-4abd-adf7-c252704f134c	9d5cec88-1acb-41b6-a302-8fd9fcf7737f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"56.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":180,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 12:51:48
12651	9d5cec88-13cb-4906-ae6f-49c6d041d1ac	9d5cec88-1acb-41b6-a302-8fd9fcf7737f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 12:51:48
9903	9d56b60a-e303-454c-b21c-a0c25c0a9e90	9d56b60b-3298-47af-b6c5-bde7e4a97b59	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 10:44:29
9904	9d56b60b-23a3-459b-934a-a4aff4f997e1	9d56b60b-3298-47af-b6c5-bde7e4a97b59	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"142.28","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 10:44:29
9905	9d56b60b-2403-480f-96fb-8befdf425d39	9d56b60b-3298-47af-b6c5-bde7e4a97b59	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 10:44:29
9906	9d56b60b-3057-4f3f-bf2e-f81227aaa942	9d56b60b-3298-47af-b6c5-bde7e4a97b59	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 10:44:29
9907	9d56b60b-30e9-48d6-85de-b3b4f52c7757	9d56b60b-3298-47af-b6c5-bde7e4a97b59	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":706,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:44:29
12049	9d5ce098-6213-4d02-9138-29d8c9fff7d0	9d5ce098-81fc-40b3-8eb8-5d8c9ed4ba9b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-29 12:18:26
12050	9d5ce098-7c27-4939-ab98-77cee1253536	9d5ce098-81fc-40b3-8eb8-5d8c9ed4ba9b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":177,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 12:18:26
12051	9d5ce098-7c97-4983-accd-34f77230e7e7	9d5ce098-81fc-40b3-8eb8-5d8c9ed4ba9b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 12:18:26
12052	9d5ce098-80a8-40fe-93c8-b5dea200b009	9d5ce098-81fc-40b3-8eb8-5d8c9ed4ba9b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-29 12:18:26
12053	9d5ce098-80ea-434c-92e7-9a630cbb79c3	9d5ce098-81fc-40b3-8eb8-5d8c9ed4ba9b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:26
12464	9d5ce532-9a83-4298-b385-f1eaff6da14f	9d5ce532-c0ea-480f-821e-84880c9df31e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 12:31:18
12465	9d5ce532-b99d-46d0-8a15-ca2958b40217	9d5ce532-c0ea-480f-821e-84880c9df31e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"51.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 12:31:18
12466	9d5ce532-ba0f-4c8b-920b-8cae887f77e2	9d5ce532-c0ea-480f-821e-84880c9df31e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 12:31:18
12467	9d5ce532-bf4b-414d-a6f0-fd73702ebedb	9d5ce532-c0ea-480f-821e-84880c9df31e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 12:31:18
12468	9d5ce532-bfa8-43d5-8f7d-3068dbf1cf8d	9d5ce532-c0ea-480f-821e-84880c9df31e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":506,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:31:18
12054	9d5ce09a-5804-42df-8315-f5b49318ebfa	9d5ce09a-7abf-41b7-9b91-ad62b33ab339	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-29 12:18:27
12055	9d5ce09a-74ff-487d-ae6a-54893e93abec	9d5ce09a-7abf-41b7-9b91-ad62b33ab339	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"52.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 12:18:27
12056	9d5ce09a-7564-4921-bca6-920b0756c886	9d5ce09a-7abf-41b7-9b91-ad62b33ab339	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 12:18:27
12057	9d5ce09a-797a-46a3-8d06-beb67772b4af	9d5ce09a-7abf-41b7-9b91-ad62b33ab339	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-29 12:18:27
12058	9d5ce09a-79be-4182-935f-801c0ec3bf96	9d5ce09a-7abf-41b7-9b91-ad62b33ab339	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":541,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:27
12469	9d5ce536-5a88-4bbc-bcd0-6a4b26ad55e4	9d5ce536-5d95-4613-926b-ddee3bb2c4f8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":135,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:31:20
12652	9d5cec88-1933-4b81-86e7-ca3863d81c9c	9d5cec88-1acb-41b6-a302-8fd9fcf7737f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 12:51:48
12653	9d5cec88-1983-4cd4-9419-dee421760ba3	9d5cec88-1acb-41b6-a302-8fd9fcf7737f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":368,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:51:48
23875	9d68a040-0527-4bbb-8301-6875c0d14759	9d68a040-29c5-441f-a678-ebaadaed97d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 08:28:27
23876	9d68a040-201b-438a-81dd-618c0c652fb7	9d68a040-29c5-441f-a678-ebaadaed97d5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 66\\n                        ","time":"54.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"f5566f306d2be9466f2c4564ce0020bd","hostname":"EderCortes"}	2024-11-04 08:28:27
23877	9d68a040-2406-401c-8d55-06d04c9ff05e	9d68a040-29c5-441f-a678-ebaadaed97d5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '66' order by \\"item_loans\\".\\"id\\" asc","time":"2.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:28:27
23878	9d68a040-246e-453e-a196-5393a0da5078	9d68a040-29c5-441f-a678-ebaadaed97d5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 08:28:27
23879	9d68a040-2888-4158-a641-ebc60502a630	9d68a040-29c5-441f-a678-ebaadaed97d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 08:28:27
24212	9d68b1fc-4465-4172-8888-09c56cf02c85	9d68b1fc-6091-4ed2-a712-d8f584a821ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 09:18:02
12059	9d5ce09e-ea1e-47cd-bde5-d856cff5dd11	9d5ce09e-ed7a-4dfa-b237-fff984bf8706	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":138,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:30
12470	9d5ce536-ab87-48b5-b9b5-32e9a6d30fc2	9d5ce536-aed0-46ab-9198-7b0fd81bf666	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":135,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:31:21
12654	9d5cec88-7bf4-4fc1-9fb8-7661484908b2	9d5cec88-99b1-4080-a9d1-510d5acf319f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 12:51:49
12655	9d5cec88-9496-442c-ae25-65ca2fef774c	9d5cec88-99b1-4080-a9d1-510d5acf319f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":180,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 12:51:49
12656	9d5cec88-94df-4fc0-9461-bfd92c009d13	9d5cec88-99b1-4080-a9d1-510d5acf319f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 12:51:49
12657	9d5cec88-98a1-49ac-93ba-4ff39208bcc2	9d5cec88-99b1-4080-a9d1-510d5acf319f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 12:51:49
12658	9d5cec88-98e4-438a-af74-a80de0535b69	9d5cec88-99b1-4080-a9d1-510d5acf319f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":306,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:51:49
23880	9d68a040-28ce-40c9-9462-98dfe9bf100f	9d68a040-29c5-441f-a678-ebaadaed97d5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/66","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":66,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":5000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"500000","loans_pago_interes":"125000"},"items":[{"id":217,"loans_codigo":66,"itemloans_cuota":"1","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:26.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":218,"loans_codigo":66,"itemloans_cuota":"2","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":219,"loans_codigo":66,"itemloans_cuota":"3","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":220,"loans_codigo":66,"itemloans_cuota":"4","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":221,"loans_codigo":66,"itemloans_cuota":"5","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":222,"loans_codigo":66,"itemloans_cuota":"6","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":223,"loans_codigo":66,"itemloans_cuota":"7","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":224,"loans_codigo":66,"itemloans_cuota":"8","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":225,"loans_codigo":66,"itemloans_cuota":"9","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-31 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":226,"loans_codigo":66,"itemloans_cuota":"10","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":256,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:28:27
24213	9d68b1fc-5c04-49b7-8dbf-3e46d45b72fc	9d68b1fc-6091-4ed2-a712-d8f584a821ba	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ma%' or \\"users\\".\\"user_document\\"::text like '%Ma%') order by \\"users\\".\\"user_document\\" asc","time":"42.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 09:18:02
24214	9d68b1fc-5f2a-47a6-9c06-aec9c09da62d	9d68b1fc-6091-4ed2-a712-d8f584a821ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 09:18:02
12060	9d5ce09f-3deb-4f37-aa6f-f61e4f9c2f53	9d5ce09f-40e6-4a1d-9e61-4c693f6f72a3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":134,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:30
12659	9d5cec89-22da-4c84-b8f4-eee88433326b	9d5cec89-5b8f-441d-a1c9-a8fd2a57f50f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 12:51:49
12472	9d5ce536-fec0-4643-8c51-a47cf833d32c	9d5ce537-09a3-4e71-a5d7-a00fb349f7e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 12:31:21
12473	9d5ce537-07f7-4617-9352-0d216db1ca37	9d5ce537-09a3-4e71-a5d7-a00fb349f7e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 12:31:21
9482	9d53006b-b234-41bd-bd25-824bdd9aa226	9d53006c-1caf-47ab-a8f7-551a5370a117	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-24 14:29:09
9483	9d53006c-1990-4887-bb90-0f34c7774f34	9d53006c-1caf-47ab-a8f7-551a5370a117	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-24 14:29:09
9484	9d53006c-1ae1-4531-bab7-ac20894d186e	9d53006c-1caf-47ab-a8f7-551a5370a117	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":735,"memory":22,"hostname":"EderCortes"}	2024-10-24 14:29:09
12474	9d5ce537-0885-45a1-b41d-0aa6affe8b76	9d5ce537-09a3-4e71-a5d7-a00fb349f7e1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAri"},"session":[],"response_status":500,"response":{"message":"Object of class Illuminate\\\\Database\\\\Query\\\\Builder could not be converted to string","exception":"Error","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":70,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":1702,"function":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\{closure}","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":829,"function":"whereNested","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":69,"function":"where","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getCustomerFilters","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":178,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:31:21
12471	9d5ce537-06be-4686-8547-4ecac4bd0754	9d5ce537-09a3-4e71-a5d7-a00fb349f7e1	9596e153c1500773808230b07a1f2db7	f	exception	{"class":"Error","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":70,"message":"Object of class Illuminate\\\\Database\\\\Query\\\\Builder could not be converted to string","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":1702},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":829},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":69},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"61":"    public function getCustomerFilters(Request $request)","62":"    {","63":"","64":"        $search = $request->all()['search'];","65":"","66":"        $data = DB::table('users')->select(","67":"            'users.id',","68":"            DB::raw(\\"CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer\\"),","69":"        )->where('users.profile_code', $request->all()['code'])->where(function ($query) {","70":"            $query->where('users.name', 'like', '%' . $query . '%')","71":"                ->orWhere('users.user_document', 'like', '%' . $query . '%');","72":"        })","73":"","74":"            ->orderBy('users.user_document')","75":"            ->get();","76":"        return response()->json([","77":"            \\"data\\" => $data","78":"        ]);","79":"","80":"    }"},"hostname":"EderCortes","occurrences":1}	2024-10-29 12:31:21
12660	9d5cec89-5174-4278-bb3d-d47ae1ee2c00	9d5cec89-5b8f-441d-a1c9-a8fd2a57f50f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"77.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 12:51:49
12661	9d5cec89-51ff-4686-a1ff-9cbcb30fbd87	9d5cec89-5b8f-441d-a1c9-a8fd2a57f50f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 12:51:49
12662	9d5cec89-596d-49a3-b43c-33d1c8bff93f	9d5cec89-5b8f-441d-a1c9-a8fd2a57f50f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-29 12:51:49
12663	9d5cec89-5a04-4802-8d9d-912fc9514491	9d5cec89-5b8f-441d-a1c9-a8fd2a57f50f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":480,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:51:49
12061	9d5ce09f-91ae-4c3b-8e88-21f8a314340d	9d5ce09f-b22e-40cd-a250-f19550cd8174	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 12:18:31
12062	9d5ce09f-ace3-4277-b692-340ee310ea55	9d5ce09f-b22e-40cd-a250-f19550cd8174	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"41.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:31
12063	9d5ce09f-b0c8-4da2-ad17-bc3983262217	9d5ce09f-b22e-40cd-a250-f19550cd8174	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:18:31
12064	9d5ce09f-b11d-40ed-8ed7-afaabae3857b	9d5ce09f-b22e-40cd-a250-f19550cd8174	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:31
12475	9d5ce537-95e5-4364-a2d6-a2ec6e8390e0	9d5ce537-98d9-4585-8201-4f3a221365f2	9596e153c1500773808230b07a1f2db7	t	exception	{"class":"Error","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":70,"message":"Object of class Illuminate\\\\Database\\\\Query\\\\Builder could not be converted to string","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":1702},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":829},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":69},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"61":"    public function getCustomerFilters(Request $request)","62":"    {","63":"","64":"        $search = $request->all()['search'];","65":"","66":"        $data = DB::table('users')->select(","67":"            'users.id',","68":"            DB::raw(\\"CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer\\"),","69":"        )->where('users.profile_code', $request->all()['code'])->where(function ($query) {","70":"            $query->where('users.name', 'like', '%' . $query . '%')","71":"                ->orWhere('users.user_document', 'like', '%' . $query . '%');","72":"        })","73":"","74":"            ->orderBy('users.user_document')","75":"            ->get();","76":"        return response()->json([","77":"            \\"data\\" => $data","78":"        ]);","79":"","80":"    }"},"hostname":"EderCortes","occurrences":2}	2024-10-29 12:31:21
12476	9d5ce537-8d9e-4493-8d4a-3b4ddc26b993	9d5ce537-98d9-4585-8201-4f3a221365f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 12:31:21
12477	9d5ce537-971f-4a93-8fc9-f9e229163d10	9d5ce537-98d9-4585-8201-4f3a221365f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 12:31:21
12478	9d5ce537-97a9-4344-9691-e058aac1d7f4	9d5ce537-98d9-4585-8201-4f3a221365f2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAria"},"session":[],"response_status":500,"response":{"message":"Object of class Illuminate\\\\Database\\\\Query\\\\Builder could not be converted to string","exception":"Error","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":70,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":1702,"function":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\{closure}","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":829,"function":"whereNested","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":69,"function":"where","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getCustomerFilters","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":199,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:31:21
12664	9d5cec8a-2bcc-4ca2-af19-92642099e4ee	9d5cec8a-4cb5-40f3-94f1-a6f3880c9d96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-29 12:51:50
12665	9d5cec8a-47cf-4ed5-9586-dc67eddaf652	9d5cec8a-4cb5-40f3-94f1-a6f3880c9d96	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 12:51:50
12666	9d5cec8a-4821-4549-8e9b-d6f39da6b019	9d5cec8a-4cb5-40f3-94f1-a6f3880c9d96	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 12:51:50
12667	9d5cec8a-4b8d-41a9-84a8-62372b02aded	9d5cec8a-4cb5-40f3-94f1-a6f3880c9d96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-29 12:51:50
12065	9d5ce09f-ff1a-4ffb-9686-3a5c1adf81a0	9d5ce0a0-201a-4db8-b7a4-18b253d41765	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:18:31
12066	9d5ce0a0-198e-48b7-afbd-23de744ec131	9d5ce0a0-201a-4db8-b7a4-18b253d41765	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"49.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:31
12067	9d5ce0a0-1eb7-4bb1-a562-789cc697cfee	9d5ce0a0-201a-4db8-b7a4-18b253d41765	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:18:31
12068	9d5ce0a0-1f0c-479f-9baf-9d9fa50924d4	9d5ce0a0-201a-4db8-b7a4-18b253d41765	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":271,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:31
12668	9d5cec8a-4bcf-47cc-82f6-070b8e4fdc10	9d5cec8a-4cb5-40f3-94f1-a6f3880c9d96	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":516,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:51:50
13605	9d5d08da-f051-4597-b92f-12cfa652bef9	9d5d08da-f3c9-45e8-86ff-c628fef8cedf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":174,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:11:00
23881	9d68a042-69f9-4feb-bd7d-7ff820a80877	9d68a042-6d05-44a9-9b3c-88e5e303e088	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":155,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:28:28
17500	9d655c0c-1df7-4ce6-a79e-3a1848374e33	9d655c0c-4241-4599-9c6b-54565271330c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:30:15
17501	9d655c0c-4047-4c9d-b54f-90285782dd90	9d655c0c-4241-4599-9c6b-54565271330c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 17:30:15
17502	9d655c0c-411d-43d0-9022-1a9f51279c98	9d655c0c-4241-4599-9c6b-54565271330c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":307,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:30:15
24215	9d68b1fc-5f6d-48cf-9bd9-1208cb0acf0a	9d68b1fc-6091-4ed2-a712-d8f584a821ba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ma"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":216,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:18:02
12069	9d5ce0a2-d84b-4e61-b439-d459e67ece6c	9d5ce0a2-dc6b-4934-8d96-b58977083549	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":148,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:33
12669	9d5cec8e-f753-4c5a-b678-54c994cafb26	9d5cec8e-fa71-44c7-bb7d-c361a2664faa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":135,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:51:53
17503	9d655c0c-a054-41cb-9cdf-bc205d2aca7d	9d655c0c-c24a-48f6-bf35-14ae8a71e727	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 17:30:15
23882	9d68a042-cf7e-4988-a881-8f2b4f4fc58e	9d68a043-1a6d-48c3-b286-3761a6453206	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 08:28:28
23883	9d68a043-0ff5-4516-b35e-d60b5c283a25	9d68a043-1a6d-48c3-b286-3761a6453206	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 218 limit 1","time":"2.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 08:28:29
23884	9d68a043-1048-402e-a4b4-de099dc6b8e1	9d68a043-1a6d-48c3-b286-3761a6453206	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 08:28:29
23885	9d68a043-1281-4388-91bb-b901a46c9161	9d68a043-1a6d-48c3-b286-3761a6453206	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 66 limit 1","time":"2.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 08:28:29
23886	9d68a043-12bf-4baa-b872-59dc272b4cec	9d68a043-1a6d-48c3-b286-3761a6453206	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 08:28:29
23887	9d68a043-1447-4886-a273-6ecbf2e2329f	9d68a043-1a6d-48c3-b286-3761a6453206	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '125000', \\"itemloans_cuota_cancelada\\" = '500000', \\"updated_at\\" = '2024-11-04 08:28:29' where \\"id\\" = 218","time":"2.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":400,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 08:28:29
23888	9d68a043-1494-49f2-8ac8-1a4df7f4a1cc	9d68a043-1a6d-48c3-b286-3761a6453206	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:218","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 08:28:29","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},"hostname":"EderCortes"}	2024-11-04 08:28:29
12070	9d5ce0a3-8c7e-4637-b9a5-cdba61dc0ea7	9d5ce0a3-8f3e-4b65-a407-c7f033bb3e00	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":139,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:33
12670	9d5cec8f-433d-4abe-bb46-e1b85aebef36	9d5cec8f-462a-462b-b554-a25795f71d48	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":129,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:51:53
13611	9d5d0958-78c8-4d54-a10b-8ce5fe79dc2c	9d5d0958-7e7f-4a09-8eca-e644ed49bd97	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":267,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:12:23
17504	9d655c0c-bbea-461d-b934-f0c5907d009d	9d655c0c-c24a-48f6-bf35-14ae8a71e727	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"51.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":46,"hash":"fb4ded687569d92428336ceae5c6ffcd","hostname":"EderCortes"}	2024-11-02 17:30:15
17505	9d655c0c-c0d9-4a10-9b00-184aa55326fd	9d655c0c-c24a-48f6-bf35-14ae8a71e727	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 17:30:15
17506	9d655c0c-c13f-48bf-a713-1f4e4a7df546	9d655c0c-c24a-48f6-bf35-14ae8a71e727	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":285,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:30:15
23889	9d68a043-1533-4a0a-9c94-d6174ee8b14a	9d68a043-1a6d-48c3-b286-3761a6453206	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 250000, \\"loans_pago_prestado\\" = 1000000, \\"updated_at\\" = '2024-11-04 08:28:29' where \\"id\\" = 66","time":"0.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":408,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 08:28:29
23890	9d68a043-1562-429a-ad56-08df1d5726c4	9d68a043-1a6d-48c3-b286-3761a6453206	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:66","changes":{"updated_at":"2024-11-04 08:28:29","loans_pago_interes":250000,"loans_pago_prestado":1000000},"hostname":"EderCortes"}	2024-11-04 08:28:29
23891	9d68a043-192b-491b-b3d4-2ae5e2e12da4	9d68a043-1a6d-48c3-b286-3761a6453206	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 08:28:29
23892	9d68a043-1976-4788-b943-a16b311df9ce	9d68a043-1a6d-48c3-b286-3761a6453206	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"180","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000","id":218,"loans_codigo":66,"itemloans_cuota":"2","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:28:29
24216	9d68b1fc-a1ac-4a4e-a2ca-3e8844d7a76c	9d68b1fc-a4a5-499a-a033-235048a896bc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":152,"memory":20,"hostname":"EderCortes"}	2024-11-04 09:18:02
11241	9d5cb0e6-6b4c-4728-af3d-8cb9255a63a3	9d5cb0e6-907d-4c48-8f5c-3075ad279357	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 10:05:04
11242	9d5cb0e6-8eba-44c3-b2e5-d25511b59268	9d5cb0e6-907d-4c48-8f5c-3075ad279357	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 10:05:04
11243	9d5cb0e6-8f79-4c38-a5ac-4cd8544f9661	9d5cb0e6-907d-4c48-8f5c-3075ad279357	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":308,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:05:04
23893	9d68a043-6d98-4ba3-b7c9-4cca0987237d	9d68a043-8f1f-4a7d-ac84-ec8fd4e2c027	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 08:28:29
23894	9d68a043-8541-45e0-9625-f839fe096203	9d68a043-8f1f-4a7d-ac84-ec8fd4e2c027	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 66\\n                        ","time":"46.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"f5566f306d2be9466f2c4564ce0020bd","hostname":"EderCortes"}	2024-11-04 08:28:29
23895	9d68a043-894d-4b6e-86bb-42bad5cdf425	9d68a043-8f1f-4a7d-ac84-ec8fd4e2c027	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '66' order by \\"item_loans\\".\\"id\\" asc","time":"1.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:28:29
23896	9d68a043-8982-4861-8c09-697f8fb6dc69	9d68a043-8f1f-4a7d-ac84-ec8fd4e2c027	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 08:28:29
23897	9d68a043-8dd7-4c70-9ce7-0e24334c108e	9d68a043-8f1f-4a7d-ac84-ec8fd4e2c027	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 08:28:29
11244	9d5cb0e7-1815-46e1-9096-dc3109ae3e74	9d5cb0e7-3655-4548-bfa0-c4fd4789eaaf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 10:05:04
11245	9d5cb0e7-3093-4ffa-a4aa-4440711102e6	9d5cb0e7-3655-4548-bfa0-c4fd4789eaaf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 10:05:04
11246	9d5cb0e7-30e0-4b01-be00-d1235d7d1d6f	9d5cb0e7-3655-4548-bfa0-c4fd4789eaaf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 10:05:04
11247	9d5cb0e7-352c-4568-beb4-140a21508fdb	9d5cb0e7-3655-4548-bfa0-c4fd4789eaaf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 10:05:04
11248	9d5cb0e7-356f-4d36-af34-d4af7471117f	9d5cb0e7-3655-4548-bfa0-c4fd4789eaaf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":386,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:05:04
12071	9d5ce0a4-1184-47e6-b324-5670e91ace6a	9d5ce0a4-2faa-4b4d-adec-723e972e7af5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:18:34
12072	9d5ce0a4-2b0b-4378-9b26-096c7daccec6	9d5ce0a4-2faa-4b4d-adec-723e972e7af5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder c%' or \\"users\\".\\"user_document\\"::text like '%Eder c%' order by \\"users\\".\\"user_document\\" asc","time":"43.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:34
12073	9d5ce0a4-2e6e-4e61-9b2f-2a0e07aa966c	9d5ce0a4-2faa-4b4d-adec-723e972e7af5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 12:18:34
12074	9d5ce0a4-2eba-4fe0-90ea-8afb152272f9	9d5ce0a4-2faa-4b4d-adec-723e972e7af5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"28","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder c"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:34
12671	9d5cec8f-9382-4e3d-a109-26051b475673	9d5cec8f-adaf-462a-bc1c-c4f2d035ae13	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-29 12:51:53
12672	9d5cec8f-a996-4221-b88f-74e9ef039970	9d5cec8f-adaf-462a-bc1c-c4f2d035ae13	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%M%' or \\"users\\".\\"user_document\\"::text like '%M%') order by \\"users\\".\\"user_document\\" asc","time":"40.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:51:53
12673	9d5cec8f-ac88-4191-845b-7706a7efbea7	9d5cec8f-adaf-462a-bc1c-c4f2d035ae13	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-29 12:51:53
12674	9d5cec8f-acca-426e-94d3-389c3fa75ff2	9d5cec8f-adaf-462a-bc1c-c4f2d035ae13	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"23","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"M"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":211,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:51:53
17507	9d655c0e-87c8-4f49-b4d2-3df403d19341	9d655c0e-b646-4557-849a-6390cb57c7e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 17:30:17
17508	9d655c0e-ad36-4a6e-b906-68b5803b53cb	9d655c0e-b646-4557-849a-6390cb57c7e7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"57.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 17:30:17
17509	9d655c0e-adc7-442a-a970-e6251c9f16d2	9d655c0e-b646-4557-849a-6390cb57c7e7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 17:30:17
17510	9d655c0e-b446-4579-a6e5-7b1031cfb10c	9d655c0e-b646-4557-849a-6390cb57c7e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 17:30:17
24217	9d68b1fd-24d2-497e-b04b-cd2a89c8f70d	9d68b1fd-434a-4e7a-a4c1-9a73ec3c00f3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 09:18:03
11249	9d5cb0e7-7a3d-4872-b347-0a8dc1c770f9	9d5cb0e7-bdb0-47d2-b5f0-73c4a99b4223	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 10:05:05
11250	9d5cb0e7-b8ec-4233-904c-8c74da4f29e9	9d5cb0e7-bdb0-47d2-b5f0-73c4a99b4223	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"139.96","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 10:05:05
11251	9d5cb0e7-b936-4671-a517-be04a00ad3fc	9d5cb0e7-bdb0-47d2-b5f0-73c4a99b4223	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 10:05:05
11252	9d5cb0e7-bc9e-4cc1-8575-2f6350395031	9d5cb0e7-bdb0-47d2-b5f0-73c4a99b4223	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 10:05:05
11253	9d5cb0e7-bcdf-42b4-81ec-09c53a08cd19	9d5cb0e7-bdb0-47d2-b5f0-73c4a99b4223	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":329,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:05:05
12075	9d5ce0a4-77ce-4499-b89d-aa2fb587ff55	9d5ce0a4-7b23-4bf0-a83e-ceceb1f3c70c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":170,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:34
12675	9d5cec8f-ebed-4ba6-b6f8-0297ffb0a584	9d5cec90-057d-42bb-8bbb-152f31acab35	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-29 12:51:54
12676	9d5cec90-0185-4248-a128-2eff71989640	9d5cec90-057d-42bb-8bbb-152f31acab35	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%M%' or \\"users\\".\\"user_document\\"::text like '%M%') order by \\"users\\".\\"user_document\\" asc","time":"39.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:51:54
12677	9d5cec90-0459-4b3c-8671-1eb2fef9ac32	9d5cec90-057d-42bb-8bbb-152f31acab35	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-29 12:51:54
12678	9d5cec90-0498-49a0-8710-50b2932b67cb	9d5cec90-057d-42bb-8bbb-152f31acab35	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"23","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"M"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":210,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:51:54
17511	9d655c0e-b4d4-4d3f-b071-4949b117c24e	9d655c0e-b646-4557-849a-6390cb57c7e7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":494,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:30:17
24218	9d68b1fd-3ef3-4f3d-af77-1b36c8af3e78	9d68b1fd-434a-4e7a-a4c1-9a73ec3c00f3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mar%' or \\"users\\".\\"user_document\\"::text like '%Mar%') order by \\"users\\".\\"user_document\\" asc","time":"50.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 09:18:03
11254	9d5cb0e9-b5a6-45f9-bad3-ef0764c78d38	9d5cb0e9-d262-4719-b63a-65a0594b28d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 10:05:06
11255	9d5cb0e9-cc72-428f-afbc-13046b779ccf	9d5cb0e9-d262-4719-b63a-65a0594b28d7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"39.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 10:05:06
11256	9d5cb0e9-ccbb-4cb0-8af6-862b7b125090	9d5cb0e9-d262-4719-b63a-65a0594b28d7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 10:05:06
11257	9d5cb0e9-d0f0-4261-bbb9-b58887215729	9d5cb0e9-d262-4719-b63a-65a0594b28d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 10:05:06
11258	9d5cb0e9-d143-421f-b7cf-9eb1daf07d68	9d5cb0e9-d262-4719-b63a-65a0594b28d7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:05:06
12076	9d5ce0a4-d9fa-4432-bfb7-94f4c57c096b	9d5ce0a4-f5d4-41d5-bfa4-37a7f78dea45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 12:18:34
12077	9d5ce0a4-f13f-477c-8c43-52c0066c42ac	9d5ce0a4-f5d4-41d5-bfa4-37a7f78dea45	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder co%' or \\"users\\".\\"user_document\\"::text like '%Eder co%' order by \\"users\\".\\"user_document\\" asc","time":"41.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:34
12078	9d5ce0a4-f450-454c-843b-b9c5be42fbed	9d5ce0a4-f5d4-41d5-bfa4-37a7f78dea45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 12:18:34
12079	9d5ce0a4-f4a9-4da2-a6c9-7c90d412c9c9	9d5ce0a4-f5d4-41d5-bfa4-37a7f78dea45	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"29","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder co"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:34
12679	9d5cec93-efc9-4c1f-86ea-aed4979fa7c5	9d5cec93-f2ac-4117-b6b9-1ab018dae2f5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":135,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:51:56
13616	9d5d0972-d29f-41a9-8d54-f6daecd9c6d7	9d5d0972-d61c-40a3-86e6-8e2d32841f5b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":183,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:12:40
24219	9d68b1fd-420d-4c7e-bce6-f40a92556431	9d68b1fd-434a-4e7a-a4c1-9a73ec3c00f3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 09:18:03
23898	9d68a043-8e28-427f-b802-467ee8411a8a	9d68a043-8f1f-4a7d-ac84-ec8fd4e2c027	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/66","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":66,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":5000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"1000000","loans_pago_interes":"250000"},"items":[{"id":217,"loans_codigo":66,"itemloans_cuota":"1","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:26.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":218,"loans_codigo":66,"itemloans_cuota":"2","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":219,"loans_codigo":66,"itemloans_cuota":"3","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":220,"loans_codigo":66,"itemloans_cuota":"4","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":221,"loans_codigo":66,"itemloans_cuota":"5","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":222,"loans_codigo":66,"itemloans_cuota":"6","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":223,"loans_codigo":66,"itemloans_cuota":"7","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":224,"loans_codigo":66,"itemloans_cuota":"8","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":225,"loans_codigo":66,"itemloans_cuota":"9","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-31 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":226,"loans_codigo":66,"itemloans_cuota":"10","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":279,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:28:29
12680	9d5cec94-a278-4fc8-8258-876c502c1c4f	9d5cec94-e821-4486-b47b-ee904c6fd700	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-29 12:51:57
12681	9d5cec94-e40c-4a41-bc7f-b30d216a6516	9d5cec94-e821-4486-b47b-ee904c6fd700	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ma%' or \\"users\\".\\"user_document\\"::text like '%Ma%') order by \\"users\\".\\"user_document\\" asc","time":"151.39","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:51:57
10465	9d56d269-0882-46ad-8983-af8e1ae3a6a6	9d56d269-2f56-4b22-97ba-3eba65d8368b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 12:03:48
10466	9d56d269-2d2c-403c-a5dc-93e170cc48d9	9d56d269-2f56-4b22-97ba-3eba65d8368b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 12:03:48
10467	9d56d269-2e28-4d59-9005-3e8edb81d349	9d56d269-2f56-4b22-97ba-3eba65d8368b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":446,"memory":22,"hostname":"EderCortes"}	2024-10-26 12:03:48
12682	9d5cec94-e701-4b2b-aead-4d895e25e3b3	9d5cec94-e821-4486-b47b-ee904c6fd700	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-29 12:51:57
12683	9d5cec94-e740-4f5b-b790-a0162647245d	9d5cec94-e821-4486-b47b-ee904c6fd700	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ma"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":316,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:51:57
24220	9d68b1fd-4252-4454-a4b1-9cd80053a598	9d68b1fd-434a-4e7a-a4c1-9a73ec3c00f3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mar"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:18:03
12080	9d5ce0a5-35f9-48d1-b317-4a5458473951	9d5ce0a5-395c-4b4f-af3b-eb32727531fa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":152,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:34
13620	9d5d0989-4aed-48f8-8ee9-ffadc762119c	9d5d0989-4e7d-4624-8933-3d45fbf7ba77	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":151,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:12:55
23899	9d68a045-b792-481a-b9bb-786efb40d2dc	9d68a045-ba9b-43cd-8f0d-2e12c64488e7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":145,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:28:30
10036	9d56c78c-1c3a-4cdc-80dc-2ae76a809dea	9d56c78c-54fa-4944-baeb-b1c8ce9734b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 11:33:25
10037	9d56c78c-52b5-4bfa-9bcf-a62237dedb85	9d56c78c-54fa-4944-baeb-b1c8ce9734b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 11:33:26
10038	9d56c78c-53a2-4318-95ff-65bed65eebd5	9d56c78c-54fa-4944-baeb-b1c8ce9734b6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":363,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:33:26
24221	9d68b1fd-7fd2-49c5-97e7-026c1d3ddd14	9d68b1fd-8332-4e86-b9c5-0976158c675c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":141,"memory":20,"hostname":"EderCortes"}	2024-11-04 09:18:03
25098	9d68bfb4-2f80-4e95-9a31-91e4dd3a18b5	9d68bfb4-cf6c-41dc-b415-5a710bb9dcf3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 09:56:24
25099	9d68bfb4-cd4c-4673-8a65-dbdbf910b92a	9d68bfb4-cf6c-41dc-b415-5a710bb9dcf3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 09:56:24
25100	9d68bfb4-ce50-43d0-87f8-07f9b4500d3e	9d68bfb4-cf6c-41dc-b415-5a710bb9dcf3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":977,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:56:24
43536	9d6cea0d-60f8-42dd-b5ff-41c3dca4220c	9d6cea0d-7e3c-482e-9305-f9269ae07c43	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-11-06 11:38:07
43537	9d6cea0d-7c80-4682-b09e-2bde70f5c99b	9d6cea0d-7e3c-482e-9305-f9269ae07c43	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-11-06 11:38:07
10039	9d56c78c-a7f5-4612-8aba-8a450da70c24	9d56c78c-f2d2-48a7-ba6c-70dfab4ca730	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 11:33:26
10040	9d56c78c-ec80-4e4d-bf67-9eb873b0e979	9d56c78c-f2d2-48a7-ba6c-70dfab4ca730	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"161.82","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:33:26
10041	9d56c78c-f15b-4a91-9940-ab242ff8d29a	9d56c78c-f2d2-48a7-ba6c-70dfab4ca730	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 11:33:26
10042	9d56c78c-f1ce-43cb-a120-5f3ff0a36091	9d56c78c-f2d2-48a7-ba6c-70dfab4ca730	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":363,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:33:26
10468	9d56d269-9a9c-4caf-a6c2-a51af650098b	9d56d269-b747-4e7a-a4a7-8470fc2f5a15	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 12:03:48
10469	9d56d269-b1e5-42d5-b634-8a25d20db0f5	9d56d269-b747-4e7a-a4a7-8470fc2f5a15	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"44.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 12:03:48
10470	9d56d269-b60b-497a-85da-92e1932c126c	9d56d269-b747-4e7a-a4a7-8470fc2f5a15	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 12:03:48
10471	9d56d269-b65f-4977-aff0-ead322fa97dc	9d56d269-b747-4e7a-a4a7-8470fc2f5a15	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":306,"memory":22,"hostname":"EderCortes"}	2024-10-26 12:03:48
12081	9d5ce0a5-b2ff-4936-ad42-995e5747b51c	9d5ce0a5-b670-44e8-8e46-cd8d5154cee5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":147,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:35
23900	9d68a046-2500-4994-b60d-c4c2ad9ebbde	9d68a046-4ff2-44d7-a200-59f98ded7a8b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 08:28:31
23901	9d68a046-42d5-4be6-b337-a09f6bc3e2d8	9d68a046-4ff2-44d7-a200-59f98ded7a8b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 219 limit 1","time":"2.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 08:28:31
10043	9d56c78e-189d-4b0f-b116-4b4565f50f44	9d56c78e-6093-4509-81c3-8ac4146909ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 11:33:27
10044	9d56c78e-5b31-44bb-b947-0298a0ed9d37	9d56c78e-6093-4509-81c3-8ac4146909ec	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"150.53","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:33:27
10045	9d56c78e-5b79-467a-a468-e15901fbe72b	9d56c78e-6093-4509-81c3-8ac4146909ec	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:33:27
10046	9d56c78e-5f3c-4fa6-a5dd-2fd93119af4c	9d56c78e-6093-4509-81c3-8ac4146909ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 11:33:27
10047	9d56c78e-5f89-46d1-a9e9-2111c89790e0	9d56c78e-6093-4509-81c3-8ac4146909ec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":436,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:33:27
10472	9d56d26b-66b7-4f28-84f2-5804fa636c96	9d56d26b-c5c3-4969-9e9c-f47cbba6c6b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 12:03:50
10473	9d56d26b-bd55-41da-b0d3-0f4396e8b265	9d56d26b-c5c3-4969-9e9c-f47cbba6c6b4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"170.88","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 12:03:50
10474	9d56d26b-bdc7-489f-9939-0f06301f14ef	9d56d26b-c5c3-4969-9e9c-f47cbba6c6b4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 12:03:50
10475	9d56d26b-c3d8-43a5-9d25-58bb03209698	9d56d26b-c5c3-4969-9e9c-f47cbba6c6b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 12:03:50
10476	9d56d26b-c45a-4934-940f-0911bec8e6dc	9d56d26b-c5c3-4969-9e9c-f47cbba6c6b4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":627,"memory":22,"hostname":"EderCortes"}	2024-10-26 12:03:50
12082	9d5ce0a6-424c-435f-89e9-6c3acc6e762d	9d5ce0a6-4694-4574-8cda-7a9d131a871f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":181,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:35
23902	9d68a046-431d-4327-a5b6-2fdd10505866	9d68a046-4ff2-44d7-a200-59f98ded7a8b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 08:28:31
23903	9d68a046-44e9-4fa0-a8bb-693bbef50865	9d68a046-4ff2-44d7-a200-59f98ded7a8b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 66 limit 1","time":"2.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 08:28:31
23904	9d68a046-452f-4bb0-afc9-8022a9826563	9d68a046-4ff2-44d7-a200-59f98ded7a8b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 08:28:31
23905	9d68a046-4977-41e7-82a8-bca3c54311c0	9d68a046-4ff2-44d7-a200-59f98ded7a8b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '125000', \\"itemloans_cuota_cancelada\\" = '500000', \\"updated_at\\" = '2024-11-04 08:28:31' where \\"id\\" = 219","time":"8.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":400,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 08:28:31
23906	9d68a046-49c8-4d0f-a8b9-96953c8cfb2a	9d68a046-4ff2-44d7-a200-59f98ded7a8b	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:219","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 08:28:31","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},"hostname":"EderCortes"}	2024-11-04 08:28:31
12083	9d5ce0a6-b1de-4360-a9a8-3753e2787b75	9d5ce0a6-f9f8-4f0c-9ad6-89b06ba27545	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 12:18:35
12084	9d5ce0a6-f464-43e1-92c9-0b2dbc5dea3f	9d5ce0a6-f9f8-4f0c-9ad6-89b06ba27545	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder cor%' or \\"users\\".\\"user_document\\"::text like '%Eder cor%' order by \\"users\\".\\"user_document\\" asc","time":"147.45","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:35
12085	9d5ce0a6-f8a8-404a-af76-817199cd2d7c	9d5ce0a6-f9f8-4f0c-9ad6-89b06ba27545	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 12:18:35
12086	9d5ce0a6-f8eb-4abf-b1c8-ca690fae6707	9d5ce0a6-f9f8-4f0c-9ad6-89b06ba27545	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"30","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder cor"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":394,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:35
23907	9d68a046-4a7e-4332-9a00-adf32e458edd	9d68a046-4ff2-44d7-a200-59f98ded7a8b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 375000, \\"loans_pago_prestado\\" = 1500000, \\"updated_at\\" = '2024-11-04 08:28:31' where \\"id\\" = 66","time":"0.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":408,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 08:28:31
23908	9d68a046-4abc-4ac3-b449-2efd0ad3ceb8	9d68a046-4ff2-44d7-a200-59f98ded7a8b	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:66","changes":{"updated_at":"2024-11-04 08:28:31","loans_pago_interes":375000,"loans_pago_prestado":1500000},"hostname":"EderCortes"}	2024-11-04 08:28:31
23909	9d68a046-4ea1-4b59-93ba-d7ddcf2d07c2	9d68a046-4ff2-44d7-a200-59f98ded7a8b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 08:28:31
23910	9d68a046-4ee3-4fb9-ad83-2250da149590	9d68a046-4ff2-44d7-a200-59f98ded7a8b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"180","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000","id":219,"loans_codigo":66,"itemloans_cuota":"3","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:28:31
24222	9d68b1fd-ff28-4916-9aae-d89b66f026aa	9d68b1fe-4313-4e68-983c-c1301ebb167f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 09:18:03
24223	9d68b1fe-3ec8-4e8f-8f34-576681bd8ad5	9d68b1fe-4313-4e68-983c-c1301ebb167f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"146.95","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 09:18:03
24224	9d68b1fe-41ae-4e14-837d-882a41fd605c	9d68b1fe-4313-4e68-983c-c1301ebb167f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 09:18:03
24225	9d68b1fe-41f3-46a6-9281-4c8e02dd4508	9d68b1fe-4313-4e68-983c-c1301ebb167f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":312,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:18:03
25101	9d68bfb5-5c9e-4791-9013-24d37393b194	9d68bfb5-8b23-48f5-af76-02b036af5514	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 09:56:24
43539	9d6cea0d-e91a-4d5d-bbc9-cdd19e5ae7e4	9d6cea0e-2c29-448c-a6da-91fa711540e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-11-06 11:38:08
43540	9d6cea0e-27f2-4fd9-85b5-1348f1076664	9d6cea0e-2c29-448c-a6da-91fa711540e8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"id\\", \\"name\\", \\"profile_code\\", \\"remember_token\\", \\"user_address\\", \\"user_age\\", \\"user_alias\\", \\"user_birth\\", \\"user_cellphone\\", \\"user_city\\", \\"user_document\\", \\"user_document_type\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_neighborhood\\" from \\"users\\" where \\"profile_code\\" = '4'","time":"146.19","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":159,"hash":"6102b4b26f332fae7602f55df2f9d07b","hostname":"EderCortes"}	2024-11-06 11:38:08
43541	9d6cea0e-2af2-4a9c-ab39-b0a7e5816cc4	9d6cea0e-2c29-448c-a6da-91fa711540e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-11-06 11:38:08
12087	9d5ce0a7-6046-4678-9abd-80ed8cf3bbe1	9d5ce0a7-8b7a-4fbc-8e80-636438733361	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 12:18:36
12088	9d5ce0a7-83e4-488a-8750-d1686b1d151e	9d5ce0a7-8b7a-4fbc-8e80-636438733361	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder corte%' or \\"users\\".\\"user_document\\"::text like '%Eder corte%' order by \\"users\\".\\"user_document\\" asc","time":"59.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:36
12089	9d5ce0a7-8986-457a-a404-66cb297df035	9d5ce0a7-8b7a-4fbc-8e80-636438733361	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 12:18:36
12090	9d5ce0a7-8a01-4b94-a51e-c05f5a4e9145	9d5ce0a7-8b7a-4fbc-8e80-636438733361	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"32","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder corte"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:36
13624	9d5d09b3-40fe-4c70-a947-836c612f00fb	9d5d09b3-44b2-4bca-b25f-a4a04623d371	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":157,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:13:22
23911	9d68a046-a2ec-42ac-8377-f4135f5345d5	9d68a046-f116-47c6-8f84-56d5352325a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 08:28:31
24226	9d68b1fe-8c6b-4c0a-ace9-a8090221b8f6	9d68b1fe-a754-4630-ba34-3101a01e9f4a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 09:18:04
15247	9d5ecf51-a1d3-49aa-b9ba-ad206783c45c	9d5ecf51-f862-4aa6-806b-e79b2c059008	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-30 11:21:47
15248	9d5ecf51-e9c0-4767-880f-82ea212ec46d	9d5ecf51-f862-4aa6-806b-e79b2c059008	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"166.38","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"088d1fdbe045a08c3b0073ef22c7da32","hostname":"EderCortes"}	2024-10-30 11:21:47
15249	9d5ecf51-ef10-4489-b25c-a36a6f55ebff	9d5ecf51-f862-4aa6-806b-e79b2c059008	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"3.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-30 11:21:47
15250	9d5ecf51-ef5b-453d-88d9-ae3cce345710	9d5ecf51-f862-4aa6-806b-e79b2c059008	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-10-30 11:21:47
15251	9d5ecf51-f691-47bb-84eb-1c5cbcf15a07	9d5ecf51-f862-4aa6-806b-e79b2c059008	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-30 11:21:47
15252	9d5ecf51-f70c-40b8-97b9-03be582291e7	9d5ecf51-f862-4aa6-806b-e79b2c059008	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":520,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:21:47
12091	9d5ce0a7-f41b-4069-ac64-57df2a91b170	9d5ce0a8-3f7b-43bc-8d26-3596c13f38ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 12:18:36
12092	9d5ce0a8-39f8-4b00-94e2-1b767c9dca9f	9d5ce0a8-3f7b-43bc-8d26-3596c13f38ed	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder corte%' or \\"users\\".\\"user_document\\"::text like '%Eder corte%' order by \\"users\\".\\"user_document\\" asc","time":"158.36","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:36
12093	9d5ce0a8-3e06-497a-a5f1-285051056028	9d5ce0a8-3f7b-43bc-8d26-3596c13f38ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 12:18:36
12094	9d5ce0a8-3e5c-474c-b65d-183383b64bf8	9d5ce0a8-3f7b-43bc-8d26-3596c13f38ed	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"32","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder corte"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":449,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:36
23912	9d68a046-e61a-4638-945c-4843ae7963ef	9d68a046-f116-47c6-8f84-56d5352325a1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 66\\n                        ","time":"158.22","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"f5566f306d2be9466f2c4564ce0020bd","hostname":"EderCortes"}	2024-11-04 08:28:31
12095	9d5ce0a8-86a3-4094-b815-1700053e6e88	9d5ce0a8-cd5a-4f7a-b7c7-03d9df690538	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 12:18:36
12096	9d5ce0a8-c62d-40ae-bba3-eba0bc817445	9d5ce0a8-cd5a-4f7a-b7c7-03d9df690538	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder cortes%' or \\"users\\".\\"user_document\\"::text like '%Eder cortes%' order by \\"users\\".\\"user_document\\" asc","time":"144.82","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:37
12097	9d5ce0a8-cba1-4155-85ec-f0d949644f14	9d5ce0a8-cd5a-4f7a-b7c7-03d9df690538	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 12:18:37
12098	9d5ce0a8-cc15-4b0a-bf62-aae77129cd01	9d5ce0a8-cd5a-4f7a-b7c7-03d9df690538	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"33","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder cortes"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":346,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:37
13629	9d5d0a32-4ca9-4492-b11d-813c7d4612f2	9d5d0a32-5040-4ae5-9680-df9b30fdd081	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":170,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:14:45
23913	9d68a046-eae3-4549-a3d4-3b35765c90a3	9d68a046-f116-47c6-8f84-56d5352325a1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '66' order by \\"item_loans\\".\\"id\\" asc","time":"2.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:28:31
23914	9d68a046-eb16-4301-9c19-7eb3b1d93cd7	9d68a046-f116-47c6-8f84-56d5352325a1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 08:28:31
15253	9d5ecf52-c535-4450-8faa-0236398991a8	9d5ecf53-1432-4128-9087-3b46451f5da9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-30 11:21:47
15254	9d5ecf53-0884-428f-a0af-c258572e1d0b	9d5ecf53-1432-4128-9087-3b46451f5da9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"81.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 11:21:48
15255	9d5ecf53-0903-4efb-83d5-5c71a3d231ee	9d5ecf53-1432-4128-9087-3b46451f5da9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 11:21:48
15256	9d5ecf53-11c5-4b85-97d4-0484bb7de4f5	9d5ecf53-1432-4128-9087-3b46451f5da9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-30 11:21:48
15257	9d5ecf53-1261-4588-abb4-232d5d4e0f1c	9d5ecf53-1432-4128-9087-3b46451f5da9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":695,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:21:48
23915	9d68a046-efac-4744-9318-f916f951da57	9d68a046-f116-47c6-8f84-56d5352325a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 08:28:31
24227	9d68b1fe-a30f-4f5a-a416-24917afae9ab	9d68b1fe-a754-4630-ba34-3101a01e9f4a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"42.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 09:18:04
24228	9d68b1fe-a60c-461e-ac2e-05dd9f1f3a39	9d68b1fe-a754-4630-ba34-3101a01e9f4a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 09:18:04
12099	9d5ce0aa-f1d5-4c27-bb90-92bdca3fa37f	9d5ce0aa-f4f6-40dc-9c8e-7c059760d687	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":147,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:38
23916	9d68a046-f015-43ef-91a8-b91b508b1c5a	9d68a046-f116-47c6-8f84-56d5352325a1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/66","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":66,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":5000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"1500000","loans_pago_interes":"375000"},"items":[{"id":217,"loans_codigo":66,"itemloans_cuota":"1","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:26.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":218,"loans_codigo":66,"itemloans_cuota":"2","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":219,"loans_codigo":66,"itemloans_cuota":"3","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":220,"loans_codigo":66,"itemloans_cuota":"4","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":221,"loans_codigo":66,"itemloans_cuota":"5","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":222,"loans_codigo":66,"itemloans_cuota":"6","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":223,"loans_codigo":66,"itemloans_cuota":"7","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":224,"loans_codigo":66,"itemloans_cuota":"8","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":225,"loans_codigo":66,"itemloans_cuota":"9","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-31 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":226,"loans_codigo":66,"itemloans_cuota":"10","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":392,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:28:31
24229	9d68b1fe-a64d-4faf-81f1-fa88c5d26b67	9d68b1fe-a754-4630-ba34-3101a01e9f4a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:18:04
43542	9d6cea0e-2b44-4b4f-8e30-0f2e9e9bd48a	9d6cea0e-2c29-448c-a6da-91fa711540e8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/showCobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@showCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","profile_code":4,"remember_token":null,"user_address":"Calle 750","user_age":"31","user_alias":"luis_martinez","user_birth":"1992-11-12T04:00:00.000Z","user_cellphone":"312596295","user_city":"Cali","user_document":"100465545","user_document_type":"CC","user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_neighborhood":"Bonilla aragon"}]},"duration":332,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:08
15258	9d5ecf53-6cfb-47e2-9a2c-54043c7d5c26	9d5ecf53-8885-4ef5-b1e8-2ef8c3963aed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-30 11:21:48
15259	9d5ecf53-83a3-4f5e-81a6-b5b596244bf7	9d5ecf53-8885-4ef5-b1e8-2ef8c3963aed	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 11:21:48
15260	9d5ecf53-83ec-4392-bd58-622c6d6b7876	9d5ecf53-8885-4ef5-b1e8-2ef8c3963aed	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 11:21:48
15261	9d5ecf53-872e-4e57-8cee-a450db51e62d	9d5ecf53-8885-4ef5-b1e8-2ef8c3963aed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-30 11:21:48
15262	9d5ecf53-8778-451a-b404-c418429ed338	9d5ecf53-8885-4ef5-b1e8-2ef8c3963aed	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":274,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:21:48
12100	9d5ce0ab-6f08-4a69-8790-2e236e688e72	9d5ce0ab-8d04-41fe-bdcb-d2b5e7aa6545	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 12:18:38
12101	9d5ce0ab-86be-4abb-b2d2-5f223124171b	9d5ce0ab-8d04-41fe-bdcb-d2b5e7aa6545	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"42.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:38
12102	9d5ce0ab-8b6e-44f7-9d89-87949bc789ac	9d5ce0ab-8d04-41fe-bdcb-d2b5e7aa6545	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 12:18:38
12103	9d5ce0ab-8bd6-44ba-8a62-d9620c55b1bd	9d5ce0ab-8d04-41fe-bdcb-d2b5e7aa6545	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":278,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:38
9645	9d548748-9a23-4086-837d-10a8dd06098a	9d54874a-f1c1-42d3-8475-d071587bf45f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-25 08:42:05
9646	9d54874a-eaae-4f0b-a6b8-c7c93422c5d5	9d54874a-f1c1-42d3-8475-d071587bf45f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-25 08:42:06
9647	9d54874a-ede4-437b-923a-d7e58248031a	9d54874a-f1c1-42d3-8475-d071587bf45f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":15854,"memory":22,"hostname":"EderCortes"}	2024-10-25 08:42:06
13633	9d5d0a8a-d1bf-4de8-a4ca-1a58d0e3769b	9d5d0a8a-d5be-4ebd-946d-cbd43975dd8d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":205,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:15:43
23917	9d68a049-36c4-4252-aaf8-411dcd647a7c	9d68a049-3a73-49a9-bcc4-d1cff63d7681	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":146,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:28:33
24230	9d68b1fe-e81b-4faf-91fd-8cc0f9f5aec7	9d68b1ff-079c-4f6a-a53b-9c46f4070a37	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 09:18:04
15263	9d5ecf54-3d55-49e6-a0d7-b5df6b9a535f	9d5ecf54-58b9-473a-b36f-c227bf48763e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-30 11:21:48
15264	9d5ecf54-5395-4598-9c6d-e21ab470b0d2	9d5ecf54-58b9-473a-b36f-c227bf48763e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"38.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 11:21:48
15265	9d5ecf54-53ea-48c9-af80-caefcb29db54	9d5ecf54-58b9-473a-b36f-c227bf48763e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 11:21:48
15266	9d5ecf54-578f-489b-99f6-d1b6e5f6d9d1	9d5ecf54-58b9-473a-b36f-c227bf48763e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-30 11:21:48
15267	9d5ecf54-57d3-47c1-8966-29a1a15be7a2	9d5ecf54-58b9-473a-b36f-c227bf48763e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":222,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:21:48
24231	9d68b1ff-034f-45f9-bbbe-47a6d711e6f9	9d68b1ff-079c-4f6a-a53b-9c46f4070a37	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"48.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 09:18:04
12104	9d5ce0b0-128e-403f-8492-641e5e04c5e9	9d5ce0b0-15b1-4a47-b586-9721de48d238	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":152,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:41
23918	9d68a049-9e1c-4456-bb4a-3b20974cfae4	9d68a049-becd-485b-8766-6b15c1eb7e47	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 08:28:33
23919	9d68a049-b66a-4449-8481-aec5cc6195ec	9d68a049-becd-485b-8766-6b15c1eb7e47	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 220 limit 1","time":"2.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 08:28:33
23920	9d68a049-b6b1-4c49-80e9-7cad8e423a5b	9d68a049-becd-485b-8766-6b15c1eb7e47	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 08:28:33
23921	9d68a049-b82b-4f40-9cf6-7987a2b90f8f	9d68a049-becd-485b-8766-6b15c1eb7e47	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 66 limit 1","time":"1.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 08:28:33
23922	9d68a049-b859-4e90-8488-6ad816077ff6	9d68a049-becd-485b-8766-6b15c1eb7e47	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 08:28:33
23923	9d68a049-b9ba-47c3-a58b-ae833e858bc5	9d68a049-becd-485b-8766-6b15c1eb7e47	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '125000', \\"itemloans_cuota_cancelada\\" = '500000', \\"updated_at\\" = '2024-11-04 08:28:33' where \\"id\\" = 220","time":"2.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":400,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 08:28:33
23924	9d68a049-ba07-478b-89b1-aa5c098e06a7	9d68a049-becd-485b-8766-6b15c1eb7e47	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:220","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 08:28:33","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},"hostname":"EderCortes"}	2024-11-04 08:28:33
23925	9d68a049-ba96-48a7-8366-3a0010a45f4e	9d68a049-becd-485b-8766-6b15c1eb7e47	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 500000, \\"loans_pago_prestado\\" = 2000000, \\"updated_at\\" = '2024-11-04 08:28:33' where \\"id\\" = 66","time":"0.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":408,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 08:28:33
23926	9d68a049-bac5-4bc5-a48b-49ae1ed05298	9d68a049-becd-485b-8766-6b15c1eb7e47	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:66","changes":{"updated_at":"2024-11-04 08:28:33","loans_pago_interes":500000,"loans_pago_prestado":2000000},"hostname":"EderCortes"}	2024-11-04 08:28:33
23927	9d68a049-bd86-482f-b860-dacdc558db7e	9d68a049-becd-485b-8766-6b15c1eb7e47	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 08:28:33
23928	9d68a049-bdc9-473b-af85-64ca247c1964	9d68a049-becd-485b-8766-6b15c1eb7e47	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"180","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000","id":220,"loans_codigo":66,"itemloans_cuota":"4","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:28:33
24232	9d68b1ff-0653-4b48-a4e4-5aac19a91a04	9d68b1ff-079c-4f6a-a53b-9c46f4070a37	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 09:18:04
24233	9d68b1ff-0698-40d9-8b35-c55b521f5603	9d68b1ff-079c-4f6a-a53b-9c46f4070a37	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"28","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:18:04
12105	9d5ce0b0-cd72-4aa7-84fd-456d6aa9b4fa	9d5ce0b0-e8f4-4962-adfe-8a38c45e28ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 12:18:42
12106	9d5ce0b0-e3b8-4763-b5b2-68a207bc7b44	9d5ce0b0-e8f4-4962-adfe-8a38c45e28ac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"42.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:42
12107	9d5ce0b0-e773-4753-96cf-7cec6a527cea	9d5ce0b0-e8f4-4962-adfe-8a38c45e28ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 12:18:42
12108	9d5ce0b0-e7dd-4aea-ade5-a94ff4680080	9d5ce0b0-e8f4-4962-adfe-8a38c45e28ac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":223,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:42
13639	9d5d0ab3-793b-4563-bade-1fa7910ee277	9d5d0ab3-7d6c-4e27-8508-cfa0444cd5c1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":159,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:16:10
23929	9d68a049-fef7-4842-923d-559bd5649c43	9d68a04a-1d44-4e94-a6fa-bd4838798d75	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 08:28:33
23930	9d68a04a-1505-4ce7-a591-482111153b42	9d68a04a-1d44-4e94-a6fa-bd4838798d75	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 66\\n                        ","time":"43.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"f5566f306d2be9466f2c4564ce0020bd","hostname":"EderCortes"}	2024-11-04 08:28:33
23931	9d68a04a-185b-4136-9514-362885273c4a	9d68a04a-1d44-4e94-a6fa-bd4838798d75	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '66' order by \\"item_loans\\".\\"id\\" asc","time":"2.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:28:33
23932	9d68a04a-188a-451d-8641-e774763c8f2f	9d68a04a-1d44-4e94-a6fa-bd4838798d75	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 08:28:33
23933	9d68a04a-1c1e-4fc4-b480-2dc1e84242ee	9d68a04a-1d44-4e94-a6fa-bd4838798d75	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 08:28:33
23934	9d68a04a-1c66-44b5-8677-304f38830c39	9d68a04a-1d44-4e94-a6fa-bd4838798d75	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/66","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":66,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":5000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"2000000","loans_pago_interes":"500000"},"items":[{"id":217,"loans_codigo":66,"itemloans_cuota":"1","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:26.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":218,"loans_codigo":66,"itemloans_cuota":"2","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":219,"loans_codigo":66,"itemloans_cuota":"3","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":220,"loans_codigo":66,"itemloans_cuota":"4","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:33.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":221,"loans_codigo":66,"itemloans_cuota":"5","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":222,"loans_codigo":66,"itemloans_cuota":"6","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":223,"loans_codigo":66,"itemloans_cuota":"7","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":224,"loans_codigo":66,"itemloans_cuota":"8","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":225,"loans_codigo":66,"itemloans_cuota":"9","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-31 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":226,"loans_codigo":66,"itemloans_cuota":"10","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:28:33
24234	9d68b201-d933-44a2-91be-7f4df6b00112	9d68b201-f7b7-4307-b0bb-eaab147f0bb1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 09:18:06
12109	9d5ce0b1-2b34-4274-bc51-78d3560b4b7c	9d5ce0b1-2e13-40b5-8fcb-69cebbdc4778	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":140,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:42
13640	9d5d0ab4-356b-4356-b2a9-d102e7025002	9d5d0ab4-6365-4160-850f-313021081fc4	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 14:16:11
13641	9d5d0ab4-5436-4b11-98d2-d0d2eee8022d	9d5d0ab4-6365-4160-850f-313021081fc4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta', 'De las nieve', 'ds', 'CC', '100465546', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '500000', 25, 7, 'Q', null, '12-11-24', 'Pendiente', '312596295', 12, 14, 18, 14, '2024-11-12T05:00:00.000Z', '2024-10-29 14:16:11', '2024-10-29 14:16:11') returning \\"id\\"","time":"5.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":108,"hash":"bfad4cea82a73099ff0b3164dd496ca0","hostname":"EderCortes"}	2024-10-29 14:16:11
13642	9d5d0ab4-54ab-46b6-814e-d8739457e49a	9d5d0ab4-6365-4160-850f-313021081fc4	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:52","hostname":"EderCortes"}	2024-10-29 14:16:11
13643	9d5d0ab4-5618-4489-a196-910dff74605b	9d5d0ab4-6365-4160-850f-313021081fc4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (52, 1, 71428.571428571, 10416.666666667, 'Pendiente', 'N\\/A', '27-11-0024', 12, '2024-10-29 14:16:11', '2024-10-29 14:16:11')","time":"2.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":160,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 14:16:11
13644	9d5d0ab4-563f-4aa7-aa64-9856a37e0030	9d5d0ab4-6365-4160-850f-313021081fc4	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 14:16:11
13645	9d5d0ab4-56b3-46d0-84ef-1b77e4a65718	9d5d0ab4-6365-4160-850f-313021081fc4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (52, 2, 71428.571428571, 10416.666666667, 'Pendiente', 'N\\/A', '12-12-0024', 12, '2024-10-29 14:16:11', '2024-10-29 14:16:11')","time":"0.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":160,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 14:16:11
13646	9d5d0ab4-56dc-4f2d-8ff6-3e01156e582e	9d5d0ab4-6365-4160-850f-313021081fc4	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 14:16:11
13647	9d5d0ab4-5760-4344-865e-1a15548d049e	9d5d0ab4-6365-4160-850f-313021081fc4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (52, 3, 71428.571428571, 10416.666666667, 'Pendiente', 'N\\/A', '27-12-0024', 12, '2024-10-29 14:16:11', '2024-10-29 14:16:11')","time":"0.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":160,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 14:16:11
13648	9d5d0ab4-5788-4177-8648-97f9d89e2d6b	9d5d0ab4-6365-4160-850f-313021081fc4	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 14:16:11
13649	9d5d0ab4-57fb-4d52-b8c9-06d8f6e03ffa	9d5d0ab4-6365-4160-850f-313021081fc4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (52, 4, 71428.571428571, 10416.666666667, 'Pendiente', 'N\\/A', '11-01-0025', 12, '2024-10-29 14:16:11', '2024-10-29 14:16:11')","time":"0.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":160,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 14:16:11
13650	9d5d0ab4-581c-49f9-ae58-a03eb46f9938	9d5d0ab4-6365-4160-850f-313021081fc4	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 14:16:11
13651	9d5d0ab4-589c-4af2-8319-f50920684792	9d5d0ab4-6365-4160-850f-313021081fc4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (52, 5, 71428.571428571, 10416.666666667, 'Pendiente', 'N\\/A', '26-01-0025', 12, '2024-10-29 14:16:11', '2024-10-29 14:16:11')","time":"0.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":160,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 14:16:11
13652	9d5d0ab4-58c0-4ef4-af65-7612be4e23bf	9d5d0ab4-6365-4160-850f-313021081fc4	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 14:16:11
13653	9d5d0ab4-592e-4f99-aa12-e139701932b9	9d5d0ab4-6365-4160-850f-313021081fc4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (52, 6, 71428.571428571, 10416.666666667, 'Pendiente', 'N\\/A', '10-02-0025', 12, '2024-10-29 14:16:11', '2024-10-29 14:16:11')","time":"0.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":160,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 14:16:11
13654	9d5d0ab4-5950-4986-83fd-e8badcfa11aa	9d5d0ab4-6365-4160-850f-313021081fc4	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 14:16:11
23935	9d68a04d-52f3-4820-876c-359025cf8885	9d68a04d-5617-4bfa-8132-dbeda1ee8fb6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":142,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:28:35
24235	9d68b201-f2b2-40b1-ac93-470266f59a98	9d68b201-f7b7-4307-b0bb-eaab147f0bb1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '19' and \\"users\\".\\"deleted_at\\" is null","time":"43.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":55,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-11-04 09:18:06
24236	9d68b201-f2ff-4b21-b84b-5e8eed8deb92	9d68b201-f7b7-4307-b0bb-eaab147f0bb1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 09:18:06
10712	9d57203c-4bd7-4646-a541-cd6d3f3c4fbd	9d57203c-75b3-49c0-b455-5159ed505cd0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 15:41:25
10713	9d57203c-73b5-4893-8ea2-e773c16cfa34	9d57203c-75b3-49c0-b455-5159ed505cd0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 15:41:25
10714	9d57203c-749d-4d00-8a02-3ade5327af50	9d57203c-75b3-49c0-b455-5159ed505cd0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":294,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:41:25
24237	9d68b201-f64b-44da-ba92-00587cfa8699	9d68b201-f7b7-4307-b0bb-eaab147f0bb1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 09:18:06
24238	9d68b201-f68f-44d5-849d-18b1e2d48a1a	9d68b201-f7b7-4307-b0bb-eaab147f0bb1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/19","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:18:06
25102	9d68bfb5-80a8-462e-8935-6bc45906f0eb	9d68bfb5-8b23-48f5-af76-02b036af5514	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"79.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 09:56:25
12110	9d5ce0b1-adf4-432c-994f-c166d5112bb8	9d5ce0b1-efcb-4a4f-8824-b4eefb07376d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 12:18:42
25103	9d68bfb5-84eb-448f-ad7e-cb45816b3068	9d68bfb5-8b23-48f5-af76-02b036af5514	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:56:25
25104	9d68bfb5-8520-4498-be53-cebd75d41a5a	9d68bfb5-8b23-48f5-af76-02b036af5514	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 09:56:25
25105	9d68bfb5-8984-4359-b71a-b16573aad09d	9d68bfb5-8b23-48f5-af76-02b036af5514	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 09:56:25
25106	9d68bfb5-89ef-491d-bc0a-1368e24ebf5c	9d68bfb5-8b23-48f5-af76-02b036af5514	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":423,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:56:25
10715	9d57203c-e713-4708-8859-d9e44411e625	9d57203d-6b11-48e6-b8b4-aa71c1057041	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 15:41:25
10716	9d57203d-5c49-48b5-8dc6-28dd713127b9	9d57203d-6b11-48e6-b8b4-aa71c1057041	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"283.28","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-26 15:41:26
10717	9d57203d-6884-41d1-b414-ea77ce1800e8	9d57203d-6b11-48e6-b8b4-aa71c1057041	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 15:41:26
10718	9d57203d-692f-4415-b8e6-2e831895b48d	9d57203d-6b11-48e6-b8b4-aa71c1057041	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":581,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:41:26
12111	9d5ce0b1-eb86-49a9-adde-0ebbd9390472	9d5ce0b1-efcb-4a4f-8824-b4eefb07376d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"139.13","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:43
12112	9d5ce0b1-ee8d-4f17-ac42-0e739e9f0069	9d5ce0b1-efcb-4a4f-8824-b4eefb07376d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 12:18:43
12113	9d5ce0b1-eed8-4907-b522-cdfa108f06b0	9d5ce0b1-efcb-4a4f-8824-b4eefb07376d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:43
13655	9d5d0ab4-59e7-45d5-b1fd-55de02012b88	9d5d0ab4-6365-4160-850f-313021081fc4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (52, 7, 71428.571428571, 10416.666666667, 'Pendiente', 'N\\/A', '25-02-0025', 12, '2024-10-29 14:16:11', '2024-10-29 14:16:11')","time":"0.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":160,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 14:16:11
13656	9d5d0ab4-5a06-4c7f-a30f-1ffd3123db53	9d5d0ab4-6365-4160-850f-313021081fc4	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 14:16:11
13657	9d5d0ab4-61c5-44ed-9e42-69878167da74	9d5d0ab4-6365-4160-850f-313021081fc4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 14:16:11
13658	9d5d0ab4-6219-4c5e-b439-afcc1823590a	9d5d0ab4-6365-4160-850f-313021081fc4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"757","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"100465546","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"500000","loans_intereses":25,"loans_cuotas":7,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":18,"user_recomendacion":14,"loans_inicio_pago":"2024-11-12T05:00:00.000Z","created_at":null,"updated_at":null,"deleted_at":null},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Tue Oct 29 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":52},"duration":276,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:16:11
23936	9d68a04d-b946-461a-8760-ec30e3956889	9d68a04d-da37-45df-bff3-b35e81cde1b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 08:28:36
25107	9d68bfb6-5095-41d2-9305-22567d8c0cdc	9d68bfb6-921a-4878-886e-a2c831fd5d5b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 09:56:25
10719	9d57203f-8686-44d3-a662-91d0f8dc7d8c	9d57203f-a700-4979-a2b4-f9ca790ebef6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 15:41:27
10720	9d57203f-a079-42ea-8e71-ade9a92a5afb	9d57203f-a700-4979-a2b4-f9ca790ebef6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 15:41:27
10721	9d57203f-a122-45fc-96a0-e03874a67767	9d57203f-a700-4979-a2b4-f9ca790ebef6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 15:41:27
10722	9d57203f-a577-4b91-bc37-a512d0df43a0	9d57203f-a700-4979-a2b4-f9ca790ebef6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 15:41:27
10723	9d57203f-a5bc-4e74-88c8-de7959b245df	9d57203f-a700-4979-a2b4-f9ca790ebef6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:41:27
12114	9d5ce0b3-0a4f-41d9-a772-d97a8a003e07	9d5ce0b3-0d2f-4c7a-934a-ba263f96dab2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":131,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:43
23937	9d68a04d-d12d-4936-97cf-9f8540ba0a91	9d68a04d-da37-45df-bff3-b35e81cde1b5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 221 limit 1","time":"3.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 08:28:36
23938	9d68a04d-d178-413d-9890-182b88ec3ad7	9d68a04d-da37-45df-bff3-b35e81cde1b5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 08:28:36
23939	9d68a04d-d2ff-4d1b-b105-2228fb88d732	9d68a04d-da37-45df-bff3-b35e81cde1b5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 66 limit 1","time":"2.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 08:28:36
23940	9d68a04d-d339-4ac2-bc95-fde158647a9d	9d68a04d-da37-45df-bff3-b35e81cde1b5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 08:28:36
23941	9d68a04d-d4a8-4322-b683-b3376ed99976	9d68a04d-da37-45df-bff3-b35e81cde1b5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '125000', \\"itemloans_cuota_cancelada\\" = '500000', \\"updated_at\\" = '2024-11-04 08:28:36' where \\"id\\" = 221","time":"2.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":400,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 08:28:36
23942	9d68a04d-d4f6-47c4-976f-04d5d386a1b0	9d68a04d-da37-45df-bff3-b35e81cde1b5	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:221","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 08:28:36","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},"hostname":"EderCortes"}	2024-11-04 08:28:36
23943	9d68a04d-d595-4f51-a0d8-5ca559592806	9d68a04d-da37-45df-bff3-b35e81cde1b5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 625000, \\"loans_pago_prestado\\" = 2500000, \\"updated_at\\" = '2024-11-04 08:28:36' where \\"id\\" = 66","time":"0.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":408,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 08:28:36
23944	9d68a04d-d5c5-45c1-b5b9-f393a0100b28	9d68a04d-da37-45df-bff3-b35e81cde1b5	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:66","changes":{"updated_at":"2024-11-04 08:28:36","loans_pago_interes":625000,"loans_pago_prestado":2500000},"hostname":"EderCortes"}	2024-11-04 08:28:36
23945	9d68a04d-d8eb-44dd-93c4-fc41277c3e2b	9d68a04d-da37-45df-bff3-b35e81cde1b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 08:28:36
23946	9d68a04d-d92d-427c-93bb-702f9dfb045d	9d68a04d-da37-45df-bff3-b35e81cde1b5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"180","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000","id":221,"loans_codigo":66,"itemloans_cuota":"5","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:28:36
10724	9d57204b-a3f8-405d-9fd8-07f8bafe7d41	9d57204b-ecdc-4321-a724-2ce2e63af04a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 15:41:35
10725	9d57204b-e71b-4749-905e-833f95276329	9d57204b-ecdc-4321-a724-2ce2e63af04a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"148.74","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-26 15:41:35
10726	9d57204b-e767-4790-bbcb-b092c21d6487	9d57204b-ecdc-4321-a724-2ce2e63af04a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-10-26 15:41:35
10727	9d57204b-eb93-4361-92b1-801f0b46d458	9d57204b-ecdc-4321-a724-2ce2e63af04a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-26 15:41:35
10728	9d57204b-ebd7-448e-8c17-2f8cee0a8429	9d57204b-ecdc-4321-a724-2ce2e63af04a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":399,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:41:35
12115	9d5ce0b3-c172-4fac-9440-1d98f74c8108	9d5ce0b4-038a-4948-acf5-f5b0c721d23c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 12:18:44
12116	9d5ce0b3-ff9f-4d21-af06-22f331f7cfe6	9d5ce0b4-038a-4948-acf5-f5b0c721d23c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder a%' or \\"users\\".\\"user_document\\"::text like '%Eder a%' order by \\"users\\".\\"user_document\\" asc","time":"144.36","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:44
12117	9d5ce0b4-0274-4c50-97d7-2ab3e39b6ccc	9d5ce0b4-038a-4948-acf5-f5b0c721d23c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-29 12:18:44
12118	9d5ce0b4-02b3-48fa-935f-09c5ff2aaaa0	9d5ce0b4-038a-4948-acf5-f5b0c721d23c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"28","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder a"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":316,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:44
23947	9d68a04e-1c8f-47aa-b15a-4c748ce6bfcb	9d68a04e-3c7d-475d-bd7b-f6782a93aedc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 08:28:36
23948	9d68a04e-337f-4b11-8538-2e48e92c9ce1	9d68a04e-3c7d-475d-bd7b-f6782a93aedc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 66\\n                        ","time":"46.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"f5566f306d2be9466f2c4564ce0020bd","hostname":"EderCortes"}	2024-11-04 08:28:36
23949	9d68a04e-3711-4977-bfb2-7e045faa5af9	9d68a04e-3c7d-475d-bd7b-f6782a93aedc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '66' order by \\"item_loans\\".\\"id\\" asc","time":"2.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:28:36
23950	9d68a04e-374e-4863-87b7-6f15c199e7bf	9d68a04e-3c7d-475d-bd7b-f6782a93aedc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 08:28:36
23951	9d68a04e-3b3c-4182-9567-6082917b0d7f	9d68a04e-3c7d-475d-bd7b-f6782a93aedc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 08:28:36
12119	9d5ce0b5-974e-4d01-a02e-a80131fdc523	9d5ce0b5-9a44-400e-b676-807e61c58dd9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":159,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:45
23952	9d68a04e-3b86-4782-96b2-46accdd418de	9d68a04e-3c7d-475d-bd7b-f6782a93aedc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/66","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":66,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":5000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"2500000","loans_pago_interes":"625000"},"items":[{"id":217,"loans_codigo":66,"itemloans_cuota":"1","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:26.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":218,"loans_codigo":66,"itemloans_cuota":"2","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":219,"loans_codigo":66,"itemloans_cuota":"3","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":220,"loans_codigo":66,"itemloans_cuota":"4","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:33.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":221,"loans_codigo":66,"itemloans_cuota":"5","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":222,"loans_codigo":66,"itemloans_cuota":"6","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":223,"loans_codigo":66,"itemloans_cuota":"7","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":224,"loans_codigo":66,"itemloans_cuota":"8","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":225,"loans_codigo":66,"itemloans_cuota":"9","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-31 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":226,"loans_codigo":66,"itemloans_cuota":"10","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:28:36
24239	9d68b21d-c92e-48fe-8706-c7e136deb307	9d68b21d-cc49-460b-a215-f4980f0797e2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":168,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:18:24
25108	9d68bfb6-848c-47a7-bd36-0a36edb3d559	9d68bfb6-921a-4878-886e-a2c831fd5d5b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"92.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:56:25
17812	9d65aef6-8814-4ad7-8345-66273e538c45	9d65aef6-b04a-4d19-b824-638172a058bb	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 21:22:06
17813	9d65aef6-adf1-403a-8b70-195e41284e9c	9d65aef6-b04a-4d19-b824-638172a058bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:22:06
17814	9d65aef6-aecb-421b-aa31-d1c389b86f55	9d65aef6-b04a-4d19-b824-638172a058bb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":317,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:22:06
25109	9d68bfb6-852b-4b22-a8e7-3eb8d1831cab	9d68bfb6-921a-4878-886e-a2c831fd5d5b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:56:25
25110	9d68bfb6-8f42-477b-89c6-83ff1d923a1c	9d68bfb6-921a-4878-886e-a2c831fd5d5b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 09:56:25
25111	9d68bfb6-9016-4f40-9bf3-c86cd995b566	9d68bfb6-921a-4878-886e-a2c831fd5d5b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":655,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:56:25
12120	9d5ce0b6-4fa6-43eb-98c7-cc0915c60b22	9d5ce0b6-959a-40bc-8305-54e211d72b33	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-29 12:18:45
12121	9d5ce0b6-919f-40d9-96d4-d46610d2be8a	9d5ce0b6-959a-40bc-8305-54e211d72b33	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder ar%' or \\"users\\".\\"user_document\\"::text like '%Eder ar%' order by \\"users\\".\\"user_document\\" asc","time":"151.65","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:46
12122	9d5ce0b6-947d-4548-bf9d-7e4621f2ad77	9d5ce0b6-959a-40bc-8305-54e211d72b33	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-29 12:18:46
12123	9d5ce0b6-94bf-4f6f-83a0-426f428e8b9b	9d5ce0b6-959a-40bc-8305-54e211d72b33	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"29","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder ar"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":334,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:46
17815	9d65aef7-1d8b-4b5f-9ff0-ccb3c6b67dc3	9d65aef7-4322-418d-9b3d-829382cf36af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:22:06
17816	9d65aef7-373d-435e-908f-32fd0292bce6	9d65aef7-4322-418d-9b3d-829382cf36af	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"52.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 21:22:06
17817	9d65aef7-3bad-44ba-a8c5-e3193bb6dbe3	9d65aef7-4322-418d-9b3d-829382cf36af	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:22:06
17818	9d65aef7-3bf7-43bf-83e6-55d1a1b21cb1	9d65aef7-4322-418d-9b3d-829382cf36af	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:22:06
17819	9d65aef7-41ac-4455-b825-bc74319c57de	9d65aef7-4322-418d-9b3d-829382cf36af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:22:06
17820	9d65aef7-421a-491e-ab55-9be8bbd62fb3	9d65aef7-4322-418d-9b3d-829382cf36af	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:34:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"}]}},"duration":332,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:22:06
23953	9d68a051-e041-4fd2-a702-6bf06a9d7653	9d68a051-e39c-49ca-8ee9-697ca1b7114e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":155,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:28:38
24240	9d68b21e-8252-49eb-b723-3d430c80660b	9d68b21e-a86d-444e-ade3-0b61be68641e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 09:18:25
25112	9d68bfb7-ae66-4a11-b632-1b3e8aa1db81	9d68bfb8-0e40-437c-a9b3-4253df35b0e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 09:56:26
12124	9d5ce0b6-d0e1-4284-bdb4-5dbc33c64df0	9d5ce0b6-d3bb-4c9a-8ba1-24c5cbc82423	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":135,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:46
17821	9d65aef9-431b-4ba4-8c77-c34c89f2c217	9d65aef9-6163-4a51-b154-677986133014	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:22:08
17822	9d65aef9-5c52-4a18-829c-9a57fb9c0ebf	9d65aef9-6163-4a51-b154-677986133014	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 21:22:08
17658	9d656080-2dc5-403d-b22f-4c82dae96616	9d656080-57e3-409b-afcb-2d8847bfe49e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 17:42:42
17659	9d656080-556a-4258-8bd3-7919472d1dfb	9d656080-57e3-409b-afcb-2d8847bfe49e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:42:42
17660	9d656080-5684-42ac-b8df-4e61d20f0c3f	9d656080-57e3-409b-afcb-2d8847bfe49e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":328,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:42:42
17823	9d65aef9-5ca0-4db2-935e-f96176f54f8e	9d65aef9-6163-4a51-b154-677986133014	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 21:22:08
17824	9d65aef9-5ff1-449e-9855-204830d74474	9d65aef9-6163-4a51-b154-677986133014	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 21:22:08
17825	9d65aef9-603a-4372-8cc3-2b6761153af0	9d65aef9-6163-4a51-b154-677986133014	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":280,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:22:08
23954	9d68a052-4287-4ff1-b89c-dc0d8f75636e	9d68a052-61dc-47c6-ad6e-f787e1a55c7c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 08:28:39
23955	9d68a052-5934-4793-8310-ae9829ea1e53	9d68a052-61dc-47c6-ad6e-f787e1a55c7c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 222 limit 1","time":"2.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 08:28:39
23956	9d68a052-5987-4232-bee6-b28ff5f1e658	9d68a052-61dc-47c6-ad6e-f787e1a55c7c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 08:28:39
23957	9d68a052-5b0c-4718-a75a-7b1c99f656f9	9d68a052-61dc-47c6-ad6e-f787e1a55c7c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 66 limit 1","time":"2.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 08:28:39
23958	9d68a052-5b3a-4d6c-b079-4bdd017d52ae	9d68a052-61dc-47c6-ad6e-f787e1a55c7c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 08:28:39
23959	9d68a052-5ca9-4c61-90b4-bbed2b8259ab	9d68a052-61dc-47c6-ad6e-f787e1a55c7c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '125000', \\"itemloans_cuota_cancelada\\" = '500000', \\"updated_at\\" = '2024-11-04 08:28:39' where \\"id\\" = 222","time":"2.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":400,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 08:28:39
23960	9d68a052-5cf8-488e-8a84-a5896bd9ff2d	9d68a052-61dc-47c6-ad6e-f787e1a55c7c	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:222","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 08:28:39","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},"hostname":"EderCortes"}	2024-11-04 08:28:39
23961	9d68a052-5d9c-4e3a-ac1c-7a72e931cf97	9d68a052-61dc-47c6-ad6e-f787e1a55c7c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 750000, \\"loans_pago_prestado\\" = 3000000, \\"updated_at\\" = '2024-11-04 08:28:39' where \\"id\\" = 66","time":"0.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":408,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 08:28:39
23962	9d68a052-5dcb-4267-b9fc-ee8ab91c3799	9d68a052-61dc-47c6-ad6e-f787e1a55c7c	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:66","changes":{"updated_at":"2024-11-04 08:28:39","loans_pago_interes":750000,"loans_pago_prestado":3000000},"hostname":"EderCortes"}	2024-11-04 08:28:39
23963	9d68a052-60af-486e-9f66-7c134719d4ac	9d68a052-61dc-47c6-ad6e-f787e1a55c7c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 08:28:39
25113	9d68bfb8-028c-430c-8192-19e3e24761fe	9d68bfb8-0e40-437c-a9b3-4253df35b0e3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"176.24","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:56:26
12125	9d5ce0b7-4c8c-477b-958c-73cba3777290	9d5ce0b7-4f3f-4120-9350-3c19e2f33a5f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":145,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:46
17661	9d656080-dad3-4fef-b8eb-2dfa5c7e3b3e	9d656080-fd80-4a19-af82-512b39590dc3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:42:43
17662	9d656080-f740-4040-96a7-d7490cdb7ee1	9d656080-fd80-4a19-af82-512b39590dc3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"51.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":57,"hash":"2cc591e3eaf2792109e07ba331bc077f","hostname":"EderCortes"}	2024-11-02 17:42:43
17663	9d656080-fbc4-4356-94b0-f4872719cfc8	9d656080-fd80-4a19-af82-512b39590dc3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:42:43
17664	9d656080-fc33-4be8-bcda-9e17d8bca4c0	9d656080-fd80-4a19-af82-512b39590dc3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"7","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"}]},"duration":350,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:42:43
23964	9d68a052-60ef-4926-ac98-7e860b7bbc03	9d68a052-61dc-47c6-ad6e-f787e1a55c7c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"180","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000","id":222,"loans_codigo":66,"itemloans_cuota":"6","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:28:39
24241	9d68b21e-9cb3-4e63-9a3b-b407daeb7d68	9d68b21e-a86d-444e-ade3-0b61be68641e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\", \\"loans_fecha_ultimo_pago\\", \\"loans_intereses_recaudar\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta 2', 'De las nieve', 'ds', 'CC', '1004655468', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon2', 'Calle 7505', '1100000', 25, 5, 'S', null, '04-11-2024', 'Pendiente', '312596295', 12, 14, 19, 14, '04-11-2024', 0, 0, '04-11-2024', 275000, '2024-11-04 09:18:25', '2024-11-04 09:18:25') returning \\"id\\"","time":"5.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":110,"hash":"f69b6b91ceb0fd9e0c386e94fcedc496","hostname":"EderCortes"}	2024-11-04 09:18:25
24242	9d68b21e-9d19-472d-b914-046d8a596ef8	9d68b21e-a86d-444e-ade3-0b61be68641e	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:71","hostname":"EderCortes"}	2024-11-04 09:18:25
24243	9d68b21e-9eb9-410d-8b8f-c805df382e66	9d68b21e-a86d-444e-ade3-0b61be68641e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (71, 1, 220000, 55000, 'Pendiente', 'N\\/A', '12-11-2024', 12, 0, 0, '2024-11-04 09:18:25', '2024-11-04 09:18:25')","time":"2.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:25
24244	9d68b21e-9ee6-4b8f-bb9d-ff67c6219dc3	9d68b21e-a86d-444e-ade3-0b61be68641e	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:25
25114	9d68bfb8-032e-4b44-8738-b6d994671100	9d68bfb8-0e40-437c-a9b3-4253df35b0e3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:56:26
24245	9d68b21e-9f53-4168-810c-388cd8452b3a	9d68b21e-a86d-444e-ade3-0b61be68641e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (71, 2, 220000, 55000, 'Pendiente', 'N\\/A', '20-11-2024', 12, 0, 0, '2024-11-04 09:18:25', '2024-11-04 09:18:25')","time":"0.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:25
24246	9d68b21e-9f76-4863-9ea1-2d235ab73484	9d68b21e-a86d-444e-ade3-0b61be68641e	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:25
10927	9d5ca6a1-8442-4f18-a624-0ed1a9bcae33	9d5ca6a1-a756-4bde-bb94-34338eeba97e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 09:36:21
10928	9d5ca6a1-a53f-4b93-8011-47d4b0525b97	9d5ca6a1-a756-4bde-bb94-34338eeba97e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 09:36:21
10929	9d5ca6a1-a620-4892-968e-ec4edd66e204	9d5ca6a1-a756-4bde-bb94-34338eeba97e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":289,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:36:21
23965	9d68a052-a3a4-4189-a48a-192ff097b01e	9d68a052-c4be-4769-bcf5-d93ba621c245	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 08:28:39
23966	9d68a052-ba5d-4ecf-ba8b-52223789368d	9d68a052-c4be-4769-bcf5-d93ba621c245	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 66\\n                        ","time":"44.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"f5566f306d2be9466f2c4564ce0020bd","hostname":"EderCortes"}	2024-11-04 08:28:39
23967	9d68a052-bed6-400e-b3fb-297791293895	9d68a052-c4be-4769-bcf5-d93ba621c245	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '66' order by \\"item_loans\\".\\"id\\" asc","time":"2.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:28:39
23968	9d68a052-bf06-4376-b9e5-aca021bc212b	9d68a052-c4be-4769-bcf5-d93ba621c245	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 08:28:39
24247	9d68b21e-9fdf-43ed-8d2c-e7596b35c622	9d68b21e-a86d-444e-ade3-0b61be68641e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (71, 3, 220000, 55000, 'Pendiente', 'N\\/A', '28-11-2024', 12, 0, 0, '2024-11-04 09:18:25', '2024-11-04 09:18:25')","time":"0.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:25
23969	9d68a052-c33b-481a-b756-43216c848891	9d68a052-c4be-4769-bcf5-d93ba621c245	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 08:28:39
24248	9d68b21e-a000-4287-823f-55c589360e3e	9d68b21e-a86d-444e-ade3-0b61be68641e	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:25
24249	9d68b21e-a069-4dd7-a247-fa7860a77b95	9d68b21e-a86d-444e-ade3-0b61be68641e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (71, 4, 220000, 55000, 'Pendiente', 'N\\/A', '06-12-2024', 12, 0, 0, '2024-11-04 09:18:25', '2024-11-04 09:18:25')","time":"0.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:25
24250	9d68b21e-a08a-46ac-9d54-50c18fe684c4	9d68b21e-a86d-444e-ade3-0b61be68641e	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:25
24251	9d68b21e-a0f3-4362-8f13-a7390a673376	9d68b21e-a86d-444e-ade3-0b61be68641e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (71, 5, 220000, 55000, 'Pendiente', 'N\\/A', '14-12-2024', 12, 0, 0, '2024-11-04 09:18:25', '2024-11-04 09:18:25')","time":"0.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:25
24252	9d68b21e-a113-450a-94fb-25a984d033c8	9d68b21e-a86d-444e-ade3-0b61be68641e	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:25
24253	9d68b21e-a6fe-4b06-8001-e7c32c5ff6cd	9d68b21e-a86d-444e-ade3-0b61be68641e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 09:18:25
25115	9d68bfb8-0be3-4a23-9206-682b4c371310	9d68bfb8-0e40-437c-a9b3-4253df35b0e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 09:56:26
10930	9d5ca6a2-3a59-41ac-a320-33051371c1f5	9d5ca6a2-845b-455e-8597-e4c487d5db4b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 09:36:22
10931	9d5ca6a2-7bb1-47ba-b86d-c039bbed9914	9d5ca6a2-845b-455e-8597-e4c487d5db4b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"155.66","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-29 09:36:22
10932	9d5ca6a2-7f08-4238-83dd-a08e2fcdf0bd	9d5ca6a2-845b-455e-8597-e4c487d5db4b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '5' order by \\"item_loans\\".\\"id\\" asc","time":"1.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 09:36:22
10933	9d5ca6a2-7f38-404d-a689-65a2cee92d6f	9d5ca6a2-845b-455e-8597-e4c487d5db4b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 09:36:22
10934	9d5ca6a2-832f-468a-91f3-d5cb760b2a16	9d5ca6a2-845b-455e-8597-e4c487d5db4b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 09:36:22
10935	9d5ca6a2-8378-4050-9cb9-ae08f21a3412	9d5ca6a2-845b-455e-8597-e4c487d5db4b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":25,"loans_codigo":5,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":26,"loans_codigo":5,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":27,"loans_codigo":5,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":28,"loans_codigo":5,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":29,"loans_codigo":5,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":30,"loans_codigo":5,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null}]}},"duration":528,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:36:22
12126	9d5ce0b7-9d6d-4925-9dc3-c35d87bcb714	9d5ce0b7-a04b-4e7d-a464-f1257c9384c5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":144,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:46
17665	9d656083-0e2e-41aa-9a21-9ea9b609f432	9d656083-2b3e-4871-b721-9e375528a1f1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:42:44
17666	9d656083-261a-4358-a9ba-c5aab7b607b8	9d656083-2b3e-4871-b721-9e375528a1f1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 17:42:44
17667	9d656083-2667-4b6c-ad17-248e85d33ef2	9d656083-2b3e-4871-b721-9e375528a1f1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 17:42:44
17668	9d656083-29e5-4ae7-b0a2-4285b31a7cb0	9d656083-2b3e-4871-b721-9e375528a1f1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:42:44
17669	9d656083-2a2f-4740-81d7-f7d3045b75e3	9d656083-2b3e-4871-b721-9e375528a1f1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":302,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:42:44
10936	9d5ca6a4-1467-42fc-ac0d-42e1e73f39ca	9d5ca6a4-314e-4d17-b378-b9b5a397f913	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 09:36:23
10937	9d5ca6a4-2c43-4a50-8e30-3879edf19bb1	9d5ca6a4-314e-4d17-b378-b9b5a397f913	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 09:36:23
10938	9d5ca6a4-2cca-4176-a1a8-40dcbf736191	9d5ca6a4-314e-4d17-b378-b9b5a397f913	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 09:36:23
10939	9d5ca6a4-3014-498a-a395-f0b40f6fa739	9d5ca6a4-314e-4d17-b378-b9b5a397f913	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 09:36:23
10940	9d5ca6a4-3064-4b4c-8fbc-8d9cb1a68dfb	9d5ca6a4-314e-4d17-b378-b9b5a397f913	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:36:23
12127	9d5ce0b7-ef3e-44ff-b7a3-8df7e6ce41ca	9d5ce0b8-08fe-41d0-b6e1-1caef89a327c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-29 12:18:47
12128	9d5ce0b8-04a0-4955-8068-1cc73617db17	9d5ce0b8-08fe-41d0-b6e1-1caef89a327c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder arl%' or \\"users\\".\\"user_document\\"::text like '%Eder arl%' order by \\"users\\".\\"user_document\\" asc","time":"40.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:47
12129	9d5ce0b8-07dc-4f90-996e-d1c91ff25216	9d5ce0b8-08fe-41d0-b6e1-1caef89a327c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-29 12:18:47
12130	9d5ce0b8-081b-4c8c-a198-2cb4bd64de33	9d5ce0b8-08fe-41d0-b6e1-1caef89a327c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"30","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder arl"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":214,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:47
23970	9d68a052-c3a5-4b2b-9f65-0877293c4fcd	9d68a052-c4be-4769-bcf5-d93ba621c245	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/66","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":66,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":5000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"3000000","loans_pago_interes":"750000"},"items":[{"id":217,"loans_codigo":66,"itemloans_cuota":"1","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:26.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":218,"loans_codigo":66,"itemloans_cuota":"2","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":219,"loans_codigo":66,"itemloans_cuota":"3","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":220,"loans_codigo":66,"itemloans_cuota":"4","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:33.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":221,"loans_codigo":66,"itemloans_cuota":"5","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":222,"loans_codigo":66,"itemloans_cuota":"6","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:39.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":223,"loans_codigo":66,"itemloans_cuota":"7","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":224,"loans_codigo":66,"itemloans_cuota":"8","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":225,"loans_codigo":66,"itemloans_cuota":"9","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-31 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":226,"loans_codigo":66,"itemloans_cuota":"10","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:28:39
10941	9d5ca6d5-6094-4811-99e1-bb5a6875e89c	9d5ca6d5-87f6-4dfb-8c6c-a106bd09989e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 09:36:55
10942	9d5ca6d5-7ee3-4205-b02b-4e9d1a4f097b	9d5ca6d5-87f6-4dfb-8c6c-a106bd09989e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"55.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-29 09:36:55
10943	9d5ca6d5-85de-48f5-8e3f-164211edaca1	9d5ca6d5-87f6-4dfb-8c6c-a106bd09989e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 09:36:55
10944	9d5ca6d5-8686-4114-9ae4-b8aae48dddbf	9d5ca6d5-87f6-4dfb-8c6c-a106bd09989e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":368,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:36:55
12131	9d5ce0b8-4b35-4cfe-9e6e-e6a13ce0b302	9d5ce0b8-6820-4db1-8dfe-6c152ced079b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-29 12:18:47
12132	9d5ce0b8-6386-4617-9b94-bbc31683127d	9d5ce0b8-6820-4db1-8dfe-6c152ced079b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder arle%' or \\"users\\".\\"user_document\\"::text like '%Eder arle%' order by \\"users\\".\\"user_document\\" asc","time":"46.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:47
12133	9d5ce0b8-66c2-4473-8709-07c6e92c44b4	9d5ce0b8-6820-4db1-8dfe-6c152ced079b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-29 12:18:47
12134	9d5ce0b8-6719-4a61-b898-8e2ea47e2758	9d5ce0b8-6820-4db1-8dfe-6c152ced079b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"31","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder arle"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:47
23971	9d68a056-5db6-4399-8411-7ff1698d29b6	9d68a056-6543-428f-93d3-86e4bb5900ad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":226,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:28:41
24254	9d68b21e-a741-4ba9-acb6-a20bb41f8ed1	9d68b21e-a86d-444e-ade3-0b61be68641e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"801","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"1004655468","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_valor_prestado":"1100000","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":19,"user_recomendacion":14,"loans_inicio_pago":"Mon Nov 04 2024","created_at":null,"updated_at":null,"deleted_at":null,"loans_pago_prestado":0,"loans_pago_interes":0},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Mon Nov 04 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":71},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:18:25
12135	9d5ce0b8-a714-4d59-a5f3-69e4dbb3bef7	9d5ce0b8-aa08-40af-a69a-a5b2809bac3c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":147,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:47
23972	9d68a056-bdde-46d5-9d5e-14774d8547c7	9d68a056-e290-48aa-8c23-c2f564210835	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 08:28:41
23973	9d68a056-d729-4d34-9552-d25ac15075a2	9d68a056-e290-48aa-8c23-c2f564210835	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 223 limit 1","time":"2.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 08:28:42
23974	9d68a056-d783-403a-a530-c05f79cb68ed	9d68a056-e290-48aa-8c23-c2f564210835	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 08:28:42
10949	9d5ca6d6-761f-41a8-a13b-f96c4054062b	9d5ca6d6-8e46-40be-b446-320076c894ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 09:36:56
23975	9d68a056-d8f2-40a0-872c-943a84735641	9d68a056-e290-48aa-8c23-c2f564210835	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 66 limit 1","time":"1.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 08:28:42
23976	9d68a056-d921-454c-92e2-3a79c78afc6d	9d68a056-e290-48aa-8c23-c2f564210835	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 08:28:42
23977	9d68a056-dcfd-4a48-8cbb-537aa7a220e6	9d68a056-e290-48aa-8c23-c2f564210835	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '125000', \\"itemloans_cuota_cancelada\\" = '500000', \\"updated_at\\" = '2024-11-04 08:28:42' where \\"id\\" = 223","time":"7.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":400,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 08:28:42
23978	9d68a056-dd6b-4f87-931b-51253d33ae0a	9d68a056-e290-48aa-8c23-c2f564210835	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:223","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 08:28:42","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},"hostname":"EderCortes"}	2024-11-04 08:28:42
23979	9d68a056-de1c-41b9-8b02-2f3bb609d710	9d68a056-e290-48aa-8c23-c2f564210835	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 875000, \\"loans_pago_prestado\\" = 3500000, \\"updated_at\\" = '2024-11-04 08:28:42' where \\"id\\" = 66","time":"0.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":408,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 08:28:42
23980	9d68a056-de50-486b-847f-457afa818ed2	9d68a056-e290-48aa-8c23-c2f564210835	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:66","changes":{"updated_at":"2024-11-04 08:28:42","loans_pago_interes":875000,"loans_pago_prestado":3500000},"hostname":"EderCortes"}	2024-11-04 08:28:42
23981	9d68a056-e114-452b-806a-89615f65bf3f	9d68a056-e290-48aa-8c23-c2f564210835	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 08:28:42
23982	9d68a056-e178-4879-883c-fe334ef2f313	9d68a056-e290-48aa-8c23-c2f564210835	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"180","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000","id":223,"loans_codigo":66,"itemloans_cuota":"7","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":255,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:28:42
24255	9d68b221-bd1d-48dc-b061-2e3050ea4e68	9d68b221-c0a8-46cc-8298-b0425539d493	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":177,"memory":20,"hostname":"EderCortes"}	2024-11-04 09:18:27
12136	9d5ce0b8-f816-4c5a-90fd-15c4b112b512	9d5ce0b9-1188-4e1c-84e7-97ef4f733d42	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-29 12:18:47
12137	9d5ce0b9-0da2-4acb-9e45-88d97867880d	9d5ce0b9-1188-4e1c-84e7-97ef4f733d42	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder arley%' or \\"users\\".\\"user_document\\"::text like '%Eder arley%' order by \\"users\\".\\"user_document\\" asc","time":"39.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:47
12138	9d5ce0b9-1066-4947-a8d4-0b8016f2e9d0	9d5ce0b9-1188-4e1c-84e7-97ef4f733d42	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-29 12:18:47
12139	9d5ce0b9-10a8-40d0-a6de-1d2b3c19b3cb	9d5ce0b9-1188-4e1c-84e7-97ef4f733d42	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"32","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder arley"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":211,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:47
23983	9d68a057-9a87-431c-bebf-20567fff0e9b	9d68a057-b8d0-489e-ad94-2fb63ef3ba2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 08:28:42
23984	9d68a057-b007-4ed6-95af-3b309d6ad5d8	9d68a057-b8d0-489e-ad94-2fb63ef3ba2b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 66\\n                        ","time":"42.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"f5566f306d2be9466f2c4564ce0020bd","hostname":"EderCortes"}	2024-11-04 08:28:42
23985	9d68a057-b372-4bfc-8a2f-25fe5dddd0dd	9d68a057-b8d0-489e-ad94-2fb63ef3ba2b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '66' order by \\"item_loans\\".\\"id\\" asc","time":"2.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:28:42
23986	9d68a057-b3bc-43ed-b7cf-e94411019c63	9d68a057-b8d0-489e-ad94-2fb63ef3ba2b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 08:28:42
23987	9d68a057-b781-481b-9063-02044647b520	9d68a057-b8d0-489e-ad94-2fb63ef3ba2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 08:28:42
23988	9d68a057-b7cd-4482-972a-72d96038e934	9d68a057-b8d0-489e-ad94-2fb63ef3ba2b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/66","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":66,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":5000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"3500000","loans_pago_interes":"875000"},"items":[{"id":217,"loans_codigo":66,"itemloans_cuota":"1","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:26.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":218,"loans_codigo":66,"itemloans_cuota":"2","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":219,"loans_codigo":66,"itemloans_cuota":"3","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":220,"loans_codigo":66,"itemloans_cuota":"4","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:33.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":221,"loans_codigo":66,"itemloans_cuota":"5","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":222,"loans_codigo":66,"itemloans_cuota":"6","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:39.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":223,"loans_codigo":66,"itemloans_cuota":"7","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:42.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":224,"loans_codigo":66,"itemloans_cuota":"8","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":225,"loans_codigo":66,"itemloans_cuota":"9","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-31 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":226,"loans_codigo":66,"itemloans_cuota":"10","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:28:42
24256	9d68b222-7734-4b88-8875-878c4ee87420	9d68b222-c412-4166-a04a-1e5b4330ec38	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 09:18:27
12140	9d5ce0b9-48d7-40d0-b78d-f485f35f724f	9d5ce0b9-4c4e-4126-bb62-8ddb34af3326	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":128,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:47
23989	9d68a05d-4722-4419-940c-4e3ddb3a4d12	9d68a05d-4acf-439d-a15d-c86c2e65fde7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":159,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:28:46
24257	9d68b222-b7f9-41ec-ae2c-c4609f60c174	9d68b222-c412-4166-a04a-1e5b4330ec38	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\", \\"loans_fecha_ultimo_pago\\", \\"loans_intereses_recaudar\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta 2', 'De las nieve', 'ds', 'CC', '1004655468', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon2', 'Calle 7505', '1100000', 25, 5, 'S', null, '04-11-2024', 'Pendiente', '312596295', 12, 14, 19, 14, '04-11-2024', 0, 0, '04-11-2024', 275000, '2024-11-04 09:18:27', '2024-11-04 09:18:27') returning \\"id\\"","time":"4.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":110,"hash":"f69b6b91ceb0fd9e0c386e94fcedc496","hostname":"EderCortes"}	2024-11-04 09:18:27
24258	9d68b222-b865-4b2e-a7c4-2cf116d44ff9	9d68b222-c412-4166-a04a-1e5b4330ec38	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:72","hostname":"EderCortes"}	2024-11-04 09:18:27
24259	9d68b222-b9ca-4d47-b5e8-e6128815f767	9d68b222-c412-4166-a04a-1e5b4330ec38	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (72, 1, 220000, 55000, 'Pendiente', 'N\\/A', '12-11-2024', 12, 0, 0, '2024-11-04 09:18:27', '2024-11-04 09:18:27')","time":"2.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:27
24260	9d68b222-ba06-4123-9211-962d3742dd4e	9d68b222-c412-4166-a04a-1e5b4330ec38	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:27
24261	9d68b222-ba87-427a-b4f8-caacaa9a7db4	9d68b222-c412-4166-a04a-1e5b4330ec38	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (72, 2, 220000, 55000, 'Pendiente', 'N\\/A', '20-11-2024', 12, 0, 0, '2024-11-04 09:18:27', '2024-11-04 09:18:27')","time":"0.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:27
24262	9d68b222-baaf-4630-be0e-d7665cadd8a4	9d68b222-c412-4166-a04a-1e5b4330ec38	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:27
24263	9d68b222-bb1a-46aa-886c-2ab2c6e1453d	9d68b222-c412-4166-a04a-1e5b4330ec38	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (72, 3, 220000, 55000, 'Pendiente', 'N\\/A', '28-11-2024', 12, 0, 0, '2024-11-04 09:18:27', '2024-11-04 09:18:27')","time":"0.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:27
24264	9d68b222-bb3a-4f43-ba72-e5e601c9e328	9d68b222-c412-4166-a04a-1e5b4330ec38	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:27
24265	9d68b222-bbbe-43b7-ad9b-849f67011e9b	9d68b222-c412-4166-a04a-1e5b4330ec38	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (72, 4, 220000, 55000, 'Pendiente', 'N\\/A', '06-12-2024', 12, 0, 0, '2024-11-04 09:18:27', '2024-11-04 09:18:27')","time":"0.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:27
24266	9d68b222-bbe4-4142-b59e-12ec6424de9c	9d68b222-c412-4166-a04a-1e5b4330ec38	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:27
24267	9d68b222-bc65-439e-977e-386780789aea	9d68b222-c412-4166-a04a-1e5b4330ec38	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (72, 5, 220000, 55000, 'Pendiente', 'N\\/A', '14-12-2024', 12, 0, 0, '2024-11-04 09:18:27', '2024-11-04 09:18:27')","time":"0.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:27
24268	9d68b222-bc8a-44e9-b7b0-620355d0da0b	9d68b222-c412-4166-a04a-1e5b4330ec38	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:27
12141	9d5ce0b9-91ee-4f13-8a22-b878ac333132	9d5ce0b9-94a0-45e1-97af-b45840f8c22e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":121,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:48
23990	9d68a05e-005b-44aa-86a1-0d96e02c490c	9d68a05e-4e6d-42cf-b1e0-3f573ab5e764	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 08:28:46
23991	9d68a05e-448b-4139-929a-b05c4f8c4d5c	9d68a05e-4e6d-42cf-b1e0-3f573ab5e764	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 224 limit 1","time":"2.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 08:28:46
17955	9d65b4ab-6581-4a3b-ba84-b938bf8a3548	9d65b4ab-88e2-4e87-bd89-f466b37b4831	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 21:38:03
17956	9d65b4ab-86d7-4793-90bd-8cb6941aa52c	9d65b4ab-88e2-4e87-bd89-f466b37b4831	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:38:03
17957	9d65b4ab-87ba-417c-a43d-255acdaa2f87	9d65b4ab-88e2-4e87-bd89-f466b37b4831	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:38:03
23992	9d68a05e-44e5-48ec-909b-b16bfcf22f2c	9d68a05e-4e6d-42cf-b1e0-3f573ab5e764	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 08:28:46
23993	9d68a05e-4695-48ca-85ad-e990f386caa0	9d68a05e-4e6d-42cf-b1e0-3f573ab5e764	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 66 limit 1","time":"1.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 08:28:46
23994	9d68a05e-46c4-45b7-bb10-2e4fd02af846	9d68a05e-4e6d-42cf-b1e0-3f573ab5e764	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 08:28:46
23995	9d68a05e-4843-4a6e-8622-18173ef1d589	9d68a05e-4e6d-42cf-b1e0-3f573ab5e764	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '125000', \\"itemloans_cuota_cancelada\\" = '500000', \\"updated_at\\" = '2024-11-04 08:28:46' where \\"id\\" = 224","time":"2.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":400,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 08:28:46
23996	9d68a05e-48b6-4083-9cf9-c10022274256	9d68a05e-4e6d-42cf-b1e0-3f573ab5e764	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:224","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 08:28:46","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},"hostname":"EderCortes"}	2024-11-04 08:28:46
23997	9d68a05e-4984-436e-aeec-7c339ed34be4	9d68a05e-4e6d-42cf-b1e0-3f573ab5e764	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 1000000, \\"loans_pago_prestado\\" = 4000000, \\"updated_at\\" = '2024-11-04 08:28:46' where \\"id\\" = 66","time":"0.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":408,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 08:28:46
23998	9d68a05e-49c2-481a-8575-5e5cf8fe43a3	9d68a05e-4e6d-42cf-b1e0-3f573ab5e764	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:66","changes":{"updated_at":"2024-11-04 08:28:46","loans_pago_interes":1000000,"loans_pago_prestado":4000000},"hostname":"EderCortes"}	2024-11-04 08:28:46
23999	9d68a05e-4cf5-4efe-8576-ec1196fa4923	9d68a05e-4e6d-42cf-b1e0-3f573ab5e764	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 08:28:46
24000	9d68a05e-4d39-4c51-9f43-425fa5ea06df	9d68a05e-4e6d-42cf-b1e0-3f573ab5e764	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"180","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000","id":224,"loans_codigo":66,"itemloans_cuota":"8","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":359,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:28:46
24269	9d68b222-c2ae-4d94-92bd-88d2b23fb881	9d68b222-c412-4166-a04a-1e5b4330ec38	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 09:18:27
24270	9d68b222-c2f0-48c9-9aad-6426e2fbac66	9d68b222-c412-4166-a04a-1e5b4330ec38	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"801","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"1004655468","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_valor_prestado":"1100000","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":19,"user_recomendacion":14,"loans_inicio_pago":"Mon Nov 04 2024","created_at":null,"updated_at":null,"deleted_at":null,"loans_pago_prestado":0,"loans_pago_interes":0},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Mon Nov 04 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":72},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:18:27
17958	9d65b4ac-01d8-42d8-8b8c-dce90f374ecc	9d65b4ac-2846-4499-a40e-501ab1104771	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:38:04
17959	9d65b4ac-1d50-42c3-b794-9f0a97ebae8f	9d65b4ac-2846-4499-a40e-501ab1104771	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"51.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"2b11ef88578e3c91c11800e110e490df","hostname":"EderCortes"}	2024-11-02 21:38:04
17960	9d65b4ac-21b8-4171-9cc1-be42624393c2	9d65b4ac-2846-4499-a40e-501ab1104771	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"2.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:38:04
10114	9d56c8e9-9da7-4d7e-8585-673f73a856ef	9d56c8e9-ee63-4bae-b25d-ccadfcae8f7c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 11:37:15
10115	9d56c8e9-ec96-42af-be83-964f7ceba079	9d56c8e9-ee63-4bae-b25d-ccadfcae8f7c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:37:15
10116	9d56c8e9-ed4c-426f-88f4-db4257c97d4d	9d56c8e9-ee63-4bae-b25d-ccadfcae8f7c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":412,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:37:15
17961	9d65b4ac-21f1-44ba-93ac-47b3b104d81d	9d65b4ac-2846-4499-a40e-501ab1104771	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:38:04
17962	9d65b4ac-26c3-434b-85cc-38401ad43680	9d65b4ac-2846-4499-a40e-501ab1104771	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:38:04
17963	9d65b4ac-2740-4d4c-b450-4ca5e8b93314	9d65b4ac-2846-4499-a40e-501ab1104771	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:38:04
24001	9d68a05e-9129-4ed3-8aeb-30178af8a5c7	9d68a05e-b2ae-42bf-b5ab-80046de6ba37	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 08:28:47
24002	9d68a05e-a962-4a0d-9c16-9f33c0ee214a	9d68a05e-b2ae-42bf-b5ab-80046de6ba37	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 66\\n                        ","time":"47.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"f5566f306d2be9466f2c4564ce0020bd","hostname":"EderCortes"}	2024-11-04 08:28:47
24003	9d68a05e-ad34-4830-8ebc-37672d3cb4fb	9d68a05e-b2ae-42bf-b5ab-80046de6ba37	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '66' order by \\"item_loans\\".\\"id\\" asc","time":"2.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:28:47
24004	9d68a05e-ad64-4b82-9c11-032b35a18ac7	9d68a05e-b2ae-42bf-b5ab-80046de6ba37	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 08:28:47
24005	9d68a05e-b15c-4cd5-8075-fc2890429543	9d68a05e-b2ae-42bf-b5ab-80046de6ba37	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 08:28:47
10117	9d56c8ea-4abe-4912-a44b-5d02cac3da19	9d56c8ea-6422-4793-a190-019f98c75a15	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:37:15
10118	9d56c8ea-5fb9-4086-b6b0-e5f97dd3ea9c	9d56c8ea-6422-4793-a190-019f98c75a15	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"41.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:37:15
10119	9d56c8ea-62e9-4f1e-bfc2-793ac79eee64	9d56c8ea-6422-4793-a190-019f98c75a15	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:37:15
10120	9d56c8ea-632b-4477-aa99-48346aa247ef	9d56c8ea-6422-4793-a190-019f98c75a15	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:37:15
12142	9d5ce0b9-e1e1-45cd-9be3-ab85cf591650	9d5ce0b9-e4c3-4977-89f6-8ddeb2cac97d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":138,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:48
17964	9d65b4ad-f4c6-452e-a8e9-2a4be3f3a2e7	9d65b4ae-440f-4466-8e55-ddaeb9b83a88	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:38:05
17965	9d65b4ae-3eef-4ccf-8f1c-e4f2e63672db	9d65b4ae-440f-4466-8e55-ddaeb9b83a88	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"156.48","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 21:38:05
17966	9d65b4ae-3f44-433a-bba2-454b0a506030	9d65b4ae-440f-4466-8e55-ddaeb9b83a88	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 21:38:05
17967	9d65b4ae-42bb-40d8-ac87-85489a50cc00	9d65b4ae-440f-4466-8e55-ddaeb9b83a88	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 21:38:05
17968	9d65b4ae-4301-4e4e-9323-d4746e26a5fd	9d65b4ae-440f-4466-8e55-ddaeb9b83a88	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":462,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:38:05
24271	9d68b223-ab08-49f2-ae6e-6608fab8328e	9d68b223-add8-4efa-b62d-57823ad292db	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":144,"memory":20,"hostname":"EderCortes"}	2024-11-04 09:18:28
10121	9d56c8eb-7322-49c0-b2d4-669e7b338a20	9d56c8eb-bbb7-476d-bd0e-d838a0ddda1f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 11:37:16
10122	9d56c8eb-b6d0-4190-acad-65fc74f10bb0	9d56c8eb-bbb7-476d-bd0e-d838a0ddda1f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"152.75","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:37:16
10123	9d56c8eb-b741-41e4-ae0e-bd902ebe1ee2	9d56c8eb-bbb7-476d-bd0e-d838a0ddda1f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:37:16
10124	9d56c8eb-ba93-4806-a9ef-18983d2658d5	9d56c8eb-bbb7-476d-bd0e-d838a0ddda1f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 11:37:16
10125	9d56c8eb-bad3-4859-ac47-c03db0bfe281	9d56c8eb-bbb7-476d-bd0e-d838a0ddda1f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":430,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:37:16
12143	9d5ce0ba-3620-44b3-abc8-89db9f079aa9	9d5ce0ba-4f52-4acd-883b-f8207a09b62d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-29 12:18:48
12144	9d5ce0ba-4b7c-492e-a401-74162a4bb120	9d5ce0ba-4f52-4acd-883b-f8207a09b62d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder arle%' or \\"users\\".\\"user_document\\"::text like '%Eder arle%' order by \\"users\\".\\"user_document\\" asc","time":"39.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:48
10950	9d5ca6d6-8a5c-4851-b9a0-e5e528c84fff	9d5ca6d6-8e46-40be-b446-320076c894ff	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"40.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-29 09:36:56
10951	9d5ca6d6-8d02-426f-a3da-d187428e90c0	9d5ca6d6-8e46-40be-b446-320076c894ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 09:36:56
12145	9d5ce0ba-4e2e-4f61-9119-bce210a26cf3	9d5ce0ba-4f52-4acd-883b-f8207a09b62d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-29 12:18:48
12146	9d5ce0ba-4e71-4070-bc68-cb5859d550e3	9d5ce0ba-4f52-4acd-883b-f8207a09b62d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"31","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder arle"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":220,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:48
24006	9d68a05e-b1a5-4e8e-9e6a-a2c8b419ed5f	9d68a05e-b2ae-42bf-b5ab-80046de6ba37	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/66","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":66,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":5000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"4000000","loans_pago_interes":"1000000"},"items":[{"id":217,"loans_codigo":66,"itemloans_cuota":"1","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:26.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":218,"loans_codigo":66,"itemloans_cuota":"2","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":219,"loans_codigo":66,"itemloans_cuota":"3","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":220,"loans_codigo":66,"itemloans_cuota":"4","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:33.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":221,"loans_codigo":66,"itemloans_cuota":"5","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":222,"loans_codigo":66,"itemloans_cuota":"6","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:39.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":223,"loans_codigo":66,"itemloans_cuota":"7","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:42.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":224,"loans_codigo":66,"itemloans_cuota":"8","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:46.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":225,"loans_codigo":66,"itemloans_cuota":"9","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-31 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":226,"loans_codigo":66,"itemloans_cuota":"10","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:28:47
12147	9d5ce0ba-8885-4904-977f-d50b93e81034	9d5ce0ba-8b3a-4dd9-9f3f-90f12d250fd2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":134,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:48
24007	9d68a063-7cad-4b3d-ba7d-4576916f3c5a	9d68a063-7fe4-4783-893d-3aa21217bcb4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":146,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:28:50
24272	9d68b224-6374-4d29-b3a8-c98ebc7d772b	9d68b224-949f-444c-8035-b0fdada5aa31	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 09:18:28
24273	9d68b224-88c4-4a09-b0c7-816cc12fb032	9d68b224-949f-444c-8035-b0fdada5aa31	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\", \\"loans_fecha_ultimo_pago\\", \\"loans_intereses_recaudar\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta 2', 'De las nieve', 'ds', 'CC', '1004655468', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon2', 'Calle 7505', '1100000', 25, 5, 'S', null, '04-11-2024', 'Pendiente', '312596295', 12, 14, 19, 14, '04-11-2024', 0, 0, '04-11-2024', 275000, '2024-11-04 09:18:28', '2024-11-04 09:18:28') returning \\"id\\"","time":"6.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":110,"hash":"f69b6b91ceb0fd9e0c386e94fcedc496","hostname":"EderCortes"}	2024-11-04 09:18:28
24274	9d68b224-893c-44da-ada8-bc4553177cbc	9d68b224-949f-444c-8035-b0fdada5aa31	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:73","hostname":"EderCortes"}	2024-11-04 09:18:28
24275	9d68b224-8b74-42f4-8b73-9b1b10171eee	9d68b224-949f-444c-8035-b0fdada5aa31	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (73, 1, 220000, 55000, 'Pendiente', 'N\\/A', '12-11-2024', 12, 0, 0, '2024-11-04 09:18:28', '2024-11-04 09:18:28')","time":"4.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:28
24276	9d68b224-8ba8-4c87-9a82-c751ade1eb36	9d68b224-949f-444c-8035-b0fdada5aa31	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:28
24277	9d68b224-8c48-43af-9661-6aa1e3190b0d	9d68b224-949f-444c-8035-b0fdada5aa31	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (73, 2, 220000, 55000, 'Pendiente', 'N\\/A', '20-11-2024', 12, 0, 0, '2024-11-04 09:18:28', '2024-11-04 09:18:28')","time":"0.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:28
24278	9d68b224-8c89-40dc-9f97-c7fc67ad0a83	9d68b224-949f-444c-8035-b0fdada5aa31	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:28
24279	9d68b224-8d34-4925-ac6a-5bb8d1ee0e6a	9d68b224-949f-444c-8035-b0fdada5aa31	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (73, 3, 220000, 55000, 'Pendiente', 'N\\/A', '28-11-2024', 12, 0, 0, '2024-11-04 09:18:28', '2024-11-04 09:18:28')","time":"0.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:28
24280	9d68b224-8d62-47a1-9284-6d6fecb29202	9d68b224-949f-444c-8035-b0fdada5aa31	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:28
24281	9d68b224-8ded-48c0-88db-ce5131fbc04a	9d68b224-949f-444c-8035-b0fdada5aa31	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (73, 4, 220000, 55000, 'Pendiente', 'N\\/A', '06-12-2024', 12, 0, 0, '2024-11-04 09:18:28', '2024-11-04 09:18:28')","time":"0.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:28
24282	9d68b224-8e19-4354-9c29-ca94249df6ec	9d68b224-949f-444c-8035-b0fdada5aa31	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:28
24283	9d68b224-8ea6-495b-a2f7-b0bf5c5645a1	9d68b224-949f-444c-8035-b0fdada5aa31	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (73, 5, 220000, 55000, 'Pendiente', 'N\\/A', '14-12-2024', 12, 0, 0, '2024-11-04 09:18:28', '2024-11-04 09:18:28')","time":"0.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:28
12148	9d5ce0ba-d58e-4d1c-9485-4bd1f7757c38	9d5ce0ba-efdd-4452-a569-1ac1a7c74b9b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-29 12:18:48
12149	9d5ce0ba-ebe5-44cf-a57a-e82468236915	9d5ce0ba-efdd-4452-a569-1ac1a7c74b9b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder arl%' or \\"users\\".\\"user_document\\"::text like '%Eder arl%' order by \\"users\\".\\"user_document\\" asc","time":"40.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:48
12150	9d5ce0ba-ee9f-456c-94c2-19ebb91eb3a2	9d5ce0ba-efdd-4452-a569-1ac1a7c74b9b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-29 12:18:48
12151	9d5ce0ba-eee0-45d8-8fe4-a5f5892738f8	9d5ce0ba-efdd-4452-a569-1ac1a7c74b9b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"30","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder arl"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":206,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:48
24008	9d68a063-e4cb-4dc9-be83-20a524b90707	9d68a064-0918-4215-8ee5-980e9f4f6326	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 08:28:50
24009	9d68a063-fff8-42eb-acb7-b1fa03805550	9d68a064-0918-4215-8ee5-980e9f4f6326	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 225 limit 1","time":"2.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 08:28:50
24010	9d68a064-004e-4f8f-858b-a022c4bc92e4	9d68a064-0918-4215-8ee5-980e9f4f6326	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 08:28:50
24011	9d68a064-020e-4fa5-a56f-a4d943623366	9d68a064-0918-4215-8ee5-980e9f4f6326	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 66 limit 1","time":"1.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 08:28:50
24012	9d68a064-023e-4279-a20c-b08db0d83474	9d68a064-0918-4215-8ee5-980e9f4f6326	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 08:28:50
24013	9d68a064-038e-4448-9089-07317fd37bad	9d68a064-0918-4215-8ee5-980e9f4f6326	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '125000', \\"itemloans_cuota_cancelada\\" = '500000', \\"updated_at\\" = '2024-11-04 08:28:50' where \\"id\\" = 225","time":"1.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":400,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 08:28:50
24014	9d68a064-03e5-4940-b1d9-7a5612d137b9	9d68a064-0918-4215-8ee5-980e9f4f6326	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:225","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 08:28:50","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},"hostname":"EderCortes"}	2024-11-04 08:28:50
24015	9d68a064-0481-4b16-b657-1a3ee7298dcf	9d68a064-0918-4215-8ee5-980e9f4f6326	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 1125000, \\"loans_pago_prestado\\" = 4500000, \\"updated_at\\" = '2024-11-04 08:28:50' where \\"id\\" = 66","time":"0.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":408,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 08:28:50
24016	9d68a064-04b2-4b2f-9f3b-b48bfc4bcb6a	9d68a064-0918-4215-8ee5-980e9f4f6326	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:66","changes":{"updated_at":"2024-11-04 08:28:50","loans_pago_interes":1125000,"loans_pago_prestado":4500000},"hostname":"EderCortes"}	2024-11-04 08:28:50
24017	9d68a064-07d8-45e6-852d-87e0642d570b	9d68a064-0918-4215-8ee5-980e9f4f6326	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 08:28:50
24018	9d68a064-0818-4df0-95a2-ba344afaccb7	9d68a064-0918-4215-8ee5-980e9f4f6326	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"180","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000","id":225,"loans_codigo":66,"itemloans_cuota":"9","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":263,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:28:50
24284	9d68b224-8edb-4f3e-8099-c905dc2bae20	9d68b224-949f-444c-8035-b0fdada5aa31	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:28
24285	9d68b224-934a-44a9-9fb6-5c43c5117af5	9d68b224-949f-444c-8035-b0fdada5aa31	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 09:18:29
12152	9d5ce0bb-4862-4aa0-ba95-4ad312b2e489	9d5ce0bb-6183-4d25-b6fb-e393bd5f77ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-29 12:18:49
12153	9d5ce0bb-5d87-4ec9-887c-f3263ec6ff7d	9d5ce0bb-6183-4d25-b6fb-e393bd5f77ef	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder ar%' or \\"users\\".\\"user_document\\"::text like '%Eder ar%' order by \\"users\\".\\"user_document\\" asc","time":"38.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:49
12154	9d5ce0bb-6040-433c-aef6-b44a4131ac44	9d5ce0bb-6183-4d25-b6fb-e393bd5f77ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-29 12:18:49
12155	9d5ce0bb-6092-4508-95af-66e2702b310d	9d5ce0bb-6183-4d25-b6fb-e393bd5f77ef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"29","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder ar"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":276,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:49
24019	9d68a064-4d28-46ab-af9f-63cbb1521799	9d68a064-6ff7-43c2-9b0f-48f7b1a6c3c7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 08:28:50
12922	9d5cee6e-9f45-44b6-9b20-b92ea779e931	9d5cee6e-edec-4743-911c-12cd0ef585c1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 12:57:07
12923	9d5cee6e-eb64-437c-8df4-def48eb30c60	9d5cee6e-edec-4743-911c-12cd0ef585c1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 12:57:07
12924	9d5cee6e-ec53-42ec-bf4a-17fab77ab600	9d5cee6e-edec-4743-911c-12cd0ef585c1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":500,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:57:07
24020	9d68a064-6550-4fb6-aeea-5d0dd7f06611	9d68a064-6ff7-43c2-9b0f-48f7b1a6c3c7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 66\\n                        ","time":"47.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"f5566f306d2be9466f2c4564ce0020bd","hostname":"EderCortes"}	2024-11-04 08:28:50
24021	9d68a064-69d1-4c43-b10a-7c84448a3025	9d68a064-6ff7-43c2-9b0f-48f7b1a6c3c7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '66' order by \\"item_loans\\".\\"id\\" asc","time":"2.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:28:50
24022	9d68a064-6a05-4ee0-87f3-b341a695aed8	9d68a064-6ff7-43c2-9b0f-48f7b1a6c3c7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 08:28:50
24023	9d68a064-6e75-4da6-8c5b-93d07f5258e7	9d68a064-6ff7-43c2-9b0f-48f7b1a6c3c7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 08:28:50
24024	9d68a064-6ed2-43c4-b05e-55442b42bb69	9d68a064-6ff7-43c2-9b0f-48f7b1a6c3c7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/66","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":66,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":5000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"4500000","loans_pago_interes":"1125000"},"items":[{"id":217,"loans_codigo":66,"itemloans_cuota":"1","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:26.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":218,"loans_codigo":66,"itemloans_cuota":"2","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":219,"loans_codigo":66,"itemloans_cuota":"3","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":220,"loans_codigo":66,"itemloans_cuota":"4","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:33.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":221,"loans_codigo":66,"itemloans_cuota":"5","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":222,"loans_codigo":66,"itemloans_cuota":"6","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:39.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":223,"loans_codigo":66,"itemloans_cuota":"7","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:42.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":224,"loans_codigo":66,"itemloans_cuota":"8","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:46.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":225,"loans_codigo":66,"itemloans_cuota":"9","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-31 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:50.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":226,"loans_codigo":66,"itemloans_cuota":"10","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-03T20:50:04.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:28:50
12156	9d5ce0bb-9d13-4da3-8edd-e1e99482de2c	9d5ce0bb-a043-4bda-b2a2-7e4bab38f037	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":133,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:49
12925	9d5cee70-34b7-41ed-b8b5-c62d88c5aa10	9d5cee70-63e0-4567-9c90-fe793d6ebf5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 12:57:08
12926	9d5cee70-5c94-4980-8ce2-be63ece23217	9d5cee70-63e0-4567-9c90-fe793d6ebf5c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"49.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 12:57:08
12927	9d5cee70-5d03-441a-ba8f-8154f82cc282	9d5cee70-63e0-4567-9c90-fe793d6ebf5c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 12:57:08
12928	9d5cee70-61f9-43c9-a90f-4be342dbcb1e	9d5cee70-63e0-4567-9c90-fe793d6ebf5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 12:57:08
12929	9d5cee70-627c-43b6-8526-1632e5990a66	9d5cee70-63e0-4567-9c90-fe793d6ebf5c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":906,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:57:08
15115	9d5ecee7-7ad9-4c0d-a4ce-c45f99935ed4	9d5ecee7-ba47-41cb-8090-9d8d45f6f1fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-30 11:20:37
15116	9d5ecee7-b70c-4bec-9742-8405f0003043	9d5ecee7-ba47-41cb-8090-9d8d45f6f1fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-30 11:20:37
15117	9d5ecee7-b893-4220-80fc-02198d532b82	9d5ecee7-ba47-41cb-8090-9d8d45f6f1fb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":555,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:20:37
12157	9d5ce0bb-f727-4f9a-9305-bb7fea5361e6	9d5ce0bc-3a45-4e95-ba44-aa0f2b94a39a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-29 12:18:49
12158	9d5ce0bc-3633-4f41-8a63-c18952c5633f	9d5ce0bc-3a45-4e95-ba44-aa0f2b94a39a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder a%' or \\"users\\".\\"user_document\\"::text like '%Eder a%' order by \\"users\\".\\"user_document\\" asc","time":"146.54","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:49
12159	9d5ce0bc-3927-4aca-bf20-53564aa9d96a	9d5ce0bc-3a45-4e95-ba44-aa0f2b94a39a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-29 12:18:49
12160	9d5ce0bc-396b-4014-ae48-bf924e816d53	9d5ce0bc-3a45-4e95-ba44-aa0f2b94a39a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"28","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder a"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":327,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:49
12930	9d5cee70-e39d-4460-b22c-e5dc437c89c9	9d5cee70-e686-42de-9024-6305f78e0398	ca0a9c8dff28b69d94bcef0a9c9bc63e	t	exception	{"class":"Error","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":39,"message":"Call to a member function orderBy() on array","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"30":"                                l.loans_cuotas,","31":"                                l.loans_estado,","32":"                                l.loans_intereses,","33":"                                uco.name as cobrador,","34":"                                ure.name as recomendador","35":"                            from loans l","36":"                            join users ucl on l.user_customer = ucl.id","37":"                            join users uco on l.user_cobrador = uco.id","38":"                            left join users ure on l.user_recomendacion = ure.id","39":"                        \\")->orderBy('l.id', 'DESC');","40":"","41":"        return response()->json([","42":"            \\"data\\" => $data","43":"        ]);","44":"","45":"","46":"    }","47":"","48":"    \\/**","49":"     * Show the form for creating a new resource."},"hostname":"EderCortes","occurrences":2}	2024-10-29 12:57:09
12931	9d5cee70-cc7d-49f9-a2cd-13ddc094e780	9d5cee70-e686-42de-9024-6305f78e0398	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 12:57:09
12932	9d5cee70-e137-4ed1-a45e-8942fd14b459	9d5cee70-e686-42de-9024-6305f78e0398	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"40.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-29 12:57:09
12933	9d5cee70-e4e6-4b72-beb8-42c17e580c4a	9d5cee70-e686-42de-9024-6305f78e0398	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 12:57:09
12934	9d5cee70-e570-46f1-9151-32cef441a953	9d5cee70-e686-42de-9024-6305f78e0398	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"Call to a member function orderBy() on array","exception":"Error","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":39,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":316,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:57:09
15118	9d5ecee8-5bf3-4818-8291-53092e72a376	9d5ecee8-91c7-4fe3-8358-9ff2cb38fdef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-30 11:20:38
24025	9d68a074-7d8b-4566-b4b2-7225faaa1fd7	9d68a074-8090-489e-8928-d764d97652e7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":135,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:29:01
12161	9d5ce0bc-7a76-43f5-ad85-fc863c26c828	9d5ce0bc-bf5c-485c-a4ab-10d36afd83df	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-29 12:18:50
12162	9d5ce0bc-bb53-42b9-b054-85302b49d24d	9d5ce0bc-bf5c-485c-a4ab-10d36afd83df	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"147.73","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:50
12163	9d5ce0bc-be2e-407e-ac1e-c97a0061df8b	9d5ce0bc-bf5c-485c-a4ab-10d36afd83df	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-10-29 12:18:50
12164	9d5ce0bc-be6f-4aeb-8fb3-9d11a79a581b	9d5ce0bc-bf5c-485c-a4ab-10d36afd83df	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":323,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:50
12935	9d5cee71-34bd-4b89-b5da-3ff48d939064	9d5cee71-507f-4551-93fd-733b6c85d235	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 12:57:09
12936	9d5cee71-4ba4-4f32-b5c2-afde9e8370b8	9d5cee71-507f-4551-93fd-733b6c85d235	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"39.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 12:57:09
12937	9d5cee71-4bf2-4b1a-9289-4deec2083c4f	9d5cee71-507f-4551-93fd-733b6c85d235	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 12:57:09
12938	9d5cee71-4ef5-4eb0-9747-3b6d13b48a23	9d5cee71-507f-4551-93fd-733b6c85d235	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 12:57:09
12939	9d5cee71-4f3a-4508-a538-b0ef21769425	9d5cee71-507f-4551-93fd-733b6c85d235	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:57:09
15119	9d5ecee8-7fa6-445e-83db-84200451a744	9d5ecee8-91c7-4fe3-8358-9ff2cb38fdef	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"68.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"088d1fdbe045a08c3b0073ef22c7da32","hostname":"EderCortes"}	2024-10-30 11:20:38
15120	9d5ecee8-87c1-46bf-95d4-ae22397cac45	9d5ecee8-91c7-4fe3-8358-9ff2cb38fdef	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"3.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-30 11:20:38
15121	9d5ecee8-880a-4d23-a884-7ab10c582243	9d5ecee8-91c7-4fe3-8358-9ff2cb38fdef	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-10-30 11:20:38
15122	9d5ecee8-8fa7-401e-8807-4e2a3ccace7d	9d5ecee8-91c7-4fe3-8358-9ff2cb38fdef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-30 11:20:38
15123	9d5ecee8-9032-47ac-8ca2-1c1416fe0197	9d5ecee8-91c7-4fe3-8358-9ff2cb38fdef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":493,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:20:38
24286	9d68b224-9392-4da6-a4dc-0c29c475713e	9d68b224-949f-444c-8035-b0fdada5aa31	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"801","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"1004655468","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_valor_prestado":"1100000","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":19,"user_recomendacion":14,"loans_inicio_pago":"Mon Nov 04 2024","created_at":null,"updated_at":null,"deleted_at":null,"loans_pago_prestado":0,"loans_pago_interes":0},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Mon Nov 04 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":73},"duration":273,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:18:29
12165	9d5ce0bc-f8ed-4c7e-903a-95a1068c8301	9d5ce0bc-fc0a-4f16-8a7d-ed9111b0d525	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":130,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:50
11409	9d5cbdf7-aade-497e-a5fb-534dc1ec5793	9d5cbdf7-ee54-4ff1-b91d-5e6f7bac381a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 10:41:36
11410	9d5cbdf7-ece1-43b2-9b35-bbe1688d4e8e	9d5cbdf7-ee54-4ff1-b91d-5e6f7bac381a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 10:41:36
11411	9d5cbdf7-ed6e-4b6f-a633-53db61b18e35	9d5cbdf7-ee54-4ff1-b91d-5e6f7bac381a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":327,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:41:36
25116	9d68bfb8-0c81-4906-9aa0-5f8929947270	9d68bfb8-0e40-437c-a9b3-4253df35b0e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":943,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:56:26
11412	9d5cbdf8-371d-471a-9959-5dcbcda80095	9d5cbdf8-5457-4d1d-87d7-da91f18727cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 10:41:37
11413	9d5cbdf8-4c15-43e3-aea2-3de6a794be49	9d5cbdf8-5457-4d1d-87d7-da91f18727cd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 1\\n                        ","time":"40.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"2bd5a29c69f6bbb290fc49b79286632e","hostname":"EderCortes"}	2024-10-29 10:41:37
11414	9d5cbdf8-4f7f-4b65-bcdd-4749cebab0be	9d5cbdf8-5457-4d1d-87d7-da91f18727cd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1' order by \\"item_loans\\".\\"id\\" asc","time":"2.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 10:41:37
11415	9d5cbdf8-4fb0-4b0d-a2cb-ecaa0a1590b3	9d5cbdf8-5457-4d1d-87d7-da91f18727cd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 10:41:37
11416	9d5cbdf8-5336-4714-b12c-4fe0f9bf85a7	9d5cbdf8-5457-4d1d-87d7-da91f18727cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 10:41:37
11417	9d5cbdf8-537c-420a-a43f-7abcd4cb4bd8	9d5cbdf8-5457-4d1d-87d7-da91f18727cd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":1,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]}},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:41:37
12166	9d5ce0bd-46ba-448c-9c10-2d457d6fe9ff	9d5ce0bd-8949-4e24-b762-e3ccecde55ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-10-29 12:18:50
12167	9d5ce0bd-8575-486e-ab57-077a95db6927	9d5ce0bd-8949-4e24-b762-e3ccecde55ee	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"143.92","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:50
12168	9d5ce0bd-8833-46e9-a2aa-657f299bec1f	9d5ce0bd-8949-4e24-b762-e3ccecde55ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-10-29 12:18:50
12169	9d5ce0bd-8873-444a-a81c-05f692bca406	9d5ce0bd-8949-4e24-b762-e3ccecde55ee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":308,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:50
15124	9d5ecee9-8523-433c-a5d6-f40032b8a55a	9d5ecee9-cbce-40cd-b041-47ae46c3f89e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-30 11:20:38
15125	9d5ecee9-be0a-458c-b56c-028ec4bb1876	9d5ecee9-cbce-40cd-b041-47ae46c3f89e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"95.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 11:20:39
15126	9d5ecee9-bea1-4608-bb3e-5cbd283b9238	9d5ecee9-cbce-40cd-b041-47ae46c3f89e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 11:20:39
15127	9d5ecee9-c999-4a96-8c86-1d31fd468b6d	9d5ecee9-cbce-40cd-b041-47ae46c3f89e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-30 11:20:39
11418	9d5cbdf9-de3e-4dad-a01b-b6acfe0cd1a8	9d5cbdf9-fd6a-4982-8c67-6064715f2762	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 10:41:38
11419	9d5cbdf9-f867-4b05-a0a3-8990b64f7c93	9d5cbdf9-fd6a-4982-8c67-6064715f2762	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 10:41:38
11420	9d5cbdf9-f8c2-4d32-8388-d312c9185b0f	9d5cbdf9-fd6a-4982-8c67-6064715f2762	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 10:41:38
11421	9d5cbdf9-fc3c-4319-87da-1fe02b437b87	9d5cbdf9-fd6a-4982-8c67-6064715f2762	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 10:41:38
11422	9d5cbdf9-fc7e-4592-860c-9f8ee83f425e	9d5cbdf9-fd6a-4982-8c67-6064715f2762	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":298,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:41:38
12170	9d5ce0bd-c83e-4de6-8793-db37ccf586fc	9d5ce0bd-caf2-4bfc-821f-3874d7c86b88	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":145,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:50
15128	9d5ecee9-ca6a-4de0-8c87-a2fae4a02145	9d5ecee9-cbce-40cd-b041-47ae46c3f89e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":780,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:20:39
24032	9d68a098-f1a4-447d-8387-08ab6ce6815a	9d68a098-f465-4e95-9ccc-8846024be876	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":187,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:29:25
14451	9d5d1e2f-7e3a-4501-bc38-c951d791a75b	9d5d1e2f-b18d-4d29-a8a0-35f910faff85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":30,"hostname":"EderCortes"}	2024-10-29 15:10:39
14452	9d5d1e2f-a90b-4946-b230-1318031cedb5	9d5d1e2f-b18d-4d29-a8a0-35f910faff85	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"66.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":179,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 15:10:39
14453	9d5d1e2f-a990-4e8d-819d-09bae7d7ddf0	9d5d1e2f-b18d-4d29-a8a0-35f910faff85	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 15:10:39
14454	9d5d1e2f-b003-452e-9c6d-c1d0f56bdf5c	9d5d1e2f-b18d-4d29-a8a0-35f910faff85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":31,"hostname":"EderCortes"}	2024-10-29 15:10:39
14455	9d5d1e2f-b070-4306-9023-df5843f9ebc7	9d5d1e2f-b18d-4d29-a8a0-35f910faff85	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":642,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:10:39
12171	9d5ce0be-3ed7-4e25-b9ec-9e770ef51567	9d5ce0be-4196-4b2f-b535-844c6b02d199	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":136,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:51
15129	9d5eceea-5df3-4a5f-a939-75c2266630ac	9d5eceea-91d9-46a9-bce5-98f468545adc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-30 11:20:39
15130	9d5eceea-8719-4d1d-a3f0-d48c5819249e	9d5eceea-91d9-46a9-bce5-98f468545adc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"66.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 11:20:39
15131	9d5eceea-87a6-4f39-b171-70e23699a0cc	9d5eceea-91d9-46a9-bce5-98f468545adc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 11:20:39
14456	9d5d1e2f-fc1f-4aa0-8751-603ec4c101a2	9d5d1e30-1de1-458a-a8fb-9360f3ef6f83	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":31,"hostname":"EderCortes"}	2024-10-29 15:10:39
14457	9d5d1e30-177b-463a-9900-aae6d05b104e	9d5d1e30-1de1-458a-a8fb-9360f3ef6f83	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":179,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 15:10:39
14458	9d5d1e30-17dd-46bd-8c6a-f575e05ead22	9d5d1e30-1de1-458a-a8fb-9360f3ef6f83	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 15:10:39
14459	9d5d1e30-1cb0-4d2c-a587-4feba14a8bf6	9d5d1e30-1de1-458a-a8fb-9360f3ef6f83	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":32,"hostname":"EderCortes"}	2024-10-29 15:10:39
14460	9d5d1e30-1d02-4a5f-aa27-f621860c41e5	9d5d1e30-1de1-458a-a8fb-9360f3ef6f83	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":257,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:10:39
15132	9d5eceea-8f78-4149-857d-618b835bb259	9d5eceea-91d9-46a9-bce5-98f468545adc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-30 11:20:39
15133	9d5eceea-9006-4d23-ab79-1b5f520ec52a	9d5eceea-91d9-46a9-bce5-98f468545adc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":482,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:20:39
24287	9d68b225-238a-4427-81c2-f98788ac8e39	9d68b225-2684-4ad2-9bbf-d4aafaba8a24	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":137,"memory":20,"hostname":"EderCortes"}	2024-11-04 09:18:29
12172	9d5ce0be-8c3b-45be-8593-778db52d0625	9d5ce0be-a5af-40d1-a565-9b7006ad92eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-10-29 12:18:51
12173	9d5ce0be-a1a8-4ced-b6ee-307958a2b787	9d5ce0be-a5af-40d1-a565-9b7006ad92eb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"39.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:51
12174	9d5ce0be-a47c-408c-bc34-f12a0ba27450	9d5ce0be-a5af-40d1-a565-9b7006ad92eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-10-29 12:18:51
12175	9d5ce0be-a4c7-4802-9a3b-62e55ed367d4	9d5ce0be-a5af-40d1-a565-9b7006ad92eb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":202,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:51
15134	9d5eceeb-4db8-43b4-b7aa-9b470017f465	9d5eceeb-68fa-482b-b3e1-390c77075bcf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-30 11:20:40
15135	9d5eceeb-641b-465e-91fa-2e1730acad24	9d5eceeb-68fa-482b-b3e1-390c77075bcf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"38.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 11:20:40
15136	9d5eceeb-6479-4d8d-9a0e-f62cacb9ce75	9d5eceeb-68fa-482b-b3e1-390c77075bcf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 11:20:40
15137	9d5eceeb-67ab-4b37-a728-2c01946102af	9d5eceeb-68fa-482b-b3e1-390c77075bcf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-30 11:20:40
15138	9d5eceeb-67f1-43be-992e-4ec1a2ed8a56	9d5eceeb-68fa-482b-b3e1-390c77075bcf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:20:40
24288	9d68b225-d8a5-4b4b-b7a7-98ba14f06cad	9d68b225-fe1d-4239-8564-cf82c56e457b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 09:18:29
24289	9d68b225-f376-408f-8076-fa856051b29b	9d68b225-fe1d-4239-8564-cf82c56e457b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\", \\"loans_fecha_ultimo_pago\\", \\"loans_intereses_recaudar\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta 2', 'De las nieve', 'ds', 'CC', '1004655468', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon2', 'Calle 7505', '1100000', 25, 5, 'S', null, '04-11-2024', 'Pendiente', '312596295', 12, 14, 19, 14, '04-11-2024', 0, 0, '04-11-2024', 275000, '2024-11-04 09:18:29', '2024-11-04 09:18:29') returning \\"id\\"","time":"6.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":110,"hash":"f69b6b91ceb0fd9e0c386e94fcedc496","hostname":"EderCortes"}	2024-11-04 09:18:29
24290	9d68b225-f3cc-4110-9f5c-802653e718e4	9d68b225-fe1d-4239-8564-cf82c56e457b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:74","hostname":"EderCortes"}	2024-11-04 09:18:29
24291	9d68b225-f511-477a-bfc6-7d1fb37eb137	9d68b225-fe1d-4239-8564-cf82c56e457b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (74, 1, 220000, 55000, 'Pendiente', 'N\\/A', '12-11-2024', 12, 0, 0, '2024-11-04 09:18:29', '2024-11-04 09:18:29')","time":"2.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:29
24292	9d68b225-f53b-4e3c-a643-c0eaea6dda51	9d68b225-fe1d-4239-8564-cf82c56e457b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:29
12176	9d5ce0be-e60b-417e-9809-e4c4302e577d	9d5ce0be-e8c5-4d8f-9133-f8fb07c64d34	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":151,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:51
24293	9d68b225-f5a3-4d0c-8eca-54eb60da9a04	9d68b225-fe1d-4239-8564-cf82c56e457b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (74, 2, 220000, 55000, 'Pendiente', 'N\\/A', '20-11-2024', 12, 0, 0, '2024-11-04 09:18:29', '2024-11-04 09:18:29')","time":"0.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:29
24294	9d68b225-f5c2-41f0-bfc4-0738df9ade0e	9d68b225-fe1d-4239-8564-cf82c56e457b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:29
24295	9d68b225-f620-424f-a21c-3fb16758afda	9d68b225-fe1d-4239-8564-cf82c56e457b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (74, 3, 220000, 55000, 'Pendiente', 'N\\/A', '28-11-2024', 12, 0, 0, '2024-11-04 09:18:29', '2024-11-04 09:18:29')","time":"0.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:29
11514	9d5cbf1c-43e1-4e94-864d-4236428b4383	9d5cbf1c-67a2-48d2-b343-3737a4c5d464	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 10:44:48
11515	9d5cbf1c-657b-426a-ac5e-f7831d9f1355	9d5cbf1c-67a2-48d2-b343-3737a4c5d464	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 10:44:48
11516	9d5cbf1c-6653-4238-a6f0-8a52307008d1	9d5cbf1c-67a2-48d2-b343-3737a4c5d464	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":255,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:44:48
14461	9d5d1e30-a446-42f0-b132-c19b8d5f0e52	9d5d1e30-ec28-482f-aa20-a572f26ded97	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":32,"hostname":"EderCortes"}	2024-10-29 15:10:40
14462	9d5d1e30-e1a0-422e-bbfb-f582b9573d3b	9d5d1e30-ec28-482f-aa20-a572f26ded97	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"88.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 15:10:40
14463	9d5d1e30-e239-4c03-87c2-828c79b2c917	9d5d1e30-ec28-482f-aa20-a572f26ded97	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 15:10:40
14464	9d5d1e30-e9ee-4c7b-ab57-b388b16a2d56	9d5d1e30-ec28-482f-aa20-a572f26ded97	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":33,"hostname":"EderCortes"}	2024-10-29 15:10:40
14465	9d5d1e30-ea6b-4d19-aaea-de3fd77bb6f3	9d5d1e30-ec28-482f-aa20-a572f26ded97	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":506,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:10:40
24296	9d68b225-f640-4bd3-bad3-c35ebc40eae4	9d68b225-fe1d-4239-8564-cf82c56e457b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:29
24297	9d68b225-f6a1-4647-a676-84b3bebd5c61	9d68b225-fe1d-4239-8564-cf82c56e457b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (74, 4, 220000, 55000, 'Pendiente', 'N\\/A', '06-12-2024', 12, 0, 0, '2024-11-04 09:18:29', '2024-11-04 09:18:29')","time":"0.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:29
24298	9d68b225-f6c0-4d15-8e63-8a32d5e24b39	9d68b225-fe1d-4239-8564-cf82c56e457b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:29
24299	9d68b225-f720-424d-ad9b-5b5016bcb1e4	9d68b225-fe1d-4239-8564-cf82c56e457b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (74, 5, 220000, 55000, 'Pendiente', 'N\\/A', '14-12-2024', 12, 0, 0, '2024-11-04 09:18:29', '2024-11-04 09:18:29')","time":"0.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:29
24300	9d68b225-f758-4089-9a8b-15d1574957da	9d68b225-fe1d-4239-8564-cf82c56e457b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:29
24301	9d68b225-fcd8-4685-b7b6-0813adbfe8d1	9d68b225-fe1d-4239-8564-cf82c56e457b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 09:18:29
11517	9d5cbf1c-c0d6-4a3a-929b-b2b33e41e8f0	9d5cbf1d-0a0a-4e21-993f-002f8bb492f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 10:44:48
10192	9d56cb02-41a5-470a-bcc7-d96e4b6d1347	9d56cb02-6176-4770-9fa9-be498ac591e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 11:43:06
10193	9d56cb02-5fde-4358-a089-debafcde5831	9d56cb02-6176-4770-9fa9-be498ac591e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 11:43:06
10194	9d56cb02-6098-4e6e-b484-5ae440b97792	9d56cb02-6176-4770-9fa9-be498ac591e1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:43:06
11518	9d5cbf1d-0034-41d8-8532-8acdcadc9d6c	9d5cbf1d-0a0a-4e21-993f-002f8bb492f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 1\\n                        ","time":"150.09","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"2bd5a29c69f6bbb290fc49b79286632e","hostname":"EderCortes"}	2024-10-29 10:44:49
11519	9d5cbf1d-0451-47df-9b5e-6a11bc524293	9d5cbf1d-0a0a-4e21-993f-002f8bb492f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1' order by \\"item_loans\\".\\"id\\" asc","time":"2.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 10:44:49
11520	9d5cbf1d-0480-41d2-a71f-82d3c332a9de	9d5cbf1d-0a0a-4e21-993f-002f8bb492f0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 10:44:49
11521	9d5cbf1d-08e5-4e9c-bd2a-dc4f69f3c432	9d5cbf1d-0a0a-4e21-993f-002f8bb492f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 10:44:49
11522	9d5cbf1d-092e-480e-877b-f97c4c1fe43b	9d5cbf1d-0a0a-4e21-993f-002f8bb492f0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":1,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]}},"duration":380,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:44:49
12177	9d5ce0bf-2dda-43d9-b32c-5c2e81544097	9d5ce0bf-306f-44fd-b46f-d9a28388a88c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":122,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:51
14466	9d5d1e32-20f6-4c90-aaa6-70d041f9a9aa	9d5d1e32-5829-4292-8e8d-7a96de9df124	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":33,"hostname":"EderCortes"}	2024-10-29 15:10:41
14467	9d5d1e32-4e7b-404f-a6bd-4cabfc8b0bb0	9d5d1e32-5829-4292-8e8d-7a96de9df124	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"70.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 15:10:41
14468	9d5d1e32-4efc-4486-a17f-c7d8942d73bf	9d5d1e32-5829-4292-8e8d-7a96de9df124	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 15:10:41
14469	9d5d1e32-5637-4aa2-8d4a-2e347c3ffda3	9d5d1e32-5829-4292-8e8d-7a96de9df124	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":34,"hostname":"EderCortes"}	2024-10-29 15:10:41
14470	9d5d1e32-56bd-42b0-a44a-296d04e1e6e9	9d5d1e32-5829-4292-8e8d-7a96de9df124	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":464,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:10:41
10195	9d56cb02-ae86-45e2-85cc-5ecbfb74bbda	9d56cb02-c7ef-4a42-92db-02615b3d5a91	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 11:43:06
10196	9d56cb02-c39e-41af-afd8-489f7298f358	9d56cb02-c7ef-4a42-92db-02615b3d5a91	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"41.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:43:07
10197	9d56cb02-c6c0-4e8f-a714-7a2f2167e3e0	9d56cb02-c7ef-4a42-92db-02615b3d5a91	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 11:43:07
10198	9d56cb02-c71b-4e2e-8958-a3a2ebdfe4a5	9d56cb02-c7ef-4a42-92db-02615b3d5a91	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":223,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:43:07
11523	9d5cbf1e-7d2c-4388-88db-61c879366427	9d5cbf1e-c478-4791-93e3-b9f2315ce298	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 10:44:49
11524	9d5cbf1e-bfba-4ba1-bd5a-bb51035da0ea	9d5cbf1e-c478-4791-93e3-b9f2315ce298	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"150.27","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 10:44:50
10952	9d5ca6d6-8d49-45c3-a4e3-7bc05a953b74	9d5ca6d6-8e46-40be-b446-320076c894ff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:36:56
11525	9d5cbf1e-c003-4d2c-a6e3-647787b2010e	9d5cbf1e-c478-4791-93e3-b9f2315ce298	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 10:44:50
11526	9d5cbf1e-c348-437f-a99d-5cbd41f360ea	9d5cbf1e-c478-4791-93e3-b9f2315ce298	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 10:44:50
11527	9d5cbf1e-c38b-4d2a-868b-74700c67155a	9d5cbf1e-c478-4791-93e3-b9f2315ce298	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:44:50
12178	9d5ce0bf-7d7d-4a11-a404-beea6c4ffd37	9d5ce0bf-97c3-466a-939e-41c3ceac8452	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-10-29 12:18:51
12179	9d5ce0bf-9302-4f42-ab86-b8cd05b30069	9d5ce0bf-97c3-466a-939e-41c3ceac8452	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder A%' or \\"users\\".\\"user_document\\"::text like '%Eder A%' order by \\"users\\".\\"user_document\\" asc","time":"39.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:52
12180	9d5ce0bf-9664-4b8f-90da-e3341d53de8b	9d5ce0bf-97c3-466a-939e-41c3ceac8452	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-10-29 12:18:52
10199	9d56cb04-0721-40c3-8045-580793a99521	9d56cb04-4e81-46b6-bac0-ec1aad1ad856	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 11:43:07
10200	9d56cb04-4909-451b-8d90-42be34631546	9d56cb04-4e81-46b6-bac0-ec1aad1ad856	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"142.62","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:43:08
10201	9d56cb04-4954-4212-b67f-110f4980f3bb	9d56cb04-4e81-46b6-bac0-ec1aad1ad856	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:43:08
10202	9d56cb04-4d35-4743-b005-27b81ab6abd3	9d56cb04-4e81-46b6-bac0-ec1aad1ad856	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 11:43:08
10203	9d56cb04-4d8c-492a-b26d-410ea4c6f4bf	9d56cb04-4e81-46b6-bac0-ec1aad1ad856	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":503,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:43:08
11528	9d5cc0fb-791e-4a11-ae51-3f8d3d746168	9d5cc0fb-c64e-4326-b22d-a5959e8bfc59	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 10:50:02
11529	9d5cc0fb-c0d6-450e-99b1-391a7f903ed0	9d5cc0fb-c64e-4326-b22d-a5959e8bfc59	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"152.68","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-29 10:50:02
10953	9d5ca6d8-30ad-4b55-8bf3-a163dcfb6bc6	9d5ca6d8-750c-438d-a8a9-3adf1bc212fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 09:36:57
10954	9d5ca6d8-7009-4c68-bc5f-848f4e244629	9d5ca6d8-750c-438d-a8a9-3adf1bc212fc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"142.07","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 09:36:57
10955	9d5ca6d8-704f-4bf3-be47-47749533a550	9d5ca6d8-750c-438d-a8a9-3adf1bc212fc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 09:36:57
10956	9d5ca6d8-73a4-4d5d-8957-7e79a7d4d71d	9d5ca6d8-750c-438d-a8a9-3adf1bc212fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 09:36:57
11530	9d5cc0fb-c4d0-4450-9861-e77cad86ad42	9d5cc0fb-c64e-4326-b22d-a5959e8bfc59	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 10:50:02
11531	9d5cc0fb-c528-46a9-a960-ba19bbe341c1	9d5cc0fb-c64e-4326-b22d-a5959e8bfc59	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":383,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:50:02
12181	9d5ce0bf-96af-4883-adbf-34c9ed8e9d5c	9d5ce0bf-97c3-466a-939e-41c3ceac8452	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"28","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder A"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":212,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:52
11532	9d5cc0fe-7d2c-4a81-bf03-b219ff12f3c1	9d5cc0fe-9d6d-4c2b-b463-49980833f452	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 10:50:04
11533	9d5cc0fe-987d-4f13-a345-4a45a3699ed6	9d5cc0fe-9d6d-4c2b-b463-49980833f452	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":153,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 10:50:04
11534	9d5cc0fe-98ca-4582-9643-31753e5bf485	9d5cc0fe-9d6d-4c2b-b463-49980833f452	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 10:50:04
11535	9d5cc0fe-9c34-4ccb-bb05-577020b7d8ce	9d5cc0fe-9d6d-4c2b-b463-49980833f452	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 10:50:04
11536	9d5cc0fe-9c75-4f03-8f0b-db8b7d346fed	9d5cc0fe-9d6d-4c2b-b463-49980833f452	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":360,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:50:04
12182	9d5ce0bf-d89d-4e12-a023-e3206abca058	9d5ce0bf-f229-4dea-8ac2-0ea05ef07223	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-10-29 12:18:52
12183	9d5ce0bf-ee1c-4651-a573-dea8958a4f66	9d5ce0bf-f229-4dea-8ac2-0ea05ef07223	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder A%' or \\"users\\".\\"user_document\\"::text like '%Eder A%' order by \\"users\\".\\"user_document\\" asc","time":"39.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:52
12184	9d5ce0bf-f10c-4394-92fa-9abb7cff61c3	9d5ce0bf-f229-4dea-8ac2-0ea05ef07223	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-10-29 12:18:52
12185	9d5ce0bf-f14e-48e6-b704-ce13ac788e51	9d5ce0bf-f229-4dea-8ac2-0ea05ef07223	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"28","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder A"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":221,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:52
24047	9d68a121-055b-4a49-8591-9a2c455b5054	9d68a121-09f0-492f-bd44-3a7a3d455b60	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":222,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:30:54
24302	9d68b225-fd1c-4f84-89f6-6e95882fd163	9d68b225-fe1d-4239-8564-cf82c56e457b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"801","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"1004655468","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_valor_prestado":"1100000","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":19,"user_recomendacion":14,"loans_inicio_pago":"Mon Nov 04 2024","created_at":null,"updated_at":null,"deleted_at":null,"loans_pago_prestado":0,"loans_pago_interes":0},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Mon Nov 04 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":74},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:18:29
11537	9d5cc0fe-e05b-4747-bdf5-0d09f80310c5	9d5cc0ff-270b-44c7-8264-bd08453b190d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 10:50:04
11538	9d5cc0ff-2213-4111-a67d-b0b48cf46238	9d5cc0ff-270b-44c7-8264-bd08453b190d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"144.73","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":153,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 10:50:04
11539	9d5cc0ff-2267-4877-a882-c58fda9dcc4b	9d5cc0ff-270b-44c7-8264-bd08453b190d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 10:50:04
11540	9d5cc0ff-25eb-4d01-bf80-41b86fd0a808	9d5cc0ff-270b-44c7-8264-bd08453b190d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 10:50:04
11541	9d5cc0ff-262d-4ac3-81f3-bed3b71f1ea8	9d5cc0ff-270b-44c7-8264-bd08453b190d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:50:04
12186	9d5ce0c0-331a-4f32-8a03-217f0aa3bf13	9d5ce0c0-51b7-408c-b448-a84e9ddd3a56	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-10-29 12:18:52
12187	9d5ce0c0-4abf-48f8-988c-49d2505c5488	9d5ce0c0-51b7-408c-b448-a84e9ddd3a56	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"45.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:52
12188	9d5ce0c0-5001-4ea6-9275-68e38cb8799a	9d5ce0c0-51b7-408c-b448-a84e9ddd3a56	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-10-29 12:18:52
12189	9d5ce0c0-507a-467c-ae66-d88694dfb79f	9d5ce0c0-51b7-408c-b448-a84e9ddd3a56	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:52
24303	9d68b226-5016-4c04-98c4-a7ed0937632d	9d68b226-5406-4b1c-96ef-428eca77853a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":140,"memory":20,"hostname":"EderCortes"}	2024-11-04 09:18:30
11542	9d5cc181-45ac-4eb6-a4a3-dc1a190cc9df	9d5cc181-48a7-44b6-98eb-d35fe6a3c3e2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":148,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:51:30
12190	9d5ce0c0-976a-46cc-8149-d10dc1f351dd	9d5ce0c0-dcae-4fed-b5cd-08a402ad03e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-10-29 12:18:52
12191	9d5ce0c0-d871-44d5-a9a3-19e576083b68	9d5ce0c0-dcae-4fed-b5cd-08a402ad03e1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"151.78","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:52
12192	9d5ce0c0-db8a-4dcb-8753-04e08af171f9	9d5ce0c0-dcae-4fed-b5cd-08a402ad03e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-10-29 12:18:52
12193	9d5ce0c0-dbca-4a32-8e54-dcc98532a065	9d5ce0c0-dcae-4fed-b5cd-08a402ad03e1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":346,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:52
24304	9d68b227-0dca-408b-9dc3-66d7a02fbaec	9d68b227-33b5-4d38-b4ce-78f15abd60b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 09:18:30
24305	9d68b227-270b-4071-8d50-d84dfd092bf8	9d68b227-33b5-4d38-b4ce-78f15abd60b0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\", \\"loans_fecha_ultimo_pago\\", \\"loans_intereses_recaudar\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta 2', 'De las nieve', 'ds', 'CC', '1004655468', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon2', 'Calle 7505', '1100000', 25, 5, 'S', null, '04-11-2024', 'Pendiente', '312596295', 12, 14, 19, 14, '04-11-2024', 0, 0, '04-11-2024', 275000, '2024-11-04 09:18:30', '2024-11-04 09:18:30') returning \\"id\\"","time":"4.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":110,"hash":"f69b6b91ceb0fd9e0c386e94fcedc496","hostname":"EderCortes"}	2024-11-04 09:18:30
24306	9d68b227-2763-47cb-be03-3e43c7d8aa0a	9d68b227-33b5-4d38-b4ce-78f15abd60b0	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:75","hostname":"EderCortes"}	2024-11-04 09:18:30
24307	9d68b227-28d1-4b6c-ac20-c1ddbf2e7c75	9d68b227-33b5-4d38-b4ce-78f15abd60b0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (75, 1, 220000, 55000, 'Pendiente', 'N\\/A', '12-11-2024', 12, 0, 0, '2024-11-04 09:18:30', '2024-11-04 09:18:30')","time":"2.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:30
24308	9d68b227-28fd-4d90-83e6-208c008cc0e9	9d68b227-33b5-4d38-b4ce-78f15abd60b0	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:30
24309	9d68b227-2974-4d44-8bf3-219d4f835d0c	9d68b227-33b5-4d38-b4ce-78f15abd60b0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (75, 2, 220000, 55000, 'Pendiente', 'N\\/A', '20-11-2024', 12, 0, 0, '2024-11-04 09:18:30', '2024-11-04 09:18:30')","time":"0.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:30
24310	9d68b227-29b3-4222-beef-767aebbe3ed1	9d68b227-33b5-4d38-b4ce-78f15abd60b0	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:30
24311	9d68b227-2a69-4055-b0f8-17a2528dd296	9d68b227-33b5-4d38-b4ce-78f15abd60b0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (75, 3, 220000, 55000, 'Pendiente', 'N\\/A', '28-11-2024', 12, 0, 0, '2024-11-04 09:18:30', '2024-11-04 09:18:30')","time":"0.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:30
24312	9d68b227-2aad-46bc-afe1-7f6210e5b0a8	9d68b227-33b5-4d38-b4ce-78f15abd60b0	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:30
24313	9d68b227-2b4a-4b56-a942-0cf171adc000	9d68b227-33b5-4d38-b4ce-78f15abd60b0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (75, 4, 220000, 55000, 'Pendiente', 'N\\/A', '06-12-2024', 12, 0, 0, '2024-11-04 09:18:30', '2024-11-04 09:18:30')","time":"0.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:30
10374	9d56cef3-3897-4961-8d8f-208c8dbe55fe	9d56cef3-59e6-4ec6-95d0-3fd3b2b90435	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 11:54:07
10375	9d56cef3-584f-49e8-a6bb-a39f44b315d1	9d56cef3-59e6-4ec6-95d0-3fd3b2b90435	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 11:54:08
10376	9d56cef3-58ff-4347-9b7c-0cbfc3bc757e	9d56cef3-59e6-4ec6-95d0-3fd3b2b90435	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:54:08
24314	9d68b227-2b78-40c5-91d3-de43bc9673d0	9d68b227-33b5-4d38-b4ce-78f15abd60b0	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:30
24062	9d68a145-c5c5-4174-918f-cc8ff9294004	9d68a145-c928-43b2-8255-2b95ff695488	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":228,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:31:18
24315	9d68b227-2bf6-4cd0-8b3a-698377f8315c	9d68b227-33b5-4d38-b4ce-78f15abd60b0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (75, 5, 220000, 55000, 'Pendiente', 'N\\/A', '14-12-2024', 12, 0, 0, '2024-11-04 09:18:30', '2024-11-04 09:18:30')","time":"0.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:30
24316	9d68b227-2c1f-4d4b-967d-63e1d439c42e	9d68b227-33b5-4d38-b4ce-78f15abd60b0	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:30
24317	9d68b227-3267-46a9-83f2-6c0254a01e7b	9d68b227-33b5-4d38-b4ce-78f15abd60b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 09:18:30
24318	9d68b227-32ad-441d-b7e9-ec6d12462b66	9d68b227-33b5-4d38-b4ce-78f15abd60b0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"801","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"1004655468","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_valor_prestado":"1100000","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":19,"user_recomendacion":14,"loans_inicio_pago":"Mon Nov 04 2024","created_at":null,"updated_at":null,"deleted_at":null,"loans_pago_prestado":0,"loans_pago_interes":0},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Mon Nov 04 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":75},"duration":259,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:18:30
10377	9d56cef3-a3df-41e1-a344-97e6235aad62	9d56cef3-bf2a-4ec5-afee-f67a3f6df1ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 11:54:08
10378	9d56cef3-bb04-478f-a73d-f64b228d4009	9d56cef3-bf2a-4ec5-afee-f67a3f6df1ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"45.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 11:54:08
10379	9d56cef3-be1b-4c8e-b0dc-8013da2eaeaa	9d56cef3-bf2a-4ec5-afee-f67a3f6df1ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 11:54:08
10380	9d56cef3-be5e-4499-873a-84d8cf25cd81	9d56cef3-bf2a-4ec5-afee-f67a3f6df1ca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:54:08
11543	9d5cc181-a770-447e-8dc4-afc85cb418f8	9d5cc181-fd70-4927-8226-54d34ea0bdbe	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 10:51:30
11544	9d5cc181-f83d-4680-b8cf-867572f09ac6	9d5cc181-fd70-4927-8226-54d34ea0bdbe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"140.03","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":71,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 10:51:30
11545	9d5cc181-fbf6-4344-ace8-814b4e29d1f5	9d5cc181-fd70-4927-8226-54d34ea0bdbe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 10:51:30
11546	9d5cc181-fc48-4ca0-bbd1-b525b3bbaa47	9d5cc181-fd70-4927-8226-54d34ea0bdbe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":368,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:51:30
12194	9d5ce0c1-1c46-40b1-bc4e-b5ffab31ab73	9d5ce0c1-1ef9-4fe6-ac7a-3bf8140101c3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":145,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:53
24063	9d68a146-7b32-4a43-8132-bbbf3cb82148	9d68a146-9c5e-4ba6-8d5f-64e580e1f22c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 08:31:19
24064	9d68a146-9280-42c9-99db-c4937a96e088	9d68a146-9c5e-4ba6-8d5f-64e580e1f22c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 66 limit 1","time":"3.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":498,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 08:31:19
24065	9d68a146-92c7-4ea5-93c8-60fbb68e9837	9d68a146-9c5e-4ba6-8d5f-64e580e1f22c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":2,"hostname":"EderCortes"}	2024-11-04 08:31:19
24066	9d68a146-945e-4288-9d82-bcab8b9e2c93	9d68a146-9c5e-4ba6-8d5f-64e580e1f22c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select count(*) as aggregate from \\"item_loans\\" where \\"loans_codigo\\" = 66 and \\"itemloans_status\\" = 'Pagada'","time":"2.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":545,"hash":"60bd91eaa209a639fc2e8afc20430a4b","hostname":"EderCortes"}	2024-11-04 08:31:19
10381	9d56cef4-e199-4ed0-a9b1-694416a442fb	9d56cef5-0444-4884-a7d1-4c7e92a9614e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 11:54:09
10382	9d56cef4-feca-4591-87a6-c93a6aef4252	9d56cef5-0444-4884-a7d1-4c7e92a9614e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"51.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:54:09
10383	9d56cef4-ff23-4a65-bf5d-6eee269b9a6c	9d56cef5-0444-4884-a7d1-4c7e92a9614e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:54:09
10384	9d56cef5-02dd-47f5-afb2-9c69a80540e6	9d56cef5-0444-4884-a7d1-4c7e92a9614e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 11:54:09
10385	9d56cef5-0329-421f-bd89-1d486fe678c3	9d56cef5-0444-4884-a7d1-4c7e92a9614e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":386,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:54:09
11547	9d5cc183-d13b-4f37-9a4f-4c0de78627b8	9d5cc183-f041-432f-82f2-42c530705277	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 10:51:31
11548	9d5cc183-ea67-45b6-8983-9ba8bcadcbc5	9d5cc183-f041-432f-82f2-42c530705277	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '18' and \\"users\\".\\"deleted_at\\" is null","time":"40.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":53,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-29 10:51:31
10957	9d5ca6d8-73ec-49c8-b022-b17082daefba	9d5ca6d8-750c-438d-a8a9-3adf1bc212fc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":322,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:36:57
11549	9d5cc183-ead6-40cc-9a13-a6c00bc3c8a2	9d5cc183-f041-432f-82f2-42c530705277	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 10:51:32
11550	9d5cc183-eedf-4d25-8419-d53ffd4ce5f0	9d5cc183-f041-432f-82f2-42c530705277	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 10:51:32
11551	9d5cc183-ef28-4cd5-b459-e1d6975d75c1	9d5cc183-f041-432f-82f2-42c530705277	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/18","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}},"duration":306,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:51:32
12195	9d5ce0c1-aa08-4243-82b1-75f8251493a3	9d5ce0c1-ad44-4ce9-a85d-995f68ec3673	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":140,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:53
24067	9d68a146-9505-4e82-9ba1-d31647107431	9d68a146-9c5e-4ba6-8d5f-64e580e1f22c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 1250000, \\"loans_pago_prestado\\" = 5000000, \\"updated_at\\" = '2024-11-04 08:31:19' where \\"id\\" = 66","time":"0.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":589,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 08:31:19
11552	9d5cc1d4-8cfa-468f-8e6a-8e720d32f8e2	9d5cc1d4-90ee-4512-8799-32cc94a1c439	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":186,"memory":20,"hostname":"EderCortes"}	2024-10-29 10:52:24
12196	9d5ce0c1-f64f-4d6e-afdb-4800e1adae26	9d5ce0c2-0eec-4b58-aedf-23f7e5f2949d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-10-29 12:18:53
12197	9d5ce0c2-0af7-4652-b794-0b121006e162	9d5ce0c2-0eec-4b58-aedf-23f7e5f2949d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Ede%' or \\"users\\".\\"user_document\\"::text like '%Ede%' order by \\"users\\".\\"user_document\\" asc","time":"38.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:53
12198	9d5ce0c2-0dbe-460e-b8ce-939d4f54e65b	9d5ce0c2-0eec-4b58-aedf-23f7e5f2949d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-10-29 12:18:53
10390	9d56cf09-e094-431b-b90e-4c6497befcda	9d56cf09-fa92-4e7e-85ec-d84b333f8939	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-26 11:54:22
12199	9d5ce0c2-0e00-4130-9c16-d2ddd64d1b05	9d5ce0c2-0eec-4b58-aedf-23f7e5f2949d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ede"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":197,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:53
24068	9d68a146-9556-40c1-8dfc-ec5e17b24ae9	9d68a146-9c5e-4ba6-8d5f-64e580e1f22c	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:66","changes":{"updated_at":"2024-11-04 08:31:19","loans_pago_interes":1250000,"loans_pago_prestado":5000000},"hostname":"EderCortes"}	2024-11-04 08:31:19
24069	9d68a146-95e4-43ed-af6c-d8a4aea1c5c7	9d68a146-9c5e-4ba6-8d5f-64e580e1f22c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 66 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"0.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":596,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 08:31:19
24070	9d68a146-9613-47c7-ae7b-1ff4571c7967	9d68a146-9c5e-4ba6-8d5f-64e580e1f22c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 08:31:19
24071	9d68a146-967f-47fa-be3b-bf6a4a44919a	9d68a146-9c5e-4ba6-8d5f-64e580e1f22c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = 125000, \\"itemloans_cuota_cancelada\\" = 500000, \\"updated_at\\" = '2024-11-04 08:31:19' where \\"id\\" = 226","time":"0.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":603,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 08:31:19
24072	9d68a146-96a5-4119-8507-08da415ba640	9d68a146-9c5e-4ba6-8d5f-64e580e1f22c	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:226","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 08:31:19","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":125000,"itemloans_cuota_cancelada":500000},"hostname":"EderCortes"}	2024-11-04 08:31:19
24073	9d68a146-96f0-4c51-91b7-f9bde45d6e98	9d68a146-9c5e-4ba6-8d5f-64e580e1f22c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"delete from \\"item_loans\\" where \\"loans_codigo\\" = 66 and \\"itemloans_status\\" = 'Pendiente'","time":"0.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":610,"hash":"89bf3c496a8b0746ff5d1219b8dc29e3","hostname":"EderCortes"}	2024-11-04 08:31:19
24074	9d68a146-9742-4293-b570-be6520600352	9d68a146-9c5e-4ba6-8d5f-64e580e1f22c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 66 limit 1","time":"0.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":613,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 08:31:19
24075	9d68a146-9b10-43c6-8c43-23d3b9a70e3e	9d68a146-9c5e-4ba6-8d5f-64e580e1f22c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 08:31:19
24076	9d68a146-9b54-40b0-a3f3-21e2220d9fbd	9d68a146-9c5e-4ba6-8d5f-64e580e1f22c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"51","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"625000","idLoans":66,"idCreador":12},"session":[],"response_status":200,"response":{"message":"El abono fue aplicado exitosamente","status":true},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:31:19
11553	9d5cc201-19cf-4906-9d42-c760ee6e2eab	9d5cc201-1d9c-4107-944b-33e03dc20f9e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":156,"memory":20,"hostname":"EderCortes"}	2024-10-29 10:52:54
12200	9d5ce0c2-5368-43ef-a8fa-63d9058c1c94	9d5ce0c2-5613-415d-9cfb-1d4ab8248d60	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":129,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:53
24319	9d68b227-7654-49f9-8ec4-13535a2418f2	9d68b227-79b4-4f9f-a997-5de3f1a78ea8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":152,"memory":20,"hostname":"EderCortes"}	2024-11-04 09:18:30
18075	9d65b78a-2447-45e1-915c-35951cf17d5e	9d65b78a-5858-4b97-a554-069970dd028b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 21:46:05
18076	9d65b78a-55aa-4146-865b-0fbf322f44c8	9d65b78a-5858-4b97-a554-069970dd028b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:46:05
18077	9d65b78a-56d6-450d-bfac-1b39fafe6a8c	9d65b78a-5858-4b97-a554-069970dd028b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":391,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:46:05
18165	9d65b970-92bc-48a7-ac0f-259fcf1e066c	9d65b970-ad1e-4d43-a1f7-4c4daa79507d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-02 21:51:24
25228	9d68c099-a9e8-4143-9106-8bc154bae9f2	9d68c099-faa4-4f93-aae1-ec60d35df07c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 09:58:54
25229	9d68c099-f857-44a2-9e96-f6bb97fe24d9	9d68c099-faa4-4f93-aae1-ec60d35df07c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 09:58:54
25230	9d68c099-f956-4c13-8b21-57e4818b34c6	9d68c099-faa4-4f93-aae1-ec60d35df07c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":550,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:58:54
12201	9d5ce0c2-a874-4ce1-a275-46639d9eb6ac	9d5ce0c2-c3a0-4db5-a654-5274d8258463	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-10-29 12:18:54
12202	9d5ce0c2-bf8a-4e6d-9e23-65fa22db0b81	9d5ce0c2-c3a0-4db5-a654-5274d8258463	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"41.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:54
12203	9d5ce0c2-c27d-4f4a-a19f-d4b910c63248	9d5ce0c2-c3a0-4db5-a654-5274d8258463	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":29,"hostname":"EderCortes"}	2024-10-29 12:18:54
12204	9d5ce0c2-c2bd-4883-9794-53a93634def9	9d5ce0c2-c3a0-4db5-a654-5274d8258463	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":218,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:54
18078	9d65b78a-f3bf-4646-aeaa-2a55e4955593	9d65b78b-2455-4505-aed7-2921d648340d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:46:05
18079	9d65b78b-188d-437b-a000-c53730202891	9d65b78b-2455-4505-aed7-2921d648340d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"70.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"2b11ef88578e3c91c11800e110e490df","hostname":"EderCortes"}	2024-11-02 21:46:06
18080	9d65b78b-1caa-4b0a-b653-99e0fba9a46b	9d65b78b-2455-4505-aed7-2921d648340d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"2.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:46:06
18081	9d65b78b-1cef-4743-a12d-88abe06805d8	9d65b78b-2455-4505-aed7-2921d648340d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:46:06
18082	9d65b78b-2275-4612-9a24-5864c47a7d40	9d65b78b-2455-4505-aed7-2921d648340d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:46:06
18083	9d65b78b-2302-4074-a127-c61543d685fb	9d65b78b-2455-4505-aed7-2921d648340d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":474,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:46:06
18166	9d65b970-ab9c-4e68-97cf-7535031ee935	9d65b970-ad1e-4d43-a1f7-4c4daa79507d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-02 21:51:24
18167	9d65b970-ac47-40ed-9b88-2b1cffff4a61	9d65b970-ad1e-4d43-a1f7-4c4daa79507d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":208,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:51:24
24320	9d68b227-cf88-4eb3-aae1-52d92b03cd26	9d68b227-f4b0-4e74-b074-b564c86813ad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 09:18:31
25231	9d68c09a-b6d9-4461-9398-1861f88f97df	9d68c09a-dd07-48c2-92a8-3383b29b7af8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 09:58:55
11557	9d5cc226-d278-48df-9df6-f190e380e4ac	9d5cc226-d65c-4fde-8944-308bda2c5838	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":198,"memory":20,"hostname":"EderCortes"}	2024-10-29 10:53:18
12205	9d5ce0c3-1bbb-4900-9bb3-992c05e971a1	9d5ce0c3-3b8f-4f0b-8e73-9848aee7e166	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":29,"hostname":"EderCortes"}	2024-10-29 12:18:54
12206	9d5ce0c3-36c8-4f3a-b08d-4cb8cb8ca066	9d5ce0c3-3b8f-4f0b-8e73-9848aee7e166	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"49.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:54
12207	9d5ce0c3-3a29-4c65-9abe-69fef0edca2b	9d5ce0c3-3b8f-4f0b-8e73-9848aee7e166	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":30,"hostname":"EderCortes"}	2024-10-29 12:18:54
12208	9d5ce0c3-3a74-4d79-8396-499d2a7db580	9d5ce0c3-3b8f-4f0b-8e73-9848aee7e166	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:54
18084	9d65b78d-89b7-4178-a8ea-ab4b35552181	9d65b78d-df80-47d6-b6bc-f30ce07acf6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:46:07
18085	9d65b78d-d665-416d-a25f-7efd1c783d78	9d65b78d-df80-47d6-b6bc-f30ce07acf6b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"163.58","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 21:46:07
18086	9d65b78d-d6dd-44e2-9296-2ed92c6f0e81	9d65b78d-df80-47d6-b6bc-f30ce07acf6b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 21:46:07
18087	9d65b78d-dd7f-49a2-b25a-cee38a66c834	9d65b78d-df80-47d6-b6bc-f30ce07acf6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 21:46:07
18088	9d65b78d-de00-4d63-b30a-816cecc13d5b	9d65b78d-df80-47d6-b6bc-f30ce07acf6b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":526,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:46:07
18168	9d65b970-f08c-424b-8382-45a9b8796ba7	9d65b971-0cec-4390-b110-7afd4f2c82ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-02 21:51:24
18169	9d65b971-0509-49ab-a9da-a11275e00df9	9d65b971-0cec-4390-b110-7afd4f2c82ed	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"41.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"2b11ef88578e3c91c11800e110e490df","hostname":"EderCortes"}	2024-11-02 21:51:24
12209	9d5ce0c3-81fd-4410-aa26-4f125c79d339	9d5ce0c3-84a1-4096-ad92-6c9a90ca9322	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":160,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:54
18170	9d65b971-0868-45a8-ac64-2134ee27f1e0	9d65b971-0cec-4390-b110-7afd4f2c82ed	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"2.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:51:24
18171	9d65b971-089b-4233-a6ad-f70b1528a8e2	9d65b971-0cec-4390-b110-7afd4f2c82ed	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:51:24
18172	9d65b971-0bc8-48a7-8d13-9dd5e348261b	9d65b971-0cec-4390-b110-7afd4f2c82ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-02 21:51:24
15287	9d5ecf82-60cd-4f87-ab98-6dbd987ba822	9d5ecf82-a24d-4ad9-a742-6cac03144dee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-10-30 11:22:19
15288	9d5ecf82-9f51-4125-abc5-a9e5fffe32f3	9d5ecf82-a24d-4ad9-a742-6cac03144dee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-10-30 11:22:19
15289	9d5ecf82-a0a4-43e1-a305-e6def4b4ebc0	9d5ecf82-a24d-4ad9-a742-6cac03144dee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":613,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:22:19
18173	9d65b971-0c10-44f5-b1f0-4b88c7b96041	9d65b971-0cec-4390-b110-7afd4f2c82ed	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":210,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:51:24
18250	9d65bb3d-cb41-42e8-ae5f-e75df03db57f	9d65bb3e-1564-409b-8abd-a4ae3d8b8829	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 21:56:26
18251	9d65bb3e-13c9-428d-804f-b6845ef96518	9d65bb3e-1564-409b-8abd-a4ae3d8b8829	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:56:26
18252	9d65bb3e-1470-4d96-9a4c-8ac038ab5e91	9d65bb3e-1564-409b-8abd-a4ae3d8b8829	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:56:26
11561	9d5cc326-e2bc-44b7-8947-5bc1b0378bf4	9d5cc326-e688-4c06-a2e8-36b295370f57	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":180,"memory":20,"hostname":"EderCortes"}	2024-10-29 10:56:06
12210	9d5ce0c3-f830-408f-ad78-ea7cedc744ce	9d5ce0c3-fb1a-4d01-a606-642ec5294434	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":125,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:54
15290	9d5ecf83-33c7-484d-ad8c-8a9be12d4b9e	9d5ecf83-651b-4166-894b-9cb12d33d289	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-10-30 11:22:19
15291	9d5ecf83-55c9-4af2-878c-630f6b22a402	9d5ecf83-651b-4166-894b-9cb12d33d289	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"64.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"088d1fdbe045a08c3b0073ef22c7da32","hostname":"EderCortes"}	2024-10-30 11:22:19
15292	9d5ecf83-5bb1-4f5c-a387-77205d700342	9d5ecf83-651b-4166-894b-9cb12d33d289	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"3.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-30 11:22:19
13026	9d5cf311-74ce-4f47-b3fc-5d260b62f39b	9d5cf311-aa49-465a-9e4a-6066ca05a91f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 13:10:05
13027	9d5cf311-a6c2-4598-ad17-83a463d0203a	9d5cf311-aa49-465a-9e4a-6066ca05a91f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 13:10:05
13028	9d5cf311-a85e-4561-a2ae-61cb3a420266	9d5cf311-aa49-465a-9e4a-6066ca05a91f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":430,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:10:05
15293	9d5ecf83-5c08-4ae3-85e2-ed48e6f1b259	9d5ecf83-651b-4166-894b-9cb12d33d289	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-10-30 11:22:19
15294	9d5ecf83-6348-46e2-8301-a2178ce1180f	9d5ecf83-651b-4166-894b-9cb12d33d289	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-10-30 11:22:19
15295	9d5ecf83-63d9-406b-9d0b-86e990465021	9d5ecf83-651b-4166-894b-9cb12d33d289	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":444,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:22:19
18174	9d65b972-42b0-401c-b558-8ea7dc2d1ed2	9d65b972-91d3-46f5-a08f-082628744b39	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-02 21:51:25
18175	9d65b972-8a80-4209-aa80-590275e9bc34	9d65b972-91d3-46f5-a08f-082628744b39	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"150.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 21:51:25
18176	9d65b972-8ad2-4980-8334-a1795432e937	9d65b972-91d3-46f5-a08f-082628744b39	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 21:51:25
18177	9d65b972-902c-43c3-9df3-699cffa9652f	9d65b972-91d3-46f5-a08f-082628744b39	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-02 21:51:25
18253	9d65bb3e-696e-4fa6-acf9-c6f5b8184f34	9d65bb3e-b2be-44da-8ae6-41f810d6d917	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:56:26
9909	9d56b6e3-875c-444d-adbf-3bed85d0af17	9d56b6e3-d3d5-4f20-ae89-afbf6070de45	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 10:46:51
9910	9d56b6e3-d202-4b67-836c-f7a9dc73dc04	9d56b6e3-d3d5-4f20-ae89-afbf6070de45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 10:46:51
9911	9d56b6e3-d2b4-405a-a361-3f8a934fc003	9d56b6e3-d3d5-4f20-ae89-afbf6070de45	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":403,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:46:51
24321	9d68b227-ea2b-46e6-8aa6-459169f47966	9d68b227-f4b0-4e74-b074-b564c86813ad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\", \\"loans_fecha_ultimo_pago\\", \\"loans_intereses_recaudar\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta 2', 'De las nieve', 'ds', 'CC', '1004655468', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon2', 'Calle 7505', '1100000', 25, 5, 'S', null, '04-11-2024', 'Pendiente', '312596295', 12, 14, 19, 14, '04-11-2024', 0, 0, '04-11-2024', 275000, '2024-11-04 09:18:31', '2024-11-04 09:18:31') returning \\"id\\"","time":"6.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":110,"hash":"f69b6b91ceb0fd9e0c386e94fcedc496","hostname":"EderCortes"}	2024-11-04 09:18:31
18178	9d65b972-909c-4f0d-a255-e4733e8e0f69	9d65b972-91d3-46f5-a08f-082628744b39	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":483,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:51:25
24322	9d68b227-ea9a-40f8-9ef6-8aebde46abac	9d68b227-f4b0-4e74-b074-b564c86813ad	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:76","hostname":"EderCortes"}	2024-11-04 09:18:31
15296	9d5ecf84-25aa-4f2e-85b9-8c3630894172	9d5ecf84-a865-4b14-99b8-d20bbf08d7ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-10-30 11:22:20
9912	9d56b6e4-2a02-4eb9-8392-0c851e4e8ac5	9d56b6e4-6a97-4383-94f0-9163f1b991d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 10:46:51
9913	9d56b6e4-658d-4e94-aa92-dbd62bd534c6	9d56b6e4-6a97-4383-94f0-9163f1b991d3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"139.60","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-26 10:46:51
9914	9d56b6e4-696d-416b-82a1-aaff030d1431	9d56b6e4-6a97-4383-94f0-9163f1b991d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 10:46:51
9915	9d56b6e4-69c5-4543-9b0a-c2c1ba4cccff	9d56b6e4-6a97-4383-94f0-9163f1b991d3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:46:51
12211	9d5ce0c4-43c1-4fbb-a6f3-e0b069fc9e74	9d5ce0c4-4663-4fff-8e5b-199b74becff3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":130,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:55
13029	9d5cf312-3f2b-4ceb-b1ca-14f12f5369b8	9d5cf312-6f4b-42e2-aea7-eb84d1cba430	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 13:10:06
13030	9d5cf312-5eef-446d-ab38-f7b4eccf6b5f	9d5cf312-6f4b-42e2-aea7-eb84d1cba430	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 28\\n                        ","time":"62.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"618a8b500e46ad393f7c65ceec660399","hostname":"EderCortes"}	2024-10-29 13:10:06
13031	9d5cf312-65a1-422b-9044-00c168d66682	9d5cf312-6f4b-42e2-aea7-eb84d1cba430	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '28' order by \\"item_loans\\".\\"id\\" asc","time":"4.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 13:10:06
13032	9d5cf312-65fc-4405-9006-b6bf08f0ac3f	9d5cf312-6f4b-42e2-aea7-eb84d1cba430	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 13:10:06
13033	9d5cf312-6d15-4151-93d5-ccd6e9ecd11a	9d5cf312-6f4b-42e2-aea7-eb84d1cba430	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 13:10:06
13034	9d5cf312-6da5-47bf-92ce-3f037d6b6f12	9d5cf312-6f4b-42e2-aea7-eb84d1cba430	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/28","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":28,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":600081,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":94,"loans_codigo":28,"itemloans_cuota":"1","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":95,"loans_codigo":28,"itemloans_cuota":"2","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":96,"loans_codigo":28,"itemloans_cuota":"3","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":97,"loans_codigo":28,"itemloans_cuota":"4","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":98,"loans_codigo":28,"itemloans_cuota":"5","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":99,"loans_codigo":28,"itemloans_cuota":"6","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":446,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:10:06
15297	9d5ecf84-63a9-46da-a301-a03f3147d7e5	9d5ecf84-a865-4b14-99b8-d20bbf08d7ed	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"81.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 11:22:20
9916	9d56b6e5-fe6f-4f74-835c-4b3c2d538ba9	9d56b6e6-1bde-477f-9e97-8b078cdb91d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 10:46:52
9917	9d56b6e6-16bb-499c-b2c7-57c5779742cb	9d56b6e6-1bde-477f-9e97-8b078cdb91d5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 10:46:52
9918	9d56b6e6-1725-470f-8fb8-27b7f1d80aed	9d56b6e6-1bde-477f-9e97-8b078cdb91d5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 10:46:52
9919	9d56b6e6-1a95-4ea8-abcb-ca60b6e7ea58	9d56b6e6-1bde-477f-9e97-8b078cdb91d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 10:46:52
9920	9d56b6e6-1ad7-4de0-be16-c4070cc99526	9d56b6e6-1bde-477f-9e97-8b078cdb91d5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-10-26 10:46:52
11565	9d5cc545-dbdc-4d41-82ed-d0ffa8fc9d81	9d5cc545-dfe2-450a-9524-744d380db845	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":193,"memory":20,"hostname":"EderCortes"}	2024-10-29 11:02:02
12212	9d5ce0c4-9312-4486-ad9e-8e0bdbbd75fe	9d5ce0c4-b030-49e3-90e5-b8328256639d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":30,"hostname":"EderCortes"}	2024-10-29 12:18:55
12213	9d5ce0c4-ac30-4953-a1ab-d309d7d2bbdf	9d5ce0c4-b030-49e3-90e5-b8328256639d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder A%' or \\"users\\".\\"user_document\\"::text like '%Eder A%' order by \\"users\\".\\"user_document\\" asc","time":"42.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:55
12214	9d5ce0c4-aeeb-4a05-a7a6-6710349a9941	9d5ce0c4-b030-49e3-90e5-b8328256639d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":31,"hostname":"EderCortes"}	2024-10-29 12:18:55
12215	9d5ce0c4-af2d-4147-b701-dd52386ca26a	9d5ce0c4-b030-49e3-90e5-b8328256639d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"28","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder A"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":218,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:55
13035	9d5cf313-38f1-450a-80af-3e05cde283e8	9d5cf313-806a-47f8-bb3c-e90608573723	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 13:10:06
13036	9d5cf313-778b-4ede-8963-e93ec5a71080	9d5cf313-806a-47f8-bb3c-e90608573723	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"108.60","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 13:10:06
13037	9d5cf313-7862-416c-b863-c8130614c349	9d5cf313-806a-47f8-bb3c-e90608573723	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 13:10:06
13038	9d5cf313-7e8d-4e5c-ba43-e534644439a3	9d5cf313-806a-47f8-bb3c-e90608573723	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 13:10:06
15298	9d5ecf84-6441-4371-8cad-c7e7f2295048	9d5ecf84-a865-4b14-99b8-d20bbf08d7ed	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 11:22:20
15299	9d5ecf84-87ee-42a5-a7ac-c1c5341523a5	9d5ecf84-a865-4b14-99b8-d20bbf08d7ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-10-30 11:22:20
12216	9d5ce0c5-0560-42e2-9687-e79822cb945b	9d5ce0c5-24c9-49a7-bb74-9198f79e6466	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":31,"hostname":"EderCortes"}	2024-10-29 12:18:55
12217	9d5ce0c5-1fc4-489e-b7e8-d0fbfecd8916	9d5ce0c5-24c9-49a7-bb74-9198f79e6466	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder A%' or \\"users\\".\\"user_document\\"::text like '%Eder A%' order by \\"users\\".\\"user_document\\" asc","time":"45.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:55
12218	9d5ce0c5-237e-4e5e-bf6d-74b71cb2bc6b	9d5ce0c5-24c9-49a7-bb74-9198f79e6466	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":32,"hostname":"EderCortes"}	2024-10-29 12:18:55
12219	9d5ce0c5-23bf-4155-ad23-cb60b4dc0cf8	9d5ce0c5-24c9-49a7-bb74-9198f79e6466	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"28","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder A"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":288,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:55
13039	9d5cf313-7f11-4c75-954c-d5dae7291d2f	9d5cf313-806a-47f8-bb3c-e90608573723	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":676,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:10:06
15300	9d5ecf84-a54a-4d96-8ae5-0f01e3a09d12	9d5ecf84-a865-4b14-99b8-d20bbf08d7ed	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":799,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:22:20
18254	9d65bb3e-a9bd-4ff0-840f-2b73384eab07	9d65bb3e-b2be-44da-8ae6-41f810d6d917	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"153.77","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"2b11ef88578e3c91c11800e110e490df","hostname":"EderCortes"}	2024-11-02 21:56:27
18255	9d65bb3e-ad3a-4e13-9f89-31499518791d	9d65bb3e-b2be-44da-8ae6-41f810d6d917	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"2.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:56:27
18256	9d65bb3e-ad86-4fc9-a942-2e6b8cd13639	9d65bb3e-b2be-44da-8ae6-41f810d6d917	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:56:27
18257	9d65bb3e-b19a-48b8-8691-c26c1ab4c468	9d65bb3e-b2be-44da-8ae6-41f810d6d917	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:56:27
11569	9d5ccaa3-1998-49b1-9634-75b8c0957e1a	9d5ccaa3-1dd5-4e91-a5bf-c5061d73aead	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":192,"memory":20,"hostname":"EderCortes"}	2024-10-29 11:17:02
12220	9d5ce0c5-63a9-454c-84d7-4edd878a4c10	9d5ce0c5-7dfe-43dd-8677-d0e0c4557aae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":32,"hostname":"EderCortes"}	2024-10-29 12:18:55
12221	9d5ce0c5-7a23-480d-9586-c107ce19c818	9d5ce0c5-7dfe-43dd-8677-d0e0c4557aae	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder Ar%' or \\"users\\".\\"user_document\\"::text like '%Eder Ar%' order by \\"users\\".\\"user_document\\" asc","time":"40.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:55
12222	9d5ce0c5-7ce0-426b-94fa-6bc2c33c2376	9d5ce0c5-7dfe-43dd-8677-d0e0c4557aae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":33,"hostname":"EderCortes"}	2024-10-29 12:18:55
12223	9d5ce0c5-7d20-480a-b511-e011660c72c3	9d5ce0c5-7dfe-43dd-8677-d0e0c4557aae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"29","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder Ar"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":214,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:55
13040	9d5cf314-7ff7-4512-9955-49fe56b7dd43	9d5cf314-9ff1-4f9b-90f4-b0515a502685	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 13:10:07
13041	9d5cf314-99de-45b6-8659-f240fd404f0d	9d5cf314-9ff1-4f9b-90f4-b0515a502685	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 13:10:07
13042	9d5cf314-9a3b-4017-be82-ae520752e70a	9d5cf314-9ff1-4f9b-90f4-b0515a502685	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 13:10:07
13043	9d5cf314-9e58-4078-8aa1-86eec10827dd	9d5cf314-9ff1-4f9b-90f4-b0515a502685	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-29 13:10:07
13044	9d5cf314-9ec0-424f-812e-9469a715b430	9d5cf314-9ff1-4f9b-90f4-b0515a502685	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":344,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:10:07
15301	9d5ecf85-2b19-4c5f-b7d6-1aa4172ec26f	9d5ecf85-71e7-4048-872e-3ca2470436e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-10-30 11:22:20
15302	9d5ecf85-6ce5-4fca-a82e-84937a71aeac	9d5ecf85-71e7-4048-872e-3ca2470436e4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"148.46","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 11:22:21
15303	9d5ecf85-6d3c-44b1-a978-6a6f635c1f86	9d5ecf85-71e7-4048-872e-3ca2470436e4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 11:22:21
15304	9d5ecf85-708e-4534-b0d4-e9d9d953209d	9d5ecf85-71e7-4048-872e-3ca2470436e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-10-30 11:22:21
24323	9d68b227-ec72-4771-b1c6-b3d1ec5b6621	9d68b227-f4b0-4e74-b074-b564c86813ad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (76, 1, 220000, 55000, 'Pendiente', 'N\\/A', '12-11-2024', 12, 0, 0, '2024-11-04 09:18:31', '2024-11-04 09:18:31')","time":"3.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:31
24324	9d68b227-ec9f-45bc-be47-23d81c3618d4	9d68b227-f4b0-4e74-b074-b564c86813ad	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:31
12224	9d5ce0c5-b5d9-4eab-b0c7-b389c066ad26	9d5ce0c5-b89d-4600-803e-b3c66de94c4c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":129,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:56
13045	9d5cf882-7168-46f4-9ad2-6e3e107462db	9d5cf882-9181-4ffd-9d4c-977504161340	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 13:25:18
13046	9d5cf882-8af9-463f-bd3a-e9d349befd1f	9d5cf882-9181-4ffd-9d4c-977504161340	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"40.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-10-29 13:25:18
13047	9d5cf882-8fe4-48f7-9ced-cb409907fe84	9d5cf882-9181-4ffd-9d4c-977504161340	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 13:25:18
13048	9d5cf882-9048-4188-b458-e78ea9abe161	9d5cf882-9181-4ffd-9d4c-977504161340	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":308,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:25:18
15305	9d5ecf85-70d5-448c-b5bd-5d0887252582	9d5ecf85-71e7-4048-872e-3ca2470436e4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":488,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:22:21
18258	9d65bb3e-b1e6-43c0-947f-1e404f1619fc	9d65bb3e-b2be-44da-8ae6-41f810d6d917	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":367,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:56:27
24325	9d68b227-ed0a-444e-a562-44f1dd4e5209	9d68b227-f4b0-4e74-b074-b564c86813ad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (76, 2, 220000, 55000, 'Pendiente', 'N\\/A', '20-11-2024', 12, 0, 0, '2024-11-04 09:18:31', '2024-11-04 09:18:31')","time":"0.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:31
24326	9d68b227-ed2c-4556-b5ad-9f4d8a10452e	9d68b227-f4b0-4e74-b074-b564c86813ad	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:31
12225	9d5ce0c5-ff25-4abd-a580-d67fb55c4512	9d5ce0c6-0207-49e1-822c-1f6af8011197	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":125,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:56
13049	9d5cf883-8bb4-4f62-ba56-a5f24d439006	9d5cf883-d7f4-48d9-ac0b-c83f935e8dff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 13:25:19
13050	9d5cf883-d312-4430-93b8-7de76b7233b7	9d5cf883-d7f4-48d9-ac0b-c83f935e8dff	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"153.96","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 13:25:19
13051	9d5cf883-d362-469a-be0a-542f04375068	9d5cf883-d7f4-48d9-ac0b-c83f935e8dff	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 13:25:19
13052	9d5cf883-d6cd-467f-a76c-c66300b34bb7	9d5cf883-d7f4-48d9-ac0b-c83f935e8dff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 13:25:19
13053	9d5cf883-d70a-47c4-ab81-9ba04d00e438	9d5cf883-d7f4-48d9-ac0b-c83f935e8dff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":466,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:25:19
24327	9d68b227-edbb-40df-a145-406ce85f0b49	9d68b227-f4b0-4e74-b074-b564c86813ad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (76, 3, 220000, 55000, 'Pendiente', 'N\\/A', '28-11-2024', 12, 0, 0, '2024-11-04 09:18:31', '2024-11-04 09:18:31')","time":"0.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:31
15034	9d5ece88-b070-4f0f-abf6-ab7283c3fd79	9d5ece88-f2e4-4ba2-a467-984567515b3a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 11:19:35
15035	9d5ece88-f007-4317-b55f-e7e0b8ead2d1	9d5ece88-f2e4-4ba2-a467-984567515b3a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 11:19:35
15036	9d5ece88-f155-4fb2-8526-327149d96548	9d5ece88-f2e4-4ba2-a467-984567515b3a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":567,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:19:35
24328	9d68b227-ede7-48b8-8d23-11cc84923756	9d68b227-f4b0-4e74-b074-b564c86813ad	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:31
24329	9d68b227-ee6f-41bc-93b8-e8bb1b5e1e83	9d68b227-f4b0-4e74-b074-b564c86813ad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (76, 4, 220000, 55000, 'Pendiente', 'N\\/A', '06-12-2024', 12, 0, 0, '2024-11-04 09:18:31', '2024-11-04 09:18:31')","time":"0.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:31
15306	9d5ecf86-2fff-4afe-b08d-5e7e39a0390c	9d5ecf86-4c74-40c1-8417-7401499bd467	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-10-30 11:22:21
18259	9d65bb40-9f82-4c04-9556-517385ca6d69	9d65bb40-e37e-46a7-8fff-00d54e5d075a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:56:28
24330	9d68b227-eeab-4f23-92bb-6f68da050da6	9d68b227-f4b0-4e74-b074-b564c86813ad	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:31
24331	9d68b227-ef63-4909-8b99-ed482824e12c	9d68b227-f4b0-4e74-b074-b564c86813ad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (76, 5, 220000, 55000, 'Pendiente', 'N\\/A', '14-12-2024', 12, 0, 0, '2024-11-04 09:18:31', '2024-11-04 09:18:31')","time":"0.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:31
24332	9d68b227-ef8c-49db-ae84-80661d994947	9d68b227-f4b0-4e74-b074-b564c86813ad	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:31
24333	9d68b227-f34d-4ab6-89fd-f52a799cd46f	9d68b227-f4b0-4e74-b074-b564c86813ad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 09:18:31
12226	9d5ce0c6-4dc2-4c2f-8011-abac2aa72b5b	9d5ce0c6-5062-46e1-a0cd-b459b47e6f92	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":135,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:56
13054	9d5cf884-17b3-4329-b9e1-1f131c623a33	9d5cf884-5e3f-4fad-a1ef-4058a3b5c702	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 13:25:19
13055	9d5cf884-594c-4569-aa09-f95f6dd10b3d	9d5cf884-5e3f-4fad-a1ef-4058a3b5c702	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"146.25","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 13:25:19
13056	9d5cf884-59ae-40dd-b71e-feb9ac19fa9d	9d5cf884-5e3f-4fad-a1ef-4058a3b5c702	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 13:25:19
13057	9d5cf884-5cf7-4ce3-a4fd-c11a5a3fdf69	9d5cf884-5e3f-4fad-a1ef-4058a3b5c702	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 13:25:19
13058	9d5cf884-5d45-4c1f-a832-6f1903921bb1	9d5cf884-5e3f-4fad-a1ef-4058a3b5c702	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":327,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:25:19
13189	9d5cfa0c-e2c3-4c20-ab29-320accb4ee88	9d5cfa0d-1a52-4e99-b0e0-9ec06aec3ddb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 13:29:37
13190	9d5cfa0d-16f1-4de4-9c97-ea94a6f8862d	9d5cfa0d-1a52-4e99-b0e0-9ec06aec3ddb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 13:29:37
13191	9d5cfa0d-1874-4bc1-829d-9200545dad7c	9d5cfa0d-1a52-4e99-b0e0-9ec06aec3ddb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":475,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:29:37
15037	9d5ece89-7368-4e2f-8e27-f797a15f5a39	9d5ece89-9eec-466d-9605-a382298b4fde	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 11:19:36
12227	9d5ce0c6-c5c6-49a3-9b2f-6509726a9ff4	9d5ce0c6-e63a-42ff-a68e-18b808882f07	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":33,"hostname":"EderCortes"}	2024-10-29 12:18:56
12228	9d5ce0c6-e18c-4918-9048-3b12526dcfe3	9d5ce0c6-e63a-42ff-a68e-18b808882f07	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder Arl%' or \\"users\\".\\"user_document\\"::text like '%Eder Arl%' order by \\"users\\".\\"user_document\\" asc","time":"50.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:56
12229	9d5ce0c6-e439-4e09-9310-b7d66f1ec2ef	9d5ce0c6-e63a-42ff-a68e-18b808882f07	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":34,"hostname":"EderCortes"}	2024-10-29 12:18:56
12230	9d5ce0c6-e477-4f0a-951a-b51cb1246110	9d5ce0c6-e63a-42ff-a68e-18b808882f07	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"30","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder Arl"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":219,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:56
13059	9d5cf887-c482-48bb-aca8-483adabfa15d	9d5cf887-c861-40ce-89cc-352a8449528e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":131,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:25:21
13192	9d5cfa0d-91d6-46d4-b1a9-9544000d1d7f	9d5cfa0d-bdbe-4ba7-a65f-63670862a83b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 13:29:37
13193	9d5cfa0d-b643-467a-9842-71206843f674	9d5cfa0d-bdbe-4ba7-a65f-63670862a83b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"57.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":180,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 13:29:37
13194	9d5cfa0d-b6b1-4a2d-a167-8602faa7e75b	9d5cfa0d-bdbe-4ba7-a65f-63670862a83b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 13:29:37
13195	9d5cfa0d-bc12-4e23-96c6-d97602eec1da	9d5cfa0d-bdbe-4ba7-a65f-63670862a83b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 13:29:37
13196	9d5cfa0d-bc90-48ac-8572-90d9d5f09b4e	9d5cfa0d-bdbe-4ba7-a65f-63670862a83b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":362,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:29:37
15038	9d5ece89-90ac-479c-b32c-c1bf8e85aabc	9d5ece89-9eec-466d-9605-a382298b4fde	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"58.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"088d1fdbe045a08c3b0073ef22c7da32","hostname":"EderCortes"}	2024-10-30 11:19:36
15039	9d5ece89-9660-4653-a6c1-58d9386b1686	9d5ece89-9eec-466d-9605-a382298b4fde	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"3.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-30 11:19:36
15040	9d5ece89-96b5-4b3d-bbcf-78dbdf9a3bd7	9d5ece89-9eec-466d-9605-a382298b4fde	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-10-30 11:19:36
15041	9d5ece89-9d4b-426a-a156-c73cc35297ff	9d5ece89-9eec-466d-9605-a382298b4fde	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-30 11:19:36
12231	9d5ce0c7-2410-4389-96c4-f54381619b96	9d5ce0c7-3f94-48d7-9abb-e6934a5a9cdb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":34,"hostname":"EderCortes"}	2024-10-29 12:18:56
12232	9d5ce0c7-3b17-4781-a8e5-a5f72f7da178	9d5ce0c7-3f94-48d7-9abb-e6934a5a9cdb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder Arle%' or \\"users\\".\\"user_document\\"::text like '%Eder Arle%' order by \\"users\\".\\"user_document\\" asc","time":"42.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:57
12233	9d5ce0c7-3e5f-468b-90b9-b442356d34d9	9d5ce0c7-3f94-48d7-9abb-e6934a5a9cdb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":35,"hostname":"EderCortes"}	2024-10-29 12:18:57
12234	9d5ce0c7-3ea7-4f7f-9782-959fbe71ad37	9d5ce0c7-3f94-48d7-9abb-e6934a5a9cdb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"31","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder Arle"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":220,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:57
13197	9d5cfa0e-1f28-4e4d-bf6d-ce85d41dc63e	9d5cfa0e-6662-480a-8c3b-865977d947e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 13:29:37
13198	9d5cfa0e-60fc-4fbc-9d18-772285242c98	9d5cfa0e-6662-480a-8c3b-865977d947e8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"145.21","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":180,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 13:29:37
13060	9d5cf888-2d38-45f8-992a-3b5ce23017c5	9d5cf888-4688-4b2a-8684-c1da2b576465	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 13:25:22
13199	9d5cfa0e-616f-45d4-b400-a99f4b1630c1	9d5cfa0e-6662-480a-8c3b-865977d947e8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 13:29:37
13200	9d5cfa0e-651e-4b3f-8509-6075b6fe3285	9d5cfa0e-6662-480a-8c3b-865977d947e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 13:29:37
13061	9d5cf888-4273-4ac8-a6f5-0977532e675a	9d5cf888-4688-4b2a-8684-c1da2b576465	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ma%' or \\"users\\".\\"user_document\\"::text like '%Ma%') order by \\"users\\".\\"user_document\\" asc","time":"38.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 13:25:22
13062	9d5cf888-4558-48cb-a577-29849bce86b0	9d5cf888-4688-4b2a-8684-c1da2b576465	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 13:25:22
13201	9d5cfa0e-656b-4e82-a6fa-0cb9de8dbb28	9d5cfa0e-6662-480a-8c3b-865977d947e8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":410,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:29:37
15042	9d5ece89-9dc0-49e4-b3db-f2bad3dfb39c	9d5ece89-9eec-466d-9605-a382298b4fde	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":387,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:19:36
15307	9d5ecf86-4742-4c1c-ad4e-9d4791923e92	9d5ecf86-4c74-40c1-8417-7401499bd467	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 11:22:21
15308	9d5ecf86-478d-43a4-aa86-f7e072dbd5bb	9d5ecf86-4c74-40c1-8417-7401499bd467	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 11:22:21
12235	9d5ce0c7-7945-4bcb-a75f-fbfaced18b0b	9d5ce0c7-7c28-453d-8f1e-0b085c3e7ff4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":128,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:57
13063	9d5cf888-459b-4e8d-80d2-6e8794c21d3c	9d5cf888-4688-4b2a-8684-c1da2b576465	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ma"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":201,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:25:22
13202	9d5cfa0f-583e-481d-a7dc-2d9073b42fa8	9d5cfa0f-a043-4056-a49b-44286267df6c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 13:29:38
13203	9d5cfa0f-9745-4b37-8814-da58e57822d8	9d5cfa0f-a043-4056-a49b-44286267df6c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"94.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 13:29:38
13204	9d5cfa0f-97bc-4f28-8e7e-c68ccc9ff078	9d5cfa0f-a043-4056-a49b-44286267df6c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 13:29:38
13205	9d5cfa0f-9e5a-4ada-9224-e05bc616571a	9d5cfa0f-a043-4056-a49b-44286267df6c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 13:29:38
13206	9d5cfa0f-9ede-4c97-9f58-5ea0b1b15fec	9d5cfa0f-a043-4056-a49b-44286267df6c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":788,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:29:38
15309	9d5ecf86-4b1e-40dc-8982-13db68d37817	9d5ecf86-4c74-40c1-8417-7401499bd467	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-10-30 11:22:21
15310	9d5ecf86-4b72-4048-b62a-4797d05cfa1f	9d5ecf86-4c74-40c1-8417-7401499bd467	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:22:21
18260	9d65bb40-de16-4e3d-a888-85ad448a28e7	9d65bb40-e37e-46a7-8fff-00d54e5d075a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"140.85","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 21:56:28
18261	9d65bb40-de7b-4095-958e-e769e6458bac	9d65bb40-e37e-46a7-8fff-00d54e5d075a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 21:56:28
18262	9d65bb40-e211-4fe0-9fc6-008c1bb3cdd5	9d65bb40-e37e-46a7-8fff-00d54e5d075a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 21:56:28
12236	9d5ce0c7-cb0b-4712-acca-0b13d301695a	9d5ce0c8-0d46-4daa-aa65-b38bcdb12558	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":35,"hostname":"EderCortes"}	2024-10-29 12:18:57
12237	9d5ce0c8-0955-44b4-8342-06aa13a9ac87	9d5ce0c8-0d46-4daa-aa65-b38bcdb12558	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder Arley%' or \\"users\\".\\"user_document\\"::text like '%Eder Arley%' order by \\"users\\".\\"user_document\\" asc","time":"141.26","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:57
12238	9d5ce0c8-0c33-44bb-b2f5-c57b9e15ef27	9d5ce0c8-0d46-4daa-aa65-b38bcdb12558	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":36,"hostname":"EderCortes"}	2024-10-29 12:18:57
12239	9d5ce0c8-0c73-4770-9e11-0e5e34353498	9d5ce0c8-0d46-4daa-aa65-b38bcdb12558	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"32","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder Arley"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":317,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:57
13064	9d5cf889-8f75-4916-b17a-82bc491fbb45	9d5cf889-923d-46d9-b6d4-e3ce24943c1c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":137,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:25:23
13207	9d5cfa10-2eac-4c1c-abb4-b49e48b7abaa	9d5cfa10-72ef-4939-8d26-e4a4a0b8c0de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 13:29:39
13208	9d5cfa10-6e03-44bd-aaa9-01b8e9c30acc	9d5cfa10-72ef-4939-8d26-e4a4a0b8c0de	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"142.57","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 13:29:39
13209	9d5cfa10-6e58-4cd7-a908-fa72b4db3e2e	9d5cfa10-72ef-4939-8d26-e4a4a0b8c0de	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 13:29:39
13210	9d5cfa10-71b9-4e72-94ec-3959342e5598	9d5cfa10-72ef-4939-8d26-e4a4a0b8c0de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 13:29:39
13211	9d5cfa10-71ff-44ea-bc2a-8cc0b0620d36	9d5cfa10-72ef-4939-8d26-e4a4a0b8c0de	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":517,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:29:39
18263	9d65bb40-e25e-4035-b603-4f0eec19b9db	9d65bb40-e37e-46a7-8fff-00d54e5d075a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":332,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:56:28
12240	9d5ce0c8-4666-4938-8569-198c6ae60ad3	9d5ce0c8-4987-4dea-bb47-18f35d385da6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":131,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:57
13065	9d5cf88a-41c4-40de-aa44-ffdf3fb51a0f	9d5cf88a-5b77-45b7-adad-6ae3f806eeed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 13:25:23
13066	9d5cf88a-5755-4639-9e5d-862984b70720	9d5cf88a-5b77-45b7-adad-6ae3f806eeed	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mar%' or \\"users\\".\\"user_document\\"::text like '%Mar%') order by \\"users\\".\\"user_document\\" asc","time":"38.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 13:25:23
13067	9d5cf88a-5a52-4eae-9ff3-fc6b0e0cca8e	9d5cf88a-5b77-45b7-adad-6ae3f806eeed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 13:25:23
13068	9d5cf88a-5a94-40ea-b1d1-a3e27e09c5fd	9d5cf88a-5b77-45b7-adad-6ae3f806eeed	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mar"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":207,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:25:23
13212	9d5cfadc-7919-41ba-991b-ad89ccdf8caf	9d5cfadc-7d7a-4559-8432-bbcca72bc717	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":179,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:31:53
24334	9d68b227-f38e-44ef-939b-735d09f17fdf	9d68b227-f4b0-4e74-b074-b564c86813ad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"801","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"1004655468","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_valor_prestado":"1100000","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":19,"user_recomendacion":14,"loans_inicio_pago":"Mon Nov 04 2024","created_at":null,"updated_at":null,"deleted_at":null,"loans_pago_prestado":0,"loans_pago_interes":0},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Mon Nov 04 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":76},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:18:31
25232	9d68c09a-d17e-4aff-a11d-f37b01cf9ae8	9d68c09a-dd07-48c2-92a8-3383b29b7af8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"50.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 09:58:55
12241	9d5ce0c8-97f7-4ec1-be39-de3a17c09de9	9d5ce0c8-9aab-4b33-9da5-b639f4befbe5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":142,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:57
13069	9d5cf88e-3741-4012-b38a-40df7de805f6	9d5cf88e-5362-4209-9b21-b77702926e01	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 13:25:26
13070	9d5cf88e-4e78-46e6-92b8-12d9e060ea0d	9d5cf88e-5362-4209-9b21-b77702926e01	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '18' and \\"users\\".\\"deleted_at\\" is null","time":"39.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":55,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-29 13:25:26
13071	9d5cf88e-4ec4-4975-b9a4-19c90499a380	9d5cf88e-5362-4209-9b21-b77702926e01	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 13:25:26
13072	9d5cf88e-5230-4335-a49c-ac3134203f5c	9d5cf88e-5362-4209-9b21-b77702926e01	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 13:25:26
13073	9d5cf88e-5272-457d-bd5d-6692a526bfcc	9d5cf88e-5362-4209-9b21-b77702926e01	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/18","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:25:26
13213	9d5cfadc-f263-4150-afac-a1eefe69d941	9d5cfadc-f580-4dfa-9e8d-995f20073b75	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":137,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:31:53
12242	9d5ce0c8-e5e7-479d-84f5-bd8a49198ba6	9d5ce0c9-006a-4c1b-bfe2-d456f37cdf62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":36,"hostname":"EderCortes"}	2024-10-29 12:18:58
12243	9d5ce0c8-fc6b-4075-aa6a-281fa04df2c4	9d5ce0c9-006a-4c1b-bfe2-d456f37cdf62	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder Arley%' or \\"users\\".\\"user_document\\"::text like '%Eder Arley%' order by \\"users\\".\\"user_document\\" asc","time":"42.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:58
12244	9d5ce0c8-ff3b-4977-9427-52193909915a	9d5ce0c9-006a-4c1b-bfe2-d456f37cdf62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":37,"hostname":"EderCortes"}	2024-10-29 12:18:58
12245	9d5ce0c8-ff7b-4016-9f61-159dcee46c5f	9d5ce0c9-006a-4c1b-bfe2-d456f37cdf62	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"33","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder Arley"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":206,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:58
13074	9d5cf8df-e3fa-459e-9452-7022d752425c	9d5cf8df-e71c-4148-aa2b-8674330d3d23	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":150,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:26:19
13214	9d5cfadd-493d-43c1-ab8b-09e0f237f687	9d5cfadd-938f-4a7a-8464-513bf9d893c3	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 13:31:53
13215	9d5cfadd-8d9d-4201-89e7-47ec3800165c	9d5cfadd-938f-4a7a-8464-513bf9d893c3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"147.40","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 13:31:53
13216	9d5cfadd-9213-42cf-a6cf-25342ff9a5d5	9d5cfadd-938f-4a7a-8464-513bf9d893c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 13:31:53
13217	9d5cfadd-9266-4027-b6ee-2dcbb316521a	9d5cfadd-938f-4a7a-8464-513bf9d893c3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:31:53
24335	9d68b228-4e47-41e0-b941-f1c1589900d2	9d68b228-51ae-4c31-a22c-a0e51be93062	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":156,"memory":20,"hostname":"EderCortes"}	2024-11-04 09:18:31
25233	9d68c09a-d5cf-490f-aa20-3e352dd4d6f2	9d68c09a-dd07-48c2-92a8-3383b29b7af8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:58:55
25234	9d68c09a-d608-4c25-9e36-028988f1d396	9d68c09a-dd07-48c2-92a8-3383b29b7af8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 09:58:55
25235	9d68c09a-db5e-4a63-b968-100f62ba63fa	9d68c09a-dd07-48c2-92a8-3383b29b7af8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 09:58:55
24336	9d68b228-dd0c-4e71-8d4e-f99cebcdce7f	9d68b228-e129-44ac-8ebb-2a18344596bf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":295,"memory":20,"hostname":"EderCortes"}	2024-11-04 09:18:31
25236	9d68c09a-dbd8-49ed-8f29-10b2dc06d54e	9d68c09a-dd07-48c2-92a8-3383b29b7af8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":529,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:58:55
9981	9d56c5c8-52c6-4be9-a839-3b44fec65ad6	9d56c5c8-768f-4846-9031-6b3b80483ad1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 11:28:29
9982	9d56c5c8-74f9-4600-9130-d273bd79acc6	9d56c5c8-768f-4846-9031-6b3b80483ad1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 11:28:29
9983	9d56c5c8-759a-4bca-a492-d8e99772e08d	9d56c5c8-768f-4846-9031-6b3b80483ad1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":282,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:28:29
25539	9d68c6dc-1037-4a18-a072-a8d630f1f9ca	9d68c6dc-55c6-4832-9eec-9364d7f483b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:16:24
24997	9d68befc-a279-4786-9cd5-20ed4adbe5f7	9d68befc-bf3c-4782-bf51-e35687dc2a93	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 09:54:23
24998	9d68befc-ba89-4c31-83c2-fda9ab37dc15	9d68befc-bf3c-4782-bf51-e35687dc2a93	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"43.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 09:54:23
24999	9d68befc-bdc3-4849-bdfe-66bece7d49a7	9d68befc-bf3c-4782-bf51-e35687dc2a93	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 09:54:23
25000	9d68befc-be2a-4fd3-9aac-7b1783832c07	9d68befc-bf3c-4782-bf51-e35687dc2a93	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":350,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:54:23
25540	9d68c6dc-46f2-4865-95d2-26877a1f23f8	9d68c6dc-55c6-4832-9eec-9364d7f483b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:16:24
25541	9d68c6dc-48aa-4590-a377-811eb1e121c1	9d68c6dc-55c6-4832-9eec-9364d7f483b4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":626,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:16:24
9984	9d56c5c8-c324-4792-afbb-426ca2ad1488	9d56c5c8-c8e2-4a2c-876b-f6bede3c531b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 11:28:30
9985	9d56c5c8-c7d0-4f12-a60b-a9d8c5593cc1	9d56c5c8-c8e2-4a2c-876b-f6bede3c531b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-26 11:28:30
9986	9d56c5c8-c827-41ff-906a-a23db497acf8	9d56c5c8-c8e2-4a2c-876b-f6bede3c531b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":"Empty Response","duration":173,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:28:30
12246	9d5ce0c9-3eed-4d69-b3cf-d2832df12136	9d5ce0c9-5869-4ce8-a0a3-07feeede5e25	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":37,"hostname":"EderCortes"}	2024-10-29 12:18:58
11054	9d5ca88c-6848-4511-ac1f-719f10b41a37	9d5ca88c-9744-45e9-b8f4-ee8dcd65ae53	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 09:41:43
11055	9d5ca88c-949f-4666-9de6-bb9fac635e8a	9d5ca88c-9744-45e9-b8f4-ee8dcd65ae53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 09:41:43
11056	9d5ca88c-95cc-4048-aeef-a932c5813858	9d5ca88c-9744-45e9-b8f4-ee8dcd65ae53	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:41:43
12247	9d5ce0c9-5488-4cde-89d0-c72ddb6dd34a	9d5ce0c9-5869-4ce8-a0a3-07feeede5e25	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder Arley C%' or \\"users\\".\\"user_document\\"::text like '%Eder Arley C%' order by \\"users\\".\\"user_document\\" asc","time":"38.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:58
12248	9d5ce0c9-5736-4ea6-90ad-b4936620e894	9d5ce0c9-5869-4ce8-a0a3-07feeede5e25	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":38,"hostname":"EderCortes"}	2024-10-29 12:18:58
12249	9d5ce0c9-5785-45ad-92ed-97397394f623	9d5ce0c9-5869-4ce8-a0a3-07feeede5e25	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"34","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder Arley C"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":217,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:58
13075	9d5cf8e0-4b32-4c6c-b76c-142f55ec18f6	9d5cf8e0-a68a-4ae9-9550-47c2e4d89036	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 13:26:20
13076	9d5cf8e0-866b-4c10-8abb-2ae0bc23ef7c	9d5cf8e0-a68a-4ae9-9550-47c2e4d89036	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta', 'De las nieve', 'ds', 'CC', '100465546', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '1000000', 30, 10, 'Q', null, 'Tue Oct 29 2024', 'Pendiente', '312596295', 12, 14, 18, 14, '2024-11-14T05:00:00.000Z', '2024-10-29 13:26:20', '2024-10-29 13:26:20') returning \\"id\\"","time":"4.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":103,"hash":"bfad4cea82a73099ff0b3164dd496ca0","hostname":"EderCortes"}	2024-10-29 13:26:20
13077	9d5cf8e0-8d86-4c22-971a-52ff77934f78	9d5cf8e0-a68a-4ae9-9550-47c2e4d89036	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:30","hostname":"EderCortes"}	2024-10-29 13:26:20
13078	9d5cf8e0-8f7e-4199-a41a-8cf4b44d2c8c	9d5cf8e0-a68a-4ae9-9550-47c2e4d89036	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (30, 1, 100000, 25000, 0, 'N\\/A', '13-11-2024', 12, '2024-10-29 13:26:20', '2024-10-29 13:26:20')","time":"3.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":154,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 13:26:20
13079	9d5cf8e0-8fa6-435c-9021-f9bdfc154e02	9d5cf8e0-a68a-4ae9-9550-47c2e4d89036	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 13:26:20
13080	9d5cf8e0-901a-4db9-8a3a-bb65d38663c1	9d5cf8e0-a68a-4ae9-9550-47c2e4d89036	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (30, 2, 100000, 25000, 0, 'N\\/A', '28-11-2024', 12, '2024-10-29 13:26:20', '2024-10-29 13:26:20')","time":"0.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":154,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 13:26:20
13081	9d5cf8e0-9038-4be7-a68e-18444bb0dd76	9d5cf8e0-a68a-4ae9-9550-47c2e4d89036	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 13:26:20
13082	9d5cf8e0-90a2-4829-9696-4ab66a35d910	9d5cf8e0-a68a-4ae9-9550-47c2e4d89036	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (30, 3, 100000, 25000, 0, 'N\\/A', '13-12-2024', 12, '2024-10-29 13:26:20', '2024-10-29 13:26:20')","time":"0.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":154,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 13:26:20
13083	9d5cf8e0-90c2-4334-a532-d38cceac3ceb	9d5cf8e0-a68a-4ae9-9550-47c2e4d89036	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 13:26:20
13218	9d5cfadd-e90f-4ef8-bc38-b07fff237e14	9d5cfade-04e8-4e4a-8a2f-c1e1dc9fa4bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 13:31:53
11057	9d5ca88d-4945-46b4-b123-24252f61d710	9d5ca88d-951a-454f-84f8-bb1ef4b8aaa0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 09:41:43
9664	9d54875c-27f4-481b-8055-f1bf74ba6497	9d54875c-4ee4-4337-8ae9-e4a89928c9bc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-25 08:42:17
9665	9d54875c-4d41-4b33-906e-3a22bb8ea2b1	9d54875c-4ee4-4337-8ae9-e4a89928c9bc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-25 08:42:17
9666	9d54875c-4dfa-4625-8cea-1cefb5065b38	9d54875c-4ee4-4337-8ae9-e4a89928c9bc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-10-25 08:42:17
11058	9d5ca88d-8db6-4c40-b369-f1889d1709ba	9d5ca88d-951a-454f-84f8-bb1ef4b8aaa0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"157.98","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-29 09:41:44
9987	9d56c5c9-fb94-471d-abd1-d621c0aa30d5	9d56c5ca-491d-498d-91dc-8507bc7f1e6f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-26 11:28:30
11059	9d5ca88d-9383-46bb-86bd-b7fb148867eb	9d5ca88d-951a-454f-84f8-bb1ef4b8aaa0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 09:41:44
9988	9d56c5ca-435d-480f-8f89-8fb9a8b945d0	9d56c5ca-491d-498d-91dc-8507bc7f1e6f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"155.03","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 11:28:31
9989	9d56c5ca-43ab-426c-89ba-216a16bf86bb	9d56c5ca-491d-498d-91dc-8507bc7f1e6f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 11:28:31
9990	9d56c5ca-470c-4fb8-a216-5acec2d8ebfb	9d56c5ca-491d-498d-91dc-8507bc7f1e6f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 11:28:31
9991	9d56c5ca-47c6-4182-89ba-5bfaa876c92a	9d56c5ca-491d-498d-91dc-8507bc7f1e6f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":485,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:28:31
11060	9d5ca88d-93f4-482b-93c0-27b34401607d	9d5ca88d-951a-454f-84f8-bb1ef4b8aaa0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":609,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:41:44
12250	9d5ce0c9-9bf8-46c2-8e96-446aee69400f	9d5ce0c9-9eab-49ba-8425-b76c85868303	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":160,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:18:58
13084	9d5cf8e0-9121-4b08-a808-36f624dbfc5d	9d5cf8e0-a68a-4ae9-9550-47c2e4d89036	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (30, 4, 100000, 25000, 0, 'N\\/A', '28-12-2024', 12, '2024-10-29 13:26:20', '2024-10-29 13:26:20')","time":"0.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":154,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 13:26:20
13085	9d5cf8e0-9143-419c-92c3-cebdb4bfc3b5	9d5cf8e0-a68a-4ae9-9550-47c2e4d89036	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 13:26:20
13086	9d5cf8e0-91c6-48f3-8e30-a0aa048be27f	9d5cf8e0-a68a-4ae9-9550-47c2e4d89036	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (30, 5, 100000, 25000, 0, 'N\\/A', '12-01-2025', 12, '2024-10-29 13:26:20', '2024-10-29 13:26:20')","time":"0.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":154,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 13:26:20
11061	9d5ca88f-e894-46df-a1ed-5727a4155dc1	9d5ca890-3014-4d2e-8c18-91e00a4e7a45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 09:41:45
11062	9d5ca890-2aa9-4bd2-9a7b-90c55b7a03ed	9d5ca890-3014-4d2e-8c18-91e00a4e7a45	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"145.16","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 09:41:45
11063	9d5ca890-2b0a-471d-81a8-fb8f356d905c	9d5ca890-3014-4d2e-8c18-91e00a4e7a45	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 09:41:45
11064	9d5ca890-2ebe-441b-8d50-078c143bbef8	9d5ca890-3014-4d2e-8c18-91e00a4e7a45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 09:41:45
11065	9d5ca890-2f02-4b04-9998-b7a20f54fc2e	9d5ca890-3014-4d2e-8c18-91e00a4e7a45	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":413,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:41:45
12251	9d5ce0ca-11f4-43c7-9241-26e06ab6a87d	9d5ce0ca-53c3-4c14-aebb-81d8c067a6ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":38,"hostname":"EderCortes"}	2024-10-29 12:18:58
12252	9d5ce0ca-4f7c-4229-8fef-621900610a41	9d5ce0ca-53c3-4c14-aebb-81d8c067a6ce	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder Arley C%' or \\"users\\".\\"user_document\\"::text like '%Eder Arley C%' order by \\"users\\".\\"user_document\\" asc","time":"141.53","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:59
12253	9d5ce0ca-529e-4f5b-862e-50d100d6844a	9d5ce0ca-53c3-4c14-aebb-81d8c067a6ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":39,"hostname":"EderCortes"}	2024-10-29 12:18:59
12254	9d5ce0ca-52e0-41f3-8f9b-14bd3be6b024	9d5ce0ca-53c3-4c14-aebb-81d8c067a6ce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"34","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder Arley C"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":305,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:59
13087	9d5cf8e0-91f5-4e06-90ca-7a6dc181ab37	9d5cf8e0-a68a-4ae9-9550-47c2e4d89036	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 13:26:20
13088	9d5cf8e0-9273-4604-b4e3-53d86b08fd47	9d5cf8e0-a68a-4ae9-9550-47c2e4d89036	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (30, 6, 100000, 25000, 0, 'N\\/A', '27-01-2025', 12, '2024-10-29 13:26:20', '2024-10-29 13:26:20')","time":"0.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":154,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 13:26:20
13089	9d5cf8e0-9295-45c6-8bf3-a27a97936beb	9d5cf8e0-a68a-4ae9-9550-47c2e4d89036	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 13:26:20
13090	9d5cf8e0-92e9-4c3e-98fc-a661818b9703	9d5cf8e0-a68a-4ae9-9550-47c2e4d89036	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (30, 7, 100000, 25000, 0, 'N\\/A', '11-02-2025', 12, '2024-10-29 13:26:20', '2024-10-29 13:26:20')","time":"0.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":154,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 13:26:20
13091	9d5cf8e0-9305-4163-a130-7fd666764553	9d5cf8e0-a68a-4ae9-9550-47c2e4d89036	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 13:26:20
13092	9d5cf8e0-9354-48a1-8470-220d1126d0da	9d5cf8e0-a68a-4ae9-9550-47c2e4d89036	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (30, 8, 100000, 25000, 0, 'N\\/A', '26-02-2025', 12, '2024-10-29 13:26:20', '2024-10-29 13:26:20')","time":"0.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":154,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 13:26:20
13093	9d5cf8e0-9370-4c70-937b-7e78804a1c59	9d5cf8e0-a68a-4ae9-9550-47c2e4d89036	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 13:26:20
25542	9d68c6dd-2ee3-4f1f-9ba0-21ec87fe441e	9d68c6dd-7d34-483b-a7f5-8ac5f8df50aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:16:25
11066	9d5ca89a-5c72-4185-a99b-a9850d947151	9d5ca89a-773e-42d1-93c9-9f9edb917a31	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 09:41:52
11067	9d5ca89a-730c-4411-ae82-bb16c9b51a95	9d5ca89a-773e-42d1-93c9-9f9edb917a31	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"42.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-29 09:41:52
11068	9d5ca89a-75e9-4675-b000-af33640ac6a1	9d5ca89a-773e-42d1-93c9-9f9edb917a31	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 09:41:52
11069	9d5ca89a-764b-4085-b0c7-9d00f28cf524	9d5ca89a-773e-42d1-93c9-9f9edb917a31	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null}]},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:41:52
12255	9d5ce0ca-9119-4379-9153-abc0ab89b289	9d5ce0ca-aaf2-455a-8882-ea6ab853d62c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":39,"hostname":"EderCortes"}	2024-10-29 12:18:59
12256	9d5ce0ca-a713-48bf-a2b3-beed396ce145	9d5ce0ca-aaf2-455a-8882-ea6ab853d62c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder Arley%' or \\"users\\".\\"user_document\\"::text like '%Eder Arley%' order by \\"users\\".\\"user_document\\" asc","time":"40.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:18:59
11137	9d5cab62-038d-40e4-b8ad-8df7e2e6e6f1	9d5cab62-2250-430a-b270-ed30fe22c465	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 09:49:38
11138	9d5cab62-20ec-4cd5-8473-5a3658a104e9	9d5cab62-2250-430a-b270-ed30fe22c465	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 09:49:38
11139	9d5cab62-2177-41d3-a9cc-887a526dcd68	9d5cab62-2250-430a-b270-ed30fe22c465	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:49:38
12257	9d5ce0ca-a9b1-422c-9a37-c6d255fdeeaf	9d5ce0ca-aaf2-455a-8882-ea6ab853d62c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":40,"hostname":"EderCortes"}	2024-10-29 12:18:59
12258	9d5ce0ca-a9fe-4e2e-8dd0-bde8fea1418b	9d5ce0ca-aaf2-455a-8882-ea6ab853d62c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"33","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder Arley"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":206,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:18:59
13094	9d5cf8e0-9404-49ce-b3d1-9910b77fd05b	9d5cf8e0-a68a-4ae9-9550-47c2e4d89036	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (30, 9, 100000, 25000, 0, 'N\\/A', '13-03-2025', 12, '2024-10-29 13:26:20', '2024-10-29 13:26:20')","time":"0.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":154,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 13:26:20
13095	9d5cf8e0-942d-4060-802f-7abbffbd6409	9d5cf8e0-a68a-4ae9-9550-47c2e4d89036	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 13:26:20
13096	9d5cf8e0-9494-41a0-8bbc-63013b88a2b8	9d5cf8e0-a68a-4ae9-9550-47c2e4d89036	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (30, 10, 100000, 25000, 0, 'N\\/A', '28-03-2025', 12, '2024-10-29 13:26:20', '2024-10-29 13:26:20')","time":"0.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":154,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 13:26:20
13097	9d5cf8e0-94b4-4573-a88f-441636164d0f	9d5cf8e0-a68a-4ae9-9550-47c2e4d89036	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 13:26:20
13098	9d5cf8e0-a4e3-45a9-be55-ac740d271fa0	9d5cf8e0-a68a-4ae9-9550-47c2e4d89036	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 13:26:20
11070	9d5ca89c-e3d7-446b-950e-f4b116bd68c6	9d5ca89d-2cf1-4cbd-9c24-9a368c3e051a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 09:41:54
11071	9d5ca89d-23fb-41c3-b803-b1e2aecb3acf	9d5ca89d-2cf1-4cbd-9c24-9a368c3e051a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 1\\n                        ","time":"150.84","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"2bd5a29c69f6bbb290fc49b79286632e","hostname":"EderCortes"}	2024-10-29 09:41:54
11072	9d5ca89d-279a-4ba3-a4a2-01734429065f	9d5ca89d-2cf1-4cbd-9c24-9a368c3e051a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1' order by \\"item_loans\\".\\"id\\" asc","time":"2.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 09:41:54
11073	9d5ca89d-27db-4fd2-8153-05e501e929ca	9d5ca89d-2cf1-4cbd-9c24-9a368c3e051a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 09:41:54
11074	9d5ca89d-2bae-47fb-8e88-61798bae36be	9d5ca89d-2cf1-4cbd-9c24-9a368c3e051a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 09:41:54
11075	9d5ca89d-2bf9-4c6c-a378-040b4e0ea853	9d5ca89d-2cf1-4cbd-9c24-9a368c3e051a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":1,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]}},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:41:54
11140	9d5cab62-6f0e-439a-8294-ad02b17530ae	9d5cab62-960b-413b-af48-687684921e08	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 09:49:39
11141	9d5cab62-893b-408b-bd67-fa9ecb7ccdeb	9d5cab62-960b-413b-af48-687684921e08	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 1\\n                        ","time":"55.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"2bd5a29c69f6bbb290fc49b79286632e","hostname":"EderCortes"}	2024-10-29 09:49:39
11142	9d5cab62-8de6-4faf-8161-bf889778be1d	9d5cab62-960b-413b-af48-687684921e08	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1' order by \\"item_loans\\".\\"id\\" asc","time":"3.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 09:49:39
11143	9d5cab62-8e54-468e-8919-954a05d9b411	9d5cab62-960b-413b-af48-687684921e08	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 09:49:39
11144	9d5cab62-93c9-47f0-a2ea-b178b458bb2a	9d5cab62-960b-413b-af48-687684921e08	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 09:49:39
12259	9d5ce0d7-ff25-4672-bb84-04d771561813	9d5ce0d8-206e-4758-a15e-9db6cfef0224	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":40,"hostname":"EderCortes"}	2024-10-29 12:19:08
12260	9d5ce0d8-1957-4049-8909-56fdc62fbfd5	9d5ce0d8-206e-4758-a15e-9db6cfef0224	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null","time":"38.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":54,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-29 12:19:08
12261	9d5ce0d8-19a0-4a6f-a832-9b26850798e1	9d5ce0d8-206e-4758-a15e-9db6cfef0224	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 12:19:08
12262	9d5ce0d8-1e87-499d-9ab8-0c61322034a3	9d5ce0d8-206e-4758-a15e-9db6cfef0224	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":41,"hostname":"EderCortes"}	2024-10-29 12:19:08
11145	9d5cab62-945c-4a02-9842-c8aa82534afe	9d5cab62-960b-413b-af48-687684921e08	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":1,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]}},"duration":260,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:49:39
12263	9d5ce0d8-1f07-4f51-ac24-cc603e2f04d0	9d5ce0d8-206e-4758-a15e-9db6cfef0224	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null}},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:19:08
13099	9d5cf8e0-a54b-4d92-aed8-f79ec502dd72	9d5cf8e0-a68a-4ae9-9550-47c2e4d89036	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"768","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"100465546","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"1000000","loans_intereses":30,"loans_cuotas":10,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":18,"user_recomendacion":14,"loans_inicio_pago":"2024-11-14T05:00:00.000Z","created_at":null,"updated_at":null,"deleted_at":null},"detail":{"status":false,"observacion":"N\\/A","fecha_pago":"Tue Oct 29 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":30},"duration":386,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:26:20
13219	9d5cfade-007e-477a-b053-a3a049a13898	9d5cfade-04e8-4e4a-8a2f-c1e1dc9fa4bb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"42.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 13:31:54
13220	9d5cfade-03aa-4621-ac7a-0807f3f056f9	9d5cfade-04e8-4e4a-8a2f-c1e1dc9fa4bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 13:31:54
13221	9d5cfade-03ee-4755-9f23-ba03bf8c8fdc	9d5cfade-04e8-4e4a-8a2f-c1e1dc9fa4bb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:31:54
24337	9d68b229-60dd-4ffc-94aa-45ec5b8e167d	9d68b229-63e2-49f7-9343-0ea3301a9b7c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":146,"memory":20,"hostname":"EderCortes"}	2024-11-04 09:18:32
11146	9d5cab64-71ba-4198-9410-d0da22bd7d5c	9d5cab64-995c-4813-9888-c7c109f636c7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 09:49:40
11147	9d5cab64-92e6-4a08-a3fc-abf837d26a7d	9d5cab64-995c-4813-9888-c7c109f636c7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"49.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 09:49:40
11148	9d5cab64-9347-4bff-834c-fa95696111a5	9d5cab64-995c-4813-9888-c7c109f636c7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 09:49:40
11149	9d5cab64-97a0-435a-a65a-2c613f6d7b6b	9d5cab64-995c-4813-9888-c7c109f636c7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 09:49:40
11150	9d5cab64-981a-4491-b4c0-eddceedb8721	9d5cab64-995c-4813-9888-c7c109f636c7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":371,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:49:40
24338	9d68b229-e8b5-4a49-a413-a5dd4d97cfbe	9d68b22a-35af-4b83-a21f-d29495c7f8ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 09:18:32
24339	9d68b22a-2959-4970-a4cd-dd02c7e7e9b9	9d68b22a-35af-4b83-a21f-d29495c7f8ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\", \\"loans_fecha_ultimo_pago\\", \\"loans_intereses_recaudar\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta 2', 'De las nieve', 'ds', 'CC', '1004655468', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon2', 'Calle 7505', '1100000', 25, 5, 'S', null, '04-11-2024', 'Pendiente', '312596295', 12, 14, 19, 14, '04-11-2024', 0, 0, '04-11-2024', 275000, '2024-11-04 09:18:32', '2024-11-04 09:18:32') returning \\"id\\"","time":"4.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":110,"hash":"f69b6b91ceb0fd9e0c386e94fcedc496","hostname":"EderCortes"}	2024-11-04 09:18:32
18621	9d6696f5-768f-4ab0-b8db-ed8490fa7f08	9d6696f5-befa-4002-8336-90708a9e6b30	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:10:48
13100	9d5cf8ec-fc4d-4ea5-a688-6c588e533e66	9d5cf8ed-184e-4a79-b01c-722277cbefdf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 13:26:28
18622	9d6696f5-bc98-40e4-b4a8-4b8cfd257373	9d6696f5-befa-4002-8336-90708a9e6b30	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:10:49
18623	9d6696f5-bda5-4781-8e4c-c00c14c36f55	9d6696f5-befa-4002-8336-90708a9e6b30	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abPendiente\\u00bb\\nLINE 4: ... WHEN l.loans_cuando = 'D' AND 'l.loans_estado = 'Pendiente'...\\n                                                             ^ (Connection: pgsql, SQL: select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND 'l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND 'l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND 'l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND 'l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND 'l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":427,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:10:49
24340	9d68b22a-29ae-48eb-b10e-64de6c07ea1a	9d68b22a-35af-4b83-a21f-d29495c7f8ca	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:77","hostname":"EderCortes"}	2024-11-04 09:18:32
24341	9d68b22a-2b87-4b48-84fc-94cc38ec7213	9d68b22a-35af-4b83-a21f-d29495c7f8ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (77, 1, 220000, 55000, 'Pendiente', 'N\\/A', '12-11-2024', 12, 0, 0, '2024-11-04 09:18:32', '2024-11-04 09:18:32')","time":"3.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:32
24342	9d68b22a-2bae-4984-8d14-2f4035e1e36c	9d68b22a-35af-4b83-a21f-d29495c7f8ca	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:32
24343	9d68b22a-2c22-491c-bbb9-ef7d0e7eb5dc	9d68b22a-35af-4b83-a21f-d29495c7f8ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (77, 2, 220000, 55000, 'Pendiente', 'N\\/A', '20-11-2024', 12, 0, 0, '2024-11-04 09:18:32', '2024-11-04 09:18:32')","time":"0.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:32
24344	9d68b22a-2c49-4996-88e6-c389673c3609	9d68b22a-35af-4b83-a21f-d29495c7f8ca	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:32
24345	9d68b22a-2cbf-4d3d-9673-163f53128589	9d68b22a-35af-4b83-a21f-d29495c7f8ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (77, 3, 220000, 55000, 'Pendiente', 'N\\/A', '28-11-2024', 12, 0, 0, '2024-11-04 09:18:32', '2024-11-04 09:18:32')","time":"0.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:32
24346	9d68b22a-2ce1-4352-8cc2-36fc3a13ed70	9d68b22a-35af-4b83-a21f-d29495c7f8ca	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:32
13101	9d5cf8ed-1328-4ebe-a6ac-f8b7f6fa77bc	9d5cf8ed-184e-4a79-b01c-722277cbefdf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"44.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-29 13:26:28
13102	9d5cf8ed-16de-4837-afa7-d104214cfc23	9d5cf8ed-184e-4a79-b01c-722277cbefdf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 13:26:28
13103	9d5cf8ed-1740-43a2-91f3-724cc5454ae4	9d5cf8ed-184e-4a79-b01c-722277cbefdf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":284,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:26:28
13222	9d5cfade-9758-4912-acaa-6b1a2f55f4c6	9d5cfade-9a80-44d4-a443-5ac000950684	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":139,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:31:54
18479	9d66924c-c0a5-4332-8434-67af1e61a415	9d66924c-df46-406a-b581-66ce1e3eb8d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 07:57:47
18480	9d66924c-ddb7-450d-9b69-3860e18780b1	9d66924c-df46-406a-b581-66ce1e3eb8d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 07:57:47
18481	9d66924c-de52-415d-b569-538a7ae70d86	9d66924c-df46-406a-b581-66ce1e3eb8d8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:57:47
18624	9d6696f7-ada5-4231-9555-fc56aa825c40	9d6696f7-ee43-4ea9-b6dc-73f778416a5d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:10:50
13104	9d5cf8f8-f1b6-42bd-9119-95bc6cbf36b7	9d5cf8f9-113d-4dca-af89-863c4dddc8c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 13:26:36
13105	9d5cf8f9-0785-41ef-a570-ed0592231295	9d5cf8f9-113d-4dca-af89-863c4dddc8c3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 30\\n                        ","time":"41.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"b9ae622c33dd7e7f0bc512338acf8ed0","hostname":"EderCortes"}	2024-10-29 13:26:36
13106	9d5cf8f9-0b4d-4672-86cc-6626a75bda54	9d5cf8f9-113d-4dca-af89-863c4dddc8c3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '30' order by \\"item_loans\\".\\"id\\" asc","time":"1.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 13:26:36
13107	9d5cf8f9-0b7e-4c8a-bf53-2969624271c7	9d5cf8f9-113d-4dca-af89-863c4dddc8c3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-10-29 13:26:36
13108	9d5cf8f9-0fd3-4274-99b9-2b5fb24929ec	9d5cf8f9-113d-4dca-af89-863c4dddc8c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 13:26:36
13109	9d5cf8f9-1036-4ba8-a02e-18c0f769f6a1	9d5cf8f9-113d-4dca-af89-863c4dddc8c3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/30","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":30,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":1000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":106,"loans_codigo":30,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":107,"loans_codigo":30,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":108,"loans_codigo":30,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":109,"loans_codigo":30,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":110,"loans_codigo":30,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":111,"loans_codigo":30,"itemloans_cuota":"6","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":112,"loans_codigo":30,"itemloans_cuota":"7","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":113,"loans_codigo":30,"itemloans_cuota":"8","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":114,"loans_codigo":30,"itemloans_cuota":"9","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":115,"loans_codigo":30,"itemloans_cuota":"10","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":242,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:26:36
13223	9d5cfadf-5e6a-4f13-ac47-b39f238c995d	9d5cfadf-7dab-4069-9ebe-dae00fb697a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 13:31:54
13224	9d5cfadf-7882-4d68-a0ac-3102d5a6b117	9d5cfadf-7dab-4069-9ebe-dae00fb697a4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ma%' or \\"users\\".\\"user_document\\"::text like '%Ma%') order by \\"users\\".\\"user_document\\" asc","time":"45.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 13:31:55
13225	9d5cfadf-7c30-45e1-8faf-9e6de8b9879f	9d5cfadf-7dab-4069-9ebe-dae00fb697a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 13:31:55
13226	9d5cfadf-7c8d-40f9-81af-575ae6817e0d	9d5cfadf-7dab-4069-9ebe-dae00fb697a4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ma"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":265,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:31:55
18482	9d66924d-35a7-448d-b7de-abf703fa2663	9d66924d-7c67-4560-83be-75d7f93cb2b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 07:57:47
18625	9d6696f7-e3a9-431c-b6c0-6fc708fcc7e3	9d6696f7-ee43-4ea9-b6dc-73f778416a5d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"109.78","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 08:10:50
18626	9d6696f7-e442-4f8e-8cc6-d709e7f69223	9d6696f7-ee43-4ea9-b6dc-73f778416a5d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 08:10:50
18627	9d6696f7-ec3b-4e3b-a095-5674082c9ac0	9d6696f7-ee43-4ea9-b6dc-73f778416a5d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 08:10:50
13227	9d5cfadf-be95-489d-83fa-4dcfbc34c0ac	9d5cfadf-c20a-494b-af7e-6c8d2e95f763	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":152,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:31:55
18483	9d66924d-7875-4fc7-a734-5c731b68fdfd	9d66924d-7c67-4560-83be-75d7f93cb2b4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"154.71","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58,"hash":"77f8314368b36a9393ec9c7735a91700","hostname":"EderCortes"}	2024-11-03 07:57:47
18484	9d66924d-7b39-4381-be28-abf123fea5d4	9d66924d-7c67-4560-83be-75d7f93cb2b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 07:57:47
18485	9d66924d-7b88-4b79-9d60-eb80f1858de1	9d66924d-7c67-4560-83be-75d7f93cb2b4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":338,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:57:47
18628	9d6696f7-ecd2-41a1-b0c0-b26f5476c9fb	9d6696f7-ee43-4ea9-b6dc-73f778416a5d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":425,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:10:50
24347	9d68b22a-2d3f-4571-9fed-7bef3371989f	9d68b22a-35af-4b83-a21f-d29495c7f8ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (77, 4, 220000, 55000, 'Pendiente', 'N\\/A', '06-12-2024', 12, 0, 0, '2024-11-04 09:18:32', '2024-11-04 09:18:32')","time":"0.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:32
24348	9d68b22a-2d5b-4bc2-8813-5cc6532656bd	9d68b22a-35af-4b83-a21f-d29495c7f8ca	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:32
24349	9d68b22a-2db5-48ef-a4db-fea016750c4f	9d68b22a-35af-4b83-a21f-d29495c7f8ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (77, 5, 220000, 55000, 'Pendiente', 'N\\/A', '14-12-2024', 12, 0, 0, '2024-11-04 09:18:32', '2024-11-04 09:18:32')","time":"0.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:32
24350	9d68b22a-2dd1-4d97-bd33-1f78fd6cba0b	9d68b22a-35af-4b83-a21f-d29495c7f8ca	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:32
24351	9d68b22a-347f-49e5-8ea9-063134453c24	9d68b22a-35af-4b83-a21f-d29495c7f8ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 09:18:32
13228	9d5cfae0-3f76-4207-a4d3-c0a7d6ed7e17	9d5cfae0-8678-4773-89ed-b8faf81ec5b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 13:31:55
13229	9d5cfae0-81c9-452e-8611-f8653c885577	9d5cfae0-8678-4773-89ed-b8faf81ec5b5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mar%' or \\"users\\".\\"user_document\\"::text like '%Mar%') order by \\"users\\".\\"user_document\\" asc","time":"153.55","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 13:31:55
13230	9d5cfae0-8548-44fa-ac94-4aecb924722b	9d5cfae0-8678-4773-89ed-b8faf81ec5b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 13:31:55
13231	9d5cfae0-858b-4ba8-afc8-801202c9db65	9d5cfae0-8678-4773-89ed-b8faf81ec5b5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mar"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:31:55
18486	9d66924e-f890-426f-af38-b306aea062b0	9d66924f-47bf-4588-84ae-e073f6f9396f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 07:57:48
18487	9d66924f-42d3-485b-8d44-5bd191192517	9d66924f-47bf-4588-84ae-e073f6f9396f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"159.96","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 07:57:48
18488	9d66924f-4325-417f-8dc6-104193614a40	9d66924f-47bf-4588-84ae-e073f6f9396f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 07:57:48
15401	9d5ed110-643d-4fce-be3c-740e726bfe39	9d5ed110-a050-45e3-a723-b9c0c5a26293	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-30 11:26:39
18489	9d66924f-466b-4f89-8e5a-1b840565143d	9d66924f-47bf-4588-84ae-e073f6f9396f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 07:57:48
18490	9d66924f-46ac-4179-b407-7b015072d6fb	9d66924f-47bf-4588-84ae-e073f6f9396f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":514,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:57:48
24352	9d68b22a-34c2-4582-ac45-3947e931a3fb	9d68b22a-35af-4b83-a21f-d29495c7f8ca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"801","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"1004655468","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_valor_prestado":"1100000","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":19,"user_recomendacion":14,"loans_inicio_pago":"Mon Nov 04 2024","created_at":null,"updated_at":null,"deleted_at":null,"loans_pago_prestado":0,"loans_pago_interes":0},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Mon Nov 04 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":77},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:18:32
18552	9d66943c-792e-4f85-8d0e-112da9e6cac3	9d66943c-9c50-49f1-bc50-9bbf053fab5f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:03:12
18553	9d66943c-9a71-4b9c-8c78-31d6951a408b	9d66943c-9c50-49f1-bc50-9bbf053fab5f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 08:03:12
18554	9d66943c-9b48-4009-8301-6c6c13c2b981	9d66943c-9c50-49f1-bc50-9bbf053fab5f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":325,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:03:12
13232	9d5cfae3-b2a7-4954-812a-4bfbdf934939	9d5cfae3-d37f-42fd-9d6c-bb073d6cd993	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 13:31:57
13233	9d5cfae3-cb94-421e-a709-64219c1be7da	9d5cfae3-d37f-42fd-9d6c-bb073d6cd993	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '18' and \\"users\\".\\"deleted_at\\" is null","time":"40.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":55,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-29 13:31:57
13234	9d5cfae3-cbdd-4645-a504-9ed315d3f8b1	9d5cfae3-d37f-42fd-9d6c-bb073d6cd993	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 13:31:57
13235	9d5cfae3-d202-4e24-9502-8dfa4bbea28b	9d5cfae3-d37f-42fd-9d6c-bb073d6cd993	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 13:31:57
13236	9d5cfae3-d24a-458c-ab87-33c23b121ac7	9d5cfae3-d37f-42fd-9d6c-bb073d6cd993	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/18","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:31:57
15402	9d5ed110-9d9f-4ed7-bb5c-3e6a1d56354d	9d5ed110-a050-45e3-a723-b9c0c5a26293	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-30 11:26:40
15403	9d5ed110-9ef9-4b46-988a-5374e6ab8ee7	9d5ed110-a050-45e3-a723-b9c0c5a26293	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":469,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:26:40
18555	9d66943c-e794-4d99-b3a4-e94376ff1392	9d66943d-0375-4a9e-a3f1-356edd7c3757	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 08:03:12
18556	9d66943c-ff33-4d2d-82a8-b66d8712bd79	9d66943d-0375-4a9e-a3f1-356edd7c3757	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"43.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58,"hash":"77f8314368b36a9393ec9c7735a91700","hostname":"EderCortes"}	2024-11-03 08:03:12
18557	9d66943d-01f6-4b43-ae7a-10778c4437ce	9d66943d-0375-4a9e-a3f1-356edd7c3757	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 08:03:12
18558	9d66943d-026f-406a-8c0c-92311a3e3988	9d66943d-0375-4a9e-a3f1-356edd7c3757	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:03:12
24353	9d68b22a-7c44-4218-9684-8a46f1f4df9a	9d68b22a-7f7c-443b-90d9-17fe28af3083	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":159,"memory":20,"hostname":"EderCortes"}	2024-11-04 09:18:32
25543	9d68c6dd-72b8-4cd8-b306-3caa9b7889c0	9d68c6dd-7d34-483b-a7f5-8ac5f8df50aa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"105.73","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 10:16:25
13237	9d5cfb31-bd2e-4054-bd8d-0badb8738d81	9d5cfb31-c0c0-408b-b47d-4ed6b9f8e197	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":184,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:32:48
15404	9d5ed111-2fd1-4bcf-a1e3-e8ddd1497ba5	9d5ed111-5e95-422c-b628-545ed85cd7eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-30 11:26:40
15405	9d5ed111-51b1-4650-8a51-c706f69d5b02	9d5ed111-5e95-422c-b628-545ed85cd7eb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"63.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"088d1fdbe045a08c3b0073ef22c7da32","hostname":"EderCortes"}	2024-10-30 11:26:40
15406	9d5ed111-5706-4194-a01d-11335709a72c	9d5ed111-5e95-422c-b628-545ed85cd7eb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-30 11:26:40
15407	9d5ed111-5752-4f9b-b6b1-71414cc9efb1	9d5ed111-5e95-422c-b628-545ed85cd7eb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-10-30 11:26:40
15408	9d5ed111-5c92-4741-9a5d-8d74621aa0ac	9d5ed111-5e95-422c-b628-545ed85cd7eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-10-30 11:26:40
15409	9d5ed111-5d19-49da-aa8c-af5402118f84	9d5ed111-5e95-422c-b628-545ed85cd7eb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":430,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:26:40
18559	9d66943f-399e-4744-960d-151d340fe870	9d66943f-5cc2-4135-ace4-09fd64c9b704	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 08:03:13
18560	9d66943f-575f-48a6-b05e-5b87e796c240	9d66943f-5cc2-4135-ace4-09fd64c9b704	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"53.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 08:03:14
18561	9d66943f-57ad-49ea-a0c2-e89e63c3e0fe	9d66943f-5cc2-4135-ace4-09fd64c9b704	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 08:03:14
18562	9d66943f-5b58-4e33-b51d-7f75541fe9b7	9d66943f-5cc2-4135-ace4-09fd64c9b704	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 08:03:14
18563	9d66943f-5ba3-4d75-bb52-a3531190d3ae	9d66943f-5cc2-4135-ace4-09fd64c9b704	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":326,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:03:14
25544	9d68c6dd-7ad9-4d17-9351-a5793a461faf	9d68c6dd-7d34-483b-a7f5-8ac5f8df50aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:16:25
13238	9d5cfb32-4757-4555-bf42-8ae2392c655d	9d5cfb32-7217-4f15-9087-a7a52444a8c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 13:32:49
13239	9d5cfb32-65d5-4a50-ae96-2659cdccad3c	9d5cfb32-7217-4f15-9087-a7a52444a8c0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta', 'De las nieve', 'ds', 'CC', '100465546', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '500000', 30, 6, 'Q', null, '29-10-2024', 'Pendiente', '312596295', 12, 14, 18, 14, '2024-11-15T05:00:00.000Z', '2024-10-29 13:32:49', '2024-10-29 13:32:49') returning \\"id\\"","time":"6.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":103,"hash":"bfad4cea82a73099ff0b3164dd496ca0","hostname":"EderCortes"}	2024-10-29 13:32:49
13240	9d5cfb32-6667-4ae0-905f-f2063fc9eebd	9d5cfb32-7217-4f15-9087-a7a52444a8c0	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:31","hostname":"EderCortes"}	2024-10-29 13:32:49
13241	9d5cfb32-684d-4ce8-84b9-534417a26906	9d5cfb32-7217-4f15-9087-a7a52444a8c0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (31, 1, 83333.333333333, 12500, 'Pendiente', 'N\\/A', '13-11-2024', 12, '2024-10-29 13:32:49', '2024-10-29 13:32:49')","time":"2.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":154,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 13:32:49
13242	9d5cfb32-6879-418f-935f-763e1e2b3e9d	9d5cfb32-7217-4f15-9087-a7a52444a8c0	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 13:32:49
13243	9d5cfb32-68f1-4435-8964-5f53d9a60c05	9d5cfb32-7217-4f15-9087-a7a52444a8c0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (31, 2, 83333.333333333, 12500, 'Pendiente', 'N\\/A', '28-11-2024', 12, '2024-10-29 13:32:49', '2024-10-29 13:32:49')","time":"0.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":154,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 13:32:49
13244	9d5cfb32-691a-40f4-b304-74ddb16054dd	9d5cfb32-7217-4f15-9087-a7a52444a8c0	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 13:32:49
13245	9d5cfb32-698e-42a2-b6cf-ecd36c924bb2	9d5cfb32-7217-4f15-9087-a7a52444a8c0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (31, 3, 83333.333333333, 12500, 'Pendiente', 'N\\/A', '13-12-2024', 12, '2024-10-29 13:32:49', '2024-10-29 13:32:49')","time":"0.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":154,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 13:32:49
13246	9d5cfb32-69ba-44d8-a726-b16eef3292e4	9d5cfb32-7217-4f15-9087-a7a52444a8c0	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 13:32:49
13247	9d5cfb32-6a31-4e04-a73b-a08772b291f2	9d5cfb32-7217-4f15-9087-a7a52444a8c0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (31, 4, 83333.333333333, 12500, 'Pendiente', 'N\\/A', '28-12-2024', 12, '2024-10-29 13:32:49', '2024-10-29 13:32:49')","time":"0.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":154,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 13:32:49
13248	9d5cfb32-6a59-4b56-b272-e3c3d5432e0a	9d5cfb32-7217-4f15-9087-a7a52444a8c0	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 13:32:49
13249	9d5cfb32-6acc-435b-bd37-a7d03d146378	9d5cfb32-7217-4f15-9087-a7a52444a8c0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (31, 5, 83333.333333333, 12500, 'Pendiente', 'N\\/A', '12-01-2025', 12, '2024-10-29 13:32:49', '2024-10-29 13:32:49')","time":"0.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":154,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 13:32:49
13250	9d5cfb32-6b00-41c6-a2b3-1d90b14caec7	9d5cfb32-7217-4f15-9087-a7a52444a8c0	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 13:32:49
13251	9d5cfb32-6bb1-48ed-9913-818e68d98021	9d5cfb32-7217-4f15-9087-a7a52444a8c0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (31, 6, 83333.333333333, 12500, 'Pendiente', 'N\\/A', '27-01-2025', 12, '2024-10-29 13:32:49', '2024-10-29 13:32:49')","time":"0.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":154,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 13:32:49
13252	9d5cfb32-6be0-437f-b14a-b1d5cfa9571e	9d5cfb32-7217-4f15-9087-a7a52444a8c0	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 13:32:49
13253	9d5cfb32-7093-4d87-bae8-8af2b0dd2547	9d5cfb32-7217-4f15-9087-a7a52444a8c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 13:32:49
15410	9d5ed112-3494-4400-a4f2-76fbf7941aed	9d5ed112-ab8c-4caf-8f4e-9fb7d67ec13c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-10-30 11:26:41
15411	9d5ed112-9d97-47cd-95b7-c5cfdccc2303	9d5ed112-ab8c-4caf-8f4e-9fb7d67ec13c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"190.22","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 11:26:41
15412	9d5ed112-9e2f-4f5c-b178-16e2f6015ace	9d5ed112-ab8c-4caf-8f4e-9fb7d67ec13c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 11:26:41
13254	9d5cfb32-70e2-4c6e-b6ea-d6577a0d689c	9d5cfb32-7217-4f15-9087-a7a52444a8c0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"772","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"100465546","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"500000","loans_intereses":30,"loans_cuotas":6,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":18,"user_recomendacion":14,"loans_inicio_pago":"2024-11-15T05:00:00.000Z","created_at":null,"updated_at":null,"deleted_at":null},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Tue Oct 29 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":31},"duration":287,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:32:49
15413	9d5ed112-a798-4816-b016-2227e6e21589	9d5ed112-ab8c-4caf-8f4e-9fb7d67ec13c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-10-30 11:26:41
15414	9d5ed112-a83d-4f5f-8a84-adeb1bae0bb5	9d5ed112-ab8c-4caf-8f4e-9fb7d67ec13c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":822,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:26:41
24354	9d68b22a-ff19-4adc-9860-731198c45921	9d68b22b-02a7-405b-93ce-cc0fd882726e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":148,"memory":20,"hostname":"EderCortes"}	2024-11-04 09:18:33
25545	9d68c6dd-7b9c-4190-ac0a-49a3a7de5e34	9d68c6dd-7d34-483b-a7f5-8ac5f8df50aa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":678,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:16:25
13255	9d5cfb39-82b8-4e1c-bdba-f6e772e9f74c	9d5cfb39-a2bf-420f-b4e9-a43810a340ba	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 13:32:54
13256	9d5cfb39-9d29-497a-8e0d-8a8701208376	9d5cfb39-a2bf-420f-b4e9-a43810a340ba	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"43.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-29 13:32:54
13257	9d5cfb39-a124-4a64-a1f8-3fbac16e9d0f	9d5cfb39-a2bf-420f-b4e9-a43810a340ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 13:32:54
13258	9d5cfb39-a196-42ef-b72f-caaf6e58467d	9d5cfb39-a2bf-420f-b4e9-a43810a340ba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":302,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:32:54
15415	9d5ed113-345e-4dd0-bd5b-aa2063ed23b6	9d5ed113-5296-4dd8-a3e2-9d8e21024571	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-10-30 11:26:41
15416	9d5ed113-4cea-414b-84ec-d689df1cfd03	9d5ed113-5296-4dd8-a3e2-9d8e21024571	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 11:26:41
15417	9d5ed113-4d37-4dfb-b0ca-9fe068dfba08	9d5ed113-5296-4dd8-a3e2-9d8e21024571	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 11:26:41
15418	9d5ed113-5134-4ee0-8695-f0e36d6db436	9d5ed113-5296-4dd8-a3e2-9d8e21024571	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-10-30 11:26:41
15419	9d5ed113-518c-405e-85db-780277c772a7	9d5ed113-5296-4dd8-a3e2-9d8e21024571	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":399,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:26:41
24355	9d68b22b-5b74-4636-bf01-3636922c6f90	9d68b22b-8c40-4e26-9762-529a335bedc9	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 09:18:33
24356	9d68b22b-7c77-4114-b792-09a3c3fc821d	9d68b22b-8c40-4e26-9762-529a335bedc9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\", \\"loans_fecha_ultimo_pago\\", \\"loans_intereses_recaudar\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta 2', 'De las nieve', 'ds', 'CC', '1004655468', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon2', 'Calle 7505', '1100000', 25, 5, 'S', null, '04-11-2024', 'Pendiente', '312596295', 12, 14, 19, 14, '04-11-2024', 0, 0, '04-11-2024', 275000, '2024-11-04 09:18:33', '2024-11-04 09:18:33') returning \\"id\\"","time":"6.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":110,"hash":"f69b6b91ceb0fd9e0c386e94fcedc496","hostname":"EderCortes"}	2024-11-04 09:18:33
24357	9d68b22b-7d3e-4c56-97a5-07448e3ca318	9d68b22b-8c40-4e26-9762-529a335bedc9	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:78","hostname":"EderCortes"}	2024-11-04 09:18:33
24358	9d68b22b-7f25-4a88-a26e-3d6a9879d945	9d68b22b-8c40-4e26-9762-529a335bedc9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (78, 1, 220000, 55000, 'Pendiente', 'N\\/A', '12-11-2024', 12, 0, 0, '2024-11-04 09:18:33', '2024-11-04 09:18:33')","time":"2.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:33
10543	9d570fd3-0bb8-4c9d-afe0-5e1aa69ba1a8	9d570fd3-5ac6-4f78-98dc-d40b11f8ba56	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 14:55:32
10544	9d570fd3-582d-4812-8eb2-524ee058b84a	9d570fd3-5ac6-4f78-98dc-d40b11f8ba56	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 14:55:32
10545	9d570fd3-594c-48c0-8655-f14057e5264c	9d570fd3-5ac6-4f78-98dc-d40b11f8ba56	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":377,"memory":22,"hostname":"EderCortes"}	2024-10-26 14:55:32
24359	9d68b22b-7f5b-4ddb-8f62-bff90a3414ca	9d68b22b-8c40-4e26-9762-529a335bedc9	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:33
24360	9d68b22b-7fe1-450e-a5c6-591d91d23e37	9d68b22b-8c40-4e26-9762-529a335bedc9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (78, 2, 220000, 55000, 'Pendiente', 'N\\/A', '20-11-2024', 12, 0, 0, '2024-11-04 09:18:33', '2024-11-04 09:18:33')","time":"0.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:33
24361	9d68b22b-800e-4810-b33d-c131e7f96e6e	9d68b22b-8c40-4e26-9762-529a335bedc9	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:33
24362	9d68b22b-809d-41cb-a5cf-1c6a34ce36fb	9d68b22b-8c40-4e26-9762-529a335bedc9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (78, 3, 220000, 55000, 'Pendiente', 'N\\/A', '28-11-2024', 12, 0, 0, '2024-11-04 09:18:33', '2024-11-04 09:18:33')","time":"0.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:33
24363	9d68b22b-80cb-40ba-8cb2-675d91d28745	9d68b22b-8c40-4e26-9762-529a335bedc9	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:33
24364	9d68b22b-8167-472e-921f-70989cebb949	9d68b22b-8c40-4e26-9762-529a335bedc9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (78, 4, 220000, 55000, 'Pendiente', 'N\\/A', '06-12-2024', 12, 0, 0, '2024-11-04 09:18:33', '2024-11-04 09:18:33')","time":"0.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:33
24365	9d68b22b-8197-47c1-acb0-6889e535d680	9d68b22b-8c40-4e26-9762-529a335bedc9	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:33
24366	9d68b22b-822a-47f0-8184-3d068f8f6139	9d68b22b-8c40-4e26-9762-529a335bedc9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (78, 5, 220000, 55000, 'Pendiente', 'N\\/A', '14-12-2024', 12, 0, 0, '2024-11-04 09:18:33', '2024-11-04 09:18:33')","time":"0.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:33
10546	9d570fd3-b5c4-4462-976c-0087d6985a57	9d570fd3-fb9a-439a-9f70-b0365e75fec7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 14:55:32
10547	9d570fd3-f6c4-447e-aa2b-3e35cf7f16dd	9d570fd3-fb9a-439a-9f70-b0365e75fec7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"152.40","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 14:55:32
10548	9d570fd3-fa6a-4264-b002-98dcb5d98b77	9d570fd3-fb9a-439a-9f70-b0365e75fec7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 14:55:32
10549	9d570fd3-faac-4896-b753-d1b9ca1e4b98	9d570fd3-fb9a-439a-9f70-b0365e75fec7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456}},"duration":380,"memory":22,"hostname":"EderCortes"}	2024-10-26 14:55:32
15420	9d5ed114-07d7-40cd-9b6a-46dcd4e74a30	9d5ed114-263f-4599-adc8-e12f1165993e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-10-30 11:26:42
15421	9d5ed114-208f-401a-9f84-33e18a818041	9d5ed114-263f-4599-adc8-e12f1165993e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 11:26:42
15422	9d5ed114-20e8-483a-8610-793ceb41c7ff	9d5ed114-263f-4599-adc8-e12f1165993e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 11:26:42
15423	9d5ed114-249c-4c9d-ad5c-9c5cf6d1e8bf	9d5ed114-263f-4599-adc8-e12f1165993e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-10-30 11:26:42
15424	9d5ed114-2504-49d8-8a7b-2e561fa2a0bf	9d5ed114-263f-4599-adc8-e12f1165993e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:26:42
24367	9d68b22b-8258-4fad-81f2-bf4c84a79bb9	9d68b22b-8c40-4e26-9762-529a335bedc9	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:33
24368	9d68b22b-8a74-4e6a-8e38-cc7f4aee0ba6	9d68b22b-8c40-4e26-9762-529a335bedc9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 09:18:33
25546	9d68c6de-3868-43c4-8d75-a4409e599e2a	9d68c6de-84c9-4386-93d1-42d235255f6e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:16:26
25547	9d68c6de-7845-4f32-99ba-786995d0cc3a	9d68c6de-84c9-4386-93d1-42d235255f6e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"109.04","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:16:26
25548	9d68c6de-78d0-4383-8908-bea524f16f3f	9d68c6de-84c9-4386-93d1-42d235255f6e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:16:26
25549	9d68c6de-817b-4f0f-9195-93dac3bd59b7	9d68c6de-84c9-4386-93d1-42d235255f6e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:16:26
10550	9d570fd5-7a84-43f5-89f0-451ad2f719c5	9d570fd5-9f03-467f-8050-b3a24656ebff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-26 14:55:33
10551	9d570fd5-9679-4bb1-9d8d-1d89d5835526	9d570fd5-9f03-467f-8050-b3a24656ebff	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"47.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 14:55:33
10552	9d570fd5-96e2-4ed5-97b8-617c2b8041b3	9d570fd5-9f03-467f-8050-b3a24656ebff	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 14:55:33
10553	9d570fd5-9d3a-4180-ad28-8ccead5a6c02	9d570fd5-9f03-467f-8050-b3a24656ebff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 14:55:33
10554	9d570fd5-9da2-48a8-ab25-9fd37f7c5544	9d570fd5-9f03-467f-8050-b3a24656ebff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":346,"memory":22,"hostname":"EderCortes"}	2024-10-26 14:55:33
24369	9d68b22b-8af2-43a0-bc10-be0bc3c17ac6	9d68b22b-8c40-4e26-9762-529a335bedc9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"801","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"1004655468","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_valor_prestado":"1100000","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":19,"user_recomendacion":14,"loans_inicio_pago":"Mon Nov 04 2024","created_at":null,"updated_at":null,"deleted_at":null,"loans_pago_prestado":0,"loans_pago_interes":0},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Mon Nov 04 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":78},"duration":293,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:18:33
25550	9d68c6de-823b-4fde-8f18-954f44adca6f	9d68c6de-84c9-4386-93d1-42d235255f6e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":646,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:16:26
25551	9d68c6df-b912-4381-8eb6-b809cdfdf439	9d68c6df-e30e-42c3-a2dd-c404aa2ef211	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:16:27
18686	9d6699a1-b9b2-402e-afe8-a6a1275f4351	9d6699a2-08c3-4142-87af-8d461ba5dd30	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 08:18:17
18687	9d6699a2-06a6-4e8f-b4bf-2008bbcb9f40	9d6699a2-08c3-4142-87af-8d461ba5dd30	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 08:18:17
18688	9d6699a2-0759-4c21-bc69-2f2c51ab808e	9d6699a2-08c3-4142-87af-8d461ba5dd30	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":426,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:18:17
25552	9d68c6df-d986-4d14-b584-1747c75c9a7f	9d68c6df-e30e-42c3-a2dd-c404aa2ef211	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"47.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:16:27
25553	9d68c6df-d9ee-4c75-a1ab-d26602f3ce41	9d68c6df-e30e-42c3-a2dd-c404aa2ef211	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:16:27
24370	9d68b22b-d7b4-422e-99cf-61de4c85cd81	9d68b22b-db80-4c52-b214-86965fcc1931	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":174,"memory":20,"hostname":"EderCortes"}	2024-11-04 09:18:33
25554	9d68c6df-dfc9-4592-9001-4c0b3e3c58f2	9d68c6df-e30e-42c3-a2dd-c404aa2ef211	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:16:27
25555	9d68c6df-e03b-46bf-8ed7-5ce39f893b56	9d68c6df-e30e-42c3-a2dd-c404aa2ef211	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":567,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:16:27
18689	9d6699a2-6922-4e1f-b240-6bd69c584107	9d6699a2-8c05-4255-89eb-4bc7459cac1d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 08:18:17
18690	9d6699a2-85f6-425e-80ae-15104c676932	9d6699a2-8c05-4255-89eb-4bc7459cac1d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"49.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c37ce191b53d9d62ae3ae483cb5ffa40","hostname":"EderCortes"}	2024-11-03 08:18:17
18691	9d6699a2-8a71-4dfa-9a2e-6eb40c828a72	9d6699a2-8c05-4255-89eb-4bc7459cac1d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 08:18:17
18692	9d6699a2-8ad8-45ee-9934-97d1b16c8015	9d6699a2-8c05-4255-89eb-4bc7459cac1d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","frecuencia_pago":"-1","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"6","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"-25","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"6","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"-25","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"-1","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"13","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"13","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"6","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"-3","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"5","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"-25","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"-25","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"-25","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":292,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:18:17
24371	9d68b22c-306e-4d1a-81e5-d5cca6a0a785	9d68b22c-3400-4a25-9ace-3baf7fee3811	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":147,"memory":20,"hostname":"EderCortes"}	2024-11-04 09:18:34
18693	9d6699a5-1692-4565-9589-8f11ee69243b	9d6699a5-4091-4445-b4c6-f6668bab2116	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 08:18:19
18694	9d6699a5-3833-4c2c-b33c-57d6ecf67b55	9d6699a5-4091-4445-b4c6-f6668bab2116	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"56.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 08:18:19
18695	9d6699a5-389f-47d2-8fb1-a6a95c4b923a	9d6699a5-4091-4445-b4c6-f6668bab2116	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 08:18:19
18696	9d6699a5-3e64-4ca7-8559-11e590b18716	9d6699a5-4091-4445-b4c6-f6668bab2116	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 08:18:19
18697	9d6699a5-3edc-40ec-af8e-9535bca95aa4	9d6699a5-4091-4445-b4c6-f6668bab2116	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":547,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:18:19
24372	9d68b22c-ba7f-4b51-abc2-c83b9d40821a	9d68b22c-e097-4881-b53d-8fc3e0749a83	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 09:18:34
24373	9d68b22c-d423-467d-a117-9edb4406a9b0	9d68b22c-e097-4881-b53d-8fc3e0749a83	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\", \\"loans_fecha_ultimo_pago\\", \\"loans_intereses_recaudar\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta 2', 'De las nieve', 'ds', 'CC', '1004655468', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon2', 'Calle 7505', '1100000', 25, 5, 'S', null, '04-11-2024', 'Pendiente', '312596295', 12, 14, 19, 14, '04-11-2024', 0, 0, '04-11-2024', 275000, '2024-11-04 09:18:34', '2024-11-04 09:18:34') returning \\"id\\"","time":"5.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":110,"hash":"f69b6b91ceb0fd9e0c386e94fcedc496","hostname":"EderCortes"}	2024-11-04 09:18:34
18755	9d669b7f-4160-4dd9-bdd5-f6e01ca92c6e	9d669b7f-62ea-46ed-b027-6a33dd2462c6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:23:30
18756	9d669b7f-611a-4135-ab70-a24cd5e1a34e	9d669b7f-62ea-46ed-b027-6a33dd2462c6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:23:30
18757	9d669b7f-61e8-4efb-8d19-7475874afa68	9d669b7f-62ea-46ed-b027-6a33dd2462c6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00ab'Diario'\\u00bb\\nLINE 16:                 WHEN l.loans_cuando = 'D' 'Diario'\\n                                                   ^ (Connection: pgsql, SQL: select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' 'Diario'\\n                WHEN l.loans_cuando = 'S' 'Semanal'\\n                WHEN l.loans_cuando = 'Q' 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' 'Mensual'\\n                WHEN l.loans_cuando = 'T' 'Trimestral'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:23:30
24374	9d68b22c-d492-43f1-9db7-88a99d1b1eb1	9d68b22c-e097-4881-b53d-8fc3e0749a83	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:79","hostname":"EderCortes"}	2024-11-04 09:18:34
24375	9d68b22c-d658-4b2e-b6a3-0b1a1dc34631	9d68b22c-e097-4881-b53d-8fc3e0749a83	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (79, 1, 220000, 55000, 'Pendiente', 'N\\/A', '12-11-2024', 12, 0, 0, '2024-11-04 09:18:34', '2024-11-04 09:18:34')","time":"3.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:34
24376	9d68b22c-d682-4bd2-90b8-38f3b4e98a3a	9d68b22c-e097-4881-b53d-8fc3e0749a83	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:34
24377	9d68b22c-d6ff-45b6-8b3c-aa5ab50eec19	9d68b22c-e097-4881-b53d-8fc3e0749a83	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (79, 2, 220000, 55000, 'Pendiente', 'N\\/A', '20-11-2024', 12, 0, 0, '2024-11-04 09:18:34', '2024-11-04 09:18:34')","time":"0.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:34
24378	9d68b22c-d734-4903-b6dc-c97051a8bcb1	9d68b22c-e097-4881-b53d-8fc3e0749a83	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:34
24379	9d68b22c-d7a8-4037-8311-f5a7f9b324e1	9d68b22c-e097-4881-b53d-8fc3e0749a83	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (79, 3, 220000, 55000, 'Pendiente', 'N\\/A', '28-11-2024', 12, 0, 0, '2024-11-04 09:18:34', '2024-11-04 09:18:34')","time":"0.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:34
24380	9d68b22c-d7cd-4fef-8184-348be19b855a	9d68b22c-e097-4881-b53d-8fc3e0749a83	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:34
18758	9d669b81-4aa0-45c1-9c9c-a18fcafe8f7d	9d669b81-6d1a-44ae-b38a-1612c1c7923b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:23:31
18759	9d669b81-6724-4727-9ea5-534c65f43fcb	9d669b81-6d1a-44ae-b38a-1612c1c7923b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 08:23:31
18760	9d669b81-676e-4619-9a5a-1d4705961292	9d669b81-6d1a-44ae-b38a-1612c1c7923b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 08:23:31
18761	9d669b81-6bcd-4588-8e00-4918f073c2a8	9d669b81-6d1a-44ae-b38a-1612c1c7923b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 08:23:31
18762	9d669b81-6c12-4faf-af58-288cbec51860	9d669b81-6d1a-44ae-b38a-1612c1c7923b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":293,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:23:31
24381	9d68b22c-d836-4874-9e8c-3d0541fb8abb	9d68b22c-e097-4881-b53d-8fc3e0749a83	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (79, 4, 220000, 55000, 'Pendiente', 'N\\/A', '06-12-2024', 12, 0, 0, '2024-11-04 09:18:34', '2024-11-04 09:18:34')","time":"0.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:34
24382	9d68b22c-d855-4d5b-bc39-3822f5a064a9	9d68b22c-e097-4881-b53d-8fc3e0749a83	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:34
24383	9d68b22c-d8bc-42b0-aac8-5df77ab801e7	9d68b22c-e097-4881-b53d-8fc3e0749a83	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (79, 5, 220000, 55000, 'Pendiente', 'N\\/A', '14-12-2024', 12, 0, 0, '2024-11-04 09:18:34', '2024-11-04 09:18:34')","time":"0.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:34
24384	9d68b22c-d8e9-43bb-9a5c-c44412f87c0f	9d68b22c-e097-4881-b53d-8fc3e0749a83	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:34
24385	9d68b22c-df07-4657-88fa-9fb43b6d78cd	9d68b22c-e097-4881-b53d-8fc3e0749a83	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 09:18:34
24386	9d68b22c-df6e-48dc-9332-c22bb10f26dc	9d68b22c-e097-4881-b53d-8fc3e0749a83	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"801","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"1004655468","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_valor_prestado":"1100000","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":19,"user_recomendacion":14,"loans_inicio_pago":"Mon Nov 04 2024","created_at":null,"updated_at":null,"deleted_at":null,"loans_pago_prestado":0,"loans_pago_interes":0},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Mon Nov 04 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":79},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:18:34
24387	9d68b22d-1d05-430a-a79d-12c1289bcc6f	9d68b22d-2035-4b59-a703-4c0b00f3dd84	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":133,"memory":20,"hostname":"EderCortes"}	2024-11-04 09:18:34
18815	9d669c48-ccfa-4a04-a446-faf57cc2f61e	9d669c49-1bb8-42ef-93fe-258d53a52dde	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 08:25:42
18816	9d669c49-1941-44f2-91eb-bbfe23674c9a	9d669c49-1bb8-42ef-93fe-258d53a52dde	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:25:42
18817	9d669c49-1a7d-4794-bcd1-ecba88801b4a	9d669c49-1bb8-42ef-93fe-258d53a52dde	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":358,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:25:42
24388	9d68b22d-7080-474c-a74f-38107f4bf03c	9d68b22d-73d7-4171-96e6-bee9a175ac00	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":130,"memory":20,"hostname":"EderCortes"}	2024-11-04 09:18:34
18818	9d669c49-750c-4e81-a09a-55fce43a3cdd	9d669c49-9131-4f06-9765-daeebdbd5574	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:25:42
18819	9d669c49-8c51-42f8-9927-4025986570db	9d669c49-9131-4f06-9765-daeebdbd5574	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"43.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 08:25:42
18820	9d669c49-9000-4f3f-a95d-3b47c4fe020d	9d669c49-9131-4f06-9765-daeebdbd5574	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:25:42
18821	9d669c49-9059-4d0d-aef3-dfb58360f86f	9d669c49-9131-4f06-9765-daeebdbd5574	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":263,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:25:42
24389	9d68b22d-d026-4f42-b500-eccf5b6963ac	9d68b22d-d31f-4df9-934d-6e935ee0e099	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":172,"memory":20,"hostname":"EderCortes"}	2024-11-04 09:18:35
25445	9d68c2f1-e026-4ae7-9680-1e45c6d8af1a	9d68c2f1-fd72-4794-a012-8aa30fa30f7e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:05:27
25446	9d68c2f1-fc02-4aa2-a1f9-b02ccfb1c5c8	9d68c2f1-fd72-4794-a012-8aa30fa30f7e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:05:27
25447	9d68c2f1-fc9b-4148-a148-4838deee1d1d	9d68c2f1-fd72-4794-a012-8aa30fa30f7e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:05:27
18822	9d669c4b-edfa-4146-bad7-ea8551333656	9d669c4c-383a-4786-afa0-bb6f02acbd06	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:25:44
18823	9d669c4c-32cf-492a-be6b-09692e785bb2	9d669c4c-383a-4786-afa0-bb6f02acbd06	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"147.03","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 08:25:44
18824	9d669c4c-332d-4175-b307-b9b331d4031d	9d669c4c-383a-4786-afa0-bb6f02acbd06	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 08:25:44
18825	9d669c4c-3697-41f4-abc1-8b1582b7e498	9d669c4c-383a-4786-afa0-bb6f02acbd06	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 08:25:44
18826	9d669c4c-36f9-4466-a4de-2fa18fdd541c	9d669c4c-383a-4786-afa0-bb6f02acbd06	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":430,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:25:44
24390	9d68b22e-4ccb-475d-b769-42749d98280e	9d68b22e-4fb0-40ce-bcc2-d02f999d6c48	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":131,"memory":20,"hostname":"EderCortes"}	2024-11-04 09:18:35
25448	9d68c2f2-8673-432d-944a-e6e7b727476b	9d68c2f2-a6c4-43a1-8c62-121db1872fda	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:05:28
25449	9d68c2f2-9ea7-4bdf-a0aa-aa78f6563215	9d68c2f2-a6c4-43a1-8c62-121db1872fda	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"49.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:05:28
25450	9d68c2f2-a206-4420-aa30-e792c688e42b	9d68c2f2-a6c4-43a1-8c62-121db1872fda	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:05:28
25451	9d68c2f2-a24d-43b5-8527-330ab2b1008c	9d68c2f2-a6c4-43a1-8c62-121db1872fda	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:05:28
25452	9d68c2f2-a5b5-4d23-be6d-c7e5c5e99dee	9d68c2f2-a6c4-43a1-8c62-121db1872fda	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 10:05:28
25453	9d68c2f2-a600-49e5-b3c6-69717b56a931	9d68c2f2-a6c4-43a1-8c62-121db1872fda	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":389,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:05:28
24391	9d68b22e-9e4f-4f27-bea6-8ae781bfae79	9d68b22e-c15f-401f-a845-307f3ae13175	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 09:18:35
24392	9d68b22e-b7cc-4903-80f7-1d23bb91aba2	9d68b22e-c15f-401f-a845-307f3ae13175	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\", \\"loans_fecha_ultimo_pago\\", \\"loans_intereses_recaudar\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta 2', 'De las nieve', 'ds', 'CC', '1004655468', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon2', 'Calle 7505', '1100000', 25, 5, 'S', null, '04-11-2024', 'Pendiente', '312596295', 12, 14, 19, 14, '04-11-2024', 0, 0, '04-11-2024', 275000, '2024-11-04 09:18:35', '2024-11-04 09:18:35') returning \\"id\\"","time":"4.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":110,"hash":"f69b6b91ceb0fd9e0c386e94fcedc496","hostname":"EderCortes"}	2024-11-04 09:18:35
24393	9d68b22e-b822-432e-ac63-423ab51e0617	9d68b22e-c15f-401f-a845-307f3ae13175	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:80","hostname":"EderCortes"}	2024-11-04 09:18:35
24394	9d68b22e-b983-496f-8e56-78cdd8838fb5	9d68b22e-c15f-401f-a845-307f3ae13175	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (80, 1, 220000, 55000, 'Pendiente', 'N\\/A', '12-11-2024', 12, 0, 0, '2024-11-04 09:18:35', '2024-11-04 09:18:35')","time":"2.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:35
24395	9d68b22e-b9b2-42ba-90d1-d5fb6ff617d1	9d68b22e-c15f-401f-a845-307f3ae13175	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:35
24396	9d68b22e-ba30-44ff-9e97-07a562b72c2e	9d68b22e-c15f-401f-a845-307f3ae13175	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (80, 2, 220000, 55000, 'Pendiente', 'N\\/A', '20-11-2024', 12, 0, 0, '2024-11-04 09:18:35', '2024-11-04 09:18:35')","time":"0.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:35
24397	9d68b22e-ba56-49f0-8eaa-ae1b4ada2d19	9d68b22e-c15f-401f-a845-307f3ae13175	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:35
24398	9d68b22e-babf-4431-beb1-3241ffdea7e4	9d68b22e-c15f-401f-a845-307f3ae13175	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (80, 3, 220000, 55000, 'Pendiente', 'N\\/A', '28-11-2024', 12, 0, 0, '2024-11-04 09:18:35', '2024-11-04 09:18:35')","time":"0.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:35
24399	9d68b22e-badf-4c43-a73f-98cf8099b71d	9d68b22e-c15f-401f-a845-307f3ae13175	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:35
24400	9d68b22e-bb45-46d6-920b-21df3988a509	9d68b22e-c15f-401f-a845-307f3ae13175	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (80, 4, 220000, 55000, 'Pendiente', 'N\\/A', '06-12-2024', 12, 0, 0, '2024-11-04 09:18:35', '2024-11-04 09:18:35')","time":"0.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:35
24401	9d68b22e-bb65-4205-a24f-bca7f3e927e9	9d68b22e-c15f-401f-a845-307f3ae13175	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:35
24402	9d68b22e-bbcf-4082-a76f-82ecf6e748c9	9d68b22e-c15f-401f-a845-307f3ae13175	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (80, 5, 220000, 55000, 'Pendiente', 'N\\/A', '14-12-2024', 12, 0, 0, '2024-11-04 09:18:35', '2024-11-04 09:18:35')","time":"0.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:35
24403	9d68b22e-bbf3-434c-a4c6-edebb70f296b	9d68b22e-c15f-401f-a845-307f3ae13175	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:35
24404	9d68b22e-c00b-41de-a08b-c85f86aca84c	9d68b22e-c15f-401f-a845-307f3ae13175	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 09:18:35
24405	9d68b22e-c051-48c4-9c1c-10e0e9d34dcd	9d68b22e-c15f-401f-a845-307f3ae13175	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"801","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"1004655468","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_valor_prestado":"1100000","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":19,"user_recomendacion":14,"loans_inicio_pago":"Mon Nov 04 2024","created_at":null,"updated_at":null,"deleted_at":null,"loans_pago_prestado":0,"loans_pago_interes":0},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Mon Nov 04 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":80},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:18:35
25349	9d68c233-05bc-4440-83fd-b1d773d967c9	9d68c233-26fe-4c25-b594-52579d9d1f53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:03:22
25350	9d68c233-2523-4724-b004-4284570882f5	9d68c233-26fe-4c25-b594-52579d9d1f53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:03:22
10631	9d571186-c22b-45f4-94be-b59961fdef15	9d571187-0a5c-4e3d-a2a2-fb7507b14049	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 15:00:17
10632	9d571187-088b-4485-9b5a-c484d01d7cbc	9d571187-0a5c-4e3d-a2a2-fb7507b14049	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 15:00:17
10633	9d571187-093c-4cd2-96f2-225864c16e25	9d571187-0a5c-4e3d-a2a2-fb7507b14049	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":367,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:00:17
25351	9d68c233-25f0-4b3d-b53c-83ab313556a2	9d68c233-26fe-4c25-b594-52579d9d1f53	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:03:22
10634	9d571187-58ac-4173-a56b-5d494213c6f2	9d571187-786a-4219-8d20-f2d56508d77d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 15:00:17
10635	9d571187-6f45-4312-adfb-5781ebc6aff0	9d571187-786a-4219-8d20-f2d56508d77d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        ","time":"43.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"b471ef668c70f979eb0ee04fbfc30910","hostname":"EderCortes"}	2024-10-26 15:00:18
10636	9d571187-7344-4984-bb0c-a476a82a7ba2	9d571187-786a-4219-8d20-f2d56508d77d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '5' order by \\"item_loans\\".\\"id\\" asc","time":"2.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-26 15:00:18
10637	9d571187-737a-473b-ba75-103381cbb7b3	9d571187-786a-4219-8d20-f2d56508d77d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-26 15:00:18
10638	9d571187-773a-4ac2-9ee8-43f1c75d64a8	9d571187-786a-4219-8d20-f2d56508d77d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 15:00:18
10639	9d571187-778f-477e-9c40-f7aeaeca3ee6	9d571187-786a-4219-8d20-f2d56508d77d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":5,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":25,"loans_codigo":5,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":26,"loans_codigo":5,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":27,"loans_codigo":5,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":28,"loans_codigo":5,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":29,"loans_codigo":5,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null},{"id":30,"loans_codigo":5,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":false,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:38:46.000000Z","updated_at":"2024-10-24T11:38:46.000000Z","deleted_at":null}]}},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:00:18
24406	9d68b22f-0558-41f7-9fb6-850542790de2	9d68b22f-08c1-4f22-830e-e5ce3513d993	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":152,"memory":20,"hostname":"EderCortes"}	2024-11-04 09:18:35
25352	9d68c233-a28d-4e3f-8c40-f2f9042f35b3	9d68c233-c1cd-4968-83cc-b28376730467	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:03:23
25353	9d68c233-b860-4e84-a525-d862ffbd1e9f	9d68c233-c1cd-4968-83cc-b28376730467	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"43.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:03:23
25354	9d68c233-bbf4-430b-a61e-1f118b0294ff	9d68c233-c1cd-4968-83cc-b28376730467	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:03:23
25355	9d68c233-bc50-4f40-8005-bb5bae1eef4a	9d68c233-c1cd-4968-83cc-b28376730467	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:03:23
25356	9d68c233-c066-44a9-80d3-d4b47e966924	9d68c233-c1cd-4968-83cc-b28376730467	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:03:23
10640	9d571188-8b98-43d9-b32b-fe197550fe69	9d571188-a8e4-4e41-8fa8-45dd12deab53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-26 15:00:18
10641	9d571188-a3e4-4721-81e2-7dfa7c2d1ced	9d571188-a8e4-4e41-8fa8-45dd12deab53	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 15:00:18
10642	9d571188-a42c-4827-adaf-af6900032828	9d571188-a8e4-4e41-8fa8-45dd12deab53	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 15:00:18
10643	9d571188-a76d-4b4d-bda5-996f6620dd3c	9d571188-a8e4-4e41-8fa8-45dd12deab53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 15:00:18
10644	9d571188-a7bb-48f9-849e-d630c8ae47b8	9d571188-a8e4-4e41-8fa8-45dd12deab53	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":306,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:00:18
24407	9d68b22f-8477-4b62-8b3a-50abda59fef9	9d68b22f-8778-429b-88d4-06704f572b5c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":241,"memory":20,"hostname":"EderCortes"}	2024-11-04 09:18:36
25357	9d68c233-c0ba-4610-ab7c-49ed58a6a96c	9d68c233-c1cd-4968-83cc-b28376730467	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:03:23
15594	9d648ead-13e2-4715-99fb-01d105587beb	9d648ead-32ac-434c-b5aa-ad30cc85bf24	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 07:55:59
15595	9d648ead-30cc-4ca4-876d-487b99702000	9d648ead-32ac-434c-b5aa-ad30cc85bf24	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 07:56:00
15596	9d648ead-3165-4b49-b7e7-243798fec70e	9d648ead-32ac-434c-b5aa-ad30cc85bf24	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-11-02 07:56:00
15597	9d648eae-6c22-412c-98a0-68c045f8c00d	9d648eae-89d0-4f5b-8aa9-ec64ba5e9f09	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 07:56:00
15598	9d648eae-846d-4070-ac3f-6e6d7c8a85ea	9d648eae-89d0-4f5b-8aa9-ec64ba5e9f09	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 07:56:00
15599	9d648eae-84c2-4fa2-b159-8bd3d014c1de	9d648eae-89d0-4f5b-8aa9-ec64ba5e9f09	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 07:56:00
15600	9d648eae-8879-4240-9f95-ba09b37fd0a1	9d648eae-89d0-4f5b-8aa9-ec64ba5e9f09	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 07:56:00
15601	9d648eae-88c2-41b3-99f7-6d4c396ace22	9d648eae-89d0-4f5b-8aa9-ec64ba5e9f09	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"}]},"duration":341,"memory":22,"hostname":"EderCortes"}	2024-11-02 07:56:00
24408	9d68b22f-dd2a-442a-8eb2-9a0cf6d62448	9d68b230-0276-44b1-a32a-833eb5fa0209	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 09:18:36
24409	9d68b22f-f7ee-4964-862d-4a4d931b8b7b	9d68b230-0276-44b1-a32a-833eb5fa0209	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\", \\"loans_fecha_ultimo_pago\\", \\"loans_intereses_recaudar\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta 2', 'De las nieve', 'ds', 'CC', '1004655468', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon2', 'Calle 7505', '1100000', 25, 5, 'S', null, '04-11-2024', 'Pendiente', '312596295', 12, 14, 19, 14, '04-11-2024', 0, 0, '04-11-2024', 275000, '2024-11-04 09:18:36', '2024-11-04 09:18:36') returning \\"id\\"","time":"6.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":110,"hash":"f69b6b91ceb0fd9e0c386e94fcedc496","hostname":"EderCortes"}	2024-11-04 09:18:36
24410	9d68b22f-f858-4469-8457-817ceffc5494	9d68b230-0276-44b1-a32a-833eb5fa0209	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:81","hostname":"EderCortes"}	2024-11-04 09:18:36
24411	9d68b22f-fa1a-409a-bec8-e53d903c8a01	9d68b230-0276-44b1-a32a-833eb5fa0209	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (81, 1, 220000, 55000, 'Pendiente', 'N\\/A', '12-11-2024', 12, 0, 0, '2024-11-04 09:18:36', '2024-11-04 09:18:36')","time":"3.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:36
24412	9d68b22f-fa4f-4c23-bd8e-165ebd190cf5	9d68b230-0276-44b1-a32a-833eb5fa0209	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:36
24413	9d68b22f-fae0-433e-87d1-4fb2e43cf08b	9d68b230-0276-44b1-a32a-833eb5fa0209	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (81, 2, 220000, 55000, 'Pendiente', 'N\\/A', '20-11-2024', 12, 0, 0, '2024-11-04 09:18:36', '2024-11-04 09:18:36')","time":"0.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:36
24414	9d68b22f-fb0a-4b1d-b7e7-92fd2cb14b4b	9d68b230-0276-44b1-a32a-833eb5fa0209	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:36
24415	9d68b22f-fb8f-446a-af69-a07b80ed594e	9d68b230-0276-44b1-a32a-833eb5fa0209	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (81, 3, 220000, 55000, 'Pendiente', 'N\\/A', '28-11-2024', 12, 0, 0, '2024-11-04 09:18:36', '2024-11-04 09:18:36')","time":"0.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:36
24416	9d68b22f-fbbd-4162-873f-da1c67419a8f	9d68b230-0276-44b1-a32a-833eb5fa0209	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:36
24417	9d68b22f-fc49-409c-ba27-f4719a86b753	9d68b230-0276-44b1-a32a-833eb5fa0209	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (81, 4, 220000, 55000, 'Pendiente', 'N\\/A', '06-12-2024', 12, 0, 0, '2024-11-04 09:18:36', '2024-11-04 09:18:36')","time":"0.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:36
15602	9d648eb7-2733-4d18-b11a-2ab50980e3dc	9d648eb7-e07c-4818-9590-633796478f3d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 07:56:06
15603	9d648eb7-db51-4b55-8a98-1a3b8cdca8ee	9d648eb7-e07c-4818-9590-633796478f3d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"149.99","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-02 07:56:07
15604	9d648eb7-db9e-4105-ba8b-4dca853e6aac	9d648eb7-e07c-4818-9590-633796478f3d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-02 07:56:07
15605	9d648eb7-df3f-4f9e-991f-e1c750970f34	9d648eb7-e07c-4818-9590-633796478f3d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 07:56:07
15606	9d648eb7-df86-410d-9a8b-44073f501b10	9d648eb7-e07c-4818-9590-633796478f3d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":663,"memory":22,"hostname":"EderCortes"}	2024-11-02 07:56:07
24418	9d68b22f-fc76-4a14-8202-551801b2bf78	9d68b230-0276-44b1-a32a-833eb5fa0209	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:36
24419	9d68b22f-fcfc-4e2b-b26f-26666aa8cb62	9d68b230-0276-44b1-a32a-833eb5fa0209	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (81, 5, 220000, 55000, 'Pendiente', 'N\\/A', '14-12-2024', 12, 0, 0, '2024-11-04 09:18:36', '2024-11-04 09:18:36')","time":"0.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:36
24420	9d68b22f-fd32-4ca7-9b70-b538dbdfd282	9d68b230-0276-44b1-a32a-833eb5fa0209	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:36
24421	9d68b230-0131-4619-a2a4-36210c43935d	9d68b230-0276-44b1-a32a-833eb5fa0209	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 09:18:36
24422	9d68b230-0170-478f-8e57-d8b88bd891b5	9d68b230-0276-44b1-a32a-833eb5fa0209	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"801","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"1004655468","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_valor_prestado":"1100000","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":19,"user_recomendacion":14,"loans_inicio_pago":"Mon Nov 04 2024","created_at":null,"updated_at":null,"deleted_at":null,"loans_pago_prestado":0,"loans_pago_interes":0},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Mon Nov 04 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":81},"duration":257,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:18:36
15607	9d648eb9-51fc-4104-b28f-1c15af742fc1	9d648eb9-6e1b-4ac8-ba12-56f8d56b90e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 07:56:08
15608	9d648eb9-6968-488f-8a7f-abf0742c1fa3	9d648eb9-6e1b-4ac8-ba12-56f8d56b90e0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"44.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":24,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-11-02 07:56:08
15609	9d648eb9-6c7e-418e-ae91-7681a6ce6e04	9d648eb9-6e1b-4ac8-ba12-56f8d56b90e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 07:56:08
15610	9d648eb9-6ce2-420e-842f-4c64ae03cf1f	9d648eb9-6e1b-4ac8-ba12-56f8d56b90e0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":280,"memory":22,"hostname":"EderCortes"}	2024-11-02 07:56:08
24423	9d68b230-3e5c-4653-b29c-54e34ed371d6	9d68b230-4189-48cc-a874-ce084ed16d5e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":132,"memory":20,"hostname":"EderCortes"}	2024-11-04 09:18:36
18914	9d66cba7-68bf-4d49-ac49-4c56d2391b90	9d66cba7-966a-48bb-a103-549b796d79d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 10:38:09
18915	9d66cba7-94d9-43d3-a74d-f31111133af1	9d66cba7-966a-48bb-a103-549b796d79d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 10:38:09
18916	9d66cba7-957a-4c50-89ce-35786f03e324	9d66cba7-966a-48bb-a103-549b796d79d2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":458,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:38:09
25733	9d68c8f3-3c4d-4ce2-915a-90d2e98d6629	9d68c8f3-93e3-466e-908a-b400adf76d00	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 10:22:15
25734	9d68c8f3-9155-4759-8623-3e83d0306477	9d68c8f3-93e3-466e-908a-b400adf76d00	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:22:15
25735	9d68c8f3-9275-4861-a64c-d198f7d5c570	9d68c8f3-93e3-466e-908a-b400adf76d00	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":566,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:22:15
18917	9d66cba8-000c-482a-80a2-8e664afe1b47	9d66cba8-4ea9-42d7-9942-ec9ba28be091	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 10:38:10
18918	9d66cba8-4952-42b7-8a89-18f9abf17155	9d66cba8-4ea9-42d7-9942-ec9ba28be091	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"169.00","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 10:38:10
18919	9d66cba8-4d2b-4c8a-b1db-01cd231f5892	9d66cba8-4ea9-42d7-9942-ec9ba28be091	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 10:38:10
18920	9d66cba8-4d9b-420a-b855-8dfbf625d18f	9d66cba8-4ea9-42d7-9942-ec9ba28be091	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":393,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:38:10
24424	9d68b230-90ca-4111-aa8a-a5a5bc1679e8	9d68b230-b469-4da2-b7c9-24a2c715e3a8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 09:18:36
24425	9d68b230-aaa7-4053-a94b-7ef330251721	9d68b230-b469-4da2-b7c9-24a2c715e3a8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\", \\"loans_fecha_ultimo_pago\\", \\"loans_intereses_recaudar\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta 2', 'De las nieve', 'ds', 'CC', '1004655468', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon2', 'Calle 7505', '1100000', 25, 5, 'S', null, '04-11-2024', 'Pendiente', '312596295', 12, 14, 19, 14, '04-11-2024', 0, 0, '04-11-2024', 275000, '2024-11-04 09:18:36', '2024-11-04 09:18:36') returning \\"id\\"","time":"4.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":110,"hash":"f69b6b91ceb0fd9e0c386e94fcedc496","hostname":"EderCortes"}	2024-11-04 09:18:36
24426	9d68b230-ab0f-4572-bb6b-1859a4448d6b	9d68b230-b469-4da2-b7c9-24a2c715e3a8	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:82","hostname":"EderCortes"}	2024-11-04 09:18:36
24427	9d68b230-ac9c-4c9b-a0a0-1ba8bb2ef0c0	9d68b230-b469-4da2-b7c9-24a2c715e3a8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (82, 1, 220000, 55000, 'Pendiente', 'N\\/A', '12-11-2024', 12, 0, 0, '2024-11-04 09:18:36', '2024-11-04 09:18:36')","time":"2.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:36
24428	9d68b230-acc4-4b5b-baa0-dedb381103a3	9d68b230-b469-4da2-b7c9-24a2c715e3a8	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:36
24429	9d68b230-ad2e-48c3-b5d7-a09f11cbfa32	9d68b230-b469-4da2-b7c9-24a2c715e3a8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (82, 2, 220000, 55000, 'Pendiente', 'N\\/A', '20-11-2024', 12, 0, 0, '2024-11-04 09:18:36', '2024-11-04 09:18:36')","time":"0.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:36
24430	9d68b230-ad4c-46e7-a488-6a1edca3acea	9d68b230-b469-4da2-b7c9-24a2c715e3a8	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:36
24431	9d68b230-ada8-4508-86ff-2a263e0554c8	9d68b230-b469-4da2-b7c9-24a2c715e3a8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (82, 3, 220000, 55000, 'Pendiente', 'N\\/A', '28-11-2024', 12, 0, 0, '2024-11-04 09:18:36', '2024-11-04 09:18:36')","time":"0.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:36
24432	9d68b230-adc4-4353-a71c-d21630fec988	9d68b230-b469-4da2-b7c9-24a2c715e3a8	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:36
24433	9d68b230-ae28-40ce-863b-83ccebb66294	9d68b230-b469-4da2-b7c9-24a2c715e3a8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (82, 4, 220000, 55000, 'Pendiente', 'N\\/A', '06-12-2024', 12, 0, 0, '2024-11-04 09:18:36', '2024-11-04 09:18:36')","time":"0.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:36
24434	9d68b230-ae48-4189-87ed-1a9c3a7127d3	9d68b230-b469-4da2-b7c9-24a2c715e3a8	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:36
15722	9d64ae20-cadb-4faf-bf34-a826c667b122	9d64ae21-20d7-4479-aa52-12d2e647f3d0	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 09:23:56
15723	9d64ae21-1907-4cae-860c-dcd0a6ada2ed	9d64ae21-20d7-4479-aa52-12d2e647f3d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:23:56
15724	9d64ae21-1b2b-46f8-9416-79b889cf672b	9d64ae21-20d7-4479-aa52-12d2e647f3d0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1897,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:23:56
24435	9d68b230-aeb0-4e19-b127-e8ada9dc1a4b	9d68b230-b469-4da2-b7c9-24a2c715e3a8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (82, 5, 220000, 55000, 'Pendiente', 'N\\/A', '14-12-2024', 12, 0, 0, '2024-11-04 09:18:36', '2024-11-04 09:18:36')","time":"0.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:36
24436	9d68b230-aed2-4b84-a628-f0bf7ac9683e	9d68b230-b469-4da2-b7c9-24a2c715e3a8	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:36
24437	9d68b230-b314-4986-b6d1-093a04abfae2	9d68b230-b469-4da2-b7c9-24a2c715e3a8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 09:18:36
18921	9d66cbaa-282f-4be1-875c-d8922f4633d0	9d66cbaa-771e-4741-a258-d8b303f42489	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 10:38:11
18922	9d66cbaa-7059-40f5-a288-eebdb57f57bb	9d66cbaa-771e-4741-a258-d8b303f42489	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"148.20","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 10:38:11
18923	9d66cbaa-70e7-4475-94c7-3534a787de7b	9d66cbaa-771e-4741-a258-d8b303f42489	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 10:38:11
18924	9d66cbaa-7566-4edc-a9d4-2958223181f7	9d66cbaa-771e-4741-a258-d8b303f42489	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 10:38:11
24438	9d68b230-b358-4d90-abd2-f5bf0dbb6478	9d68b230-b469-4da2-b7c9-24a2c715e3a8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"801","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"1004655468","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_valor_prestado":"1100000","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":19,"user_recomendacion":14,"loans_inicio_pago":"Mon Nov 04 2024","created_at":null,"updated_at":null,"deleted_at":null,"loans_pago_prestado":0,"loans_pago_interes":0},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Mon Nov 04 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":82},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:18:36
25736	9d68c8f4-3b30-4a0b-a76b-875b1b5b7eb5	9d68c8f4-653e-4303-a13a-0154e46d98c1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:22:16
25737	9d68c8f4-56e1-45c2-b39c-66548d7f73ae	9d68c8f4-653e-4303-a13a-0154e46d98c1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"53.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:22:16
25738	9d68c8f4-5bd5-4358-94cb-5605a8ecba3c	9d68c8f4-653e-4303-a13a-0154e46d98c1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:22:16
25739	9d68c8f4-5c1e-49b8-8311-12fbd7f9ea9f	9d68c8f4-653e-4303-a13a-0154e46d98c1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:22:16
25740	9d68c8f4-6368-4e11-9c3e-a87fab1e64b0	9d68c8f4-653e-4303-a13a-0154e46d98c1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:22:16
15725	9d64ae24-0f3e-463e-9862-460194e73772	9d64ae24-5aa8-486f-b3a3-87594134d811	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:23:58
15726	9d64ae24-4e55-4729-a2ff-c6daf8178ca2	9d64ae24-5aa8-486f-b3a3-87594134d811	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"109.30","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 09:23:59
15727	9d64ae24-4ee2-42e0-bbf6-9c4ed527feef	9d64ae24-5aa8-486f-b3a3-87594134d811	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 09:23:59
15728	9d64ae24-581a-4af0-bc55-e02d2de14de1	9d64ae24-5aa8-486f-b3a3-87594134d811	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:23:59
15729	9d64ae24-58a7-4309-98eb-e7e91a3628f2	9d64ae24-5aa8-486f-b3a3-87594134d811	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":688,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:23:59
18925	9d66cbaa-75b7-4284-9851-6f759d572aa8	9d66cbaa-771e-4741-a258-d8b303f42489	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":506,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:38:11
24439	9d68b231-02e2-436b-8796-c7d538cbe8f8	9d68b231-28bb-432e-bfaa-acfa545515c1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 09:18:37
24440	9d68b231-1cb6-4144-b1a4-b438fbe8e877	9d68b231-28bb-432e-bfaa-acfa545515c1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\", \\"loans_fecha_ultimo_pago\\", \\"loans_intereses_recaudar\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta 2', 'De las nieve', 'ds', 'CC', '1004655468', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon2', 'Calle 7505', '1100000', 25, 5, 'S', null, '04-11-2024', 'Pendiente', '312596295', 12, 14, 19, 14, '04-11-2024', 0, 0, '04-11-2024', 275000, '2024-11-04 09:18:37', '2024-11-04 09:18:37') returning \\"id\\"","time":"4.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":110,"hash":"f69b6b91ceb0fd9e0c386e94fcedc496","hostname":"EderCortes"}	2024-11-04 09:18:37
24441	9d68b231-1d0c-49c2-8e3a-6c1695b9de75	9d68b231-28bb-432e-bfaa-acfa545515c1	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:83","hostname":"EderCortes"}	2024-11-04 09:18:37
24442	9d68b231-1e95-47d7-9870-eef205d7962e	9d68b231-28bb-432e-bfaa-acfa545515c1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (83, 1, 220000, 55000, 'Pendiente', 'N\\/A', '12-11-2024', 12, 0, 0, '2024-11-04 09:18:37', '2024-11-04 09:18:37')","time":"2.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:37
24443	9d68b231-1ebd-45a3-a95d-c239be26e2e5	9d68b231-28bb-432e-bfaa-acfa545515c1	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:37
24444	9d68b231-1f30-4dac-88a3-3cb60f165427	9d68b231-28bb-432e-bfaa-acfa545515c1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (83, 2, 220000, 55000, 'Pendiente', 'N\\/A', '20-11-2024', 12, 0, 0, '2024-11-04 09:18:37', '2024-11-04 09:18:37')","time":"0.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:37
24445	9d68b231-1f50-4b1d-b25d-09d0804a5e9c	9d68b231-28bb-432e-bfaa-acfa545515c1	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:37
15730	9d64ae2c-67b8-4dc3-8e84-cf7e3cb5cc1e	9d64ae2c-820c-4308-839d-261aba96dbe4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:24:04
15731	9d64ae2c-7d8d-4e0b-82cb-a1e4dbec58f3	9d64ae2c-820c-4308-839d-261aba96dbe4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"42.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-02 09:24:04
15732	9d64ae2c-80a1-40f6-a6d5-ff0a5fcb13d9	9d64ae2c-820c-4308-839d-261aba96dbe4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 09:24:04
15733	9d64ae2c-80fd-4961-b10d-4cba3e212f2b	9d64ae2c-820c-4308-839d-261aba96dbe4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":292,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:24:04
24446	9d68b231-1fbf-483d-98d1-7118fda18c40	9d68b231-28bb-432e-bfaa-acfa545515c1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (83, 3, 220000, 55000, 'Pendiente', 'N\\/A', '28-11-2024', 12, 0, 0, '2024-11-04 09:18:37', '2024-11-04 09:18:37')","time":"0.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:37
24447	9d68b231-1fdf-46ab-a2c0-e8ef58aa3f10	9d68b231-28bb-432e-bfaa-acfa545515c1	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:37
24448	9d68b231-205b-4fc6-aacb-8f68f8fd660e	9d68b231-28bb-432e-bfaa-acfa545515c1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (83, 4, 220000, 55000, 'Pendiente', 'N\\/A', '06-12-2024', 12, 0, 0, '2024-11-04 09:18:37', '2024-11-04 09:18:37')","time":"0.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:37
24449	9d68b231-2080-47f3-aaf5-25e29060226a	9d68b231-28bb-432e-bfaa-acfa545515c1	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:37
24450	9d68b231-20e9-4ef5-bf2f-119c534f40b2	9d68b231-28bb-432e-bfaa-acfa545515c1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (83, 5, 220000, 55000, 'Pendiente', 'N\\/A', '14-12-2024', 12, 0, 0, '2024-11-04 09:18:37', '2024-11-04 09:18:37')","time":"0.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:37
24451	9d68b231-2108-4bb3-85c8-66eac4f44c81	9d68b231-28bb-432e-bfaa-acfa545515c1	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:37
24452	9d68b231-2777-4937-9b66-3830b6915065	9d68b231-28bb-432e-bfaa-acfa545515c1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 09:18:37
24453	9d68b231-27bb-4a9b-9133-9bcb14905718	9d68b231-28bb-432e-bfaa-acfa545515c1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"801","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"1004655468","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_valor_prestado":"1100000","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":19,"user_recomendacion":14,"loans_inicio_pago":"Mon Nov 04 2024","created_at":null,"updated_at":null,"deleted_at":null,"loans_pago_prestado":0,"loans_pago_interes":0},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Mon Nov 04 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":83},"duration":279,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:18:37
14129	9d5d1640-2b44-4951-9457-e2e40e2f1a90	9d5d1640-589f-4445-bfc7-0ea1e85b51de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 14:48:28
14130	9d5d1640-5678-44b9-a96a-8968b004ff3f	9d5d1640-589f-4445-bfc7-0ea1e85b51de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 14:48:28
14131	9d5d1640-5765-4293-88ce-eed26e233eeb	9d5d1640-589f-4445-bfc7-0ea1e85b51de	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":367,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:48:28
24454	9d68b231-6817-446e-8fae-ac3b128d58b9	9d68b231-8b89-4a34-9908-4f841c535615	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 09:18:37
24455	9d68b231-820c-4541-adff-e9b69b0376bd	9d68b231-8b89-4a34-9908-4f841c535615	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\", \\"loans_fecha_ultimo_pago\\", \\"loans_intereses_recaudar\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta 2', 'De las nieve', 'ds', 'CC', '1004655468', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon2', 'Calle 7505', '1100000', 25, 5, 'S', null, '04-11-2024', 'Pendiente', '312596295', 12, 14, 19, 14, '04-11-2024', 0, 0, '04-11-2024', 275000, '2024-11-04 09:18:37', '2024-11-04 09:18:37') returning \\"id\\"","time":"4.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":110,"hash":"f69b6b91ceb0fd9e0c386e94fcedc496","hostname":"EderCortes"}	2024-11-04 09:18:37
24456	9d68b231-8263-4d44-9b73-99add949fb9e	9d68b231-8b89-4a34-9908-4f841c535615	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:84","hostname":"EderCortes"}	2024-11-04 09:18:37
24457	9d68b231-83df-46c9-b7a9-0f37d0ca59c5	9d68b231-8b89-4a34-9908-4f841c535615	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (84, 1, 220000, 55000, 'Pendiente', 'N\\/A', '12-11-2024', 12, 0, 0, '2024-11-04 09:18:37', '2024-11-04 09:18:37')","time":"2.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:37
24458	9d68b231-8407-4812-aef6-33be30b4b7fe	9d68b231-8b89-4a34-9908-4f841c535615	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:37
24459	9d68b231-8472-4657-b6e5-09fc6887dea3	9d68b231-8b89-4a34-9908-4f841c535615	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (84, 2, 220000, 55000, 'Pendiente', 'N\\/A', '20-11-2024', 12, 0, 0, '2024-11-04 09:18:37', '2024-11-04 09:18:37')","time":"0.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:37
24460	9d68b231-848e-4b4d-9cad-894de9452126	9d68b231-8b89-4a34-9908-4f841c535615	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:37
14132	9d5d1641-0e67-4f3e-b465-666600f481ce	9d5d1641-42eb-4574-b4b1-3f356ff03f2f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 14:48:28
14133	9d5d1641-3947-4f38-89e8-0aee5d6639b7	9d5d1641-42eb-4574-b4b1-3f356ff03f2f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"63.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":182,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 14:48:28
14134	9d5d1641-39d3-436d-b575-021597a1c93b	9d5d1641-42eb-4574-b4b1-3f356ff03f2f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 14:48:28
14135	9d5d1641-4165-49a9-8ec1-2ed0ca3fad6d	9d5d1641-42eb-4574-b4b1-3f356ff03f2f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 14:48:28
14136	9d5d1641-41c3-40e8-9287-c7c473ea7096	9d5d1641-42eb-4574-b4b1-3f356ff03f2f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":545,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:48:28
15734	9d64ae40-4498-4645-9447-55d00eac2615	9d64ae40-a34d-4a33-925e-933ca0c777b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 09:24:17
15735	9d64ae40-980b-42be-b2a7-1cf010226fca	9d64ae40-a34d-4a33-925e-933ca0c777b5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"188.48","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-02 09:24:17
15736	9d64ae40-a153-4201-8dab-675854d889db	9d64ae40-a34d-4a33-925e-933ca0c777b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 09:24:17
15737	9d64ae40-a1f4-4911-b9a9-64b2953632d9	9d64ae40-a34d-4a33-925e-933ca0c777b5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":478,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:24:17
24461	9d68b231-84f0-4404-8700-998ed207c7eb	9d68b231-8b89-4a34-9908-4f841c535615	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (84, 3, 220000, 55000, 'Pendiente', 'N\\/A', '28-11-2024', 12, 0, 0, '2024-11-04 09:18:37', '2024-11-04 09:18:37')","time":"0.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:37
24462	9d68b231-850e-4c85-b05b-24cf994d4341	9d68b231-8b89-4a34-9908-4f841c535615	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:37
24463	9d68b231-8571-481b-9582-cca04b40d1e0	9d68b231-8b89-4a34-9908-4f841c535615	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (84, 4, 220000, 55000, 'Pendiente', 'N\\/A', '06-12-2024', 12, 0, 0, '2024-11-04 09:18:37', '2024-11-04 09:18:37')","time":"0.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:37
24464	9d68b231-858d-45cf-a293-50104a8da910	9d68b231-8b89-4a34-9908-4f841c535615	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:37
24465	9d68b231-85ef-4b53-a78a-1114f915a65a	9d68b231-8b89-4a34-9908-4f841c535615	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (84, 5, 220000, 55000, 'Pendiente', 'N\\/A', '14-12-2024', 12, 0, 0, '2024-11-04 09:18:37', '2024-11-04 09:18:37')","time":"0.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:37
24466	9d68b231-860c-49c6-b567-92209d079610	9d68b231-8b89-4a34-9908-4f841c535615	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:37
14137	9d5d1641-b39f-4e71-9cd7-02220754a781	9d5d1641-dc77-406f-87d9-8493f31c18a0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 14:48:29
14138	9d5d1641-d49a-499a-9776-0d79b2fe1c34	9d5d1641-dc77-406f-87d9-8493f31c18a0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"60.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 14:48:29
14139	9d5d1641-d514-47b4-85e0-800c7b4b3f32	9d5d1641-dc77-406f-87d9-8493f31c18a0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 14:48:29
14140	9d5d1641-da8d-4008-acd1-86bddbc36e2f	9d5d1641-dc77-406f-87d9-8493f31c18a0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 14:48:29
14141	9d5d1641-db17-4950-9928-11382aca3c5b	9d5d1641-dc77-406f-87d9-8493f31c18a0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":370,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:48:29
15738	9d64ae40-f117-46be-b6ca-afba9588a0ea	9d64ae41-0ecc-47ae-9a0c-2dbd8924ff18	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 09:24:17
15739	9d64ae41-09f7-4eeb-942f-561a6cdddf70	9d64ae41-0ecc-47ae-9a0c-2dbd8924ff18	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"48.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":24,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-11-02 09:24:17
15740	9d64ae41-0d0f-4a7c-b9ca-a8a93ebc288f	9d64ae41-0ecc-47ae-9a0c-2dbd8924ff18	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 09:24:17
15741	9d64ae41-0d99-4d8e-acab-da08abbb198d	9d64ae41-0ecc-47ae-9a0c-2dbd8924ff18	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:24:17
24467	9d68b231-89ea-4acf-940d-edd256f79004	9d68b231-8b89-4a34-9908-4f841c535615	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 09:18:37
24468	9d68b231-8a40-4025-aa10-d02ab9ac4494	9d68b231-8b89-4a34-9908-4f841c535615	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"801","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"1004655468","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_valor_prestado":"1100000","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":19,"user_recomendacion":14,"loans_inicio_pago":"Mon Nov 04 2024","created_at":null,"updated_at":null,"deleted_at":null,"loans_pago_prestado":0,"loans_pago_interes":0},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Mon Nov 04 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":84},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:18:37
14142	9d5d1642-2050-4f94-aff7-1007ab6a7882	9d5d1642-3cfa-492e-b714-48cca6ae76cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 14:48:29
14143	9d5d1642-3823-42f8-996a-5fda43094ccf	9d5d1642-3cfa-492e-b714-48cca6ae76cd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"38.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":182,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 14:48:29
14144	9d5d1642-386e-4b6c-b517-e648e82cfa02	9d5d1642-3cfa-492e-b714-48cca6ae76cd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 14:48:29
14145	9d5d1642-3bfb-433d-a04a-5b22ede1305a	9d5d1642-3cfa-492e-b714-48cca6ae76cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 14:48:29
14146	9d5d1642-3c3c-4893-8673-c86e90878390	9d5d1642-3cfa-492e-b714-48cca6ae76cd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:48:29
15742	9d64ae44-6d6f-4e5f-bced-4a51c9cf9c57	9d64ae44-913b-4d49-a93b-1dc7d7a7d8e2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 09:24:20
15743	9d64ae44-86aa-42ac-8e75-fcba2b52364b	9d64ae44-913b-4d49-a93b-1dc7d7a7d8e2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"49.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"088d1fdbe045a08c3b0073ef22c7da32","hostname":"EderCortes"}	2024-11-02 09:24:20
15744	9d64ae44-8af4-48fa-846b-abce75d352af	9d64ae44-913b-4d49-a93b-1dc7d7a7d8e2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:24:20
15745	9d64ae44-8b5c-46ee-a18d-5f19b5eebd3d	9d64ae44-913b-4d49-a93b-1dc7d7a7d8e2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 09:24:20
15746	9d64ae44-8f78-4fa2-88af-c4735642277e	9d64ae44-913b-4d49-a93b-1dc7d7a7d8e2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 09:24:20
15747	9d64ae44-8fdf-4578-817d-50d84f6e4d17	9d64ae44-913b-4d49-a93b-1dc7d7a7d8e2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":268,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:24:20
24469	9d68b231-ca40-43ca-b58e-8bca5134da02	9d68b231-ec99-4f7c-9d4e-e58082c0910f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 09:18:37
14147	9d5d1644-4103-40c3-aa05-5fe41e4c7fd5	9d5d1644-604f-407c-b3bf-2bbe5c01a808	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 14:48:30
14148	9d5d1644-5b0c-42ad-bebe-a71816df3bf1	9d5d1644-604f-407c-b3bf-2bbe5c01a808	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 14:48:30
14149	9d5d1644-5b77-43ce-abca-1226cccb0141	9d5d1644-604f-407c-b3bf-2bbe5c01a808	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 14:48:30
14150	9d5d1644-5efb-4675-b5a6-ae71ad7612f5	9d5d1644-604f-407c-b3bf-2bbe5c01a808	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 14:48:30
14151	9d5d1644-5f3d-42f1-a271-ccdebf9abd57	9d5d1644-604f-407c-b3bf-2bbe5c01a808	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":369,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:48:30
24470	9d68b231-e3d1-4092-a5b0-663269aab6ba	9d68b231-ec99-4f7c-9d4e-e58082c0910f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\", \\"loans_fecha_ultimo_pago\\", \\"loans_intereses_recaudar\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta 2', 'De las nieve', 'ds', 'CC', '1004655468', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon2', 'Calle 7505', '1100000', 25, 5, 'S', null, '04-11-2024', 'Pendiente', '312596295', 12, 14, 19, 14, '04-11-2024', 0, 0, '04-11-2024', 275000, '2024-11-04 09:18:37', '2024-11-04 09:18:37') returning \\"id\\"","time":"4.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":110,"hash":"f69b6b91ceb0fd9e0c386e94fcedc496","hostname":"EderCortes"}	2024-11-04 09:18:37
24471	9d68b231-e423-4c7d-9b5c-00fd4f09f060	9d68b231-ec99-4f7c-9d4e-e58082c0910f	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:85","hostname":"EderCortes"}	2024-11-04 09:18:37
24472	9d68b231-e592-4c3f-98df-9679fc6645af	9d68b231-ec99-4f7c-9d4e-e58082c0910f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (85, 1, 220000, 55000, 'Pendiente', 'N\\/A', '12-11-2024', 12, 0, 0, '2024-11-04 09:18:37', '2024-11-04 09:18:37')","time":"2.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:37
24473	9d68b231-e5ba-4afb-9d7a-50827aa323e0	9d68b231-ec99-4f7c-9d4e-e58082c0910f	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:37
24474	9d68b231-e627-44d1-9ad1-0204e14de840	9d68b231-ec99-4f7c-9d4e-e58082c0910f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (85, 2, 220000, 55000, 'Pendiente', 'N\\/A', '20-11-2024', 12, 0, 0, '2024-11-04 09:18:37', '2024-11-04 09:18:37')","time":"0.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:37
24475	9d68b231-e671-4236-8c3d-d26154b4d643	9d68b231-ec99-4f7c-9d4e-e58082c0910f	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:37
24476	9d68b231-e6ee-44eb-b1c2-3206a1231d05	9d68b231-ec99-4f7c-9d4e-e58082c0910f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (85, 3, 220000, 55000, 'Pendiente', 'N\\/A', '28-11-2024', 12, 0, 0, '2024-11-04 09:18:37', '2024-11-04 09:18:37')","time":"0.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:37
24477	9d68b231-e711-4c28-a760-0062b184e43b	9d68b231-ec99-4f7c-9d4e-e58082c0910f	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:37
24478	9d68b231-e772-46e5-8d2a-c3a174615da8	9d68b231-ec99-4f7c-9d4e-e58082c0910f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (85, 4, 220000, 55000, 'Pendiente', 'N\\/A', '06-12-2024', 12, 0, 0, '2024-11-04 09:18:37', '2024-11-04 09:18:37')","time":"0.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:37
24479	9d68b231-e796-412b-9df0-ffc9e1877f71	9d68b231-ec99-4f7c-9d4e-e58082c0910f	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:37
14152	9d5d164b-b908-4dfe-8997-2d009939ba0f	9d5d164b-bcf0-4a87-9bea-be0ee4b8e910	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":178,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:48:35
24480	9d68b231-e7fe-4e48-bf98-c800f026d694	9d68b231-ec99-4f7c-9d4e-e58082c0910f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (85, 5, 220000, 55000, 'Pendiente', 'N\\/A', '14-12-2024', 12, 0, 0, '2024-11-04 09:18:37', '2024-11-04 09:18:37')","time":"0.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:37
24481	9d68b231-e81c-44ed-886a-c495aca3f3b0	9d68b231-ec99-4f7c-9d4e-e58082c0910f	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:37
15834	9d64b0cd-0434-443f-be41-eb1c4335c59e	9d64b0cd-245a-44c2-a13c-7811929a098c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:31:25
15835	9d64b0cd-22d7-488e-a431-402aab65eb92	9d64b0cd-245a-44c2-a13c-7811929a098c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 09:31:25
15836	9d64b0cd-2370-44a6-9394-0690aa74180b	9d64b0cd-245a-44c2-a13c-7811929a098c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:31:25
24482	9d68b231-eb56-4eef-95b6-74915453879d	9d68b231-ec99-4f7c-9d4e-e58082c0910f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 09:18:37
24483	9d68b231-eb99-4957-8881-39843fdfbbce	9d68b231-ec99-4f7c-9d4e-e58082c0910f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"801","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"1004655468","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_valor_prestado":"1100000","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":19,"user_recomendacion":14,"loans_inicio_pago":"Mon Nov 04 2024","created_at":null,"updated_at":null,"deleted_at":null,"loans_pago_prestado":0,"loans_pago_interes":0},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Mon Nov 04 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":85},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:18:37
709	9d4f2e22-b540-45a3-8aa0-ca91dc0ddf0d	9d4f2e22-b97f-47fc-af04-1546572dc40b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":51}	2024-10-22 16:53:40
24484	9d68b232-2fae-4c69-9770-f94c0dd8d9a3	9d68b232-5812-4cb7-b330-0be6928429c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 09:18:37
24485	9d68b232-4dfb-486a-b386-819aec238b87	9d68b232-5812-4cb7-b330-0be6928429c3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\", \\"loans_fecha_ultimo_pago\\", \\"loans_intereses_recaudar\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta 2', 'De las nieve', 'ds', 'CC', '1004655468', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon2', 'Calle 7505', '1100000', 25, 5, 'S', null, '04-11-2024', 'Pendiente', '312596295', 12, 14, 19, 14, '04-11-2024', 0, 0, '04-11-2024', 275000, '2024-11-04 09:18:38', '2024-11-04 09:18:38') returning \\"id\\"","time":"7.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":110,"hash":"f69b6b91ceb0fd9e0c386e94fcedc496","hostname":"EderCortes"}	2024-11-04 09:18:38
10205	9d56cb25-9043-4228-a043-e327423b84cd	9d56cb25-b4c2-4e62-9e08-92a9a46e59cd	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-26 11:43:29
10206	9d56cb25-b2df-4e9b-acab-47ed4d30cbc7	9d56cb25-b4c2-4e62-9e08-92a9a46e59cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-26 11:43:29
10207	9d56cb25-b3ac-4c43-9d6a-9e90a7dca4d2	9d56cb25-b4c2-4e62-9e08-92a9a46e59cd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":260,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:43:29
24486	9d68b232-4e75-4a17-88dc-8935e6d42a65	9d68b232-5812-4cb7-b330-0be6928429c3	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:86","hostname":"EderCortes"}	2024-11-04 09:18:38
24487	9d68b232-5010-46a3-955a-7eb5f8d7d583	9d68b232-5812-4cb7-b330-0be6928429c3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (86, 1, 220000, 55000, 'Pendiente', 'N\\/A', '12-11-2024', 12, 0, 0, '2024-11-04 09:18:38', '2024-11-04 09:18:38')","time":"2.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:38
24488	9d68b232-503a-4082-b3ea-302d6823c10a	9d68b232-5812-4cb7-b330-0be6928429c3	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:38
24489	9d68b232-50b7-47e7-b9e9-4ce8f68f1898	9d68b232-5812-4cb7-b330-0be6928429c3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (86, 2, 220000, 55000, 'Pendiente', 'N\\/A', '20-11-2024', 12, 0, 0, '2024-11-04 09:18:38', '2024-11-04 09:18:38')","time":"0.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:38
24490	9d68b232-50e5-457d-8de4-05ab9bfd2043	9d68b232-5812-4cb7-b330-0be6928429c3	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:38
24491	9d68b232-516d-49a6-91a5-ec53e19350ba	9d68b232-5812-4cb7-b330-0be6928429c3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (86, 3, 220000, 55000, 'Pendiente', 'N\\/A', '28-11-2024', 12, 0, 0, '2024-11-04 09:18:38', '2024-11-04 09:18:38')","time":"0.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:38
24492	9d68b232-5195-4cf5-b3a5-c9ff9b11cad2	9d68b232-5812-4cb7-b330-0be6928429c3	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:38
24493	9d68b232-520e-4880-b5fc-8c3b5ec3521b	9d68b232-5812-4cb7-b330-0be6928429c3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (86, 4, 220000, 55000, 'Pendiente', 'N\\/A', '06-12-2024', 12, 0, 0, '2024-11-04 09:18:38', '2024-11-04 09:18:38')","time":"0.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:38
24494	9d68b232-523a-4d3f-b052-94dbce6d088a	9d68b232-5812-4cb7-b330-0be6928429c3	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:38
24495	9d68b232-52c3-4283-9a35-45b9dd431683	9d68b232-5812-4cb7-b330-0be6928429c3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (86, 5, 220000, 55000, 'Pendiente', 'N\\/A', '14-12-2024', 12, 0, 0, '2024-11-04 09:18:38', '2024-11-04 09:18:38')","time":"0.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:38
24496	9d68b232-52ed-49db-862c-addd14344c3d	9d68b232-5812-4cb7-b330-0be6928429c3	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:38
24497	9d68b232-56ca-4c5a-9f26-4ccc01fcab7c	9d68b232-5812-4cb7-b330-0be6928429c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 09:18:38
14153	9d5d164c-3826-49e4-9f37-f136c53ab290	9d5d164c-3b54-4bca-8933-21915ac447c0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":144,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:48:36
15837	9d64b0cd-6e06-4e89-b7c0-cee219fe2f89	9d64b0cd-8d85-4d79-936d-35f5dd8ad615	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 09:31:25
15838	9d64b0cd-8368-48a5-8440-28ad4536823f	9d64b0cd-8d85-4d79-936d-35f5dd8ad615	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"42.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"088d1fdbe045a08c3b0073ef22c7da32","hostname":"EderCortes"}	2024-11-02 09:31:25
15839	9d64b0cd-874e-4c49-bb61-8aa936898106	9d64b0cd-8d85-4d79-936d-35f5dd8ad615	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:31:25
15840	9d64b0cd-8785-453b-8c42-e827765a7a47	9d64b0cd-8d85-4d79-936d-35f5dd8ad615	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 09:31:25
15841	9d64b0cd-8c20-48e5-888e-b553ee93402d	9d64b0cd-8d85-4d79-936d-35f5dd8ad615	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 09:31:25
15842	9d64b0cd-8c87-4bbc-8869-f3c7e2d1811c	9d64b0cd-8d85-4d79-936d-35f5dd8ad615	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:31:25
24498	9d68b232-5710-4565-881f-2c35c326f2c7	9d68b232-5812-4cb7-b330-0be6928429c3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"801","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"1004655468","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_valor_prestado":"1100000","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":19,"user_recomendacion":14,"loans_inicio_pago":"Mon Nov 04 2024","created_at":null,"updated_at":null,"deleted_at":null,"loans_pago_prestado":0,"loans_pago_interes":0},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Mon Nov 04 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":86},"duration":260,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:18:38
25741	9d68c8f4-63f3-40ac-a4b5-b5d718d2cf5d	9d68c8f4-653e-4303-a13a-0154e46d98c1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":491,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:22:16
10730	9d57205f-2b25-41b6-8a21-3b029dc531dc	9d57205f-49ac-4890-a1a8-6056ff253bcb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-26 15:41:48
10731	9d57205f-47dd-4652-a203-f9b83eb87555	9d57205f-49ac-4890-a1a8-6056ff253bcb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-26 15:41:48
10732	9d57205f-4874-4e54-85b2-161cfd690e6b	9d57205f-49ac-4890-a1a8-6056ff253bcb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":245,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:41:48
24499	9d68b232-96b8-4f55-9140-f65a2d74ecbe	9d68b232-e675-4284-88a6-c6cd0bfe77ab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 09:18:38
24500	9d68b232-dcaf-4c10-b15e-32b6c2224b75	9d68b232-e675-4284-88a6-c6cd0bfe77ab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\", \\"loans_fecha_ultimo_pago\\", \\"loans_intereses_recaudar\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta 2', 'De las nieve', 'ds', 'CC', '1004655468', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon2', 'Calle 7505', '1100000', 25, 5, 'S', null, '04-11-2024', 'Pendiente', '312596295', 12, 14, 19, 14, '04-11-2024', 0, 0, '04-11-2024', 275000, '2024-11-04 09:18:38', '2024-11-04 09:18:38') returning \\"id\\"","time":"5.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":110,"hash":"f69b6b91ceb0fd9e0c386e94fcedc496","hostname":"EderCortes"}	2024-11-04 09:18:38
24501	9d68b232-dd04-467c-b92b-b6cd0b6e3b4e	9d68b232-e675-4284-88a6-c6cd0bfe77ab	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:87","hostname":"EderCortes"}	2024-11-04 09:18:38
24502	9d68b232-de76-4078-a687-06db01e140fb	9d68b232-e675-4284-88a6-c6cd0bfe77ab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (87, 1, 220000, 55000, 'Pendiente', 'N\\/A', '12-11-2024', 12, 0, 0, '2024-11-04 09:18:38', '2024-11-04 09:18:38')","time":"2.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:38
24503	9d68b232-dea9-49f5-9621-f8adb7ed65d9	9d68b232-e675-4284-88a6-c6cd0bfe77ab	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:38
24504	9d68b232-df63-43a4-a634-32b2aafae7c3	9d68b232-e675-4284-88a6-c6cd0bfe77ab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (87, 2, 220000, 55000, 'Pendiente', 'N\\/A', '20-11-2024', 12, 0, 0, '2024-11-04 09:18:38', '2024-11-04 09:18:38')","time":"0.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:38
24505	9d68b232-df99-4c5f-be9a-09e468431a86	9d68b232-e675-4284-88a6-c6cd0bfe77ab	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:38
10733	9d57205f-95b3-4861-9028-c24626ae9d27	9d57205f-dfde-48a3-868b-4e07c78ca833	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-26 15:41:48
10734	9d57205f-da24-42d7-8c9d-01b44a7056aa	9d57205f-dfde-48a3-868b-4e07c78ca833	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"151.35","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-10-26 15:41:48
10735	9d57205f-daa9-4b0d-971c-36c4cf83ba97	9d57205f-dfde-48a3-868b-4e07c78ca833	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-10-26 15:41:48
10736	9d57205f-de73-467c-bf74-c243c4e15838	9d57205f-dfde-48a3-868b-4e07c78ca833	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-26 15:41:48
10737	9d57205f-dec3-497f-b534-75e7dac4c41d	9d57205f-dfde-48a3-868b-4e07c78ca833	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":351,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:41:48
14154	9d5d164c-b56d-41e7-8717-3a8667f29aab	9d5d164c-cf76-4341-b3cf-4a28926cf513	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 14:48:36
14155	9d5d164c-cb62-4509-b149-135ff503c62b	9d5d164c-cf76-4341-b3cf-4a28926cf513	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ma%' or \\"users\\".\\"user_document\\"::text like '%Ma%') order by \\"users\\".\\"user_document\\" asc","time":"39.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 14:48:36
14156	9d5d164c-ce4b-46b0-9409-ef38df745bd8	9d5d164c-cf76-4341-b3cf-4a28926cf513	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 14:48:36
14157	9d5d164c-ce90-42e3-adf0-fab86cb8751f	9d5d164c-cf76-4341-b3cf-4a28926cf513	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ma"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":219,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:48:36
10738	9d572061-6c51-4a3c-b239-9f97eee9efb5	9d572061-8bcd-41e4-b373-3a0ac78dc873	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-26 15:41:49
10739	9d572061-86d2-40e8-9889-df2365eb5857	9d572061-8bcd-41e4-b373-3a0ac78dc873	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-26 15:41:49
10740	9d572061-871c-425f-adfb-890afd930c83	9d572061-8bcd-41e4-b373-3a0ac78dc873	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-26 15:41:49
10741	9d572061-8a9f-4923-92d8-50323f1f2348	9d572061-8bcd-41e4-b373-3a0ac78dc873	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-26 15:41:49
10742	9d572061-8adf-4d5e-b1d9-9ab6b69e8ac0	9d572061-8bcd-41e4-b373-3a0ac78dc873	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-10-26 15:41:49
14158	9d5d164d-0a7b-40f1-9580-08f9af9e0e0b	9d5d164d-0db1-45b4-af87-18460ae564a6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":138,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:48:36
15843	9d64b0cf-578d-4f0e-972a-ec0da54dc696	9d64b0cf-7a1a-4b08-b59d-d9b792faf4a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 09:31:26
15844	9d64b0cf-742d-43a8-bdf3-ab0308abf6a7	9d64b0cf-7a1a-4b08-b59d-d9b792faf4a2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"49.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 09:31:26
15845	9d64b0cf-749e-4837-ae55-297f4935a673	9d64b0cf-7a1a-4b08-b59d-d9b792faf4a2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 09:31:26
15846	9d64b0cf-7860-452e-be42-81e08222e38f	9d64b0cf-7a1a-4b08-b59d-d9b792faf4a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 09:31:26
15847	9d64b0cf-78bf-495b-afbc-e96133f3f80c	9d64b0cf-7a1a-4b08-b59d-d9b792faf4a2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":259,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:31:26
24506	9d68b232-e05c-4152-931f-f185f4ceb97e	9d68b232-e675-4284-88a6-c6cd0bfe77ab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (87, 3, 220000, 55000, 'Pendiente', 'N\\/A', '28-11-2024', 12, 0, 0, '2024-11-04 09:18:38', '2024-11-04 09:18:38')","time":"0.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:38
24507	9d68b232-e085-4c92-bc6e-68795bdbb197	9d68b232-e675-4284-88a6-c6cd0bfe77ab	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:38
24508	9d68b232-e0f5-46c0-95ff-666e663e1ea5	9d68b232-e675-4284-88a6-c6cd0bfe77ab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (87, 4, 220000, 55000, 'Pendiente', 'N\\/A', '06-12-2024', 12, 0, 0, '2024-11-04 09:18:38', '2024-11-04 09:18:38')","time":"0.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:38
14159	9d5d164d-5757-412b-ad43-dab8530efe40	9d5d164d-5a07-44d2-9ed7-7b103e455872	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":130,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:48:36
24509	9d68b232-e114-48f1-8b0a-e5a1dc66d666	9d68b232-e675-4284-88a6-c6cd0bfe77ab	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:38
24510	9d68b232-e177-452b-b775-bd5f66512cf6	9d68b232-e675-4284-88a6-c6cd0bfe77ab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (87, 5, 220000, 55000, 'Pendiente', 'N\\/A', '14-12-2024', 12, 0, 0, '2024-11-04 09:18:38', '2024-11-04 09:18:38')","time":"0.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:38
24511	9d68b232-e196-411a-a2df-d08a475c9b6a	9d68b232-e675-4284-88a6-c6cd0bfe77ab	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:38
24512	9d68b232-e51f-4cba-a4c6-40af1cab368c	9d68b232-e675-4284-88a6-c6cd0bfe77ab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 09:18:38
24513	9d68b232-e562-4dbf-b8f8-21545996c421	9d68b232-e675-4284-88a6-c6cd0bfe77ab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"801","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"1004655468","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_valor_prestado":"1100000","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":19,"user_recomendacion":14,"loans_inicio_pago":"Mon Nov 04 2024","created_at":null,"updated_at":null,"deleted_at":null,"loans_pago_prestado":0,"loans_pago_interes":0},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Mon Nov 04 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":87},"duration":346,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:18:38
14160	9d5d164d-d708-4619-9015-e56033ea6b51	9d5d164e-1dfd-4413-8975-f087f8fe71c1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 14:48:37
14161	9d5d164e-19fc-45b1-8c65-c6ad36ae874e	9d5d164e-1dfd-4413-8975-f087f8fe71c1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ma%' or \\"users\\".\\"user_document\\"::text like '%Ma%') order by \\"users\\".\\"user_document\\" asc","time":"155.19","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 14:48:37
14162	9d5d164e-1cda-435e-a4c5-b6be5b659e0b	9d5d164e-1dfd-4413-8975-f087f8fe71c1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 14:48:37
14163	9d5d164e-1d21-42ba-a49a-bfe78a500ebc	9d5d164e-1dfd-4413-8975-f087f8fe71c1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ma"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:48:37
24514	9d68b233-2c17-4f49-8f80-9bebf28be5e0	9d68b233-54fa-4c24-85f4-14f17750d013	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 09:18:38
24515	9d68b233-4b25-4d91-be3f-cdb421096778	9d68b233-54fa-4c24-85f4-14f17750d013	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\", \\"loans_fecha_ultimo_pago\\", \\"loans_intereses_recaudar\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta 2', 'De las nieve', 'ds', 'CC', '1004655468', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon2', 'Calle 7505', '1100000', 25, 5, 'S', null, '04-11-2024', 'Pendiente', '312596295', 12, 14, 19, 14, '04-11-2024', 0, 0, '04-11-2024', 275000, '2024-11-04 09:18:38', '2024-11-04 09:18:38') returning \\"id\\"","time":"5.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":110,"hash":"f69b6b91ceb0fd9e0c386e94fcedc496","hostname":"EderCortes"}	2024-11-04 09:18:38
24516	9d68b233-4b8e-4b02-ae91-16745be75bb8	9d68b233-54fa-4c24-85f4-14f17750d013	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:88","hostname":"EderCortes"}	2024-11-04 09:18:38
24517	9d68b233-4d29-4a0a-b852-3c182e0efec6	9d68b233-54fa-4c24-85f4-14f17750d013	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (88, 1, 220000, 55000, 'Pendiente', 'N\\/A', '12-11-2024', 12, 0, 0, '2024-11-04 09:18:38', '2024-11-04 09:18:38')","time":"2.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:38
24518	9d68b233-4d51-44e4-bfe4-f6e642d1acb1	9d68b233-54fa-4c24-85f4-14f17750d013	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:38
24519	9d68b233-4de7-4ab7-84c0-3597e320557b	9d68b233-54fa-4c24-85f4-14f17750d013	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (88, 2, 220000, 55000, 'Pendiente', 'N\\/A', '20-11-2024', 12, 0, 0, '2024-11-04 09:18:38', '2024-11-04 09:18:38')","time":"0.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:38
24520	9d68b233-4e13-41bd-b05e-8cad482139aa	9d68b233-54fa-4c24-85f4-14f17750d013	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:38
24521	9d68b233-4e9a-4c36-88c7-592b2ac62cca	9d68b233-54fa-4c24-85f4-14f17750d013	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (88, 3, 220000, 55000, 'Pendiente', 'N\\/A', '28-11-2024', 12, 0, 0, '2024-11-04 09:18:38', '2024-11-04 09:18:38')","time":"0.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:38
24522	9d68b233-4ec4-493b-891c-937a510f8e90	9d68b233-54fa-4c24-85f4-14f17750d013	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:38
24523	9d68b233-4f45-4d0f-b204-785866ce55eb	9d68b233-54fa-4c24-85f4-14f17750d013	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (88, 4, 220000, 55000, 'Pendiente', 'N\\/A', '06-12-2024', 12, 0, 0, '2024-11-04 09:18:38', '2024-11-04 09:18:38')","time":"0.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:38
24524	9d68b233-4f66-42aa-b335-dc73d6afe175	9d68b233-54fa-4c24-85f4-14f17750d013	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:38
14164	9d5d164e-622b-4b54-a10a-b5e1ec9a3e23	9d5d164e-654e-4b4f-8975-ce70dc0664b2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":151,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:48:37
24525	9d68b233-4fdd-4ea7-92de-eeabd05d2b9c	9d68b233-54fa-4c24-85f4-14f17750d013	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (88, 5, 220000, 55000, 'Pendiente', 'N\\/A', '14-12-2024', 12, 0, 0, '2024-11-04 09:18:38', '2024-11-04 09:18:38')","time":"0.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:38
19051	9d66cf8a-ee5b-47f9-98c6-dd63d91b636b	9d66cf8b-1e17-49f2-b1f9-448b95966802	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 10:49:02
19052	9d66cf8b-1bd6-43ee-8fe6-0bcc8f7ffd4c	9d66cf8b-1e17-49f2-b1f9-448b95966802	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 10:49:02
19053	9d66cf8b-1cc9-43d8-aae4-d8e94655fd32	9d66cf8b-1e17-49f2-b1f9-448b95966802	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":389,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:49:02
24526	9d68b233-5001-4a29-859d-23ddc226497f	9d68b233-54fa-4c24-85f4-14f17750d013	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:38
24527	9d68b233-5376-4f3e-94a5-97820082f98b	9d68b233-54fa-4c24-85f4-14f17750d013	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 09:18:38
24528	9d68b233-53bc-4ba0-9823-ea9b85c4a7ec	9d68b233-54fa-4c24-85f4-14f17750d013	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"801","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"1004655468","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_valor_prestado":"1100000","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":19,"user_recomendacion":14,"loans_inicio_pago":"Mon Nov 04 2024","created_at":null,"updated_at":null,"deleted_at":null,"loans_pago_prestado":0,"loans_pago_interes":0},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Mon Nov 04 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":88},"duration":262,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:18:38
25641	9d68c7b1-5d74-42d6-8d06-293111c3bddc	9d68c7b1-85e7-4649-9a7b-cb1f5bedb38c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:18:44
25642	9d68c7b1-8320-4ba5-a585-781e26a934c8	9d68c7b1-85e7-4649-9a7b-cb1f5bedb38c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:18:44
25643	9d68c7b1-8432-4d9e-97b8-dc47fda33361	9d68c7b1-85e7-4649-9a7b-cb1f5bedb38c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":460,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:18:44
14165	9d5d164e-e348-489f-ab49-201a1925ce40	9d5d164e-fd7a-4a28-80e6-65b482112b99	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 14:48:37
14166	9d5d164e-f927-4787-b74e-858de0aee8bb	9d5d164e-fd7a-4a28-80e6-65b482112b99	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mar%' or \\"users\\".\\"user_document\\"::text like '%Mar%') order by \\"users\\".\\"user_document\\" asc","time":"39.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 14:48:37
14167	9d5d164e-fc2a-4778-9cda-bac280dbfe6d	9d5d164e-fd7a-4a28-80e6-65b482112b99	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 14:48:37
14168	9d5d164e-fc84-4e9a-aa4f-2e6d59748ef0	9d5d164e-fd7a-4a28-80e6-65b482112b99	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mar"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:48:37
19054	9d66cf8b-a39f-4928-8f12-6bc3024ebbc3	9d66cf8b-f384-4b87-9129-a4fc78ff5469	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 10:49:02
15934	9d64b576-1382-4606-aa1e-c4fc802f6d97	9d64b576-4222-4f42-b9e8-14487877a548	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 09:44:27
15935	9d64b576-3f6f-42e3-9bf5-85739b2cfd32	9d64b576-4222-4f42-b9e8-14487877a548	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:44:27
15936	9d64b576-40ca-4e0c-b740-9bf7ea5fab87	9d64b576-4222-4f42-b9e8-14487877a548	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":380,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:44:27
19055	9d66cf8b-e558-4a04-a33d-ceccd9da7116	9d66cf8b-f384-4b87-9129-a4fc78ff5469	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"152.98","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 10:49:02
19056	9d66cf8b-ea65-4ed0-8810-56592587ce3a	9d66cf8b-f384-4b87-9129-a4fc78ff5469	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 10:49:02
19057	9d66cf8b-eaaf-446a-b89f-bf046c873738	9d66cf8b-f384-4b87-9129-a4fc78ff5469	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 10:49:02
19058	9d66cf8b-f218-4c14-9f4f-3d28d62c6f36	9d66cf8b-f384-4b87-9129-a4fc78ff5469	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 10:49:02
19059	9d66cf8b-f27b-482d-bf0c-b49dc8aa388d	9d66cf8b-f384-4b87-9129-a4fc78ff5469	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T02:27:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"0"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":483,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:49:02
24529	9d68b233-9c7a-4129-8c50-fcf50c9c3fbe	9d68b233-ba94-4db4-86b6-4adb610b88a0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 09:18:38
24530	9d68b233-b671-4c73-bb59-75f9df016da7	9d68b233-ba94-4db4-86b6-4adb610b88a0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"48.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 09:18:38
14169	9d5d164f-3b17-4862-9aa4-4d3eabafc583	9d5d164f-803b-4c5b-a95d-a839196298ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 14:48:38
14170	9d5d164f-7c22-4848-aff2-d7cbf078b37c	9d5d164f-803b-4c5b-a95d-a839196298ef	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"149.51","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 14:48:38
14171	9d5d164f-7f04-4dd4-ad8d-c9fac86d7d90	9d5d164f-803b-4c5b-a95d-a839196298ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-29 14:48:38
14172	9d5d164f-7f47-4fde-a8fe-d9ffee20ab56	9d5d164f-803b-4c5b-a95d-a839196298ef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":326,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:48:38
15937	9d64b576-cb09-47f7-91c9-f4ba634a369d	9d64b576-f3f4-4685-903a-7f3a2c3173de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:44:27
15938	9d64b576-e8d6-45c8-a01f-a2db054bc0a3	9d64b576-f3f4-4685-903a-7f3a2c3173de	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 22\\n                        ","time":"57.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"f9344e277d181987f84c6dcddcb4342d","hostname":"EderCortes"}	2024-11-02 09:44:27
14287	9d5d195d-bdc3-4e95-a9b1-1d3ba9e472d0	9d5d195e-1c45-4a50-bb05-5f6ebac91e45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 14:57:10
14288	9d5d195e-197f-46a5-a139-890fd07a64ee	9d5d195e-1c45-4a50-bb05-5f6ebac91e45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 14:57:11
14289	9d5d195e-1ac4-480c-957b-a98a5bb90e76	9d5d195e-1c45-4a50-bb05-5f6ebac91e45	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":626,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:57:11
15939	9d64b576-ed57-4188-beff-a399f4bebe6c	9d64b576-f3f4-4685-903a-7f3a2c3173de	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '22' order by \\"item_loans\\".\\"id\\" asc","time":"2.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:44:27
15940	9d64b576-eda0-42c5-81ad-e42bbd149310	9d64b576-f3f4-4685-903a-7f3a2c3173de	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-02 09:44:27
15941	9d64b576-f287-4716-a29f-780f13d2491c	9d64b576-f3f4-4685-903a-7f3a2c3173de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:44:27
15942	9d64b576-f2ed-4718-9532-d16223e5239a	9d64b576-f3f4-4685-903a-7f3a2c3173de	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/22","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":22,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":70,"loans_codigo":22,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":71,"loans_codigo":22,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":72,"loans_codigo":22,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":73,"loans_codigo":22,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":74,"loans_codigo":22,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":75,"loans_codigo":22,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-04-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":406,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:44:27
19060	9d66cf8d-e7a3-459a-99b5-a0c1243f01d7	9d66cf8e-0244-4bf9-b0b3-4aa1c58f2426	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 10:49:04
19061	9d66cf8d-fd92-45c2-ae13-2cd23216ce47	9d66cf8e-0244-4bf9-b0b3-4aa1c58f2426	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"38.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 10:49:04
19062	9d66cf8d-fdd9-4dbb-8b92-3135b016809a	9d66cf8e-0244-4bf9-b0b3-4aa1c58f2426	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 10:49:04
19063	9d66cf8e-0106-4ca8-8d37-33ec8155477e	9d66cf8e-0244-4bf9-b0b3-4aa1c58f2426	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 10:49:04
24531	9d68b233-b946-4bb2-9983-73d4b2adb62f	9d68b233-ba94-4db4-86b6-4adb610b88a0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 09:18:38
14173	9d5d164f-bfa2-4dad-acf2-3b67c8dcb6a7	9d5d164f-da6b-4af6-aff6-9683073164d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-29 14:48:38
14174	9d5d164f-d657-4d3b-901d-919bddf71702	9d5d164f-da6b-4af6-aff6-9683073164d5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"42.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 14:48:38
14175	9d5d164f-d93b-4e07-a348-9b0464ff3a8a	9d5d164f-da6b-4af6-aff6-9683073164d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-29 14:48:38
14176	9d5d164f-d984-4838-b00c-27f76fb815f2	9d5d164f-da6b-4af6-aff6-9683073164d5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":218,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:48:38
14290	9d5d195e-d324-486b-80dd-4c4b23d6ec72	9d5d195f-5498-4105-953f-b6f148e3d25d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 14:57:11
14291	9d5d195f-4433-4df3-ad18-b5879e5c1364	9d5d195f-5498-4105-953f-b6f148e3d25d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 55\\n                        ","time":"267.89","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"ff7240abed4441475e0acd0c74a5f6aa","hostname":"EderCortes"}	2024-10-29 14:57:11
14292	9d5d195f-49fa-41e8-a331-424e7002b803	9d5d195f-5498-4105-953f-b6f148e3d25d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '55' order by \\"item_loans\\".\\"id\\" asc","time":"3.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 14:57:11
14293	9d5d195f-4a4c-42c4-bdc1-0685fdf32f32	9d5d195f-5498-4105-953f-b6f148e3d25d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":7,"hostname":"EderCortes"}	2024-10-29 14:57:11
14294	9d5d195f-528d-4d20-b026-212f72fe5ffa	9d5d195f-5498-4105-953f-b6f148e3d25d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 14:57:11
14295	9d5d195f-5344-4dfa-8627-45af130a8e85	9d5d195f-5498-4105-953f-b6f148e3d25d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/55","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":55,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":7,"loans_valor_prestado":50000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"15-11-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":150,"loans_codigo":55,"itemloans_cuota":"1","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":151,"loans_codigo":55,"itemloans_cuota":"2","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":152,"loans_codigo":55,"itemloans_cuota":"3","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":153,"loans_codigo":55,"itemloans_cuota":"4","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":154,"loans_codigo":55,"itemloans_cuota":"5","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":155,"loans_codigo":55,"itemloans_cuota":"6","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":156,"loans_codigo":55,"itemloans_cuota":"7","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":741,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:57:11
15943	9d64b578-ee83-48ba-b162-5d4465818d9c	9d64b579-159d-42d1-8be3-cb42bb98eb39	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:44:28
15944	9d64b579-0eca-4617-9c26-94aea2712e7e	9d64b579-159d-42d1-8be3-cb42bb98eb39	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"55.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 09:44:29
15945	9d64b579-0f3a-4d67-b740-a59063953fe3	9d64b579-159d-42d1-8be3-cb42bb98eb39	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 09:44:29
15946	9d64b579-13e8-487b-b058-badf08b7d0e5	9d64b579-159d-42d1-8be3-cb42bb98eb39	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 09:44:29
25644	9d68c7b2-7827-4dc3-9bf0-56ec878ba2a6	9d68c7b2-b1ca-460b-aeaf-0281d0f8dfb3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:18:45
14177	9d5d1653-e813-4adc-be3a-732d92f81bbb	9d5d1654-352a-4ec3-b7a0-20e6e6db2a60	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-29 14:48:41
14178	9d5d1654-2fc7-432e-a2fd-1ae51b95283b	9d5d1654-352a-4ec3-b7a0-20e6e6db2a60	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '18' and \\"users\\".\\"deleted_at\\" is null","time":"158.29","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":55,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-29 14:48:41
14179	9d5d1654-3018-410e-8522-0d3641b40161	9d5d1654-352a-4ec3-b7a0-20e6e6db2a60	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 14:48:41
14180	9d5d1654-33df-4911-82c6-0792aaeea1ed	9d5d1654-352a-4ec3-b7a0-20e6e6db2a60	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-29 14:48:41
14181	9d5d1654-3431-4724-994b-0a4a90cf7c47	9d5d1654-352a-4ec3-b7a0-20e6e6db2a60	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/18","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}},"duration":377,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:48:41
14296	9d5d195f-cfa8-40f7-82c1-70bd53dcd027	9d5d1960-048e-4eb7-aefb-318f0615a5ad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 14:57:12
14297	9d5d195f-fa35-4398-af21-f817367900f8	9d5d1960-048e-4eb7-aefb-318f0615a5ad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"62.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 14:57:12
14298	9d5d195f-fac2-4636-859c-3be12e97bf2c	9d5d1960-048e-4eb7-aefb-318f0615a5ad	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 14:57:12
14299	9d5d1960-0214-42bd-898f-7917d17d33b8	9d5d1960-048e-4eb7-aefb-318f0615a5ad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 14:57:12
14300	9d5d1960-02ac-4b11-ab48-4063dde307b8	9d5d1960-048e-4eb7-aefb-318f0615a5ad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":433,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:57:12
15947	9d64b579-1454-42a6-92cf-2b4fc133d2f6	9d64b579-159d-42d1-8be3-cb42bb98eb39	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","user-agent":"Mozilla\\/5.0 (iPhone; CPU iPhone OS 16_6 like Mac OS X) AppleWebKit\\/605.1.15 (KHTML, like Gecko) Version\\/16.6 Mobile\\/15E148 Safari\\/604.1","accept":"application\\/json, text\\/plain, *\\/*","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":327,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:44:29
14182	9d5d167d-1791-4049-9779-ef7a9860a2a3	9d5d167d-1b2b-46ac-971c-e83736e4e13d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":160,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:49:08
14301	9d5d1960-9963-4540-a7b6-7a3e818ef7ae	9d5d1960-c8e9-406e-b650-830252669280	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 14:57:12
14302	9d5d1960-c030-4958-bd98-0efcd6a026cc	9d5d1960-c8e9-406e-b650-830252669280	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"65.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 14:57:12
14303	9d5d1960-c0d0-42dd-8c0e-99bfc1c407e4	9d5d1960-c8e9-406e-b650-830252669280	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 14:57:12
14304	9d5d1960-c723-49b4-bd17-e5bd6cb34a77	9d5d1960-c8e9-406e-b650-830252669280	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 14:57:12
14305	9d5d1960-c795-4280-b298-db6245d734aa	9d5d1960-c8e9-406e-b650-830252669280	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":471,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:57:12
19064	9d66cf8e-0147-4aa0-889b-c96ca969c8f6	9d66cf8e-0244-4bf9-b0b3-4aa1c58f2426	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":214,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:49:04
24532	9d68b233-b9a7-446d-a6cd-f8a3d3a3feb7	9d68b233-ba94-4db4-86b6-4adb610b88a0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:18:38
14183	9d5d167d-cde5-4b34-9c91-a107b4420230	9d5d167e-1f69-4245-88bb-18ea8a7d5405	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 14:49:08
14184	9d5d167e-11de-4533-bb66-30704cf5269d	9d5d167e-1f69-4245-88bb-18ea8a7d5405	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta', 'De las nieve', 'ds', 'CC', '100465546', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '600000', 30, 7, 'Q', null, '12-11-2024', 'Pendiente', '312596295', 12, 14, 18, 14, '12-11-2024', '2024-10-29 14:49:08', '2024-10-29 14:49:08') returning \\"id\\"","time":"5.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":104,"hash":"bfad4cea82a73099ff0b3164dd496ca0","hostname":"EderCortes"}	2024-10-29 14:49:08
14185	9d5d167e-1250-4a88-9e08-4715a5317bbf	9d5d167e-1f69-4245-88bb-18ea8a7d5405	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:54","hostname":"EderCortes"}	2024-10-29 14:49:08
14186	9d5d167e-1388-42d2-8fa5-01edbec81562	9d5d167e-1f69-4245-88bb-18ea8a7d5405	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (54, 1, 85714.285714286, 15000, 'Pendiente', 'N\\/A', '27-11-2024', 12, '2024-10-29 14:49:08', '2024-10-29 14:49:08')","time":"1.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":155,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 14:49:08
10296	9d56cd48-9895-40b6-af56-ccc4731aafd8	9d56cd48-c2ae-4fbf-b3da-5715b5319758	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-26 11:49:28
10297	9d56cd48-c0f6-4e86-a8f8-14d4f1ad7a6c	9d56cd48-c2ae-4fbf-b3da-5715b5319758	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-26 11:49:28
10298	9d56cd48-c1bb-482f-946d-dbb8bb6fa23e	9d56cd48-c2ae-4fbf-b3da-5715b5319758	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:49:28
14187	9d5d167e-13b1-4440-956f-2cc9e6e6d62c	9d5d167e-1f69-4245-88bb-18ea8a7d5405	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 14:49:08
14188	9d5d167e-1437-407a-bf2d-c864ef0bbdcc	9d5d167e-1f69-4245-88bb-18ea8a7d5405	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (54, 2, 85714.285714286, 15000, 'Pendiente', 'N\\/A', '12-12-2024', 12, '2024-10-29 14:49:08', '2024-10-29 14:49:08')","time":"0.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":155,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 14:49:08
14189	9d5d167e-1466-4893-b3bc-197cfa9766e3	9d5d167e-1f69-4245-88bb-18ea8a7d5405	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 14:49:08
14190	9d5d167e-14e2-478e-9dd5-c578eb76040f	9d5d167e-1f69-4245-88bb-18ea8a7d5405	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (54, 3, 85714.285714286, 15000, 'Pendiente', 'N\\/A', '27-12-2024', 12, '2024-10-29 14:49:08', '2024-10-29 14:49:08')","time":"0.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":155,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 14:49:08
14191	9d5d167e-1510-4ed3-b879-3aef0c5b417b	9d5d167e-1f69-4245-88bb-18ea8a7d5405	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 14:49:08
14192	9d5d167e-156f-4098-a722-4d2f0e651aae	9d5d167e-1f69-4245-88bb-18ea8a7d5405	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (54, 4, 85714.285714286, 15000, 'Pendiente', 'N\\/A', '11-01-2025', 12, '2024-10-29 14:49:08', '2024-10-29 14:49:08')","time":"0.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":155,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 14:49:08
14193	9d5d167e-158b-49ec-80a3-e5606c54fa96	9d5d167e-1f69-4245-88bb-18ea8a7d5405	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 14:49:08
14194	9d5d167e-15e9-48f4-8577-fa608babd8f0	9d5d167e-1f69-4245-88bb-18ea8a7d5405	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (54, 5, 85714.285714286, 15000, 'Pendiente', 'N\\/A', '26-01-2025', 12, '2024-10-29 14:49:08', '2024-10-29 14:49:08')","time":"0.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":155,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 14:49:08
14195	9d5d167e-1605-4344-a15a-d1b551c3d0c8	9d5d167e-1f69-4245-88bb-18ea8a7d5405	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 14:49:08
14196	9d5d167e-1666-47d3-91fa-eb54778a7ba5	9d5d167e-1f69-4245-88bb-18ea8a7d5405	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (54, 6, 85714.285714286, 15000, 'Pendiente', 'N\\/A', '10-02-2025', 12, '2024-10-29 14:49:08', '2024-10-29 14:49:08')","time":"0.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":155,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 14:49:08
14197	9d5d167e-1687-46f5-8491-f2673cc322b1	9d5d167e-1f69-4245-88bb-18ea8a7d5405	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 14:49:08
14198	9d5d167e-16e6-45de-b3db-7b54163d9fa9	9d5d167e-1f69-4245-88bb-18ea8a7d5405	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (54, 7, 85714.285714286, 15000, 'Pendiente', 'N\\/A', '25-02-2025', 12, '2024-10-29 14:49:08', '2024-10-29 14:49:08')","time":"0.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":155,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 14:49:08
14199	9d5d167e-1706-41d1-b4e7-26501c5ae726	9d5d167e-1f69-4245-88bb-18ea8a7d5405	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 14:49:08
14200	9d5d167e-1de3-447f-a79b-054269638615	9d5d167e-1f69-4245-88bb-18ea8a7d5405	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 14:49:08
14201	9d5d167e-1e4a-427d-88ba-9cf2f2fb2740	9d5d167e-1f69-4245-88bb-18ea8a7d5405	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"743","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"100465546","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"600000","loans_intereses":30,"loans_cuotas":7,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":18,"user_recomendacion":14,"loans_inicio_pago":"12-11-2024","created_at":null,"updated_at":null,"deleted_at":null},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Tue Oct 29 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":54},"duration":352,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:49:08
24533	9d68b234-0b18-4dfd-8ebb-5fba9ddbf264	9d68b234-2fee-414f-9191-4ba64c2f1efc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 09:18:39
24534	9d68b234-268c-4101-ac50-7174c29a4cf5	9d68b234-2fee-414f-9191-4ba64c2f1efc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\", \\"loans_fecha_ultimo_pago\\", \\"loans_intereses_recaudar\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta 2', 'De las nieve', 'ds', 'CC', '1004655468', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon2', 'Calle 7505', '1100000', 25, 5, 'S', null, '04-11-2024', 'Pendiente', '312596295', 12, 14, 19, 14, '04-11-2024', 0, 0, '04-11-2024', 275000, '2024-11-04 09:18:39', '2024-11-04 09:18:39') returning \\"id\\"","time":"5.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":110,"hash":"f69b6b91ceb0fd9e0c386e94fcedc496","hostname":"EderCortes"}	2024-11-04 09:18:39
24535	9d68b234-26fe-4352-80cf-36aa519add67	9d68b234-2fee-414f-9191-4ba64c2f1efc	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:89","hostname":"EderCortes"}	2024-11-04 09:18:39
24536	9d68b234-28cd-4ebc-afc5-42eacf4f639c	9d68b234-2fee-414f-9191-4ba64c2f1efc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (89, 1, 220000, 55000, 'Pendiente', 'N\\/A', '12-11-2024', 12, 0, 0, '2024-11-04 09:18:39', '2024-11-04 09:18:39')","time":"3.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:39
24537	9d68b234-28ff-47ee-b9bc-e5c88b22e290	9d68b234-2fee-414f-9191-4ba64c2f1efc	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:39
24538	9d68b234-2988-4c6e-9a59-d78dc2b98052	9d68b234-2fee-414f-9191-4ba64c2f1efc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (89, 2, 220000, 55000, 'Pendiente', 'N\\/A', '20-11-2024', 12, 0, 0, '2024-11-04 09:18:39', '2024-11-04 09:18:39')","time":"0.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:39
24539	9d68b234-29ac-4ab9-ba66-f8abb8793636	9d68b234-2fee-414f-9191-4ba64c2f1efc	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:39
24540	9d68b234-2a13-477f-bedd-f5a76a1fca44	9d68b234-2fee-414f-9191-4ba64c2f1efc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (89, 3, 220000, 55000, 'Pendiente', 'N\\/A', '28-11-2024', 12, 0, 0, '2024-11-04 09:18:39', '2024-11-04 09:18:39')","time":"0.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:39
24541	9d68b234-2a33-4371-bb67-5b6d82c3dfa5	9d68b234-2fee-414f-9191-4ba64c2f1efc	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:39
24542	9d68b234-2a96-452d-a5a1-1c04e5c56098	9d68b234-2fee-414f-9191-4ba64c2f1efc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (89, 4, 220000, 55000, 'Pendiente', 'N\\/A', '06-12-2024', 12, 0, 0, '2024-11-04 09:18:39', '2024-11-04 09:18:39')","time":"0.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:39
24543	9d68b234-2ab3-4196-b4e4-8e3a6f19444f	9d68b234-2fee-414f-9191-4ba64c2f1efc	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:39
25645	9d68c7b2-9b04-410c-b478-bff652d9ef24	9d68c7b2-b1ca-460b-aeaf-0281d0f8dfb3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"71.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:18:45
25646	9d68c7b2-a35f-4623-982b-f439fe398ea8	9d68c7b2-b1ca-460b-aeaf-0281d0f8dfb3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"4.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:18:45
25647	9d68c7b2-a426-4e86-ae61-e06cf8e96f8b	9d68c7b2-b1ca-460b-aeaf-0281d0f8dfb3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:18:45
25648	9d68c7b2-aee8-4bdf-85b2-09f111244c19	9d68c7b2-b1ca-460b-aeaf-0281d0f8dfb3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 10:18:45
13892	9d5d13d4-14ea-4ec4-a455-6559df52221e	9d5d13d4-3467-4f57-88cf-0aeadcad53fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 14:41:41
13893	9d5d13d4-3286-402b-9042-979bebb6a20e	9d5d13d4-3467-4f57-88cf-0aeadcad53fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 14:41:41
13894	9d5d13d4-3378-457e-b18f-71353294b707	9d5d13d4-3467-4f57-88cf-0aeadcad53fb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":273,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:41:41
25649	9d68c7b2-afaa-4ff7-9b1d-f9911d3c7b72	9d68c7b2-b1ca-460b-aeaf-0281d0f8dfb3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":695,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:18:45
43346	9d6ce5ec-ac9e-4461-8447-a1e9f9dd2375	9d6ce5ec-c584-421e-b52f-a7804a2bd620	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":31,"hostname":"EderCortes"}	2024-11-06 11:26:35
43347	9d6ce5ec-c40e-495a-b6ae-718cab3030ed	9d6ce5ec-c584-421e-b52f-a7804a2bd620	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":32,"hostname":"EderCortes"}	2024-11-06 11:26:35
24544	9d68b234-2b16-406d-aa68-627690daae1c	9d68b234-2fee-414f-9191-4ba64c2f1efc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (89, 5, 220000, 55000, 'Pendiente', 'N\\/A', '14-12-2024', 12, 0, 0, '2024-11-04 09:18:39', '2024-11-04 09:18:39')","time":"0.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:39
24545	9d68b234-2b34-4511-ab86-e2ba1ebbd0b9	9d68b234-2fee-414f-9191-4ba64c2f1efc	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:39
13895	9d5d13d4-8650-479b-b49c-daf142f28f74	9d5d13d4-a776-4992-996e-51ecab1550f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 14:41:42
12480	9d5ce93d-e7c0-4877-a3db-03042947ae10	9d5ce93e-35c9-4225-bb7d-d8d8f571f90d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 12:42:37
12481	9d5ce93e-33f5-4e6e-9892-4a8c4aa15937	9d5ce93e-35c9-4225-bb7d-d8d8f571f90d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:42:37
12482	9d5ce93e-34c8-4032-8cc7-5f627fa81950	9d5ce93e-35c9-4225-bb7d-d8d8f571f90d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":397,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:42:37
19156	9d66d0ca-e301-4698-a2a4-762528983d49	9d66d0cb-0c11-40b6-bc30-ddd47cd2071b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 10:52:31
13896	9d5d13d4-9d7c-4175-9164-27fdf7acb950	9d5d13d4-a776-4992-996e-51ecab1550f4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 52\\n                        ","time":"45.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"b818d1825eff359c94d73944c3be2955","hostname":"EderCortes"}	2024-10-29 14:41:42
13897	9d5d13d4-a203-49b0-87dc-81a8fdfdd40f	9d5d13d4-a776-4992-996e-51ecab1550f4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '52' order by \\"item_loans\\".\\"id\\" asc","time":"2.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 14:41:42
13898	9d5d13d4-a23a-4fcc-84ff-344f85c47495	9d5d13d4-a776-4992-996e-51ecab1550f4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":7,"hostname":"EderCortes"}	2024-10-29 14:41:42
13899	9d5d13d4-a642-4036-beea-493df3558936	9d5d13d4-a776-4992-996e-51ecab1550f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 14:41:42
19157	9d66d0cb-09e9-4647-9af7-ce27ae75e674	9d66d0cb-0c11-40b6-bc30-ddd47cd2071b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 10:52:31
19158	9d66d0cb-0ab5-46ab-a561-0c3e362903a4	9d66d0cb-0c11-40b6-bc30-ddd47cd2071b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":296,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:52:31
24546	9d68b234-2eab-4b4c-9caf-d64240f29113	9d68b234-2fee-414f-9191-4ba64c2f1efc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 09:18:39
24547	9d68b234-2ef9-4c8e-87b2-801d3406a45b	9d68b234-2fee-414f-9191-4ba64c2f1efc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"801","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"1004655468","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_valor_prestado":"1100000","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":19,"user_recomendacion":14,"loans_inicio_pago":"Mon Nov 04 2024","created_at":null,"updated_at":null,"deleted_at":null,"loans_pago_prestado":0,"loans_pago_interes":0},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Mon Nov 04 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":89},"duration":290,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:18:39
43349	9d6ce5ed-4bd0-4cf0-9c50-47ab07a4ac5f	9d6ce5ed-6aa2-4426-bc78-84606811518c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":32,"hostname":"EderCortes"}	2024-11-06 11:26:35
43350	9d6ce5ed-657d-4cfc-a86f-c7329c66c765	9d6ce5ed-6aa2-4426-bc78-84606811518c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT id,\\n                            name,\\n                            profile_code,\\n                            remember_token,\\n                            user_address,\\n                            user_age,\\n                            user_alias,\\n                            user_birth,\\n                            user_cellphone,\\n                            user_city,\\n                            user_document,\\n                            user_document_type,\\n                            user_last_name_one,\\n                            user_last_name_two,\\n                            user_neighborhood\\n                        FROM users\\n                        WHERE profile_code = 4;\\n                            ","time":"50.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":142,"hash":"e2980c10c70608ca75f9c2180abc54e1","hostname":"EderCortes"}	2024-11-06 11:26:35
12483	9d5ce93e-ad27-4fb5-9bd0-6828f536f51e	9d5ce93e-d0bb-4ce9-a864-c093c7850429	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:42:37
12484	9d5ce93e-cb47-43fb-aee4-3a8540df48fb	9d5ce93e-d0bb-4ce9-a864-c093c7850429	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":180,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 12:42:37
12485	9d5ce93e-cba1-4403-a7a3-f4189c8db805	9d5ce93e-d0bb-4ce9-a864-c093c7850429	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 12:42:37
12486	9d5ce93e-cf56-49ef-8156-f739f1f93126	9d5ce93e-d0bb-4ce9-a864-c093c7850429	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:42:37
12487	9d5ce93e-cfc4-404d-b106-cd13e1614b31	9d5ce93e-d0bb-4ce9-a864-c093c7850429	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":353,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:42:37
13900	9d5d13d4-a690-4f9b-a244-71d1c56ab4cf	9d5d13d4-a776-4992-996e-51ecab1550f4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/52","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":52,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":7,"loans_valor_prestado":500000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"12-11-24","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":136,"loans_codigo":52,"itemloans_cuota":"1","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":137,"loans_codigo":52,"itemloans_cuota":"2","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0024-12-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":138,"loans_codigo":52,"itemloans_cuota":"3","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0024-12-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":139,"loans_codigo":52,"itemloans_cuota":"4","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0025-01-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":140,"loans_codigo":52,"itemloans_cuota":"5","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0025-01-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":141,"loans_codigo":52,"itemloans_cuota":"6","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0025-02-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":142,"loans_codigo":52,"itemloans_cuota":"7","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0025-02-25 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:41:42
19159	9d66d0cb-7045-4d59-a30d-560165327804	9d66d0cb-9508-46a9-84bf-881d475685d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 10:52:32
19160	9d66d0cb-89e5-40d3-afc8-6932e6dedf3a	9d66d0cb-9508-46a9-84bf-881d475685d5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"51.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 10:52:32
19161	9d66d0cb-8e94-4ec3-a2fc-4987d7fabc37	9d66d0cb-9508-46a9-84bf-881d475685d5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 10:52:32
19162	9d66d0cb-8ec8-4f46-a382-4df9af434afd	9d66d0cb-9508-46a9-84bf-881d475685d5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 10:52:32
19163	9d66d0cb-93a3-4f92-9b5b-ebaf45e5c5d7	9d66d0cb-9508-46a9-84bf-881d475685d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 10:52:32
19164	9d66d0cb-93f0-41d4-a606-8de644906833	9d66d0cb-9508-46a9-84bf-881d475685d5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T02:27:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"0"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":306,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:52:32
24548	9d68b234-6e58-48f9-87c4-cefa861cf468	9d68b234-c2fb-481a-a7e8-4187a2f6b2d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 09:18:39
43351	9d6ce5ed-694c-4161-a6d0-1804f99bcb4c	9d6ce5ed-6aa2-4426-bc78-84606811518c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":33,"hostname":"EderCortes"}	2024-11-06 11:26:35
12488	9d5ce93f-0fd0-4566-987b-479a7883aa7c	9d5ce93f-2ed1-4025-bcff-b5e34b0f2048	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:42:37
12489	9d5ce93f-2a08-454d-a776-17479ca4d61c	9d5ce93f-2ed1-4025-bcff-b5e34b0f2048	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":180,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 12:42:37
12490	9d5ce93f-2a50-40b5-9ba4-412e3c68ac96	9d5ce93f-2ed1-4025-bcff-b5e34b0f2048	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 12:42:37
12491	9d5ce93f-2ddb-4297-9bb4-7ea577ad4e1f	9d5ce93f-2ed1-4025-bcff-b5e34b0f2048	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 12:42:37
12492	9d5ce93f-2e1a-4894-a77a-ddd4b14ec170	9d5ce93f-2ed1-4025-bcff-b5e34b0f2048	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":228,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:42:37
19165	9d66d0cd-1ef7-421f-ae7f-f927fee70fa4	9d66d0cd-5b8c-4785-a277-e96b161ca044	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 10:52:33
19166	9d66d0cd-4f6b-49df-97ba-4d6925a769fa	9d66d0cd-5b8c-4785-a277-e96b161ca044	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"78.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 10:52:33
16024	9d64b81b-5a47-40bb-97f4-89cb1e28c7a0	9d64b81b-7972-4f19-8fec-7f5fc48efec4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 09:51:50
16025	9d64b81b-77d1-4f73-84bd-e9978903d557	9d64b81b-7972-4f19-8fec-7f5fc48efec4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 09:51:50
16026	9d64b81b-787a-4c48-974e-28d6a41153f2	9d64b81b-7972-4f19-8fec-7f5fc48efec4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:51:50
19167	9d66d0cd-5013-4e87-b614-58731c9dd2c8	9d66d0cd-5b8c-4785-a277-e96b161ca044	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 10:52:33
19168	9d66d0cd-5948-4068-b556-c2a8d4d8916b	9d66d0cd-5b8c-4785-a277-e96b161ca044	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 10:52:33
19169	9d66d0cd-59f9-4982-953b-0b89ef60b8cc	9d66d0cd-5b8c-4785-a277-e96b161ca044	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":545,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:52:33
24549	9d68b234-b3e7-4567-85a2-4b5bc770444f	9d68b234-c2fb-481a-a7e8-4187a2f6b2d6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\", \\"loans_fecha_ultimo_pago\\", \\"loans_intereses_recaudar\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta 2', 'De las nieve', 'ds', 'CC', '1004655468', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon2', 'Calle 7505', '1100000', 25, 5, 'S', null, '04-11-2024', 'Pendiente', '312596295', 12, 14, 19, 14, '04-11-2024', 0, 0, '04-11-2024', 275000, '2024-11-04 09:18:39', '2024-11-04 09:18:39') returning \\"id\\"","time":"6.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":110,"hash":"f69b6b91ceb0fd9e0c386e94fcedc496","hostname":"EderCortes"}	2024-11-04 09:18:39
24550	9d68b234-b45a-4cb9-8387-f14f16b3ff97	9d68b234-c2fb-481a-a7e8-4187a2f6b2d6	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:90","hostname":"EderCortes"}	2024-11-04 09:18:39
24551	9d68b234-b649-4940-ae3d-2b62f10c392b	9d68b234-c2fb-481a-a7e8-4187a2f6b2d6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (90, 1, 220000, 55000, 'Pendiente', 'N\\/A', '12-11-2024', 12, 0, 0, '2024-11-04 09:18:39', '2024-11-04 09:18:39')","time":"3.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:39
12493	9d5ce941-31f2-49b0-9d02-fb468c393339	9d5ce941-4d02-46de-8a01-334b720134ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 12:42:39
12494	9d5ce941-488a-4194-8466-00283b8be4a9	9d5ce941-4d02-46de-8a01-334b720134ef	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"38.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 12:42:39
12495	9d5ce941-48ce-4667-80c0-fbf93db0f7d4	9d5ce941-4d02-46de-8a01-334b720134ef	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 12:42:39
12496	9d5ce941-4bc6-40bd-8d9f-80fbb230fe8e	9d5ce941-4d02-46de-8a01-334b720134ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 12:42:39
12497	9d5ce941-4c19-4295-b59a-9ae81a99fa5e	9d5ce941-4d02-46de-8a01-334b720134ef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":267,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:42:39
16027	9d64b81b-c398-4a10-8152-b2b83ddae0c7	9d64b81b-e266-49a0-949e-dbe812cc5fb2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 09:51:51
16028	9d64b81b-da26-47c4-807f-3cae16a18f54	9d64b81b-e266-49a0-949e-dbe812cc5fb2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 22\\n                        ","time":"44.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"f9344e277d181987f84c6dcddcb4342d","hostname":"EderCortes"}	2024-11-02 09:51:51
16029	9d64b81b-dd8d-4ffa-b7c6-8ea187f9562f	9d64b81b-e266-49a0-949e-dbe812cc5fb2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '22' order by \\"item_loans\\".\\"id\\" asc","time":"1.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:51:51
16030	9d64b81b-ddd6-484e-8381-a9deda3669a3	9d64b81b-e266-49a0-949e-dbe812cc5fb2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-02 09:51:51
16031	9d64b81b-e149-4e19-9f25-cac35eca0520	9d64b81b-e266-49a0-949e-dbe812cc5fb2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 09:51:51
16032	9d64b81b-e197-4b1c-b0ef-448683ef7959	9d64b81b-e266-49a0-949e-dbe812cc5fb2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/22","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":22,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":70,"loans_codigo":22,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":71,"loans_codigo":22,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":72,"loans_codigo":22,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":73,"loans_codigo":22,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":74,"loans_codigo":22,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":75,"loans_codigo":22,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-04-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:51:51
24552	9d68b234-b67a-47c7-b178-7574359fac33	9d68b234-c2fb-481a-a7e8-4187a2f6b2d6	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:39
24553	9d68b234-b716-4edd-9a59-98361f1f21d6	9d68b234-c2fb-481a-a7e8-4187a2f6b2d6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (90, 2, 220000, 55000, 'Pendiente', 'N\\/A', '20-11-2024', 12, 0, 0, '2024-11-04 09:18:39', '2024-11-04 09:18:39')","time":"0.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:39
24554	9d68b234-b741-4349-b3c5-a2f2fe120b80	9d68b234-c2fb-481a-a7e8-4187a2f6b2d6	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:39
12498	9d5ce948-647d-4d8c-ae0a-260dbe36e182	9d5ce948-67af-4cc8-8f92-2dd3e2549f74	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":134,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:42:43
24555	9d68b234-b7d4-4c95-96cf-20e693058ff8	9d68b234-c2fb-481a-a7e8-4187a2f6b2d6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (90, 3, 220000, 55000, 'Pendiente', 'N\\/A', '28-11-2024', 12, 0, 0, '2024-11-04 09:18:39', '2024-11-04 09:18:39')","time":"0.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:39
14351	9d5d1e09-d4c5-49c8-a862-93fff53da14d	9d5d1e0a-d53c-4d2f-b248-7752d9c3e2db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 15:10:14
14352	9d5d1e0a-cfc0-4799-9cb0-0e3c63ac3c9d	9d5d1e0a-d53c-4d2f-b248-7752d9c3e2db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 15:10:15
10387	9d56cf09-7be6-4dfa-bd80-bed63b674b33	9d56cf09-9a45-4364-9656-00d131d07cb3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-26 11:54:22
10388	9d56cf09-98bd-493f-be80-b81d52e83b81	9d56cf09-9a45-4364-9656-00d131d07cb3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-26 11:54:22
10389	9d56cf09-994b-4224-8e84-738e313bf180	9d56cf09-9a45-4364-9656-00d131d07cb3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-10-26 11:54:22
14353	9d5d1e0a-d1bb-4a48-b642-95464effa4d5	9d5d1e0a-d53c-4d2f-b248-7752d9c3e2db	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1310,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:10:15
24556	9d68b234-b7ff-459f-956f-f653d2ce2f65	9d68b234-c2fb-481a-a7e8-4187a2f6b2d6	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:39
19246	9d66d286-7ee4-4c83-9e15-59003b67d134	9d66d286-9bb1-4c63-8e7c-51c59aa90ef2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 10:57:22
16033	9d64b81d-66c2-4630-8ccc-00b9adcb916b	9d64b81d-8471-48fe-9745-379a06b05ad5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 09:51:52
16034	9d64b81d-7f06-4eb7-99e8-3e4b7fe4503b	9d64b81d-8471-48fe-9745-379a06b05ad5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 09:51:52
16035	9d64b81d-7f87-4f64-b1c5-861e27f9a6cd	9d64b81d-8471-48fe-9745-379a06b05ad5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 09:51:52
16036	9d64b81d-8325-4937-9775-cf31e7a6d2d9	9d64b81d-8471-48fe-9745-379a06b05ad5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-02 09:51:52
19247	9d66d286-9a16-40d3-9ac6-30eb0eb246aa	9d66d286-9bb1-4c63-8e7c-51c59aa90ef2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 10:57:22
19248	9d66d286-9aaf-481f-b042-e7cce161a0bb	9d66d286-9bb1-4c63-8e7c-51c59aa90ef2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:57:22
24557	9d68b234-b8c9-4394-938b-a33d57576ed7	9d68b234-c2fb-481a-a7e8-4187a2f6b2d6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (90, 4, 220000, 55000, 'Pendiente', 'N\\/A', '06-12-2024', 12, 0, 0, '2024-11-04 09:18:39', '2024-11-04 09:18:39')","time":"1.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:39
24558	9d68b234-b904-4417-bea7-6ba9fbdbc159	9d68b234-c2fb-481a-a7e8-4187a2f6b2d6	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:39
24559	9d68b234-b9b2-4def-a03e-951594ae8307	9d68b234-c2fb-481a-a7e8-4187a2f6b2d6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (90, 5, 220000, 55000, 'Pendiente', 'N\\/A', '14-12-2024', 12, 0, 0, '2024-11-04 09:18:39', '2024-11-04 09:18:39')","time":"0.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:18:39
24560	9d68b234-b9e3-4169-bf00-00785674b1aa	9d68b234-c2fb-481a-a7e8-4187a2f6b2d6	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:18:39
24561	9d68b234-c11e-4dcd-865b-56a531fe194d	9d68b234-c2fb-481a-a7e8-4187a2f6b2d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 09:18:39
43352	9d6ce5ed-699e-4c26-b502-22c99619320d	9d6ce5ed-6aa2-4426-bc78-84606811518c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/showCobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@showCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":14,"name":"Luis andre","profile_code":4,"remember_token":null,"user_address":"Calle 750","user_age":"31","user_alias":"luis_martinez","user_birth":"1992-11-12T04:00:00.000Z","user_cellphone":"312596295","user_city":"Cali","user_document":"100465545","user_document_type":"CC","user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_neighborhood":"Bonilla aragon"}},"duration":278,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:26:35
12499	9d5ce949-20c8-4968-9ec7-302d0d836cc5	9d5ce949-3a85-4875-963b-932643fb7188	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 12:42:44
12500	9d5ce949-3628-4cfe-8513-4d4b216f57eb	9d5ce949-3a85-4875-963b-932643fb7188	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"38.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:42:44
12501	9d5ce949-393f-49b5-8ba5-9fa87369b8d3	9d5ce949-3a85-4875-963b-932643fb7188	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 12:42:44
12502	9d5ce949-3981-4cb3-ba4c-3d2f57e9bde5	9d5ce949-3a85-4875-963b-932643fb7188	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":221,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:42:44
14354	9d5d1e0c-055a-4155-99fd-23d509b17859	9d5d1e0c-60ed-471b-9946-7944cf11498e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 15:10:16
14355	9d5d1e0c-519c-4678-be11-8e5020588d12	9d5d1e0c-60ed-471b-9946-7944cf11498e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"130.40","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":179,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 15:10:16
14356	9d5d1e0c-5255-42a6-a4be-4361797dff54	9d5d1e0c-60ed-471b-9946-7944cf11498e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 15:10:16
14357	9d5d1e0c-5e38-4cce-8622-42a0419c7179	9d5d1e0c-60ed-471b-9946-7944cf11498e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 15:10:16
14358	9d5d1e0c-5ed5-4bb5-af39-1216501f17cb	9d5d1e0c-60ed-471b-9946-7944cf11498e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":901,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:10:16
16037	9d64b81d-8376-4bbc-80ab-f7ee1635ee3f	9d64b81d-8471-48fe-9745-379a06b05ad5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:51:52
19249	9d66d286-e7cf-4b97-9b34-17ed2861f29a	9d66d287-0723-4576-ad1c-a8cffa801a9b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 10:57:22
19250	9d66d286-fe74-44aa-aa12-150f466e74a0	9d66d287-0723-4576-ad1c-a8cffa801a9b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"44.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 10:57:22
12503	9d5ce949-72e5-48c4-9ee9-ca4541475610	9d5ce949-757f-4b01-9a74-e34a1e243f8c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":129,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:42:44
14359	9d5d1e0d-1246-4b7e-ba0f-7608a10b721f	9d5d1e0d-7337-4063-a6bd-811efd10abed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 15:10:16
14360	9d5d1e0d-68b2-4312-9225-ce68cc10f2e8	9d5d1e0d-7337-4063-a6bd-811efd10abed	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"169.45","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":179,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 15:10:17
14361	9d5d1e0d-694f-4057-9746-c62d5c74e611	9d5d1e0d-7337-4063-a6bd-811efd10abed	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 15:10:17
12685	9d5cecae-ea92-49ce-a187-0c88db1bbf64	9d5cecaf-3988-4d98-9a11-42a3bc89226b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-29 12:52:14
12686	9d5cecaf-37b6-445f-95b4-0d42ad3a52ca	9d5cecaf-3988-4d98-9a11-42a3bc89226b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-29 12:52:14
12687	9d5cecaf-385e-4d1b-a1f8-2506ca131a63	9d5cecaf-3988-4d98-9a11-42a3bc89226b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":402,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:14
14362	9d5d1e0d-70f8-4678-8442-86db726cfb3b	9d5d1e0d-7337-4063-a6bd-811efd10abed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-29 15:10:17
14363	9d5d1e0d-718a-41f2-a252-0b57f3e8f500	9d5d1e0d-7337-4063-a6bd-811efd10abed	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":674,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:10:17
19251	9d66d287-01e9-4738-9878-c490ccb9480e	9d66d287-0723-4576-ad1c-a8cffa801a9b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"1.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 10:57:22
19252	9d66d287-021a-40e8-93c7-92d28924bac7	9d66d287-0723-4576-ad1c-a8cffa801a9b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 10:57:22
19253	9d66d287-05e5-42c5-b054-9e5dbbb83450	9d66d287-0723-4576-ad1c-a8cffa801a9b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 10:57:22
19254	9d66d287-062d-4a10-8c5a-d5b5ed3c6b14	9d66d287-0723-4576-ad1c-a8cffa801a9b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T02:27:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"0"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:57:22
24562	9d68b234-c18f-4488-84c4-e41552cc70ce	9d68b234-c2fb-481a-a7e8-4187a2f6b2d6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"801","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"1004655468","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_valor_prestado":"1100000","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":19,"user_recomendacion":14,"loans_inicio_pago":"Mon Nov 04 2024","created_at":null,"updated_at":null,"deleted_at":null,"loans_pago_prestado":0,"loans_pago_interes":0},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Mon Nov 04 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":90},"duration":359,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:18:39
12504	9d5ce949-ee10-48aa-adf5-f12323ada94a	9d5ce94a-3042-49c1-bf0a-279979ea5564	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 12:42:44
12505	9d5ce94a-2bd1-4f6b-acbc-b7903bee72dc	9d5ce94a-3042-49c1-bf0a-279979ea5564	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"143.59","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:42:45
12506	9d5ce94a-2f02-4b99-b3b1-c5bcaf2cb02c	9d5ce94a-3042-49c1-bf0a-279979ea5564	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 12:42:45
12507	9d5ce94a-2f46-4a02-8db6-d63bf5d6989d	9d5ce94a-3042-49c1-bf0a-279979ea5564	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":314,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:42:45
11424	9d5cbe39-f462-4db8-a010-99f6a191d9f8	9d5cbe3a-1f9a-4025-b3f8-2ab129dd2aed	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 10:42:20
11425	9d5cbe3a-1d04-4519-be1f-5c7817d7137b	9d5cbe3a-1f9a-4025-b3f8-2ab129dd2aed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 10:42:20
11426	9d5cbe3a-1e24-4cdb-9d98-26536c021914	9d5cbe3a-1f9a-4025-b3f8-2ab129dd2aed	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":323,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:42:20
12688	9d5cecaf-8c2f-42fc-bf75-c9b91446c639	9d5cecaf-af99-4b67-a13e-ee7447949537	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-29 12:52:14
12689	9d5cecaf-a5b2-4e9b-b112-92743c474475	9d5cecaf-af99-4b67-a13e-ee7447949537	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 28\\n                        ","time":"48.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"618a8b500e46ad393f7c65ceec660399","hostname":"EderCortes"}	2024-10-29 12:52:14
12690	9d5cecaf-a9d9-45fc-84cb-ef2a4ca763ad	9d5cecaf-af99-4b67-a13e-ee7447949537	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '28' order by \\"item_loans\\".\\"id\\" asc","time":"2.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 12:52:14
12691	9d5cecaf-aa10-4b78-ac87-2bb685610f44	9d5cecaf-af99-4b67-a13e-ee7447949537	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 12:52:14
12692	9d5cecaf-ae4f-4596-9fda-f31b031f0ae1	9d5cecaf-af99-4b67-a13e-ee7447949537	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-29 12:52:14
12693	9d5cecaf-aeb7-4606-9eec-18814692b593	9d5cecaf-af99-4b67-a13e-ee7447949537	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/28","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":28,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":600081,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":94,"loans_codigo":28,"itemloans_cuota":"1","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":95,"loans_codigo":28,"itemloans_cuota":"2","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":96,"loans_codigo":28,"itemloans_cuota":"3","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":97,"loans_codigo":28,"itemloans_cuota":"4","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":98,"loans_codigo":28,"itemloans_cuota":"5","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":99,"loans_codigo":28,"itemloans_cuota":"6","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null}]}},"duration":265,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:14
14364	9d5d1e0e-3d41-46a8-aa5d-70276a507797	9d5d1e0e-98f0-4e42-8a1a-7c030d11a94c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-29 15:10:17
14365	9d5d1e0e-8f53-4e3d-afd4-938dc6662287	9d5d1e0e-98f0-4e42-8a1a-7c030d11a94c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"165.91","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 15:10:17
14366	9d5d1e0e-8fc2-4edb-84e3-9d32db647b49	9d5d1e0e-98f0-4e42-8a1a-7c030d11a94c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 15:10:17
14367	9d5d1e0e-962b-4bb4-bdee-236dd7de9054	9d5d1e0e-98f0-4e42-8a1a-7c030d11a94c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-29 15:10:17
19255	9d66d288-363c-42c7-ae96-ffbf7e2fab3b	9d66d288-620d-401e-80de-d36ab9d46092	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 10:57:23
24563	9d68b243-cd73-404e-a31c-e7f38923b627	9d68b243-ec73-4a77-84f0-0220706ded0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 09:18:49
24564	9d68b243-e340-4a20-b4ca-2b01d24acb74	9d68b243-ec73-4a77-84f0-0220706ded0d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"42.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 09:18:49
24565	9d68b243-e711-491e-8bb9-b5f4b12afe1e	9d68b243-ec73-4a77-84f0-0220706ded0d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:18:49
10946	9d5ca6d6-02a2-4cf7-937a-81dcfa8e4827	9d5ca6d6-213b-4241-8863-f05c1567ed83	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 09:36:55
10947	9d5ca6d6-1f6c-43a7-abfa-25fc92c2ce64	9d5ca6d6-213b-4241-8863-f05c1567ed83	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 09:36:56
10948	9d5ca6d6-202c-43c8-857b-499cdeb8ccc9	9d5ca6d6-213b-4241-8863-f05c1567ed83	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":302,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:36:56
24566	9d68b243-e748-47eb-92dc-e3e8e65a3b6f	9d68b243-ec73-4a77-84f0-0220706ded0d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 09:18:49
19256	9d66d288-5847-4711-9ea8-bf93a298d03a	9d66d288-620d-401e-80de-d36ab9d46092	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"60.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 10:57:23
19257	9d66d288-5917-4229-b743-3f3b689958c8	9d66d288-620d-401e-80de-d36ab9d46092	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 10:57:23
19258	9d66d288-5f95-4983-a64e-5f397aaefad4	9d66d288-620d-401e-80de-d36ab9d46092	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 10:57:23
24567	9d68b243-eb12-4a71-9666-0edeed4ed4dd	9d68b243-ec73-4a77-84f0-0220706ded0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 09:18:49
24568	9d68b243-eb59-4743-a4b0-322456b1d45c	9d68b243-ec73-4a77-84f0-0220706ded0d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:18:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":347,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:18:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":348,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:18:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":349,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:18:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":350,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:18:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:18:49
43353	9d6ce5ef-3bb1-48cc-94cd-5b93ac461f45	9d6ce5ef-8197-430e-ba93-a9c5a3a11f64	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":33,"hostname":"EderCortes"}	2024-11-06 11:26:36
43354	9d6ce5ef-7856-4953-a394-8aad6a286d2c	9d6ce5ef-8197-430e-ba93-a9c5a3a11f64	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"117.30","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:26:37
43355	9d6ce5ef-78e6-4e08-afa1-1f2e0de17bf8	9d6ce5ef-8197-430e-ba93-a9c5a3a11f64	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:26:37
43356	9d6ce5ef-7faf-4f68-b312-52c334304871	9d6ce5ef-8197-430e-ba93-a9c5a3a11f64	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":34,"hostname":"EderCortes"}	2024-11-06 11:26:37
11427	9d5cbe3a-8a67-4378-856e-7ecc8242509a	9d5cbe3a-da48-48ca-90bc-c2fc331eb6c7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 10:42:20
11428	9d5cbe3a-ceb5-41c9-a2ad-d43cba812e71	9d5cbe3a-da48-48ca-90bc-c2fc331eb6c7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 1\\n                        ","time":"161.48","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"2bd5a29c69f6bbb290fc49b79286632e","hostname":"EderCortes"}	2024-10-29 10:42:20
11429	9d5cbe3a-d341-4166-9b25-7208638ad309	9d5cbe3a-da48-48ca-90bc-c2fc331eb6c7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1' order by \\"item_loans\\".\\"id\\" asc","time":"2.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 10:42:20
11430	9d5cbe3a-d37e-4615-b544-d444ea9f75ef	9d5cbe3a-da48-48ca-90bc-c2fc331eb6c7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 10:42:20
11431	9d5cbe3a-d8cc-4d34-9b5a-c1090c4a08be	9d5cbe3a-da48-48ca-90bc-c2fc331eb6c7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 10:42:20
11432	9d5cbe3a-d921-486e-9a76-777fb5a5b4f0	9d5cbe3a-da48-48ca-90bc-c2fc331eb6c7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":1,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]}},"duration":440,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:42:20
12508	9d5ce95d-af69-4a8a-8556-576b44120bbf	9d5ce95d-b28e-4042-a09d-452e5a6738c3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":129,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:42:57
14368	9d5d1e0e-96a3-4639-b419-131a1632c9b7	9d5d1e0e-98f0-4e42-8a1a-7c030d11a94c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":723,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:10:17
19259	9d66d288-602c-48cc-997f-5bfc41f09118	9d66d288-620d-401e-80de-d36ab9d46092	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":403,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:57:23
24569	9d68b4a5-04ac-4b66-adb1-c3aca21511cd	9d68b4a5-2ba3-46c2-bebd-6490ce79ce78	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 09:25:28
11433	9d5cbe3c-9eea-46ee-80ee-54c819170822	9d5cbe3c-bdd6-4df0-a39e-78c79f4ff5ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 10:42:21
11434	9d5cbe3c-b932-4aff-8ba8-c6814abbc414	9d5cbe3c-bdd6-4df0-a39e-78c79f4ff5ea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 10:42:22
11435	9d5cbe3c-b9af-4097-8881-29860828c76d	9d5cbe3c-bdd6-4df0-a39e-78c79f4ff5ea	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 10:42:22
11436	9d5cbe3c-bcb5-4c04-b733-2144a38e03ec	9d5cbe3c-bdd6-4df0-a39e-78c79f4ff5ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 10:42:22
11437	9d5cbe3c-bcf6-464d-8edc-d997a050779a	9d5cbe3c-bdd6-4df0-a39e-78c79f4ff5ea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":259,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:42:22
12509	9d5ce95e-1859-4258-b130-f7dcc1986c07	9d5ce95e-5a4d-4b0d-92e2-23d13196dcd2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 12:42:58
12510	9d5ce95e-55fe-4738-ac1d-47941000b15e	9d5ce95e-5a4d-4b0d-92e2-23d13196dcd2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%') order by \\"users\\".\\"user_document\\" asc","time":"142.76","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:42:58
12511	9d5ce95e-5904-4bf3-8582-35fa897a5f8d	9d5ce95e-5a4d-4b0d-92e2-23d13196dcd2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 12:42:58
12512	9d5ce95e-5947-4077-abf0-5d69f960db9f	9d5ce95e-5a4d-4b0d-92e2-23d13196dcd2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[]},"duration":302,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:42:58
14369	9d5d1e10-3001-4926-ad92-15e9dc29fb54	9d5d1e10-9017-434f-8ea6-c767753c980e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-29 15:10:18
14370	9d5d1e10-7d38-4011-8c59-ad37fcf56c33	9d5d1e10-9017-434f-8ea6-c767753c980e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"142.12","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 15:10:19
14371	9d5d1e10-7e16-4c74-9a19-612df179d2c7	9d5d1e10-9017-434f-8ea6-c767753c980e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 15:10:19
14372	9d5d1e10-8c84-4ae0-9098-7eb5ac6b1340	9d5d1e10-9017-434f-8ea6-c767753c980e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-29 15:10:19
14373	9d5d1e10-8d46-4bdf-93d5-3764cff43cae	9d5d1e10-9017-434f-8ea6-c767753c980e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":669,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:10:19
12513	9d5cea67-cfe4-43c4-9687-7eb0d7b579fc	9d5cea67-d414-4130-b1c1-f3cdee74c61a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":175,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:45:52
24570	9d68b4a5-2468-4de9-af1e-860e512b6cdd	9d68b4a5-2ba3-46c2-bebd-6490ce79ce78	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"50.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 09:25:28
24571	9d68b4a5-29be-448a-aa75-4029112b7247	9d68b4a5-2ba3-46c2-bebd-6490ce79ce78	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 09:25:28
24572	9d68b4a5-2a46-49b9-9be5-91b6b634ffec	9d68b4a5-2ba3-46c2-bebd-6490ce79ce78	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":362,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:25:28
11442	9d5cbe74-ea1c-4b58-960a-9e6ecf3b2eb5	9d5cbe75-0d3d-42d0-b467-f3c44299c8ab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 10:42:58
12514	9d5cea68-1f01-46c2-b2b4-e4ff96046a6d	9d5cea68-2215-40db-9103-b76ad974f3bf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":131,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:45:52
24573	9d68b4a8-7e55-40bf-b3cc-4ce27b6c4466	9d68b4a8-cf96-4953-9407-0a47e5214bca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 09:25:31
24574	9d68b4a8-c4b1-4cd0-bc44-23fdbddb59b3	9d68b4a8-cf96-4953-9407-0a47e5214bca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"163.46","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 09:25:31
24575	9d68b4a8-c91d-4e4b-84d4-23756df01e06	9d68b4a8-cf96-4953-9407-0a47e5214bca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:25:31
24576	9d68b4a8-c969-46db-b9c0-2bc486cbf9e5	9d68b4a8-cf96-4953-9407-0a47e5214bca	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 09:25:31
24577	9d68b4a8-ce00-477d-bca4-2247daa1852e	9d68b4a8-cf96-4953-9407-0a47e5214bca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 09:25:31
24578	9d68b4a8-ce6d-43e7-8013-99e04dfba02b	9d68b4a8-cf96-4953-9407-0a47e5214bca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:18:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":347,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:18:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":348,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:18:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":349,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:18:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":350,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:18:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":569,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:25:31
12515	9d5cea68-73b1-42b3-9c77-f1d0c712b908	9d5cea68-93ed-4c4d-8c0e-0b97b02a2786	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 12:45:52
12516	9d5cea68-8e80-45ca-bf81-2f55a3c7bd4b	9d5cea68-93ed-4c4d-8c0e-0b97b02a2786	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"41.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:45:52
12517	9d5cea68-926d-4d58-ad4f-5c9572c6023a	9d5cea68-93ed-4c4d-8c0e-0b97b02a2786	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:45:52
12518	9d5cea68-92c2-46f1-aa37-abb3ae6f9bf3	9d5cea68-93ed-4c4d-8c0e-0b97b02a2786	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:45:52
24579	9d68b4df-3405-4def-a315-213f6b8fc48f	9d68b4df-5204-432b-becc-ffc1d2cfcee7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 09:26:06
24580	9d68b4df-4d9c-4427-b2b6-405841a7ca30	9d68b4df-5204-432b-becc-ffc1d2cfcee7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"49.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 09:26:06
24581	9d68b4df-50a1-41d7-838d-fe241f69a273	9d68b4df-5204-432b-becc-ffc1d2cfcee7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 09:26:06
24582	9d68b4df-5105-4be0-9852-63e3a9870ee4	9d68b4df-5204-432b-becc-ffc1d2cfcee7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:26:06
12519	9d5cea68-df9e-4322-b342-2556cd34adab	9d5cea69-23e9-4387-bc5c-034a6d70bee3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:45:52
12520	9d5cea69-1eec-4024-8b73-0868418ca1f4	9d5cea69-23e9-4387-bc5c-034a6d70bee3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"147.23","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:45:53
12521	9d5cea69-2257-49ac-82d0-9874e8670071	9d5cea69-23e9-4387-bc5c-034a6d70bee3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:45:53
12522	9d5cea69-22a3-419b-a63e-9820974de8a8	9d5cea69-23e9-4387-bc5c-034a6d70bee3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":351,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:45:53
24583	9d68b4f0-10ff-4e22-a023-ecfd08ddc23d	9d68b4f0-3295-4b29-b8e8-78fe7d9b8f40	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 09:26:17
24584	9d68b4f0-29b7-45e6-91ef-feafadce687b	9d68b4f0-3295-4b29-b8e8-78fe7d9b8f40	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 66\\n                        ","time":"48.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"f5566f306d2be9466f2c4564ce0020bd","hostname":"EderCortes"}	2024-11-04 09:26:17
24585	9d68b4f0-2d2f-4020-8dfc-c955d6838eb7	9d68b4f0-3295-4b29-b8e8-78fe7d9b8f40	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '66' order by \\"item_loans\\".\\"id\\" asc","time":"2.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:26:17
24586	9d68b4f0-2d80-4fba-964c-893f27472736	9d68b4f0-3295-4b29-b8e8-78fe7d9b8f40	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 09:26:17
24587	9d68b4f0-3149-45ee-afcd-c2f5989e0f40	9d68b4f0-3295-4b29-b8e8-78fe7d9b8f40	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 09:26:17
24588	9d68b4f0-3191-4302-834b-93bb6f12bd38	9d68b4f0-3295-4b29-b8e8-78fe7d9b8f40	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/66","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":66,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":5000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"5000000","loans_pago_interes":"1250000"},"items":[{"id":217,"loans_codigo":66,"itemloans_cuota":"1","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:26.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":218,"loans_codigo":66,"itemloans_cuota":"2","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":219,"loans_codigo":66,"itemloans_cuota":"3","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":220,"loans_codigo":66,"itemloans_cuota":"4","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:33.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":221,"loans_codigo":66,"itemloans_cuota":"5","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":222,"loans_codigo":66,"itemloans_cuota":"6","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:39.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":223,"loans_codigo":66,"itemloans_cuota":"7","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:42.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":224,"loans_codigo":66,"itemloans_cuota":"8","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:46.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":225,"loans_codigo":66,"itemloans_cuota":"9","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-31 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:50.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":226,"loans_codigo":66,"itemloans_cuota":"10","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:31:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"}]}},"duration":276,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:26:17
16144	9d64b9ba-5b34-457d-9114-9e8199b41dc3	9d64b9ba-7a66-425a-a229-a81bd108fe8f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 09:56:22
16145	9d64b9ba-7900-480a-a5a5-8b5794cdd1dd	9d64b9ba-7a66-425a-a229-a81bd108fe8f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 09:56:22
16146	9d64b9ba-7992-4f02-9783-d2f5114b33d0	9d64b9ba-7a66-425a-a229-a81bd108fe8f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:56:22
16147	9d64b9ba-c544-4f1f-aed4-3452d0c90786	9d64b9bb-0c70-4092-b0b9-2207b1b8b58e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 09:56:23
16148	9d64b9bb-040d-4fd5-978e-c8faf2a292f1	9d64b9bb-0c70-4092-b0b9-2207b1b8b58e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 22\\n                        ","time":"148.78","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"f9344e277d181987f84c6dcddcb4342d","hostname":"EderCortes"}	2024-11-02 09:56:23
16149	9d64b9bb-0775-46b7-8e91-08e8d10b0838	9d64b9bb-0c70-4092-b0b9-2207b1b8b58e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '22' order by \\"item_loans\\".\\"id\\" asc","time":"1.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:56:23
16150	9d64b9bb-07aa-460d-ae6b-6fdac70057c7	9d64b9bb-0c70-4092-b0b9-2207b1b8b58e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-02 09:56:23
16151	9d64b9bb-0b55-4063-b424-63822e1d031a	9d64b9bb-0c70-4092-b0b9-2207b1b8b58e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 09:56:23
16152	9d64b9bb-0ba1-497e-bc0d-afb8fa18d05c	9d64b9bb-0c70-4092-b0b9-2207b1b8b58e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/22","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":22,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":70,"loans_codigo":22,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":71,"loans_codigo":22,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":72,"loans_codigo":22,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":73,"loans_codigo":22,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":74,"loans_codigo":22,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":75,"loans_codigo":22,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-04-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:56:23
16153	9d64b9bc-96ab-40b7-87c7-c0753933aa1c	9d64b9bc-ea78-4436-b556-3b5c08243714	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 09:56:24
16154	9d64b9bc-e13e-4d94-bad2-d9943c2a8810	9d64b9bc-ea78-4436-b556-3b5c08243714	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"164.35","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 09:56:24
16155	9d64b9bc-e1d6-4025-9481-35dc4f919666	9d64b9bc-ea78-4436-b556-3b5c08243714	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 09:56:24
16156	9d64b9bc-e8a8-4c86-a7c8-699dadf9acf3	9d64b9bc-ea78-4436-b556-3b5c08243714	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 09:56:24
14599	9d5ebec8-1e87-4ecd-8d5f-a3dcbd96e7e1	9d5ebec8-691d-4da7-97e1-8740f6ae767e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-30 10:35:32
14600	9d5ebec8-6715-4fea-8be4-d35e5c3f7124	9d5ebec8-691d-4da7-97e1-8740f6ae767e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-30 10:35:32
14601	9d5ebec8-6801-4cda-aae5-b49ba2a223a9	9d5ebec8-691d-4da7-97e1-8740f6ae767e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:35:32
16157	9d64b9bc-e936-4018-aa08-1040d15737d9	9d64b9bc-ea78-4436-b556-3b5c08243714	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":583,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:56:24
16248	9d64bf7a-e7b1-4e3b-a49d-871e53fd22ed	9d64bf7b-1768-402e-873c-b96c35c6250b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 10:12:27
16249	9d64bf7b-147f-4746-88e6-dc2fd318bc7b	9d64bf7b-1768-402e-873c-b96c35c6250b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 10:12:28
16250	9d64bf7b-15cc-4d33-ab7a-2cc7eaa6f935	9d64bf7b-1768-402e-873c-b96c35c6250b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":396,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:12:28
16251	9d64bf7b-952b-4a2f-b050-db5727ae2b01	9d64bf7b-c03a-4051-8fd4-0bdc988a9f76	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 10:12:28
16252	9d64bf7b-b344-45eb-b5c8-582d9dbbb109	9d64bf7b-c03a-4051-8fd4-0bdc988a9f76	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"61.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 10:12:28
16253	9d64bf7b-b87e-439e-853f-5acecae42fb0	9d64bf7b-c03a-4051-8fd4-0bdc988a9f76	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 10:12:28
16254	9d64bf7b-b8cd-4e5e-af9a-f5041c985068	9d64bf7b-c03a-4051-8fd4-0bdc988a9f76	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 10:12:28
16255	9d64bf7b-bef7-47af-a3e6-1caf5e4a36cc	9d64bf7b-c03a-4051-8fd4-0bdc988a9f76	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 10:12:28
16256	9d64bf7b-bf53-4327-8e48-35f0257cdc31	9d64bf7b-c03a-4051-8fd4-0bdc988a9f76	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":353,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:12:28
43357	9d6ce5ef-8038-40ea-92ec-9d092ac393fa	9d6ce5ef-8197-430e-ba93-a9c5a3a11f64	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":451,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:26:37
25883	9d68cb43-b0dc-45dc-8f8f-4dc6d5d21df9	9d68cb43-e34c-49f9-bb52-2a3577c6aa05	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 10:28:43
25884	9d68cb43-dfa0-494a-b66a-4c5d4b7d9191	9d68cb43-e34c-49f9-bb52-2a3577c6aa05	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:28:43
16257	9d64bf7d-d0aa-4a0d-8cf3-5cb03be0d586	9d64bf7e-5728-4034-8912-c123054f3f85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 10:12:29
16258	9d64bf7e-4ba8-4175-8441-deefecc1d4cb	9d64bf7e-5728-4034-8912-c123054f3f85	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"279.57","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 10:12:30
16259	9d64bf7e-4c51-4d07-8196-e8c69c54c136	9d64bf7e-5728-4034-8912-c123054f3f85	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 10:12:30
16260	9d64bf7e-54fb-4411-a332-041b419fe9ae	9d64bf7e-5728-4034-8912-c123054f3f85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 10:12:30
16261	9d64bf7e-55b2-4b23-b3c4-376db31ff13a	9d64bf7e-5728-4034-8912-c123054f3f85	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":699,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:12:30
25885	9d68cb43-e107-4ae8-be9a-0d5e31c5e128	9d68cb43-e34c-49f9-bb52-2a3577c6aa05	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":618,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:28:43
19336	9d66d58d-2f99-440c-a554-71edc4b50582	9d66d58d-4d42-4bc0-abb0-0f1836aa9bba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 11:05:50
19337	9d66d58d-4bae-4735-931b-4c614ae1d54c	9d66d58d-4d42-4bc0-abb0-0f1836aa9bba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 11:05:50
19338	9d66d58d-4c45-4e8d-b36f-476dd25b80c0	9d66d58d-4d42-4bc0-abb0-0f1836aa9bba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":262,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:05:50
43358	9d6ce5ef-d36c-4364-a7e7-4aa4caa5bc28	9d6ce5f0-12e9-4b5f-88b0-4868d9d4497d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":34,"hostname":"EderCortes"}	2024-11-06 11:26:37
43359	9d6ce5f0-0eb0-4bba-9d8a-3e44ab86941e	9d6ce5f0-12e9-4b5f-88b0-4868d9d4497d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"139.81","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:26:37
43360	9d6ce5f0-1187-4a8d-8add-316dceffd7b5	9d6ce5f0-12e9-4b5f-88b0-4868d9d4497d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":35,"hostname":"EderCortes"}	2024-11-06 11:26:37
43361	9d6ce5f0-11d6-45b8-ac05-74c0196b70e0	9d6ce5f0-12e9-4b5f-88b0-4868d9d4497d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":344,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:26:37
19339	9d66d58d-969f-41b7-a7e1-684220353244	9d66d58d-b520-49fc-a191-3141d00e4bee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 11:05:50
19340	9d66d58d-acd5-4b99-bf47-5c1f021d1296	9d66d58d-b520-49fc-a191-3141d00e4bee	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"43.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 11:05:50
19341	9d66d58d-b057-4c44-9638-ee559f06f15b	9d66d58d-b520-49fc-a191-3141d00e4bee	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:05:50
19342	9d66d58d-b086-4458-a977-3647ca0e1646	9d66d58d-b520-49fc-a191-3141d00e4bee	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:05:50
19343	9d66d58d-b3e0-40c8-b862-8e2d202ad5c8	9d66d58d-b520-49fc-a191-3141d00e4bee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 11:05:50
19344	9d66d58d-b423-4c19-94d5-88edc2eadf42	9d66d58d-b520-49fc-a191-3141d00e4bee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T02:27:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"0"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:05:50
25886	9d68cb44-8b7c-46c3-b1c3-121b991d6cc5	9d68cb44-b108-44fb-a78b-eb6a31ccad30	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:28:44
25887	9d68cb44-a3c4-4896-a6f7-4cfbd19cf71f	9d68cb44-b108-44fb-a78b-eb6a31ccad30	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"48.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:28:44
25888	9d68cb44-a8e6-490f-8bbb-a93282835fe0	9d68cb44-b108-44fb-a78b-eb6a31ccad30	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:28:44
25889	9d68cb44-a920-4549-8c30-3ec319547f64	9d68cb44-b108-44fb-a78b-eb6a31ccad30	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:28:44
25890	9d68cb44-af4a-4657-881f-af3f65ae819f	9d68cb44-b108-44fb-a78b-eb6a31ccad30	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:28:44
19345	9d66d58f-0f4c-4802-b4d6-0b74836b78f5	9d66d58f-2f77-4380-82b1-bb762e236c63	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 11:05:51
19346	9d66d58f-2a59-4879-9214-37bf63540323	9d66d58f-2f77-4380-82b1-bb762e236c63	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:05:51
19347	9d66d58f-2aa2-40f5-805f-dfdd0d5cd3ac	9d66d58f-2f77-4380-82b1-bb762e236c63	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:05:51
19348	9d66d58f-2df4-4c38-8b8a-0dd5664fd2dd	9d66d58f-2f77-4380-82b1-bb762e236c63	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 11:05:51
19349	9d66d58f-2e4a-4867-a025-39e7fc292326	9d66d58f-2f77-4380-82b1-bb762e236c63	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":437,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:05:51
25891	9d68cb44-afcb-434e-a001-99076c9b98bc	9d68cb44-b108-44fb-a78b-eb6a31ccad30	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":478,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:28:44
19426	9d66d666-876d-4882-83c4-b917b5cbc641	9d66d666-a46f-47aa-8e02-d358315cc960	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 11:08:12
19427	9d66d666-a2c1-4bed-8637-ef0af40a5c79	9d66d666-a46f-47aa-8e02-d358315cc960	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 11:08:12
19428	9d66d666-a35d-420d-9494-979dfe40951b	9d66d666-a46f-47aa-8e02-d358315cc960	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":223,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:08:12
19429	9d66d666-ed6f-4dff-822e-85a1373d393c	9d66d667-0c5b-446a-8f72-0a52825af520	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 11:08:12
19430	9d66d667-0324-408a-92ee-b36e2a496dcb	9d66d667-0c5b-446a-8f72-0a52825af520	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"42.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 11:08:13
19431	9d66d667-070d-45e7-8416-966110c39d79	9d66d667-0c5b-446a-8f72-0a52825af520	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:08:13
19432	9d66d667-0741-4657-b7b6-777456200016	9d66d667-0c5b-446a-8f72-0a52825af520	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:08:13
19433	9d66d667-0b15-42ab-aafb-eb174a5543d1	9d66d667-0c5b-446a-8f72-0a52825af520	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 11:08:13
19434	9d66d667-0b6b-4410-addd-df7f870afc56	9d66d667-0c5b-446a-8f72-0a52825af520	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T02:27:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"0"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":228,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:08:13
19435	9d66d668-69c4-49d3-afe3-93295765c354	9d66d668-9333-4312-999f-7a8a1a5f2ef9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 11:08:13
19436	9d66d668-8a27-4fac-828a-6a3efb4084ee	9d66d668-9333-4312-999f-7a8a1a5f2ef9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"56.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:08:14
19437	9d66d668-8aa9-4495-8495-0637e8016807	9d66d668-9333-4312-999f-7a8a1a5f2ef9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:08:14
19438	9d66d668-9149-47b9-a424-6e12f05d7462	9d66d668-9333-4312-999f-7a8a1a5f2ef9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 11:08:14
19439	9d66d668-91c7-4fce-9fa6-e2f3c9e1918b	9d66d668-9333-4312-999f-7a8a1a5f2ef9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":370,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:08:14
26003	9d68ccf3-38c9-46c8-a65a-1fee380ecdf3	9d68ccf3-8c8b-4230-9ab2-faeb42eff673	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 10:33:26
26004	9d68ccf3-8a3a-463b-b228-9f98a29793bd	9d68ccf3-8c8b-4230-9ab2-faeb42eff673	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:33:26
26005	9d68ccf3-8b51-4b1e-8a38-667babf4fd43	9d68ccf3-8c8b-4230-9ab2-faeb42eff673	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":557,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:33:26
26006	9d68ccf4-2598-416f-b837-460620e353cf	9d68ccf4-6ecd-4bd2-a168-a2e6834288d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:33:27
26007	9d68ccf4-653a-4f85-afb6-020464a9c39b	9d68ccf4-6ecd-4bd2-a168-a2e6834288d3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 90\\n                        ","time":"148.24","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"93c10371e33ace24260de21c3ff3890d","hostname":"EderCortes"}	2024-11-04 10:33:27
26008	9d68ccf4-68fa-41e5-bb17-8376eb1c1083	9d68ccf4-6ecd-4bd2-a168-a2e6834288d3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"2.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:33:27
26009	9d68ccf4-6935-49e5-955f-19e833c59494	9d68ccf4-6ecd-4bd2-a168-a2e6834288d3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 10:33:27
16353	9d64c3b1-cf3b-47bf-9e42-9f90a68e552a	9d64c3b1-f7c0-444b-aed4-eb00236666a4	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 10:24:15
16354	9d64c3b1-f5a4-47c4-9167-b621a34bb6aa	9d64c3b1-f7c0-444b-aed4-eb00236666a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 10:24:15
16355	9d64c3b1-f687-4c5c-ba94-3d0fe553ac79	9d64c3b1-f7c0-444b-aed4-eb00236666a4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":325,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:24:15
26010	9d68ccf4-6db3-4e37-b745-df46362096f5	9d68ccf4-6ecd-4bd2-a168-a2e6834288d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:33:27
26011	9d68ccf4-6dfe-4c67-a463-725fbcc93c74	9d68ccf4-6ecd-4bd2-a168-a2e6834288d3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"}]}},"duration":489,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:33:27
16356	9d64c3b2-50cc-4aeb-9b43-735cd3f96ce8	9d64c3b2-9f3c-48d8-bc26-6eccd686cfcc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 10:24:15
16357	9d64c3b2-932a-45b0-85a1-b55352635f36	9d64c3b2-9f3c-48d8-bc26-6eccd686cfcc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"154.91","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 10:24:15
16358	9d64c3b2-97f2-4a48-b5e1-6dbb2ff78b28	9d64c3b2-9f3c-48d8-bc26-6eccd686cfcc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"4.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 10:24:15
16359	9d64c3b2-9847-4d95-981c-567d36adf7c8	9d64c3b2-9f3c-48d8-bc26-6eccd686cfcc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 10:24:15
16360	9d64c3b2-9d8e-443e-b89c-0f188cd417d7	9d64c3b2-9f3c-48d8-bc26-6eccd686cfcc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 10:24:15
16361	9d64c3b2-9e04-46ec-99e9-468481222a5a	9d64c3b2-9f3c-48d8-bc26-6eccd686cfcc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":389,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:24:15
16362	9d64c3b4-7549-4ea5-af54-fc714f1a1a8f	9d64c3b4-c1e3-4bf3-90e8-dd4a6d496d6d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 10:24:16
16363	9d64c3b4-bc8a-460a-8c33-0fcd140d7ef7	9d64c3b4-c1e3-4bf3-90e8-dd4a6d496d6d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"151.17","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 10:24:16
16364	9d64c3b4-bcf2-4c4d-9d11-e81ff255ce1b	9d64c3b4-c1e3-4bf3-90e8-dd4a6d496d6d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 10:24:16
16365	9d64c3b4-c057-4c95-8d33-695499c30a2e	9d64c3b4-c1e3-4bf3-90e8-dd4a6d496d6d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 10:24:16
16366	9d64c3b4-c0b4-4707-a273-ad5ce5c11267	9d64c3b4-c1e3-4bf3-90e8-dd4a6d496d6d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":436,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:24:16
26272	9d68d051-eda1-42d6-8baf-eaee4cc40581	9d68d052-16a7-4374-a21f-8ff94031e7f0	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 10:42:51
26273	9d68d052-1474-4541-82b2-1f7e5b01d4a9	9d68d052-16a7-4374-a21f-8ff94031e7f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:42:51
26274	9d68d052-156c-4967-bf47-9ff5398378cf	9d68d052-16a7-4374-a21f-8ff94031e7f0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":494,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:42:51
26164	9d68ceb8-6572-4e4d-bcd1-8903cd7b9bb3	9d68ceb8-bb11-4ae9-948a-632be5c31b42	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 10:38:23
26165	9d68ceb8-b78c-4516-9803-2e249a76af08	9d68ceb8-bb11-4ae9-948a-632be5c31b42	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:38:23
26166	9d68ceb8-b8e9-4ccd-92c6-47b395493e7d	9d68ceb8-bb11-4ae9-948a-632be5c31b42	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":679,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:38:23
26275	9d68d052-cf47-4858-abad-0b01d3c7e9a6	9d68d052-f767-4299-8528-f31cd60716a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:42:52
26276	9d68d052-eb24-49a2-98cf-74110d904946	9d68d052-f767-4299-8528-f31cd60716a1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"53.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 10:42:52
26277	9d68d052-f023-46f2-86ab-57d551c08f27	9d68d052-f767-4299-8528-f31cd60716a1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"3.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:42:52
26278	9d68d052-f066-48f4-ae77-629dbd6d0b99	9d68d052-f767-4299-8528-f31cd60716a1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:42:52
26279	9d68d052-f61a-4007-a9ff-6c8745fc8bda	9d68d052-f767-4299-8528-f31cd60716a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:42:52
16438	9d64c9bb-c3c9-4cfe-862a-d43ecbbc2c3f	9d64c9bb-e58c-4366-9859-b4d10a2c5257	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 10:41:08
16439	9d64c9bb-e3a1-48eb-b80a-28c4fe020619	9d64c9bb-e58c-4366-9859-b4d10a2c5257	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 10:41:08
16440	9d64c9bb-e44a-4d89-9553-90704b89f6e7	9d64c9bb-e58c-4366-9859-b4d10a2c5257	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:41:08
16441	9d64c9bc-4385-4986-a5a8-f2118a0e0722	9d64c9bc-9615-4b13-ba48-dc0190e0e63d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 10:41:08
16442	9d64c9bc-89b4-4395-92e3-212ef7e4e6a9	9d64c9bc-9615-4b13-ba48-dc0190e0e63d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"166.96","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 10:41:08
16443	9d64c9bc-8ea0-4224-aef4-19e1432d99a5	9d64c9bc-9615-4b13-ba48-dc0190e0e63d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 10:41:08
16444	9d64c9bc-8ee9-403e-8274-ae8aa2970e05	9d64c9bc-9615-4b13-ba48-dc0190e0e63d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 10:41:08
16445	9d64c9bc-9456-4254-86c7-dfc2b74e0a8f	9d64c9bc-9615-4b13-ba48-dc0190e0e63d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 10:41:08
16446	9d64c9bc-94df-4593-8027-23362a33e582	9d64c9bc-9615-4b13-ba48-dc0190e0e63d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":382,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:41:08
26167	9d68ceb9-80ce-448b-a946-3dc35e8ce814	9d68ceb9-abd1-4a93-85a1-bf4031387782	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:38:24
26168	9d68ceb9-9ed3-4044-b560-d4575cb4609b	9d68ceb9-abd1-4a93-85a1-bf4031387782	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"54.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 10:38:24
26169	9d68ceb9-a383-4a23-97ea-538a46f2012b	9d68ceb9-abd1-4a93-85a1-bf4031387782	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:38:24
26170	9d68ceb9-a3be-4bf5-a757-e9bdd2811def	9d68ceb9-abd1-4a93-85a1-bf4031387782	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:38:24
26171	9d68ceb9-a9df-42d9-9ab9-a47e4361e5f4	9d68ceb9-abd1-4a93-85a1-bf4031387782	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:38:24
12941	9d5ceef5-a8a2-4917-9119-f95af260caa9	9d5ceef5-f70e-401d-af60-6c225b20ea86	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 12:58:36
12942	9d5ceef5-f501-4771-85d5-112264de7859	9d5ceef5-f70e-401d-af60-6c225b20ea86	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:58:36
12943	9d5ceef5-f5cc-41b4-89bf-7efbf85295d9	9d5ceef5-f70e-401d-af60-6c225b20ea86	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":371,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:58:36
26280	9d68d052-f670-4853-b1d2-05ccb2a60f06	9d68d052-f767-4299-8528-f31cd60716a1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":477,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:42:52
26172	9d68ceb9-aa60-40aa-8a24-b748ffb7fe25	9d68ceb9-abd1-4a93-85a1-bf4031387782	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"240000","loans_pago_interes":"60000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":548,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:38:24
16447	9d64c9bd-e160-48bb-b0fc-6024cf71e152	9d64c9be-0e04-4f5a-808a-5026f2689498	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 10:41:09
12945	9d5ceef6-4e69-4e08-aeae-df9225d50721	9d5ceef6-92f4-4062-a13f-f2ddef4c8f59	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:58:36
12946	9d5ceef6-8e4f-4130-9bb4-8eb16f9f1ab1	9d5ceef6-92f4-4062-a13f-f2ddef4c8f59	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"150.32","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-29 12:58:36
12947	9d5ceef6-91ab-4fea-9bdb-75ecdc75991c	9d5ceef6-92f4-4062-a13f-f2ddef4c8f59	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:58:36
12948	9d5ceef6-922a-40ea-896c-13f18eacd2bc	9d5ceef6-92f4-4062-a13f-f2ddef4c8f59	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"Call to a member function orderBy() on array","exception":"Error","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":41,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":365,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:58:36
12944	9d5ceef6-9090-4cc7-ba42-4b0c18ba1eb4	9d5ceef6-92f4-4062-a13f-f2ddef4c8f59	4b6d7cebf2ab1d73a4624f86545ad1de	f	exception	{"class":"Error","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":41,"message":"Call to a member function orderBy() on array","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"32":"                                l.loans_intereses,","33":"                                uco.name as cobrador,","34":"                                ure.name as recomendador","35":"                            from loans l","36":"                            join users ucl on l.user_customer = ucl.id","37":"                            join users uco on l.user_cobrador = uco.id","38":"                            left join users ure on l.user_recomendacion = ure.id","39":"                        \\");","40":"","41":"        $data = $data->orderBy('l.id', 'DESC');","42":"        return response()->json([","43":"            \\"data\\" => $data","44":"        ]);","45":"","46":"","47":"    }","48":"","49":"    \\/**","50":"     * Show the form for creating a new resource.","51":"     *\\/"},"hostname":"EderCortes","occurrences":1}	2024-10-29 12:58:36
16448	9d64c9be-05ac-4e74-9db0-8c0a794dbabe	9d64c9be-0e04-4f5a-808a-5026f2689498	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"58.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 10:41:09
16449	9d64c9be-062f-45cb-b186-04f088833440	9d64c9be-0e04-4f5a-808a-5026f2689498	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 10:41:09
16450	9d64c9be-0c1c-4b49-be55-1dcd49b4d939	9d64c9be-0e04-4f5a-808a-5026f2689498	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 10:41:09
16451	9d64c9be-0c98-44ac-9f67-5ef2d4e55f88	9d64c9be-0e04-4f5a-808a-5026f2689498	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":464,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:41:09
19560	9d66e094-6227-485a-a6cb-91431dcd93dc	9d66e094-b29f-4e64-9b30-88b404dbd8dc	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 11:36:40
19561	9d66e094-b044-458a-bca4-d136b796bf12	9d66e094-b29f-4e64-9b30-88b404dbd8dc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:36:40
11152	9d5cab69-1443-4f4c-857c-f15e31f26bc8	9d5cab69-5adf-4c23-b811-7b61ce9a7cda	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 09:49:43
11153	9d5cab69-598a-4ff0-8544-e986452420b9	9d5cab69-5adf-4c23-b811-7b61ce9a7cda	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 09:49:43
11154	9d5cab69-5a11-4817-b6b5-734c59937261	9d5cab69-5adf-4c23-b811-7b61ce9a7cda	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":327,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:49:43
19562	9d66e094-b134-4c09-85cd-cf5be19e8695	9d66e094-b29f-4e64-9b30-88b404dbd8dc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":433,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:36:40
11155	9d5cab69-a569-4a69-9389-baa98c80b2c8	9d5cab69-c062-4335-ab9b-784f8f21a5a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 09:49:43
11156	9d5cab69-b814-46a8-808f-60b697b9f932	9d5cab69-c062-4335-ab9b-784f8f21a5a6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 1\\n                        ","time":"37.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"2bd5a29c69f6bbb290fc49b79286632e","hostname":"EderCortes"}	2024-10-29 09:49:43
11157	9d5cab69-bbc9-4598-a0b4-f146555ee555	9d5cab69-c062-4335-ab9b-784f8f21a5a6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '1' order by \\"item_loans\\".\\"id\\" asc","time":"1.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 09:49:43
11158	9d5cab69-bbf9-457f-8e83-34f41be83e1f	9d5cab69-c062-4335-ab9b-784f8f21a5a6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 09:49:43
11159	9d5cab69-bf33-4b5d-8e5a-f590eef8f9a1	9d5cab69-c062-4335-ab9b-784f8f21a5a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 09:49:43
11160	9d5cab69-bf8a-46fd-9df8-5f62807a3f25	9d5cab69-c062-4335-ab9b-784f8f21a5a6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":1,"cobrador":"Luis andre","recomendador":null,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_apellido_dos":"MArtinez","loans_tipo_documento":"CC","loans_documento":100465545,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Thu Oct 24 2024","loans_estado":"Pendiente","loans_celular":655465456},"items":[{"id":1,"loans_codigo":1,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":2,"loans_codigo":1,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":3,"loans_codigo":1,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":4,"loans_codigo":1,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":5,"loans_codigo":1,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null},{"id":6,"loans_codigo":1,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":1,"itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-24T11:33:55.000000Z","updated_at":"2024-10-24T11:33:55.000000Z","deleted_at":null}]}},"duration":228,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:49:43
12949	9d5ceef8-41c0-4599-8f86-cff1281c6f38	9d5ceef8-6028-41b3-bdd7-0778dc1c07a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:58:37
12950	9d5ceef8-5ad5-4213-9621-53c71d0b6a63	9d5ceef8-6028-41b3-bdd7-0778dc1c07a4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 12:58:38
12951	9d5ceef8-5b34-4674-956a-e45fa018561b	9d5ceef8-6028-41b3-bdd7-0778dc1c07a4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 12:58:38
12952	9d5ceef8-5f09-4abd-a75d-51b12499d7c7	9d5ceef8-6028-41b3-bdd7-0778dc1c07a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 12:58:38
12953	9d5ceef8-5f4a-4557-8855-075a34e19ff3	9d5ceef8-6028-41b3-bdd7-0778dc1c07a4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":261,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:58:38
19563	9d66e095-2bae-45b6-bf06-3c21aa803f3a	9d66e095-7c81-413f-be02-f649c8107784	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:36:40
11161	9d5cab6a-d3b8-4c1b-93cb-79b7bfbaffe6	9d5cab6b-2953-42ab-bd1d-4224578ea4fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 09:49:44
11162	9d5cab6b-2395-4c06-bef9-51aaaed6ea3b	9d5cab6b-2953-42ab-bd1d-4224578ea4fb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"156.21","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 09:49:44
11163	9d5cab6b-23e5-4a10-993c-6c760f395d1f	9d5cab6b-2953-42ab-bd1d-4224578ea4fb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 09:49:44
11164	9d5cab6b-27db-47ee-8637-be6e85a70ffb	9d5cab6b-2953-42ab-bd1d-4224578ea4fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-29 09:49:44
11165	9d5cab6b-2829-4947-8536-373002e0ee57	9d5cab6b-2953-42ab-bd1d-4224578ea4fb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":472,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:49:44
12954	9d5ceef8-ce9b-46b4-88eb-88ea39b96441	9d5ceef8-d190-4015-a1d1-b5ea62e4a56f	4b6d7cebf2ab1d73a4624f86545ad1de	t	exception	{"class":"Error","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":41,"message":"Call to a member function orderBy() on array","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"32":"                                l.loans_intereses,","33":"                                uco.name as cobrador,","34":"                                ure.name as recomendador","35":"                            from loans l","36":"                            join users ucl on l.user_customer = ucl.id","37":"                            join users uco on l.user_cobrador = uco.id","38":"                            left join users ure on l.user_recomendacion = ure.id","39":"                        \\");","40":"","41":"        $data = $data->orderBy('l.id', 'DESC');","42":"        return response()->json([","43":"            \\"data\\" => $data","44":"        ]);","45":"","46":"","47":"    }","48":"","49":"    \\/**","50":"     * Show the form for creating a new resource.","51":"     *\\/"},"hostname":"EderCortes","occurrences":2}	2024-10-29 12:58:38
12955	9d5ceef8-b39f-424f-8e85-9f5d3927859a	9d5ceef8-d190-4015-a1d1-b5ea62e4a56f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 12:58:38
12956	9d5ceef8-cc2f-4baf-9278-c4af50b9de68	9d5ceef8-d190-4015-a1d1-b5ea62e4a56f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                        ","time":"45.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"297c426a3b8a8fdd3df6f118ae4b0b1e","hostname":"EderCortes"}	2024-10-29 12:58:38
12957	9d5ceef8-cfcd-4829-96fe-249216e7209e	9d5ceef8-d190-4015-a1d1-b5ea62e4a56f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 12:58:38
12958	9d5ceef8-d06c-4731-9074-6a3879fdbda3	9d5ceef8-d190-4015-a1d1-b5ea62e4a56f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"Call to a member function orderBy() on array","exception":"Error","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":41,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":268,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:58:38
19564	9d66e095-6f28-4b6d-bce4-bb52566d1c78	9d66e095-7c81-413f-be02-f649c8107784	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"157.30","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 11:36:41
19565	9d66e095-749d-4558-b614-edad2dd111a0	9d66e095-7c81-413f-be02-f649c8107784	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:36:41
19566	9d66e095-74e4-4d1f-8856-3d1b607e7738	9d66e095-7c81-413f-be02-f649c8107784	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:36:41
19567	9d66e095-7b0a-47d2-965b-0f91cbf33088	9d66e095-7c81-413f-be02-f649c8107784	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:36:41
19568	9d66e095-7b61-4cbd-ad67-a20af25635f1	9d66e095-7c81-413f-be02-f649c8107784	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":461,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:36:41
26652	9d68da62-a00a-496b-b5b8-91df19874c2a	9d68da62-c387-4c86-962e-648c97343be5	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 11:11:00
26392	9d68d3d8-f9f3-411a-9a27-11b5ad29faf8	9d68d3d9-4bb9-41b3-a712-58ac5ef109b8	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 10:52:43
26393	9d68d3d9-4990-45f5-a5f1-61a4db58d8f4	9d68d3d9-4bb9-41b3-a712-58ac5ef109b8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:52:43
26394	9d68d3d9-4a67-4888-86c2-78885a9b846a	9d68d3d9-4bb9-41b3-a712-58ac5ef109b8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":605,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:52:43
26653	9d68da62-c196-4d76-80ac-80f9948068ba	9d68da62-c387-4c86-962e-648c97343be5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:11:00
26654	9d68da62-c258-4eac-af4d-d8276941844c	9d68da62-c387-4c86-962e-648c97343be5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":428,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:11:00
19569	9d66e097-9c58-4d5e-9e01-5e943a368118	9d66e097-ba4f-446f-8c18-1ba64e063895	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:36:42
19570	9d66e097-b4d1-47d7-895f-d6e53ddf4ce9	9d66e097-ba4f-446f-8c18-1ba64e063895	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:36:42
19571	9d66e097-b522-41b0-abaf-a1885e2b7738	9d66e097-ba4f-446f-8c18-1ba64e063895	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:36:42
19572	9d66e097-b8db-4983-96d5-0cdc51752dff	9d66e097-ba4f-446f-8c18-1ba64e063895	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 11:36:42
19573	9d66e097-b92a-4fa1-be8a-49ea0cd3f63f	9d66e097-ba4f-446f-8c18-1ba64e063895	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":265,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:36:42
26395	9d68d3d9-faaa-454f-aa26-e83a9055300e	9d68d3da-483b-4c34-afd4-64c70e7c4ae1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:52:44
26396	9d68d3da-3e75-4476-83ab-1d01a22b2ee8	9d68d3da-483b-4c34-afd4-64c70e7c4ae1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"155.80","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 10:52:44
26397	9d68d3da-4235-45f1-8258-40d9c6ed872f	9d68d3da-483b-4c34-afd4-64c70e7c4ae1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:52:44
26398	9d68d3da-4270-4403-af27-c6ba41e9dcfb	9d68d3da-483b-4c34-afd4-64c70e7c4ae1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:52:44
26399	9d68d3da-46d1-44a8-a647-a331def7b7a4	9d68d3da-483b-4c34-afd4-64c70e7c4ae1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:52:44
26400	9d68d3da-4722-4254-b2ff-e28a24ff972a	9d68d3da-483b-4c34-afd4-64c70e7c4ae1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":548,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:52:44
26482	9d68d719-8c4d-4cd1-8f28-06d1c6e9d8fe	9d68d719-bdf8-43b9-8912-a0ac5f861c52	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 11:01:49
26483	9d68d719-bb22-48cc-971e-13e428d9793a	9d68d719-bdf8-43b9-8912-a0ac5f861c52	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:01:49
26484	9d68d719-bc50-43fa-bf20-6ed78386ecb1	9d68d719-bdf8-43b9-8912-a0ac5f861c52	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":550,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:01:49
26655	9d68da63-4d8f-4ba6-8dc0-0a53560a6002	9d68da63-6dfa-482e-aeb3-885005a2f01f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:11:01
26485	9d68d71a-78f0-47c5-b2a1-889154e586ca	9d68d71a-c44a-4d17-95ef-fbaa359c4dd1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:01:49
26486	9d68d71a-ba2a-41dc-b595-89f8b61adc4e	9d68d71a-c44a-4d17-95ef-fbaa359c4dd1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"148.89","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:01:50
26487	9d68d71a-be63-4e66-b495-254a768771c1	9d68d71a-c44a-4d17-95ef-fbaa359c4dd1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:01:50
26488	9d68d71a-be97-4d37-8950-2315eb772514	9d68d71a-c44a-4d17-95ef-fbaa359c4dd1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:01:50
26489	9d68d71a-c2f3-4296-968f-6b67d89f8bef	9d68d71a-c44a-4d17-95ef-fbaa359c4dd1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:01:50
26490	9d68d71a-c34b-48e7-90ff-33d3ccedb4c5	9d68d71a-c44a-4d17-95ef-fbaa359c4dd1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":621,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:01:50
26656	9d68da63-6491-475f-8c9d-4212040503a5	9d68da63-6dfa-482e-aeb3-885005a2f01f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"45.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 11:11:01
26657	9d68da63-6825-42b8-984c-1587e7b2c212	9d68da63-6dfa-482e-aeb3-885005a2f01f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:11:01
26658	9d68da63-685b-4042-80eb-3e067f73dfea	9d68da63-6dfa-482e-aeb3-885005a2f01f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:11:01
26659	9d68da63-6cb5-423a-a1e0-9b62b55596ec	9d68da63-6dfa-482e-aeb3-885005a2f01f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:11:01
26660	9d68da63-6d03-43c9-b71b-fbbf142cc4c0	9d68da63-6dfa-482e-aeb3-885005a2f01f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":391,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:11:01
26562	9d68d84a-a1ba-4a66-84db-d4836c48551a	9d68d84a-ce43-4741-abf7-56d128843ff6	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 11:05:09
26563	9d68d84a-cc2f-466d-9e31-fef246a436ac	9d68d84a-ce43-4741-abf7-56d128843ff6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:05:09
26564	9d68d84a-cd13-4c7e-b91d-00886831e742	9d68d84a-ce43-4741-abf7-56d128843ff6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":455,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:05:09
8708	9d52eea4-7d91-498f-a089-daf62275e0fc	9d52eea4-81d5-496c-80c6-206772fe8383	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":421}	2024-10-24 13:39:26
11934	9d5cd8da-8369-47bd-b0b6-23a247c5ed2c	9d5cd8da-a8ab-42d3-9d9f-db51f7ebee86	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 11:56:47
11935	9d5cd8da-a6ed-4921-9db2-9ac13edc48db	9d5cd8da-a8ab-42d3-9d9f-db51f7ebee86	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 11:56:47
11936	9d5cd8da-a798-429f-8cc7-b7d981057dbb	9d5cd8da-a8ab-42d3-9d9f-db51f7ebee86	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":285,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:56:47
11937	9d5cd8db-0197-45c2-a7e2-ffeaeb2bfaa4	9d5cd8db-2456-4e1a-b755-93598f9727a0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 11:56:47
11938	9d5cd8db-1a7f-4540-b500-7d3183a388e7	9d5cd8db-2456-4e1a-b755-93598f9727a0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 28\\n                        ","time":"48.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"618a8b500e46ad393f7c65ceec660399","hostname":"EderCortes"}	2024-10-29 11:56:47
11939	9d5cd8db-1ea7-470b-a295-72b624ff0e63	9d5cd8db-2456-4e1a-b755-93598f9727a0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '28' order by \\"item_loans\\".\\"id\\" asc","time":"2.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 11:56:47
11940	9d5cd8db-1eee-4364-a046-e97a26b3e6fc	9d5cd8db-2456-4e1a-b755-93598f9727a0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 11:56:47
11941	9d5cd8db-22ce-4a60-b307-5691231d61f6	9d5cd8db-2456-4e1a-b755-93598f9727a0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 11:56:47
11942	9d5cd8db-2324-4e28-8d02-ee6e18d143b5	9d5cd8db-2456-4e1a-b755-93598f9727a0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/28","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":28,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":600081,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":94,"loans_codigo":28,"itemloans_cuota":"1","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":95,"loans_codigo":28,"itemloans_cuota":"2","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":96,"loans_codigo":28,"itemloans_cuota":"3","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":97,"loans_codigo":28,"itemloans_cuota":"4","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":98,"loans_codigo":28,"itemloans_cuota":"5","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":99,"loans_codigo":28,"itemloans_cuota":"6","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null}]}},"duration":280,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:56:47
26565	9d68d84b-71ed-445e-b283-b55781c39507	9d68d84b-bfa3-4f2f-b617-6c994d39cc4a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:05:09
26566	9d68d84b-b41f-4e15-9e49-9f504c7917de	9d68d84b-bfa3-4f2f-b617-6c994d39cc4a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"154.33","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:05:09
13660	9d5d0ab9-e58f-4fbb-aad3-d43f68ad3e69	9d5d0aba-3cb0-4c66-b55f-6256bd6ad729	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 14:16:14
13661	9d5d0aba-3b33-4b0b-b7b9-658b16ba7aed	9d5d0aba-3cb0-4c66-b55f-6256bd6ad729	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 14:16:14
26567	9d68d84b-b8f4-45a8-a2ee-3a89f3a647b1	9d68d84b-bfa3-4f2f-b617-6c994d39cc4a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:05:10
26568	9d68d84b-b933-41b1-98d8-6a25a57a4381	9d68d84b-bfa3-4f2f-b617-6c994d39cc4a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:05:10
26569	9d68d84b-be33-48cb-afce-67fd9035effa	9d68d84b-bfa3-4f2f-b617-6c994d39cc4a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:05:10
13662	9d5d0aba-3bca-4b21-9f72-3dbc0345a613	9d5d0aba-3cb0-4c66-b55f-6256bd6ad729	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":456,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:16:14
19650	9d66e2b7-7c55-4022-a8d5-3487c1a8dd78	9d66e2b7-cc5c-44f1-bf87-28b64b6bcabc	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 11:42:39
19651	9d66e2b7-ca08-4958-a6ce-a68b0b42d0a7	9d66e2b7-cc5c-44f1-bf87-28b64b6bcabc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:42:39
19652	9d66e2b7-cb07-4a4c-85df-119e72bb8d2f	9d66e2b7-cc5c-44f1-bf87-28b64b6bcabc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":395,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:42:39
26570	9d68d84b-be97-41e4-93a7-59590f5986bb	9d68d84b-bfa3-4f2f-b617-6c994d39cc4a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":567,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:05:10
4745	9d5134fc-c811-4c00-9ee7-06dc688bfab2	9d5134fc-cb5f-4d7a-b3dc-d4c567f3be03	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":257}	2024-10-23 17:04:28
13663	9d5d0aba-872d-45dc-91ab-fc172f523996	9d5d0aba-c95d-4bf7-8801-944d836a53af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 14:16:15
13664	9d5d0aba-c57b-42ac-a30c-5d5c55a909a0	9d5d0aba-c95d-4bf7-8801-944d836a53af	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"148.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-29 14:16:15
13665	9d5d0aba-c83a-4e3c-a536-e5a207ba4a4f	9d5d0aba-c95d-4bf7-8801-944d836a53af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 14:16:15
13666	9d5d0aba-c886-48c4-8d3b-b25002c2ca70	9d5d0aba-c95d-4bf7-8801-944d836a53af	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":318,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:16:15
19653	9d66e2b8-4249-4abe-92c4-7e0dcd1cebf3	9d66e2b8-6643-45e5-9b9e-3ec42163ae5d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:42:39
19654	9d66e2b8-5bd2-455d-8864-3f27d29e69a0	9d66e2b8-6643-45e5-9b9e-3ec42163ae5d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"50.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 11:42:39
19655	9d66e2b8-5fb9-4a2f-84d3-b685ed9e7169	9d66e2b8-6643-45e5-9b9e-3ec42163ae5d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:42:39
19656	9d66e2b8-5ff4-46cd-a2c4-06199952f136	9d66e2b8-6643-45e5-9b9e-3ec42163ae5d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:42:39
19657	9d66e2b8-64e3-40fd-9460-7aaa66e8d42b	9d66e2b8-6643-45e5-9b9e-3ec42163ae5d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:42:39
19658	9d66e2b8-6549-4e50-9c88-cd1f7942d697	9d66e2b8-6643-45e5-9b9e-3ec42163ae5d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:42:39
13667	9d5d0abc-834d-4492-9756-13c951b57c76	9d5d0abc-a33f-4383-8ee8-c27058a8664b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 14:16:16
13668	9d5d0abc-9d70-4b8c-9fc1-db79efa00fdf	9d5d0abc-a33f-4383-8ee8-c27058a8664b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"39.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 14:16:16
13669	9d5d0abc-9dc7-4825-afd3-cae0b4a5e426	9d5d0abc-a33f-4383-8ee8-c27058a8664b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 14:16:16
13670	9d5d0abc-a200-4f67-9553-47707ac01032	9d5d0abc-a33f-4383-8ee8-c27058a8664b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 14:16:16
12265	9d5ce164-9866-4990-b12a-fc69342b6683	9d5ce164-bce9-4d7e-86b7-ae7816a34ab4	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 12:20:40
12266	9d5ce164-bb3b-4d13-8630-cc0c3875168a	9d5ce164-bce9-4d7e-86b7-ae7816a34ab4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:20:40
12267	9d5ce164-bbee-4077-868d-d5eb9094899a	9d5ce164-bce9-4d7e-86b7-ae7816a34ab4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":309,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:20:40
13671	9d5d0abc-a251-4723-a5b0-3b1a0d6dfe97	9d5d0abc-a33f-4383-8ee8-c27058a8664b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":407,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:16:16
19659	9d66e2ba-ab0a-432c-aaad-00a79a2a321d	9d66e2ba-ef27-43f1-b1a7-a69dafdff327	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:42:41
19660	9d66e2ba-ea64-492a-8fd2-5d01e00b611c	9d66e2ba-ef27-43f1-b1a7-a69dafdff327	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"142.27","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:42:41
16562	9d64d3cd-bc3a-430a-b4da-373b04c7b7cc	9d64d3cd-e842-4f13-bdf6-63a1f4350194	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 11:09:17
16563	9d64d3cd-e629-451e-aacb-6eb108e9cba7	9d64d3cd-e842-4f13-bdf6-63a1f4350194	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 11:09:17
16564	9d64d3cd-e705-40a6-86cc-1414b37fc679	9d64d3cd-e842-4f13-bdf6-63a1f4350194	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":375,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:09:17
19661	9d66e2ba-eaad-426d-92f9-685355a36080	9d66e2ba-ef27-43f1-b1a7-a69dafdff327	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:42:41
19662	9d66e2ba-ee07-4809-a31b-c64636d96f59	9d66e2ba-ef27-43f1-b1a7-a69dafdff327	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 11:42:41
19663	9d66e2ba-ee49-423d-b9e4-c7e5f2ca7e9d	9d66e2ba-ef27-43f1-b1a7-a69dafdff327	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":526,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:42:41
12268	9d5ce165-1664-4afc-8e82-b55c5d9413a8	9d5ce165-5ff4-47e4-b9fd-e290c967ea1c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:20:40
12269	9d5ce165-59fb-43d1-bbc0-915d0932236b	9d5ce165-5ff4-47e4-b9fd-e290c967ea1c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"151.05","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":177,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 12:20:40
12270	9d5ce165-5a43-4cc7-90a3-cc919bf8c955	9d5ce165-5ff4-47e4-b9fd-e290c967ea1c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 12:20:40
12271	9d5ce165-5ec5-4047-bdc5-d625d20505d5	9d5ce165-5ff4-47e4-b9fd-e290c967ea1c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:20:40
12272	9d5ce165-5f15-4bf6-b67c-5d144db16da3	9d5ce165-5ff4-47e4-b9fd-e290c967ea1c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":380,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:20:40
13672	9d5d0bfb-d21e-4a27-9c59-3ad132cda6f4	9d5d0bfb-f5de-4690-9fd6-bfe46ef625a1	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 14:19:45
13673	9d5d0bfb-ebbf-4c97-88aa-77d030153f47	9d5d0bfb-f5de-4690-9fd6-bfe46ef625a1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 52\\n                        ","time":"42.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"b818d1825eff359c94d73944c3be2955","hostname":"EderCortes"}	2024-10-29 14:19:45
13674	9d5d0bfb-efc2-4288-9425-fc59ab388fac	9d5d0bfb-f5de-4690-9fd6-bfe46ef625a1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '52' order by \\"item_loans\\".\\"id\\" asc","time":"2.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 14:19:45
13675	9d5d0bfb-eff2-4c72-8f37-0aeaaf3dfd6f	9d5d0bfb-f5de-4690-9fd6-bfe46ef625a1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":7,"hostname":"EderCortes"}	2024-10-29 14:19:45
13676	9d5d0bfb-f471-4cc2-b6b7-bc88034951fc	9d5d0bfb-f5de-4690-9fd6-bfe46ef625a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 14:19:45
13677	9d5d0bfb-f4cb-4785-900b-b65c8a770588	9d5d0bfb-f5de-4690-9fd6-bfe46ef625a1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/52","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":52,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":7,"loans_valor_prestado":500000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"12-11-24","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":136,"loans_codigo":52,"itemloans_cuota":"1","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":137,"loans_codigo":52,"itemloans_cuota":"2","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0024-12-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":138,"loans_codigo":52,"itemloans_cuota":"3","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0024-12-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":139,"loans_codigo":52,"itemloans_cuota":"4","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0025-01-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":140,"loans_codigo":52,"itemloans_cuota":"5","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0025-01-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":141,"loans_codigo":52,"itemloans_cuota":"6","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0025-02-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":142,"loans_codigo":52,"itemloans_cuota":"7","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0025-02-25 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":296,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:19:45
16565	9d64d3ce-5ea7-4837-95af-99ef85afe67d	9d64d3ce-98ca-44c0-8dad-8530906ad3fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 11:09:18
12273	9d5ce165-a807-424d-8103-f540f8e64c11	9d5ce165-c7cd-48ca-9b78-b311bea7a55f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:20:40
12274	9d5ce165-c34a-45b9-86b6-7dfe37bdef52	9d5ce165-c7cd-48ca-9b78-b311bea7a55f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":177,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 12:20:40
12275	9d5ce165-c399-4dc2-8703-b0c9e898b36a	9d5ce165-c7cd-48ca-9b78-b311bea7a55f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 12:20:40
12276	9d5ce165-c6d2-404f-baf0-8ba257710e07	9d5ce165-c7cd-48ca-9b78-b311bea7a55f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 12:20:40
12277	9d5ce165-c713-4ac9-adc1-189be08be44b	9d5ce165-c7cd-48ca-9b78-b311bea7a55f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":248,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:20:40
13678	9d5d0c53-5bd6-46c2-ae09-ddfaab24e4a2	9d5d0c53-5fad-41c0-ba1c-fed04c41177b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":204,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:20:43
16566	9d64d3ce-7f19-4239-af7e-c8d68f2bae64	9d64d3ce-98ca-44c0-8dad-8530906ad3fd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"66.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 11:09:18
16567	9d64d3ce-852f-4ac1-97c8-ee9d8ede4e9d	9d64d3ce-98ca-44c0-8dad-8530906ad3fd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"3.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 11:09:18
16568	9d64d3ce-85a8-47fb-bd9f-5b71925e0ed6	9d64d3ce-98ca-44c0-8dad-8530906ad3fd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 11:09:18
16569	9d64d3ce-9567-4ad3-a1af-2a363ded2f55	9d64d3ce-98ca-44c0-8dad-8530906ad3fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 11:09:18
16570	9d64d3ce-9676-4165-a5ea-445e2d57da2d	9d64d3ce-98ca-44c0-8dad-8530906ad3fd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":403,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:09:18
12278	9d5ce167-b45f-45ed-ba46-d89c63c540d3	9d5ce167-f80c-46e9-a082-b860e8688a6d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 12:20:42
12279	9d5ce167-f2b2-4ddf-9e72-923b62461e4d	9d5ce167-f80c-46e9-a082-b860e8688a6d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"141.52","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 12:20:42
12280	9d5ce167-f318-4658-aecf-541f73b2cf4a	9d5ce167-f80c-46e9-a082-b860e8688a6d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 12:20:42
12281	9d5ce167-f6ed-417d-9175-beab0def05e8	9d5ce167-f80c-46e9-a082-b860e8688a6d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 12:20:42
12282	9d5ce167-f732-4497-b51f-3d20e04f4291	9d5ce167-f80c-46e9-a082-b860e8688a6d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:20:42
17063	9d6548b3-2a6b-47e9-b122-6ee3f1395329	9d6548b3-2d74-4ebc-a21e-a4b27dd64c27	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42883]: Undefined function: 7 ERROR:  no existe la funci\\u00f3n datediff(character varying, integer)\\nLINE 1: select DATEDIFF(l.loans_fecha_ultimo_pago, 02-11-2024) as di...\\n               ^\\nHINT:  Ninguna funci\\u00f3n coincide en el nombre y tipos de argumentos. Puede ser necesario agregar conversi\\u00f3n expl\\u00edcita de tipos. (Connection: pgsql, SQL: select DATEDIFF(l.loans_fecha_ultimo_pago, 02-11-2024) as dis_restantes, \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":45},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":805}	2024-11-02 16:36:09
12283	9d5ce16c-2864-4fd6-a6a5-7be6c2bcf0e9	9d5ce16c-2b12-4b2d-9dd3-31d1596b3283	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":141,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:20:45
13683	9d5d0c6f-b606-4cb8-9087-16a28636e3cf	9d5d0c6f-b9ba-452b-8180-e8d33b140895	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":161,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:21:01
26763	9d68dc1f-7d51-443d-9ef8-9411994bc2f4	9d68dc1f-9c0a-41fc-83e9-3e451e424530	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:15:52
26764	9d68dc1f-9a41-49b3-93b5-0cee9553fcb8	9d68dc1f-9c0a-41fc-83e9-3e451e424530	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:15:52
26765	9d68dc1f-9adf-4cdc-b976-68480912631d	9d68dc1f-9c0a-41fc-83e9-3e451e424530	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":359,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:15:52
21543	9d673bea-3fac-4660-b329-d6e883b9caf9	9d673bea-438d-4f95-b97a-c0cd3a6a078f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1044}	2024-11-03 15:52:03
12284	9d5ce16c-de70-4d1a-9c10-11afa6a23d8b	9d5ce16c-f816-4eac-bc9b-bc26b83c09f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 12:20:45
12285	9d5ce16c-f3dd-454f-b3b4-25b1bbee5566	9d5ce16c-f816-4eac-bc9b-bc26b83c09f4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 or \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"39.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"805f12b63a2f006ec36b2474905c2fcb","hostname":"EderCortes"}	2024-10-29 12:20:45
12286	9d5ce16c-f6cf-4acf-a1d8-109486b6e1dd	9d5ce16c-f816-4eac-bc9b-bc26b83c09f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 12:20:45
12287	9d5ce16c-f71f-4551-948f-2dd173fee6f2	9d5ce16c-f816-4eac-bc9b-bc26b83c09f4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[{"id":12,"name_customer":"Eder Arley  Cortes - 1004608333"},{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":214,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:20:45
26766	9d68dc20-1bd7-4c8f-81bc-65db37f4c125	9d68dc20-3ae4-4c86-b907-6a5d1d9c83d4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:15:52
6256	9d5263a6-e2cc-4896-a5d9-769d9bb6ca30	9d5263a6-e826-4fc0-8308-c88fbb95f5ca	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abfrom\\u00bb\\nLINE 14:     from loans l\\n             ^ (Connection: pgsql, SQL: \\n    select l.id,\\n        l.loans_documento,\\n        l.loans_nombre,\\n        l.loans_apellido_uno,\\n        l.loans_fecha,\\n        l.loans_valor_prestado,\\n        l.loans_cuotas,\\n        l.loans_estado,\\n        l.loans_intereses,\\n        ucl.name as cliente,\\n        uco.name as cobrador,\\n        ure.name as recomendador,\\n    from loans l\\n    join users ucl on l.user_customer = ucl.id\\n    join users uco on l.user_cobrador = uco.id\\n    left join users ure on l.user_recomendacion = ure.id\\n)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":317}	2024-10-24 07:10:47
13688	9d5d0ca1-05fe-4058-8eb7-e87eee993ac2	9d5d0ca1-091f-46e4-8d78-6c3a99891423	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":186,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:21:33
26767	9d68dc20-3192-4ac4-aee8-94594ec9db7f	9d68dc20-3ae4-4c86-b907-6a5d1d9c83d4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"42.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 11:15:52
26768	9d68dc20-35a1-47e8-81a0-57ee63b4ff35	9d68dc20-3ae4-4c86-b907-6a5d1d9c83d4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:15:52
26769	9d68dc20-35d5-46ec-9517-9dac7fd30322	9d68dc20-3ae4-4c86-b907-6a5d1d9c83d4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:15:52
26770	9d68dc20-396b-403b-8051-896925a73ed8	9d68dc20-3ae4-4c86-b907-6a5d1d9c83d4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:15:52
26771	9d68dc20-39cb-4def-bb38-be1eed69c784	9d68dc20-3ae4-4c86-b907-6a5d1d9c83d4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":365,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:15:52
13693	9d5d0cc9-97f6-449f-a5fa-119a3e41d410	9d5d0cc9-9b34-4373-bff0-93ce0758a52e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":168,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:22:00
19740	9d66e572-ceff-4728-aa16-ad3729f70e66	9d66e572-f526-45ed-a633-11eb2942c079	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 11:50:17
19741	9d66e572-f34d-45ae-a3a3-31120a118b2a	9d66e572-f526-45ed-a633-11eb2942c079	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 11:50:17
19742	9d66e572-f436-4843-b906-c2d338776f1e	9d66e572-f526-45ed-a633-11eb2942c079	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":331,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:50:17
10018	9d56c6b6-2f04-40f6-ac3f-1b47fe95b045	9d56c6b6-3213-408a-ac52-748715ca808d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abl\\u00bb\\nLINE 13:                                 l.loans_nombre\\n                                         ^ (Connection: pgsql, SQL: \\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                                l.loans_nombre\\n                                l.loans_apellido_uno\\n                                l.loans_apellido_dos\\n                                l.loans_tipo_documento\\n                                l.loans_documento\\n                                l.loans_fecha_nacimiento\\n                                l.loans_ciudad\\n                                l.loans_barrio\\n                                l.loans_direccion\\n                                l.loans_intereses\\n                                l.loans_cuotas\\n                                l.loans_valor_prestado\\n                                l.loans_cuando\\n                                l.loans_observacion\\n                                l.loans_fecha\\n                                l.loans_estado\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":483}	2024-10-26 11:31:05
19743	9d66e573-4f9b-42cd-a19f-0a18238d7e9e	9d66e573-9c20-4272-9a0f-81675eb0d03c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 11:50:17
19744	9d66e573-9187-4b0e-90e1-c02f8ddaaeee	9d66e573-9c20-4272-9a0f-81675eb0d03c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"152.81","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 11:50:17
13698	9d5d0cf8-375b-4de1-a605-55458efc453d	9d5d0cf8-3b8a-44dc-913d-4b54836ff625	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":165,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:22:31
19745	9d66e573-9624-4f70-bc06-eaea309229a3	9d66e573-9c20-4272-9a0f-81675eb0d03c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:50:17
19746	9d66e573-966f-4ca9-8163-2b3b502e1ec1	9d66e573-9c20-4272-9a0f-81675eb0d03c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:50:17
19747	9d66e573-9aa4-40f6-970d-052aee643836	9d66e573-9c20-4272-9a0f-81675eb0d03c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 11:50:17
19748	9d66e573-9b08-492e-a6ea-6ab0d6ff230d	9d66e573-9c20-4272-9a0f-81675eb0d03c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":386,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:50:17
19749	9d66e575-3083-4bb6-828b-ede92c32afbc	9d66e575-53a3-4828-8af0-49f19170d682	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 11:50:18
19750	9d66e575-4d45-4ebe-83a7-15a0e7c8017e	9d66e575-53a3-4828-8af0-49f19170d682	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:50:18
19751	9d66e575-4db0-4cb0-b753-5b285d8be3e6	9d66e575-53a3-4828-8af0-49f19170d682	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:50:18
19752	9d66e575-5214-42c4-abb9-4b9b06f43a19	9d66e575-53a3-4828-8af0-49f19170d682	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 11:50:18
19753	9d66e575-5281-41df-9d3d-5fd5bd8802ee	9d66e575-53a3-4828-8af0-49f19170d682	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:50:18
11260	9d5cb211-469c-412a-bfe8-2ffd5e480f10	9d5cb211-80a0-4f5a-bf0f-1a25716d5d02	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 10:08:20
11261	9d5cb211-7cfe-44f2-ac6f-7e9fc68039f6	9d5cb211-80a0-4f5a-bf0f-1a25716d5d02	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 10:08:20
11262	9d5cb211-7e7f-4ce2-ace2-4d0246ed64d5	9d5cb211-80a0-4f5a-bf0f-1a25716d5d02	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":494,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:08:20
13702	9d5d0d36-a2b5-49b4-9e1f-fb53b2a6672b	9d5d0d36-a824-46ed-bfe8-85b09b85b4f7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":245,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:23:12
16690	9d64d60a-1160-49f7-98be-6e5269dc258d	9d64d60a-6a75-4ddf-90ba-d47d67b7a78d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 11:15:32
16691	9d64d60a-6858-4dd7-a3b7-a040d0f91e34	9d64d60a-6a75-4ddf-90ba-d47d67b7a78d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 11:15:32
16692	9d64d60a-6940-412a-97c4-a2002f6bbab9	9d64d60a-6a75-4ddf-90ba-d47d67b7a78d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":520,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:15:32
11263	9d5cb212-22ea-4eb1-8738-9503e53d537d	9d5cb212-45ac-4d80-85a1-9530f410ddc3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 10:08:20
11264	9d5cb212-3f7b-4c5e-a4e2-881ac38cba37	9d5cb212-45ac-4d80-85a1-9530f410ddc3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 10:08:20
11265	9d5cb212-3fdb-4ac1-b2f8-82b88bf2e206	9d5cb212-45ac-4d80-85a1-9530f410ddc3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 10:08:20
11266	9d5cb212-4474-4dd0-9c67-ac287c5d6abe	9d5cb212-45ac-4d80-85a1-9530f410ddc3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 10:08:20
11267	9d5cb212-44bc-4287-9443-b9723e939e0e	9d5cb212-45ac-4d80-85a1-9530f410ddc3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":464,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:08:20
16693	9d64d60a-e76a-42d8-ba40-1a73a1b601ed	9d64d60b-0e5c-44e6-bc6f-5f2813dfebe5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 11:15:33
16694	9d64d60a-fef5-4bb1-be9f-e79a607dff74	9d64d60b-0e5c-44e6-bc6f-5f2813dfebe5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"46.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 11:15:33
11268	9d5cb212-9893-4d4f-8679-0c56a1246362	9d5cb212-bc1f-4545-8e91-da0c8190cac5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 10:08:21
11269	9d5cb212-b3df-45ce-95d7-b219c2c44eec	9d5cb212-bc1f-4545-8e91-da0c8190cac5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":152,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 10:08:21
11270	9d5cb212-b449-4a9c-8fe8-25373e73b458	9d5cb212-bc1f-4545-8e91-da0c8190cac5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 10:08:21
11271	9d5cb212-ba78-4f7d-8e81-29ed9d178440	9d5cb212-bc1f-4545-8e91-da0c8190cac5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 10:08:21
11272	9d5cb212-bae9-4f5e-9e68-0b36e5fdfe40	9d5cb212-bc1f-4545-8e91-da0c8190cac5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":283,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:08:21
13707	9d5d0d46-7ae7-40fb-abcb-1059ea3d3ebc	9d5d0d46-7de3-4ea9-86dc-9dfebbb912dc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":154,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:23:22
16695	9d64d60b-047b-48a7-bc13-6b1133110a95	9d64d60b-0e5c-44e6-bc6f-5f2813dfebe5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"3.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 11:15:33
16696	9d64d60b-04d5-4839-adc5-a8b30d6f4b7a	9d64d60b-0e5c-44e6-bc6f-5f2813dfebe5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 11:15:33
16697	9d64d60b-0c8d-4a77-8d65-acbdb6b56953	9d64d60b-0e5c-44e6-bc6f-5f2813dfebe5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 11:15:33
16698	9d64d60b-0ce6-4528-834a-b9cee8c703aa	9d64d60b-0e5c-44e6-bc6f-5f2813dfebe5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:15:33
11273	9d5cb214-cbd3-4feb-8e28-db339a1c2664	9d5cb215-1851-4865-8837-718d46d7b658	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 10:08:22
11274	9d5cb215-11ce-40d9-9fd7-d75832375523	9d5cb215-1851-4865-8837-718d46d7b658	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"158.80","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 10:08:22
11275	9d5cb215-1249-4bba-bd8c-2431df162243	9d5cb215-1851-4865-8837-718d46d7b658	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 10:08:22
11276	9d5cb215-16c1-4a13-9081-b0d3c6e63272	9d5cb215-1851-4865-8837-718d46d7b658	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 10:08:22
11277	9d5cb215-1722-4757-b0e2-3f9e2be925eb	9d5cb215-1851-4865-8837-718d46d7b658	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":426,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:08:22
16699	9d64d60d-1318-4a38-8418-04e7e0daf17b	9d64d60d-32a8-4d69-b729-79920bb10a51	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 11:15:34
16700	9d64d60d-2d7a-45a7-ada6-5e9e5bd1effe	9d64d60d-32a8-4d69-b729-79920bb10a51	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 11:15:34
16701	9d64d60d-2dd4-490a-bb0b-c9f9e91419c7	9d64d60d-32a8-4d69-b729-79920bb10a51	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 11:15:34
16702	9d64d60d-3140-43fd-8110-da9cab45a29f	9d64d60d-32a8-4d69-b729-79920bb10a51	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 11:15:34
16703	9d64d60d-3192-4826-acb8-b4722bb79240	9d64d60d-32a8-4d69-b729-79920bb10a51	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":312,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:15:34
13712	9d5d0d5f-a84b-44ba-aa63-f61def587a51	9d5d0d5f-abdf-4b9b-9046-5f45bf8c634a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":157,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:23:38
26905	9d68dd91-fb7d-4210-a3ee-17690f57c4c1	9d68dd92-1937-47ba-b02c-9257ec903286	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:19:54
26906	9d68dd92-1765-425e-813e-b4da1d5ea8f1	9d68dd92-1937-47ba-b02c-9257ec903286	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:19:54
26907	9d68dd92-1834-447b-84e2-225064226c6c	9d68dd92-1937-47ba-b02c-9257ec903286	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":360,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:19:54
27110	9d68e242-1d53-4e4c-9b0d-5ee8f7611030	9d68e242-6852-4db2-9807-3bd68c67f50d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 11:33:01
27111	9d68e242-64fd-4b24-a632-dc7663705e01	9d68e242-6852-4db2-9807-3bd68c67f50d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:33:01
27112	9d68e242-666b-4af3-aadf-adaef019b6c1	9d68e242-6852-4db2-9807-3bd68c67f50d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":669,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:33:01
27064	9d68e1b8-e8e4-4575-8dc9-3de71378a928	9d68e1b8-ed91-43ed-9c05-3a4e9e1fbe02	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1260}	2024-11-04 11:31:31
26908	9d68dd92-9526-4bd4-aa31-7f218f0733e3	9d68dd92-b5d9-4427-b11c-2c78ed3c1a38	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:19:55
27113	9d68e243-3a18-437c-b622-e5a6e2842681	9d68e243-6a4d-493c-9c04-2a5c3864f62d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:33:02
26909	9d68dd92-ad59-4f41-a795-ff72d99d9353	9d68dd92-b5d9-4427-b11c-2c78ed3c1a38	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"47.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:19:55
26910	9d68dd92-b0c7-44a3-a624-d0df3c343890	9d68dd92-b5d9-4427-b11c-2c78ed3c1a38	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:19:55
26911	9d68dd92-b111-4e8a-9feb-7582f9e73206	9d68dd92-b5d9-4427-b11c-2c78ed3c1a38	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:19:55
26912	9d68dd92-b4be-44c5-9866-6dd6cdd1f4c8	9d68dd92-b5d9-4427-b11c-2c78ed3c1a38	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:19:55
26913	9d68dd92-b511-4581-84c9-9deec6230429	9d68dd92-b5d9-4427-b11c-2c78ed3c1a38	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":361,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:19:55
27114	9d68e243-5b3e-4b8b-a828-1824c46b7286	9d68e243-6a4d-493c-9c04-2a5c3864f62d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"63.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:33:02
27115	9d68e243-6172-4990-8786-9566c7036e8b	9d68e243-6a4d-493c-9c04-2a5c3864f62d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"3.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:33:02
27116	9d68e243-61e3-4b50-a949-aa56aba2b4a9	9d68e243-6a4d-493c-9c04-2a5c3864f62d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:33:02
27117	9d68e243-6875-4b24-993c-c91cd70bca16	9d68e243-6a4d-493c-9c04-2a5c3864f62d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:33:02
27118	9d68e243-6900-418f-8671-0f948261da8d	9d68e243-6a4d-493c-9c04-2a5c3864f62d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":599,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:33:02
13111	9d5cf97d-4515-4eee-bd74-546fc80c4b29	9d5cf97d-a070-4316-b49f-b2b5cf9853f3	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 13:28:02
13112	9d5cf97d-9e05-4f67-8585-bf15dc9cd092	9d5cf97d-a070-4316-b49f-b2b5cf9853f3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 13:28:03
13113	9d5cf97d-9f0d-4add-bc56-2ed1557970f4	9d5cf97d-a070-4316-b49f-b2b5cf9853f3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":492,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:28:03
13114	9d5cf97e-1f46-4773-8e79-668277cda0a7	9d5cf97e-4fab-4924-9367-99d61022a737	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 13:28:03
13115	9d5cf97e-4048-4e36-bf05-4ff96c97f2b0	9d5cf97e-4fab-4924-9367-99d61022a737	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 30\\n                        ","time":"61.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"b9ae622c33dd7e7f0bc512338acf8ed0","hostname":"EderCortes"}	2024-10-29 13:28:03
13116	9d5cf97e-4645-408b-99f2-15a5ec4d215b	9d5cf97e-4fab-4924-9367-99d61022a737	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '30' order by \\"item_loans\\".\\"id\\" asc","time":"4.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 13:28:03
13117	9d5cf97e-468b-41fa-8d0d-e89dc831f2d7	9d5cf97e-4fab-4924-9367-99d61022a737	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-10-29 13:28:03
13118	9d5cf97e-4e48-4628-9109-58a28ade3f05	9d5cf97e-4fab-4924-9367-99d61022a737	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 13:28:03
13119	9d5cf97e-4eb0-498c-8d18-dc0532fbd1c8	9d5cf97e-4fab-4924-9367-99d61022a737	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/30","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":30,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":1000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":106,"loans_codigo":30,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":107,"loans_codigo":30,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":108,"loans_codigo":30,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":109,"loans_codigo":30,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":110,"loans_codigo":30,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":111,"loans_codigo":30,"itemloans_cuota":"6","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":112,"loans_codigo":30,"itemloans_cuota":"7","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":113,"loans_codigo":30,"itemloans_cuota":"8","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":114,"loans_codigo":30,"itemloans_cuota":"9","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":115,"loans_codigo":30,"itemloans_cuota":"10","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"0","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T18:26:20.000000Z","updated_at":"2024-10-29T18:26:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":407,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:28:03
27212	9d68e2f7-4550-4542-b454-54abacb4a8a7	9d68e2f7-681f-4cbf-aa5e-50ca004dfe03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:35:00
27213	9d68e2f7-664a-4088-a175-0c0553da30e4	9d68e2f7-681f-4cbf-aa5e-50ca004dfe03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:35:00
27214	9d68e2f7-6713-4671-b17c-3697888e0642	9d68e2f7-681f-4cbf-aa5e-50ca004dfe03	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":415,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:35:00
27215	9d68e2f7-f21b-48e0-9a62-6a7b8ee42ea5	9d68e2f8-14fd-4d75-ba67-684cf303a2c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:35:00
19974	9d66ec69-4d0a-4d88-bdb8-2823b4eb280c	9d66ec69-69b5-464f-baab-fbef8d5834b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:09:45
19975	9d66ec69-6827-4673-9b72-0e23eb9239a0	9d66ec69-69b5-464f-baab-fbef8d5834b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:09:45
19976	9d66ec69-68b9-4898-8809-bcff9eb68b99	9d66ec69-69b5-464f-baab-fbef8d5834b0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:09:45
27216	9d68e2f8-0a67-4c68-8a35-825c6d608602	9d68e2f8-14fd-4d75-ba67-684cf303a2c3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"47.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:35:00
27217	9d68e2f8-0e54-4a51-b5f7-ce25ab011b4e	9d68e2f8-14fd-4d75-ba67-684cf303a2c3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:35:00
27218	9d68e2f8-0e8c-4689-bd01-d92a94b34a68	9d68e2f8-14fd-4d75-ba67-684cf303a2c3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:35:00
27219	9d68e2f8-137c-4fc9-ae8d-2d997396e607	9d68e2f8-14fd-4d75-ba67-684cf303a2c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 11:35:00
27220	9d68e2f8-13ef-496f-912a-f6a04e4032cb	9d68e2f8-14fd-4d75-ba67-684cf303a2c3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":395,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:35:00
19866	9d66eb0d-48a6-4c09-9030-369f57831309	9d66eb0d-9ef7-4a5c-a5dd-16f044bb50e0	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 12:05:57
19867	9d66eb0d-9c13-450e-a317-df12272f5233	9d66eb0d-9ef7-4a5c-a5dd-16f044bb50e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:05:57
19868	9d66eb0d-9dbd-452c-994d-a806fcbdd460	9d66eb0d-9ef7-4a5c-a5dd-16f044bb50e0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":523,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:05:57
19977	9d66ec69-b20f-4173-915a-3941157e770b	9d66ec69-d096-4221-a479-ebf066b32709	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:09:45
19869	9d66eb0e-0cdb-412f-8b85-114a871f2a33	9d66eb0e-30a6-4971-9bdb-49db54467c1e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:05:57
19870	9d66eb0e-24e7-4c23-8910-c6341316400e	9d66eb0e-30a6-4971-9bdb-49db54467c1e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"44.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:05:57
19871	9d66eb0e-291f-4689-9c2c-b91905b13209	9d66eb0e-30a6-4971-9bdb-49db54467c1e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:05:57
19872	9d66eb0e-295c-4910-9bb3-eee7215bdbb3	9d66eb0e-30a6-4971-9bdb-49db54467c1e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:05:57
19873	9d66eb0e-2ee4-4b6a-b554-7dde1c9d3a78	9d66eb0e-30a6-4971-9bdb-49db54467c1e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:05:58
19874	9d66eb0e-2f65-45cf-ba48-e584d2a8780e	9d66eb0e-30a6-4971-9bdb-49db54467c1e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"200000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:37.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"0"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":327,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:05:58
19978	9d66ec69-c7ca-408a-ad8a-e08611c0af16	9d66ec69-d096-4221-a479-ebf066b32709	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"43.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:09:45
19979	9d66ec69-cbb5-48cc-84f7-9f58fc66c19b	9d66ec69-d096-4221-a479-ebf066b32709	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:09:45
19980	9d66ec69-cbef-4f81-aa4e-5d59fc0c8314	9d66ec69-d096-4221-a479-ebf066b32709	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:09:45
19981	9d66ec69-cf77-4c79-86a7-ed0e57d6cfa4	9d66ec69-d096-4221-a479-ebf066b32709	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:09:45
19875	9d66eb10-3e37-4696-bb16-d550363b6fd9	9d66eb10-6421-4e87-bfbd-5ca893809429	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:05:59
19876	9d66eb10-5ccb-46a7-aa7b-9e34cad253e9	9d66eb10-6421-4e87-bfbd-5ca893809429	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"54.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:05:59
19877	9d66eb10-5d32-443c-9132-9fe3a63a9ce6	9d66eb10-6421-4e87-bfbd-5ca893809429	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:05:59
19878	9d66eb10-6245-49f9-8a72-0559533efcee	9d66eb10-6421-4e87-bfbd-5ca893809429	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:05:59
19879	9d66eb10-62a2-4966-9405-9b9f563cb722	9d66eb10-6421-4e87-bfbd-5ca893809429	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":363,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:05:59
19982	9d66ec69-cfbc-4fa3-8b6b-9d0ea60cdf10	9d66ec69-d096-4221-a479-ebf066b32709	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":224,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:09:45
20059	9d66ede3-49e0-436c-bda0-c5e63b94be20	9d66ede3-6fb5-49ef-8c5c-42cf87243883	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:13:53
19880	9d66eb18-b743-49d4-bb3d-7a7b8060b664	9d66eb18-bafd-46ce-91e6-43bb6872e11a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":158,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:06:04
19983	9d66ec6b-7e12-4806-a667-c3528ccac465	9d66ec6b-d41b-4a56-9a68-889537c99ec9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:09:46
19984	9d66ec6b-cadf-4a8c-8601-ca7532eadd7d	9d66ec6b-d41b-4a56-9a68-889537c99ec9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"135.50","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:09:47
19985	9d66ec6b-cb67-4f0c-9178-000e33adcafb	9d66ec6b-d41b-4a56-9a68-889537c99ec9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:09:47
19986	9d66ec6b-d1eb-4897-b1ff-393f77a184b9	9d66ec6b-d41b-4a56-9a68-889537c99ec9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:09:47
19987	9d66ec6b-d267-445b-82f1-0c626f349dce	9d66ec6b-d41b-4a56-9a68-889537c99ec9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":497,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:09:47
20060	9d66ede3-6dd5-4a5c-b597-b27e8cee75cd	9d66ede3-6fb5-49ef-8c5c-42cf87243883	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:13:53
20061	9d66ede3-6e85-4b2d-a211-0b1f30296a00	9d66ede3-6fb5-49ef-8c5c-42cf87243883	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":298,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:13:53
27348	9d68e433-d173-40e2-8171-9340145d2f5d	9d68e433-f863-446d-b68a-1fb31d8a9f55	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 11:38:27
27349	9d68e433-f64b-49a4-b570-8c471bee35f7	9d68e433-f863-446d-b68a-1fb31d8a9f55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:38:27
19881	9d66eb19-69b6-4eec-a8e5-ccfb2eb7521e	9d66eb19-8899-4300-946d-085969d2b660	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:06:05
16974	9d654684-7ca3-4a4c-abb5-3357b8202515	9d654684-97e0-4266-842a-6f8b2172a495	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 16:30:03
16975	9d654684-9634-4a8f-b68d-20e11a8658ff	9d654684-97e0-4266-842a-6f8b2172a495	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 16:30:03
16976	9d654684-96d0-45aa-9d89-3ccc19188cb9	9d654684-97e0-4266-842a-6f8b2172a495	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42P01]: Undefined table: 7 ERROR:  referencia a la entrada de la cl\\u00e1usula FROM para la tabla \\u00abloans\\u00bb no v\\u00e1lida\\nLINE 1: ...rom \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"loans\\".\\"u...\\n                                                             ^\\nHINT:  Probablemente quiera hacer referencia al alias de la tabla \\u00abl\\u00bb. (Connection: pgsql, SQL: select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"loans\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"loans\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"loans\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id \\" desc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":42,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:30:03
19882	9d66eb19-801f-4e2c-90dd-dad2bd57c7ba	9d66eb19-8899-4300-946d-085969d2b660	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 184 limit 1","time":"2.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-03 12:06:05
19883	9d66eb19-8069-4034-846f-ced55ff3c9a8	9d66eb19-8899-4300-946d-085969d2b660	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-03 12:06:05
19884	9d66eb19-81e5-46b2-8f57-9329c0fbba37	9d66eb19-8899-4300-946d-085969d2b660	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 61 limit 1","time":"1.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 12:06:05
19885	9d66eb19-8215-4e52-9532-ba15620051b9	9d66eb19-8899-4300-946d-085969d2b660	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 12:06:05
19886	9d66eb19-8359-452d-a3e3-6ef8735ceb98	9d66eb19-8899-4300-946d-085969d2b660	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '03-11-2024', \\"itemloans_cuota_cancelada\\" = '100000', \\"updated_at\\" = '2024-11-03 12:06:05' where \\"id\\" = 184","time":"1.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":394,"hash":"35b67f849e4a0ba5090d9c1eb8abfe94","hostname":"EderCortes"}	2024-11-03 12:06:05
19887	9d66eb19-83b0-4dc0-8195-24af551260f9	9d66eb19-8899-4300-946d-085969d2b660	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:184","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-03 12:06:05","item_loans_cuando_pago":"03-11-2024","itemloans_cuota_cancelada":"100000"},"hostname":"EderCortes"}	2024-11-03 12:06:05
19888	9d66eb19-8450-4387-80c0-7542b1058d59	9d66eb19-8899-4300-946d-085969d2b660	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_prestado\\" = 300000, \\"updated_at\\" = '2024-11-03 12:06:05' where \\"id\\" = 61","time":"0.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":402,"hash":"4f19d69da2d9a6a5193ed1537b66ca88","hostname":"EderCortes"}	2024-11-03 12:06:05
19889	9d66eb19-8482-49ac-b0d6-217e1a744bb6	9d66eb19-8899-4300-946d-085969d2b660	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:61","changes":{"updated_at":"2024-11-03 12:06:05","loans_pago_prestado":300000},"hostname":"EderCortes"}	2024-11-03 12:06:05
19890	9d66eb19-876f-403d-90d1-0f9c295e6e0d	9d66eb19-8899-4300-946d-085969d2b660	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:06:05
19891	9d66eb19-87af-4ece-b679-d19680752970	9d66eb19-8899-4300-946d-085969d2b660	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"179","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000","id":184,"loans_codigo":61,"itemloans_cuota":"3","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":222,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:06:05
20062	9d66ede3-bef9-4c29-81b8-7d0eea7091bc	9d66ede4-052a-4c9f-ae9e-ef16af868aea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:13:53
20063	9d66ede3-fc32-41e5-85fb-9db1d9875d61	9d66ede4-052a-4c9f-ae9e-ef16af868aea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"141.04","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:13:53
20064	9d66ede4-0003-4675-841e-4b4e93de6308	9d66ede4-052a-4c9f-ae9e-ef16af868aea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:13:53
20065	9d66ede4-0031-477f-a895-50c945dcba59	9d66ede4-052a-4c9f-ae9e-ef16af868aea	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:13:53
20066	9d66ede4-0404-4223-b3a4-a4de8d778c9e	9d66ede4-052a-4c9f-ae9e-ef16af868aea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 12:13:53
27350	9d68e433-f71d-4c71-aacd-bd90888657d8	9d68e433-f863-446d-b68a-1fb31d8a9f55	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":425,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:38:27
16977	9d654685-f1cb-40a8-9ca8-043cbb049434	9d654686-10d7-4c94-aec3-d4a0ff31829b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 16:30:04
16978	9d654686-0ae5-4626-b27c-72a86469f1b2	9d654686-10d7-4c94-aec3-d4a0ff31829b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 16:30:04
16979	9d654686-0b41-4867-812a-f87ea63ba7eb	9d654686-10d7-4c94-aec3-d4a0ff31829b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 16:30:04
16980	9d654686-0ee0-48e3-acb4-fe7d59e9e765	9d654686-10d7-4c94-aec3-d4a0ff31829b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-02 16:30:04
16911	9d64dfa7-03c4-4dd6-beb7-1070662775ce	9d64dfa7-328a-4484-adbb-570d4077798e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 11:42:25
16912	9d64dfa7-2f9f-4362-b9fa-bd1d4ac03849	9d64dfa7-328a-4484-adbb-570d4077798e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 11:42:25
16913	9d64dfa7-30fc-490c-b6cd-b19f5e783bdb	9d64dfa7-328a-4484-adbb-570d4077798e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":442,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:42:25
16981	9d654686-0f70-4478-acd9-481a9d1e4b8b	9d654686-10d7-4c94-aec3-d4a0ff31829b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":351,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:30:04
19892	9d66eb19-d5bc-4c0d-9119-924aa534261e	9d66eb19-f510-43ca-9482-97d8fc0a13eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:06:05
19893	9d66eb19-ec0b-4c0e-bff3-07e263fdbd88	9d66eb19-f510-43ca-9482-97d8fc0a13eb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"44.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:06:05
19894	9d66eb19-efde-4bc7-8be5-ad3a17b791ed	9d66eb19-f510-43ca-9482-97d8fc0a13eb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:06:05
19895	9d66eb19-f00e-4913-8e8d-397dae7a311e	9d66eb19-f510-43ca-9482-97d8fc0a13eb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:06:05
19896	9d66eb19-f3bc-42be-addd-264bf46ded61	9d66eb19-f510-43ca-9482-97d8fc0a13eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:06:05
19897	9d66eb19-f41c-4fb2-8895-281f8b92e20a	9d66eb19-f510-43ca-9482-97d8fc0a13eb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:06:05
27351	9d68e434-915c-456a-ba4e-7faebcec412e	9d68e434-b127-4477-b176-fcf4cd7f6327	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:38:28
16914	9d64dfa7-b5e3-47b2-a15a-1092a01b9f67	9d64dfa8-0031-4132-93de-abe7fcf0d574	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 11:42:26
16915	9d64dfa7-f9a2-44ca-b019-8ec1a9ff0a28	9d64dfa8-0031-4132-93de-abe7fcf0d574	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"156.38","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":26,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-11-02 11:42:26
16916	9d64dfa7-fec8-4541-99f5-353e1de16344	9d64dfa8-0031-4132-93de-abe7fcf0d574	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 11:42:26
16917	9d64dfa7-ff31-4064-ac8f-c280a896c375	9d64dfa8-0031-4132-93de-abe7fcf0d574	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":463,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:42:26
20067	9d66ede4-044b-4c9a-a1ad-db059c181ae5	9d66ede4-052a-4c9f-ae9e-ef16af868aea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":338,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:13:53
27352	9d68e434-a6ef-456e-bf4a-d402777ab59d	9d68e434-b127-4477-b176-fcf4cd7f6327	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"43.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:38:28
27353	9d68e434-ab09-4240-83b9-820b567e2ea0	9d68e434-b127-4477-b176-fcf4cd7f6327	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:38:28
27354	9d68e434-ab43-4a1c-8e0d-be9eac571f0d	9d68e434-b127-4477-b176-fcf4cd7f6327	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:38:28
27355	9d68e434-afbc-4ad3-bb85-3d7caa51638c	9d68e434-b127-4477-b176-fcf4cd7f6327	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:38:28
16918	9d64dfaa-42d7-4f12-8766-424397509657	9d64dfaa-8c78-486e-9169-78083c3e65a0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 11:42:27
16919	9d64dfaa-86d2-46d0-a235-f863886ed052	9d64dfaa-8c78-486e-9169-78083c3e65a0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"147.47","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 11:42:27
16920	9d64dfaa-873a-461b-9358-d2b09a23450a	9d64dfaa-8c78-486e-9169-78083c3e65a0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 11:42:27
16921	9d64dfaa-8b1d-4d3c-95e9-8e0e4d13294d	9d64dfaa-8c78-486e-9169-78083c3e65a0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 11:42:27
16922	9d64dfaa-8b73-4a4f-88d3-1a6c0d6c8ef5	9d64dfaa-8c78-486e-9169-78083c3e65a0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":488,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:42:27
20068	9d66ede5-ce99-44c6-9069-4335ec8dd546	9d66ede6-06f1-4c0c-9d71-89e704e6a3c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 12:13:54
20069	9d66ede5-fd17-4c95-b45d-dd05e688eaa7	9d66ede6-06f1-4c0c-9d71-89e704e6a3c8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"78.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:13:54
20070	9d66ede5-fdc6-4b0c-89e7-7f6624ee84f2	9d66ede6-06f1-4c0c-9d71-89e704e6a3c8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:13:54
20071	9d66ede6-0536-48cd-b798-979e7010f80c	9d66ede6-06f1-4c0c-9d71-89e704e6a3c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 12:13:54
20072	9d66ede6-05ba-40e2-a7ee-f7f7c114d0d0	9d66ede6-06f1-4c0c-9d71-89e704e6a3c8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":552,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:13:54
27356	9d68e434-b00c-4be7-ade6-c04a5d8e27d5	9d68e434-b127-4477-b176-fcf4cd7f6327	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":428,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:38:28
16923	9d654093-6b88-4cfa-9c5e-065aa5435c67	9d654093-7661-4d17-be72-d68e5e14b435	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":200,"memory":18,"hostname":"EderCortes"}	2024-11-02 16:13:26
20149	9d66eed5-c5e9-4782-bbec-9e453135eac4	9d66eed5-e9b3-4c33-8fab-e9090aa4f65e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 12:16:32
20150	9d66eed5-e7d6-4f1e-9fad-0552683faff6	9d66eed5-e9b3-4c33-8fab-e9090aa4f65e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:16:32
20151	9d66eed5-e893-4670-8279-c367e6b14ebc	9d66eed5-e9b3-4c33-8fab-e9090aa4f65e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:16:32
27503	9d68e793-0ed0-4a78-a2e5-6bf264ee1426	9d68e793-38ff-41cc-ab4c-a3d7ad1c8689	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 11:47:53
27504	9d68e793-35f6-485d-a682-f9ecc0bdbb76	9d68e793-38ff-41cc-ab4c-a3d7ad1c8689	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:47:53
27505	9d68e793-3785-4900-9676-f9fb879e5a34	9d68e793-38ff-41cc-ab4c-a3d7ad1c8689	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":499,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:47:53
27506	9d68e793-dbc4-49ff-bbaf-23b6a88ebbe8	9d68e794-00f5-4f2c-98a9-fa4ac6040b57	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:47:53
11571	9d5ccaf5-1b08-4c76-b900-c4fa972a07e9	9d5ccaf5-38e9-407f-971b-1aef0df39aff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 11:17:56
11572	9d5ccaf5-374d-4e2c-8cc5-f230408271b1	9d5ccaf5-38e9-407f-971b-1aef0df39aff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 11:17:56
11573	9d5ccaf5-37e9-4393-8553-c22f6f43ff71	9d5ccaf5-38e9-407f-971b-1aef0df39aff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":277,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:17:56
27507	9d68e793-f561-4933-b013-fdef74f190e8	9d68e794-00f5-4f2c-98a9-fa4ac6040b57	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"51.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:47:53
27508	9d68e793-fa21-40b6-a907-d93b1840376e	9d68e794-00f5-4f2c-98a9-fa4ac6040b57	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:47:53
27509	9d68e793-fa61-4ff8-be7f-37c45bd5329a	9d68e794-00f5-4f2c-98a9-fa4ac6040b57	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:47:53
27510	9d68e793-ff8e-4134-a531-f3000e250b9e	9d68e794-00f5-4f2c-98a9-fa4ac6040b57	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:47:53
11574	9d5ccaf5-8db2-4931-b66f-60fe54ebae69	9d5ccaf5-b181-495a-8682-c663a6800d2e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 11:17:56
11575	9d5ccaf5-ab48-44e5-b41d-47c4b27c71df	9d5ccaf5-b181-495a-8682-c663a6800d2e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":176,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 11:17:56
11576	9d5ccaf5-ab94-45bd-9764-14362cde1558	9d5ccaf5-b181-495a-8682-c663a6800d2e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 11:17:56
11577	9d5ccaf5-b00f-4506-9689-825229cb4dc7	9d5ccaf5-b181-495a-8682-c663a6800d2e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 11:17:56
11578	9d5ccaf5-b071-4713-8e1e-aaff85d94a6e	9d5ccaf5-b181-495a-8682-c663a6800d2e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":268,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:17:56
16924	9d654093-ef1a-4119-9507-cae8dcea1df4	9d654095-efd9-44ca-b841-daf0618a603b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 16:13:26
16925	9d654095-b393-4dc5-a832-0d332374ab00	9d654095-efd9-44ca-b841-daf0618a603b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"48.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-02 16:13:28
16926	9d654095-b3f4-4a84-825b-99891336db7c	9d654095-efd9-44ca-b841-daf0618a603b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-02 16:13:28
16927	9d654095-ee6e-4ca8-9fd1-a87e30259b40	9d654095-efd9-44ca-b841-daf0618a603b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:13:28
16928	9d654095-eed7-45bb-87e0-2eefea584c39	9d654095-efd9-44ca-b841-daf0618a603b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","profile":1},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":1528,"memory":24,"hostname":"EderCortes"}	2024-11-02 16:13:28
20152	9d66eed6-4a55-433a-9db8-d3f417ead3f7	9d66eed6-68aa-464a-ab86-fe8bbae1ccb2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:16:32
20153	9d66eed6-5f9f-4d70-be68-7aba73233a3d	9d66eed6-68aa-464a-ab86-fe8bbae1ccb2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"42.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:16:32
20154	9d66eed6-633e-4a69-869a-9e5d8f31b212	9d66eed6-68aa-464a-ab86-fe8bbae1ccb2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:16:32
20155	9d66eed6-636d-47df-844f-5194459d9fa3	9d66eed6-68aa-464a-ab86-fe8bbae1ccb2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:16:32
20156	9d66eed6-6758-4af6-a4ce-0ec22cfb9c33	9d66eed6-68aa-464a-ab86-fe8bbae1ccb2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:16:32
11579	9d5ccaf5-f70d-48d1-b705-aa3a16800e6d	9d5ccaf6-409a-4b4a-a98f-3201a8fc223f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 11:17:56
11580	9d5ccaf6-3b7b-4658-98f4-80cb1403ff95	9d5ccaf6-409a-4b4a-a98f-3201a8fc223f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"152.84","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":176,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 11:17:56
11581	9d5ccaf6-3be2-402b-ba9a-447f50f5cec9	9d5ccaf6-409a-4b4a-a98f-3201a8fc223f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 11:17:56
11582	9d5ccaf6-3f84-4a43-8ba0-ec6b3cc6ceb0	9d5ccaf6-409a-4b4a-a98f-3201a8fc223f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 11:17:56
11583	9d5ccaf6-3fc9-45df-82d8-a071b959cca3	9d5ccaf6-409a-4b4a-a98f-3201a8fc223f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":351,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:17:56
16929	9d654096-ddee-4907-b59b-1ab24efa3c3a	9d654096-fd11-46fe-86b7-a7bf09b24086	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:13:28
16930	9d654096-f842-49d2-8fff-73b75b4092d5	9d654096-fd11-46fe-86b7-a7bf09b24086	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"46.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 16:13:28
16931	9d654096-f88c-4d0a-82ba-4ff37690ee0f	9d654096-fd11-46fe-86b7-a7bf09b24086	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 16:13:28
16932	9d654096-fbce-470b-bd68-fb014b952e21	9d654096-fd11-46fe-86b7-a7bf09b24086	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 16:13:28
16933	9d654096-fc32-48ea-9489-3e7f02dff775	9d654096-fd11-46fe-86b7-a7bf09b24086	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":268,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:13:28
20157	9d66eed6-67b5-45d8-8475-c9c3f90226bd	9d66eed6-68aa-464a-ab86-fe8bbae1ccb2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":272,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:16:32
27511	9d68e793-ffeb-41a2-9359-69b9ddb5f87d	9d68e794-00f5-4f2c-98a9-fa4ac6040b57	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":458,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:47:53
11584	9d5ccaf8-1ed0-4b09-aca5-bee766a20ca7	9d5ccaf8-45d5-4b9d-a930-4cc82e02b0a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 11:17:58
11585	9d5ccaf8-4004-4df3-bf7c-f72e539304a5	9d5ccaf8-45d5-4b9d-a930-4cc82e02b0a1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"48.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 11:17:58
11586	9d5ccaf8-4065-4940-bd8c-d15565c312d3	9d5ccaf8-45d5-4b9d-a930-4cc82e02b0a1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 11:17:58
11587	9d5ccaf8-447f-425a-ae3d-240201803848	9d5ccaf8-45d5-4b9d-a930-4cc82e02b0a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 11:17:58
11588	9d5ccaf8-44c8-47a7-9682-f346eb203d27	9d5ccaf8-45d5-4b9d-a930-4cc82e02b0a1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":440,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:17:58
16934	9d6540fa-5ca7-4961-bcbb-9582657a7934	9d6540fa-866e-4a1a-aee6-789eabccd344	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 16:14:34
16935	9d6540fa-7d7e-4805-bd21-2c4b47e183a2	9d6540fa-866e-4a1a-aee6-789eabccd344	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"51.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":26,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-11-02 16:14:34
16936	9d6540fa-8412-437a-93e8-f7ee30d51518	9d6540fa-866e-4a1a-aee6-789eabccd344	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:14:34
16937	9d6540fa-84c0-4abd-8f8c-69457256e16a	9d6540fa-866e-4a1a-aee6-789eabccd344	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:14:34
20158	9d66eed7-f32a-46aa-8d01-89f30662bbe3	9d66eed8-1bf1-48f1-b7cc-14623a5cae30	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:16:33
20159	9d66eed8-1348-4138-96fb-63b00199fc57	9d66eed8-1bf1-48f1-b7cc-14623a5cae30	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"51.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:16:33
20160	9d66eed8-13c4-4fff-ba62-7c22fc5e8399	9d66eed8-1bf1-48f1-b7cc-14623a5cae30	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:16:33
20161	9d66eed8-1a46-4253-8b6f-ca0c932ac66b	9d66eed8-1bf1-48f1-b7cc-14623a5cae30	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:16:33
16938	9d6540fd-e49e-4b3d-8848-7d2a0a6056ec	9d6540fe-2fd2-4d3e-94bf-d6c0182ef144	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:14:36
16939	9d6540fe-26ba-4345-ba68-c9268acfacac	9d6540fe-2fd2-4d3e-94bf-d6c0182ef144	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"154.49","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":242,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 16:14:36
16940	9d6540fe-2b13-4682-8953-373ae9ce63d1	9d6540fe-2fd2-4d3e-94bf-d6c0182ef144	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":271,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 16:14:36
16941	9d6540fe-2b50-444c-aa63-d4fd02a2803c	9d6540fe-2fd2-4d3e-94bf-d6c0182ef144	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 16:14:36
16942	9d6540fe-2ec6-46f3-8919-6dca14486cb2	9d6540fe-2fd2-4d3e-94bf-d6c0182ef144	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 16:14:36
16943	9d6540fe-2f0b-48f2-9bea-35dbc2351939	9d6540fe-2fd2-4d3e-94bf-d6c0182ef144	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:34:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"}]}},"duration":395,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:14:36
20162	9d66eed8-1ab7-4731-b867-282f99005002	9d66eed8-1bf1-48f1-b7cc-14623a5cae30	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":353,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:16:33
16944	9d654652-1b6c-4ae0-b9d3-d87506205729	9d654652-4053-44e2-8107-e71a79daccb4	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 16:29:30
16945	9d654652-3ab7-44ed-b791-4ec3ee85ad38	9d654652-4053-44e2-8107-e71a79daccb4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"44.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-02 16:29:30
16946	9d654652-3ec0-472e-89b3-81d362fde98a	9d654652-4053-44e2-8107-e71a79daccb4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:29:30
16947	9d654652-3f29-4d71-bd4a-794eb596c505	9d654652-4053-44e2-8107-e71a79daccb4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":334,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:29:30
27811	9d68ea06-73b6-4471-9ee1-92ceeb47ab1e	9d68ea06-aa1c-4027-92bc-e62a5d4e813a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 11:54:44
27812	9d68ea06-a80b-448c-9bd5-1bf969824c24	9d68ea06-aa1c-4027-92bc-e62a5d4e813a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:54:44
27813	9d68ea06-a8ff-4967-a3d6-59fd36a68d68	9d68ea06-aa1c-4027-92bc-e62a5d4e813a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":477,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:54:44
15140	9d5ecf14-4720-473b-b3aa-30ba1bc507c3	9d5ecf14-66c6-4bb9-845e-ad43096f33bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-30 11:21:07
15141	9d5ecf14-6530-46a8-bf17-46a594a3dce1	9d5ecf14-66c6-4bb9-845e-ad43096f33bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-30 11:21:07
15142	9d5ecf14-65cb-4e25-ab1d-3a6f07684932	9d5ecf14-66c6-4bb9-845e-ad43096f33bd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":320,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:21:07
15143	9d5ecf14-aca4-477e-b3d4-4ba0e65255fc	9d5ecf14-f68d-40cb-b767-111fda24f8b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-30 11:21:07
15144	9d5ecf14-f0b6-4978-94ea-ac7c7801a2a7	9d5ecf14-f68d-40cb-b767-111fda24f8b5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"153.15","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 11:21:07
15145	9d5ecf14-f120-4e65-bf8d-e3cf6d69ec5b	9d5ecf14-f68d-40cb-b767-111fda24f8b5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-30 11:21:07
15146	9d5ecf14-f55a-4767-bcaf-cc7803129d0b	9d5ecf14-f68d-40cb-b767-111fda24f8b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-30 11:21:07
15147	9d5ecf14-f59e-4b91-931d-279ae744a73b	9d5ecf14-f68d-40cb-b767-111fda24f8b5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:21:07
20257	9d66f0d1-b3d4-47fc-8fc4-bea6634e1f68	9d66f0d1-d66b-4ac3-bc0c-2b5a9bce3347	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:22:05
20258	9d66f0d1-d49e-4eab-b963-3a1feafb4408	9d66f0d1-d66b-4ac3-bc0c-2b5a9bce3347	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:22:05
20259	9d66f0d1-d569-4d3c-96f6-805b4f206075	9d66f0d1-d66b-4ac3-bc0c-2b5a9bce3347	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:22:05
17034	9d654745-7def-45cb-8404-f427f06644d6	9d654745-c16f-4ccb-8168-c34f21fb817c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 16:32:09
27814	9d68ea07-5ae3-4218-a282-45cc6ce19a8f	9d68ea07-ab61-407e-8854-97edcdf9a1e2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:54:45
27667	9d68e91d-0e6f-40c6-8084-926bd0503bef	9d68e91d-3762-46e5-bd40-ebc5f0800ab5	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 11:52:11
27668	9d68e91d-3471-483e-9d8f-ac64ee56efde	9d68e91d-3762-46e5-bd40-ebc5f0800ab5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:52:11
27669	9d68e91d-359d-4895-8339-d8a35b0e88b1	9d68e91d-3762-46e5-bd40-ebc5f0800ab5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":438,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:52:11
27815	9d68ea07-a0e6-4b4b-9105-0e6c8514b02a	9d68ea07-ab61-407e-8854-97edcdf9a1e2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"151.87","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:54:45
27816	9d68ea07-a553-4f3c-b618-2b3a9b00f60a	9d68ea07-ab61-407e-8854-97edcdf9a1e2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:54:45
27817	9d68ea07-a596-455d-a1f2-eb00e9435990	9d68ea07-ab61-407e-8854-97edcdf9a1e2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:54:45
27818	9d68ea07-a9cd-474c-9927-0d09d196e2cd	9d68ea07-ab61-407e-8854-97edcdf9a1e2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:54:45
27819	9d68ea07-aa1f-46f7-9514-bda370255d3f	9d68ea07-ab61-407e-8854-97edcdf9a1e2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":605,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:54:45
15148	9d5ecf15-4535-4161-92f6-14492ddff0ea	9d5ecf15-679a-4978-9c38-7631d9c37534	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-30 11:21:07
15149	9d5ecf15-61d0-40f4-a107-0f9a5620479d	9d5ecf15-679a-4978-9c38-7631d9c37534	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 11:21:07
15150	9d5ecf15-623b-41ce-b8eb-1a5d173ec4e6	9d5ecf15-679a-4978-9c38-7631d9c37534	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-30 11:21:07
15151	9d5ecf15-666f-4798-8ce6-a760b6b0ee1b	9d5ecf15-679a-4978-9c38-7631d9c37534	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-30 11:21:07
15152	9d5ecf15-66bc-4172-9a17-39b46633eb0f	9d5ecf15-679a-4978-9c38-7631d9c37534	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":271,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:21:07
17035	9d654745-bfc7-4729-a3e9-f46781965649	9d654745-c16f-4ccb-8168-c34f21fb817c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 16:32:10
17036	9d654745-c056-4283-8e65-0410a2fde4bb	9d654745-c16f-4ccb-8168-c34f21fb817c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna l.id \\nLINE 1: ...on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id \\" ...\\n                                                             ^\\nHINT:  Probablemente quiera hacer referencia a la columna \\u00abl.id\\u00bb. (Connection: pgsql, SQL: select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id \\" desc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":42,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":324,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:32:10
20260	9d66f0d2-2732-47dc-bc60-248637d7a655	9d66f0d2-72a8-41b8-9ae3-6d231bf25e55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:22:05
20261	9d66f0d2-66d1-436a-8c35-acd8e06360bc	9d66f0d2-72a8-41b8-9ae3-6d231bf25e55	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"146.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:22:05
20262	9d66f0d2-6baa-43dd-afc3-004521319a14	9d66f0d2-72a8-41b8-9ae3-6d231bf25e55	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:22:05
20263	9d66f0d2-6be8-4223-8f00-676981caa132	9d66f0d2-72a8-41b8-9ae3-6d231bf25e55	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:22:05
20264	9d66f0d2-7155-4b42-ada2-98fa0c9403e6	9d66f0d2-72a8-41b8-9ae3-6d231bf25e55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:22:05
20265	9d66f0d2-71b5-40c2-9e4c-e0f93c5aaf38	9d66f0d2-72a8-41b8-9ae3-6d231bf25e55	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:22:05
27670	9d68e91d-d7e4-4527-b45e-7d8c390b6c71	9d68e91d-fc8b-4fb5-b152-345f7231f9a0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:52:12
20266	9d66f0d3-cd30-4d56-ae7b-40bf6bebc482	9d66f0d3-fb44-4ec7-aea8-c5482b3b6f07	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:22:06
20267	9d66f0d3-f404-4e09-92d9-9b795835ed0a	9d66f0d3-fb44-4ec7-aea8-c5482b3b6f07	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"64.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:22:06
20268	9d66f0d3-f46d-416f-bb77-32bc11be6205	9d66f0d3-fb44-4ec7-aea8-c5482b3b6f07	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:22:06
20269	9d66f0d3-f9a4-4e63-9d7e-8587f3ae73f3	9d66f0d3-fb44-4ec7-aea8-c5482b3b6f07	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:22:06
10959	9d5ca6dd-e4d2-4e7d-a843-1ab18a135ba2	9d5ca6de-0266-4bcf-939e-06e4e37bf6b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 09:37:01
10960	9d5ca6de-007b-4d67-af42-988e5a724664	9d5ca6de-0266-4bcf-939e-06e4e37bf6b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 09:37:01
10961	9d5ca6de-0123-4f62-896c-8798b366e31b	9d5ca6de-0266-4bcf-939e-06e4e37bf6b9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-10-29 09:37:01
20270	9d66f0d3-fa0b-4608-b819-fc197fec9ffb	9d66f0d3-fb44-4ec7-aea8-c5482b3b6f07	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":457,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:22:06
27671	9d68e91d-f0fd-49ac-8035-ed7fbe3318f5	9d68e91d-fc8b-4fb5-b152-345f7231f9a0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"46.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:52:12
27672	9d68e91d-f562-425b-b874-32c846c2d6a3	9d68e91d-fc8b-4fb5-b152-345f7231f9a0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:52:12
27673	9d68e91d-f59f-4e74-91ad-6edf146be7e2	9d68e91d-fc8b-4fb5-b152-345f7231f9a0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:52:12
27674	9d68e91d-fb01-4c0a-8f38-23063890992e	9d68e91d-fc8b-4fb5-b152-345f7231f9a0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:52:12
27675	9d68e91d-fb6d-4c27-a1de-1953bde71d30	9d68e91d-fc8b-4fb5-b152-345f7231f9a0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":457,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:52:12
17094	9d654ab8-634e-420b-b6f7-f41e1d9cff2c	9d654abc-4913-4c78-8287-26bd6481a4e6	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 16:41:49
17095	9d654abb-fc5d-4359-82bf-70d3c601262f	9d654abc-4913-4c78-8287-26bd6481a4e6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:41:50
17096	9d654abc-1c3c-4185-8b99-7a711395b2bc	9d654abc-4913-4c78-8287-26bd6481a4e6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":15670,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:41:50
28170	9d68ff1b-81f9-44f0-85b1-ebff1d089aed	9d68ff1b-a694-47b4-a627-9dcb49dbc81c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 12:53:41
28047	9d68eb61-1312-45d0-8587-6298feb2f977	9d68eb61-3900-456d-a29b-896ec75733f1	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 11:58:31
28048	9d68eb61-3717-46eb-b85a-142b153f1c4a	9d68eb61-3900-456d-a29b-896ec75733f1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:58:31
28049	9d68eb61-37d6-434d-8645-4601af5bd1be	9d68eb61-3900-456d-a29b-896ec75733f1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":411,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:58:31
28171	9d68ff1b-a4c1-45a3-ad3f-4d5e59fad26f	9d68ff1b-a694-47b4-a627-9dcb49dbc81c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 12:53:41
28172	9d68ff1b-a571-4f0d-bb32-d63ba3598db8	9d68ff1b-a694-47b4-a627-9dcb49dbc81c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":469,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:53:41
17097	9d654abc-ea09-494c-bfb7-ee9c0349a303	9d654abd-fa0d-4413-b700-d77ae172b4e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:41:51
17098	9d654abd-0b08-4ae7-ac0a-d2802d13768b	9d654abd-fa0d-4413-b700-d77ae172b4e5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select ('2024-11-02'::date - l.loans_fecha_ultimo_pago::date) as dis_restantes, \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"40.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":32,"hash":"b26a1a11ff63295839d34fb5fb0c691f","hostname":"EderCortes"}	2024-11-02 16:41:51
17099	9d654abd-f7df-4df4-afe8-b427a58617eb	9d654abd-fa0d-4413-b700-d77ae172b4e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 16:41:52
17100	9d654abd-f873-4e89-996a-bd005b7e1e11	9d654abd-fa0d-4413-b700-d77ae172b4e5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dis_restantes":31,"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":1009,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:41:52
15044	9d5ece89-f896-4a28-a4aa-6dfdb132883d	9d5ece8a-3d6f-4328-8b04-1fe8c042bd6e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-30 11:19:36
15045	9d5ece8a-3bd3-4dd6-8ce6-d273a2fd1147	9d5ece8a-3d6f-4328-8b04-1fe8c042bd6e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-30 11:19:36
15046	9d5ece8a-3c6b-4395-8b98-6739cbc8deec	9d5ece8a-3d6f-4328-8b04-1fe8c042bd6e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":387,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:19:36
20362	9d66f1a7-4585-4ef2-b109-46c83082ba69	9d66f1a7-629d-48ac-a7bc-a8af33d2628a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:24:24
20363	9d66f1a7-611c-420c-ba17-056182048f52	9d66f1a7-629d-48ac-a7bc-a8af33d2628a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:24:25
20364	9d66f1a7-61b2-420a-968d-5a381aa7d5e8	9d66f1a7-629d-48ac-a7bc-a8af33d2628a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:24:25
27934	9d68ea7c-e37e-4807-b7fd-b1c99c65c961	9d68ea7d-096d-40a1-9049-e83673310524	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 11:56:02
27935	9d68ea7d-071e-4f5c-bdb7-5f9bfa500990	9d68ea7d-096d-40a1-9049-e83673310524	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:56:02
27936	9d68ea7d-082a-4b03-bf65-53231320a1bc	9d68ea7d-096d-40a1-9049-e83673310524	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":417,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:56:02
28050	9d68eb61-c34e-4d8b-bb04-d112ed7b3a74	9d68eb61-e396-4a48-b501-e0285c9f5df9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:58:32
28173	9d68ff1c-30e6-4b2f-94ff-25893481e724	9d68ff1c-5114-44cc-94f0-77520262581f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 12:53:41
15047	9d5ece8a-8d0e-4b7a-bb8a-197d88ca5889	9d5ece8a-d554-44be-bfbd-a2d57a26cf12	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-30 11:19:36
15048	9d5ece8a-cb25-4584-8540-ecf827641636	9d5ece8a-d554-44be-bfbd-a2d57a26cf12	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"146.89","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"088d1fdbe045a08c3b0073ef22c7da32","hostname":"EderCortes"}	2024-10-30 11:19:36
15049	9d5ece8a-cedd-4636-850f-06424f79c182	9d5ece8a-d554-44be-bfbd-a2d57a26cf12	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-30 11:19:36
15050	9d5ece8a-cf11-4814-80d5-2cb2bfd90056	9d5ece8a-d554-44be-bfbd-a2d57a26cf12	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-10-30 11:19:36
15051	9d5ece8a-d3f3-4d20-bfe7-f47b9c1f97c8	9d5ece8a-d554-44be-bfbd-a2d57a26cf12	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-30 11:19:36
15052	9d5ece8a-d45e-4e0c-8704-ea5fa31cba86	9d5ece8a-d554-44be-bfbd-a2d57a26cf12	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":352,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:19:36
17101	9d654ac0-1745-4a56-8cfd-99fba49485c8	9d654ac0-4be6-4a8a-b495-1892375f9bad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 16:41:53
17102	9d654ac0-2f3c-4c26-b26a-dbae3a6a921b	9d654ac0-4be6-4a8a-b495-1892375f9bad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 16:41:53
17103	9d654ac0-2f9b-4cb0-b650-b6cfc3bed38b	9d654ac0-4be6-4a8a-b495-1892375f9bad	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 16:41:53
17104	9d654ac0-4a45-41b0-a534-4749a3ab2426	9d654ac0-4be6-4a8a-b495-1892375f9bad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 16:41:53
17105	9d654ac0-4ab0-4976-a112-3e0b9f9846d2	9d654ac0-4be6-4a8a-b495-1892375f9bad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":289,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:41:53
20365	9d66f1a7-acb7-46f3-8c53-97c6ba45af57	9d66f1a7-cb62-41b8-aefc-900367ccf05e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:24:25
27937	9d68ea7d-9d19-4a0a-9ef7-f83c8321b682	9d68ea7d-e7d2-4c9e-8e39-034a90b19bfb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:56:02
28174	9d68ff1c-4b0c-482d-bf69-9c9dc25bb9ef	9d68ff1c-5114-44cc-94f0-77520262581f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 12:53:42
28175	9d68ff1c-4b5b-44d3-a1e3-d823a06708c5	9d68ff1c-5114-44cc-94f0-77520262581f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 12:53:42
28176	9d68ff1c-5012-4f60-82cb-c9da9af67e11	9d68ff1c-5114-44cc-94f0-77520262581f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 12:53:42
20366	9d66f1a7-c2d3-42b8-bc20-3217ec05d6a2	9d66f1a7-cb62-41b8-aefc-900367ccf05e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"43.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:24:25
20367	9d66f1a7-c637-44c1-9ebc-49fcad6cd26b	9d66f1a7-cb62-41b8-aefc-900367ccf05e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:24:25
20368	9d66f1a7-c66e-491d-a0db-beb7ef880c61	9d66f1a7-cb62-41b8-aefc-900367ccf05e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:24:25
20369	9d66f1a7-ca61-4d3f-ae71-98ed38ff4342	9d66f1a7-cb62-41b8-aefc-900367ccf05e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:24:25
20370	9d66f1a7-caa4-4bdf-a78e-d29b0b269188	9d66f1a7-cb62-41b8-aefc-900367ccf05e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:24:25
27938	9d68ea7d-de0e-429b-a39c-b73d9dbaa91e	9d68ea7d-e7d2-4c9e-8e39-034a90b19bfb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"153.15","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:56:02
27939	9d68ea7d-e1b5-46c5-b45e-472ba9758a3a	9d68ea7d-e7d2-4c9e-8e39-034a90b19bfb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:56:02
27940	9d68ea7d-e1eb-4428-88af-508acb463c43	9d68ea7d-e7d2-4c9e-8e39-034a90b19bfb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:56:02
27941	9d68ea7d-e6ad-4e74-9fce-9b2e2e523e24	9d68ea7d-e7d2-4c9e-8e39-034a90b19bfb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:56:02
28177	9d68ff1c-5055-458f-bd34-5c4c6e2dc455	9d68ff1c-5114-44cc-94f0-77520262581f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":392,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:53:42
20371	9d66f1a9-5a79-41ae-ab0d-98211e9e1d3c	9d66f1a9-8262-45c3-af50-bcd82bde9fb0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:24:26
20372	9d66f1a9-7a94-4c7f-ba2a-25ab7f1f1b9a	9d66f1a9-8262-45c3-af50-bcd82bde9fb0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:24:26
20373	9d66f1a9-7b13-4faf-a933-fc80a2632f0d	9d66f1a9-8262-45c3-af50-bcd82bde9fb0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:24:26
20374	9d66f1a9-80b7-4478-8ae5-a6b75880fbb2	9d66f1a9-8262-45c3-af50-bcd82bde9fb0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:24:26
20375	9d66f1a9-811e-4958-911b-25b847bc275b	9d66f1a9-8262-45c3-af50-bcd82bde9fb0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":365,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:24:26
27942	9d68ea7d-e6fe-4dd0-81c6-146746ad95f1	9d68ea7d-e7d2-4c9e-8e39-034a90b19bfb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":525,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:56:02
28051	9d68eb61-d974-4d41-8332-a922ccda7038	9d68eb61-e396-4a48-b501-e0285c9f5df9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"44.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:58:32
28052	9d68eb61-dd60-4b8d-b2b8-e7257cd7cb33	9d68eb61-e396-4a48-b501-e0285c9f5df9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:58:32
28053	9d68eb61-dd98-4679-a87b-86baae1ad4a7	9d68eb61-e396-4a48-b501-e0285c9f5df9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:58:32
28054	9d68eb61-e236-4445-8033-0a86211857f1	9d68eb61-e396-4a48-b501-e0285c9f5df9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:58:32
28178	9d68ff1c-c2c9-476c-9088-4b7ca717e81b	9d68ff1c-e13f-4a80-aac7-34e4d2d48613	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 12:53:42
28179	9d68ff1c-dbf6-456b-8a8c-852acfbfd7fa	9d68ff1c-e13f-4a80-aac7-34e4d2d48613	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 12:53:42
28180	9d68ff1c-dc55-4263-9672-23e174d325e2	9d68ff1c-e13f-4a80-aac7-34e4d2d48613	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 12:53:42
28181	9d68ff1c-dfee-4515-a1fb-4f6bd45d0534	9d68ff1c-e13f-4a80-aac7-34e4d2d48613	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 12:53:42
28055	9d68eb61-e292-4971-a7ed-2392789ded7c	9d68eb61-e396-4a48-b501-e0285c9f5df9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":394,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:58:32
28182	9d68ff1c-e03d-4242-97ad-75bab46abf9a	9d68ff1c-e13f-4a80-aac7-34e4d2d48613	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:53:42
28293	9d690054-b2b4-47be-a8a5-c88a9e2afc3a	9d690054-d9e7-4f24-ba75-76610bec7aef	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 12:57:06
28294	9d690054-d798-429e-856f-69295cb72f4b	9d690054-d9e7-4f24-ba75-76610bec7aef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 12:57:06
28295	9d690054-d896-4d52-a50d-35db322b0c03	9d690054-d9e7-4f24-ba75-76610bec7aef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":436,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:57:06
15312	9d5ed0ca-5e9b-4c4a-b024-42607886c44c	9d5ed0ca-8b01-4852-ac12-2a2c419df0c1	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-30 11:25:54
15313	9d5ed0ca-88ad-4f36-9bb4-2a353cbdf815	9d5ed0ca-8b01-4852-ac12-2a2c419df0c1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 11:25:54
15314	9d5ed0ca-89ab-4f13-b704-a3fd13aaea3b	9d5ed0ca-8b01-4852-ac12-2a2c419df0c1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":390,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:25:54
15315	9d5ed0ca-ffeb-47a5-a49b-f360374f5abf	9d5ed0cb-1f6d-416e-b7eb-e8a68d0be509	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 11:25:54
15316	9d5ed0cb-1a4d-4820-bc12-5d298ba2934c	9d5ed0cb-1f6d-416e-b7eb-e8a68d0be509	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 11:25:54
15317	9d5ed0cb-1a95-4e0a-a9ed-6c64b2811b62	9d5ed0cb-1f6d-416e-b7eb-e8a68d0be509	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-30 11:25:54
15318	9d5ed0cb-1e4a-462c-b3da-2223d88ec993	9d5ed0cb-1f6d-416e-b7eb-e8a68d0be509	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 11:25:54
15319	9d5ed0cb-1e8c-46d6-a087-cf42db66e4f6	9d5ed0cb-1f6d-416e-b7eb-e8a68d0be509	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":334,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:25:54
28183	9d68ff1d-62b3-47b5-8aed-aaf1ec0c7573	9d68ff1d-b2b0-420a-8b0a-c2b96890f9a0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 12:53:42
28184	9d68ff1d-aafe-4d6e-89ef-c573d4a5dcd2	9d68ff1d-b2b0-420a-8b0a-c2b96890f9a0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '81' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"162.40","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 12:53:42
28185	9d68ff1d-ab63-4131-be79-978115252549	9d68ff1d-b2b0-420a-8b0a-c2b96890f9a0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 12:53:42
28186	9d68ff1d-ad83-4ca2-9987-450076047f9f	9d68ff1d-b2b0-420a-8b0a-c2b96890f9a0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '81' order by \\"item_loans\\".\\"id\\" asc","time":"2.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 12:53:42
28187	9d68ff1d-adc7-4e57-9da1-2748c0efb5d1	9d68ff1d-b2b0-420a-8b0a-c2b96890f9a0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 12:53:42
28188	9d68ff1d-b198-43dc-bdae-0cef08cc84b0	9d68ff1d-b2b0-420a-8b0a-c2b96890f9a0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 12:53:42
28189	9d68ff1d-b1e6-450d-896f-85484ede29e0	9d68ff1d-b2b0-420a-8b0a-c2b96890f9a0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/81","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":81,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"0","loans_pago_prestado":"0","loans_intereses_recaudar":"275000"},"items":[{"id":311,"loans_codigo":81,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":312,"loans_codigo":81,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":313,"loans_codigo":81,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":314,"loans_codigo":81,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":315,"loans_codigo":81,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":516,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:53:42
28296	9d690055-8088-4227-9d6a-bb0387fdf387	9d690055-d0a7-40c5-975d-bcc6abffa7d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 12:57:07
28297	9d690055-c3b3-45be-add0-4ba17b32ed9c	9d690055-d0a7-40c5-975d-bcc6abffa7d0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"157.35","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 12:57:07
28298	9d690055-c80b-470a-afa2-6ef37aa0b21c	9d690055-d0a7-40c5-975d-bcc6abffa7d0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 12:57:07
28299	9d690055-c84c-46df-a680-fbae60b957d9	9d690055-d0a7-40c5-975d-bcc6abffa7d0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 12:57:07
28300	9d690055-cf5f-4789-b661-5a138900e8c9	9d690055-d0a7-40c5-975d-bcc6abffa7d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 12:57:07
15320	9d5ed0cb-607b-4d2d-9307-a309104bd4a2	9d5ed0cb-7e52-4017-bfa8-138ebf9dd6c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 11:25:54
15321	9d5ed0cb-7997-41a1-b0c4-08556bd0f9df	9d5ed0cb-7e52-4017-bfa8-138ebf9dd6c8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 11:25:54
15322	9d5ed0cb-79e3-4248-8fe2-691b6715b0aa	9d5ed0cb-7e52-4017-bfa8-138ebf9dd6c8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-30 11:25:54
15323	9d5ed0cb-7d0b-4a43-ad2c-1613801600df	9d5ed0cb-7e52-4017-bfa8-138ebf9dd6c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 11:25:54
15324	9d5ed0cb-7d6f-4df5-a2a6-0fb2dc1b4bcc	9d5ed0cb-7e52-4017-bfa8-138ebf9dd6c8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":228,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:25:54
28301	9d690055-cfbd-4a8f-8a1d-018948126b05	9d690055-d0a7-40c5-975d-bcc6abffa7d0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":576,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:57:07
17198	9d655018-332f-4931-8250-f602afb5c00e	9d655018-5db6-477b-a1fa-0d2afe97dfab	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 16:56:50
17199	9d655018-5b85-40ca-b688-3cc8cda0ef0f	9d655018-5db6-477b-a1fa-0d2afe97dfab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:56:50
17200	9d655018-5c9b-4309-843c-ec3124607c2e	9d655018-5db6-477b-a1fa-0d2afe97dfab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":327,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:56:50
28416	9d6901aa-1d81-4956-ad9a-5e5e518d471e	9d6901aa-4741-48f4-8044-0128a7d1a1e9	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 13:00:50
28417	9d6901aa-44b0-4ca7-8057-82d9bfbee3d2	9d6901aa-4741-48f4-8044-0128a7d1a1e9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 13:00:50
28418	9d6901aa-45c8-4f67-9c15-7cc79bbee66c	9d6901aa-4741-48f4-8044-0128a7d1a1e9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":495,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:00:50
17201	9d655018-fa0d-4f14-909e-ca7490aaf9dd	9d655019-3eac-44f4-876d-4b12fa65995e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:56:50
17202	9d655019-396b-4677-9103-3c1cdcdaf223	9d655019-3eac-44f4-876d-4b12fa65995e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"143.79","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":46,"hash":"fb4ded687569d92428336ceae5c6ffcd","hostname":"EderCortes"}	2024-11-02 16:56:50
17203	9d655019-3d0b-4db6-b6b1-c90f62837365	9d655019-3eac-44f4-876d-4b12fa65995e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 16:56:50
17204	9d655019-3d78-4fad-955c-4996981020d3	9d655019-3eac-44f4-876d-4b12fa65995e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":515,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:56:50
28419	9d6901aa-ed0f-46aa-87ea-6152d3c929a5	9d6901ab-3c04-436c-89ac-db41655f3146	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 13:00:51
28420	9d6901ab-2f83-4279-a910-7f8cd87aad90	9d6901ab-3c04-436c-89ac-db41655f3146	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"154.73","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 13:00:51
20467	9d66f420-6792-4a6b-949a-6fa869c48037	9d66f420-aed4-4c6e-8bb1-fa550a7a3cd4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:31:19
20468	9d66f420-ace9-48e2-8049-7aec3e884b01	9d66f420-aed4-4c6e-8bb1-fa550a7a3cd4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:31:20
20469	9d66f420-adbc-4afd-8298-f71edd455aa6	9d66f420-aed4-4c6e-8bb1-fa550a7a3cd4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":377,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:31:20
28421	9d6901ab-3383-44dd-8a61-8a8e87809fa4	9d6901ab-3c04-436c-89ac-db41655f3146	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:00:51
28422	9d6901ab-33c4-4363-86c1-6f089f8ffa73	9d6901ab-3c04-436c-89ac-db41655f3146	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:00:51
28423	9d6901ab-3a5a-4d2a-a210-fe1d13dee02f	9d6901ab-3c04-436c-89ac-db41655f3146	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 13:00:51
28424	9d6901ab-3ada-4ab7-8798-20d5ce9b679a	9d6901ab-3c04-436c-89ac-db41655f3146	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":576,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:00:51
17205	9d65501b-0506-40bf-9ed4-ac8517aaaf00	9d65501b-2400-41ed-8566-3da013d35f23	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 16:56:52
17206	9d65501b-1e7a-4925-ac3f-acd1521ead80	9d65501b-2400-41ed-8566-3da013d35f23	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 16:56:52
17207	9d65501b-1ee6-4b71-af21-2f1d272f6868	9d65501b-2400-41ed-8566-3da013d35f23	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 16:56:52
17208	9d65501b-22b5-472e-a23f-06b7de3fc014	9d65501b-2400-41ed-8566-3da013d35f23	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 16:56:52
17209	9d65501b-2301-4ec1-927a-483d76b17318	9d65501b-2400-41ed-8566-3da013d35f23	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":406,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:56:52
20470	9d66f421-0a10-4dde-bd1e-f2bb44003981	9d66f421-4ee3-483f-bdaf-ba352e2ae921	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:31:20
20471	9d66f421-4667-44db-b993-2c220421fddb	9d66f421-4ee3-483f-bdaf-ba352e2ae921	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"141.90","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:31:20
20472	9d66f421-49d7-44cc-9853-09e6c0941f7f	9d66f421-4ee3-483f-bdaf-ba352e2ae921	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:31:20
20473	9d66f421-4a06-4ef0-934e-713d76ccd928	9d66f421-4ee3-483f-bdaf-ba352e2ae921	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:31:20
20474	9d66f421-4d80-4f79-833f-b6562cc7b1fe	9d66f421-4ee3-483f-bdaf-ba352e2ae921	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:31:20
20475	9d66f421-4de7-4488-a5a7-6e5764cc442f	9d66f421-4ee3-483f-bdaf-ba352e2ae921	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":337,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:31:20
20476	9d66f422-e26c-407a-9764-b82d74d8e97e	9d66f423-0f5b-47c4-aee5-472787d585aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:31:21
20477	9d66f423-0777-46d1-a8d8-3e4b7fbdfa6e	9d66f423-0f5b-47c4-aee5-472787d585aa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"57.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:31:21
20478	9d66f423-07f7-4750-83c2-bb2eac01d3e5	9d66f423-0f5b-47c4-aee5-472787d585aa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:31:21
20479	9d66f423-0ddd-4597-953c-ffad74e7aaaa	9d66f423-0f5b-47c4-aee5-472787d585aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:31:21
20480	9d66f423-0e44-4e10-ac03-b180379eb1a7	9d66f423-0f5b-47c4-aee5-472787d585aa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":559,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:31:21
20645	9d66f941-5ab8-408b-b0cb-f0793c5fbfbe	9d66f941-b086-4f84-9a9d-acfced730758	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 12:45:40
20646	9d66f941-ae35-45b6-886f-47ddecffb4a0	9d66f941-b086-4f84-9a9d-acfced730758	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:45:40
20647	9d66f941-af33-46ca-aa04-c62c608976d7	9d66f941-b086-4f84-9a9d-acfced730758	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":452,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:45:40
20648	9d66f942-1cd8-420e-93dd-58222f8e3786	9d66f942-6a40-4075-89b6-0f6c37f2e580	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:45:40
20649	9d66f942-5f12-484f-96c8-d851917e3cd5	9d66f942-6a40-4075-89b6-0f6c37f2e580	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"156.17","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:45:41
20650	9d66f942-62fe-4007-86dd-700bf9c1add0	9d66f942-6a40-4075-89b6-0f6c37f2e580	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:45:41
20651	9d66f942-633a-44a9-8de4-ca184a8d2217	9d66f942-6a40-4075-89b6-0f6c37f2e580	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:45:41
20652	9d66f942-68aa-4dc3-bfb3-d490e85402dd	9d66f942-6a40-4075-89b6-0f6c37f2e580	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:45:41
20653	9d66f942-6904-4b2e-9d9d-e806aee9c7cd	9d66f942-6a40-4075-89b6-0f6c37f2e580	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"400000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:40:42.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":null,"itemloans_cuota_cancelada":"100000"},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":430,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:45:41
20654	9d66f944-9d23-4700-b2ee-8671b730601c	9d66f944-c6ca-453b-9802-459a0b206a55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:45:42
20655	9d66f944-bf8d-43c2-b682-254260d90ac4	9d66f944-c6ca-453b-9802-459a0b206a55	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"60.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:45:42
20656	9d66f944-c008-41ab-a70a-76d443ec46b2	9d66f944-c6ca-453b-9802-459a0b206a55	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:45:42
17276	9d6551eb-4e69-4ce2-96ba-de6a86fc7c9a	9d6551eb-968a-4c8b-a939-d03b781d0b86	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 17:01:56
15426	9d5ed226-4d15-46a0-9202-12bfe619360b	9d5ed226-9e47-4bcd-89b0-549dc528e6ef	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-30 11:29:42
15427	9d5ed226-9c23-4661-9148-95668ec6ce86	9d5ed226-9e47-4bcd-89b0-549dc528e6ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 11:29:42
15428	9d5ed226-9d17-4ff7-891a-d0082cd3b2c0	9d5ed226-9e47-4bcd-89b0-549dc528e6ef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":500,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:29:42
17277	9d6551eb-94f4-4056-b961-84208643efc7	9d6551eb-968a-4c8b-a939-d03b781d0b86	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 17:01:56
17278	9d6551eb-9588-4b22-96e5-88b84d8ddc6e	9d6551eb-968a-4c8b-a939-d03b781d0b86	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":350,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:01:56
20657	9d66f944-c556-428d-840b-2b2a838c98be	9d66f944-c6ca-453b-9802-459a0b206a55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:45:42
20658	9d66f944-c5d0-4ea6-a4e6-320b9833ff15	9d66f944-c6ca-453b-9802-459a0b206a55	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":409,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:45:42
15429	9d5ed227-019b-444b-8d57-83a26e06952e	9d5ed227-222c-4bf2-91a4-8115278f8389	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 11:29:42
15430	9d5ed227-1bfa-450f-bb8f-81eb78047c17	9d5ed227-222c-4bf2-91a4-8115278f8389	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 11:29:42
15431	9d5ed227-1c7e-4a0f-8d5d-d08d55aa613a	9d5ed227-222c-4bf2-91a4-8115278f8389	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-30 11:29:42
15432	9d5ed227-20c1-47bc-aac2-a6fb240f683f	9d5ed227-222c-4bf2-91a4-8115278f8389	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 11:29:42
15433	9d5ed227-2116-4115-be15-15e92cd63873	9d5ed227-222c-4bf2-91a4-8115278f8389	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":296,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:29:42
17279	9d6551eb-e805-4dce-8026-21a79ae156c3	9d6551ec-2dc8-4b74-b4dd-a2106bcb2aa1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 17:01:56
17280	9d6551ec-29d7-4e2d-bb62-41e0d0d3c998	9d6551ec-2dc8-4b74-b4dd-a2106bcb2aa1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"150.79","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":46,"hash":"fb4ded687569d92428336ceae5c6ffcd","hostname":"EderCortes"}	2024-11-02 17:01:56
17281	9d6551ec-2c89-45ed-b364-c1a91528ed16	9d6551ec-2dc8-4b74-b4dd-a2106bcb2aa1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 17:01:56
17282	9d6551ec-2cdf-4fa5-abfc-6d9f132aaff1	9d6551ec-2dc8-4b74-b4dd-a2106bcb2aa1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:01:56
20659	9d66f94b-7614-4c91-aeff-60ab42e210a6	9d66f94b-790f-4149-8f70-4630e3b4d983	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":152,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:45:46
15434	9d5ed227-6b53-4ad3-be9b-a52bce13b467	9d5ed227-b53d-4ace-9739-972476004ff2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 11:29:42
15435	9d5ed227-b045-47e9-b497-c9c2f09cdde0	9d5ed227-b53d-4ace-9739-972476004ff2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"152.86","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 11:29:43
15436	9d5ed227-b092-44ca-8061-a8689a96b538	9d5ed227-b53d-4ace-9739-972476004ff2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-30 11:29:43
15437	9d5ed227-b3ee-4abd-8ed3-e15bbd1041b8	9d5ed227-b53d-4ace-9739-972476004ff2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 11:29:43
15438	9d5ed227-b42f-4aa3-885c-9f1e7dce965e	9d5ed227-b53d-4ace-9739-972476004ff2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:29:43
17283	9d6551ee-07db-4924-a8fc-9046df3b81f4	9d6551ee-25e9-424a-8d4a-b4da37d11ddd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 17:01:58
17284	9d6551ee-207f-49f4-bd00-96e6079a5662	9d6551ee-25e9-424a-8d4a-b4da37d11ddd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 17:01:58
17285	9d6551ee-210b-4245-98f1-94bf7c71fc2e	9d6551ee-25e9-424a-8d4a-b4da37d11ddd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 17:01:58
17286	9d6551ee-2494-42d7-8581-445409464c86	9d6551ee-25e9-424a-8d4a-b4da37d11ddd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-02 17:01:58
17287	9d6551ee-24e4-4422-b294-74383aaf2e4f	9d6551ee-25e9-424a-8d4a-b4da37d11ddd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":299,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:01:58
20667	9d66f94c-980f-467f-8f68-04c7701c9df2	9d66f94c-b73c-4e1c-ba4b-e750b6aee0ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:45:47
20668	9d66f94c-ae7d-461a-94fc-746175e3ff54	9d66f94c-b73c-4e1c-ba4b-e750b6aee0ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"44.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:45:47
20669	9d66f94c-b201-48b3-8eb3-0b3d3f751611	9d66f94c-b73c-4e1c-ba4b-e750b6aee0ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:45:47
20670	9d66f94c-b231-4209-ae8c-166361ca8aa7	9d66f94c-b73c-4e1c-ba4b-e750b6aee0ca	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:45:47
20671	9d66f94c-b5e8-49fb-ad74-63640db6c255	9d66f94c-b73c-4e1c-ba4b-e750b6aee0ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:45:47
20672	9d66f94c-b62d-4343-9c2f-97170f074440	9d66f94c-b73c-4e1c-ba4b-e750b6aee0ca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"400000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:40:42.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":null,"itemloans_cuota_cancelada":"100000"},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:45:47
28665	9d69070f-4939-4998-a729-a4d279f458d9	9d69070f-76a0-46f6-94ec-da07c9a059b2	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 13:15:55
28666	9d69070f-743d-4998-af08-a115ad7a51c2	9d69070f-76a0-46f6-94ec-da07c9a059b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 13:15:55
28667	9d69070f-7533-433c-af88-2edeea2d9ba4	9d69070f-76a0-46f6-94ec-da07c9a059b2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":574,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:15:55
17349	9d655877-247d-4aa3-a59a-ce7308094be4	9d655877-51ae-4207-965a-f9223e421a03	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 17:20:14
17350	9d655877-4f61-4b6a-8ee5-30f8dbf7d74c	9d655877-51ae-4207-965a-f9223e421a03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:20:14
17351	9d655877-5062-4f57-a97b-5dfd32bce70d	9d655877-51ae-4207-965a-f9223e421a03	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":414,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:20:14
28668	9d690710-3af4-44ca-b23b-f655ec66fac3	9d690710-8b4b-4d8f-9438-e1233f98dd74	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 13:15:56
28669	9d690710-83ad-418b-afc3-573389fa9d7d	9d690710-8b4b-4d8f-9438-e1233f98dd74	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"159.62","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:15:56
28670	9d690710-8419-43e9-9407-4992ef4478e6	9d690710-8b4b-4d8f-9438-e1233f98dd74	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 13:15:56
28671	9d690710-89a8-47fb-8bde-bc8f0efdfe90	9d690710-8b4b-4d8f-9438-e1233f98dd74	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 13:15:56
28672	9d690710-8a1b-4072-918c-96e4a223a6b3	9d690710-8b4b-4d8f-9438-e1233f98dd74	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":585,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:15:56
17352	9d655877-f983-4b46-a8b0-d50a93bac2d7	9d655878-1aeb-406d-9696-92f35b4517ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:20:15
17353	9d655878-150f-4a02-93a3-d014940d52ab	9d655878-1aeb-406d-9696-92f35b4517ee	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"51.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":46,"hash":"fb4ded687569d92428336ceae5c6ffcd","hostname":"EderCortes"}	2024-11-02 17:20:15
17354	9d655878-1966-4d49-b50d-051047e699db	9d655878-1aeb-406d-9696-92f35b4517ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:20:15
17355	9d655878-19cf-4b69-9299-a221dfafad09	9d655878-1aeb-406d-9696-92f35b4517ee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":444,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:20:15
28673	9d690711-0ef6-4596-85eb-acbab69be826	9d690711-5824-45be-b3de-8a4c79690e0a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 13:15:56
28674	9d690711-52e7-475a-8555-2baf92b94ad3	9d690711-5824-45be-b3de-8a4c79690e0a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"150.56","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:15:57
28675	9d690711-5343-44d2-81c3-220fb01d91f8	9d690711-5824-45be-b3de-8a4c79690e0a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 13:15:57
28676	9d690711-56f8-484a-915a-6f35ac9f3cdf	9d690711-5824-45be-b3de-8a4c79690e0a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 13:15:57
28677	9d690711-5746-419f-bd5c-5144c39f9641	9d690711-5824-45be-b3de-8a4c79690e0a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":507,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:15:57
28678	9d690711-ccae-4091-9d45-ce2a6617f8fd	9d690711-ebfa-4710-80c6-6d326e53137d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 13:15:57
28679	9d690711-e525-4a52-8170-f270e896e0e9	9d690711-ebfa-4710-80c6-6d326e53137d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '89' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"43.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 13:15:57
28680	9d690711-e576-4940-84f7-5316dbbd3ed2	9d690711-ebfa-4710-80c6-6d326e53137d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 13:15:57
28681	9d690711-e718-436d-a2c2-65391814956f	9d690711-ebfa-4710-80c6-6d326e53137d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"1.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:15:57
28682	9d690711-e75d-4420-8a09-940b56d484cc	9d690711-ebfa-4710-80c6-6d326e53137d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:15:57
28683	9d690711-eaa3-4e5f-aa3a-4bff0d1616f4	9d690711-ebfa-4710-80c6-6d326e53137d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 13:15:57
28684	9d690711-eb0a-4fac-9028-1ad84a730b8b	9d690711-ebfa-4710-80c6-6d326e53137d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"146000","loans_pago_prestado":"584000","loans_intereses_recaudar":"275000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":363,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:15:57
28788	9d690832-71c0-4450-9feb-fd69f15920ba	9d690832-9953-487e-8cb6-47e4be3078d3	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 13:19:06
28789	9d690832-9735-4377-8c6a-182ec7a22b78	9d690832-9953-487e-8cb6-47e4be3078d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 13:19:06
28790	9d690832-980a-4549-8206-7f9aa739c0aa	9d690832-9953-487e-8cb6-47e4be3078d3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":426,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:19:06
28791	9d690833-068c-4d76-9cbd-3ba6a9530f0e	9d690833-2ce4-49e9-825c-765a11ffd597	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 13:19:06
28792	9d690833-2578-497c-8910-d7cdb9e2b693	9d690833-2ce4-49e9-825c-765a11ffd597	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:19:06
28793	9d690833-25f5-472f-8bc5-2291407a6aeb	9d690833-2ce4-49e9-825c-765a11ffd597	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 13:19:06
28794	9d690833-2b6f-443e-97e3-82f6fd49f80e	9d690833-2ce4-49e9-825c-765a11ffd597	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 13:19:06
14203	9d5d169a-073a-4107-a015-81b1ff1a0b62	9d5d169a-259d-4473-80a1-9efd11e0ed0e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 14:49:27
14204	9d5d169a-23fc-494d-9040-c5b4ad3a17c7	9d5d169a-259d-4473-80a1-9efd11e0ed0e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 14:49:27
14205	9d5d169a-248f-45c4-a01d-5ee31cfbabef	9d5d169a-259d-4473-80a1-9efd11e0ed0e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":269,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:49:27
28795	9d690833-2bd0-45e9-a451-de0b05a18a20	9d690833-2ce4-49e9-825c-765a11ffd597	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":331,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:19:06
14206	9d5d169a-6c82-4345-84d1-de104070141c	9d5d169a-85a3-4684-a45c-3a6a13556438	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 14:49:27
14207	9d5d169a-81c2-4477-9bb1-803540fe480d	9d5d169a-85a3-4684-a45c-3a6a13556438	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"42.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-29 14:49:27
14208	9d5d169a-848c-472a-9159-45e8e390d711	9d5d169a-85a3-4684-a45c-3a6a13556438	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 14:49:27
14209	9d5d169a-84d7-4516-a420-03fa6a896afa	9d5d169a-85a3-4684-a45c-3a6a13556438	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":211,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:49:27
28796	9d690833-8612-4a33-be8b-09d712fc32c6	9d690833-a8e9-44d4-86c7-c360cbc298dc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 13:19:07
28797	9d690833-a2e9-47c9-b026-0311da34dc7f	9d690833-a8e9-44d4-86c7-c360cbc298dc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:19:07
28798	9d690833-a343-4e5c-8bfb-7fc6eb2295e6	9d690833-a8e9-44d4-86c7-c360cbc298dc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 13:19:07
28799	9d690833-a780-4ae4-901f-881f1b13b139	9d690833-a8e9-44d4-86c7-c360cbc298dc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 13:19:07
28800	9d690833-a7e3-4f42-bdae-93f186fa7aac	9d690833-a8e9-44d4-86c7-c360cbc298dc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":294,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:19:07
28926	9d690dbf-7c09-41f9-a167-aba713cc138f	9d690dbf-c940-4974-83fe-9b561afb9e4d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 13:34:37
28927	9d690dbf-c791-4ede-8979-253d5ba51754	9d690dbf-c940-4974-83fe-9b561afb9e4d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 13:34:37
28928	9d690dbf-c847-469f-89a3-622bb2ef9444	9d690dbf-c940-4974-83fe-9b561afb9e4d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":470,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:34:37
14210	9d5d169b-f7bb-4f36-a98c-3392110d7640	9d5d169c-2707-4055-a450-4ea951ca0bd9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 14:49:28
14211	9d5d169c-1c9a-4239-9db0-e447861cc406	9d5d169c-2707-4055-a450-4ea951ca0bd9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"64.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 14:49:28
14212	9d5d169c-1d25-4f8f-93de-f27b21a66def	9d5d169c-2707-4055-a450-4ea951ca0bd9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 14:49:28
14213	9d5d169c-2563-4bcb-a077-64b65cf56c87	9d5d169c-2707-4055-a450-4ea951ca0bd9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 14:49:28
14214	9d5d169c-25c8-4aef-a730-48b80056644a	9d5d169c-2707-4055-a450-4ea951ca0bd9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":460,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:49:28
28801	9d690833-fced-4514-814a-c756a7d22087	9d690834-20a9-454f-ab7c-3d33f6e1db97	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 13:19:07
28802	9d690834-1727-4927-b28a-ff8e3095ff9d	9d690834-20a9-454f-ab7c-3d33f6e1db97	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '89' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"44.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 13:19:07
28803	9d690834-178f-4de7-a3ff-368f8ba59c52	9d690834-20a9-454f-ab7c-3d33f6e1db97	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 13:19:07
28804	9d690834-1970-4580-896f-d19ca9f84212	9d690834-20a9-454f-ab7c-3d33f6e1db97	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:19:07
28805	9d690834-19b3-4592-8807-e27129fc1c33	9d690834-20a9-454f-ab7c-3d33f6e1db97	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:19:07
28806	9d690834-1f09-4adc-95c0-54c0c3709387	9d690834-20a9-454f-ab7c-3d33f6e1db97	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 13:19:07
28807	9d690834-1f76-48a8-9b2c-915a44096a20	9d690834-20a9-454f-ab7c-3d33f6e1db97	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"146000","loans_pago_prestado":"584000","loans_intereses_recaudar":"275000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":290,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:19:07
28929	9d690dc0-3048-447a-8ae3-b8f327d4daaf	9d690dc0-5151-4f72-8905-e1d01a961bac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 13:34:38
28930	9d690dc0-4646-434a-9758-ea1babb17599	9d690dc0-5151-4f72-8905-e1d01a961bac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"41.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 13:34:38
14215	9d5d16c3-7fb0-44e7-a136-df03943f7dc5	9d5d16c3-82d8-49f7-a01c-a489f0ffd200	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":134,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:49:54
28931	9d690dc0-4a11-4fc6-9119-66359533a1d4	9d690dc0-5151-4f72-8905-e1d01a961bac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:34:38
28932	9d690dc0-4a4f-4d2f-a1ae-92ef55703329	9d690dc0-5151-4f72-8905-e1d01a961bac	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:34:38
28933	9d690dc0-4ffa-4c86-8efc-aec8a5a326d5	9d690dc0-5151-4f72-8905-e1d01a961bac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 13:34:38
28934	9d690dc0-5050-4dbe-8fc4-a687f827eb5a	9d690dc0-5151-4f72-8905-e1d01a961bac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":306,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:34:38
14216	9d5d16c3-e643-4dbf-8287-895c3d8a77b6	9d5d16c4-3527-4661-a505-671f8a29cd2f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 14:49:54
14217	9d5d16c4-2b1c-4a1c-aaa1-d465c8a6a514	9d5d16c4-3527-4661-a505-671f8a29cd2f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta', 'De las nieve', 'ds', 'CC', '100465546', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '50000', 30, 7, 'Q', null, '15-11-2024', 'Pendiente', '312596295', 12, 14, 18, 14, '15-11-2024', '2024-10-29 14:49:54', '2024-10-29 14:49:54') returning \\"id\\"","time":"4.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":104,"hash":"bfad4cea82a73099ff0b3164dd496ca0","hostname":"EderCortes"}	2024-10-29 14:49:54
14218	9d5d16c4-2b70-4ed2-b025-41b55a93d373	9d5d16c4-3527-4661-a505-671f8a29cd2f	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:55","hostname":"EderCortes"}	2024-10-29 14:49:54
14219	9d5d16c4-2ca4-483b-a16c-1c1db0eaf58a	9d5d16c4-3527-4661-a505-671f8a29cd2f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (55, 1, 7142.8571428571, 1250, 'Pendiente', 'N\\/A', '30-11-2024', 12, '2024-10-29 14:49:54', '2024-10-29 14:49:54')","time":"2.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":155,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 14:49:54
14220	9d5d16c4-2ccd-453f-b606-bd96d0a6511b	9d5d16c4-3527-4661-a505-671f8a29cd2f	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 14:49:54
14221	9d5d16c4-2d3b-4d9d-98e8-ca29185e433a	9d5d16c4-3527-4661-a505-671f8a29cd2f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (55, 2, 7142.8571428571, 1250, 'Pendiente', 'N\\/A', '15-12-2024', 12, '2024-10-29 14:49:54', '2024-10-29 14:49:54')","time":"0.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":155,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 14:49:54
14222	9d5d16c4-2d66-46db-9d9f-cda89565794c	9d5d16c4-3527-4661-a505-671f8a29cd2f	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 14:49:54
14223	9d5d16c4-2de9-4ab4-bf50-136721b1b8b5	9d5d16c4-3527-4661-a505-671f8a29cd2f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (55, 3, 7142.8571428571, 1250, 'Pendiente', 'N\\/A', '30-12-2024', 12, '2024-10-29 14:49:54', '2024-10-29 14:49:54')","time":"0.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":155,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 14:49:54
14224	9d5d16c4-2e0f-4abc-bad3-9bd7b22c3d3a	9d5d16c4-3527-4661-a505-671f8a29cd2f	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 14:49:54
14225	9d5d16c4-2e8b-442a-b499-d64731ab63aa	9d5d16c4-3527-4661-a505-671f8a29cd2f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (55, 4, 7142.8571428571, 1250, 'Pendiente', 'N\\/A', '14-01-2025', 12, '2024-10-29 14:49:54', '2024-10-29 14:49:54')","time":"0.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":155,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 14:49:54
14226	9d5d16c4-2eb0-4847-baed-465511f83e46	9d5d16c4-3527-4661-a505-671f8a29cd2f	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 14:49:54
14227	9d5d16c4-2f29-488c-8388-a937b5a34e57	9d5d16c4-3527-4661-a505-671f8a29cd2f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (55, 5, 7142.8571428571, 1250, 'Pendiente', 'N\\/A', '29-01-2025', 12, '2024-10-29 14:49:54', '2024-10-29 14:49:54')","time":"0.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":155,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 14:49:54
14228	9d5d16c4-2f5a-464e-9c3e-415eee9f4a4e	9d5d16c4-3527-4661-a505-671f8a29cd2f	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 14:49:54
14229	9d5d16c4-2fc6-4f62-9f5f-ded54038384a	9d5d16c4-3527-4661-a505-671f8a29cd2f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (55, 6, 7142.8571428571, 1250, 'Pendiente', 'N\\/A', '13-02-2025', 12, '2024-10-29 14:49:54', '2024-10-29 14:49:54')","time":"0.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":155,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 14:49:54
14230	9d5d16c4-2fe8-470a-bdd7-beab6d9dfd86	9d5d16c4-3527-4661-a505-671f8a29cd2f	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 14:49:54
14231	9d5d16c4-3048-42ce-907b-49252c5d6172	9d5d16c4-3527-4661-a505-671f8a29cd2f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"updated_at\\", \\"created_at\\") values (55, 7, 7142.8571428571, 1250, 'Pendiente', 'N\\/A', '28-02-2025', 12, '2024-10-29 14:49:54', '2024-10-29 14:49:54')","time":"0.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":155,"hash":"f84942b123ec1f4562ce3f5fadf38fb2","hostname":"EderCortes"}	2024-10-29 14:49:54
14232	9d5d16c4-3066-42c5-bf89-ec1db3335f31	9d5d16c4-3527-4661-a505-671f8a29cd2f	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-10-29 14:49:54
14233	9d5d16c4-3402-4cfc-8dfc-077c2e9f84d1	9d5d16c4-3527-4661-a505-671f8a29cd2f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 14:49:54
14234	9d5d16c4-3441-4c7e-9bba-e0bfdda500c7	9d5d16c4-3527-4661-a505-671f8a29cd2f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"742","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"100465546","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"50000","loans_intereses":30,"loans_cuotas":7,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":18,"user_recomendacion":14,"loans_inicio_pago":"15-11-2024","created_at":null,"updated_at":null,"deleted_at":null},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Tue Oct 29 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":55},"duration":341,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:49:54
17435	9d655a63-7635-4e34-a6cc-a741bc901e6b	9d655a63-99f1-47cc-9f2c-d0d392b885c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:25:37
17436	9d655a63-9783-4c61-91b0-ecf26d98ac3f	9d655a63-99f1-47cc-9f2c-d0d392b885c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 17:25:37
17437	9d655a63-98ab-4df1-99f7-19a081d7a164	9d655a63-99f1-47cc-9f2c-d0d392b885c9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":303,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:25:37
4487	9d5130c8-f8a0-4750-ac5b-b484f1fa70ff	9d5130c8-fd02-4501-b25e-a0fcc727ca99	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":245}	2024-10-23 16:52:43
17438	9d655a63-f544-4912-8399-2cc675df25b3	9d655a64-168a-401d-bb74-3ea5ffe2d67c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 17:25:37
17439	9d655a64-1142-4dbc-82f3-d94fc3fe4d57	9d655a64-168a-401d-bb74-3ea5ffe2d67c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"52.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":46,"hash":"fb4ded687569d92428336ceae5c6ffcd","hostname":"EderCortes"}	2024-11-02 17:25:37
17440	9d655a64-1528-4e4b-8df3-dccaf64d5004	9d655a64-168a-401d-bb74-3ea5ffe2d67c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 17:25:37
17441	9d655a64-1588-4776-ae41-08df4622c0ce	9d655a64-168a-401d-bb74-3ea5ffe2d67c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":276,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:25:37
17442	9d655a65-c383-4103-b01a-c9d2c86dab92	9d655a65-e8b0-4cc1-ba4f-f03f85720985	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 17:25:38
17443	9d655a65-e268-409c-8b31-5f6ca63d0006	9d655a65-e8b0-4cc1-ba4f-f03f85720985	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"57.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 17:25:38
17444	9d655a65-e2d2-4f7a-9cd5-4dc66c4394e5	9d655a65-e8b0-4cc1-ba4f-f03f85720985	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 17:25:38
17445	9d655a65-e730-4d6b-948e-3202ec47fedc	9d655a65-e8b0-4cc1-ba4f-f03f85720985	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 17:25:38
17446	9d655a65-e791-4762-a07f-2909e6503361	9d655a65-e8b0-4cc1-ba4f-f03f85720985	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":383,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:25:38
40894	9d6cc872-7a29-462f-80d3-67483329f973	9d6cc872-7cdf-4b07-ad11-d5458d7a798a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1866}	2024-11-06 10:04:09
20893	9d66fd8a-f75a-4398-8e7a-4a360a3b9e69	9d66fd8b-244c-4ed9-a540-ae4cb2f408a0	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 12:57:39
20894	9d66fd8b-21fc-420d-9a68-0f3342acc224	9d66fd8b-244c-4ed9-a540-ae4cb2f408a0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:57:39
20895	9d66fd8b-22ff-4eb7-985b-82ca52398351	9d66fd8b-244c-4ed9-a540-ae4cb2f408a0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":412,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:57:39
13902	9d5d13d5-242f-4843-b2ac-65b6e7e2bf62	9d5d13d5-50cb-4753-a1c0-e467b88fab02	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 14:41:42
13903	9d5d13d5-4dbe-4254-b64e-dfac1bbeed69	9d5d13d5-50cb-4753-a1c0-e467b88fab02	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 14:41:42
13904	9d5d13d5-4f10-4ec7-9016-a8e197fb3fac	9d5d13d5-50cb-4753-a1c0-e467b88fab02	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":417,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:41:42
20896	9d66fd8b-b462-4c5b-a064-477e6ccca196	9d66fd8b-d646-470d-a379-cf4880136ac0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:57:40
20897	9d66fd8b-d09d-429b-a5f1-1b81b0035c32	9d66fd8b-d646-470d-a379-cf4880136ac0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"52.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 12:57:40
29130	9d6912e1-33c8-4821-a86f-165fa207240b	9d6912e1-56ab-40ee-bc2b-67dcf2248cba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 13:48:58
20898	9d66fd8b-d45d-4408-8324-2761073e55ab	9d66fd8b-d646-470d-a379-cf4880136ac0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:57:40
29131	9d6912e1-54ab-4d46-ad14-a4fb37200ce4	9d6912e1-56ab-40ee-bc2b-67dcf2248cba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 13:48:58
29132	9d6912e1-5587-44cc-ae8a-63dbdfb74425	9d6912e1-56ab-40ee-bc2b-67dcf2248cba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":302,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:48:58
4989	9d513660-7e3e-467e-90eb-51ccf8ebaf3e	9d513660-83e8-4101-b7c1-95401d6517fe	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":268}	2024-10-23 17:08:22
13905	9d5d13d5-e286-446f-88ee-9ecf6157bd58	9d5d13d6-387a-41fa-bfee-3d3b86407ab7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 14:41:43
13906	9d5d13d6-2eca-40b9-92af-c990f3a74df0	9d5d13d6-387a-41fa-bfee-3d3b86407ab7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"158.60","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":194,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 14:41:43
13907	9d5d13d6-2f38-44ed-b9b1-a6d61c163b6c	9d5d13d6-387a-41fa-bfee-3d3b86407ab7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 14:41:43
13908	9d5d13d6-36a1-4ccb-afdb-f6d1c91fcec5	9d5d13d6-387a-41fa-bfee-3d3b86407ab7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 14:41:43
13909	9d5d13d6-3724-48e3-8510-655ff595b66e	9d5d13d6-387a-41fa-bfee-3d3b86407ab7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":538,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:41:43
14375	9d5d1e15-9a48-4588-b1fc-34101d60ce4b	9d5d1e15-e089-4578-b448-f5fa4e136ff1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-29 15:10:22
14376	9d5d1e15-de5b-4613-8a2a-2258bc145a37	9d5d1e15-e089-4578-b448-f5fa4e136ff1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-29 15:10:22
29133	9d6912e1-afc7-4eb5-8319-f98ca97f81a1	9d6912e1-d4c4-409f-bb87-2c3eebd802bc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 13:48:59
13910	9d5d13d6-a8b7-4454-9a8c-8b8481964f38	9d5d13d6-d703-4223-b3f6-15c572b1978d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 14:41:43
13911	9d5d13d6-ce30-4ba5-bfdc-601e1da93b47	9d5d13d6-d703-4223-b3f6-15c572b1978d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"56.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":194,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 14:41:43
13912	9d5d13d6-ce95-4ccc-9601-b9193de853e7	9d5d13d6-d703-4223-b3f6-15c572b1978d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 14:41:43
13913	9d5d13d6-d518-48ad-9dc9-5e9093805dd7	9d5d13d6-d703-4223-b3f6-15c572b1978d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 14:41:43
13914	9d5d13d6-d5a4-45f7-9d96-888bae1b60f2	9d5d13d6-d703-4223-b3f6-15c572b1978d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":382,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:41:43
14377	9d5d1e15-df58-4b50-baf6-3450b4ccca7b	9d5d1e15-e089-4578-b448-f5fa4e136ff1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":411,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:10:22
20899	9d66fd8b-d4c0-4969-9486-e652062f8070	9d66fd8b-d646-470d-a379-cf4880136ac0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":null,"loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":368,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:57:40
29134	9d6912e1-c8f3-4e3d-ad2b-cf862dbc0e31	9d6912e1-d4c4-409f-bb87-2c3eebd802bc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"51.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 13:48:59
29135	9d6912e1-cdf9-4881-9673-17b0de2b912b	9d6912e1-d4c4-409f-bb87-2c3eebd802bc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"3.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:48:59
29136	9d6912e1-ce40-4914-beed-80080713f714	9d6912e1-d4c4-409f-bb87-2c3eebd802bc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:48:59
29137	9d6912e1-d358-449a-8538-e90461ea7c9f	9d6912e1-d4c4-409f-bb87-2c3eebd802bc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 13:48:59
14378	9d5d1e16-3bd7-4b0d-822b-d27afd8d5a20	9d5d1e16-849b-4834-9b55-79803b745d99	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-29 15:10:22
14379	9d5d1e16-7a6f-4ecf-9ec3-ab5d739902df	9d5d1e16-849b-4834-9b55-79803b745d99	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 55\\n                        ","time":"146.19","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"ff7240abed4441475e0acd0c74a5f6aa","hostname":"EderCortes"}	2024-10-29 15:10:23
14380	9d5d1e16-7f17-491b-8833-e0d7ec78bfaa	9d5d1e16-849b-4834-9b55-79803b745d99	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '55' order by \\"item_loans\\".\\"id\\" asc","time":"2.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 15:10:23
14381	9d5d1e16-7f4e-4b5c-8e76-f902cbc23c9b	9d5d1e16-849b-4834-9b55-79803b745d99	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":7,"hostname":"EderCortes"}	2024-10-29 15:10:23
14382	9d5d1e16-8343-4157-bbe8-62f80711d2dc	9d5d1e16-849b-4834-9b55-79803b745d99	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-29 15:10:23
14383	9d5d1e16-839c-49c6-a8f5-c56ee62071d0	9d5d1e16-849b-4834-9b55-79803b745d99	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/55","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":55,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":7,"loans_valor_prestado":50000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"15-11-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":150,"loans_codigo":55,"itemloans_cuota":"1","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":151,"loans_codigo":55,"itemloans_cuota":"2","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":152,"loans_codigo":55,"itemloans_cuota":"3","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":153,"loans_codigo":55,"itemloans_cuota":"4","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":154,"loans_codigo":55,"itemloans_cuota":"5","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":155,"loans_codigo":55,"itemloans_cuota":"6","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":156,"loans_codigo":55,"itemloans_cuota":"7","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:10:23
20900	9d66fd8e-1dfa-425b-a637-ca89be96c9cc	9d66fd8e-3b03-4cf6-b13b-67542979fa9f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:57:41
15612	9d648f3a-89af-4d15-bfb8-6ab53028f188	9d648f3a-ab6c-483d-805c-0c5bb1bda7f7	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 07:57:32
15613	9d648f3a-a970-4bf9-8a5d-65d4df117daa	9d648f3a-ab6c-483d-805c-0c5bb1bda7f7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 07:57:32
15614	9d648f3a-aa55-42b2-9d24-be3b3f3c0cf2	9d648f3a-ab6c-483d-805c-0c5bb1bda7f7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":281,"memory":22,"hostname":"EderCortes"}	2024-11-02 07:57:32
20901	9d66fd8e-35d8-4dc9-b288-96712e131120	9d66fd8e-3b03-4cf6-b13b-67542979fa9f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:57:41
20902	9d66fd8e-362e-4382-ab45-094dd1b5c37a	9d66fd8e-3b03-4cf6-b13b-67542979fa9f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:57:41
20903	9d66fd8e-39b6-41ff-8839-6235f0c2eed8	9d66fd8e-3b03-4cf6-b13b-67542979fa9f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:57:41
20904	9d66fd8e-3a04-4107-81c5-1a1d015a5f87	9d66fd8e-3b03-4cf6-b13b-67542979fa9f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":327,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:57:41
15615	9d648f3c-870c-4189-a644-3e0e1d4a661e	9d648f3c-a42c-4872-bb9e-edc25a80c464	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 07:57:33
15616	9d648f3c-9e75-4e26-afa6-fce8341100c9	9d648f3c-a42c-4872-bb9e-edc25a80c464	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"38.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 07:57:34
15617	9d648f3c-9ec4-46db-a5a2-cce5e4b37bcc	9d648f3c-a42c-4872-bb9e-edc25a80c464	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 07:57:34
15618	9d648f3c-a2ca-4a0d-b592-7f678aae5a5d	9d648f3c-a42c-4872-bb9e-edc25a80c464	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 07:57:34
15619	9d648f3c-a313-4719-ad89-248af1dcbac0	9d648f3c-a42c-4872-bb9e-edc25a80c464	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-11-02 07:57:34
29138	9d6912e1-d3ac-4a93-bd7f-d64d79f67625	9d6912e1-d4c4-409f-bb87-2c3eebd802bc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":276,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:48:59
29202	9d6913de-2008-40f3-9bb0-211f66692b99	9d6913de-49a5-4a56-8f03-7c55fea7b8c2	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 13:51:44
29203	9d6913de-46f6-48b6-b540-df001c1b4d86	9d6913de-49a5-4a56-8f03-7c55fea7b8c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 13:51:44
29204	9d6913de-47f8-44e7-9f0b-be5444ca0048	9d6913de-49a5-4a56-8f03-7c55fea7b8c2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:51:44
29205	9d6913de-ac96-43ea-8f1e-2b8c85ba7393	9d6913de-cf7d-4261-b136-dc423207c285	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 13:51:44
29206	9d6913de-c2a9-484b-84a0-acdf5ff29cb6	9d6913de-cf7d-4261-b136-dc423207c285	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"42.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 13:51:44
29207	9d6913de-c642-4529-9e1d-a8a03820ae18	9d6913de-cf7d-4261-b136-dc423207c285	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:51:44
29208	9d6913de-c677-4acf-b402-a2e6a53a518b	9d6913de-cf7d-4261-b136-dc423207c285	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:51:44
29209	9d6913de-ce03-4f4a-aa73-dc4242f867e1	9d6913de-cf7d-4261-b136-dc423207c285	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 13:51:44
29210	9d6913de-ce4e-4d24-9734-5abfd723251e	9d6913de-cf7d-4261-b136-dc423207c285	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":294,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:51:44
29317	9d691812-4f74-43b1-a648-de7e337ada31	9d691813-52ce-4f88-a437-e44f39e02437	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 14:03:29
29318	9d691813-513b-4383-9f6a-2157e2a6c00e	9d691813-52ce-4f88-a437-e44f39e02437	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 14:03:30
29319	9d691813-51dd-40a4-83c6-fb76e11005f8	9d691813-52ce-4f88-a437-e44f39e02437	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":938,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:03:30
29320	9d691813-aa32-4a55-bc70-3611923ccb7b	9d691813-c80c-40c2-b1a1-de0769b0f79b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 14:03:30
29321	9d691813-c2d4-455f-9bbc-584b670cc6c8	9d691813-c80c-40c2-b1a1-de0769b0f79b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"42.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-04 14:03:30
29322	9d691813-c322-4789-96d4-6ad492e0b0fe	9d691813-c80c-40c2-b1a1-de0769b0f79b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 14:03:30
29323	9d691813-c6be-480d-9c10-8c768d0e2488	9d691813-c80c-40c2-b1a1-de0769b0f79b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 14:03:30
29324	9d691813-c706-46a0-8896-6d9838ea09ac	9d691813-c80c-40c2-b1a1-de0769b0f79b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:03:30
29325	9d691815-b2bd-49e8-a413-9bb8091d7954	9d691816-1868-4a94-8829-6f43b5e67871	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 14:03:32
29326	9d691816-1206-46af-a871-88a7c0041512	9d691816-1868-4a94-8829-6f43b5e67871	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"213.67","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:03:32
29327	9d691816-1264-4064-aeb3-870bfae60cd6	9d691816-1868-4a94-8829-6f43b5e67871	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:03:32
29328	9d691816-16de-45ab-9e65-9e4c05f87c14	9d691816-1868-4a94-8829-6f43b5e67871	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 14:03:32
29329	9d691816-174d-4f33-8998-3ffc040214ad	9d691816-1868-4a94-8829-6f43b5e67871	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":624,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:03:32
29625	9d6929f7-8578-418e-aa01-9667288e1038	9d6929f7-a3e0-4a08-abef-95a3e8c96c17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 14:53:32
29626	9d6929f7-a246-44d8-bce2-d644372a6cd0	9d6929f7-a3e0-4a08-abef-95a3e8c96c17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 14:53:32
29627	9d6929f7-a2e9-49f4-9bb9-616835d02872	9d6929f7-a3e0-4a08-abef-95a3e8c96c17	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:53:32
29628	9d6929f7-f45a-4aa6-8a72-6003727f125e	9d6929f8-12ae-4506-9b6b-6a50b6b26d01	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 14:53:32
29629	9d6929f8-0967-40a5-9d9a-a6d9b578afbc	9d6929f8-12ae-4506-9b6b-6a50b6b26d01	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"42.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 14:53:32
17513	9d655c2b-7235-4f3e-a7a4-ea0df5df2fdf	9d655c2b-bee3-44de-bd9a-9f9da4e7ee17	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 17:30:36
17514	9d655c2b-bcee-4581-9406-77f8335d852e	9d655c2b-bee3-44de-bd9a-9f9da4e7ee17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:30:36
17515	9d655c2b-bda2-42fe-9b1e-fc5a8608616b	9d655c2b-bee3-44de-bd9a-9f9da4e7ee17	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":361,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:30:36
29630	9d6929f8-0da5-4a2f-8317-dd6a750dd63c	9d6929f8-12ae-4506-9b6b-6a50b6b26d01	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 14:53:32
29631	9d6929f8-0de5-4027-9f83-d731188a2472	9d6929f8-12ae-4506-9b6b-6a50b6b26d01	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 14:53:32
29538	9d6928fd-ccf6-4114-aa36-711a85baf09b	9d6928fd-f1ec-43fe-8022-aeeae1f268d6	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 14:50:48
29632	9d6929f8-1174-45d2-b977-6f05bcd79f65	9d6929f8-12ae-4506-9b6b-6a50b6b26d01	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 14:53:32
29633	9d6929f8-11be-465b-90ba-f67d190dc032	9d6929f8-12ae-4506-9b6b-6a50b6b26d01	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:53:32
29539	9d6928fd-efc7-4e97-bc72-2562b9cd6935	9d6928fd-f1ec-43fe-8022-aeeae1f268d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 14:50:48
29540	9d6928fd-f084-40d0-a592-b99e6594afdd	9d6928fd-f1ec-43fe-8022-aeeae1f268d6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":321,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:50:48
14603	9d5ebec9-0526-44b6-94d1-f0c3f1d1a748	9d5ebec9-3abe-4292-8946-d83593b800ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-30 10:35:33
14604	9d5ebec9-3805-4ff5-9ecd-4c9663f8e052	9d5ebec9-3abe-4292-8946-d83593b800ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-30 10:35:33
14605	9d5ebec9-392d-4d58-8016-993bf0e5ec30	9d5ebec9-3abe-4292-8946-d83593b800ff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":493,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:35:33
21196	9d6736b0-bf8b-4c03-8b23-8e29ef421382	9d6736b0-dd66-400e-8c6e-517a75469884	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 15:37:27
21197	9d6736b0-db19-4b0c-bc56-5141a513ac91	9d6736b0-dd66-400e-8c6e-517a75469884	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 15:37:27
21198	9d6736b0-dc3a-4cbf-b9b7-be76e05c2b27	9d6736b0-dd66-400e-8c6e-517a75469884	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:37:27
11279	9d5cb233-0f47-41c4-9e4f-d0555e4ed358	9d5cb233-2fa7-4075-baa5-41b1db36a467	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 10:08:42
11280	9d5cb233-2e2b-4d8a-a451-5f8feaa34c2c	9d5cb233-2fa7-4075-baa5-41b1db36a467	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 10:08:42
11281	9d5cb233-2eb7-49c5-919e-03b32f838201	9d5cb233-2fa7-4075-baa5-41b1db36a467	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":242,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:08:42
21199	9d6736b1-2ce2-4239-a5b4-5c9756ae44a0	9d6736b1-4d20-4c91-a08c-69b8c45a7f88	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 15:37:27
14606	9d5ebec9-c052-45ef-b922-a228b448d145	9d5ebec9-e76a-4794-8cdb-038f7651ade0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-30 10:35:33
14607	9d5ebec9-dd39-46dc-903b-8a33ef15ca39	9d5ebec9-e76a-4794-8cdb-038f7651ade0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 55\\n                        ","time":"54.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"ff7240abed4441475e0acd0c74a5f6aa","hostname":"EderCortes"}	2024-10-30 10:35:33
14608	9d5ebec9-e1a0-443d-bae2-8e8a95d3c835	9d5ebec9-e76a-4794-8cdb-038f7651ade0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '55' order by \\"item_loans\\".\\"id\\" asc","time":"2.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-30 10:35:33
14609	9d5ebec9-e1d4-4883-b02a-a57969a1b745	9d5ebec9-e76a-4794-8cdb-038f7651ade0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":7,"hostname":"EderCortes"}	2024-10-30 10:35:33
14610	9d5ebec9-e5f3-432c-9f2f-9d2d7eba69e9	9d5ebec9-e76a-4794-8cdb-038f7651ade0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-30 10:35:33
14611	9d5ebec9-e656-4a62-b823-672d3576e8fe	9d5ebec9-e76a-4794-8cdb-038f7651ade0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/55","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":55,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":7,"loans_valor_prestado":50000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"15-11-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":150,"loans_codigo":55,"itemloans_cuota":"1","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":151,"loans_codigo":55,"itemloans_cuota":"2","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":152,"loans_codigo":55,"itemloans_cuota":"3","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":153,"loans_codigo":55,"itemloans_cuota":"4","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":154,"loans_codigo":55,"itemloans_cuota":"5","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":155,"loans_codigo":55,"itemloans_cuota":"6","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":156,"loans_codigo":55,"itemloans_cuota":"7","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":387,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:35:33
17516	9d655c2c-4caf-456a-afe5-c1b0d78d22e1	9d655c2c-9587-4fb8-9f83-857bebcc6b48	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:30:36
17517	9d655c2c-90b2-4567-a2b1-165ad4a001ef	9d655c2c-9587-4fb8-9f83-857bebcc6b48	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"154.98","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":46,"hash":"fb4ded687569d92428336ceae5c6ffcd","hostname":"EderCortes"}	2024-11-02 17:30:36
15749	9d64af1b-8933-46c3-be71-ebfddb26d5ca	9d64af1b-b20b-4fb8-8dd8-e9e5df355b31	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 09:26:41
15750	9d64af1b-af77-4c4a-8c17-59f080cf3285	9d64af1b-b20b-4fb8-8dd8-e9e5df355b31	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:26:41
17518	9d655c2c-945a-4a09-a6d6-b81799bfa995	9d655c2c-9587-4fb8-9f83-857bebcc6b48	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:30:36
17519	9d655c2c-94ab-454b-97cf-930e310b12b8	9d655c2c-9587-4fb8-9f83-857bebcc6b48	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":514,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:30:36
29541	9d6928fe-58ab-4048-a76e-52a36b1a6fbb	9d6928fe-a2ea-4ce6-b783-84441a741397	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 14:50:48
15751	9d64af1b-b095-49f6-baba-ef452d857952	9d64af1b-b20b-4fb8-8dd8-e9e5df355b31	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":438,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:26:41
17520	9d655c2e-e4da-46eb-8da1-2211c54c766f	9d655c2f-16b5-4a9a-a855-00943265f806	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:30:38
17521	9d655c2f-0c3c-4cfe-9b08-ff94d1317215	9d655c2f-16b5-4a9a-a855-00943265f806	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"69.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 17:30:38
17522	9d655c2f-0ccf-43a1-8014-c282fdefe409	9d655c2f-16b5-4a9a-a855-00943265f806	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 17:30:38
17523	9d655c2f-1421-4d5a-927e-aae01fa95bef	9d655c2f-16b5-4a9a-a855-00943265f806	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:30:38
17524	9d655c2f-14d5-47af-ab3a-8de9a9f223bc	9d655c2f-16b5-4a9a-a855-00943265f806	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":602,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:30:38
21200	9d6736b1-425f-4c31-9389-0d0da18c73f9	9d6736b1-4d20-4c91-a08c-69b8c45a7f88	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 65\\n                        ","time":"41.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6768d7067397538897aacf4d73c43049","hostname":"EderCortes"}	2024-11-03 15:37:27
21201	9d6736b1-46c0-412a-85fc-471c6949df65	9d6736b1-4d20-4c91-a08c-69b8c45a7f88	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '65' order by \\"item_loans\\".\\"id\\" asc","time":"2.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 15:37:27
21202	9d6736b1-4706-4351-a422-f1f67415d366	9d6736b1-4d20-4c91-a08c-69b8c45a7f88	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 15:37:27
21203	9d6736b1-4ba0-4944-81f9-50a1f4ba3b47	9d6736b1-4d20-4c91-a08c-69b8c45a7f88	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 15:37:27
21204	9d6736b1-4bfb-45df-9545-ab692955c13a	9d6736b1-4d20-4c91-a08c-69b8c45a7f88	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/65","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":65,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":3000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-10 00:00:00","loans_pago_prestado":"600000","loans_pago_interes":"180000"},"items":[{"id":207,"loans_codigo":65,"itemloans_cuota":"1","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:02.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":208,"loans_codigo":65,"itemloans_cuota":"2","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":209,"loans_codigo":65,"itemloans_cuota":"3","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":210,"loans_codigo":65,"itemloans_cuota":"4","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":211,"loans_codigo":65,"itemloans_cuota":"5","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":212,"loans_codigo":65,"itemloans_cuota":"6","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":213,"loans_codigo":65,"itemloans_cuota":"7","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":214,"loans_codigo":65,"itemloans_cuota":"8","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":215,"loans_codigo":65,"itemloans_cuota":"9","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":216,"loans_codigo":65,"itemloans_cuota":"10","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-09-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:37:27
15752	9d64af1c-28fc-4b3a-a7db-a244a69766f1	9d64af1c-4ad7-465d-947a-e99433502af7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:26:41
15753	9d64af1c-40e0-4ce1-bf49-ad14e126b769	9d64af1c-4ad7-465d-947a-e99433502af7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"46.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"088d1fdbe045a08c3b0073ef22c7da32","hostname":"EderCortes"}	2024-11-02 09:26:41
15754	9d64af1c-4488-4154-a3d9-e667caa202d1	9d64af1c-4ad7-465d-947a-e99433502af7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:26:41
15755	9d64af1c-44c0-426b-b0ea-adccaf50d2e0	9d64af1c-4ad7-465d-947a-e99433502af7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 09:26:41
15756	9d64af1c-4986-4e94-8d23-42116553511c	9d64af1c-4ad7-465d-947a-e99433502af7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:26:41
15757	9d64af1c-49e4-4876-bca6-a4d39d48c765	9d64af1c-4ad7-465d-947a-e99433502af7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:26:41
21205	9d6736b2-98f9-4776-80dd-8c1b65bfc71d	9d6736b2-d636-4065-89ab-260e4b060426	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 15:37:28
21206	9d6736b2-c8d9-4558-935e-09d9e4777a91	9d6736b2-d636-4065-89ab-260e4b060426	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"77.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 15:37:28
21207	9d6736b2-c9a4-46ec-bd8f-2ae2625625aa	9d6736b2-d636-4065-89ab-260e4b060426	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 15:37:28
21208	9d6736b2-d3ae-4165-8827-81c91448a4bf	9d6736b2-d636-4065-89ab-260e4b060426	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 15:37:28
21209	9d6736b2-d473-407a-804d-346bb50e37d4	9d6736b2-d636-4065-89ab-260e4b060426	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":467,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:37:28
15758	9d64af1e-4dcf-441e-9fcf-9cb88c685887	9d64af1e-6d9e-4222-8a75-22a24c7d4d39	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:26:42
15759	9d64af1e-682b-4dbd-8d30-449a74621ccf	9d64af1e-6d9e-4222-8a75-22a24c7d4d39	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 09:26:42
15760	9d64af1e-6886-4f7b-a504-4e04c411b4d8	9d64af1e-6d9e-4222-8a75-22a24c7d4d39	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 09:26:42
15761	9d64af1e-6c21-4f56-8021-b44b4da78959	9d64af1e-6d9e-4222-8a75-22a24c7d4d39	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 09:26:42
15762	9d64af1e-6c7d-4727-9ad1-76db326a03b9	9d64af1e-6d9e-4222-8a75-22a24c7d4d39	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":315,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:26:42
29542	9d6928fe-97c3-451d-87ee-cc747a497273	9d6928fe-a2ea-4ce6-b783-84441a741397	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"147.99","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 14:50:49
29543	9d6928fe-9bfc-4924-85da-d1d9ae2809b2	9d6928fe-a2ea-4ce6-b783-84441a741397	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 14:50:49
29544	9d6928fe-9c36-405b-bbee-ac06594a9ace	9d6928fe-a2ea-4ce6-b783-84441a741397	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 14:50:49
29545	9d6928fe-a16e-42e8-9d00-4c8195e2a62f	9d6928fe-a2ea-4ce6-b783-84441a741397	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 14:50:49
29546	9d6928fe-a1de-44ec-a438-4dd757a5d486	9d6928fe-a2ea-4ce6-b783-84441a741397	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":401,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:50:49
29741	9d692af2-dfbb-45eb-90e6-45b39d1a5c41	9d692af3-05a8-4f13-b2fd-46effb406ac9	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 14:56:16
29742	9d692af3-0399-4fb8-9b9a-74e55c5594e8	9d692af3-05a8-4f13-b2fd-46effb406ac9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 14:56:16
29743	9d692af3-0456-47a4-bded-f4c736586fbe	9d692af3-05a8-4f13-b2fd-46effb406ac9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":282,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:56:16
29744	9d692af3-6f5e-4f12-958b-f1b403b0cf28	9d692af3-bcc5-4808-bdfc-ec0f0cc72e4b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 14:56:17
29745	9d692af3-b35f-4426-b4a0-ac929d05c4cf	9d692af3-bcc5-4808-bdfc-ec0f0cc72e4b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"151.77","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 14:56:17
12960	9d5cef98-5bb3-48dc-8a83-1a02004743a7	9d5cef98-8062-402a-b071-5026adfd7a9f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 13:00:22
12961	9d5cef98-7e36-4270-9407-36ba3cc1526b	9d5cef98-8062-402a-b071-5026adfd7a9f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 13:00:23
12962	9d5cef98-7f24-44d9-a698-6afc0f7ad930	9d5cef98-8062-402a-b071-5026adfd7a9f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":261,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:00:23
29746	9d692af3-b704-4394-868d-91d849a4898b	9d692af3-bcc5-4808-bdfc-ec0f0cc72e4b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"1.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 14:56:17
29747	9d692af3-b738-4855-a29b-52c6be3251b5	9d692af3-bcc5-4808-bdfc-ec0f0cc72e4b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 14:56:17
15849	9d64b1cf-2e22-45b1-881e-27e9413ed4c9	9d64b1cf-8b77-49e8-9030-4a287d9eb7d3	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 09:34:14
15850	9d64b1cf-87ec-4a67-8fdc-48d1e7e4f32c	9d64b1cf-8b77-49e8-9030-4a287d9eb7d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:34:14
15851	9d64b1cf-89e6-47ed-9a60-701fff1c6d20	9d64b1cf-8b77-49e8-9030-4a287d9eb7d3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":504,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:34:14
29748	9d692af3-bb9b-4696-89f6-8de4e239f934	9d692af3-bcc5-4808-bdfc-ec0f0cc72e4b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 14:56:17
29749	9d692af3-bbe5-40a2-a623-87a2bdf3759e	9d692af3-bcc5-4808-bdfc-ec0f0cc72e4b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":416,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:56:17
15852	9d64b1cf-f685-4d33-9276-ad7edbfc2b9e	9d64b1d0-479d-47a6-9f85-e19cc77f8a56	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:34:14
15853	9d64b1d0-3b1e-4754-b26b-20553d3fdf95	9d64b1d0-479d-47a6-9f85-e19cc77f8a56	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"160.91","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"088d1fdbe045a08c3b0073ef22c7da32","hostname":"EderCortes"}	2024-11-02 09:34:15
15854	9d64b1d0-404d-4f8d-b57e-16202be76527	9d64b1d0-479d-47a6-9f85-e19cc77f8a56	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"3.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:34:15
15855	9d64b1d0-409e-4a89-a730-bdba017d4952	9d64b1d0-479d-47a6-9f85-e19cc77f8a56	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 09:34:15
15856	9d64b1d0-462b-4baf-a463-ec24f2669cd8	9d64b1d0-479d-47a6-9f85-e19cc77f8a56	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:34:15
15857	9d64b1d0-4696-4a66-98f0-9abecfa8db58	9d64b1d0-479d-47a6-9f85-e19cc77f8a56	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":438,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:34:15
15858	9d64b1d2-371b-45ab-9a67-c7c9f75b1ffa	9d64b1d2-5661-4e9f-8125-8e37befc922f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:34:16
15859	9d64b1d2-5158-47fa-a6e8-a063b7a6eb65	9d64b1d2-5661-4e9f-8125-8e37befc922f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"47.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 09:34:16
15860	9d64b1d2-51a8-4eaa-8bfe-98eb77afb553	9d64b1d2-5661-4e9f-8125-8e37befc922f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 09:34:16
15861	9d64b1d2-54fd-40fe-ad01-b11423cf3207	9d64b1d2-5661-4e9f-8125-8e37befc922f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 09:34:16
15862	9d64b1d2-555b-4133-b7f6-b2e38718145b	9d64b1d2-5661-4e9f-8125-8e37befc922f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":264,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:34:16
29818	9d692bdd-0838-43f0-82f6-973c5c22b8ce	9d692bdd-2e8d-4978-9e43-b6e1218ae6e3	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 14:58:50
29819	9d692bdd-2c3f-4b21-a393-5fe9901c4fde	9d692bdd-2e8d-4978-9e43-b6e1218ae6e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 14:58:50
29820	9d692bdd-2d64-4114-afd8-5721079e181e	9d692bdd-2e8d-4978-9e43-b6e1218ae6e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":326,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:58:50
21373	9d67399c-ab9c-45e4-bc1d-b34af8f27cf1	9d67399c-fbe4-43f0-953e-029cd85107f7	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 15:45:37
21374	9d67399c-f983-4e29-8009-fab906f0fa01	9d67399c-fbe4-43f0-953e-029cd85107f7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:45:37
21375	9d67399c-fa86-426a-8f9a-e12235347211	9d67399c-fbe4-43f0-953e-029cd85107f7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":426,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:45:37
29821	9d692bdd-8ea4-4b42-8e22-99e172dd27ae	9d692bdd-af56-4f7d-8f54-010fb75b14fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 14:58:50
29822	9d692bdd-a550-425c-8af6-10c352731b15	9d692bdd-af56-4f7d-8f54-010fb75b14fa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"45.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 14:58:50
29823	9d692bdd-a970-4c9a-bd49-64ffd8149162	9d692bdd-af56-4f7d-8f54-010fb75b14fa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"1.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 14:58:50
29824	9d692bdd-a9ad-4439-b53f-b42409d71e70	9d692bdd-af56-4f7d-8f54-010fb75b14fa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 14:58:50
29825	9d692bdd-ae0e-4139-be01-e8f6444a5f50	9d692bdd-af56-4f7d-8f54-010fb75b14fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 14:58:50
21376	9d67399d-6bf9-4aa6-9793-258c0eaacbe8	9d67399d-8d36-4bba-92ac-6ad95b0974a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:45:38
17827	9d65b0cc-de76-40fe-b64d-4837ae6d4278	9d65b0cd-0bf9-4157-a703-cae849fa06dd	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 21:27:14
17828	9d65b0cd-0921-49f8-a559-04ebe20ed4f8	9d65b0cd-0bf9-4157-a703-cae849fa06dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:27:14
17829	9d65b0cd-0a65-4c9f-b8ad-8cd83e914b43	9d65b0cd-0bf9-4157-a703-cae849fa06dd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":371,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:27:14
12695	9d5cecb0-51f6-47f5-aa05-c623ad2dddd2	9d5cecb0-8a7b-4c2e-a6fd-03c4bc022926	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-29 12:52:15
12696	9d5cecb0-87c4-46b9-b805-55aa12a51524	9d5cecb0-8a7b-4c2e-a6fd-03c4bc022926	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-29 12:52:15
12697	9d5cecb0-8905-4a03-b888-68426d5f7f2e	9d5cecb0-8a7b-4c2e-a6fd-03c4bc022926	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":537,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:15
21377	9d67399d-82c7-4cbf-a646-204f70cf86d7	9d67399d-8d36-4bba-92ac-6ad95b0974a5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 65\\n                        ","time":"46.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6768d7067397538897aacf4d73c43049","hostname":"EderCortes"}	2024-11-03 15:45:38
21378	9d67399d-86bd-49d6-9aac-e6630cba9846	9d67399d-8d36-4bba-92ac-6ad95b0974a5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '65' order by \\"item_loans\\".\\"id\\" asc","time":"2.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 15:45:38
21379	9d67399d-86fc-4ddf-bfb8-9830862bfe3e	9d67399d-8d36-4bba-92ac-6ad95b0974a5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 15:45:38
21380	9d67399d-8ba2-452b-ab56-bb27a67ee1c8	9d67399d-8d36-4bba-92ac-6ad95b0974a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:45:38
21381	9d67399d-8c02-4323-bcea-cfa70cf7ff38	9d67399d-8d36-4bba-92ac-6ad95b0974a5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/65","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":65,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":3000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-10 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":207,"loans_codigo":65,"itemloans_cuota":"1","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:44:10.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":208,"loans_codigo":65,"itemloans_cuota":"2","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":209,"loans_codigo":65,"itemloans_cuota":"3","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":210,"loans_codigo":65,"itemloans_cuota":"4","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":211,"loans_codigo":65,"itemloans_cuota":"5","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":212,"loans_codigo":65,"itemloans_cuota":"6","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":213,"loans_codigo":65,"itemloans_cuota":"7","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":214,"loans_codigo":65,"itemloans_cuota":"8","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":215,"loans_codigo":65,"itemloans_cuota":"9","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":216,"loans_codigo":65,"itemloans_cuota":"10","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-09-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":297,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:45:38
29826	9d692bdd-ae67-4140-96b6-8f2daae1f42f	9d692bdd-af56-4f7d-8f54-010fb75b14fa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":285,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:58:50
29471	9d69280f-9004-45e7-bd25-2f4a317e66aa	9d69280f-b8c4-4ad3-9d43-3181c2aa1a21	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 14:48:12
29472	9d69280f-b6a9-4f03-af87-98707717c661	9d69280f-b8c4-4ad3-9d43-3181c2aa1a21	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 14:48:12
29473	9d69280f-b792-4301-811b-16682447f1d5	9d69280f-b8c4-4ad3-9d43-3181c2aa1a21	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":337,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:48:12
12698	9d5cecb1-2035-44db-9e01-2066f9273848	9d5cecb1-78f5-4c6e-b550-3c8b7d61fa68	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-29 12:52:15
12699	9d5cecb1-6d39-46e7-9751-a3aef09e982e	9d5cecb1-78f5-4c6e-b550-3c8b7d61fa68	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"160.77","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":180,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 12:52:16
12700	9d5cecb1-6dbd-46a3-8cc4-64bd2ab3f959	9d5cecb1-78f5-4c6e-b550-3c8b7d61fa68	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 12:52:16
12701	9d5cecb1-769e-46b8-8ca5-df62d37fe9aa	9d5cecb1-78f5-4c6e-b550-3c8b7d61fa68	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-29 12:52:16
12702	9d5cecb1-7732-4c15-9b04-705701e45fc2	9d5cecb1-78f5-4c6e-b550-3c8b7d61fa68	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":549,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:16
17830	9d65b0cd-8999-46a6-ac4f-101be8637171	9d65b0cd-b610-46b1-ba20-cd32490cac47	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:27:15
17831	9d65b0cd-a6ec-4c08-802b-34ade1339b18	9d65b0cd-b610-46b1-ba20-cd32490cac47	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"57.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 21:27:15
17832	9d65b0cd-ac1f-45d2-8ed1-038e1c800101	9d65b0cd-b610-46b1-ba20-cd32490cac47	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:27:15
17833	9d65b0cd-ac65-4503-8913-588c77737db6	9d65b0cd-b610-46b1-ba20-cd32490cac47	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:27:15
17834	9d65b0cd-b3d2-412f-b4ba-3078f5d71f1b	9d65b0cd-b610-46b1-ba20-cd32490cac47	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:27:15
17835	9d65b0cd-b46e-45c7-b133-0a823b45ff03	9d65b0cd-b610-46b1-ba20-cd32490cac47	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:34:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"}]}},"duration":365,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:27:15
21382	9d67399f-93b0-4c96-88ea-dcc65dd45766	9d67399f-b568-4286-905b-c8f107a99e08	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:45:39
21383	9d67399f-b0ac-4bdb-8c09-453ef4cbd7a4	9d67399f-b568-4286-905b-c8f107a99e08	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"48.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 15:45:39
21384	9d67399f-b0f7-4d23-b8ea-0026d68133e0	9d67399f-b568-4286-905b-c8f107a99e08	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 15:45:39
21385	9d67399f-b43d-47c0-adec-3a7a65711372	9d67399f-b568-4286-905b-c8f107a99e08	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 15:45:39
29474	9d692810-365e-46ed-8ca8-7d6b45fc5098	9d692810-58ac-4786-86e6-e3b64c1059e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 14:48:12
12703	9d5cecb1-f17e-4603-8ab3-7fa368a3182a	9d5cecb2-13ad-4df5-8a00-2e752dea52d4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-29 12:52:16
12704	9d5cecb2-0e40-40fe-bf30-2eaabb9f781b	9d5cecb2-13ad-4df5-8a00-2e752dea52d4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":180,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 12:52:16
12705	9d5cecb2-0e9d-4529-8f38-1fc963a93fd2	9d5cecb2-13ad-4df5-8a00-2e752dea52d4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 12:52:16
12706	9d5cecb2-126c-4021-8e88-83c0cbfb16a5	9d5cecb2-13ad-4df5-8a00-2e752dea52d4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-10-29 12:52:16
12289	9d5ce1d6-345c-42a1-ab0e-471483eaad48	9d5ce1d6-594e-4764-9fd6-c7bce49cd258	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 12:21:54
12290	9d5ce1d6-56fc-4a5d-9e77-e239720a226d	9d5ce1d6-594e-4764-9fd6-c7bce49cd258	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:21:54
12291	9d5ce1d6-5825-4d6d-9a5c-f8873dc99fdc	9d5ce1d6-594e-4764-9fd6-c7bce49cd258	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":301,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:21:54
12707	9d5cecb2-12cf-49fa-b3c7-5cdd4525d9f9	9d5cecb2-13ad-4df5-8a00-2e752dea52d4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:16
29475	9d692810-4dc1-40d1-8e32-1018b3ed868f	9d692810-58ac-4786-86e6-e3b64c1059e5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"44.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 14:48:12
17671	9d6560a2-c924-4de8-8475-0ad6d90b0f02	9d6560a2-ea43-48e4-9640-f0d81ed48d53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:43:05
15949	9d64b66a-fb80-4213-98b7-f041735633ce	9d64b66b-1ed6-4fa5-8947-e120c414b76a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 09:47:07
15950	9d64b66b-1c5f-4c74-8e07-aaffe2e018ad	9d64b66b-1ed6-4fa5-8947-e120c414b76a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:47:07
15951	9d64b66b-1da9-4d9c-a5dc-4782a9ff0970	9d64b66b-1ed6-4fa5-8947-e120c414b76a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":302,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:47:07
17672	9d6560a2-e7c6-4667-9525-5137a2b72592	9d6560a2-ea43-48e4-9640-f0d81ed48d53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 17:43:05
17673	9d6560a2-e8cf-4f89-bd75-0f34db2056d5	9d6560a2-ea43-48e4-9640-f0d81ed48d53	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":272,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:43:05
29476	9d692810-51c8-4eaf-bebd-d88a1dd18bcd	9d692810-58ac-4786-86e6-e3b64c1059e5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 14:48:12
29477	9d692810-51fd-4a63-a51f-4acee4b8cb1a	9d692810-58ac-4786-86e6-e3b64c1059e5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 14:48:12
17836	9d65b0d0-905e-4857-9a87-9b1e0dd20930	9d65b0d0-c494-4089-a949-0858483066e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:27:17
29478	9d692810-5779-4bdd-a491-21b096a46b22	9d692810-58ac-4786-86e6-e3b64c1059e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 14:48:12
12292	9d5ce1d6-bb01-4d40-9042-348aa3d75ce8	9d5ce1d6-dcc2-4dbd-bb49-73396287e8ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 12:21:54
12293	9d5ce1d6-d5e7-47fc-8385-916fce65e285	9d5ce1d6-dcc2-4dbd-bb49-73396287e8ac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":177,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 12:21:55
12294	9d5ce1d6-d639-40b0-a624-f979bd7b7233	9d5ce1d6-dcc2-4dbd-bb49-73396287e8ac	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 12:21:55
12295	9d5ce1d6-db26-4d68-b2c8-56f12c7d589c	9d5ce1d6-dcc2-4dbd-bb49-73396287e8ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:21:55
12296	9d5ce1d6-dba3-439b-929f-64ea401b0e56	9d5ce1d6-dcc2-4dbd-bb49-73396287e8ac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":302,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:21:55
15952	9d64b66b-80fa-4363-b206-5a35f48117a2	9d64b66b-a023-497c-93a0-4b4b22c12b2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:47:07
17674	9d6560a3-40f4-4f23-a0ad-0506fd292336	9d6560a3-5e0d-4734-a38b-2962824dc2c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 17:43:05
12708	9d5cecb3-7593-434a-a255-9d035c8298aa	9d5cecb4-6da8-46ed-a044-dc730367b05b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-10-29 12:52:17
12709	9d5cecb4-643a-4709-ab17-f7bf18e4c7f4	9d5cecb4-6da8-46ed-a044-dc730367b05b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"377.05","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 12:52:17
12710	9d5cecb4-64b5-432a-9627-54c3e591a82e	9d5cecb4-6da8-46ed-a044-dc730367b05b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 12:52:17
12711	9d5cecb4-6baa-483e-96b9-44c86d72f57f	9d5cecb4-6da8-46ed-a044-dc730367b05b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-10-29 12:52:17
12712	9d5cecb4-6c1c-41cf-97c3-7ff9a5b526f2	9d5cecb4-6da8-46ed-a044-dc730367b05b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":1517,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:17
12722	9d5cecb8-8af9-48d0-bf12-f10c1dd877a3	9d5cecb8-aef9-4fd2-bf40-daa5ee9bef19	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-10-29 12:52:20
12723	9d5cecb8-a4a9-49ff-b519-79a7638acc9f	9d5cecb8-aef9-4fd2-bf40-daa5ee9bef19	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 28\\n                        ","time":"50.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150,"hash":"618a8b500e46ad393f7c65ceec660399","hostname":"EderCortes"}	2024-10-29 12:52:20
12724	9d5cecb8-a8b9-4604-bb91-200f33757be2	9d5cecb8-aef9-4fd2-bf40-daa5ee9bef19	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '28' order by \\"item_loans\\".\\"id\\" asc","time":"2.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":178,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 12:52:20
12725	9d5cecb8-a8fb-47d0-90b5-93b2d8d52cd0	9d5cecb8-aef9-4fd2-bf40-daa5ee9bef19	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-10-29 12:52:20
12726	9d5cecb8-ad78-497b-b8eb-68091e9c5246	9d5cecb8-aef9-4fd2-bf40-daa5ee9bef19	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-10-29 12:52:20
12297	9d5ce1d7-213a-43ad-af2e-cfcdce367e24	9d5ce1d7-4003-44c2-ac09-4d0fe809be82	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:21:55
12298	9d5ce1d7-3ace-4d8b-871e-660d09fc2757	9d5ce1d7-4003-44c2-ac09-4d0fe809be82	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":177,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 12:21:55
12299	9d5ce1d7-3b2f-4671-bf12-9afa19118f43	9d5ce1d7-4003-44c2-ac09-4d0fe809be82	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 12:21:55
12300	9d5ce1d7-3efa-4243-ba9f-eca12fe8b75a	9d5ce1d7-4003-44c2-ac09-4d0fe809be82	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 12:21:55
12301	9d5ce1d7-3f3b-4e15-94b7-243f8a4b22e5	9d5ce1d7-4003-44c2-ac09-4d0fe809be82	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:21:55
17837	9d65b0d0-b9e2-4f9e-b08a-4b70f3715b78	9d65b0d0-c494-4089-a949-0858483066e7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"69.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 21:27:17
17838	9d65b0d0-ba61-4037-9a22-f1a0a35e1998	9d65b0d0-c494-4089-a949-0858483066e7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 21:27:17
12713	9d5cecb5-360b-4521-885e-47233aa705c0	9d5cecb5-a4ad-4d80-81b6-cf0616cb65b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-10-29 12:52:18
12714	9d5cecb5-99a9-4cfd-bc7c-a2a4ab64bb11	9d5cecb5-a4ad-4d80-81b6-cf0616cb65b6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"172.22","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 12:52:18
12715	9d5cecb5-9a47-481c-a700-d5366ca4511c	9d5cecb5-a4ad-4d80-81b6-cf0616cb65b6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 12:52:18
12716	9d5cecb5-a2ac-4f12-91c7-c41b49ece0d7	9d5cecb5-a4ad-4d80-81b6-cf0616cb65b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-10-29 12:52:18
12717	9d5cecb5-a33e-4a31-941e-a79617e81ed4	9d5cecb5-a4ad-4d80-81b6-cf0616cb65b6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":774,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:18
12727	9d5cecb8-ade6-4620-9b59-93512667f629	9d5cecb8-aef9-4fd2-bf40-daa5ee9bef19	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/28","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":28,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":600081,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":94,"loans_codigo":28,"itemloans_cuota":"1","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":95,"loans_codigo":28,"itemloans_cuota":"2","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":96,"loans_codigo":28,"itemloans_cuota":"3","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":97,"loans_codigo":28,"itemloans_cuota":"4","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":98,"loans_codigo":28,"itemloans_cuota":"5","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null},{"id":99,"loans_codigo":28,"itemloans_cuota":"6","itemloans_valor_cuota":"100013.5","itemloans_iteres":"12501.6875","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:30:53.000000Z","updated_at":"2024-10-29T16:30:53.000000Z","deleted_at":null}]}},"duration":279,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:20
17839	9d65b0d0-c261-432c-8817-6386202c75df	9d65b0d0-c494-4089-a949-0858483066e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 21:27:17
12302	9d5ce1d9-0c47-4be2-982b-45fb90e5583f	9d5ce1d9-585e-4ef4-8892-aa6fd954d87b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 12:21:56
12303	9d5ce1d9-512b-483b-8ef5-d06e0271c857	9d5ce1d9-585e-4ef4-8892-aa6fd954d87b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"150.59","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 12:21:56
12304	9d5ce1d9-51b3-456e-86d6-8e5296c2b7e9	9d5ce1d9-585e-4ef4-8892-aa6fd954d87b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 12:21:56
12305	9d5ce1d9-56b9-4b93-a4db-d409847839fd	9d5ce1d9-585e-4ef4-8892-aa6fd954d87b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 12:21:56
12306	9d5ce1d9-5710-45cb-98d5-922061a90ea5	9d5ce1d9-585e-4ef4-8892-aa6fd954d87b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":436,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:21:56
15953	9d64b66b-9678-4e7e-8ddf-9101d952d70b	9d64b66b-a023-497c-93a0-4b4b22c12b2b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 22\\n                        ","time":"42.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"f9344e277d181987f84c6dcddcb4342d","hostname":"EderCortes"}	2024-11-02 09:47:07
15954	9d64b66b-9a71-457b-847d-774af2108de0	9d64b66b-a023-497c-93a0-4b4b22c12b2b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '22' order by \\"item_loans\\".\\"id\\" asc","time":"2.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:47:07
15955	9d64b66b-9aad-4af8-981b-7c9084c7e015	9d64b66b-a023-497c-93a0-4b4b22c12b2b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-02 09:47:07
15956	9d64b66b-9ed7-4cab-86ed-f97e7e0ad221	9d64b66b-a023-497c-93a0-4b4b22c12b2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:47:07
15957	9d64b66b-9f43-4684-8713-ac1cb65fe2fe	9d64b66b-a023-497c-93a0-4b4b22c12b2b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/22","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":22,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":70,"loans_codigo":22,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":71,"loans_codigo":22,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":72,"loans_codigo":22,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":73,"loans_codigo":22,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":74,"loans_codigo":22,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":75,"loans_codigo":22,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-04-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":276,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:47:07
17840	9d65b0d0-c309-4000-9fb6-8c1d318caf79	9d65b0d0-c494-4089-a949-0858483066e7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":595,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:27:17
12307	9d5ce1e3-8bb1-4087-a18c-8416f0267117	9d5ce1e3-8e7a-4911-a957-52fe652b713b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":143,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:22:03
15958	9d64b66d-757e-4870-98eb-5b2d780c30f4	9d64b66d-91d2-4384-a8db-9dd54ee7142f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:47:09
15959	9d64b66d-8cb6-4762-ba0c-1ae8e3d7e37a	9d64b66d-91d2-4384-a8db-9dd54ee7142f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"39.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 09:47:09
15960	9d64b66d-8d09-4115-a2c7-f69fb0ea968a	9d64b66d-91d2-4384-a8db-9dd54ee7142f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 09:47:09
15961	9d64b66d-9075-439c-8306-7a6eb5052966	9d64b66d-91d2-4384-a8db-9dd54ee7142f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 09:47:09
15962	9d64b66d-90c2-4200-a805-abbfa80c8d25	9d64b66d-91d2-4384-a8db-9dd54ee7142f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":219,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:47:09
17675	9d6560a3-5951-4f9e-a452-4cd1a130222a	9d6560a3-5e0d-4734-a38b-2962824dc2c3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"43.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":57,"hash":"2cc591e3eaf2792109e07ba331bc077f","hostname":"EderCortes"}	2024-11-02 17:43:05
17676	9d6560a3-5cd1-445c-9eb9-a75d98959890	9d6560a3-5e0d-4734-a38b-2962824dc2c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 17:43:05
17677	9d6560a3-5d25-47e5-bdf5-6e91df809bf9	9d6560a3-5e0d-4734-a38b-2962824dc2c3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"7","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:43:05
29479	9d692810-57d0-4bc8-9b4c-75733689fb6a	9d692810-58ac-4786-86e6-e3b64c1059e5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":298,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:48:12
12308	9d5ce1e4-45bc-4c95-8785-b82934f8cb7c	9d5ce1e4-886d-4d24-a765-0964bddb8df5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 12:22:03
12309	9d5ce1e4-8406-4157-8ee6-801fb81683ed	9d5ce1e4-886d-4d24-a765-0964bddb8df5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and \\"users\\".\\"name\\"::text like '%Eder%' or \\"users\\".\\"user_document\\"::text like '%Eder%' order by \\"users\\".\\"user_document\\" asc","time":"142.13","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":72,"hash":"346e96d5b86098f6cea2c4bc11d5ca30","hostname":"EderCortes"}	2024-10-29 12:22:04
12310	9d5ce1e4-8749-446f-a687-ca48df2a7dbb	9d5ce1e4-886d-4d24-a765-0964bddb8df5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 12:22:04
12311	9d5ce1e4-878b-44c2-9446-8b6670003d6e	9d5ce1e4-886d-4d24-a765-0964bddb8df5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Eder"},"session":[],"response_status":200,"response":{"data":[]},"duration":320,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:22:04
17678	9d6560a5-91fd-469a-8282-0d87febf05c7	9d6560a5-dfec-4800-9660-5258c079eab5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 17:43:07
17679	9d6560a5-db7c-430d-be8f-f00ab4d4f398	9d6560a5-dfec-4800-9660-5258c079eab5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"151.15","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 17:43:07
17680	9d6560a5-dbc7-4e07-a756-4f3410a40121	9d6560a5-dfec-4800-9660-5258c079eab5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 17:43:07
17681	9d6560a5-dec7-4b1f-b200-282487434b76	9d6560a5-dfec-4800-9660-5258c079eab5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 17:43:07
17682	9d6560a5-df0d-4005-83a0-6f43135abcfb	9d6560a5-dfec-4800-9660-5258c079eab5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":637,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:43:07
21386	9d67399f-b480-44b4-a34c-c24702e9fcc3	9d67399f-b568-4286-905b-c8f107a99e08	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":269,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:45:39
21387	9d6739b2-f110-40bd-9c8f-895fcdfae2d2	9d6739b3-0d60-4628-a378-111b0566fa1d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 15:45:52
21388	9d6739b3-0930-441f-9b9a-1a70ce693a95	9d6739b3-0d60-4628-a378-111b0566fa1d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"40.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 15:45:52
21389	9d6739b3-0c10-4276-941a-6a3a8178a1be	9d6739b3-0d60-4628-a378-111b0566fa1d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 15:45:52
21390	9d6739b3-0c69-40fb-b92e-b8d0abad282d	9d6739b3-0d60-4628-a378-111b0566fa1d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":null,"loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":422,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:45:52
21391	9d6739bf-27e6-4649-9cb7-c7b0440244c8	9d6739bf-4601-4e32-9d98-6b10038430b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 15:46:00
21392	9d6739bf-3d78-4f2f-9981-de506ac2bbe7	9d6739bf-4601-4e32-9d98-6b10038430b6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 65\\n                        ","time":"41.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6768d7067397538897aacf4d73c43049","hostname":"EderCortes"}	2024-11-03 15:46:00
21393	9d6739bf-40dc-4132-9722-82383cb9245f	9d6739bf-4601-4e32-9d98-6b10038430b6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '65' order by \\"item_loans\\".\\"id\\" asc","time":"1.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 15:46:00
21394	9d6739bf-4111-4239-8d1a-d9262f2ba8ed	9d6739bf-4601-4e32-9d98-6b10038430b6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 15:46:00
21395	9d6739bf-44a9-4164-a278-04c293b9f5c5	9d6739bf-4601-4e32-9d98-6b10038430b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 15:46:00
21396	9d6739bf-44fc-4a71-8027-640e8347a00b	9d6739bf-4601-4e32-9d98-6b10038430b6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/65","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":65,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":3000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-10 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":207,"loans_codigo":65,"itemloans_cuota":"1","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:44:10.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":208,"loans_codigo":65,"itemloans_cuota":"2","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":209,"loans_codigo":65,"itemloans_cuota":"3","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":210,"loans_codigo":65,"itemloans_cuota":"4","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":211,"loans_codigo":65,"itemloans_cuota":"5","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":212,"loans_codigo":65,"itemloans_cuota":"6","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":213,"loans_codigo":65,"itemloans_cuota":"7","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":214,"loans_codigo":65,"itemloans_cuota":"8","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":215,"loans_codigo":65,"itemloans_cuota":"9","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":216,"loans_codigo":65,"itemloans_cuota":"10","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-09-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:46:00
21397	9d6739c9-a0fb-431f-bba1-6458f6281128	9d6739c9-a3fe-4ddd-b8b5-fa5ddeb344f6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":156,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:46:07
29963	9d692d71-f125-4d22-a8ce-1b10c266e1b3	9d692d72-171f-48f9-b006-8d8a32b8032b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 15:03:15
29964	9d692d72-1557-424c-9a48-760107e2fd60	9d692d72-171f-48f9-b006-8d8a32b8032b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:03:15
29965	9d692d72-160e-4038-b2b1-0ea78c98ecac	9d692d72-171f-48f9-b006-8d8a32b8032b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:03:15
16039	9d64b84b-9630-401e-95df-7cb5025c6393	9d64b84b-bd07-491b-b1c0-66ead883fc14	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 09:52:22
16040	9d64b84b-bb07-48f3-9e08-af965173da00	9d64b84b-bd07-491b-b1c0-66ead883fc14	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:52:22
16041	9d64b84b-bbd6-4b18-b30c-0eb312cdf9f8	9d64b84b-bd07-491b-b1c0-66ead883fc14	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:52:22
16042	9d64b84c-1492-452c-b869-e0353a670480	9d64b84c-34df-4497-af11-5adf60dd3211	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:52:22
16043	9d64b84c-2b23-4b52-a71e-4bbf7972849f	9d64b84c-34df-4497-af11-5adf60dd3211	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 22\\n                        ","time":"46.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"f9344e277d181987f84c6dcddcb4342d","hostname":"EderCortes"}	2024-11-02 09:52:22
16044	9d64b84c-2ed7-4c2e-9954-d5732c797e71	9d64b84c-34df-4497-af11-5adf60dd3211	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '22' order by \\"item_loans\\".\\"id\\" asc","time":"2.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:52:22
11944	9d5cd8db-7495-49c6-968e-15b5cdc041e8	9d5cd8db-95cb-47b9-8f5e-7e0ebe905410	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 11:56:48
11945	9d5cd8db-9401-40f6-ac99-049280621742	9d5cd8db-95cb-47b9-8f5e-7e0ebe905410	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 11:56:48
11946	9d5cd8db-94d1-452a-8306-883b3b5887f4	9d5cd8db-95cb-47b9-8f5e-7e0ebe905410	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:56:48
16045	9d64b84c-2f11-4867-b43c-75402ea8979b	9d64b84c-34df-4497-af11-5adf60dd3211	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-02 09:52:22
16046	9d64b84c-3347-47dc-bbd5-a97230de68a8	9d64b84c-34df-4497-af11-5adf60dd3211	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:52:22
16047	9d64b84c-339b-4006-acd5-99a03a88404d	9d64b84c-34df-4497-af11-5adf60dd3211	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/22","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":22,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":70,"loans_codigo":22,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":71,"loans_codigo":22,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":72,"loans_codigo":22,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":73,"loans_codigo":22,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":74,"loans_codigo":22,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":75,"loans_codigo":22,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-04-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":269,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:52:22
29966	9d692d72-7b6f-41b1-9352-a6293ee89b03	9d692d72-c693-4aad-b375-463608ab2e57	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:03:16
29967	9d692d72-bcbb-47ab-9f49-e2021d2550f9	9d692d72-c693-4aad-b375-463608ab2e57	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"152.74","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 15:03:16
29968	9d692d72-c0b2-4486-ab9f-d040c0c7b96d	9d692d72-c693-4aad-b375-463608ab2e57	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 15:03:16
29969	9d692d72-c0ed-4f71-9cf2-cd77e3bb44eb	9d692d72-c693-4aad-b375-463608ab2e57	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 15:03:16
29970	9d692d72-c569-447d-b6d0-809f60dbbb23	9d692d72-c693-4aad-b375-463608ab2e57	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 15:03:16
11947	9d5cd8db-dce0-45cd-b496-d119827f7423	9d5cd8dc-209b-4cb2-adb3-633e7f3dae6c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 11:56:48
11948	9d5cd8dc-1c18-434f-87ac-e0f0c963988b	9d5cd8dc-209b-4cb2-adb3-633e7f3dae6c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"142.07","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":177,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 11:56:48
11949	9d5cd8dc-1c5f-449d-969c-f2a9e854f974	9d5cd8dc-209b-4cb2-adb3-633e7f3dae6c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 11:56:48
11950	9d5cd8dc-1f9a-4263-92cb-5421652e50c7	9d5cd8dc-209b-4cb2-adb3-633e7f3dae6c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 11:56:48
11951	9d5cd8dc-1fda-4963-94fd-e71b0c57e339	9d5cd8dc-209b-4cb2-adb3-633e7f3dae6c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":323,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:56:48
16048	9d64b84d-7d91-4978-9872-f92ad7fbc252	9d64b84d-d5ad-467a-b4cb-6d35410758c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:52:23
16049	9d64b84d-cdc9-46f7-9739-602344af5d82	9d64b84d-d5ad-467a-b4cb-6d35410758c4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"174.92","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 09:52:23
16050	9d64b84d-ce4f-4355-b049-ae942546c59c	9d64b84d-d5ad-467a-b4cb-6d35410758c4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 09:52:23
16051	9d64b84d-d434-416b-aac5-03978fe6816a	9d64b84d-d5ad-467a-b4cb-6d35410758c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 09:52:23
16052	9d64b84d-d497-404e-95e8-62ebe4f4c148	9d64b84d-d5ad-467a-b4cb-6d35410758c4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":551,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:52:23
21405	9d6739ca-be42-4c4b-8eaf-12a5d5ac2ba9	9d6739ca-dbfe-432d-b404-9bf1ba9ad374	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 15:46:07
21406	9d6739ca-d34e-4839-8f68-4dcd2da5b9a7	9d6739ca-dbfe-432d-b404-9bf1ba9ad374	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 65\\n                        ","time":"40.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6768d7067397538897aacf4d73c43049","hostname":"EderCortes"}	2024-11-03 15:46:07
21407	9d6739ca-d6c4-4dd5-849b-f98fd0ae2794	9d6739ca-dbfe-432d-b404-9bf1ba9ad374	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '65' order by \\"item_loans\\".\\"id\\" asc","time":"1.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 15:46:07
21408	9d6739ca-d705-4af6-bea7-a7f680c7b362	9d6739ca-dbfe-432d-b404-9bf1ba9ad374	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 15:46:07
21409	9d6739ca-dac1-40b3-b20e-8c7298fcee85	9d6739ca-dbfe-432d-b404-9bf1ba9ad374	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 15:46:07
11952	9d5cd8dc-620b-4d81-aff0-7df31c31fab4	9d5cd8dc-7e9b-4626-abf6-3a00902fbe38	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 11:56:48
11953	9d5cd8dc-7a1f-42df-99d3-e996f33241e3	9d5cd8dc-7e9b-4626-abf6-3a00902fbe38	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":177,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 11:56:48
11954	9d5cd8dc-7a67-47be-b9c1-8e90b762a242	9d5cd8dc-7e9b-4626-abf6-3a00902fbe38	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 11:56:48
11955	9d5cd8dc-7d9e-41fb-a698-2181699d2dcd	9d5cd8dc-7e9b-4626-abf6-3a00902fbe38	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 11:56:48
11956	9d5cd8dc-7ddf-4a5d-b44e-a9e98c58e87d	9d5cd8dc-7e9b-4626-abf6-3a00902fbe38	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":228,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:56:48
21410	9d6739ca-db0d-4c8c-b1bf-f7f9d5ea8182	9d6739ca-dbfe-432d-b404-9bf1ba9ad374	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/65","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":65,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":3000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-10 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":207,"loans_codigo":65,"itemloans_cuota":"1","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:44:10.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":208,"loans_codigo":65,"itemloans_cuota":"2","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":209,"loans_codigo":65,"itemloans_cuota":"3","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":210,"loans_codigo":65,"itemloans_cuota":"4","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":211,"loans_codigo":65,"itemloans_cuota":"5","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":212,"loans_codigo":65,"itemloans_cuota":"6","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":213,"loans_codigo":65,"itemloans_cuota":"7","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":214,"loans_codigo":65,"itemloans_cuota":"8","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":215,"loans_codigo":65,"itemloans_cuota":"9","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":216,"loans_codigo":65,"itemloans_cuota":"10","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-09-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:46:07
21411	9d673a12-7e13-4213-9e31-aae48c758fe7	9d673a12-822a-4e6a-b5e5-bdd8853772c0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":171,"memory":20,"hostname":"EderCortes"}	2024-11-03 15:46:54
29971	9d692d72-c5b4-40c1-84a4-6c7d4c2124fe	9d692d72-c693-4aad-b375-463608ab2e57	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":405,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:03:16
21412	9d673a12-ecf4-4387-af02-e57cf66d3e7c	9d673a13-44f0-4f6c-9822-02424d232117	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 15:46:55
21413	9d673a13-37d7-4387-9441-5cd0528c452a	9d673a13-44f0-4f6c-9822-02424d232117	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 207 limit 1","time":"4.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-03 15:46:55
21414	9d673a13-38aa-4514-95fe-e45e0514965c	9d673a13-44f0-4f6c-9822-02424d232117	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-03 15:46:55
21415	9d673a13-3af8-4588-a565-cc46b6145251	9d673a13-44f0-4f6c-9822-02424d232117	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 65 limit 1","time":"2.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 15:46:55
21416	9d673a13-3b4a-4878-a588-ad7c31d65a17	9d673a13-44f0-4f6c-9822-02424d232117	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 15:46:55
21417	9d673a13-3cf4-42f9-8ed6-25402c63e1f1	9d673a13-44f0-4f6c-9822-02424d232117	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '03-11-2024', \\"itemloans_interes_canelado\\" = '90000', \\"itemloans_cuota_cancelada\\" = '300000', \\"updated_at\\" = '2024-11-03 15:46:55' where \\"id\\" = 207","time":"1.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":400,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-03 15:46:55
21418	9d673a13-3d63-41eb-9fbc-1e4f74f2ffb8	9d673a13-44f0-4f6c-9822-02424d232117	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:207","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-03 15:46:55","item_loans_cuando_pago":"03-11-2024","itemloans_interes_canelado":"90000","itemloans_cuota_cancelada":"300000"},"hostname":"EderCortes"}	2024-11-03 15:46:55
21419	9d673a13-3e2c-4c58-97b4-312e58e210d0	9d673a13-44f0-4f6c-9822-02424d232117	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 90000, \\"loans_pago_prestado\\" = 300000, \\"updated_at\\" = '2024-11-03 15:46:55' where \\"id\\" = 65","time":"1.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":408,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-03 15:46:55
21420	9d673a13-3e64-4d3f-8132-7744f5c74593	9d673a13-44f0-4f6c-9822-02424d232117	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:65","changes":{"updated_at":"2024-11-03 15:46:55","loans_pago_interes":90000,"loans_pago_prestado":300000},"hostname":"EderCortes"}	2024-11-03 15:46:55
21421	9d673a13-4306-41ce-846a-1dc0e7a4ab6b	9d673a13-44f0-4f6c-9822-02424d232117	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:46:55
21422	9d673a13-436e-4f7b-bda6-327cad768551	9d673a13-44f0-4f6c-9822-02424d232117	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"179","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"90000","itemloans_cuota_cancelada":"300000","id":207,"loans_codigo":65,"itemloans_cuota":"1","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":416,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:46:55
30050	9d69336e-826d-43c6-a228-cfac58e5ae09	9d69336e-ae96-40ce-96ba-8bb0737d2c9b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 15:20:00
30051	9d69336e-ac27-4b89-a106-736f631083ea	9d69336e-ae96-40ce-96ba-8bb0737d2c9b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:20:00
30052	9d69336e-ad65-4995-8580-0d0ecc68a325	9d69336e-ae96-40ce-96ba-8bb0737d2c9b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:20:00
21423	9d673a13-ad8b-4f66-9a73-d6c012c79996	9d673a13-d32b-4a1d-bbfd-a2597d71e95c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:46:55
21424	9d673a13-c631-412b-bb10-7aa46ea764b5	9d673a13-d32b-4a1d-bbfd-a2597d71e95c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 65\\n                        ","time":"47.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6768d7067397538897aacf4d73c43049","hostname":"EderCortes"}	2024-11-03 15:46:55
21425	9d673a13-cad8-462b-9d62-d96fd214734b	9d673a13-d32b-4a1d-bbfd-a2597d71e95c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '65' order by \\"item_loans\\".\\"id\\" asc","time":"3.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 15:46:55
21426	9d673a13-cb1e-4f1c-a601-b5fc54c12274	9d673a13-d32b-4a1d-bbfd-a2597d71e95c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 15:46:55
21427	9d673a13-d16b-4068-908d-98cf24faf4b5	9d673a13-d32b-4a1d-bbfd-a2597d71e95c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:46:55
21428	9d673a13-d205-49fa-ae1d-f0d08c142a2f	9d673a13-d32b-4a1d-bbfd-a2597d71e95c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/65","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":65,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":3000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-10 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"90000"},"items":[{"id":207,"loans_codigo":65,"itemloans_cuota":"1","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:46:55.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"90000","itemloans_cuota_cancelada":"300000"},{"id":208,"loans_codigo":65,"itemloans_cuota":"2","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":209,"loans_codigo":65,"itemloans_cuota":"3","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":210,"loans_codigo":65,"itemloans_cuota":"4","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":211,"loans_codigo":65,"itemloans_cuota":"5","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":212,"loans_codigo":65,"itemloans_cuota":"6","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":213,"loans_codigo":65,"itemloans_cuota":"7","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":214,"loans_codigo":65,"itemloans_cuota":"8","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":215,"loans_codigo":65,"itemloans_cuota":"9","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":216,"loans_codigo":65,"itemloans_cuota":"10","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-09-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":338,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:46:55
30053	9d69336f-13b2-4faa-be95-ad8a6366d2e2	9d69336f-349c-415d-a6f8-360cadff40f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:20:00
30054	9d69336f-297d-4b4a-9212-e4bfcbaeb66b	9d69336f-349c-415d-a6f8-360cadff40f6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"43.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 15:20:00
30055	9d69336f-2e06-48ed-b987-17c774329a31	9d69336f-349c-415d-a6f8-360cadff40f6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 15:20:00
30056	9d69336f-2e5f-4c64-9677-15e2224efb7f	9d69336f-349c-415d-a6f8-360cadff40f6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 15:20:00
30057	9d69336f-3344-4326-b19b-47a582ced341	9d69336f-349c-415d-a6f8-360cadff40f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 15:20:00
17970	9d65b4f5-1bdf-47e3-9832-d8643507c850	9d65b4f5-6487-4421-a5ee-2ebb14967137	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 21:38:52
17971	9d65b4f5-62ee-4bd2-ba92-b7755e1a9aae	9d65b4f5-6487-4421-a5ee-2ebb14967137	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 21:38:52
17972	9d65b4f5-6388-4729-8672-416bd120d2fe	9d65b4f5-6487-4421-a5ee-2ebb14967137	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":342,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:38:52
30058	9d69336f-339c-4725-b117-b6d4c133e5bf	9d69336f-349c-415d-a6f8-360cadff40f6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":296,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:20:00
21429	9d673a18-bf12-485e-a869-5063d8dba2b6	9d673a18-db4c-4e79-9606-6c9878ca7571	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:46:58
21430	9d673a18-d6ed-4f0b-b1e0-67bdf1576169	9d673a18-db4c-4e79-9606-6c9878ca7571	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"45.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 15:46:58
21431	9d673a18-da08-450c-9160-b7818751bbd1	9d673a18-db4c-4e79-9606-6c9878ca7571	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 15:46:58
17973	9d65b4f5-b276-4472-861a-7aab7b1bd98b	9d65b4f5-d10b-4a9f-b212-6cbf9861baed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 21:38:52
17974	9d65b4f5-c708-4f62-a7e2-6d704c84de52	9d65b4f5-d10b-4a9f-b212-6cbf9861baed	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"39.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"2b11ef88578e3c91c11800e110e490df","hostname":"EderCortes"}	2024-11-02 21:38:52
17975	9d65b4f5-caa9-4b65-a12e-c7d67644ae5c	9d65b4f5-d10b-4a9f-b212-6cbf9861baed	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"2.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:38:52
17976	9d65b4f5-cadd-4852-a3e7-e3d5e9e76efb	9d65b4f5-d10b-4a9f-b212-6cbf9861baed	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:38:52
17977	9d65b4f5-cf49-4c5c-90b6-4f4cfcb79d3b	9d65b4f5-d10b-4a9f-b212-6cbf9861baed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 21:38:52
17978	9d65b4f5-cfdd-4e40-ac6a-4721df52afab	9d65b4f5-d10b-4a9f-b212-6cbf9861baed	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:38:52
21432	9d673a18-da5a-4c4f-b9e4-5287b351277d	9d673a18-db4c-4e79-9606-6c9878ca7571	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":null,"loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":215,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:46:58
17979	9d65b4f7-2a11-4926-a069-28ac6e097f44	9d65b4f7-557f-4686-b3a5-fb11151945c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 21:38:53
17980	9d65b4f7-4bc7-40dd-8fa9-ddbc68b1f546	9d65b4f7-557f-4686-b3a5-fb11151945c0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"57.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 21:38:53
17981	9d65b4f7-4c4f-4c37-ac5d-862d82b2eb5f	9d65b4f7-557f-4686-b3a5-fb11151945c0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 21:38:53
17982	9d65b4f7-5378-44ed-94ae-6ff593ead6cf	9d65b4f7-557f-4686-b3a5-fb11151945c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 21:38:53
17983	9d65b4f7-5406-47e6-8abc-1deb1387f0a9	9d65b4f7-557f-4686-b3a5-fb11151945c0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":416,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:38:53
21433	9d673a42-f187-4d0d-a571-4c00f4b3077a	9d673a43-1011-41ff-8d60-eab310e07f03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 15:47:26
21434	9d673a43-06fd-41fb-9e03-1f78eb2d9291	9d673a43-1011-41ff-8d60-eab310e07f03	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 63\\n                        ","time":"42.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"a9a42f966ad800b5e6c84202c7e51542","hostname":"EderCortes"}	2024-11-03 15:47:26
21435	9d673a43-0a7e-4b1e-8f62-8ddfd8d92ce6	9d673a43-1011-41ff-8d60-eab310e07f03	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '63' order by \\"item_loans\\".\\"id\\" asc","time":"2.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 15:47:26
21436	9d673a43-0aaf-4fde-8540-717f19cc6c11	9d673a43-1011-41ff-8d60-eab310e07f03	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 15:47:26
21437	9d673a43-0eab-470c-a7c4-88427b0aafb7	9d673a43-1011-41ff-8d60-eab310e07f03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 15:47:26
21438	9d673a43-0ef2-4923-ae1e-da7d3e0014c8	9d673a43-1011-41ff-8d60-eab310e07f03	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/63","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":63,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":40,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"17-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-17 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":192,"loans_codigo":63,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"80000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T17:54:51.000000Z","updated_at":"2024-11-03T17:54:51.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":193,"loans_codigo":63,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"80000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T17:54:51.000000Z","updated_at":"2024-11-03T17:54:51.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":194,"loans_codigo":63,"itemloans_cuota":"3","itemloans_valor_cuota":"200000","itemloans_iteres":"80000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T17:54:51.000000Z","updated_at":"2024-11-03T17:54:51.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":195,"loans_codigo":63,"itemloans_cuota":"4","itemloans_valor_cuota":"200000","itemloans_iteres":"80000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T17:54:51.000000Z","updated_at":"2024-11-03T17:54:51.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":196,"loans_codigo":63,"itemloans_cuota":"5","itemloans_valor_cuota":"200000","itemloans_iteres":"80000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T17:54:51.000000Z","updated_at":"2024-11-03T17:54:51.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":321,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:47:26
11439	9d5cbe74-4673-40d3-9fbc-0a4b27c1601f	9d5cbe74-9520-4aeb-bbf7-7250700de61d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 10:42:58
11440	9d5cbe74-9344-416a-acf9-c9ef8c14b25f	9d5cbe74-9520-4aeb-bbf7-7250700de61d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 10:42:58
11441	9d5cbe74-9407-497d-b8fe-88ebbdaa7183	9d5cbe74-9520-4aeb-bbf7-7250700de61d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":398,"memory":22,"hostname":"EderCortes"}	2024-10-29 10:42:58
16159	9d64b9c9-f903-4fc4-aa3c-1de9f3be43a8	9d64b9ca-1645-4fa8-a9cc-5c7d92ad90a3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 09:56:33
16160	9d64b9ca-14be-46a3-bb66-61c1fcf42bb6	9d64b9ca-1645-4fa8-a9cc-5c7d92ad90a3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 09:56:33
16161	9d64b9ca-155d-4053-9520-432a490a7525	9d64b9ca-1645-4fa8-a9cc-5c7d92ad90a3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:56:33
21439	9d673a4c-cc0c-482e-8982-a4ea63d1af32	9d673a4c-ceb4-437a-be9a-e44eb64cf409	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":123,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:47:33
16162	9d64b9ca-5bda-49b0-b2a0-ff87785cdc38	9d64b9ca-7ab5-4b31-b028-5d8bcbe495db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 09:56:33
16163	9d64b9ca-7216-4fb8-9430-9756c82e39d7	9d64b9ca-7ab5-4b31-b028-5d8bcbe495db	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 22\\n                        ","time":"44.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"f9344e277d181987f84c6dcddcb4342d","hostname":"EderCortes"}	2024-11-02 09:56:33
16164	9d64b9ca-75b6-4dc6-a0f5-ea5ee3e6063c	9d64b9ca-7ab5-4b31-b028-5d8bcbe495db	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '22' order by \\"item_loans\\".\\"id\\" asc","time":"2.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:56:33
16165	9d64b9ca-7603-42e0-94d3-f8a1e099c986	9d64b9ca-7ab5-4b31-b028-5d8bcbe495db	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-02 09:56:33
16166	9d64b9ca-798f-43b2-917a-0679e9bec8b4	9d64b9ca-7ab5-4b31-b028-5d8bcbe495db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 09:56:33
16167	9d64b9ca-79df-4ce0-a31e-a3034e80b25c	9d64b9ca-7ab5-4b31-b028-5d8bcbe495db	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/22","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":22,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":70,"loans_codigo":22,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":71,"loans_codigo":22,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":72,"loans_codigo":22,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":73,"loans_codigo":22,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":74,"loans_codigo":22,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":75,"loans_codigo":22,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-04-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":220,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:56:33
21440	9d673a4d-43d0-4fbd-b4c5-c044fb562a28	9d673a4d-60ac-4df8-bb98-4cad3fbf654e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 15:47:33
21441	9d673a4d-5868-44a1-99c2-135d6d3614d2	9d673a4d-60ac-4df8-bb98-4cad3fbf654e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 192 limit 1","time":"2.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-03 15:47:33
21442	9d673a4d-58b3-45d9-be75-5b4f07c03513	9d673a4d-60ac-4df8-bb98-4cad3fbf654e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-03 15:47:33
21443	9d673a4d-5a24-4df5-a787-477f90efbf8f	9d673a4d-60ac-4df8-bb98-4cad3fbf654e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 63 limit 1","time":"1.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 15:47:33
21444	9d673a4d-5a5f-475e-8f98-5f93bcc89e81	9d673a4d-60ac-4df8-bb98-4cad3fbf654e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 15:47:33
21445	9d673a4d-5ba5-44d2-af38-5fb5af477c3b	9d673a4d-60ac-4df8-bb98-4cad3fbf654e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '03-11-2024', \\"itemloans_interes_canelado\\" = '80000', \\"itemloans_cuota_cancelada\\" = '200000', \\"updated_at\\" = '2024-11-03 15:47:33' where \\"id\\" = 192","time":"1.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":400,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-03 15:47:33
21446	9d673a4d-5c04-41c2-bcd0-e5567535b754	9d673a4d-60ac-4df8-bb98-4cad3fbf654e	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:192","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-03 15:47:33","item_loans_cuando_pago":"03-11-2024","itemloans_interes_canelado":"80000","itemloans_cuota_cancelada":"200000"},"hostname":"EderCortes"}	2024-11-03 15:47:33
21447	9d673a4d-5ca2-4f8a-b9eb-74bcb377806b	9d673a4d-60ac-4df8-bb98-4cad3fbf654e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_fecha_ultimo_pago\\" = '03-11-2024', \\"loans_pago_interes\\" = 80000, \\"loans_pago_prestado\\" = 200000, \\"updated_at\\" = '2024-11-03 15:47:33' where \\"id\\" = 63","time":"0.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":408,"hash":"138ffd5a6aae2847ac945cb6fb277db0","hostname":"EderCortes"}	2024-11-03 15:47:33
21448	9d673a4d-5ce2-419d-b718-9134b8b7d803	9d673a4d-60ac-4df8-bb98-4cad3fbf654e	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:63","changes":{"updated_at":"2024-11-03 15:47:33","loans_fecha_ultimo_pago":"03-11-2024","loans_pago_interes":80000,"loans_pago_prestado":200000},"hostname":"EderCortes"}	2024-11-03 15:47:33
21449	9d673a4d-5f86-46a9-af05-4264d0d33fd6	9d673a4d-60ac-4df8-bb98-4cad3fbf654e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 15:47:33
16168	9d64b9cb-fe41-4c67-906a-60c9607895b7	9d64b9cc-4ef4-4790-bcfa-28f722b78757	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 09:56:34
16169	9d64b9cc-4848-494a-a477-112f86979b44	9d64b9cc-4ef4-4790-bcfa-28f722b78757	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"168.49","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 09:56:34
16170	9d64b9cc-48b1-4b89-8d8b-d09add6290f2	9d64b9cc-4ef4-4790-bcfa-28f722b78757	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 09:56:34
16171	9d64b9cc-4d5e-4623-8938-8f42b9fcaf8a	9d64b9cc-4ef4-4790-bcfa-28f722b78757	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-02 09:56:34
16172	9d64b9cc-4dcc-451b-9189-b1d4c4337e7c	9d64b9cc-4ef4-4790-bcfa-28f722b78757	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":449,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:56:34
21450	9d673a4d-5fc4-4e10-8587-df6b4777d08c	9d673a4d-60ac-4df8-bb98-4cad3fbf654e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"179","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"80000","itemloans_cuota_cancelada":"200000","id":192,"loans_codigo":63,"itemloans_cuota":"1","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":203,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:47:33
21451	9d673a4d-a1f9-470d-80b3-f663f022e693	9d673a4d-bf83-4e00-989c-882e48e56ac6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 15:47:33
21452	9d673a4d-b6f6-4fab-9870-395ef072ff33	9d673a4d-bf83-4e00-989c-882e48e56ac6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 63\\n                        ","time":"41.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"a9a42f966ad800b5e6c84202c7e51542","hostname":"EderCortes"}	2024-11-03 15:47:33
21453	9d673a4d-ba85-4c30-9e2d-21dc5cda7be2	9d673a4d-bf83-4e00-989c-882e48e56ac6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '63' order by \\"item_loans\\".\\"id\\" asc","time":"2.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 15:47:33
21454	9d673a4d-bac5-43b4-b325-ed5f3d2c74df	9d673a4d-bf83-4e00-989c-882e48e56ac6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 15:47:33
21455	9d673a4d-be4b-4ccb-a775-c3248c0e86a4	9d673a4d-bf83-4e00-989c-882e48e56ac6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 15:47:33
21456	9d673a4d-be90-4217-a810-353d7e0fd575	9d673a4d-bf83-4e00-989c-882e48e56ac6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/63","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":63,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":40,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"17-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-17 00:00:00","loans_pago_prestado":"200000","loans_pago_interes":"80000"},"items":[{"id":192,"loans_codigo":63,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"80000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T17:54:51.000000Z","updated_at":"2024-11-03T20:47:33.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"80000","itemloans_cuota_cancelada":"200000"},{"id":193,"loans_codigo":63,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"80000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T17:54:51.000000Z","updated_at":"2024-11-03T17:54:51.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":194,"loans_codigo":63,"itemloans_cuota":"3","itemloans_valor_cuota":"200000","itemloans_iteres":"80000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T17:54:51.000000Z","updated_at":"2024-11-03T17:54:51.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":195,"loans_codigo":63,"itemloans_cuota":"4","itemloans_valor_cuota":"200000","itemloans_iteres":"80000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T17:54:51.000000Z","updated_at":"2024-11-03T17:54:51.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":196,"loans_codigo":63,"itemloans_cuota":"5","itemloans_valor_cuota":"200000","itemloans_iteres":"80000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T17:54:51.000000Z","updated_at":"2024-11-03T17:54:51.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":221,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:47:33
22000	9d674167-ad64-4eaa-915b-e9e676d4b3e8	9d674167-e383-4609-ae85-f97811b9c97d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-03 16:07:25
22001	9d674167-e174-4e42-afe2-21963af51e7d	9d674167-e383-4609-ae85-f97811b9c97d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-03 16:07:25
22002	9d674167-e250-49fe-98ea-e11e85545356	9d674167-e383-4609-ae85-f97811b9c97d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":470,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:07:25
21457	9d673a5b-bd90-48b9-9b04-4f108cad9ed2	9d673a5b-fee3-4bef-aadf-f8b2f2d4d4e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 15:47:42
21458	9d673a5b-fad7-4f1d-bc30-5cab41f96000	9d673a5b-fee3-4bef-aadf-f8b2f2d4d4e0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"141.82","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 15:47:42
21459	9d673a5b-fda5-4616-934a-8057e1940ef2	9d673a5b-fee3-4bef-aadf-f8b2f2d4d4e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 15:47:42
21460	9d673a5b-fdf6-42ab-8ba1-c66167b2209f	9d673a5b-fee3-4bef-aadf-f8b2f2d4d4e0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":321,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:47:42
22003	9d674168-7987-4a51-a704-ad3518d4dfb7	9d674168-a84b-4973-96a8-cf55925838cb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-03 16:07:25
22004	9d674168-9995-4c52-8974-b6ab475ad17e	9d674168-a84b-4973-96a8-cf55925838cb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 68\\n                        ","time":"56.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"7d9994d55cb8dde82ff4185920c79043","hostname":"EderCortes"}	2024-11-03 16:07:25
22005	9d674168-a051-4424-8aa5-8ea3310633db	9d674168-a84b-4973-96a8-cf55925838cb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '68' order by \\"item_loans\\".\\"id\\" asc","time":"4.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 16:07:25
22006	9d674168-a0d9-4483-a0a4-ee0d20fb6f5d	9d674168-a84b-4973-96a8-cf55925838cb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 16:07:25
22007	9d674168-a65d-43c9-8682-8f0d0b30ca40	9d674168-a84b-4973-96a8-cf55925838cb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-03 16:07:25
22008	9d674168-a6e8-4732-a0d7-4e9aafb909b6	9d674168-a84b-4973-96a8-cf55925838cb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/68","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":68,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":10000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"1000000","loans_pago_interes":"250000"},"items":[{"id":227,"loans_codigo":68,"itemloans_cuota":"1","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":228,"loans_codigo":68,"itemloans_cuota":"2","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":229,"loans_codigo":68,"itemloans_cuota":"3","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":230,"loans_codigo":68,"itemloans_cuota":"4","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":231,"loans_codigo":68,"itemloans_cuota":"5","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":232,"loans_codigo":68,"itemloans_cuota":"6","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":233,"loans_codigo":68,"itemloans_cuota":"7","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":234,"loans_codigo":68,"itemloans_cuota":"8","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":235,"loans_codigo":68,"itemloans_cuota":"9","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":236,"loans_codigo":68,"itemloans_cuota":"10","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":443,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:07:25
21461	9d673adb-8675-4ff4-a5e2-4bdf40917710	9d673adb-aa31-49b9-9fcc-57031a9a2868	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 15:49:06
21462	9d673adb-a47c-4662-97b3-2cf665bb733d	9d673adb-aa31-49b9-9fcc-57031a9a2868	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"48.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-03 15:49:06
21463	9d673adb-a87e-4b32-a7ba-cb9d1f82e7e1	9d673adb-aa31-49b9-9fcc-57031a9a2868	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:49:06
21464	9d673adb-a8ea-473e-b2aa-e8b80b14d302	9d673adb-aa31-49b9-9fcc-57031a9a2868	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":358,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:49:06
22009	9d674169-7b47-4661-95b1-9089c7670fa5	9d674169-e80d-4d73-b88b-5ed742337234	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-03 16:07:26
22010	9d674169-db25-4dca-8417-8d6d5e0f5702	9d674169-e80d-4d73-b88b-5ed742337234	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"86.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:07:26
22011	9d674169-dbcf-476d-a0a2-07b63970f55e	9d674169-e80d-4d73-b88b-5ed742337234	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:07:26
22012	9d674169-e5b7-494f-b4cb-29ff870da93b	9d674169-e80d-4d73-b88b-5ed742337234	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-03 16:07:26
22013	9d674169-e65f-47a3-be2e-2b703e6cd51e	9d674169-e80d-4d73-b88b-5ed742337234	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":799,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:07:26
21465	9d673add-645f-4e89-b445-fe027cf45dea	9d673add-df5a-4b27-8396-971f82dd796c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:49:07
21466	9d673add-dac8-4d29-8daf-d8c655304779	9d673add-df5a-4b27-8396-971f82dd796c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"38.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 15:49:08
13717	9d5d0e40-7672-4969-96d2-b95d5c30c236	9d5d0e40-a236-4c49-b8b1-ca10ca2eb5ed	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 14:26:06
13718	9d5d0e40-9fd1-43e9-9f79-6a5ddc76fda3	9d5d0e40-a236-4c49-b8b1-ca10ca2eb5ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 14:26:06
13719	9d5d0e40-a0e1-4a5c-a6a5-e99a481d96b5	9d5d0e40-a236-4c49-b8b1-ca10ca2eb5ed	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":453,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:26:06
21467	9d673add-db12-4436-8156-0f5134a72e61	9d673add-df5a-4b27-8396-971f82dd796c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 15:49:08
21468	9d673add-de3f-4679-9b7b-1ed5673f9e57	9d673add-df5a-4b27-8396-971f82dd796c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:49:08
21469	9d673add-de7d-460b-bd1f-efff0826016d	9d673add-df5a-4b27-8396-971f82dd796c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":560,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:49:08
22014	9d67416a-88bc-45da-a237-764ad31deece	9d67416a-c2ec-4e05-99e4-c3e60ef03466	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-03 16:07:26
22015	9d67416a-b91b-4362-9b7e-d2d3ff9d0bce	9d67416a-c2ec-4e05-99e4-c3e60ef03466	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"77.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:07:27
22016	9d67416a-b9a4-4b8c-b6d0-f340c83e2de6	9d67416a-c2ec-4e05-99e4-c3e60ef03466	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:07:27
22017	9d67416a-c0bf-440d-8d76-ad65cd9057f1	9d67416a-c2ec-4e05-99e4-c3e60ef03466	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-03 16:07:27
22018	9d67416a-c15b-4224-b6a1-cc0373b0382a	9d67416a-c2ec-4e05-99e4-c3e60ef03466	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":533,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:07:27
21470	9d673ade-1d08-4c3a-b0c8-e37c660e0727	9d673ade-3a6e-40ce-a502-c43e4f8c8dc8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:49:08
21471	9d673ade-35aa-478e-b023-d543344d88c5	9d673ade-3a6e-40ce-a502-c43e4f8c8dc8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 15:49:08
13121	9d5cf97e-dca4-4a18-8b7e-4a8cf1b7d88d	9d5cf97f-1058-4888-bf8f-ae0b84add499	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 13:28:03
13122	9d5cf97f-0c7a-4b53-9826-ff532ffc85df	9d5cf97f-1058-4888-bf8f-ae0b84add499	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 13:28:04
13123	9d5cf97f-0e27-4f4d-9f69-4f753cdf806b	9d5cf97f-1058-4888-bf8f-ae0b84add499	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":473,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:28:04
21472	9d673ade-3603-4574-9983-73eb2bfef021	9d673ade-3a6e-40ce-a502-c43e4f8c8dc8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-03 15:49:08
21473	9d673ade-393b-4ae6-baa9-a393015fdf6b	9d673ade-3a6e-40ce-a502-c43e4f8c8dc8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 15:49:08
21474	9d673ade-397e-4e1f-8250-c70a762bceca	9d673ade-3a6e-40ce-a502-c43e4f8c8dc8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":219,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:49:08
22102	9d674253-8083-4c33-9d98-1c997a60b9ae	9d674253-d77d-4b6b-8af6-a0af37d283ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 16:09:59
22103	9d674253-d3c3-4983-8648-dbd6bb8ec288	9d674253-d77d-4b6b-8af6-a0af37d283ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 16:09:59
22104	9d674253-d54c-4899-85cf-7c348dcd2699	9d674253-d77d-4b6b-8af6-a0af37d283ec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":648,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:09:59
13124	9d5cf97f-b2ec-4311-b0e6-1e5fe33ed53d	9d5cf980-0b1a-4c2d-bf7e-0bbad00ba793	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 13:28:04
13125	9d5cf980-0199-476b-b113-090d79ef081d	9d5cf980-0b1a-4c2d-bf7e-0bbad00ba793	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"165.88","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 13:28:04
13126	9d5cf980-021b-4d3c-8af4-96df47d640a7	9d5cf980-0b1a-4c2d-bf7e-0bbad00ba793	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 13:28:04
13127	9d5cf980-0940-46a3-aea0-cb9599f452c6	9d5cf980-0b1a-4c2d-bf7e-0bbad00ba793	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 13:28:04
13128	9d5cf980-09c3-417a-9c35-0c783ff53a3e	9d5cf980-0b1a-4c2d-bf7e-0bbad00ba793	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":583,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:28:04
13720	9d5d0e41-0f2a-419b-9b7e-9637b9d300e8	9d5d0e41-61d6-4dbd-8579-fd2abadfe7bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 14:26:06
13721	9d5d0e41-5471-4d73-8953-d6e4f7191d57	9d5d0e41-61d6-4dbd-8579-fd2abadfe7bf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 52\\n                        ","time":"162.30","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"b818d1825eff359c94d73944c3be2955","hostname":"EderCortes"}	2024-10-29 14:26:06
13722	9d5d0e41-5b25-43c6-895d-0e2b9d708d7c	9d5d0e41-61d6-4dbd-8579-fd2abadfe7bf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '52' order by \\"item_loans\\".\\"id\\" asc","time":"7.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 14:26:06
13723	9d5d0e41-5b65-4bed-8cfb-6e76c5baebd6	9d5d0e41-61d6-4dbd-8579-fd2abadfe7bf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":7,"hostname":"EderCortes"}	2024-10-29 14:26:06
13724	9d5d0e41-6086-4bae-8d41-ae19359850bf	9d5d0e41-61d6-4dbd-8579-fd2abadfe7bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 14:26:06
13725	9d5d0e41-60d9-4624-b32e-f084f313b23e	9d5d0e41-61d6-4dbd-8579-fd2abadfe7bf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/52","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":52,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":7,"loans_valor_prestado":500000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"12-11-24","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":136,"loans_codigo":52,"itemloans_cuota":"1","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":137,"loans_codigo":52,"itemloans_cuota":"2","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0024-12-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":138,"loans_codigo":52,"itemloans_cuota":"3","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0024-12-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":139,"loans_codigo":52,"itemloans_cuota":"4","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0025-01-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":140,"loans_codigo":52,"itemloans_cuota":"5","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0025-01-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":141,"loans_codigo":52,"itemloans_cuota":"6","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0025-02-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":142,"loans_codigo":52,"itemloans_cuota":"7","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0025-02-25 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":447,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:26:06
21475	9d673ae8-98f7-48c1-871f-f28431350356	9d673ae8-9be4-47c2-b572-79e0b5cc14a8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":165,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:49:15
22105	9d674254-ebf6-4e1c-bda0-2d1a46645a2d	9d674255-2ae3-4ce0-9e0b-598a56e299e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 16:10:00
16263	9d64bfa3-d2f2-4ed1-9b9c-2d3df56965c1	9d64bfa3-f2d4-4505-a771-4745268f1046	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 10:12:54
16264	9d64bfa3-f0ea-4d7c-90c7-cf6efb400331	9d64bfa3-f2d4-4505-a771-4745268f1046	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 10:12:54
16265	9d64bfa3-f1b7-4dad-a310-6448c7323ee4	9d64bfa3-f2d4-4505-a771-4745268f1046	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:12:54
21476	9d673ae8-f70c-4a3e-84c5-c10085e73a1f	9d673ae8-fa91-48ba-825c-67cb0f2d61d3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":144,"memory":20,"hostname":"EderCortes"}	2024-11-03 15:49:15
13764	9d5d0e7f-1b95-4cef-9854-93688297203b	9d5d0e7f-443d-4ff7-96d9-42a9e7f0131c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 14:26:47
13765	9d5d0e7f-3bbd-4db5-85ed-7c0a5c619b73	9d5d0e7f-443d-4ff7-96d9-42a9e7f0131c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":194,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 14:26:47
13766	9d5d0e7f-3c45-47a3-a06c-d31528f4c948	9d5d0e7f-443d-4ff7-96d9-42a9e7f0131c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 14:26:47
13767	9d5d0e7f-425e-44fb-ab9b-bdba562c1587	9d5d0e7f-443d-4ff7-96d9-42a9e7f0131c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 14:26:47
13768	9d5d0e7f-42dc-47c4-bec6-f2ef8313e585	9d5d0e7f-443d-4ff7-96d9-42a9e7f0131c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":392,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:26:47
22106	9d674255-187c-43ba-9d5a-92e6ef4e4279	9d674255-2ae3-4ce0-9e0b-598a56e299e3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 68\\n                        ","time":"77.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"7d9994d55cb8dde82ff4185920c79043","hostname":"EderCortes"}	2024-11-03 16:10:00
22107	9d674255-1f26-4fd6-8231-a96b175b8c82	9d674255-2ae3-4ce0-9e0b-598a56e299e3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '68' order by \\"item_loans\\".\\"id\\" asc","time":"3.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 16:10:00
22108	9d674255-1f83-4591-acb7-2128e7d71df6	9d674255-2ae3-4ce0-9e0b-598a56e299e3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 16:10:00
22109	9d674255-28a4-4a40-bd2d-0a17d42d05ee	9d674255-2ae3-4ce0-9e0b-598a56e299e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 16:10:00
22110	9d674255-294f-48d7-accf-5c2c74db9a45	9d674255-2ae3-4ce0-9e0b-598a56e299e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/68","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":68,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":10000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"1000000","loans_pago_interes":"250000"},"items":[{"id":227,"loans_codigo":68,"itemloans_cuota":"1","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":228,"loans_codigo":68,"itemloans_cuota":"2","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":229,"loans_codigo":68,"itemloans_cuota":"3","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":230,"loans_codigo":68,"itemloans_cuota":"4","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":231,"loans_codigo":68,"itemloans_cuota":"5","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":232,"loans_codigo":68,"itemloans_cuota":"6","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":233,"loans_codigo":68,"itemloans_cuota":"7","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":234,"loans_codigo":68,"itemloans_cuota":"8","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":235,"loans_codigo":68,"itemloans_cuota":"9","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":236,"loans_codigo":68,"itemloans_cuota":"10","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":794,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:10:00
16266	9d64bfa4-4376-48a4-9f0e-b70c918ad735	9d64bfa4-8f8c-4e6f-8641-cafa4abc3724	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 10:12:55
16267	9d64bfa4-862e-4cb6-8e85-568843dc75c4	9d64bfa4-8f8c-4e6f-8641-cafa4abc3724	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"157.47","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 10:12:55
16268	9d64bfa4-8a2d-424c-8ccf-fa4832a4da06	9d64bfa4-8f8c-4e6f-8641-cafa4abc3724	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 10:12:55
16269	9d64bfa4-8a75-49a0-8e89-e53e6c36144c	9d64bfa4-8f8c-4e6f-8641-cafa4abc3724	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 10:12:55
13769	9d5d0e7f-b19b-40bb-a827-84062606d108	9d5d0e7f-fee9-4bbe-9c21-b3f7c7fc6da8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 14:26:47
13770	9d5d0e7f-f895-44e9-85a4-b6aa82494137	9d5d0e7f-fee9-4bbe-9c21-b3f7c7fc6da8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"151.01","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":194,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 14:26:47
13771	9d5d0e7f-f909-4e20-9066-211545af1353	9d5d0e7f-fee9-4bbe-9c21-b3f7c7fc6da8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 14:26:47
13772	9d5d0e7f-fd1d-433e-b12d-a9fe483ea7b2	9d5d0e7f-fee9-4bbe-9c21-b3f7c7fc6da8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-29 14:26:47
13773	9d5d0e7f-fd9f-4fe6-b5ab-c18f6d5b8552	9d5d0e7f-fee9-4bbe-9c21-b3f7c7fc6da8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":455,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:26:47
16270	9d64bfa4-8e47-4707-b0be-d48907a345c7	9d64bfa4-8f8c-4e6f-8641-cafa4abc3724	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 10:12:55
16271	9d64bfa4-8e9b-45c5-9f14-162e5121ee3b	9d64bfa4-8f8c-4e6f-8641-cafa4abc3724	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":360,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:12:55
21477	9d673ae9-44e5-4bfa-84c7-7137a5fa461c	9d673ae9-5eab-42aa-b8a2-e058dfdf6395	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 15:49:15
21478	9d673ae9-5a79-4dcd-a704-3825c56f634f	9d673ae9-5eab-42aa-b8a2-e058dfdf6395	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ma%' or \\"users\\".\\"user_document\\"::text like '%Ma%') order by \\"users\\".\\"user_document\\" asc","time":"40.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 15:49:15
21479	9d673ae9-5d8e-4702-8e73-8ddaa5ed51ae	9d673ae9-5eab-42aa-b8a2-e058dfdf6395	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 15:49:15
22111	9d674256-101b-4d27-9895-4c68c4eff284	9d674256-653d-4a4f-a1e5-a355457b854e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 16:10:01
16272	9d64bfa5-b308-4d12-b10f-6cde22c4d3d4	9d64bfa6-058e-4388-8aab-d25cd584a36c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 10:12:55
16273	9d64bfa5-fd18-4ccb-9e27-de03c57eba02	9d64bfa6-058e-4388-8aab-d25cd584a36c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"160.43","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 10:12:56
16274	9d64bfa5-fda6-4e18-8df1-c2161200836d	9d64bfa6-058e-4388-8aab-d25cd584a36c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 10:12:56
16275	9d64bfa6-03ca-4b09-bab2-ab57cf25daa6	9d64bfa6-058e-4388-8aab-d25cd584a36c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 10:12:56
13774	9d5d0e80-a762-452a-9faa-a27007ae3412	9d5d0e80-df2c-43c5-908d-58c734584796	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-29 14:26:48
13775	9d5d0e80-d484-437e-9786-87c647a861dc	9d5d0e80-df2c-43c5-908d-58c734584796	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"67.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 14:26:48
13776	9d5d0e80-d512-4baf-96a2-070c7b58c8e7	9d5d0e80-df2c-43c5-908d-58c734584796	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 14:26:48
13777	9d5d0e80-dd08-4401-8936-6133fca5bf3a	9d5d0e80-df2c-43c5-908d-58c734584796	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-29 14:26:48
13778	9d5d0e80-dda1-4a56-b7a2-a2a0919b37e0	9d5d0e80-df2c-43c5-908d-58c734584796	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":550,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:26:48
16276	9d64bfa6-0447-402b-a960-be2fe34f2fd3	9d64bfa6-058e-4388-8aab-d25cd584a36c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":478,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:12:56
21480	9d673ae9-5dd1-4bce-8c43-9888db6eb8dc	9d673ae9-5eab-42aa-b8a2-e058dfdf6395	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ma"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":204,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:49:15
22112	9d674256-594e-43a3-9b27-a06698ee8476	9d674256-653d-4a4f-a1e5-a355457b854e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"111.10","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:10:01
22113	9d674256-59d2-4d05-8be4-c7f23833ed15	9d674256-653d-4a4f-a1e5-a355457b854e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:10:01
22114	9d674256-62f2-41f5-9e8a-1c524bfce636	9d674256-653d-4a4f-a1e5-a355457b854e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 16:10:01
21481	9d673ae9-964e-469f-92d8-0b54332849d2	9d673ae9-9908-4d24-9007-013f2b3a3799	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":129,"memory":20,"hostname":"EderCortes"}	2024-11-03 15:49:15
22115	9d674256-6397-447b-8a69-30b2ba80aee8	9d674256-653d-4a4f-a1e5-a355457b854e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":779,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:10:01
13779	9d5d0e81-6c84-4316-b510-da0e479d581e	9d5d0e81-9c31-40d2-b2d6-cb6c253e479f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-29 14:26:48
13780	9d5d0e81-92cc-4dcd-9978-64805fb78f74	9d5d0e81-9c31-40d2-b2d6-cb6c253e479f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"61.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 14:26:48
13781	9d5d0e81-9352-4c28-ad2a-9db69d59056e	9d5d0e81-9c31-40d2-b2d6-cb6c253e479f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 14:26:48
13782	9d5d0e81-9a2d-4881-97d5-dc79e842a63b	9d5d0e81-9c31-40d2-b2d6-cb6c253e479f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-29 14:26:48
13783	9d5d0e81-9ac5-46e1-858c-84b6b1c164b9	9d5d0e81-9c31-40d2-b2d6-cb6c253e479f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":461,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:26:48
21482	9d673ae9-e28d-48d1-be31-83701e41a375	9d673ae9-e5aa-4556-b82c-173c2b872039	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":124,"memory":20,"hostname":"EderCortes"}	2024-11-03 15:49:15
22116	9d674257-4380-43de-af64-84c526e7213c	9d674257-8f1f-4ec9-80d0-bc8c6ad38553	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 16:10:02
18090	9d65b790-d1ce-4457-8e99-fdca0477d47c	9d65b791-1b53-40f4-8b26-782b7d0319cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 21:46:09
18091	9d65b791-1a09-42b9-afd8-f063ebfa7373	9d65b791-1b53-40f4-8b26-782b7d0319cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 21:46:09
18092	9d65b791-1a90-4e57-9b29-585f2e1976e4	9d65b791-1b53-40f4-8b26-782b7d0319cd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":371,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:46:09
22117	9d674257-84b1-4d08-8184-8999d40fdde1	9d674257-8f1f-4ec9-80d0-bc8c6ad38553	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"105.29","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:10:02
22118	9d674257-855c-4109-980b-097a73960840	9d674257-8f1f-4ec9-80d0-bc8c6ad38553	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:10:02
22119	9d674257-8c83-4bb8-b33a-5051c6a65cd2	9d674257-8f1f-4ec9-80d0-bc8c6ad38553	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 16:10:02
22120	9d674257-8d5d-4ac1-aef7-028d36330dac	9d674257-8f1f-4ec9-80d0-bc8c6ad38553	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":734,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:10:02
30273	9d69397e-1f8c-47bf-9659-8c0d531a4f10	9d69397e-4672-4f93-9778-9360f0a4ba3f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 15:36:56
18093	9d65b791-624a-4929-a2dd-988780ace99d	9d65b791-7d56-473e-a98a-0f074c21f5c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 21:46:10
18094	9d65b791-7580-4e2c-8f78-68d91ca76401	9d65b791-7d56-473e-a98a-0f074c21f5c5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"38.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"2b11ef88578e3c91c11800e110e490df","hostname":"EderCortes"}	2024-11-02 21:46:10
18095	9d65b791-78ce-46fb-85f8-206acdb54bda	9d65b791-7d56-473e-a98a-0f074c21f5c5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"2.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:46:10
18096	9d65b791-7902-4088-9d42-af1ee67d930a	9d65b791-7d56-473e-a98a-0f074c21f5c5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:46:10
18097	9d65b791-7c55-404d-8c3d-365df2530ede	9d65b791-7d56-473e-a98a-0f074c21f5c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 21:46:10
18098	9d65b791-7c9b-4537-98af-3514f3370133	9d65b791-7d56-473e-a98a-0f074c21f5c5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":213,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:46:10
21483	9d673aea-5edf-4f70-b3da-54f3858aa360	9d673aea-79d5-4d96-93f3-d66b1078523e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 15:49:16
21484	9d673aea-750b-4f39-8955-d07bfd95b48c	9d673aea-79d5-4d96-93f3-d66b1078523e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mar%' or \\"users\\".\\"user_document\\"::text like '%Mar%') order by \\"users\\".\\"user_document\\" asc","time":"41.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 15:49:16
21485	9d673aea-785a-42d2-a608-f582f3cb8747	9d673aea-79d5-4d96-93f3-d66b1078523e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 15:49:16
21486	9d673aea-78a1-45ca-a85c-e3cf91a06015	9d673aea-79d5-4d96-93f3-d66b1078523e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mar"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":211,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:49:16
30274	9d69397e-4474-4d28-a167-b74c406c16ef	9d69397e-4672-4f93-9778-9360f0a4ba3f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:36:57
30275	9d69397e-452f-4da5-9aed-7a9f22b67d42	9d69397e-4672-4f93-9778-9360f0a4ba3f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:36:57
18099	9d65b792-cd0b-409e-be6b-a972e0daa250	9d65b793-05c2-4e01-a2c6-751f32902f85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 21:46:11
18100	9d65b792-ffac-4e4e-bbc1-bfd2c5e29457	9d65b793-05c2-4e01-a2c6-751f32902f85	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"74.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 21:46:11
18101	9d65b793-0011-4c02-8737-53010b0484e7	9d65b793-05c2-4e01-a2c6-751f32902f85	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 21:46:11
18102	9d65b793-041f-420b-b79b-9ee82b77bc64	9d65b793-05c2-4e01-a2c6-751f32902f85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 21:46:11
13260	9d5cfc8e-3c9f-4c0a-bc6a-f5afaacccb80	9d5cfc8e-6376-4cec-9558-b41b05eec72b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 13:36:37
13261	9d5cfc8e-618c-47f0-bd13-b35554c60228	9d5cfc8e-6376-4cec-9558-b41b05eec72b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 13:36:37
13262	9d5cfc8e-6251-4cac-8914-3a2e3a999088	9d5cfc8e-6376-4cec-9558-b41b05eec72b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:36:37
18103	9d65b793-048f-44f8-bddb-d21d784ee37c	9d65b793-05c2-4e01-a2c6-751f32902f85	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":416,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:46:11
18265	9d65bb5e-630c-49ba-a22d-30e3ad567edd	9d65bb5e-8029-4723-9ba9-bc858713969a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 21:56:47
18266	9d65bb5e-7e7e-45be-8ecc-e2ac2b385e0c	9d65bb5e-8029-4723-9ba9-bc858713969a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 21:56:47
18267	9d65bb5e-7f22-4ba6-9de5-e5ad21465a2f	9d65bb5e-8029-4723-9ba9-bc858713969a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":221,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:56:47
21487	9d673aea-b9db-4ab4-a441-22a562117144	9d673aea-fe86-4482-8a8a-40cbd3303307	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 15:49:16
30276	9d69397e-a77f-4dd3-867e-98b1494d7d95	9d69397e-c8cc-4047-80e7-5596879c99d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:36:57
13263	9d5cfc8e-bfa3-439c-9202-38dbef712b64	9d5cfc8e-dd74-496c-86ab-9ed348479eeb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 13:36:37
13264	9d5cfc8e-d839-4776-88df-f09bb5440e82	9d5cfc8e-dd74-496c-86ab-9ed348479eeb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"48.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-29 13:36:37
13265	9d5cfc8e-dc20-417f-9a11-4b0c79cd816f	9d5cfc8e-dd74-496c-86ab-9ed348479eeb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 13:36:37
13266	9d5cfc8e-dc6e-46b5-b6e3-d390e0a5d321	9d5cfc8e-dd74-496c-86ab-9ed348479eeb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":272,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:36:37
18268	9d65bb5e-c83b-4ec3-8d19-c03b57d9036d	9d65bb5e-e576-44d2-9314-74ee5a6213c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 21:56:48
18269	9d65bb5e-dca7-4aa9-a78e-aa6ed8277039	9d65bb5e-e576-44d2-9314-74ee5a6213c4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"41.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"2b11ef88578e3c91c11800e110e490df","hostname":"EderCortes"}	2024-11-02 21:56:48
18180	9d65b999-4424-4502-81cc-73a151467df1	9d65b999-69f6-41e2-b0fc-d228445539a1	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 21:51:50
18181	9d65b999-6714-4a4d-9555-736248e9a545	9d65b999-69f6-41e2-b0fc-d228445539a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:51:50
18182	9d65b999-687a-4a1a-88dd-2839edf2ad57	9d65b999-69f6-41e2-b0fc-d228445539a1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":261,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:51:50
18270	9d65bb5e-e045-438d-aa46-005dd5f08443	9d65bb5e-e576-44d2-9314-74ee5a6213c4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"2.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:56:48
18271	9d65bb5e-e088-45e7-95c0-d7c999778fdf	9d65bb5e-e576-44d2-9314-74ee5a6213c4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:56:48
18272	9d65bb5e-e41c-43ee-a9d3-7643e155020d	9d65bb5e-e576-44d2-9314-74ee5a6213c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 21:56:48
18273	9d65bb5e-e468-420f-b7c4-2afc6e62a641	9d65bb5e-e576-44d2-9314-74ee5a6213c4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":222,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:56:48
21488	9d673aea-fa25-40b3-b849-5c1fc0185afb	9d673aea-fe86-4482-8a8a-40cbd3303307	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"148.65","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 15:49:16
21489	9d673aea-fd33-4fa3-b6aa-1b4de17bf03d	9d673aea-fe86-4482-8a8a-40cbd3303307	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 15:49:16
18183	9d65b999-de1b-49aa-b769-985d8666cbc9	9d65b99a-3167-4426-ae0d-2ec85c2d64bc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:51:51
18184	9d65b99a-236d-4e71-a408-161ef251fce0	9d65b99a-3167-4426-ae0d-2ec85c2d64bc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"163.06","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"2b11ef88578e3c91c11800e110e490df","hostname":"EderCortes"}	2024-11-02 21:51:51
18185	9d65b99a-28b0-40f4-8309-3eaaf7c218f2	9d65b99a-3167-4426-ae0d-2ec85c2d64bc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"2.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:51:51
18186	9d65b99a-28f9-4f24-8243-dbc31385d524	9d65b99a-3167-4426-ae0d-2ec85c2d64bc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:51:51
18187	9d65b99a-2f14-4132-bc80-04b15a8fc768	9d65b99a-3167-4426-ae0d-2ec85c2d64bc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:51:51
18188	9d65b99a-2f70-4841-9c59-5ba9a34a3635	9d65b99a-3167-4426-ae0d-2ec85c2d64bc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":459,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:51:51
18274	9d65bb60-30e2-4c1e-8704-ab01d1d7a020	9d65bb60-5c58-4a76-860c-c25e4ef6b775	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 21:56:49
18275	9d65bb60-5346-44fa-9db0-6c3bcba27b61	9d65bb60-5c58-4a76-860c-c25e4ef6b775	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"59.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 21:56:49
18276	9d65bb60-53b2-4341-acf2-98a04af88457	9d65bb60-5c58-4a76-860c-c25e4ef6b775	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 21:56:49
18277	9d65bb60-5a57-4e7a-892d-5e9d99ace711	9d65bb60-5c58-4a76-860c-c25e4ef6b775	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 21:56:49
18278	9d65bb60-5aed-47dc-8bf7-bd9326bc781d	9d65bb60-5c58-4a76-860c-c25e4ef6b775	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":384,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:56:49
21490	9d673aea-fd85-40bd-b293-1e3edae36664	9d673aea-fe86-4482-8a8a-40cbd3303307	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":324,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:49:16
18189	9d65b99b-f6eb-41a5-b501-e3f4dce3a67b	9d65b99c-262e-4991-8b72-598bce1ca298	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:51:52
18190	9d65b99c-1c4e-4868-b430-c509bddb3482	9d65b99c-262e-4991-8b72-598bce1ca298	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"62.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 21:51:52
18191	9d65b99c-1cd4-458f-acb9-b53def98b2ae	9d65b99c-262e-4991-8b72-598bce1ca298	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 21:51:52
18192	9d65b99c-23d6-42bb-8fc1-396cd8f62685	9d65b99c-262e-4991-8b72-598bce1ca298	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 21:51:52
18193	9d65b99c-2465-4638-ac81-451d0d39d1f9	9d65b99c-262e-4991-8b72-598bce1ca298	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":433,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:51:52
18279	9d668c55-17f8-4cbd-a4c4-6f1368783885	9d668c55-2615-47f5-9068-aaa330d22216	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":262,"memory":18,"hostname":"EderCortes"}	2024-11-03 07:41:06
21491	9d673aeb-3e18-4a86-89a3-a2d1f4c9bc8a	9d673aeb-844f-4f90-ae6d-5659ff1425c7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 15:49:16
21492	9d673aeb-8046-456f-a0e9-0f2fcee0fc44	9d673aeb-844f-4f90-ae6d-5659ff1425c7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"151.85","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 15:49:17
21493	9d673aeb-8336-42b3-b911-b714aa7ccc2b	9d673aeb-844f-4f90-ae6d-5659ff1425c7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 15:49:17
21494	9d673aeb-8378-4e64-a499-e59f877d4037	9d673aeb-844f-4f90-ae6d-5659ff1425c7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":328,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:49:17
30176	9d693594-3d93-46d0-afbc-b0c81712aef4	9d693594-9f2d-4369-acd8-f1314ffdda51	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 15:26:00
18280	9d668c55-ddbd-47b8-b757-69ae26bc970e	9d668c57-f03e-4fa1-90c1-bc48bb139ff2	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 07:41:06
18281	9d668c57-bc5c-481a-a800-8410429ec18e	9d668c57-f03e-4fa1-90c1-bc48bb139ff2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"60.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-03 07:41:07
18282	9d668c57-bcc3-454d-ba75-686ea11b6b85	9d668c57-f03e-4fa1-90c1-bc48bb139ff2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 07:41:07
18283	9d668c57-eeea-4c54-9aba-2d31b748fb91	9d668c57-f03e-4fa1-90c1-bc48bb139ff2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 07:41:07
18284	9d668c57-ef3e-4baa-acae-19412fe5e22c	9d668c57-f03e-4fa1-90c1-bc48bb139ff2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","profile":1},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":1675,"memory":24,"hostname":"EderCortes"}	2024-11-03 07:41:07
30277	9d69397e-bde7-4897-a3ef-38d7fc1bcd61	9d69397e-c8cc-4047-80e7-5596879c99d1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"43.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 15:36:57
30278	9d69397e-c21f-45d3-80ff-246a7d9081bd	9d69397e-c8cc-4047-80e7-5596879c99d1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 15:36:57
30279	9d69397e-c255-42c9-9691-5c5fe27e1b81	9d69397e-c8cc-4047-80e7-5596879c99d1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 15:36:57
21495	9d673aee-793c-4da0-9469-7652450cd461	9d673aee-c1ba-43fc-bc23-ddc0c902bb5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 15:49:18
30177	9d693594-9d44-4788-9487-65724242c73c	9d693594-9f2d-4369-acd8-f1314ffdda51	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:26:00
30178	9d693594-9dfe-4b49-9067-1efb45d8b15d	9d693594-9f2d-4369-acd8-f1314ffdda51	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":647,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:26:00
30280	9d69397e-c75e-45c5-9629-7a1fe0ee4db6	9d69397e-c8cc-4047-80e7-5596879c99d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 15:36:57
30281	9d69397e-c7c7-4343-8133-a5fb8c674112	9d69397e-c8cc-4047-80e7-5596879c99d1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":291,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:36:57
18285	9d668c58-da38-42be-9cb7-7331805797a4	9d668c58-fb9a-46e6-b573-293d8fe6d487	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 07:41:08
18286	9d668c58-f673-4227-a7b2-7a42857b9452	9d668c58-fb9a-46e6-b573-293d8fe6d487	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"52.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 07:41:08
18287	9d668c58-f6e0-4ac1-aa5f-93924bb8dd6c	9d668c58-fb9a-46e6-b573-293d8fe6d487	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 07:41:08
18288	9d668c58-fa85-449c-a079-9fa2e1b8ab80	9d668c58-fb9a-46e6-b573-293d8fe6d487	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 07:41:08
18289	9d668c58-fac6-4ef4-8427-49d6e53509af	9d668c58-fb9a-46e6-b573-293d8fe6d487	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":263,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:41:08
21496	9d673aee-bcf8-4b26-acc6-161c11037cad	9d673aee-c1ba-43fc-bc23-ddc0c902bb5c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '18' and \\"users\\".\\"deleted_at\\" is null","time":"149.93","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":55,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-11-03 15:49:19
21497	9d673aee-bd41-4b86-85ed-5fb89eef25b4	9d673aee-c1ba-43fc-bc23-ddc0c902bb5c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 15:49:19
21498	9d673aee-c08c-463e-a4c1-3add5676a5f3	9d673aee-c1ba-43fc-bc23-ddc0c902bb5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 15:49:19
21499	9d673aee-c0d1-4043-a503-8dc70e5e0591	9d673aee-c1ba-43fc-bc23-ddc0c902bb5c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/18","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}},"duration":353,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:49:19
30179	9d693595-2d7b-4d79-8950-456aaa99f386	9d693595-4fb4-4504-9ad9-ff86441fb117	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:26:00
30180	9d693595-44e0-4eff-a33d-1f1f14e82ea7	9d693595-4fb4-4504-9ad9-ff86441fb117	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"45.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 15:26:01
30181	9d693595-4944-4bc3-85f5-65d9d28f13a0	9d693595-4fb4-4504-9ad9-ff86441fb117	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 15:26:01
30182	9d693595-4984-48d5-bd52-3d487339c580	9d693595-4fb4-4504-9ad9-ff86441fb117	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 15:26:01
30183	9d693595-4e72-4b5d-b0c5-a2d403c08aa1	9d693595-4fb4-4504-9ad9-ff86441fb117	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 15:26:01
18290	9d668c64-809c-4d33-948f-dfe7cc1284b8	9d668c64-a7ff-4d1e-abcf-42cf6732a1ad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 07:41:16
18291	9d668c64-a210-462f-a7a2-479d8de1892c	9d668c64-a7ff-4d1e-abcf-42cf6732a1ad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"59.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58,"hash":"77f8314368b36a9393ec9c7735a91700","hostname":"EderCortes"}	2024-11-03 07:41:16
18292	9d668c64-a69d-47d6-adc0-47a993965aa2	9d668c64-a7ff-4d1e-abcf-42cf6732a1ad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 07:41:16
18293	9d668c64-a6fc-4524-90ec-29343b441dbf	9d668c64-a7ff-4d1e-abcf-42cf6732a1ad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":320,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:41:16
21500	9d673b32-f25b-4c0c-a61e-f75a7d5a77bf	9d673b32-f74e-432a-92b3-d557d4ac8396	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":209,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:50:03
30184	9d693595-4ec1-4e0f-80f6-03262be8d3a3	9d693595-4fb4-4504-9ad9-ff86441fb117	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":343,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:26:01
16368	9d64c411-b9fb-406d-a219-12c91538b22d	9d64c411-e578-4ba9-9b62-bbd90e31d398	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 10:25:17
16369	9d64c411-e304-4225-bad3-0df99b68b0ec	9d64c411-e578-4ba9-9b62-bbd90e31d398	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 10:25:17
16370	9d64c411-e430-4521-94d3-e42ca8060a6b	9d64c411-e578-4ba9-9b62-bbd90e31d398	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":321,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:25:17
19769	9d66e6b6-9f0f-4be7-8f37-ebfbac815e85	9d66e6b6-a418-4069-a1e9-101ff28771f0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":975}	2024-11-03 11:53:49
21501	9d673b33-b265-4caf-a159-d3ab5b7f6432	9d673b34-0499-4594-bfa9-4d766d0ef97e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 15:50:04
21502	9d673b33-f784-4744-80ab-5963e10c91d4	9d673b34-0499-4594-bfa9-4d766d0ef97e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\", \\"loans_fecha_ultimo_pago\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta', 'De las nieve', 'ds', 'CC', '100465546', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '5000000', 25, 10, 'M', null, '03-11-2024', 'Pendiente', '312596295', 12, 14, 18, 14, '03-11-2024', 0, 0, '03-11-2024', '2024-11-03 15:50:04', '2024-11-03 15:50:04') returning \\"id\\"","time":"4.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":106,"hash":"627b53ca897e623c432f1126c69a0881","hostname":"EderCortes"}	2024-11-03 15:50:04
21503	9d673b33-f807-43fe-80d6-69b2430c0dc2	9d673b34-0499-4594-bfa9-4d766d0ef97e	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:66","hostname":"EderCortes"}	2024-11-03 15:50:04
30412	9d693de5-0228-443f-a500-48ad6a2c8416	9d693de5-2d18-4479-91f4-8c4902b15a80	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 15:49:15
30413	9d693de5-2a47-4a2a-a459-46e54ceb7463	9d693de5-2d18-4479-91f4-8c4902b15a80	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:49:15
16371	9d64c412-56ec-492d-93db-d86d3e8f36b5	9d64c412-7d4e-4ef6-a905-075dc6cf6b54	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 10:25:18
16372	9d64c412-7176-4d4c-8a17-ffc8ff86df71	9d64c412-7d4e-4ef6-a905-075dc6cf6b54	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"48.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 10:25:18
16373	9d64c412-75a1-4ccf-9db0-5b84208bb443	9d64c412-7d4e-4ef6-a905-075dc6cf6b54	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 10:25:18
16374	9d64c412-75e0-422a-87fe-9af1278217e6	9d64c412-7d4e-4ef6-a905-075dc6cf6b54	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 10:25:18
16375	9d64c412-7b76-48f9-9ee2-b9856a9246d8	9d64c412-7d4e-4ef6-a905-075dc6cf6b54	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 10:25:18
16376	9d64c412-7c00-4cc0-b520-e389e7e9c2d6	9d64c412-7d4e-4ef6-a905-075dc6cf6b54	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":341,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:25:18
18294	9d668c93-3b6f-4bde-9cd7-6c18319de18d	9d668c93-5efc-43b2-989b-92a097449dcd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 07:41:46
18295	9d668c93-54be-4ee0-ba42-c3ecb0487d0f	9d668c93-5efc-43b2-989b-92a097449dcd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"51.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-03 07:41:46
18296	9d668c93-5920-4429-a811-7d3947847086	9d668c93-5efc-43b2-989b-92a097449dcd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 07:41:46
18297	9d668c93-5950-422a-8209-99f72ee4521b	9d668c93-5efc-43b2-989b-92a097449dcd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 07:41:46
18298	9d668c93-5d9b-4af1-88c0-bb540737a8cf	9d668c93-5efc-43b2-989b-92a097449dcd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 07:41:46
21504	9d673b33-f9cc-4792-b96a-be7396c82fc8	9d673b34-0499-4594-bfa9-4d766d0ef97e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (66, 1, 500000, 125000, 'Pendiente', 'N\\/A', '03-12-2024', 12, 0, 0, '2024-11-03 15:50:04', '2024-11-03 15:50:04')","time":"2.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 15:50:04
21505	9d673b33-f9f9-47ee-92ea-904e877b623f	9d673b34-0499-4594-bfa9-4d766d0ef97e	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 15:50:04
30414	9d693de5-2b9c-4a8e-b0a4-afadd17f2254	9d693de5-2d18-4479-91f4-8c4902b15a80	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":400,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:49:15
16377	9d64c414-5b29-4014-b3e9-35c65c506e69	9d64c414-838a-4ee6-ba34-9e03ecc764ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 10:25:19
16378	9d64c414-7b7c-4c2c-8439-9516455b63f1	9d64c414-838a-4ee6-ba34-9e03ecc764ec	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"53.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 10:25:19
16379	9d64c414-7c0b-4244-a8d3-9e4556e45fb7	9d64c414-838a-4ee6-ba34-9e03ecc764ec	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 10:25:19
16380	9d64c414-81a0-42a1-9f02-96a1b8c124fd	9d64c414-838a-4ee6-ba34-9e03ecc764ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 10:25:19
16381	9d64c414-821e-4611-8e53-666defeb3c0b	9d64c414-838a-4ee6-ba34-9e03ecc764ec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:25:19
18299	9d668c93-5dea-48f9-b6d4-a5c14a93a12c	9d668c93-5efc-43b2-989b-92a097449dcd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:34:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"}]}},"duration":242,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:41:46
21506	9d673b33-fa6f-46e1-9938-3e0ee807a886	9d673b34-0499-4594-bfa9-4d766d0ef97e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (66, 2, 500000, 125000, 'Pendiente', 'N\\/A', '02-01-2025', 12, 0, 0, '2024-11-03 15:50:04', '2024-11-03 15:50:04')","time":"0.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 15:50:04
21507	9d673b33-fa93-4bd6-93e4-f6b28ce5c939	9d673b34-0499-4594-bfa9-4d766d0ef97e	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 15:50:04
21508	9d673b33-fafe-4eec-8cd8-0365d2eb34de	9d673b34-0499-4594-bfa9-4d766d0ef97e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (66, 3, 500000, 125000, 'Pendiente', 'N\\/A', '01-02-2025', 12, 0, 0, '2024-11-03 15:50:04', '2024-11-03 15:50:04')","time":"0.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 15:50:04
21509	9d673b33-fb22-49c5-9b0d-6b860267cf44	9d673b34-0499-4594-bfa9-4d766d0ef97e	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 15:50:04
21510	9d673b33-fb9d-49ec-aedb-c346e681fb33	9d673b34-0499-4594-bfa9-4d766d0ef97e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (66, 4, 500000, 125000, 'Pendiente', 'N\\/A', '03-03-2025', 12, 0, 0, '2024-11-03 15:50:04', '2024-11-03 15:50:04')","time":"0.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 15:50:04
21511	9d673b33-fbc3-45be-ac71-2a260febbce6	9d673b34-0499-4594-bfa9-4d766d0ef97e	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 15:50:04
21512	9d673b33-fc34-4454-b1b8-653cdab8170e	9d673b34-0499-4594-bfa9-4d766d0ef97e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (66, 5, 500000, 125000, 'Pendiente', 'N\\/A', '02-04-2025', 12, 0, 0, '2024-11-03 15:50:04', '2024-11-03 15:50:04')","time":"0.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 15:50:04
21513	9d673b33-fc58-4b1f-babf-9dd3b31ecf3c	9d673b34-0499-4594-bfa9-4d766d0ef97e	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 15:50:04
21514	9d673b33-fccf-48b6-aea7-0719d0933ff3	9d673b34-0499-4594-bfa9-4d766d0ef97e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (66, 6, 500000, 125000, 'Pendiente', 'N\\/A', '02-05-2025', 12, 0, 0, '2024-11-03 15:50:04', '2024-11-03 15:50:04')","time":"0.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 15:50:04
21515	9d673b33-fcff-4c6e-94e8-957b5b72e773	9d673b34-0499-4594-bfa9-4d766d0ef97e	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 15:50:04
21516	9d673b33-fd73-4d65-b410-93de0dde8c57	9d673b34-0499-4594-bfa9-4d766d0ef97e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (66, 7, 500000, 125000, 'Pendiente', 'N\\/A', '01-06-2025', 12, 0, 0, '2024-11-03 15:50:04', '2024-11-03 15:50:04')","time":"0.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 15:50:04
21517	9d673b33-fd97-4976-90f9-dd48adadbf4a	9d673b34-0499-4594-bfa9-4d766d0ef97e	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 15:50:04
21518	9d673b33-fe03-48a0-97fb-92da6843c9f4	9d673b34-0499-4594-bfa9-4d766d0ef97e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (66, 8, 500000, 125000, 'Pendiente', 'N\\/A', '01-07-2025', 12, 0, 0, '2024-11-03 15:50:04', '2024-11-03 15:50:04')","time":"0.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 15:50:04
21519	9d673b33-fe2c-4f7a-b04a-1479af5b6460	9d673b34-0499-4594-bfa9-4d766d0ef97e	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 15:50:04
21520	9d673b33-feac-4359-8f32-9f0b17960be4	9d673b34-0499-4594-bfa9-4d766d0ef97e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (66, 9, 500000, 125000, 'Pendiente', 'N\\/A', '31-07-2025', 12, 0, 0, '2024-11-03 15:50:04', '2024-11-03 15:50:04')","time":"0.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 15:50:04
21521	9d673b33-fed3-4664-a551-4d2d94d68a9d	9d673b34-0499-4594-bfa9-4d766d0ef97e	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 15:50:04
21522	9d673b33-ff44-4c3f-b43b-ada1f3042d65	9d673b34-0499-4594-bfa9-4d766d0ef97e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (66, 10, 500000, 125000, 'Pendiente', 'N\\/A', '30-08-2025', 12, 0, 0, '2024-11-03 15:50:04', '2024-11-03 15:50:04')","time":"0.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 15:50:04
21523	9d673b33-ff6b-451f-84b3-ae92e5adc9fd	9d673b34-0499-4594-bfa9-4d766d0ef97e	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 15:50:04
21524	9d673b34-033f-4243-91ff-5e344f584824	9d673b34-0499-4594-bfa9-4d766d0ef97e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 15:50:04
21525	9d673b34-0384-44c1-9cc7-1870c04fe2bb	9d673b34-0499-4594-bfa9-4d766d0ef97e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"792","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"100465546","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"5000000","loans_intereses":25,"loans_cuotas":10,"loans_cuando":"M","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":18,"user_recomendacion":14,"loans_inicio_pago":"03-11-2024","created_at":null,"updated_at":null,"deleted_at":null,"loans_pago_prestado":0,"loans_pago_interes":0},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Sun Nov 03 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":66},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:50:04
30415	9d693de5-bc4b-41fc-8e9b-bc741b69b2de	9d693de6-0d2d-4ff0-ba41-93ff5776e9ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:49:15
21526	9d673b43-8893-4b80-95e3-64ebd8102963	9d673b43-a9a7-4124-97b5-2d077abca041	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 15:50:14
21527	9d673b43-a44f-49a7-86fa-79f5962651d0	9d673b43-a9a7-4124-97b5-2d077abca041	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"42.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 15:50:14
21528	9d673b43-a807-43df-a6e6-ae59f13601df	9d673b43-a9a7-4124-97b5-2d077abca041	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:50:14
21529	9d673b43-a878-42a3-a8b3-940c52b46ec9	9d673b43-a9a7-4124-97b5-2d077abca041	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:50:14
30416	9d693de6-0131-4ecf-9aeb-4521efceae53	9d693de6-0d2d-4ff0-ba41-93ff5776e9ba	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"151.81","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 15:49:16
22204	9d67439c-3469-4c8f-952c-61d2d73729b1	9d67439c-7224-4f13-8e00-0d5540999af6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 16:13:35
22205	9d67439c-6e43-4d4e-b613-99c1a650c9e9	9d67439c-7224-4f13-8e00-0d5540999af6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 16:13:35
22206	9d67439c-7033-47b1-bed7-c53505fa7f82	9d67439c-7224-4f13-8e00-0d5540999af6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":641,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:13:35
30417	9d693de6-060a-4408-b119-e78858d9cb59	9d693de6-0d2d-4ff0-ba41-93ff5776e9ba	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 15:49:16
30418	9d693de6-0651-4327-b7d1-1566b5674a18	9d693de6-0d2d-4ff0-ba41-93ff5776e9ba	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 15:49:16
30419	9d693de6-0bcb-43fa-a51a-44c01568d3b5	9d693de6-0d2d-4ff0-ba41-93ff5776e9ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 15:49:16
30420	9d693de6-0c2a-488e-a3f7-d3ab2a56712c	9d693de6-0d2d-4ff0-ba41-93ff5776e9ba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":516,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:49:16
16453	9d64c9d9-3369-4780-860b-40da3494d2c0	9d64c9d9-50ee-4546-947d-151528d70edc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 10:41:27
16454	9d64c9d9-4f35-45bc-93ca-21358571f42c	9d64c9d9-50ee-4546-947d-151528d70edc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-02 10:41:27
16455	9d64c9d9-4fef-4d52-acee-09a8343cb93d	9d64c9d9-50ee-4546-947d-151528d70edc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:41:27
22207	9d67439d-2adc-4f2e-9f9e-ca79c53ec22a	9d67439d-60ed-415a-821d-46e1fdc98f32	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 16:13:35
392	9d4f278d-1a2f-4710-b632-0b28611042dd	9d4f278d-1d67-48b4-b230-fae8eac84c6b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":25}	2024-10-22 16:35:15
16456	9d64c9d9-9e19-4bbb-92f7-5228bb70307d	9d64c9d9-bd38-4499-9323-8bf24702bc11	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-02 10:41:27
16457	9d64c9d9-b3cd-4f67-9437-eab1cbc72b46	9d64c9d9-bd38-4499-9323-8bf24702bc11	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"43.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 10:41:27
16458	9d64c9d9-b7c5-4ad3-b11f-dd241e17671a	9d64c9d9-bd38-4499-9323-8bf24702bc11	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 10:41:27
16459	9d64c9d9-b7fc-4626-b496-c333b543fd76	9d64c9d9-bd38-4499-9323-8bf24702bc11	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 10:41:27
16460	9d64c9d9-bbc7-422a-88fe-661bff6afa53	9d64c9d9-bd38-4499-9323-8bf24702bc11	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-02 10:41:27
16461	9d64c9d9-bc1c-41c1-a930-c5df76b23d43	9d64c9d9-bd38-4499-9323-8bf24702bc11	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:41:27
18492	9d669261-da90-44f2-96e6-c430b97234ee	9d669261-f797-4033-8f16-d7bd6bf7de6d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 07:58:01
18493	9d669261-f5dd-432d-aba9-b16d639a7e95	9d669261-f797-4033-8f16-d7bd6bf7de6d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 07:58:01
18494	9d669261-f687-4ec5-ae13-52fafc0f4269	9d669261-f797-4033-8f16-d7bd6bf7de6d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:58:01
18629	9d6696f8-4afc-45cd-9ab5-cb52bd123905	9d6696f8-4de3-40f8-81c7-d6d968c24f4a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abPendiente\\u00bb\\nLINE 4: ... WHEN l.loans_cuando = 'D' AND 'l.loans_estado = 'Pendiente'...\\n                                                             ^ (Connection: pgsql, SQL: select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND 'l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND 'l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND 'l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND 'l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND 'l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":897}	2024-11-03 08:10:50
18630	9d6696f8-32c7-4562-bc03-37c23b347bcb	9d6696f8-4de3-40f8-81c7-d6d968c24f4a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 08:10:50
18631	9d6696f8-4c34-4a47-9a79-43b84e007df8	9d6696f8-4de3-40f8-81c7-d6d968c24f4a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 08:10:50
18632	9d6696f8-4cc9-42f6-a4bc-798f9d75eb18	9d6696f8-4de3-40f8-81c7-d6d968c24f4a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abPendiente\\u00bb\\nLINE 4: ... WHEN l.loans_cuando = 'D' AND 'l.loans_estado = 'Pendiente'...\\n                                                             ^ (Connection: pgsql, SQL: select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND 'l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND 'l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND 'l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND 'l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND 'l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:10:50
22208	9d67439d-5139-4bea-8934-894edb0734c1	9d67439d-60ed-415a-821d-46e1fdc98f32	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 68\\n                        ","time":"69.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"7d9994d55cb8dde82ff4185920c79043","hostname":"EderCortes"}	2024-11-03 16:13:35
22209	9d67439d-57e6-41b5-952d-22e3c9212bfb	9d67439d-60ed-415a-821d-46e1fdc98f32	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '68' order by \\"item_loans\\".\\"id\\" asc","time":"4.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 16:13:35
22210	9d67439d-583d-4c57-9c02-b251ebab3ac6	9d67439d-60ed-415a-821d-46e1fdc98f32	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 16:13:35
22211	9d67439d-5ef2-4cad-9d26-3d44d8674d8e	9d67439d-60ed-415a-821d-46e1fdc98f32	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 16:13:35
16462	9d64c9db-5a57-459d-b21c-5566ecb25340	9d64c9db-886c-4334-a6ca-a7280095e488	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-02 10:41:28
16463	9d64c9db-803f-43e1-b84a-46fee3566f74	9d64c9db-886c-4334-a6ca-a7280095e488	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"60.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 10:41:28
16464	9d64c9db-80c9-439d-9ce8-48b779d423e1	9d64c9db-886c-4334-a6ca-a7280095e488	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 10:41:28
16465	9d64c9db-866b-463a-a0a1-e5c267eef0c9	9d64c9db-886c-4334-a6ca-a7280095e488	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-02 10:41:28
16466	9d64c9db-86f7-45f9-b04a-e28a3d503043	9d64c9db-886c-4334-a6ca-a7280095e488	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":403,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:41:28
18495	9d669262-4329-42bb-992b-80fd2be61b1b	9d669262-5e4e-4505-a24f-bbb4fd7c1c3f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 07:58:01
18496	9d669262-5a51-4704-8126-4dfd3568d8b1	9d669262-5e4e-4505-a24f-bbb4fd7c1c3f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"42.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58,"hash":"77f8314368b36a9393ec9c7735a91700","hostname":"EderCortes"}	2024-11-03 07:58:01
18497	9d669262-5d23-44df-9271-0e0e1fe23baa	9d669262-5e4e-4505-a24f-bbb4fd7c1c3f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 07:58:01
18498	9d669262-5d72-4bd8-8ac2-1ac541773283	9d669262-5e4e-4505-a24f-bbb4fd7c1c3f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:58:01
22212	9d67439d-5f86-411b-a12c-ad5772dda405	9d67439d-60ed-415a-821d-46e1fdc98f32	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/68","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":68,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":10000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"1000000","loans_pago_interes":"250000"},"items":[{"id":227,"loans_codigo":68,"itemloans_cuota":"1","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":228,"loans_codigo":68,"itemloans_cuota":"2","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":229,"loans_codigo":68,"itemloans_cuota":"3","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":230,"loans_codigo":68,"itemloans_cuota":"4","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":231,"loans_codigo":68,"itemloans_cuota":"5","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":232,"loans_codigo":68,"itemloans_cuota":"6","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":233,"loans_codigo":68,"itemloans_cuota":"7","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":234,"loans_codigo":68,"itemloans_cuota":"8","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":235,"loans_codigo":68,"itemloans_cuota":"9","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":236,"loans_codigo":68,"itemloans_cuota":"10","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":532,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:13:35
16467	9d64ca23-7c4f-4e09-ae5e-bc40800a1967	9d64ca23-804d-4e10-8853-c39b06eb2805	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":328,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:42:16
18499	9d669264-b215-4074-bd0a-cf46e0958b43	9d669264-e2f8-412e-b482-715828f10286	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 07:58:02
18500	9d669264-d93d-4893-a460-8bc6d7ad8322	9d669264-e2f8-412e-b482-715828f10286	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"58.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 07:58:03
18501	9d669264-d9ba-4e47-9d13-7d8a89acabe2	9d669264-e2f8-412e-b482-715828f10286	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 07:58:03
18502	9d669264-e124-4a44-9d58-d0532cb416f5	9d669264-e2f8-412e-b482-715828f10286	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 07:58:03
18503	9d669264-e1a1-4ffb-8214-4aeddb312687	9d669264-e2f8-412e-b482-715828f10286	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":383,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:58:03
22213	9d67439e-090a-437c-8e29-9965784059d7	9d67439e-6d59-49a5-ac75-4da6b869c8aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 16:13:36
22214	9d67439e-60ee-4ccc-bbb5-be3c0f38444c	9d67439e-6d59-49a5-ac75-4da6b869c8aa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"165.73","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:13:36
22215	9d67439e-619d-4074-851f-27c74ef55728	9d67439e-6d59-49a5-ac75-4da6b869c8aa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:13:36
22216	9d67439e-6a94-4b0f-ac3f-4a8e237efa30	9d67439e-6d59-49a5-ac75-4da6b869c8aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 16:13:36
22217	9d67439e-6b3a-4400-ba62-78ea7ec072a3	9d67439e-6d59-49a5-ac75-4da6b869c8aa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":662,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:13:36
16468	9d64ca24-5485-450d-a7b4-2653246ace65	9d64ca24-66c6-4ea0-bb3f-6c93dabb7e1d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 10:42:16
16469	9d64ca24-649c-4fe0-bebb-a1524ab51628	9d64ca24-66c6-4ea0-bb3f-6c93dabb7e1d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 10:42:16
16470	9d64ca24-6529-4f21-8a47-9f3cba40af3d	9d64ca24-66c6-4ea0-bb3f-6c93dabb7e1d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"2","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":[]},"duration":273,"memory":20,"hostname":"EderCortes"}	2024-11-02 10:42:16
22218	9d67439f-5ea8-40cf-b877-7f4f978edf1c	9d67439f-8ab4-4a71-960d-f9c3e1b297a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 16:13:37
22219	9d67439f-83f5-4e8f-abf9-8cb394dd362c	9d67439f-8ab4-4a71-960d-f9c3e1b297a4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"58.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:13:37
22220	9d67439f-846b-4c70-9564-713cd3175823	9d67439f-8ab4-4a71-960d-f9c3e1b297a4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:13:37
22221	9d67439f-88f6-4001-9600-83db0dfd3f24	9d67439f-8ab4-4a71-960d-f9c3e1b297a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 16:13:37
22222	9d67439f-8969-4fce-8f4b-4334da8e9ebd	9d67439f-8ab4-4a71-960d-f9c3e1b297a4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":548,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:13:37
18565	9d66946a-d26a-42df-9627-0e2f53234c36	9d66946b-1783-4397-abd2-480892d81c4c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 08:03:42
18566	9d66946b-1601-435a-b536-4f5b9ce89c7b	9d66946b-1783-4397-abd2-480892d81c4c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 08:03:42
18567	9d66946b-1692-4c56-b870-e13c1f7b525c	9d66946b-1783-4397-abd2-480892d81c4c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":350,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:03:42
18568	9d66946b-7bdc-42e9-96c2-06e60bb3ab0f	9d66946b-9b42-4353-b37d-d57784d8b348	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 08:03:42
18569	9d66946b-9685-4e91-8aa9-406064936dbb	9d66946b-9b42-4353-b37d-d57784d8b348	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"49.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58,"hash":"77f8314368b36a9393ec9c7735a91700","hostname":"EderCortes"}	2024-11-03 08:03:43
18570	9d66946b-99c8-4ba2-8b44-81cfe298a099	9d66946b-9b42-4353-b37d-d57784d8b348	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 08:03:43
18571	9d66946b-9a3a-4a2a-9951-39a3fb23bf30	9d66946b-9b42-4353-b37d-d57784d8b348	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":298,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:03:43
30585	9d694066-9266-45b3-9b1b-9088ff35f45b	9d694066-c0df-43db-bb34-831aa4458c14	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 15:56:15
30586	9d694066-bdf1-4413-8176-0de2e9ff7dee	9d694066-c0df-43db-bb34-831aa4458c14	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:56:16
22316	9d674a75-4967-4a58-be8c-4c92628fd99a	9d674a75-883a-42df-b75f-45e86e2cf4cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 16:32:43
22317	9d674a75-84c5-4ad6-a1d7-2988d81352c7	9d674a75-883a-42df-b75f-45e86e2cf4cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 16:32:44
22318	9d674a75-867b-4806-9765-8f79e8505432	9d674a75-883a-42df-b75f-45e86e2cf4cf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":669,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:32:44
30587	9d694066-bf4d-463f-b30a-0ae1a698e438	9d694066-c0df-43db-bb34-831aa4458c14	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":381,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:56:16
18572	9d66946d-729b-4eca-af93-aac1d7d1ccc7	9d66946d-abd7-4156-be9f-c98cbfd55652	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 08:03:44
18573	9d66946d-9ed2-4e37-952b-6aa875d6c34e	9d66946d-abd7-4156-be9f-c98cbfd55652	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"75.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 08:03:44
18574	9d66946d-9f89-4d23-915e-86833d28c7c4	9d66946d-abd7-4156-be9f-c98cbfd55652	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 08:03:44
18575	9d66946d-a970-4b5e-8e2b-1d66f7543f32	9d66946d-abd7-4156-be9f-c98cbfd55652	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 08:03:44
18576	9d66946d-aa46-4a2d-92a9-6557d6328d10	9d66946d-abd7-4156-be9f-c98cbfd55652	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":610,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:03:44
22319	9d674a76-2364-4ff5-a2a0-e3d7663e85b4	9d674a76-7d23-4385-915e-e83b5e58c366	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 16:32:44
22320	9d674a76-6ec4-4f9e-8b5d-4740443fd8d8	9d674a76-7d23-4385-915e-e83b5e58c366	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 68\\n                        ","time":"166.20","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"7d9994d55cb8dde82ff4185920c79043","hostname":"EderCortes"}	2024-11-03 16:32:44
22321	9d674a76-73c7-4665-bc4a-05b03cd3101c	9d674a76-7d23-4385-915e-e83b5e58c366	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '68' order by \\"item_loans\\".\\"id\\" asc","time":"3.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 16:32:44
22322	9d674a76-7418-4e28-9750-3648a38f3e00	9d674a76-7d23-4385-915e-e83b5e58c366	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 16:32:44
22323	9d674a76-7b2f-431c-a16a-63de14c37766	9d674a76-7d23-4385-915e-e83b5e58c366	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 16:32:44
22324	9d674a76-7ba9-4184-9248-9c1002a81ba6	9d674a76-7d23-4385-915e-e83b5e58c366	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/68","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":68,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":10000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"1000000","loans_pago_interes":"250000"},"items":[{"id":227,"loans_codigo":68,"itemloans_cuota":"1","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":228,"loans_codigo":68,"itemloans_cuota":"2","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":229,"loans_codigo":68,"itemloans_cuota":"3","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":230,"loans_codigo":68,"itemloans_cuota":"4","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":231,"loans_codigo":68,"itemloans_cuota":"5","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":232,"loans_codigo":68,"itemloans_cuota":"6","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":233,"loans_codigo":68,"itemloans_cuota":"7","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":234,"loans_codigo":68,"itemloans_cuota":"8","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":235,"loans_codigo":68,"itemloans_cuota":"9","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":236,"loans_codigo":68,"itemloans_cuota":"10","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":562,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:32:44
30588	9d694067-473d-4489-8cd6-06c7f0804cd8	9d694067-6bae-47f8-a747-864d0f9cd1b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:56:16
22325	9d674a77-cbab-41ba-81ac-c7645e2bddf4	9d674a78-5845-4488-9b21-39c8600dcb96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 16:32:45
22326	9d674a78-4663-4d94-9d71-0db9b08623f3	9d674a78-5845-4488-9b21-39c8600dcb96	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"148.64","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:32:45
22327	9d674a78-472a-40c4-b04e-daa64b7f891c	9d674a78-5845-4488-9b21-39c8600dcb96	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:32:45
22328	9d674a78-4fff-4c5b-8313-2bdd9ece7a9b	9d674a78-5845-4488-9b21-39c8600dcb96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 16:32:45
22329	9d674a78-5107-4608-8260-c2e01e46d49c	9d674a78-5845-4488-9b21-39c8600dcb96	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1165,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:32:45
30589	9d694067-5fed-4e26-9ac7-2b8a36caf08d	9d694067-6bae-47f8-a747-864d0f9cd1b9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"46.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 15:56:16
30590	9d694067-63ff-4bbc-974c-2c06007ef638	9d694067-6bae-47f8-a747-864d0f9cd1b9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 15:56:16
30591	9d694067-6444-461c-829f-77f4436e1521	9d694067-6bae-47f8-a747-864d0f9cd1b9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 15:56:16
30592	9d694067-69ea-4e18-b97f-152c5ee74f2f	9d694067-6bae-47f8-a747-864d0f9cd1b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 15:56:16
30593	9d694067-6a61-4d4f-9b4a-067e2fe7ba5c	9d694067-6bae-47f8-a747-864d0f9cd1b9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder.cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":370,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:56:16
22330	9d674a79-0d64-478e-9f0e-3029a98b1449	9d674a79-41ff-4e7b-acc1-5495195fad90	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 16:32:46
22331	9d674a79-38aa-4790-8f8b-146ba6782642	9d674a79-41ff-4e7b-acc1-5495195fad90	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"67.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:32:46
22332	9d674a79-3950-4408-b38f-8c888ba33ee5	9d674a79-41ff-4e7b-acc1-5495195fad90	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:32:46
22333	9d674a79-400a-4a6e-964b-1f19b11df971	9d674a79-41ff-4e7b-acc1-5495195fad90	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 16:32:46
22334	9d674a79-4089-43d6-91fd-2cb8b6eb902f	9d674a79-41ff-4e7b-acc1-5495195fad90	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":567,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:32:46
30717	9d694313-a19c-421b-adfa-0477c2a0ecb0	9d694314-0107-42df-98e5-da22368edc53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:03:44
30718	9d694313-fe66-4b21-9ca0-c77fb3dd1f44	9d694314-0107-42df-98e5-da22368edc53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:03:45
30719	9d694313-ff66-4cd9-b127-091e0d027f19	9d694314-0107-42df-98e5-da22368edc53	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":574,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:03:45
30720	9d694314-6a7a-4c50-90bf-6104dcccc3e4	9d694314-9881-4f37-8d17-36b5e82c88b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:03:45
21763	9d673e27-9ab5-4cdb-87e8-03b58bebb73d	9d673e27-bbf1-411d-ac8b-38b36b830e13	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 15:58:19
21764	9d673e27-ba45-486c-af23-f1a1f25a52f6	9d673e27-bbf1-411d-ac8b-38b36b830e13	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:58:19
21765	9d673e27-baf3-439c-82dc-bb6698fa68fd	9d673e27-bbf1-411d-ac8b-38b36b830e13	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:58:19
30721	9d694314-8ad7-4400-a6eb-03e1ab662190	9d694314-9881-4f37-8d17-36b5e82c88b2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"56.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 16:03:45
30722	9d694314-901e-4652-a52a-e7f276e3a417	9d694314-9881-4f37-8d17-36b5e82c88b2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 16:03:45
30723	9d694314-9064-40f9-babb-d517f4778b2e	9d694314-9881-4f37-8d17-36b5e82c88b2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 16:03:45
30724	9d694314-96ff-4c2b-8c6d-1439cb8ce353	9d694314-9881-4f37-8d17-36b5e82c88b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:03:45
30725	9d694314-9775-4657-a201-9012d0cecb64	9d694314-9881-4f37-8d17-36b5e82c88b2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder.cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":329,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:03:45
16572	9d64d3cf-1653-4b64-9c0e-7014887ecc30	9d64d3cf-378f-4f8e-934b-4b827aaa08a9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 11:09:18
16573	9d64d3cf-3618-495d-ab72-4ea5912e7370	9d64d3cf-378f-4f8e-934b-4b827aaa08a9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 11:09:18
16574	9d64d3cf-36b1-4b19-ac18-508cd067544e	9d64d3cf-378f-4f8e-934b-4b827aaa08a9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":387,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:09:18
21766	9d673e28-11ab-4226-8aba-d4f28f825bb4	9d673e28-2e8d-42be-86cf-f1229574847b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:58:20
21767	9d673e28-2978-43c6-8bfd-838c023f6f5c	9d673e28-2e8d-42be-86cf-f1229574847b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 15:58:20
30867	9d694409-f587-4436-b3fd-e4cf7cf4e775	9d69440a-21bb-4267-bfa1-a6949f35c431	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 16:06:26
21768	9d673e28-29df-487a-87eb-35911bcfea9f	9d673e28-2e8d-42be-86cf-f1229574847b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 15:58:20
21769	9d673e28-2d61-453f-a012-73ae81721c22	9d673e28-2e8d-42be-86cf-f1229574847b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:58:20
30868	9d69440a-1f82-418b-9525-1ef89b55d182	9d69440a-21bb-4267-bfa1-a6949f35c431	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:06:26
30869	9d69440a-209a-48c0-9821-a737ac32ac2b	9d69440a-21bb-4267-bfa1-a6949f35c431	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":315,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:06:26
16575	9d64d3cf-997c-497c-b6e1-e4aebaf31c27	9d64d3cf-be91-47a4-94f1-79d64a6c0cd2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 11:09:18
16576	9d64d3cf-b1ca-4c65-8b69-22d6490e3289	9d64d3cf-be91-47a4-94f1-79d64a6c0cd2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"44.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 11:09:18
16577	9d64d3cf-b74d-4595-8df8-2f631ea89d99	9d64d3cf-be91-47a4-94f1-79d64a6c0cd2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"3.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 11:09:18
16578	9d64d3cf-b789-4acd-b7a6-0156fb43a99b	9d64d3cf-be91-47a4-94f1-79d64a6c0cd2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 11:09:18
16579	9d64d3cf-bca9-498b-8a13-775ccd652eac	9d64d3cf-be91-47a4-94f1-79d64a6c0cd2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 11:09:18
16580	9d64d3cf-bd42-4a5c-b814-46df93688782	9d64d3cf-be91-47a4-94f1-79d64a6c0cd2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":298,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:09:18
21770	9d673e28-2dbb-4b4c-a5aa-1c6c5f94393a	9d673e28-2e8d-42be-86cf-f1229574847b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:58:20
30870	9d69440a-85ff-4a89-9809-555b779b4290	9d69440a-a48f-4a1b-bd77-654a0359112a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:06:26
30871	9d69440a-9b1a-4d05-82c0-8b7e25749f6d	9d69440a-a48f-4a1b-bd77-654a0359112a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"40.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 16:06:26
30872	9d69440a-9eb5-45bf-9f14-73ad2920d276	9d69440a-a48f-4a1b-bd77-654a0359112a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 16:06:26
30873	9d69440a-9eeb-40ff-bf7e-bb1b5762d95f	9d69440a-a48f-4a1b-bd77-654a0359112a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 16:06:26
16581	9d64d3d1-d650-4a86-bf78-0d8e779f1d0b	9d64d3d1-fbbf-49a5-9bde-5f4848c61a51	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 11:09:20
16582	9d64d3d1-f5fd-4799-9828-04d1ce99b458	9d64d3d1-fbbf-49a5-9bde-5f4848c61a51	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"53.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 11:09:20
16583	9d64d3d1-f65b-4355-9f7c-0dfc8c257098	9d64d3d1-fbbf-49a5-9bde-5f4848c61a51	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 11:09:20
16584	9d64d3d1-fa51-4441-91b2-8c5edb934a08	9d64d3d1-fbbf-49a5-9bde-5f4848c61a51	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 11:09:20
16585	9d64d3d1-faa6-430d-921b-0fdf50caf61c	9d64d3d1-fbbf-49a5-9bde-5f4848c61a51	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":366,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:09:20
21771	9d673e28-6dad-43b7-8d48-bb0ae6b090ae	9d673e28-8c05-4105-8226-202629cbd7db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:58:20
21772	9d673e28-86a5-410e-b327-202ea2fa93fe	9d673e28-8c05-4105-8226-202629cbd7db	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 15:58:20
21773	9d673e28-8710-4c76-aa13-2c55fd8e18b5	9d673e28-8c05-4105-8226-202629cbd7db	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-03 15:58:20
21774	9d673e28-8ae6-4b7c-b593-a4a6cce5d922	9d673e28-8c05-4105-8226-202629cbd7db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 15:58:20
21775	9d673e28-8b36-4ea2-93ef-a2d900bef356	9d673e28-8c05-4105-8226-202629cbd7db	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":220,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:58:20
30874	9d69440a-a336-4dcd-9bb2-7be5d94854b5	9d69440a-a48f-4a1b-bd77-654a0359112a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:06:26
30875	9d69440a-a386-4679-9bc2-5743a96d8c20	9d69440a-a48f-4a1b-bd77-654a0359112a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder.cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":287,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:06:26
16586	9d64d3d9-3bf9-4dd4-aa04-b3875b4c734a	9d64d3d9-4201-46fe-886b-90b9f64d239a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":243,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:09:25
21776	9d673e2a-4648-482a-a11a-9082ae4b3bac	9d673e2a-8cd9-4ab6-9619-eddcca049e55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 15:58:21
21777	9d673e2a-8839-4c8b-ae9e-516e027afdc4	9d673e2a-8cd9-4ab6-9619-eddcca049e55	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"147.85","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 15:58:21
21778	9d673e2a-8897-4850-b8ef-2841254ed669	9d673e2a-8cd9-4ab6-9619-eddcca049e55	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 15:58:21
21779	9d673e2a-8bad-4da6-a4be-0aae1a6407e8	9d673e2a-8cd9-4ab6-9619-eddcca049e55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 15:58:21
21780	9d673e2a-8bf4-4338-95a5-a5a479c0b74d	9d673e2a-8cd9-4ab6-9619-eddcca049e55	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":428,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:58:21
30975	9d69450b-0373-406d-88b7-b73449cb0c4c	9d69450b-49d9-496e-98bf-48e6bf7d4dac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 16:09:14
22478	9d674f57-66b1-47f7-bbf6-6d29032692fb	9d674f57-a208-424b-aded-bd2d81195a6d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 16:46:23
22479	9d674f57-9f34-4c9f-bea5-860419e48175	9d674f57-a208-424b-aded-bd2d81195a6d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 16:46:23
22480	9d674f57-a05e-4dd8-a779-60ecca672ed6	9d674f57-a208-424b-aded-bd2d81195a6d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":441,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:46:23
30976	9d69450b-4845-4bbc-97db-736eab8fa0d7	9d69450b-49d9-496e-98bf-48e6bf7d4dac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 16:09:14
30977	9d69450b-48de-4bf4-8fed-6b0f14160fbe	9d69450b-49d9-496e-98bf-48e6bf7d4dac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":384,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:09:14
21781	9d673ef7-e22d-40a2-9a0e-06e8253e1b06	9d673ef7-e88e-444d-ab68-6099118d2294	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":253,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:00:36
18699	9d6699b1-881c-4ebc-a2b1-60cbe3059270	9d6699b1-a6fc-436e-af58-0316c3120561	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 08:18:27
18700	9d6699b1-a554-4d9e-a44e-53176df39d6a	9d6699b1-a6fc-436e-af58-0316c3120561	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 08:18:27
15154	9d5ecf15-e95d-4db8-9423-b2761ae6e816	9d5ecf16-3e96-4957-8180-061b09e615b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-30 11:21:08
15155	9d5ecf16-39ea-4a35-b717-a3271b2efc0e	9d5ecf16-3e96-4957-8180-061b09e615b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-30 11:21:08
15156	9d5ecf16-3bb8-4b56-8917-9ac0e09e7f20	9d5ecf16-3e96-4957-8180-061b09e615b2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":526,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:21:08
18701	9d6699b1-a5e9-4a02-ba3f-3b7b75b313e7	9d6699b1-a6fc-436e-af58-0316c3120561	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:18:27
22481	9d674f58-4065-4f93-ba18-c4a1d4c8c4d2	9d674f58-a1dc-4271-bdc3-a3e411cc7d53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 16:46:23
22482	9d674f58-8d66-4ab0-91d3-e0976251dfff	9d674f58-a1dc-4271-bdc3-a3e411cc7d53	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 68\\n                        ","time":"174.85","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"7d9994d55cb8dde82ff4185920c79043","hostname":"EderCortes"}	2024-11-03 16:46:23
22483	9d674f58-961b-4fb1-9860-05f67951abdb	9d674f58-a1dc-4271-bdc3-a3e411cc7d53	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '68' order by \\"item_loans\\".\\"id\\" asc","time":"5.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 16:46:23
22484	9d674f58-96d3-4e15-b64a-6207d343ac4c	9d674f58-a1dc-4271-bdc3-a3e411cc7d53	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 16:46:23
22485	9d674f58-9f94-4521-afc7-9eeccbba65a4	9d674f58-a1dc-4271-bdc3-a3e411cc7d53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 16:46:24
22486	9d674f58-a03a-4e25-87d8-40d3e6d42d13	9d674f58-a1dc-4271-bdc3-a3e411cc7d53	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/68","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":68,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":10000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"1000000","loans_pago_interes":"250000"},"items":[{"id":227,"loans_codigo":68,"itemloans_cuota":"1","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":228,"loans_codigo":68,"itemloans_cuota":"2","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":229,"loans_codigo":68,"itemloans_cuota":"3","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":230,"loans_codigo":68,"itemloans_cuota":"4","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":231,"loans_codigo":68,"itemloans_cuota":"5","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":232,"loans_codigo":68,"itemloans_cuota":"6","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":233,"loans_codigo":68,"itemloans_cuota":"7","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":234,"loans_codigo":68,"itemloans_cuota":"8","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":235,"loans_codigo":68,"itemloans_cuota":"9","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":236,"loans_codigo":68,"itemloans_cuota":"10","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":570,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:46:24
30978	9d69450b-9cb0-463b-925a-06f5e887bcdd	9d69450b-bcc5-477f-8b3b-331e51517e79	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 16:09:15
16592	9d64d3ec-1189-4392-b5a5-15c849a87d95	9d64d3ec-1688-4c36-a47d-3777ade1dfcb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":225,"memory":20,"hostname":"EderCortes"}	2024-11-02 11:09:37
18702	9d6699b1-f55f-42c4-9508-b1a0a7e25844	9d6699b2-3e0b-4fb1-bd4c-cfbf74d132eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 08:18:28
18703	9d6699b2-39a6-4f52-9a29-7e93f043cda9	9d6699b2-3e0b-4fb1-bd4c-cfbf74d132eb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"156.43","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c37ce191b53d9d62ae3ae483cb5ffa40","hostname":"EderCortes"}	2024-11-03 08:18:28
18704	9d6699b2-3cc4-49cc-84b3-d8bcaaba4e6e	9d6699b2-3e0b-4fb1-bd4c-cfbf74d132eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 08:18:28
18705	9d6699b2-3d1c-4247-9378-ab7313028192	9d6699b2-3e0b-4fb1-bd4c-cfbf74d132eb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","frecuencia_pago":"-1","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"6","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"-25","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"6","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"-25","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"-1","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"13","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"13","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"6","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"-3","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"5","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"-25","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"-25","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"-25","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":346,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:18:28
21782	9d673ef8-6cdc-4c90-88d5-92ded2d4653a	9d673ef8-7025-4dcd-91df-78d11376e9bc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":156,"memory":20,"hostname":"EderCortes"}	2024-11-03 16:00:36
22487	9d674f59-8817-4d0d-8246-a357884a1e97	9d674f5a-08f1-402d-9a73-6cbfe30f3480	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 16:46:24
22488	9d674f59-f9fd-415a-a1c2-5f4cd0546371	9d674f5a-08f1-402d-9a73-6cbfe30f3480	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"110.49","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:46:24
22489	9d674f59-faab-4b79-b586-b0f65cfd2471	9d674f5a-08f1-402d-9a73-6cbfe30f3480	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:46:24
22490	9d674f5a-0591-49f0-ab98-4fc6f2f05c04	9d674f5a-08f1-402d-9a73-6cbfe30f3480	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 16:46:24
22491	9d674f5a-063f-4c52-bb79-ec9b8376315a	9d674f5a-08f1-402d-9a73-6cbfe30f3480	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":895,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:46:24
22492	9d674f5a-f520-4918-a3cf-29355ba1b4b7	9d674f5b-2454-4453-92f3-296e3e255b04	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 16:46:25
22493	9d674f5b-1ad3-415b-8268-906c141fd973	9d674f5b-2454-4453-92f3-296e3e255b04	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"60.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:46:25
22494	9d674f5b-1b59-43b4-b434-de9d644e99c7	9d674f5b-2454-4453-92f3-296e3e255b04	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:46:25
12524	9d5cea7a-6ba9-4fc4-98c6-3bfe1d74eafb	9d5cea7a-89f6-47dc-b879-d3dcb0bafb62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 12:46:04
12525	9d5cea7a-884d-4c21-bb69-9248bddc4fd2	9d5cea7a-89f6-47dc-b879-d3dcb0bafb62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 12:46:04
12526	9d5cea7a-88d8-47ed-96a0-a970e803a2c3	9d5cea7a-89f6-47dc-b879-d3dcb0bafb62	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":228,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:46:04
21783	9d673ef8-d775-4699-b2ed-fcd24a8d22d5	9d673ef8-dae0-451b-bbd9-915cc4492887	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":184,"memory":20,"hostname":"EderCortes"}	2024-11-03 16:00:36
22495	9d674f5b-2233-47a7-9d75-b65444cbd5f6	9d674f5b-2454-4453-92f3-296e3e255b04	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 16:46:25
22496	9d674f5b-22c5-49cc-9ed8-14856800cbc4	9d674f5b-2454-4453-92f3-296e3e255b04	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":416,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:46:25
30979	9d69450b-b34c-4120-95a5-32965105907e	9d69450b-bcc5-477f-8b3b-331e51517e79	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"44.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 16:09:15
30980	9d69450b-b752-411b-a1d4-b2ec3c17369d	9d69450b-bcc5-477f-8b3b-331e51517e79	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 16:09:15
30981	9d69450b-b790-48c0-bfee-b2600776b1ca	9d69450b-bcc5-477f-8b3b-331e51517e79	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 16:09:15
30982	9d69450b-bb8e-421a-b925-f2d7a4935758	9d69450b-bcc5-477f-8b3b-331e51517e79	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 16:09:15
12527	9d5cea7a-d2d5-4056-a77c-680834757c7a	9d5cea7a-efc8-4ee5-83f9-fa35765e2e0e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 12:46:04
12528	9d5cea7a-ea9c-4158-8074-db44a96be34c	9d5cea7a-efc8-4ee5-83f9-fa35765e2e0e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":180,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 12:46:04
12529	9d5cea7a-eb00-4d1e-a248-ecc226e4515c	9d5cea7a-efc8-4ee5-83f9-fa35765e2e0e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 12:46:04
12530	9d5cea7a-eeb2-4307-a9e0-449ebcf5b9a2	9d5cea7a-efc8-4ee5-83f9-fa35765e2e0e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 12:46:04
12531	9d5cea7a-eefb-40d8-a196-82aedea3e91e	9d5cea7a-efc8-4ee5-83f9-fa35765e2e0e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":222,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:46:04
16593	9d64d3ec-e4cf-48f6-a17d-82d19fa6df42	9d64d3ed-3841-4549-b2c6-f276fb10249c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 11:09:38
16594	9d64d3ed-2c84-40ac-b74e-8d1ac6221118	9d64d3ed-3841-4549-b2c6-f276fb10249c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 188 limit 1","time":"4.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":325,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-02 11:09:38
16595	9d64d3ed-2d0c-4f8c-8a39-7ccbf7ad5b58	9d64d3ed-3841-4549-b2c6-f276fb10249c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-02 11:09:38
16596	9d64d3ed-31d2-44e0-b1f4-28c179e787b7	9d64d3ed-3841-4549-b2c6-f276fb10249c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '02-11-2024', \\"itemloans_interes_canelado\\" = '50000', \\"itemloans_cuota_cancelada\\" = '100000', \\"updated_at\\" = '2024-11-02 11:09:38' where \\"id\\" = 188","time":"8.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":348,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-02 11:09:38
16597	9d64d3ed-327d-4c28-bddb-99600a14599a	9d64d3ed-3841-4549-b2c6-f276fb10249c	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:188","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-02 11:09:38","item_loans_cuando_pago":"02-11-2024","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},"hostname":"EderCortes"}	2024-11-02 11:09:38
16598	9d64d3ed-363a-4496-9917-27a2ea676c4c	9d64d3ed-3841-4549-b2c6-f276fb10249c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 11:09:38
16599	9d64d3ed-36a3-4fb4-8caa-a13994212c2f	9d64d3ed-3841-4549-b2c6-f276fb10249c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"157","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000","id":188,"loans_codigo":62,"item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":421,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:09:38
18706	9d6699b3-c306-4a8f-a698-b2228463fd9f	9d6699b4-0de0-4eee-a40e-27e4b2de5b61	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 08:18:29
18707	9d6699b4-0926-4b79-88c0-acd5560f5dc8	9d6699b4-0de0-4eee-a40e-27e4b2de5b61	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"152.76","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 08:18:29
18708	9d6699b4-096e-43c9-ace3-f5a9a657621b	9d6699b4-0de0-4eee-a40e-27e4b2de5b61	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 08:18:29
18709	9d6699b4-0ca3-44b2-812e-3cc5500e1263	9d6699b4-0de0-4eee-a40e-27e4b2de5b61	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 08:18:29
21784	9d673ef9-3f44-4d78-bc39-4309f456883c	9d673ef9-43ff-4077-8a95-bee343639c9c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":178,"memory":20,"hostname":"EderCortes"}	2024-11-03 16:00:37
12532	9d5cea7b-2b91-4722-9750-cf8502874c9e	9d5cea7b-49c3-4a23-a54f-a79ceff00e0e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 12:46:04
12533	9d5cea7b-4428-481b-9d79-f6022b938de0	9d5cea7b-49c3-4a23-a54f-a79ceff00e0e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":180,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 12:46:04
12534	9d5cea7b-4489-40bc-90f4-548055fd215f	9d5cea7b-49c3-4a23-a54f-a79ceff00e0e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 12:46:04
12535	9d5cea7b-48a1-4ca3-8704-0f8f7529cb1c	9d5cea7b-49c3-4a23-a54f-a79ceff00e0e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 12:46:05
12536	9d5cea7b-48ff-46aa-a68d-34d0ecc64033	9d5cea7b-49c3-4a23-a54f-a79ceff00e0e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":213,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:46:05
18710	9d6699b4-0ce4-451d-8530-ae955dcc2211	9d6699b4-0de0-4eee-a40e-27e4b2de5b61	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":539,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:18:29
21785	9d673ef9-9b2e-4c47-b1f5-83c058ca10b4	9d673ef9-9e46-42ce-b600-20dd42cd7449	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":154,"memory":20,"hostname":"EderCortes"}	2024-11-03 16:00:37
15054	9d5ece8b-5b99-4db5-bb9d-a00fb1fd2e47	9d5ece8b-bb1b-4340-86a0-e3e4fe2b9712	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-30 11:19:37
15055	9d5ece8b-b7d9-444e-ae6b-7e566c20eca0	9d5ece8b-bb1b-4340-86a0-e3e4fe2b9712	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-30 11:19:37
15056	9d5ece8b-b91f-4cb3-ac9e-b885626c7a7c	9d5ece8b-bb1b-4340-86a0-e3e4fe2b9712	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":570,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:19:37
22497	9d674f6a-46cc-4080-a179-604669bffe91	9d674f6a-49d0-47f1-93d7-6226d6665d5d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":174,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:46:35
30983	9d69450b-bbe2-4092-ae62-9715fab46ac6	9d69450b-bcc5-477f-8b3b-331e51517e79	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder.cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:09:15
12537	9d5cea7d-3ec2-453e-a04c-bbc7fac4f9dc	9d5cea7d-5fb2-4517-a9ca-f06fb00a3753	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 12:46:06
12538	9d5cea7d-5aa8-4a03-90b1-9f71346dcd67	9d5cea7d-5fb2-4517-a9ca-f06fb00a3753	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 12:46:06
12539	9d5cea7d-5af8-45f3-8f5f-c07aa71485b4	9d5cea7d-5fb2-4517-a9ca-f06fb00a3753	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 12:46:06
12540	9d5cea7d-5e65-42e2-aff3-a05c30d72788	9d5cea7d-5fb2-4517-a9ca-f06fb00a3753	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 12:46:06
12541	9d5cea7d-5eb1-4e99-818c-8bd93c0f577f	9d5cea7d-5fb2-4517-a9ca-f06fb00a3753	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":327,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:46:06
15057	9d5ece8c-4d4c-4f27-bfca-66dc6b9cc725	9d5ece8c-7b5f-4c99-828f-abb97db731d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-30 11:19:37
15058	9d5ece8c-74dc-479f-bb54-3a247f5b3d2a	9d5ece8c-7b5f-4c99-828f-abb97db731d0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"57.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 11:19:37
15059	9d5ece8c-7533-420d-acd6-b950620acfea	9d5ece8c-7b5f-4c99-828f-abb97db731d0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-30 11:19:37
15060	9d5ece8c-79d7-4f1d-b8a2-a16e75edf620	9d5ece8c-7b5f-4c99-828f-abb97db731d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-30 11:19:37
15061	9d5ece8c-7a3e-4e22-b516-fd8827fcec64	9d5ece8c-7b5f-4c99-828f-abb97db731d0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":422,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:19:37
18763	9d669b81-f270-4e65-a311-381ba4253cce	9d669b81-f546-4489-9aa2-2369d143092e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00ab'Diario'\\u00bb\\nLINE 16:                 WHEN l.loans_cuando = 'D' 'Diario'\\n                                                   ^ (Connection: pgsql, SQL: select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' 'Diario'\\n                WHEN l.loans_cuando = 'S' 'Semanal'\\n                WHEN l.loans_cuando = 'Q' 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' 'Mensual'\\n                WHEN l.loans_cuando = 'T' 'Trimestral'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":909}	2024-11-03 08:23:32
18764	9d669b81-b276-452e-ad05-e9fcbbd90cf5	9d669b81-f546-4489-9aa2-2369d143092e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 08:23:31
18765	9d669b81-f3ab-4537-babe-5f918dc628dc	9d669b81-f546-4489-9aa2-2369d143092e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 08:23:32
18766	9d669b81-f438-4c4e-9d92-49230b3c0301	9d669b81-f546-4489-9aa2-2369d143092e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00ab'Diario'\\u00bb\\nLINE 16:                 WHEN l.loans_cuando = 'D' 'Diario'\\n                                                   ^ (Connection: pgsql, SQL: select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' 'Diario'\\n                WHEN l.loans_cuando = 'S' 'Semanal'\\n                WHEN l.loans_cuando = 'Q' 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' 'Mensual'\\n                WHEN l.loans_cuando = 'T' 'Trimestral'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":329,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:23:32
21786	9d673efa-16d7-4708-9d21-fb189d26367e	9d673efa-19eb-4ee1-adf1-155a6f8376ab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":131,"memory":20,"hostname":"EderCortes"}	2024-11-03 16:00:37
22498	9d674f6a-9a11-4397-b964-d5d2d958cc2c	9d674f6a-b4b7-4f6e-b49d-e6ae82dcbdf7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 16:46:35
22499	9d674f6a-afd6-47de-9a08-dd082061435d	9d674f6a-b4b7-4f6e-b49d-e6ae82dcbdf7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 68 limit 1","time":"37.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":490,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 16:46:35
22500	9d674f6a-b02a-4406-b7aa-653296c3493f	9d674f6a-b4b7-4f6e-b49d-e6ae82dcbdf7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 16:46:35
22501	9d674f6a-b383-49a7-88c8-f92e31c0111b	9d674f6a-b4b7-4f6e-b49d-e6ae82dcbdf7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 16:46:35
12542	9d5ceaa1-c9a3-4bc3-998e-234d786ca13c	9d5ceaa1-cc6c-4ced-8474-d75210107db0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":132,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:46:30
15062	9d5ece8c-e0d8-4d0e-80eb-b8b499cfe112	9d5ece8d-27eb-41b6-915a-7cb645644cbf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-30 11:19:38
15063	9d5ece8d-2321-4323-b748-b6f1e7f73925	9d5ece8d-27eb-41b6-915a-7cb645644cbf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"143.72","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 11:19:38
15064	9d5ece8d-236b-41f9-b17b-100c808d81aa	9d5ece8d-27eb-41b6-915a-7cb645644cbf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-30 11:19:38
15065	9d5ece8d-26ba-4e6b-a90c-075adfa040ff	9d5ece8d-27eb-41b6-915a-7cb645644cbf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-30 11:19:38
15066	9d5ece8d-270e-465c-8ab9-9b2bb9c020a9	9d5ece8d-27eb-41b6-915a-7cb645644cbf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":426,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:19:38
21787	9d673efa-6fc6-459f-a524-ecc585f0aeea	9d673efa-9059-4225-a451-1bcc38f99e34	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 16:00:37
21788	9d673efa-8a81-40e9-90c6-a9a0e911bb61	9d673efa-9059-4225-a451-1bcc38f99e34	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"40.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 16:00:37
21789	9d673efa-8ebf-4f70-a1e1-a47f1d7beed0	9d673efa-9059-4225-a451-1bcc38f99e34	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 16:00:38
21790	9d673efa-8f17-46ac-999e-c5173a07cf14	9d673efa-9059-4225-a451-1bcc38f99e34	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:00:38
22502	9d674f6a-b3c9-4fd0-b072-c8c786cd8425	9d674f6a-b4b7-4f6e-b49d-e6ae82dcbdf7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"39","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"200000000","idLoans":68},"session":[],"response_status":200,"response":{"message":"El valor a abonar supera el valor de la deuda que es actalmente de 11250000"},"duration":206,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:46:35
12543	9d5ceaa2-155b-461f-9892-5755fa1b1b18	9d5ceaa2-1855-42d7-a7ce-38dd47cf9714	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":132,"memory":20,"hostname":"EderCortes"}	2024-10-29 12:46:30
21791	9d673efa-e63b-488d-9bf7-9f233eb5f2af	9d673efb-0477-4af8-844d-319b2f6ff269	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 16:00:38
21792	9d673efb-0010-4bcb-8bbb-94b2fa7d8826	9d673efb-0477-4af8-844d-319b2f6ff269	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"48.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 16:00:38
21793	9d673efb-0328-4b0f-af5c-7278589acad1	9d673efb-0477-4af8-844d-319b2f6ff269	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 16:00:38
21794	9d673efb-036f-4cfc-aa73-efebe041f250	9d673efb-0477-4af8-844d-319b2f6ff269	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":282,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:00:38
12544	9d5ceaa2-636b-4b9b-809f-0a6282c5d3cc	9d5ceaa2-7d6b-4971-bb96-c0911a80f307	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 12:46:30
12545	9d5ceaa2-797d-4140-a87a-467efc6ce766	9d5ceaa2-7d6b-4971-bb96-c0911a80f307	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"41.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:46:30
12546	9d5ceaa2-7c45-4b92-9bae-9df5c9bdcc11	9d5ceaa2-7d6b-4971-bb96-c0911a80f307	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 12:46:30
12547	9d5ceaa2-7c8b-457c-baa1-7c2be068b55d	9d5ceaa2-7d6b-4971-bb96-c0911a80f307	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":207,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:46:30
3973	9d511b28-da66-45e3-96d1-396b5b78bc1d	9d511b28-dd65-4842-a554-c110426b96bf	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":221}	2024-10-23 15:52:15
12548	9d5ceaa2-b99c-4e6b-b51d-7a86caf60e52	9d5ceaa2-fde0-4f0b-b0d7-245ed3135fdf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 12:46:30
12549	9d5ceaa2-f9a3-4617-a609-22d926d233cb	9d5ceaa2-fde0-4f0b-b0d7-245ed3135fdf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"145.12","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":75,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 12:46:31
12550	9d5ceaa2-fcbc-498d-aed0-97b3dbb66061	9d5ceaa2-fde0-4f0b-b0d7-245ed3135fdf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 12:46:31
12551	9d5ceaa2-fcfc-40bc-ac5b-6abbba5f42bf	9d5ceaa2-fde0-4f0b-b0d7-245ed3135fdf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":320,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:46:31
21795	9d673efb-51dc-476c-b139-051525069ea6	9d673efb-558a-4fca-a2c3-ddedded47592	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":177,"memory":20,"hostname":"EderCortes"}	2024-11-03 16:00:38
22624	9d67f73c-e98a-42b7-9938-cf964a4482e1	9d67f73d-07a4-48b9-a284-b0e8e18080cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 00:35:51
22625	9d67f73d-0625-4fa0-96dd-7a8bba5e05a4	9d67f73d-07a4-48b9-a284-b0e8e18080cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 00:35:51
22626	9d67f73d-06b9-40ea-a7cb-52a0ef76e3bf	9d67f73d-07a4-48b9-a284-b0e8e18080cd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:35:51
21796	9d673efb-de96-4377-9228-05871e8fb203	9d673efb-f9bd-4464-8b93-ed4f88f22236	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 16:00:38
21797	9d673efb-f4b6-4acc-bb8f-6feded965759	9d673efb-f9bd-4464-8b93-ed4f88f22236	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"40.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 16:00:38
21798	9d673efb-f85e-4e15-a1e3-f33979ebb1ec	9d673efb-f9bd-4464-8b93-ed4f88f22236	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 16:00:38
21799	9d673efb-f8a8-4b29-8097-8b7b83657478	9d673efb-f9bd-4464-8b93-ed4f88f22236	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:00:38
22627	9d67f73d-52fe-4e2c-b8da-135d34b176c7	9d67f73d-9e53-48c5-ac68-e5938d53d51d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 00:35:51
22628	9d67f73d-9801-4d95-90fe-acd7c9cc3d1a	9d67f73d-9e53-48c5-ac68-e5938d53d51d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"155.44","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 00:35:52
22629	9d67f73d-9861-44d8-950d-7644494c2977	9d67f73d-9e53-48c5-ac68-e5938d53d51d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 00:35:52
22630	9d67f73d-9c94-45d0-95a0-27b34ad21859	9d67f73d-9e53-48c5-ac68-e5938d53d51d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 00:35:52
22631	9d67f73d-9d1a-44b0-a1f1-1d17466324f2	9d67f73d-9e53-48c5-ac68-e5938d53d51d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":342,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:35:52
21800	9d673efc-3956-4840-81aa-a2430c35fca4	9d673efc-538f-4eaa-8027-c47e0b61bc95	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 16:00:39
16705	9d64d616-ff09-4e8a-bdb1-43ac809e6f32	9d64d617-4b99-40c4-9f7a-c6eb08eeb246	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 11:15:41
16706	9d64d617-49c0-4598-a6c8-d9748eb36ce4	9d64d617-4b99-40c4-9f7a-c6eb08eeb246	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 11:15:41
16707	9d64d617-4a6f-48f2-9cfc-1e854c2afb86	9d64d617-4b99-40c4-9f7a-c6eb08eeb246	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":361,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:15:41
21801	9d673efc-4f74-4033-868a-51a34c495a3c	9d673efc-538f-4eaa-8027-c47e0b61bc95	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAr%' or \\"users\\".\\"user_document\\"::text like '%MAr%') order by \\"users\\".\\"user_document\\" asc","time":"39.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 16:00:39
21802	9d673efc-5245-4ceb-90db-2eb47b2787e8	9d673efc-538f-4eaa-8027-c47e0b61bc95	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 16:00:39
21803	9d673efc-5286-476e-84db-ed03f613c432	9d673efc-538f-4eaa-8027-c47e0b61bc95	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAr"},"session":[],"response_status":200,"response":{"data":[]},"duration":221,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:00:39
22632	9d67f73d-ea5c-4c6b-965d-f348255129cc	9d67f73e-0b2e-4a10-943f-6e2c9811ee8e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 00:35:52
22633	9d67f73e-04fc-4e02-b473-9b8c7bf7ff5a	9d67f73e-0b2e-4a10-943f-6e2c9811ee8e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 00:35:52
22634	9d67f73e-055a-4e67-976e-d9a6a2105403	9d67f73e-0b2e-4a10-943f-6e2c9811ee8e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 00:35:52
22635	9d67f73e-09da-4f52-8679-15bd48cfbb81	9d67f73e-0b2e-4a10-943f-6e2c9811ee8e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 00:35:52
22636	9d67f73e-0a38-42bd-a197-72e9366e1d75	9d67f73e-0b2e-4a10-943f-6e2c9811ee8e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":265,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:35:52
16708	9d64d617-c96a-4651-9e50-4c642909b2fe	9d64d617-f851-4aa6-8781-3575d6eb2a5d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 11:15:41
16709	9d64d617-ecd5-4439-918f-5be9d3f14ad5	9d64d617-f851-4aa6-8781-3575d6eb2a5d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"61.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 11:15:41
16710	9d64d617-f193-4d80-8d3d-ca9b07c9603a	9d64d617-f851-4aa6-8781-3575d6eb2a5d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 11:15:41
16711	9d64d617-f1d8-4de1-bedf-239012317dd2	9d64d617-f851-4aa6-8781-3575d6eb2a5d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 11:15:41
16712	9d64d617-f6e3-4cf7-86fb-6a6d08acec97	9d64d617-f851-4aa6-8781-3575d6eb2a5d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 11:15:41
16713	9d64d617-f74e-4077-af7d-67bd99cc267b	9d64d617-f851-4aa6-8781-3575d6eb2a5d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":403,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:15:41
21804	9d673efc-9109-4d74-a17d-a9c77c91e89e	9d673efc-daf2-4b74-9768-1a027841d620	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 16:00:39
18828	9d669c6f-a869-49a1-8432-91122e94a117	9d669c6f-c6b8-487c-9d87-1f0bd0f74a76	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 08:26:07
18829	9d669c6f-c516-4d93-b00a-e6ca5a553d46	9d669c6f-c6b8-487c-9d87-1f0bd0f74a76	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 08:26:07
18830	9d669c6f-c5c5-4f2f-8719-a9cb1e5e1bb6	9d669c6f-c6b8-487c-9d87-1f0bd0f74a76	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:26:07
21805	9d673efc-d563-4bb3-bd7f-4dfbd902e8d6	9d673efc-daf2-4b74-9768-1a027841d620	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAri%' or \\"users\\".\\"user_document\\"::text like '%MAri%') order by \\"users\\".\\"user_document\\" asc","time":"158.02","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 16:00:39
21806	9d673efc-d9b9-4bd7-8134-8cb211e6c2f9	9d673efc-daf2-4b74-9768-1a027841d620	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 16:00:39
21807	9d673efc-d9fd-4867-95b2-a5df8ad36ea4	9d673efc-daf2-4b74-9768-1a027841d620	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAri"},"session":[],"response_status":200,"response":{"data":[]},"duration":337,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:00:39
16714	9d64d619-46f1-4848-b449-8e12d3f73332	9d64d619-7995-42d8-8cd8-fbd3178c1f41	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 11:15:42
16715	9d64d619-7007-4763-9294-3eb610520114	9d64d619-7995-42d8-8cd8-fbd3178c1f41	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"66.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 11:15:42
16716	9d64d619-70a1-4f71-aeb6-7f4057ae66ab	9d64d619-7995-42d8-8cd8-fbd3178c1f41	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 11:15:42
16717	9d64d619-7769-4964-8dba-2358aa33db49	9d64d619-7995-42d8-8cd8-fbd3178c1f41	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 11:15:42
16718	9d64d619-77ee-48f1-8ae6-0e7fecc4c072	9d64d619-7995-42d8-8cd8-fbd3178c1f41	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":480,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:15:42
18831	9d669c70-1381-49c2-bd90-43612bde75f9	9d669c70-2fa4-4dea-bfb3-6692b6581b87	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 08:26:08
18832	9d669c70-2b78-4753-8a72-9971c0422572	9d669c70-2fa4-4dea-bfb3-6692b6581b87	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"42.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 08:26:08
18833	9d669c70-2e73-4cd1-b963-b1e5295f64ef	9d669c70-2fa4-4dea-bfb3-6692b6581b87	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 08:26:08
18834	9d669c70-2ec4-4f11-9dd6-93920d4a7d5d	9d669c70-2fa4-4dea-bfb3-6692b6581b87	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:26:08
21808	9d673efd-2134-42a5-a503-bbc2bb6be1a1	9d673efd-6588-4b87-a434-030202f5cb15	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 16:00:39
21809	9d673efd-6158-44ff-9396-9e8c1573cf87	9d673efd-6588-4b87-a434-030202f5cb15	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAria%' or \\"users\\".\\"user_document\\"::text like '%MAria%') order by \\"users\\".\\"user_document\\" asc","time":"147.27","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 16:00:39
21810	9d673efd-646a-4688-b527-622585b33cea	9d673efd-6588-4b87-a434-030202f5cb15	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 16:00:39
21811	9d673efd-64aa-43bb-a5e0-78772f03a76f	9d673efd-6588-4b87-a434-030202f5cb15	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAria"},"session":[],"response_status":200,"response":{"data":[]},"duration":337,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:00:39
18835	9d669c72-3d3e-450b-8fc1-dccf7880881e	9d669c72-6469-4dd7-ab8a-527cb68638bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 08:26:09
18836	9d669c72-5f32-419c-9e61-4e3b2e006eb4	9d669c72-6469-4dd7-ab8a-527cb68638bd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"51.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 08:26:09
18837	9d669c72-5f90-4553-8ddf-570aeca10712	9d669c72-6469-4dd7-ab8a-527cb68638bd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 08:26:09
18838	9d669c72-630f-483e-ac2f-36323e0fecfe	9d669c72-6469-4dd7-ab8a-527cb68638bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 08:26:09
18839	9d669c72-635c-4268-81b4-6ddee8418d4b	9d669c72-6469-4dd7-ab8a-527cb68638bd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":460,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:26:09
21812	9d673efd-a9d7-4740-8b22-b3c02a70887a	9d673efd-c5d6-48b0-a031-a697693b236e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 16:00:40
21813	9d673efd-c1c5-4e5c-b526-beaffbd0fefd	9d673efd-c5d6-48b0-a031-a697693b236e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAria%' or \\"users\\".\\"user_document\\"::text like '%MAria%') order by \\"users\\".\\"user_document\\" asc","time":"40.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 16:00:40
21814	9d673efd-c4a6-42b1-afc6-50a1b6f2cf4a	9d673efd-c5d6-48b0-a031-a697693b236e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 16:00:40
21815	9d673efd-c4e8-4867-96f3-cc36adccb9a1	9d673efd-c5d6-48b0-a031-a697693b236e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"28","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAria"},"session":[],"response_status":200,"response":{"data":[]},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:00:40
21816	9d673efe-029a-4410-b7bd-cf86a053e5be	9d673efe-0577-4687-b62c-072b736d18f8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":143,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:00:40
15326	9d5ed0cb-c2a2-42be-afd2-a7aef519349e	9d5ed0cb-e157-4437-8988-7795714fa791	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 11:25:55
15327	9d5ed0cb-dfd2-4f84-a83f-af156447c713	9d5ed0cb-e157-4437-8988-7795714fa791	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-30 11:25:55
15328	9d5ed0cb-e069-4430-86b8-ffbf0df37b07	9d5ed0cb-e157-4437-8988-7795714fa791	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:25:55
21817	9d673efe-532c-463b-895b-e31aa52d79f0	9d673efe-563c-44c8-a749-6a751bac49ce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":137,"memory":20,"hostname":"EderCortes"}	2024-11-03 16:00:40
40605	9d6cc5dc-f9c9-439e-abca-fb6a1edf5685	9d6cc5dc-fca1-4484-9b85-e6ae99501720	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1832}	2024-11-06 09:56:56
7033	9d52da97-1921-471a-87cd-9c841e22eea2	9d52da97-2075-43fd-9e0b-8543c1a61276	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":356}	2024-10-24 12:43:22
21818	9d673efe-cb1e-483f-a67d-a0add496979e	9d673efe-cdf3-4a80-aabc-c8937c7b017f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":130,"memory":20,"hostname":"EderCortes"}	2024-11-03 16:00:40
40367	9d6cc2a5-cdd3-4df5-894a-4bee27205f3a	9d6cc2a5-d27e-4c56-bc07-617ed6f9c2a8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1804}	2024-11-06 09:47:56
42689	9d6cdff1-d0fc-4829-8ae3-db668026a02c	9d6cdff1-d5e9-4a69-ad67-d8df4c43a4de	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1965}	2024-11-06 11:09:51
21819	9d673eff-1adc-47e8-b56e-7f86ef04074a	9d673eff-6459-458d-ba52-4ca0d4c0b57f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 16:00:40
21820	9d673eff-5f92-48fc-a93b-7e16afc83d22	9d673eff-6459-458d-ba52-4ca0d4c0b57f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mria%' or \\"users\\".\\"user_document\\"::text like '%Mria%') order by \\"users\\".\\"user_document\\" asc","time":"160.55","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 16:00:41
21821	9d673eff-6321-4201-9fdc-b6ac369b8ac9	9d673eff-6459-458d-ba52-4ca0d4c0b57f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 16:00:41
21822	9d673eff-6363-4367-beed-4f099ff617b5	9d673eff-6459-458d-ba52-4ca0d4c0b57f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mria"},"session":[],"response_status":200,"response":{"data":[]},"duration":331,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:00:41
21823	9d673eff-a437-4cbc-a42a-e388701448b3	9d673eff-bef0-41e1-9cfe-1445432ab69d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 16:00:41
21824	9d673eff-baaf-42a0-b833-aaad9d66d234	9d673eff-bef0-41e1-9cfe-1445432ab69d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"41.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 16:00:41
21825	9d673eff-bd8c-4182-b978-a2b227edd5f4	9d673eff-bef0-41e1-9cfe-1445432ab69d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 16:00:41
21826	9d673eff-bde3-442e-9508-15bc388b9375	9d673eff-bef0-41e1-9cfe-1445432ab69d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"28","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":218,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:00:41
21827	9d673f00-0634-45f5-bd25-afb3333a0790	9d673f00-4b31-4d9e-b483-7fce16210b7d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 16:00:41
21828	9d673f00-4711-49ee-853f-654082c17689	9d673f00-4b31-4d9e-b483-7fce16210b7d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"150.47","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 16:00:41
21829	9d673f00-4a10-4786-bc45-205879d062b6	9d673f00-4b31-4d9e-b483-7fce16210b7d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-03 16:00:41
21830	9d673f00-4a52-4d3e-a59f-a3f0e65a7882	9d673f00-4b31-4d9e-b483-7fce16210b7d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"29","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:00:41
31199	9d6946f7-2b06-4e9c-ba09-8f70413157d8	9d6946f7-820c-4d33-8ea4-f85547730194	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 16:14:37
31200	9d6946f7-7cf8-4a35-acc4-41a437f837c7	9d6946f7-820c-4d33-8ea4-f85547730194	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:14:37
31201	9d6946f7-809e-4940-b7b8-cd61a8c832a3	9d6946f7-820c-4d33-8ea4-f85547730194	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":518,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:14:37
31372	9d694b08-299e-4060-843d-204c32534a0e	9d694b08-5867-433e-a034-bb8c8eeb093c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 16:25:59
31373	9d694b08-567b-4b45-8a4a-67d3cc22198d	9d694b08-5867-433e-a034-bb8c8eeb093c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:25:59
31374	9d694b08-5746-4aea-8516-2f146439bdad	9d694b08-5867-433e-a034-bb8c8eeb093c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:25:59
21831	9d673f00-8829-4c50-8a5c-e34ca7b0f840	9d673f00-8ae1-45a6-b973-61dc2ca41434	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":132,"memory":20,"hostname":"EderCortes"}	2024-11-03 16:00:41
31202	9d6946f7-f0eb-4f8f-84ed-3e14de84e683	9d6946f8-3f40-482a-beed-07a340e6df18	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:14:37
31203	9d6946f8-3848-4552-a9f3-7c11ea903ee3	9d6946f8-3f40-482a-beed-07a340e6df18	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"156.35","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:14:37
31204	9d6946f8-38a3-4b37-b1f4-180afae4a6eb	9d6946f8-3f40-482a-beed-07a340e6df18	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 16:14:37
31205	9d6946f8-3de3-4596-a4c3-3b892bcee8c5	9d6946f8-3f40-482a-beed-07a340e6df18	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:14:38
31206	9d6946f8-3e4b-40cb-8b38-65e47570e7c9	9d6946f8-3f40-482a-beed-07a340e6df18	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":430,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:14:38
31375	9d694b08-dea5-4e1c-9e1e-496cf3eeff5b	9d694b09-09eb-4744-9f96-0a6c6739cac7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:25:59
31376	9d694b08-ff94-4ac1-817d-6bfb15bdcf6d	9d694b09-09eb-4744-9f96-0a6c6739cac7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"62.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 16:26:00
31377	9d694b09-037f-48e2-8e34-05d38c8a1430	9d694b09-09eb-4744-9f96-0a6c6739cac7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" inner join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '92' order by \\"item_loans\\".\\"id\\" asc","time":"4.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":304,"hash":"ac513f13416666eb3a5127ebc04741a7","hostname":"EderCortes"}	2024-11-04 16:26:00
31378	9d694b09-083d-493c-971e-0a32b59a1684	9d694b09-09eb-4744-9f96-0a6c6739cac7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:26:00
31379	9d694b09-08db-47cc-a666-468e47aa7665	9d694b09-09eb-4744-9f96-0a6c6739cac7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":92,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":15,"loans_valor_prestado":8000009,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"533333.93333333","loans_pago_interes":"133333.48333333","user_alias":"eder.cortes"},"items":[{"id":379,"loans_codigo":92,"itemloans_cuota":"1","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:13:07","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":380,"loans_codigo":92,"itemloans_cuota":"2","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":381,"loans_codigo":92,"itemloans_cuota":"3","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":382,"loans_codigo":92,"itemloans_cuota":"4","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":383,"loans_codigo":92,"itemloans_cuota":"5","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":384,"loans_codigo":92,"itemloans_cuota":"6","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":385,"loans_codigo":92,"itemloans_cuota":"7","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":386,"loans_codigo":92,"itemloans_cuota":"8","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":387,"loans_codigo":92,"itemloans_cuota":"9","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-15 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":388,"loans_codigo":92,"itemloans_cuota":"10","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":389,"loans_codigo":92,"itemloans_cuota":"11","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-31 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":390,"loans_codigo":92,"itemloans_cuota":"12","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":391,"loans_codigo":92,"itemloans_cuota":"13","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-16 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":392,"loans_codigo":92,"itemloans_cuota":"14","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":393,"loans_codigo":92,"itemloans_cuota":"15","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:26:00
21832	9d673f01-3f1b-4e94-9be2-75ab959b196e	9d673f01-8480-4053-8e08-2fd9d23921a0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-03 16:00:42
21833	9d673f01-808e-461d-8629-5a5b78d50299	9d673f01-8480-4053-8e08-2fd9d23921a0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"152.54","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 16:00:42
11958	9d5cd8dc-f81e-4fd5-b4e9-6def2368853b	9d5cd8dd-5e61-4547-94e6-0a67064f86b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 11:56:49
11959	9d5cd8dd-5b66-454c-aed0-262e7634b35d	9d5cd8dd-5e61-4547-94e6-0a67064f86b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 11:56:49
11960	9d5cd8dd-5cc7-4162-aedf-62bd2f381e0e	9d5cd8dd-5e61-4547-94e6-0a67064f86b9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":558,"memory":22,"hostname":"EderCortes"}	2024-10-29 11:56:49
21834	9d673f01-8358-4329-90ec-953dfe3d6e9a	9d673f01-8480-4053-8e08-2fd9d23921a0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-03 16:00:42
21835	9d673f01-8398-49b5-80d6-5de7ce1e2dfc	9d673f01-8480-4053-8e08-2fd9d23921a0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"28","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":334,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:00:42
31207	9d6946f8-93ce-410b-bdc0-2370261793b0	9d6946f8-b72b-426a-9792-a4f046241544	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:14:38
31208	9d6946f8-b067-4036-b59b-79d330b40512	9d6946f8-b72b-426a-9792-a4f046241544	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:14:38
31209	9d6946f8-b0c8-4eea-bdca-110df0ea9c3b	9d6946f8-b72b-426a-9792-a4f046241544	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 16:14:38
31210	9d6946f8-b563-4a23-b460-f96b7ebb650f	9d6946f8-b72b-426a-9792-a4f046241544	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:14:38
31211	9d6946f8-b5d1-4e38-9200-c94ce1e0df26	9d6946f8-b72b-426a-9792-a4f046241544	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":285,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:14:38
31380	9d694b0b-8eb1-45d6-bf15-6c896b592db8	9d694b0b-c134-4ea0-b46d-d6ab91b77c2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:26:01
31381	9d694b0b-b625-4ed1-ab80-dff2cf802e1c	9d694b0b-c134-4ea0-b46d-d6ab91b77c2b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"72.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:26:01
31382	9d694b0b-b6b4-4896-90cc-405e2d179034	9d694b0b-c134-4ea0-b46d-d6ab91b77c2b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:26:01
31383	9d694b0b-bedf-4bea-a75a-04cfc3aa7649	9d694b0b-c134-4ea0-b46d-d6ab91b77c2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:26:01
18927	9d66cbae-8fda-4d64-aede-97cce903c274	9d66cbae-ae26-40b0-bd6d-71a15a5cd719	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 10:38:14
18928	9d66cbae-ac65-4fff-b5f7-11db10e2f29e	9d66cbae-ae26-40b0-bd6d-71a15a5cd719	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 10:38:14
18929	9d66cbae-ad01-40d4-aecb-9cc00da6f45d	9d66cbae-ae26-40b0-bd6d-71a15a5cd719	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":293,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:38:14
21836	9d673f05-2e19-4ae0-9e80-3fa39f5acb56	9d673f05-4c33-49e0-89aa-f0934f394fbf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-03 16:00:44
21837	9d673f05-46dc-4edd-b22d-d69f30f13e0f	9d673f05-4c33-49e0-89aa-f0934f394fbf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '19' and \\"users\\".\\"deleted_at\\" is null","time":"39.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":55,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-11-03 16:00:45
21838	9d673f05-4725-402a-8605-8a3d966c9aea	9d673f05-4c33-49e0-89aa-f0934f394fbf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 16:00:45
21839	9d673f05-4ae8-4933-87ae-949adb4db130	9d673f05-4c33-49e0-89aa-f0934f394fbf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-03 16:00:45
21840	9d673f05-4b2d-4d0a-9789-1f0e44da9143	9d673f05-4c33-49e0-89aa-f0934f394fbf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/19","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:00:45
31384	9d694b0b-bf56-451e-827e-fda3470b11e0	9d694b0b-c134-4ea0-b46d-d6ab91b77c2b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":493,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:26:01
31518	9d694ca6-0d55-4e00-a84b-394011356769	9d694ca6-3541-45a0-b120-9dac5e571e03	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 16:30:30
14236	9d5d16c8-f753-4b69-8309-2952d583fb03	9d5d16c9-167e-47bf-9145-7c4f41e1402d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 14:49:57
14237	9d5d16c9-1516-4c05-a99a-91daeea68df8	9d5d16c9-167e-47bf-9145-7c4f41e1402d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 14:49:57
14238	9d5d16c9-15a6-4a5f-9912-b3e25e45ce08	9d5d16c9-167e-47bf-9145-7c4f41e1402d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:49:57
31519	9d694ca6-3335-4756-888c-214d6f1cc1f7	9d694ca6-3541-45a0-b120-9dac5e571e03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:30:30
21841	9d673f27-6732-48ab-b06c-9fde7e99df79	9d673f27-6a24-47b3-b72b-fb94088f88d6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":159,"memory":20,"hostname":"EderCortes"}	2024-11-03 16:01:07
31520	9d694ca6-3416-4e7b-bcd6-71de6c90e180	9d694ca6-3541-45a0-b120-9dac5e571e03	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:30:30
31517	9d694ca6-314e-4a85-9b24-357ce736fa8f	9d694ca6-3541-45a0-b120-9dac5e571e03	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1507}	2024-11-04 16:30:30
14239	9d5d16c9-5e3f-4cc7-bc83-1e95e4e9464a	9d5d16c9-767e-4537-9b8b-2136e553a702	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 14:49:58
14240	9d5d16c9-7239-45df-813a-97ac5e62139d	9d5d16c9-767e-4537-9b8b-2136e553a702	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"39.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-29 14:49:58
14241	9d5d16c9-7555-414c-a85a-0f74debded27	9d5d16c9-767e-4537-9b8b-2136e553a702	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 14:49:58
14242	9d5d16c9-75a1-4553-b502-8a76417ec5cc	9d5d16c9-767e-4537-9b8b-2136e553a702	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":207,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:49:58
18930	9d66cbae-f9f8-4fd1-b1d6-381a7a887b3d	9d66cbaf-1516-44ab-a3aa-413410e987c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 10:38:14
18931	9d66cbaf-10f6-45d6-b4f5-4f4c14e9f091	9d66cbaf-1516-44ab-a3aa-413410e987c4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"43.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 10:38:14
18932	9d66cbaf-13ed-4507-a0d7-a1615809bd34	9d66cbaf-1516-44ab-a3aa-413410e987c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 10:38:14
18933	9d66cbaf-143c-45b6-8370-00dd042e4da5	9d66cbaf-1516-44ab-a3aa-413410e987c4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":223,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:38:14
31521	9d694ca6-a0ad-457f-ab26-efd6ccbe326a	9d694ca6-eff2-4457-84f7-0664cc51a5a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:30:31
31522	9d694ca6-e6f6-4b3e-a77d-17c49b0c45b4	9d694ca6-eff2-4457-84f7-0664cc51a5a6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"149.64","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:30:31
31523	9d694ca6-e765-4c1b-bb61-9cb2e67ef8c7	9d694ca6-eff2-4457-84f7-0664cc51a5a6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 16:30:31
31524	9d694ca6-eea2-40af-821b-f99ff5026ecb	9d694ca6-eff2-4457-84f7-0664cc51a5a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:30:31
31525	9d694ca6-eef1-4545-820c-c69d7bd4ea89	9d694ca6-eff2-4457-84f7-0664cc51a5a6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":430,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:30:31
14243	9d5d16ca-d061-477a-a737-56e912130908	9d5d16ca-ef37-4ca1-8148-35912d743ee2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 14:49:59
14244	9d5d16ca-ea8c-441f-9189-fbc6c7bbe252	9d5d16ca-ef37-4ca1-8148-35912d743ee2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 14:49:59
14245	9d5d16ca-ead0-42a7-8253-0ae48e343a94	9d5d16ca-ef37-4ca1-8148-35912d743ee2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 14:49:59
14246	9d5d16ca-ee10-411b-b14b-865973836a23	9d5d16ca-ef37-4ca1-8148-35912d743ee2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 14:49:59
14247	9d5d16ca-ee50-4e35-ad97-97ee5bce8b31	9d5d16ca-ef37-4ca1-8148-35912d743ee2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":365,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:49:59
18934	9d66cbb0-c054-4bd1-84bd-02b46f584659	9d66cbb0-dc67-4239-a32f-05e1503beaa7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 10:38:15
18935	9d66cbb0-d797-4083-b553-1babde24133a	9d66cbb0-dc67-4239-a32f-05e1503beaa7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 10:38:15
18936	9d66cbb0-d7de-4649-a87c-b643c5b9f7ef	9d66cbb0-dc67-4239-a32f-05e1503beaa7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 10:38:15
18937	9d66cbb0-db17-4e1f-ad68-308aa2a6beba	9d66cbb0-dc67-4239-a32f-05e1503beaa7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 10:38:15
18938	9d66cbb0-db5a-41f9-9749-34951d2fabb1	9d66cbb0-dc67-4239-a32f-05e1503beaa7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:38:15
31526	9d694ca7-3f13-4ced-8bea-de6eda9b034c	9d694ca7-63d0-42f1-83fa-9dc3c4ae347f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:30:31
31527	9d694ca7-5d6a-4979-96c2-13128498964a	9d694ca7-63d0-42f1-83fa-9dc3c4ae347f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"53.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:30:31
31528	9d694ca7-5dd1-4314-ad1b-7317c7ebc4f7	9d694ca7-63d0-42f1-83fa-9dc3c4ae347f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 16:30:31
31529	9d694ca7-6255-4236-943e-71768900cb60	9d694ca7-63d0-42f1-83fa-9dc3c4ae347f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:30:31
31315	9d694a26-abb6-4796-a20f-5aef319695a1	9d694a26-d036-477d-9d9e-3f1cd07e3285	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 16:23:31
13916	9d5d13d7-383e-41a8-af9a-4bbf74acc79a	9d5d13d7-66c9-405c-b33f-2d21a97948e9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 14:41:43
13917	9d5d13d7-6420-49ec-b184-844c9236e96f	9d5d13d7-66c9-405c-b33f-2d21a97948e9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 14:41:44
13918	9d5d13d7-654c-467c-87fe-110d95ef98dd	9d5d13d7-66c9-405c-b33f-2d21a97948e9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":352,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:41:44
31316	9d694a26-ce48-4879-8331-69565008ccb1	9d694a26-d036-477d-9d9e-3f1cd07e3285	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:23:31
31317	9d694a26-cf16-4c61-9a47-5442aa93f7bb	9d694a26-d036-477d-9d9e-3f1cd07e3285	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:23:31
31530	9d694ca7-62c0-48c4-9e65-eb4e632e3efc	9d694ca7-63d0-42f1-83fa-9dc3c4ae347f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":279,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:30:31
31309	9d6949fb-9319-4cfb-bc2b-d96e95ae5fd7	9d6949fb-993c-4c5f-a05f-26ef8c2e004f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abas\\u00bb\\nLINE 1: select * from \\"item_loans\\".* as \\"u.user_alias\\" inner join \\"u...\\n                                     ^ (Connection: pgsql, SQL: select * from \\"item_loans\\".* as \\"u.user_alias\\" inner join \\"users\\" as \\"u\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"u\\".\\"id\\" where \\"loans_codigo\\" = 92 order by \\"item_loans\\".\\"id\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":305},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1490}	2024-11-04 16:23:03
13919	9d5d13d7-ba06-4072-ae0a-e4533831b49d	9d5d13d7-e545-4c05-8c9a-a115603c601d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 14:41:44
13920	9d5d13d7-da48-47c9-abf8-93400cf9d06f	9d5d13d7-e545-4c05-8c9a-a115603c601d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"51.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":194,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 14:41:44
13921	9d5d13d7-dac3-4e79-a39a-0d9432d92342	9d5d13d7-e545-4c05-8c9a-a115603c601d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 14:41:44
13922	9d5d13d7-e042-4e76-92e3-b4bf9a915199	9d5d13d7-e545-4c05-8c9a-a115603c601d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 14:41:44
13923	9d5d13d7-e3df-4b62-a27c-377657f8850d	9d5d13d7-e545-4c05-8c9a-a115603c601d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":274,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:41:44
14248	9d5d16ed-ad82-46fc-9280-cf8075f313f7	9d5d16ed-cee8-48a1-a7c6-4208a9418ab7	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 14:50:21
14249	9d5d16ed-c916-43bb-acda-7aa142ecd977	9d5d16ed-cee8-48a1-a7c6-4208a9418ab7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"43.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-29 14:50:22
14250	9d5d16ed-cd2e-476d-a7ae-f5211d355228	9d5d16ed-cee8-48a1-a7c6-4208a9418ab7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 14:50:22
14251	9d5d16ed-cd93-4ea6-a698-b1a06be2abd6	9d5d16ed-cee8-48a1-a7c6-4208a9418ab7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:50:22
18939	9d66cbde-c3c5-48dc-9cf5-9bbd6be79bcd	9d66cbdf-0ac4-45a3-9490-c2e0617a7950	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 10:38:45
18940	9d66cbdf-0242-4a6a-bf6a-dc136baa3613	9d66cbdf-0ac4-45a3-9490-c2e0617a7950	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"147.56","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-03 10:38:46
18941	9d66cbdf-05b9-4239-84e4-ff03e1d56008	9d66cbdf-0ac4-45a3-9490-c2e0617a7950	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 10:38:46
18942	9d66cbdf-05e9-4fa9-bd9f-2b7975d529b6	9d66cbdf-0ac4-45a3-9490-c2e0617a7950	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 10:38:46
18943	9d66cbdf-0970-4d6b-a966-f19c402d8dde	9d66cbdf-0ac4-45a3-9490-c2e0617a7950	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 10:38:46
13924	9d5d13d8-323b-4c06-aece-c53a277c305f	9d5d13d8-78be-4474-ace7-3752674e3953	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 14:41:44
13925	9d5d13d8-73cf-4e5d-ad0c-610fa3fcc1f7	9d5d13d8-78be-4474-ace7-3752674e3953	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"146.02","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":194,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 14:41:44
13926	9d5d13d8-741f-4603-8182-08a97896c182	9d5d13d8-78be-4474-ace7-3752674e3953	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 14:41:44
13927	9d5d13d8-7788-43e6-a087-1ab10aefb312	9d5d13d8-78be-4474-ace7-3752674e3953	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 14:41:44
13928	9d5d13d8-77cc-44b4-918d-5e0adf4572f2	9d5d13d8-78be-4474-ace7-3752674e3953	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":350,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:41:44
14252	9d5d16f0-05f9-4179-ad23-4a2c49120dd1	9d5d16f0-4b72-46e8-bb2f-95dfdbc56c2c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 14:50:23
14253	9d5d16f0-4220-436e-aa9e-1635db71033b	9d5d16f0-4b72-46e8-bb2f-95dfdbc56c2c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 55\\n                        ","time":"142.20","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"ff7240abed4441475e0acd0c74a5f6aa","hostname":"EderCortes"}	2024-10-29 14:50:23
14254	9d5d16f0-45c9-4258-b2db-32ba7a423f74	9d5d16f0-4b72-46e8-bb2f-95dfdbc56c2c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '55' order by \\"item_loans\\".\\"id\\" asc","time":"1.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 14:50:23
14255	9d5d16f0-45f9-4679-b8a4-086141fcfae5	9d5d16f0-4b72-46e8-bb2f-95dfdbc56c2c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":7,"hostname":"EderCortes"}	2024-10-29 14:50:23
14256	9d5d16f0-49f1-4e04-be6d-64ffea6caf12	9d5d16f0-4b72-46e8-bb2f-95dfdbc56c2c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 14:50:23
14257	9d5d16f0-4a4a-460f-b41d-81e3ae17dddf	9d5d16f0-4b72-46e8-bb2f-95dfdbc56c2c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/55","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":55,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":7,"loans_valor_prestado":50000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"15-11-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":150,"loans_codigo":55,"itemloans_cuota":"1","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":151,"loans_codigo":55,"itemloans_cuota":"2","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":152,"loans_codigo":55,"itemloans_cuota":"3","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":153,"loans_codigo":55,"itemloans_cuota":"4","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":154,"loans_codigo":55,"itemloans_cuota":"5","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":155,"loans_codigo":55,"itemloans_cuota":"6","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":156,"loans_codigo":55,"itemloans_cuota":"7","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":377,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:50:23
21848	9d674039-8003-47de-af6e-67afb3b2fe27	9d674039-854d-4618-8025-9fb184b070c0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":219,"memory":20,"hostname":"EderCortes"}	2024-11-03 16:04:07
13929	9d5d13d8-f633-4081-bcd9-843f7ea50234	9d5d13d9-843d-44f6-a1cf-3b02d5349483	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 14:41:45
13930	9d5d13d9-791f-4143-8a55-459db26bb757	9d5d13d9-843d-44f6-a1cf-3b02d5349483	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"243.05","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 14:41:45
13931	9d5d13d9-79a0-44e3-b205-c22365100624	9d5d13d9-843d-44f6-a1cf-3b02d5349483	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 14:41:45
13932	9d5d13d9-81b4-48d7-8612-2f6d25b0fdc4	9d5d13d9-843d-44f6-a1cf-3b02d5349483	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 14:41:45
13933	9d5d13d9-8260-487f-8dd8-cd43f3f126a4	9d5d13d9-843d-44f6-a1cf-3b02d5349483	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":670,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:41:45
14258	9d5d17ca-c8ef-45a8-8344-f59a4f73b0b7	9d5d17ca-e88d-46a4-95f2-5abf9b85e5fd	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 14:52:46
14259	9d5d17ca-e33b-40b6-a907-e2f69d097693	9d5d17ca-e88d-46a4-95f2-5abf9b85e5fd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"45.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-29 14:52:46
14260	9d5d17ca-e6fc-4a81-8ab4-5a69f11ec271	9d5d17ca-e88d-46a4-95f2-5abf9b85e5fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 14:52:46
14261	9d5d17ca-e75b-4d64-84ce-b7492b938eca	9d5d17ca-e88d-46a4-95f2-5abf9b85e5fd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":288,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:52:46
18944	9d66cbdf-09b7-48ff-907f-a60c966cf6d6	9d66cbdf-0ac4-45a3-9490-c2e0617a7950	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:34:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"}]}},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:38:46
21849	9d674039-ea1d-4477-abc9-d5a40161120d	9d67403a-1fff-41a9-bdaf-c866ce00d49c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 16:04:07
13934	9d5d13da-258e-4f79-bc85-6636382fef80	9d5d13da-5dac-4eff-9609-f819e4a5b4de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 14:41:45
13935	9d5d13da-585a-4543-9917-c8a1deb5a17e	9d5d13da-5dac-4eff-9609-f819e4a5b4de	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"63.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 14:41:45
13936	9d5d13da-58cc-498e-b5d0-e8328cb23a8e	9d5d13da-5dac-4eff-9609-f819e4a5b4de	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 14:41:45
13937	9d5d13da-5c8f-4946-ab33-f48758bcebd3	9d5d13da-5dac-4eff-9609-f819e4a5b4de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-29 14:41:45
13938	9d5d13da-5cd1-44c6-bd09-8b50310812e2	9d5d13da-5dac-4eff-9609-f819e4a5b4de	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":532,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:41:45
14262	9d5d181d-16de-4d10-b13e-b736a25893fa	9d5d181d-31a0-44b9-82c3-25a0d29ad832	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 14:53:40
14263	9d5d181d-2ca6-418f-bd2d-8c978214e66b	9d5d181d-31a0-44b9-82c3-25a0d29ad832	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"42.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-29 14:53:40
14264	9d5d181d-2fd7-40a2-b907-fb3b65ae1805	9d5d181d-31a0-44b9-82c3-25a0d29ad832	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 14:53:40
14265	9d5d181d-302a-4eb4-9e2f-e6422203f35e	9d5d181d-31a0-44b9-82c3-25a0d29ad832	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":265,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:53:40
18945	9d66cd2c-1687-4859-ac8d-6c0131abfaae	9d66cd2c-44e6-4904-ba13-7fbb7c35f2d2	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 10:42:24
18946	9d66cd2c-3e56-4af9-9879-be46dab4ec99	9d66cd2c-44e6-4904-ba13-7fbb7c35f2d2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"51.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 10:42:24
18947	9d66cd2c-3eb7-42d4-ad29-55f4455e5f7b	9d66cd2c-44e6-4904-ba13-7fbb7c35f2d2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 10:42:24
18948	9d66cd2c-42f5-4832-a03c-c1cf1af56906	9d66cd2c-44e6-4904-ba13-7fbb7c35f2d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 10:42:24
13939	9d5d13ea-f23d-4082-8a2a-c66bcd9fe1d7	9d5d13ea-f670-48df-9901-ff3ab75b83ae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":171,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:41:56
14266	9d5d1850-77de-457b-9598-42dee225ac6b	9d5d1850-ca96-4510-a18f-eae2cd7cb6a7	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 14:54:14
14267	9d5d1850-bdd2-40fd-ab49-b1dde555e70c	9d5d1850-ca96-4510-a18f-eae2cd7cb6a7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 55\\n                        ","time":"151.62","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"ff7240abed4441475e0acd0c74a5f6aa","hostname":"EderCortes"}	2024-10-29 14:54:14
14268	9d5d1850-c252-48a5-b924-bc584115069a	9d5d1850-ca96-4510-a18f-eae2cd7cb6a7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '55' order by \\"item_loans\\".\\"id\\" asc","time":"2.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 14:54:14
14269	9d5d1850-c290-4469-b338-cce421261619	9d5d1850-ca96-4510-a18f-eae2cd7cb6a7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":7,"hostname":"EderCortes"}	2024-10-29 14:54:14
14270	9d5d1850-c8cc-4d15-8659-9ac6cb81415d	9d5d1850-ca96-4510-a18f-eae2cd7cb6a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 14:54:14
14271	9d5d1850-c941-4b7c-b5a2-6997d6caf3d3	9d5d1850-ca96-4510-a18f-eae2cd7cb6a7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/55","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":55,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":7,"loans_valor_prestado":50000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"15-11-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":150,"loans_codigo":55,"itemloans_cuota":"1","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":151,"loans_codigo":55,"itemloans_cuota":"2","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":152,"loans_codigo":55,"itemloans_cuota":"3","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":153,"loans_codigo":55,"itemloans_cuota":"4","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":154,"loans_codigo":55,"itemloans_cuota":"5","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":155,"loans_codigo":55,"itemloans_cuota":"6","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":156,"loans_codigo":55,"itemloans_cuota":"7","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":394,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:54:14
18949	9d66cd2c-434a-4ff2-a1a4-5a292661f7b1	9d66cd2c-44e6-4904-ba13-7fbb7c35f2d2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":447,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:42:24
21850	9d67403a-0c03-495f-aed6-650d90d32b76	9d67403a-1fff-41a9-bdaf-c866ce00d49c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\", \\"loans_fecha_ultimo_pago\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta 2', 'De las nieve', 'ds', 'CC', '1004655468', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon2', 'Calle 7505', '10000000', 25, 10, 'Q', null, '03-11-2024', 'Pendiente', '312596295', 12, 14, 19, 14, '03-11-2024', 0, 0, '03-11-2024', '2024-11-03 16:04:07', '2024-11-03 16:04:07') returning \\"id\\"","time":"5.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":106,"hash":"627b53ca897e623c432f1126c69a0881","hostname":"EderCortes"}	2024-11-03 16:04:07
13940	9d5d13eb-5045-4e3a-be30-5f0aa5f12da5	9d5d13eb-5398-434d-8bb3-f093abb0ddc9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":161,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:41:57
18950	9d66cd2c-9757-451b-9052-10f859b33daf	9d66cd2c-dfe6-4be7-859b-f0135fea8693	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 10:42:24
18951	9d66cd2c-d6ed-4e94-a399-dfed5b0d11ba	9d66cd2c-dfe6-4be7-859b-f0135fea8693	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"150.57","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-03 10:42:24
18952	9d66cd2c-da62-4d64-9f6d-bc627b153af2	9d66cd2c-dfe6-4be7-859b-f0135fea8693	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"1.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 10:42:24
18953	9d66cd2c-da95-4ce2-911a-de16ad1a4f86	9d66cd2c-dfe6-4be7-859b-f0135fea8693	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 10:42:24
18954	9d66cd2c-de86-4ef2-80fe-be5b7e62ed6e	9d66cd2c-dfe6-4be7-859b-f0135fea8693	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 10:42:24
18955	9d66cd2c-ded9-4bec-bb89-d2258bb8cd53	9d66cd2c-dfe6-4be7-859b-f0135fea8693	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:34:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"}]}},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:42:24
21851	9d67403a-0c9f-4437-8d0d-1bac51ca736f	9d67403a-1fff-41a9-bdaf-c866ce00d49c	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:68","hostname":"EderCortes"}	2024-11-03 16:04:07
21852	9d67403a-0e8c-406f-ad94-75bd5f3e2bed	9d67403a-1fff-41a9-bdaf-c866ce00d49c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (68, 1, 1000000, 250000, 'Pendiente', 'N\\/A', '19-11-2024', 12, 0, 0, '2024-11-03 16:04:07', '2024-11-03 16:04:07')","time":"3.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 16:04:07
21853	9d67403a-0eb7-4d87-9116-e3de16d65f79	9d67403a-1fff-41a9-bdaf-c866ce00d49c	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 16:04:07
21854	9d67403a-0f37-43fe-8b72-8c5dd5722eba	9d67403a-1fff-41a9-bdaf-c866ce00d49c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (68, 2, 1000000, 250000, 'Pendiente', 'N\\/A', '05-12-2024', 12, 0, 0, '2024-11-03 16:04:07', '2024-11-03 16:04:07')","time":"0.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 16:04:07
21855	9d67403a-0f6c-4b7a-870e-5c05ef5d3dae	9d67403a-1fff-41a9-bdaf-c866ce00d49c	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 16:04:07
21856	9d67403a-0ffa-40cb-8e2f-aad442253e3e	9d67403a-1fff-41a9-bdaf-c866ce00d49c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (68, 3, 1000000, 250000, 'Pendiente', 'N\\/A', '21-12-2024', 12, 0, 0, '2024-11-03 16:04:07', '2024-11-03 16:04:07')","time":"0.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 16:04:07
13941	9d5d13eb-cd0d-4c9e-b198-64b1af168f01	9d5d13eb-d011-4acd-ab25-63dd62e1a427	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":137,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:41:57
21857	9d67403a-1022-4cbf-95b9-e09821c365e4	9d67403a-1fff-41a9-bdaf-c866ce00d49c	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 16:04:07
21858	9d67403a-10a8-4e99-876a-fea9dae22af7	9d67403a-1fff-41a9-bdaf-c866ce00d49c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (68, 4, 1000000, 250000, 'Pendiente', 'N\\/A', '06-01-2025', 12, 0, 0, '2024-11-03 16:04:07', '2024-11-03 16:04:07')","time":"0.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 16:04:07
21859	9d67403a-10e1-4339-b2a9-747ac652ace6	9d67403a-1fff-41a9-bdaf-c866ce00d49c	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 16:04:07
21860	9d67403a-1168-4869-8a93-8161fdb05c60	9d67403a-1fff-41a9-bdaf-c866ce00d49c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (68, 5, 1000000, 250000, 'Pendiente', 'N\\/A', '22-01-2025', 12, 0, 0, '2024-11-03 16:04:07', '2024-11-03 16:04:07')","time":"0.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 16:04:07
21861	9d67403a-119e-4151-ab4f-b1630af90bef	9d67403a-1fff-41a9-bdaf-c866ce00d49c	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 16:04:07
21862	9d67403a-122f-49a8-8222-c84ba7750ded	9d67403a-1fff-41a9-bdaf-c866ce00d49c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (68, 6, 1000000, 250000, 'Pendiente', 'N\\/A', '07-02-2025', 12, 0, 0, '2024-11-03 16:04:07', '2024-11-03 16:04:07')","time":"0.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 16:04:07
21863	9d67403a-125b-48c1-ac6b-d1fc3c4d4d72	9d67403a-1fff-41a9-bdaf-c866ce00d49c	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 16:04:07
21864	9d67403a-12d0-4fbb-93be-4ccf60ed61bd	9d67403a-1fff-41a9-bdaf-c866ce00d49c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (68, 7, 1000000, 250000, 'Pendiente', 'N\\/A', '23-02-2025', 12, 0, 0, '2024-11-03 16:04:07', '2024-11-03 16:04:07')","time":"0.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 16:04:07
21865	9d67403a-12fb-4cc2-9bd1-93242298561f	9d67403a-1fff-41a9-bdaf-c866ce00d49c	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 16:04:07
21866	9d67403a-1372-4cc9-8e22-89f81e9e7b62	9d67403a-1fff-41a9-bdaf-c866ce00d49c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (68, 8, 1000000, 250000, 'Pendiente', 'N\\/A', '11-03-2025', 12, 0, 0, '2024-11-03 16:04:07', '2024-11-03 16:04:07')","time":"0.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 16:04:07
21867	9d67403a-139f-4d20-9fdc-acf3ee225962	9d67403a-1fff-41a9-bdaf-c866ce00d49c	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 16:04:07
21868	9d67403a-1416-49d3-a059-25eef0e2abae	9d67403a-1fff-41a9-bdaf-c866ce00d49c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (68, 9, 1000000, 250000, 'Pendiente', 'N\\/A', '27-03-2025', 12, 0, 0, '2024-11-03 16:04:07', '2024-11-03 16:04:07')","time":"0.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 16:04:07
21869	9d67403a-1440-47fd-a649-f539f7f4f422	9d67403a-1fff-41a9-bdaf-c866ce00d49c	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 16:04:07
21870	9d67403a-14b6-42c1-a4bd-721a6122db3d	9d67403a-1fff-41a9-bdaf-c866ce00d49c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (68, 10, 1000000, 250000, 'Pendiente', 'N\\/A', '12-04-2025', 12, 0, 0, '2024-11-03 16:04:07', '2024-11-03 16:04:07')","time":"0.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 16:04:07
21871	9d67403a-14e1-4a35-8e72-586ca05b879a	9d67403a-1fff-41a9-bdaf-c866ce00d49c	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 16:04:07
21872	9d67403a-1e5e-4468-b1d5-843ef3f4eca9	9d67403a-1fff-41a9-bdaf-c866ce00d49c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 16:04:07
13942	9d5d13ec-4dc9-498e-95cc-252e1843c016	9d5d13ec-5120-4e21-9b1d-2e53fa18e7aa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":145,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:41:57
21873	9d67403a-1ec0-4b78-b8ff-fa9f0537651b	9d67403a-1fff-41a9-bdaf-c866ce00d49c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"803","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"1004655468","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_valor_prestado":"10000000","loans_intereses":25,"loans_cuotas":10,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":19,"user_recomendacion":14,"loans_inicio_pago":"Sun Nov 03 2024","created_at":null,"updated_at":null,"deleted_at":null,"loans_pago_prestado":0,"loans_pago_interes":0},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Sun Nov 03 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":68},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:04:07
13943	9d5d13ec-d463-43dc-86a2-cdbfad05c50e	9d5d13ed-187b-4597-a2c6-c1c3922adaf5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-29 14:41:58
13944	9d5d13ed-1304-4742-80ba-9bce7025a457	9d5d13ed-187b-4597-a2c6-c1c3922adaf5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"143.67","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 14:41:58
13945	9d5d13ed-16ee-4509-9a1e-a8fb0b6ac3d2	9d5d13ed-187b-4597-a2c6-c1c3922adaf5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-29 14:41:58
13946	9d5d13ed-174c-448b-8e22-a53a85350504	9d5d13ed-187b-4597-a2c6-c1c3922adaf5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":332,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:41:58
21874	9d674041-6910-4b34-8af9-828fe691bfe3	9d674041-8612-4dfc-9d33-437de89ba9ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 16:04:12
15440	9d5ed228-48f6-494d-ac79-4cd0a93b8e7a	9d5ed228-ae40-4399-8707-6a9dcddf7f62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 11:29:43
15441	9d5ed228-ab95-4466-8a8d-adc893b06cdc	9d5ed228-ae40-4399-8707-6a9dcddf7f62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-30 11:29:43
15442	9d5ed228-acda-481f-bfac-b40dea7f8da1	9d5ed228-ae40-4399-8707-6a9dcddf7f62	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":621,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:29:43
21875	9d674041-80eb-423e-a786-1a849e1723d0	9d674041-8612-4dfc-9d33-437de89ba9ce	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:04:12
21876	9d674041-8134-42a1-baf8-3d46db0f5b0a	9d674041-8612-4dfc-9d33-437de89ba9ce	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:04:12
21877	9d674041-84ea-4a2f-b145-0f41adf3097f	9d674041-8612-4dfc-9d33-437de89ba9ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 16:04:12
21878	9d674041-852d-4d52-b3c5-028924b262ed	9d674041-8612-4dfc-9d33-437de89ba9ce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":326,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:04:12
13947	9d5d13ed-5c9e-4e1e-abb1-70ab4e1fa64b	9d5d13ed-6016-45a7-b201-d50b01e5d6a4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":147,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:41:58
21879	9d674044-5b41-40c0-b9d0-e1f9f0d5e1e7	9d674044-75d8-4d8b-8e80-d66f11dd12ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 16:04:14
21880	9d674044-71c8-43ea-bb9a-c6bd27ba0544	9d674044-75d8-4d8b-8e80-d66f11dd12ed	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"42.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 16:04:14
21881	9d674044-74a3-43e9-96b1-b8a69f1658c6	9d674044-75d8-4d8b-8e80-d66f11dd12ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 16:04:14
12964	9d5cef98-d774-4f0b-b8bb-067983cbd9c3	9d5cef98-f42a-449c-8a1c-6d5a8ff52b4f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 13:00:23
12965	9d5cef98-f2cf-4828-893c-e11a4d0dc56d	9d5cef98-f42a-449c-8a1c-6d5a8ff52b4f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 13:00:23
12966	9d5cef98-f358-4264-9137-4e52698e65ed	9d5cef98-f42a-449c-8a1c-6d5a8ff52b4f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[3F000]: Invalid schema name: 7 ERROR:  no existe el esquema \\u00abl\\u00bb\\nLINE 17:                             order by l.id 'desc'\\n                                              ^ (Connection: pgsql, SQL: \\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id 'desc'\\n                        )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":256,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:00:23
21882	9d674044-74f7-443b-8af0-0f2498016939	9d674044-75d8-4d8b-8e80-d66f11dd12ed	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:04:14
41389	9d6ccc74-79bf-4900-b3a6-b37c5040b3b9	9d6ccc74-9479-469d-b78e-1208c9547d43	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":30,"hostname":"EderCortes"}	2024-11-06 10:15:22
41390	9d6ccc74-92c8-421e-afd8-fb44c8545dbd	9d6ccc74-9479-469d-b78e-1208c9547d43	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":31,"hostname":"EderCortes"}	2024-11-06 10:15:22
12967	9d5cef9a-ced5-414e-9455-dffe40470b1c	9d5cef9a-ee0c-4769-96c6-0796d1d3b191	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 13:00:24
12968	9d5cef9a-e87a-4ee0-9338-cb1f12c740ac	9d5cef9a-ee0c-4769-96c6-0796d1d3b191	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 13:00:24
12969	9d5cef9a-e8c5-4f98-87bb-eb93852236db	9d5cef9a-ee0c-4769-96c6-0796d1d3b191	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 13:00:24
12970	9d5cef9a-ecdb-466a-b634-1b4287832877	9d5cef9a-ee0c-4769-96c6-0796d1d3b191	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 13:00:24
12971	9d5cef9a-ed21-49c8-97f4-62855dae79e7	9d5cef9a-ee0c-4769-96c6-0796d1d3b191	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:00:24
13948	9d5d13ed-dff5-414e-a7bc-338e403ead77	9d5d13ee-232f-486b-84c6-05cc912c892d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-29 14:41:58
13949	9d5d13ee-1f0e-43fa-96f1-a6022187180e	9d5d13ee-232f-486b-84c6-05cc912c892d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"144.95","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 14:41:58
13950	9d5d13ee-2205-474b-bf09-6ca444e7a712	9d5d13ee-232f-486b-84c6-05cc912c892d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-29 14:41:58
13951	9d5d13ee-2247-447e-9274-4ea35a054107	9d5d13ee-232f-486b-84c6-05cc912c892d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":323,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:41:58
21883	9d674051-b1f6-40b2-a392-ded79d0f6523	9d674051-d158-4f82-bbb3-9c3f17f9d094	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 16:04:22
21884	9d674051-c7ef-4873-a663-a912f40e7f51	9d674051-d158-4f82-bbb3-9c3f17f9d094	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 68\\n                        ","time":"42.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"7d9994d55cb8dde82ff4185920c79043","hostname":"EderCortes"}	2024-11-03 16:04:22
21885	9d674051-cb6e-446d-8aa1-4a9e71141ea2	9d674051-d158-4f82-bbb3-9c3f17f9d094	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '68' order by \\"item_loans\\".\\"id\\" asc","time":"2.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 16:04:22
21886	9d674051-cb9d-4180-81c7-db1849dda9b2	9d674051-d158-4f82-bbb3-9c3f17f9d094	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 16:04:22
21887	9d674051-d013-4d16-a7c2-d6e8cb033af9	9d674051-d158-4f82-bbb3-9c3f17f9d094	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 16:04:22
41392	9d6ccc74-fc7d-4f97-b4d7-e72e4d0edb28	9d6ccc75-1843-4011-9908-ed2d899dfb2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":31,"hostname":"EderCortes"}	2024-11-06 10:15:22
13952	9d5d13ee-6bbd-480b-bb8e-17bfc0a33afa	9d5d13ee-86e2-41ac-994d-4a5c2d5866a3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-29 14:41:59
13953	9d5d13ee-82a5-4b02-94c8-5f3a5ce0a289	9d5d13ee-86e2-41ac-994d-4a5c2d5866a3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAr%' or \\"users\\".\\"user_document\\"::text like '%MAr%') order by \\"users\\".\\"user_document\\" asc","time":"41.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 14:41:59
13954	9d5d13ee-8594-47d7-8b0e-814fa1930594	9d5d13ee-86e2-41ac-994d-4a5c2d5866a3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-29 14:41:59
13955	9d5d13ee-85d8-469e-ab47-dbdf4d98bccd	9d5d13ee-86e2-41ac-994d-4a5c2d5866a3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAr"},"session":[],"response_status":200,"response":{"data":[]},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:41:59
21888	9d674051-d06a-41af-bf70-0f6b137f7b49	9d674051-d158-4f82-bbb3-9c3f17f9d094	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/68","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":68,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":10000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":227,"loans_codigo":68,"itemloans_cuota":"1","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":228,"loans_codigo":68,"itemloans_cuota":"2","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":229,"loans_codigo":68,"itemloans_cuota":"3","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":230,"loans_codigo":68,"itemloans_cuota":"4","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":231,"loans_codigo":68,"itemloans_cuota":"5","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":232,"loans_codigo":68,"itemloans_cuota":"6","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":233,"loans_codigo":68,"itemloans_cuota":"7","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":234,"loans_codigo":68,"itemloans_cuota":"8","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":235,"loans_codigo":68,"itemloans_cuota":"9","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":236,"loans_codigo":68,"itemloans_cuota":"10","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":284,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:04:22
16983	9d654686-5f07-4d3e-98ba-b24c9e12c805	9d654686-a6e4-41e0-917a-e895d90f86b7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-02 16:30:04
14385	9d5d1e17-e6d9-4e98-a4e7-1278b75d76a4	9d5d1e18-244a-4f2b-8be7-0e0949beea4e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-29 15:10:24
14386	9d5d1e18-20fa-494d-91ec-d747fdfa37e1	9d5d1e18-244a-4f2b-8be7-0e0949beea4e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-29 15:10:24
14387	9d5d1e18-22a7-4f80-a18d-064a8431f0fc	9d5d1e18-244a-4f2b-8be7-0e0949beea4e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1048,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:10:24
16984	9d654686-a547-4ab2-9847-fce6fb88e69b	9d654686-a6e4-41e0-917a-e895d90f86b7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-02 16:30:04
16985	9d654686-a5dc-4611-978b-65ab6270fdcb	9d654686-a6e4-41e0-917a-e895d90f86b7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42P01]: Undefined table: 7 ERROR:  referencia a la entrada de la cl\\u00e1usula FROM para la tabla \\u00abloans\\u00bb no v\\u00e1lida\\nLINE 1: ...rom \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"loans\\".\\"u...\\n                                                             ^\\nHINT:  Probablemente quiera hacer referencia al alias de la tabla \\u00abl\\u00bb. (Connection: pgsql, SQL: select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"loans\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"loans\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"loans\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id \\" desc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":42,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":367,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:30:04
41393	9d6ccc75-13cc-4627-8550-845a783fd941	9d6ccc75-1843-4011-9908-ed2d899dfb2b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"43.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 10:15:22
41394	9d6ccc75-16ea-47ab-b43c-798222ff0656	9d6ccc75-1843-4011-9908-ed2d899dfb2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":32,"hostname":"EderCortes"}	2024-11-06 10:15:22
41395	9d6ccc75-1755-48ea-bee2-102d5add8fb1	9d6ccc75-1843-4011-9908-ed2d899dfb2b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:22
13956	9d5d13ee-c984-4925-97e0-ee8462ec69d4	9d5d13ef-0d3e-4aa5-8cb9-bfbe8d78b8e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-29 14:41:59
13957	9d5d13ef-07cc-4b31-b7ef-830d08b1ed52	9d5d13ef-0d3e-4aa5-8cb9-bfbe8d78b8e3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAri%' or \\"users\\".\\"user_document\\"::text like '%MAri%') order by \\"users\\".\\"user_document\\" asc","time":"143.83","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 14:41:59
13958	9d5d13ef-0bf0-4caa-9d8e-e57feba919b7	9d5d13ef-0d3e-4aa5-8cb9-bfbe8d78b8e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-29 14:41:59
13959	9d5d13ef-0c3d-4d65-9ec3-0c86acfd1ce8	9d5d13ef-0d3e-4aa5-8cb9-bfbe8d78b8e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAri"},"session":[],"response_status":200,"response":{"data":[]},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:41:59
14388	9d5d1e19-4b04-4eff-a77e-345884911036	9d5d1e19-aebe-429c-99c2-490d0854d878	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-29 15:10:24
14389	9d5d1e19-8892-48b3-bc10-752d7ea6cf55	9d5d1e19-aebe-429c-99c2-490d0854d878	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"75.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":179,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 15:10:25
14390	9d5d1e19-8940-4e65-8aed-8e896b76435a	9d5d1e19-aebe-429c-99c2-490d0854d878	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 15:10:25
14391	9d5d1e19-ac48-450d-ae49-8e89d02863b9	9d5d1e19-aebe-429c-99c2-490d0854d878	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-29 15:10:25
14392	9d5d1e19-ad1e-4850-b867-7eb883f8b7c7	9d5d1e19-aebe-429c-99c2-490d0854d878	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":943,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:10:25
21889	9d674091-8e5d-4ce7-a3b0-0e6b9eb72222	9d674091-91db-485c-81d2-787fc5156533	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":175,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:05:04
41396	9d6ccc75-659c-44c1-beee-59a564918d59	9d6ccc75-ab9a-4d13-8a19-1e895511548e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":32,"hostname":"EderCortes"}	2024-11-06 10:15:22
41397	9d6ccc75-a685-4d8b-b35c-9502a13a7943	9d6ccc75-ab9a-4d13-8a19-1e895511548e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"140.54","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:15:22
41398	9d6ccc75-a6d6-43ac-915d-703674668262	9d6ccc75-ab9a-4d13-8a19-1e895511548e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:15:22
41399	9d6ccc75-aa58-4ba0-8219-6365a915516b	9d6ccc75-ab9a-4d13-8a19-1e895511548e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":33,"hostname":"EderCortes"}	2024-11-06 10:15:22
41400	9d6ccc75-aaa5-4ce7-ad82-2dbec7ee498d	9d6ccc75-ab9a-4d13-8a19-1e895511548e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":368,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:22
13960	9d5d13ef-4ff9-4a73-850c-191fdd7a3b69	9d5d13ef-914e-4f7e-b346-70e256eca83f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-29 14:41:59
13961	9d5d13ef-8d48-43cd-a0fb-b906d749dc5d	9d5d13ef-914e-4f7e-b346-70e256eca83f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAria%' or \\"users\\".\\"user_document\\"::text like '%MAria%') order by \\"users\\".\\"user_document\\" asc","time":"139.78","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 14:41:59
13962	9d5d13ef-901e-4f8d-8e8f-537edacd0521	9d5d13ef-914e-4f7e-b346-70e256eca83f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-29 14:41:59
13963	9d5d13ef-9063-4a2a-bb27-9410d1008000	9d5d13ef-914e-4f7e-b346-70e256eca83f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAria"},"session":[],"response_status":200,"response":{"data":[]},"duration":324,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:41:59
14393	9d5d1e1a-b028-4b58-a51c-f0e933be74e8	9d5d1e1b-1a19-41c1-9523-59aafcec1429	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-29 15:10:25
14394	9d5d1e1b-0fd2-438e-b88e-d7161c7b6598	9d5d1e1b-1a19-41c1-9523-59aafcec1429	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"191.47","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":179,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 15:10:26
14395	9d5d1e1b-106b-416a-a635-89123a213e5e	9d5d1e1b-1a19-41c1-9523-59aafcec1429	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 15:10:26
14396	9d5d1e1b-17ef-4841-93d6-6c640632629f	9d5d1e1b-1a19-41c1-9523-59aafcec1429	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-29 15:10:26
14397	9d5d1e1b-188a-4742-8ecf-349eafb92c27	9d5d1e1b-1a19-41c1-9523-59aafcec1429	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":877,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:10:26
21890	9d674092-1f5d-4e6e-b59e-b9ba5617ec12	9d674092-48e3-4294-aca4-a558b7992dc3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 16:05:05
21891	9d674092-3af1-4160-8d9c-c351fa1acefc	9d674092-48e3-4294-aca4-a558b7992dc3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 227 limit 1","time":"4.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-03 16:05:05
21892	9d674092-3b61-4189-9a82-50ff29b537ea	9d674092-48e3-4294-aca4-a558b7992dc3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-03 16:05:05
21893	9d674092-3de1-4d08-9242-ccc1d669e6c9	9d674092-48e3-4294-aca4-a558b7992dc3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 68 limit 1","time":"3.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 16:05:05
21894	9d674092-3e31-43d6-b223-3b14dc0e0b33	9d674092-48e3-4294-aca4-a558b7992dc3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 16:05:05
21895	9d674092-426a-46b1-8eea-712393c8c63f	9d674092-48e3-4294-aca4-a558b7992dc3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '03-11-2024', \\"itemloans_interes_canelado\\" = '250000', \\"itemloans_cuota_cancelada\\" = '1000000', \\"updated_at\\" = '2024-11-03 16:05:05' where \\"id\\" = 227","time":"7.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":400,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-03 16:05:05
21896	9d674092-42ca-4e23-a889-9e2fb28b40e8	9d674092-48e3-4294-aca4-a558b7992dc3	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:227","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-03 16:05:05","item_loans_cuando_pago":"03-11-2024","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},"hostname":"EderCortes"}	2024-11-03 16:05:05
21897	9d674092-43a0-41f9-aa54-e300c1f43ac5	9d674092-48e3-4294-aca4-a558b7992dc3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 250000, \\"loans_pago_prestado\\" = 1000000, \\"updated_at\\" = '2024-11-03 16:05:05' where \\"id\\" = 68","time":"0.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":408,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-03 16:05:05
21898	9d674092-43e0-41c8-82cd-ad17b20e71c0	9d674092-48e3-4294-aca4-a558b7992dc3	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:68","changes":{"updated_at":"2024-11-03 16:05:05","loans_pago_interes":250000,"loans_pago_prestado":1000000},"hostname":"EderCortes"}	2024-11-03 16:05:05
13964	9d5d13ef-d043-4815-94b9-7bf5024b7adf	9d5d13ef-d312-4cc0-a9a2-c67f02e1112f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":142,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:42:00
14398	9d5d1e1e-4662-4c0c-8465-359ee066609b	9d5d1e1e-9802-433a-820c-7b158a82981c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-29 15:10:28
14399	9d5d1e1e-8b1e-4677-95db-edcb959186eb	9d5d1e1e-9802-433a-820c-7b158a82981c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"93.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 15:10:28
14400	9d5d1e1e-8c44-42d7-9157-8c25ced12761	9d5d1e1e-9802-433a-820c-7b158a82981c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 15:10:28
14401	9d5d1e1e-95c9-481f-b089-c2ae7037474d	9d5d1e1e-9802-433a-820c-7b158a82981c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-29 15:10:28
14402	9d5d1e1e-9669-4a69-8e9e-87543b9b7b2b	9d5d1e1e-9802-433a-820c-7b158a82981c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":965,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:10:28
21899	9d674092-4770-410d-953a-39cf43d6634e	9d674092-48e3-4294-aca4-a558b7992dc3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 16:05:05
21900	9d674092-47c4-431a-8c47-6a4c25123934	9d674092-48e3-4294-aca4-a558b7992dc3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"181","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000","id":227,"loans_codigo":68,"itemloans_cuota":"1","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":288,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:05:05
31736	9d6954d6-9614-4492-9ee3-3cc0af7751d6	9d6954d6-ea75-4420-86e4-aab6985be429	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 16:53:24
31737	9d6954d6-e7c6-42fb-a2b6-05330eed190a	9d6954d6-ea75-4420-86e4-aab6985be429	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 16:53:24
31738	9d6954d6-e902-4f8c-a226-9cd86228c668	9d6954d6-ea75-4420-86e4-aab6985be429	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":654,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:53:24
41401	9d6ccc75-ec86-4e98-affe-4884bccf0d8a	9d6ccc76-0928-43d9-a4ba-fc9b0e8e08b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":33,"hostname":"EderCortes"}	2024-11-06 10:15:23
41402	9d6ccc76-03c9-486e-b901-257f82c56d06	9d6ccc76-0928-43d9-a4ba-fc9b0e8e08b4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:15:23
41403	9d6ccc76-0427-4e6d-a236-34caa235ac5a	9d6ccc76-0928-43d9-a4ba-fc9b0e8e08b4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:15:23
41404	9d6ccc76-07c0-4814-bc56-ecec48f96f3d	9d6ccc76-0928-43d9-a4ba-fc9b0e8e08b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":34,"hostname":"EderCortes"}	2024-11-06 10:15:23
41405	9d6ccc76-080c-4e27-9d85-afd14b6de25a	9d6ccc76-0928-43d9-a4ba-fc9b0e8e08b4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":220,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:23
13965	9d5d13f0-1a82-4517-af50-38c0e59e6924	9d5d13f0-1d7e-44a2-b7df-f912252def52	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":123,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:42:00
21901	9d674092-9c1a-48eb-bcc2-f4f4426c8fe0	9d674092-c32c-4c61-a2a5-8b8a257bbf71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 16:05:05
21902	9d674092-b52b-49c5-9755-0b5687b87cc9	9d674092-c32c-4c61-a2a5-8b8a257bbf71	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 68\\n                        ","time":"49.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"7d9994d55cb8dde82ff4185920c79043","hostname":"EderCortes"}	2024-11-03 16:05:05
21903	9d674092-ba34-446c-98ed-c56fd9ca5a85	9d674092-c32c-4c61-a2a5-8b8a257bbf71	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '68' order by \\"item_loans\\".\\"id\\" asc","time":"2.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 16:05:05
21904	9d674092-ba76-4e2c-8c0a-762475600cc9	9d674092-c32c-4c61-a2a5-8b8a257bbf71	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 16:05:05
21905	9d674092-c102-4024-98f7-afe9b8d662a4	9d674092-c32c-4c61-a2a5-8b8a257bbf71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 16:05:05
21906	9d674092-c194-43a8-b62a-221bcde0b0f1	9d674092-c32c-4c61-a2a5-8b8a257bbf71	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/68","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":68,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":10000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"1000000","loans_pago_interes":"250000"},"items":[{"id":227,"loans_codigo":68,"itemloans_cuota":"1","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":228,"loans_codigo":68,"itemloans_cuota":"2","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":229,"loans_codigo":68,"itemloans_cuota":"3","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":230,"loans_codigo":68,"itemloans_cuota":"4","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":231,"loans_codigo":68,"itemloans_cuota":"5","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":232,"loans_codigo":68,"itemloans_cuota":"6","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":233,"loans_codigo":68,"itemloans_cuota":"7","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":234,"loans_codigo":68,"itemloans_cuota":"8","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":235,"loans_codigo":68,"itemloans_cuota":"9","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":236,"loans_codigo":68,"itemloans_cuota":"10","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":291,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:05:05
31739	9d6954d7-b267-489f-bd9e-00da4421e975	9d6954d8-0efb-42c3-b42d-4833d79c88e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 16:53:25
31740	9d6954d8-04ec-4495-b3a3-1a12896f4434	9d6954d8-0efb-42c3-b42d-4833d79c88e7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"165.04","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:53:25
31741	9d6954d8-0583-42a1-ab9c-b1233fc2cfd4	9d6954d8-0efb-42c3-b42d-4833d79c88e7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 16:53:25
31742	9d6954d8-0d2f-44e9-b489-0ddcad0737e9	9d6954d8-0efb-42c3-b42d-4833d79c88e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 16:53:25
31743	9d6954d8-0db0-4abd-9b71-ccf74b6a5a27	9d6954d8-0efb-42c3-b42d-4833d79c88e7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":654,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:53:25
41406	9d6ccc77-532b-44da-9e0a-4581c51dc8c9	9d6ccc77-abd1-4e2c-8bc2-9c4cd60dcfa8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":34,"hostname":"EderCortes"}	2024-11-06 10:15:24
13966	9d5d13f0-9764-46b0-ac29-f2a74aa24a8d	9d5d13f0-9a8c-4090-ac15-10fb81cd978c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":137,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:42:00
31631	9d695232-d763-4077-bd44-1b79f2856e0e	9d695233-29ff-4ff6-a11c-3b2b1c677306	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 16:46:01
31632	9d695233-277c-4606-9432-44ca3a3a7ad1	9d695233-29ff-4ff6-a11c-3b2b1c677306	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:46:02
16949	9d654652-9f22-45e3-8ae9-027b17db20e5	9d654653-1605-468c-8adb-57f3faec62df	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:29:30
16950	9d654653-1389-46cc-a8f8-ff6962e1bcff	9d654653-1605-468c-8adb-57f3faec62df	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 16:29:31
16951	9d654653-14b2-43ec-bd88-3d5c032cb7ba	9d654653-1605-468c-8adb-57f3faec62df	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42P01]: Undefined table: 7 ERROR:  falta una entrada para la tabla \\u00abl\\u00bb en la cl\\u00e1usula FROM\\nLINE 1: select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", ...\\n               ^ (Connection: pgsql, SQL: select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" inner join \\"users\\" as \\"ucl\\" on \\"loans\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"loans\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"loans\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id \\" desc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":42,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":531,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:29:31
31633	9d695233-2889-4a66-84c1-4e70feb5fb9f	9d695233-29ff-4ff6-a11c-3b2b1c677306	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":420,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:46:02
41407	9d6ccc77-a4e1-4c51-87a5-dd54a46a2b23	9d6ccc77-abd1-4e2c-8bc2-9c4cd60dcfa8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"168.28","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:15:24
31744	9d6954d8-5eda-4b76-8d1d-80e66c34818a	9d6954d8-7f2d-4ffd-8f43-7a846a435ee4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 16:53:25
31745	9d6954d8-7988-4cfe-bb41-675e1efecdc4	9d6954d8-7f2d-4ffd-8f43-7a846a435ee4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:53:25
31746	9d6954d8-79e6-47f2-85dd-e65eb7217376	9d6954d8-7f2d-4ffd-8f43-7a846a435ee4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 16:53:26
31747	9d6954d8-7df6-46b7-959f-f5aa53c7460c	9d6954d8-7f2d-4ffd-8f43-7a846a435ee4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 16:53:26
41408	9d6ccc77-a542-4d0c-a42c-1db5a28938ad	9d6ccc77-abd1-4e2c-8bc2-9c4cd60dcfa8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:15:24
41409	9d6ccc77-a9ec-4b47-bd91-692c3f8f1ea3	9d6ccc77-abd1-4e2c-8bc2-9c4cd60dcfa8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":35,"hostname":"EderCortes"}	2024-11-06 10:15:24
41410	9d6ccc77-aa58-4276-9abe-0540f01f7f71	9d6ccc77-abd1-4e2c-8bc2-9c4cd60dcfa8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":584,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:24
13967	9d5d13f1-154b-4d10-8b28-d44390f04818	9d5d13f1-1823-4102-aa1c-10a1ecaf549b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":134,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:42:00
31634	9d695233-ae9f-4ab8-807a-3f60d8468cfc	9d695233-cf8f-4a49-a48d-322aabcea00d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:46:02
19066	9d66cfaf-9583-4385-8452-46b4991aa40e	9d66cfaf-da80-4907-a95d-41d295257b39	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 10:49:26
19067	9d66cfaf-d8f9-4118-8ed0-a8b46a7395b4	9d66cfaf-da80-4907-a95d-41d295257b39	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 10:49:26
19068	9d66cfaf-d98a-4c93-ac25-db5617726f16	9d66cfaf-da80-4907-a95d-41d295257b39	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":326,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:49:26
31635	9d695233-c68d-4c7c-9cb9-d24883b48018	9d695233-cf8f-4a49-a48d-322aabcea00d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"47.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 16:46:02
31636	9d695233-c9fc-4cf5-9a9f-4f2224a81045	9d695233-cf8f-4a49-a48d-322aabcea00d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '92' order by \\"item_loans\\".\\"id\\" asc","time":"2.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 16:46:02
31637	9d695233-ce14-4c39-a20f-8bd360aebd8d	9d695233-cf8f-4a49-a48d-322aabcea00d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:46:02
31638	9d695233-ce84-4e97-87c5-79d3446796db	9d695233-cf8f-4a49-a48d-322aabcea00d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":92,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":15,"loans_valor_prestado":8000009,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"533333.93333333","loans_pago_interes":"133333.48333333","user_alias":"eder.cortes"},"items":[{"id":379,"loans_codigo":92,"itemloans_cuota":"1","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:13:07","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":380,"loans_codigo":92,"itemloans_cuota":"2","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":381,"loans_codigo":92,"itemloans_cuota":"3","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":382,"loans_codigo":92,"itemloans_cuota":"4","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":383,"loans_codigo":92,"itemloans_cuota":"5","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":384,"loans_codigo":92,"itemloans_cuota":"6","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":385,"loans_codigo":92,"itemloans_cuota":"7","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":386,"loans_codigo":92,"itemloans_cuota":"8","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":387,"loans_codigo":92,"itemloans_cuota":"9","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-15 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":388,"loans_codigo":92,"itemloans_cuota":"10","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":389,"loans_codigo":92,"itemloans_cuota":"11","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-31 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":390,"loans_codigo":92,"itemloans_cuota":"12","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":391,"loans_codigo":92,"itemloans_cuota":"13","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-16 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":392,"loans_codigo":92,"itemloans_cuota":"14","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":393,"loans_codigo":92,"itemloans_cuota":"15","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":317,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:46:02
31748	9d6954d8-7e40-4a83-bed5-50680b44ee94	9d6954d8-7f2d-4ffd-8f43-7a846a435ee4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":268,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:53:26
41411	9d6ccc78-076f-42d6-b15f-de2df25a4ac6	9d6ccc78-52c7-435d-9474-e939665690e2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":35,"hostname":"EderCortes"}	2024-11-06 10:15:24
13968	9d5d13f1-67e8-4e18-9ba0-2b0eb73e2a52	9d5d13f1-a93d-4c8d-a2b2-6ec997646c41	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-29 14:42:01
13969	9d5d13f1-a532-4306-a3a8-700eeb1de7f8	9d5d13f1-a93d-4c8d-a2b2-6ec997646c41	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAri%' or \\"users\\".\\"user_document\\"::text like '%MAri%') order by \\"users\\".\\"user_document\\" asc","time":"139.67","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 14:42:01
13970	9d5d13f1-a81f-4ccb-9241-8a5981213ab7	9d5d13f1-a93d-4c8d-a2b2-6ec997646c41	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-29 14:42:01
13971	9d5d13f1-a860-453f-a2fb-c3ee6d004b9a	9d5d13f1-a93d-4c8d-a2b2-6ec997646c41	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAri"},"session":[],"response_status":200,"response":{"data":[]},"duration":317,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:42:01
19069	9d66cfb0-23ac-43e6-9401-4c863a4b2e40	9d66cfb0-41f4-4bc1-80ce-7fd2c74884d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 10:49:26
19070	9d66cfb0-38ff-4093-b237-7b09af9111e2	9d66cfb0-41f4-4bc1-80ce-7fd2c74884d2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"42.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 10:49:26
19071	9d66cfb0-3c3b-4984-9473-a31f3c0c3f1e	9d66cfb0-41f4-4bc1-80ce-7fd2c74884d2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"1.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 10:49:26
19072	9d66cfb0-3c86-4669-bb52-7fdd99606400	9d66cfb0-41f4-4bc1-80ce-7fd2c74884d2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 10:49:26
19073	9d66cfb0-40d7-4758-a8aa-c21c6386b9ff	9d66cfb0-41f4-4bc1-80ce-7fd2c74884d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 10:49:26
19074	9d66cfb0-411b-4116-83f7-3cf54799c446	9d66cfb0-41f4-4bc1-80ce-7fd2c74884d2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T02:27:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"0"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:49:26
31639	9d695235-f662-41ba-bb84-b089523f0a9c	9d695236-4ff7-473b-8066-dea34b62459d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:46:03
31640	9d695236-46a2-49b3-b956-410727f4607d	9d695236-4ff7-473b-8066-dea34b62459d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"171.47","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:46:04
31641	9d695236-4738-41ff-b03f-32634c7b1b4b	9d695236-4ff7-473b-8066-dea34b62459d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:46:04
31642	9d695236-4e22-41ef-8b0d-ab758c47fd17	9d695236-4ff7-473b-8066-dea34b62459d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:46:04
31749	9d6954d9-0642-4995-8722-c583e40aab2f	9d6954d9-473f-4b34-9fa2-b37d15bc16f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 16:53:26
13972	9d5d13f1-ef08-4b9b-ab61-f815cb7f6b5c	9d5d13f2-33a9-45c3-9884-ae11ac1144e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-29 14:42:01
13973	9d5d13f2-2f94-4ac0-a982-d5820b3adb99	9d5d13f2-33a9-45c3-9884-ae11ac1144e7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAr%' or \\"users\\".\\"user_document\\"::text like '%MAr%') order by \\"users\\".\\"user_document\\" asc","time":"148.09","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 14:42:01
13974	9d5d13f2-3282-4c28-b996-8db326b1975d	9d5d13f2-33a9-45c3-9884-ae11ac1144e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-29 14:42:01
13975	9d5d13f2-32c4-4209-9ed7-5da68250de67	9d5d13f2-33a9-45c3-9884-ae11ac1144e7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAr"},"session":[],"response_status":200,"response":{"data":[]},"duration":338,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:42:01
19075	9d66cfb1-8961-4276-879d-87382409148e	9d66cfb1-a8f0-4cb9-a120-0979dd32b538	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 10:49:27
19076	9d66cfb1-a2e6-4488-bd6e-dd5968aa4f52	9d66cfb1-a8f0-4cb9-a120-0979dd32b538	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 10:49:27
19077	9d66cfb1-a32e-4e78-acb6-0d7a9ea4be41	9d66cfb1-a8f0-4cb9-a120-0979dd32b538	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 10:49:27
19078	9d66cfb1-a775-456a-85e9-c2d7a1544661	9d66cfb1-a8f0-4cb9-a120-0979dd32b538	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 10:49:27
19079	9d66cfb1-a7cf-4237-ad00-b1a5f6a58c80	9d66cfb1-a8f0-4cb9-a120-0979dd32b538	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":403,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:49:27
31643	9d695236-4eb6-4ca9-acfd-4cca56806929	9d695236-4ff7-473b-8066-dea34b62459d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":577,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:46:04
31750	9d6954d9-3de5-414c-a125-1ac2e4a83d1c	9d6954d9-473f-4b34-9fa2-b37d15bc16f2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"72.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:53:26
31751	9d6954d9-3e82-4b9e-91e9-6001541705ff	9d6954d9-473f-4b34-9fa2-b37d15bc16f2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:53:26
31752	9d6954d9-4555-49eb-a764-0786ba102f56	9d6954d9-473f-4b34-9fa2-b37d15bc16f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 16:53:26
13976	9d5d13f2-720b-4620-8cd6-bbde1c52e56e	9d5d13f2-750b-407c-ba5a-d4cf38300672	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":136,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:42:01
31644	9d6952cf-bda6-40a5-8d9c-0f3fd50b66a7	9d6952cf-e5b6-4179-ad05-7fdb8b6dbafe	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 16:47:44
31645	9d6952cf-e02d-4c58-8450-16e91e9d233e	9d6952cf-e5b6-4179-ad05-7fdb8b6dbafe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"57.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 16:47:44
31646	9d6952cf-e3f3-428a-826e-d80cb75c2c36	9d6952cf-e5b6-4179-ad05-7fdb8b6dbafe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:47:44
31647	9d6952cf-e46d-4805-b976-dd5981affd5d	9d6952cf-e5b6-4179-ad05-7fdb8b6dbafe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:47:44
31753	9d6954d9-45d9-4dd4-84f6-d92558fa27ba	9d6954d9-473f-4b34-9fa2-b37d15bc16f2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":496,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:53:26
13977	9d5d13f2-c570-49b1-8422-1606ef7777fe	9d5d13f2-e25a-4319-b165-22b673d6894a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-10-29 14:42:01
13978	9d5d13f2-dda3-4b0b-b579-d98c511335c0	9d5d13f2-e25a-4319-b165-22b673d6894a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"44.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 14:42:02
13979	9d5d13f2-e124-4049-b755-16da2b73f1cd	9d5d13f2-e25a-4319-b165-22b673d6894a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-29 14:42:02
13980	9d5d13f2-e16c-4b2c-9ec4-91de46f98408	9d5d13f2-e25a-4319-b165-22b673d6894a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":224,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:42:02
31754	9d6954d9-c6f0-44a8-a8f7-6db776f1f0af	9d6954d9-fc4b-4b01-9249-b2fc099612ab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 16:53:26
31755	9d6954d9-f2ef-43ba-ba99-8f6166f1a068	9d6954d9-fc4b-4b01-9249-b2fc099612ab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"66.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:53:26
31756	9d6954d9-f373-4a40-aa4e-2098afb8054a	9d6954d9-fc4b-4b01-9249-b2fc099612ab	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:53:26
31757	9d6954d9-fa3a-45e5-93c6-053f86530759	9d6954d9-fc4b-4b01-9249-b2fc099612ab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 16:53:26
31758	9d6954d9-facc-424f-9218-56e95894d832	9d6954d9-fc4b-4b01-9249-b2fc099612ab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":435,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:53:26
41412	9d6ccc78-4e15-4c0c-9b90-23d033398b0d	9d6ccc78-52c7-435d-9474-e939665690e2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"161.66","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:15:24
41413	9d6ccc78-5146-4ffe-bf5b-efa05ce7df61	9d6ccc78-52c7-435d-9474-e939665690e2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":36,"hostname":"EderCortes"}	2024-11-06 10:15:24
41414	9d6ccc78-5199-47d7-aaf0-6c3a6e59918e	9d6ccc78-52c7-435d-9474-e939665690e2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":410,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:24
13981	9d5d13f3-2b6b-48ff-9011-872f5c4e1540	9d5d13f3-73b0-42c1-9490-083a0b02cb45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-29 14:42:02
13982	9d5d13f3-6ea5-4615-9b2c-81df578de5e6	9d5d13f3-73b0-42c1-9490-083a0b02cb45	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ma%' or \\"users\\".\\"user_document\\"::text like '%Ma%') order by \\"users\\".\\"user_document\\" asc","time":"155.15","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 14:42:02
13983	9d5d13f3-7275-4faa-9b15-90ca6424f659	9d5d13f3-73b0-42c1-9490-083a0b02cb45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-10-29 14:42:02
13984	9d5d13f3-72c6-4385-8427-7262c0410dd1	9d5d13f3-73b0-42c1-9490-083a0b02cb45	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ma"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:42:02
41415	9d6ccc78-b862-4190-a94d-8a661535c4c1	9d6ccc78-bee4-4a14-a794-1c56958b7ef8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":227,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:24
31759	9d6954ef-cea2-4ab7-b1ad-093f035b6d20	9d6954f0-071c-40d0-8437-b5dcd7b8a328	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 16:53:41
31760	9d6954f0-0073-4aab-b0e2-3d6c58f43135	9d6954f0-071c-40d0-8437-b5dcd7b8a328	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"42.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":19,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-04 16:53:41
31761	9d6954f0-00de-47ee-a2b4-ef2727ce2c45	9d6954f0-071c-40d0-8437-b5dcd7b8a328	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 16:53:41
31762	9d6954f0-0586-465f-9640-9a6cf634338d	9d6954f0-071c-40d0-8437-b5dcd7b8a328	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:53:41
13985	9d5d13f3-b979-41f7-9116-b4813fa7ba95	9d5d13f3-bc7b-4604-8a12-1e0285623daf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":157,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:42:02
31763	9d6954f0-05e0-4492-9aad-121eef9ec001	9d6954f0-071c-40d0-8437-b5dcd7b8a328	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:55:01.000000Z","deleted_at":null,"user_alias":"eder.cortes"}]},"duration":306,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:53:41
17038	9d6547a3-c9e0-4132-985c-f47684cb7f02	9d6547a3-ed1a-42b6-a7b9-bf0d168d53aa	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 16:33:11
17039	9d6547a3-eb2f-4aac-924f-28ea0b1a78a9	9d6547a3-ed1a-42b6-a7b9-bf0d168d53aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:33:11
17040	9d6547a3-ebef-4e2a-b879-d7c3d451c7c5	9d6547a3-ed1a-42b6-a7b9-bf0d168d53aa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:33:11
19171	9d66d147-2000-4233-9cb5-8065cf19000a	9d66d147-4c0a-4813-a731-f0452b20d14a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 10:53:53
19172	9d66d147-4958-4891-a383-681c452175e5	9d66d147-4c0a-4813-a731-f0452b20d14a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 10:53:53
19173	9d66d147-4a64-40bc-a348-631dc84e2fd3	9d66d147-4c0a-4813-a731-f0452b20d14a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":309,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:53:53
41416	9d6ccc79-8ecb-4f2f-b95d-177f4083677b	9d6ccc79-b937-41e4-8a55-f17db93e1649	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:15:25
41417	9d6ccc79-b145-495b-b0da-4c5eca7557a0	9d6ccc79-b937-41e4-8a55-f17db93e1649	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"50.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 10:15:25
41418	9d6ccc79-b720-4fad-8cfa-c07906c7a92d	9d6ccc79-b937-41e4-8a55-f17db93e1649	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:15:25
41419	9d6ccc79-b7d1-4e22-a7c2-2a569fd132bb	9d6ccc79-b937-41e4-8a55-f17db93e1649	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":331,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:25
13986	9d5d13f4-1088-473a-9b4e-478b5adce4a7	9d5d13f4-2ab3-4f91-95a3-2b8351db5e22	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-10-29 14:42:02
13987	9d5d13f4-26c5-4d1f-af26-c422871745c0	9d5d13f4-2ab3-4f91-95a3-2b8351db5e22	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mar%' or \\"users\\".\\"user_document\\"::text like '%Mar%') order by \\"users\\".\\"user_document\\" asc","time":"40.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 14:42:02
13988	9d5d13f4-2990-4e12-b68e-3d651fac23b7	9d5d13f4-2ab3-4f91-95a3-2b8351db5e22	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-10-29 14:42:02
13989	9d5d13f4-29d2-4302-8d7a-68f4c1c3d76f	9d5d13f4-2ab3-4f91-95a3-2b8351db5e22	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mar"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":221,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:42:02
17041	9d6547a4-72f0-407b-b295-dd9646122a32	9d6547a4-8e29-4d8d-aaa5-775043d665a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:33:12
17042	9d6547a4-8982-4957-a22e-7086452b71fb	9d6547a4-8e29-4d8d-aaa5-775043d665a6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"41.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":44,"hash":"f9f3598e6ad2468770f89917d2ab916c","hostname":"EderCortes"}	2024-11-02 16:33:12
17043	9d6547a4-8ce9-4a7b-b727-097c36a5fb1c	9d6547a4-8e29-4d8d-aaa5-775043d665a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 16:33:12
17044	9d6547a4-8d3f-4690-b5f6-51f6febc6d50	9d6547a4-8e29-4d8d-aaa5-775043d665a6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":374,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:33:12
19174	9d66d147-b57a-455b-afcd-64658eaaf639	9d66d147-dc27-42e0-8299-7a071315eb78	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 10:53:53
19175	9d66d147-cfe9-4db3-ba53-b4ae2cad76ce	9d66d147-dc27-42e0-8299-7a071315eb78	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"55.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 10:53:53
19176	9d66d147-d4ee-46f6-aedc-98e856a47f78	9d66d147-dc27-42e0-8299-7a071315eb78	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 10:53:53
19177	9d66d147-d531-4b4d-a422-f2d7c6a6e461	9d66d147-dc27-42e0-8299-7a071315eb78	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 10:53:53
19178	9d66d147-da9d-4d71-87f7-cb3c4f801e98	9d66d147-dc27-42e0-8299-7a071315eb78	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 10:53:53
31764	9d695519-c430-49f3-9b17-e57f9efbb928	9d695519-e49b-4412-b7af-0fb5e0295fc7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:54:08
31765	9d695519-debe-4d2f-8d5b-49159908def4	9d695519-e49b-4412-b7af-0fb5e0295fc7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '14' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"43.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":73,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 16:54:08
13990	9d5d13f4-6ae3-4d87-8dbd-33b115f9f858	9d5d13f4-6dc8-4c62-92b1-36ae0fabb07a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":145,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:42:03
17045	9d6547a6-4d0a-41cf-9387-8f8fc2ca0de7	9d6547a6-927f-4781-804c-7a5f30986738	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 16:33:13
17046	9d6547a6-8d86-44fb-8464-f57ffeafd08a	9d6547a6-927f-4781-804c-7a5f30986738	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"144.47","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 16:33:13
17047	9d6547a6-8de2-4ec8-8d1e-ee9e041fd0e6	9d6547a6-927f-4781-804c-7a5f30986738	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 16:33:13
14613	9d5ebeca-8563-411e-b0ba-5560b63b745f	9d5ebeca-dab2-47da-a2a7-d9cc65f0151b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-30 10:35:34
14614	9d5ebeca-d72b-4bc7-bd91-b41145824477	9d5ebeca-dab2-47da-a2a7-d9cc65f0151b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-30 10:35:34
14615	9d5ebeca-d8d4-4989-96dd-39e27017320a	9d5ebeca-dab2-47da-a2a7-d9cc65f0151b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":607,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:35:34
17048	9d6547a6-914f-4a3b-a7a2-e3a774a6726a	9d6547a6-927f-4781-804c-7a5f30986738	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 16:33:13
17049	9d6547a6-9198-4168-a68f-7fec418be154	9d6547a6-927f-4781-804c-7a5f30986738	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":321,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:33:13
19179	9d66d147-db04-4026-8c26-fb906503ca2d	9d66d147-dc27-42e0-8299-7a071315eb78	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T02:27:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"0"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:53:53
31766	9d695519-df1f-427c-b5c8-a6c73d12fcd7	9d695519-e49b-4412-b7af-0fb5e0295fc7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 16:54:08
31767	9d695519-e339-4b60-8e8b-65e9f69ef99a	9d695519-e49b-4412-b7af-0fb5e0295fc7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:54:08
31768	9d695519-e38f-40e9-a288-0b2bf4a30ca0	9d695519-e49b-4412-b7af-0fb5e0295fc7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/14","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}},"duration":366,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:54:08
13991	9d5d13f4-e310-43b6-ad0b-f5ca8ca7624d	9d5d13f4-e5fc-429b-b572-407775762b79	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":136,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:42:03
14616	9d5ebecb-ddd8-41a3-bb9c-bf8bde9a01d8	9d5ebecc-2083-44d3-95cd-b70dac69ca1f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-30 10:35:35
14617	9d5ebecc-14e9-4589-b06a-57e5f71407c8	9d5ebecc-2083-44d3-95cd-b70dac69ca1f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"77.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 10:35:35
14618	9d5ebecc-1581-42b7-8f2a-bb0a4b7e7951	9d5ebecc-2083-44d3-95cd-b70dac69ca1f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 10:35:35
14619	9d5ebecc-1e4a-40be-b5b2-e610a847932e	9d5ebecc-2083-44d3-95cd-b70dac69ca1f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-30 10:35:35
14620	9d5ebecc-1ed9-4d6e-883c-0487b66d3c13	9d5ebecc-2083-44d3-95cd-b70dac69ca1f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":770,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:35:35
19180	9d66d14a-003e-4009-b560-02636d0b94a3	9d66d14a-2d96-47f8-9b28-ea2681de6662	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 10:53:55
19181	9d66d14a-26e9-40cd-8610-c92845bb11ea	9d66d14a-2d96-47f8-9b28-ea2681de6662	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"57.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 10:53:55
19182	9d66d14a-275e-4707-b235-4b0f40422d70	9d66d14a-2d96-47f8-9b28-ea2681de6662	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 10:53:55
19183	9d66d14a-2c46-46a2-9073-476e2c1b646d	9d66d14a-2d96-47f8-9b28-ea2681de6662	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 10:53:55
19184	9d66d14a-2c94-42c2-81d2-23ba16416bbc	9d66d14a-2d96-47f8-9b28-ea2681de6662	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":367,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:53:55
31769	9d69551f-b65d-41a9-a861-be2046c2006b	9d69551f-d453-457e-839d-29f070f29ae0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:54:12
31770	9d69551f-cf16-4e85-a664-d392d0136790	9d69551f-d453-457e-839d-29f070f29ae0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"39.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":19,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-04 16:54:12
31771	9d69551f-cf67-49cf-a9e0-b71dec4b38e8	9d69551f-d453-457e-839d-29f070f29ae0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 16:54:12
31772	9d69551f-d2ff-49ce-bf1e-9e55133a290f	9d69551f-d453-457e-839d-29f070f29ae0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:54:12
13992	9d5d13f5-6326-43c7-af7b-d37f63269e8a	9d5d13f5-7e29-4a53-b9b9-d6bd676db395	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-10-29 14:42:03
13993	9d5d13f5-79f9-43e7-9ad7-da58cdc003cc	9d5d13f5-7e29-4a53-b9b9-d6bd676db395	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mara%' or \\"users\\".\\"user_document\\"::text like '%Mara%') order by \\"users\\".\\"user_document\\" asc","time":"41.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 14:42:03
13994	9d5d13f5-7d07-4873-9d93-58c2719f4f4f	9d5d13f5-7e29-4a53-b9b9-d6bd676db395	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-10-29 14:42:03
13995	9d5d13f5-7d49-414f-a7e6-98c717f354bd	9d5d13f5-7e29-4a53-b9b9-d6bd676db395	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mara"},"session":[],"response_status":200,"response":{"data":[]},"duration":219,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:42:03
14621	9d5ebecc-b51d-4e03-9f17-03437bea3ce3	9d5ebecc-e9a8-492f-9bd6-ba48c570deea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-30 10:35:35
14622	9d5ebecc-dff5-42a5-88a2-4c4a749ff383	9d5ebecc-e9a8-492f-9bd6-ba48c570deea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"69.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 10:35:35
14623	9d5ebecc-e098-4952-9105-dc61ab0bccd6	9d5ebecc-e9a8-492f-9bd6-ba48c570deea	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 10:35:35
14624	9d5ebecc-e759-4e5a-8444-5000cd55e660	9d5ebecc-e9a8-492f-9bd6-ba48c570deea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-30 10:35:35
14625	9d5ebecc-e800-4f5f-b8cf-513a60c80306	9d5ebecc-e9a8-492f-9bd6-ba48c570deea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":487,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:35:35
31773	9d69551f-d348-4b51-99f8-e9bec015db76	9d69551f-d453-457e-839d-29f070f29ae0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:55:01.000000Z","deleted_at":null,"user_alias":"eder.cortes"}]},"duration":256,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:54:12
13996	9d5d13f5-b99b-412a-8d67-9614f5dbdd4f	9d5d13f5-bd31-4909-8f77-fb87c91792eb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":136,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:42:03
14626	9d5ebecd-aec0-425a-82e7-6f3b7e398672	9d5ebecd-d3c6-4d65-8080-3df01824fb84	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-30 10:35:36
14627	9d5ebecd-cbb9-4a73-894e-c1584bf88f3b	9d5ebecd-d3c6-4d65-8080-3df01824fb84	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"48.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 10:35:36
14628	9d5ebecd-cc29-444b-b7ac-446c2059ac8f	9d5ebecd-d3c6-4d65-8080-3df01824fb84	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 10:35:36
14629	9d5ebecd-d1f0-4cc8-8385-4adab5188684	9d5ebecd-d3c6-4d65-8080-3df01824fb84	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-30 10:35:36
14630	9d5ebecd-d27c-42b5-b49b-7a4881f5c709	9d5ebecd-d3c6-4d65-8080-3df01824fb84	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":284,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:35:36
31774	9d695523-a374-4139-b991-89f1e100a17b	9d695523-c5f3-4395-aad3-d9f6ae352eea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:54:15
31775	9d695523-bf6f-4115-b3a6-b4c57e1ede5c	9d695523-c5f3-4395-aad3-d9f6ae352eea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"46.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":19,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-04 16:54:15
31776	9d695523-bfc5-4d1c-a453-e1372f1f1eb2	9d695523-c5f3-4395-aad3-d9f6ae352eea	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 16:54:15
31777	9d695523-c495-474d-9fdb-359beadc0010	9d695523-c5f3-4395-aad3-d9f6ae352eea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:54:15
31778	9d695523-c4f6-4d36-9ffd-3153b1262901	9d695523-c5f3-4395-aad3-d9f6ae352eea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:55:01.000000Z","deleted_at":null,"user_alias":"eder.cortes"}]},"duration":303,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:54:15
13997	9d5d13f6-0ec9-4f44-a777-4c1064e438b0	9d5d13f6-29b8-4c65-9b93-409e29f127ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-10-29 14:42:04
13998	9d5d13f6-253d-47ac-b395-ba84d318ac1c	9d5d13f6-29b8-4c65-9b93-409e29f127ff	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mar%' or \\"users\\".\\"user_document\\"::text like '%Mar%') order by \\"users\\".\\"user_document\\" asc","time":"40.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 14:42:04
13999	9d5d13f6-2855-475b-8435-2415ae00f1df	9d5d13f6-29b8-4c65-9b93-409e29f127ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-10-29 14:42:04
14000	9d5d13f6-28ae-4117-b14e-bb5355fdd5f0	9d5d13f6-29b8-4c65-9b93-409e29f127ff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mar"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":222,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:42:04
31779	9d695525-c6b9-43da-80df-267717596d73	9d695526-0f62-4251-8a13-e195e42cdf84	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:54:16
31780	9d695526-09c3-48c3-a38e-9d006fc1e401	9d695526-0f62-4251-8a13-e195e42cdf84	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '18' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"146.74","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":73,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 16:54:16
31781	9d695526-0a15-4911-8602-61be01825ae6	9d695526-0f62-4251-8a13-e195e42cdf84	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 16:54:16
31782	9d695526-0e0e-4992-a67f-318ad253e4cc	9d695526-0f62-4251-8a13-e195e42cdf84	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:54:16
31783	9d695526-0e5b-431b-886b-63be9297aeeb	9d695526-0f62-4251-8a13-e195e42cdf84	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/18","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"}},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:54:16
31943	9d695787-ad96-418a-9c37-3bebd7340a15	9d695788-0450-40db-ac14-4c45a322d77e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 17:00:56
31944	9d695788-01a2-43e8-808d-3e4f4884df2c	9d695788-0450-40db-ac14-4c45a322d77e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 17:00:56
31945	9d695788-02df-4833-a0da-9468274d54ed	9d695788-0450-40db-ac14-4c45a322d77e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":433,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:00:56
14001	9d5d13f6-6ba4-48fd-bdb8-a8d1e7f3e098	9d5d13f6-85c8-433d-b806-0ec8478f55b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-10-29 14:42:04
14002	9d5d13f6-81d0-409f-a69b-0caa3b074c65	9d5d13f6-85c8-433d-b806-0ec8478f55b6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"40.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 14:42:04
14003	9d5d13f6-84a0-4ce7-aad7-7bdb348f83e2	9d5d13f6-85c8-433d-b806-0ec8478f55b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-10-29 14:42:04
14004	9d5d13f6-84e2-452e-b943-44fa0795b550	9d5d13f6-85c8-433d-b806-0ec8478f55b6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":219,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:42:04
31946	9d695788-78b4-4f7d-9d91-13899d9e0d91	9d695788-ce1e-4c62-87a7-84ca9cd67068	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 17:00:56
31947	9d695788-c498-4ef8-8910-ee7c6920d003	9d695788-ce1e-4c62-87a7-84ca9cd67068	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"162.06","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":227,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 17:00:57
31948	9d695788-c517-4f93-bdb8-bcf7bda6a311	9d695788-ce1e-4c62-87a7-84ca9cd67068	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 17:00:57
17107	9d654b13-517a-4609-9d6d-ada96f5fe7da	9d654b13-a065-4ec3-9692-ef4c3dc98cc8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 16:42:48
31784	9d695529-0f40-4744-b8b6-09d95802b9e0	9d695529-31e8-4395-8a35-6dabe5704309	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:54:18
31785	9d695529-2c65-4879-9654-a018abcdf2b8	9d695529-31e8-4395-8a35-6dabe5704309	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"43.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":19,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-04 16:54:18
31786	9d695529-2cbd-4379-b334-30c594945d90	9d695529-31e8-4395-8a35-6dabe5704309	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 16:54:18
31787	9d695529-30a0-41b6-8532-b08cb24778b8	9d695529-31e8-4395-8a35-6dabe5704309	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:54:18
31949	9d695788-cc61-4c89-ba3a-45c152342301	9d695788-ce1e-4c62-87a7-84ca9cd67068	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 17:00:57
31950	9d695788-cced-4dbd-96dd-a673f41d26ff	9d695788-ce1e-4c62-87a7-84ca9cd67068	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":460,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:00:57
14005	9d5d13f6-c9c6-49a5-a6b1-ebf7547ff996	9d5d13f6-e32a-4642-a497-b1cf2e371d1c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-10-29 14:42:04
14006	9d5d13f6-df3c-4493-90bf-e2fbe6df7c94	9d5d13f6-e32a-4642-a497-b1cf2e371d1c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"39.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 14:42:04
14007	9d5d13f6-e1fb-4dbf-a890-a2985cb5ab33	9d5d13f6-e32a-4642-a497-b1cf2e371d1c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-10-29 14:42:04
14008	9d5d13f6-e23c-4d14-a20d-6819df08df0b	9d5d13f6-e32a-4642-a497-b1cf2e371d1c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":224,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:42:04
17108	9d654b13-9ede-4eef-a6ff-ff0336261543	9d654b13-a065-4ec3-9692-ef4c3dc98cc8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 16:42:48
17109	9d654b13-9f7b-4cf7-8b76-eab09c75a6de	9d654b13-a065-4ec3-9692-ef4c3dc98cc8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":415,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:42:48
31788	9d695529-30eb-45c6-9a07-940570b8375c	9d695529-31e8-4395-8a35-6dabe5704309	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:55:01.000000Z","deleted_at":null,"user_alias":"eder.cortes"}]},"duration":292,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:54:18
31951	9d695789-269d-4cbf-ab74-f8968a07b6cb	9d695789-4826-4ce9-91f4-c81d5578b324	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 17:00:57
19261	9d66d2c3-962e-4a32-a81e-59d3745b4d8f	9d66d2c3-bfd8-4b9c-b4c7-133d32231d78	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 10:58:02
19262	9d66d2c3-bd88-4d5a-ac76-6907d74a6c42	9d66d2c3-bfd8-4b9c-b4c7-133d32231d78	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 10:58:02
19263	9d66d2c3-be7f-491d-ba5c-6b02158c133e	9d66d2c3-bfd8-4b9c-b4c7-133d32231d78	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":317,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:58:02
31952	9d695789-424c-4d6c-9321-b0dfc30c5c25	9d695789-4826-4ce9-91f4-c81d5578b324	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":216,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 17:00:57
31953	9d695789-42b5-4a29-aaae-50c1ba7de9bd	9d695789-4826-4ce9-91f4-c81d5578b324	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 17:00:57
31954	9d695789-46c3-48a3-af68-86dd57e79322	9d695789-4826-4ce9-91f4-c81d5578b324	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 17:00:57
31955	9d695789-4718-46d2-bbd0-37ac892af1d6	9d695789-4826-4ce9-91f4-c81d5578b324	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":297,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:00:57
14009	9d5d13f7-4512-4681-8cb7-e1d44efb49be	9d5d13f7-6108-4452-9274-58ff8607a2a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-10-29 14:42:04
14010	9d5d13f7-5c0b-4663-b53d-4b59008521bf	9d5d13f7-6108-4452-9274-58ff8607a2a4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '18' and \\"users\\".\\"deleted_at\\" is null","time":"39.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":55,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-29 14:42:04
14011	9d5d13f7-5c56-4d59-826f-26599f58a624	9d5d13f7-6108-4452-9274-58ff8607a2a4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 14:42:04
14012	9d5d13f7-5fa9-463a-be9f-3bd534a40c3d	9d5d13f7-6108-4452-9274-58ff8607a2a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-10-29 14:42:04
14013	9d5d13f7-5ff9-4ac7-884b-a7249e8394ec	9d5d13f7-6108-4452-9274-58ff8607a2a4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/18","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}},"duration":207,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:42:04
17110	9d654b13-f828-477c-aa5a-47af5a5fd49f	9d654b14-3d56-4424-83b6-cf18f2b0afff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 16:42:48
17111	9d654b14-3894-4c1e-89a0-f50ef16ccdd8	9d654b14-3d56-4424-83b6-cf18f2b0afff	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select ('02-11-2024'::date - l.loans_fecha_ultimo_pago::date) as dis_restantes, \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"147.31","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":42,"hash":"138adb4a6ec64b5d6fafeaaca028ba85","hostname":"EderCortes"}	2024-11-02 16:42:48
17112	9d654b14-3b6f-4be2-8d3e-6838d3412992	9d654b14-3d56-4424-83b6-cf18f2b0afff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 16:42:48
17113	9d654b14-3bf3-4a16-b057-82fc76766794	9d654b14-3d56-4424-83b6-cf18f2b0afff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dis_restantes":31,"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dis_restantes":null,"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":359,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:42:48
19264	9d66d2c4-30e7-49d4-a306-0c45bf7b8b01	9d66d2c4-56b9-422b-b354-830da8b42113	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 10:58:02
19265	9d66d2c4-498e-4bfb-89a7-1a98ca38a159	9d66d2c4-56b9-422b-b354-830da8b42113	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"49.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 10:58:03
19266	9d66d2c4-4f20-4102-be7f-9f1ac328be47	9d66d2c4-56b9-422b-b354-830da8b42113	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"3.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 10:58:03
19267	9d66d2c4-4f6c-457b-8267-120b4f213ece	9d66d2c4-56b9-422b-b354-830da8b42113	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 10:58:03
19268	9d66d2c4-5583-4514-8d2f-cb86954dc355	9d66d2c4-56b9-422b-b354-830da8b42113	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 10:58:03
31789	9d69552d-d439-46f8-a070-398ae6fe673e	9d69552d-f436-408a-b0f4-03e479e326c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:54:21
14014	9d5d1418-6c8b-4beb-bec6-7eee54310ab5	9d5d1418-6f96-443a-9710-b4b19fa78dda	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":162,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:42:26
17114	9d654b16-09a7-4f48-9b0f-82fd1db98e9f	9d654b16-2f56-41e5-a933-3a3c0404134c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 16:42:49
17115	9d654b16-2949-432b-99c1-fa93a8c42f4f	9d654b16-2f56-41e5-a933-3a3c0404134c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 16:42:50
17116	9d654b16-29ac-417c-bd5b-a7d5aed68d38	9d654b16-2f56-41e5-a933-3a3c0404134c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 16:42:50
17117	9d654b16-2dc7-42bf-b7c0-4f8035ece80b	9d654b16-2f56-41e5-a933-3a3c0404134c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:42:50
17118	9d654b16-2e20-486f-a8ac-b6aad7f4a50e	9d654b16-2f56-41e5-a933-3a3c0404134c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":414,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:42:50
19269	9d66d2c4-55d5-4933-908c-a1f48b6aedde	9d66d2c4-56b9-422b-b354-830da8b42113	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T02:27:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"0"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":337,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:58:03
31790	9d69552d-eedf-4c38-a470-cb549e93097b	9d69552d-f436-408a-b0f4-03e479e326c5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '19' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"41.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":73,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 16:54:22
31791	9d69552d-ef33-486a-ad80-9f06e9958d02	9d69552d-f436-408a-b0f4-03e479e326c5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 16:54:22
31792	9d69552d-f2b8-440e-b3ca-a2af7cd9fd52	9d69552d-f436-408a-b0f4-03e479e326c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 16:54:22
31793	9d69552d-f300-4a3e-a6aa-a998dd37a4c7	9d69552d-f436-408a-b0f4-03e479e326c5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/19","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:54:22
31956	9d695789-9f2d-4b51-9b1e-78f2d5f591ae	9d695789-bf51-4289-b8b6-f3c1366cc3ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 17:00:57
31957	9d695789-b9ba-416a-9a17-b4239d107be6	9d695789-bf51-4289-b8b6-f3c1366cc3ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 17:00:57
31958	9d695789-ba14-4855-bca9-242a3a96df13	9d695789-bf51-4289-b8b6-f3c1366cc3ca	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 17:00:57
17119	9d654b43-6503-4ce6-a361-a8d90f1fb52b	9d654b43-b670-40b6-b363-4c1931d53aa8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:43:19
17120	9d654b43-a77d-418e-88ad-3c0275a658fd	9d654b43-b670-40b6-b363-4c1931d53aa8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"158.70","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":259,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 16:43:19
17121	9d654b43-b1ef-4d87-94bf-518a93f7d3af	9d654b43-b670-40b6-b363-4c1931d53aa8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":288,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 16:43:19
17122	9d654b43-b21f-4a37-8760-ceb613670ad1	9d654b43-b670-40b6-b363-4c1931d53aa8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 16:43:19
17123	9d654b43-b557-4a57-b791-e4b188072d07	9d654b43-b670-40b6-b363-4c1931d53aa8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 16:43:19
17124	9d654b43-b597-479d-9b78-fa8b8ca1b75f	9d654b43-b670-40b6-b363-4c1931d53aa8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:34:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"}]}},"duration":401,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:43:19
19270	9d66d2c6-b7c0-49ac-afd1-77e47d1d739a	9d66d2c6-de67-4c82-b890-ccacec227585	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 10:58:04
19271	9d66d2c6-d742-4e0a-b0e5-ca71b0a8fa52	9d66d2c6-de67-4c82-b890-ccacec227585	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"52.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 10:58:04
19272	9d66d2c6-d7af-46be-b54e-d610c3f57543	9d66d2c6-de67-4c82-b890-ccacec227585	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 10:58:04
19273	9d66d2c6-dcd4-433a-8737-2385c307b74a	9d66d2c6-de67-4c82-b890-ccacec227585	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 10:58:04
19274	9d66d2c6-dd36-4f74-a0b0-cf308d61e3f7	9d66d2c6-de67-4c82-b890-ccacec227585	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":472,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:58:04
31794	9d695530-c104-4907-a0ae-134424d63db0	9d695530-e09b-48b5-9f79-f29fd0352309	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 16:54:23
31795	9d695530-dae1-4615-a0cb-9a401157ef8d	9d695530-e09b-48b5-9f79-f29fd0352309	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"37.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":19,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-04 16:54:23
31796	9d695530-db3c-4f14-a234-12148660c83f	9d695530-e09b-48b5-9f79-f29fd0352309	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 16:54:23
31797	9d695530-df54-462a-9be0-b7338506971b	9d695530-e09b-48b5-9f79-f29fd0352309	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 16:54:23
14018	9d5d1432-9a40-4f7d-aa1c-2090304f7a3e	9d5d1432-b9fd-47dd-953a-2d134b909da3	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 14:42:43
14019	9d5d1432-b48b-4907-981f-8153840b0159	9d5d1432-b9fd-47dd-953a-2d134b909da3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"42.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-29 14:42:43
14020	9d5d1432-b86b-4b4f-9620-dea9b1b73a4a	9d5d1432-b9fd-47dd-953a-2d134b909da3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 14:42:43
14021	9d5d1432-b8cc-4ec0-a1f1-ea9d14837847	9d5d1432-b9fd-47dd-953a-2d134b909da3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":340,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:42:43
17125	9d654b4d-26ad-4916-87fd-f9973a235872	9d654b4d-29f3-4691-9fa1-adbf3ed1f6f4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":148,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:43:26
31798	9d695530-df9f-461b-9488-b2b04b749bee	9d695530-e09b-48b5-9f79-f29fd0352309	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:55:01.000000Z","deleted_at":null,"user_alias":"eder.cortes"}]},"duration":283,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:54:23
31959	9d695789-bdbd-4ca0-b4a1-ce67457e0dbd	9d695789-bf51-4289-b8b6-f3c1366cc3ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 17:00:57
31960	9d695789-be1c-4767-9e8f-0232b77c90c2	9d695789-bf51-4289-b8b6-f3c1366cc3ca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":285,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:00:57
14022	9d5d1476-4e66-4ff0-ad4c-da10f326b53b	9d5d1476-51f4-48fd-a61e-dd847cdb80a1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":178,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:43:28
31799	9d695533-737d-426a-81d1-a07822bd979c	9d695533-94bb-4a43-a577-b53b2e73cded	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 16:54:25
31800	9d695533-8f92-4982-aa39-ecc968520c24	9d695533-94bb-4a43-a577-b53b2e73cded	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"44.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":73,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 16:54:25
31801	9d695533-8fe2-48d6-90a6-f73c7987e238	9d695533-94bb-4a43-a577-b53b2e73cded	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 16:54:25
31802	9d695533-931a-41bb-bf07-9e60be1241bc	9d695533-94bb-4a43-a577-b53b2e73cded	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 16:54:25
31803	9d695533-9390-4e65-8cb7-f4633390d847	9d695533-94bb-4a43-a577-b53b2e73cded	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:55:01.000000Z","deleted_at":null,"user_alias":"eder.cortes"}},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:54:25
31961	9d69578b-fdcf-4551-846b-ff685b3b7f36	9d69578c-4c1d-4793-b3ac-1540e8258c7c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 17:00:59
31962	9d69578c-4500-4256-9b68-d14be40ac6f6	9d69578c-4c1d-4793-b3ac-1540e8258c7c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"150.05","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 17:00:59
31963	9d69578c-459a-45f8-ae44-42f862554f1d	9d69578c-4c1d-4793-b3ac-1540e8258c7c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 17:00:59
31964	9d69578c-4a42-41b8-a0a5-d4623648ea82	9d69578c-4c1d-4793-b3ac-1540e8258c7c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 17:00:59
31965	9d69578c-4aae-428f-a236-af424206d1e8	9d69578c-4c1d-4793-b3ac-1540e8258c7c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":544,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:00:59
15621	9d648f65-86e6-4348-b6fd-a9922a006c41	9d648f65-a385-4fe3-8bd2-2aa048bb9163	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 07:58:00
15622	9d648f65-a1d9-45c3-b7da-85472cda4b53	9d648f65-a385-4fe3-8bd2-2aa048bb9163	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 07:58:00
15623	9d648f65-a286-4f9b-8e93-5dde9b1d1a1f	9d648f65-a385-4fe3-8bd2-2aa048bb9163	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-11-02 07:58:00
31804	9d695536-f8d3-4e2c-8835-1de3a8dece6f	9d695537-1756-4059-a43e-55f3b8887ba4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 16:54:27
31805	9d695537-1191-434b-9dde-7c7ad33a0fea	9d695537-1756-4059-a43e-55f3b8887ba4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"40.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":19,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-04 16:54:27
31806	9d695537-11e2-418f-ba4c-95bfb96fb5fc	9d695537-1756-4059-a43e-55f3b8887ba4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 16:54:27
31807	9d695537-15a1-4ab8-ae13-ca031ba40b30	9d695537-1756-4059-a43e-55f3b8887ba4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 16:54:28
31808	9d695537-160b-4288-a986-4ec0b7c7a34d	9d695537-1756-4059-a43e-55f3b8887ba4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:55:01.000000Z","deleted_at":null,"user_alias":"eder.cortes"}]},"duration":289,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:54:28
15624	9d648f66-fb41-44ad-a046-f5c4aa111cc1	9d648f67-1e22-4aef-a51d-b2b8e25c40f3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 07:58:01
15625	9d648f67-18d8-4154-8b32-a3c3726e094d	9d648f67-1e22-4aef-a51d-b2b8e25c40f3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 07:58:01
15626	9d648f67-193b-41ba-81d5-a0f1e052a3a5	9d648f67-1e22-4aef-a51d-b2b8e25c40f3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 07:58:01
15627	9d648f67-1cc7-4720-9b26-bbdfbcf49e92	9d648f67-1e22-4aef-a51d-b2b8e25c40f3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 07:58:01
15628	9d648f67-1d15-45a5-8707-3125a35bef12	9d648f67-1e22-4aef-a51d-b2b8e25c40f3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":434,"memory":22,"hostname":"EderCortes"}	2024-11-02 07:58:01
17133	9d654b4e-4fb2-4b50-8508-07e6b1916a28	9d654b4e-73f2-4e8f-917e-b5d67234a328	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 16:43:26
17134	9d654b4e-6844-4d27-84d6-03ef0308fec3	9d654b4e-73f2-4e8f-917e-b5d67234a328	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"49.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":259,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 16:43:26
17135	9d654b4e-6d0a-41ba-a947-00f08609132e	9d654b4e-73f2-4e8f-917e-b5d67234a328	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":288,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 16:43:26
17136	9d654b4e-6d4e-43b2-b2e6-ab36b4151796	9d654b4e-73f2-4e8f-917e-b5d67234a328	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 16:43:26
17137	9d654b4e-723c-4297-a65c-97c727891c1d	9d654b4e-73f2-4e8f-917e-b5d67234a328	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 16:43:26
17138	9d654b4e-72b7-4ebd-b31e-23160225eaf0	9d654b4e-73f2-4e8f-917e-b5d67234a328	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:34:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"}]}},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:43:26
31809	9d695545-8f42-4176-b2ee-487c9af327bb	9d695545-ac5e-4e62-aedc-c9d5a63b3dcf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 16:54:37
15629	9d648f70-3b44-40e8-9231-edb4b1201e73	9d648f70-544a-462f-b16f-44f9fb5d267f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 07:58:07
15630	9d648f70-5042-4269-a290-7e8e94235e9f	9d648f70-544a-462f-b16f-44f9fb5d267f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"40.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":24,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-11-02 07:58:07
15631	9d648f70-52ef-4c98-b137-b3adbede5666	9d648f70-544a-462f-b16f-44f9fb5d267f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 07:58:07
15632	9d648f70-534b-401f-9905-429976e58d3b	9d648f70-544a-462f-b16f-44f9fb5d267f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":213,"memory":22,"hostname":"EderCortes"}	2024-11-02 07:58:07
31810	9d695545-a77a-4d6b-aeb8-0421e606f9e2	9d695545-ac5e-4e62-aedc-c9d5a63b3dcf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"46.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 16:54:37
31811	9d695545-aacc-4910-bf82-d5e517675e03	9d695545-ac5e-4e62-aedc-c9d5a63b3dcf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 16:54:37
31812	9d695545-ab47-438c-bbcf-c347b3c7cb25	9d695545-ac5e-4e62-aedc-c9d5a63b3dcf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:54:37
15633	9d648f75-ffd5-4b50-a64f-0c02e5ae77d3	9d648f76-4b06-46a9-b2c7-412278a9d01e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 07:58:11
15634	9d648f76-3beb-4deb-ba43-0b201c5b4604	9d648f76-4b06-46a9-b2c7-412278a9d01e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"140.13","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"088d1fdbe045a08c3b0073ef22c7da32","hostname":"EderCortes"}	2024-11-02 07:58:11
15635	9d648f76-4651-4463-835a-7ea56f21edb5	9d648f76-4b06-46a9-b2c7-412278a9d01e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 07:58:11
15636	9d648f76-4686-472f-83da-f3ad91ef9d45	9d648f76-4b06-46a9-b2c7-412278a9d01e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 07:58:11
15637	9d648f76-49d0-49eb-8f7e-8560a01ce759	9d648f76-4b06-46a9-b2c7-412278a9d01e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 07:58:11
15638	9d648f76-4a1d-4ca5-a87b-7503688d4e3d	9d648f76-4b06-46a9-b2c7-412278a9d01e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":399,"memory":22,"hostname":"EderCortes"}	2024-11-02 07:58:11
31813	9d695547-c79f-4126-800c-cafc992e7f8a	9d695547-e6a5-4d5e-a7ca-e68d50da68c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 16:54:38
31814	9d695547-e142-47c7-940a-32f62d48b32a	9d695547-e6a5-4d5e-a7ca-e68d50da68c9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:54:39
31815	9d695547-e194-4132-8413-73127cbd7e08	9d695547-e6a5-4d5e-a7ca-e68d50da68c9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 16:54:39
31816	9d695547-e546-4530-b534-87d3ae9594e3	9d695547-e6a5-4d5e-a7ca-e68d50da68c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 16:54:39
31817	9d695547-e595-4e74-9ba3-0be13c38eb2a	9d695547-e6a5-4d5e-a7ca-e68d50da68c9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":305,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:54:39
15639	9d648f84-2998-4782-a604-ef7fb45c2574	9d648f84-4828-4b21-be3c-070b930dfc39	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 07:58:20
15640	9d648f84-4292-4553-a6f8-a08847accbc1	9d648f84-4828-4b21-be3c-070b930dfc39	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"49.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":24,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-11-02 07:58:21
15641	9d648f84-4669-481f-9229-e11c01f180ac	9d648f84-4828-4b21-be3c-070b930dfc39	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 07:58:21
15642	9d648f84-46f4-465b-97d2-dc263c1fe921	9d648f84-4828-4b21-be3c-070b930dfc39	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-11-02 07:58:21
31818	9d695548-2943-4bfe-916f-938c507a5fc5	9d695548-488d-49fe-9ccd-a683eee2443d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 16:54:39
31819	9d695548-4378-4163-b0ef-045519de8298	9d695548-488d-49fe-9ccd-a683eee2443d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:54:39
31820	9d695548-43c8-4931-8be7-f559469e2314	9d695548-488d-49fe-9ccd-a683eee2443d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 16:54:39
31821	9d695548-4726-44b6-b961-272bc1801eee	9d695548-488d-49fe-9ccd-a683eee2443d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 16:54:39
31822	9d695548-4774-42ed-a72d-e29eecb3ec8b	9d695548-488d-49fe-9ccd-a683eee2443d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:54:39
15643	9d648f85-bfbf-4fe5-8800-e9e17d442cd9	9d648f86-0498-4cde-a9a6-193386cad0bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 07:58:21
15644	9d648f85-ffa4-4af2-830e-2a68adfca48f	9d648f86-0498-4cde-a9a6-193386cad0bf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"150.63","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-02 07:58:22
15645	9d648f86-0345-4b22-bdc3-6dad7a3d847b	9d648f86-0498-4cde-a9a6-193386cad0bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 07:58:22
15646	9d648f86-039c-4a92-99f9-76f37c03445d	9d648f86-0498-4cde-a9a6-193386cad0bf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":375,"memory":22,"hostname":"EderCortes"}	2024-11-02 07:58:22
15647	9d648f8a-f3f0-4cf9-92a6-66b6442b422a	9d648f8b-3ae2-4d44-84cd-898bf36129d4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 07:58:25
15648	9d648f8b-3552-4a85-a498-abb3079e55de	9d648f8b-3ae2-4d44-84cd-898bf36129d4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"145.65","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-02 07:58:25
15649	9d648f8b-35cb-4052-9615-2b3a2fe6af7b	9d648f8b-3ae2-4d44-84cd-898bf36129d4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-02 07:58:25
15650	9d648f8b-39a4-4f35-9c5f-76dc3bffe505	9d648f8b-3ae2-4d44-84cd-898bf36129d4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-02 07:58:25
15651	9d648f8b-39f3-4e15-9056-a10902faee25	9d648f8b-3ae2-4d44-84cd-898bf36129d4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":338,"memory":22,"hostname":"EderCortes"}	2024-11-02 07:58:25
32101	9d695ca9-1fc6-4f44-b904-2bf66e135cce	9d695ca9-42cf-494e-a65d-117f1f08f56f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 17:15:17
32102	9d695ca9-4125-414e-af4c-a5e4d38bb310	9d695ca9-42cf-494e-a65d-117f1f08f56f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 17:15:17
32103	9d695ca9-41d0-48f2-8481-6800f539d33c	9d695ca9-42cf-494e-a65d-117f1f08f56f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":282,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:15:17
22926	9d67fd91-baac-47eb-b0ee-d46f275666fe	9d67fd91-df04-42f5-a770-bde8cf442ba2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 00:53:33
22927	9d67fd91-dd4c-4563-85ab-64ff0cb3c0bf	9d67fd91-df04-42f5-a770-bde8cf442ba2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 00:53:33
22928	9d67fd91-dded-4235-9d53-31ac2c4c3fea	9d67fd91-df04-42f5-a770-bde8cf442ba2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":342,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:53:33
17211	9d65502a-5a99-46bc-a78a-9a897ae6c885	9d65502a-7b82-4234-a86f-3a304d8133c1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 16:57:02
17212	9d65502a-79ae-483e-ac17-5b9404ed2da9	9d65502a-7b82-4234-a86f-3a304d8133c1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 16:57:02
17213	9d65502a-7a69-43ff-b081-5e828abe771b	9d65502a-7b82-4234-a86f-3a304d8133c1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:57:02
34360	9d69be1a-5812-43a0-94db-c32b9e9559c9	9d69be1a-7c46-431f-89d3-09d53d3fd6e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:47:45
34361	9d69be1a-79f2-4bad-b507-28cce79590b8	9d69be1a-7c46-431f-89d3-09d53d3fd6e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:47:45
22929	9d67fd92-518d-4b35-bcf8-c2008225b7fc	9d67fd92-749c-4152-a0c4-4e42c7126616	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 00:53:34
34362	9d69be1a-7b45-4c8f-98f6-67cbdad3585c	9d69be1a-7c46-431f-89d3-09d53d3fd6e4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":312,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:47:45
17214	9d65502a-cc23-4278-8434-def42e8251e8	9d65502a-e75b-4ef2-82b5-fe0ad2ab486d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 16:57:02
17215	9d65502a-e2f8-4cb5-a3da-f858def59ef7	9d65502a-e75b-4ef2-82b5-fe0ad2ab486d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"41.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":46,"hash":"fb4ded687569d92428336ceae5c6ffcd","hostname":"EderCortes"}	2024-11-02 16:57:02
17216	9d65502a-e61f-41ff-b952-bd3c361e27ec	9d65502a-e75b-4ef2-82b5-fe0ad2ab486d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 16:57:02
17217	9d65502a-e675-4630-a9ec-f4cf8f0fe1c6	9d65502a-e75b-4ef2-82b5-fe0ad2ab486d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:57:02
22930	9d67fd92-6a31-46b8-ae7e-ff42fd17aed9	9d67fd92-749c-4152-a0c4-4e42c7126616	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 70\\n                        ","time":"45.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"40345ecc36d5b014fbb2cca663c7c347","hostname":"EderCortes"}	2024-11-04 00:53:34
22931	9d67fd92-6e83-4a8e-a3c8-055bf6e0a0e1	9d67fd92-749c-4152-a0c4-4e42c7126616	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '70' order by \\"item_loans\\".\\"id\\" asc","time":"2.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 00:53:34
22932	9d67fd92-6eca-4ce3-91c8-51178893cf38	9d67fd92-749c-4152-a0c4-4e42c7126616	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 00:53:34
22933	9d67fd92-7362-48e7-a01c-5654a23a7f0a	9d67fd92-749c-4152-a0c4-4e42c7126616	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 00:53:34
22934	9d67fd92-73b2-46b1-8bcb-fd5c1eaed2b7	9d67fd92-749c-4152-a0c4-4e42c7126616	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/70","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":70,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":2150000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"430000","loans_pago_interes":"107500"},"items":[{"id":248,"loans_codigo":70,"itemloans_cuota":"1","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:52:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"107500","itemloans_cuota_cancelada":"430000"},{"id":249,"loans_codigo":70,"itemloans_cuota":"2","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":250,"loans_codigo":70,"itemloans_cuota":"3","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":251,"loans_codigo":70,"itemloans_cuota":"4","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":252,"loans_codigo":70,"itemloans_cuota":"5","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":272,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:53:34
34363	9d69be1a-dc4c-4aff-9d41-630201947f4d	9d69be1a-fe85-4074-bc5b-281f4072d785	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:47:45
34364	9d69be1a-f71f-4e51-850c-7655020bd6e1	9d69be1a-fe85-4074-bc5b-281f4072d785	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:47:45
34365	9d69be1a-f79a-43d8-8d71-2b7c98efde10	9d69be1a-fe85-4074-bc5b-281f4072d785	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:47:45
17218	9d65502c-a793-41e8-b889-16dba66bc958	9d65502c-c373-4b88-bb9c-4f482f22fbdb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 16:57:03
17219	9d65502c-be50-4a0e-828f-f792f4f4a9cb	9d65502c-c373-4b88-bb9c-4f482f22fbdb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"38.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 16:57:03
17220	9d65502c-be9e-46a0-9ee1-e9284c41b15f	9d65502c-c373-4b88-bb9c-4f482f22fbdb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 16:57:03
17221	9d65502c-c218-484f-93cd-ee52fab4d794	9d65502c-c373-4b88-bb9c-4f482f22fbdb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 16:57:03
17222	9d65502c-c26a-44fb-bc7c-bc399be98d85	9d65502c-c373-4b88-bb9c-4f482f22fbdb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:57:03
22935	9d67fd94-4406-40db-a062-4faf048be67b	9d67fd94-65e1-4418-a2c5-8d706b962178	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 00:53:35
22936	9d67fd94-5fa5-4adf-8c3c-c85e95aefd20	9d67fd94-65e1-4418-a2c5-8d706b962178	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"47.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 00:53:35
22937	9d67fd94-5ff9-4946-a06f-3bff10fe95cc	9d67fd94-65e1-4418-a2c5-8d706b962178	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 00:53:35
22938	9d67fd94-643e-430a-9f01-37514e484121	9d67fd94-65e1-4418-a2c5-8d706b962178	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 00:53:35
22939	9d67fd94-64ad-4779-8966-e525870bd19d	9d67fd94-65e1-4418-a2c5-8d706b962178	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":439,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:53:35
34366	9d69be1a-fd03-4971-8edc-c37afc892276	9d69be1a-fe85-4074-bc5b-281f4072d785	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 21:47:45
34367	9d69be1a-fd6b-4ec4-820a-b1594daf9a53	9d69be1a-fe85-4074-bc5b-281f4072d785	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":283,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:47:45
22940	9d67fdee-0998-42a0-8dd0-a6870d0ccf40	9d67fdee-0ce9-413a-b3d8-977701753b5c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":176,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:54:34
34368	9d69be1b-4934-48e9-939d-1271fac15fc9	9d69be1b-68c7-4042-b221-de30f26d78ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 21:47:45
34369	9d69be1b-6352-47b8-84f7-2c83f82b9899	9d69be1b-68c7-4042-b221-de30f26d78ed	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 21:47:45
34370	9d69be1b-63a5-43a8-99ab-3c3bea668240	9d69be1b-68c7-4042-b221-de30f26d78ed	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 21:47:45
34371	9d69be1b-67a9-4b58-8625-98782e8df9d8	9d69be1b-68c7-4042-b221-de30f26d78ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 21:47:45
34372	9d69be1b-67f9-4731-9c71-bd015217a253	9d69be1b-68c7-4042-b221-de30f26d78ed	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:47:45
34373	9d69be1b-be62-45fc-bf7a-0f8807324c72	9d69be1c-0c4b-43bf-9a6b-b2c7dff5b03d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 21:47:46
34374	9d69be1c-068f-47ab-9290-2bc60abdca7d	9d69be1c-0c4b-43bf-9a6b-b2c7dff5b03d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"156.43","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:47:46
13268	9d5cfc8f-57b5-4557-96cd-d70f034161f2	9d5cfc8f-99f4-473b-b0e3-2c177b78a270	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 13:36:38
13269	9d5cfc8f-9760-492c-ba91-18c854a7b9fa	9d5cfc8f-99f4-473b-b0e3-2c177b78a270	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 13:36:38
13270	9d5cfc8f-987a-4312-b9fc-7f81d0aeb380	9d5cfc8f-99f4-473b-b0e3-2c177b78a270	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":469,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:36:38
19351	9d66d5be-42b6-4177-b2c3-df062b649096	9d66d5be-6042-45da-8f9b-068d3b7ad70b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 11:06:22
19352	9d66d5be-5e6f-4e21-b6c9-90ed61369665	9d66d5be-6042-45da-8f9b-068d3b7ad70b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 11:06:22
19353	9d66d5be-5f40-4c4e-bae8-13fcf18e95b2	9d66d5be-6042-45da-8f9b-068d3b7ad70b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":224,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:06:22
34375	9d69be1c-06ec-423d-88f0-331521ff5839	9d69be1c-0c4b-43bf-9a6b-b2c7dff5b03d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:47:46
34376	9d69be1c-0af8-4fee-957b-92e6ebfbf547	9d69be1c-0c4b-43bf-9a6b-b2c7dff5b03d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 21:47:46
34377	9d69be1c-0b55-4a02-90eb-ef4f3a858e28	9d69be1c-0c4b-43bf-9a6b-b2c7dff5b03d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":404,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:47:46
34601	9d69bf06-426d-4e85-a5c3-648d065cf96a	9d69bf06-6698-4a2c-8fb5-77cdabc633b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 21:50:19
34602	9d69bf06-64c7-4886-bb49-dac2278817a9	9d69bf06-6698-4a2c-8fb5-77cdabc633b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 21:50:19
34603	9d69bf06-657e-436c-9800-0416518f1a5b	9d69bf06-6698-4a2c-8fb5-77cdabc633b3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":305,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:50:19
13271	9d5cfc90-48c7-466f-82df-b6a1aac73980	9d5cfc90-7c33-4881-bee4-ee420b3f9c20	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 13:36:38
13272	9d5cfc90-73c7-4404-aa33-bb9e09797d68	9d5cfc90-7c33-4881-bee4-ee420b3f9c20	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"64.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 13:36:38
13273	9d5cfc90-744c-4f7d-b16e-520e3b91b947	9d5cfc90-7c33-4881-bee4-ee420b3f9c20	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 13:36:38
13274	9d5cfc90-7aa6-406b-af33-b1ebc25e4f0b	9d5cfc90-7c33-4881-bee4-ee420b3f9c20	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 13:36:38
13275	9d5cfc90-7b01-418b-a680-099b90d91a47	9d5cfc90-7c33-4881-bee4-ee420b3f9c20	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":527,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:36:38
19354	9d66d5be-ae05-4d3f-88c3-9bcf9445d820	9d66d5be-cc6d-47cd-92ec-e0d201ac60b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 11:06:22
19355	9d66d5be-c2ae-420e-9160-298ae25da0d2	9d66d5be-cc6d-47cd-92ec-e0d201ac60b9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"41.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 11:06:22
19356	9d66d5be-c6fa-4f41-8ee1-48837175b0d7	9d66d5be-cc6d-47cd-92ec-e0d201ac60b9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"1.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:06:22
19357	9d66d5be-c738-4b3b-bbb8-e5e27581ba6b	9d66d5be-cc6d-47cd-92ec-e0d201ac60b9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:06:22
19358	9d66d5be-cb29-429d-91ce-0d3733b43835	9d66d5be-cc6d-47cd-92ec-e0d201ac60b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 11:06:22
19359	9d66d5be-cb76-4f04-b409-8c817db4c8cf	9d66d5be-cc6d-47cd-92ec-e0d201ac60b9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T02:27:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"0"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":224,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:06:22
22955	9d67fedb-ef85-4ab6-b83c-5a56c63459e6	9d67fedb-f3cb-4470-8f6f-bf5e04679f3d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":205,"memory":20,"hostname":"EderCortes"}	2024-11-04 00:57:10
34378	9d69be1c-592a-40a1-9b07-a8ab0ba6aaac	9d69be1c-a3f5-4ccb-b51c-e193c8e1b78d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 21:47:46
34604	9d69bf06-ca9a-426f-a36f-3d82619f3bc4	9d69bf07-1b2e-4b76-a3bd-a68b35e200bf	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 21:50:20
34605	9d69bf07-130b-4d9c-9781-8615df87d8a8	9d69bf07-1b2e-4b76-a3bd-a68b35e200bf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"141.90","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":257,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:50:20
34606	9d69bf07-1391-4f21-bb21-7471192535e4	9d69bf07-1b2e-4b76-a3bd-a68b35e200bf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:50:20
13276	9d5cfc90-eeba-4183-8249-5cc45d8a316b	9d5cfc91-190a-4ca7-8db5-7cd969f40dff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 13:36:39
13277	9d5cfc91-11de-4d87-bbb0-fd60335d383c	9d5cfc91-190a-4ca7-8db5-7cd969f40dff	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"52.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 13:36:39
13278	9d5cfc91-1254-4d7c-8f4c-5d87862cc602	9d5cfc91-190a-4ca7-8db5-7cd969f40dff	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 13:36:39
13279	9d5cfc91-1758-44d1-9e18-e16913f3c51a	9d5cfc91-190a-4ca7-8db5-7cd969f40dff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 13:36:39
13280	9d5cfc91-17b7-4bf2-9dd5-c528b3297dc1	9d5cfc91-190a-4ca7-8db5-7cd969f40dff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":381,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:36:39
19360	9d66d5c0-7d9e-4654-bea0-adb27fbfa33e	9d66d5c0-9927-45b9-9454-2b03bc8e0795	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 11:06:23
15764	9d64af6a-9315-4dd5-a742-e2f619b0dda7	9d64af6a-e11a-4c40-98d3-1e935c22dc1c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 09:27:32
15765	9d64af6a-df68-4766-b358-d572fdfbfd9b	9d64af6a-e11a-4c40-98d3-1e935c22dc1c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 09:27:33
15766	9d64af6a-e00f-4c9d-890c-e2e1ce7302b6	9d64af6a-e11a-4c40-98d3-1e935c22dc1c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":396,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:27:33
19361	9d66d5c0-947a-47d3-a528-9202dfc1b970	9d66d5c0-9927-45b9-9454-2b03bc8e0795	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:06:23
19362	9d66d5c0-94c2-4c93-a192-e262b63432ec	9d66d5c0-9927-45b9-9454-2b03bc8e0795	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:06:23
19363	9d66d5c0-97e5-4715-865a-f2f086ce0e60	9d66d5c0-9927-45b9-9454-2b03bc8e0795	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 11:06:23
19364	9d66d5c0-9826-4981-9c93-675e60e9dd9f	9d66d5c0-9927-45b9-9454-2b03bc8e0795	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":259,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:06:23
34379	9d69be1c-9d13-4213-b684-cb5268e8ba86	9d69be1c-a3f5-4ccb-b51c-e193c8e1b78d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_valor_prestado\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"loans_inicio_pago\\", \\"user_creador\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\" from \\"loans\\" where \\"id\\" = '93' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"148.95","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":229,"hash":"791d750d4c6b9ac54b3081f6e0f634ea","hostname":"EderCortes"}	2024-11-04 21:47:46
34380	9d69be1c-9d66-45e9-a688-a8eb96a75966	9d69be1c-a3f5-4ccb-b51c-e193c8e1b78d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 21:47:46
34381	9d69be1c-9f38-4a49-b41c-9aa133552de6	9d69be1c-a3f5-4ccb-b51c-e193c8e1b78d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"2.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":230,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 21:47:46
34382	9d69be1c-9f75-4be5-9ed7-a967a8237c19	9d69be1c-a3f5-4ccb-b51c-e193c8e1b78d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 21:47:46
34383	9d69be1c-a2c4-4c71-9509-52dd96a7677b	9d69be1c-a3f5-4ccb-b51c-e193c8e1b78d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 21:47:46
34607	9d69bf07-196f-4874-8937-9199f792c5dc	9d69bf07-1b2e-4b76-a3bd-a68b35e200bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:50:20
13281	9d5cfc91-9471-405e-81e5-26ded03f55dc	9d5cfc91-c433-4c2d-82b1-d2e52decd678	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 13:36:39
13282	9d5cfc91-b935-4042-81a7-392d13220afb	9d5cfc91-c433-4c2d-82b1-d2e52decd678	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"68.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 13:36:39
13283	9d5cfc91-b9c6-43eb-8b67-9a9d4edad99f	9d5cfc91-c433-4c2d-82b1-d2e52decd678	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 13:36:39
13284	9d5cfc91-c22a-4ac9-aac6-64bc37e37e93	9d5cfc91-c433-4c2d-82b1-d2e52decd678	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 13:36:39
13285	9d5cfc91-c2c0-4060-bcc8-4bff8679705a	9d5cfc91-c433-4c2d-82b1-d2e52decd678	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":423,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:36:39
15767	9d64af6b-423f-4b94-8226-26550b7ef759	9d64af6b-687a-4e22-b2cd-c8fca06ebe06	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 09:27:33
15768	9d64af6b-5de5-4548-b205-905d23611b6b	9d64af6b-687a-4e22-b2cd-c8fca06ebe06	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"54.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"088d1fdbe045a08c3b0073ef22c7da32","hostname":"EderCortes"}	2024-11-02 09:27:33
15769	9d64af6b-6212-41a6-84fd-8a9a10a31035	9d64af6b-687a-4e22-b2cd-c8fca06ebe06	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:27:33
15770	9d64af6b-6253-4d12-8736-8aa2a7cbe1fa	9d64af6b-687a-4e22-b2cd-c8fca06ebe06	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 09:27:33
15771	9d64af6b-6746-4a00-b2b9-e622356eb355	9d64af6b-687a-4e22-b2cd-c8fca06ebe06	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 09:27:33
15772	9d64af6b-679c-416f-882e-2e406ffb4ed3	9d64af6b-687a-4e22-b2cd-c8fca06ebe06	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":301,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:27:33
34384	9d69be1c-a30c-4d0b-b9ca-08935695d472	9d69be1c-a3f5-4ccb-b51c-e193c8e1b78d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","user_creador":12,"loans_pago_prestado":"1000000","loans_pago_interes":"250000"},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:19:45.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:22:30.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":399,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":400,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":401,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":402,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"}]}},"duration":375,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:47:46
13286	9d5cfc93-00b4-4863-8367-ddee3bc48b01	9d5cfc93-52a0-4f7c-ace0-1975512564cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 13:36:40
13287	9d5cfc93-4cb2-4d25-bc9c-f12db7576744	9d5cfc93-52a0-4f7c-ace0-1975512564cf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"166.28","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 13:36:40
13288	9d5cfc93-4d22-4b7c-a912-b35e14a316c9	9d5cfc93-52a0-4f7c-ace0-1975512564cf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 13:36:40
13289	9d5cfc93-5116-42e0-b9c6-048aa22bdf2c	9d5cfc93-52a0-4f7c-ace0-1975512564cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 13:36:40
13290	9d5cfc93-517e-4b28-a8d6-8651b57774b4	9d5cfc93-52a0-4f7c-ace0-1975512564cf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":611,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:36:40
15773	9d64af6d-0418-412f-a81b-eb71dfbac4cf	9d64af6d-221c-420b-8409-0a21594bde81	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 09:27:34
15774	9d64af6d-1cd7-433c-963c-5212104066c7	9d64af6d-221c-420b-8409-0a21594bde81	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 09:27:34
15775	9d64af6d-1d31-4f65-a6be-49f2e75ecb57	9d64af6d-221c-420b-8409-0a21594bde81	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 09:27:34
15776	9d64af6d-20ba-43ef-be55-b17a4d7572a6	9d64af6d-221c-420b-8409-0a21594bde81	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 09:27:34
15777	9d64af6d-210a-4f71-ade2-ec1ab3a90821	9d64af6d-221c-420b-8409-0a21594bde81	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":366,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:27:34
34385	9d69be1e-6f1c-469a-a047-276f8ff5fcb5	9d69be1e-a615-46be-ad29-c43cd0e74c53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 21:47:47
23189	9d688d13-a8c6-4a53-af9d-32f1484dc164	9d688d13-d781-4b6f-911f-0cf9676e0ac5	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 07:34:50
23190	9d688d13-d54a-4a36-81e1-2b639e05fab0	9d688d13-d781-4b6f-911f-0cf9676e0ac5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 07:34:50
23191	9d688d13-d649-41bc-af7b-f3b9c39a3230	9d688d13-d781-4b6f-911f-0cf9676e0ac5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:34:50
34386	9d69be1e-a02f-46a1-a4f4-b0a0a82eae9a	9d69be1e-a615-46be-ad29-c43cd0e74c53	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"91.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:47:48
34387	9d69be1e-a0a8-47f4-b3c9-c4319e79fe65	9d69be1e-a615-46be-ad29-c43cd0e74c53	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:47:48
34388	9d69be1e-a4a8-4dcb-8a62-5b3a8a6be56b	9d69be1e-a615-46be-ad29-c43cd0e74c53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 21:47:48
13291	9d5cfc97-e76f-4981-b003-ccc0b051faaf	9d5cfc97-eab3-4f61-a9ca-708289f775f8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":161,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:36:43
22970	9d67ff0c-b9f3-4242-88b4-6c2cc705a53d	9d67ff0c-bf2b-4b10-81c4-5ad0cd6ae33f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":256,"memory":20,"hostname":"EderCortes"}	2024-11-04 00:57:42
23192	9d688d14-6202-43ca-8445-4aa08c47352a	9d688d14-8bd1-4c6d-8ff8-02e0a4dc25f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 07:34:50
23193	9d688d14-7d33-449b-b493-ee06dd9a5cbc	9d688d14-8bd1-4c6d-8ff8-02e0a4dc25f9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 70\\n                        ","time":"51.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"40345ecc36d5b014fbb2cca663c7c347","hostname":"EderCortes"}	2024-11-04 07:34:50
23194	9d688d14-8260-46ab-8f23-597e65f4b1a7	9d688d14-8bd1-4c6d-8ff8-02e0a4dc25f9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '70' order by \\"item_loans\\".\\"id\\" asc","time":"2.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 07:34:50
23195	9d688d14-82b9-4bd1-9b2e-91b0de77c126	9d688d14-8bd1-4c6d-8ff8-02e0a4dc25f9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 07:34:50
23196	9d688d14-89ed-47f5-af5a-5924db3cbe50	9d688d14-8bd1-4c6d-8ff8-02e0a4dc25f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 07:34:50
23197	9d688d14-8a88-466c-bf6e-97064422a550	9d688d14-8bd1-4c6d-8ff8-02e0a4dc25f9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/70","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":70,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":2150000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"430000","loans_pago_interes":"107500"},"items":[{"id":248,"loans_codigo":70,"itemloans_cuota":"1","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:52:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"107500","itemloans_cuota_cancelada":"430000"},{"id":249,"loans_codigo":70,"itemloans_cuota":"2","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":250,"loans_codigo":70,"itemloans_cuota":"3","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":251,"loans_codigo":70,"itemloans_cuota":"4","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":252,"loans_codigo":70,"itemloans_cuota":"5","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":379,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:34:50
34389	9d69be1e-a4f5-4357-a8d3-0d638a4df9d4	9d69be1e-a615-46be-ad29-c43cd0e74c53	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":594,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:47:48
13292	9d5cfc98-5dbd-4a18-ade7-698b35a2fedd	9d5cfc98-6095-4a4f-b5a3-d43bf3563750	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":128,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:36:43
23198	9d688d16-adbc-412a-8667-c9aae4bae698	9d688d17-0146-4ab6-abf2-2ba54dec8cc0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 07:34:52
23199	9d688d16-f8fd-4553-816d-03cf8277be67	9d688d17-0146-4ab6-abf2-2ba54dec8cc0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"160.65","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 07:34:52
23200	9d688d16-f97d-4cc4-952e-da6a6653364f	9d688d17-0146-4ab6-abf2-2ba54dec8cc0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 07:34:52
23201	9d688d16-fff1-4caf-8248-40f1025f9430	9d688d17-0146-4ab6-abf2-2ba54dec8cc0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 07:34:52
23202	9d688d17-0038-4e6b-8ed5-c785e189d10e	9d688d17-0146-4ab6-abf2-2ba54dec8cc0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":438,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:34:52
32744	9d6989a6-466b-4123-97f0-cd1add4b7ae6	9d6989a6-94a8-48e1-b77d-8f2a6695febc	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 19:21:05
32745	9d6989a6-914d-4a1b-92f5-f7dca2980c33	9d6989a6-94a8-48e1-b77d-8f2a6695febc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 19:21:05
32746	9d6989a6-92f1-4d4b-9448-7a9c6356f7bf	9d6989a6-94a8-48e1-b77d-8f2a6695febc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":777,"memory":22,"hostname":"EderCortes"}	2024-11-04 19:21:05
13293	9d5cfc98-ab24-4a86-83ca-d098271b95a5	9d5cfc98-ae20-4d64-ae67-bc9184534b2c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":132,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:36:44
22985	9d67ffed-f476-4557-ab92-148f242fa7df	9d67ffed-fa16-4d63-ad2c-2752740e3ece	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":234,"memory":20,"hostname":"EderCortes"}	2024-11-04 01:00:09
23203	9d688d25-6836-435c-8761-22a47eb4fe75	9d688d25-6b58-4555-9a6b-df7d0b04fc06	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":236,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:35:01
32747	9d6989a7-8698-40c8-8522-269bf707fde8	9d6989a7-b8aa-4285-b78d-d81439761d46	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 19:21:05
32748	9d6989a7-abc7-45b9-9478-10eda00ea4ef	9d6989a7-b8aa-4285-b78d-d81439761d46	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 91\\n                        ","time":"65.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"9ae30bc69b6b272f3f51ff48e54319f5","hostname":"EderCortes"}	2024-11-04 19:21:05
32749	9d6989a7-afe6-44a8-a390-cbc241eb168f	9d6989a7-b8aa-4285-b78d-d81439761d46	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '91' order by \\"item_loans\\".\\"id\\" asc","time":"3.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 19:21:05
32750	9d6989a7-b6e4-4119-8775-c4ffca92717d	9d6989a7-b8aa-4285-b78d-d81439761d46	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 19:21:05
32751	9d6989a7-b76c-4c5c-8f3a-da5e58e95b19	9d6989a7-b8aa-4285-b78d-d81439761d46	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/91","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":91,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":8,"loans_valor_prestado":5000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"800000","loans_pago_interes":"200000","user_alias":"eder.cortes"},"items":[{"id":371,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 17:44:55","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"200000","itemloans_cuota_cancelada":"800000","user_alias":"eder.cortes"},{"id":403,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":404,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":405,"loans_codigo":91,"itemloans_cuota":"3","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":406,"loans_codigo":91,"itemloans_cuota":"4","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":407,"loans_codigo":91,"itemloans_cuota":"5","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":408,"loans_codigo":91,"itemloans_cuota":"6","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":409,"loans_codigo":91,"itemloans_cuota":"7","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":410,"loans_codigo":91,"itemloans_cuota":"8","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-03-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":528,"memory":22,"hostname":"EderCortes"}	2024-11-04 19:21:05
13294	9d5cfc99-2333-4e21-94f4-3b5883495af9	9d5cfc99-2632-4b0a-a79a-d13115664523	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":131,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:36:44
23204	9d688d26-200a-4b9e-88c2-a8a3c18111eb	9d688d26-445f-4e57-87f0-659e17268791	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 07:35:02
23205	9d688d26-365a-4f39-ae05-d227ced63af3	9d688d26-445f-4e57-87f0-659e17268791	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 70 limit 1","time":"2.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":498,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 07:35:02
23206	9d688d26-36b3-4096-b7b3-fb7595600c66	9d688d26-445f-4e57-87f0-659e17268791	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":2,"hostname":"EderCortes"}	2024-11-04 07:35:02
23207	9d688d26-37eb-44f9-aa97-2f8e9785c046	9d688d26-445f-4e57-87f0-659e17268791	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 247500, \\"loans_pago_prestado\\" = 990000, \\"updated_at\\" = '2024-11-04 07:35:02' where \\"id\\" = 70","time":"0.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":556,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 07:35:02
23208	9d688d26-3853-4d21-815d-0182b545c842	9d688d26-445f-4e57-87f0-659e17268791	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:70","changes":{"updated_at":"2024-11-04 07:35:02","loans_pago_interes":247500,"loans_pago_prestado":990000},"hostname":"EderCortes"}	2024-11-04 07:35:02
23209	9d688d26-39cd-4769-bc3c-e72b08cd9059	9d688d26-445f-4e57-87f0-659e17268791	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 70 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"2.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":563,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 07:35:02
23210	9d688d26-3a02-467c-b1e1-b21f583880d2	9d688d26-445f-4e57-87f0-659e17268791	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 07:35:02
23211	9d688d26-3a7f-46b5-8979-3958723342a8	9d688d26-445f-4e57-87f0-659e17268791	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = 140000, \\"itemloans_cuota_cancelada\\" = 560000, \\"updated_at\\" = '2024-11-04 07:35:02' where \\"id\\" = 249","time":"0.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":570,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 07:35:02
23212	9d688d26-3aac-4516-bf0d-606e1ceb90b2	9d688d26-445f-4e57-87f0-659e17268791	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:249","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 07:35:02","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":140000,"itemloans_cuota_cancelada":560000},"hostname":"EderCortes"}	2024-11-04 07:35:02
23213	9d688d26-3b12-4338-b3ff-b316b1a7b569	9d688d26-445f-4e57-87f0-659e17268791	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select count(*) as aggregate from \\"item_loans\\" where \\"loans_codigo\\" = 70 and \\"itemloans_status\\" = 'Pagada'","time":"0.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":578,"hash":"60bd91eaa209a639fc2e8afc20430a4b","hostname":"EderCortes"}	2024-11-04 07:35:02
23214	9d688d26-3b6c-47ee-b6eb-db1ec3c3d136	9d688d26-445f-4e57-87f0-659e17268791	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"delete from \\"item_loans\\" where \\"loans_codigo\\" = 70 and \\"itemloans_status\\" = 'Pendiente'","time":"0.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":602,"hash":"89bf3c496a8b0746ff5d1219b8dc29e3","hostname":"EderCortes"}	2024-11-04 07:35:02
23215	9d688d26-3bc6-40cf-9863-baf7b62c676e	9d688d26-445f-4e57-87f0-659e17268791	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 70 limit 1","time":"0.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":605,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 07:35:02
23216	9d688d26-3d34-447c-9fda-a62488a91158	9d688d26-445f-4e57-87f0-659e17268791	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (70, 3, 386666.66666667, 96666.666666667, 'Pendiente', 'Se realiza abono', '12-11-2024', 12, 140000, 560000, '2024-11-04 07:35:02', '2024-11-04 07:35:02')","time":"2.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":673,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 07:35:02
23217	9d688d26-3d73-43f8-bc98-8fa149ddd315	9d688d26-445f-4e57-87f0-659e17268791	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 07:35:02
23218	9d688d26-3e0a-4d24-98b1-7c5e418c0c27	9d688d26-445f-4e57-87f0-659e17268791	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (70, 4, 386666.66666667, 96666.666666667, 'Pendiente', 'Se realiza abono', '20-11-2024', 12, 140000, 560000, '2024-11-04 07:35:02', '2024-11-04 07:35:02')","time":"0.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":673,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 07:35:02
23219	9d688d26-3e37-4a93-aaf6-5ab2c4722fc7	9d688d26-445f-4e57-87f0-659e17268791	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 07:35:02
13295	9d5cfc99-75f8-46b5-8710-92906924c4da	9d5cfc99-9099-4fe1-8bda-cdd628083fd7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 13:36:44
13296	9d5cfc99-8c92-4e26-b8a9-29c83bffaf95	9d5cfc99-9099-4fe1-8bda-cdd628083fd7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"41.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 13:36:44
13297	9d5cfc99-8f47-4940-a892-9d625422ac82	9d5cfc99-9099-4fe1-8bda-cdd628083fd7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 13:36:44
13298	9d5cfc99-8f89-4da3-b2a3-43bd368ee198	9d5cfc99-9099-4fe1-8bda-cdd628083fd7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":216,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:36:44
23220	9d688d26-3ec6-49ff-a5a9-cdc4f653203c	9d688d26-445f-4e57-87f0-659e17268791	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (70, 5, 386666.66666667, 96666.666666667, 'Pendiente', 'Se realiza abono', '28-11-2024', 12, 140000, 560000, '2024-11-04 07:35:02', '2024-11-04 07:35:02')","time":"0.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":673,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 07:35:02
23221	9d688d26-3ef7-4932-b387-f09b18a91422	9d688d26-445f-4e57-87f0-659e17268791	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 07:35:02
19441	9d66d67c-fba7-4919-a3bd-219f0e3a4382	9d66d67d-4333-4f1a-8979-cb0a03e56e98	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 11:08:27
19442	9d66d67d-41a5-4265-bc4b-bf2d63042b35	9d66d67d-4333-4f1a-8979-cb0a03e56e98	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 11:08:27
19443	9d66d67d-4238-4c98-9460-329d2e98b316	9d66d67d-4333-4f1a-8979-cb0a03e56e98	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:08:27
23222	9d688d26-42f8-42dd-b480-b2690ab2d413	9d688d26-445f-4e57-87f0-659e17268791	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 07:35:02
23223	9d688d26-4340-4c50-a441-c1e03d97f425	9d688d26-445f-4e57-87f0-659e17268791	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"51","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"700000","idLoans":70,"idCreador":12},"session":[],"response_status":200,"response":{"message":"El abono fue aplicado exitosamente","status":true},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:35:02
34608	9d69bf07-19e6-4833-8113-3aa4650c7448	9d69bf07-1b2e-4b76-a3bd-a68b35e200bf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":411,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:50:20
13299	9d5cfc99-cf9e-4c09-a7f7-10f04a8ed5d8	9d5cfc99-e9bb-46d9-8867-48d6bf61aa11	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 13:36:44
13300	9d5cfc99-e5a7-4da4-a7f3-be4deaf7ed9b	9d5cfc99-e9bb-46d9-8867-48d6bf61aa11	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"40.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 13:36:44
13301	9d5cfc99-e895-4bf7-b835-068db0e86a5a	9d5cfc99-e9bb-46d9-8867-48d6bf61aa11	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 13:36:44
13302	9d5cfc99-e8d7-4aa7-8160-f834d9a143dd	9d5cfc99-e9bb-46d9-8867-48d6bf61aa11	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":218,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:36:44
19444	9d66d67d-8c5d-488c-865d-817607ad6c81	9d66d67d-d3be-4d8c-b4c7-96a47c36a6a9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 11:08:27
15864	9d64b1f9-3e12-4587-a093-bbc83ed25bb1	9d64b1f9-5c7f-45bf-9e48-bafb2b9835fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 09:34:41
15865	9d64b1f9-5abd-4d5f-b6d6-4e30ed78a042	9d64b1f9-5c7f-45bf-9e48-bafb2b9835fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 09:34:41
15866	9d64b1f9-5b60-49db-a2ae-0b5a5f09a55e	9d64b1f9-5c7f-45bf-9e48-bafb2b9835fe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:34:41
17289	9d655233-b370-4598-8a1d-00b1713a26de	9d655234-03fe-4238-87f3-d0b35c259d88	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 17:02:43
17290	9d655234-01cb-4014-980f-d1edaa500f36	9d655234-03fe-4238-87f3-d0b35c259d88	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:02:43
17291	9d655234-02ac-4e29-9ced-9e34fc9f015f	9d655234-03fe-4238-87f3-d0b35c259d88	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":420,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:02:43
19445	9d66d67d-cb45-4d77-beff-0ccce720b530	9d66d67d-d3be-4d8c-b4c7-96a47c36a6a9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"146.70","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 11:08:27
19446	9d66d67d-cec2-43bf-bef6-f402e3c988c9	9d66d67d-d3be-4d8c-b4c7-96a47c36a6a9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:08:27
19447	9d66d67d-cf0a-4ef4-9d9f-69b17f55b1a2	9d66d67d-d3be-4d8c-b4c7-96a47c36a6a9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:08:27
19448	9d66d67d-d2a1-4020-bb46-56318202d4f8	9d66d67d-d3be-4d8c-b4c7-96a47c36a6a9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 11:08:27
19449	9d66d67d-d2e6-42fd-ba1d-9dceda761919	9d66d67d-d3be-4d8c-b4c7-96a47c36a6a9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T02:27:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"0"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":329,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:08:27
34609	9d69bf07-820c-4d8b-a4eb-55811e394408	9d69bf07-ab33-46ce-8538-a0224d0ac3a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:50:20
34610	9d69bf07-a3ef-4839-8149-b041ce245bed	9d69bf07-ab33-46ce-8538-a0224d0ac3a2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"56.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":246,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 21:50:20
34611	9d69bf07-a46c-4691-b9f7-08120981b3e3	9d69bf07-ab33-46ce-8538-a0224d0ac3a2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 21:50:20
19450	9d66d67f-55f0-4b04-a833-eccbb37b0a24	9d66d67f-7460-40f5-89d7-921fd2c1dab1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 11:08:28
19451	9d66d67f-6f54-4938-8e10-54eed5055a43	9d66d67f-7460-40f5-89d7-921fd2c1dab1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"46.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:08:29
12719	9d5cecb7-e468-42ea-afa1-80054dbdb909	9d5cecb8-2fa6-4ed7-8971-23b52a9c539d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-10-29 12:52:20
12720	9d5cecb8-2d82-455d-a756-b6e6a9796d44	9d5cecb8-2fa6-4ed7-8971-23b52a9c539d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-10-29 12:52:20
12721	9d5cecb8-2e8f-4ec5-8a24-abf6c80dd187	9d5cecb8-2fa6-4ed7-8971-23b52a9c539d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":419,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:20
19452	9d66d67f-6f9d-431f-8f75-2d684d5088f9	9d66d67f-7460-40f5-89d7-921fd2c1dab1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:08:29
19453	9d66d67f-7306-4a99-b36b-fddc55f427c3	9d66d67f-7460-40f5-89d7-921fd2c1dab1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 11:08:29
19454	9d66d67f-734b-4664-b5b9-0d1bb769df0a	9d66d67f-7460-40f5-89d7-921fd2c1dab1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":248,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:08:29
34612	9d69bf07-a9a4-49cf-8fd4-fe524685d7bc	9d69bf07-ab33-46ce-8538-a0224d0ac3a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:50:20
17292	9d655234-a69e-4f87-a48a-7fd5702a256d	9d655234-f345-494e-b2f3-a6df7ec138ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:02:44
34613	9d69bf07-a9fc-4978-9f48-462df58f464e	9d69bf07-ab33-46ce-8538-a0224d0ac3a2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:50:20
33916	9d69b81b-da8e-43d2-adfc-0d12d560b1b6	9d69b81b-fca7-44c9-b901-4ede0917bd09	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:30:59
33917	9d69b81b-fa96-4028-a34a-93068bfb6147	9d69b81b-fca7-44c9-b901-4ede0917bd09	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:30:59
33918	9d69b81b-fb85-491b-a807-b2dde690a7ed	9d69b81b-fca7-44c9-b901-4ede0917bd09	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":289,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:30:59
13303	9d5cfc9a-2a00-4005-b1ab-02fc0f4f135d	9d5cfc9a-44f9-40c3-a2a6-9776e4d7fbb2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 13:36:45
13304	9d5cfc9a-40c7-4039-8c98-4c5a10dbf2a0	9d5cfc9a-44f9-40c3-a2a6-9776e4d7fbb2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAr%' or \\"users\\".\\"user_document\\"::text like '%MAr%') order by \\"users\\".\\"user_document\\" asc","time":"38.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 13:36:45
13305	9d5cfc9a-43b4-4856-a806-c6db27197b22	9d5cfc9a-44f9-40c3-a2a6-9776e4d7fbb2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 13:36:45
13306	9d5cfc9a-43f5-494c-beb3-31e5725fc2f3	9d5cfc9a-44f9-40c3-a2a6-9776e4d7fbb2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAr"},"session":[],"response_status":200,"response":{"data":[]},"duration":224,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:36:45
15867	9d64b1f9-a7bd-432e-a313-a86f7b56b32b	9d64b1f9-c681-4826-a790-94ad6f322dbc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 09:34:42
15868	9d64b1f9-bdc2-492c-9d17-b05e24b20494	9d64b1f9-c681-4826-a790-94ad6f322dbc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"42.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"088d1fdbe045a08c3b0073ef22c7da32","hostname":"EderCortes"}	2024-11-02 09:34:42
15869	9d64b1f9-c12d-4be7-82d6-603de237e35a	9d64b1f9-c681-4826-a790-94ad6f322dbc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"1.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:34:42
15870	9d64b1f9-c166-40e6-a956-595a877acf3e	9d64b1f9-c681-4826-a790-94ad6f322dbc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 09:34:42
15871	9d64b1f9-c54b-4bf3-9b2a-58b75c3bd517	9d64b1f9-c681-4826-a790-94ad6f322dbc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 09:34:42
15872	9d64b1f9-c59f-4065-b4fd-21db848ebe1f	9d64b1f9-c681-4826-a790-94ad6f322dbc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:34:42
17293	9d655234-ecda-4854-b72c-1971b658a840	9d655234-f345-494e-b2f3-a6df7ec138ee	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"161.43","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":46,"hash":"fb4ded687569d92428336ceae5c6ffcd","hostname":"EderCortes"}	2024-11-02 17:02:44
17294	9d655234-f1a8-4133-92e0-56a12cd768f7	9d655234-f345-494e-b2f3-a6df7ec138ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:02:44
33919	9d69b81c-56a1-41d2-8c88-b067b4ba3d25	9d69b81c-a2e7-4a02-bdd3-067c1bcac3ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:30:59
13307	9d5cfc9a-8728-4d2f-a36e-dad1ba422b84	9d5cfc9a-a456-425a-9c29-bb8afbe104f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 13:36:45
13308	9d5cfc9a-a007-46e2-b952-9f22c7f9b243	9d5cfc9a-a456-425a-9c29-bb8afbe104f2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAri%' or \\"users\\".\\"user_document\\"::text like '%MAri%') order by \\"users\\".\\"user_document\\" asc","time":"42.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 13:36:45
13309	9d5cfc9a-a306-4fd0-a5c9-d79f42afe715	9d5cfc9a-a456-425a-9c29-bb8afbe104f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 13:36:45
13310	9d5cfc9a-a348-4efe-937a-ad687a6277a7	9d5cfc9a-a456-425a-9c29-bb8afbe104f2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAri"},"session":[],"response_status":200,"response":{"data":[]},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:36:45
15873	9d64b1fb-3242-4545-a917-527338da46a1	9d64b1fb-5173-4cac-8738-fc2b5cf99354	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 09:34:43
15874	9d64b1fb-4bd4-43e3-a251-d0fe68ba1c21	9d64b1fb-5173-4cac-8738-fc2b5cf99354	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 09:34:43
15875	9d64b1fb-4c2b-42e0-aa8b-1b8284c79315	9d64b1fb-5173-4cac-8738-fc2b5cf99354	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 09:34:43
15876	9d64b1fb-501b-416d-907b-d5dc4a79fbd7	9d64b1fb-5173-4cac-8738-fc2b5cf99354	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 09:34:43
15877	9d64b1fb-5068-424d-8c9c-fb740b02f661	9d64b1fb-5173-4cac-8738-fc2b5cf99354	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","user-agent":"Mozilla\\/5.0 (iPhone; CPU iPhone OS 16_6 like Mac OS X) AppleWebKit\\/605.1.15 (KHTML, like Gecko) Version\\/16.6 Mobile\\/15E148 Safari\\/604.1","accept":"application\\/json, text\\/plain, *\\/*","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":309,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:34:43
17295	9d655234-f215-4832-b089-d4cd3278ea36	9d655234-f345-494e-b2f3-a6df7ec138ee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":563,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:02:44
33920	9d69b81c-9b0c-4a5a-855a-920c0dfd8d9c	9d69b81c-a2e7-4a02-bdd3-067c1bcac3ed	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 82\\n                        ","time":"162.53","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"23238af5dc47e80ea555e80a08e2015d","hostname":"EderCortes"}	2024-11-04 21:31:00
13311	9d5cfc9b-02ee-4518-a4ff-40e197fe9dd8	9d5cfc9b-061c-4b8f-bd66-fe8676d684ad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":159,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:36:45
17296	9d655237-15e9-4007-8d50-3f69ae5dbb75	9d655237-3e3b-4ca1-bcaf-b5f6dc27869c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:02:45
17297	9d655237-3554-4c4f-8bb7-de70a199ff55	9d655237-3e3b-4ca1-bcaf-b5f6dc27869c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"51.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 17:02:46
17298	9d655237-35dd-4da5-8d5b-dbf31b9949a8	9d655237-3e3b-4ca1-bcaf-b5f6dc27869c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 17:02:46
17299	9d655237-3c29-43da-89f0-9bf4adf2f611	9d655237-3e3b-4ca1-bcaf-b5f6dc27869c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:02:46
17300	9d655237-3cab-4241-a52f-d16df6d74db2	9d655237-3e3b-4ca1-bcaf-b5f6dc27869c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":480,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:02:46
33921	9d69b81c-9e4b-4b89-b113-e15549881bfc	9d69b81c-a2e7-4a02-bdd3-067c1bcac3ed	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '82' order by \\"item_loans\\".\\"id\\" asc","time":"2.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:31:00
33922	9d69b81c-a1aa-49f5-9d4d-f5053c1cc7e9	9d69b81c-a2e7-4a02-bdd3-067c1bcac3ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:31:00
33923	9d69b81c-a1fb-4f1f-94a7-c84542977cd5	9d69b81c-a2e7-4a02-bdd3-067c1bcac3ed	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/82","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":82,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"240000","loans_pago_interes":"60000","user_alias":"eder.cortes"},"items":[{"id":316,"loans_codigo":82,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:36","updated_at":"2024-11-04 21:29:42","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":464,"loans_codigo":82,"itemloans_cuota":"2","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:29:42","updated_at":"2024-11-04 21:29:42","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":465,"loans_codigo":82,"itemloans_cuota":"3","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:29:42","updated_at":"2024-11-04 21:29:42","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":466,"loans_codigo":82,"itemloans_cuota":"4","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:29:42","updated_at":"2024-11-04 21:29:42","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":467,"loans_codigo":82,"itemloans_cuota":"5","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:29:42","updated_at":"2024-11-04 21:29:42","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":369,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:31:00
34614	9d69bf07-ff86-4c1f-a056-53c816a27605	9d69bf08-23e8-4808-b9dc-5563199b41fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:50:20
34615	9d69bf08-1c9d-4e04-bbbe-a24862f9ae2b	9d69bf08-23e8-4808-b9dc-5563199b41fe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:50:21
34616	9d69bf08-1d1a-496c-9013-089d846ff23d	9d69bf08-23e8-4808-b9dc-5563199b41fe	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:50:21
34617	9d69bf08-227d-40c7-a199-6de535ae2d41	9d69bf08-23e8-4808-b9dc-5563199b41fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:50:21
13312	9d5cfc9b-7ebc-40bf-8310-3c9f88e95786	9d5cfc9b-8162-4757-a4aa-218f6f2983db	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":134,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:36:46
33924	9d69b81e-a235-4d66-86fb-8430d56e193f	9d69b81e-c4f0-42a1-ad67-879b3c48bc86	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:31:01
33925	9d69b81e-bf10-4196-908a-9e36ed891d8a	9d69b81e-c4f0-42a1-ad67-879b3c48bc86	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"48.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:31:01
33926	9d69b81e-bf79-47e2-bcde-d2c0a1ed4753	9d69b81e-c4f0-42a1-ad67-879b3c48bc86	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:31:01
23390	9d6895fc-09f6-482f-980c-9e46a08b6f33	9d6895fc-2b2b-471b-afa9-d694fca4c3be	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 07:59:44
23391	9d6895fc-2988-4b69-96bf-b3fa7d54a000	9d6895fc-2b2b-471b-afa9-d694fca4c3be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 07:59:44
23392	9d6895fc-2a36-4fc9-be24-7f7440cb9efe	9d6895fc-2b2b-471b-afa9-d694fca4c3be	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:59:44
33927	9d69b81e-c369-4073-8e89-4cc0eefd47e5	9d69b81e-c4f0-42a1-ad67-879b3c48bc86	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:31:01
33928	9d69b81e-c3c7-4f03-b6c9-e81c7d1185d6	9d69b81e-c4f0-42a1-ad67-879b3c48bc86	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":407,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:31:01
34618	9d69bf08-22e3-4e9d-b5b1-1397f8be2bbd	9d69bf08-23e8-4808-b9dc-5563199b41fe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":293,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:50:21
13313	9d5cfc9b-f2a1-4494-a237-ceac37004358	9d5cfc9b-f553-469e-9816-6662704f63ad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":123,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:36:46
23393	9d6895fc-82bb-4e81-b8a7-a5d85c8aa7fa	9d6895fc-a32a-4e82-a1b1-4dc6d8cb6637	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 07:59:45
23394	9d6895fc-99bf-4902-9bd8-43def08ba0a6	9d6895fc-a32a-4e82-a1b1-4dc6d8cb6637	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 69\\n                        ","time":"46.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"28d3d4f6fe6eff992a986b780c628d2e","hostname":"EderCortes"}	2024-11-04 07:59:45
23395	9d6895fc-9da7-49fa-850d-e5675ae7aa05	9d6895fc-a32a-4e82-a1b1-4dc6d8cb6637	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '69' order by \\"item_loans\\".\\"id\\" asc","time":"3.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 07:59:45
23396	9d6895fc-9dde-4868-af8e-bf126c1d7f06	9d6895fc-a32a-4e82-a1b1-4dc6d8cb6637	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 07:59:45
23397	9d6895fc-a1ce-418e-90cc-88d41649b611	9d6895fc-a32a-4e82-a1b1-4dc6d8cb6637	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 07:59:45
23398	9d6895fc-a223-416f-bc0f-179c8ca285b4	9d6895fc-a32a-4e82-a1b1-4dc6d8cb6637	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/69","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":69,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1150000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":243,"loans_codigo":69,"itemloans_cuota":"1","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T05:49:09.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":244,"loans_codigo":69,"itemloans_cuota":"2","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T05:49:09.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":245,"loans_codigo":69,"itemloans_cuota":"3","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T05:49:09.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":246,"loans_codigo":69,"itemloans_cuota":"4","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T05:49:09.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":247,"loans_codigo":69,"itemloans_cuota":"5","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T05:49:09.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":265,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:59:45
33929	9d69b837-d082-47b5-a3e7-fbd9deb78b3a	9d69b837-d430-440f-9213-f11e97cad868	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":172,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:31:17
34619	9d69bf08-7548-460a-a4ea-06b48d074b03	9d69bf08-98f5-4049-b08b-13951d7c4b6f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:50:21
34620	9d69bf08-90f6-4d7b-a501-b47c6cb274a9	9d69bf08-98f5-4049-b08b-13951d7c4b6f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_valor_prestado\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"loans_inicio_pago\\", \\"user_creador\\", \\"user_cobrador\\", \\"loans_pago_prestado\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\" from \\"loans\\" where \\"id\\" = '93' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"44.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":233,"hash":"58481adc49710b91b872dd680f964f96","hostname":"EderCortes"}	2024-11-04 21:50:21
34621	9d69bf08-9163-457d-87e0-4a6ce40618a4	9d69bf08-98f5-4049-b08b-13951d7c4b6f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 21:50:21
34622	9d69bf08-9325-463c-98ff-930a708a96f4	9d69bf08-98f5-4049-b08b-13951d7c4b6f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"2.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":234,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 21:50:21
34623	9d69bf08-9361-4b5e-bace-2d3493b0ab52	9d69bf08-98f5-4049-b08b-13951d7c4b6f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 21:50:21
34624	9d69bf08-979b-4bd0-937a-e8602bdb551a	9d69bf08-98f5-4049-b08b-13951d7c4b6f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:50:21
13314	9d5cfc9c-467e-4d12-a76d-e61222d40e63	9d5cfc9c-6194-4200-92de-b9cf059f658f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-29 13:36:46
13315	9d5cfc9c-5c91-4998-9382-56abd521dbdd	9d5cfc9c-6194-4200-92de-b9cf059f658f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAr%' or \\"users\\".\\"user_document\\"::text like '%MAr%') order by \\"users\\".\\"user_document\\" asc","time":"40.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 13:36:46
13316	9d5cfc9c-600c-4999-867c-f112dece6a45	9d5cfc9c-6194-4200-92de-b9cf059f658f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-29 13:36:46
13317	9d5cfc9c-606e-4844-8336-48be09d878a9	9d5cfc9c-6194-4200-92de-b9cf059f658f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAr"},"session":[],"response_status":200,"response":{"data":[]},"duration":220,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:36:46
23399	9d6895fe-4a89-4d4f-af15-5af0c6c45406	9d6895fe-67a7-4bd2-863d-0a6d4071aafa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 07:59:46
23400	9d6895fe-6308-45d7-b9e4-35319d662123	9d6895fe-67a7-4bd2-863d-0a6d4071aafa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 07:59:46
23401	9d6895fe-6366-45e6-a709-635ef51575a6	9d6895fe-67a7-4bd2-863d-0a6d4071aafa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 07:59:46
23402	9d6895fe-666d-4e33-a9f7-6a81f569ff5a	9d6895fe-67a7-4bd2-863d-0a6d4071aafa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 07:59:46
23403	9d6895fe-66b2-49e5-92e6-160440cd77c8	9d6895fe-67a7-4bd2-863d-0a6d4071aafa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:59:46
33930	9d69b838-8e47-4677-b5a9-297653a6d565	9d69b838-b3a8-4032-8315-e5c0799a2ad4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:31:18
33931	9d69b838-a587-43a8-a373-fc81c78e374b	9d69b838-b3a8-4032-8315-e5c0799a2ad4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 82 limit 1","time":"2.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":505,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 21:31:18
33932	9d69b838-a5d7-41ad-86c4-a16dcc95eb24	9d69b838-b3a8-4032-8315-e5c0799a2ad4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":2,"hostname":"EderCortes"}	2024-11-04 21:31:18
33933	9d69b838-a794-4ac0-8835-d58ecf888afc	9d69b838-b3a8-4032-8315-e5c0799a2ad4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select count(*) as aggregate from \\"item_loans\\" where \\"loans_codigo\\" = 82 and (\\"itemloans_status\\" = 'Pagada' or \\"itemloans_status\\" = 'Abono')","time":"2.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":566,"hash":"40bb62c1101cd4a074e44b13c59d4517","hostname":"EderCortes"}	2024-11-04 21:31:18
33934	9d69b838-a83e-4d94-b8d7-2bb8882f3468	9d69b838-b3a8-4032-8315-e5c0799a2ad4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 120000, \\"loans_pago_prestado\\" = 480000, \\"updated_at\\" = '2024-11-04 21:31:18' where \\"id\\" = 82","time":"0.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":605,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 21:31:18
33935	9d69b838-a897-4cf1-b151-7c9aed32f6fa	9d69b838-b3a8-4032-8315-e5c0799a2ad4	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:82","changes":{"updated_at":"2024-11-04 21:31:18","loans_pago_interes":120000,"loans_pago_prestado":480000},"hostname":"EderCortes"}	2024-11-04 21:31:18
33936	9d69b838-a91d-4fa6-ae9e-7004ce333653	9d69b838-b3a8-4032-8315-e5c0799a2ad4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 82 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"0.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":612,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 21:31:18
33937	9d69b838-a94c-44b4-ba52-f13754434a38	9d69b838-b3a8-4032-8315-e5c0799a2ad4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 21:31:18
13318	9d5cfc9c-a71a-4fa2-bc61-d9809d5c7a92	9d5cfc9c-c171-4e5e-9329-98e7c1338964	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-29 13:36:46
13319	9d5cfc9c-bd2c-4857-a778-b46b4f52d3d3	9d5cfc9c-c171-4e5e-9329-98e7c1338964	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"40.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 13:36:46
13320	9d5cfc9c-c01a-4db8-bd5d-4552473953a0	9d5cfc9c-c171-4e5e-9329-98e7c1338964	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-29 13:36:46
13321	9d5cfc9c-c06c-41b3-b99a-b3a804af58ef	9d5cfc9c-c171-4e5e-9329-98e7c1338964	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:36:46
23404	9d68961b-7706-487a-9534-88cc8395dcc9	9d68961b-7ac7-49c0-8fd6-7259637045e2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":155,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:00:05
33938	9d69b838-aa8a-4236-8c60-32d92aea1522	9d69b838-b3a8-4032-8315-e5c0799a2ad4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Abono', \\"itemloans_aprobador\\" = 12, \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = 60000, \\"itemloans_cuota_cancelada\\" = 240000, \\"updated_at\\" = '2024-11-04 21:31:18' where \\"id\\" = 464","time":"2.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":620,"hash":"6acd4a1714feb503cbc85629417266cf","hostname":"EderCortes"}	2024-11-04 21:31:18
33939	9d69b838-aabe-4d2e-91d4-d7b42c730ca8	9d69b838-b3a8-4032-8315-e5c0799a2ad4	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:464","changes":{"itemloans_status":"Abono","itemloans_aprobador":12,"updated_at":"2024-11-04 21:31:18","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":60000,"itemloans_cuota_cancelada":240000},"hostname":"EderCortes"}	2024-11-04 21:31:18
33940	9d69b838-ab1f-4c95-bf9b-9e0edc9af2e2	9d69b838-b3a8-4032-8315-e5c0799a2ad4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"delete from \\"item_loans\\" where \\"loans_codigo\\" = 82 and \\"itemloans_status\\" = 'Pendiente'","time":"0.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":627,"hash":"89bf3c496a8b0746ff5d1219b8dc29e3","hostname":"EderCortes"}	2024-11-04 21:31:18
33941	9d69b838-ab87-436b-92f7-67e14087402b	9d69b838-b3a8-4032-8315-e5c0799a2ad4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 82 limit 1","time":"0.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":630,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 21:31:18
33942	9d69b838-ac35-4c27-a420-b872160db2a3	9d69b838-b3a8-4032-8315-e5c0799a2ad4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (82, 3, 155000, 38750, 'Pendiente', 'Se realiza abono', '12-11-2024', 0, 0, '2024-11-04 21:31:18', '2024-11-04 21:31:18')","time":"0.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":693,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:31:18
33943	9d69b838-ac60-4808-8efb-36b828e890dd	9d69b838-b3a8-4032-8315-e5c0799a2ad4	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:31:18
33944	9d69b838-acdb-4e2b-8ae5-4360ad04c1f1	9d69b838-b3a8-4032-8315-e5c0799a2ad4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (82, 4, 155000, 38750, 'Pendiente', 'Se realiza abono', '20-11-2024', 0, 0, '2024-11-04 21:31:18', '2024-11-04 21:31:18')","time":"0.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":693,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:31:18
33945	9d69b838-ad15-4b3f-ba02-2346d226b85c	9d69b838-b3a8-4032-8315-e5c0799a2ad4	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:31:18
33946	9d69b838-ad91-48cc-a944-993d618d4750	9d69b838-b3a8-4032-8315-e5c0799a2ad4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (82, 5, 155000, 38750, 'Pendiente', 'Se realiza abono', '28-11-2024', 0, 0, '2024-11-04 21:31:18', '2024-11-04 21:31:18')","time":"0.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":693,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:31:18
33947	9d69b838-adc9-42a0-b84a-f5485be48b6f	9d69b838-b3a8-4032-8315-e5c0799a2ad4	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:31:18
13322	9d5cfc9d-02f6-4b51-8224-ab576068a99a	9d5cfc9d-1da5-4972-977e-bf456fbb93c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-29 13:36:47
13323	9d5cfc9d-19c2-4982-a40e-a7df4785fd8c	9d5cfc9d-1da5-4972-977e-bf456fbb93c8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ma%' or \\"users\\".\\"user_document\\"::text like '%Ma%') order by \\"users\\".\\"user_document\\" asc","time":"42.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 13:36:47
13324	9d5cfc9d-1c64-49dd-9c5f-88aca5a4380c	9d5cfc9d-1da5-4972-977e-bf456fbb93c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-29 13:36:47
13325	9d5cfc9d-1ca7-4c6d-95b2-d1c01ed13573	9d5cfc9d-1da5-4972-977e-bf456fbb93c8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ma"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":221,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:36:47
33948	9d69b838-ae3c-46c6-87e9-8e91de887b82	9d69b838-b3a8-4032-8315-e5c0799a2ad4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (82, 6, 155000, 38750, 'Pendiente', 'Se realiza abono', '06-12-2024', 0, 0, '2024-11-04 21:31:18', '2024-11-04 21:31:18')","time":"0.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":693,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:31:18
32909	9d69a6ff-5929-4567-9de9-0a2f9246be8a	9d69a6ff-ac63-4c44-bbaf-7cc00b43e45b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 20:43:08
32910	9d69a6ff-a998-46b2-bf0e-c340fff6c521	9d69a6ff-ac63-4c44-bbaf-7cc00b43e45b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 20:43:08
32911	9d69a6ff-aae4-477b-87d8-5f241ead320e	9d69a6ff-ac63-4c44-bbaf-7cc00b43e45b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":393,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:43:09
33949	9d69b838-ae61-4699-967e-b9e127e8591f	9d69b838-b3a8-4032-8315-e5c0799a2ad4	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:31:18
34625	9d69bf08-97fa-44d5-9bf7-b35f41be71f7	9d69bf08-98f5-4049-b08b-13951d7c4b6f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","user_creador":12,"user_cobrador":22,"loans_pago_prestado":"1000000","user_customer":19,"user_recomendacion":18,"loans_pago_interes":"250000"},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:19:45.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:22:30.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":399,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":400,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":401,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":402,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"}]}},"duration":278,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:50:21
33950	9d69b838-b250-471e-914c-ae422c0e92b7	9d69b838-b3a8-4032-8315-e5c0799a2ad4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:31:18
13326	9d5cfc9d-592a-403f-b176-949076c17aa0	9d5cfc9d-5c14-40df-b85b-09357702a745	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":139,"memory":20,"hostname":"EderCortes"}	2024-10-29 13:36:47
23417	9d6896b8-eafb-4d78-bc22-b895f70bb9ac	9d6896b8-efa8-4f22-bbf0-16f639f5157b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":221,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:01:48
32912	9d69a700-0f15-49a9-a441-a0b6197eb2df	9d69a700-55cb-4f6e-960f-e782c7ac5d4e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 20:43:09
32913	9d69a700-4dc8-49c2-814f-51ccc2e044f1	9d69a700-55cb-4f6e-960f-e782c7ac5d4e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 91\\n                        ","time":"146.93","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"9ae30bc69b6b272f3f51ff48e54319f5","hostname":"EderCortes"}	2024-11-04 20:43:09
32914	9d69a700-50a7-4976-afc5-fe44e798c8df	9d69a700-55cb-4f6e-960f-e782c7ac5d4e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '91' order by \\"item_loans\\".\\"id\\" asc","time":"1.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 20:43:09
32915	9d69a700-548b-4941-a009-7003fb5017a2	9d69a700-55cb-4f6e-960f-e782c7ac5d4e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 20:43:09
32916	9d69a700-54e9-4177-bc29-74d9a2446401	9d69a700-55cb-4f6e-960f-e782c7ac5d4e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/91","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":91,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":8,"loans_valor_prestado":5000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1725000","loans_pago_interes":"431250","user_alias":"eder.cortes"},"items":[{"id":371,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 17:44:55","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"200000","itemloans_cuota_cancelada":"800000","user_alias":"eder.cortes"},{"id":403,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 20:42:05","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"131250","itemloans_cuota_cancelada":"525000","user_alias":"eder.cortes"},{"id":404,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 20:42:18","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000","user_alias":"eder.cortes"},{"id":411,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"467857.14285714","itemloans_iteres":"116964.28571429","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:42:18","updated_at":"2024-11-04 20:42:18","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":412,"loans_codigo":91,"itemloans_cuota":"3","itemloans_valor_cuota":"467857.14285714","itemloans_iteres":"116964.28571429","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:42:18","updated_at":"2024-11-04 20:42:18","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":413,"loans_codigo":91,"itemloans_cuota":"4","itemloans_valor_cuota":"467857.14285714","itemloans_iteres":"116964.28571429","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:42:18","updated_at":"2024-11-04 20:42:18","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":414,"loans_codigo":91,"itemloans_cuota":"5","itemloans_valor_cuota":"467857.14285714","itemloans_iteres":"116964.28571429","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:42:18","updated_at":"2024-11-04 20:42:18","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":415,"loans_codigo":91,"itemloans_cuota":"6","itemloans_valor_cuota":"467857.14285714","itemloans_iteres":"116964.28571429","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:42:18","updated_at":"2024-11-04 20:42:18","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":416,"loans_codigo":91,"itemloans_cuota":"7","itemloans_valor_cuota":"467857.14285714","itemloans_iteres":"116964.28571429","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:42:18","updated_at":"2024-11-04 20:42:18","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":417,"loans_codigo":91,"itemloans_cuota":"8","itemloans_valor_cuota":"467857.14285714","itemloans_iteres":"116964.28571429","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:42:18","updated_at":"2024-11-04 20:42:18","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":380,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:43:09
33951	9d69b838-b298-4a03-b233-31efc52f69b2	9d69b838-b3a8-4032-8315-e5c0799a2ad4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"61","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"300000","idLoans":82,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El abono fue aplicado exitosamente","status":true},"duration":256,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:31:18
34626	9d69bf0a-53df-4aaf-8122-408e8dc06300	9d69bf0a-810b-4e71-a231-c5aa7b6653d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:50:22
13327	9d5cfc9e-13b5-4763-90cb-71ad50c7dc93	9d5cfc9e-2eef-4efa-b6b5-a656fe2b00fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-29 13:36:47
13328	9d5cfc9e-2ae8-4287-929f-85760da2a3d7	9d5cfc9e-2eef-4efa-b6b5-a656fe2b00fa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mar%' or \\"users\\".\\"user_document\\"::text like '%Mar%') order by \\"users\\".\\"user_document\\" asc","time":"40.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-10-29 13:36:47
13329	9d5cfc9e-2dcc-4c47-8dc0-5ae8155fed46	9d5cfc9e-2eef-4efa-b6b5-a656fe2b00fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-29 13:36:47
13330	9d5cfc9e-2e0f-4704-b69a-8d12a9f2f6cf	9d5cfc9e-2eef-4efa-b6b5-a656fe2b00fa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mar"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:36:47
23418	9d6896b9-5a44-4f77-8178-c983fe2feba9	9d6896b9-8be6-4034-92e1-f8c8ba5c93f3	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 08:01:48
23419	9d6896b9-7d2a-402d-b0ea-4cefe2ccd335	9d6896b9-8be6-4034-92e1-f8c8ba5c93f3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 243 limit 1","time":"4.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 08:01:48
23420	9d6896b9-7dc3-4eb3-9709-b5ad5e8cc80e	9d6896b9-8be6-4034-92e1-f8c8ba5c93f3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 08:01:48
23421	9d6896b9-7fa5-4ec2-8319-c0d9603de404	9d6896b9-8be6-4034-92e1-f8c8ba5c93f3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 69 limit 1","time":"2.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 08:01:48
23422	9d6896b9-7fdb-4668-a3da-f8d78c8d4708	9d6896b9-8be6-4034-92e1-f8c8ba5c93f3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 08:01:48
23423	9d6896b9-83a7-4fa7-8776-f135fa24a024	9d6896b9-8be6-4034-92e1-f8c8ba5c93f3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '57500', \\"itemloans_cuota_cancelada\\" = '230000', \\"updated_at\\" = '2024-11-04 08:01:48' where \\"id\\" = 243","time":"7.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":400,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 08:01:48
23424	9d6896b9-8419-4463-83f7-a74f34773651	9d6896b9-8be6-4034-92e1-f8c8ba5c93f3	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:243","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 08:01:48","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000"},"hostname":"EderCortes"}	2024-11-04 08:01:49
23425	9d6896b9-84dc-46f6-aa61-84e8f34ce516	9d6896b9-8be6-4034-92e1-f8c8ba5c93f3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 57500, \\"loans_pago_prestado\\" = 230000, \\"updated_at\\" = '2024-11-04 08:01:49' where \\"id\\" = 69","time":"1.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":408,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 08:01:49
23426	9d6896b9-8518-42a4-a9cb-020a3922399b	9d6896b9-8be6-4034-92e1-f8c8ba5c93f3	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:69","changes":{"updated_at":"2024-11-04 08:01:49","loans_pago_interes":57500,"loans_pago_prestado":230000},"hostname":"EderCortes"}	2024-11-04 08:01:49
23427	9d6896b9-89f6-445f-8e93-7480e50eaf9b	9d6896b9-8be6-4034-92e1-f8c8ba5c93f3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 08:01:49
23428	9d6896b9-8a71-4da6-b2db-3ce435426df1	9d6896b9-8be6-4034-92e1-f8c8ba5c93f3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"179","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000","id":243,"loans_codigo":69,"itemloans_cuota":"1","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:01:49
32917	9d69a702-59b2-4b59-af82-7f90e96dc5a8	9d69a702-9f9f-4b36-bd1b-b818323d88fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 20:43:10
32918	9d69a702-99c3-44d0-aa62-456ea16de412	9d69a702-9f9f-4b36-bd1b-b818323d88fb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"143.35","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 20:43:10
32919	9d69a702-9a1f-4dfe-bee5-9a4c9da33287	9d69a702-9f9f-4b36-bd1b-b818323d88fb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 20:43:10
32920	9d69a702-9df0-45a4-8a7e-1cf8182a7c0b	9d69a702-9f9f-4b36-bd1b-b818323d88fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 20:43:10
13331	9d5cfc9f-e6bf-474a-b4ed-065935f99203	9d5cfca0-2deb-4799-bb24-c48757c599d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-29 13:36:48
13332	9d5cfca0-2884-47e4-bcf3-b42b8e839fbe	9d5cfca0-2deb-4799-bb24-c48757c599d2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '18' and \\"users\\".\\"deleted_at\\" is null","time":"138.91","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":55,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-10-29 13:36:49
13333	9d5cfca0-28e3-425f-97ca-8e83bc585c8a	9d5cfca0-2deb-4799-bb24-c48757c599d2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 13:36:49
13334	9d5cfca0-2cb6-482b-814e-b67446723777	9d5cfca0-2deb-4799-bb24-c48757c599d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-29 13:36:49
13335	9d5cfca0-2cfa-44cf-b41e-0618f4c6831d	9d5cfca0-2deb-4799-bb24-c48757c599d2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/18","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}},"duration":370,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:36:49
23429	9d6896ba-0023-44be-8e87-d0075a0d0446	9d6896ba-2540-40a8-9801-63445139e17e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 08:01:49
23430	9d6896ba-1acb-4966-874e-8e131e4ba97f	9d6896ba-2540-40a8-9801-63445139e17e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 69\\n                        ","time":"51.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"28d3d4f6fe6eff992a986b780c628d2e","hostname":"EderCortes"}	2024-11-04 08:01:49
23431	9d6896ba-1f09-4567-84a0-ec6205b822ad	9d6896ba-2540-40a8-9801-63445139e17e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '69' order by \\"item_loans\\".\\"id\\" asc","time":"2.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:01:49
23432	9d6896ba-1f48-4dd8-b9c4-343bc93dee59	9d6896ba-2540-40a8-9801-63445139e17e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 08:01:49
23433	9d6896ba-23c8-4f72-9171-712fb3d20442	9d6896ba-2540-40a8-9801-63445139e17e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 08:01:49
23434	9d6896ba-2417-4bde-b48c-1a469d9e28cf	9d6896ba-2540-40a8-9801-63445139e17e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/69","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":69,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1150000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"230000","loans_pago_interes":"57500"},"items":[{"id":243,"loans_codigo":69,"itemloans_cuota":"1","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T13:01:48.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000"},{"id":244,"loans_codigo":69,"itemloans_cuota":"2","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T05:49:09.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":245,"loans_codigo":69,"itemloans_cuota":"3","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T05:49:09.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":246,"loans_codigo":69,"itemloans_cuota":"4","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T05:49:09.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":247,"loans_codigo":69,"itemloans_cuota":"5","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T05:49:09.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":366,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:01:49
33952	9d69b839-01fb-4b26-8b5f-42ee2f75bc2d	9d69b839-2066-4d18-bd2f-d68bd4764ec1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:31:18
34627	9d69bf0a-78f4-4cde-bab0-ab2441b09562	9d69bf0a-810b-4e71-a231-c5aa7b6653d5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"62.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:50:22
34628	9d69bf0a-7986-44a1-8334-81b5a57632d5	9d69bf0a-810b-4e71-a231-c5aa7b6653d5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:50:22
23435	9d6896c0-c242-49dd-9530-237808a1d8e4	9d6896c0-c55e-4811-9533-34c5b416bbc3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":130,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:01:53
32921	9d69a702-9e42-47ef-a09e-47d249739d01	9d69a702-9f9f-4b36-bd1b-b818323d88fb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":432,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:43:10
34629	9d69bf0a-7f58-4b65-9f20-65c459580391	9d69bf0a-810b-4e71-a231-c5aa7b6653d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:50:22
34630	9d69bf0a-7fcf-4564-b5c9-29d536ed6ad6	9d69bf0a-810b-4e71-a231-c5aa7b6653d5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":431,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:50:22
17357	9d655878-71c3-47e9-b3f5-7679fe8c601d	9d655878-96b0-4fb5-9e14-1797394cc60d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:20:15
17358	9d655878-94f7-4437-9408-2324ae7afff6	9d655878-96b0-4fb5-9e14-1797394cc60d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:20:15
17359	9d655878-95b9-48bd-a292-f8295c5f6825	9d655878-96b0-4fb5-9e14-1797394cc60d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":302,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:20:15
32922	9d69a710-979d-49ca-9314-6ef54fc4339e	9d69a710-9c4b-4451-9cc5-6b19f883c86d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":183,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:43:20
23436	9d6896c1-30af-421c-8142-35c15d874830	9d6896c1-554b-493c-a828-42c12c918d94	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 08:01:54
23437	9d6896c1-49f1-4ed3-a1ff-66159c74ef0e	9d6896c1-554b-493c-a828-42c12c918d94	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 244 limit 1","time":"3.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 08:01:54
23438	9d6896c1-4a40-4e55-a43a-8b402595a668	9d6896c1-554b-493c-a828-42c12c918d94	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 08:01:54
23439	9d6896c1-4be5-4b18-b1d2-9a59247e9ee7	9d6896c1-554b-493c-a828-42c12c918d94	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 69 limit 1","time":"1.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 08:01:54
23440	9d6896c1-4c13-45dd-a832-43367f41a7e5	9d6896c1-554b-493c-a828-42c12c918d94	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 08:01:54
23441	9d6896c1-4fbf-4bde-854b-e8daa4648c4e	9d6896c1-554b-493c-a828-42c12c918d94	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '57500', \\"itemloans_cuota_cancelada\\" = '230000', \\"updated_at\\" = '2024-11-04 08:01:54' where \\"id\\" = 244","time":"7.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":400,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 08:01:54
17360	9d655878-e723-4d7d-aa79-cccdaa9afbe5	9d655879-0323-40e5-ace2-8753c5de2ee6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:20:15
17361	9d655878-feec-4b90-bd82-b4eb9c5812b4	9d655879-0323-40e5-ace2-8753c5de2ee6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"42.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":46,"hash":"fb4ded687569d92428336ceae5c6ffcd","hostname":"EderCortes"}	2024-11-02 17:20:15
17362	9d655879-01ed-484f-887c-44926986490d	9d655879-0323-40e5-ace2-8753c5de2ee6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 17:20:15
17363	9d655879-023e-42aa-ab64-808f0277e097	9d655879-0323-40e5-ace2-8753c5de2ee6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:20:15
23442	9d6896c1-502a-4572-a086-220932362531	9d6896c1-554b-493c-a828-42c12c918d94	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:244","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 08:01:54","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000"},"hostname":"EderCortes"}	2024-11-04 08:01:54
23443	9d6896c1-50e8-4d29-8f04-523755b177da	9d6896c1-554b-493c-a828-42c12c918d94	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 115000, \\"loans_pago_prestado\\" = 460000, \\"updated_at\\" = '2024-11-04 08:01:54' where \\"id\\" = 69","time":"0.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":408,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 08:01:54
23444	9d6896c1-511c-4f46-a02c-1c38c32e8494	9d6896c1-554b-493c-a828-42c12c918d94	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:69","changes":{"updated_at":"2024-11-04 08:01:54","loans_pago_interes":115000,"loans_pago_prestado":460000},"hostname":"EderCortes"}	2024-11-04 08:01:54
23445	9d6896c1-5421-4991-b4d7-ce9531dfedf0	9d6896c1-554b-493c-a828-42c12c918d94	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 08:01:54
23446	9d6896c1-5462-4308-b28b-f2ee3ce69991	9d6896c1-554b-493c-a828-42c12c918d94	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"179","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000","id":244,"loans_codigo":69,"itemloans_cuota":"2","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:01:54
32923	9d69a711-595f-4840-9fb1-9f49e4575619	9d69a711-847f-4cc2-a775-8b5b1b312dc5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 20:43:20
32924	9d69a711-7251-4fc7-a1bd-afc407535562	9d69a711-847f-4cc2-a775-8b5b1b312dc5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 91 limit 1","time":"2.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":505,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 20:43:20
32925	9d69a711-72a8-4f0c-ab5c-55b2b49b4447	9d69a711-847f-4cc2-a775-8b5b1b312dc5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":2,"hostname":"EderCortes"}	2024-11-04 20:43:20
32926	9d69a711-746c-4655-bbb1-120749349605	9d69a711-847f-4cc2-a775-8b5b1b312dc5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select count(*) as aggregate from \\"item_loans\\" where \\"loans_codigo\\" = 91 and \\"itemloans_status\\" = 'Pagada'","time":"2.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":563,"hash":"60bd91eaa209a639fc2e8afc20430a4b","hostname":"EderCortes"}	2024-11-04 20:43:20
32927	9d69a711-7536-45c3-848a-5c532a07f877	9d69a711-847f-4cc2-a775-8b5b1b312dc5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 531250, \\"loans_pago_prestado\\" = 2125000, \\"updated_at\\" = '2024-11-04 20:43:20' where \\"id\\" = 91","time":"0.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":602,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 20:43:20
32928	9d69a711-75bb-42d1-81ba-dd0fc365ae26	9d69a711-847f-4cc2-a775-8b5b1b312dc5	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:91","changes":{"updated_at":"2024-11-04 20:43:20","loans_pago_interes":531250,"loans_pago_prestado":2125000},"hostname":"EderCortes"}	2024-11-04 20:43:20
17364	9d65587b-0695-43ae-a912-cd66f290660a	9d65587b-2a8c-42e9-bce8-a64d63b288d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 17:20:17
17365	9d65587b-226e-4952-b00b-d112dd978c72	9d65587b-2a8c-42e9-bce8-a64d63b288d5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"47.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 17:20:17
17366	9d65587b-230a-4486-b268-b813528322b6	9d65587b-2a8c-42e9-bce8-a64d63b288d5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 17:20:17
17367	9d65587b-288b-4860-9a36-e2bf4d8b480b	9d65587b-2a8c-42e9-bce8-a64d63b288d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 17:20:17
17368	9d65587b-2911-4be7-bb64-db48d2444c77	9d65587b-2a8c-42e9-bce8-a64d63b288d5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":390,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:20:17
23447	9d6896c1-9ecf-44bc-aaaf-2e4e2ae8233f	9d6896c1-e6f2-40fc-8510-a49a3392f9cc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 08:01:54
23448	9d6896c1-ddc2-4df2-a2d2-43b2ac04e630	9d6896c1-e6f2-40fc-8510-a49a3392f9cc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 69\\n                        ","time":"146.66","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"28d3d4f6fe6eff992a986b780c628d2e","hostname":"EderCortes"}	2024-11-04 08:01:54
23449	9d6896c1-e156-41cb-9e2b-07ea3e3ba159	9d6896c1-e6f2-40fc-8510-a49a3392f9cc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '69' order by \\"item_loans\\".\\"id\\" asc","time":"1.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:01:54
23450	9d6896c1-e19e-454b-b64f-1fc63b46f4ae	9d6896c1-e6f2-40fc-8510-a49a3392f9cc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 08:01:54
23451	9d6896c1-e5a0-4d87-a539-01fd94d0aecf	9d6896c1-e6f2-40fc-8510-a49a3392f9cc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 08:01:54
23452	9d6896c1-e5ea-4982-86f2-c476f41ad543	9d6896c1-e6f2-40fc-8510-a49a3392f9cc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/69","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":69,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1150000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"460000","loans_pago_interes":"115000"},"items":[{"id":243,"loans_codigo":69,"itemloans_cuota":"1","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T13:01:48.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000"},{"id":244,"loans_codigo":69,"itemloans_cuota":"2","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T13:01:54.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000"},{"id":245,"loans_codigo":69,"itemloans_cuota":"3","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T05:49:09.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":246,"loans_codigo":69,"itemloans_cuota":"4","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T05:49:09.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":247,"loans_codigo":69,"itemloans_cuota":"5","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T05:49:09.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:01:54
32929	9d69a711-7661-4a40-b9c1-193870f3bdda	9d69a711-847f-4cc2-a775-8b5b1b312dc5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 91 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"0.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":609,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 20:43:20
32930	9d69a711-769e-48fe-87f0-dd3794debb12	9d69a711-847f-4cc2-a775-8b5b1b312dc5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 20:43:20
23453	9d68971e-4003-4d6b-a8fa-29a76fda978c	9d68971e-43f2-4507-807f-6f3054f1947c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":176,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:02:55
32931	9d69a711-77fa-4769-85b8-c49a3e5f0a67	9d69a711-847f-4cc2-a775-8b5b1b312dc5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Abono', \\"itemloans_aprobador\\" = 12, \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = 100000, \\"itemloans_cuota_cancelada\\" = 400000, \\"updated_at\\" = '2024-11-04 20:43:20' where \\"id\\" = 411","time":"2.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":617,"hash":"6acd4a1714feb503cbc85629417266cf","hostname":"EderCortes"}	2024-11-04 20:43:20
32932	9d69a711-7840-48dc-8582-233cd29a384d	9d69a711-847f-4cc2-a775-8b5b1b312dc5	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:411","changes":{"itemloans_status":"Abono","itemloans_aprobador":12,"updated_at":"2024-11-04 20:43:20","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":100000,"itemloans_cuota_cancelada":400000},"hostname":"EderCortes"}	2024-11-04 20:43:20
32933	9d69a711-78c8-49db-ad63-b0895f6e99fe	9d69a711-847f-4cc2-a775-8b5b1b312dc5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"delete from \\"item_loans\\" where \\"loans_codigo\\" = 91 and \\"itemloans_status\\" = 'Pendiente'","time":"0.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":624,"hash":"89bf3c496a8b0746ff5d1219b8dc29e3","hostname":"EderCortes"}	2024-11-04 20:43:20
16054	9d64b8f0-e13b-458d-8fca-a38b3378d95f	9d64b8f1-0cbb-497d-b8c7-508a286182f8	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 09:54:10
16055	9d64b8f1-0a7c-4832-ba7f-d65fc8463495	9d64b8f1-0cbb-497d-b8c7-508a286182f8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:54:10
16056	9d64b8f1-0ba0-473c-a332-9d9f8c4a9e5b	9d64b8f1-0cbb-497d-b8c7-508a286182f8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":314,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:54:10
32934	9d69a711-7941-4cc9-a30a-d190cb348921	9d69a711-847f-4cc2-a775-8b5b1b312dc5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 91 limit 1","time":"0.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":627,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 20:43:20
32935	9d69a711-7a01-4aaa-9805-55e7a05ae785	9d69a711-847f-4cc2-a775-8b5b1b312dc5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 1, 410714.28571429, 102678.57142857, 'Pendiente', 'Se realiza abono', '20-11-2024', 0, 0, '2024-11-04 20:43:20', '2024-11-04 20:43:20')","time":"0.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:43:20
32936	9d69a711-7a33-4a79-85e8-9f6f9afc0796	9d69a711-847f-4cc2-a775-8b5b1b312dc5	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:43:20
32937	9d69a711-7aab-450d-8b13-b45641d8102e	9d69a711-847f-4cc2-a775-8b5b1b312dc5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 2, 410714.28571429, 102678.57142857, 'Pendiente', 'Se realiza abono', '06-12-2024', 0, 0, '2024-11-04 20:43:20', '2024-11-04 20:43:20')","time":"0.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:43:20
32938	9d69a711-7ad3-4b4f-9a9a-3607c5ee5efa	9d69a711-847f-4cc2-a775-8b5b1b312dc5	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:43:20
32939	9d69a711-7b68-41b3-87c4-52fbb765d0f5	9d69a711-847f-4cc2-a775-8b5b1b312dc5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 3, 410714.28571429, 102678.57142857, 'Pendiente', 'Se realiza abono', '22-12-2024', 0, 0, '2024-11-04 20:43:20', '2024-11-04 20:43:20')","time":"0.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:43:20
32940	9d69a711-7ba7-429f-8257-a2734837c676	9d69a711-847f-4cc2-a775-8b5b1b312dc5	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:43:20
32941	9d69a711-7c4c-4875-b137-b93508991ce3	9d69a711-847f-4cc2-a775-8b5b1b312dc5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 4, 410714.28571429, 102678.57142857, 'Pendiente', 'Se realiza abono', '07-01-2025', 0, 0, '2024-11-04 20:43:20', '2024-11-04 20:43:20')","time":"0.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:43:20
32942	9d69a711-7c7d-49a4-80b1-84b5df849f44	9d69a711-847f-4cc2-a775-8b5b1b312dc5	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:43:20
32943	9d69a711-7d06-496a-8e14-df4939a71986	9d69a711-847f-4cc2-a775-8b5b1b312dc5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 5, 410714.28571429, 102678.57142857, 'Pendiente', 'Se realiza abono', '23-01-2025', 0, 0, '2024-11-04 20:43:20', '2024-11-04 20:43:20')","time":"0.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:43:20
32944	9d69a711-7d34-4c05-a620-9e2d44579fa9	9d69a711-847f-4cc2-a775-8b5b1b312dc5	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:43:20
16057	9d64b8f1-7574-49ea-a544-f9edc24bd98e	9d64b8f1-9bfb-4c38-8f1d-4e80595e278b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:54:11
16058	9d64b8f1-90d0-4d7e-9d0f-7a048786f1d1	9d64b8f1-9bfb-4c38-8f1d-4e80595e278b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 22\\n                        ","time":"49.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"f9344e277d181987f84c6dcddcb4342d","hostname":"EderCortes"}	2024-11-02 09:54:11
16059	9d64b8f1-94ee-45f4-8702-51fcaccd3911	9d64b8f1-9bfb-4c38-8f1d-4e80595e278b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '22' order by \\"item_loans\\".\\"id\\" asc","time":"2.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:54:11
16060	9d64b8f1-953f-4389-94ff-a748d2d0bf63	9d64b8f1-9bfb-4c38-8f1d-4e80595e278b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-02 09:54:11
16061	9d64b8f1-9a77-4c8a-a044-3e4ddd96cfc5	9d64b8f1-9bfb-4c38-8f1d-4e80595e278b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:54:11
16062	9d64b8f1-9ad8-4892-947f-8a404e59906a	9d64b8f1-9bfb-4c38-8f1d-4e80595e278b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/22","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":22,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":70,"loans_codigo":22,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":71,"loans_codigo":22,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":72,"loans_codigo":22,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":73,"loans_codigo":22,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":74,"loans_codigo":22,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":75,"loans_codigo":22,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-04-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":324,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:54:11
23454	9d68971e-aa96-4ad9-a3a6-fdc1b8e6dbac	9d68971f-0653-4529-9f20-314204a5beb9	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 08:02:55
19575	9d66e0bd-8647-4f3d-9c1b-a54378d48839	9d66e0bd-a358-4c91-8647-6045da23d57a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 11:37:07
19576	9d66e0bd-a1c8-462e-be23-62aa3b60f343	9d66e0bd-a358-4c91-8647-6045da23d57a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 11:37:07
19577	9d66e0bd-a25c-46cd-9a14-241aabe1ef27	9d66e0bd-a358-4c91-8647-6045da23d57a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:37:07
23455	9d68971e-f43d-4771-962c-bf52c8e43833	9d68971f-0653-4529-9f20-314204a5beb9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 245 limit 1","time":"3.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 08:02:55
23456	9d68971e-f4d4-4cfc-9d2b-654cf286c06b	9d68971f-0653-4529-9f20-314204a5beb9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 08:02:55
23457	9d68971e-f74e-45f2-93a6-9c456200e04d	9d68971f-0653-4529-9f20-314204a5beb9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 69 limit 1","time":"2.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 08:02:55
23458	9d68971e-f78d-4ca9-8480-002d14179479	9d68971f-0653-4529-9f20-314204a5beb9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 08:02:55
23459	9d68971e-fb32-4681-a19c-f1ff567530a8	9d68971f-0653-4529-9f20-314204a5beb9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '57500', \\"itemloans_cuota_cancelada\\" = '230000', \\"updated_at\\" = '2024-11-04 08:02:55' where \\"id\\" = 245","time":"7.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":400,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 08:02:55
23460	9d68971e-fbc3-43e3-a829-eab016d40743	9d68971f-0653-4529-9f20-314204a5beb9	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:245","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 08:02:55","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000"},"hostname":"EderCortes"}	2024-11-04 08:02:55
23461	9d68971e-fce6-4d2b-95d3-28c27d16a72a	9d68971f-0653-4529-9f20-314204a5beb9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 172500, \\"loans_pago_prestado\\" = 690000, \\"updated_at\\" = '2024-11-04 08:02:55' where \\"id\\" = 69","time":"1.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":408,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 08:02:55
23462	9d68971e-fd32-43c0-97a1-e83bac81e7f2	9d68971f-0653-4529-9f20-314204a5beb9	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:69","changes":{"updated_at":"2024-11-04 08:02:55","loans_pago_interes":172500,"loans_pago_prestado":690000},"hostname":"EderCortes"}	2024-11-04 08:02:55
23463	9d68971f-043b-4521-b2eb-60050d03a3eb	9d68971f-0653-4529-9f20-314204a5beb9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 08:02:55
16063	9d64b8f3-76c3-4870-a210-956aac923cc9	9d64b8f3-9b33-4010-bb2e-eed2139cb908	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:54:12
16064	9d64b8f3-93d7-4f22-8d3e-0de1746fc54b	9d64b8f3-9b33-4010-bb2e-eed2139cb908	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"48.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 09:54:12
16065	9d64b8f3-9431-446a-96c5-4e83ab594bd0	9d64b8f3-9b33-4010-bb2e-eed2139cb908	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 09:54:12
16066	9d64b8f3-993e-4881-8a29-42c40003c8de	9d64b8f3-9b33-4010-bb2e-eed2139cb908	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 09:54:12
16067	9d64b8f3-99d2-41df-b8f9-54451926b962	9d64b8f3-9b33-4010-bb2e-eed2139cb908	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":390,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:54:12
19578	9d66e0bd-f06e-4c1b-ada3-b658f63667fb	9d66e0be-1037-4979-a994-256f5606501c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 11:37:07
19579	9d66e0be-06fe-4c2a-97d4-1df6bd65c02f	9d66e0be-1037-4979-a994-256f5606501c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"43.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 11:37:07
19580	9d66e0be-0aad-470c-bd38-6db60efb7780	9d66e0be-1037-4979-a994-256f5606501c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:37:07
19581	9d66e0be-0aef-445d-ac55-89f430cb6a45	9d66e0be-1037-4979-a994-256f5606501c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:37:07
19582	9d66e0be-0ef7-4bf1-9814-5bac3ec6ce8f	9d66e0be-1037-4979-a994-256f5606501c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 11:37:07
19583	9d66e0be-0f44-4a08-82f8-2a4312fd59b0	9d66e0be-1037-4979-a994-256f5606501c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:37:07
32945	9d69a711-7db2-4be9-9d9c-b397df8ff44b	9d69a711-847f-4cc2-a775-8b5b1b312dc5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 6, 410714.28571429, 102678.57142857, 'Pendiente', 'Se realiza abono', '08-02-2025', 0, 0, '2024-11-04 20:43:20', '2024-11-04 20:43:20')","time":"0.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:43:20
32946	9d69a711-7df1-42fc-951f-b04feb0cfa89	9d69a711-847f-4cc2-a775-8b5b1b312dc5	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:43:20
19584	9d66e0bf-8228-488d-819c-67ec00b9f1ed	9d66e0bf-db97-4ff4-80dd-1c709a9d08da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 11:37:08
19585	9d66e0bf-d49a-4ac2-bef0-b862219e018d	9d66e0bf-db97-4ff4-80dd-1c709a9d08da	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"184.85","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:37:08
19586	9d66e0bf-d52f-4bdc-9457-f91d9062254f	9d66e0bf-db97-4ff4-80dd-1c709a9d08da	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:37:08
19587	9d66e0bf-d93d-46ab-953d-48ad16d17d96	9d66e0bf-db97-4ff4-80dd-1c709a9d08da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 11:37:08
19588	9d66e0bf-d9f6-4a90-98c8-da7eb52ecd97	9d66e0bf-db97-4ff4-80dd-1c709a9d08da	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":485,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:37:08
23464	9d68971f-04b2-46e4-8df1-e055cac8f078	9d68971f-0653-4529-9f20-314204a5beb9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"179","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000","id":245,"loans_codigo":69,"itemloans_cuota":"3","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":420,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:02:55
32947	9d69a711-7e67-40b3-9015-719b2dff55b9	9d69a711-847f-4cc2-a775-8b5b1b312dc5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 7, 410714.28571429, 102678.57142857, 'Pendiente', 'Se realiza abono', '24-02-2025', 0, 0, '2024-11-04 20:43:20', '2024-11-04 20:43:20')","time":"0.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:43:20
32948	9d69a711-7e90-4c96-855d-644df0c8f75d	9d69a711-847f-4cc2-a775-8b5b1b312dc5	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:43:20
32949	9d69a711-82fe-4f77-b695-33129f0d97f3	9d69a711-847f-4cc2-a775-8b5b1b312dc5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 20:43:20
32950	9d69a711-834e-4e5b-9fe6-235f602e6b7f	9d69a711-847f-4cc2-a775-8b5b1b312dc5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"61","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"500000","idLoans":91,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El abono fue aplicado exitosamente","status":true},"duration":283,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:43:20
23465	9d68971f-70fd-41bf-9a55-cc01a2a4bee7	9d68971f-c10d-4b8f-9ecf-07b8aba76b83	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 08:02:55
23466	9d68971f-b5d8-4f12-b436-09d3c1ccb83b	9d68971f-c10d-4b8f-9ecf-07b8aba76b83	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 69\\n                        ","time":"162.90","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"28d3d4f6fe6eff992a986b780c628d2e","hostname":"EderCortes"}	2024-11-04 08:02:55
23467	9d68971f-ba7b-42aa-8ab7-a28fabcf6971	9d68971f-c10d-4b8f-9ecf-07b8aba76b83	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '69' order by \\"item_loans\\".\\"id\\" asc","time":"3.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:02:55
23468	9d68971f-bab9-476f-a731-fe56955b01b2	9d68971f-c10d-4b8f-9ecf-07b8aba76b83	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 08:02:55
23469	9d68971f-bf26-460f-9880-ff00bbba2d4a	9d68971f-c10d-4b8f-9ecf-07b8aba76b83	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 08:02:55
23470	9d68971f-bfa9-4f1d-853e-9b0ebff9c353	9d68971f-c10d-4b8f-9ecf-07b8aba76b83	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/69","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":69,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1150000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"690000","loans_pago_interes":"172500"},"items":[{"id":243,"loans_codigo":69,"itemloans_cuota":"1","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T13:01:48.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000"},{"id":244,"loans_codigo":69,"itemloans_cuota":"2","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T13:01:54.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000"},{"id":245,"loans_codigo":69,"itemloans_cuota":"3","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T13:02:55.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000"},{"id":246,"loans_codigo":69,"itemloans_cuota":"4","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T05:49:09.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":247,"loans_codigo":69,"itemloans_cuota":"5","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T05:49:09.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":450,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:02:55
32951	9d69a711-d343-4eac-8c92-683b017653de	9d69a711-f22b-447e-b8c4-e06f78e3fe9b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 20:43:20
32952	9d69a711-ea6f-45e5-836d-6f47d27ba69a	9d69a711-f22b-447e-b8c4-e06f78e3fe9b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 91\\n                        ","time":"44.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"9ae30bc69b6b272f3f51ff48e54319f5","hostname":"EderCortes"}	2024-11-04 20:43:20
32953	9d69a711-ed38-4884-988a-a39ff329ce79	9d69a711-f22b-447e-b8c4-e06f78e3fe9b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '91' order by \\"item_loans\\".\\"id\\" asc","time":"2.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 20:43:20
32954	9d69a711-f080-4cf1-af10-bae3e6a07d68	9d69a711-f22b-447e-b8c4-e06f78e3fe9b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 20:43:20
23471	9d689726-a949-4290-8b11-abd422bd12c2	9d689726-ac5b-486f-8275-a708ac08eaf3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":143,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:03:00
32955	9d69a711-f0f1-447f-b997-c77125f27005	9d69a711-f22b-447e-b8c4-e06f78e3fe9b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/91","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":91,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":8,"loans_valor_prestado":5000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"2125000","loans_pago_interes":"531250","user_alias":"eder.cortes"},"items":[{"id":371,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 17:44:55","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"200000","itemloans_cuota_cancelada":"800000","user_alias":"eder.cortes"},{"id":403,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 20:42:05","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"131250","itemloans_cuota_cancelada":"525000","user_alias":"eder.cortes"},{"id":404,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 20:42:18","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000","user_alias":"eder.cortes"},{"id":411,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"467857.14285714","itemloans_iteres":"116964.28571429","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 20:42:18","updated_at":"2024-11-04 20:43:20","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000","user_alias":"eder.cortes"},{"id":418,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"410714.28571429","itemloans_iteres":"102678.57142857","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:43:20","updated_at":"2024-11-04 20:43:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":419,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"410714.28571429","itemloans_iteres":"102678.57142857","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:43:20","updated_at":"2024-11-04 20:43:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":420,"loans_codigo":91,"itemloans_cuota":"3","itemloans_valor_cuota":"410714.28571429","itemloans_iteres":"102678.57142857","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:43:20","updated_at":"2024-11-04 20:43:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":421,"loans_codigo":91,"itemloans_cuota":"4","itemloans_valor_cuota":"410714.28571429","itemloans_iteres":"102678.57142857","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:43:20","updated_at":"2024-11-04 20:43:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":422,"loans_codigo":91,"itemloans_cuota":"5","itemloans_valor_cuota":"410714.28571429","itemloans_iteres":"102678.57142857","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:43:20","updated_at":"2024-11-04 20:43:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":423,"loans_codigo":91,"itemloans_cuota":"6","itemloans_valor_cuota":"410714.28571429","itemloans_iteres":"102678.57142857","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:43:20","updated_at":"2024-11-04 20:43:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":424,"loans_codigo":91,"itemloans_cuota":"7","itemloans_valor_cuota":"410714.28571429","itemloans_iteres":"102678.57142857","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:43:20","updated_at":"2024-11-04 20:43:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":257,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:43:20
23472	9d689727-1079-4bf8-a66b-10fbb8a724bc	9d689727-2fee-4643-9205-b506de7f247b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 08:03:00
23473	9d689727-271e-44c9-abcf-9ea1d247b81a	9d689727-2fee-4643-9205-b506de7f247b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 246 limit 1","time":"2.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 08:03:00
23474	9d689727-2765-4a14-8d13-c1ce75e30747	9d689727-2fee-4643-9205-b506de7f247b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 08:03:00
23475	9d689727-28d2-4410-862f-4e035b88a662	9d689727-2fee-4643-9205-b506de7f247b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 69 limit 1","time":"1.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 08:03:00
23476	9d689727-2900-45d0-babe-d503b8bd4a77	9d689727-2fee-4643-9205-b506de7f247b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 08:03:00
23477	9d689727-2a93-4409-a535-036c44c6e3bd	9d689727-2fee-4643-9205-b506de7f247b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '57500', \\"itemloans_cuota_cancelada\\" = '230000', \\"updated_at\\" = '2024-11-04 08:03:00' where \\"id\\" = 246","time":"2.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":400,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 08:03:00
23478	9d689727-2ae2-423f-be43-3cee08a8d48f	9d689727-2fee-4643-9205-b506de7f247b	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:246","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 08:03:00","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000"},"hostname":"EderCortes"}	2024-11-04 08:03:00
23479	9d689727-2b82-4df8-b100-506cc3b0925b	9d689727-2fee-4643-9205-b506de7f247b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 230000, \\"loans_pago_prestado\\" = 920000, \\"updated_at\\" = '2024-11-04 08:03:00' where \\"id\\" = 69","time":"0.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":408,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 08:03:00
23480	9d689727-2bb2-4d06-86e2-e2584bfe8315	9d689727-2fee-4643-9205-b506de7f247b	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:69","changes":{"updated_at":"2024-11-04 08:03:00","loans_pago_interes":230000,"loans_pago_prestado":920000},"hostname":"EderCortes"}	2024-11-04 08:03:00
23481	9d689727-2e9b-4bed-bba2-3a29feecb2bc	9d689727-2fee-4643-9205-b506de7f247b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 08:03:00
23482	9d689727-2edb-45ea-a3c3-9230e8d59867	9d689727-2fee-4643-9205-b506de7f247b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"179","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000","id":246,"loans_codigo":69,"itemloans_cuota":"4","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:03:00
32956	9d69a786-014f-45b9-89db-d1c51391a2ab	9d69a786-046a-47c0-be15-b660a69e20f8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":166,"memory":20,"hostname":"EderCortes"}	2024-11-04 20:44:37
32957	9d69a786-6325-45c1-aa78-a712e778951e	9d69a786-9329-47a2-8eb9-b7e197a1bb0d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 20:44:37
32958	9d69a786-7fc9-4bf1-b096-26cdca8f934c	9d69a786-9329-47a2-8eb9-b7e197a1bb0d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 91 limit 1","time":"3.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":505,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 20:44:37
32959	9d69a786-8037-45b3-a20e-4505d28e0de7	9d69a786-9329-47a2-8eb9-b7e197a1bb0d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":2,"hostname":"EderCortes"}	2024-11-04 20:44:37
32960	9d69a786-8278-42b2-9518-f4142d0bae49	9d69a786-9329-47a2-8eb9-b7e197a1bb0d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select count(*) as aggregate from \\"item_loans\\" where \\"loans_codigo\\" = 91 and \\"itemloans_status\\" = 'Pagada'","time":"3.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":563,"hash":"60bd91eaa209a639fc2e8afc20430a4b","hostname":"EderCortes"}	2024-11-04 20:44:37
17448	9d655a71-79c8-467d-b8b6-b46d549f76f2	9d655a71-96b6-4bc5-9909-9319b1bb283d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 17:25:46
17449	9d655a71-94b6-4dd8-a1d8-d908c607fcb8	9d655a71-96b6-4bc5-9909-9319b1bb283d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 17:25:46
17450	9d655a71-95ab-4766-9fc2-5ac4bace1018	9d655a71-96b6-4bc5-9909-9319b1bb283d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:25:46
23483	9d689727-710a-4d54-bc0c-9670670cc3ce	9d689727-b923-4318-94b9-aa31551e7e91	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 08:03:01
32961	9d69a786-8339-48da-914c-2676e443917d	9d69a786-9329-47a2-8eb9-b7e197a1bb0d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 631250, \\"loans_pago_prestado\\" = 2525000, \\"updated_at\\" = '2024-11-04 20:44:37' where \\"id\\" = 91","time":"0.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":602,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 20:44:37
32962	9d69a786-8396-41ff-b2af-2c6fd3d3130b	9d69a786-9329-47a2-8eb9-b7e197a1bb0d	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:91","changes":{"updated_at":"2024-11-04 20:44:37","loans_pago_interes":631250,"loans_pago_prestado":2525000},"hostname":"EderCortes"}	2024-11-04 20:44:37
32963	9d69a786-8447-4291-b316-24e9188ff32f	9d69a786-9329-47a2-8eb9-b7e197a1bb0d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 91 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"1.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":609,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 20:44:37
32964	9d69a786-8473-44ba-a808-7dd769c8113f	9d69a786-9329-47a2-8eb9-b7e197a1bb0d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 20:44:37
32965	9d69a786-85d0-4106-abad-cbf04869d0fd	9d69a786-9329-47a2-8eb9-b7e197a1bb0d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Abono', \\"itemloans_aprobador\\" = 12, \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = 100000, \\"itemloans_cuota_cancelada\\" = 400000, \\"updated_at\\" = '2024-11-04 20:44:37' where \\"id\\" = 418","time":"2.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":617,"hash":"6acd4a1714feb503cbc85629417266cf","hostname":"EderCortes"}	2024-11-04 20:44:37
32966	9d69a786-8604-4e96-8620-16b67046478e	9d69a786-9329-47a2-8eb9-b7e197a1bb0d	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:418","changes":{"itemloans_status":"Abono","itemloans_aprobador":12,"updated_at":"2024-11-04 20:44:37","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":100000,"itemloans_cuota_cancelada":400000},"hostname":"EderCortes"}	2024-11-04 20:44:37
32967	9d69a786-866b-4be5-98be-14911dcebda2	9d69a786-9329-47a2-8eb9-b7e197a1bb0d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"delete from \\"item_loans\\" where \\"loans_codigo\\" = 91 and \\"itemloans_status\\" = 'Pendiente'","time":"0.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":624,"hash":"89bf3c496a8b0746ff5d1219b8dc29e3","hostname":"EderCortes"}	2024-11-04 20:44:37
32968	9d69a786-86cc-47a5-b4b2-cd14368358b4	9d69a786-9329-47a2-8eb9-b7e197a1bb0d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 91 limit 1","time":"0.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":627,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 20:44:37
32969	9d69a786-8773-46de-ba80-0db42c5a4538	9d69a786-9329-47a2-8eb9-b7e197a1bb0d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 2, 353571.42857143, 88392.857142857, 'Pendiente', 'Se realiza abono', '20-11-2024', 0, 0, '2024-11-04 20:44:37', '2024-11-04 20:44:37')","time":"0.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:44:37
32970	9d69a786-879a-4b1d-9364-053e6d3ab801	9d69a786-9329-47a2-8eb9-b7e197a1bb0d	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:44:37
32971	9d69a786-8820-423d-9fc8-4f1a504c1223	9d69a786-9329-47a2-8eb9-b7e197a1bb0d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 3, 353571.42857143, 88392.857142857, 'Pendiente', 'Se realiza abono', '06-12-2024', 0, 0, '2024-11-04 20:44:37', '2024-11-04 20:44:37')","time":"0.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:44:37
32972	9d69a786-884a-4498-8e14-334292134b51	9d69a786-9329-47a2-8eb9-b7e197a1bb0d	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:44:37
32973	9d69a786-88c3-4055-9f8e-efe284f3ad37	9d69a786-9329-47a2-8eb9-b7e197a1bb0d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 4, 353571.42857143, 88392.857142857, 'Pendiente', 'Se realiza abono', '22-12-2024', 0, 0, '2024-11-04 20:44:37', '2024-11-04 20:44:37')","time":"0.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:44:37
32974	9d69a786-88f1-4ac5-b69e-29e41d1211a9	9d69a786-9329-47a2-8eb9-b7e197a1bb0d	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:44:37
17451	9d655a71-dfb9-4a3c-bdb1-203cc50e447f	9d655a71-fb8f-47a2-a290-85e1d5d50e5a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 17:25:46
17452	9d655a71-f74b-432c-8eb3-4877964765fb	9d655a71-fb8f-47a2-a290-85e1d5d50e5a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"44.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":46,"hash":"fb4ded687569d92428336ceae5c6ffcd","hostname":"EderCortes"}	2024-11-02 17:25:46
17453	9d655a71-fa59-46ae-aa96-620e703ad2a9	9d655a71-fb8f-47a2-a290-85e1d5d50e5a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 17:25:46
17454	9d655a71-faac-41e0-bac7-a5f601c3fc2c	9d655a71-fb8f-47a2-a290-85e1d5d50e5a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":221,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:25:46
23484	9d689727-b08a-4951-96cc-515995013cb7	9d689727-b923-4318-94b9-aa31551e7e91	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 69\\n                        ","time":"149.98","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"28d3d4f6fe6eff992a986b780c628d2e","hostname":"EderCortes"}	2024-11-04 08:03:01
19665	9d66e35a-1729-4724-b384-cb07d7527d29	9d66e35a-6bf1-4df2-84fd-86733c37ac08	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 11:44:25
19666	9d66e35a-6900-439f-b2fe-982622757ae7	9d66e35a-6bf1-4df2-84fd-86733c37ac08	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:44:25
19667	9d66e35a-6a71-4a75-b04a-c8c8fb0ec912	9d66e35a-6bf1-4df2-84fd-86733c37ac08	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":429,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:44:25
23485	9d689727-b401-46b6-861b-a51481ec5f9f	9d689727-b923-4318-94b9-aa31551e7e91	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '69' order by \\"item_loans\\".\\"id\\" asc","time":"2.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:03:01
23486	9d689727-b433-4ae0-ae06-bc9f470d1f04	9d689727-b923-4318-94b9-aa31551e7e91	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 08:03:01
23487	9d689727-b7d2-4792-a722-60013e45dfb6	9d689727-b923-4318-94b9-aa31551e7e91	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 08:03:01
23488	9d689727-b817-4d75-9231-e7daf1d637e0	9d689727-b923-4318-94b9-aa31551e7e91	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/69","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":69,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1150000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"920000","loans_pago_interes":"230000"},"items":[{"id":243,"loans_codigo":69,"itemloans_cuota":"1","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T13:01:48.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000"},{"id":244,"loans_codigo":69,"itemloans_cuota":"2","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T13:01:54.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000"},{"id":245,"loans_codigo":69,"itemloans_cuota":"3","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T13:02:55.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000"},{"id":246,"loans_codigo":69,"itemloans_cuota":"4","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T13:03:00.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000"},{"id":247,"loans_codigo":69,"itemloans_cuota":"5","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T05:49:09.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:03:01
17455	9d655a73-aff3-4e0c-8e70-09272bc6a203	9d655a73-ced2-4c98-a468-4cfe69f63ebd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 17:25:47
17456	9d655a73-c91d-43fc-8f59-c50c8a077fef	9d655a73-ced2-4c98-a468-4cfe69f63ebd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 17:25:47
17457	9d655a73-c979-4fe3-8157-78a278eda622	9d655a73-ced2-4c98-a468-4cfe69f63ebd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 17:25:47
17458	9d655a73-cd78-4052-bcf3-e8907866058d	9d655a73-ced2-4c98-a468-4cfe69f63ebd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-02 17:25:47
17459	9d655a73-cdc7-47c6-a56e-d7196ae66640	9d655a73-ced2-4c98-a468-4cfe69f63ebd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":259,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:25:47
19668	9d66e35a-dff5-4f6a-8adf-fa9ecfdaf952	9d66e35b-0271-4785-bbeb-0acf9363bc0e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:44:26
19669	9d66e35a-f79a-41a6-ad53-cbcb90df15ff	9d66e35b-0271-4785-bbeb-0acf9363bc0e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"45.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 11:44:26
19670	9d66e35a-fbf8-4289-b4bc-1c7b0cda8ac0	9d66e35b-0271-4785-bbeb-0acf9363bc0e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:44:26
19671	9d66e35a-fc33-448b-a854-97b3951009e2	9d66e35b-0271-4785-bbeb-0acf9363bc0e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:44:26
19672	9d66e35b-0123-43ae-9e05-435634c658d4	9d66e35b-0271-4785-bbeb-0acf9363bc0e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:44:26
19673	9d66e35b-017a-4ef6-9878-f9d35fdda793	9d66e35b-0271-4785-bbeb-0acf9363bc0e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":334,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:44:26
23489	9d689737-bad7-4b79-8f17-4916e1916696	9d689737-bdfc-44c0-ba19-94a7069117b4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":136,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:03:11
19674	9d66e35c-f9c7-4464-9f32-07c94d6e29a2	9d66e35d-3eac-423d-968f-a8aa2290b08e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:44:27
19675	9d66e35d-39f0-4fd4-9e8c-95670bde2f0e	9d66e35d-3eac-423d-968f-a8aa2290b08e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"144.28","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:44:27
19676	9d66e35d-3a40-4d8e-b806-bd7e2f246b5f	9d66e35d-3eac-423d-968f-a8aa2290b08e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:44:27
19677	9d66e35d-3d7a-4d5d-9f7f-f1740b6dbf24	9d66e35d-3eac-423d-968f-a8aa2290b08e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 11:44:27
19678	9d66e35d-3dbd-40a2-be8b-1d27a93bfbe1	9d66e35d-3eac-423d-968f-a8aa2290b08e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":332,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:44:27
32975	9d69a786-8972-415c-bda0-167c09443ad3	9d69a786-9329-47a2-8eb9-b7e197a1bb0d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 5, 353571.42857143, 88392.857142857, 'Pendiente', 'Se realiza abono', '07-01-2025', 0, 0, '2024-11-04 20:44:37', '2024-11-04 20:44:37')","time":"0.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:44:37
32976	9d69a786-89a0-4ccd-b354-ab7bac4dbef5	9d69a786-9329-47a2-8eb9-b7e197a1bb0d	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:44:37
32977	9d69a786-8a0f-4d3b-9582-df3ae78acda9	9d69a786-9329-47a2-8eb9-b7e197a1bb0d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 6, 353571.42857143, 88392.857142857, 'Pendiente', 'Se realiza abono', '23-01-2025', 0, 0, '2024-11-04 20:44:37', '2024-11-04 20:44:37')","time":"0.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:44:37
32978	9d69a786-8a33-41f8-8484-6782de3319d6	9d69a786-9329-47a2-8eb9-b7e197a1bb0d	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:44:37
32979	9d69a786-8a97-4387-b52b-ce87f73ff19f	9d69a786-9329-47a2-8eb9-b7e197a1bb0d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 7, 353571.42857143, 88392.857142857, 'Pendiente', 'Se realiza abono', '08-02-2025', 0, 0, '2024-11-04 20:44:37', '2024-11-04 20:44:37')","time":"0.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:44:37
32980	9d69a786-8ab6-4503-a284-23ad38f3fb42	9d69a786-9329-47a2-8eb9-b7e197a1bb0d	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:44:37
32981	9d69a786-8b11-4a39-87c3-43423d47da50	9d69a786-9329-47a2-8eb9-b7e197a1bb0d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 8, 353571.42857143, 88392.857142857, 'Pendiente', 'Se realiza abono', '24-02-2025', 0, 0, '2024-11-04 20:44:37', '2024-11-04 20:44:37')","time":"0.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:44:37
32982	9d69a786-8b2e-4781-8901-d5bfa53457d9	9d69a786-9329-47a2-8eb9-b7e197a1bb0d	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:44:37
32983	9d69a786-91b2-4546-b37b-233634a4fc73	9d69a786-9329-47a2-8eb9-b7e197a1bb0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 20:44:37
32984	9d69a786-9204-495e-b49f-298785ac5c62	9d69a786-9329-47a2-8eb9-b7e197a1bb0d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"61","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"500000","idLoans":91,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El abono fue aplicado exitosamente","status":true},"duration":276,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:44:37
23502	9d68975e-1ffb-4e82-878f-1aa09b3b3b10	9d68975e-22c1-4850-8f29-9b3ffdff8e24	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":159,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:03:36
32985	9d69a786-e669-4773-bfa8-fe287cb0bcf2	9d69a787-2deb-4808-82cb-c9229ff33bad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 20:44:37
16174	9d64ba10-8e59-44d9-b74e-9b36adff3e20	9d64ba10-b88a-4342-9c6d-ee3cc304d797	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 09:57:19
16175	9d64ba10-b585-408e-ad61-bf5aeb8990b9	9d64ba10-b88a-4342-9c6d-ee3cc304d797	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:57:19
16176	9d64ba10-b6fb-4602-8c32-13b6cf23a5d1	9d64ba10-b88a-4342-9c6d-ee3cc304d797	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":305,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:57:19
32986	9d69a787-26cf-4995-964e-9ad0bd415e43	9d69a787-2deb-4808-82cb-c9229ff33bad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 91\\n                        ","time":"152.59","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"9ae30bc69b6b272f3f51ff48e54319f5","hostname":"EderCortes"}	2024-11-04 20:44:37
32987	9d69a787-299b-4758-87ad-9d3b7e7330de	9d69a787-2deb-4808-82cb-c9229ff33bad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '91' order by \\"item_loans\\".\\"id\\" asc","time":"2.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 20:44:37
32988	9d69a787-2c83-452d-b5fd-4e060ca0f66c	9d69a787-2deb-4808-82cb-c9229ff33bad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 20:44:37
32989	9d69a787-2cef-4eac-85c3-15e335bb6269	9d69a787-2deb-4808-82cb-c9229ff33bad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/91","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":91,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":8,"loans_valor_prestado":5000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"2525000","loans_pago_interes":"631250","user_alias":"eder.cortes"},"items":[{"id":371,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 17:44:55","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"200000","itemloans_cuota_cancelada":"800000","user_alias":"eder.cortes"},{"id":403,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 20:42:05","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"131250","itemloans_cuota_cancelada":"525000","user_alias":"eder.cortes"},{"id":404,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 20:42:18","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000","user_alias":"eder.cortes"},{"id":411,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"467857.14285714","itemloans_iteres":"116964.28571429","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 20:42:18","updated_at":"2024-11-04 20:43:20","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000","user_alias":"eder.cortes"},{"id":418,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"410714.28571429","itemloans_iteres":"102678.57142857","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 20:43:20","updated_at":"2024-11-04 20:44:37","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000","user_alias":"eder.cortes"},{"id":425,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"353571.42857143","itemloans_iteres":"88392.857142857","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:44:37","updated_at":"2024-11-04 20:44:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":426,"loans_codigo":91,"itemloans_cuota":"3","itemloans_valor_cuota":"353571.42857143","itemloans_iteres":"88392.857142857","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:44:37","updated_at":"2024-11-04 20:44:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":427,"loans_codigo":91,"itemloans_cuota":"4","itemloans_valor_cuota":"353571.42857143","itemloans_iteres":"88392.857142857","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:44:37","updated_at":"2024-11-04 20:44:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":428,"loans_codigo":91,"itemloans_cuota":"5","itemloans_valor_cuota":"353571.42857143","itemloans_iteres":"88392.857142857","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:44:37","updated_at":"2024-11-04 20:44:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":429,"loans_codigo":91,"itemloans_cuota":"6","itemloans_valor_cuota":"353571.42857143","itemloans_iteres":"88392.857142857","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:44:37","updated_at":"2024-11-04 20:44:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":430,"loans_codigo":91,"itemloans_cuota":"7","itemloans_valor_cuota":"353571.42857143","itemloans_iteres":"88392.857142857","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:44:37","updated_at":"2024-11-04 20:44:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":431,"loans_codigo":91,"itemloans_cuota":"8","itemloans_valor_cuota":"353571.42857143","itemloans_iteres":"88392.857142857","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:44:37","updated_at":"2024-11-04 20:44:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:44:37
16177	9d64ba11-26dc-4005-8015-1f184702d915	9d64ba11-4dde-484a-9e19-edd960294eb5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:57:19
16178	9d64ba11-414d-402c-8721-8eec1c362b8e	9d64ba11-4dde-484a-9e19-edd960294eb5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 22\\n                        ","time":"52.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"f9344e277d181987f84c6dcddcb4342d","hostname":"EderCortes"}	2024-11-02 09:57:19
16179	9d64ba11-46f5-41d9-9809-3e91e1dc5236	9d64ba11-4dde-484a-9e19-edd960294eb5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '22' order by \\"item_loans\\".\\"id\\" asc","time":"3.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:57:19
16180	9d64ba11-4749-4ee5-a844-c8ebc51a75ad	9d64ba11-4dde-484a-9e19-edd960294eb5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-02 09:57:19
16181	9d64ba11-4c73-4021-bd41-8df8ddf4597a	9d64ba11-4dde-484a-9e19-edd960294eb5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:57:19
16182	9d64ba11-4cda-4d50-8e93-fecb0da6dd76	9d64ba11-4dde-484a-9e19-edd960294eb5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/22","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":22,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":70,"loans_codigo":22,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":71,"loans_codigo":22,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":72,"loans_codigo":22,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":73,"loans_codigo":22,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":74,"loans_codigo":22,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":75,"loans_codigo":22,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-04-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:57:19
32990	9d69a79b-aaf7-4f6c-bf61-1978ec99c571	9d69a79b-ae7d-485b-90db-9c821ea282fa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":144,"memory":20,"hostname":"EderCortes"}	2024-11-04 20:44:51
16183	9d64ba12-f730-481b-ada5-a1a56705313e	9d64ba13-36db-45f4-9fd3-d5224954c516	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:57:20
16184	9d64ba13-2c18-4f59-9672-601270b5c9ea	9d64ba13-36db-45f4-9fd3-d5224954c516	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"91.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 09:57:21
16185	9d64ba13-2c92-4234-9e12-f1152a502ca9	9d64ba13-36db-45f4-9fd3-d5224954c516	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 09:57:21
16186	9d64ba13-34a1-4746-acc7-a4a5ec4fd7b4	9d64ba13-36db-45f4-9fd3-d5224954c516	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 09:57:21
16187	9d64ba13-353a-422c-b435-49c67f796659	9d64ba13-36db-45f4-9fd3-d5224954c516	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":539,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:57:21
32991	9d69a79c-1a4c-43c2-8bbe-17a10e3d30fa	9d69a79c-6da7-463c-8f49-0ffd502836dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 20:44:51
32992	9d69a79c-5ccd-45e9-bdb4-4bc684506a7f	9d69a79c-6da7-463c-8f49-0ffd502836dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 91 limit 1","time":"2.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":505,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 20:44:51
32993	9d69a79c-5d24-44b3-88d7-c2b55ef9beaa	9d69a79c-6da7-463c-8f49-0ffd502836dd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":2,"hostname":"EderCortes"}	2024-11-04 20:44:51
32994	9d69a79c-5ef3-4ce2-93fc-ea5d9592956c	9d69a79c-6da7-463c-8f49-0ffd502836dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select count(*) as aggregate from \\"item_loans\\" where \\"loans_codigo\\" = 91 and \\"itemloans_status\\" = 'Pagada'","time":"2.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":563,"hash":"60bd91eaa209a639fc2e8afc20430a4b","hostname":"EderCortes"}	2024-11-04 20:44:51
32995	9d69a79c-5fcd-45a4-8bb1-dd580d81461a	9d69a79c-6da7-463c-8f49-0ffd502836dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 731250, \\"loans_pago_prestado\\" = 2925000, \\"updated_at\\" = '2024-11-04 20:44:51' where \\"id\\" = 91","time":"1.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":602,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 20:44:51
32996	9d69a79c-6026-4f0e-b386-7c3b0d82afca	9d69a79c-6da7-463c-8f49-0ffd502836dd	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:91","changes":{"updated_at":"2024-11-04 20:44:51","loans_pago_interes":731250,"loans_pago_prestado":2925000},"hostname":"EderCortes"}	2024-11-04 20:44:51
32997	9d69a79c-60b9-48c0-974d-90a5cfcdb4ad	9d69a79c-6da7-463c-8f49-0ffd502836dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 91 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"0.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":609,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 20:44:51
32998	9d69a79c-60f2-4069-b777-6f41acec5b8c	9d69a79c-6da7-463c-8f49-0ffd502836dd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 20:44:51
32999	9d69a79c-6257-4af6-8b00-ebdb18a34c1f	9d69a79c-6da7-463c-8f49-0ffd502836dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Abono', \\"itemloans_aprobador\\" = 12, \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = 100000, \\"itemloans_cuota_cancelada\\" = 400000, \\"updated_at\\" = '2024-11-04 20:44:51' where \\"id\\" = 425","time":"2.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":617,"hash":"6acd4a1714feb503cbc85629417266cf","hostname":"EderCortes"}	2024-11-04 20:44:51
33000	9d69a79c-6295-423d-bd8b-da3d30671d52	9d69a79c-6da7-463c-8f49-0ffd502836dd	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:425","changes":{"itemloans_status":"Abono","itemloans_aprobador":12,"updated_at":"2024-11-04 20:44:51","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":100000,"itemloans_cuota_cancelada":400000},"hostname":"EderCortes"}	2024-11-04 20:44:51
33001	9d69a79c-62fe-466f-840f-c1601d7166e9	9d69a79c-6da7-463c-8f49-0ffd502836dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"delete from \\"item_loans\\" where \\"loans_codigo\\" = 91 and \\"itemloans_status\\" = 'Pendiente'","time":"0.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":624,"hash":"89bf3c496a8b0746ff5d1219b8dc29e3","hostname":"EderCortes"}	2024-11-04 20:44:51
33002	9d69a79c-636b-4e9e-91b2-fdf6f7a993b2	9d69a79c-6da7-463c-8f49-0ffd502836dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 91 limit 1","time":"0.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":627,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 20:44:51
16188	9d64ba78-11b0-46ce-a227-65f1df95ff0b	9d64ba78-6f68-42fc-b9e7-2cb3aba1888d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 09:58:27
16189	9d64ba78-6451-4045-a0d9-9510ce2c65fb	9d64ba78-6f68-42fc-b9e7-2cb3aba1888d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"168.81","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":24,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-11-02 09:58:27
16190	9d64ba78-6c98-4aa2-8222-a9101cc2daa3	9d64ba78-6f68-42fc-b9e7-2cb3aba1888d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:58:27
16191	9d64ba78-6d4e-404c-8a9e-f9e352f7c60b	9d64ba78-6f68-42fc-b9e7-2cb3aba1888d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":518,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:58:27
33003	9d69a79c-641a-4083-87d7-a5a6f5193e66	9d69a79c-6da7-463c-8f49-0ffd502836dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 2, 296428.57142857, 74107.142857143, 'Pendiente', 'Se realiza abono', '20-11-2024', 0, 0, '2024-11-04 20:44:51', '2024-11-04 20:44:51')","time":"0.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:44:51
33004	9d69a79c-6448-4182-be49-d581fc661b47	9d69a79c-6da7-463c-8f49-0ffd502836dd	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:44:51
33005	9d69a79c-64bf-4369-b847-9c22507d0dd7	9d69a79c-6da7-463c-8f49-0ffd502836dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 3, 296428.57142857, 74107.142857143, 'Pendiente', 'Se realiza abono', '06-12-2024', 0, 0, '2024-11-04 20:44:51', '2024-11-04 20:44:51')","time":"0.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:44:51
33006	9d69a79c-64e7-46ab-90ad-536713641bd1	9d69a79c-6da7-463c-8f49-0ffd502836dd	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:44:51
33007	9d69a79c-655f-47fd-b1a1-9a09da2e84aa	9d69a79c-6da7-463c-8f49-0ffd502836dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 4, 296428.57142857, 74107.142857143, 'Pendiente', 'Se realiza abono', '22-12-2024', 0, 0, '2024-11-04 20:44:51', '2024-11-04 20:44:51')","time":"0.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:44:51
33008	9d69a79c-6586-4262-97cb-504e360c66ce	9d69a79c-6da7-463c-8f49-0ffd502836dd	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:44:51
33009	9d69a79c-660c-4eb1-9ad7-b9fce18a3b3e	9d69a79c-6da7-463c-8f49-0ffd502836dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 5, 296428.57142857, 74107.142857143, 'Pendiente', 'Se realiza abono', '07-01-2025', 0, 0, '2024-11-04 20:44:51', '2024-11-04 20:44:51')","time":"0.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:44:51
33010	9d69a79c-6652-4ec8-ae95-e42fc0110d86	9d69a79c-6da7-463c-8f49-0ffd502836dd	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:44:51
33011	9d69a79c-66e4-43bb-8d18-e5018beb32d5	9d69a79c-6da7-463c-8f49-0ffd502836dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 6, 296428.57142857, 74107.142857143, 'Pendiente', 'Se realiza abono', '23-01-2025', 0, 0, '2024-11-04 20:44:51', '2024-11-04 20:44:51')","time":"0.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:44:51
33012	9d69a79c-670c-4db0-903a-fc06ec8264b9	9d69a79c-6da7-463c-8f49-0ffd502836dd	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:44:51
16192	9d64ba85-7ad1-4c16-bab1-262509a3ee44	9d64ba85-a113-4f02-897b-887111122f23	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:58:36
16193	9d64ba85-9a84-4f69-9b03-6940c14b6f86	9d64ba85-a113-4f02-897b-887111122f23	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"61.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":24,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-11-02 09:58:36
16194	9d64ba85-9f26-425e-afaf-46d74f00053c	9d64ba85-a113-4f02-897b-887111122f23	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:58:36
16195	9d64ba85-9f9b-42b4-8b71-1d2a9e1fa5e7	9d64ba85-a113-4f02-897b-887111122f23	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":418,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:58:36
33013	9d69a79c-6786-4e02-bfc3-f096e21dd753	9d69a79c-6da7-463c-8f49-0ffd502836dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 7, 296428.57142857, 74107.142857143, 'Pendiente', 'Se realiza abono', '08-02-2025', 0, 0, '2024-11-04 20:44:51', '2024-11-04 20:44:51')","time":"0.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:44:51
33014	9d69a79c-67b0-4d2f-928b-9b32a813b2a2	9d69a79c-6da7-463c-8f49-0ffd502836dd	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:44:51
33015	9d69a79c-6827-46c9-a305-e13eed7e01ce	9d69a79c-6da7-463c-8f49-0ffd502836dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 8, 296428.57142857, 74107.142857143, 'Pendiente', 'Se realiza abono', '24-02-2025', 0, 0, '2024-11-04 20:44:51', '2024-11-04 20:44:51')","time":"0.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:44:51
33016	9d69a79c-684f-4eb3-b770-eb7a3fa491a3	9d69a79c-6da7-463c-8f49-0ffd502836dd	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:44:51
33017	9d69a79c-6c31-4f74-b9eb-36e4d94b412c	9d69a79c-6da7-463c-8f49-0ffd502836dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 20:44:51
33018	9d69a79c-6c94-4111-a170-9daa834dd720	9d69a79c-6da7-463c-8f49-0ffd502836dd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"61","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"500000","idLoans":91,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El abono fue aplicado exitosamente","status":true},"duration":379,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:44:51
16196	9d64ba89-85bf-4e88-9267-951b66d1faf1	9d64ba89-d7b9-4d35-847f-19e243c86a03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:58:38
16197	9d64ba89-cc3c-451e-80b2-a725ce9aafac	9d64ba89-d7b9-4d35-847f-19e243c86a03	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"163.35","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"088d1fdbe045a08c3b0073ef22c7da32","hostname":"EderCortes"}	2024-11-02 09:58:38
16198	9d64ba89-d12e-4025-98ea-3d44ab5f01dd	9d64ba89-d7b9-4d35-847f-19e243c86a03	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"3.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:58:38
16199	9d64ba89-d180-4836-b820-d22e924c9f4e	9d64ba89-d7b9-4d35-847f-19e243c86a03	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 09:58:38
16200	9d64ba89-d5c7-4ed4-bfd8-a5459aa02e41	9d64ba89-d7b9-4d35-847f-19e243c86a03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 09:58:38
16201	9d64ba89-d639-42c1-8efa-24dae4a8a8fa	9d64ba89-d7b9-4d35-847f-19e243c86a03	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":399,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:58:38
33019	9d69a79c-b641-465e-a3b2-8a4be08a37c7	9d69a79c-d45b-4fc2-8016-dc35679e9416	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 20:44:51
33020	9d69a79c-ccf8-4fd7-b825-7b95e8417883	9d69a79c-d45b-4fc2-8016-dc35679e9416	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 91\\n                        ","time":"44.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"9ae30bc69b6b272f3f51ff48e54319f5","hostname":"EderCortes"}	2024-11-04 20:44:51
33021	9d69a79c-cff0-4372-a26d-14815de2de39	9d69a79c-d45b-4fc2-8016-dc35679e9416	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '91' order by \\"item_loans\\".\\"id\\" asc","time":"2.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 20:44:51
33022	9d69a79c-d2de-4c05-99b6-8a0215197d54	9d69a79c-d45b-4fc2-8016-dc35679e9416	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 20:44:51
33023	9d69a79c-d334-4d61-a1a6-27e2876fa6f6	9d69a79c-d45b-4fc2-8016-dc35679e9416	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/91","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":91,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":8,"loans_valor_prestado":5000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"2925000","loans_pago_interes":"731250","user_alias":"eder.cortes"},"items":[{"id":371,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 17:44:55","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"200000","itemloans_cuota_cancelada":"800000","user_alias":"eder.cortes"},{"id":403,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 20:42:05","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"131250","itemloans_cuota_cancelada":"525000","user_alias":"eder.cortes"},{"id":404,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 20:42:18","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000","user_alias":"eder.cortes"},{"id":411,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"467857.14285714","itemloans_iteres":"116964.28571429","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 20:42:18","updated_at":"2024-11-04 20:43:20","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000","user_alias":"eder.cortes"},{"id":418,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"410714.28571429","itemloans_iteres":"102678.57142857","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 20:43:20","updated_at":"2024-11-04 20:44:37","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000","user_alias":"eder.cortes"},{"id":425,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"353571.42857143","itemloans_iteres":"88392.857142857","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 20:44:37","updated_at":"2024-11-04 20:44:51","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000","user_alias":"eder.cortes"},{"id":432,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"296428.57142857","itemloans_iteres":"74107.142857143","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:44:51","updated_at":"2024-11-04 20:44:51","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":433,"loans_codigo":91,"itemloans_cuota":"3","itemloans_valor_cuota":"296428.57142857","itemloans_iteres":"74107.142857143","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:44:51","updated_at":"2024-11-04 20:44:51","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":434,"loans_codigo":91,"itemloans_cuota":"4","itemloans_valor_cuota":"296428.57142857","itemloans_iteres":"74107.142857143","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:44:51","updated_at":"2024-11-04 20:44:51","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":435,"loans_codigo":91,"itemloans_cuota":"5","itemloans_valor_cuota":"296428.57142857","itemloans_iteres":"74107.142857143","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:44:51","updated_at":"2024-11-04 20:44:51","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":436,"loans_codigo":91,"itemloans_cuota":"6","itemloans_valor_cuota":"296428.57142857","itemloans_iteres":"74107.142857143","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:44:51","updated_at":"2024-11-04 20:44:51","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":437,"loans_codigo":91,"itemloans_cuota":"7","itemloans_valor_cuota":"296428.57142857","itemloans_iteres":"74107.142857143","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:44:51","updated_at":"2024-11-04 20:44:51","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":438,"loans_codigo":91,"itemloans_cuota":"8","itemloans_valor_cuota":"296428.57142857","itemloans_iteres":"74107.142857143","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:44:51","updated_at":"2024-11-04 20:44:51","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:44:51
34848	9d69c0cc-143e-4fd2-be35-1045f2f5d0ae	9d69c0cc-37a6-4d50-95b9-7faf06c63af4	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 21:55:17
34849	9d69c0cc-35b3-44f5-a44c-3cfed78e3ac6	9d69c0cc-37a6-4d50-95b9-7faf06c63af4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:55:17
34850	9d69c0cc-367d-4651-b68a-588566f83478	9d69c0cc-37a6-4d50-95b9-7faf06c63af4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:55:17
36793	9d6b40c5-88bb-4d00-a97f-0c47872806ae	9d6b40c5-8d3d-40de-a02f-a1561090d7f0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1663}	2024-11-05 15:48:57
33024	9d69a7ab-8af6-49d9-ae47-450c9ffe82d7	9d69a7ab-8e36-4650-9bf6-4690d043f89a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-total-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":151,"memory":20,"hostname":"EderCortes"}	2024-11-04 20:45:01
34851	9d69c0cc-9476-4965-927e-4ee8406ba62a	9d69c0cc-b276-48b4-ad1a-fc35646bde08	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:55:17
34852	9d69c0cc-aca3-41b0-886f-2cc364afe1df	9d69c0cc-b276-48b4-ad1a-fc35646bde08	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:55:17
34853	9d69c0cc-acfc-446b-bb04-9319c8e1f1b4	9d69c0cc-b276-48b4-ad1a-fc35646bde08	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:55:17
34854	9d69c0cc-b145-4ecd-989d-08f75159127c	9d69c0cc-b276-48b4-ad1a-fc35646bde08	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:55:17
34855	9d69c0cc-b191-4415-a2dc-d97a4138cb9d	9d69c0cc-b276-48b4-ad1a-fc35646bde08	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":264,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:55:17
33025	9d69a7ac-0eb7-4bc2-9c95-c603057309c1	9d69a7ac-5be0-4ebd-8feb-ac9825bf404a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 20:45:01
33026	9d69a7ac-4f30-4816-bd50-36f7d9895e16	9d69a7ac-5be0-4ebd-8feb-ac9825bf404a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 91 limit 1","time":"2.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":715,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 20:45:02
33027	9d69a7ac-4f81-46ce-881e-4fd57a0efe68	9d69a7ac-5be0-4ebd-8feb-ac9825bf404a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 20:45:02
33028	9d69a7ac-50a4-4707-896a-636ff4c2d81d	9d69a7ac-5be0-4ebd-8feb-ac9825bf404a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_estado\\" = 'Cancelado', \\"loans_pago_interes\\" = 1250000, \\"loans_pago_prestado\\" = 5000000, \\"updated_at\\" = '2024-11-04 20:45:02' where \\"id\\" = 91","time":"0.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":740,"hash":"acfe32aea56c9ca6bdbb917f944a78d1","hostname":"EderCortes"}	2024-11-04 20:45:02
33029	9d69a7ac-5106-40ff-8f95-440b2150a128	9d69a7ac-5be0-4ebd-8feb-ac9825bf404a	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:91","changes":{"loans_estado":"Cancelado","updated_at":"2024-11-04 20:45:02","loans_pago_interes":1250000,"loans_pago_prestado":5000000},"hostname":"EderCortes"}	2024-11-04 20:45:02
33030	9d69a7ac-526a-48d6-a94e-f337a9a3edf9	9d69a7ac-5be0-4ebd-8feb-ac9825bf404a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 91 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"2.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":745,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 20:45:02
33031	9d69a7ac-52a5-4078-92fb-fd5e97301688	9d69a7ac-5be0-4ebd-8feb-ac9825bf404a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 20:45:02
33032	9d69a7ac-53df-4810-be0c-4eb4b155c851	9d69a7ac-5be0-4ebd-8feb-ac9825bf404a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_interes_canelado\\" = '74107.142857143', \\"itemloans_cuota_cancelada\\" = '296428.57142857', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_status\\" = 'Pagada', \\"itemloans_aprobador\\" = 12, \\"updated_at\\" = '2024-11-04 20:45:02' where \\"loans_codigo\\" = 91 and \\"itemloans_status\\" = 'Pendiente'","time":"2.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":754,"hash":"87a64c6113219082cd85f391b598ec7f","hostname":"EderCortes"}	2024-11-04 20:45:02
33033	9d69a7ac-5a98-43bb-9c67-51e5c36a8bc5	9d69a7ac-5be0-4ebd-8feb-ac9825bf404a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 20:45:02
33034	9d69a7ac-5ae3-4f4e-a4cd-246928a9cafb	9d69a7ac-5be0-4ebd-8feb-ac9825bf404a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-total-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payTotal","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"39","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"idLoans":91,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"Se ha realizado el pago total del credito","status":true},"duration":358,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:45:02
34856	9d69c0cc-f403-47f4-b37d-db0440552ac5	9d69c0cd-38e4-4633-9c5f-17b6d22cb52f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:55:17
34857	9d69c0cd-3384-4e69-9a03-9cb3d52c1c7d	9d69c0cd-38e4-4633-9c5f-17b6d22cb52f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"139.89","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 21:55:18
34858	9d69c0cd-33da-4e94-b355-6bca60f3068d	9d69c0cd-38e4-4633-9c5f-17b6d22cb52f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 21:55:18
34859	9d69c0cd-37b6-410a-9979-887e0296ea78	9d69c0cd-38e4-4633-9c5f-17b6d22cb52f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:55:18
34860	9d69c0cd-3803-49d7-8bed-414da1898586	9d69c0cd-38e4-4633-9c5f-17b6d22cb52f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:55:18
33953	9d69b839-181e-4f79-a17e-443003438b7c	9d69b839-2066-4d18-bd2f-d68bd4764ec1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 82\\n                        ","time":"42.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"23238af5dc47e80ea555e80a08e2015d","hostname":"EderCortes"}	2024-11-04 21:31:18
33954	9d69b839-1b4a-42c9-bc69-e16b11cdba15	9d69b839-2066-4d18-bd2f-d68bd4764ec1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '82' order by \\"item_loans\\".\\"id\\" asc","time":"2.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:31:18
33035	9d69a7ac-a69a-4be4-9224-d7589a71e4f1	9d69a7ac-c3e1-474f-b82f-0bd1e6d08859	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 20:45:02
19755	9d66e5cd-2863-495e-8e9f-d7fe0beaeceb	9d66e5cd-5207-4d69-b25e-3ecc2e32e571	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 11:51:16
19756	9d66e5cd-4ef9-4644-855d-8a6a868a9031	9d66e5cd-5207-4d69-b25e-3ecc2e32e571	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:51:16
19757	9d66e5cd-5079-4e2c-b74a-cc823a554b79	9d66e5cd-5207-4d69-b25e-3ecc2e32e571	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":303,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:51:16
33036	9d69a7ac-bc22-4cc9-ad06-a1a2dfd22961	9d69a7ac-c3e1-474f-b82f-0bd1e6d08859	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 91\\n                        ","time":"43.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"9ae30bc69b6b272f3f51ff48e54319f5","hostname":"EderCortes"}	2024-11-04 20:45:02
33037	9d69a7ac-befe-481e-8758-5f27446b4e6d	9d69a7ac-c3e1-474f-b82f-0bd1e6d08859	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '91' order by \\"item_loans\\".\\"id\\" asc","time":"2.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 20:45:02
33038	9d69a7ac-c285-4614-b608-40ed9a3de4e3	9d69a7ac-c3e1-474f-b82f-0bd1e6d08859	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 20:45:02
33955	9d69b839-1e90-49ac-9808-71ee213e90a7	9d69b839-2066-4d18-bd2f-d68bd4764ec1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:31:18
33956	9d69b839-1f07-4010-b7c1-02071f3adb2d	9d69b839-2066-4d18-bd2f-d68bd4764ec1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/82","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":82,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"480000","loans_pago_interes":"120000","user_alias":"eder.cortes"},"items":[{"id":316,"loans_codigo":82,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:36","updated_at":"2024-11-04 21:29:42","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":464,"loans_codigo":82,"itemloans_cuota":"2","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 21:29:42","updated_at":"2024-11-04 21:31:18","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":468,"loans_codigo":82,"itemloans_cuota":"3","itemloans_valor_cuota":"155000","itemloans_iteres":"38750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:31:18","updated_at":"2024-11-04 21:31:18","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":469,"loans_codigo":82,"itemloans_cuota":"4","itemloans_valor_cuota":"155000","itemloans_iteres":"38750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:31:18","updated_at":"2024-11-04 21:31:18","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":470,"loans_codigo":82,"itemloans_cuota":"5","itemloans_valor_cuota":"155000","itemloans_iteres":"38750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:31:18","updated_at":"2024-11-04 21:31:18","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":471,"loans_codigo":82,"itemloans_cuota":"6","itemloans_valor_cuota":"155000","itemloans_iteres":"38750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:31:18","updated_at":"2024-11-04 21:31:18","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:31:18
34861	9d69c0cd-7c90-47a3-8abc-d31b80dece3f	9d69c0cd-998d-4490-9874-4291de26bc00	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:55:18
19758	9d66e5cd-c8d8-4ed4-942a-cc260a635e8b	9d66e5ce-13f0-4900-b7ba-3efcc6657bf9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:51:16
19759	9d66e5ce-0907-4a51-871f-9e518833d4bf	9d66e5ce-13f0-4900-b7ba-3efcc6657bf9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"149.30","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 11:51:17
19760	9d66e5ce-0cc8-48cc-b651-d7526ab1d238	9d66e5ce-13f0-4900-b7ba-3efcc6657bf9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:51:17
19761	9d66e5ce-0d0d-4833-aff3-4e2bf1500bd4	9d66e5ce-13f0-4900-b7ba-3efcc6657bf9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:51:17
19762	9d66e5ce-127c-441f-99ba-10806ae64317	9d66e5ce-13f0-4900-b7ba-3efcc6657bf9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:51:17
19763	9d66e5ce-12d6-4aaf-a7b1-8065ef3ac08a	9d66e5ce-13f0-4900-b7ba-3efcc6657bf9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"100000","loans_pago_interes":"50000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":422,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:51:17
33039	9d69a7ac-c2db-4601-80f7-67ea735e2047	9d69a7ac-c3e1-474f-b82f-0bd1e6d08859	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/91","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":91,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":8,"loans_valor_prestado":5000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"5000000","loans_pago_interes":"1250000","user_alias":"eder.cortes"},"items":[{"id":371,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 17:44:55","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"200000","itemloans_cuota_cancelada":"800000","user_alias":"eder.cortes"},{"id":403,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 20:42:05","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"131250","itemloans_cuota_cancelada":"525000","user_alias":"eder.cortes"},{"id":404,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 20:42:18","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000","user_alias":"eder.cortes"},{"id":411,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"467857.14285714","itemloans_iteres":"116964.28571429","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 20:42:18","updated_at":"2024-11-04 20:43:20","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000","user_alias":"eder.cortes"},{"id":418,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"410714.28571429","itemloans_iteres":"102678.57142857","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 20:43:20","updated_at":"2024-11-04 20:44:37","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000","user_alias":"eder.cortes"},{"id":425,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"353571.42857143","itemloans_iteres":"88392.857142857","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 20:44:37","updated_at":"2024-11-04 20:44:51","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000","user_alias":"eder.cortes"},{"id":432,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"296428.57142857","itemloans_iteres":"74107.142857143","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 20:44:51","updated_at":"2024-11-04 20:45:02","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"74107.142857143","itemloans_cuota_cancelada":"296428.57142857","user_alias":"eder.cortes"},{"id":433,"loans_codigo":91,"itemloans_cuota":"3","itemloans_valor_cuota":"296428.57142857","itemloans_iteres":"74107.142857143","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 20:44:51","updated_at":"2024-11-04 20:45:02","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"74107.142857143","itemloans_cuota_cancelada":"296428.57142857","user_alias":"eder.cortes"},{"id":434,"loans_codigo":91,"itemloans_cuota":"4","itemloans_valor_cuota":"296428.57142857","itemloans_iteres":"74107.142857143","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 20:44:51","updated_at":"2024-11-04 20:45:02","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"74107.142857143","itemloans_cuota_cancelada":"296428.57142857","user_alias":"eder.cortes"},{"id":435,"loans_codigo":91,"itemloans_cuota":"5","itemloans_valor_cuota":"296428.57142857","itemloans_iteres":"74107.142857143","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 20:44:51","updated_at":"2024-11-04 20:45:02","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"74107.142857143","itemloans_cuota_cancelada":"296428.57142857","user_alias":"eder.cortes"},{"id":436,"loans_codigo":91,"itemloans_cuota":"6","itemloans_valor_cuota":"296428.57142857","itemloans_iteres":"74107.142857143","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 20:44:51","updated_at":"2024-11-04 20:45:02","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"74107.142857143","itemloans_cuota_cancelada":"296428.57142857","user_alias":"eder.cortes"},{"id":437,"loans_codigo":91,"itemloans_cuota":"7","itemloans_valor_cuota":"296428.57142857","itemloans_iteres":"74107.142857143","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 20:44:51","updated_at":"2024-11-04 20:45:02","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"74107.142857143","itemloans_cuota_cancelada":"296428.57142857","user_alias":"eder.cortes"},{"id":438,"loans_codigo":91,"itemloans_cuota":"8","itemloans_valor_cuota":"296428.57142857","itemloans_iteres":"74107.142857143","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 20:44:51","updated_at":"2024-11-04 20:45:02","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"74107.142857143","itemloans_cuota_cancelada":"296428.57142857","user_alias":"eder.cortes"}]}},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:45:02
34862	9d69c0cd-946a-4c24-b90d-fb9dae3ac195	9d69c0cd-998d-4490-9874-4291de26bc00	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:55:18
34863	9d69c0cd-94c0-46ba-bca1-bdccc1ebe205	9d69c0cd-998d-4490-9874-4291de26bc00	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:55:18
34864	9d69c0cd-985a-4b04-b749-1147b634bfc0	9d69c0cd-998d-4490-9874-4291de26bc00	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:55:18
19764	9d66e5d0-0068-4664-a307-b7f3f54acb11	9d66e5d0-1bb8-4a7d-b196-0f46b4ea9df4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:51:18
19765	9d66e5d0-16cf-4e21-983c-d6b60b401cdd	9d66e5d0-1bb8-4a7d-b196-0f46b4ea9df4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"38.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:51:18
19766	9d66e5d0-1717-4f64-984c-f4f4af791748	9d66e5d0-1bb8-4a7d-b196-0f46b4ea9df4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:51:18
19767	9d66e5d0-1a62-40d1-8c97-bccc719a88fe	9d66e5d0-1bb8-4a7d-b196-0f46b4ea9df4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 11:51:18
19768	9d66e5d0-1aab-4769-81ee-b9ae4b7b123a	9d66e5d0-1bb8-4a7d-b196-0f46b4ea9df4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":274,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:51:18
33040	9d69a7b2-b764-44bc-a179-046b8595aeb7	9d69a7b3-0822-4cdc-8b06-d52aa2ecd1df	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 20:45:06
33041	9d69a7b3-0160-4225-9840-b6bc8084f857	9d69a7b3-0822-4cdc-8b06-d52aa2ecd1df	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"177.25","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 20:45:06
33042	9d69a7b3-0637-490a-8666-0df260edf6c7	9d69a7b3-0822-4cdc-8b06-d52aa2ecd1df	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 20:45:06
33043	9d69a7b3-06d2-46ea-8a67-77dc8c4bb385	9d69a7b3-0822-4cdc-8b06-d52aa2ecd1df	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":368,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:45:06
34865	9d69c0cd-98a5-4e74-9086-b610972edfa5	9d69c0cd-998d-4490-9874-4291de26bc00	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:55:18
33044	9d69a7b3-5267-447f-b1da-75f8163faab0	9d69a7b3-7990-42b2-9d87-4098909624ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 20:45:06
33045	9d69a7b3-74c9-4c60-b288-593381251533	9d69a7b3-7990-42b2-9d87-4098909624ed	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"41.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 20:45:06
33046	9d69a7b3-7822-4374-83fb-3543395c3809	9d69a7b3-7990-42b2-9d87-4098909624ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 20:45:06
33047	9d69a7b3-788c-41d1-93ef-bc7c146214f9	9d69a7b3-7990-42b2-9d87-4098909624ed	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":260,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:45:06
33957	9d69b869-8ad6-4d3d-8cb5-f4c8d2c36773	9d69b869-8ea8-4064-9f87-ff91bac1f5c8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":188,"memory":20,"hostname":"EderCortes"}	2024-11-04 21:31:50
33048	9d69a7b7-f67c-4615-a596-d41da7ac591b	9d69a7b8-3a6e-4215-81c3-703e47691d1d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 20:45:09
17526	9d655c49-ec40-43fe-9246-eac605cae88b	9d655c4a-0bce-4965-b20e-5614df5d1f38	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:30:56
17527	9d655c4a-0a27-4822-830e-da53ed963346	9d655c4a-0bce-4965-b20e-5614df5d1f38	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 17:30:56
17528	9d655c4a-0ac9-4a68-bfc9-2e41e5d03db3	9d655c4a-0bce-4965-b20e-5614df5d1f38	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":264,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:30:56
33049	9d69a7b8-3318-4740-8890-adbc2723363b	9d69a7b8-3a6e-4215-81c3-703e47691d1d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"144.10","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 20:45:09
33050	9d69a7b8-35fb-40d7-b1ab-2712979db5f9	9d69a7b8-3a6e-4215-81c3-703e47691d1d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 20:45:09
33051	9d69a7b8-3916-4765-ad64-3d32fd56736e	9d69a7b8-3a6e-4215-81c3-703e47691d1d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 20:45:09
17529	9d655c4a-55bc-4cdb-9da6-d4803be69831	9d655c4a-9cf4-4d25-88e5-118c94a79e70	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 17:30:56
17530	9d655c4a-98d6-4ee0-b9d6-1d2dd2d85ea5	9d655c4a-9cf4-4d25-88e5-118c94a79e70	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"156.95","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":46,"hash":"fb4ded687569d92428336ceae5c6ffcd","hostname":"EderCortes"}	2024-11-02 17:30:56
17531	9d655c4a-9bbf-41c3-9332-5c514f29cc1b	9d655c4a-9cf4-4d25-88e5-118c94a79e70	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 17:30:56
17532	9d655c4a-9c16-40c0-97fd-845a99eb4343	9d655c4a-9cf4-4d25-88e5-118c94a79e70	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":332,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:30:56
33052	9d69a7b8-396d-42b5-83f3-dac4f5012f5e	9d69a7b8-3a6e-4215-81c3-703e47691d1d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder.cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:39","updated_at":"2024-11-04 10:36:27","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 10:36:27","updated_at":"2024-11-04 10:39:58","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000","user_alias":"eder.cortes"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 10:36:27","updated_at":"2024-11-04 13:14:01","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000","user_alias":"eder.cortes"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 10:36:27","updated_at":"2024-11-04 10:36:27","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 10:36:27","updated_at":"2024-11-04 10:36:27","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 10:36:27","updated_at":"2024-11-04 10:36:27","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:45:09
17533	9d655c4b-f8e7-4776-bf8d-d0778341ed3e	9d655c4c-23af-4f11-b0dc-21e5c95e33ab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 17:30:57
17534	9d655c4c-1972-46e3-81eb-6d7ec43c96d1	9d655c4c-23af-4f11-b0dc-21e5c95e33ab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"58.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 17:30:57
17535	9d655c4c-19f3-454b-920f-324bf30673d8	9d655c4c-23af-4f11-b0dc-21e5c95e33ab	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 17:30:57
17536	9d655c4c-213e-46c4-a602-b0ec7f1f1c13	9d655c4c-23af-4f11-b0dc-21e5c95e33ab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 17:30:57
17537	9d655c4c-2213-484b-a562-149c6318e1f3	9d655c4c-23af-4f11-b0dc-21e5c95e33ab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":437,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:30:57
33053	9d69a867-52bc-49b3-95e0-8c64982fa45b	9d69a867-5787-4601-83c5-45847c74a288	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":214,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:47:04
35070	9d69c223-4905-410e-830e-ca7361a1fa32	9d69c223-784b-4674-b329-2ad04d151a05	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 21:59:02
33972	9d69b86a-c1f1-48e7-b3c4-04198d8f447e	9d69b86a-e6c5-4fc1-b921-11101de34e9e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:31:51
35071	9d69c223-75cf-4e85-ab71-0b2a9ef0c83a	9d69c223-784b-4674-b329-2ad04d151a05	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:59:02
35072	9d69c223-76df-4758-a818-ee2e645978ac	9d69c223-784b-4674-b329-2ad04d151a05	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":384,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:59:02
33054	9d69a867-bc34-4d52-b328-31478cd40f59	9d69a868-1613-4ca0-8d50-62b5a1f7cb7b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 20:47:04
33055	9d69a868-05cc-4dbe-bf2a-728b32fb5735	9d69a868-1613-4ca0-8d50-62b5a1f7cb7b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 89 limit 1","time":"2.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":505,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 20:47:05
33056	9d69a868-0655-4215-80d1-9432618264a9	9d69a868-1613-4ca0-8d50-62b5a1f7cb7b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":2,"hostname":"EderCortes"}	2024-11-04 20:47:05
33057	9d69a868-0890-464b-b4b8-2224771940e2	9d69a868-1613-4ca0-8d50-62b5a1f7cb7b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select count(*) as aggregate from \\"item_loans\\" where \\"loans_codigo\\" = 89 and \\"itemloans_status\\" = 'Pagada'","time":"2.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":563,"hash":"60bd91eaa209a639fc2e8afc20430a4b","hostname":"EderCortes"}	2024-11-04 20:47:05
33058	9d69a868-0953-45a5-9a02-215b51d5fb95	9d69a868-1613-4ca0-8d50-62b5a1f7cb7b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 266000, \\"loans_pago_prestado\\" = 1064000, \\"updated_at\\" = '2024-11-04 20:47:05' where \\"id\\" = 89","time":"0.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":602,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 20:47:05
33059	9d69a868-09c9-4297-bc26-5b934c04e9af	9d69a868-1613-4ca0-8d50-62b5a1f7cb7b	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:89","changes":{"updated_at":"2024-11-04 20:47:05","loans_pago_interes":266000,"loans_pago_prestado":1064000},"hostname":"EderCortes"}	2024-11-04 20:47:05
33060	9d69a868-0a68-4c4f-8f67-0d4cb18aa771	9d69a868-1613-4ca0-8d50-62b5a1f7cb7b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 89 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"0.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":609,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 20:47:05
33061	9d69a868-0aa0-4a2e-9f7e-836958d8b29d	9d69a868-1613-4ca0-8d50-62b5a1f7cb7b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 20:47:05
33062	9d69a868-0b28-4648-badb-86b0a26bc145	9d69a868-1613-4ca0-8d50-62b5a1f7cb7b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Abono', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = 120000, \\"itemloans_cuota_cancelada\\" = 480000, \\"updated_at\\" = '2024-11-04 20:47:05' where \\"id\\" = 368","time":"0.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":617,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 20:47:05
33063	9d69a868-0b64-4c51-9265-bb314a1d9d1d	9d69a868-1613-4ca0-8d50-62b5a1f7cb7b	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:368","changes":{"itemloans_status":"Abono","updated_at":"2024-11-04 20:47:05","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":120000,"itemloans_cuota_cancelada":480000},"hostname":"EderCortes"}	2024-11-04 20:47:05
33064	9d69a868-0bdb-4b17-804d-92dff4d1049d	9d69a868-1613-4ca0-8d50-62b5a1f7cb7b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"delete from \\"item_loans\\" where \\"loans_codigo\\" = 89 and \\"itemloans_status\\" = 'Pendiente'","time":"0.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":624,"hash":"89bf3c496a8b0746ff5d1219b8dc29e3","hostname":"EderCortes"}	2024-11-04 20:47:05
33065	9d69a868-0c87-4fd0-91d9-b3cafc698f98	9d69a868-1613-4ca0-8d50-62b5a1f7cb7b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 89 limit 1","time":"0.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":627,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 20:47:05
33066	9d69a868-0d68-4cc6-bf64-88a1c4867af4	9d69a868-1613-4ca0-8d50-62b5a1f7cb7b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (89, 3, 12000, 3000, 'Pendiente', 'Se realiza abono', '12-11-2024', 0, 0, '2024-11-04 20:47:05', '2024-11-04 20:47:05')","time":"1.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:47:05
33067	9d69a868-0d94-437f-a43e-7c6d4eab1ae9	9d69a868-1613-4ca0-8d50-62b5a1f7cb7b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:47:05
33068	9d69a868-0e17-4dde-84c8-cf8db1728fd9	9d69a868-1613-4ca0-8d50-62b5a1f7cb7b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (89, 4, 12000, 3000, 'Pendiente', 'Se realiza abono', '20-11-2024', 0, 0, '2024-11-04 20:47:05', '2024-11-04 20:47:05')","time":"0.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:47:05
33069	9d69a868-0e3d-4834-9a5d-a69a42b72238	9d69a868-1613-4ca0-8d50-62b5a1f7cb7b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:47:05
33070	9d69a868-0ead-4b99-b962-4126d2526c31	9d69a868-1613-4ca0-8d50-62b5a1f7cb7b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (89, 5, 12000, 3000, 'Pendiente', 'Se realiza abono', '28-11-2024', 0, 0, '2024-11-04 20:47:05', '2024-11-04 20:47:05')","time":"0.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:47:05
33071	9d69a868-0ee1-41bb-92a4-e6129a206f85	9d69a868-1613-4ca0-8d50-62b5a1f7cb7b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:47:05
33072	9d69a868-143c-4f56-b75f-60400b913e0b	9d69a868-1613-4ca0-8d50-62b5a1f7cb7b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 20:47:05
35073	9d69c223-f36e-45e6-9ee4-5f844959630b	9d69c224-43ae-41af-a1ac-477386c981f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:59:02
33073	9d69a868-14a3-46c2-b6fc-2153ac125279	9d69a868-1613-4ca0-8d50-62b5a1f7cb7b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"61","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"600000","idLoans":89,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El abono fue aplicado exitosamente","status":true},"duration":414,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:47:05
35074	9d69c224-3c8c-4a6c-b4e6-6a06952ccd75	9d69c224-43ae-41af-a1ac-477386c981f4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"157.63","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:59:02
35075	9d69c224-3d13-47cf-b4ed-b273988d8759	9d69c224-43ae-41af-a1ac-477386c981f4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:59:02
35076	9d69c224-424f-49ce-9554-5254c80bfc67	9d69c224-43ae-41af-a1ac-477386c981f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:59:02
35077	9d69c224-42b0-4881-841f-b35f1efb6747	9d69c224-43ae-41af-a1ac-477386c981f4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":465,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:59:02
33074	9d69a868-958f-4949-93a7-1b43b90aac2c	9d69a868-b8e0-47fb-b40f-d52929419cf6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 20:47:05
33075	9d69a868-afd1-4852-8209-d3b96a7a2e0c	9d69a868-b8e0-47fb-b40f-d52929419cf6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"50.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 20:47:05
33076	9d69a868-b3b2-4de7-a86c-123834d5c54d	9d69a868-b8e0-47fb-b40f-d52929419cf6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"3.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 20:47:05
33077	9d69a868-b74f-4c0c-b424-564f2dcc5fb0	9d69a868-b8e0-47fb-b40f-d52929419cf6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 20:47:05
33078	9d69a868-b7b7-4c2c-a250-b609706358d7	9d69a868-b8e0-47fb-b40f-d52929419cf6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1064000","loans_pago_interes":"266000","user_alias":"eder.cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:39","updated_at":"2024-11-04 10:36:27","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 10:36:27","updated_at":"2024-11-04 10:39:58","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000","user_alias":"eder.cortes"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 10:36:27","updated_at":"2024-11-04 13:14:01","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000","user_alias":"eder.cortes"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 10:36:27","updated_at":"2024-11-04 20:47:05","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"120000","itemloans_cuota_cancelada":"480000","user_alias":"eder.cortes"},{"id":439,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"12000","itemloans_iteres":"3000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:47:05","updated_at":"2024-11-04 20:47:05","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":440,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"12000","itemloans_iteres":"3000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:47:05","updated_at":"2024-11-04 20:47:05","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":441,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"12000","itemloans_iteres":"3000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:47:05","updated_at":"2024-11-04 20:47:05","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":386,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:47:05
35078	9d69c224-97d5-41bf-ac6e-bdb787bfd87c	9d69c224-e3a9-4bd1-a671-a6244186b7ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:59:03
35079	9d69c224-de04-44fe-a4b7-d5ab99918341	9d69c224-e3a9-4bd1-a671-a6244186b7ea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"150.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 21:59:03
35080	9d69c224-de71-430e-b7aa-9e7777d28d8d	9d69c224-e3a9-4bd1-a671-a6244186b7ea	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 21:59:03
35081	9d69c224-e279-48db-8549-38a0c349b282	9d69c224-e3a9-4bd1-a671-a6244186b7ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:59:03
35082	9d69c224-e2ca-4a12-a83a-ec58fe759d84	9d69c224-e3a9-4bd1-a671-a6244186b7ea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":389,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:59:03
35083	9d69c225-2e14-46e1-9f3a-c55531228029	9d69c225-4bb8-4274-b90a-f785221e5567	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:59:03
35084	9d69c225-4619-4c0b-a526-afd57e127c91	9d69c225-4bb8-4274-b90a-f785221e5567	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"37.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:59:03
33973	9d69b86a-dcec-4fd9-9678-ab1911555804	9d69b86a-e6c5-4fc1-b921-11101de34e9e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 82\\n                        ","time":"53.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"23238af5dc47e80ea555e80a08e2015d","hostname":"EderCortes"}	2024-11-04 21:31:51
33974	9d69b86a-e051-4857-ad56-c14d6c317443	9d69b86a-e6c5-4fc1-b921-11101de34e9e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '82' order by \\"item_loans\\".\\"id\\" asc","time":"2.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:31:51
12973	9d5cef9b-35fc-4dd1-8936-ef71361394f3	9d5cef9b-5117-4b4f-bf4f-96796ca2ac5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 13:00:24
12974	9d5cef9b-4f76-49e3-9350-4527f648a903	9d5cef9b-5117-4b4f-bf4f-96796ca2ac5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 13:00:24
12975	9d5cef9b-5013-4a7e-b8f3-4aed43628e0f	9d5cef9b-5117-4b4f-bf4f-96796ca2ac5c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[3F000]: Invalid schema name: 7 ERROR:  no existe el esquema \\u00abl\\u00bb\\nLINE 17:                             order by l.id 'desc'\\n                                              ^ (Connection: pgsql, SQL: \\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id 'desc'\\n                        )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:00:24
33975	9d69b86a-e416-4a24-b9a3-768a4a5c58f5	9d69b86a-e6c5-4fc1-b921-11101de34e9e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:31:51
35085	9d69c225-4685-4034-824a-ca6b9581703c	9d69c225-4bb8-4274-b90a-f785221e5567	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:59:03
35086	9d69c225-4a64-4553-ba9c-4dcbb850f097	9d69c225-4bb8-4274-b90a-f785221e5567	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:59:03
35087	9d69c225-4ac2-4dae-8dbc-abbf0e0313a0	9d69c225-4bb8-4274-b90a-f785221e5567	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:59:03
33976	9d69b86a-e4b3-4ba0-b60f-0f7466239424	9d69b86a-e6c5-4fc1-b921-11101de34e9e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/82","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":82,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"480000","loans_pago_interes":"120000","user_alias":"eder.cortes"},"items":[{"id":316,"loans_codigo":82,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:36","updated_at":"2024-11-04 21:29:42","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":464,"loans_codigo":82,"itemloans_cuota":"2","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 21:29:42","updated_at":"2024-11-04 21:31:18","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":468,"loans_codigo":82,"itemloans_cuota":"3","itemloans_valor_cuota":"155000","itemloans_iteres":"38750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:31:18","updated_at":"2024-11-04 21:31:18","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":469,"loans_codigo":82,"itemloans_cuota":"4","itemloans_valor_cuota":"155000","itemloans_iteres":"38750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:31:18","updated_at":"2024-11-04 21:31:18","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":470,"loans_codigo":82,"itemloans_cuota":"5","itemloans_valor_cuota":"155000","itemloans_iteres":"38750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:31:18","updated_at":"2024-11-04 21:31:18","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":471,"loans_codigo":82,"itemloans_cuota":"6","itemloans_valor_cuota":"155000","itemloans_iteres":"38750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:31:18","updated_at":"2024-11-04 21:31:18","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:31:51
12980	9d5cefb2-0cdd-4abd-a46f-8778a0a49991	9d5cefb2-4e68-4078-aed0-c017a23be10a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 13:00:39
35198	9d69c2f3-dc18-4958-aea2-ea11df6236a8	9d69c2f3-f98b-462a-aae6-ead31b755542	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 22:01:18
35199	9d69c2f3-f812-4b34-90ee-adbcf9365c4d	9d69c2f3-f98b-462a-aae6-ead31b755542	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 22:01:18
35200	9d69c2f3-f8ac-487c-a7a9-c3c8732ab9c1	9d69c2f3-f98b-462a-aae6-ead31b755542	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:01:18
33977	9d69b8d0-66e9-4cbc-9dfd-43a6ce07faff	9d69b8d0-6a87-4392-a5bb-b475e05d7807	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":173,"memory":20,"hostname":"EderCortes"}	2024-11-04 21:32:57
35201	9d69c2f4-4d39-4b13-8aa3-202154425075	9d69c2f4-6b2d-438a-8d6a-6440de93c5db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 22:01:19
35202	9d69c2f4-661c-43b7-b280-2c82d83be32d	9d69c2f4-6b2d-438a-8d6a-6440de93c5db	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:01:19
35203	9d69c2f4-6679-4c63-a17d-74f902f2984a	9d69c2f4-6b2d-438a-8d6a-6440de93c5db	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:01:19
17684	9d6560b4-e45d-4101-904e-c09592c09c0c	9d6560b5-01cc-48ab-bc33-94bae3740930	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 17:43:17
17685	9d6560b5-003c-4da8-b77a-a9e935ad8a91	9d6560b5-01cc-48ab-bc33-94bae3740930	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 17:43:17
17686	9d6560b5-00d7-4cf0-be35-b868cee6b3ca	9d6560b5-01cc-48ab-bc33-94bae3740930	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:43:17
35204	9d69c2f4-69fd-4780-9abc-8c01c6dfbfff	9d69c2f4-6b2d-438a-8d6a-6440de93c5db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 22:01:19
35205	9d69c2f4-6a4a-4cbd-ae5e-1443b6520fa1	9d69c2f4-6b2d-438a-8d6a-6440de93c5db	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":245,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:01:19
17687	9d6560b5-4a25-45d7-9520-d91f24f1b2d3	9d6560b5-6615-4b68-b3cb-0cb51f74154c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 17:43:17
17688	9d6560b5-61d2-4eda-97e1-feb6e7426503	9d6560b5-6615-4b68-b3cb-0cb51f74154c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"45.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58,"hash":"77f8314368b36a9393ec9c7735a91700","hostname":"EderCortes"}	2024-11-02 17:43:17
17689	9d6560b5-64d9-4b85-a306-a98b7073e6ad	9d6560b5-6615-4b68-b3cb-0cb51f74154c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 17:43:17
15068	9d5ece8d-6c3a-48b3-992a-ab7714d005f0	9d5ece8d-95e9-4db2-9107-be7dd30b7cbe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-30 11:19:38
15069	9d5ece8d-93e6-4d78-affe-e72e6255218c	9d5ece8d-95e9-4db2-9107-be7dd30b7cbe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-30 11:19:38
15070	9d5ece8d-94c4-4723-a24a-c4b607cec7ac	9d5ece8d-95e9-4db2-9107-be7dd30b7cbe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":267,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:19:38
17690	9d6560b5-6532-451e-9b9c-c94b1c88500d	9d6560b5-6615-4b68-b3cb-0cb51f74154c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":220,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:43:17
35206	9d69c2f4-b246-40a2-865c-81e5de647f89	9d69c2f4-fe61-47b0-8d79-69b639390457	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 22:01:19
17842	9d65b0d9-1a75-43ce-b324-cfa5376fa60c	9d65b0d9-3e2e-4ca1-abfd-3d4e94f1ef71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 21:27:22
17843	9d65b0d9-3c55-4ca1-8bb1-84bad6cb7401	9d65b0d9-3e2e-4ca1-abfd-3d4e94f1ef71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 21:27:22
17844	9d65b0d9-3d0d-4f7d-a087-74404df3ddc2	9d65b0d9-3e2e-4ca1-abfd-3d4e94f1ef71	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":277,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:27:22
35207	9d69c2f4-f914-4876-a227-12291a1250d9	9d69c2f4-fe61-47b0-8d79-69b639390457	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"155.52","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 22:01:19
35208	9d69c2f4-f971-460f-9fb3-81b5845ba265	9d69c2f4-fe61-47b0-8d79-69b639390457	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 22:01:19
35209	9d69c2f4-fd36-4c65-bf0a-9402aefd37c7	9d69c2f4-fe61-47b0-8d79-69b639390457	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 22:01:19
35210	9d69c2f4-fd82-4923-a0e3-138bb074225a	9d69c2f4-fe61-47b0-8d79-69b639390457	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":364,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:01:19
15071	9d5ece8d-eb46-4f77-8533-c8442513fbd7	9d5ece8e-3563-4c5c-a3bd-660d2b95a906	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-30 11:19:38
15072	9d5ece8e-3037-4e24-898c-02039cb33a28	9d5ece8e-3563-4c5c-a3bd-660d2b95a906	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"147.50","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 11:19:39
15073	9d5ece8e-30af-4540-b7c0-3461ef214d0a	9d5ece8e-3563-4c5c-a3bd-660d2b95a906	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-30 11:19:39
15074	9d5ece8e-3426-46f6-9237-c599b69374b0	9d5ece8e-3563-4c5c-a3bd-660d2b95a906	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-30 11:19:39
15075	9d5ece8e-347a-4cf4-b66b-f1b816c04d54	9d5ece8e-3563-4c5c-a3bd-660d2b95a906	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":371,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:19:39
17691	9d6560b7-0426-4ed4-b87f-bb1299ead0c2	9d6560b7-244b-4f90-9b0f-04686927bc33	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 17:43:18
17692	9d6560b7-1ed5-4d18-a682-e4a26b42eb73	9d6560b7-244b-4f90-9b0f-04686927bc33	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"46.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 17:43:18
17693	9d6560b7-1f21-47be-97f7-7a957077a24e	9d6560b7-244b-4f90-9b0f-04686927bc33	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 17:43:18
17694	9d6560b7-22aa-454f-8885-5e8f756c4e6d	9d6560b7-244b-4f90-9b0f-04686927bc33	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-02 17:43:18
17695	9d6560b7-230d-401f-b8fd-a68101079626	9d6560b7-244b-4f90-9b0f-04686927bc33	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:43:18
17845	9d65b0d9-98de-437a-924e-6987dc9cf5b9	9d65b0d9-bb94-49fb-aa6e-3fbe4db2057d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 21:27:23
17846	9d65b0d9-b192-4108-b607-e01a85546b6c	9d65b0d9-bb94-49fb-aa6e-3fbe4db2057d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"48.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 21:27:23
17847	9d65b0d9-b55a-4f3e-9135-fa0adc609399	9d65b0d9-bb94-49fb-aa6e-3fbe4db2057d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:27:23
17848	9d65b0d9-b59d-456c-8a61-969c0ea21825	9d65b0d9-bb94-49fb-aa6e-3fbe4db2057d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:27:23
17849	9d65b0d9-ba11-44e0-9abe-cc5158a7720e	9d65b0d9-bb94-49fb-aa6e-3fbe4db2057d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 21:27:23
35211	9d69c2f5-47a0-4248-ace9-6550618ca8dd	9d69c2f5-90a3-4e65-8931-185a93cc0646	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 22:01:19
15076	9d5ece8e-7757-4ec0-a39f-437b0f20cb0a	9d5ece8e-bc87-43b1-9816-2ae94aa85eb4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-30 11:19:39
15077	9d5ece8e-b782-4702-9013-84e1127e102a	9d5ece8e-bc87-43b1-9816-2ae94aa85eb4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"142.33","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 11:19:39
15078	9d5ece8e-b7d6-462d-9314-d0fc91ca7483	9d5ece8e-bc87-43b1-9816-2ae94aa85eb4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-30 11:19:39
15079	9d5ece8e-bb38-48c4-89d2-e895cf77d1e8	9d5ece8e-bc87-43b1-9816-2ae94aa85eb4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-30 11:19:39
15080	9d5ece8e-bba0-4895-9291-0c4afa81d5f7	9d5ece8e-bc87-43b1-9816-2ae94aa85eb4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":331,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:19:39
17696	9d6560ce-5fb2-4da3-94c9-df5f62456f0a	9d6560ce-80cb-440e-aa44-2db04830ac7d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-02 17:43:33
17697	9d6560ce-75c5-48fc-933d-d1fb75654aae	9d6560ce-80cb-440e-aa44-2db04830ac7d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 55\\n                        ","time":"44.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"02985109e2690b43eb6cffcb71b88b94","hostname":"EderCortes"}	2024-11-02 17:43:34
17698	9d6560ce-7c0e-4148-be02-d87ac3f24f0c	9d6560ce-80cb-440e-aa44-2db04830ac7d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '55' order by \\"item_loans\\".\\"id\\" asc","time":"8.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 17:43:34
17699	9d6560ce-7c59-43de-9d18-12a5daf31cb0	9d6560ce-80cb-440e-aa44-2db04830ac7d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":7,"hostname":"EderCortes"}	2024-11-02 17:43:34
17700	9d6560ce-7f8c-466d-9b79-8875c66624b4	9d6560ce-80cb-440e-aa44-2db04830ac7d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-02 17:43:34
17701	9d6560ce-7fd2-471b-822e-a0f2910262fc	9d6560ce-80cb-440e-aa44-2db04830ac7d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/55","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":55,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":7,"loans_valor_prestado":50000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"15-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-15 00:00:00"},"items":[{"id":150,"loans_codigo":55,"itemloans_cuota":"1","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":151,"loans_codigo":55,"itemloans_cuota":"2","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":152,"loans_codigo":55,"itemloans_cuota":"3","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":153,"loans_codigo":55,"itemloans_cuota":"4","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":154,"loans_codigo":55,"itemloans_cuota":"5","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":155,"loans_codigo":55,"itemloans_cuota":"6","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":156,"loans_codigo":55,"itemloans_cuota":"7","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":288,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:43:34
35212	9d69c2f5-8b39-474a-b100-d6c0b5e1d836	9d69c2f5-90a3-4e65-8931-185a93cc0646	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"148.76","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:01:19
35213	9d69c2f5-8b89-4946-a924-f9e21bb22355	9d69c2f5-90a3-4e65-8931-185a93cc0646	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:01:19
35214	9d69c2f5-8f72-43bd-992b-282831b5a1d8	9d69c2f5-90a3-4e65-8931-185a93cc0646	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 22:01:19
15081	9d5ece8f-43aa-4faf-b56a-44fd199d0c9f	9d5ece8f-7d85-4959-a6f7-74f5c3e662fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-30 11:19:39
15082	9d5ece8f-72bb-45f2-819c-c13f0d34454c	9d5ece8f-7d85-4959-a6f7-74f5c3e662fd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"79.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 11:19:39
15083	9d5ece8f-7361-43cf-b4d4-e92d8c176f36	9d5ece8f-7d85-4959-a6f7-74f5c3e662fd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 11:19:39
15084	9d5ece8f-7b43-4a94-a272-6a6dbb4014b4	9d5ece8f-7d85-4959-a6f7-74f5c3e662fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-30 11:19:39
15085	9d5ece8f-7bcc-4b90-b7e3-5567c2173e48	9d5ece8f-7d85-4959-a6f7-74f5c3e662fd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":478,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:19:39
17702	9d6560e5-0343-4424-847c-d64f7d25bb0b	9d6560e5-0647-4e30-a67f-e6f4a9f5dde8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":132,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:43:48
17850	9d65b0d9-ba6d-450e-a9e2-b3afea06b74c	9d65b0d9-bb94-49fb-aa6e-3fbe4db2057d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:34:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"}]}},"duration":276,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:27:23
35215	9d69c2f5-8fbc-402f-b30c-70cc9015d2c7	9d69c2f5-90a3-4e65-8931-185a93cc0646	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":355,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:01:19
15086	9d5ece90-05db-4dbf-964c-8fe706b09723	9d5ece90-39e8-4981-8a6f-d3b220ceb133	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-30 11:19:40
15087	9d5ece90-30a5-4440-b14d-33534456fb51	9d5ece90-39e8-4981-8a6f-d3b220ceb133	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"63.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 11:19:40
15088	9d5ece90-3152-49ec-8e4b-dd7983a13314	9d5ece90-39e8-4981-8a6f-d3b220ceb133	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 11:19:40
15089	9d5ece90-37d9-4d69-97f7-0b7d3512621b	9d5ece90-39e8-4981-8a6f-d3b220ceb133	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-30 11:19:40
15090	9d5ece90-3860-4bd1-a8e4-16641af9545e	9d5ece90-39e8-4981-8a6f-d3b220ceb133	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":456,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:19:40
17703	9d6560e5-7119-4d65-88f6-03e67fd43f64	9d6560e5-9b1f-401d-915e-fb6c76753c41	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 17:43:49
17704	9d6560e5-8ec1-46e0-bf59-65d9cb87422a	9d6560e5-9b1f-401d-915e-fb6c76753c41	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 150 limit 1","time":"3.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":381,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-02 17:43:49
16383	9d64c905-f2bc-468b-9a2b-2e8c829767a5	9d64c906-21f4-48b1-8bdd-b0e1d471fb91	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 10:39:09
16384	9d64c906-1eb5-4fba-8c0e-75aa5d3a30b2	9d64c906-21f4-48b1-8bdd-b0e1d471fb91	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 10:39:09
16385	9d64c906-208d-4cec-ac0c-d2e48be3f144	9d64c906-21f4-48b1-8bdd-b0e1d471fb91	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":387,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:39:09
17705	9d6560e5-8f20-4517-b242-07b5fdb476f1	9d6560e5-9b1f-401d-915e-fb6c76753c41	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-02 17:43:49
17706	9d6560e5-90d1-45c0-afa2-32b9c49efa24	9d6560e5-9b1f-401d-915e-fb6c76753c41	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 55 limit 1","time":"2.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":382,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-02 17:43:49
17707	9d6560e5-910f-4355-aa0d-aaac8b8aae65	9d6560e5-9b1f-401d-915e-fb6c76753c41	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-02 17:43:49
17708	9d6560e5-94aa-4921-bef2-81effdc31757	9d6560e5-9b1f-401d-915e-fb6c76753c41	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '02-11-2024', \\"itemloans_interes_canelado\\" = '1250', \\"itemloans_cuota_cancelada\\" = '7142.8571428571', \\"updated_at\\" = '2024-11-02 17:43:49' where \\"id\\" = 150","time":"7.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":403,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-02 17:43:49
17709	9d6560e5-9503-4d47-ace8-6de24be683e7	9d6560e5-9b1f-401d-915e-fb6c76753c41	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:150","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-02 17:43:49","item_loans_cuando_pago":"02-11-2024","itemloans_interes_canelado":"1250","itemloans_cuota_cancelada":"7142.8571428571"},"hostname":"EderCortes"}	2024-11-02 17:43:49
17710	9d6560e5-959f-42b5-99bc-4755098a1ca1	9d6560e5-9b1f-401d-915e-fb6c76753c41	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_fecha_ultimo_pago\\" = '02-11-2024', \\"updated_at\\" = '2024-11-02 17:43:49' where \\"id\\" = 55","time":"0.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":411,"hash":"cf593c3f0d97e8454c5164f16511623d","hostname":"EderCortes"}	2024-11-02 17:43:49
17711	9d6560e5-95d3-4f98-aff4-ecbf4dbf5a29	9d6560e5-9b1f-401d-915e-fb6c76753c41	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:55","changes":{"updated_at":"2024-11-02 17:43:49","loans_fecha_ultimo_pago":"02-11-2024"},"hostname":"EderCortes"}	2024-11-02 17:43:49
17712	9d6560e5-99a8-4896-8fd2-507928e63895	9d6560e5-9b1f-401d-915e-fb6c76753c41	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:43:49
17713	9d6560e5-99fb-4d57-8645-08d492e216ce	9d6560e5-9b1f-401d-915e-fb6c76753c41	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"165","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"1250","itemloans_cuota_cancelada":"7142.8571428571","id":150,"loans_codigo":55,"item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":257,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:43:49
17851	9d65b0db-313a-4da8-81e9-ddc3e4c955c2	9d65b0db-5723-453d-b6d0-1c84f2d171c7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 21:27:24
33992	9d69b8d1-9c67-4560-8098-26acabd27eef	9d69b8d1-c104-4752-a29e-3aabc93cfbb0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:32:58
15091	9d5ece90-fa5d-4d2d-9a48-abd5f9f1dff3	9d5ece91-450f-4399-b80b-115990795cd0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-30 11:19:40
15092	9d5ece91-3dc5-4483-9882-526eb071d303	9d5ece91-450f-4399-b80b-115990795cd0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"152.88","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 11:19:41
15093	9d5ece91-3e41-4d24-b0b2-9c70b1f8a1c8	9d5ece91-450f-4399-b80b-115990795cd0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 11:19:41
15094	9d5ece91-43c5-4d74-8101-aecafe71cb79	9d5ece91-450f-4399-b80b-115990795cd0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-30 11:19:41
15095	9d5ece91-4417-4812-a3ce-ef8efb8b4600	9d5ece91-450f-4399-b80b-115990795cd0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":371,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:19:41
16386	9d64c906-9f45-4269-97e6-920ea61ed62d	9d64c906-f372-4ad8-8f4b-124f1f38ae46	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 10:39:09
16387	9d64c906-e83c-4b93-83a5-4771c7fb2407	9d64c906-f372-4ad8-8f4b-124f1f38ae46	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"167.02","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 10:39:09
16388	9d64c906-ec96-467e-9251-4b74e8d4658b	9d64c906-f372-4ad8-8f4b-124f1f38ae46	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 10:39:09
16389	9d64c906-ecd7-4823-8beb-6004b7cbdb66	9d64c906-f372-4ad8-8f4b-124f1f38ae46	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 10:39:09
16390	9d64c906-f1af-42f3-95d8-0c0e3748bb96	9d64c906-f372-4ad8-8f4b-124f1f38ae46	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 10:39:09
16391	9d64c906-f22a-4745-8fea-7a78c0629c3f	9d64c906-f372-4ad8-8f4b-124f1f38ae46	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":485,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:39:09
17714	9d6560e5-ecd2-4e61-90c5-57f65b21ee70	9d6560e6-31d5-46c3-8cb7-779120b57c96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:43:49
17852	9d65b0db-5033-4517-b489-e589363eefb7	9d65b0db-5723-453d-b6d0-1c84f2d171c7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"51.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 21:27:24
17853	9d65b0db-50a0-4d0c-8a29-02fe826778dc	9d65b0db-5723-453d-b6d0-1c84f2d171c7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 21:27:24
17854	9d65b0db-555e-41ee-b34d-2bd31f4009ac	9d65b0db-5723-453d-b6d0-1c84f2d171c7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 21:27:24
16392	9d64c908-f2c3-4cb4-a277-72eb748ba47c	9d64c909-21ac-412f-8ffb-456321398016	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 10:39:10
16393	9d64c909-1866-420a-adb7-c38bd25790c7	9d64c909-21ac-412f-8ffb-456321398016	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"63.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 10:39:11
16394	9d64c909-18d5-4aff-97c0-547852aa0f4b	9d64c909-21ac-412f-8ffb-456321398016	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 10:39:11
16395	9d64c909-1fac-4f6c-a146-d39e00d1555f	9d64c909-21ac-412f-8ffb-456321398016	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 10:39:11
16396	9d64c909-203d-4d3c-99cc-4f07381d231e	9d64c909-21ac-412f-8ffb-456321398016	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":438,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:39:11
17715	9d6560e6-2961-43a9-92f7-06a818de1c77	9d6560e6-31d5-46c3-8cb7-779120b57c96	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 55\\n                        ","time":"142.99","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"02985109e2690b43eb6cffcb71b88b94","hostname":"EderCortes"}	2024-11-02 17:43:49
17716	9d6560e6-2cd8-461b-90ca-632e8f0aa7e1	9d6560e6-31d5-46c3-8cb7-779120b57c96	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '55' order by \\"item_loans\\".\\"id\\" asc","time":"1.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 17:43:49
17717	9d6560e6-2d08-4ded-8c49-848b3db8ee39	9d6560e6-31d5-46c3-8cb7-779120b57c96	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":7,"hostname":"EderCortes"}	2024-11-02 17:43:49
17718	9d6560e6-30a1-49e8-8815-775245bebbec	9d6560e6-31d5-46c3-8cb7-779120b57c96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:43:49
17719	9d6560e6-30ea-4bc0-bbd0-50101d4f77db	9d6560e6-31d5-46c3-8cb7-779120b57c96	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/55","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":55,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":7,"loans_valor_prestado":50000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"15-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-15 00:00:00"},"items":[{"id":150,"loans_codigo":55,"itemloans_cuota":"1","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-11-02T22:43:49.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"1250","itemloans_cuota_cancelada":"7142.8571428571"},{"id":151,"loans_codigo":55,"itemloans_cuota":"2","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":152,"loans_codigo":55,"itemloans_cuota":"3","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":153,"loans_codigo":55,"itemloans_cuota":"4","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":154,"loans_codigo":55,"itemloans_cuota":"5","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":155,"loans_codigo":55,"itemloans_cuota":"6","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":156,"loans_codigo":55,"itemloans_cuota":"7","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":365,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:43:49
17720	9d6560ed-cba8-487e-bf49-d1faa255bb70	9d6560ee-123c-4151-aa28-5c014ed2eda1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:43:54
17721	9d6560ee-0e22-4425-83e5-f6307d8b1489	9d6560ee-123c-4151-aa28-5c014ed2eda1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"155.33","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58,"hash":"77f8314368b36a9393ec9c7735a91700","hostname":"EderCortes"}	2024-11-02 17:43:54
17722	9d6560ee-1102-411e-a68a-aec387b5bd29	9d6560ee-123c-4151-aa28-5c014ed2eda1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:43:54
17723	9d6560ee-1154-45b5-ad66-bb9ba19674d7	9d6560ee-123c-4151-aa28-5c014ed2eda1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"14","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":338,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:43:54
17855	9d65b0db-55df-4d51-aebf-05cf60db1f7b	9d65b0db-5723-453d-b6d0-1c84f2d171c7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":480,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:27:24
33993	9d69b8d1-b710-49bf-8da2-1a11da75404d	9d69b8d1-c104-4752-a29e-3aabc93cfbb0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 82\\n                        ","time":"53.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"23238af5dc47e80ea555e80a08e2015d","hostname":"EderCortes"}	2024-11-04 21:32:58
33994	9d69b8d1-bb8c-47a7-9757-340dc37b1747	9d69b8d1-c104-4752-a29e-3aabc93cfbb0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '82' order by \\"item_loans\\".\\"id\\" asc","time":"3.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:32:58
33995	9d69b8d1-bf7a-47aa-80b3-21c42b12262c	9d69b8d1-c104-4752-a29e-3aabc93cfbb0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:32:58
17724	9d656112-bdd3-4f0a-8d6e-837040cadce7	9d656112-db7e-4fef-b01f-7bc99098832a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:44:18
17725	9d656112-d300-4571-8910-9e9c6c88686d	9d656112-db7e-4fef-b01f-7bc99098832a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 52\\n                        ","time":"42.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"015af4c3d73f0a00e06908cfbb662ced","hostname":"EderCortes"}	2024-11-02 17:44:18
17726	9d656112-d673-4716-8570-8bc7153f6abf	9d656112-db7e-4fef-b01f-7bc99098832a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '52' order by \\"item_loans\\".\\"id\\" asc","time":"1.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 17:44:18
17727	9d656112-d6ac-448f-b07c-578757fe8ca7	9d656112-db7e-4fef-b01f-7bc99098832a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":7,"hostname":"EderCortes"}	2024-11-02 17:44:18
17728	9d656112-da47-4725-9495-c661c3edbf7b	9d656112-db7e-4fef-b01f-7bc99098832a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 17:44:18
17729	9d656112-da8d-439a-aa4e-21b43a8c300d	9d656112-db7e-4fef-b01f-7bc99098832a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/52","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":52,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":7,"loans_valor_prestado":500000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"12-11-24","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-12 05:00:00"},"items":[{"id":136,"loans_codigo":52,"itemloans_cuota":"1","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":137,"loans_codigo":52,"itemloans_cuota":"2","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0024-12-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":138,"loans_codigo":52,"itemloans_cuota":"3","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0024-12-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":139,"loans_codigo":52,"itemloans_cuota":"4","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0025-01-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":140,"loans_codigo":52,"itemloans_cuota":"5","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0025-01-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":141,"loans_codigo":52,"itemloans_cuota":"6","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0025-02-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":142,"loans_codigo":52,"itemloans_cuota":"7","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0025-02-25 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":279,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:44:18
17856	9d65b0df-29e8-4534-b241-53dd2939bf34	9d65b0df-4691-49cf-a95c-e5005a0466a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 21:27:26
17857	9d65b0df-4217-4be6-abee-752336765e19	9d65b0df-4691-49cf-a95c-e5005a0466a4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"44.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58,"hash":"77f8314368b36a9393ec9c7735a91700","hostname":"EderCortes"}	2024-11-02 21:27:26
17858	9d65b0df-4539-419d-a961-21fda5b5222f	9d65b0df-4691-49cf-a95c-e5005a0466a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 21:27:26
17859	9d65b0df-4592-4665-8848-9d9d97f038ce	9d65b0df-4691-49cf-a95c-e5005a0466a4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"14","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":220,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:27:26
17860	9d65b0e1-a4b6-420c-8430-7645975acf04	9d65b0e1-ee9a-4c69-b0e0-e8e867f429ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 21:27:28
17861	9d65b0e1-e589-4b49-9cd3-250471ccc297	9d65b0e1-ee9a-4c69-b0e0-e8e867f429ce	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"154.41","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-02 21:27:28
17862	9d65b0e1-e930-4b91-b399-f7b0dc35281f	9d65b0e1-ee9a-4c69-b0e0-e8e867f429ce	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"1.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:27:28
17863	9d65b0e1-e966-4581-9511-fd63832f0edd	9d65b0e1-ee9a-4c69-b0e0-e8e867f429ce	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:27:28
17864	9d65b0e1-ed53-46f4-baa4-4a029665586b	9d65b0e1-ee9a-4c69-b0e0-e8e867f429ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 21:27:28
17865	9d65b0e1-eda0-4ffa-bd34-be23c6c54795	9d65b0e1-ee9a-4c69-b0e0-e8e867f429ce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":341,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:27:28
17866	9d65b0ee-453a-481e-bdda-e624032594c3	9d65b0ee-4843-46e4-bd94-1002630034af	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-intereses","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":135,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:27:36
33996	9d69b8d1-bfe2-444f-8086-04cd7f6090fd	9d69b8d1-c104-4752-a29e-3aabc93cfbb0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/82","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":82,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"480000","loans_pago_interes":"120000","user_alias":"eder.cortes"},"items":[{"id":316,"loans_codigo":82,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:36","updated_at":"2024-11-04 21:29:42","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":464,"loans_codigo":82,"itemloans_cuota":"2","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 21:29:42","updated_at":"2024-11-04 21:31:18","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":468,"loans_codigo":82,"itemloans_cuota":"3","itemloans_valor_cuota":"155000","itemloans_iteres":"38750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:31:18","updated_at":"2024-11-04 21:31:18","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":469,"loans_codigo":82,"itemloans_cuota":"4","itemloans_valor_cuota":"155000","itemloans_iteres":"38750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:31:18","updated_at":"2024-11-04 21:31:18","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":470,"loans_codigo":82,"itemloans_cuota":"5","itemloans_valor_cuota":"155000","itemloans_iteres":"38750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:31:18","updated_at":"2024-11-04 21:31:18","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":471,"loans_codigo":82,"itemloans_cuota":"6","itemloans_valor_cuota":"155000","itemloans_iteres":"38750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:31:18","updated_at":"2024-11-04 21:31:18","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":344,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:32:58
35366	9d69c448-6260-40e7-849a-67342331950b	9d69c448-8d1c-4e12-9eda-21c687a59352	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 22:05:02
35367	9d69c448-8a99-43e8-990e-a2faf1a881c1	9d69c448-8d1c-4e12-9eda-21c687a59352	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 22:05:02
35368	9d69c448-8bb3-41f0-83b2-7c655379e571	9d69c448-8d1c-4e12-9eda-21c687a59352	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":344,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:05:02
35618	9d69c537-78b0-4696-bb18-5017f2ef59eb	9d69c537-c3d5-41d6-bb08-c729e242895e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 22:07:38
35619	9d69c537-c1ff-471c-b1ec-20482892e416	9d69c537-c3d5-41d6-bb08-c729e242895e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 22:07:38
35620	9d69c537-c2bc-423c-a3de-4d29c2c32318	9d69c537-c3d5-41d6-bb08-c729e242895e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":360,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:07:38
17867	9d65b0ee-ae6f-41d9-9182-9afe1640ce63	9d65b0ee-d0a4-4ad6-a15a-39ed7fd2b7b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 21:27:36
17868	9d65b0ee-c6ea-4248-88df-c96fdc86b0d3	9d65b0ee-d0a4-4ad6-a15a-39ed7fd2b7b3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 182 limit 1","time":"2.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":441,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-02 21:27:36
17869	9d65b0ee-c73c-4d08-881f-4df1620e6df0	9d65b0ee-d0a4-4ad6-a15a-39ed7fd2b7b3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-02 21:27:36
17870	9d65b0ee-c8f7-498c-9149-8c83e6f64641	9d65b0ee-d0a4-4ad6-a15a-39ed7fd2b7b3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 61 limit 1","time":"1.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":442,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-02 21:27:36
17871	9d65b0ee-c92b-48ec-b928-1fb1886157ca	9d65b0ee-d0a4-4ad6-a15a-39ed7fd2b7b3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-02 21:27:36
17872	9d65b0ee-cadb-4cfc-84b7-00f0fbfc3dd5	9d65b0ee-d0a4-4ad6-a15a-39ed7fd2b7b3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Abono intereses', \\"item_loans_cuando_pago\\" = '02-11-2024', \\"itemloans_interes_canelado\\" = '50000', \\"itemloans_cuota_cancelada\\" = 0, \\"updated_at\\" = '2024-11-02 21:27:36' where \\"id\\" = 182","time":"1.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":463,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-02 21:27:36
17873	9d65b0ee-cb99-4bca-972d-d99c1a5cfef6	9d65b0ee-d0a4-4ad6-a15a-39ed7fd2b7b3	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:182","changes":{"itemloans_status":"Abono intereses","updated_at":"2024-11-02 21:27:36","item_loans_cuando_pago":"02-11-2024","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":0},"hostname":"EderCortes"}	2024-11-02 21:27:36
17874	9d65b0ee-cc51-4abd-9df0-05928c80baa3	9d65b0ee-d0a4-4ad6-a15a-39ed7fd2b7b3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_fecha_ultimo_pago\\" = '02-11-2024', \\"updated_at\\" = '2024-11-02 21:27:36' where \\"id\\" = 61","time":"0.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":471,"hash":"cf593c3f0d97e8454c5164f16511623d","hostname":"EderCortes"}	2024-11-02 21:27:36
17875	9d65b0ee-cc90-4f2a-9ef7-a00f78637646	9d65b0ee-d0a4-4ad6-a15a-39ed7fd2b7b3	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:61","changes":{"updated_at":"2024-11-02 21:27:36","loans_fecha_ultimo_pago":"02-11-2024"},"hostname":"EderCortes"}	2024-11-02 21:27:36
17876	9d65b0ee-cf73-4d90-97d8-6e91eeb12dac	9d65b0ee-d0a4-4ad6-a15a-39ed7fd2b7b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-02 21:27:36
17877	9d65b0ee-cfb6-46d3-a82b-57e0d485d781	9d65b0ee-d0a4-4ad6-a15a-39ed7fd2b7b3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-intereses","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payInterese","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"150","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":0,"id":182,"loans_codigo":61,"item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El abono a intereses  de la cuota fue aplicado exitosamente","status":true},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:27:36
33997	9d69b909-783b-42fb-a894-cfeeaa966990	9d69b909-7be3-4bf1-96b4-d39480fe835e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":186,"memory":20,"hostname":"EderCortes"}	2024-11-04 21:33:35
35369	9d69c449-03aa-47fe-8b0b-4207862dc5f6	9d69c449-2aa4-445e-948a-ccf765e48639	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 22:05:02
35370	9d69c449-21c2-4ee1-bccd-c3508d7f0d8a	9d69c449-2aa4-445e-948a-ccf765e48639	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:05:02
35371	9d69c449-2224-43bc-9b4c-682e3b836edc	9d69c449-2aa4-445e-948a-ccf765e48639	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:05:02
35372	9d69c449-28b1-441f-aef5-5f7199d0b9d5	9d69c449-2aa4-445e-948a-ccf765e48639	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 22:05:02
35621	9d69c538-2333-4a66-bd32-c7940fde67c4	9d69c538-42ad-414b-8e45-8580553013a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 22:07:39
35622	9d69c538-3c3f-42b9-9dd8-21110b25dade	9d69c538-42ad-414b-8e45-8580553013a5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:07:39
35623	9d69c538-3c92-4810-b2bb-bf8bd1a89615	9d69c538-42ad-414b-8e45-8580553013a5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:07:39
35624	9d69c538-40e9-4993-ac6f-64cc3cea6541	9d69c538-42ad-414b-8e45-8580553013a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 22:07:39
17878	9d65b0ef-13ba-499b-9b46-5219a0e6a172	9d65b0ef-328d-4fff-8a9d-2c96d3e86cd2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-02 21:27:37
17879	9d65b0ef-2976-4ab8-a32d-4f09b63346b1	9d65b0ef-328d-4fff-8a9d-2c96d3e86cd2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"43.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-02 21:27:37
17880	9d65b0ef-2d0d-4234-80e7-2c42059c1050	9d65b0ef-328d-4fff-8a9d-2c96d3e86cd2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"1.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:27:37
17881	9d65b0ef-2d4f-4cda-9221-5013412d1d69	9d65b0ef-328d-4fff-8a9d-2c96d3e86cd2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:27:37
17882	9d65b0ef-3128-4984-b739-5e20fa262f63	9d65b0ef-328d-4fff-8a9d-2c96d3e86cd2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-02 21:27:37
17883	9d65b0ef-317d-433f-a719-ac148e9d9066	9d65b0ef-328d-4fff-8a9d-2c96d3e86cd2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T02:27:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"0"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:27:37
35373	9d69c449-2930-4f14-9b77-c8ff95d3d418	9d69c449-2aa4-445e-948a-ccf765e48639	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":341,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:05:02
35625	9d69c538-4167-4dbf-a49a-90dc96a64bb5	9d69c538-42ad-414b-8e45-8580553013a5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:07:39
17884	9d65b110-9e4d-4e2c-a7b7-a187e8633682	9d65b110-bb25-49ec-bc43-48b1cd890f5d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-02 21:27:59
17885	9d65b110-b695-4aef-bc2a-d1adfb1fa7bc	9d65b110-bb25-49ec-bc43-48b1cd890f5d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"45.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58,"hash":"77f8314368b36a9393ec9c7735a91700","hostname":"EderCortes"}	2024-11-02 21:27:59
17886	9d65b110-b9c8-4382-9f75-59ebde9e523e	9d65b110-bb25-49ec-bc43-48b1cd890f5d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-02 21:27:59
17887	9d65b110-ba29-4f30-bc46-d50392ac7061	9d65b110-bb25-49ec-bc43-48b1cd890f5d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"7","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"14","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:27:59
17657	9d656080-5310-4556-8552-d1dc0f26f3bf	9d656080-57e3-409b-afcb-2d8847bfe49e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":844}	2024-11-02 17:42:42
35374	9d69c449-7ea4-485b-8a25-4080c510ad3c	9d69c449-a1b3-4c2b-ba6c-d021f768c3d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 22:05:02
35375	9d69c449-9bbc-4af5-8038-71214c3e362c	9d69c449-a1b3-4c2b-ba6c-d021f768c3d5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 22:05:02
35376	9d69c449-9c12-4160-9904-63bb7e322db9	9d69c449-a1b3-4c2b-ba6c-d021f768c3d5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 22:05:02
35377	9d69c449-a066-4bc0-aafb-8143b6aa77ea	9d69c449-a1b3-4c2b-ba6c-d021f768c3d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 22:05:02
14404	9d5d1e1f-6a8c-4761-8f04-a476b49d27a6	9d5d1e1f-c394-464e-83e7-7758d592fe45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-10-29 15:10:28
14405	9d5d1e1f-bfc6-4587-8535-d3805fb8d74e	9d5d1e1f-c394-464e-83e7-7758d592fe45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-10-29 15:10:29
14406	9d5d1e1f-c1a5-409e-b956-25e970140fdb	9d5d1e1f-c394-464e-83e7-7758d592fe45	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":734,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:10:29
34012	9d69b90a-87dc-4f4f-971a-ce8822443ffa	9d69b90a-ae70-4eb7-8eaa-c2f2a6fd2e84	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:33:36
34013	9d69b90a-a5a5-486f-95c4-5f92d6126880	9d69b90a-ae70-4eb7-8eaa-c2f2a6fd2e84	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 82\\n                        ","time":"54.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"23238af5dc47e80ea555e80a08e2015d","hostname":"EderCortes"}	2024-11-04 21:33:36
34014	9d69b90a-a8de-4255-9e0d-314d77493429	9d69b90a-ae70-4eb7-8eaa-c2f2a6fd2e84	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '82' order by \\"item_loans\\".\\"id\\" asc","time":"2.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:33:36
34015	9d69b90a-acbc-47d2-91b8-097ac852693a	9d69b90a-ae70-4eb7-8eaa-c2f2a6fd2e84	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:33:36
35378	9d69c449-a0c3-4e94-850c-73509fe0a82a	9d69c449-a1b3-4c2b-ba6c-d021f768c3d5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":289,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:05:02
35626	9d69c538-8971-43e9-8c73-6e4e659e55af	9d69c538-d342-47b9-b291-5b4cd7e22302	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 22:07:39
35627	9d69c538-cdad-48eb-a1c7-7e39b3cc4842	9d69c538-d342-47b9-b291-5b4cd7e22302	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"153.25","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 22:07:39
35628	9d69c538-ce02-4a49-b570-905bccb4ba84	9d69c538-d342-47b9-b291-5b4cd7e22302	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 22:07:39
35629	9d69c538-d204-48d1-bee5-bc8ec69e6d95	9d69c538-d342-47b9-b291-5b4cd7e22302	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 22:07:39
35630	9d69c538-d251-44a1-8d78-9d8ebb4548eb	9d69c538-d342-47b9-b291-5b4cd7e22302	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":350,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:07:39
14407	9d5d1e20-6f50-495b-841a-9cbf3ed8b96e	9d5d1e20-afc6-4717-be28-f9f53199efa8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-10-29 15:10:29
14408	9d5d1e20-a36c-4aec-b970-134240631962	9d5d1e20-afc6-4717-be28-f9f53199efa8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"70.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":179,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 15:10:29
14409	9d5d1e20-a3e5-4f49-8e27-8a5b92d364b9	9d5d1e20-afc6-4717-be28-f9f53199efa8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 15:10:29
14410	9d5d1e20-ad2a-44ae-be6c-448d64e0f6b2	9d5d1e20-afc6-4717-be28-f9f53199efa8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-10-29 15:10:29
14411	9d5d1e20-add9-4cf3-83db-0f5e09e29aa0	9d5d1e20-afc6-4717-be28-f9f53199efa8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":522,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:10:29
35379	9d69c449-fb12-4c43-aa77-d318b072034e	9d69c44a-1fd6-4a06-8c05-f4487ff9d302	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 22:05:03
15330	9d5ed0cc-2b56-4b68-95d2-13d54d2d77a8	9d5ed0cc-70a3-4535-bbf9-985e8495c50e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-30 11:25:55
15331	9d5ed0cc-6f15-4efa-abe6-07909b57b175	9d5ed0cc-70a3-4535-bbf9-985e8495c50e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-30 11:25:55
34016	9d69b90a-ad28-468b-9773-881fcb7e8d9f	9d69b90a-ae70-4eb7-8eaa-c2f2a6fd2e84	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/82","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":82,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"480000","loans_pago_interes":"120000","user_alias":"eder.cortes"},"items":[{"id":316,"loans_codigo":82,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:36","updated_at":"2024-11-04 21:29:42","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":464,"loans_codigo":82,"itemloans_cuota":"2","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 21:29:42","updated_at":"2024-11-04 21:31:18","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":468,"loans_codigo":82,"itemloans_cuota":"3","itemloans_valor_cuota":"155000","itemloans_iteres":"38750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:31:18","updated_at":"2024-11-04 21:31:18","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":469,"loans_codigo":82,"itemloans_cuota":"4","itemloans_valor_cuota":"155000","itemloans_iteres":"38750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:31:18","updated_at":"2024-11-04 21:31:18","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":470,"loans_codigo":82,"itemloans_cuota":"5","itemloans_valor_cuota":"155000","itemloans_iteres":"38750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:31:18","updated_at":"2024-11-04 21:31:18","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":471,"loans_codigo":82,"itemloans_cuota":"6","itemloans_valor_cuota":"155000","itemloans_iteres":"38750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:31:18","updated_at":"2024-11-04 21:31:18","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":387,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:33:36
14412	9d5d1e21-66a3-49f9-a6a4-29a4bdfe021b	9d5d1e21-a223-4e5e-8528-f81d0e69eaa0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-10-29 15:10:30
14413	9d5d1e21-9609-4b96-a241-9927efeb7ef7	9d5d1e21-a223-4e5e-8528-f81d0e69eaa0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"71.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":179,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 15:10:30
14414	9d5d1e21-969a-440b-93a5-aa63e0ba4b31	9d5d1e21-a223-4e5e-8528-f81d0e69eaa0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 15:10:30
14415	9d5d1e21-a018-4d06-8b4e-c45b81ea1aae	9d5d1e21-a223-4e5e-8528-f81d0e69eaa0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-10-29 15:10:30
14416	9d5d1e21-a0a9-4f70-80ab-d211c485679c	9d5d1e21-a223-4e5e-8528-f81d0e69eaa0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":593,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:10:30
15332	9d5ed0cc-6fad-4e8b-b52b-0b71a6517433	9d5ed0cc-70a3-4535-bbf9-985e8495c50e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:25:55
17888	9d65b180-936f-496a-ad74-a47d348f7f60	9d65b180-e21f-4abf-96b7-1d62809ae7d7	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 21:29:12
17889	9d65b180-d739-48cf-b79d-a1a9b94a365c	9d65b180-e21f-4abf-96b7-1d62809ae7d7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"148.28","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"2b11ef88578e3c91c11800e110e490df","hostname":"EderCortes"}	2024-11-02 21:29:12
17890	9d65b180-db56-4a19-8f6e-fc47fa051f06	9d65b180-e21f-4abf-96b7-1d62809ae7d7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"2.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:29:12
17891	9d65b180-db9d-4dc7-8c51-0ecb34dbcc7e	9d65b180-e21f-4abf-96b7-1d62809ae7d7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:29:12
17892	9d65b180-e081-48b0-ba1e-e2808cbe110e	9d65b180-e21f-4abf-96b7-1d62809ae7d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:29:12
17893	9d65b180-e0f6-4aef-ade4-982beec5b015	9d65b180-e21f-4abf-96b7-1d62809ae7d7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":391,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:29:12
34017	9d69b957-48be-4e40-9646-5e02f17f3aec	9d69b957-4bd2-4230-98bd-f8c615d858ff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":144,"memory":20,"hostname":"EderCortes"}	2024-11-04 21:34:26
34018	9d69b957-d06a-4790-b179-edc5cc785474	9d69b957-fc2f-484a-b36f-0dd1efedded8	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 21:34:26
34019	9d69b957-ebec-46ab-87e6-b6a75609374c	9d69b957-fc2f-484a-b36f-0dd1efedded8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 82 limit 1","time":"3.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":505,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 21:34:26
34020	9d69b957-ec4d-4a86-aab1-65e89a64fce3	9d69b957-fc2f-484a-b36f-0dd1efedded8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":2,"hostname":"EderCortes"}	2024-11-04 21:34:26
19899	9d66eb36-bb57-4a25-a7cd-740c686ff6fa	9d66eb37-062c-402a-8a79-852f4c3ec682	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:06:24
14421	9d5d1e23-e6d9-4397-86af-a9ac3f56d637	9d5d1e24-523c-4e22-b7f6-47b460b471de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-10-29 15:10:31
19900	9d66eb37-0453-4be3-92da-4c136acf0706	9d66eb37-062c-402a-8a79-852f4c3ec682	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:06:24
19901	9d66eb37-052b-4e28-9422-af3f4c7bdf55	9d66eb37-062c-402a-8a79-852f4c3ec682	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:06:24
34021	9d69b957-ee3a-4fa9-8aff-32130aefd15c	9d69b957-fc2f-484a-b36f-0dd1efedded8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select count(*) as aggregate from \\"item_loans\\" where \\"loans_codigo\\" = 82 and (\\"itemloans_status\\" = 'Pagada' or \\"itemloans_status\\" = 'Abono')","time":"2.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":566,"hash":"40bb62c1101cd4a074e44b13c59d4517","hostname":"EderCortes"}	2024-11-04 21:34:26
34022	9d69b957-ef12-4893-b226-36ea4c40745f	9d69b957-fc2f-484a-b36f-0dd1efedded8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 180000, \\"loans_pago_prestado\\" = 720000, \\"updated_at\\" = '2024-11-04 21:34:26' where \\"id\\" = 82","time":"1.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":605,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 21:34:26
34023	9d69b957-ef70-44ec-a295-6985924465af	9d69b957-fc2f-484a-b36f-0dd1efedded8	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:82","changes":{"updated_at":"2024-11-04 21:34:26","loans_pago_interes":180000,"loans_pago_prestado":720000},"hostname":"EderCortes"}	2024-11-04 21:34:26
34024	9d69b957-eff3-4ff1-a468-8f774e5d1da5	9d69b957-fc2f-484a-b36f-0dd1efedded8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 82 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"0.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":612,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 21:34:26
34025	9d69b957-f022-41db-8a0b-c6bc7ba915b9	9d69b957-fc2f-484a-b36f-0dd1efedded8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 21:34:26
34026	9d69b957-f18a-479c-90fa-4008aa271251	9d69b957-fc2f-484a-b36f-0dd1efedded8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Abono', \\"itemloans_aprobador\\" = 12, \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = 60000, \\"itemloans_cuota_cancelada\\" = 240000, \\"updated_at\\" = '2024-11-04 21:34:26' where \\"id\\" = 468","time":"2.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":620,"hash":"6acd4a1714feb503cbc85629417266cf","hostname":"EderCortes"}	2024-11-04 21:34:26
34027	9d69b957-f1bf-45c7-8be6-7f60c09ae37c	9d69b957-fc2f-484a-b36f-0dd1efedded8	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:468","changes":{"itemloans_status":"Abono","itemloans_aprobador":12,"updated_at":"2024-11-04 21:34:26","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":60000,"itemloans_cuota_cancelada":240000},"hostname":"EderCortes"}	2024-11-04 21:34:26
34028	9d69b957-f221-42d2-a3a4-53af59a74e9c	9d69b957-fc2f-484a-b36f-0dd1efedded8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"delete from \\"item_loans\\" where \\"loans_codigo\\" = 82 and \\"itemloans_status\\" = 'Pendiente'","time":"0.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":627,"hash":"89bf3c496a8b0746ff5d1219b8dc29e3","hostname":"EderCortes"}	2024-11-04 21:34:26
34029	9d69b957-f285-4558-8b32-8e28e8809eec	9d69b957-fc2f-484a-b36f-0dd1efedded8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 82 limit 1","time":"0.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":630,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 21:34:26
34030	9d69b957-f344-4f92-85da-776e7d4dd646	9d69b957-fc2f-484a-b36f-0dd1efedded8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (82, 4, 190000, 47500, 'Pendiente', 'Se realiza abono', '12-11-2024', 0, 0, '2024-11-04 21:34:26', '2024-11-04 21:34:26')","time":"0.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":693,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:34:26
34031	9d69b957-f36f-4350-94cb-92761c8300f6	9d69b957-fc2f-484a-b36f-0dd1efedded8	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:34:26
34032	9d69b957-f3fa-4ce4-9c8b-4c8925f097ee	9d69b957-fc2f-484a-b36f-0dd1efedded8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (82, 5, 190000, 47500, 'Pendiente', 'Se realiza abono', '20-11-2024', 0, 0, '2024-11-04 21:34:26', '2024-11-04 21:34:26')","time":"0.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":693,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:34:26
34033	9d69b957-f423-4d59-9ad7-dbb39eac1240	9d69b957-fc2f-484a-b36f-0dd1efedded8	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:34:26
34034	9d69b957-faa7-4734-9023-be5a5d856a25	9d69b957-fc2f-484a-b36f-0dd1efedded8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:34:26
35380	9d69c44a-18d4-4164-9440-d7a66c814ae6	9d69c44a-1fd6-4a06-8c05-f4487ff9d302	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:05:03
35381	9d69c44a-194d-433b-8d2b-004fb6f574aa	9d69c44a-1fd6-4a06-8c05-f4487ff9d302	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:05:03
19902	9d66eb37-591b-46c8-81c4-b675a00e1103	9d66eb37-7712-45d6-b570-eb7de6c56264	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:06:24
19903	9d66eb37-6cf8-42b7-89b6-23447963e02f	9d66eb37-7712-45d6-b570-eb7de6c56264	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"38.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:06:25
19904	9d66eb37-714e-4fe4-891e-bc30a2634f53	9d66eb37-7712-45d6-b570-eb7de6c56264	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:06:25
19905	9d66eb37-717e-45df-9695-5dd2e0085947	9d66eb37-7712-45d6-b570-eb7de6c56264	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:06:25
19906	9d66eb37-75ec-4564-b30d-a1028ec51e4f	9d66eb37-7712-45d6-b570-eb7de6c56264	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 12:06:25
19907	9d66eb37-7638-4d6f-b04d-7de038cef19e	9d66eb37-7712-45d6-b570-eb7de6c56264	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:06:25
34035	9d69b957-fafb-44e4-9f71-972486c00cb9	9d69b957-fc2f-484a-b36f-0dd1efedded8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"61","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"300000","idLoans":82,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El abono fue aplicado exitosamente","status":true},"duration":274,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:34:26
35382	9d69c44a-1e06-4f4a-a040-e51674aa14d2	9d69c44a-1fd6-4a06-8c05-f4487ff9d302	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 22:05:03
35383	9d69c44a-1e84-4308-a6de-f3268f59c8fb	9d69c44a-1fd6-4a06-8c05-f4487ff9d302	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":301,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:05:03
35631	9d69c539-2685-4958-963b-6cf052a39843	9d69c539-4349-4f3e-a3fd-6657913ec0f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 22:07:39
35632	9d69c539-3e24-4907-bd5a-623549d3943e	9d69c539-4349-4f3e-a3fd-6657913ec0f6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"38.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:07:39
19908	9d66eb38-ccac-4c96-9541-013553cde28b	9d66eb38-ee2b-4ec5-9aca-816652a7e46a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 12:06:25
19909	9d66eb38-e8df-4296-80e4-081c907a82c7	9d66eb38-ee2b-4ec5-9aca-816652a7e46a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:06:26
19910	9d66eb38-e928-4a02-a211-13cbf730531c	9d66eb38-ee2b-4ec5-9aca-816652a7e46a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:06:26
19911	9d66eb38-ecd4-4652-900e-261338555150	9d66eb38-ee2b-4ec5-9aca-816652a7e46a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 12:06:26
19912	9d66eb38-ed28-4717-89d9-2aea4e597a9e	9d66eb38-ee2b-4ec5-9aca-816652a7e46a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":359,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:06:26
34036	9d69b958-594d-4a34-b7c3-582eb302a859	9d69b958-7be0-43af-8e3a-a90f44529ad3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:34:27
34037	9d69b958-735e-4f37-a236-c4cd37f18d91	9d69b958-7be0-43af-8e3a-a90f44529ad3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 82\\n                        ","time":"50.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"23238af5dc47e80ea555e80a08e2015d","hostname":"EderCortes"}	2024-11-04 21:34:27
34038	9d69b958-7663-4e22-b158-4c1408e56c90	9d69b958-7be0-43af-8e3a-a90f44529ad3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '82' order by \\"item_loans\\".\\"id\\" asc","time":"2.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:34:27
34039	9d69b958-7a2a-4abc-be0e-0b42aca3c639	9d69b958-7be0-43af-8e3a-a90f44529ad3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:34:27
34040	9d69b958-7a9f-488b-ad96-521658a456ba	9d69b958-7be0-43af-8e3a-a90f44529ad3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/82","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":82,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"720000","loans_pago_interes":"180000","user_alias":"eder.cortes"},"items":[{"id":316,"loans_codigo":82,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:36","updated_at":"2024-11-04 21:29:42","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":464,"loans_codigo":82,"itemloans_cuota":"2","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 21:29:42","updated_at":"2024-11-04 21:31:18","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":468,"loans_codigo":82,"itemloans_cuota":"3","itemloans_valor_cuota":"155000","itemloans_iteres":"38750","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 21:31:18","updated_at":"2024-11-04 21:34:26","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":472,"loans_codigo":82,"itemloans_cuota":"4","itemloans_valor_cuota":"190000","itemloans_iteres":"47500","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:34:26","updated_at":"2024-11-04 21:34:26","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":473,"loans_codigo":82,"itemloans_cuota":"5","itemloans_valor_cuota":"190000","itemloans_iteres":"47500","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:34:26","updated_at":"2024-11-04 21:34:26","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":302,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:34:27
35633	9d69c539-3e74-4526-acfc-b82ea8437f14	9d69c539-4349-4f3e-a3fd-6657913ec0f6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:07:39
35634	9d69c539-4220-402e-9d1c-e47a5314bfa3	9d69c539-4349-4f3e-a3fd-6657913ec0f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 22:07:39
19989	9d66ec7b-b0fb-4c4a-94f0-93d50c7780e2	9d66ec7b-ce17-4c57-8fcf-49a10e0c5204	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:09:57
19990	9d66ec7b-cc34-4e5f-ab73-d273e59b671f	9d66ec7b-ce17-4c57-8fcf-49a10e0c5204	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 12:09:57
19991	9d66ec7b-ccf1-41bd-bab6-be39511d792e	9d66ec7b-ce17-4c57-8fcf-49a10e0c5204	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":259,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:09:57
34041	9d69b97d-ef93-4aaa-8e85-cd04e0f9cbe5	9d69b97e-0b1c-414f-849e-8c82251eb394	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:34:51
34042	9d69b97e-0693-4e3f-b2e7-6bce23df7e84	9d69b97e-0b1c-414f-849e-8c82251eb394	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"43.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 21:34:51
34043	9d69b97e-09b3-43b1-99ff-5e0d58161387	9d69b97e-0b1c-414f-849e-8c82251eb394	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:34:51
34044	9d69b97e-0a20-4ac8-8f4c-6fbd9de370af	9d69b97e-0b1c-414f-849e-8c82251eb394	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":218,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:34:51
35635	9d69c539-426d-4eae-a8db-913b5680592a	9d69c539-4349-4f3e-a3fd-6657913ec0f6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":267,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:07:39
19992	9d66ec7c-198f-48fd-a2d5-2290f103ae39	9d66ec7c-6278-4fac-a081-007709f4c250	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 12:09:57
19993	9d66ec7c-598d-4257-abcf-1a3b78b6c24d	9d66ec7c-6278-4fac-a081-007709f4c250	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"151.17","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:09:57
19994	9d66ec7c-5d00-40c6-8c84-fc143f175b53	9d66ec7c-6278-4fac-a081-007709f4c250	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:09:57
19995	9d66ec7c-5d30-483f-a265-4e56036b32d4	9d66ec7c-6278-4fac-a081-007709f4c250	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:09:57
19996	9d66ec7c-613c-491e-a2c8-c3847881ec5d	9d66ec7c-6278-4fac-a081-007709f4c250	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 12:09:57
19997	9d66ec7c-6183-426f-8fb1-f5a7fe880e6e	9d66ec7c-6278-4fac-a081-007709f4c250	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":339,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:09:57
34045	9d69b989-a2d9-4df7-abac-1be9b2f0d824	9d69b989-ea2b-482a-aa5f-bff9c855fedf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:34:59
34046	9d69b989-e2dc-4cad-bfab-813d907678fe	9d69b989-ea2b-482a-aa5f-bff9c855fedf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 75\\n                        ","time":"151.75","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"bbcd699f0014905e552a5f09996004ad","hostname":"EderCortes"}	2024-11-04 21:34:59
34047	9d69b989-e59f-4435-b2b6-a2afb5879f90	9d69b989-ea2b-482a-aa5f-bff9c855fedf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '75' order by \\"item_loans\\".\\"id\\" asc","time":"1.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:34:59
34048	9d69b989-e8b0-4b8b-9e11-bd5c91c33133	9d69b989-ea2b-482a-aa5f-bff9c855fedf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:34:59
19998	9d66ec7d-99c8-4f3f-91b3-901fe768ead9	9d66ec7d-e8b5-4598-b557-ea35e1004335	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 12:09:58
19999	9d66ec7d-e051-47ab-9192-7359d89afd7b	9d66ec7d-e8b5-4598-b557-ea35e1004335	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"149.03","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:09:58
20000	9d66ec7d-e0ab-4825-9ca2-763d03bff56c	9d66ec7d-e8b5-4598-b557-ea35e1004335	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:09:58
20001	9d66ec7d-e6b3-41ae-9d01-09696297213d	9d66ec7d-e8b5-4598-b557-ea35e1004335	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 12:09:58
20002	9d66ec7d-e739-482a-b1c2-e1f49537a6aa	9d66ec7d-e8b5-4598-b557-ea35e1004335	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":523,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:09:58
34049	9d69b989-e921-495b-8038-88361c56c04b	9d69b989-ea2b-482a-aa5f-bff9c855fedf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/75","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":75,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0","user_alias":"eder.cortes"},"items":[{"id":281,"loans_codigo":75,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:30","updated_at":"2024-11-04 09:18:30","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":282,"loans_codigo":75,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:30","updated_at":"2024-11-04 09:18:30","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":283,"loans_codigo":75,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:30","updated_at":"2024-11-04 09:18:30","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":284,"loans_codigo":75,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:30","updated_at":"2024-11-04 09:18:30","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":285,"loans_codigo":75,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:30","updated_at":"2024-11-04 09:18:30","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":396,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:34:59
20074	9d66edf7-8f0b-42eb-a158-12163aae4c37	9d66edf7-d63b-4d16-9355-f609d3929858	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 12:14:06
20075	9d66edf7-d43c-4594-bb52-781e8876b15c	9d66edf7-d63b-4d16-9355-f609d3929858	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 12:14:06
20076	9d66edf7-d4f6-420d-b01a-1e01d981e205	9d66edf7-d63b-4d16-9355-f609d3929858	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":334,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:14:06
20077	9d66edf8-39a8-4eb6-ad40-ef5dc3364928	9d66edf8-57ed-4094-b3b6-cbc356257bbf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 12:14:06
20078	9d66edf8-4e66-40fd-a38a-a2ff9d64dcb7	9d66edf8-57ed-4094-b3b6-cbc356257bbf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"41.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:14:06
20079	9d66edf8-5200-4ead-808d-7a4a5fa92f2e	9d66edf8-57ed-4094-b3b6-cbc356257bbf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:14:06
20080	9d66edf8-5232-4acf-843f-a4bf2fa7b236	9d66edf8-57ed-4094-b3b6-cbc356257bbf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:14:06
20081	9d66edf8-5670-4b46-a903-1c2fd7bf122e	9d66edf8-57ed-4094-b3b6-cbc356257bbf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-03 12:14:07
20082	9d66edf8-56c1-424b-befd-99931d2bcd40	9d66edf8-57ed-4094-b3b6-cbc356257bbf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:14:07
34050	9d69b997-3cfd-4e0c-8c9e-3fbeb33f0e99	9d69b997-401e-4810-b2e2-e833e79a2655	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":130,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:35:08
20083	9d66edfa-419d-400f-8bdf-1f98df6da199	9d66edfa-7d25-4995-a026-86162bba7f09	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 12:14:08
20084	9d66edfa-7198-462c-a6d9-ba770394225b	9d66edfa-7d25-4995-a026-86162bba7f09	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"70.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:14:08
20085	9d66edfa-7250-444b-b07c-ae059c6b9ae3	9d66edfa-7d25-4995-a026-86162bba7f09	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:14:08
20086	9d66edfa-7b12-4259-9867-2e449c8e0173	9d66edfa-7d25-4995-a026-86162bba7f09	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:14:08
20087	9d66edfa-7ba6-494f-b317-bfc463eac8d2	9d66edfa-7d25-4995-a026-86162bba7f09	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":566,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:14:08
34051	9d69b997-a6b9-48a1-ab76-3890ff93251e	9d69b997-cb48-4944-b14b-41331591a805	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:35:08
34052	9d69b997-bd0b-4aa2-9297-b5c8db553924	9d69b997-cb48-4944-b14b-41331591a805	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 75 limit 1","time":"2.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":505,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 21:35:08
34053	9d69b997-bd5a-4975-b4f0-6c9b515a3a44	9d69b997-cb48-4944-b14b-41331591a805	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":2,"hostname":"EderCortes"}	2024-11-04 21:35:08
34054	9d69b997-bef4-4039-853b-4bbe631fcde9	9d69b997-cb48-4944-b14b-41331591a805	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select count(*) as aggregate from \\"item_loans\\" where \\"loans_codigo\\" = 75 and (\\"itemloans_status\\" = 'Pagada' or \\"itemloans_status\\" = 'Abono')","time":"2.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":566,"hash":"40bb62c1101cd4a074e44b13c59d4517","hostname":"EderCortes"}	2024-11-04 21:35:08
34055	9d69b997-bf9a-465e-8332-dfa35b51e59b	9d69b997-cb48-4944-b14b-41331591a805	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_estado\\" = 'En curso', \\"loans_pago_interes\\" = 60000, \\"loans_pago_prestado\\" = 240000, \\"updated_at\\" = '2024-11-04 21:35:08' where \\"id\\" = 75","time":"0.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":605,"hash":"acfe32aea56c9ca6bdbb917f944a78d1","hostname":"EderCortes"}	2024-11-04 21:35:08
34056	9d69b997-bff2-4fff-a6e3-9c358eba2560	9d69b997-cb48-4944-b14b-41331591a805	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:75","changes":{"loans_estado":"En curso","updated_at":"2024-11-04 21:35:08","loans_pago_interes":60000,"loans_pago_prestado":240000},"hostname":"EderCortes"}	2024-11-04 21:35:08
34057	9d69b997-c073-4a20-a4d8-7de81206569c	9d69b997-cb48-4944-b14b-41331591a805	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 75 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"0.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":612,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 21:35:08
34058	9d69b997-c0a3-4dcc-90b2-ab1bda0fba4c	9d69b997-cb48-4944-b14b-41331591a805	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 21:35:08
34059	9d69b997-c12b-4ceb-ae04-e8f64b634446	9d69b997-cb48-4944-b14b-41331591a805	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Abono', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = 60000, \\"itemloans_cuota_cancelada\\" = 240000, \\"updated_at\\" = '2024-11-04 21:35:08' where \\"id\\" = 281","time":"0.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":620,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 21:35:08
34060	9d69b997-c15e-40ba-a8ad-74b297f139ce	9d69b997-cb48-4944-b14b-41331591a805	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:281","changes":{"itemloans_status":"Abono","updated_at":"2024-11-04 21:35:08","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":60000,"itemloans_cuota_cancelada":240000},"hostname":"EderCortes"}	2024-11-04 21:35:08
34061	9d69b997-c1c3-4b88-9891-c65efec52f19	9d69b997-cb48-4944-b14b-41331591a805	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"delete from \\"item_loans\\" where \\"loans_codigo\\" = 75 and \\"itemloans_status\\" = 'Pendiente'","time":"0.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":627,"hash":"89bf3c496a8b0746ff5d1219b8dc29e3","hostname":"EderCortes"}	2024-11-04 21:35:08
34062	9d69b997-c226-474e-906e-0d608057b42d	9d69b997-cb48-4944-b14b-41331591a805	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 75 limit 1","time":"0.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":630,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 21:35:08
34063	9d69b997-c2cf-4b3d-b00c-85db6400f24a	9d69b997-cb48-4944-b14b-41331591a805	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (75, 2, 215000, 53750, 'Pendiente', 'Se realiza abono', '12-11-2024', 0, 0, '2024-11-04 21:35:08', '2024-11-04 21:35:08')","time":"0.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":693,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:35:08
20164	9d66eefe-7f75-429a-9ca2-7b44d26f3b26	9d66eefe-ca9e-47f8-adcd-608f64a9be9a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:16:58
20165	9d66eefe-c8b5-47fd-8e93-e805c2dc2244	9d66eefe-ca9e-47f8-adcd-608f64a9be9a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:16:58
20166	9d66eefe-c981-4ef7-b575-7e18163e3198	9d66eefe-ca9e-47f8-adcd-608f64a9be9a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":372,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:16:59
34064	9d69b997-c2fa-47c1-ac2d-7d2ddec8263e	9d69b997-cb48-4944-b14b-41331591a805	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:35:08
34065	9d69b997-c362-439e-9e0b-8f637317f76e	9d69b997-cb48-4944-b14b-41331591a805	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (75, 3, 215000, 53750, 'Pendiente', 'Se realiza abono', '20-11-2024', 0, 0, '2024-11-04 21:35:08', '2024-11-04 21:35:08')","time":"0.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":693,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:35:08
34066	9d69b997-c389-490c-9bee-84c89d9c8c7f	9d69b997-cb48-4944-b14b-41331591a805	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:35:08
34067	9d69b997-c3ea-4eaf-8f86-c11f649f9759	9d69b997-cb48-4944-b14b-41331591a805	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (75, 4, 215000, 53750, 'Pendiente', 'Se realiza abono', '28-11-2024', 0, 0, '2024-11-04 21:35:08', '2024-11-04 21:35:08')","time":"0.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":693,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:35:08
34068	9d69b997-c40d-4ab9-942d-47acab9b37df	9d69b997-cb48-4944-b14b-41331591a805	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:35:08
34069	9d69b997-c470-4549-8f43-a4751a9648d6	9d69b997-cb48-4944-b14b-41331591a805	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (75, 5, 215000, 53750, 'Pendiente', 'Se realiza abono', '06-12-2024', 0, 0, '2024-11-04 21:35:08', '2024-11-04 21:35:08')","time":"0.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":693,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:35:08
34070	9d69b997-c493-43d2-940b-7a5cd2352cdf	9d69b997-cb48-4944-b14b-41331591a805	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:35:08
20167	9d66eeff-1d9c-4bd1-ba1a-2941b8dc723a	9d66eeff-3b94-4ecc-bba8-3cb935f6e0b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:16:59
20168	9d66eeff-3309-4df7-beb4-041b575525e9	9d66eeff-3b94-4ecc-bba8-3cb935f6e0b3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"41.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:16:59
20169	9d66eeff-369e-495c-931e-39fed55c4c21	9d66eeff-3b94-4ecc-bba8-3cb935f6e0b3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:16:59
20170	9d66eeff-36e2-40db-858f-2e7a2d0750c2	9d66eeff-3b94-4ecc-bba8-3cb935f6e0b3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:16:59
17985	9d65b50b-83ba-4740-9971-f76541548fed	9d65b50b-a931-49b7-bf96-06b76f7de8df	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 21:39:06
17986	9d65b50b-a726-4cae-b762-a299ed639ed1	9d65b50b-a931-49b7-bf96-06b76f7de8df	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:39:06
17987	9d65b50b-a7eb-4bd8-b06e-7e6c3e99814d	9d65b50b-a931-49b7-bf96-06b76f7de8df	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":268,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:39:06
20171	9d66eeff-3a66-4311-b072-fbafc042a9c8	9d66eeff-3b94-4ecc-bba8-3cb935f6e0b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:16:59
20172	9d66eeff-3aa9-49a9-a241-cd6149e46e1d	9d66eeff-3b94-4ecc-bba8-3cb935f6e0b3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:16:59
34071	9d69b997-ca24-4544-a7ea-632febc2580b	9d69b997-cb48-4944-b14b-41331591a805	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:35:08
34072	9d69b997-ca67-4e09-a914-24641312d2a4	9d69b997-cb48-4944-b14b-41331591a805	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"61","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"300000","idLoans":75,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El abono fue aplicado exitosamente","status":true},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:35:08
17988	9d65b50c-058c-4767-9248-e3c2688e1b39	9d65b50c-25e5-4568-8169-f6e064e00220	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:39:07
17989	9d65b50c-1c17-4db1-88c1-4fdce310ed76	9d65b50c-25e5-4568-8169-f6e064e00220	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"45.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"2b11ef88578e3c91c11800e110e490df","hostname":"EderCortes"}	2024-11-02 21:39:07
16601	9d64d3fc-8a74-4dff-b771-e98255a52935	9d64d3fc-d31b-4562-aa24-8326c88be91b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 11:09:48
16602	9d64d3fc-d169-4780-b907-1255cebe8499	9d64d3fc-d31b-4562-aa24-8326c88be91b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 11:09:48
14632	9d5ebef1-56f5-42ea-935a-399720b08f20	9d5ebef1-a32c-40de-af7c-75f37840fd69	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-30 10:35:59
14633	9d5ebef1-a049-4109-8f11-61dd18ac98e7	9d5ebef1-a32c-40de-af7c-75f37840fd69	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-30 10:35:59
14634	9d5ebef1-a1d7-4943-a8f6-fdb86f92c42d	9d5ebef1-a32c-40de-af7c-75f37840fd69	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":464,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:35:59
16603	9d64d3fc-d207-4e69-8aa0-a8dbc864f5a6	9d64d3fc-d31b-4562-aa24-8326c88be91b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":374,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:09:48
17990	9d65b50c-1fa4-4bfc-9720-e808b1b93160	9d65b50c-25e5-4568-8169-f6e064e00220	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"2.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:39:07
17991	9d65b50c-1fdb-4a2f-80d2-49e177b61615	9d65b50c-25e5-4568-8169-f6e064e00220	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:39:07
17992	9d65b50c-2481-4f5f-9f52-295046fab2d2	9d65b50c-25e5-4568-8169-f6e064e00220	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:39:07
17993	9d65b50c-24d6-469e-ae7c-0fae1ae49d61	9d65b50c-25e5-4568-8169-f6e064e00220	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":277,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:39:07
20173	9d66ef00-9319-4f33-a186-e93f9437c1fa	9d66ef00-bc9b-478b-82f7-6b2a5fa900bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:17:00
20174	9d66ef00-b416-401d-ab59-8766e83aa0c3	9d66ef00-bc9b-478b-82f7-6b2a5fa900bd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:17:00
20175	9d66ef00-b48b-4fc2-8005-bf988c5ada0e	9d66ef00-bc9b-478b-82f7-6b2a5fa900bd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:17:00
20176	9d66ef00-ba72-460e-8106-ae7752cc9599	9d66ef00-bc9b-478b-82f7-6b2a5fa900bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:17:00
20177	9d66ef00-baf7-4a85-9e4f-a3464e7b7e5d	9d66ef00-bc9b-478b-82f7-6b2a5fa900bd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":502,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:17:00
34073	9d69b998-1626-4f58-8198-31a54bdbd7b7	9d69b998-328e-48f6-a980-062c009656c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:35:08
16604	9d64d3fd-2201-4f83-9517-427868107506	9d64d3fd-4295-4aac-bc79-c84fc578a5d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 11:09:48
16605	9d64d3fd-39e7-4c1b-a66a-5d9a1d671dae	9d64d3fd-4295-4aac-bc79-c84fc578a5d6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"46.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 11:09:48
16606	9d64d3fd-3db2-43b2-881b-62f44ff13208	9d64d3fd-4295-4aac-bc79-c84fc578a5d6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 11:09:48
16607	9d64d3fd-3dea-4184-adb2-b1dc3632e49c	9d64d3fd-4295-4aac-bc79-c84fc578a5d6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 11:09:48
14027	9d5d147a-bac5-42bd-82f4-737f2e22c0f2	9d5d147b-019a-4c8d-9534-d8dfdc8d1d44	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 14:43:31
14028	9d5d147a-ffb5-4278-96d5-357d1db563d8	9d5d147b-019a-4c8d-9534-d8dfdc8d1d44	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 14:43:31
14029	9d5d147b-003f-4b05-a7f5-713c17b93d50	9d5d147b-019a-4c8d-9534-d8dfdc8d1d44	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":358,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:43:31
16608	9d64d3fd-4178-4b41-bd11-050ed2d37884	9d64d3fd-4295-4aac-bc79-c84fc578a5d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-02 11:09:48
16609	9d64d3fd-41c9-4c4e-a9dd-cc3f60b187bd	9d64d3fd-4295-4aac-bc79-c84fc578a5d6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:09:48
17994	9d65b50d-abbd-4eff-a163-27d566a0f6e4	9d65b50d-db5a-4e6d-9734-7c8e64091bd4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:39:08
17995	9d65b50d-d077-42c2-912c-a2597210f103	9d65b50d-db5a-4e6d-9734-7c8e64091bd4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"63.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 21:39:08
17996	9d65b50d-d0fb-4b53-bbad-99a482ccc01d	9d65b50d-db5a-4e6d-9734-7c8e64091bd4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 21:39:08
17997	9d65b50d-d925-423f-a3d9-5eff09d55a86	9d65b50d-db5a-4e6d-9734-7c8e64091bd4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 21:39:08
17998	9d65b50d-d9c7-4aac-b18a-63f2c5810da6	9d65b50d-db5a-4e6d-9734-7c8e64091bd4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":384,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:39:08
14030	9d5d147b-4a4d-4b1c-873a-b81970110de1	9d5d147b-8ba4-4a01-aab5-8eb58b5f95cb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 14:43:31
14031	9d5d147b-878d-43c2-8113-3c76a381a05f	9d5d147b-8ba4-4a01-aab5-8eb58b5f95cb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"145.57","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-10-29 14:43:31
14032	9d5d147b-8a79-462c-af21-18e7753590a3	9d5d147b-8ba4-4a01-aab5-8eb58b5f95cb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 14:43:31
14033	9d5d147b-8ac6-4b16-84fe-dcd9689bdb7c	9d5d147b-8ba4-4a01-aab5-8eb58b5f95cb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":319,"memory":20,"hostname":"EderCortes"}	2024-10-29 14:43:31
16610	9d64d3fe-9871-49e9-8300-44fbf639b7f1	9d64d3fe-cbf3-4e3b-a1d6-21a9b80c3a73	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-02 11:09:49
16611	9d64d3fe-c281-4c0d-9810-bfc1f90f9c76	9d64d3fe-cbf3-4e3b-a1d6-21a9b80c3a73	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"66.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 11:09:49
14422	9d5d1e24-470a-4ddb-9638-6a75effec76e	9d5d1e24-523c-4e22-b7f6-47b460b471de	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"139.21","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 15:10:32
14423	9d5d1e24-47ec-4344-926c-b3f1d3216941	9d5d1e24-523c-4e22-b7f6-47b460b471de	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 15:10:32
14424	9d5d1e24-506a-4aa5-b83e-c6eea8db1b4a	9d5d1e24-523c-4e22-b7f6-47b460b471de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-10-29 15:10:32
16612	9d64d3fe-c311-47a0-b468-d98bc9a53202	9d64d3fe-cbf3-4e3b-a1d6-21a9b80c3a73	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 11:09:49
16613	9d64d3fe-ca13-4d04-83ea-7d55102c641b	9d64d3fe-cbf3-4e3b-a1d6-21a9b80c3a73	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-02 11:09:49
16614	9d64d3fe-ca99-4294-b76f-24dd6d6af5e6	9d64d3fe-cbf3-4e3b-a1d6-21a9b80c3a73	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":500,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:09:49
14034	9d5d147c-e9b6-4521-ad9a-896aefb8b61a	9d5d147d-1547-4d24-8c4f-214d070f9215	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 14:43:32
14035	9d5d147d-0cbb-49cc-b0fd-e68d35619d2b	9d5d147d-1547-4d24-8c4f-214d070f9215	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"60.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 14:43:32
14036	9d5d147d-0d36-4f79-9868-cb4c3284503d	9d5d147d-1547-4d24-8c4f-214d070f9215	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 14:43:32
14037	9d5d147d-1370-4bf1-9f31-1ff7d0ed3c5e	9d5d147d-1547-4d24-8c4f-214d070f9215	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 14:43:32
14038	9d5d147d-13cd-490d-ab48-6b2da59429f6	9d5d147d-1547-4d24-8c4f-214d070f9215	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":420,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:43:32
34074	9d69b998-2b59-41ee-b4db-20913924a13e	9d69b998-328e-48f6-a980-062c009656c4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 75\\n                        ","time":"41.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"bbcd699f0014905e552a5f09996004ad","hostname":"EderCortes"}	2024-11-04 21:35:08
34075	9d69b998-2e20-4dd6-989c-336f252d8d85	9d69b998-328e-48f6-a980-062c009656c4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '75' order by \\"item_loans\\".\\"id\\" asc","time":"2.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:35:08
14425	9d5d1e24-50e2-4d54-8a34-3c5225de28a5	9d5d1e24-523c-4e22-b7f6-47b460b471de	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":1030,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:10:32
34076	9d69b998-3120-4d89-81d5-af52024cad71	9d69b998-328e-48f6-a980-062c009656c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:35:08
34077	9d69b998-3173-4b5d-87ea-200f6987458d	9d69b998-328e-48f6-a980-062c009656c4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/75","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":75,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"240000","loans_pago_interes":"60000","user_alias":"eder.cortes"},"items":[{"id":281,"loans_codigo":75,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:30","updated_at":"2024-11-04 21:35:08","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":474,"loans_codigo":75,"itemloans_cuota":"2","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:35:08","updated_at":"2024-11-04 21:35:08","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":475,"loans_codigo":75,"itemloans_cuota":"3","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:35:08","updated_at":"2024-11-04 21:35:08","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":476,"loans_codigo":75,"itemloans_cuota":"4","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:35:08","updated_at":"2024-11-04 21:35:08","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":477,"loans_codigo":75,"itemloans_cuota":"5","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:35:08","updated_at":"2024-11-04 21:35:08","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:35:08
15444	9d5ed229-80cf-4ead-960d-9afc0784ae98	9d5ed229-b9f2-444e-b13f-85f02d63608b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-30 11:29:44
15445	9d5ed229-b736-4afc-a807-ebe3b475df8b	9d5ed229-b9f2-444e-b13f-85f02d63608b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-30 11:29:44
15446	9d5ed229-b8a7-424a-b225-89f9f3eb0724	9d5ed229-b9f2-444e-b13f-85f02d63608b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":626,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:29:44
14426	9d5d1e25-4d48-43b5-8a08-7211bc9aa224	9d5d1e25-8b66-43f7-ae94-f90f381acbd8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-10-29 15:10:32
15447	9d5ed22a-4c72-44f5-ad05-ea2bbdb8c710	9d5ed22a-7fec-47ae-a76c-4f62d5e19673	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-30 11:29:44
15448	9d5ed22a-6eb7-414c-8b3f-0b7b058bf33c	9d5ed22a-7fec-47ae-a76c-4f62d5e19673	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"63.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"088d1fdbe045a08c3b0073ef22c7da32","hostname":"EderCortes"}	2024-10-30 11:29:44
15449	9d5ed22a-75c0-489d-a8ee-4ce9ef10f6e4	9d5ed22a-7fec-47ae-a76c-4f62d5e19673	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"3.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-30 11:29:44
15450	9d5ed22a-7617-4df8-a0e5-81b6af4e11e9	9d5ed22a-7fec-47ae-a76c-4f62d5e19673	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-10-30 11:29:44
15451	9d5ed22a-7dfb-487b-9b29-1e5420d85f0a	9d5ed22a-7fec-47ae-a76c-4f62d5e19673	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-30 11:29:44
15452	9d5ed22a-7e8c-4005-bdcf-cfcb9f6058c5	9d5ed22a-7fec-47ae-a76c-4f62d5e19673	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":452,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:29:44
34078	9d69b9ac-7963-428c-b037-16342d75b0fa	9d69b9ac-7c7a-4264-a1c8-82efba3e77e9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":152,"memory":20,"hostname":"EderCortes"}	2024-11-04 21:35:22
35859	9d69c80c-dabd-41be-b6f9-37d4ae354d33	9d69c80c-f8cb-4f82-9c93-797f1314c4bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 22:15:34
35860	9d69c80c-f73c-48df-8ff9-388a09665dfb	9d69c80c-f8cb-4f82-9c93-797f1314c4bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 22:15:34
35861	9d69c80c-f7e3-49ec-b464-2b3579160f29	9d69c80c-f8cb-4f82-9c93-797f1314c4bd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":283,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:15:34
15453	9d5ed22b-7085-4589-8c4d-02fad74e9584	9d5ed22b-b5ad-4ae2-8731-53cf292c31bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-30 11:29:45
15454	9d5ed22b-aad7-4944-8d3c-e565b0b307b3	9d5ed22b-b5ad-4ae2-8731-53cf292c31bf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"94.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 11:29:45
15455	9d5ed22b-ab65-4f81-8e97-10fdf13ef9be	9d5ed22b-b5ad-4ae2-8731-53cf292c31bf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 11:29:45
15456	9d5ed22b-b397-4267-b60a-003aca0adc7f	9d5ed22b-b5ad-4ae2-8731-53cf292c31bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-30 11:29:45
15457	9d5ed22b-b442-4738-b766-fc619531d749	9d5ed22b-b5ad-4ae2-8731-53cf292c31bf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":771,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:29:45
34079	9d69b9ac-db7f-497e-9e1c-d3d7a011dd25	9d69b9ad-2bd3-4658-a61b-2eaef076e135	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:35:22
34080	9d69b9ad-1e1e-4666-815d-71dc94963a2e	9d69b9ad-2bd3-4658-a61b-2eaef076e135	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 75 limit 1","time":"2.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":505,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 21:35:22
34081	9d69b9ad-1e71-4e54-9d7f-7706e2d44c20	9d69b9ad-2bd3-4658-a61b-2eaef076e135	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":2,"hostname":"EderCortes"}	2024-11-04 21:35:22
34082	9d69b9ad-2020-495e-bf0d-e4ce2cc4268b	9d69b9ad-2bd3-4658-a61b-2eaef076e135	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select count(*) as aggregate from \\"item_loans\\" where \\"loans_codigo\\" = 75 and (\\"itemloans_status\\" = 'Pagada' or \\"itemloans_status\\" = 'Abono')","time":"2.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":566,"hash":"40bb62c1101cd4a074e44b13c59d4517","hostname":"EderCortes"}	2024-11-04 21:35:22
34083	9d69b9ad-20df-451a-b491-b37fe9b3b11f	9d69b9ad-2bd3-4658-a61b-2eaef076e135	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 120000, \\"loans_pago_prestado\\" = 480000, \\"updated_at\\" = '2024-11-04 21:35:22' where \\"id\\" = 75","time":"0.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":605,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 21:35:22
34084	9d69b9ad-2138-4db0-9ef9-5ce3f8d63548	9d69b9ad-2bd3-4658-a61b-2eaef076e135	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:75","changes":{"updated_at":"2024-11-04 21:35:22","loans_pago_interes":120000,"loans_pago_prestado":480000},"hostname":"EderCortes"}	2024-11-04 21:35:22
34085	9d69b9ad-21c1-47ee-b19e-469ad3b4c998	9d69b9ad-2bd3-4658-a61b-2eaef076e135	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 75 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"0.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":612,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 21:35:22
34086	9d69b9ad-21f6-47a7-a6fe-b8cf2662d554	9d69b9ad-2bd3-4658-a61b-2eaef076e135	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 21:35:22
34087	9d69b9ad-239d-4e39-b106-91f39435ca4d	9d69b9ad-2bd3-4658-a61b-2eaef076e135	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Abono', \\"itemloans_aprobador\\" = 12, \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = 60000, \\"itemloans_cuota_cancelada\\" = 240000, \\"updated_at\\" = '2024-11-04 21:35:22' where \\"id\\" = 474","time":"3.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":620,"hash":"6acd4a1714feb503cbc85629417266cf","hostname":"EderCortes"}	2024-11-04 21:35:22
34088	9d69b9ad-23d9-4a36-ae73-1adfeeb7b27d	9d69b9ad-2bd3-4658-a61b-2eaef076e135	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:474","changes":{"itemloans_status":"Abono","itemloans_aprobador":12,"updated_at":"2024-11-04 21:35:22","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":60000,"itemloans_cuota_cancelada":240000},"hostname":"EderCortes"}	2024-11-04 21:35:22
34089	9d69b9ad-243e-44b5-8c95-3db57c8daf09	9d69b9ad-2bd3-4658-a61b-2eaef076e135	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"delete from \\"item_loans\\" where \\"loans_codigo\\" = 75 and \\"itemloans_status\\" = 'Pendiente'","time":"0.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":627,"hash":"89bf3c496a8b0746ff5d1219b8dc29e3","hostname":"EderCortes"}	2024-11-04 21:35:22
34090	9d69b9ad-24a2-4a6c-8e8e-50180d6a51db	9d69b9ad-2bd3-4658-a61b-2eaef076e135	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 75 limit 1","time":"0.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":630,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 21:35:22
34091	9d69b9ad-254b-4ea1-afdf-f368f459b5ab	9d69b9ad-2bd3-4658-a61b-2eaef076e135	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (75, 3, 206666.66666667, 51666.666666667, 'Pendiente', 'Se realiza abono', '12-11-2024', 0, 0, '2024-11-04 21:35:22', '2024-11-04 21:35:22')","time":"0.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":693,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:35:22
15458	9d5ed22c-175d-4d4a-983a-1615dc21e191	9d5ed22c-341d-482d-9844-47439aef5582	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-30 11:29:45
15459	9d5ed22c-2f66-4c7d-8566-78701c8228fd	9d5ed22c-341d-482d-9844-47439aef5582	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 11:29:45
15460	9d5ed22c-2fb3-410b-8d69-7cef9cbe606c	9d5ed22c-341d-482d-9844-47439aef5582	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 11:29:45
15461	9d5ed22c-32e7-4c14-9786-2e445a704413	9d5ed22c-341d-482d-9844-47439aef5582	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-30 11:29:45
15462	9d5ed22c-332d-447d-8765-64672f1c97d0	9d5ed22c-341d-482d-9844-47439aef5582	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":287,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:29:45
34092	9d69b9ad-257a-4d03-8686-69e54a91008a	9d69b9ad-2bd3-4658-a61b-2eaef076e135	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:35:22
34093	9d69b9ad-25f1-4e49-bdfa-38d28ab90c74	9d69b9ad-2bd3-4658-a61b-2eaef076e135	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (75, 4, 206666.66666667, 51666.666666667, 'Pendiente', 'Se realiza abono', '20-11-2024', 0, 0, '2024-11-04 21:35:22', '2024-11-04 21:35:22')","time":"0.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":693,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:35:22
34094	9d69b9ad-2616-4de6-8270-2cf8b1d37050	9d69b9ad-2bd3-4658-a61b-2eaef076e135	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:35:22
34095	9d69b9ad-2681-4d8c-82cb-6b50049f6591	9d69b9ad-2bd3-4658-a61b-2eaef076e135	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (75, 5, 206666.66666667, 51666.666666667, 'Pendiente', 'Se realiza abono', '28-11-2024', 0, 0, '2024-11-04 21:35:22', '2024-11-04 21:35:22')","time":"0.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":693,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:35:22
34096	9d69b9ad-26aa-4d27-a2fb-fe286a698e35	9d69b9ad-2bd3-4658-a61b-2eaef076e135	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:35:22
34097	9d69b9ad-2a7e-4c0e-9b38-dabbc9a92d2b	9d69b9ad-2bd3-4658-a61b-2eaef076e135	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:35:22
34098	9d69b9ad-2ac5-4dcf-bdbd-cab847e8c4ec	9d69b9ad-2bd3-4658-a61b-2eaef076e135	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"61","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"300000","idLoans":75,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El abono fue aplicado exitosamente","status":true},"duration":363,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:35:22
35862	9d69c80d-4a0d-44fd-8f0a-afb75e7f373c	9d69c80d-69be-4bd4-b1ac-f01470c5c625	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 22:15:34
35863	9d69c80d-638c-4eb9-9897-e0c2e06088fe	9d69c80d-69be-4bd4-b1ac-f01470c5c625	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:15:34
35864	9d69c80d-63ec-47f0-acdc-e369411ee814	9d69c80d-69be-4bd4-b1ac-f01470c5c625	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 22:15:34
35865	9d69c80d-68aa-4b05-aeb7-5e88b8bef471	9d69c80d-69be-4bd4-b1ac-f01470c5c625	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 22:15:34
15463	9d5ed22c-edb5-4845-b412-085e6b19c74c	9d5ed22d-0afc-4e81-9762-cce2b14801fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-30 11:29:46
15464	9d5ed22d-0582-4119-8c19-09fcc8fff72e	9d5ed22d-0afc-4e81-9762-cce2b14801fc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 11:29:46
15465	9d5ed22d-05e4-45e8-8998-5335a1867e46	9d5ed22d-0afc-4e81-9762-cce2b14801fc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 11:29:46
15466	9d5ed22d-09be-44f9-872a-b0f6fa37cbd2	9d5ed22d-0afc-4e81-9762-cce2b14801fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-30 11:29:46
15467	9d5ed22d-0a06-4588-bedf-abe2aef5f1d5	9d5ed22d-0afc-4e81-9762-cce2b14801fc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:29:46
34099	9d69b9ad-7995-4007-9b89-feb3f6e7f66e	9d69b9ad-bfa2-4122-9c88-2d25e5527144	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:35:22
34100	9d69b9ad-b83f-4a64-8a83-d6b575db8bb4	9d69b9ad-bfa2-4122-9c88-2d25e5527144	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 75\\n                        ","time":"148.67","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"bbcd699f0014905e552a5f09996004ad","hostname":"EderCortes"}	2024-11-04 21:35:22
34101	9d69b9ad-bb3e-4ac5-aa31-ff3b53f42cc0	9d69b9ad-bfa2-4122-9c88-2d25e5527144	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '75' order by \\"item_loans\\".\\"id\\" asc","time":"2.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:35:22
34102	9d69b9ad-be5d-401f-b372-dd0f00335084	9d69b9ad-bfa2-4122-9c88-2d25e5527144	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 21:35:22
34103	9d69b9ad-beac-4f28-9114-d661c667f8c0	9d69b9ad-bfa2-4122-9c88-2d25e5527144	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/75","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":75,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"480000","loans_pago_interes":"120000","user_alias":"eder.cortes"},"items":[{"id":281,"loans_codigo":75,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:30","updated_at":"2024-11-04 21:35:08","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":474,"loans_codigo":75,"itemloans_cuota":"2","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 21:35:08","updated_at":"2024-11-04 21:35:22","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":478,"loans_codigo":75,"itemloans_cuota":"3","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:35:22","updated_at":"2024-11-04 21:35:22","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":479,"loans_codigo":75,"itemloans_cuota":"4","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:35:22","updated_at":"2024-11-04 21:35:22","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":480,"loans_codigo":75,"itemloans_cuota":"5","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:35:22","updated_at":"2024-11-04 21:35:22","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":355,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:35:22
34104	9d69bab7-9e59-480a-b23c-9c3e116ea784	9d69bab7-a47a-4d6c-bf9f-70368d9da120	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-total-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":251,"memory":20,"hostname":"EderCortes"}	2024-11-04 21:38:17
35866	9d69c80d-68ef-4eea-9217-281d54ca0635	9d69c80d-69be-4bd4-b1ac-f01470c5c625	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:15:34
36026	9d69c8d6-ae29-43f1-bc3f-0c8c2f10440b	9d69c8d7-009f-49ea-bed8-617a1d40bb4d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 22:17:46
36027	9d69c8d6-fddc-4b08-95bf-ae5536a72065	9d69c8d7-009f-49ea-bed8-617a1d40bb4d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 22:17:46
36028	9d69c8d6-ff2c-4220-8516-2e6918801c0f	9d69c8d7-009f-49ea-bed8-617a1d40bb4d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":419,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:17:46
35997	9d69c8a0-6646-48e7-b165-a24df049ae90	9d69c8a0-6b9d-426a-8ab1-09df6d3c9637	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1630}	2024-11-04 22:17:10
36029	9d69c8d7-789a-4efb-9930-7d108e09623e	9d69c8d7-c271-4a6a-93d9-30c79ea1e469	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 22:17:46
36030	9d69c8d7-bc7b-4758-93dc-f01d080106c1	9d69c8d7-c271-4a6a-93d9-30c79ea1e469	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '22' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"144.02","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":74,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 22:17:47
20272	9d66f0e2-9d2f-4597-aab4-63c127513a1a	9d66f0e2-bb1f-401d-9648-34846f6f42fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:22:16
20273	9d66f0e2-b98e-4ad1-ad05-c02844d370d9	9d66f0e2-bb1f-401d-9648-34846f6f42fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 12:22:16
20274	9d66f0e2-ba2b-4295-91b0-5f81cfa4daef	9d66f0e2-bb1f-401d-9648-34846f6f42fe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:22:16
35867	9d69c80d-af48-4fa8-a35d-d00f28c9438d	9d69c80d-ccab-4eba-a2bd-f2da5ca9432d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 22:15:34
35868	9d69c80d-c7b4-49cb-b104-b315897d1616	9d69c80d-ccab-4eba-a2bd-f2da5ca9432d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 22:15:34
36031	9d69c8d7-bce5-4afb-b90c-1560f4ec1ba6	9d69c8d7-c271-4a6a-93d9-30c79ea1e469	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 22:17:47
35869	9d69c80d-c815-4628-aee6-612d810478d2	9d69c80d-ccab-4eba-a2bd-f2da5ca9432d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 22:15:34
35870	9d69c80d-cb87-4e73-bcb4-67b6b251809a	9d69c80d-ccab-4eba-a2bd-f2da5ca9432d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 22:15:34
35871	9d69c80d-cbd5-4ec4-a324-b804393f360e	9d69c80d-ccab-4eba-a2bd-f2da5ca9432d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:15:34
36032	9d69c8d7-c134-4af1-a357-b58836f3ec11	9d69c8d7-c271-4a6a-93d9-30c79ea1e469	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 22:17:47
36033	9d69c8d7-c180-43f7-82c7-4a758a93c118	9d69c8d7-c271-4a6a-93d9-30c79ea1e469	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/22","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}},"duration":441,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:17:47
20275	9d66f0e3-077c-4c34-a0c2-697fafc9d1f2	9d66f0e3-4d7a-4a51-8063-b92350018d9a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 12:22:16
20276	9d66f0e3-451d-4def-8cb6-5f75e0206f46	9d66f0e3-4d7a-4a51-8063-b92350018d9a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"145.63","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:22:16
20277	9d66f0e3-485d-4999-8f53-5257d5804905	9d66f0e3-4d7a-4a51-8063-b92350018d9a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"1.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:22:16
20278	9d66f0e3-488c-424c-99d5-1288c4289140	9d66f0e3-4d7a-4a51-8063-b92350018d9a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:22:16
20279	9d66f0e3-4c5b-4326-81a2-b005910d21c6	9d66f0e3-4d7a-4a51-8063-b92350018d9a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 12:22:16
20280	9d66f0e3-4ca0-4d56-9cae-f0bc8a77755b	9d66f0e3-4d7a-4a51-8063-b92350018d9a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":331,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:22:16
34105	9d69bab8-353d-4e5e-a420-b3fda3d17da0	9d69bab8-8f67-46b5-8311-3ede61a6f2f9	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 21:38:17
34106	9d69bab8-8040-4dba-9ff4-19284747987a	9d69bab8-8f67-46b5-8311-3ede61a6f2f9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 75 limit 1","time":"4.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":724,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 21:38:17
34107	9d69bab8-80e3-4ea2-a3cf-fda0559f8296	9d69bab8-8f67-46b5-8311-3ede61a6f2f9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 21:38:17
34108	9d69bab8-82cb-44b6-86f9-d1662a5bc955	9d69bab8-8f67-46b5-8311-3ede61a6f2f9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_estado\\" = 'Cancelado', \\"loans_pago_interes\\" = 275000, \\"loans_pago_prestado\\" = 1100000, \\"updated_at\\" = '2024-11-04 21:38:17' where \\"id\\" = 75","time":"1.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":749,"hash":"acfe32aea56c9ca6bdbb917f944a78d1","hostname":"EderCortes"}	2024-11-04 21:38:17
34109	9d69bab8-8359-4468-b0cb-65f8a4a72d55	9d69bab8-8f67-46b5-8311-3ede61a6f2f9	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:75","changes":{"loans_estado":"Cancelado","updated_at":"2024-11-04 21:38:17","loans_pago_interes":275000,"loans_pago_prestado":1100000},"hostname":"EderCortes"}	2024-11-04 21:38:17
34110	9d69bab8-856a-4a77-b679-c12ebeb545d2	9d69bab8-8f67-46b5-8311-3ede61a6f2f9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 75 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"3.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":754,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 21:38:17
34111	9d69bab8-85a7-4a89-bbbe-4303ed3b3182	9d69bab8-8f67-46b5-8311-3ede61a6f2f9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 21:38:17
34112	9d69bab8-87dd-474f-8008-ec00f526a99b	9d69bab8-8f67-46b5-8311-3ede61a6f2f9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_interes_canelado\\" = '51666.666666667', \\"itemloans_cuota_cancelada\\" = '206666.66666667', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_status\\" = 'Pagada', \\"itemloans_aprobador\\" = 12, \\"updated_at\\" = '2024-11-04 21:38:17' where \\"loans_codigo\\" = 75 and \\"itemloans_status\\" = 'Pendiente'","time":"4.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":763,"hash":"87a64c6113219082cd85f391b598ec7f","hostname":"EderCortes"}	2024-11-04 21:38:17
34113	9d69bab8-8da3-40e6-96b0-f1c81babfe97	9d69bab8-8f67-46b5-8311-3ede61a6f2f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:38:17
35872	9d69c80e-1190-426e-87aa-ad839ae311fe	9d69c80e-2f52-4ebb-94d6-84a0c192b0b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 22:15:34
35873	9d69c80e-29df-4836-ac1b-3703045d78e6	9d69c80e-2f52-4ebb-94d6-84a0c192b0b6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:15:34
20281	9d66f0e5-1aa4-4e57-921e-3329c6f6f80c	9d66f0e5-4a49-4446-bad3-07fb63dbfc6f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 12:22:17
20282	9d66f0e5-4271-4467-9d8f-4cbd5f3c8649	9d66f0e5-4a49-4446-bad3-07fb63dbfc6f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"68.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:22:17
20283	9d66f0e5-42da-4145-83cd-0039cbb6c629	9d66f0e5-4a49-4446-bad3-07fb63dbfc6f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:22:17
20284	9d66f0e5-486e-4a72-aaea-97e95f6c0297	9d66f0e5-4a49-4446-bad3-07fb63dbfc6f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 12:22:17
20285	9d66f0e5-48dd-45b2-9c2f-ad9c00195a8d	9d66f0e5-4a49-4446-bad3-07fb63dbfc6f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":393,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:22:17
34114	9d69bab8-8e00-42fe-847b-b55c8e56a2b6	9d69bab8-8f67-46b5-8311-3ede61a6f2f9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-total-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payTotal","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"39","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"idLoans":75,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"Se ha realizado el pago total del credito","status":true},"duration":422,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:38:17
35874	9d69c80e-2a41-495a-b471-5ca8952be317	9d69c80e-2f52-4ebb-94d6-84a0c192b0b6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:15:34
35875	9d69c80e-2e28-4847-b26d-c75fe7c62fd8	9d69c80e-2f52-4ebb-94d6-84a0c192b0b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 22:15:34
35876	9d69c80e-2e76-475f-93a5-4baf253ff472	9d69c80e-2f52-4ebb-94d6-84a0c192b0b6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:15:34
13727	9d5d0e41-ec3e-4a73-9300-d6a4957f44be	9d5d0e42-2cd5-4451-8028-2dd1a1d0201a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 14:26:07
13728	9d5d0e42-2971-4dd4-a435-cdc69b33c209	9d5d0e42-2cd5-4451-8028-2dd1a1d0201a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 14:26:07
13729	9d5d0e42-2b0c-48b9-86a3-063997fb8441	9d5d0e42-2cd5-4451-8028-2dd1a1d0201a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":503,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:26:07
13730	9d5d0e42-cfbd-4615-8ee5-e2d05c8befb2	9d5d0e43-076a-4aa4-879a-5b26e5db8ee7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 14:26:07
13731	9d5d0e42-fc0a-4169-b36e-14d79e035ad1	9d5d0e43-076a-4aa4-879a-5b26e5db8ee7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"66.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":194,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 14:26:07
13732	9d5d0e42-fc76-4716-8a31-a8996247b751	9d5d0e43-076a-4aa4-879a-5b26e5db8ee7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 14:26:07
13733	9d5d0e43-04de-47ec-ac49-17954f99bac2	9d5d0e43-076a-4aa4-879a-5b26e5db8ee7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 14:26:07
13734	9d5d0e43-0594-4d2f-8427-a9a5ef3f2988	9d5d0e43-076a-4aa4-879a-5b26e5db8ee7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":500,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:26:07
34115	9d69bab9-6dd4-4cfb-89d8-13501a10e5fb	9d69bab9-b782-4673-bd63-fade24c26a63	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:38:18
34116	9d69bab9-af66-4f4f-8487-1400fbe92061	9d69bab9-b782-4673-bd63-fade24c26a63	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 75\\n                        ","time":"156.18","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"bbcd699f0014905e552a5f09996004ad","hostname":"EderCortes"}	2024-11-04 21:38:18
34117	9d69bab9-b26e-4821-b421-f433f1ebd39c	9d69bab9-b782-4673-bd63-fade24c26a63	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '75' order by \\"item_loans\\".\\"id\\" asc","time":"2.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:38:18
34118	9d69bab9-b61d-4e15-887f-30638a1b63c1	9d69bab9-b782-4673-bd63-fade24c26a63	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:38:18
34119	9d69bab9-b672-49df-9a2c-336d639c8439	9d69bab9-b782-4673-bd63-fade24c26a63	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/75","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":75,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000","user_alias":"eder.cortes"},"items":[{"id":281,"loans_codigo":75,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:30","updated_at":"2024-11-04 21:35:08","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":474,"loans_codigo":75,"itemloans_cuota":"2","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 21:35:08","updated_at":"2024-11-04 21:35:22","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":478,"loans_codigo":75,"itemloans_cuota":"3","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 21:35:22","updated_at":"2024-11-04 21:38:17","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"51666.666666667","itemloans_cuota_cancelada":"206666.66666667","user_alias":"eder.cortes"},{"id":479,"loans_codigo":75,"itemloans_cuota":"4","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 21:35:22","updated_at":"2024-11-04 21:38:17","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"51666.666666667","itemloans_cuota_cancelada":"206666.66666667","user_alias":"eder.cortes"},{"id":480,"loans_codigo":75,"itemloans_cuota":"5","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 21:35:22","updated_at":"2024-11-04 21:38:17","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"51666.666666667","itemloans_cuota_cancelada":"206666.66666667","user_alias":"eder.cortes"}]}},"duration":430,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:38:18
13735	9d5d0e43-958f-4abb-b593-b9d129742264	9d5d0e43-cd41-4bb3-a5ee-6b86e03ddff8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 14:26:08
13736	9d5d0e43-c49a-49b3-b6c3-ba05067c7692	9d5d0e43-cd41-4bb3-a5ee-6b86e03ddff8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"63.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":194,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 14:26:08
13737	9d5d0e43-c534-4737-9fda-72e66c0a4980	9d5d0e43-cd41-4bb3-a5ee-6b86e03ddff8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 14:26:08
13738	9d5d0e43-cb26-4294-bad2-a56cf7247cf0	9d5d0e43-cd41-4bb3-a5ee-6b86e03ddff8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 14:26:08
13739	9d5d0e43-cbad-47d7-a445-800185c50d92	9d5d0e43-cd41-4bb3-a5ee-6b86e03ddff8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":478,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:26:08
34120	9d69bac5-8764-44e4-86ad-e04168acdba3	9d69bac5-a0c5-44b8-ba59-d36a8160df4e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:38:26
16720	9d64d643-4948-4937-b974-4c2ca54c5b16	9d64d643-6901-444a-8e2b-cba7e239ce4b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 11:16:10
14427	9d5d1e25-7a44-4ae2-b415-c55b2f646bca	9d5d1e25-8b66-43f7-ae94-f90f381acbd8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 55\\n                        ","time":"85.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"ff7240abed4441475e0acd0c74a5f6aa","hostname":"EderCortes"}	2024-10-29 15:10:32
16721	9d64d643-6763-4e31-a74f-cf9d5e80288c	9d64d643-6901-444a-8e2b-cba7e239ce4b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 11:16:10
16722	9d64d643-680a-42c2-b927-b22f18cc7110	9d64d643-6901-444a-8e2b-cba7e239ce4b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":267,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:16:10
34121	9d69bac5-9c79-4dc0-9ca5-6229c41d8447	9d69bac5-a0c5-44b8-ba59-d36a8160df4e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"42.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 21:38:26
34122	9d69bac5-9f5a-4b58-8232-c6b2ea7b3108	9d69bac5-a0c5-44b8-ba59-d36a8160df4e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:38:26
13740	9d5d0e44-a3e2-4013-a646-27d10aa20da2	9d5d0e44-e826-4c73-a5d3-c75e6f9b9019	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 14:26:09
13741	9d5d0e44-dd27-4151-b8ff-18fd894f8084	9d5d0e44-e826-4c73-a5d3-c75e6f9b9019	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"90.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 14:26:09
13742	9d5d0e44-ddc7-40bc-a500-d96cd53fbaf8	9d5d0e44-e826-4c73-a5d3-c75e6f9b9019	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 14:26:09
13743	9d5d0e44-e64f-45a6-aa4f-b3bad36001c2	9d5d0e44-e826-4c73-a5d3-c75e6f9b9019	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 14:26:09
13744	9d5d0e44-e6e2-46e3-8eab-63f97902bd95	9d5d0e44-e826-4c73-a5d3-c75e6f9b9019	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":695,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:26:09
16723	9d64d643-be1c-4fb3-a4d0-89960b9347f9	9d64d643-dd79-4769-a2bc-028821b95369	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 11:16:10
16724	9d64d643-d420-4006-908d-0abc0d9908de	9d64d643-dd79-4769-a2bc-028821b95369	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"43.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 11:16:10
14428	9d5d1e25-80ed-4027-9982-ea5656f62f12	9d5d1e25-8b66-43f7-ae94-f90f381acbd8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '55' order by \\"item_loans\\".\\"id\\" asc","time":"3.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 15:10:32
14429	9d5d1e25-813f-4714-a41b-220ec9cf62ec	9d5d1e25-8b66-43f7-ae94-f90f381acbd8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":7,"hostname":"EderCortes"}	2024-10-29 15:10:32
14430	9d5d1e25-8937-4768-a7cd-429e794059cf	9d5d1e25-8b66-43f7-ae94-f90f381acbd8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-10-29 15:10:32
16725	9d64d643-d7e3-41d3-92c8-9e8db8142d7e	9d64d643-dd79-4769-a2bc-028821b95369	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"1.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 11:16:10
16726	9d64d643-d81a-45db-8b5b-615c431fd339	9d64d643-dd79-4769-a2bc-028821b95369	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 11:16:10
16727	9d64d643-dc51-48be-aa93-e5ce42d205c1	9d64d643-dd79-4769-a2bc-028821b95369	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 11:16:10
16728	9d64d643-dca0-4880-a8ac-289dcc6d797f	9d64d643-dd79-4769-a2bc-028821b95369	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:16:10
13745	9d5d0e45-9af6-4913-b1c5-8e75c8a7227e	9d5d0e45-d8a2-4d80-bd70-a1c8fb7d66a0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 14:26:09
13746	9d5d0e45-cec2-4344-a50b-4712d8bd7892	9d5d0e45-d8a2-4d80-bd70-a1c8fb7d66a0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"82.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 14:26:09
13747	9d5d0e45-cf60-430c-b350-8603f16ab607	9d5d0e45-d8a2-4d80-bd70-a1c8fb7d66a0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 14:26:09
13748	9d5d0e45-d679-4634-8bed-7bbc7d7b8cdf	9d5d0e45-d8a2-4d80-bd70-a1c8fb7d66a0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 14:26:09
12729	9d5cecb9-49db-4500-819a-110a7b52219f	9d5cecb9-8417-41f3-a5a1-5e73adf80a8b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-10-29 12:52:21
12730	9d5cecb9-8113-47be-8f2e-fe5cbfc014fe	9d5cecb9-8417-41f3-a5a1-5e73adf80a8b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-10-29 12:52:21
12731	9d5cecb9-8277-4b63-96b4-63e851e76dc0	9d5cecb9-8417-41f3-a5a1-5e73adf80a8b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":529,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:21
13749	9d5d0e45-d727-4bcd-9900-99aa2d46eb7d	9d5d0e45-d8a2-4d80-bd70-a1c8fb7d66a0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":589,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:26:09
16729	9d64d645-a398-46b4-a1eb-abe196f2a056	9d64d645-c171-4207-a295-566e6f434a9c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 11:16:11
16730	9d64d645-bc1a-4b2e-8778-b976175466de	9d64d645-c171-4207-a295-566e6f434a9c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 11:16:11
16731	9d64d645-bc70-477d-861e-24f0bf4907fd	9d64d645-c171-4207-a295-566e6f434a9c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 11:16:11
16732	9d64d645-c002-41e7-adc7-61dcd73f3c05	9d64d645-c171-4207-a295-566e6f434a9c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-02 11:16:11
16733	9d64d645-c04f-4eb1-91f8-d84bd05ed38c	9d64d645-c171-4207-a295-566e6f434a9c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":283,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:16:11
34123	9d69bac5-9fc6-4634-9605-c11bc5a0e3e4	9d69bac5-a0c5-44b8-ba59-d36a8160df4e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:38:26
16734	9d64d650-f9c3-40c0-b7d0-2f18f84dfb49	9d64d650-fddb-4e88-9b49-92ea80f7c6aa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":160,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:16:19
34124	9d69bac7-9199-4ba9-800b-5810dadf1a9f	9d69bac7-af47-4ff9-ba54-0a13cd4f76f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:38:27
34125	9d69bac7-aa82-4e58-a8ab-2024f74c687f	9d69bac7-af47-4ff9-ba54-0a13cd4f76f5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"45.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 21:38:27
34126	9d69bac7-adce-4355-9571-abb52bb4e890	9d69bac7-af47-4ff9-ba54-0a13cd4f76f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:38:27
24078	9d68a153-30b8-4551-9ee7-af2ce6c20fd4	9d68a153-5143-4f8a-93d9-929c5b3daacb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 08:31:27
24079	9d68a153-4f9a-4119-9785-fb5df4da0da8	9d68a153-5143-4f8a-93d9-929c5b3daacb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 08:31:27
24080	9d68a153-5036-4f4e-9f27-2afc1f7b1864	9d68a153-5143-4f8a-93d9-929c5b3daacb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:31:27
34127	9d69bac7-ae49-476f-be58-6a36d2565721	9d69bac7-af47-4ff9-ba54-0a13cd4f76f5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:38:27
36702	9d6b3e6f-9bf0-4c83-b56b-c8e015fb93fc	9d6b3e6f-bb7c-475e-b22b-6a044d3261d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:42:25
36224	9d6b33b2-a8c9-4baa-bd32-d8860e94ef8a	9d6b33b2-f453-42a0-956f-69db85ad4a55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:12:24
36225	9d6b33b2-f256-4978-951d-44b5e421df5e	9d6b33b2-f453-42a0-956f-69db85ad4a55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:12:24
36226	9d6b33b2-f352-4fab-890b-a0655efc34bf	9d6b33b2-f453-42a0-956f-69db85ad4a55	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":382,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:12:24
36703	9d6b3e6f-b9a2-42cb-a5f4-a991909c77e3	9d6b3e6f-bb7c-475e-b22b-6a044d3261d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 15:42:25
36704	9d6b3e6f-ba6c-477e-96e8-f166b112c5ac	9d6b3e6f-bb7c-475e-b22b-6a044d3261d3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":261,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:42:25
16735	9d64d651-afac-4f4b-a794-e14f4ecb335e	9d64d651-cda8-4a53-999e-c6f4b025f624	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-02 11:16:19
16736	9d64d651-c6c4-4704-a6f5-100733a7d87a	9d64d651-cda8-4a53-999e-c6f4b025f624	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 190 limit 1","time":"2.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":326,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-02 11:16:19
16737	9d64d651-c714-4f70-8821-3f9d4724df0a	9d64d651-cda8-4a53-999e-c6f4b025f624	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-02 11:16:19
16738	9d64d651-c953-457e-ae7b-c4dcf1c0f7a9	9d64d651-cda8-4a53-999e-c6f4b025f624	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '02-11-2024', \\"itemloans_interes_canelado\\" = '50000', \\"itemloans_cuota_cancelada\\" = '100000', \\"updated_at\\" = '2024-11-02 11:16:19' where \\"id\\" = 190","time":"2.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":345,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-02 11:16:19
16739	9d64d651-c9b4-4ad8-91a1-126c0ac8ee04	9d64d651-cda8-4a53-999e-c6f4b025f624	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:190","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-02 11:16:19","item_loans_cuando_pago":"02-11-2024","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},"hostname":"EderCortes"}	2024-11-02 11:16:19
16740	9d64d651-cc72-4a98-9401-4952683f3967	9d64d651-cda8-4a53-999e-c6f4b025f624	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-02 11:16:19
16741	9d64d651-ccb6-419c-8e2c-a2befcf790b2	9d64d651-cda8-4a53-999e-c6f4b025f624	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"157","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000","id":190,"loans_codigo":62,"item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":218,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:16:19
24081	9d68a153-9d5c-4dcb-b541-ba225af481f7	9d68a153-bb93-4c1f-9b40-cc0ad97b4b26	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 08:31:27
24082	9d68a153-b1f7-4ba1-91f6-0bf770d7c7c3	9d68a153-bb93-4c1f-9b40-cc0ad97b4b26	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 66\\n                        ","time":"40.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"f5566f306d2be9466f2c4564ce0020bd","hostname":"EderCortes"}	2024-11-04 08:31:27
20377	9d66f1c3-58e0-48e2-bc9a-5a6b23d3e728	9d66f1c3-7843-4acd-8e58-d5b61e74abea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:24:43
20378	9d66f1c3-767c-44a6-9b2e-463da9ee0bd7	9d66f1c3-7843-4acd-8e58-d5b61e74abea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 12:24:43
20379	9d66f1c3-7748-477a-8a10-4e0ab8dc2b9b	9d66f1c3-7843-4acd-8e58-d5b61e74abea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:24:43
24083	9d68a153-b5d9-4f53-91b5-cf166da45fde	9d68a153-bb93-4c1f-9b40-cc0ad97b4b26	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '66' order by \\"item_loans\\".\\"id\\" asc","time":"2.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:31:27
24084	9d68a153-b619-4db7-ab80-e6d97fc25b5c	9d68a153-bb93-4c1f-9b40-cc0ad97b4b26	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 08:31:27
24085	9d68a153-ba38-4f30-b4a5-cc7d59388273	9d68a153-bb93-4c1f-9b40-cc0ad97b4b26	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 08:31:27
24086	9d68a153-bab2-49b7-9ea4-06c00e8f44a8	9d68a153-bb93-4c1f-9b40-cc0ad97b4b26	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/66","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":66,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":5000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"5000000","loans_pago_interes":"1250000"},"items":[{"id":217,"loans_codigo":66,"itemloans_cuota":"1","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:26.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":218,"loans_codigo":66,"itemloans_cuota":"2","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":219,"loans_codigo":66,"itemloans_cuota":"3","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":220,"loans_codigo":66,"itemloans_cuota":"4","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:33.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":221,"loans_codigo":66,"itemloans_cuota":"5","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":222,"loans_codigo":66,"itemloans_cuota":"6","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:39.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":223,"loans_codigo":66,"itemloans_cuota":"7","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:42.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":224,"loans_codigo":66,"itemloans_cuota":"8","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:46.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":225,"loans_codigo":66,"itemloans_cuota":"9","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-31 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:50.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":226,"loans_codigo":66,"itemloans_cuota":"10","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:31:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"}]}},"duration":228,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:31:27
16742	9d64d652-215f-43ed-9dcf-8a2444112ac7	9d64d652-3fb4-400d-9249-c6b7a02e5fb5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-02 11:16:19
16743	9d64d652-363d-4a8c-9554-f7247f523590	9d64d652-3fb4-400d-9249-c6b7a02e5fb5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"41.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 11:16:20
16744	9d64d652-3a44-4881-a891-32ce0d62f203	9d64d652-3fb4-400d-9249-c6b7a02e5fb5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 11:16:20
16745	9d64d652-3a88-483e-a9ff-7398dc761c34	9d64d652-3fb4-400d-9249-c6b7a02e5fb5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 11:16:20
16746	9d64d652-3e81-4dc4-b62b-ea9482350737	9d64d652-3fb4-400d-9249-c6b7a02e5fb5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-02 11:16:20
16747	9d64d652-3ed1-49bc-82b0-7923ccb440b9	9d64d652-3fb4-400d-9249-c6b7a02e5fb5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:16:20
20380	9d66f1c3-c30b-459e-a27e-99e159e6314d	9d66f1c4-0ae4-4d05-9452-a4300607d0d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 12:24:43
20381	9d66f1c4-01fa-40d0-9991-2ca1e16ccbc0	9d66f1c4-0ae4-4d05-9452-a4300607d0d5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"147.02","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:24:43
20382	9d66f1c4-05cb-4cf0-b43a-3f21601cb5d3	9d66f1c4-0ae4-4d05-9452-a4300607d0d5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:24:43
20383	9d66f1c4-05fc-49c2-9f54-0ba8fc04f165	9d66f1c4-0ae4-4d05-9452-a4300607d0d5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:24:43
20384	9d66f1c4-09a8-44b6-ac91-b3e937a20124	9d66f1c4-0ae4-4d05-9452-a4300607d0d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 12:24:43
20385	9d66f1c4-09eb-42ab-9b7b-69e32a952c5c	9d66f1c4-0ae4-4d05-9452-a4300607d0d5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":334,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:24:43
24087	9d68a155-a87a-4a05-8dc1-0fd14288f75f	9d68a155-ea83-4458-91af-f984a075c97d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 08:31:29
24088	9d68a155-e5ab-44e7-95ab-5b2be86a59d7	9d68a155-ea83-4458-91af-f984a075c97d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"138.08","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 08:31:29
24089	9d68a155-e608-446c-981a-e7e3a2ef46b5	9d68a155-ea83-4458-91af-f984a075c97d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 08:31:29
24090	9d68a155-e954-4791-aafb-cae3644e51ff	9d68a155-ea83-4458-91af-f984a075c97d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 08:31:29
24091	9d68a155-e998-42f1-af56-348a0a1fc5a9	9d68a155-ea83-4458-91af-f984a075c97d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":585,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:31:29
34128	9d69bace-75b6-4593-b5fe-1b8e33ce8fb3	9d69bace-93fb-4392-bdaf-2527bb776d54	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:38:32
36227	9d6b33b3-4e67-4784-83f9-ab3c71533997	9d6b33b3-96a8-4ce7-a8c3-06472cf470aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:12:24
36705	9d6b3e70-12ef-4fde-852e-26cb2c6c20dc	9d6b3e70-3141-4b5c-a14a-6aac691d9ea1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 15:42:25
20386	9d66f1c5-4f20-4853-8c38-19d1d4d95926	9d66f1c5-7f1f-4be4-9bc7-72c6e834c544	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 12:24:44
20387	9d66f1c5-7402-42a9-85ee-c1e60ba10b46	9d66f1c5-7f1f-4be4-9bc7-72c6e834c544	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"65.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:24:44
20388	9d66f1c5-7498-455e-82cd-cc0d16c42be4	9d66f1c5-7f1f-4be4-9bc7-72c6e834c544	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:24:44
20389	9d66f1c5-7ca7-4bf1-acd1-5e21b734ab99	9d66f1c5-7f1f-4be4-9bc7-72c6e834c544	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 12:24:44
20390	9d66f1c5-7d36-493b-a4f6-cba7e16644fa	9d66f1c5-7f1f-4be4-9bc7-72c6e834c544	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":498,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:24:44
24092	9d68a45a-6c0e-4eeb-a254-b583106c6d3a	9d68a45a-9091-4d4c-ad86-0799bb815146	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 08:39:55
24093	9d68a45a-888d-4e3d-846b-ed953b120cfa	9d68a45a-9091-4d4c-ad86-0799bb815146	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"44.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 08:39:55
24094	9d68a45a-8eef-4044-b642-5ea49838a3e1	9d68a45a-9091-4d4c-ad86-0799bb815146	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 08:39:55
24095	9d68a45a-8f52-42ec-a530-2d32de5d748f	9d68a45a-9091-4d4c-ad86-0799bb815146	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":273,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:39:55
34129	9d69bace-8c61-4b8f-90af-efde9b86ab11	9d69bace-93fb-4392-bdaf-2527bb776d54	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 74\\n                        ","time":"43.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"7b2020e1046e2e554bfa3e1b1826bcb8","hostname":"EderCortes"}	2024-11-04 21:38:32
34130	9d69bace-8f25-4eb9-a1b5-b229bcb1ee28	9d69bace-93fb-4392-bdaf-2527bb776d54	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '74' order by \\"item_loans\\".\\"id\\" asc","time":"2.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:38:32
34131	9d69bace-9278-4b24-863f-61f66fc56e2d	9d69bace-93fb-4392-bdaf-2527bb776d54	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:38:32
34132	9d69bace-92d1-49e9-bd58-71526584f53f	9d69bace-93fb-4392-bdaf-2527bb776d54	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/74","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":74,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0","user_alias":"eder.cortes"},"items":[{"id":276,"loans_codigo":74,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:29","updated_at":"2024-11-04 09:18:29","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":277,"loans_codigo":74,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:29","updated_at":"2024-11-04 09:18:29","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":278,"loans_codigo":74,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:29","updated_at":"2024-11-04 09:18:29","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":279,"loans_codigo":74,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:29","updated_at":"2024-11-04 09:18:29","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":280,"loans_codigo":74,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:29","updated_at":"2024-11-04 09:18:29","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:38:32
36228	9d6b33b3-9188-495d-bce2-dd2cf3bb6d35	9d6b33b3-96a8-4ce7-a8c3-06472cf470aa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"153.40","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:12:24
36229	9d6b33b3-94d8-4fc3-92f8-59374e653cd4	9d6b33b3-96a8-4ce7-a8c3-06472cf470aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:12:24
36230	9d6b33b3-955b-4dbe-b9c8-cbf830ad4c6c	9d6b33b3-96a8-4ce7-a8c3-06472cf470aa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":362,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:12:24
36706	9d6b3e70-2c87-4b64-b5c1-9fbce9ad3229	9d6b3e70-3141-4b5c-a14a-6aac691d9ea1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"48.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:42:26
36385	9d6b39f2-ab16-4df9-81a7-1526b417b366	9d6b39f2-ceb4-4f94-9ef2-bb307ff3080b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 15:29:52
36386	9d6b39f2-cce5-4870-8f36-f4a9c244b35a	9d6b39f2-ceb4-4f94-9ef2-bb307ff3080b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:29:52
36387	9d6b39f2-cda0-4f43-a51e-cb6d99876acf	9d6b39f2-ceb4-4f94-9ef2-bb307ff3080b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":314,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:29:52
36707	9d6b3e70-2fc0-47b2-ae64-adfc41c82680	9d6b3e70-3141-4b5c-a14a-6aac691d9ea1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 15:42:26
36231	9d6b33b4-064a-4976-8141-4bb2024755e2	9d6b33b4-2d58-4ff7-8d55-c1471ec689b7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:12:24
18105	9d65b823-02e8-45ea-959c-3810f60d66d2	9d65b823-3311-4502-82c8-11ecf8594f21	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 21:47:45
18106	9d65b823-2ff8-41e3-85d5-aaf040b5008c	9d65b823-3311-4502-82c8-11ecf8594f21	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:47:45
18107	9d65b823-313c-48d3-91fb-add9d556a9c3	9d65b823-3311-4502-82c8-11ecf8594f21	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":316,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:47:45
36232	9d6b33b4-2864-4409-9d31-f8a6a1951497	9d6b33b4-2d58-4ff7-8d55-c1471ec689b7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"58.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:12:25
34133	9d69bad9-46e7-472e-970c-4a2270dac63b	9d69bad9-4a32-4b6a-aa02-baf7fcbe670f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":143,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:38:39
36233	9d6b33b4-28af-41c4-bdcc-793c32b756ac	9d6b33b4-2d58-4ff7-8d55-c1471ec689b7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:12:25
36234	9d6b33b4-2c1e-4f4d-85a8-76ca54c18288	9d6b33b4-2d58-4ff7-8d55-c1471ec689b7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 15:12:25
36235	9d6b33b4-2c5f-411e-b5b1-ea7bda2fff88	9d6b33b4-2d58-4ff7-8d55-c1471ec689b7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":365,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:12:25
36388	9d6b39f3-3235-42bd-a033-56a538d97008	9d6b39f3-50b0-44f6-8e8c-776fcb6c740c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:29:53
36389	9d6b39f3-49fe-4390-9667-a31e08954cf9	9d6b39f3-50b0-44f6-8e8c-776fcb6c740c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"44.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:29:53
36390	9d6b39f3-4f27-4447-ae8d-abd964e017de	9d6b39f3-50b0-44f6-8e8c-776fcb6c740c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:29:53
36391	9d6b39f3-4f97-4f2e-b5a1-c31f8fdc927c	9d6b39f3-50b0-44f6-8e8c-776fcb6c740c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":274,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:29:53
18108	9d65b823-d8e6-434e-b058-6c09427a210a	9d65b824-016b-4b8a-9f9d-1187acef266e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:47:46
18109	9d65b823-f3ce-405d-a1e0-f30ac032b031	9d65b824-016b-4b8a-9f9d-1187acef266e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"55.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"2b11ef88578e3c91c11800e110e490df","hostname":"EderCortes"}	2024-11-02 21:47:46
18110	9d65b823-f97a-4166-9735-9a93faf04160	9d65b824-016b-4b8a-9f9d-1187acef266e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"2.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:47:46
18111	9d65b823-f9e1-49fb-a19d-d6b74fcb7a4e	9d65b824-016b-4b8a-9f9d-1187acef266e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:47:46
18112	9d65b823-ffe9-43b5-ba47-8fb5d78027bc	9d65b824-016b-4b8a-9f9d-1187acef266e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:47:46
18113	9d65b824-0059-41b2-92d4-1e7730c5d9d9	9d65b824-016b-4b8a-9f9d-1187acef266e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":426,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:47:46
34134	9d69bad9-bb21-481f-a7ab-1e304de930e1	9d69bada-0a8b-4d96-a832-bee47804d132	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:38:39
34135	9d69bad9-fd9d-4355-b8e1-33797830f897	9d69bada-0a8b-4d96-a832-bee47804d132	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 74 limit 1","time":"2.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":505,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 21:38:39
34136	9d69bad9-fdec-4694-b375-145db45b1fe1	9d69bada-0a8b-4d96-a832-bee47804d132	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":2,"hostname":"EderCortes"}	2024-11-04 21:38:39
34137	9d69bad9-ff90-4358-afcd-4e6efb997de5	9d69bada-0a8b-4d96-a832-bee47804d132	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select count(*) as aggregate from \\"item_loans\\" where \\"loans_codigo\\" = 74 and (\\"itemloans_status\\" = 'Pagada' or \\"itemloans_status\\" = 'Abono')","time":"2.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":566,"hash":"40bb62c1101cd4a074e44b13c59d4517","hostname":"EderCortes"}	2024-11-04 21:38:39
34138	9d69bada-0035-43cd-baa8-10d692833474	9d69bada-0a8b-4d96-a832-bee47804d132	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_estado\\" = 'En curso', \\"loans_pago_interes\\" = 60000, \\"loans_pago_prestado\\" = 240000, \\"updated_at\\" = '2024-11-04 21:38:39' where \\"id\\" = 74","time":"0.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":605,"hash":"acfe32aea56c9ca6bdbb917f944a78d1","hostname":"EderCortes"}	2024-11-04 21:38:39
34139	9d69bada-008d-4ff7-8ca6-cd22b8bf24f8	9d69bada-0a8b-4d96-a832-bee47804d132	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:74","changes":{"loans_estado":"En curso","updated_at":"2024-11-04 21:38:39","loans_pago_interes":60000,"loans_pago_prestado":240000},"hostname":"EderCortes"}	2024-11-04 21:38:39
34140	9d69bada-0116-47cb-ab7f-4aee8fb78669	9d69bada-0a8b-4d96-a832-bee47804d132	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 74 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"0.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":612,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 21:38:39
34141	9d69bada-0153-40d2-ac52-eacf3201ff73	9d69bada-0a8b-4d96-a832-bee47804d132	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 21:38:39
34142	9d69bada-01d9-45ed-9fef-905d2b7f4a15	9d69bada-0a8b-4d96-a832-bee47804d132	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Abono', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = 60000, \\"itemloans_cuota_cancelada\\" = 240000, \\"updated_at\\" = '2024-11-04 21:38:39' where \\"id\\" = 276","time":"0.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":620,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 21:38:39
34143	9d69bada-0211-4fc8-9eb5-4f6525f1c560	9d69bada-0a8b-4d96-a832-bee47804d132	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:276","changes":{"itemloans_status":"Abono","updated_at":"2024-11-04 21:38:39","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":60000,"itemloans_cuota_cancelada":240000},"hostname":"EderCortes"}	2024-11-04 21:38:39
36236	9d6b33b4-7acc-4f16-805b-fb14b4834ff8	9d6b33b4-c4f2-4b37-9c25-b39e70eb30a8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 15:12:25
18114	9d65b825-f5fe-4b45-bee2-0a9e470f3d91	9d65b826-2777-4a9d-9e80-a7ddbce007b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:47:47
18115	9d65b826-1ea3-415f-93cc-c1fb6b947b69	9d65b826-2777-4a9d-9e80-a7ddbce007b9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"63.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 21:47:47
18116	9d65b826-1f43-4f02-bd08-a3826cc2f5ea	9d65b826-2777-4a9d-9e80-a7ddbce007b9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 21:47:47
18117	9d65b826-2579-42a0-bbee-8065e033a66a	9d65b826-2777-4a9d-9e80-a7ddbce007b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 21:47:47
18118	9d65b826-2608-4e40-8adb-4db764ff94f6	9d65b826-2777-4a9d-9e80-a7ddbce007b9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":384,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:47:47
34144	9d69bada-026d-4158-859b-07abe638b551	9d69bada-0a8b-4d96-a832-bee47804d132	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"delete from \\"item_loans\\" where \\"loans_codigo\\" = 74 and \\"itemloans_status\\" = 'Pendiente'","time":"0.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":627,"hash":"89bf3c496a8b0746ff5d1219b8dc29e3","hostname":"EderCortes"}	2024-11-04 21:38:39
34145	9d69bada-02cb-49d4-aca8-b242c96f7925	9d69bada-0a8b-4d96-a832-bee47804d132	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 74 limit 1","time":"0.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":630,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 21:38:39
34146	9d69bada-038a-4803-8fc0-2316a3a30f31	9d69bada-0a8b-4d96-a832-bee47804d132	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (74, 2, 215000, 53750, 'Pendiente', 'Se realiza abono', '12-11-2024', 0, 0, '2024-11-04 21:38:39', '2024-11-04 21:38:39')","time":"0.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":686,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:38:39
34147	9d69bada-03b9-4de1-9cda-24778f24b9e1	9d69bada-0a8b-4d96-a832-bee47804d132	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:38:39
34148	9d69bada-042b-407d-97fb-f6fac525f428	9d69bada-0a8b-4d96-a832-bee47804d132	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (74, 3, 215000, 53750, 'Pendiente', 'Se realiza abono', '20-11-2024', 0, 0, '2024-11-04 21:38:39', '2024-11-04 21:38:39')","time":"0.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":686,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:38:39
34149	9d69bada-0450-4a90-9224-c552809e1d33	9d69bada-0a8b-4d96-a832-bee47804d132	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:38:39
34150	9d69bada-04b8-4c60-a773-073bb2db650e	9d69bada-0a8b-4d96-a832-bee47804d132	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (74, 4, 215000, 53750, 'Pendiente', 'Se realiza abono', '28-11-2024', 0, 0, '2024-11-04 21:38:39', '2024-11-04 21:38:39')","time":"0.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":686,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:38:39
34151	9d69bada-04dd-4b4a-88d5-4d085907faae	9d69bada-0a8b-4d96-a832-bee47804d132	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:38:39
34152	9d69bada-0542-4039-98f5-2b6ad38a63fd	9d69bada-0a8b-4d96-a832-bee47804d132	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (74, 5, 215000, 53750, 'Pendiente', 'Se realiza abono', '06-12-2024', 0, 0, '2024-11-04 21:38:39', '2024-11-04 21:38:39')","time":"0.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":686,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:38:39
34153	9d69bada-0565-4447-a8ea-9ce11f96a079	9d69bada-0a8b-4d96-a832-bee47804d132	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:38:39
34154	9d69bada-094b-45b3-a532-bcd53e653b91	9d69bada-0a8b-4d96-a832-bee47804d132	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:38:39
36237	9d6b33b4-be40-464a-a87a-ee80f2d1dcae	9d6b33b4-c4f2-4b37-9c25-b39e70eb30a8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"148.02","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:12:25
34155	9d69bada-0994-4dc9-8ec5-883902fff4ce	9d69bada-0a8b-4d96-a832-bee47804d132	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"61","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"300000","idLoans":74,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El abono fue aplicado exitosamente","status":true},"duration":355,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:38:39
36238	9d6b33b4-beba-4d75-ab73-c08dc167e33b	9d6b33b4-c4f2-4b37-9c25-b39e70eb30a8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:12:25
36239	9d6b33b4-c38d-4b09-9cea-d90cd237ad9f	9d6b33b4-c4f2-4b37-9c25-b39e70eb30a8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 15:12:25
36240	9d6b33b4-c3d8-4ab0-95f1-e05664701a80	9d6b33b4-c4f2-4b37-9c25-b39e70eb30a8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:12:25
36392	9d6b39f3-ac5d-45bf-9e44-7b94faa6b537	9d6b39f4-0153-40f2-b4bd-3f87ae70f3c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:29:53
36393	9d6b39f3-f8aa-41dc-b27b-542a77d8080d	9d6b39f4-0153-40f2-b4bd-3f87ae70f3c0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"162.93","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:29:53
36394	9d6b39f3-f918-444c-ae7b-6f75baab8008	9d6b39f4-0153-40f2-b4bd-3f87ae70f3c0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:29:53
36395	9d6b39f3-ff57-456b-a9a9-6cf2db6f610e	9d6b39f4-0153-40f2-b4bd-3f87ae70f3c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:29:53
36396	9d6b39f3-ffd7-4792-97c0-31d0b0d26987	9d6b39f4-0153-40f2-b4bd-3f87ae70f3c0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":440,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:29:53
36708	9d6b3e70-3036-4ab0-8d10-bbc34bbc04ad	9d6b3e70-3141-4b5c-a14a-6aac691d9ea1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:42:26
36241	9d6b33b5-a0d6-41b6-adff-f775cf34b665	9d6b33b5-c111-4f9e-93db-d5489c5546a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 15:12:26
36242	9d6b33b5-bbbe-4404-b264-b977692f4cbc	9d6b33b5-c111-4f9e-93db-d5489c5546a6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"46.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:12:26
18195	9d65ba1f-af07-456d-9bcb-9ee670d66935	9d65ba20-05ca-468d-8680-b09fc3c1cd4e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 21:53:18
18196	9d65ba20-0302-4336-b580-12aaacfc656b	9d65ba20-05ca-468d-8680-b09fc3c1cd4e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:53:19
18197	9d65ba20-046d-4cfa-a96b-efc01f210681	9d65ba20-05ca-468d-8680-b09fc3c1cd4e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":424,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:53:19
34156	9d69bada-555d-46df-8f93-b593d447a5ee	9d69bada-742b-49c2-aae7-94e35ecbfadb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:38:39
34157	9d69bada-6c1a-43fe-9b35-ef899673d3db	9d69bada-742b-49c2-aae7-94e35ecbfadb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 74\\n                        ","time":"44.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"7b2020e1046e2e554bfa3e1b1826bcb8","hostname":"EderCortes"}	2024-11-04 21:38:40
34158	9d69bada-6eae-4dd9-a8b7-27f8d7667502	9d69bada-742b-49c2-aae7-94e35ecbfadb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '74' order by \\"item_loans\\".\\"id\\" asc","time":"2.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:38:40
34159	9d69bada-72a8-4481-9390-4e46f5c3f809	9d69bada-742b-49c2-aae7-94e35ecbfadb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:38:40
36243	9d6b33b5-bc0e-4397-a6fd-b490af028bac	9d6b33b5-c111-4f9e-93db-d5489c5546a6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:12:26
36244	9d6b33b5-bfd9-438d-b757-44033bc1f0ff	9d6b33b5-c111-4f9e-93db-d5489c5546a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 15:12:26
36245	9d6b33b5-c02a-4559-9781-9c66ec0b8867	9d6b33b5-c111-4f9e-93db-d5489c5546a6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:12:26
36397	9d6b39f4-55e7-4d66-9516-720557185d1d	9d6b39f4-796a-4e29-8b03-2f3958d81596	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:29:53
36398	9d6b39f4-731d-425b-8eaa-369c60f89f0e	9d6b39f4-796a-4e29-8b03-2f3958d81596	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:29:53
36399	9d6b39f4-7379-4408-9dd3-32befd4ab81d	9d6b39f4-796a-4e29-8b03-2f3958d81596	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:29:53
36400	9d6b39f4-782a-4fb4-bfdf-ba4b6000b482	9d6b39f4-796a-4e29-8b03-2f3958d81596	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:29:53
36709	9d6b3e70-802f-48c4-a678-f159ee365c74	9d6b3e70-ccfd-4570-b4ce-408d798e03f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 15:42:26
36710	9d6b3e70-c7a2-4f46-a486-0d8809f957e5	9d6b3e70-ccfd-4570-b4ce-408d798e03f2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"153.46","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:42:26
36711	9d6b3e70-c7f8-42cc-a924-8d3e7844b397	9d6b3e70-ccfd-4570-b4ce-408d798e03f2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:42:26
18198	9d65ba20-828c-4184-934a-9bb80ebcd091	9d65ba20-d34d-421c-8477-fad53a4b676e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:53:19
18199	9d65ba20-c67c-48dc-9f00-7577453f386f	9d65ba20-d34d-421c-8477-fad53a4b676e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"156.67","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"2b11ef88578e3c91c11800e110e490df","hostname":"EderCortes"}	2024-11-02 21:53:19
18200	9d65ba20-ca85-43f9-8562-2f047e207204	9d65ba20-d34d-421c-8477-fad53a4b676e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"2.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:53:19
18201	9d65ba20-cabf-4140-980c-c49020ce4f3f	9d65ba20-d34d-421c-8477-fad53a4b676e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:53:19
18202	9d65ba20-d169-45b3-96bf-72ac8245b7e0	9d65ba20-d34d-421c-8477-fad53a4b676e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:53:19
18203	9d65ba20-d1f8-4487-8c7f-23977be96a98	9d65ba20-d34d-421c-8477-fad53a4b676e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":461,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:53:19
34160	9d69bada-7311-481d-aa81-44c517723d23	9d69bada-742b-49c2-aae7-94e35ecbfadb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/74","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":74,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"240000","loans_pago_interes":"60000","user_alias":"eder.cortes"},"items":[{"id":276,"loans_codigo":74,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:29","updated_at":"2024-11-04 21:38:39","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":481,"loans_codigo":74,"itemloans_cuota":"2","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:38:39","updated_at":"2024-11-04 21:38:39","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":482,"loans_codigo":74,"itemloans_cuota":"3","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:38:39","updated_at":"2024-11-04 21:38:39","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":483,"loans_codigo":74,"itemloans_cuota":"4","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:38:39","updated_at":"2024-11-04 21:38:39","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":484,"loans_codigo":74,"itemloans_cuota":"5","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:38:39","updated_at":"2024-11-04 21:38:39","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:38:40
36401	9d6b39f4-7877-4597-943a-0f297b09fef0	9d6b39f4-796a-4e29-8b03-2f3958d81596	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":288,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:29:53
36712	9d6b3e70-cbb8-4103-9af6-a0f07cb9ef30	9d6b3e70-ccfd-4570-b4ce-408d798e03f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 15:42:26
34161	9d69bb05-2cc0-4f9e-b640-2d4f6424f476	9d69bb05-46fd-4c8b-8e7e-926ecb61b170	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:39:08
34162	9d69bb05-428b-42f3-a619-cec904627ed1	9d69bb05-46fd-4c8b-8e7e-926ecb61b170	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"42.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 21:39:08
34163	9d69bb05-4561-42b9-ab47-75f30024f93e	9d69bb05-46fd-4c8b-8e7e-926ecb61b170	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 21:39:08
34164	9d69bb05-45ea-44cb-9f47-5308a67b7451	9d69bb05-46fd-4c8b-8e7e-926ecb61b170	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":228,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:39:08
36402	9d6b39f5-b07a-430d-a858-a9a6d3a15519	9d6b39f5-d06e-4866-9b44-173893b2bdff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:29:54
36403	9d6b39f5-cb23-4d32-8779-f3d72707e8f9	9d6b39f5-d06e-4866-9b44-173893b2bdff	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:29:54
36404	9d6b39f5-cb79-429f-800c-947255a4833b	9d6b39f5-d06e-4866-9b44-173893b2bdff	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:29:54
36405	9d6b39f5-cf27-4425-a167-73aef087680c	9d6b39f5-d06e-4866-9b44-173893b2bdff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:29:54
36406	9d6b39f5-cf69-4e50-8479-1703b55eb274	9d6b39f5-d06e-4866-9b44-173893b2bdff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":263,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:29:54
36713	9d6b3e70-cbfa-40c8-a7ab-fa5743576367	9d6b3e70-ccfd-4570-b4ce-408d798e03f2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":382,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:42:26
36714	9d6b3e71-1428-4749-b62c-bc18d1393454	9d6b3e71-3328-41c9-94bc-62e026a488d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 15:42:26
36546	9d6b3cfc-24b7-4781-b9a9-ec6537535e9a	9d6b3cfc-7c38-491f-8f35-9843fbb54c6d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 15:38:22
34165	9d69bb07-e5c6-4c20-a0ca-c6ac5757f9ea	9d69bb08-05a6-4b8a-8b0d-ce7fcaf1397a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 21:39:09
20482	9d66f43f-fa77-4892-8db2-ffe56bfc9424	9d66f440-18b5-4d7f-abbd-c72c7850a0af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:31:40
20483	9d66f440-16fc-44c7-a11f-9c7db1b8d1cc	9d66f440-18b5-4d7f-abbd-c72c7850a0af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 12:31:40
20484	9d66f440-17b6-41f3-bac1-302973e22f8a	9d66f440-18b5-4d7f-abbd-c72c7850a0af	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:31:40
34166	9d69bb08-001b-48b4-b86a-b2be19405ca5	9d69bb08-05a6-4b8a-8b0d-ce7fcaf1397a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":227,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:39:09
34167	9d69bb08-0071-4e27-99ec-4f423124c182	9d69bb08-05a6-4b8a-8b0d-ce7fcaf1397a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:39:09
34168	9d69bb08-0456-4923-8a55-d4eb39e5b20c	9d69bb08-05a6-4b8a-8b0d-ce7fcaf1397a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 21:39:09
36547	9d6b3cfc-7a0c-43bb-8f85-00944295a992	9d6b3cfc-7c38-491f-8f35-9843fbb54c6d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:38:22
34169	9d69bb08-04a4-4fa7-abcc-8b51784cfc81	9d69bb08-05a6-4b8a-8b0d-ce7fcaf1397a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":289,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:39:09
36548	9d6b3cfc-7aea-468a-8ac6-25a1394fbe50	9d6b3cfc-7c38-491f-8f35-9843fbb54c6d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":466,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:38:22
36715	9d6b3e71-2d91-43e0-818f-4aa3b0a96556	9d6b3e71-3328-41c9-94bc-62e026a488d5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:42:26
36716	9d6b3e71-2de9-4b89-a289-0b52b3ab16b1	9d6b3e71-3328-41c9-94bc-62e026a488d5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:42:26
36717	9d6b3e71-31a3-454a-89a3-fcba7fb087de	9d6b3e71-3328-41c9-94bc-62e026a488d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 15:42:26
36718	9d6b3e71-3202-4f26-80f9-ae66b1addae3	9d6b3e71-3328-41c9-94bc-62e026a488d5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":245,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:42:26
20485	9d66f440-706b-4921-8f35-a2dc8f5df3a2	9d66f440-b9a6-4690-8aad-7472991d8197	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 12:31:40
20486	9d66f440-b11d-4734-a652-63775d00bd86	9d66f440-b9a6-4690-8aad-7472991d8197	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"152.39","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:31:41
20487	9d66f440-b49a-44bd-8284-a277277d84e4	9d66f440-b9a6-4690-8aad-7472991d8197	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:31:41
20488	9d66f440-b4c9-40f9-9533-9b89eb4f06a2	9d66f440-b9a6-4690-8aad-7472991d8197	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:31:41
20489	9d66f440-b87c-447f-8256-0153329e1fc9	9d66f440-b9a6-4690-8aad-7472991d8197	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 12:31:41
20490	9d66f440-b8c1-45e3-9371-cb8f29f7d708	9d66f440-b9a6-4690-8aad-7472991d8197	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":370,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:31:41
34170	9d69bb08-4e6c-40ee-bd04-147044002523	9d69bb08-98fe-44d9-9a5b-6ab4a8d445cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 21:39:10
34171	9d69bb08-9359-4fda-a0cf-b5fd784da9d6	9d69bb08-98fe-44d9-9a5b-6ab4a8d445cd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"152.12","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":216,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 21:39:10
34172	9d69bb08-93ba-4361-940f-30edf295edab	9d69bb08-98fe-44d9-9a5b-6ab4a8d445cd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 21:39:10
34173	9d69bb08-97a8-475d-90bd-56a03eab4698	9d69bb08-98fe-44d9-9a5b-6ab4a8d445cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 21:39:10
34174	9d69bb08-97fd-4d33-a986-b9e485bce816	9d69bb08-98fe-44d9-9a5b-6ab4a8d445cd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":361,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:39:10
36549	9d6b3cfc-fabf-40f8-8ee0-8baf5148df96	9d6b3cfd-492b-46a6-a42a-128b868edea1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:38:22
36550	9d6b3cfd-4382-445c-831b-9ce7911e5404	9d6b3cfd-492b-46a6-a42a-128b868edea1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"160.41","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:38:22
36551	9d6b3cfd-4781-48ed-8053-4992cc79c2f3	9d6b3cfd-492b-46a6-a42a-128b868edea1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:38:22
20491	9d66f442-8421-498d-b926-326ee55eae95	9d66f442-a250-4898-a696-07efde5db43e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 12:31:42
20492	9d66f442-9d21-4789-8b96-182a880f0f28	9d66f442-a250-4898-a696-07efde5db43e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:31:42
20493	9d66f442-9d6d-473f-bb43-cb61587b6b9a	9d66f442-a250-4898-a696-07efde5db43e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:31:42
20494	9d66f442-a0db-4a36-a30b-a8bd28e473fa	9d66f442-a250-4898-a696-07efde5db43e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 12:31:42
20495	9d66f442-a11e-4510-82f2-72ed45f6f58d	9d66f442-a250-4898-a696-07efde5db43e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":314,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:31:42
34175	9d69bb08-dc79-4185-a097-4f2bdfa757ad	9d69bb09-21e0-4dda-8604-7d300b2e8e56	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 21:39:10
34176	9d69bb09-1cae-4be4-a490-276861f7f2ba	9d69bb09-21e0-4dda-8604-7d300b2e8e56	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"142.66","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:39:10
34177	9d69bb09-1d04-4aeb-8c06-190bf2896b63	9d69bb09-21e0-4dda-8604-7d300b2e8e56	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:39:10
34178	9d69bb09-20a1-43e5-b0ea-a097e28038ac	9d69bb09-21e0-4dda-8604-7d300b2e8e56	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 21:39:10
34179	9d69bb09-20f0-4fbe-9946-4da6d504d595	9d69bb09-21e0-4dda-8604-7d300b2e8e56	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":329,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:39:10
36552	9d6b3cfd-4812-46ba-bd7a-3cb8e2f31666	9d6b3cfd-492b-46a6-a42a-128b868edea1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":454,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:38:22
36719	9d6b3e72-f8fd-4e4b-b038-50e8314eaf7c	9d6b3e73-1e33-437c-b654-ada6ffb94f5e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 15:42:27
36720	9d6b3e73-17e2-4062-829a-8d355b93e697	9d6b3e73-1e33-437c-b654-ada6ffb94f5e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"49.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:42:27
36721	9d6b3e73-183c-4049-a5cd-08cd61f9336a	9d6b3e73-1e33-437c-b654-ada6ffb94f5e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:42:27
36722	9d6b3e73-1cb5-4181-87fc-2767248c8177	9d6b3e73-1e33-437c-b654-ada6ffb94f5e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 15:42:27
36723	9d6b3e73-1d06-41c2-844d-9ce0f95ec6d2	9d6b3e73-1e33-437c-b654-ada6ffb94f5e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":343,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:42:27
18301	9d668d88-2043-4b26-8686-a9ad9be1fc02	9d668d88-8838-4271-9693-b7e244a6fae1	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 07:44:27
18302	9d668d88-8424-4a3d-87d8-cdfa251a68ab	9d668d88-8838-4271-9693-b7e244a6fae1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 07:44:27
18303	9d668d88-8615-4b84-b620-0aaaeec29b28	9d668d88-8838-4271-9693-b7e244a6fae1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":543,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:44:27
36553	9d6b3cfd-e127-43f8-82aa-61ee37613f82	9d6b3cfe-1aae-4c7a-8dd1-be268742bd7c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:38:23
36554	9d6b3cfe-1477-498c-a7b3-9de2d167148f	9d6b3cfe-1aae-4c7a-8dd1-be268742bd7c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"52.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:38:23
36555	9d6b3cfe-14dd-4766-8f0e-035b70ef6723	9d6b3cfe-1aae-4c7a-8dd1-be268742bd7c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:38:23
36556	9d6b3cfe-1930-4198-aef1-65c229b1b4cc	9d6b3cfe-1aae-4c7a-8dd1-be268742bd7c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:38:23
36557	9d6b3cfe-197f-40bc-8a24-8a947c0177bb	9d6b3cfe-1aae-4c7a-8dd1-be268742bd7c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":513,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:38:23
18304	9d668d89-1e69-407c-8d13-533100595af5	9d668d89-6640-499c-a4f9-03afbea55317	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 07:44:27
18305	9d668d89-5c66-4785-9c27-83be6aaaaad2	9d668d89-6640-499c-a4f9-03afbea55317	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"143.80","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-03 07:44:28
18306	9d668d89-6050-4cac-a339-01187aae3e50	9d668d89-6640-499c-a4f9-03afbea55317	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"1.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 07:44:28
18307	9d668d89-6098-40ac-a150-ade47a55d003	9d668d89-6640-499c-a4f9-03afbea55317	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 07:44:28
15653	9d648fcf-f340-434a-b76c-1bd4971ed540	9d648fd0-1992-43ed-b973-7ade20a5d5ab	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 07:59:10
15654	9d648fd0-174f-413d-9a51-31e624f4c763	9d648fd0-1992-43ed-b973-7ade20a5d5ab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 07:59:10
15655	9d648fd0-1842-4b5c-85d8-f2247e5a50de	9d648fd0-1992-43ed-b973-7ade20a5d5ab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":285,"memory":22,"hostname":"EderCortes"}	2024-11-02 07:59:10
18308	9d668d89-64fb-4df1-9fc7-a75915940367	9d668d89-6640-499c-a4f9-03afbea55317	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 07:44:28
18309	9d668d89-6545-4c18-be82-259e4f40019e	9d668d89-6640-499c-a4f9-03afbea55317	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:34:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"}]}},"duration":468,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:44:28
36558	9d6b3cfe-6ad7-4a3d-808e-e8d1dceaf16a	9d6b3cfe-8f57-41e8-9d95-f95ddf79e3aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:38:23
36559	9d6b3cfe-8935-404d-a05e-91ac4fd3ccc6	9d6b3cfe-8f57-41e8-9d95-f95ddf79e3aa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:38:23
36560	9d6b3cfe-8996-483f-90c7-3c416b6c7a34	9d6b3cfe-8f57-41e8-9d95-f95ddf79e3aa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:38:23
36561	9d6b3cfe-8e02-4b8c-959b-d76605b25c14	9d6b3cfe-8f57-41e8-9d95-f95ddf79e3aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:38:23
36562	9d6b3cfe-8e46-4879-b547-309d4d439815	9d6b3cfe-8f57-41e8-9d95-f95ddf79e3aa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:38:23
15656	9d648fd1-883c-4979-98df-1ce0960dad21	9d648fd1-aa73-4866-ba53-7f665746ffc5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 07:59:11
15657	9d648fd1-a469-4fd0-90f0-d9de99dbf860	9d648fd1-aa73-4866-ba53-7f665746ffc5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 07:59:11
15658	9d648fd1-a4c6-410b-a39b-1142bdd0d5a6	9d648fd1-aa73-4866-ba53-7f665746ffc5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 07:59:11
15659	9d648fd1-a918-4873-bfd2-c23902d0a62d	9d648fd1-aa73-4866-ba53-7f665746ffc5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 07:59:11
15660	9d648fd1-a968-4ad9-abc4-6245f10484a5	9d648fd1-aa73-4866-ba53-7f665746ffc5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":429,"memory":22,"hostname":"EderCortes"}	2024-11-02 07:59:11
18310	9d668d8a-c477-4213-8757-4a69089670e9	9d668d8b-1cd3-44aa-b6d8-e019326604f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 07:44:29
18311	9d668d8b-149c-48a1-be94-71986f73acff	9d668d8b-1cd3-44aa-b6d8-e019326604f4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"173.57","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 07:44:29
18312	9d668d8b-1510-4a97-89fe-9a15a8a19045	9d668d8b-1cd3-44aa-b6d8-e019326604f4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 07:44:29
18313	9d668d8b-1b27-4081-86bd-ae2f3887452c	9d668d8b-1cd3-44aa-b6d8-e019326604f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 07:44:29
18314	9d668d8b-1b9b-4ab3-97df-e0e1c7fddb0b	9d668d8b-1cd3-44aa-b6d8-e019326604f4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":380,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:44:29
36563	9d6b3d00-745c-495f-a74a-6bf17fc65f74	9d6b3d00-9d2d-4c5f-acbb-1bb66613102b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:38:25
36564	9d6b3d00-94b3-49ec-b294-4c41e2726bc0	9d6b3d00-9d2d-4c5f-acbb-1bb66613102b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"52.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:38:25
36565	9d6b3d00-9527-470e-8836-24ddfa137f3a	9d6b3d00-9d2d-4c5f-acbb-1bb66613102b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:38:25
36566	9d6b3d00-9b3c-4b02-98e5-2b3c3041ad17	9d6b3d00-9d2d-4c5f-acbb-1bb66613102b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:38:25
18315	9d668e9a-617e-4186-ab15-2b432a6312eb	9d668e9a-887b-4bae-b803-6e69a8b681da	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 07:47:27
18316	9d668e9a-82c6-467d-a0ee-42291ebb9be7	9d668e9a-887b-4bae-b803-6e69a8b681da	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"48.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58,"hash":"77f8314368b36a9393ec9c7735a91700","hostname":"EderCortes"}	2024-11-03 07:47:27
18317	9d668e9a-86e9-466f-820c-69cfa5f19854	9d668e9a-887b-4bae-b803-6e69a8b681da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 07:47:27
18318	9d668e9a-8751-4852-af03-d698abe65b6c	9d668e9a-887b-4bae-b803-6e69a8b681da	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":387,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:47:27
36567	9d6b3d00-9b9b-4605-8e8a-31cfdbd9bc58	9d6b3d00-9d2d-4c5f-acbb-1bb66613102b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":439,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:38:25
16987	9d6546cf-c23c-4308-bccf-7b311aba7d22	9d6546d0-1d2f-4a62-96c0-61690da89f9d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 16:30:52
16988	9d6546d0-1ab7-453f-8481-10831451ca99	9d6546d0-1d2f-4a62-96c0-61690da89f9d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:30:53
16989	9d6546d0-1bb4-4743-8940-31120a244313	9d6546d0-1d2f-4a62-96c0-61690da89f9d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":451,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:30:53
18319	9d668e9f-a89b-4a55-8e89-99af5ce73623	9d668e9f-f2e6-419b-908b-6b263564f293	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 07:47:30
18320	9d668e9f-e9cf-4c04-bc92-aaf63730ed2e	9d668e9f-f2e6-419b-908b-6b263564f293	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 60\\n                        ","time":"154.86","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"17136fa7b24c4dffd736d28ef469ee16","hostname":"EderCortes"}	2024-11-03 07:47:30
18321	9d668e9f-ed8f-4b72-a1da-aa74e9d38c2f	9d668e9f-f2e6-419b-908b-6b263564f293	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '60' order by \\"item_loans\\".\\"id\\" asc","time":"2.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 07:47:30
18322	9d668e9f-edd0-4680-8b4c-3560d3cc9dc6	9d668e9f-f2e6-419b-908b-6b263564f293	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 07:47:30
18323	9d668e9f-f1bc-4ab7-9d46-c4b7e9d00086	9d668e9f-f2e6-419b-908b-6b263564f293	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 07:47:30
18324	9d668e9f-f201-4aed-bf73-689e51b275d4	9d668e9f-f2e6-419b-908b-6b263564f293	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/60","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":60,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":177,"loans_codigo":60,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-10-30T15:56:57.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":178,"loans_codigo":60,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-10-30T15:56:57.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":179,"loans_codigo":60,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-10-30T15:56:57.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":180,"loans_codigo":60,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-10-30T15:56:57.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":181,"loans_codigo":60,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-10-30T15:56:57.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":381,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:47:30
16953	9d654662-ae60-4d85-b81f-bc97ff7b0f47	9d654662-d1c8-4a29-9a1b-958e3bebabe8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 16:29:41
16954	9d654662-cfb9-489e-a882-728acef8183a	9d654662-d1c8-4a29-9a1b-958e3bebabe8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 16:29:41
16955	9d654662-d0a0-4db8-935e-0b0a8994a32a	9d654662-d1c8-4a29-9a1b-958e3bebabe8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:29:41
18325	9d668ebc-769c-49b4-88df-d23b4f7c7cc5	9d668ebc-95ff-4e36-9140-48e16c764bb7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 07:47:49
18326	9d668ebc-904d-4b82-b193-5d45321f65a6	9d668ebc-95ff-4e36-9140-48e16c764bb7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"47.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58,"hash":"77f8314368b36a9393ec9c7735a91700","hostname":"EderCortes"}	2024-11-03 07:47:49
18327	9d668ebc-945a-495a-9b59-1cad32a40c28	9d668ebc-95ff-4e36-9140-48e16c764bb7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 07:47:49
18328	9d668ebc-94da-4e93-b044-c7e0a318064b	9d668ebc-95ff-4e36-9140-48e16c764bb7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:47:49
36886	9d6b4170-df86-4eb2-bca5-3a042d1f3c3a	9d6b4171-0991-4528-ba5f-6283947758e3	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 15:50:49
36887	9d6b4171-076e-40d8-a0c9-457c4fa9873e	9d6b4171-0991-4528-ba5f-6283947758e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:50:49
36888	9d6b4171-082c-4ad4-b465-8e6472c7b53d	9d6b4171-0991-4528-ba5f-6283947758e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":326,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:50:49
37047	9d6b44bc-a84e-4320-b724-ffd93fd1bb04	9d6b44bc-d74c-41fb-86c9-f4c5df6c8ebe	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 16:00:02
37048	9d6b44bc-d446-4e07-9ef3-c9e45861eb04	9d6b44bc-d74c-41fb-86c9-f4c5df6c8ebe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 16:00:02
18329	9d668ed4-d4ba-4d9a-b94c-b486bfc4d0aa	9d668ed5-060a-4d83-9a9c-d20278b957a3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 07:48:05
18330	9d668ed4-f8a3-4345-b078-79e8bda0044f	9d668ed5-060a-4d83-9a9c-d20278b957a3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 60\\n                        ","time":"69.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"17136fa7b24c4dffd736d28ef469ee16","hostname":"EderCortes"}	2024-11-03 07:48:05
18331	9d668ed4-fe96-446e-8c9f-4c6cd3c8f1ec	9d668ed5-060a-4d83-9a9c-d20278b957a3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '60' order by \\"item_loans\\".\\"id\\" asc","time":"3.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 07:48:05
18332	9d668ed4-fee9-481d-976b-8c1eb2bfe78e	9d668ed5-060a-4d83-9a9c-d20278b957a3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 07:48:05
18333	9d668ed5-0401-45dc-bc7d-7711915d4540	9d668ed5-060a-4d83-9a9c-d20278b957a3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 07:48:05
18334	9d668ed5-0491-4191-822c-7631da73d60e	9d668ed5-060a-4d83-9a9c-d20278b957a3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/60","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":60,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":177,"loans_codigo":60,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-10-30T15:56:57.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":178,"loans_codigo":60,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-10-30T15:56:57.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":179,"loans_codigo":60,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-10-30T15:56:57.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":180,"loans_codigo":60,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-10-30T15:56:57.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":181,"loans_codigo":60,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-10-30T15:56:57.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":397,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:48:05
36889	9d6b4171-7079-4aad-a318-1bd3d02ac30a	9d6b4171-8e6c-448f-a556-a53bbd35a5ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:50:50
24762	9d68bd27-01ad-4494-a88b-28ca4d28187e	9d68bd27-3c44-413b-8509-e4ffca40bea5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 09:49:16
24763	9d68bd27-394e-46e6-841e-7b4bd9f33bed	9d68bd27-3c44-413b-8509-e4ffca40bea5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 09:49:16
24764	9d68bd27-3abc-4a87-a538-cea605441200	9d68bd27-3c44-413b-8509-e4ffca40bea5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":721,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:49:16
36890	9d6b4171-890b-4a1a-91b7-511d6372152a	9d6b4171-8e6c-448f-a556-a53bbd35a5ed	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"46.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:50:50
36891	9d6b4171-8d0a-44d9-bb73-e4f704507659	9d6b4171-8e6c-448f-a556-a53bbd35a5ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:50:50
36892	9d6b4171-8d79-421e-a1ed-f84eaf2dc0a3	9d6b4171-8e6c-448f-a556-a53bbd35a5ed	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":289,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:50:50
37049	9d6b44bc-d55e-4d6b-8513-0fede33eea96	9d6b44bc-d74c-41fb-86c9-f4c5df6c8ebe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":306,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:00:02
18335	9d668fa6-6f2f-471b-95cb-263eea43e364	9d668fa6-7344-49ac-babe-02c50a12d819	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":239,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:50:22
24765	9d68bd28-0574-4242-b0a7-ec101feb2471	9d68bd28-37a4-45e0-abde-0ad261ec4a87	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 09:49:16
24766	9d68bd28-2954-44bb-880f-7ad2467e3aa0	9d68bd28-37a4-45e0-abde-0ad261ec4a87	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"65.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 09:49:16
24767	9d68bd28-2f33-4f1f-8bdd-8346e0e7d8b9	9d68bd28-37a4-45e0-abde-0ad261ec4a87	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"3.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:49:16
24768	9d68bd28-2f7f-4ac2-a7d1-9ffa2ab0f54a	9d68bd28-37a4-45e0-abde-0ad261ec4a87	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 09:49:16
24769	9d68bd28-3619-4b4f-af8a-0de734607697	9d68bd28-37a4-45e0-abde-0ad261ec4a87	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 09:49:16
24770	9d68bd28-36a4-4709-b7b4-94166b0ea6e3	9d68bd28-37a4-45e0-abde-0ad261ec4a87	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":570,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:49:16
36893	9d6b4171-dc06-455b-be43-904dda1739f0	9d6b4172-2840-4f80-a87a-7a3b9d502ab4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:50:50
36894	9d6b4172-22e9-4ef5-8f86-00850a6d341f	9d6b4172-2840-4f80-a87a-7a3b9d502ab4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"145.74","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:50:50
36895	9d6b4172-2348-4da6-a0ff-f47645140a63	9d6b4172-2840-4f80-a87a-7a3b9d502ab4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:50:50
36896	9d6b4172-271d-4ccd-8766-c175882d8d6c	9d6b4172-2840-4f80-a87a-7a3b9d502ab4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:50:50
36897	9d6b4172-2768-405d-92c4-08386cb5e9c2	9d6b4172-2840-4f80-a87a-7a3b9d502ab4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":379,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:50:50
37050	9d6b44bd-4886-433b-8632-0fe5f1dbd4ee	9d6b44bd-6f88-4fc3-95b7-9551dd75eeba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 16:00:03
18336	9d668fa7-05f3-424b-8bb1-b8cb2f062a05	9d668fa7-5af7-4f0a-b5a4-177676377a88	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 07:50:23
18337	9d668fa7-4f7d-4a26-804c-4c6adb58956b	9d668fa7-5af7-4f0a-b5a4-177676377a88	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 177 limit 1","time":"3.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":381,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-03 07:50:23
18338	9d668fa7-4ffa-48c7-b206-fc24057c8d41	9d668fa7-5af7-4f0a-b5a4-177676377a88	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-03 07:50:23
18339	9d668fa7-5209-4add-8570-0cd9ef6c096b	9d668fa7-5af7-4f0a-b5a4-177676377a88	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 60 limit 1","time":"1.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":382,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 07:50:23
18340	9d668fa7-5239-49a3-9d3b-e3299b3c64f1	9d668fa7-5af7-4f0a-b5a4-177676377a88	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 07:50:23
18341	9d668fa7-53f2-49e5-868b-a57770c7b847	9d668fa7-5af7-4f0a-b5a4-177676377a88	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '03-11-2024', \\"itemloans_interes_canelado\\" = '50000', \\"itemloans_cuota_cancelada\\" = '100000', \\"updated_at\\" = '2024-11-03 07:50:23' where \\"id\\" = 177","time":"1.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":409,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-03 07:50:23
18342	9d668fa7-5495-435e-9c2e-acfb2b49a8c1	9d668fa7-5af7-4f0a-b5a4-177676377a88	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:177","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-03 07:50:23","item_loans_cuando_pago":"03-11-2024","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},"hostname":"EderCortes"}	2024-11-03 07:50:23
18343	9d668fa7-555e-4fb1-a622-a486bdb61878	9d668fa7-5af7-4f0a-b5a4-177676377a88	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_estado\\" = 'En curso', \\"loans_fecha_ultimo_pago\\" = '03-11-2024', \\"updated_at\\" = '2024-11-03 07:50:23' where \\"id\\" = 60","time":"0.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":417,"hash":"401474b65cdf866a42a346357071e5f1","hostname":"EderCortes"}	2024-11-03 07:50:23
18344	9d668fa7-559a-4f60-bcd0-3e900c6c6d2e	9d668fa7-5af7-4f0a-b5a4-177676377a88	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:60","changes":{"loans_estado":"En curso","updated_at":"2024-11-03 07:50:23","loans_fecha_ultimo_pago":"03-11-2024"},"hostname":"EderCortes"}	2024-11-03 07:50:23
18345	9d668fa7-5981-4fa2-b44b-7977415a2964	9d668fa7-5af7-4f0a-b5a4-177676377a88	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 07:50:23
18346	9d668fa7-59e3-4543-9481-c0b71f5e8911	9d668fa7-5af7-4f0a-b5a4-177676377a88	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"179","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000","id":177,"loans_codigo":60,"itemloans_cuota":"1","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":409,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:50:23
24771	9d68bd29-357e-4833-bef4-876a5438c627	9d68bd29-abaa-4da7-8931-4c1022a215e6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 09:49:17
24772	9d68bd29-a22f-4610-b587-fbb512f87978	9d68bd29-abaa-4da7-8931-4c1022a215e6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"224.71","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:49:17
24773	9d68bd29-a2cf-4d73-a49d-daa1372c70fb	9d68bd29-abaa-4da7-8931-4c1022a215e6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:49:17
24774	9d68bd29-a970-4136-ab94-d652f0f8fc2d	9d68bd29-abaa-4da7-8931-4c1022a215e6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 09:49:17
24775	9d68bd29-a9f7-46f4-bbad-b07e46a244d5	9d68bd29-abaa-4da7-8931-4c1022a215e6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":929,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:49:17
36898	9d6b4172-745d-4342-bf1d-52c4bb605d27	9d6b4172-9466-4d7c-8b5a-18c157baaf37	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:50:50
36899	9d6b4172-8f2c-40f7-a70f-be4bc3c183f7	9d6b4172-9466-4d7c-8b5a-18c157baaf37	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:50:50
18347	9d668fa8-21cd-4428-898c-9d9f663cfa24	9d668fa8-3e63-46c2-9e92-08d843afb270	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 07:50:23
18348	9d668fa8-35e4-4ac3-a648-ff7084a7e835	9d668fa8-3e63-46c2-9e92-08d843afb270	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 60\\n                        ","time":"39.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"17136fa7b24c4dffd736d28ef469ee16","hostname":"EderCortes"}	2024-11-03 07:50:23
18349	9d668fa8-3974-4e21-86ed-1de92879b61c	9d668fa8-3e63-46c2-9e92-08d843afb270	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '60' order by \\"item_loans\\".\\"id\\" asc","time":"2.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 07:50:23
18350	9d668fa8-39a4-41ec-b2ad-ad1ef1f76330	9d668fa8-3e63-46c2-9e92-08d843afb270	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 07:50:23
18351	9d668fa8-3d37-46fc-a664-e5ba901b6546	9d668fa8-3e63-46c2-9e92-08d843afb270	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 07:50:23
18352	9d668fa8-3d7e-41bc-b024-d5be2785c4d7	9d668fa8-3e63-46c2-9e92-08d843afb270	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/60","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":60,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":177,"loans_codigo":60,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-11-03T12:50:23.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":178,"loans_codigo":60,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-10-30T15:56:57.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":179,"loans_codigo":60,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-10-30T15:56:57.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":180,"loans_codigo":60,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-10-30T15:56:57.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":181,"loans_codigo":60,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-10-30T15:56:57.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:50:23
18353	9d668fbd-239d-4317-b018-9f8147629930	9d668fbd-26eb-4027-aaa2-f80f9225e23b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":169,"memory":20,"hostname":"EderCortes"}	2024-11-03 07:50:37
24776	9d68bd2a-da07-42b3-bc99-790f0cb66134	9d68bd2b-0446-4ea2-8ac5-2aff7534d845	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 09:49:18
24777	9d68bd2a-fb48-411f-b215-201586f6515e	9d68bd2b-0446-4ea2-8ac5-2aff7534d845	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"60.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:49:18
24778	9d68bd2a-fbcb-4bbb-bf44-4e38e821c141	9d68bd2b-0446-4ea2-8ac5-2aff7534d845	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:49:18
24779	9d68bd2b-023c-42e3-8275-885d75d2533e	9d68bd2b-0446-4ea2-8ac5-2aff7534d845	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 09:49:18
24780	9d68bd2b-02c3-47e6-9b9b-a717aec2c5b4	9d68bd2b-0446-4ea2-8ac5-2aff7534d845	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":573,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:49:18
36900	9d6b4172-8f8f-4a14-86d3-7bf6b9a320aa	9d6b4172-9466-4d7c-8b5a-18c157baaf37	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:50:50
36901	9d6b4172-9303-4a1b-bcfd-e09c0e91578c	9d6b4172-9466-4d7c-8b5a-18c157baaf37	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:50:50
36902	9d6b4172-9342-4ac4-a987-061be5e7fca0	9d6b4172-9466-4d7c-8b5a-18c157baaf37	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":257,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:50:50
37051	9d6b44bd-6637-410d-87a8-8ce07a350eb3	9d6b44bd-6f88-4fc3-95b7-9551dd75eeba	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"54.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 16:00:03
37052	9d6b44bd-6d9c-41a9-b6ab-91862eb042cd	9d6b44bd-6f88-4fc3-95b7-9551dd75eeba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 16:00:03
37053	9d6b44bd-6e5f-4d73-9ecd-415d623e9e53	9d6b44bd-6f88-4fc3-95b7-9551dd75eeba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":334,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:00:03
18354	9d668fbd-da98-4aca-9a96-3a8fdfbc7da2	9d668fbd-f8d7-42f9-be88-782f5f1d6656	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 07:50:38
18355	9d668fbd-f057-46e2-a67a-cf68c62fa90f	9d668fbd-f8d7-42f9-be88-782f5f1d6656	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 178 limit 1","time":"2.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":381,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-03 07:50:38
18356	9d668fbd-f0a6-47db-b24e-507005cf591e	9d668fbd-f8d7-42f9-be88-782f5f1d6656	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-03 07:50:38
18357	9d668fbd-f25d-4ae3-944a-fa0282eb01e6	9d668fbd-f8d7-42f9-be88-782f5f1d6656	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 60 limit 1","time":"2.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":382,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 07:50:38
18358	9d668fbd-f292-437d-8ade-ec04a154fcac	9d668fbd-f8d7-42f9-be88-782f5f1d6656	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 07:50:38
18359	9d668fbd-f437-4019-84bf-2cbcf8a134d6	9d668fbd-f8d7-42f9-be88-782f5f1d6656	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '03-11-2024', \\"itemloans_interes_canelado\\" = '50000', \\"itemloans_cuota_cancelada\\" = '100000', \\"updated_at\\" = '2024-11-03 07:50:38' where \\"id\\" = 178","time":"2.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":409,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-03 07:50:38
18360	9d668fbd-f48c-4b03-a7b2-b36e4e845f4e	9d668fbd-f8d7-42f9-be88-782f5f1d6656	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:178","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-03 07:50:38","item_loans_cuando_pago":"03-11-2024","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},"hostname":"EderCortes"}	2024-11-03 07:50:38
18361	9d668fbd-f7ba-4309-b911-13591c62de57	9d668fbd-f8d7-42f9-be88-782f5f1d6656	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 07:50:38
18362	9d668fbd-f7fa-4978-a299-53a300d0c8fb	9d668fbd-f8d7-42f9-be88-782f5f1d6656	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"179","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000","id":178,"loans_codigo":60,"itemloans_cuota":"2","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":223,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:50:38
36903	9d6b4194-5490-4cc2-8eab-8f14915fa997	9d6b4194-73f5-4f49-bc00-ea950297ff59	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:51:13
36904	9d6b4194-6eae-4777-93a6-5a0d405ba489	9d6b4194-73f5-4f49-bc00-ea950297ff59	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:51:13
36905	9d6b4194-6f11-4687-9070-104faf1e27e2	9d6b4194-73f5-4f49-bc00-ea950297ff59	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:51:13
36906	9d6b4194-72c0-4ed7-90a0-e1a866988277	9d6b4194-73f5-4f49-bc00-ea950297ff59	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:51:13
36907	9d6b4194-7303-43fc-bae6-562126268f55	9d6b4194-73f5-4f49-bc00-ea950297ff59	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":272,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:51:13
37054	9d6b44bd-c3b2-4a68-a4fc-a62880548989	9d6b44bd-e7e4-498e-bd84-ac7bf2e975d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 16:00:03
37055	9d6b44bd-e1ea-4be4-ade2-53dbfc2eeb66	9d6b44bd-e7e4-498e-bd84-ac7bf2e975d1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:00:03
37056	9d6b44bd-e233-4743-bd7f-9b9e001e190a	9d6b44bd-e7e4-498e-bd84-ac7bf2e975d1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:00:03
37057	9d6b44bd-e63b-4e03-9a7f-02468784618b	9d6b44bd-e7e4-498e-bd84-ac7bf2e975d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 16:00:03
18363	9d668fbe-453e-4675-aa27-627e7f9440d7	9d668fbe-8a67-4b56-9cb5-d0dabd164f6e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 07:50:38
18364	9d668fbe-81a9-43aa-bc0f-95d7114dfd20	9d668fbe-8a67-4b56-9cb5-d0dabd164f6e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 60\\n                        ","time":"142.85","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"17136fa7b24c4dffd736d28ef469ee16","hostname":"EderCortes"}	2024-11-03 07:50:38
18365	9d668fbe-856b-40c9-af60-c281615ee827	9d668fbe-8a67-4b56-9cb5-d0dabd164f6e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '60' order by \\"item_loans\\".\\"id\\" asc","time":"2.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 07:50:38
18366	9d668fbe-859b-4fa2-96eb-3b7211c8c29f	9d668fbe-8a67-4b56-9cb5-d0dabd164f6e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 07:50:38
18367	9d668fbe-8937-46e0-9a9c-61688e4640fa	9d668fbe-8a67-4b56-9cb5-d0dabd164f6e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 07:50:38
18368	9d668fbe-8980-4b8a-83b7-b3e837bef56b	9d668fbe-8a67-4b56-9cb5-d0dabd164f6e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/60","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":60,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":177,"loans_codigo":60,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-11-03T12:50:23.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":178,"loans_codigo":60,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-11-03T12:50:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":179,"loans_codigo":60,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-10-30T15:56:57.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":180,"loans_codigo":60,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-10-30T15:56:57.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":181,"loans_codigo":60,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-10-30T15:56:57.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":329,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:50:38
37058	9d6b44bd-e69d-46b3-8710-6903cdcba81a	9d6b44bd-e7e4-498e-bd84-ac7bf2e975d1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":296,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:00:03
18505	9d66929a-87e3-4c8d-917d-692f7be59439	9d66929a-b2c9-4983-b058-c537fcbfb046	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 07:58:38
18506	9d66929a-b084-43cd-9373-2e856cf84134	9d66929a-b2c9-4983-b058-c537fcbfb046	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 07:58:38
18507	9d66929a-b149-416e-a3d0-1ce53eef2327	9d66929a-b2c9-4983-b058-c537fcbfb046	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":315,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:58:38
18369	9d668fc4-3a31-4553-920d-559933957deb	9d668fc4-3d91-4293-ab01-6177d215b042	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":164,"memory":20,"hostname":"EderCortes"}	2024-11-03 07:50:42
18508	9d66929b-26c5-4113-98ba-5ef8eb583b8f	9d66929b-7535-4e44-a63e-f37a34e4412c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 07:58:38
18509	9d66929b-6f25-4033-9d53-34862d8f2be5	9d66929b-7535-4e44-a63e-f37a34e4412c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"166.96","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58,"hash":"77f8314368b36a9393ec9c7735a91700","hostname":"EderCortes"}	2024-11-03 07:58:38
18510	9d66929b-739e-4c5a-a7a5-8298b671b5fc	9d66929b-7535-4e44-a63e-f37a34e4412c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 07:58:38
18511	9d66929b-741d-47b1-8709-a1a36e3f5391	9d66929b-7535-4e44-a63e-f37a34e4412c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":450,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:58:38
18634	9d669798-aebd-4fba-bf6b-02631673b7bc	9d669798-faba-4352-8fef-b2205c837928	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 08:12:35
18370	9d668fc4-f012-4eef-a1c5-f7df1a7f3757	9d668fc5-0db8-4747-a586-32a97ea440dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 07:50:42
18371	9d668fc5-05ec-45c6-a6bf-78e2b5ab025e	9d668fc5-0db8-4747-a586-32a97ea440dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 179 limit 1","time":"2.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":381,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-03 07:50:42
18372	9d668fc5-0633-4d0a-9273-977edc5a1f1c	9d668fc5-0db8-4747-a586-32a97ea440dd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-03 07:50:42
18373	9d668fc5-07a7-42c8-b214-2b84d6914118	9d668fc5-0db8-4747-a586-32a97ea440dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 60 limit 1","time":"1.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":382,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 07:50:42
18374	9d668fc5-07d9-4279-9f4c-25d7c9167815	9d668fc5-0db8-4747-a586-32a97ea440dd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 07:50:42
18375	9d668fc5-096b-49cd-84f6-e483c0b80a65	9d668fc5-0db8-4747-a586-32a97ea440dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '03-11-2024', \\"itemloans_interes_canelado\\" = '50000', \\"itemloans_cuota_cancelada\\" = '100000', \\"updated_at\\" = '2024-11-03 07:50:42' where \\"id\\" = 179","time":"2.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":409,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-03 07:50:42
18376	9d668fc5-09b9-431a-abc2-5b9105a556ff	9d668fc5-0db8-4747-a586-32a97ea440dd	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:179","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-03 07:50:42","item_loans_cuando_pago":"03-11-2024","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},"hostname":"EderCortes"}	2024-11-03 07:50:42
18377	9d668fc5-0c95-47e5-a9cb-701a217e4e3d	9d668fc5-0db8-4747-a586-32a97ea440dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 07:50:42
18378	9d668fc5-0cd6-484b-9027-4cb2cbfe957d	9d668fc5-0db8-4747-a586-32a97ea440dd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"179","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000","id":179,"loans_codigo":60,"itemloans_cuota":"3","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":216,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:50:42
18512	9d66929d-675a-49a3-887d-68782a5b84f3	9d66929d-8d81-4204-866d-1ec34a080d97	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 07:58:40
18513	9d66929d-86db-4a60-b843-a64030d058f7	9d66929d-8d81-4204-866d-1ec34a080d97	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"48.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 07:58:40
18514	9d66929d-8723-4727-8cf4-7222f1810e3a	9d66929d-8d81-4204-866d-1ec34a080d97	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 07:58:40
18515	9d66929d-8bbb-41c6-a660-1f9b83a70e20	9d66929d-8d81-4204-866d-1ec34a080d97	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 07:58:40
18516	9d66929d-8c1f-4fd7-8df5-f46b1953fe96	9d66929d-8d81-4204-866d-1ec34a080d97	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":455,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:58:40
18635	9d669798-f8c9-45e1-943d-295360eeea99	9d669798-faba-4352-8fef-b2205c837928	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:12:36
18636	9d669798-f991-40f2-8d9c-a30bea08d8bc	9d669798-faba-4352-8fef-b2205c837928	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":361,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:12:36
37059	9d6b44be-2f76-4c79-bc42-4530a7535020	9d6b44be-4f0c-4a3b-971e-c44a763a427d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 16:00:03
37060	9d6b44be-4a20-4f08-98cb-2c514fda1334	9d6b44be-4f0c-4a3b-971e-c44a763a427d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:00:03
37061	9d6b44be-4a6d-4831-9691-44235873aa56	9d6b44be-4f0c-4a3b-971e-c44a763a427d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:00:03
37062	9d6b44be-4dc0-4e15-bcf8-beee20bf4bca	9d6b44be-4f0c-4a3b-971e-c44a763a427d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 16:00:03
18379	9d668fc5-53e0-4b45-8e9f-0b5afb9286b8	9d668fc5-7121-4181-bf4d-fbec226e13f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 07:50:42
18380	9d668fc5-68c2-44ed-bc72-89b8282e72f9	9d668fc5-7121-4181-bf4d-fbec226e13f9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 60\\n                        ","time":"41.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"17136fa7b24c4dffd736d28ef469ee16","hostname":"EderCortes"}	2024-11-03 07:50:43
17051	9d6548af-45fb-4dc2-9f89-606239189176	9d6548af-954c-4e00-933e-46e14dcb0f1d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 16:36:07
17052	9d6548af-935c-40d3-8d08-b2689c0d73e2	9d6548af-954c-4e00-933e-46e14dcb0f1d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:36:07
17053	9d6548af-941e-448b-b5d7-a189e51a7c20	9d6548af-954c-4e00-933e-46e14dcb0f1d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":409,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:36:07
18381	9d668fc5-6c5c-4307-aa12-a46d60e0a484	9d668fc5-7121-4181-bf4d-fbec226e13f9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '60' order by \\"item_loans\\".\\"id\\" asc","time":"2.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 07:50:43
18382	9d668fc5-6c8b-4c50-b22a-886fa994be14	9d668fc5-7121-4181-bf4d-fbec226e13f9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 07:50:43
18383	9d668fc5-6ffb-447b-823d-38762b39f324	9d668fc5-7121-4181-bf4d-fbec226e13f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 07:50:43
18384	9d668fc5-7041-457d-a063-2ea506891ddc	9d668fc5-7121-4181-bf4d-fbec226e13f9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/60","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":60,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":177,"loans_codigo":60,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-11-03T12:50:23.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":178,"loans_codigo":60,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-11-03T12:50:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":179,"loans_codigo":60,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-11-03T12:50:42.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":180,"loans_codigo":60,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-10-30T15:56:57.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":181,"loans_codigo":60,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-10-30T15:56:57.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":220,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:50:43
18637	9d669799-5d99-4941-b819-178113ec8609	9d669799-a433-4575-a841-6d12d2e15dde	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:12:36
18638	9d669799-9fd4-4139-9eb7-496b27424657	9d669799-a433-4575-a841-6d12d2e15dde	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"153.22","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58,"hash":"8c8e5c1025213c11a10d0db7a142a089","hostname":"EderCortes"}	2024-11-03 08:12:36
18639	9d669799-a2fc-4da6-a1c5-597e072cb79a	9d669799-a433-4575-a841-6d12d2e15dde	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:12:36
18640	9d669799-a34a-4dd2-862a-e0c2df87c974	9d669799-a433-4575-a841-6d12d2e15dde	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":363,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:12:36
37063	9d6b44be-4e08-493e-b247-b7e1954584ab	9d6b44be-4f0c-4a3b-971e-c44a763a427d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":245,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:00:03
15879	9d64b212-b4c0-4e2c-8d96-04feba156498	9d64b212-f96e-4fb8-bbf1-f1bfb9ae2849	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 09:34:58
15880	9d64b212-f7fa-4680-9b86-e5b7e4091a8b	9d64b212-f96e-4fb8-bbf1-f1bfb9ae2849	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 09:34:58
15881	9d64b212-f88e-4166-8516-6d34dbb8efb6	9d64b212-f96e-4fb8-bbf1-f1bfb9ae2849	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":341,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:34:58
18385	9d668fca-7368-41ca-8474-d95788705b41	9d668fca-75f2-4b1b-83a1-da2cbbb292a7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":158,"memory":20,"hostname":"EderCortes"}	2024-11-03 07:50:46
20674	9d66f99b-5c21-4166-bdb2-a0c9f5406d7f	9d66f99b-a5a5-4814-ab78-3c98d797fad3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:46:39
20675	9d66f99b-a41c-4e28-9b12-c774c7c0856a	9d66f99b-a5a5-4814-ab78-3c98d797fad3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:46:39
20676	9d66f99b-a4b1-4401-9a50-3e409d6d7a8d	9d66f99b-a5a5-4814-ab78-3c98d797fad3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":353,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:46:39
24862	9d68bd9e-a79c-4c66-b587-6ee54224be6a	9d68bd9e-ebaa-4e9f-b2cb-d0c1c2c0212d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 09:50:34
24863	9d68bd9e-e8ac-49d3-86a4-ce3de09820af	9d68bd9e-ebaa-4e9f-b2cb-d0c1c2c0212d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 09:50:34
24864	9d68bd9e-e9fb-4704-aa37-a2d3b2f9d846	9d68bd9e-ebaa-4e9f-b2cb-d0c1c2c0212d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":979,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:50:34
15882	9d64b213-4682-4f59-a449-a6de4bb39430	9d64b213-6521-45f4-bea2-3deb9c491fdd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 09:34:58
15883	9d64b213-5cb2-4419-8fd2-0c517051014f	9d64b213-6521-45f4-bea2-3deb9c491fdd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"42.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"088d1fdbe045a08c3b0073ef22c7da32","hostname":"EderCortes"}	2024-11-02 09:34:59
15884	9d64b213-604c-4e4e-9f8d-bfaff1a03682	9d64b213-6521-45f4-bea2-3deb9c491fdd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"1.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:34:59
15885	9d64b213-6085-41fd-974f-8a54347462ac	9d64b213-6521-45f4-bea2-3deb9c491fdd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 09:34:59
15886	9d64b213-63f4-485d-9ba0-fb5a889e13f0	9d64b213-6521-45f4-bea2-3deb9c491fdd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 09:34:59
15887	9d64b213-6440-4483-8fac-a873acb1d0c5	9d64b213-6521-45f4-bea2-3deb9c491fdd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:34:59
18386	9d668fcb-2912-4e1c-a3ce-5c1d7cd0ee8f	9d668fcb-6e53-49aa-93af-2485e962c40b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 07:50:46
18387	9d668fcb-66b4-4db9-9763-5aaba1b1f657	9d668fcb-6e53-49aa-93af-2485e962c40b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 180 limit 1","time":"2.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":381,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-03 07:50:46
18388	9d668fcb-66fa-4425-a396-a1d75514d45f	9d668fcb-6e53-49aa-93af-2485e962c40b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-03 07:50:46
18389	9d668fcb-6856-40bf-a275-08364ce3d501	9d668fcb-6e53-49aa-93af-2485e962c40b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 60 limit 1","time":"1.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":382,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 07:50:46
18390	9d668fcb-6884-48fe-b3fa-032f9b15bb89	9d668fcb-6e53-49aa-93af-2485e962c40b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 07:50:46
18391	9d668fcb-69f0-468e-9d4b-8e7d58844cdf	9d668fcb-6e53-49aa-93af-2485e962c40b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '03-11-2024', \\"itemloans_interes_canelado\\" = '50000', \\"itemloans_cuota_cancelada\\" = '100000', \\"updated_at\\" = '2024-11-03 07:50:46' where \\"id\\" = 180","time":"2.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":409,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-03 07:50:46
18392	9d668fcb-6a41-4f98-adc9-f786b5228315	9d668fcb-6e53-49aa-93af-2485e962c40b	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:180","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-03 07:50:46","item_loans_cuando_pago":"03-11-2024","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},"hostname":"EderCortes"}	2024-11-03 07:50:46
18393	9d668fcb-6d2f-49a1-b5ee-59e876f9e300	9d668fcb-6e53-49aa-93af-2485e962c40b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 07:50:46
18394	9d668fcb-6d70-4702-b6af-d7284cdd147d	9d668fcb-6e53-49aa-93af-2485e962c40b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"179","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000","id":180,"loans_codigo":60,"itemloans_cuota":"4","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":319,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:50:46
18641	9d66979b-6804-445a-90ef-70540109f49d	9d66979b-9f12-40c4-b3d6-7954ce77c66b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:12:37
15888	9d64b214-e9c9-4c5a-98f8-9937a3f6ee60	9d64b215-0998-477a-85e4-148a5be0272b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 09:35:00
15889	9d64b215-034d-42b4-8a73-321bacb579c9	9d64b215-0998-477a-85e4-148a5be0272b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 09:35:00
15890	9d64b215-03a4-434d-8954-c68bac3b62cd	9d64b215-0998-477a-85e4-148a5be0272b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 09:35:00
15891	9d64b215-0839-4692-b975-64fafb9a4022	9d64b215-0998-477a-85e4-148a5be0272b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-02 09:35:00
15892	9d64b215-0889-450b-9518-2bf147442125	9d64b215-0998-477a-85e4-148a5be0272b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","user-agent":"Mozilla\\/5.0 (iPhone; CPU iPhone OS 16_6 like Mac OS X) AppleWebKit\\/605.1.15 (KHTML, like Gecko) Version\\/16.6 Mobile\\/15E148 Safari\\/604.1","accept":"application\\/json, text\\/plain, *\\/*","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:35:00
18395	9d668fcb-ad5c-4d03-97f5-e9bc68624445	9d668fcb-cad8-4876-8b3b-aafc3e312aeb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 07:50:47
18396	9d668fcb-c29d-4735-8c1f-403afe9e44b6	9d668fcb-cad8-4876-8b3b-aafc3e312aeb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 60\\n                        ","time":"41.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"17136fa7b24c4dffd736d28ef469ee16","hostname":"EderCortes"}	2024-11-03 07:50:47
18397	9d668fcb-c611-4418-85d0-c93c11057850	9d668fcb-cad8-4876-8b3b-aafc3e312aeb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '60' order by \\"item_loans\\".\\"id\\" asc","time":"2.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 07:50:47
18398	9d668fcb-c641-4b8c-a4f2-8b4dda8c4a3b	9d668fcb-cad8-4876-8b3b-aafc3e312aeb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 07:50:47
18399	9d668fcb-c9b9-48c8-a0d1-ac1452e6741c	9d668fcb-cad8-4876-8b3b-aafc3e312aeb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 07:50:47
18400	9d668fcb-c9ff-459a-9c96-8b5b425e74b5	9d668fcb-cad8-4876-8b3b-aafc3e312aeb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/60","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":60,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":177,"loans_codigo":60,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-11-03T12:50:23.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":178,"loans_codigo":60,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-11-03T12:50:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":179,"loans_codigo":60,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-11-03T12:50:42.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":180,"loans_codigo":60,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-11-03T12:50:46.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":181,"loans_codigo":60,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-10-30T15:56:57.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":221,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:50:47
18642	9d66979b-98c8-42d2-9b5d-546ed749c2d0	9d66979b-9f12-40c4-b3d6-7954ce77c66b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"57.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 08:12:37
18643	9d66979b-992c-4f9b-960c-bcd3c231e7ae	9d66979b-9f12-40c4-b3d6-7954ce77c66b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 08:12:37
18644	9d66979b-9d9f-4cbd-82aa-12a92e80a8a7	9d66979b-9f12-40c4-b3d6-7954ce77c66b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 08:12:37
15893	9d64b226-16b7-4d96-8b65-d552940d0a87	9d64b226-38b6-4a2d-bf2f-0a03445f3111	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-02 09:35:11
15894	9d64b226-3280-43c7-86c8-c9774c7db904	9d64b226-38b6-4a2d-bf2f-0a03445f3111	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id DESC\\n                        ","time":"56.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":24,"hash":"260f946734e62b8b22f6f7e8ec87b603","hostname":"EderCortes"}	2024-11-02 09:35:11
15895	9d64b226-363b-42da-997d-df8fb9f38655	9d64b226-38b6-4a2d-bf2f-0a03445f3111	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-02 09:35:11
15896	9d64b226-36e4-4947-8dd7-b8c7f4c5febc	9d64b226-38b6-4a2d-bf2f-0a03445f3111	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","user-agent":"Mozilla\\/5.0 (iPhone; CPU iPhone OS 16_6 like Mac OS X) AppleWebKit\\/605.1.15 (KHTML, like Gecko) Version\\/16.6 Mobile\\/15E148 Safari\\/604.1","accept":"application\\/json, text\\/plain, *\\/*","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":352,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:35:11
18401	9d668fd5-eb09-44db-8690-42d694d114d8	9d668fd5-edea-46ff-9bd4-e549ffb08506	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":133,"memory":20,"hostname":"EderCortes"}	2024-11-03 07:50:53
18645	9d66979b-9dff-4a89-adcd-c541d30a7c66	9d66979b-9f12-40c4-b3d6-7954ce77c66b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":370,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:12:37
20677	9d66f99b-fcac-45ec-80a9-1bd52a4ebb4d	9d66f99c-43cd-468f-ba9f-cf263b9ab241	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:46:39
20678	9d66f99c-3b4b-4928-828a-84c4c7ed3a2a	9d66f99c-43cd-468f-ba9f-cf263b9ab241	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"148.24","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:46:39
20679	9d66f99c-3ed2-48ce-ac97-492361fd80a9	9d66f99c-43cd-468f-ba9f-cf263b9ab241	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"1.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:46:39
15897	9d64b25a-91a3-4baf-b59f-65b4b661be15	9d64b25a-bea5-4a75-a2ec-c255d3810d19	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 09:35:45
15898	9d64b25a-b200-48e3-8ce1-0defb140ba13	9d64b25a-bea5-4a75-a2ec-c255d3810d19	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 22\\n                        ","time":"53.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"f9344e277d181987f84c6dcddcb4342d","hostname":"EderCortes"}	2024-11-02 09:35:45
15899	9d64b25a-b71c-4e0a-a556-93471d1501f0	9d64b25a-bea5-4a75-a2ec-c255d3810d19	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '22' order by \\"item_loans\\".\\"id\\" asc","time":"2.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:35:45
15900	9d64b25a-b76c-4611-a8b2-8d27c4a87df3	9d64b25a-bea5-4a75-a2ec-c255d3810d19	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-02 09:35:45
15901	9d64b25a-bcb2-494c-847c-ca3d2c2b147d	9d64b25a-bea5-4a75-a2ec-c255d3810d19	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:35:45
15902	9d64b25a-bd23-4e9c-94b2-7dd7a6a640d7	9d64b25a-bea5-4a75-a2ec-c255d3810d19	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/22","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":22,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":70,"loans_codigo":22,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":71,"loans_codigo":22,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":72,"loans_codigo":22,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":73,"loans_codigo":22,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":74,"loans_codigo":22,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":75,"loans_codigo":22,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-04-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":306,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:35:45
18402	9d668fd6-55b5-4698-8fe7-806d8e69da17	9d668fd6-a48e-4953-857f-db7bbd0496f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 07:50:54
18403	9d668fd6-9988-4073-8a74-fd4fd44a1465	9d668fd6-a48e-4953-857f-db7bbd0496f5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 181 limit 1","time":"3.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":381,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-03 07:50:54
18404	9d668fd6-99cf-415c-b398-f698704c3425	9d668fd6-a48e-4953-857f-db7bbd0496f5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-03 07:50:54
18405	9d668fd6-9b5a-4245-940d-9e3d2e38c169	9d668fd6-a48e-4953-857f-db7bbd0496f5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 60 limit 1","time":"2.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":382,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 07:50:54
18406	9d668fd6-9b89-4c03-afef-ce47cb8cb50f	9d668fd6-a48e-4953-857f-db7bbd0496f5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 07:50:54
18407	9d668fd6-9f69-4f70-8350-b86689ccf037	9d668fd6-a48e-4953-857f-db7bbd0496f5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '03-11-2024', \\"itemloans_interes_canelado\\" = '50000', \\"itemloans_cuota_cancelada\\" = '100000', \\"updated_at\\" = '2024-11-03 07:50:54' where \\"id\\" = 181","time":"7.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":409,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-03 07:50:54
18408	9d668fd6-9fb7-4eda-a22a-5ab07377a59f	9d668fd6-a48e-4953-857f-db7bbd0496f5	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:181","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-03 07:50:54","item_loans_cuando_pago":"03-11-2024","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},"hostname":"EderCortes"}	2024-11-03 07:50:54
18409	9d668fd6-a05f-4488-bc73-a93fd8bd41d6	9d668fd6-a48e-4953-857f-db7bbd0496f5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_estado\\" = 'Cancelado', \\"updated_at\\" = '2024-11-03 07:50:54' where \\"id\\" = 60","time":"0.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":417,"hash":"633cd7b6fc569e7b4277bc2482f50d66","hostname":"EderCortes"}	2024-11-03 07:50:54
18410	9d668fd6-a08e-4a74-8090-c460565909d7	9d668fd6-a48e-4953-857f-db7bbd0496f5	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:60","changes":{"loans_estado":"Cancelado","updated_at":"2024-11-03 07:50:54"},"hostname":"EderCortes"}	2024-11-03 07:50:54
18411	9d668fd6-a374-4c9b-8cf9-bb7f554b6d64	9d668fd6-a48e-4953-857f-db7bbd0496f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 07:50:54
20680	9d66f99c-3f04-4414-842d-9b1ad976a27a	9d66f99c-43cd-468f-ba9f-cf263b9ab241	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:46:39
20681	9d66f99c-428b-437a-971b-78864dc5e057	9d66f99c-43cd-468f-ba9f-cf263b9ab241	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 12:46:39
24865	9d68bd9f-9711-4a4a-a064-ce96848a5282	9d68bd9f-e1e8-4b54-99f2-5e4740263287	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 09:50:35
18412	9d668fd6-a3b4-4cc5-b6d7-d988af4bf3c0	9d668fd6-a48e-4953-857f-db7bbd0496f5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"179","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000","id":181,"loans_codigo":60,"itemloans_cuota":"5","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":344,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:50:54
20682	9d66f99c-42e5-4ef5-892d-8e4d40d9872e	9d66f99c-43cd-468f-ba9f-cf263b9ab241	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"400000","loans_pago_interes":"200000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:40:42.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":null,"itemloans_cuota_cancelada":"100000"},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":337,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:46:39
24866	9d68bd9f-d79f-43d2-9451-17a6a686bc37	9d68bd9f-e1e8-4b54-99f2-5e4740263287	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"152.01","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 09:50:35
24867	9d68bd9f-dbf2-4821-a3e6-1c2d2b73694e	9d68bd9f-e1e8-4b54-99f2-5e4740263287	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:50:35
24868	9d68bd9f-dc2e-4b95-a2e5-8d97c738363a	9d68bd9f-e1e8-4b54-99f2-5e4740263287	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 09:50:35
24869	9d68bd9f-e05c-4bd1-b516-acadccb9e623	9d68bd9f-e1e8-4b54-99f2-5e4740263287	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 09:50:35
24870	9d68bd9f-e0bd-43cf-9f13-496ffff1a409	9d68bd9f-e1e8-4b54-99f2-5e4740263287	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":555,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:50:35
37064	9d6b44c0-15cb-4f75-82a1-6844428a09f8	9d6b44c0-5fc1-4891-b168-a37b4e6896fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 16:00:05
37065	9d6b44c0-5881-469e-a3cc-e9bcf4723f5e	9d6b44c0-5fc1-4891-b168-a37b4e6896fe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"149.85","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 16:00:05
37066	9d6b44c0-58fb-4347-916c-62c0da330cbf	9d6b44c0-5fc1-4891-b168-a37b4e6896fe	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 16:00:05
37067	9d6b44c0-5e56-470b-babe-77c1622a620a	9d6b44c0-5fc1-4891-b168-a37b4e6896fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 16:00:05
18413	9d668fd6-e5b5-47c6-87f8-47e39bdc33cb	9d668fd7-03f3-4d7b-b910-854d6bff83e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 07:50:54
18414	9d668fd6-fae9-417b-a018-7d85b46dc00a	9d668fd7-03f3-4d7b-b910-854d6bff83e0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 60\\n                        ","time":"42.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"17136fa7b24c4dffd736d28ef469ee16","hostname":"EderCortes"}	2024-11-03 07:50:54
18415	9d668fd6-fee6-4cc4-a071-83c858c6b5b3	9d668fd7-03f3-4d7b-b910-854d6bff83e0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '60' order by \\"item_loans\\".\\"id\\" asc","time":"2.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 07:50:54
18416	9d668fd6-ff16-4aab-8dc4-b818307ec707	9d668fd7-03f3-4d7b-b910-854d6bff83e0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 07:50:54
18417	9d668fd7-02cf-41fd-8270-cf661db2b6c1	9d668fd7-03f3-4d7b-b910-854d6bff83e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-03 07:50:54
18418	9d668fd7-0315-45a2-98b3-a4d754ee1050	9d668fd7-03f3-4d7b-b910-854d6bff83e0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/60","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":60,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":177,"loans_codigo":60,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-11-03T12:50:23.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":178,"loans_codigo":60,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-11-03T12:50:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":179,"loans_codigo":60,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-11-03T12:50:42.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":180,"loans_codigo":60,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-11-03T12:50:46.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":181,"loans_codigo":60,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:56:57.000000Z","updated_at":"2024-11-03T12:50:54.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"}]}},"duration":228,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:50:54
24871	9d68bda0-9d06-4870-82b3-769290d49b68	9d68bda0-d191-4b08-8ec7-569993bb6e35	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 09:50:35
24872	9d68bda0-c738-4738-811b-0b5cc3d00d8c	9d68bda0-d191-4b08-8ec7-569993bb6e35	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"69.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:50:35
15964	9d64b6db-36c9-4221-8feb-f9c0601bfc76	9d64b6db-6180-4b5b-9503-a8b57fcaecab	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 09:48:21
15965	9d64b6db-5ee2-4ac2-a8cf-e7e9f7763aee	9d64b6db-6180-4b5b-9503-a8b57fcaecab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:48:21
15966	9d64b6db-5fe4-4c87-936d-1f6828a538fc	9d64b6db-6180-4b5b-9503-a8b57fcaecab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":302,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:48:21
18419	9d668fef-6909-499e-8614-2d612bc77235	9d668fef-8502-416b-93d8-eff5b8f84490	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-03 07:51:10
18420	9d668fef-808d-47a9-896d-08c2038a8c8b	9d668fef-8502-416b-93d8-eff5b8f84490	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"42.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58,"hash":"77f8314368b36a9393ec9c7735a91700","hostname":"EderCortes"}	2024-11-03 07:51:10
24873	9d68bda0-c7c7-4346-92fa-cfdf45d521ba	9d68bda0-d191-4b08-8ec7-569993bb6e35	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:50:35
18421	9d668fef-83ca-49f8-99d8-32e063970acc	9d668fef-8502-416b-93d8-eff5b8f84490	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-03 07:51:10
18422	9d668fef-841a-4228-9577-106e37496603	9d668fef-8502-416b-93d8-eff5b8f84490	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:51:10
20683	9d66f99d-e816-46ab-b52b-bf3fa8695c7e	9d66f99e-24e4-40a7-8575-216867d9416a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 12:46:41
24874	9d68bda0-cf5c-40ac-9265-49725fa06744	9d68bda0-d191-4b08-8ec7-569993bb6e35	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 09:50:35
24875	9d68bda0-cfe5-46a8-8071-a9c24c5bdfef	9d68bda0-d191-4b08-8ec7-569993bb6e35	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":591,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:50:35
15967	9d64b6db-c933-4ee0-8639-560185894b1c	9d64b6dc-1a12-4ff7-a614-eebbb326951b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:48:21
15968	9d64b6dc-0c46-4c48-8d4c-d9237b6778d9	9d64b6dc-1a12-4ff7-a614-eebbb326951b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 22\\n                        ","time":"155.05","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"f9344e277d181987f84c6dcddcb4342d","hostname":"EderCortes"}	2024-11-02 09:48:21
15969	9d64b6dc-117d-4438-9799-24d4e32a13e3	9d64b6dc-1a12-4ff7-a614-eebbb326951b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '22' order by \\"item_loans\\".\\"id\\" asc","time":"2.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:48:21
15970	9d64b6dc-11c5-4fe1-a42f-f08bfb804d9d	9d64b6dc-1a12-4ff7-a614-eebbb326951b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-02 09:48:21
15971	9d64b6dc-18aa-48de-8190-79af6de61e5f	9d64b6dc-1a12-4ff7-a614-eebbb326951b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:48:21
15972	9d64b6dc-1908-4bbb-8a84-d0bdc4da9cb9	9d64b6dc-1a12-4ff7-a614-eebbb326951b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/22","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":22,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":70,"loans_codigo":22,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":71,"loans_codigo":22,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":72,"loans_codigo":22,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":73,"loans_codigo":22,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":74,"loans_codigo":22,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":75,"loans_codigo":22,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-04-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":429,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:48:21
18423	9d6690ad-ebaa-400e-b136-5b038f9beb38	9d6690ae-1828-4757-9969-f416a5917463	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 07:53:15
18424	9d6690ae-0fa8-402d-b638-26af7d4d8d6f	9d6690ae-1828-4757-9969-f416a5917463	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"58.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-03 07:53:15
18425	9d6690ae-15d8-4be8-87bb-7da4f053ac64	9d6690ae-1828-4757-9969-f416a5917463	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 07:53:15
18426	9d6690ae-1683-496d-a330-2797e842d520	9d6690ae-1828-4757-9969-f416a5917463	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":399,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:53:15
20684	9d66f99e-1abe-4d7e-8044-10d7063566a8	9d66f99e-24e4-40a7-8575-216867d9416a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"61.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:46:41
20685	9d66f99e-1b3e-4b78-8a94-c4df14b2e1bc	9d66f99e-24e4-40a7-8575-216867d9416a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:46:41
20686	9d66f99e-229a-4da0-8f89-d6a2376e7786	9d66f99e-24e4-40a7-8575-216867d9416a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:46:41
15973	9d64b6de-0525-4c69-806e-5526b4abd1e9	9d64b6de-2e2a-454e-832b-5fe403d28ace	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:48:22
15974	9d64b6de-2441-4bcc-a27c-b8c8e4762566	9d64b6de-2e2a-454e-832b-5fe403d28ace	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"58.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 09:48:23
15975	9d64b6de-24cb-46d3-843a-8bd318924466	9d64b6de-2e2a-454e-832b-5fe403d28ace	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 09:48:23
15976	9d64b6de-2bff-4b63-ad5d-4cd173161da9	9d64b6de-2e2a-454e-832b-5fe403d28ace	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 09:48:23
15977	9d64b6de-2c6c-4dbe-ba8e-04c97e63109b	9d64b6de-2e2a-454e-832b-5fe403d28ace	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":374,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:48:23
18427	9d6690b4-6521-41e1-b8a8-e6e806d2e624	9d6690b4-a950-4f61-9e06-1addf7b94916	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 07:53:19
18428	9d6690b4-a564-4d02-a8c9-12263badc23c	9d6690b4-a950-4f61-9e06-1addf7b94916	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"148.92","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58,"hash":"77f8314368b36a9393ec9c7735a91700","hostname":"EderCortes"}	2024-11-03 07:53:19
18429	9d6690b4-a82a-43c4-afde-b68ca5d195f7	9d6690b4-a950-4f61-9e06-1addf7b94916	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 07:53:19
18430	9d6690b4-a87b-43a9-b1ea-e7cd2ce95f6e	9d6690b4-a950-4f61-9e06-1addf7b94916	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":374,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:53:19
20687	9d66f99e-233f-4f8a-bcd0-b06a022600af	9d66f99e-24e4-40a7-8575-216867d9416a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":580,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:46:41
24876	9d68bda1-78b5-4031-854d-f65d845db859	9d68bda1-a4fa-4dbb-9e2d-4e37a8c32d29	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 09:50:36
24877	9d68bda1-9dcd-4e66-a780-ee24da1eefc8	9d68bda1-a4fa-4dbb-9e2d-4e37a8c32d29	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"60.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:50:36
24878	9d68bda1-9e29-477f-99b9-09fb26d1253c	9d68bda1-a4fa-4dbb-9e2d-4e37a8c32d29	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:50:36
24879	9d68bda1-a343-46a1-acbb-93ff7dcf272e	9d68bda1-a4fa-4dbb-9e2d-4e37a8c32d29	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 09:50:36
24880	9d68bda1-a3bb-4524-9a83-88354aab6c1d	9d68bda1-a4fa-4dbb-9e2d-4e37a8c32d29	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":516,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:50:36
37068	9d6b44c0-5ea0-4f5b-b144-11f8ff191e3a	9d6b44c0-5fc1-4891-b168-a37b4e6896fe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":451,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:00:05
24881	9d68bdac-0966-4c2e-97ed-00f0debdf927	9d68bdac-0c6d-4b84-850b-ff4c325b4925	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":143,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:50:43
18578	9d66949e-c2c9-4205-9329-004825f14dfd	9d66949e-f6d3-4345-91de-70e52220bd32	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 08:04:16
18579	9d66949e-f491-4dcc-8936-24048e383681	9d66949e-f6d3-4345-91de-70e52220bd32	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:04:16
18580	9d66949e-f57a-4eee-b4be-0bc2a04f0f0a	9d66949e-f6d3-4345-91de-70e52220bd32	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":344,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:04:16
18581	9d66949f-a5fb-472b-ada7-a47b560191ef	9d66949f-f336-4c22-bd92-b8b4d6930d14	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:04:17
18582	9d66949f-ecae-4a4d-8642-73378868d00e	9d66949f-f336-4c22-bd92-b8b4d6930d14	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"162.62","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58,"hash":"77f8314368b36a9393ec9c7735a91700","hostname":"EderCortes"}	2024-11-03 08:04:17
18583	9d66949f-f1ee-4dd6-a9d9-4bc5c7b732a2	9d66949f-f336-4c22-bd92-b8b4d6930d14	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:04:17
18584	9d66949f-f249-414a-b9d0-b496d2669982	9d66949f-f336-4c22-bd92-b8b4d6930d14	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":595,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:04:17
24882	9d68bdac-9b77-4e63-9ee5-bf6ee29a4ac1	9d68bdac-bf1f-422a-abf8-5adac3678300	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 09:50:43
24883	9d68bdac-b3f1-413a-8b09-f8e684163d9d	9d68bdac-bf1f-422a-abf8-5adac3678300	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 356 limit 1","time":"2.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 09:50:43
24884	9d68bdac-b443-4250-a272-122fc6577289	9d68bdac-bf1f-422a-abf8-5adac3678300	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 09:50:43
24885	9d68bdac-b5cd-4db0-a3e8-0f60353f6499	9d68bdac-bf1f-422a-abf8-5adac3678300	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 90 limit 1","time":"1.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 09:50:43
24886	9d68bdac-b601-4e6a-99d9-5a49d055eac6	9d68bdac-bf1f-422a-abf8-5adac3678300	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 09:50:43
24887	9d68bdac-b9a5-4440-99b6-f72ca08c58e1	9d68bdac-bf1f-422a-abf8-5adac3678300	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '55000', \\"itemloans_cuota_cancelada\\" = '220000', \\"updated_at\\" = '2024-11-04 09:50:43' where \\"id\\" = 356","time":"7.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":400,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 09:50:43
24888	9d68bdac-ba1d-4e05-b7d9-6f36b0093d87	9d68bdac-bf1f-422a-abf8-5adac3678300	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:356","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 09:50:43","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},"hostname":"EderCortes"}	2024-11-04 09:50:43
24889	9d68bdac-bac7-45a7-a68d-a1fa472242fe	9d68bdac-bf1f-422a-abf8-5adac3678300	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 55000, \\"loans_pago_prestado\\" = 220000, \\"updated_at\\" = '2024-11-04 09:50:43' where \\"id\\" = 90","time":"0.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":408,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 09:50:43
24890	9d68bdac-bafd-4561-82a6-52b1a933a8c2	9d68bdac-bf1f-422a-abf8-5adac3678300	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:90","changes":{"updated_at":"2024-11-04 09:50:43","loans_pago_interes":55000,"loans_pago_prestado":220000},"hostname":"EderCortes"}	2024-11-04 09:50:43
24891	9d68bdac-bdec-43d4-bc05-dab23441bded	9d68bdac-bf1f-422a-abf8-5adac3678300	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 09:50:43
24892	9d68bdac-be30-4d38-9cca-5a6d8bffe53d	9d68bdac-bf1f-422a-abf8-5adac3678300	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"179","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000","id":356,"loans_codigo":90,"itemloans_cuota":"1","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:50:43
24893	9d68bdad-341f-41d0-a140-7fe0eeb925f8	9d68bdad-5493-4034-a116-2a1848201aab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 09:50:44
17140	9d654ec1-6805-4542-9cab-f4f24fa52d87	9d654ec1-8b4f-4681-9ac2-cca75ba5ae03	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 16:53:05
17141	9d654ec1-8969-4248-aec8-0f848c2cc6dd	9d654ec1-8b4f-4681-9ac2-cca75ba5ae03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:53:05
17142	9d654ec1-8a23-4b1d-ba45-0d0a4777cdd9	9d654ec1-8b4f-4681-9ac2-cca75ba5ae03	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":278,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:53:05
24894	9d68bdad-4bdb-47d7-b468-4a8dafdbb98d	9d68bdad-5493-4034-a116-2a1848201aab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 90\\n                        ","time":"46.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"93c10371e33ace24260de21c3ff3890d","hostname":"EderCortes"}	2024-11-04 09:50:44
18585	9d6694a2-7004-4e93-820c-c86978b695a2	9d6694a2-b3f4-473f-a7c0-21630c134d0a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:04:18
18586	9d6694a2-a822-4e73-bcd3-7e963075ba44	9d6694a2-b3f4-473f-a7c0-21630c134d0a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"96.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 08:04:19
24895	9d68bdad-4f74-4a90-a077-7439daddc3c6	9d68bdad-5493-4034-a116-2a1848201aab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"2.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:50:44
18587	9d6694a2-a8bb-4227-b6d5-f0c034189606	9d6694a2-b3f4-473f-a7c0-21630c134d0a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 08:04:19
18588	9d6694a2-b1dc-4801-852f-403711e5b3c6	9d6694a2-b3f4-473f-a7c0-21630c134d0a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 08:04:19
18589	9d6694a2-b26e-43fd-b576-1de74ce0f246	9d6694a2-b3f4-473f-a7c0-21630c134d0a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":604,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:04:19
24896	9d68bdad-4faa-4f0d-b3a4-2c475c43cd72	9d68bdad-5493-4034-a116-2a1848201aab	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 09:50:44
24897	9d68bdad-534a-4439-be5d-e547671ed63c	9d68bdad-5493-4034-a116-2a1848201aab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 09:50:44
24898	9d68bdad-5398-4cf1-9695-6e15c0f32e5d	9d68bdad-5493-4034-a116-2a1848201aab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"220000","loans_pago_interes":"55000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":362,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:50:44
17143	9d654ec2-1440-4a81-b9dd-0f3d43b39db8	9d654ec2-6d8d-4160-81b8-99745b9eab91	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:53:06
17144	9d654ec2-6095-4721-b905-9e75b0c08a71	9d654ec2-6d8d-4160-81b8-99745b9eab91	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"174.29","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":281,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 16:53:06
17145	9d654ec2-65d1-40e9-921d-e4de8896c267	9d654ec2-6d8d-4160-81b8-99745b9eab91	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":310,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 16:53:06
17146	9d654ec2-661a-4801-8527-5bb259c3e165	9d654ec2-6d8d-4160-81b8-99745b9eab91	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 16:53:06
17147	9d654ec2-6b7d-40d0-ab33-e18d37904bd4	9d654ec2-6d8d-4160-81b8-99745b9eab91	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 16:53:06
17148	9d654ec2-6bef-4d43-8147-da1b5942ecfb	9d654ec2-6d8d-4160-81b8-99745b9eab91	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:34:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"}]}},"duration":538,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:53:06
37208	9d6b45df-0721-45c4-8934-dbbe48705797	9d6b45df-2867-4d88-8bf3-f12302fa4bfc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 16:03:13
37209	9d6b45df-2650-4afd-97f5-ac88cb2a1e3b	9d6b45df-2867-4d88-8bf3-f12302fa4bfc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 16:03:13
37210	9d6b45df-2722-4012-b771-3da7f405490f	9d6b45df-2867-4d88-8bf3-f12302fa4bfc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":280,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:03:13
17149	9d654ec4-73ea-4456-bed5-4fb26a40053b	9d654ec4-905f-44dd-b7ab-261666539b3a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 16:53:07
17150	9d654ec4-8b6f-4371-8f82-e2d151d3f48b	9d654ec4-905f-44dd-b7ab-261666539b3a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"39.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 16:53:07
17151	9d654ec4-8bce-4b53-9ba8-524cbd126594	9d654ec4-905f-44dd-b7ab-261666539b3a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 16:53:07
17152	9d654ec4-8f2e-46a4-aed6-7409a4929a3d	9d654ec4-905f-44dd-b7ab-261666539b3a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 16:53:07
17153	9d654ec4-8f78-4c01-8c3f-feec3d5710ea	9d654ec4-905f-44dd-b7ab-261666539b3a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:53:07
37211	9d6b45df-7cfd-468f-a119-b9daf57c37cb	9d6b45df-c4cf-4865-af10-cda353f88d0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 16:03:13
37212	9d6b45df-c029-486a-bf40-47fc5bdec48d	9d6b45df-c4cf-4865-af10-cda353f88d0d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"154.93","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 16:03:13
37213	9d6b45df-c309-4b96-9690-80b919cb3739	9d6b45df-c4cf-4865-af10-cda353f88d0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 16:03:13
37214	9d6b45df-c395-408c-8d6d-2ccd0459053b	9d6b45df-c4cf-4865-af10-cda353f88d0d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:03:13
17154	9d654ed3-b68e-435e-915e-3c622bcc8bcb	9d654ed3-d9a7-46a5-bfe8-fe5c6feeea04	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 16:53:17
17155	9d654ed3-d56e-4956-a4d2-e1ceb3abaa25	9d654ed3-d9a7-46a5-bfe8-fe5c6feeea04	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"61.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":46,"hash":"fb4ded687569d92428336ceae5c6ffcd","hostname":"EderCortes"}	2024-11-02 16:53:17
17156	9d654ed3-d859-4540-b055-71476b68519c	9d654ed3-d9a7-46a5-bfe8-fe5c6feeea04	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 16:53:17
17157	9d654ed3-d8ad-4497-a1a7-c6ea870b61fa	9d654ed3-d9a7-46a5-bfe8-fe5c6feeea04	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":260,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:53:17
37215	9d6b45e0-28f3-4ad7-8e4f-d5582427d933	9d6b45e0-782b-4ed9-a822-f080669bcfc5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 16:03:13
37216	9d6b45e0-7138-42ed-b652-fbc0426b4272	9d6b45e0-782b-4ed9-a822-f080669bcfc5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"150.87","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:03:13
37217	9d6b45e0-71c5-4230-9a31-496c5f4a189e	9d6b45e0-782b-4ed9-a822-f080669bcfc5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:03:13
37218	9d6b45e0-76b8-43a2-b3a5-7f874e3053a4	9d6b45e0-782b-4ed9-a822-f080669bcfc5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 16:03:13
37219	9d6b45e0-770a-4cc1-8b00-7f3107454b4f	9d6b45e0-782b-4ed9-a822-f080669bcfc5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":436,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:03:13
37220	9d6b45e1-029a-4ea3-8b5f-ca997300f4f8	9d6b45e1-25c9-4557-9e9b-9c5892876aae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 16:03:14
37221	9d6b45e1-1ff7-49d9-a147-e4142dd3b9e3	9d6b45e1-25c9-4557-9e9b-9c5892876aae	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:03:14
37222	9d6b45e1-2045-41b4-941a-32525400d9f1	9d6b45e1-25c9-4557-9e9b-9c5892876aae	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:03:14
37223	9d6b45e1-2478-414b-89ca-8caf946ce4db	9d6b45e1-25c9-4557-9e9b-9c5892876aae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 16:03:14
37224	9d6b45e1-24c8-4377-a787-e07b9b4878ed	9d6b45e1-25c9-4557-9e9b-9c5892876aae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":422,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:03:14
37225	9d6b45e2-f6a0-41ff-aa97-e5b397c722cc	9d6b45e3-54b3-450d-9aa3-e95a3b0e86ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 16:03:15
37226	9d6b45e3-4928-4580-bcdc-370538839356	9d6b45e3-54b3-450d-9aa3-e95a3b0e86ae	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"111.94","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 16:03:15
37227	9d6b45e3-49b2-4b3d-9dba-559cfcc6f349	9d6b45e3-54b3-450d-9aa3-e95a3b0e86ae	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 16:03:15
37228	9d6b45e3-526d-4274-af4f-62d6bdea4f6c	9d6b45e3-54b3-450d-9aa3-e95a3b0e86ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 16:03:15
37229	9d6b45e3-52f5-49fc-884e-f0e47e4c9459	9d6b45e3-54b3-450d-9aa3-e95a3b0e86ae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":785,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:03:15
25118	9d68bfd5-098c-4cea-bb97-355ed5fe7718	9d68bfd5-2ee0-4f30-8838-71190e03ccab	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 09:56:45
25119	9d68bfd5-2cde-47a2-a005-e961212ecc25	9d68bfd5-2ee0-4f30-8838-71190e03ccab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 09:56:45
25120	9d68bfd5-2dba-464f-8a54-e380c9352cee	9d68bfd5-2ee0-4f30-8838-71190e03ccab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:56:45
25121	9d68bfd5-bf44-48fa-93b6-d7ef050141b6	9d68bfd5-e104-49a3-ab2c-f4d43e2fcffd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 09:56:46
25122	9d68bfd5-d51c-42ac-818e-18b8dd2e5fa0	9d68bfd5-e104-49a3-ab2c-f4d43e2fcffd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"44.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 09:56:46
25123	9d68bfd5-d946-4ad8-bc21-71eaa17aab59	9d68bfd5-e104-49a3-ab2c-f4d43e2fcffd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:56:46
25124	9d68bfd5-d985-44ae-8b1e-021d914c3501	9d68bfd5-e104-49a3-ab2c-f4d43e2fcffd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 09:56:46
25125	9d68bfd5-dfcf-4ee4-bddb-fde1398e02a6	9d68bfd5-e104-49a3-ab2c-f4d43e2fcffd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 09:56:46
25126	9d68bfd5-e018-481e-bfc2-79629463e4de	9d68bfd5-e104-49a3-ab2c-f4d43e2fcffd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":352,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":353,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":354,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":355,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":411,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:56:46
37401	9d6b4a38-f29f-4ed1-9d1d-721748ba5d21	9d6b4a39-1b3f-437a-8001-97c20e951f6f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 16:15:23
37402	9d6b4a39-1968-4420-b665-e5ff71e724fc	9d6b4a39-1b3f-437a-8001-97c20e951f6f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 16:15:23
37403	9d6b4a39-1a26-4f2c-9b02-d3600399b64d	9d6b4a39-1b3f-437a-8001-97c20e951f6f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":321,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:15:23
24590	9d68b754-ed98-4e57-9e96-698981c1a56e	9d68b755-3f7b-4a78-86b9-4b2a7e854828	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 09:32:59
24591	9d68b755-3d41-45df-b0a8-d8834afb1cd2	9d68b755-3f7b-4a78-86b9-4b2a7e854828	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 09:32:59
24592	9d68b755-3e22-4665-9574-845a9f9acbac	9d68b755-3f7b-4a78-86b9-4b2a7e854828	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":464,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:32:59
37608	9d6b58c8-265c-4b2f-b2b0-fead5ae06466	9d6b58c8-43e6-488b-aa8a-afc32efa96a9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 16:56:05
37609	9d6b58c8-4249-48e7-a6b4-dddb0cd57b2e	9d6b58c8-43e6-488b-aa8a-afc32efa96a9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 16:56:05
37610	9d6b58c8-42e6-4bb7-8155-716531c59ca7	9d6b58c8-43e6-488b-aa8a-afc32efa96a9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:56:05
24593	9d68b755-c927-4b67-9da2-110eb1d3c4c3	9d68b755-f418-49d1-bfe9-a9300e23ce09	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 09:33:00
24594	9d68b755-e6b5-4575-8de9-951dd21f083d	9d68b755-f418-49d1-bfe9-a9300e23ce09	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 66\\n                        ","time":"62.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"f5566f306d2be9466f2c4564ce0020bd","hostname":"EderCortes"}	2024-11-04 09:33:00
14273	9d5d195c-094e-41b0-b885-3b384a3c3d50	9d5d195c-3831-4f4e-9b8a-0114595b29fe	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-29 14:57:09
14274	9d5d195c-3631-429f-b9ad-29dd0cb0b3d5	9d5d195c-3831-4f4e-9b8a-0114595b29fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 14:57:09
14275	9d5d195c-3711-46ab-8d35-70af4427ef21	9d5d195c-3831-4f4e-9b8a-0114595b29fe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:57:09
18712	9d6699d5-0ec4-47ac-94fd-c99533c0541a	9d6699d5-32dc-4c77-b887-4aec59a5638c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 08:18:51
18713	9d6699d5-30c1-40ef-b40d-407a08e8d45c	9d6699d5-32dc-4c77-b887-4aec59a5638c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:18:51
18714	9d6699d5-3187-485c-af21-bf1c86adb425	9d6699d5-32dc-4c77-b887-4aec59a5638c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:18:51
24595	9d68b755-ebf9-4e64-9d7b-9891f808be5f	9d68b755-f418-49d1-bfe9-a9300e23ce09	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '66' order by \\"item_loans\\".\\"id\\" asc","time":"3.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:33:00
24596	9d68b755-ec51-4cce-b302-84681c9be5b6	9d68b755-f418-49d1-bfe9-a9300e23ce09	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 09:33:00
24597	9d68b755-f260-4509-8788-d6054326e99e	9d68b755-f418-49d1-bfe9-a9300e23ce09	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 09:33:00
24598	9d68b755-f2c6-4ede-b194-1a43639499f8	9d68b755-f418-49d1-bfe9-a9300e23ce09	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/66","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":66,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":5000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"5000000","loans_pago_interes":"1250000"},"items":[{"id":217,"loans_codigo":66,"itemloans_cuota":"1","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:26.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":218,"loans_codigo":66,"itemloans_cuota":"2","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":219,"loans_codigo":66,"itemloans_cuota":"3","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":220,"loans_codigo":66,"itemloans_cuota":"4","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:33.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":221,"loans_codigo":66,"itemloans_cuota":"5","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":222,"loans_codigo":66,"itemloans_cuota":"6","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:39.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":223,"loans_codigo":66,"itemloans_cuota":"7","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:42.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":224,"loans_codigo":66,"itemloans_cuota":"8","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:46.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":225,"loans_codigo":66,"itemloans_cuota":"9","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-31 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:50.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":226,"loans_codigo":66,"itemloans_cuota":"10","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:31:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"}]}},"duration":375,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:33:00
37404	9d6b4a39-a8df-4db8-829a-1cfb123b575d	9d6b4a39-c7cd-41ec-b968-0889d3b2098c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 16:15:23
37405	9d6b4a39-bfc1-46e4-8bac-e1336bd7899e	9d6b4a39-c7cd-41ec-b968-0889d3b2098c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 84\\n                        ","time":"44.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ab3bc7b9a0b897ddfe4287a88fc64c84","hostname":"EderCortes"}	2024-11-05 16:15:23
37406	9d6b4a39-c2dc-4da6-a748-418283583ee8	9d6b4a39-c7cd-41ec-b968-0889d3b2098c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '84' order by \\"item_loans\\".\\"id\\" asc","time":"2.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":304,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-05 16:15:23
14276	9d5d195c-a1f7-4bab-b546-04d8f82b3ddc	9d5d195c-c1c8-4cca-b7e2-759b23d2eb45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-29 14:57:10
14277	9d5d195c-bae5-4f0b-98f5-ed57a6901b76	9d5d195c-c1c8-4cca-b7e2-759b23d2eb45	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":179,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 14:57:10
14278	9d5d195c-bb4c-4a7a-93ba-2652250d2ddc	9d5d195c-c1c8-4cca-b7e2-759b23d2eb45	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-29 14:57:10
14279	9d5d195c-c00c-41bb-922f-777bea159815	9d5d195c-c1c8-4cca-b7e2-759b23d2eb45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 14:57:10
14280	9d5d195c-c07d-41af-ad85-773bd867d67f	9d5d195c-c1c8-4cca-b7e2-759b23d2eb45	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":297,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:57:10
18715	9d6699d5-8784-4608-aed0-e61848ecb161	9d6699d5-a387-43f4-b781-329aea220d22	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:18:51
18716	9d6699d5-9ef7-4e83-9463-e64ed980fa6d	9d6699d5-a387-43f4-b781-329aea220d22	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"44.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c37ce191b53d9d62ae3ae483cb5ffa40","hostname":"EderCortes"}	2024-11-03 08:18:51
18717	9d6699d5-a251-4df3-a118-3afb4a799868	9d6699d5-a387-43f4-b781-329aea220d22	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:18:51
18718	9d6699d5-a2a2-4909-8a9f-b7fe6092cecf	9d6699d5-a387-43f4-b781-329aea220d22	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","frecuencia_pago":"-1","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"6","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"-25","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"6","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"-25","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"-1","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"13","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"13","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"6","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"-3","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"5","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"-25","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"-25","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"-25","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:18:51
37407	9d6b4a39-c685-4da4-8322-0598405ede89	9d6b4a39-c7cd-41ec-b968-0889d3b2098c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 16:15:23
37408	9d6b4a39-c6d7-4d7c-8648-d61becd7c31e	9d6b4a39-c7cd-41ec-b968-0889d3b2098c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/84","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":84,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"480000","loans_pago_interes":"120000","user_alias":"juan_jaramillo"},"items":[{"id":326,"loans_codigo":84,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 21:20:45","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":452,"loans_codigo":84,"itemloans_cuota":"4","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 21:20:45","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":456,"loans_codigo":84,"itemloans_cuota":"3","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:21:49","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":457,"loans_codigo":84,"itemloans_cuota":"4","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:21:49","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":458,"loans_codigo":84,"itemloans_cuota":"5","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:21:49","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":300,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:15:23
37611	9d6b58c8-962d-4b8e-949d-e590661f5696	9d6b58c8-b4c7-4e66-a196-0781f97da3d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 16:56:06
37612	9d6b58c8-af74-4db9-864b-95226ace3aaa	9d6b58c8-b4c7-4e66-a196-0781f97da3d9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:56:06
37613	9d6b58c8-afc2-4ed5-ac7a-6beb75c1d50d	9d6b58c8-b4c7-4e66-a196-0781f97da3d9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:56:06
37614	9d6b58c8-b34f-4485-9aca-5e07b26693a0	9d6b58c8-b4c7-4e66-a196-0781f97da3d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 16:56:06
14281	9d5d195d-0364-404f-b2f4-59e93ca210a4	9d5d195d-215c-4168-b1d1-350bd6c0969d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-29 14:57:10
14282	9d5d195d-1c3f-437b-8d38-ea8970c833e8	9d5d195d-215c-4168-b1d1-350bd6c0969d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":179,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-29 14:57:10
14283	9d5d195d-1c96-45ec-b8f1-88b6aa623958	9d5d195d-215c-4168-b1d1-350bd6c0969d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-29 14:57:10
14284	9d5d195d-2041-42c4-b73b-6be2e7d0f8a6	9d5d195d-215c-4168-b1d1-350bd6c0969d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-29 14:57:10
14285	9d5d195d-2086-4362-b1c2-2b4acf78ac82	9d5d195d-215c-4168-b1d1-350bd6c0969d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":228,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:57:10
18719	9d6699d7-7819-4985-81ae-c0025b04428b	9d6699d7-c07f-4ea1-b154-fb7ab67d87cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:18:52
18720	9d6699d7-bb70-4d0a-9c23-d5dc92111ecf	9d6699d7-c07f-4ea1-b154-fb7ab67d87cd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"152.34","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 08:18:52
14431	9d5d1e25-89db-4a97-8ae4-4efd13e59e30	9d5d1e25-8b66-43f7-ae94-f90f381acbd8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/55","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":55,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":7,"loans_valor_prestado":50000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"15-11-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":150,"loans_codigo":55,"itemloans_cuota":"1","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":151,"loans_codigo":55,"itemloans_cuota":"2","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":152,"loans_codigo":55,"itemloans_cuota":"3","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":153,"loans_codigo":55,"itemloans_cuota":"4","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":154,"loans_codigo":55,"itemloans_cuota":"5","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":155,"loans_codigo":55,"itemloans_cuota":"6","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":156,"loans_codigo":55,"itemloans_cuota":"7","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":777,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:10:32
18721	9d6699d7-bbba-4338-b726-bac26e8d57a9	9d6699d7-c07f-4ea1-b154-fb7ab67d87cd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 08:18:52
18722	9d6699d7-bf53-41a4-b286-ef9f7a7d7f9a	9d6699d7-c07f-4ea1-b154-fb7ab67d87cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 08:18:52
18723	9d6699d7-bf97-43fd-9f0b-3289dcdbd7a0	9d6699d7-c07f-4ea1-b154-fb7ab67d87cd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":401,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:18:52
37409	9d6b4a3b-cf9c-4522-abf8-787edec1766d	9d6b4a3c-1aab-4fae-951b-c91a54c05b79	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 16:15:24
37410	9d6b4a3c-1544-4c01-9105-54decdc8c602	9d6b4a3c-1aab-4fae-951b-c91a54c05b79	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"156.22","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 16:15:25
37411	9d6b4a3c-15a6-4725-a4d1-66a448456199	9d6b4a3c-1aab-4fae-951b-c91a54c05b79	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 16:15:25
37412	9d6b4a3c-195a-4066-b8bf-4ce107c2154a	9d6b4a3c-1aab-4fae-951b-c91a54c05b79	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 16:15:25
37413	9d6b4a3c-19a6-4f81-b575-1229c70293ca	9d6b4a3c-1aab-4fae-951b-c91a54c05b79	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":445,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:15:25
25238	9d68c09b-a318-4a49-9213-e53d04cb32c8	9d68c09b-e153-4891-ad8f-1b518518376b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 09:58:55
25239	9d68c09b-de2c-480a-8b00-e192f55df252	9d68c09b-e153-4891-ad8f-1b518518376b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 09:58:56
25240	9d68c09b-df9c-40a3-9dc3-a88ad925277c	9d68c09b-e153-4891-ad8f-1b518518376b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":637,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:58:56
14432	9d5d1e28-8aaf-4cd6-a05c-bf0d4518d511	9d5d1e28-befd-48d4-b1f7-2bdf8d996d07	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-10-29 15:10:34
14433	9d5d1e28-b4a5-4032-b798-42b8b0934d95	9d5d1e28-befd-48d4-b1f7-2bdf8d996d07	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"74.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-29 15:10:35
14434	9d5d1e28-b523-48b7-87c5-4fbcfb547af0	9d5d1e28-befd-48d4-b1f7-2bdf8d996d07	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-29 15:10:35
14435	9d5d1e28-bc3e-42e0-a8cd-3e4d983a1062	9d5d1e28-befd-48d4-b1f7-2bdf8d996d07	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-10-29 15:10:35
14436	9d5d1e28-bcfc-4c1e-bb27-5b132243ca22	9d5d1e28-befd-48d4-b1f7-2bdf8d996d07	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":399,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:10:35
37615	9d6b58c8-b3bb-45de-afca-9a1317e74b24	9d6b58c8-b4c7-4e66-a196-0781f97da3d9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:56:06
18768	9d669bb2-57d2-4fcb-b7a9-d3d112cb48ee	9d669bb2-a8c9-47e1-ba60-8dfd9b775770	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 08:24:03
18769	9d669bb2-a647-4d3f-a1a3-90a433970c2c	9d669bb2-a8c9-47e1-ba60-8dfd9b775770	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 08:24:04
18770	9d669bb2-a75d-4f22-a6db-45f8590a2167	9d669bb2-a8c9-47e1-ba60-8dfd9b775770	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":432,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:24:04
37931	9d6b5dc8-73c7-45d9-b02d-508f952b0e2a	9d6b5dc8-e317-4384-b633-76ff10ba4d96	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 17:10:04
37616	9d6b58c8-fd68-4c2f-92b5-8a65ff8daaa3	9d6b58c9-1c2a-4bf4-82c3-3dded1129fd9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 16:56:06
37617	9d6b58c9-1708-4d92-bd7f-2a7337759008	9d6b58c9-1c2a-4bf4-82c3-3dded1129fd9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-05 16:56:06
37618	9d6b58c9-1759-4c66-8789-c93ea289026d	9d6b58c9-1c2a-4bf4-82c3-3dded1129fd9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-05 16:56:06
37619	9d6b58c9-1aee-4571-8c2a-afe8baa5f2ba	9d6b58c9-1c2a-4bf4-82c3-3dded1129fd9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 16:56:06
37620	9d6b58c9-1b36-4af2-afbf-a2923a560e68	9d6b58c9-1c2a-4bf4-82c3-3dded1129fd9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:56:06
37932	9d6b5dc8-df28-433b-b286-d37dfd12c964	9d6b5dc8-e317-4384-b633-76ff10ba4d96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:10:05
37933	9d6b5dc8-e112-42ad-9542-ddf0b493b1c7	9d6b5dc8-e317-4384-b633-76ff10ba4d96	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":517,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:10:05
25241	9d68c09c-a014-4bf3-9e15-6d2c29636877	9d68c09c-d300-4d7a-acf0-21a1b5d4d23e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 09:58:56
25242	9d68c09c-c9af-4a12-a12b-fcb865d9b990	9d68c09c-d300-4d7a-acf0-21a1b5d4d23e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"61.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 09:58:56
25243	9d68c09c-d0d8-402a-abb4-8a2f678722a8	9d68c09c-d300-4d7a-acf0-21a1b5d4d23e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 09:58:56
25244	9d68c09c-d18e-47a2-8707-6aeffcbe38f5	9d68c09c-d300-4d7a-acf0-21a1b5d4d23e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":547,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:58:56
37621	9d6b58c9-5fb3-49eb-98e8-2714af05e167	9d6b58c9-7d7f-4f6f-a931-2ed463264d4a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 16:56:06
37622	9d6b58c9-77ed-40f6-980a-218118cd9cfe	9d6b58c9-7d7f-4f6f-a931-2ed463264d4a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:56:06
37623	9d6b58c9-7836-4749-b3c4-87b8203bc073	9d6b58c9-7d7f-4f6f-a931-2ed463264d4a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-05 16:56:06
37624	9d6b58c9-7c2f-4e58-ad77-414c2ea436fe	9d6b58c9-7d7f-4f6f-a931-2ed463264d4a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 16:56:06
37625	9d6b58c9-7c70-4b5f-9095-145e741540bd	9d6b58c9-7d7f-4f6f-a931-2ed463264d4a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:56:06
37934	9d6b5dc9-71d6-4d66-902a-6fa6bf855ceb	9d6b5dc9-bc2f-4992-bdda-03a7c2c2f00d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:10:05
37935	9d6b5dc9-b61e-4dfd-864b-38ed5e99a103	9d6b5dc9-bc2f-4992-bdda-03a7c2c2f00d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"151.79","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:10:05
37936	9d6b5dc9-baaa-4b2d-8a24-31ed90e4862e	9d6b5dc9-bc2f-4992-bdda-03a7c2c2f00d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:10:05
37626	9d6b58c9-c53a-4d54-a56d-5064faa58852	9d6b58c9-e451-4630-b98c-946f2b3b1821	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 16:56:06
20906	9d66fdbd-a49f-4761-893c-0db58007784c	9d66fdbe-2510-441d-85ac-efbda08d9988	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:58:12
20907	9d66fdbe-220c-4d6e-b652-d6df37a1e792	9d66fdbe-2510-441d-85ac-efbda08d9988	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:58:13
20908	9d66fdbe-2365-4bce-8700-de92071cd15e	9d66fdbe-2510-441d-85ac-efbda08d9988	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":637,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:58:13
37627	9d6b58c9-dd98-4c31-b67e-b500f93da4ae	9d6b58c9-e451-4630-b98c-946f2b3b1821	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_valor_prestado\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\" from \\"loans\\" where \\"id\\" = '93' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"41.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":229,"hash":"f00e27e21a94f93c5c7a1d0cd56f9f13","hostname":"EderCortes"}	2024-11-05 16:56:06
37628	9d6b58c9-dde2-44d4-902b-367f3154f1aa	9d6b58c9-e451-4630-b98c-946f2b3b1821	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-05 16:56:06
25245	9d68c09d-8796-4fcb-8e8b-b02e97bc724c	9d68c09d-df6c-4054-84e9-c21fee4d4bae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 09:58:57
25246	9d68c09d-d482-40b5-b15d-54039f7d804e	9d68c09d-df6c-4054-84e9-c21fee4d4bae	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"151.94","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:58:57
37629	9d6b58c9-dfb5-42b1-ba99-175fab91eed7	9d6b58c9-e451-4630-b98c-946f2b3b1821	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"2.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":230,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-05 16:56:06
25247	9d68c09d-d517-45e4-aa38-2a0811073f30	9d68c09d-df6c-4054-84e9-c21fee4d4bae	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:58:57
25248	9d68c09d-dd23-49f1-b4a8-73122bd8b9e5	9d68c09d-df6c-4054-84e9-c21fee4d4bae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 09:58:57
37630	9d6b58c9-dfe7-40ea-96f8-7d94d4124aef	9d6b58c9-e451-4630-b98c-946f2b3b1821	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-05 16:56:06
37631	9d6b58c9-e32c-4732-9ae5-82f65214da65	9d6b58c9-e451-4630-b98c-946f2b3b1821	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 16:56:06
37632	9d6b58c9-e373-4fde-a907-c5a2f894fc3f	9d6b58c9-e451-4630-b98c-946f2b3b1821	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"user_creador":22,"user_cobrador":22,"user_customer":19,"user_recomendacion":18},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:19:45.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:22:30.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":399,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":400,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":401,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":402,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"}]}},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:56:06
37937	9d6b5dc9-bb35-4a0d-8147-c2262faa4326	9d6b5dc9-bc2f-4992-bdda-03a7c2c2f00d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":469,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:10:05
20909	9d66fdbe-a4af-4b6d-bd6b-0c9d84bf1ee0	9d66fdbe-c995-4e74-bed7-5568d6a5fca9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:58:13
20910	9d66fdbe-c349-4dd5-8291-74fe5f2a356b	9d66fdbe-c995-4e74-bed7-5568d6a5fca9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"51.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 12:58:13
20911	9d66fdbe-c81c-46c6-8a88-3cacfc61995a	9d66fdbe-c995-4e74-bed7-5568d6a5fca9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:58:13
20912	9d66fdbe-c888-49a1-a1c3-8f6f7d945120	9d66fdbe-c995-4e74-bed7-5568d6a5fca9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":null,"loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:58:13
25249	9d68c09d-ddd3-4970-be13-3fca45e478c6	9d68c09d-df6c-4054-84e9-c21fee4d4bae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":672,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:58:57
20913	9d66fdc1-1d93-404c-aa83-c2197a020433	9d66fdc1-4afe-438a-a7af-7365a6c61245	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:58:15
20914	9d66fdc1-4380-4a99-9dab-c9e611148497	9d66fdc1-4afe-438a-a7af-7365a6c61245	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"63.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:58:15
20915	9d66fdc1-43fa-4518-bd1e-b489951f6f4e	9d66fdc1-4afe-438a-a7af-7365a6c61245	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:58:15
20916	9d66fdc1-4905-4db0-9a19-7145657646bf	9d66fdc1-4afe-438a-a7af-7365a6c61245	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:58:15
15158	9d5ecf17-5740-4c72-b86e-7c21722e86ef	9d5ecf17-b974-4375-8078-e6154d3d27eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-30 11:21:09
15159	9d5ecf17-b645-41ad-888d-4c63dc610ed8	9d5ecf17-b974-4375-8078-e6154d3d27eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-30 11:21:09
15160	9d5ecf17-b7a5-4deb-b578-37fb44afb8ab	9d5ecf17-b974-4375-8078-e6154d3d27eb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":894,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:21:09
20917	9d66fdc1-4991-463c-8bb9-855a5b7d579e	9d66fdc1-4afe-438a-a7af-7365a6c61245	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":584,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:58:15
25250	9d68c09f-77c2-444b-99ac-c26078928bb2	9d68c09f-9ceb-4f2e-b13c-f20c3ae6a44f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 09:58:58
25251	9d68c09f-9521-4bab-9b2c-2f42f8daa5e4	9d68c09f-9ceb-4f2e-b13c-f20c3ae6a44f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"51.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:58:58
25252	9d68c09f-9580-4b46-a410-2ae706fd852d	9d68c09f-9ceb-4f2e-b13c-f20c3ae6a44f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:58:58
25253	9d68c09f-9b12-43e7-9bcb-82a962c6d7d6	9d68c09f-9ceb-4f2e-b13c-f20c3ae6a44f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 09:58:58
25254	9d68c09f-9b9d-4dea-83fb-984af3c58da3	9d68c09f-9ceb-4f2e-b13c-f20c3ae6a44f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":461,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:58:58
37633	9d6b58cb-8037-44da-8510-2ba7ad036c47	9d6b58cb-be2b-4a99-9df4-9a4d5c78551b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 16:56:07
37634	9d6b58cb-b74b-4fff-8ca9-9b189b0b8142	9d6b58cb-be2b-4a99-9df4-9a4d5c78551b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"76.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 16:56:08
37635	9d6b58cb-b79c-4610-8442-34abccc2519b	9d6b58cb-be2b-4a99-9df4-9a4d5c78551b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 16:56:08
37636	9d6b58cb-bc49-412c-91e8-e9db0ea7d704	9d6b58cb-be2b-4a99-9df4-9a4d5c78551b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 16:56:08
37938	9d6b5dca-2536-4e0b-ba49-7221c5e535f7	9d6b5dca-6f83-456a-8b8a-e38aa19bbd59	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:10:05
37939	9d6b5dca-69bd-4cec-8f8b-a1d1ec7a76c7	9d6b5dca-6f83-456a-8b8a-e38aa19bbd59	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"141.71","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:10:06
37940	9d6b5dca-6a28-477c-8e95-f639464005eb	9d6b5dca-6f83-456a-8b8a-e38aa19bbd59	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:10:06
15161	9d5ecf18-881f-4c8e-880e-e0c66e40db68	9d5ecf18-e111-44da-bf13-6aa3b2f2b5ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-30 11:21:09
15162	9d5ecf18-d236-4729-8521-17e06af0063a	9d5ecf18-e111-44da-bf13-6aa3b2f2b5ea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"165.70","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"088d1fdbe045a08c3b0073ef22c7da32","hostname":"EderCortes"}	2024-10-30 11:21:09
15163	9d5ecf18-d807-466f-8931-73031fc87c0e	9d5ecf18-e111-44da-bf13-6aa3b2f2b5ea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"3.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-30 11:21:09
15164	9d5ecf18-d85e-453e-ad4c-b4fd250a994e	9d5ecf18-e111-44da-bf13-6aa3b2f2b5ea	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-10-30 11:21:09
15165	9d5ecf18-df14-40a2-b543-517dd32687b7	9d5ecf18-e111-44da-bf13-6aa3b2f2b5ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-30 11:21:10
15166	9d5ecf18-dfad-4512-be6b-8545f3b18fc2	9d5ecf18-e111-44da-bf13-6aa3b2f2b5ea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":698,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:21:10
20918	9d66fe33-3ffb-4de5-a343-0775c3e9f35e	9d66fe33-5fe1-404a-a6e9-22b6a61cc8ec	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 12:59:29
20919	9d66fe33-5a56-48f8-a2a8-a15a4a6133c3	9d66fe33-5fe1-404a-a6e9-22b6a61cc8ec	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"43.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-03 12:59:30
20920	9d66fe33-5e42-497c-bea8-3cd50f616bf4	9d66fe33-5fe1-404a-a6e9-22b6a61cc8ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:59:30
20921	9d66fe33-5ea9-4be0-b918-c111e0aa3f09	9d66fe33-5fe1-404a-a6e9-22b6a61cc8ec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:59:30
37941	9d6b5dca-6e05-42ce-a6ab-2567447f4e91	9d6b5dca-6f83-456a-8b8a-e38aa19bbd59	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:10:06
15167	9d5ecf19-a7d9-4b3c-a06a-00f5ec3f91ef	9d5ecf1a-1afc-4838-b2c4-80790214908b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-30 11:21:10
15168	9d5ecf1a-0eaa-472c-a4de-0e0eb258f3ae	9d5ecf1a-1afc-4838-b2c4-80790214908b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"204.66","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 11:21:10
15169	9d5ecf1a-0f46-4ed8-b38b-67336f29f530	9d5ecf1a-1afc-4838-b2c4-80790214908b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 11:21:10
15170	9d5ecf1a-1870-406c-8bc9-365ed79cb9ce	9d5ecf1a-1afc-4838-b2c4-80790214908b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-30 11:21:10
15171	9d5ecf1a-1934-4046-a880-29ccc3ed1366	9d5ecf1a-1afc-4838-b2c4-80790214908b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":778,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:21:10
20922	9d66fe35-c65a-4348-82b6-67c446612ae2	9d66fe36-0d8c-4ba0-af6e-44dc616591c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:59:31
20923	9d66fe36-087a-41aa-8741-5cc8c129a1da	9d66fe36-0d8c-4ba0-af6e-44dc616591c4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"144.77","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":184,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 12:59:31
20924	9d66fe36-08e1-47e5-bdfe-48c5f46a0460	9d66fe36-0d8c-4ba0-af6e-44dc616591c4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 12:59:31
20925	9d66fe36-0c56-445f-b1b0-40c14534bbf3	9d66fe36-0d8c-4ba0-af6e-44dc616591c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:59:31
20926	9d66fe36-0c9a-473e-90bd-e14e5e6ec3d9	9d66fe36-0d8c-4ba0-af6e-44dc616591c4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":464,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:59:31
37637	9d6b58cb-bcb0-4d18-b74d-6b4e9944734e	9d6b58cb-be2b-4a99-9df4-9a4d5c78551b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":601,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:56:08
37942	9d6b5dca-6e6f-4ab6-b695-29c8d667b3dd	9d6b5dca-6f83-456a-8b8a-e38aa19bbd59	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":438,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:10:06
15172	9d5ecf1a-9fc4-4428-acca-a24e8229445a	9d5ecf1a-e6bf-43f9-9996-7bedc12baf35	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-30 11:21:11
15173	9d5ecf1a-e1a0-444d-a4c7-ead2e5c999ff	9d5ecf1a-e6bf-43f9-9996-7bedc12baf35	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"146.10","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 11:21:11
15174	9d5ecf1a-e1fa-4b8d-9f6c-764b506a4451	9d5ecf1a-e6bf-43f9-9996-7bedc12baf35	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 11:21:11
15175	9d5ecf1a-e568-49ae-aba1-a3516ce076bf	9d5ecf1a-e6bf-43f9-9996-7bedc12baf35	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-30 11:21:11
15176	9d5ecf1a-e5b0-4869-b7c6-fed0fa250f18	9d5ecf1a-e6bf-43f9-9996-7bedc12baf35	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":496,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:21:11
20927	9d66fe36-5296-46ec-8474-36ed680fc481	9d66fe36-7074-4cd8-b5c3-6a889ab0193a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:59:31
20928	9d66fe36-6b0f-47b7-b9d9-fcdf67b18e2c	9d66fe36-7074-4cd8-b5c3-6a889ab0193a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":184,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 12:59:32
20929	9d66fe36-6b69-48cc-a43c-1c214f7c9d8e	9d66fe36-7074-4cd8-b5c3-6a889ab0193a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-03 12:59:32
20930	9d66fe36-6f11-4a73-974a-ec6e69d9c2f0	9d66fe36-7074-4cd8-b5c3-6a889ab0193a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:59:32
20931	9d66fe36-6f68-4e36-babc-28c8861b5a0a	9d66fe36-7074-4cd8-b5c3-6a889ab0193a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:59:32
37943	9d6b5dca-b328-4814-9592-e4372f7f2c1c	9d6b5dca-fbda-4494-9bc5-f868954f4c28	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:10:06
37944	9d6b5dca-f5ce-473f-82fc-5886773d342a	9d6b5dca-fbda-4494-9bc5-f868954f4c28	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"148.57","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:10:06
37945	9d6b5dca-f648-41fa-bbfa-0ca05df6b286	9d6b5dca-fbda-4494-9bc5-f868954f4c28	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:10:06
37946	9d6b5dca-fa89-490e-8789-ee1dbafca2d0	9d6b5dca-fbda-4494-9bc5-f868954f4c28	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:10:06
37947	9d6b5dca-faca-412a-8e5f-079938931978	9d6b5dca-fbda-4494-9bc5-f868954f4c28	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:10:06
15177	9d5ecf1b-9f2d-4d43-b594-6bbcdf1ce4e9	9d5ecf1b-e43c-4949-babf-aac80ec190d4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-10-30 11:21:11
15178	9d5ecf1b-df45-47e0-a384-c92fcd7822b1	9d5ecf1b-e43c-4949-babf-aac80ec190d4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"146.72","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 11:21:11
15179	9d5ecf1b-dfa0-49f6-97b3-4333dfab6168	9d5ecf1b-e43c-4949-babf-aac80ec190d4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 11:21:11
15180	9d5ecf1b-e2fe-4789-9d73-176465f86385	9d5ecf1b-e43c-4949-babf-aac80ec190d4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-10-30 11:21:11
15181	9d5ecf1b-e34a-423d-8456-0e2f938ca211	9d5ecf1b-e43c-4949-babf-aac80ec190d4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":334,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:21:11
20932	9d66fe3a-2e3d-4d78-8442-51a30df2f2f0	9d66fe3a-3148-417d-ac49-a1f3d80adc22	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":169,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:59:34
25557	9d68c717-e831-4905-ab70-adfcdac9088f	9d68c718-0a63-4c4b-b3e0-6316734fa01d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:17:03
25558	9d68c718-08c7-4814-ad6f-734d41fc85a9	9d68c718-0a63-4c4b-b3e0-6316734fa01d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:17:04
25559	9d68c718-096e-4b06-9f5d-2ea9a844e727	9d68c718-0a63-4c4b-b3e0-6316734fa01d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":422,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:17:04
37948	9d6b5dcc-5868-4f6f-a838-21cbb953dd21	9d6b5dcc-7b89-439b-a54d-d2c4c601d44c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:10:07
20933	9d66fe3a-a68e-48cd-b33a-a437f5004706	9d66fe3a-a956-4327-ae4c-8c633aef98e1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":128,"memory":20,"hostname":"EderCortes"}	2024-11-03 12:59:34
25560	9d68c718-9f89-440d-931b-67c011edc57b	9d68c718-c43d-41f4-ac16-4c2debed2252	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:17:04
25561	9d68c718-b7e6-42a7-a7ca-ecb3275fc133	9d68c718-c43d-41f4-ac16-4c2debed2252	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"49.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:17:04
25562	9d68c718-bd78-4cb9-9c27-bd83c8a0c4d5	9d68c718-c43d-41f4-ac16-4c2debed2252	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"5.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:17:04
18841	9d669d4a-2dec-41cd-a3f0-faba50b374b2	9d669d4a-5281-496e-b8ca-cbfca3b2cca6	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 08:28:31
18842	9d669d4a-5086-4dba-9775-231c843e1a9c	9d669d4a-5281-496e-b8ca-cbfca3b2cca6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:28:31
18843	9d669d4a-514a-4bb4-9888-930f0fbb9d71	9d669d4a-5281-496e-b8ca-cbfca3b2cca6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":305,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:28:31
25563	9d68c718-bde2-455f-8e63-87a592d79466	9d68c718-c43d-41f4-ac16-4c2debed2252	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:17:04
25564	9d68c718-c2d9-4e2c-a600-2b17d978d655	9d68c718-c43d-41f4-ac16-4c2debed2252	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 10:17:04
25565	9d68c718-c33b-49c7-b5ce-57f1fc069fb0	9d68c718-c43d-41f4-ac16-4c2debed2252	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":424,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:17:04
37949	9d6b5dcc-7612-4fe7-ab48-fe1f4c7d36c9	9d6b5dcc-7b89-439b-a54d-d2c4c601d44c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:10:07
37950	9d6b5dcc-767d-413f-81f3-03c2d14f2f09	9d6b5dcc-7b89-439b-a54d-d2c4c601d44c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:10:07
37951	9d6b5dcc-7a3f-458e-bc9a-461f36472960	9d6b5dcc-7b89-439b-a54d-d2c4c601d44c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:10:07
17302	9d6552ca-ac24-4604-8073-04db29e3e5fc	9d6552ca-d71d-43d7-97db-4fc7c607b1c5	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 17:04:22
17303	9d6552ca-d4e1-477e-90b9-4bee3c7c05dc	9d6552ca-d71d-43d7-97db-4fc7c607b1c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:04:22
17304	9d6552ca-d5c9-4228-8061-5c297da2088f	9d6552ca-d71d-43d7-97db-4fc7c607b1c5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:04:22
37952	9d6b5dcc-7a86-4266-b7ee-ac6f5b034e78	9d6b5dcc-7b89-439b-a54d-d2c4c601d44c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":485,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:10:07
18465	9d66921d-95d8-4c01-befb-c4e5ffeeddc0	9d66921d-99e1-4fc6-a04f-119ec7cbb520	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":883}	2024-11-03 07:57:16
16203	9d64bab1-0261-4f60-8a63-9347527be4d8	9d64bab1-2458-497f-a375-e66a90798a0c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 09:59:04
16204	9d64bab1-221e-443e-9b1c-c18dc2072669	9d64bab1-2458-497f-a375-e66a90798a0c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 09:59:04
16205	9d64bab1-2309-4bb1-abee-98e72381aebb	9d64bab1-2458-497f-a375-e66a90798a0c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:59:04
16206	9d64bab1-6e1a-4158-9e55-fcfc4591c66e	9d64bab1-b87f-4ab3-af70-9d35af943cdc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 09:59:04
16207	9d64bab1-afb0-43e8-ae2e-72e3b23a9862	9d64bab1-b87f-4ab3-af70-9d35af943cdc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"156.06","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"088d1fdbe045a08c3b0073ef22c7da32","hostname":"EderCortes"}	2024-11-02 09:59:04
16208	9d64bab1-b31a-4449-a6f2-846c4cc85ca3	9d64bab1-b87f-4ab3-af70-9d35af943cdc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:59:04
16209	9d64bab1-b353-46e6-a5e4-336e4ce2a7b3	9d64bab1-b87f-4ab3-af70-9d35af943cdc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 09:59:04
16210	9d64bab1-b731-4bf0-8a1a-c6dac20d3828	9d64bab1-b87f-4ab3-af70-9d35af943cdc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 09:59:04
16211	9d64bab1-b7ab-42ad-83a1-fba257fcf367	9d64bab1-b87f-4ab3-af70-9d35af943cdc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:59:04
17305	9d6552cb-7323-461c-90ec-303642e81fa3	9d6552cb-9494-48cd-b85e-0da37353d287	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:04:23
17306	9d6552cb-8ea2-4a84-9611-27c0069b7194	9d6552cb-9494-48cd-b85e-0da37353d287	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"49.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":46,"hash":"fb4ded687569d92428336ceae5c6ffcd","hostname":"EderCortes"}	2024-11-02 17:04:23
17307	9d6552cb-92ed-4f20-9c22-d5e114d697ac	9d6552cb-9494-48cd-b85e-0da37353d287	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:04:23
17308	9d6552cb-9364-40ce-a651-b9c20ae80e04	9d6552cb-9494-48cd-b85e-0da37353d287	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":437,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:04:23
18844	9d669d4a-b63f-44f5-a7b3-da707f89e10b	9d669d4a-d41d-4e3d-815a-a03be1528d97	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:28:31
20934	9d66fe3b-20a3-4a7c-b2b3-f37f0452395a	9d66fe3b-2364-4501-a240-1c44604a6cbc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":133,"memory":20,"hostname":"EderCortes"}	2024-11-03 12:59:35
16212	9d64bab3-54cf-4ef4-ab7d-32aa5024a70e	9d64bab3-a012-44ca-bcd9-645ad9690b3c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 09:59:06
16213	9d64bab3-999e-4007-b6f8-52642e933ae9	9d64bab3-a012-44ca-bcd9-645ad9690b3c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"156.67","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 09:59:06
16214	9d64bab3-9a14-4e20-be0e-8acc99421330	9d64bab3-a012-44ca-bcd9-645ad9690b3c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 09:59:06
16215	9d64bab3-9e30-43a9-9fb2-da0ec675ba11	9d64bab3-a012-44ca-bcd9-645ad9690b3c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 09:59:06
16216	9d64bab3-9e96-4373-93c1-c7f31fa79700	9d64bab3-a012-44ca-bcd9-645ad9690b3c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":503,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:59:06
17309	9d6552cd-b428-4bd1-8cff-da502e29f16b	9d6552cd-d0d8-45c6-9cd1-9dcf5c804384	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:04:24
17310	9d6552cd-cbb1-4367-b01d-e2cc98c8c061	9d6552cd-d0d8-45c6-9cd1-9dcf5c804384	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 17:04:24
17311	9d6552cd-cbff-4991-841d-b1bd980cf91e	9d6552cd-d0d8-45c6-9cd1-9dcf5c804384	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 17:04:24
17312	9d6552cd-cf99-49aa-8414-ed7fdd70b2b0	9d6552cd-d0d8-45c6-9cd1-9dcf5c804384	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:04:24
17313	9d6552cd-cfe3-49cf-a856-37a7e2e89232	9d6552cd-d0d8-45c6-9cd1-9dcf5c804384	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:04:24
18845	9d669d4a-cec3-4dcd-9af0-f55023d6a90e	9d669d4a-d41d-4e3d-815a-a03be1528d97	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"45.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 08:28:31
18846	9d669d4a-d2ef-4f23-a5f3-2ad3c710bef4	9d669d4a-d41d-4e3d-815a-a03be1528d97	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:28:31
18847	9d669d4a-d33e-4bc2-acec-bae0547d785b	9d669d4a-d41d-4e3d-815a-a03be1528d97	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":272,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:28:31
18848	9d669d4d-473a-4154-9947-fe40376ea82d	9d669d4d-903e-4b41-a3f0-02d07d11136a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:28:33
18849	9d669d4d-8b69-4486-a07c-ab90fed1d935	9d669d4d-903e-4b41-a3f0-02d07d11136a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"154.91","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 08:28:33
18850	9d669d4d-8bc9-4c73-9d59-cb1e16a8fd87	9d669d4d-903e-4b41-a3f0-02d07d11136a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 08:28:33
18851	9d669d4d-8f14-4121-ad45-eda6afe7add7	9d669d4d-903e-4b41-a3f0-02d07d11136a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 08:28:33
18852	9d669d4d-8f55-45c6-ad63-f041f91f2770	9d669d4d-903e-4b41-a3f0-02d07d11136a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":339,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:28:33
20935	9d66fe3b-6f3b-4a7b-b522-8c594b821ffc	9d66fe3b-8991-4ef4-b994-b3d076b3c33c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:59:35
20936	9d66fe3b-852f-4738-8088-fbb2e17606c8	9d66fe3b-8991-4ef4-b994-b3d076b3c33c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ma%' or \\"users\\".\\"user_document\\"::text like '%Ma%') order by \\"users\\".\\"user_document\\" asc","time":"40.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 12:59:35
20937	9d66fe3b-8864-48cd-ba54-be71e8984e67	9d66fe3b-8991-4ef4-b994-b3d076b3c33c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:59:35
20938	9d66fe3b-88a5-4d27-85cd-0342c8bec40e	9d66fe3b-8991-4ef4-b994-b3d076b3c33c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ma"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":206,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:59:35
25455	9d68c2f3-7124-4993-bb93-eaddc5d27ef0	9d68c2f3-aa63-4058-abb3-38a3aa867727	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 10:05:28
25456	9d68c2f3-a777-45dc-b751-db4826c79db0	9d68c2f3-aa63-4058-abb3-38a3aa867727	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 10:05:29
25457	9d68c2f3-a8dc-4214-bc2d-70ad4c3bc37c	9d68c2f3-aa63-4058-abb3-38a3aa867727	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":643,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:05:29
18853	9d669db8-3d7e-4250-b7c8-d0371a3fdcb6	9d669db8-70b7-4a12-9b8f-7b803a4bdfdb	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 08:29:43
18854	9d669db8-5a7e-427e-899d-8ccf8bdc0a42	9d669db8-70b7-4a12-9b8f-7b803a4bdfdb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"47.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-03 08:29:43
18855	9d669db8-6a3f-41ad-bceb-68ebc46dbfda	9d669db8-70b7-4a12-9b8f-7b803a4bdfdb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 08:29:43
18856	9d669db8-6a71-405f-8929-6ec6cac0df35	9d669db8-70b7-4a12-9b8f-7b803a4bdfdb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 08:29:43
18857	9d669db8-6f10-4831-8540-b8eed08f982d	9d669db8-70b7-4a12-9b8f-7b803a4bdfdb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:29:43
18858	9d669db8-6f7c-412e-830e-e3e74c9f260d	9d669db8-70b7-4a12-9b8f-7b803a4bdfdb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:34:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"}]}},"duration":311,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:29:43
20939	9d66fe3b-cdb4-48a7-ab95-63839a79abee	9d66fe3b-d138-4e31-8d9f-ee03230e7e9c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":156,"memory":20,"hostname":"EderCortes"}	2024-11-03 12:59:35
25458	9d68c2f4-723b-4bfc-bb9c-ea95a83e957a	9d68c2f4-c8a6-4c63-b67e-79d58e6fd311	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 10:05:29
25459	9d68c2f4-bfa4-4dfd-8335-1087b934d0ed	9d68c2f4-c8a6-4c63-b67e-79d58e6fd311	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"176.06","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 10:05:29
25460	9d68c2f4-c66e-434e-9899-4a83582e9293	9d68c2f4-c8a6-4c63-b67e-79d58e6fd311	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 10:05:29
38110	9d6b5f51-1aef-4d23-ad24-7ab1f1be1f9a	9d6b5f51-5e36-4cec-a436-a0eaaef2d120	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 17:14:22
38111	9d6b5f51-5c39-402a-8a5f-02c7d2492301	9d6b5f51-5e36-4cec-a436-a0eaaef2d120	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-05 17:14:22
16278	9d64c06e-862d-42b6-a178-44421caaa406	9d64c06e-db6d-4ad1-8c5b-6ad4b36ab667	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 10:15:07
16279	9d64c06e-d8ed-4aec-8458-560ef8174203	9d64c06e-db6d-4ad1-8c5b-6ad4b36ab667	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 10:15:07
16280	9d64c06e-da24-4e13-9cba-575795d512d1	9d64c06e-db6d-4ad1-8c5b-6ad4b36ab667	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":514,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:15:07
38112	9d6b5f51-5cfb-4666-9652-1f903d6ed055	9d6b5f51-5e36-4cec-a436-a0eaaef2d120	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:14:22
16281	9d64c06f-4260-4d03-b393-1b53e0f1790b	9d64c06f-6815-4256-ae43-2ee2f0014851	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 10:15:08
16282	9d64c06f-5d2c-4c17-89b5-eccdc38c9373	9d64c06f-6815-4256-ae43-2ee2f0014851	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"50.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 10:15:08
16283	9d64c06f-61f6-493f-aa09-568dc6c7b508	9d64c06f-6815-4256-ae43-2ee2f0014851	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 10:15:08
16284	9d64c06f-622f-428d-be00-5ee340a2d380	9d64c06f-6815-4256-ae43-2ee2f0014851	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 10:15:08
16285	9d64c06f-66c5-49ca-a4bf-e7dd4b8cf905	9d64c06f-6815-4256-ae43-2ee2f0014851	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 10:15:08
16286	9d64c06f-6718-4e1f-8106-aaf0a3b66919	9d64c06f-6815-4256-ae43-2ee2f0014851	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":314,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:15:08
18859	9d669dc0-a149-4282-90d9-ed2cebe5bd3f	9d669dc0-bf5a-46db-a837-b5856f234ad3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:29:48
18860	9d669dc0-baa2-4fa9-93db-c3fd6e9b4a55	9d669dc0-bf5a-46db-a837-b5856f234ad3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"47.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 08:29:48
18861	9d669dc0-be08-45ee-ab14-0fbd57f01b68	9d669dc0-bf5a-46db-a837-b5856f234ad3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:29:48
18862	9d669dc0-be59-47a0-aa1b-5b5244f215e4	9d669dc0-bf5a-46db-a837-b5856f234ad3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":320,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:29:48
20940	9d66fe3c-2b10-4b98-a8db-1e9b46e42b95	9d66fe3c-4537-43d8-9f1f-916322729394	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:59:35
20941	9d66fe3c-4133-47bb-81af-d39ebdd8c081	9d66fe3c-4537-43d8-9f1f-916322729394	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mar%' or \\"users\\".\\"user_document\\"::text like '%Mar%') order by \\"users\\".\\"user_document\\" asc","time":"40.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 12:59:35
20942	9d66fe3c-440e-4d3a-b2fa-3c7ac18a18d8	9d66fe3c-4537-43d8-9f1f-916322729394	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:59:35
16287	9d64c071-5c6c-4542-b88b-66ffccf972ec	9d64c071-7960-4495-bf5e-b98af60dc9c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 10:15:09
16288	9d64c071-74ad-4ea0-8266-9f790da91e93	9d64c071-7960-4495-bf5e-b98af60dc9c2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 10:15:09
16289	9d64c071-7501-412e-9694-2ea2147b5365	9d64c071-7960-4495-bf5e-b98af60dc9c2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 10:15:09
16290	9d64c071-7817-4e26-8b5e-0256d0bb75da	9d64c071-7960-4495-bf5e-b98af60dc9c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 10:15:09
16291	9d64c071-7861-4b93-9a81-c8def42dbff9	9d64c071-7960-4495-bf5e-b98af60dc9c2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":305,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:15:09
20943	9d66fe3c-4450-4478-89d0-0fcda990dc02	9d66fe3c-4537-43d8-9f1f-916322729394	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mar"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:59:35
25461	9d68c2f4-c730-4cb3-8c34-72abe6cb76fd	9d68c2f4-c8a6-4c63-b67e-79d58e6fd311	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":660,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:05:29
38113	9d6b5f51-bba8-4891-b9d9-791a6fdf3a60	9d6b5f51-dbc6-4f91-a7f3-6d2e2b8a0780	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-05 17:14:22
25359	9d68c234-75a6-4456-9427-c9c3511e7a03	9d68c234-afd7-4a7f-b025-d62bb2b45c0f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:03:23
38114	9d6b5f51-d6e5-4da5-9dff-2a572216c1e0	9d6b5f51-dbc6-4f91-a7f3-6d2e2b8a0780	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"46.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:14:22
38115	9d6b5f51-da4d-40fb-abf1-7a413530e1ed	9d6b5f51-dbc6-4f91-a7f3-6d2e2b8a0780	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-05 17:14:22
20944	9d66fe3c-89ef-439d-a820-63d3a19a8233	9d66fe3c-a75e-44a9-aae8-9f54dc168bd8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:59:36
20945	9d66fe3c-a17e-4107-b3be-e5a83980ba58	9d66fe3c-a75e-44a9-aae8-9f54dc168bd8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"42.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 12:59:36
20946	9d66fe3c-a5ca-491b-9b1e-248483e2fa46	9d66fe3c-a75e-44a9-aae8-9f54dc168bd8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:59:36
20947	9d66fe3c-a62b-4122-afd1-f4e0d0cec40d	9d66fe3c-a75e-44a9-aae8-9f54dc168bd8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:59:36
25360	9d68c234-ac86-413f-b852-082d3ae84b49	9d68c234-afd7-4a7f-b025-d62bb2b45c0f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:03:23
25361	9d68c234-addc-40c2-ab31-cd3e2c6d48ba	9d68c234-afd7-4a7f-b025-d62bb2b45c0f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":592,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:03:23
25462	9d68c2f5-7be2-455b-8407-cfa8b3846318	9d68c2f5-bea3-408c-995e-bfce32ec14fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 10:05:30
25463	9d68c2f5-b0ab-4a80-929b-c771a4113f8e	9d68c2f5-bea3-408c-995e-bfce32ec14fb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"80.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:05:30
25464	9d68c2f5-b146-427e-8b2c-cf993dbc2da5	9d68c2f5-bea3-408c-995e-bfce32ec14fb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:05:30
25465	9d68c2f5-bafc-4b6c-ac2d-d61266e75d51	9d68c2f5-bea3-408c-995e-bfce32ec14fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 10:05:30
25466	9d68c2f5-bbb1-4420-baa8-8a45c473649e	9d68c2f5-bea3-408c-995e-bfce32ec14fb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":595,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:05:30
38116	9d6b5f51-dac7-4e3f-92f6-c77abde931a0	9d6b5f51-dbc6-4f91-a7f3-6d2e2b8a0780	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":267,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:14:22
20948	9d66fe3c-ed4f-4377-a7d0-e63cbd9c7b71	9d66fe3d-078a-4948-bd89-b0438a8e2193	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:59:36
20949	9d66fe3d-034f-42fd-81df-9ea2afa71a3a	9d66fe3d-078a-4948-bd89-b0438a8e2193	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"39.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 12:59:36
20950	9d66fe3d-0660-4601-869c-99239f1dd8c5	9d66fe3d-078a-4948-bd89-b0438a8e2193	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 12:59:36
20951	9d66fe3d-06a2-4a8e-8aa8-70ca3c6b0207	9d66fe3d-078a-4948-bd89-b0438a8e2193	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:59:36
25362	9d68c235-a009-4abf-91dc-630156de4389	9d68c235-d707-4726-aa25-7267e858d8e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:03:24
25363	9d68c235-cf12-4248-acce-0e017641b51b	9d68c235-d707-4726-aa25-7267e858d8e5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"81.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 10:03:24
25364	9d68c235-d505-4047-adc0-8c4228f83f7d	9d68c235-d707-4726-aa25-7267e858d8e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:03:24
25365	9d68c235-d5ae-4393-ad18-e0617fc9bb2d	9d68c235-d707-4726-aa25-7267e858d8e5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":660,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:03:24
25467	9d68c2f6-bede-444d-8a02-d9bd18b51963	9d68c2f7-11a7-4123-b78a-4b4340d2ac35	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 10:05:31
25468	9d68c2f7-0832-4333-ab6b-b2b71fdead45	9d68c2f7-11a7-4123-b78a-4b4340d2ac35	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"124.10","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:05:31
25469	9d68c2f7-08da-4348-91b1-d2d7430bd59b	9d68c2f7-11a7-4123-b78a-4b4340d2ac35	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:05:31
25470	9d68c2f7-0fa2-40fe-899a-e2577a1b7161	9d68c2f7-11a7-4123-b78a-4b4340d2ac35	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 10:05:31
25471	9d68c2f7-101f-43ca-ae03-040b03353d4a	9d68c2f7-11a7-4123-b78a-4b4340d2ac35	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":670,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:05:31
20952	9d66fe40-60b0-4b33-a6bf-ea7bc4f40d23	9d66fe40-7fd8-4f19-87f7-91cf40110fbb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 12:59:38
20953	9d66fe40-7a1a-4c2d-95c4-c7c780b7f384	9d66fe40-7fd8-4f19-87f7-91cf40110fbb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '19' and \\"users\\".\\"deleted_at\\" is null","time":"43.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":55,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-11-03 12:59:38
20954	9d66fe40-7a65-4cd1-849d-5782b796d07f	9d66fe40-7fd8-4f19-87f7-91cf40110fbb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 12:59:38
20955	9d66fe40-7e65-478e-84e2-7a9dbd1131aa	9d66fe40-7fd8-4f19-87f7-91cf40110fbb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 12:59:38
20956	9d66fe40-7ec6-4ce3-b64e-fbfbcd698a2b	9d66fe40-7fd8-4f19-87f7-91cf40110fbb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/19","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}},"duration":257,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:59:38
25366	9d68c236-de2f-4eed-b349-87f1945ea6be	9d68c237-9ab7-461a-980f-a4aaed81e6b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:03:25
25367	9d68c237-8e5d-46e4-8e26-85ca995fb9e9	9d68c237-9ab7-461a-980f-a4aaed81e6b9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"268.05","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:03:25
25368	9d68c237-8f0b-4ecc-a165-86dbe8038b29	9d68c237-9ab7-461a-980f-a4aaed81e6b9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:03:25
25369	9d68c237-986e-4a71-8c86-eaa86b8c1cb2	9d68c237-9ab7-461a-980f-a4aaed81e6b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:03:25
25370	9d68c237-9903-4cd5-ab7f-ea139c4862fd	9d68c237-9ab7-461a-980f-a4aaed81e6b9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1140,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:03:25
38117	9d6b5f52-2f9d-4803-a179-fef192a1c08d	9d6b5f52-584f-43e9-905f-361a90d4b674	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-05 17:14:22
38118	9d6b5f52-4f57-48ea-a2f1-8ce956994fe6	9d6b5f52-584f-43e9-905f-361a90d4b674	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"58.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:14:22
38119	9d6b5f52-50cc-4917-9e74-e630b7ae260d	9d6b5f52-584f-43e9-905f-361a90d4b674	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:14:22
38120	9d6b5f52-56fc-479a-9c96-1f10a46dae36	9d6b5f52-584f-43e9-905f-361a90d4b674	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-05 17:14:22
38121	9d6b5f52-5750-41ec-898f-6fdf4fb784b8	9d6b5f52-584f-43e9-905f-361a90d4b674	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":303,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:14:22
20957	9d66fe85-18b3-41c2-a485-351f65749ac1	9d66fe85-1ca1-4789-89aa-be83e0d2b385	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":215,"memory":22,"hostname":"EderCortes"}	2024-11-03 13:00:23
25371	9d68c238-739b-47bb-bc4f-d4c1bed16960	9d68c238-9f39-4eef-a426-43248841e786	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:03:26
25028	9d68bf66-14ff-4411-bcab-35bd30bc0cba	9d68bf66-3a01-4550-83c2-66af3aa79558	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 09:55:32
25029	9d68bf66-37fb-4e25-9705-e651913dfeab	9d68bf66-3a01-4550-83c2-66af3aa79558	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 09:55:33
25030	9d68bf66-38bb-48db-a2ef-7fe5ef143660	9d68bf66-3a01-4550-83c2-66af3aa79558	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":392,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:55:33
25372	9d68c238-94be-4ece-8449-5273e66a624a	9d68c238-9f39-4eef-a426-43248841e786	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"54.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:03:26
25373	9d68c238-9565-4b90-9ea3-ed07d8ce6214	9d68c238-9f39-4eef-a426-43248841e786	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:03:26
25374	9d68c238-9cf9-49e4-a043-f87bc62d7249	9d68c238-9f39-4eef-a426-43248841e786	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 10:03:26
25375	9d68c238-9d9c-4f2a-87a0-a159e3c7443e	9d68c238-9f39-4eef-a426-43248841e786	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":634,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:03:26
38122	9d6b5f52-b579-4234-8d43-fb742c274064	9d6b5f52-e5be-4074-ab36-c291bccb1a50	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-05 17:14:23
38123	9d6b5f52-dc1f-4ca6-ae00-57537be556de	9d6b5f52-e5be-4074-ab36-c291bccb1a50	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"69.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:14:23
38124	9d6b5f52-dc97-4d7a-924a-1d0ba495f18e	9d6b5f52-e5be-4074-ab36-c291bccb1a50	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:14:23
38125	9d6b5f52-e38b-4f97-a784-6584424e0caf	9d6b5f52-e5be-4074-ab36-c291bccb1a50	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-05 17:14:23
38126	9d6b5f52-e430-46e0-b70c-4daba651269d	9d6b5f52-e5be-4074-ab36-c291bccb1a50	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":344,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:14:23
20958	9d66fe85-d742-413e-811f-f5832a4f2810	9d66fe86-023f-40b7-963a-f63c4ec2d652	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 13:00:24
20959	9d66fe85-f1b1-462d-93c0-2c42d9fed843	9d66fe86-023f-40b7-963a-f63c4ec2d652	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\", \\"loans_fecha_ultimo_pago\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta 2', 'De las nieve', 'ds', 'CC', '1004655468', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon2', 'Calle 7505', '2000000', 25, 10, 'Q', null, '17-11-2024', 'Pendiente', '312596295', 12, 14, 19, 14, '17-11-2024', 0, 0, '17-11-2024', '2024-11-03 13:00:24', '2024-11-03 13:00:24') returning \\"id\\"","time":"5.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":105,"hash":"627b53ca897e623c432f1126c69a0881","hostname":"EderCortes"}	2024-11-03 13:00:24
20960	9d66fe85-f23a-4645-ada0-95fd3b221899	9d66fe86-023f-40b7-963a-f63c4ec2d652	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:64","hostname":"EderCortes"}	2024-11-03 13:00:24
20961	9d66fe85-f3b1-4427-93e1-13f18071c8f7	9d66fe86-023f-40b7-963a-f63c4ec2d652	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (64, 1, 200000, 50000, 'Pendiente', 'N\\/A', '03-12-2024', 12, 0, 0, '2024-11-03 13:00:24', '2024-11-03 13:00:24')","time":"2.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":157,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 13:00:24
20962	9d66fe85-f3de-4e8d-a1b1-7ef13d24fd47	9d66fe86-023f-40b7-963a-f63c4ec2d652	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 13:00:24
20963	9d66fe85-f483-46ae-8ba2-e60f2c09abdc	9d66fe86-023f-40b7-963a-f63c4ec2d652	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (64, 2, 200000, 50000, 'Pendiente', 'N\\/A', '19-12-2024', 12, 0, 0, '2024-11-03 13:00:24', '2024-11-03 13:00:24')","time":"0.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":157,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 13:00:24
20964	9d66fe85-f4bc-4c38-b76a-aafa6413ba9c	9d66fe86-023f-40b7-963a-f63c4ec2d652	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 13:00:24
20965	9d66fe85-f574-4c54-8f5a-fb012162e036	9d66fe86-023f-40b7-963a-f63c4ec2d652	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (64, 3, 200000, 50000, 'Pendiente', 'N\\/A', '04-01-2025', 12, 0, 0, '2024-11-03 13:00:24', '2024-11-03 13:00:24')","time":"0.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":157,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 13:00:24
20966	9d66fe85-f5b2-4a14-89a0-f96a61750b80	9d66fe86-023f-40b7-963a-f63c4ec2d652	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 13:00:24
20967	9d66fe85-f677-44d8-a636-6b9cc44d88db	9d66fe86-023f-40b7-963a-f63c4ec2d652	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (64, 4, 200000, 50000, 'Pendiente', 'N\\/A', '20-01-2025', 12, 0, 0, '2024-11-03 13:00:24', '2024-11-03 13:00:24')","time":"0.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":157,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 13:00:24
20968	9d66fe85-f6ab-4b66-9811-e9b79e51c7f4	9d66fe86-023f-40b7-963a-f63c4ec2d652	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 13:00:24
20969	9d66fe85-f768-49c7-b5cc-64c1523cf1e2	9d66fe86-023f-40b7-963a-f63c4ec2d652	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (64, 5, 200000, 50000, 'Pendiente', 'N\\/A', '05-02-2025', 12, 0, 0, '2024-11-03 13:00:24', '2024-11-03 13:00:24')","time":"0.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":157,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 13:00:24
20970	9d66fe85-f7ab-4ee2-bb72-9792becab861	9d66fe86-023f-40b7-963a-f63c4ec2d652	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 13:00:24
20971	9d66fe85-f886-40ca-bf02-74240c85238d	9d66fe86-023f-40b7-963a-f63c4ec2d652	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (64, 6, 200000, 50000, 'Pendiente', 'N\\/A', '21-02-2025', 12, 0, 0, '2024-11-03 13:00:24', '2024-11-03 13:00:24')","time":"0.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":157,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 13:00:24
20972	9d66fe85-f8bf-48e4-bd0a-ccf32c7675fa	9d66fe86-023f-40b7-963a-f63c4ec2d652	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 13:00:24
20973	9d66fe85-f985-4477-ad62-8d17aa4abe07	9d66fe86-023f-40b7-963a-f63c4ec2d652	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (64, 7, 200000, 50000, 'Pendiente', 'N\\/A', '09-03-2025', 12, 0, 0, '2024-11-03 13:00:24', '2024-11-03 13:00:24')","time":"0.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":157,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 13:00:24
20974	9d66fe85-f9c5-4d83-9784-aa00ae01fda6	9d66fe86-023f-40b7-963a-f63c4ec2d652	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 13:00:24
20975	9d66fe85-faf1-4f89-a968-60d87b32440a	9d66fe86-023f-40b7-963a-f63c4ec2d652	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (64, 8, 200000, 50000, 'Pendiente', 'N\\/A', '25-03-2025', 12, 0, 0, '2024-11-03 13:00:24', '2024-11-03 13:00:24')","time":"1.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":157,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 13:00:24
20976	9d66fe85-fb1c-4f39-9480-85883dd52250	9d66fe86-023f-40b7-963a-f63c4ec2d652	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 13:00:24
20977	9d66fe85-fba8-40c0-92ec-e9c26dd0c5e8	9d66fe86-023f-40b7-963a-f63c4ec2d652	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (64, 9, 200000, 50000, 'Pendiente', 'N\\/A', '10-04-2025', 12, 0, 0, '2024-11-03 13:00:24', '2024-11-03 13:00:24')","time":"0.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":157,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 13:00:24
20978	9d66fe85-fbd5-4191-bc2e-a1318a469e22	9d66fe86-023f-40b7-963a-f63c4ec2d652	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 13:00:24
20979	9d66fe85-fc52-46a3-ba0a-f7e4908e32e4	9d66fe86-023f-40b7-963a-f63c4ec2d652	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (64, 10, 200000, 50000, 'Pendiente', 'N\\/A', '26-04-2025', 12, 0, 0, '2024-11-03 13:00:24', '2024-11-03 13:00:24')","time":"0.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":157,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 13:00:24
20980	9d66fe85-fc7e-48b0-8ee5-769aadbf3d9b	9d66fe86-023f-40b7-963a-f63c4ec2d652	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 13:00:24
20981	9d66fe86-00b5-4f50-9879-aa4ec17e9c13	9d66fe86-023f-40b7-963a-f63c4ec2d652	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 13:00:24
20982	9d66fe86-0101-4c01-94b1-e0ce25938bbb	9d66fe86-023f-40b7-963a-f63c4ec2d652	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"797","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"1004655468","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_valor_prestado":"2000000","loans_intereses":25,"loans_cuotas":10,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":19,"user_recomendacion":14,"loans_inicio_pago":"17-11-2024","created_at":null,"updated_at":null,"deleted_at":null,"loans_pago_prestado":0,"loans_pago_interes":0},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Sun Nov 03 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":64},"duration":280,"memory":22,"hostname":"EderCortes"}	2024-11-03 13:00:24
25031	9d68bf66-ceba-4b4e-9666-8519cfcccb2a	9d68bf66-ee71-4fa8-ab16-c52ac8a5c303	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 09:55:33
25032	9d68bf66-e475-479a-a0a9-81a1c942d263	9d68bf66-ee71-4fa8-ab16-c52ac8a5c303	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"43.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 09:55:33
25033	9d68bf66-e838-4b8d-8d68-6d0158d45883	9d68bf66-ee71-4fa8-ab16-c52ac8a5c303	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"1.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:55:33
25034	9d68bf66-e896-4e3c-ae8d-223bc3580bf0	9d68bf66-ee71-4fa8-ab16-c52ac8a5c303	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 09:55:33
25035	9d68bf66-ed24-44dc-88dd-a9ddcbe2c248	9d68bf66-ee71-4fa8-ab16-c52ac8a5c303	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 09:55:33
38127	9d6b5f55-1f80-4959-a679-27199e625237	9d6b5f55-4d90-4b7c-8fa2-5df1dc5607b8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-05 17:14:24
14636	9d5ebef2-6b96-4090-bb43-864821f2bf5f	9d5ebef2-9d08-437a-b030-16e37577ad6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-30 10:36:00
14637	9d5ebef2-9a18-4f02-b72b-da0438697275	9d5ebef2-9d08-437a-b030-16e37577ad6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-30 10:36:00
14638	9d5ebef2-9b93-4afe-b028-4b9cb3cdb514	9d5ebef2-9d08-437a-b030-16e37577ad6b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":596,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:36:00
38128	9d6b5f55-45eb-427a-bffd-1ebd01190331	9d6b5f55-4d90-4b7c-8fa2-5df1dc5607b8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"59.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:14:24
38129	9d6b5f55-4658-4806-add1-f7df86c33779	9d6b5f55-4d90-4b7c-8fa2-5df1dc5607b8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:14:24
38130	9d6b5f55-4bcb-4a10-a5ce-3915c7b1821c	9d6b5f55-4d90-4b7c-8fa2-5df1dc5607b8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-05 17:14:24
25376	9d68c245-6f9f-478d-bd22-f95b4b08c139	9d68c245-8ef3-4393-950a-3e4a6769c762	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 10:03:34
38131	9d6b5f55-4c2c-4cbf-8f06-9035fd8d4d67	9d6b5f55-4d90-4b7c-8fa2-5df1dc5607b8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":529,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:14:24
20983	9d66fe89-1b6d-459e-b762-ddb33b5dfa7c	9d66fe89-3e58-460c-ba86-a89c8e774ccd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 13:00:26
38266	9d6b60a9-9b9c-4b0a-acdc-5021deeccb2d	9d6b60a9-bed9-414e-a69f-19b09d571e5f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 17:18:07
38267	9d6b60a9-bcde-4091-9bfc-e1347e2e560b	9d6b60a9-bed9-414e-a69f-19b09d571e5f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 17:18:07
38268	9d6b60a9-bd99-4be2-91c2-f54671a26787	9d6b60a9-bed9-414e-a69f-19b09d571e5f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:18:07
14639	9d5ebef3-25f3-416b-a971-1bbcfbdff66e	9d5ebef3-58a7-4f6c-9552-3a1d7d813db6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-30 10:36:00
14640	9d5ebef3-47c4-48b8-bec2-39415823a30c	9d5ebef3-58a7-4f6c-9552-3a1d7d813db6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 55\\n                        ","time":"66.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"ff7240abed4441475e0acd0c74a5f6aa","hostname":"EderCortes"}	2024-10-30 10:36:01
14641	9d5ebef3-4f98-405d-9874-c44b2fdff673	9d5ebef3-58a7-4f6c-9552-3a1d7d813db6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '55' order by \\"item_loans\\".\\"id\\" asc","time":"3.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-30 10:36:01
14642	9d5ebef3-4fea-47f8-84f0-b9fc43a9177c	9d5ebef3-58a7-4f6c-9552-3a1d7d813db6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":7,"hostname":"EderCortes"}	2024-10-30 10:36:01
14643	9d5ebef3-5707-465f-8585-327e46abaebc	9d5ebef3-58a7-4f6c-9552-3a1d7d813db6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-30 10:36:01
14644	9d5ebef3-5787-4d3f-9f71-f4fe2d1ae750	9d5ebef3-58a7-4f6c-9552-3a1d7d813db6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/55","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":55,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":7,"loans_valor_prestado":50000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"15-11-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":150,"loans_codigo":55,"itemloans_cuota":"1","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":151,"loans_codigo":55,"itemloans_cuota":"2","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":152,"loans_codigo":55,"itemloans_cuota":"3","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":153,"loans_codigo":55,"itemloans_cuota":"4","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":154,"loans_codigo":55,"itemloans_cuota":"5","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":155,"loans_codigo":55,"itemloans_cuota":"6","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":156,"loans_codigo":55,"itemloans_cuota":"7","itemloans_valor_cuota":"7142.8571428571","itemloans_iteres":"1250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:49:54.000000Z","updated_at":"2024-10-29T19:49:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":425,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:36:01
20984	9d66fe89-3672-41b4-a982-be9c226daec3	9d66fe89-3e58-460c-ba86-a89c8e774ccd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"50.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 13:00:26
20985	9d66fe89-3c1a-4626-be02-36ab4bd70cea	9d66fe89-3e58-460c-ba86-a89c8e774ccd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-03 13:00:26
15334	9d5ed0cd-084a-4b0b-b1a3-a36ffe37a7bf	9d5ed0cd-443b-453f-867b-aee5970590c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-30 11:25:55
15335	9d5ed0cd-4086-4736-bbc4-54606b955fae	9d5ed0cd-443b-453f-867b-aee5970590c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-30 11:25:55
20986	9d66fe89-3cbf-40f7-ac75-39685427d3a1	9d66fe89-3e58-460c-ba86-a89c8e774ccd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"28","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"17-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":null,"loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":294,"memory":22,"hostname":"EderCortes"}	2024-11-03 13:00:26
38269	9d6b60aa-1ff0-4373-9097-5b8f903930f1	9d6b60aa-3e6a-4ea9-82fc-201d4657fb6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 17:18:08
15336	9d5ed0cd-4208-42b7-9679-ef227bda7a6d	9d5ed0cd-443b-453f-867b-aee5970590c5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":498,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:25:55
25036	9d68bf66-ed6f-4bd1-91f9-89b048aca06e	9d68bf66-ee71-4fa8-ab16-c52ac8a5c303	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":352,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":353,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":354,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":355,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":417,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:55:33
25377	9d68c245-85fb-42b4-84c0-0392d9d01d11	9d68c245-8ef3-4393-950a-3e4a6769c762	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 90\\n                        ","time":"43.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"93c10371e33ace24260de21c3ff3890d","hostname":"EderCortes"}	2024-11-04 10:03:34
25378	9d68c245-89af-416c-9557-6debc53b6740	9d68c245-8ef3-4393-950a-3e4a6769c762	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"1.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:03:34
25379	9d68c245-89f3-4e50-ad40-b15263f03035	9d68c245-8ef3-4393-950a-3e4a6769c762	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 10:03:34
25380	9d68c245-8d91-4f76-bfdb-329331d67b79	9d68c245-8ef3-4393-950a-3e4a6769c762	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 10:03:34
25381	9d68c245-8de2-4fc5-aecf-853eec2a0b6c	9d68c245-8ef3-4393-950a-3e4a6769c762	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"}]}},"duration":388,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:03:34
38270	9d6b60aa-3955-457a-b4e0-14a62532dff3	9d6b60aa-3e6a-4ea9-82fc-201d4657fb6b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"46.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:18:08
38271	9d6b60aa-3cc7-470b-a195-d82aecc5a4d1	9d6b60aa-3e6a-4ea9-82fc-201d4657fb6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 17:18:08
15337	9d5ed0cd-c7a6-4de7-bf58-c65e1f812d6a	9d5ed0cd-f31d-44bf-873e-2d9a7717da77	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-30 11:25:56
15338	9d5ed0cd-eb10-4be7-b244-763968392688	9d5ed0cd-f31d-44bf-873e-2d9a7717da77	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"60.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 11:25:56
15339	9d5ed0cd-eb8a-476a-afa7-979aca9463eb	9d5ed0cd-f31d-44bf-873e-2d9a7717da77	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-30 11:25:56
15340	9d5ed0cd-f159-40ff-a9e4-c978407cdf82	9d5ed0cd-f31d-44bf-873e-2d9a7717da77	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-30 11:25:56
15341	9d5ed0cd-f1d3-484f-9330-0408a16fd82c	9d5ed0cd-f31d-44bf-873e-2d9a7717da77	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":387,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:25:56
38272	9d6b60aa-3d47-4445-963d-1e69d7c0d2cf	9d6b60aa-3e6a-4ea9-82fc-201d4657fb6b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":264,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:18:08
15342	9d5ed0ce-475c-43c4-8d4b-bf8c9899c3aa	9d5ed0ce-653b-4dac-89fb-80dbd8bffe2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-30 11:25:56
15343	9d5ed0ce-60c3-4ed6-b641-801cd930e432	9d5ed0ce-653b-4dac-89fb-80dbd8bffe2b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 11:25:56
15344	9d5ed0ce-610d-4cd7-94fa-ac530fd53abd	9d5ed0ce-653b-4dac-89fb-80dbd8bffe2b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-30 11:25:56
15345	9d5ed0ce-6424-4a6b-b0e2-d4ff9c77c3f9	9d5ed0ce-653b-4dac-89fb-80dbd8bffe2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-30 11:25:56
15346	9d5ed0ce-6467-4f40-a529-2e631d7b4d13	9d5ed0ce-653b-4dac-89fb-80dbd8bffe2b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:25:56
38273	9d6b60aa-9717-46c6-ae85-3856a0da6ba7	9d6b60aa-b855-4987-96c5-4945137c3f4c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 17:18:08
21211	9d6736f2-32dc-4da2-9952-ed95b3b48710	9d6736f2-6217-42b1-88aa-c6a7aa1f08cc	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 15:38:10
21212	9d6736f2-5fc2-46cc-a66f-c0be2bf61521	9d6736f2-6217-42b1-88aa-c6a7aa1f08cc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:38:10
21213	9d6736f2-60bd-47f7-bb61-c10504bdd11b	9d6736f2-6217-42b1-88aa-c6a7aa1f08cc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:38:10
38274	9d6b60aa-b27e-4f19-80e1-3ec538a3ca14	9d6b60aa-b855-4987-96c5-4945137c3f4c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:18:08
38275	9d6b60aa-b2fc-478d-9501-5e447acd86c0	9d6b60aa-b855-4987-96c5-4945137c3f4c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:18:08
38276	9d6b60aa-b6f4-4e4e-9a45-31761180876d	9d6b60aa-b855-4987-96c5-4945137c3f4c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 17:18:08
38277	9d6b60aa-b740-4869-8df5-11efc44a1403	9d6b60aa-b855-4987-96c5-4945137c3f4c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":298,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:18:08
21214	9d6736f2-cd69-4b07-96ee-2906578e9322	9d6736f3-1ba7-4daf-bd68-ccbfbcd5bac3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:38:10
21215	9d6736f3-0e8a-46d6-aee9-9d3c54615787	9d6736f3-1ba7-4daf-bd68-ccbfbcd5bac3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 65\\n                        ","time":"148.25","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6768d7067397538897aacf4d73c43049","hostname":"EderCortes"}	2024-11-03 15:38:10
21216	9d6736f3-12dd-498b-9364-1ce538f6d74e	9d6736f3-1ba7-4daf-bd68-ccbfbcd5bac3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '65' order by \\"item_loans\\".\\"id\\" asc","time":"2.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 15:38:10
21217	9d6736f3-131f-4b6e-93d3-29f10d39cd5d	9d6736f3-1ba7-4daf-bd68-ccbfbcd5bac3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 15:38:10
21218	9d6736f3-19ed-4396-8c07-ec1dde3df886	9d6736f3-1ba7-4daf-bd68-ccbfbcd5bac3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:38:10
21219	9d6736f3-1a57-481a-88f2-7c93cca4feed	9d6736f3-1ba7-4daf-bd68-ccbfbcd5bac3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/65","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":65,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":3000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-10 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":207,"loans_codigo":65,"itemloans_cuota":"1","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:02.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":208,"loans_codigo":65,"itemloans_cuota":"2","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":209,"loans_codigo":65,"itemloans_cuota":"3","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":210,"loans_codigo":65,"itemloans_cuota":"4","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":211,"loans_codigo":65,"itemloans_cuota":"5","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":212,"loans_codigo":65,"itemloans_cuota":"6","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":213,"loans_codigo":65,"itemloans_cuota":"7","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":214,"loans_codigo":65,"itemloans_cuota":"8","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":215,"loans_codigo":65,"itemloans_cuota":"9","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":216,"loans_codigo":65,"itemloans_cuota":"10","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-09-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":427,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:38:10
38278	9d6b60ab-0456-4a1c-81f4-6f7cda638504	9d6b60ab-4f2c-4725-bc27-d953e8800468	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 17:18:08
38279	9d6b60ab-4a00-4c09-b71c-8ddb259dc783	9d6b60ab-4f2c-4725-bc27-d953e8800468	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"153.43","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:18:08
38280	9d6b60ab-4a50-4d5f-8b2a-28b02b39366e	9d6b60ab-4f2c-4725-bc27-d953e8800468	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:18:08
38281	9d6b60ab-4dd6-4082-87b5-fcc866ce8bf7	9d6b60ab-4f2c-4725-bc27-d953e8800468	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 17:18:09
38282	9d6b60ab-4e18-404f-8057-ca044474cc04	9d6b60ab-4f2c-4725-bc27-d953e8800468	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":370,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:18:09
21220	9d6736f5-56a0-4b55-a74d-73346c4344c3	9d6736f5-8273-4d77-8cc2-5a21e1fb20c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:38:12
12788	9d5cecde-105e-4825-a91e-74c2e4e33578	9d5cecde-2e51-487d-9e23-e780892eb206	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 12:52:45
12789	9d5cecde-2c73-46a6-b7ad-8eb8e4543c51	9d5cecde-2e51-487d-9e23-e780892eb206	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-29 12:52:45
12790	9d5cecde-2d41-4c93-871f-4da65a594623	9d5cecde-2e51-487d-9e23-e780892eb206	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-10-29 12:52:45
21221	9d6736f5-7adc-4047-95dc-6a04ba629fe5	9d6736f5-8273-4d77-8cc2-5a21e1fb20c2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"61.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 15:38:12
21222	9d6736f5-7b5b-48b7-8e19-006d9860e26d	9d6736f5-8273-4d77-8cc2-5a21e1fb20c2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 15:38:12
21223	9d6736f5-80b0-4ac2-8220-7d52318b5d7e	9d6736f5-8273-4d77-8cc2-5a21e1fb20c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 15:38:12
21224	9d6736f5-811c-4588-8f8b-f70936e19e4f	9d6736f5-8273-4d77-8cc2-5a21e1fb20c2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":379,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:38:12
38283	9d6b60ad-10db-4c43-a828-bacd941be877	9d6b60ad-3f86-4bd1-b719-4e44e02226b3	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 17:18:10
38284	9d6b60ad-37f6-4622-855e-4d5114d7e029	9d6b60ad-3f86-4bd1-b719-4e44e02226b3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"47.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:18:10
38285	9d6b60ad-388b-45d7-98e9-0689afcd9737	9d6b60ad-3f86-4bd1-b719-4e44e02226b3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:18:10
38286	9d6b60ad-3db0-4063-ab6e-3eab84b6fd1f	9d6b60ad-3f86-4bd1-b719-4e44e02226b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:18:10
38287	9d6b60ad-3e3c-42dd-b300-a69ec57b894a	9d6b60ad-3f86-4bd1-b719-4e44e02226b3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":570,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:18:10
21225	9d673715-2254-4de7-a6bd-9bbc077b0067	9d673715-2579-4a05-80d9-941326c8fcf4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":155,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:38:33
25743	9d68c8f5-2c87-48df-a190-471bd1fee5cc	9d68c8f5-7086-4f49-a7c7-5a53414c626f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:22:16
25744	9d68c8f5-6d76-4187-8c6c-a7ac4dc3c65b	9d68c8f5-7086-4f49-a7c7-5a53414c626f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:22:16
25745	9d68c8f5-6eb7-4921-b9d9-2c73d3fa80bb	9d68c8f5-7086-4f49-a7c7-5a53414c626f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":663,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:22:16
25651	9d68c7b3-7b54-4345-83dc-e6b03289e98c	9d68c7b3-bdee-4ae5-8a46-7f184c760b4e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 10:18:45
25652	9d68c7b3-ba77-4414-b976-14239cb8d1b8	9d68c7b3-bdee-4ae5-8a46-7f184c760b4e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 10:18:46
25653	9d68c7b3-bc5e-49a1-a1ea-1b9854c65952	9d68c7b3-bdee-4ae5-8a46-7f184c760b4e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":652,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:18:46
18957	9d66cd9c-818b-4242-ade0-42a3965bc344	9d66cd9c-ced2-4ac5-9b36-4a0e90d864e6	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 10:43:38
18958	9d66cd9c-ccd1-4eb7-be22-44c359e48152	9d66cd9c-ced2-4ac5-9b36-4a0e90d864e6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 10:43:38
18959	9d66cd9c-cd9c-4efb-802c-0317b8c42569	9d66cd9c-ced2-4ac5-9b36-4a0e90d864e6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":346,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:43:38
25654	9d68c7b4-8794-46f5-9bd8-46dd93c65ae0	9d68c7b4-c327-4b3b-b935-2a5bfea937a0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 10:18:46
25655	9d68c7b4-b79f-44e3-bb16-c6d756cc2f7f	9d68c7b4-c327-4b3b-b935-2a5bfea937a0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"88.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 10:18:46
20212	9d66f01b-11cc-45ce-8dfb-a6d727e55dd2	9d66f01b-15b9-493e-beda-62007023b290	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1001}	2024-11-03 12:20:05
25656	9d68c7b4-c09e-4271-bcaf-38725725e661	9d68c7b4-c327-4b3b-b935-2a5bfea937a0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 10:18:46
25746	9d68c8f6-bf07-4dfd-ac44-2f75f568fd42	9d68c8f7-1bb3-49d2-911d-eadf8fe23d4d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:22:17
18960	9d66cd9d-44c1-492e-9978-0a39f733953c	9d66cd9d-68d5-4760-a6c2-4e98f0aa3c1e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 10:43:38
18961	9d66cd9d-5eac-4d34-ac34-56eecd2e67ff	9d66cd9d-68d5-4760-a6c2-4e98f0aa3c1e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"50.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-03 10:43:38
18962	9d66cd9d-62aa-45e6-b395-e9876fc8e486	9d66cd9d-68d5-4760-a6c2-4e98f0aa3c1e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 10:43:38
18963	9d66cd9d-62e5-4bc2-a194-e806c6ee7ef4	9d66cd9d-68d5-4760-a6c2-4e98f0aa3c1e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 10:43:38
18964	9d66cd9d-6789-48a7-8e3a-deada382109f	9d66cd9d-68d5-4760-a6c2-4e98f0aa3c1e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 10:43:38
18965	9d66cd9d-67dc-4766-bada-7e292c98f7ac	9d66cd9d-68d5-4760-a6c2-4e98f0aa3c1e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:34:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"}]}},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:43:38
21233	9d673716-6aa7-4f5e-9f5d-c37e81f3d171	9d673716-b501-4386-bc0f-a4a515da757b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 15:38:34
21234	9d673716-abb6-42c1-9814-ccb1b4ce11c6	9d673716-b501-4386-bc0f-a4a515da757b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 65\\n                        ","time":"154.30","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6768d7067397538897aacf4d73c43049","hostname":"EderCortes"}	2024-11-03 15:38:34
21235	9d673716-af6a-4424-a38d-e49a2f72ec58	9d673716-b501-4386-bc0f-a4a515da757b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '65' order by \\"item_loans\\".\\"id\\" asc","time":"2.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 15:38:34
21236	9d673716-af9f-47ac-b56f-520a875447e3	9d673716-b501-4386-bc0f-a4a515da757b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 15:38:34
21237	9d673716-b3a6-45ec-b81b-80f6e1c976ce	9d673716-b501-4386-bc0f-a4a515da757b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 15:38:34
18966	9d66cd9f-67be-41ed-8df4-6cb311320362	9d66cd9f-ab63-47a1-a95c-af76cf8f1761	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 10:43:40
18967	9d66cd9f-a601-44e3-b887-b1d9b5275611	9d66cd9f-ab63-47a1-a95c-af76cf8f1761	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"140.22","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 10:43:40
18968	9d66cd9f-a658-44de-a7b3-413cb551eee4	9d66cd9f-ab63-47a1-a95c-af76cf8f1761	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 10:43:40
18969	9d66cd9f-a9db-428a-a00e-ad94b320aea4	9d66cd9f-ab63-47a1-a95c-af76cf8f1761	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 10:43:40
18970	9d66cd9f-aa1e-4931-aba3-0952e8eb8cb4	9d66cd9f-ab63-47a1-a95c-af76cf8f1761	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:43:40
21238	9d673716-b400-41e9-906c-ca5dae011733	9d673716-b501-4386-bc0f-a4a515da757b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/65","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":65,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":3000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-10 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":207,"loans_codigo":65,"itemloans_cuota":"1","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:02.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":208,"loans_codigo":65,"itemloans_cuota":"2","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":209,"loans_codigo":65,"itemloans_cuota":"3","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":210,"loans_codigo":65,"itemloans_cuota":"4","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":211,"loans_codigo":65,"itemloans_cuota":"5","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":212,"loans_codigo":65,"itemloans_cuota":"6","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":213,"loans_codigo":65,"itemloans_cuota":"7","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":214,"loans_codigo":65,"itemloans_cuota":"8","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":215,"loans_codigo":65,"itemloans_cuota":"9","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":216,"loans_codigo":65,"itemloans_cuota":"10","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-09-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":355,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:38:34
25657	9d68c7b4-c174-485c-b585-804056cdb319	9d68c7b4-c327-4b3b-b935-2a5bfea937a0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":597,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:18:46
25747	9d68c8f7-0aa3-4cbb-805a-7a7143ba032a	9d68c8f7-1bb3-49d2-911d-eadf8fe23d4d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 90\\n                        ","time":"165.59","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"93c10371e33ace24260de21c3ff3890d","hostname":"EderCortes"}	2024-11-04 10:22:17
25658	9d68c7b5-a0c4-4ff3-8588-c0ce62476aca	9d68c7b5-e2fd-4a15-9ece-81eb0e139ae6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 10:18:47
25659	9d68c7b5-d8f8-4356-8c98-a996b477867e	9d68c7b5-e2fd-4a15-9ece-81eb0e139ae6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"83.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:18:47
25660	9d68c7b5-d983-40c3-be62-35049fc8c100	9d68c7b5-e2fd-4a15-9ece-81eb0e139ae6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:18:47
25661	9d68c7b5-e0f9-472d-a2f2-1c8e23304a54	9d68c7b5-e2fd-4a15-9ece-81eb0e139ae6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 10:18:47
25662	9d68c7b5-e188-4fa0-b656-310a1680f841	9d68c7b5-e2fd-4a15-9ece-81eb0e139ae6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":722,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:18:47
25748	9d68c8f7-11fc-4bc3-ae33-ef8c5846c22f	9d68c8f7-1bb3-49d2-911d-eadf8fe23d4d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"4.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:22:17
25749	9d68c8f7-1264-4017-b395-d5463452722e	9d68c8f7-1bb3-49d2-911d-eadf8fe23d4d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 10:22:17
25750	9d68c8f7-1927-4858-80e6-5dbeeea24e07	9d68c8f7-1bb3-49d2-911d-eadf8fe23d4d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:22:17
25751	9d68c8f7-19f8-47a3-8139-7efba9a542b5	9d68c8f7-1bb3-49d2-911d-eadf8fe23d4d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"}]}},"duration":974,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:22:17
25663	9d68c7b6-9a2c-4d94-b9bb-7dd8e3ec660f	9d68c7b6-cf20-4b46-a92e-c3951e2c1b6d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 10:18:47
25664	9d68c7b6-c4c1-4105-a110-4b5551e9c06a	9d68c7b6-cf20-4b46-a92e-c3951e2c1b6d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"73.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:18:48
25665	9d68c7b6-c561-42b8-8d9b-8bebed58151e	9d68c7b6-cf20-4b46-a92e-c3951e2c1b6d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:18:48
25666	9d68c7b6-cd10-4a77-bd3b-d2a8e31d9a96	9d68c7b6-cf20-4b46-a92e-c3951e2c1b6d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 10:18:48
25667	9d68c7b6-cda8-4bbb-9760-24e9b5a3981a	9d68c7b6-cf20-4b46-a92e-c3951e2c1b6d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":579,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:18:48
25752	9d68c8f8-d082-47b7-af46-001e14f519ba	9d68c8f9-5bef-48e6-8633-b78ce480dcc5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:22:19
25753	9d68c8f9-4fd0-477c-b71b-19c0243cb4a0	9d68c8f9-5bef-48e6-8633-b78ce480dcc5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"222.09","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:22:19
25754	9d68c8f9-5069-452a-9cf3-89e0571a3ca1	9d68c8f9-5bef-48e6-8633-b78ce480dcc5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:22:19
25755	9d68c8f9-58d0-469e-9e6a-86224760b3e8	9d68c8f9-5bef-48e6-8633-b78ce480dcc5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:22:19
25756	9d68c8f9-59a2-492c-8fec-b1dbe9c93115	9d68c8f9-5bef-48e6-8633-b78ce480dcc5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1448,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:22:19
25757	9d68c8fa-4657-4773-bd09-c1d255c87ab8	9d68c8fa-7b8d-4573-bf7a-0b3930d02f90	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:22:20
25758	9d68c8fa-7161-44fa-82b8-01522496a1bf	9d68c8fa-7b8d-4573-bf7a-0b3930d02f90	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"74.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:22:20
25759	9d68c8fa-71e7-4eff-a516-44be6099a52a	9d68c8fa-7b8d-4573-bf7a-0b3930d02f90	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:22:20
17461	9d655aca-7022-4080-bf83-2e68577e4a5e	9d655aca-bbd8-4ba3-b9ba-1eac82aef397	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 17:26:44
13751	9d5d0e7c-fd85-44b3-900d-dc3af863e7df	9d5d0e7d-482b-470f-a48a-65d6e5fe0bef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-29 14:26:45
13752	9d5d0e7d-4696-40b9-99f6-52b7e9acb64d	9d5d0e7d-482b-470f-a48a-65d6e5fe0bef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 14:26:46
13753	9d5d0e7d-4728-4b59-9cb2-280b2b63406f	9d5d0e7d-482b-470f-a48a-65d6e5fe0bef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:26:46
17462	9d655aca-b9ce-4eaf-968d-81a7c2781bdd	9d655aca-bbd8-4ba3-b9ba-1eac82aef397	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:26:44
17463	9d655aca-ba87-4a02-a000-36c4853041c5	9d655aca-bbd8-4ba3-b9ba-1eac82aef397	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":362,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:26:44
25760	9d68c8fa-7973-4fc0-9ca1-0d07ef9f2086	9d68c8fa-7b8d-4573-bf7a-0b3930d02f90	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:22:20
25761	9d68c8fa-7a04-42b8-8f50-6fae97c1d828	9d68c8fa-7b8d-4573-bf7a-0b3930d02f90	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":701,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:22:20
13754	9d5d0e7d-915b-42db-b93e-52d7a34ced0e	9d5d0e7d-d6cf-4ffb-b3b3-567ea8147154	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-29 14:26:46
13755	9d5d0e7d-ce33-4f41-90cd-d12b62fb584d	9d5d0e7d-d6cf-4ffb-b3b3-567ea8147154	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 52\\n                        ","time":"143.64","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":152,"hash":"b818d1825eff359c94d73944c3be2955","hostname":"EderCortes"}	2024-10-29 14:26:46
13756	9d5d0e7d-d1ab-4a57-9ff2-8439a5f8e3c7	9d5d0e7d-d6cf-4ffb-b3b3-567ea8147154	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '52' order by \\"item_loans\\".\\"id\\" asc","time":"2.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":180,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-29 14:26:46
13757	9d5d0e7d-d1db-490a-912b-9a7bcfb37f3e	9d5d0e7d-d6cf-4ffb-b3b3-567ea8147154	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":7,"hostname":"EderCortes"}	2024-10-29 14:26:46
13758	9d5d0e7d-d5a9-473a-9279-aa30896d10b6	9d5d0e7d-d6cf-4ffb-b3b3-567ea8147154	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 14:26:46
13759	9d5d0e7d-d5f4-40c6-a6ae-10cab820ae43	9d5d0e7d-d6cf-4ffb-b3b3-567ea8147154	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/52","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":52,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":7,"loans_valor_prestado":500000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"12-11-24","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":136,"loans_codigo":52,"itemloans_cuota":"1","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":137,"loans_codigo":52,"itemloans_cuota":"2","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0024-12-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":138,"loans_codigo":52,"itemloans_cuota":"3","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0024-12-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":139,"loans_codigo":52,"itemloans_cuota":"4","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0025-01-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":140,"loans_codigo":52,"itemloans_cuota":"5","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0025-01-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":141,"loans_codigo":52,"itemloans_cuota":"6","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0025-02-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":142,"loans_codigo":52,"itemloans_cuota":"7","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"0025-02-25 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:26:46
17464	9d655acb-488c-4cb7-9f75-6c0b77ad8ae6	9d655acb-64df-40ce-af7a-fb90f2be8565	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:26:45
17465	9d655acb-6015-49ba-b628-f94a3e35120d	9d655acb-64df-40ce-af7a-fb90f2be8565	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"44.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":46,"hash":"fb4ded687569d92428336ceae5c6ffcd","hostname":"EderCortes"}	2024-11-02 17:26:45
17466	9d655acb-63a7-4292-9856-ac1f35d974d9	9d655acb-64df-40ce-af7a-fb90f2be8565	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:26:45
17467	9d655acb-63f9-4478-9527-6a3dedfdc9c8	9d655acb-64df-40ce-af7a-fb90f2be8565	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":374,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:26:45
17468	9d655acc-d151-4e34-998f-0b70a03ee878	9d655acd-06e3-41e7-83c6-cc51ee50d51e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:26:46
17469	9d655acd-01c5-41fe-a881-83951a231fb2	9d655acd-06e3-41e7-83c6-cc51ee50d51e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"96.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 17:26:46
17470	9d655acd-0219-4991-97ac-028e8993ceba	9d655acd-06e3-41e7-83c6-cc51ee50d51e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 17:26:46
17471	9d655acd-058b-4e0d-954b-1c2b71528393	9d655acd-06e3-41e7-83c6-cc51ee50d51e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:26:46
17472	9d655acd-05d8-45db-ab87-b36cb34fd023	9d655acd-06e3-41e7-83c6-cc51ee50d51e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":436,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:26:46
16398	9d64c91c-e2bf-4bf8-8a7c-dde81b1b3394	9d64c91d-01cf-49c7-9631-9969233c0ea4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 10:39:24
16399	9d64c91d-0063-4089-ae24-0c3fb19be36b	9d64c91d-01cf-49c7-9631-9969233c0ea4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 10:39:24
16400	9d64c91d-00f6-4e7a-86d9-43cd095fb871	9d64c91d-01cf-49c7-9631-9969233c0ea4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:39:24
16401	9d64c91d-4d9e-48b4-aeb7-01366b59c3e5	9d64c91d-9736-4bf5-9cea-27ca754f579f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 10:39:24
16402	9d64c91d-8dea-40ed-a933-383600250ea9	9d64c91d-9736-4bf5-9cea-27ca754f579f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"151.46","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 10:39:24
16403	9d64c91d-9218-464f-9b2a-d20a60de25ad	9d64c91d-9736-4bf5-9cea-27ca754f579f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 10:39:24
16404	9d64c91d-9259-4494-bae4-4372a958c42b	9d64c91d-9736-4bf5-9cea-27ca754f579f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 10:39:24
16405	9d64c91d-9621-4808-a595-191b987b9473	9d64c91d-9736-4bf5-9cea-27ca754f579f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 10:39:24
16406	9d64c91d-966b-4ba2-aeb6-77f06d84d043	9d64c91d-9736-4bf5-9cea-27ca754f579f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:39:24
38879	9d6b707f-20e3-4d1b-9fa4-a0fae5409458	9d6b707f-7ae4-4baa-84db-0ac78ac4c2c0	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 18:02:24
38880	9d6b707f-7669-4c6d-a917-efbbc6de94f7	9d6b707f-7ae4-4baa-84db-0ac78ac4c2c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 18:02:24
38881	9d6b707f-78b5-44b1-8a7e-563ba1a8ab44	9d6b707f-7ae4-4baa-84db-0ac78ac4c2c0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":850,"memory":22,"hostname":"EderCortes"}	2024-11-05 18:02:24
16407	9d64c91e-cbf4-4af8-b274-b3204cd25956	9d64c91e-f761-475b-9d21-b5f53d8f73a9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 10:39:25
16408	9d64c91e-ee63-44b2-b0d5-3fcb8aa44e99	9d64c91e-f761-475b-9d21-b5f53d8f73a9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"56.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 10:39:25
16409	9d64c91e-eeec-4860-a71a-90c58b837b16	9d64c91e-f761-475b-9d21-b5f53d8f73a9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 10:39:25
16410	9d64c91e-f55d-4653-892e-961fa7b99f1a	9d64c91e-f761-475b-9d21-b5f53d8f73a9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 10:39:25
16411	9d64c91e-f5e5-4c67-a182-9116d759536f	9d64c91e-f761-475b-9d21-b5f53d8f73a9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":438,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:39:25
38882	9d6b707f-ec39-4e07-8388-578716ab3850	9d6b7080-0e8a-48b3-aac8-49f29a655b9d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 18:02:24
38883	9d6b7080-06b2-43d6-8e3b-00ecb38847e8	9d6b7080-0e8a-48b3-aac8-49f29a655b9d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"48.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 18:02:25
38884	9d6b7080-0cde-4275-8587-01013dd86635	9d6b7080-0e8a-48b3-aac8-49f29a655b9d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 18:02:25
38885	9d6b7080-0d62-4f13-b268-f0b209aed80b	9d6b7080-0e8a-48b3-aac8-49f29a655b9d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":309,"memory":22,"hostname":"EderCortes"}	2024-11-05 18:02:25
38623	9d6b67b2-f3f2-49a9-bcfd-4d8ed1cb5066	9d6b67b3-19cd-4c4a-a102-cce31862a01d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 17:37:48
38624	9d6b67b3-1786-4d96-995c-daf03ee500e1	9d6b67b3-19cd-4c4a-a102-cce31862a01d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:37:48
38625	9d6b67b3-186b-4a36-86f1-6b3136260c44	9d6b67b3-19cd-4c4a-a102-cce31862a01d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":276,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:37:48
38626	9d6b67b3-9ec9-4a35-8fb7-00c60069ddc1	9d6b67b3-bcf3-4908-b395-c53ee5f66cbf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:37:48
38627	9d6b67b3-b856-4740-a36e-b7715f99da91	9d6b67b3-bcf3-4908-b395-c53ee5f66cbf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"46.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":125,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:37:48
38628	9d6b67b3-bb73-412c-9071-5704349ef367	9d6b67b3-bcf3-4908-b395-c53ee5f66cbf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:37:48
38629	9d6b67b3-bc06-4804-8a4d-58b3dc101cc2	9d6b67b3-bcf3-4908-b395-c53ee5f66cbf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":278,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:37:48
38886	9d6b7080-6a89-4a4c-a535-e2548273fa84	9d6b7080-91e8-49ab-be73-afa28db6b4c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 18:02:25
38887	9d6b7080-8b45-458b-866e-582d28da171d	9d6b7080-91e8-49ab-be73-afa28db6b4c2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 18:02:25
38888	9d6b7080-8b9a-4264-a147-332f7641cc1e	9d6b7080-91e8-49ab-be73-afa28db6b4c2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 18:02:25
38889	9d6b7080-9075-403e-ae0f-f8f07f17f825	9d6b7080-91e8-49ab-be73-afa28db6b4c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 18:02:25
38890	9d6b7080-90d1-431a-833e-97f5265fa648	9d6b7080-91e8-49ab-be73-afa28db6b4c2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":326,"memory":22,"hostname":"EderCortes"}	2024-11-05 18:02:25
38630	9d6b67b4-18b0-429f-ae96-41a510ba9620	9d6b67b4-3866-4997-991c-3368c45b87ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:37:49
38631	9d6b67b4-32c5-4769-8058-62e6692cb062	9d6b67b4-3866-4997-991c-3368c45b87ea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:37:49
38632	9d6b67b4-331c-42b6-a5ca-5d9a1c93a6e0	9d6b67b4-3866-4997-991c-3368c45b87ea	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:37:49
38633	9d6b67b4-36d3-444e-8ca1-365e74515622	9d6b67b4-3866-4997-991c-3368c45b87ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:37:49
38634	9d6b67b4-3745-48fe-b78c-a8c451df271d	9d6b67b4-3866-4997-991c-3368c45b87ea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":301,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:37:49
38891	9d6b7080-d7fa-420b-8ab6-b69a64adfc65	9d6b7080-f6ea-47ff-90f6-8c722e8402bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 18:02:25
38892	9d6b7080-f1ba-4d00-86fc-4873161b68cd	9d6b7080-f6ea-47ff-90f6-8c722e8402bf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 18:02:25
38893	9d6b7080-f20c-4c48-8d93-b543956b9249	9d6b7080-f6ea-47ff-90f6-8c722e8402bf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 18:02:25
38894	9d6b7080-f597-4c8a-823a-0d804577894e	9d6b7080-f6ea-47ff-90f6-8c722e8402bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 18:02:25
38895	9d6b7080-f5db-4f0b-8712-5617614f0e75	9d6b7080-f6ea-47ff-90f6-8c722e8402bf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-11-05 18:02:25
15469	9d5ed331-e9ea-47d9-a537-6415b4e77b9a	9d5ed332-3fb2-4822-ba83-4e2674d2995b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-30 11:32:37
15470	9d5ed332-3ca9-4e67-b74d-6a7ba22eeb28	9d5ed332-3fb2-4822-ba83-4e2674d2995b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 11:32:37
15471	9d5ed332-3e76-485f-8f58-40621f016f2f	9d5ed332-3fb2-4822-ba83-4e2674d2995b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":497,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:32:37
19081	9d66cfe9-40d9-4566-ac45-9dfac32f85c7	9d66cfe9-90f9-4f1e-aa0d-a2be6ccf8754	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 10:50:03
19082	9d66cfe9-8e8e-40a4-b0d5-c2d64c200f1d	9d66cfe9-90f9-4f1e-aa0d-a2be6ccf8754	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 10:50:04
19083	9d66cfe9-8fa5-401c-9a47-a7108986dfda	9d66cfe9-90f9-4f1e-aa0d-a2be6ccf8754	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":407,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:50:04
38635	9d6b67b4-7c35-4713-a157-0a506805716b	9d6b67b4-98d8-4ece-8386-ca8c9ce7e315	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:37:49
38636	9d6b67b4-93fc-4d33-88f8-d2f73c34cf17	9d6b67b4-98d8-4ece-8386-ca8c9ce7e315	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:37:49
16472	9d64ccc6-086b-497a-81e4-1bf63de4b4cd	9d64ccc6-33cd-4f06-856c-4a3591a32328	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 10:49:38
16473	9d64ccc6-3134-4930-8a38-b7d039c678f4	9d64ccc6-33cd-4f06-856c-4a3591a32328	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 10:49:38
16474	9d64ccc6-3223-4a14-9a80-0e043aacf857	9d64ccc6-33cd-4f06-856c-4a3591a32328	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":366,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:49:38
25893	9d68cb46-771f-4293-991d-aabc28ee9d9e	9d68cb46-b500-4275-9d1a-18bad95ac363	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:28:45
25894	9d68cb46-b1e3-47d2-a57f-16a5e4d6f38a	9d68cb46-b500-4275-9d1a-18bad95ac363	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:28:45
25895	9d68cb46-b33a-4cc5-af6e-99e5639a20db	9d68cb46-b500-4275-9d1a-18bad95ac363	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1300,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:28:45
38637	9d6b67b4-944f-4ba9-a326-12beaad8b221	9d6b67b4-98d8-4ece-8386-ca8c9ce7e315	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:37:49
38638	9d6b67b4-9794-48a9-aea5-98936aee4cad	9d6b67b4-98d8-4ece-8386-ca8c9ce7e315	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:37:49
38639	9d6b67b4-97d6-4af7-984b-8d26bbbd2fef	9d6b67b4-98d8-4ece-8386-ca8c9ce7e315	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:37:49
38896	9d6b7082-f8cc-44c7-829a-50354c7ba4ff	9d6b7083-2a30-4a5f-8673-812a99e3eb7c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 18:02:26
38897	9d6b7083-1f40-4882-a965-ec1891555fc7	9d6b7083-2a30-4a5f-8673-812a99e3eb7c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"68.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 18:02:27
38898	9d6b7083-1fd8-459e-a5d6-d19ee112d36f	9d6b7083-2a30-4a5f-8673-812a99e3eb7c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 18:02:27
38899	9d6b7083-27eb-498c-b1d2-ff1c33b94d18	9d6b7083-2a30-4a5f-8673-812a99e3eb7c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 18:02:27
38900	9d6b7083-2892-48d8-8548-777e18025560	9d6b7083-2a30-4a5f-8673-812a99e3eb7c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":398,"memory":22,"hostname":"EderCortes"}	2024-11-05 18:02:27
16475	9d64ccc6-a6cc-49f6-99ac-c8c4d5569a1d	9d64ccc6-f829-49fd-be14-5341d674843c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 10:49:38
16476	9d64ccc6-ec28-4074-a261-cb617d450b0e	9d64ccc6-f829-49fd-be14-5341d674843c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"162.17","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 10:49:38
16477	9d64ccc6-f0ed-43a6-891f-dd93b8e299c7	9d64ccc6-f829-49fd-be14-5341d674843c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 10:49:38
16478	9d64ccc6-f12a-4bd7-bf23-2d61d7dc7902	9d64ccc6-f829-49fd-be14-5341d674843c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 10:49:38
16479	9d64ccc6-f646-4d86-961f-590091fec606	9d64ccc6-f829-49fd-be14-5341d674843c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 10:49:38
16480	9d64ccc6-f6cf-4a21-b563-9f1c02d58b7c	9d64ccc6-f829-49fd-be14-5341d674843c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":459,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:49:38
19084	9d66cfe9-fc38-4f62-8355-49502d95d43a	9d66cfea-47d3-4c9f-9d03-5df27156ee7f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 10:50:04
19085	9d66cfea-3abc-4c54-aceb-ec2333a89e4c	9d66cfea-47d3-4c9f-9d03-5df27156ee7f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"147.42","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 10:50:04
19086	9d66cfea-3f13-4b82-8e30-f37df3635f23	9d66cfea-47d3-4c9f-9d03-5df27156ee7f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 10:50:04
19087	9d66cfea-3f48-4cdf-8034-802d579adde9	9d66cfea-47d3-4c9f-9d03-5df27156ee7f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 10:50:04
19088	9d66cfea-4617-47fb-89b7-3887ca1190cd	9d66cfea-47d3-4c9f-9d03-5df27156ee7f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 10:50:04
19089	9d66cfea-467f-40e9-8c74-c9b5a7548faa	9d66cfea-47d3-4c9f-9d03-5df27156ee7f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T02:27:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"0"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":416,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:50:04
19090	9d66cfec-4811-44e5-a63a-df331021a1b1	9d66cfec-7462-4131-a812-a8a6f77d5eb3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 10:50:05
19091	9d66cfec-6c91-40f5-b47b-0aa707e98b45	9d66cfec-7462-4131-a812-a8a6f77d5eb3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"63.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 10:50:06
19092	9d66cfec-6d18-4a48-8ac3-8ea47c21246f	9d66cfec-7462-4131-a812-a8a6f77d5eb3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 10:50:06
19093	9d66cfec-7278-4f21-97ab-cb6782208819	9d66cfec-7462-4131-a812-a8a6f77d5eb3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 10:50:06
19094	9d66cfec-72d6-4630-b6db-079c036fa32b	9d66cfec-7462-4131-a812-a8a6f77d5eb3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":379,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:50:06
25896	9d68cb47-da70-473e-9c1b-a3692aa7f6de	9d68cb48-0ce0-4e16-b23c-098d336e1d81	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:28:46
25897	9d68cb47-fcc7-4913-b464-2994d1fb11c1	9d68cb48-0ce0-4e16-b23c-098d336e1d81	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 90\\n                        ","time":"65.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"93c10371e33ace24260de21c3ff3890d","hostname":"EderCortes"}	2024-11-04 10:28:46
25898	9d68cb48-0348-4142-b3fd-20c43281301e	9d68cb48-0ce0-4e16-b23c-098d336e1d81	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"3.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:28:46
25899	9d68cb48-03a2-46e0-b8a8-ab71a7909d82	9d68cb48-0ce0-4e16-b23c-098d336e1d81	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 10:28:46
25900	9d68cb48-0b09-44c4-9acd-405c070554f7	9d68cb48-0ce0-4e16-b23c-098d336e1d81	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:28:46
25901	9d68cb48-0b8b-4974-b7ce-9aae1e4e11f4	9d68cb48-0ce0-4e16-b23c-098d336e1d81	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"}]}},"duration":802,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:28:46
38640	9d6b67b6-9d04-4c09-8990-031a4d6ff5d5	9d6b67b6-bdbc-40c3-942f-b3c33208a57f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:37:50
38641	9d6b67b6-b792-4e75-a23a-2ad2c69b8d7f	9d6b67b6-bdbc-40c3-942f-b3c33208a57f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:37:50
38642	9d6b67b6-b7e3-4dac-a90b-9f4f36a12f93	9d6b67b6-bdbc-40c3-942f-b3c33208a57f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:37:50
25902	9d68cb49-5032-43bf-9218-2cc2835fd2e7	9d68cb49-ace1-4338-8d95-1adc2b540841	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:28:47
25903	9d68cb49-a120-4859-a1cf-4752608786b6	9d68cb49-ace1-4338-8d95-1adc2b540841	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"112.19","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:28:47
25904	9d68cb49-a1b6-410d-a690-d416ee9604e3	9d68cb49-ace1-4338-8d95-1adc2b540841	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:28:47
25905	9d68cb49-aac2-49eb-bd0a-a3db46f4fc34	9d68cb49-ace1-4338-8d95-1adc2b540841	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:28:47
25906	9d68cb49-ab5e-4356-ae8e-b2e6d3ec24bf	9d68cb49-ace1-4338-8d95-1adc2b540841	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1038,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:28:47
38643	9d6b67b6-bc40-42d0-a6ba-0c1a65d463d0	9d6b67b6-bdbc-40c3-942f-b3c33208a57f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:37:50
38644	9d6b67b6-bca3-4209-bc26-842a8033098d	9d6b67b6-bdbc-40c3-942f-b3c33208a57f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":422,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:37:50
38901	9d6b7083-a49c-4e66-bba5-64b37eed7bfa	9d6b7083-a86d-4b58-bf6c-bf65e5ffbafb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":278,"memory":22,"hostname":"EderCortes"}	2024-11-05 18:02:27
25907	9d68cb4a-961d-403a-baf2-1b86c4a8fe6f	9d68cb4b-1258-495e-980c-3c7619d43f31	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:28:48
25908	9d68cb4b-08ca-418d-8cbe-fed7a801d653	9d68cb4b-1258-495e-980c-3c7619d43f31	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"256.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:28:48
25909	9d68cb4b-0958-4440-8abc-ac6b31f27068	9d68cb4b-1258-495e-980c-3c7619d43f31	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:28:48
25910	9d68cb4b-1039-4684-bebc-6c4d56a8b448	9d68cb4b-1258-495e-980c-3c7619d43f31	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:28:48
25911	9d68cb4b-10d4-4c77-ac81-246f6d154f2b	9d68cb4b-1258-495e-980c-3c7619d43f31	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":871,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:28:48
38645	9d6b67b7-0bfc-42e7-955d-f26254608cee	9d6b67b7-2858-44b4-99d8-ab332e587e66	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:37:51
38646	9d6b67b7-2455-4633-8852-3cab287ce7f6	9d6b67b7-2858-44b4-99d8-ab332e587e66	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"45.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":125,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:37:51
38647	9d6b67b7-271d-4455-b615-23a242eb3c4e	9d6b67b7-2858-44b4-99d8-ab332e587e66	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:37:51
38648	9d6b67b7-2788-42d4-ae92-cf8dcab8f53c	9d6b67b7-2858-44b4-99d8-ab332e587e66	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"0","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:37:51
38902	9d6b7084-2085-4a3f-b305-be1bb837cd42	9d6b7084-3d73-4e20-bbc3-edc133b43610	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 18:02:27
38903	9d6b7084-38c1-4d78-9c46-64dfef28c7a6	9d6b7084-3d73-4e20-bbc3-edc133b43610	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"44.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 18:02:27
38904	9d6b7084-3bea-45f6-a77a-281923b898e9	9d6b7084-3d73-4e20-bbc3-edc133b43610	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 18:02:27
38905	9d6b7084-3c59-4a8e-9bfd-b04afe07c3e4	9d6b7084-3d73-4e20-bbc3-edc133b43610	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":219,"memory":22,"hostname":"EderCortes"}	2024-11-05 18:02:27
26013	9d68ccf5-55cb-41b5-ac06-00b7aec127e1	9d68ccf5-c347-45e7-8bde-fdd70dcb3822	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:33:27
26014	9d68ccf5-bf4a-436e-b38b-82834073952a	9d68ccf5-c347-45e7-8bde-fdd70dcb3822	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:33:28
26015	9d68ccf5-c0d9-461c-be14-a4417eaca295	9d68ccf5-c347-45e7-8bde-fdd70dcb3822	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":847,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:33:28
26016	9d68ccf6-c8e5-4e2a-b177-88cdab8e74b2	9d68ccf6-fbcf-4e79-a2b1-a56a20f1c842	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:33:28
26017	9d68ccf6-eaeb-42a8-b46c-a00dd5f5a802	9d68ccf6-fbcf-4e79-a2b1-a56a20f1c842	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"66.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:33:28
26018	9d68ccf6-f115-496a-a318-464df46b8efe	9d68ccf6-fbcf-4e79-a2b1-a56a20f1c842	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"4.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:33:28
26019	9d68ccf6-f196-42f5-90db-71c8b5ce3111	9d68ccf6-fbcf-4e79-a2b1-a56a20f1c842	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:33:28
26020	9d68ccf6-f968-4d9f-9f78-fe58bc391cb1	9d68ccf6-fbcf-4e79-a2b1-a56a20f1c842	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:33:28
26021	9d68ccf6-fa0a-4661-b451-8b4640feb966	9d68ccf6-fbcf-4e79-a2b1-a56a20f1c842	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":715,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:33:28
38649	9d6b67f2-d1c0-487d-a273-6328e0cb2746	9d6b67f2-d4d7-4815-9919-8942666613b1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":199,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:38:30
39512	9d6bdd96-c61a-4f88-9c26-69c5a4ad2ac6	9d6bdd96-f538-4d42-b7f6-59cfe0a9c09c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 23:07:27
39513	9d6bdd96-f30b-45eb-b165-f008e4e96b52	9d6bdd96-f538-4d42-b7f6-59cfe0a9c09c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 23:07:27
39514	9d6bdd96-f3ed-4eff-ae27-5863b4dab6df	9d6bdd96-f538-4d42-b7f6-59cfe0a9c09c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":395,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:07:27
19186	9d66d170-4afc-49b9-b708-1973523d710e	9d66d170-8f95-47ee-9c31-bcc4bc571775	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 10:54:20
19187	9d66d170-8dc8-4c94-a2e6-b37b51770d63	9d66d170-8f95-47ee-9c31-bcc4bc571775	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 10:54:20
19188	9d66d170-8e5a-46ad-abcc-11e5e195bb1f	9d66d170-8f95-47ee-9c31-bcc4bc571775	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":326,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:54:20
39515	9d6bdd97-5abf-41a7-95b2-7a137590ace2	9d6bdd97-790e-4b05-b072-20ef02cbe6cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 23:07:27
19189	9d66d170-db56-49e6-99c7-af9b715eb395	9d66d170-f8db-4aec-8e44-1eb576982e69	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 10:54:20
19190	9d66d170-f004-4489-b975-d1bad3d1cfae	9d66d170-f8db-4aec-8e44-1eb576982e69	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"41.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 10:54:20
19191	9d66d170-f3ee-45f6-8348-b08f89cae43e	9d66d170-f8db-4aec-8e44-1eb576982e69	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 10:54:20
19192	9d66d170-f420-40f7-aaa3-2a6c9521308a	9d66d170-f8db-4aec-8e44-1eb576982e69	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 10:54:20
19193	9d66d170-f7ae-4609-8c4e-a812865bf494	9d66d170-f8db-4aec-8e44-1eb576982e69	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 10:54:20
19194	9d66d170-f7f2-405e-9bb1-51564eace370	9d66d170-f8db-4aec-8e44-1eb576982e69	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T02:27:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"0"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:54:20
26022	9d68ccf7-cd9c-46b1-85d0-1eefea374791	9d68ccf8-0aa2-4f73-8bdc-4e50afdc1f4a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:33:29
26023	9d68ccf7-ff0d-47ca-b996-2357a8c0a0d9	9d68ccf8-0aa2-4f73-8bdc-4e50afdc1f4a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"82.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:33:29
26024	9d68ccf7-ffb3-4bd0-95f5-98ba10992d3d	9d68ccf8-0aa2-4f73-8bdc-4e50afdc1f4a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:33:29
26025	9d68ccf8-0827-4c00-8d49-68903c215da6	9d68ccf8-0aa2-4f73-8bdc-4e50afdc1f4a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:33:29
26026	9d68ccf8-08c2-42d8-8dc5-0724a16f9ebc	9d68ccf8-0aa2-4f73-8bdc-4e50afdc1f4a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":669,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:33:29
38650	9d6b67f3-9e7c-4eaa-9b6b-1f1284f1006c	9d6b67f3-a60c-4218-bcfc-7a0c9b4348ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:38:30
38651	9d6b67f3-a4c8-495a-aa6c-d0977f98e2b4	9d6b67f3-a60c-4218-bcfc-7a0c9b4348ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 17:38:30
19195	9d66d172-2aec-4913-891d-3c8bf9220604	9d66d172-7a99-47b7-884b-8ea81e173037	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 10:54:21
19196	9d66d172-741d-4b24-8d3c-07faa6c69f30	9d66d172-7a99-47b7-884b-8ea81e173037	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"160.49","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 10:54:21
19197	9d66d172-7480-4717-89d8-36b4b8c7bad6	9d66d172-7a99-47b7-884b-8ea81e173037	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 10:54:21
19198	9d66d172-792f-4bf5-bfe3-89b815cf8b3e	9d66d172-7a99-47b7-884b-8ea81e173037	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 10:54:21
19199	9d66d172-798f-49d9-8206-bcbc3509b64e	9d66d172-7a99-47b7-884b-8ea81e173037	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":500,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:54:21
26027	9d68ccf8-c8a4-47ef-8710-db848719cc8c	9d68ccf9-011e-44c8-832f-2ac442e83391	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:33:30
26028	9d68ccf8-f62e-479c-8b92-216d464d2477	9d68ccf9-011e-44c8-832f-2ac442e83391	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"76.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:33:30
26029	9d68ccf8-f6bf-48ac-8f7a-5c9bd7053064	9d68ccf9-011e-44c8-832f-2ac442e83391	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:33:30
26030	9d68ccf8-fed4-4f2b-a634-d7975c05fffd	9d68ccf9-011e-44c8-832f-2ac442e83391	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:33:30
26031	9d68ccf8-ff7f-4a73-8498-584561444528	9d68ccf9-011e-44c8-832f-2ac442e83391	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":602,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:33:30
38652	9d6b67f3-a509-4aad-836c-7116ad8960da	9d6b67f3-a60c-4218-bcfc-7a0c9b4348ff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":14,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":{"cobrador":14,"frecuencia":null,"estado":null,"prestamista":null}},"duration":226,"memory":20,"hostname":"EderCortes"}	2024-11-05 17:38:30
39516	9d6bdd97-7460-4191-9ef3-35316d48a8c0	9d6bdd97-790e-4b05-b072-20ef02cbe6cf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"49.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":89,"hash":"f9f3598e6ad2468770f89917d2ab916c","hostname":"EderCortes"}	2024-11-05 23:07:27
39517	9d6bdd97-77d5-4911-8936-98d45ad6b17a	9d6bdd97-790e-4b05-b072-20ef02cbe6cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 23:07:27
39211	9d6bcd8c-fb98-49a4-bae1-8e95f14ef7fa	9d6bcd8d-23b8-4e67-a9bc-f47041fe1288	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 22:22:36
39212	9d6bcd8d-21d4-48ef-b07a-5a4915345c4e	9d6bcd8d-23b8-4e67-a9bc-f47041fe1288	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 22:22:36
39213	9d6bcd8d-2291-48c8-8385-6de8374d0d0a	9d6bcd8d-23b8-4e67-a9bc-f47041fe1288	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":314,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:22:36
39214	9d6bcd8d-8eb2-4e73-a3d8-ad995d8e0bb2	9d6bcd8d-9632-4b69-82f6-c5d1882e8791	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 22:22:36
39215	9d6bcd8d-94fa-48a7-bcad-36bb0687ff14	9d6bcd8d-9632-4b69-82f6-c5d1882e8791	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 22:22:36
39216	9d6bcd8d-9558-421c-8c97-3236cd8f998c	9d6bcd8d-9632-4b69-82f6-c5d1882e8791	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null}},"duration":238,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:22:36
39518	9d6bdd97-7832-4a2e-9074-a41551e56016	9d6bdd97-790e-4b05-b072-20ef02cbe6cf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getLoansCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":281,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:07:27
38473	9d6b6516-5771-4147-896a-641926ee94ef	9d6b6516-7a05-441c-b388-e0cd8a4f6ed2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:30:30
38474	9d6b6516-784f-46e9-adce-2f65a8b2c5c5	9d6b6516-7a05-441c-b388-e0cd8a4f6ed2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:30:30
38475	9d6b6516-78e6-4f8d-b333-bf4d027a0e59	9d6b6516-7a05-441c-b388-e0cd8a4f6ed2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:30:30
38476	9d6b6516-d4c8-445b-8155-1d0ded54a121	9d6b6516-f433-4e44-9ed9-eddd87c7b7db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:30:30
38477	9d6b6516-ee3b-4641-8196-32a786b29091	9d6b6516-f433-4e44-9ed9-eddd87c7b7db	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"47.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:30:30
38478	9d6b6516-f264-4fad-89d5-e5596051971f	9d6b6516-f433-4e44-9ed9-eddd87c7b7db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 17:30:30
38479	9d6b6516-f302-4f6f-9cf8-dc18035494af	9d6b6516-f433-4e44-9ed9-eddd87c7b7db	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":257,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:30:30
39217	9d6bcd8e-0841-4c72-9baa-919a70299786	9d6bcd8e-2889-40b5-a99d-e854a18ecbbd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 22:22:36
39218	9d6bcd8e-2317-41e8-8e96-89eb72d7540e	9d6bcd8e-2889-40b5-a99d-e854a18ecbbd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:22:37
39219	9d6bcd8e-238c-4288-8c9e-276ac0e24f31	9d6bcd8e-2889-40b5-a99d-e854a18ecbbd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:22:37
39220	9d6bcd8e-2740-440c-a15e-8f8818d9d034	9d6bcd8e-2889-40b5-a99d-e854a18ecbbd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 22:22:37
39221	9d6bcd8e-2794-4f89-96c4-07ed820238be	9d6bcd8e-2889-40b5-a99d-e854a18ecbbd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":320,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:22:37
39519	9d6bdd97-bdac-44f0-bf47-82aaeb066aee	9d6bdd98-0486-4edc-9c69-e3d682342770	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 23:07:27
39520	9d6bdd97-fee9-4d76-b2f3-cc39416f1430	9d6bdd98-0486-4edc-9c69-e3d682342770	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"143.25","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 23:07:27
39521	9d6bdd97-ff3b-4422-8edb-4f5c0731c9ff	9d6bdd98-0486-4edc-9c69-e3d682342770	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 23:07:27
39522	9d6bdd98-035e-438d-8f09-9c612024d224	9d6bdd98-0486-4edc-9c69-e3d682342770	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 23:07:27
39523	9d6bdd98-03a5-47da-bd24-78e7b24bf218	9d6bdd98-0486-4edc-9c69-e3d682342770	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:07:27
38480	9d6b6517-3fe2-4322-ba15-cc043befaf05	9d6b6517-6add-4452-a1c7-705e1f76c1f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 17:30:30
38481	9d6b6517-63d5-469f-866b-d657ab42cb9f	9d6b6517-6add-4452-a1c7-705e1f76c1f5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"65.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:30:30
38482	9d6b6517-644a-42e3-a9fe-2bf5cb19ebba	9d6b6517-6add-4452-a1c7-705e1f76c1f5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:30:30
38483	9d6b6517-6998-468d-9619-0bcc6cb72532	9d6b6517-6add-4452-a1c7-705e1f76c1f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 17:30:30
38484	9d6b6517-69e5-43a9-ba74-5356a6ca242b	9d6b6517-6add-4452-a1c7-705e1f76c1f5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":288,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:30:30
39222	9d6bcd8e-6daa-4d83-ab88-1146bee6dbad	9d6bcd8e-8c93-4d95-af57-beb97e6f4bb0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 22:22:37
39223	9d6bcd8e-8717-4a59-a868-dd930dbd1347	9d6bcd8e-8c93-4d95-af57-beb97e6f4bb0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:22:37
39224	9d6bcd8e-8770-47e2-ba8a-c9a622c6c651	9d6bcd8e-8c93-4d95-af57-beb97e6f4bb0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:22:37
39225	9d6bcd8e-8b02-46b9-9ca2-abeed852659e	9d6bcd8e-8c93-4d95-af57-beb97e6f4bb0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 22:22:37
39226	9d6bcd8e-8b71-44ce-8ec5-b0b0059478b5	9d6bcd8e-8c93-4d95-af57-beb97e6f4bb0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:22:37
39524	9d6bdd98-586d-4567-be18-2b0f6b2496da	9d6bdd98-7ba6-4b0d-a9e5-88abf3a9eaf3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 23:07:28
39525	9d6bdd98-771f-4bed-87c6-bc15e2e259a4	9d6bdd98-7ba6-4b0d-a9e5-88abf3a9eaf3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 23:07:28
39526	9d6bdd98-7768-4f03-90e6-a0b7d607d64b	9d6bdd98-7ba6-4b0d-a9e5-88abf3a9eaf3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 23:07:28
39527	9d6bdd98-7aa9-48c2-bc4b-aff54fe486c7	9d6bdd98-7ba6-4b0d-a9e5-88abf3a9eaf3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 23:07:28
39528	9d6bdd98-7ae7-41a8-bd3f-06642b312d52	9d6bdd98-7ba6-4b0d-a9e5-88abf3a9eaf3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":291,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:07:28
38485	9d6b6517-b724-4efa-bda2-30608b262610	9d6b6517-d688-4857-9b3e-375e14073611	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 17:30:31
38486	9d6b6517-d130-4eba-937a-422e7a3dfc5d	9d6b6517-d688-4857-9b3e-375e14073611	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:30:31
38487	9d6b6517-d17d-4ba8-8365-de8adfb8b58d	9d6b6517-d688-4857-9b3e-375e14073611	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:30:31
38488	9d6b6517-d528-4929-9955-b688ae800d29	9d6b6517-d688-4857-9b3e-375e14073611	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 17:30:31
19276	9d66d2f5-f856-466e-b073-6cf34ae7c0b4	9d66d2f6-1a4d-4b20-a843-8dc323e61a96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 10:58:35
19277	9d66d2f6-1853-4942-8032-3b920f08fa5d	9d66d2f6-1a4d-4b20-a843-8dc323e61a96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 10:58:35
19278	9d66d2f6-1917-4c0b-9fb8-5b67f18687b8	9d66d2f6-1a4d-4b20-a843-8dc323e61a96	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":269,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:58:35
38489	9d6b6517-d576-4332-bc3a-38473a4a6b21	9d6b6517-d688-4857-9b3e-375e14073611	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":255,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:30:31
39227	9d6bcd90-400f-4869-ac56-9b9a5219b2a6	9d6bcd90-5dbb-4ee0-b458-a9c8f617c36f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 22:22:38
39228	9d6bcd90-5889-4b49-b240-555352ffa420	9d6bcd90-5dbb-4ee0-b458-a9c8f617c36f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 22:22:38
39229	9d6bcd90-58cf-4d2a-aad1-49e8af861d4d	9d6bcd90-5dbb-4ee0-b458-a9c8f617c36f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 22:22:38
39230	9d6bcd90-5c55-4b93-81cf-088ec0c81746	9d6bcd90-5dbb-4ee0-b458-a9c8f617c36f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 22:22:38
39231	9d6bcd90-5cb3-4d48-9d4c-c84bd4c31b12	9d6bcd90-5dbb-4ee0-b458-a9c8f617c36f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":425,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:22:38
39529	9d6bdd9a-341f-4081-b835-0c772a3dccc0	9d6bdd9a-6ca5-47b1-877d-48fc74a51523	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 23:07:29
39530	9d6bdd9a-65f3-4426-9645-f879703f18f8	9d6bdd9a-6ca5-47b1-877d-48fc74a51523	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"59.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 23:07:29
39531	9d6bdd9a-665a-48ac-aab9-a23acb83fee2	9d6bdd9a-6ca5-47b1-877d-48fc74a51523	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 23:07:29
39532	9d6bdd9a-6acc-4b83-9691-bcb3fe7ff633	9d6bdd9a-6ca5-47b1-877d-48fc74a51523	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 23:07:29
19279	9d66d2f6-7220-4642-b693-58e1c5b916cd	9d66d2f6-9577-4c17-ba87-dc3f203a20c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 10:58:35
19280	9d66d2f6-8b6d-4736-8a4e-b50f2c377659	9d66d2f6-9577-4c17-ba87-dc3f203a20c8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"50.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 10:58:35
19281	9d66d2f6-900d-4da6-9532-1b7563766bda	9d66d2f6-9577-4c17-ba87-dc3f203a20c8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 10:58:35
19282	9d66d2f6-9054-4c09-ae72-3d4b8a8243b9	9d66d2f6-9577-4c17-ba87-dc3f203a20c8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 10:58:35
19283	9d66d2f6-942f-4fa0-aded-69b66f2ba59e	9d66d2f6-9577-4c17-ba87-dc3f203a20c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 10:58:36
19284	9d66d2f6-9485-4e89-9056-e535719d3ea2	9d66d2f6-9577-4c17-ba87-dc3f203a20c8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T02:27:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"0"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":269,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:58:36
26174	9d68ceba-eda5-43cc-9475-4dc8148b914a	9d68cebb-3b76-4145-b69c-cd42575c1304	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:38:25
26175	9d68cebb-3871-43f3-8d75-2a8e4187c27c	9d68cebb-3b76-4145-b69c-cd42575c1304	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:38:25
26176	9d68cebb-39c3-40d2-b15a-5168a5ba846d	9d68cebb-3b76-4145-b69c-cd42575c1304	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":994,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:38:25
38490	9d6b6519-b44a-43f8-80df-8c0986dc93ef	9d6b6519-d2e1-41cc-b1fd-e67f53296646	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 17:30:32
38491	9d6b6519-cd26-42e6-978e-c891cad75bbc	9d6b6519-d2e1-41cc-b1fd-e67f53296646	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:30:32
38492	9d6b6519-cd80-4123-9007-373060ca248d	9d6b6519-d2e1-41cc-b1fd-e67f53296646	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:30:32
38493	9d6b6519-d186-4682-bce5-616473871980	9d6b6519-d2e1-41cc-b1fd-e67f53296646	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 17:30:32
38494	9d6b6519-d1ce-48b5-aeaa-accc4f8158c9	9d6b6519-d2e1-41cc-b1fd-e67f53296646	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":306,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:30:32
19285	9d66d2f8-1a1a-4f9a-9276-8a90534d9c02	9d66d2f8-6d57-479f-9520-ba03c3464823	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 10:58:37
19286	9d66d2f8-61a1-47f1-a0ea-703747196933	9d66d2f8-6d57-479f-9520-ba03c3464823	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"135.12","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 10:58:37
19287	9d66d2f8-624c-4874-b343-a86ec36055e2	9d66d2f8-6d57-479f-9520-ba03c3464823	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 10:58:37
19288	9d66d2f8-6aed-4a8a-adc8-9d39b4d9d606	9d66d2f8-6d57-479f-9520-ba03c3464823	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 10:58:37
19289	9d66d2f8-6b99-4078-a979-80f347d35cbe	9d66d2f8-6d57-479f-9520-ba03c3464823	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":517,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:58:37
26177	9d68cebc-8a13-4823-81a3-22f1119ab14e	9d68cebc-b70b-4706-afcc-35b63d197033	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:38:26
26178	9d68cebc-a927-4ff5-be2c-fc14c745eec1	9d68cebc-b70b-4706-afcc-35b63d197033	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"60.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:38:26
26179	9d68cebc-aed7-45be-a1ff-33357c282722	9d68cebc-b70b-4706-afcc-35b63d197033	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"3.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:38:26
26180	9d68cebc-af21-4400-859c-c8b03330d799	9d68cebc-b70b-4706-afcc-35b63d197033	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:38:26
26181	9d68cebc-b575-4204-b3d9-c703ea8ae162	9d68cebc-b70b-4706-afcc-35b63d197033	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:38:26
26182	9d68cebc-b5d7-49f8-8da0-182db78c3122	9d68cebc-b70b-4706-afcc-35b63d197033	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":889,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:38:26
38495	9d6b6533-060c-4220-a974-438a1b152576	9d6b6533-251a-4bda-a680-91dd4fdbfec1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 17:30:49
39232	9d6bcd90-a576-445b-b187-941e1e006781	9d6bcd90-a897-4636-aba4-6e3b43ad6713	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":162,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:22:38
26183	9d68cebd-a79f-4ef9-81b7-2edf71341907	9d68cebd-f29e-4e16-855d-ce6fb9030c19	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:38:26
26184	9d68cebd-e6a8-4d06-a939-c065c532e034	9d68cebd-f29e-4e16-855d-ce6fb9030c19	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"99.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:38:27
26185	9d68cebd-e763-4d08-be29-3aa67a8004b2	9d68cebd-f29e-4e16-855d-ce6fb9030c19	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:38:27
26186	9d68cebd-f011-4a6d-bdd6-c647393d5358	9d68cebd-f29e-4e16-855d-ce6fb9030c19	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:38:27
26187	9d68cebd-f0c3-488c-a87d-9c270ff9115b	9d68cebd-f29e-4e16-855d-ce6fb9030c19	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":787,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:38:27
38496	9d6b6533-2034-4251-9a2f-b7c2d5d65062	9d6b6533-251a-4bda-a680-91dd4fdbfec1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"47.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:30:49
38497	9d6b6533-239c-43fc-a0d1-504dedb12040	9d6b6533-251a-4bda-a680-91dd4fdbfec1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 17:30:49
38498	9d6b6533-2418-4461-aee6-4ef30ec2ba64	9d6b6533-251a-4bda-a680-91dd4fdbfec1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":272,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:30:49
39233	9d6bcd90-faea-43e8-b24b-c50b604e6cdb	9d6bcd91-027b-405d-b2b5-9e5739171cf8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 22:22:38
39234	9d6bcd91-0081-4bfe-8b0b-c495ade928ec	9d6bcd91-027b-405d-b2b5-9e5739171cf8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 22:22:38
39235	9d6bcd91-00f1-4d95-adf3-6230b813639a	9d6bcd91-027b-405d-b2b5-9e5739171cf8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null}},"duration":164,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:22:38
39533	9d6bdd9a-6b4a-4f66-9ca4-37df32fed9b1	9d6bdd9a-6ca5-47b1-877d-48fc74a51523	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":436,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:07:29
26188	9d68cebe-a5f6-4760-9f55-ba8b4c21657b	9d68cebe-d6ca-4c42-9a6c-e36a7c62fd72	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:38:27
26189	9d68cebe-ccab-4a6c-bad7-16e3a1c0712a	9d68cebe-d6ca-4c42-9a6c-e36a7c62fd72	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"65.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:38:27
26190	9d68cebe-cd26-47cd-a72e-567553c6850c	9d68cebe-d6ca-4c42-9a6c-e36a7c62fd72	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:38:27
26191	9d68cebe-d4af-4cd0-a2c5-4998fc155726	9d68cebe-d6ca-4c42-9a6c-e36a7c62fd72	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:38:27
26192	9d68cebe-d54a-4d8a-9111-d9ae17f49e27	9d68cebe-d6ca-4c42-9a6c-e36a7c62fd72	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":554,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:38:27
39236	9d6bcd97-c608-4bdd-b3f4-dc4f5bfd4924	9d6bcd97-c977-4acf-b607-13160d69a3b1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":149,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:22:43
26282	9d68d053-e377-486b-815e-196d9cfb45d3	9d68d054-acdb-41a1-8252-2c4126df04c7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:42:53
26283	9d68d054-a99e-4710-a809-9e1521c16993	9d68d054-acdb-41a1-8252-2c4126df04c7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:42:53
26284	9d68d054-ab53-46db-995d-873e3cb504ea	9d68d054-acdb-41a1-8252-2c4126df04c7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1097,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:42:53
39534	9d6bdd9a-bc17-4677-ba65-ec821eccab76	9d6bdd9a-bf15-4eb1-a2dd-03d84ee2af91	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":174,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:07:29
26285	9d68d055-a749-4640-a042-24c914e655cc	9d68d055-d322-41a7-9cbe-4402de2b09e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:42:54
26286	9d68d055-c544-4bf6-9adf-3b72f16bd80a	9d68d055-d322-41a7-9cbe-4402de2b09e4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"54.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:42:54
26287	9d68d055-cc62-42da-ae30-f0bf24d69a8f	9d68d055-d322-41a7-9cbe-4402de2b09e4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:42:54
26288	9d68d055-cc9e-42a4-8146-0ceb5a50dbe9	9d68d055-d322-41a7-9cbe-4402de2b09e4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:42:54
26289	9d68d055-d1a6-4be7-971e-ee4b840fa53a	9d68d055-d322-41a7-9cbe-4402de2b09e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:42:54
26290	9d68d055-d208-4874-a2b3-f66ec8ee56c6	9d68d055-d322-41a7-9cbe-4402de2b09e4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":664,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:42:54
39237	9d6bcd98-4c54-4918-abbd-95a6edfb254f	9d6bcd98-52fa-42fb-9b6c-5efffbdf960f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 22:22:43
39238	9d6bcd98-51e0-408c-be54-9d36d45cdd63	9d6bcd98-52fa-42fb-9b6c-5efffbdf960f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 22:22:43
39239	9d6bcd98-5221-4b0c-9605-2c9dfcb34693	9d6bcd98-52fa-42fb-9b6c-5efffbdf960f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":14,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":{"cobrador":14,"frecuencia":null,"estado":null,"prestamista":null}},"duration":183,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:22:43
39535	9d6bdd9b-111d-4513-82d8-5d736b6df78b	9d6bdd9b-2b87-43ae-9d54-2d96b9969a9a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 23:07:29
39536	9d6bdd9b-2738-4f4c-b192-6a3268147451	9d6bdd9b-2b87-43ae-9d54-2d96b9969a9a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"40.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":89,"hash":"f9f3598e6ad2468770f89917d2ab916c","hostname":"EderCortes"}	2024-11-05 23:07:29
39537	9d6bdd9b-2a22-4f95-8333-d5a5b780055f	9d6bdd9b-2b87-43ae-9d54-2d96b9969a9a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 23:07:29
39240	9d6bcda1-b65c-4e16-abbb-1410eb989db3	9d6bcda1-ba05-4be0-bbb8-9d66e138a598	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":310,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:22:49
21531	9d673ba6-2390-4640-9fa0-80dbacbd5790	9d673ba6-5548-464c-8dd8-cc6bc256fac2	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 15:51:19
21532	9d673ba6-52f7-4717-949e-14197c1c0dbe	9d673ba6-5548-464c-8dd8-cc6bc256fac2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:51:19
21533	9d673ba6-53f4-4d0d-b1a1-4d824d1af513	9d673ba6-5548-464c-8dd8-cc6bc256fac2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":626,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:51:19
39538	9d6bdd9b-2a7e-4e4a-8252-da07fd64f5fa	9d6bdd9b-2b87-43ae-9d54-2d96b9969a9a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getLoansCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":214,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:07:29
26291	9d68d056-a552-49dd-b97a-25032ecfeb90	9d68d056-ebf1-4c04-b366-1da7d2973787	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:42:55
26292	9d68d056-e205-48d1-8741-4981dff68dab	9d68d056-ebf1-4c04-b366-1da7d2973787	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"90.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:42:55
26293	9d68d056-e2a3-4827-ae6e-2a8ec5df6646	9d68d056-ebf1-4c04-b366-1da7d2973787	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:42:55
26294	9d68d056-e9d0-4386-8d9d-938ad2c903c7	9d68d056-ebf1-4c04-b366-1da7d2973787	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:42:55
21534	9d673ba6-c8c5-4371-a3e6-693aaa202837	9d673ba7-0aad-472a-b5d4-213b790cca27	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:51:19
17731	9d6561ce-4b03-42c9-85ec-60ac149c3670	9d6561ce-6f23-4aea-b561-848abe05ebb4	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 17:46:21
17732	9d6561ce-6d49-4590-8e1f-15fb5a022034	9d6561ce-6f23-4aea-b561-848abe05ebb4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:46:21
17733	9d6561ce-6e00-4e2d-9270-a5e314dd8a77	9d6561ce-6f23-4aea-b561-848abe05ebb4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":308,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:46:21
21535	9d673ba6-ff4f-49e0-b64f-b6903999d80b	9d673ba7-0aad-472a-b5d4-213b790cca27	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"85.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 15:51:19
21536	9d673ba7-084c-4359-ac4f-59c0c2afc8ba	9d673ba7-0aad-472a-b5d4-213b790cca27	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:51:19
21537	9d673ba7-08f5-4b21-83ea-292ba9bdf11e	9d673ba7-0aad-472a-b5d4-213b790cca27	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":381,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:51:19
26295	9d68d056-ea4a-4295-bc11-4e8f2bb9d83c	9d68d056-ebf1-4c04-b366-1da7d2973787	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":700,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:42:55
39241	9d6bcda2-711c-4e6f-833c-33720e16dd54	9d6bcda2-7786-4d72-a49e-f62273c2426e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 22:22:50
39242	9d6bcda2-7659-4975-aff1-7bc5af374a98	9d6bcda2-7786-4d72-a49e-f62273c2426e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 22:22:50
39243	9d6bcda2-769d-44ed-9169-323944790f29	9d6bcda2-7786-4d72-a49e-f62273c2426e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"46","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":{"frecuencia":null,"estado":null,"prestamista":null}},"duration":173,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:22:50
17734	9d6561ce-c58d-4f79-8a1e-1044dda15fc7	9d6561ce-e3b4-4d40-8f37-0d007483e0d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:46:21
17735	9d6561ce-da84-4249-9ea5-5c6aca61c6d5	9d6561ce-e3b4-4d40-8f37-0d007483e0d9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 52\\n                        ","time":"41.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"015af4c3d73f0a00e06908cfbb662ced","hostname":"EderCortes"}	2024-11-02 17:46:22
12977	9d5cefb1-7c9f-4ed8-9e75-0adcb72f84ec	9d5cefb1-c2b7-45bf-8d32-e8ee032373f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-29 13:00:39
12978	9d5cefb1-c124-46c6-8e11-9d0b89aed105	9d5cefb1-c2b7-45bf-8d32-e8ee032373f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-29 13:00:39
12979	9d5cefb1-c1d0-43f6-9550-b1ac61b5c666	9d5cefb1-c2b7-45bf-8d32-e8ee032373f6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":341,"memory":22,"hostname":"EderCortes"}	2024-10-29 13:00:39
17736	9d6561ce-de1c-452c-8e94-e9abd0ef6b58	9d6561ce-e3b4-4d40-8f37-0d007483e0d9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '52' order by \\"item_loans\\".\\"id\\" asc","time":"1.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 17:46:22
17737	9d6561ce-de50-4996-9294-eb58042d0171	9d6561ce-e3b4-4d40-8f37-0d007483e0d9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":7,"hostname":"EderCortes"}	2024-11-02 17:46:22
17738	9d6561ce-e289-4b51-bc2d-1e681a082452	9d6561ce-e3b4-4d40-8f37-0d007483e0d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:46:22
17739	9d6561ce-e2d3-4ece-92ba-c659b5f05b8d	9d6561ce-e3b4-4d40-8f37-0d007483e0d9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/52","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":52,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":7,"loans_valor_prestado":500000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"12-11-24","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-12 05:00:00"},"items":[{"id":136,"loans_codigo":52,"itemloans_cuota":"1","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":137,"loans_codigo":52,"itemloans_cuota":"2","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":138,"loans_codigo":52,"itemloans_cuota":"3","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":139,"loans_codigo":52,"itemloans_cuota":"4","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":140,"loans_codigo":52,"itemloans_cuota":"5","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":141,"loans_codigo":52,"itemloans_cuota":"6","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":142,"loans_codigo":52,"itemloans_cuota":"7","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:46:22
21538	9d673ba9-bef8-40b1-ba48-482c00e29b6e	9d673ba9-dee3-4b3f-aec9-b97bfd3707c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:51:21
21539	9d673ba9-d982-46cc-994b-6b8d1d9b02da	9d673ba9-dee3-4b3f-aec9-b97bfd3707c2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"46.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 15:51:21
21540	9d673ba9-d9e9-4096-ad3e-25e521b41d78	9d673ba9-dee3-4b3f-aec9-b97bfd3707c2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 15:51:21
21541	9d673ba9-dd88-4f41-a953-0b64bd15a31c	9d673ba9-dee3-4b3f-aec9-b97bfd3707c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 15:51:21
21542	9d673ba9-ddd6-4177-b60a-86909cc86222	9d673ba9-dee3-4b3f-aec9-b97bfd3707c2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":344,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:51:21
26296	9d68d057-a368-4bbc-ad3f-18113e60d755	9d68d057-d619-4a48-a016-0c7f061372a3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:42:55
26297	9d68d057-cc22-4d80-a652-d824291a57e2	9d68d057-d619-4a48-a016-0c7f061372a3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"67.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:42:55
17740	9d6561d0-e5be-4d62-9adb-e1371bba7b75	9d6561d1-0196-4574-b689-8f67fbc04dad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:46:23
17741	9d6561d0-fc73-4196-b2a5-4313c8cd333b	9d6561d1-0196-4574-b689-8f67fbc04dad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"39.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 17:46:23
17742	9d6561d0-fcc0-4c60-998c-d3eec98d4440	9d6561d1-0196-4574-b689-8f67fbc04dad	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 17:46:23
17743	9d6561d1-003a-4ca1-9740-85912eeb3a24	9d6561d1-0196-4574-b689-8f67fbc04dad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:46:23
17744	9d6561d1-0098-4cb9-b31a-c954a800b26f	9d6561d1-0196-4574-b689-8f67fbc04dad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":265,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:46:23
26298	9d68d057-ccad-4973-90b0-e38d29728ad6	9d68d057-d619-4a48-a016-0c7f061372a3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:42:55
26299	9d68d057-d37e-4074-870d-5f76fa6e381d	9d68d057-d619-4a48-a016-0c7f061372a3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:42:55
26300	9d68d057-d422-4527-aa47-2c748b7dcda0	9d68d057-d619-4a48-a016-0c7f061372a3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":570,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:42:55
39244	9d6bcdc8-a046-4303-9d8c-f5eb406cfdd6	9d6bcdc8-a3c4-46f6-aa70-9e18fa074963	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":165,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:23:15
17745	9d6561f3-dab1-47f5-a583-cf3afddadbdc	9d6561f3-de60-4a53-8c1e-d0c90de6ded0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":158,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:46:46
39245	9d6bcdc9-66bf-4592-b658-9eac9199976f	9d6bcdc9-70c5-4ca5-b6da-e5ddb7c47972	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 22:23:15
39246	9d6bcdc9-6f13-485a-860e-2a7d63181223	9d6bcdc9-70c5-4ca5-b6da-e5ddb7c47972	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 22:23:15
39247	9d6bcdc9-6f7b-42bb-95c5-075de473b0b4	9d6bcdc9-70c5-4ca5-b6da-e5ddb7c47972	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":14,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":{"cobrador":14,"frecuencia":null,"estado":null,"prestamista":null}},"duration":209,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:23:15
17746	9d6561f4-8e9a-46ce-a788-14303ca1064a	9d6561f4-da5f-4476-ae65-cbf19ceadcc2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:46:46
17747	9d6561f4-d183-4091-8e1f-74ce0197bf00	9d6561f4-da5f-4476-ae65-cbf19ceadcc2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 136 limit 1","time":"3.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":381,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-02 17:46:46
17748	9d6561f4-d1e0-4a1a-b39f-d1f7565c7393	9d6561f4-da5f-4476-ae65-cbf19ceadcc2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-02 17:46:46
17749	9d6561f4-d355-4ec7-9dcb-e73aff79314c	9d6561f4-da5f-4476-ae65-cbf19ceadcc2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 52 limit 1","time":"1.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":382,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-02 17:46:46
17750	9d6561f4-d386-4b29-b175-8786606500ce	9d6561f4-da5f-4476-ae65-cbf19ceadcc2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-02 17:46:46
17751	9d6561f4-d51f-4242-b8e3-583597798205	9d6561f4-da5f-4476-ae65-cbf19ceadcc2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '02-11-2024', \\"itemloans_interes_canelado\\" = '10416.666666667', \\"itemloans_cuota_cancelada\\" = '71428.571428571', \\"updated_at\\" = '2024-11-02 17:46:46' where \\"id\\" = 136","time":"2.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":403,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-02 17:46:46
17752	9d6561f4-d584-4aa5-a93c-942cb5a9be7b	9d6561f4-da5f-4476-ae65-cbf19ceadcc2	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:136","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-02 17:46:46","item_loans_cuando_pago":"02-11-2024","itemloans_interes_canelado":"10416.666666667","itemloans_cuota_cancelada":"71428.571428571"},"hostname":"EderCortes"}	2024-11-02 17:46:46
17753	9d6561f4-d628-465b-a272-93f20bb2a0c2	9d6561f4-da5f-4476-ae65-cbf19ceadcc2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_fecha_ultimo_pago\\" = '02-11-2024', \\"updated_at\\" = '2024-11-02 17:46:46' where \\"id\\" = 52","time":"0.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":411,"hash":"cf593c3f0d97e8454c5164f16511623d","hostname":"EderCortes"}	2024-11-02 17:46:46
17754	9d6561f4-d65f-4ddb-a2a1-726a11530e54	9d6561f4-da5f-4476-ae65-cbf19ceadcc2	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:52","changes":{"updated_at":"2024-11-02 17:46:46","loans_fecha_ultimo_pago":"02-11-2024"},"hostname":"EderCortes"}	2024-11-02 17:46:46
17755	9d6561f4-d92a-4c62-9b0e-0c75e1b2258e	9d6561f4-da5f-4476-ae65-cbf19ceadcc2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 17:46:46
17756	9d6561f4-d96f-4bf9-b234-cb5a2d31bab6	9d6561f4-da5f-4476-ae65-cbf19ceadcc2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"176","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"10416.666666667","itemloans_cuota_cancelada":"71428.571428571","id":136,"loans_codigo":52,"item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":338,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:46:46
39248	9d6bcdd1-d669-4fb8-ba73-58d6d39d1d64	9d6bcdd1-d9eb-4a4e-874b-7b3bb4c09cc1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":177,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:23:21
39249	9d6bcdd2-9420-4c63-a5fe-0ef996591d90	9d6bcdd2-9b83-48a6-a889-cdc48c231272	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 22:23:21
15662	9d648fe4-8cbd-4673-b0d4-b20ce6af85b2	9d648fe4-aa78-4d77-af6d-16b5ef81dd4b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 07:59:24
15663	9d648fe4-a8db-4e8a-8c41-60c5f24ed6d3	9d648fe4-aa78-4d77-af6d-16b5ef81dd4b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 07:59:24
15664	9d648fe4-a983-45b4-bb4a-ee229f106234	9d648fe4-aa78-4d77-af6d-16b5ef81dd4b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-11-02 07:59:24
26402	9d68d3da-f86a-45ac-b9e0-77881291784a	9d68d3db-2fab-4608-baec-7647974d3e84	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:52:45
26403	9d68d3db-2d31-4004-b470-a50cb34cc606	9d68d3db-2fab-4608-baec-7647974d3e84	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:52:45
26404	9d68d3db-2e50-4219-983e-ba42b0fe1651	9d68d3db-2fab-4608-baec-7647974d3e84	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":572,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:52:45
39250	9d6bcdd2-9a0b-4ca3-b5b6-135d48618d79	9d6bcdd2-9b83-48a6-a889-cdc48c231272	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 22:23:21
39251	9d6bcdd2-9a56-40e0-bc70-aeb35991c594	9d6bcdd2-9b83-48a6-a889-cdc48c231272	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"46","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":{"frecuencia":null,"estado":null,"prestamista":null}},"duration":186,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:23:21
39663	9d6be112-151d-42af-b7d9-77b214e1a460	9d6be112-3e12-4ecc-b6b3-ebcf632fec67	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 23:17:11
39664	9d6be112-3ba5-4ce0-9cab-0c54259adf01	9d6be112-3e12-4ecc-b6b3-ebcf632fec67	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 23:17:11
39665	9d6be112-3ce5-4a95-845d-41179dc7ca58	9d6be112-3e12-4ecc-b6b3-ebcf632fec67	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":331,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:17:11
15665	9d648fe6-3cad-466e-853c-b267018ad1fc	9d648fe6-81ac-4ed4-a66e-0796ed7c32d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 07:59:25
15666	9d648fe6-7cbb-4b50-bfcf-a7e5e9761ea7	9d648fe6-81ac-4ed4-a66e-0796ed7c32d9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"144.68","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 07:59:25
15667	9d648fe6-7d0d-400c-a9c5-6ae1d25aaebd	9d648fe6-81ac-4ed4-a66e-0796ed7c32d9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 07:59:25
15668	9d648fe6-804b-48b0-b0c9-37b21e42417e	9d648fe6-81ac-4ed4-a66e-0796ed7c32d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 07:59:25
15669	9d648fe6-8099-4c58-8096-f25a753d5bf5	9d648fe6-81ac-4ed4-a66e-0796ed7c32d9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":319,"memory":22,"hostname":"EderCortes"}	2024-11-02 07:59:25
17757	9d6561f5-3bed-47c6-80f8-938bdee97c3f	9d6561f5-5c0b-4175-84b7-f4dcc06feb48	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 17:46:47
17758	9d6561f5-52ee-434d-91c5-59d220944dde	9d6561f5-5c0b-4175-84b7-f4dcc06feb48	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 52\\n                        ","time":"45.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"015af4c3d73f0a00e06908cfbb662ced","hostname":"EderCortes"}	2024-11-02 17:46:47
17759	9d6561f5-56d8-4350-8bb2-e8332b2a793d	9d6561f5-5c0b-4175-84b7-f4dcc06feb48	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '52' order by \\"item_loans\\".\\"id\\" asc","time":"2.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 17:46:47
17760	9d6561f5-5713-4cf8-8e01-225c16a60618	9d6561f5-5c0b-4175-84b7-f4dcc06feb48	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":7,"hostname":"EderCortes"}	2024-11-02 17:46:47
17761	9d6561f5-5aca-4360-9e19-219d08076c3b	9d6561f5-5c0b-4175-84b7-f4dcc06feb48	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 17:46:47
17762	9d6561f5-5b17-4aab-b1d2-fe3bad051427	9d6561f5-5c0b-4175-84b7-f4dcc06feb48	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/52","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":52,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":7,"loans_valor_prestado":500000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"12-11-24","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-12 05:00:00"},"items":[{"id":136,"loans_codigo":52,"itemloans_cuota":"1","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-11-02T22:46:46.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"10416.666666667","itemloans_cuota_cancelada":"71428.571428571"},{"id":137,"loans_codigo":52,"itemloans_cuota":"2","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":138,"loans_codigo":52,"itemloans_cuota":"3","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":139,"loans_codigo":52,"itemloans_cuota":"4","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":140,"loans_codigo":52,"itemloans_cuota":"5","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":141,"loans_codigo":52,"itemloans_cuota":"6","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":142,"loans_codigo":52,"itemloans_cuota":"7","itemloans_valor_cuota":"71428.571428571","itemloans_iteres":"10416.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T19:16:11.000000Z","updated_at":"2024-10-29T19:16:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":280,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:46:47
26405	9d68d3db-fd20-49fa-86cc-948949e758b8	9d68d3dc-471e-453e-b1cb-a70fd4ef52e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:52:45
39666	9d6be114-6e31-495c-8f86-fc02fae3f656	9d6be114-9962-4131-b2e7-693377ba9a8f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 23:17:12
15670	9d648fe9-d2e8-436a-a584-fc6d06ae3a20	9d648fe9-f027-42f3-8192-52513998345c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 07:59:27
15671	9d648fe9-eadd-4461-b9f0-71db80513c95	9d648fe9-f027-42f3-8192-52513998345c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"39.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-02 07:59:27
15672	9d648fe9-eb32-47a7-9a83-760856ce71ac	9d648fe9-f027-42f3-8192-52513998345c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-02 07:59:27
15673	9d648fe9-eed9-41c4-9f16-17c8a163c5aa	9d648fe9-f027-42f3-8192-52513998345c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 07:59:27
15674	9d648fe9-ef24-4d3f-8200-268f81d1c158	9d648fe9-f027-42f3-8192-52513998345c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":272,"memory":22,"hostname":"EderCortes"}	2024-11-02 07:59:27
17763	9d65620e-12ba-4c0b-a40b-a5f6fb9234b4	9d65620e-2f9f-41d6-98e9-f6de8cd69846	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 17:47:03
17764	9d65620e-2b54-4cd2-95fe-d677ef81adbf	9d65620e-2f9f-41d6-98e9-f6de8cd69846	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"45.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58,"hash":"77f8314368b36a9393ec9c7735a91700","hostname":"EderCortes"}	2024-11-02 17:47:03
17765	9d65620e-2e52-4056-8d99-de36d7805b45	9d65620e-2f9f-41d6-98e9-f6de8cd69846	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 17:47:03
17766	9d65620e-2ea9-424f-baa2-a8c56fe1a9b0	9d65620e-2f9f-41d6-98e9-f6de8cd69846	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"14","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:47:03
26406	9d68d3dc-337d-4a16-acd9-ec4d4a91d8ae	9d68d3dc-471e-453e-b1cb-a70fd4ef52e8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"106.23","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:52:45
17767	9d656225-2aee-471b-9822-852907c16ee0	9d656225-74ad-43f9-8229-7237f84d37c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 17:47:18
17768	9d656225-6c1e-4bcb-8f65-55093633eabd	9d656225-74ad-43f9-8229-7237f84d37c2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 16\\n                        ","time":"153.95","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"cfb44b82f7d7694546abfc24319d9906","hostname":"EderCortes"}	2024-11-02 17:47:18
17769	9d656225-6fb1-4c17-bd1a-c53fef8d51d8	9d656225-74ad-43f9-8229-7237f84d37c2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '16' order by \\"item_loans\\".\\"id\\" asc","time":"2.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 17:47:18
17770	9d656225-6fe7-47b1-be42-c99b3037c943	9d656225-74ad-43f9-8229-7237f84d37c2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-02 17:47:18
17771	9d656225-7374-4aef-8391-be134ee460eb	9d656225-74ad-43f9-8229-7237f84d37c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 17:47:18
17772	9d656225-73bc-4873-8417-c2688c1763e9	9d656225-74ad-43f9-8229-7237f84d37c2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/16","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":16,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-05 05:00:00"},"items":[{"id":64,"loans_codigo":16,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:22:57.000000Z","updated_at":"2024-10-29T16:22:57.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":65,"loans_codigo":16,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:22:58.000000Z","updated_at":"2024-10-29T16:22:58.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":66,"loans_codigo":16,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:22:58.000000Z","updated_at":"2024-10-29T16:22:58.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":67,"loans_codigo":16,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-10-25 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:22:58.000000Z","updated_at":"2024-10-29T16:22:58.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":68,"loans_codigo":16,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-01-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:22:58.000000Z","updated_at":"2024-10-29T16:22:58.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":69,"loans_codigo":16,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-04-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:22:58.000000Z","updated_at":"2024-10-29T16:22:58.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":370,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:47:18
26407	9d68d3dc-3c0d-40a8-ad8e-d63e0d69a63c	9d68d3dc-471e-453e-b1cb-a70fd4ef52e8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"4.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:52:45
26408	9d68d3dc-3c83-4edb-a0ed-d06193439a58	9d68d3dc-471e-453e-b1cb-a70fd4ef52e8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:52:45
26409	9d68d3dc-44a3-405b-9097-6d268d62f143	9d68d3dc-471e-453e-b1cb-a70fd4ef52e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:52:45
26410	9d68d3dc-4545-4c77-9c2c-645e81f4786e	9d68d3dc-471e-453e-b1cb-a70fd4ef52e8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":643,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:52:45
39252	9d6bcea6-eae0-42ce-8c13-e56a13b45c36	9d6bcea6-ef6a-4a8f-9e55-23a9447e02f3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":188,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:25:41
39667	9d6be114-92b2-4f1b-acb8-7ead6d7ca7d0	9d6be114-9962-4131-b2e7-693377ba9a8f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"58.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 23:17:12
39253	9d6bcea7-7a2a-4e5e-b182-4cf433394525	9d6bcea7-8728-4e60-a9f5-097363a6eb8a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 22:25:41
13761	9d5d0e7e-5648-4dde-ab89-2cfec32772d1	9d5d0e7e-93e8-453c-986c-7196e4830d12	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-29 14:26:46
13762	9d5d0e7e-9115-42d2-974c-88b69848bcb8	9d5d0e7e-93e8-453c-986c-7196e4830d12	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-29 14:26:46
13763	9d5d0e7e-9285-42a9-94fe-03adbd86ada3	9d5d0e7e-93e8-453c-986c-7196e4830d12	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":470,"memory":22,"hostname":"EderCortes"}	2024-10-29 14:26:46
39254	9d6bcea7-84f0-412c-b8cc-473fd484c870	9d6bcea7-8728-4e60-a9f5-097363a6eb8a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 22:25:41
39255	9d6bcea7-8569-4bd3-b98c-ee8171432867	9d6bcea7-8728-4e60-a9f5-097363a6eb8a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":14,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":{"cobrador":14,"frecuencia":null,"estado":null,"prestamista":null}},"duration":212,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:25:41
26492	9d68d71b-4815-42d1-bdc3-c6696fc8096f	9d68d71b-6a81-4311-ae53-ca5e323c45f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:01:50
26411	9d68d3e4-c29f-4845-a394-122439ec7fa3	9d68d3e4-eba8-4b1f-b89d-de6ad2f2a875	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:52:51
26412	9d68d3e4-e2a4-4d99-a2ea-e2ac2d2aaa87	9d68d3e4-eba8-4b1f-b89d-de6ad2f2a875	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"54.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:52:51
26413	9d68d3e4-e30d-4089-b551-31cd410ec397	9d68d3e4-eba8-4b1f-b89d-de6ad2f2a875	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:52:51
26414	9d68d3e4-e955-496b-b062-89263aa53caf	9d68d3e4-eba8-4b1f-b89d-de6ad2f2a875	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:52:51
26493	9d68d71b-68e2-4932-8a41-9360894af052	9d68d71b-6a81-4311-ae53-ca5e323c45f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:01:50
26494	9d68d71b-698e-48cd-b1c9-508541cf2b8d	9d68d71b-6a81-4311-ae53-ca5e323c45f5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":408,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:01:50
39668	9d6be114-9317-4c42-8df4-3240d118523b	9d6be114-9962-4131-b2e7-693377ba9a8f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 23:17:12
39669	9d6be114-97ac-441a-bff0-b35e0a89166a	9d6be114-9962-4131-b2e7-693377ba9a8f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 23:17:12
39670	9d6be114-97f9-4e58-8b97-319c4bef8bca	9d6be114-9962-4131-b2e7-693377ba9a8f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":432,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:17:12
17773	9d65630e-3fc1-4c4d-9179-ee2669aa07ae	9d65630e-6875-4369-8ab9-b37b38e54169	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 17:49:51
17774	9d65630e-6162-4ec8-9ece-12fc5916f97b	9d65630e-6875-4369-8ab9-b37b38e54169	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"51.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58,"hash":"77f8314368b36a9393ec9c7735a91700","hostname":"EderCortes"}	2024-11-02 17:49:51
17775	9d65630e-6679-48a8-8948-10801ab136e7	9d65630e-6875-4369-8ab9-b37b38e54169	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:49:51
17776	9d65630e-6705-49e2-b556-e3fbebf87746	9d65630e-6875-4369-8ab9-b37b38e54169	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"14","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":329,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:49:51
26415	9d68d3e4-e9db-4537-80ba-30ca35dadb3f	9d68d3e4-eba8-4b1f-b89d-de6ad2f2a875	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":574,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:52:51
26495	9d68d71b-e83e-4d2c-a04c-28d0319ecfb0	9d68d71c-08de-4f9b-a9b8-f9df259cfef0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:01:50
26496	9d68d71c-0042-41af-8d3e-27e50d74e56d	9d68d71c-08de-4f9b-a9b8-f9df259cfef0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"46.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 11:01:50
26497	9d68d71c-03d8-43f1-a240-00bbd4f4362a	9d68d71c-08de-4f9b-a9b8-f9df259cfef0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:01:50
26498	9d68d71c-040d-4c8e-a110-bf8c6b083cb0	9d68d71c-08de-4f9b-a9b8-f9df259cfef0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:01:50
26499	9d68d71c-0773-4d04-8132-ef100fa51ac0	9d68d71c-08de-4f9b-a9b8-f9df259cfef0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:01:50
26416	9d68d3e5-8405-4371-8b24-e3b22a80b9e7	9d68d3e5-bac6-462f-a9d3-d654424f159f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:52:51
26417	9d68d3e5-b02b-4fdd-ba56-74922aa06d5e	9d68d3e5-bac6-462f-a9d3-d654424f159f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"69.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:52:52
26418	9d68d3e5-b0e2-4a4b-a9a7-78555ad31877	9d68d3e5-bac6-462f-a9d3-d654424f159f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:52:52
26419	9d68d3e5-b85c-4e64-acd0-d2fbbb0ded9f	9d68d3e5-bac6-462f-a9d3-d654424f159f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:52:52
26420	9d68d3e5-b936-43c3-b8bd-eb8aff6ab371	9d68d3e5-bac6-462f-a9d3-d654424f159f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":510,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:52:52
26500	9d68d71c-07c2-403e-a20f-2cb8bc707642	9d68d71c-08de-4f9b-a9b8-f9df259cfef0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":360,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:01:50
39256	9d6bceb1-12ef-48b3-a15a-0406c85134f2	9d6bceb1-166b-40a8-ad88-4f24315ec085	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":213,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:25:47
16749	9d64d69a-1eef-4aee-8b48-7be001bd84e7	9d64d69a-48a8-423b-a656-046019bd4b8f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 11:17:07
16750	9d64d69a-4645-4ee1-9d32-72bb27a40fbe	9d64d69a-48a8-423b-a656-046019bd4b8f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 11:17:07
16751	9d64d69a-472f-4bdd-8f0f-2af115739a4a	9d64d69a-48a8-423b-a656-046019bd4b8f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":320,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:17:07
39257	9d6bceb1-d54b-4a71-b4b1-98a7a7252546	9d6bceb1-dca3-4fd3-be95-3aa6db64ffb3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 22:25:48
39258	9d6bceb1-db58-4913-bd33-63ecfab06420	9d6bceb1-dca3-4fd3-be95-3aa6db64ffb3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 22:25:48
39259	9d6bceb1-dba5-4e8e-a5e8-2a35df3b1fbc	9d6bceb1-dca3-4fd3-be95-3aa6db64ffb3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"46","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":{"frecuencia":null,"estado":null,"prestamista":null}},"duration":200,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:25:48
20586	9d66f79f-8e2f-422c-816f-80978f61d6e4	9d66f79f-91e6-47b6-b2a0-2231292a5681	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1021}	2024-11-03 12:41:06
16752	9d64d69a-b1ca-483c-9f25-347e2e47ac9a	9d64d69a-d815-4787-8481-cd2355526374	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 11:17:07
16753	9d64d69a-cb86-4134-b8b4-7c3e941df197	9d64d69a-d815-4787-8481-cd2355526374	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"51.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 11:17:07
16754	9d64d69a-d01a-425a-803a-932d410165f4	9d64d69a-d815-4787-8481-cd2355526374	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 11:17:07
16755	9d64d69a-d05f-48db-ab81-520be78535f4	9d64d69a-d815-4787-8481-cd2355526374	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 11:17:07
16756	9d64d69a-d669-4899-bed4-027b1f57b696	9d64d69a-d815-4787-8481-cd2355526374	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 11:17:07
16757	9d64d69a-d6d4-4ab9-92b6-21ff1cb1e6f6	9d64d69a-d815-4787-8481-cd2355526374	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":322,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:17:07
26662	9d68da64-22f1-4a98-8bee-3b8791aaf8b6	9d68da64-56af-4116-a88a-3add11ace05b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:11:01
14418	9d5d1e22-658f-4677-9bda-3aeffdca9615	9d5d1e22-a48c-4095-960f-6195a9b9f8b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-10-29 15:10:30
14419	9d5d1e22-a0fc-4270-8e39-6ec956873e4d	9d5d1e22-a48c-4095-960f-6195a9b9f8b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-10-29 15:10:31
14420	9d5d1e22-a280-4f1b-8da7-fb2c73a42766	9d5d1e22-a48c-4095-960f-6195a9b9f8b5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":634,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:10:31
16758	9d64d69c-871e-4ae9-ac45-d49a07bf2407	9d64d69c-ad36-436d-8583-737219ae8e53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 11:17:08
16759	9d64d69c-a449-48fc-a2f7-08a8319f060e	9d64d69c-ad36-436d-8583-737219ae8e53	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 11:17:08
16760	9d64d69c-a4be-4966-b40e-456a9f1a51c8	9d64d69c-ad36-436d-8583-737219ae8e53	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 11:17:08
16761	9d64d69c-ab7a-4c0a-9140-93c71e4550d4	9d64d69c-ad36-436d-8583-737219ae8e53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 11:17:08
16762	9d64d69c-abea-4c57-8ce0-4cac65300d25	9d64d69c-ad36-436d-8583-737219ae8e53	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":458,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:17:08
26572	9d68d84c-9b93-4896-b06d-5e175415b6fb	9d68d84d-3c14-43c4-bb28-910177779579	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:05:10
19366	9d66d5d0-5410-4e7c-9ac6-ddf79f9cd646	9d66d5d0-9ff0-49f7-982b-e13af500b1e1	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 11:06:34
19367	9d66d5d0-9e06-41b4-8da0-72b10a0ddcba	9d66d5d0-9ff0-49f7-982b-e13af500b1e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:06:34
19368	9d66d5d0-9ec6-4220-b55c-b45dea6c06c0	9d66d5d0-9ff0-49f7-982b-e13af500b1e1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":374,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:06:34
26573	9d68d84d-388d-43dc-a38b-41bc5df6d0af	9d68d84d-3c14-43c4-bb28-910177779579	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:05:10
26574	9d68d84d-3a17-4bd1-b36f-040cad4becac	9d68d84d-3c14-43c4-bb28-910177779579	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":956,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:05:10
26663	9d68da64-5448-4776-a356-f58f9c9f9884	9d68da64-56af-4116-a88a-3add11ace05b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:11:01
26664	9d68da64-5567-4bb8-b40f-62496ea2e774	9d68da64-56af-4116-a88a-3add11ace05b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":576,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:11:01
39746	9d6cb442-3cb5-4705-b92b-e5cdf563092c	9d6cb442-8930-4dee-8c2d-21ef62065095	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:07:42
39747	9d6cb442-873a-411d-9cf3-05d295ff80c5	9d6cb442-8930-4dee-8c2d-21ef62065095	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:07:42
39748	9d6cb442-87f7-4cca-b7e1-7a3fa49ac16c	9d6cb442-8930-4dee-8c2d-21ef62065095	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":382,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:07:42
19369	9d66d5d0-fcff-40f4-ac51-9338280287f1	9d66d5d1-1d29-4e19-92d0-d3237ebef1c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:06:34
19370	9d66d5d1-131a-4c51-93ea-10b1340cfe09	9d66d5d1-1d29-4e19-92d0-d3237ebef1c2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"43.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 11:06:34
19371	9d66d5d1-173f-4bef-a60e-3fc929e37340	9d66d5d1-1d29-4e19-92d0-d3237ebef1c2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"1.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:06:34
15779	9d64af93-73ee-4283-b391-fc5dd2dc8e74	9d64af93-9cd3-4b97-9738-3de76e264ab2	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 09:27:59
15780	9d64af93-9a98-4ad1-964b-c3e9356c45e7	9d64af93-9cd3-4b97-9738-3de76e264ab2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:27:59
15781	9d64af93-9b54-4a13-abf5-4b2daa5664bd	9d64af93-9cd3-4b97-9738-3de76e264ab2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:27:59
19372	9d66d5d1-1788-43fb-aa01-12be60da1e32	9d66d5d1-1d29-4e19-92d0-d3237ebef1c2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:06:34
19373	9d66d5d1-1b9d-47ce-b0f6-f16829825f6e	9d66d5d1-1d29-4e19-92d0-d3237ebef1c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:06:34
19374	9d66d5d1-1c19-4cad-8d53-1e56c18387be	9d66d5d1-1d29-4e19-92d0-d3237ebef1c2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T02:27:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"0"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":276,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:06:34
26575	9d68d84e-5aac-4fe4-8463-7f7fef36b626	9d68d84e-b6fc-4130-acf8-06a5d943fd89	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:05:11
26576	9d68d84e-ab4f-4cd7-9c3d-253e797dd951	9d68d84e-b6fc-4130-acf8-06a5d943fd89	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"169.92","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 11:05:11
26577	9d68d84e-b0aa-453a-944e-5651fc9c999d	9d68d84e-b6fc-4130-acf8-06a5d943fd89	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:05:11
26578	9d68d84e-b0ef-4c29-a368-11150b15b76a	9d68d84e-b6fc-4130-acf8-06a5d943fd89	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:05:11
26579	9d68d84e-b593-44b1-bb54-adaf480d5ebe	9d68d84e-b6fc-4130-acf8-06a5d943fd89	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:05:11
26665	9d68da65-1b2c-4c15-8492-477f968a422f	9d68da65-4745-4aa7-b622-85648a6de284	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:11:02
39749	9d6cb443-65c2-448e-9891-647de4e55b70	9d6cb443-b421-4cf3-8afe-139b66dedf1c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:07:43
15782	9d64af93-fe9e-42c8-abd0-5a0400993362	9d64af94-2043-4dcb-be7b-73534205b0eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:28:00
15783	9d64af94-1686-418c-b4f0-86b13387967a	9d64af94-2043-4dcb-be7b-73534205b0eb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"46.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"088d1fdbe045a08c3b0073ef22c7da32","hostname":"EderCortes"}	2024-11-02 09:28:00
15784	9d64af94-1a13-4795-9a59-228a8337ea9e	9d64af94-2043-4dcb-be7b-73534205b0eb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:28:00
15785	9d64af94-1a4c-4ee8-b0e9-d5127624a87b	9d64af94-2043-4dcb-be7b-73534205b0eb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 09:28:00
15786	9d64af94-1eb8-4b6f-9f1a-dcf412a2651c	9d64af94-2043-4dcb-be7b-73534205b0eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:28:00
15787	9d64af94-1f40-4b98-94bd-68fc9172ac5f	9d64af94-2043-4dcb-be7b-73534205b0eb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":290,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:28:00
16763	9d64d6a9-f751-4222-b395-84d69bbc0a51	9d64d6a9-fa4b-483e-ad94-58ac4d0ed6da	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":142,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:17:17
19375	9d66d5d2-8c20-4fd5-8900-41776c7174f9	9d66d5d2-b39a-4ed4-bce0-6fe3bf713c62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:06:35
19376	9d66d5d2-ad2f-44bd-8217-66041d861adb	9d66d5d2-b39a-4ed4-bce0-6fe3bf713c62	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"48.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:06:35
19377	9d66d5d2-ad9e-4625-9e54-ba758ae49d4c	9d66d5d2-b39a-4ed4-bce0-6fe3bf713c62	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:06:35
19378	9d66d5d2-b21d-4c5e-8f9c-5d239af31dd6	9d66d5d2-b39a-4ed4-bce0-6fe3bf713c62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 11:06:35
19379	9d66d5d2-b269-45bb-8363-7475973d54a5	9d66d5d2-b39a-4ed4-bce0-6fe3bf713c62	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":518,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:06:35
15788	9d64af95-fc50-44e1-b6f3-408e9a8104d2	9d64af96-20c5-4aa3-a4df-7560696f8a21	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:28:01
15789	9d64af96-1a2d-4262-b974-09f82746afcb	9d64af96-20c5-4aa3-a4df-7560696f8a21	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 09:28:01
15790	9d64af96-1aa3-4598-9b5e-626ba53af616	9d64af96-20c5-4aa3-a4df-7560696f8a21	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 09:28:01
15791	9d64af96-1eda-4dee-b26a-63b1bfb46864	9d64af96-20c5-4aa3-a4df-7560696f8a21	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 09:28:01
15792	9d64af96-1f3b-48e7-b653-3eab001a2a70	9d64af96-20c5-4aa3-a4df-7560696f8a21	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":414,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:28:01
26580	9d68d84e-b5f5-479a-92a8-41c089ba46df	9d68d84e-b6fc-4130-acf8-06a5d943fd89	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":890,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:05:11
26666	9d68da65-38d7-4f54-a5da-45f5ff268608	9d68da65-4745-4aa7-b622-85648a6de284	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"52.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:11:02
26667	9d68da65-3e66-4a23-a55a-675a2f8127f7	9d68da65-4745-4aa7-b622-85648a6de284	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"3.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:11:02
26668	9d68da65-3eb2-4fe5-89c4-1a05c30b104c	9d68da65-4745-4aa7-b622-85648a6de284	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:11:02
26669	9d68da65-4463-4a02-94dc-db0dc003d92d	9d68da65-4745-4aa7-b622-85648a6de284	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:11:02
39750	9d6cb443-ae3a-4eea-92f4-9a2bc485fcd5	9d6cb443-b421-4cf3-8afe-139b66dedf1c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"163.57","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:07:43
39751	9d6cb443-ae98-4caf-b0d7-a3678ec7851e	9d6cb443-b421-4cf3-8afe-139b66dedf1c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:07:43
39752	9d6cb443-b2bc-4917-9ea7-65d78836a13f	9d6cb443-b421-4cf3-8afe-139b66dedf1c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:07:43
16769	9d64d6aa-ec8d-4672-8379-9403d58ad44a	9d64d6ab-0ca8-460a-927f-327dddce0dbf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 11:17:18
16770	9d64d6ab-03b4-44f0-b8de-0ca12734685a	9d64d6ab-0ca8-460a-927f-327dddce0dbf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"43.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 11:17:18
16771	9d64d6ab-0790-4009-8a94-0182a5b3819b	9d64d6ab-0ca8-460a-927f-327dddce0dbf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"1.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 11:17:18
16772	9d64d6ab-07c8-4e22-8a4d-e192a6d95900	9d64d6ab-0ca8-460a-927f-327dddce0dbf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 11:17:18
16773	9d64d6ab-0b15-462f-b7c6-b5c3fbb5ab4a	9d64d6ab-0ca8-460a-927f-327dddce0dbf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 11:17:18
16774	9d64d6ab-0b5f-427c-8068-450b4da8be84	9d64d6ab-0ca8-460a-927f-327dddce0dbf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:17:18
26581	9d68d84f-8d11-4742-aa2d-49aa49d0b6fd	9d68d84f-d09e-4859-a5ea-f43441175989	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:05:12
26582	9d68d84f-c6b2-427d-9e9c-9a276cc30d15	9d68d84f-d09e-4859-a5ea-f43441175989	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"79.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:05:12
26583	9d68d84f-c740-498c-bda1-854947099a38	9d68d84f-d09e-4859-a5ea-f43441175989	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:05:12
26584	9d68d84f-ce6d-4629-a165-582c0503e0e7	9d68d84f-d09e-4859-a5ea-f43441175989	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:05:12
26585	9d68d84f-cf08-4f1b-8dc8-f7f552ea7b11	9d68d84f-d09e-4859-a5ea-f43441175989	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":696,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:05:12
26670	9d68da65-44f8-450a-91fd-beeda86e050e	9d68da65-4745-4aa7-b622-85648a6de284	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":544,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:11:02
39753	9d6cb443-b311-48b4-b03a-ee5e132686b4	9d6cb443-b421-4cf3-8afe-139b66dedf1c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":401,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:07:43
26586	9d68d850-7f5a-4fc9-a6a2-d2995790aaac	9d68d850-de5d-498d-85f7-7e000d17c6e6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:05:13
26587	9d68d850-d4d8-44e1-814b-f8f9fe79f855	9d68d850-de5d-498d-85f7-7e000d17c6e6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"179.90","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:05:13
26588	9d68d850-d569-41a2-b86d-07119465b68d	9d68d850-de5d-498d-85f7-7e000d17c6e6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:05:13
26589	9d68d850-dc64-4265-9f6d-5032006099ec	9d68d850-de5d-498d-85f7-7e000d17c6e6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:05:13
22122	9d674259-06e8-473b-b249-30e32be1e105	9d674259-3430-40d5-b25f-e03ee1a1e745	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 16:10:03
22123	9d674259-31d5-459a-8c48-1a0621f88ed6	9d674259-3430-40d5-b25f-e03ee1a1e745	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 16:10:03
22124	9d674259-32c5-4ccb-a056-895315c7612a	9d674259-3430-40d5-b25f-e03ee1a1e745	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":493,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:10:03
26590	9d68d850-dce5-4156-a87f-66178af6abfa	9d68d850-de5d-498d-85f7-7e000d17c6e6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":647,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:05:13
26671	9d68da66-9098-4a8d-8a44-16a2573cc200	9d68da66-f600-4511-9d13-c94a87545a6d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:11:03
26672	9d68da66-ea65-44ec-8f14-b7758a61a6aa	9d68da66-f600-4511-9d13-c94a87545a6d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"73.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:11:03
26673	9d68da66-eb03-496b-93bb-3307a644906d	9d68da66-f600-4511-9d13-c94a87545a6d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:11:03
26674	9d68da66-f366-42db-a081-56b10bc839a5	9d68da66-f600-4511-9d13-c94a87545a6d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:11:03
26675	9d68da66-f428-4848-aaa1-fcecb095d3d5	9d68da66-f600-4511-9d13-c94a87545a6d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1071,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:11:03
22125	9d674259-8c57-40ca-b005-fed811619cc6	9d674259-aa16-4255-83c9-41b950d55182	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 16:10:03
22126	9d674259-a538-4f2b-8649-6cd76411c157	9d674259-aa16-4255-83c9-41b950d55182	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 16:10:03
22127	9d674259-a58b-407b-be34-deba8db29dc4	9d674259-aa16-4255-83c9-41b950d55182	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 16:10:03
22128	9d674259-a8ee-40e4-acb8-94f356189765	9d674259-aa16-4255-83c9-41b950d55182	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 16:10:03
22129	9d674259-a933-41c4-ab69-e378894cdf14	9d674259-aa16-4255-83c9-41b950d55182	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:10:03
26676	9d68da67-b822-48c8-bb64-efbef0d2ca0a	9d68da68-0e40-46b3-86fd-a908f7ae840c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:11:03
26677	9d68da68-0471-4972-b6bc-b4a838f0275b	9d68da68-0e40-46b3-86fd-a908f7ae840c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"73.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:11:04
26678	9d68da68-0518-4ad3-97f5-7fb889054083	9d68da68-0e40-46b3-86fd-a908f7ae840c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:11:04
26679	9d68da68-0c0d-4d10-877e-426a9ccb9fd5	9d68da68-0e40-46b3-86fd-a908f7ae840c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:11:04
26680	9d68da68-0cc3-4c2b-8a36-eebfd5424dfd	9d68da68-0e40-46b3-86fd-a908f7ae840c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":692,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:11:04
22130	9d674259-e932-447d-9f58-958f368ec1b8	9d67425a-2fc6-42da-b8f9-8f500e85f1cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 16:10:03
22131	9d67425a-2b19-487b-9df3-b1489542108b	9d67425a-2fc6-42da-b8f9-8f500e85f1cd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"142.70","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 16:10:03
22132	9d67425a-2b69-44f5-866d-f0e9055ccf5f	9d67425a-2fc6-42da-b8f9-8f500e85f1cd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-03 16:10:03
22133	9d67425a-2ead-4759-9d4f-b00f13bdd6f4	9d67425a-2fc6-42da-b8f9-8f500e85f1cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-03 16:10:03
22134	9d67425a-2ef3-415d-a1a0-e346a7c7d8cb	9d67425a-2fc6-42da-b8f9-8f500e85f1cd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":328,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:10:03
39818	9d6cb6a9-b89b-4971-8d60-6c1a550c068b	9d6cb6aa-10cf-405a-aa6e-6f8ebfafee52	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 09:14:26
39819	9d6cb6aa-0e1f-438c-9ccb-3bba9e0022d2	9d6cb6aa-10cf-405a-aa6e-6f8ebfafee52	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:14:26
39820	9d6cb6aa-0f35-4dd1-a403-2b246828a72b	9d6cb6aa-10cf-405a-aa6e-6f8ebfafee52	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":476,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:14:26
39821	9d6cb6ab-98b7-47ed-91b7-4bd1a5bf939a	9d6cb6ab-e554-415f-807a-888a9a538680	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:14:27
39822	9d6cb6ab-df9c-4df6-b825-c50f79f72705	9d6cb6ab-e554-415f-807a-888a9a538680	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"158.06","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:14:27
19456	9d66d69d-6aec-44a0-8bce-af01080e3c97	9d66d69d-8d39-4a2a-bad4-f909bf0a2f84	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 11:08:48
19457	9d66d69d-8b37-4558-82ae-dcb8c4fd1276	9d66d69d-8d39-4a2a-bad4-f909bf0a2f84	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:08:48
19458	9d66d69d-8bee-463a-b63f-06d836eaaa83	9d66d69d-8d39-4a2a-bad4-f909bf0a2f84	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:08:48
39823	9d6cb6ab-dffb-42fd-bf2c-6196c1b8000a	9d6cb6ab-e554-415f-807a-888a9a538680	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:14:27
39824	9d6cb6ab-e41b-44c2-a36d-c262b09a94fc	9d6cb6ab-e554-415f-807a-888a9a538680	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:14:27
39825	9d6cb6ab-e469-4f41-b560-3385adc84cd0	9d6cb6ab-e554-415f-807a-888a9a538680	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":461,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:14:27
39856	9d6cb844-2663-4dea-a640-f6133fbab295	9d6cb844-77f9-4e82-8435-ed2eee7ace14	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 09:18:55
39857	9d6cb844-7584-4367-abeb-7783f5fed273	9d6cb844-77f9-4e82-8435-ed2eee7ace14	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:18:55
39858	9d6cb844-766c-4c3c-96fd-0bb774c574ff	9d6cb844-77f9-4e82-8435-ed2eee7ace14	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":544,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:18:55
19459	9d66d69d-e653-4ac5-9ed6-828138a2decc	9d66d69e-04f7-4740-b12e-c68d8f45afd2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:08:48
19460	9d66d69d-fb67-40c5-b2b0-9e606b533723	9d66d69e-04f7-4740-b12e-c68d8f45afd2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"41.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 11:08:49
19461	9d66d69d-fecd-4fb5-90e7-00f7be4a43ae	9d66d69e-04f7-4740-b12e-c68d8f45afd2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:08:49
19462	9d66d69d-fefd-498a-a129-23d6c252df83	9d66d69e-04f7-4740-b12e-c68d8f45afd2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:08:49
19463	9d66d69e-0396-4985-9205-f8352a855a42	9d66d69e-04f7-4740-b12e-c68d8f45afd2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:08:49
19464	9d66d69e-03ee-4dd6-91a6-bd8da47a2fbe	9d66d69e-04f7-4740-b12e-c68d8f45afd2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T02:27:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"0"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":265,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:08:49
39859	9d6cb868-ca4a-41fc-9311-5aac5a1a8ccf	9d6cb868-ec11-4c88-aafd-6aba78928b9d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:19:19
39860	9d6cb868-e62b-4f5c-964d-5fdea1ec18aa	9d6cb868-ec11-4c88-aafd-6aba78928b9d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"51.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:19:19
39861	9d6cb868-e677-4edf-af56-90696a41a307	9d6cb868-ec11-4c88-aafd-6aba78928b9d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:19:19
39862	9d6cb868-eabc-4f4c-89a5-ac68c9837f68	9d6cb868-ec11-4c88-aafd-6aba78928b9d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:19:19
39863	9d6cb868-eb06-463e-95fd-84db4abfe959	9d6cb868-ec11-4c88-aafd-6aba78928b9d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":289,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:19:19
19465	9d66d69f-85a1-488f-9f26-ba28798b4e2e	9d66d69f-af9c-4899-b0fe-cf21c290407f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:08:50
19466	9d66d69f-aa12-4311-820c-59a7218d19c1	9d66d69f-af9c-4899-b0fe-cf21c290407f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"53.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:08:50
19467	9d66d69f-aa85-4d7d-8178-1237e7bf17d1	9d66d69f-af9c-4899-b0fe-cf21c290407f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:08:50
19468	9d66d69f-ae4b-4ca8-a55d-5c2621ccd854	9d66d69f-af9c-4899-b0fe-cf21c290407f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 11:08:50
19469	9d66d69f-ae91-4d2e-9bb5-680c4d18895c	9d66d69f-af9c-4899-b0fe-cf21c290407f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":456,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:08:50
39864	9d6cb870-165f-4b8a-a9fc-b4677521d842	9d6cb870-370e-48c1-a519-2b720c65c5e9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:19:23
39865	9d6cb870-3207-4094-81bc-a9cdea9c53d2	9d6cb870-370e-48c1-a519-2b720c65c5e9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:19:23
39866	9d6cb870-3252-4d38-90b2-387eef83e5f0	9d6cb870-370e-48c1-a519-2b720c65c5e9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:19:23
39867	9d6cb870-35ac-4134-bc24-44d96200930b	9d6cb870-370e-48c1-a519-2b720c65c5e9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:19:23
39868	9d6cb870-3603-4419-87fd-6012d4387728	9d6cb870-370e-48c1-a519-2b720c65c5e9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":394,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:19:23
19470	9d66d7e0-e7c9-46f1-b8e5-758a404518b9	9d66d7e0-eb97-4ebf-ba62-da492151d2e0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":169,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:12:20
39869	9d6cb8fe-b323-4239-802b-95087939966e	9d6cb8fe-d666-4a01-9c7b-33b3c3344675	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 09:20:57
39870	9d6cb8fe-cfcb-477f-b5bc-ddab596d622a	9d6cb8fe-d666-4a01-9c7b-33b3c3344675	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"39.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:20:57
39871	9d6cb8fe-d02f-4bbe-b6fd-31d6734feb1c	9d6cb8fe-d666-4a01-9c7b-33b3c3344675	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:20:57
39872	9d6cb8fe-d4c4-46cf-8a1c-e1df7ce84995	9d6cb8fe-d666-4a01-9c7b-33b3c3344675	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:20:57
39873	9d6cb8fe-d521-427d-abc2-288a22f2d122	9d6cb8fe-d666-4a01-9c7b-33b3c3344675	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:20:57
19471	9d66d7e1-450e-4d69-93be-6e4e608949aa	9d66d7e1-95fd-4ab4-b0a9-1cce05c6a3e6	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 11:12:20
19472	9d66d7e1-71a0-422b-ae7b-690cab3c8a15	9d66d7e1-95fd-4ab4-b0a9-1cce05c6a3e6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 182 limit 1","time":"3.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":354,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-03 11:12:21
19473	9d66d7e1-7200-417a-b4b3-f301974c077e	9d66d7e1-95fd-4ab4-b0a9-1cce05c6a3e6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-03 11:12:21
19474	9d66d7e1-7d3f-4f75-8e59-d63945d59cb8	9d66d7e1-95fd-4ab4-b0a9-1cce05c6a3e6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 61 limit 1","time":"2.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":355,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 11:12:21
19475	9d66d7e1-7d86-462c-88b2-9d3e3d0b00a7	9d66d7e1-95fd-4ab4-b0a9-1cce05c6a3e6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 11:12:21
19476	9d66d7e1-89e5-4463-bedf-1c62328f1802	9d66d7e1-95fd-4ab4-b0a9-1cce05c6a3e6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '03-11-2024', \\"itemloans_cuota_cancelada\\" = '100000', \\"updated_at\\" = '2024-11-03 11:12:21' where \\"id\\" = 182","time":"2.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":382,"hash":"35b67f849e4a0ba5090d9c1eb8abfe94","hostname":"EderCortes"}	2024-11-03 11:12:21
19477	9d66d7e1-8fce-466b-a370-7f639c081955	9d66d7e1-95fd-4ab4-b0a9-1cce05c6a3e6	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:182","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-03 11:12:21","item_loans_cuando_pago":"03-11-2024","itemloans_cuota_cancelada":"100000"},"hostname":"EderCortes"}	2024-11-03 11:12:21
19478	9d66d7e1-90b8-4c74-8327-9bd9a3b22acf	9d66d7e1-95fd-4ab4-b0a9-1cce05c6a3e6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_estado\\" = 'En curso', \\"loans_fecha_ultimo_pago\\" = '03-11-2024', \\"updated_at\\" = '2024-11-03 11:12:21' where \\"id\\" = 61","time":"1.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":390,"hash":"401474b65cdf866a42a346357071e5f1","hostname":"EderCortes"}	2024-11-03 11:12:21
19479	9d66d7e1-90eb-4a78-b283-0b5e4c7c82dc	9d66d7e1-95fd-4ab4-b0a9-1cce05c6a3e6	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:61","changes":{"loans_estado":"En curso","updated_at":"2024-11-03 11:12:21","loans_fecha_ultimo_pago":"03-11-2024"},"hostname":"EderCortes"}	2024-11-03 11:12:21
19480	9d66d7e1-949d-4eb2-b772-e9488b0336d7	9d66d7e1-95fd-4ab4-b0a9-1cce05c6a3e6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:12:21
19481	9d66d7e1-94ef-4d7b-aff0-b21c6419bac7	9d66d7e1-95fd-4ab4-b0a9-1cce05c6a3e6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"179","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000","id":182,"loans_codigo":61,"itemloans_cuota":"1","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:12:21
39874	9d6cb92a-aa84-4cf1-9f0c-cd4fe6e899e0	9d6cb92a-c868-4e8d-bcad-ce24d0b7ab61	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:21:26
39875	9d6cb92a-c29d-4951-8bf2-ed7c152b74a1	9d6cb92a-c868-4e8d-bcad-ce24d0b7ab61	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:21:26
39876	9d6cb92a-c300-4dba-a622-8844c1005616	9d6cb92a-c868-4e8d-bcad-ce24d0b7ab61	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:21:26
39877	9d6cb92a-c6d3-4ca0-8ad3-4f366553b924	9d6cb92a-c868-4e8d-bcad-ce24d0b7ab61	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:21:26
39878	9d6cb92a-c71a-4101-9460-74f278bccf25	9d6cb92a-c868-4e8d-bcad-ce24d0b7ab61	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":431,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:21:26
19482	9d66d7e1-edaf-4797-a864-6de583384e39	9d66d7e2-0c3f-47c4-95f3-eb00f783a86e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:12:21
19483	9d66d7e2-0350-4a37-8020-652b0641edc0	9d66d7e2-0c3f-47c4-95f3-eb00f783a86e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"42.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 11:12:21
19484	9d66d7e2-06dc-4597-bbf2-acd15e845d36	9d66d7e2-0c3f-47c4-95f3-eb00f783a86e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:12:21
19485	9d66d7e2-070c-43b2-ab41-a12d9f4d0db4	9d66d7e2-0c3f-47c4-95f3-eb00f783a86e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:12:21
19486	9d66d7e2-0af2-42dc-9d8a-1193491d4362	9d66d7e2-0c3f-47c4-95f3-eb00f783a86e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:12:21
19487	9d66d7e2-0b37-484f-abd1-4d5c4f9933ca	9d66d7e2-0c3f-47c4-95f3-eb00f783a86e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":281,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:12:21
39879	9d6cb92b-2385-4444-9ac9-40ff1abfa8f7	9d6cb92b-261f-4649-bd0f-1638fd6e9d34	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":404,"response":{"error":"No se encontro la url especificada","code":404},"duration":207,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:21:26
26773	9d68dc20-f62d-4137-a495-eed73e87186d	9d68dc21-2d47-4d46-9aee-c4af7a84e32d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:15:53
26774	9d68dc21-297d-4501-9889-e8d9061dad47	9d68dc21-2d47-4d46-9aee-c4af7a84e32d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:15:53
26775	9d68dc21-2af7-4df3-8821-27163b1b8696	9d68dc21-2d47-4d46-9aee-c4af7a84e32d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":596,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:15:53
39880	9d6cb95e-03a2-473a-95d5-0d2b474adce4	9d6cb95e-48c6-4ed5-acfe-63a0b6e79e84	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 09:21:59
39881	9d6cb95e-3b95-478b-a039-754f22ccd48c	9d6cb95e-48c6-4ed5-acfe-63a0b6e79e84	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"73.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:21:59
39882	9d6cb95e-3c4a-40de-90d9-3ec023876d7d	9d6cb95e-48c6-4ed5-acfe-63a0b6e79e84	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:21:59
39883	9d6cb95e-4549-4772-8c3f-3becb003e03f	9d6cb95e-48c6-4ed5-acfe-63a0b6e79e84	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:21:59
39884	9d6cb95e-461b-483e-a6ea-4e83e302a38b	9d6cb95e-48c6-4ed5-acfe-63a0b6e79e84	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":601,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:21:59
22224	9d6743a2-b06b-43ab-ab6d-467198e055b7	9d6743a2-cd90-494e-a55f-09ad259e500e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 16:13:39
22225	9d6743a2-cb8a-4792-bd4b-28b43c8f8492	9d6743a2-cd90-494e-a55f-09ad259e500e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 16:13:39
22226	9d6743a2-cc76-42b3-99ab-6e312f7db318	9d6743a2-cd90-494e-a55f-09ad259e500e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":272,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:13:39
26776	9d68dc22-0253-4081-894d-1c6d3bf735ce	9d68dc22-3192-40bf-aacb-38be0614a727	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:15:53
26777	9d68dc22-2768-4117-8340-a86d4b6cd1df	9d68dc22-3192-40bf-aacb-38be0614a727	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"73.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 11:15:53
39885	9d6cb95f-3cfd-407f-980b-059bf70af45b	9d6cb95f-40cc-4647-8a0e-4352a99e4a7d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":404,"response":{"error":"No se encontro la url especificada","code":404},"duration":597,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:22:00
26778	9d68dc22-2f0d-4faf-b130-2c2ee0bb8dfe	9d68dc22-3192-40bf-aacb-38be0614a727	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:15:53
22227	9d6743a3-1963-4f76-b814-5136a136808b	9d6743a3-35ba-40df-8937-e18a15ff1032	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 16:13:39
22228	9d6743a3-30ba-42c6-b952-8f8b5deed180	9d6743a3-35ba-40df-8937-e18a15ff1032	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"38.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 16:13:39
22229	9d6743a3-3110-47b9-94b3-a64c72607978	9d6743a3-35ba-40df-8937-e18a15ff1032	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 16:13:39
22230	9d6743a3-3495-44de-8b27-e2ef92f12037	9d6743a3-35ba-40df-8937-e18a15ff1032	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 16:13:39
18000	9d65b675-109c-4e80-a0f0-59a922f0565e	9d65b675-3b6c-42e5-bab0-a53ae893dc53	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 21:43:03
18001	9d65b675-3916-4595-a820-2bfb8c3d85be	9d65b675-3b6c-42e5-bab0-a53ae893dc53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:43:03
18002	9d65b675-3a0f-4a51-9b52-b36d726000dd	9d65b675-3b6c-42e5-bab0-a53ae893dc53	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":363,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:43:03
22231	9d6743a3-34e1-43fa-bf7e-ad6efd6b82b6	9d6743a3-35ba-40df-8937-e18a15ff1032	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:13:39
26779	9d68dc22-2fe7-4fb6-bd46-e8fcf7ff3c76	9d68dc22-3192-40bf-aacb-38be0614a727	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":591,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:15:53
39886	9d6cbb4b-95b3-48e2-96f7-fa6ee32f5f0b	9d6cbb4b-f643-48c8-92e1-f47bfea8495a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 09:27:23
39887	9d6cbb4b-ed38-4d95-bf77-c32ad0e6b3f5	9d6cbb4b-f643-48c8-92e1-f47bfea8495a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"162.68","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:27:23
39888	9d6cbb4b-edb8-4c14-964c-2b0c8e4468a9	9d6cbb4b-f643-48c8-92e1-f47bfea8495a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:27:23
39889	9d6cbb4b-f449-47b5-9de5-593025de6c1a	9d6cbb4b-f643-48c8-92e1-f47bfea8495a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:27:23
39890	9d6cbb4b-f4ce-4df3-90b6-1bcbbf430d9c	9d6cbb4b-f643-48c8-92e1-f47bfea8495a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":571,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:27:23
18003	9d65b675-a78d-4672-9830-5842430b8aff	9d65b675-f380-436f-b951-c726c40c875c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:43:04
18004	9d65b675-e925-42ec-be10-c3e05ac36319	9d65b675-f380-436f-b951-c726c40c875c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"150.68","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"2b11ef88578e3c91c11800e110e490df","hostname":"EderCortes"}	2024-11-02 21:43:04
18005	9d65b675-ecd9-4573-989b-62b20cbdaed1	9d65b675-f380-436f-b951-c726c40c875c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"2.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:43:04
18006	9d65b675-ed10-48ac-b8bd-ed0216f76910	9d65b675-f380-436f-b951-c726c40c875c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:43:04
18007	9d65b675-f224-4132-89dd-c1f2b141cb24	9d65b675-f380-436f-b951-c726c40c875c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:43:04
18008	9d65b675-f277-4f0b-bfca-19033f29d462	9d65b675-f380-436f-b951-c726c40c875c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":428,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:43:04
22232	9d6743a3-73d6-4d64-9999-76013e288970	9d6743a3-9020-4cf0-909b-556fdec5092e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 16:13:39
22233	9d6743a3-8b2e-48d9-9329-bfedcbf2e1e0	9d6743a3-9020-4cf0-909b-556fdec5092e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 16:13:39
22234	9d6743a3-8b7e-4efb-9caa-52918a842516	9d6743a3-9020-4cf0-909b-556fdec5092e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-03 16:13:39
22235	9d6743a3-8eeb-40f6-bf40-93eae5a1d01c	9d6743a3-9020-4cf0-909b-556fdec5092e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-03 16:13:39
22236	9d6743a3-8f35-4839-8c15-53bf60ccd8ce	9d6743a3-9020-4cf0-909b-556fdec5092e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":217,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:13:39
26780	9d68dc22-d836-4971-af6a-fc42d2b7fec9	9d68dc23-1346-4568-afa6-5e8b05500afc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:15:54
26781	9d68dc23-07ae-4b50-8c69-0fbb72e52d7d	9d68dc23-1346-4568-afa6-5e8b05500afc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"82.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:15:54
26782	9d68dc23-085b-4f4e-9b16-5a753882a13c	9d68dc23-1346-4568-afa6-5e8b05500afc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:15:54
26783	9d68dc23-10f0-4a23-a917-83d424754858	9d68dc23-1346-4568-afa6-5e8b05500afc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:15:54
18009	9d65b678-0b4a-4e2b-aab1-0e0dbdde0e5a	9d65b678-4f15-476b-8e19-75512fea98ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:43:05
18010	9d65b678-49bf-4fe4-88c8-ab16d956e29c	9d65b678-4f15-476b-8e19-75512fea98ef	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"139.46","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 21:43:05
18011	9d65b678-4a0e-4c6f-a1e0-2b4da4e82c32	9d65b678-4f15-476b-8e19-75512fea98ef	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 21:43:05
18012	9d65b678-4dd7-4db1-a0de-378df0cfca9f	9d65b678-4f15-476b-8e19-75512fea98ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 21:43:05
18013	9d65b678-4e1e-4d96-b5b8-99926eb44eb0	9d65b678-4f15-476b-8e19-75512fea98ef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:43:05
26784	9d68dc23-1194-4a02-acc1-24ad590ec04e	9d68dc23-1346-4568-afa6-5e8b05500afc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":558,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:15:54
26785	9d68dc24-a974-4af8-a4ef-6e6c41de4dcc	9d68dc24-d7da-414a-b76b-cb8818c54ae9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:15:55
26786	9d68dc24-cbf0-472f-8710-9e1902b2994b	9d68dc24-d7da-414a-b76b-cb8818c54ae9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"57.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:15:55
26787	9d68dc24-cc72-4053-8521-ef99d59eb040	9d68dc24-d7da-414a-b76b-cb8818c54ae9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:15:55
26788	9d68dc24-d61a-440c-9b13-b4de1be0750c	9d68dc24-d7da-414a-b76b-cb8818c54ae9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 11:15:55
26789	9d68dc24-d689-4acd-bcb5-1abdb0b2d0a3	9d68dc24-d7da-414a-b76b-cb8818c54ae9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":605,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:15:55
40690	9d6cc68f-17d2-4028-82cc-f69d260fa9a8	9d6cc68f-1b69-496b-bb5b-bd3b90cc9024	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1842}	2024-11-06 09:58:52
26790	9d68dc30-9e6a-4f56-a5ae-c05757bf324b	9d68dc30-c17c-49a4-848d-b43c3262134a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 11:16:03
26791	9d68dc30-bb3d-4fe4-9912-906a65b618b5	9d68dc30-c17c-49a4-848d-b43c3262134a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"45.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 11:16:03
26792	9d68dc30-bf83-4c1b-891b-fcba472f996e	9d68dc30-c17c-49a4-848d-b43c3262134a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:16:03
26793	9d68dc30-c02b-4d47-8b41-96b283f63e68	9d68dc30-c17c-49a4-848d-b43c3262134a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":372,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:16:03
26794	9d68dc34-1f8d-4388-b122-d59fe3e89799	9d68dc34-4187-4df2-b6b7-eb86cf854748	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:16:05
26795	9d68dc34-3743-4a1c-9f20-f4824e62df38	9d68dc34-4187-4df2-b6b7-eb86cf854748	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"46.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:16:05
26796	9d68dc34-3bc2-4fdc-a5f0-5ffaf61946e5	9d68dc34-4187-4df2-b6b7-eb86cf854748	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:16:05
15979	9d64b763-cf95-45e3-930e-02557598a7e8	9d64b763-fb72-4fa7-8103-4323d8ebcaf2	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 09:49:50
15980	9d64b763-f8b2-4d9f-bfa8-f2f239212f19	9d64b763-fb72-4fa7-8103-4323d8ebcaf2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:49:50
15981	9d64b763-fa0a-4b5d-b2dd-c2515584563b	9d64b763-fb72-4fa7-8103-4323d8ebcaf2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":296,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:49:50
26797	9d68dc34-3bf1-4b78-a475-59e7c5e9e18e	9d68dc34-4187-4df2-b6b7-eb86cf854748	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:16:05
26798	9d68dc34-401d-496a-9742-f26ca40ca9ae	9d68dc34-4187-4df2-b6b7-eb86cf854748	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:16:05
26799	9d68dc34-406f-4b03-9cd8-6be031157333	9d68dc34-4187-4df2-b6b7-eb86cf854748	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":442,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:16:05
15982	9d64b764-637a-43a6-8223-badf138566bb	9d64b764-87e8-451c-b932-c800e20b387f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:49:51
15983	9d64b764-7d25-45a2-848c-423db8af251f	9d64b764-87e8-451c-b932-c800e20b387f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 22\\n                        ","time":"52.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"f9344e277d181987f84c6dcddcb4342d","hostname":"EderCortes"}	2024-11-02 09:49:51
15984	9d64b764-8103-426e-81dd-f26f33ab93bd	9d64b764-87e8-451c-b932-c800e20b387f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '22' order by \\"item_loans\\".\\"id\\" asc","time":"2.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:49:51
15985	9d64b764-8163-494e-9dff-f4f5b0dacdfd	9d64b764-87e8-451c-b932-c800e20b387f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-02 09:49:51
15986	9d64b764-866a-4172-af6b-7c07a86edde0	9d64b764-87e8-451c-b932-c800e20b387f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:49:51
15987	9d64b764-86c9-4790-9868-6d802a6f69bc	9d64b764-87e8-451c-b932-c800e20b387f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/22","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":22,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":70,"loans_codigo":22,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":71,"loans_codigo":22,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":72,"loans_codigo":22,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":73,"loans_codigo":22,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":74,"loans_codigo":22,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":75,"loans_codigo":22,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-04-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:49:51
22336	9d674a88-d199-4368-9246-793ae30cfabe	9d674a88-f021-440b-b2eb-5425343bfb9a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 16:32:56
22337	9d674a88-ee73-4859-8482-640b8ac050d3	9d674a88-f021-440b-b2eb-5425343bfb9a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 16:32:56
15988	9d64b766-79bd-4383-adb9-5771d035e329	9d64b766-c1c4-4204-9a4d-a972943e46b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:49:52
15989	9d64b766-bbf1-46ba-a3f2-aa20f3aa032a	9d64b766-c1c4-4204-9a4d-a972943e46b2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"151.95","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 09:49:52
15990	9d64b766-bc51-45d0-bbb1-1dbdfd807e7a	9d64b766-c1c4-4204-9a4d-a972943e46b2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 09:49:52
15991	9d64b766-c023-4d36-a838-33d385b6c482	9d64b766-c1c4-4204-9a4d-a972943e46b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 09:49:52
15992	9d64b766-c094-4903-ae09-f6918c72d4e3	9d64b766-c1c4-4204-9a4d-a972943e46b2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":362,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:49:52
22338	9d674a88-ef0f-433c-a336-4c206f27e005	9d674a88-f021-440b-b2eb-5425343bfb9a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":268,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:32:56
22339	9d674a89-4600-438c-b6de-4bd1a338043f	9d674a89-672b-49ea-8559-decf326e3a6d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 16:32:57
22020	9d674170-f3f0-47b9-9a2e-1849edc921e4	9d674171-1436-4f2a-a05c-e9b59634ae18	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-03 16:07:31
22021	9d674171-126c-47d5-a380-7ff664e02267	9d674171-1436-4f2a-a05c-e9b59634ae18	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-03 16:07:31
22022	9d674171-133e-4de9-967d-2870bec75c78	9d674171-1436-4f2a-a05c-e9b59634ae18	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":296,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:07:31
16957	9d654663-1e30-44d3-be14-c53acf37cf63	9d654663-3a83-4192-96a5-42be5bf2865b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 16:29:41
16958	9d654663-38f8-4cf9-9e14-3b58f5674827	9d654663-3a83-4192-96a5-42be5bf2865b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 16:29:41
16959	9d654663-3994-4c2e-b288-28431c1d5336	9d654663-3a83-4192-96a5-42be5bf2865b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42P01]: Undefined table: 7 ERROR:  falta una entrada para la tabla \\u00abl\\u00bb en la cl\\u00e1usula FROM\\nLINE 1: select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", ...\\n               ^ (Connection: pgsql, SQL: select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" inner join \\"users\\" as \\"ucl\\" on \\"loans\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"loans\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"loans\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id \\" desc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":42,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:29:41
22340	9d674a89-60ed-4f7a-9d30-ea0ae3c0837b	9d674a89-672b-49ea-8559-decf326e3a6d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 16:32:57
22341	9d674a89-614e-4140-af08-e0abf45afd94	9d674a89-672b-49ea-8559-decf326e3a6d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 16:32:57
22342	9d674a89-65a0-485d-ad6e-4985130babb8	9d674a89-672b-49ea-8559-decf326e3a6d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 16:32:57
22343	9d674a89-660e-4e1d-a665-9c33a0cade2c	9d674a89-672b-49ea-8559-decf326e3a6d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:32:57
26915	9d68dd93-6fb3-4248-978e-4ab6a7cb9b7b	9d68dd93-a2db-408d-8645-583cea4f9192	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:19:55
26916	9d68dd93-9ffd-4142-a099-406ad6433c43	9d68dd93-a2db-408d-8645-583cea4f9192	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:19:55
26917	9d68dd93-a15d-4ed3-8827-2810e50f35a6	9d68dd93-a2db-408d-8645-583cea4f9192	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":586,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:19:55
22023	9d674171-61bd-4998-90c1-b0028cb8a652	9d674171-aebc-4ad5-85ee-fb9d1a178d71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-03 16:07:31
22024	9d674171-a694-48d0-9a17-fb5edcc332a1	9d674171-aebc-4ad5-85ee-fb9d1a178d71	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"154.79","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 16:07:31
22025	9d674171-a6ff-42a5-863c-55dda83dfbd1	9d674171-aebc-4ad5-85ee-fb9d1a178d71	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 16:07:31
22026	9d674171-ad00-4cf0-a97a-5ec33bff5d2e	9d674171-aebc-4ad5-85ee-fb9d1a178d71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-03 16:07:31
22027	9d674171-ad6f-4e6d-bd58-503a55ceff39	9d674171-aebc-4ad5-85ee-fb9d1a178d71	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":350,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:07:31
22344	9d674a89-af56-4aff-bf0f-c0ec73c5c2b8	9d674a89-d262-48db-82d4-52a0f4978910	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 16:32:57
22345	9d674a89-cab6-48f5-9970-dd336c68abab	9d674a89-d262-48db-82d4-52a0f4978910	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 16:32:57
22346	9d674a89-cb39-41a4-b235-fdd3a952751d	9d674a89-d262-48db-82d4-52a0f4978910	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-03 16:32:57
22347	9d674a89-d106-4a5b-ad23-1e7d1fe64009	9d674a89-d262-48db-82d4-52a0f4978910	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-03 16:32:57
22348	9d674a89-d162-4434-895c-816b3f7ede0b	9d674a89-d262-48db-82d4-52a0f4978910	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":260,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:32:57
26918	9d68dd94-631b-450f-b269-d619a4a5a35c	9d68dd94-da88-40ba-b362-3f8acecaf90a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:19:56
26919	9d68dd94-cf63-40e9-b9f8-7fe48c27fcca	9d68dd94-da88-40ba-b362-3f8acecaf90a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"204.06","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:19:56
26920	9d68dd94-d01e-4761-8b97-fecee92083f5	9d68dd94-da88-40ba-b362-3f8acecaf90a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:19:56
26921	9d68dd94-d833-4e97-a92d-e493b7cc0c38	9d68dd94-da88-40ba-b362-3f8acecaf90a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:19:56
26922	9d68dd94-d8c9-4f96-824c-18499d96903d	9d68dd94-da88-40ba-b362-3f8acecaf90a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":734,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:19:56
19590	9d66e129-3e6d-47c6-970e-8e90aad02c32	9d66e129-9248-4197-85d4-d2194acd30d3	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 11:38:18
19591	9d66e129-9011-4db5-85d9-6f73db7eb44f	9d66e129-9248-4197-85d4-d2194acd30d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:38:18
19592	9d66e129-90d6-46dc-90d4-f7f7ec03ec9c	9d66e129-9248-4197-85d4-d2194acd30d3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":428,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:38:18
26923	9d68dd96-399a-41e7-a68c-999b357e19ba	9d68dd96-6aee-4fe0-8aeb-c305cfc3997d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:19:57
26924	9d68dd96-60a2-4848-ba0d-a88380719958	9d68dd96-6aee-4fe0-8aeb-c305cfc3997d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"62.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:19:57
26925	9d68dd96-612d-492e-a9b7-f7c55675d7b1	9d68dd96-6aee-4fe0-8aeb-c305cfc3997d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:19:57
26926	9d68dd96-687e-4bb1-9f5b-e7328f7bf72e	9d68dd96-6aee-4fe0-8aeb-c305cfc3997d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:19:57
19593	9d66e12a-0912-49fd-a3c8-baf49d973ea3	9d66e12a-33ee-479f-a4c0-5cb347327435	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:38:18
19594	9d66e12a-2640-47e7-a53a-213877280185	9d66e12a-33ee-479f-a4c0-5cb347327435	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"57.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 11:38:18
19595	9d66e12a-2c2c-4563-80ba-996dec02c201	9d66e12a-33ee-479f-a4c0-5cb347327435	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:38:18
19596	9d66e12a-2c70-486c-ae4e-f55e5ef7236a	9d66e12a-33ee-479f-a4c0-5cb347327435	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:38:18
19597	9d66e12a-321e-4fc4-b765-282ff5b3f512	9d66e12a-33ee-479f-a4c0-5cb347327435	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:38:18
19598	9d66e12a-32aa-4dab-8c56-1cdd7e2386dd	9d66e12a-33ee-479f-a4c0-5cb347327435	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":365,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:38:18
22028	9d674172-0395-40a7-8879-48ac05fea964	9d674172-68d8-4283-a82d-e743add649df	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-03 16:07:31
22029	9d674172-5c23-4c30-843d-3667fda75426	9d674172-68d8-4283-a82d-e743add649df	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"203.68","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 16:07:32
22030	9d674172-5cb8-4079-ae69-3b8e7cf291ba	9d674172-68d8-4283-a82d-e743add649df	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-03 16:07:32
22031	9d674172-66d3-49a1-82be-1f3a3e0e3c4b	9d674172-68d8-4283-a82d-e743add649df	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-03 16:07:32
22032	9d674172-6762-4b77-a1e2-b55f23d9354b	9d674172-68d8-4283-a82d-e743add649df	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":453,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:07:32
19599	9d66e12c-446e-465a-9042-ab2cafb2576f	9d66e12c-6269-4e35-ac8b-18133ae169d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:38:20
19600	9d66e12c-5d06-473c-8b5a-2a701aaf46a9	9d66e12c-6269-4e35-ac8b-18133ae169d1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:38:20
19601	9d66e12c-5d66-4a03-8553-446ee8195d76	9d66e12c-6269-4e35-ac8b-18133ae169d1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:38:20
19602	9d66e12c-612f-47b2-9a80-b10a665791f4	9d66e12c-6269-4e35-ac8b-18133ae169d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 11:38:20
19603	9d66e12c-6171-4b32-858a-163abe6bebb5	9d66e12c-6269-4e35-ac8b-18133ae169d1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:38:20
26927	9d68dd96-690b-4d1e-a6bc-8a4a329dc385	9d68dd96-6aee-4fe0-8aeb-c305cfc3997d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":712,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:19:57
26928	9d68dd9a-0f88-40bd-aef6-094e606cb04a	9d68dd9a-33d4-4cec-aab3-5781288e4473	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:20:00
26929	9d68dd9a-2c7e-44df-ab76-485b0f30ae67	9d68dd9a-33d4-4cec-aab3-5781288e4473	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"44.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-04 11:20:00
26930	9d68dd9a-2cef-464a-ac36-b0cd57e65e5a	9d68dd9a-33d4-4cec-aab3-5781288e4473	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 11:20:00
26931	9d68dd9a-322f-4293-b4cc-53c40967a9f1	9d68dd9a-33d4-4cec-aab3-5781288e4473	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:20:00
26932	9d68dd9a-329b-42fe-9d38-ded34179da96	9d68dd9a-33d4-4cec-aab3-5781288e4473	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":483,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:20:00
4851	9d513612-cf42-4e9e-a520-dcf8431e7bfc	9d513612-d35a-427c-ae73-f3e16a1e4264	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":261}	2024-10-23 17:07:31
27120	9d68e244-ac32-40be-bcc1-49c37e95efbf	9d68e244-f0b4-4338-ab2f-f17ddf965390	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:33:03
27121	9d68e244-ed89-47af-af49-24dc0df0c645	9d68e244-f0b4-4338-ab2f-f17ddf965390	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:33:03
27122	9d68e244-eeef-470d-9f74-b781b71cf7aa	9d68e244-f0b4-4338-ab2f-f17ddf965390	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":876,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:33:03
29316	9d691813-411c-4cf5-8bda-44317a3c84af	9d691813-52ce-4f88-a437-e44f39e02437	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1375}	2024-11-04 14:03:30
13857	9d5d12bd-2949-4a27-831e-88f3e843bce9	9d5d12bd-2f08-4094-ad56-d693d6b17ca8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":640}	2024-10-29 14:38:39
15183	9d5ecf41-daa4-4f40-b6c0-7fe2237504a0	9d5ecf42-2cb1-4c7d-8e75-3763b4731e2b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-30 11:21:36
15184	9d5ecf42-2a31-42aa-ac44-c69af22730ba	9d5ecf42-2cb1-4c7d-8e75-3763b4731e2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 11:21:37
15185	9d5ecf42-2afc-4365-86f6-6fa1c7e0c713	9d5ecf42-2cb1-4c7d-8e75-3763b4731e2b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":484,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:21:37
27123	9d68e245-b2e9-4436-b523-e7627a94ccf9	9d68e245-e2a4-4559-8378-104a0cdc2d4f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:33:03
27124	9d68e245-d964-48b6-ade8-a3d2bdf64d47	9d68e245-e2a4-4559-8378-104a0cdc2d4f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"58.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:33:03
27125	9d68e245-d9f0-4765-8a77-9707c6079cea	9d68e245-e2a4-4559-8378-104a0cdc2d4f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:33:03
27126	9d68e245-e0b9-4fc8-a8b4-c842bc90c3be	9d68e245-e2a4-4559-8378-104a0cdc2d4f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:33:03
16069	9d64b94d-c38f-4a13-ba8a-ee6822939683	9d64b94e-1396-4a44-8c87-8cd6150edcf0	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 09:55:11
16070	9d64b94e-1083-4783-b0de-49e92cad87c6	9d64b94e-1396-4a44-8c87-8cd6150edcf0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:55:11
16071	9d64b94e-11dc-4091-8490-99772c433026	9d64b94e-1396-4a44-8c87-8cd6150edcf0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":393,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:55:11
27127	9d68e245-e147-4df6-9e2d-15f7ce858e86	9d68e245-e2a4-4559-8378-104a0cdc2d4f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":541,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:33:03
16072	9d64b94e-842c-4bab-9fad-00c42db4de88	9d64b94e-d02e-4c38-b3b3-e5c572f66ac8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 09:55:12
16073	9d64b94e-c49f-44c0-940c-8fc0763c15d7	9d64b94e-d02e-4c38-b3b3-e5c572f66ac8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 22\\n                        ","time":"149.22","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"f9344e277d181987f84c6dcddcb4342d","hostname":"EderCortes"}	2024-11-02 09:55:12
16074	9d64b94e-c866-41cf-8b52-0160ee8b4022	9d64b94e-d02e-4c38-b3b3-e5c572f66ac8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '22' order by \\"item_loans\\".\\"id\\" asc","time":"2.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:55:12
16075	9d64b94e-c8a2-4a5c-bda0-f3dc74785a10	9d64b94e-d02e-4c38-b3b3-e5c572f66ac8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-02 09:55:12
16076	9d64b94e-ce6e-48e3-b29a-5913c4da59ef	9d64b94e-d02e-4c38-b3b3-e5c572f66ac8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:55:12
16077	9d64b94e-cefd-4ada-b17f-0c2ba341d4ef	9d64b94e-d02e-4c38-b3b3-e5c572f66ac8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/22","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":22,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":70,"loans_codigo":22,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":71,"loans_codigo":22,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":72,"loans_codigo":22,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":73,"loans_codigo":22,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":74,"loans_codigo":22,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":75,"loans_codigo":22,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-04-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":435,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:55:12
27128	9d68e246-83b6-4441-bc1d-efe7e2e2f9fb	9d68e246-ae29-4fd7-bd50-b9f17ef9cf72	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:33:04
27129	9d68e246-a5f8-4763-a312-829aa3b2d82b	9d68e246-ae29-4fd7-bd50-b9f17ef9cf72	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"56.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:33:04
22504	9d674fcd-0c60-49bb-89b8-ea5047aed239	9d674fcd-65c3-4675-951f-9803c895172f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 16:47:40
22505	9d674fcd-63a9-4e30-b13e-2c65aee8ce9d	9d674fcd-65c3-4675-951f-9803c895172f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 16:47:40
27130	9d68e246-a677-4dfb-8839-6231c466f9e2	9d68e246-ae29-4fd7-bd50-b9f17ef9cf72	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 11:33:04
27131	9d68e246-ac68-4d5e-af77-57cf69482932	9d68e246-ae29-4fd7-bd50-b9f17ef9cf72	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:33:04
27132	9d68e246-acdd-4127-b8c1-560c3c163bf6	9d68e246-ae29-4fd7-bd50-b9f17ef9cf72	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":498,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:33:04
16078	9d64b950-c1ee-4e8d-9a0e-5c44f956b19b	9d64b951-1481-4db8-88d2-a8f401fed737	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 09:55:13
16079	9d64b951-0e26-452f-a25a-03515af47353	9d64b951-1481-4db8-88d2-a8f401fed737	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"163.94","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 09:55:13
16080	9d64b951-0e93-444f-b303-e5452937a36e	9d64b951-1481-4db8-88d2-a8f401fed737	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 09:55:13
16081	9d64b951-12f6-4400-a478-f8c62becbf1e	9d64b951-1481-4db8-88d2-a8f401fed737	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 09:55:13
16082	9d64b951-1357-4614-8115-f1d6a91d9fee	9d64b951-1481-4db8-88d2-a8f401fed737	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":477,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:55:13
22506	9d674fcd-64a1-4e9d-ac81-620cf549e7f6	9d674fcd-65c3-4675-951f-9803c895172f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":551,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:47:40
27133	9d68e248-0f48-4652-b605-11e6ab1c9c45	9d68e248-695b-4cee-becd-a0ead458b456	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:33:05
27134	9d68e248-5f66-4c72-9d71-16cd5c255b09	9d68e248-695b-4cee-becd-a0ead458b456	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"133.89","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:33:05
27135	9d68e248-6004-4a92-9b0c-a6f6544ef26b	9d68e248-695b-4cee-becd-a0ead458b456	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:33:05
27136	9d68e248-674d-4e5e-be61-6b67efd34a89	9d68e248-695b-4cee-becd-a0ead458b456	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:33:05
27137	9d68e248-67e0-4f59-b71d-7b0989335e50	9d68e248-695b-4cee-becd-a0ead458b456	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1112,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:33:05
22507	9d674fcd-de09-49f4-a8b2-a947b8883e44	9d674fce-0321-4073-9da7-63b9a1df1556	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 16:47:40
22508	9d674fcd-fc89-4d02-8c33-a02186f26721	9d674fce-0321-4073-9da7-63b9a1df1556	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 16:47:40
22509	9d674fcd-fd05-45df-b8d3-d69abe0da520	9d674fce-0321-4073-9da7-63b9a1df1556	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 16:47:40
22510	9d674fce-01a5-4934-9eae-de8226b6aa4c	9d674fce-0321-4073-9da7-63b9a1df1556	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 16:47:40
22511	9d674fce-021a-45cf-af09-fc25ab26b039	9d674fce-0321-4073-9da7-63b9a1df1556	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:47:40
27138	9d68e249-48c2-4676-b3a0-cdff3c017337	9d68e249-7762-41f3-a84f-836763d5bab7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:33:06
27139	9d68e249-6ca9-4148-ab03-767e8b9de358	9d68e249-7762-41f3-a84f-836763d5bab7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"57.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:33:06
27140	9d68e249-6d24-40fb-90a5-878b8f3e73ee	9d68e249-7762-41f3-a84f-836763d5bab7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:33:06
27141	9d68e249-74c7-4a83-86fe-b0b383dc81d4	9d68e249-7762-41f3-a84f-836763d5bab7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:33:06
27142	9d68e249-757a-4c99-a23b-bfeec721b247	9d68e249-7762-41f3-a84f-836763d5bab7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":661,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:33:06
22512	9d674fce-59a4-4545-9897-178c2133ac15	9d674fce-a845-4d6b-b995-5d37a4ab42ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 16:47:41
22513	9d674fce-a252-44f7-9f36-8e58a0f17a1e	9d674fce-a845-4d6b-b995-5d37a4ab42ff	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"162.85","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 16:47:41
22514	9d674fce-a2b1-403a-a040-cbc84710ebbd	9d674fce-a845-4d6b-b995-5d37a4ab42ff	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-03 16:47:41
22515	9d674fce-a6d7-452a-ab62-58757a57af1a	9d674fce-a845-4d6b-b995-5d37a4ab42ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 16:47:41
19680	9d66e39c-bcaf-4698-a196-a4195a82bf6f	9d66e39c-e282-4dd8-8a00-ecdcb947fdf2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 11:45:09
19681	9d66e39c-e0e4-4f9b-a284-3f92da875446	9d66e39c-e282-4dd8-8a00-ecdcb947fdf2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 11:45:09
19682	9d66e39c-e17b-4243-be36-318808bfd5ba	9d66e39c-e282-4dd8-8a00-ecdcb947fdf2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":303,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:45:09
22516	9d674fce-a73b-4751-b8e5-5a636a9ea44b	9d674fce-a845-4d6b-b995-5d37a4ab42ff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":407,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:47:41
19683	9d66e39d-3f9d-4288-b439-b61d56ef4e85	9d66e39d-637d-483b-b010-f0cfd1766b03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 11:45:09
19684	9d66e39d-59da-4eac-bfa8-e20184e568f4	9d66e39d-637d-483b-b010-f0cfd1766b03	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"50.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 11:45:09
18120	9d65b918-d838-43a6-b217-c87e54857720	9d65b919-022c-468a-8d89-573d59996ff9	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 21:50:26
18121	9d65b918-ffc8-4048-842b-ab3e7a83df50	9d65b919-022c-468a-8d89-573d59996ff9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:50:26
18122	9d65b919-00dd-4abd-bdba-e52f1458eadd	9d65b919-022c-468a-8d89-573d59996ff9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":358,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:50:26
19685	9d66e39d-5e0b-4a26-8ac8-ed4c6b4e8e99	9d66e39d-637d-483b-b010-f0cfd1766b03	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:45:09
19686	9d66e39d-5e41-4720-acef-78898cba2f85	9d66e39d-637d-483b-b010-f0cfd1766b03	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:45:09
19687	9d66e39d-6218-4ea7-af40-14e666de43ee	9d66e39d-637d-483b-b010-f0cfd1766b03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 11:45:09
19688	9d66e39d-626e-4703-9bf2-85690d5927e3	9d66e39d-637d-483b-b010-f0cfd1766b03	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":281,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:45:09
40656	9d6cc64b-3989-44c2-89e5-0b0997085807	9d6cc64b-3c5c-4c58-a725-988a1ffa945d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1838}	2024-11-06 09:58:08
19689	9d66e39f-2335-4b1b-ada5-099a874c6614	9d66e39f-90a3-4bd8-89af-0765e2b6e502	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 11:45:10
17055	9d6548b0-3d27-4e1e-ad1e-caf212b45ff4	9d6548b0-6257-426f-aad2-2ccfc3ff14c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:36:07
17056	9d6548b0-604a-4ac2-8246-718e70cea130	9d6548b0-6257-426f-aad2-2ccfc3ff14c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 16:36:07
17057	9d6548b0-611e-4ede-9e0c-59b0826ec0db	9d6548b0-6257-426f-aad2-2ccfc3ff14c3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42883]: Undefined function: 7 ERROR:  no existe la funci\\u00f3n datediff(character varying, integer)\\nLINE 1: select DATEDIFF(l.loans_fecha_ultimo_pago, 02-11-2024) as di...\\n               ^\\nHINT:  Ninguna funci\\u00f3n coincide en el nombre y tipos de argumentos. Puede ser necesario agregar conversi\\u00f3n expl\\u00edcita de tipos. (Connection: pgsql, SQL: select DATEDIFF(l.loans_fecha_ultimo_pago, 02-11-2024) as dis_restantes, \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":45,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":485,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:36:07
19690	9d66e39f-87f7-4fdc-a9b0-51bf2012d03f	9d66e39f-90a3-4bd8-89af-0765e2b6e502	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"211.40","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:45:11
21908	9d6740cd-07bf-4c66-8cd6-06917cbff486	9d6740cd-4f6b-4026-9d1e-3b4d4dcf60ba	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 16:05:43
19691	9d66e39f-886c-4b1b-9a13-841a2869ff0c	9d66e39f-90a3-4bd8-89af-0765e2b6e502	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:45:11
19692	9d66e39f-8ec4-48b0-8142-1e9e69027ffb	9d66e39f-90a3-4bd8-89af-0765e2b6e502	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 11:45:11
19693	9d66e39f-8f3a-444c-be49-fcdd934bbca5	9d66e39f-90a3-4bd8-89af-0765e2b6e502	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":614,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:45:11
21909	9d6740cd-4b87-4a81-83f2-473b578c5353	9d6740cd-4f6b-4026-9d1e-3b4d4dcf60ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 16:05:43
21910	9d6740cd-4d47-47a2-ae93-cf28eed2e403	9d6740cd-4f6b-4026-9d1e-3b4d4dcf60ba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":640,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:05:43
27222	9d68e2f8-c952-4049-9836-437d0e843f96	9d68e2f9-0d55-490b-8715-ddb333c8bcb5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 11:35:01
27223	9d68e2f9-0aea-4950-8401-01189d9d8039	9d68e2f9-0d55-490b-8715-ddb333c8bcb5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 11:35:01
27224	9d68e2f9-0be6-4505-b8d6-534f5f845def	9d68e2f9-0d55-490b-8715-ddb333c8bcb5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":618,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:35:01
17058	9d6548b2-6f72-45dd-8d0d-f37890658e3f	9d6548b2-c092-471b-b0ed-d2354dd04407	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 16:36:09
17059	9d6548b2-bb19-43ce-bc07-e09cf16e3e45	9d6548b2-c092-471b-b0ed-d2354dd04407	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"155.22","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 16:36:09
17060	9d6548b2-bb65-457d-a568-e201d5c9bb52	9d6548b2-c092-471b-b0ed-d2354dd04407	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 16:36:09
17061	9d6548b2-bf4d-4be6-a271-4e757f018ee2	9d6548b2-c092-471b-b0ed-d2354dd04407	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 16:36:09
17062	9d6548b2-bf94-4175-995f-6325587e6d87	9d6548b2-c092-471b-b0ed-d2354dd04407	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":494,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:36:09
18123	9d65b919-70dd-44fb-835e-a8154a07557d	9d65b919-97a9-4beb-85ef-158d01b1faa2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:50:27
18124	9d65b919-8bc4-4a40-ad72-08641c8c6fe6	9d65b919-97a9-4beb-85ef-158d01b1faa2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"52.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"2b11ef88578e3c91c11800e110e490df","hostname":"EderCortes"}	2024-11-02 21:50:27
18125	9d65b919-9085-4955-91c6-1b9999c0113f	9d65b919-97a9-4beb-85ef-158d01b1faa2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"2.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:50:27
18126	9d65b919-90c6-4390-a402-850ae026295c	9d65b919-97a9-4beb-85ef-158d01b1faa2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:50:27
18127	9d65b919-961b-49b2-8d42-84752d2b4be7	9d65b919-97a9-4beb-85ef-158d01b1faa2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:50:27
18128	9d65b919-968a-41df-aa1b-1d2cb94339c6	9d65b919-97a9-4beb-85ef-158d01b1faa2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:50:27
21911	9d6740cd-f550-4459-9be8-b433aaa153c8	9d6740ce-1c10-4929-b5b6-2973cad5ecec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 16:05:44
27225	9d68e2f9-de11-4840-96aa-ff3b559b14f5	9d68e2fa-1653-4556-a04f-990ccf79fc30	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 11:35:01
27226	9d68e2fa-0cab-418d-ab5d-4d293ce14d24	9d68e2fa-1653-4556-a04f-990ccf79fc30	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"69.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:35:01
27227	9d68e2fa-0d44-4301-b08e-2e5058fe9e36	9d68e2fa-1653-4556-a04f-990ccf79fc30	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:35:01
27228	9d68e2fa-146d-4642-8e02-83b6507a063f	9d68e2fa-1653-4556-a04f-990ccf79fc30	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 11:35:01
18129	9d65b91b-9b3f-460f-a598-a756f666db61	9d65b91b-ccda-4422-aea6-e3a901c8b949	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:50:28
18130	9d65b91b-c442-45e8-9d99-881ec7172ef6	9d65b91b-ccda-4422-aea6-e3a901c8b949	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"78.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 21:50:28
18131	9d65b91b-c4c5-46b3-aee6-3921fe41a5cd	9d65b91b-ccda-4422-aea6-e3a901c8b949	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 21:50:28
18132	9d65b91b-cad5-401e-826f-c1f97f4f45cb	9d65b91b-ccda-4422-aea6-e3a901c8b949	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 21:50:28
18133	9d65b91b-cb62-44f0-b5e3-56e9cb47ba6b	9d65b91b-ccda-4422-aea6-e3a901c8b949	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":367,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:50:28
21912	9d6740ce-0fd3-4776-9881-3aebae8e0176	9d6740ce-1c10-4929-b5b6-2973cad5ecec	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 68\\n                        ","time":"50.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"7d9994d55cb8dde82ff4185920c79043","hostname":"EderCortes"}	2024-11-03 16:05:44
21913	9d6740ce-1468-4ba7-8542-b46e6f77ea84	9d6740ce-1c10-4929-b5b6-2973cad5ecec	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '68' order by \\"item_loans\\".\\"id\\" asc","time":"3.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 16:05:44
21914	9d6740ce-14b5-414c-bf3d-6fc630884e3d	9d6740ce-1c10-4929-b5b6-2973cad5ecec	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 16:05:44
21915	9d6740ce-1a88-444a-86cb-69eaae249f4d	9d6740ce-1c10-4929-b5b6-2973cad5ecec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 16:05:44
21916	9d6740ce-1af7-4830-9dda-b7308ab53ae2	9d6740ce-1c10-4929-b5b6-2973cad5ecec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/68","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":68,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":10000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"1000000","loans_pago_interes":"250000"},"items":[{"id":227,"loans_codigo":68,"itemloans_cuota":"1","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":228,"loans_codigo":68,"itemloans_cuota":"2","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":229,"loans_codigo":68,"itemloans_cuota":"3","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":230,"loans_codigo":68,"itemloans_cuota":"4","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":231,"loans_codigo":68,"itemloans_cuota":"5","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":232,"loans_codigo":68,"itemloans_cuota":"6","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":233,"loans_codigo":68,"itemloans_cuota":"7","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":234,"loans_codigo":68,"itemloans_cuota":"8","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":235,"loans_codigo":68,"itemloans_cuota":"9","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":236,"loans_codigo":68,"itemloans_cuota":"10","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":421,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:05:44
27229	9d68e2fa-14fa-48e0-b7eb-e5e8bbb6e40a	9d68e2fa-1653-4556-a04f-990ccf79fc30	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":595,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:35:01
27230	9d68e2fa-c750-4235-aa08-dc0e7ddad593	9d68e2fa-f2d5-4bb0-ae53-8fb012d26481	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 11:35:02
14646	9d5ebef3-e364-44f5-adf6-ba7eff7f4022	9d5ebef4-c8d4-4a0f-aa4a-3ae5af108918	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-30 10:36:01
14647	9d5ebef4-c586-4013-8b17-c5b93e8d150a	9d5ebef4-c8d4-4a0f-aa4a-3ae5af108918	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-10-30 10:36:01
14648	9d5ebef4-c705-412c-842c-c4f8597e7ec3	9d5ebef4-c8d4-4a0f-aa4a-3ae5af108918	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":924,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:36:01
27231	9d68e2fa-eb44-49f5-b825-8f9bc7e0fd98	9d68e2fa-f2d5-4bb0-ae53-8fb012d26481	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"57.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:35:02
27232	9d68e2fa-ebd1-47a1-bc2b-59817c628423	9d68e2fa-f2d5-4bb0-ae53-8fb012d26481	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 11:35:02
27233	9d68e2fa-f122-4d8a-8117-26725122952a	9d68e2fa-f2d5-4bb0-ae53-8fb012d26481	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 11:35:02
27234	9d68e2fa-f197-4620-ab5d-f2437d66964e	9d68e2fa-f2d5-4bb0-ae53-8fb012d26481	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":540,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:35:02
14649	9d5ebef5-ca9c-4bbd-8e56-c0c49c735931	9d5ebef6-1794-4eaf-8c23-b4032ec89429	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-10-30 10:36:02
14650	9d5ebef6-0b38-48f9-be63-832572360d2d	9d5ebef6-1794-4eaf-8c23-b4032ec89429	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"81.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 10:36:02
14651	9d5ebef6-0bdd-4b70-957f-34e08a393f0b	9d5ebef6-1794-4eaf-8c23-b4032ec89429	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 10:36:02
14652	9d5ebef6-152b-47e0-b386-b808d7d881a8	9d5ebef6-1794-4eaf-8c23-b4032ec89429	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 10:36:02
14653	9d5ebef6-15c6-4c4c-b902-c8eaa7e844e0	9d5ebef6-1794-4eaf-8c23-b4032ec89429	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":782,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:36:02
27235	9d68e2fc-6335-41b2-a99d-089c910728de	9d68e2fc-9c2e-4bf0-ae59-a8b1f458acb6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 11:35:03
27236	9d68e2fc-91cc-49d6-87c8-d6a4f1c5bf9d	9d68e2fc-9c2e-4bf0-ae59-a8b1f458acb6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"78.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:35:03
22638	9d67f73e-a89e-48fe-b296-fbb6ed0a0a7b	9d67f73e-f1e9-48b8-a3a2-cb5e9e58cd56	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 00:35:52
22639	9d67f73e-ed23-436c-b580-a38acd06ca6d	9d67f73e-f1e9-48b8-a3a2-cb5e9e58cd56	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 00:35:52
22640	9d67f73e-ef67-4165-b325-d87b4e3ecc5a	9d67f73e-f1e9-48b8-a3a2-cb5e9e58cd56	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":570,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:35:52
27237	9d68e2fc-9260-462e-8ffb-28f93214644a	9d68e2fc-9c2e-4bf0-ae59-a8b1f458acb6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:35:03
27238	9d68e2fc-99e1-4443-9310-90473fe04318	9d68e2fc-9c2e-4bf0-ae59-a8b1f458acb6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 11:35:03
27239	9d68e2fc-9a69-4046-9156-39fddaed8296	9d68e2fc-9c2e-4bf0-ae59-a8b1f458acb6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1062,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:35:03
14654	9d5ebef6-c86e-4d91-9a7b-a01019480a82	9d5ebef6-f88a-404d-bb4a-0de696f11e69	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 10:36:03
14655	9d5ebef6-ef64-4b2f-a287-60d399e8cbf6	9d5ebef6-f88a-404d-bb4a-0de696f11e69	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"60.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 10:36:03
14656	9d5ebef6-efe0-4fcb-89f3-791af7358399	9d5ebef6-f88a-404d-bb4a-0de696f11e69	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 10:36:03
14657	9d5ebef6-f69c-4a72-b144-1ef3ec9d6ddd	9d5ebef6-f88a-404d-bb4a-0de696f11e69	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 10:36:03
14658	9d5ebef6-f72b-4ee0-8947-f50070dfe700	9d5ebef6-f88a-404d-bb4a-0de696f11e69	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":551,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:36:03
22641	9d67f73f-ed2b-4784-b887-1d90843b90d0	9d67f740-41ed-4123-90b5-d94dbc70757f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 00:35:53
22642	9d67f740-2631-48c4-b278-b2a50a068e81	9d67f740-41ed-4123-90b5-d94dbc70757f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 65\\n                        ","time":"86.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6768d7067397538897aacf4d73c43049","hostname":"EderCortes"}	2024-11-04 00:35:53
22643	9d67f740-37de-44eb-86e3-779ef0f1c618	9d67f740-41ed-4123-90b5-d94dbc70757f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '65' order by \\"item_loans\\".\\"id\\" asc","time":"2.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 00:35:53
22644	9d67f740-384b-4486-b8f5-3c577849f910	9d67f740-41ed-4123-90b5-d94dbc70757f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 00:35:53
22645	9d67f740-3fca-4f5a-8a67-fd396a1a1199	9d67f740-41ed-4123-90b5-d94dbc70757f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 00:35:53
22646	9d67f740-4070-42ad-9e46-f16b370615ba	9d67f740-41ed-4123-90b5-d94dbc70757f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/65","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":65,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":3000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-10 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"90000"},"items":[{"id":207,"loans_codigo":65,"itemloans_cuota":"1","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:46:55.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"90000","itemloans_cuota_cancelada":"300000"},{"id":208,"loans_codigo":65,"itemloans_cuota":"2","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":209,"loans_codigo":65,"itemloans_cuota":"3","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":210,"loans_codigo":65,"itemloans_cuota":"4","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":211,"loans_codigo":65,"itemloans_cuota":"5","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":212,"loans_codigo":65,"itemloans_cuota":"6","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":213,"loans_codigo":65,"itemloans_cuota":"7","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":214,"loans_codigo":65,"itemloans_cuota":"8","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":215,"loans_codigo":65,"itemloans_cuota":"9","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":216,"loans_codigo":65,"itemloans_cuota":"10","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-09-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":776,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:35:53
27240	9d68e2fd-8172-4b52-b1eb-395263d9afd0	9d68e2fd-a394-4c75-9f4f-6a6cb35d3256	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 11:35:04
27241	9d68e2fd-9dd0-45d6-909f-016ac9a50b5d	9d68e2fd-a394-4c75-9f4f-6a6cb35d3256	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:35:04
27242	9d68e2fd-9e50-4912-9a6a-8da2b4961e50	9d68e2fd-a394-4c75-9f4f-6a6cb35d3256	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:35:04
14659	9d5ebef7-cab0-4b64-a0a5-87c7772f95ef	9d5ebef7-f205-4503-a3c8-8a49d44a6dab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 10:36:03
14660	9d5ebef7-e8c8-4479-af73-248c8c40203c	9d5ebef7-f205-4503-a3c8-8a49d44a6dab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"51.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 10:36:04
14661	9d5ebef7-e94f-41a6-a88a-ecfd6374373e	9d5ebef7-f205-4503-a3c8-8a49d44a6dab	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 10:36:04
14662	9d5ebef7-f00c-4928-9d46-8d6e41c5062c	9d5ebef7-f205-4503-a3c8-8a49d44a6dab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 10:36:04
14663	9d5ebef7-f08f-4b58-943c-2a70ff7062c2	9d5ebef7-f205-4503-a3c8-8a49d44a6dab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":324,"memory":22,"hostname":"EderCortes"}	2024-10-30 10:36:04
27243	9d68e2fd-a1f8-42fe-bb62-837d3c86b22a	9d68e2fd-a394-4c75-9f4f-6a6cb35d3256	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 11:35:04
27244	9d68e2fd-a275-4893-a103-c623bddb4447	9d68e2fd-a394-4c75-9f4f-6a6cb35d3256	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":648,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:35:04
27358	9d68e435-933b-4b7d-874e-de6770b97996	9d68e435-cc98-4268-a71d-a919ed79b6ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:38:28
27359	9d68e435-ca09-41d9-bd0b-0794f346cd69	9d68e435-cc98-4268-a71d-a919ed79b6ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:38:28
27360	9d68e435-cb29-4a75-a69a-c5085600b44a	9d68e435-cc98-4268-a71d-a919ed79b6ef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":700,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:38:28
27361	9d68e436-e424-4024-8460-8f3579b80547	9d68e437-142c-4dbc-902a-bf0b10d6f128	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:38:29
27362	9d68e437-0a7f-426c-b6c3-3e29ea9ae529	9d68e437-142c-4dbc-902a-bf0b10d6f128	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"59.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:38:29
27363	9d68e437-0b23-40dc-b604-66ec70cb9213	9d68e437-142c-4dbc-902a-bf0b10d6f128	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:38:29
27364	9d68e437-1222-4e92-8363-a5e7986ad914	9d68e437-142c-4dbc-902a-bf0b10d6f128	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:38:29
27365	9d68e437-12bd-4c92-a37d-7711c41ed43d	9d68e437-142c-4dbc-902a-bf0b10d6f128	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":705,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:38:29
27366	9d68e437-8fc8-47f5-b9a1-fb2debe0640a	9d68e437-ae8a-4b28-b073-ccdcd5cb5db0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:38:30
27367	9d68e437-a957-47b8-908b-3b0ecf717197	9d68e437-ae8a-4b28-b073-ccdcd5cb5db0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:38:30
27368	9d68e437-a9ad-47eb-a0aa-7733c2efbcdb	9d68e437-ae8a-4b28-b073-ccdcd5cb5db0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 11:38:30
27369	9d68e437-ad4d-4a28-9643-81413a62d1bd	9d68e437-ae8a-4b28-b073-ccdcd5cb5db0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:38:30
17224	9d6550ca-edce-40b2-8d4a-de43f8a44446	9d6550cb-1a42-47f3-adb1-a1012cc4ade4	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 16:58:47
17225	9d6550cb-17b9-4dbf-bde6-8ab12d604a4e	9d6550cb-1a42-47f3-adb1-a1012cc4ade4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:58:47
17226	9d6550cb-18ea-44d6-9051-1d71a78c5d25	9d6550cb-1a42-47f3-adb1-a1012cc4ade4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":344,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:58:47
27370	9d68e437-ad98-48fd-8128-031d97af6a76	9d68e437-ae8a-4b28-b073-ccdcd5cb5db0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":364,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:38:30
17227	9d6550cb-b322-4dcb-a759-455fa9fa4fc8	9d6550cb-d4ac-46dd-b6b8-2f3726103fdb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:58:47
17228	9d6550cb-cedd-4c74-9ad9-74c58cd584c2	9d6550cb-d4ac-46dd-b6b8-2f3726103fdb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"49.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":46,"hash":"fb4ded687569d92428336ceae5c6ffcd","hostname":"EderCortes"}	2024-11-02 16:58:47
17229	9d6550cb-d334-4669-87f9-eff430175c86	9d6550cb-d4ac-46dd-b6b8-2f3726103fdb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 16:58:47
17230	9d6550cb-d397-4935-83ae-3edb4b2df55b	9d6550cb-d4ac-46dd-b6b8-2f3726103fdb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":429,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:58:47
27371	9d68e438-8e5e-4415-97de-02ff32b26383	9d68e438-cd81-473a-88f8-1297aabf5066	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:38:30
27372	9d68e438-c22d-48a6-9e7e-afe6d18726eb	9d68e438-cd81-473a-88f8-1297aabf5066	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"62.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:38:30
27373	9d68e438-c2bb-4772-b994-01bfc3b1d3b5	9d68e438-cd81-473a-88f8-1297aabf5066	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:38:30
27374	9d68e438-cb00-4b1f-a4bd-b25c6a7c0045	9d68e438-cd81-473a-88f8-1297aabf5066	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:38:30
27375	9d68e438-cbc0-4027-bfba-f7a5646bc4e9	9d68e438-cd81-473a-88f8-1297aabf5066	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":714,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:38:30
17231	9d6550cd-ca94-47ec-b9c3-f05a722882e8	9d6550cd-e826-40f8-8064-2f8baf78eb5d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 16:58:49
17232	9d6550cd-e2aa-46bf-ae0f-92093c31c2a5	9d6550cd-e826-40f8-8064-2f8baf78eb5d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 16:58:49
17233	9d6550cd-e313-43f1-b94a-de2c2572197f	9d6550cd-e826-40f8-8064-2f8baf78eb5d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 16:58:49
17234	9d6550cd-e6c4-49a6-bfd2-ac853fbf80f2	9d6550cd-e826-40f8-8064-2f8baf78eb5d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 16:58:49
17235	9d6550cd-e711-4c07-9a12-82263ad4b179	9d6550cd-e826-40f8-8064-2f8baf78eb5d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":263,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:58:49
27376	9d68e439-9a60-4d54-9705-1d592c715e95	9d68e439-f048-4478-a499-57e15ee4c1e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:38:31
27377	9d68e439-e5e4-4251-b4fd-11a2f8e4007e	9d68e439-f048-4478-a499-57e15ee4c1e8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"152.69","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:38:31
27378	9d68e439-e664-4b18-8d4a-728a0ed07804	9d68e439-f048-4478-a499-57e15ee4c1e8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:38:31
27379	9d68e439-ee6a-4f2c-9ce3-5760428378ef	9d68e439-f048-4478-a499-57e15ee4c1e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:38:31
27380	9d68e439-eef0-4774-ac49-7fb2c1258feb	9d68e439-f048-4478-a499-57e15ee4c1e8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":709,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:38:31
40432	9d6cc364-3673-4728-b218-ed36f1cc526a	9d6cc364-61c2-40d7-b5d7-73f6c4bc7d0e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 09:50:01
40433	9d6cc364-6019-4866-bc93-4bb850eb134c	9d6cc364-61c2-40d7-b5d7-73f6c4bc7d0e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 09:50:01
40434	9d6cc364-60c0-4886-a554-3a9172a674b0	9d6cc364-61c2-40d7-b5d7-73f6c4bc7d0e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":389,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:50:01
27513	9d68e794-b685-402e-95fa-e44560d3184c	9d68e795-02e5-45df-a507-9b9647f15396	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:47:54
27514	9d68e794-ff2e-4204-963d-ab5a3d133dbf	9d68e795-02e5-45df-a507-9b9647f15396	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:47:54
27515	9d68e795-00bc-401c-8ef1-da9646f61825	9d68e795-02e5-45df-a507-9b9647f15396	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":643,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:47:54
7205	9d52db8e-6b19-4013-969a-6846bcc9dd5d	9d52db8e-6deb-48eb-aca4-97c87d7ea814	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":363}	2024-10-24 12:46:04
16704	9d64d617-484c-4546-8cb4-0c423f5e6cb0	9d64d617-4b99-40c4-9f7a-c6eb08eeb246	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":778}	2024-11-02 11:15:41
27516	9d68e795-b7e9-4d30-a3cd-483b4508dd98	9d68e795-f07d-4324-bfaf-49d9f52b0b9e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:47:55
27517	9d68e795-e42b-459f-bc84-7fadaac6bde1	9d68e795-f07d-4324-bfaf-49d9f52b0b9e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"70.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:47:55
27518	9d68e795-e4a9-45f5-ba8e-570f87c08b4f	9d68e795-f07d-4324-bfaf-49d9f52b0b9e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:47:55
27519	9d68e795-ed78-4925-b412-2ab04c168a7d	9d68e795-f07d-4324-bfaf-49d9f52b0b9e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:47:55
27520	9d68e795-ee68-4684-bbaf-e4ee3d3678f0	9d68e795-f07d-4324-bfaf-49d9f52b0b9e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":530,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:47:55
40517	9d6cc429-d910-422e-bae3-634d37237920	9d6cc42a-2c12-4b21-bb18-e2760f0abae3	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 09:52:11
40518	9d6cc42a-29da-4172-85e7-73542810ab7d	9d6cc42a-2c12-4b21-bb18-e2760f0abae3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:52:11
40519	9d6cc42a-2ab6-4b2e-88e7-0a1d7c40f8a2	9d6cc42a-2c12-4b21-bb18-e2760f0abae3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":447,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:52:11
19770	9d66e6b6-503f-49e7-9e82-3d9d36f0db6e	9d66e6b6-a418-4069-a1e9-101ff28771f0	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 11:53:49
19771	9d66e6b6-a109-45d2-8f97-351daaf81ce8	9d66e6b6-a418-4069-a1e9-101ff28771f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:53:49
19772	9d66e6b6-a2a2-478b-9a94-5b73142ff7e1	9d66e6b6-a418-4069-a1e9-101ff28771f0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":493,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:53:49
40636	9d6cc62c-9e00-4dea-9331-99b1a09c5fc6	9d6cc62c-c1fb-4d4a-9540-7dacc0daf453	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 09:57:48
27521	9d68e796-9cb0-433a-8f54-1be818036e5c	9d68e796-d034-403f-afc0-a0c27615663f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:47:55
27522	9d68e796-c650-457d-a2ff-b593aa823a5b	9d68e796-d034-403f-afc0-a0c27615663f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"66.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:47:55
27523	9d68e796-c6e6-4ae4-a2f3-fe83988bf69d	9d68e796-d034-403f-afc0-a0c27615663f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 11:47:55
27524	9d68e796-ce31-43fd-b26f-98e27cc337c1	9d68e796-d034-403f-afc0-a0c27615663f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:47:55
40637	9d6cc62c-bfd5-4713-bfd7-7db3aca2fee7	9d6cc62c-c1fb-4d4a-9540-7dacc0daf453	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:57:48
40638	9d6cc62c-c09f-42c7-84b4-8a6d9274ed74	9d6cc62c-c1fb-4d4a-9540-7dacc0daf453	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":301,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:57:48
19773	9d66e6b7-13a2-4b9b-9388-973d765052cc	9d66e6b7-3a1e-4908-b4eb-ef81ad4a9190	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:53:49
19774	9d66e6b7-2e8c-41f7-bc02-80cd83736977	9d66e6b7-3a1e-4908-b4eb-ef81ad4a9190	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"51.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 11:53:49
19775	9d66e6b7-3259-493a-bce6-427e3746a4f2	9d66e6b7-3a1e-4908-b4eb-ef81ad4a9190	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:53:49
19776	9d66e6b7-328e-40c8-9309-555374a37f38	9d66e6b7-3a1e-4908-b4eb-ef81ad4a9190	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:53:49
19777	9d66e6b7-386d-4494-9c49-d3f036d6fe4f	9d66e6b7-3a1e-4908-b4eb-ef81ad4a9190	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:53:49
19778	9d66e6b7-38e3-4bf8-973d-a423cfb116e9	9d66e6b7-3a1e-4908-b4eb-ef81ad4a9190	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"100000","loans_pago_interes":"50000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":332,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:53:49
27525	9d68e796-cecd-4759-b1e2-7517ac856287	9d68e796-d034-403f-afc0-a0c27615663f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":547,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:47:55
40585	9d6cc5c8-ce89-4531-aa36-8361d11ce05c	9d6cc5c9-222c-43f3-8e7d-aed7376ef388	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 09:56:43
40586	9d6cc5c9-2039-46dd-9469-65294f2461b2	9d6cc5c9-222c-43f3-8e7d-aed7376ef388	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:56:43
19779	9d66e6b9-34de-478b-bdb8-39cd774bd83f	9d66e6b9-7cbc-4c93-a1cf-978ee80d1f1a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:53:51
19780	9d66e6b9-77e0-4620-931c-82c97577dc78	9d66e6b9-7cbc-4c93-a1cf-978ee80d1f1a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"152.74","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:53:51
19781	9d66e6b9-7826-4ba2-953a-4f8632095226	9d66e6b9-7cbc-4c93-a1cf-978ee80d1f1a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:53:51
19782	9d66e6b9-7b70-4338-9da0-9d631fbeed55	9d66e6b9-7cbc-4c93-a1cf-978ee80d1f1a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 11:53:51
19783	9d66e6b9-7bb2-488f-a49f-1b4f8a00fd2b	9d66e6b9-7cbc-4c93-a1cf-978ee80d1f1a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":394,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:53:51
27526	9d68e797-7f5d-4980-89fb-6f5ca6206b2d	9d68e797-ab59-4c97-afc6-bd18527ca3a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:47:56
27527	9d68e797-a1ad-49ff-9918-c6953449718a	9d68e797-ab59-4c97-afc6-bd18527ca3a7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '90' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"58.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 11:47:56
27528	9d68e797-a22a-4a95-b8a5-473ef78878b2	9d68e797-ab59-4c97-afc6-bd18527ca3a7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 11:47:56
27529	9d68e797-a470-4b51-be90-6bd034957cea	9d68e797-ab59-4c97-afc6-bd18527ca3a7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"3.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:47:56
27530	9d68e797-a4bc-430b-80ff-b3134ac58a43	9d68e797-ab59-4c97-afc6-bd18527ca3a7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 11:47:56
27531	9d68e797-a91f-45eb-a30e-156d59712fe7	9d68e797-ab59-4c97-afc6-bd18527ca3a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:47:56
27532	9d68e797-a995-456c-a6ce-30901c3d0f05	9d68e797-ab59-4c97-afc6-bd18527ca3a7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"275000","loans_pago_prestado":"1100000","loans_intereses_recaudar":"275000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"}]}},"duration":528,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:47:56
40587	9d6cc5c9-2114-40e5-b66e-0f75f0270d76	9d6cc5c9-222c-43f3-8e7d-aed7376ef388	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":434,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:56:43
27533	9d68e799-03b8-4743-8e24-7f734cb6beae	9d68e799-3b12-4ab5-b5ea-7008b86b6b6e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:47:57
27534	9d68e799-3058-410e-916e-61ef6e06921c	9d68e799-3b12-4ab5-b5ea-7008b86b6b6e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"71.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:47:57
15348	9d5ed0ce-dc19-404e-88be-2d42efc85dcb	9d5ed0cf-1749-48b7-9c83-ef82f9ab4e17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-30 11:25:57
15349	9d5ed0cf-1446-4aa4-9e55-1d5847ded648	9d5ed0cf-1749-48b7-9c83-ef82f9ab4e17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-30 11:25:57
15350	9d5ed0cf-1583-47de-ba9e-a9103f6b1388	9d5ed0cf-1749-48b7-9c83-ef82f9ab4e17	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":440,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:25:57
27535	9d68e799-30e3-4450-adba-52bd74049383	9d68e799-3b12-4ab5-b5ea-7008b86b6b6e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:47:57
27536	9d68e799-390f-4e1d-af09-464a99d6ff9f	9d68e799-3b12-4ab5-b5ea-7008b86b6b6e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:47:57
27537	9d68e799-399c-4911-8690-085c313e0cb9	9d68e799-3b12-4ab5-b5ea-7008b86b6b6e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":999,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:47:57
15351	9d5ed0cf-c3b0-418c-9503-c4aff326b758	9d5ed0cf-f333-43f9-83a1-8f2ef1db56e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-30 11:25:57
15352	9d5ed0cf-e5fd-4b31-95d3-a2e3ed9daa35	9d5ed0cf-f333-43f9-83a1-8f2ef1db56e0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"65.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"088d1fdbe045a08c3b0073ef22c7da32","hostname":"EderCortes"}	2024-10-30 11:25:57
15353	9d5ed0cf-ebcc-493e-97c4-292be887e8ed	9d5ed0cf-f333-43f9-83a1-8f2ef1db56e0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"3.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-30 11:25:57
15354	9d5ed0cf-ec16-423e-a0e5-03be66d74e7f	9d5ed0cf-f333-43f9-83a1-8f2ef1db56e0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-10-30 11:25:57
15355	9d5ed0cf-f1c4-4318-9e08-14b86a017d83	9d5ed0cf-f333-43f9-83a1-8f2ef1db56e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-30 11:25:57
15356	9d5ed0cf-f240-4be5-8738-74a7e57520bd	9d5ed0cf-f333-43f9-83a1-8f2ef1db56e0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":506,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:25:57
27538	9d68e79a-059d-4b32-bdf0-f2d7b2e37214	9d68e79a-245c-44b1-98ec-784c213a8b4c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:47:57
27539	9d68e79a-1fa7-4854-8d74-558a1d59fd9d	9d68e79a-245c-44b1-98ec-784c213a8b4c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:47:57
27540	9d68e79a-1ff2-434b-941a-ab720576c3f3	9d68e79a-245c-44b1-98ec-784c213a8b4c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:47:57
27541	9d68e79a-2302-4bb0-8bac-3e29f14e6016	9d68e79a-245c-44b1-98ec-784c213a8b4c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:47:57
27542	9d68e79a-2365-4224-acba-980a4dfd4c68	9d68e79a-245c-44b1-98ec-784c213a8b4c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":573,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:47:57
27677	9d68e91e-a8fa-4407-8b1b-9f26b557d5d6	9d68e91f-12b4-4862-9e62-af9cfe42c825	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:52:12
27678	9d68e91f-0fd5-4578-a984-79c7c36e2e48	9d68e91f-12b4-4862-9e62-af9cfe42c825	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:52:12
27679	9d68e91f-1136-4538-86f8-1f6ac422b705	9d68e91f-12b4-4862-9e62-af9cfe42c825	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":688,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:52:12
502	9d4f29e5-5dda-4a75-86fa-5985cc76e384	9d4f29e5-608e-41f9-bacd-9c5d3f779537	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":35}	2024-10-22 16:41:48
40738	9d6cc6e4-894a-46dd-b48b-a537177218f2	9d6cc6e4-cd62-4041-ac69-022be41e2048	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 09:59:48
12523	9d5cea7a-86fe-4a63-8169-2f257f7aee2f	9d5cea7a-89f6-47dc-b879-d3dcb0bafb62	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":600}	2024-10-29 12:46:04
27680	9d68e91f-d9b1-4cc8-b743-ebfc7d60a0d2	9d68e920-37b9-4d80-9f0f-8fc9f40593cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:52:13
27681	9d68e920-2db1-40cd-9bf7-0aa701356e09	9d68e920-37b9-4d80-9f0f-8fc9f40593cf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"170.93","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:52:13
27682	9d68e920-2e44-4f63-878d-5703b0eeba0a	9d68e920-37b9-4d80-9f0f-8fc9f40593cf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:52:13
27683	9d68e920-35d4-4827-a02c-6b15acc83751	9d68e920-37b9-4d80-9f0f-8fc9f40593cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:52:13
27684	9d68e920-3660-4fb8-8138-1ac2f84259ed	9d68e920-37b9-4d80-9f0f-8fc9f40593cf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":676,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:52:13
40739	9d6cc6e4-cbd5-49ae-80cf-bdff852db28a	9d6cc6e4-cd62-4041-ac69-022be41e2048	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 09:59:49
40740	9d6cc6e4-cc6a-4eb3-b93c-72e2fe1474d2	9d6cc6e4-cd62-4041-ac69-022be41e2048	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:59:49
27685	9d68e920-de38-4c59-a3a8-4e429c0db87f	9d68e921-0686-4b21-bbf7-de2c061473f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:52:14
27686	9d68e920-fe9b-4f2c-92be-a49ca92f1576	9d68e921-0686-4b21-bbf7-de2c061473f4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:52:14
27687	9d68e920-ff03-4724-9259-c59b3436da06	9d68e921-0686-4b21-bbf7-de2c061473f4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 11:52:14
27688	9d68e921-04b9-4bf5-abe4-a641eef3c269	9d68e921-0686-4b21-bbf7-de2c061473f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:52:14
27689	9d68e921-0535-4d9f-81eb-bfba8b16c63c	9d68e921-0686-4b21-bbf7-de2c061473f4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":487,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:52:14
40874	9d6cc850-a45a-4566-8686-74863ab337f6	9d6cc850-cf23-43f8-b9a2-5f258807f61b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:03:47
27821	9d68ea08-8e95-4a72-b1de-fee7c93dc1a7	9d68ea08-eb71-4d16-afa9-3355e185b511	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:54:45
27822	9d68ea08-e85a-4b5d-8286-e83edd8e9340	9d68ea08-eb71-4d16-afa9-3355e185b511	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:54:46
27823	9d68ea08-e9cf-4048-ac97-99ea689efb66	9d68ea08-eb71-4d16-afa9-3355e185b511	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":804,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:54:46
40364	9d6cc2a4-e86d-4bf4-a78f-b47d6f473628	9d6cc2a5-11b8-4b37-9e80-102efce759b4	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 09:47:56
40365	9d6cc2a5-0f6d-4fb3-89dc-9d6b21a79329	9d6cc2a5-11b8-4b37-9e80-102efce759b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:47:56
40366	9d6cc2a5-102d-4581-8fa6-57c6641c0084	9d6cc2a5-11b8-4b37-9e80-102efce759b4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":284,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:47:56
40875	9d6cc850-ccef-4b58-8c8c-f90faa488be6	9d6cc850-cf23-43f8-b9a2-5f258807f61b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:03:47
40876	9d6cc850-cdda-4a03-a8f2-5396296cd21b	9d6cc850-cf23-43f8-b9a2-5f258807f61b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":328,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:03:47
40976	9d6cc91c-fb72-4d9c-ae00-88fee849900c	9d6cc91d-1f09-4bd0-9235-e8bbd01b42a3	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:06:01
40977	9d6cc91d-1d1d-4fc7-af64-d9dfd137100e	9d6cc91d-1f09-4bd0-9235-e8bbd01b42a3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:06:01
40978	9d6cc91d-1de3-42bc-96fa-7b7bab670a7f	9d6cc91d-1f09-4bd0-9235-e8bbd01b42a3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:06:01
27690	9d68e921-b019-4249-9cd0-a4a2930b81fc	9d68e921-dd53-42a0-afc6-d491055d9bd0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:52:14
27691	9d68e921-d2f6-4bb5-8d11-b44538b0d576	9d68e921-dd53-42a0-afc6-d491055d9bd0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '90' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"58.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 11:52:14
27692	9d68e921-d373-481c-af21-b1ed94bf75c8	9d68e921-dd53-42a0-afc6-d491055d9bd0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 11:52:14
27693	9d68e921-d5ed-4188-918f-2cf5453af413	9d68e921-dd53-42a0-afc6-d491055d9bd0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"3.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:52:14
27694	9d68e921-d65f-4cd0-b284-1d4bd7f7c56e	9d68e921-dd53-42a0-afc6-d491055d9bd0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 11:52:14
27695	9d68e921-db4c-4f51-880b-6dfd23d92004	9d68e921-dd53-42a0-afc6-d491055d9bd0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:52:14
27696	9d68e921-dbf4-47e5-81f6-77f5b09360d3	9d68e921-dd53-42a0-afc6-d491055d9bd0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"275000","loans_pago_prestado":"1100000","loans_intereses_recaudar":"275000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"}]}},"duration":519,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:52:14
27824	9d68ea09-ac9c-437d-9769-e4dc7144f52d	9d68ea09-d18d-4c06-8677-0cb6a8bc6b98	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:54:46
27825	9d68ea09-ca46-4a52-8abc-8e91844326aa	9d68ea09-d18d-4c06-8677-0cb6a8bc6b98	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:54:46
27826	9d68ea09-cabc-457e-969d-a112a82bc9c1	9d68ea09-d18d-4c06-8677-0cb6a8bc6b98	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:54:46
27827	9d68ea09-cf64-430a-93c7-24355807a239	9d68ea09-d18d-4c06-8677-0cb6a8bc6b98	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:54:46
27828	9d68ea09-d038-4091-8e30-801e9cb2183e	9d68ea09-d18d-4c06-8677-0cb6a8bc6b98	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":521,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:54:46
16293	9d64c085-7042-4dd3-ba5b-378f559856be	9d64c085-8c94-450a-a223-016b4f0ab993	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 10:15:22
16294	9d64c085-8b1a-401d-8b6c-e02ec8de1fc0	9d64c085-8c94-450a-a223-016b4f0ab993	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 10:15:22
16295	9d64c085-8bae-44d2-8154-23b1f5c9dfbc	9d64c085-8c94-450a-a223-016b4f0ab993	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":224,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:15:22
40256	9d6cc237-0bf5-489b-ac69-d1a95764c734	9d6cc237-323d-4eb6-8e02-e70e8f113fce	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 09:46:44
40257	9d6cc237-2fd0-4396-9701-0b1551010fed	9d6cc237-323d-4eb6-8e02-e70e8f113fce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:46:44
40258	9d6cc237-30ba-4d71-905e-f69c45960d84	9d6cc237-323d-4eb6-8e02-e70e8f113fce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:46:44
40673	9d6cc66a-817c-410f-8520-b3291b12bd89	9d6cc66a-842d-44a6-b321-97aeb5847696	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1840}	2024-11-06 09:58:28
22417	9d674f10-7937-4162-b9db-86b0ed40192e	9d674f10-7d14-46a8-a0da-fc2ac938ea70	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1077}	2024-11-03 16:45:36
16296	9d64c085-d4ef-4e34-9e84-7f5f1cab4edd	9d64c086-1e32-48de-a32f-4405d26a8643	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 10:15:22
16297	9d64c086-15e3-41c6-a0ba-2718a27788c6	9d64c086-1e32-48de-a32f-4405d26a8643	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"154.91","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 10:15:23
16298	9d64c086-1942-436b-b0a6-51c5a0e8786c	9d64c086-1e32-48de-a32f-4405d26a8643	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 10:15:23
16299	9d64c086-197b-4694-9e88-088c640c6094	9d64c086-1e32-48de-a32f-4405d26a8643	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 10:15:23
16300	9d64c086-1cff-4a8b-b2b5-75c87e7c094e	9d64c086-1e32-48de-a32f-4405d26a8643	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 10:15:23
16301	9d64c086-1d4e-49ab-bd65-9a1d97728bd4	9d64c086-1e32-48de-a32f-4405d26a8643	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:15:23
27697	9d68e922-921a-4663-b574-cf2878dba696	9d68e923-35a4-4793-b6f0-1697ffa7dd8c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:52:15
27698	9d68e923-2918-4d86-bc75-7a1b8ebfa6ee	9d68e923-35a4-4793-b6f0-1697ffa7dd8c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"226.84","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:52:15
27699	9d68e923-29a8-48df-a3de-2193df6925f1	9d68e923-35a4-4793-b6f0-1697ffa7dd8c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:52:15
27700	9d68e923-334c-4976-9353-bdd1308ffbf4	9d68e923-35a4-4793-b6f0-1697ffa7dd8c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:52:15
27701	9d68e923-3406-4624-85d9-134b460fe4d9	9d68e923-35a4-4793-b6f0-1697ffa7dd8c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":862,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:52:15
27829	9d68ea0a-8888-4ca8-8303-447525c39eef	9d68ea0a-b080-4fe6-ab04-de17679dbb9b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:54:47
27830	9d68ea0a-a71f-4e95-b547-24eb46808a24	9d68ea0a-b080-4fe6-ab04-de17679dbb9b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"56.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:54:47
27831	9d68ea0a-a7b0-4fd5-974f-d379cc8bcbfa	9d68ea0a-b080-4fe6-ab04-de17679dbb9b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 11:54:47
27832	9d68ea0a-aea0-4c4a-bed0-aef1cd14c650	9d68ea0a-b080-4fe6-ab04-de17679dbb9b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:54:47
16302	9d64c087-7055-445f-aaea-fc6dc39051bd	9d64c087-8f53-48d5-b806-19c0cd448388	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 10:15:23
16303	9d64c087-895e-4e26-993c-9fa4a6952a07	9d64c087-8f53-48d5-b806-19c0cd448388	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 10:15:23
16304	9d64c087-89ba-4da4-a1a7-8dd71f19781b	9d64c087-8f53-48d5-b806-19c0cd448388	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 10:15:23
16305	9d64c087-8e02-40b4-ac20-51576b45d9df	9d64c087-8f53-48d5-b806-19c0cd448388	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 10:15:23
16306	9d64c087-8e4d-4ed4-9b43-c64dc8facc3a	9d64c087-8f53-48d5-b806-19c0cd448388	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":423,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:15:23
27702	9d68e924-4442-4eae-bd37-a37ecde8991c	9d68e924-78f7-4c26-909a-14fe40ac6d60	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:52:16
27703	9d68e924-703d-40b2-b74b-6fc1e55ca293	9d68e924-78f7-4c26-909a-14fe40ac6d60	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"70.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:52:16
17370	9d6558b7-0065-4a08-b946-2cdd5e5d9458	9d6558b9-dd03-4581-8ab4-d51b9a90b29a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 17:20:56
17371	9d6558b9-9e21-4bd4-b2de-6095f4ba523c	9d6558b9-dd03-4581-8ab4-d51b9a90b29a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 17:20:58
17372	9d6558b9-b298-41f7-be0b-ebecbc589b29	9d6558b9-dd03-4581-8ab4-d51b9a90b29a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":13305,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:20:58
27704	9d68e924-70ce-49da-b726-d50452cadf39	9d68e924-78f7-4c26-909a-14fe40ac6d60	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:52:16
27705	9d68e924-76cf-45e2-b2ec-e3f615fbd29e	9d68e924-78f7-4c26-909a-14fe40ac6d60	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:52:16
27706	9d68e924-775c-45a2-843a-9aa465d21f2e	9d68e924-78f7-4c26-909a-14fe40ac6d60	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":785,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:52:16
27833	9d68ea0a-af35-4dc1-9af4-68a718bc8fa0	9d68ea0a-b080-4fe6-ab04-de17679dbb9b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":554,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:54:47
17373	9d6558ba-454c-4df5-93a6-67e6c6dd025e	9d6558ba-ea81-4a06-a798-2fa33136a6a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 17:20:58
17374	9d6558ba-63d3-4a85-85af-3fa9dc8ac8e9	9d6558ba-ea81-4a06-a798-2fa33136a6a5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"43.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":46,"hash":"fb4ded687569d92428336ceae5c6ffcd","hostname":"EderCortes"}	2024-11-02 17:20:58
17375	9d6558ba-e92a-4ef6-b6dd-9bd9231f9b1f	9d6558ba-ea81-4a06-a798-2fa33136a6a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 17:20:59
17376	9d6558ba-e990-4d69-9662-09b00fefe6d1	9d6558ba-ea81-4a06-a798-2fa33136a6a5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":595,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:20:59
27834	9d68ea0b-4294-4d01-af52-3a22a8a11ac9	9d68ea0b-6a9b-49da-8522-2e1a6a76380a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:54:47
27835	9d68ea0b-6222-4700-a068-499901320b94	9d68ea0b-6a9b-49da-8522-2e1a6a76380a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '81' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"50.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 11:54:47
27836	9d68ea0b-629d-42d4-b902-a13ef28ff2b5	9d68ea0b-6a9b-49da-8522-2e1a6a76380a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 11:54:47
27837	9d68ea0b-64ca-4c13-8726-6e3af34d3a6a	9d68ea0b-6a9b-49da-8522-2e1a6a76380a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '81' order by \\"item_loans\\".\\"id\\" asc","time":"2.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:54:47
27838	9d68ea0b-6503-4b41-ada7-9f421076f6ab	9d68ea0b-6a9b-49da-8522-2e1a6a76380a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 11:54:47
27839	9d68ea0b-68f8-4855-ac19-527af7e44cff	9d68ea0b-6a9b-49da-8522-2e1a6a76380a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:54:47
27840	9d68ea0b-6950-4ef4-bfd4-5c76e08d15f3	9d68ea0b-6a9b-49da-8522-2e1a6a76380a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/81","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":81,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"0","loans_pago_prestado":"0","loans_intereses_recaudar":"275000"},"items":[{"id":311,"loans_codigo":81,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":312,"loans_codigo":81,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":313,"loans_codigo":81,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":314,"loans_codigo":81,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":315,"loans_codigo":81,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":444,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:54:47
17377	9d6558bc-47dd-457c-bc3e-3985a7076d32	9d6558bc-ca2c-44d3-9d5c-53e030ad8590	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 17:20:59
17378	9d6558bc-95d9-486f-af2a-82b277710b0e	9d6558bc-ca2c-44d3-9d5c-53e030ad8590	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"173.79","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 17:21:00
17379	9d6558bc-9672-4f58-ae11-228525102efb	9d6558bc-ca2c-44d3-9d5c-53e030ad8590	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 17:21:00
17380	9d6558bc-c79c-465c-8a68-285a91b4d0b0	9d6558bc-ca2c-44d3-9d5c-53e030ad8590	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 17:21:00
17381	9d6558bc-c842-45db-9040-9ac827e1dfbf	9d6558bc-ca2c-44d3-9d5c-53e030ad8590	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":683,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:21:00
27841	9d68ea0c-33a5-4d74-b7f0-cf1f73801605	9d68ea0c-8bd7-4266-9bed-162cc8499212	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:54:48
27842	9d68ea0c-8186-4704-9a10-fe90599b0045	9d68ea0c-8bd7-4266-9bed-162cc8499212	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"131.72","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:54:48
27843	9d68ea0c-8215-477e-8ac6-79fd1f19b3c9	9d68ea0c-8bd7-4266-9bed-162cc8499212	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:54:48
27844	9d68ea0c-89a8-4415-b0ed-5c24551df11d	9d68ea0c-8bd7-4266-9bed-162cc8499212	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:54:48
27845	9d68ea0c-8a40-40fb-985b-8c53334df0da	9d68ea0c-8bd7-4266-9bed-162cc8499212	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":722,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:54:48
27846	9d68ea0d-4d7b-4fbd-a822-af973b883a92	9d68ea0d-7e3d-4219-8424-0ca80b3a34aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:54:49
27847	9d68ea0d-74c4-4e2a-95c1-4fae7bdadaf0	9d68ea0d-7e3d-4219-8424-0ca80b3a34aa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"62.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:54:49
27848	9d68ea0d-754a-4d93-ba14-abcaa808ccbd	9d68ea0d-7e3d-4219-8424-0ca80b3a34aa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:54:49
27849	9d68ea0d-7c32-4a67-8b48-1a162d19c43d	9d68ea0d-7e3d-4219-8424-0ca80b3a34aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:54:49
27850	9d68ea0d-7cbd-492a-a53b-a9ddfc1e3809	9d68ea0d-7e3d-4219-8424-0ca80b3a34aa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":592,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:54:49
40622	9d6cc615-18a3-4a79-af5b-a7828abdef2c	9d6cc615-1c18-4db5-b7d5-7183a9560745	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1834}	2024-11-06 09:57:33
27944	9d68ea7e-636b-410b-8291-4d6e57b8b8da	9d68ea7e-817b-4b38-ac5d-e2dc4150dbaf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:56:03
27945	9d68ea7e-7fb6-4742-bb28-cf635fdc4189	9d68ea7e-817b-4b38-ac5d-e2dc4150dbaf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:56:03
27946	9d68ea7e-8055-406c-a4ec-446e4bfef1b8	9d68ea7e-817b-4b38-ac5d-e2dc4150dbaf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:56:03
2525	9d50fa2a-1ff2-4a4c-bcde-e263a9d6989d	9d50fa2a-2331-4c2f-8e4a-85484e055dde	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":144}	2024-10-23 14:20:00
4951	9d513657-bc44-4ab3-ba57-b1d831a66ecf	9d513657-c1ee-45e8-af9a-1774b8161a68	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":266}	2024-10-23 17:08:16
27947	9d68ea7f-04a5-40e2-85be-54effb0400c1	9d68ea7f-25dc-46b8-95a2-f105f62d8721	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:56:03
27948	9d68ea7f-1b65-4d1c-b152-a88e5caa340a	9d68ea7f-25dc-46b8-95a2-f105f62d8721	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"43.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:56:03
27949	9d68ea7f-1f71-451f-8e28-5085bd79eabe	9d68ea7f-25dc-46b8-95a2-f105f62d8721	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:56:03
27950	9d68ea7f-1fab-42ec-aa8f-6fe522a0b0aa	9d68ea7f-25dc-46b8-95a2-f105f62d8721	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:56:03
27951	9d68ea7f-2467-46cb-b4f3-bfc2011eb35b	9d68ea7f-25dc-46b8-95a2-f105f62d8721	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:56:03
27952	9d68ea7f-24c7-48c1-b86b-e49fca0ffff4	9d68ea7f-25dc-46b8-95a2-f105f62d8721	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":374,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:56:03
28057	9d68eb62-a421-41ae-887c-c073199d5370	9d68eb62-e0e0-4792-98b0-79ff4b42fa86	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:58:32
28058	9d68eb62-de17-4ce9-a12a-e24856c0dc32	9d68eb62-e0e0-4792-98b0-79ff4b42fa86	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:58:32
28059	9d68eb62-df5b-4f21-a067-fcb4f6a2f6c1	9d68eb62-e0e0-4792-98b0-79ff4b42fa86	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":628,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:58:32
19290	9d66d349-bae6-4308-aa9d-1388378f3c60	9d66d349-bf31-483d-aa19-894dab961489	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":945}	2024-11-03 10:59:30
5474	9d5220ed-76eb-4593-9fd8-356eeced83a0	9d5220ed-87d5-4dd3-a55a-253a030f333e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":293}	2024-10-24 04:04:13
28060	9d68eb63-a0d8-448c-8460-95c1d0d8e9a3	9d68eb63-d806-425a-b87f-422da0ee00be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:58:33
28061	9d68eb63-cd66-4b49-8fb2-b2f4b6754f6a	9d68eb63-d806-425a-b87f-422da0ee00be	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"73.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:58:33
28062	9d68eb63-ce01-4a61-b954-e5fbe7e5756e	9d68eb63-d806-425a-b87f-422da0ee00be	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:58:33
28063	9d68eb63-d5c1-4315-8c15-a42c9ddd3fbf	9d68eb63-d806-425a-b87f-422da0ee00be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:58:33
19914	9d66eba9-2502-4fbd-ac75-c8658f535ff3	9d66eba9-7a9b-4b0a-a0c7-5e1cc9f6fa12	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 12:07:39
19915	9d66eba9-7887-4c51-98c8-018b69bdd8d1	9d66eba9-7a9b-4b0a-a0c7-5e1cc9f6fa12	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:07:39
19916	9d66eba9-7964-4e78-8e1c-308476a9058a	9d66eba9-7a9b-4b0a-a0c7-5e1cc9f6fa12	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":417,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:07:39
28064	9d68eb63-d663-4fbe-9bd0-43c851912878	9d68eb63-d806-425a-b87f-422da0ee00be	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":558,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:58:33
19917	9d66eba9-eff1-401e-abcd-002be5d40b74	9d66ebaa-1168-4108-8e4c-83e41a4a81ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:07:40
19918	9d66ebaa-069c-422b-89e2-84b3454730a5	9d66ebaa-1168-4108-8e4c-83e41a4a81ce	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"43.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:07:40
19919	9d66ebaa-0b07-42dc-8740-edecb0362cd4	9d66ebaa-1168-4108-8e4c-83e41a4a81ce	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:07:40
19920	9d66ebaa-0b3b-4e74-bff2-09b82f978710	9d66ebaa-1168-4108-8e4c-83e41a4a81ce	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:07:40
19921	9d66ebaa-1018-4855-8794-261c5e440975	9d66ebaa-1168-4108-8e4c-83e41a4a81ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:07:40
19922	9d66ebaa-106f-4705-95e5-dc05cec10cac	9d66ebaa-1168-4108-8e4c-83e41a4a81ce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":341,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:07:40
28065	9d68eb64-8ebe-43b1-85af-dc49d2150b41	9d68eb64-e5bf-4ff2-b3f8-e0ffe75228d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:58:33
28066	9d68eb64-dc45-422a-876f-1f4725e4b007	9d68eb64-e5bf-4ff2-b3f8-e0ffe75228d6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"165.67","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:58:34
28067	9d68eb64-dcc7-4bd8-894f-aa21849d1387	9d68eb64-e5bf-4ff2-b3f8-e0ffe75228d6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 11:58:34
28068	9d68eb64-e3ad-46df-af40-60ccd6d7b9f2	9d68eb64-e5bf-4ff2-b3f8-e0ffe75228d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:58:34
28069	9d68eb64-e432-48b2-bee2-2332dca11789	9d68eb64-e5bf-4ff2-b3f8-e0ffe75228d6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":658,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:58:34
19923	9d66ebac-09d1-4d29-aa92-c89671b4d882	9d66ebac-284d-4f4e-8639-4b8b88813fbc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:07:41
19924	9d66ebac-2315-4a17-aa8a-d0e1745495b3	9d66ebac-284d-4f4e-8639-4b8b88813fbc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:07:41
19925	9d66ebac-235f-4b48-bbf2-5f5a5226008c	9d66ebac-284d-4f4e-8639-4b8b88813fbc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:07:41
19926	9d66ebac-2706-410e-a84a-bb6b060a9946	9d66ebac-284d-4f4e-8639-4b8b88813fbc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:07:41
19927	9d66ebac-274b-48fb-ab1f-7171a3727b73	9d66ebac-284d-4f4e-8639-4b8b88813fbc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:07:41
28070	9d68eb65-8da8-4a76-b78d-c61029ae75ae	9d68eb65-b7f1-4885-990b-3a0507aff477	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:58:34
28071	9d68eb65-ac51-493f-8aae-1bb805a781c5	9d68eb65-b7f1-4885-990b-3a0507aff477	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '81' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"54.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 11:58:34
28072	9d68eb65-aced-40e7-ab88-7e8a3a526bc6	9d68eb65-b7f1-4885-990b-3a0507aff477	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 11:58:34
28073	9d68eb65-b042-4598-b8a6-760804495fbf	9d68eb65-b7f1-4885-990b-3a0507aff477	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '81' order by \\"item_loans\\".\\"id\\" asc","time":"4.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:58:34
28074	9d68eb65-b0a1-43f4-96ea-815560e6c06f	9d68eb65-b7f1-4885-990b-3a0507aff477	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 11:58:34
28075	9d68eb65-b61c-421f-b4c1-2b46c2936a8e	9d68eb65-b7f1-4885-990b-3a0507aff477	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:58:34
28076	9d68eb65-b6a7-4a2f-b4ba-98fa86c7a7e4	9d68eb65-b7f1-4885-990b-3a0507aff477	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/81","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":81,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"0","loans_pago_prestado":"0","loans_intereses_recaudar":"275000"},"items":[{"id":311,"loans_codigo":81,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":312,"loans_codigo":81,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":313,"loans_codigo":81,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":314,"loans_codigo":81,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":315,"loans_codigo":81,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":509,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:58:34
28077	9d68eb66-d6fd-4954-878a-5455c1245dc5	9d68eb67-38d2-42f0-ae27-9d15e4f0ff59	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:58:35
28078	9d68eb67-2ce1-4ee8-87ae-c1cc1bb716cb	9d68eb67-38d2-42f0-ae27-9d15e4f0ff59	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"117.53","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:58:35
18518	9d6692f6-7855-4378-b0d8-5275b65bbf18	9d6692f6-a1ca-49a7-9cc6-02758fbfba92	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 07:59:38
18519	9d6692f6-9fad-4e82-adb5-d6101871a8fd	9d6692f6-a1ca-49a7-9cc6-02758fbfba92	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 07:59:38
18520	9d6692f6-a098-48ee-8114-d80507be813e	9d6692f6-a1ca-49a7-9cc6-02758fbfba92	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":320,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:59:38
28079	9d68eb67-2d8b-42d2-b6a5-ced6a1d6ee00	9d68eb67-38d2-42f0-ae27-9d15e4f0ff59	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:58:35
28080	9d68eb67-3655-4f60-bdb7-4d11bffb8853	9d68eb67-38d2-42f0-ae27-9d15e4f0ff59	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:58:35
28081	9d68eb67-36f7-4809-9395-3f7913089605	9d68eb67-38d2-42f0-ae27-9d15e4f0ff59	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":957,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:58:35
28082	9d68eb68-11b9-4194-9ca8-7d70f6899906	9d68eb68-650a-466d-b078-ce25c489971f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:58:36
18432	9d669127-6bc3-4dbe-ae87-6126489c3c07	9d669127-c4f4-4b4e-b086-49ab2faffd5a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 07:54:35
18433	9d669127-c2a1-472c-a8c7-a4fc0d19844b	9d669127-c4f4-4b4e-b086-49ab2faffd5a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 07:54:35
18434	9d669127-c3af-462f-bdf3-e0e01d34bf4a	9d669127-c4f4-4b4e-b086-49ab2faffd5a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":437,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:54:35
28083	9d68eb68-5633-46b0-8d49-2783d79a7deb	9d68eb68-650a-466d-b078-ce25c489971f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"119.64","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:58:36
28084	9d68eb68-56dd-442a-a56f-cc6fdfe81310	9d68eb68-650a-466d-b078-ce25c489971f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:58:36
18521	9d6692f7-143c-442a-bfe5-c829729b22a5	9d6692f7-61b5-4f53-b4e2-7a5c12c822a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 07:59:38
28085	9d68eb68-606b-453c-b1cd-b8339679065f	9d68eb68-650a-466d-b078-ce25c489971f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:58:36
18522	9d6692f7-5c71-4361-8652-9f43a7bcd79c	9d6692f7-61b5-4f53-b4e2-7a5c12c822a5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"163.73","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58,"hash":"77f8314368b36a9393ec9c7735a91700","hostname":"EderCortes"}	2024-11-03 07:59:39
18523	9d6692f7-6048-4c15-b3f3-ccf69d00edd8	9d6692f7-61b5-4f53-b4e2-7a5c12c822a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 07:59:39
28086	9d68eb68-611f-460d-a4b7-3a303ed842ec	9d68eb68-650a-466d-b078-ce25c489971f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":730,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:58:36
18435	9d669128-3428-4f2b-a21f-d69c3de0c13a	9d669128-53f2-4776-ab74-22f578725e66	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 07:54:35
18436	9d669128-4e53-4bb7-a777-ff0d1a995aa4	9d669128-53f2-4776-ab74-22f578725e66	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"48.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58,"hash":"77f8314368b36a9393ec9c7735a91700","hostname":"EderCortes"}	2024-11-03 07:54:35
18437	9d669128-5261-475c-a529-e9ded87e00e4	9d669128-53f2-4776-ab74-22f578725e66	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 07:54:35
18438	9d669128-52da-4da2-a506-104330192409	9d669128-53f2-4776-ab74-22f578725e66	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":307,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:54:35
18524	9d6692f7-60bb-4cfd-94a3-b6a207f7d764	9d6692f7-61b5-4f53-b4e2-7a5c12c822a5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":439,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:59:39
18439	9d669129-f100-4a02-b27a-71a4ea29adea	9d66912a-0d49-499d-8873-2e46086753d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 07:54:36
18440	9d66912a-083e-4f9f-b7f2-e0c8ae854bb4	9d66912a-0d49-499d-8873-2e46086753d8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 07:54:36
18441	9d66912a-0888-4a34-8310-965f62d164a5	9d66912a-0d49-499d-8873-2e46086753d8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 07:54:36
18442	9d66912a-0c1c-4021-8792-729e8d19a98c	9d66912a-0d49-499d-8873-2e46086753d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 07:54:36
18443	9d66912a-0c63-4e23-85b8-b5b2bc0c04fc	9d66912a-0d49-499d-8873-2e46086753d8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":242,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:54:36
18525	9d6692f9-ec5c-4d25-84e2-b16d9a16a094	9d6692fa-3be1-44b4-929f-13099f254055	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 07:59:40
18526	9d6692fa-34dc-4419-a7e6-0e5ac3749c84	9d6692fa-3be1-44b4-929f-13099f254055	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"156.26","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 07:59:40
18527	9d6692fa-353a-40cb-b4f1-6025be6cec96	9d6692fa-3be1-44b4-929f-13099f254055	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 07:59:40
18528	9d6692fa-3a22-4385-9d3b-1de556ab7920	9d6692fa-3be1-44b4-929f-13099f254055	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 07:59:40
18529	9d6692fa-3a83-4aeb-9f95-a01ff6bca19d	9d6692fa-3be1-44b4-929f-13099f254055	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":423,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:59:40
20004	9d66ed1b-df92-4448-b3b2-87d81551b708	9d66ed1c-2e3b-4cbe-b056-94fb3e8ab9ec	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 12:11:42
20005	9d66ed1c-2c54-4a3e-b7e5-e9fcb0c9952b	9d66ed1c-2e3b-4cbe-b056-94fb3e8ab9ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:11:42
20006	9d66ed1c-2d0e-4376-ad43-eaa0dd13971f	9d66ed1c-2e3b-4cbe-b056-94fb3e8ab9ec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":394,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:11:42
37207	9d6b45df-2512-46ba-a498-700bf43a77a0	9d6b45df-2867-4d88-8bf3-f12302fa4bfc	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1681}	2024-11-05 16:03:13
20391	9d66f1d6-25e0-42fc-b8df-1319c0d739f7	9d66f1d6-2945-4078-a58d-6723cf04d128	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1012}	2024-11-03 12:24:55
20007	9d66ed1c-97ee-41e1-a87f-8adf0d7a7834	9d66ed1c-b65c-4ec6-85e8-42c74f760225	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:11:42
20008	9d66ed1c-acf5-4375-9538-9d2225db62bc	9d66ed1c-b65c-4ec6-85e8-42c74f760225	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"40.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:11:43
20009	9d66ed1c-b06c-4e63-b6f4-05f8a0df2c75	9d66ed1c-b65c-4ec6-85e8-42c74f760225	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"1.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:11:43
20010	9d66ed1c-b09b-43af-b290-02f069c64247	9d66ed1c-b65c-4ec6-85e8-42c74f760225	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:11:43
18647	9d669896-b4c9-4f7d-b2cd-113ddb2b9f77	9d669896-e02a-451d-9bf0-d05ac3ca57b9	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 08:15:22
18648	9d669896-de35-44b5-9b4c-6dba85a4fe58	9d669896-e02a-451d-9bf0-d05ac3ca57b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:15:22
18649	9d669896-defb-4949-a366-1c8ed7ef10a6	9d669896-e02a-451d-9bf0-d05ac3ca57b9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":396,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:15:22
20011	9d66ed1c-b529-4173-9204-50c3abb6cf32	9d66ed1c-b65c-4ec6-85e8-42c74f760225	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:11:43
20012	9d66ed1c-b577-484d-839a-0e62ec44e7d0	9d66ed1c-b65c-4ec6-85e8-42c74f760225	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:11:43
28191	9d68ff1e-6bb5-44b5-a13c-1023e50c4c92	9d68ff1e-9f73-4041-92d3-22eaaf197158	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 12:53:43
28192	9d68ff1e-9ca1-4cd8-b368-37b3d759d2b8	9d68ff1e-9f73-4041-92d3-22eaaf197158	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 12:53:43
28193	9d68ff1e-9dee-466d-b9ee-d0fbf22160f1	9d68ff1e-9f73-4041-92d3-22eaaf197158	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":590,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:53:43
28303	9d690056-e670-4aa3-b6c7-1ebf121f0296	9d690057-2910-4911-89bb-95e3a531a2ad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 12:57:08
28304	9d690057-25c7-4083-8390-7b284d6a6cee	9d690057-2910-4911-89bb-95e3a531a2ad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 12:57:08
28305	9d690057-2716-4122-8478-b9abe17f9f12	9d690057-2910-4911-89bb-95e3a531a2ad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":865,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:57:08
18650	9d669897-51fc-43fd-b245-3001899fcaf8	9d669897-9de5-495f-8c75-b27b9beaf306	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:15:22
18651	9d669897-986a-45ca-b21f-1d9adb04e687	9d669897-9de5-495f-8c75-b27b9beaf306	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"160.57","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58,"hash":"8c8e5c1025213c11a10d0db7a142a089","hostname":"EderCortes"}	2024-11-03 08:15:22
18652	9d669897-9c86-40e8-abb7-92adad677bd7	9d669897-9de5-495f-8c75-b27b9beaf306	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:15:22
18653	9d669897-9cee-4354-9d73-39ec6d2f1a74	9d669897-9de5-495f-8c75-b27b9beaf306	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":441,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:15:22
20013	9d66ed1e-825a-4b45-87a4-1d26f774682f	9d66ed1e-ca44-47bf-a664-947b44a16dcc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:11:44
20014	9d66ed1e-c106-4838-b183-ef3281686037	9d66ed1e-ca44-47bf-a664-947b44a16dcc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"135.73","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:11:44
20015	9d66ed1e-c173-4be6-80ac-ae02030053af	9d66ed1e-ca44-47bf-a664-947b44a16dcc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:11:44
20016	9d66ed1e-c7df-4045-a35b-81cc34928050	9d66ed1e-ca44-47bf-a664-947b44a16dcc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:11:44
20017	9d66ed1e-c857-4e39-9f6d-214e043b507a	9d66ed1e-ca44-47bf-a664-947b44a16dcc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":427,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:11:44
28194	9d68ff1f-9f46-489a-9cb5-4adfc0b91a1c	9d68ff1f-e866-45d5-b2cc-792374663a67	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 12:53:44
28306	9d690058-3ae4-4647-a27f-bd45d0e44db1	9d690058-9b5c-4c21-a433-3aaee66e88d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 12:57:09
28307	9d690058-920c-4e9e-9dc6-c82755a29a32	9d690058-9b5c-4c21-a433-3aaee66e88d9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"174.61","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 12:57:09
28308	9d690058-929a-419b-b4e5-f28f30100ae2	9d690058-9b5c-4c21-a433-3aaee66e88d9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 12:57:09
28309	9d690058-98fa-4adb-b6cf-ecf59ba1b86f	9d690058-9b5c-4c21-a433-3aaee66e88d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 12:57:09
18654	9d669899-d6fb-466c-be48-d678c959c28f	9d669899-fb6b-4dd1-9947-4c660e2c0c96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:15:24
18655	9d669899-f44b-4b8a-8150-3b67c959862f	9d669899-fb6b-4dd1-9947-4c660e2c0c96	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"49.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 08:15:24
18656	9d669899-f4c8-4d54-b6b1-c3832a6fcc8c	9d669899-fb6b-4dd1-9947-4c660e2c0c96	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 08:15:24
18657	9d669899-fa04-413e-a7b9-8325fde83e0e	9d669899-fb6b-4dd1-9947-4c660e2c0c96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 08:15:24
18658	9d669899-fa65-4e62-803d-81187f9abf1f	9d669899-fb6b-4dd1-9947-4c660e2c0c96	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":367,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:15:24
28195	9d68ff1f-d0a6-4884-8f99-515ab9866c39	9d68ff1f-e866-45d5-b2cc-792374663a67	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"92.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 12:53:44
28196	9d68ff1f-dbb7-431f-92e2-3877f784749d	9d68ff1f-e866-45d5-b2cc-792374663a67	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"11.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 12:53:44
28197	9d68ff1f-dc56-4224-b81b-89620028ba07	9d68ff1f-e866-45d5-b2cc-792374663a67	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 12:53:44
28198	9d68ff1f-e65f-494a-83e7-17c0464e8bcd	9d68ff1f-e866-45d5-b2cc-792374663a67	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 12:53:44
28199	9d68ff1f-e708-4c20-a421-8566a400f275	9d68ff1f-e866-45d5-b2cc-792374663a67	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":764,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:53:44
28310	9d690058-99d5-45a1-acee-a9c7ee79bf9c	9d690058-9b5c-4c21-a433-3aaee66e88d9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":863,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:57:09
28200	9d68ff20-ad7d-4da6-b24f-8836143dee68	9d68ff20-e923-4e63-a12f-d79c2086f45e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 12:53:44
28201	9d68ff20-de99-4d96-91f9-f6f0efe10812	9d68ff20-e923-4e63-a12f-d79c2086f45e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"76.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 12:53:45
28202	9d68ff20-df29-47a4-a988-c9c16054506e	9d68ff20-e923-4e63-a12f-d79c2086f45e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 12:53:45
28203	9d68ff20-e70f-4fee-b84a-eda338b0622e	9d68ff20-e923-4e63-a12f-d79c2086f45e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 12:53:45
28204	9d68ff20-e79f-4900-8cae-314fd8c6c764	9d68ff20-e923-4e63-a12f-d79c2086f45e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":633,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:53:45
28311	9d690059-2d8c-42df-a985-c56b29b83764	9d690059-5462-47f6-98f2-96cf34a65083	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 12:57:09
28312	9d690059-4d67-4b59-ba0f-15bf4af8a01a	9d690059-5462-47f6-98f2-96cf34a65083	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 12:57:09
28313	9d690059-4ddd-4b43-80d8-ac732762b969	9d690059-5462-47f6-98f2-96cf34a65083	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 12:57:09
28314	9d690059-52f6-4dc6-9479-b15ba4f013e8	9d690059-5462-47f6-98f2-96cf34a65083	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 12:57:09
28315	9d690059-5350-4cd6-bef0-946fe6785651	9d690059-5462-47f6-98f2-96cf34a65083	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":453,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:57:09
20089	9d66ee56-e854-4db5-871f-13223e684275	9d66ee57-4aff-45ee-8d76-34e0b0b4b02d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 12:15:08
20090	9d66ee57-4726-4a12-a33b-e8b71df64944	9d66ee57-4aff-45ee-8d76-34e0b0b4b02d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:15:09
20091	9d66ee57-48d5-4871-af3f-3393f0af7c4b	9d66ee57-4aff-45ee-8d76-34e0b0b4b02d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":763,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:15:09
20092	9d66ee57-e62f-4631-8f14-ee7ca7aa69fd	9d66ee58-a732-4e0b-af50-c6dad3f4d758	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:15:09
20093	9d66ee58-93ed-4537-adf4-1d11c5b6b0cd	9d66ee58-a732-4e0b-af50-c6dad3f4d758	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"226.24","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:15:10
20094	9d66ee58-9b5f-49f8-9e84-6f14f0bbb4d5	9d66ee58-a732-4e0b-af50-c6dad3f4d758	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"3.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:15:10
20095	9d66ee58-9bb3-4aa9-9d2f-b60d04316f0a	9d66ee58-a732-4e0b-af50-c6dad3f4d758	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:15:10
20096	9d66ee58-a53e-423a-9b14-b5c00438b163	9d66ee58-a732-4e0b-af50-c6dad3f4d758	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:15:10
20097	9d66ee58-a5c5-4a63-9dba-07648d90f646	9d66ee58-a732-4e0b-af50-c6dad3f4d758	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":821,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:15:10
28205	9d68ff21-a5ea-4ab0-9513-9ddee99b560c	9d68ff21-f48b-4981-989e-c4156a4bff04	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 12:53:45
28206	9d68ff21-e949-4780-aa2c-608930363ac4	9d68ff21-f48b-4981-989e-c4156a4bff04	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"110.85","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 12:53:45
28207	9d68ff21-e9fa-4fd6-a0b0-cfec657317da	9d68ff21-f48b-4981-989e-c4156a4bff04	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 12:53:45
28208	9d68ff21-f256-4c7b-aaee-873bedf6b4d4	9d68ff21-f48b-4981-989e-c4156a4bff04	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 12:53:45
28209	9d68ff21-f2f9-450d-96df-c1125e53ffae	9d68ff21-f48b-4981-989e-c4156a4bff04	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":659,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:53:45
28316	9d690059-e8a6-42eb-bd6c-87df17a43095	9d69005a-1ac2-4f3d-974b-93bd9b89aecb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 12:57:10
28317	9d69005a-0f01-4d85-9670-998737347ef2	9d69005a-1ac2-4f3d-974b-93bd9b89aecb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '81' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"60.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 12:57:10
28318	9d69005a-0f9a-4929-8740-bf8870bb93c6	9d69005a-1ac2-4f3d-974b-93bd9b89aecb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 12:57:10
20098	9d66ee5b-2ef7-4576-b571-3bb2b4d832ea	9d66ee5b-9721-4786-bc16-6021b6e84be5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:15:11
20099	9d66ee5b-8d05-42e2-a634-1d593d0196d8	9d66ee5b-9721-4786-bc16-6021b6e84be5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"176.39","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:15:12
20100	9d66ee5b-8d83-4504-affd-271c258b47c8	9d66ee5b-9721-4786-bc16-6021b6e84be5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:15:12
20101	9d66ee5b-94e3-4dda-beca-33c003b370fd	9d66ee5b-9721-4786-bc16-6021b6e84be5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:15:12
20102	9d66ee5b-956d-4a2c-9756-45f5f0d2ced1	9d66ee5b-9721-4786-bc16-6021b6e84be5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":696,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:15:12
28319	9d69005a-1248-4d70-b6af-80b4729ea9ab	9d69005a-1ac2-4f3d-974b-93bd9b89aecb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '81' order by \\"item_loans\\".\\"id\\" asc","time":"3.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 12:57:10
28320	9d69005a-12be-4a39-96d0-42651e2daa37	9d69005a-1ac2-4f3d-974b-93bd9b89aecb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 12:57:10
28321	9d69005a-18c5-418e-9d57-51edc4ea8e2a	9d69005a-1ac2-4f3d-974b-93bd9b89aecb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 12:57:10
28322	9d69005a-1950-40f1-9c0d-dfc0c670163c	9d69005a-1ac2-4f3d-974b-93bd9b89aecb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/81","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":81,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"0","loans_pago_prestado":"0","loans_intereses_recaudar":"275000"},"items":[{"id":311,"loans_codigo":81,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":312,"loans_codigo":81,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":313,"loans_codigo":81,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":314,"loans_codigo":81,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":315,"loans_codigo":81,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":484,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:57:10
28323	9d69005a-fdb5-4acc-a2fe-8ce29c98eb4a	9d69005b-ba69-4df2-abed-a71064c5af01	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 12:57:10
28324	9d69005b-ae1c-4643-81e7-988bf672392e	9d69005b-ba69-4df2-abed-a71064c5af01	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"270.27","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 12:57:11
28325	9d69005b-aecd-49ef-9408-db64cdd84fd3	9d69005b-ba69-4df2-abed-a71064c5af01	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 12:57:11
28326	9d69005b-b7c5-48ef-96e2-532d0ab73bbd	9d69005b-ba69-4df2-abed-a71064c5af01	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 12:57:11
28327	9d69005b-b87e-4e1a-bc01-272e4805b716	9d69005b-ba69-4df2-abed-a71064c5af01	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1043,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:57:11
20179	9d66ef2b-b9ac-4df7-b448-a03b8cc88ff2	9d66ef2b-d89b-4631-951c-f892bf18ac8a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:17:28
20180	9d66ef2b-d6d0-4c30-9d1a-417114afaf85	9d66ef2b-d89b-4631-951c-f892bf18ac8a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 12:17:28
20181	9d66ef2b-d78f-4d0f-9493-d330367a50f0	9d66ef2b-d89b-4631-951c-f892bf18ac8a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":255,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:17:28
28328	9d69005c-8492-40f4-befd-86124a583a42	9d69005c-f9e4-4183-821e-7356d218c790	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 12:57:11
28329	9d69005c-f23e-497a-bc71-ba3b56939611	9d69005c-f9e4-4183-821e-7356d218c790	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"113.59","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 12:57:12
28330	9d69005c-f2f9-4244-a563-95c0cb713f4d	9d69005c-f9e4-4183-821e-7356d218c790	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 12:57:12
28331	9d69005c-f80f-4911-a2f7-dadf9ee753f3	9d69005c-f9e4-4183-821e-7356d218c790	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 12:57:12
20182	9d66ef2c-32f7-4801-a2e9-abfeb082f758	9d66ef2c-7cf3-4608-a7c4-7243141af39e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 12:17:28
20183	9d66ef2c-7425-4451-ae3f-c35850c0a8b5	9d66ef2c-7cf3-4608-a7c4-7243141af39e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"151.94","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:17:28
20184	9d66ef2c-77b4-4d97-9b46-4dd5925807f2	9d66ef2c-7cf3-4608-a7c4-7243141af39e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:17:28
20185	9d66ef2c-7800-4068-8210-6e83e78a66be	9d66ef2c-7cf3-4608-a7c4-7243141af39e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:17:28
20186	9d66ef2c-7bcd-45d8-8be5-24dbb64031fa	9d66ef2c-7cf3-4608-a7c4-7243141af39e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 12:17:28
20187	9d66ef2c-7c11-434d-8103-d45e3b2bb834	9d66ef2c-7cf3-4608-a7c4-7243141af39e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":375,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:17:28
28332	9d69005c-f886-4460-9826-a481a4ca9ae7	9d69005c-f9e4-4183-821e-7356d218c790	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":790,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:57:12
20188	9d66ef2e-1fa9-415d-b414-e3f6d3d8ddfa	9d66ef2e-5307-4bed-bbfc-a88d3d8aa4e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 12:17:30
20189	9d66ef2e-49d8-447b-bd21-7577cce40661	9d66ef2e-5307-4bed-bbfc-a88d3d8aa4e0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"77.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:17:30
20190	9d66ef2e-4a61-4523-a8d5-076a59d69ee4	9d66ef2e-5307-4bed-bbfc-a88d3d8aa4e0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:17:30
20191	9d66ef2e-5100-4b1a-8a36-1d058023f53c	9d66ef2e-5307-4bed-bbfc-a88d3d8aa4e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 12:17:30
20192	9d66ef2e-5184-413d-8e59-1fc8da0efceb	9d66ef2e-5307-4bed-bbfc-a88d3d8aa4e0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":358,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:17:30
28426	9d6901ac-0392-482d-8248-42715dac07df	9d6901ac-d7fc-479b-befc-3063fdd05414	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 13:00:51
28427	9d6901ac-d4c3-479a-96fd-1307b3192a63	9d6901ac-d7fc-479b-befc-3063fdd05414	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 13:00:52
28428	9d6901ac-d649-41a4-9d78-c21621cbcd8f	9d6901ac-d7fc-479b-befc-3063fdd05414	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1027,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:00:52
28429	9d6901ad-c561-4019-abba-a5578458c5ff	9d6901ae-0ffd-4f61-adb0-071e1e1e16c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 13:00:52
28430	9d6901ae-03eb-4480-936e-61a4a7ec8a53	9d6901ae-0ffd-4f61-adb0-071e1e1e16c8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"97.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:00:53
28431	9d6901ae-04a5-42fe-bf23-dc921c88bec3	9d6901ae-0ffd-4f61-adb0-071e1e1e16c8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 13:00:53
28432	9d6901ae-0d93-4e89-9355-9818ef6de5e8	9d6901ae-0ffd-4f61-adb0-071e1e1e16c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 13:00:53
28433	9d6901ae-0e47-464f-80b0-9ba268a6a750	9d6901ae-0ffd-4f61-adb0-071e1e1e16c8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":711,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:00:53
14438	9d5d1e2d-069e-427e-88ac-638c8905a83a	9d5d1e2d-2c0b-4fba-b04a-90825c9b19c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-10-29 15:10:37
14439	9d5d1e2d-29dc-4f0a-abd0-2e767737173c	9d5d1e2d-2c0b-4fba-b04a-90825c9b19c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-10-29 15:10:37
14440	9d5d1e2d-2ac9-4973-9894-ae28871be1a7	9d5d1e2d-2c0b-4fba-b04a-90825c9b19c9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":465,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:10:37
28434	9d6901ae-dbec-4b17-b946-a793ede8d9a1	9d6901af-29a3-4ece-bd7f-da264af6a8da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 13:00:53
28435	9d6901af-1cc0-4044-97cc-58de40263dda	9d6901af-29a3-4ece-bd7f-da264af6a8da	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"108.88","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:00:53
28436	9d6901af-1d71-4f3f-be80-48ec145f718f	9d6901af-29a3-4ece-bd7f-da264af6a8da	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 13:00:53
28437	9d6901af-26db-4c40-9a63-3b17ec42b2a2	9d6901af-29a3-4ece-bd7f-da264af6a8da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 13:00:53
28438	9d6901af-27a1-40e1-af49-078e5c56ed61	9d6901af-29a3-4ece-bd7f-da264af6a8da	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":696,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:00:53
28439	9d6901af-f6a6-4d19-89f1-f41b8c0136a8	9d6901b0-1b1f-4be7-944c-f18bfb9cd7a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 13:00:54
28440	9d6901b0-129c-4570-ba1a-930a5db9c29a	9d6901b0-1b1f-4be7-944c-f18bfb9cd7a6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '81' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"43.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 13:00:54
23001	9d68005c-6ca2-4d4c-811d-6d195222e228	9d68005c-919f-4768-97a5-f0b4bdfc9c07	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 01:01:22
23002	9d68005c-8fb6-4f1d-8ca2-c3ee06a9546e	9d68005c-919f-4768-97a5-f0b4bdfc9c07	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 01:01:22
23003	9d68005c-9082-4f94-b963-5e3d5a2ad0e6	9d68005c-919f-4768-97a5-f0b4bdfc9c07	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-11-04 01:01:22
28441	9d6901b0-12fb-47da-b59e-ed8df9dfa115	9d6901b0-1b1f-4be7-944c-f18bfb9cd7a6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 13:00:54
28442	9d6901b0-14b3-4a8f-ac93-22756edeb0a3	9d6901b0-1b1f-4be7-944c-f18bfb9cd7a6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '81' order by \\"item_loans\\".\\"id\\" asc","time":"2.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:00:54
28443	9d6901b0-14ed-44c2-9601-79bd17fb9379	9d6901b0-1b1f-4be7-944c-f18bfb9cd7a6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 13:00:54
28444	9d6901b0-1962-423e-9705-748a17e60815	9d6901b0-1b1f-4be7-944c-f18bfb9cd7a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 13:00:54
28445	9d6901b0-19da-40a3-8260-44a4a1d0e5f0	9d6901b0-1b1f-4be7-944c-f18bfb9cd7a6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/81","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":81,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"0","loans_pago_prestado":"0","loans_intereses_recaudar":"275000"},"items":[{"id":311,"loans_codigo":81,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":312,"loans_codigo":81,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":313,"loans_codigo":81,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":314,"loans_codigo":81,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":315,"loans_codigo":81,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":587,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:00:54
23004	9d68005d-0391-4e6d-bea5-360448b9b5ce	9d68005d-4c56-4dac-948b-19870bddcf47	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 01:01:22
23005	9d68005d-42fa-4646-bd68-c37b75cb4fc8	9d68005d-4c56-4dac-948b-19870bddcf47	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 70\\n                        ","time":"150.10","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"40345ecc36d5b014fbb2cca663c7c347","hostname":"EderCortes"}	2024-11-04 01:01:22
23006	9d68005d-467e-4daa-9678-23f2a422387f	9d68005d-4c56-4dac-948b-19870bddcf47	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '70' order by \\"item_loans\\".\\"id\\" asc","time":"1.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 01:01:22
23007	9d68005d-46b1-4689-94e0-1bff23f93dcb	9d68005d-4c56-4dac-948b-19870bddcf47	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 01:01:22
23008	9d68005d-4b45-42ba-b714-7322da937a34	9d68005d-4c56-4dac-948b-19870bddcf47	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 01:01:22
23009	9d68005d-4b90-4b53-9d32-d20a9cb573bf	9d68005d-4c56-4dac-948b-19870bddcf47	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/70","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":70,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":2150000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"430000","loans_pago_interes":"107500"},"items":[{"id":248,"loans_codigo":70,"itemloans_cuota":"1","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:52:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"107500","itemloans_cuota_cancelada":"430000"},{"id":249,"loans_codigo":70,"itemloans_cuota":"2","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":250,"loans_codigo":70,"itemloans_cuota":"3","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":251,"loans_codigo":70,"itemloans_cuota":"4","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":252,"loans_codigo":70,"itemloans_cuota":"5","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":386,"memory":22,"hostname":"EderCortes"}	2024-11-04 01:01:22
28446	9d6901b0-edff-40bd-97ea-ef1dd825ba19	9d6901b1-2c0b-4691-b25d-bc5bc6af4cae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 13:00:55
28447	9d6901b1-21df-4095-b87c-71a9cc0ed0ac	9d6901b1-2c0b-4691-b25d-bc5bc6af4cae	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"94.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:00:55
28448	9d6901b1-226a-4e5f-b0b3-5b8c1c339242	9d6901b1-2c0b-4691-b25d-bc5bc6af4cae	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:00:55
28449	9d6901b1-29ef-4c64-a202-3d29a2cb523e	9d6901b1-2c0b-4691-b25d-bc5bc6af4cae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 13:00:55
28450	9d6901b1-2a89-438f-bbf8-42eaa93cc62d	9d6901b1-2c0b-4691-b25d-bc5bc6af4cae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":680,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:00:55
23010	9d68005f-256d-46f2-a32b-5b804f8823f8	9d68005f-40e6-4600-b7dc-57e66a662aa6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 01:01:23
23011	9d68005f-3bb7-4b87-9f08-395018b500b7	9d68005f-40e6-4600-b7dc-57e66a662aa6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"38.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 01:01:24
23012	9d68005f-3c04-4708-b1d3-0ed7c8c9c40e	9d68005f-40e6-4600-b7dc-57e66a662aa6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 01:01:24
23013	9d68005f-3f7e-417b-a875-0280bb609de9	9d68005f-40e6-4600-b7dc-57e66a662aa6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 01:01:24
23014	9d68005f-3fcd-4754-b0a9-378f8c22f520	9d68005f-40e6-4600-b7dc-57e66a662aa6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-11-04 01:01:24
28451	9d6901b1-f3d1-4dbf-8c0a-176e6d01f998	9d6901b2-5089-42b6-81a5-43d47a30d537	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 13:00:55
28452	9d6901b2-480b-4106-8138-99737eca5353	9d6901b2-5089-42b6-81a5-43d47a30d537	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"174.96","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:00:55
28453	9d6901b2-48ba-46c2-8801-9625faa4b85c	9d6901b2-5089-42b6-81a5-43d47a30d537	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:00:55
28454	9d6901b2-4e7a-4dfa-abad-71d87fe78880	9d6901b2-5089-42b6-81a5-43d47a30d537	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 13:00:55
28455	9d6901b2-4f0a-4d82-adcc-5c0b020f2adb	9d6901b2-5089-42b6-81a5-43d47a30d537	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":719,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:00:55
23015	9d68007d-1310-4fa1-a699-7ae6a66afc13	9d68007d-16fa-4e99-b106-e7c7e2c4b83b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":162,"memory":22,"hostname":"EderCortes"}	2024-11-04 01:01:43
16482	9d64ccc7-47e5-47ec-a8f9-97c330198355	9d64ccc7-6b1a-403b-8ed1-65f09af1e2a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 10:49:39
16483	9d64ccc7-695b-4b5b-aaf2-c95cc461b78f	9d64ccc7-6b1a-403b-8ed1-65f09af1e2a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 10:49:39
16484	9d64ccc7-6a08-43fc-bb9e-d8d77a3ada6c	9d64ccc7-6b1a-403b-8ed1-65f09af1e2a4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":273,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:49:39
16485	9d64ccc7-ba63-40d6-b77c-abe17eee9d4c	9d64ccc8-035c-4a9e-b04e-f7a4c787564a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 10:49:39
16486	9d64ccc7-fad4-44f7-80b8-091d9352fa63	9d64ccc8-035c-4a9e-b04e-f7a4c787564a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"154.24","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 10:49:39
16487	9d64ccc7-fe63-4651-aaf0-ae3ed1fef409	9d64ccc8-035c-4a9e-b04e-f7a4c787564a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 10:49:39
16488	9d64ccc7-fe98-4b3e-abc4-727288b380c5	9d64ccc8-035c-4a9e-b04e-f7a4c787564a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 10:49:39
16489	9d64ccc8-0239-4218-9bfa-4a8a27371e80	9d64ccc8-035c-4a9e-b04e-f7a4c787564a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 10:49:39
16490	9d64ccc8-0286-4867-a0bc-34d8b52076d2	9d64ccc8-035c-4a9e-b04e-f7a4c787564a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":344,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:49:39
23225	9d688d33-46b7-4d8b-bf5c-edfdf36d7b10	9d688d33-6530-4a98-8818-c61c8da3e1be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 07:35:11
16491	9d64ccca-0754-4adf-b951-d1aee956b879	9d64ccca-2920-4eb7-a59d-67868ccdabfd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 10:49:40
16492	9d64ccca-2355-4253-bfe3-7828261ed951	9d64ccca-2920-4eb7-a59d-67868ccdabfd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"46.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 10:49:40
16493	9d64ccca-23b6-4656-afcc-1b940cd34e01	9d64ccca-2920-4eb7-a59d-67868ccdabfd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 10:49:40
16494	9d64ccca-2788-4e2d-a936-5e39b810bfb1	9d64ccca-2920-4eb7-a59d-67868ccdabfd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 10:49:40
16495	9d64ccca-27e9-43e0-a337-cefe813a45ad	9d64ccca-2920-4eb7-a59d-67868ccdabfd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:49:40
23226	9d688d33-63a4-4549-a5aa-23ac90791143	9d688d33-6530-4a98-8818-c61c8da3e1be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 07:35:11
20287	9d66f105-a6d2-4fac-8699-4ca363f3afbe	9d66f105-cd47-4020-98d3-6aed298924be	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 12:22:39
20288	9d66f105-cb55-4453-ba76-64452c8e556b	9d66f105-cd47-4020-98d3-6aed298924be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:22:39
20289	9d66f105-cc14-44e0-ae10-73adf00a9cc9	9d66f105-cd47-4020-98d3-6aed298924be	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":265,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:22:39
23227	9d688d33-6441-4c70-ba64-d42e86355190	9d688d33-6530-4a98-8818-c61c8da3e1be	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":276,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:35:11
16496	9d64ccdb-cb5f-48a0-94e5-b96df1dcc207	9d64ccdb-cf32-4e0c-8132-7605696c23bb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":210,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:49:52
18772	9d669bb3-0719-4cb2-a740-85fccd9495bc	9d669bb3-28b5-4d77-af74-c7b96f9f67eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 08:24:04
18773	9d669bb3-26cc-4277-80af-5f98c362735e	9d669bb3-28b5-4d77-af74-c7b96f9f67eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 08:24:04
18774	9d669bb3-2793-4dba-9e40-83ac5db9137a	9d669bb3-28b5-4d77-af74-c7b96f9f67eb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42883]: Undefined function: 7 ERROR:  el operador no existe: text - date\\nLINE 23:             - CURRENT_DATE\\n                     ^\\nHINT:  Ning\\u00fan operador coincide en el nombre y tipos de argumentos. Puede ser necesario agregar conversi\\u00f3n expl\\u00edcita de tipos. (Connection: pgsql, SQL: select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":278,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:24:04
18771	9d669bb3-24ec-41eb-b827-4e1d6e4bacea	9d669bb3-28b5-4d77-af74-c7b96f9f67eb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42883]: Undefined function: 7 ERROR:  el operador no existe: text - date\\nLINE 23:             - CURRENT_DATE\\n                     ^\\nHINT:  Ning\\u00fan operador coincide en el nombre y tipos de argumentos. Puede ser necesario agregar conversi\\u00f3n expl\\u00edcita de tipos. (Connection: pgsql, SQL: select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":911}	2024-11-03 08:24:04
23228	9d688d33-b142-4fa6-8ad3-882dc96d4f1c	9d688d33-d06c-4a0b-af48-4263df725274	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 07:35:11
20290	9d66f106-30a4-46f2-b383-8a885a009479	9d66f106-79ef-450b-a5f4-2aa81f56b746	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:22:39
20291	9d66f106-6ef4-43f1-8dab-a3ad9bc8db0a	9d66f106-79ef-450b-a5f4-2aa81f56b746	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"147.83","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:22:39
20292	9d66f106-7327-4708-908f-fdd779cb5f99	9d66f106-79ef-450b-a5f4-2aa81f56b746	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:22:39
20293	9d66f106-736b-4f69-a9fa-cdb992a60875	9d66f106-79ef-450b-a5f4-2aa81f56b746	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:22:39
20294	9d66f106-7839-4c09-8048-bc62978408c9	9d66f106-79ef-450b-a5f4-2aa81f56b746	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:22:39
20295	9d66f106-7884-4833-ba19-3c4e49daf5b7	9d66f106-79ef-450b-a5f4-2aa81f56b746	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":395,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:22:39
16497	9d64ccdc-906d-4684-b2a2-c597b77dddd9	9d64ccdc-99a7-49a3-939e-4cf9bbd5a3c6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 10:49:52
16498	9d64ccdc-97f3-4ab6-b9c2-cf2de750e793	9d64ccdc-99a7-49a3-939e-4cf9bbd5a3c6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 10:49:52
16499	9d64ccdc-9855-45d7-a149-6eee816ed5dd	9d64ccdc-99a7-49a3-939e-4cf9bbd5a3c6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"157","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000","id":187,"loans_codigo":62,"item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"result":{"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000","id":187,"loans_codigo":62,"item_loans_cuando_pago":null,"itemloans_aprobador":12}},"duration":208,"memory":20,"hostname":"EderCortes"}	2024-11-02 10:49:52
18775	9d669bb4-c344-4af2-baee-39e773aa6c9e	9d669bb5-1062-4b24-9f28-dc3685ac6d94	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 08:24:05
18776	9d669bb5-095c-4335-bca5-06f9200b1cce	9d669bb5-1062-4b24-9f28-dc3685ac6d94	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"156.74","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 08:24:05
18777	9d669bb5-09ca-43c2-8f52-9ac3e323329d	9d669bb5-1062-4b24-9f28-dc3685ac6d94	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 08:24:05
18778	9d669bb5-0e99-4256-8818-03369cf89bfe	9d669bb5-1062-4b24-9f28-dc3685ac6d94	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 08:24:05
18779	9d669bb5-0f10-46b9-9d14-3fb5711c5a52	9d669bb5-1062-4b24-9f28-dc3685ac6d94	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":498,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:24:05
20296	9d66f107-c81a-424e-85f5-cbffafc40e18	9d66f108-2b2f-4552-a2d0-91033b33c38d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:22:40
20297	9d66f108-2259-44d4-8232-97b8e4f88045	9d66f108-2b2f-4552-a2d0-91033b33c38d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"168.12","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:22:40
20298	9d66f108-22f2-4011-8f2a-1604603f585b	9d66f108-2b2f-4552-a2d0-91033b33c38d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:22:40
20299	9d66f108-2986-4ce5-ac7b-8b09dba731f1	9d66f108-2b2f-4552-a2d0-91033b33c38d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:22:40
20300	9d66f108-29ef-4478-b5c9-afd0ea8a4001	9d66f108-2b2f-4552-a2d0-91033b33c38d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":619,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:22:40
23229	9d688d33-c79b-44ce-b5a1-4f47b278935b	9d688d33-d06c-4a0b-af48-4263df725274	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 70\\n                        ","time":"44.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"40345ecc36d5b014fbb2cca663c7c347","hostname":"EderCortes"}	2024-11-04 07:35:11
23230	9d688d33-cb3e-48c6-83f7-8765be9e7cae	9d688d33-d06c-4a0b-af48-4263df725274	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '70' order by \\"item_loans\\".\\"id\\" asc","time":"1.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 07:35:11
23231	9d688d33-cb8b-410a-9c8c-f8f47479a307	9d688d33-d06c-4a0b-af48-4263df725274	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 07:35:11
23232	9d688d33-cf2c-430f-82e1-8a5bcb3b5f9b	9d688d33-d06c-4a0b-af48-4263df725274	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 07:35:11
23233	9d688d33-cf7c-4285-a88d-ee2c3db7c0ff	9d688d33-d06c-4a0b-af48-4263df725274	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/70","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":70,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":2150000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"990000","loans_pago_interes":"247500"},"items":[{"id":248,"loans_codigo":70,"itemloans_cuota":"1","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:52:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"107500","itemloans_cuota_cancelada":"430000"},{"id":249,"loans_codigo":70,"itemloans_cuota":"2","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T12:35:02.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"140000","itemloans_cuota_cancelada":"560000"},{"id":253,"loans_codigo":70,"itemloans_cuota":"3","itemloans_valor_cuota":"386666.66666667","itemloans_iteres":"96666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T12:35:02.000000Z","updated_at":"2024-11-04T12:35:02.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"140000","itemloans_cuota_cancelada":"560000"},{"id":254,"loans_codigo":70,"itemloans_cuota":"4","itemloans_valor_cuota":"386666.66666667","itemloans_iteres":"96666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T12:35:02.000000Z","updated_at":"2024-11-04T12:35:02.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"140000","itemloans_cuota_cancelada":"560000"},{"id":255,"loans_codigo":70,"itemloans_cuota":"5","itemloans_valor_cuota":"386666.66666667","itemloans_iteres":"96666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T12:35:02.000000Z","updated_at":"2024-11-04T12:35:02.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"140000","itemloans_cuota_cancelada":"560000"}]}},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:35:11
23234	9d688d35-780e-4888-a52e-5c626c5fc6d4	9d688d35-c048-46d1-b9fb-5a41eabf2e72	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 07:35:12
23235	9d688d35-ba53-45cb-a1e9-abcf74685f90	9d688d35-c048-46d1-b9fb-5a41eabf2e72	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"146.99","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 07:35:12
23236	9d688d35-baa9-4226-b980-4b7139bc16ad	9d688d35-c048-46d1-b9fb-5a41eabf2e72	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 07:35:12
23237	9d688d35-beb2-4a15-8c5e-aff61d3ee6c6	9d688d35-c048-46d1-b9fb-5a41eabf2e72	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 07:35:12
23238	9d688d35-bf12-422b-8da5-dcc189735960	9d688d35-c048-46d1-b9fb-5a41eabf2e72	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":580,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:35:12
23239	9d688e53-7511-48ba-84e1-149258ce69c6	9d688e53-7a0e-4ce3-b46d-8ba12dff2e1b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":226,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:38:19
23240	9d688e53-da06-4d9c-b344-d078d949ca92	9d688e54-3852-4c0a-8f85-38fbada62262	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 07:38:20
23241	9d688e54-2832-4de6-8187-f3cc776d62f6	9d688e54-3852-4c0a-8f85-38fbada62262	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 70 limit 1","time":"3.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":498,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 07:38:20
23242	9d688e54-28bd-4988-974d-4941ee2fe457	9d688e54-3852-4c0a-8f85-38fbada62262	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":2,"hostname":"EderCortes"}	2024-11-04 07:38:20
23243	9d688e54-2a45-4546-86f0-62b822e01536	9d688e54-3852-4c0a-8f85-38fbada62262	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 367500, \\"loans_pago_prestado\\" = 1470000, \\"updated_at\\" = '2024-11-04 07:38:20' where \\"id\\" = 70","time":"0.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":556,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 07:38:20
23244	9d688e54-2ab8-46bb-886f-7725e09edb4a	9d688e54-3852-4c0a-8f85-38fbada62262	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:70","changes":{"updated_at":"2024-11-04 07:38:20","loans_pago_interes":367500,"loans_pago_prestado":1470000},"hostname":"EderCortes"}	2024-11-04 07:38:20
23245	9d688e54-2c5b-436a-a23e-34d90ab83ea3	9d688e54-3852-4c0a-8f85-38fbada62262	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 70 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"2.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":563,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 07:38:20
23246	9d688e54-2c95-430d-b4ff-b6c60e3bee16	9d688e54-3852-4c0a-8f85-38fbada62262	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 07:38:20
23247	9d688e54-2d33-4ef1-8498-4ca6c76bf124	9d688e54-3852-4c0a-8f85-38fbada62262	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = 120000, \\"itemloans_cuota_cancelada\\" = 480000, \\"updated_at\\" = '2024-11-04 07:38:20' where \\"id\\" = 253","time":"0.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":570,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 07:38:20
23248	9d688e54-2d79-4fe4-88ec-e8538c18917a	9d688e54-3852-4c0a-8f85-38fbada62262	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:253","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 07:38:20","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":120000,"itemloans_cuota_cancelada":480000},"hostname":"EderCortes"}	2024-11-04 07:38:20
23249	9d688e54-2e16-4e10-9341-c8ed74251b4f	9d688e54-3852-4c0a-8f85-38fbada62262	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select count(*) as aggregate from \\"item_loans\\" where \\"loans_codigo\\" = 70 and \\"itemloans_status\\" = 'Pagada'","time":"0.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":578,"hash":"60bd91eaa209a639fc2e8afc20430a4b","hostname":"EderCortes"}	2024-11-04 07:38:20
23250	9d688e54-2e88-4c08-ba4e-c1aa0957e838	9d688e54-3852-4c0a-8f85-38fbada62262	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"delete from \\"item_loans\\" where \\"loans_codigo\\" = 70 and \\"itemloans_status\\" = 'Pendiente'","time":"0.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":602,"hash":"89bf3c496a8b0746ff5d1219b8dc29e3","hostname":"EderCortes"}	2024-11-04 07:38:20
23251	9d688e54-2efd-42fb-a4b4-6fac1ff44e90	9d688e54-3852-4c0a-8f85-38fbada62262	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 70 limit 1","time":"0.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":605,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 07:38:20
23252	9d688e54-302a-4601-8328-e0ffb2759978	9d688e54-3852-4c0a-8f85-38fbada62262	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (70, 4, 340000, 85000, 'Pendiente', 'Se realiza abono', '12-11-2024', 12, 0, 0, '2024-11-04 07:38:20', '2024-11-04 07:38:20')","time":"1.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":673,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 07:38:20
23253	9d688e54-305b-4201-b518-9e156a305c84	9d688e54-3852-4c0a-8f85-38fbada62262	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 07:38:20
23254	9d688e54-30e3-4696-bdb5-d9ff110d66d4	9d688e54-3852-4c0a-8f85-38fbada62262	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (70, 5, 340000, 85000, 'Pendiente', 'Se realiza abono', '20-11-2024', 12, 0, 0, '2024-11-04 07:38:20', '2024-11-04 07:38:20')","time":"0.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":673,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 07:38:20
23255	9d688e54-311a-4776-a414-a8462808bb9c	9d688e54-3852-4c0a-8f85-38fbada62262	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 07:38:20
23256	9d688e54-3681-42d0-bf6b-1d561bb8b283	9d688e54-3852-4c0a-8f85-38fbada62262	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 07:38:20
23257	9d688e54-36e7-4e9c-b7f6-510ae7ff5640	9d688e54-3852-4c0a-8f85-38fbada62262	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"51","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"600000","idLoans":70,"idCreador":12},"session":[],"response_status":200,"response":{"message":"El abono fue aplicado exitosamente","status":true},"duration":420,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:38:20
20392	9d66f1d5-d7ae-419b-93a4-44acf2064f70	9d66f1d6-2945-4078-a58d-6723cf04d128	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 12:24:55
20393	9d66f1d6-2756-4cd6-a5ef-0b3bc30531b2	9d66f1d6-2945-4078-a58d-6723cf04d128	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:24:55
20394	9d66f1d6-2811-434f-9267-a8730dde35a4	9d66f1d6-2945-4078-a58d-6723cf04d128	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":435,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:24:55
3669	9d51092f-eacb-48a2-92bf-167b8f81de99	9d51092f-efe9-41be-813f-9188d667f838	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":205}	2024-10-23 15:02:00
3517	9d5106e4-b32a-438d-96a2-f033a8ef0678	9d5106e4-b99f-4da5-b1b2-4b637cc36ba2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":197}	2024-10-23 14:55:35
20395	9d66f1d6-849b-443a-9457-620f18226737	9d66f1d6-a2e4-4487-9ab6-e2c83fe24fe4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:24:55
20396	9d66f1d6-9952-4da4-97ee-a3d644970082	9d66f1d6-a2e4-4487-9ab6-e2c83fe24fe4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"40.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:24:55
20397	9d66f1d6-9cd7-4054-b403-e7a3e65372c5	9d66f1d6-a2e4-4487-9ab6-e2c83fe24fe4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:24:55
20398	9d66f1d6-9d06-4c8c-b3d7-4e0111b93778	9d66f1d6-a2e4-4487-9ab6-e2c83fe24fe4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:24:55
20399	9d66f1d6-a19e-4fc1-9e6b-fc06bd259abe	9d66f1d6-a2e4-4487-9ab6-e2c83fe24fe4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:24:56
20400	9d66f1d6-a1ef-4ab6-a178-3dfeda8cc3e9	9d66f1d6-a2e4-4487-9ab6-e2c83fe24fe4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:24:56
41219	9d6ccbdc-fd97-4ab9-9dc3-26aa98b27f33	9d6ccbdd-200f-4396-ac4e-188d7c237dca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-06 10:13:42
41220	9d6ccbdd-1da6-40f7-8957-f3c9996eb18a	9d6ccbdd-200f-4396-ac4e-188d7c237dca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-06 10:13:42
41221	9d6ccbdd-1ebd-4628-a2d3-30bd21b7ddf4	9d6ccbdd-200f-4396-ac4e-188d7c237dca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:13:42
20401	9d66f1d8-3fda-4485-9f9c-59eef2cb63a5	9d66f1d8-6634-4734-86f2-f0442305096d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:24:57
20402	9d66f1d8-5e4f-43fe-b942-6df52fa88b96	9d66f1d8-6634-4734-86f2-f0442305096d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"51.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:24:57
20403	9d66f1d8-5ec3-4377-bdcb-ada0db4cb4d6	9d66f1d8-6634-4734-86f2-f0442305096d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:24:57
20404	9d66f1d8-648b-4e47-8e2a-af157e85209f	9d66f1d8-6634-4734-86f2-f0442305096d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:24:57
20405	9d66f1d8-64f2-4e08-87ee-1518979d6e9e	9d66f1d8-6634-4734-86f2-f0442305096d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":359,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:24:57
37	9d4cf46c-c959-429d-bedb-471f6aa2e8c7	9d4cf46c-cc59-4e1c-90f0-3ab382f9e26f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[23502]: Not null violation: 7 ERROR:  el valor nulo en la columna \\u00abuser_state\\u00bb de la relaci\\u00f3n \\u00abusers\\u00bb viola la restricci\\u00f3n de no nulo\\nDETAIL:  La fila que falla contiene (8, Eder Arley, edercortez10@gmail.com, null, 123456789, Cortes, Cabezas, CC, 1004608333, 2024-10-23T05:00:00.000Z, Cali, Las Orquideas, calle 107a, 3152596295, null, 29, 1, null, 0, null, 2024-10-21 14:20:38, 2024-10-21 14:20:38, null). (Connection: pgsql, SQL: insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"user_state\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"updated_at\\", \\"created_at\\") values (Eder Arley, edercortez10@gmail.com, Cortes, Cabezas, CC, 1004608333, 2024-10-23T05:00:00.000Z, Cali, Las Orquideas, calle 107a, 3152596295, ?, 1, 29, 123456789, 2024-10-21 14:20:38, 2024-10-21 14:20:38) returning \\"id\\")","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":401},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor.php","line":24},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3549},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":1982},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1334},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1299},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1138},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":35},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":8}	2024-10-21 14:20:38
47	9d4cf4b9-0df9-457c-9c88-e4ddfd4d370a	9d4cf4b9-1169-4265-903b-1b27b910ce8c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[23503]: Foreign key violation: 7 ERROR:  inserci\\u00f3n o actualizaci\\u00f3n en la tabla \\u00abusers\\u00bb viola la llave for\\u00e1nea \\u00abusers_profile_code_foreign\\u00bb\\nDETAIL:  La llave (profile_code)=(1) no est\\u00e1 presente en la tabla \\u00abprofile\\u00bb. (Connection: pgsql, SQL: insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"updated_at\\", \\"created_at\\") values (Eder Arley, edercortez10@gmail.com, Cortes, Cabezas, CC, 1004608333, 2024-10-23T05:00:00.000Z, Cali, Las Orquideas, calle 107a, 3152596295, 1, 29, 123456789, 2024-10-21 14:21:28, 2024-10-21 14:21:28) returning \\"id\\")","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":401},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor.php","line":24},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3549},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":1982},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1334},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1299},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1138},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":35},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":10}	2024-10-21 14:21:28
32	9d4cf419-fd60-419b-a856-2b01ec64c6a2	9d4cf41a-00fb-49ac-b8fc-9eff7381b62d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[23502]: Not null violation: 7 ERROR:  el valor nulo en la columna \\u00abuser_photo\\u00bb de la relaci\\u00f3n \\u00abusers\\u00bb viola la restricci\\u00f3n de no nulo\\nDETAIL:  La fila que falla contiene (7, Eder Arley, edercortez10@gmail.com, null, 123456789, Cortes, Cabezas, CC, 1004608333, 2024-10-23T05:00:00.000Z, Cali, Las Orquideas, calle 107a, 3152596295, null, null, 29, 1, null, 0, null, 2024-10-21 14:19:44, 2024-10-21 14:19:44, null). (Connection: pgsql, SQL: insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"user_state\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"updated_at\\", \\"created_at\\") values (Eder Arley, edercortez10@gmail.com, Cortes, Cabezas, CC, 1004608333, 2024-10-23T05:00:00.000Z, Cali, Las Orquideas, calle 107a, 3152596295, ?, 1, 29, 123456789, 2024-10-21 14:19:44, 2024-10-21 14:19:44) returning \\"id\\")","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":401},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor.php","line":24},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3549},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":1982},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1334},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1299},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1138},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":35},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":7}	2024-10-21 14:19:44
7	9d4cf148-936b-45c0-917c-cb2894e5da9c	9d4cf148-9716-41e2-9cef-8299123175d2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[23502]: Not null violation: 7 ERROR:  el valor nulo en la columna \\u00abuser_birth\\u00bb de la relaci\\u00f3n \\u00abusers\\u00bb viola la restricci\\u00f3n de no nulo\\nDETAIL:  La fila que falla contiene (2, 1994-12-30T05:00:00.000Z, edercortez10@gmail.com, null, 12345678, Cortes, Cabezas, CC, 1004608333, null, Cali, Las orquideas, Calle 107a No 28a- 66, 3152596295, null, null, 29, 1, null, 0, null, 2024-10-21 14:11:51, 2024-10-21 14:11:51, null). (Connection: pgsql, SQL: insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"user_photo\\", \\"user_state\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"updated_at\\", \\"created_at\\") values (1994-12-30T05:00:00.000Z, edercortez10@gmail.com, Cortes, Cabezas, CC, 1004608333, ?, Cali, Las orquideas, Calle 107a No 28a- 66, 3152596295, ?, ?, 1, 29, 12345678, 2024-10-21 14:11:51, 2024-10-21 14:11:51) returning \\"id\\")","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":401},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor.php","line":24},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3549},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":1982},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1334},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1299},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1138},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":35},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2}	2024-10-21 14:11:51
28686	9d690712-b8be-4837-8bd0-4194eb0a248c	9d690712-fad2-44b8-a595-60e40a98014e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 13:15:57
28687	9d690712-f6de-45b9-bdc3-c365143ddcc3	9d690712-fad2-44b8-a595-60e40a98014e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 13:15:58
28688	9d690712-f88f-47d3-9503-3c1862905d76	9d690712-fad2-44b8-a595-60e40a98014e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":671,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:15:58
30421	9d693de6-bd96-4d5d-b85b-152cf8590e55	9d693de6-c369-4a8e-9faa-fd852b4dc9e7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1449}	2024-11-04 15:49:16
28808	9d690834-f240-4d47-8f59-d12461c34d56	9d690834-f80a-464f-b040-34d236809274	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1343}	2024-11-04 13:19:08
28689	9d690713-bb5e-4371-b42e-4052d48bbf16	9d690713-f5d7-4de9-91ba-97599d1a19a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 13:15:58
28690	9d690713-e39b-4bdb-bcf7-295faa9c94ac	9d690713-f5d7-4de9-91ba-97599d1a19a6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"78.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 13:15:58
28691	9d690713-eb48-4719-b4b1-07ad28fc4f59	9d690713-f5d7-4de9-91ba-97599d1a19a6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"4.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:15:58
28692	9d690713-ebb7-41d5-80e9-022af3b851c4	9d690713-f5d7-4de9-91ba-97599d1a19a6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:15:58
17474	9d655b30-2f13-4400-860f-695edf873af2	9d655b30-594e-43be-8de3-0d4b046f0089	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 17:27:51
17475	9d655b30-5737-455f-b95d-926a308c2b48	9d655b30-594e-43be-8de3-0d4b046f0089	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:27:51
17476	9d655b30-580b-42c7-8c57-d70c546bd985	9d655b30-594e-43be-8de3-0d4b046f0089	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:27:51
28693	9d690713-f352-46f4-861e-74aeecf43998	9d690713-f5d7-4de9-91ba-97599d1a19a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 13:15:58
28694	9d690713-f3ec-4746-87e5-d318ad853c66	9d690713-f5d7-4de9-91ba-97599d1a19a6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":555,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:15:58
17477	9d655b30-f2e9-4ec4-9b65-b4085dd5630f	9d655b31-15fd-41b8-9e8b-adc8217fc4f7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:27:51
17478	9d655b31-0ff6-4b9b-8347-46f211f26c5e	9d655b31-15fd-41b8-9e8b-adc8217fc4f7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"55.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":46,"hash":"fb4ded687569d92428336ceae5c6ffcd","hostname":"EderCortes"}	2024-11-02 17:27:51
17479	9d655b31-149b-40c1-a0cb-f06c35ae9ec0	9d655b31-15fd-41b8-9e8b-adc8217fc4f7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:27:52
17480	9d655b31-1509-458c-a779-62f5912293af	9d655b31-15fd-41b8-9e8b-adc8217fc4f7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":440,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:27:52
28695	9d690714-ff64-4068-9f6d-d4ced55877eb	9d690715-7944-4424-85d6-89983289f1b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 13:15:59
28696	9d690715-6eb7-446c-8700-b6ae6cf59620	9d690715-7944-4424-85d6-89983289f1b2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"193.37","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:15:59
18864	9d669ddf-058f-4008-b7f6-b34449642e36	9d669ddf-5280-423c-bcc0-20c752b59a24	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:30:08
18865	9d669ddf-50ed-4294-9315-44cdf621166b	9d669ddf-5280-423c-bcc0-20c752b59a24	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 08:30:08
18866	9d669ddf-5180-4981-8ce1-47f42cb45e63	9d669ddf-5280-423c-bcc0-20c752b59a24	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":366,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:30:08
28697	9d690715-6f4c-423b-95d2-643818251893	9d690715-7944-4424-85d6-89983289f1b2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:15:59
28698	9d690715-7701-419c-987b-0d180ed6962a	9d690715-7944-4424-85d6-89983289f1b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 13:15:59
28699	9d690715-77a7-431c-8201-15a938f2529d	9d690715-7944-4424-85d6-89983289f1b2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":964,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:15:59
16616	9d64d41a-90d1-4832-bdf6-4930d75736cf	9d64d41a-afff-4bb7-977c-e71ddbae8457	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-02 11:10:08
16617	9d64d41a-ae54-4a8f-b50a-ed7f2ba8c60c	9d64d41a-afff-4bb7-977c-e71ddbae8457	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-02 11:10:08
16618	9d64d41a-af08-4183-b002-aa9c7c11534b	9d64d41a-afff-4bb7-977c-e71ddbae8457	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:10:08
28700	9d690716-696c-43c0-8f69-530ba54d321e	9d690716-ce54-4bbc-84c7-24356addc4a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 13:16:00
28701	9d690716-c58a-4923-8629-f16013124564	9d690716-ce54-4bbc-84c7-24356addc4a5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"191.29","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:16:00
28702	9d690716-c61b-4472-9ea1-e4da56a67ec2	9d690716-ce54-4bbc-84c7-24356addc4a5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:16:00
28703	9d690716-cc76-4716-a8dc-16d4e8496c0e	9d690716-ce54-4bbc-84c7-24356addc4a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 13:16:00
16619	9d64d41b-0390-444f-ae18-b5a8307d323c	9d64d41b-2429-4dd9-9f98-dbec7d65bf46	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-02 11:10:08
16620	9d64d41b-1aa6-4539-8f15-a42aff419689	9d64d41b-2429-4dd9-9f98-dbec7d65bf46	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"45.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 11:10:08
16621	9d64d41b-1ee6-4482-b929-df81b27e6cf8	9d64d41b-2429-4dd9-9f98-dbec7d65bf46	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 11:10:08
16622	9d64d41b-1f24-4cc3-8885-1133ad190e0c	9d64d41b-2429-4dd9-9f98-dbec7d65bf46	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 11:10:08
16623	9d64d41b-22f5-4fe0-b8ac-89e0b61cb4e0	9d64d41b-2429-4dd9-9f98-dbec7d65bf46	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-02 11:10:08
16624	9d64d41b-2348-4bd2-95c1-426d9c6951f7	9d64d41b-2429-4dd9-9f98-dbec7d65bf46	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":256,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:10:08
17481	9d655b33-1097-496a-a744-2f6ad4678669	9d655b33-2e4a-4038-8696-287c652836fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:27:53
17482	9d655b33-2862-43e5-934b-6a1fd3a403d4	9d655b33-2e4a-4038-8696-287c652836fc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 17:27:53
17483	9d655b33-28af-4722-9d7d-08fa6a3161e0	9d655b33-2e4a-4038-8696-287c652836fc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 17:27:53
17484	9d655b33-2cc4-47a8-8d7d-c3b90c7da787	9d655b33-2e4a-4038-8696-287c652836fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:27:53
17485	9d655b33-2d38-4dfd-b987-3f77f5cee22c	9d655b33-2e4a-4038-8696-287c652836fc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":277,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:27:53
18867	9d669ddf-9f4e-4d42-9324-6c1684d0adc0	9d669ddf-bbdd-4e65-9879-1827b1845a64	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 08:30:09
18868	9d669ddf-b797-4e86-9673-d10b2da63970	9d669ddf-bbdd-4e65-9879-1827b1845a64	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"45.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 08:30:09
16625	9d64d41c-c9bc-4f30-aea2-c642dd1a347e	9d64d41c-f591-42c0-be9c-3a93e711f4bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-02 11:10:09
16626	9d64d41c-ed52-4c37-b942-29e6d849c301	9d64d41c-f591-42c0-be9c-3a93e711f4bf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"58.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 11:10:09
16627	9d64d41c-ede2-42f7-91a9-f75c23d53d7d	9d64d41c-f591-42c0-be9c-3a93e711f4bf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 11:10:09
16628	9d64d41c-f329-4962-950a-44e34bcb67f2	9d64d41c-f591-42c0-be9c-3a93e711f4bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-02 11:10:09
16629	9d64d41c-f3aa-4f97-8ae2-f9f9a0f4b6b5	9d64d41c-f591-42c0-be9c-3a93e711f4bf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":390,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:10:09
18869	9d669ddf-baa2-4f9d-93bc-3c22be5baa35	9d669ddf-bbdd-4e65-9879-1827b1845a64	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 08:30:09
18870	9d669ddf-baf7-43b4-809c-965759152a5a	9d669ddf-bbdd-4e65-9879-1827b1845a64	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:30:09
18871	9d669de2-3e95-4a32-bf06-83543fbfe5b6	9d669de2-84cb-425f-b2fc-d9bd8e4266ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 08:30:10
18872	9d669de2-8025-4213-8b92-50234d83cb29	9d669de2-84cb-425f-b2fc-d9bd8e4266ac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"148.66","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 08:30:10
18873	9d669de2-806d-4a0a-8a1c-ee3b61697f24	9d669de2-84cb-425f-b2fc-d9bd8e4266ac	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 08:30:10
18874	9d669de2-83ac-4898-acc4-b85d014eadd0	9d669de2-84cb-425f-b2fc-d9bd8e4266ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 08:30:10
18875	9d669de2-83ef-409a-b6aa-47bbaf6ef275	9d669de2-84cb-425f-b2fc-d9bd8e4266ac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":401,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:30:10
28704	9d690716-cd01-4b10-b344-b1bcda7af70d	9d690716-ce54-4bbc-84c7-24356addc4a5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":848,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:16:00
15794	9d64afb6-079d-4d57-8d4d-b371ead47156	9d64afb6-2622-4319-821a-33d960ed072a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 09:28:22
15795	9d64afb6-24ab-48ec-8cf1-2f9b50061f34	9d64afb6-2622-4319-821a-33d960ed072a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 09:28:22
15796	9d64afb6-2541-4513-9fce-bc2fb13fe7ec	9d64afb6-2622-4319-821a-33d960ed072a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:28:22
15797	9d64afb6-6e06-48f1-8be8-e6ede65f1dd9	9d64afb6-bf5d-4495-b3ea-ecb0c5161615	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 09:28:22
15798	9d64afb6-b356-45ba-9b21-dda44ae65487	9d64afb6-bf5d-4495-b3ea-ecb0c5161615	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"164.48","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"088d1fdbe045a08c3b0073ef22c7da32","hostname":"EderCortes"}	2024-11-02 09:28:22
15799	9d64afb6-b949-47aa-aa65-73d1b1ba0bd4	9d64afb6-bf5d-4495-b3ea-ecb0c5161615	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:28:22
15800	9d64afb6-b98f-49a0-8216-f0b53ada6c1a	9d64afb6-bf5d-4495-b3ea-ecb0c5161615	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 09:28:22
15801	9d64afb6-be3b-4cfb-ac6b-304a5e2bf52e	9d64afb6-bf5d-4495-b3ea-ecb0c5161615	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 09:28:22
15802	9d64afb6-be92-4eed-90e1-02ad253aad80	9d64afb6-bf5d-4495-b3ea-ecb0c5161615	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":353,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:28:22
15803	9d64afb8-066f-43ef-9fd8-3010ab55736f	9d64afb8-5367-4013-bfec-46fad9988486	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 09:28:23
15804	9d64afb8-4ce0-4cbb-b47f-5e5c50c38660	9d64afb8-5367-4013-bfec-46fad9988486	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"159.04","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 09:28:23
15805	9d64afb8-4d55-4b43-b924-d1d64a1ed669	9d64afb8-5367-4013-bfec-46fad9988486	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 09:28:23
15806	9d64afb8-518a-4df8-9dee-d6fbc8bb187c	9d64afb8-5367-4013-bfec-46fad9988486	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 09:28:23
15807	9d64afb8-5206-4622-a167-b0ff84976208	9d64afb8-5367-4013-bfec-46fad9988486	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":515,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:28:23
41695	9d6ccece-fc40-4616-bf42-c3e924a7a37a	9d6ccece-ff8d-43f6-9549-e6305fc4fd89	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1918}	2024-11-06 10:21:57
28809	9d690834-9bfd-4231-b594-67293e04470a	9d690834-f80a-464f-b040-34d236809274	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 13:19:07
28810	9d690834-f501-4395-a567-50e32683afcf	9d690834-f80a-464f-b040-34d236809274	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 13:19:08
28811	9d690834-f651-419b-831a-a0e6561cf8db	9d690834-f80a-464f-b040-34d236809274	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":529,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:19:08
37115	9d6b453b-e6c5-4c08-b9bb-1ffacc198a65	9d6b453b-eb88-4b46-9402-69442afe6c60	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1677}	2024-11-05 16:01:26
1095	9d4f3ed5-f513-4398-b95a-4b6f7e62f05f	9d4f3ed5-f9a9-4ec1-91cb-ab20cd8e3aca	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":85}	2024-10-22 17:40:21
28812	9d690835-9531-4282-a8ef-b92bf918eaa1	9d690835-c7bc-42a6-b716-025a3a60692e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 13:19:08
28813	9d690835-b642-4949-bf9e-7f07cd629eb3	9d690835-c7bc-42a6-b716-025a3a60692e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"59.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 13:19:08
28814	9d690835-bc9d-400e-9a95-43ecf2e06d77	9d690835-c7bc-42a6-b716-025a3a60692e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"3.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:19:08
28815	9d690835-bced-4189-9fbf-999294efb52c	9d690835-c7bc-42a6-b716-025a3a60692e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:19:08
28816	9d690835-c59d-43fb-8564-31d0f99c0177	9d690835-c7bc-42a6-b716-025a3a60692e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 13:19:08
28817	9d690835-c627-4589-a56a-a68f510256f5	9d690835-c7bc-42a6-b716-025a3a60692e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":455,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:19:08
20497	9d66f453-eea4-4bd8-abd0-d9f1f7d8845f	9d66f454-3b5e-46d3-8eff-e1592f767f28	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 12:31:53
20498	9d66f454-396e-4cb7-8827-e216859d27f6	9d66f454-3b5e-46d3-8eff-e1592f767f28	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:31:53
20499	9d66f454-3a34-43b5-b5ff-0607051acc89	9d66f454-3b5e-46d3-8eff-e1592f767f28	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":355,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:31:53
28818	9d690836-76ad-489c-a6ed-e6cb646f0702	9d690836-edec-498b-8c92-29bf29dee1f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 13:19:09
20500	9d66f454-9544-4a9f-be78-a47bc346ac8e	9d66f454-b501-46c3-bf9d-e5185a8ece30	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:31:54
20501	9d66f454-aaf0-4ae8-ba3b-2fd066a05a1e	9d66f454-b501-46c3-bf9d-e5185a8ece30	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"42.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:31:54
20502	9d66f454-aedd-4299-8dbc-31d84b1f9693	9d66f454-b501-46c3-bf9d-e5185a8ece30	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:31:54
20503	9d66f454-af12-496f-baf6-a3de0ff29be0	9d66f454-b501-46c3-bf9d-e5185a8ece30	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:31:54
20504	9d66f454-b3a3-4c50-a4df-fe14bb0e6491	9d66f454-b501-46c3-bf9d-e5185a8ece30	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:31:54
20505	9d66f454-b3f2-4260-8455-b62d7266137b	9d66f454-b501-46c3-bf9d-e5185a8ece30	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":268,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:31:54
28819	9d690836-e363-4b06-8b8a-538f9e6da654	9d690836-edec-498b-8c92-29bf29dee1f4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"108.89","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:19:09
28820	9d690836-e3ff-41b9-a419-79b2a0ff2df1	9d690836-edec-498b-8c92-29bf29dee1f4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:19:09
28821	9d690836-eb9e-4863-9231-f403a958d5f6	9d690836-edec-498b-8c92-29bf29dee1f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 13:19:09
28822	9d690836-ec49-4cf5-a5f8-8f8209195c75	9d690836-edec-498b-8c92-29bf29dee1f4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":727,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:19:09
20506	9d66f456-2545-49a7-85f4-770502b860a8	9d66f456-86f4-4199-9735-04dbc4cc13c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:31:55
20507	9d66f456-8149-4dad-9529-612f31873826	9d66f456-86f4-4199-9735-04dbc4cc13c3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"168.83","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:31:55
20508	9d66f456-81a5-4c1b-b251-ce0c41e7c557	9d66f456-86f4-4199-9735-04dbc4cc13c3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:31:55
20509	9d66f456-8564-4c72-84f0-44583ac3c8ce	9d66f456-86f4-4199-9735-04dbc4cc13c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:31:55
20510	9d66f456-85bb-4bc5-8891-dc2d54d4c2b2	9d66f456-86f4-4199-9735-04dbc4cc13c3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":658,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:31:55
28823	9d690837-9cf2-48ef-99ff-969dbf640e7a	9d690837-d014-4dea-a7a7-ed6b4f2071bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 13:19:09
28824	9d690837-c3c9-4f24-9931-c0bc31c95d24	9d690837-d014-4dea-a7a7-ed6b4f2071bf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"65.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:19:09
28825	9d690837-c489-4032-be2a-965e950f7bbb	9d690837-d014-4dea-a7a7-ed6b4f2071bf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:19:09
28826	9d690837-cd98-4a47-b92c-8be39db75d07	9d690837-d014-4dea-a7a7-ed6b4f2071bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 13:19:10
28827	9d690837-ce48-42a3-b4e4-abeb3c7b8b9b	9d690837-d014-4dea-a7a7-ed6b4f2071bf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":551,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:19:10
28936	9d690dc0-a30b-43ae-b7ef-8e553f7e4455	9d690dc0-c60b-4db5-bae5-f34b457b7eab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 13:34:38
28937	9d690dc0-c450-4b2e-8f24-47f5692f4595	9d690dc0-c60b-4db5-bae5-f34b457b7eab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 13:34:38
28938	9d690dc0-c509-441c-a558-2990249de28d	9d690dc0-c60b-4db5-bae5-f34b457b7eab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":284,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:34:38
31314	9d694a26-cc80-429c-86e5-b00fd37d12ab	9d694a26-d036-477d-9d9e-3f1cd07e3285	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1491}	2024-11-04 16:23:31
8992	9d52f39c-a839-4ba2-8c15-79cfeed2e8a1	9d52f39c-abb2-49a1-af48-c14eb147b6e8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":432}	2024-10-24 13:53:20
28939	9d690dc1-1a00-472a-9791-8632fd73bdc3	9d690dc1-38d4-47c2-bfbe-9a9fb3f3d811	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 13:34:38
28940	9d690dc1-2ec3-4be3-8a53-43af75d1ee38	9d690dc1-38d4-47c2-bfbe-9a9fb3f3d811	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"41.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 13:34:38
28941	9d690dc1-32fd-4cc5-94cd-fc49625231a8	9d690dc1-38d4-47c2-bfbe-9a9fb3f3d811	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"1.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:34:38
28942	9d690dc1-333a-4fe1-8854-f82d51adb970	9d690dc1-38d4-47c2-bfbe-9a9fb3f3d811	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:34:38
28943	9d690dc1-3774-4cbd-94a7-446a05e4f7ff	9d690dc1-38d4-47c2-bfbe-9a9fb3f3d811	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 13:34:38
28944	9d690dc1-37e4-4bad-9d70-6b5d4146bff6	9d690dc1-38d4-47c2-bfbe-9a9fb3f3d811	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:34:38
23516	9d689784-9424-4cb8-9e61-a6976ca2e741	9d689784-e62d-4d2e-918b-51c651369333	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 08:04:02
23517	9d689784-e38b-4fc4-aa2a-b919071a4e6d	9d689784-e62d-4d2e-918b-51c651369333	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 08:04:02
23518	9d689784-e4ac-4103-8354-e6823cdcd443	9d689784-e62d-4d2e-918b-51c651369333	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":388,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:04:02
23519	9d689785-5f0f-4191-9e8a-e64a03ecfc4b	9d689785-a79e-472f-b370-ffac536cd551	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 08:04:02
23520	9d689785-9d68-4f93-9790-f4fd6cf1ccd8	9d689785-a79e-472f-b370-ffac536cd551	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 69\\n                        ","time":"146.91","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"28d3d4f6fe6eff992a986b780c628d2e","hostname":"EderCortes"}	2024-11-04 08:04:02
23521	9d689785-a123-47cf-9c2a-e9d2ed02ab38	9d689785-a79e-472f-b370-ffac536cd551	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '69' order by \\"item_loans\\".\\"id\\" asc","time":"2.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:04:02
17539	9d655caf-8250-4f8e-a8c3-a5cf60f25e7b	9d655caf-b1bb-45a5-a7f7-c5f821e6232c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 17:32:02
17540	9d655caf-aefe-4f05-9399-15b4e3504cbd	9d655caf-b1bb-45a5-a7f7-c5f821e6232c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:32:02
17541	9d655caf-b041-46b8-8f4c-2fd5b47ae25d	9d655caf-b1bb-45a5-a7f7-c5f821e6232c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":422,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:32:02
23522	9d689785-a159-44a9-901c-751819b58ca6	9d689785-a79e-472f-b370-ffac536cd551	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 08:04:02
23523	9d689785-a605-4af2-bbc7-66800555699c	9d689785-a79e-472f-b370-ffac536cd551	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 08:04:02
23524	9d689785-a67e-430b-af03-f86687a26d77	9d689785-a79e-472f-b370-ffac536cd551	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/69","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":69,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1150000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"920000","loans_pago_interes":"230000"},"items":[{"id":243,"loans_codigo":69,"itemloans_cuota":"1","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T13:01:48.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000"},{"id":244,"loans_codigo":69,"itemloans_cuota":"2","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T13:01:54.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000"},{"id":245,"loans_codigo":69,"itemloans_cuota":"3","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T13:02:55.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000"},{"id":246,"loans_codigo":69,"itemloans_cuota":"4","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T13:03:00.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000"},{"id":247,"loans_codigo":69,"itemloans_cuota":"5","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T05:49:09.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":392,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:04:02
40928	9d6cc8b6-00bd-4af4-a500-7cf272c7d44e	9d6cc8b6-0462-42f6-8b03-82f798691c23	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1870}	2024-11-06 10:04:53
17542	9d655cb0-519c-4016-8632-9f9249e52613	9d655cb0-7117-4ec0-82e7-8571ba590cdf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:32:03
17543	9d655cb0-6b5b-4049-854d-daaf755786ec	9d655cb0-7117-4ec0-82e7-8571ba590cdf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"46.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":57,"hash":"2cc591e3eaf2792109e07ba331bc077f","hostname":"EderCortes"}	2024-11-02 17:32:03
17544	9d655cb0-6fae-4931-82b5-493c1f2b2713	9d655cb0-7117-4ec0-82e7-8571ba590cdf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:32:03
17545	9d655cb0-700e-4775-9875-59c2f212f3c8	9d655cb0-7117-4ec0-82e7-8571ba590cdf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"}]},"duration":436,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:32:03
23525	9d689787-7513-4b4c-9dce-fcff942eb6d3	9d689787-9a7d-4c9b-a24e-38ea0848c7f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 08:04:03
23526	9d689787-93a0-450f-907b-c7c40d68de9d	9d689787-9a7d-4c9b-a24e-38ea0848c7f6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 08:04:04
23527	9d689787-941b-4d66-9fbf-dbcb46863dc0	9d689787-9a7d-4c9b-a24e-38ea0848c7f6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 08:04:04
23528	9d689787-9896-4a3a-af0c-c042971d549f	9d689787-9a7d-4c9b-a24e-38ea0848c7f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 08:04:04
23529	9d689787-9911-4a4f-89e1-653aba356ce1	9d689787-9a7d-4c9b-a24e-38ea0848c7f6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":466,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:04:04
29140	9d6912e2-551c-4983-b657-8229a6443364	9d6912e2-894a-499a-bd50-fd4cc96d7d2c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 13:48:59
17546	9d655cb2-7e8a-4821-9c38-e99de900ec07	9d655cb2-a265-45d1-a1b0-f0db6e0c72e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:32:04
17547	9d655cb2-9a9a-4551-99e2-417e58a5fb08	9d655cb2-a265-45d1-a1b0-f0db6e0c72e4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"49.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 17:32:04
17548	9d655cb2-9b0f-450b-93fd-ea10c5a6f8d5	9d655cb2-a265-45d1-a1b0-f0db6e0c72e4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 17:32:04
17549	9d655cb2-a0aa-4496-9d96-ecae62bb8b59	9d655cb2-a265-45d1-a1b0-f0db6e0c72e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:32:04
17550	9d655cb2-a121-4da7-9061-6756163345b4	9d655cb2-a265-45d1-a1b0-f0db6e0c72e4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":363,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:32:04
23530	9d68979b-8868-432c-9598-515deb28df36	9d68979b-8bb3-41a1-9f92-c32fe3517c08	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":150,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:04:17
29141	9d6912e2-8653-4e98-9f63-5bafb6683975	9d6912e2-894a-499a-bd50-fd4cc96d7d2c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 13:48:59
29142	9d6912e2-87a4-41c4-ad6a-f8842d5eccd8	9d6912e2-894a-499a-bd50-fd4cc96d7d2c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":439,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:48:59
17551	9d655cd8-df22-4a69-ad07-84104bcf9775	9d655cd9-0f96-4780-b30a-1c535e1c5523	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:32:29
17552	9d655cd8-fa62-4fad-bc91-61e1d80396a8	9d655cd9-0f96-4780-b30a-1c535e1c5523	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"52.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":292,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 17:32:29
17553	9d655cd9-0804-4eae-ab5e-cd656d29ed89	9d655cd9-0f96-4780-b30a-1c535e1c5523	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"3.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":321,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 17:32:29
17554	9d655cd9-083e-4fc6-a2b4-5aa741ad9e13	9d655cd9-0f96-4780-b30a-1c535e1c5523	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 17:32:29
17555	9d655cd9-0e18-4f6d-84a8-43c423aeaeed	9d655cd9-0f96-4780-b30a-1c535e1c5523	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 17:32:29
17556	9d655cd9-0e7d-4573-b001-c080d0c27535	9d655cd9-0f96-4780-b30a-1c535e1c5523	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:34:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"}]}},"duration":444,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:32:29
29143	9d6912e4-bc17-468a-9ed6-cddd3042446f	9d6912e4-f4d4-4adc-98c5-029d00bf6b6a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 13:49:01
29144	9d6912e4-ed2c-497d-b79a-0fbfa2c3f82e	9d6912e4-f4d4-4adc-98c5-029d00bf6b6a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"72.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:49:01
29145	9d6912e4-edae-41a9-ab71-84220fef39cf	9d6912e4-f4d4-4adc-98c5-029d00bf6b6a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:49:01
29146	9d6912e4-f334-47de-8e29-af56bc01c1d8	9d6912e4-f4d4-4adc-98c5-029d00bf6b6a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 13:49:01
29147	9d6912e4-f3a2-4ce0-aa6f-6a2c6a2a964f	9d6912e4-f4d4-4adc-98c5-029d00bf6b6a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":615,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:49:01
17557	9d655ce3-8f77-4cd9-927b-14b2becf8fd3	9d655ce3-afaf-4060-82eb-166c80ab4aac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 17:32:36
17558	9d655ce3-ab36-4c1c-b6b6-79a8bec0d242	9d655ce3-afaf-4060-82eb-166c80ab4aac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"50.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":57,"hash":"2cc591e3eaf2792109e07ba331bc077f","hostname":"EderCortes"}	2024-11-02 17:32:36
17559	9d655ce3-ae49-4193-b9a6-730aa059cd80	9d655ce3-afaf-4060-82eb-166c80ab4aac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 17:32:36
17560	9d655ce3-aea7-450d-9e9d-5bea7719e364	9d655ce3-afaf-4060-82eb-166c80ab4aac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"}]},"duration":262,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:32:36
20689	9d66fae0-5bbb-4563-af29-9714e0ca26f3	9d66fae0-b26f-43ad-bba7-50cd43dc25b9	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 12:50:12
20690	9d66fae0-afe6-4466-9e78-8550c03972bd	9d66fae0-b26f-43ad-bba7-50cd43dc25b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:50:12
20691	9d66fae0-b0f1-4ba6-aa70-d54a79db0482	9d66fae0-b26f-43ad-bba7-50cd43dc25b9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":497,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:50:12
29148	9d6912e5-6e59-4787-abef-676f4593a35b	9d6912e5-9e56-4415-a2e5-74e557d8f2aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 13:49:01
20692	9d66fae1-24bc-408e-9e54-87dd0830c9be	9d66fae1-483b-4a3f-b833-a0bd32a43954	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:50:12
20693	9d66fae1-3c7e-4e21-9e7f-296736208bd0	9d66fae1-483b-4a3f-b833-a0bd32a43954	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"48.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:50:12
20694	9d66fae1-40b3-42f4-ab78-7ba703705cbb	9d66fae1-483b-4a3f-b833-a0bd32a43954	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:50:12
20695	9d66fae1-40fd-4a22-b73b-67e4631a9ab2	9d66fae1-483b-4a3f-b833-a0bd32a43954	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:50:12
20696	9d66fae1-46af-4d06-9695-ebe4e1ba671d	9d66fae1-483b-4a3f-b833-a0bd32a43954	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:50:12
20697	9d66fae1-470f-4ebe-a1fb-0c55c667f42d	9d66fae1-483b-4a3f-b833-a0bd32a43954	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"400000","loans_pago_interes":"200000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:40:42.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":334,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:50:12
41853	9d6cd062-c204-4868-a7f2-d4d5220cc4ed	9d6cd062-e5ea-4406-bf5a-ad2c516db174	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:26:21
41854	9d6cd062-e3ed-472e-8389-ef1673c4e8b5	9d6cd062-e5ea-4406-bf5a-ad2c516db174	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:26:21
41855	9d6cd062-e4c1-4ffc-b06c-4a54d93a8890	9d6cd062-e5ea-4406-bf5a-ad2c516db174	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":259,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:26:21
20698	9d66fae3-9bd3-4bce-b235-babaad2f0108	9d66fae3-c4e1-410d-80d3-08e32c69db7d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:50:14
20699	9d66fae3-bd1d-4ce1-b611-e4b96eb5aed7	9d66fae3-c4e1-410d-80d3-08e32c69db7d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"54.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:50:14
20700	9d66fae3-bd97-49db-a794-bb4194f39e5a	9d66fae3-c4e1-410d-80d3-08e32c69db7d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:50:14
20701	9d66fae3-c2f9-4e6e-bb89-b0af24ab69f5	9d66fae3-c4e1-410d-80d3-08e32c69db7d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:50:14
17895	9d65b3a3-7f1b-435f-9202-52a45d16d79e	9d65b3a3-a6e4-4939-99d5-9ef4bcb64642	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 21:35:10
17896	9d65b3a3-a47a-412a-b406-8ed6e796220e	9d65b3a3-a6e4-4939-99d5-9ef4bcb64642	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:35:11
17897	9d65b3a3-a578-4b67-b867-9be5a563909e	9d65b3a3-a6e4-4939-99d5-9ef4bcb64642	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":331,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:35:11
20702	9d66fae3-c378-42ac-a586-8f1c9a99d835	9d66fae3-c4e1-410d-80d3-08e32c69db7d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":372,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:50:14
29149	9d6912e5-95b1-40b6-bba5-7adfb8329879	9d6912e5-9e56-4415-a2e5-74e557d8f2aa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"67.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:49:01
29150	9d6912e5-964d-43d3-adb6-7e867315b4b2	9d6912e5-9e56-4415-a2e5-74e557d8f2aa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:49:01
29151	9d6912e5-9c8e-489c-8477-3188457daa4e	9d6912e5-9e56-4415-a2e5-74e557d8f2aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 13:49:01
29152	9d6912e5-9d1b-4340-bd22-a6b2d48fc441	9d6912e5-9e56-4415-a2e5-74e557d8f2aa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":411,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:49:01
2345	9d50e72d-321f-4777-927e-8e36a2fbde6c	9d50e72d-35a2-4e01-8c6b-78f8b63c9e17	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":134}	2024-10-23 13:26:54
15187	9d5ecf42-f260-4513-8810-f0e36e5f2959	9d5ecf43-4957-4bda-bb1d-a45976014514	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 11:21:37
15188	9d5ecf43-46c2-4c48-818b-ed46482c7fc4	9d5ecf43-4957-4bda-bb1d-a45976014514	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 11:21:37
15189	9d5ecf43-4802-4c43-908d-b03146523b7a	9d5ecf43-4957-4bda-bb1d-a45976014514	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":689,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:21:37
18119	9d65b918-fd9e-499d-9e49-0e10a27ec461	9d65b919-022c-468a-8d89-573d59996ff9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":868}	2024-11-02 21:50:26
15190	9d5ecf43-bfc6-4a34-9043-86be86701cb6	9d5ecf43-de4c-4ec8-ad3e-8393c8d401c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 11:21:38
15191	9d5ecf43-d859-4d8b-ac43-281e2c984713	9d5ecf43-de4c-4ec8-ad3e-8393c8d401c3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 11:21:38
15192	9d5ecf43-d8a7-4e63-ab9b-16ffe529b7cd	9d5ecf43-de4c-4ec8-ad3e-8393c8d401c3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-30 11:21:38
15193	9d5ecf43-dce6-4bf3-8c7c-a0486dab3288	9d5ecf43-de4c-4ec8-ad3e-8393c8d401c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 11:21:38
15194	9d5ecf43-dd45-42d6-aec1-fceeede30a4a	9d5ecf43-de4c-4ec8-ad3e-8393c8d401c3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":327,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:21:38
17898	9d65b3a4-1596-47e9-ba32-ec41e6fd8b89	9d65b3a4-3b44-453c-9302-7dc422cb9b6a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:35:11
17899	9d65b3a4-2f81-4512-9ab5-84c84d017372	9d65b3a4-3b44-453c-9302-7dc422cb9b6a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"49.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"2b11ef88578e3c91c11800e110e490df","hostname":"EderCortes"}	2024-11-02 21:35:11
17900	9d65b3a4-3434-4933-9663-4f97f4743952	9d65b3a4-3b44-453c-9302-7dc422cb9b6a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"2.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:35:11
17901	9d65b3a4-346b-439c-bdd7-8ea50815b849	9d65b3a4-3b44-453c-9302-7dc422cb9b6a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:35:11
17902	9d65b3a4-39d2-4452-80f1-2c500cfdac3f	9d65b3a4-3b44-453c-9302-7dc422cb9b6a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:35:11
17903	9d65b3a4-3a34-4832-8a6b-212ca0b96bf3	9d65b3a4-3b44-453c-9302-7dc422cb9b6a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":320,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:35:11
15195	9d5ecf44-1f6a-4321-8480-8809d7a3a1df	9d5ecf44-3bcf-472e-b284-bbe2ed6851eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 11:21:38
15196	9d5ecf44-36fb-4b03-8262-58eb3303686e	9d5ecf44-3bcf-472e-b284-bbe2ed6851eb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 11:21:38
15197	9d5ecf44-374c-4ab5-bb71-8949594f5057	9d5ecf44-3bcf-472e-b284-bbe2ed6851eb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-30 11:21:38
15198	9d5ecf44-3ab7-48f9-b2dc-05f2eb83c51d	9d5ecf44-3bcf-472e-b284-bbe2ed6851eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-30 11:21:38
15199	9d5ecf44-3afd-4fb9-be9c-9b6929efee05	9d5ecf44-3bcf-472e-b284-bbe2ed6851eb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:21:38
17904	9d65b3a6-20cb-45e3-902a-8c8f3d4d084b	9d65b3a6-7326-4aec-a906-124bb9d186cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:35:12
17905	9d65b3a6-6ad7-4b25-926b-4fca9d6bcc84	9d65b3a6-7326-4aec-a906-124bb9d186cf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"160.80","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 21:35:12
17906	9d65b3a6-6b58-4878-88d8-f58a7bb88d1e	9d65b3a6-7326-4aec-a906-124bb9d186cf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 21:35:12
17907	9d65b3a6-713f-47ea-8427-3f5456f49fb6	9d65b3a6-7326-4aec-a906-124bb9d186cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 21:35:12
17908	9d65b3a6-71d6-4e5e-babc-87c5a94aed9c	9d65b3a6-7326-4aec-a906-124bb9d186cf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":470,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:35:12
42434	9d6cde3a-05e0-4435-88c3-7dfdfa636301	9d6cde3a-24a5-46eb-b37d-bd486c47319c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:05:03
41692	9d6ccece-52ed-4db8-908e-b22a16567bcd	9d6ccece-77a8-484f-b576-4ef97dc1caca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:21:56
41693	9d6ccece-75ea-414b-855f-ad31384112fc	9d6ccece-77a8-484f-b576-4ef97dc1caca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:21:56
41694	9d6ccece-76bb-48aa-88a9-755ddcdd6298	9d6ccece-77a8-484f-b576-4ef97dc1caca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":381,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:21:56
42435	9d6cde3a-22f0-4334-9733-64771760e663	9d6cde3a-24a5-46eb-b37d-bd486c47319c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:05:03
41965	9d6cd192-c22e-4622-a64d-4e4a588fbb19	9d6cd193-0d15-4f41-97c5-c9c171df6373	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:29:40
42436	9d6cde3a-23a0-4c6f-b9c1-2074e9d3ffd7	9d6cde3a-24a5-46eb-b37d-bd486c47319c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:05:03
41966	9d6cd193-0b74-4004-bd56-9ef833df66e7	9d6cd193-0d15-4f41-97c5-c9c171df6373	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:29:41
41967	9d6cd193-0c16-44a7-a283-c67acd986c68	9d6cd193-0d15-4f41-97c5-c9c171df6373	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":392,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:29:41
41473	9d6ccce4-163e-4a98-83b1-95faf4b4922b	9d6ccce4-42e2-4db6-a23f-e75f2bfc6ddf	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:16:35
41474	9d6ccce4-40c0-4ca4-bbe7-611bb5e4d372	9d6ccce4-42e2-4db6-a23f-e75f2bfc6ddf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:16:35
29212	9d6913df-1430-4eeb-934f-5e3cb9c85935	9d6913df-339a-41c2-a4d7-25e71ae83893	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 13:51:45
29213	9d6913df-3213-4f93-a1a6-c55e15cf3da7	9d6913df-339a-41c2-a4d7-25e71ae83893	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 13:51:45
29214	9d6913df-32a5-45b1-b842-1995bb4da161	9d6913df-339a-41c2-a4d7-25e71ae83893	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:51:45
41475	9d6ccce4-41ad-4edf-80f2-23233981997c	9d6ccce4-42e2-4db6-a23f-e75f2bfc6ddf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":305,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:16:35
41802	9d6ccfbb-cfc8-4cbb-9b74-9743cbec46e6	9d6ccfbb-fa66-4886-8525-bd016536cefe	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:24:32
41803	9d6ccfbb-f812-4242-9945-48c2e5b0d83e	9d6ccfbb-fa66-4886-8525-bd016536cefe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:24:32
41804	9d6ccfbb-f923-4313-a8a0-2ae3b2ac2793	9d6ccfbb-fa66-4886-8525-bd016536cefe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:24:32
42690	9d6cdff1-ab00-4527-8f1c-9648f42cc716	9d6cdff1-d5e9-4a69-ad67-d8df4c43a4de	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 11:09:51
42691	9d6cdff1-d32a-4c44-95db-7a742999af05	9d6cdff1-d5e9-4a69-ad67-d8df4c43a4de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:09:51
42692	9d6cdff1-d456-4510-9ff7-53dd849848d7	9d6cdff1-d5e9-4a69-ad67-d8df4c43a4de	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":310,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:09:51
43120	9d6ce503-e8ec-4311-bd40-3aa1ec26b733	9d6ce504-0e18-42cf-8d2a-63e7691a0bf9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 11:24:02
43014	9d6ce37e-c1a7-402d-ba9d-e80102ba7517	9d6ce37e-e896-4e73-bfb4-f06b2f74cd16	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 11:19:47
43015	9d6ce37e-e698-4aa5-be51-53dc903c9828	9d6ce37e-e896-4e73-bfb4-f06b2f74cd16	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:19:47
43016	9d6ce37e-e748-462c-9612-47531e57af17	9d6ce37e-e896-4e73-bfb4-f06b2f74cd16	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":256,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:19:47
43121	9d6ce504-0b59-4a06-8c93-bc1b7c28c223	9d6ce504-0e18-42cf-8d2a-63e7691a0bf9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 11:24:02
43122	9d6ce504-0ca1-4161-bcd4-591ea6590488	9d6ce504-0e18-42cf-8d2a-63e7691a0bf9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":301,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:24:02
29215	9d6913df-8568-4f2c-ae0d-92ac279067ac	9d6913df-a466-45f1-ae05-e4f74756ca32	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 13:51:45
29216	9d6913df-9b37-4355-b152-bc9dd2b55e4f	9d6913df-a466-45f1-ae05-e4f74756ca32	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"41.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 13:51:45
29217	9d6913df-9f36-459c-95c2-7d5308349214	9d6913df-a466-45f1-ae05-e4f74756ca32	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"1.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:51:45
29218	9d6913df-9f6a-4bec-9150-cbb7f74783c0	9d6913df-a466-45f1-ae05-e4f74756ca32	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:51:45
29219	9d6913df-a2d4-41fa-a58d-f28511bc4177	9d6913df-a466-45f1-ae05-e4f74756ca32	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 13:51:45
29220	9d6913df-a34c-4ed8-8dab-05bfca38b057	9d6913df-a466-45f1-ae05-e4f74756ca32	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":242,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:51:45
41751	9d6ccf23-829a-4a5d-a205-446d4d3705bb	9d6ccf23-cc92-48dd-b998-934528e0c6f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:22:52
41752	9d6ccf23-cac5-4163-81a0-facd1bfab25b	9d6ccf23-cc92-48dd-b998-934528e0c6f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:22:52
41753	9d6ccf23-cb8a-438c-8211-8ce274f251a7	9d6ccf23-cc92-48dd-b998-934528e0c6f0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:22:52
43074	9d6ce3fa-b9f9-410f-85ae-42c76c867d42	9d6ce3fb-0cab-49df-9134-505293eb5b69	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 11:21:08
43075	9d6ce3fb-09ee-4e31-9c2e-5f021e954eec	9d6ce3fb-0cab-49df-9134-505293eb5b69	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:21:09
43076	9d6ce3fb-0b5e-4fcc-bf07-e7c2f807ee65	9d6ce3fb-0cab-49df-9134-505293eb5b69	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":461,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:21:09
42954	9d6ce30b-0e3e-463f-b24f-c243dfaeedd8	9d6ce30b-3cf3-460f-8574-0bc754ee6a5b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 11:18:31
41624	9d6cce3d-1e5f-4b38-b9b8-91496e5260d4	9d6cce3d-4dcc-481c-a8ce-9631ef6d5559	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:20:21
41625	9d6cce3d-4bb6-48f1-b83c-44111aa1dda2	9d6cce3d-4dcc-481c-a8ce-9631ef6d5559	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:20:21
41626	9d6cce3d-4c89-4115-8496-72f4e4f3931e	9d6cce3d-4dcc-481c-a8ce-9631ef6d5559	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":390,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:20:21
42955	9d6ce30b-3aaa-4e7a-b9d9-42496cc97a5a	9d6ce30b-3cf3-460f-8574-0bc754ee6a5b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:18:31
42056	9d6cd403-24c5-4386-9d2f-be51bff045ae	9d6cd403-7066-499d-96f1-77de9b07cef1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:36:30
42956	9d6ce30b-3b85-4429-99a3-e52a779a4aa0	9d6ce30b-3cf3-460f-8574-0bc754ee6a5b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":430,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:18:31
42940	9d6ce181-cbff-4771-afb0-3471d897359b	9d6ce181-cec0-47da-8853-5bca32db82ff	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1970}	2024-11-06 11:14:14
42057	9d6cd403-6ea9-4b6c-b195-b999a6c3a2b0	9d6cd403-7066-499d-96f1-77de9b07cef1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:36:30
42058	9d6cd403-6f45-41ee-b977-e28a87f34a55	9d6cd403-7066-499d-96f1-77de9b07cef1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":370,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:36:30
40100	9d6cc105-9b53-452e-a8d5-7c98715e4a07	9d6cc105-9e73-4573-abc7-484a0bb08610	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1793}	2024-11-06 09:43:23
29331	9d69188f-1ee7-4b9d-897b-bfcb8fd27e9d	9d69188f-49d8-400d-bd99-e9aa00faa42d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 14:04:51
29332	9d69188f-4803-449a-92d9-fa37eccd7a28	9d69188f-49d8-400d-bd99-e9aa00faa42d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 14:04:51
29333	9d69188f-48cd-49af-b76c-1b7175252deb	9d69188f-49d8-400d-bd99-e9aa00faa42d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":310,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:04:51
41523	9d6ccd3a-9dda-4c6d-91da-1ba7cadb3bc5	9d6ccd3a-a1a8-4f86-b571-c3489d686b91	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1903}	2024-11-06 10:17:31
29334	9d69188f-b98b-48b1-ab3e-632f4ba0d12b	9d69188f-df41-4095-9e89-17d741167f71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 14:04:51
29335	9d69188f-cf47-486a-a7a3-7e33e24b4efd	9d69188f-df41-4095-9e89-17d741167f71	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"43.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 14:04:52
29336	9d69188f-d9fd-4da9-93f4-e4506c953840	9d69188f-df41-4095-9e89-17d741167f71	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 14:04:52
29337	9d69188f-da33-43df-b6a2-f0455d6fa9a4	9d69188f-df41-4095-9e89-17d741167f71	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 14:04:52
29338	9d69188f-de1a-43dc-8ee1-1869c82fe94a	9d69188f-df41-4095-9e89-17d741167f71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 14:04:52
29339	9d69188f-de70-4c99-a3df-b6009025a3af	9d69188f-df41-4095-9e89-17d741167f71	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:04:52
29635	9d6929f8-9a46-4dd3-8572-bb1e495222d5	9d6929f8-cd16-418a-8251-59c62ecd955e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 14:53:32
29636	9d6929f8-ca0c-412f-bdd2-b6cd8fff8bf7	9d6929f8-cd16-418a-8251-59c62ecd955e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 14:53:32
29637	9d6929f8-cb77-4dd7-842f-1f7f2ade6f9f	9d6929f8-cd16-418a-8251-59c62ecd955e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":456,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:53:32
991	9d4f3bde-9868-4205-9645-1b87c49ea2cc	9d4f3bde-9c95-4783-83d6-1e80ca5574d1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":79}	2024-10-22 17:32:04
6337	9d526487-d2c0-4c6a-8568-22e7e0357a84	9d526487-d645-47bd-9fe9-735016b31f6b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":331}	2024-10-24 07:13:15
29638	9d6929f9-693c-4587-8505-287356d62a9a	9d6929f9-a343-4e23-825c-86362aa3ca76	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 14:53:33
29639	9d6929f9-98b2-448c-9285-459e74efee79	9d6929f9-a343-4e23-825c-86362aa3ca76	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"79.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":56,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 14:53:33
29640	9d6929f9-9967-4ea6-9687-4375d6d92f8c	9d6929f9-a343-4e23-825c-86362aa3ca76	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 14:53:33
29641	9d6929f9-a163-4000-b24d-6b43dae305d0	9d6929f9-a343-4e23-825c-86362aa3ca76	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 14:53:33
19096	9d66cffd-c402-42fd-8c8d-051ec619d10f	9d66cffe-09c3-4716-89b5-822cbca79412	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 10:50:17
19097	9d66cffe-082a-4103-81b0-6507af06db1c	9d66cffe-09c3-4716-89b5-822cbca79412	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 10:50:17
19098	9d66cffe-08bd-4aca-8e9d-b537bc7be76f	9d66cffe-09c3-4716-89b5-822cbca79412	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:50:17
29642	9d6929f9-a1e3-4c3f-a284-85b895cb80c0	9d6929f9-a343-4e23-825c-86362aa3ca76	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":469,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:53:33
19099	9d66cffe-5129-42d4-8872-e53f93dddf24	9d66cffe-9aed-425a-9432-01d81ba6e9e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 10:50:17
19100	9d66cffe-92a5-4f9e-ba31-0fcf737f4de3	9d66cffe-9aed-425a-9432-01d81ba6e9e5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"155.09","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 10:50:17
19101	9d66cffe-95dd-48b6-948a-17a78e49ee1f	9d66cffe-9aed-425a-9432-01d81ba6e9e5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 10:50:17
19102	9d66cffe-960e-4240-a545-4d43d6edc19e	9d66cffe-9aed-425a-9432-01d81ba6e9e5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 10:50:17
19103	9d66cffe-99d7-449e-9ce6-6f31b76bd609	9d66cffe-9aed-425a-9432-01d81ba6e9e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 10:50:17
19104	9d66cffe-9a29-4d03-9969-1ad39a57ea16	9d66cffe-9aed-425a-9432-01d81ba6e9e5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T02:27:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"0"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:50:17
29643	9d6929fa-b00a-4f27-b7fd-a29e6f23b95f	9d6929fa-fd68-44b0-8593-e4ec09db9f78	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 14:53:34
29644	9d6929fa-f174-4c80-b902-6d2290d41d04	9d6929fa-fd68-44b0-8593-e4ec09db9f78	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"109.18","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:53:34
29645	9d6929fa-f204-455e-855f-b374d0ff770f	9d6929fa-fd68-44b0-8593-e4ec09db9f78	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:53:34
29646	9d6929fa-fb63-42d8-a993-66da4b3ddab8	9d6929fa-fd68-44b0-8593-e4ec09db9f78	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 14:53:34
29647	9d6929fa-fc04-40b5-bee8-0444506b21c7	9d6929fa-fd68-44b0-8593-e4ec09db9f78	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":854,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:53:34
19105	9d66cfff-b906-479f-83b4-b0a770cd7eed	9d66d000-084c-483d-8dc4-a3f99844c799	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 10:50:18
19106	9d66d000-006c-400b-9d3f-4e3593337ed1	9d66d000-084c-483d-8dc4-a3f99844c799	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"156.85","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 10:50:18
19107	9d66d000-00cb-4621-9698-bec47ede3010	9d66d000-084c-483d-8dc4-a3f99844c799	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 10:50:18
19108	9d66d000-0667-4676-8ccb-87db302656f5	9d66d000-084c-483d-8dc4-a3f99844c799	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 10:50:18
19109	9d66d000-06d7-403d-a99b-406f30230a5a	9d66d000-084c-483d-8dc4-a3f99844c799	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":477,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:50:18
29648	9d6929fb-d6f8-4e61-aebf-5642acd80ef7	9d6929fc-0403-48ba-a93b-5af4a7746ec6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 14:53:34
29649	9d6929fb-fbde-4fdf-bde5-784ad9316a5b	9d6929fc-0403-48ba-a93b-5af4a7746ec6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"57.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:53:35
29650	9d6929fb-fc6d-4535-bf77-b155dcd65f01	9d6929fc-0403-48ba-a93b-5af4a7746ec6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:53:35
29651	9d6929fc-0203-4b36-904c-2bfc718e5022	9d6929fc-0403-48ba-a93b-5af4a7746ec6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 14:53:35
29652	9d6929fc-0288-4b03-934b-08cbfb07f01f	9d6929fc-0403-48ba-a93b-5af4a7746ec6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":642,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:53:35
29548	9d6928ff-2e89-4818-a785-2c149cc01d14	9d6928ff-87ab-4744-82a4-bb1bfdfa66c6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 14:50:49
29549	9d6928ff-840a-4b5c-9d5e-8703382ff39d	9d6928ff-87ab-4744-82a4-bb1bfdfa66c6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 14:50:49
29550	9d6928ff-857c-40ad-9904-eaba215353b9	9d6928ff-87ab-4744-82a4-bb1bfdfa66c6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":563,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:50:49
16084	9d64b964-fb65-406e-852e-4112a0fc8d9c	9d64b965-190b-4c6c-b87d-557aaa975ffb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 09:55:26
16085	9d64b965-1743-4931-88a0-ff409f6d2381	9d64b965-190b-4c6c-b87d-557aaa975ffb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 09:55:27
16086	9d64b965-17e6-4507-b102-557457079e88	9d64b965-190b-4c6c-b87d-557aaa975ffb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:55:27
41200	9d6ccbda-eeb3-4de0-85a4-1f6f706a602e	9d6ccbda-f25b-4a1d-b4ef-9c75fa0e89a4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1886}	2024-11-06 10:13:41
39847	9d6cb7ed-cdfd-4a56-bbc8-01fadbe5371d	9d6cb7ed-d1d9-43ef-b58c-c634832b080f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1785}	2024-11-06 09:17:58
16087	9d64b965-6639-4571-819d-25abc0f79f32	9d64b965-8554-4477-ab4a-d7f086e01144	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 09:55:27
16088	9d64b965-7cae-470b-8031-018a407aa2a7	9d64b965-8554-4477-ab4a-d7f086e01144	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 22\\n                        ","time":"43.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"f9344e277d181987f84c6dcddcb4342d","hostname":"EderCortes"}	2024-11-02 09:55:27
16089	9d64b965-805c-433e-bef9-bae707167cd7	9d64b965-8554-4477-ab4a-d7f086e01144	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '22' order by \\"item_loans\\".\\"id\\" asc","time":"2.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:55:27
16090	9d64b965-8095-42bc-a15c-346e4f6133da	9d64b965-8554-4477-ab4a-d7f086e01144	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-02 09:55:27
16091	9d64b965-841e-4d9f-94af-fb52f144bd3a	9d64b965-8554-4477-ab4a-d7f086e01144	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 09:55:27
16092	9d64b965-846f-4e29-b985-9aa0411e8c67	9d64b965-8554-4477-ab4a-d7f086e01144	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/22","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":22,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":70,"loans_codigo":22,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":71,"loans_codigo":22,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":72,"loans_codigo":22,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":73,"loans_codigo":22,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":74,"loans_codigo":22,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":75,"loans_codigo":22,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-04-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:55:27
29551	9d692900-2e84-43ee-a037-3abb4486daac	9d692900-8626-4584-affb-d1bb10262406	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 14:50:50
29552	9d692900-7c91-48ce-b734-07070f5f789c	9d692900-8626-4584-affb-d1bb10262406	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"161.13","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":56,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 14:50:50
29553	9d692900-7d1d-4869-b60f-2c923f2be5ed	9d692900-8626-4584-affb-d1bb10262406	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 14:50:50
29554	9d692900-8466-48a9-b254-2bee8ffa81db	9d692900-8626-4584-affb-d1bb10262406	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 14:50:50
29555	9d692900-84ed-42ca-8143-c130b162d3f5	9d692900-8626-4584-affb-d1bb10262406	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":572,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:50:50
16093	9d64b966-bdf3-4747-bda5-92428b407136	9d64b966-e7ce-4068-9731-f6ab412df560	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 09:55:28
16094	9d64b966-e1de-49d0-8e3e-7dc9bb061478	9d64b966-e7ce-4068-9731-f6ab412df560	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"56.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 09:55:28
16095	9d64b966-e249-4767-8090-880f1ba9cbb0	9d64b966-e7ce-4068-9731-f6ab412df560	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 09:55:28
16096	9d64b966-e635-4eac-acf3-86882a576721	9d64b966-e7ce-4068-9731-f6ab412df560	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 09:55:28
16097	9d64b966-e6b2-44ee-8680-1b74c35f68ac	9d64b966-e7ce-4068-9731-f6ab412df560	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":426,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:55:28
29556	9d692901-2410-42fc-a422-83de10f7d1ad	9d692901-824b-49d3-9412-3933430beba3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 14:50:50
29557	9d692901-76ba-469d-8301-edf0cd2a5ee9	9d692901-824b-49d3-9412-3933430beba3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"88.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:50:50
29558	9d692901-775a-44c0-9b11-9399ed6f45b9	9d692901-824b-49d3-9412-3933430beba3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:50:50
29559	9d692901-7fdc-4584-b295-35fea031b9cf	9d692901-824b-49d3-9412-3933430beba3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 14:50:50
29560	9d692901-8096-44fa-be09-99c95ef8f683	9d692901-824b-49d3-9412-3933430beba3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":623,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:50:50
29561	9d692902-86d2-4e90-9d4b-22ff39420f3d	9d692902-b630-4c95-ac8e-ac3c56e4b967	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 14:50:51
29562	9d692902-adc8-441b-a30e-cdcea36af432	9d692902-b630-4c95-ac8e-ac3c56e4b967	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"62.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:50:51
29563	9d692902-ae2f-498a-9cd5-df943849cc3e	9d692902-b630-4c95-ac8e-ac3c56e4b967	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:50:51
29564	9d692902-b43b-47dd-ad6b-f037f7be61b0	9d692902-b630-4c95-ac8e-ac3c56e4b967	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 14:50:51
29565	9d692902-b4c6-49d3-845e-61098465420a	9d692902-b630-4c95-ac8e-ac3c56e4b967	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":663,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:50:51
29481	9d692810-a524-4e4a-b18b-915a4f93d05e	9d692810-ef7e-4016-8b93-c1eaf23ced3b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 14:48:13
29482	9d692810-eddc-467c-b887-15c229b3929f	9d692810-ef7e-4016-8b93-c1eaf23ced3b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 14:48:13
29483	9d692810-ee6a-41e8-9174-c1da865a3151	9d692810-ef7e-4016-8b93-c1eaf23ced3b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":369,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:48:13
29484	9d692811-4bc4-402e-961b-505b03da6e7c	9d692811-9a0a-4a16-9f1b-d184978c6773	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 14:48:13
29485	9d692811-8fc8-4928-8131-ca27007b2cb5	9d692811-9a0a-4a16-9f1b-d184978c6773	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"159.51","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 14:48:13
29486	9d692811-9435-4671-80a3-e22ebd3bd8a3	9d692811-9a0a-4a16-9f1b-d184978c6773	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"3.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 14:48:13
16991	9d6546d0-bd22-456c-868c-bcd7d7f71229	9d6546d0-de2c-4ac5-895e-5d4a8f5b35b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:30:53
16992	9d6546d0-dc10-46c3-abf8-75511ca2281a	9d6546d0-de2c-4ac5-895e-5d4a8f5b35b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 16:30:53
16993	9d6546d0-dce6-48de-ab32-61e7eef6b9a4	9d6546d0-de2c-4ac5-895e-5d4a8f5b35b1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42P01]: Undefined table: 7 ERROR:  falta una entrada para la tabla \\u00abl\\u00bb en la cl\\u00e1usula FROM\\nLINE 1: select \\"l\\".\\"id\\", \\"loans\\".\\"loans_documento\\", \\"loans\\".\\"loans_n...\\n               ^ (Connection: pgsql, SQL: select \\"l\\".\\"id\\", \\"loans\\".\\"loans_documento\\", \\"loans\\".\\"loans_nombre\\", \\"loans\\".\\"loans_apellido_uno\\", \\"loans\\".\\"loans_fecha\\", \\"loans\\".\\"loans_valor_prestado\\", \\"loans\\".\\"loans_cuotas\\", \\"loans\\".\\"loans_estado\\", \\"loans\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" inner join \\"users\\" as \\"ucl\\" on \\"loans\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"loans\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"loans\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"loans\\".\\"id \\" desc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":42,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":452,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:30:53
29487	9d692811-9484-4390-af69-d9d047f934c9	9d692811-9a0a-4a16-9f1b-d184978c6773	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 14:48:13
29488	9d692811-989c-4dca-b68a-dc729e84f27e	9d692811-9a0a-4a16-9f1b-d184978c6773	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 14:48:13
29489	9d692811-98e8-4c18-a8f4-0ef8def8b8ff	9d692811-9a0a-4a16-9f1b-d184978c6773	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":382,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:48:13
16994	9d6546d2-a9b6-4aa8-8639-a8760540d19a	9d6546d2-c6ba-4dd8-b4a0-e16528daf79d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 16:30:54
16995	9d6546d2-c0f5-4f2d-aa53-ae3c22eccca9	9d6546d2-c6ba-4dd8-b4a0-e16528daf79d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 16:30:54
16996	9d6546d2-c150-4815-8687-df725e97b1de	9d6546d2-c6ba-4dd8-b4a0-e16528daf79d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 16:30:54
16997	9d6546d2-c556-4de2-a5a1-9981cd5980b6	9d6546d2-c6ba-4dd8-b4a0-e16528daf79d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 16:30:54
16998	9d6546d2-c5a1-4151-ba6e-c2feb0df5424	9d6546d2-c6ba-4dd8-b4a0-e16528daf79d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:30:54
40911	9d6cc8a4-3b60-4667-aef6-9b25e82bd19f	9d6cc8a4-3ee2-423f-8635-a7b20a824642	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1868}	2024-11-06 10:04:42
19201	9d66d1b1-92aa-48d3-896e-bd7b698a8cd8	9d66d1b1-b61d-452c-bd2f-55d54a07aab3	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 10:55:03
19202	9d66d1b1-b408-4c39-993f-2772f0991ccf	9d66d1b1-b61d-452c-bd2f-55d54a07aab3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 10:55:03
19203	9d66d1b1-b4e9-4642-bb09-e19c8f9f10e0	9d66d1b1-b61d-452c-bd2f-55d54a07aab3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:55:03
19204	9d66d1b2-0dad-40bc-807a-a1c9d27d1028	9d66d1b2-2cb4-448f-ada6-d575b9aa7054	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 10:55:03
19205	9d66d1b2-2385-473c-9a90-a22c7d5606df	9d66d1b2-2cb4-448f-ada6-d575b9aa7054	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"43.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 10:55:03
19206	9d66d1b2-271f-4a55-bf3c-c72f9fac5769	9d66d1b2-2cb4-448f-ada6-d575b9aa7054	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 10:55:03
19207	9d66d1b2-274f-4c8b-bab7-e02249150596	9d66d1b2-2cb4-448f-ada6-d575b9aa7054	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 10:55:03
19208	9d66d1b2-2b8f-4e4a-a13e-1b2ba4cbc9b7	9d66d1b2-2cb4-448f-ada6-d575b9aa7054	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 10:55:03
19209	9d66d1b2-2bd3-45db-87aa-e8b13bffc7ff	9d66d1b2-2cb4-448f-ada6-d575b9aa7054	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T02:27:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"0"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":263,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:55:03
29751	9d692af4-eb61-4be8-a067-2070603eb372	9d692af5-58ea-45b5-a25f-4215cf04a726	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 14:56:18
19210	9d66d1b3-d47d-45d3-99b7-7757778a3c85	9d66d1b4-0134-4eee-8880-dba501be0955	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 10:55:04
19211	9d66d1b3-f99d-41cb-aff2-c68e362eef4a	9d66d1b4-0134-4eee-8880-dba501be0955	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"60.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 10:55:04
19212	9d66d1b3-f9ff-4c1a-9278-d7d12cffbbe7	9d66d1b4-0134-4eee-8880-dba501be0955	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 10:55:04
19213	9d66d1b3-ff59-43e8-a2c3-24091eb3e919	9d66d1b4-0134-4eee-8880-dba501be0955	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 10:55:04
19214	9d66d1b3-ffc8-47d5-92de-5603ae3ea110	9d66d1b4-0134-4eee-8880-dba501be0955	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":441,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:55:04
29752	9d692af5-5610-48b6-a9cb-d1467591204c	9d692af5-58ea-45b5-a25f-4215cf04a726	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 14:56:18
29753	9d692af5-5769-45eb-93bc-ecfd963aa051	9d692af5-58ea-45b5-a25f-4215cf04a726	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1033,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:56:18
29754	9d692af5-e7ce-461e-92fd-b0649c398c8c	9d692af6-174e-4446-8346-6d471007182f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 14:56:18
29755	9d692af6-0e59-4d05-8bc0-82a73f2ca9e7	9d692af6-174e-4446-8346-6d471007182f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"58.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":56,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 14:56:18
29756	9d692af6-0ee1-4405-beed-9f415c103137	9d692af6-174e-4446-8346-6d471007182f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 14:56:18
29757	9d692af6-1563-42cb-ad3e-2aa5b74ff459	9d692af6-174e-4446-8346-6d471007182f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 14:56:18
29758	9d692af6-15e4-48b8-9503-ece48a1df203	9d692af6-174e-4446-8346-6d471007182f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":407,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:56:18
43430	9d6ce9ff-0590-4883-bfc2-c0544f42aacc	9d6ce9ff-74aa-41e8-9cfc-8d79cc0d6f29	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 11:37:58
43431	9d6ce9ff-7168-4182-bfa7-1b39724989e7	9d6ce9ff-74aa-41e8-9cfc-8d79cc0d6f29	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:37:58
43432	9d6ce9ff-72d4-4610-a93b-7cd1f12c80ae	9d6ce9ff-74aa-41e8-9cfc-8d79cc0d6f29	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":766,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:37:58
29759	9d692af8-2409-45e0-9ca6-a54b3838ca78	9d692af8-94d2-4ea9-ba89-f5adf1803a1b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 14:56:20
29760	9d692af8-89cb-412d-90f7-fc9a83ff0c9f	9d692af8-94d2-4ea9-ba89-f5adf1803a1b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"171.63","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:56:20
29761	9d692af8-8a6b-4ccf-8a61-10105f10f638	9d692af8-94d2-4ea9-ba89-f5adf1803a1b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:56:20
29762	9d692af8-923c-42f9-87aa-e71d56bac25e	9d692af8-94d2-4ea9-ba89-f5adf1803a1b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 14:56:20
29763	9d692af8-92d3-4b08-9982-961ee3de9655	9d692af8-94d2-4ea9-ba89-f5adf1803a1b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1607,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:56:20
40877	9d6cc851-804d-473d-a40a-1349b8f64cf2	9d6cc851-83a6-428e-88be-aa114e9fa318	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1864}	2024-11-06 10:03:48
29764	9d692af9-67cc-44dd-8459-e103bf8e8d10	9d692af9-a4c6-46dc-a1fa-1e2f1b7f924d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 14:56:21
15358	9d5ed0d0-60a2-46de-8cb3-e0ed1116beb8	9d5ed0d0-8814-46f6-9fa7-d2f4339fb2fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-30 11:25:58
15359	9d5ed0d0-867f-4b1a-a0e2-cd5f4fa3b6db	9d5ed0d0-8814-46f6-9fa7-d2f4339fb2fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-30 11:25:58
15360	9d5ed0d0-8715-4c38-a4cb-7f2f4597e0bf	9d5ed0d0-8814-46f6-9fa7-d2f4339fb2fb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":361,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:25:58
29765	9d692af9-9bb1-4ff5-a501-e4080bd5d539	9d692af9-a4c6-46dc-a1fa-1e2f1b7f924d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"75.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:56:21
29766	9d692af9-9c56-4570-859b-bc2a59090c4e	9d692af9-a4c6-46dc-a1fa-1e2f1b7f924d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:56:21
29767	9d692af9-a293-46a1-9724-88bf203593c0	9d692af9-a4c6-46dc-a1fa-1e2f1b7f924d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 14:56:21
29768	9d692af9-a32c-42d3-b49c-27839974bd13	9d692af9-a4c6-46dc-a1fa-1e2f1b7f924d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":666,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:56:21
15361	9d5ed0d0-d6a8-416d-856e-98aa851a5dae	9d5ed0d0-f73e-4dfe-9b49-2a8da5af8bf9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-30 11:25:58
15362	9d5ed0d0-ed22-485f-bc90-7baa37a83e61	9d5ed0d0-f73e-4dfe-9b49-2a8da5af8bf9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"42.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"088d1fdbe045a08c3b0073ef22c7da32","hostname":"EderCortes"}	2024-10-30 11:25:58
15363	9d5ed0d0-f10f-4f5f-8346-baf11aa003c5	9d5ed0d0-f73e-4dfe-9b49-2a8da5af8bf9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-30 11:25:58
15364	9d5ed0d0-f13f-4507-94e0-122edd5cc668	9d5ed0d0-f73e-4dfe-9b49-2a8da5af8bf9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-10-30 11:25:58
15365	9d5ed0d0-f5ba-45b7-a3e4-18f69cc0a63f	9d5ed0d0-f73e-4dfe-9b49-2a8da5af8bf9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-30 11:25:58
15366	9d5ed0d0-f612-494a-accb-2e123591e67a	9d5ed0d0-f73e-4dfe-9b49-2a8da5af8bf9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:25:58
29828	9d692bde-3146-45c3-9064-46a4ce8b1ff5	9d692bde-943d-4171-9fca-3652c8592dc4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 14:58:51
29829	9d692bde-90e7-4fd9-8d67-9ecf3fb98136	9d692bde-943d-4171-9fca-3652c8592dc4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 14:58:51
29830	9d692bde-926f-4a24-8e72-371c20c2f5b6	9d692bde-943d-4171-9fca-3652c8592dc4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":570,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:58:51
15367	9d5ed0d1-91a7-4fbc-90e3-29eae50d4c26	9d5ed0d1-d07f-4fe5-87fb-3f0421cf8569	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-10-30 11:25:58
15368	9d5ed0d1-c62a-4143-ae8e-8fb3af8d2a94	9d5ed0d1-d07f-4fe5-87fb-3f0421cf8569	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"81.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 11:25:58
15369	9d5ed0d1-c6bb-49f9-b101-52af66a19f9c	9d5ed0d1-d07f-4fe5-87fb-3f0421cf8569	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 11:25:58
15370	9d5ed0d1-ce64-4bd6-bb64-ced4b98ba0cf	9d5ed0d1-d07f-4fe5-87fb-3f0421cf8569	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-30 11:25:58
15371	9d5ed0d1-ceee-4906-8b50-4490f70eaf14	9d5ed0d1-d07f-4fe5-87fb-3f0421cf8569	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":539,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:25:58
29831	9d692bdf-2246-4072-817b-3663d051d88f	9d692bdf-577f-46fd-ab89-2366823be77f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 14:58:51
29832	9d692bdf-4b26-4ab4-8ede-cf46b8db5805	9d692bdf-577f-46fd-ab89-2366823be77f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"63.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":56,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 14:58:51
29833	9d692bdf-4bc3-4e29-861e-2842bc259d20	9d692bdf-577f-46fd-ab89-2366823be77f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 14:58:51
29834	9d692bdf-54c3-4f0a-9726-ac1ea4a1dc6d	9d692bdf-577f-46fd-ab89-2366823be77f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 14:58:51
29835	9d692bdf-5565-43ca-ad51-7a1566e1cb7e	9d692bdf-577f-46fd-ab89-2366823be77f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":423,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:58:51
15372	9d5ed0d2-8c02-4dc4-988c-fd91d36d2e34	9d5ed0d2-d95a-46ef-b596-7d546c413c99	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-30 11:25:59
15373	9d5ed0d2-d234-4086-b9bc-0aa74c0e2cd0	9d5ed0d2-d95a-46ef-b596-7d546c413c99	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"160.54","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 11:25:59
15374	9d5ed0d2-d2bd-42ff-a591-b279c9bc70d5	9d5ed0d2-d95a-46ef-b596-7d546c413c99	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 11:25:59
15375	9d5ed0d2-d7ce-4c71-8398-bb3d3d44d098	9d5ed0d2-d95a-46ef-b596-7d546c413c99	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-30 11:25:59
15376	9d5ed0d2-d83c-462d-95c8-331a36d98dd7	9d5ed0d2-d95a-46ef-b596-7d546c413c99	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":352,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:25:59
29836	9d692be0-af75-47ea-b87f-0810fbfa98d3	9d692be1-1ae4-4524-b97c-b65670d44243	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 14:58:52
29837	9d692be1-0e98-4f51-aa9d-75012a9428ed	9d692be1-1ae4-4524-b97c-b65670d44243	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"153.57","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:58:52
29838	9d692be1-0f46-4789-9287-194237663ef7	9d692be1-1ae4-4524-b97c-b65670d44243	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:58:52
29839	9d692be1-18d1-4889-bec7-deb23f1834db	9d692be1-1ae4-4524-b97c-b65670d44243	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 14:58:52
29840	9d692be1-1967-458a-9ced-a69e0ca3c020	9d692be1-1ae4-4524-b97c-b65670d44243	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1124,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:58:52
15377	9d5ed0d3-93ef-4587-88b7-ce5c83fffb33	9d5ed0d3-afc8-4c05-a970-8ba43b736a96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-30 11:26:00
15378	9d5ed0d3-aad6-49f5-9e93-22e0844d8539	9d5ed0d3-afc8-4c05-a970-8ba43b736a96	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"39.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 11:26:00
15379	9d5ed0d3-ab1f-46f1-9a23-c4f552293a10	9d5ed0d3-afc8-4c05-a970-8ba43b736a96	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 11:26:00
15380	9d5ed0d3-ae91-4e80-a0c8-70939b2e1b3a	9d5ed0d3-afc8-4c05-a970-8ba43b736a96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-10-30 11:26:00
15381	9d5ed0d3-aedb-4cad-915a-ce56453e38b9	9d5ed0d3-afc8-4c05-a970-8ba43b736a96	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:26:00
29841	9d692be1-e36a-4b83-aa58-64bf7a1c3c00	9d692be2-1631-4858-bf3c-5bbd9d0a9670	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 14:58:53
29842	9d692be2-0cd7-4cd7-b969-bda3d5d82594	9d692be2-1631-4858-bf3c-5bbd9d0a9670	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"65.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:58:53
29843	9d692be2-0d72-4290-8a65-e8e490d3ec51	9d692be2-1631-4858-bf3c-5bbd9d0a9670	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:58:53
29844	9d692be2-13db-4790-ab93-23c027954d15	9d692be2-1631-4858-bf3c-5bbd9d0a9670	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 14:58:53
29845	9d692be2-1470-4290-801c-f0968d78cb06	9d692be2-1631-4858-bf3c-5bbd9d0a9670	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":536,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:58:53
43363	9d6ce601-0c17-43fd-bc0c-136d7bdfc82c	9d6ce601-2f69-4d82-8272-38c8842e3676	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 11:26:48
43364	9d6ce601-2d8e-49bb-b1ef-2d601f1d2700	9d6ce601-2f69-4d82-8272-38c8842e3676	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:26:48
43365	9d6ce601-2e48-4e9b-b939-16f0757e8d37	9d6ce601-2f69-4d82-8272-38c8842e3676	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:26:48
43362	9d6ce601-2c1b-4de2-9571-8e220f2b4bc5	9d6ce601-2f69-4d82-8272-38c8842e3676	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2017}	2024-11-06 11:26:48
20988	9d66ff4f-e962-4c6b-9b29-743caf625454	9d66ff50-152d-4dc4-8220-90227091ed26	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 13:02:36
20989	9d66ff50-1329-4a28-9915-fb090688c584	9d66ff50-152d-4dc4-8220-90227091ed26	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 13:02:36
20990	9d66ff50-13ef-4aac-819c-f2fefd0ba8d0	9d66ff50-152d-4dc4-8220-90227091ed26	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":360,"memory":22,"hostname":"EderCortes"}	2024-11-03 13:02:36
266	9d4f1764-fedb-4cbb-b950-009678ad4520	9d4f1765-739c-4d0a-bef8-d365054768f6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42P01]: Undefined table: 7 ERROR:  falta una entrada para la tabla \\u00abmenu_name, menu\\u00bb en la cl\\u00e1usula FROM\\nLINE 1: select \\"menu\\".\\"menu_name, menu\\".\\"menu_url\\" from \\"menu\\" inner...\\n               ^ (Connection: pgsql, SQL: select \\"menu\\".\\"menu_name, menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = 1 and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":16}	2024-10-22 15:50:04
25510	9d68c688-0a73-4ea6-8267-614a0eb68c5d	9d68c688-0fc6-403b-a830-d97cd91c192f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1167}	2024-11-04 10:15:29
20991	9d66ff50-9608-45bf-8c4b-316192911784	9d66ff50-b57e-4173-914f-d64c03413204	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 13:02:36
17054	9d6548b0-5e56-4bd8-addb-f5ba463c80a5	9d6548b0-6257-426f-aad2-2ccfc3ff14c3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42883]: Undefined function: 7 ERROR:  no existe la funci\\u00f3n datediff(character varying, integer)\\nLINE 1: select DATEDIFF(l.loans_fecha_ultimo_pago, 02-11-2024) as di...\\n               ^\\nHINT:  Ninguna funci\\u00f3n coincide en el nombre y tipos de argumentos. Puede ser necesario agregar conversi\\u00f3n expl\\u00edcita de tipos. (Connection: pgsql, SQL: select DATEDIFF(l.loans_fecha_ultimo_pago, 02-11-2024) as dis_restantes, \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":45},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":804}	2024-11-02 16:36:07
20992	9d66ff50-af87-4fd0-a31d-6d6d08daf543	9d66ff50-b57e-4173-914f-d64c03413204	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"45.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 13:02:37
20993	9d66ff50-b3c1-47f1-a99e-d2e4be69a62f	9d66ff50-b57e-4173-914f-d64c03413204	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 13:02:37
20994	9d66ff50-b43d-4852-afde-d7cc56f4e866	9d66ff50-b57e-4173-914f-d64c03413204	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"28","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"17-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":null,"loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-11-03 13:02:37
20995	9d66ff52-f705-4932-83c0-b233b4f61fff	9d66ff53-1d3e-4978-acd1-75b7d61e46ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 13:02:38
20996	9d66ff53-1718-4d5e-858b-ab3ea10da577	9d66ff53-1d3e-4978-acd1-75b7d61e46ba	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"52.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 13:02:38
20997	9d66ff53-1774-4d36-bda7-c568124ea2c6	9d66ff53-1d3e-4978-acd1-75b7d61e46ba	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 13:02:38
20998	9d66ff53-1bca-4c24-8f83-114cc711c3bb	9d66ff53-1d3e-4978-acd1-75b7d61e46ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 13:02:38
20999	9d66ff53-1c1f-43b2-b9c7-68d36420b24e	9d66ff53-1d3e-4978-acd1-75b7d61e46ba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":367,"memory":22,"hostname":"EderCortes"}	2024-11-03 13:02:38
29973	9d692d73-4cad-42ee-8d89-7ceca58f958e	9d692d73-8529-421a-b241-a7bf776294dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 15:03:16
17064	9d6548b3-11dc-4652-a176-1682da8ca138	9d6548b3-2d74-4ebc-a21e-a4b27dd64c27	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 16:36:09
17065	9d6548b3-2bd1-48e5-90d1-59ebb9c9cce1	9d6548b3-2d74-4ebc-a21e-a4b27dd64c27	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 16:36:09
17066	9d6548b3-2c75-470e-8312-1abe5f436a60	9d6548b3-2d74-4ebc-a21e-a4b27dd64c27	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42883]: Undefined function: 7 ERROR:  no existe la funci\\u00f3n datediff(character varying, integer)\\nLINE 1: select DATEDIFF(l.loans_fecha_ultimo_pago, 02-11-2024) as di...\\n               ^\\nHINT:  Ninguna funci\\u00f3n coincide en el nombre y tipos de argumentos. Puede ser necesario agregar conversi\\u00f3n expl\\u00edcita de tipos. (Connection: pgsql, SQL: select DATEDIFF(l.loans_fecha_ultimo_pago, 02-11-2024) as dis_restantes, \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":45,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":262,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:36:09
29974	9d692d73-8165-4e29-b123-df7bdb8c9618	9d692d73-8529-421a-b241-a7bf776294dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 15:03:16
29975	9d692d73-8303-44f6-88e8-58dd7bbe57f2	9d692d73-8529-421a-b241-a7bf776294dd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":471,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:03:16
43173	9d6ce530-14b9-4c72-8164-a33f04dd407e	9d6ce530-1731-4db8-9a5e-271c97c69922	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1998}	2024-11-06 11:24:31
21000	9d66ff58-7508-449e-b970-d77b4dc39299	9d66ff58-be10-493f-9d4d-9b001ae12429	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 13:02:42
21001	9d66ff58-b567-44ca-84f8-fbb3919632c0	9d66ff58-be10-493f-9d4d-9b001ae12429	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 64\\n                        ","time":"152.89","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"45dfab6b4f68d5c2aab17cd8432b9cbd","hostname":"EderCortes"}	2024-11-03 13:02:42
21002	9d66ff58-b902-4db1-b18f-739282c6c17b	9d66ff58-be10-493f-9d4d-9b001ae12429	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '64' order by \\"item_loans\\".\\"id\\" asc","time":"2.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 13:02:42
21003	9d66ff58-b93b-41db-859d-3276c8159158	9d66ff58-be10-493f-9d4d-9b001ae12429	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 13:02:42
21004	9d66ff58-bcde-4510-b6b2-2533b599ce8f	9d66ff58-be10-493f-9d4d-9b001ae12429	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 13:02:42
21005	9d66ff58-bd2e-45b2-9246-ad14ba8a55fd	9d66ff58-be10-493f-9d4d-9b001ae12429	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/64","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":64,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":2000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"17-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-17 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":197,"loans_codigo":64,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:00:24.000000Z","updated_at":"2024-11-03T18:00:24.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":198,"loans_codigo":64,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:00:24.000000Z","updated_at":"2024-11-03T18:00:24.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":199,"loans_codigo":64,"itemloans_cuota":"3","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:00:24.000000Z","updated_at":"2024-11-03T18:00:24.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":200,"loans_codigo":64,"itemloans_cuota":"4","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:00:24.000000Z","updated_at":"2024-11-03T18:00:24.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":201,"loans_codigo":64,"itemloans_cuota":"5","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:00:24.000000Z","updated_at":"2024-11-03T18:00:24.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":202,"loans_codigo":64,"itemloans_cuota":"6","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:00:24.000000Z","updated_at":"2024-11-03T18:00:24.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":203,"loans_codigo":64,"itemloans_cuota":"7","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:00:24.000000Z","updated_at":"2024-11-03T18:00:24.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":204,"loans_codigo":64,"itemloans_cuota":"8","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-25 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:00:24.000000Z","updated_at":"2024-11-03T18:00:24.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":205,"loans_codigo":64,"itemloans_cuota":"9","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:00:24.000000Z","updated_at":"2024-11-03T18:00:24.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":206,"loans_codigo":64,"itemloans_cuota":"10","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:00:24.000000Z","updated_at":"2024-11-03T18:00:24.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":366,"memory":22,"hostname":"EderCortes"}	2024-11-03 13:02:42
29976	9d692d74-167e-49c6-a272-da67b4eb0091	9d692d74-4963-481b-90ce-e864ee1a43b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 15:03:17
29977	9d692d74-3fe8-4cd0-bc0a-4cc6877739e2	9d692d74-4963-481b-90ce-e864ee1a43b3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"62.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":56,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 15:03:17
29978	9d692d74-4070-4112-91b0-a8f9ba6457e1	9d692d74-4963-481b-90ce-e864ee1a43b3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 15:03:17
29979	9d692d74-4751-4b6a-b523-7cdbb1cc9b93	9d692d74-4963-481b-90ce-e864ee1a43b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 15:03:17
29980	9d692d74-4804-4539-b600-90d3cc072e04	9d692d74-4963-481b-90ce-e864ee1a43b3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":419,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:03:17
21006	9d67006e-3d55-4977-986d-7dae501de84b	9d67006e-8ce1-4150-8a9c-39cb9356b8e4	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 13:05:44
21007	9d67006e-86b4-4987-8fea-c278cd1db432	9d67006e-8ce1-4150-8a9c-39cb9356b8e4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"160.24","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-03 13:05:44
21008	9d67006e-8afe-4131-bb07-89b198f41288	9d67006e-8ce1-4150-8a9c-39cb9356b8e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 13:05:44
21009	9d67006e-8b88-42e1-893e-537bf23f1131	9d67006e-8ce1-4150-8a9c-39cb9356b8e4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":456,"memory":22,"hostname":"EderCortes"}	2024-11-03 13:05:44
29981	9d692d75-4c8f-44f2-8c00-3beff714e396	9d692d76-0d7a-48cf-83d9-5bde7fec242e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 15:03:17
29982	9d692d76-05e1-45fa-822d-58840d151e29	9d692d76-0d7a-48cf-83d9-5bde7fec242e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"245.30","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:03:18
29983	9d692d76-0662-412b-9bd1-c492a5a334cf	9d692d76-0d7a-48cf-83d9-5bde7fec242e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:03:18
29984	9d692d76-0b7f-4da7-aeba-96d2b2507667	9d692d76-0d7a-48cf-83d9-5bde7fec242e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 15:03:18
29985	9d692d76-0c03-462a-9495-df7575525877	9d692d76-0d7a-48cf-83d9-5bde7fec242e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1133,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:03:18
21010	9d670070-355d-4115-ae89-7b62e2b63481	9d670070-550c-417b-873a-ab8b82dfab69	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 13:05:45
21011	9d670070-4fa7-4481-8cb6-ecfc5787c8b8	9d670070-550c-417b-873a-ab8b82dfab69	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 13:05:45
21012	9d670070-4ff1-4d35-a521-54cee27e3db4	9d670070-550c-417b-873a-ab8b82dfab69	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 13:05:45
21013	9d670070-53aa-4eab-a243-cb22dd66b39e	9d670070-550c-417b-873a-ab8b82dfab69	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 13:05:45
21014	9d670070-53fd-4062-8cf5-de004a679658	9d670070-550c-417b-873a-ab8b82dfab69	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":359,"memory":22,"hostname":"EderCortes"}	2024-11-03 13:05:45
29986	9d692d76-8a91-4511-bd5d-8c4897bab175	9d692d76-e551-45de-9733-396a6fa1c9ab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 15:03:18
29987	9d692d76-dc03-45ed-b44c-d68fef75d044	9d692d76-e551-45de-9733-396a6fa1c9ab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"179.48","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:03:18
29988	9d692d76-dc90-4799-ad0a-76fd3d7b508b	9d692d76-e551-45de-9733-396a6fa1c9ab	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:03:18
29989	9d692d76-e35d-484a-8610-4d93e19478dc	9d692d76-e551-45de-9733-396a6fa1c9ab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 15:03:18
29990	9d692d76-e3e7-4edc-bcd0-764f5dc8d66b	9d692d76-e551-45de-9733-396a6fa1c9ab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":534,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:03:18
21015	9d670070-a5e2-46b4-9f6e-b013e840ba50	9d670070-cc41-435f-83a8-a7cb9bf93df0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 13:05:45
21016	9d670070-c1bd-4069-aea6-161f2a1cdf07	9d670070-cc41-435f-83a8-a7cb9bf93df0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 13:05:45
21017	9d670070-c245-4e53-9ded-548195969e53	9d670070-cc41-435f-83a8-a7cb9bf93df0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-03 13:05:45
21018	9d670070-ca27-48eb-8e89-68d0c44eb609	9d670070-cc41-435f-83a8-a7cb9bf93df0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 13:05:45
21019	9d670070-cab3-443e-9590-59b122346512	9d670070-cc41-435f-83a8-a7cb9bf93df0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":283,"memory":22,"hostname":"EderCortes"}	2024-11-03 13:05:45
24097	9d68a558-95ee-479f-80cc-6579f1902551	9d68a558-ba95-42ef-8186-88aca5077c74	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 08:42:42
24098	9d68a558-b89b-4bc9-9141-9771adf43682	9d68a558-ba95-42ef-8186-88aca5077c74	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 08:42:42
24099	9d68a558-b961-449d-825f-d41131d7fbd7	9d68a558-ba95-42ef-8186-88aca5077c74	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":332,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:42:42
43345	9d6ce5ec-c2e4-4c53-a67d-594a337f2342	9d6ce5ec-c584-421e-b52f-a7804a2bd620	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2016}	2024-11-06 11:26:35
21020	9d670074-9fc7-4a8f-be1d-256647ad52c5	9d670074-a2c0-499c-95df-3c83f38fc45f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":142,"memory":22,"hostname":"EderCortes"}	2024-11-03 13:05:48
24100	9d68a559-28d4-46f5-abb0-c9552ef1c2e3	9d68a559-46a6-4201-b168-3c885112660b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 08:42:42
24101	9d68a559-4161-4724-9933-8b4afe03524d	9d68a559-46a6-4201-b168-3c885112660b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"45.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 08:42:42
24102	9d68a559-452e-47ec-8e56-889db6ab5ae5	9d68a559-46a6-4201-b168-3c885112660b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 08:42:42
24103	9d68a559-45aa-4994-be9a-ce27c5c68070	9d68a559-46a6-4201-b168-3c885112660b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":278,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:42:42
30060	9d69336f-b509-4b1d-89cc-f4d74c178f6b	9d69336f-f344-416b-8cbd-3eb7caf96364	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 15:20:00
30061	9d69336f-f02d-48c9-9536-ac7cea0fb3f2	9d69336f-f344-416b-8cbd-3eb7caf96364	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 15:20:01
30062	9d69336f-f170-48d9-af4d-8ec602b7b2c6	9d69336f-f344-416b-8cbd-3eb7caf96364	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":471,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:20:01
43199	9d6ce544-5d1d-42af-8ab2-02301ebc8a7d	9d6ce544-7783-49a0-849a-87d6ea140b9a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 11:24:44
30063	9d693370-9205-4b77-b99a-ccc96aea8a18	9d693370-f0a2-4683-868e-fc331a71b570	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 15:20:01
14448	9d5d1e2e-589a-4cff-add6-24fc6702346a	9d5d1e2e-9197-40e9-9521-0032072a5b36	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":29,"hostname":"EderCortes"}	2024-10-29 15:10:38
14449	9d5d1e2e-8e01-49f8-bfa2-42008b98c758	9d5d1e2e-9197-40e9-9521-0032072a5b36	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":30,"hostname":"EderCortes"}	2024-10-29 15:10:38
14450	9d5d1e2e-8f99-49bb-b020-0360e934fa8e	9d5d1e2e-9197-40e9-9521-0032072a5b36	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":495,"memory":22,"hostname":"EderCortes"}	2024-10-29 15:10:38
30064	9d693370-e5bc-4fae-b651-8a45769fca65	9d693370-f0a2-4683-868e-fc331a71b570	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"171.14","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":56,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 15:20:01
30065	9d693370-e65e-4d05-98ec-2bb1e5761ac0	9d693370-f0a2-4683-868e-fc331a71b570	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 15:20:01
30066	9d693370-ede5-4796-9e0f-208a0f1e61d8	9d693370-f0a2-4683-868e-fc331a71b570	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 15:20:01
30067	9d693370-ee83-498e-9986-27322c9060cc	9d693370-f0a2-4683-868e-fc331a71b570	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":565,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:20:01
43200	9d6ce544-75e4-4639-9277-d3910f6b45ba	9d6ce544-7783-49a0-849a-87d6ea140b9a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 11:24:44
43201	9d6ce544-7673-4e02-b941-d3ea7c2231f0	9d6ce544-7783-49a0-849a-87d6ea140b9a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":222,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:24:44
21021	9d670075-1454-4c5a-8c58-0d0ccf90de47	9d670075-1768-407c-b240-8403c7de3446	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":133,"memory":20,"hostname":"EderCortes"}	2024-11-03 13:05:48
24104	9d68a55b-52bd-4f83-a1cc-f68b7b4ccedb	9d68a55b-7106-4aab-9a4a-98a626065960	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 08:42:43
24105	9d68a55b-6c00-4c33-a623-0368d9b64f9d	9d68a55b-7106-4aab-9a4a-98a626065960	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"46.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 08:42:43
24106	9d68a55b-6c51-495d-b31d-88bc061c5f9c	9d68a55b-7106-4aab-9a4a-98a626065960	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 08:42:43
24107	9d68a55b-6fad-4fa6-b206-af4d192729e4	9d68a55b-7106-4aab-9a4a-98a626065960	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 08:42:43
24108	9d68a55b-6ff4-4539-8b94-5ac848db3b4e	9d68a55b-7106-4aab-9a4a-98a626065960	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:42:43
30068	9d693371-b85c-4afe-8732-7fd0dddf64f5	9d693371-f585-4e62-baab-400346b79116	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 15:20:02
30069	9d693371-e935-4258-9fe9-9e90c5acc12d	9d693371-f585-4e62-baab-400346b79116	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"79.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:20:02
30070	9d693371-e9d7-4fd4-97d0-84b191592dfd	9d693371-f585-4e62-baab-400346b79116	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:20:02
30071	9d693371-f2fb-472a-8198-42b39a46e4ff	9d693371-f585-4e62-baab-400346b79116	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 15:20:02
30072	9d693371-f3b1-48fc-b25e-d267f3537b04	9d693371-f585-4e62-baab-400346b79116	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":633,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:20:02
43202	9d6ce544-cc44-4bbe-832b-6b14ae03ff57	9d6ce544-e573-4c20-ab2c-584eff1a423d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 11:24:45
43203	9d6ce544-e14a-4368-b5ea-40aaa1843c6e	9d6ce544-e573-4c20-ab2c-584eff1a423d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT id,\\n                            name,\\n                            profile_code,\\n                            remember_token,\\n                            user_address,\\n                            user_age,\\n                            user_alias,\\n                            user_birth,\\n                            user_cellphone,\\n                            user_city,\\n                            user_document,\\n                            user_document_type,\\n                            user_last_name_one,\\n                            user_last_name_two,\\n                            user_neighborhood\\n                        FROM users\\n                        WHERE profile_code = 4;\\n                            ","time":"41.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":142,"hash":"e2980c10c70608ca75f9c2180abc54e1","hostname":"EderCortes"}	2024-11-06 11:24:45
43204	9d6ce544-e43e-47b6-af5f-261f7553f84a	9d6ce544-e573-4c20-ab2c-584eff1a423d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 11:24:45
21022	9d670075-6ec0-4f69-ae66-272f5b7484cc	9d670075-b1ae-4c29-b59b-458499409bd8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 13:05:48
21023	9d670075-ad9e-4cab-9d1e-eb39bf8abae5	9d670075-b1ae-4c29-b59b-458499409bd8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ma%' or \\"users\\".\\"user_document\\"::text like '%Ma%') order by \\"users\\".\\"user_document\\" asc","time":"144.63","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 13:05:49
21024	9d670075-b08e-4a05-aa89-e4ec62a714ce	9d670075-b1ae-4c29-b59b-458499409bd8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 13:05:49
21025	9d670075-b0ce-4c5e-b6e6-40eab42bbdb7	9d670075-b1ae-4c29-b59b-458499409bd8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ma"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":341,"memory":22,"hostname":"EderCortes"}	2024-11-03 13:05:49
18015	9d65b6a6-2f50-48aa-885c-27ca652539d0	9d65b6a6-78ed-48d8-927c-5bc07324433b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 21:43:36
18016	9d65b6a6-7751-4cf4-931a-41556a025a95	9d65b6a6-78ed-48d8-927c-5bc07324433b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 21:43:36
18017	9d65b6a6-77ec-4dc1-8512-a4df521ab831	9d65b6a6-78ed-48d8-927c-5bc07324433b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":350,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:43:36
24109	9d68a55f-be2d-4a30-a050-b40e4a6321f3	9d68a55f-dd38-4e9d-b017-4251175898c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 08:42:46
24110	9d68a55f-d406-4f8e-bf09-5683c2303307	9d68a55f-dd38-4e9d-b017-4251175898c0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 66\\n                        ","time":"43.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"f5566f306d2be9466f2c4564ce0020bd","hostname":"EderCortes"}	2024-11-04 08:42:46
24111	9d68a55f-d7c4-4339-9c61-90e0105365e3	9d68a55f-dd38-4e9d-b017-4251175898c0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '66' order by \\"item_loans\\".\\"id\\" asc","time":"2.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:42:46
24112	9d68a55f-d811-464e-8607-44d7d89b344c	9d68a55f-dd38-4e9d-b017-4251175898c0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 08:42:46
24113	9d68a55f-dbfe-486c-a699-3e6db5943eeb	9d68a55f-dd38-4e9d-b017-4251175898c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 08:42:46
24114	9d68a55f-dc4d-4df2-a350-dadf949a2934	9d68a55f-dd38-4e9d-b017-4251175898c0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/66","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":66,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":5000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"5000000","loans_pago_interes":"1250000"},"items":[{"id":217,"loans_codigo":66,"itemloans_cuota":"1","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:26.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":218,"loans_codigo":66,"itemloans_cuota":"2","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":219,"loans_codigo":66,"itemloans_cuota":"3","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":220,"loans_codigo":66,"itemloans_cuota":"4","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:33.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":221,"loans_codigo":66,"itemloans_cuota":"5","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":222,"loans_codigo":66,"itemloans_cuota":"6","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:39.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":223,"loans_codigo":66,"itemloans_cuota":"7","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:42.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":224,"loans_codigo":66,"itemloans_cuota":"8","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:46.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":225,"loans_codigo":66,"itemloans_cuota":"9","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-31 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:50.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":226,"loans_codigo":66,"itemloans_cuota":"10","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:31:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"}]}},"duration":278,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:42:46
30073	9d693373-1bb1-4205-befc-d466a97a6ba6	9d693373-624b-4ce8-9c54-d85263b40334	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 15:20:03
18018	9d65b6a6-c576-457f-b441-bfaf4152ce45	9d65b6a7-0e73-431b-af40-d3fd210390a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 21:43:36
18019	9d65b6a7-0614-4550-9782-760c5c99cd25	9d65b6a7-0e73-431b-af40-d3fd210390a4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"151.89","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"2b11ef88578e3c91c11800e110e490df","hostname":"EderCortes"}	2024-11-02 21:43:36
18020	9d65b6a7-0977-47fc-b051-eb366e589312	9d65b6a7-0e73-431b-af40-d3fd210390a4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"2.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:43:36
18021	9d65b6a7-09ac-47a0-8bf8-0276e41c4722	9d65b6a7-0e73-431b-af40-d3fd210390a4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:43:36
18022	9d65b6a7-0d46-401e-9f00-94bcf849b1ec	9d65b6a7-0e73-431b-af40-d3fd210390a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 21:43:36
18023	9d65b6a7-0d92-47e1-ae50-a2bc4cc3f1a3	9d65b6a7-0e73-431b-af40-d3fd210390a4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":342,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:43:36
21026	9d670075-f019-4307-9589-f8decf28c1fd	9d670075-f329-437b-b717-e88144f83d06	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":136,"memory":20,"hostname":"EderCortes"}	2024-11-03 13:05:49
30074	9d693373-57ec-4975-89d7-712f459e0a78	9d693373-624b-4ce8-9c54-d85263b40334	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"100.94","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:20:03
30075	9d693373-588e-4b70-bd0f-f968fb067344	9d693373-624b-4ce8-9c54-d85263b40334	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:20:03
30076	9d693373-5ff5-4f8d-910d-d098bce31093	9d693373-624b-4ce8-9c54-d85263b40334	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 15:20:03
30077	9d693373-60c9-40f6-b2ac-bf2e3768e806	9d693373-624b-4ce8-9c54-d85263b40334	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":542,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:20:03
43205	9d6ce544-e487-4dfe-b9ed-47e9054aadca	9d6ce544-e573-4c20-ab2c-584eff1a423d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/showCobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@showCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":14,"name":"Luis andre","profile_code":4,"remember_token":null,"user_address":"Calle 750","user_age":"31","user_alias":"luis_martinez","user_birth":"1992-11-12T04:00:00.000Z","user_cellphone":"312596295","user_city":"Cali","user_document":"100465545","user_document_type":"CC","user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_neighborhood":"Bonilla aragon"}},"duration":214,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:24:45
16308	9d64c0ae-c6e1-42cf-8b24-a3f8aa3652c4	9d64c0af-1393-4ca4-998d-5023b536e8ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 10:15:49
16309	9d64c0af-11b5-472a-8604-fe53d49253dd	9d64c0af-1393-4ca4-998d-5023b536e8ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 10:15:49
16310	9d64c0af-1280-4120-a908-dd7fa468c2c5	9d64c0af-1393-4ca4-998d-5023b536e8ef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":351,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:15:49
21027	9d670076-45c5-4154-b64c-0ae40d85a59c	9d670076-8683-411b-aa5c-bdea841f4160	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 13:05:49
21028	9d670076-826e-4ebd-89b9-d957a49788b9	9d670076-8683-411b-aa5c-bdea841f4160	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mar%' or \\"users\\".\\"user_document\\"::text like '%Mar%') order by \\"users\\".\\"user_document\\" asc","time":"139.33","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 13:05:49
21029	9d670076-8554-4994-b74a-7dd5539b602d	9d670076-8683-411b-aa5c-bdea841f4160	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 13:05:49
21030	9d670076-859b-4c09-8a7b-bc5679328971	9d670076-8683-411b-aa5c-bdea841f4160	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mar"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":322,"memory":22,"hostname":"EderCortes"}	2024-11-03 13:05:49
18024	9d65b6a8-81eb-49bf-be30-848c29fb1f7e	9d65b6a8-a1af-4070-9c8e-2d1c3bfb5c12	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 21:43:37
15473	9d5ed333-555f-497b-ac76-65b50cda4b8b	9d5ed333-91e7-4ed4-a3ba-0ca9c27cc41f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-10-30 11:32:38
15474	9d5ed333-8f2f-4351-99ef-4f43eb2ec003	9d5ed333-91e7-4ed4-a3ba-0ca9c27cc41f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 11:32:38
15475	9d5ed333-9082-4b74-96ca-4f1e9dab0cb5	9d5ed333-91e7-4ed4-a3ba-0ca9c27cc41f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":826,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:32:38
18025	9d65b6a8-9c70-4c40-aedc-dfc6bc566168	9d65b6a8-a1af-4070-9c8e-2d1c3bfb5c12	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 21:43:37
16311	9d64c0af-7122-4af7-8187-4848e60c7b29	9d64c0af-931d-4c0c-b93e-9faec73fc6e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 10:15:50
18026	9d65b6a8-9cbb-4e5a-a4c2-d7c91646d1cc	9d65b6a8-a1af-4070-9c8e-2d1c3bfb5c12	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 21:43:37
16312	9d64c0af-8a5a-4374-b7a0-1bb92d2920be	9d64c0af-931d-4c0c-b93e-9faec73fc6e3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"47.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 10:15:50
16313	9d64c0af-8e5b-46a7-ab1d-3ebd8d30c064	9d64c0af-931d-4c0c-b93e-9faec73fc6e3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 10:15:50
16314	9d64c0af-8e94-48ff-95fe-9f016f01d927	9d64c0af-931d-4c0c-b93e-9faec73fc6e3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 10:15:50
16315	9d64c0af-91e9-4bb8-9447-22826faa7941	9d64c0af-931d-4c0c-b93e-9faec73fc6e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 10:15:50
18027	9d65b6a8-a054-4196-9410-2100c71ed46e	9d65b6a8-a1af-4070-9c8e-2d1c3bfb5c12	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 21:43:37
18028	9d65b6a8-a09c-428d-865e-70228fdecd44	9d65b6a8-a1af-4070-9c8e-2d1c3bfb5c12	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":424,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:43:37
21031	9d670076-c55c-47a1-9971-b467b1890c6f	9d670076-e2f8-45a2-8dd3-8840616e6ce2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 13:05:49
21032	9d670076-de16-4a1b-b94b-bba1f1100bb8	9d670076-e2f8-45a2-8dd3-8840616e6ce2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"44.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 13:05:49
21033	9d670076-e17e-49db-a299-3320b8c4ac1d	9d670076-e2f8-45a2-8dd3-8840616e6ce2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 13:05:49
43206	9d6ce546-8be5-42df-8af0-418b06d7172e	9d6ce546-b80b-44f0-84f3-076dd64589c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 11:24:46
43207	9d6ce546-b149-4874-afdd-32fe5069ccde	9d6ce546-b80b-44f0-84f3-076dd64589c4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"60.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:24:46
43208	9d6ce546-b1b5-40e9-83f7-f1f8d0100875	9d6ce546-b80b-44f0-84f3-076dd64589c4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:24:46
15476	9d5ed333-ee3e-49c0-9cb8-9df8e649b83e	9d5ed334-0f05-4081-b62b-8834a449fe76	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-10-30 11:32:38
15477	9d5ed334-090a-4083-8d41-b0f6467cc839	9d5ed334-0f05-4081-b62b-8834a449fe76	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 11:32:38
15478	9d5ed334-0955-47c8-a9e8-646f511a4259	9d5ed334-0f05-4081-b62b-8834a449fe76	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-10-30 11:32:38
15479	9d5ed334-0dda-40a8-9ffc-c4fb788cf306	9d5ed334-0f05-4081-b62b-8834a449fe76	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 11:32:38
15480	9d5ed334-0e1d-4fef-9182-953b950c7e44	9d5ed334-0f05-4081-b62b-8834a449fe76	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:32:38
16316	9d64c0af-923d-4c57-9aad-13cbae615d1d	9d64c0af-931d-4c0c-b93e-9faec73fc6e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":272,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:15:50
21034	9d670076-e1e4-4135-ae89-9d99341256d2	9d670076-e2f8-45a2-8dd3-8840616e6ce2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":224,"memory":22,"hostname":"EderCortes"}	2024-11-03 13:05:49
43209	9d6ce546-b677-4125-8fe2-5fa83de7f0fe	9d6ce546-b80b-44f0-84f3-076dd64589c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-06 11:24:46
43210	9d6ce546-b6dc-47de-a700-810bc593b555	9d6ce546-b80b-44f0-84f3-076dd64589c4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":378,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:24:46
15481	9d5ed334-57ff-4c3b-9acd-4b696683a883	9d5ed334-9cef-4bea-867e-6103f1786e47	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-10-30 11:32:39
15482	9d5ed334-977b-486c-9d5e-bb3c57fc32a6	9d5ed334-9cef-4bea-867e-6103f1786e47	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"141.80","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":181,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-10-30 11:32:39
15483	9d5ed334-97dc-45e5-9466-c3bc48020bef	9d5ed334-9cef-4bea-867e-6103f1786e47	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-10-30 11:32:39
15484	9d5ed334-9baf-4ff6-b699-170e94645a8b	9d5ed334-9cef-4bea-867e-6103f1786e47	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-30 11:32:39
15485	9d5ed334-9c09-4473-9c0f-c2398275f241	9d5ed334-9cef-4bea-867e-6103f1786e47	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":339,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:32:39
16317	9d64c0b1-30fa-4444-ba74-8c5a8b7cfff9	9d64c0b1-510e-4769-b763-3f118ffd44d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 10:15:51
16318	9d64c0b1-4a1a-494c-a286-217ea64dc006	9d64c0b1-510e-4769-b763-3f118ffd44d9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 10:15:51
16319	9d64c0b1-4a95-43c4-8eb6-ff77737b7776	9d64c0b1-510e-4769-b763-3f118ffd44d9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 10:15:51
16320	9d64c0b1-4f8c-45ec-898d-bfb47f23f6b2	9d64c0b1-510e-4769-b763-3f118ffd44d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-02 10:15:51
16321	9d64c0b1-4fd8-4ef2-8d6c-1e5c0d6d67da	9d64c0b1-510e-4769-b763-3f118ffd44d9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-11-02 10:15:51
21035	9d67007c-b4bf-4c2c-b0cd-28d8350c9789	9d67007c-d18e-45d4-ad47-9c71e50a8ac0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 13:05:53
21036	9d67007c-cc42-4132-a7e2-93f4c02ec99f	9d67007c-d18e-45d4-ad47-9c71e50a8ac0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '18' and \\"users\\".\\"deleted_at\\" is null","time":"39.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":55,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-11-03 13:05:53
21037	9d67007c-cc93-4535-bd89-290356203243	9d67007c-d18e-45d4-ad47-9c71e50a8ac0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 13:05:53
21038	9d67007c-d064-4c4f-bb25-b5d89880de32	9d67007c-d18e-45d4-ad47-9c71e50a8ac0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 13:05:53
21039	9d67007c-d0a8-4905-8dab-8125489315ba	9d67007c-d18e-45d4-ad47-9c71e50a8ac0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/18","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-11-03 13:05:53
43211	9d6ce546-fe7c-4a61-ad52-58640ec780c4	9d6ce547-3fed-4fd7-bc7c-06adf6ddf267	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-06 11:24:46
21040	9d6700af-d61a-4be3-8965-3ec3556daa29	9d6700af-d92b-4455-9d09-6e7b6f0d9ef5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":185,"memory":22,"hostname":"EderCortes"}	2024-11-03 13:06:27
43212	9d6ce547-3bed-4a4e-8e87-eeeb7f918dea	9d6ce547-3fed-4fd7-bc7c-06adf6ddf267	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"146.55","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:24:46
43213	9d6ce547-3e68-4f3b-b789-ed8973344796	9d6ce547-3fed-4fd7-bc7c-06adf6ddf267	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-06 11:24:46
43214	9d6ce547-3eb9-41b8-9b7f-2e86292b121e	9d6ce547-3fed-4fd7-bc7c-06adf6ddf267	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":323,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:24:46
17159	9d654ed9-4406-45d1-b992-5f6287fa117d	9d654ed9-8b23-4789-8d85-183169a0836a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 16:53:21
17160	9d654ed9-8951-4207-9161-3e8a4fc2aeb3	9d654ed9-8b23-4789-8d85-183169a0836a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 16:53:21
17161	9d654ed9-8a2a-4258-bb7d-a6fcffdf7386	9d654ed9-8b23-4789-8d85-183169a0836a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:53:21
30584	9d694066-bb4a-4902-8509-bf07aefcc5fe	9d694066-c0df-43db-bb34-831aa4458c14	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1459}	2024-11-04 15:56:16
17162	9d654ed9-d9f0-4a6b-85aa-76a6ba18ca5b	9d654ed9-fb4d-4533-beb4-91441a1bf801	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 16:53:21
17163	9d654ed9-f6e7-44ba-94ca-a0b832a5bdb8	9d654ed9-fb4d-4533-beb4-91441a1bf801	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"52.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":46,"hash":"fb4ded687569d92428336ceae5c6ffcd","hostname":"EderCortes"}	2024-11-02 16:53:21
17164	9d654ed9-f9f8-43c6-bcae-d8b1aa13b900	9d654ed9-fb4d-4533-beb4-91441a1bf801	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 16:53:21
17165	9d654ed9-fa51-4bc1-bc78-2fc4e1b15bdf	9d654ed9-fb4d-4533-beb4-91441a1bf801	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:53:21
21041	9d6700b0-8bae-4033-9d28-be5e98382876	9d6700b0-aec7-41ce-b111-bdec625ed625	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 13:06:27
21042	9d6700b0-a3d5-408f-b962-2710a1511256	9d6700b0-aec7-41ce-b111-bdec625ed625	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\", \\"loans_fecha_ultimo_pago\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta', 'De las nieve', 'ds', 'CC', '100465546', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon', 'Calle 750', '3000000', 30, 10, 'M', null, '03-11-2024', 'Pendiente', '312596295', 12, 14, 18, 14, '10-11-2024', 0, 0, '10-11-2024', '2024-11-03 13:06:27', '2024-11-03 13:06:27') returning \\"id\\"","time":"4.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":106,"hash":"627b53ca897e623c432f1126c69a0881","hostname":"EderCortes"}	2024-11-03 13:06:27
21043	9d6700b0-a445-40ec-8234-573bfb35aca6	9d6700b0-aec7-41ce-b111-bdec625ed625	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:65","hostname":"EderCortes"}	2024-11-03 13:06:27
21044	9d6700b0-a5ba-4929-9de7-ff307376e756	9d6700b0-aec7-41ce-b111-bdec625ed625	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (65, 1, 300000, 90000, 'Pendiente', 'N\\/A', '10-12-2024', 12, 0, 0, '2024-11-03 13:06:27', '2024-11-03 13:06:27')","time":"2.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 13:06:27
21045	9d6700b0-a5e1-4c04-9530-6d7727ab06b4	9d6700b0-aec7-41ce-b111-bdec625ed625	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 13:06:27
21046	9d6700b0-a646-41b9-a1a9-cc08be3df7b5	9d6700b0-aec7-41ce-b111-bdec625ed625	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (65, 2, 300000, 90000, 'Pendiente', 'N\\/A', '09-01-2025', 12, 0, 0, '2024-11-03 13:06:27', '2024-11-03 13:06:27')","time":"0.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 13:06:27
21047	9d6700b0-a662-48f5-a0de-c20480a2a2e9	9d6700b0-aec7-41ce-b111-bdec625ed625	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 13:06:27
21048	9d6700b0-a6bf-44f8-812d-9f92447a3a3c	9d6700b0-aec7-41ce-b111-bdec625ed625	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (65, 3, 300000, 90000, 'Pendiente', 'N\\/A', '08-02-2025', 12, 0, 0, '2024-11-03 13:06:27', '2024-11-03 13:06:27')","time":"0.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 13:06:27
21049	9d6700b0-a6da-4079-82f9-7bd98bb77b23	9d6700b0-aec7-41ce-b111-bdec625ed625	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 13:06:27
17166	9d654edb-eb16-4540-ad93-8927e69473f7	9d654edc-08d4-4f7f-92d8-39cd0432e128	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 16:53:22
17167	9d654edc-0396-4c12-b065-4bc41b43e771	9d654edc-08d4-4f7f-92d8-39cd0432e128	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 16:53:22
17168	9d654edc-03e5-4391-babc-7445b262a159	9d654edc-08d4-4f7f-92d8-39cd0432e128	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 16:53:22
17169	9d654edc-077b-4fe0-8253-f8ec25b6d6e6	9d654edc-08d4-4f7f-92d8-39cd0432e128	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 16:53:23
17170	9d654edc-07dc-479f-992b-44943f015427	9d654edc-08d4-4f7f-92d8-39cd0432e128	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":329,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:53:23
21050	9d6700b0-a734-4d9a-ac67-d1a32264f590	9d6700b0-aec7-41ce-b111-bdec625ed625	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (65, 4, 300000, 90000, 'Pendiente', 'N\\/A', '10-03-2025', 12, 0, 0, '2024-11-03 13:06:27', '2024-11-03 13:06:27')","time":"0.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 13:06:27
21051	9d6700b0-a753-401b-a492-3107bed2fdd2	9d6700b0-aec7-41ce-b111-bdec625ed625	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 13:06:27
19381	9d66d5e2-0b09-42b6-b8d0-21c5723333ae	9d66d5e2-2818-410a-ab86-e00626f9c97d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 11:06:45
19382	9d66d5e2-2692-43e7-92a5-4be93566dbdb	9d66d5e2-2818-410a-ab86-e00626f9c97d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 11:06:45
19383	9d66d5e2-2729-4c65-8767-88e45116fc00	9d66d5e2-2818-410a-ab86-e00626f9c97d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:06:45
21052	9d6700b0-a7b1-40ad-89a7-39033f080b90	9d6700b0-aec7-41ce-b111-bdec625ed625	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (65, 5, 300000, 90000, 'Pendiente', 'N\\/A', '09-04-2025', 12, 0, 0, '2024-11-03 13:06:27', '2024-11-03 13:06:27')","time":"0.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 13:06:27
21053	9d6700b0-a7ce-4e19-8067-6c753353f683	9d6700b0-aec7-41ce-b111-bdec625ed625	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 13:06:27
21054	9d6700b0-a829-4e9b-8a31-3bdb57f01cc4	9d6700b0-aec7-41ce-b111-bdec625ed625	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (65, 6, 300000, 90000, 'Pendiente', 'N\\/A', '09-05-2025', 12, 0, 0, '2024-11-03 13:06:27', '2024-11-03 13:06:27')","time":"0.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 13:06:27
21055	9d6700b0-a844-4fc3-a592-c8bb644cf5d3	9d6700b0-aec7-41ce-b111-bdec625ed625	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 13:06:27
21056	9d6700b0-a899-407b-8d9a-b48e53c70748	9d6700b0-aec7-41ce-b111-bdec625ed625	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (65, 7, 300000, 90000, 'Pendiente', 'N\\/A', '08-06-2025', 12, 0, 0, '2024-11-03 13:06:27', '2024-11-03 13:06:27')","time":"0.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 13:06:27
21057	9d6700b0-a8b4-4e84-9a88-3c1f35264499	9d6700b0-aec7-41ce-b111-bdec625ed625	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 13:06:27
21058	9d6700b0-a905-4aaf-bb15-8a7f7eab459e	9d6700b0-aec7-41ce-b111-bdec625ed625	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (65, 8, 300000, 90000, 'Pendiente', 'N\\/A', '08-07-2025', 12, 0, 0, '2024-11-03 13:06:27', '2024-11-03 13:06:27')","time":"0.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 13:06:27
21059	9d6700b0-a91f-46f1-b921-30027403d3f8	9d6700b0-aec7-41ce-b111-bdec625ed625	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 13:06:27
19384	9d66d5e2-7305-4f05-bd5b-3bffa3a9cd01	9d66d5e2-903b-40d6-a3af-3514945e0ba7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 11:06:46
19385	9d66d5e2-87e5-4277-a7fe-f4e11253e7c0	9d66d5e2-903b-40d6-a3af-3514945e0ba7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"41.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 11:06:46
19386	9d66d5e2-8b7c-464d-9bc6-c8d1efaff8ec	9d66d5e2-903b-40d6-a3af-3514945e0ba7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"1.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:06:46
19387	9d66d5e2-8bab-44fe-b293-7dedfeae49ca	9d66d5e2-903b-40d6-a3af-3514945e0ba7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:06:46
19388	9d66d5e2-8f1b-46ff-b4c2-911a3dec488a	9d66d5e2-903b-40d6-a3af-3514945e0ba7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 11:06:46
19389	9d66d5e2-8f60-4cad-9d14-4f520e086e6f	9d66d5e2-903b-40d6-a3af-3514945e0ba7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T02:27:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"0"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:06:46
21060	9d6700b0-a96e-4342-9927-0e3ddd3ccb10	9d6700b0-aec7-41ce-b111-bdec625ed625	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (65, 9, 300000, 90000, 'Pendiente', 'N\\/A', '07-08-2025', 12, 0, 0, '2024-11-03 13:06:27', '2024-11-03 13:06:27')","time":"0.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 13:06:27
21061	9d6700b0-a989-4c8b-94fa-556029f3f73e	9d6700b0-aec7-41ce-b111-bdec625ed625	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 13:06:27
21062	9d6700b0-a9d9-435b-b8bf-450438488065	9d6700b0-aec7-41ce-b111-bdec625ed625	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (65, 10, 300000, 90000, 'Pendiente', 'N\\/A', '06-09-2025', 12, 0, 0, '2024-11-03 13:06:27', '2024-11-03 13:06:27')","time":"0.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":158,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-03 13:06:27
21063	9d6700b0-a9f4-4e94-962b-c3a95a679100	9d6700b0-aec7-41ce-b111-bdec625ed625	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-03 13:06:27
21064	9d6700b0-ad9e-454c-9955-022d1478b98a	9d6700b0-aec7-41ce-b111-bdec625ed625	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 13:06:27
21065	9d6700b0-addf-4633-bd65-d6b6515c1797	9d6700b0-aec7-41ce-b111-bdec625ed625	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"792","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"100465546","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_valor_prestado":"3000000","loans_intereses":30,"loans_cuotas":10,"loans_cuando":"M","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":18,"user_recomendacion":14,"loans_inicio_pago":"10-11-2024","created_at":null,"updated_at":null,"deleted_at":null,"loans_pago_prestado":0,"loans_pago_interes":0},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Sun Nov 03 2024","aprobador":12}},"session":[],"response_status":200,"response":{"response":"Registro creado exitosamente","id":65},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-11-03 13:06:27
19390	9d66d5e4-09f7-4352-8685-2792fc0cbfcc	9d66d5e4-2674-4d89-adfb-af1dc2f275ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 11:06:47
19391	9d66d5e4-2178-4620-b535-3b7e6526328e	9d66d5e4-2674-4d89-adfb-af1dc2f275ff	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:06:47
19392	9d66d5e4-21be-451f-a45c-704023fe3fad	9d66d5e4-2674-4d89-adfb-af1dc2f275ff	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:06:47
19393	9d66d5e4-2555-4241-8d43-0426969adfcb	9d66d5e4-2674-4d89-adfb-af1dc2f275ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 11:06:47
19394	9d66d5e4-2593-4ff8-8d16-fd4296c6deca	9d66d5e4-2674-4d89-adfb-af1dc2f275ff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:06:47
21066	9d6700b3-e66c-4b2e-bfa2-5206d31aa033	9d6700b4-2eb5-4da3-9976-52aafb3f11ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 13:06:29
21067	9d6700b4-2a0c-4730-9507-96b89a1cdd7d	9d6700b4-2eb5-4da3-9976-52aafb3f11ae	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"154.16","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 13:06:29
21068	9d6700b4-2d60-45e4-a425-62fa704f7995	9d6700b4-2eb5-4da3-9976-52aafb3f11ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 13:06:30
21069	9d6700b4-2db6-4b01-8e2c-5f199ea0ac55	9d6700b4-2eb5-4da3-9976-52aafb3f11ae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"37","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"10-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"17-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":null,"loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":366,"memory":22,"hostname":"EderCortes"}	2024-11-03 13:06:30
21240	9d673723-b538-404f-b2b1-dff8067c9a60	9d673723-fd55-403d-b9fa-ed6550af369a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 15:38:42
21241	9d673723-fbd1-49d6-ad7c-c09b20409a2c	9d673723-fd55-403d-b9fa-ed6550af369a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 15:38:42
21242	9d673723-fc65-4bc0-9ce0-808aa2b41407	9d673723-fd55-403d-b9fa-ed6550af369a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":374,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:38:42
21243	9d673724-4a18-4409-b0cf-a93399532165	9d673724-68d9-457d-88c1-a2d5691a301c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 15:38:43
21244	9d673724-5fab-422f-998b-3747885e3aaa	9d673724-68d9-457d-88c1-a2d5691a301c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 65\\n                        ","time":"42.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6768d7067397538897aacf4d73c43049","hostname":"EderCortes"}	2024-11-03 15:38:43
21245	9d673724-6355-48d8-9601-afa5aa766517	9d673724-68d9-457d-88c1-a2d5691a301c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '65' order by \\"item_loans\\".\\"id\\" asc","time":"2.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 15:38:43
21246	9d673724-638a-40ca-810b-b5f04fb273d8	9d673724-68d9-457d-88c1-a2d5691a301c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 15:38:43
21247	9d673724-6756-452b-ba59-29a7d9c3b7cb	9d673724-68d9-457d-88c1-a2d5691a301c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 15:38:43
21248	9d673724-67b8-451a-b098-6df501f800c3	9d673724-68d9-457d-88c1-a2d5691a301c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/65","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":65,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":3000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-10 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":207,"loans_codigo":65,"itemloans_cuota":"1","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:02.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":208,"loans_codigo":65,"itemloans_cuota":"2","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":209,"loans_codigo":65,"itemloans_cuota":"3","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":210,"loans_codigo":65,"itemloans_cuota":"4","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":211,"loans_codigo":65,"itemloans_cuota":"5","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":212,"loans_codigo":65,"itemloans_cuota":"6","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":213,"loans_codigo":65,"itemloans_cuota":"7","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":214,"loans_codigo":65,"itemloans_cuota":"8","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":215,"loans_codigo":65,"itemloans_cuota":"9","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":216,"loans_codigo":65,"itemloans_cuota":"10","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-09-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:38:43
21249	9d673726-21c4-45f4-b40c-c3e5596f53a4	9d673726-7030-49d2-8994-4fcabf6c14fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 15:38:44
21250	9d673726-69f7-4a33-8b28-b4d2bad025ef	9d673726-7030-49d2-8994-4fcabf6c14fd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"161.67","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 15:38:44
21251	9d673726-6a53-443e-9f75-b43098c735fc	9d673726-7030-49d2-8994-4fcabf6c14fd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 15:38:44
21252	9d673726-6e9b-4c0e-9b45-655c5ac3b54d	9d673726-7030-49d2-8994-4fcabf6c14fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 15:38:44
21253	9d673726-6ef9-4b72-82f7-1b5b43376e8e	9d673726-7030-49d2-8994-4fcabf6c14fd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":455,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:38:44
21254	9d67372c-580d-4d8b-9a6f-7393e2a67c74	9d67372c-5bbc-4113-9ac4-0f14aa0b693f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":149,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:38:48
30283	9d69397f-49f5-4f77-9ce5-48d35bfa3005	9d69397f-81cc-40df-a6ca-a11038729786	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 15:36:57
30284	9d69397f-7efd-4fe9-b887-3560125c8cba	9d69397f-81cc-40df-a6ca-a11038729786	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 15:36:57
30285	9d69397f-8078-465e-b6e5-4259845d66a7	9d69397f-81cc-40df-a6ca-a11038729786	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":458,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:36:57
30286	9d693980-1019-4b27-a264-bd5e60849b6d	9d693980-407d-4795-aca1-3f33e86983b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 15:36:58
30287	9d693980-3592-420e-baf6-1b73e2120ca8	9d693980-407d-4795-aca1-3f33e86983b0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"64.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:36:58
30288	9d693980-3648-4548-955a-35378aa00ff3	9d693980-407d-4795-aca1-3f33e86983b0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:36:58
30289	9d693980-3e86-4d33-b3f9-d6298643cd99	9d693980-407d-4795-aca1-3f33e86983b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 15:36:58
30186	9d693595-dc0d-4459-bb85-1418b483759a	9d693596-1cba-44ad-aae9-53dac3a1033b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 15:26:01
30187	9d693596-19f4-4282-ad8e-5f75808b5e3e	9d693596-1cba-44ad-aae9-53dac3a1033b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 15:26:01
30188	9d693596-1b3b-4fad-abd2-bf0b374f668e	9d693596-1cba-44ad-aae9-53dac3a1033b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":504,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:26:01
30290	9d693980-3f21-47d2-b1c3-390039b86ead	9d693980-407d-4795-aca1-3f33e86983b0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":410,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:36:58
21262	9d67372d-9abb-4536-90f1-2d9c3fb72a2d	9d67372d-e555-4720-8a01-e64fc08f180e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 15:38:49
21263	9d67372d-d966-4845-835d-920efd43b5ef	9d67372d-e555-4720-8a01-e64fc08f180e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 65\\n                        ","time":"147.68","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6768d7067397538897aacf4d73c43049","hostname":"EderCortes"}	2024-11-03 15:38:49
21264	9d67372d-df31-44c3-93b1-cee6497be5e8	9d67372d-e555-4720-8a01-e64fc08f180e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '65' order by \\"item_loans\\".\\"id\\" asc","time":"2.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 15:38:49
21265	9d67372d-df66-481b-bbfa-d9f97e6a4d6b	9d67372d-e555-4720-8a01-e64fc08f180e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 15:38:49
21266	9d67372d-e3b9-4dd6-bd80-c19f99be797e	9d67372d-e555-4720-8a01-e64fc08f180e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-03 15:38:49
21267	9d67372d-e413-4cb0-96b5-9a780a8d74c5	9d67372d-e555-4720-8a01-e64fc08f180e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/65","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":65,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":3000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-10 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":207,"loans_codigo":65,"itemloans_cuota":"1","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:02.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":208,"loans_codigo":65,"itemloans_cuota":"2","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":209,"loans_codigo":65,"itemloans_cuota":"3","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":210,"loans_codigo":65,"itemloans_cuota":"4","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":211,"loans_codigo":65,"itemloans_cuota":"5","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":212,"loans_codigo":65,"itemloans_cuota":"6","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":213,"loans_codigo":65,"itemloans_cuota":"7","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":214,"loans_codigo":65,"itemloans_cuota":"8","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":215,"loans_codigo":65,"itemloans_cuota":"9","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":216,"loans_codigo":65,"itemloans_cuota":"10","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-09-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:38:49
30189	9d693596-b0a6-4bf7-85ef-9546beb53bd1	9d693596-e40b-42e9-b667-e07d7eb07c00	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 15:26:01
30190	9d693596-da43-4389-bb28-b3d26739c995	9d693596-e40b-42e9-b667-e07d7eb07c00	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"64.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:26:02
30191	9d693596-dad0-47b7-b3e7-5363e6917bc2	9d693596-e40b-42e9-b667-e07d7eb07c00	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:26:02
30192	9d693596-e1b9-4309-9c55-fff5966a6cfc	9d693596-e40b-42e9-b667-e07d7eb07c00	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 15:26:02
30193	9d693596-e235-4d10-af08-1495fb431b7a	9d693596-e40b-42e9-b667-e07d7eb07c00	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":425,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:26:02
30291	9d693980-c93e-4688-9335-350b2fb37dc4	9d693980-f8fd-4391-bea0-2d7bf16a329b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 15:36:58
30292	9d693980-f2da-42a3-b133-1a17a81dd2ac	9d693980-f8fd-4391-bea0-2d7bf16a329b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"69.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":56,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 15:36:58
30293	9d693980-f34b-423e-8021-d5fa8d0777f7	9d693980-f8fd-4391-bea0-2d7bf16a329b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 15:36:58
30194	9d693597-5e69-4830-a6b3-493ce8dc282f	9d693597-8a93-4c88-8477-e19fce82a983	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 15:26:02
30195	9d693597-7e24-45b2-8786-252608969f18	9d693597-8a93-4c88-8477-e19fce82a983	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"51.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":56,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 15:26:02
30196	9d693597-7ed4-4225-b05d-8296e961bc1c	9d693597-8a93-4c88-8477-e19fce82a983	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 15:26:02
30197	9d693597-884b-4b3c-9152-7f913c36c4ec	9d693597-8a93-4c88-8477-e19fce82a983	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 15:26:02
30198	9d693597-88ea-4d9c-ab49-b1d1e2f6d194	9d693597-8a93-4c88-8477-e19fce82a983	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":396,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:26:02
30294	9d693980-f782-4262-b13c-dbbdc65b787e	9d693980-f8fd-4391-bea0-2d7bf16a329b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 15:36:58
30295	9d693980-f7ea-42f3-a6e2-b751eadd1471	9d693980-f8fd-4391-bea0-2d7bf16a329b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":447,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:36:58
30422	9d693de6-8b71-4f69-9294-ecec2da39f59	9d693de6-c369-4a8e-9faa-fd852b4dc9e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 15:49:16
30423	9d693de6-c047-482a-9a56-5591fb6fad42	9d693de6-c369-4a8e-9faa-fd852b4dc9e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 15:49:16
30424	9d693de6-c205-4982-b8ac-e1b8fa0ba4ca	9d693de6-c369-4a8e-9faa-fd852b4dc9e7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":442,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:49:16
30199	9d693599-d2a2-40d8-b8e4-9a42714f56d3	9d69359a-0d42-4267-b26c-7e79ae3e9891	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 15:26:04
30200	9d69359a-046b-4101-8aa4-14e4b46697c8	9d69359a-0d42-4267-b26c-7e79ae3e9891	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"86.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:26:04
17237	9d655127-1010-4d90-9607-9e1bef8b16a0	9d655127-40b9-408d-8591-2278e3e5ba5c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 16:59:47
17238	9d655127-3e32-40d7-97dd-3e5d6387ba68	9d655127-40b9-408d-8591-2278e3e5ba5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:59:47
17239	9d655127-3f48-4ca9-809a-0daf2d6d233a	9d655127-40b9-408d-8591-2278e3e5ba5c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":327,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:59:47
30201	9d69359a-04f9-45b5-8b23-5eb0941b8d67	9d69359a-0d42-4267-b26c-7e79ae3e9891	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:26:04
30202	9d69359a-0b23-49d3-afc4-b79a67822b63	9d69359a-0d42-4267-b26c-7e79ae3e9891	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 15:26:04
30203	9d69359a-0bb7-417b-9e9f-211b8eab4995	9d69359a-0d42-4267-b26c-7e79ae3e9891	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":601,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:26:04
30296	9d693983-2179-4480-8f4e-41830907913f	9d693983-55ac-4294-850c-60625ba89045	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 15:37:00
30297	9d693983-4c4e-40f8-a9fe-c27a5917034a	9d693983-55ac-4294-850c-60625ba89045	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"65.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:37:00
30298	9d693983-4ce1-48db-8c8b-23851e896c5d	9d693983-55ac-4294-850c-60625ba89045	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:37:00
30299	9d693983-538e-4894-8fb7-841cd29442dc	9d693983-55ac-4294-850c-60625ba89045	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 15:37:00
30300	9d693983-5424-482e-9366-927c38004910	9d693983-55ac-4294-850c-60625ba89045	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":561,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:37:00
30425	9d693de7-6d7f-4195-bb61-9e0b0bf47010	9d693de7-a1cf-4a1c-808a-c5801bd4fee6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 15:49:17
30426	9d693de7-97cd-43ae-beb0-945649d793e3	9d693de7-a1cf-4a1c-808a-c5801bd4fee6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"62.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":58,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 15:49:17
30427	9d693de7-9859-4f30-a6fd-396a3ca0c6ef	9d693de7-a1cf-4a1c-808a-c5801bd4fee6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 15:49:17
30428	9d693de7-9f92-4c50-ac9e-d8ceabcf42a4	9d693de7-a1cf-4a1c-808a-c5801bd4fee6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 15:49:17
30429	9d693de7-a044-486c-9291-6d3e2c6776e8	9d693de7-a1cf-4a1c-808a-c5801bd4fee6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:47:38.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":487,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:49:17
17240	9d655127-e2fb-4388-8b2a-d5f6ea054937	9d655128-2ec9-4430-bbf1-2e2d2e1a56bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 16:59:48
17241	9d655128-2973-4e20-b8c2-0f2ace99db63	9d655128-2ec9-4430-bbf1-2e2d2e1a56bf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"162.60","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":46,"hash":"fb4ded687569d92428336ceae5c6ffcd","hostname":"EderCortes"}	2024-11-02 16:59:48
17242	9d655128-2d33-4aaf-ac13-6a3cb1ae5a9a	9d655128-2ec9-4430-bbf1-2e2d2e1a56bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 16:59:48
17243	9d655128-2d97-4ed8-8ccd-243912d6ffef	9d655128-2ec9-4430-bbf1-2e2d2e1a56bf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":560,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:59:48
30204	9d69359e-d774-400b-af06-a145a11e9863	9d69359e-db6c-40f9-b5ca-379ab9ca4048	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/update-users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"PUT","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":159,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:26:07
30430	9d693de9-28f5-4168-aa1a-771865b4a744	9d693de9-7680-44e0-8383-cc08da499a09	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 15:49:18
30431	9d693de9-6c0c-4309-801f-aca2fd9301b4	9d693de9-7680-44e0-8383-cc08da499a09	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"96.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:49:18
30432	9d693de9-6cd9-420d-883b-8e5519d3e8ac	9d693de9-7680-44e0-8383-cc08da499a09	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:49:18
30433	9d693de9-744d-4a81-9d98-b97d72eec945	9d693de9-7680-44e0-8383-cc08da499a09	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 15:49:18
30434	9d693de9-74e4-4c09-b5de-98c484ce67c6	9d693de9-7680-44e0-8383-cc08da499a09	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1132,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:49:18
17244	9d65512a-01a0-4016-9f7c-36ff4b9c4e96	9d65512a-2385-44bf-b33f-a59934ce35dc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 16:59:49
17245	9d65512a-1dd9-4103-b5bf-46d4919dcdc0	9d65512a-2385-44bf-b33f-a59934ce35dc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 16:59:49
17246	9d65512a-1e49-4e67-a295-3811e9d1658c	9d65512a-2385-44bf-b33f-a59934ce35dc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 16:59:49
17247	9d65512a-221d-4528-910c-708953f76073	9d65512a-2385-44bf-b33f-a59934ce35dc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 16:59:49
17248	9d65512a-226b-40cc-b9de-5bf3a95da060	9d65512a-2385-44bf-b33f-a59934ce35dc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":464,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:59:49
30205	9d69359f-9793-4abc-9b5b-fa3fbd2aca41	9d69359f-9a65-4624-bb98-63ed59f8c715	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/update-users","method":"PUT","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"547","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","profile_code":1,"user_age":"29","user_alias":"eder_cortes","email_verified_at":null,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},"session":[],"response_status":404,"response":{"error":"El m\\u00e9todo especificado en la petici\\u00f3n no es val\\u00eddo","code":404},"duration":166,"memory":20,"hostname":"EderCortes"}	2024-11-04 15:26:07
30435	9d693dea-3071-4c68-a279-84a9be972a5d	9d693dea-6c21-47bb-818d-e5c137e4bc7c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 15:49:18
24782	9d68bd45-9da0-4349-b3f7-08281ecb39b0	9d68bd45-bba3-4472-90d2-ed722c6ac1fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 09:49:36
24783	9d68bd45-b9fb-4983-84b0-29ffefb82c16	9d68bd45-bba3-4472-90d2-ed722c6ac1fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 09:49:36
24784	9d68bd45-ba9f-4b1f-8096-cbb319e277e3	9d68bd45-bba3-4472-90d2-ed722c6ac1fc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":366,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:49:36
30436	9d693dea-6165-4351-a616-8aef15cd3090	9d693dea-6c21-47bb-818d-e5c137e4bc7c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"75.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:49:18
30437	9d693dea-622d-4d4b-83e3-abb22ba9380f	9d693dea-6c21-47bb-818d-e5c137e4bc7c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:49:18
30438	9d693dea-69a7-4a41-bee4-9eecf526c491	9d693dea-6c21-47bb-818d-e5c137e4bc7c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 15:49:18
30439	9d693dea-6a45-461b-80ca-20879ca265c8	9d693dea-6c21-47bb-818d-e5c137e4bc7c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":603,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:49:18
24785	9d68bd46-39ec-478a-b0d5-a0539ca53a73	9d68bd46-58b7-442e-9c38-64cf204c7453	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 09:49:36
24786	9d68bd46-4fd4-4de0-b9e3-a6d1d17b93b7	9d68bd46-58b7-442e-9c38-64cf204c7453	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 66\\n                        ","time":"44.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"f5566f306d2be9466f2c4564ce0020bd","hostname":"EderCortes"}	2024-11-04 09:49:36
24787	9d68bd46-5346-4c55-8069-305f480016ee	9d68bd46-58b7-442e-9c38-64cf204c7453	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '66' order by \\"item_loans\\".\\"id\\" asc","time":"1.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:49:36
24788	9d68bd46-538e-40f0-9803-315d5a4f8260	9d68bd46-58b7-442e-9c38-64cf204c7453	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 09:49:36
24789	9d68bd46-576b-4342-8c32-817a1b61475f	9d68bd46-58b7-442e-9c38-64cf204c7453	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 09:49:36
24790	9d68bd46-57bd-43b0-9d25-602bc76b3a41	9d68bd46-58b7-442e-9c38-64cf204c7453	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/66","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":66,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":5000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"5000000","loans_pago_interes":"1250000"},"items":[{"id":217,"loans_codigo":66,"itemloans_cuota":"1","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:26.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":218,"loans_codigo":66,"itemloans_cuota":"2","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":219,"loans_codigo":66,"itemloans_cuota":"3","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":220,"loans_codigo":66,"itemloans_cuota":"4","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:33.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":221,"loans_codigo":66,"itemloans_cuota":"5","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":222,"loans_codigo":66,"itemloans_cuota":"6","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:39.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":223,"loans_codigo":66,"itemloans_cuota":"7","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:42.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":224,"loans_codigo":66,"itemloans_cuota":"8","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:46.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":225,"loans_codigo":66,"itemloans_cuota":"9","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-31 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:50.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":226,"loans_codigo":66,"itemloans_cuota":"10","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:31:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"}]}},"duration":355,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:49:36
30206	9d693651-61a0-467e-a658-9369f2ee9b75	9d693651-660b-440a-bf20-cf40e75bdc37	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/update-users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"PUT","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":195,"memory":20,"hostname":"EderCortes"}	2024-11-04 15:28:04
4970	9d51365c-8233-4a90-b00e-3c9126eabd9b	9d51365c-8874-4909-ae76-dcc30721d5d8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":267}	2024-10-23 17:08:19
18135	9d65b92f-28a4-43c7-b701-6968c9e9b7f1	9d65b92f-6f9d-4608-9764-4b29f3210191	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 21:50:41
18136	9d65b92f-6e07-4551-a76b-4321f8f81b1c	9d65b92f-6f9d-4608-9764-4b29f3210191	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 21:50:41
18137	9d65b92f-6ea7-4157-9331-9f7671fc7cc9	9d65b92f-6f9d-4608-9764-4b29f3210191	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:50:41
30207	9d693651-bede-4380-8a4f-f17a824759c0	9d693651-c1f2-40e7-b562-d77893838144	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/update-users","method":"PUT","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"547","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","profile_code":1,"user_age":"29","user_alias":"eder_cortes","email_verified_at":null,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},"session":[],"response_status":404,"response":{"error":"El m\\u00e9todo especificado en la petici\\u00f3n no es val\\u00eddo","code":404},"duration":160,"memory":20,"hostname":"EderCortes"}	2024-11-04 15:28:04
18138	9d65b92f-bc40-4515-aa60-5abbe4770e6f	9d65b92f-d9c7-4f1b-8ed7-afa5b0f435ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 21:50:41
18139	9d65b92f-d10e-4547-8114-08dfdfc6a0f1	9d65b92f-d9c7-4f1b-8ed7-afa5b0f435ff	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"41.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"2b11ef88578e3c91c11800e110e490df","hostname":"EderCortes"}	2024-11-02 21:50:41
18140	9d65b92f-d4a1-44fc-af60-aaf94ee2ce94	9d65b92f-d9c7-4f1b-8ed7-afa5b0f435ff	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"2.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:50:41
18141	9d65b92f-d4d5-4087-a180-230b80c20533	9d65b92f-d9c7-4f1b-8ed7-afa5b0f435ff	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:50:41
18142	9d65b92f-d87b-479e-a4cb-1ee1c7a846b1	9d65b92f-d9c7-4f1b-8ed7-afa5b0f435ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 21:50:41
18143	9d65b92f-d8d5-4ab7-ba0c-32c752c1ec1d	9d65b92f-d9c7-4f1b-8ed7-afa5b0f435ff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:50:41
18144	9d65b931-0cde-4808-be04-0d62b2058b13	9d65b931-6495-40c1-9cab-2c5433c9e07e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 21:50:42
18145	9d65b931-5cac-4013-a6d9-4cebe445bab6	9d65b931-6495-40c1-9cab-2c5433c9e07e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"174.00","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 21:50:42
18146	9d65b931-5d45-4c2a-b647-aab2f907d224	9d65b931-6495-40c1-9cab-2c5433c9e07e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 21:50:42
18147	9d65b931-633c-41cb-b418-a176b3098d98	9d65b931-6495-40c1-9cab-2c5433c9e07e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 21:50:42
18148	9d65b931-6396-43f9-b106-71885f342aa5	9d65b931-6495-40c1-9cab-2c5433c9e07e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":500,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:50:42
18205	9d65ba21-33ae-41ed-9db4-bb1bb77d9f9c	9d65ba21-7a69-48f8-b31c-9564e0dda0fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:53:19
18206	9d65ba21-78b9-4478-8e39-7313c88775b3	9d65ba21-7a69-48f8-b31c-9564e0dda0fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 21:53:20
18207	9d65ba21-7950-454b-b2e5-dbf76cc65e68	9d65ba21-7a69-48f8-b31c-9564e0dda0fa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":409,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:53:20
18208	9d65ba21-c778-417b-8ff0-a89a47ce9ca1	9d65ba22-0b82-4df3-b09a-595c3f682e83	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 21:53:20
18209	9d65ba22-02ef-41fa-a7f4-b7cc52312ae4	9d65ba22-0b82-4df3-b09a-595c3f682e83	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"141.36","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"2b11ef88578e3c91c11800e110e490df","hostname":"EderCortes"}	2024-11-02 21:53:20
18210	9d65ba22-0646-479f-b329-f4b8fbaf5b77	9d65ba22-0b82-4df3-b09a-595c3f682e83	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"2.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:53:20
18211	9d65ba22-067b-4479-9f89-5431d07df31f	9d65ba22-0b82-4df3-b09a-595c3f682e83	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:53:20
18212	9d65ba22-0a31-4fdc-b7d3-8467e3a1ac8a	9d65ba22-0b82-4df3-b09a-595c3f682e83	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 21:53:20
18213	9d65ba22-0a8f-4dba-96bf-e3aebf4ea12d	9d65ba22-0b82-4df3-b09a-595c3f682e83	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":329,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:53:20
18214	9d65ba24-9c4b-458e-8be8-f91c98528d87	9d65ba24-d5c7-4993-90e2-0fad0a02d223	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 21:53:22
18215	9d65ba24-ca8c-4c1d-bdbc-3b719e54ab7e	9d65ba24-d5c7-4993-90e2-0fad0a02d223	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"72.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 21:53:22
18216	9d65ba24-cb1c-440d-9621-6f1f059e6641	9d65ba24-d5c7-4993-90e2-0fad0a02d223	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 21:53:22
18217	9d65ba24-d35f-4ad1-8e35-4655f2b3aa35	9d65ba24-d5c7-4993-90e2-0fad0a02d223	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 21:53:22
18218	9d65ba24-d408-482f-b5f7-30221fc59917	9d65ba24-d5c7-4993-90e2-0fad0a02d223	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":688,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:53:22
30595	9d694067-fe5a-4756-8ab1-ce11d04e0ec1	9d694068-5c1e-41c6-9c17-e48a3b7c215a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 15:56:16
30596	9d694068-5960-48b7-99d4-8204acaba2ff	9d694068-5c1e-41c6-9c17-e48a3b7c215a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 15:56:17
30597	9d694068-5aa2-4028-aefc-a6cd9db67ad4	9d694068-5c1e-41c6-9c17-e48a3b7c215a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":596,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:56:17
24900	9d68bde7-c133-441b-af3a-8c26f6f1ad11	9d68bde8-0be5-4126-8db2-91bc631a01f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 09:51:22
24901	9d68bde8-09c1-40bb-9fb4-96844528c2aa	9d68bde8-0be5-4126-8db2-91bc631a01f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 09:51:22
24902	9d68bde8-0ab9-46e8-a4d8-aff48a05cc5d	9d68bde8-0be5-4126-8db2-91bc631a01f9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":501,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:51:22
30598	9d694069-0636-41b9-a9c4-35f1910eb531	9d694069-3b7e-48f1-8f70-761094ea3379	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 15:56:17
30599	9d694069-309a-4d6a-8a06-413d63929aa0	9d694069-3b7e-48f1-8f70-761094ea3379	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"63.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":58,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 15:56:17
30600	9d694069-3133-40cc-8fb6-607a86376d74	9d694069-3b7e-48f1-8f70-761094ea3379	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 15:56:17
30601	9d694069-3963-4fe4-8602-febfcdff7d44	9d694069-3b7e-48f1-8f70-761094ea3379	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 15:56:17
24903	9d68bde8-9443-4fda-b789-d4fc2f6dab01	9d68bde8-dd2b-49f2-bec7-9126cc9eaa9d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 09:51:22
24904	9d68bde8-d2b9-4497-8734-0b8c99729395	9d68bde8-dd2b-49f2-bec7-9126cc9eaa9d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 90\\n                        ","time":"143.51","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"93c10371e33ace24260de21c3ff3890d","hostname":"EderCortes"}	2024-11-04 09:51:23
24905	9d68bde8-d701-4681-8504-3b184f59be20	9d68bde8-dd2b-49f2-bec7-9126cc9eaa9d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"2.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:51:23
24906	9d68bde8-d744-4291-bf7a-d0e1fdfc0bf8	9d68bde8-dd2b-49f2-bec7-9126cc9eaa9d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 09:51:23
24907	9d68bde8-dbec-450f-95f4-45cfb7ae8486	9d68bde8-dd2b-49f2-bec7-9126cc9eaa9d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 09:51:23
24908	9d68bde8-dc45-47b8-a6fa-6f81b11c18dc	9d68bde8-dd2b-49f2-bec7-9126cc9eaa9d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"220000","loans_pago_interes":"55000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":485,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:51:23
30602	9d694069-39ee-461b-8fb6-0e80110b1938	9d694069-3b7e-48f1-8f70-761094ea3379	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:55:01.000000Z","deleted_at":null,"user_alias":"eder.cortes"}},"duration":495,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:56:17
30603	9d69406a-f9ea-4173-a0c9-8e7dd36369b1	9d69406b-38d3-42aa-b343-9389bc80b95f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 15:56:18
30604	9d69406b-2fd6-4500-8edd-318e3ffae362	9d69406b-38d3-42aa-b343-9389bc80b95f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"95.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:56:18
30605	9d69406b-3062-434a-a748-a7d8017aa295	9d69406b-38d3-42aa-b343-9389bc80b95f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:56:18
30606	9d69406b-36cd-471d-b853-7ee3f0133ef4	9d69406b-38d3-42aa-b343-9389bc80b95f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 15:56:18
17315	9d6552f3-6ba0-4712-b09f-64383c1dddc8	9d6552f3-afd3-48f6-8cd7-942f869f869d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:04:49
17316	9d6552f3-ae40-4366-9d50-b0a540ca3a1a	9d6552f3-afd3-48f6-8cd7-942f869f869d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 17:04:49
17317	9d6552f3-aed7-4a52-9986-567cd830d4d0	9d6552f3-afd3-48f6-8cd7-942f869f869d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:04:49
30607	9d69406b-3766-408c-b71d-5f969c098fb8	9d69406b-38d3-42aa-b343-9389bc80b95f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1269,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:56:18
17318	9d6552f3-fa75-4846-9006-7fb9d499ab43	9d6552f4-3e76-40c7-8d2d-321d255ebe78	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 17:04:49
17319	9d6552f4-3a12-4931-af1e-05b82039716d	9d6552f4-3e76-40c7-8d2d-321d255ebe78	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"143.58","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":46,"hash":"fb4ded687569d92428336ceae5c6ffcd","hostname":"EderCortes"}	2024-11-02 17:04:49
17320	9d6552f4-3d38-4c66-951b-54deb7f2740e	9d6552f4-3e76-40c7-8d2d-321d255ebe78	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 17:04:49
17321	9d6552f4-3d8d-4295-977e-21e05505a0b8	9d6552f4-3e76-40c7-8d2d-321d255ebe78	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":328,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:04:49
30608	9d69406c-3bb8-407c-a868-7873310eff0f	9d69406c-6bf7-4ca2-87c3-cf916679f780	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 15:56:19
30609	9d69406c-6384-4185-8060-17794ea0c28a	9d69406c-6bf7-4ca2-87c3-cf916679f780	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"61.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:56:19
30610	9d69406c-6412-4cab-ac86-b5e4a5e3d095	9d69406c-6bf7-4ca2-87c3-cf916679f780	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:56:19
30611	9d69406c-69d9-415d-8e94-9b9f7d5663d4	9d69406c-6bf7-4ca2-87c3-cf916679f780	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 15:56:19
30612	9d69406c-6a64-4330-9254-4dd4fc7848ab	9d69406c-6bf7-4ca2-87c3-cf916679f780	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":757,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:56:19
17322	9d6552f5-a550-43ed-96f0-61e6f516f097	9d6552f5-c145-4834-b203-aa5c0891b600	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 17:04:50
17323	9d6552f5-bbf3-46d4-b9c5-553fbfe87303	9d6552f5-c145-4834-b203-aa5c0891b600	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"39.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 17:04:50
17324	9d6552f5-bc42-498e-a709-b420ba5ddc53	9d6552f5-c145-4834-b203-aa5c0891b600	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 17:04:50
17325	9d6552f5-bff2-41b6-8703-436523c80943	9d6552f5-c145-4834-b203-aa5c0891b600	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 17:04:50
17326	9d6552f5-c03f-44c0-a64a-98958bd291d8	9d6552f5-c145-4834-b203-aa5c0891b600	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":377,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:04:50
25128	9d68bfd7-00a1-45d8-9db8-50798e758c36	9d68bfd7-77e5-4d5b-9be4-f59fe79c42d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 09:56:47
25129	9d68bfd7-7498-413a-8a8d-c436edbc2011	9d68bfd7-77e5-4d5b-9be4-f59fe79c42d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 09:56:47
25130	9d68bfd7-7612-4e71-83f9-8ac903d8c01c	9d68bfd7-77e5-4d5b-9be4-f59fe79c42d3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1024,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:56:47
25131	9d68bfd8-1f14-4e1a-b397-9858e381df94	9d68bfd8-4b4d-410f-935e-0ca698d6f77a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 09:56:47
25132	9d68bfd8-40ca-4917-a534-cf264e9b4b59	9d68bfd8-4b4d-410f-935e-0ca698d6f77a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"68.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 09:56:47
25133	9d68bfd8-4514-4651-ae4f-a45a3e05313e	9d68bfd8-4b4d-410f-935e-0ca698d6f77a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:56:47
25134	9d68bfd8-4550-4f2e-9d7d-bc539c7b16ce	9d68bfd8-4b4d-410f-935e-0ca698d6f77a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 09:56:47
25135	9d68bfd8-49d7-4e16-88ed-4105e0e61495	9d68bfd8-4b4d-410f-935e-0ca698d6f77a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 09:56:47
25136	9d68bfd8-4a36-4ece-8215-a9afcb95ae13	9d68bfd8-4b4d-410f-935e-0ca698d6f77a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":437,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:56:47
25137	9d68bfd9-3d85-45be-88a2-641a8893fdbb	9d68bfd9-9bd0-4dff-a2c0-02854cbc47c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 09:56:48
25138	9d68bfd9-92cd-469e-952a-9620560538cb	9d68bfd9-9bd0-4dff-a2c0-02854cbc47c4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"179.19","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:56:48
25139	9d68bfd9-9348-4756-bd0e-b8a2e04719c5	9d68bfd9-9bd0-4dff-a2c0-02854cbc47c4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:56:48
25140	9d68bfd9-99c6-4720-8cc5-7946cd7f5dff	9d68bfd9-9bd0-4dff-a2c0-02854cbc47c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 09:56:48
25141	9d68bfd9-9a4d-4dfe-884a-8d53706ba8a3	9d68bfd9-9bd0-4dff-a2c0-02854cbc47c4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":833,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:56:48
30727	9d694314-f6cc-4652-afdb-78cd513d7cb3	9d694315-1d54-496b-bf4b-6221237351f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:03:45
30728	9d694315-1ba3-4129-8f32-d0a963833592	9d694315-1d54-496b-bf4b-6221237351f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:03:45
30729	9d694315-1c62-432e-b5c4-ccf5f7205425	9d694315-1d54-496b-bf4b-6221237351f2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":321,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:03:45
25142	9d68bfda-a7c8-497a-b2f2-dd9326a67521	9d68bfda-fd4f-4c52-a786-fb61ee9a75a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 09:56:49
25143	9d68bfda-f3ec-41db-9a5e-7c4664e721e0	9d68bfda-fd4f-4c52-a786-fb61ee9a75a5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"164.87","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:56:49
25144	9d68bfda-f477-477a-844e-6e69a0ce81e2	9d68bfda-fd4f-4c52-a786-fb61ee9a75a5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:56:49
25145	9d68bfda-fb5a-4b32-ad4a-7bf0ac5e8fce	9d68bfda-fd4f-4c52-a786-fb61ee9a75a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 09:56:49
24600	9d68b756-9c0b-42a2-a8cf-48da8b29ced0	9d68b756-fc8d-4f51-b8c4-909a827fc250	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 09:33:00
24601	9d68b756-f237-4090-bdfe-b1d193a30c2c	9d68b756-fc8d-4f51-b8c4-909a827fc250	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 09:33:00
24602	9d68b756-f525-4b64-afcb-bff9af870720	9d68b756-fc8d-4f51-b8c4-909a827fc250	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":643,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:33:00
25146	9d68bfda-fbdd-4ef7-83ac-b7c02fdcdba3	9d68bfda-fd4f-4c52-a786-fb61ee9a75a5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":598,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:56:49
30730	9d694315-baf3-4c19-99a5-0796126601e9	9d694315-f385-4ee6-9030-b9164578583e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:03:46
30731	9d694315-edda-4143-bd7f-7872ee02ac0a	9d694315-f385-4ee6-9030-b9164578583e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"97.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:03:46
30732	9d694315-ee4c-497e-90c2-4ab318379491	9d694315-f385-4ee6-9030-b9164578583e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 16:03:46
30733	9d694315-f21c-4e9a-b451-dc8493fdbae7	9d694315-f385-4ee6-9030-b9164578583e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:03:46
30734	9d694315-f278-437f-9b78-fda2b5902819	9d694315-f385-4ee6-9030-b9164578583e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":500,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:03:46
24603	9d68b757-d6e5-474c-94aa-d0025dfabd67	9d68b758-12b3-456d-9517-c7783783c6ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 09:33:01
24604	9d68b758-02da-430d-b4b7-2bdf2916cfa2	9d68b758-12b3-456d-9517-c7783783c6ae	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"79.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 09:33:01
24605	9d68b758-0985-4331-a60e-84944629f127	9d68b758-12b3-456d-9517-c7783783c6ae	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"3.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:33:01
24606	9d68b758-09d2-4e61-8db7-f6c97f5cf5ff	9d68b758-12b3-456d-9517-c7783783c6ae	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 09:33:01
24607	9d68b758-1134-41e9-aed9-f43ab4299ecb	9d68b758-12b3-456d-9517-c7783783c6ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 09:33:01
24608	9d68b758-119a-438c-9750-552e269f7e3f	9d68b758-12b3-456d-9517-c7783783c6ae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:18:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":347,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:18:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":348,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:18:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":349,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:18:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":350,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:18:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":579,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:33:01
30735	9d694316-453b-4f6a-98da-579b2f614090	9d694316-9521-48f3-bbd0-4c91bcb5113d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:03:46
30736	9d694316-8ec0-41a3-b9ad-bd2b4d213362	9d694316-9521-48f3-bbd0-4c91bcb5113d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"156.40","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:03:46
30737	9d694316-8f46-4bbc-acdc-cff828976b5c	9d694316-9521-48f3-bbd0-4c91bcb5113d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 16:03:46
30738	9d694316-93ee-4ea3-b285-5e3bfd3d4049	9d694316-9521-48f3-bbd0-4c91bcb5113d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:03:46
30739	9d694316-9435-4425-8b7f-e48250bf59b1	9d694316-9521-48f3-bbd0-4c91bcb5113d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":398,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:03:46
19605	9d66e144-23a5-4ae6-8b3a-9534dd985902	9d66e144-405d-4dc8-acf4-81c2de7ea90a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 11:38:35
19606	9d66e144-3ec5-442e-b8b9-eeacb00198ec	9d66e144-405d-4dc8-acf4-81c2de7ea90a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 11:38:35
19607	9d66e144-3f55-448a-9181-dd763df4e050	9d66e144-405d-4dc8-acf4-81c2de7ea90a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":223,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:38:35
17253	9d6551a0-3c91-4b4f-a33e-bef4de7ccdf8	9d6551a0-3fc5-4c18-be07-87149a8bee5b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":818}	2024-11-02 17:01:07
27461	9d68e567-7897-4f6e-bcb5-d8911301789c	9d68e567-7d48-43c9-b566-40a34c43a54f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1279}	2024-11-04 11:41:49
19608	9d66e144-8a9f-4959-ae18-9327e1b2c492	9d66e144-d222-400f-95a3-8c0477e32b67	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 11:38:35
19609	9d66e144-c99a-4d70-a62e-7d7e37fc5627	9d66e144-d222-400f-95a3-8c0477e32b67	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"148.90","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 11:38:36
19610	9d66e144-cd34-47c5-b538-f1871ea5d1ff	9d66e144-d222-400f-95a3-8c0477e32b67	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"1.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:38:36
19611	9d66e144-cd63-4f0a-ac36-b98e2a80c039	9d66e144-d222-400f-95a3-8c0477e32b67	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:38:36
19612	9d66e144-d0f7-47b3-ac14-eb4d347b21e9	9d66e144-d222-400f-95a3-8c0477e32b67	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 11:38:36
19613	9d66e144-d13e-4b79-953f-adffeb91e208	9d66e144-d222-400f-95a3-8c0477e32b67	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":331,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:38:36
24609	9d68b758-b99a-49c8-810a-f80f9bc5fdb5	9d68b758-ff84-45a3-b4d8-f34bc7f24878	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 09:33:02
24610	9d68b758-f590-4222-8673-82f88b772be2	9d68b758-ff84-45a3-b4d8-f34bc7f24878	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"90.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:33:02
24611	9d68b758-f625-41c6-bb6b-3618c1bfa5c1	9d68b758-ff84-45a3-b4d8-f34bc7f24878	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:33:02
24612	9d68b758-fd79-43cc-98c0-2ff71baf39fc	9d68b758-ff84-45a3-b4d8-f34bc7f24878	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 09:33:02
24613	9d68b758-fe23-4730-9cb0-27604bf936ee	9d68b758-ff84-45a3-b4d8-f34bc7f24878	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":580,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:33:02
19614	9d66e146-322b-4cca-b830-0bf682c21c2c	9d66e146-7b45-4d96-8e12-87ddbde0c2eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 11:38:36
19615	9d66e146-7584-4956-8a7f-9f4c9553cfb0	9d66e146-7b45-4d96-8e12-87ddbde0c2eb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"143.08","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:38:37
19616	9d66e146-75e3-4b87-9060-fc3548db133b	9d66e146-7b45-4d96-8e12-87ddbde0c2eb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:38:37
19617	9d66e146-79d4-47f2-84cf-995f68fe5899	9d66e146-7b45-4d96-8e12-87ddbde0c2eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 11:38:37
19618	9d66e146-7a37-420e-9518-cf514f9784fc	9d66e146-7b45-4d96-8e12-87ddbde0c2eb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":546,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:38:37
24614	9d68b759-e1a1-4223-a429-420f47595b01	9d68b75a-155b-4229-97d8-4d52f18eae56	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 09:33:02
24615	9d68b75a-0b38-44d2-94f5-03f4b322d229	9d68b75a-155b-4229-97d8-4d52f18eae56	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"70.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:33:02
24616	9d68b75a-0bbd-4343-aabc-eb52ff053f8e	9d68b75a-155b-4229-97d8-4d52f18eae56	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:33:02
24617	9d68b75a-1319-424b-b71b-61825063a809	9d68b75a-155b-4229-97d8-4d52f18eae56	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 09:33:02
24618	9d68b75a-13b3-435d-82d1-3c59d1cba301	9d68b75a-155b-4229-97d8-4d52f18eae56	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":600,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:33:02
24619	9d68b772-3941-409c-9aee-c2e4ffa46fcb	9d68b772-3c84-4e2f-ba00-85b66045c443	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":130,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:33:18
24620	9d68b772-a60c-4c2a-90cc-7eeac85a45ad	9d68b772-ce6e-4a75-93fb-fed421d35723	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 09:33:19
24621	9d68b772-c13c-43dd-b73f-67bfb886a775	9d68b772-ce6e-4a75-93fb-fed421d35723	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 88 limit 1","time":"2.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":498,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 09:33:19
24622	9d68b772-c1a6-414c-92ae-b03c3fa81b3c	9d68b772-ce6e-4a75-93fb-fed421d35723	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":2,"hostname":"EderCortes"}	2024-11-04 09:33:19
24623	9d68b772-c346-47d5-861e-93f7df477afb	9d68b772-ce6e-4a75-93fb-fed421d35723	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select count(*) as aggregate from \\"item_loans\\" where \\"loans_codigo\\" = 88 and \\"itemloans_status\\" = 'Pagada'","time":"2.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":545,"hash":"60bd91eaa209a639fc2e8afc20430a4b","hostname":"EderCortes"}	2024-11-04 09:33:19
24624	9d68b772-c3e5-4211-820d-08d410cc9952	9d68b772-ce6e-4a75-93fb-fed421d35723	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 100000, \\"loans_pago_prestado\\" = 400000, \\"updated_at\\" = '2024-11-04 09:33:19' where \\"id\\" = 88","time":"0.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":582,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 09:33:19
24625	9d68b772-c46c-405d-bdd1-45647d154ea8	9d68b772-ce6e-4a75-93fb-fed421d35723	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:88","changes":{"updated_at":"2024-11-04 09:33:19","loans_pago_interes":100000,"loans_pago_prestado":400000},"hostname":"EderCortes"}	2024-11-04 09:33:19
24626	9d68b772-c4ef-4b4a-aef3-b86cf42b8c0a	9d68b772-ce6e-4a75-93fb-fed421d35723	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 88 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"0.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":589,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 09:33:19
24627	9d68b772-c51c-41c8-b8d9-e1a67c668fd1	9d68b772-ce6e-4a75-93fb-fed421d35723	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 09:33:19
24628	9d68b772-c590-401e-955b-37a42611dcbb	9d68b772-ce6e-4a75-93fb-fed421d35723	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = 100000, \\"itemloans_cuota_cancelada\\" = 400000, \\"updated_at\\" = '2024-11-04 09:33:19' where \\"id\\" = 346","time":"0.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":596,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 09:33:19
24629	9d68b772-c5bb-4bcf-94c8-02f69b65f9a2	9d68b772-ce6e-4a75-93fb-fed421d35723	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:346","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 09:33:19","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":100000,"itemloans_cuota_cancelada":400000},"hostname":"EderCortes"}	2024-11-04 09:33:19
24630	9d68b772-c60c-4dc7-ab5b-27d84e4014d1	9d68b772-ce6e-4a75-93fb-fed421d35723	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"delete from \\"item_loans\\" where \\"loans_codigo\\" = 88 and \\"itemloans_status\\" = 'Pendiente'","time":"0.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":603,"hash":"89bf3c496a8b0746ff5d1219b8dc29e3","hostname":"EderCortes"}	2024-11-04 09:33:19
24631	9d68b772-c661-47dc-a412-3f77bf3edb3a	9d68b772-ce6e-4a75-93fb-fed421d35723	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 88 limit 1","time":"0.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":606,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 09:33:19
24632	9d68b772-c75e-4031-b10b-e29d5242b13e	9d68b772-ce6e-4a75-93fb-fed421d35723	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (88, 1, 140000, 35000, 'Pendiente', 'Se realiza abono', '12-11-2024', 12, 0, 0, '2024-11-04 09:33:19', '2024-11-04 09:33:19')","time":"1.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":657,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:33:19
24633	9d68b772-c78a-4775-b3c0-87ba8206016f	9d68b772-ce6e-4a75-93fb-fed421d35723	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:33:19
24634	9d68b772-c809-49e8-b2bd-a350cfbc5cca	9d68b772-ce6e-4a75-93fb-fed421d35723	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (88, 2, 140000, 35000, 'Pendiente', 'Se realiza abono', '20-11-2024', 12, 0, 0, '2024-11-04 09:33:19', '2024-11-04 09:33:19')","time":"0.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":657,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:33:19
24635	9d68b772-c831-4424-8a34-98066434895a	9d68b772-ce6e-4a75-93fb-fed421d35723	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:33:19
24636	9d68b772-c897-4b75-b6ac-a1283606218c	9d68b772-ce6e-4a75-93fb-fed421d35723	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (88, 3, 140000, 35000, 'Pendiente', 'Se realiza abono', '28-11-2024', 12, 0, 0, '2024-11-04 09:33:19', '2024-11-04 09:33:19')","time":"0.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":657,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:33:19
24637	9d68b772-c8b7-4279-86ae-9529014ece6c	9d68b772-ce6e-4a75-93fb-fed421d35723	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:33:19
24638	9d68b772-c913-4eab-a961-3d69dad5b768	9d68b772-ce6e-4a75-93fb-fed421d35723	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (88, 4, 140000, 35000, 'Pendiente', 'Se realiza abono', '06-12-2024', 12, 0, 0, '2024-11-04 09:33:19', '2024-11-04 09:33:19')","time":"0.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":657,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:33:19
24639	9d68b772-c933-445f-97bf-ac1993e1b641	9d68b772-ce6e-4a75-93fb-fed421d35723	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:33:19
24640	9d68b772-c98e-47d5-8a7a-e6b56f6fcf33	9d68b772-ce6e-4a75-93fb-fed421d35723	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (88, 5, 140000, 35000, 'Pendiente', 'Se realiza abono', '14-12-2024', 12, 0, 0, '2024-11-04 09:33:19', '2024-11-04 09:33:19')","time":"0.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":657,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 09:33:19
24641	9d68b772-c9ad-428d-973f-071a6e9ed8e2	9d68b772-ce6e-4a75-93fb-fed421d35723	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 09:33:19
24642	9d68b772-cd00-4524-9d55-ffb3ea7a6378	9d68b772-ce6e-4a75-93fb-fed421d35723	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 09:33:19
24643	9d68b772-cd43-4c77-a21b-daffde70ec8b	9d68b772-ce6e-4a75-93fb-fed421d35723	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"51","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"500000","idLoans":88,"idCreador":12},"session":[],"response_status":200,"response":{"message":"El abono fue aplicado exitosamente","status":true},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:33:19
30877	9d69440b-28ff-4ad0-889b-762830b2f3e8	9d69440b-8cde-44b8-9417-086fef3ad55f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:06:27
30878	9d69440b-8996-471d-bc9b-49274e7597a1	9d69440b-8cde-44b8-9417-086fef3ad55f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:06:27
30879	9d69440b-8b36-42ab-9a04-5e4b68616add	9d69440b-8cde-44b8-9417-086fef3ad55f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":574,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:06:27
25038	9d68bf67-eba8-42a7-a13e-455a380e6d56	9d68bf68-6bff-4b68-ad92-196cb600254c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 09:55:34
25039	9d68bf68-67e1-4256-9db1-1da8edda7f54	9d68bf68-6bff-4b68-ad92-196cb600254c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 09:55:34
25040	9d68bf68-69a3-4364-85b4-8e0f74bbb7ff	9d68bf68-6bff-4b68-ad92-196cb600254c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":961,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:55:34
30880	9d69440c-4189-4d4a-ae67-97f714d48bf4	9d69440c-99be-4dad-a216-d4ae0d7012d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:06:27
15201	9d5ecf44-b7c9-43be-b088-9b72d0f63ee5	9d5ecf44-eeba-4022-bd1f-e70b15258f5a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-30 11:21:38
15202	9d5ecf44-eb5b-4cb9-9fa7-7d8e26af0daf	9d5ecf44-eeba-4022-bd1f-e70b15258f5a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-30 11:21:38
15203	9d5ecf44-ecda-4328-9f71-8c22202c0eb3	9d5ecf44-eeba-4022-bd1f-e70b15258f5a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":442,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:21:38
25041	9d68bf69-3522-4424-9b1b-27e8546bee65	9d68bf69-560a-47e7-9d7d-8eba9e9067c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 09:55:35
25042	9d68bf69-4ca1-41c3-82e9-03a2f9bd3181	9d68bf69-560a-47e7-9d7d-8eba9e9067c3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"45.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 09:55:35
25043	9d68bf69-5092-4567-90a4-58d3df13228d	9d68bf69-560a-47e7-9d7d-8eba9e9067c3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:55:35
25044	9d68bf69-50c8-4b19-a695-15bf1fe18dcd	9d68bf69-560a-47e7-9d7d-8eba9e9067c3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 09:55:35
25045	9d68bf69-548b-4700-b27f-ca43b75a733b	9d68bf69-560a-47e7-9d7d-8eba9e9067c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 09:55:35
25046	9d68bf69-551b-41da-bbc9-0d7009ebb2c3	9d68bf69-560a-47e7-9d7d-8eba9e9067c3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":527,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:55:35
30881	9d69440c-883d-4772-b4e5-1daa3942c524	9d69440c-99be-4dad-a216-d4ae0d7012d7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 91\\n                        ","time":"145.55","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9ae30bc69b6b272f3f51ff48e54319f5","hostname":"EderCortes"}	2024-11-04 16:06:27
30882	9d69440c-8f67-4072-bb8f-d19fee4ab646	9d69440c-99be-4dad-a216-d4ae0d7012d7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '91' order by \\"item_loans\\".\\"id\\" asc","time":"3.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 16:06:28
30883	9d69440c-8fe5-4f12-9968-53953c0cedc4	9d69440c-99be-4dad-a216-d4ae0d7012d7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":8,"hostname":"EderCortes"}	2024-11-04 16:06:28
30884	9d69440c-9791-478a-9034-503d9f03ef0c	9d69440c-99be-4dad-a216-d4ae0d7012d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:06:28
25047	9d68bf69-fedd-45c2-be78-ef90e5232fb4	9d68bf6a-379b-4b06-80dc-169bd2a23112	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 09:55:35
25048	9d68bf6a-2c57-4288-b965-aa32cd821bdb	9d68bf6a-379b-4b06-80dc-169bd2a23112	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"70.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:55:35
25049	9d68bf6a-2ce0-49bd-9df7-5b0586b1f022	9d68bf6a-379b-4b06-80dc-169bd2a23112	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:55:35
25050	9d68bf6a-356d-43b1-ba5d-fe45f8081cea	9d68bf6a-379b-4b06-80dc-169bd2a23112	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 09:55:35
21544	9d673bea-20ef-48db-8c3f-85af6d8ee377	9d673bea-438d-4f95-b97a-c0cd3a6a078f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 15:52:03
21545	9d673bea-415e-47f0-88b0-2f28e40384c4	9d673bea-438d-4f95-b97a-c0cd3a6a078f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 15:52:04
21546	9d673bea-4235-4581-bf40-bba8511cf261	9d673bea-438d-4f95-b97a-c0cd3a6a078f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:52:04
25051	9d68bf6a-3600-4a02-8a97-d6cd825e49f9	9d68bf6a-379b-4b06-80dc-169bd2a23112	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":562,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:55:35
30885	9d69440c-9825-4320-803a-37e1dc908d7f	9d69440c-99be-4dad-a216-d4ae0d7012d7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/91","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":91,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":8,"loans_valor_prestado":5000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0","user_alias":"eder.cortes"},"items":[{"id":371,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:04:19.000000Z","updated_at":"2024-11-04T21:04:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":372,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:04:19.000000Z","updated_at":"2024-11-04T21:04:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":373,"loans_codigo":91,"itemloans_cuota":"3","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:04:19.000000Z","updated_at":"2024-11-04T21:04:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":374,"loans_codigo":91,"itemloans_cuota":"4","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:04:19.000000Z","updated_at":"2024-11-04T21:04:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":375,"loans_codigo":91,"itemloans_cuota":"5","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:04:19.000000Z","updated_at":"2024-11-04T21:04:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":376,"loans_codigo":91,"itemloans_cuota":"6","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:04:19.000000Z","updated_at":"2024-11-04T21:04:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":377,"loans_codigo":91,"itemloans_cuota":"7","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:04:19.000000Z","updated_at":"2024-11-04T21:04:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":378,"loans_codigo":91,"itemloans_cuota":"8","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:04:19.000000Z","updated_at":"2024-11-04T21:04:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":590,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:06:28
30985	9d69450c-7d01-40ec-a48c-8191e4edcfb5	9d69450c-d189-4e80-b10d-914ee4159f5e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 16:09:15
30986	9d69450c-ce49-47a2-b990-46c9083bfc2d	9d69450c-d189-4e80-b10d-914ee4159f5e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 16:09:15
30987	9d69450c-cfb3-429f-ac74-ea8df9a4151e	9d69450c-d189-4e80-b10d-914ee4159f5e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":686,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:09:15
21547	9d673bea-a481-4fb8-adab-9c58534ac814	9d673bea-c3cb-4033-a72e-4f133e068b61	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 15:52:04
21548	9d673bea-be98-480e-81f7-6514b247b13d	9d673bea-c3cb-4033-a72e-4f133e068b61	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"48.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 15:52:04
21549	9d673bea-c270-41c8-acc8-57cb2067f104	9d673bea-c3cb-4033-a72e-4f133e068b61	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 15:52:04
21550	9d673bea-c2d2-4a4b-8117-4fa50e4f774b	9d673bea-c3cb-4033-a72e-4f133e068b61	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":279,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:52:04
25052	9d68bf6a-f2a9-48bc-ab04-0e7f39c2e472	9d68bf6b-4cf4-45b6-9514-690211abcc48	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 09:55:36
25053	9d68bf6b-43ab-4755-a525-216013349750	9d68bf6b-4cf4-45b6-9514-690211abcc48	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"173.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:55:36
25054	9d68bf6b-4449-464e-8654-d0b92a9125cd	9d68bf6b-4cf4-45b6-9514-690211abcc48	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:55:36
25055	9d68bf6b-4ae1-4e6c-9fab-68f3aa55bfad	9d68bf6b-4cf4-45b6-9514-690211abcc48	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 09:55:36
25056	9d68bf6b-4b58-49d3-9278-2e17ed1a4e48	9d68bf6b-4cf4-45b6-9514-690211abcc48	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":683,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:55:36
30886	9d69440e-3cb5-4306-ac88-492d77559f09	9d69440e-c455-4ff1-a6a3-ea1657e1474e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:06:29
25256	9d68c0cc-6138-4ddc-94bf-bf8ce5553048	9d68c0cc-7dfd-4166-9290-4dc2430378da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 09:59:27
25257	9d68c0cc-7c71-4188-bbdc-e755106457d8	9d68c0cc-7dfd-4166-9290-4dc2430378da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 09:59:27
25258	9d68c0cc-7d08-46ea-8b63-dbe3076b8dd1	9d68c0cc-7dfd-4166-9290-4dc2430378da	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":367,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:59:27
30887	9d69440e-b8a4-4131-92b5-7a9eaaf55a6f	9d69440e-c455-4ff1-a6a3-ea1657e1474e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"168.53","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:06:29
30888	9d69440e-b929-4bdf-adb4-8ad4a4bea989	9d69440e-c455-4ff1-a6a3-ea1657e1474e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:06:29
30889	9d69440e-c230-4c8b-b636-85a671861637	9d69440e-c455-4ff1-a6a3-ea1657e1474e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:06:29
30988	9d69450d-60ed-4b48-ab18-da8461b996cb	9d69450d-98ec-4035-9ce7-81f549c55c97	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 16:09:16
30989	9d69450d-8ea1-4772-ad31-111792c6a0d7	9d69450d-98ec-4035-9ce7-81f549c55c97	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"69.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:09:16
30990	9d69450d-8f4f-4dbb-8667-86a99a1a53a4	9d69450d-98ec-4035-9ce7-81f549c55c97	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 16:09:16
21551	9d673bec-e1e3-4072-afc5-d48d58bf94a6	9d673bed-0ec1-4f46-9b42-b33fd2687a98	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 15:52:05
21552	9d673bed-07c1-4814-9174-23a3a0620aef	9d673bed-0ec1-4f46-9b42-b33fd2687a98	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"56.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 15:52:05
21553	9d673bed-0869-426a-afbd-b45ed0d460f1	9d673bed-0ec1-4f46-9b42-b33fd2687a98	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 15:52:05
21554	9d673bed-0d23-4e14-98f4-3c1f390416b6	9d673bed-0ec1-4f46-9b42-b33fd2687a98	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 15:52:05
21555	9d673bed-0d7c-42d1-a921-4ce4d278768a	9d673bed-0ec1-4f46-9b42-b33fd2687a98	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":658,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:52:05
25259	9d68c0cc-ff9a-4472-b0e1-3a249d13290c	9d68c0cd-272a-4d7b-a93a-7d5fb830bbe7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 09:59:28
25260	9d68c0cd-1fed-4ae8-bc96-df16275cdc80	9d68c0cd-272a-4d7b-a93a-7d5fb830bbe7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"58.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 09:59:28
25261	9d68c0cd-251d-40e7-8ebe-ede9ed81a3c1	9d68c0cd-272a-4d7b-a93a-7d5fb830bbe7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 09:59:28
25262	9d68c0cd-25d6-413e-aa95-fd5b512b4c54	9d68c0cd-272a-4d7b-a93a-7d5fb830bbe7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":386,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:59:28
30890	9d69440e-c2c9-4067-83fa-499dde1b15ad	9d69440e-c455-4ff1-a6a3-ea1657e1474e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1387,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:06:29
30991	9d69450d-96b0-4557-b57f-0396f14fcb81	9d69450d-98ec-4035-9ce7-81f549c55c97	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 16:09:16
30891	9d69440f-c270-4e99-8cf6-eefd8e86f1fb	9d694410-05ae-431b-9779-8c486e389362	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:06:30
17383	9d65590a-be9b-42c4-8562-3aaa8db9e78f	9d65590a-e96f-4f14-9062-3ffc3796a259	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 17:21:51
17384	9d65590a-e764-49f3-98a1-afe2696d16a8	9d65590a-e96f-4f14-9062-3ffc3796a259	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:21:51
17385	9d65590a-e83d-43a3-b934-a4eefacef34f	9d65590a-e96f-4f14-9062-3ffc3796a259	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":305,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:21:51
30892	9d69440f-f8a6-4ea5-bb20-c711279a9c7b	9d694410-05ae-431b-9779-8c486e389362	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"94.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:06:30
30893	9d69440f-f969-48ba-94ec-0f5bf2b4a5d2	9d694410-05ae-431b-9779-8c486e389362	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:06:30
30894	9d694410-0351-4051-ac39-8d2d4da145f6	9d694410-05ae-431b-9779-8c486e389362	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:06:30
30895	9d694410-03ff-4bfc-a664-853452710814	9d694410-05ae-431b-9779-8c486e389362	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":792,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:06:30
30992	9d69450d-9751-40a0-9c21-b575d385db78	9d69450d-98ec-4035-9ce7-81f549c55c97	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":417,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:09:16
24761	9d68bd27-36a9-47c3-88cb-60dcd285fee2	9d68bd27-3c44-413b-8509-e4ffca40bea5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1123}	2024-11-04 09:49:16
17386	9d65590b-70a5-44ad-89c7-b98403f5375b	9d65590b-8d4e-4044-b155-f74309eb6f19	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:21:51
17387	9d65590b-88bb-4235-a87e-2731cf68e4a0	9d65590b-8d4e-4044-b155-f74309eb6f19	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"44.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":46,"hash":"fb4ded687569d92428336ceae5c6ffcd","hostname":"EderCortes"}	2024-11-02 17:21:51
17388	9d65590b-8c16-41b2-b11f-4b8ba651caee	9d65590b-8d4e-4044-b155-f74309eb6f19	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:21:51
17389	9d65590b-8c69-4540-97b6-0cd6ee8d3492	9d65590b-8d4e-4044-b155-f74309eb6f19	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":371,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:21:51
30993	9d69450e-1ab5-46ac-aeba-8bc285519b60	9d69450e-4477-4aae-ae94-8be45e5e99b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 16:09:16
30994	9d69450e-3dbe-4dbc-b846-339086fd3f13	9d69450e-4477-4aae-ae94-8be45e5e99b1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"50.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:09:16
30995	9d69450e-3e31-4437-9212-1fba33bc1a4a	9d69450e-4477-4aae-ae94-8be45e5e99b1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 16:09:16
30996	9d69450e-42d0-4cb7-9435-d31290e2f53b	9d69450e-4477-4aae-ae94-8be45e5e99b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 16:09:16
30997	9d69450e-4367-4e21-b173-a1f88fd20753	9d69450e-4477-4aae-ae94-8be45e5e99b1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":415,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:09:16
30998	9d69450e-f682-43a9-a322-eebf6079e17d	9d69450f-3eeb-4104-9da3-6fa87e655773	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 16:09:17
30999	9d69450f-33ff-49ad-a02d-8f0794f2aa7f	9d69450f-3eeb-4104-9da3-6fa87e655773	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"113.64","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:09:17
31000	9d69450f-34a7-4f16-93f4-1819a12456f5	9d69450f-3eeb-4104-9da3-6fa87e655773	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:09:17
16631	9d64d427-2e11-4237-9f11-0556b1a0e263	9d64d427-507c-481e-80ae-73022eb7e43f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-02 11:10:16
16632	9d64d427-4dca-462e-95e0-0c0cd474e1f5	9d64d427-507c-481e-80ae-73022eb7e43f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-02 11:10:16
16633	9d64d427-4f2b-45a7-adf6-d60f5298da1e	9d64d427-507c-481e-80ae-73022eb7e43f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":288,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:10:16
31001	9d69450f-3cbc-48e6-8779-cd2ee6bf3a46	9d69450f-3eeb-4104-9da3-6fa87e655773	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 16:09:17
31002	9d69450f-3d58-4227-9eb6-7eb95f937049	9d69450f-3eeb-4104-9da3-6fa87e655773	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":608,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:09:17
16634	9d64d427-b4a0-450d-8020-ab1593e5217d	9d64d427-ffa9-48c0-95af-47e1a551d467	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-02 11:10:16
16635	9d64d427-f5a0-43c9-8ceb-f0a8e016f6dc	9d64d427-ffa9-48c0-95af-47e1a551d467	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"152.51","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 11:10:16
16636	9d64d427-f9ad-4f1f-89e4-bf54a6bc470f	9d64d427-ffa9-48c0-95af-47e1a551d467	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 11:10:16
16637	9d64d427-f9f9-41ab-afdd-55d51f0f0009	9d64d427-ffa9-48c0-95af-47e1a551d467	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 11:10:16
16638	9d64d427-fe1d-466a-a5dd-4fc4d5a840e3	9d64d427-ffa9-48c0-95af-47e1a551d467	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-02 11:10:16
16639	9d64d427-fe78-46a5-a825-1eb56dd95759	9d64d427-ffa9-48c0-95af-47e1a551d467	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":398,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:10:16
17390	9d65590d-8208-4761-ae23-8c81bf356677	9d65590d-b07a-4829-907e-055081a90d1f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:21:53
17391	9d65590d-a690-47cb-8082-f1b0db254eed	9d65590d-b07a-4829-907e-055081a90d1f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"67.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 17:21:53
17392	9d65590d-a718-42ff-87d1-02fdba66870d	9d65590d-b07a-4829-907e-055081a90d1f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 17:21:53
17393	9d65590d-ae56-4cfc-90c0-8f13fbafcb92	9d65590d-b07a-4829-907e-055081a90d1f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:21:53
17394	9d65590d-aed7-4b7c-b2a6-77ca2b4c71fb	9d65590d-b07a-4829-907e-055081a90d1f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":404,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:21:53
31003	9d694510-1aaa-4496-a0d9-5d4cdfa1435f	9d694510-920c-482c-9c2c-d5788fb3cd6e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 16:09:18
31004	9d694510-8878-4b7d-858f-2f8f98fca99c	9d694510-920c-482c-9c2c-d5788fb3cd6e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"173.14","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:09:18
31005	9d694510-8907-4a43-b6cb-076b477fd5bb	9d694510-920c-482c-9c2c-d5788fb3cd6e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:09:18
31006	9d694510-8ffa-4f39-9ee9-4595f0be619b	9d694510-920c-482c-9c2c-d5788fb3cd6e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 16:09:18
16640	9d64d429-4468-444e-8cd1-526b098064cf	9d64d429-7f67-4511-9998-63e05e741ebe	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 11:10:17
16641	9d64d429-72c8-4fc1-b5d3-e3f93434b32d	9d64d429-7f67-4511-9998-63e05e741ebe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"62.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 11:10:17
16642	9d64d429-7374-45a3-aeaa-fbb4db0c11e0	9d64d429-7f67-4511-9998-63e05e741ebe	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 11:10:17
16643	9d64d429-7cce-4595-9877-d3c1ec6ec734	9d64d429-7f67-4511-9998-63e05e741ebe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 11:10:17
16644	9d64d429-7d7f-43fa-803b-f3fb89ea1ab0	9d64d429-7f67-4511-9998-63e05e741ebe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":505,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:10:17
31007	9d694510-9087-4e98-a78e-7d707489e085	9d694510-920c-482c-9c2c-d5788fb3cd6e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":790,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:09:18
34600	9d69bf06-625f-4a48-a8f8-3098ad8fe7fe	9d69bf06-6698-4a2c-8fb5-77cdabc633b3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1567}	2024-11-04 21:50:19
31008	9d694527-64f3-4d08-b099-d33cce9e9374	9d694527-6934-444f-a851-89e5be32134f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":146,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:09:33
31009	9d694527-cb5e-480e-912a-15c83e597a19	9d694527-cef2-4227-a96b-6097bd78e667	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":143,"memory":20,"hostname":"EderCortes"}	2024-11-04 16:09:33
31010	9d694528-2421-405e-9a2f-b9ffb062cfb4	9d694528-278f-4b15-a0cf-8b7704a83ad9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":152,"memory":20,"hostname":"EderCortes"}	2024-11-04 16:09:33
25567	9d68c719-d0ca-4e6e-82b9-14f3e0bf516b	9d68c71a-1cc5-4742-bf16-9068927552e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 10:17:05
25568	9d68c71a-196c-476b-943c-65e35088b74a	9d68c71a-1cc5-4742-bf16-9068927552e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 10:17:05
25569	9d68c71a-1b17-4d3a-8d83-93d38f97b54f	9d68c71a-1cc5-4742-bf16-9068927552e7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":865,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:17:05
31011	9d694528-abd5-475c-8111-442feb0f4932	9d694528-c7a7-49fb-9bc8-041873b47e6f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 16:09:34
31012	9d694528-c337-4e36-8ef6-7cec22f64e24	9d694528-c7a7-49fb-9bc8-041873b47e6f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ma%' or \\"users\\".\\"user_document\\"::text like '%Ma%') order by \\"users\\".\\"user_document\\" asc","time":"42.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 16:09:34
31013	9d694528-c63f-414a-acd8-a508450dcb02	9d694528-c7a7-49fb-9bc8-041873b47e6f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 16:09:34
19814	9d66e7f4-f3da-4c17-ae09-a1f479cd0c59	9d66e7f4-f7d7-465f-b9b0-13af36e37e8b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":978}	2024-11-03 11:57:18
25473	9d68c679-21b5-412d-8920-fb78f26132a1	9d68c679-4c39-4da8-9c26-b7a1171b38b7	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 10:15:19
25474	9d68c679-4a3d-480b-8fd0-d5c7bef787a8	9d68c679-4c39-4da8-9c26-b7a1171b38b7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:15:19
25475	9d68c679-4b0f-4c89-8c4c-332b8b81126a	9d68c679-4c39-4da8-9c26-b7a1171b38b7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":507,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:15:19
31014	9d694528-c68b-47e0-87c3-0795cfd570c3	9d694528-c7a7-49fb-9bc8-041873b47e6f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ma"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:09:34
25476	9d68c679-fe2a-4031-a2d4-6969a50391b4	9d68c67a-4758-4656-bc91-b1c30a12f7a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:15:20
25477	9d68c67a-41a9-4c79-abca-bdbec46038e2	9d68c67a-4758-4656-bc91-b1c30a12f7a2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"151.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 10:15:20
25478	9d68c67a-45b8-41bf-af56-676211d34f7b	9d68c67a-4758-4656-bc91-b1c30a12f7a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:15:20
25479	9d68c67a-4651-44d2-99aa-3bad3a95814f	9d68c67a-4758-4656-bc91-b1c30a12f7a2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":543,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:15:20
25570	9d68c71b-067e-4151-ae9b-d6d4d6471d11	9d68c71b-35a7-458e-b1dc-26396bc7b037	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 10:17:05
25571	9d68c71b-2bf2-467d-ae09-a888115b8fab	9d68c71b-35a7-458e-b1dc-26396bc7b037	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"66.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 10:17:06
25572	9d68c71b-3339-4580-9a47-c14e96d04f04	9d68c71b-35a7-458e-b1dc-26396bc7b037	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 10:17:06
25573	9d68c71b-3425-4e7f-b391-2c0cf72a6648	9d68c71b-35a7-458e-b1dc-26396bc7b037	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":633,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:17:06
31015	9d694529-033d-416c-8b53-3d71ce07f638	9d694529-21f1-4fe0-96ae-14a3c6947644	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 16:09:34
31016	9d694529-1daf-401a-a75b-8f5d44e7ce61	9d694529-21f1-4fe0-96ae-14a3c6947644	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mar%' or \\"users\\".\\"user_document\\"::text like '%Mar%') order by \\"users\\".\\"user_document\\" asc","time":"52.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 16:09:34
31017	9d694529-2065-4502-8ffd-6eef0f6dbe87	9d694529-21f1-4fe0-96ae-14a3c6947644	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 16:09:34
31018	9d694529-20ad-454f-8ce0-291915d47e31	9d694529-21f1-4fe0-96ae-14a3c6947644	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mar"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":221,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:09:34
25383	9d68c25b-8391-4e0c-bd7d-f7f251ee989e	9d68c25b-a940-4dad-8570-c4b4419c618b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 10:03:49
25384	9d68c25b-a744-4afc-a2fe-20e34fbf48ac	9d68c25b-a940-4dad-8570-c4b4419c618b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:03:49
25385	9d68c25b-a816-41eb-af63-09a10c8d0142	9d68c25b-a940-4dad-8570-c4b4419c618b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":404,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:03:49
25574	9d68c71c-39f1-43d7-96a1-90fcb1f22bed	9d68c71d-28da-470a-b315-13550dcdc148	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 10:17:06
25575	9d68c71d-162d-4c09-9fb6-d279d07fc450	9d68c71d-28da-470a-b315-13550dcdc148	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"232.62","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:17:07
25576	9d68c71d-16de-4f5c-9ea3-cb4246bdb735	9d68c71d-28da-470a-b315-13550dcdc148	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:17:07
25577	9d68c71d-24ea-4383-b5db-1b50d3e96412	9d68c71d-28da-470a-b315-13550dcdc148	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 10:17:07
25386	9d68c25c-3533-42ab-bf38-c33397789dfa	9d68c25c-540c-4f7f-8527-67e0ddc60b82	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:03:49
25387	9d68c25c-4ab9-4893-905d-2ce980556391	9d68c25c-540c-4f7f-8527-67e0ddc60b82	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"41.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:03:49
25388	9d68c25c-4e7c-4733-93bb-03bc99b161ef	9d68c25c-540c-4f7f-8527-67e0ddc60b82	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:03:49
25389	9d68c25c-4eb2-4c50-8a04-9d32a6bcc07f	9d68c25c-540c-4f7f-8527-67e0ddc60b82	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:03:49
18531	9d66936b-3014-4b03-b05a-4b5b1f533b91	9d66936b-5b13-4856-b18a-617053e03367	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 08:00:55
18532	9d66936b-5834-4aea-867b-1fd7d2606435	9d66936b-5b13-4856-b18a-617053e03367	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:00:55
18533	9d66936b-5990-473a-a75d-eb1819ab76b3	9d66936b-5b13-4856-b18a-617053e03367	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":316,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:00:55
25390	9d68c25c-52ed-4176-8017-ef19506761c4	9d68c25c-540c-4f7f-8527-67e0ddc60b82	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:03:49
25391	9d68c25c-5339-4fc2-91cc-287abe51f6dc	9d68c25c-540c-4f7f-8527-67e0ddc60b82	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":391,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:03:49
25578	9d68c71d-25dd-4747-83ca-f3ddd1b8822c	9d68c71d-28da-470a-b315-13550dcdc148	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1254,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:17:07
31019	9d694529-6c39-4591-a0d4-c827c3a36297	9d694529-8861-4041-b8e9-7adb430c4afb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 16:09:34
31020	9d694529-83f5-48a2-b32b-9f907d62bc05	9d694529-8861-4041-b8e9-7adb430c4afb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"43.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 16:09:34
31021	9d694529-8723-46b2-898d-4b71ecfc8ff9	9d694529-8861-4041-b8e9-7adb430c4afb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 16:09:34
18534	9d66936b-c681-419f-aa36-e0730192bc6c	9d66936c-1586-493c-9988-93c45a20c4ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:00:55
18535	9d66936c-1054-422a-a6c6-ae413cf11c64	9d66936c-1586-493c-9988-93c45a20c4ff	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"165.86","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58,"hash":"77f8314368b36a9393ec9c7735a91700","hostname":"EderCortes"}	2024-11-03 08:00:55
18536	9d66936c-1424-4f97-954f-c25eae5d004b	9d66936c-1586-493c-9988-93c45a20c4ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:00:55
18537	9d66936c-1480-418f-812d-95e7bb21ce61	9d66936c-1586-493c-9988-93c45a20c4ff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":431,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:00:55
25579	9d68c71e-883d-4e2c-ac4e-cc45b9d2dc2b	9d68c71e-c0d9-425b-b495-c07c02caed19	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 10:17:08
25580	9d68c71e-b5c4-45b2-b641-b15090f0af8a	9d68c71e-c0d9-425b-b495-c07c02caed19	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"68.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:17:08
25581	9d68c71e-b64c-4963-aa07-510112f714e1	9d68c71e-c0d9-425b-b495-c07c02caed19	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:17:08
25582	9d68c71e-be90-4c83-bd1d-a4b78f10c8af	9d68c71e-c0d9-425b-b495-c07c02caed19	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 10:17:08
25583	9d68c71e-bf2a-4860-b851-bc0d95795c51	9d68c71e-c0d9-425b-b495-c07c02caed19	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1010,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:17:08
31022	9d694529-8773-4320-9582-9b00f8d9672b	9d694529-8861-4041-b8e9-7adb430c4afb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:09:34
18538	9d66936e-331a-4bfd-b500-d2e4bec5b30c	9d66936e-79b2-4f3e-9814-a65d4cb8f6de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:00:56
18539	9d66936e-74f9-427e-9e72-5c133aad0229	9d66936e-79b2-4f3e-9814-a65d4cb8f6de	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"148.91","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 08:00:57
18540	9d66936e-7542-4b48-99cd-bea13fd904ce	9d66936e-79b2-4f3e-9814-a65d4cb8f6de	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 08:00:57
18541	9d66936e-787e-4d9c-9402-de9109ef7f6b	9d66936e-79b2-4f3e-9814-a65d4cb8f6de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 08:00:57
18542	9d66936e-78bf-4595-bd02-13062ad89f1b	9d66936e-79b2-4f3e-9814-a65d4cb8f6de	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":371,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:00:57
31023	9d694529-c479-48f3-8059-146145b7c383	9d694529-c7ca-4049-9d1e-f4f29216fd4b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":138,"memory":20,"hostname":"EderCortes"}	2024-11-04 16:09:34
31024	9d69452a-803a-445c-adac-acad452d7cfe	9d69452a-9afa-475b-8585-34ad4e9fd3f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 16:09:35
31025	9d69452a-9694-40bc-a65e-14863b0c7541	9d69452a-9afa-475b-8585-34ad4e9fd3f4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"39.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 16:09:35
31026	9d69452a-99ce-42c0-b71c-1e0d3671fd74	9d69452a-9afa-475b-8585-34ad4e9fd3f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 16:09:35
31027	9d69452a-9a18-41c6-b484-14aabfc90015	9d69452a-9afa-475b-8585-34ad4e9fd3f4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:09:35
31028	9d69452b-4c0a-4430-8941-97542564540f	9d69452b-4fbe-48e5-8dad-8f30f7d3e814	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":141,"memory":20,"hostname":"EderCortes"}	2024-11-04 16:09:35
19785	9d66e6e3-bbc1-4e95-82b8-2d788f7419f2	9d66e6e3-d961-4f4f-8be2-26dfd3c85b41	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 11:54:19
19786	9d66e6e3-d7df-487f-937b-1fffdf590143	9d66e6e3-d961-4f4f-8be2-26dfd3c85b41	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 11:54:19
19787	9d66e6e3-d874-43a3-b861-52171308108c	9d66e6e3-d961-4f4f-8be2-26dfd3c85b41	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:54:19
19788	9d66e6e4-2517-4eac-a53f-b78eff57b7f8	9d66e6e4-6b90-4057-af49-1146d69b9a8c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 11:54:19
19789	9d66e6e4-62ca-4b72-97f6-d9005635f69a	9d66e6e4-6b90-4057-af49-1146d69b9a8c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"145.60","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 11:54:19
19790	9d66e6e4-6660-476e-84da-89c4b5e3859b	9d66e6e4-6b90-4057-af49-1146d69b9a8c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:54:19
19791	9d66e6e4-668f-4473-811c-94af446e508f	9d66e6e4-6b90-4057-af49-1146d69b9a8c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:54:19
18660	9d669907-d843-460d-8bf3-086be9d3deb5	9d669907-fe08-4984-b79d-1c0e9bccb4eb	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 08:16:36
18661	9d669907-fbf8-467c-8323-469937242b35	9d669907-fe08-4984-b79d-1c0e9bccb4eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:16:36
18662	9d669907-fccc-435a-b588-53cc32b74141	9d669907-fe08-4984-b79d-1c0e9bccb4eb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":272,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:16:36
19792	9d66e6e4-6a74-4956-bb75-4243955a6596	9d66e6e4-6b90-4057-af49-1146d69b9a8c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 11:54:19
19793	9d66e6e4-6ac8-41d2-a3b9-71b434866b03	9d66e6e4-6b90-4057-af49-1146d69b9a8c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"100000","loans_pago_interes":"50000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":325,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:54:19
31029	9d69452c-03f3-4878-8422-00d549bb13d9	9d69452c-1e9f-4f0f-bb50-7838d32d5870	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 16:09:36
31030	9d69452c-1a2e-4dce-a0df-996b1e3ad1d2	9d69452c-1e9f-4f0f-bb50-7838d32d5870	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"40.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 16:09:36
31031	9d69452c-1d45-4de6-8662-3161044fac81	9d69452c-1e9f-4f0f-bb50-7838d32d5870	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 16:09:36
31032	9d69452c-1d8c-42fc-ad3b-74aec33cab35	9d69452c-1e9f-4f0f-bb50-7838d32d5870	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:09:36
18663	9d669908-5812-4aa0-a2a2-0410977c1eba	9d669908-74a1-40bc-9e16-54f8fbdf1a71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:16:36
18664	9d669908-6fe0-4faf-b5f1-457bd70fdfb2	9d669908-74a1-40bc-9e16-54f8fbdf1a71	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"43.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58,"hash":"8c8e5c1025213c11a10d0db7a142a089","hostname":"EderCortes"}	2024-11-03 08:16:36
18665	9d669908-7341-4cef-a0de-6768077dbda4	9d669908-74a1-40bc-9e16-54f8fbdf1a71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:16:36
18666	9d669908-7393-471f-8fb4-18b089986931	9d669908-74a1-40bc-9e16-54f8fbdf1a71	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":260,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:16:36
19794	9d66e6e5-cec6-4b68-a241-5618794567f3	9d66e6e5-fa34-46f6-9fb5-0f63fd758ac5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 11:54:20
19795	9d66e6e5-f1bf-4ab0-b1fe-4e58238fc8ff	9d66e6e5-fa34-46f6-9fb5-0f63fd758ac5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"56.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:54:20
19796	9d66e6e5-f21a-442d-895a-17c474caf06a	9d66e6e5-fa34-46f6-9fb5-0f63fd758ac5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:54:20
19797	9d66e6e5-f864-4e2e-abeb-e39727a4ad77	9d66e6e5-fa34-46f6-9fb5-0f63fd758ac5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 11:54:20
19798	9d66e6e5-f8dd-480c-af91-832104e873e8	9d66e6e5-fa34-46f6-9fb5-0f63fd758ac5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":406,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:54:20
31033	9d69452d-e034-40ba-b8ab-c43168f7c9de	9d69452e-004f-443f-8282-bb7e02f1dfc1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 16:09:37
31034	9d69452d-fb0f-4824-820d-f6a2444b1876	9d69452e-004f-443f-8282-bb7e02f1dfc1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '19' and \\"users\\".\\"deleted_at\\" is null","time":"39.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":55,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-11-04 16:09:37
31035	9d69452d-fb62-4a90-b0ee-62afea56a3ca	9d69452e-004f-443f-8282-bb7e02f1dfc1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 16:09:37
31036	9d69452d-fef1-4448-a123-7c3369a51f7d	9d69452e-004f-443f-8282-bb7e02f1dfc1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 16:09:37
18667	9d66990a-632a-421a-be83-923024a40010	9d66990a-b2ee-40f3-8198-a610e005fcb1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:16:38
18668	9d66990a-ac80-4cbc-baa2-388614cf0cad	9d66990a-b2ee-40f3-8198-a610e005fcb1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"157.91","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 08:16:38
18669	9d66990a-acea-4905-a761-9afcfbd72b31	9d66990a-b2ee-40f3-8198-a610e005fcb1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 08:16:38
18670	9d66990a-b185-44b7-877d-c48a37ea7a35	9d66990a-b2ee-40f3-8198-a610e005fcb1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 08:16:38
18671	9d66990a-b1dc-47dd-bcd1-2cef3d9a4c3d	9d66990a-b2ee-40f3-8198-a610e005fcb1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":478,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:16:38
31037	9d69452d-ff39-411b-a1cb-480375fcd65f	9d69452e-004f-443f-8282-bb7e02f1dfc1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/19","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:09:37
14645	9d5ebef4-c2aa-484f-a705-f53beda1a688	9d5ebef4-c8d4-4a0f-aa4a-3ae5af108918	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":672}	2024-10-30 10:36:01
18591	9d669574-0394-4e1c-a462-426a4672a06a	9d669574-28d1-455c-97ee-26a230886b24	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 08:06:36
18592	9d669574-26d5-4deb-ac9d-6a71aef40997	9d669574-28d1-455c-97ee-26a230886b24	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:06:36
18593	9d669574-2792-439f-9292-1ff8140eb831	9d669574-28d1-455c-97ee-26a230886b24	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":306,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:06:36
31038	9d694561-62f6-46a1-9460-57d254ce2be8	9d694561-66ca-4041-928f-66f6b0d9ec6e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":177,"memory":20,"hostname":"EderCortes"}	2024-11-04 16:10:11
16776	9d64d6bd-35f0-4f2e-b87b-f57b118feb8c	9d64d6bd-5cbd-4676-af24-0e27ffca9c97	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 11:17:30
16777	9d64d6bd-5a9b-4323-9f10-1eb0e31f1ce2	9d64d6bd-5cbd-4676-af24-0e27ffca9c97	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 11:17:30
16778	9d64d6bd-5b61-453b-b9b5-2fd6d6d2b926	9d64d6bd-5cbd-4676-af24-0e27ffca9c97	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":282,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:17:30
22136	9d67425a-ae35-4351-aec4-b515a6fb9d34	9d67425a-e66d-43c2-b93e-33338c7eedb6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-03 16:10:04
22137	9d67425a-e346-449f-859f-d4f2ff74b360	9d67425a-e66d-43c2-b93e-33338c7eedb6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-03 16:10:04
22138	9d67425a-e4cf-4346-b6fe-e3bcdb9c5985	9d67425a-e66d-43c2-b93e-33338c7eedb6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":446,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:10:04
16779	9d64d6bd-adab-4ac4-84f4-94dfdad17943	9d64d6bd-cf56-4d6a-b768-2cc5c6dc202c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 11:17:30
16780	9d64d6bd-c63e-45a6-8825-6b1a77b9e13e	9d64d6bd-cf56-4d6a-b768-2cc5c6dc202c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"49.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 11:17:30
16781	9d64d6bd-c9f7-4f91-85ec-d1cef4a15a39	9d64d6bd-cf56-4d6a-b768-2cc5c6dc202c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 11:17:30
16782	9d64d6bd-ca37-4984-a251-d4d892ec34e8	9d64d6bd-cf56-4d6a-b768-2cc5c6dc202c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 11:17:30
16783	9d64d6bd-ce08-49d9-b89a-9ea4c0ea3417	9d64d6bd-cf56-4d6a-b768-2cc5c6dc202c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 11:17:30
16784	9d64d6bd-ce5c-48ac-88e0-fde38076221d	9d64d6bd-cf56-4d6a-b768-2cc5c6dc202c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:17:30
18594	9d669574-83a1-4b88-97de-ed95f06512d5	9d669574-a18d-4e80-b5e5-5ba1bf9e404d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:06:36
18595	9d669574-9c42-4e15-b9c8-baa4e29f694d	9d669574-a18d-4e80-b5e5-5ba1bf9e404d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"44.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58,"hash":"77f8314368b36a9393ec9c7735a91700","hostname":"EderCortes"}	2024-11-03 08:06:36
18596	9d669574-a00c-44f0-9d32-67ff4bf0514e	9d669574-a18d-4e80-b5e5-5ba1bf9e404d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:06:36
18597	9d669574-a08c-403e-80f8-a6546e18ab77	9d669574-a18d-4e80-b5e5-5ba1bf9e404d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:06:36
22139	9d67425b-80c3-4de3-920a-8d35ab899c26	9d67425b-dd90-45f9-88f1-39f26d6261c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-03 16:10:04
31039	9d694561-cfe0-4232-bd7c-10dbea787de8	9d694562-3030-4026-88e4-d1cac686145d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 16:10:11
16785	9d64d6bf-8a2a-4660-b55d-7959ee542269	9d64d6bf-b65e-422e-85d3-81a7a321ab57	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 11:17:31
16786	9d64d6bf-ace4-4a29-94cd-fc3a31555c66	9d64d6bf-b65e-422e-85d3-81a7a321ab57	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"61.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 11:17:31
16787	9d64d6bf-ad74-4e69-8f33-37e4800ddb1b	9d64d6bf-b65e-422e-85d3-81a7a321ab57	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 11:17:31
16788	9d64d6bf-b415-4aec-a90c-2afa3def3323	9d64d6bf-b65e-422e-85d3-81a7a321ab57	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 11:17:31
16789	9d64d6bf-b4c3-4665-87ea-71c96a741ddb	9d64d6bf-b65e-422e-85d3-81a7a321ab57	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":412,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:17:31
18598	9d669576-8939-406d-9658-941f26e8d85a	9d669576-d2f2-41cc-9255-cee7efecef8c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:06:37
18599	9d669576-cdc8-4107-bafb-babf0cc09b1e	9d669576-d2f2-41cc-9255-cee7efecef8c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"156.00","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 08:06:38
18600	9d669576-ce0e-4a66-8c7b-b71be601ff45	9d669576-d2f2-41cc-9255-cee7efecef8c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 08:06:38
18601	9d669576-d19d-4cf0-a787-81c6ec433313	9d669576-d2f2-41cc-9255-cee7efecef8c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 08:06:38
18602	9d669576-d1e3-411c-93b6-a06bb0454a88	9d669576-d2f2-41cc-9255-cee7efecef8c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":338,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:06:38
22140	9d67425b-cdc3-4f7d-b0b8-924f4906f94c	9d67425b-dd90-45f9-88f1-39f26d6261c2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 68\\n                        ","time":"173.73","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"7d9994d55cb8dde82ff4185920c79043","hostname":"EderCortes"}	2024-11-03 16:10:05
22141	9d67425b-d3a1-4648-9188-f4108ca5fd8f	9d67425b-dd90-45f9-88f1-39f26d6261c2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '68' order by \\"item_loans\\".\\"id\\" asc","time":"3.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 16:10:05
22142	9d67425b-d3f4-4fcf-8635-7d6390507ab1	9d67425b-dd90-45f9-88f1-39f26d6261c2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 16:10:05
22143	9d67425b-db50-40a1-94ea-b73e15f02bd4	9d67425b-dd90-45f9-88f1-39f26d6261c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-03 16:10:05
22144	9d67425b-dbe6-40b4-a711-b3d81396fa20	9d67425b-dd90-45f9-88f1-39f26d6261c2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/68","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":68,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":10000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"1000000","loans_pago_interes":"250000"},"items":[{"id":227,"loans_codigo":68,"itemloans_cuota":"1","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":228,"loans_codigo":68,"itemloans_cuota":"2","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":229,"loans_codigo":68,"itemloans_cuota":"3","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":230,"loans_codigo":68,"itemloans_cuota":"4","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":231,"loans_codigo":68,"itemloans_cuota":"5","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":232,"loans_codigo":68,"itemloans_cuota":"6","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":233,"loans_codigo":68,"itemloans_cuota":"7","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":234,"loans_codigo":68,"itemloans_cuota":"8","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":235,"loans_codigo":68,"itemloans_cuota":"9","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":236,"loans_codigo":68,"itemloans_cuota":"10","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":554,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:10:05
31040	9d694562-1d1a-400f-9476-70fbe537a708	9d694562-3030-4026-88e4-d1cac686145d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"loans_fecha_ultimo_pago\\", \\"loans_intereses_recaudar\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta 2', 'De las nieve', 'ds', 'CC', '1004655468', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon2', 'Calle 7505', '8000009', 25, 15, 'S', null, '04-11-2024', 'Pendiente', '312596295', 12, 14, 19, 14, '04-11-2024', '04-11-2024', 2000002.25, 0, 0, '2024-11-04 16:10:11', '2024-11-04 16:10:11') returning \\"id\\"","time":"5.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":110,"hash":"1942e0e5f2555e71f5f5d75cd5941e3e","hostname":"EderCortes"}	2024-11-04 16:10:11
31041	9d694562-1db1-47ef-86de-2bb39ee1c864	9d694562-3030-4026-88e4-d1cac686145d	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:92","hostname":"EderCortes"}	2024-11-04 16:10:11
31042	9d694562-1f3d-40d7-9487-1f84026efc8b	9d694562-3030-4026-88e4-d1cac686145d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (92, 1, 533333.93333333, 133333.48333333, 'Pendiente', 'N\\/A', '12-11-2024', 12, 0, 0, '2024-11-04 16:10:11', '2024-11-04 16:10:11')","time":"2.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 16:10:11
31043	9d694562-1f6a-430f-b2da-873d458cf4c8	9d694562-3030-4026-88e4-d1cac686145d	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 16:10:11
31044	9d694562-1fda-420e-a8bd-ee6ed819dd8c	9d694562-3030-4026-88e4-d1cac686145d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (92, 2, 533333.93333333, 133333.48333333, 'Pendiente', 'N\\/A', '20-11-2024', 12, 0, 0, '2024-11-04 16:10:11', '2024-11-04 16:10:11')","time":"0.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 16:10:11
31045	9d694562-1ffc-4ec5-b3e4-40ff2b3fc2df	9d694562-3030-4026-88e4-d1cac686145d	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 16:10:11
31046	9d694562-2066-4964-8025-15ba6cf996d6	9d694562-3030-4026-88e4-d1cac686145d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (92, 3, 533333.93333333, 133333.48333333, 'Pendiente', 'N\\/A', '28-11-2024', 12, 0, 0, '2024-11-04 16:10:11', '2024-11-04 16:10:11')","time":"0.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 16:10:11
31047	9d694562-2089-49c4-b4bd-8093be43ef89	9d694562-3030-4026-88e4-d1cac686145d	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 16:10:11
31048	9d694562-20f2-4904-922b-0bdef2b7a9da	9d694562-3030-4026-88e4-d1cac686145d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (92, 4, 533333.93333333, 133333.48333333, 'Pendiente', 'N\\/A', '06-12-2024', 12, 0, 0, '2024-11-04 16:10:11', '2024-11-04 16:10:11')","time":"0.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 16:10:11
31049	9d694562-2117-4b9f-8d3f-7426abbab235	9d694562-3030-4026-88e4-d1cac686145d	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 16:10:11
31050	9d694562-21a2-4b89-96a4-f778d0cc97fb	9d694562-3030-4026-88e4-d1cac686145d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (92, 5, 533333.93333333, 133333.48333333, 'Pendiente', 'N\\/A', '14-12-2024', 12, 0, 0, '2024-11-04 16:10:11', '2024-11-04 16:10:11')","time":"0.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 16:10:11
31051	9d694562-21c9-4bef-b8ec-6dd04a8b3def	9d694562-3030-4026-88e4-d1cac686145d	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 16:10:11
22145	9d67425c-a2d4-417e-84fe-b43f78966225	9d67425d-0080-4dcf-b5d6-07b0573ed76e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-03 16:10:05
22146	9d67425c-f5db-4271-a6b0-4c8090fb82f2	9d67425d-0080-4dcf-b5d6-07b0573ed76e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"162.98","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:10:05
22147	9d67425c-f666-4e1c-8404-fea119333c21	9d67425d-0080-4dcf-b5d6-07b0573ed76e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:10:05
22148	9d67425c-fe69-4548-8caa-a20e0484ea26	9d67425d-0080-4dcf-b5d6-07b0573ed76e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-03 16:10:05
22149	9d67425c-fef2-487d-bc54-d91b907ae1b9	9d67425d-0080-4dcf-b5d6-07b0573ed76e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":714,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:10:05
31052	9d694562-2237-480e-bf75-b9f308cc97bc	9d694562-3030-4026-88e4-d1cac686145d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (92, 6, 533333.93333333, 133333.48333333, 'Pendiente', 'N\\/A', '22-12-2024', 12, 0, 0, '2024-11-04 16:10:11', '2024-11-04 16:10:11')","time":"0.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 16:10:11
31053	9d694562-225f-42d2-9958-d722d3fa765a	9d694562-3030-4026-88e4-d1cac686145d	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 16:10:11
31054	9d694562-22c2-4c6c-a7b1-45cdc6379491	9d694562-3030-4026-88e4-d1cac686145d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (92, 7, 533333.93333333, 133333.48333333, 'Pendiente', 'N\\/A', '30-12-2024', 12, 0, 0, '2024-11-04 16:10:11', '2024-11-04 16:10:11')","time":"0.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 16:10:11
31055	9d694562-22e5-46d4-b872-6a0a46ef207a	9d694562-3030-4026-88e4-d1cac686145d	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 16:10:11
31056	9d694562-2347-44a6-b505-99359b2addd0	9d694562-3030-4026-88e4-d1cac686145d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (92, 8, 533333.93333333, 133333.48333333, 'Pendiente', 'N\\/A', '07-01-2025', 12, 0, 0, '2024-11-04 16:10:11', '2024-11-04 16:10:11')","time":"0.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 16:10:11
31057	9d694562-2369-4a1a-abd5-3d002a5edbde	9d694562-3030-4026-88e4-d1cac686145d	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 16:10:11
31058	9d694562-2423-40b3-85cf-aebab9132bf3	9d694562-3030-4026-88e4-d1cac686145d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (92, 9, 533333.93333333, 133333.48333333, 'Pendiente', 'N\\/A', '15-01-2025', 12, 0, 0, '2024-11-04 16:10:11', '2024-11-04 16:10:11')","time":"1.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 16:10:11
31059	9d694562-2458-4cc9-811b-3a34b19243f5	9d694562-3030-4026-88e4-d1cac686145d	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 16:10:11
31060	9d694562-24eb-4e36-bddb-df17675584d7	9d694562-3030-4026-88e4-d1cac686145d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (92, 10, 533333.93333333, 133333.48333333, 'Pendiente', 'N\\/A', '23-01-2025', 12, 0, 0, '2024-11-04 16:10:11', '2024-11-04 16:10:11')","time":"0.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 16:10:11
31061	9d694562-2514-4146-b3aa-134ee7dd5db4	9d694562-3030-4026-88e4-d1cac686145d	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 16:10:11
22150	9d67425d-8ff8-4d71-8272-e1618af7d3e1	9d67425d-d75b-4846-98f2-2f06af1920da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-03 16:10:06
22151	9d67425d-d2db-4d34-bd9e-f01c84225c6a	9d67425d-d75b-4846-98f2-2f06af1920da	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"151.81","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:10:06
22152	9d67425d-d32b-400f-bd4f-ae760a9146ba	9d67425d-d75b-4846-98f2-2f06af1920da	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:10:06
22153	9d67425d-d618-4414-a2af-60671ea44858	9d67425d-d75b-4846-98f2-2f06af1920da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-03 16:10:06
22154	9d67425d-d65d-44a5-9bd9-8f71303698cd	9d67425d-d75b-4846-98f2-2f06af1920da	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":529,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:10:06
31062	9d694562-258c-44e8-aea0-a517dda45c92	9d694562-3030-4026-88e4-d1cac686145d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (92, 11, 533333.93333333, 133333.48333333, 'Pendiente', 'N\\/A', '31-01-2025', 12, 0, 0, '2024-11-04 16:10:11', '2024-11-04 16:10:11')","time":"0.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 16:10:11
31063	9d694562-25ba-4f5f-9505-c8ac4e8abaa8	9d694562-3030-4026-88e4-d1cac686145d	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 16:10:11
31064	9d694562-264a-4677-9f5b-ded7b7213a07	9d694562-3030-4026-88e4-d1cac686145d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (92, 12, 533333.93333333, 133333.48333333, 'Pendiente', 'N\\/A', '08-02-2025', 12, 0, 0, '2024-11-04 16:10:11', '2024-11-04 16:10:11')","time":"0.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 16:10:11
31065	9d694562-267f-4e76-9dfc-1dc3a18a0c40	9d694562-3030-4026-88e4-d1cac686145d	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 16:10:11
31066	9d694562-2719-4424-a31c-818f0dc5f2b5	9d694562-3030-4026-88e4-d1cac686145d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (92, 13, 533333.93333333, 133333.48333333, 'Pendiente', 'N\\/A', '16-02-2025', 12, 0, 0, '2024-11-04 16:10:11', '2024-11-04 16:10:11')","time":"0.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 16:10:11
31067	9d694562-274c-47cb-a07c-c25b384ce719	9d694562-3030-4026-88e4-d1cac686145d	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 16:10:11
31068	9d694562-27de-4b07-8fa5-c2f016d3a85e	9d694562-3030-4026-88e4-d1cac686145d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (92, 14, 533333.93333333, 133333.48333333, 'Pendiente', 'N\\/A', '24-02-2025', 12, 0, 0, '2024-11-04 16:10:11', '2024-11-04 16:10:11')","time":"0.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 16:10:11
31069	9d694562-2811-40f6-a59e-0984afeee03b	9d694562-3030-4026-88e4-d1cac686145d	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 16:10:11
31070	9d694562-2885-4ba1-91b3-dd3ef190ec33	9d694562-3030-4026-88e4-d1cac686145d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (92, 15, 533333.93333333, 133333.48333333, 'Pendiente', 'N\\/A', '04-03-2025', 12, 0, 0, '2024-11-04 16:10:11', '2024-11-04 16:10:11')","time":"0.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 16:10:11
31071	9d694562-28b4-4e23-8a02-c86ad4bb442b	9d694562-3030-4026-88e4-d1cac686145d	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 16:10:11
31072	9d694562-2e66-4135-b77f-3992d10da4a9	9d694562-3030-4026-88e4-d1cac686145d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:10:11
31073	9d694562-2ecc-4001-92f4-b63cd69e9a57	9d694562-3030-4026-88e4-d1cac686145d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"861","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"1004655468","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_valor_prestado":"8000009","loans_intereses":25,"loans_cuotas":15,"loans_cuando":"S","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":19,"user_recomendacion":14,"loans_inicio_pago":"Mon Nov 04 2024","loans_fecha_ultimo_pago":null,"loans_intereses_recaudar":null,"created_at":null,"updated_at":null,"deleted_at":null,"loans_pago_prestado":0,"loans_pago_interes":0},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Mon Nov 04 2024","aprobador":12}},"session":[],"response_status":200,"response":{"message":"Registro creado exitosamente","id":92},"duration":439,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:10:11
27953	9d68ea80-1818-48a2-b11f-f662474a0a12	9d68ea80-1d49-4eb7-a4fd-d798c9c3e36b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1303}	2024-11-04 11:56:04
31213	9d6946f9-378b-4e7c-a722-26a92cd8cff4	9d6946f9-6581-4e6e-a555-b1a2b7499e49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:14:38
31214	9d6946f9-6324-4f6c-898c-de8515feb139	9d6946f9-6581-4e6e-a555-b1a2b7499e49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:14:38
31215	9d6946f9-6443-4e47-8cfb-561a90c6cd93	9d6946f9-6581-4e6e-a555-b1a2b7499e49	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":421,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:14:38
31074	9d694568-feaa-48fc-b8f7-f353c9c7d878	9d694569-47fe-4381-aace-5532b1253b0c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:10:16
31075	9d694569-4380-445b-bcba-97f3df904aec	9d694569-47fe-4381-aace-5532b1253b0c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"156.34","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 16:10:16
31076	9d694569-467a-487e-ab20-12f1ab0fa026	9d694569-47fe-4381-aace-5532b1253b0c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:10:16
31077	9d694569-46e7-443e-90b9-d15637c48ce6	9d694569-47fe-4381-aace-5532b1253b0c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":434,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:10:16
31216	9d6946fa-0afa-451f-bb01-305f58d29265	9d6946fa-4253-475b-8d2d-c2d3b3f76bcc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:14:39
31217	9d6946fa-310c-4a63-b530-8ef5e1b49ea4	9d6946fa-4253-475b-8d2d-c2d3b3f76bcc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"71.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 16:14:39
31218	9d6946fa-378c-4db0-bdcd-b4ccd336e0ef	9d6946fa-4253-475b-8d2d-c2d3b3f76bcc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '92' order by \\"item_loans\\".\\"id\\" asc","time":"3.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 16:14:39
31219	9d6946fa-37e6-4792-ade6-2f4e57228ccb	9d6946fa-4253-475b-8d2d-c2d3b3f76bcc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":15,"hostname":"EderCortes"}	2024-11-04 16:14:39
31220	9d6946fa-4055-4b80-9b3e-82dcdebd94f8	9d6946fa-4253-475b-8d2d-c2d3b3f76bcc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:14:39
31221	9d6946fa-40ec-4c74-963d-36db8f9f8b39	9d6946fa-4253-475b-8d2d-c2d3b3f76bcc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":92,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":15,"loans_valor_prestado":8000009,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"533333.93333333","loans_pago_interes":"133333.48333333","user_alias":"eder.cortes"},"items":[{"id":379,"loans_codigo":92,"itemloans_cuota":"1","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:13:07.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333"},{"id":380,"loans_codigo":92,"itemloans_cuota":"2","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":381,"loans_codigo":92,"itemloans_cuota":"3","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":382,"loans_codigo":92,"itemloans_cuota":"4","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":383,"loans_codigo":92,"itemloans_cuota":"5","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":384,"loans_codigo":92,"itemloans_cuota":"6","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":385,"loans_codigo":92,"itemloans_cuota":"7","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":386,"loans_codigo":92,"itemloans_cuota":"8","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":387,"loans_codigo":92,"itemloans_cuota":"9","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":388,"loans_codigo":92,"itemloans_cuota":"10","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":389,"loans_codigo":92,"itemloans_cuota":"11","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-31 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":390,"loans_codigo":92,"itemloans_cuota":"12","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":391,"loans_codigo":92,"itemloans_cuota":"13","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-16 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":392,"loans_codigo":92,"itemloans_cuota":"14","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":393,"loans_codigo":92,"itemloans_cuota":"15","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":486,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:14:39
31078	9d69456e-f12c-4e27-9aaf-1b8a8a747d09	9d69456f-1441-43d2-9088-d886f6029ca2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:10:20
31079	9d69456f-0930-4158-8a08-b2a1594f5e3b	9d69456f-1441-43d2-9088-d886f6029ca2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"46.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 16:10:20
31080	9d69456f-0d64-4b17-af36-edd83f2f9ff2	9d69456f-1441-43d2-9088-d886f6029ca2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '92' order by \\"item_loans\\".\\"id\\" asc","time":"2.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 16:10:20
31081	9d69456f-0da3-47b4-a368-ae08b419e15e	9d69456f-1441-43d2-9088-d886f6029ca2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":15,"hostname":"EderCortes"}	2024-11-04 16:10:20
31082	9d69456f-1296-4f3d-a28d-b42120200328	9d69456f-1441-43d2-9088-d886f6029ca2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:10:20
31083	9d69456f-12fb-4ed8-888c-cdd132da6b67	9d69456f-1441-43d2-9088-d886f6029ca2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":92,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":15,"loans_valor_prestado":8000009,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0","user_alias":"eder.cortes"},"items":[{"id":379,"loans_codigo":92,"itemloans_cuota":"1","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":380,"loans_codigo":92,"itemloans_cuota":"2","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":381,"loans_codigo":92,"itemloans_cuota":"3","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":382,"loans_codigo":92,"itemloans_cuota":"4","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":383,"loans_codigo":92,"itemloans_cuota":"5","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":384,"loans_codigo":92,"itemloans_cuota":"6","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":385,"loans_codigo":92,"itemloans_cuota":"7","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":386,"loans_codigo":92,"itemloans_cuota":"8","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":387,"loans_codigo":92,"itemloans_cuota":"9","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":388,"loans_codigo":92,"itemloans_cuota":"10","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":389,"loans_codigo":92,"itemloans_cuota":"11","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-31 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":390,"loans_codigo":92,"itemloans_cuota":"12","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":391,"loans_codigo":92,"itemloans_cuota":"13","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-16 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":392,"loans_codigo":92,"itemloans_cuota":"14","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":393,"loans_codigo":92,"itemloans_cuota":"15","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:10:20
31222	9d6946fb-0745-4448-a3f0-7c815b334bc9	9d6946fb-9da1-4a85-baef-de6c2f5605ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:14:39
31223	9d6946fb-9331-43bc-a877-f24c35e42438	9d6946fb-9da1-4a85-baef-de6c2f5605ee	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"255.12","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:14:40
31224	9d6946fb-93e2-4a5e-85c3-4e4814f0e639	9d6946fb-9da1-4a85-baef-de6c2f5605ee	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:14:40
31225	9d6946fb-9b94-40f9-98d5-a0189020bfe2	9d6946fb-9da1-4a85-baef-de6c2f5605ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:14:40
31226	9d6946fb-9c1e-411e-a6aa-2279a3bf187c	9d6946fb-9da1-4a85-baef-de6c2f5605ee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":852,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:14:40
25669	9d68c7c4-e19c-4d8c-85f7-8cdef8048f75	9d68c7c5-090b-4482-951c-52adcfd853c9	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 10:18:57
25670	9d68c7c5-0717-47fa-a1c0-d5691465bfb5	9d68c7c5-090b-4482-951c-52adcfd853c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:18:57
25671	9d68c7c5-07db-4b2f-b5fc-0c76475104aa	9d68c7c5-090b-4482-951c-52adcfd853c9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":391,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:18:57
26401	9d68d3db-2ab4-46e9-af7d-ab117b6be02f	9d68d3db-2fab-4608-baec-7647974d3e84	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1223}	2024-11-04 10:52:45
31227	9d6946fc-64af-4e03-8a6e-e24dee59654a	9d6946fc-9d76-4a30-852d-f0def5ea913f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:14:40
25763	9d68c8fe-d33e-42d1-ab18-1a33d01b89c0	9d68c8fe-f529-454c-aac9-a58251e014ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:22:23
31228	9d6946fc-9217-40cb-8bdd-30975028db90	9d6946fc-9d76-4a30-852d-f0def5ea913f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"70.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:14:40
31229	9d6946fc-92fd-40bf-a7e0-8fe27d310179	9d6946fc-9d76-4a30-852d-f0def5ea913f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:14:40
31230	9d6946fc-9b1b-4ec2-b06d-31f3856a433a	9d6946fc-9d76-4a30-852d-f0def5ea913f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 16:14:40
25672	9d68c7c5-998a-405d-8264-aa46ba46d1ea	9d68c7c5-ba01-422d-93fa-53ee353198d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:18:57
25673	9d68c7c5-aff6-460f-b486-e97215b0e907	9d68c7c5-ba01-422d-93fa-53ee353198d7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"44.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:18:57
25674	9d68c7c5-b40c-4645-8e8a-47465ac445d5	9d68c7c5-ba01-422d-93fa-53ee353198d7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:18:57
25675	9d68c7c5-b44d-4b8c-9901-e2901239f321	9d68c7c5-ba01-422d-93fa-53ee353198d7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:18:57
25676	9d68c7c5-b8bf-41cb-be2f-3cbd7e846be6	9d68c7c5-ba01-422d-93fa-53ee353198d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:18:57
25677	9d68c7c5-b908-48c2-a43a-e4c395bfc715	9d68c7c5-ba01-422d-93fa-53ee353198d7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":407,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:18:57
25764	9d68c8fe-f382-47fd-b672-1ed9722e6dd1	9d68c8fe-f529-454c-aac9-a58251e014ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:22:23
25765	9d68c8fe-f42f-47c9-9e4e-4917aa0179c0	9d68c8fe-f529-454c-aac9-a58251e014ba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":393,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:22:23
31231	9d6946fc-9bac-4f3b-bb21-95cb05806428	9d6946fc-9d76-4a30-852d-f0def5ea913f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":593,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:14:40
25766	9d68c8ff-8516-45de-8afb-7aaf8bc2b81b	9d68c8ff-d047-4767-9277-e9abbfb69fe2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:22:23
25767	9d68c8ff-c6e9-4769-bffb-e5adba0ab1b7	9d68c8ff-d047-4767-9277-e9abbfb69fe2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"155.12","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:22:23
25768	9d68c8ff-ca6a-41e4-a90f-6b6e22fd1c77	9d68c8ff-d047-4767-9277-e9abbfb69fe2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"1.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:22:23
25769	9d68c8ff-caad-4598-94be-0ac1902f862c	9d68c8ff-d047-4767-9277-e9abbfb69fe2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:22:23
25770	9d68c8ff-cefe-4f81-9766-a14cfacea963	9d68c8ff-d047-4767-9277-e9abbfb69fe2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 10:22:23
25771	9d68c8ff-cf5f-4e62-9953-445e14086249	9d68c8ff-d047-4767-9277-e9abbfb69fe2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":477,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:22:23
31232	9d694705-eb34-4fca-8a79-4bec62a859ac	9d694705-ee56-4050-afdc-a03fb34f8be9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-intereses","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":150,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:14:46
16099	9d64b983-198a-4616-8886-edad6cb03e92	9d64b983-63d0-4a1f-b20e-41b3f6000dba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 09:55:46
16100	9d64b983-61d2-4059-acc1-16958f50a0f7	9d64b983-63d0-4a1f-b20e-41b3f6000dba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 09:55:46
16101	9d64b983-62a7-4a2b-a4bf-89c5705933f1	9d64b983-63d0-4a1f-b20e-41b3f6000dba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":342,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:55:46
25348	9d68c233-2205-4e2f-8a3e-0b6e1eda808d	9d68c233-26fe-4c25-b594-52579d9d1f53	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1156}	2024-11-04 10:03:22
16102	9d64b983-afa6-4399-b76a-28665d260857	9d64b983-cce2-4254-88e4-fa5f5f65eb94	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 09:55:47
16103	9d64b983-c4a6-45e0-98e8-29cbd980a257	9d64b983-cce2-4254-88e4-fa5f5f65eb94	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 22\\n                        ","time":"42.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"f9344e277d181987f84c6dcddcb4342d","hostname":"EderCortes"}	2024-11-02 09:55:47
16104	9d64b983-c81d-4a0a-8d13-994921e71e6f	9d64b983-cce2-4254-88e4-fa5f5f65eb94	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '22' order by \\"item_loans\\".\\"id\\" asc","time":"2.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 09:55:47
16105	9d64b983-c857-46a4-9aac-ce6eb6f8e08f	9d64b983-cce2-4254-88e4-fa5f5f65eb94	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-02 09:55:47
16106	9d64b983-cbcc-48e3-afb7-545797fd8198	9d64b983-cce2-4254-88e4-fa5f5f65eb94	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 09:55:47
16107	9d64b983-cc1a-4638-aac6-618b6bf2ac16	9d64b983-cce2-4254-88e4-fa5f5f65eb94	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/22","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":22,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":6,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"Tue Oct 29 2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":70,"loans_codigo":22,"itemloans_cuota":"1","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":71,"loans_codigo":22,"itemloans_cuota":"2","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":72,"loans_codigo":22,"itemloans_cuota":"3","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-26 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":73,"loans_codigo":22,"itemloans_cuota":"4","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-10-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":74,"loans_codigo":22,"itemloans_cuota":"5","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":75,"loans_codigo":22,"itemloans_cuota":"6","itemloans_valor_cuota":"83333.333333333","itemloans_iteres":"10416.666666667","itemloans_status":"PENDIENTE","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2026-04-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-29T16:26:41.000000Z","updated_at":"2024-10-29T16:26:41.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":224,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:55:47
22238	9d6743a4-1668-4bc6-bc14-538ff07be062	9d6743a4-7873-4262-8199-0f44961517ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-03 16:13:40
22239	9d6743a4-7580-49fb-9c77-4e929c3ea968	9d6743a4-7873-4262-8199-0f44961517ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-03 16:13:40
16108	9d64b985-485d-4d7e-b8fc-4dd0d6f9646c	9d64b985-7dbd-400e-8904-9470024bea71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 09:55:48
16109	9d64b985-75e9-4f1e-a2cc-82aebad73a2d	9d64b985-7dbd-400e-8904-9470024bea71	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"87.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 09:55:48
16110	9d64b985-766e-4e73-9f02-0e48799c92d3	9d64b985-7dbd-400e-8904-9470024bea71	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 09:55:48
16111	9d64b985-7bce-4081-ad52-f0e77e10f508	9d64b985-7dbd-400e-8904-9470024bea71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-02 09:55:48
16112	9d64b985-7c55-48d8-91f4-1eb3d4066b0a	9d64b985-7dbd-400e-8904-9470024bea71	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":355,"memory":22,"hostname":"EderCortes"}	2024-11-02 09:55:48
22240	9d6743a4-76d8-42db-9d79-7572f0313d9d	9d6743a4-7873-4262-8199-0f44961517ca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":579,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:13:40
22241	9d6743a5-03ec-444b-871e-afc5e02241d3	9d6743a5-61f9-41b1-ba33-ff020eacefb2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-03 16:13:40
22242	9d6743a5-4f52-4d0b-b32a-98c7af989dc7	9d6743a5-61f9-41b1-ba33-ff020eacefb2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 68\\n                        ","time":"176.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"7d9994d55cb8dde82ff4185920c79043","hostname":"EderCortes"}	2024-11-03 16:13:40
22243	9d6743a5-570c-45bb-89eb-3cc3595fa935	9d6743a5-61f9-41b1-ba33-ff020eacefb2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '68' order by \\"item_loans\\".\\"id\\" asc","time":"3.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 16:13:41
22244	9d6743a5-5782-4a0f-85e3-9a2ae2a5f171	9d6743a5-61f9-41b1-ba33-ff020eacefb2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 16:13:41
22245	9d6743a5-5fcb-4adc-838b-3796998d63a0	9d6743a5-61f9-41b1-ba33-ff020eacefb2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-03 16:13:41
22246	9d6743a5-6075-4e7e-bfab-0be6a3b1ac93	9d6743a5-61f9-41b1-ba33-ff020eacefb2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/68","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":68,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":10000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"1000000","loans_pago_interes":"250000"},"items":[{"id":227,"loans_codigo":68,"itemloans_cuota":"1","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":228,"loans_codigo":68,"itemloans_cuota":"2","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":229,"loans_codigo":68,"itemloans_cuota":"3","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":230,"loans_codigo":68,"itemloans_cuota":"4","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":231,"loans_codigo":68,"itemloans_cuota":"5","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":232,"loans_codigo":68,"itemloans_cuota":"6","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":233,"loans_codigo":68,"itemloans_cuota":"7","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":234,"loans_codigo":68,"itemloans_cuota":"8","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":235,"loans_codigo":68,"itemloans_cuota":"9","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":236,"loans_codigo":68,"itemloans_cuota":"10","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":522,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:13:41
31240	9d694706-b745-4dba-9c83-b082a80eb511	9d694706-d7b1-48aa-8f40-f696277b7c92	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 16:14:47
31241	9d694706-cd36-4a2e-807b-1fd61f1a2e0f	9d694706-d7b1-48aa-8f40-f696277b7c92	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"41.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 16:14:47
31242	9d694706-d16a-4f0f-9379-125eda6bdcab	9d694706-d7b1-48aa-8f40-f696277b7c92	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '92' order by \\"item_loans\\".\\"id\\" asc","time":"2.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 16:14:47
31243	9d694706-d1a3-4351-a0a1-842e0c1061db	9d694706-d7b1-48aa-8f40-f696277b7c92	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":15,"hostname":"EderCortes"}	2024-11-04 16:14:47
31244	9d694706-d664-4bb9-a734-1234d86844be	9d694706-d7b1-48aa-8f40-f696277b7c92	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 16:14:47
18725	9d6699e8-2ac3-4261-a419-116fccf8c2b8	9d6699e8-7160-4c4c-8be0-decc6df65b5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 08:19:03
18726	9d6699e8-6fa8-447b-ac43-5c7c5cb637b1	9d6699e8-7160-4c4c-8be0-decc6df65b5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 08:19:03
18727	9d6699e8-7044-4094-bc70-2cb161a7c196	9d6699e8-7160-4c4c-8be0-decc6df65b5c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":355,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:19:03
18728	9d6699e8-bc55-44cd-b9e4-d4da0e373e7b	9d6699e8-d9b9-4a61-b0bc-d540827384d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 08:19:03
18729	9d6699e8-d5b2-4766-a7d3-876864af14b2	9d6699e8-d9b9-4a61-b0bc-d540827384d2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"47.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c37ce191b53d9d62ae3ae483cb5ffa40","hostname":"EderCortes"}	2024-11-03 08:19:03
18730	9d6699e8-d87a-49c5-85bf-5c4fdfd73a9b	9d6699e8-d9b9-4a61-b0bc-d540827384d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 08:19:03
18731	9d6699e8-d8ca-47e1-86ca-a67a7b107646	9d6699e8-d9b9-4a61-b0bc-d540827384d2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","frecuencia_pago":"-1","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"6","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"-25","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"6","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"-25","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"-1","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"13","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"13","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"6","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"-3","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"5","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"-25","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"-25","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"-25","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:19:03
22247	9d6743a6-7042-498b-8759-e2ade0b64af2	9d6743a6-c617-4f97-928f-abf677c1e5aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-03 16:13:41
22248	9d6743a6-b9b0-40fa-a031-cd4efd82d12c	9d6743a6-c617-4f97-928f-abf677c1e5aa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"101.24","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:13:41
22249	9d6743a6-ba4a-41c9-b406-8d6d5b169569	9d6743a6-c617-4f97-928f-abf677c1e5aa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:13:41
22250	9d6743a6-c292-4d1d-bedc-b3f2ebe9ed0d	9d6743a6-c617-4f97-928f-abf677c1e5aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-03 16:13:41
22251	9d6743a6-c37b-4f67-b58f-5646131c9142	9d6743a6-c617-4f97-928f-abf677c1e5aa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":877,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:13:41
31245	9d694706-d6b4-4fe1-96c8-59ed8d07c940	9d694706-d7b1-48aa-8f40-f696277b7c92	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":92,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":15,"loans_valor_prestado":8000009,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"533333.93333333","loans_pago_interes":"133333.48333333","user_alias":"eder.cortes"},"items":[{"id":379,"loans_codigo":92,"itemloans_cuota":"1","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:13:07.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333"},{"id":380,"loans_codigo":92,"itemloans_cuota":"2","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":381,"loans_codigo":92,"itemloans_cuota":"3","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":382,"loans_codigo":92,"itemloans_cuota":"4","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":383,"loans_codigo":92,"itemloans_cuota":"5","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":384,"loans_codigo":92,"itemloans_cuota":"6","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":385,"loans_codigo":92,"itemloans_cuota":"7","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":386,"loans_codigo":92,"itemloans_cuota":"8","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":387,"loans_codigo":92,"itemloans_cuota":"9","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":388,"loans_codigo":92,"itemloans_cuota":"10","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":389,"loans_codigo":92,"itemloans_cuota":"11","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-31 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":390,"loans_codigo":92,"itemloans_cuota":"12","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":391,"loans_codigo":92,"itemloans_cuota":"13","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-16 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":392,"loans_codigo":92,"itemloans_cuota":"14","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":393,"loans_codigo":92,"itemloans_cuota":"15","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:14:47
18732	9d6699ea-599f-4d56-ab5a-6a642c393996	9d6699ea-8526-4584-8602-30aac0d6464c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 08:19:04
18733	9d6699ea-7ca4-4f10-bddb-27d982151cf3	9d6699ea-8526-4584-8602-30aac0d6464c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"53.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 08:19:05
18734	9d6699ea-7d03-48f0-915b-95ac8ccfcf7b	9d6699ea-8526-4584-8602-30aac0d6464c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 08:19:05
18735	9d6699ea-8330-491c-a3f0-e3fbad6259a7	9d6699ea-8526-4584-8602-30aac0d6464c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 08:19:05
18736	9d6699ea-83b2-4007-935d-ff92492bfa46	9d6699ea-8526-4584-8602-30aac0d6464c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":445,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:19:05
22252	9d6743a7-36d8-4fa0-a8e7-4006cbee2569	9d6743a7-7dd7-43db-875e-e85aad859639	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-03 16:13:42
22253	9d6743a7-7830-403d-b274-677df3c60eb7	9d6743a7-7dd7-43db-875e-e85aad859639	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"146.68","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:13:42
22254	9d6743a7-788b-4833-883f-56b9bb20576a	9d6743a7-7dd7-43db-875e-e85aad859639	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:13:42
22255	9d6743a7-7c3d-47bf-80a2-e4a32780b57b	9d6743a7-7dd7-43db-875e-e85aad859639	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-03 16:13:42
22256	9d6743a7-7c9a-456d-bdd2-d5b1ab4fd89e	9d6743a7-7dd7-43db-875e-e85aad859639	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":438,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:13:42
22257	9d67440b-687b-4e60-a07a-cb61f743660e	9d67440b-6bb0-4f60-8026-e32c3b21f82f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":165,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:14:47
22034	9d674173-14e3-4d47-bf17-96d9d9fe4f5e	9d674173-5067-40b6-9aba-d08ec0b1e2f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-03 16:07:32
22035	9d674173-4d2e-4676-8854-ed0e17bf3116	9d674173-5067-40b6-9aba-d08ec0b1e2f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-03 16:07:32
22036	9d674173-4f0d-4ab3-8d96-096679be35cc	9d674173-5067-40b6-9aba-d08ec0b1e2f2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":558,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:07:32
22037	9d674173-e799-469c-95e0-f29485cc253c	9d674174-1b7e-46e7-bb7d-6cfd66dd44d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-03 16:07:33
22038	9d674174-0c65-48aa-a093-87997729e920	9d674174-1b7e-46e7-bb7d-6cfd66dd44d6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 68\\n                        ","time":"70.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"7d9994d55cb8dde82ff4185920c79043","hostname":"EderCortes"}	2024-11-03 16:07:33
22039	9d674174-11b0-4579-866c-b70f36a70a22	9d674174-1b7e-46e7-bb7d-6cfd66dd44d6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '68' order by \\"item_loans\\".\\"id\\" asc","time":"2.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 16:07:33
22040	9d674174-1209-40d1-ad95-384835e3ce5f	9d674174-1b7e-46e7-bb7d-6cfd66dd44d6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 16:07:33
22041	9d674174-1984-4b5d-90b2-281d751811a0	9d674174-1b7e-46e7-bb7d-6cfd66dd44d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-03 16:07:33
22042	9d674174-1a31-43ff-b1fe-4613d9dccf24	9d674174-1b7e-46e7-bb7d-6cfd66dd44d6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/68","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":68,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":10000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"1000000","loans_pago_interes":"250000"},"items":[{"id":227,"loans_codigo":68,"itemloans_cuota":"1","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":228,"loans_codigo":68,"itemloans_cuota":"2","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":229,"loans_codigo":68,"itemloans_cuota":"3","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":230,"loans_codigo":68,"itemloans_cuota":"4","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":231,"loans_codigo":68,"itemloans_cuota":"5","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":232,"loans_codigo":68,"itemloans_cuota":"6","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":233,"loans_codigo":68,"itemloans_cuota":"7","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":234,"loans_codigo":68,"itemloans_cuota":"8","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":235,"loans_codigo":68,"itemloans_cuota":"9","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":236,"loans_codigo":68,"itemloans_cuota":"10","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":441,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:07:33
22258	9d67440b-d30e-4626-8803-2d866bbaf3f9	9d67440b-e262-4b07-94cd-beca1654aa3b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 16:14:48
22259	9d67440b-e092-4170-936a-c0da0005c1c8	9d67440b-e262-4b07-94cd-beca1654aa3b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 16:14:48
22260	9d67440b-e0fc-4fa1-8aeb-531ca10fb161	9d67440b-e262-4b07-94cd-beca1654aa3b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"2","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"message":"Realizacion abono","data":[]},"duration":215,"memory":20,"hostname":"EderCortes"}	2024-11-03 16:14:48
22043	9d674174-c973-422c-b1db-ca5eb9bfe79c	9d674175-1bcb-46d0-9f53-16b51dfff6a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-03 16:07:33
22044	9d674175-100d-47b6-96da-9d86ca10ccaf	9d674175-1bcb-46d0-9f53-16b51dfff6a7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"138.54","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:07:33
22045	9d674175-10a3-47a7-ae65-bc17561f5ae1	9d674175-1bcb-46d0-9f53-16b51dfff6a7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:07:33
22046	9d674175-18ac-4534-b4c3-3caa8095a0a7	9d674175-1bcb-46d0-9f53-16b51dfff6a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-03 16:07:33
22047	9d674175-1955-4127-8005-a9d469c450d1	9d674175-1bcb-46d0-9f53-16b51dfff6a7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":618,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:07:33
31386	9d694b8c-ac72-4ee3-be7a-a030eb6d06db	9d694b8d-01e3-4b1b-8c21-74320613d5cc	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 16:27:26
31387	9d694b8c-ffaf-4fa5-a407-9bd107a572c8	9d694b8d-01e3-4b1b-8c21-74320613d5cc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:27:26
31388	9d694b8d-00bb-40b6-beaf-de9bef39e4aa	9d694b8d-01e3-4b1b-8c21-74320613d5cc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":551,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:27:26
22048	9d674175-d546-4388-94f5-924e7c87ef2e	9d674175-fedc-4bdd-b7f0-4d3aace1b8b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-03 16:07:34
22049	9d674175-f742-489e-bd66-92d715724a77	9d674175-fedc-4bdd-b7f0-4d3aace1b8b3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"58.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:07:34
22050	9d674175-f7b8-4e52-94f7-c5f026b95b7a	9d674175-fedc-4bdd-b7f0-4d3aace1b8b3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:07:34
22051	9d674175-fd20-41aa-88d3-991923887b2c	9d674175-fedc-4bdd-b7f0-4d3aace1b8b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-03 16:07:34
22052	9d674175-fd93-41e5-9bcc-aa17018076fc	9d674175-fedc-4bdd-b7f0-4d3aace1b8b3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":521,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:07:34
31389	9d694b8d-6edf-4936-b07b-c3aafc4d0a16	9d694b8d-9050-42c8-837c-939090f1c63f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:27:26
31390	9d694b8d-89e3-4f6b-a750-ea9c13f83edd	9d694b8d-9050-42c8-837c-939090f1c63f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:27:26
31391	9d694b8d-8a3a-4325-be1c-0965122b6a57	9d694b8d-9050-42c8-837c-939090f1c63f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 16:27:26
31392	9d694b8d-8f21-42da-8022-32292a78205d	9d694b8d-9050-42c8-837c-939090f1c63f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:27:26
31393	9d694b8d-8f7c-4325-b0e4-070d6c5e2456	9d694b8d-9050-42c8-837c-939090f1c63f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":305,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:27:26
31394	9d694b8d-db11-4b6f-8030-3db4fd5ef8ab	9d694b8d-f906-43f6-8966-d7597e910048	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:27:27
31395	9d694b8d-f3d8-423c-b6c5-7e48444f6135	9d694b8d-f906-43f6-8966-d7597e910048	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:27:27
31396	9d694b8d-f42b-4e0b-a5fa-565082301162	9d694b8d-f906-43f6-8966-d7597e910048	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 16:27:27
31319	9d694a27-2f11-4b37-bcd6-1f612d497cc9	9d694a27-4cdc-4688-8b1c-24cd490671c6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:23:32
31320	9d694a27-4543-42c3-bd82-95373581e6dc	9d694a27-4cdc-4688-8b1c-24cd490671c6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"42.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 16:23:32
31321	9d694a27-4b48-4ccd-b06f-38042c7a240b	9d694a27-4cdc-4688-8b1c-24cd490671c6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:23:32
31397	9d694b8d-f7e0-4aa2-be4c-f23038095e48	9d694b8d-f906-43f6-8966-d7597e910048	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:27:27
31398	9d694b8d-f827-41f3-b0a3-764ab23b0b4c	9d694b8d-f906-43f6-8966-d7597e910048	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:27:27
31322	9d694a27-4bdf-41d5-9d39-750d6b52c08d	9d694a27-4cdc-4688-8b1c-24cd490671c6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abas\\u00bb\\nLINE 1: select * from \\"item_loans\\".* as \\"users.user_alias\\" inner joi...\\n                                     ^ (Connection: pgsql, SQL: select * from \\"item_loans\\".* as \\"users.user_alias\\" inner join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"loans_codigo\\" = 92 order by \\"item_loans\\".\\"id\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":305,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":273,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:23:32
31323	9d694a29-59d7-40dd-adcd-a3ad5ef2b744	9d694a29-8329-4231-9ef5-b96d037847f3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:23:33
31324	9d694a29-7adc-4f5e-824b-862e3a5a27d4	9d694a29-8329-4231-9ef5-b96d037847f3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"55.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:23:33
31325	9d694a29-7b50-4371-88e4-197f4ef049c7	9d694a29-8329-4231-9ef5-b96d037847f3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:23:33
31326	9d694a29-817c-4525-91e8-4950799fcb0f	9d694a29-8329-4231-9ef5-b96d037847f3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:23:33
31327	9d694a29-81d8-48ec-bc1a-da4c7da50609	9d694a29-8329-4231-9ef5-b96d037847f3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":365,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:23:33
20019	9d66ed49-0796-446d-8cc6-6446f4c314ac	9d66ed49-24f3-414d-9011-efe951d55f8f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:12:12
20020	9d66ed49-2346-4a1f-92c5-05b4fc024aa7	9d66ed49-24f3-414d-9011-efe951d55f8f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:12:12
20021	9d66ed49-23f8-47c7-9e6c-a82f4fa3671b	9d66ed49-24f3-414d-9011-efe951d55f8f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":242,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:12:12
31532	9d694ca7-e2fd-4b7f-925e-cdd2f0389ce4	9d694ca8-2529-426b-a5ed-7222f7f87649	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:30:31
31533	9d694ca8-21e4-4e73-bfab-e6e2c77c44d6	9d694ca8-2529-426b-a5ed-7222f7f87649	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:30:32
31534	9d694ca8-2348-42df-98c8-36559499b3ac	9d694ca8-2529-426b-a5ed-7222f7f87649	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":477,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:30:32
20022	9d66ed49-7b07-4274-87e3-2514cd05172a	9d66ed49-9a81-4351-930d-1fc49768d3cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:12:12
20023	9d66ed49-90ad-4716-848b-421b78b5388b	9d66ed49-9a81-4351-930d-1fc49768d3cf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"43.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:12:12
20024	9d66ed49-949e-4d8f-976c-566bb4610083	9d66ed49-9a81-4351-930d-1fc49768d3cf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:12:12
20025	9d66ed49-94d3-4e0e-8619-1955098fb19d	9d66ed49-9a81-4351-930d-1fc49768d3cf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:12:12
20026	9d66ed49-98c2-47d7-9ea3-f7480050e31a	9d66ed49-9a81-4351-930d-1fc49768d3cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:12:12
20027	9d66ed49-993d-4674-8b9e-8f201a663c28	9d66ed49-9a81-4351-930d-1fc49768d3cf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:12:12
31535	9d694ca8-c695-4fe7-a785-6dd3a17c7822	9d694ca8-f7e9-4fb3-a911-670492fe455a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:30:32
22350	9d674a8a-643a-43a2-9c15-f02c09441f24	9d674a8a-abfc-453f-9193-a8d515d8910e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-03 16:32:57
22351	9d674a8a-a815-41a2-bdc8-f19cbdd237a6	9d674a8a-abfc-453f-9193-a8d515d8910e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-03 16:32:57
22352	9d674a8a-a9b3-4a45-9f47-5a8691a1301a	9d674a8a-abfc-453f-9193-a8d515d8910e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":537,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:32:57
31536	9d694ca8-e9e6-496b-af7f-e100db4466a6	9d694ca8-f7e9-4fb3-a911-670492fe455a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"67.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 16:30:32
31537	9d694ca8-ee85-477f-9ac0-9bccbe0bdcf3	9d694ca8-f7e9-4fb3-a911-670492fe455a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" inner join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '92' order by \\"item_loans\\".\\"id\\" asc","time":"3.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":304,"hash":"ac513f13416666eb3a5127ebc04741a7","hostname":"EderCortes"}	2024-11-04 16:30:32
31538	9d694ca8-f5ab-4bc4-aaba-05b7e3edcfd2	9d694ca8-f7e9-4fb3-a911-670492fe455a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:30:32
20028	9d66ed4b-3b50-4eea-9372-18294fc709a8	9d66ed4b-81db-49ab-8010-50aa27b979f7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:12:13
20029	9d66ed4b-79a0-4484-ad57-b54fd1a7fb78	9d66ed4b-81db-49ab-8010-50aa27b979f7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"123.49","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:12:13
20030	9d66ed4b-7a28-4ad5-8453-3b2722ce387a	9d66ed4b-81db-49ab-8010-50aa27b979f7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:12:13
20031	9d66ed4b-7fe4-4ac9-8e2c-289e019ca26a	9d66ed4b-81db-49ab-8010-50aa27b979f7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:12:13
20032	9d66ed4b-8058-44cf-a6db-b99e619a2eb7	9d66ed4b-81db-49ab-8010-50aa27b979f7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":596,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:12:13
22353	9d674a8b-53c4-4705-91fe-9fe8cedc9296	9d674a8b-8c51-46dc-998c-662e402e607d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-03 16:32:58
22354	9d674a8b-7b16-47bf-a821-f43051650916	9d674a8b-8c51-46dc-998c-662e402e607d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 68\\n                        ","time":"74.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"7d9994d55cb8dde82ff4185920c79043","hostname":"EderCortes"}	2024-11-03 16:32:58
22355	9d674a8b-81da-4177-b0f7-534a8b1895a9	9d674a8b-8c51-46dc-998c-662e402e607d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '68' order by \\"item_loans\\".\\"id\\" asc","time":"3.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 16:32:58
22356	9d674a8b-8233-4228-90b4-847f4d2863d2	9d674a8b-8c51-46dc-998c-662e402e607d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 16:32:58
22357	9d674a8b-89dd-40f3-8cb9-ea67a78b1375	9d674a8b-8c51-46dc-998c-662e402e607d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-03 16:32:58
22358	9d674a8b-8a8b-4a5a-aa34-72bab329f270	9d674a8b-8c51-46dc-998c-662e402e607d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/68","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":68,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":10000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"1000000","loans_pago_interes":"250000"},"items":[{"id":227,"loans_codigo":68,"itemloans_cuota":"1","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":228,"loans_codigo":68,"itemloans_cuota":"2","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":229,"loans_codigo":68,"itemloans_cuota":"3","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":230,"loans_codigo":68,"itemloans_cuota":"4","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":231,"loans_codigo":68,"itemloans_cuota":"5","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":232,"loans_codigo":68,"itemloans_cuota":"6","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":233,"loans_codigo":68,"itemloans_cuota":"7","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":234,"loans_codigo":68,"itemloans_cuota":"8","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":235,"loans_codigo":68,"itemloans_cuota":"9","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":236,"loans_codigo":68,"itemloans_cuota":"10","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":479,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:32:58
22359	9d674a8c-40e2-434f-ab21-82e1e115e584	9d674a8c-8940-42c0-91fd-f21af008d3cb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-03 16:32:58
22360	9d674a8c-7e84-4f52-b925-4da5a78ed5bf	9d674a8c-8940-42c0-91fd-f21af008d3cb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"102.37","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:32:59
22361	9d674a8c-7f3b-4976-b1e5-6e2dd1a75aba	9d674a8c-8940-42c0-91fd-f21af008d3cb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:32:59
22362	9d674a8c-86d6-4a05-a708-4c21f1eaf475	9d674a8c-8940-42c0-91fd-f21af008d3cb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-03 16:32:59
22363	9d674a8c-8780-4ab2-9c97-c0c0888ababb	9d674a8c-8940-42c0-91fd-f21af008d3cb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":619,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:32:59
31539	9d694ca8-f64d-4166-acb5-ac203c162f44	9d694ca8-f7e9-4fb3-a911-670492fe455a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":92,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":15,"loans_valor_prestado":8000009,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"533333.93333333","loans_pago_interes":"133333.48333333","user_alias":"eder.cortes"},"items":[{"id":379,"loans_codigo":92,"itemloans_cuota":"1","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:13:07","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":380,"loans_codigo":92,"itemloans_cuota":"2","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":381,"loans_codigo":92,"itemloans_cuota":"3","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":382,"loans_codigo":92,"itemloans_cuota":"4","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":383,"loans_codigo":92,"itemloans_cuota":"5","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":384,"loans_codigo":92,"itemloans_cuota":"6","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":385,"loans_codigo":92,"itemloans_cuota":"7","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":386,"loans_codigo":92,"itemloans_cuota":"8","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":387,"loans_codigo":92,"itemloans_cuota":"9","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-15 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":388,"loans_codigo":92,"itemloans_cuota":"10","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":389,"loans_codigo":92,"itemloans_cuota":"11","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-31 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":390,"loans_codigo":92,"itemloans_cuota":"12","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":391,"loans_codigo":92,"itemloans_cuota":"13","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-16 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":392,"loans_codigo":92,"itemloans_cuota":"14","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":393,"loans_codigo":92,"itemloans_cuota":"15","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":452,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:30:32
17000	9d6546d3-0aaf-4c62-be7d-a2a501ead72a	9d6546d3-4e18-4cdf-97bf-e9e433f10db2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 16:30:54
17001	9d6546d3-4c66-4df0-99ae-e665b3708c01	9d6546d3-4e18-4cdf-97bf-e9e433f10db2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 16:30:55
17002	9d6546d3-4cf9-4bce-8a6a-9f04da108d5b	9d6546d3-4e18-4cdf-97bf-e9e433f10db2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42P01]: Undefined table: 7 ERROR:  falta una entrada para la tabla \\u00abl\\u00bb en la cl\\u00e1usula FROM\\nLINE 1: select \\"l\\".\\"id\\", \\"loans\\".\\"loans_documento\\", \\"loans\\".\\"loans_n...\\n               ^ (Connection: pgsql, SQL: select \\"l\\".\\"id\\", \\"loans\\".\\"loans_documento\\", \\"loans\\".\\"loans_nombre\\", \\"loans\\".\\"loans_apellido_uno\\", \\"loans\\".\\"loans_fecha\\", \\"loans\\".\\"loans_valor_prestado\\", \\"loans\\".\\"loans_cuotas\\", \\"loans\\".\\"loans_estado\\", \\"loans\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" inner join \\"users\\" as \\"ucl\\" on \\"loans\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"loans\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"loans\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"loans\\".\\"id \\" desc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":42,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":325,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:30:55
21918	9d674108-03b5-4cc1-9674-be2a2db1f276	9d674108-2352-44ad-805c-3a1b9e7bfa76	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 16:06:22
21919	9d674108-21c5-4f0e-b20e-8ecb5a19b210	9d674108-2352-44ad-805c-3a1b9e7bfa76	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 16:06:22
21920	9d674108-225f-4637-9d7b-c64008f331fc	9d674108-2352-44ad-805c-3a1b9e7bfa76	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":307,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:06:22
31540	9d694ca9-d6b5-4582-8c91-5d60696c928f	9d694caa-27db-4b7c-9c39-4b2075ebc777	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:30:33
31541	9d694caa-1b61-4bf5-9e75-b25f08549ade	9d694caa-27db-4b7c-9c39-4b2075ebc777	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"111.17","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:30:33
31542	9d694caa-1c13-4277-855e-20464cf27bd2	9d694caa-27db-4b7c-9c39-4b2075ebc777	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:30:33
31543	9d694caa-256d-46f5-a2ba-38f19a2d99d0	9d694caa-27db-4b7c-9c39-4b2075ebc777	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:30:33
21921	9d674108-7072-411d-bbef-085f6403f613	9d674108-8dc9-4155-b887-9bdb5797a44f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 16:06:22
21922	9d674108-887b-4a56-b199-9d7ec106d0cf	9d674108-8dc9-4155-b887-9bdb5797a44f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 16:06:22
21923	9d674108-88e5-4fde-9a87-20404e24fd67	9d674108-8dc9-4155-b887-9bdb5797a44f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 16:06:22
21924	9d674108-8c4f-4de7-993d-b93c809a4d6a	9d674108-8dc9-4155-b887-9bdb5797a44f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 16:06:22
17562	9d655dc0-69e9-40a6-8508-c164d60d5a96	9d655dc0-c2b2-4982-a67c-36c38cac8361	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 17:35:01
17563	9d655dc0-c052-4a19-9776-e8caec8fcd30	9d655dc0-c2b2-4982-a67c-36c38cac8361	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:35:01
17564	9d655dc0-c14f-4850-acd4-80c1c364ca2e	9d655dc0-c2b2-4982-a67c-36c38cac8361	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":485,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:35:01
21925	9d674108-8c98-4d59-bb8f-b0f08ce04f35	9d674108-8dc9-4155-b887-9bdb5797a44f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":228,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:06:22
22364	9d674a8d-6094-4e2d-836b-9f5b6a3907a4	9d674a8d-9c5c-49f9-8ecd-06c31ebf563e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-03 16:32:59
22365	9d674a8d-9119-4079-aa84-a86554fce5fe	9d674a8d-9c5c-49f9-8ecd-06c31ebf563e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"80.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:32:59
22366	9d674a8d-91ac-4d35-9359-a2438cb0d869	9d674a8d-9c5c-49f9-8ecd-06c31ebf563e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:32:59
22367	9d674a8d-9a0f-474a-9848-45bfcf17683d	9d674a8d-9c5c-49f9-8ecd-06c31ebf563e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-03 16:32:59
22368	9d674a8d-9a98-4fe7-a2e7-47ac19e3a892	9d674a8d-9c5c-49f9-8ecd-06c31ebf563e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":630,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:32:59
31544	9d694caa-25ff-4d1e-aaf7-3ab408dc8674	9d694caa-27db-4b7c-9c39-4b2075ebc777	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":720,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:30:33
17565	9d655dc1-63e9-4784-a5dd-f7365b90e8e7	9d655dc1-86a8-457b-9053-3dfd834a10e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 17:35:02
17566	9d655dc1-8097-4beb-92c5-375c76cc66d7	9d655dc1-86a8-457b-9053-3dfd834a10e5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"54.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":57,"hash":"2cc591e3eaf2792109e07ba331bc077f","hostname":"EderCortes"}	2024-11-02 17:35:02
17567	9d655dc1-8522-486c-a6c9-da5a8228870a	9d655dc1-86a8-457b-9053-3dfd834a10e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:35:02
17568	9d655dc1-8589-4e4b-b67d-d0816c83c696	9d655dc1-86a8-457b-9053-3dfd834a10e5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","recomendador":"Luis andre"}]},"duration":457,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:35:02
21926	9d674108-d2e7-4265-bb98-bc7d45b932f9	9d674108-ef3a-4571-863e-20ba9e73c284	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 16:06:22
21927	9d674108-ea2c-4ac4-9611-2489992204e0	9d674108-ef3a-4571-863e-20ba9e73c284	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"38.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 16:06:22
21928	9d674108-ea87-4786-9dd6-e366c9f546f5	9d674108-ef3a-4571-863e-20ba9e73c284	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-03 16:06:22
21929	9d674108-edf4-474e-adf4-fd54b5d1339a	9d674108-ef3a-4571-863e-20ba9e73c284	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 16:06:22
21930	9d674108-ee3b-4aad-b21a-fd16e6170485	9d674108-ef3a-4571-863e-20ba9e73c284	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:06:22
22369	9d674b9c-f3e5-41ab-9861-9f11f19b6ae2	9d674b9c-f9b3-4deb-8544-973d6b984918	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":218,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:35:57
31545	9d694caa-e2fe-4fff-a5ec-e74767a0f85f	9d694cab-1a3b-49b2-9094-a132f2a0820b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:30:33
31546	9d694cab-0c95-493b-af83-93b6f6c6725c	9d694cab-1a3b-49b2-9094-a132f2a0820b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"71.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:30:34
31547	9d694cab-0d48-443e-b9cf-300cdb883b89	9d694cab-1a3b-49b2-9094-a132f2a0820b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:30:34
31548	9d694cab-15f6-462e-8ebb-ae66f1c27bbb	9d694cab-1a3b-49b2-9094-a132f2a0820b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 16:30:34
17569	9d655dc3-b277-41b5-9db1-0c1cdfbb36d1	9d655dc3-db4d-4e09-9a5f-232f565173ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 17:35:03
17570	9d655dc3-d3f7-433d-8ec0-73dd64f030cc	9d655dc3-db4d-4e09-9a5f-232f565173ba	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"55.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 17:35:03
17571	9d655dc3-d458-4eb1-9e2b-c91e675b0dac	9d655dc3-db4d-4e09-9a5f-232f565173ba	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 17:35:03
17572	9d655dc3-d98f-4e32-9260-e4fc9edec17b	9d655dc3-db4d-4e09-9a5f-232f565173ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:35:03
17573	9d655dc3-da00-4739-b30b-12ec8556b69c	9d655dc3-db4d-4e09-9a5f-232f565173ba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:35:03
22370	9d674b9d-6845-46df-ae75-0f22a2a68b12	9d674b9d-9678-4e39-bd61-f9e82cf1da9b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 16:35:58
22371	9d674b9d-8c32-4a55-b9f5-9e36c6fc1881	9d674b9d-9678-4e39-bd61-f9e82cf1da9b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 68 limit 1","time":"48.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":490,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 16:35:58
22372	9d674b9d-8cb0-47ef-8a5c-7d27a0067498	9d674b9d-9678-4e39-bd61-f9e82cf1da9b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 16:35:58
22373	9d674b9d-9460-4809-816f-910d10d223b7	9d674b9d-9678-4e39-bd61-f9e82cf1da9b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 16:35:58
22374	9d674b9d-9519-4955-9e95-62e96d6cb5c2	9d674b9d-9678-4e39-bd61-f9e82cf1da9b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"37","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"5000000","idLoans":68},"session":[],"response_status":200,"response":{"canceladoHastaLaFecha":1250000,"recaudoTotal":12500000,"interesePesos":2500000,"data":{"id":68,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":10000000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_fecha_ultimo_pago":"03-11-2024","loans_pago_interes":"250000","loans_pago_prestado":"1000000"}},"duration":328,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:35:58
31549	9d694cab-169d-4657-97a3-f4d4896a4821	9d694cab-1a3b-49b2-9094-a132f2a0820b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":575,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:30:34
22375	9d674c0c-5821-4cb4-98e4-f55b389f7c8c	9d674c0c-5c45-4822-ab84-738883586e31	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":237,"memory":20,"hostname":"EderCortes"}	2024-11-03 16:37:10
22376	9d674c0c-cc45-4f87-88c9-9df70cd02c5e	9d674c0c-f60d-4706-9c64-05c8b991a6e1	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 16:37:11
22377	9d674c0c-edef-411f-81dd-71d055d40b5d	9d674c0c-f60d-4706-9c64-05c8b991a6e1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 68 limit 1","time":"43.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":490,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 16:37:11
22378	9d674c0c-ee66-4a2f-b404-d31f1b060101	9d674c0c-f60d-4706-9c64-05c8b991a6e1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 16:37:11
22379	9d674c0c-f3f2-42bf-90be-e32d5657f5f4	9d674c0c-f60d-4706-9c64-05c8b991a6e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 16:37:11
22380	9d674c0c-f473-4dc2-bf8c-f14c02e9051c	9d674c0c-f60d-4706-9c64-05c8b991a6e1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"37","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"5000000","idLoans":68},"session":[],"response_status":200,"response":{"canceladoHastaLaFecha":1250000,"recaudoTotal":12500000,"interesePesos":2500000,"valorAbono":"5000000","data":{"id":68,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":10000000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_fecha_ultimo_pago":"03-11-2024","loans_pago_interes":"250000","loans_pago_prestado":"1000000"}},"duration":320,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:37:11
10425	9d56cf98-c4c9-4daf-8193-1cd204b62628	9d56cf98-c82f-4f3c-8817-6ccc9a024614	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":515}	2024-10-26 11:55:56
22381	9d674c2d-f40c-4f86-a262-4a6a30ee4e7d	9d674c2d-f798-458c-88b0-a8b775a9762a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":185,"memory":20,"hostname":"EderCortes"}	2024-11-03 16:37:32
22382	9d674c2e-5439-40a9-b10d-675e19a5457b	9d674c2e-9a1b-4b27-bfdc-91eabd58f18e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 16:37:32
22383	9d674c2e-9509-44d3-884c-ee5479d68fd4	9d674c2e-9a1b-4b27-bfdc-91eabd58f18e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 68 limit 1","time":"145.90","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":490,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 16:37:33
22384	9d674c2e-9553-4c9f-b737-d739c79869ce	9d674c2e-9a1b-4b27-bfdc-91eabd58f18e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 16:37:33
22385	9d674c2e-98c8-4009-b7a5-9bef7928a844	9d674c2e-9a1b-4b27-bfdc-91eabd58f18e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 16:37:33
22386	9d674c2e-990e-47d2-a2f4-2be3da243a21	9d674c2e-9a1b-4b27-bfdc-91eabd58f18e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"37","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"5000000","idLoans":68},"session":[],"response_status":200,"response":{"canceladoHastaLaFecha":1250000,"recaudoTotal":12500000,"interesePesos":2500000,"valorAbono":5000000,"data":{"id":68,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":10000000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_fecha_ultimo_pago":"03-11-2024","loans_pago_interes":"250000","loans_pago_prestado":"1000000"}},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:37:33
270	9d4f178f-fa10-4aad-bb5f-575cb5271cf0	9d4f1790-6774-472b-b09d-d41fae9c2791	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42P01]: Undefined table: 7 ERROR:  falta una entrada para la tabla \\u00abmenu_name, menu\\u00bb en la cl\\u00e1usula FROM\\nLINE 1: select \\"menu\\".\\"menu_name, menu\\".\\"menu_url\\" from \\"menu\\" inner...\\n               ^ (Connection: pgsql, SQL: select \\"menu\\".\\"menu_name, menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = 1 and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":17}	2024-10-22 15:50:32
22387	9d674daa-0cdf-4ba1-8b25-ccd7844229f2	9d674daa-1144-4948-89f0-3e8d5142d6ea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":206,"memory":20,"hostname":"EderCortes"}	2024-11-03 16:41:41
20194	9d66ef40-f2df-4819-ba02-bdcd76db5efb	9d66ef41-19ea-4b06-8f7a-9b2dfd360f8c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 12:17:42
20195	9d66ef41-181a-44b4-a54e-4ff47ce5ef03	9d66ef41-19ea-4b06-8f7a-9b2dfd360f8c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:17:42
20196	9d66ef41-18d4-4e00-9eca-2472c2a7a7e9	9d66ef41-19ea-4b06-8f7a-9b2dfd360f8c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:17:42
15487	9d5ed335-1203-415d-80b6-2acd9dfd535e	9d5ed335-4c54-4c2d-99de-359fabe98433	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-10-30 11:32:39
15488	9d5ed335-4951-4ac7-911f-d2192f5bd866	9d5ed335-4c54-4c2d-99de-359fabe98433	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-30 11:32:39
15489	9d5ed335-4ac9-437f-928c-b994f6c68413	9d5ed335-4c54-4c2d-99de-359fabe98433	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":434,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:32:39
18877	9d669e69-61bc-47f7-b88e-46a008f71715	9d669e69-878b-44db-b156-9e28c167ad84	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 08:31:39
15490	9d5ed335-e776-4de4-a170-b5b6bbf5ba56	9d5ed336-1580-4706-b6b5-eeffcf0d71e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-10-30 11:32:40
15491	9d5ed336-0740-444e-a744-7ef536bfaa5b	9d5ed336-1580-4706-b6b5-eeffcf0d71e4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"58.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"088d1fdbe045a08c3b0073ef22c7da32","hostname":"EderCortes"}	2024-10-30 11:32:40
15492	9d5ed336-0cce-444e-b727-5b785ae20e2e	9d5ed336-1580-4706-b6b5-eeffcf0d71e4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"3.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":268,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-10-30 11:32:40
15493	9d5ed336-0d23-4219-9eda-bb012bed9da2	9d5ed336-1580-4706-b6b5-eeffcf0d71e4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-10-30 11:32:40
15494	9d5ed336-137b-4f8f-a2d5-82683f426ee1	9d5ed336-1580-4706-b6b5-eeffcf0d71e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-30 11:32:40
15495	9d5ed336-140f-46a9-b9dc-93fc8abe603e	9d5ed336-1580-4706-b6b5-eeffcf0d71e4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null}]}},"duration":455,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:32:40
18878	9d669e69-8559-4455-b9a4-261770037fb2	9d669e69-878b-44db-b156-9e28c167ad84	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:31:39
18879	9d669e69-8651-45c4-9577-081cf0fee507	9d669e69-878b-44db-b156-9e28c167ad84	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":299,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:31:39
20197	9d66ef41-734a-48fa-9ed3-9e280b91f8cf	9d66ef41-9122-43f5-856d-71536e59cf08	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:17:42
20198	9d66ef41-8860-4612-a744-6605b2ef39cb	9d66ef41-9122-43f5-856d-71536e59cf08	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"42.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:17:42
20199	9d66ef41-8bfe-49c9-bdf7-7881b4495e53	9d66ef41-9122-43f5-856d-71536e59cf08	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:17:42
20200	9d66ef41-8c31-4c11-8115-e74dcddc06d9	9d66ef41-9122-43f5-856d-71536e59cf08	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:17:42
20201	9d66ef41-8ffe-434b-b73c-6ee75b4e0be3	9d66ef41-9122-43f5-856d-71536e59cf08	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:17:42
22388	9d674daa-96f6-4ea9-a2be-b60cf58338f3	9d674daa-bc80-4f6b-ad42-1b5a8e60d092	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 16:41:42
22389	9d674daa-b5d9-4189-bb53-58b8e78bcbce	9d674daa-bc80-4f6b-ad42-1b5a8e60d092	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 68 limit 1","time":"42.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":490,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 16:41:42
22390	9d674daa-b64e-4bdc-91a4-c239e437ceac	9d674daa-bc80-4f6b-ad42-1b5a8e60d092	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 16:41:42
22391	9d674daa-baf3-4c11-9073-8adbfa97d111	9d674daa-bc80-4f6b-ad42-1b5a8e60d092	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 16:41:42
15496	9d5ed337-1adb-4c21-94fe-e9623e7771b1	9d5ed337-817c-4248-9124-b5de3aba1fc2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-10-30 11:32:40
15497	9d5ed337-74bf-43ba-be72-c8b920bfefba	9d5ed337-817c-4248-9124-b5de3aba1fc2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"177.93","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 11:32:41
15498	9d5ed337-75a6-4b7d-a216-b4d315f306a6	9d5ed337-817c-4248-9124-b5de3aba1fc2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 11:32:41
15499	9d5ed337-7e41-4665-83b6-19d0fe050c94	9d5ed337-817c-4248-9124-b5de3aba1fc2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-30 11:32:41
15500	9d5ed337-7ee4-435a-9f58-18895e335c46	9d5ed337-817c-4248-9124-b5de3aba1fc2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":911,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:32:41
18880	9d669e69-e3a0-4d83-952c-627348fe1a20	9d669e6a-2b40-43e7-bcee-8bcdb890b95f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:31:39
18881	9d669e6a-266b-4ce4-aee8-5e226408868a	9d669e6a-2b40-43e7-bcee-8bcdb890b95f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"154.76","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 08:31:39
18882	9d669e6a-29e9-4144-a678-e4cbe24342d0	9d669e6a-2b40-43e7-bcee-8bcdb890b95f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:31:39
18883	9d669e6a-2a50-40c2-ac5c-b0739485df6b	9d669e6a-2b40-43e7-bcee-8bcdb890b95f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:31:39
20202	9d66ef41-9041-4aab-b727-fa11dafe0e92	9d66ef41-9122-43f5-856d-71536e59cf08	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":260,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:17:42
15501	9d5ed337-fc17-4af5-9fb7-5c62d704079a	9d5ed338-2088-4c6f-82fc-41b7a75f32ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-10-30 11:32:41
15502	9d5ed338-1b44-4463-9b7a-ba895d793f29	9d5ed338-2088-4c6f-82fc-41b7a75f32ec	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"48.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 11:32:41
15503	9d5ed338-1bad-4f1e-b37f-72b49d4e20da	9d5ed338-2088-4c6f-82fc-41b7a75f32ec	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 11:32:41
15504	9d5ed338-1f61-47e2-87d0-b6b97c75ef22	9d5ed338-2088-4c6f-82fc-41b7a75f32ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-30 11:32:41
15505	9d5ed338-1fac-4bde-82a3-65ce8963684a	9d5ed338-2088-4c6f-82fc-41b7a75f32ec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":380,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:32:41
18884	9d669e6c-a3ed-4fd7-9ef2-aff30732a8ca	9d669e6c-ea7c-4087-b659-6dff53d95e9a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:31:41
18885	9d669e6c-e556-4f83-a82d-d9e570e02ca9	9d669e6c-ea7c-4087-b659-6dff53d95e9a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"146.62","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 08:31:41
18886	9d669e6c-e59f-4ba9-8e9e-525da70a5c0a	9d669e6c-ea7c-4087-b659-6dff53d95e9a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 08:31:41
18887	9d669e6c-e94e-4216-92cb-24fd778e305f	9d669e6c-ea7c-4087-b659-6dff53d95e9a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 08:31:41
18888	9d669e6c-e992-4098-b10a-a9b15f981abd	9d669e6c-ea7c-4087-b659-6dff53d95e9a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":394,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:31:41
20203	9d66ef43-027b-4135-9f9f-a9c2bb0e99dd	9d66ef43-2f20-48a1-94e8-88120529bc03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:17:43
20204	9d66ef43-2484-467f-a147-b59e23dc9140	9d66ef43-2f20-48a1-94e8-88120529bc03	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"53.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:17:43
20205	9d66ef43-2515-49d2-9202-c60379525981	9d66ef43-2f20-48a1-94e8-88120529bc03	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:17:43
20206	9d66ef43-2ca2-4eb2-b1ec-a47e1f6e21a2	9d66ef43-2f20-48a1-94e8-88120529bc03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:17:43
15506	9d5ed338-d9f9-46c0-9949-48712a7ab1b2	9d5ed339-1e8d-4fc5-9c9c-edc197a4a3be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-10-30 11:32:42
15507	9d5ed339-1901-45e0-b5fe-c621cc091511	9d5ed339-1e8d-4fc5-9c9c-edc197a4a3be	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"140.33","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-10-30 11:32:42
15508	9d5ed339-1976-4fdd-9fb2-b7a570d4e00a	9d5ed339-1e8d-4fc5-9c9c-edc197a4a3be	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":7,"hostname":"EderCortes"}	2024-10-30 11:32:42
15509	9d5ed339-1d35-4211-af35-0cc23c25fc13	9d5ed339-1e8d-4fc5-9c9c-edc197a4a3be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-30 11:32:42
15510	9d5ed339-1d82-4446-9113-efbbfb249387	9d5ed339-1e8d-4fc5-9c9c-edc197a4a3be	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamista","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"}]},"duration":331,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:32:42
20207	9d66ef43-2d6f-42f5-ab14-87e5f367a167	9d66ef43-2f20-48a1-94e8-88120529bc03	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":492,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:17:43
22392	9d674daa-bb4b-440e-8dee-7e4e832fcd81	9d674daa-bc80-4f6b-ad42-1b5a8e60d092	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"37","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"5000000","idLoans":68},"session":[],"response_status":200,"response":{"canceladoHastaLaFecha":1250000,"recaudoTotal":12500000,"interesePesos":2500000,"valorAbono":5000000,"valorPorPagar":11250000,"data":{"id":68,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":10000000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_fecha_ultimo_pago":"03-11-2024","loans_pago_interes":"250000","loans_pago_prestado":"1000000"}},"duration":263,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:41:42
25913	9d68cb50-6b02-4db4-aa64-cbbf2261619a	9d68cb50-8840-4403-bb2c-511f1cdfa38e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:28:52
25914	9d68cb50-86bc-41c6-b236-e36edec2acbf	9d68cb50-8840-4403-bb2c-511f1cdfa38e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:28:52
20208	9d66efa2-ac0c-4658-9cb2-2275b349efaa	9d66efa2-d9f1-4660-8641-4f422e1d35e3	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 12:18:46
20209	9d66efa2-d267-41a7-89fd-206f8997c1ed	9d66efa2-d9f1-4660-8641-4f422e1d35e3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"55.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 12:18:46
20210	9d66efa2-d7dd-441b-bb61-5f666d0293ff	9d66efa2-d9f1-4660-8641-4f422e1d35e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:18:46
20211	9d66efa2-d864-4d8e-9747-e0beb87a6d39	9d66efa2-d9f1-4660-8641-4f422e1d35e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":358,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:18:46
22393	9d674e97-05f5-441f-a0ec-14433a9543b0	9d674e97-0abe-4611-b09c-f256b1530720	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":230,"memory":20,"hostname":"EderCortes"}	2024-11-03 16:44:17
25915	9d68cb50-8755-431c-935e-aed8cb61da2d	9d68cb50-8840-4403-bb2c-511f1cdfa38e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":377,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:28:52
22394	9d674e97-9e8f-43d8-81bc-91010c6dca8d	9d674e97-caa7-411d-b862-9eb6c394d7b0	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 16:44:17
22395	9d674e97-c2eb-4e7c-ba2c-9524b0c625c8	9d674e97-caa7-411d-b862-9eb6c394d7b0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 68 limit 1","time":"46.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":490,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 16:44:17
22396	9d674e97-c36d-4520-b216-7ea00eb9bec8	9d674e97-caa7-411d-b862-9eb6c394d7b0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 16:44:17
22397	9d674e97-c8f8-4e94-86fc-996c94f866d7	9d674e97-caa7-411d-b862-9eb6c394d7b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 16:44:17
22398	9d674e97-c95b-43fd-a0cb-62f87873fa48	9d674e97-caa7-411d-b862-9eb6c394d7b0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"38","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"12000000","idLoans":68},"session":[],"response_status":200,"response":{"message":"El valor a abonar supera el valor de la deuda que es actalmente de 11250000"},"duration":316,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:44:17
25916	9d68cb51-020e-403b-9b3f-bfc860d932e0	9d68cb51-1fa0-43a4-92ab-7f7b9439c9f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:28:52
25917	9d68cb51-1788-47ba-bc78-9c8adeb1d644	9d68cb51-1fa0-43a4-92ab-7f7b9439c9f9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"40.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:28:52
25918	9d68cb51-1b03-4484-93d6-d5657cb8c2e1	9d68cb51-1fa0-43a4-92ab-7f7b9439c9f9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:28:52
25919	9d68cb51-1b36-4c40-8cce-976c3a1582b3	9d68cb51-1fa0-43a4-92ab-7f7b9439c9f9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:28:52
25920	9d68cb51-1e6c-462c-b939-aac60eaf0f98	9d68cb51-1fa0-43a4-92ab-7f7b9439c9f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 10:28:52
25921	9d68cb51-1ec9-4b86-bc69-d76ad06860d6	9d68cb51-1fa0-43a4-92ab-7f7b9439c9f9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":342,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:28:52
22399	9d674eb9-80e0-4c07-9877-fca1c625ce9c	9d674eb9-84cf-4e7b-8ce5-75eda97e2488	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":208,"memory":20,"hostname":"EderCortes"}	2024-11-03 16:44:39
31649	9d695388-c844-495c-9f84-11b5b4069cb9	9d695388-ec87-48e7-9314-d2c413cdba68	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 16:49:46
31650	9d695388-ea83-4e66-8380-f54ce79719d3	9d695388-ec87-48e7-9314-d2c413cdba68	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:49:46
31651	9d695388-eb44-4f26-b6b7-32e81365865e	9d695388-ec87-48e7-9314-d2c413cdba68	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":309,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:49:46
22400	9d674eb9-ddef-4d33-a7ec-16475bab9322	9d674eba-23cd-4fcc-adb6-6172ebd464b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 16:44:39
22401	9d674eba-1f45-492d-93f6-aac46b01a5fe	9d674eba-23cd-4fcc-adb6-6172ebd464b2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 68 limit 1","time":"148.60","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":490,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 16:44:40
22402	9d674eba-1f94-44a2-ad0d-5b7c86aaae58	9d674eba-23cd-4fcc-adb6-6172ebd464b2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 16:44:40
22403	9d674eba-22ac-4019-9899-b8417f465fa9	9d674eba-23cd-4fcc-adb6-6172ebd464b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 16:44:40
22404	9d674eba-22eb-4a3d-8824-e91416b23814	9d674eba-23cd-4fcc-adb6-6172ebd464b2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"38","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"12000000","idLoans":68},"session":[],"response_status":200,"response":{"message":"El valor a abonar supera el valor de la deuda que es actalmente de 11250000"},"duration":344,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:44:40
31652	9d695389-5054-477a-a808-ea4ef9eb6f6a	9d695389-6cd6-47dc-8cc4-c231b0b0ff86	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:49:46
31653	9d695389-67d7-4c3e-a185-515084520fd7	9d695389-6cd6-47dc-8cc4-c231b0b0ff86	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"42.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 16:49:46
22518	9d674fcf-626b-432d-9bf5-970db5be8699	9d674fcf-9b7f-47bb-8ce3-4b7151d8dbdb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 16:47:41
22519	9d674fcf-978b-4b6f-8062-e7661d7d7ab4	9d674fcf-9b7f-47bb-8ce3-4b7151d8dbdb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 16:47:41
22520	9d674fcf-993e-405a-9480-de1247f1308f	9d674fcf-9b7f-47bb-8ce3-4b7151d8dbdb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":598,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:47:41
31654	9d695389-6b73-49dc-8e99-d4686b1b27ed	9d695389-6cd6-47dc-8cc4-c231b0b0ff86	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:49:46
31655	9d695389-6be0-48d0-bd2a-3bbe6daf63cf	9d695389-6cd6-47dc-8cc4-c231b0b0ff86	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":272,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:49:46
22405	9d674ec8-a56e-43ab-9604-70c66356245e	9d674ec8-a881-4160-b0af-c0aabb8cf77c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":150,"memory":20,"hostname":"EderCortes"}	2024-11-03 16:44:49
22521	9d674fd0-583f-45e8-9f72-4d6ca781cad6	9d674fd0-bc98-4fcc-99ec-be4e0263c996	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 16:47:42
22522	9d674fd0-a691-4815-8051-9ea1c0b9a993	9d674fd0-bc98-4fcc-99ec-be4e0263c996	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 68\\n                        ","time":"175.50","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"7d9994d55cb8dde82ff4185920c79043","hostname":"EderCortes"}	2024-11-03 16:47:42
22523	9d674fd0-ad7b-49f2-a582-af05330ed196	9d674fd0-bc98-4fcc-99ec-be4e0263c996	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '68' order by \\"item_loans\\".\\"id\\" asc","time":"3.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 16:47:42
22524	9d674fd0-ade7-4783-a77c-38370203c428	9d674fd0-bc98-4fcc-99ec-be4e0263c996	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 16:47:42
22525	9d674fd0-b9f5-46d0-974d-3bcc8cd838e0	9d674fd0-bc98-4fcc-99ec-be4e0263c996	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 16:47:42
22526	9d674fd0-bab0-4195-9378-5036326eb218	9d674fd0-bc98-4fcc-99ec-be4e0263c996	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/68","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":68,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":10000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"1000000","loans_pago_interes":"250000"},"items":[{"id":227,"loans_codigo":68,"itemloans_cuota":"1","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":228,"loans_codigo":68,"itemloans_cuota":"2","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":229,"loans_codigo":68,"itemloans_cuota":"3","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":230,"loans_codigo":68,"itemloans_cuota":"4","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":231,"loans_codigo":68,"itemloans_cuota":"5","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":232,"loans_codigo":68,"itemloans_cuota":"6","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":233,"loans_codigo":68,"itemloans_cuota":"7","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":234,"loans_codigo":68,"itemloans_cuota":"8","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":235,"loans_codigo":68,"itemloans_cuota":"9","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":236,"loans_codigo":68,"itemloans_cuota":"10","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":663,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:47:42
31656	9d69538b-e720-4e2b-85d3-4d8719ff53d9	9d69538c-3e12-4883-a609-072f7c64336c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:49:48
31657	9d69538c-34fa-4f87-8f0b-c63f510577a5	9d69538c-3e12-4883-a609-072f7c64336c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"156.41","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:49:48
31658	9d69538c-3575-4918-ab67-26a8e8a678d5	9d69538c-3e12-4883-a609-072f7c64336c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:49:48
31659	9d69538c-3c11-4a67-a189-adbe1ddfad28	9d69538c-3e12-4883-a609-072f7c64336c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:49:48
31660	9d69538c-3c92-468c-aa4b-a529cdfe5dd6	9d69538c-3e12-4883-a609-072f7c64336c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":525,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:49:48
22406	9d674ec9-5749-47ef-9c27-6c13031cdd45	9d674ec9-9d15-44df-83fc-3b926e6a6f2e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 16:44:50
22407	9d674ec9-9821-4912-ae8b-30e15ae3d83c	9d674ec9-9d15-44df-83fc-3b926e6a6f2e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 68 limit 1","time":"145.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":490,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 16:44:50
22408	9d674ec9-9869-4e9d-8406-c012ad5ecc4c	9d674ec9-9d15-44df-83fc-3b926e6a6f2e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 16:44:50
22409	9d674ec9-9bc1-4eb2-ab36-91f2488c733d	9d674ec9-9d15-44df-83fc-3b926e6a6f2e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 16:44:50
22410	9d674ec9-9c18-4d58-82d4-ca38a9c88ff4	9d674ec9-9d15-44df-83fc-3b926e6a6f2e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"38","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"11000000","idLoans":68},"session":[],"response_status":200,"response":{"canceladoHastaLaFecha":1250000,"recaudoTotal":12500000,"interesePesos":2500000,"valorAbono":11000000,"valorPorPagar":11250000,"data":{"id":68,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":10000000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_fecha_ultimo_pago":"03-11-2024","loans_pago_interes":"250000","loans_pago_prestado":"1000000"}},"duration":321,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:44:50
22527	9d674fd2-03a7-43a6-8a98-a00140672c45	9d674fd3-0533-4a93-92c8-1fd755d4a0d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 16:47:43
22528	9d674fd2-fae3-43a6-9ce8-b9e3199681c4	9d674fd3-0533-4a93-92c8-1fd755d4a0d9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"512.01","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:47:44
22529	9d674fd2-fb7c-41c6-acbb-42b498f57f97	9d674fd3-0533-4a93-92c8-1fd755d4a0d9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:47:44
22530	9d674fd3-0319-42bb-9ca8-6fa507e64eab	9d674fd3-0533-4a93-92c8-1fd755d4a0d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 16:47:44
22531	9d674fd3-03aa-4657-88bf-dffb9927af22	9d674fd3-0533-4a93-92c8-1fd755d4a0d9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1470,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:47:44
31661	9d6953d1-663c-44b4-a5de-c2759095e975	9d6953d1-8eb0-40b6-8fab-ac3e57c5fef6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:50:33
31662	9d6953d1-847e-4bde-89e0-d87955466885	9d6953d1-8eb0-40b6-8fab-ac3e57c5fef6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 91\\n                        ","time":"54.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"9ae30bc69b6b272f3f51ff48e54319f5","hostname":"EderCortes"}	2024-11-04 16:50:33
31663	9d6953d1-8898-4593-bf81-030344ca5295	9d6953d1-8eb0-40b6-8fab-ac3e57c5fef6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '91' order by \\"item_loans\\".\\"id\\" asc","time":"2.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 16:50:33
22411	9d674ef2-78c8-4f52-b435-1b182578591a	9d674ef2-7b8b-4db0-9566-6a5a9d00f845	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":152,"memory":20,"hostname":"EderCortes"}	2024-11-03 16:45:17
22532	9d674fd3-8e38-4afb-a1db-b8b5027d07d7	9d674fd3-e23f-441c-beb8-5693c3985f23	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 16:47:44
22533	9d674fd3-dd2b-4699-ba7c-227446972763	9d674fd3-e23f-441c-beb8-5693c3985f23	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"162.74","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:47:44
22534	9d674fd3-dd85-4bcc-bb19-8cce0edfdfd7	9d674fd3-e23f-441c-beb8-5693c3985f23	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:47:44
22535	9d674fd3-e0db-4199-b0f6-b4de08b234b3	9d674fd3-e23f-441c-beb8-5693c3985f23	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 16:47:44
22536	9d674fd3-e12e-45ef-a04a-54c5240a3b64	9d674fd3-e23f-441c-beb8-5693c3985f23	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":540,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:47:44
31664	9d6953d1-8cbf-44e4-bf5b-2d86236beb4f	9d6953d1-8eb0-40b6-8fab-ac3e57c5fef6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:50:33
31665	9d6953d1-8d4b-49ca-ae33-465fbf858a7d	9d6953d1-8eb0-40b6-8fab-ac3e57c5fef6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/91","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":91,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":8,"loans_valor_prestado":5000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0","user_alias":"eder.cortes"},"items":[{"id":371,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 16:04:19","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":372,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 16:04:19","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":373,"loans_codigo":91,"itemloans_cuota":"3","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 16:04:19","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":374,"loans_codigo":91,"itemloans_cuota":"4","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 16:04:19","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":375,"loans_codigo":91,"itemloans_cuota":"5","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 16:04:19","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":376,"loans_codigo":91,"itemloans_cuota":"6","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 16:04:19","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":377,"loans_codigo":91,"itemloans_cuota":"7","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 16:04:19","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":378,"loans_codigo":91,"itemloans_cuota":"8","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 16:04:19","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":342,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:50:33
22412	9d674ef3-2eca-48c4-889f-559ee6d373af	9d674ef3-51dd-40b2-92e0-7a5a2e5bcd45	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 16:45:17
22413	9d674ef3-4aa6-4a7c-b736-4f2557266d67	9d674ef3-51dd-40b2-92e0-7a5a2e5bcd45	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 68 limit 1","time":"41.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":490,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 16:45:17
22414	9d674ef3-4b25-4070-a33c-2e28224727a7	9d674ef3-51dd-40b2-92e0-7a5a2e5bcd45	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 16:45:17
22415	9d674ef3-506f-45c8-ad62-d28c988f0b8e	9d674ef3-51dd-40b2-92e0-7a5a2e5bcd45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 16:45:17
22416	9d674ef3-50c6-4309-9159-60839f96bc55	9d674ef3-51dd-40b2-92e0-7a5a2e5bcd45	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"37","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"2000000","idLoans":68},"session":[],"response_status":200,"response":{"canceladoHastaLaFecha":1250000,"recaudoTotal":12500000,"interesePesos":2500000,"valorAbono":2000000,"valorPorPagar":11250000,"data":{"id":68,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":10000000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_fecha_ultimo_pago":"03-11-2024","loans_pago_interes":"250000","loans_pago_prestado":"1000000"}},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:45:17
22537	9d67539e-5649-4277-8d4e-6ec827b3ac35	9d67539e-5a3f-40a7-801a-7d9241404cda	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":172,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:58:20
31666	9d6953e2-e24c-43ed-aa3d-72cfd4dbf893	9d6953e3-0172-4b7a-a1de-293285e9152f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:50:45
31667	9d6953e2-fc6e-4bf5-9774-b18ed589fc31	9d6953e3-0172-4b7a-a1de-293285e9152f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"49.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 16:50:45
26033	9d68cd33-a7cd-43fe-8139-df928b52e6a7	9d68cd33-c900-4b8a-8764-116001f01e56	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:34:08
26034	9d68cd33-c6bd-410e-bbab-75a8ef88e640	9d68cd33-c900-4b8a-8764-116001f01e56	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:34:08
26035	9d68cd33-c7ae-4b66-98d8-19b2e8d0ca1a	9d68cd33-c900-4b8a-8764-116001f01e56	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":403,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:34:08
31668	9d6953e2-ffe8-4932-bd88-70edacbe4ae8	9d6953e3-0172-4b7a-a1de-293285e9152f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:50:45
31669	9d6953e3-0061-4723-bf2f-f08295082bd7	9d6953e3-0172-4b7a-a1de-293285e9152f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:50:45
22538	9d67539e-b53e-49a2-92ae-a9345eb0ef5a	9d67539e-d699-4dbc-86e3-b7aaf716edae	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 16:58:21
22539	9d67539e-d042-4ce5-b291-c57b896eddb3	9d67539e-d699-4dbc-86e3-b7aaf716edae	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 68 limit 1","time":"37.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":490,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 16:58:21
22540	9d67539e-d0c7-46f4-bceb-ddbab6648e79	9d67539e-d699-4dbc-86e3-b7aaf716edae	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 16:58:21
22541	9d67539e-d507-4d08-85f0-303ec00cd1a7	9d67539e-d699-4dbc-86e3-b7aaf716edae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 16:58:21
22542	9d67539e-d559-4bda-a88e-25d52107b165	9d67539e-d699-4dbc-86e3-b7aaf716edae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"37","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"5000000","idLoans":68},"session":[],"response_status":200,"response":{"canceladoHastaLaFecha":1250000,"recaudoTotal":12500000,"interesePesos":2500000,"valorAbono":5000000,"valorPorPagar":11250000,"valorSinInteresPorPagar":9000000,"interesPorCancelar":2250000,"data":{"id":68,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":10000000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_fecha_ultimo_pago":"03-11-2024","loans_pago_interes":"250000","loans_pago_prestado":"1000000"}},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:58:21
26036	9d68cd34-553b-4282-afb3-35291b79da27	9d68cd34-7800-4a9e-878e-1d1c2a5d04e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:34:09
26037	9d68cd34-6cc9-4e20-8c16-60245a57d72c	9d68cd34-7800-4a9e-878e-1d1c2a5d04e4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 90\\n                        ","time":"45.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"93c10371e33ace24260de21c3ff3890d","hostname":"EderCortes"}	2024-11-04 10:34:09
26038	9d68cd34-71c2-48c2-83d9-063098bc07e9	9d68cd34-7800-4a9e-878e-1d1c2a5d04e4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"3.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:34:09
26039	9d68cd34-71ff-4c8a-8620-2c611b35d55a	9d68cd34-7800-4a9e-878e-1d1c2a5d04e4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 10:34:09
26040	9d68cd34-7658-4d9e-958f-76c194b08c02	9d68cd34-7800-4a9e-878e-1d1c2a5d04e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 10:34:09
26041	9d68cd34-76c4-4f59-a398-8ae23779cc20	9d68cd34-7800-4a9e-878e-1d1c2a5d04e4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"}]}},"duration":393,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:34:09
31670	9d6953f7-61a4-4ecd-8eaa-c49fc49caf34	9d6953f7-ab5b-4985-9199-3106529c6e16	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 16:50:58
31671	9d6953f7-a59d-4d43-811c-84e4511bfa4e	9d6953f7-ab5b-4985-9199-3106529c6e16	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"150.60","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 16:50:58
31550	9d694edd-ef15-40c0-9f04-f208b66a5a0a	9d694edd-f31a-41aa-9c28-5b2bcd9f759c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1509}	2024-11-04 16:36:42
17778	9d65ad77-d741-44fc-8da9-1b6906239ffd	9d65ad78-8d9b-4402-bfcd-261490c919e5	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 21:17:55
17779	9d65ad78-874e-4414-9b16-69814c226704	9d65ad78-8d9b-4402-bfcd-261490c919e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:17:56
17780	9d65ad78-8a87-42e1-9797-d833b344e4e4	9d65ad78-8d9b-4402-bfcd-261490c919e5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":2042,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:17:56
31672	9d6953f7-a9a4-4bcd-a43b-8a8f0bfed461	9d6953f7-ab5b-4985-9199-3106529c6e16	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:50:58
31673	9d6953f7-aa19-40d9-bbbe-54fab19d2183	9d6953f7-ab5b-4985-9199-3106529c6e16	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":392,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:50:58
17781	9d65ad79-f6a8-497b-b278-71c87f8e4339	9d65ad7a-3350-49c1-8e1f-575d0b483724	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:17:57
17782	9d65ad7a-24dc-41e6-8846-b2868d253ef7	9d65ad7a-3350-49c1-8e1f-575d0b483724	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"77.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58,"hash":"77f8314368b36a9393ec9c7735a91700","hostname":"EderCortes"}	2024-11-02 21:17:57
17783	9d65ad7a-310a-4ff1-8e34-78e0a1f2d53a	9d65ad7a-3350-49c1-8e1f-575d0b483724	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:17:57
17784	9d65ad7a-31a0-4f9c-9e3b-39125093190e	9d65ad7a-3350-49c1-8e1f-575d0b483724	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"14","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-17","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-24","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":781,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:17:57
22543	9d6756d3-22cf-4c83-b2bd-9cc69c51dc15	9d6756d3-2785-46a8-8885-72af6fb782b2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":209,"memory":20,"hostname":"EderCortes"}	2024-11-03 17:07:18
17785	9d65ad7f-10f4-4ae9-8c48-e2adcdc581f0	9d65ad7f-66ea-44d5-ad07-c83e480c2cbe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:18:00
17786	9d65ad7f-5d23-4c25-9d64-448cb6d17329	9d65ad7f-66ea-44d5-ad07-c83e480c2cbe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"158.96","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 21:18:00
17787	9d65ad7f-5d91-4595-9d59-563e262e53d3	9d65ad7f-66ea-44d5-ad07-c83e480c2cbe	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 21:18:00
17788	9d65ad7f-65a5-44f8-9590-157fbb6a9d1f	9d65ad7f-66ea-44d5-ad07-c83e480c2cbe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 21:18:00
17789	9d65ad7f-65f1-4cf6-9fb0-aaf26edee15a	9d65ad7f-66ea-44d5-ad07-c83e480c2cbe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":484,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:18:00
22544	9d6756d3-82fe-43f5-81cd-f94f5ca1288f	9d6756d3-ab90-4f09-ad6f-766d581fa193	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 17:07:18
22545	9d6756d3-a1ed-4563-9ac5-007dec372039	9d6756d3-ab90-4f09-ad6f-766d581fa193	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 68 limit 1","time":"44.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":490,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 17:07:19
22546	9d6756d3-a286-43e0-b6b1-cd733d44e2a4	9d6756d3-ab90-4f09-ad6f-766d581fa193	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 17:07:19
22547	9d6756d3-a998-4a17-82a4-592139f1fd43	9d6756d3-ab90-4f09-ad6f-766d581fa193	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 17:07:19
22548	9d6756d3-aa20-4dc5-ba37-36f2cbbf8249	9d6756d3-ab90-4f09-ad6f-766d581fa193	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"37","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"5000000","idLoans":68},"session":[],"response_status":200,"response":{"canceladoHastaLaFecha":1250000,"recaudoTotal":12500000,"interesePesos":2500000,"valorAbono":5000000,"valorPorPagar":11250000,"valorSinInteresPorPagar":9000000,"interesPorCancelar":2250000,"dividirInteresPorValorPagar":0.2,"dividirCapitalporvalorPagar":0.8,"data":{"id":68,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":10000000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_fecha_ultimo_pago":"03-11-2024","loans_pago_interes":"250000","loans_pago_prestado":"1000000"}},"duration":274,"memory":22,"hostname":"EderCortes"}	2024-11-03 17:07:19
22549	9d6759df-26ae-4e66-8dec-2bdc0fae780c	9d6759df-2c8a-41ea-bb80-42c81041d291	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":239,"memory":20,"hostname":"EderCortes"}	2024-11-03 17:15:49
22550	9d6759df-b8b8-4537-bf49-a806b061a89c	9d6759df-e669-4bb9-887e-c94e7ad019ff	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 17:15:50
22551	9d6759df-dedb-4558-9e36-ee51a3cd9fc0	9d6759df-e669-4bb9-887e-c94e7ad019ff	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 68 limit 1","time":"56.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":490,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 17:15:50
22552	9d6759df-df67-4720-9ec1-4dc193a35a5a	9d6759df-e669-4bb9-887e-c94e7ad019ff	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 17:15:50
22553	9d6759df-e42b-4055-bf17-8d71b74d930c	9d6759df-e669-4bb9-887e-c94e7ad019ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 17:15:50
22554	9d6759df-e493-4e89-b022-f94b1ee848ed	9d6759df-e669-4bb9-887e-c94e7ad019ff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"37","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"5000000","idLoans":68},"session":[],"response_status":200,"response":{"abonoParaCapital":4000000,"abonoParaInteres":1000000},"duration":306,"memory":22,"hostname":"EderCortes"}	2024-11-03 17:15:50
22648	9d67f740-c766-4b9a-bf51-f6f1abccfd34	9d67f740-fcb7-4103-82c4-3cc4756e2d13	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 00:35:54
22649	9d67f740-f9c8-4ed4-833d-f5be1d3041c3	9d67f740-fcb7-4103-82c4-3cc4756e2d13	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 00:35:54
22650	9d67f740-faf1-449c-9ca9-0064aba87761	9d67f740-fcb7-4103-82c4-3cc4756e2d13	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":454,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:35:54
22555	9d675d13-7d29-4a9d-b0dd-1b7dde1089f6	9d675d13-82c6-4ec3-b3a4-c73c805e6f2d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":250,"memory":20,"hostname":"EderCortes"}	2024-11-03 17:24:47
22651	9d67f741-9762-49ff-a2d8-f184a1901521	9d67f741-ce09-487a-8e61-69e860e66e42	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 00:35:54
22652	9d67f741-bdae-44d5-b06f-8f4ebeee3d79	9d67f741-ce09-487a-8e61-69e860e66e42	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 65\\n                        ","time":"68.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6768d7067397538897aacf4d73c43049","hostname":"EderCortes"}	2024-11-04 00:35:54
22653	9d67f741-c31a-4683-be71-0e28783eaa60	9d67f741-ce09-487a-8e61-69e860e66e42	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '65' order by \\"item_loans\\".\\"id\\" asc","time":"2.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 00:35:54
18972	9d66cdf8-fc2b-472c-bbbf-b078120ee706	9d66cdf9-2767-4ce4-8de7-a97bb652a454	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 10:44:38
18973	9d66cdf9-2554-4113-aee8-dcd786ee50cd	9d66cdf9-2767-4ce4-8de7-a97bb652a454	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 10:44:38
18974	9d66cdf9-2615-43ee-a01b-7d455bf2d742	9d66cdf9-2767-4ce4-8de7-a97bb652a454	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":308,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:44:38
22654	9d67f741-c370-42f3-b209-c7b5a8b3f70e	9d67f741-ce09-487a-8e61-69e860e66e42	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 00:35:54
22655	9d67f741-cbaa-4fb4-b046-09c5da250bbe	9d67f741-ce09-487a-8e61-69e860e66e42	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 00:35:54
22656	9d67f741-cc4c-4919-ad93-685b62c92c79	9d67f741-ce09-487a-8e61-69e860e66e42	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/65","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":65,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":3000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-10 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"90000"},"items":[{"id":207,"loans_codigo":65,"itemloans_cuota":"1","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:46:55.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"90000","itemloans_cuota_cancelada":"300000"},{"id":208,"loans_codigo":65,"itemloans_cuota":"2","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":209,"loans_codigo":65,"itemloans_cuota":"3","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":210,"loans_codigo":65,"itemloans_cuota":"4","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":211,"loans_codigo":65,"itemloans_cuota":"5","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":212,"loans_codigo":65,"itemloans_cuota":"6","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":213,"loans_codigo":65,"itemloans_cuota":"7","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":214,"loans_codigo":65,"itemloans_cuota":"8","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":215,"loans_codigo":65,"itemloans_cuota":"9","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":216,"loans_codigo":65,"itemloans_cuota":"10","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-09-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":460,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:35:54
22556	9d675d13-eaa8-48de-845f-53a4ca7cb002	9d675d14-5de0-4efa-a3af-ccf4f744b4f3	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 17:24:47
22557	9d675d14-3ea9-4275-8966-f8caac2bf4c7	9d675d14-5de0-4efa-a3af-ccf4f744b4f3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 68 limit 1","time":"169.77","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":490,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 17:24:48
22558	9d675d14-3fe5-466c-abd8-5ae494a6fd3f	9d675d14-5de0-4efa-a3af-ccf4f744b4f3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 17:24:48
17910	9d65b3fd-4cef-4210-a253-769cc22d7a8d	9d65b3fd-9bce-4e00-be3c-2a777f95c374	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 21:36:09
17911	9d65b3fd-99c3-426b-a401-c50c91084941	9d65b3fd-9bce-4e00-be3c-2a777f95c374	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 21:36:09
17912	9d65b3fd-9aa0-47c2-9c23-e61b08c7097c	9d65b3fd-9bce-4e00-be3c-2a777f95c374	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":420,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:36:09
22559	9d675d14-5826-4f33-8544-de32d106e220	9d675d14-5de0-4efa-a3af-ccf4f744b4f3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 17:24:48
22560	9d675d14-5a10-4738-b440-856c2fd3a165	9d675d14-5de0-4efa-a3af-ccf4f744b4f3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"37","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"5000000","idLoans":68},"session":[],"response_status":200,"response":{"abonoParaCapital":4000000,"abonoParaInteres":1000000,"canceladoHastaLaFecha":1250000,"recaudoTotal":12500000,"interesePesos":2500000,"valorAbono":5000000,"valorPorPagar":11250000,"valorSinInteresPorPagar":9000000,"interesPorCancelar":2250000,"dividirInteresPorValorPagar":0.2,"dividirCapitalporvalorPagar":0.8,"data":{"id":68,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":10000000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_fecha_ultimo_pago":"03-11-2024","loans_pago_interes":"250000","loans_pago_prestado":"1000000"}},"duration":471,"memory":22,"hostname":"EderCortes"}	2024-11-03 17:24:48
22657	9d67f742-ad06-488e-93e4-4ba613902dfd	9d67f742-fac5-4b98-9d03-aa7bc6084768	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 00:35:55
22658	9d67f742-f0e4-4196-84b3-487a1826896b	9d67f742-fac5-4b98-9d03-aa7bc6084768	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"101.06","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 00:35:55
22659	9d67f742-f16f-431e-92d5-65800dafa540	9d67f742-fac5-4b98-9d03-aa7bc6084768	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 00:35:55
22660	9d67f742-f90b-49a5-bff5-cfada24e2719	9d67f742-fac5-4b98-9d03-aa7bc6084768	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 00:35:55
22661	9d67f742-f98d-4bd4-ae1d-3f022bd8e6f7	9d67f742-fac5-4b98-9d03-aa7bc6084768	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":750,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:35:55
17913	9d65b3fe-198d-4ab5-8729-bab68d3b1393	9d65b3fe-41fc-4aaa-84bf-3c48ce89bc43	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 21:36:10
17914	9d65b3fe-367b-4a7b-968f-370966e59785	9d65b3fe-41fc-4aaa-84bf-3c48ce89bc43	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"48.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"2b11ef88578e3c91c11800e110e490df","hostname":"EderCortes"}	2024-11-02 21:36:10
17915	9d65b3fe-3aef-4773-87a2-6b9f020b6218	9d65b3fe-41fc-4aaa-84bf-3c48ce89bc43	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"2.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:36:10
17916	9d65b3fe-3b24-4327-b810-ba42418b4cc2	9d65b3fe-41fc-4aaa-84bf-3c48ce89bc43	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:36:10
17917	9d65b3fe-406a-4e51-849b-d5ff7ffaeeb6	9d65b3fe-41fc-4aaa-84bf-3c48ce89bc43	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:36:10
17918	9d65b3fe-40d9-4060-8400-e28b380284d7	9d65b3fe-41fc-4aaa-84bf-3c48ce89bc43	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":324,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:36:10
18975	9d66cdf9-9c36-4750-8c3a-9a1e9c28b028	9d66cdf9-c27a-413b-a6f8-26424f52a537	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 10:44:39
18976	9d66cdf9-b6ef-4608-bba5-71404153ff90	9d66cdf9-c27a-413b-a6f8-26424f52a537	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"51.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-03 10:44:39
18977	9d66cdf9-bb59-4626-9128-39704675bb74	9d66cdf9-c27a-413b-a6f8-26424f52a537	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 10:44:39
18978	9d66cdf9-bb97-4148-8b9b-5a7d743a3e55	9d66cdf9-c27a-413b-a6f8-26424f52a537	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 10:44:39
18979	9d66cdf9-c128-4f25-b4a6-ac5933cc3eda	9d66cdf9-c27a-413b-a6f8-26424f52a537	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 10:44:39
18980	9d66cdf9-c17e-4762-84aa-94c2847cf2db	9d66cdf9-c27a-413b-a6f8-26424f52a537	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:34:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"}]}},"duration":343,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:44:39
17919	9d65b3ff-f037-45b8-8af5-20836d0af9ae	9d65b400-1e53-4709-a37e-0778fd4408db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:36:11
17920	9d65b400-1761-494e-aff0-dd5f96cc5f97	9d65b400-1e53-4709-a37e-0778fd4408db	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"59.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 21:36:11
17921	9d65b400-1813-4035-94d0-172d3afc64b7	9d65b400-1e53-4709-a37e-0778fd4408db	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 21:36:11
17922	9d65b400-1cd6-4092-81c8-56d6a3ae2203	9d65b400-1e53-4709-a37e-0778fd4408db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:36:11
17923	9d65b400-1d2f-4104-8a9a-8deeb9eda0ee	9d65b400-1e53-4709-a37e-0778fd4408db	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":491,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:36:11
18981	9d66cdfb-6e5b-4d79-939c-85de5c3e06ee	9d66cdfb-b137-4317-86a7-a855605e2857	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 10:44:40
18982	9d66cdfb-ac8a-41b4-bcd4-169fe19c825c	9d66cdfb-b137-4317-86a7-a855605e2857	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"140.48","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 10:44:40
18983	9d66cdfb-acd4-468f-89ea-5df1970b4545	9d66cdfb-b137-4317-86a7-a855605e2857	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 10:44:40
18984	9d66cdfb-b002-40ab-b257-0b4b37a1ea6e	9d66cdfb-b137-4317-86a7-a855605e2857	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 10:44:40
18985	9d66cdfb-b045-44ac-9820-d473776167da	9d66cdfb-b137-4317-86a7-a855605e2857	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":521,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:44:40
22561	9d675da4-e534-4e50-a83e-40bfec006d3e	9d675da5-3d57-4c18-935d-a07913613f7d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 17:26:22
22562	9d675da5-376f-4d3d-b0a6-536ded7af52a	9d675da5-3d57-4c18-935d-a07913613f7d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"158.05","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 17:26:23
22563	9d675da5-3baa-4ad3-98c5-6fcea0261df2	9d675da5-3d57-4c18-935d-a07913613f7d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 17:26:23
22662	9d67f743-95d6-40c1-8baf-7288b9ecfb23	9d67f743-ce3f-4556-a715-08fe4a97979a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 00:35:55
22663	9d67f743-c571-460c-a6a8-3a4b1e55355d	9d67f743-ce3f-4556-a715-08fe4a97979a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"72.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 00:35:56
22664	9d67f743-c5f8-4b89-8396-4e3bb5c46b86	9d67f743-ce3f-4556-a715-08fe4a97979a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 00:35:56
22665	9d67f743-cc8f-43d4-a870-41aaeaaa9771	9d67f743-ce3f-4556-a715-08fe4a97979a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 00:35:56
22564	9d675da5-3c11-416e-8a05-5aeb2e0c1d03	9d675da5-3d57-4c18-935d-a07913613f7d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":565,"memory":22,"hostname":"EderCortes"}	2024-11-03 17:26:23
22666	9d67f743-ccf0-4fbe-ac32-f0594fff055a	9d67f743-ce3f-4556-a715-08fe4a97979a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":518,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:35:56
22565	9d675dd4-92eb-45ac-9f9b-f8349019c31a	9d675dd4-dcdf-4c70-9838-301aabc31b81	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 17:26:54
22566	9d675dd4-d6fd-4115-8753-91645a8cf451	9d675dd4-dcdf-4c70-9838-301aabc31b81	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"154.83","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 17:26:54
22567	9d675dd4-daa0-437c-aade-16b0f834100d	9d675dd4-dcdf-4c70-9838-301aabc31b81	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 17:26:54
22568	9d675dd4-db28-48ff-8e68-d7d4484c5823	9d675dd4-dcdf-4c70-9838-301aabc31b81	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":470,"memory":22,"hostname":"EderCortes"}	2024-11-03 17:26:54
22569	9d675ddc-b5a4-40db-906a-bde49d18b39a	9d675ddc-dc6a-4c4c-8e69-a10831f8ef1d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 17:26:59
20407	9d66f21a-208b-43ab-9789-7f0839e1305a	9d66f21a-40e4-4ec6-9f1a-ee4f5a50ef44	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:25:40
20408	9d66f21a-3eb9-4f90-9e45-6124ed1658a5	9d66f21a-40e4-4ec6-9f1a-ee4f5a50ef44	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:25:40
20409	9d66f21a-3fa0-432a-bf06-14a5e5e3c54a	9d66f21a-40e4-4ec6-9f1a-ee4f5a50ef44	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":260,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:25:40
22570	9d675ddc-d1ab-4784-99f6-7220142c5b8b	9d675ddc-dc6a-4c4c-8e69-a10831f8ef1d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 65\\n                        ","time":"53.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6768d7067397538897aacf4d73c43049","hostname":"EderCortes"}	2024-11-03 17:26:59
22571	9d675ddc-d619-4d7f-b2dd-bd92fcde0726	9d675ddc-dc6a-4c4c-8e69-a10831f8ef1d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '65' order by \\"item_loans\\".\\"id\\" asc","time":"2.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 17:26:59
22572	9d675ddc-d658-4a9a-ae4f-eec845292e91	9d675ddc-dc6a-4c4c-8e69-a10831f8ef1d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 17:26:59
22573	9d675ddc-daab-4133-a39e-344003c44a48	9d675ddc-dc6a-4c4c-8e69-a10831f8ef1d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 17:26:59
20410	9d66f21a-999b-4380-84c6-af05e9fc9875	9d66f21a-bd8d-4761-b7df-133fabba2484	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:25:40
20411	9d66f21a-b1dd-443d-8ef0-93c8153b1b67	9d66f21a-bd8d-4761-b7df-133fabba2484	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"48.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:25:40
20412	9d66f21a-b718-4883-bcfa-6b99dd43256f	9d66f21a-bd8d-4761-b7df-133fabba2484	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:25:40
20413	9d66f21a-b774-4c40-b956-4a5293e37114	9d66f21a-bd8d-4761-b7df-133fabba2484	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:25:40
20414	9d66f21a-bbf9-40b4-a27e-e795b65dc891	9d66f21a-bd8d-4761-b7df-133fabba2484	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:25:40
20415	9d66f21a-bc59-45fc-a3d0-9393aec8d455	9d66f21a-bd8d-4761-b7df-133fabba2484	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":269,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:25:40
22574	9d675ddc-db0a-4b87-9db0-aeca816e512f	9d675ddc-dc6a-4c4c-8e69-a10831f8ef1d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/65","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":65,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":3000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-10 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"90000"},"items":[{"id":207,"loans_codigo":65,"itemloans_cuota":"1","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:46:55.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"90000","itemloans_cuota_cancelada":"300000"},{"id":208,"loans_codigo":65,"itemloans_cuota":"2","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":209,"loans_codigo":65,"itemloans_cuota":"3","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":210,"loans_codigo":65,"itemloans_cuota":"4","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":211,"loans_codigo":65,"itemloans_cuota":"5","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":212,"loans_codigo":65,"itemloans_cuota":"6","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":213,"loans_codigo":65,"itemloans_cuota":"7","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":214,"loans_codigo":65,"itemloans_cuota":"8","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":215,"loans_codigo":65,"itemloans_cuota":"9","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":216,"loans_codigo":65,"itemloans_cuota":"10","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-09-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":285,"memory":22,"hostname":"EderCortes"}	2024-11-03 17:26:59
20416	9d66f21c-7e6a-476b-9553-4f8f8222b5c8	9d66f21c-a9c4-4643-86f2-c59686ee4a6f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:25:41
20417	9d66f21c-a139-48c0-9d98-cf692eecb659	9d66f21c-a9c4-4643-86f2-c59686ee4a6f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"53.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:25:41
20418	9d66f21c-a1a6-4d67-bf21-3071cd86dcf1	9d66f21c-a9c4-4643-86f2-c59686ee4a6f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:25:41
20419	9d66f21c-a6f7-4e22-87d5-242c5089e54e	9d66f21c-a9c4-4643-86f2-c59686ee4a6f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:25:41
20420	9d66f21c-a768-4ad6-8ae0-e6b5b689981c	9d66f21c-a9c4-4643-86f2-c59686ee4a6f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":479,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:25:41
31824	9d6955df-0a23-4e73-b948-03e180d2bdac	9d6955df-d9f5-47f0-86de-c97f4e15459c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 16:56:18
31825	9d6955df-d719-42e0-81e2-b8a7c87b7ea8	9d6955df-d9f5-47f0-86de-c97f4e15459c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:56:18
31826	9d6955df-d872-4ecd-adf5-c7cc5fc44f88	9d6955df-d9f5-47f0-86de-c97f4e15459c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":829,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:56:18
31967	9d6957fe-47e1-471f-9a23-3c088fbd8979	9d6957fe-9dc8-44eb-b1b0-40c60f541e9c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 17:02:14
26194	9d68cef7-b069-48a6-97a6-6b7620fcbcee	9d68cef7-d3d1-4a30-979a-8226e7becd3c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:39:04
26195	9d68cef7-d1f8-425d-89a0-b5413f4ffc85	9d68cef7-d3d1-4a30-979a-8226e7becd3c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:39:05
26196	9d68cef7-d2d9-4837-a3ae-a51744512c59	9d68cef7-d3d1-4a30-979a-8226e7becd3c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":432,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:39:05
31968	9d6957fe-9b57-47f0-b208-d847fe6e317a	9d6957fe-9dc8-44eb-b1b0-40c60f541e9c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 17:02:14
31969	9d6957fe-9c6d-4de6-9f54-0679cb78beac	9d6957fe-9dc8-44eb-b1b0-40c60f541e9c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":433,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:02:14
31827	9d6955e0-6bd8-4575-a381-25ab2581cf3f	9d6955e0-6f09-4238-b341-a2ca8ec41809	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":null,"middleware":[],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":404,"response":{"error":"No se encontro la url especificada","code":404},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:56:18
26197	9d68cef8-64ce-45e5-a01c-e80d9254a6cb	9d68cef8-88c7-4fdc-9d05-2734d7d7df01	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:39:05
26198	9d68cef8-7f7a-4dd0-94f5-d5ae4740d31b	9d68cef8-88c7-4fdc-9d05-2734d7d7df01	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"55.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 10:39:05
26199	9d68cef8-8317-4d3c-a8dc-b8809b8c6c2c	9d68cef8-88c7-4fdc-9d05-2734d7d7df01	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:39:05
26200	9d68cef8-834d-41b2-ad3f-06b14580c7ff	9d68cef8-88c7-4fdc-9d05-2734d7d7df01	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:39:05
26201	9d68cef8-8776-4faa-9ef7-2b955e6e88f6	9d68cef8-88c7-4fdc-9d05-2734d7d7df01	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 10:39:05
26202	9d68cef8-87d5-426e-9b41-a4d2024368ae	9d68cef8-88c7-4fdc-9d05-2734d7d7df01	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"240000","loans_pago_interes":"60000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":412,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:39:05
31828	9d6955e1-01bd-4192-b6e1-1a9962800ab0	9d6955e1-2339-4e81-8bff-3ad620ffbb3c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:56:19
31829	9d6955e1-1d36-4e56-b5da-98e71eaea1bb	9d6955e1-2339-4e81-8bff-3ad620ffbb3c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:56:19
31830	9d6955e1-1d8f-4139-aba3-07beadb08ebc	9d6955e1-2339-4e81-8bff-3ad620ffbb3c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 16:56:19
31831	9d6955e1-21c5-4b85-a952-cf7830699d83	9d6955e1-2339-4e81-8bff-3ad620ffbb3c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:56:19
31832	9d6955e1-220a-457f-8a9d-a6085f56ac7f	9d6955e1-2339-4e81-8bff-3ad620ffbb3c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:56:19
31970	9d6957ff-0ee0-4207-b185-e3a978f628eb	9d6957ff-3480-4d8d-89cf-85fd68fc36e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 17:02:14
31971	9d6957ff-2e10-4375-84a6-8557d36da361	9d6957ff-3480-4d8d-89cf-85fd68fc36e4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"50.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":227,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 17:02:14
31972	9d6957ff-2e6d-42ba-80a8-26c8bb6cb2d2	9d6957ff-3480-4d8d-89cf-85fd68fc36e4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 17:02:14
31973	9d6957ff-333c-45d5-b25b-2a05052d3fa6	9d6957ff-3480-4d8d-89cf-85fd68fc36e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 17:02:14
31974	9d6957ff-3386-44fa-b4c6-c73b0c0200fc	9d6957ff-3480-4d8d-89cf-85fd68fc36e4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:02:14
31975	9d6957ff-8451-4022-93a5-8aae07d1acfe	9d6957ff-cf4f-48b7-9b51-6d58bc3915dc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 17:02:14
31976	9d6957ff-c955-429e-93b2-7e2beba47154	9d6957ff-cf4f-48b7-9b51-6d58bc3915dc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"149.02","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":216,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 17:02:15
31977	9d6957ff-c9b3-4a94-a29d-4d23dacb223d	9d6957ff-cf4f-48b7-9b51-6d58bc3915dc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":3,"hostname":"EderCortes"}	2024-11-04 17:02:15
31978	9d6957ff-cdc2-44a8-94e7-1d95a3916e37	9d6957ff-cf4f-48b7-9b51-6d58bc3915dc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 17:02:15
31979	9d6957ff-ce30-41ee-b577-272e6e9e1a29	9d6957ff-cf4f-48b7-9b51-6d58bc3915dc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":382,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:02:15
26302	9d68d208-3197-4afc-b83a-d290c5dfdf6b	9d68d208-5b0c-4fa3-a51b-0627cd11c732	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 10:47:39
26303	9d68d208-588a-408a-a948-2e081f180382	9d68d208-5b0c-4fa3-a51b-0627cd11c732	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:47:39
26304	9d68d208-599c-480d-b883-c284ac62cec6	9d68d208-5b0c-4fa3-a51b-0627cd11c732	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":490,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:47:39
31980	9d695800-1ffc-40e0-aaca-3a381d65c0e1	9d695800-41af-4a49-9df1-f5d43f51beeb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 17:02:15
31981	9d695800-3bce-45c8-8872-4b7c902cd3d4	9d695800-41af-4a49-9df1-f5d43f51beeb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 17:02:15
31982	9d695800-3c2b-40e2-a579-3a2b8e517c52	9d695800-41af-4a49-9df1-f5d43f51beeb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 17:02:15
31983	9d695800-4065-46af-9875-888ddef56111	9d695800-41af-4a49-9df1-f5d43f51beeb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 17:02:15
26305	9d68d208-f9f5-4139-acfb-0bb20a01cd6c	9d68d209-22ea-4a7b-9160-8ebcb62d9c52	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:47:39
26306	9d68d209-14de-414a-bbe4-5b48bed03add	9d68d209-22ea-4a7b-9160-8ebcb62d9c52	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"53.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 10:47:39
26307	9d68d209-1a8e-4519-af53-9446e0f83a5c	9d68d209-22ea-4a7b-9160-8ebcb62d9c52	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"3.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:47:39
26308	9d68d209-1ada-4d05-9099-a2a1f63dddd6	9d68d209-22ea-4a7b-9160-8ebcb62d9c52	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:47:39
26309	9d68d209-218f-4b92-8caa-aade6318b68c	9d68d209-22ea-4a7b-9160-8ebcb62d9c52	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:47:39
26310	9d68d209-21ed-45aa-90a7-a094afaaf55e	9d68d209-22ea-4a7b-9160-8ebcb62d9c52	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":453,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:47:39
31984	9d695800-40b2-4bf2-9f93-91b28b3515fe	9d695800-41af-4a49-9df1-f5d43f51beeb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":277,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:02:15
31985	9d695802-af68-4b6c-ac23-e85e196a36dd	9d695803-1ff1-4e96-817e-56cc1778cd05	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 17:02:16
31986	9d695803-170e-4427-a92b-aeeda315adfb	9d695803-1ff1-4e96-817e-56cc1778cd05	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"221.15","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 17:02:17
31987	9d695803-1792-4877-8639-8ff6934d9792	9d695803-1ff1-4e96-817e-56cc1778cd05	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 17:02:17
31988	9d695803-1e05-410f-bdcf-4095f89acd0d	9d695803-1ff1-4e96-817e-56cc1778cd05	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 17:02:17
31989	9d695803-1e8f-4228-bb30-1dfe92d7592c	9d695803-1ff1-4e96-817e-56cc1778cd05	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":567,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:02:17
32105	9d695cab-598e-4260-a952-bd63e4082bae	9d695cab-78f8-43db-b484-1766abb9c15b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 17:15:18
32106	9d695cab-774d-45ee-a980-959519a81b79	9d695cab-78f8-43db-b484-1766abb9c15b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 17:15:18
20512	9d66f473-2b3f-4f20-848f-9f4d29d41d59	9d66f473-70de-447f-b6d2-17d8eada083c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:32:14
20513	9d66f473-6f57-4b0a-bcce-cc7100be4f54	9d66f473-70de-447f-b6d2-17d8eada083c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:32:14
20514	9d66f473-6fea-4f6b-875e-87890c20f2e7	9d66f473-70de-447f-b6d2-17d8eada083c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:32:14
32107	9d695cab-77ed-44c5-b462-9da4603d6368	9d695cab-78f8-43db-b484-1766abb9c15b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":279,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:15:18
15226	9d5ecf4d-d376-4393-ab73-e268d012b4f1	9d5ecf4e-1bac-468d-8076-96f041d897ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-10-30 11:21:44
15227	9d5ecf4e-1999-4d31-b433-29f5ae80c67e	9d5ecf4e-1bac-468d-8076-96f041d897ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-30 11:21:44
15228	9d5ecf4e-1aaa-4e7d-a2f7-4b7a57c88601	9d5ecf4e-1bac-468d-8076-96f041d897ca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":407,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:21:44
32108	9d695cbb-08ac-494f-8bcf-a021112d84d4	9d695cbb-0bea-4dc3-b5f1-7fc5137edd92	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":153,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:15:28
20515	9d66f473-ba1a-4f55-9b48-df9bed125700	9d66f474-0327-4bf2-b6db-2c9c099c0323	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:32:14
20516	9d66f473-faae-483f-84e9-2ed45046c838	9d66f474-0327-4bf2-b6db-2c9c099c0323	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"152.71","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:32:14
20517	9d66f473-fe30-41b3-b03d-34736b627aa8	9d66f474-0327-4bf2-b6db-2c9c099c0323	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:32:14
20518	9d66f473-fe6b-4219-b8c0-0db84afa0c45	9d66f474-0327-4bf2-b6db-2c9c099c0323	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:32:14
20519	9d66f474-0205-445d-a0ea-edb31ab8f745	9d66f474-0327-4bf2-b6db-2c9c099c0323	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:32:14
20520	9d66f474-024e-49b9-9660-8b82992f7d44	9d66f474-0327-4bf2-b6db-2c9c099c0323	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":332,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:32:14
32109	9d695cbb-cc25-4e2c-823b-c0a63c067d3d	9d695cbd-7efe-4811-8593-5fab0a8e83fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 17:15:29
32110	9d695cbd-58bc-4b4a-8034-4bfbbd050cf3	9d695cbd-7efe-4811-8593-5fab0a8e83fb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"148.68","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-04 17:15:30
32111	9d695cbd-594c-4a42-a511-f253594550ac	9d695cbd-7efe-4811-8593-5fab0a8e83fb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 17:15:30
32112	9d695cbd-7daa-454c-be10-6a91858d67d8	9d695cbd-7efe-4811-8593-5fab0a8e83fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 17:15:30
32113	9d695cbd-7df7-4654-9047-07fc70a2785c	9d695cbd-7efe-4811-8593-5fab0a8e83fb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","profile":1},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":1292,"memory":24,"hostname":"EderCortes"}	2024-11-04 17:15:30
20521	9d66f475-db72-4c19-8499-8ed5938547d7	9d66f476-044d-45e0-a280-a7dc47e4f6a3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:32:15
20522	9d66f475-f9f4-4fcd-8742-a4a9eb3df02b	9d66f476-044d-45e0-a280-a7dc47e4f6a3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"52.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:32:15
20523	9d66f475-fa6c-4b01-b151-ec356887e88a	9d66f476-044d-45e0-a280-a7dc47e4f6a3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:32:15
20524	9d66f476-023a-4f08-bada-68f23c1a7485	9d66f476-044d-45e0-a280-a7dc47e4f6a3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:32:15
20525	9d66f476-02b3-4b56-b478-0b555243f758	9d66f476-044d-45e0-a280-a7dc47e4f6a3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":355,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:32:15
32114	9d695cbd-dc0c-432b-a32e-476c35867c01	9d695cbe-2608-407a-b76e-5b0ecd347605	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 17:15:30
32115	9d695cbe-20f7-4afd-ac1f-b0e325d58686	9d695cbe-2608-407a-b76e-5b0ecd347605	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"154.15","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 17:15:30
32116	9d695cbe-2158-4be9-962e-a7dc03d39bf2	9d695cbe-2608-407a-b76e-5b0ecd347605	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 17:15:30
32117	9d695cbe-24c7-4d18-a169-8077752b6735	9d695cbe-2608-407a-b76e-5b0ecd347605	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 17:15:30
32118	9d695cbe-2511-457e-9337-c81b6d599375	9d695cbe-2608-407a-b76e-5b0ecd347605	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":368,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:15:30
20526	9d66f573-e292-4d97-976b-0503292fda7a	9d66f573-e64e-470e-ad36-da45a2b9a577	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":167,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:35:02
32119	9d695cd1-8211-4646-9b92-1e78431ce97e	9d695cd1-a286-47c8-aae9-d3c9afee84ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 17:15:43
32120	9d695cd1-9ca3-40df-9c96-990ecaa8e249	9d695cd1-a286-47c8-aae9-d3c9afee84ea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"41.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":19,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-04 17:15:43
32121	9d695cd1-9d00-4825-90bb-e6fae1c8b1b5	9d695cd1-a286-47c8-aae9-d3c9afee84ea	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":5,"hostname":"EderCortes"}	2024-11-04 17:15:43
32122	9d695cd1-a110-4832-a706-664f192b2915	9d695cd1-a286-47c8-aae9-d3c9afee84ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 17:15:43
32123	9d695cd1-a175-4fdb-9a38-7dd965574590	9d695cd1-a286-47c8-aae9-d3c9afee84ea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:55:01.000000Z","deleted_at":null,"user_alias":"eder.cortes"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:15:43
32124	9d695ce6-ca33-47e2-8790-57e4fd98267b	9d695ce6-eb34-4e44-af9d-2ad4db4cc043	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 17:15:57
32125	9d695ce6-e2f4-41ad-8417-2d001237b59f	9d695ce6-eb34-4e44-af9d-2ad4db4cc043	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"41.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":19,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-04 17:15:57
32126	9d695ce6-e5d5-455c-8ace-8a1f13ffba54	9d695ce6-eb34-4e44-af9d-2ad4db4cc043	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":5,"hostname":"EderCortes"}	2024-11-04 17:15:57
32127	9d695ce6-e9e2-4f89-a921-d6af15b838a4	9d695ce6-eb34-4e44-af9d-2ad4db4cc043	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 17:15:57
32128	9d695ce6-ea31-4bbb-892f-0a32819f3390	9d695ce6-eb34-4e44-af9d-2ad4db4cc043	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:55:01.000000Z","deleted_at":null,"user_alias":"eder.cortes"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":281,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:15:57
20534	9d66f574-e3ec-433f-b054-147b989e895a	9d66f575-0431-4b91-84e7-7c64d6cbf392	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:35:03
20535	9d66f574-fb5b-4259-a945-7f4dea4e6fcc	9d66f575-0431-4b91-84e7-7c64d6cbf392	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"43.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:35:03
20536	9d66f574-fedb-4ae4-b850-e85689a3f332	9d66f575-0431-4b91-84e7-7c64d6cbf392	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"1.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:35:03
20537	9d66f574-ff0f-49bb-8eb9-7b436d37a947	9d66f575-0431-4b91-84e7-7c64d6cbf392	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:35:03
20538	9d66f575-02ec-40d4-a30f-7b71165fb67d	9d66f575-0431-4b91-84e7-7c64d6cbf392	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:35:03
20539	9d66f575-033b-404a-a8f2-8108414af284	9d66f575-0431-4b91-84e7-7c64d6cbf392	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":289,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:35:03
32129	9d695cf0-5557-486c-802e-0df981d1dbe8	9d695cf0-a016-4c6b-8003-ec1d45e3ba78	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 17:16:03
32130	9d695cf0-9a27-4fb1-9e73-2f2165a3a297	9d695cf0-a016-4c6b-8003-ec1d45e3ba78	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '22' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"152.74","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":74,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 17:16:03
32131	9d695cf0-9a78-4208-8943-62ec67466bac	9d695cf0-a016-4c6b-8003-ec1d45e3ba78	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 17:16:03
32132	9d695cf0-9eb8-4200-aa27-194ba2c784c2	9d695cf0-a016-4c6b-8003-ec1d45e3ba78	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 17:16:04
32133	9d695cf0-9f0c-4fc3-a58c-27e8984acdf7	9d695cf0-a016-4c6b-8003-ec1d45e3ba78	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/22","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:04
20540	9d66f580-4ead-49c1-995a-ea63bba15828	9d66f580-5152-426a-b7f2-60b53e0948f1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":127,"memory":20,"hostname":"EderCortes"}	2024-11-03 12:35:10
32134	9d695d11-679b-480f-9509-5afc5f532c02	9d695d11-8d0d-41f3-9e6f-3c0ccb105891	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 17:16:25
26422	9d68d3e9-0529-4fb4-b395-bbe35487feae	9d68d3e9-22e9-4f06-9888-811159a7103d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:52:54
26423	9d68d3e9-214a-4d72-809e-d97b3f719858	9d68d3e9-22e9-4f06-9888-811159a7103d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:52:54
26424	9d68d3e9-21e0-46b8-a328-045d809d3e94	9d68d3e9-22e9-4f06-9888-811159a7103d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":355,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:52:54
32135	9d695d11-85be-46b7-ad54-10ff818d4699	9d695d11-8d0d-41f3-9e6f-3c0ccb105891	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"47.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 17:16:25
32136	9d695d11-8af9-416a-8ffb-e426d2a2682b	9d695d11-8d0d-41f3-9e6f-3c0ccb105891	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 17:16:25
26502	9d68d71c-8fa2-4499-8c66-811cdcb204dd	9d68d71c-e0ce-4ce2-8ae3-182fea4b7aae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:01:51
26503	9d68d71c-df22-4756-a199-dcb947b815e3	9d68d71c-e0ce-4ce2-8ae3-182fea4b7aae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:01:51
26504	9d68d71c-dfc6-4f22-89ce-7f3ca38458a3	9d68d71c-e0ce-4ce2-8ae3-182fea4b7aae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":531,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:01:51
32137	9d695d11-8ba0-4109-81c7-cb259dce551b	9d695d11-8d0d-41f3-9e6f-3c0ccb105891	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":276,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:25
26425	9d68d3e9-9d07-408e-9bd6-33e4455459d4	9d68d3e9-e3da-40f9-9ee1-5582fa92d267	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:52:54
26426	9d68d3e9-da9b-4637-9fd7-909fe8918607	9d68d3e9-e3da-40f9-9ee1-5582fa92d267	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"146.59","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 10:52:54
26427	9d68d3e9-de29-415c-9270-675feebbbcf2	9d68d3e9-e3da-40f9-9ee1-5582fa92d267	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:52:54
26428	9d68d3e9-de65-4975-94c1-465a03c86aad	9d68d3e9-e3da-40f9-9ee1-5582fa92d267	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:52:54
26429	9d68d3e9-e28a-4538-8967-cda0cff6695c	9d68d3e9-e3da-40f9-9ee1-5582fa92d267	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 10:52:54
26430	9d68d3e9-e2dd-49ef-b1b3-ffd7fde76ba0	9d68d3e9-e3da-40f9-9ee1-5582fa92d267	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":445,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:52:54
26505	9d68d71d-6306-4060-806b-12d573f4aea8	9d68d71d-8215-4aee-bb44-fc446e7a562e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:01:51
26506	9d68d71d-7944-47e8-b13f-8a98be9f576c	9d68d71d-8215-4aee-bb44-fc446e7a562e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"41.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:01:51
26507	9d68d71d-7d06-4b28-96e5-729968d37b9b	9d68d71d-8215-4aee-bb44-fc446e7a562e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"1.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:01:51
26508	9d68d71d-7d42-4827-bfc3-9b00dd109226	9d68d71d-8215-4aee-bb44-fc446e7a562e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:01:51
26509	9d68d71d-80d8-49ba-ace3-7fd52cbecc8b	9d68d71d-8215-4aee-bb44-fc446e7a562e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:01:51
32138	9d695d14-7e77-4260-8258-ec33bd6738fb	9d695d14-bf59-4be4-9c2f-5fc0886b0137	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 17:16:27
20548	9d66f581-42b0-480d-ac96-dab6b5cc9081	9d66f581-60d3-4aa3-95bb-3242919d09e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:35:11
20549	9d66f581-582f-407b-affa-8663f3de942e	9d66f581-60d3-4aa3-95bb-3242919d09e4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"41.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:35:11
20550	9d66f581-5bc0-4fe6-80df-de13899f3abb	9d66f581-60d3-4aa3-95bb-3242919d09e4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:35:11
20551	9d66f581-5c08-4b5f-8012-c28e5a10e8a6	9d66f581-60d3-4aa3-95bb-3242919d09e4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:35:11
20552	9d66f581-5fa4-4815-b7d1-9774276974eb	9d66f581-60d3-4aa3-95bb-3242919d09e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:35:11
20553	9d66f581-5fea-4cca-8786-ba6ba4268422	9d66f581-60d3-4aa3-95bb-3242919d09e4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:35:11
26510	9d68d71d-8127-46d0-acd7-fc3dd2bcf1f7	9d68d71d-8215-4aee-bb44-fc446e7a562e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:01:51
32139	9d695d14-bab1-44f1-a35c-4787be27e386	9d695d14-bf59-4be4-9c2f-5fc0886b0137	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"141.35","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 17:16:27
32140	9d695d14-bdd2-4a00-b6b3-7ea9c4895806	9d695d14-bf59-4be4-9c2f-5fc0886b0137	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 17:16:27
20554	9d66f587-ccb0-4d9c-a80c-4676d02d52e7	9d66f587-cf71-4c7b-bb17-ec8a9dd8efe7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":133,"memory":20,"hostname":"EderCortes"}	2024-11-03 12:35:15
32141	9d695d14-be53-4252-851b-11f5a142b3a9	9d695d14-bf59-4be4-9c2f-5fc0886b0137	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":346,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:27
19216	9d66d1db-0d58-430a-9d56-f2c253fda174	9d66d1db-526d-4111-97ab-ba3139555269	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 10:55:30
19217	9d66d1db-50e0-4144-8354-b867bbf8554c	9d66d1db-526d-4111-97ab-ba3139555269	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 10:55:30
19218	9d66d1db-5179-407a-b047-817dae6ed37e	9d66d1db-526d-4111-97ab-ba3139555269	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":331,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:55:30
32142	9d695d19-5d2d-430f-bd0c-11db64185e8e	9d695d19-7a8a-4b51-999c-641b1659c72b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 17:16:30
32143	9d695d19-7590-4a13-99b8-48b10806156c	9d695d19-7a8a-4b51-999c-641b1659c72b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":227,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 17:16:30
32144	9d695d19-75e5-41f2-a490-6d44cbc051cc	9d695d19-7a8a-4b51-999c-641b1659c72b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 17:16:30
32145	9d695d19-7949-4c1a-8638-a4cc058d9e1f	9d695d19-7a8a-4b51-999c-641b1659c72b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 17:16:30
19219	9d66d1db-a3e5-4f54-871d-6443f419eb22	9d66d1db-c1d4-4ae8-8acf-6842c3faaf83	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 10:55:30
19220	9d66d1db-b91f-42c3-9d2f-b7978f4e67ba	9d66d1db-c1d4-4ae8-8acf-6842c3faaf83	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"42.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 10:55:30
19221	9d66d1db-bcd4-4a05-945d-2dab84804b10	9d66d1db-c1d4-4ae8-8acf-6842c3faaf83	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 10:55:30
19222	9d66d1db-bd0e-4396-a3cb-ab87ae4ebbf7	9d66d1db-c1d4-4ae8-8acf-6842c3faaf83	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 10:55:30
19223	9d66d1db-c0b7-4708-86e8-a28da9088e55	9d66d1db-c1d4-4ae8-8acf-6842c3faaf83	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 10:55:30
19224	9d66d1db-c0fa-4fe8-907c-4e357f0490f5	9d66d1db-c1d4-4ae8-8acf-6842c3faaf83	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T02:27:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"0"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:55:30
32146	9d695d19-7994-4a4c-956b-e2018f37fece	9d695d19-7a8a-4b51-999c-641b1659c72b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":278,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:30
19225	9d66d1dc-eade-4c0e-814d-62bdbda13d15	9d66d1dd-1357-4033-a5f9-aa28b4e4d0fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 10:55:31
19226	9d66d1dd-0ae2-4630-95e8-57b011d6712b	9d66d1dd-1357-4033-a5f9-aa28b4e4d0fb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"53.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 10:55:31
19227	9d66d1dd-0b7c-4256-a804-1364b8f820a4	9d66d1dd-1357-4033-a5f9-aa28b4e4d0fb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 10:55:31
19228	9d66d1dd-1195-45ba-877b-aad857c5fecb	9d66d1dd-1357-4033-a5f9-aa28b4e4d0fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 10:55:31
19229	9d66d1dd-1229-4c8a-9651-e1a48d1487ff	9d66d1dd-1357-4033-a5f9-aa28b4e4d0fb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":438,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:55:31
20562	9d66f588-8e4e-452b-abe9-afefe1f8350b	9d66f588-d153-430e-a417-2cc0dba2d3d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:35:15
20563	9d66f588-c8ef-4623-bfd8-379f8910347c	9d66f588-d153-430e-a417-2cc0dba2d3d5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"139.61","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:35:16
20564	9d66f588-cc6b-4a57-8197-7029034ca6f3	9d66f588-d153-430e-a417-2cc0dba2d3d5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"1.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:35:16
20565	9d66f588-ccb2-4ca8-b966-56138f5ecfcd	9d66f588-d153-430e-a417-2cc0dba2d3d5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:35:16
20566	9d66f588-d028-4b27-b335-c73a038aece1	9d66f588-d153-430e-a417-2cc0dba2d3d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:35:16
20567	9d66f588-d073-43ac-a854-1c6b216fadb1	9d66f588-d153-430e-a417-2cc0dba2d3d5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":309,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:35:16
32147	9d695d19-c0d9-4a2f-9725-94d1b59b9508	9d695d19-dd74-416a-8abd-f5a6fd93bfe0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 17:16:30
32148	9d695d19-d8a0-4648-8501-86772a1880d2	9d695d19-dd74-416a-8abd-f5a6fd93bfe0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":216,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 17:16:31
32149	9d695d19-d8f6-4049-8a6d-282ae16f206e	9d695d19-dd74-416a-8abd-f5a6fd93bfe0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 17:16:31
20568	9d66f77a-7964-4d50-8f2c-38a0d17c9fad	9d66f77a-7dd6-49cf-9823-3288b5dd38f8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":188,"memory":20,"hostname":"EderCortes"}	2024-11-03 12:40:42
32150	9d695d19-dc34-4689-906b-faa9ce6613e5	9d695d19-dd74-416a-8abd-f5a6fd93bfe0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 17:16:31
32151	9d695d19-dc85-42f1-9d1f-29dcec632959	9d695d19-dd74-416a-8abd-f5a6fd93bfe0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":214,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:31
20569	9d66f77a-d2e7-4c75-ab62-493346c10153	9d66f77a-fbc5-442c-853f-6a103691c657	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 12:40:42
20570	9d66f77a-ee94-4564-8cfc-f939d9b2ac35	9d66f77a-fbc5-442c-853f-6a103691c657	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 185 limit 1","time":"2.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-03 12:40:42
20571	9d66f77a-eef7-4457-a1c0-5cab9eb3b7aa	9d66f77a-fbc5-442c-853f-6a103691c657	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-03 12:40:42
20572	9d66f77a-f0ca-4c3f-9e84-e41b51767680	9d66f77a-fbc5-442c-853f-6a103691c657	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 61 limit 1","time":"2.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 12:40:42
20573	9d66f77a-f0f9-4f0f-8108-d8b6db7f04a6	9d66f77a-fbc5-442c-853f-6a103691c657	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 12:40:42
20574	9d66f77a-f4d8-483f-bf18-4607a2bd3186	9d66f77a-fbc5-442c-853f-6a103691c657	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '03-11-2024', \\"itemloans_cuota_cancelada\\" = '100000', \\"updated_at\\" = '2024-11-03 12:40:42' where \\"id\\" = 185","time":"7.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":394,"hash":"35b67f849e4a0ba5090d9c1eb8abfe94","hostname":"EderCortes"}	2024-11-03 12:40:42
20575	9d66f77a-f563-438d-a4c3-52b929cc6fdd	9d66f77a-fbc5-442c-853f-6a103691c657	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:185","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-03 12:40:42","item_loans_cuando_pago":"03-11-2024","itemloans_cuota_cancelada":"100000"},"hostname":"EderCortes"}	2024-11-03 12:40:42
20576	9d66f77a-f612-449d-9cb4-beef5bcdaa52	9d66f77a-fbc5-442c-853f-6a103691c657	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_prestado\\" = 400000, \\"updated_at\\" = '2024-11-03 12:40:42' where \\"id\\" = 61","time":"0.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":402,"hash":"4f19d69da2d9a6a5193ed1537b66ca88","hostname":"EderCortes"}	2024-11-03 12:40:42
20577	9d66f77a-f647-408d-900d-56f79ddb4c2c	9d66f77a-fbc5-442c-853f-6a103691c657	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:61","changes":{"updated_at":"2024-11-03 12:40:42","loans_pago_prestado":400000},"hostname":"EderCortes"}	2024-11-03 12:40:42
20578	9d66f77a-fa4c-42f9-a04e-9b6685259d53	9d66f77a-fbc5-442c-853f-6a103691c657	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:40:42
20579	9d66f77a-faa2-455d-8a1b-48d4ea074be6	9d66f77a-fbc5-442c-853f-6a103691c657	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"179","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000","id":185,"loans_codigo":61,"itemloans_cuota":"4","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":257,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:40:42
32152	9d695d1a-28cb-4e37-bc72-f6d3765dfcdf	9d695d1a-461e-4679-82fd-f28f7ffa3c26	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 17:16:31
32153	9d695d1a-403d-4d98-b9db-3e3309531695	9d695d1a-461e-4679-82fd-f28f7ffa3c26	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 17:16:31
32154	9d695d1a-4092-4405-b1d8-6e338bfc2b8e	9d695d1a-461e-4679-82fd-f28f7ffa3c26	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 17:16:31
32155	9d695d1a-44ab-4adf-9055-bccfcc6f3f12	9d695d1a-461e-4679-82fd-f28f7ffa3c26	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 17:16:31
32156	9d695d1a-4506-4d2e-8228-a0c386b8c09f	9d695d1a-461e-4679-82fd-f28f7ffa3c26	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:31
20580	9d66f77b-5081-422f-a7fe-d0e8785bc69a	9d66f77b-6e59-4b07-be73-164bf24ad673	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:40:42
20581	9d66f77b-65d1-493c-9d2e-de3c9a362378	9d66f77b-6e59-4b07-be73-164bf24ad673	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"40.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:40:42
20582	9d66f77b-692e-4f6b-8267-a521754d9077	9d66f77b-6e59-4b07-be73-164bf24ad673	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:40:42
20583	9d66f77b-695d-431e-810a-d6418b34e9bc	9d66f77b-6e59-4b07-be73-164bf24ad673	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:40:42
20584	9d66f77b-6d24-4915-9671-1516f55941e8	9d66f77b-6e59-4b07-be73-164bf24ad673	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:40:42
20585	9d66f77b-6d69-466b-b3a1-43610efdedf2	9d66f77b-6e59-4b07-be73-164bf24ad673	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"400000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:40:42.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":null,"itemloans_cuota_cancelada":"100000"},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":273,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:40:42
32157	9d695d1f-4895-440e-8dd2-e1306c88442f	9d695d1f-4b9e-46ca-86c6-718b05244074	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":144,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:34
32158	9d695d1f-a1a7-4a1c-9b9f-a257feeb32ac	9d695d1f-a4ab-42b2-9436-6efe29a1ef05	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":155,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:16:34
26592	9d68d8c6-1b5c-4b71-adc2-70d2b999e946	9d68d8c6-411d-43f4-8fd6-f56bb8f1754a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 11:06:30
26593	9d68d8c6-3f50-4c13-b896-9c9e9538aeac	9d68d8c6-411d-43f4-8fd6-f56bb8f1754a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:06:30
26594	9d68d8c6-400f-4536-9a21-c09007be3f9a	9d68d8c6-411d-43f4-8fd6-f56bb8f1754a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":400,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:06:30
26595	9d68d8c6-d2a8-41ba-98f3-8377abde7e05	9d68d8c6-f2a0-4354-9e94-c43328808a7d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:06:30
26596	9d68d8c6-e87c-4152-8679-31ae763991ad	9d68d8c6-f2a0-4354-9e94-c43328808a7d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"43.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:06:30
26597	9d68d8c6-ec74-4120-825d-b8ed03d8eb64	9d68d8c6-f2a0-4354-9e94-c43328808a7d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:06:30
26598	9d68d8c6-ecb0-4da9-a524-8fd1d4988d18	9d68d8c6-f2a0-4354-9e94-c43328808a7d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:06:30
26599	9d68d8c6-f135-49e2-aab9-ddc52cf1dc3a	9d68d8c6-f2a0-4354-9e94-c43328808a7d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:06:30
26600	9d68d8c6-f186-4ec9-ab61-ab51862e2015	9d68d8c6-f2a0-4354-9e94-c43328808a7d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":403,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:06:30
16986	9d6546d0-1881-4e47-8afa-c5892f3a21c0	9d6546d0-1d2f-4a62-96c0-61690da89f9d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":793}	2024-11-02 16:30:53
19291	9d66d349-6cdf-400b-a302-c011ec24ada0	9d66d349-bf31-483d-aa19-894dab961489	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 10:59:30
19292	9d66d349-bcee-457b-974b-bd5d3d602930	9d66d349-bf31-483d-aa19-894dab961489	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 10:59:30
19293	9d66d349-bddc-4f1b-b586-3efbca92f973	9d66d349-bf31-483d-aa19-894dab961489	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":413,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:59:30
32159	9d695d1f-f1e1-45e9-8518-e0249d3c8893	9d695d1f-f494-48d2-a5fb-42e725c05788	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":139,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:16:35
19294	9d66d34a-3462-4f5d-aaf4-45eb438dbb44	9d66d34a-5a94-49ce-86ec-5d25d6b7fad4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 10:59:30
19295	9d66d34a-508a-4c48-9e34-3481d2fa5948	9d66d34a-5a94-49ce-86ec-5d25d6b7fad4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"49.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 10:59:30
19296	9d66d34a-5473-4564-98bf-b88701dfb54d	9d66d34a-5a94-49ce-86ec-5d25d6b7fad4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 10:59:30
19297	9d66d34a-54a4-4cd2-a00e-20b07fe4ff05	9d66d34a-5a94-49ce-86ec-5d25d6b7fad4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 10:59:30
19298	9d66d34a-5939-4484-9082-2fab05e0f811	9d66d34a-5a94-49ce-86ec-5d25d6b7fad4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 10:59:30
19299	9d66d34a-598a-4b0b-8200-b60597d4138e	9d66d34a-5a94-49ce-86ec-5d25d6b7fad4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T02:27:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"0"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:59:30
32160	9d695d20-3ec5-48d1-9a3a-e7b3d3cd9896	9d695d20-41ab-42dd-8847-66fcd7cd406d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":135,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:16:35
26682	9d68db50-2670-45b6-b54a-7c1af5efe32e	9d68db50-4b04-4827-8754-42fe4e93d5ba	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 11:13:36
19300	9d66d34c-64d9-4b0c-ac33-04dfc6daacc5	9d66d34c-8d29-404f-86be-326ef5268120	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 10:59:32
19301	9d66d34c-858e-40ea-b922-49473e1f7e29	9d66d34c-8d29-404f-86be-326ef5268120	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"54.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 10:59:32
19302	9d66d34c-85f3-4359-a95a-cec6a80666bb	9d66d34c-8d29-404f-86be-326ef5268120	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 10:59:32
19303	9d66d34c-8ba3-4273-9b65-84d2fce5d9c3	9d66d34c-8d29-404f-86be-326ef5268120	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 10:59:32
19304	9d66d34c-8bff-4527-9b2d-971c0ae49d45	9d66d34c-8d29-404f-86be-326ef5268120	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":416,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:59:32
26683	9d68db50-4926-49bb-9c6c-8664f50dc686	9d68db50-4b04-4827-8754-42fe4e93d5ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:13:36
26684	9d68db50-49e3-4a19-8862-dcafbe92fd20	9d68db50-4b04-4827-8754-42fe4e93d5ba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":428,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:13:36
32161	9d695d20-9507-4da9-97f2-811c4852682e	9d695d20-aff3-47e5-92cf-ee245262ebb4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 17:16:35
32162	9d695d20-aa83-49d8-8ac9-e58d15e501aa	9d695d20-aff3-47e5-92cf-ee245262ebb4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"39.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 17:16:35
32163	9d695d20-ae70-4035-a4a5-de50ca102e3e	9d695d20-aff3-47e5-92cf-ee245262ebb4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 17:16:35
32164	9d695d20-aecc-4a02-94ad-d4b3f4cc0ddb	9d695d20-aff3-47e5-92cf-ee245262ebb4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:35
26685	9d68db50-dce0-4f6e-ad92-7be93fb41bfc	9d68db51-24ec-438a-822b-4106e56e14db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:13:36
26686	9d68db51-1b5f-45d3-9541-09353cb7e2e1	9d68db51-24ec-438a-822b-4106e56e14db	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"146.88","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:13:36
26687	9d68db51-1f29-4423-8660-48edf922a4cb	9d68db51-24ec-438a-822b-4106e56e14db	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:13:36
26688	9d68db51-1f64-44e4-81f1-910fc730bcb2	9d68db51-24ec-438a-822b-4106e56e14db	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:13:36
26689	9d68db51-23b6-4522-9fcf-34c39163af61	9d68db51-24ec-438a-822b-4106e56e14db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:13:36
26690	9d68db51-2404-414b-b4f5-af6701fb8d78	9d68db51-24ec-438a-822b-4106e56e14db	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":510,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:13:36
32165	9d695d20-f013-4952-9780-bc86f92b1558	9d695d20-f2d0-46f1-83de-f5481091dfe1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":150,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:16:35
26691	9d68db53-5b72-4df4-917f-09f6554a61cf	9d68db53-7e2f-4eab-a640-dc692c5a6030	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:13:38
26692	9d68db53-7783-4690-b96c-0e2d5a1af3ab	9d68db53-7e2f-4eab-a640-dc692c5a6030	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"47.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:13:38
26693	9d68db53-77ee-422f-831b-0852b1628fac	9d68db53-7e2f-4eab-a640-dc692c5a6030	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:13:38
26694	9d68db53-7c89-48a8-a0c4-e65a7410ccf3	9d68db53-7e2f-4eab-a640-dc692c5a6030	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:13:38
26695	9d68db53-7cfc-424a-9ca0-54630f6e200d	9d68db53-7e2f-4eab-a640-dc692c5a6030	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":470,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:13:38
32166	9d695d21-6bce-46a5-ab2b-5704e293eb68	9d695d21-6e90-4e82-9081-1ca688406d70	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":141,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:16:35
26696	9d68db5a-c73d-4af4-9cf5-c79a96760108	9d68db5a-e598-45dc-aefb-3a43ac082ad6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:13:43
26697	9d68db5a-e124-4b4a-b90c-e8e2ff118d08	9d68db5a-e598-45dc-aefb-3a43ac082ad6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"46.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 11:13:43
26698	9d68db5a-e433-473b-8dad-ca86fe287488	9d68db5a-e598-45dc-aefb-3a43ac082ad6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:13:43
26699	9d68db5a-e4a1-4492-9ad3-3da9a77195d9	9d68db5a-e598-45dc-aefb-3a43ac082ad6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":378,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:13:43
32167	9d695d21-f19c-49da-9320-983895bd9943	9d695d22-3894-4835-92ed-c526c747479f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 17:16:36
32168	9d695d22-346c-4dfd-a9d9-ea6e216042c4	9d695d22-3894-4835-92ed-c526c747479f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"153.00","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 17:16:36
32169	9d695d22-3750-4470-afd0-5504329ce37c	9d695d22-3894-4835-92ed-c526c747479f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 17:16:36
32170	9d695d22-3797-4c69-85bb-549a24b31592	9d695d22-3894-4835-92ed-c526c747479f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:36
26700	9d68db5e-ca77-4349-9133-4ce02144e6ef	9d68db5e-e550-4d94-adf8-b0dc3a370b65	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:13:45
26701	9d68db5e-e137-49a9-8cb0-c576cb1e8762	9d68db5e-e550-4d94-adf8-b0dc3a370b65	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"43.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 11:13:45
26702	9d68db5e-e3e8-48bf-bfc3-c62026b0d628	9d68db5e-e550-4d94-adf8-b0dc3a370b65	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:13:45
26703	9d68db5e-e44d-47d3-ad70-b4f3f653b6eb	9d68db5e-e550-4d94-adf8-b0dc3a370b65	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":351,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:13:45
32171	9d695d22-939d-4b65-8628-02a79d1cda3d	9d695d22-dc85-45d0-9c9e-2c090c0832a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 17:16:36
32172	9d695d22-d721-4ac2-91bc-ad06e39d1fe3	9d695d22-dc85-45d0-9c9e-2c090c0832a2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"154.59","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 17:16:36
32173	9d695d22-db13-48df-bad5-299d3d1bce06	9d695d22-dc85-45d0-9c9e-2c090c0832a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 17:16:36
32174	9d695d22-db6c-4e56-9196-d6222674d72b	9d695d22-dc85-45d0-9c9e-2c090c0832a2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":401,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:36
26704	9d68db70-16d6-4aa7-823e-c1d5b7451d50	9d68db70-5eae-4b20-814c-a5d34fdd9686	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:13:57
26705	9d68db70-59fd-49b3-a433-e4c723b61709	9d68db70-5eae-4b20-814c-a5d34fdd9686	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"158.55","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 11:13:57
26706	9d68db70-5d17-4943-bd35-5d071741badd	9d68db70-5eae-4b20-814c-a5d34fdd9686	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:13:57
26707	9d68db70-5d8f-472d-a0ef-89aa4bae5b50	9d68db70-5eae-4b20-814c-a5d34fdd9686	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":476,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:13:57
32175	9d695d23-2d55-4aa3-a577-893bfb3b9349	9d695d23-4b15-4458-9ce8-f08f88530ab7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 17:16:37
32176	9d695d23-467b-4592-a124-e890c8b9714f	9d695d23-4b15-4458-9ce8-f08f88530ab7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAr%' or \\"users\\".\\"user_document\\"::text like '%MAr%') order by \\"users\\".\\"user_document\\" asc","time":"40.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 17:16:37
32177	9d695d23-49a3-4174-a56d-a15d57f22f3e	9d695d23-4b15-4458-9ce8-f08f88530ab7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 17:16:37
32178	9d695d23-49ef-4718-baff-87be151df055	9d695d23-4b15-4458-9ce8-f08f88530ab7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAr"},"session":[],"response_status":200,"response":{"data":[]},"duration":269,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:37
32179	9d695d23-8748-470e-967d-e9428cde5db9	9d695d23-8aaa-4e1b-bb34-346ed0fe5c4e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":135,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:16:37
32180	9d695d23-d755-4123-948c-56de70d06bcc	9d695d23-da6e-4029-b31e-52dbffc5078f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":138,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:16:37
32181	9d695d24-5374-49bb-8558-a502ebe27f91	9d695d24-6cf3-455b-998b-8bcc0ec060f3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 17:16:37
32182	9d695d24-6904-41e0-9643-a1a446c62403	9d695d24-6cf3-455b-998b-8bcc0ec060f3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAri%' or \\"users\\".\\"user_document\\"::text like '%MAri%') order by \\"users\\".\\"user_document\\" asc","time":"38.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 17:16:37
32183	9d695d24-6bca-4a97-ae06-6b8063d42106	9d695d24-6cf3-455b-998b-8bcc0ec060f3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 17:16:37
32184	9d695d24-6c0f-4a4c-b241-55e18aabcdf3	9d695d24-6cf3-455b-998b-8bcc0ec060f3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAri"},"session":[],"response_status":200,"response":{"data":[]},"duration":212,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:37
32185	9d695d24-a856-4d79-9871-bec38ed9fe05	9d695d24-ab7d-4459-ab8b-7c4c8cd841e1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":140,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:16:38
32186	9d695d25-2c1b-4283-8b40-979df95f5e0f	9d695d25-2ef4-4a80-b2ec-42f0b3e7e214	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":147,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:16:38
19489	9d66db1d-37b4-4264-b0cb-1dd7b840735f	9d66db1d-860e-475c-a67f-c450bf342b17	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 11:21:23
19490	9d66db1d-83d8-4463-aec8-7f49a7e73d3f	9d66db1d-860e-475c-a67f-c450bf342b17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:21:23
19491	9d66db1d-84e2-42b3-9645-bb15644469f6	9d66db1d-860e-475c-a67f-c450bf342b17	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":404,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:21:23
19492	9d66db1d-e865-43c2-a8b5-cf2e06b115a9	9d66db1e-07af-4484-948a-7954409660d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:21:23
19493	9d66db1d-fe6b-4b70-9a8b-89a289987331	9d66db1e-07af-4484-948a-7954409660d6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"41.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 11:21:24
19494	9d66db1e-01e5-4f27-a11d-ac30a7e542bd	9d66db1e-07af-4484-948a-7954409660d6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:21:24
19495	9d66db1e-0215-45fa-b051-69a36a7c76cd	9d66db1e-07af-4484-948a-7954409660d6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:21:24
19496	9d66db1e-0683-47d0-86f4-7be59080af52	9d66db1e-07af-4484-948a-7954409660d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:21:24
19497	9d66db1e-06cd-4788-807e-49f5e135c17d	9d66db1e-07af-4484-948a-7954409660d6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":274,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:21:24
32187	9d695d25-83b0-4de9-8b9b-bf488035bdae	9d695d25-9e0e-4808-abf0-08ae81158dbd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 17:16:38
32188	9d695d25-99bb-4bfe-8057-aae0fd0cdc69	9d695d25-9e0e-4808-abf0-08ae81158dbd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAria%' or \\"users\\".\\"user_document\\"::text like '%MAria%') order by \\"users\\".\\"user_document\\" asc","time":"40.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 17:16:38
32189	9d695d25-9cd2-427f-adfe-0e4b92b02188	9d695d25-9e0e-4808-abf0-08ae81158dbd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 17:16:38
32190	9d695d25-9d1c-4957-ab0f-75d01a4b9f18	9d695d25-9e0e-4808-abf0-08ae81158dbd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAria"},"session":[],"response_status":200,"response":{"data":[]},"duration":219,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:38
19498	9d66db1f-e1ba-4368-9146-397d1f62c1a9	9d66db20-2654-4f80-b3e9-b46c25abc01e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:21:25
19499	9d66db20-2159-4196-9890-68fc7f89c8ba	9d66db20-2654-4f80-b3e9-b46c25abc01e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"144.49","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:21:25
19500	9d66db20-21ad-41a4-9e0c-16fdac1b537e	9d66db20-2654-4f80-b3e9-b46c25abc01e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:21:25
19501	9d66db20-2515-42d6-88b8-2c119933f770	9d66db20-2654-4f80-b3e9-b46c25abc01e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 11:21:25
19502	9d66db20-255b-4503-b746-4283d963cffc	9d66db20-2654-4f80-b3e9-b46c25abc01e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:21:25
32191	9d695d25-dfee-4922-abd4-9123a5df2088	9d695d25-e2ec-4ebb-bff9-c465930083b5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":155,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:16:38
18220	9d65ba5a-57d4-4593-89d3-f45f256ee786	9d65ba5a-739c-41b7-b826-49c68d802feb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 21:53:57
18221	9d65ba5a-71ff-4e6a-9fbc-f55d01a43900	9d65ba5a-739c-41b7-b826-49c68d802feb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 21:53:57
18222	9d65ba5a-7299-432c-8734-68e52603326a	9d65ba5a-739c-41b7-b826-49c68d802feb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:53:57
32192	9d695d26-33c3-4da6-a8c0-873bd13cdf47	9d695d26-36c3-4081-a07f-b843defffb5f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":140,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:16:39
18223	9d65ba5a-bee6-40a4-bc8f-64b989131289	9d65ba5a-de74-4170-94a1-c4d803ef9305	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 21:53:57
18224	9d65ba5a-d5e4-4527-bde0-50d03532e97d	9d65ba5a-de74-4170-94a1-c4d803ef9305	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"46.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"2b11ef88578e3c91c11800e110e490df","hostname":"EderCortes"}	2024-11-02 21:53:57
18225	9d65ba5a-d952-4087-832e-bf673e827f26	9d65ba5a-de74-4170-94a1-c4d803ef9305	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"2.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:53:57
18226	9d65ba5a-d988-4ce3-9443-b15216ffd2bd	9d65ba5a-de74-4170-94a1-c4d803ef9305	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:53:57
18227	9d65ba5a-dd3a-481d-afd2-0725dd7b69f7	9d65ba5a-de74-4170-94a1-c4d803ef9305	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 21:53:57
18228	9d65ba5a-dd87-4393-9d86-1d679ae2ef29	9d65ba5a-de74-4170-94a1-c4d803ef9305	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:53:57
32193	9d695d26-87e7-4bbc-82c0-284744f5efd0	9d695d26-8b9f-4717-820c-0d762ff96bb5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":144,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:16:39
18229	9d65ba5d-033c-4cce-9108-c1a91176cb41	9d65ba5d-670a-44c3-ba6a-dd2adb72f449	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 21:53:59
18230	9d65ba5d-5c37-4f97-9980-0b567b54fb6f	9d65ba5d-670a-44c3-ba6a-dd2adb72f449	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"75.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 21:53:59
18231	9d65ba5d-5cd7-437e-9aa8-d178019e9189	9d65ba5d-670a-44c3-ba6a-dd2adb72f449	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 21:53:59
18232	9d65ba5d-6494-4ab8-8a77-00c2bd95e066	9d65ba5d-670a-44c3-ba6a-dd2adb72f449	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 21:53:59
18233	9d65ba5d-6541-4373-abb0-5589fe8a41c2	9d65ba5d-670a-44c3-ba6a-dd2adb72f449	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":848,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:53:59
32194	9d695d26-d869-49a9-8add-cdc1d41cd846	9d695d26-db6e-4694-9c0f-92a88ee2578e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":133,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:16:39
32195	9d695d27-2bbe-4d36-8e93-47dd7f9be8bf	9d695d27-459c-4f97-90d0-30412f1d0296	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 17:16:39
32196	9d695d27-4129-45db-a9e5-e3a1775d0ca6	9d695d27-459c-4f97-90d0-30412f1d0296	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAria%' or \\"users\\".\\"user_document\\"::text like '%MAria%') order by \\"users\\".\\"user_document\\" asc","time":"39.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 17:16:39
32197	9d695d27-4462-4d0c-a5b7-c84faf8fa14a	9d695d27-459c-4f97-90d0-30412f1d0296	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 17:16:39
32198	9d695d27-44ab-4e24-9715-9d30ef751e46	9d695d27-459c-4f97-90d0-30412f1d0296	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"28","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAria"},"session":[],"response_status":200,"response":{"data":[]},"duration":218,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:39
26801	9d68dc5a-2450-41c7-9966-8468d3b5b067	9d68dc5a-422a-4092-81e9-abf3cf92f7ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:16:30
26802	9d68dc5a-408a-435d-a973-82ab7e65e3a4	9d68dc5a-422a-4092-81e9-abf3cf92f7ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:16:30
26803	9d68dc5a-4124-4e52-86a7-e4da22a588f9	9d68dc5a-422a-4092-81e9-abf3cf92f7ee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:16:30
26804	9d68dc5a-c360-45b7-9874-80736e522d93	9d68dc5a-e13e-461f-b563-ceb14df1c28d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:16:30
26805	9d68dc5a-d8b5-4739-ab4b-3cadc98d0ac6	9d68dc5a-e13e-461f-b563-ceb14df1c28d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"43.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:16:31
26806	9d68dc5a-dc38-4de1-9712-4921a50ae6ce	9d68dc5a-e13e-461f-b563-ceb14df1c28d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:16:31
26807	9d68dc5a-dc6d-40c5-9b09-827817e1fd5d	9d68dc5a-e13e-461f-b563-ceb14df1c28d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:16:31
26808	9d68dc5a-dffe-4f74-83af-c222261ac2d4	9d68dc5a-e13e-461f-b563-ceb14df1c28d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:16:31
26809	9d68dc5a-e04e-4145-abf9-ec474c3c82d4	9d68dc5a-e13e-461f-b563-ceb14df1c28d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":361,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:16:31
32199	9d695d27-8620-42ea-b570-28d713b86f50	9d695d27-a08a-44f4-884a-77f52cbcb16f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 17:16:39
32200	9d695d27-9c54-4099-9fc4-d0ffac50756e	9d695d27-a08a-44f4-884a-77f52cbcb16f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAria%' or \\"users\\".\\"user_document\\"::text like '%MAria%') order by \\"users\\".\\"user_document\\" asc","time":"41.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 17:16:40
32201	9d695d27-9f4f-46b3-a009-369c5867f834	9d695d27-a08a-44f4-884a-77f52cbcb16f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 17:16:40
32202	9d695d27-9f98-4cb2-a3e8-aab4c950ecef	9d695d27-a08a-44f4-884a-77f52cbcb16f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAria"},"session":[],"response_status":200,"response":{"data":[]},"duration":224,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:40
23031	9d6800ee-e30f-4e5d-af7d-8679629e9b5e	9d6800ef-2eda-488b-811d-3d1aeba6879f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 01:02:58
23032	9d6800ef-2d1f-4179-997c-f69e9d135f8b	9d6800ef-2eda-488b-811d-3d1aeba6879f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 01:02:58
23033	9d6800ef-2dd6-4695-b3d4-9fd3f3f39e9c	9d6800ef-2eda-488b-811d-3d1aeba6879f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":341,"memory":22,"hostname":"EderCortes"}	2024-11-04 01:02:58
23034	9d680128-595d-4b3a-9446-74470a5c254b	9d680128-b8f2-47a7-a426-94bcf351ed55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 01:03:35
23035	9d680128-a714-4a41-a5dc-d7648792ff9e	9d680128-b8f2-47a7-a426-94bcf351ed55	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 70\\n                        ","time":"157.66","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"40345ecc36d5b014fbb2cca663c7c347","hostname":"EderCortes"}	2024-11-04 01:03:36
23036	9d680128-adb5-4dd6-9909-8fefac13a7c4	9d680128-b8f2-47a7-a426-94bcf351ed55	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '70' order by \\"item_loans\\".\\"id\\" asc","time":"2.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 01:03:36
23037	9d680128-ae0a-4250-b46c-4c6bed8412e7	9d680128-b8f2-47a7-a426-94bcf351ed55	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 01:03:36
23038	9d680128-b6d0-4bc0-a533-bd1030e41e44	9d680128-b8f2-47a7-a426-94bcf351ed55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 01:03:36
23039	9d680128-b761-4a70-bf5f-13d69611a2b2	9d680128-b8f2-47a7-a426-94bcf351ed55	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/70","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":70,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":2150000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"430000","loans_pago_interes":"107500"},"items":[{"id":248,"loans_codigo":70,"itemloans_cuota":"1","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:52:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"107500","itemloans_cuota_cancelada":"430000"},{"id":249,"loans_codigo":70,"itemloans_cuota":"2","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":250,"loans_codigo":70,"itemloans_cuota":"3","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":251,"loans_codigo":70,"itemloans_cuota":"4","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":252,"loans_codigo":70,"itemloans_cuota":"5","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":37660,"memory":22,"hostname":"EderCortes"}	2024-11-04 01:03:36
32203	9d695d27-de12-4632-bd25-d7fb633efd29	9d695d27-e0c3-4b48-b225-b4849b19d11a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":140,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:16:40
32204	9d695d28-5f7a-41fb-978d-932aa89c825e	9d695d28-a1a1-48e8-acd8-df0e007f2de5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 17:16:40
32205	9d695d28-9da7-44f1-ac06-351ab6f83fd0	9d695d28-a1a1-48e8-acd8-df0e007f2de5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAri%' or \\"users\\".\\"user_document\\"::text like '%MAri%') order by \\"users\\".\\"user_document\\" asc","time":"144.99","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 17:16:40
17396	9d655944-d47e-4200-917b-d70d88f1db6b	9d655944-f392-4965-a0b0-3d2f0f7501f3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 17:22:29
17397	9d655944-f202-44d2-bfdf-88a0237afa93	9d655944-f392-4965-a0b0-3d2f0f7501f3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 17:22:29
17398	9d655944-f29f-45b0-8e0f-a15eff6806fb	9d655944-f392-4965-a0b0-3d2f0f7501f3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:22:29
32206	9d695d28-a060-49ab-81e0-5dce4dc40962	9d695d28-a1a1-48e8-acd8-df0e007f2de5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 17:16:40
32207	9d695d28-a0af-413f-97b5-dd29776ef2c8	9d695d28-a1a1-48e8-acd8-df0e007f2de5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAri"},"session":[],"response_status":200,"response":{"data":[]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:40
17399	9d655945-46c5-4f11-83d8-d55ba360b6c7	9d655945-6537-424f-a744-85e72461a538	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 17:22:29
17400	9d655945-6010-4d26-8efe-77fd141493cc	9d655945-6537-424f-a744-85e72461a538	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"45.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":46,"hash":"fb4ded687569d92428336ceae5c6ffcd","hostname":"EderCortes"}	2024-11-02 17:22:29
17401	9d655945-63a1-4908-adf6-e4bef60c70cd	9d655945-6537-424f-a744-85e72461a538	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 17:22:29
17402	9d655945-641f-4f3c-a22b-417dd9a42710	9d655945-6537-424f-a744-85e72461a538	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"0","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"0","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"7","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"-2","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":"6","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"dias_faltantes":null,"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":248,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:22:29
32208	9d695d28-e053-45f4-916b-80026e1a1f88	9d695d28-e385-4335-a65e-ef8a1cdd5f38	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":140,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:16:40
17403	9d655946-e7c6-4a1e-beb6-85a32e00c454	9d655947-1fa4-4413-8cb2-8639ddfa2db6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 17:22:30
17404	9d655947-1902-4685-9aa6-0153366f2a93	9d655947-1fa4-4413-8cb2-8639ddfa2db6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"100.45","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 17:22:30
17405	9d655947-197b-4f83-b94e-9b856bd97ab5	9d655947-1fa4-4413-8cb2-8639ddfa2db6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 17:22:30
17406	9d655947-1e3c-425e-a0e0-9f99ec08072c	9d655947-1fa4-4413-8cb2-8639ddfa2db6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 17:22:30
17407	9d655947-1e9d-4cd7-a848-78f338ede791	9d655947-1fa4-4413-8cb2-8639ddfa2db6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":506,"memory":22,"hostname":"EderCortes"}	2024-11-02 17:22:30
32209	9d695d29-34f0-4ed9-ad41-8d0cfa63df94	9d695d29-4dd4-4595-a5af-370028f440ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 17:16:41
32210	9d695d29-4925-4467-a42f-fd049c37b98e	9d695d29-4dd4-4595-a5af-370028f440ee	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAr%' or \\"users\\".\\"user_document\\"::text like '%MAr%') order by \\"users\\".\\"user_document\\" asc","time":"37.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 17:16:41
26934	9d68ddbb-a6a2-4929-b431-6aae96bea1a0	9d68ddbb-c7b0-4e7c-857e-5e73c87ff53a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:20:22
26935	9d68ddbb-c5e5-4383-aa20-09ed0cadf7cc	9d68ddbb-c7b0-4e7c-857e-5e73c87ff53a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 11:20:22
26936	9d68ddbb-c69d-45ee-abf6-8c6ec9893383	9d68ddbb-c7b0-4e7c-857e-5e73c87ff53a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":382,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:20:22
32211	9d695d29-4c71-43d6-a829-eecbe47debc9	9d695d29-4dd4-4595-a5af-370028f440ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 17:16:41
32212	9d695d29-4cca-42b0-8f9f-30cff3fcdeb2	9d695d29-4dd4-4595-a5af-370028f440ee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAr"},"session":[],"response_status":200,"response":{"data":[]},"duration":216,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:41
26937	9d68ddbc-470f-4800-8aed-c5ef2ea5c64f	9d68ddbc-66a8-453d-b7d8-2e9609365c5e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 11:20:22
26938	9d68ddbc-5d19-4303-89c2-6ab148fa4999	9d68ddbc-66a8-453d-b7d8-2e9609365c5e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"43.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:20:22
26939	9d68ddbc-6128-4f1a-8051-161e6aa89be5	9d68ddbc-66a8-453d-b7d8-2e9609365c5e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:20:22
26940	9d68ddbc-6164-4f2f-9eef-fa0dd91d3e17	9d68ddbc-66a8-453d-b7d8-2e9609365c5e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:20:22
26941	9d68ddbc-6555-4bbf-94f6-837754aa022d	9d68ddbc-66a8-453d-b7d8-2e9609365c5e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 11:20:22
26942	9d68ddbc-65ad-440b-af99-a7527185d9fd	9d68ddbc-66a8-453d-b7d8-2e9609365c5e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:20:22
32213	9d695d29-8aad-4c5e-8fb1-54d93de97333	9d695d29-8d8c-477a-9389-ad41f80a5cf3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":137,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:16:41
32214	9d695d29-dede-4752-80bc-0ae8625c80a8	9d695d29-f92c-45ee-9e72-71d9790fdce5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 17:16:41
32215	9d695d29-f4b2-4db8-879f-30eedab1ac07	9d695d29-f92c-45ee-9e72-71d9790fdce5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"40.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 17:16:41
32216	9d695d29-f7c6-43c4-8ae4-ecab14155bdf	9d695d29-f92c-45ee-9e72-71d9790fdce5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 17:16:41
32217	9d695d29-f81a-436d-86a2-18e2c47797fb	9d695d29-f92c-45ee-9e72-71d9790fdce5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":220,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:41
32218	9d695d2a-36e6-4778-aa05-9f8cbf86a75c	9d695d2a-39dc-44de-b93c-7e88669da148	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":139,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:16:41
32219	9d695d2a-88c4-4e80-9b50-58b58c7c4ab7	9d695d2a-a37e-42c6-bc34-fd9880899f5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 17:16:41
32220	9d695d2a-9eec-4c83-a11a-f02a087b9e58	9d695d2a-a37e-42c6-bc34-fd9880899f5c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAa%' or \\"users\\".\\"user_document\\"::text like '%MAa%') order by \\"users\\".\\"user_document\\" asc","time":"41.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 17:16:42
32221	9d695d2a-a229-4338-8af2-d88c6714745e	9d695d2a-a37e-42c6-bc34-fd9880899f5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 17:16:42
16791	9d64d6c3-e8e2-4551-aec8-41f4802313a3	9d64d6c4-2fa7-4ae4-a973-d328fd0d4f03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 11:17:34
16792	9d64d6c4-2e3e-4a5e-aa6f-141c59ec0dc6	9d64d6c4-2fa7-4ae4-a973-d328fd0d4f03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-02 11:17:34
16793	9d64d6c4-2ed7-4d59-ab64-1b57cf417454	9d64d6c4-2fa7-4ae4-a973-d328fd0d4f03	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":359,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:17:34
32222	9d695d2a-a280-48a0-96c3-57036dcb010a	9d695d2a-a37e-42c6-bc34-fd9880899f5c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAa"},"session":[],"response_status":200,"response":{"data":[]},"duration":214,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:42
16794	9d64d6c4-7e31-4ea7-a8c7-2835678ea367	9d64d6c4-c8da-4e54-9e99-e43c4848ae4a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-02 11:17:34
16795	9d64d6c4-c072-4e7c-aef0-dd2faaa58dae	9d64d6c4-c8da-4e54-9e99-e43c4848ae4a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"154.42","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 11:17:35
16796	9d64d6c4-c3c6-4ee7-851d-c24c8e81e809	9d64d6c4-c8da-4e54-9e99-e43c4848ae4a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 11:17:35
16797	9d64d6c4-c3fe-4008-b0a9-2d4a21e002e8	9d64d6c4-c8da-4e54-9e99-e43c4848ae4a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 11:17:35
16798	9d64d6c4-c796-47c1-8de7-63ac8551881a	9d64d6c4-c8da-4e54-9e99-e43c4848ae4a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-02 11:17:35
16799	9d64d6c4-c7ed-4bd2-a8d9-f6fe76f654bd	9d64d6c4-c8da-4e54-9e99-e43c4848ae4a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:17:35
32223	9d695d2a-dfac-4cca-a2e2-20c936b4ba48	9d695d2a-e2f8-4caa-9d3b-9915058ccff3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":141,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:16:42
23259	9d688e58-0da9-4fe2-8f90-53d2adf326c3	9d688e58-2e41-41b2-abdc-c875e91f0f6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 07:38:22
16800	9d64d6c6-164b-4c8e-a114-61388f059b3c	9d64d6c6-4607-4aa5-a990-098d205a0275	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-02 11:17:35
16801	9d64d6c6-3dc0-4252-b6cd-aeb90ba79fe7	9d64d6c6-4607-4aa5-a990-098d205a0275	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"70.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 11:17:36
16802	9d64d6c6-3e4d-4272-8848-8a670e479427	9d64d6c6-4607-4aa5-a990-098d205a0275	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 11:17:36
16803	9d64d6c6-4421-44ce-9378-f8b1dd0b2aea	9d64d6c6-4607-4aa5-a990-098d205a0275	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-02 11:17:36
16804	9d64d6c6-44a0-450b-bbaa-a1e1f511ee66	9d64d6c6-4607-4aa5-a990-098d205a0275	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":392,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:17:36
23260	9d688e58-2c46-4ddd-82e6-488b55b38b31	9d688e58-2e41-41b2-abdc-c875e91f0f6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 07:38:23
23261	9d688e58-2d32-42bf-8b50-ddf3c6a6aa37	9d688e58-2e41-41b2-abdc-c875e91f0f6b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":296,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:38:23
32224	9d695d2b-3374-4138-bf8e-fcdb9b5a07ee	9d695d2b-4e8a-4499-8090-a8abb3eb0ccd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 17:16:42
27144	9d68e276-fea6-42f1-90c2-762b07b52c9b	9d68e277-1e62-46a7-b4fa-15770be2169d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:33:36
27145	9d68e277-1c9f-43f1-a373-a660c14aa49d	9d68e277-1e62-46a7-b4fa-15770be2169d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:33:36
27146	9d68e277-1d42-4a7c-8b00-04b426a27ab8	9d68e277-1e62-46a7-b4fa-15770be2169d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":367,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:33:36
32225	9d695d2b-4a05-49e2-a408-17815044937e	9d695d2b-4e8a-4499-8090-a8abb3eb0ccd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"41.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 17:16:42
32226	9d695d2b-4d40-4bb8-befa-784e1b3552b6	9d695d2b-4e8a-4499-8090-a8abb3eb0ccd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 17:16:42
32227	9d695d2b-4d99-4c5a-9754-7ecaa0955d1a	9d695d2b-4e8a-4499-8090-a8abb3eb0ccd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":212,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:42
16805	9d64d6cd-e81d-4f3b-bdb9-1005544930d7	9d64d6cd-eb44-420b-bb23-bc5029035a84	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":138,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:17:41
23262	9d688e58-8ed6-4531-82e3-9c0865bea247	9d688e58-ae40-4fee-8a71-bb326fdaf6ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 07:38:23
23263	9d688e58-a4f4-493e-ba05-9b3a55172973	9d688e58-ae40-4fee-8a71-bb326fdaf6ef	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 70\\n                        ","time":"44.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"40345ecc36d5b014fbb2cca663c7c347","hostname":"EderCortes"}	2024-11-04 07:38:23
23264	9d688e58-a8e4-47a7-92e9-53c0d0622956	9d688e58-ae40-4fee-8a71-bb326fdaf6ef	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '70' order by \\"item_loans\\".\\"id\\" asc","time":"1.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 07:38:23
23265	9d688e58-a91f-4fd7-86f6-c04d662127d7	9d688e58-ae40-4fee-8a71-bb326fdaf6ef	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 07:38:23
23266	9d688e58-ad00-456a-89d7-b57ef1fd3356	9d688e58-ae40-4fee-8a71-bb326fdaf6ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 07:38:23
23267	9d688e58-ad4f-4c4f-968d-af6830a04af0	9d688e58-ae40-4fee-8a71-bb326fdaf6ef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/70","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":70,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":2150000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1470000","loans_pago_interes":"367500"},"items":[{"id":248,"loans_codigo":70,"itemloans_cuota":"1","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:52:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"107500","itemloans_cuota_cancelada":"430000"},{"id":249,"loans_codigo":70,"itemloans_cuota":"2","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T12:35:02.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"140000","itemloans_cuota_cancelada":"560000"},{"id":253,"loans_codigo":70,"itemloans_cuota":"3","itemloans_valor_cuota":"386666.66666667","itemloans_iteres":"96666.666666667","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T12:35:02.000000Z","updated_at":"2024-11-04T12:38:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"120000","itemloans_cuota_cancelada":"480000"},{"id":256,"loans_codigo":70,"itemloans_cuota":"4","itemloans_valor_cuota":"340000","itemloans_iteres":"85000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T12:38:20.000000Z","updated_at":"2024-11-04T12:38:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":257,"loans_codigo":70,"itemloans_cuota":"5","itemloans_valor_cuota":"340000","itemloans_iteres":"85000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T12:38:20.000000Z","updated_at":"2024-11-04T12:38:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:38:23
27147	9d68e277-a19c-40ce-a080-ee1390bfbce8	9d68e277-c1b3-4802-a04c-91afd6afa4ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:33:36
27148	9d68e277-b8a7-47f3-9523-d479835a4cb8	9d68e277-c1b3-4802-a04c-91afd6afa4ac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"45.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:33:36
27149	9d68e277-bc65-4c4c-bd91-133a81e2dbb0	9d68e277-c1b3-4802-a04c-91afd6afa4ac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:33:36
27150	9d68e277-bca4-4f57-afc4-bb125890ac90	9d68e277-c1b3-4802-a04c-91afd6afa4ac	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:33:36
27151	9d68e277-c0ab-4132-903c-a89acc1f2d76	9d68e277-c1b3-4802-a04c-91afd6afa4ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 11:33:36
23268	9d688e5a-6eb8-405f-9491-5c395ecdd5ff	9d688e5a-8d63-4835-8bcd-aebf24507869	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 07:38:24
23269	9d688e5a-8820-476d-a0f2-f0e132de43a1	9d688e5a-8d63-4835-8bcd-aebf24507869	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 07:38:24
23270	9d688e5a-8885-4cd9-a800-bae19e7508d5	9d688e5a-8d63-4835-8bcd-aebf24507869	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 07:38:24
23271	9d688e5a-8c1a-4e43-b3e4-57fa2e3f2063	9d688e5a-8d63-4835-8bcd-aebf24507869	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 07:38:24
23272	9d688e5a-8c62-491d-86a5-d0eb5bcffd23	9d688e5a-8d63-4835-8bcd-aebf24507869	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":428,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:38:24
27152	9d68e277-c0f4-48c2-93ba-fdb790fa8c48	9d68e277-c1b3-4802-a04c-91afd6afa4ac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":371,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:33:36
32228	9d695d2b-91b7-48cf-9d93-d93993d37a43	9d695d2b-ad9c-47dd-84f8-1c1314134dd9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 17:16:42
32229	9d695d2b-a83a-4aba-8d1f-cd459d7ff79d	9d695d2b-ad9c-47dd-84f8-1c1314134dd9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ma%' or \\"users\\".\\"user_document\\"::text like '%Ma%') order by \\"users\\".\\"user_document\\" asc","time":"42.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 17:16:42
32230	9d695d2b-ac53-443c-aa2b-d4876f307772	9d695d2b-ad9c-47dd-84f8-1c1314134dd9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 17:16:42
32231	9d695d2b-aca3-4409-a0e4-c3b219db2692	9d695d2b-ad9c-47dd-84f8-1c1314134dd9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ma"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:42
16811	9d64d6ce-c473-424b-89ca-80783e18d0bd	9d64d6cf-0b3c-4fc7-a599-6347bec963eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-02 11:17:41
16812	9d64d6cf-027f-4dfc-97b6-e6031249e866	9d64d6cf-0b3c-4fc7-a599-6347bec963eb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"146.78","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":240,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-02 11:17:41
16813	9d64d6cf-05ff-4472-84a4-b22766d85dbf	9d64d6cf-0b3c-4fc7-a599-6347bec963eb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"1.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":269,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 11:17:41
16814	9d64d6cf-0638-4d6f-bdce-0e90894f5bcf	9d64d6cf-0b3c-4fc7-a599-6347bec963eb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 11:17:41
16815	9d64d6cf-09f0-48e6-a493-580a326af14e	9d64d6cf-0b3c-4fc7-a599-6347bec963eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-02 11:17:41
16816	9d64d6cf-0a42-4767-9994-8587dfeec693	9d64d6cf-0b3c-4fc7-a599-6347bec963eb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-10-30T16:00:56.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":337,"memory":22,"hostname":"EderCortes"}	2024-11-02 11:17:41
23273	9d688fd2-0ac4-408d-bebf-9dbe970c7de6	9d688fd2-0f6c-4b34-8722-6284e769f73d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":225,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:42:30
32232	9d695d2b-f346-4c3f-a983-d08c4ad09269	9d695d2b-f634-48e4-89ed-6c0f5539de9e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":160,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:16:42
23322	9d689458-80ea-42f1-9ec1-998aef065daa	9d689458-ab68-4ada-869d-ea09822a30a8	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 07:55:09
23323	9d689458-a960-46d0-a69e-88f649ad816a	9d689458-ab68-4ada-869d-ea09822a30a8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 07:55:09
23324	9d689458-aa3b-4eaa-95d4-53202d7647a3	9d689458-ab68-4ada-869d-ea09822a30a8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":358,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:55:09
23325	9d689459-27f1-4382-b378-206bbf47cc08	9d689459-4e14-4595-b2d7-746659ee8d67	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 07:55:10
23326	9d689459-40ad-44c5-acfb-b5fcd4c1d7fa	9d689459-4e14-4595-b2d7-746659ee8d67	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 70\\n                        ","time":"49.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"40345ecc36d5b014fbb2cca663c7c347","hostname":"EderCortes"}	2024-11-04 07:55:10
23327	9d689459-46aa-4885-a8bb-bfe6960051b8	9d689459-4e14-4595-b2d7-746659ee8d67	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '70' order by \\"item_loans\\".\\"id\\" asc","time":"3.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 07:55:10
23328	9d689459-4712-4fdc-a3c2-fd30824763a2	9d689459-4e14-4595-b2d7-746659ee8d67	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 07:55:10
23329	9d689459-4c9f-4bf3-9592-e813bf5c4f6f	9d689459-4e14-4595-b2d7-746659ee8d67	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 07:55:10
23330	9d689459-4cfa-427c-8f90-bb1ddb4ef004	9d689459-4e14-4595-b2d7-746659ee8d67	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/70","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":70,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":2150000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1950000","loans_pago_interes":"487500"},"items":[{"id":248,"loans_codigo":70,"itemloans_cuota":"1","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:52:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"107500","itemloans_cuota_cancelada":"430000"},{"id":249,"loans_codigo":70,"itemloans_cuota":"2","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T12:35:02.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"140000","itemloans_cuota_cancelada":"560000"},{"id":253,"loans_codigo":70,"itemloans_cuota":"3","itemloans_valor_cuota":"386666.66666667","itemloans_iteres":"96666.666666667","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T12:35:02.000000Z","updated_at":"2024-11-04T12:38:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"120000","itemloans_cuota_cancelada":"480000"},{"id":256,"loans_codigo":70,"itemloans_cuota":"4","itemloans_valor_cuota":"340000","itemloans_iteres":"85000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T12:38:20.000000Z","updated_at":"2024-11-04T12:50:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"120000","itemloans_cuota_cancelada":"480000"},{"id":258,"loans_codigo":70,"itemloans_cuota":"5","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T12:50:01.000000Z","updated_at":"2024-11-04T12:50:01.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":328,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:55:10
23279	9d689028-d37b-4757-bc2e-306849844ea4	9d689028-f76d-4b51-a10b-a1a2ce6f70c6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 07:43:27
23280	9d689028-f26a-4aef-a79a-7c253d777f3a	9d689028-f76d-4b51-a10b-a1a2ce6f70c6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"56.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 07:43:27
23281	9d689028-f5b7-4970-bb88-d7622e3e1188	9d689028-f76d-4b51-a10b-a1a2ce6f70c6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 07:43:27
23282	9d689028-f61b-4056-9982-35e231108d2b	9d689028-f76d-4b51-a10b-a1a2ce6f70c6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":455,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:43:27
23331	9d68945b-8547-4d09-ab40-284bf5d96f1d	9d68945b-d70b-4958-9c6e-aa7275dc0cc1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 07:55:11
23332	9d68945b-ceb5-4a47-bc29-cbd057278954	9d68945b-d70b-4958-9c6e-aa7275dc0cc1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"165.12","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 07:55:12
23333	9d68945b-cf1c-43b8-bbd4-4badd72990f2	9d68945b-d70b-4958-9c6e-aa7275dc0cc1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 07:55:12
23334	9d68945b-d513-46fb-8499-ca6656e8fa2c	9d68945b-d70b-4958-9c6e-aa7275dc0cc1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 07:55:12
23335	9d68945b-d58a-481f-b7a7-924263c52289	9d68945b-d70b-4958-9c6e-aa7275dc0cc1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":405,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:55:12
32233	9d695d2c-4bcd-49b7-af25-b5adf407b967	9d695d2c-673e-4d54-89c3-2c9f04f38630	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 17:16:43
32234	9d695d2c-6338-47d1-9b7a-1a4acdea052a	9d695d2c-673e-4d54-89c3-2c9f04f38630	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mar%' or \\"users\\".\\"user_document\\"::text like '%Mar%') order by \\"users\\".\\"user_document\\" asc","time":"42.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 17:16:43
32235	9d695d2c-65f0-4abc-b320-a910c31f3dea	9d695d2c-673e-4d54-89c3-2c9f04f38630	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 17:16:43
23283	9d689089-31c4-485f-a5a9-fb2a68745068	9d689089-861f-41d7-b83f-3277e94c6dd9	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 07:44:30
23284	9d689089-79e2-4f9d-b9ac-e75101d2a552	9d689089-861f-41d7-b83f-3277e94c6dd9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 70\\n                        ","time":"152.72","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"40345ecc36d5b014fbb2cca663c7c347","hostname":"EderCortes"}	2024-11-04 07:44:30
23285	9d689089-7eb3-4be6-9e57-7e38aca68e55	9d689089-861f-41d7-b83f-3277e94c6dd9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '70' order by \\"item_loans\\".\\"id\\" asc","time":"2.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 07:44:30
23286	9d689089-7ef4-4a9d-b08e-5fb57cd2584b	9d689089-861f-41d7-b83f-3277e94c6dd9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 07:44:30
23287	9d689089-848c-4bf8-b781-af7e5988a122	9d689089-861f-41d7-b83f-3277e94c6dd9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 07:44:30
23288	9d689089-8500-4cf8-8a9e-941fcdbebf70	9d689089-861f-41d7-b83f-3277e94c6dd9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/70","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":70,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":2150000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1470000","loans_pago_interes":"367500"},"items":[{"id":248,"loans_codigo":70,"itemloans_cuota":"1","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:52:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"107500","itemloans_cuota_cancelada":"430000"},{"id":249,"loans_codigo":70,"itemloans_cuota":"2","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T12:35:02.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"140000","itemloans_cuota_cancelada":"560000"},{"id":253,"loans_codigo":70,"itemloans_cuota":"3","itemloans_valor_cuota":"386666.66666667","itemloans_iteres":"96666.666666667","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T12:35:02.000000Z","updated_at":"2024-11-04T12:38:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"120000","itemloans_cuota_cancelada":"480000"},{"id":256,"loans_codigo":70,"itemloans_cuota":"4","itemloans_valor_cuota":"340000","itemloans_iteres":"85000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T12:38:20.000000Z","updated_at":"2024-11-04T12:38:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":257,"loans_codigo":70,"itemloans_cuota":"5","itemloans_valor_cuota":"340000","itemloans_iteres":"85000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T12:38:20.000000Z","updated_at":"2024-11-04T12:38:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":411,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:44:30
32236	9d695d2c-6645-49bc-861f-ec82e85e6124	9d695d2c-673e-4d54-89c3-2c9f04f38630	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mar"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:43
23289	9d689281-b58c-4278-83c8-e8cabcf5433f	9d689281-ba4a-4c04-8ffe-347a1b54192a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":234,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:50:01
32237	9d695d2c-a8e0-471a-b099-49cd0f07518f	9d695d2c-ad17-45a9-a73c-6b12bb60e1f7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":149,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:16:43
23290	9d689282-230e-4a50-953f-5f6481f4e5b1	9d689282-566a-40bf-885b-d65334262778	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 07:50:01
23291	9d689282-4400-4333-adcf-53475565299b	9d689282-566a-40bf-885b-d65334262778	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 70 limit 1","time":"4.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":498,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 07:50:01
23292	9d689282-449f-4a7f-b1c1-54c792cd6653	9d689282-566a-40bf-885b-d65334262778	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":2,"hostname":"EderCortes"}	2024-11-04 07:50:01
23293	9d689282-46cd-4120-9c4b-a00a8c281072	9d689282-566a-40bf-885b-d65334262778	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 487500, \\"loans_pago_prestado\\" = 1950000, \\"updated_at\\" = '2024-11-04 07:50:01' where \\"id\\" = 70","time":"1.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":556,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 07:50:01
23294	9d689282-4745-43ef-975f-e43601366d4e	9d689282-566a-40bf-885b-d65334262778	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:70","changes":{"updated_at":"2024-11-04 07:50:01","loans_pago_interes":487500,"loans_pago_prestado":1950000},"hostname":"EderCortes"}	2024-11-04 07:50:01
23295	9d689282-48e0-4c28-be5f-ad4cc1520a54	9d689282-566a-40bf-885b-d65334262778	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 70 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"2.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":563,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 07:50:01
23296	9d689282-4920-42c9-bad3-a5f18caa848c	9d689282-566a-40bf-885b-d65334262778	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 07:50:01
23297	9d689282-49be-4876-aa9b-2eb318ca3f96	9d689282-566a-40bf-885b-d65334262778	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = 120000, \\"itemloans_cuota_cancelada\\" = 480000, \\"updated_at\\" = '2024-11-04 07:50:01' where \\"id\\" = 256","time":"0.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":570,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 07:50:01
23298	9d689282-4a03-4811-b3cb-421f9d4d44fe	9d689282-566a-40bf-885b-d65334262778	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:256","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 07:50:01","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":120000,"itemloans_cuota_cancelada":480000},"hostname":"EderCortes"}	2024-11-04 07:50:01
23299	9d689282-4aa7-432c-a95a-5902cd468ebe	9d689282-566a-40bf-885b-d65334262778	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select count(*) as aggregate from \\"item_loans\\" where \\"loans_codigo\\" = 70 and \\"itemloans_status\\" = 'Pagada'","time":"0.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":578,"hash":"60bd91eaa209a639fc2e8afc20430a4b","hostname":"EderCortes"}	2024-11-04 07:50:01
23300	9d689282-4b25-4037-8377-daad98ae9fd0	9d689282-566a-40bf-885b-d65334262778	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"delete from \\"item_loans\\" where \\"loans_codigo\\" = 70 and \\"itemloans_status\\" = 'Pendiente'","time":"0.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":602,"hash":"89bf3c496a8b0746ff5d1219b8dc29e3","hostname":"EderCortes"}	2024-11-04 07:50:01
23301	9d689282-4bb4-421e-9705-c613fbdbc996	9d689282-566a-40bf-885b-d65334262778	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 70 limit 1","time":"0.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":605,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 07:50:01
23302	9d689282-4cf3-4a78-929a-a0c833e2c802	9d689282-566a-40bf-885b-d65334262778	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (70, 5, 200000, 50000, 'Pendiente', 'Se realiza abono', '12-11-2024', 12, 0, 0, '2024-11-04 07:50:01', '2024-11-04 07:50:01')","time":"1.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":673,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 07:50:01
23303	9d689282-4d1d-41eb-9b12-722c287357b0	9d689282-566a-40bf-885b-d65334262778	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 07:50:01
23304	9d689282-54b5-4143-a794-4750f2f31cf2	9d689282-566a-40bf-885b-d65334262778	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 07:50:01
23305	9d689282-5513-4a0f-aa20-30e13d640b8f	9d689282-566a-40bf-885b-d65334262778	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"51","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"600000","idLoans":70,"idCreador":12},"session":[],"response_status":200,"response":{"message":"El abono fue aplicado exitosamente","status":true},"duration":326,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:50:01
32238	9d695d2c-fecb-4aa5-b5c7-808ee318bd44	9d695d2d-1a0b-4c82-9aea-26df697939b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 17:16:43
32239	9d695d2d-158f-4d3d-98ce-b02aebda0f19	9d695d2d-1a0b-4c82-9aea-26df697939b0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"41.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 17:16:43
32240	9d695d2d-18bb-468d-9140-b3d0d3239a9a	9d695d2d-1a0b-4c82-9aea-26df697939b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 17:16:43
32241	9d695d2d-1907-47af-8807-1ebead70e5c7	9d695d2d-1a0b-4c82-9aea-26df697939b0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":221,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:43
32242	9d695d2d-561a-4f6b-b82b-b3d381380486	9d695d2d-5919-4e51-8e1c-4cf6dcf06585	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":141,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:16:43
27246	9d68e344-7b3b-41d9-ad38-5ec49aa8fd6f	9d68e344-ccad-46f7-8095-7342e725020e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 11:35:50
27247	9d68e344-ca92-4b24-a448-2fb47c6249cd	9d68e344-ccad-46f7-8095-7342e725020e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:35:50
27248	9d68e344-cb7e-45e4-9bb1-e3a7676d97f2	9d68e344-ccad-46f7-8095-7342e725020e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":550,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:35:50
27249	9d68e345-6ff3-4bbf-b49e-db86a7c2824c	9d68e345-bd95-4909-8b0e-e136b55a8411	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:35:51
27250	9d68e345-b2c7-4024-a13f-244be8d771d0	9d68e345-bd95-4909-8b0e-e136b55a8411	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"157.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:35:51
27251	9d68e345-b751-4af6-a6d8-0402ec86e953	9d68e345-bd95-4909-8b0e-e136b55a8411	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:35:51
27252	9d68e345-b797-474f-995d-c25216f3ef58	9d68e345-bd95-4909-8b0e-e136b55a8411	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:35:51
27253	9d68e345-bc47-4bb6-a6dd-57d768bb588c	9d68e345-bd95-4909-8b0e-e136b55a8411	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:35:51
27254	9d68e345-bc9c-4ee3-9ce1-d3fb3c0028ca	9d68e345-bd95-4909-8b0e-e136b55a8411	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":562,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:35:51
32243	9d695d2d-d20b-4b27-8738-451f4f933701	9d695d2d-eccd-45cb-8ae7-8b689f080e48	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 17:16:44
32244	9d695d2d-e891-46a5-8b55-aa011e457ef5	9d695d2d-eccd-45cb-8ae7-8b689f080e48	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"40.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 17:16:44
32245	9d695d2d-eb93-4728-86fc-4591b3068b51	9d695d2d-eccd-45cb-8ae7-8b689f080e48	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-04 17:16:44
32246	9d695d2d-ebdc-445f-b360-b95927a26d49	9d695d2d-eccd-45cb-8ae7-8b689f080e48	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:44
32247	9d695d2e-2bd2-4600-9da1-1749a50043ef	9d695d2e-2f11-4590-9874-8f61093d5e7d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":142,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:16:44
32248	9d695d2e-8a4b-498b-a6c5-d75e8e54c84c	9d695d2e-a567-441d-905d-97ec7e6792ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-04 17:16:44
32249	9d695d2e-a0ed-47d6-83de-1e010862ab4d	9d695d2e-a567-441d-905d-97ec7e6792ec	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"40.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 17:16:44
32250	9d695d2e-a401-4f9e-b339-d05116e5b69a	9d695d2e-a567-441d-905d-97ec7e6792ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-04 17:16:44
32251	9d695d2e-a44d-4298-81a6-5e6da7b0e55f	9d695d2e-a567-441d-905d-97ec7e6792ec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"28","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":245,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:44
32252	9d695d2e-f70f-49ac-bc10-9227a4a71e94	9d695d2f-3d41-43b1-a8a2-b9d59d38bcb0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-04 17:16:44
32253	9d695d2f-38aa-4e29-a77a-a1597d2e10f9	9d695d2f-3d41-43b1-a8a2-b9d59d38bcb0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"147.48","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 17:16:45
32254	9d695d2f-3bf5-44d3-a4ac-27a9e958f162	9d695d2f-3d41-43b1-a8a2-b9d59d38bcb0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-04 17:16:45
32255	9d695d2f-3c45-4357-a2d9-5d97a93441c2	9d695d2f-3d41-43b1-a8a2-b9d59d38bcb0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":375,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:45
32256	9d695d2f-7fcb-4ea2-b672-cf75bc1c9d65	9d695d2f-c394-4c12-93e9-74e00bf02118	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-04 17:16:45
32257	9d695d2f-beaa-4d99-9ac3-cd8784d407d1	9d695d2f-c394-4c12-93e9-74e00bf02118	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"143.67","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 17:16:45
32258	9d695d2f-c255-464c-bdf2-73ef26114261	9d695d2f-c394-4c12-93e9-74e00bf02118	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-11-04 17:16:45
32259	9d695d2f-c2a3-4d7d-8433-39f6c5ea0826	9d695d2f-c394-4c12-93e9-74e00bf02118	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"28","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":331,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:45
32260	9d695d30-1498-44f4-92be-a7b5276e53f0	9d695d30-56eb-4085-b572-74e814954822	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-11-04 17:16:45
32261	9d695d30-52b6-4e2f-876b-fc716f51925a	9d695d30-56eb-4085-b572-74e814954822	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"143.46","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 17:16:45
32262	9d695d30-559f-4946-ac9d-d2be85725b0d	9d695d30-56eb-4085-b572-74e814954822	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-11-04 17:16:45
18445	9d66917f-dcf6-4705-83e1-0a180ff9099f	9d669184-3b93-4198-ac4f-a4583f3093b8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 07:55:33
18446	9d669183-eaca-4418-b936-2d3fc7fb4a05	9d669184-3b93-4198-ac4f-a4583f3093b8	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 07:55:35
18447	9d669184-0b48-444a-a906-c632be6e7b27	9d669184-3b93-4198-ac4f-a4583f3093b8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":20645,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:55:35
32263	9d695d30-55ec-46ba-8834-6dd0ad3d3e85	9d695d30-56eb-4085-b572-74e814954822	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":358,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:45
18448	9d669184-bdf6-4b80-bf97-ef2030df216d	9d669185-bd78-4c0d-9d78-0bf3d80ad0e8	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 07:55:36
18449	9d669185-10f1-4dcb-a8a6-38d3716824f7	9d669185-bd78-4c0d-9d78-0bf3d80ad0e8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"148.12","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58,"hash":"77f8314368b36a9393ec9c7735a91700","hostname":"EderCortes"}	2024-11-03 07:55:36
18450	9d669185-bc41-49cd-bd0a-acfbd8774421	9d669185-bd78-4c0d-9d78-0bf3d80ad0e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 07:55:36
18451	9d669185-bc94-4dbe-957b-596ca11494e3	9d669185-bd78-4c0d-9d78-0bf3d80ad0e8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":891,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:55:36
32264	9d695d30-9c0c-4cac-be01-36572fee1ab2	9d695d30-b6ff-44c6-b839-cbfb2a5cfd0c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-11-04 17:16:45
32265	9d695d30-b2bc-4a37-82c6-28ea818a584b	9d695d30-b6ff-44c6-b839-cbfb2a5cfd0c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"40.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 17:16:45
32266	9d695d30-b5c8-4507-a66c-2fdc8fb68c16	9d695d30-b6ff-44c6-b839-cbfb2a5cfd0c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-11-04 17:16:46
32267	9d695d30-b612-4cbe-9d8c-a51cb8392019	9d695d30-b6ff-44c6-b839-cbfb2a5cfd0c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:46
27382	9d68e449-6eed-41c4-8dcc-49141956dfca	9d68e449-8e3d-4f86-ac93-03d53a3bcb21	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:38:41
27383	9d68e449-8c9d-4afb-aa90-4a3734afdb37	9d68e449-8e3d-4f86-ac93-03d53a3bcb21	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:38:41
27384	9d68e449-8d36-42c4-b2da-6cf1ce828559	9d68e449-8e3d-4f86-ac93-03d53a3bcb21	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":420,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:38:41
32268	9d695d30-fba9-4342-aae2-2f55b4f10703	9d695d31-3d0f-45ca-bccb-c0bc6a1ac686	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-11-04 17:16:46
32269	9d695d31-3863-4483-aae2-5349671ddac0	9d695d31-3d0f-45ca-bccb-c0bc6a1ac686	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"139.07","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 17:16:46
32270	9d695d31-3bce-4235-a267-3e9421c8bc3d	9d695d31-3d0f-45ca-bccb-c0bc6a1ac686	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-11-04 17:16:46
27385	9d68e44a-0ee4-459f-a151-d64e08325f40	9d68e44a-6050-4200-8da2-c9d76535dfb1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:38:42
27386	9d68e44a-5610-474c-831e-7c466be6e35b	9d68e44a-6050-4200-8da2-c9d76535dfb1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"169.59","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:38:42
27387	9d68e44a-5ac2-4b78-bb67-9a8f1db5ca81	9d68e44a-6050-4200-8da2-c9d76535dfb1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:38:42
27388	9d68e44a-5b06-49a5-a3c5-f04b425ef2bf	9d68e44a-6050-4200-8da2-c9d76535dfb1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:38:42
27389	9d68e44a-5f1d-48d9-b332-4d65b50993fd	9d68e44a-6050-4200-8da2-c9d76535dfb1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 11:38:42
27390	9d68e44a-5f6e-4939-91f5-2758f32c545b	9d68e44a-6050-4200-8da2-c9d76535dfb1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":490,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:38:42
32271	9d695d31-3c1b-4f2a-9bce-696f5e004312	9d695d31-3d0f-45ca-bccb-c0bc6a1ac686	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":334,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:46
32272	9d695d31-8086-47d7-8b72-1b8d167d758b	9d695d31-83cb-45e8-bd8b-55ec87b21948	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":150,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:46
21071	9d671a28-63a4-40ae-9ba9-fa7836122d98	9d671a2c-8d32-4773-abf7-761328406d85	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 14:17:40
21072	9d671a2c-3f87-45de-919f-9a8b27ded1dd	9d671a2c-8d32-4773-abf7-761328406d85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 14:17:42
21073	9d671a2c-5f88-4909-b377-34867f828522	9d671a2c-8d32-4773-abf7-761328406d85	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":16360,"memory":22,"hostname":"EderCortes"}	2024-11-03 14:17:43
32273	9d695d32-661a-43c2-b599-6c1e07978268	9d695d32-abec-498a-9202-692336daf239	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-11-04 17:16:47
32274	9d695d32-a1c6-4d67-b46f-c2c1edc5f16a	9d695d32-abec-498a-9202-692336daf239	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"128.00","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 17:16:47
32275	9d695d32-a9c1-48cd-bf39-7919c756a68c	9d695d32-abec-498a-9202-692336daf239	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":29,"hostname":"EderCortes"}	2024-11-04 17:16:47
21074	9d671a2d-0b2c-4733-b909-16aa630bf085	9d671a2d-df2d-4a1f-9197-0e3d22c80f6f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 14:17:43
21075	9d671a2d-2dd9-4cd9-945d-043469e673b9	9d671a2d-df2d-4a1f-9197-0e3d22c80f6f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"43.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 14:17:43
21076	9d671a2d-ddf5-48f5-b1c2-7693031942ff	9d671a2d-df2d-4a1f-9197-0e3d22c80f6f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 14:17:44
21077	9d671a2d-de4d-41ed-917e-ff7261158a7b	9d671a2d-df2d-4a1f-9197-0e3d22c80f6f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"37","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"10-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"17-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":null,"loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":745,"memory":22,"hostname":"EderCortes"}	2024-11-03 14:17:44
32276	9d695d32-aa49-47a6-8d8e-bcb8afa7c996	9d695d32-abec-498a-9202-692336daf239	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"28","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":443,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:47
21078	9d671a2f-cfb8-42e1-87b2-cd762a20ab94	9d671a30-3fc1-4a75-a5ec-aa15f4069cba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 14:17:45
21079	9d671a30-1de3-4669-afbc-2d9b47457861	9d671a30-3fc1-4a75-a5ec-aa15f4069cba	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"170.42","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 14:17:45
21080	9d671a30-1e5d-4f9f-9d09-3ff609919836	9d671a30-3fc1-4a75-a5ec-aa15f4069cba	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 14:17:45
21081	9d671a30-3e4f-4d69-bdd9-9d37838d7145	9d671a30-3fc1-4a75-a5ec-aa15f4069cba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 14:17:45
21082	9d671a30-3e9a-4f21-8ffd-5f1236b13230	9d671a30-3fc1-4a75-a5ec-aa15f4069cba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":525,"memory":22,"hostname":"EderCortes"}	2024-11-03 14:17:45
32277	9d695d3e-2776-4efb-9fe5-cc47a8861bd1	9d695d3e-6ff5-44f8-bf36-31d1d11998f8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":29,"hostname":"EderCortes"}	2024-11-04 17:16:54
32278	9d695d3e-6abb-4ff8-9291-6dd3ab6e594b	9d695d3e-6ff5-44f8-bf36-31d1d11998f8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '19' and \\"users\\".\\"deleted_at\\" is null","time":"151.08","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":55,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-11-04 17:16:54
32279	9d695d3e-6b14-42d2-987c-a3b1f073432a	9d695d3e-6ff5-44f8-bf36-31d1d11998f8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 17:16:54
32280	9d695d3e-6e99-44f9-b724-e77df7b66c59	9d695d3e-6ff5-44f8-bf36-31d1d11998f8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":30,"hostname":"EderCortes"}	2024-11-04 17:16:54
32281	9d695d3e-6ee8-430f-bfe7-82f7e676acc7	9d695d3e-6ff5-44f8-bf36-31d1d11998f8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/19","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:16:54
32282	9d695d9a-30ba-4314-9926-d7b587beeb51	9d695d9a-34cf-4ab7-a5df-7f0415841c6c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":170,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:17:55
32283	9d695d9a-9d69-4b30-ab92-32f2a00fb2f2	9d695d9a-f452-4e7c-a3f3-9716dce8cc55	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 17:17:55
32284	9d695d9a-e49c-47a5-b4ac-84e0956fb616	9d695d9a-f452-4e7c-a3f3-9716dce8cc55	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"loans_fecha_ultimo_pago\\", \\"loans_intereses_recaudar\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta 2', 'De las nieve', 'ds', 'CC', '1004655468', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon2', 'Calle 7505', '1000000', 25, 5, 'S', null, '04-11-2024', 'Pendiente', '312596295', 12, 22, 19, 18, '04-11-2024', '04-11-2024', 250000, 0, 0, '2024-11-04 17:17:55', '2024-11-04 17:17:55') returning \\"id\\"","time":"6.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":110,"hash":"1942e0e5f2555e71f5f5d75cd5941e3e","hostname":"EderCortes"}	2024-11-04 17:17:55
32285	9d695d9a-e54b-4122-965e-49ac8f73fb0d	9d695d9a-f452-4e7c-a3f3-9716dce8cc55	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:93","hostname":"EderCortes"}	2024-11-04 17:17:55
32286	9d695d9a-e77b-41b6-a988-941e9af9ffda	9d695d9a-f452-4e7c-a3f3-9716dce8cc55	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (93, 1, 200000, 50000, 'Pendiente', 'N\\/A', '12-11-2024', 12, 0, 0, '2024-11-04 17:17:55', '2024-11-04 17:17:55')","time":"3.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 17:17:55
32287	9d695d9a-e7b6-42b6-8b71-65b69581c23d	9d695d9a-f452-4e7c-a3f3-9716dce8cc55	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 17:17:55
32288	9d695d9a-e872-4232-af97-2a5b0a31338e	9d695d9a-f452-4e7c-a3f3-9716dce8cc55	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (93, 2, 200000, 50000, 'Pendiente', 'N\\/A', '20-11-2024', 12, 0, 0, '2024-11-04 17:17:55', '2024-11-04 17:17:55')","time":"0.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 17:17:55
32289	9d695d9a-e8ab-455b-8500-56024c06308b	9d695d9a-f452-4e7c-a3f3-9716dce8cc55	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 17:17:55
32290	9d695d9a-e96a-44a8-8714-50eda0ca8bc1	9d695d9a-f452-4e7c-a3f3-9716dce8cc55	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (93, 3, 200000, 50000, 'Pendiente', 'N\\/A', '28-11-2024', 12, 0, 0, '2024-11-04 17:17:55', '2024-11-04 17:17:55')","time":"0.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 17:17:55
32291	9d695d9a-e9a0-47af-b6cc-3948ee2a262a	9d695d9a-f452-4e7c-a3f3-9716dce8cc55	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 17:17:55
32292	9d695d9a-ea4f-4e7e-a5a8-f32d7164e423	9d695d9a-f452-4e7c-a3f3-9716dce8cc55	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (93, 4, 200000, 50000, 'Pendiente', 'N\\/A', '06-12-2024', 12, 0, 0, '2024-11-04 17:17:55', '2024-11-04 17:17:55')","time":"0.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 17:17:55
32293	9d695d9a-ea87-4359-a8b4-1e626ef5a8f9	9d695d9a-f452-4e7c-a3f3-9716dce8cc55	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 17:17:55
32294	9d695d9a-eb3e-4b9f-ad4b-b46bed4a8d68	9d695d9a-f452-4e7c-a3f3-9716dce8cc55	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (93, 5, 200000, 50000, 'Pendiente', 'N\\/A', '14-12-2024', 12, 0, 0, '2024-11-04 17:17:55', '2024-11-04 17:17:55')","time":"0.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 17:17:55
32295	9d695d9a-eb74-4cfb-9268-108a39e661a5	9d695d9a-f452-4e7c-a3f3-9716dce8cc55	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 17:17:55
32296	9d695d9a-f1f8-4463-b6f5-717c00539c62	9d695d9a-f452-4e7c-a3f3-9716dce8cc55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 17:17:55
32297	9d695d9a-f2de-4238-aab9-4ba386d5ef9c	9d695d9a-f452-4e7c-a3f3-9716dce8cc55	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"860","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"1004655468","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_valor_prestado":"1000000","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":22,"user_customer":19,"user_recomendacion":18,"loans_inicio_pago":"Mon Nov 04 2024","loans_fecha_ultimo_pago":null,"loans_intereses_recaudar":null,"created_at":null,"updated_at":null,"deleted_at":null,"loans_pago_prestado":0,"loans_pago_interes":0},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Mon Nov 04 2024","aprobador":12}},"session":[],"response_status":200,"response":{"message":"Registro creado exitosamente","id":93},"duration":410,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:17:55
34632	9d69bf2f-83c0-4a47-9c34-f32765f612cc	9d69bf2f-a343-4cf0-9b3d-a4a6020c765c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:50:46
34633	9d69bf2f-a195-4322-9a9d-efdadea4fb9b	9d69bf2f-a343-4cf0-9b3d-a4a6020c765c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:50:46
34634	9d69bf2f-a24f-4ba2-a843-2f8b58590650	9d69bf2f-a343-4cf0-9b3d-a4a6020c765c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:50:46
32298	9d695dad-2ee3-4dd5-8667-132b4f65a04b	9d695dad-4948-4952-ba2d-b98688a6664b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 17:18:07
32299	9d695dad-4484-438b-b6ea-283069dc42a8	9d695dad-4948-4952-ba2d-b98688a6664b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"42.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 17:18:07
32300	9d695dad-47cc-4351-a89f-84d24e9f5659	9d695dad-4948-4952-ba2d-b98688a6664b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 17:18:07
32301	9d695dad-483e-4d68-9e8a-44bc74bd52e4	9d695dad-4948-4952-ba2d-b98688a6664b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":291,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:18:07
19620	9d66e258-3029-4c94-84c4-983b3ef7748e	9d66e258-5360-413e-901b-838e1d89a9b7	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 11:41:36
19621	9d66e258-51a9-44b0-afcc-6da02f2a93ef	9d66e258-5360-413e-901b-838e1d89a9b7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:41:36
19622	9d66e258-5259-44c6-992d-0ea750da6b39	9d66e258-5360-413e-901b-838e1d89a9b7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":294,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:41:36
27544	9d68e7f8-4b11-47cc-bc3c-ac17a8b7b7f5	9d68e7f8-76f5-4613-a390-8f112485dc61	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 11:48:59
34635	9d69bf2f-fd59-4d1c-8346-926a3b20cbfe	9d69bf30-1b7c-4dfe-af37-cf994dec950a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:50:47
33080	9d69a8d2-70f2-4e52-936b-60300d8580d2	9d69a8d2-a9d7-43fb-b779-395f0b9c7ed1	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 20:48:14
33081	9d69a8d2-a5da-46df-8476-f3235295cd63	9d69a8d2-a9d7-43fb-b779-395f0b9c7ed1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 20:48:15
33082	9d69a8d2-a70b-4f3e-aa51-c93b4c2e7d9c	9d69a8d2-a9d7-43fb-b779-395f0b9c7ed1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":434,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:48:15
34636	9d69bf30-1674-4515-a358-a14eaba7c599	9d69bf30-1b7c-4dfe-af37-cf994dec950a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":257,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:50:47
34637	9d69bf30-16c6-43f4-9361-618d241d8f07	9d69bf30-1b7c-4dfe-af37-cf994dec950a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:50:47
34638	9d69bf30-1a4b-4c78-ade2-71d8e4cdb690	9d69bf30-1b7c-4dfe-af37-cf994dec950a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:50:47
34639	9d69bf30-1a93-4904-a5d5-176a2988e425	9d69bf30-1b7c-4dfe-af37-cf994dec950a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:50:47
19623	9d66e258-b1b3-4e37-a8fd-65882b854ab1	9d66e258-d0d9-4f66-aa9a-33ade4af91c6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:41:36
19624	9d66e258-c78a-486b-bddc-39a210966ec2	9d66e258-d0d9-4f66-aa9a-33ade4af91c6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"42.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 11:41:36
17004	9d6546f0-c0db-4a31-b389-73b0a211cd08	9d6546f0-e23e-4fa1-b5f2-1120250d1909	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 16:31:14
17005	9d6546f0-e037-4984-a397-d5752fe5269f	9d6546f0-e23e-4fa1-b5f2-1120250d1909	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 16:31:14
17006	9d6546f0-e101-48af-b2d9-1416bfcb134c	9d6546f0-e23e-4fa1-b5f2-1120250d1909	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:31:14
19625	9d66e258-cb7d-414c-a003-8a7a611b8aba	9d66e258-d0d9-4f66-aa9a-33ade4af91c6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:41:36
19626	9d66e258-cbab-4c80-a419-55c79c5a58b8	9d66e258-d0d9-4f66-aa9a-33ade4af91c6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:41:36
19627	9d66e258-cf8e-4aef-a1e2-6519b1e8d007	9d66e258-d0d9-4f66-aa9a-33ade4af91c6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:41:36
19628	9d66e258-cfd8-4495-b8fe-99876c361bf4	9d66e258-d0d9-4f66-aa9a-33ade4af91c6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":277,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:41:36
27545	9d68e7f8-741a-45c0-a76f-1f8041681e06	9d68e7f8-76f5-4613-a390-8f112485dc61	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:48:59
27546	9d68e7f8-7560-4057-a70b-14c6495c6016	9d68e7f8-76f5-4613-a390-8f112485dc61	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":431,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:48:59
32302	9d695db2-43d1-47c6-84af-d3a7edf0b7d5	9d695db2-9072-4e12-af55-740f6bee9865	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 17:18:10
32303	9d695db2-8b42-46b7-975e-89f40bc85c90	9d695db2-9072-4e12-af55-740f6bee9865	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"152.62","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":227,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 17:18:11
32304	9d695db2-8bae-4e6f-a3ae-edda1968034f	9d695db2-9072-4e12-af55-740f6bee9865	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 17:18:11
32305	9d695db2-8f2d-4186-ab79-8e5914cddd6a	9d695db2-9072-4e12-af55-740f6bee9865	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 17:18:11
32306	9d695db2-8f78-4011-af54-fd8dfb92a418	9d695db2-9072-4e12-af55-740f6bee9865	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:18:11
33083	9d69a8d3-7585-4a42-9afe-4be1b5883b94	9d69a8d3-9ab9-4f8f-a584-1eaeaa6dc915	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 20:48:15
34640	9d69bf30-5ce0-4e2b-a69e-8cab53e4a717	9d69bf30-7b86-4ba3-8faa-5ad7c816caf4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:50:47
34641	9d69bf30-7658-4fba-a1e9-c21f13e95270	9d69bf30-7b86-4ba3-8faa-5ad7c816caf4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":246,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 21:50:47
19629	9d66e25a-ceda-4f40-aa46-b2d9761476ff	9d66e25a-ec09-4e27-a0af-346b68df12b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:41:38
19630	9d66e25a-e715-47ea-b29d-74fe5db28e30	9d66e25a-ec09-4e27-a0af-346b68df12b9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:41:38
19631	9d66e25a-e762-4702-b52f-24541e0f864d	9d66e25a-ec09-4e27-a0af-346b68df12b9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:41:38
19632	9d66e25a-ead2-43a7-9919-d5aedc5c45c8	9d66e25a-ec09-4e27-a0af-346b68df12b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 11:41:38
19633	9d66e25a-eb22-49c6-a433-74382ccb6b7a	9d66e25a-ec09-4e27-a0af-346b68df12b9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":268,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:41:38
27547	9d68e7f9-222f-4504-b696-cc1f4eb3eb93	9d68e7f9-4b9d-46df-82ed-c9953bc8067c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:49:00
27548	9d68e7f9-4051-4ea3-9761-13d941cb4212	9d68e7f9-4b9d-46df-82ed-c9953bc8067c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"61.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:49:00
27549	9d68e7f9-44cb-461a-91ef-3415a391e0b5	9d68e7f9-4b9d-46df-82ed-c9953bc8067c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:49:00
27550	9d68e7f9-450c-4b5e-b47e-c55d73caf078	9d68e7f9-4b9d-46df-82ed-c9953bc8067c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:49:00
27551	9d68e7f9-4a0c-45fb-8dae-663db875833e	9d68e7f9-4b9d-46df-82ed-c9953bc8067c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:49:00
27552	9d68e7f9-4a75-4a00-92dc-14fdb0cafdb7	9d68e7f9-4b9d-46df-82ed-c9953bc8067c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":483,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:49:00
32307	9d695db2-d0ab-4ece-8c91-c5232e98144a	9d695db3-175b-4e63-96a4-cc117d28de62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 17:18:11
32308	9d695db3-1213-46fb-bd47-8a52522db4d5	9d695db3-175b-4e63-96a4-cc117d28de62	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"145.02","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":216,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 17:18:11
32309	9d695db3-1269-429d-9840-973ea3081573	9d695db3-175b-4e63-96a4-cc117d28de62	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 17:18:11
32310	9d695db3-1621-411d-99cc-65510658f829	9d695db3-175b-4e63-96a4-cc117d28de62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 17:18:11
32311	9d695db3-166f-44a0-bea2-c4730aaf39e1	9d695db3-175b-4e63-96a4-cc117d28de62	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":332,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:18:11
33084	9d69a8d3-911e-4878-9820-568c64a6eed1	9d69a8d3-9ab9-4f8f-a584-1eaeaa6dc915	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"51.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 20:48:15
33085	9d69a8d3-9484-4564-a7ae-f3390e5ca5d0	9d69a8d3-9ab9-4f8f-a584-1eaeaa6dc915	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 20:48:15
33086	9d69a8d3-9947-4e5a-bfa6-587179382a67	9d69a8d3-9ab9-4f8f-a584-1eaeaa6dc915	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 20:48:15
33087	9d69a8d3-99ac-41cf-b887-ebe5989f51d7	9d69a8d3-9ab9-4f8f-a584-1eaeaa6dc915	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1064000","loans_pago_interes":"266000","user_alias":"eder.cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:39","updated_at":"2024-11-04 10:36:27","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 10:36:27","updated_at":"2024-11-04 10:39:58","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000","user_alias":"eder.cortes"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 10:36:27","updated_at":"2024-11-04 13:14:01","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000","user_alias":"eder.cortes"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 10:36:27","updated_at":"2024-11-04 20:47:05","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"120000","itemloans_cuota_cancelada":"480000","user_alias":"eder.cortes"},{"id":439,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"12000","itemloans_iteres":"3000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:47:05","updated_at":"2024-11-04 20:47:05","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":440,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"12000","itemloans_iteres":"3000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:47:05","updated_at":"2024-11-04 20:47:05","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":441,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"12000","itemloans_iteres":"3000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:47:05","updated_at":"2024-11-04 20:47:05","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":477,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:48:15
34642	9d69bf30-76b1-4251-a3dc-cf2da54a35bb	9d69bf30-7b86-4ba3-8faa-5ad7c816caf4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 21:50:47
34643	9d69bf30-7a4e-449a-b0f5-8c3a95c173c0	9d69bf30-7b86-4ba3-8faa-5ad7c816caf4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 21:50:47
34644	9d69bf30-7a9a-45a2-8353-b76d0915bfc4	9d69bf30-7b86-4ba3-8faa-5ad7c816caf4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:50:47
33088	9d69a8d5-ab7b-4499-85e3-26970c02661b	9d69a8d5-f8b2-44c0-bbed-00ecc93a91e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 20:48:17
18604	9d6695f2-959d-483e-8c50-0f425a2af651	9d6695f2-ccdd-4c16-ad8f-ac59f090a4d4	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 08:07:59
18605	9d6695f2-ca00-47a5-8265-6792a51c09a2	9d6695f2-ccdd-4c16-ad8f-ac59f090a4d4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:07:59
18606	9d6695f2-cb3f-470a-b54b-16beb4dbe4e0	9d6695f2-ccdd-4c16-ad8f-ac59f090a4d4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":422,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:07:59
33089	9d69a8d5-f0f3-4560-bdfb-1c706bef611b	9d69a8d5-f8b2-44c0-bbed-00ecc93a91e1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"153.25","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 20:48:17
33090	9d69a8d5-f14d-4429-aada-646e5cf4be71	9d69a8d5-f8b2-44c0-bbed-00ecc93a91e1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 20:48:17
33091	9d69a8d5-f6bb-45d4-b18b-020ea2225ef2	9d69a8d5-f8b2-44c0-bbed-00ecc93a91e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 20:48:17
32312	9d695db3-56f6-484a-9e31-ebf3e50aad49	9d695db3-72fd-4e37-8c1d-8bcee097d9fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 17:18:11
32313	9d695db3-6e1c-4382-9653-9872254e9b03	9d695db3-72fd-4e37-8c1d-8bcee097d9fb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"37.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 17:18:11
32314	9d695db3-6e71-466a-9215-a5a208a3e7e4	9d695db3-72fd-4e37-8c1d-8bcee097d9fb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 17:18:11
32315	9d695db3-71be-420b-8436-2a57ab41a57f	9d695db3-72fd-4e37-8c1d-8bcee097d9fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 17:18:11
33092	9d69a8d5-f737-4f96-8ab7-af8265cf10e3	9d69a8d5-f8b2-44c0-bbed-00ecc93a91e1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":392,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:48:17
34645	9d69bf30-c604-429a-b9ce-5d02b2a91026	9d69bf30-e32f-4099-833c-557d56e43838	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 21:50:47
34646	9d69bf30-de27-4228-a23b-1b843a2f28a6	9d69bf30-e32f-4099-833c-557d56e43838	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:50:47
34647	9d69bf30-de8b-4d31-8a48-3214d5556119	9d69bf30-e32f-4099-833c-557d56e43838	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:50:47
34648	9d69bf30-e206-4f11-b774-359690247ea4	9d69bf30-e32f-4099-833c-557d56e43838	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 21:50:47
34649	9d69bf30-e24f-4074-a73d-d35b4e4c2424	9d69bf30-e32f-4099-833c-557d56e43838	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:50:47
18607	9d6695f3-574d-44d5-b5d4-3b7bb027cdcd	9d6695f3-a233-42e2-b2b3-2ddc701624d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:07:59
18608	9d6695f3-9bf7-4b0e-b312-238a15a728e3	9d6695f3-a233-42e2-b2b3-2ddc701624d5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"155.62","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58,"hash":"77f8314368b36a9393ec9c7735a91700","hostname":"EderCortes"}	2024-11-03 08:07:59
18609	9d6695f3-a09f-4dab-8dd5-799ec502c3cf	9d6695f3-a233-42e2-b2b3-2ddc701624d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:07:59
18610	9d6695f3-a128-4688-850f-043fe699d44a	9d6695f3-a233-42e2-b2b3-2ddc701624d5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":464,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:07:59
32316	9d695db3-720c-41ce-a22c-d26c1e42bf58	9d695db3-72fd-4e37-8c1d-8bcee097d9fb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":221,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:18:11
33093	9d69a8df-b833-4017-b62f-41c0b098ba7e	9d69a8df-bb6d-4f8e-9c72-ce1158481db4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":159,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:48:23
18611	9d6695f5-d0ee-44ca-95cd-9631d0f494d0	9d6695f6-0968-471d-ac1c-862d3e2eef50	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:08:01
18612	9d6695f6-0099-4577-b282-a305d1a9ca53	9d6695f6-0968-471d-ac1c-862d3e2eef50	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"97.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 08:08:01
18613	9d6695f6-0121-44c7-abb7-d953cc42ad3f	9d6695f6-0968-471d-ac1c-862d3e2eef50	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 08:08:01
18614	9d6695f6-06df-4dba-9585-752d08ed1348	9d6695f6-0968-471d-ac1c-862d3e2eef50	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 08:08:01
18615	9d6695f6-079f-4a84-982c-0e83e7075c5f	9d6695f6-0968-471d-ac1c-862d3e2eef50	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":405,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:08:01
32317	9d695db3-b436-4932-82f5-14b742bdc40c	9d695db3-d1b7-4422-9799-82e3b8628d4b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 17:18:11
32318	9d695db3-caf3-4ac1-81a6-0b65369d9f93	9d695db3-d1b7-4422-9799-82e3b8628d4b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '93' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"39.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 17:18:11
32319	9d695db3-cb5b-4dec-a42d-8c5f96ce3fe6	9d695db3-d1b7-4422-9799-82e3b8628d4b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 17:18:11
32320	9d695db3-ccf3-4bd0-b3b4-1891523fcf5e	9d695db3-d1b7-4422-9799-82e3b8628d4b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"1.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 17:18:11
32321	9d695db3-cd29-4416-9da6-c038dbd57cdc	9d695db3-d1b7-4422-9799-82e3b8628d4b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 17:18:11
32322	9d695db3-d05e-4431-894d-3006986a278e	9d695db3-d1b7-4422-9799-82e3b8628d4b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 17:18:11
32323	9d695db3-d0b5-438e-b449-aa8039f3db4e	9d695db3-d1b7-4422-9799-82e3b8628d4b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":93,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":18,"loans_valor_prestado":1000000,"user_customer":19,"user_cobrador":22,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:17:55.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"0","loans_pago_prestado":"0","loans_intereses_recaudar":"250000"},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:17:55.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:17:55.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":396,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:17:55.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":397,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:17:55.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":398,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:17:55.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":223,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:18:11
23544	9d689a34-6bd9-4bd7-bea3-f476828c1175	9d689a34-91a1-4293-8394-36c3645d28ed	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 08:11:32
23545	9d689a34-8f30-4cc1-ac9d-df6b5e69f1f9	9d689a34-91a1-4293-8394-36c3645d28ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 08:11:32
23546	9d689a34-8ff8-4efa-a611-0855ce719043	9d689a34-91a1-4293-8394-36c3645d28ed	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:11:32
23547	9d689a34-fda5-4103-8282-360e1d22b0e8	9d689a35-1ca4-48a6-bb24-dc0758e171a9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 08:11:33
23548	9d689a35-1336-4280-8100-c1f809bfd560	9d689a35-1ca4-48a6-bb24-dc0758e171a9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 69\\n                        ","time":"42.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"28d3d4f6fe6eff992a986b780c628d2e","hostname":"EderCortes"}	2024-11-04 08:11:33
23549	9d689a35-16ff-4f18-aed2-585ebd905416	9d689a35-1ca4-48a6-bb24-dc0758e171a9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '69' order by \\"item_loans\\".\\"id\\" asc","time":"1.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:11:33
23550	9d689a35-1733-4948-9a63-b66fa0b81368	9d689a35-1ca4-48a6-bb24-dc0758e171a9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 08:11:33
23551	9d689a35-1b6c-4b42-aeb0-63ee168b0c3f	9d689a35-1ca4-48a6-bb24-dc0758e171a9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 08:11:33
23552	9d689a35-1bb7-41fa-b71b-4e21883aa706	9d689a35-1ca4-48a6-bb24-dc0758e171a9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/69","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":69,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1150000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"920000","loans_pago_interes":"230000"},"items":[{"id":243,"loans_codigo":69,"itemloans_cuota":"1","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T13:01:48.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000"},{"id":244,"loans_codigo":69,"itemloans_cuota":"2","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T13:01:54.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000"},{"id":245,"loans_codigo":69,"itemloans_cuota":"3","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T13:02:55.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000"},{"id":246,"loans_codigo":69,"itemloans_cuota":"4","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T13:03:00.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000"},{"id":247,"loans_codigo":69,"itemloans_cuota":"5","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T05:49:09.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":281,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:11:33
32324	9d695dc1-7d22-435b-a19f-95ed0b67c6b7	9d695dc1-96d4-4ab6-8b67-29be68fa1c71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 17:18:20
32325	9d695dc1-92a0-4ba0-98d8-69f3f2a68c37	9d695dc1-96d4-4ab6-8b67-29be68fa1c71	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"42.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 17:18:20
32326	9d695dc1-956f-47c4-9eb4-2270df3ce644	9d695dc1-96d4-4ab6-8b67-29be68fa1c71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 17:18:20
32327	9d695dc1-95d8-40b0-84bf-706b563430a5	9d695dc1-96d4-4ab6-8b67-29be68fa1c71	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:18:20
23553	9d689a37-1ef1-4a3c-b2f9-8ec8c103bb70	9d689a37-64b6-4b38-b85a-354bbce8feb3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 08:11:34
23554	9d689a37-5f92-4320-bd3d-38fdc5263fb1	9d689a37-64b6-4b38-b85a-354bbce8feb3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"145.85","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 08:11:34
23555	9d689a37-5fee-4efb-a94e-f5ceaeffb78e	9d689a37-64b6-4b38-b85a-354bbce8feb3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 08:11:34
23556	9d689a37-6370-406a-be36-f279b9694859	9d689a37-64b6-4b38-b85a-354bbce8feb3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 08:11:34
23557	9d689a37-63b7-4091-957d-a7d316f7bf28	9d689a37-64b6-4b38-b85a-354bbce8feb3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":402,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:11:34
32328	9d695dc6-7320-4a7e-88d8-40f29033a192	9d695dc6-9086-43a3-ba0b-082cfac14c9d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 17:18:24
32329	9d695dc6-8b87-4abb-aba5-326f431d5833	9d695dc6-9086-43a3-ba0b-082cfac14c9d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"44.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 17:18:24
32330	9d695dc6-8ec2-49f2-84dc-02350df1df14	9d695dc6-9086-43a3-ba0b-082cfac14c9d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 17:18:24
32331	9d695dc6-8f34-4e85-9d82-3be8ea43a838	9d695dc6-9086-43a3-ba0b-082cfac14c9d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:18:24
23558	9d689a4a-83eb-4625-abb7-587cba4fce2b	9d689a4a-877d-409c-9463-d3a207f6765d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":167,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:11:47
32332	9d695dcf-fa7e-4d51-93b1-d53a6d28054b	9d695dd0-178e-4811-bf8c-854b89114741	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 17:18:30
32333	9d695dd0-107d-4d07-8c2c-e96e95885310	9d695dd0-178e-4811-bf8c-854b89114741	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 93\\n                        ","time":"42.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"9c742b70d7e4a1a77b260fd1a8993140","hostname":"EderCortes"}	2024-11-04 17:18:30
32334	9d695dd0-132f-4318-8284-9da5a9c1bf18	9d695dd0-178e-4811-bf8c-854b89114741	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"2.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 17:18:30
32335	9d695dd0-161e-4343-84a2-a4a9f013dd6a	9d695dd0-178e-4811-bf8c-854b89114741	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 17:18:30
32336	9d695dd0-166d-417f-ba44-dadfd174ea87	9d695dd0-178e-4811-bf8c-854b89114741	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":93,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0","user_alias":"eder.cortes"},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:17:55","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:17:55","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":396,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:17:55","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":397,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:17:55","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":398,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:17:55","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":313,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:18:30
33099	9d69a8e1-0822-44f1-88ee-3e82b795f5d9	9d69a8e1-267a-4f57-8d83-32156ea7ce33	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 20:48:24
33100	9d69a8e1-1e4f-436d-88f9-94eb4fe07163	9d69a8e1-267a-4f57-8d83-32156ea7ce33	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"43.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 20:48:24
32337	9d695e42-665f-4b7a-b53b-3e321dc92b86	9d695e42-6a4f-4937-bdc6-ab84dd683457	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":154,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:19:45
33101	9d69a8e1-2145-4dcb-bcbf-a25fdf81fc57	9d69a8e1-267a-4f57-8d83-32156ea7ce33	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 20:48:24
23559	9d689a4b-3958-4482-9ccf-5fd6fb1ec386	9d689a4b-5d8a-4eeb-9a08-36bbb8589276	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 08:11:47
19695	9d66e408-ab05-4b63-94b0-b7f70fedf853	9d66e408-f8fd-4c33-a34a-a739f002a5dc	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 11:46:19
19696	9d66e408-f72f-41b8-bcaa-0768dbba3b60	9d66e408-f8fd-4c33-a34a-a739f002a5dc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:46:20
19697	9d66e408-f7ea-4914-84f5-8f9cdd9eca85	9d66e408-f8fd-4c33-a34a-a739f002a5dc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:46:20
23560	9d689a4b-5042-41f3-b3ba-6336bd9c9bef	9d689a4b-5d8a-4eeb-9a08-36bbb8589276	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 69 limit 1","time":"2.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":498,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 08:11:47
33102	9d69a8e1-24f9-40c1-aad2-f4cfc3a65add	9d69a8e1-267a-4f57-8d83-32156ea7ce33	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 20:48:24
23561	9d689a4b-508e-4805-aa5a-aa1b5da2c04d	9d689a4b-5d8a-4eeb-9a08-36bbb8589276	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":2,"hostname":"EderCortes"}	2024-11-04 08:11:47
23562	9d689a4b-5213-43fb-abb7-6ca0ecd3e0d8	9d689a4b-5d8a-4eeb-9a08-36bbb8589276	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select count(*) as aggregate from \\"item_loans\\" where \\"loans_codigo\\" = 69 and \\"itemloans_status\\" = 'Pagada'","time":"1.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":545,"hash":"60bd91eaa209a639fc2e8afc20430a4b","hostname":"EderCortes"}	2024-11-04 08:11:47
23563	9d689a4b-52b1-4209-a13a-bcc674caabd1	9d689a4b-5d8a-4eeb-9a08-36bbb8589276	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 270000, \\"loans_pago_prestado\\" = 1080000, \\"updated_at\\" = '2024-11-04 08:11:47' where \\"id\\" = 69","time":"0.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":590,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 08:11:47
23564	9d689a4b-5310-40d2-809a-7510749a3dd8	9d689a4b-5d8a-4eeb-9a08-36bbb8589276	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:69","changes":{"updated_at":"2024-11-04 08:11:47","loans_pago_interes":270000,"loans_pago_prestado":1080000},"hostname":"EderCortes"}	2024-11-04 08:11:47
23565	9d689a4b-538c-4995-bf63-f49b37d16b7c	9d689a4b-5d8a-4eeb-9a08-36bbb8589276	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 69 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"0.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":597,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 08:11:47
23566	9d689a4b-53ba-4018-b7b9-2c174b2274e7	9d689a4b-5d8a-4eeb-9a08-36bbb8589276	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 08:11:47
23567	9d689a4b-542e-4fe0-be5a-029913447dc1	9d689a4b-5d8a-4eeb-9a08-36bbb8589276	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = 40000, \\"itemloans_cuota_cancelada\\" = 160000, \\"updated_at\\" = '2024-11-04 08:11:47' where \\"id\\" = 247","time":"0.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":604,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 08:11:47
23568	9d689a4b-5459-4abe-b4fe-163d098b5707	9d689a4b-5d8a-4eeb-9a08-36bbb8589276	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:247","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 08:11:47","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":40000,"itemloans_cuota_cancelada":160000},"hostname":"EderCortes"}	2024-11-04 08:11:47
33103	9d69a8e1-2552-46d2-b212-b993dc275556	9d69a8e1-267a-4f57-8d83-32156ea7ce33	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1064000","loans_pago_interes":"266000","user_alias":"eder.cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:39","updated_at":"2024-11-04 10:36:27","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 10:36:27","updated_at":"2024-11-04 10:39:58","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000","user_alias":"eder.cortes"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 10:36:27","updated_at":"2024-11-04 13:14:01","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000","user_alias":"eder.cortes"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 10:36:27","updated_at":"2024-11-04 20:47:05","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"120000","itemloans_cuota_cancelada":"480000","user_alias":"eder.cortes"},{"id":439,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"12000","itemloans_iteres":"3000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:47:05","updated_at":"2024-11-04 20:47:05","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":440,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"12000","itemloans_iteres":"3000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:47:05","updated_at":"2024-11-04 20:47:05","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":441,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"12000","itemloans_iteres":"3000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:47:05","updated_at":"2024-11-04 20:47:05","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:48:24
19698	9d66e409-5c12-46f5-b11f-afd379f935a6	9d66e409-a5cb-4d2e-ab14-0c95c72fa4f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:46:20
19699	9d66e409-9cb8-4561-9bd3-eadf8702e227	9d66e409-a5cb-4d2e-ab14-0c95c72fa4f6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"153.14","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 11:46:20
19700	9d66e409-a05b-496c-b4cf-ed47c768b186	9d66e409-a5cb-4d2e-ab14-0c95c72fa4f6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"1.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:46:20
19701	9d66e409-a08a-4449-87b5-9ea6e223e3d4	9d66e409-a5cb-4d2e-ab14-0c95c72fa4f6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:46:20
19702	9d66e409-a4a6-4fa4-91ea-408ef419059c	9d66e409-a5cb-4d2e-ab14-0c95c72fa4f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:46:20
19703	9d66e409-a4ed-4eb8-a887-d1b5037e9e97	9d66e409-a5cb-4d2e-ab14-0c95c72fa4f6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":null,"loans_pago_interes":null},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":380,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:46:20
23569	9d689a4b-54a9-4f23-a84e-811edde0dbf3	9d689a4b-5d8a-4eeb-9a08-36bbb8589276	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"delete from \\"item_loans\\" where \\"loans_codigo\\" = 69 and \\"itemloans_status\\" = 'Pendiente'","time":"0.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":611,"hash":"89bf3c496a8b0746ff5d1219b8dc29e3","hostname":"EderCortes"}	2024-11-04 08:11:47
23570	9d689a4b-5500-4a2d-a95e-54c50fa8a81f	9d689a4b-5d8a-4eeb-9a08-36bbb8589276	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 69 limit 1","time":"0.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":614,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 08:11:47
23571	9d689a4b-55f4-446b-bbde-6054585dfc4f	9d689a4b-5d8a-4eeb-9a08-36bbb8589276	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (69, 5, 70000, -270000, 'Pendiente', 'Se realiza abono', '20-11-2024', 12, 0, 0, '2024-11-04 08:11:47', '2024-11-04 08:11:47')","time":"1.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":666,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 08:11:47
23572	9d689a4b-5622-486f-9fb4-6a227837c6fa	9d689a4b-5d8a-4eeb-9a08-36bbb8589276	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 08:11:47
23573	9d689a4b-5bdb-471d-b75c-74b64a68ab77	9d689a4b-5d8a-4eeb-9a08-36bbb8589276	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 08:11:47
23574	9d689a4b-5c4c-4e5b-9fe1-1b847eca1ec3	9d689a4b-5d8a-4eeb-9a08-36bbb8589276	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"51","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"200000","idLoans":69,"idCreador":12},"session":[],"response_status":200,"response":{"message":"El abono fue aplicado exitosamente","status":true},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:11:47
32338	9d695e42-e986-4dc7-b862-430286ea6e2e	9d695e43-3f8e-424c-afef-c0f48d3a7bd8	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 17:19:45
32339	9d695e43-327b-4796-bd76-352d8deff5f0	9d695e43-3f8e-424c-afef-c0f48d3a7bd8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 394 limit 1","time":"2.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":362,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 17:19:45
19704	9d66e40b-59b0-4259-ae16-4feb0abac8c9	9d66e40b-77be-4bec-a417-f902d5aad389	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:46:21
19705	9d66e40b-7230-4da9-ab08-55a3ef544097	9d66e40b-77be-4bec-a417-f902d5aad389	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:46:21
19706	9d66e40b-72a0-430a-b722-a3099657b9f2	9d66e40b-77be-4bec-a417-f902d5aad389	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:46:21
19707	9d66e40b-767b-4e4c-8d1c-cc1f67696df1	9d66e40b-77be-4bec-a417-f902d5aad389	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 11:46:21
19708	9d66e40b-76bf-4d25-b18d-b00976c755e0	9d66e40b-77be-4bec-a417-f902d5aad389	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:46:21
32340	9d695e43-32ea-4c3b-8ebc-055ec9fdb5e1	9d695e43-3f8e-424c-afef-c0f48d3a7bd8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 17:19:45
32341	9d695e43-34d5-4bd6-8c11-8428c4051cbb	9d695e43-3f8e-424c-afef-c0f48d3a7bd8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 93 limit 1","time":"2.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":363,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 17:19:45
32342	9d695e43-3509-4cdf-9b3a-46333e6c99e6	9d695e43-3f8e-424c-afef-c0f48d3a7bd8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 17:19:45
32343	9d695e43-389f-4381-8c84-289daeb95a80	9d695e43-3f8e-424c-afef-c0f48d3a7bd8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '50000', \\"itemloans_cuota_cancelada\\" = '200000', \\"updated_at\\" = '2024-11-04 17:19:45' where \\"id\\" = 394","time":"7.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":406,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 17:19:45
32344	9d695e43-38fd-41d4-b66f-556f8a12a0b6	9d695e43-3f8e-424c-afef-c0f48d3a7bd8	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:394","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 17:19:45","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000"},"hostname":"EderCortes"}	2024-11-04 17:19:45
32345	9d695e43-39b2-40ef-837c-d7d51856c8cd	9d695e43-3f8e-424c-afef-c0f48d3a7bd8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_estado\\" = 'En curso', \\"loans_pago_interes\\" = 50000, \\"loans_pago_prestado\\" = 200000, \\"updated_at\\" = '2024-11-04 17:19:45' where \\"id\\" = 93","time":"0.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":414,"hash":"acfe32aea56c9ca6bdbb917f944a78d1","hostname":"EderCortes"}	2024-11-04 17:19:45
32346	9d695e43-39e9-4c7b-8d18-15eab0a2396b	9d695e43-3f8e-424c-afef-c0f48d3a7bd8	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:93","changes":{"loans_estado":"En curso","updated_at":"2024-11-04 17:19:45","loans_pago_interes":50000,"loans_pago_prestado":200000},"hostname":"EderCortes"}	2024-11-04 17:19:45
32347	9d695e43-3dff-4d06-8385-7e7ea072186f	9d695e43-3f8e-424c-afef-c0f48d3a7bd8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 17:19:45
32348	9d695e43-3e5a-4a71-9c8d-621a63931d67	9d695e43-3f8e-424c-afef-c0f48d3a7bd8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"179","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000","id":394,"loans_codigo":93,"itemloans_cuota":"1","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":380,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:19:45
33104	9d69a900-0f70-413f-881e-6ae428f696ab	9d69a900-1285-42fa-8a1f-430463c36ff6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":135,"memory":20,"hostname":"EderCortes"}	2024-11-04 20:48:44
32349	9d695e43-a564-4221-b63d-9686b4b2f238	9d695e43-ef50-4a2d-a1a8-9a639a1f26ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 17:19:46
32350	9d695e43-e6b1-4c94-b3aa-0aa5e99e9372	9d695e43-ef50-4a2d-a1a8-9a639a1f26ed	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 93\\n                        ","time":"153.00","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"9c742b70d7e4a1a77b260fd1a8993140","hostname":"EderCortes"}	2024-11-04 17:19:46
32351	9d695e43-e9dc-49e0-9920-2a3aabd5fa32	9d695e43-ef50-4a2d-a1a8-9a639a1f26ed	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"2.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 17:19:46
32352	9d695e43-edce-4b10-8426-22e4fdf01cf3	9d695e43-ef50-4a2d-a1a8-9a639a1f26ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 17:19:46
32353	9d695e43-ee42-42b7-9ba0-bdb25bc87353	9d695e43-ef50-4a2d-a1a8-9a639a1f26ed	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":93,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"200000","loans_pago_interes":"50000","user_alias":"eder.cortes"},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:19:45","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000","user_alias":"eder.cortes"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:17:55","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":396,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:17:55","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":397,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:17:55","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":398,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:17:55","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":422,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:19:46
33105	9d69a900-725b-42e5-bf0d-e72161553f0f	9d69a900-bff1-4746-86d2-1ab52ef5f1dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 20:48:45
33106	9d69a900-b17d-48eb-ad37-2b4306a8344d	9d69a900-bff1-4746-86d2-1ab52ef5f1dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 89 limit 1","time":"2.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":505,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 20:48:45
33107	9d69a900-b1c5-4063-add8-6df5484b95d7	9d69a900-bff1-4746-86d2-1ab52ef5f1dd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":2,"hostname":"EderCortes"}	2024-11-04 20:48:45
33108	9d69a900-b36d-4660-8041-bb963e80e493	9d69a900-bff1-4746-86d2-1ab52ef5f1dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select count(*) as aggregate from \\"item_loans\\" where \\"loans_codigo\\" = 89 and \\"itemloans_status\\" = 'Pagada'","time":"2.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":563,"hash":"60bd91eaa209a639fc2e8afc20430a4b","hostname":"EderCortes"}	2024-11-04 20:48:45
33109	9d69a900-b408-4701-8aa2-71656b1e08e5	9d69a900-bff1-4746-86d2-1ab52ef5f1dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 268400, \\"loans_pago_prestado\\" = 1073600, \\"updated_at\\" = '2024-11-04 20:48:45' where \\"id\\" = 89","time":"0.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":602,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 20:48:45
33110	9d69a900-b45d-44c4-9e7f-e8e942a8f86b	9d69a900-bff1-4746-86d2-1ab52ef5f1dd	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:89","changes":{"updated_at":"2024-11-04 20:48:45","loans_pago_interes":268400,"loans_pago_prestado":1073600},"hostname":"EderCortes"}	2024-11-04 20:48:45
33111	9d69a900-b4d6-4fca-b6da-a4ae55eea6b3	9d69a900-bff1-4746-86d2-1ab52ef5f1dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 89 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"0.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":609,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 20:48:45
33112	9d69a900-b4ff-4fb9-a3a3-415144da9034	9d69a900-bff1-4746-86d2-1ab52ef5f1dd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 20:48:45
33113	9d69a900-b633-4fc1-925b-35b67b4b1c0d	9d69a900-bff1-4746-86d2-1ab52ef5f1dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Abono', \\"itemloans_aprobador\\" = 12, \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = 2400, \\"itemloans_cuota_cancelada\\" = 9600, \\"updated_at\\" = '2024-11-04 20:48:45' where \\"id\\" = 439","time":"2.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":617,"hash":"6acd4a1714feb503cbc85629417266cf","hostname":"EderCortes"}	2024-11-04 20:48:45
32354	9d695e6f-694d-49eb-84f8-016771b38715	9d695e6f-6cce-4553-b07b-432e89623427	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":153,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:20:14
33114	9d69a900-b666-45fa-a154-fe9f01999fb3	9d69a900-bff1-4746-86d2-1ab52ef5f1dd	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:439","changes":{"itemloans_status":"Abono","itemloans_aprobador":12,"updated_at":"2024-11-04 20:48:45","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":2400,"itemloans_cuota_cancelada":9600},"hostname":"EderCortes"}	2024-11-04 20:48:45
33115	9d69a900-b6ce-4e6a-b026-973e1463a4f0	9d69a900-bff1-4746-86d2-1ab52ef5f1dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"delete from \\"item_loans\\" where \\"loans_codigo\\" = 89 and \\"itemloans_status\\" = 'Pendiente'","time":"0.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":624,"hash":"89bf3c496a8b0746ff5d1219b8dc29e3","hostname":"EderCortes"}	2024-11-04 20:48:45
33116	9d69a900-b728-4ca5-9140-827cd0bf93ec	9d69a900-bff1-4746-86d2-1ab52ef5f1dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 89 limit 1","time":"0.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":627,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 20:48:45
33117	9d69a900-b7c0-4530-b103-af3c7ac58c76	9d69a900-bff1-4746-86d2-1ab52ef5f1dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (89, 3, 8800, 2200, 'Pendiente', 'Se realiza abono', '12-11-2024', 0, 0, '2024-11-04 20:48:45', '2024-11-04 20:48:45')","time":"0.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:48:45
33118	9d69a900-b7e5-4784-b81f-7445e4731865	9d69a900-bff1-4746-86d2-1ab52ef5f1dd	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:48:45
33119	9d69a900-b848-4e7c-8ec7-e25a9f529b38	9d69a900-bff1-4746-86d2-1ab52ef5f1dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (89, 4, 8800, 2200, 'Pendiente', 'Se realiza abono', '20-11-2024', 0, 0, '2024-11-04 20:48:45', '2024-11-04 20:48:45')","time":"0.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:48:45
33120	9d69a900-b869-462f-8324-9fbc97cddf3f	9d69a900-bff1-4746-86d2-1ab52ef5f1dd	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:48:45
33121	9d69a900-b8dd-4492-8707-9018be6a6516	9d69a900-bff1-4746-86d2-1ab52ef5f1dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (89, 5, 8800, 2200, 'Pendiente', 'Se realiza abono', '28-11-2024', 0, 0, '2024-11-04 20:48:45', '2024-11-04 20:48:45')","time":"0.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 20:48:45
33122	9d69a900-b900-488f-946c-aa92666edbd7	9d69a900-bff1-4746-86d2-1ab52ef5f1dd	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 20:48:45
33123	9d69a900-beb5-4a00-b568-32a86755b5db	9d69a900-bff1-4746-86d2-1ab52ef5f1dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 20:48:45
33124	9d69a900-bef6-4e7e-9486-6803b6d9ba82	9d69a900-bff1-4746-86d2-1ab52ef5f1dd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"12000","idLoans":89,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El abono fue aplicado exitosamente","status":true},"duration":337,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:48:45
27708	9d68e938-5acf-4d56-b064-64cd7f85f257	9d68e938-778e-49fc-9360-f5e476f88b77	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:52:29
27709	9d68e938-75c2-442a-80f9-fd884f4d0683	9d68e938-778e-49fc-9360-f5e476f88b77	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 11:52:29
27710	9d68e938-768f-493c-a1dc-ccec4ff8c389	9d68e938-778e-49fc-9360-f5e476f88b77	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":355,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:52:29
27711	9d68e938-fe9e-4779-b657-4cf941de824f	9d68e939-1c25-492c-9ecd-7b2cb4f21cdd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 11:52:29
27712	9d68e939-13b5-49e8-8799-9e6a9dd39968	9d68e939-1c25-492c-9ecd-7b2cb4f21cdd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"43.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:52:29
27713	9d68e939-172a-4631-9ca5-a032d7bd4baf	9d68e939-1c25-492c-9ecd-7b2cb4f21cdd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"1.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:52:29
27714	9d68e939-1767-448e-b75b-4ecfb09165ef	9d68e939-1c25-492c-9ecd-7b2cb4f21cdd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:52:29
27715	9d68e939-1af0-4779-9dfd-0489e8c3a099	9d68e939-1c25-492c-9ecd-7b2cb4f21cdd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 11:52:29
27716	9d68e939-1b3d-45dd-91b7-dcb1e16a2203	9d68e939-1c25-492c-9ecd-7b2cb4f21cdd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":342,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:52:29
32362	9d695e70-3d0f-494c-aa86-e59445bab377	9d695e70-8871-4411-a918-9bdb7ce1ca3a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 17:20:15
32363	9d695e70-7f7f-4fdc-a159-e20772f352a0	9d695e70-8871-4411-a918-9bdb7ce1ca3a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 93\\n                        ","time":"157.68","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"9c742b70d7e4a1a77b260fd1a8993140","hostname":"EderCortes"}	2024-11-04 17:20:15
32364	9d695e70-82a9-4227-a7f9-460e8077099d	9d695e70-8871-4411-a918-9bdb7ce1ca3a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"2.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 17:20:15
32365	9d695e70-86f1-4ca1-a171-9d89e48fe7be	9d695e70-8871-4411-a918-9bdb7ce1ca3a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 17:20:15
32366	9d695e70-875d-4b8b-b14c-b601c49aa953	9d695e70-8871-4411-a918-9bdb7ce1ca3a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":93,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"200000","loans_pago_interes":"50000","user_alias":"eder.cortes"},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:19:45","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000","user_alias":"eder.cortes"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:17:55","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":396,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:17:55","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":397,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:17:55","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":398,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:17:55","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":361,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:20:15
33125	9d69a901-04e7-41ce-9883-5f4307b0ef31	9d69a901-2125-4d1f-940c-f520321315ad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 20:48:45
33126	9d69a901-1a7e-4a0d-81c7-dcbb1961fd15	9d69a901-2125-4d1f-940c-f520321315ad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"41.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 20:48:45
33127	9d69a901-1cfb-4e46-ab7a-54efa5da5c5a	9d69a901-2125-4d1f-940c-f520321315ad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 20:48:45
33128	9d69a901-1fb6-4175-9664-fc6c225947ff	9d69a901-2125-4d1f-940c-f520321315ad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 20:48:45
32367	9d695e90-8b79-488e-a138-a421e327a357	9d695e90-8e81-48ad-8cd5-3804fae5c648	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":137,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:20:36
33129	9d69a901-2000-4f02-b0ea-6ab674afb2e7	9d69a901-2125-4d1f-940c-f520321315ad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1073600","loans_pago_interes":"268400","user_alias":"eder.cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:39","updated_at":"2024-11-04 10:36:27","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 10:36:27","updated_at":"2024-11-04 10:39:58","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000","user_alias":"eder.cortes"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 10:36:27","updated_at":"2024-11-04 13:14:01","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000","user_alias":"eder.cortes"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 10:36:27","updated_at":"2024-11-04 20:47:05","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"120000","itemloans_cuota_cancelada":"480000","user_alias":"eder.cortes"},{"id":439,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"12000","itemloans_iteres":"3000","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 20:47:05","updated_at":"2024-11-04 20:48:45","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"2400","itemloans_cuota_cancelada":"9600","user_alias":"eder.cortes"},{"id":442,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"8800","itemloans_iteres":"2200","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:48:45","updated_at":"2024-11-04 20:48:45","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":443,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"8800","itemloans_iteres":"2200","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:48:45","updated_at":"2024-11-04 20:48:45","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":444,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"8800","itemloans_iteres":"2200","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:48:45","updated_at":"2024-11-04 20:48:45","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:48:45
27852	9d68ea1f-f266-4000-a3f7-e8ce8ef63531	9d68ea20-0eed-4da0-a78f-d5c0c2ead4c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:55:01
27853	9d68ea20-0d99-49ae-831f-52dd4281e991	9d68ea20-0eed-4da0-a78f-d5c0c2ead4c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 11:55:01
27854	9d68ea20-0e24-4077-9655-f21f7213cd3c	9d68ea20-0eed-4da0-a78f-d5c0c2ead4c8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:55:01
27855	9d68ea20-8ddf-4878-83a9-1f55cd7af5cc	9d68ea20-ad31-43a2-9a4e-0c8f1ada2b17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 11:55:01
27856	9d68ea20-a3a5-41d3-9ad2-99fa0cb0a1a7	9d68ea20-ad31-43a2-9a4e-0c8f1ada2b17	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"42.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:55:01
27857	9d68ea20-a789-4905-be33-803b173216de	9d68ea20-ad31-43a2-9a4e-0c8f1ada2b17	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"1.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:55:01
27858	9d68ea20-a7c4-4392-977a-26d8794fa2cc	9d68ea20-ad31-43a2-9a4e-0c8f1ada2b17	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:55:01
27859	9d68ea20-abb4-4c35-ae40-5564f34eec6b	9d68ea20-ad31-43a2-9a4e-0c8f1ada2b17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 11:55:01
27860	9d68ea20-ac1f-41c9-82dc-1ecce4248ccf	9d68ea20-ad31-43a2-9a4e-0c8f1ada2b17	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":355,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:55:01
33130	9d69a91a-15e2-4b92-8118-5688d2e6ebba	9d69a91a-5e19-49f2-b3c3-c16b215364e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 20:49:01
33131	9d69a91a-5926-4c40-a35f-c1e9fcc6f935	9d69a91a-5e19-49f2-b3c3-c16b215364e1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"153.24","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 20:49:02
33132	9d69a91a-5c8a-4a5e-bdeb-887e95d27fc2	9d69a91a-5e19-49f2-b3c3-c16b215364e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 20:49:02
33133	9d69a91a-5cfc-41b5-a33e-9285ed6cfde6	9d69a91a-5e19-49f2-b3c3-c16b215364e1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":344,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:49:02
18738	9d669a41-1db4-4fc0-84a6-2f335afa5cc3	9d669a41-4746-45b0-b6da-fdf48eac466b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 08:20:01
18739	9d669a41-453e-40e4-a8bf-c15fb0b2b859	9d669a41-4746-45b0-b6da-fdf48eac466b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:20:01
18740	9d669a41-45ff-4062-877e-ee813376d0b1	9d669a41-4746-45b0-b6da-fdf48eac466b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":313,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:20:01
18741	9d669a41-b4ff-40dc-9084-7a8c96c5e04c	9d669a42-01a9-47e5-af93-26d97e92b9e9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:20:02
18742	9d669a41-fc54-4a33-b71d-2ef8259171ac	9d669a42-01a9-47e5-af93-26d97e92b9e9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"163.34","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c37ce191b53d9d62ae3ae483cb5ffa40","hostname":"EderCortes"}	2024-11-03 08:20:02
18743	9d669a42-0040-4509-a534-29123ef60d7d	9d669a42-01a9-47e5-af93-26d97e92b9e9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:20:02
18744	9d669a42-009c-4faa-87df-c0c012d40de6	9d669a42-01a9-47e5-af93-26d97e92b9e9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","frecuencia_pago":"-1","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"6","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":null,"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"-25","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"6","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"-25","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"-1","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"13","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"13","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"6","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"-18","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"-3","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"5","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"-25","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"-25","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"-25","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":430,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:20:02
32372	9d695e91-a9b5-4afa-8569-18c9a0c464b4	9d695e91-c8ea-4593-a7f2-2014d0a3e24e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 17:20:37
32373	9d695e91-bfc2-484e-a0d9-183bab23ff62	9d695e91-c8ea-4593-a7f2-2014d0a3e24e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 93\\n                        ","time":"44.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"9c742b70d7e4a1a77b260fd1a8993140","hostname":"EderCortes"}	2024-11-04 17:20:37
32374	9d695e91-c3fe-4f75-9de5-0a4bc171bae2	9d695e91-c8ea-4593-a7f2-2014d0a3e24e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"3.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 17:20:37
32375	9d695e91-c75a-4c22-96da-ee5e16ad7285	9d695e91-c8ea-4593-a7f2-2014d0a3e24e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 17:20:37
32376	9d695e91-c7ae-4d4b-8424-2917ea15a02c	9d695e91-c8ea-4593-a7f2-2014d0a3e24e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":93,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"200000","loans_pago_interes":"50000","user_alias":"eder.cortes"},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:19:45","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000","user_alias":"eder.cortes"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:17:55","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":396,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:17:55","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":397,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:17:55","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":398,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:17:55","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":319,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:20:37
33134	9d69a91f-4aa7-4847-825b-f8ba3e2e4770	9d69a91f-6799-4afb-9115-221fd9fc2639	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 20:49:05
18745	9d669a44-05ec-4fc5-b862-70d703c72406	9d669a44-4e67-4910-8003-15ca4f752147	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:20:03
18746	9d669a44-49c0-49a3-a741-47f82e7b9b52	9d669a44-4e67-4910-8003-15ca4f752147	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"154.14","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 08:20:03
18747	9d669a44-4a0b-4642-a275-54e4b438e645	9d669a44-4e67-4910-8003-15ca4f752147	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 08:20:03
18748	9d669a44-4d3c-4e5b-a6a6-12fc02e568f4	9d669a44-4e67-4910-8003-15ca4f752147	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 08:20:03
18749	9d669a44-4d7d-4404-8d57-7b6b2e24a0d7	9d669a44-4e67-4910-8003-15ca4f752147	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":353,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:20:03
32377	9d695f1c-e3a7-4fd2-aa2e-0ebb70739580	9d695f1c-e8d5-42d8-89f6-6ffa88199fa1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":228,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:22:08
33135	9d69a91f-6034-410d-97c4-9893adff5d1f	9d69a91f-6799-4afb-9115-221fd9fc2639	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"43.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 20:49:05
33136	9d69a91f-632c-4ab5-a966-ce0801963c4c	9d69a91f-6799-4afb-9115-221fd9fc2639	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 20:49:05
33137	9d69a91f-6656-40c4-8c6d-ff763bfcd674	9d69a91f-6799-4afb-9115-221fd9fc2639	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 20:49:05
27954	9d68ea7f-e5e1-4580-912d-2f7496c2ff9b	9d68ea80-1d49-4eb7-a4fd-d798c9c3e36b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:56:04
27955	9d68ea80-1a5b-4062-b6e8-899b9f5b132b	9d68ea80-1d49-4eb7-a4fd-d798c9c3e36b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:56:04
27956	9d68ea80-1bbc-44c1-a3f5-e80831b49fbf	9d68ea80-1d49-4eb7-a4fd-d798c9c3e36b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":611,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:56:04
18781	9d669bb5-5aa9-4e0e-875e-eff2bdbcf0c1	9d669bb5-a25c-4e51-ad09-fb5a203d207d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 08:24:05
18782	9d669bb5-a0ad-4381-bef5-285567078fa7	9d669bb5-a25c-4e51-ad09-fb5a203d207d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 08:24:05
18783	9d669bb5-a13c-4641-977e-c28f6919f570	9d669bb5-a25c-4e51-ad09-fb5a203d207d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42883]: Undefined function: 7 ERROR:  el operador no existe: text - date\\nLINE 23:             - CURRENT_DATE\\n                     ^\\nHINT:  Ning\\u00fan operador coincide en el nombre y tipos de argumentos. Puede ser necesario agregar conversi\\u00f3n expl\\u00edcita de tipos. (Connection: pgsql, SQL: select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":351,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:24:05
33138	9d69a91f-66ac-48e1-8618-144a3fb97955	9d69a91f-6799-4afb-9115-221fd9fc2639	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1073600","loans_pago_interes":"268400","user_alias":"eder.cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:39","updated_at":"2024-11-04 10:36:27","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 10:36:27","updated_at":"2024-11-04 10:39:58","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000","user_alias":"eder.cortes"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 10:36:27","updated_at":"2024-11-04 13:14:01","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000","user_alias":"eder.cortes"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 10:36:27","updated_at":"2024-11-04 20:47:05","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"120000","itemloans_cuota_cancelada":"480000","user_alias":"eder.cortes"},{"id":439,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"12000","itemloans_iteres":"3000","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 20:47:05","updated_at":"2024-11-04 20:48:45","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"2400","itemloans_cuota_cancelada":"9600","user_alias":"eder.cortes"},{"id":442,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"8800","itemloans_iteres":"2200","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:48:45","updated_at":"2024-11-04 20:48:45","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":443,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"8800","itemloans_iteres":"2200","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:48:45","updated_at":"2024-11-04 20:48:45","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":444,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"8800","itemloans_iteres":"2200","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 20:48:45","updated_at":"2024-11-04 20:48:45","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:49:05
27957	9d68ea80-f9a5-4c4a-9f6b-1fae1f27742d	9d68ea81-3472-45b3-b606-a8aae25b5cf8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:56:04
27958	9d68ea81-29d2-4dc7-8ea7-d2cc1ccfb4dc	9d68ea81-3472-45b3-b606-a8aae25b5cf8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"78.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:56:04
27959	9d68ea81-2a6e-40ea-8382-9598a39e60e1	9d68ea81-3472-45b3-b606-a8aae25b5cf8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:56:04
27960	9d68ea81-322f-431a-95d6-1cb5c1b2dec7	9d68ea81-3472-45b3-b606-a8aae25b5cf8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:56:04
27961	9d68ea81-32c5-4232-a02a-5d380ffc6e9c	9d68ea81-3472-45b3-b606-a8aae25b5cf8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":615,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:56:04
18780	9d669bb5-9f82-45be-8234-eaadab09b4b9	9d669bb5-a25c-4e51-ad09-fb5a203d207d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42883]: Undefined function: 7 ERROR:  el operador no existe: text - date\\nLINE 23:             - CURRENT_DATE\\n                     ^\\nHINT:  Ning\\u00fan operador coincide en el nombre y tipos de argumentos. Puede ser necesario agregar conversi\\u00f3n expl\\u00edcita de tipos. (Connection: pgsql, SQL: select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":912}	2024-11-03 08:24:05
27962	9d68ea82-24fd-4426-857b-2e5ea60140c3	9d68ea82-8317-4f47-bed0-5afe588911af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:56:05
27963	9d68ea82-7d05-4ee0-929f-531037c730fd	9d68ea82-8317-4f47-bed0-5afe588911af	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"171.42","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:56:05
27964	9d68ea82-7d6d-4521-9896-cfda545747e1	9d68ea82-8317-4f47-bed0-5afe588911af	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 11:56:05
27965	9d68ea82-81dc-469a-a31d-3bb5a9dc6a40	9d68ea82-8317-4f47-bed0-5afe588911af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:56:05
27966	9d68ea82-822f-462c-b3ce-010c878ac5f7	9d68ea82-8317-4f47-bed0-5afe588911af	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":829,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:56:05
32383	9d695f1e-5608-416c-8ecf-efe763e40a93	9d695f1e-771f-48dd-8dcd-37b981cfb648	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 17:22:09
32384	9d695f1e-6e74-47ba-94dd-8d57ea521ab4	9d695f1e-771f-48dd-8dcd-37b981cfb648	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 93\\n                        ","time":"49.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"9c742b70d7e4a1a77b260fd1a8993140","hostname":"EderCortes"}	2024-11-04 17:22:09
32385	9d695f1e-7215-423a-bd4c-b190947b65ec	9d695f1e-771f-48dd-8dcd-37b981cfb648	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"2.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 17:22:09
32386	9d695f1e-75b0-486f-b31e-8e5b801801db	9d695f1e-771f-48dd-8dcd-37b981cfb648	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 17:22:09
32387	9d695f1e-7603-40e5-b4cb-5f13ea5fa8bb	9d695f1e-771f-48dd-8dcd-37b981cfb648	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":93,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"200000","loans_pago_interes":"50000","user_alias":"eder.cortes"},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:19:45","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000","user_alias":"eder.cortes"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:17:55","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":396,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:17:55","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":397,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:17:55","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":398,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:17:55","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":326,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:22:09
27967	9d68ea83-1145-4001-9eb4-6870d700450c	9d68ea83-34fd-48da-aa45-bf14fcedf124	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:56:06
27968	9d68ea83-2bd8-480c-946f-131a01476a27	9d68ea83-34fd-48da-aa45-bf14fcedf124	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '81' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"45.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 11:56:06
27969	9d68ea83-2c39-49ab-a268-69694fce546c	9d68ea83-34fd-48da-aa45-bf14fcedf124	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 11:56:06
15230	9d5ecf4e-d0d9-4fa4-8253-b5b200ef005b	9d5ecf4f-0a15-4ee3-b3f7-ce71bcafa94c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-10-30 11:21:45
15231	9d5ecf4f-079a-4bcb-b28a-1f49257273c0	9d5ecf4f-0a15-4ee3-b3f7-ce71bcafa94c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-10-30 11:21:45
15232	9d5ecf4f-088f-4507-93b6-db8a60358fd1	9d5ecf4f-0a15-4ee3-b3f7-ce71bcafa94c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":565,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:21:45
27970	9d68ea83-2e52-426e-abe3-b12e8a816154	9d68ea83-34fd-48da-aa45-bf14fcedf124	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '81' order by \\"item_loans\\".\\"id\\" asc","time":"2.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:56:06
27971	9d68ea83-2ea7-4f4e-904f-fe2abdafafbd	9d68ea83-34fd-48da-aa45-bf14fcedf124	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 11:56:06
27972	9d68ea83-3361-4c05-a1e6-a72aea4b808e	9d68ea83-34fd-48da-aa45-bf14fcedf124	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:56:06
27973	9d68ea83-33cd-4277-a556-4f3f2937da9a	9d68ea83-34fd-48da-aa45-bf14fcedf124	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/81","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":81,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"0","loans_pago_prestado":"0","loans_intereses_recaudar":"275000"},"items":[{"id":311,"loans_codigo":81,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":312,"loans_codigo":81,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":313,"loans_codigo":81,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":314,"loans_codigo":81,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":315,"loans_codigo":81,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":441,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:56:06
32388	9d695f3d-63e4-4357-8d7b-d5305c085e6d	9d695f3d-67af-4756-9171-8666707be332	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":192,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:22:29
33139	9d69a924-5c30-4ae6-94aa-dc4c7cb92675	9d69a924-600f-4773-ba9b-95158c6b3062	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-total-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":144,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:49:08
32389	9d695f3e-1e6e-4919-b467-e55034465666	9d695f3e-6c82-4e5d-96a9-d6a57d618ecb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 17:22:30
32390	9d695f3e-5f19-4094-8e6b-da285b75f727	9d695f3e-6c82-4e5d-96a9-d6a57d618ecb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 93 limit 1","time":"3.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":505,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 17:22:30
32391	9d695f3e-5f7b-4496-9029-70c3939e1b61	9d695f3e-6c82-4e5d-96a9-d6a57d618ecb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":2,"hostname":"EderCortes"}	2024-11-04 17:22:30
32392	9d695f3e-613b-4b0b-8553-7e299b3fbdfb	9d695f3e-6c82-4e5d-96a9-d6a57d618ecb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select count(*) as aggregate from \\"item_loans\\" where \\"loans_codigo\\" = 93 and \\"itemloans_status\\" = 'Pagada'","time":"2.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":563,"hash":"60bd91eaa209a639fc2e8afc20430a4b","hostname":"EderCortes"}	2024-11-04 17:22:30
32393	9d695f3e-6201-4745-b0ce-3373062666ef	9d695f3e-6c82-4e5d-96a9-d6a57d618ecb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 150000, \\"loans_pago_prestado\\" = 600000, \\"updated_at\\" = '2024-11-04 17:22:30' where \\"id\\" = 93","time":"0.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":602,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 17:22:30
32394	9d695f3e-6269-475c-88ce-f6c99f3cd82d	9d695f3e-6c82-4e5d-96a9-d6a57d618ecb	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:93","changes":{"updated_at":"2024-11-04 17:22:30","loans_pago_interes":150000,"loans_pago_prestado":600000},"hostname":"EderCortes"}	2024-11-04 17:22:30
32395	9d695f3e-62f7-4d9c-80a5-8dea9eae16e6	9d695f3e-6c82-4e5d-96a9-d6a57d618ecb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 93 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"0.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":609,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 17:22:30
32396	9d695f3e-6328-40f4-bdbc-b93224011c66	9d695f3e-6c82-4e5d-96a9-d6a57d618ecb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 17:22:30
32397	9d695f3e-63a3-43df-ac6c-0b2aef55b9a2	9d695f3e-6c82-4e5d-96a9-d6a57d618ecb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Abono', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = 100000, \\"itemloans_cuota_cancelada\\" = 400000, \\"updated_at\\" = '2024-11-04 17:22:30' where \\"id\\" = 395","time":"0.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":617,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 17:22:30
32398	9d695f3e-63d3-4b32-8fff-2dfc851e9682	9d695f3e-6c82-4e5d-96a9-d6a57d618ecb	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:395","changes":{"itemloans_status":"Abono","updated_at":"2024-11-04 17:22:30","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":100000,"itemloans_cuota_cancelada":400000},"hostname":"EderCortes"}	2024-11-04 17:22:30
32399	9d695f3e-6432-40b2-8d58-53575a3084f6	9d695f3e-6c82-4e5d-96a9-d6a57d618ecb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"delete from \\"item_loans\\" where \\"loans_codigo\\" = 93 and \\"itemloans_status\\" = 'Pendiente'","time":"0.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":624,"hash":"89bf3c496a8b0746ff5d1219b8dc29e3","hostname":"EderCortes"}	2024-11-04 17:22:30
32400	9d695f3e-649c-40c2-97a1-83370aa15ab8	9d695f3e-6c82-4e5d-96a9-d6a57d618ecb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 93 limit 1","time":"0.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":627,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 17:22:30
32401	9d695f3e-654c-42c5-ae6f-412c4a099b92	9d695f3e-6c82-4e5d-96a9-d6a57d618ecb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (93, 2, 100000, 25000, 'Pendiente', 'Se realiza abono', '12-11-2024', 0, 0, '2024-11-04 17:22:30', '2024-11-04 17:22:30')","time":"0.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 17:22:30
32402	9d695f3e-6578-4cbb-8f95-100a1ad374d4	9d695f3e-6c82-4e5d-96a9-d6a57d618ecb	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 17:22:30
32403	9d695f3e-65e9-41f4-9c71-150b6230d460	9d695f3e-6c82-4e5d-96a9-d6a57d618ecb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (93, 3, 100000, 25000, 'Pendiente', 'Se realiza abono', '20-11-2024', 0, 0, '2024-11-04 17:22:30', '2024-11-04 17:22:30')","time":"0.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 17:22:30
32404	9d695f3e-6614-4864-abbb-b606ddc57d9a	9d695f3e-6c82-4e5d-96a9-d6a57d618ecb	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 17:22:30
32405	9d695f3e-668e-4fb3-9d53-68d0d9c8e960	9d695f3e-6c82-4e5d-96a9-d6a57d618ecb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (93, 4, 100000, 25000, 'Pendiente', 'Se realiza abono', '28-11-2024', 0, 0, '2024-11-04 17:22:30', '2024-11-04 17:22:30')","time":"0.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 17:22:30
32406	9d695f3e-66c4-4584-b943-34dff0c2e001	9d695f3e-6c82-4e5d-96a9-d6a57d618ecb	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 17:22:30
33140	9d69a924-c7b2-48f6-8413-4098c2d7a9d0	9d69a924-e9c6-45ac-b32b-034ed30a3221	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 20:49:08
33141	9d69a924-df46-4f93-b632-78f0e1ee6822	9d69a924-e9c6-45ac-b32b-034ed30a3221	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 89 limit 1","time":"3.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":715,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 20:49:08
32407	9d695f3e-6737-48ef-b8e6-b5ce6cf281c8	9d695f3e-6c82-4e5d-96a9-d6a57d618ecb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (93, 5, 100000, 25000, 'Pendiente', 'Se realiza abono', '06-12-2024', 0, 0, '2024-11-04 17:22:30', '2024-11-04 17:22:30')","time":"0.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 17:22:30
32408	9d695f3e-6771-48f7-80d9-c26a35815cdd	9d695f3e-6c82-4e5d-96a9-d6a57d618ecb	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 17:22:30
32409	9d695f3e-6b36-429a-9613-24c1a7f506da	9d695f3e-6c82-4e5d-96a9-d6a57d618ecb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 17:22:30
32410	9d695f3e-6b7b-4312-9858-97656662759b	9d695f3e-6c82-4e5d-96a9-d6a57d618ecb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"61","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"500000","idLoans":93,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El abono fue aplicado exitosamente","status":true},"duration":353,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:22:30
33142	9d69a924-dfa2-4d55-a880-ba5fd4b47876	9d69a924-e9c6-45ac-b32b-034ed30a3221	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 20:49:08
33143	9d69a924-e0dc-45e0-8051-74443a708b45	9d69a924-e9c6-45ac-b32b-034ed30a3221	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_estado\\" = 'Cancelado', \\"loans_pago_interes\\" = 275000, \\"loans_pago_prestado\\" = 1100000, \\"updated_at\\" = '2024-11-04 20:49:08' where \\"id\\" = 89","time":"0.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":740,"hash":"acfe32aea56c9ca6bdbb917f944a78d1","hostname":"EderCortes"}	2024-11-04 20:49:08
33144	9d69a924-e136-407f-95f4-4ac5085b82f9	9d69a924-e9c6-45ac-b32b-034ed30a3221	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:89","changes":{"loans_estado":"Cancelado","updated_at":"2024-11-04 20:49:08","loans_pago_interes":275000,"loans_pago_prestado":1100000},"hostname":"EderCortes"}	2024-11-04 20:49:08
33145	9d69a924-e2b0-4781-ab67-aa384f344c19	9d69a924-e9c6-45ac-b32b-034ed30a3221	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 89 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"2.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":745,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 20:49:08
33146	9d69a924-e2e9-4fa5-86bd-602f2d4aed25	9d69a924-e9c6-45ac-b32b-034ed30a3221	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 20:49:08
33147	9d69a924-e472-4601-9931-772b36d1bf23	9d69a924-e9c6-45ac-b32b-034ed30a3221	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_interes_canelado\\" = '2200', \\"itemloans_cuota_cancelada\\" = '8800', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_status\\" = 'Pagada', \\"itemloans_aprobador\\" = 12, \\"updated_at\\" = '2024-11-04 20:49:08' where \\"loans_codigo\\" = 89 and \\"itemloans_status\\" = 'Pendiente'","time":"3.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":754,"hash":"87a64c6113219082cd85f391b598ec7f","hostname":"EderCortes"}	2024-11-04 20:49:08
33148	9d69a924-e85d-4a4c-baa1-d4c416d6e81f	9d69a924-e9c6-45ac-b32b-034ed30a3221	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 20:49:08
33149	9d69a924-e8a3-4c0d-9274-1517f33bdd63	9d69a924-e9c6-45ac-b32b-034ed30a3221	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-total-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payTotal","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"39","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"idLoans":89,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"Se ha realizado el pago total del credito","status":true},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:49:08
32411	9d695f3e-b4f8-4f75-93fd-a63dd9962072	9d695f3e-d1bd-4ee9-9ddb-c0b83461c843	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 17:22:30
32412	9d695f3e-ca80-4778-b53d-93711894ee61	9d695f3e-d1bd-4ee9-9ddb-c0b83461c843	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 93\\n                        ","time":"42.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"9c742b70d7e4a1a77b260fd1a8993140","hostname":"EderCortes"}	2024-11-04 17:22:30
32413	9d695f3e-cd4e-4d0a-804a-3ba3c50ee613	9d695f3e-d1bd-4ee9-9ddb-c0b83461c843	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"2.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 17:22:30
32414	9d695f3e-d034-4115-b8df-0cef9cfb4111	9d695f3e-d1bd-4ee9-9ddb-c0b83461c843	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 17:22:30
32415	9d695f3e-d087-4441-8107-a34c962d67f2	9d695f3e-d1bd-4ee9-9ddb-c0b83461c843	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":93,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"600000","loans_pago_interes":"150000","user_alias":"eder.cortes"},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:19:45","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000","user_alias":"eder.cortes"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:22:30","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000","user_alias":"eder.cortes"},{"id":399,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:22:30","updated_at":"2024-11-04 17:22:30","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":400,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:22:30","updated_at":"2024-11-04 17:22:30","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":401,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:22:30","updated_at":"2024-11-04 17:22:30","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":402,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:22:30","updated_at":"2024-11-04 17:22:30","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:22:30
33150	9d69a925-4b1a-4093-9d4a-274402216819	9d69a925-6e10-440b-b4e5-e35e75be33c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 20:49:09
33151	9d69a925-655f-476e-bb3e-3b8613b57531	9d69a925-6e10-440b-b4e5-e35e75be33c9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"50.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 20:49:09
33152	9d69a925-6898-4c5d-b23d-e517ed87c143	9d69a925-6e10-440b-b4e5-e35e75be33c9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 20:49:09
33153	9d69a925-6bf3-4314-8751-a5becb88711f	9d69a925-6e10-440b-b4e5-e35e75be33c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 20:49:09
33154	9d69a925-6c8b-42b0-b8a2-900ef1bdeade	9d69a925-6e10-440b-b4e5-e35e75be33c9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000","user_alias":"eder.cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:39","updated_at":"2024-11-04 10:36:27","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 10:36:27","updated_at":"2024-11-04 10:39:58","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000","user_alias":"eder.cortes"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 10:36:27","updated_at":"2024-11-04 13:14:01","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000","user_alias":"eder.cortes"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 10:36:27","updated_at":"2024-11-04 20:47:05","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"120000","itemloans_cuota_cancelada":"480000","user_alias":"eder.cortes"},{"id":439,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"12000","itemloans_iteres":"3000","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 20:47:05","updated_at":"2024-11-04 20:48:45","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"2400","itemloans_cuota_cancelada":"9600","user_alias":"eder.cortes"},{"id":442,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"8800","itemloans_iteres":"2200","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 20:48:45","updated_at":"2024-11-04 20:49:08","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"2200","itemloans_cuota_cancelada":"8800","user_alias":"eder.cortes"},{"id":443,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"8800","itemloans_iteres":"2200","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 20:48:45","updated_at":"2024-11-04 20:49:08","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"2200","itemloans_cuota_cancelada":"8800","user_alias":"eder.cortes"},{"id":444,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"8800","itemloans_iteres":"2200","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 20:48:45","updated_at":"2024-11-04 20:49:08","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"2200","itemloans_cuota_cancelada":"8800","user_alias":"eder.cortes"}]}},"duration":309,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:49:09
19929	9d66ebce-078a-4de5-8d98-b182ce3e7e0f	9d66ebce-245e-4936-98ee-bb426f7cd6af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:08:03
19930	9d66ebce-22b2-40e9-9f60-1199d06d358e	9d66ebce-245e-4936-98ee-bb426f7cd6af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:08:03
19931	9d66ebce-235a-4763-9909-17b7ebabfdf4	9d66ebce-245e-4936-98ee-bb426f7cd6af	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:08:03
32416	9d6960db-a4bd-454d-a79e-17126c06107e	9d6960db-a9b5-4522-96f7-339ac82763a5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-total-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":238,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:27:01
19932	9d66ebce-6f00-4803-ad1b-ab8af677b0b8	9d66ebce-8d8e-456f-bc77-ca9fbfce00f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:08:03
19933	9d66ebce-8496-4573-8369-419480230a4f	9d66ebce-8d8e-456f-bc77-ca9fbfce00f2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"42.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:08:04
19934	9d66ebce-883e-4667-80dc-2858b10f64e2	9d66ebce-8d8e-456f-bc77-ca9fbfce00f2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:08:04
19935	9d66ebce-886e-4931-96db-f952378b318d	9d66ebce-8d8e-456f-bc77-ca9fbfce00f2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:08:04
19936	9d66ebce-8c1a-4752-91d4-86f76d6ad387	9d66ebce-8d8e-456f-bc77-ca9fbfce00f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:08:04
19937	9d66ebce-8c83-4ac2-a128-7b4a25165701	9d66ebce-8d8e-456f-bc77-ca9fbfce00f2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:08:04
32417	9d6960dc-0ad4-4523-beb4-331310de4b43	9d6960dc-656a-4913-ae5c-0332579f7b0a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 17:27:01
32418	9d6960dc-578b-40a2-841a-879c53dab35e	9d6960dc-656a-4913-ae5c-0332579f7b0a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 93 limit 1","time":"3.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":715,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 17:27:01
32419	9d6960dc-57f4-4c32-900d-f47cc9a9b9b3	9d6960dc-656a-4913-ae5c-0332579f7b0a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 17:27:01
32420	9d6960dc-595b-4220-a226-6fc8832f5891	9d6960dc-656a-4913-ae5c-0332579f7b0a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_estado\\" = 'Cancelado', \\"loans_pago_interes\\" = 250000, \\"loans_pago_prestado\\" = 1000000, \\"updated_at\\" = '2024-11-04 17:27:01' where \\"id\\" = 93","time":"0.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":740,"hash":"acfe32aea56c9ca6bdbb917f944a78d1","hostname":"EderCortes"}	2024-11-04 17:27:01
32421	9d6960dc-59c7-4d44-9e18-cdf0bec7e569	9d6960dc-656a-4913-ae5c-0332579f7b0a	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:93","changes":{"loans_estado":"Cancelado","updated_at":"2024-11-04 17:27:01","loans_pago_interes":250000,"loans_pago_prestado":1000000},"hostname":"EderCortes"}	2024-11-04 17:27:01
32422	9d6960dc-5b35-4ba0-846e-accf665c7193	9d6960dc-656a-4913-ae5c-0332579f7b0a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 93 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"2.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":745,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 17:27:01
32423	9d6960dc-5b67-4d6b-a54d-beaa435149c4	9d6960dc-656a-4913-ae5c-0332579f7b0a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 17:27:01
32424	9d6960dc-5cc7-460c-8ecb-5c50e3ce3a97	9d6960dc-656a-4913-ae5c-0332579f7b0a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_interes_canelado\\" = '25000', \\"itemloans_cuota_cancelada\\" = '100000', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_status\\" = 'Pagada', \\"itemloans_aprobador\\" = 12, \\"updated_at\\" = '2024-11-04 17:27:01' where \\"loans_codigo\\" = 93 and \\"itemloans_status\\" = 'Pendiente'","time":"2.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":754,"hash":"87a64c6113219082cd85f391b598ec7f","hostname":"EderCortes"}	2024-11-04 17:27:01
32425	9d6960dc-63b5-42bf-aa1d-d29aedb6bb80	9d6960dc-656a-4913-ae5c-0332579f7b0a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 17:27:01
33155	9d69a927-1ad9-4386-95b9-56c29ffc37db	9d69a927-60f7-4edd-950f-80d98e32c20a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 20:49:10
19938	9d66ebcf-b4d3-4a57-9b3f-6754554a3a0b	9d66ebcf-f717-443f-8b2a-72d7bbd21539	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:08:04
19939	9d66ebcf-eecb-4bbc-b375-a23b6074762d	9d66ebcf-f717-443f-8b2a-72d7bbd21539	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"83.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:08:04
19940	9d66ebcf-ef3f-4ee9-b8f4-11a2f61e88b3	9d66ebcf-f717-443f-8b2a-72d7bbd21539	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:08:04
19941	9d66ebcf-f56c-40c8-bb9b-99595128f05b	9d66ebcf-f717-443f-8b2a-72d7bbd21539	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:08:04
19942	9d66ebcf-f5d4-43f3-ab09-c81870f62819	9d66ebcf-f717-443f-8b2a-72d7bbd21539	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":441,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:08:04
32426	9d6960dc-6418-42f4-a933-f795b024012f	9d6960dc-656a-4913-ae5c-0332579f7b0a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-total-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payTotal","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"39","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"idLoans":93,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"Se ha realizado el pago total del credito","status":true},"duration":408,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:27:01
28088	9d68ebb4-2eac-4479-b526-ed3c104fb25a	9d68ebb4-52bf-4dc8-9a90-7c2b2c754cca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:59:26
28089	9d68ebb4-5114-4ba7-a371-9c748844a149	9d68ebb4-52bf-4dc8-9a90-7c2b2c754cca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 11:59:26
28090	9d68ebb4-51b5-4ea2-ac7f-29a28fad19ba	9d68ebb4-52bf-4dc8-9a90-7c2b2c754cca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":436,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:59:26
33156	9d69a927-5cfd-4021-a71c-1e456a9b671a	9d69a927-60f7-4edd-950f-80d98e32c20a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"154.38","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 20:49:10
33157	9d69a927-5fa4-47fe-9502-c727059282ae	9d69a927-60f7-4edd-950f-80d98e32c20a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 20:49:10
33158	9d69a927-600a-4a35-8357-96a4d19f440a	9d69a927-60f7-4edd-950f-80d98e32c20a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":323,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:49:10
28091	9d68ebb4-f320-403b-a725-032d604a4902	9d68ebb5-5574-4f83-915b-b902215ba34c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 11:59:26
28092	9d68ebb5-465f-4c4b-bd45-4e36e66b6ae2	9d68ebb5-5574-4f83-915b-b902215ba34c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"192.44","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:59:26
28093	9d68ebb5-4ccb-49e9-8f46-dca7351462c4	9d68ebb5-5574-4f83-915b-b902215ba34c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"3.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:59:26
28094	9d68ebb5-4d23-43de-a9dd-5c06ed364711	9d68ebb5-5574-4f83-915b-b902215ba34c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:59:26
28095	9d68ebb5-536d-4148-ad04-d8abca0b1b1c	9d68ebb5-5574-4f83-915b-b902215ba34c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 11:59:26
28096	9d68ebb5-5406-466c-b70c-ab7ed407ab3b	9d68ebb5-5574-4f83-915b-b902215ba34c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":603,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:59:26
32427	9d6960dd-399c-4a71-bab6-52249527d9c6	9d6960dd-562a-4d86-8676-cff366e086e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 17:27:02
32428	9d6960dd-4ef7-4e71-a872-01027cbb37f5	9d6960dd-562a-4d86-8676-cff366e086e4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 93\\n                        ","time":"42.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"9c742b70d7e4a1a77b260fd1a8993140","hostname":"EderCortes"}	2024-11-04 17:27:02
32429	9d6960dd-51d1-4cb6-b1c9-0927ec48ff61	9d6960dd-562a-4d86-8676-cff366e086e4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"2.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 17:27:02
32430	9d6960dd-54bc-4fa5-9c69-d9af042efdfa	9d6960dd-562a-4d86-8676-cff366e086e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 17:27:02
33159	9d69a92c-fcf5-4a9c-bb2c-540a54ccb363	9d69a92d-1f4c-4df7-a590-3c38ea8c6503	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 20:49:14
32431	9d6960dd-5521-4e85-b34d-9b93092c3013	9d6960dd-562a-4d86-8676-cff366e086e4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":93,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1000000","loans_pago_interes":"250000","user_alias":"eder.cortes"},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:19:45","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000","user_alias":"eder.cortes"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:22:30","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000","user_alias":"eder.cortes"},{"id":399,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:22:30","updated_at":"2024-11-04 17:27:01","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000","user_alias":"eder.cortes"},{"id":400,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:22:30","updated_at":"2024-11-04 17:27:01","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000","user_alias":"eder.cortes"},{"id":401,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:22:30","updated_at":"2024-11-04 17:27:01","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000","user_alias":"eder.cortes"},{"id":402,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:22:30","updated_at":"2024-11-04 17:27:01","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000","user_alias":"eder.cortes"}]}},"duration":280,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:27:02
33160	9d69a92d-1790-4a68-b6c6-d8e3d51863e3	9d69a92d-1f4c-4df7-a590-3c38ea8c6503	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 87\\n                        ","time":"42.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"309a6eff5ebe9f2d91248732844dd9ed","hostname":"EderCortes"}	2024-11-04 20:49:14
33161	9d69a92d-1a56-4758-a7b5-43b52feeb554	9d69a92d-1f4c-4df7-a590-3c38ea8c6503	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '87' order by \\"item_loans\\".\\"id\\" asc","time":"2.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 20:49:14
33162	9d69a92d-1e0f-4f66-b178-eb2d9c69d7a9	9d69a92d-1f4c-4df7-a590-3c38ea8c6503	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 20:49:14
33163	9d69a92d-1e69-44ae-b2b0-e0dd043e6452	9d69a92d-1f4c-4df7-a590-3c38ea8c6503	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/87","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":87,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0","user_alias":"eder.cortes"},"items":[{"id":341,"loans_codigo":87,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":342,"loans_codigo":87,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":343,"loans_codigo":87,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":344,"loans_codigo":87,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":345,"loans_codigo":87,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":283,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:49:14
22747	9d67f9e8-1de5-43e7-8967-cf96cd15f1cf	9d67f9e8-20f4-4132-8e43-2229710fa199	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1090}	2024-11-04 00:43:19
28211	9d68ff41-92c9-4a8b-9136-c904b6ce4b61	9d68ff41-b00c-4e29-8609-e8ff183406eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 12:54:06
28212	9d68ff41-aea4-4afd-95d1-0245e88ef726	9d68ff41-b00c-4e29-8609-e8ff183406eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 12:54:06
28213	9d68ff41-af31-4dc1-ab32-2be84192a4be	9d68ff41-b00c-4e29-8609-e8ff183406eb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":385,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:54:06
32432	9d696101-25b8-471d-bb36-b51fd8d85405	9d696101-6cb3-40d4-b472-9d400350955a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 17:27:25
32433	9d696101-6847-46f3-8234-f88489ca5b4e	9d696101-6cb3-40d4-b472-9d400350955a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"151.43","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 17:27:26
32434	9d696101-6b46-4772-9961-94842f03584b	9d696101-6cb3-40d4-b472-9d400350955a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 17:27:26
32435	9d696101-6bb6-4173-958b-0dc5fc83e16b	9d696101-6cb3-40d4-b472-9d400350955a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":350,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:27:26
28214	9d68ff42-3635-4463-bd89-235a242de74c	9d68ff42-55bf-4e52-b271-c55bc3f856ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 12:54:06
28215	9d68ff42-4cbf-4cb0-a002-e26d7d4ec2f6	9d68ff42-55bf-4e52-b271-c55bc3f856ed	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"43.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 12:54:06
28216	9d68ff42-5057-4154-ba67-6f9785d11a1d	9d68ff42-55bf-4e52-b271-c55bc3f856ed	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 12:54:06
28217	9d68ff42-508f-468e-aeb8-2b3852cdd74a	9d68ff42-55bf-4e52-b271-c55bc3f856ed	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 12:54:06
28218	9d68ff42-5499-40d7-be41-70a15a24939a	9d68ff42-55bf-4e52-b271-c55bc3f856ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 12:54:06
28219	9d68ff42-54e2-48e6-901e-c3dae78c2095	9d68ff42-55bf-4e52-b271-c55bc3f856ed	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":375,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:54:06
32436	9d696106-ddd3-4daf-b3aa-94dcc4631035	9d696106-f9a1-4b01-a184-60269c11e4bc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 17:27:29
32437	9d696106-f2a4-44b6-8882-a7e3ceedb2f6	9d696106-f9a1-4b01-a184-60269c11e4bc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"41.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 17:27:29
32438	9d696106-f530-499f-a277-c4434b415875	9d696106-f9a1-4b01-a184-60269c11e4bc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '92' order by \\"item_loans\\".\\"id\\" asc","time":"2.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 17:27:29
32439	9d696106-f828-4966-b963-c2a0ba9de2fa	9d696106-f9a1-4b01-a184-60269c11e4bc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 17:27:29
20104	9d66ee5c-d919-4a29-947b-66a1ad4b18b6	9d66ee5d-081b-48f9-9874-fddcea11fe00	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:15:12
20105	9d66ee5d-05ee-456e-9212-fdb666b3ac6c	9d66ee5d-081b-48f9-9874-fddcea11fe00	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:15:12
20106	9d66ee5d-06d3-4456-8d82-2aeea530f56c	9d66ee5d-081b-48f9-9874-fddcea11fe00	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":371,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:15:12
20107	9d66ee5d-69fc-40b8-931a-332f44f7d367	9d66ee5d-9796-4313-a58c-18fc23f56b81	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:15:13
20108	9d66ee5d-8aea-44f9-902b-73533b37bdd0	9d66ee5d-9796-4313-a58c-18fc23f56b81	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"57.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:15:13
20109	9d66ee5d-8fb3-4122-a391-264a649ee3d5	9d66ee5d-9796-4313-a58c-18fc23f56b81	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:15:13
20110	9d66ee5d-8fed-4811-8618-414654427b7f	9d66ee5d-9796-4313-a58c-18fc23f56b81	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:15:13
20111	9d66ee5d-95b0-4f1e-86f5-3c8b80e93431	9d66ee5d-9796-4313-a58c-18fc23f56b81	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:15:13
20112	9d66ee5d-9658-40df-a680-b3e7bf047319	9d66ee5d-9796-4313-a58c-18fc23f56b81	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":308,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:15:13
32440	9d696106-f889-4a4c-82b1-c7293762a934	9d696106-f9a1-4b01-a184-60269c11e4bc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":92,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":15,"loans_valor_prestado":8000009,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"533333.93333333","loans_pago_interes":"133333.48333333","user_alias":"eder.cortes"},"items":[{"id":379,"loans_codigo":92,"itemloans_cuota":"1","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:13:07","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":380,"loans_codigo":92,"itemloans_cuota":"2","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":381,"loans_codigo":92,"itemloans_cuota":"3","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":382,"loans_codigo":92,"itemloans_cuota":"4","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":383,"loans_codigo":92,"itemloans_cuota":"5","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":384,"loans_codigo":92,"itemloans_cuota":"6","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":385,"loans_codigo":92,"itemloans_cuota":"7","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":386,"loans_codigo":92,"itemloans_cuota":"8","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":387,"loans_codigo":92,"itemloans_cuota":"9","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-15 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":388,"loans_codigo":92,"itemloans_cuota":"10","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":389,"loans_codigo":92,"itemloans_cuota":"11","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-31 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":390,"loans_codigo":92,"itemloans_cuota":"12","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":391,"loans_codigo":92,"itemloans_cuota":"13","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-16 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":392,"loans_codigo":92,"itemloans_cuota":"14","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":393,"loans_codigo":92,"itemloans_cuota":"15","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":220,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:27:29
33164	9d69a9c1-5d84-48b2-be04-cdb59337972e	9d69a9c1-6275-460e-94d5-595fd61476dc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":268,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:50:51
20113	9d66ee5f-3fc5-422f-aed6-ec6d5e3c075b	9d66ee5f-6e51-491c-9875-980df93d7da2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:15:14
20114	9d66ee5f-66b5-4f7f-8579-31a778f15f9a	9d66ee5f-6e51-491c-9875-980df93d7da2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"66.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:15:14
20115	9d66ee5f-672e-4683-8179-f85772ab3c22	9d66ee5f-6e51-491c-9875-980df93d7da2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:15:14
20116	9d66ee5f-6ca3-4093-a3c1-cb378c99f468	9d66ee5f-6e51-491c-9875-980df93d7da2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:15:14
20117	9d66ee5f-6d0a-42b8-883f-58f418ddeb0a	9d66ee5f-6e51-491c-9875-980df93d7da2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":439,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:15:14
32441	9d696132-477d-400a-afb8-7a00d9397234	9d696132-4abf-4f52-ac2b-f53e9407c7dd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-intereses","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":166,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:27:58
33165	9d69a9c1-f9eb-435e-8095-fb5450f03e79	9d69a9c2-570d-4900-9e88-ef00a318b4f0	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 20:50:51
33166	9d69a9c2-4bdf-425d-84d1-be776d2931fb	9d69a9c2-570d-4900-9e88-ef00a318b4f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 341 limit 1","time":"4.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":362,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 20:50:52
33167	9d69a9c2-4c83-4183-baaa-09ad453c9e55	9d69a9c2-570d-4900-9e88-ef00a318b4f0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 20:50:52
33168	9d69a9c2-4e80-434f-bb24-08adbc1ad3e1	9d69a9c2-570d-4900-9e88-ef00a318b4f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 87 limit 1","time":"2.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":363,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 20:50:52
33169	9d69a9c2-4eb1-4d85-b07c-2ae4c2643357	9d69a9c2-570d-4900-9e88-ef00a318b4f0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 20:50:52
33170	9d69a9c2-5021-4d98-82e2-aaa13d07c37d	9d69a9c2-570d-4900-9e88-ef00a318b4f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '55000', \\"itemloans_cuota_cancelada\\" = '220000', \\"updated_at\\" = '2024-11-04 20:50:52' where \\"id\\" = 341","time":"1.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":406,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 20:50:52
33171	9d69a9c2-507e-4594-bb4d-ebb78c07d7be	9d69a9c2-570d-4900-9e88-ef00a318b4f0	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:341","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 20:50:52","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},"hostname":"EderCortes"}	2024-11-04 20:50:52
33172	9d69a9c2-5136-4bbb-bf40-1bbdbb05d3e9	9d69a9c2-570d-4900-9e88-ef00a318b4f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_estado\\" = 'En curso', \\"loans_pago_interes\\" = 55000, \\"loans_pago_prestado\\" = 220000, \\"updated_at\\" = '2024-11-04 20:50:52' where \\"id\\" = 87","time":"0.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":414,"hash":"acfe32aea56c9ca6bdbb917f944a78d1","hostname":"EderCortes"}	2024-11-04 20:50:52
33173	9d69a9c2-516d-494a-a662-1e7a003457d2	9d69a9c2-570d-4900-9e88-ef00a318b4f0	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:87","changes":{"loans_estado":"En curso","updated_at":"2024-11-04 20:50:52","loans_pago_interes":55000,"loans_pago_prestado":220000},"hostname":"EderCortes"}	2024-11-04 20:50:52
33174	9d69a9c2-5546-4945-80ea-d5fb2afc92b8	9d69a9c2-570d-4900-9e88-ef00a318b4f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 20:50:52
32442	9d696133-00a9-46dc-90d2-3c7d190d26a7	9d696133-2386-4110-9c5b-ca8ab568ef19	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 17:27:58
32443	9d696133-17f7-476a-8368-091133ab77a6	9d696133-2386-4110-9c5b-ca8ab568ef19	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 380 limit 1","time":"2.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":444,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 17:27:58
32444	9d696133-184e-410b-88e3-4aa44f4018d2	9d696133-2386-4110-9c5b-ca8ab568ef19	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 17:27:58
32445	9d696133-19e2-4ec9-926c-1628305250ec	9d696133-2386-4110-9c5b-ca8ab568ef19	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 92 limit 1","time":"1.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":445,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 17:27:58
32446	9d696133-1a1d-426d-86a6-5f9741f1bf04	9d696133-2386-4110-9c5b-ca8ab568ef19	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 17:27:58
32447	9d696133-1e27-4659-af2f-f3f5fedc109f	9d696133-2386-4110-9c5b-ca8ab568ef19	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Abono intereses', \\"itemloans_aprobador\\" = 12, \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '133333.48333333', \\"updated_at\\" = '2024-11-04 17:27:58' where \\"id\\" = 380","time":"8.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":467,"hash":"af051d771f12c3efe446ba395bfe2ec0","hostname":"EderCortes"}	2024-11-04 17:27:58
32448	9d696133-1e97-45b5-a9af-91f286dc1c0d	9d696133-2386-4110-9c5b-ca8ab568ef19	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:380","changes":{"itemloans_status":"Abono intereses","itemloans_aprobador":12,"updated_at":"2024-11-04 17:27:58","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"133333.48333333"},"hostname":"EderCortes"}	2024-11-04 17:27:58
32449	9d696133-1f39-46b9-8d6f-33a4351de2e8	9d696133-2386-4110-9c5b-ca8ab568ef19	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 266666.96666666, \\"updated_at\\" = '2024-11-04 17:27:58' where \\"id\\" = 92","time":"0.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":475,"hash":"2cc48cbe18727cffabd573a782a26616","hostname":"EderCortes"}	2024-11-04 17:27:58
32450	9d696133-1f73-4e80-bff8-87d3e5db9837	9d696133-2386-4110-9c5b-ca8ab568ef19	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:92","changes":{"updated_at":"2024-11-04 17:27:58","loans_pago_interes":266666.96666666},"hostname":"EderCortes"}	2024-11-04 17:27:58
32451	9d696133-2234-4ad8-b7e6-0faca0920932	9d696133-2386-4110-9c5b-ca8ab568ef19	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 17:27:58
32452	9d696133-227b-4cd8-8cef-93a24b9d9aa4	9d696133-2386-4110-9c5b-ca8ab568ef19	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-intereses","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payInterese","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"160","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":0,"id":380,"loans_codigo":92,"item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El abono a intereses  de la cuota fue aplicado exitosamente","status":true},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:27:58
33175	9d69a9c2-55a3-4b0e-bc14-735f3d8b7624	9d69a9c2-570d-4900-9e88-ef00a318b4f0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"179","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000","id":341,"loans_codigo":87,"itemloans_cuota":"1","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":438,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:50:52
32453	9d696133-6f83-48a3-a9bc-9dab92fdebde	9d696133-b5ad-41f7-b4a8-90cc49f0ecb6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 17:27:58
32454	9d696133-ac39-43d5-bbef-ba5bb613cfdf	9d696133-b5ad-41f7-b4a8-90cc49f0ecb6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"143.74","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 17:27:59
32455	9d696133-af7b-4226-a969-34fd47397f0b	9d696133-b5ad-41f7-b4a8-90cc49f0ecb6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '92' order by \\"item_loans\\".\\"id\\" asc","time":"2.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 17:27:59
32456	9d696133-b42f-4738-be53-dc6b675d04a5	9d696133-b5ad-41f7-b4a8-90cc49f0ecb6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 17:27:59
32457	9d696133-b4a0-44d7-b979-1373a5545dac	9d696133-b5ad-41f7-b4a8-90cc49f0ecb6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":92,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":15,"loans_valor_prestado":8000009,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"533333.93333333","loans_pago_interes":"266666.96666666","user_alias":"eder.cortes"},"items":[{"id":379,"loans_codigo":92,"itemloans_cuota":"1","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:13:07","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":380,"loans_codigo":92,"itemloans_cuota":"2","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:27:58","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":381,"loans_codigo":92,"itemloans_cuota":"3","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":382,"loans_codigo":92,"itemloans_cuota":"4","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":383,"loans_codigo":92,"itemloans_cuota":"5","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":384,"loans_codigo":92,"itemloans_cuota":"6","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":385,"loans_codigo":92,"itemloans_cuota":"7","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":386,"loans_codigo":92,"itemloans_cuota":"8","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":387,"loans_codigo":92,"itemloans_cuota":"9","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-15 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":388,"loans_codigo":92,"itemloans_cuota":"10","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":389,"loans_codigo":92,"itemloans_cuota":"11","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-31 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":390,"loans_codigo":92,"itemloans_cuota":"12","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":391,"loans_codigo":92,"itemloans_cuota":"13","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-16 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":392,"loans_codigo":92,"itemloans_cuota":"14","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":393,"loans_codigo":92,"itemloans_cuota":"15","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:27:59
33176	9d69a9c3-2d7e-4c46-b9ff-169bc52328ae	9d69a9c3-4a69-44d7-b8b2-be3a11485195	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 20:50:52
33177	9d69a9c3-427a-4438-8f64-4f49ef97ca7e	9d69a9c3-4a69-44d7-b8b2-be3a11485195	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 87\\n                        ","time":"43.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"309a6eff5ebe9f2d91248732844dd9ed","hostname":"EderCortes"}	2024-11-04 20:50:52
33178	9d69a9c3-4551-478f-94fd-d79157431152	9d69a9c3-4a69-44d7-b8b2-be3a11485195	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '87' order by \\"item_loans\\".\\"id\\" asc","time":"2.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 20:50:52
33179	9d69a9c3-4923-4f12-8f92-e80e24aa1029	9d69a9c3-4a69-44d7-b8b2-be3a11485195	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 20:50:52
32458	9d6961b1-cfcd-497e-9a96-bd546d0cfc60	9d6961b1-d4a1-4a9b-9045-b69c7a07a1b2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-intereses","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":228,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:29:21
33180	9d69a9c3-496d-40c6-bfc9-6d7db213a475	9d69a9c3-4a69-44d7-b8b2-be3a11485195	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/87","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":87,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"220000","loans_pago_interes":"55000","user_alias":"eder.cortes"},"items":[{"id":341,"loans_codigo":87,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 20:50:52","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000","user_alias":"eder.cortes"},{"id":342,"loans_codigo":87,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":343,"loans_codigo":87,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":344,"loans_codigo":87,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":345,"loans_codigo":87,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":289,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:50:52
28334	9d6900cc-706e-4744-83f1-7f90347e22d6	9d6900cc-9af5-4167-9a4d-caaab868350d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 12:58:25
28335	9d6900cc-98a2-42ac-92eb-c3b4a00d3acf	9d6900cc-9af5-4167-9a4d-caaab868350d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 12:58:25
28336	9d6900cc-9984-4cd2-aa57-d20288a4018c	9d6900cc-9af5-4167-9a4d-caaab868350d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":460,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:58:25
28337	9d6900cd-4be6-483c-81b3-a7a179fd2ef2	9d6900cd-a600-45c4-9636-d54c90d1dd87	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 12:58:25
28338	9d6900cd-8fbe-4900-975f-d276b1a11c67	9d6900cd-a600-45c4-9636-d54c90d1dd87	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"161.18","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 12:58:25
28339	9d6900cd-96c9-4d91-b789-6e48586195c1	9d6900cd-a600-45c4-9636-d54c90d1dd87	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"4.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 12:58:26
28340	9d6900cd-973e-48b9-880d-8ef1f512904a	9d6900cd-a600-45c4-9636-d54c90d1dd87	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 12:58:26
21557	9d673c0c-e58d-4dd4-ae0d-a782b34bca1b	9d673c0d-0aec-4eb0-abf1-45236b0336ff	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 15:52:26
21558	9d673c0d-091a-40c3-af24-d8d681b6f364	9d673c0d-0aec-4eb0-abf1-45236b0336ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:52:26
21559	9d673c0d-09d9-44cb-a7d4-d67be90d93b8	9d673c0d-0aec-4eb0-abf1-45236b0336ff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":304,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:52:26
28341	9d6900cd-a3a1-41c1-80ba-6bfd79ff78e9	9d6900cd-a600-45c4-9636-d54c90d1dd87	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 12:58:26
28342	9d6900cd-a444-408f-b4ae-4e0d90157392	9d6900cd-a600-45c4-9636-d54c90d1dd87	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":625,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:58:26
32459	9d6961b2-662f-412d-92f0-357c05f8ee9e	9d6961b2-9b4b-4bb3-a4cf-b4069fa50659	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 17:29:22
32460	9d6961b2-89e0-4d4c-ad6d-c3763678ffa7	9d6961b2-9b4b-4bb3-a4cf-b4069fa50659	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 381 limit 1","time":"4.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":444,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 17:29:22
32461	9d6961b2-8a80-418c-b39e-468b5e106d77	9d6961b2-9b4b-4bb3-a4cf-b4069fa50659	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 17:29:22
32462	9d6961b2-8d94-45bb-a01a-d105026b4d9a	9d6961b2-9b4b-4bb3-a4cf-b4069fa50659	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 92 limit 1","time":"2.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":445,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 17:29:22
32463	9d6961b2-8dcf-4b8b-a215-e1b407d927b7	9d6961b2-9b4b-4bb3-a4cf-b4069fa50659	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 17:29:22
32464	9d6961b2-92b3-47c0-ab1c-213d34061e4d	9d6961b2-9b4b-4bb3-a4cf-b4069fa50659	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Abono intereses', \\"itemloans_aprobador\\" = 12, \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '133333.48333333', \\"updated_at\\" = '2024-11-04 17:29:22' where \\"id\\" = 381","time":"10.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":467,"hash":"af051d771f12c3efe446ba395bfe2ec0","hostname":"EderCortes"}	2024-11-04 17:29:22
32465	9d6961b2-933c-43a3-98a9-6383f04e4296	9d6961b2-9b4b-4bb3-a4cf-b4069fa50659	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:381","changes":{"itemloans_status":"Abono intereses","itemloans_aprobador":12,"updated_at":"2024-11-04 17:29:22","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"133333.48333333"},"hostname":"EderCortes"}	2024-11-04 17:29:22
32466	9d6961b2-9411-4fcf-a4b0-50869c99539c	9d6961b2-9b4b-4bb3-a4cf-b4069fa50659	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 400000.44999999, \\"updated_at\\" = '2024-11-04 17:29:22' where \\"id\\" = 92","time":"1.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":475,"hash":"2cc48cbe18727cffabd573a782a26616","hostname":"EderCortes"}	2024-11-04 17:29:22
32467	9d6961b2-9464-438e-89d7-4b788c0e0d0e	9d6961b2-9b4b-4bb3-a4cf-b4069fa50659	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:92","changes":{"updated_at":"2024-11-04 17:29:22","loans_pago_interes":400000.44999998994},"hostname":"EderCortes"}	2024-11-04 17:29:22
32468	9d6961b2-994e-4b86-93b1-fd7c576e9d54	9d6961b2-9b4b-4bb3-a4cf-b4069fa50659	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 17:29:22
21560	9d673c0d-711e-4364-a65d-da51d76054cd	9d673c0d-8eab-49fa-bf7a-b939c380c457	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:52:27
21561	9d673c0d-897c-42aa-9b81-dffd5d785d35	9d673c0d-8eab-49fa-bf7a-b939c380c457	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"44.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 15:52:27
21562	9d673c0d-8d58-441b-b726-428cc49644c7	9d673c0d-8eab-49fa-bf7a-b939c380c457	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:52:27
21563	9d673c0d-8dc4-4b19-8962-934ae04f1322	9d673c0d-8eab-49fa-bf7a-b939c380c457	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":290,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:52:27
17925	9d65b415-fefc-48f3-ba00-c9d0779e1fb9	9d65b416-2334-4141-a4f7-59224784473d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:36:25
17926	9d65b416-20fe-4905-a2cd-078a326d7bc1	9d65b416-2334-4141-a4f7-59224784473d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 21:36:26
17927	9d65b416-21b6-4982-9c80-40dd7df50d1e	9d65b416-2334-4141-a4f7-59224784473d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":281,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:36:26
32469	9d6961b2-99c5-4542-9b9e-d0abab41be36	9d6961b2-9b4b-4bb3-a4cf-b4069fa50659	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-intereses","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payInterese","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"160","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":0,"id":381,"loans_codigo":92,"item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El abono a intereses  de la cuota fue aplicado exitosamente","status":true},"duration":332,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:29:22
33181	9d69a9ef-636a-4fc8-aba4-efc793886d21	9d69a9ef-66ac-4faa-98ce-26a3354e59c8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":154,"memory":20,"hostname":"EderCortes"}	2024-11-04 20:51:21
17928	9d65b416-8943-40f7-a6a7-cf66ae68746e	9d65b416-b190-4de5-b1a7-28eac5c1e36c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 21:36:26
17929	9d65b416-a512-4e8f-91f7-7562673c2902	9d65b416-b190-4de5-b1a7-28eac5c1e36c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"50.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"2b11ef88578e3c91c11800e110e490df","hostname":"EderCortes"}	2024-11-02 21:36:26
17930	9d65b416-a98c-4820-9d70-fae42a993fb9	9d65b416-b190-4de5-b1a7-28eac5c1e36c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"2.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:36:26
17931	9d65b416-a9d0-4831-a368-e35ed03f2a82	9d65b416-b190-4de5-b1a7-28eac5c1e36c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:36:26
17932	9d65b416-afb6-4fc2-9cef-dece090610d7	9d65b416-b190-4de5-b1a7-28eac5c1e36c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 21:36:26
17933	9d65b416-b01a-430e-87a9-ccc74b02bc5f	9d65b416-b190-4de5-b1a7-28eac5c1e36c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":293,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:36:26
21564	9d673c0f-7476-4379-ae1c-29e904c6d837	9d673c0f-926f-4ac9-a00f-366d890896d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:52:28
21565	9d673c0f-8ced-4146-886c-c9595fe39b95	9d673c0f-926f-4ac9-a00f-366d890896d8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 15:52:28
21566	9d673c0f-8d49-4fd0-bcdd-277c39e783c7	9d673c0f-926f-4ac9-a00f-366d890896d8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 15:52:28
21567	9d673c0f-9129-49af-afc1-8f7b7d4b7e4d	9d673c0f-926f-4ac9-a00f-366d890896d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 15:52:28
21568	9d673c0f-9176-4325-b6e1-2df698b46273	9d673c0f-926f-4ac9-a00f-366d890896d8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":271,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:52:28
32470	9d6961b3-8413-45a4-9ad6-6917d9abdf0b	9d6961b3-a527-4abd-a398-7ebd0dd7df13	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 17:29:22
17934	9d65b418-493a-4df9-9004-f10f360f86c6	9d65b418-815f-4aad-a6ce-9e0e03f45aa8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-02 21:36:27
17935	9d65b418-795a-4847-9f6b-654d8b06d6c0	9d65b418-815f-4aad-a6ce-9e0e03f45aa8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"70.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 21:36:27
17936	9d65b418-79e6-47c9-b0aa-d59c2768f2c0	9d65b418-815f-4aad-a6ce-9e0e03f45aa8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 21:36:27
17937	9d65b418-7fa9-48d1-8c12-909a6c13d303	9d65b418-815f-4aad-a6ce-9e0e03f45aa8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 21:36:27
17938	9d65b418-8008-47c6-814a-4642263dfaea	9d65b418-815f-4aad-a6ce-9e0e03f45aa8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":401,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:36:27
21569	9d673c11-9c60-4d92-ad77-00a6708a8307	9d673c11-b6dd-4d90-858f-011e0ccce17f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 15:52:29
21570	9d673c11-b28f-4f4a-bca9-72265226c9e8	9d673c11-b6dd-4d90-858f-011e0ccce17f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"42.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-03 15:52:29
21571	9d673c11-b564-4900-bac4-00f0a1d73f04	9d673c11-b6dd-4d90-858f-011e0ccce17f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 15:52:29
21572	9d673c11-b5c4-4390-840c-6ee62c8418ba	9d673c11-b6dd-4d90-858f-011e0ccce17f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:52:29
32471	9d6961b3-9c77-4c14-a1c3-222dc04cc1f1	9d6961b3-a527-4abd-a398-7ebd0dd7df13	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"47.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 17:29:22
32472	9d6961b3-9f5a-42e4-a25a-4bab2f380e40	9d6961b3-a527-4abd-a398-7ebd0dd7df13	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '92' order by \\"item_loans\\".\\"id\\" asc","time":"2.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 17:29:22
32473	9d6961b3-a398-47e6-8f5b-a9d982c86679	9d6961b3-a527-4abd-a398-7ebd0dd7df13	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 17:29:22
32474	9d6961b3-a409-4a6b-b46a-ebc6a322954f	9d6961b3-a527-4abd-a398-7ebd0dd7df13	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":92,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":15,"loans_valor_prestado":8000009,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"533333.93333333","loans_pago_interes":"400000.44999999","user_alias":"eder.cortes"},"items":[{"id":379,"loans_codigo":92,"itemloans_cuota":"1","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:13:07","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":380,"loans_codigo":92,"itemloans_cuota":"2","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:27:58","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":381,"loans_codigo":92,"itemloans_cuota":"3","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:29:22","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":382,"loans_codigo":92,"itemloans_cuota":"4","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":383,"loans_codigo":92,"itemloans_cuota":"5","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":384,"loans_codigo":92,"itemloans_cuota":"6","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":385,"loans_codigo":92,"itemloans_cuota":"7","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":386,"loans_codigo":92,"itemloans_cuota":"8","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":387,"loans_codigo":92,"itemloans_cuota":"9","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-15 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":388,"loans_codigo":92,"itemloans_cuota":"10","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":389,"loans_codigo":92,"itemloans_cuota":"11","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-31 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":390,"loans_codigo":92,"itemloans_cuota":"12","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":391,"loans_codigo":92,"itemloans_cuota":"13","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-16 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":392,"loans_codigo":92,"itemloans_cuota":"14","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":393,"loans_codigo":92,"itemloans_cuota":"15","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":334,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:29:22
20302	9d66f114-972c-4e8a-be95-ee17285bebd8	9d66f114-b74a-4fb5-ba58-b8174b5e53ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:22:48
20303	9d66f114-b57b-4b82-b09b-230396f7806e	9d66f114-b74a-4fb5-ba58-b8174b5e53ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:22:48
20304	9d66f114-b61d-4d50-8200-e8187fa73d70	9d66f114-b74a-4fb5-ba58-b8174b5e53ca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":264,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:22:48
20305	9d66f115-111b-4ca0-bfd7-b4ec50d50588	9d66f115-2edc-4cef-ba5c-acbf8c4c1794	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:22:49
20306	9d66f115-26d8-4ee7-b771-42283914fdc1	9d66f115-2edc-4cef-ba5c-acbf8c4c1794	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"42.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:22:49
20307	9d66f115-2a2b-432c-8604-0a02eb7d3a65	9d66f115-2edc-4cef-ba5c-acbf8c4c1794	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:22:49
20308	9d66f115-2a65-4ec4-8144-209424a427a4	9d66f115-2edc-4cef-ba5c-acbf8c4c1794	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:22:49
20309	9d66f115-2dd6-4207-a7c9-b2daa1fbf06d	9d66f115-2edc-4cef-ba5c-acbf8c4c1794	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:22:49
20310	9d66f115-2e1b-483c-8854-8a3f4955b1f3	9d66f115-2edc-4cef-ba5c-acbf8c4c1794	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":259,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:22:49
21573	9d673c14-8e46-49e5-9977-8ca78532b84f	9d673c14-ac30-412d-917f-df4a77f23cc1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 15:52:31
21574	9d673c14-a6c5-41e5-8b3a-10bcfaa62d03	9d673c14-ac30-412d-917f-df4a77f23cc1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 15:52:31
21575	9d673c14-a70f-4025-ad59-d563352fda2e	9d673c14-ac30-412d-917f-df4a77f23cc1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 15:52:31
21576	9d673c14-aaa2-42cc-bae8-e9da4f70ce9a	9d673c14-ac30-412d-917f-df4a77f23cc1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 15:52:31
21577	9d673c14-ab08-4de3-a33b-8ff49caa89cf	9d673c14-ac30-412d-917f-df4a77f23cc1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":248,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:52:31
32475	9d6961d8-006c-48c5-b2e0-ad70992d9a23	9d6961d8-0437-4ab0-997d-e0087d37f2c1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-intereses","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":171,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:29:46
20311	9d66f116-d91f-4f66-aad2-041de52cd2f1	9d66f117-0a2c-49ab-841c-f6f1f009224d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:22:50
20312	9d66f117-0257-467b-9bee-423ededc1d9c	9d66f117-0a2c-49ab-841c-f6f1f009224d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"77.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:22:50
20313	9d66f117-02a9-4a8f-a950-d975ff7d3bfb	9d66f117-0a2c-49ab-841c-f6f1f009224d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:22:50
20314	9d66f117-0856-49eb-a9ad-54df60ae333d	9d66f117-0a2c-49ab-841c-f6f1f009224d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:22:50
20315	9d66f117-08d2-40ae-8bf1-900dcd27acb2	9d66f117-0a2c-49ab-841c-f6f1f009224d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":365,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:22:50
21578	9d673c14-ebc4-4962-8619-1c29b6e45e54	9d673c15-07c8-4690-bee5-4df7d766980f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 15:52:31
21579	9d673c15-02d3-496b-9248-829fa9fb6c20	9d673c15-07c8-4690-bee5-4df7d766980f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 15:52:32
21580	9d673c15-0332-4556-a50c-88ea884d3029	9d673c15-07c8-4690-bee5-4df7d766980f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-03 15:52:32
21581	9d673c15-06a4-4377-bc12-1530ee4d422d	9d673c15-07c8-4690-bee5-4df7d766980f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 15:52:32
21582	9d673c15-06e9-4fed-ac40-97d0490494fd	9d673c15-07c8-4690-bee5-4df7d766980f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":218,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:52:32
32476	9d6961d8-b6c8-4e8f-b550-c95e18337cf0	9d6961d8-d8e8-4bb5-9b55-93bd96942898	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 17:29:47
32477	9d6961d8-ceaf-45c0-a329-69d60fa1aaac	9d6961d8-d8e8-4bb5-9b55-93bd96942898	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 382 limit 1","time":"3.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":444,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 17:29:47
32478	9d6961d8-ceff-480a-8bb2-9a292ded1870	9d6961d8-d8e8-4bb5-9b55-93bd96942898	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 17:29:47
32479	9d6961d8-d0cd-48f4-91a5-e2fb96d18902	9d6961d8-d8e8-4bb5-9b55-93bd96942898	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 92 limit 1","time":"2.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":445,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 17:29:47
32480	9d6961d8-d106-44ca-a55d-ee0d4a8c478d	9d6961d8-d8e8-4bb5-9b55-93bd96942898	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 17:29:47
32481	9d6961d8-d2e5-4165-ab0b-795b04011e7e	9d6961d8-d8e8-4bb5-9b55-93bd96942898	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Abono intereses', \\"itemloans_aprobador\\" = 12, \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '133333.48333333', \\"updated_at\\" = '2024-11-04 17:29:47' where \\"id\\" = 382","time":"2.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":467,"hash":"af051d771f12c3efe446ba395bfe2ec0","hostname":"EderCortes"}	2024-11-04 17:29:47
32482	9d6961d8-d33d-4b75-aef2-ff48f986a093	9d6961d8-d8e8-4bb5-9b55-93bd96942898	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:382","changes":{"itemloans_status":"Abono intereses","itemloans_aprobador":12,"updated_at":"2024-11-04 17:29:47","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"133333.48333333"},"hostname":"EderCortes"}	2024-11-04 17:29:47
32483	9d6961d8-d3e7-466a-802d-fcc7955cee02	9d6961d8-d8e8-4bb5-9b55-93bd96942898	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 533333.93333332, \\"updated_at\\" = '2024-11-04 17:29:47' where \\"id\\" = 92","time":"0.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":475,"hash":"2cc48cbe18727cffabd573a782a26616","hostname":"EderCortes"}	2024-11-04 17:29:47
21583	9d673c17-77a4-475b-8494-adeb31358886	9d673c17-7acf-4f7d-aab2-0f34291520f2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":189,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:52:33
32484	9d6961d8-d422-44d8-8dac-4d8a843d186a	9d6961d8-d8e8-4bb5-9b55-93bd96942898	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:92","changes":{"updated_at":"2024-11-04 17:29:47","loans_pago_interes":533333.93333332},"hostname":"EderCortes"}	2024-11-04 17:29:47
32485	9d6961d8-d768-43ae-bce6-f68654b57c2a	9d6961d8-d8e8-4bb5-9b55-93bd96942898	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 17:29:47
32486	9d6961d8-d7c7-45fa-ad16-57a0443b3821	9d6961d8-d8e8-4bb5-9b55-93bd96942898	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-intereses","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payInterese","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"160","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":0,"id":382,"loans_codigo":92,"item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El abono a intereses  de la cuota fue aplicado exitosamente","status":true},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:29:47
21584	9d673c17-e0e0-4130-8235-a1287d820a77	9d673c17-e3e2-46eb-a755-824de9fabdea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":127,"memory":20,"hostname":"EderCortes"}	2024-11-03 15:52:33
32487	9d6961d9-2b81-4206-9ffb-8af79ee03e90	9d6961d9-4b88-42b4-b044-1538aaa2067e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 17:29:47
32488	9d6961d9-4400-4ddf-88df-285f6e4e6dc4	9d6961d9-4b88-42b4-b044-1538aaa2067e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"49.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 17:29:47
32489	9d6961d9-475a-4e38-9a54-d10f50a464ba	9d6961d9-4b88-42b4-b044-1538aaa2067e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '92' order by \\"item_loans\\".\\"id\\" asc","time":"2.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 17:29:47
32490	9d6961d9-4a1b-48e5-a2ff-c62e75806e38	9d6961d9-4b88-42b4-b044-1538aaa2067e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 17:29:47
32491	9d6961d9-4a6e-4885-b926-8df14a283549	9d6961d9-4b88-42b4-b044-1538aaa2067e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":92,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":15,"loans_valor_prestado":8000009,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"533333.93333333","loans_pago_interes":"533333.93333332","user_alias":"eder.cortes"},"items":[{"id":379,"loans_codigo":92,"itemloans_cuota":"1","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:13:07","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":380,"loans_codigo":92,"itemloans_cuota":"2","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:27:58","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":381,"loans_codigo":92,"itemloans_cuota":"3","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:29:22","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":382,"loans_codigo":92,"itemloans_cuota":"4","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:29:47","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":383,"loans_codigo":92,"itemloans_cuota":"5","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":384,"loans_codigo":92,"itemloans_cuota":"6","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":385,"loans_codigo":92,"itemloans_cuota":"7","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":386,"loans_codigo":92,"itemloans_cuota":"8","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":387,"loans_codigo":92,"itemloans_cuota":"9","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-15 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":388,"loans_codigo":92,"itemloans_cuota":"10","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":389,"loans_codigo":92,"itemloans_cuota":"11","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-31 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":390,"loans_codigo":92,"itemloans_cuota":"12","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":391,"loans_codigo":92,"itemloans_cuota":"13","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-16 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":392,"loans_codigo":92,"itemloans_cuota":"14","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":393,"loans_codigo":92,"itemloans_cuota":"15","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:29:47
33196	9d69a9f0-88ed-4c97-aefd-7aea55f69dbb	9d69a9f0-a5cc-4d87-95f3-8f947cb0aa12	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 20:51:22
33197	9d69a9f0-9e88-46e0-9ac8-82597da71ea6	9d69a9f0-a5cc-4d87-95f3-8f947cb0aa12	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 87\\n                        ","time":"41.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"309a6eff5ebe9f2d91248732844dd9ed","hostname":"EderCortes"}	2024-11-04 20:51:22
21585	9d673c18-308c-4c5b-b55a-e0c3113b0760	9d673c18-3366-4e54-9abe-73bfaa189705	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":131,"memory":20,"hostname":"EderCortes"}	2024-11-03 15:52:34
32492	9d696215-05e2-4dd8-87c5-ea55ca3e88a0	9d696215-09c7-44a6-ad5c-6c4be3006989	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":192,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:30:26
33198	9d69a9f0-a16f-40cc-963c-2297417fde73	9d69a9f0-a5cc-4d87-95f3-8f947cb0aa12	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '87' order by \\"item_loans\\".\\"id\\" asc","time":"2.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 20:51:22
28457	9d6901c1-6f19-4572-b93f-2e10e1fd26bf	9d6901c1-8c33-4e4d-95bd-b98f25ee1acc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 13:01:05
28458	9d6901c1-8a55-4362-95a4-554a9aedf956	9d6901c1-8c33-4e4d-95bd-b98f25ee1acc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 13:01:05
28459	9d6901c1-8b07-4b06-96ed-30f9a9df68f0	9d6901c1-8c33-4e4d-95bd-b98f25ee1acc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":368,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:01:05
33199	9d69a9f0-a462-4f79-a234-fb66273812d1	9d69a9f0-a5cc-4d87-95f3-8f947cb0aa12	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 20:51:22
33200	9d69a9f0-a4be-44f6-aa4c-5d39c4bc6aa9	9d69a9f0-a5cc-4d87-95f3-8f947cb0aa12	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/87","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":87,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"220000","loans_pago_interes":"55000","user_alias":"eder.cortes"},"items":[{"id":341,"loans_codigo":87,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 20:50:52","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000","user_alias":"eder.cortes"},{"id":342,"loans_codigo":87,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":343,"loans_codigo":87,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":344,"loans_codigo":87,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":345,"loans_codigo":87,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:51:22
21586	9d673c18-b4fc-4bb9-88fc-b4f104e33cc2	9d673c18-d1e3-44ec-a26d-4747afe8bc57	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 15:52:34
21587	9d673c18-cd04-4331-8be4-8b3b539c339b	9d673c18-d1e3-44ec-a26d-4747afe8bc57	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"43.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 15:52:34
21588	9d673c18-d074-426a-9ab8-5caf99a8f391	9d673c18-d1e3-44ec-a26d-4747afe8bc57	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 15:52:34
21589	9d673c18-d0c9-4212-8d47-7bdcbd7e3227	9d673c18-d1e3-44ec-a26d-4747afe8bc57	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:52:34
28460	9d6901c2-234d-40f2-aedf-18715331e19a	9d6901c2-693f-4d93-ba62-ef10d9f1fcb1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 13:01:06
28461	9d6901c2-5fb6-47b0-9125-69ae0dca6d89	9d6901c2-693f-4d93-ba62-ef10d9f1fcb1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"141.17","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 13:01:06
28462	9d6901c2-637a-4f8a-b62d-d4d150b507fa	9d6901c2-693f-4d93-ba62-ef10d9f1fcb1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:01:06
28463	9d6901c2-63b6-44a6-94ca-54ff56d3bf00	9d6901c2-693f-4d93-ba62-ef10d9f1fcb1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:01:06
28464	9d6901c2-67c6-48d5-88a3-d6557ba4d27c	9d6901c2-693f-4d93-ba62-ef10d9f1fcb1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 13:01:06
28465	9d6901c2-681d-4687-87b3-934b49157b31	9d6901c2-693f-4d93-ba62-ef10d9f1fcb1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":475,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:01:06
32493	9d696215-70e6-41ab-9082-ea0c6a1f4b9b	9d696215-a230-44ca-9be5-9cf744dcb20e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 17:30:26
32494	9d696215-91d8-43b5-9aaf-18930f1a3000	9d696215-a230-44ca-9be5-9cf744dcb20e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 380 limit 1","time":"3.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":362,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 17:30:27
32495	9d696215-9255-4597-b109-1407c92e05c3	9d696215-a230-44ca-9be5-9cf744dcb20e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 17:30:27
32496	9d696215-9487-4790-a924-08f1040686a9	9d696215-a230-44ca-9be5-9cf744dcb20e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 92 limit 1","time":"2.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":363,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 17:30:27
32497	9d696215-94c2-4745-8896-9ec37b7a782e	9d696215-a230-44ca-9be5-9cf744dcb20e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 17:30:27
21590	9d673c19-0eca-42fd-abc5-0ade748ac80b	9d673c19-2bc6-4471-9131-6b1e568ff40a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 15:52:34
21591	9d673c19-260a-4f3c-a2b9-5c028eb732f6	9d673c19-2bc6-4471-9131-6b1e568ff40a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"42.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 15:52:34
21592	9d673c19-2a11-424d-8f94-af8c0ffc5c84	9d673c19-2bc6-4471-9131-6b1e568ff40a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 15:52:34
21593	9d673c19-2a7c-4c2b-aa8d-4b0c2c5839f3	9d673c19-2bc6-4471-9131-6b1e568ff40a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":214,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:52:34
32498	9d696215-9873-43d8-991e-e735ad3727d3	9d696215-a230-44ca-9be5-9cf744dcb20e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_cuota_cancelada\\" = '533333.93333333', \\"updated_at\\" = '2024-11-04 17:30:27' where \\"id\\" = 380","time":"6.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":406,"hash":"35b67f849e4a0ba5090d9c1eb8abfe94","hostname":"EderCortes"}	2024-11-04 17:30:27
32499	9d696215-98d9-4266-af0c-e9504cc8374f	9d696215-a230-44ca-9be5-9cf744dcb20e	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:380","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 17:30:27","item_loans_cuando_pago":"04-11-2024","itemloans_cuota_cancelada":"533333.93333333"},"hostname":"EderCortes"}	2024-11-04 17:30:27
32500	9d696215-99a3-4000-b697-ce8d912795ff	9d696215-a230-44ca-9be5-9cf744dcb20e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_prestado\\" = 1066667.8666667, \\"updated_at\\" = '2024-11-04 17:30:27' where \\"id\\" = 92","time":"0.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":414,"hash":"4f19d69da2d9a6a5193ed1537b66ca88","hostname":"EderCortes"}	2024-11-04 17:30:27
32501	9d696215-99f3-4cce-b3b5-cdab5db3cc9b	9d696215-a230-44ca-9be5-9cf744dcb20e	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:92","changes":{"updated_at":"2024-11-04 17:30:27","loans_pago_prestado":1066667.86666666},"hostname":"EderCortes"}	2024-11-04 17:30:27
32502	9d696215-a00d-4113-be29-d00057249483	9d696215-a230-44ca-9be5-9cf744dcb20e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 17:30:27
32503	9d696215-a095-4db3-8f7d-cde927300b4b	9d696215-a230-44ca-9be5-9cf744dcb20e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"198","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","id":380,"loans_codigo":92,"itemloans_cuota":"2","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":322,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:30:27
21594	9d673c19-685b-446f-87ac-42d0f6c4ac04	9d673c19-81b3-4c32-a332-ab04687bb5fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 15:52:34
21595	9d673c19-7d9e-4b97-a13d-3d780a15a948	9d673c19-81b3-4c32-a332-ab04687bb5fc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"40.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 15:52:34
21596	9d673c19-8081-49e3-92b5-7153a7d6e032	9d673c19-81b3-4c32-a332-ab04687bb5fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 15:52:34
21597	9d673c19-80c5-4cad-ba50-a39c3f3fd899	9d673c19-81b3-4c32-a332-ab04687bb5fc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":209,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:52:34
32504	9d696216-1aa9-4a51-a8f1-a8b748bf66d8	9d696216-6402-46d5-904d-ee520a135bf3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 17:30:27
32505	9d696216-5adc-436e-8589-bcb827222630	9d696216-6402-46d5-904d-ee520a135bf3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"149.07","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 17:30:27
32506	9d696216-5e9b-48ec-bb40-f97aa6acf746	9d696216-6402-46d5-904d-ee520a135bf3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '92' order by \\"item_loans\\".\\"id\\" asc","time":"3.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 17:30:27
32507	9d696216-621f-442c-a7d1-9ab892e27c2a	9d696216-6402-46d5-904d-ee520a135bf3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 17:30:27
32508	9d696216-62a8-42e3-8777-1b537f6d3754	9d696216-6402-46d5-904d-ee520a135bf3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":92,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":15,"loans_valor_prestado":8000009,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1066667.8666667","loans_pago_interes":"533333.93333332","user_alias":"eder.cortes"},"items":[{"id":379,"loans_codigo":92,"itemloans_cuota":"1","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:13:07","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":380,"loans_codigo":92,"itemloans_cuota":"2","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:30:27","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":381,"loans_codigo":92,"itemloans_cuota":"3","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:29:22","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":382,"loans_codigo":92,"itemloans_cuota":"4","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:29:47","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":383,"loans_codigo":92,"itemloans_cuota":"5","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":384,"loans_codigo":92,"itemloans_cuota":"6","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":385,"loans_codigo":92,"itemloans_cuota":"7","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":386,"loans_codigo":92,"itemloans_cuota":"8","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":387,"loans_codigo":92,"itemloans_cuota":"9","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-15 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":388,"loans_codigo":92,"itemloans_cuota":"10","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":389,"loans_codigo":92,"itemloans_cuota":"11","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-31 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":390,"loans_codigo":92,"itemloans_cuota":"12","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":391,"loans_codigo":92,"itemloans_cuota":"13","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-16 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":392,"loans_codigo":92,"itemloans_cuota":"14","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":393,"loans_codigo":92,"itemloans_cuota":"15","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":465,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:30:27
21598	9d673c19-ba78-4d8f-ae7c-9677a00403a9	9d673c19-bd63-4a08-b207-5453bdc4287d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":133,"memory":20,"hostname":"EderCortes"}	2024-11-03 15:52:35
32509	9d696248-03b5-4d43-9cae-94190b9bdff5	9d696248-0881-4293-b6a4-f9398cb0f773	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":207,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:31:00
21599	9d673c1a-0a7c-42d1-96c3-7a80b0f846c2	9d673c1a-0e71-4d2f-b675-755ab188c3af	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":137,"memory":20,"hostname":"EderCortes"}	2024-11-03 15:52:35
32510	9d696248-6ee4-40e8-96f3-dac4e8dc18d1	9d696248-96c8-47f5-a962-4647e5611958	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 17:31:00
32511	9d696248-895b-455c-b247-572c14ec3cc9	9d696248-96c8-47f5-a962-4647e5611958	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 381 limit 1","time":"4.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":362,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 17:31:00
32512	9d696248-89d2-4431-9b67-5753778dfdca	9d696248-96c8-47f5-a962-4647e5611958	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 17:31:00
32513	9d696248-8c2e-4bec-a1e1-57864cb65f84	9d696248-96c8-47f5-a962-4647e5611958	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 92 limit 1","time":"3.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":363,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 17:31:00
32514	9d696248-8c73-4853-9684-0d8f33b8f95e	9d696248-96c8-47f5-a962-4647e5611958	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 17:31:00
32515	9d696248-903a-4a4e-8ad0-1d162083212f	9d696248-96c8-47f5-a962-4647e5611958	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_cuota_cancelada\\" = '533333.93333333', \\"updated_at\\" = '2024-11-04 17:31:00' where \\"id\\" = 381","time":"7.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":406,"hash":"35b67f849e4a0ba5090d9c1eb8abfe94","hostname":"EderCortes"}	2024-11-04 17:31:00
32516	9d696248-909d-4090-a37c-88692d9d34bb	9d696248-96c8-47f5-a962-4647e5611958	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:381","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 17:31:00","item_loans_cuando_pago":"04-11-2024","itemloans_cuota_cancelada":"533333.93333333"},"hostname":"EderCortes"}	2024-11-04 17:31:00
32517	9d696248-9158-4e85-8b80-8f9003743ccb	9d696248-96c8-47f5-a962-4647e5611958	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_prestado\\" = 1600001.8, \\"updated_at\\" = '2024-11-04 17:31:00' where \\"id\\" = 92","time":"0.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":414,"hash":"4f19d69da2d9a6a5193ed1537b66ca88","hostname":"EderCortes"}	2024-11-04 17:31:00
32518	9d696248-919c-453e-b3bc-5a1f5dd72793	9d696248-96c8-47f5-a962-4647e5611958	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:92","changes":{"updated_at":"2024-11-04 17:31:00","loans_pago_prestado":1600001.80000003},"hostname":"EderCortes"}	2024-11-04 17:31:00
32519	9d696248-9549-40cc-bc31-5f40d82bfc2a	9d696248-96c8-47f5-a962-4647e5611958	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 17:31:00
32520	9d696248-95a0-4ed4-b341-b9994259004d	9d696248-96c8-47f5-a962-4647e5611958	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"198","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","id":381,"loans_codigo":92,"itemloans_cuota":"3","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":283,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:31:00
21600	9d673c1a-5d82-40cd-9b28-ee4cc469be50	9d673c1a-608b-405e-a19a-edf0b037185a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":138,"memory":20,"hostname":"EderCortes"}	2024-11-03 15:52:35
32521	9d696248-f57b-4e29-80aa-addbb13b47fa	9d696249-1845-4ca2-b3eb-ace451167209	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 17:31:00
32522	9d696249-0fda-40bb-b96e-d1037c54743f	9d696249-1845-4ca2-b3eb-ace451167209	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"55.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 17:31:00
32523	9d696249-12c2-4ec0-ba4f-d33190555501	9d696249-1845-4ca2-b3eb-ace451167209	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '92' order by \\"item_loans\\".\\"id\\" asc","time":"2.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 17:31:00
32524	9d696249-1697-40d7-a94f-c719a34d0979	9d696249-1845-4ca2-b3eb-ace451167209	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 17:31:00
32525	9d696249-16fe-4e01-8256-7f125f9d2138	9d696249-1845-4ca2-b3eb-ace451167209	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":92,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":15,"loans_valor_prestado":8000009,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1600001.8","loans_pago_interes":"533333.93333332","user_alias":"eder.cortes"},"items":[{"id":379,"loans_codigo":92,"itemloans_cuota":"1","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:13:07","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":380,"loans_codigo":92,"itemloans_cuota":"2","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:30:27","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":381,"loans_codigo":92,"itemloans_cuota":"3","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:31:00","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":382,"loans_codigo":92,"itemloans_cuota":"4","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:29:47","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":383,"loans_codigo":92,"itemloans_cuota":"5","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":384,"loans_codigo":92,"itemloans_cuota":"6","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":385,"loans_codigo":92,"itemloans_cuota":"7","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":386,"loans_codigo":92,"itemloans_cuota":"8","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":387,"loans_codigo":92,"itemloans_cuota":"9","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-15 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":388,"loans_codigo":92,"itemloans_cuota":"10","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":389,"loans_codigo":92,"itemloans_cuota":"11","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-31 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":390,"loans_codigo":92,"itemloans_cuota":"12","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":391,"loans_codigo":92,"itemloans_cuota":"13","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-16 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":392,"loans_codigo":92,"itemloans_cuota":"14","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":393,"loans_codigo":92,"itemloans_cuota":"15","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":300,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:31:00
21601	9d673c1a-b157-40e9-9af1-6f5d6c1373cf	9d673c1a-f843-4299-b5e3-65f5415fe737	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 15:52:35
21602	9d673c1a-f442-4f2e-8dc1-a5df3cf0fe5f	9d673c1a-f843-4299-b5e3-65f5415fe737	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAr%' or \\"users\\".\\"user_document\\"::text like '%MAr%') order by \\"users\\".\\"user_document\\" asc","time":"150.80","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 15:52:35
21603	9d673c1a-f714-417b-b4bd-673c2a8f2739	9d673c1a-f843-4299-b5e3-65f5415fe737	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-03 15:52:35
21604	9d673c1a-f75a-464e-b7d7-cee3b6c13110	9d673c1a-f843-4299-b5e3-65f5415fe737	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAr"},"session":[],"response_status":200,"response":{"data":[]},"duration":331,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:52:35
32526	9d696258-e4e1-4c0d-a723-8af1645a0751	9d696258-e89d-4fcf-9543-6e04f04c6faa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":149,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:31:11
34867	9d69c0ce-1325-4669-aac6-848e0503f9b3	9d69c0ce-4618-4f8d-a989-d95ebc641d4f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:55:18
34868	9d69c0ce-4301-43e5-88b4-60bf695d271e	9d69c0ce-4618-4f8d-a989-d95ebc641d4f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:55:18
34869	9d69c0ce-4476-430c-bb9a-6b443dc868ca	9d69c0ce-4618-4f8d-a989-d95ebc641d4f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":419,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:55:18
21605	9d673c1b-3a17-4669-99d6-a4f1ecad771e	9d673c1b-54ce-47e9-83b8-b053c2c5985b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-03 15:52:36
21606	9d673c1b-5096-4775-b67b-05f9b86e67aa	9d673c1b-54ce-47e9-83b8-b053c2c5985b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAri%' or \\"users\\".\\"user_document\\"::text like '%MAri%') order by \\"users\\".\\"user_document\\" asc","time":"40.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 15:52:36
21607	9d673c1b-5397-4679-a10d-93466a4d83b1	9d673c1b-54ce-47e9-83b8-b053c2c5985b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-03 15:52:36
21608	9d673c1b-53df-434b-9b95-270ada8d155b	9d673c1b-54ce-47e9-83b8-b053c2c5985b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAri"},"session":[],"response_status":200,"response":{"data":[]},"duration":218,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:52:36
32527	9d696259-662d-4b23-8518-e7058a56a4be	9d696259-8830-423f-85be-beb659d747b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 17:31:11
24116	9d68a765-c8be-47a9-a52f-758899c284aa	9d68a765-ed7e-4c31-a117-0111bfb8a4d5	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 08:48:26
24117	9d68a765-eb4f-4a5c-9d1f-d7e84ff0548f	9d68a765-ed7e-4c31-a117-0111bfb8a4d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 08:48:26
24118	9d68a765-ec31-4595-8284-b530171b7fae	9d68a765-ed7e-4c31-a117-0111bfb8a4d5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":293,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:48:26
32528	9d696259-7cb3-46ce-a444-62c2c264de54	9d696259-8830-423f-85be-beb659d747b3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 382 limit 1","time":"3.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":362,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 17:31:11
32529	9d696259-7d0e-41dd-93d3-502378f14d68	9d696259-8830-423f-85be-beb659d747b3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 17:31:11
32530	9d696259-7eb4-492c-82fe-a2baa3c98086	9d696259-8830-423f-85be-beb659d747b3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 92 limit 1","time":"2.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":363,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 17:31:11
32531	9d696259-7ee9-4c19-b8a3-7ab02089011f	9d696259-8830-423f-85be-beb659d747b3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 17:31:11
32532	9d696259-8295-4e00-8be1-d724b19db2f8	9d696259-8830-423f-85be-beb659d747b3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_cuota_cancelada\\" = '533333.93333333', \\"updated_at\\" = '2024-11-04 17:31:11' where \\"id\\" = 382","time":"7.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":406,"hash":"35b67f849e4a0ba5090d9c1eb8abfe94","hostname":"EderCortes"}	2024-11-04 17:31:11
32533	9d696259-82ef-4acf-97f3-0eb50b11fccb	9d696259-8830-423f-85be-beb659d747b3	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:382","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 17:31:11","item_loans_cuando_pago":"04-11-2024","itemloans_cuota_cancelada":"533333.93333333"},"hostname":"EderCortes"}	2024-11-04 17:31:11
32534	9d696259-83b7-4f67-81d2-749265a26a45	9d696259-8830-423f-85be-beb659d747b3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_prestado\\" = 2133335.7333333, \\"updated_at\\" = '2024-11-04 17:31:11' where \\"id\\" = 92","time":"1.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":414,"hash":"4f19d69da2d9a6a5193ed1537b66ca88","hostname":"EderCortes"}	2024-11-04 17:31:11
32535	9d696259-83f0-4e24-8780-4597b4483388	9d696259-8830-423f-85be-beb659d747b3	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:92","changes":{"updated_at":"2024-11-04 17:31:11","loans_pago_prestado":2133335.73333333},"hostname":"EderCortes"}	2024-11-04 17:31:11
32536	9d696259-86ef-4fe6-b716-e1e2870cee32	9d696259-8830-423f-85be-beb659d747b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 17:31:11
32537	9d696259-8732-40c9-854b-6b820013f139	9d696259-8830-423f-85be-beb659d747b3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"198","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","id":382,"loans_codigo":92,"itemloans_cuota":"4","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:31:11
34870	9d69c0ce-e70e-45ae-8334-687487389154	9d69c0cf-1618-4e64-9c20-c4bb1afa7f73	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:55:19
21609	9d673c1b-94e6-4de6-a500-b6ab9e7e7876	9d673c1b-af59-4df1-97e7-77430f3f0ebe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-03 15:52:36
21610	9d673c1b-ab12-48a4-94aa-e2396dbcb7c2	9d673c1b-af59-4df1-97e7-77430f3f0ebe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAria%' or \\"users\\".\\"user_document\\"::text like '%MAria%') order by \\"users\\".\\"user_document\\" asc","time":"40.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 15:52:36
21611	9d673c1b-ae0a-4064-94ee-ec56c862df18	9d673c1b-af59-4df1-97e7-77430f3f0ebe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-03 15:52:36
21612	9d673c1b-ae53-4b3a-9fba-0fe398b52e0e	9d673c1b-af59-4df1-97e7-77430f3f0ebe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAria"},"session":[],"response_status":200,"response":{"data":[]},"duration":217,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:52:36
24119	9d68a766-545c-4d3c-8464-96fafe0fea52	9d68a766-742f-413b-b07e-635c67981dbd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 08:48:26
24120	9d68a766-6a79-458b-90fb-0e4ab7e01679	9d68a766-742f-413b-b07e-635c67981dbd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 66\\n                        ","time":"44.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"f5566f306d2be9466f2c4564ce0020bd","hostname":"EderCortes"}	2024-11-04 08:48:26
24121	9d68a766-6e19-40ac-a9da-f2528b1bede8	9d68a766-742f-413b-b07e-635c67981dbd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '66' order by \\"item_loans\\".\\"id\\" asc","time":"2.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:48:26
24122	9d68a766-6e59-4279-bb6f-0701c21a543c	9d68a766-742f-413b-b07e-635c67981dbd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 08:48:26
24123	9d68a766-7298-44b5-ba68-c2a8e2da362c	9d68a766-742f-413b-b07e-635c67981dbd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 08:48:26
24124	9d68a766-72e7-47be-b2dc-da5f3c7416a6	9d68a766-742f-413b-b07e-635c67981dbd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/66","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":66,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":5000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"5000000","loans_pago_interes":"1250000"},"items":[{"id":217,"loans_codigo":66,"itemloans_cuota":"1","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:26.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":218,"loans_codigo":66,"itemloans_cuota":"2","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":219,"loans_codigo":66,"itemloans_cuota":"3","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":220,"loans_codigo":66,"itemloans_cuota":"4","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:33.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":221,"loans_codigo":66,"itemloans_cuota":"5","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":222,"loans_codigo":66,"itemloans_cuota":"6","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:39.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":223,"loans_codigo":66,"itemloans_cuota":"7","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:42.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":224,"loans_codigo":66,"itemloans_cuota":"8","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:46.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":225,"loans_codigo":66,"itemloans_cuota":"9","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-31 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:50.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":226,"loans_codigo":66,"itemloans_cuota":"10","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:31:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"}]}},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:48:26
32538	9d696259-d762-4897-b416-c71a64d48bda	9d69625a-234c-4091-bdf9-6ba6b5d89448	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 17:31:11
34871	9d69c0cf-0f6b-4ffb-b0d2-25dc175d0e6d	9d69c0cf-1618-4e64-9c20-c4bb1afa7f73	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"65.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 21:55:19
34872	9d69c0cf-1435-42d3-8bed-47154708b7cf	9d69c0cf-1618-4e64-9c20-c4bb1afa7f73	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:55:19
21613	9d673c1d-bcd8-48b5-bd1d-b1f2df7b56f9	9d673c1d-bfd9-446c-b5fd-e4c2c28771cb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":142,"memory":20,"hostname":"EderCortes"}	2024-11-03 15:52:37
24125	9d68a768-90a4-44e2-a40f-ec5f5086582a	9d68a768-dbcb-4499-bb10-2a63d0e33d7e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 08:48:28
24126	9d68a768-d6ae-4528-9778-feafb14f5232	9d68a768-dbcb-4499-bb10-2a63d0e33d7e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"158.13","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 08:48:28
24127	9d68a768-d70d-4f12-9793-67c0c47dec84	9d68a768-dbcb-4499-bb10-2a63d0e33d7e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 08:48:28
24128	9d68a768-da74-49a3-b9a1-4e8671616ee0	9d68a768-dbcb-4499-bb10-2a63d0e33d7e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 08:48:28
24129	9d68a768-daba-44d1-be5d-154af67998e1	9d68a768-dbcb-4499-bb10-2a63d0e33d7e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:48:28
32539	9d69625a-19cb-4069-8180-4eba6fdb8cd1	9d69625a-234c-4091-bdf9-6ba6b5d89448	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"155.75","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 17:31:11
32540	9d69625a-1dde-4acb-9337-3d4155d3038c	9d69625a-234c-4091-bdf9-6ba6b5d89448	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '92' order by \\"item_loans\\".\\"id\\" asc","time":"2.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 17:31:11
32541	9d69625a-21f1-4237-9460-265ccc5ee824	9d69625a-234c-4091-bdf9-6ba6b5d89448	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 17:31:12
18987	9d66ce08-ed16-4f6a-991f-307ad93167f2	9d66ce09-0a9e-4787-ba8f-4505ddfd4d5f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 10:44:49
18988	9d66ce09-090b-4866-9064-94bda6ee2216	9d66ce09-0a9e-4787-ba8f-4505ddfd4d5f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 10:44:49
18989	9d66ce09-09a1-4918-b055-d30741167d1c	9d66ce09-0a9e-4787-ba8f-4505ddfd4d5f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:44:49
18990	9d66ce09-7d55-4a97-9a68-afc8c6c3df65	9d66ce09-9edf-4cec-a225-8f792577dd50	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 10:44:49
18991	9d66ce09-949a-4245-8332-bc29302a6fff	9d66ce09-9edf-4cec-a225-8f792577dd50	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"44.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ab80581c546fc8f323443e6bdf9d144f","hostname":"EderCortes"}	2024-11-03 10:44:49
18992	9d66ce09-98c8-42c3-aa28-08d8e88a410b	9d66ce09-9edf-4cec-a225-8f792577dd50	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 10:44:49
18993	9d66ce09-990b-4a0c-b15f-fb7148032791	9d66ce09-9edf-4cec-a225-8f792577dd50	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 10:44:49
18994	9d66ce09-9d29-404f-8500-51824ee68fdf	9d66ce09-9edf-4cec-a225-8f792577dd50	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 10:44:49
18995	9d66ce09-9da7-49e3-9c84-c39b9fbd6fd6	9d66ce09-9edf-4cec-a225-8f792577dd50	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:34:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"}]}},"duration":337,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:44:49
21614	9d673c1e-3521-4a96-acce-e915fe68a1da	9d673c1e-382c-44ee-95e5-257a8b611a21	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":136,"memory":20,"hostname":"EderCortes"}	2024-11-03 15:52:38
32542	9d69625a-224b-4479-8302-7055811f0ccc	9d69625a-234c-4091-bdf9-6ba6b5d89448	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":92,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":15,"loans_valor_prestado":8000009,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"2133335.7333333","loans_pago_interes":"533333.93333332","user_alias":"eder.cortes"},"items":[{"id":379,"loans_codigo":92,"itemloans_cuota":"1","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:13:07","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":380,"loans_codigo":92,"itemloans_cuota":"2","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:30:27","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":381,"loans_codigo":92,"itemloans_cuota":"3","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:31:00","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":382,"loans_codigo":92,"itemloans_cuota":"4","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:31:11","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":383,"loans_codigo":92,"itemloans_cuota":"5","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":384,"loans_codigo":92,"itemloans_cuota":"6","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":385,"loans_codigo":92,"itemloans_cuota":"7","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":386,"loans_codigo":92,"itemloans_cuota":"8","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":387,"loans_codigo":92,"itemloans_cuota":"9","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-15 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":388,"loans_codigo":92,"itemloans_cuota":"10","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":389,"loans_codigo":92,"itemloans_cuota":"11","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-31 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":390,"loans_codigo":92,"itemloans_cuota":"12","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":391,"loans_codigo":92,"itemloans_cuota":"13","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-16 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":392,"loans_codigo":92,"itemloans_cuota":"14","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":393,"loans_codigo":92,"itemloans_cuota":"15","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":369,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:31:12
18996	9d66ce0a-fc53-4e7a-a3fb-5e2d6e17f54d	9d66ce0b-21c8-43ae-88b0-9e5ce9041b58	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 10:44:50
18997	9d66ce0b-1ba8-45a7-902a-91b2a0b5079b	9d66ce0b-21c8-43ae-88b0-9e5ce9041b58	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"47.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 10:44:50
18998	9d66ce0b-1c00-453b-8d55-a721234d00b0	9d66ce0b-21c8-43ae-88b0-9e5ce9041b58	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 10:44:50
18999	9d66ce0b-2063-433c-b12b-4f36bf5403d3	9d66ce0b-21c8-43ae-88b0-9e5ce9041b58	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 10:44:50
19000	9d66ce0b-20a8-4c18-bbcb-afd2125544b2	9d66ce0b-21c8-43ae-88b0-9e5ce9041b58	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":425,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:44:50
21615	9d673c1e-8502-4eeb-93ba-440cbbb48398	9d673c1e-cb35-422d-8c15-56acfb438882	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-03 15:52:38
21616	9d673c1e-c6e2-40af-acff-203056b91ff4	9d673c1e-cb35-422d-8c15-56acfb438882	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mria%' or \\"users\\".\\"user_document\\"::text like '%Mria%') order by \\"users\\".\\"user_document\\" asc","time":"151.74","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 15:52:38
21617	9d673c1e-c9fa-4560-9537-14eb4af74e69	9d673c1e-cb35-422d-8c15-56acfb438882	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-03 15:52:38
21618	9d673c1e-ca40-4996-b24f-5d84b9d5ab2b	9d673c1e-cb35-422d-8c15-56acfb438882	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mria"},"session":[],"response_status":200,"response":{"data":[]},"duration":321,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:52:38
32543	9d6962db-d255-4b51-b8b7-4613f19294c0	9d6962db-f458-4a53-9b18-fbfe1c538f30	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 17:32:37
32544	9d6962db-ee71-4a07-827b-cc716385345c	9d6962db-f458-4a53-9b18-fbfe1c538f30	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"43.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 17:32:37
32545	9d6962db-f281-4f90-a078-f729e80bd5d1	9d6962db-f458-4a53-9b18-fbfe1c538f30	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 17:32:37
32546	9d6962db-f301-4adf-9a41-f910022bfd4d	9d6962db-f458-4a53-9b18-fbfe1c538f30	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":289,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:32:37
19001	9d66ce0d-aeb5-4749-af3a-32a40faf8d4f	9d66ce0d-ca8e-4738-b208-e585b8ca6a96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 10:44:52
19002	9d66ce0d-c631-42c2-8734-4724d22fd710	9d66ce0d-ca8e-4738-b208-e585b8ca6a96	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"43.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 10:44:52
19003	9d66ce0d-c909-495c-aea5-a9782583ea6d	9d66ce0d-ca8e-4738-b208-e585b8ca6a96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 10:44:52
19004	9d66ce0d-c96b-4eb1-a15b-fae51333d5f0	9d66ce0d-ca8e-4738-b208-e585b8ca6a96	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":218,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:44:52
21619	9d673c1f-11f0-4a68-81b7-c2869867c41a	9d673c1f-2dc5-4ff5-822c-7ac83d51142b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-03 15:52:38
21620	9d673c1f-297c-4230-b0b5-a8a73003712b	9d673c1f-2dc5-4ff5-822c-7ac83d51142b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"42.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 15:52:38
21621	9d673c1f-2c79-4d5d-b560-fb7228f365f6	9d673c1f-2dc5-4ff5-822c-7ac83d51142b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-03 15:52:38
21622	9d673c1f-2cc1-4506-9841-95b9f2f77577	9d673c1f-2dc5-4ff5-822c-7ac83d51142b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:52:38
32547	9d6962e9-737f-4ccd-804a-0a97fda54cf5	9d6962e9-8fc7-4ecc-a0f6-565c9dd8fb0b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 17:32:45
32548	9d6962e9-8866-4cd2-b938-b81147edfbc8	9d6962e9-8fc7-4ecc-a0f6-565c9dd8fb0b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"41.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 17:32:45
32549	9d6962e9-8aeb-4107-b283-69828188f2ab	9d6962e9-8fc7-4ecc-a0f6-565c9dd8fb0b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '92' order by \\"item_loans\\".\\"id\\" asc","time":"2.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 17:32:45
19005	9d66ce11-bc3c-4c0b-9dbf-96f4fdf46e99	9d66ce12-000e-4cca-98ff-82c12156d842	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 10:44:54
19006	9d66ce11-f7a2-4437-8d9d-b5ff4d043ed2	9d66ce12-000e-4cca-98ff-82c12156d842	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"140.45","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"2b11ef88578e3c91c11800e110e490df","hostname":"EderCortes"}	2024-11-03 10:44:55
19007	9d66ce11-fb0f-4e66-b3d7-5e1d5e9c18ba	9d66ce12-000e-4cca-98ff-82c12156d842	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"1.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 10:44:55
19008	9d66ce11-fb3e-4495-a2c1-866d2aa0dbde	9d66ce12-000e-4cca-98ff-82c12156d842	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 10:44:55
19009	9d66ce11-fedf-4a9a-9252-39fab67d90f6	9d66ce12-000e-4cca-98ff-82c12156d842	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 10:44:55
19010	9d66ce11-ff25-4c30-a3f5-b0d567b8778e	9d66ce12-000e-4cca-98ff-82c12156d842	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:44:55
21623	9d673c22-a8c7-4c30-ab22-52ae86f5cf81	9d673c22-c6e0-400c-8c19-1e8747a81909	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-03 15:52:40
21624	9d673c22-c1f5-437e-a928-eb022e247188	9d673c22-c6e0-400c-8c19-1e8747a81909	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '19' and \\"users\\".\\"deleted_at\\" is null","time":"43.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":55,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-11-03 15:52:41
21625	9d673c22-c246-4152-906a-02227734b084	9d673c22-c6e0-400c-8c19-1e8747a81909	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 15:52:41
21626	9d673c22-c5a9-4721-80e8-535b4d0b1343	9d673c22-c6e0-400c-8c19-1e8747a81909	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-03 15:52:41
21627	9d673c22-c5f1-4144-b6bb-cca7ab0032a4	9d673c22-c6e0-400c-8c19-1e8747a81909	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/19","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:52:41
32550	9d6962e9-8e4d-4c1e-bea3-f5d6d955cec6	9d6962e9-8fc7-4ecc-a0f6-565c9dd8fb0b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 17:32:46
6825	9d52d5a5-9735-4f52-9351-bd943b3cc2e3	9d52d5a5-9c1b-4901-9b60-fdebdad5bc31	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":348}	2024-10-24 12:29:32
18030	9d65b6c1-7c94-4bc9-bfdb-83d1b9f0cbb5	9d65b6c1-9b5a-4b7d-a6e4-07fa7ccbd3a8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 21:43:53
18031	9d65b6c1-99bb-4615-8a73-b77e719547f1	9d65b6c1-9b5a-4b7d-a6e4-07fa7ccbd3a8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 21:43:53
18032	9d65b6c1-9a5a-4ef3-aa7c-dd4f50c0fe11	9d65b6c1-9b5a-4b7d-a6e4-07fa7ccbd3a8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:43:53
32551	9d6962e9-8eaa-48a7-94f2-7fe87c379f0a	9d6962e9-8fc7-4ecc-a0f6-565c9dd8fb0b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":92,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":15,"loans_valor_prestado":8000009,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"2133335.7333333","loans_pago_interes":"533333.93333332","user_alias":"eder.cortes"},"items":[{"id":379,"loans_codigo":92,"itemloans_cuota":"1","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:13:07","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":380,"loans_codigo":92,"itemloans_cuota":"2","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:30:27","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":381,"loans_codigo":92,"itemloans_cuota":"3","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:31:00","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":382,"loans_codigo":92,"itemloans_cuota":"4","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:31:11","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":383,"loans_codigo":92,"itemloans_cuota":"5","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":384,"loans_codigo":92,"itemloans_cuota":"6","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":385,"loans_codigo":92,"itemloans_cuota":"7","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":386,"loans_codigo":92,"itemloans_cuota":"8","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":387,"loans_codigo":92,"itemloans_cuota":"9","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-15 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":388,"loans_codigo":92,"itemloans_cuota":"10","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":389,"loans_codigo":92,"itemloans_cuota":"11","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-31 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":390,"loans_codigo":92,"itemloans_cuota":"12","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":391,"loans_codigo":92,"itemloans_cuota":"13","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-16 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":392,"loans_codigo":92,"itemloans_cuota":"14","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":393,"loans_codigo":92,"itemloans_cuota":"15","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":299,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:32:46
18033	9d65b6c1-e78f-437e-be48-6d4bf8a3005e	9d65b6c2-3119-4eec-bd5f-c1601436d455	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 21:43:54
18034	9d65b6c2-2847-4111-9c6a-1d562a8f09e0	9d65b6c2-3119-4eec-bd5f-c1601436d455	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"153.18","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"2b11ef88578e3c91c11800e110e490df","hostname":"EderCortes"}	2024-11-02 21:43:54
18035	9d65b6c2-2bd6-4088-9651-ed30967f1dbe	9d65b6c2-3119-4eec-bd5f-c1601436d455	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"1.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:43:54
18036	9d65b6c2-2c0b-43ab-a7c8-825dbb4ea170	9d65b6c2-3119-4eec-bd5f-c1601436d455	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:43:54
18037	9d65b6c2-2fe5-418f-bc9c-86023dacd80e	9d65b6c2-3119-4eec-bd5f-c1601436d455	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 21:43:54
18038	9d65b6c2-3031-4c4b-b9d3-322410a325d4	9d65b6c2-3119-4eec-bd5f-c1601436d455	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":342,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:43:54
21628	9d673c57-c8d1-4f1a-b075-dd5181a4ca60	9d673c57-ea5c-42e9-a6d4-361621e2e23e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-03 15:53:15
21629	9d673c57-e279-491a-9210-46f30e21b2d8	9d673c57-ea5c-42e9-a6d4-361621e2e23e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"51.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-03 15:53:15
21630	9d673c57-e7f6-40f6-b2a1-9a858d6be24b	9d673c57-ea5c-42e9-a6d4-361621e2e23e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-03 15:53:15
21631	9d673c57-e8a7-4e84-bd8f-b82ff340be72	9d673c57-ea5c-42e9-a6d4-361621e2e23e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":321,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:53:15
18039	9d65b6c3-ed72-43ff-912a-d33116c7834e	9d65b6c4-2069-415e-ac46-e5bc29278bb8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 21:43:55
18040	9d65b6c4-18a9-49f7-ba1a-a1ed4d38137a	9d65b6c4-2069-415e-ac46-e5bc29278bb8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"77.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 21:43:55
18041	9d65b6c4-191b-47be-b0d3-9b81a2572d40	9d65b6c4-2069-415e-ac46-e5bc29278bb8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 21:43:55
18042	9d65b6c4-1e44-4c25-950c-05f38507060d	9d65b6c4-2069-415e-ac46-e5bc29278bb8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-02 21:43:55
18043	9d65b6c4-1ee5-40df-9e7f-afc8028a07ab	9d65b6c4-2069-415e-ac46-e5bc29278bb8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":360,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:43:55
21632	9d673c5b-bf10-4dfb-b8e3-46e08f75a819	9d673c5c-0acf-4432-b8c0-7ca10edc859b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-03 15:53:18
21633	9d673c5c-04d7-40fb-acfc-1dceb3894fc4	9d673c5c-0acf-4432-b8c0-7ca10edc859b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"160.17","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 15:53:18
21634	9d673c5c-08f1-411d-927c-243490187d16	9d673c5c-0acf-4432-b8c0-7ca10edc859b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-03 15:53:18
21635	9d673c5c-096e-4d3d-b8ab-45e9d2a917d5	9d673c5c-0acf-4432-b8c0-7ca10edc859b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":405,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:53:18
32552	9d696318-5cc0-4dcb-8c50-8b17e9a24526	9d696318-60fb-4f78-85e9-ade7b4b51a88	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-intereses","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":203,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:33:16
21636	9d673cae-bae6-4066-9bee-16f43fc866be	9d673cae-e644-4133-a6e6-f2c3bca8b9f6	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 15:54:12
21637	9d673cae-ddb4-4ecf-93db-eb4cc2b874d6	9d673cae-e644-4133-a6e6-f2c3bca8b9f6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"57.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-03 15:54:12
21638	9d673cae-e3df-496d-9bf3-1bc9fdbbfaf1	9d673cae-e644-4133-a6e6-f2c3bca8b9f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:54:12
21639	9d673cae-e49e-4fec-a0b0-fa3abe037423	9d673cae-e644-4133-a6e6-f2c3bca8b9f6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":323,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:54:12
32553	9d696318-d003-4729-85b8-7f8b31bcd86f	9d696319-2429-45e6-9f60-9798fccfa762	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 17:33:16
32554	9d696319-1504-4f73-9d4d-23269375cca2	9d696319-2429-45e6-9f60-9798fccfa762	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 383 limit 1","time":"3.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":444,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 17:33:17
32555	9d696319-157d-4ceb-a98d-c8cecb279a08	9d696319-2429-45e6-9f60-9798fccfa762	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 17:33:17
32556	9d696319-17c2-48d2-a515-a85b68544db4	9d696319-2429-45e6-9f60-9798fccfa762	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 92 limit 1","time":"2.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":445,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 17:33:17
32557	9d696319-1811-4b19-a7ed-d5027c5baf51	9d696319-2429-45e6-9f60-9798fccfa762	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 17:33:17
32558	9d696319-1b47-4e5f-a4e1-4c999e0b2294	9d696319-2429-45e6-9f60-9798fccfa762	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Abono intereses', \\"itemloans_aprobador\\" = 12, \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '133333.48333333', \\"updated_at\\" = '2024-11-04 17:33:17' where \\"id\\" = 383","time":"5.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":467,"hash":"af051d771f12c3efe446ba395bfe2ec0","hostname":"EderCortes"}	2024-11-04 17:33:17
32559	9d696319-1bc8-4f3d-ab2b-cd303c97b079	9d696319-2429-45e6-9f60-9798fccfa762	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:383","changes":{"itemloans_status":"Abono intereses","itemloans_aprobador":12,"updated_at":"2024-11-04 17:33:17","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"133333.48333333"},"hostname":"EderCortes"}	2024-11-04 17:33:17
32560	9d696319-1ca5-4ab0-8f93-d2e2d67c1644	9d696319-2429-45e6-9f60-9798fccfa762	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 666667.41666665, \\"updated_at\\" = '2024-11-04 17:33:17' where \\"id\\" = 92","time":"0.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":475,"hash":"2cc48cbe18727cffabd573a782a26616","hostname":"EderCortes"}	2024-11-04 17:33:17
32561	9d696319-1ce9-43fd-a8bb-01d0b75d0221	9d696319-2429-45e6-9f60-9798fccfa762	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:92","changes":{"updated_at":"2024-11-04 17:33:17","loans_pago_interes":666667.41666665},"hostname":"EderCortes"}	2024-11-04 17:33:17
32562	9d696319-2243-477e-9b9b-eeee8db12e66	9d696319-2429-45e6-9f60-9798fccfa762	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 17:33:17
32563	9d696319-22c3-4287-a15e-22bcd3f9d0b2	9d696319-2429-45e6-9f60-9798fccfa762	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-intereses","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payInterese","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"160","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":0,"id":383,"loans_codigo":92,"item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El abono a intereses  de la cuota fue aplicado exitosamente","status":true},"duration":419,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:33:17
21640	9d673cb0-7ddc-4083-aefe-b7e7f06dcf09	9d673cb0-c563-44c8-ab2f-6d1d4c411499	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:54:13
21641	9d673cb0-c016-44f4-80ce-a2f3054990b5	9d673cb0-c563-44c8-ab2f-6d1d4c411499	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"142.94","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 15:54:14
21642	9d673cb0-c067-4dff-8c1e-30f515a2f25d	9d673cb0-c563-44c8-ab2f-6d1d4c411499	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 15:54:14
21643	9d673cb0-c427-4190-a92a-760fe0fb0526	9d673cb0-c563-44c8-ab2f-6d1d4c411499	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:54:14
21644	9d673cb0-c47b-401a-9866-26e69f85306d	9d673cb0-c563-44c8-ab2f-6d1d4c411499	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":521,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:54:14
32564	9d696319-96b3-44b9-8e2e-51acc19a6f69	9d696319-e383-4141-a059-e199a360ab13	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 17:33:17
32565	9d696319-da82-4be5-8ba7-2da4710df814	9d696319-e383-4141-a059-e199a360ab13	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"156.81","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 17:33:17
32566	9d696319-de2d-4a84-9c5e-fb14b33a836d	9d696319-e383-4141-a059-e199a360ab13	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '92' order by \\"item_loans\\".\\"id\\" asc","time":"2.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 17:33:17
32567	9d696319-e201-4634-84dd-3da7eaa655a2	9d696319-e383-4141-a059-e199a360ab13	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 17:33:17
32568	9d696319-e262-4d19-a1a8-00db81c13b21	9d696319-e383-4141-a059-e199a360ab13	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":92,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":15,"loans_valor_prestado":8000009,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"2133335.7333333","loans_pago_interes":"666667.41666665","user_alias":"eder.cortes"},"items":[{"id":379,"loans_codigo":92,"itemloans_cuota":"1","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:13:07","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":380,"loans_codigo":92,"itemloans_cuota":"2","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:30:27","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":381,"loans_codigo":92,"itemloans_cuota":"3","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:31:00","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":382,"loans_codigo":92,"itemloans_cuota":"4","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:31:11","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":383,"loans_codigo":92,"itemloans_cuota":"5","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:33:17","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":384,"loans_codigo":92,"itemloans_cuota":"6","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":385,"loans_codigo":92,"itemloans_cuota":"7","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":386,"loans_codigo":92,"itemloans_cuota":"8","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":387,"loans_codigo":92,"itemloans_cuota":"9","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-15 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":388,"loans_codigo":92,"itemloans_cuota":"10","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":389,"loans_codigo":92,"itemloans_cuota":"11","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-31 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":390,"loans_codigo":92,"itemloans_cuota":"12","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":391,"loans_codigo":92,"itemloans_cuota":"13","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-16 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":392,"loans_codigo":92,"itemloans_cuota":"14","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":393,"loans_codigo":92,"itemloans_cuota":"15","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":451,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:33:17
21645	9d673cb1-09fe-4344-908f-9f4abe8f2822	9d673cb1-263c-40f3-9088-bf8e358cd602	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:54:14
21646	9d673cb1-2191-4f0d-9207-4569a4b28e04	9d673cb1-263c-40f3-9088-bf8e358cd602	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 15:54:14
21647	9d673cb1-21d8-4d1e-b771-1e82dda6bb34	9d673cb1-263c-40f3-9088-bf8e358cd602	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-03 15:54:14
21648	9d673cb1-2512-4c2e-8ff1-7b2c6be31d1e	9d673cb1-263c-40f3-9088-bf8e358cd602	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 15:54:14
21649	9d673cb1-2555-476f-87c0-04d28ee8eed1	9d673cb1-263c-40f3-9088-bf8e358cd602	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":228,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:54:14
32569	9d6963b6-b7e0-4439-9c89-e463a2dee484	9d6963b6-bece-4559-a81b-defd9af8bb18	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-total-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":241,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:35:00
34391	9d69be31-9a31-43db-9feb-68f9fde6ed30	9d69be31-df38-48f1-8425-30bc621e93bc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 21:48:00
34392	9d69be31-ddc8-479f-bae8-df0f358ed374	9d69be31-df38-48f1-8425-30bc621e93bc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 21:48:00
34393	9d69be31-de60-4367-89b1-abe575c0efaa	9d69be31-df38-48f1-8425-30bc621e93bc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":365,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:48:00
21650	9d673cb4-b3da-4015-8fbd-f3446fae4f39	9d673cb4-b6c4-4f98-a356-8ee8ca52962e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":140,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:54:16
32570	9d6963b7-2031-4833-9d63-e9a5d1d424a8	9d6963b7-4bb7-4bf5-bb9b-04d3f9324ace	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 17:35:00
32571	9d6963b7-408c-42a6-8d64-76912ea0429a	9d6963b7-4bb7-4bf5-bb9b-04d3f9324ace	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 92 limit 1","time":"2.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":715,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 17:35:00
32572	9d6963b7-40f4-483a-9c9b-fccdf102294c	9d6963b7-4bb7-4bf5-bb9b-04d3f9324ace	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 17:35:00
32573	9d6963b7-4234-40a0-be9e-53d774b8fe41	9d6963b7-4bb7-4bf5-bb9b-04d3f9324ace	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_estado\\" = 'Cancelado', \\"loans_pago_interes\\" = 2000002.25, \\"loans_pago_prestado\\" = 8000009, \\"updated_at\\" = '2024-11-04 17:35:00' where \\"id\\" = 92","time":"0.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":740,"hash":"acfe32aea56c9ca6bdbb917f944a78d1","hostname":"EderCortes"}	2024-11-04 17:35:00
32574	9d6963b7-4294-4d30-8bd8-43ce6271a1ec	9d6963b7-4bb7-4bf5-bb9b-04d3f9324ace	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:92","changes":{"loans_estado":"Cancelado","updated_at":"2024-11-04 17:35:00","loans_pago_interes":2000002.25,"loans_pago_prestado":8000009},"hostname":"EderCortes"}	2024-11-04 17:35:00
32575	9d6963b7-4405-44e8-80e1-5c34c5c5576b	9d6963b7-4bb7-4bf5-bb9b-04d3f9324ace	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 92 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"2.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":745,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 17:35:00
32576	9d6963b7-4436-4013-a7e0-0c3624fde1c8	9d6963b7-4bb7-4bf5-bb9b-04d3f9324ace	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 17:35:00
32577	9d6963b7-4579-4645-89cc-b3eba208fcc4	9d6963b7-4bb7-4bf5-bb9b-04d3f9324ace	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_interes_canelado\\" = '133333.48333333', \\"itemloans_cuota_cancelada\\" = '533333.93333333', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_status\\" = 'Pagada', \\"itemloans_aprobador\\" = 12, \\"updated_at\\" = '2024-11-04 17:35:00' where \\"loans_codigo\\" = 92 and \\"itemloans_status\\" = 'Pendiente'","time":"2.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":754,"hash":"87a64c6113219082cd85f391b598ec7f","hostname":"EderCortes"}	2024-11-04 17:35:00
32578	9d6963b7-49f9-45f2-b4ef-ee6509c9b5be	9d6963b7-4bb7-4bf5-bb9b-04d3f9324ace	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 17:35:00
32579	9d6963b7-4a54-4e34-a09b-1ab2cee5f126	9d6963b7-4bb7-4bf5-bb9b-04d3f9324ace	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-total-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payTotal","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"39","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"idLoans":92,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"Se ha realizado el pago total del credito","status":true},"duration":292,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:35:00
34394	9d69be32-349e-40e3-aaac-70b01ff20f9e	9d69be32-79e3-4175-9301-43f3764cdf16	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 21:48:00
34395	9d69be32-74b1-4e26-beba-da3e757023b2	9d69be32-79e3-4175-9301-43f3764cdf16	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"140.58","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":254,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:48:01
34396	9d69be32-7532-4ac6-864c-df9822b80a45	9d69be32-79e3-4175-9301-43f3764cdf16	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:48:01
34397	9d69be32-78cd-4ad7-ba86-9f3aa018bffa	9d69be32-79e3-4175-9301-43f3764cdf16	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 21:48:01
34398	9d69be32-7910-4c0a-8181-2bb826775777	9d69be32-79e3-4175-9301-43f3764cdf16	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":343,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:48:01
21651	9d673cb5-2d47-44e4-9265-e2c14f20a959	9d673cb5-302a-41db-a3f7-d41e62692fb9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":138,"memory":20,"hostname":"EderCortes"}	2024-11-03 15:54:16
32580	9d6963b8-336c-43ef-a2fe-b54f5ad93f67	9d6963b8-4f88-40f7-aa93-aeb110b8885d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 17:35:01
32581	9d6963b8-4890-47b9-af53-c46e7522334a	9d6963b8-4f88-40f7-aa93-aeb110b8885d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"41.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 17:35:01
32582	9d6963b8-4b28-4e0d-8729-aa87c5b94cd5	9d6963b8-4f88-40f7-aa93-aeb110b8885d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '92' order by \\"item_loans\\".\\"id\\" asc","time":"2.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 17:35:01
32583	9d6963b8-4e0f-4150-8a03-5ebd3f9c4afb	9d6963b8-4f88-40f7-aa93-aeb110b8885d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 17:35:01
32584	9d6963b8-4e7c-44dc-a074-fbd846a2ece7	9d6963b8-4f88-40f7-aa93-aeb110b8885d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":92,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":15,"loans_valor_prestado":8000009,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"8000009","loans_pago_interes":"2000002.25","user_alias":"eder.cortes"},"items":[{"id":379,"loans_codigo":92,"itemloans_cuota":"1","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:13:07","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":380,"loans_codigo":92,"itemloans_cuota":"2","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:30:27","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":381,"loans_codigo":92,"itemloans_cuota":"3","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:31:00","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":382,"loans_codigo":92,"itemloans_cuota":"4","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:31:11","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":383,"loans_codigo":92,"itemloans_cuota":"5","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:33:17","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":384,"loans_codigo":92,"itemloans_cuota":"6","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:35:00","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":385,"loans_codigo":92,"itemloans_cuota":"7","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:35:00","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":386,"loans_codigo":92,"itemloans_cuota":"8","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:35:00","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":387,"loans_codigo":92,"itemloans_cuota":"9","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-15 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:35:00","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":388,"loans_codigo":92,"itemloans_cuota":"10","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:35:00","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":389,"loans_codigo":92,"itemloans_cuota":"11","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-31 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:35:00","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":390,"loans_codigo":92,"itemloans_cuota":"12","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:35:00","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":391,"loans_codigo":92,"itemloans_cuota":"13","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-16 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:35:00","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":392,"loans_codigo":92,"itemloans_cuota":"14","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:35:00","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":393,"loans_codigo":92,"itemloans_cuota":"15","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 17:35:00","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"}]}},"duration":319,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:35:01
34399	9d69be32-bf63-4a37-a320-46e5b599532a	9d69be32-dc40-4b6c-9a57-2cc0ca7833e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 21:48:01
34400	9d69be32-d6ed-49ed-8204-48c291abcef9	9d69be32-dc40-4b6c-9a57-2cc0ca7833e5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":243,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 21:48:01
34401	9d69be32-d73d-4fb1-825f-0e7de61dd049	9d69be32-dc40-4b6c-9a57-2cc0ca7833e5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 21:48:01
34402	9d69be32-db14-4a25-bb44-bfe7c1563118	9d69be32-dc40-4b6c-9a57-2cc0ca7833e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 21:48:01
34403	9d69be32-db5e-43ed-8c87-5a495d17560f	9d69be32-dc40-4b6c-9a57-2cc0ca7833e5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:48:01
21652	9d673cb5-aa80-48ea-a64d-1214617424ed	9d673cb5-eca2-4b88-99c5-72e065ed9df6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 15:54:17
21653	9d673cb5-e850-409a-b989-3a70ada19c43	9d673cb5-eca2-4b88-99c5-72e065ed9df6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ma%' or \\"users\\".\\"user_document\\"::text like '%Ma%') order by \\"users\\".\\"user_document\\" asc","time":"143.15","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 15:54:17
21654	9d673cb5-eb5f-4f49-96c8-f3b8653cc4b5	9d673cb5-eca2-4b88-99c5-72e065ed9df6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 15:54:17
21655	9d673cb5-ebab-4bd9-8ae8-a63bab8ffc98	9d673cb5-eca2-4b88-99c5-72e065ed9df6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ma"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":314,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:54:17
32585	9d696723-a2ca-4363-8958-92b03801e930	9d696723-f34a-4b4d-b32a-0e6313e4b482	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 17:44:35
32586	9d696723-ed89-4622-831a-a5687a7b07d8	9d696723-f34a-4b4d-b32a-0e6313e4b482	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"159.37","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 17:44:35
32587	9d696723-f14f-4f5b-aa35-0b9dae1f11dd	9d696723-f34a-4b4d-b32a-0e6313e4b482	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 17:44:35
32588	9d696723-f1ea-4105-bbd0-8b699c487398	9d696723-f34a-4b4d-b32a-0e6313e4b482	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":391,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:44:35
34404	9d69be33-20ae-4dac-9c3e-aed531d58604	9d69be33-6592-448d-81e9-6c5ebf34eef7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 21:48:01
34405	9d69be33-6010-4180-9a6e-82ec1825ee83	9d69be33-6592-448d-81e9-6c5ebf34eef7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"141.03","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:48:01
34406	9d69be33-6067-4e91-a7d4-e91899eb9680	9d69be33-6592-448d-81e9-6c5ebf34eef7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:48:01
34407	9d69be33-647d-40c8-8979-b1a5fc1c0c1d	9d69be33-6592-448d-81e9-6c5ebf34eef7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 21:48:01
21656	9d673cb6-2da7-4888-ac16-f72cbfb267fe	9d673cb6-3067-467e-96c9-1889a820f586	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":142,"memory":20,"hostname":"EderCortes"}	2024-11-03 15:54:17
32589	9d696724-7bad-4c92-8a50-e79734bf449b	9d696724-c31c-4af6-8bb0-6f1cc01a2a37	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 17:44:35
32590	9d696724-be56-406e-89bf-da08d1fe6a52	9d696724-c31c-4af6-8bb0-6f1cc01a2a37	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"154.24","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 17:44:35
32591	9d696724-c1a6-478e-a841-91c59afeb1ea	9d696724-c31c-4af6-8bb0-6f1cc01a2a37	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 17:44:35
32592	9d696724-c221-4021-af39-7676999be72c	9d696724-c31c-4af6-8bb0-6f1cc01a2a37	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":369,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:44:35
34408	9d69be33-64c6-4c5f-911d-f2a5c7c677b1	9d69be33-6592-448d-81e9-6c5ebf34eef7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":338,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:48:01
34873	9d69c0cf-14e4-41e8-b7d5-01dae8c96d1c	9d69c0cf-1618-4e64-9c20-c4bb1afa7f73	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":448,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:55:19
21657	9d673cb6-7ed4-4791-a273-4357e100093a	9d673cb6-81ba-4216-88cd-2ffc662fd96f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":130,"memory":20,"hostname":"EderCortes"}	2024-11-03 15:54:17
32593	9d696729-559a-49c0-b694-e924ae704211	9d696729-99e2-4d04-afbb-ccb2185ac375	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 17:44:38
32594	9d696729-930e-4944-a55a-8a423a378399	9d696729-99e2-4d04-afbb-ccb2185ac375	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 91\\n                        ","time":"144.45","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"9ae30bc69b6b272f3f51ff48e54319f5","hostname":"EderCortes"}	2024-11-04 17:44:39
32595	9d696729-95c8-4ff3-9910-8acc19be9292	9d696729-99e2-4d04-afbb-ccb2185ac375	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '91' order by \\"item_loans\\".\\"id\\" asc","time":"2.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 17:44:39
28706	9d690735-d51a-4877-b52e-e4c2e59cb0c3	9d690735-f489-43b6-9082-31705b62c5f1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 13:16:20
28707	9d690735-f2cf-4479-baad-db686f3b053e	9d690735-f489-43b6-9082-31705b62c5f1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 13:16:21
28708	9d690735-f37b-45d6-a8b4-1d05e1aab09b	9d690735-f489-43b6-9082-31705b62c5f1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":433,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:16:21
32596	9d696729-9896-47ef-8b48-3e9b2f567eac	9d696729-99e2-4d04-afbb-ccb2185ac375	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 17:44:39
32597	9d696729-98e8-481f-9c6a-a32f56c89582	9d696729-99e2-4d04-afbb-ccb2185ac375	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/91","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":91,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":8,"loans_valor_prestado":5000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0","user_alias":"eder.cortes"},"items":[{"id":371,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 16:04:19","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":372,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 16:04:19","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":373,"loans_codigo":91,"itemloans_cuota":"3","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 16:04:19","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":374,"loans_codigo":91,"itemloans_cuota":"4","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 16:04:19","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":375,"loans_codigo":91,"itemloans_cuota":"5","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 16:04:19","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":376,"loans_codigo":91,"itemloans_cuota":"6","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 16:04:19","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":377,"loans_codigo":91,"itemloans_cuota":"7","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 16:04:19","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":378,"loans_codigo":91,"itemloans_cuota":"8","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 16:04:19","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":329,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:44:39
34409	9d69be33-a7f2-49d7-bbd7-942eb87163e6	9d69be33-f348-4406-aecf-64a84f6dc47f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 21:48:01
34410	9d69be33-eb74-474c-aab3-639d634b0170	9d69be33-f348-4406-aecf-64a84f6dc47f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_valor_prestado\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"loans_inicio_pago\\", \\"user_creador\\", \\"user_cobrador\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\" from \\"loans\\" where \\"id\\" = '93' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"151.81","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":230,"hash":"dc36cfe73e584c5ac1844cdd4e6447e9","hostname":"EderCortes"}	2024-11-04 21:48:02
34411	9d69be33-ebd1-4438-9663-4607cda6a3b8	9d69be33-f348-4406-aecf-64a84f6dc47f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 21:48:02
34412	9d69be33-ed76-47d4-b0fb-608c3e3ac88f	9d69be33-f348-4406-aecf-64a84f6dc47f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"1.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":231,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 21:48:02
34413	9d69be33-edb1-44fd-8c2d-886fe14484b4	9d69be33-f348-4406-aecf-64a84f6dc47f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 21:48:02
34414	9d69be33-f21e-4438-a39b-8b66d53d4a94	9d69be33-f348-4406-aecf-64a84f6dc47f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 21:48:02
21658	9d673cb6-d4d0-4a0a-8688-ca17eda0d49a	9d673cb6-ef99-49de-af21-00d8a9b77bc8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 15:54:18
21659	9d673cb6-eb18-4ea3-9a09-10013d1278d0	9d673cb6-ef99-49de-af21-00d8a9b77bc8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mar%' or \\"users\\".\\"user_document\\"::text like '%Mar%') order by \\"users\\".\\"user_document\\" asc","time":"40.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 15:54:18
21660	9d673cb6-ee44-4f51-99f7-dfc3c83b3f47	9d673cb6-ef99-49de-af21-00d8a9b77bc8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 15:54:18
21661	9d673cb6-ee96-42f3-9ca1-056b44f2d975	9d673cb6-ef99-49de-af21-00d8a9b77bc8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mar"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:54:18
28709	9d690736-7e23-4795-aa83-a6e053c7404f	9d690736-9c66-43e9-acdb-208d6ae09a2c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 13:16:21
28710	9d690736-96e7-4fc6-b9ad-c116e927d3f5	9d690736-9c66-43e9-acdb-208d6ae09a2c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:16:21
28711	9d690736-9765-42a6-b7df-4d7d2c1eccea	9d690736-9c66-43e9-acdb-208d6ae09a2c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 13:16:21
28712	9d690736-9b41-4aa7-bb77-3b8424c05df7	9d690736-9c66-43e9-acdb-208d6ae09a2c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 13:16:21
28713	9d690736-9b8a-4119-9b82-6dacb8bd8d31	9d690736-9c66-43e9-acdb-208d6ae09a2c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":375,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:16:21
32598	9d696734-5f3b-4b12-bd2a-bb474a39c982	9d696734-62d8-41d6-8d5b-69fd73892164	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":147,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:44:46
34415	9d69be33-f26d-4342-b8a8-238b0ed09068	9d69be33-f348-4406-aecf-64a84f6dc47f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","user_creador":12,"user_cobrador":22,"loans_pago_prestado":"1000000","loans_pago_interes":"250000"},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:19:45.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:22:30.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":399,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":400,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":401,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":402,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"}]}},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:48:02
34874	9d69c0cf-b446-4599-83ce-0d845861185b	9d69c0cf-f7ed-48b6-93ed-b15a7e9520f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:55:19
34875	9d69c0cf-edab-47b0-9a4c-e2e520b46523	9d69c0cf-f7ed-48b6-93ed-b15a7e9520f5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"87.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:55:19
34876	9d69c0cf-ee7d-4c58-8466-87a2d7144b80	9d69c0cf-f7ed-48b6-93ed-b15a7e9520f5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:55:19
34877	9d69c0cf-f5d1-46a2-a2ea-c4455ab51790	9d69c0cf-f7ed-48b6-93ed-b15a7e9520f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:55:19
21662	9d673cb7-316b-4ea9-a960-c8b3de635c95	9d673cb7-3547-413d-b904-f8208c2378ae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":154,"memory":20,"hostname":"EderCortes"}	2024-11-03 15:54:18
28714	9d690737-1154-44da-80d3-52aac50067a7	9d690737-318a-4f7c-a722-b04a86745817	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 13:16:21
28715	9d690737-2c32-497c-a7cc-bd9cb981a780	9d690737-318a-4f7c-a722-b04a86745817	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:16:21
28716	9d690737-2c80-45bc-b6b1-0f9a39d60abc	9d690737-318a-4f7c-a722-b04a86745817	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 13:16:21
28717	9d690737-300e-481d-b4f5-c59086afd069	9d690737-318a-4f7c-a722-b04a86745817	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 13:16:21
28718	9d690737-3057-4863-827a-2fbc934143b1	9d690737-318a-4f7c-a722-b04a86745817	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":362,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:16:21
34416	9d69be35-c1d0-456e-b7c7-597bac5a9e3d	9d69be36-09ed-4a97-86dc-e4382d0ff587	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 21:48:03
34417	9d69be36-04c1-4875-9ac1-60ea22750625	9d69be36-09ed-4a97-86dc-e4382d0ff587	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"151.28","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:48:03
34418	9d69be36-0520-4356-952d-94e614d84534	9d69be36-09ed-4a97-86dc-e4382d0ff587	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:48:03
34419	9d69be36-08b1-4230-b9ec-1b23715ba8b9	9d69be36-09ed-4a97-86dc-e4382d0ff587	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 21:48:03
34420	9d69be36-08f1-4a3c-aae2-36479f6e5670	9d69be36-09ed-4a97-86dc-e4382d0ff587	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":498,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:48:03
34878	9d69c0cf-f67a-462a-b690-76646a75b902	9d69c0cf-f7ed-48b6-93ed-b15a7e9520f5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":564,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:55:19
21663	9d673cb7-8674-41aa-939a-2bff03b691b3	9d673cb7-c8b5-4af3-9218-a91557a63d57	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 15:54:18
21664	9d673cb7-c4c6-4927-ac52-0d8ac9d64797	9d673cb7-c8b5-4af3-9218-a91557a63d57	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"143.23","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 15:54:18
21665	9d673cb7-c79f-4b9e-89fa-e9e28bbfc751	9d673cb7-c8b5-4af3-9218-a91557a63d57	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 15:54:18
21666	9d673cb7-c7df-4183-94db-1099148261d7	9d673cb7-c8b5-4af3-9218-a91557a63d57	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":315,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:54:18
28719	9d690737-a446-464e-a37c-487a3fdb553d	9d690737-d278-4fe0-afbf-a770af622bb8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 13:16:22
28720	9d690737-cb86-4973-83f0-d867d876bf8c	9d690737-d278-4fe0-afbf-a770af622bb8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '89' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"63.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 13:16:22
28721	9d690737-cbfd-4d60-b433-f008a4e9f22a	9d690737-d278-4fe0-afbf-a770af622bb8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 13:16:22
28722	9d690737-cdcd-49f0-bbd7-73f658290c72	9d690737-d278-4fe0-afbf-a770af622bb8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:16:22
28723	9d690737-ce04-4681-8b18-bb80b24fcd9b	9d690737-d278-4fe0-afbf-a770af622bb8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:16:22
28724	9d690737-d137-4ed5-ac58-d35925fbde3f	9d690737-d278-4fe0-afbf-a770af622bb8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 13:16:22
28725	9d690737-d198-4878-a0ce-ad6ee47c2ee3	9d690737-d278-4fe0-afbf-a770af622bb8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"146000","loans_pago_prestado":"584000","loans_intereses_recaudar":"275000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":397,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:16:22
32603	9d696735-9235-41d2-987f-650277c71a14	9d696735-afd8-4aad-8aa2-e09f41be2b5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 17:44:46
32604	9d696735-a84f-4f4d-9324-6383581db1d7	9d696735-afd8-4aad-8aa2-e09f41be2b5c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 91\\n                        ","time":"42.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"9ae30bc69b6b272f3f51ff48e54319f5","hostname":"EderCortes"}	2024-11-04 17:44:46
34879	9d69c0d1-66cc-444a-ba74-eb6d88ad66de	9d69c0d1-9295-40e3-8499-64b56b2f3902	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:55:20
21667	9d673cb8-12e1-4338-89ed-dfd2c503a77d	9d673cb8-55d8-4afc-b274-79f968bdb4a9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 15:54:18
21668	9d673cb8-51bc-4ec4-a240-f7b4f214ff7f	9d673cb8-55d8-4afc-b274-79f968bdb4a9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"144.50","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 15:54:19
21669	9d673cb8-54ad-4a6e-b26d-800eb97ebc47	9d673cb8-55d8-4afc-b274-79f968bdb4a9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 15:54:19
21670	9d673cb8-54f1-4e6a-8f26-618af92254eb	9d673cb8-55d8-4afc-b274-79f968bdb4a9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":341,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:54:19
32605	9d696735-ab36-45ce-9a9b-1b557e740b2d	9d696735-afd8-4aad-8aa2-e09f41be2b5c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '91' order by \\"item_loans\\".\\"id\\" asc","time":"2.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 17:44:46
32606	9d696735-ae42-41f8-b707-cf094554317d	9d696735-afd8-4aad-8aa2-e09f41be2b5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 17:44:46
32607	9d696735-aeac-4683-b775-b892ffb079dc	9d696735-afd8-4aad-8aa2-e09f41be2b5c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/91","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":91,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":8,"loans_valor_prestado":5000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0","user_alias":"eder.cortes"},"items":[{"id":371,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 16:04:19","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":372,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 16:04:19","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":373,"loans_codigo":91,"itemloans_cuota":"3","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 16:04:19","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":374,"loans_codigo":91,"itemloans_cuota":"4","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 16:04:19","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":375,"loans_codigo":91,"itemloans_cuota":"5","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 16:04:19","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":376,"loans_codigo":91,"itemloans_cuota":"6","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 16:04:19","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":377,"loans_codigo":91,"itemloans_cuota":"7","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 16:04:19","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":378,"loans_codigo":91,"itemloans_cuota":"8","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 16:04:19","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":280,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:44:46
34880	9d69c0d1-8c52-4a83-b949-9c84ada10b06	9d69c0d1-9295-40e3-8499-64b56b2f3902	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"54.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:55:20
34881	9d69c0d1-8cb0-4bfc-a582-1cf4fe490e76	9d69c0d1-9295-40e3-8499-64b56b2f3902	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:55:20
34882	9d69c0d1-90d1-46d1-99c4-089e7d362bb0	9d69c0d1-9295-40e3-8499-64b56b2f3902	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 21:55:20
34883	9d69c0d1-9132-4e2f-95fd-66e722cdab37	9d69c0d1-9295-40e3-8499-64b56b2f3902	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":715,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:55:20
19111	9d66d045-8c4d-4e77-a4a9-e63de72aaeab	9d66d045-b8f7-4198-87c1-70c95126d688	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 10:51:04
19112	9d66d045-b5c0-4eed-9003-ba191b5b6b49	9d66d045-b8f7-4198-87c1-70c95126d688	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 10:51:04
19113	9d66d045-b763-4143-9a54-26e7a0fbdc83	9d66d045-b8f7-4198-87c1-70c95126d688	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":313,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:51:04
32608	9d696742-f188-4339-8f6c-38ed2a64d975	9d696742-f49c-4637-bd13-e7a79b74342a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":143,"memory":20,"hostname":"EderCortes"}	2024-11-04 17:44:55
19114	9d66d046-259c-4945-9e42-cf73989752b9	9d66d046-74bb-4999-8272-0c414d1433bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 10:51:04
19115	9d66d046-695f-443f-b779-3a7de3375b1b	9d66d046-74bb-4999-8272-0c414d1433bb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"160.33","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 10:51:05
19116	9d66d046-6ddf-40df-be2a-9c81911f0d10	9d66d046-74bb-4999-8272-0c414d1433bb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 10:51:05
19117	9d66d046-6e15-455a-a42a-b82f4083eeee	9d66d046-74bb-4999-8272-0c414d1433bb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 10:51:05
19118	9d66d046-7370-4598-8dd4-10a367bad21b	9d66d046-74bb-4999-8272-0c414d1433bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 10:51:05
19119	9d66d046-73c0-401a-bf31-cf594c509e04	9d66d046-74bb-4999-8272-0c414d1433bb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T02:27:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"0"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":427,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:51:05
21671	9d673cb8-9b6d-4e82-982a-90143d49162e	9d673cb8-b5cd-42d4-943e-8e76d814adaa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 15:54:19
21672	9d673cb8-b1a6-434f-8be0-b5c1c571bd76	9d673cb8-b5cd-42d4-943e-8e76d814adaa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"41.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-03 15:54:19
21673	9d673cb8-b4a3-4204-9076-fa586d697f71	9d673cb8-b5cd-42d4-943e-8e76d814adaa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 15:54:19
21674	9d673cb8-b4eb-4277-b6c5-dd81b4628b31	9d673cb8-b5cd-42d4-943e-8e76d814adaa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"28","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":224,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:54:19
32609	9d696743-531c-4850-a2c6-b3bb5179cee3	9d696743-7ba7-4271-b2ac-c04e17d4d773	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 17:44:55
32610	9d696743-6b3e-4138-9af5-487c2b99b595	9d696743-7ba7-4271-b2ac-c04e17d4d773	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 91 limit 1","time":"3.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":505,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 17:44:55
32611	9d696743-6b91-4d13-b2d9-de8e5492a3ab	9d696743-7ba7-4271-b2ac-c04e17d4d773	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":2,"hostname":"EderCortes"}	2024-11-04 17:44:55
32612	9d696743-6d99-41f8-812f-03f7d00fed0c	9d696743-7ba7-4271-b2ac-c04e17d4d773	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select count(*) as aggregate from \\"item_loans\\" where \\"loans_codigo\\" = 91 and \\"itemloans_status\\" = 'Pagada'","time":"2.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":563,"hash":"60bd91eaa209a639fc2e8afc20430a4b","hostname":"EderCortes"}	2024-11-04 17:44:55
19120	9d66d048-6bdb-4fb3-b51a-c0d546507c09	9d66d048-9209-4b11-8c54-5bbab7d232a9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 10:51:06
19121	9d66d048-8a08-4024-8059-b140a23b68c0	9d66d048-9209-4b11-8c54-5bbab7d232a9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"52.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 10:51:06
19122	9d66d048-8a86-4b66-9937-2943cdcf4252	9d66d048-9209-4b11-8c54-5bbab7d232a9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 10:51:06
19123	9d66d048-9043-429b-b864-4d4a1ce10556	9d66d048-9209-4b11-8c54-5bbab7d232a9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 10:51:06
19124	9d66d048-90c2-4823-8d75-bb55689af6f4	9d66d048-9209-4b11-8c54-5bbab7d232a9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":325,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:51:06
21675	9d673cb9-c5ae-4c3c-9452-5b065620ad38	9d673cb9-e2cf-440d-bdcc-5df4a3f79748	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 15:54:20
21676	9d673cb9-ddca-40c6-976b-b427292be567	9d673cb9-e2cf-440d-bdcc-5df4a3f79748	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '19' and \\"users\\".\\"deleted_at\\" is null","time":"40.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":55,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-11-03 15:54:20
21677	9d673cb9-de19-48d5-9c4e-5e40355bab7d	9d673cb9-e2cf-440d-bdcc-5df4a3f79748	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 15:54:20
21678	9d673cb9-e1a7-4ec1-a343-d9a8af2fe200	9d673cb9-e2cf-440d-bdcc-5df4a3f79748	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 15:54:20
21679	9d673cb9-e1e9-4a29-967a-3ac9303c8a94	9d673cb9-e2cf-440d-bdcc-5df4a3f79748	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/19","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:54:20
32613	9d696743-6e77-4f51-a20c-a086c7c231a1	9d696743-7ba7-4271-b2ac-c04e17d4d773	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_estado\\" = 'En curso', \\"loans_pago_interes\\" = 200000, \\"loans_pago_prestado\\" = 800000, \\"updated_at\\" = '2024-11-04 17:44:55' where \\"id\\" = 91","time":"0.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":602,"hash":"acfe32aea56c9ca6bdbb917f944a78d1","hostname":"EderCortes"}	2024-11-04 17:44:55
32614	9d696743-6ee6-4ff0-8518-bd0d616ec45f	9d696743-7ba7-4271-b2ac-c04e17d4d773	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:91","changes":{"loans_estado":"En curso","updated_at":"2024-11-04 17:44:55","loans_pago_interes":200000,"loans_pago_prestado":800000},"hostname":"EderCortes"}	2024-11-04 17:44:55
32615	9d696743-6f83-4b31-8e80-2c3f46052351	9d696743-7ba7-4271-b2ac-c04e17d4d773	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 91 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"0.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":609,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 17:44:55
32616	9d696743-6fb7-4dc4-9bfc-d32a29783f0c	9d696743-7ba7-4271-b2ac-c04e17d4d773	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 17:44:55
32617	9d696743-7031-4f7b-b4bd-02de5575e671	9d696743-7ba7-4271-b2ac-c04e17d4d773	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Abono', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = 200000, \\"itemloans_cuota_cancelada\\" = 800000, \\"updated_at\\" = '2024-11-04 17:44:55' where \\"id\\" = 371","time":"0.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":617,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 17:44:55
32618	9d696743-7061-4725-875d-3d3419647efd	9d696743-7ba7-4271-b2ac-c04e17d4d773	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:371","changes":{"itemloans_status":"Abono","updated_at":"2024-11-04 17:44:55","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":200000,"itemloans_cuota_cancelada":800000},"hostname":"EderCortes"}	2024-11-04 17:44:55
32619	9d696743-70be-44b8-81f6-da5fa2afea8a	9d696743-7ba7-4271-b2ac-c04e17d4d773	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"delete from \\"item_loans\\" where \\"loans_codigo\\" = 91 and \\"itemloans_status\\" = 'Pendiente'","time":"0.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":624,"hash":"89bf3c496a8b0746ff5d1219b8dc29e3","hostname":"EderCortes"}	2024-11-04 17:44:55
32620	9d696743-711f-4ea8-841e-04008a71c0d2	9d696743-7ba7-4271-b2ac-c04e17d4d773	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 91 limit 1","time":"0.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":627,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 17:44:56
32621	9d696743-71dd-4fe5-ae5a-b928afb51aeb	9d696743-7ba7-4271-b2ac-c04e17d4d773	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 1, 525000, 131250, 'Pendiente', 'Se realiza abono', '20-11-2024', 0, 0, '2024-11-04 17:44:56', '2024-11-04 17:44:56')","time":"0.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 17:44:56
32622	9d696743-7215-4bbd-8b54-cc92aac3a4c2	9d696743-7ba7-4271-b2ac-c04e17d4d773	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 17:44:56
32623	9d696743-7294-4e86-9a7e-31e9f57b6dbc	9d696743-7ba7-4271-b2ac-c04e17d4d773	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 2, 525000, 131250, 'Pendiente', 'Se realiza abono', '06-12-2024', 0, 0, '2024-11-04 17:44:56', '2024-11-04 17:44:56')","time":"0.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 17:44:56
32624	9d696743-72bd-4ed5-8d65-0d772c11163d	9d696743-7ba7-4271-b2ac-c04e17d4d773	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 17:44:56
32625	9d696743-732c-41b5-88c1-114890acf7d1	9d696743-7ba7-4271-b2ac-c04e17d4d773	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 3, 525000, 131250, 'Pendiente', 'Se realiza abono', '22-12-2024', 0, 0, '2024-11-04 17:44:56', '2024-11-04 17:44:56')","time":"0.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 17:44:56
32626	9d696743-7352-4f4a-b5ad-cb96261031b7	9d696743-7ba7-4271-b2ac-c04e17d4d773	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 17:44:56
32627	9d696743-73bb-49f1-8cf7-e5d015079be6	9d696743-7ba7-4271-b2ac-c04e17d4d773	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 4, 525000, 131250, 'Pendiente', 'Se realiza abono', '07-01-2025', 0, 0, '2024-11-04 17:44:56', '2024-11-04 17:44:56')","time":"0.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 17:44:56
32628	9d696743-73e1-4da8-95ca-ce7d867f801e	9d696743-7ba7-4271-b2ac-c04e17d4d773	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 17:44:56
32629	9d696743-7465-40d0-bb02-8bf1a53ec0aa	9d696743-7ba7-4271-b2ac-c04e17d4d773	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 5, 525000, 131250, 'Pendiente', 'Se realiza abono', '23-01-2025', 0, 0, '2024-11-04 17:44:56', '2024-11-04 17:44:56')","time":"0.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 17:44:56
32630	9d696743-7497-4db3-b30f-45402522c446	9d696743-7ba7-4271-b2ac-c04e17d4d773	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 17:44:56
32631	9d696743-750d-4c0f-8156-d6db3a6fc76f	9d696743-7ba7-4271-b2ac-c04e17d4d773	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 6, 525000, 131250, 'Pendiente', 'Se realiza abono', '08-02-2025', 0, 0, '2024-11-04 17:44:56', '2024-11-04 17:44:56')","time":"0.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 17:44:56
32632	9d696743-7533-4d25-99cc-8098420c4b17	9d696743-7ba7-4271-b2ac-c04e17d4d773	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 17:44:56
32633	9d696743-7599-4a3f-8b16-9eb225e939bb	9d696743-7ba7-4271-b2ac-c04e17d4d773	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 7, 525000, 131250, 'Pendiente', 'Se realiza abono', '24-02-2025', 0, 0, '2024-11-04 17:44:56', '2024-11-04 17:44:56')","time":"0.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 17:44:56
32634	9d696743-75be-4a5e-9389-a447af1fa36a	9d696743-7ba7-4271-b2ac-c04e17d4d773	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 17:44:56
22156	9d674277-5cd9-400e-b45a-932189bc3ebe	9d674277-7b76-43d2-a6f9-2bb4d04289e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-03 16:10:23
22157	9d674277-79cf-4aad-a990-c3f0252c74e4	9d674277-7b76-43d2-a6f9-2bb4d04289e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-03 16:10:23
22158	9d674277-7a82-4371-ac40-c790c16a86bb	9d674277-7b76-43d2-a6f9-2bb4d04289e4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":284,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:10:23
32635	9d696743-7622-47be-bb8f-a9b9f09d6b02	9d696743-7ba7-4271-b2ac-c04e17d4d773	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 8, 525000, 131250, 'Pendiente', 'Se realiza abono', '12-03-2025', 0, 0, '2024-11-04 17:44:56', '2024-11-04 17:44:56')","time":"0.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":677,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 17:44:56
32636	9d696743-7647-48ee-bceb-3a4462713de3	9d696743-7ba7-4271-b2ac-c04e17d4d773	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 17:44:56
32637	9d696743-7a4a-4db8-8d30-0efda67338ea	9d696743-7ba7-4271-b2ac-c04e17d4d773	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 17:44:56
22159	9d674277-c74e-4e4d-81ab-c53526041096	9d674278-10ab-46bf-9aa7-5e02c2614ef4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-03 16:10:23
22160	9d674278-0ae2-4b05-9572-34ce6d78843e	9d674278-10ab-46bf-9aa7-5e02c2614ef4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"150.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 16:10:23
22161	9d674278-0b51-4e36-b35c-83148c06d7f3	9d674278-10ab-46bf-9aa7-5e02c2614ef4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 16:10:23
22162	9d674278-0f6d-48db-951e-c27e6d608f02	9d674278-10ab-46bf-9aa7-5e02c2614ef4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-03 16:10:23
22163	9d674278-0fbb-4556-8286-e07ca298bd69	9d674278-10ab-46bf-9aa7-5e02c2614ef4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":334,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:10:23
32638	9d696743-7aa0-435e-89c7-1341b364f990	9d696743-7ba7-4271-b2ac-c04e17d4d773	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"62","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"1000000","idLoans":91,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El abono fue aplicado exitosamente","status":true},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:44:56
22164	9d674278-52e4-4073-8f94-782da0bc0386	9d674278-95d2-4ccc-9f39-a5e53b9cf90b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-03 16:10:23
22165	9d674278-9102-4428-b46c-4d605b3153a9	9d674278-95d2-4ccc-9f39-a5e53b9cf90b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"138.64","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 16:10:23
22166	9d674278-9152-4620-b769-658c948a3370	9d674278-95d2-4ccc-9f39-a5e53b9cf90b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-03 16:10:23
22167	9d674278-94aa-455d-b76b-a7400ba8b225	9d674278-95d2-4ccc-9f39-a5e53b9cf90b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-03 16:10:23
22168	9d674278-94f3-4c11-abd3-d353483b169d	9d674278-95d2-4ccc-9f39-a5e53b9cf90b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":322,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:10:23
32639	9d696743-c47d-4293-9ca3-a0fcd76e665e	9d696744-0f86-41d7-952e-6e8a3b7fbeee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 17:44:56
32640	9d696744-0838-4f83-9589-4526aa5c1a47	9d696744-0f86-41d7-952e-6e8a3b7fbeee	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 91\\n                        ","time":"156.23","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"9ae30bc69b6b272f3f51ff48e54319f5","hostname":"EderCortes"}	2024-11-04 17:44:56
32641	9d696744-0b16-4a22-a4a6-c827624e7ad8	9d696744-0f86-41d7-952e-6e8a3b7fbeee	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '91' order by \\"item_loans\\".\\"id\\" asc","time":"2.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 17:44:56
32642	9d696744-0e35-41e6-a316-22cdfe8b71f2	9d696744-0f86-41d7-952e-6e8a3b7fbeee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 17:44:56
32643	9d696744-0e8f-4dfb-84d3-b8fcfc6c360c	9d696744-0f86-41d7-952e-6e8a3b7fbeee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/91","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":91,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":8,"loans_valor_prestado":5000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"800000","loans_pago_interes":"200000","user_alias":"eder.cortes"},"items":[{"id":371,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 17:44:55","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"200000","itemloans_cuota_cancelada":"800000","user_alias":"eder.cortes"},{"id":403,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":404,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":405,"loans_codigo":91,"itemloans_cuota":"3","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":406,"loans_codigo":91,"itemloans_cuota":"4","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":407,"loans_codigo":91,"itemloans_cuota":"5","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":408,"loans_codigo":91,"itemloans_cuota":"6","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":409,"loans_codigo":91,"itemloans_cuota":"7","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":410,"loans_codigo":91,"itemloans_cuota":"8","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-03-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":355,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:44:56
24792	9d68bd47-225c-440b-bc0d-b7817c0e1bbe	9d68bd47-5faa-464f-8065-1199fc41cb01	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 09:49:37
24793	9d68bd47-5c2c-4ff7-876d-70b7f44a1ed5	9d68bd47-5faa-464f-8065-1199fc41cb01	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 09:49:37
24794	9d68bd47-5d86-4828-9de9-e284adab003b	9d68bd47-5faa-464f-8065-1199fc41cb01	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":657,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:49:37
10139	9d56c9b8-e028-4c6f-b074-feee62a32955	9d56c9b8-e3bf-42ee-b789-0bac36c7be84	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":493}	2024-10-26 11:39:30
27323	9d68e41c-214a-4bd2-8c08-6a0e9e9fe3d1	9d68e41c-27d3-4a42-afe2-e9ffd40ff989	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1274}	2024-11-04 11:38:12
24795	9d68bd48-1bce-4505-b4d6-ebe0f097519c	9d68bd48-4c19-488a-8f91-cca5584e3e1e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 09:49:37
24796	9d68bd48-3f76-41f1-89fc-792a13a7abb3	9d68bd48-4c19-488a-8f91-cca5584e3e1e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"66.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 09:49:37
24797	9d68bd48-4411-47c9-9d07-92b2b7a9d4c6	9d68bd48-4c19-488a-8f91-cca5584e3e1e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:49:37
24798	9d68bd48-4458-4baf-8be5-c0f4e9d18bac	9d68bd48-4c19-488a-8f91-cca5584e3e1e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 09:49:37
24799	9d68bd48-4a18-4a62-8921-289b5df381d7	9d68bd48-4c19-488a-8f91-cca5584e3e1e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 09:49:37
24800	9d68bd48-4aae-49cd-a164-620e278a0122	9d68bd48-4c19-488a-8f91-cca5584e3e1e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":527,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:49:37
24801	9d68bd49-ae93-4cc3-824a-51321188b32f	9d68bd49-f9b8-42c3-b226-e80c326692fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 09:49:38
24802	9d68bd49-eb9c-4144-940c-6868c203e657	9d68bd49-f9b8-42c3-b226-e80c326692fb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"83.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:49:38
24803	9d68bd49-ec3a-45c5-b1c2-6e001741f515	9d68bd49-f9b8-42c3-b226-e80c326692fb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:49:38
24804	9d68bd49-f6d5-415f-b275-c1009230e7e6	9d68bd49-f9b8-42c3-b226-e80c326692fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 09:49:39
24805	9d68bd49-f797-4ca6-b811-17c6d9c25a12	9d68bd49-f9b8-42c3-b226-e80c326692fb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1069,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:49:39
24806	9d68bd4a-e49b-44c0-8e59-f2f5990b1155	9d68bd4b-079c-4c6b-b4cc-b22ee10b138d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 09:49:39
24807	9d68bd4b-01ef-4f14-840c-a9f763e39a9d	9d68bd4b-079c-4c6b-b4cc-b22ee10b138d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"47.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:49:39
24808	9d68bd4b-0241-4163-a319-6bec8a661a5d	9d68bd4b-079c-4c6b-b4cc-b22ee10b138d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:49:39
24809	9d68bd4b-0623-4d58-9614-e8fd737a86a4	9d68bd4b-079c-4c6b-b4cc-b22ee10b138d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 09:49:39
24810	9d68bd4b-0668-41e5-bc46-672bd0c02347	9d68bd4b-079c-4c6b-b4cc-b22ee10b138d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":661,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:49:39
35089	9d69c225-9336-47fc-8506-ce8039d2871d	9d69c225-b0b4-43ea-8276-7ca96c345d8e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:59:03
35090	9d69c225-af05-4f4b-af1c-78a8830df11a	9d69c225-b0b4-43ea-8276-7ca96c345d8e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:59:03
35091	9d69c225-afbc-4ef6-8958-a1774d49da93	9d69c225-b0b4-43ea-8276-7ca96c345d8e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:59:03
28829	9d690a2e-c4bb-4002-b665-a1de14487682	9d690a2e-f995-477b-86ed-891235ce9f74	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 13:24:39
28830	9d690a2e-f61b-4cad-adb9-fb80d6820de8	9d690a2e-f995-477b-86ed-891235ce9f74	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 13:24:39
28831	9d690a2e-f7dd-4258-b1bb-1f653c0e7e94	9d690a2e-f995-477b-86ed-891235ce9f74	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":589,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:24:39
28832	9d690a2f-a4b9-4e4b-8aa8-623538aee6f7	9d690a2f-ee64-458a-80fc-c27ca37655a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 13:24:40
28833	9d690a2f-e229-4e4b-bad7-1b3e12ea3882	9d690a2f-ee64-458a-80fc-c27ca37655a4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"97.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:24:40
28834	9d690a2f-e2d1-4264-b4eb-70312bed12fd	9d690a2f-ee64-458a-80fc-c27ca37655a4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 13:24:40
28835	9d690a2f-ec39-4cf3-8ce4-6885825cd4de	9d690a2f-ee64-458a-80fc-c27ca37655a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 13:24:40
28836	9d690a2f-eccc-4351-a54d-3476bff7dfcb	9d690a2f-ee64-458a-80fc-c27ca37655a4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":null}]},"duration":546,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:24:40
35092	9d69c226-01f2-4e4e-ab07-693e98987b07	9d69c226-1e06-4cd7-bfbf-b9548b422727	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:59:03
35093	9d69c226-19b7-4b5d-9e7b-aab192d2082f	9d69c226-1e06-4cd7-bfbf-b9548b422727	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"43.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 21:59:04
35094	9d69c226-1cbb-4746-8ca5-b02ada46cf9e	9d69c226-1e06-4cd7-bfbf-b9548b422727	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:59:04
35095	9d69c226-1d25-4ac7-981f-8d50313e2ea8	9d69c226-1e06-4cd7-bfbf-b9548b422727	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:59:04
28837	9d690a30-6ba8-44c2-b153-0ea29e07ae01	9d690a30-95da-4024-b1a1-cb243f31e202	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 13:24:40
28838	9d690a30-8ed6-4733-8607-27ada66b5af7	9d690a30-95da-4024-b1a1-cb243f31e202	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"54.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:24:40
28839	9d690a30-8f48-4d5f-8bfa-f7d3855845a6	9d690a30-95da-4024-b1a1-cb243f31e202	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 13:24:40
28840	9d690a30-944e-4552-820b-f0fefe495d07	9d690a30-95da-4024-b1a1-cb243f31e202	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 13:24:40
28841	9d690a30-94ca-4df2-a84f-36b6aadbe88e	9d690a30-95da-4024-b1a1-cb243f31e202	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":null}]},"duration":401,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:24:40
32753	9d6989a8-a0cf-48ab-b428-2d1b672a0b4a	9d6989aa-1043-48bf-8edb-5dc4497459e9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 19:21:06
32754	9d6989aa-0d0c-4910-8148-6dcad5624ebb	9d6989aa-1043-48bf-8edb-5dc4497459e9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 19:21:07
32755	9d6989aa-0e2a-465b-89d0-40e389169796	9d6989aa-1043-48bf-8edb-5dc4497459e9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1521,"memory":22,"hostname":"EderCortes"}	2024-11-04 19:21:07
24910	9d68bde9-d885-4b06-8dc5-85cbe4d56d92	9d68bdea-633e-403e-aed5-e638e1190ee6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 09:51:23
24911	9d68bdea-6037-4406-a6e4-6f805090b844	9d68bdea-633e-403e-aed5-e638e1190ee6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 09:51:24
24912	9d68bdea-61a9-4dc5-818f-64b8c7521af8	9d68bdea-633e-403e-aed5-e638e1190ee6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":981,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:51:24
24913	9d68bdeb-3dcb-4f85-9bbc-9da53409c21b	9d68bdeb-6478-43b5-a4c2-56f1b71b8621	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 09:51:24
24914	9d68bdeb-5ae7-4b0e-98b4-efff6777789c	9d68bdeb-6478-43b5-a4c2-56f1b71b8621	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"57.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 09:51:24
24915	9d68bdeb-5f02-4638-9662-d1df87e3f5ee	9d68bdeb-6478-43b5-a4c2-56f1b71b8621	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"3.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:51:24
24916	9d68bdeb-5f3e-451d-83bc-9d2f86318350	9d68bdeb-6478-43b5-a4c2-56f1b71b8621	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 09:51:24
24917	9d68bdeb-6316-4a7b-8060-3510b2d2df85	9d68bdeb-6478-43b5-a4c2-56f1b71b8621	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 09:51:24
24918	9d68bdeb-6369-471c-b75a-78e35efbed12	9d68bdeb-6478-43b5-a4c2-56f1b71b8621	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":561,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:51:24
28842	9d690a30-ef1c-4624-895f-cd949455bdd8	9d690a31-14a7-4446-9e78-4163bb54d3e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 13:24:41
28843	9d690a31-0b93-4426-9f67-669e4f8537a8	9d690a31-14a7-4446-9e78-4163bb54d3e1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '89' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"50.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 13:24:41
28844	9d690a31-0bf9-4664-a2f3-5b551774898c	9d690a31-14a7-4446-9e78-4163bb54d3e1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 13:24:41
28845	9d690a31-0e1f-4482-9702-e5d43cc1b286	9d690a31-14a7-4446-9e78-4163bb54d3e1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:24:41
28846	9d690a31-0e65-4354-b297-7bd82b1d38ef	9d690a31-14a7-4446-9e78-4163bb54d3e1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:24:41
28847	9d690a31-130a-43f8-8152-6fac06065a88	9d690a31-14a7-4446-9e78-4163bb54d3e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 13:24:41
28848	9d690a31-1381-4092-8b1d-2818c093f03b	9d690a31-14a7-4446-9e78-4163bb54d3e1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"146000","loans_pago_prestado":"584000","loans_intereses_recaudar":"275000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":302,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:24:41
32756	9d6989ab-b429-48e7-9693-23c5d6936b65	9d6989ac-02bd-4032-80b0-bb8509bc447c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 19:21:08
32757	9d6989ab-fba9-4035-8196-f289c6d6c638	9d6989ac-02bd-4032-80b0-bb8509bc447c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"150.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":227,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 19:21:08
32758	9d6989ab-fc1c-4c13-add0-378674bd836a	9d6989ac-02bd-4032-80b0-bb8509bc447c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 19:21:08
22054	9d674181-fa96-4f1e-adeb-caef2d4af0e1	9d674182-4120-45a3-8bbb-af72c7f1f0a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-03 16:07:42
22055	9d674182-3f9f-4e62-bf2c-7899bd3e1b84	9d674182-4120-45a3-8bbb-af72c7f1f0a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-03 16:07:42
22056	9d674182-4036-4f16-9dae-753cde62e1e6	9d674182-4120-45a3-8bbb-af72c7f1f0a5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:07:42
22057	9d674182-8fb3-419c-a855-b346dd730865	9d674182-ad3d-49c8-b564-6020399e2081	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-03 16:07:42
22058	9d674182-a82b-4308-bef8-e95ffa2de82d	9d674182-ad3d-49c8-b564-6020399e2081	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 16:07:42
22059	9d674182-a886-4a14-855a-02f3225ca503	9d674182-ad3d-49c8-b564-6020399e2081	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 16:07:42
22060	9d674182-ac18-46f3-971a-cf0e248406b7	9d674182-ad3d-49c8-b564-6020399e2081	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-03 16:07:42
22061	9d674182-ac61-4bf3-9306-8189326953da	9d674182-ad3d-49c8-b564-6020399e2081	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:07:42
24919	9d68bdec-20df-47c3-b99f-12234bfa05ce	9d68bdec-6204-49a3-93a7-5be2746ffb41	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 09:51:25
24920	9d68bdec-56f2-4545-8022-5191a192aa41	9d68bdec-6204-49a3-93a7-5be2746ffb41	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"77.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:51:25
24921	9d68bdec-577c-40be-b2aa-f786e69dffc5	9d68bdec-6204-49a3-93a7-5be2746ffb41	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:51:25
24922	9d68bdec-5fd3-4e82-8e1d-44a4f9660d11	9d68bdec-6204-49a3-93a7-5be2746ffb41	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 09:51:25
24923	9d68bdec-607e-4ec5-92f8-1499a43044cd	9d68bdec-6204-49a3-93a7-5be2746ffb41	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":633,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:51:25
32759	9d6989ac-015d-4db2-92b1-618b618ca61a	9d6989ac-02bd-4032-80b0-bb8509bc447c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 19:21:08
25148	9d68bfed-2c10-4362-85b1-706bdc40ee00	9d68bfed-4a1a-4e43-acba-bd0829eb13a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 09:57:01
25149	9d68bfed-4865-4680-871b-e57e7a9d5e99	9d68bfed-4a1a-4e43-acba-bd0829eb13a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 09:57:01
25150	9d68bfed-490c-4d85-9b46-6032a28c9575	9d68bfed-4a1a-4e43-acba-bd0829eb13a5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":352,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:57:01
32760	9d6989ac-01b2-4b9b-9075-75399fd6afd7	9d6989ac-02bd-4032-80b0-bb8509bc447c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":497,"memory":22,"hostname":"EderCortes"}	2024-11-04 19:21:08
22062	9d674182-ed04-4068-84f8-1a57bd3a5622	9d674183-30af-4c42-826a-4d60a8e34bf2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-03 16:07:42
22063	9d674183-2bd7-49fb-a969-75d3100b6677	9d674183-30af-4c42-826a-4d60a8e34bf2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"139.79","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 16:07:43
22064	9d674183-2c2c-4adc-960e-11c09d1bbc11	9d674183-30af-4c42-826a-4d60a8e34bf2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-03 16:07:43
22065	9d674183-2f8f-41eb-81bf-b105ac4917f8	9d674183-30af-4c42-826a-4d60a8e34bf2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-03 16:07:43
22066	9d674183-2fd8-4f06-a92d-4b0fa3740ee6	9d674183-30af-4c42-826a-4d60a8e34bf2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:07:43
24924	9d68bdec-f773-4252-913a-bea92ed33c6e	9d68bded-4999-4987-b3ff-4f10dc0795cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 09:51:25
24925	9d68bded-422c-4f27-bb78-427e31b0a62d	9d68bded-4999-4987-b3ff-4f10dc0795cd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"165.84","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:51:26
24926	9d68bded-42b8-40df-854e-96de8a7d852e	9d68bded-4999-4987-b3ff-4f10dc0795cd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:51:26
24927	9d68bded-4836-4963-9b13-66c1108969b0	9d68bded-4999-4987-b3ff-4f10dc0795cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 09:51:26
24928	9d68bded-488e-4aca-87be-fe7e472a3131	9d68bded-4999-4987-b3ff-4f10dc0795cd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":572,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:51:26
25151	9d68bfed-c73c-48cb-8229-3717a9b4a29d	9d68bfed-e6d2-4e5c-9a48-46cee257ee93	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 09:57:01
25152	9d68bfed-dcf5-4955-8813-dd6981bf8fe7	9d68bfed-e6d2-4e5c-9a48-46cee257ee93	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"42.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 09:57:01
25153	9d68bfed-e19f-4e5d-ae31-8c7dff358a84	9d68bfed-e6d2-4e5c-9a48-46cee257ee93	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:57:01
32761	9d6989ac-5fbf-479d-80cf-6488311880ea	9d6989ac-81d7-4fcb-b6a6-6fc12a3072a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 19:21:09
32762	9d6989ac-7b4f-427e-ace9-0de3868bd641	9d6989ac-81d7-4fcb-b6a6-6fc12a3072a7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":216,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 19:21:09
24929	9d68be47-596e-4d1f-9725-4893e40591b2	9d68be47-833e-40b1-b211-4e1c31646649	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 09:52:25
20422	9d66f2ed-d8b6-4fdc-98ac-fd3c44fbca23	9d66f2ee-03ce-4ac2-bd66-0783c824db45	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 12:27:58
20423	9d66f2ee-0150-454b-9102-43bf4f26ad04	9d66f2ee-03ce-4ac2-bd66-0783c824db45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:27:59
20424	9d66f2ee-0276-4420-afc4-948ee8ab10bf	9d66f2ee-03ce-4ac2-bd66-0783c824db45	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":346,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:27:59
24930	9d68be47-7ada-4364-8c66-20a1682ed73c	9d68be47-833e-40b1-b211-4e1c31646649	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"50.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 09:52:25
32763	9d6989ac-7ba9-4d23-806e-cdd8a56af37f	9d6989ac-81d7-4fcb-b6a6-6fc12a3072a7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 19:21:09
24931	9d68be47-80e3-48de-b7b7-e8cd052c5483	9d68be47-833e-40b1-b211-4e1c31646649	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 09:52:25
24932	9d68be47-81a9-46e7-94be-170ab78fdbe7	9d68be47-833e-40b1-b211-4e1c31646649	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":435,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:52:25
25154	9d68bfed-e1d5-47b5-ba27-144d979dec44	9d68bfed-e6d2-4e5c-9a48-46cee257ee93	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 09:57:01
25155	9d68bfed-e5bb-4fde-a0a0-27676148ce16	9d68bfed-e6d2-4e5c-9a48-46cee257ee93	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 09:57:01
32764	9d6989ac-803d-4d0f-ba48-f48f99c3af8c	9d6989ac-81d7-4fcb-b6a6-6fc12a3072a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 19:21:09
32765	9d6989ac-80b7-4466-a0a9-b851880feef4	9d6989ac-81d7-4fcb-b6a6-6fc12a3072a7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":291,"memory":22,"hostname":"EderCortes"}	2024-11-04 19:21:09
20425	9d66f2ee-7d25-4d34-bcca-8bfd29910a1d	9d66f2ee-a07f-452c-98ae-8b5f51f1c6aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:27:59
20426	9d66f2ee-961d-497b-8334-2a1e379c1982	9d66f2ee-a07f-452c-98ae-8b5f51f1c6aa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"48.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:27:59
20427	9d66f2ee-9a07-4295-b19c-93665a934589	9d66f2ee-a07f-452c-98ae-8b5f51f1c6aa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:27:59
20428	9d66f2ee-9a43-451c-9bbd-a6b2ac2d556a	9d66f2ee-a07f-452c-98ae-8b5f51f1c6aa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:27:59
20429	9d66f2ee-9f43-490b-a996-227346f15ea4	9d66f2ee-a07f-452c-98ae-8b5f51f1c6aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:27:59
20430	9d66f2ee-9f8e-4a5e-9f42-fecf325312ae	9d66f2ee-a07f-452c-98ae-8b5f51f1c6aa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:27:59
24933	9d68be7a-dde8-4729-b421-7cbbd216d5c3	9d68be7b-01b2-4f2d-a9c8-3b6675128617	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 09:52:58
24934	9d68be7a-f72a-4b19-8b58-0a35e42bc0d9	9d68be7b-01b2-4f2d-a9c8-3b6675128617	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"52.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 09:52:58
24935	9d68be7a-fb64-44a7-8ff5-998f8c50cba5	9d68be7b-01b2-4f2d-a9c8-3b6675128617	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:52:58
24936	9d68be7a-fb98-460c-9ead-a03e93b5ca2c	9d68be7b-01b2-4f2d-a9c8-3b6675128617	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 09:52:58
24937	9d68be7b-0024-4b94-a42b-c2566735b8af	9d68be7b-01b2-4f2d-a9c8-3b6675128617	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 09:52:58
32766	9d6989ac-f90e-4c9e-a94f-9dc3732c91d1	9d6989ad-474d-4532-aa78-bbaae060bce4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 19:21:09
32767	9d6989ad-40db-404e-a3c4-27b56cfebfcf	9d6989ad-474d-4532-aa78-bbaae060bce4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"149.36","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 19:21:09
32768	9d6989ad-4163-4dea-8c05-68873c0ac269	9d6989ad-474d-4532-aa78-bbaae060bce4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 19:21:09
20431	9d66f2f0-f075-498e-9d69-67a2f82fa0ee	9d66f2f1-4289-4950-ac05-f71ca9d23f3b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:28:01
20432	9d66f2f1-3ac6-4e86-baf5-7a34a807febb	9d66f2f1-4289-4950-ac05-f71ca9d23f3b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"164.41","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:28:01
20433	9d66f2f1-3b47-491a-a298-e9c043fcf9aa	9d66f2f1-4289-4950-ac05-f71ca9d23f3b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:28:01
20434	9d66f2f1-40f3-4401-9318-9b7749ddadbd	9d66f2f1-4289-4950-ac05-f71ca9d23f3b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:28:01
20435	9d66f2f1-414b-460b-b154-ccb6e19a8047	9d66f2f1-4289-4950-ac05-f71ca9d23f3b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":519,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:28:01
24938	9d68be7b-0086-48bb-b0d4-d9e1a48859e0	9d68be7b-01b2-4f2d-a9c8-3b6675128617	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":352,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":353,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":354,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":355,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":467,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:52:58
25156	9d68bfed-e607-4260-bac6-168d0f6c1cbd	9d68bfed-e6d2-4e5c-9a48-46cee257ee93	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":352,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":353,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":354,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":355,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:57:01
32769	9d6989ad-45cb-4165-8c65-7dec9c3a78e7	9d6989ad-474d-4532-aa78-bbaae060bce4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 19:21:09
32770	9d6989ad-462f-4f56-bc4d-246537107eb1	9d6989ad-474d-4532-aa78-bbaae060bce4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":398,"memory":22,"hostname":"EderCortes"}	2024-11-04 19:21:09
28946	9d690dc1-b9ed-47dd-af97-ba02c1b27288	9d690dc1-e6ce-425f-bfc5-e70d76501421	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 13:34:39
28947	9d690dc1-e3a1-4b12-bf68-b442b3562648	9d690dc1-e6ce-425f-bfc5-e70d76501421	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 13:34:39
28948	9d690dc1-e54e-4928-ae12-532ec013e16b	9d690dc1-e6ce-425f-bfc5-e70d76501421	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":424,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:34:39
24645	9d68b777-444f-4689-8f8d-9b308f820168	9d68b777-61df-4d5c-b98d-4284dc06d00e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 09:33:22
24646	9d68b777-6083-46c6-b204-2f28a6a80bb6	9d68b777-61df-4d5c-b98d-4284dc06d00e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 09:33:22
24647	9d68b777-610e-42fe-a380-8b56e58e07b0	9d68b777-61df-4d5c-b98d-4284dc06d00e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:33:22
32771	9d6989ad-cd39-48c8-80f3-fd028d04eaa7	9d6989ae-0f46-4844-a8f1-cbbcab877086	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 19:21:09
32772	9d6989ae-0463-4ad0-b5a7-e4d95c32e2f4	9d6989ae-0f46-4844-a8f1-cbbcab877086	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"95.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 19:21:10
32773	9d6989ae-054e-44fa-8b59-5592257e9ec0	9d6989ae-0f46-4844-a8f1-cbbcab877086	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 19:21:10
32774	9d6989ae-0d34-4c46-9485-f7c7f0d1dbf6	9d6989ae-0f46-4844-a8f1-cbbcab877086	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 19:21:10
24648	9d68b777-b30a-4139-8038-23c7a8c26371	9d68b777-d258-4658-a220-08ced0ef57d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 09:33:22
24649	9d68b777-c920-4520-835d-763db0c62ca8	9d68b777-d258-4658-a220-08ced0ef57d1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"44.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 09:33:22
24650	9d68b777-cd1c-425c-9e7a-24f41969c1e2	9d68b777-d258-4658-a220-08ced0ef57d1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"1.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:33:22
24651	9d68b777-cd52-4cd3-85ee-e0455b6dac7b	9d68b777-d258-4658-a220-08ced0ef57d1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 09:33:22
24652	9d68b777-d11f-4bcd-bace-e5692a152e6e	9d68b777-d258-4658-a220-08ced0ef57d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 09:33:22
24653	9d68b777-d187-4dd2-a200-05b85178ee1a	9d68b777-d258-4658-a220-08ced0ef57d1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"400000","loans_pago_interes":"100000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:33:22
28949	9d690dc2-a26d-4d64-aab8-c30453618d43	9d690dc2-da01-48dc-a067-b1f86bd1ab14	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 13:34:39
28950	9d690dc2-cf99-4dfb-b881-13f7abf06e9a	9d690dc2-da01-48dc-a067-b1f86bd1ab14	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"69.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:34:39
28951	9d690dc2-d023-4473-98cd-dacc0131136d	9d690dc2-da01-48dc-a067-b1f86bd1ab14	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 13:34:39
28952	9d690dc2-d7d9-4eac-a10e-d5df982b534b	9d690dc2-da01-48dc-a067-b1f86bd1ab14	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 13:34:39
28953	9d690dc2-d872-4a8f-9462-49f7b5626453	9d690dc2-da01-48dc-a067-b1f86bd1ab14	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":535,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:34:40
32775	9d6989ae-0dbd-4017-b7a6-83e6a81be4bc	9d6989ae-0f46-4844-a8f1-cbbcab877086	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":469,"memory":22,"hostname":"EderCortes"}	2024-11-04 19:21:10
20704	9d66fba0-ba10-4382-983f-874faa53d1b1	9d66fba1-0b49-4938-99b5-4650c26c1797	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 12:52:18
20705	9d66fba1-0918-4c4d-abfb-f8cd0f6879ca	9d66fba1-0b49-4938-99b5-4650c26c1797	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:52:18
20706	9d66fba1-0a0b-4b0b-bf83-baf7d8172570	9d66fba1-0b49-4938-99b5-4650c26c1797	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":520,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:52:18
22647	9d67f740-f762-44a9-9029-a0c4d56e592a	9d67f740-fcb7-4103-82c4-3cc4756e2d13	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1088}	2024-11-04 00:35:54
32781	9d6992e4-fe89-4205-995b-3637d80c4e9a	9d6992e5-06c5-4ca1-81f5-f99d89060b0a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1543}	2024-11-04 19:46:56
20707	9d66fba1-9154-4ce8-9145-f49528d9bb15	9d66fba1-b5c6-4afc-8f70-5dcffdb3d0a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:52:18
20708	9d66fba1-a90f-44fa-9a44-6f127e2ca8fe	9d66fba1-b5c6-4afc-8f70-5dcffdb3d0a1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"46.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:52:19
20709	9d66fba1-ae86-4cf9-9885-7d603717f496	9d66fba1-b5c6-4afc-8f70-5dcffdb3d0a1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"3.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:52:19
20710	9d66fba1-aed2-48b4-8ec5-4ebe80f1c047	9d66fba1-b5c6-4afc-8f70-5dcffdb3d0a1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:52:19
19306	9d66d3cc-876c-4876-8305-17c6312b5fee	9d66d3cc-b642-4035-9bba-62d784972414	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 11:00:56
19307	9d66d3cc-b3ad-43bc-ab21-fd2a2976be65	9d66d3cc-b642-4035-9bba-62d784972414	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:00:56
19308	9d66d3cc-b4b1-4525-88b8-daaed7cd554d	9d66d3cc-b642-4035-9bba-62d784972414	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":331,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:00:56
20711	9d66fba1-b42e-46f4-a2a7-dc631503b940	9d66fba1-b5c6-4afc-8f70-5dcffdb3d0a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:52:19
20712	9d66fba1-b497-44b2-857a-a8d8f7e0acd5	9d66fba1-b5c6-4afc-8f70-5dcffdb3d0a1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"400000","loans_pago_interes":"200000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:40:42.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"}]}},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:52:19
24654	9d68b779-a339-4887-bf3e-2e3fe981766e	9d68b779-fcd7-4afa-a961-118d5a0c923a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 09:33:23
24655	9d68b779-f491-4836-9516-8105abe9916b	9d68b779-fcd7-4afa-a961-118d5a0c923a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"166.93","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:33:23
24656	9d68b779-f50a-45fe-82ce-622d95cfe9c9	9d68b779-fcd7-4afa-a961-118d5a0c923a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:33:23
24657	9d68b779-faca-49fa-8916-e6b5e8bd8b15	9d68b779-fcd7-4afa-a961-118d5a0c923a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 09:33:23
24658	9d68b779-fb4f-492a-9712-ebad0f7e3a52	9d68b779-fcd7-4afa-a961-118d5a0c923a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":594,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:33:23
28954	9d690dc3-415c-4c2c-b6ff-c0fb036d554c	9d690dc3-90d9-4c3d-a987-01069771f0df	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 13:34:40
28955	9d690dc3-8a2c-4d6a-af42-bb13326a1c27	9d690dc3-90d9-4c3d-a987-01069771f0df	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"150.15","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:34:40
19309	9d66d3cd-22c8-425b-b23b-1d9ad4d72d69	9d66d3cd-79e4-4622-ba59-5d99190adda7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:00:56
19310	9d66d3cd-6bcd-42a5-98b9-d31bedfaacca	9d66d3cd-79e4-4622-ba59-5d99190adda7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"170.95","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 11:00:56
19311	9d66d3cd-709a-4d01-95b3-c42a135ebf77	9d66d3cd-79e4-4622-ba59-5d99190adda7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:00:56
19312	9d66d3cd-70e4-4607-9f25-8f19eebf973f	9d66d3cd-79e4-4622-ba59-5d99190adda7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:00:56
19313	9d66d3cd-77e7-41b3-97dd-1d595b459818	9d66d3cd-79e4-4622-ba59-5d99190adda7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:00:56
19314	9d66d3cd-785a-42c3-8fc5-3155628f1e43	9d66d3cd-79e4-4622-ba59-5d99190adda7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T02:27:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"0"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":448,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:00:56
20713	9d66fba3-f936-4e27-85c7-2a998e9a1e90	9d66fba4-43e2-4b1d-8bf2-a4fb16ae21b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:52:20
20714	9d66fba4-3eec-4955-ad54-d25b117f26c5	9d66fba4-43e2-4b1d-8bf2-a4fb16ae21b5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"149.49","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:52:20
20715	9d66fba4-3f36-46cb-916b-0008c5b04809	9d66fba4-43e2-4b1d-8bf2-a4fb16ae21b5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:52:20
20716	9d66fba4-4298-49d8-acc2-637c61471292	9d66fba4-43e2-4b1d-8bf2-a4fb16ae21b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:52:20
20717	9d66fba4-42dc-4bf7-956a-03335e2aba04	9d66fba4-43e2-4b1d-8bf2-a4fb16ae21b5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":446,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:52:20
24659	9d68b799-f8e6-4b0d-bd6f-617ecd83992f	9d68b799-fbe8-46db-8ccd-1ac84fa42a5d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-total-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":138,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:33:44
28956	9d690dc3-8a96-43d6-8066-aa20d4d288ab	9d690dc3-90d9-4c3d-a987-01069771f0df	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 13:34:40
28957	9d690dc3-8f57-48e1-96e1-023f62066bed	9d690dc3-90d9-4c3d-a987-01069771f0df	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 13:34:40
19315	9d66d3cf-51c6-48b5-9174-ec82d2b4fb64	9d66d3cf-82b1-459a-a9c9-98d9c9bc466b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:00:58
19316	9d66d3cf-7b0b-4236-a341-cd5415120264	9d66d3cf-82b1-459a-a9c9-98d9c9bc466b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"64.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:00:58
19317	9d66d3cf-7b8f-4ad6-91f0-099078a63f5a	9d66d3cf-82b1-459a-a9c9-98d9c9bc466b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:00:58
19318	9d66d3cf-8134-43e2-a9bb-d0087504d25f	9d66d3cf-82b1-459a-a9c9-98d9c9bc466b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 11:00:58
19319	9d66d3cf-818f-4d81-b831-bfd7bbe79e51	9d66d3cf-82b1-459a-a9c9-98d9c9bc466b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":401,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:00:58
20718	9d66fbbd-4176-461c-a4ca-954e4284f308	9d66fbbd-4511-4be4-8c40-0121a4134ba5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":162,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:52:37
24660	9d68b853-0492-4a23-9708-ae1ec53db20f	9d68b853-0a8f-40a0-a71b-2936ec59b8cb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-total-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":253,"memory":20,"hostname":"EderCortes"}	2024-11-04 09:35:46
28958	9d690dc3-8fc2-4d30-8191-9be102c90ebe	9d690dc3-90d9-4c3d-a987-01069771f0df	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":439,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:34:40
32776	9d6989ae-c53f-439f-bcbf-7369eb1c0b06	9d6989af-222a-4944-9c0f-624de25e8d11	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 19:21:10
32777	9d6989af-17f5-4cf4-8384-541d824f83ac	9d6989af-222a-4944-9c0f-624de25e8d11	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"173.61","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 19:21:10
32778	9d6989af-1889-4f58-b2b9-ba5dd5127551	9d6989af-222a-4944-9c0f-624de25e8d11	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 19:21:10
32779	9d6989af-2040-40bf-ad88-8a6db355d8f0	9d6989af-222a-4944-9c0f-624de25e8d11	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 19:21:10
28959	9d690dc3-fffd-4f8f-9fc9-73142c4f4263	9d690dc4-2ec0-4a5e-b99d-cd5dfb3d26a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 13:34:40
20726	9d66fbbe-6617-422c-8765-256ce2cf75c3	9d66fbbe-85ce-486e-afd8-e85abe37a041	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:52:37
20727	9d66fbbe-7cb1-4525-bbfd-88428fca4eab	9d66fbbe-85ce-486e-afd8-e85abe37a041	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"43.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:52:37
20728	9d66fbbe-8054-45c5-ac06-6a3f8df463da	9d66fbbe-85ce-486e-afd8-e85abe37a041	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:52:37
20729	9d66fbbe-8084-4fd8-9fcd-76f1f1072431	9d66fbbe-85ce-486e-afd8-e85abe37a041	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:52:37
20730	9d66fbbe-84a1-4c58-98af-c278c89e59ac	9d66fbbe-85ce-486e-afd8-e85abe37a041	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:52:37
20731	9d66fbbe-84e5-4069-951e-9f782382bb1c	9d66fbbe-85ce-486e-afd8-e85abe37a041	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"400000","loans_pago_interes":"200000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:40:42.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"}]}},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:52:37
28960	9d690dc4-222a-467b-baeb-8ee2eb70f6a0	9d690dc4-2ec0-4a5e-b99d-cd5dfb3d26a6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '89' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"58.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 13:34:40
28961	9d690dc4-22b8-4e11-8f47-bc491da7d725	9d690dc4-2ec0-4a5e-b99d-cd5dfb3d26a6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 13:34:40
28962	9d690dc4-2597-4c19-b99a-b704e768aa03	9d690dc4-2ec0-4a5e-b99d-cd5dfb3d26a6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"3.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:34:40
28963	9d690dc4-25f1-4961-88ff-375438e44685	9d690dc4-2ec0-4a5e-b99d-cd5dfb3d26a6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:34:40
28964	9d690dc4-2cc1-4e48-869b-797f92b30f8f	9d690dc4-2ec0-4a5e-b99d-cd5dfb3d26a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 13:34:40
28965	9d690dc4-2d4f-4316-a326-414ab8e2294f	9d690dc4-2ec0-4a5e-b99d-cd5dfb3d26a6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"146000","loans_pago_prestado":"584000","loans_intereses_recaudar":"275000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":381,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:34:40
32780	9d6989af-20d0-4176-8147-aefbdaeccd0e	9d6989af-222a-4944-9c0f-624de25e8d11	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":528,"memory":22,"hostname":"EderCortes"}	2024-11-04 19:21:10
24670	9d68b8a1-14a6-469a-ad39-66cbe51e317d	9d68b8a1-1838-4d19-8f4f-e0b0ac8c30ba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-total-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":197,"memory":20,"hostname":"EderCortes"}	2024-11-04 09:36:37
35217	9d69c2f6-08ba-4919-aaaf-81eecc040336	9d69c2f6-3e13-4104-a848-dff31304b9ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 22:01:20
35218	9d69c2f6-3b30-4645-8725-8156aa57e92b	9d69c2f6-3e13-4104-a848-dff31304b9ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 22:01:20
35219	9d69c2f6-3c71-41ee-b5ce-f3927ccb7a57	9d69c2f6-3e13-4104-a848-dff31304b9ed	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":428,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:01:20
35220	9d69c2f6-d705-466a-aadc-9f3ae2abc378	9d69c2f7-0402-4e42-9a14-4ef7754308c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 22:01:20
35221	9d69c2f6-fbec-405b-a3a7-88dca42af18b	9d69c2f7-0402-4e42-9a14-4ef7754308c9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"66.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 22:01:20
35222	9d69c2f7-01e8-4644-873a-96e1e0340492	9d69c2f7-0402-4e42-9a14-4ef7754308c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 22:01:20
35223	9d69c2f7-0296-4d47-8d41-42702f8fe8f4	9d69c2f7-0402-4e42-9a14-4ef7754308c9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":425,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:01:20
24680	9d68b939-8500-4c0e-b9da-f987d0dacfa3	9d68b939-8994-4c0e-a674-008d0b7fc7bc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-total-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":144,"memory":20,"hostname":"EderCortes"}	2024-11-04 09:38:17
35224	9d69c2f7-808c-4aa2-9533-cf163b76e8d8	9d69c2f7-b09c-42ad-a225-467566182e22	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 22:01:21
35225	9d69c2f7-a7eb-4cad-8b0d-d970f3e0d2d3	9d69c2f7-b09c-42ad-a225-467566182e22	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"61.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:01:21
35226	9d69c2f7-a8a0-456f-a969-7572e60458eb	9d69c2f7-b09c-42ad-a225-467566182e22	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:01:21
25058	9d68bfa5-6fe5-411b-8b98-c7a1c301bba4	9d68bfa5-9349-4011-b97c-5e238fc088e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 09:56:14
25059	9d68bfa5-915c-461b-a0ed-b3fcc584a1e8	9d68bfa5-9349-4011-b97c-5e238fc088e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 09:56:14
25060	9d68bfa5-9224-40cd-94fd-4fd66357fae5	9d68bfa5-9349-4011-b97c-5e238fc088e5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":406,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:56:14
35227	9d69c2f7-af15-49e6-8939-42ac8f35024b	9d69c2f7-b09c-42ad-a225-467566182e22	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 22:01:21
35228	9d69c2f7-af8c-4b40-8c2b-88aadfccd476	9d69c2f7-b09c-42ad-a225-467566182e22	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":429,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:01:21
25061	9d68bfa6-1d2d-4a08-8d5f-a90c69f9bdb3	9d68bfa6-7181-4a15-baa7-f16032cbb2f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 09:56:14
25062	9d68bfa6-6725-417a-9b30-20cea43011d4	9d68bfa6-7181-4a15-baa7-f16032cbb2f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"170.08","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 09:56:15
25063	9d68bfa6-6b11-4a3e-a6fe-10f4b9eb0e3b	9d68bfa6-7181-4a15-baa7-f16032cbb2f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:56:15
25064	9d68bfa6-6b4a-4b09-8139-36efbfc91d78	9d68bfa6-7181-4a15-baa7-f16032cbb2f0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 09:56:15
25065	9d68bfa6-7008-4340-a0f9-421155627b29	9d68bfa6-7181-4a15-baa7-f16032cbb2f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 09:56:15
25066	9d68bfa6-7068-4fe1-9979-7d20865a6b81	9d68bfa6-7181-4a15-baa7-f16032cbb2f0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":352,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":353,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":354,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":355,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":519,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:56:15
35229	9d69c2f8-dcae-426b-8a5f-40be1b3501b2	9d69c2f9-4d5e-4e7a-bdc9-0b21d369b310	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 22:01:22
35230	9d69c2f9-437b-4ddc-8959-0675db64c663	9d69c2f9-4d5e-4e7a-bdc9-0b21d369b310	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"144.96","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:01:22
35231	9d69c2f9-4408-45dc-bd84-ed08cb6f2ffa	9d69c2f9-4d5e-4e7a-bdc9-0b21d369b310	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:01:22
35232	9d69c2f9-4b56-4df7-accc-0fa2a705f8b7	9d69c2f9-4d5e-4e7a-bdc9-0b21d369b310	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-04 22:01:22
35233	9d69c2f9-4bda-4cfd-8add-649a7218b351	9d69c2f9-4d5e-4e7a-bdc9-0b21d369b310	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1038,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:01:22
35234	9d69c2f9-f929-467b-ac03-6b89ed174f91	9d69c2fa-2362-4086-9f9e-cdf927b59e00	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-04 22:01:22
22262	9d674858-3f57-40bb-b39a-f85882eeec8b	9d674858-7476-4a07-8a57-539b47263771	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 16:26:49
22263	9d674858-7180-4e5c-bdf4-c5ff7ee0a1ec	9d674858-7476-4a07-8a57-539b47263771	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 16:26:49
22264	9d674858-72b3-4b44-8250-0ccfec51ca13	9d674858-7476-4a07-8a57-539b47263771	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":523,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:26:49
35235	9d69c2fa-1951-4512-94d1-54e7211e406f	9d69c2fa-2362-4086-9f9e-cdf927b59e00	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"52.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:01:22
24690	9d68b950-7187-43b6-852f-85e7c2113346	9d68b950-75cf-4cdf-b475-89c72daad011	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-total-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":247,"memory":20,"hostname":"EderCortes"}	2024-11-04 09:38:32
35236	9d69c2fa-19df-4c3a-a0a7-707c6bc44be2	9d69c2fa-2362-4086-9f9e-cdf927b59e00	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:01:22
35237	9d69c2fa-2165-45e8-bccf-f472ad11c497	9d69c2fa-2362-4086-9f9e-cdf927b59e00	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-04 22:01:22
35238	9d69c2fa-21dc-4736-a78c-21942d660d9f	9d69c2fa-2362-4086-9f9e-cdf927b59e00	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":524,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:01:22
22265	9d674859-0b53-4abb-95fe-b675551246a8	9d674859-32d6-4252-bb51-941c823edade	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 16:26:49
22266	9d674859-2af3-4d72-9a57-6db80282afb5	9d674859-32d6-4252-bb51-941c823edade	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"52.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 16:26:49
22267	9d674859-2b68-4c1e-b864-837808a02911	9d674859-32d6-4252-bb51-941c823edade	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 16:26:49
22268	9d674859-3153-465f-a3c3-a8909344c46e	9d674859-32d6-4252-bb51-941c823edade	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 16:26:49
22269	9d674859-31b9-4154-b4a2-ca9f16f062db	9d674859-32d6-4252-bb51-941c823edade	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:26:49
24691	9d68b9db-8f05-4979-afc2-738acffaa8a5	9d68b9db-9255-408c-a694-8f86c99aaa36	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-total-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":155,"memory":20,"hostname":"EderCortes"}	2024-11-04 09:40:03
22270	9d674859-9c6a-496c-9d49-b37bc642ee9f	9d674859-f633-47a4-9d82-ee932b0b26d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 16:26:50
22271	9d674859-ed2c-4d27-bdf7-fa15db726c46	9d674859-f633-47a4-9d82-ee932b0b26d9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"170.38","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 16:26:50
22272	9d674859-edb9-4508-a46f-7dd1835b0e38	9d674859-f633-47a4-9d82-ee932b0b26d9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-03 16:26:50
22273	9d674859-f354-4bea-be1d-ecf55465d48c	9d674859-f633-47a4-9d82-ee932b0b26d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 16:26:50
17008	9d6546f1-3d74-4dee-88c6-6fc1a331a27d	9d6546f1-5ed9-42da-b7e0-63449dcc1093	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-02 16:31:14
17009	9d6546f1-5d58-4253-a153-ee7f8baff432	9d6546f1-5ed9-42da-b7e0-63449dcc1093	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 16:31:14
17010	9d6546f1-5def-4a1b-9a66-b409d5273101	9d6546f1-5ed9-42da-b7e0-63449dcc1093	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna loans.id \\nLINE 1: ...loans\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"loans\\".\\"i...\\n                                                             ^\\nHINT:  Probablemente quiera hacer referencia a la columna \\u00abloans.id\\u00bb. (Connection: pgsql, SQL: select \\"loans\\".\\"id\\", \\"loans\\".\\"loans_documento\\", \\"loans\\".\\"loans_nombre\\", \\"loans\\".\\"loans_apellido_uno\\", \\"loans\\".\\"loans_fecha\\", \\"loans\\".\\"loans_valor_prestado\\", \\"loans\\".\\"loans_cuotas\\", \\"loans\\".\\"loans_estado\\", \\"loans\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" inner join \\"users\\" as \\"ucl\\" on \\"loans\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"loans\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"loans\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"loans\\".\\"id \\" desc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":42,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":277,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:31:14
22274	9d674859-f43f-478b-9176-42fb20c02656	9d674859-f633-47a4-9d82-ee932b0b26d9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":473,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:26:50
24692	9d68bb9e-1729-4cf3-a4f2-90c07f6fe593	9d68bb9e-1d3a-4cef-b5c5-90e90252c78c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-total-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":202,"memory":20,"hostname":"EderCortes"}	2024-11-04 09:44:58
35385	9d69c44a-a6c9-4bb6-9188-ab2f17e953c7	9d69c44a-e3b7-42c6-bfdf-0bf20dcd6232	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 22:05:03
35386	9d69c44a-e0bb-4cd0-ae86-7038e8fb4ebe	9d69c44a-e3b7-42c6-bfdf-0bf20dcd6232	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 22:05:03
29422	9d69245b-9730-4c2b-89b3-d385f07f6e2a	9d69245b-9d28-4d2f-bd45-a9775ea033ae	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1383}	2024-11-04 14:37:51
17011	9d6546f2-d67a-4200-8a4d-87154f122d69	9d6546f3-24f0-4182-bf4c-e959f3f8b7bc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-02 16:31:15
17012	9d6546f3-1e92-40ea-bffc-2bf9ade72aeb	9d6546f3-24f0-4182-bf4c-e959f3f8b7bc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"158.93","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 16:31:15
17013	9d6546f3-1ef0-4c32-aeb4-72e176ef463b	9d6546f3-24f0-4182-bf4c-e959f3f8b7bc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 16:31:15
17014	9d6546f3-23b8-48e9-bf50-85c7015f6993	9d6546f3-24f0-4182-bf4c-e959f3f8b7bc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 16:31:15
17015	9d6546f3-2400-491a-9e88-b19d8dc63705	9d6546f3-24f0-4182-bf4c-e959f3f8b7bc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":514,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:31:15
24693	9d68bb9e-a43f-458c-bf6f-2d3e2af686cd	9d68bb9e-cd6c-44e2-9696-defaaa2b44ca	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 09:44:58
24694	9d68bb9e-c0d1-4672-9ece-613dd580cb01	9d68bb9e-cd6c-44e2-9696-defaaa2b44ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 88 limit 1","time":"2.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":697,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 09:44:59
24695	9d68bb9e-c12e-4dc2-ba69-51d5ed7a4c54	9d68bb9e-cd6c-44e2-9696-defaaa2b44ca	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 09:44:59
24696	9d68bb9e-c283-4c2f-800e-7f0ffe3871ca	9d68bb9e-cd6c-44e2-9696-defaaa2b44ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_estado\\" = 'Cancelado', \\"loans_pago_interes\\" = 275000, \\"loans_pago_prestado\\" = 1100000, \\"updated_at\\" = '2024-11-04 09:44:59' where \\"id\\" = 88","time":"0.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":722,"hash":"acfe32aea56c9ca6bdbb917f944a78d1","hostname":"EderCortes"}	2024-11-04 09:44:59
24697	9d68bb9e-c2e4-4c13-9863-d6c9a84f281f	9d68bb9e-cd6c-44e2-9696-defaaa2b44ca	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:88","changes":{"loans_estado":"Cancelado","updated_at":"2024-11-04 09:44:59","loans_pago_interes":275000,"loans_pago_prestado":1100000},"hostname":"EderCortes"}	2024-11-04 09:44:59
24698	9d68bb9e-c436-4b55-a636-0ab41783649c	9d68bb9e-cd6c-44e2-9696-defaaa2b44ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 88 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"2.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":727,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 09:44:59
24699	9d68bb9e-c465-44da-996d-571de34a09ae	9d68bb9e-cd6c-44e2-9696-defaaa2b44ca	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 09:44:59
24700	9d68bb9e-c4ca-4af6-970b-62a1c4b340c2	9d68bb9e-cd6c-44e2-9696-defaaa2b44ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_interes_canelado\\" = '35000', \\"itemloans_cuota_cancelada\\" = '140000', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_status\\" = 'Pagada', \\"itemloans_aprobador\\" = 12, \\"updated_at\\" = '2024-11-04 09:44:59' where \\"loans_codigo\\" = 88 and \\"itemloans_status\\" = 'Pendiente'","time":"0.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":736,"hash":"87a64c6113219082cd85f391b598ec7f","hostname":"EderCortes"}	2024-11-04 09:44:59
24701	9d68bb9e-cbc6-491a-bfa5-06ad14a64cbc	9d68bb9e-cd6c-44e2-9696-defaaa2b44ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 09:44:59
24702	9d68bb9e-cc19-4e18-9831-b84615b4b3d2	9d68bb9e-cd6c-44e2-9696-defaaa2b44ca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-total-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payTotal","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"29","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"idLoans":88,"idCreador":12},"session":[],"response_status":200,"response":{"message":"Se ha realizado el pago total del credito","status":true},"duration":389,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:44:59
35387	9d69c44a-e234-411a-85f9-c17d5067b58c	9d69c44a-e3b7-42c6-bfdf-0bf20dcd6232	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":481,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:05:03
25264	9d68c0cd-f707-4938-871c-fb9828a61d86	9d68c0ce-3dcf-4598-b7f7-624265688dd0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 09:59:28
25265	9d68c0ce-3a85-45ab-8daf-227d971c5586	9d68c0ce-3dcf-4598-b7f7-624265688dd0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 09:59:29
25266	9d68c0ce-3c17-415f-9e0a-259169388450	9d68c0ce-3dcf-4598-b7f7-624265688dd0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":701,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:59:29
26904	9d68dd92-160b-494a-a26a-8fde5cfd4564	9d68dd92-1937-47ba-b02c-9257ec903286	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1255}	2024-11-04 11:19:54
35388	9d69c44b-80e0-417a-8442-38a978081e4c	9d69c44b-b08a-4391-974e-bc8c8dd96d7d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 22:05:04
35389	9d69c44b-a85c-422e-b26e-adf16ab7c146	9d69c44b-b08a-4391-974e-bc8c8dd96d7d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"67.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 22:05:04
35390	9d69c44b-ae57-4df9-910e-812170d6e8b1	9d69c44b-b08a-4391-974e-bc8c8dd96d7d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 22:05:04
25267	9d68c0cf-2e1c-4c80-b694-ed50538c7a9e	9d68c0cf-7473-4fec-b51c-e0ab1234ed50	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 09:59:29
25268	9d68c0cf-6b7a-4205-bc38-a13c55b55701	9d68c0cf-7473-4fec-b51c-e0ab1234ed50	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"144.48","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 09:59:29
25269	9d68c0cf-6f4f-412e-9cca-add956ae117e	9d68c0cf-7473-4fec-b51c-e0ab1234ed50	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"1.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:59:29
25270	9d68c0cf-6f84-41f2-a274-14d04fdf7210	9d68c0cf-7473-4fec-b51c-e0ab1234ed50	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 09:59:29
25271	9d68c0cf-732c-4683-a8c3-834d7806e3c0	9d68c0cf-7473-4fec-b51c-e0ab1234ed50	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 09:59:29
25272	9d68c0cf-737c-4ae5-be56-3de949fd0917	9d68c0cf-7473-4fec-b51c-e0ab1234ed50	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":713,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:59:29
35391	9d69c44b-af14-47c5-a0e7-ee6e8beb692f	9d69c44b-b08a-4391-974e-bc8c8dd96d7d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":435,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:05:04
35637	9d69c539-dc80-4544-ae5d-05fcd5107e8e	9d69c53a-1125-4398-802a-db8eca208f80	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 22:07:40
25273	9d68c0d0-39bf-46df-9e88-309b48a0a1e5	9d68c0d0-752c-4e37-8c63-04f19add89c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 09:59:30
25274	9d68c0d0-6ba9-44b2-8cc5-9297c664a3b3	9d68c0d0-752c-4e37-8c63-04f19add89c0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"82.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:59:30
25275	9d68c0d0-6c2b-4205-be72-b5b3cb6a005f	9d68c0d0-752c-4e37-8c63-04f19add89c0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:59:30
25276	9d68c0d0-7321-4a81-b887-5166be620a30	9d68c0d0-752c-4e37-8c63-04f19add89c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 09:59:30
25277	9d68c0d0-73b0-4e7b-8a5b-598915b52216	9d68c0d0-752c-4e37-8c63-04f19add89c0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":631,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:59:30
35392	9d69c44c-23ae-4189-9412-ac7c8d72ba3a	9d69c44c-5923-4ed6-be96-f3030a3cf0fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 22:05:04
35393	9d69c44c-4f62-45bb-a03a-3c95cc601695	9d69c44c-5923-4ed6-be96-f3030a3cf0fa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"73.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:05:04
35394	9d69c44c-5002-48c6-b6c1-43e023d8bf73	9d69c44c-5923-4ed6-be96-f3030a3cf0fa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:05:04
35395	9d69c44c-56f3-4bc3-ac5d-28652d38bd2d	9d69c44c-5923-4ed6-be96-f3030a3cf0fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 22:05:04
35396	9d69c44c-5785-4e00-9108-54a2533de0fa	9d69c44c-5923-4ed6-be96-f3030a3cf0fa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":417,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:05:04
35638	9d69c53a-0edf-48ff-a043-5cfeab33e4a4	9d69c53a-1125-4398-802a-db8eca208f80	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 22:07:40
35639	9d69c53a-1008-4b8b-b74d-ab2805cb553f	9d69c53a-1125-4398-802a-db8eca208f80	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":514,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:07:40
25278	9d68c0d1-7ae4-4769-a1c6-079d072ef82e	9d68c0d1-a5f9-4456-b061-5f17aa72e2d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 09:59:31
25279	9d68c0d1-9da1-44a8-870a-f59899962d7e	9d68c0d1-a5f9-4456-b061-5f17aa72e2d8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"58.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:59:31
25280	9d68c0d1-9e2b-488b-a3d2-a236ad117d13	9d68c0d1-a5f9-4456-b061-5f17aa72e2d8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:59:31
25281	9d68c0d1-a409-4072-b7f9-c85fe728c1d1	9d68c0d1-a5f9-4456-b061-5f17aa72e2d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 09:59:31
25282	9d68c0d1-a4bb-4665-9a49-ca54e79222bb	9d68c0d1-a5f9-4456-b061-5f17aa72e2d8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":473,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:59:31
35397	9d69c44c-ebdd-44d9-9853-4e5065da813d	9d69c44d-9d2a-49e3-992e-4b9d10e2906d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 22:05:05
35398	9d69c44d-9009-4229-ab9d-8b555023d261	9d69c44d-9d2a-49e3-992e-4b9d10e2906d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"337.85","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:05:05
35399	9d69c44d-90a6-4cc8-9c5d-6683c6f33a91	9d69c44d-9d2a-49e3-992e-4b9d10e2906d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:05:05
35400	9d69c44d-9a3d-429a-b42f-bc4561d7f82f	9d69c44d-9d2a-49e3-992e-4b9d10e2906d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 22:05:05
35401	9d69c44d-9b60-420e-a48e-761d058e6b84	9d69c44d-9d2a-49e3-992e-4b9d10e2906d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":803,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:05:05
35640	9d69c53a-9c27-4632-8c6f-391ae3d991e3	9d69c53a-ce8f-4c38-b4fa-ffcd834abef7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 22:07:40
35641	9d69c53a-c541-4d63-af19-5bdfc08ce806	9d69c53a-ce8f-4c38-b4fa-ffcd834abef7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"75.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 22:07:40
35642	9d69c53a-cc83-49bc-ad6f-cc559c96b6f0	9d69c53a-ce8f-4c38-b4fa-ffcd834abef7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 22:07:40
35402	9d69c44e-494f-4998-bbab-b743378a0dea	9d69c44e-b1f4-4a06-b8f3-79f283f2046b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 22:05:05
35403	9d69c44e-a6b4-42d1-9e8d-6c220ab1dfd5	9d69c44e-b1f4-4a06-b8f3-79f283f2046b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"198.32","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:05:06
35404	9d69c44e-a747-4aa7-a705-95da38f6347e	9d69c44e-b1f4-4a06-b8f3-79f283f2046b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:05:06
35405	9d69c44e-afa9-4b14-b5a8-f915f0dc721e	9d69c44e-b1f4-4a06-b8f3-79f283f2046b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 22:05:06
29154	9d6912f9-344a-4da4-bd73-a992250b4126	9d6912f9-59b3-4d26-90cb-60c34f1177f4	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 13:49:14
29155	9d6912f9-57e1-4b80-ac5a-e1e4685bee60	9d6912f9-59b3-4d26-90cb-60c34f1177f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 13:49:14
29156	9d6912f9-58ac-44b7-835a-52f0c3a329e5	9d6912f9-59b3-4d26-90cb-60c34f1177f4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":271,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:49:14
35406	9d69c44e-b04a-4e3e-b25a-cbce2b8bf5db	9d69c44e-b1f4-4a06-b8f3-79f283f2046b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":670,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:05:06
35643	9d69c53a-cd32-44aa-a3fc-53fabcce3038	9d69c53a-ce8f-4c38-b4fa-ffcd834abef7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":399,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:07:40
29157	9d6912f9-bb51-4e44-8203-a84b938500bd	9d6912f9-da0d-4cc0-8ebf-171a8677b1c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 13:49:14
29158	9d6912f9-d0d2-41d3-beda-d7dda740d93e	9d6912f9-da0d-4cc0-8ebf-171a8677b1c5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"42.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 13:49:14
29159	9d6912f9-d47d-425b-bc94-c1d68a95eadc	9d6912f9-da0d-4cc0-8ebf-171a8677b1c5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:49:14
29160	9d6912f9-d4b7-4ef2-985e-e173bf7a784e	9d6912f9-da0d-4cc0-8ebf-171a8677b1c5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:49:14
29161	9d6912f9-d8d9-48f2-a5dc-5189029a2ff9	9d6912f9-da0d-4cc0-8ebf-171a8677b1c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 13:49:14
29162	9d6912f9-d924-4119-89c1-563656a037c3	9d6912f9-da0d-4cc0-8ebf-171a8677b1c5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":279,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:49:14
35644	9d69c53b-9aa2-467b-85f7-3d51f825bac2	9d69c53b-c596-4c5e-9b07-a711e17c129d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 22:07:41
35645	9d69c53b-bf55-4bdf-b74c-eb670555cdc1	9d69c53b-c596-4c5e-9b07-a711e17c129d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"56.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:07:41
35646	9d69c53b-bfb2-4c18-8d05-b444ad9134bd	9d69c53b-c596-4c5e-9b07-a711e17c129d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:07:41
35647	9d69c53b-c435-4644-8a5b-a1a801bbb6d9	9d69c53b-c596-4c5e-9b07-a711e17c129d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 22:07:41
35648	9d69c53b-c492-4ab7-ab34-ed3a203628f4	9d69c53b-c596-4c5e-9b07-a711e17c129d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":615,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:07:41
35649	9d69c53c-a3d7-4e18-aac2-e74658d9d710	9d69c53d-4238-49e2-88fc-f133503d7133	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 22:07:42
35650	9d69c53d-386c-45cf-aff7-693fe8502dd0	9d69c53d-4238-49e2-88fc-f133503d7133	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"114.82","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:07:42
35651	9d69c53d-3904-4788-89c8-6151ee12c9d7	9d69c53d-4238-49e2-88fc-f133503d7133	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:07:42
15244	9d5ecf50-d0c8-4cbd-98f7-8662c09e577f	9d5ecf51-122b-4619-8464-6379107b9399	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-10-30 11:21:46
15245	9d5ecf51-0f8d-4f5a-9c9f-9a2a66465931	9d5ecf51-122b-4619-8464-6379107b9399	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-10-30 11:21:46
15246	9d5ecf51-10d7-4a43-a7b7-632ba5551ab3	9d5ecf51-122b-4619-8464-6379107b9399	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":450,"memory":22,"hostname":"EderCortes"}	2024-10-30 11:21:46
35652	9d69c53d-3fe9-4f90-83a2-4fafb6f74984	9d69c53d-4238-49e2-88fc-f133503d7133	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 22:07:42
18453	9d669186-1170-4baa-a032-9007a8cb6668	9d669186-5ee5-4d9d-b3be-ec108ec28911	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 07:55:37
18454	9d669186-5d41-4c5f-9662-2e98f0843644	9d669186-5ee5-4d9d-b3be-ec108ec28911	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 07:55:37
18455	9d669186-5dec-4697-8738-7567a04a07cc	9d669186-5ee5-4d9d-b3be-ec108ec28911	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":400,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:55:37
35653	9d69c53d-4097-462e-82cf-a164f6df34f0	9d69c53d-4238-49e2-88fc-f133503d7133	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":944,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:07:42
18456	9d669186-acb4-45f6-b15e-55e83c6161f1	9d669186-c868-4886-975a-6fdc6987dbda	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 07:55:37
18457	9d669186-c437-40a4-9bcd-5f8dc5ac931d	9d669186-c868-4886-975a-6fdc6987dbda	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"41.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58,"hash":"77f8314368b36a9393ec9c7735a91700","hostname":"EderCortes"}	2024-11-03 07:55:37
18458	9d669186-c729-47f2-a479-ced53b3346d9	9d669186-c868-4886-975a-6fdc6987dbda	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 07:55:37
18459	9d669186-c779-4128-b8d3-f2800739eca1	9d669186-c868-4886-975a-6fdc6987dbda	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-1","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"6","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:55:37
19396	9d66d604-fae8-4f3f-b47f-d3f0e5051f10	9d66d605-16d2-47e3-b6d6-fc1e7f235692	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 11:07:08
19397	9d66d605-1569-4752-b7f0-00bf8e509d77	9d66d605-16d2-47e3-b6d6-fc1e7f235692	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 11:07:08
19398	9d66d605-15f0-4ec0-bd79-e614058459ab	9d66d605-16d2-47e3-b6d6-fc1e7f235692	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":219,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:07:08
35654	9d69c53d-d471-483a-93a6-010c82b5bd88	9d69c53e-0bea-4fef-adb0-7870334413bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 22:07:42
18460	9d669188-c715-4e08-a55c-324c8a6fd02a	9d669188-fa42-48a4-8cc4-808e975c5270	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 07:55:38
18461	9d669188-def5-4663-b574-eb95666d60dd	9d669188-fa42-48a4-8cc4-808e975c5270	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 07:55:38
18462	9d669188-df42-4465-a55d-a660a41175c7	9d669188-fa42-48a4-8cc4-808e975c5270	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 07:55:38
18463	9d669188-f919-4a1c-889b-bc04ef0bfe55	9d669188-fa42-48a4-8cc4-808e975c5270	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 07:55:38
18464	9d669188-f95d-4613-9c87-5aae2b2a613c	9d669188-fa42-48a4-8cc4-808e975c5270	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":308,"memory":22,"hostname":"EderCortes"}	2024-11-03 07:55:38
19399	9d66d605-6367-4d20-ba09-cd6ffd912662	9d66d605-84b4-4717-8462-14bceb1b2fae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 11:07:09
19400	9d66d605-7a26-4b4c-be4d-34bd44493012	9d66d605-84b4-4717-8462-14bceb1b2fae	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"44.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 11:07:09
19401	9d66d605-7ed0-4e81-ba0a-8ea8900b2b2f	9d66d605-84b4-4717-8462-14bceb1b2fae	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:07:09
19402	9d66d605-7f11-4f90-9a2f-510f0572de1d	9d66d605-84b4-4717-8462-14bceb1b2fae	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:07:09
19403	9d66d605-8389-42de-9a04-c80f643d2c8b	9d66d605-84b4-4717-8462-14bceb1b2fae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 11:07:09
19404	9d66d605-83d6-4a6d-a4fa-393de616425f	9d66d605-84b4-4717-8462-14bceb1b2fae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T02:27:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"0"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:07:09
35655	9d69c53e-02db-41d3-aa00-ac27d3a90ffb	9d69c53e-0bea-4fef-adb0-7870334413bd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"66.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:07:43
35656	9d69c53e-0363-4b63-bfcb-0040b1524e05	9d69c53e-0bea-4fef-adb0-7870334413bd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:07:43
35657	9d69c53e-09de-4ee3-a52b-37d1fa8d5e28	9d69c53e-0bea-4fef-adb0-7870334413bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 22:07:43
19405	9d66d606-e818-47d2-9778-323be6e3c656	9d66d607-1db5-4a75-8c0f-5b9196b9753d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 11:07:10
19406	9d66d607-168b-4967-8b74-66d5907cd165	9d66d607-1db5-4a75-8c0f-5b9196b9753d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"58.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:07:10
19407	9d66d607-16fd-44c5-83af-37a1ce785766	9d66d607-1db5-4a75-8c0f-5b9196b9753d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:07:10
19408	9d66d607-1c14-41c7-ab20-c5711e245aa8	9d66d607-1db5-4a75-8c0f-5b9196b9753d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 11:07:10
19409	9d66d607-1c7e-4f9b-bfd2-8d9bb2a2517a	9d66d607-1db5-4a75-8c0f-5b9196b9753d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":466,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:07:10
35658	9d69c53e-0a68-46f8-8319-387774b438ba	9d69c53e-0bea-4fef-adb0-7870334413bd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":491,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:07:43
34181	9d69bba7-1b22-4bd3-9b28-16b58a0a88e8	9d69bba7-49b1-45e0-957d-2cead54fdeef	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 21:40:54
34182	9d69bba7-471c-4618-ad8d-c5a34fdd9486	9d69bba7-49b1-45e0-957d-2cead54fdeef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:40:54
34183	9d69bba7-4853-4549-b98c-7cbccdb25408	9d69bba7-49b1-45e0-957d-2cead54fdeef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":411,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:40:54
9273	9d52f6ab-e810-44f9-ba1c-dd124221ecb5	9d52f6ab-eb37-4ed3-82ee-93e028987696	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":443}	2024-10-24 14:01:53
27933	9d68ea7d-0558-430f-a73e-a8662f13327f	9d68ea7d-096d-40a1-9049-e83673310524	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1301}	2024-11-04 11:56:02
34184	9d69bba7-ed75-4599-bf44-a8907f0fdf92	9d69bba8-17b3-4cdb-88c0-82c4d28ad5c1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:40:54
34185	9d69bba8-0fda-4684-b337-4bd87e8f9b94	9d69bba8-17b3-4cdb-88c0-82c4d28ad5c1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"56.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":227,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:40:54
34186	9d69bba8-1047-4530-9aae-31d57b51c4fb	9d69bba8-17b3-4cdb-88c0-82c4d28ad5c1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:40:54
34187	9d69bba8-1660-4a1b-ab28-6bca12c63a20	9d69bba8-17b3-4cdb-88c0-82c4d28ad5c1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:40:54
34188	9d69bba8-16c0-4864-a754-6526ce615a2c	9d69bba8-17b3-4cdb-88c0-82c4d28ad5c1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":377,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:40:54
21932	9d674109-6f43-4b2e-92d8-f2a9676ca64b	9d674109-d336-4cf0-a530-9fa5f57e0211	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 16:06:23
21933	9d674109-cfb2-455c-8145-9e2272c5fc6d	9d674109-d336-4cf0-a530-9fa5f57e0211	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 16:06:23
21934	9d674109-d169-4028-ab93-d4f0d6581b98	9d674109-d336-4cf0-a530-9fa5f57e0211	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":568,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:06:23
34189	9d69bba8-6720-4cb7-838d-7d1547be978d	9d69bba8-b398-4bba-9c6e-e3914c54f4d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:40:55
34190	9d69bba8-ae02-4e34-b44c-08b19923f9e1	9d69bba8-b398-4bba-9c6e-e3914c54f4d0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"154.95","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":216,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 21:40:55
34191	9d69bba8-ae59-4f21-ad95-e5ed2560a52f	9d69bba8-b398-4bba-9c6e-e3914c54f4d0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 21:40:55
34192	9d69bba8-b256-462e-a672-09cbae1de6b9	9d69bba8-b398-4bba-9c6e-e3914c54f4d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:40:55
21935	9d67410a-826b-4c23-9422-a67c708f304f	9d67410a-b7c9-403b-8399-1dcc184043ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 16:06:24
21936	9d67410a-a817-4b70-b215-fe36d2fd929a	9d67410a-b7c9-403b-8399-1dcc184043ef	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 68\\n                        ","time":"76.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"7d9994d55cb8dde82ff4185920c79043","hostname":"EderCortes"}	2024-11-03 16:06:24
21937	9d67410a-af64-4788-9e42-3f075a77475b	9d67410a-b7c9-403b-8399-1dcc184043ef	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '68' order by \\"item_loans\\".\\"id\\" asc","time":"3.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 16:06:24
21938	9d67410a-afbf-437f-af70-d1b547bb0023	9d67410a-b7c9-403b-8399-1dcc184043ef	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 16:06:24
21939	9d67410a-b5c7-47f4-86b1-e3bb01c5da6e	9d67410a-b7c9-403b-8399-1dcc184043ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 16:06:24
21940	9d67410a-b640-41c3-b172-97fe68afed93	9d67410a-b7c9-403b-8399-1dcc184043ef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/68","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":68,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":10000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"1000000","loans_pago_interes":"250000"},"items":[{"id":227,"loans_codigo":68,"itemloans_cuota":"1","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":228,"loans_codigo":68,"itemloans_cuota":"2","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":229,"loans_codigo":68,"itemloans_cuota":"3","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":230,"loans_codigo":68,"itemloans_cuota":"4","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":231,"loans_codigo":68,"itemloans_cuota":"5","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":232,"loans_codigo":68,"itemloans_cuota":"6","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":233,"loans_codigo":68,"itemloans_cuota":"7","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":234,"loans_codigo":68,"itemloans_cuota":"8","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":235,"loans_codigo":68,"itemloans_cuota":"9","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":236,"loans_codigo":68,"itemloans_cuota":"10","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":495,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:06:24
34193	9d69bba8-b2ad-4652-ae8e-93226d2594bf	9d69bba8-b398-4bba-9c6e-e3914c54f4d0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":384,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:40:55
29222	9d6913e0-2bca-4bbf-ac42-c89ee6ad12d4	9d6913e0-5cc1-40af-8faa-6c3d96406252	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 13:51:45
29223	9d6913e0-598a-4140-ba3b-2fec857e0e39	9d6913e0-5cc1-40af-8faa-6c3d96406252	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 13:51:45
29224	9d6913e0-5b37-4a8c-ad33-9efcdd2dcd3f	9d6913e0-5cc1-40af-8faa-6c3d96406252	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":458,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:51:45
21941	9d67410b-e914-4e37-9ac2-0b7fd10313c2	9d67410c-4d6d-4613-9e4b-a827c548b6c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 16:06:24
21942	9d67410c-41da-4a57-af48-bb569bce169a	9d67410c-4d6d-4613-9e4b-a827c548b6c9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"139.33","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:06:25
21943	9d67410c-4263-428d-8601-c84f5a075d20	9d67410c-4d6d-4613-9e4b-a827c548b6c9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:06:25
21944	9d67410c-4b27-4caa-b174-b3d7fc987c1b	9d67410c-4d6d-4613-9e4b-a827c548b6c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 16:06:25
21945	9d67410c-4bca-438a-9c97-335b1dc2235d	9d67410c-4d6d-4613-9e4b-a827c548b6c9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1014,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:06:25
34194	9d69bba8-f465-4350-9ad7-d3514c6c739f	9d69bba9-3be6-4754-8a55-cb3f0d895a36	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:40:55
34195	9d69bba9-376f-4594-98ca-7b7c5435c2c1	9d69bba9-3be6-4754-8a55-cb3f0d895a36	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"152.32","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:40:55
34196	9d69bba9-37bd-4fea-abd6-a72fdf4bc17f	9d69bba9-3be6-4754-8a55-cb3f0d895a36	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:40:55
34197	9d69bba9-3acd-430f-a9b4-2f0ef5b21686	9d69bba9-3be6-4754-8a55-cb3f0d895a36	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:40:55
34198	9d69bba9-3b15-48f5-a144-ae0b2daecb38	9d69bba9-3be6-4754-8a55-cb3f0d895a36	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:40:55
21946	9d67410c-d259-4c81-a6ae-f53a2b6b0a42	9d67410d-02e2-4fdc-8c0c-66c112e40d4f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 16:06:25
21947	9d67410c-f8e9-4e2a-866f-03ed3b71ecae	9d67410d-02e2-4fdc-8c0c-66c112e40d4f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"65.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:06:25
21948	9d67410c-f976-4eb1-9537-466efcdb4f30	9d67410d-02e2-4fdc-8c0c-66c112e40d4f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:06:25
21949	9d67410d-004c-42b1-aa5c-bc8d8c91737e	9d67410d-02e2-4fdc-8c0c-66c112e40d4f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 16:06:25
21950	9d67410d-0115-479d-8521-ef61dab81231	9d67410d-02e2-4fdc-8c0c-66c112e40d4f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":435,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:06:25
25481	9d68c67a-fb93-4069-a0bc-317462296832	9d68c67b-3cbd-4e87-bd42-63d1089976e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:15:21
25482	9d68c67b-3a2b-4470-9136-302a863ea287	9d68c67b-3cbd-4e87-bd42-63d1089976e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:15:21
25483	9d68c67b-3b54-4800-8833-49c299b83af9	9d68c67b-3cbd-4e87-bd42-63d1089976e7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":605,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:15:21
36035	9d69c8d8-4062-4248-a325-ebef4bd70b5c	9d69c8d8-74ea-449a-ac53-89b79eb778ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 22:17:47
35878	9d69c80e-a841-43df-8569-32ae0f26a2bd	9d69c80e-dab9-4390-84b8-bb6cde59fe4a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 22:15:35
35879	9d69c80e-d7e7-4223-94e1-e99860859c3d	9d69c80e-dab9-4390-84b8-bb6cde59fe4a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 22:15:35
35880	9d69c80e-d932-4866-aea2-7cc52eb16af3	9d69c80e-dab9-4390-84b8-bb6cde59fe4a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":424,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:15:35
36036	9d69c8d8-71a5-48e9-bb75-27b0e45b962c	9d69c8d8-74ea-449a-ac53-89b79eb778ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 22:17:47
36037	9d69c8d8-7342-45ae-a5c2-283390db1375	9d69c8d8-74ea-449a-ac53-89b79eb778ff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":441,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:17:47
25393	9d68c25d-1594-4d98-9e1c-d955d2518871	9d68c25d-50ee-4002-86e3-2fc90319c6d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:03:50
25394	9d68c25d-4dbb-4316-b1c0-ed675fa18169	9d68c25d-50ee-4002-86e3-2fc90319c6d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:03:50
25395	9d68c25d-4f31-4f36-b703-1322cddd0e05	9d68c25d-50ee-4002-86e3-2fc90319c6d0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":626,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:03:50
25396	9d68c25e-0ddb-4639-86a4-a195d99ad614	9d68c25e-4283-4533-b9f0-84af13d8b62a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:03:51
25397	9d68c25e-321d-4f6d-88a7-5ef7e6818a70	9d68c25e-4283-4533-b9f0-84af13d8b62a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 90\\n                        ","time":"67.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"93c10371e33ace24260de21c3ff3890d","hostname":"EderCortes"}	2024-11-04 10:03:51
25398	9d68c25e-3894-496a-bcca-d57cf37d7993	9d68c25e-4283-4533-b9f0-84af13d8b62a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"3.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:03:51
25399	9d68c25e-38e6-4ff7-8348-c0666a99e2c3	9d68c25e-4283-4533-b9f0-84af13d8b62a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 10:03:51
25400	9d68c25e-4093-4133-bf68-c3480afff67b	9d68c25e-4283-4533-b9f0-84af13d8b62a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:03:51
25401	9d68c25e-411f-4db4-8972-851e54a9c4eb	9d68c25e-4283-4533-b9f0-84af13d8b62a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"}]}},"duration":541,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:03:51
25484	9d68c67c-5751-4f3e-a4d4-f6a64768aec9	9d68c67c-9184-48c9-9782-6438ea71ef7e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:15:21
25485	9d68c67c-80d1-4b62-b3cc-b859086280a0	9d68c67c-9184-48c9-9782-6438ea71ef7e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"73.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:15:22
25486	9d68c67c-8702-4e9b-bf73-cd84d055a412	9d68c67c-9184-48c9-9782-6438ea71ef7e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"3.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:15:22
25487	9d68c67c-8755-487e-bfa2-096f90f80d49	9d68c67c-9184-48c9-9782-6438ea71ef7e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:15:22
25488	9d68c67c-8ea3-42b3-bffc-7ba9f93fac7d	9d68c67c-9184-48c9-9782-6438ea71ef7e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:15:22
35881	9d69c80f-653a-46c8-8644-488226166409	9d69c80f-9382-4234-b7b7-28b99e8d4cf0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 22:15:35
35882	9d69c80f-8a4b-46e3-a349-45d9ca417f36	9d69c80f-9382-4234-b7b7-28b99e8d4cf0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '22' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"56.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":74,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 22:15:35
35883	9d69c80f-8acf-4a7c-9d07-e66eb5b4ee49	9d69c80f-9382-4234-b7b7-28b99e8d4cf0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 22:15:35
35884	9d69c80f-918d-4abc-b9c7-2d6e9b722259	9d69c80f-9382-4234-b7b7-28b99e8d4cf0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 22:15:35
25402	9d68c25f-bdcf-4527-9496-4c12485c4684	9d68c25f-f59a-4c42-9365-5011780dea8e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:03:52
25403	9d68c25f-e9ce-4fdd-b30f-4f6a95ee0020	9d68c25f-f59a-4c42-9365-5011780dea8e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"63.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:03:52
25404	9d68c25f-ea68-4440-8cc8-dd92829c8623	9d68c25f-f59a-4c42-9365-5011780dea8e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:03:52
25405	9d68c25f-f300-4ae5-90d3-d3b4230997e3	9d68c25f-f59a-4c42-9365-5011780dea8e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:03:52
25406	9d68c25f-f39a-4cf2-be9c-593a2a83cf3d	9d68c25f-f59a-4c42-9365-5011780dea8e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1087,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:03:52
25489	9d68c67c-8f35-4cbb-b02b-ea83cf6f80cb	9d68c67c-9184-48c9-9782-6438ea71ef7e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":716,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:15:22
35885	9d69c80f-9218-467a-b4f8-42172b85049e	9d69c80f-9382-4234-b7b7-28b99e8d4cf0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/22","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}},"duration":394,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:15:35
36038	9d69c8d9-2efc-46b3-9fc1-59376bc2dd90	9d69c8d9-8db5-4b97-89fb-0c1d123d5491	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 22:17:48
36039	9d69c8d9-82d6-4bd3-8770-2d619ad6e3af	9d69c8d9-8db5-4b97-89fb-0c1d123d5491	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"176.89","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 22:17:48
36040	9d69c8d9-8b32-4c8f-b7d2-e7b5421a6f79	9d69c8d9-8db5-4b97-89fb-0c1d123d5491	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 22:17:48
25407	9d68c260-6842-4d6c-a2cf-443682d64094	9d68c260-8569-4752-b86d-eb7a0ee93380	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:03:52
25408	9d68c260-807d-46ee-ab78-25ebdbae0ec8	9d68c260-8569-4752-b86d-eb7a0ee93380	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:03:52
25409	9d68c260-80cd-444d-9f17-876cff1ce915	9d68c260-8569-4752-b86d-eb7a0ee93380	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:03:52
25410	9d68c260-8426-4ebb-b060-f6281c7ebf20	9d68c260-8569-4752-b86d-eb7a0ee93380	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:03:52
25411	9d68c260-846e-4b22-9b64-ea528211f14f	9d68c260-8569-4752-b86d-eb7a0ee93380	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:03:52
25490	9d68c67d-839f-4317-bbf5-1a0be87459a5	9d68c67d-c421-426f-96a0-c71e947a3441	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:15:22
25491	9d68c67d-b7ba-417f-8927-101c74bc3f39	9d68c67d-c421-426f-96a0-c71e947a3441	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"86.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:15:22
25492	9d68c67d-b85b-4c1b-a462-5861cffaee97	9d68c67d-c421-426f-96a0-c71e947a3441	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:15:22
25493	9d68c67d-c1fe-4508-bcd9-2048ca6b6713	9d68c67d-c421-426f-96a0-c71e947a3441	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:15:22
25494	9d68c67d-c2aa-4324-a5e9-031c221d6320	9d68c67d-c421-426f-96a0-c71e947a3441	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":759,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:15:22
35886	9d69c810-24ca-4e8c-b624-c8a7173b3e05	9d69c810-6097-4b44-bb81-892d1a2d2901	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 22:15:36
35887	9d69c810-5637-4f0a-9195-c9182269fa8c	9d69c810-6097-4b44-bb81-892d1a2d2901	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"78.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:15:36
35888	9d69c810-56dc-4b8d-a714-a8726eb8a7a7	9d69c810-6097-4b44-bb81-892d1a2d2901	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:15:36
35889	9d69c810-5e6c-4f75-b3d1-20ad2c09f475	9d69c810-6097-4b44-bb81-892d1a2d2901	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 22:15:36
25412	9d68c272-1b41-441e-a58e-245340b43ff3	9d68c272-37db-4518-916a-26864ce70137	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:04:04
25413	9d68c272-3347-4242-9dfc-c56b0bb1fc5b	9d68c272-37db-4518-916a-26864ce70137	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"44.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 10:04:04
25414	9d68c272-3656-4587-ba37-208f4b3e2383	9d68c272-37db-4518-916a-26864ce70137	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:04:04
25415	9d68c272-36d7-48dd-9590-a2574ad67d65	9d68c272-37db-4518-916a-26864ce70137	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":371,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:04:04
25495	9d68c67e-85e7-4827-83b4-9fbca98d022d	9d68c67e-b5f6-4116-b555-b26f9a6c7743	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:15:23
25496	9d68c67e-acfd-425d-b63b-ab8cf8530c25	9d68c67e-b5f6-4116-b555-b26f9a6c7743	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"61.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:15:23
25497	9d68c67e-ad7d-43f9-85c2-46f5f1939339	9d68c67e-b5f6-4116-b555-b26f9a6c7743	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:15:23
25498	9d68c67e-b3fb-4be9-be5f-3cc604c5d121	9d68c67e-b5f6-4116-b555-b26f9a6c7743	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:15:23
25499	9d68c67e-b480-407a-9a99-2dd3b305e30f	9d68c67e-b5f6-4116-b555-b26f9a6c7743	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":591,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:15:23
35890	9d69c810-5f0e-417b-bb8b-d52357ae4323	9d69c810-6097-4b44-bb81-892d1a2d2901	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":503,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:15:36
35891	9d69c810-f48e-40c4-9d45-54952670f4a5	9d69c811-233b-4732-b267-e6a15acabfac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 22:15:36
35892	9d69c811-19bb-4013-98f3-926d487fe95d	9d69c811-233b-4732-b267-e6a15acabfac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"61.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:15:36
35893	9d69c811-1a4c-48c4-b32d-5a902ab32e0d	9d69c811-233b-4732-b267-e6a15acabfac	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:15:36
35894	9d69c811-2134-4429-a9d5-9ca15eda63d9	9d69c811-233b-4732-b267-e6a15acabfac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 22:15:36
25585	9d68c72e-66e6-4963-bea6-7efec241f946	9d68c72e-846b-475e-a192-e87640d16e5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 10:17:18
25586	9d68c72e-82e7-4d11-aa5e-13302438a552	9d68c72e-846b-475e-a192-e87640d16e5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 10:17:18
25587	9d68c72e-837b-41f7-afa5-1cf7bb0eb211	9d68c72e-846b-475e-a192-e87640d16e5c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":383,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:17:18
35895	9d69c811-21bc-4e43-abfd-cdd9c9841b5f	9d69c811-233b-4732-b267-e6a15acabfac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":460,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:15:36
36041	9d69c8d9-8c2b-40ad-9dcb-b2c87c41286d	9d69c8d9-8db5-4b97-89fb-0c1d123d5491	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":628,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:17:48
25588	9d68c72f-16b7-4163-a3a7-0784da96758e	9d68c72f-380d-4696-8c8a-2877015133e2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 10:17:19
25589	9d68c72f-2e4e-4e90-96f9-a3980a3f70ea	9d68c72f-380d-4696-8c8a-2877015133e2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"44.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:17:19
25590	9d68c72f-3260-4a0e-99fa-8d9625130f18	9d68c72f-380d-4696-8c8a-2877015133e2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"1.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:17:19
25591	9d68c72f-329e-4b5f-92ed-fc9de6a7f61f	9d68c72f-380d-4696-8c8a-2877015133e2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:17:19
19504	9d66df2a-d435-4290-9422-296358ca7c15	9d66df2b-2450-472b-a18f-b2c29b6f173f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 11:32:43
19505	9d66df2b-20e7-464f-ba04-4d20d628b5d0	9d66df2b-2450-472b-a18f-b2c29b6f173f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:32:43
19506	9d66df2b-2292-4072-9b63-290237b81cf3	9d66df2b-2450-472b-a18f-b2c29b6f173f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":514,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:32:43
25592	9d68c72f-36da-46a6-ad58-027593f2e829	9d68c72f-380d-4696-8c8a-2877015133e2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 10:17:19
25593	9d68c72f-372c-41dc-a934-3f7243fe2017	9d68c72f-380d-4696-8c8a-2877015133e2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":380,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:17:19
35896	9d69c81f-2145-4504-804c-0bb1b733f6a4	9d69c81f-755c-42eb-ae5d-0b1cdbc3c382	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 22:15:46
35897	9d69c81f-6d7a-4b03-858b-6efde09eca42	9d69c81f-755c-42eb-ae5d-0b1cdbc3c382	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"178.94","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":26,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 22:15:46
35898	9d69c81f-733c-4ccf-ab25-893351d2c94e	9d69c81f-755c-42eb-ae5d-0b1cdbc3c382	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 22:15:46
36042	9d69c8da-155e-4419-b5f9-4e086779292e	9d69c8da-47c4-4d59-956a-f66018b8b689	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 22:17:48
36043	9d69c8da-40b8-4474-aab9-59ed9f199780	9d69c8da-47c4-4d59-956a-f66018b8b689	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"61.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:17:48
36044	9d69c8da-4144-4c65-adfa-3b7784dae456	9d69c8da-47c4-4d59-956a-f66018b8b689	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 22:17:48
36045	9d69c8da-45e0-4b8c-a61e-2dfe49448098	9d69c8da-47c4-4d59-956a-f66018b8b689	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 22:17:48
19507	9d66df2b-d351-41b0-a494-d4c1667382cb	9d66df2b-fa7d-4550-a2e5-abf6844df2b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:32:44
19508	9d66df2b-ee19-42d5-81dc-0cf88a2fab44	9d66df2b-fa7d-4550-a2e5-abf6844df2b1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"52.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 11:32:44
19509	9d66df2b-f2e8-4b29-959b-52f844c7cc07	9d66df2b-fa7d-4550-a2e5-abf6844df2b1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:32:44
19510	9d66df2b-f323-451f-9594-bf90dad9ece7	9d66df2b-fa7d-4550-a2e5-abf6844df2b1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:32:44
19511	9d66df2b-f8ec-45ad-9fed-92d099cb79c6	9d66df2b-fa7d-4550-a2e5-abf6844df2b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:32:44
19512	9d66df2b-f94f-4b7d-84bb-368013e0dcd6	9d66df2b-fa7d-4550-a2e5-abf6844df2b1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":427,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:32:44
35899	9d69c81f-73e4-4f6c-b521-a2dc37745050	9d69c81f-755c-42eb-ae5d-0b1cdbc3c382	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":417,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:15:46
22576	9d67e3d1-001e-4b9c-9f72-6e7e42ab6dd7	9d67e3d1-5857-45ed-8d4a-3cd7f31bff12	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 23:41:33
22577	9d67e3d1-53a4-4459-b94a-fc0b94db2050	9d67e3d1-5857-45ed-8d4a-3cd7f31bff12	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 23:41:33
22578	9d67e3d1-55a0-43b6-9bea-438d0eff4596	9d67e3d1-5857-45ed-8d4a-3cd7f31bff12	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1008,"memory":22,"hostname":"EderCortes"}	2024-11-03 23:41:33
36046	9d69c8da-4668-4a39-bcd2-58a804061719	9d69c8da-47c4-4d59-956a-f66018b8b689	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":452,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:17:48
19513	9d66df2e-0bd7-4227-98cd-e0fb63d7a09d	9d66df2e-54c9-4c7d-b161-fa2c92713283	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:32:45
19514	9d66df2e-4f9a-4c97-866c-d7eb8922f567	9d66df2e-54c9-4c7d-b161-fa2c92713283	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"152.66","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:32:45
19515	9d66df2e-4fe1-409b-85b8-efff18e9c472	9d66df2e-54c9-4c7d-b161-fa2c92713283	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:32:45
19516	9d66df2e-5368-4ee5-94b7-0069c7b828fc	9d66df2e-54c9-4c7d-b161-fa2c92713283	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 11:32:45
19517	9d66df2e-53af-480a-a497-08a67e8be3e0	9d66df2e-54c9-4c7d-b161-fa2c92713283	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":435,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:32:45
22579	9d67e3d2-3a0e-41b6-8014-85950754cc48	9d67e3d2-7811-4840-adc9-c03a0cf51444	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 23:41:33
22580	9d67e3d2-6329-44b7-84f7-d2d38acf25eb	9d67e3d2-7811-4840-adc9-c03a0cf51444	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 65\\n                        ","time":"66.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6768d7067397538897aacf4d73c43049","hostname":"EderCortes"}	2024-11-03 23:41:34
22581	9d67e3d2-6aba-45b4-a847-6345e762c472	9d67e3d2-7811-4840-adc9-c03a0cf51444	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '65' order by \\"item_loans\\".\\"id\\" asc","time":"3.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 23:41:34
22582	9d67e3d2-6b1d-4c17-8541-a1fa3131953c	9d67e3d2-7811-4840-adc9-c03a0cf51444	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 23:41:34
22583	9d67e3d2-759f-4255-9646-bd3afea2a4f5	9d67e3d2-7811-4840-adc9-c03a0cf51444	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 23:41:34
22584	9d67e3d2-765d-433a-8a0c-7bf1c6e1f74e	9d67e3d2-7811-4840-adc9-c03a0cf51444	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/65","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":65,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":3000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-10 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"90000"},"items":[{"id":207,"loans_codigo":65,"itemloans_cuota":"1","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:46:55.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"90000","itemloans_cuota_cancelada":"300000"},{"id":208,"loans_codigo":65,"itemloans_cuota":"2","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":209,"loans_codigo":65,"itemloans_cuota":"3","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":210,"loans_codigo":65,"itemloans_cuota":"4","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":211,"loans_codigo":65,"itemloans_cuota":"5","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":212,"loans_codigo":65,"itemloans_cuota":"6","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":213,"loans_codigo":65,"itemloans_cuota":"7","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":214,"loans_codigo":65,"itemloans_cuota":"8","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":215,"loans_codigo":65,"itemloans_cuota":"9","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":216,"loans_codigo":65,"itemloans_cuota":"10","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-09-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":595,"memory":22,"hostname":"EderCortes"}	2024-11-03 23:41:34
35900	9d69c81f-eee8-4098-a743-877a7b2c5e8e	9d69c820-120c-492b-aeed-538717d07c18	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 22:15:46
36047	9d69c8da-9129-4ee9-806f-e8dfd8d67f67	9d69c8da-af80-412d-bbeb-32e0ede98d4c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 22:17:48
36048	9d69c8da-aa38-4c9b-9c54-b9b5bf14a211	9d69c8da-af80-412d-bbeb-32e0ede98d4c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:17:49
36049	9d69c8da-aa93-4a5e-98b6-e875da25929f	9d69c8da-af80-412d-bbeb-32e0ede98d4c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 22:17:49
35901	9d69c820-0cce-4192-8afb-fb5be0bd3b51	9d69c820-120c-492b-aeed-538717d07c18	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"49.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 22:15:46
35902	9d69c820-1041-45e6-a61d-fc99a2408686	9d69c820-120c-492b-aeed-538717d07c18	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 22:15:46
35903	9d69c820-10ca-4ba4-80a9-a03f4fc77f6d	9d69c820-120c-492b-aeed-538717d07c18	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":368,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:15:46
36050	9d69c8da-ae3f-43ba-ba72-042381ce753c	9d69c8da-af80-412d-bbeb-32e0ede98d4c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 22:17:49
36051	9d69c8da-ae8c-4c3e-a846-18da7871eec3	9d69c8da-af80-412d-bbeb-32e0ede98d4c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:17:49
35904	9d69c820-80a7-49d0-a3d7-778931e64405	9d69c820-a1fe-4df3-b31c-eae6075aa536	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 22:15:47
35905	9d69c820-9cbc-4054-87c4-9bdce128d563	9d69c820-a1fe-4df3-b31c-eae6075aa536	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:15:47
29341	9d691890-76aa-4fa6-b36a-96f1111359a8	9d691890-cdf5-472e-ac23-a9872b4c4098	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 14:04:52
29342	9d691890-c96b-444a-b466-6e4d0ec1f13f	9d691890-cdf5-472e-ac23-a9872b4c4098	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 14:04:52
29343	9d691890-cb8f-48f9-bdfc-23bcd07cb1b9	9d691890-cdf5-472e-ac23-a9872b4c4098	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":586,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:04:52
35906	9d69c820-9d0b-4a5e-8a9f-e798fa5b6947	9d69c820-a1fe-4df3-b31c-eae6075aa536	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 22:15:47
35907	9d69c820-a0a8-4b70-b968-08bdd4dc866e	9d69c820-a1fe-4df3-b31c-eae6075aa536	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 22:15:47
35908	9d69c820-a0ed-4029-bdb1-98ec51af9e08	9d69c820-a1fe-4df3-b31c-eae6075aa536	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:15:47
36052	9d69c8db-aae2-447a-aeb6-152748fe848b	9d69c8db-fde8-4beb-8e66-8a1ed00466d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 22:17:49
36053	9d69c8db-f395-4a97-8c99-ab8e032a1799	9d69c8db-fde8-4beb-8e66-8a1ed00466d3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"111.43","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:17:49
36054	9d69c8db-f42c-4653-b5e6-dcafde27649b	9d69c8db-fde8-4beb-8e66-8a1ed00466d3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:17:49
36055	9d69c8db-fbb6-4c54-a2b9-71f18ca77bfd	9d69c8db-fde8-4beb-8e66-8a1ed00466d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 22:17:49
36056	9d69c8db-fc58-4f79-a206-3c30225e6f30	9d69c8db-fde8-4beb-8e66-8a1ed00466d3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":836,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:17:49
29344	9d691891-8ae6-4fa6-83ff-ab455b493186	9d691891-be85-4110-ae0b-7c0fdc2d5eb0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 14:04:53
29345	9d691891-b40b-4510-a000-534ec7522b77	9d691891-be85-4110-ae0b-7c0fdc2d5eb0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"65.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-04 14:04:53
29346	9d691891-b4a3-4350-84ef-36e0b4562513	9d691891-be85-4110-ae0b-7c0fdc2d5eb0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 14:04:53
29347	9d691891-bc6f-42ec-99f9-9e3bc2cf5549	9d691891-be85-4110-ae0b-7c0fdc2d5eb0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 14:04:53
29348	9d691891-bcfd-4055-aca8-8420fb71e109	9d691891-be85-4110-ae0b-7c0fdc2d5eb0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":499,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:04:53
35909	9d69c820-ed5f-42b7-89a3-cb151a35d9ba	9d69c821-0dbb-4128-a6d3-4d83195ff4f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 22:15:47
35910	9d69c821-08cf-4fdf-ac17-6adc57069f89	9d69c821-0dbb-4128-a6d3-4d83195ff4f2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:15:47
35911	9d69c821-0938-4ab9-bf15-5d3973a280d4	9d69c821-0dbb-4128-a6d3-4d83195ff4f2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 22:15:47
35912	9d69c821-0c7b-42b3-a931-15b549c3763e	9d69c821-0dbb-4128-a6d3-4d83195ff4f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 22:15:47
35913	9d69c821-0cc0-4594-b4db-afbfaeaf58cf	9d69c821-0dbb-4128-a6d3-4d83195ff4f2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":259,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:15:47
36057	9d69c8dc-87b6-44d0-b105-7fef28f91df1	9d69c8dc-b078-45f3-94fc-f1cbc6de3009	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 22:17:50
36058	9d69c8dc-a88a-4b12-8316-6139971314ca	9d69c8dc-b078-45f3-94fc-f1cbc6de3009	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"58.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:17:50
36059	9d69c8dc-a8f4-453b-b985-1c4004cc7c58	9d69c8dc-b078-45f3-94fc-f1cbc6de3009	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:17:50
36060	9d69c8dc-ae7c-4672-b8c4-38cda07fb68e	9d69c8dc-b078-45f3-94fc-f1cbc6de3009	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 22:17:50
36061	9d69c8dc-af07-48b9-90ce-72d9603b1a51	9d69c8dc-b078-45f3-94fc-f1cbc6de3009	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":430,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:17:50
29349	9d691892-8fe9-4744-89db-cb2c818965df	9d691892-d6b7-4838-9f65-fec979deb391	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 14:04:53
29350	9d691892-cb06-4a05-bf91-90cd0d4da634	9d691892-d6b7-4838-9f65-fec979deb391	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"105.93","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:04:54
29351	9d691892-cb94-4f6e-be0b-90ee852da93b	9d691892-d6b7-4838-9f65-fec979deb391	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:04:54
29352	9d691892-d384-43ef-adbc-ebb641b0be7f	9d691892-d6b7-4838-9f65-fec979deb391	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 14:04:54
29353	9d691892-d413-43b3-adc3-c559338e611d	9d691892-d6b7-4838-9f65-fec979deb391	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":684,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:04:54
29354	9d691893-deb9-4840-b2d0-5dd6426730b6	9d691894-1f95-447a-ad9b-d5b6908382f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 14:04:54
29355	9d691894-14bb-45ff-bb8c-da609d9d2631	9d691894-1f95-447a-ad9b-d5b6908382f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"94.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:04:54
29356	9d691894-1552-46be-9a16-1a1020ed18fb	9d691894-1f95-447a-ad9b-d5b6908382f0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:04:54
29357	9d691894-1ce9-414c-896a-e05ff57f0b3d	9d691894-1f95-447a-ad9b-d5b6908382f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 14:04:54
29358	9d691894-1d90-46e5-adea-0f078b1e9590	9d691894-1f95-447a-ad9b-d5b6908382f0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":814,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:04:54
36247	9d6b33bf-a500-4ba4-a9f5-1c4d417d6642	9d6b33bf-c724-455e-a4a7-a746f16d98fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 15:12:32
36248	9d6b33bf-c560-4c3a-a429-2009401d99de	9d6b33bf-c724-455e-a4a7-a746f16d98fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 15:12:32
36249	9d6b33bf-c5fb-454c-bc59-f8983ab1c5cf	9d6b33bf-c724-455e-a4a7-a746f16d98fb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":268,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:12:32
25679	9d68c7c6-7850-4fa8-a7c2-e00db58d5cc2	9d68c7c6-a9d3-4908-9f13-dff6c4cf531c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:18:58
25680	9d68c7c6-a6bd-496a-bacf-98aa7a865cb1	9d68c7c6-a9d3-4908-9f13-dff6c4cf531c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:18:58
25681	9d68c7c6-a80b-4488-b414-fc554a2e1778	9d68c7c6-a9d3-4908-9f13-dff6c4cf531c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":593,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:18:58
25682	9d68c7c7-637c-4ebe-a56f-d43f203e20d5	9d68c7c7-906e-4983-b358-045648d529be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:18:58
25683	9d68c7c7-87c5-474c-bfe1-73dfacfe6292	9d68c7c7-906e-4983-b358-045648d529be	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"65.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 10:18:59
25684	9d68c7c7-8e1a-4048-9783-b9f091b6dae4	9d68c7c7-906e-4983-b358-045648d529be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:18:59
25685	9d68c7c7-8ec7-4db8-8c4d-c52b67ac9eb0	9d68c7c7-906e-4983-b358-045648d529be	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":522,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:18:59
36250	9d6b33c0-1d08-4e04-b9bd-91a63f1ac013	9d6b33c0-3dc2-44fd-a25e-69d2d6dd6609	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 15:12:32
29491	9d692812-4aa5-4053-8a04-2c8683f1345e	9d692812-8c55-4c9c-997f-01dd8f189d4f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 14:48:14
29492	9d692812-890c-4634-bf4a-28831f952957	9d692812-8c55-4c9c-997f-01dd8f189d4f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 14:48:14
29493	9d692812-8aa5-47a6-8935-0133f445b9b2	9d692812-8c55-4c9c-997f-01dd8f189d4f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":596,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:48:14
36251	9d6b33c0-37b7-4d1e-adb6-a7816bb6566b	9d6b33c0-3dc2-44fd-a25e-69d2d6dd6609	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"49.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:12:32
29654	9d692a0b-3a4f-416b-9adc-7f6101b0021d	9d692a0b-591a-45dd-8e99-75ab4e5d3e7f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 14:53:45
29655	9d692a0b-5786-43af-9454-43381393b08d	9d692a0b-591a-45dd-8e99-75ab4e5d3e7f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 14:53:45
29656	9d692a0b-5823-414e-9157-9d0e82a93e4f	9d692a0b-591a-45dd-8e99-75ab4e5d3e7f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:53:45
36252	9d6b33c0-3c32-4c89-bc59-57edd95e4d59	9d6b33c0-3dc2-44fd-a25e-69d2d6dd6609	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 15:12:32
36253	9d6b33c0-3caf-4839-b7f4-f56a983ea01a	9d6b33c0-3dc2-44fd-a25e-69d2d6dd6609	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:12:32
25686	9d68c7c8-3575-4b5e-82b0-221ebe72a593	9d68c7c8-79d0-477a-90fd-d76db9d137bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:18:59
25687	9d68c7c8-6ba6-47f7-a622-d47e3ef1c59c	9d68c7c8-79d0-477a-90fd-d76db9d137bb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"102.18","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:18:59
25688	9d68c7c8-6c3a-4b6c-a0ce-f9df05e33c4e	9d68c7c8-79d0-477a-90fd-d76db9d137bb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:18:59
25689	9d68c7c8-7733-49d6-a532-a8a371376b79	9d68c7c8-79d0-477a-90fd-d76db9d137bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:18:59
25690	9d68c7c8-77f9-40fc-ba56-ee4a763f89a1	9d68c7c8-79d0-477a-90fd-d76db9d137bb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":581,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:18:59
29494	9d692813-62d6-4afe-9a53-93565023e9f5	9d692813-67c6-4441-b603-ec58d34012db	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user\\/12","method":"GET","controller_action":null,"middleware":[],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":404,"response":{"error":"No se encontro la url especificada","code":404},"duration":441,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:48:14
29657	9d692a0b-acaf-4be0-978b-797116b9a590	9d692a0b-cb65-42f8-864b-4ee7d7d04e0c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 14:53:45
29658	9d692a0b-c1b3-471d-9b4e-83fdf8c11507	9d692a0b-cb65-42f8-864b-4ee7d7d04e0c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"42.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 14:53:45
29659	9d692a0b-c5da-44a6-8e0d-3dd89ec8cafe	9d692a0b-cb65-42f8-864b-4ee7d7d04e0c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 14:53:45
29660	9d692a0b-c614-482a-9739-66adf9f357b2	9d692a0b-cb65-42f8-864b-4ee7d7d04e0c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 14:53:45
29661	9d692a0b-ca2f-4a92-9e54-a3afe5e721fd	9d692a0b-cb65-42f8-864b-4ee7d7d04e0c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 14:53:45
29662	9d692a0b-ca7f-4d70-ac6b-3e22517ab601	9d692a0b-cb65-42f8-864b-4ee7d7d04e0c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:53:45
36254	9d6b33c0-962e-4c1b-a499-2ec35a7522f1	9d6b33c0-e217-4217-bb9b-2020dcea3ae0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 15:12:33
25691	9d68c7c9-6f33-4d32-8003-54061566c260	9d68c7c9-c22c-44b1-b359-a57c5062f3e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:19:00
25692	9d68c7c9-b9db-40b7-b969-26c2195e62be	9d68c7c9-c22c-44b1-b359-a57c5062f3e1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"95.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:19:00
25693	9d68c7c9-ba58-4828-b813-706a7fd1a796	9d68c7c9-c22c-44b1-b359-a57c5062f3e1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:19:00
25694	9d68c7c9-c02d-4264-963d-ec53ba20363e	9d68c7c9-c22c-44b1-b359-a57c5062f3e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:19:00
25695	9d68c7c9-c0bc-4b01-9cde-7442a1ef2009	9d68c7c9-c22c-44b1-b359-a57c5062f3e1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":765,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:19:00
36255	9d6b33c0-dca7-4aab-9902-2239f32ed0d6	9d6b33c0-e217-4217-bb9b-2020dcea3ae0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"154.75","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:12:33
36256	9d6b33c0-dd1c-4517-aa9d-2176329397f8	9d6b33c0-e217-4217-bb9b-2020dcea3ae0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:12:33
25773	9d68c900-9e81-4c3c-af42-65cd4ddf09e8	9d68c900-df12-4100-ab36-70927dd1a86f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 10:22:24
25774	9d68c900-db5b-4f84-af5f-17995528a01c	9d68c900-df12-4100-ab36-70927dd1a86f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 10:22:24
25775	9d68c900-dd17-42fa-99ca-9e29e8a3388c	9d68c900-df12-4100-ab36-70927dd1a86f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":668,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:22:24
36257	9d6b33c0-e0d5-4c48-9218-f5ae334977b6	9d6b33c0-e217-4217-bb9b-2020dcea3ae0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 15:12:33
36258	9d6b33c0-e117-467e-9b62-a19b1578250b	9d6b33c0-e217-4217-bb9b-2020dcea3ae0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":410,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:12:33
25696	9d68c811-341b-40ba-b7a5-d6b5fdff7b57	9d68c811-5963-4eaa-bc1a-5eb05b826329	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:19:47
25697	9d68c811-4df2-4aea-8aa7-58affcce2215	9d68c811-5963-4eaa-bc1a-5eb05b826329	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 90\\n                        ","time":"49.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"93c10371e33ace24260de21c3ff3890d","hostname":"EderCortes"}	2024-11-04 10:19:47
25698	9d68c811-5295-4831-a4e1-77e46d920f0e	9d68c811-5963-4eaa-bc1a-5eb05b826329	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"2.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:19:47
25699	9d68c811-52d8-48b2-b38f-4acc92fd6bf4	9d68c811-5963-4eaa-bc1a-5eb05b826329	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 10:19:47
25700	9d68c811-57d1-47d3-8ede-a94f40e5f1c2	9d68c811-5963-4eaa-bc1a-5eb05b826329	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:19:47
25701	9d68c811-583a-422b-bb1b-0ced02a981c3	9d68c811-5963-4eaa-bc1a-5eb05b826329	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"}]}},"duration":442,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:19:47
25776	9d68c901-bbff-4781-940e-ee9d6313fef9	9d68c902-139d-4d5c-be02-5612010039be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 10:22:24
25777	9d68c902-03a5-490e-9150-52951b5ba213	9d68c902-139d-4d5c-be02-5612010039be	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 90\\n                        ","time":"163.69","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"93c10371e33ace24260de21c3ff3890d","hostname":"EderCortes"}	2024-11-04 10:22:25
25778	9d68c902-09f6-4f38-87a5-f80987afb986	9d68c902-139d-4d5c-be02-5612010039be	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"3.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:22:25
25779	9d68c902-0a46-40be-921b-14271b965438	9d68c902-139d-4d5c-be02-5612010039be	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 10:22:25
25780	9d68c902-1184-46fb-964d-26df1807cc7b	9d68c902-139d-4d5c-be02-5612010039be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 10:22:25
36259	9d6b33c1-289b-472d-83f1-bfaf55803cf5	9d6b33c1-6e22-4f19-840a-95ffc52c8b8d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 15:12:33
36260	9d6b33c1-6881-4ad2-9ab7-fc231a3a58fd	9d6b33c1-6e22-4f19-840a-95ffc52c8b8d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"141.91","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:12:33
25781	9d68c902-121d-4f2c-81fb-53e1f3970063	9d68c902-139d-4d5c-be02-5612010039be	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"}]}},"duration":695,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:22:25
36261	9d6b33c1-68e6-474a-b7e2-d0db7fe0416a	9d6b33c1-6e22-4f19-840a-95ffc52c8b8d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:12:33
36262	9d6b33c1-6cac-400a-97b6-76695a2bc8fc	9d6b33c1-6e22-4f19-840a-95ffc52c8b8d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 15:12:33
36263	9d6b33c1-6cf6-4bf5-81cc-9b6d98abf3f7	9d6b33c1-6e22-4f19-840a-95ffc52c8b8d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":338,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:12:33
25782	9d68c902-f858-4d50-9f77-717f7de725ba	9d68c903-5b1d-4d79-8767-371d5ed6a070	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 10:22:25
25783	9d68c903-4f2c-4586-85f4-58b17cc6c186	9d68c903-5b1d-4d79-8767-371d5ed6a070	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"178.28","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:22:25
25784	9d68c903-4fb9-4dac-9e27-05d52593052b	9d68c903-5b1d-4d79-8767-371d5ed6a070	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:22:25
25785	9d68c903-589f-4357-ad2b-45c0259ac472	9d68c903-5b1d-4d79-8767-371d5ed6a070	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 10:22:25
25786	9d68c903-5963-4cbd-a414-ec21e7625cba	9d68c903-5b1d-4d79-8767-371d5ed6a070	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":813,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:22:25
36264	9d6b33c2-a544-4738-96f2-7a360605db7f	9d6b33c2-ec75-428e-a197-dac48427131d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 15:12:34
36265	9d6b33c2-e6e7-435c-8ad4-91b82f25d6eb	9d6b33c2-ec75-428e-a197-dac48427131d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"146.21","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:12:34
36266	9d6b33c2-e745-46d3-8b50-d27f915830ab	9d6b33c2-ec75-428e-a197-dac48427131d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:12:34
36267	9d6b33c2-eade-4583-94b0-c486cacd8a34	9d6b33c2-ec75-428e-a197-dac48427131d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 15:12:34
36268	9d6b33c2-eb47-495b-8f74-b2f23f0a07b5	9d6b33c2-ec75-428e-a197-dac48427131d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:12:34
36408	9d6b3a1f-ab8e-4f6a-9db8-5a066d7656e7	9d6b3a1f-cfe7-4a75-ba85-4a51f4dfa02a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:30:22
36409	9d6b3a1f-cd29-46b0-960d-60b1c0607595	9d6b3a1f-cfe7-4a75-ba85-4a51f4dfa02a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 15:30:22
36410	9d6b3a1f-ce71-4f37-8b2b-9e0434d14806	9d6b3a1f-cfe7-4a75-ba85-4a51f4dfa02a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:30:22
25787	9d68c904-46b2-4855-949d-401d84c0b5a8	9d68c904-78f6-48e8-80b7-42acafa5d41b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 10:22:26
25788	9d68c904-6f05-490d-b741-0f6972f53255	9d68c904-78f6-48e8-80b7-42acafa5d41b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"68.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:22:26
25789	9d68c904-6f86-4d75-9c85-d5275200b32b	9d68c904-78f6-48e8-80b7-42acafa5d41b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:22:26
25790	9d68c904-76e7-462c-9e60-3c43e9dd65e1	9d68c904-78f6-48e8-80b7-42acafa5d41b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 10:22:26
25791	9d68c904-7779-48e9-bee4-74e893ea9e74	9d68c904-78f6-48e8-80b7-42acafa5d41b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":704,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:22:26
36411	9d6b3a20-33b8-4b6b-b3bd-c0f57972775c	9d6b3a20-527e-49e4-8e5d-d4df9240cb93	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 15:30:22
36412	9d6b3a20-4d3d-49eb-a363-b6382be78dab	9d6b3a20-527e-49e4-8e5d-d4df9240cb93	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"46.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:30:22
29567	9d69293d-fb02-4b94-a431-2bf82ad0f7e9	9d69293e-577c-4c72-b201-ab6a75285aea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 14:51:30
29568	9d69293e-5413-44d7-bfa6-44675aed04e9	9d69293e-577c-4c72-b201-ab6a75285aea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 14:51:30
29569	9d69293e-55fb-46e6-b1ff-c236628cbf75	9d69293e-577c-4c72-b201-ab6a75285aea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":423,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:51:30
36413	9d6b3a20-5094-41be-9d83-3a35096ff392	9d6b3a20-527e-49e4-8e5d-d4df9240cb93	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 15:30:22
36414	9d6b3a20-5137-44c0-8879-e375a9606b28	9d6b3a20-527e-49e4-8e5d-d4df9240cb93	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":260,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:30:22
29570	9d69293e-d272-4a3f-b6f0-396be092c53e	9d69293f-1f72-495a-99a7-952d191a4ca7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 14:51:31
29571	9d69293f-14a4-4982-89b6-4226cdde7fbe	9d69293f-1f72-495a-99a7-952d191a4ca7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"154.20","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 14:51:31
29572	9d69293f-18ec-44ca-978e-c81ad0b5daec	9d69293f-1f72-495a-99a7-952d191a4ca7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"1.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 14:51:31
29573	9d69293f-1938-4067-90d3-169d95e8e90b	9d69293f-1f72-495a-99a7-952d191a4ca7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 14:51:31
29574	9d69293f-1dd7-4f67-a6ef-4e8049afdde0	9d69293f-1f72-495a-99a7-952d191a4ca7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 14:51:31
29575	9d69293f-1e4d-4cf6-a7c5-8c4a98c6ed4c	9d69293f-1f72-495a-99a7-952d191a4ca7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":385,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:51:31
36415	9d6b3a20-ac99-4b0c-90a7-ccc37f82e50e	9d6b3a20-cbf6-44ee-946c-fcd7539d23da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 15:30:22
36416	9d6b3a20-c6da-4fe7-90ff-4612f13745d8	9d6b3a20-cbf6-44ee-946c-fcd7539d23da	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:30:22
36417	9d6b3a20-c732-4590-aa3e-d149899e5c9e	9d6b3a20-cbf6-44ee-946c-fcd7539d23da	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:30:22
36418	9d6b3a20-caa6-450c-8fc3-4fb44644c5c6	9d6b3a20-cbf6-44ee-946c-fcd7539d23da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 15:30:22
36419	9d6b3a20-caf7-40ba-933d-fa778c4ae1a3	9d6b3a20-cbf6-44ee-946c-fcd7539d23da	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":301,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:30:22
36420	9d6b3a21-127d-4874-8b53-61186fb65b1d	9d6b3a21-313f-487d-ac85-90760452c531	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 15:30:23
36421	9d6b3a21-2c07-4da5-bde2-a0b4daf4244f	9d6b3a21-313f-487d-ac85-90760452c531	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:30:23
36422	9d6b3a21-2c5f-4b2c-902b-1b70574e1038	9d6b3a21-313f-487d-ac85-90760452c531	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:30:23
36423	9d6b3a21-301c-4360-91ca-a21f41a0e133	9d6b3a21-313f-487d-ac85-90760452c531	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 15:30:23
18785	9d669beb-d8ae-49bd-8e03-e64114610a49	9d669bec-27b0-4f01-b355-99aef59663ff	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 08:24:41
18786	9d669bec-24c9-4911-9368-08464f232e79	9d669bec-27b0-4f01-b355-99aef59663ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:24:41
18787	9d669bec-25e9-498c-a640-80fa1cde5a67	9d669bec-27b0-4f01-b355-99aef59663ff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":400,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:24:41
36424	9d6b3a21-3064-4abd-92d7-a898566946c5	9d6b3a21-313f-487d-ac85-90760452c531	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:30:23
36425	9d6b3a22-0b54-4b8e-b032-f312882b459c	9d6b3a22-2b6d-4bed-8db5-c18845e2703b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 15:30:23
36426	9d6b3a22-2673-4439-a9a7-df03b3660822	9d6b3a22-2b6d-4bed-8db5-c18845e2703b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"47.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:30:23
36427	9d6b3a22-26d2-4817-be6b-f0dc2625fc33	9d6b3a22-2b6d-4bed-8db5-c18845e2703b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:30:23
36428	9d6b3a22-2a15-4616-b957-2ad74641473f	9d6b3a22-2b6d-4bed-8db5-c18845e2703b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 15:30:23
36429	9d6b3a22-2a5e-468e-8c3b-c32cc61c65ff	9d6b3a22-2b6d-4bed-8db5-c18845e2703b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:30:23
36725	9d6b3e99-67a8-4a36-bb05-28b0c5d3466f	9d6b3e99-8d14-4f47-a388-58808bcb3f40	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 15:42:53
36726	9d6b3e99-8ab8-48a3-b9d6-5e8af25b345f	9d6b3e99-8d14-4f47-a388-58808bcb3f40	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:42:53
36727	9d6b3e99-8bf0-4620-bc33-ad61e26480f4	9d6b3e99-8d14-4f47-a388-58808bcb3f40	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":287,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:42:53
36728	9d6b3e9a-01fb-4964-85c3-6de4eedf5b3f	9d6b3e9a-21ae-4840-8e53-07bff81c4539	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:42:53
36729	9d6b3e9a-1c18-47ae-a2e2-7bca1aaafca4	9d6b3e9a-21ae-4840-8e53-07bff81c4539	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"46.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:42:53
36730	9d6b3e9a-1ff0-4766-a443-f27d9db459c1	9d6b3e9a-21ae-4840-8e53-07bff81c4539	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:42:53
36731	9d6b3e9a-2074-42bd-be2c-bbd6c7a8b18e	9d6b3e9a-21ae-4840-8e53-07bff81c4539	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":278,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:42:53
36732	9d6b3e9a-718d-45aa-9e2c-ab7dc5d3a535	9d6b3e9a-9383-49b1-8ace-58ebab7164c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:42:53
36733	9d6b3e9a-8e2b-4505-9705-58044a6ff294	9d6b3e9a-9383-49b1-8ace-58ebab7164c8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:42:53
36734	9d6b3e9a-8e7c-44bf-aa74-a99271615606	9d6b3e9a-9383-49b1-8ace-58ebab7164c8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:42:53
36735	9d6b3e9a-9211-41b9-9015-2292486968e6	9d6b3e9a-9383-49b1-8ace-58ebab7164c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:42:53
36736	9d6b3e9a-9255-4275-ae59-e68d101d9212	9d6b3e9a-9383-49b1-8ace-58ebab7164c8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":281,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:42:53
36569	9d6b3d58-fa89-4bfc-b218-cd5923fd40bd	9d6b3d59-1f60-4c1f-979e-8001b9d2b2a5	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 15:39:23
36570	9d6b3d59-1d2f-48ac-ac87-f0c2370ef449	9d6b3d59-1f60-4c1f-979e-8001b9d2b2a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:39:23
36571	9d6b3d59-1e54-4ba4-8a21-ae36f9a382e3	9d6b3d59-1f60-4c1f-979e-8001b9d2b2a5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:39:23
36737	9d6b3e9a-d942-413e-9373-de9b1d36ced0	9d6b3e9a-f782-479c-af21-ec985373fce8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:42:53
36738	9d6b3e9a-f224-4349-b3c7-c9b37bb41fc0	9d6b3e9a-f782-479c-af21-ec985373fce8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:42:54
36739	9d6b3e9a-f26f-4646-be92-2ebcbb560045	9d6b3e9a-f782-479c-af21-ec985373fce8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:42:54
36740	9d6b3e9a-f652-4515-aa6e-9284650fc564	9d6b3e9a-f782-479c-af21-ec985373fce8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:42:54
36572	9d6b3d59-84dc-48ae-a3ff-766a89bde63e	9d6b3d59-a53c-4638-8518-4a463dac2936	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:39:23
36573	9d6b3d59-9e42-4b32-acc3-a7f7d52454ed	9d6b3d59-a53c-4638-8518-4a463dac2936	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"47.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:39:23
36574	9d6b3d59-a39c-4f6e-8f1b-6a78bb487cee	9d6b3d59-a53c-4638-8518-4a463dac2936	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:39:23
36575	9d6b3d59-a41d-4caa-ae8b-6ded92009718	9d6b3d59-a53c-4638-8518-4a463dac2936	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":283,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:39:23
36741	9d6b3e9a-f698-4924-9a59-d40d75ed5bad	9d6b3e9a-f782-479c-af21-ec985373fce8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":242,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:42:54
36576	9d6b3d59-fb78-4136-a386-307d9bde7850	9d6b3d5a-26b0-434e-82a7-e5e053f343fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:39:23
36577	9d6b3d5a-1fb3-4f3c-8f44-84b35e6de6e3	9d6b3d5a-26b0-434e-82a7-e5e053f343fe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"51.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:39:23
36578	9d6b3d5a-2004-4d73-8e89-a1eb7a7acc55	9d6b3d5a-26b0-434e-82a7-e5e053f343fe	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:39:23
36579	9d6b3d5a-2519-41ff-8c3c-c205a7649019	9d6b3d5a-26b0-434e-82a7-e5e053f343fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:39:23
36580	9d6b3d5a-2584-46e8-a6be-2f1ed22222f9	9d6b3d5a-26b0-434e-82a7-e5e053f343fe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":315,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:39:23
36742	9d6b3e9c-790d-42fc-a831-2a1480b62521	9d6b3e9c-aed9-4f09-96b1-9fe74f0b74ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:42:55
36743	9d6b3e9c-a54f-45db-b534-33654ae24125	9d6b3e9c-aed9-4f09-96b1-9fe74f0b74ba	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"71.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:42:55
36744	9d6b3e9c-a647-4cd1-95d9-9e6c5877b747	9d6b3e9c-aed9-4f09-96b1-9fe74f0b74ba	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:42:55
36745	9d6b3e9c-ad56-4510-8f15-217f86892f13	9d6b3e9c-aed9-4f09-96b1-9fe74f0b74ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:42:55
36746	9d6b3e9c-adb1-43c5-ad64-e160aec185a0	9d6b3e9c-aed9-4f09-96b1-9fe74f0b74ba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":469,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:42:55
36581	9d6b3d5a-70aa-49cd-8e89-762f81673a3c	9d6b3d5a-8ef8-424f-8f61-0a53a8facff9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:39:23
36582	9d6b3d5a-89e1-4671-be4e-676075c8217a	9d6b3d5a-8ef8-424f-8f61-0a53a8facff9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:39:24
36583	9d6b3d5a-8a2a-4c5b-9339-573bc085bfe9	9d6b3d5a-8ef8-424f-8f61-0a53a8facff9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:39:24
36584	9d6b3d5a-8da6-4c29-8f69-d6db095d9f5a	9d6b3d5a-8ef8-424f-8f61-0a53a8facff9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:39:24
29770	9d692b17-90a2-4e79-af4a-ea8f45dad828	9d692b17-af7b-47c8-90fd-73be7fc5fb7c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 14:56:40
29771	9d692b17-adcb-4b13-8e82-c18ef2ebd396	9d692b17-af7b-47c8-90fd-73be7fc5fb7c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 14:56:40
29772	9d692b17-ae77-4b0a-9c84-661c68e729c4	9d692b17-af7b-47c8-90fd-73be7fc5fb7c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":242,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:56:40
36585	9d6b3d5a-8df8-4389-80e0-3c37e6ffc3a3	9d6b3d5a-8ef8-424f-8f61-0a53a8facff9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:39:24
29773	9d692b17-fce1-434d-8438-a29d3ceeb726	9d692b18-4645-47fe-8a67-a71eac788a32	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 14:56:41
29774	9d692b18-3d6c-4b16-8b16-d4977de46320	9d692b18-4645-47fe-8a67-a71eac788a32	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"150.47","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 14:56:41
29775	9d692b18-4173-458d-8639-f1720e14731a	9d692b18-4645-47fe-8a67-a71eac788a32	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 14:56:41
29776	9d692b18-41c3-4d43-b933-6f8e96b60e74	9d692b18-4645-47fe-8a67-a71eac788a32	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 14:56:41
29777	9d692b18-4523-4ad4-84a1-97706ca89449	9d692b18-4645-47fe-8a67-a71eac788a32	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 14:56:41
29778	9d692b18-456a-456a-8145-3969c7a9090b	9d692b18-4645-47fe-8a67-a71eac788a32	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":337,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:56:41
25923	9d68cb51-d987-49bf-9fdc-233bbcbbb9da	9d68cb52-13b9-466c-a3a6-be961e4bc805	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 10:28:52
25924	9d68cb52-10c3-4e74-bf25-798a0d014f4a	9d68cb52-13b9-466c-a3a6-be961e4bc805	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 10:28:53
25925	9d68cb52-1221-45e4-9681-67827fecfc42	9d68cb52-13b9-466c-a3a6-be961e4bc805	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":611,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:28:53
29605	9d6929ca-e554-4750-b561-f72c2c5a776b	9d6929ca-eabe-4f4d-8b31-0000ea855b80	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1397}	2024-11-04 14:53:02
6449	9d52d144-79f5-4ef5-8786-af2b2572aa5f	9d52d144-9085-4e69-b691-d70e75abcaad	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":334}	2024-10-24 12:17:18
25926	9d68cb52-d10b-4874-b9a1-697ed13be49a	9d68cb53-0307-43fc-b2f4-4b7029a0fa50	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 10:28:53
25927	9d68cb52-f609-40e5-ba57-8407561e7f2a	9d68cb53-0307-43fc-b2f4-4b7029a0fa50	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 90\\n                        ","time":"62.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"93c10371e33ace24260de21c3ff3890d","hostname":"EderCortes"}	2024-11-04 10:28:53
25928	9d68cb52-faf1-42c8-9874-d51230dc308b	9d68cb53-0307-43fc-b2f4-4b7029a0fa50	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"3.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:28:53
25929	9d68cb52-fb40-4d22-90a6-6aff87b025d3	9d68cb53-0307-43fc-b2f4-4b7029a0fa50	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 10:28:53
25930	9d68cb53-0145-4252-8d1e-666951579122	9d68cb53-0307-43fc-b2f4-4b7029a0fa50	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 10:28:53
25931	9d68cb53-01c1-41a3-bb38-783702e7d92b	9d68cb53-0307-43fc-b2f4-4b7029a0fa50	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"}]}},"duration":537,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:28:53
25932	9d68cb54-5519-4fff-a218-52c440e3c28f	9d68cb54-9cd3-4628-a06a-20b68b980bef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 10:28:54
19710	9d66e464-0039-4959-ac30-40b4bc838491	9d66e464-52f2-4e95-9f87-a02d12db9ffe	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 11:47:19
19711	9d66e464-5042-4e48-8a0c-b4033f3e6bdc	9d66e464-52f2-4e95-9f87-a02d12db9ffe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:47:20
19712	9d66e464-51b8-4742-9697-7f9c281a17cd	9d66e464-52f2-4e95-9f87-a02d12db9ffe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":421,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:47:20
25933	9d68cb54-91fc-46e6-a02c-f5f519213fdf	9d68cb54-9cd3-4628-a06a-20b68b980bef	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"105.55","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:28:54
25934	9d68cb54-929e-4fdb-82ef-03e23d77dcc4	9d68cb54-9cd3-4628-a06a-20b68b980bef	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:28:54
25935	9d68cb54-9ac5-4879-99be-af8dd8f00217	9d68cb54-9cd3-4628-a06a-20b68b980bef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 10:28:54
25936	9d68cb54-9b4f-49e0-a67c-003dbbeb12cb	9d68cb54-9cd3-4628-a06a-20b68b980bef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1027,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:28:54
29847	9d692bf1-872e-4bbb-99da-89d733aa7a6b	9d692bf1-a776-4082-a15e-4dc8f7cba0bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 14:59:03
29848	9d692bf1-a5b7-45b6-9a74-9442952983ff	9d692bf1-a776-4082-a15e-4dc8f7cba0bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 14:59:03
29849	9d692bf1-a665-412c-9563-aa592c3bfa1e	9d692bf1-a776-4082-a15e-4dc8f7cba0bb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":261,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:59:03
19713	9d66e464-c58e-42e1-8357-8f580daa07d0	9d66e465-11ec-4bdc-805a-1304044d9821	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:47:20
19714	9d66e465-075e-4d33-aa8f-e42b9136b311	9d66e465-11ec-4bdc-805a-1304044d9821	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"154.65","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 11:47:20
19715	9d66e465-0bb5-4dd8-8dda-2a4236fd7052	9d66e465-11ec-4bdc-805a-1304044d9821	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:47:20
19716	9d66e465-0bf6-47d8-8917-31f3e5245bac	9d66e465-11ec-4bdc-805a-1304044d9821	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:47:20
19717	9d66e465-1035-4cc7-b556-85fa7cc1249c	9d66e465-11ec-4bdc-805a-1304044d9821	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:47:20
19718	9d66e465-10aa-4ca6-9561-4e8c631c19a0	9d66e465-11ec-4bdc-805a-1304044d9821	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":null,"loans_pago_interes":null},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":440,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:47:20
25937	9d68cb55-70bf-443e-8b29-af1a370d6084	9d68cb55-b267-4fd0-bdfc-d8c36b80a93e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 10:28:55
25938	9d68cb55-a712-4deb-97e8-0520e9ab463f	9d68cb55-b267-4fd0-bdfc-d8c36b80a93e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"76.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:28:55
25939	9d68cb55-a7c0-494b-abfe-189b6a34d20a	9d68cb55-b267-4fd0-bdfc-d8c36b80a93e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:28:55
25940	9d68cb55-affa-4447-8ef8-c3837fa69b50	9d68cb55-b267-4fd0-bdfc-d8c36b80a93e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 10:28:55
25941	9d68cb55-b09d-44c7-9e32-ef7350221b79	9d68cb55-b267-4fd0-bdfc-d8c36b80a93e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":685,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:28:55
29850	9d692bf1-fb60-4c26-8f41-9da38a189ae3	9d692bf2-1bd0-42f5-8512-d6cdf5ab7215	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 14:59:04
19719	9d66e467-27aa-45b5-8474-a054db9beb55	9d66e467-6975-457b-b6d9-472d85929190	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:47:21
19720	9d66e467-5f41-4c18-927b-774e3ff027c3	9d66e467-6975-457b-b6d9-472d85929190	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"67.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:47:22
19721	9d66e467-5ff0-4048-ba3d-835c7448baed	9d66e467-6975-457b-b6d9-472d85929190	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:47:22
19722	9d66e467-67b0-46ba-abda-dfaf58e0c214	9d66e467-6975-457b-b6d9-472d85929190	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 11:47:22
19723	9d66e467-683f-4062-af84-ab7b2a2f7a2f	9d66e467-6975-457b-b6d9-472d85929190	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":729,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:47:22
29851	9d692bf2-12c1-4bd5-86da-f911b737bb0b	9d692bf2-1bd0-42f5-8512-d6cdf5ab7215	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"46.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 14:59:04
29852	9d692bf2-16c6-4609-8e93-e85fc82dd778	9d692bf2-1bd0-42f5-8512-d6cdf5ab7215	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"1.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 14:59:04
29853	9d692bf2-16fb-439b-828a-4cd2ebdfaefd	9d692bf2-1bd0-42f5-8512-d6cdf5ab7215	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 14:59:04
29854	9d692bf2-1a9e-445d-a78a-5aaf5a50057a	9d692bf2-1bd0-42f5-8512-d6cdf5ab7215	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 14:59:04
29855	9d692bf2-1aec-4ab5-b74f-39b5c9e5c6cc	9d692bf2-1bd0-42f5-8512-d6cdf5ab7215	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:59:04
36909	9d6b4239-a617-42a7-829d-3d46bec821ee	9d6b4239-c99b-42fe-a019-0293759b4be7	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 15:53:01
36910	9d6b4239-c783-4da5-9129-9a2f4bdce05f	9d6b4239-c99b-42fe-a019-0293759b4be7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:53:01
36911	9d6b4239-c843-45c5-a2e5-32b1cbc872dd	9d6b4239-c99b-42fe-a019-0293759b4be7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":290,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:53:01
36912	9d6b423a-459f-421d-83ab-1ff0db40049e	9d6b423a-624f-4adc-b6ed-f40d9873bac5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:53:01
36913	9d6b423a-5d50-4693-96c7-0e317ba848cd	9d6b423a-624f-4adc-b6ed-f40d9873bac5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"43.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:53:01
36914	9d6b423a-610b-4cbf-81e3-fa756d233c35	9d6b423a-624f-4adc-b6ed-f40d9873bac5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:53:01
36915	9d6b423a-6174-4852-9743-125041252741	9d6b423a-624f-4adc-b6ed-f40d9873bac5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":264,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:53:01
37001	9d6b4452-1e86-450f-8c97-cf0c1b861ce5	9d6b4452-486d-478a-b6cf-9f7b22465904	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 15:58:52
37002	9d6b4452-4665-49ad-8dc4-0d532044b770	9d6b4452-486d-478a-b6cf-9f7b22465904	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:58:53
37003	9d6b4452-472e-4a6c-858d-da6dfe62c2fb	9d6b4452-486d-478a-b6cf-9f7b22465904	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:58:53
36916	9d6b423a-ab6b-4731-9445-2a727586f55d	9d6b423a-f57f-4522-85c4-651808c86d26	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:53:02
36917	9d6b423a-f0b4-4eed-8e49-dcf7020540e7	9d6b423a-f57f-4522-85c4-651808c86d26	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"150.85","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:53:02
26043	9d68cd35-735f-4b2a-95f9-2ffaee9020d9	9d68cd35-f0dd-4a5d-a146-9ecb81b97de7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 10:34:09
26044	9d68cd35-ed9e-46b5-80f2-8c2e472870a8	9d68cd35-f0dd-4a5d-a146-9ecb81b97de7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 10:34:10
26045	9d68cd35-eef8-4865-b624-5613cbf60add	9d68cd35-f0dd-4a5d-a146-9ecb81b97de7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":945,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:34:10
36918	9d6b423a-f10f-443d-abaa-6f1590094994	9d6b423a-f57f-4522-85c4-651808c86d26	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:53:02
36919	9d6b423a-f43e-4262-9833-96af0e7e81ad	9d6b423a-f57f-4522-85c4-651808c86d26	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:53:02
36920	9d6b423a-f4a1-48ff-98aa-f836f3e1e0d8	9d6b423a-f57f-4522-85c4-651808c86d26	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":368,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:53:02
37004	9d6b4452-cd9d-4308-8427-c6731014ebd7	9d6b4453-153f-454f-b439-cffcc212c268	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:58:53
37005	9d6b4453-0f17-43d3-a06e-62aa30d18227	9d6b4453-153f-454f-b439-cffcc212c268	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"148.37","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:58:53
37006	9d6b4453-1346-4e83-a304-03e60f956460	9d6b4453-153f-454f-b439-cffcc212c268	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:58:53
37007	9d6b4453-13f7-484a-9772-d7b2c0b0c59e	9d6b4453-153f-454f-b439-cffcc212c268	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":402,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:58:53
26046	9d68cd37-12d2-4169-9795-84c7b29ecef1	9d68cd37-3c16-41b1-b8bb-5001162fd271	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 10:34:10
26047	9d68cd37-302e-447d-b82a-29052ee61e64	9d68cd37-3c16-41b1-b8bb-5001162fd271	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"56.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:34:11
26048	9d68cd37-3448-4b8d-971a-a65fa956350c	9d68cd37-3c16-41b1-b8bb-5001162fd271	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:34:11
26049	9d68cd37-348f-49e2-826e-fcaa5ad2749d	9d68cd37-3c16-41b1-b8bb-5001162fd271	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:34:11
26050	9d68cd37-3a78-4d58-ae1d-33d1843c238f	9d68cd37-3c16-41b1-b8bb-5001162fd271	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 10:34:11
26051	9d68cd37-3ad6-4c72-a3ab-a824b3b282e0	9d68cd37-3c16-41b1-b8bb-5001162fd271	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":774,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:34:11
26052	9d68cd38-3204-40e5-96d6-4637d72a117a	9d68cd38-8654-4f1f-a6a2-074740d6d9fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 10:34:11
26053	9d68cd38-7840-42cb-9147-710f1e5ea64e	9d68cd38-8654-4f1f-a6a2-074740d6d9fd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"118.35","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:34:11
26054	9d68cd38-78d4-4a4b-a63d-e3aaeaf72d0c	9d68cd38-8654-4f1f-a6a2-074740d6d9fd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:34:11
26055	9d68cd38-82e2-48f0-94e0-83b395f0f1d5	9d68cd38-8654-4f1f-a6a2-074740d6d9fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 10:34:11
26056	9d68cd38-83fe-4a99-8e03-0beabe9a6443	9d68cd38-8654-4f1f-a6a2-074740d6d9fd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":818,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:34:11
36921	9d6b423b-37b5-40cf-8f48-f06c6e2bc724	9d6b423b-5388-4373-8491-be6921de757e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:53:02
36922	9d6b423b-4e69-4a82-bdad-7d73cff6d3e4	9d6b423b-5388-4373-8491-be6921de757e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"38.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:53:02
36923	9d6b423b-4eae-430f-a12c-fdb48b8c15e0	9d6b423b-5388-4373-8491-be6921de757e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:53:02
36924	9d6b423b-5267-4a70-89bb-e8d0e19c4e7f	9d6b423b-5388-4373-8491-be6921de757e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:53:02
36925	9d6b423b-52c0-4d72-9f70-daa765b76866	9d6b423b-5388-4373-8491-be6921de757e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":228,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:53:02
37008	9d6b4453-859b-4ffa-8b1a-778d971827f3	9d6b4453-ab46-43b1-baca-6a5479cb7f47	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:58:53
37009	9d6b4453-a42d-4e9c-8e51-145867d81544	9d6b4453-ab46-43b1-baca-6a5479cb7f47	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:58:53
37010	9d6b4453-a47d-49f6-8528-9fca9815fa36	9d6b4453-ab46-43b1-baca-6a5479cb7f47	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:58:53
37011	9d6b4453-a945-45c9-af2b-6aa0fc1078fe	9d6b4453-ab46-43b1-baca-6a5479cb7f47	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:58:53
37012	9d6b4453-a9d8-4d65-ae90-c35d10ee61bc	9d6b4453-ab46-43b1-baca-6a5479cb7f47	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":360,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:58:53
26057	9d68cd39-6186-4622-ac11-f7119bcb3e34	9d68cd39-cf81-4927-888e-c52a98269323	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 10:34:12
26058	9d68cd39-c3d2-4a54-bfb9-d8a7a3f3f909	9d68cd39-cf81-4927-888e-c52a98269323	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"193.10","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:34:12
26059	9d68cd39-c48a-4c4d-8805-2a879e88c86c	9d68cd39-cf81-4927-888e-c52a98269323	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:34:12
26060	9d68cd39-cd38-4737-a7f6-1990fe02318b	9d68cd39-cf81-4927-888e-c52a98269323	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 10:34:12
26061	9d68cd39-cdbc-4e92-9110-2e9400b0a9ba	9d68cd39-cf81-4927-888e-c52a98269323	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":811,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:34:12
36926	9d6b423d-6adf-40f3-897a-d8e612b99a65	9d6b423d-8876-4c1b-9c78-f5a534eff70c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:53:03
36927	9d6b423d-8396-4b17-a4c3-c1d11af072ad	9d6b423d-8876-4c1b-9c78-f5a534eff70c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:53:03
36928	9d6b423d-83db-4fa4-969f-24d031d73273	9d6b423d-8876-4c1b-9c78-f5a534eff70c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:53:03
36929	9d6b423d-874b-42d2-896a-5ce64e60d320	9d6b423d-8876-4c1b-9c78-f5a534eff70c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:53:03
36930	9d6b423d-878c-4dec-a581-1e5ec2087e7a	9d6b423d-8876-4c1b-9c78-f5a534eff70c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":359,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:53:03
37013	9d6b4454-02e8-4b17-bd99-a153b2907242	9d6b4454-2571-4ffb-b172-f545353149d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:58:54
37014	9d6b4454-1fe8-4aeb-b2b3-baf62f057ae2	9d6b4454-2571-4ffb-b172-f545353149d1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:58:54
37015	9d6b4454-2040-4de2-831c-50a997c08825	9d6b4454-2571-4ffb-b172-f545353149d1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:58:54
37016	9d6b4454-23ed-4794-b32c-aef3d1929274	9d6b4454-2571-4ffb-b172-f545353149d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:58:54
37017	9d6b4454-2448-4ae9-a7ee-7c24fd33e9a2	9d6b4454-2571-4ffb-b172-f545353149d1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":290,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:58:54
37018	9d6b4456-0008-4298-ba52-853eb6e74462	9d6b4456-1f82-4f46-ad53-46a0cc884f03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:58:55
37019	9d6b4456-1a1c-43d5-8bc3-ba055aa0a794	9d6b4456-1f82-4f46-ad53-46a0cc884f03	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:58:55
37020	9d6b4456-1a7a-428e-b219-05ff7d359afc	9d6b4456-1f82-4f46-ad53-46a0cc884f03	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:58:55
37021	9d6b4456-1e03-4b14-955e-a31e8a8865c0	9d6b4456-1f82-4f46-ad53-46a0cc884f03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:58:55
37022	9d6b4456-1e65-4e37-a800-2fbd32f3c626	9d6b4456-1f82-4f46-ad53-46a0cc884f03	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":310,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:58:55
21084	9d673405-258a-4830-90b2-ed9ff55646f7	9d673405-6e30-40b9-aec9-8c5d95dc6810	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 15:29:59
21085	9d673405-69e8-4090-bfa5-f669760dcc66	9d673405-6e30-40b9-aec9-8c5d95dc6810	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:29:59
21086	9d673405-6be9-45aa-9238-a3d232a1d666	9d673405-6e30-40b9-aec9-8c5d95dc6810	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1290,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:29:59
21087	9d673413-9665-45d4-9e26-465d9fcfb0b1	9d673415-b825-4030-85f2-19f6d68d10b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:30:09
21088	9d673414-bfc0-47d2-b720-5a5d87824b49	9d673415-b825-4030-85f2-19f6d68d10b9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"126.73","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 15:30:09
21089	9d673415-8ee3-4ec9-8a84-f348f032bc80	9d673415-b825-4030-85f2-19f6d68d10b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:30:10
21090	9d673415-9411-4bc9-bafe-0f9b9cf63dcd	9d673415-b825-4030-85f2-19f6d68d10b9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"37","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"10-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"17-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":null,"loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":10460,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:30:10
21091	9d67341b-d38d-4256-a885-a59f3ec487cb	9d67341c-606e-4211-b0d1-454c3e818ef7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:30:14
21092	9d67341c-46a0-4500-bf82-1ea36289bd81	9d67341c-606e-4211-b0d1-454c3e818ef7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"151.17","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 15:30:14
21093	9d67341c-471c-4fe5-bfa2-7b2f5dcbdf9d	9d67341c-606e-4211-b0d1-454c3e818ef7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 15:30:14
21094	9d67341c-5ea2-40df-9387-1d3035d04514	9d67341c-606e-4211-b0d1-454c3e818ef7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 15:30:14
21095	9d67341c-5f16-4f65-9e39-55ea93d4dc90	9d67341c-606e-4211-b0d1-454c3e818ef7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":3084,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:30:14
37070	9d6b44e9-20c5-475d-af37-1e8b6780a7bb	9d6b44e9-4161-4499-a66c-1e18422dc23d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 16:00:31
37071	9d6b44e9-3f28-4a78-9a87-3ddad1813f8e	9d6b44e9-4161-4499-a66c-1e18422dc23d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 16:00:31
37072	9d6b44e9-3fff-4b53-a76c-af738dacfd9f	9d6b44e9-4161-4499-a66c-1e18422dc23d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":262,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:00:31
29992	9d692db3-89b5-43cc-a61f-9debe1f2a99a	9d692db3-a739-449e-bbe5-eb2a0ac84ef0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 15:03:58
29993	9d692db3-a572-4a75-9d4a-2b8b2b3c0a1c	9d692db3-a739-449e-bbe5-eb2a0ac84ef0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 15:03:58
29994	9d692db3-a638-494d-8ce5-47af12271aba	9d692db3-a739-449e-bbe5-eb2a0ac84ef0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:03:58
31990	9d695867-a4e1-4941-a2ca-725c3a1b8a20	9d695867-a940-4c47-9d11-f8f093ee3348	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1530}	2024-11-04 17:03:23
19065	9d66cfaf-d7cb-4118-a561-b14a9f4c7a42	9d66cfaf-da80-4907-a95d-41d295257b39	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":930}	2024-11-03 10:49:26
29995	9d692db3-fa10-45a7-835c-86d4070545ec	9d692db4-1c4e-4614-afed-979b67c6d52c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 15:03:58
29996	9d692db4-1299-4ae6-b198-1579407d0786	9d692db4-1c4e-4614-afed-979b67c6d52c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"47.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 15:03:59
29997	9d692db4-1697-4d55-90b8-e50ba6b5fcee	9d692db4-1c4e-4614-afed-979b67c6d52c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 15:03:59
29998	9d692db4-16cc-4aea-aec5-47fa2cea8ad7	9d692db4-1c4e-4614-afed-979b67c6d52c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 15:03:59
29999	9d692db4-1b27-4ea1-b014-6c59ed9cc59d	9d692db4-1c4e-4614-afed-979b67c6d52c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 15:03:59
30000	9d692db4-1b76-45e6-96b7-43be2f436228	9d692db4-1c4e-4614-afed-979b67c6d52c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:03:59
37073	9d6b44e9-9c77-4ecb-8696-ce1fcfb52f74	9d6b44e9-bba0-4bb8-a483-77ee4b419156	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 16:00:32
37074	9d6b44e9-b64e-414f-a969-3507b98a88fb	9d6b44e9-bba0-4bb8-a483-77ee4b419156	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"47.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 16:00:32
37075	9d6b44e9-ba13-43a0-9f95-1303ed8f8df1	9d6b44e9-bba0-4bb8-a483-77ee4b419156	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 16:00:32
37076	9d6b44e9-ba89-47c1-a683-644c5ee5a1f9	9d6b44e9-bba0-4bb8-a483-77ee4b419156	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":256,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:00:32
23041	9d680129-80d1-491c-a6f9-1d1061aca11d	9d680129-b413-4c92-a767-b162c7386328	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 01:03:36
23042	9d680129-b0be-417d-a3b5-99f92acc1904	9d680129-b413-4c92-a767-b162c7386328	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 01:03:36
23043	9d680129-b262-40ca-b0d8-5ff03356556a	9d680129-b413-4c92-a767-b162c7386328	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":620,"memory":22,"hostname":"EderCortes"}	2024-11-04 01:03:36
37077	9d6b44ea-12b0-4b53-a733-5c791e4fef4f	9d6b44ea-3507-46a1-bc45-4ce7f236ac41	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 16:00:32
37078	9d6b44ea-2f9c-4983-8469-63dec400a0f3	9d6b44ea-3507-46a1-bc45-4ce7f236ac41	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:00:32
37079	9d6b44ea-3000-452a-a5dd-4bb40a9faec5	9d6b44ea-3507-46a1-bc45-4ce7f236ac41	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:00:32
37080	9d6b44ea-33cb-4c98-9130-35d7e370a888	9d6b44ea-3507-46a1-bc45-4ce7f236ac41	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 16:00:32
23044	9d68012a-65ea-4fbb-8a63-0692f4282f75	9d68012a-a068-4cad-884f-dc47950dd286	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 01:03:37
23045	9d68012a-95b6-4d8b-a6af-fc98acdc8b03	9d68012a-a068-4cad-884f-dc47950dd286	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"71.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 01:03:37
23046	9d68012a-9653-42e2-97a9-b186974ae203	9d68012a-a068-4cad-884f-dc47950dd286	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 01:03:37
23047	9d68012a-9e2c-45ea-a088-7582dd1c7d4f	9d68012a-a068-4cad-884f-dc47950dd286	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 01:03:37
23048	9d68012a-9eda-4240-b727-c5c56afd49ea	9d68012a-a068-4cad-884f-dc47950dd286	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":523,"memory":22,"hostname":"EderCortes"}	2024-11-04 01:03:37
37081	9d6b44ea-340c-429d-8154-9f827f28604f	9d6b44ea-3507-46a1-bc45-4ce7f236ac41	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":296,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:00:32
23049	9d68012b-9bce-49fd-8faf-5aa5e04ec487	9d68012b-f9e6-4966-960a-79901d9ca258	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 01:03:37
23050	9d68012b-f13a-4e07-945b-8c8e7af37f54	9d68012b-f9e6-4966-960a-79901d9ca258	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"174.45","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 01:03:38
23051	9d68012b-f1b6-4b7c-9c4c-7d778640a171	9d68012b-f9e6-4966-960a-79901d9ca258	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 01:03:38
23052	9d68012b-f815-4ae1-bd52-b7774febba14	9d68012b-f9e6-4966-960a-79901d9ca258	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 01:03:38
19800	9d66e722-8548-4776-827f-7ae6cf151cdd	9d66e722-ad8c-42a5-a687-390ed0079136	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 11:55:00
19801	9d66e722-ab24-430c-9343-a3bf5e7199fd	9d66e722-ad8c-42a5-a687-390ed0079136	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:55:00
19802	9d66e722-ac1a-4c64-8c22-fbb68fc0114b	9d66e722-ad8c-42a5-a687-390ed0079136	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":295,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:55:00
23053	9d68012b-f88f-48cd-a041-25932dacffa6	9d68012b-f9e6-4966-960a-79901d9ca258	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":859,"memory":22,"hostname":"EderCortes"}	2024-11-04 01:03:38
37082	9d6b44ea-8386-4f6c-b4eb-8a65e56d9523	9d6b44ea-a46a-4455-974c-ce35dbdb74bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 16:00:32
37083	9d6b44ea-9fa6-4260-ba13-71648305d64f	9d6b44ea-a46a-4455-974c-ce35dbdb74bd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:00:32
37084	9d6b44ea-9ff0-4f71-9c3a-595c6bb6c853	9d6b44ea-a46a-4455-974c-ce35dbdb74bd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:00:32
37085	9d6b44ea-a331-4b89-8a17-c745095a65b0	9d6b44ea-a46a-4455-974c-ce35dbdb74bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 16:00:32
37086	9d6b44ea-a373-4042-9dbe-b15b5f040500	9d6b44ea-a46a-4455-974c-ce35dbdb74bd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":265,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:00:32
19803	9d66e723-18fa-444e-87ba-e1dd8e35f25d	9d66e723-3e4f-4355-b255-31c423be52c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 11:55:00
19804	9d66e723-3292-4028-97df-ce70876ac015	9d66e723-3e4f-4355-b255-31c423be52c0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"51.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 11:55:00
19805	9d66e723-36f1-4e06-9bfd-52c4067408ff	9d66e723-3e4f-4355-b255-31c423be52c0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:55:00
19806	9d66e723-3732-43df-b642-565fe3396bbf	9d66e723-3e4f-4355-b255-31c423be52c0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:55:00
19807	9d66e723-3cab-481e-ab4c-c8c6c10c1c26	9d66e723-3e4f-4355-b255-31c423be52c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:55:00
19808	9d66e723-3d22-45be-9864-80f0af15e0c9	9d66e723-3e4f-4355-b255-31c423be52c0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"100000","loans_pago_interes":"50000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":320,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:55:00
37087	9d6b44ed-8986-4fb7-98d2-edab16d8d330	9d6b44ed-cd25-4088-8b36-6ea6eab65e32	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 16:00:34
37088	9d6b44ed-c33a-4475-a3c2-2d3223d6bf24	9d6b44ed-cd25-4088-8b36-6ea6eab65e32	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"81.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 16:00:34
37089	9d6b44ed-c3aa-4755-a1e7-b5dc98bd2032	9d6b44ed-cd25-4088-8b36-6ea6eab65e32	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 16:00:34
37090	9d6b44ed-ca9b-455f-96ba-b9ed252c6256	9d6b44ed-cd25-4088-8b36-6ea6eab65e32	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 16:00:34
37091	9d6b44ed-cb2c-4b77-bee6-ed768ba7b149	9d6b44ed-cd25-4088-8b36-6ea6eab65e32	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1190,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:00:34
19809	9d66e725-3832-4f2d-9afe-e5d8d04abec0	9d66e725-56dc-4415-9172-663b3135b7bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 11:55:02
19810	9d66e725-511d-41f5-aa5a-317a591d38f5	9d66e725-56dc-4415-9172-663b3135b7bf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:55:02
19811	9d66e725-5184-4fb0-b1f7-9a6ebf85ae18	9d66e725-56dc-4415-9172-663b3135b7bf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:55:02
19812	9d66e725-55ae-42cd-85d8-d2e177d4eae6	9d66e725-56dc-4415-9172-663b3135b7bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 11:55:02
19813	9d66e725-55ef-4a89-88f1-78494e9dbc9f	9d66e725-56dc-4415-9172-663b3135b7bf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":273,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:55:02
30079	9d69337b-acdc-4994-8db3-00c5bc3f058a	9d69337b-cead-4ce5-8272-f786b9664363	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 15:20:08
30080	9d69337b-cd10-46e9-b2c5-88c459cbaeb1	9d69337b-cead-4ce5-8272-f786b9664363	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 15:20:08
30081	9d69337b-cdbc-4206-b734-91caa1ea04ae	9d69337b-cead-4ce5-8272-f786b9664363	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":255,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:20:08
21269	9d67378d-74e6-4e3a-b2dc-97e85ec59931	9d67378d-a31a-4146-9456-519d70e03e49	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 15:39:52
21270	9d67378d-a09b-4e8b-8366-6de10d332d0e	9d67378d-a31a-4146-9456-519d70e03e49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:39:52
21271	9d67378d-a1f2-49f9-aa72-779b41c19f28	9d67378d-a31a-4146-9456-519d70e03e49	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":309,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:39:52
5906	9d52546f-3b4d-424c-88c7-a22434153dbe	9d52546f-4015-48bf-9367-c6b86da2d9ee	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":304}	2024-10-24 06:28:14
29139	9d6912e2-838f-41a9-8144-f30a6b308a4e	9d6912e2-894a-499a-bd50-fd4cc96d7d2c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1360}	2024-11-04 13:48:59
21272	9d67378e-1852-4954-8316-76aac3b3b2da	9d67378e-424a-4f48-8157-c060c747eacc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:39:52
21273	9d67378e-32e3-432c-be5b-542029660dc4	9d67378e-424a-4f48-8157-c060c747eacc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 65\\n                        ","time":"54.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6768d7067397538897aacf4d73c43049","hostname":"EderCortes"}	2024-11-03 15:39:52
21274	9d67378e-38ab-46c8-af78-b5916071f138	9d67378e-424a-4f48-8157-c060c747eacc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '65' order by \\"item_loans\\".\\"id\\" asc","time":"3.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 15:39:52
21275	9d67378e-38f8-4e8e-92ef-da8c3cbe65fe	9d67378e-424a-4f48-8157-c060c747eacc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 15:39:52
21276	9d67378e-40c7-4045-9e49-948db56dc817	9d67378e-424a-4f48-8157-c060c747eacc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:39:52
21277	9d67378e-412e-4236-94ac-78cb21322314	9d67378e-424a-4f48-8157-c060c747eacc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/65","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":65,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":3000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-10 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":207,"loans_codigo":65,"itemloans_cuota":"1","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:02.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":208,"loans_codigo":65,"itemloans_cuota":"2","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":209,"loans_codigo":65,"itemloans_cuota":"3","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":210,"loans_codigo":65,"itemloans_cuota":"4","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":211,"loans_codigo":65,"itemloans_cuota":"5","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":212,"loans_codigo":65,"itemloans_cuota":"6","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":213,"loans_codigo":65,"itemloans_cuota":"7","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":214,"loans_codigo":65,"itemloans_cuota":"8","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":215,"loans_codigo":65,"itemloans_cuota":"9","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":216,"loans_codigo":65,"itemloans_cuota":"10","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-09-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:39:52
30082	9d69337c-2652-45cf-96e6-213f4141a261	9d69337c-71bc-4a1d-b3ca-408548ed92dc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 15:20:09
30083	9d69337c-676d-4689-b86b-06cb17a56324	9d69337c-71bc-4a1d-b3ca-408548ed92dc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"148.87","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 15:20:09
30084	9d69337c-6b9b-4d1a-b489-88f8ca23826a	9d69337c-71bc-4a1d-b3ca-408548ed92dc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 15:20:09
30085	9d69337c-6bd3-4e51-a8cb-27e97b696989	9d69337c-71bc-4a1d-b3ca-408548ed92dc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 15:20:09
30086	9d69337c-7084-449a-b0d1-ed333dbf2fc6	9d69337c-71bc-4a1d-b3ca-408548ed92dc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 15:20:09
30087	9d69337c-70d0-4181-9ffe-c426b21a9a67	9d69337c-71bc-4a1d-b3ca-408548ed92dc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":366,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:20:09
26204	9d68cef9-5153-44b7-a97e-ff220a8e50e7	9d68cef9-bebe-40ae-8a2a-1c260081274a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 10:39:06
26205	9d68cef9-bb8f-4c03-b4c6-b6ad11fc0938	9d68cef9-bebe-40ae-8a2a-1c260081274a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 10:39:06
26206	9d68cef9-bcda-458a-ad95-ebeacc28239b	9d68cef9-bebe-40ae-8a2a-1c260081274a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":771,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:39:06
26207	9d68cefa-ab29-491d-b4ca-d39b0a13eebb	9d68cefa-d252-48aa-a439-1e1f8d4fd9e9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 10:39:06
26208	9d68cefa-c5bd-47e1-b9ec-46a84c21f79f	9d68cefa-d252-48aa-a439-1e1f8d4fd9e9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"49.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:39:07
26209	9d68cefa-ca91-4bac-9104-b82413d54f10	9d68cefa-d252-48aa-a439-1e1f8d4fd9e9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:39:07
26210	9d68cefa-cad6-46f0-b4cb-7a47e2735f7c	9d68cefa-d252-48aa-a439-1e1f8d4fd9e9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:39:07
26211	9d68cefa-d0a8-4e15-b2f2-df834f7e40f7	9d68cefa-d252-48aa-a439-1e1f8d4fd9e9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 10:39:07
26212	9d68cefa-d121-4ca7-a0a7-1cb97fc2dc28	9d68cefa-d252-48aa-a439-1e1f8d4fd9e9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":615,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:39:07
26213	9d68cefc-03d0-4c75-87b1-1dc6e5854b35	9d68cefc-3daf-44af-984e-bef663cd3571	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 10:39:07
26214	9d68cefc-3231-481d-aecc-a46e5a0d35fe	9d68cefc-3daf-44af-984e-bef663cd3571	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"70.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:39:07
26215	9d68cefc-32e8-412a-afab-974fc899f998	9d68cefc-3daf-44af-984e-bef663cd3571	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:39:07
26216	9d68cefc-3b7f-4a78-93d3-49602f1cf351	9d68cefc-3daf-44af-984e-bef663cd3571	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 10:39:07
26217	9d68cefc-3c1b-4fb1-9fda-92162cfd2748	9d68cefc-3daf-44af-984e-bef663cd3571	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":911,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:39:07
26218	9d68cefc-f825-4bf7-8c85-d19076ad6b74	9d68cefd-2aaa-4c7e-8d27-e758ca3cfa19	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 10:39:08
26219	9d68cefd-214b-4d7f-9566-6a9ebe0fa80a	9d68cefd-2aaa-4c7e-8d27-e758ca3cfa19	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"67.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:39:08
26220	9d68cefd-21e8-4443-8e5c-c40525500e51	9d68cefd-2aaa-4c7e-8d27-e758ca3cfa19	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:39:08
26221	9d68cefd-28af-464c-af33-008f5b36bb45	9d68cefd-2aaa-4c7e-8d27-e758ca3cfa19	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 10:39:08
26222	9d68cefd-293a-4a67-aa0e-8b24b00c4ad9	9d68cefd-2aaa-4c7e-8d27-e758ca3cfa19	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":580,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:39:08
18045	9d65b6dc-3a21-4a79-aa27-6d5e5163fb31	9d65b6dc-5d6b-47c9-a0a8-f9cfd89dc13f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-02 21:44:11
18046	9d65b6dc-5b8f-4615-b1e2-0a184d7ecc1c	9d65b6dc-5d6b-47c9-a0a8-f9cfd89dc13f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:44:11
18047	9d65b6dc-5c6e-4a27-9756-7c6cd0a19358	9d65b6dc-5d6b-47c9-a0a8-f9cfd89dc13f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":245,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:44:11
37231	9d6b45e5-527b-47f5-9445-7c25e144cd36	9d6b45e5-9a23-4d7d-8fed-8218b8d2194f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 16:03:17
37232	9d6b45e5-9872-4ecf-97e8-d46c781119eb	9d6b45e5-9a23-4d7d-8fed-8218b8d2194f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 16:03:17
37233	9d6b45e5-9912-41de-95c2-9070a9d52c9f	9d6b45e5-9a23-4d7d-8fed-8218b8d2194f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":368,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:03:17
18048	9d65b6dc-b873-494e-aa44-73b61774f87e	9d65b6dd-02a4-4dbe-ad0f-fc154a00695f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-02 21:44:11
18049	9d65b6dc-f960-4f89-8fd7-8ac7dfaf4f8b	9d65b6dd-02a4-4dbe-ad0f-fc154a00695f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"153.11","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":293,"hash":"2b11ef88578e3c91c11800e110e490df","hostname":"EderCortes"}	2024-11-02 21:44:11
18050	9d65b6dc-fce4-4273-9cc4-be3134b187ef	9d65b6dd-02a4-4dbe-ad0f-fc154a00695f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"2.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-02 21:44:11
18051	9d65b6dc-fd19-4774-a2f7-cd9234ba17de	9d65b6dd-02a4-4dbe-ad0f-fc154a00695f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-02 21:44:11
18052	9d65b6dd-016e-4f39-9937-e2bf07c3266c	9d65b6dd-02a4-4dbe-ad0f-fc154a00695f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:44:11
18053	9d65b6dd-01b7-4be3-ba46-7fec5b94bf46	9d65b6dd-02a4-4dbe-ad0f-fc154a00695f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:54:38.000000Z","updated_at":"2024-10-30T15:54:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":381,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:44:11
37234	9d6b45e5-f3ff-46ae-ad37-9f806e8c5403	9d6b45e6-1217-47f2-9730-7830dc748b07	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 16:03:17
37235	9d6b45e6-0d78-449f-8e5f-0c1e427cfec8	9d6b45e6-1217-47f2-9730-7830dc748b07	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"47.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 16:03:17
37236	9d6b45e6-1091-4b8c-ad12-9d02ece7ffe8	9d6b45e6-1217-47f2-9730-7830dc748b07	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 16:03:17
37237	9d6b45e6-1103-4ee0-b655-d65536cd145b	9d6b45e6-1217-47f2-9730-7830dc748b07	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:03:17
18054	9d65b6de-5e3b-4f8d-9b85-21991dfd5c13	9d65b6de-7ef3-4d9d-ad07-aa0aec9eb45b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-02 21:44:12
18055	9d65b6de-78f1-4f8b-ae23-3b992d84618d	9d65b6de-7ef3-4d9d-ad07-aa0aec9eb45b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-02 21:44:12
18056	9d65b6de-7946-40e5-8ca7-bc397b64957c	9d65b6de-7ef3-4d9d-ad07-aa0aec9eb45b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-02 21:44:12
18057	9d65b6de-7d83-4fab-bb02-a7f07db522a2	9d65b6de-7ef3-4d9d-ad07-aa0aec9eb45b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-02 21:44:12
18058	9d65b6de-7dd7-43e1-ac32-3ac181acb67f	9d65b6de-7ef3-4d9d-ad07-aa0aec9eb45b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":465,"memory":22,"hostname":"EderCortes"}	2024-11-02 21:44:12
37238	9d6b45e6-74e1-4fce-a09e-034941051747	9d6b45e6-c43d-4825-9fb4-061e5e122989	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 16:03:17
37239	9d6b45e6-bd82-457d-b2ec-f351926784d8	9d6b45e6-c43d-4825-9fb4-061e5e122989	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"153.82","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:03:18
37240	9d6b45e6-be0b-40bc-8d08-7ca84499450e	9d6b45e6-c43d-4825-9fb4-061e5e122989	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:03:18
37241	9d6b45e6-c2b7-42ae-9c6a-ae947f934b38	9d6b45e6-c43d-4825-9fb4-061e5e122989	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 16:03:18
37242	9d6b45e6-c317-4f7d-a969-13babac80e8b	9d6b45e6-c43d-4825-9fb4-061e5e122989	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":446,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:03:18
37243	9d6b45e7-112b-43c1-a6bd-89a3a94a0a6e	9d6b45e7-319c-4d5d-8ee6-2206fabe4eaf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 16:03:18
37244	9d6b45e7-2c71-4195-a69d-bed065e8e9df	9d6b45e7-319c-4d5d-8ee6-2206fabe4eaf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:03:18
37245	9d6b45e7-2cd8-4078-b702-12260d5fab90	9d6b45e7-319c-4d5d-8ee6-2206fabe4eaf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:03:18
37246	9d6b45e7-301a-4072-9c42-5035c342bf4b	9d6b45e7-319c-4d5d-8ee6-2206fabe4eaf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 16:03:18
37247	9d6b45e7-308c-4317-9d26-37e1042e75a1	9d6b45e7-319c-4d5d-8ee6-2206fabe4eaf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":263,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:03:18
18620	9d6696f5-ba9c-430e-86ca-7bcc5f4d4eae	9d6696f5-befa-4002-8336-90708a9e6b30	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abPendiente\\u00bb\\nLINE 4: ... WHEN l.loans_cuando = 'D' AND 'l.loans_estado = 'Pendiente'...\\n                                                             ^ (Connection: pgsql, SQL: select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND 'l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND 'l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND 'l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND 'l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND 'l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":58},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":896}	2024-11-03 08:10:49
26312	9d68d20a-1b7c-4692-a0e7-1528bcc544e6	9d68d20a-b878-4876-a2e7-64886b1ee1b8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:47:40
26313	9d68d20a-b580-433f-89c9-24f16b843599	9d68d20a-b878-4876-a2e7-64886b1ee1b8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:47:40
26314	9d68d20a-b6e9-44f5-bb2e-00a534a70090	9d68d20a-b878-4876-a2e7-64886b1ee1b8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1016,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:47:40
37248	9d6b45e9-09ea-4319-b276-d252ca766428	9d6b45e9-560b-4616-ad1e-2f2146f0e261	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 16:03:19
37249	9d6b45e9-508c-4fd4-a5fc-86ae1035982d	9d6b45e9-560b-4616-ad1e-2f2146f0e261	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"158.51","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 16:03:19
37250	9d6b45e9-50d3-4744-a32a-9ad56f9cabb5	9d6b45e9-560b-4616-ad1e-2f2146f0e261	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 16:03:19
37251	9d6b45e9-5483-498a-b5ff-079600e4a2b0	9d6b45e9-560b-4616-ad1e-2f2146f0e261	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-05 16:03:19
26315	9d68d20b-b953-4cbc-bc6b-869f733acc34	9d68d20c-15b2-4fe4-9415-b07f6722972a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:47:41
26316	9d68d20c-0042-47f2-b235-3b9750d5c79a	9d68d20c-15b2-4fe4-9415-b07f6722972a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"137.38","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:47:41
26317	9d68d20c-098e-435f-902f-665ca77ccde1	9d68d20c-15b2-4fe4-9415-b07f6722972a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"4.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:47:41
26318	9d68d20c-09fe-41e8-8c7f-590c6e758a40	9d68d20c-15b2-4fe4-9415-b07f6722972a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:47:41
26319	9d68d20c-1310-40fa-923c-f46c1b4ee42c	9d68d20c-15b2-4fe4-9415-b07f6722972a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:47:41
26320	9d68d20c-13b5-49c3-97a4-f72b9e458786	9d68d20c-15b2-4fe4-9415-b07f6722972a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":796,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:47:41
37252	9d6b45e9-54ca-4f7f-9b85-e094270172d9	9d6b45e9-560b-4616-ad1e-2f2146f0e261	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":473,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:03:19
26321	9d68d20c-e8c6-4149-8385-b08228c3a245	9d68d20d-25ed-4e6f-aa03-796fce18280a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:47:42
26322	9d68d20d-1b46-4eda-8b34-0d07b963a786	9d68d20d-25ed-4e6f-aa03-796fce18280a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"86.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:47:42
26323	9d68d20d-1bd4-47f9-af82-709bed6404fe	9d68d20d-25ed-4e6f-aa03-796fce18280a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:47:42
26324	9d68d20d-23b8-43cf-9eb7-0fbbddb85dd0	9d68d20d-25ed-4e6f-aa03-796fce18280a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:47:42
26325	9d68d20d-2450-4206-9710-fc7750a62b41	9d68d20d-25ed-4e6f-aa03-796fce18280a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":666,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:47:42
26326	9d68d20d-dbcd-4860-aae4-4720cabceab2	9d68d20e-18e5-4b3c-88b1-24aaba04deba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:47:42
26327	9d68d20e-0fe3-4b2e-a2c8-8af3acb7d09d	9d68d20e-18e5-4b3c-88b1-24aaba04deba	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"97.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:47:42
26328	9d68d20e-1072-470b-bd77-a88161919cd3	9d68d20e-18e5-4b3c-88b1-24aaba04deba	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:47:42
26329	9d68d20e-16d1-4175-9c83-2f297e8a00f7	9d68d20e-18e5-4b3c-88b1-24aaba04deba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:47:42
26330	9d68d20e-175f-4bfc-8352-88e40f7bb068	9d68d20e-18e5-4b3c-88b1-24aaba04deba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":596,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:47:42
18754	9d669b7f-5f84-447e-9a1a-42d2756e09ff	9d669b7f-62ea-46ed-b027-6a33dd2462c6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00ab'Diario'\\u00bb\\nLINE 16:                 WHEN l.loans_cuando = 'D' 'Diario'\\n                                                   ^ (Connection: pgsql, SQL: select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' 'Diario'\\n                WHEN l.loans_cuando = 'S' 'Semanal'\\n                WHEN l.loans_cuando = 'Q' 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' 'Mensual'\\n                WHEN l.loans_cuando = 'T' 'Trimestral'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":908}	2024-11-03 08:23:30
37415	9d6b4a86-c392-4a46-a4ce-a64410fee841	9d6b4a86-e3da-4ddd-964f-fa3d1136136f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 16:16:14
37416	9d6b4a86-e1fe-4e0e-beb5-d434fdec429d	9d6b4a86-e3da-4ddd-964f-fa3d1136136f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 16:16:14
37417	9d6b4a86-e298-46ae-b110-7b3b2206e18d	9d6b4a86-e3da-4ddd-964f-fa3d1136136f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":257,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:16:14
41691	9d6ccece-7428-41a3-89a5-5a4756b7fe9f	9d6ccece-77a8-484f-b576-4ef97dc1caca	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1917}	2024-11-06 10:21:56
23188	9d688d13-d336-4278-8a0b-a57ab09f4aaa	9d688d13-d781-4b6f-911f-0cf9676e0ac5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1098}	2024-11-04 07:34:50
37418	9d6b4a87-3c0b-457a-afc7-dad7b7197c00	9d6b4a87-81be-440d-a177-92fc6fe446ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 16:16:14
37419	9d6b4a87-7a18-4d1a-9b43-9be312ab5dc9	9d6b4a87-81be-440d-a177-92fc6fe446ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 84\\n                        ","time":"145.45","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ab3bc7b9a0b897ddfe4287a88fc64c84","hostname":"EderCortes"}	2024-11-05 16:16:14
37420	9d6b4a87-7cb6-4559-a110-72a9bcb7cc9f	9d6b4a87-81be-440d-a177-92fc6fe446ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '84' order by \\"item_loans\\".\\"id\\" asc","time":"2.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":304,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-05 16:16:14
37421	9d6b4a87-803c-49fa-88f4-c2951709274b	9d6b4a87-81be-440d-a177-92fc6fe446ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 16:16:14
37422	9d6b4a87-80b8-4a9d-822b-270b93d54f04	9d6b4a87-81be-440d-a177-92fc6fe446ca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/84","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":84,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"480000","loans_pago_interes":"120000","user_alias":"juan_jaramillo"},"items":[{"id":326,"loans_codigo":84,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 21:20:45","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":452,"loans_codigo":84,"itemloans_cuota":"4","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 21:20:45","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":456,"loans_codigo":84,"itemloans_cuota":"3","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:21:49","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":457,"loans_codigo":84,"itemloans_cuota":"4","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:21:49","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":458,"loans_codigo":84,"itemloans_cuota":"5","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:21:49","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":342,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:16:14
37423	9d6b4a89-214b-48f1-b47f-8c5be7604a78	9d6b4a89-802d-48c2-9155-56d8e37cf922	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 16:16:15
37424	9d6b4a89-7634-481c-ad60-c40ee09602b5	9d6b4a89-802d-48c2-9155-56d8e37cf922	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"173.01","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 16:16:15
37425	9d6b4a89-76b7-4d7a-9c8e-4630f78836f4	9d6b4a89-802d-48c2-9155-56d8e37cf922	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 16:16:15
37426	9d6b4a89-7df8-4d4c-bfc2-22f6672a8e0f	9d6b4a89-802d-48c2-9155-56d8e37cf922	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 16:16:15
37427	9d6b4a89-7e96-4e97-9189-95995d035b3e	9d6b4a89-802d-48c2-9155-56d8e37cf922	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":716,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:16:15
37639	9d6b58e7-0d7e-49d8-9622-5e73b9083727	9d6b58e7-525d-4629-8a3e-e3dc8e33323a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 16:56:25
37640	9d6b58e7-50a2-4e14-af58-118b21da2a32	9d6b58e7-525d-4629-8a3e-e3dc8e33323a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 16:56:26
19944	9d66ebf7-b95d-4138-a057-9a91a3a8718a	9d66ebf7-fe0e-4d9f-a0fd-4f661d105b25	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:08:31
19945	9d66ebf7-fc8b-4763-92f3-4a849ef88d22	9d66ebf7-fe0e-4d9f-a0fd-4f661d105b25	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 12:08:31
19946	9d66ebf7-fd1f-4449-b44c-20df56a56863	9d66ebf7-fe0e-4d9f-a0fd-4f661d105b25	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":332,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:08:31
37641	9d6b58e7-5140-4988-8dea-407b26acdb77	9d6b58e7-525d-4629-8a3e-e3dc8e33323a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:56:26
19947	9d66ebf8-4692-4f76-b9b0-e5ef1b7150ec	9d66ebf8-902f-4e53-8b15-5db80de66007	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 12:08:31
19948	9d66ebf8-8716-4c5e-b422-51efb18b89a2	9d66ebf8-902f-4e53-8b15-5db80de66007	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"152.62","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:08:31
19949	9d66ebf8-8afe-4575-8c9b-12fb62b9a62a	9d66ebf8-902f-4e53-8b15-5db80de66007	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:08:31
19950	9d66ebf8-8b2f-4e2f-ad0a-5211811a1c5c	9d66ebf8-902f-4e53-8b15-5db80de66007	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:08:31
19951	9d66ebf8-8efe-4535-b9d8-e6e449fe793a	9d66ebf8-902f-4e53-8b15-5db80de66007	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 12:08:31
19952	9d66ebf8-8f48-4ed5-a9fa-1926ff419075	9d66ebf8-902f-4e53-8b15-5db80de66007	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":331,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:08:31
37642	9d6b58e7-aa0b-459d-974a-445f51471e89	9d6b58e7-c8c0-4b3a-96b9-f21fce094c2e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 16:56:26
37643	9d6b58e7-c3a0-4f69-9c17-889db8682e0f	9d6b58e7-c8c0-4b3a-96b9-f21fce094c2e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:56:26
37644	9d6b58e7-c3f0-4429-9bdb-c6a5d04b0253	9d6b58e7-c8c0-4b3a-96b9-f21fce094c2e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:56:26
37645	9d6b58e7-c77d-4afd-a5b6-3a94bc7e316e	9d6b58e7-c8c0-4b3a-96b9-f21fce094c2e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 16:56:26
37646	9d6b58e7-c7c2-4326-aa30-9720b44c0007	9d6b58e7-c8c0-4b3a-96b9-f21fce094c2e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:56:26
19953	9d66ebfa-6d4e-4bb0-98e4-cf5679b6ca3c	9d66ebfa-8d20-4244-914d-77d9e9cd6566	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 12:08:32
19954	9d66ebfa-84cb-4aad-96aa-e7c195b47e72	9d66ebfa-8d20-4244-914d-77d9e9cd6566	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:08:32
19955	9d66ebfa-8544-4707-b1e2-f3865429f6c9	9d66ebfa-8d20-4244-914d-77d9e9cd6566	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:08:32
19956	9d66ebfa-8b97-4f16-b512-1c16dc51d20b	9d66ebfa-8d20-4244-914d-77d9e9cd6566	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 12:08:32
19957	9d66ebfa-8bf8-4bcc-b960-7d1ec7a187dd	9d66ebfa-8d20-4244-914d-77d9e9cd6566	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":311,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:08:32
37647	9d6b58e8-12bf-4705-ad5f-a60739b06a67	9d6b58e8-3300-4b50-972a-4c5589ef4a08	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 16:56:26
30302	9d69398b-9c74-4948-8181-b2092cdaeeaa	9d69398b-bbe1-4136-be4a-6a97d5b0cfce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 15:37:05
30303	9d69398b-ba3c-4122-8a5c-004323d52695	9d69398b-bbe1-4136-be4a-6a97d5b0cfce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 15:37:05
30304	9d69398b-bae4-40f7-be94-407e47596a3b	9d69398b-bbe1-4136-be4a-6a97d5b0cfce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":257,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:37:05
37648	9d6b58e8-2d16-4ac9-bab5-9bb4f3b6ed62	9d6b58e8-3300-4b50-972a-4c5589ef4a08	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-05 16:56:26
37649	9d6b58e8-2d78-4579-a8d4-8e21f44c4bcc	9d6b58e8-3300-4b50-972a-4c5589ef4a08	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-05 16:56:26
37650	9d6b58e8-31cf-4336-8ee0-de19baddd4fd	9d6b58e8-3300-4b50-972a-4c5589ef4a08	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-05 16:56:26
37651	9d6b58e8-3216-4509-8886-08bf680ffe57	9d6b58e8-3300-4b50-972a-4c5589ef4a08	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:56:26
30305	9d69398c-17fa-42c7-adb3-ac016314ce75	9d69398c-3813-40dc-b0d2-d8edc92cc2b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 15:37:06
30306	9d69398c-2f01-4223-a922-04518ce7e07a	9d69398c-3813-40dc-b0d2-d8edc92cc2b0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"44.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 15:37:06
30307	9d69398c-328d-4f2a-9031-d5d1f91e53c5	9d69398c-3813-40dc-b0d2-d8edc92cc2b0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 15:37:06
30308	9d69398c-32c2-464c-8aef-0aee8c7fb005	9d69398c-3813-40dc-b0d2-d8edc92cc2b0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 15:37:06
30309	9d69398c-36ab-4448-bbd7-7267489f60d9	9d69398c-3813-40dc-b0d2-d8edc92cc2b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 15:37:06
30310	9d69398c-36f9-4808-acbe-796c9ecce37a	9d69398c-3813-40dc-b0d2-d8edc92cc2b0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":263,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:37:06
37652	9d6b58e8-8125-4bfe-8c90-d35d81f1ea25	9d6b58e8-a10c-4b12-9f7a-bc24b3127f59	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-05 16:56:26
37653	9d6b58e8-9bd2-4182-b712-36129710db7a	9d6b58e8-a10c-4b12-9f7a-bc24b3127f59	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:56:27
37654	9d6b58e8-9c26-4a6c-bd17-efbeca03076d	9d6b58e8-a10c-4b12-9f7a-bc24b3127f59	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-05 16:56:27
37655	9d6b58e8-9fd4-41ee-a395-91b59f8d037f	9d6b58e8-a10c-4b12-9f7a-bc24b3127f59	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-05 16:56:27
37656	9d6b58e8-a028-44be-a706-6f99b1dcebc1	9d6b58e8-a10c-4b12-9f7a-bc24b3127f59	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:56:27
36384	9d6b39f2-cb3b-4526-a274-488245f603b0	9d6b39f2-ceb4-4f94-9ef2-bb307ff3080b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1645}	2024-11-05 15:29:52
26432	9d68d3ea-accf-40a5-8ca9-7d0e28b0de9b	9d68d3ea-e3c6-46a9-aae0-5bc4f10601b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 10:52:55
26433	9d68d3ea-e0b0-478a-9ee2-ddfbe52ebc91	9d68d3ea-e3c6-46a9-aae0-5bc4f10601b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 10:52:55
26434	9d68d3ea-e226-4810-9aff-fa9f8a9fb423	9d68d3ea-e3c6-46a9-aae0-5bc4f10601b1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":636,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:52:55
37657	9d6b58e8-e6d0-44b6-a353-8b52f7f7f24f	9d6b58e9-067b-41da-a23b-6f8c296ff81e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-05 16:56:27
37658	9d6b58e8-ff51-4c38-88bc-4a5e47d6891d	9d6b58e9-067b-41da-a23b-6f8c296ff81e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_valor_prestado\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\" from \\"loans\\" where \\"id\\" = '93' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"40.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":229,"hash":"f00e27e21a94f93c5c7a1d0cd56f9f13","hostname":"EderCortes"}	2024-11-05 16:56:27
37659	9d6b58e8-ffa6-426b-8046-e988628a7fec	9d6b58e9-067b-41da-a23b-6f8c296ff81e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-05 16:56:27
37660	9d6b58e9-014d-4495-827f-d6d62ec27913	9d6b58e9-067b-41da-a23b-6f8c296ff81e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"2.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":230,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-05 16:56:27
37661	9d6b58e9-0183-4c16-a0ea-fa79d69e87da	9d6b58e9-067b-41da-a23b-6f8c296ff81e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-05 16:56:27
26435	9d68d3eb-aab0-408c-b735-072689932eac	9d68d3eb-e161-4538-bd57-69696f48f3a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 10:52:55
26436	9d68d3eb-d09b-4a17-9762-ca38c6a280ef	9d68d3eb-e161-4538-bd57-69696f48f3a4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"76.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:52:56
26437	9d68d3eb-d748-451c-aa4a-6bbd28fc2fac	9d68d3eb-e161-4538-bd57-69696f48f3a4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"3.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:52:56
26438	9d68d3eb-d7bf-4e96-ab08-28b72b4a49f0	9d68d3eb-e161-4538-bd57-69696f48f3a4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:52:56
26439	9d68d3eb-df61-4796-9e43-0dff4c0aaf1e	9d68d3eb-e161-4538-bd57-69696f48f3a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 10:52:56
26440	9d68d3eb-dff3-4df3-b6c0-2dea28d0abc7	9d68d3eb-e161-4538-bd57-69696f48f3a4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":574,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:52:56
37662	9d6b58e9-0559-4322-bbdd-27541af32cb2	9d6b58e9-067b-41da-a23b-6f8c296ff81e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-05 16:56:27
37663	9d6b58e9-05a5-47b2-b39c-33a7aa025a26	9d6b58e9-067b-41da-a23b-6f8c296ff81e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"user_creador":22,"user_cobrador":22,"user_customer":19,"user_recomendacion":18},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:19:45.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:22:30.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":399,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":400,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":401,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":402,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"}]}},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:56:27
37954	9d6b5dd3-59d9-4193-be4a-b1ae267a5752	9d6b5dd3-a1d4-4154-8f65-aaceb61d0b74	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:10:11
37955	9d6b5dd3-a04d-4e3f-a0c5-a88ae4484eb8	9d6b5dd3-a1d4-4154-8f65-aaceb61d0b74	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:10:12
37956	9d6b5dd3-a0dd-4de1-9cd6-de697d4ee25e	9d6b5dd3-a1d4-4154-8f65-aaceb61d0b74	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:10:12
26441	9d68d3ec-a421-4aae-b694-fdc74cec785c	9d68d3ec-e9a1-46d2-8cbf-81fd75707a46	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 10:52:56
26442	9d68d3ec-deec-4bd2-9267-2304bef6cc77	9d68d3ec-e9a1-46d2-8cbf-81fd75707a46	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"108.52","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:52:56
26443	9d68d3ec-df78-487b-a217-caa825bb5342	9d68d3ec-e9a1-46d2-8cbf-81fd75707a46	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:52:56
26444	9d68d3ec-e761-4021-908a-dc46fb639b75	9d68d3ec-e9a1-46d2-8cbf-81fd75707a46	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 10:52:56
26445	9d68d3ec-e7f1-4a81-8ad5-bb12d297283f	9d68d3ec-e9a1-46d2-8cbf-81fd75707a46	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":649,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:52:56
30441	9d693f8f-054a-4599-8ae5-7e97a746e04e	9d693f8f-5547-421e-916b-a8748ffed2e8	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 15:53:54
30442	9d693f8f-52ea-49d5-af19-4393328f36bc	9d693f8f-5547-421e-916b-a8748ffed2e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:53:54
30443	9d693f8f-53d0-4a9a-9262-cb33a5765ac9	9d693f8f-5547-421e-916b-a8748ffed2e8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":458,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:53:54
37664	9d6b58ea-e808-4538-9ac8-3bf81e4bc14c	9d6b58eb-2ff3-4aec-a75f-276e82428ecc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-05 16:56:28
37665	9d6b58eb-2ab6-48f4-b8a2-d31791c29402	9d6b58eb-2ff3-4aec-a75f-276e82428ecc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"148.74","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 16:56:28
37666	9d6b58eb-2b16-46e0-a0b4-a00a5a85a1a0	9d6b58eb-2ff3-4aec-a75f-276e82428ecc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 16:56:28
37667	9d6b58eb-2ea1-4121-b914-ec9ef0b4e75c	9d6b58eb-2ff3-4aec-a75f-276e82428ecc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-05 16:56:28
37668	9d6b58eb-2ee4-4e96-8426-5b9ec4875e14	9d6b58eb-2ff3-4aec-a75f-276e82428ecc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":405,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:56:28
37957	9d6b5dd4-0373-4f34-9a8f-6a63d47a91a0	9d6b5dd4-2b6d-47b3-87b0-c7c16986b1b7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:10:12
37958	9d6b5dd4-244e-4bd8-b64b-6695a9e70fb5	9d6b5dd4-2b6d-47b3-87b0-c7c16986b1b7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"59.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:10:12
37959	9d6b5dd4-2946-4c9f-a350-caee162a9184	9d6b5dd4-2b6d-47b3-87b0-c7c16986b1b7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 17:10:12
26446	9d68d3ed-c276-4da2-bfda-c8d3972cd0af	9d68d3ee-20c2-441c-8337-038c4e31ab8d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 10:52:57
26447	9d68d3ee-163c-4ee7-b39b-cd98c3f77948	9d68d3ee-20c2-441c-8337-038c4e31ab8d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"181.52","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:52:57
26448	9d68d3ee-16d2-4d77-aa25-109d9df4061a	9d68d3ee-20c2-441c-8337-038c4e31ab8d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:52:57
26449	9d68d3ee-1e98-4cc7-86b6-8b9dc973e7a7	9d68d3ee-20c2-441c-8337-038c4e31ab8d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 10:52:57
26450	9d68d3ee-1f31-4f7d-b6e5-67e32591f438	9d68d3ee-20c2-441c-8337-038c4e31ab8d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":670,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:52:57
30444	9d693f8f-d376-48a6-b016-6ff3758e4c2f	9d693f8f-f430-4127-a6e7-26bb01894cdf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:53:55
30209	9d6936fd-8872-459a-9620-fd951c837c7e	9d6936fd-b505-4daa-9761-09f1a0cbb552	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 15:29:57
30210	9d6936fd-b27f-4284-a6a2-d767aae4ffe8	9d6936fd-b505-4daa-9761-09f1a0cbb552	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:29:57
30211	9d6936fd-b3d5-455b-928c-22feb9139422	9d6936fd-b505-4daa-9761-09f1a0cbb552	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":359,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:29:57
30445	9d693f8f-edb3-4516-bb11-876a4e9d88de	9d693f8f-f430-4127-a6e7-26bb01894cdf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"39.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":58,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 15:53:55
30446	9d693f8f-ee31-4284-a8b8-2da856213293	9d693f8f-f430-4127-a6e7-26bb01894cdf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 15:53:55
30447	9d693f8f-f2ee-4b6f-aec1-e749895c39b8	9d693f8f-f430-4127-a6e7-26bb01894cdf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 15:53:55
30448	9d693f8f-f334-4b35-8da6-dc87c81aee4d	9d693f8f-f430-4127-a6e7-26bb01894cdf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:47:38.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":304,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:53:55
37960	9d6b5dd4-29ec-4713-a300-5968c474b1f2	9d6b5dd4-2b6d-47b3-87b0-c7c16986b1b7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":291,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:10:12
26512	9d68d71e-77b0-44b8-9e1d-03d2c799b495	9d68d71f-ad3d-487c-84a3-431960420763	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:01:52
26513	9d68d71f-aa10-4e2c-b2cd-1891655d4549	9d68d71f-ad3d-487c-84a3-431960420763	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:01:53
26514	9d68d71f-ab8d-4a81-b08a-3301da558b9a	9d68d71f-ad3d-487c-84a3-431960420763	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1406,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:01:53
37961	9d6b5dd4-866e-4b11-a29e-4bc47c147803	9d6b5dd4-a935-4396-aa20-78abffa33f30	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 17:10:12
37962	9d6b5dd4-a2e5-4f6c-8cce-aff49b66f29b	9d6b5dd4-a935-4396-aa20-78abffa33f30	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:10:12
37963	9d6b5dd4-a372-4b87-a629-700f3accb3f6	9d6b5dd4-a935-4396-aa20-78abffa33f30	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:10:12
37964	9d6b5dd4-a7d6-4a22-a824-151b33fedf58	9d6b5dd4-a935-4396-aa20-78abffa33f30	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 17:10:12
26515	9d68d720-e747-4697-afa4-4597088edf47	9d68d721-26ef-4881-a218-5674e9874ceb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:01:54
26516	9d68d721-0cc8-4da0-b903-0ae2dd410fd2	9d68d721-26ef-4881-a218-5674e9874ceb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"72.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 11:01:54
26517	9d68d721-1a3a-430e-9464-6c09ec7bec5c	9d68d721-26ef-4881-a218-5674e9874ceb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"4.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:01:54
26518	9d68d721-1aaf-491a-98bf-56353dec136b	9d68d721-26ef-4881-a218-5674e9874ceb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:01:54
26519	9d68d721-2451-467a-adb0-20fede819290	9d68d721-26ef-4881-a218-5674e9874ceb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:01:54
26520	9d68d721-24f1-4135-8b5a-2de0db5a9ec4	9d68d721-26ef-4881-a218-5674e9874ceb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":823,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:01:54
30212	9d6936fe-23f5-4328-9b45-a740879b9dfb	9d6936fe-4603-41eb-a3f6-79e50363ae3f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:29:57
30213	9d6936fe-3a21-4b7c-a071-bdcb3b2433fa	9d6936fe-4603-41eb-a3f6-79e50363ae3f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"41.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 15:29:57
30214	9d6936fe-3f17-4627-bd61-e0d14370c09a	9d6936fe-4603-41eb-a3f6-79e50363ae3f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"1.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 15:29:57
30215	9d6936fe-3f4c-4dda-94cd-8ec2ee4d3f2d	9d6936fe-4603-41eb-a3f6-79e50363ae3f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 15:29:57
30216	9d6936fe-44d8-4ad0-951a-63e021e3027d	9d6936fe-4603-41eb-a3f6-79e50363ae3f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 15:29:57
26521	9d68d722-3a5b-44e1-b96c-933c29856b99	9d68d722-8a00-41cf-84e5-8a1543944d0e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:01:55
26522	9d68d722-7dda-4d3b-b135-9a8d42c153f8	9d68d722-8a00-41cf-84e5-8a1543944d0e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"95.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:01:55
26523	9d68d722-7e97-4204-a1c8-d1540a3d7be7	9d68d722-8a00-41cf-84e5-8a1543944d0e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:01:55
26524	9d68d722-877e-467a-98a9-b074c6517d50	9d68d722-8a00-41cf-84e5-8a1543944d0e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 11:01:55
20034	9d66ed9f-0afa-4c88-b4a5-4cf61090f64a	9d66ed9f-5c02-493b-b098-a72413a49ee2	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 12:13:08
20035	9d66ed9f-59e2-4f48-a8e3-abfa53b349d2	9d66ed9f-5c02-493b-b098-a72413a49ee2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:13:08
20036	9d66ed9f-5adf-4da2-8345-f1e88aad7ae7	9d66ed9f-5c02-493b-b098-a72413a49ee2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":416,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:13:08
26525	9d68d722-8817-4524-8df1-83da196b13d5	9d68d722-8a00-41cf-84e5-8a1543944d0e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":877,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:01:55
30217	9d6936fe-452a-423b-942f-44679ece7419	9d6936fe-4603-41eb-a3f6-79e50363ae3f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":316,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:29:57
37965	9d6b5dd4-a844-4d5e-a8d9-7b2c7eb1c410	9d6b5dd4-a935-4396-aa20-78abffa33f30	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":305,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:10:12
20037	9d66ed9f-d38a-462c-9d6f-8543239ca09f	9d66eda0-2180-44f9-a26d-963f93a094e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:13:09
20038	9d66eda0-160d-415c-ba0c-940700d39781	9d66eda0-2180-44f9-a26d-963f93a094e8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"151.55","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:13:09
20039	9d66eda0-1aa1-4480-969d-ebd88753480a	9d66eda0-2180-44f9-a26d-963f93a094e8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:13:09
20040	9d66eda0-1ad9-49d7-9ae1-b932b4de3a2e	9d66eda0-2180-44f9-a26d-963f93a094e8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:13:09
20041	9d66eda0-1fa2-43e6-997b-eca5651e46ee	9d66eda0-2180-44f9-a26d-963f93a094e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:13:09
20042	9d66eda0-2020-4186-b57c-1dc28943f657	9d66eda0-2180-44f9-a26d-963f93a094e8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":450,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:13:09
26526	9d68d723-61ed-40f0-91ec-344562163906	9d68d723-92df-456f-b03d-3cece46d0ab7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 11:01:55
26527	9d68d723-894c-4c0a-ba18-6b1e9696fba7	9d68d723-92df-456f-b03d-3cece46d0ab7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"67.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:01:55
26528	9d68d723-89e1-41ea-9999-8cd00237a32d	9d68d723-92df-456f-b03d-3cece46d0ab7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:01:55
26529	9d68d723-9095-49cb-b8d5-f65a3a01d0c2	9d68d723-92df-456f-b03d-3cece46d0ab7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 11:01:55
26530	9d68d723-9129-4669-a4e5-561bb9c418dc	9d68d723-92df-456f-b03d-3cece46d0ab7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":650,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:01:55
37966	9d6b5dd5-1cb3-4408-9191-7107f9b7130a	9d6b5dd5-466c-40a9-902f-67a757fd1d3a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 17:10:13
37967	9d6b5dd5-3f17-41c7-a9df-d5286e2d64ff	9d6b5dd5-466c-40a9-902f-67a757fd1d3a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"54.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:10:13
37968	9d6b5dd5-3f7f-459d-82e4-25d01781109b	9d6b5dd5-466c-40a9-902f-67a757fd1d3a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:10:13
37969	9d6b5dd5-44be-4c2c-bd72-6f89179472d7	9d6b5dd5-466c-40a9-902f-67a757fd1d3a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 17:10:13
37970	9d6b5dd5-452d-41b8-ae29-366a8f2565ec	9d6b5dd5-466c-40a9-902f-67a757fd1d3a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":384,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:10:13
19126	9d66d067-1560-4b70-8be8-c9ce705daf58	9d66d067-355d-49e3-984a-60baea0cc889	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 10:51:26
19127	9d66d067-337e-4db0-b9e2-19d338222111	9d66d067-355d-49e3-984a-60baea0cc889	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 10:51:26
19128	9d66d067-3431-49be-82c9-707b4cf776f2	9d66d067-355d-49e3-984a-60baea0cc889	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":271,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:51:26
19129	9d66d067-8980-4c60-9c97-4b71c11eb69d	9d66d067-a7d8-4ffa-a7fa-224780aebd76	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 10:51:26
19130	9d66d067-9e9f-4921-8a05-8876a486289e	9d66d067-a7d8-4ffa-a7fa-224780aebd76	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"40.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 10:51:26
19131	9d66d067-a272-400b-b1e5-43882366b36a	9d66d067-a7d8-4ffa-a7fa-224780aebd76	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"1.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 10:51:26
19132	9d66d067-a2a6-4631-a11f-bf29d7d60105	9d66d067-a7d8-4ffa-a7fa-224780aebd76	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 10:51:26
19133	9d66d067-a640-41ae-bf34-379ae7d878b8	9d66d067-a7d8-4ffa-a7fa-224780aebd76	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 10:51:26
19134	9d66d067-a6b2-4e64-aa9b-9b349a43dc02	9d66d067-a7d8-4ffa-a7fa-224780aebd76	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Abono intereses","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T02:27:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"0"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:51:26
20043	9d66eda2-395c-43e6-a175-837a85433e1b	9d66eda2-6851-4129-8af9-dd34cda74f4f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:13:10
20044	9d66eda2-5f3d-4155-b7c7-24051a99c02b	9d66eda2-6851-4129-8af9-dd34cda74f4f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"64.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:13:10
20045	9d66eda2-5fd6-4127-899c-b5bad9686861	9d66eda2-6851-4129-8af9-dd34cda74f4f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:13:10
20046	9d66eda2-6659-4b48-98c9-27bbb6363028	9d66eda2-6851-4129-8af9-dd34cda74f4f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:13:10
20047	9d66eda2-66bd-4eef-ab66-eac6d650a242	9d66eda2-6851-4129-8af9-dd34cda74f4f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":414,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:13:10
37971	9d6b5dd7-254b-4343-a3ee-d22a8c84e4c0	9d6b5dd7-43cb-4b90-b81b-ea5178a66649	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 17:10:14
37972	9d6b5dd7-3eb7-46a2-a1a4-af521422c919	9d6b5dd7-43cb-4b90-b81b-ea5178a66649	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:10:14
37973	9d6b5dd7-3f0d-4295-98ad-85d03976fa7d	9d6b5dd7-43cb-4b90-b81b-ea5178a66649	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:10:14
37974	9d6b5dd7-42a2-4636-bf91-ebe8d28f7ae9	9d6b5dd7-43cb-4b90-b81b-ea5178a66649	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 17:10:14
19135	9d66d068-e224-4391-bb9b-5842ffcba69f	9d66d069-36d4-4d71-b1a1-7b0fc470d14b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 10:51:27
19136	9d66d069-2de9-4df3-9aae-435f0637ee7a	9d66d069-36d4-4d71-b1a1-7b0fc470d14b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"171.70","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 10:51:27
19137	9d66d069-2e68-4cee-b248-94a133fc8909	9d66d069-36d4-4d71-b1a1-7b0fc470d14b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 10:51:27
19138	9d66d069-351e-41fd-bc1f-4da6b30f41b4	9d66d069-36d4-4d71-b1a1-7b0fc470d14b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 10:51:27
19139	9d66d069-35a3-4b40-9954-2ebce4bff70d	9d66d069-36d4-4d71-b1a1-7b0fc470d14b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":562,"memory":22,"hostname":"EderCortes"}	2024-11-03 10:51:27
37975	9d6b5dd7-42e5-44fc-aed6-67eaec5e3ad9	9d6b5dd7-43cb-4b90-b81b-ea5178a66649	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":294,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:10:14
26602	9d68d8c7-c25f-40c9-9982-ef261964fe44	9d68d8c8-050b-4b1c-a14b-bb1a053b26fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:06:31
26603	9d68d8c8-00aa-4a53-adc7-624896f6c374	9d68d8c8-050b-4b1c-a14b-bb1a053b26fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:06:31
26604	9d68d8c8-0244-423c-a489-b5f2af07f4dd	9d68d8c8-050b-4b1c-a14b-bb1a053b26fa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":684,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:06:31
38133	9d6b5fd3-457b-436b-8817-4337ec3b21ca	9d6b5fd3-6f6b-41f9-b8b7-271f6439ec47	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 17:15:47
26605	9d68d8c8-e7c8-4899-9d8d-e1f2d08590b9	9d68d8c9-186b-4154-a4ee-091ae685b8ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:06:32
26606	9d68d8c9-09d7-439f-a587-95a8e2f2a019	9d68d8c9-186b-4154-a4ee-091ae685b8ea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"59.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 11:06:32
26607	9d68d8c9-0f09-413f-83b3-048b1606de61	9d68d8c9-186b-4154-a4ee-091ae685b8ea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"3.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:06:32
26608	9d68d8c9-0f4a-48e7-9b39-345f5ee30796	9d68d8c9-186b-4154-a4ee-091ae685b8ea	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:06:32
26609	9d68d8c9-1665-49e9-9a61-89c57fe6c949	9d68d8c9-186b-4154-a4ee-091ae685b8ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:06:32
26610	9d68d8c9-16fc-4725-8e09-8c46e82347ac	9d68d8c9-186b-4154-a4ee-091ae685b8ea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":617,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:06:32
38134	9d6b5fd3-6d32-4cbb-883b-2b59d0522b59	9d6b5fd3-6f6b-41f9-b8b7-271f6439ec47	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:15:47
38135	9d6b5fd3-6e28-4c55-8ba7-4649a95f3de9	9d6b5fd3-6f6b-41f9-b8b7-271f6439ec47	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":381,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:15:47
26611	9d68d8ca-2d64-4ea7-9f00-cc85e29f0d3d	9d68d8ca-65cd-4240-8118-28963a3e515a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:06:32
26612	9d68d8ca-5d1e-49d6-bf04-fe9869a7d152	9d68d8ca-65cd-4240-8118-28963a3e515a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"72.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:06:33
26613	9d68d8ca-5db9-4317-9a1e-9adadcbef344	9d68d8ca-65cd-4240-8118-28963a3e515a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:06:33
17017	9d6546f3-6a79-4f34-ad43-212047835fe1	9d6546f3-85cd-4d59-a078-134e32150160	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-02 16:31:16
17018	9d6546f3-8430-497e-8905-a416ffb048a3	9d6546f3-85cd-4d59-a078-134e32150160	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-02 16:31:16
17019	9d6546f3-84c8-4f05-867a-8c8174557670	9d6546f3-85cd-4d59-a078-134e32150160	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna loans.id \\nLINE 1: ...loans\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"loans\\".\\"i...\\n                                                             ^\\nHINT:  Probablemente quiera hacer referencia a la columna \\u00abloans.id\\u00bb. (Connection: pgsql, SQL: select \\"loans\\".\\"id\\", \\"loans\\".\\"loans_documento\\", \\"loans\\".\\"loans_nombre\\", \\"loans\\".\\"loans_apellido_uno\\", \\"loans\\".\\"loans_fecha\\", \\"loans\\".\\"loans_valor_prestado\\", \\"loans\\".\\"loans_cuotas\\", \\"loans\\".\\"loans_estado\\", \\"loans\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" inner join \\"users\\" as \\"ucl\\" on \\"loans\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"loans\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"loans\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"loans\\".\\"id \\" desc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":42,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-11-02 16:31:16
26614	9d68d8ca-6407-4130-971d-8618515bdefb	9d68d8ca-65cd-4240-8118-28963a3e515a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:06:33
26615	9d68d8ca-6473-426e-8964-c94ad45654fb	9d68d8ca-65cd-4240-8118-28963a3e515a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":828,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:06:33
38136	9d6b5fd3-dc77-460e-8617-499ca08acd55	9d6b5fd4-2359-46cf-85af-9ef9f50b49ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:15:47
38137	9d6b5fd4-1df9-4582-8d73-4ff9cc35fc8a	9d6b5fd4-2359-46cf-85af-9ef9f50b49ee	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"150.28","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:15:47
38138	9d6b5fd4-2217-4755-8b21-f4dcac5c359a	9d6b5fd4-2359-46cf-85af-9ef9f50b49ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:15:47
38139	9d6b5fd4-228b-49c1-82a2-1cba3ab76b77	9d6b5fd4-2359-46cf-85af-9ef9f50b49ee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":398,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:15:47
26616	9d68d8cb-143d-4be4-a761-86925def0cab	9d68d8cb-4634-4b0e-9ba5-fc836d916055	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:06:33
26617	9d68d8cb-3d10-4bd5-8ab5-a6c8fdb19a19	9d68d8cb-4634-4b0e-9ba5-fc836d916055	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"67.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:06:33
26618	9d68d8cb-3d95-4c19-b1dd-b98c24abdd74	9d68d8cb-4634-4b0e-9ba5-fc836d916055	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:06:33
26619	9d68d8cb-441b-4eb2-99e0-e6c2ceed13ae	9d68d8cb-4634-4b0e-9ba5-fc836d916055	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:06:33
26620	9d68d8cb-44aa-4390-b275-3e5d2fe61c44	9d68d8cb-4634-4b0e-9ba5-fc836d916055	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":551,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:06:33
38140	9d6b5fd4-7f77-4c16-b00a-c024a0c66899	9d6b5fd4-a0a4-4068-83e7-a15976a5c5c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:15:48
38141	9d6b5fd4-9aeb-4cab-9ae4-a52470383f69	9d6b5fd4-a0a4-4068-83e7-a15976a5c5c9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:15:48
38142	9d6b5fd4-9b3e-4d1e-ac57-e038b0c44d80	9d6b5fd4-a0a4-4068-83e7-a15976a5c5c9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:15:48
38143	9d6b5fd4-9f6a-4ad9-9ea8-0dd582ddc3c1	9d6b5fd4-a0a4-4068-83e7-a15976a5c5c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:15:48
38144	9d6b5fd4-9fb1-435b-a503-09cc0fe07256	9d6b5fd4-a0a4-4068-83e7-a15976a5c5c9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":300,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:15:48
20119	9d66ee83-abca-4ecf-bd9d-65bb16592878	9d66ee83-c792-4170-8ec7-414934e54eeb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:15:38
20120	9d66ee83-c5f1-4454-822d-61228c613d43	9d66ee83-c792-4170-8ec7-414934e54eeb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 12:15:38
20121	9d66ee83-c685-4f5e-98d5-0a2ebfbbd439	9d66ee83-c792-4170-8ec7-414934e54eeb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:15:38
38145	9d6b5fd4-e8ef-4e13-bab8-9555350200aa	9d6b5fd5-099f-4224-8de2-cd8da1063c43	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:15:48
38146	9d6b5fd5-03cf-4973-b8fd-4194db2b34f2	9d6b5fd5-099f-4224-8de2-cd8da1063c43	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:15:48
38147	9d6b5fd5-0428-4b82-bd25-a08d687fdf0b	9d6b5fd5-099f-4224-8de2-cd8da1063c43	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:15:48
38148	9d6b5fd5-081b-4133-a9c7-ddffe6e128ee	9d6b5fd5-099f-4224-8de2-cd8da1063c43	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:15:48
20122	9d66ee84-158f-46a7-b4b3-46004a1a5f34	9d66ee84-5cea-4053-b1cc-031b1d615990	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 12:15:38
20123	9d66ee84-5418-4b11-8db0-a297afd05718	9d66ee84-5cea-4053-b1cc-031b1d615990	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"148.19","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:15:38
20124	9d66ee84-5792-4723-b2cf-a4af750a55fe	9d66ee84-5cea-4053-b1cc-031b1d615990	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:15:38
20125	9d66ee84-57c1-4f4d-aa95-f6589de5098a	9d66ee84-5cea-4053-b1cc-031b1d615990	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:15:38
20126	9d66ee84-5bc0-4a32-a6b0-302c035e04ff	9d66ee84-5cea-4053-b1cc-031b1d615990	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 12:15:38
20127	9d66ee84-5c0b-4a00-a598-742d0a3e9c76	9d66ee84-5cea-4053-b1cc-031b1d615990	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:15:38
38149	9d6b5fd5-086d-4856-a270-2bebd2737e46	9d6b5fd5-099f-4224-8de2-cd8da1063c43	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":248,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:15:48
30614	9d694124-31f9-49f7-99f4-2f9787edbe9b	9d694124-869c-4ec5-befe-15a2ced0dbaf	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 15:58:20
30615	9d694124-8446-4ff9-a462-afdaa1da6acf	9d694124-869c-4ec5-befe-15a2ced0dbaf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:58:20
30616	9d694124-8549-42a8-908f-ed28ef11a7a7	9d694124-869c-4ec5-befe-15a2ced0dbaf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":487,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:58:20
30617	9d694125-00c6-41f0-b119-7d1968565ae5	9d694125-269a-4719-813d-52c7b46b3bac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:58:20
30618	9d694125-19c9-4d04-917b-6a35c0207c16	9d694125-269a-4719-813d-52c7b46b3bac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"47.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 15:58:20
30619	9d694125-1ef4-4cfb-a2d6-a2d4a9b10728	9d694125-269a-4719-813d-52c7b46b3bac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 15:58:20
30620	9d694125-1f44-453a-a0dc-77eded7eb2a2	9d694125-269a-4719-813d-52c7b46b3bac	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 15:58:20
30621	9d694125-2518-496e-8796-c21674f638bf	9d694125-269a-4719-813d-52c7b46b3bac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 15:58:20
30622	9d694125-2585-426e-b55d-da989f93a78f	9d694125-269a-4719-813d-52c7b46b3bac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder.cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:58:20
38289	9d6b61d8-4af4-4dfe-b59f-e0a52cef2296	9d6b61d8-a5f3-4cfc-8f46-a88b6331deac	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 17:21:26
38290	9d6b61d8-a1ea-49b2-8e9a-d0bf181d0a75	9d6b61d8-a5f3-4cfc-8f46-a88b6331deac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:21:26
23576	9d689aa0-63e6-4fab-9678-cf1e44283705	9d689aa0-8e3e-406b-9051-e4dddf983edd	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 08:12:43
23577	9d689aa0-8c62-45fa-97ae-dd02bd3f1a09	9d689aa0-8e3e-406b-9051-e4dddf983edd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 08:12:43
23578	9d689aa0-8d1f-4746-9677-9f197b998ca1	9d689aa0-8e3e-406b-9051-e4dddf983edd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":301,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:12:43
38291	9d6b61d8-a308-457d-a0d7-6e968decf7d4	9d6b61d8-a5f3-4cfc-8f46-a88b6331deac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":573,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:21:26
23579	9d689aa1-0722-4282-9d6d-61ff5d8dd479	9d689aa1-2d54-4290-9783-a749d3d82769	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 08:12:44
23580	9d689aa1-20b4-400a-b207-0e828a1e55ea	9d689aa1-2d54-4290-9783-a749d3d82769	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 69\\n                        ","time":"45.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"28d3d4f6fe6eff992a986b780c628d2e","hostname":"EderCortes"}	2024-11-04 08:12:44
23581	9d689aa1-2526-4915-8b78-33a52c1500d3	9d689aa1-2d54-4290-9783-a749d3d82769	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '69' order by \\"item_loans\\".\\"id\\" asc","time":"2.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:12:44
23582	9d689aa1-256d-4c35-ad78-262425e9afe4	9d689aa1-2d54-4290-9783-a749d3d82769	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 08:12:44
23583	9d689aa1-2b9e-44ef-9b65-0c3ff188f2e0	9d689aa1-2d54-4290-9783-a749d3d82769	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 08:12:44
23584	9d689aa1-2c1b-47b4-979e-32c7368c7dfc	9d689aa1-2d54-4290-9783-a749d3d82769	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/69","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":69,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1150000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1080000","loans_pago_interes":"270000"},"items":[{"id":243,"loans_codigo":69,"itemloans_cuota":"1","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T13:01:48.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000"},{"id":244,"loans_codigo":69,"itemloans_cuota":"2","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T13:01:54.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000"},{"id":245,"loans_codigo":69,"itemloans_cuota":"3","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T13:02:55.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000"},{"id":246,"loans_codigo":69,"itemloans_cuota":"4","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T13:03:00.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"57500","itemloans_cuota_cancelada":"230000"},{"id":247,"loans_codigo":69,"itemloans_cuota":"5","itemloans_valor_cuota":"230000","itemloans_iteres":"57500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:49:09.000000Z","updated_at":"2024-11-04T13:11:47.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"40000","itemloans_cuota_cancelada":"160000"},{"id":259,"loans_codigo":69,"itemloans_cuota":"5","itemloans_valor_cuota":"70000","itemloans_iteres":"-270000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T13:11:47.000000Z","updated_at":"2024-11-04T13:11:47.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":327,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:12:44
23585	9d689aa3-070d-47ec-ae77-d0d63a993601	9d689aa3-3546-454c-b8e3-2741086e073c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 08:12:45
23586	9d689aa3-2ae8-414a-97d3-01887b80a8d3	9d689aa3-3546-454c-b8e3-2741086e073c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"62.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 08:12:45
23587	9d689aa3-2b58-432b-aec2-735a8a1faf04	9d689aa3-3546-454c-b8e3-2741086e073c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 08:12:45
23588	9d689aa3-32b4-4096-8784-8675ea75c99b	9d689aa3-3546-454c-b8e3-2741086e073c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 08:12:45
23589	9d689aa3-335e-4717-b50a-3d5d6241e50a	9d689aa3-3546-454c-b8e3-2741086e073c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":466,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:12:45
38292	9d6b61d9-d397-4544-ad2e-cbb1cf656000	9d6b61d9-fda1-41d2-8671-870ecb8b359f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:21:27
38293	9d6b61d9-f5dc-4ae0-9553-61bb7a28845e	9d6b61d9-fda1-41d2-8671-870ecb8b359f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"60.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:21:27
38294	9d6b61d9-fb5a-4618-87ea-372318cd0d76	9d6b61d9-fda1-41d2-8671-870ecb8b359f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:21:27
38295	9d6b61d9-fc08-4150-a6c7-c8af87ae619f	9d6b61d9-fda1-41d2-8671-870ecb8b359f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":571,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:21:27
20213	9d66f01a-c134-4b04-91f3-c09a5819dcb5	9d66f01b-15b9-493e-beda-62007023b290	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 12:20:05
20214	9d66f01b-1394-4bd7-899a-31d061f9e9e9	9d66f01b-15b9-493e-beda-62007023b290	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:20:05
20215	9d66f01b-1472-4a0e-aefb-3f393951fc21	9d66f01b-15b9-493e-beda-62007023b290	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":521,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:20:05
38296	9d6b61da-5958-4ed0-ae83-2063a6c00d06	9d6b61da-7820-44a1-a677-a8b427e305c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:21:27
38297	9d6b61da-7307-450c-9f07-22e8fb90de81	9d6b61da-7820-44a1-a677-a8b427e305c2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:21:27
38298	9d6b61da-7353-46d6-95cd-edb49f342bce	9d6b61da-7820-44a1-a677-a8b427e305c2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:21:27
38299	9d6b61da-76d9-4d83-bbdc-425e620c575f	9d6b61da-7820-44a1-a677-a8b427e305c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:21:27
20216	9d66f01b-8413-4e65-92dd-770b9442e90d	9d66f01b-a759-4a9d-8b92-fe5c090b2510	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 12:20:05
20217	9d66f01b-9fb7-4987-b5ec-8abf93c23a7c	9d66f01b-a759-4a9d-8b92-fe5c090b2510	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"48.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-03 12:20:05
20218	9d66f01b-a52b-46a7-aeb7-314d873f5d38	9d66f01b-a759-4a9d-8b92-fe5c090b2510	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:20:05
20219	9d66f01b-a5c1-4c3d-9d41-f7c6c1f636bb	9d66f01b-a759-4a9d-8b92-fe5c090b2510	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-1","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-18","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-25","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":323,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:20:05
23590	9d689ab5-d730-45b2-87eb-201dc92604bb	9d689ab5-f328-43e3-840a-6f3a5216ce0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 08:12:57
23591	9d689ab5-ef3f-4150-816e-168d0ce56903	9d689ab5-f328-43e3-840a-6f3a5216ce0d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"45.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 08:12:57
23592	9d689ab5-f1e6-4fb3-9511-0ba4a612ba05	9d689ab5-f328-43e3-840a-6f3a5216ce0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 08:12:57
23593	9d689ab5-f243-495e-9386-5a236551282c	9d689ab5-f328-43e3-840a-6f3a5216ce0d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:12:57
38300	9d6b61da-7725-45fa-ac88-04f1d1942766	9d6b61da-7820-44a1-a677-a8b427e305c2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":296,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:21:27
26709	9d68db8c-b929-4977-8ba9-1c17bd0a443c	9d68db8c-d8fa-48ba-a8f2-ee41ad111e87	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:14:15
20220	9d66f01d-ebc6-4638-87f6-c8d3ef9ba89d	9d66f01e-47bf-4681-90f4-620897c30b45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:20:07
20221	9d66f01e-3fed-4f24-abac-2ac54b6ce4ac	9d66f01e-47bf-4681-90f4-620897c30b45	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"176.94","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:20:07
20222	9d66f01e-4056-4852-94aa-5052d6a5ec55	9d66f01e-47bf-4681-90f4-620897c30b45	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:20:07
20223	9d66f01e-4601-4df9-b836-61f628098bc5	9d66f01e-47bf-4681-90f4-620897c30b45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:20:07
20224	9d66f01e-466e-44dd-8254-bcf7132dde04	9d66f01e-47bf-4681-90f4-620897c30b45	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":564,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:20:07
23594	9d689aba-e0b5-4cf0-bf14-7fe1acd07701	9d689abb-2c0c-4f0b-a4c9-e88465fcfcd2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 08:13:00
23595	9d689abb-22a5-41e0-a25d-e2fd7a774918	9d689abb-2c0c-4f0b-a4c9-e88465fcfcd2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 68\\n                        ","time":"155.71","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"7d9994d55cb8dde82ff4185920c79043","hostname":"EderCortes"}	2024-11-04 08:13:01
23596	9d689abb-263a-4ac3-a361-91de76a7e0f3	9d689abb-2c0c-4f0b-a4c9-e88465fcfcd2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '68' order by \\"item_loans\\".\\"id\\" asc","time":"1.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:13:01
23597	9d689abb-2671-4d56-8729-762911d12ce7	9d689abb-2c0c-4f0b-a4c9-e88465fcfcd2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 08:13:01
23598	9d689abb-2a6f-485a-a0aa-72b525167959	9d689abb-2c0c-4f0b-a4c9-e88465fcfcd2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 08:13:01
23599	9d689abb-2ac2-45af-9c8f-be40b28c5440	9d689abb-2c0c-4f0b-a4c9-e88465fcfcd2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/68","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":68,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":10000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"1000000","loans_pago_interes":"250000"},"items":[{"id":227,"loans_codigo":68,"itemloans_cuota":"1","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":228,"loans_codigo":68,"itemloans_cuota":"2","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":229,"loans_codigo":68,"itemloans_cuota":"3","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":230,"loans_codigo":68,"itemloans_cuota":"4","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":231,"loans_codigo":68,"itemloans_cuota":"5","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":232,"loans_codigo":68,"itemloans_cuota":"6","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":233,"loans_codigo":68,"itemloans_cuota":"7","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":234,"loans_codigo":68,"itemloans_cuota":"8","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":235,"loans_codigo":68,"itemloans_cuota":"9","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":236,"loans_codigo":68,"itemloans_cuota":"10","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":378,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:13:01
26710	9d68db8c-d73c-4f85-b8d5-a6a7b70f2af9	9d68db8c-d8fa-48ba-a8f2-ee41ad111e87	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:14:16
26711	9d68db8c-d7f6-4958-ad61-e9cfda369b8a	9d68db8c-d8fa-48ba-a8f2-ee41ad111e87	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":387,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:14:16
38301	9d6b61da-b9c9-4122-9a7e-36722d63e3a4	9d6b61db-02ef-4a70-b9d4-c98fe085fb7d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:21:27
20225	9d66f032-1d0c-44da-aafb-141f39f3e5b5	9d66f032-6cfc-4b45-b506-760bdb0a725e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:20:20
20226	9d66f032-6277-43a4-b4b1-22f41de52933	9d66f032-6cfc-4b45-b506-760bdb0a725e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 62\\n                        ","time":"157.27","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"20ddbf2cbd038a7caf6d95e5c7db7937","hostname":"EderCortes"}	2024-11-03 12:20:20
20227	9d66f032-66af-4a7a-8870-d2f6370c7401	9d66f032-6cfc-4b45-b506-760bdb0a725e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '62' order by \\"item_loans\\".\\"id\\" asc","time":"2.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:20:20
20228	9d66f032-66ef-4857-84d4-ce976766b730	9d66f032-6cfc-4b45-b506-760bdb0a725e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:20:20
20229	9d66f032-6b80-4cb8-92ac-a85c82f23b2c	9d66f032-6cfc-4b45-b506-760bdb0a725e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:20:20
20230	9d66f032-6be5-4b20-af3c-2fb332944661	9d66f032-6cfc-4b45-b506-760bdb0a725e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/62","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":62,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":187,"loans_codigo":62,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:06:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":188,"loans_codigo":62,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:09:38.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":189,"loans_codigo":62,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:13:57.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":190,"loans_codigo":62,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:16:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":191,"loans_codigo":62,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-29 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T16:00:56.000000Z","updated_at":"2024-11-02T16:34:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-02 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"}]}},"duration":547,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:20:20
23600	9d689b4d-1acf-4c17-b7d3-0be0a2a908b4	9d689b4d-1ef0-448a-b45f-b756f91f2ee7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":183,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:14:36
26712	9d68db8d-5f12-4506-afe2-69df3f3c6538	9d68db8d-7ffc-4837-ade7-8d67c795d03f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:14:16
26713	9d68db8d-76be-4f50-839e-c8fe546e4b10	9d68db8d-7ffc-4837-ade7-8d67c795d03f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"46.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 11:14:16
26714	9d68db8d-7a73-4771-9af4-dca02d25fd9a	9d68db8d-7ffc-4837-ade7-8d67c795d03f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:14:16
26715	9d68db8d-7ab2-4416-ad55-5e8beeb3dfff	9d68db8d-7ffc-4837-ade7-8d67c795d03f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:14:16
26716	9d68db8d-7eb9-49a0-81bf-633a424de416	9d68db8d-7ffc-4837-ade7-8d67c795d03f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:14:16
23608	9d689b4e-480c-457d-9e36-6cad530b016d	9d689b4e-6dd7-4459-96c7-917f1424c531	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 08:14:37
23609	9d689b4e-6227-4584-a717-d15e8ff340d5	9d689b4e-6dd7-4459-96c7-917f1424c531	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 68\\n                        ","time":"48.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"7d9994d55cb8dde82ff4185920c79043","hostname":"EderCortes"}	2024-11-04 08:14:37
23610	9d689b4e-6716-449b-94c0-ada06f104dc2	9d689b4e-6dd7-4459-96c7-917f1424c531	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '68' order by \\"item_loans\\".\\"id\\" asc","time":"2.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:14:37
23611	9d689b4e-674c-4671-9177-1167ce82e907	9d689b4e-6dd7-4459-96c7-917f1424c531	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 08:14:37
23612	9d689b4e-6c61-4e16-8e74-ae4e7404c15f	9d689b4e-6dd7-4459-96c7-917f1424c531	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 08:14:37
23613	9d689b4e-6cbc-4223-9252-9544fdb8e712	9d689b4e-6dd7-4459-96c7-917f1424c531	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/68","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":68,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":10000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"1000000","loans_pago_interes":"250000"},"items":[{"id":227,"loans_codigo":68,"itemloans_cuota":"1","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":228,"loans_codigo":68,"itemloans_cuota":"2","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":229,"loans_codigo":68,"itemloans_cuota":"3","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":230,"loans_codigo":68,"itemloans_cuota":"4","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":231,"loans_codigo":68,"itemloans_cuota":"5","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":232,"loans_codigo":68,"itemloans_cuota":"6","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":233,"loans_codigo":68,"itemloans_cuota":"7","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":234,"loans_codigo":68,"itemloans_cuota":"8","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":235,"loans_codigo":68,"itemloans_cuota":"9","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":236,"loans_codigo":68,"itemloans_cuota":"10","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":334,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:14:37
26717	9d68db8d-7f0a-4990-bbe7-a82a1002b39e	9d68db8d-7ffc-4837-ade7-8d67c795d03f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":379,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:14:16
38302	9d6b61da-fcec-48b1-b29e-189395ccc07a	9d6b61db-02ef-4a70-b9d4-c98fe085fb7d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"146.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:21:28
38303	9d6b61da-fd60-43ae-ae86-1a744654d3f3	9d6b61db-02ef-4a70-b9d4-c98fe085fb7d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:21:28
38304	9d6b61db-0178-4173-8ac8-3ff9043ef7c4	9d6b61db-02ef-4a70-b9d4-c98fe085fb7d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:21:28
38305	9d6b61db-01d0-4f35-b56f-4a497d12b8ce	9d6b61db-02ef-4a70-b9d4-c98fe085fb7d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":341,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:21:28
23614	9d689b52-bb18-4d3e-9b29-30a6f340ae6c	9d689b52-bea8-4543-bdfd-0214581d2e8b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":151,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:14:40
38306	9d6b61dc-ddb8-4844-9da4-47906c9ab581	9d6b61dc-fcf8-454c-97eb-2f7f315478c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:21:29
38307	9d6b61dc-f78d-42ff-96f6-44aabbb84026	9d6b61dc-fcf8-454c-97eb-2f7f315478c2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:21:29
38308	9d6b61dc-f7e9-4771-8bb5-c74cd123a875	9d6b61dc-fcf8-454c-97eb-2f7f315478c2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:21:29
38309	9d6b61dc-fb79-4bc3-b500-c01f860798cb	9d6b61dc-fcf8-454c-97eb-2f7f315478c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:21:29
38310	9d6b61dc-fbce-41ea-bc9a-4bafee26f235	9d6b61dc-fcf8-454c-97eb-2f7f315478c2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":364,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:21:29
23615	9d689b53-40da-4add-8fd2-7d7f5dcbf4fe	9d689b53-6055-482a-9d14-c15ab8e76c74	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 08:14:40
23616	9d689b53-5799-4e7b-b755-a79f836b972b	9d689b53-6055-482a-9d14-c15ab8e76c74	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 228 limit 1","time":"2.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 08:14:40
23617	9d689b53-57e0-4a9c-ab31-0d13659d5460	9d689b53-6055-482a-9d14-c15ab8e76c74	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 08:14:40
23618	9d689b53-599d-488e-8f00-5b674a30c855	9d689b53-6055-482a-9d14-c15ab8e76c74	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 68 limit 1","time":"2.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 08:14:40
23619	9d689b53-59cb-4659-b48c-409eb8471032	9d689b53-6055-482a-9d14-c15ab8e76c74	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 08:14:40
23620	9d689b53-5b0d-4aaf-9f2f-965e7fcae1f7	9d689b53-6055-482a-9d14-c15ab8e76c74	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '250000', \\"itemloans_cuota_cancelada\\" = '1000000', \\"updated_at\\" = '2024-11-04 08:14:40' where \\"id\\" = 228","time":"1.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":400,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 08:14:40
23621	9d689b53-5b64-4362-bc9c-f145661ccb82	9d689b53-6055-482a-9d14-c15ab8e76c74	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:228","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 08:14:40","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},"hostname":"EderCortes"}	2024-11-04 08:14:40
23622	9d689b53-5c0a-48df-8380-fe521bf753bd	9d689b53-6055-482a-9d14-c15ab8e76c74	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_fecha_ultimo_pago\\" = '04-11-2024', \\"loans_pago_interes\\" = 500000, \\"loans_pago_prestado\\" = 2000000, \\"updated_at\\" = '2024-11-04 08:14:40' where \\"id\\" = 68","time":"0.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":408,"hash":"138ffd5a6aae2847ac945cb6fb277db0","hostname":"EderCortes"}	2024-11-04 08:14:40
23623	9d689b53-5c3b-4446-bbc1-4dd2c296cf04	9d689b53-6055-482a-9d14-c15ab8e76c74	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:68","changes":{"updated_at":"2024-11-04 08:14:40","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":500000,"loans_pago_prestado":2000000},"hostname":"EderCortes"}	2024-11-04 08:14:40
23624	9d689b53-5f25-440d-b5cf-5e50c1146f65	9d689b53-6055-482a-9d14-c15ab8e76c74	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 08:14:40
23625	9d689b53-5f65-497c-b291-a45e75b81310	9d689b53-6055-482a-9d14-c15ab8e76c74	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"181","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000","id":228,"loans_codigo":68,"itemloans_cuota":"2","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":245,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:14:40
23626	9d689b53-a88b-47b7-ab94-890986ab0bab	9d689b53-c7f3-412e-9b20-92e39dbea8b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 08:14:41
23627	9d689b53-bec9-4d1b-a760-43e6ba6fe47a	9d689b53-c7f3-412e-9b20-92e39dbea8b9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 68\\n                        ","time":"45.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"7d9994d55cb8dde82ff4185920c79043","hostname":"EderCortes"}	2024-11-04 08:14:41
23628	9d689b53-c2a7-4275-99a6-35ab77a48fc7	9d689b53-c7f3-412e-9b20-92e39dbea8b9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '68' order by \\"item_loans\\".\\"id\\" asc","time":"2.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:14:41
23629	9d689b53-c2d7-404e-b636-2e4fd3546996	9d689b53-c7f3-412e-9b20-92e39dbea8b9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 08:14:41
23630	9d689b53-c68e-43c8-bc62-9866aac90e2b	9d689b53-c7f3-412e-9b20-92e39dbea8b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 08:14:41
23631	9d689b53-c6d7-42f5-a293-4ed5ce611053	9d689b53-c7f3-412e-9b20-92e39dbea8b9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/68","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":68,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":10000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"2000000","loans_pago_interes":"500000"},"items":[{"id":227,"loans_codigo":68,"itemloans_cuota":"1","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":228,"loans_codigo":68,"itemloans_cuota":"2","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:14:40.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":229,"loans_codigo":68,"itemloans_cuota":"3","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":230,"loans_codigo":68,"itemloans_cuota":"4","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":231,"loans_codigo":68,"itemloans_cuota":"5","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":232,"loans_codigo":68,"itemloans_cuota":"6","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":233,"loans_codigo":68,"itemloans_cuota":"7","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":234,"loans_codigo":68,"itemloans_cuota":"8","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":235,"loans_codigo":68,"itemloans_cuota":"9","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":236,"loans_codigo":68,"itemloans_cuota":"10","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":245,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:14:41
23632	9d689b57-4b07-4f2e-8d61-72ad35d31ab5	9d689b57-4e25-4e6c-bb34-e9c39ce37c33	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":132,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:14:43
23633	9d689b57-b804-48e5-8409-02c9d364b3f1	9d689b57-e2a3-414c-bb3c-a31629d3726b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 08:14:43
23634	9d689b57-d754-43e6-8fb6-e0334b34b4f5	9d689b57-e2a3-414c-bb3c-a31629d3726b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 229 limit 1","time":"3.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 08:14:43
23635	9d689b57-d79d-48c0-9e2b-b79568e48af5	9d689b57-e2a3-414c-bb3c-a31629d3726b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 08:14:43
23636	9d689b57-d92c-4e4b-96ba-93eb30971b4d	9d689b57-e2a3-414c-bb3c-a31629d3726b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 68 limit 1","time":"2.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 08:14:43
23637	9d689b57-d95a-4bce-963d-80c59a4ca82f	9d689b57-e2a3-414c-bb3c-a31629d3726b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 08:14:43
23638	9d689b57-dd41-4520-adf6-3e7677c2dbd1	9d689b57-e2a3-414c-bb3c-a31629d3726b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '250000', \\"itemloans_cuota_cancelada\\" = '1000000', \\"updated_at\\" = '2024-11-04 08:14:43' where \\"id\\" = 229","time":"7.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":400,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 08:14:43
23639	9d689b57-ddab-47d8-a87f-a2ac248d9bfd	9d689b57-e2a3-414c-bb3c-a31629d3726b	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:229","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 08:14:43","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},"hostname":"EderCortes"}	2024-11-04 08:14:43
23640	9d689b57-de50-490d-bb8a-a1de2cb32424	9d689b57-e2a3-414c-bb3c-a31629d3726b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 750000, \\"loans_pago_prestado\\" = 3000000, \\"updated_at\\" = '2024-11-04 08:14:43' where \\"id\\" = 68","time":"0.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":408,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 08:14:43
23641	9d689b57-de84-4a78-ae44-970eb1bd111e	9d689b57-e2a3-414c-bb3c-a31629d3726b	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:68","changes":{"updated_at":"2024-11-04 08:14:43","loans_pago_interes":750000,"loans_pago_prestado":3000000},"hostname":"EderCortes"}	2024-11-04 08:14:43
23642	9d689b57-e175-4c24-a158-23f7a530f993	9d689b57-e2a3-414c-bb3c-a31629d3726b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 08:14:43
23643	9d689b57-e1b7-48c9-940c-ff9660d8b82c	9d689b57-e2a3-414c-bb3c-a31629d3726b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"181","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000","id":229,"loans_codigo":68,"itemloans_cuota":"3","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":256,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:14:43
30741	9d694316-df00-4384-8cd0-6d6bed3e9af3	9d694316-fc1c-4e88-ba7b-5bd1f8b92bb9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:03:46
30742	9d694316-fa6d-438e-a28f-75e4336a5c07	9d694316-fc1c-4e88-ba7b-5bd1f8b92bb9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 16:03:47
30743	9d694316-fb25-41fd-b20e-d9690caa2827	9d694316-fc1c-4e88-ba7b-5bd1f8b92bb9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":242,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:03:47
23644	9d689b58-235e-46aa-8909-51d0f324f0bc	9d689b58-45d8-4b03-8bde-f206e984e3be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 08:14:44
23645	9d689b58-3cad-4734-af13-bd77108ecf0b	9d689b58-45d8-4b03-8bde-f206e984e3be	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 68\\n                        ","time":"48.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"7d9994d55cb8dde82ff4185920c79043","hostname":"EderCortes"}	2024-11-04 08:14:44
23646	9d689b58-407b-43fc-8a13-c58ad278750d	9d689b58-45d8-4b03-8bde-f206e984e3be	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '68' order by \\"item_loans\\".\\"id\\" asc","time":"2.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:14:44
23647	9d689b58-40ab-4999-ace4-006f5832a15c	9d689b58-45d8-4b03-8bde-f206e984e3be	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 08:14:44
23648	9d689b58-449b-4345-bae5-ce084e2afa97	9d689b58-45d8-4b03-8bde-f206e984e3be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 08:14:44
23649	9d689b58-44e6-4e88-a970-3448c7734e96	9d689b58-45d8-4b03-8bde-f206e984e3be	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/68","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":68,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":10000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"3000000","loans_pago_interes":"750000"},"items":[{"id":227,"loans_codigo":68,"itemloans_cuota":"1","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":228,"loans_codigo":68,"itemloans_cuota":"2","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:14:40.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":229,"loans_codigo":68,"itemloans_cuota":"3","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:14:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":230,"loans_codigo":68,"itemloans_cuota":"4","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":231,"loans_codigo":68,"itemloans_cuota":"5","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":232,"loans_codigo":68,"itemloans_cuota":"6","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":233,"loans_codigo":68,"itemloans_cuota":"7","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":234,"loans_codigo":68,"itemloans_cuota":"8","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":235,"loans_codigo":68,"itemloans_cuota":"9","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":236,"loans_codigo":68,"itemloans_cuota":"10","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:14:44
30744	9d694317-4df8-4c26-9a4f-ca7219314098	9d694317-6e52-469f-8f36-90065c7b458a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 16:03:47
30745	9d694317-653b-45db-9b84-ac3ae355dee3	9d694317-6e52-469f-8f36-90065c7b458a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"43.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 16:03:47
30746	9d694317-6939-4356-a7fb-d4e8fcb25fd3	9d694317-6e52-469f-8f36-90065c7b458a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"1.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 16:03:47
30747	9d694317-696f-4ea4-bf42-b0b1ee214973	9d694317-6e52-469f-8f36-90065c7b458a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 16:03:47
30748	9d694317-6d2a-46cc-bafb-fafc31515d64	9d694317-6e52-469f-8f36-90065c7b458a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 16:03:47
23650	9d689b60-9af4-460c-b57e-e21afbbe79fb	9d689b60-9e45-4a75-9f14-5d2cda12f56f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":150,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:14:49
30749	9d694317-6d75-4ca6-9022-9e5022b320b3	9d694317-6e52-469f-8f36-90065c7b458a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder.cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":242,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:03:47
20317	9d66f127-80e5-46f8-983d-089dbe000d49	9d66f127-a192-4f0f-8fa7-735de6c55a33	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:23:01
20318	9d66f127-9ffc-4cdc-a60d-6ef0563e6a49	9d66f127-a192-4f0f-8fa7-735de6c55a33	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 12:23:01
20319	9d66f127-a093-4dd6-a349-d29191114ed5	9d66f127-a192-4f0f-8fa7-735de6c55a33	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:23:01
20320	9d66f127-f05a-42f1-ae07-4da748b92a3a	9d66f128-0f0d-4185-b504-247ab3cd062a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 12:23:01
20321	9d66f128-06b2-47e3-9c3a-be1ab13fc2c7	9d66f128-0f0d-4185-b504-247ab3cd062a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"43.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:23:01
20322	9d66f128-0a29-409d-95f1-8d17c795efb8	9d66f128-0f0d-4185-b504-247ab3cd062a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:23:01
20323	9d66f128-0a59-4c3a-9775-885309a7619e	9d66f128-0f0d-4185-b504-247ab3cd062a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:23:01
20324	9d66f128-0de4-4094-9b02-253036ebc145	9d66f128-0f0d-4185-b504-247ab3cd062a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 12:23:01
20325	9d66f128-0e2a-4eb0-b3da-12f139562bb0	9d66f128-0f0d-4185-b504-247ab3cd062a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:23:01
23651	9d689b61-0752-420e-b924-185f1352713d	9d689b61-28ac-4f22-835e-8135b7bd8fc4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 08:14:49
23652	9d689b61-2011-4e55-883a-f763ace152bc	9d689b61-28ac-4f22-835e-8135b7bd8fc4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 230 limit 1","time":"2.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 08:14:49
23653	9d689b61-2066-458b-a496-c1cd661fb0d8	9d689b61-28ac-4f22-835e-8135b7bd8fc4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 08:14:49
23654	9d689b61-21ef-4938-a856-0d2a2641be00	9d689b61-28ac-4f22-835e-8135b7bd8fc4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 68 limit 1","time":"1.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 08:14:49
23655	9d689b61-2222-46d4-8703-edebadaa0b51	9d689b61-28ac-4f22-835e-8135b7bd8fc4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 08:14:49
23656	9d689b61-2354-493f-81fd-ebddd518a9ed	9d689b61-28ac-4f22-835e-8135b7bd8fc4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '250000', \\"itemloans_cuota_cancelada\\" = '1000000', \\"updated_at\\" = '2024-11-04 08:14:49' where \\"id\\" = 230","time":"1.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":400,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 08:14:49
23657	9d689b61-23a2-496f-bc8a-d21d9213cb50	9d689b61-28ac-4f22-835e-8135b7bd8fc4	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:230","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 08:14:49","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},"hostname":"EderCortes"}	2024-11-04 08:14:49
23658	9d689b61-2449-4519-bc6a-27325402ff7f	9d689b61-28ac-4f22-835e-8135b7bd8fc4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 1000000, \\"loans_pago_prestado\\" = 4000000, \\"updated_at\\" = '2024-11-04 08:14:49' where \\"id\\" = 68","time":"0.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":408,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 08:14:49
23659	9d689b61-2478-4916-aafd-c282487ac393	9d689b61-28ac-4f22-835e-8135b7bd8fc4	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:68","changes":{"updated_at":"2024-11-04 08:14:49","loans_pago_interes":1000000,"loans_pago_prestado":4000000},"hostname":"EderCortes"}	2024-11-04 08:14:49
23660	9d689b61-276b-423d-b7bc-414fe62cc57d	9d689b61-28ac-4f22-835e-8135b7bd8fc4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 08:14:49
20326	9d66f129-7089-41d6-ae28-ce8c36b359e4	9d66f129-a402-4d85-9b47-00b6abd5c752	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 12:23:02
20327	9d66f129-97c2-4422-a2e3-a7fa7a6b840d	9d66f129-a402-4d85-9b47-00b6abd5c752	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"64.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:23:02
20328	9d66f129-987b-4753-9579-caa56600fade	9d66f129-a402-4d85-9b47-00b6abd5c752	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:23:02
20329	9d66f129-a1ee-4ce6-82c4-0e970bce10c8	9d66f129-a402-4d85-9b47-00b6abd5c752	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 12:23:02
20330	9d66f129-a289-4141-8b6a-33033fbe422a	9d66f129-a402-4d85-9b47-00b6abd5c752	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":495,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:23:02
23661	9d689b61-27ac-45b7-bb46-38ed4b97fe7e	9d689b61-28ac-4f22-835e-8135b7bd8fc4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"181","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000","id":230,"loans_codigo":68,"itemloans_cuota":"4","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:14:49
23662	9d689b61-9007-4ba9-a1d9-a2aaaddeb2d0	9d689b61-dca3-4e5b-ad03-31cea49cfbc8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 08:14:50
23663	9d689b61-d226-419c-8feb-5d74c030be2f	9d689b61-dca3-4e5b-ad03-31cea49cfbc8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 68\\n                        ","time":"155.24","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"7d9994d55cb8dde82ff4185920c79043","hostname":"EderCortes"}	2024-11-04 08:14:50
23664	9d689b61-d635-4420-b91e-8fa409bbffcb	9d689b61-dca3-4e5b-ad03-31cea49cfbc8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '68' order by \\"item_loans\\".\\"id\\" asc","time":"2.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:14:50
23665	9d689b61-d666-4bd7-976a-4afa9f45573d	9d689b61-dca3-4e5b-ad03-31cea49cfbc8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 08:14:50
23666	9d689b61-db1c-4ffa-8ccc-14a8be4aec08	9d689b61-dca3-4e5b-ad03-31cea49cfbc8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 08:14:50
23667	9d689b61-db92-4bdf-9a0d-7f97c7438005	9d689b61-dca3-4e5b-ad03-31cea49cfbc8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/68","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":68,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":10000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"4000000","loans_pago_interes":"1000000"},"items":[{"id":227,"loans_codigo":68,"itemloans_cuota":"1","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":228,"loans_codigo":68,"itemloans_cuota":"2","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:14:40.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":229,"loans_codigo":68,"itemloans_cuota":"3","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:14:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":230,"loans_codigo":68,"itemloans_cuota":"4","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:14:49.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":231,"loans_codigo":68,"itemloans_cuota":"5","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":232,"loans_codigo":68,"itemloans_cuota":"6","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":233,"loans_codigo":68,"itemloans_cuota":"7","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":234,"loans_codigo":68,"itemloans_cuota":"8","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":235,"loans_codigo":68,"itemloans_cuota":"9","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":236,"loans_codigo":68,"itemloans_cuota":"10","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":442,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:14:50
23668	9d689b70-8851-4930-8697-873744e8e388	9d689b70-8cfc-4674-8114-0e1f7133d159	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":162,"memory":20,"hostname":"EderCortes"}	2024-11-04 08:15:00
23679	9d689b7b-7d88-44d7-bfed-2ce99f7df57a	9d689b7b-9d99-4443-8576-68c84a1dccb3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 08:15:07
23685	9d689b7d-5df7-4715-b00d-c31fee006958	9d689b7d-7e8b-4e8e-882b-193a107d1a73	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 08:15:08
30897	9d694438-44d5-4051-b28b-a8f6f9ad3d8b	9d694438-8ef5-47af-b2c9-851ff4ac887f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:06:56
30898	9d694438-8d15-48aa-802f-b23c63ca6b78	9d694438-8ef5-47af-b2c9-851ff4ac887f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 16:06:56
30899	9d694438-8df6-48b1-8820-6a6566c97f10	9d694438-8ef5-47af-b2c9-851ff4ac887f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":365,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:06:56
27676	9d68e91f-0d44-42c0-968b-a0bfe8f1b93d	9d68e91f-12b4-4862-9e62-af9cfe42c825	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1290}	2024-11-04 11:52:12
17037	9d6547a3-e9a5-4d5e-bdd5-9d08a4867d66	9d6547a3-ed1a-42b6-a7b9-bf0d168d53aa	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":802}	2024-11-02 16:33:11
30900	9d694438-ec9d-4c0e-824c-da5a4c656a0b	9d694439-0d71-4e92-8a48-69328765779b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 16:06:57
30901	9d694439-03ca-4e62-ae26-130967474be4	9d694439-0d71-4e92-8a48-69328765779b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"46.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 16:06:57
30902	9d694439-07f5-4274-a52e-b400dd5d763a	9d694439-0d71-4e92-8a48-69328765779b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 16:06:57
30903	9d694439-0831-4138-8feb-957ed4b65430	9d694439-0d71-4e92-8a48-69328765779b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 16:06:57
30904	9d694439-0c2f-4af9-96c4-57980b2a5237	9d694439-0d71-4e92-8a48-69328765779b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 16:06:57
30905	9d694439-0c84-4bd9-9adf-53adae655b65	9d694439-0d71-4e92-8a48-69328765779b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder.cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":269,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:06:57
26811	9d68dc5b-a79d-40d0-baff-9399c22bb9a1	9d68dc5b-dc33-4cae-a40d-33c0b65f89e9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:16:31
26812	9d68dc5b-d954-4ef5-ab78-1dd6d8c0455f	9d68dc5b-dc33-4cae-a40d-33c0b65f89e9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:16:31
26813	9d68dc5b-da93-4318-9bbf-e50fb4518b16	9d68dc5b-dc33-4cae-a40d-33c0b65f89e9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":627,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:16:31
26814	9d68dc5c-ac61-47a4-b4cb-7ef56655472a	9d68dc5c-fca7-42ac-b6ee-00384972067c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:16:32
26815	9d68dc5c-f4d3-4329-acd3-b2a181c7f26a	9d68dc5c-fca7-42ac-b6ee-00384972067c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"168.48","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 11:16:32
26816	9d68dc5c-fa89-4323-8163-8504c5cc3361	9d68dc5c-fca7-42ac-b6ee-00384972067c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:16:32
26817	9d68dc5c-fb39-4884-9830-afb9c9f8f76c	9d68dc5c-fca7-42ac-b6ee-00384972067c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":651,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:16:32
26818	9d68dc5d-eca1-46fd-8c9b-3f651680a226	9d68dc5e-7f6c-425f-879c-d9fdeea87725	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:16:33
26819	9d68dc5e-74cd-4e02-95cd-a8bfd4b077a6	9d68dc5e-7f6c-425f-879c-d9fdeea87725	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"266.44","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:16:33
26820	9d68dc5e-757b-4987-919d-02d39c3d8e6e	9d68dc5e-7f6c-425f-879c-d9fdeea87725	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:16:33
26821	9d68dc5e-7d3d-46d4-9c9c-1572343b6950	9d68dc5e-7f6c-425f-879c-d9fdeea87725	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:16:33
26822	9d68dc5e-7dce-44b8-893a-4a23a398d6a5	9d68dc5e-7f6c-425f-879c-d9fdeea87725	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":961,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:16:33
26823	9d68dc5f-6dfc-46fe-814e-d845ef5ae9fa	9d68dc5f-d98f-4552-ad5c-b2f9f97ab157	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:16:34
26824	9d68dc5f-cebb-44b9-b674-2744a5d4ade8	9d68dc5f-d98f-4552-ad5c-b2f9f97ab157	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"200.50","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:16:34
26825	9d68dc5f-cf5d-4a64-a6c2-f4fbf3cccb51	9d68dc5f-d98f-4552-ad5c-b2f9f97ab157	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:16:34
26826	9d68dc5f-d724-43a7-bed0-4845feeaa3d3	9d68dc5f-d98f-4552-ad5c-b2f9f97ab157	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:16:34
26827	9d68dc5f-d7cb-4f50-aa36-2d73c1c91da9	9d68dc5f-d98f-4552-ad5c-b2f9f97ab157	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":860,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:16:34
38907	9d6bc9e7-e82d-4c85-906a-6ea14205623c	9d6bc9ed-696e-42c2-a7a6-3f35f4cd525a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 22:12:25
38908	9d6bc9ec-f8cb-4147-a4ec-ffb07ea22d07	9d6bc9ed-696e-42c2-a7a6-3f35f4cd525a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 22:12:28
38909	9d6bc9ed-3427-48f6-84d9-9fda8cb7d21a	9d6bc9ed-696e-42c2-a7a6-3f35f4cd525a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":31175,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:12:28
36545	9d6b3cfc-780c-450c-8f8d-0e3b15a0b26c	9d6b3cfc-7c38-491f-8f35-9843fbb54c6d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1652}	2024-11-05 15:38:22
27543	9d68e7f8-7243-4792-a952-44c63b58bf33	9d68e7f8-76f5-4613-a390-8f112485dc61	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1283}	2024-11-04 11:48:59
38910	9d6bc9ee-bf98-4618-af11-eb8b4e5d819c	9d6bc9f0-e296-4e88-a930-b7e5c84e371c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 22:12:29
38911	9d6bc9ef-dbb7-4953-b255-8ef5b5e4bb6c	9d6bc9f0-e296-4e88-a930-b7e5c84e371c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"104.07","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:12:30
38912	9d6bc9ef-dc55-4c41-8f16-c86db98e2431	9d6bc9f0-e296-4e88-a930-b7e5c84e371c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:12:30
38913	9d6bc9f0-e13a-4160-894d-88b0488b3a92	9d6bc9f0-e296-4e88-a930-b7e5c84e371c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 22:12:30
38914	9d6bc9f0-e17b-4689-b742-1065fa45bb63	9d6bc9f0-e296-4e88-a930-b7e5c84e371c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":1905,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:12:30
38915	9d6bc9f1-3738-45b0-b0a9-089104bf028d	9d6bc9f1-5bec-4046-9b16-9c152a4f2e2c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 22:12:30
38916	9d6bc9f1-5660-431e-acdf-66bed317ff9c	9d6bc9f1-5bec-4046-9b16-9c152a4f2e2c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"51.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:12:30
38917	9d6bc9f1-56ac-452d-835d-36f3095d9511	9d6bc9f1-5bec-4046-9b16-9c152a4f2e2c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:12:30
38918	9d6bc9f1-5a93-4aaf-a6c7-1451ac3c57e8	9d6bc9f1-5bec-4046-9b16-9c152a4f2e2c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 22:12:30
38919	9d6bc9f1-5afa-4381-ac0f-cb2cc17d8918	9d6bc9f1-5bec-4046-9b16-9c152a4f2e2c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":279,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:12:30
38654	9d6b6b0c-a6bd-41d2-9b1a-dc86a9a778ef	9d6b6b0c-d3e7-4411-a995-ce3543474d9f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 17:47:10
38655	9d6b6b0c-d11d-4ab9-ac78-2dc4c43bb138	9d6b6b0c-d3e7-4411-a995-ce3543474d9f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:47:10
38656	9d6b6b0c-d27f-4994-839b-0698622de3ac	9d6b6b0c-d3e7-4411-a995-ce3543474d9f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":386,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:47:10
15182	9d5ecf42-289c-4531-99eb-fc54989a2d0d	9d5ecf42-2cb1-4c7d-8e75-3763b4731e2b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":685}	2024-10-30 11:21:37
38920	9d6bc9f1-ba03-4dfb-8528-52b854f8b612	9d6bc9f1-ff28-4468-b1ef-bdf2223d1e31	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 22:12:31
38921	9d6bc9f1-f90f-471b-87bd-2a8d3bfe790b	9d6bc9f1-ff28-4468-b1ef-bdf2223d1e31	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"91.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 22:12:31
38922	9d6bc9f1-fd5b-4ad3-bf08-5443599cd165	9d6bc9f1-ff28-4468-b1ef-bdf2223d1e31	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 22:12:31
26944	9d68ddbd-1b66-438e-a697-725618bbccd4	9d68ddbd-4d4e-4118-9bc1-bd8367841ea0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 11:20:23
26945	9d68ddbd-4a30-4556-af77-b91fcfac9c8a	9d68ddbd-4d4e-4118-9bc1-bd8367841ea0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 11:20:23
26946	9d68ddbd-4baf-4690-81c1-312bdb0a5995	9d68ddbd-4d4e-4118-9bc1-bd8367841ea0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":569,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:20:23
26947	9d68ddbd-fe26-432c-8e5b-01c57a145247	9d68ddbe-3276-4322-8a8f-4513b2e2df0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 11:20:23
26948	9d68ddbe-2763-456d-86b2-adc7c5b2600b	9d68ddbe-3276-4322-8a8f-4513b2e2df0d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"67.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:20:23
26949	9d68ddbe-2801-4654-b373-6d9d1a72826c	9d68ddbe-3276-4322-8a8f-4513b2e2df0d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:20:23
26950	9d68ddbe-3045-456a-8ea9-339448b1214c	9d68ddbe-3276-4322-8a8f-4513b2e2df0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 11:20:23
26951	9d68ddbe-30db-4617-9461-cc9ceb31ae6f	9d68ddbe-3276-4322-8a8f-4513b2e2df0d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":508,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:20:23
38923	9d6bc9f1-fdeb-4438-8739-af29b652dcd0	9d6bc9f1-ff28-4468-b1ef-bdf2223d1e31	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":401,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:12:31
38658	9d6b6b0d-497e-4a68-a956-adebf625fc88	9d6b6b0d-53d9-4225-bcbd-66634f983b42	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:47:10
38659	9d6b6b0d-523b-4cf8-abc8-2bda49bd15dd	9d6b6b0d-53d9-4225-bcbd-66634f983b42	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:47:10
38660	9d6b6b0d-52d2-4d8c-b02d-4520121a3938	9d6b6b0d-53d9-4225-bcbd-66634f983b42	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"Undefined array key \\"cobrador\\"","exception":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255,"function":"handleError","class":"Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83,"function":"Illuminate\\\\Foundation\\\\Bootstrap\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"listPrecautions","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":258,"memory":20,"hostname":"EderCortes"}	2024-11-05 17:47:10
26952	9d68ddbe-da30-4443-a1f0-28343cf2d59e	9d68ddbf-048c-4a70-abbd-e4e5ec79944d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 11:20:24
26953	9d68ddbe-fc77-4787-83b9-c2203f4146d2	9d68ddbf-048c-4a70-abbd-e4e5ec79944d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"50.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-04 11:20:24
26954	9d68ddbe-fcef-450e-8810-09a683df993a	9d68ddbf-048c-4a70-abbd-e4e5ec79944d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 11:20:24
26955	9d68ddbf-027b-4661-b798-d1f4d16b27e0	9d68ddbf-048c-4a70-abbd-e4e5ec79944d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 11:20:24
26956	9d68ddbf-0314-4c31-a922-f22db8dd6907	9d68ddbf-048c-4a70-abbd-e4e5ec79944d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":510,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:20:24
38661	9d6b6b0d-d776-44b7-aabb-14fb00211c7b	9d6b6b0d-fb6e-4015-9af0-5d4fe67cf85a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:47:11
38662	9d6b6b0d-f526-43ed-9685-8b7b2e8c8582	9d6b6b0d-fb6e-4015-9af0-5d4fe67cf85a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"51.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:47:11
38663	9d6b6b0d-f572-4880-96b4-9e3f5b2bdb41	9d6b6b0d-fb6e-4015-9af0-5d4fe67cf85a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:47:11
38664	9d6b6b0d-fa33-4d3f-83a8-48d638e52ec4	9d6b6b0d-fb6e-4015-9af0-5d4fe67cf85a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:47:11
38665	9d6b6b0d-fa77-4052-93bd-1cb86f9bd9d1	9d6b6b0d-fb6e-4015-9af0-5d4fe67cf85a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:47:11
38924	9d6bc9f4-8851-43ff-bbad-9c2f57696ac2	9d6bc9f4-a9eb-42ba-8aef-76823b8ab7be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 22:12:33
38925	9d6bc9f4-a475-430e-9afb-fff201222738	9d6bc9f4-a9eb-42ba-8aef-76823b8ab7be	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"49.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 22:12:33
38926	9d6bc9f4-a4c6-40f1-b74f-721c3b1aa870	9d6bc9f4-a9eb-42ba-8aef-76823b8ab7be	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 22:12:33
38927	9d6bc9f4-a88f-48fa-968e-ab3aeae39558	9d6bc9f4-a9eb-42ba-8aef-76823b8ab7be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 22:12:33
38928	9d6bc9f4-a8d4-42b0-ac4c-9c3ebfcb2fb7	9d6bc9f4-a9eb-42ba-8aef-76823b8ab7be	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":551,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:12:33
26957	9d68ddc1-00d8-4640-84c8-8e26f58d5d77	9d68ddc1-2569-4d5b-8765-94f0fdcd5e88	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 11:20:25
26958	9d68ddc1-1e80-4347-857f-f5886550d5dc	9d68ddc1-2569-4d5b-8765-94f0fdcd5e88	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:20:25
26959	9d68ddc1-1eec-4839-b954-b3edd5b08678	9d68ddc1-2569-4d5b-8765-94f0fdcd5e88	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:20:25
26960	9d68ddc1-23d5-4d45-aba7-8696a631d156	9d68ddc1-2569-4d5b-8765-94f0fdcd5e88	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 11:20:25
26961	9d68ddc1-2435-41fc-9e27-83682693ff03	9d68ddc1-2569-4d5b-8765-94f0fdcd5e88	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":463,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:20:25
38666	9d6b6b0e-42a9-4bd4-896d-eae0aa3583b1	9d6b6b0e-618a-45b2-a0ab-8956d1e7be2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:47:11
38667	9d6b6b0e-5bfc-4968-a886-7404c4f49e37	9d6b6b0e-618a-45b2-a0ab-8956d1e7be2b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:47:11
38668	9d6b6b0e-5c53-45d3-aaaa-c9f95820dbcf	9d6b6b0e-618a-45b2-a0ab-8956d1e7be2b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:47:11
38669	9d6b6b0e-6061-4575-a5de-fdf6280adac0	9d6b6b0e-618a-45b2-a0ab-8956d1e7be2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:47:11
38670	9d6b6b0e-60ab-45f0-ac3a-df29dd70f84b	9d6b6b0e-618a-45b2-a0ab-8956d1e7be2b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:47:11
38929	9d6bc9f4-f2da-495b-a8bd-b6e0b67b6b22	9d6bc9f4-f6b1-46f4-bcab-fbcd675009de	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":165,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:12:33
26962	9d68dddb-33e4-47f6-a32c-e3d78ded45c8	9d68dddb-545b-4dd4-a847-34a4b65fd226	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 11:20:42
26963	9d68dddb-4ebe-45eb-beaf-cd7174cb329f	9d68dddb-545b-4dd4-a847-34a4b65fd226	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"44.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 11:20:42
26964	9d68dddb-52bc-4d8f-99e6-4ec3637c4814	9d68dddb-545b-4dd4-a847-34a4b65fd226	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:20:42
26965	9d68dddb-5329-4c25-b03e-e6f6c402dd10	9d68dddb-545b-4dd4-a847-34a4b65fd226	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":379,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:20:42
20587	9d66f79f-70fa-4cc1-9c32-7015cc47b8c2	9d66f79f-91e6-47b6-b2a0-2231292a5681	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 12:41:06
20588	9d66f79f-8fc7-48e8-9e39-a26ed5ed6e3b	9d66f79f-91e6-47b6-b2a0-2231292a5681	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:41:06
20589	9d66f79f-90c4-4d4e-938f-a3d7584b7406	9d66f79f-91e6-47b6-b2a0-2231292a5681	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":256,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:41:06
38671	9d6b6b10-603f-43a9-a3c5-4ab6b9cbc4d9	9d6b6b10-81e5-4cc4-8e5c-a048781dab62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:47:12
38672	9d6b6b10-7b2f-45e4-9e5b-3d3fea108338	9d6b6b10-81e5-4cc4-8e5c-a048781dab62	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:47:13
38673	9d6b6b10-7b8c-4e66-886a-159427af9c0d	9d6b6b10-81e5-4cc4-8e5c-a048781dab62	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:47:13
38674	9d6b6b10-8050-48fd-b83c-4d9e74e9495b	9d6b6b10-81e5-4cc4-8e5c-a048781dab62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:47:13
38675	9d6b6b10-80a5-4268-a8fa-60e45326adb8	9d6b6b10-81e5-4cc4-8e5c-a048781dab62	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":307,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:47:13
38930	9d6bc9f5-b6be-4fb0-9cd5-314c2af0d4ab	9d6bc9f5-d64a-4110-8b2d-42949cedbdf9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 22:12:33
38931	9d6bc9f5-d05e-44fe-8802-14cfa2f176ec	9d6bc9f5-d64a-4110-8b2d-42949cedbdf9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"47.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 22:12:33
38932	9d6bc9f5-d479-4841-a700-386d35d0fab1	9d6bc9f5-d64a-4110-8b2d-42949cedbdf9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 22:12:33
38933	9d6bc9f5-d501-46a1-85d7-e22aeebd51f5	9d6bc9f5-d64a-4110-8b2d-42949cedbdf9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:12:33
20590	9d66f79f-ec1b-426b-a91c-e042d22786f8	9d66f7a0-09d1-4b6c-b5c0-1ee72e3eec35	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:41:06
20591	9d66f7a0-0148-4da7-8be2-a9fe54b1088b	9d66f7a0-09d1-4b6c-b5c0-1ee72e3eec35	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"41.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:41:06
20592	9d66f7a0-0508-4ab8-878c-0105a3d5eaf8	9d66f7a0-09d1-4b6c-b5c0-1ee72e3eec35	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:41:06
20593	9d66f7a0-0541-479d-9c62-f5c50de5c8a8	9d66f7a0-09d1-4b6c-b5c0-1ee72e3eec35	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:41:06
20594	9d66f7a0-08a6-472c-85c7-b73d0e6205e0	9d66f7a0-09d1-4b6c-b5c0-1ee72e3eec35	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:41:06
20595	9d66f7a0-08ec-4e79-953f-913d782d5109	9d66f7a0-09d1-4b6c-b5c0-1ee72e3eec35	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"400000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:40:42.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":null,"itemloans_cuota_cancelada":"100000"},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":242,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:41:06
26966	9d68dde2-a015-4eb5-af2b-24eb2cfbde3c	9d68dde2-c461-45e2-91ea-98436e5ea54d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:20:47
26967	9d68dde2-bde3-48ef-92d8-a242a40ea15c	9d68dde2-c461-45e2-91ea-98436e5ea54d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"45.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-04 11:20:47
26968	9d68dde2-be47-4400-bc69-22b10d3bf7db	9d68dde2-c461-45e2-91ea-98436e5ea54d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 11:20:47
26969	9d68dde2-c2f6-44b3-a615-62560b201557	9d68dde2-c461-45e2-91ea-98436e5ea54d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:20:47
26970	9d68dde2-c346-4d74-a8c9-d68d498312e2	9d68dde2-c461-45e2-91ea-98436e5ea54d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":456,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:20:47
38934	9d6bc9fa-4dc7-48cf-96a6-b8fc92b9cddf	9d6bc9fa-7fd3-4104-b25d-06822c4321ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 22:12:36
20596	9d66f7a2-122f-4bbc-9c32-0252678c0deb	9d66f7a2-33c2-4b4f-95ec-762cd81aaefb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:41:08
20597	9d66f7a2-2e13-4e9d-b65b-58e697c56108	9d66f7a2-33c2-4b4f-95ec-762cd81aaefb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"47.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:41:08
20598	9d66f7a2-2e68-4fa9-8923-9cc52370f4bc	9d66f7a2-33c2-4b4f-95ec-762cd81aaefb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:41:08
20599	9d66f7a2-3261-4c60-a89c-adf3402f78a9	9d66f7a2-33c2-4b4f-95ec-762cd81aaefb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:41:08
20600	9d66f7a2-32ae-4d97-bfa0-6cfeb4bceec2	9d66f7a2-33c2-4b4f-95ec-762cd81aaefb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":323,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:41:08
26971	9d68dde8-e8aa-40e6-a3ea-660dae83cf7f	9d68dde9-03fb-4223-80b8-3b9b293e6774	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:20:51
26972	9d68dde8-ff9e-4196-93a0-0d204ec2851b	9d68dde9-03fb-4223-80b8-3b9b293e6774	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"42.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 11:20:51
23686	9d689b7d-78a4-45a4-8104-4dceedd628ca	9d689b7d-7e8b-4e8e-882b-193a107d1a73	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"46.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 08:15:08
23687	9d689b7d-7904-4f08-83e6-875dc8491376	9d689b7d-7e8b-4e8e-882b-193a107d1a73	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 08:15:08
23688	9d689b7d-7d0d-4a0b-97a9-8e9db47d1675	9d689b7d-7e8b-4e8e-882b-193a107d1a73	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 08:15:08
26973	9d68dde9-0284-4c29-b019-c9756b671454	9d68dde9-03fb-4223-80b8-3b9b293e6774	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:20:51
26974	9d68dde9-02e6-48cb-8159-ab688459a190	9d68dde9-03fb-4223-80b8-3b9b293e6774	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":513,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:20:51
38677	9d6b6b10-d54d-4398-b4c1-0fc21b3299dd	9d6b6b10-e1f6-4a7a-8f67-40bc2f6c56e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:47:13
38678	9d6b6b10-ddbf-4902-a636-766419c8ee2a	9d6b6b10-e1f6-4a7a-8f67-40bc2f6c56e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:47:13
26975	9d68df1f-c13a-4f1d-ac28-4371a3cd841b	9d68df1f-f09b-4bcf-9747-0d84ea806115	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 11:24:15
26976	9d68df1f-e866-4274-9bf4-fee6441e5f8f	9d68df1f-f09b-4bcf-9747-0d84ea806115	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"51.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:24:15
26977	9d68df1f-e8e1-4e64-938b-920ab87361fc	9d68df1f-f09b-4bcf-9747-0d84ea806115	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:24:15
26978	9d68df1f-eed2-45c3-9732-201fa5d816d0	9d68df1f-f09b-4bcf-9747-0d84ea806115	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:24:15
26979	9d68df1f-ef40-43f6-b8fb-8f33508a9342	9d68df1f-f09b-4bcf-9747-0d84ea806115	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":604,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:24:15
38679	9d6b6b10-de87-410c-a14d-6ffd65791906	9d6b6b10-e1f6-4a7a-8f67-40bc2f6c56e0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"0","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"Undefined array key \\"cobrador\\"","exception":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255,"function":"handleError","class":"Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83,"function":"Illuminate\\\\Foundation\\\\Bootstrap\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"listPrecautions","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":216,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:47:13
38935	9d6bc9fa-73c7-42d0-8199-9621b515899e	9d6bc9fa-7fd3-4104-b25d-06822c4321ea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"71.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":338,"hash":"90d4ef06242c93b4a3636d1fa3349e48","hostname":"EderCortes"}	2024-11-05 22:12:36
38936	9d6bc9fa-7938-4a7d-b243-a6e873a23d61	9d6bc9fa-7fd3-4104-b25d-06822c4321ea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"4.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":376,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-05 22:12:36
38937	9d6bc9fa-7dfb-4958-9bff-bcd3668594e4	9d6bc9fa-7fd3-4104-b25d-06822c4321ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 22:12:36
26980	9d68df20-7d96-43a8-8294-496522fbd711	9d68df20-a110-47fd-8005-c5b4f995d3e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:24:16
26981	9d68df20-9848-4025-adc7-27d4595ccb9a	9d68df20-a110-47fd-8005-c5b4f995d3e0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '90' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"45.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 11:24:16
26982	9d68df20-98ae-4dfb-828d-1b9047ffa750	9d68df20-a110-47fd-8005-c5b4f995d3e0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 11:24:16
26983	9d68df20-9a85-4e8b-a786-02f4ebc192b1	9d68df20-a110-47fd-8005-c5b4f995d3e0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"2.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:24:16
26984	9d68df20-9ac6-4ec6-bd7a-5dcb9fdff82b	9d68df20-a110-47fd-8005-c5b4f995d3e0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 11:24:16
26985	9d68df20-9f4d-4954-9c97-5200df1c74b5	9d68df20-a110-47fd-8005-c5b4f995d3e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:24:16
26986	9d68df20-9fc4-4591-8066-6c791d1b0ee8	9d68df20-a110-47fd-8005-c5b4f995d3e0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"275000","loans_pago_prestado":"1100000","loans_intereses_recaudar":"275000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"}]}},"duration":434,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:24:16
38680	9d6b6b40-7b91-4d0d-8de4-6b7d0b2f0cd5	9d6b6b40-7eb4-48fb-913f-d962e66075c9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":180,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:47:44
38938	9d6bc9fa-7e66-45a2-b941-8b3ca32a5f48	9d6bc9fa-7fd3-4104-b25d-06822c4321ea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000","user_alias":"juan_jaramillo"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:33:19","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000","user_alias":"eder.cortes"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:33:19","updated_at":"2024-11-04 09:44:59","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000","user_alias":"eder.cortes"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:33:19","updated_at":"2024-11-04 09:44:59","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000","user_alias":"eder.cortes"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:33:19","updated_at":"2024-11-04 09:44:59","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000","user_alias":"eder.cortes"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:33:19","updated_at":"2024-11-04 09:44:59","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000","user_alias":"eder.cortes"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:33:19","updated_at":"2024-11-04 09:44:59","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000","user_alias":"eder.cortes"}]}},"duration":448,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:12:36
26987	9d68df21-2436-40bf-b942-f3e39213b968	9d68df21-4806-4430-be3b-7991a11ad076	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:24:16
26988	9d68df21-4161-47c0-a384-abafa50e99d4	9d68df21-4806-4430-be3b-7991a11ad076	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:24:16
26989	9d68df21-41cc-448a-aea3-d5856ceedbbf	9d68df21-4806-4430-be3b-7991a11ad076	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 11:24:16
26990	9d68df21-4677-4c30-97c6-45787ec98f4a	9d68df21-4806-4430-be3b-7991a11ad076	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:24:16
26991	9d68df21-46df-4465-bc75-2473d2d1fd71	9d68df21-4806-4430-be3b-7991a11ad076	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":403,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:24:16
38681	9d6b6b41-3b35-4c24-9442-9703ce91380d	9d6b6b41-5aa0-4169-a66e-b9301fc8ccde	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:47:44
38682	9d6b6b41-5532-4658-aec9-9f607914b522	9d6b6b41-5aa0-4169-a66e-b9301fc8ccde	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" where \\"l\\".\\"user_cobrador\\" = 14 and \\"l\\".\\"loans_cuando\\" is null order by \\"l\\".\\"id\\" desc","time":"46.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"797b5790111c94e36346a7a01b6f035a","hostname":"EderCortes"}	2024-11-05 17:47:45
38683	9d6b6b41-58eb-459f-bab5-df76cddc1382	9d6b6b41-5aa0-4169-a66e-b9301fc8ccde	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 17:47:45
38684	9d6b6b41-5931-4f03-a581-e7447dc7a388	9d6b6b41-5aa0-4169-a66e-b9301fc8ccde	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":14,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[]},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:47:45
38939	9d6bca02-2aac-4afb-beb1-19c9c51f910d	9d6bca02-2ecf-4a58-a253-cc2886b0b5ad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":177,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:12:42
26992	9d68df45-862b-4d5d-ad74-81870a1a72e6	9d68df45-a55a-40b7-b3cd-b8f79d590b16	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:24:40
26993	9d68df45-a04d-4e0a-a032-69f0e5383657	9d68df45-a55a-40b7-b3cd-b8f79d590b16	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"51.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 11:24:40
26994	9d68df45-a3e1-4b6f-8b93-2c4ed81d23df	9d68df45-a55a-40b7-b3cd-b8f79d590b16	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:24:40
26995	9d68df45-a446-4956-9731-75bcd91af7f8	9d68df45-a55a-40b7-b3cd-b8f79d590b16	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":378,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:24:40
38940	9d6bca02-90d0-4fd9-873c-0b71be07f1bf	9d6bca02-b3bf-40e7-b392-f89816c011de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 22:12:42
38941	9d6bca02-ad20-4b57-aaa1-2ce9257b619d	9d6bca02-b3bf-40e7-b392-f89816c011de	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:12:42
38942	9d6bca02-ad7c-442f-80c8-15e6089d2d4f	9d6bca02-b3bf-40e7-b392-f89816c011de	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:12:42
38943	9d6bca02-b206-4922-92a9-bc0e2789d08a	9d6bca02-b3bf-40e7-b392-f89816c011de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 22:12:42
38944	9d6bca02-b269-48a0-b60a-0f6328d8853d	9d6bca02-b3bf-40e7-b392-f89816c011de	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":271,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:12:42
26996	9d68dfad-14da-4964-bebe-ecac08b7221a	9d68dfad-45ee-4d1e-a715-d50349be31b4	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 11:25:48
26997	9d68dfad-3d14-4088-8500-c1bcada85276	9d68dfad-45ee-4d1e-a715-d50349be31b4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"55.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:25:48
26998	9d68dfad-3de4-4f7d-aa7d-e2b40944b577	9d68dfad-45ee-4d1e-a715-d50349be31b4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:25:48
26999	9d68dfad-43f4-4be2-a5ee-2661222cfa67	9d68dfad-45ee-4d1e-a715-d50349be31b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:25:48
27000	9d68dfad-4486-41ef-86e8-ee4295824e9d	9d68dfad-45ee-4d1e-a715-d50349be31b4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":452,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:25:48
38945	9d6bca03-03ee-49ad-ac48-01f68f179af9	9d6bca03-4bb8-4911-90d1-453b7656e9db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 22:12:42
38946	9d6bca03-464f-445c-a93c-c6f514888302	9d6bca03-4bb8-4911-90d1-453b7656e9db	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"144.94","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:12:42
38947	9d6bca03-46a7-4ae4-b74e-74442e76615b	9d6bca03-4bb8-4911-90d1-453b7656e9db	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:12:42
38948	9d6bca03-4a47-4f36-8bbf-c68dd60f666c	9d6bca03-4bb8-4911-90d1-453b7656e9db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 22:12:42
38949	9d6bca03-4a91-4614-a20d-13ab9cb282c4	9d6bca03-4bb8-4911-90d1-453b7656e9db	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":371,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:12:42
27001	9d68dfad-e10c-4071-9add-9b1ee55a5eaf	9d68dfae-0137-457e-a453-4a24139d7710	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:25:48
27002	9d68dfad-fc23-43aa-9ccc-75f700609342	9d68dfae-0137-457e-a453-4a24139d7710	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:25:48
27003	9d68dfad-fc72-46cf-a01f-7949c7a92bec	9d68dfae-0137-457e-a453-4a24139d7710	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 11:25:48
27004	9d68dfad-ffd0-4e83-b37e-1de9b62570d7	9d68dfae-0137-457e-a453-4a24139d7710	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:25:48
27005	9d68dfae-0016-4ed6-92cf-4d3c28edfaa8	9d68dfae-0137-457e-a453-4a24139d7710	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":460,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:25:48
38950	9d6bca03-9816-4dbd-9d8a-ec4255cdebef	9d6bca03-b78a-401c-a94e-58d60038b059	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 22:12:42
38951	9d6bca03-b1e3-4af9-96b5-477871607802	9d6bca03-b78a-401c-a94e-58d60038b059	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"45.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 22:12:43
38952	9d6bca03-b5ae-4f10-b89d-1901ddbc494e	9d6bca03-b78a-401c-a94e-58d60038b059	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 22:12:43
38953	9d6bca03-b646-4f5c-ab28-1b9856960421	9d6bca03-b78a-401c-a94e-58d60038b059	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":255,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:12:43
27006	9d68dfae-83aa-48e2-a7a2-31d367490d03	9d68dfae-a17e-497f-b98d-e338b53d4455	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:25:49
27007	9d68dfae-9ad9-48e5-83d5-d019b573f5f5	9d68dfae-a17e-497f-b98d-e338b53d4455	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '90' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"38.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 11:25:49
27008	9d68dfae-9b32-4ca5-b708-bde6416717eb	9d68dfae-a17e-497f-b98d-e338b53d4455	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 11:25:49
27009	9d68dfae-9cd7-4a27-affe-fafc15de49a8	9d68dfae-a17e-497f-b98d-e338b53d4455	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"2.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:25:49
27010	9d68dfae-9d1e-4734-9205-d15bba0309c7	9d68dfae-a17e-497f-b98d-e338b53d4455	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 11:25:49
27011	9d68dfae-a040-489a-8f34-9f5484e8edd4	9d68dfae-a17e-497f-b98d-e338b53d4455	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:25:49
27012	9d68dfae-a08a-4b8f-9468-4271e95be51b	9d68dfae-a17e-497f-b98d-e338b53d4455	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"275000","loans_pago_prestado":"1100000","loans_intereses_recaudar":"275000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"}]}},"duration":395,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:25:49
38954	9d6bca4f-ec82-4bd5-ba25-4c997719cd69	9d6bca50-135a-477c-ac48-aeb9f5b2cddc	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 22:13:32
38955	9d6bca50-09ee-4382-af74-f6f488013281	9d6bca50-135a-477c-ac48-aeb9f5b2cddc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"48.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":338,"hash":"2d7f6944539e3b04500dbfdcf935ad8b","hostname":"EderCortes"}	2024-11-05 22:13:33
27154	9d68e278-850c-44e3-a6c6-343ac20bd222	9d68e278-b887-4da3-a333-326d0d1a86e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 11:33:37
27155	9d68e278-b576-4d1e-a124-1a98c5e245f9	9d68e278-b887-4da3-a333-326d0d1a86e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 11:33:37
27156	9d68e278-b6a7-4108-a034-45a36701f11f	9d68e278-b887-4da3-a333-326d0d1a86e7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":616,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:33:37
38956	9d6bca50-0cee-4b85-aefa-1096b96fd8b8	9d6bca50-135a-477c-ac48-aeb9f5b2cddc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"2.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":376,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-05 22:13:33
38957	9d6bca50-117c-4680-8d73-2eba5d2ce8ad	9d6bca50-135a-477c-ac48-aeb9f5b2cddc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 22:13:33
27013	9d68dfed-dade-4bd1-8da9-fb25abccad2a	9d68dfed-f772-4d05-9a7e-930b73e31643	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:26:30
27014	9d68dfed-f2c4-4fee-bec5-c7c8f7b8f695	9d68dfed-f772-4d05-9a7e-930b73e31643	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"43.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 11:26:30
27015	9d68dfed-f614-43ea-afd0-069d4e4bbfd6	9d68dfed-f772-4d05-9a7e-930b73e31643	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:26:30
27016	9d68dfed-f680-40da-9ff4-5c1891f4f9f2	9d68dfed-f772-4d05-9a7e-930b73e31643	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":363,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:26:30
27157	9d68e279-6b33-47ff-86d6-4b2360c72314	9d68e279-9e6d-4304-a49d-215d2f034182	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 11:33:37
27158	9d68e279-95c5-452c-8a6b-3d31e03a2c08	9d68e279-9e6d-4304-a49d-215d2f034182	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"70.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:33:37
27159	9d68e279-9654-4aa0-9049-52f3693db8be	9d68e279-9e6d-4304-a49d-215d2f034182	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:33:37
27160	9d68e279-9c77-486c-b8de-427dd140dde6	9d68e279-9e6d-4304-a49d-215d2f034182	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 11:33:37
27161	9d68e279-9cfa-4170-9433-93eebb2828ff	9d68e279-9e6d-4304-a49d-215d2f034182	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":513,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:33:37
38958	9d6bca50-11fd-48a5-8915-b0bef6e51b7e	9d6bca50-135a-477c-ac48-aeb9f5b2cddc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0","user_alias":"juan_jaramillo"},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-10-30 10:54:38","updated_at":"2024-10-30 10:54:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null,"user_alias":"eder.cortes"},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":12,"created_at":"2024-10-30 10:54:38","updated_at":"2024-10-30 10:54:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null,"user_alias":"eder.cortes"},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-10-30 10:54:38","updated_at":"2024-10-30 10:54:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null,"user_alias":"eder.cortes"},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":12,"created_at":"2024-10-30 10:54:38","updated_at":"2024-10-30 10:54:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null,"user_alias":"eder.cortes"},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":12,"created_at":"2024-10-30 10:54:38","updated_at":"2024-10-30 10:54:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null,"user_alias":"eder.cortes"}]}},"duration":384,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:13:33
38500	9d6b6553-f0ca-466f-8b5d-9377943f9ac3	9d6b6554-1564-4faf-8253-8537a6a3ea71	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 17:31:10
38501	9d6b6554-134f-4e12-babe-f6548976d90a	9d6b6554-1564-4faf-8253-8537a6a3ea71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:31:10
38502	9d6b6554-1422-44e0-9ee2-5bca6befde60	9d6b6554-1564-4faf-8253-8537a6a3ea71	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":280,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:31:10
27017	9d68dff0-4895-4032-8f2c-2ccdad9d0564	9d68dff0-6778-436a-b8fc-d04c9de4a80a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:26:32
27018	9d68dff0-5eb7-4a4a-b0db-91455c4e2297	9d68dff0-6778-436a-b8fc-d04c9de4a80a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 90\\n                        ","time":"42.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"93c10371e33ace24260de21c3ff3890d","hostname":"EderCortes"}	2024-11-04 11:26:32
27019	9d68dff0-6275-43bc-ada7-3e009d0ccdb2	9d68dff0-6778-436a-b8fc-d04c9de4a80a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"2.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:26:32
27020	9d68dff0-62ab-4ee6-afbf-5787f5a45080	9d68dff0-6778-436a-b8fc-d04c9de4a80a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 11:26:32
27021	9d68dff0-662d-4e61-8d1d-9d86b0e46a80	9d68dff0-6778-436a-b8fc-d04c9de4a80a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:26:32
27022	9d68dff0-6674-49ab-ad4e-a00db7a91599	9d68dff0-6778-436a-b8fc-d04c9de4a80a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"}]}},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:26:32
27162	9d68e27a-4aeb-4a04-af51-4aa29a64c29d	9d68e27a-7a66-40b3-aeff-ff74472a7b70	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 11:33:38
27163	9d68e27a-71a3-4816-a274-c213e920bc5d	9d68e27a-7a66-40b3-aeff-ff74472a7b70	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"60.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:33:38
27164	9d68e27a-722a-4faf-ac89-c22c37cdad96	9d68e27a-7a66-40b3-aeff-ff74472a7b70	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 11:33:38
27165	9d68e27a-7892-426f-bbd8-ba756040e363	9d68e27a-7a66-40b3-aeff-ff74472a7b70	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 11:33:38
27166	9d68e27a-7906-4887-a13c-83643f8df740	9d68e27a-7a66-40b3-aeff-ff74472a7b70	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":531,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:33:38
38503	9d6b6554-9115-4907-83ab-eca9858ac153	9d6b6554-daaf-4de0-af81-4ffcba1887f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:31:11
22068	9d674183-b802-4863-ad50-f094000830e0	9d674183-eb9c-488c-a4c3-c465eca4e3ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-03 16:07:43
22069	9d674183-e8a4-4b33-bfff-3b2ac4000fda	9d674183-eb9c-488c-a4c3-c465eca4e3ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-11-03 16:07:43
22070	9d674183-ea0f-4b75-aa69-0b125296957d	9d674183-eb9c-488c-a4c3-c465eca4e3ba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":457,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:07:43
22071	9d674184-8b98-42aa-bda5-6de864934153	9d674184-bbfa-41d9-8249-bd2cd742b379	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-11-03 16:07:43
22072	9d674184-ab5f-4e56-96b6-2e1f2ff9dc64	9d674184-bbfa-41d9-8249-bd2cd742b379	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 68\\n                        ","time":"60.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"7d9994d55cb8dde82ff4185920c79043","hostname":"EderCortes"}	2024-11-03 16:07:44
22073	9d674184-b19a-4983-bad7-a5e8530fd728	9d674184-bbfa-41d9-8249-bd2cd742b379	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '68' order by \\"item_loans\\".\\"id\\" asc","time":"3.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 16:07:44
22074	9d674184-b1f5-4b5c-b29e-903f18beb73e	9d674184-bbfa-41d9-8249-bd2cd742b379	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 16:07:44
22075	9d674184-b9dd-41f0-ac21-05083adcc6b5	9d674184-bbfa-41d9-8249-bd2cd742b379	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-11-03 16:07:44
22076	9d674184-ba7a-46dc-8a78-7d2addbbde97	9d674184-bbfa-41d9-8249-bd2cd742b379	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/68","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":68,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":10000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"1000000","loans_pago_interes":"250000"},"items":[{"id":227,"loans_codigo":68,"itemloans_cuota":"1","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":228,"loans_codigo":68,"itemloans_cuota":"2","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":229,"loans_codigo":68,"itemloans_cuota":"3","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":230,"loans_codigo":68,"itemloans_cuota":"4","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":231,"loans_codigo":68,"itemloans_cuota":"5","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":232,"loans_codigo":68,"itemloans_cuota":"6","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":233,"loans_codigo":68,"itemloans_cuota":"7","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":234,"loans_codigo":68,"itemloans_cuota":"8","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":235,"loans_codigo":68,"itemloans_cuota":"9","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":236,"loans_codigo":68,"itemloans_cuota":"10","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":457,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:07:44
27023	9d68dffb-e426-402f-a988-fd3655c4aa9d	9d68dffc-2a87-459b-869c-b782fb3d0598	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:26:39
27024	9d68dffc-2618-4ce6-8c15-8f44646ddf2a	9d68dffc-2a87-459b-869c-b782fb3d0598	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"149.69","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 11:26:40
27025	9d68dffc-2915-4dab-9700-a02769d4aa89	9d68dffc-2a87-459b-869c-b782fb3d0598	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:26:40
27026	9d68dffc-297e-4b8b-b51f-0028724a35e3	9d68dffc-2a87-459b-869c-b782fb3d0598	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":493,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:26:40
27167	9d68e27b-ce15-4629-907f-3548abf0f4fa	9d68e27c-1f1f-4f3d-a69e-5a80aae1e3ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 11:33:39
22077	9d674185-d34e-4bc1-bb26-2389471900ad	9d674186-1278-4e7f-a2a3-48342009d774	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-11-03 16:07:44
22078	9d674186-0277-4483-903c-b5ca92ae6952	9d674186-1278-4e7f-a2a3-48342009d774	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"71.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:07:44
22079	9d674186-0317-4c3a-8b02-22306c7d159d	9d674186-1278-4e7f-a2a3-48342009d774	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:07:44
22080	9d674186-0fa2-4fcc-88f2-0e0d7bd29e10	9d674186-1278-4e7f-a2a3-48342009d774	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-11-03 16:07:44
22081	9d674186-1075-487a-b560-c0b1a95af21b	9d674186-1278-4e7f-a2a3-48342009d774	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":846,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:07:44
27027	9d68e007-c963-495d-96ee-8af1090b917e	9d68e007-ea5e-4b7b-817a-d6aeab50e9b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:26:47
27028	9d68e007-df56-4975-9bca-4e82971fb500	9d68e007-ea5e-4b7b-817a-d6aeab50e9b9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 87\\n                        ","time":"42.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"0c61814412b2d318bf70ad1ab6d7de57","hostname":"EderCortes"}	2024-11-04 11:26:47
23689	9d689b7d-7d70-4731-bc9b-cf946098ce76	9d689b7d-7e8b-4e8e-882b-193a107d1a73	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:15:08
27029	9d68e007-e2d4-4d97-ae03-1d533da447f4	9d68e007-ea5e-4b7b-817a-d6aeab50e9b9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '87' order by \\"item_loans\\".\\"id\\" asc","time":"2.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:26:47
27030	9d68e007-e305-470c-bae5-5721ac523a7f	9d68e007-ea5e-4b7b-817a-d6aeab50e9b9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 11:26:47
27031	9d68e007-e6c1-4186-8a6d-5aaafade1c6f	9d68e007-ea5e-4b7b-817a-d6aeab50e9b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:26:47
27168	9d68e27c-16fd-4304-aa03-5fe94a057a82	9d68e27c-1f1f-4f3d-a69e-5a80aae1e3ea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"112.14","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:33:39
27169	9d68e27c-177c-4f7f-a682-a8fd672f7907	9d68e27c-1f1f-4f3d-a69e-5a80aae1e3ea	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:33:39
19519	9d66df45-5cda-496e-ad57-855bdde54357	9d66df45-7a32-4b1d-ab83-d9b620ecda3a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 11:33:00
19520	9d66df45-783d-44a0-9ce9-b4b83f4f7382	9d66df45-7a32-4b1d-ab83-d9b620ecda3a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 11:33:00
19521	9d66df45-78e9-4850-8d60-e5217e8c5f76	9d66df45-7a32-4b1d-ab83-d9b620ecda3a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:33:00
19522	9d66df45-c395-429c-9b39-65e06d7e5528	9d66df45-e016-42a6-ab57-04d0dc75517a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 11:33:01
19523	9d66df45-d7ba-435c-8283-2734c384a919	9d66df45-e016-42a6-ab57-04d0dc75517a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"40.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"bfe40f6c4595319360cf763965a9cb73","hostname":"EderCortes"}	2024-11-03 11:33:01
19524	9d66df45-db96-4869-839a-cf4172fc2788	9d66df45-e016-42a6-ab57-04d0dc75517a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":295,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 11:33:01
19525	9d66df45-dbdd-442b-b5ee-c51a8eb818cb	9d66df45-e016-42a6-ab57-04d0dc75517a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 11:33:01
19526	9d66df45-df15-4323-8f82-4b74be85a4f8	9d66df45-e016-42a6-ab57-04d0dc75517a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 11:33:01
19527	9d66df45-df57-492f-b113-668cfe701141	9d66df45-e016-42a6-ab57-04d0dc75517a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":220,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:33:01
22082	9d674186-a6d0-4e23-9738-496688ae09b3	9d674186-d678-483f-a054-177a9b93dd17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-11-03 16:07:45
22083	9d674186-cd4c-45cc-aa7e-6b8dd8afb3a5	9d674186-d678-483f-a054-177a9b93dd17	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"61.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:07:45
22084	9d674186-cdd7-44a1-9cff-6293748993f1	9d674186-d678-483f-a054-177a9b93dd17	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:07:45
22085	9d674186-d45e-45d5-b449-949351a0d66e	9d674186-d678-483f-a054-177a9b93dd17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-11-03 16:07:45
22086	9d674186-d4e8-48dd-8f56-9b9e71bdbe34	9d674186-d678-483f-a054-177a9b93dd17	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":469,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:07:45
23690	9d689b91-7fec-4e0e-846c-edffb03e2bfa	9d689b91-831d-4fc0-9fe2-ccd766bc19ab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":135,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:15:21
27170	9d68e27c-1d86-42f5-9ebe-4b2b03ab3fca	9d68e27c-1f1f-4f3d-a69e-5a80aae1e3ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 11:33:39
19528	9d66df47-3673-4c15-b7f1-ac9aab588b2f	9d66df47-86a1-4c03-98c7-06b1563cc259	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 11:33:02
19529	9d66df47-804d-4159-8fa8-d4e040bbc977	9d66df47-86a1-4c03-98c7-06b1563cc259	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"162.81","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 11:33:02
19530	9d66df47-80b5-4ae8-befe-bc8a85924369	9d66df47-86a1-4c03-98c7-06b1563cc259	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 11:33:02
19531	9d66df47-8528-4216-9be4-ed626d529db9	9d66df47-86a1-4c03-98c7-06b1563cc259	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 11:33:02
19532	9d66df47-857a-446b-8988-2a8eeb63c260	9d66df47-86a1-4c03-98c7-06b1563cc259	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":523,"memory":22,"hostname":"EderCortes"}	2024-11-03 11:33:02
27032	9d68e007-e714-46cd-9912-a71ae19c9b49	9d68e007-ea5e-4b7b-817a-d6aeab50e9b9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/87","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":87,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":341,"loans_codigo":87,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:18:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":342,"loans_codigo":87,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:18:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":343,"loans_codigo":87,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:18:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":344,"loans_codigo":87,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:18:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":345,"loans_codigo":87,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:18:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:26:47
27171	9d68e27c-1df2-4808-81df-185480bc9bd2	9d68e27c-1f1f-4f3d-a69e-5a80aae1e3ea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1048,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:33:39
23691	9d689b91-ebcb-4b63-8c63-2bb18c0d35f1	9d689b92-0fba-447a-b851-1fc080c2153c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 08:15:21
23692	9d689b92-03f2-4ee4-817e-aa74f9e02040	9d689b92-0fba-447a-b851-1fc080c2153c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 231 limit 1","time":"3.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 08:15:21
23693	9d689b92-0444-48c9-bb23-4782b6c255b7	9d689b92-0fba-447a-b851-1fc080c2153c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 08:15:21
23694	9d689b92-05d5-422c-b314-8572e919d77d	9d689b92-0fba-447a-b851-1fc080c2153c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 68 limit 1","time":"2.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 08:15:21
23695	9d689b92-0620-46a6-8b1d-589da3810983	9d689b92-0fba-447a-b851-1fc080c2153c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 08:15:21
18788	9d669bec-b45f-4f45-b42b-18df70dbebef	9d669bec-b7da-4088-b3f7-5411a9947906	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42883]: Undefined function: 7 ERROR:  no existe la funci\\u00f3n pg_catalog.extract(unknown, text)\\nLINE 14:         EXTRACT(DAY FROM (\\n                 ^\\nHINT:  Ninguna funci\\u00f3n coincide en el nombre y tipos de argumentos. Puede ser necesario agregar conversi\\u00f3n expl\\u00edcita de tipos. (Connection: pgsql, SQL: select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        )) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":914}	2024-11-03 08:24:42
18789	9d669bec-9454-414d-b627-290802158d38	9d669bec-b7da-4088-b3f7-5411a9947906	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 08:24:41
18790	9d669bec-b5de-4bf6-aaf6-b5be0975802d	9d669bec-b7da-4088-b3f7-5411a9947906	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 08:24:42
18791	9d669bec-b6bc-491a-9f53-daaaf5e216b9	9d669bec-b7da-4088-b3f7-5411a9947906	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42883]: Undefined function: 7 ERROR:  no existe la funci\\u00f3n pg_catalog.extract(unknown, text)\\nLINE 14:         EXTRACT(DAY FROM (\\n                 ^\\nHINT:  Ninguna funci\\u00f3n coincide en el nombre y tipos de argumentos. Puede ser necesario agregar conversi\\u00f3n expl\\u00edcita de tipos. (Connection: pgsql, SQL: select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        )) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":319,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:24:42
38504	9d6b6554-d5ba-430e-8fb0-aa23e8b6dd0c	9d6b6554-daaf-4de0-af81-4ffcba1887f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"151.39","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:31:11
27172	9d68e27c-f572-4bc1-b4ce-0a04a4e6105e	9d68e27d-1345-48f2-9e71-42ff571a823c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 11:33:40
27033	9d68e03c-2943-40a7-aee1-973b42e47046	9d68e03c-4e40-4798-8800-56cf74ed0438	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 11:27:21
27034	9d68e03c-4727-459f-ba3e-0f6ec8029e17	9d68e03c-4e40-4798-8800-56cf74ed0438	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"50.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 11:27:22
27035	9d68e03c-4c1d-4fc5-ac05-6f065bb0c339	9d68e03c-4e40-4798-8800-56cf74ed0438	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:27:22
27036	9d68e03c-4cbf-40f6-80dd-d2e0df5e4a5f	9d68e03c-4e40-4798-8800-56cf74ed0438	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":455,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:27:22
27173	9d68e27d-0e28-4dcd-8c92-720f0aae2305	9d68e27d-1345-48f2-9e71-42ff571a823c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:33:40
23696	9d689b92-09e2-488e-8a68-0f2e7622a6dc	9d689b92-0fba-447a-b851-1fc080c2153c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '250000', \\"itemloans_cuota_cancelada\\" = '1000000', \\"updated_at\\" = '2024-11-04 08:15:21' where \\"id\\" = 231","time":"7.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":400,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 08:15:21
23697	9d689b92-0a4a-4d64-a29f-a40947d5d1f4	9d689b92-0fba-447a-b851-1fc080c2153c	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:231","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 08:15:21","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},"hostname":"EderCortes"}	2024-11-04 08:15:21
38505	9d6b6554-d8f8-4236-ab98-f328e39269ed	9d6b6554-daaf-4de0-af81-4ffcba1887f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:31:11
27174	9d68e27d-0e74-41f2-b242-5721f0e65e0e	9d68e27d-1345-48f2-9e71-42ff571a823c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:33:40
27175	9d68e27d-120a-481b-a5ce-b282e14c0792	9d68e27d-1345-48f2-9e71-42ff571a823c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 11:33:40
27037	9d68e043-de2d-4b80-be09-7a317fabc71f	9d68e043-ff75-4495-a653-788e62a3927d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:27:27
27038	9d68e043-f98a-41ae-a3aa-eaaad96ab90d	9d68e043-ff75-4495-a653-788e62a3927d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:27:27
27039	9d68e043-f9da-46c5-897c-73593b3be2dd	9d68e043-ff75-4495-a653-788e62a3927d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:27:27
27040	9d68e043-fde9-42dc-a1f6-31f3e69c232c	9d68e043-ff75-4495-a653-788e62a3927d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:27:27
23698	9d689b92-0afe-48ae-bd07-60febeb50983	9d689b92-0fba-447a-b851-1fc080c2153c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 1250000, \\"loans_pago_prestado\\" = 5000000, \\"updated_at\\" = '2024-11-04 08:15:21' where \\"id\\" = 68","time":"0.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":408,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 08:15:21
27041	9d68e043-fe53-4fd5-afa2-eca6f5e6cb72	9d68e043-ff75-4495-a653-788e62a3927d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":440,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:27:27
27176	9d68e27d-124e-4353-bc63-fe3bb947320d	9d68e27d-1345-48f2-9e71-42ff571a823c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":597,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:33:40
38506	9d6b6554-d965-4b65-aac9-4769671f6309	9d6b6554-daaf-4de0-af81-4ffcba1887f0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":436,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:31:11
38959	9d6bca59-6d40-4418-964c-807fab5edeae	9d6bca59-7144-4dc0-bd9d-0c32c09a0023	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":265,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:13:39
27042	9d68e044-7388-4ce8-85a4-85535915977d	9d68e044-929e-4736-87e9-9277b016ff47	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:27:27
27043	9d68e044-8c7f-4ffb-ae97-7fd445186bba	9d68e044-929e-4736-87e9-9277b016ff47	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:27:27
27044	9d68e044-8cd4-4fe5-9e48-393b04e4b69c	9d68e044-929e-4736-87e9-9277b016ff47	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 11:27:27
27045	9d68e044-910e-4bf4-bfa3-66c6af68c841	9d68e044-929e-4736-87e9-9277b016ff47	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:27:27
23699	9d689b92-0b36-4f75-817a-bc39c6ca6682	9d689b92-0fba-447a-b851-1fc080c2153c	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:68","changes":{"updated_at":"2024-11-04 08:15:21","loans_pago_interes":1250000,"loans_pago_prestado":5000000},"hostname":"EderCortes"}	2024-11-04 08:15:21
23700	9d689b92-0e50-485a-87b3-c5e77be3c990	9d689b92-0fba-447a-b851-1fc080c2153c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 08:15:22
27046	9d68e044-9169-468e-bbad-852bd05392d4	9d68e044-929e-4736-87e9-9277b016ff47	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":363,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:27:27
38507	9d6b6555-24ac-45f0-8afe-4bda38ee161c	9d6b6555-6dec-463b-a6c8-bf3b445b08bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:31:11
38508	9d6b6555-67e8-4c5e-b847-cbf423576b15	9d6b6555-6dec-463b-a6c8-bf3b445b08bf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"149.32","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:31:11
38509	9d6b6555-6855-458c-bc7c-ccae0251c475	9d6b6555-6dec-463b-a6c8-bf3b445b08bf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:31:11
38510	9d6b6555-6cd1-4e3d-9ec7-e73b97aeeb0b	9d6b6555-6dec-463b-a6c8-bf3b445b08bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:31:11
38511	9d6b6555-6d1c-400e-82b1-8359f5a8bf0b	9d6b6555-6dec-463b-a6c8-bf3b445b08bf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":358,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:31:11
38960	9d6bca5a-2e23-495a-b977-d66792812f3b	9d6bca5a-854a-43e9-b334-d6fcd8086143	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 22:13:39
38961	9d6bca5a-5ecd-4eb5-84f4-6752abfcaa58	9d6bca5a-854a-43e9-b334-d6fcd8086143	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 172 limit 1","time":"4.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":435,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-05 22:13:39
38962	9d6bca5a-5f20-4e9c-b284-5a60c7112750	9d6bca5a-854a-43e9-b334-d6fcd8086143	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-05 22:13:39
38963	9d6bca5a-6acf-4d7b-bf8e-78ec99614993	9d6bca5a-854a-43e9-b334-d6fcd8086143	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 59 limit 1","time":"2.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":436,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-05 22:13:39
38964	9d6bca5a-6b05-4a0d-ac15-bfe7675937cf	9d6bca5a-854a-43e9-b334-d6fcd8086143	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-05 22:13:39
38965	9d6bca5a-7899-41fe-a7f7-ed0fab55522e	9d6bca5a-854a-43e9-b334-d6fcd8086143	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '05-11-2024', \\"itemloans_interes_canelado\\" = '50000', \\"itemloans_cuota_cancelada\\" = '100000', \\"updated_at\\" = '2024-11-05 22:13:39' where \\"id\\" = 172","time":"2.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":479,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-05 22:13:39
38966	9d6bca5a-7eae-46a7-ab7b-0caa689f16aa	9d6bca5a-854a-43e9-b334-d6fcd8086143	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:172","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-05 22:13:39","item_loans_cuando_pago":"05-11-2024","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},"hostname":"EderCortes"}	2024-11-05 22:13:39
38967	9d6bca5a-8079-4c46-95eb-63222e12878d	9d6bca5a-854a-43e9-b334-d6fcd8086143	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_estado\\" = 'En curso', \\"loans_fecha_ultimo_pago\\" = '05-11-2024', \\"loans_pago_prestado\\" = 100000, \\"updated_at\\" = '2024-11-05 22:13:39' where \\"id\\" = 59","time":"3.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":487,"hash":"0af121d0921e848be76418f6e502dafb","hostname":"EderCortes"}	2024-11-05 22:13:39
38968	9d6bca5a-80b4-4fed-b3c3-15473b88655e	9d6bca5a-854a-43e9-b334-d6fcd8086143	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:59","changes":{"loans_estado":"En curso","updated_at":"2024-11-05 22:13:39","loans_fecha_ultimo_pago":"05-11-2024","loans_pago_prestado":100000},"hostname":"EderCortes"}	2024-11-05 22:13:39
27047	9d68e045-0b64-4a75-8339-aea82f354e1a	9d68e045-2c82-4e21-9883-6d5ca49c256f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:27:27
27048	9d68e045-24bf-4590-9a2a-9382a9974b80	9d68e045-2c82-4e21-9883-6d5ca49c256f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '87' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"44.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 11:27:27
27049	9d68e045-250c-4998-9f2b-6aed4686db1a	9d68e045-2c82-4e21-9883-6d5ca49c256f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 11:27:27
27050	9d68e045-26da-45d6-83f2-5ebae596531a	9d68e045-2c82-4e21-9883-6d5ca49c256f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '87' order by \\"item_loans\\".\\"id\\" asc","time":"2.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:27:27
27051	9d68e045-2713-446f-80b4-682ff778cfe8	9d68e045-2c82-4e21-9883-6d5ca49c256f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 11:27:27
27052	9d68e045-2b2f-4330-b430-1cbff1869116	9d68e045-2c82-4e21-9883-6d5ca49c256f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:27:27
27053	9d68e045-2b7d-4e98-9d9f-63ce0fbfe7f5	9d68e045-2c82-4e21-9883-6d5ca49c256f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/87","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":87,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:18:38.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"0","loans_pago_prestado":"0","loans_intereses_recaudar":"275000"},"items":[{"id":341,"loans_codigo":87,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:18:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":342,"loans_codigo":87,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:18:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":343,"loans_codigo":87,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:18:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":344,"loans_codigo":87,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:18:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":345,"loans_codigo":87,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:18:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":375,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:27:27
38512	9d6b6555-b6b0-4e45-ae2c-5ee639abe669	9d6b6555-d92c-4da5-a9a0-8d220bc94eec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:31:11
38513	9d6b6555-d328-4827-9721-7769ceb1e71c	9d6b6555-d92c-4da5-a9a0-8d220bc94eec	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:31:11
38514	9d6b6555-d373-4b8c-9122-8b912d3f44df	9d6b6555-d92c-4da5-a9a0-8d220bc94eec	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:31:11
38515	9d6b6555-d73c-4ddb-96bb-4a396cf3ea97	9d6b6555-d92c-4da5-a9a0-8d220bc94eec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:31:11
38516	9d6b6555-d7c4-4ddd-8b5d-e38fe2c3c392	9d6b6555-d92c-4da5-a9a0-8d220bc94eec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:31:11
38969	9d6bca5a-83d7-4a22-b8c5-48028b124924	9d6bca5a-854a-43e9-b334-d6fcd8086143	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 22:13:39
38970	9d6bca5a-8428-45b4-b957-a84c9435ee2e	9d6bca5a-854a-43e9-b334-d6fcd8086143	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"179","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000","id":172,"loans_codigo":59,"itemloans_cuota":"1","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":394,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:13:39
38517	9d6b6557-9804-4ba7-8b88-4cc2a3ae84ba	9d6b6557-e335-4b17-b4f8-16a401506e29	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:31:13
38518	9d6b6557-dd31-4fd9-9cfb-c465fd9fadb3	9d6b6557-e335-4b17-b4f8-16a401506e29	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"151.45","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:31:13
38519	9d6b6557-dd7c-4671-9ecc-41e8d1bd50b9	9d6b6557-e335-4b17-b4f8-16a401506e29	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:31:13
38520	9d6b6557-e1c6-48c7-9b26-2663ee617fb8	9d6b6557-e335-4b17-b4f8-16a401506e29	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:31:13
38521	9d6b6557-e22a-462b-95a4-63ea9626c6c8	9d6b6557-e335-4b17-b4f8-16a401506e29	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":411,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:31:13
38971	9d6bca5a-dc72-4cb1-8f66-e29893cb9fda	9d6bca5a-fcc4-41e0-ac1c-65b52dab0dea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 22:13:40
38972	9d6bca5a-f49d-4a69-bf5c-e681326df283	9d6bca5a-fcc4-41e0-ac1c-65b52dab0dea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"47.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":338,"hash":"2d7f6944539e3b04500dbfdcf935ad8b","hostname":"EderCortes"}	2024-11-05 22:13:40
38973	9d6bca5a-f79a-40f7-a437-3baa84c76355	9d6bca5a-fcc4-41e0-ac1c-65b52dab0dea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"2.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":376,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-05 22:13:40
38974	9d6bca5a-fb70-42fb-a047-7af23cf3eb4f	9d6bca5a-fcc4-41e0-ac1c-65b52dab0dea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 22:13:40
38975	9d6bca5a-fbb5-40ed-8ca4-fbbcbe257cce	9d6bca5a-fcc4-41e0-ac1c-65b52dab0dea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"100000","loans_pago_interes":"0","user_alias":"juan_jaramillo"},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-10-30 10:54:38","updated_at":"2024-11-05 22:13:39","deleted_at":null,"item_loans_cuando_pago":"2024-11-05 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000","user_alias":"eder.cortes"},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":12,"created_at":"2024-10-30 10:54:38","updated_at":"2024-10-30 10:54:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null,"user_alias":"eder.cortes"},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-10-30 10:54:38","updated_at":"2024-10-30 10:54:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null,"user_alias":"eder.cortes"},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":12,"created_at":"2024-10-30 10:54:38","updated_at":"2024-10-30 10:54:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null,"user_alias":"eder.cortes"},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":12,"created_at":"2024-10-30 10:54:38","updated_at":"2024-10-30 10:54:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null,"user_alias":"eder.cortes"}]}},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:13:40
31085	9d6945e4-f80d-44ad-a5a4-e288bfaa6880	9d6945e5-1ee9-411e-8b56-90e9e34e8b58	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 16:11:37
31086	9d6945e5-1d20-44cc-ad0d-127365720dda	9d6945e5-1ee9-411e-8b56-90e9e34e8b58	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:11:37
31087	9d6945e5-1dd3-4981-9cb4-405af6a76c65	9d6945e5-1ee9-411e-8b56-90e9e34e8b58	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:11:37
3911	9d511af0-5ddc-45a7-aea2-66b745ba8aa0	9d511af0-63fa-4815-b46c-56e726c7c12c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":218}	2024-10-23 15:51:38
38976	9d6bca64-9dd7-4d3d-babd-4e0f492186a4	9d6bca64-bd7f-408e-bbea-891e29d70c43	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 22:13:46
38977	9d6bca64-b8a4-4e97-b2d3-2191f7d5a93c	9d6bca64-bd7f-408e-bbea-891e29d70c43	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"56.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":26,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-05 22:13:46
38978	9d6bca64-bc15-4313-8495-45bf67edcc32	9d6bca64-bd7f-408e-bbea-891e29d70c43	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 22:13:46
22418	9d674f10-5752-417a-8325-19e6fbe8cf1c	9d674f10-7d14-46a8-a0da-fc2ac938ea70	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 16:45:36
22419	9d674f10-7b39-42f7-b120-a4505efb7c82	9d674f10-7d14-46a8-a0da-fc2ac938ea70	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 16:45:36
22420	9d674f10-7bee-4076-88d1-3bf4da1d6ec9	9d674f10-7d14-46a8-a0da-fc2ac938ea70	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":456,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:45:36
22421	9d674f10-e6e1-4010-96e6-08d9eda48852	9d674f11-1213-413b-90ee-b1bb8c3e6b69	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 16:45:37
22422	9d674f11-0aa4-4f58-8ace-5286b40856a6	9d674f11-1213-413b-90ee-b1bb8c3e6b69	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"56.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 16:45:37
22423	9d674f11-0b28-43f5-bb3f-d64d8cb9402d	9d674f11-1213-413b-90ee-b1bb8c3e6b69	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 16:45:37
22424	9d674f11-1082-4ec2-8fd2-1d5a8b52e517	9d674f11-1213-413b-90ee-b1bb8c3e6b69	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 16:45:37
22425	9d674f11-10f6-4489-8c40-8622fd781de1	9d674f11-1213-413b-90ee-b1bb8c3e6b69	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":307,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:45:37
31088	9d6945e5-9df1-4d6f-b810-8e3c3ad8f846	9d6945e5-bd59-4669-9247-aa18b2de007d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:11:38
31089	9d6945e5-b790-4d99-86ba-11ef8995c286	9d6945e5-bd59-4669-9247-aa18b2de007d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:11:38
31090	9d6945e5-b7f1-4d87-ac89-7b2efb645769	9d6945e5-bd59-4669-9247-aa18b2de007d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 16:11:38
31091	9d6945e5-bc1a-4c16-9fb1-773d15600412	9d6945e5-bd59-4669-9247-aa18b2de007d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:11:38
31092	9d6945e5-bc72-4d59-a9d2-f984018fced2	9d6945e5-bd59-4669-9247-aa18b2de007d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":291,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:11:38
38522	9d6b655b-893a-4df4-b610-6a7185955397	9d6b655b-b16d-47bb-bfd1-1ff1b5de41b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:31:15
38523	9d6b655b-aa0f-47b3-8de3-976b004921a2	9d6b655b-b16d-47bb-bfd1-1ff1b5de41b1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"62.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:31:15
38524	9d6b655b-af16-4a46-bc72-f61bb3d971a7	9d6b655b-b16d-47bb-bfd1-1ff1b5de41b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:31:15
38525	9d6b655b-afe0-4aa5-89f0-e2711ea388e3	9d6b655b-b16d-47bb-bfd1-1ff1b5de41b1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":311,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:31:15
38979	9d6bca64-bc79-4467-a61b-eefe0100fad8	9d6bca64-bd7f-408e-bbea-891e29d70c43	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:13:46
22426	9d674f11-65d5-40f7-a2ce-a85a90f1cf35	9d674f11-8d1b-45fc-a669-8a4dad0f28a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 16:45:37
22427	9d674f11-8329-4bb1-b619-23adff1a4cc1	9d674f11-8d1b-45fc-a669-8a4dad0f28a1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 16:45:37
22428	9d674f11-8389-44d4-aeae-0ba23a05c361	9d674f11-8d1b-45fc-a669-8a4dad0f28a1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-03 16:45:37
22429	9d674f11-8aff-4a74-96a8-893026236670	9d674f11-8d1b-45fc-a669-8a4dad0f28a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 16:45:37
22430	9d674f11-8ba9-4068-9058-838bece64ee0	9d674f11-8d1b-45fc-a669-8a4dad0f28a1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":293,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:45:37
31093	9d6945e6-0404-45e0-b32c-ecc790e182ce	9d6945e6-23e7-4edb-a518-47bf244b40c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:11:38
31094	9d6945e6-1e36-4bdb-80a8-702559c8dcee	9d6945e6-23e7-4edb-a518-47bf244b40c3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:11:38
23701	9d689b92-0ea5-474c-af36-a280275e6d42	9d689b92-0fba-447a-b851-1fc080c2153c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"181","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000","id":231,"loans_codigo":68,"itemloans_cuota":"5","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:15:22
31095	9d6945e6-1e8b-4012-b311-a4a6a8e69363	9d6945e6-23e7-4edb-a518-47bf244b40c3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 16:11:38
31096	9d6945e6-22ac-428c-acfe-1ed1a41cf80f	9d6945e6-23e7-4edb-a518-47bf244b40c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:11:38
31097	9d6945e6-2302-478b-9fa6-54d038fa4ca2	9d6945e6-23e7-4edb-a518-47bf244b40c3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:11:38
38980	9d6bca66-c635-41f5-a4d1-e2ac7a15a804	9d6bca66-ca33-4171-a5b3-274684bdb095	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":160,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:13:47
38981	9d6bca67-4695-40a5-b600-6d341bb0cc32	9d6bca67-66b3-404e-b2d7-99df894172fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 22:13:48
22668	9d67f8a3-490f-405d-85d1-62911f413a13	9d67f8a3-984b-49dd-8b4a-a05afb4f433b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 00:39:46
22669	9d67f8a3-9648-484a-8d06-2bd9e5d0cf2b	9d67f8a3-984b-49dd-8b4a-a05afb4f433b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 00:39:46
22670	9d67f8a3-972f-49f2-b73b-d66aae966883	9d67f8a3-984b-49dd-8b4a-a05afb4f433b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":421,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:39:46
38982	9d6bca67-6191-4c50-99d8-9c1217f35e9e	9d6bca67-66b3-404e-b2d7-99df894172fa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:13:48
38983	9d6bca67-61dc-46e5-90a7-cd685b71e18e	9d6bca67-66b3-404e-b2d7-99df894172fa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:13:48
38984	9d6bca67-6588-437d-b15b-e00ede4eda48	9d6bca67-66b3-404e-b2d7-99df894172fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 22:13:48
22671	9d67f8a4-0394-46d2-9589-1cf0656798d4	9d67f8a4-4f59-49b4-b9d6-88f250d6d516	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 00:39:46
22672	9d67f8a4-4448-45a3-b4d4-83409b514771	9d67f8a4-4f59-49b4-b9d6-88f250d6d516	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 65\\n                        ","time":"153.41","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6768d7067397538897aacf4d73c43049","hostname":"EderCortes"}	2024-11-04 00:39:47
22673	9d67f8a4-4877-4df7-9c84-81e0adf97194	9d67f8a4-4f59-49b4-b9d6-88f250d6d516	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '65' order by \\"item_loans\\".\\"id\\" asc","time":"2.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 00:39:47
22674	9d67f8a4-48bb-459b-9d5a-0dbe6dae817e	9d67f8a4-4f59-49b4-b9d6-88f250d6d516	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 00:39:47
22675	9d67f8a4-4d9e-4ac1-a3b9-483f8e674426	9d67f8a4-4f59-49b4-b9d6-88f250d6d516	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 00:39:47
22676	9d67f8a4-4e02-4010-a6be-9af095307854	9d67f8a4-4f59-49b4-b9d6-88f250d6d516	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/65","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":65,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":3000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-10 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"90000"},"items":[{"id":207,"loans_codigo":65,"itemloans_cuota":"1","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:46:55.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"90000","itemloans_cuota_cancelada":"300000"},{"id":208,"loans_codigo":65,"itemloans_cuota":"2","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":209,"loans_codigo":65,"itemloans_cuota":"3","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":210,"loans_codigo":65,"itemloans_cuota":"4","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":211,"loans_codigo":65,"itemloans_cuota":"5","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":212,"loans_codigo":65,"itemloans_cuota":"6","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":213,"loans_codigo":65,"itemloans_cuota":"7","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":214,"loans_codigo":65,"itemloans_cuota":"8","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":215,"loans_codigo":65,"itemloans_cuota":"9","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":216,"loans_codigo":65,"itemloans_cuota":"10","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-09-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":390,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:39:47
38985	9d6bca67-65c8-4d63-ab4c-b64d56f30cd2	9d6bca67-66b3-404e-b2d7-99df894172fa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:13:48
20733	9d66fbc9-9790-497a-97b5-bd5cdc368fb6	9d66fbc9-b60d-41d1-a2b8-5c91fb1065a3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:52:45
20734	9d66fbc9-b45a-464e-a671-0d356fdc7059	9d66fbc9-b60d-41d1-a2b8-5c91fb1065a3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:52:45
20735	9d66fbc9-b51f-46f0-a777-d618248453b8	9d66fbc9-b60d-41d1-a2b8-5c91fb1065a3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:52:45
20736	9d66fbca-08f2-46c4-9358-c04c8a7e3fa0	9d66fbca-2823-4957-85b0-b1411a89ce76	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:52:45
20737	9d66fbca-1f5d-42a1-b28d-628ae4b78c4e	9d66fbca-2823-4957-85b0-b1411a89ce76	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"42.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:52:45
20738	9d66fbca-2318-491c-a767-4a694f9a43ab	9d66fbca-2823-4957-85b0-b1411a89ce76	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:52:45
20739	9d66fbca-234b-4e01-95ef-35330219b439	9d66fbca-2823-4957-85b0-b1411a89ce76	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:52:45
20740	9d66fbca-26e1-465d-a6cb-6d892e86a7d7	9d66fbca-2823-4957-85b0-b1411a89ce76	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 12:52:45
20741	9d66fbca-272b-440f-9939-aaa95f7f7714	9d66fbca-2823-4957-85b0-b1411a89ce76	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"400000","loans_pago_interes":"200000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:40:42.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"}]}},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:52:45
22677	9d67f8a6-597c-4717-a25d-cd1bf7d3b5bc	9d67f8a6-79da-49b0-8101-975c3a26072f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 00:39:48
22678	9d67f8a6-74f0-41f9-91ee-a3cac727d9b7	9d67f8a6-79da-49b0-8101-975c3a26072f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 00:39:48
22679	9d67f8a6-753d-458b-a734-305f16400d3f	9d67f8a6-79da-49b0-8101-975c3a26072f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 00:39:48
22680	9d67f8a6-789d-4eea-966a-0bbaff99ceb6	9d67f8a6-79da-49b0-8101-975c3a26072f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 00:39:48
22681	9d67f8a6-78e3-4b96-9754-e4aa78e4f853	9d67f8a6-79da-49b0-8101-975c3a26072f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":276,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:39:48
23702	9d689b92-5b34-4959-a415-5d4a87ceb21d	9d689b92-7d8d-4629-86dc-8d89f2a3537e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 08:15:22
38986	9d6bca67-aa65-40ab-ae1e-7aff3d4f3010	9d6bca67-fb1f-4213-b969-5e5ca2e13afb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 22:13:48
38987	9d6bca67-f323-43a4-8f2e-057ddaccd7e1	9d6bca67-fb1f-4213-b969-5e5ca2e13afb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"163.20","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:13:48
38988	9d6bca67-f384-4c64-afab-ecb7327adda8	9d6bca67-fb1f-4213-b969-5e5ca2e13afb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:13:48
20742	9d66fbcb-d8aa-49f9-b73e-102228d85dff	9d66fbcc-25e9-43ec-9d82-5e2a884480f3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 12:52:46
20743	9d66fbcc-1ccc-4718-a176-c074f61f025e	9d66fbcc-25e9-43ec-9d82-5e2a884480f3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"113.51","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:52:46
20744	9d66fbcc-1d55-4439-ab05-59313ddec56c	9d66fbcc-25e9-43ec-9d82-5e2a884480f3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:52:46
20745	9d66fbcc-23cc-48d4-8857-fefb33afce69	9d66fbcc-25e9-43ec-9d82-5e2a884480f3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 12:52:46
20746	9d66fbcc-2458-4dba-8a3b-6825e7111bea	9d66fbcc-25e9-43ec-9d82-5e2a884480f3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":557,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:52:46
22682	9d67f8b1-0ff0-41ce-971e-a8e9c25ebf30	9d67f8b1-13a5-4bdd-90b6-d59b21b8b9a4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":166,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:39:55
27256	9d68e346-7b57-4931-8b8c-89dc74d8c10c	9d68e346-b743-4ecb-8e84-c0a9ca282c85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:35:52
27257	9d68e346-b3b5-440b-bc11-950f44a44f4f	9d68e346-b743-4ecb-8e84-c0a9ca282c85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:35:52
27258	9d68e346-b51a-4bfe-9ced-4bb76abf3cbb	9d68e346-b743-4ecb-8e84-c0a9ca282c85	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":616,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:35:52
38989	9d6bca67-f912-484d-a572-e860c9803846	9d6bca67-fb1f-4213-b969-5e5ca2e13afb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 22:13:48
22683	9d67f8b1-cb43-4bec-95dc-51c9b7730af6	9d67f8b2-34ad-4c68-8524-c7cd8580c98b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 00:39:55
22684	9d67f8b2-1b14-4272-abed-1f1f403022e9	9d67f8b2-34ad-4c68-8524-c7cd8580c98b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 208 limit 1","time":"2.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 00:39:56
22685	9d67f8b2-1b6c-4d19-a331-9790ad8b37ec	9d67f8b2-34ad-4c68-8524-c7cd8580c98b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 00:39:56
22686	9d67f8b2-1d0e-480e-8569-fd311fee9215	9d67f8b2-34ad-4c68-8524-c7cd8580c98b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 65 limit 1","time":"2.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 00:39:56
20751	9d66fbe4-177e-42ba-b110-c9bbb5ee5088	9d66fbe4-3574-40d4-9f07-ee0fb839b09d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 12:53:02
22687	9d67f8b2-1d41-4263-891c-111ff46b51e8	9d67f8b2-34ad-4c68-8524-c7cd8580c98b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 00:39:56
22688	9d67f8b2-299f-43a9-95e3-aa64a82ef036	9d67f8b2-34ad-4c68-8524-c7cd8580c98b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '90000', \\"itemloans_cuota_cancelada\\" = '300000', \\"updated_at\\" = '2024-11-04 00:39:56' where \\"id\\" = 208","time":"1.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":400,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 00:39:56
22689	9d67f8b2-2f5a-4434-a9a1-9754ea50433c	9d67f8b2-34ad-4c68-8524-c7cd8580c98b	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:208","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 00:39:56","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"90000","itemloans_cuota_cancelada":"300000"},"hostname":"EderCortes"}	2024-11-04 00:39:56
22690	9d67f8b2-300f-41af-bffb-b12952a033ca	9d67f8b2-34ad-4c68-8524-c7cd8580c98b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_fecha_ultimo_pago\\" = '04-11-2024', \\"loans_pago_interes\\" = 180000, \\"loans_pago_prestado\\" = 600000, \\"updated_at\\" = '2024-11-04 00:39:56' where \\"id\\" = 65","time":"0.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":408,"hash":"138ffd5a6aae2847ac945cb6fb277db0","hostname":"EderCortes"}	2024-11-04 00:39:56
22691	9d67f8b2-3047-4315-8428-75558cd9037f	9d67f8b2-34ad-4c68-8524-c7cd8580c98b	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:65","changes":{"updated_at":"2024-11-04 00:39:56","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":180000,"loans_pago_prestado":600000},"hostname":"EderCortes"}	2024-11-04 00:39:56
22692	9d67f8b2-3360-4605-a37b-3aec52228878	9d67f8b2-34ad-4c68-8524-c7cd8580c98b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 00:39:56
22693	9d67f8b2-33a7-4433-9e2e-928f188acf1b	9d67f8b2-34ad-4c68-8524-c7cd8580c98b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"179","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"90000","itemloans_cuota_cancelada":"300000","id":208,"loans_codigo":65,"itemloans_cuota":"2","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":424,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:39:56
27259	9d68e347-7986-40c7-85ab-295c84813ded	9d68e347-aaef-4e43-af88-fc432dfb9c0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:35:52
27260	9d68e347-a39c-4c3e-894e-b25752a4800a	9d68e347-aaef-4e43-af88-fc432dfb9c0d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"64.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:35:52
27261	9d68e347-a425-4dcb-974c-1f8514a4e85b	9d68e347-aaef-4e43-af88-fc432dfb9c0d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:35:52
27262	9d68e347-a908-49a2-b255-706bb4494ff4	9d68e347-aaef-4e43-af88-fc432dfb9c0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:35:52
27263	9d68e347-a96a-4b93-b7f3-42570a3173fa	9d68e347-aaef-4e43-af88-fc432dfb9c0d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":542,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:35:52
22694	9d67f8b2-80cf-4846-95ae-622f97e186dc	9d67f8b2-c7da-4175-bc20-f920120b297d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 00:39:56
22695	9d67f8b2-befc-4b77-b585-021aa79b16f6	9d67f8b2-c7da-4175-bc20-f920120b297d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 65\\n                        ","time":"145.92","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6768d7067397538897aacf4d73c43049","hostname":"EderCortes"}	2024-11-04 00:39:56
22696	9d67f8b2-c27e-4efd-989f-547f362327d0	9d67f8b2-c7da-4175-bc20-f920120b297d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '65' order by \\"item_loans\\".\\"id\\" asc","time":"2.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 00:39:56
22697	9d67f8b2-c2b2-444b-9742-7ead30c48036	9d67f8b2-c7da-4175-bc20-f920120b297d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 00:39:56
20757	9d66fbe6-0c3a-4ca4-90c4-bf006dcfadb8	9d66fbe6-66e5-4af1-bb56-961d5661ff74	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-03 12:53:03
22698	9d67f8b2-c69a-4cc4-9cce-f12474e4049d	9d67f8b2-c7da-4175-bc20-f920120b297d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 00:39:56
22699	9d67f8b2-c6e9-4fd0-b61f-8f65e62ea078	9d67f8b2-c7da-4175-bc20-f920120b297d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/65","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":65,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":3000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-10 00:00:00","loans_pago_prestado":"600000","loans_pago_interes":"180000"},"items":[{"id":207,"loans_codigo":65,"itemloans_cuota":"1","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:46:55.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"90000","itemloans_cuota_cancelada":"300000"},{"id":208,"loans_codigo":65,"itemloans_cuota":"2","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-04T05:39:56.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"90000","itemloans_cuota_cancelada":"300000"},{"id":209,"loans_codigo":65,"itemloans_cuota":"3","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":210,"loans_codigo":65,"itemloans_cuota":"4","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":211,"loans_codigo":65,"itemloans_cuota":"5","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":212,"loans_codigo":65,"itemloans_cuota":"6","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":213,"loans_codigo":65,"itemloans_cuota":"7","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":214,"loans_codigo":65,"itemloans_cuota":"8","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":215,"loans_codigo":65,"itemloans_cuota":"9","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":216,"loans_codigo":65,"itemloans_cuota":"10","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-09-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":353,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:39:56
27264	9d68e348-5adb-4832-8f7e-2e4e59f68489	9d68e348-ae53-4942-abb5-6bc68e2c4ba0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:35:53
27265	9d68e348-a5af-4eb7-ad42-33ff339f1a72	9d68e348-ae53-4942-abb5-6bc68e2c4ba0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"156.40","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:35:53
27266	9d68e348-a63b-42e2-a389-10369b3bba22	9d68e348-ae53-4942-abb5-6bc68e2c4ba0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 11:35:53
27267	9d68e348-acad-4476-bcf1-ec4795316326	9d68e348-ae53-4942-abb5-6bc68e2c4ba0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:35:53
27268	9d68e348-ad3d-4f9a-9a72-b9c0f9542da6	9d68e348-ae53-4942-abb5-6bc68e2c4ba0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":634,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:35:53
22700	9d67f8c2-2d6d-48d4-ad9e-ddf2663510e5	9d67f8c2-3085-4db2-8e5c-ecc8ab8f3e69	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":144,"memory":20,"hostname":"EderCortes"}	2024-11-04 00:40:06
27269	9d68e349-a432-4879-abeb-51c4bec43b83	9d68e349-f12d-4846-a0ea-5d5119887496	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:35:54
27270	9d68e349-e678-4d87-aba5-b64922ec3a12	9d68e349-f12d-4846-a0ea-5d5119887496	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"84.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:35:54
27271	9d68e349-e73f-4aae-b5eb-2a7af98c1885	9d68e349-f12d-4846-a0ea-5d5119887496	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:35:54
27272	9d68e349-ef49-4e51-ad89-2c75ea0286d5	9d68e349-f12d-4846-a0ea-5d5119887496	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:35:54
27273	9d68e349-efe3-4eb0-9d81-b6ba38d4ff7d	9d68e349-f12d-4846-a0ea-5d5119887496	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":800,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:35:54
38990	9d6bca67-f98c-43ea-adff-02b655d00264	9d6bca67-fb1f-4213-b969-5e5ca2e13afb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":362,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:13:48
22701	9d67f8c2-a46c-4b31-8127-efbdbaa4fae9	9d67f8c2-c766-4773-bbc0-de7189367d06	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 00:40:06
22702	9d67f8c2-bd08-4cd5-a355-d73a5ba3b6a0	9d67f8c2-c766-4773-bbc0-de7189367d06	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 209 limit 1","time":"3.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 00:40:07
22703	9d67f8c2-bd5f-4edc-9f04-b7b2bf79837b	9d67f8c2-c766-4773-bbc0-de7189367d06	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 00:40:07
22704	9d67f8c2-bef5-465c-8b43-b72b7b8b5d19	9d67f8c2-c766-4773-bbc0-de7189367d06	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 65 limit 1","time":"1.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 00:40:07
22705	9d67f8c2-bf2d-4c38-aec4-8da48280a30f	9d67f8c2-c766-4773-bbc0-de7189367d06	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 00:40:07
22706	9d67f8c2-c094-45dc-a64e-a13a863ec8a5	9d67f8c2-c766-4773-bbc0-de7189367d06	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '90000', \\"itemloans_cuota_cancelada\\" = '300000', \\"updated_at\\" = '2024-11-04 00:40:07' where \\"id\\" = 209","time":"1.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":400,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 00:40:07
22707	9d67f8c2-c0ec-4228-b3e0-4dd424d60e48	9d67f8c2-c766-4773-bbc0-de7189367d06	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:209","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 00:40:07","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"90000","itemloans_cuota_cancelada":"300000"},"hostname":"EderCortes"}	2024-11-04 00:40:07
22708	9d67f8c2-c18f-46eb-aba2-ad68ad026eef	9d67f8c2-c766-4773-bbc0-de7189367d06	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 270000, \\"loans_pago_prestado\\" = 900000, \\"updated_at\\" = '2024-11-04 00:40:07' where \\"id\\" = 65","time":"0.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":408,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 00:40:07
22709	9d67f8c2-c1cd-4e51-b6b5-6a67bc237509	9d67f8c2-c766-4773-bbc0-de7189367d06	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:65","changes":{"updated_at":"2024-11-04 00:40:07","loans_pago_interes":270000,"loans_pago_prestado":900000},"hostname":"EderCortes"}	2024-11-04 00:40:07
22710	9d67f8c2-c5c7-498c-9250-e1fe54c57f47	9d67f8c2-c766-4773-bbc0-de7189367d06	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 00:40:07
22711	9d67f8c2-c621-449a-a234-44957787bd2c	9d67f8c2-c766-4773-bbc0-de7189367d06	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"179","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"90000","itemloans_cuota_cancelada":"300000","id":209,"loans_codigo":65,"itemloans_cuota":"3","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:40:07
27274	9d68e34a-fdb9-4cdc-943a-d1cca8371bae	9d68e34b-33e1-4d51-81ee-6a03703da400	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:35:55
27275	9d68e34b-295c-4ca0-9f30-c4ab0828454b	9d68e34b-33e1-4d51-81ee-6a03703da400	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"63.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:35:55
27276	9d68e34b-29dd-40eb-901c-b34129289439	9d68e34b-33e1-4d51-81ee-6a03703da400	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:35:55
27277	9d68e34b-31a3-48e5-96d7-20fece0ae454	9d68e34b-33e1-4d51-81ee-6a03703da400	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:35:55
27278	9d68e34b-3230-4d10-bd39-451be3f03a50	9d68e34b-33e1-4d51-81ee-6a03703da400	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":796,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:35:55
38991	9d6bca68-5b00-4b46-884b-781a3db1f523	9d6bca68-8615-44c5-bac4-74ba484ac9ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 22:13:48
22712	9d67f8c3-0eb8-45b9-95d4-3809374417af	9d67f8c3-2f3f-448c-98c9-767645f68943	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 00:40:07
22713	9d67f8c3-24ab-4cef-880e-83c299c82b9d	9d67f8c3-2f3f-448c-98c9-767645f68943	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 65\\n                        ","time":"42.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6768d7067397538897aacf4d73c43049","hostname":"EderCortes"}	2024-11-04 00:40:07
22714	9d67f8c3-28e9-47e5-9580-9b44e180d47b	9d67f8c3-2f3f-448c-98c9-767645f68943	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '65' order by \\"item_loans\\".\\"id\\" asc","time":"2.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 00:40:07
22715	9d67f8c3-291d-4545-a2ad-e450b3accf7d	9d67f8c3-2f3f-448c-98c9-767645f68943	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 00:40:07
22716	9d67f8c3-2deb-4bdd-8932-d06195726ba7	9d67f8c3-2f3f-448c-98c9-767645f68943	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 00:40:07
22717	9d67f8c3-2e3d-449f-87ef-ab21e4478626	9d67f8c3-2f3f-448c-98c9-767645f68943	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/65","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":65,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":3000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-10 00:00:00","loans_pago_prestado":"900000","loans_pago_interes":"270000"},"items":[{"id":207,"loans_codigo":65,"itemloans_cuota":"1","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:46:55.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"90000","itemloans_cuota_cancelada":"300000"},{"id":208,"loans_codigo":65,"itemloans_cuota":"2","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-04T05:39:56.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"90000","itemloans_cuota_cancelada":"300000"},{"id":209,"loans_codigo":65,"itemloans_cuota":"3","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-04T05:40:07.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"90000","itemloans_cuota_cancelada":"300000"},{"id":210,"loans_codigo":65,"itemloans_cuota":"4","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":211,"loans_codigo":65,"itemloans_cuota":"5","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":212,"loans_codigo":65,"itemloans_cuota":"6","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":213,"loans_codigo":65,"itemloans_cuota":"7","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":214,"loans_codigo":65,"itemloans_cuota":"8","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":215,"loans_codigo":65,"itemloans_cuota":"9","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":216,"loans_codigo":65,"itemloans_cuota":"10","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-09-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:40:07
38992	9d6bca68-7e6d-4e00-8c36-6d7a3d059531	9d6bca68-8615-44c5-bac4-74ba484ac9ce	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"65.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 22:13:49
38993	9d6bca68-83d9-42c0-bb3a-a601f2afd4ca	9d6bca68-8615-44c5-bac4-74ba484ac9ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 22:13:49
38994	9d6bca68-8490-42b1-84d8-a01d1b46a5f0	9d6bca68-8615-44c5-bac4-74ba484ac9ce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:13:49
22718	9d67f8e5-4f13-4b93-bd64-599023edf7b0	9d67f8e5-5225-4848-a6b7-04880e819e51	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":129,"memory":20,"hostname":"EderCortes"}	2024-11-04 00:40:29
38995	9d6bca7a-ae77-4327-991b-b854f3062542	9d6bca7a-fadb-4606-a76d-7a40c31aa733	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 22:14:00
38996	9d6bca7a-f30d-43be-9e09-c3d71884f8b4	9d6bca7a-fadb-4606-a76d-7a40c31aa733	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 59\\n                        ","time":"157.01","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":338,"hash":"2d7f6944539e3b04500dbfdcf935ad8b","hostname":"EderCortes"}	2024-11-05 22:14:01
38997	9d6bca7a-f60b-48dc-bae7-bea31c1c1a08	9d6bca7a-fadb-4606-a76d-7a40c31aa733	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '59' order by \\"item_loans\\".\\"id\\" asc","time":"2.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":376,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-05 22:14:01
38998	9d6bca7a-f94d-485e-a336-cca500b7d8a1	9d6bca7a-fadb-4606-a76d-7a40c31aa733	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 22:14:01
38999	9d6bca7a-f9ac-4064-88f0-ad673ea79858	9d6bca7a-fadb-4606-a76d-7a40c31aa733	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/59","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":59,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"100000","loans_pago_interes":"0","user_alias":"juan_jaramillo"},"items":[{"id":172,"loans_codigo":59,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-10-30 10:54:38","updated_at":"2024-11-05 22:13:39","deleted_at":null,"item_loans_cuando_pago":"2024-11-05 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000","user_alias":"eder.cortes"},{"id":173,"loans_codigo":59,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":12,"created_at":"2024-10-30 10:54:38","updated_at":"2024-10-30 10:54:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null,"user_alias":"eder.cortes"},{"id":174,"loans_codigo":59,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-10-30 10:54:38","updated_at":"2024-10-30 10:54:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null,"user_alias":"eder.cortes"},{"id":175,"loans_codigo":59,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-27 00:00:00","itemloans_aprobador":12,"created_at":"2024-10-30 10:54:38","updated_at":"2024-10-30 10:54:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null,"user_alias":"eder.cortes"},{"id":176,"loans_codigo":59,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":12,"created_at":"2024-10-30 10:54:38","updated_at":"2024-10-30 10:54:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null,"user_alias":"eder.cortes"}]}},"duration":407,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:14:01
22719	9d67f956-01c1-4504-be73-487971b9cedc	9d67f956-056c-43cc-a705-70265965c107	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":153,"memory":20,"hostname":"EderCortes"}	2024-11-04 00:41:43
39000	9d6bcb07-47da-4b69-bf0c-c2585826c091	9d6bcb07-4c1f-41cc-9b4f-9ac87a442854	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":154,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:15:33
22720	9d67f9d4-5b13-453f-9b0c-650837320a64	9d67f9d4-5e41-401c-b0a6-e8a577d90278	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":171,"memory":20,"hostname":"EderCortes"}	2024-11-04 00:43:06
39001	9d6bcb07-a13b-4781-8421-d4fc28f10cc9	9d6bcb07-c714-47f0-bb62-c0670438451d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 22:15:33
31247	9d694921-4347-414a-ac6c-be75f1c5804e	9d694921-750b-4c49-9851-4a9549394278	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 16:20:40
31248	9d694921-721f-4523-a243-03bd0dd6dc85	9d694921-750b-4c49-9851-4a9549394278	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:20:40
31249	9d694921-737c-4e34-9826-2d0bf0d3489d	9d694921-750b-4c49-9851-4a9549394278	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":426,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:20:40
39002	9d6bcb07-bf6b-4ef2-af65-341fbd6a5902	9d6bcb07-c714-47f0-bb62-c0670438451d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:15:33
39003	9d6bcb07-bfd4-468d-92fe-a07bf2f920a6	9d6bcb07-c714-47f0-bb62-c0670438451d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:15:33
39004	9d6bcb07-c580-4e47-9d7d-29239c2c648f	9d6bcb07-c714-47f0-bb62-c0670438451d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 22:15:33
39005	9d6bcb07-c5d4-449c-94bd-83b54d03abe0	9d6bcb07-c714-47f0-bb62-c0670438451d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:15:33
21952	9d674148-027d-4cf2-9ddf-81a18ffb73ff	9d674148-53f4-4f83-80fa-78ae6457321d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 16:07:04
21953	9d674148-51d2-40ea-9752-35ad79d03ae8	9d674148-53f4-4f83-80fa-78ae6457321d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 16:07:04
21954	9d674148-52b6-4c06-b1e1-cc40b451c598	9d674148-53f4-4f83-80fa-78ae6457321d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":540,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:07:04
21955	9d674148-c709-4765-ae8c-6eb2e04f6bd8	9d674149-1768-484c-8d19-a337bd569d82	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 16:07:04
21956	9d674149-10af-4b69-8e77-418a6b291fbd	9d674149-1768-484c-8d19-a337bd569d82	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"161.26","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 16:07:04
21957	9d674149-110f-4f29-a88b-cd4f51919d6b	9d674149-1768-484c-8d19-a337bd569d82	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 16:07:04
21958	9d674149-161d-4209-95bf-d0fbc0ccedc1	9d674149-1768-484c-8d19-a337bd569d82	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 16:07:05
21959	9d674149-1672-4d44-a91b-e7199c1da559	9d674149-1768-484c-8d19-a337bd569d82	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":449,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:07:05
22721	9d67f9d4-b462-4400-8673-51c050bac55e	9d67f9d5-0e05-4aec-8345-fffc0ba1e9ac	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 00:43:06
22722	9d67f9d4-fc08-47c8-b7cd-2117daa42263	9d67f9d5-0e05-4aec-8345-fffc0ba1e9ac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 65 limit 1","time":"3.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":498,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 00:43:06
22723	9d67f9d4-fc69-47b2-b69b-9eff8bf1bf24	9d67f9d5-0e05-4aec-8345-fffc0ba1e9ac	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":2,"hostname":"EderCortes"}	2024-11-04 00:43:06
22724	9d67f9d4-fda8-4efa-9c99-a641f2bdef85	9d67f9d5-0e05-4aec-8345-fffc0ba1e9ac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 500769.23076923, \\"loans_pago_prestado\\" = 1669230.7692308, \\"updated_at\\" = '2024-11-04 00:43:06' where \\"id\\" = 65","time":"0.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":554,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 00:43:06
22725	9d67f9d4-fdfe-4646-b4ce-c02e6b4cbb2c	9d67f9d5-0e05-4aec-8345-fffc0ba1e9ac	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:65","changes":{"updated_at":"2024-11-04 00:43:06","loans_pago_interes":500769.23076923075,"loans_pago_prestado":1669230.7692307692},"hostname":"EderCortes"}	2024-11-04 00:43:06
22726	9d67f9d4-ff66-423f-9002-6594d7bcdf40	9d67f9d5-0e05-4aec-8345-fffc0ba1e9ac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 65 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"2.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":561,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 00:43:06
22727	9d67f9d4-ff93-44d1-8750-856e326db896	9d67f9d5-0e05-4aec-8345-fffc0ba1e9ac	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 00:43:06
22728	9d67f9d5-0008-479a-be1a-d605e9c927ce	9d67f9d5-0e05-4aec-8345-fffc0ba1e9ac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = 230769.23076923, \\"itemloans_cuota_cancelada\\" = 769230.76923077, \\"updated_at\\" = '2024-11-04 00:43:06' where \\"id\\" = 210","time":"0.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":568,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 00:43:06
22729	9d67f9d5-002e-4ba4-8c3f-a66d049aa9ee	9d67f9d5-0e05-4aec-8345-fffc0ba1e9ac	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:210","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 00:43:06","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":230769.23076923078,"itemloans_cuota_cancelada":769230.7692307692},"hostname":"EderCortes"}	2024-11-04 00:43:06
22730	9d67f9d5-008d-4cd2-ab9d-32d01ef9ffca	9d67f9d5-0e05-4aec-8345-fffc0ba1e9ac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select count(*) as aggregate from \\"item_loans\\" where \\"loans_codigo\\" = 65 and \\"itemloans_status\\" = 'Pagada'","time":"0.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":576,"hash":"60bd91eaa209a639fc2e8afc20430a4b","hostname":"EderCortes"}	2024-11-04 00:43:06
22731	9d67f9d5-00df-4639-93c8-a5fd286a091a	9d67f9d5-0e05-4aec-8345-fffc0ba1e9ac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"delete from \\"item_loans\\" where \\"loans_codigo\\" = 65 and \\"itemloans_status\\" = 'Pendiente'","time":"0.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":592,"hash":"89bf3c496a8b0746ff5d1219b8dc29e3","hostname":"EderCortes"}	2024-11-04 00:43:06
22732	9d67f9d5-0132-41df-9e8a-0cd9e782a90b	9d67f9d5-0e05-4aec-8345-fffc0ba1e9ac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 65 limit 1","time":"0.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":595,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 00:43:06
22733	9d67f9d5-0220-49fb-b140-fb99d86d005b	9d67f9d5-0e05-4aec-8345-fffc0ba1e9ac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (65, 5, 221794.87179487, -83461.538461538, 'Pendiente', 'Se realiza abono', '04-12-2024', 12, 230769.23076923, 769230.76923077, '2024-11-04 00:43:06', '2024-11-04 00:43:06')","time":"1.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":645,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 00:43:06
22734	9d67f9d5-0246-4ba1-b501-8a31b1b7472e	9d67f9d5-0e05-4aec-8345-fffc0ba1e9ac	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 00:43:06
31250	9d694921-f98a-4767-acde-2dab072573d8	9d694922-23dc-4293-98a1-1124fc0968e6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:20:40
21960	9d674149-65d0-4294-90db-d23f4822932e	9d674149-8895-40ed-8459-f9ff555b75e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 16:07:05
21961	9d674149-82bc-469f-a1c2-45737f61099c	9d674149-8895-40ed-8459-f9ff555b75e3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 16:07:05
21962	9d674149-8339-4078-ad6e-f609b77d6fa7	9d674149-8895-40ed-8459-f9ff555b75e3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-03 16:07:05
21963	9d674149-873c-4a97-a74d-3684e87f0d0c	9d674149-8895-40ed-8459-f9ff555b75e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 16:07:05
21964	9d674149-8795-46d8-9484-07db8316a81d	9d674149-8895-40ed-8459-f9ff555b75e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:07:05
22735	9d67f9d5-02a5-4180-ac2b-8af7c7c99ac8	9d67f9d5-0e05-4aec-8345-fffc0ba1e9ac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (65, 6, 221794.87179487, -83461.538461538, 'Pendiente', 'Se realiza abono', '03-01-2025', 12, 230769.23076923, 769230.76923077, '2024-11-04 00:43:06', '2024-11-04 00:43:06')","time":"0.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":645,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 00:43:06
22736	9d67f9d5-02c1-4c43-9a6b-e9deb4acb901	9d67f9d5-0e05-4aec-8345-fffc0ba1e9ac	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 00:43:06
22737	9d67f9d5-0322-49d7-997f-e291945a1981	9d67f9d5-0e05-4aec-8345-fffc0ba1e9ac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (65, 7, 221794.87179487, -83461.538461538, 'Pendiente', 'Se realiza abono', '02-02-2025', 12, 230769.23076923, 769230.76923077, '2024-11-04 00:43:06', '2024-11-04 00:43:06')","time":"0.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":645,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 00:43:06
22738	9d67f9d5-033e-434f-b6bc-c920b9b50a65	9d67f9d5-0e05-4aec-8345-fffc0ba1e9ac	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 00:43:06
22739	9d67f9d5-039c-4f4e-9771-40c32fec585b	9d67f9d5-0e05-4aec-8345-fffc0ba1e9ac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (65, 8, 221794.87179487, -83461.538461538, 'Pendiente', 'Se realiza abono', '04-03-2025', 12, 230769.23076923, 769230.76923077, '2024-11-04 00:43:06', '2024-11-04 00:43:06')","time":"0.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":645,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 00:43:06
22740	9d67f9d5-03b9-4b53-91d9-523416d8dc93	9d67f9d5-0e05-4aec-8345-fffc0ba1e9ac	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 00:43:06
22741	9d67f9d5-0411-4fa6-b8d7-9ab64ab85760	9d67f9d5-0e05-4aec-8345-fffc0ba1e9ac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (65, 9, 221794.87179487, -83461.538461538, 'Pendiente', 'Se realiza abono', '03-04-2025', 12, 230769.23076923, 769230.76923077, '2024-11-04 00:43:06', '2024-11-04 00:43:06')","time":"0.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":645,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 00:43:06
22742	9d67f9d5-042d-4d6e-889d-84da025b558c	9d67f9d5-0e05-4aec-8345-fffc0ba1e9ac	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 00:43:06
22743	9d67f9d5-048d-4b45-b51f-2ed1176956c7	9d67f9d5-0e05-4aec-8345-fffc0ba1e9ac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (65, 10, 221794.87179487, -83461.538461538, 'Pendiente', 'Se realiza abono', '03-05-2025', 12, 230769.23076923, 769230.76923077, '2024-11-04 00:43:06', '2024-11-04 00:43:06')","time":"0.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":645,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 00:43:06
22744	9d67f9d5-04ae-47f2-aa77-2d5937eb5a87	9d67f9d5-0e05-4aec-8345-fffc0ba1e9ac	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 00:43:06
22745	9d67f9d5-0c15-480f-a2d8-b2319c571b54	9d67f9d5-0e05-4aec-8345-fffc0ba1e9ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 00:43:06
39006	9d6bcb08-18d9-44e9-acde-0713876d4eea	9d6bcb08-3644-4d84-8504-6c54754955cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 22:15:33
22746	9d67f9d5-0c85-45b0-b2ec-136dc3d763c9	9d67f9d5-0e05-4aec-8345-fffc0ba1e9ac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"52","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"1000000","idLoans":65,"idCreador":12},"session":[],"response_status":200,"response":{"message":"El abono fue aplicado exitosamente","status":true},"duration":377,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:43:06
31251	9d694922-179e-4877-b0f1-be08e350ac06	9d694922-23dc-4293-98a1-1124fc0968e6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"61.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 16:20:40
31252	9d694922-1c2d-4df7-a558-03a369236bcd	9d694922-23dc-4293-98a1-1124fc0968e6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '92' order by \\"item_loans\\".\\"id\\" asc","time":"2.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 16:20:40
31253	9d694922-1c77-485e-b4fa-8378bf67b1cf	9d694922-23dc-4293-98a1-1124fc0968e6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":15,"hostname":"EderCortes"}	2024-11-04 16:20:40
21969	9d67414b-035f-4005-a4cf-4c36e4f0b0e6	9d67414b-43ce-447d-9d70-618c8342e3b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 16:07:06
31254	9d694922-225d-44a1-b7dd-5cd93a3afbf5	9d694922-23dc-4293-98a1-1124fc0968e6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:20:41
31255	9d694922-22cd-4c1a-8ea8-4b5686cc2d10	9d694922-23dc-4293-98a1-1124fc0968e6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":92,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":15,"loans_valor_prestado":8000009,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"533333.93333333","loans_pago_interes":"133333.48333333","user_alias":"eder.cortes"},"items":[{"id":379,"loans_codigo":92,"itemloans_cuota":"1","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:13:07.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333"},{"id":380,"loans_codigo":92,"itemloans_cuota":"2","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":381,"loans_codigo":92,"itemloans_cuota":"3","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":382,"loans_codigo":92,"itemloans_cuota":"4","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":383,"loans_codigo":92,"itemloans_cuota":"5","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":384,"loans_codigo":92,"itemloans_cuota":"6","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":385,"loans_codigo":92,"itemloans_cuota":"7","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":386,"loans_codigo":92,"itemloans_cuota":"8","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":387,"loans_codigo":92,"itemloans_cuota":"9","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":388,"loans_codigo":92,"itemloans_cuota":"10","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":389,"loans_codigo":92,"itemloans_cuota":"11","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-31 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":390,"loans_codigo":92,"itemloans_cuota":"12","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":391,"loans_codigo":92,"itemloans_cuota":"13","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-16 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":392,"loans_codigo":92,"itemloans_cuota":"14","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":393,"loans_codigo":92,"itemloans_cuota":"15","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":374,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:20:41
39007	9d6bcb08-313e-4dd6-95ed-17469979d9ca	9d6bcb08-3644-4d84-8504-6c54754955cd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:15:33
39008	9d6bcb08-319c-4e0a-a705-c075838c96ee	9d6bcb08-3644-4d84-8504-6c54754955cd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:15:33
39009	9d6bcb08-34eb-41f4-b420-6f1787f6f5d5	9d6bcb08-3644-4d84-8504-6c54754955cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 22:15:33
31256	9d694924-7339-473d-93eb-b0ea1b7e9003	9d694924-9f8c-4bf1-b01d-1c2696a93736	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:20:42
31257	9d694924-97b5-40f8-9cb1-5c0b9c91a889	9d694924-9f8c-4bf1-b01d-1c2696a93736	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"57.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:20:42
31258	9d694924-9897-4bba-b0e4-a63384d177c3	9d694924-9f8c-4bf1-b01d-1c2696a93736	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:20:42
31259	9d694924-9d6d-40fb-810f-447477c88d2d	9d694924-9f8c-4bf1-b01d-1c2696a93736	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:20:42
21975	9d67414b-fa6f-4f41-aafc-59d3e7ac21a8	9d67414c-a66f-4a5f-888f-3c01dd80f2d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 16:07:06
31260	9d694924-9dff-463a-94bc-b24f6bdba5fe	9d694924-9f8c-4bf1-b01d-1c2696a93736	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":449,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:20:42
39010	9d6bcb08-352b-44b6-91e8-15266c15acb0	9d6bcb08-3644-4d84-8504-6c54754955cd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":263,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:15:33
39011	9d6bcb08-7d02-4f45-9576-6965bba0dd7d	9d6bcb08-994c-4a32-a2a4-1ce7ce7444e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 22:15:33
39012	9d6bcb08-9472-4cfd-885f-fa7d2307f30c	9d6bcb08-994c-4a32-a2a4-1ce7ce7444e4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"43.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 22:15:33
39013	9d6bcb08-97a1-452e-8dd6-63c4ad35d451	9d6bcb08-994c-4a32-a2a4-1ce7ce7444e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 22:15:33
39014	9d6bcb08-982f-4815-8eb4-864448fe1c21	9d6bcb08-994c-4a32-a2a4-1ce7ce7444e4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:15:33
39540	9d6bdda7-b2f7-468b-8d13-0128e2cd56b2	9d6bdda7-d153-4568-a3b1-1029afb75564	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 23:07:38
39541	9d6bdda7-cfab-4e88-a5fa-ee6353dec9be	9d6bdda7-d153-4568-a3b1-1029afb75564	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 23:07:38
39542	9d6bdda7-d050-400d-9101-f0b251e83647	9d6bdda7-d153-4568-a3b1-1029afb75564	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:07:38
39015	9d6bcb11-087b-40c5-884f-6f8f6d63dfa2	9d6bcb11-0baf-4222-9679-d985854642d0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":166,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:15:39
39543	9d6bdda8-2783-4b17-82f5-03c3363ca3e4	9d6bdda8-6be4-4b0c-814f-0bd0b09f96e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 23:07:38
39544	9d6bdda8-66b2-4de8-8961-dadd9a6b6c67	9d6bdda8-6be4-4b0c-814f-0bd0b09f96e4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"143.71","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":89,"hash":"f9f3598e6ad2468770f89917d2ab916c","hostname":"EderCortes"}	2024-11-05 23:07:38
39545	9d6bdda8-6a7d-4645-be3d-46ed2c911d39	9d6bdda8-6be4-4b0c-814f-0bd0b09f96e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 23:07:38
39546	9d6bdda8-6ae8-49f1-8ceb-07d2da263959	9d6bdda8-6be4-4b0c-814f-0bd0b09f96e4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getLoansCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:07:38
39016	9d6bcb11-ba4f-4c41-87d3-8adc9f6444e4	9d6bcb11-d450-4904-8327-35dd66565e24	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 22:15:39
39017	9d6bcb11-cfeb-4667-be63-0608b05943cb	9d6bcb11-d450-4904-8327-35dd66565e24	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" where \\"l\\".\\"loans_cuando\\" = 'S' order by \\"l\\".\\"id\\" desc","time":"39.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"47674f76c8458eeaaea7595a72e119a9","hostname":"EderCortes"}	2024-11-05 22:15:40
39018	9d6bcb11-d2cb-4d11-b070-8ea8090abd3e	9d6bcb11-d450-4904-8327-35dd66565e24	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 22:15:40
39019	9d6bcb11-d324-4e6c-b1b0-441eb80078bb	9d6bcb11-d450-4904-8327-35dd66565e24	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"61","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":"S","estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":207,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:15:40
39547	9d6bdda8-c13c-4458-a982-b425869e6d35	9d6bdda8-e029-4d99-8e3e-fa19d2ba158c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 23:07:38
39548	9d6bdda8-da87-4ba1-82bd-ec8d399e7445	9d6bdda8-e029-4d99-8e3e-fa19d2ba158c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 23:07:38
39549	9d6bdda8-dadd-4bfc-badb-6d5161d925f2	9d6bdda8-e029-4d99-8e3e-fa19d2ba158c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 23:07:38
39550	9d6bdda8-deb7-4a6e-959a-6340c35f4105	9d6bdda8-e029-4d99-8e3e-fa19d2ba158c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 23:07:38
39551	9d6bdda8-defd-4180-8f07-17ad140f27b0	9d6bdda8-e029-4d99-8e3e-fa19d2ba158c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":279,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:07:38
39020	9d6bcb1a-b568-4539-8041-56f099817c4d	9d6bcb1a-b8b5-4d33-9d06-20a09307664b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":315,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:15:45
39552	9d6bdda9-26f0-43e7-9034-d016015e607e	9d6bdda9-452e-4f11-b69a-bcb492acc080	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 23:07:39
39553	9d6bdda9-401a-4097-88e4-0d6bd830374b	9d6bdda9-452e-4f11-b69a-bcb492acc080	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 23:07:39
39261	9d6bcee6-dd95-4db8-86d8-0fe4262cef17	9d6bcee6-fd0e-4429-82f2-04c9256a6824	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 22:26:22
39262	9d6bcee6-fb1d-49cc-b90c-47776e15d455	9d6bcee6-fd0e-4429-82f2-04c9256a6824	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 22:26:23
39263	9d6bcee6-fbd0-412f-ab90-c8f62faa1bfa	9d6bcee6-fd0e-4429-82f2-04c9256a6824	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:26:23
39554	9d6bdda9-4089-4e29-aa97-4c9d78e0a289	9d6bdda9-452e-4f11-b69a-bcb492acc080	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 23:07:39
39555	9d6bdda9-441a-4c15-a2fb-7d805685bc09	9d6bdda9-452e-4f11-b69a-bcb492acc080	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 23:07:39
39556	9d6bdda9-4462-4b70-b928-c21697e0bec6	9d6bdda9-452e-4f11-b69a-bcb492acc080	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":245,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:07:39
39021	9d6bcb1b-6b69-4b25-a9d7-e97153030220	9d6bcb1b-8b2c-4e09-a3e9-387f3e30e344	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 22:15:46
39022	9d6bcb1b-86aa-4f14-9e72-a241e2890438	9d6bcb1b-8b2c-4e09-a3e9-387f3e30e344	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" where \\"l\\".\\"loans_cuando\\" = 'Q' order by \\"l\\".\\"id\\" desc","time":"50.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"47674f76c8458eeaaea7595a72e119a9","hostname":"EderCortes"}	2024-11-05 22:15:46
39023	9d6bcb1b-89cd-4b66-ad43-6fb40371a9d1	9d6bcb1b-8b2c-4e09-a3e9-387f3e30e344	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 22:15:46
39024	9d6bcb1b-8a19-427d-a688-3c9743454c93	9d6bcb1b-8b2c-4e09-a3e9-387f3e30e344	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"61","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":"Q","estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"}]},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:15:46
27392	9d68e44b-19d8-4826-bc1c-50a182591d40	9d68e44b-53db-4169-8cce-89379338f916	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 11:38:42
27393	9d68e44b-5093-414c-a504-f928bcc2ecba	9d68e44b-53db-4169-8cce-89379338f916	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 11:38:43
27394	9d68e44b-5207-4689-b5cb-a39e4b1eb49a	9d68e44b-53db-4169-8cce-89379338f916	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":599,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:38:43
39264	9d6bcee7-5349-4600-9adb-72aa863cdf99	9d6bcee7-59e8-4859-8af9-ed20c647210c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 22:26:23
39265	9d6bcee7-58d4-4998-9c23-ca6c921c795c	9d6bcee7-59e8-4859-8af9-ed20c647210c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 22:26:23
39266	9d6bcee7-591a-4c9a-bf95-6e23065d542e	9d6bcee7-59e8-4859-8af9-ed20c647210c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null}},"duration":183,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:26:23
39557	9d6bddaa-f55b-4cad-a4ea-80c461d65d74	9d6bddab-14ac-40f9-a94e-0e0487b4b3ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 23:07:40
39558	9d6bddab-0f51-49cf-8cdf-3f9c279e916c	9d6bddab-14ac-40f9-a94e-0e0487b4b3ce	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 23:07:40
39559	9d6bddab-0f9f-4913-84d0-2f141a2ad12b	9d6bddab-14ac-40f9-a94e-0e0487b4b3ce	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 23:07:40
39560	9d6bddab-1323-4189-b745-eae71a681ca4	9d6bddab-14ac-40f9-a94e-0e0487b4b3ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 23:07:40
39561	9d6bddab-136c-4784-8404-bd319e2ac981	9d6bddab-14ac-40f9-a94e-0e0487b4b3ce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":352,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:07:40
27395	9d68e44c-2623-4cbb-b233-33e73ac0fe11	9d68e44c-6411-471e-bfdd-4660bef06a0c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 11:38:43
27396	9d68e44c-5a8f-4ed4-a888-f99fb16a83df	9d68e44c-6411-471e-bfdd-4660bef06a0c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"86.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:38:43
27397	9d68e44c-5b20-4f8f-b0c9-56bf92d04eff	9d68e44c-6411-471e-bfdd-4660bef06a0c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:38:43
27398	9d68e44c-620b-404a-a50f-6d6ffc41c1fa	9d68e44c-6411-471e-bfdd-4660bef06a0c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 11:38:43
27399	9d68e44c-6295-49d3-88cd-a9c47076127a	9d68e44c-6411-471e-bfdd-4660bef06a0c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":613,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:38:43
39025	9d6bcb21-a2e9-421e-947a-832a6629742d	9d6bcb21-a6f4-4e1b-8d61-8e0410bb384c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":159,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:15:50
39267	9d6bcee7-de18-4926-8a38-fd2449caff4f	9d6bcee8-236a-4f8e-ad4b-54aa44405f0c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 22:26:23
31400	9d694b8e-7faa-42da-949e-f4a331b1137c	9d694b8e-c0ca-420d-9cc8-cb4c394db9b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:27:27
31401	9d694b8e-b991-4d57-b9b7-a8eefd21f91c	9d694b8e-c0ca-420d-9cc8-cb4c394db9b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:27:27
31402	9d694b8e-bb2d-4e75-9c7b-357aec236123	9d694b8e-c0ca-420d-9cc8-cb4c394db9b3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":480,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:27:27
39268	9d6bcee8-1e12-4844-9fb8-5eb58ff8c8bb	9d6bcee8-236a-4f8e-ad4b-54aa44405f0c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"139.63","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:26:23
39269	9d6bcee8-1e67-43e7-a947-c08d2451a6d7	9d6bcee8-236a-4f8e-ad4b-54aa44405f0c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:26:23
39270	9d6bcee8-221e-4acb-891a-ecbb2fbb4fc7	9d6bcee8-236a-4f8e-ad4b-54aa44405f0c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 22:26:23
39271	9d6bcee8-227b-4811-9d17-9829cde97a93	9d6bcee8-236a-4f8e-ad4b-54aa44405f0c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:26:23
39562	9d6bddab-5812-4613-87c0-36b54917fa8d	9d6bddab-5b24-4e87-87d8-e81410409db7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":153,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:07:40
27400	9d68e44d-0578-441b-8ef1-353340b524a3	9d68e44d-3988-4159-a3d3-db68a8cb5fa1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 11:38:44
27401	9d68e44d-2f98-4d50-953d-d3b65eed090e	9d68e44d-3988-4159-a3d3-db68a8cb5fa1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"65.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:38:44
27402	9d68e44d-302f-444e-8592-41d4ba97319e	9d68e44d-3988-4159-a3d3-db68a8cb5fa1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 11:38:44
27403	9d68e44d-375d-4a97-a14b-af1eadcd5dfa	9d68e44d-3988-4159-a3d3-db68a8cb5fa1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 11:38:44
27404	9d68e44d-37f3-4b8a-87e5-066e2ec72aa7	9d68e44d-3988-4159-a3d3-db68a8cb5fa1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":522,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:38:44
31403	9d694b8f-7899-4286-b21f-f4f35427b832	9d694b8f-b141-4bc2-9138-ecd96894a3c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:27:28
31404	9d694b8f-a2a9-4493-89ee-3472e005d8b2	9d694b8f-b141-4bc2-9138-ecd96894a3c9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"82.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 16:27:28
31405	9d694b8f-a7cf-4e16-a2f7-3c1a324be83f	9d694b8f-b141-4bc2-9138-ecd96894a3c9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" inner join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '92' order by \\"item_loans\\".\\"id\\" asc","time":"4.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":304,"hash":"ac513f13416666eb3a5127ebc04741a7","hostname":"EderCortes"}	2024-11-04 16:27:28
31406	9d694b8f-af00-499e-93ad-7bf7427de9bb	9d694b8f-b141-4bc2-9138-ecd96894a3c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:27:28
31407	9d694b8f-afac-4ef7-9f8e-07eeb26c2481	9d694b8f-b141-4bc2-9138-ecd96894a3c9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":92,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":15,"loans_valor_prestado":8000009,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"533333.93333333","loans_pago_interes":"133333.48333333","user_alias":"eder.cortes"},"items":[{"id":379,"loans_codigo":92,"itemloans_cuota":"1","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:13:07","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":380,"loans_codigo":92,"itemloans_cuota":"2","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":381,"loans_codigo":92,"itemloans_cuota":"3","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":382,"loans_codigo":92,"itemloans_cuota":"4","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":383,"loans_codigo":92,"itemloans_cuota":"5","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":384,"loans_codigo":92,"itemloans_cuota":"6","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":385,"loans_codigo":92,"itemloans_cuota":"7","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":386,"loans_codigo":92,"itemloans_cuota":"8","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":387,"loans_codigo":92,"itemloans_cuota":"9","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-15 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":388,"loans_codigo":92,"itemloans_cuota":"10","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":389,"loans_codigo":92,"itemloans_cuota":"11","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-31 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":390,"loans_codigo":92,"itemloans_cuota":"12","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":391,"loans_codigo":92,"itemloans_cuota":"13","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-16 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":392,"loans_codigo":92,"itemloans_cuota":"14","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":393,"loans_codigo":92,"itemloans_cuota":"15","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":502,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:27:28
39026	9d6bcb22-591e-425c-9516-9541479d6050	9d6bcb22-7420-4f59-866c-1d72eeee4956	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 22:15:50
39272	9d6bcee8-65c4-4d83-9905-8a5d5be3be56	9d6bcee8-8476-4dc3-b0d2-4eba9119e3e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 22:26:23
39273	9d6bcee8-7f26-4db9-a0ce-bd69d2ff0484	9d6bcee8-8476-4dc3-b0d2-4eba9119e3e7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:26:24
31408	9d694b90-bad2-4674-b279-cdee270dc207	9d694b91-9397-4102-9b45-1af6ff1ad7da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:27:29
31409	9d694b91-8905-4a39-a875-7ef45b6571be	9d694b91-9397-4102-9b45-1af6ff1ad7da	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"392.12","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:27:29
27405	9d68e44e-66bc-45d1-8eca-b7ecddc2f97f	9d68e44e-a6fa-4ef7-8c73-9d029a578e24	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 11:38:45
24812	9d68bd69-13f1-472a-90f7-bd1bccc11dba	9d68bd69-305a-4cee-9152-b3b80fe50b81	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 09:49:59
24813	9d68bd69-2ed1-4d04-a14f-ec96deff7385	9d68bd69-305a-4cee-9152-b3b80fe50b81	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 09:49:59
24814	9d68bd69-2f5f-40b2-bd09-54f829ab200c	9d68bd69-305a-4cee-9152-b3b80fe50b81	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":367,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:49:59
31410	9d694b91-8994-4b7a-bbe8-30706292520b	9d694b91-9397-4102-9b45-1af6ff1ad7da	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:27:29
27406	9d68e44e-9918-41d4-a5d7-b408afd4cd78	9d68e44e-a6fa-4ef7-8c73-9d029a578e24	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"82.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:38:45
27407	9d68e44e-99ee-4caf-bb19-ecc87a66b132	9d68e44e-a6fa-4ef7-8c73-9d029a578e24	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:38:45
27408	9d68e44e-a45a-4cf7-9172-be6fa5a1d480	9d68e44e-a6fa-4ef7-8c73-9d029a578e24	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 11:38:45
27409	9d68e44e-a503-4ab7-ac23-4decbf10e524	9d68e44e-a6fa-4ef7-8c73-9d029a578e24	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":908,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:38:45
31411	9d694b91-918d-42d9-88c8-37ad87ab5dab	9d694b91-9397-4102-9b45-1af6ff1ad7da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:27:29
31412	9d694b91-9230-44ed-9b0e-aa8f083fb4ec	9d694b91-9397-4102-9b45-1af6ff1ad7da	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1178,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:27:29
39027	9d6bcb22-6fd8-4db7-98f4-ee0f6d8870a4	9d6bcb22-7420-4f59-866c-1d72eeee4956	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" where \\"l\\".\\"loans_cuando\\" = 'M' order by \\"l\\".\\"id\\" desc","time":"41.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"47674f76c8458eeaaea7595a72e119a9","hostname":"EderCortes"}	2024-11-05 22:15:50
39028	9d6bcb22-72e1-4e56-bc77-61e245a65700	9d6bcb22-7420-4f59-866c-1d72eeee4956	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 22:15:50
39274	9d6bcee8-7f82-44fd-a41f-7e12907c569e	9d6bcee8-8476-4dc3-b0d2-4eba9119e3e7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:26:24
39275	9d6bcee8-82eb-44e7-a818-1c8944e698db	9d6bcee8-8476-4dc3-b0d2-4eba9119e3e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 22:26:24
39563	9d6bddab-de92-4e92-adf6-cdbec8e950a5	9d6bddab-fea6-4e18-abff-cd4bffdf650b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 23:07:40
24815	9d68bd69-ab1c-4daa-8416-895d382e33db	9d68bd69-ccea-4524-ab82-b1dd2239e30d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 09:49:59
24816	9d68bd69-c3ae-4833-825e-30809473216c	9d68bd69-ccea-4524-ab82-b1dd2239e30d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 66\\n                        ","time":"50.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"f5566f306d2be9466f2c4564ce0020bd","hostname":"EderCortes"}	2024-11-04 09:49:59
24817	9d68bd69-c7a5-4a08-9fcc-fdcb78a19798	9d68bd69-ccea-4524-ab82-b1dd2239e30d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '66' order by \\"item_loans\\".\\"id\\" asc","time":"2.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:49:59
24818	9d68bd69-c7dd-42a0-a75f-5dcdb23f8b05	9d68bd69-ccea-4524-ab82-b1dd2239e30d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 09:49:59
24819	9d68bd69-cbb2-4cd5-8d25-8d14672578f0	9d68bd69-ccea-4524-ab82-b1dd2239e30d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 09:49:59
24820	9d68bd69-cc04-427e-8c1e-065bee89b2f5	9d68bd69-ccea-4524-ab82-b1dd2239e30d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/66","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":66,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":5000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"5000000","loans_pago_interes":"1250000"},"items":[{"id":217,"loans_codigo":66,"itemloans_cuota":"1","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:26.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":218,"loans_codigo":66,"itemloans_cuota":"2","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":219,"loans_codigo":66,"itemloans_cuota":"3","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":220,"loans_codigo":66,"itemloans_cuota":"4","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:33.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":221,"loans_codigo":66,"itemloans_cuota":"5","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":222,"loans_codigo":66,"itemloans_cuota":"6","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:39.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":223,"loans_codigo":66,"itemloans_cuota":"7","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:42.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":224,"loans_codigo":66,"itemloans_cuota":"8","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:46.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":225,"loans_codigo":66,"itemloans_cuota":"9","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-31 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:50.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":226,"loans_codigo":66,"itemloans_cuota":"10","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:31:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"}]}},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:49:59
27410	9d68e44f-7bf1-48b0-93a7-832846ca79e6	9d68e44f-a575-4bcf-9d3f-bc74497e6efc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 11:38:45
27411	9d68e44f-9ebc-470f-af97-2ec34ae590eb	9d68e44f-a575-4bcf-9d3f-bc74497e6efc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"55.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:38:45
27412	9d68e44f-9f1f-4492-bbad-76ac5a610b1c	9d68e44f-a575-4bcf-9d3f-bc74497e6efc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:38:45
27413	9d68e44f-a3f4-438f-a897-a83931d82547	9d68e44f-a575-4bcf-9d3f-bc74497e6efc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 11:38:45
27414	9d68e44f-a455-4c80-8c51-615116b47ea9	9d68e44f-a575-4bcf-9d3f-bc74497e6efc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":625,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:38:45
31413	9d694b93-a9c6-4fbf-961e-5efea67657ce	9d694b94-0fda-4224-89c6-b3ec3c5cf121	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:27:30
31329	9d694a2a-4e16-4ffc-9136-3339f8726305	9d694a2a-7e88-479d-8390-cec4f4990df4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:23:34
31330	9d694a2a-7355-43c3-b76a-12cb280c141c	9d694a2a-7e88-479d-8390-cec4f4990df4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"60.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 16:23:34
31331	9d694a2a-7c1c-4caa-a1a8-561f9e12a66c	9d694a2a-7e88-479d-8390-cec4f4990df4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:23:34
31332	9d694a2a-7d1e-46f9-b198-95846830367d	9d694a2a-7e88-479d-8390-cec4f4990df4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abas\\u00bb\\nLINE 1: select * from \\"item_loans\\".* as \\"users.user_alias\\" inner joi...\\n                                     ^ (Connection: pgsql, SQL: select * from \\"item_loans\\".* as \\"users.user_alias\\" inner join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"loans_codigo\\" = 92 order by \\"item_loans\\".\\"id\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":305,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":619,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:23:34
31414	9d694b94-032e-4204-8fc0-6f7676b95293	9d694b94-0fda-4224-89c6-b3ec3c5cf121	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"182.53","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:27:31
31415	9d694b94-03d9-4c47-90b6-4847fde56f8b	9d694b94-0fda-4224-89c6-b3ec3c5cf121	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:27:31
31416	9d694b94-0c3f-4781-b4bd-ce1c30301855	9d694b94-0fda-4224-89c6-b3ec3c5cf121	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 16:27:31
31417	9d694b94-0ce3-471d-b7e8-accae2825b4e	9d694b94-0fda-4224-89c6-b3ec3c5cf121	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1599,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:27:31
27415	9d68e45a-5177-4bfe-989e-16fc97ee5f9f	9d68e45a-54c6-4ab1-8020-87b507e482f3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":140,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:38:52
31333	9d694aa3-18ac-4147-9865-cc616310cce1	9d694aa3-6e56-4708-987f-3e39a53f55a3	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 16:24:53
31334	9d694aa3-6745-45d0-9979-000470b927f6	9d694aa3-6e56-4708-987f-3e39a53f55a3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"161.01","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:24:53
31335	9d694aa3-67af-40e9-a84e-af956e54a37d	9d694aa3-6e56-4708-987f-3e39a53f55a3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 16:24:53
31336	9d694aa3-6cf4-4297-9dec-402f56bfdf82	9d694aa3-6e56-4708-987f-3e39a53f55a3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:24:53
31337	9d694aa3-6d4c-4c9c-b24a-0f904396d941	9d694aa3-6e56-4708-987f-3e39a53f55a3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":415,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:24:53
39029	9d6bcb22-732b-4d3d-9cc4-6c2766fbba10	9d6bcb22-7420-4f59-866c-1d72eeee4956	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"61","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":"M","estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"}]},"duration":218,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:15:50
39276	9d6bcee8-834d-45d3-825c-8248232ebd3d	9d6bcee8-8476-4dc3-b0d2-4eba9119e3e7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:26:24
39564	9d6bddab-f95e-434a-ab67-5234fced955e	9d6bddab-fea6-4e18-abff-cd4bffdf650b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"49.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":89,"hash":"f9f3598e6ad2468770f89917d2ab916c","hostname":"EderCortes"}	2024-11-05 23:07:40
39565	9d6bddab-fd38-4ae9-a626-3bf9e698fe9c	9d6bddab-fea6-4e18-abff-cd4bffdf650b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 23:07:40
27416	9d68e45a-afbf-4ade-9e2b-2d086ea50659	9d68e45a-b9f4-4710-94a7-fa6238d42d77	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":146,"memory":20,"hostname":"EderCortes"}	2024-11-04 11:38:53
39277	9d6bceea-0ec1-4a2d-bebd-cb49aba9e458	9d6bceea-3eec-4cd1-aadf-dbe818f56717	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 22:26:25
39278	9d6bceea-35a5-4799-8870-a051434fd698	9d6bceea-3eec-4cd1-aadf-dbe818f56717	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"64.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 22:26:25
23307	9d6892c3-10c8-4cde-8b35-8ae0ab6425d8	9d6892c3-3c2a-4bd3-99b2-dcb012dc0a05	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 07:50:44
23308	9d6892c3-3967-4561-9c0d-62167cb8196f	9d6892c3-3c2a-4bd3-99b2-dcb012dc0a05	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 07:50:44
23309	9d6892c3-3a7f-400f-b7fd-73724bd01a2f	9d6892c3-3c2a-4bd3-99b2-dcb012dc0a05	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":398,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:50:44
25158	9d68bfee-e786-4aea-99c0-da074eb525b7	9d68bfef-545c-429a-bc32-04a01de7ad9c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 09:57:02
25159	9d68bfef-5109-4bee-9aa7-3ae0cb4e3775	9d68bfef-545c-429a-bc32-04a01de7ad9c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 09:57:02
25160	9d68bfef-5292-4144-938a-62c10b711ca5	9d68bfef-545c-429a-bc32-04a01de7ad9c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":914,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:57:02
39279	9d6bceea-3629-4047-a499-2fef20e0e76d	9d6bceea-3eec-4cd1-aadf-dbe818f56717	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 22:26:25
39280	9d6bceea-3cc6-46d7-b31c-2ee3c5a0c781	9d6bceea-3eec-4cd1-aadf-dbe818f56717	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 22:26:25
39281	9d6bceea-3d52-4e67-ad97-b5bb6018bdbb	9d6bceea-3eec-4cd1-aadf-dbe818f56717	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":479,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:26:25
39566	9d6bddab-fd97-4612-b9db-78dc623123c9	9d6bddab-fea6-4e18-abff-cd4bffdf650b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getLoansCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":245,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:07:40
23310	9d6892c3-b256-473b-b2e9-a2a0cd35571f	9d6892c4-0744-47ab-af12-2bf58667e3f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 07:50:44
23311	9d6892c3-f979-4970-be72-0ffafcc60607	9d6892c4-0744-47ab-af12-2bf58667e3f9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 70\\n                        ","time":"163.85","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"40345ecc36d5b014fbb2cca663c7c347","hostname":"EderCortes"}	2024-11-04 07:50:44
23312	9d6892c3-fee1-4252-96b5-8d84cb84f01f	9d6892c4-0744-47ab-af12-2bf58667e3f9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '70' order by \\"item_loans\\".\\"id\\" asc","time":"2.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 07:50:44
23313	9d6892c3-ff25-4d43-b1ba-039628e57708	9d6892c4-0744-47ab-af12-2bf58667e3f9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 07:50:44
23314	9d6892c4-0590-4274-9dcc-3eee4aa93eb8	9d6892c4-0744-47ab-af12-2bf58667e3f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 07:50:44
23315	9d6892c4-05fc-4dcd-b996-d6088e55799e	9d6892c4-0744-47ab-af12-2bf58667e3f9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/70","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":70,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":2150000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1950000","loans_pago_interes":"487500"},"items":[{"id":248,"loans_codigo":70,"itemloans_cuota":"1","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:52:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"107500","itemloans_cuota_cancelada":"430000"},{"id":249,"loans_codigo":70,"itemloans_cuota":"2","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T12:35:02.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"140000","itemloans_cuota_cancelada":"560000"},{"id":253,"loans_codigo":70,"itemloans_cuota":"3","itemloans_valor_cuota":"386666.66666667","itemloans_iteres":"96666.666666667","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T12:35:02.000000Z","updated_at":"2024-11-04T12:38:20.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"120000","itemloans_cuota_cancelada":"480000"},{"id":256,"loans_codigo":70,"itemloans_cuota":"4","itemloans_valor_cuota":"340000","itemloans_iteres":"85000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T12:38:20.000000Z","updated_at":"2024-11-04T12:50:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"120000","itemloans_cuota_cancelada":"480000"},{"id":258,"loans_codigo":70,"itemloans_cuota":"5","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T12:50:01.000000Z","updated_at":"2024-11-04T12:50:01.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":426,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:50:44
25161	9d68bfef-ee50-45fc-90b1-72f170c6c0a6	9d68bff0-0d6d-41ea-a3d0-95a4f037bed1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 09:57:03
25162	9d68bff0-048a-48fe-a1c4-7ee55668ac41	9d68bff0-0d6d-41ea-a3d0-95a4f037bed1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"43.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 09:57:03
25163	9d68bff0-083a-477f-a678-c039b146805a	9d68bff0-0d6d-41ea-a3d0-95a4f037bed1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:57:03
25164	9d68bff0-086f-4b3c-93ec-12ea45c858c4	9d68bff0-0d6d-41ea-a3d0-95a4f037bed1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 09:57:03
25165	9d68bff0-0c0b-4afa-aede-dfb47871ca32	9d68bff0-0d6d-41ea-a3d0-95a4f037bed1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 09:57:03
27417	9d68e45b-4195-4e98-949b-f42ede343376	9d68e45b-5fa3-411a-ac73-b469eb440089	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 11:38:53
27418	9d68e45b-5b22-49b2-ac27-4ba22073bb25	9d68e45b-5fa3-411a-ac73-b469eb440089	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ma%' or \\"users\\".\\"user_document\\"::text like '%Ma%') order by \\"users\\".\\"user_document\\" asc","time":"48.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 11:38:53
23316	9d6892c6-4678-4cbb-a750-87a4c076fa22	9d6892c6-6888-4e79-b655-546f90457505	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 07:50:46
23317	9d6892c6-608d-490e-88d8-0baf756f7b88	9d6892c6-6888-4e79-b655-546f90457505	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 07:50:46
23318	9d6892c6-60da-4d0d-a155-f98f8a0c6267	9d6892c6-6888-4e79-b655-546f90457505	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 07:50:46
23319	9d6892c6-648e-415f-bb5e-b54dcf5a647e	9d6892c6-6888-4e79-b655-546f90457505	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 07:50:46
23320	9d6892c6-64f4-4068-a9a9-23c9fcbbd553	9d6892c6-6888-4e79-b655-546f90457505	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-11-04 07:50:46
25166	9d68bff0-0c58-42d4-a0b0-cd047c51f30b	9d68bff0-0d6d-41ea-a3d0-95a4f037bed1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":400,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:57:03
27419	9d68e45b-5e56-48e4-bde7-6da3b445fdb4	9d68e45b-5fa3-411a-ac73-b469eb440089	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 11:38:53
27420	9d68e45b-5ea7-4afa-b182-2cd4c2715687	9d68e45b-5fa3-411a-ac73-b469eb440089	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ma"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":353,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:38:53
39282	9d6bceea-b577-4f48-8f12-fb17cf87cb66	9d6bceea-b9ea-462c-b005-3506916f69df	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":274,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:26:25
39567	9d6bddb3-0a51-4938-8ec1-2d4bd25c329b	9d6bddb3-0de1-4833-8d60-7153eed1a23e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":156,"memory":20,"hostname":"EderCortes"}	2024-11-05 23:07:45
25167	9d68bff0-bb86-4277-b555-793c02f87dcc	9d68bff0-f5a2-47a5-a6f4-1ea6d6d23fbe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 09:57:03
25168	9d68bff0-e931-488a-a155-774552e97931	9d68bff0-f5a2-47a5-a6f4-1ea6d6d23fbe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"70.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:57:03
25169	9d68bff0-e9ff-4698-82d8-65d6cc6a5e21	9d68bff0-f5a2-47a5-a6f4-1ea6d6d23fbe	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:57:03
25170	9d68bff0-f324-4370-a92d-de82e3f60940	9d68bff0-f5a2-47a5-a6f4-1ea6d6d23fbe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 09:57:03
25171	9d68bff0-f3cb-42c5-962f-6c5c75bcccb9	9d68bff0-f5a2-47a5-a6f4-1ea6d6d23fbe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":578,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:57:03
27421	9d68e45b-d89a-40f1-b984-6b5be5d0e657	9d68e45b-f367-4f9e-b295-1d704d9d8536	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 11:38:53
27422	9d68e45b-ef0b-4a36-9d9c-f1176358e37c	9d68e45b-f367-4f9e-b295-1d704d9d8536	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mar%' or \\"users\\".\\"user_document\\"::text like '%Mar%') order by \\"users\\".\\"user_document\\" asc","time":"41.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 11:38:53
27423	9d68e45b-f233-4bec-86d3-518ce289d601	9d68e45b-f367-4f9e-b295-1d704d9d8536	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 11:38:53
27424	9d68e45b-f27a-4977-b526-d503a7f28453	9d68e45b-f367-4f9e-b295-1d704d9d8536	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mar"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":369,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:38:53
39283	9d6bceeb-70ce-4496-9fa1-5605d7c246c7	9d6bceeb-78b4-4fd0-b06f-096b88968fea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 22:26:25
39284	9d6bceeb-7756-4f5d-9dcf-2108af4c37af	9d6bceeb-78b4-4fd0-b06f-096b88968fea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 22:26:25
39285	9d6bceeb-77a4-48e6-b5a6-81e36ab0ad54	9d6bceeb-78b4-4fd0-b06f-096b88968fea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null}},"duration":183,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:26:25
39568	9d6bddb3-7307-42d6-84aa-30214c8eca66	9d6bddb3-932d-41b3-ac04-f96997d782e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 23:07:45
39569	9d6bddb3-8e2c-49fb-9103-0e34f90d8276	9d6bddb3-932d-41b3-ac04-f96997d782e8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" where \\"l\\".\\"user_cobrador\\" = 14 order by \\"l\\".\\"id\\" desc","time":"51.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":89,"hash":"16e7ca2a46d6db2eca0924d1509baaa1","hostname":"EderCortes"}	2024-11-05 23:07:45
39570	9d6bddb3-9191-4c16-a3ca-da8191d29cd1	9d6bddb3-932d-41b3-ac04-f96997d782e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 23:07:45
25172	9d68bff1-a051-46ab-97fe-650ce80a300e	9d68bff1-cdd5-4fb4-a162-3725155cc3a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 09:57:04
25173	9d68bff1-c6cf-4037-9b86-78db9ace0251	9d68bff1-cdd5-4fb4-a162-3725155cc3a4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"59.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:57:04
25174	9d68bff1-c744-42e3-9487-d4899465bd6e	9d68bff1-cdd5-4fb4-a162-3725155cc3a4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:57:04
25175	9d68bff1-cc38-422c-8162-c87dae076448	9d68bff1-cdd5-4fb4-a162-3725155cc3a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 09:57:04
25176	9d68bff1-ccb3-4450-88f2-691471424fb9	9d68bff1-cdd5-4fb4-a162-3725155cc3a4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":528,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:57:04
27425	9d68e45d-5254-48fe-b30b-08304c403436	9d68e45d-5562-480d-85fe-bcf71b59cf95	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":160,"memory":20,"hostname":"EderCortes"}	2024-11-04 11:38:54
39286	9d6bcef8-063b-4e3b-b504-7be382c8968e	9d6bcef8-097f-4368-9ebd-d75c6b5bf310	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":178,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:26:34
39571	9d6bddb3-9204-4e57-96a1-ef0309db7013	9d6bddb3-932d-41b3-ac04-f96997d782e8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getLoansCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":14,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":248,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:07:45
25177	9d68bffc-b41c-4962-8bab-35852ec9e7dd	9d68bffc-d6a9-410d-9e37-0b6f75687338	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 09:57:11
25178	9d68bffc-d287-4d3e-8202-c396f31febcc	9d68bffc-d6a9-410d-9e37-0b6f75687338	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"55.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 09:57:11
25179	9d68bffc-d550-40ca-84fb-b805aa83f128	9d68bffc-d6a9-410d-9e37-0b6f75687338	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 09:57:11
25180	9d68bffc-d5b5-435e-8c0a-87870815683f	9d68bffc-d6a9-410d-9e37-0b6f75687338	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":372,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:57:11
27426	9d68e45d-faf4-4034-9b4f-17c757b72f4d	9d68e45d-fde0-40c4-a217-5c8fd087ef72	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":147,"memory":20,"hostname":"EderCortes"}	2024-11-04 11:38:55
39287	9d6bcef8-c517-4f2f-ada6-a8dcdabd0256	9d6bcef8-cd14-47d5-9001-b882d4660620	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 22:26:34
39288	9d6bcef8-cb7f-495b-b29b-ea95435ea474	9d6bcef8-cd14-47d5-9001-b882d4660620	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 22:26:34
39289	9d6bcef8-cbf1-4c61-a47e-2595dbf0ec6e	9d6bcef8-cd14-47d5-9001-b882d4660620	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":14,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":{"cobrador":14,"frecuencia":null,"estado":null,"prestamista":null}},"duration":188,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:26:34
39572	9d6bddba-261c-4e23-9712-3562ff0a61f6	9d6bddba-29b5-4309-8204-480190a62f2d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":197,"memory":20,"hostname":"EderCortes"}	2024-11-05 23:07:50
27427	9d68e45e-814b-4ee6-9f37-85a860f1fab1	9d68e45e-9f0d-4b3f-9e93-85b5ac1f893f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 11:38:55
27428	9d68e45e-9a83-4546-88bc-867af672c4e7	9d68e45e-9f0d-4b3f-9e93-85b5ac1f893f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"46.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 11:38:55
27429	9d68e45e-9dc7-453f-8cf1-005f79382f4a	9d68e45e-9f0d-4b3f-9e93-85b5ac1f893f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 11:38:55
27430	9d68e45e-9e10-443f-8f73-b24356837099	9d68e45e-9f0d-4b3f-9e93-85b5ac1f893f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":351,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:38:55
39290	9d6bcf01-81a3-4ca1-8305-81840bc3a8ed	9d6bcf01-8515-4956-969b-22742c1a46f7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":177,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:26:40
39573	9d6bddba-e353-46da-88dd-777b94e03b09	9d6bddba-ff9c-49b0-b105-9a305964e37b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 23:07:50
39574	9d6bddba-fb0d-4955-8346-d329991ecf4a	9d6bddba-ff9c-49b0-b105-9a305964e37b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"43.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":89,"hash":"f9f3598e6ad2468770f89917d2ab916c","hostname":"EderCortes"}	2024-11-05 23:07:50
39575	9d6bddba-fe43-4d99-b2ff-41b1c0cf5ce6	9d6bddba-ff9c-49b0-b105-9a305964e37b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 23:07:50
39576	9d6bddba-fea4-48e5-a34a-76f3323f43da	9d6bddba-ff9c-49b0-b105-9a305964e37b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getLoansCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:07:50
27431	9d68e45f-11e2-46f9-a79c-e0df6420b862	9d68e45f-2c42-45d8-ac2e-29cd2fd083f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 11:38:55
27432	9d68e45f-27c6-413c-a40e-2386be8dae67	9d68e45f-2c42-45d8-ac2e-29cd2fd083f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"40.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 11:38:56
27433	9d68e45f-2aee-45ed-8322-259101edd3de	9d68e45f-2c42-45d8-ac2e-29cd2fd083f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 11:38:56
27434	9d68e45f-2b3b-4f7a-88fd-fca80ded4ce1	9d68e45f-2c42-45d8-ac2e-29cd2fd083f0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:38:56
31551	9d694edd-9f10-484c-a6ec-0fbc335e5fda	9d694edd-f31a-41aa-9c28-5b2bcd9f759c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 16:36:42
31552	9d694edd-f0fa-4299-aafb-33054ecb97e9	9d694edd-f31a-41aa-9c28-5b2bcd9f759c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:36:42
31553	9d694edd-f1c9-4a1d-9a28-583d63d331f3	9d694edd-f31a-41aa-9c28-5b2bcd9f759c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":481,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:36:42
39291	9d6bcf02-4514-41f5-8809-15c5686767aa	9d6bcf02-4e8a-4a59-85dd-9d7f92feaecd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 22:26:40
39292	9d6bcf02-4cbe-4e8b-bb92-63ea60ef8694	9d6bcf02-4e8a-4a59-85dd-9d7f92feaecd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 22:26:40
39293	9d6bcf02-4d41-429f-939d-3cf6f230caae	9d6bcf02-4e8a-4a59-85dd-9d7f92feaecd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"59","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":0,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":{"cobrador":0,"frecuencia":null,"estado":null,"prestamista":null}},"duration":202,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:26:40
39577	9d6bddc1-38ae-42c8-b928-bb0e0c684eb7	9d6bddc1-3c8b-4556-a832-80accd0d9d56	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":173,"memory":20,"hostname":"EderCortes"}	2024-11-05 23:07:54
7512	9d52df52-f804-4df2-94a1-5d0848cea57e	9d52df52-faa7-46f7-b306-0ebc6e1eb0b8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":375}	2024-10-24 12:56:36
25068	9d68bfa7-dc06-4187-b133-c2251561a8e9	9d68bfa8-4506-47a2-b738-8475d58c91c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 09:56:16
25069	9d68bfa8-40bb-4dfd-b116-480af68e8858	9d68bfa8-4506-47a2-b738-8475d58c91c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 09:56:16
25070	9d68bfa8-4205-4601-9e21-ebd349194244	9d68bfa8-4506-47a2-b738-8475d58c91c8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1171,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:56:16
39578	9d6bddc1-f350-4d31-80af-a706b64cdb97	9d6bddc2-0ff2-434e-87aa-66ac8141f6fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 23:07:55
39579	9d6bddc2-0b43-438b-ad61-9f5a2cf1ea01	9d6bddc2-0ff2-434e-87aa-66ac8141f6fe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" where \\"l\\".\\"loans_cuando\\" = 'D' order by \\"l\\".\\"id\\" desc","time":"43.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":89,"hash":"0c79d8e84fb7ae332adf13400a0d1890","hostname":"EderCortes"}	2024-11-05 23:07:55
39580	9d6bddc2-0e93-4b02-809d-675257041e13	9d6bddc2-0ff2-434e-87aa-66ac8141f6fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-05 23:07:55
25071	9d68bfa8-f66d-4934-987b-a11158e687b6	9d68bfa9-19e2-4c77-a686-4f26d4531542	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 09:56:16
25072	9d68bfa9-0fbb-4367-9ca1-fc1c8f8cfb42	9d68bfa9-19e2-4c77-a686-4f26d4531542	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"48.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 09:56:16
25073	9d68bfa9-13bc-4e5f-9ffb-79909497f302	9d68bfa9-19e2-4c77-a686-4f26d4531542	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:56:16
25074	9d68bfa9-13fc-413e-94ab-f8ea66a77d8e	9d68bfa9-19e2-4c77-a686-4f26d4531542	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 09:56:16
25075	9d68bfa9-1891-4dd5-b7c4-0ddb33336f8f	9d68bfa9-19e2-4c77-a686-4f26d4531542	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 09:56:16
25076	9d68bfa9-18f6-4cf2-a965-244bf52552b0	9d68bfa9-19e2-4c77-a686-4f26d4531542	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":423,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:56:16
27435	9d68e464-5320-4359-8e8c-3d1c265ff14b	9d68e464-7202-4172-97fb-e1423d86a71d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 11:38:59
27436	9d68e464-6d52-4694-96d4-ed928d1ac7d7	9d68e464-7202-4172-97fb-e1423d86a71d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '19' and \\"users\\".\\"deleted_at\\" is null","time":"41.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":55,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-11-04 11:38:59
27437	9d68e464-6da3-45ae-8810-3b4a0c43665a	9d68e464-7202-4172-97fb-e1423d86a71d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:38:59
27438	9d68e464-70c3-4681-95c5-1a097b3edb09	9d68e464-7202-4172-97fb-e1423d86a71d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 11:38:59
27439	9d68e464-7109-4a34-a0d6-d571a1f5dc8a	9d68e464-7202-4172-97fb-e1423d86a71d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/19","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}},"duration":384,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:38:59
31554	9d694ede-932e-4182-b73a-dfec4d1c3622	9d694ede-e6a3-4673-a8eb-9afb109e4e33	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:36:43
25077	9d68bfa9-e399-4045-8b7b-7c8a48c2fe65	9d68bfaa-2071-48f2-80b6-e0fd24ee9aeb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 09:56:17
25078	9d68bfaa-1412-4fb1-aab4-aa20dbff2568	9d68bfaa-2071-48f2-80b6-e0fd24ee9aeb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"82.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:56:17
25079	9d68bfaa-14a0-462c-9b8d-273f75f42ce3	9d68bfaa-2071-48f2-80b6-e0fd24ee9aeb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:56:17
25080	9d68bfaa-1de6-4467-b5db-cd6bc1d1f0cc	9d68bfaa-2071-48f2-80b6-e0fd24ee9aeb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 09:56:17
25081	9d68bfaa-1eb3-4802-9eb4-c00f2fe61a73	9d68bfaa-2071-48f2-80b6-e0fd24ee9aeb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":657,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:56:17
27440	9d68e4a6-253a-4025-8b71-eaec9e8b8f28	9d68e4a6-827f-477d-b0de-d28c99b6f8f4	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 11:39:42
27441	9d68e4a6-7a84-4c0c-807c-2fad2fbcdd05	9d68e4a6-827f-477d-b0de-d28c99b6f8f4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"166.88","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 11:39:42
27442	9d68e4a6-806e-4629-b3e5-ffe8905396ea	9d68e4a6-827f-477d-b0de-d28c99b6f8f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:39:42
27443	9d68e4a6-810b-41c2-8678-274d9a85cf1d	9d68e4a6-827f-477d-b0de-d28c99b6f8f4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":816,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:39:42
39581	9d6bddc2-0ee4-4092-a734-1d6c8aa0db2d	9d6bddc2-0ff2-434e-87aa-66ac8141f6fe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getLoansCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"61","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":"D","estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:07:55
25082	9d68bfaa-d6bd-4e6d-8117-cb3a2f51515e	9d68bfab-1065-4951-a510-a7fbc3182806	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 09:56:18
25083	9d68bfab-01e4-49d3-94b1-79a62e58e8d8	9d68bfab-1065-4951-a510-a7fbc3182806	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"77.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:56:18
25084	9d68bfab-0293-445e-a5fe-8adcf52c2edf	9d68bfab-1065-4951-a510-a7fbc3182806	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:56:18
25085	9d68bfab-0d6b-4a83-b941-50bd30256246	9d68bfab-1065-4951-a510-a7fbc3182806	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 09:56:18
25086	9d68bfab-0e26-42f9-8bc5-613041e01647	9d68bfab-1065-4951-a510-a7fbc3182806	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":586,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:56:18
27444	9d68e4ab-ee5f-418b-88ca-4ac98469895a	9d68e4ac-3eb6-4af4-a880-48f482c3aa04	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:39:46
27445	9d68e4ac-38fb-4c8c-909a-65e103307fb9	9d68e4ac-3eb6-4af4-a880-48f482c3aa04	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"103.54","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:39:46
27446	9d68e4ac-3954-4c9f-b066-8ae5163bf191	9d68e4ac-3eb6-4af4-a880-48f482c3aa04	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:39:46
27447	9d68e4ac-3d3a-4a2e-ab13-3738cd33a11d	9d68e4ac-3eb6-4af4-a880-48f482c3aa04	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:39:46
27448	9d68e4ac-3d9f-49ea-b17d-1467d1555335	9d68e4ac-3eb6-4af4-a880-48f482c3aa04	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":642,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:39:46
31555	9d694ede-da0a-4b37-9811-e4ac4b824e02	9d694ede-e6a3-4673-a8eb-9afb109e4e33	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"161.12","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 16:36:43
31556	9d694ede-dde7-40a5-8829-f64c809779fb	9d694ede-e6a3-4673-a8eb-9afb109e4e33	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '92' order by \\"item_loans\\".\\"id\\" asc","time":"3.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":304,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 16:36:43
31557	9d694ede-e4b5-4de9-a303-8aa8f15b0e43	9d694ede-e6a3-4673-a8eb-9afb109e4e33	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:36:43
24704	9d68bba6-affc-491d-a8e8-dcdc924b0a39	9d68bba6-cf34-4281-b962-6524def0e1eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 09:45:04
24705	9d68bba6-cda3-4c2f-8f52-6fa5cf028b49	9d68bba6-cf34-4281-b962-6524def0e1eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 09:45:04
24706	9d68bba6-ce3d-4c66-b3b1-56bffda1c611	9d68bba6-cf34-4281-b962-6524def0e1eb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":403,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:45:04
39582	9d6bddc6-5689-482a-841d-f754159d7767	9d6bddc6-5a21-4a1b-ba0f-fbb288596254	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":169,"memory":20,"hostname":"EderCortes"}	2024-11-05 23:07:58
24707	9d68bba7-5b10-4352-ab0a-6a46148274e0	9d68bba7-78d1-42ec-b733-e2c6539bf04a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 09:45:04
24708	9d68bba7-7068-4ce2-a605-2a34fcdacf2d	9d68bba7-78d1-42ec-b733-e2c6539bf04a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"41.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 09:45:04
24709	9d68bba7-73e1-4463-aad0-f4f64cc0567c	9d68bba7-78d1-42ec-b733-e2c6539bf04a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"1.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:45:04
24710	9d68bba7-742d-4148-9860-e7f6cc8f0a12	9d68bba7-78d1-42ec-b733-e2c6539bf04a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 09:45:04
24711	9d68bba7-77bc-4af5-9eb5-4b1998a027db	9d68bba7-78d1-42ec-b733-e2c6539bf04a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 09:45:04
24712	9d68bba7-7814-4ae3-9f28-f2ae4d9fca83	9d68bba7-78d1-42ec-b733-e2c6539bf04a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:45:04
27449	9d68e4ac-bf15-4e46-831d-37134e12ae78	9d68e4ac-df07-401c-8d35-3eabd620c766	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:39:46
27450	9d68e4ac-d970-4cde-9e37-f8b8024783f2	9d68e4ac-df07-401c-8d35-3eabd620c766	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:39:46
27451	9d68e4ac-d9c7-4bd1-9acf-0b262b08e9c8	9d68e4ac-df07-401c-8d35-3eabd620c766	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 11:39:46
27452	9d68e4ac-ddaa-4824-a382-9db40be7ed06	9d68e4ac-df07-401c-8d35-3eabd620c766	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:39:46
27453	9d68e4ac-de07-455a-b29f-19cb1ea92efe	9d68e4ac-df07-401c-8d35-3eabd620c766	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":396,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:39:46
31558	9d694ede-e549-47c1-b31b-d1e44c3bf008	9d694ede-e6a3-4673-a8eb-9afb109e4e33	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":92,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":15,"loans_valor_prestado":8000009,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"533333.93333333","loans_pago_interes":"133333.48333333","user_alias":"eder.cortes"},"items":[{"id":379,"loans_codigo":92,"itemloans_cuota":"1","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:13:07","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":null},{"id":380,"loans_codigo":92,"itemloans_cuota":"2","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":381,"loans_codigo":92,"itemloans_cuota":"3","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":382,"loans_codigo":92,"itemloans_cuota":"4","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":383,"loans_codigo":92,"itemloans_cuota":"5","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":384,"loans_codigo":92,"itemloans_cuota":"6","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":385,"loans_codigo":92,"itemloans_cuota":"7","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":386,"loans_codigo":92,"itemloans_cuota":"8","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":387,"loans_codigo":92,"itemloans_cuota":"9","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-15 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":388,"loans_codigo":92,"itemloans_cuota":"10","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":389,"loans_codigo":92,"itemloans_cuota":"11","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-31 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":390,"loans_codigo":92,"itemloans_cuota":"12","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":391,"loans_codigo":92,"itemloans_cuota":"13","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-16 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":392,"loans_codigo":92,"itemloans_cuota":"14","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":393,"loans_codigo":92,"itemloans_cuota":"15","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":485,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:36:43
24713	9d68bba9-961c-40c3-a7b2-4ebe8c147214	9d68bba9-b3b6-4acf-8e54-542fff519cda	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 09:45:06
24714	9d68bba9-aebc-471e-b19c-896489a9d846	9d68bba9-b3b6-4acf-8e54-542fff519cda	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:45:06
24715	9d68bba9-af09-4eac-9d65-c31bbedb88cc	9d68bba9-b3b6-4acf-8e54-542fff519cda	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:45:06
24716	9d68bba9-b289-4f59-a561-8a390b6e3ed3	9d68bba9-b3b6-4acf-8e54-542fff519cda	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 09:45:06
24717	9d68bba9-b2cf-453e-9bfb-dc43957f6e97	9d68bba9-b3b6-4acf-8e54-542fff519cda	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":458,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:45:06
27454	9d68e4ad-50f7-4e86-af13-ef5924ddbf3f	9d68e4ad-72c8-49c2-a618-49e24d176c91	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:39:47
27455	9d68e4ad-6bd0-49ee-9391-36b285a4080d	9d68e4ad-72c8-49c2-a618-49e24d176c91	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '90' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"48.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 11:39:47
27456	9d68e4ad-6c1c-4325-962f-55fe93baf979	9d68e4ad-72c8-49c2-a618-49e24d176c91	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 11:39:47
27457	9d68e4ad-6db5-489e-a438-816c93c0bc95	9d68e4ad-72c8-49c2-a618-49e24d176c91	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"1.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:39:47
27458	9d68e4ad-6dea-46a7-9d18-96f474e42411	9d68e4ad-72c8-49c2-a618-49e24d176c91	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 11:39:47
27459	9d68e4ad-7171-4ad7-8e6d-9153ec3ff204	9d68e4ad-72c8-49c2-a618-49e24d176c91	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:39:47
27460	9d68e4ad-71b8-46fb-8554-5dd811feb52b	9d68e4ad-72c8-49c2-a618-49e24d176c91	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"275000","loans_pago_prestado":"1100000","loans_intereses_recaudar":"275000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"}]}},"duration":363,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:39:47
31559	9d694ee1-43fd-4a58-ae5d-25cfdc62e322	9d694ee1-791a-47de-a9d7-0ca77dcfbc60	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:36:45
31560	9d694ee1-6e97-415d-8406-ea077ad5e1e3	9d694ee1-791a-47de-a9d7-0ca77dcfbc60	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"62.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:36:45
31561	9d694ee1-6f14-4690-93e6-32b9f104ac8d	9d694ee1-791a-47de-a9d7-0ca77dcfbc60	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:36:45
31562	9d694ee1-770d-4b15-9fb3-483d79dce687	9d694ee1-791a-47de-a9d7-0ca77dcfbc60	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:36:45
39583	9d6bddc7-1058-47bc-ae20-af71feafeb82	9d6bddc7-2bbc-4141-8639-a5d88235de96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-05 23:07:58
24718	9d68bbcd-5588-4a54-bfb7-07254a690d04	9d68bbcd-58e1-435d-8947-499dcc311b15	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-total-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":146,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:45:29
31563	9d694ee1-77b3-4e3e-b0ad-48a39d7dc8bf	9d694ee1-791a-47de-a9d7-0ca77dcfbc60	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":491,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:36:45
39584	9d6bddc7-2729-4edd-86c2-e8949dcee0eb	9d6bddc7-2bbc-4141-8639-a5d88235de96	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" where \\"l\\".\\"loans_cuando\\" = 'S' order by \\"l\\".\\"id\\" desc","time":"42.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":89,"hash":"0c79d8e84fb7ae332adf13400a0d1890","hostname":"EderCortes"}	2024-11-05 23:07:58
39585	9d6bddc7-2a48-4569-bbe8-82ead723d106	9d6bddc7-2bbc-4141-8639-a5d88235de96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-05 23:07:58
39586	9d6bddc7-2a9c-4934-ba77-af065260eed3	9d6bddc7-2bbc-4141-8639-a5d88235de96	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getLoansCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"61","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":"S","estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:07:58
39587	9d6bde70-f01f-4e63-b1b7-69f720d2f5db	9d6bde70-f459-4f7f-83f6-5c087c5c4757	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":177,"memory":20,"hostname":"EderCortes"}	2024-11-05 23:09:50
24724	9d68bbdf-399b-4220-9245-d8666e42a78c	9d68bbdf-3db5-4c10-ab1e-5e96ad4145bb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-total-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":182,"memory":20,"hostname":"EderCortes"}	2024-11-04 09:45:41
39588	9d6bde71-4a84-4814-9976-dcfba61f585c	9d6bde71-9983-405e-a7d5-fa087748c0bf	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 23:09:50
27554	9d68e7fa-1209-4a02-ab6c-cae8351168f1	9d68e7fa-6daa-4642-8322-34faeecd1959	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:49:00
27555	9d68e7fa-6af7-4365-9e4b-c37064295d2f	9d68e7fa-6daa-4642-8322-34faeecd1959	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:49:01
27556	9d68e7fa-6c0c-4a35-9166-004f778a7f6d	9d68e7fa-6daa-4642-8322-34faeecd1959	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":725,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:49:01
39589	9d6bde71-9333-4ea3-8607-e85bd7666342	9d6bde71-9983-405e-a7d5-fa087748c0bf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"150.13","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 23:09:50
39590	9d6bde71-9399-49ec-afae-cdb27d471f4e	9d6bde71-9983-405e-a7d5-fa087748c0bf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 23:09:50
39591	9d6bde71-97db-4b69-a8d5-2498dc7043ec	9d6bde71-9983-405e-a7d5-fa087748c0bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 23:09:50
39592	9d6bde71-982b-4498-8126-9efc273d830e	9d6bde71-9983-405e-a7d5-fa087748c0bf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":353,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:09:50
27557	9d68e7fb-3ada-4f2d-a912-9bd66aaa4b10	9d68e7fb-684b-4173-b3e5-362649e8f8c7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:49:01
27558	9d68e7fb-5e5a-4a2e-a43b-75bcf50556d5	9d68e7fb-684b-4173-b3e5-362649e8f8c7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"54.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:49:01
27559	9d68e7fb-5edd-41c3-a21e-2f5fcad67c02	9d68e7fb-684b-4173-b3e5-362649e8f8c7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:49:01
27560	9d68e7fb-660a-4a0b-9297-64eeaef46fec	9d68e7fb-684b-4173-b3e5-362649e8f8c7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:49:01
27561	9d68e7fb-66c4-4b6e-9afd-a7111d2e6bc0	9d68e7fb-684b-4173-b3e5-362649e8f8c7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":558,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:49:01
39593	9d6bde71-f071-4775-8597-eb5f4d55663b	9d6bde72-0d8e-4405-8c2c-3cccb6074f73	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 23:09:50
39594	9d6bde72-08c7-4b23-b40b-449c7bb167cb	9d6bde72-0d8e-4405-8c2c-3cccb6074f73	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 23:09:50
39595	9d6bde72-092a-4439-b0ee-0b2a177ad274	9d6bde72-0d8e-4405-8c2c-3cccb6074f73	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 23:09:50
39596	9d6bde72-0c3c-42ce-9483-78c1def9f95e	9d6bde72-0d8e-4405-8c2c-3cccb6074f73	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 23:09:50
39597	9d6bde72-0c79-4271-83d7-7f8ced0c35df	9d6bde72-0d8e-4405-8c2c-3cccb6074f73	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":272,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:09:50
27562	9d68e7fc-2246-4127-9118-63990a926185	9d68e7fc-4fc5-4325-9315-320fb47526e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:49:02
27563	9d68e7fc-4766-4aeb-9203-6df5dae186f4	9d68e7fc-4fc5-4325-9315-320fb47526e7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"61.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:49:02
27564	9d68e7fc-47e9-4880-8500-ac072a70214a	9d68e7fc-4fc5-4325-9315-320fb47526e7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 11:49:02
27565	9d68e7fc-4da2-411a-acee-84887e19ed6c	9d68e7fc-4fc5-4325-9315-320fb47526e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:49:02
27566	9d68e7fc-4e37-45dd-bc32-0ff5e98d2994	9d68e7fc-4fc5-4325-9315-320fb47526e7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":573,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:49:02
39598	9d6bde72-a57c-4f9e-95f2-26c9c6262a39	9d6bde72-c272-4b8c-92df-7947d56a030c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 23:09:51
39599	9d6bde72-be53-4f7a-959f-71f69d24ff48	9d6bde72-c272-4b8c-92df-7947d56a030c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"45.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 23:09:51
39600	9d6bde72-c124-46a9-9a99-c869d369e3c8	9d6bde72-c272-4b8c-92df-7947d56a030c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 23:09:51
39601	9d6bde72-c189-472c-9db6-4ab5a150231c	9d6bde72-c272-4b8c-92df-7947d56a030c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":440,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:09:51
39672	9d6be15a-c09f-4977-ab0b-1aa5713bc21f	9d6be15a-e611-499e-907e-503925e09c05	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 23:17:58
39673	9d6be15a-e18b-446b-a1b8-e72452e3ef74	9d6be15a-e611-499e-907e-503925e09c05	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 23:17:58
39674	9d6be15a-e4e4-41ad-99d9-d0e80370875b	9d6be15a-e611-499e-907e-503925e09c05	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":313,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:17:58
27567	9d68e7fc-e71d-497c-b2cc-897de180a018	9d68e7fd-089d-4f17-a29d-22f0444df04b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:49:02
27568	9d68e7fd-01a1-4673-ac61-dab774d24598	9d68e7fd-089d-4f17-a29d-22f0444df04b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '90' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"44.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 11:49:02
27569	9d68e7fd-01ee-461c-86c6-62acb1682116	9d68e7fd-089d-4f17-a29d-22f0444df04b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 11:49:02
27570	9d68e7fd-0365-452b-8091-e00b5fb55a2d	9d68e7fd-089d-4f17-a29d-22f0444df04b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"1.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:49:02
27571	9d68e7fd-03b3-47cf-aee5-acd70b60c967	9d68e7fd-089d-4f17-a29d-22f0444df04b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 11:49:02
27572	9d68e7fd-0763-425c-9334-ec2c03df7d00	9d68e7fd-089d-4f17-a29d-22f0444df04b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:49:02
27573	9d68e7fd-07b9-4140-acb5-dda5b048df54	9d68e7fd-089d-4f17-a29d-22f0444df04b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"275000","loans_pago_prestado":"1100000","loans_intereses_recaudar":"275000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"}]}},"duration":448,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:49:02
39602	9d6bde7c-fa7a-4d15-b033-feb6e45ed4a6	9d6bde7c-fd93-4e09-9db0-6cd07a4718e0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":181,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:09:57
39675	9d6be15c-aa12-4725-a145-0ee521fef821	9d6be15c-f67c-4112-8ebe-5e3314ae9935	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 23:18:00
39676	9d6be15c-efc9-4d99-ad6e-4bc968e5eb7c	9d6be15c-f67c-4112-8ebe-5e3314ae9935	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"150.30","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 23:18:00
39677	9d6be15c-f027-48e4-898d-3422b3d95031	9d6be15c-f67c-4112-8ebe-5e3314ae9935	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 23:18:00
39678	9d6be15c-f4e9-419e-ac65-b3609ea9fd4b	9d6be15c-f67c-4112-8ebe-5e3314ae9935	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 23:18:00
39679	9d6be15c-f543-44fe-a7bd-f241e83f1076	9d6be15c-f67c-4112-8ebe-5e3314ae9935	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":466,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:18:00
27574	9d68e7fe-23e8-4f8d-9a31-18ed9e0806e5	9d68e7fe-8f38-401a-858b-919a5b2a2774	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:49:03
27575	9d68e7fe-8317-444c-8a80-30d4caf0dbdb	9d68e7fe-8f38-401a-858b-919a5b2a2774	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"174.37","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:49:03
27576	9d68e7fe-83d6-428e-a210-ab1b29b5e1f5	9d68e7fe-8f38-401a-858b-919a5b2a2774	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:49:03
27577	9d68e7fe-8c59-41d2-95c9-aba6f1703c37	9d68e7fe-8f38-401a-858b-919a5b2a2774	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:49:03
27578	9d68e7fe-8d21-443a-8a0f-a9adf58f861f	9d68e7fe-8f38-401a-858b-919a5b2a2774	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":977,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:49:03
39603	9d6bde7d-67dd-4b66-88c1-0f5dc39f6a4e	9d6bde7d-87ab-419d-884c-9219fce3659e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 23:09:58
39604	9d6bde7d-8261-4e24-a22f-5dfd40bf2bf8	9d6bde7d-87ab-419d-884c-9219fce3659e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 23:09:58
39605	9d6bde7d-82aa-4e6a-9340-48dd716ed231	9d6bde7d-87ab-419d-884c-9219fce3659e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 23:09:58
39606	9d6bde7d-864d-4345-9c39-412a21384e46	9d6bde7d-87ab-419d-884c-9219fce3659e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 23:09:58
39607	9d6bde7d-8697-42d5-9833-396af5b4edc9	9d6bde7d-87ab-419d-884c-9219fce3659e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:09:58
27579	9d68e7ff-68d2-4b50-8bbf-2a037b1c95e7	9d68e7ff-af41-43e8-a7c0-a2bc2780d7e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:49:04
27580	9d68e7ff-a4b0-4eaa-8265-70831e6d78ee	9d68e7ff-af41-43e8-a7c0-a2bc2780d7e5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"85.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:49:04
27581	9d68e7ff-a537-4dde-971b-a968565f1c73	9d68e7ff-af41-43e8-a7c0-a2bc2780d7e5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:49:04
27582	9d68e7ff-ad1b-41e4-a1d7-27dc955974f2	9d68e7ff-af41-43e8-a7c0-a2bc2780d7e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:49:04
27583	9d68e7ff-ada2-4b90-ae1c-d6a20fd28502	9d68e7ff-af41-43e8-a7c0-a2bc2780d7e5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":697,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:49:04
39608	9d6bde7d-d0b5-4455-83b2-22be83b80dba	9d6bde7e-149f-4a2f-9f03-c563b19a75b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 23:09:58
39609	9d6bde7e-0fbe-4ae0-b2e3-013afc6214dc	9d6bde7e-149f-4a2f-9f03-c563b19a75b5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"137.72","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 23:09:58
39610	9d6bde7e-1015-4f1b-8e2b-301c1f212c87	9d6bde7e-149f-4a2f-9f03-c563b19a75b5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 23:09:58
39611	9d6bde7e-1340-4c7d-8737-1ce7bc240149	9d6bde7e-149f-4a2f-9f03-c563b19a75b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 23:09:58
39612	9d6bde7e-138e-460f-86bd-9adc79af518c	9d6bde7e-149f-4a2f-9f03-c563b19a75b5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":338,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:09:58
17909	9d65b3fd-97d9-484c-9920-e64024e00e97	9d65b3fd-9bce-4e00-be3c-2a777f95c374	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":854}	2024-11-02 21:36:09
25284	9d68c105-da8e-4cd6-a6af-837c9923b9b2	9d68c106-05ff-4ffc-bf0f-17c66714c369	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 10:00:05
25285	9d68c106-03b3-4816-a923-d58c6ae4bea5	9d68c106-05ff-4ffc-bf0f-17c66714c369	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:00:05
25286	9d68c106-04b0-4f7d-8e1f-33f12968e851	9d68c106-05ff-4ffc-bf0f-17c66714c369	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":445,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:00:05
39613	9d6bde7e-57cb-416a-adb0-f9d8aeeff031	9d6bde7e-9b18-41d7-b19d-c2defe4616fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 23:09:58
39614	9d6bde7e-964b-4480-9f2a-a52094245e21	9d6bde7e-9b18-41d7-b19d-c2defe4616fb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"144.23","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":89,"hash":"f9f3598e6ad2468770f89917d2ab916c","hostname":"EderCortes"}	2024-11-05 23:09:58
39615	9d6bde7e-99ba-4d52-a55b-650120fe42e6	9d6bde7e-9b18-41d7-b19d-c2defe4616fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 23:09:59
25287	9d68c106-a63a-4384-be3e-7979c2b60fd8	9d68c106-f56e-4f80-ae58-06e4258dea3c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:00:05
25288	9d68c106-eef9-4cb2-a852-a111a8385921	9d68c106-f56e-4f80-ae58-06e4258dea3c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"165.92","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 10:00:06
25289	9d68c106-f3be-4fe2-b057-85a455773bea	9d68c106-f56e-4f80-ae58-06e4258dea3c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:00:06
25290	9d68c106-f454-4add-8415-b0cf40938781	9d68c106-f56e-4f80-ae58-06e4258dea3c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":557,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:00:06
39616	9d6bde7e-9a20-47a0-9df4-180a9ec9c488	9d6bde7e-9b18-41d7-b19d-c2defe4616fb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getLoansCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":324,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:09:59
24940	9d68bee0-ca9a-443e-bf80-5c5eba845ebb	9d68bee0-f974-45f7-ac7d-f0fd9e0fc59b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 09:54:05
24941	9d68bee0-f6dd-4b9b-b0a2-23c2cac73d1c	9d68bee0-f974-45f7-ac7d-f0fd9e0fc59b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 09:54:05
24942	9d68bee0-f82c-4b7e-9e45-8409da24f88c	9d68bee0-f974-45f7-ac7d-f0fd9e0fc59b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":480,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:54:05
20406	9d66f21a-3cd6-4784-a454-bf0dfa85372d	9d66f21a-40e4-4ec6-9f1a-ee4f5a50ef44	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1013}	2024-11-03 12:25:40
7309	9d52dd0f-e551-4edd-bbcc-68af2ced3fcc	9d52dd0f-e80d-402d-b8fc-d6936ebb4c5e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":367}	2024-10-24 12:50:16
24943	9d68bee1-b44a-4c1b-a715-71fc82bb8d5a	9d68bee1-ff7b-4648-92f0-be995469db99	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 09:54:06
24944	9d68bee1-f3ab-480c-b260-80ca8c5afa57	9d68bee1-ff7b-4648-92f0-be995469db99	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"148.45","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 09:54:06
24945	9d68bee1-f83d-4e0c-b037-7555e66bf816	9d68bee1-ff7b-4648-92f0-be995469db99	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"3.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:54:06
24946	9d68bee1-f87e-4449-a0a4-aaa06980360e	9d68bee1-ff7b-4648-92f0-be995469db99	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 09:54:06
24947	9d68bee1-fd9f-4ba1-bcec-98b1ccf0d0a6	9d68bee1-ff7b-4648-92f0-be995469db99	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 09:54:06
24948	9d68bee1-fe2f-4f7f-a482-772b6054442a	9d68bee1-ff7b-4648-92f0-be995469db99	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":352,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":353,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":354,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":355,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":563,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:54:06
31675	9d695482-d31a-43ef-8d58-b1e1cbdad1fc	9d695482-f89e-4427-b13c-b22269d71548	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 16:52:29
31676	9d695482-f6b1-497a-96e2-13d9b8d8e07a	9d695482-f89e-4427-b13c-b22269d71548	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:52:29
31677	9d695482-f77d-496c-ba70-25f85c274b66	9d695482-f89e-4427-b13c-b22269d71548	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":290,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:52:29
39755	9d6cb4d3-2f86-4196-9607-b01e61bf4ea0	9d6cb4d3-6014-4426-ad5d-0a5804fd977d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 09:09:17
39756	9d6cb4d3-5d2d-4f37-8482-780c9d8a4a80	9d6cb4d3-6014-4426-ad5d-0a5804fd977d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:09:17
39757	9d6cb4d3-5e66-4218-ac03-6f023a8cd7a9	9d6cb4d3-6014-4426-ad5d-0a5804fd977d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":415,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:09:17
31678	9d695483-7373-44f4-be72-8ac5a41003bc	9d695483-93f9-4d4c-a02b-67a2d4972eec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:52:30
31679	9d695483-8c84-41f1-a5c4-ebd39d95ba71	9d695483-93f9-4d4c-a02b-67a2d4972eec	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:52:30
31680	9d695483-8cf2-4cad-888b-3a43a2e278d2	9d695483-93f9-4d4c-a02b-67a2d4972eec	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 16:52:30
31681	9d695483-926b-4443-84a5-d84a5a573d9f	9d695483-93f9-4d4c-a02b-67a2d4972eec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:52:30
31682	9d695483-92da-498f-a7d3-092967a16781	9d695483-93f9-4d4c-a02b-67a2d4972eec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":284,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:52:30
39758	9d6cb4d4-db36-473d-b024-fdf9acbe9615	9d6cb4d4-fece-40e7-b790-3b3066e8ac32	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:09:18
39759	9d6cb4d4-f676-4175-9f47-6dcb070a3c68	9d6cb4d4-fece-40e7-b790-3b3066e8ac32	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:09:18
39760	9d6cb4d4-f6e0-468d-8f5a-3f4c342deeba	9d6cb4d4-fece-40e7-b790-3b3066e8ac32	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:09:18
39761	9d6cb4d4-fce8-473d-8226-11580a34c457	9d6cb4d4-fece-40e7-b790-3b3066e8ac32	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:09:18
39762	9d6cb4d4-fd4a-45c4-91b3-fe8b5570d0a3	9d6cb4d4-fece-40e7-b790-3b3066e8ac32	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":321,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:09:18
31683	9d695483-d616-4a59-b3d0-13e618c35edb	9d695483-f3e7-44b3-9ae8-465160307da0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:52:30
31684	9d695483-ef06-499f-8007-d89a860ace47	9d695483-f3e7-44b3-9ae8-465160307da0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:52:30
31685	9d695483-ef57-42fa-9840-b4b7cfc03d49	9d695483-f3e7-44b3-9ae8-465160307da0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 16:52:30
31686	9d695483-f2a2-41dd-be9c-5e3e6b083d50	9d695483-f3e7-44b3-9ae8-465160307da0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:52:30
31687	9d695483-f2e9-432b-944d-c8b83fa5a0d2	9d695483-f3e7-44b3-9ae8-465160307da0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:52:30
27718	9d68e939-e65c-4a56-9653-b77974e54594	9d68e93a-1d92-49a8-b3c5-a21cbeaabad6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 11:52:30
27719	9d68e93a-1b23-468a-bb9f-a9ed3417a074	9d68e93a-1d92-49a8-b3c5-a21cbeaabad6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 11:52:30
27720	9d68e93a-1c40-4713-8a12-44470e5536c4	9d68e93a-1d92-49a8-b3c5-a21cbeaabad6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":639,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:52:30
27721	9d68e93a-db3d-4efc-8f82-8b93df5f9bad	9d68e93b-314f-41ea-842c-60e0007b1278	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 11:52:31
27722	9d68e93b-2ace-4075-af35-d661ed33f769	9d68e93b-314f-41ea-842c-60e0007b1278	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"164.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:52:31
27723	9d68e93b-2b5e-4bcd-9475-6cb89c7e3fe3	9d68e93b-314f-41ea-842c-60e0007b1278	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:52:31
27724	9d68e93b-2ff0-4918-bf24-46c5b0f7dd17	9d68e93b-314f-41ea-842c-60e0007b1278	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 11:52:31
27725	9d68e93b-3052-41d2-b2e3-5cde32ac461e	9d68e93b-314f-41ea-842c-60e0007b1278	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":632,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:52:31
39827	9d6cb6b9-14be-4039-95f8-e4b7be06596c	9d6cb6b9-332a-47ad-84b1-15a8af79cb0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:14:36
39828	9d6cb6b9-310f-4edc-ad45-458fa9393df3	9d6cb6b9-332a-47ad-84b1-15a8af79cb0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:14:36
39829	9d6cb6b9-3211-4e9d-b79d-2b7e73d92d31	9d6cb6b9-332a-47ad-84b1-15a8af79cb0d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:14:36
27726	9d68e93b-ce2b-4969-867d-78427b3ee21b	9d68e93b-fa8d-47f4-a3b1-2e95aa30c811	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 11:52:31
27727	9d68e93b-f1ca-4ecd-aff6-b264b6e2e05f	9d68e93b-fa8d-47f4-a3b1-2e95aa30c811	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"58.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:52:31
27728	9d68e93b-f24f-46b9-bbe7-e7bdac057dfc	9d68e93b-fa8d-47f4-a3b1-2e95aa30c811	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 11:52:31
27729	9d68e93b-f8f4-448c-9bb8-61ad2deb61b9	9d68e93b-fa8d-47f4-a3b1-2e95aa30c811	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 11:52:31
27730	9d68e93b-f96b-446e-b2f0-cb1e5abf2d0e	9d68e93b-fa8d-47f4-a3b1-2e95aa30c811	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":490,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:52:31
39830	9d6cb6b9-eaa9-4ac8-86a0-3cbb26bbbace	9d6cb6ba-37b3-487c-9d46-b58f997c200c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:14:36
39831	9d6cb6ba-308d-4462-8b5d-ca5f23be2099	9d6cb6ba-37b3-487c-9d46-b58f997c200c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"158.95","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:14:36
39832	9d6cb6ba-30fb-46e1-853b-daf3527d21f4	9d6cb6ba-37b3-487c-9d46-b58f997c200c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:14:36
39833	9d6cb6ba-363c-4468-8a05-bc88fb433643	9d6cb6ba-37b3-487c-9d46-b58f997c200c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:14:36
39834	9d6cb6ba-369d-48e1-8413-af1c94b03048	9d6cb6ba-37b3-487c-9d46-b58f997c200c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":361,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:14:36
27731	9d68e93c-70b5-44a7-a1d4-05245fe7f756	9d68e93c-b654-4164-93c5-752b79f5ecf6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 11:52:32
27732	9d68e93c-afb8-40b6-b2e2-ef56af896d33	9d68e93c-b654-4164-93c5-752b79f5ecf6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '90' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"141.41","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 11:52:32
27733	9d68e93c-b006-4b47-9f22-85b07ef69d3d	9d68e93c-b654-4164-93c5-752b79f5ecf6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 11:52:32
27734	9d68e93c-b189-4e34-8796-6ade1445a5e6	9d68e93c-b654-4164-93c5-752b79f5ecf6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"2.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:52:32
27735	9d68e93c-b1c3-4e12-904c-a11fe697d4bf	9d68e93c-b654-4164-93c5-752b79f5ecf6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 11:52:32
27736	9d68e93c-b505-424e-a070-ccf6822852b0	9d68e93c-b654-4164-93c5-752b79f5ecf6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 11:52:32
27737	9d68e93c-b562-4f79-9102-014147223ede	9d68e93c-b654-4164-93c5-752b79f5ecf6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"275000","loans_pago_prestado":"1100000","loans_intereses_recaudar":"275000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"}]}},"duration":460,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:52:32
27738	9d68e93d-7a4f-49c8-9849-483f2548a592	9d68e93d-b845-4b8b-b29d-27991778fd60	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 11:52:32
27739	9d68e93d-aee2-4dd2-bb85-ee64e9e6ed74	9d68e93d-b845-4b8b-b29d-27991778fd60	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"86.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:52:32
27740	9d68e93d-af56-468a-8b45-a585fa7dcb51	9d68e93d-b845-4b8b-b29d-27991778fd60	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:52:32
27741	9d68e93d-b5da-4cd6-a7ae-12330ea08d5a	9d68e93d-b845-4b8b-b29d-27991778fd60	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 11:52:32
27742	9d68e93d-b650-45c4-9eca-437691a40654	9d68e93d-b845-4b8b-b29d-27991778fd60	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":644,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:52:32
21279	9d67378e-92ee-4acc-b7aa-273f8503b03f	9d67378e-e358-43b9-b37f-32ced44d28b7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:39:52
21280	9d67378e-e112-45c4-b573-184cf023bbb3	9d67378e-e358-43b9-b37f-32ced44d28b7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 15:39:53
21281	9d67378e-e219-4437-aa31-758706686b7b	9d67378e-e358-43b9-b37f-32ced44d28b7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":392,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:39:53
36154	9d6b330d-dbcf-4eb9-b1c2-e914c5d070df	9d6b330d-e007-46cb-b8dc-6b30d29c297b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1635}	2024-11-05 15:10:36
25640	9d68c7b1-808e-4c6c-85cc-3e07958cc201	9d68c7b1-85e7-4649-9a7b-cb1f5bedb38c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1176}	2024-11-04 10:18:44
21282	9d67378f-3201-4676-a42e-a305c3c986dd	9d67378f-501f-4552-94b8-59a3ff37d887	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 15:39:53
21283	9d67378f-46ec-47c9-92f0-955be669f45c	9d67378f-501f-4552-94b8-59a3ff37d887	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 65\\n                        ","time":"40.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6768d7067397538897aacf4d73c43049","hostname":"EderCortes"}	2024-11-03 15:39:53
21284	9d67378f-4abf-4abf-841e-c4f1de38d5fc	9d67378f-501f-4552-94b8-59a3ff37d887	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '65' order by \\"item_loans\\".\\"id\\" asc","time":"2.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 15:39:53
21285	9d67378f-4b02-4fb6-b92f-63c1dac7168e	9d67378f-501f-4552-94b8-59a3ff37d887	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 15:39:53
21286	9d67378f-4edb-4b35-a7ee-c6ba6d8ef674	9d67378f-501f-4552-94b8-59a3ff37d887	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 15:39:53
21287	9d67378f-4f2b-4ce8-8682-f5ae6de5042c	9d67378f-501f-4552-94b8-59a3ff37d887	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/65","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":65,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":3000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-10 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":207,"loans_codigo":65,"itemloans_cuota":"1","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:02.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":208,"loans_codigo":65,"itemloans_cuota":"2","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":209,"loans_codigo":65,"itemloans_cuota":"3","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":210,"loans_codigo":65,"itemloans_cuota":"4","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":211,"loans_codigo":65,"itemloans_cuota":"5","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":212,"loans_codigo":65,"itemloans_cuota":"6","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":213,"loans_codigo":65,"itemloans_cuota":"7","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":214,"loans_codigo":65,"itemloans_cuota":"8","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":215,"loans_codigo":65,"itemloans_cuota":"9","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":216,"loans_codigo":65,"itemloans_cuota":"10","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-09-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":228,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:39:53
27743	9d68e93e-cae0-4fc5-8f98-bddb1902a6ef	9d68e93e-ea4a-4667-b93e-773ce4cf93ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 11:52:33
27744	9d68e93e-e47e-4e8c-a0ab-21a02545b9f2	9d68e93e-ea4a-4667-b93e-773ce4cf93ba	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:52:33
27745	9d68e93e-e4d5-4552-b940-1024ee9c3c93	9d68e93e-ea4a-4667-b93e-773ce4cf93ba	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:52:33
27746	9d68e93e-e8cf-4eae-bd33-1a6e27b5d8d8	9d68e93e-ea4a-4667-b93e-773ce4cf93ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 11:52:33
27747	9d68e93e-e937-4982-a3cc-11f120a158d8	9d68e93e-ea4a-4667-b93e-773ce4cf93ba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":759,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:52:33
21288	9d673791-9b09-4bd7-8082-5230ec417cde	9d673791-c96f-40b2-a146-b4da1d64ff95	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 15:39:54
21289	9d673791-bf27-46e9-b974-e4c4965a0199	9d673791-c96f-40b2-a146-b4da1d64ff95	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"56.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 15:39:54
21290	9d673791-bfab-4c8a-a739-3055d8d9b8b1	9d673791-c96f-40b2-a146-b4da1d64ff95	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 15:39:54
21291	9d673791-c71c-4ce3-b26c-d7f9cc78fa47	9d673791-c96f-40b2-a146-b4da1d64ff95	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 15:39:54
21292	9d673791-c7be-403e-8a97-7820fde0d02d	9d673791-c96f-40b2-a146-b4da1d64ff95	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":401,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:39:54
21976	9d67414c-9a59-4ea3-b904-b4a170b4622e	9d67414c-a66f-4a5f-888f-3c01dd80f2d2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"218.05","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:07:07
21977	9d67414c-9b01-4629-825e-f434c949a122	9d67414c-a66f-4a5f-888f-3c01dd80f2d2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:07:07
21978	9d67414c-a407-41e7-83bd-434f2601201e	9d67414c-a66f-4a5f-888f-3c01dd80f2d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 16:07:07
21293	9d67379e-73d0-4700-9415-462e2359862a	9d67379e-772c-44bd-bb24-fcbc4311e1a5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":167,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:40:03
27862	9d68ea21-7f56-47d1-883c-df03b10581ab	9d68ea21-b8bd-4150-8578-705fbae913a8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 11:55:02
27863	9d68ea21-b568-4d5a-9f4d-6a14d1ac187c	9d68ea21-b8bd-4150-8578-705fbae913a8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 11:55:02
21979	9d67414c-a4b6-47a6-8867-bed133cc5a72	9d67414c-a66f-4a5f-888f-3c01dd80f2d2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":874,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:07:07
27864	9d68ea21-b6e2-477c-8d33-a51728881c59	9d68ea21-b8bd-4150-8578-705fbae913a8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":664,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:55:02
21294	9d67379f-2a4d-4e7d-96d8-50554b0b536a	9d67379f-4d6b-4fac-a618-11668c7da786	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 15:40:03
21295	9d67379f-4201-48f2-afb1-55726158025e	9d67379f-4d6b-4fac-a618-11668c7da786	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 207 limit 1","time":"2.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-03 15:40:03
21296	9d67379f-424f-47c8-a3a1-1b6cc6dedee4	9d67379f-4d6b-4fac-a618-11668c7da786	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-03 15:40:03
21297	9d67379f-43d2-4a23-86fd-43929c33d23d	9d67379f-4d6b-4fac-a618-11668c7da786	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 65 limit 1","time":"1.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 15:40:03
21298	9d67379f-4406-4071-be29-338610207e5b	9d67379f-4d6b-4fac-a618-11668c7da786	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 15:40:03
21299	9d67379f-47c2-4abd-807d-2d666d7cfe5b	9d67379f-4d6b-4fac-a618-11668c7da786	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '03-11-2024', \\"itemloans_cuota_cancelada\\" = '300000', \\"updated_at\\" = '2024-11-03 15:40:03' where \\"id\\" = 207","time":"7.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":400,"hash":"35b67f849e4a0ba5090d9c1eb8abfe94","hostname":"EderCortes"}	2024-11-03 15:40:03
21300	9d67379f-4834-4999-9e7e-7afc999713fd	9d67379f-4d6b-4fac-a618-11668c7da786	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:207","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-03 15:40:03","item_loans_cuando_pago":"03-11-2024","itemloans_cuota_cancelada":"300000"},"hostname":"EderCortes"}	2024-11-03 15:40:03
21301	9d67379f-48d7-4ba3-b75f-c1a31dc3b613	9d67379f-4d6b-4fac-a618-11668c7da786	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 90000, \\"loans_pago_prestado\\" = 300000, \\"updated_at\\" = '2024-11-03 15:40:03' where \\"id\\" = 65","time":"0.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":408,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-03 15:40:03
21302	9d67379f-490f-4ded-86e7-9c20f49b2875	9d67379f-4d6b-4fac-a618-11668c7da786	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:65","changes":{"updated_at":"2024-11-03 15:40:03","loans_pago_interes":90000,"loans_pago_prestado":300000},"hostname":"EderCortes"}	2024-11-03 15:40:03
21303	9d67379f-4c34-424a-aea7-f9b434e919e2	9d67379f-4d6b-4fac-a618-11668c7da786	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 15:40:03
21304	9d67379f-4c7a-4233-ab26-b1b97e0bca37	9d67379f-4d6b-4fac-a618-11668c7da786	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"179","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"90000","itemloans_cuota_cancelada":"300000","id":207,"loans_codigo":65,"itemloans_cuota":"1","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:40:03
27865	9d68ea22-801f-4022-8bca-b84bc9c48614	9d68ea22-d5ed-4ce1-822f-82ca158212e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 11:55:02
21980	9d67414d-46a3-44c0-8599-937a884b154c	9d67414d-76c4-4a7f-af9b-f5bebecda4e2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 16:07:07
21981	9d67414d-6dc2-4b61-a595-8631cf11eb0b	9d67414d-76c4-4a7f-af9b-f5bebecda4e2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"64.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:07:07
21982	9d67414d-6e4c-44d2-b596-f4fbb2d2e586	9d67414d-76c4-4a7f-af9b-f5bebecda4e2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:07:07
21983	9d67414d-743e-4bec-9933-8ce90e035d57	9d67414d-76c4-4a7f-af9b-f5bebecda4e2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 16:07:07
25501	9d68c686-69ce-49bf-9653-a2488d0fc00f	9d68c686-86a2-459d-ad94-c6ba0beb9fda	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:15:28
25502	9d68c686-851f-4bc6-9593-b121a9634f3a	9d68c686-86a2-459d-ad94-c6ba0beb9fda	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:15:28
25503	9d68c686-85b4-4bd5-bad9-f12ae1205ca5	9d68c686-86a2-459d-ad94-c6ba0beb9fda	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":364,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:15:28
27866	9d68ea22-cdab-4913-81c7-9c7966ebae68	9d68ea22-d5ed-4ce1-822f-82ca158212e0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"169.50","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:55:03
27867	9d68ea22-ce3b-4be3-87d1-55865d45dd02	9d68ea22-d5ed-4ce1-822f-82ca158212e0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:55:03
27868	9d68ea22-d414-4d76-81ac-d2029230a39f	9d68ea22-d5ed-4ce1-822f-82ca158212e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 11:55:03
21305	9d67379f-952e-4a6e-9d6c-9f6672979e74	9d67379f-b45c-4455-abd0-b3b24fc10145	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 15:40:03
21306	9d67379f-aaed-4d77-866c-d1f3d5500266	9d67379f-b45c-4455-abd0-b3b24fc10145	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 65\\n                        ","time":"42.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6768d7067397538897aacf4d73c43049","hostname":"EderCortes"}	2024-11-03 15:40:04
21307	9d67379f-aec0-407b-a49a-4d23e668113c	9d67379f-b45c-4455-abd0-b3b24fc10145	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '65' order by \\"item_loans\\".\\"id\\" asc","time":"2.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 15:40:04
21308	9d67379f-aef4-4341-a5fd-050010010c55	9d67379f-b45c-4455-abd0-b3b24fc10145	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 15:40:04
21309	9d67379f-b2fa-4f95-a2f1-114324d7d43b	9d67379f-b45c-4455-abd0-b3b24fc10145	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 15:40:04
21310	9d67379f-b34d-409f-8bc3-cbe897f23cc9	9d67379f-b45c-4455-abd0-b3b24fc10145	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/65","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":65,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":3000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-10 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"90000"},"items":[{"id":207,"loans_codigo":65,"itemloans_cuota":"1","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:40:03.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"300000"},{"id":208,"loans_codigo":65,"itemloans_cuota":"2","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:34:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":209,"loans_codigo":65,"itemloans_cuota":"3","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":210,"loans_codigo":65,"itemloans_cuota":"4","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":211,"loans_codigo":65,"itemloans_cuota":"5","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":212,"loans_codigo":65,"itemloans_cuota":"6","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":213,"loans_codigo":65,"itemloans_cuota":"7","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":214,"loans_codigo":65,"itemloans_cuota":"8","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":215,"loans_codigo":65,"itemloans_cuota":"9","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":216,"loans_codigo":65,"itemloans_cuota":"10","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-09-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T18:06:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:40:04
25504	9d68c687-015b-400e-b61d-f0b42965b4b2	9d68c687-2212-4c9b-8630-61606b9c218d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:15:28
21984	9d67414d-74d7-43d6-8927-c442f6774c64	9d67414d-76c4-4a7f-af9b-f5bebecda4e2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":504,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:07:07
27869	9d68ea22-d492-4b71-a0b9-cba60228bcd2	9d68ea22-d5ed-4ce1-822f-82ca158212e0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":619,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:55:03
25505	9d68c687-1967-44a5-98c6-bb67ce32a557	9d68c687-2212-4c9b-8630-61606b9c218d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"45.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:15:29
25506	9d68c687-1cdd-42d8-92b3-fa6d219fc571	9d68c687-2212-4c9b-8630-61606b9c218d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"1.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:15:29
25507	9d68c687-1d11-45e6-8c3a-e24331c391f1	9d68c687-2212-4c9b-8630-61606b9c218d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:15:29
25508	9d68c687-2089-4fd1-97b2-c9fe6d60e8b7	9d68c687-2212-4c9b-8630-61606b9c218d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 10:15:29
25509	9d68c687-20d4-4beb-b2b0-cefc256afbec	9d68c687-2212-4c9b-8630-61606b9c218d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":350,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:15:29
27870	9d68ea23-6c07-4a2c-b9f8-7fb548a9a91f	9d68ea23-929c-4a6b-9574-2be22ecb5985	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 11:55:03
27871	9d68ea23-8b9a-4145-9a0d-757160402935	9d68ea23-929c-4a6b-9574-2be22ecb5985	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"52.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:55:03
27872	9d68ea23-8c0e-48fb-9606-022158c958b7	9d68ea23-929c-4a6b-9574-2be22ecb5985	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 11:55:03
27873	9d68ea23-90ee-4eb1-8f1f-40e7341b0e20	9d68ea23-929c-4a6b-9574-2be22ecb5985	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 11:55:03
27874	9d68ea23-9155-44a6-b353-88196bd562e8	9d68ea23-929c-4a6b-9574-2be22ecb5985	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":460,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:55:03
27875	9d68ea24-31a4-41fc-beef-b9ef0dd2b8eb	9d68ea24-61d3-4e4c-80ed-8a0e58e11f30	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 11:55:04
27876	9d68ea24-5657-432d-be9f-f8899b0437d7	9d68ea24-61d3-4e4c-80ed-8a0e58e11f30	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '81' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"63.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 11:55:04
27877	9d68ea24-56cf-42d8-a380-9123e831f3e6	9d68ea24-61d3-4e4c-80ed-8a0e58e11f30	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 11:55:04
27878	9d68ea24-596e-42fb-ac4c-81aad2a0b7c6	9d68ea24-61d3-4e4c-80ed-8a0e58e11f30	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '81' order by \\"item_loans\\".\\"id\\" asc","time":"3.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:55:04
27879	9d68ea24-59c2-47bf-a555-1aef12f9edd0	9d68ea24-61d3-4e4c-80ed-8a0e58e11f30	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 11:55:04
27880	9d68ea24-6029-4f71-bea0-dc40041f3bcb	9d68ea24-61d3-4e4c-80ed-8a0e58e11f30	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 11:55:04
27881	9d68ea24-608c-4847-a066-d2066f9de82c	9d68ea24-61d3-4e4c-80ed-8a0e58e11f30	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/81","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":81,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"0","loans_pago_prestado":"0","loans_intereses_recaudar":"275000"},"items":[{"id":311,"loans_codigo":81,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":312,"loans_codigo":81,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":313,"loans_codigo":81,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":314,"loans_codigo":81,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":315,"loans_codigo":81,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":510,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:55:04
27882	9d68ea25-78f7-400e-843c-e82de19f3845	9d68ea25-d838-4467-a400-44ff63ffeb22	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 11:55:04
27883	9d68ea25-cafe-4f47-9628-8b1962a3fe1c	9d68ea25-d838-4467-a400-44ff63ffeb22	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"148.33","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:55:05
27884	9d68ea25-cb97-4f68-8a39-ef66d0d5ef09	9d68ea25-d838-4467-a400-44ff63ffeb22	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:55:05
27885	9d68ea25-d566-4332-bec9-3d121dae6c6e	9d68ea25-d838-4467-a400-44ff63ffeb22	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 11:55:05
27886	9d68ea25-d67e-4931-a906-fd3e31877963	9d68ea25-d838-4467-a400-44ff63ffeb22	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":936,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:55:05
27887	9d68ea26-e2c4-46a2-9f73-e41bb20c9e4f	9d68ea27-05f0-4d57-8b6c-cc39524eecf0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 11:55:05
27888	9d68ea27-0081-44e4-8da2-b20e1ba473d9	9d68ea27-05f0-4d57-8b6c-cc39524eecf0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"47.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:55:05
27889	9d68ea27-00d3-41d5-9d40-2da5fab941bc	9d68ea27-05f0-4d57-8b6c-cc39524eecf0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:55:05
24131	9d68a7d5-2b36-4ea1-9a15-19a2be8fdd2f	9d68a7d5-5a95-401c-8b73-16bb7c607c46	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 08:49:39
24132	9d68a7d5-5826-4c58-b117-c53673595b7c	9d68a7d5-5a95-401c-8b73-16bb7c607c46	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 08:49:39
24133	9d68a7d5-5927-40ed-a9c5-fd74fed61219	9d68a7d5-5a95-401c-8b73-16bb7c607c46	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":326,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:49:39
27890	9d68ea27-0493-4696-989b-d278a86030db	9d68ea27-05f0-4d57-8b6c-cc39524eecf0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 11:55:05
27891	9d68ea27-04dc-400c-a0ad-c27e3ce08712	9d68ea27-05f0-4d57-8b6c-cc39524eecf0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":745,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:55:05
24134	9d68a7d5-ccde-40cc-b388-345efa1fad31	9d68a7d6-16ea-4f10-95b8-97ad24a816f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 08:49:39
24135	9d68a7d6-0c72-47a3-8167-b092f8423192	9d68a7d6-16ea-4f10-95b8-97ad24a816f6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 66\\n                        ","time":"147.07","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"f5566f306d2be9466f2c4564ce0020bd","hostname":"EderCortes"}	2024-11-04 08:49:39
24136	9d68a7d6-1031-4b13-9de3-9966d08e0c10	9d68a7d6-16ea-4f10-95b8-97ad24a816f6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '66' order by \\"item_loans\\".\\"id\\" asc","time":"1.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:49:39
24137	9d68a7d6-106e-45a3-a6d4-4aefc215ad97	9d68a7d6-16ea-4f10-95b8-97ad24a816f6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 08:49:39
24138	9d68a7d6-1574-4fad-8c65-47459c2d2c49	9d68a7d6-16ea-4f10-95b8-97ad24a816f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 08:49:39
24139	9d68a7d6-15e0-4e32-bf16-b3bb8d567d37	9d68a7d6-16ea-4f10-95b8-97ad24a816f6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/66","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":66,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":5000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"5000000","loans_pago_interes":"1250000"},"items":[{"id":217,"loans_codigo":66,"itemloans_cuota":"1","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:26.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":218,"loans_codigo":66,"itemloans_cuota":"2","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":219,"loans_codigo":66,"itemloans_cuota":"3","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":220,"loans_codigo":66,"itemloans_cuota":"4","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:33.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":221,"loans_codigo":66,"itemloans_cuota":"5","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":222,"loans_codigo":66,"itemloans_cuota":"6","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:39.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":223,"loans_codigo":66,"itemloans_cuota":"7","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:42.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":224,"loans_codigo":66,"itemloans_cuota":"8","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:46.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":225,"loans_codigo":66,"itemloans_cuota":"9","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-31 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:50.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":226,"loans_codigo":66,"itemloans_cuota":"10","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:31:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"}]}},"duration":426,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:49:39
24140	9d68a7d8-0d8d-4cf4-8255-81a957c8d65b	9d68a7d8-2fd9-43f8-81a0-2f9529652270	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 08:49:41
24141	9d68a7d8-290c-49bf-b1ee-a16af6699574	9d68a7d8-2fd9-43f8-81a0-2f9529652270	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 08:49:41
24142	9d68a7d8-2978-4706-9c68-25f7d0d4312d	9d68a7d8-2fd9-43f8-81a0-2f9529652270	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 08:49:41
24143	9d68a7d8-2e25-4c0d-9367-b24c80f987e7	9d68a7d8-2fd9-43f8-81a0-2f9529652270	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 08:49:41
24144	9d68a7d8-2e89-43fa-b56e-50bfb6ff8780	9d68a7d8-2fd9-43f8-81a0-2f9529652270	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":301,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:49:41
25595	9d68c72f-f343-45f7-9894-1e653b7e2c5d	9d68c730-480e-4bc4-9e33-01e305754d75	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 10:17:19
25596	9d68c730-45b5-426d-9945-b69e2f3a2138	9d68c730-480e-4bc4-9e33-01e305754d75	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 10:17:19
25597	9d68c730-46da-4bad-bfb4-a14b6f6540ce	9d68c730-480e-4bc4-9e33-01e305754d75	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":674,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:17:19
31246	9d694921-6f86-450b-89be-7a5446727951	9d694921-750b-4c49-9851-4a9549394278	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1485}	2024-11-04 16:20:40
8074	9d52e698-2496-4ea1-84de-a2f5bac9a92e	9d52e698-28af-4514-ba2c-aaefc03392c6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":396}	2024-10-24 13:16:56
25598	9d68c731-0433-4d9a-93e7-5b7dc0d5d0d8	9d68c731-5cee-47f3-8fd3-421ff93138f3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 10:17:20
25599	9d68c731-543f-4fa6-be64-719b049e4344	9d68c731-5cee-47f3-8fd3-421ff93138f3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"171.21","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 10:17:20
25600	9d68c731-5abd-475e-9500-1297a618b957	9d68c731-5cee-47f3-8fd3-421ff93138f3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 10:17:20
25601	9d68c731-5b87-4ad8-b523-4b34964a8669	9d68c731-5cee-47f3-8fd3-421ff93138f3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":640,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:17:20
27975	9d68ea83-b66f-47df-9f9b-b45c063c49f2	9d68ea83-d786-4e76-bdbb-7782fc89e561	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:56:06
27976	9d68ea83-d5ac-4dd5-80a0-247c4f56e3a9	9d68ea83-d786-4e76-bdbb-7782fc89e561	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 11:56:06
27977	9d68ea83-d68f-47d0-b720-bf6d8e40ea60	9d68ea83-d786-4e76-bdbb-7782fc89e561	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":400,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:56:06
25602	9d68c732-01fc-4c00-b129-2f97df28a497	9d68c732-4f97-4e5c-9983-54e813f9187d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 10:17:21
25603	9d68c732-443f-4299-b155-24923e4dd9d2	9d68c732-4f97-4e5c-9983-54e813f9187d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"112.75","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:17:21
25604	9d68c732-44cc-4203-850e-fafa44e97fb6	9d68c732-4f97-4e5c-9983-54e813f9187d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:17:21
25605	9d68c732-4d53-4130-8c51-5be91d34ddf9	9d68c732-4f97-4e5c-9983-54e813f9187d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 10:17:21
25606	9d68c732-4deb-452e-8f66-812f334ca9c2	9d68c732-4f97-4e5c-9983-54e813f9187d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":601,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:17:21
27978	9d68ea84-66ac-4e68-be0e-e41c249c5c74	9d68ea84-b448-40ce-b53e-41e70f19a12d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 11:56:07
27979	9d68ea84-adf9-478e-ae61-2453340754db	9d68ea84-b448-40ce-b53e-41e70f19a12d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"156.66","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:56:07
27980	9d68ea84-ae67-4aa3-b958-da8d5c9db3b3	9d68ea84-b448-40ce-b53e-41e70f19a12d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:56:07
27981	9d68ea84-b2d7-4046-976b-fbe88c23d0f8	9d68ea84-b448-40ce-b53e-41e70f19a12d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 11:56:07
27982	9d68ea84-b339-4b51-8854-24409538e31a	9d68ea84-b448-40ce-b53e-41e70f19a12d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":514,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:56:07
39892	9d6cbb4c-81e9-4165-974e-c6ef438075ba	9d6cbb4c-c7a9-4786-bc32-950fafca1776	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:27:23
39893	9d6cbb4c-c5f0-4924-bc8a-8aa15b18f454	9d6cbb4c-c7a9-4786-bc32-950fafca1776	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:27:23
39894	9d6cbb4c-c692-4013-a480-8970a77c3893	9d6cbb4c-c7a9-4786-bc32-950fafca1776	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[0A000]: Feature not supported: 7 ERROR:  no est\\u00e1n implementadas las referencias entre bases de datos: users.name, users.user_alias, profile.profile_name\\nLINE 1: select \\"users\\".\\"name, users\\".\\"user_alias, profile\\".\\"profile_...\\n               ^ (Connection: pgsql, SQL: select \\"users\\".\\"name, users\\".\\"user_alias, profile\\".\\"profile_name\\" from \\"users\\" inner join \\"profile\\" on \\"users\\".\\"profile_code\\" = \\"profile\\".\\"id\\" where \\"users\\".\\"profile_code\\" = 1)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":130,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":519,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:27:23
25607	9d68c733-3530-4e6a-8f28-2ca504da89f3	9d68c733-5c3d-4d84-aeca-37f0791c1f4a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 10:17:21
25608	9d68c733-5618-490c-a7ee-171134ccea29	9d68c733-5c3d-4d84-aeca-37f0791c1f4a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"58.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:17:21
25609	9d68c733-567a-4009-95b0-942f0278600b	9d68c733-5c3d-4d84-aeca-37f0791c1f4a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:17:21
25610	9d68c733-5ad1-4c6f-921f-b462b6bf17d5	9d68c733-5c3d-4d84-aeca-37f0791c1f4a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 10:17:21
25611	9d68c733-5b24-4d22-a153-80f7419bc987	9d68c733-5c3d-4d84-aeca-37f0791c1f4a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":497,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:17:21
27983	9d68ea85-4696-4039-a081-786720325b87	9d68ea85-9653-43a8-a772-1e455a23776b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 11:56:07
27984	9d68ea85-8f9c-4e46-9857-d1e9d1f5dc01	9d68ea85-9653-43a8-a772-1e455a23776b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"160.18","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:56:07
27985	9d68ea85-8ff8-4ef5-bd03-da828bcc6433	9d68ea85-9653-43a8-a772-1e455a23776b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 11:56:07
27986	9d68ea85-951e-41e4-9f7b-cea6ed2b0705	9d68ea85-9653-43a8-a772-1e455a23776b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 11:56:07
27987	9d68ea85-9571-453c-b929-7dfdd17306b5	9d68ea85-9653-43a8-a772-1e455a23776b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":561,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:56:07
39895	9d6cbd19-f2f7-4e40-bf36-e20a7707aa9b	9d6cbd1a-4aa1-445d-a10c-f4ae6832ba92	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 09:32:26
31834	9d6955e2-2366-455e-950c-26a4f69952bb	9d6955e2-70d3-4ac7-ab72-62f0c749d870	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:56:20
31835	9d6955e2-6d71-437f-859d-debad2d5c5b8	9d6955e2-70d3-4ac7-ab72-62f0c749d870	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:56:20
31836	9d6955e2-6eed-4fea-917f-c1002415d2d2	9d6955e2-70d3-4ac7-ab72-62f0c749d870	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":665,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:56:20
39896	9d6cbd1a-41cb-47f9-b2cc-c0e3b2dad61f	9d6cbd1a-4aa1-445d-a10c-f4ae6832ba92	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"156.21","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:32:26
39897	9d6cbd1a-426d-4b99-ba0a-fc2a9ea97dcc	9d6cbd1a-4aa1-445d-a10c-f4ae6832ba92	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:32:26
39898	9d6cbd1a-487f-4a8e-b750-1bda26c19b27	9d6cbd1a-4aa1-445d-a10c-f4ae6832ba92	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:32:26
27988	9d68ea86-0b64-4433-ba73-062c6deda855	9d68ea86-2f40-4e32-97a1-50b50422cff2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 11:56:08
27989	9d68ea86-2799-477f-b8e5-ad9282a1bf43	9d68ea86-2f40-4e32-97a1-50b50422cff2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '81' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"49.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 11:56:08
27990	9d68ea86-27f1-468d-8961-d636a801059a	9d68ea86-2f40-4e32-97a1-50b50422cff2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 11:56:08
27991	9d68ea86-2a01-4f74-9e09-9e517aff5340	9d68ea86-2f40-4e32-97a1-50b50422cff2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '81' order by \\"item_loans\\".\\"id\\" asc","time":"2.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:56:08
27992	9d68ea86-2a39-4b67-8d5c-210b4c27675f	9d68ea86-2f40-4e32-97a1-50b50422cff2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 11:56:08
27993	9d68ea86-2dd3-4f72-9faf-72456ddf5cc8	9d68ea86-2f40-4e32-97a1-50b50422cff2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 11:56:08
27994	9d68ea86-2e2f-4f57-a36b-64dbeb746677	9d68ea86-2f40-4e32-97a1-50b50422cff2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/81","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":81,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"0","loans_pago_prestado":"0","loans_intereses_recaudar":"275000"},"items":[{"id":311,"loans_codigo":81,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":312,"loans_codigo":81,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":313,"loans_codigo":81,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":314,"loans_codigo":81,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":315,"loans_codigo":81,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:56:08
31837	9d6955e3-5eab-4e92-9c80-d01b3b2312ce	9d6955e3-6377-40d6-b1e3-63df069fcdb9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":null,"middleware":[],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":404,"response":{"error":"No se encontro la url especificada","code":404},"duration":482,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:56:20
39899	9d6cbd1a-48ee-4741-bc52-695c5327eb3c	9d6cbd1a-4aa1-445d-a10c-f4ae6832ba92	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":467,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:32:26
27995	9d68ea87-8956-4efd-9ff8-ed69b65789a5	9d68ea87-c4db-4498-8a7f-ab0ccb2aea23	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 11:56:09
27996	9d68ea87-bb13-43d5-9cb6-15ebf339d927	9d68ea87-c4db-4498-8a7f-ab0ccb2aea23	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"62.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:56:09
27997	9d68ea87-bbac-4f9c-ae8d-b4e439335038	9d68ea87-c4db-4498-8a7f-ab0ccb2aea23	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:56:09
27998	9d68ea87-c2eb-47e9-8793-33b2f9522e9b	9d68ea87-c4db-4498-8a7f-ab0ccb2aea23	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 11:56:09
27999	9d68ea87-c365-4cff-b4db-2624e9f6a00f	9d68ea87-c4db-4498-8a7f-ab0ccb2aea23	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1021,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:56:09
31838	9d6955e3-fa50-4f0f-a3db-0c55f483e268	9d6955e4-1e5d-43e6-984f-1a59b5263c85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:56:21
31839	9d6955e4-1794-4ecd-9c14-8c1ba0222767	9d6955e4-1e5d-43e6-984f-1a59b5263c85	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:56:21
31840	9d6955e4-180b-4f61-ae33-948a283a6a7a	9d6955e4-1e5d-43e6-984f-1a59b5263c85	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 16:56:21
31841	9d6955e4-1cca-4741-ba3d-c39e54df38d6	9d6955e4-1e5d-43e6-984f-1a59b5263c85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:56:21
31842	9d6955e4-1d25-4e41-a4be-3b45ea9efc14	9d6955e4-1e5d-43e6-984f-1a59b5263c85	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:56:21
39900	9d6cbd1a-c971-4383-9064-fbcd74569910	9d6cbd1b-0ed0-4773-8058-9a987ae99010	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:32:26
39901	9d6cbd1b-0a0c-40d1-9776-38a728dd7482	9d6cbd1b-0ed0-4773-8058-9a987ae99010	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"151.26","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:32:26
39902	9d6cbd1b-0d79-40b5-b75a-abcaac36c2cf	9d6cbd1b-0ed0-4773-8058-9a987ae99010	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:32:26
39903	9d6cbd1b-0dc1-4740-9f71-4fb7fafbc8c7	9d6cbd1b-0ed0-4773-8058-9a987ae99010	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}]},"duration":474,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:32:26
28000	9d68ea88-c12f-42a6-8d9a-cfd18921a87e	9d68ea89-0827-4dec-97b7-d7582e9ebc28	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 11:56:09
28001	9d68ea89-02d3-4495-b4ea-01102f6424cb	9d68ea89-0827-4dec-97b7-d7582e9ebc28	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"148.76","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:56:10
28002	9d68ea89-032e-42a4-8c06-b35fbdbd7ea1	9d68ea89-0827-4dec-97b7-d7582e9ebc28	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:56:10
28003	9d68ea89-06c7-4520-b8cf-4884257e495a	9d68ea89-0827-4dec-97b7-d7582e9ebc28	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 11:56:10
28004	9d68ea89-0714-44dc-b0c4-93f0b2e644b3	9d68ea89-0827-4dec-97b7-d7582e9ebc28	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":804,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:56:10
31843	9d6955e4-a62c-41ae-9cd5-ca83187aca26	9d6955e4-dec5-49fc-9003-51433fc5ba4c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:56:21
31844	9d6955e4-d4d7-4e96-ac2b-f1127263fd43	9d6955e4-dec5-49fc-9003-51433fc5ba4c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"81.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:56:21
31845	9d6955e4-d55f-4616-a50d-b0bf0c4a7951	9d6955e4-dec5-49fc-9003-51433fc5ba4c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:56:21
31846	9d6955e4-dc9b-4d8e-a5ee-9e2369d8e5ff	9d6955e4-dec5-49fc-9003-51433fc5ba4c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:56:21
31847	9d6955e4-dd23-4f78-8365-e16a96fe72f5	9d6955e4-dec5-49fc-9003-51433fc5ba4c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":467,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:56:21
39904	9d6cbd31-4f6a-47fc-9264-d44e265d4d1e	9d6cbd31-9836-432c-a0ef-6e089c32a4e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:32:41
39905	9d6cbd31-92c8-4ec1-ace0-7363813c7dc3	9d6cbd31-9836-432c-a0ef-6e089c32a4e5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"152.38","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:32:41
39906	9d6cbd31-9325-46d0-9726-d4e076113de5	9d6cbd31-9836-432c-a0ef-6e089c32a4e5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:32:41
39907	9d6cbd31-96d3-420d-89cc-2fce72b837ae	9d6cbd31-9836-432c-a0ef-6e089c32a4e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:32:41
31848	9d6955e5-78cf-409b-bbc2-57ac4c230707	9d6955e5-7e4e-4d57-95fd-0c845562f946	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":404,"response":{"error":"No se encontro la url especificada","code":404},"duration":358,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:56:22
39908	9d6cbd31-971a-45aa-8ab8-7bb575dd694b	9d6cbd31-9836-432c-a0ef-6e089c32a4e5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:32:41
31849	9d6955e6-109c-4a9d-ace1-8637edb2f755	9d6955e6-3d8d-47c1-affa-9db25b563dd1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:56:22
31850	9d6955e6-35ac-4570-a7d2-56dbc56d1134	9d6955e6-3d8d-47c1-affa-9db25b563dd1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"63.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:56:22
31851	9d6955e6-362f-4b8a-b361-d6050d69f257	9d6955e6-3d8d-47c1-affa-9db25b563dd1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:56:22
31852	9d6955e6-3b7d-43ae-a522-60d2ee41f3c8	9d6955e6-3d8d-47c1-affa-9db25b563dd1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:56:22
31853	9d6955e6-3c07-4833-8387-f40fdb4578ae	9d6955e6-3d8d-47c1-affa-9db25b563dd1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":388,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:56:22
39909	9d6cbd31-e61b-44ee-93bc-b024514467a8	9d6cbd31-ffd1-40a6-bc96-3745013b4592	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:32:41
39910	9d6cbd31-fbce-424b-900b-a0815a800f86	9d6cbd31-ffd1-40a6-bc96-3745013b4592	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"40.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:32:41
39911	9d6cbd31-fe96-40d6-9822-5cbeabf52eb4	9d6cbd31-ffd1-40a6-bc96-3745013b4592	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:32:41
39912	9d6cbd31-fed7-4f70-97db-f078bd862448	9d6cbd31-ffd1-40a6-bc96-3745013b4592	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:32:41
31854	9d6955e6-acb8-4bff-8ff3-ed66adc8abc9	9d6955e6-b08f-4a96-97e7-7b4da2b3a4cf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":404,"response":{"error":"No se encontro la url especificada","code":404},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:56:23
39913	9d6cbe12-6fea-4a3f-a605-b311ad5fb263	9d6cbe12-a4d4-4931-96bd-49c89a940184	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 09:35:09
39914	9d6cbe12-9be5-42ac-a57b-c70cb74a090c	9d6cbe12-a4d4-4931-96bd-49c89a940184	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"68.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:35:09
39915	9d6cbe12-9c5c-480f-abdc-198a158d4a37	9d6cbe12-a4d4-4931-96bd-49c89a940184	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:35:09
39916	9d6cbe12-a2af-40fa-8878-190358934784	9d6cbe12-a4d4-4931-96bd-49c89a940184	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:35:09
39917	9d6cbe12-a336-4917-bd8d-9e5b0128b0ac	9d6cbe12-a4d4-4931-96bd-49c89a940184	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":481,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:35:09
28098	9d68ebb6-43a0-4bd2-9a09-ad9c2b99342a	9d68ebb6-9483-4813-9528-eb574f90ffa2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 11:59:27
28099	9d68ebb6-905f-4519-9684-4e592a01d107	9d68ebb6-9483-4813-9528-eb574f90ffa2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 11:59:27
28100	9d68ebb6-9253-4ac2-ba45-71263eb09c91	9d68ebb6-9483-4813-9528-eb574f90ffa2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":785,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:59:27
39918	9d6cbe13-54d3-499d-bcf6-3e1bdba2648a	9d6cbe13-7a09-458c-aa27-dddf2ea6acfd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:35:09
39919	9d6cbe13-72f8-41a3-828f-7ce6b8f83117	9d6cbe13-7a09-458c-aa27-dddf2ea6acfd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"55.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:35:09
39920	9d6cbe13-7853-4b9b-a0fc-fe97949fb6bc	9d6cbe13-7a09-458c-aa27-dddf2ea6acfd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:35:09
28101	9d68ebb7-654d-43f7-b9cd-c45a0669d0fd	9d68ebb7-99ff-43fe-9128-70d653d407f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 11:59:28
28102	9d68ebb7-9058-43c2-b302-fce2d1843210	9d68ebb7-99ff-43fe-9128-70d653d407f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"72.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:59:28
28103	9d68ebb7-9100-44b2-8f38-0fe4581dbb00	9d68ebb7-99ff-43fe-9128-70d653d407f0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:59:28
28104	9d68ebb7-981f-4811-917a-0f362168beca	9d68ebb7-99ff-43fe-9128-70d653d407f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 11:59:28
28105	9d68ebb7-98a3-4a99-ba0b-dc42ac48aec8	9d68ebb7-99ff-43fe-9128-70d653d407f0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":571,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:59:28
39921	9d6cbe13-78b8-4561-af7f-258f47b1ff6a	9d6cbe13-7a09-458c-aa27-dddf2ea6acfd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":528,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:35:09
28106	9d68ebb8-30d2-474d-b944-5646dea670fb	9d68ebb8-5dfb-4210-8502-7bc522f7ee76	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 11:59:28
28107	9d68ebb8-55fc-484b-91c7-9171c221ac1c	9d68ebb8-5dfb-4210-8502-7bc522f7ee76	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"61.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:59:28
28108	9d68ebb8-5691-43fa-a485-9effbb9db1c7	9d68ebb8-5dfb-4210-8502-7bc522f7ee76	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 11:59:28
28109	9d68ebb8-5c4c-4d62-9127-55887cb8f4a3	9d68ebb8-5dfb-4210-8502-7bc522f7ee76	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 11:59:28
28110	9d68ebb8-5cc2-4ee1-976a-005278f21f6a	9d68ebb8-5dfb-4210-8502-7bc522f7ee76	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":477,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:59:28
39922	9d6cbe1a-82e9-49b3-a4ac-95d7aef37f10	9d6cbe1a-9fad-4050-8168-7b1b0d09e3f8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:35:14
39923	9d6cbe1a-9ae6-4977-8be7-c6df0b4201c7	9d6cbe1a-9fad-4050-8168-7b1b0d09e3f8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:35:14
39924	9d6cbe1a-9b2f-4178-b1b1-62fd19aacddc	9d6cbe1a-9fad-4050-8168-7b1b0d09e3f8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:35:14
39925	9d6cbe1a-9e67-4763-bf54-b186bc68da49	9d6cbe1a-9fad-4050-8168-7b1b0d09e3f8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:35:14
39926	9d6cbe1a-9ead-48d5-a40f-09ca59977689	9d6cbe1a-9fad-4050-8168-7b1b0d09e3f8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:35:14
28111	9d68ebb9-024c-4c38-92d1-b7b9fa5b2924	9d68ebb9-57c5-4b6c-8c63-88ef7a31d03e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 11:59:29
28112	9d68ebb9-4f9e-4247-b036-c704e15d55d0	9d68ebb9-57c5-4b6c-8c63-88ef7a31d03e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '81' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"167.72","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 11:59:29
28113	9d68ebb9-5004-4361-a70e-00842c737dd9	9d68ebb9-57c5-4b6c-8c63-88ef7a31d03e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 11:59:29
28114	9d68ebb9-5236-426c-9c4b-69a9671bf7b5	9d68ebb9-57c5-4b6c-8c63-88ef7a31d03e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '81' order by \\"item_loans\\".\\"id\\" asc","time":"3.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:59:29
28115	9d68ebb9-5290-444c-af13-817a4b7af8a1	9d68ebb9-57c5-4b6c-8c63-88ef7a31d03e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 11:59:29
28116	9d68ebb9-567c-42cb-a61e-732c6538aac5	9d68ebb9-57c5-4b6c-8c63-88ef7a31d03e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 11:59:29
28117	9d68ebb9-56da-4394-bfef-3f701b141a2a	9d68ebb9-57c5-4b6c-8c63-88ef7a31d03e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/81","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":81,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"0","loans_pago_prestado":"0","loans_intereses_recaudar":"275000"},"items":[{"id":311,"loans_codigo":81,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":312,"loans_codigo":81,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":313,"loans_codigo":81,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":314,"loans_codigo":81,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":315,"loans_codigo":81,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":622,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:59:29
39927	9d6cbe1a-e125-4553-ad6c-adde3e3904aa	9d6cbe1a-fa5e-4706-a960-72611fa4abb4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:35:14
31991	9d695867-7e54-4f79-a80f-f953fe84c8fd	9d695867-a940-4c47-9d11-f8f093ee3348	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 17:03:23
31992	9d695867-a6e9-4b23-af95-ea9497e5cf22	9d695867-a940-4c47-9d11-f8f093ee3348	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 17:03:23
31993	9d695867-a7cb-45c7-b733-05577889bc99	9d695867-a940-4c47-9d11-f8f093ee3348	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":305,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:03:23
39928	9d6cbe1a-f654-4e9d-bf01-394d531ea57f	9d6cbe1a-fa5e-4706-a960-72611fa4abb4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"40.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:35:14
39929	9d6cbe1a-f92b-4166-91ba-91207c05fd54	9d6cbe1a-fa5e-4706-a960-72611fa4abb4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:35:14
39930	9d6cbe1a-f973-4419-8369-82b99385283f	9d6cbe1a-fa5e-4706-a960-72611fa4abb4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":220,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:35:14
28118	9d68ebba-3335-46a5-a81d-f12427752eea	9d68ebba-96d6-47fe-b9e2-6d5dba660691	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 11:59:30
28119	9d68ebba-8148-4bcc-ab82-916e2fb6e184	9d68ebba-96d6-47fe-b9e2-6d5dba660691	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"148.05","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:59:30
28120	9d68ebba-81cb-4df7-a3e6-8218682bdbf1	9d68ebba-96d6-47fe-b9e2-6d5dba660691	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:59:30
28121	9d68ebba-8c75-4087-9749-13b9eb48f8cd	9d68ebba-96d6-47fe-b9e2-6d5dba660691	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 11:59:30
28122	9d68ebba-903a-4157-8e24-bd1f84ddf8cb	9d68ebba-96d6-47fe-b9e2-6d5dba660691	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":781,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:59:30
31994	9d695868-2019-4ff0-8ec5-f04e50a9148f	9d695868-416b-41c3-a583-731f729a8f91	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 17:03:23
31995	9d695868-3aa5-492d-98a4-12e64d7d12bd	9d695868-416b-41c3-a583-731f729a8f91	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":227,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 17:03:23
31996	9d695868-3b1c-4acd-8821-8699430edaf0	9d695868-416b-41c3-a583-731f729a8f91	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 17:03:23
31997	9d695868-3ff0-43ef-89be-8c62e43c1381	9d695868-416b-41c3-a583-731f729a8f91	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 17:03:23
31998	9d695868-4059-438a-bd96-adc708f61b64	9d695868-416b-41c3-a583-731f729a8f91	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":332,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:03:23
39931	9d6cbe25-a7a2-4ec2-bfd2-942cc03b5961	9d6cbe25-eee7-4e63-b84f-7eb4d527de20	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:35:21
39932	9d6cbe25-ea2f-40d4-b951-5f0aa38e304b	9d6cbe25-eee7-4e63-b84f-7eb4d527de20	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"148.55","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:35:21
39933	9d6cbe25-ea7d-4437-b850-114d9fd1e9d9	9d6cbe25-eee7-4e63-b84f-7eb4d527de20	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:35:21
39934	9d6cbe25-eda8-4c21-838d-8f4d433e4c03	9d6cbe25-eee7-4e63-b84f-7eb4d527de20	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:35:21
39935	9d6cbe25-edef-42d6-8ad8-365f4b48033e	9d6cbe25-eee7-4e63-b84f-7eb4d527de20	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":334,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:35:21
28123	9d68ebbb-e651-40e9-a668-146d1005e696	9d68ebbc-2c4f-4aac-b00a-3d1781b7ba51	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 11:59:31
28124	9d68ebbc-2124-4902-974a-f2c2b83d76c7	9d68ebbc-2c4f-4aac-b00a-3d1781b7ba51	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"77.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:59:31
28125	9d68ebbc-21d6-4837-acea-a13ae197098e	9d68ebbc-2c4f-4aac-b00a-3d1781b7ba51	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:59:31
28126	9d68ebbc-29b0-4244-a3b0-b038855bf779	9d68ebbc-2c4f-4aac-b00a-3d1781b7ba51	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:59:31
28127	9d68ebbc-2a5f-4993-b908-c8c715ae8189	9d68ebbc-2c4f-4aac-b00a-3d1781b7ba51	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":976,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:59:31
31999	9d695868-87fb-4e40-9ff5-158c2f803350	9d695868-d172-45b9-98b1-d011d3a083da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 17:03:23
32000	9d695868-cccf-4f2f-ab1f-21a972dd2a4e	9d695868-d172-45b9-98b1-d011d3a083da	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"154.42","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":216,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 17:03:23
32001	9d695868-cd2e-4608-8bb4-59ab73f1d269	9d695868-d172-45b9-98b1-d011d3a083da	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":3,"hostname":"EderCortes"}	2024-11-04 17:03:23
32002	9d695868-d068-4c9e-9235-8c15952b9c65	9d695868-d172-45b9-98b1-d011d3a083da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 17:03:23
32003	9d695868-d0af-485d-a1f2-744ce23ce1b6	9d695868-d172-45b9-98b1-d011d3a083da	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":352,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:03:23
39936	9d6cbe26-32ac-4ad4-979d-fa7b7759b440	9d6cbe26-4c38-42f7-a56e-6c5d3365d803	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:35:22
39937	9d6cbe26-47d4-4b24-bf21-e489cd772466	9d6cbe26-4c38-42f7-a56e-6c5d3365d803	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"42.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:35:22
39938	9d6cbe26-4b00-4da8-9c93-41e3308296dd	9d6cbe26-4c38-42f7-a56e-6c5d3365d803	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 09:35:22
39939	9d6cbe26-4b40-4bad-a471-304efcd058e4	9d6cbe26-4c38-42f7-a56e-6c5d3365d803	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":223,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:35:22
25703	9d68c883-8cff-4cc4-af28-01ce6ce8cc4e	9d68c883-b911-46eb-a038-35b3c8714d7e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 10:21:02
25704	9d68c883-b691-4d70-adcb-aabb722b1e22	9d68c883-b911-46eb-a038-35b3c8714d7e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:21:02
25705	9d68c883-b7bd-4bf8-9f53-903a790c3dc1	9d68c883-b911-46eb-a038-35b3c8714d7e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":507,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:21:02
39940	9d6cbe54-d7ee-4a3a-9bb1-1ec610dc652b	9d6cbe54-f6ac-4239-887f-637596b61b42	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 09:35:52
39941	9d6cbe54-f0eb-464f-ba9b-c75f84b6bf9c	9d6cbe54-f6ac-4239-887f-637596b61b42	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:35:52
39942	9d6cbe54-f141-4e90-bd3e-94bf9ea2db1f	9d6cbe54-f6ac-4239-887f-637596b61b42	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:35:52
39943	9d6cbe54-f51b-460c-8d97-e4d1b658dcf3	9d6cbe54-f6ac-4239-887f-637596b61b42	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 09:35:52
25706	9d68c884-9873-4043-9c77-06f2e526e721	9d68c884-c5f5-43d7-a5dc-9b9cc83675bc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:21:02
25707	9d68c884-b785-4900-aa97-eabcccd4da41	9d68c884-c5f5-43d7-a5dc-9b9cc83675bc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"50.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:21:03
25708	9d68c884-bc91-46b0-a161-73675744c3f3	9d68c884-c5f5-43d7-a5dc-9b9cc83675bc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"3.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:21:03
25709	9d68c884-bcda-4d94-b0b3-2ff18ddb6a85	9d68c884-c5f5-43d7-a5dc-9b9cc83675bc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:21:03
25710	9d68c884-c46c-4220-8af5-6b6c1a315038	9d68c884-c5f5-43d7-a5dc-9b9cc83675bc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:21:03
25711	9d68c884-c4d6-45e6-9c7e-d7dc45a9a05a	9d68c884-c5f5-43d7-a5dc-9b9cc83675bc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":629,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:21:03
32004	9d695869-26b3-496a-b462-595d540b409c	9d695869-461f-47a8-8c48-99a045e3058d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 17:03:24
28221	9d68ff43-0b7f-48d0-908a-709b0930b919	9d68ff43-4af7-4cea-a0eb-227a6725a519	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 12:54:07
28222	9d68ff43-4880-47c5-a0c3-f4c736ab0c0a	9d68ff43-4af7-4cea-a0eb-227a6725a519	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 12:54:07
28223	9d68ff43-4984-4c66-9e21-74264e0ed0d4	9d68ff43-4af7-4cea-a0eb-227a6725a519	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":612,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:54:07
32005	9d695869-4145-4474-8c30-c1fdff2f5a14	9d695869-461f-47a8-8c48-99a045e3058d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 17:03:24
32006	9d695869-4198-456d-b529-7fe4fbe4df99	9d695869-461f-47a8-8c48-99a045e3058d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 17:03:24
32007	9d695869-44ff-4dfd-ae89-4c3a06e1d456	9d695869-461f-47a8-8c48-99a045e3058d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 17:03:24
32008	9d695869-4547-4900-9161-e7b35f83f020	9d695869-461f-47a8-8c48-99a045e3058d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":281,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:03:24
28224	9d68ff44-0f1c-4df4-a137-09e5902d26be	9d68ff44-3fbd-4ea1-ad03-4e0ffbec1968	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 12:54:08
28225	9d68ff44-391e-49f8-ae53-b80eb3c44705	9d68ff44-3fbd-4ea1-ad03-4e0ffbec1968	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"61.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 12:54:08
28226	9d68ff44-397d-4055-994e-d6419d2f89be	9d68ff44-3fbd-4ea1-ad03-4e0ffbec1968	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 12:54:08
28227	9d68ff44-3e24-4f7d-9d88-b5676a7ca8af	9d68ff44-3fbd-4ea1-ad03-4e0ffbec1968	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 12:54:08
28228	9d68ff44-3e93-48ed-a565-0e42c0d48c3d	9d68ff44-3fbd-4ea1-ad03-4e0ffbec1968	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":551,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:54:08
39944	9d6cbe54-f580-4b0c-9412-5fef0602ab5e	9d6cbe54-f6ac-4239-887f-637596b61b42	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:35:52
28229	9d68ff44-de9a-4be2-847b-b74d96b17572	9d68ff45-06b0-4d22-ac57-67523fbf5171	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 12:54:08
28230	9d68ff45-0064-4944-aee1-7e0af0ef63f7	9d68ff45-06b0-4d22-ac57-67523fbf5171	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"53.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 12:54:08
28231	9d68ff45-00d9-4dff-855a-1b82f88d1b99	9d68ff45-06b0-4d22-ac57-67523fbf5171	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 12:54:08
28232	9d68ff45-0508-47e7-a01f-1236985dfbf1	9d68ff45-06b0-4d22-ac57-67523fbf5171	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 12:54:08
28233	9d68ff45-0568-4e71-bbea-b2eb211165d0	9d68ff45-06b0-4d22-ac57-67523fbf5171	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":486,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:54:08
39945	9d6cbe55-4260-43f4-95f9-b08fcc92de45	9d6cbe55-5f96-43e6-b15e-c98b943e74f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 09:35:52
39946	9d6cbe55-5807-4405-b3d5-746578952f93	9d6cbe55-5f96-43e6-b15e-c98b943e74f2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"41.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:35:52
39947	9d6cbe55-5db6-4efc-bca4-3ccad800beae	9d6cbe55-5f96-43e6-b15e-c98b943e74f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 09:35:52
39948	9d6cbe55-5e49-4a80-a20f-f66e165f6526	9d6cbe55-5f96-43e6-b15e-c98b943e74f2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:35:52
28234	9d68ff45-9961-4b25-b7ff-52ca619b4cc1	9d68ff45-c6c5-44f5-ad97-4af7f41d6967	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 12:54:09
28235	9d68ff45-bb39-4f32-b0cf-e46aa6324aa1	9d68ff45-c6c5-44f5-ad97-4af7f41d6967	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '81' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"56.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 12:54:09
28236	9d68ff45-bbc6-4a5a-8edf-8eab2705e7d0	9d68ff45-c6c5-44f5-ad97-4af7f41d6967	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 12:54:09
28237	9d68ff45-be63-4731-9059-bebc718b563c	9d68ff45-c6c5-44f5-ad97-4af7f41d6967	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '81' order by \\"item_loans\\".\\"id\\" asc","time":"3.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 12:54:09
28238	9d68ff45-beae-48c3-b7ad-567772f459a1	9d68ff45-c6c5-44f5-ad97-4af7f41d6967	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 12:54:09
28239	9d68ff45-c4ce-40e2-8e3c-0e1a9ac3433a	9d68ff45-c6c5-44f5-ad97-4af7f41d6967	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 12:54:09
28240	9d68ff45-c556-4fd0-8cf8-e6a0c15cf441	9d68ff45-c6c5-44f5-ad97-4af7f41d6967	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/81","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":81,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"0","loans_pago_prestado":"0","loans_intereses_recaudar":"275000"},"items":[{"id":311,"loans_codigo":81,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":312,"loans_codigo":81,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":313,"loans_codigo":81,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":314,"loans_codigo":81,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":315,"loans_codigo":81,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":470,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:54:09
39949	9d6cbe7a-1bf2-4867-b6b5-663c15941a09	9d6cbe7a-54a5-4e3f-bc64-0e5da0afcb46	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 09:36:17
39950	9d6cbe7a-4c76-42c4-808f-772f769592da	9d6cbe7a-54a5-4e3f-bc64-0e5da0afcb46	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"89.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:36:17
39951	9d6cbe7a-4d51-4a57-b013-1543246ff75e	9d6cbe7a-54a5-4e3f-bc64-0e5da0afcb46	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:36:17
39952	9d6cbe7a-52ad-4639-8707-9a47771c37e3	9d6cbe7a-54a5-4e3f-bc64-0e5da0afcb46	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:36:17
39953	9d6cbe7a-5341-42f2-a13e-8299e94cd29d	9d6cbe7a-54a5-4e3f-bc64-0e5da0afcb46	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:36:17
28241	9d68ff46-aa57-4e37-94f3-093af61ff0b7	9d68ff46-edab-408a-869d-ba2c771b6704	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 12:54:09
28242	9d68ff46-e1c3-4d00-bacb-1bd802261931	9d68ff46-edab-408a-869d-ba2c771b6704	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"83.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 12:54:09
28243	9d68ff46-e261-4f16-8439-720aaafa0d6d	9d68ff46-edab-408a-869d-ba2c771b6704	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 12:54:09
28244	9d68ff46-eb76-4efc-86fc-600c7c80475a	9d68ff46-edab-408a-869d-ba2c771b6704	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 12:54:09
28245	9d68ff46-ec0a-4756-9e5d-2236586fe51a	9d68ff46-edab-408a-869d-ba2c771b6704	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":725,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:54:09
39954	9d6cbe7a-f5c5-4590-b269-191f0305c2f4	9d6cbe7b-3808-43e1-ace3-b65f3b9d098e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:36:17
39955	9d6cbe7b-33b9-4d5a-964c-03c91562be1b	9d6cbe7b-3808-43e1-ace3-b65f3b9d098e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"144.45","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:36:17
39956	9d6cbe7b-369f-4454-992e-bd2262b1fc3a	9d6cbe7b-3808-43e1-ace3-b65f3b9d098e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:36:17
39957	9d6cbe7b-36e0-4ddc-b5c3-821d4b5ec8a8	9d6cbe7b-3808-43e1-ace3-b65f3b9d098e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":564,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:36:17
28246	9d68ff47-a825-48b1-81da-cd7ea7b6737d	9d68ff47-fdd1-42bc-8106-44df28fd4466	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 12:54:10
28247	9d68ff47-f30a-4ce1-bfb9-55d620847bf2	9d68ff47-fdd1-42bc-8106-44df28fd4466	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"158.16","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 12:54:10
28248	9d68ff47-f373-45b4-ace3-ce0adbeb18be	9d68ff47-fdd1-42bc-8106-44df28fd4466	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 12:54:10
28249	9d68ff47-fb50-4b4a-a48a-36bb2269124e	9d68ff47-fdd1-42bc-8106-44df28fd4466	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 12:54:10
28250	9d68ff47-fc23-4ccd-a4e9-34eb654a07d4	9d68ff47-fdd1-42bc-8106-44df28fd4466	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":670,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:54:10
39958	9d6cbe87-a528-44a7-a13a-593c8a5a2c5b	9d6cbe87-f5eb-4080-8583-32b4d4add06e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:36:25
39959	9d6cbe87-eeb2-437e-bb15-d14e01ea2c14	9d6cbe87-f5eb-4080-8583-32b4d4add06e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"157.93","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:36:26
39960	9d6cbe87-ef2f-4892-862a-a30237782bc6	9d6cbe87-f5eb-4080-8583-32b4d4add06e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:36:26
39961	9d6cbe87-f472-46d6-92be-65aa3aa90324	9d6cbe87-f5eb-4080-8583-32b4d4add06e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:36:26
39962	9d6cbe87-f4ca-4e2f-b651-6832c9129a28	9d6cbe87-f5eb-4080-8583-32b4d4add06e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":415,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:36:26
39963	9d6cbe88-51ff-440d-bff8-208419a3d424	9d6cbe88-6e0a-4d57-886b-da138668a3fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:36:26
39964	9d6cbe88-692e-4e6f-9f11-3269cc1e9fd4	9d6cbe88-6e0a-4d57-886b-da138668a3fd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"45.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:36:26
39965	9d6cbe88-6cb6-49ff-a3df-d616f167b2ec	9d6cbe88-6e0a-4d57-886b-da138668a3fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:36:26
39966	9d6cbe88-6d05-4884-b02a-4a08ae8e2b7f	9d6cbe88-6e0a-4d57-886b-da138668a3fd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":293,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:36:26
39967	9d6cbe97-17a0-4a93-b65c-4b238e2bd566	9d6cbe97-3919-44aa-b2ff-c68052af4894	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:36:36
39968	9d6cbe97-3414-46ee-81e7-4a5a5dca84f6	9d6cbe97-3919-44aa-b2ff-c68052af4894	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"48.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:36:36
39969	9d6cbe97-3461-4400-8129-5f4421fe7e8b	9d6cbe97-3919-44aa-b2ff-c68052af4894	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:36:36
39970	9d6cbe97-37d1-48dd-a30f-6830fee6f349	9d6cbe97-3919-44aa-b2ff-c68052af4894	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:36:36
39971	9d6cbe97-3818-45c2-9a61-a9fe73403322	9d6cbe97-3919-44aa-b2ff-c68052af4894	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:36:36
39972	9d6cbe97-7aed-43f5-b9e0-df4908b6aa00	9d6cbe97-c07f-4059-be51-a7ca71c8fed5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:36:36
39973	9d6cbe97-bc4a-4051-9c2e-8883dd4848c5	9d6cbe97-c07f-4059-be51-a7ca71c8fed5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"153.77","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:36:36
39974	9d6cbe97-bf43-412d-addd-f4d284b3f55d	9d6cbe97-c07f-4059-be51-a7ca71c8fed5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 09:36:36
39975	9d6cbe97-bf86-4d19-bcf3-7e7212952f89	9d6cbe97-c07f-4059-be51-a7ca71c8fed5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:36:36
28344	9d6900ce-6b87-4b7c-a422-0681af4e651e	9d6900ce-9ecd-4bbb-8448-4e14bce8e543	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 12:58:26
28345	9d6900ce-9a7a-4a68-a7ce-64bf2796109a	9d6900ce-9ecd-4bbb-8448-4e14bce8e543	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 12:58:26
28346	9d6900ce-9be3-45b9-80cc-c8267ce9795a	9d6900ce-9ecd-4bbb-8448-4e14bce8e543	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":602,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:58:26
39976	9d6cbee2-e927-47b2-853c-a0b594244fad	9d6cbee3-1d2d-4d32-9809-d00351f53e46	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 09:37:25
39977	9d6cbee3-124d-485a-a406-5cb8c4e68dba	9d6cbee3-1d2d-4d32-9809-d00351f53e46	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"53.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:37:25
39978	9d6cbee3-12cf-445c-b502-056606aad0fc	9d6cbee3-1d2d-4d32-9809-d00351f53e46	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:37:25
39979	9d6cbee3-1b11-4f76-a462-df6613d5a98e	9d6cbee3-1d2d-4d32-9809-d00351f53e46	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:37:25
28347	9d6900cf-8906-4e9d-95bf-75262f4957af	9d6900cf-c73b-4925-9180-6507603f4e36	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 12:58:27
28348	9d6900cf-bfa3-4c2f-b191-8bcd2f2f4cf0	9d6900cf-c73b-4925-9180-6507603f4e36	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"86.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 12:58:27
28349	9d6900cf-c03b-4f8e-9bc6-bcbc964118d3	9d6900cf-c73b-4925-9180-6507603f4e36	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 12:58:27
28350	9d6900cf-c54d-4ef4-b8c4-c9a8740b8fce	9d6900cf-c73b-4925-9180-6507603f4e36	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 12:58:27
28351	9d6900cf-c5ac-4143-a9c4-97ba323c2191	9d6900cf-c73b-4925-9180-6507603f4e36	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":662,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:58:27
39980	9d6cbee3-1bba-495f-addd-3e4c4ae0ef70	9d6cbee3-1d2d-4d32-9809-d00351f53e46	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":406,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:37:25
28352	9d6900d0-8003-4a39-84fe-1c2bd0fd04f0	9d6900d0-dcdf-4e7f-a3e1-4c3a01a58196	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 12:58:27
28353	9d6900d0-d313-4aec-91f9-a38693561e9e	9d6900d0-dcdf-4e7f-a3e1-4c3a01a58196	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"173.68","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 12:58:28
28354	9d6900d0-d3d1-4173-bc61-b8b9c4881e21	9d6900d0-dcdf-4e7f-a3e1-4c3a01a58196	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 12:58:28
28355	9d6900d0-dab6-4def-874c-81518e1b5775	9d6900d0-dcdf-4e7f-a3e1-4c3a01a58196	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 12:58:28
28356	9d6900d0-db40-443c-be5c-15065ad3cea2	9d6900d0-dcdf-4e7f-a3e1-4c3a01a58196	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":688,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:58:28
39981	9d6cbee3-b9f7-4e69-8917-daa53dd16ccd	9d6cbee3-dd50-4bbc-aa75-736984dd6b21	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:37:26
39982	9d6cbee3-d502-4f77-a3d5-0417f756f37e	9d6cbee3-dd50-4bbc-aa75-736984dd6b21	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"54.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:37:26
39983	9d6cbee3-db61-41e4-ad90-687ab29860ec	9d6cbee3-dd50-4bbc-aa75-736984dd6b21	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:37:26
39984	9d6cbee3-dbea-4032-849d-f0ef74d945ef	9d6cbee3-dd50-4bbc-aa75-736984dd6b21	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":469,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:37:26
28357	9d6900d1-851a-422d-aec3-84d92809577f	9d6900d1-b37b-4e12-9008-ada610f3be59	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 12:58:28
28358	9d6900d1-a677-4dc8-83ea-1204dc663e61	9d6900d1-b37b-4e12-9008-ada610f3be59	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '81' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"58.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 12:58:28
28359	9d6900d1-a6fd-4cb5-87e5-be5048ea1833	9d6900d1-b37b-4e12-9008-ada610f3be59	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 12:58:28
28360	9d6900d1-aa65-41b5-acfa-bb9552b14d70	9d6900d1-b37b-4e12-9008-ada610f3be59	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '81' order by \\"item_loans\\".\\"id\\" asc","time":"5.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 12:58:28
28361	9d6900d1-aab8-4e5a-9985-b3a513cb83e6	9d6900d1-b37b-4e12-9008-ada610f3be59	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 12:58:28
28362	9d6900d1-b146-404f-bfc9-30b35f3c0cbb	9d6900d1-b37b-4e12-9008-ada610f3be59	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 12:58:28
28363	9d6900d1-b1df-420e-b7c2-827d07b84319	9d6900d1-b37b-4e12-9008-ada610f3be59	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/81","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":81,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"0","loans_pago_prestado":"0","loans_intereses_recaudar":"275000"},"items":[{"id":311,"loans_codigo":81,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":312,"loans_codigo":81,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":313,"loans_codigo":81,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":314,"loans_codigo":81,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":315,"loans_codigo":81,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":525,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:58:28
39985	9d6cbf4c-707f-4adc-93b0-fa083137f158	9d6cbf4c-a42c-426d-a2e1-9efdd0551312	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 09:38:34
39986	9d6cbf4c-99df-497a-afe5-de1ede9cba48	9d6cbf4c-a42c-426d-a2e1-9efdd0551312	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"61.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:38:34
39987	9d6cbf4c-9a84-4b35-92e1-ff475cb0a18a	9d6cbf4c-a42c-426d-a2e1-9efdd0551312	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:38:34
39988	9d6cbf4c-a1dd-43f5-9156-ca9f230a5182	9d6cbf4c-a42c-426d-a2e1-9efdd0551312	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:38:34
39989	9d6cbf4c-a261-4271-82e0-e05f8c868691	9d6cbf4c-a42c-426d-a2e1-9efdd0551312	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":450,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:38:34
28364	9d6900d3-01ea-41f5-bee9-cfbf41514186	9d6900d3-529f-4f8c-af9b-d719113f4d08	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 12:58:29
28365	9d6900d3-4877-48c1-b3af-93122dd4f1a5	9d6900d3-529f-4f8c-af9b-d719113f4d08	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"141.96","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 12:58:29
28366	9d6900d3-4931-4ca1-8056-53f5b51fd9c3	9d6900d3-529f-4f8c-af9b-d719113f4d08	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 12:58:29
28367	9d6900d3-50a6-4adf-8444-9ac4aa6806f8	9d6900d3-529f-4f8c-af9b-d719113f4d08	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 12:58:29
20332	9d66f148-48d1-4ab2-a764-ddb37a3e17c8	9d66f148-671a-4921-bf27-4d720813cc44	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 12:23:22
20333	9d66f148-653c-4f6e-84fa-6c21922e645a	9d66f148-671a-4921-bf27-4d720813cc44	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-03 12:23:22
20334	9d66f148-65ec-45bd-bd56-4aa0e8300af9	9d66f148-671a-4921-bf27-4d720813cc44	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":276,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:23:22
28368	9d6900d3-5145-439b-8b48-c114044314f5	9d6900d3-529f-4f8c-af9b-d719113f4d08	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1040,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:58:29
39990	9d6cbf4d-4422-4ec7-8db8-817f04e651b7	9d6cbf4d-6632-4ade-8a26-93a79f27a6ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:38:35
39991	9d6cbf4d-5ee5-4b6f-a7a3-d8c4240c9860	9d6cbf4d-6632-4ade-8a26-93a79f27a6ac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"53.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:38:35
39992	9d6cbf4d-64ac-40e8-9b13-d74574689529	9d6cbf4d-6632-4ade-8a26-93a79f27a6ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:38:35
39993	9d6cbf4d-6509-41f3-99ba-32c3ee4ff877	9d6cbf4d-6632-4ade-8a26-93a79f27a6ac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":471,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:38:35
20335	9d66f148-d8e2-4f61-9ebf-087c93bd5dd4	9d66f148-f957-45b9-8725-bf8df81f3694	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-03 12:23:23
20336	9d66f148-f06c-4ddb-b14e-b3b1015d7b66	9d66f148-f957-45b9-8725-bf8df81f3694	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"45.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:23:23
20337	9d66f148-f445-4f9c-9018-4e8aee3946f3	9d66f148-f957-45b9-8725-bf8df81f3694	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"1.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:23:23
20338	9d66f148-f477-404e-8a22-d5d6d5e72d17	9d66f148-f957-45b9-8725-bf8df81f3694	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:23:23
20339	9d66f148-f827-4700-9829-c51ef6d4cd0f	9d66f148-f957-45b9-8725-bf8df81f3694	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-03 12:23:23
20340	9d66f148-f871-4916-99e1-741ffa407fc1	9d66f148-f957-45b9-8725-bf8df81f3694	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":326,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:23:23
28369	9d6900d4-72ba-4ac7-935f-f5fb84b03559	9d6900d4-a2f4-4e11-b81a-e0ea739392f7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 12:58:30
28370	9d6900d4-9a08-4711-83a3-ddcf24aa906f	9d6900d4-a2f4-4e11-b81a-e0ea739392f7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"62.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 12:58:30
28371	9d6900d4-9a93-4a3e-b386-be2d19336da9	9d6900d4-a2f4-4e11-b81a-e0ea739392f7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 12:58:30
28372	9d6900d4-a0eb-45af-8827-d31358ab5f33	9d6900d4-a2f4-4e11-b81a-e0ea739392f7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 12:58:30
28373	9d6900d4-a173-45f5-9a8e-38fdac79a941	9d6900d4-a2f4-4e11-b81a-e0ea739392f7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":829,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:58:30
39994	9d6cbf63-9866-4d21-b62b-2ba70d7a7154	9d6cbf63-ee7c-4f63-8b7b-c770e99d4897	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:38:50
39995	9d6cbf63-e71f-4d8b-8d03-5c6f4b709a3d	9d6cbf63-ee7c-4f63-8b7b-c770e99d4897	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"165.04","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:38:50
39996	9d6cbf63-e7ab-4a4a-8716-399e1580b97d	9d6cbf63-ee7c-4f63-8b7b-c770e99d4897	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:38:50
20341	9d66f14a-8ff0-4657-8249-ee0bda124cba	9d66f14a-ea97-4d2b-b4af-efb30988fb30	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-03 12:23:24
20342	9d66f14a-e194-44ef-a2c1-51706b43c311	9d66f14a-ea97-4d2b-b4af-efb30988fb30	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"189.02","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:23:24
20343	9d66f14a-e240-4a45-86e2-146cd6dba0e8	9d66f14a-ea97-4d2b-b4af-efb30988fb30	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:23:24
20344	9d66f14a-e8be-4341-a214-c648ab9647bf	9d66f14a-ea97-4d2b-b4af-efb30988fb30	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-03 12:23:24
20345	9d66f14a-e92e-43a9-8925-cd8bdb80219d	9d66f14a-ea97-4d2b-b4af-efb30988fb30	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":501,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:23:24
39997	9d6cbf63-ecd6-4a22-b128-a421b09d6625	9d6cbf63-ee7c-4f63-8b7b-c770e99d4897	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:38:50
39998	9d6cbf63-ed35-477e-a6ac-52c8d51c7269	9d6cbf63-ee7c-4f63-8b7b-c770e99d4897	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":558,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:38:50
20758	9d66fbe6-5bb4-44ab-b2d3-8ff3b300b32d	9d66fbe6-66e5-4af1-bb56-961d5661ff74	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"165.57","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:53:04
20759	9d66fbe6-5c3a-45af-b0ac-82008110422a	9d66fbe6-66e5-4af1-bb56-961d5661ff74	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:53:04
20760	9d66fbe6-6454-4083-a777-12e28308ab1e	9d66fbe6-66e5-4af1-bb56-961d5661ff74	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-03 12:53:04
39999	9d6cbf64-500c-4871-884b-9651c5986d11	9d6cbf64-73a2-4e6d-bebd-455f8d95d619	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:38:50
40000	9d6cbf64-6c3c-4d9a-8dd9-60b0347b5d53	9d6cbf64-73a2-4e6d-bebd-455f8d95d619	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"51.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:38:50
40001	9d6cbf64-721f-48ee-a95f-fc727402b6de	9d6cbf64-73a2-4e6d-bebd-455f8d95d619	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:38:50
40002	9d6cbf64-7280-49a3-acfb-71fc4c380e05	9d6cbf64-73a2-4e6d-bebd-455f8d95d619	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":316,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:38:50
40003	9d6cbf73-603e-4768-bead-f6f3d9b1c027	9d6cbf73-8c12-4649-8d91-cfd6c00f1940	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:39:00
40004	9d6cbf73-84e6-4867-b668-250d660fbafd	9d6cbf73-8c12-4649-8d91-cfd6c00f1940	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"61.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:39:00
40005	9d6cbf73-8549-49b2-92c2-adad91632f84	9d6cbf73-8c12-4649-8d91-cfd6c00f1940	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:39:00
40006	9d6cbf73-8a69-4b8a-ad40-9d35b29f84f3	9d6cbf73-8c12-4649-8d91-cfd6c00f1940	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:39:00
40007	9d6cbf73-8ad5-4b3a-b4fd-c9ddc78c7449	9d6cbf73-8c12-4649-8d91-cfd6c00f1940	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":390,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:39:00
40008	9d6cbf73-fad3-4fa5-a711-e8d604369f79	9d6cbf74-217c-46da-a7ac-1fe72a652309	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:39:00
40009	9d6cbf74-19eb-44a5-92cb-f0c79d83ceef	9d6cbf74-217c-46da-a7ac-1fe72a652309	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"61.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:39:00
40010	9d6cbf74-1f9c-494d-aa87-dfe81b60ef8a	9d6cbf74-217c-46da-a7ac-1fe72a652309	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 09:39:00
40011	9d6cbf74-2022-42b4-8c6a-cb83e95d60ed	9d6cbf74-217c-46da-a7ac-1fe72a652309	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":359,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:39:00
28467	9d6901c3-2383-4d0f-b649-541648de8024	9d6901c3-5a8b-4276-99ad-d440a181389e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 13:01:06
28468	9d6901c3-5744-4625-9bc9-5d8cbae6dc66	9d6901c3-5a8b-4276-99ad-d440a181389e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 13:01:07
28469	9d6901c3-58bb-4d52-af95-9ce76cef8096	9d6901c3-5a8b-4276-99ad-d440a181389e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":598,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:01:07
28470	9d6901c3-fd6f-45cd-97da-58477e4d50b6	9d6901c4-2879-49d1-8f09-c4bcb09cbaf6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 13:01:07
28471	9d6901c4-1dbc-4e66-a630-dbfeb21533be	9d6901c4-2879-49d1-8f09-c4bcb09cbaf6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"57.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:01:07
28472	9d6901c4-1e58-47fd-8536-f59147d84aab	9d6901c4-2879-49d1-8f09-c4bcb09cbaf6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 13:01:07
28473	9d6901c4-2678-41e9-b815-26c4f3387411	9d6901c4-2879-49d1-8f09-c4bcb09cbaf6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 13:01:07
28474	9d6901c4-26fd-461e-a389-7e323202d7cf	9d6901c4-2879-49d1-8f09-c4bcb09cbaf6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":447,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:01:07
40012	9d6cbf9e-072b-40ed-b71c-9aa01e929058	9d6cbf9e-2a57-41cd-8430-00159ef5e29e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 09:39:28
40013	9d6cbf9e-22ea-455b-9d9f-1a5ee4201af7	9d6cbf9e-2a57-41cd-8430-00159ef5e29e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"46.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:39:28
40014	9d6cbf9e-234c-428e-8aa6-331956b610f9	9d6cbf9e-2a57-41cd-8430-00159ef5e29e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:39:28
40015	9d6cbf9e-28c7-4f98-a215-6053dcb28e9c	9d6cbf9e-2a57-41cd-8430-00159ef5e29e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 09:39:28
40016	9d6cbf9e-292b-48b3-a4d0-3cbb630ad10c	9d6cbf9e-2a57-41cd-8430-00159ef5e29e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":308,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:39:28
28475	9d6901c4-dcb5-443e-b58e-ed287b38387a	9d6901c5-07e0-4ff5-8445-b152f32953f8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 13:01:08
28476	9d6901c5-0075-4627-8424-8dc2297d00e1	9d6901c5-07e0-4ff5-8445-b152f32953f8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"53.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:01:08
28477	9d6901c5-00f6-45e5-a249-4020ca843520	9d6901c5-07e0-4ff5-8445-b152f32953f8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 13:01:08
28478	9d6901c5-0663-4580-902b-126b7e08e88d	9d6901c5-07e0-4ff5-8445-b152f32953f8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 13:01:08
28479	9d6901c5-06c9-42ee-9edb-88f26db721a6	9d6901c5-07e0-4ff5-8445-b152f32953f8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":547,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:01:08
40017	9d6cbf9e-812d-483c-bad6-35155fb101ef	9d6cbf9e-a025-490e-acae-92a6c7668843	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 09:39:28
40018	9d6cbf9e-9a10-406d-b410-2e3a6518c792	9d6cbf9e-a025-490e-acae-92a6c7668843	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"48.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:39:28
40019	9d6cbf9e-9e8a-438d-9d30-fa250421547d	9d6cbf9e-a025-490e-acae-92a6c7668843	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 09:39:28
40020	9d6cbf9e-9ef7-4020-88ae-8ecfaf2573a5	9d6cbf9e-a025-490e-acae-92a6c7668843	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":284,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:39:28
28480	9d6901c5-8dc6-40ca-8e8e-4a8076bb17a1	9d6901c5-b254-48c9-9d27-0b19e0474433	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 13:01:08
28481	9d6901c5-a932-46f1-8451-e40125ad557f	9d6901c5-b254-48c9-9d27-0b19e0474433	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '81' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"44.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 13:01:08
28482	9d6901c5-a9ab-49bf-9e70-dca2a383e149	9d6901c5-b254-48c9-9d27-0b19e0474433	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 13:01:08
28483	9d6901c5-abd4-4487-8ce6-0b76c6097b74	9d6901c5-b254-48c9-9d27-0b19e0474433	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '81' order by \\"item_loans\\".\\"id\\" asc","time":"2.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:01:08
28484	9d6901c5-ac17-451c-8e96-c132b14df6f1	9d6901c5-b254-48c9-9d27-0b19e0474433	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 13:01:08
28485	9d6901c5-b090-4ed5-8482-1ea958630416	9d6901c5-b254-48c9-9d27-0b19e0474433	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 13:01:08
28486	9d6901c5-b11c-4da0-8a32-18640a543c96	9d6901c5-b254-48c9-9d27-0b19e0474433	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/81","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":81,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"0","loans_pago_prestado":"0","loans_intereses_recaudar":"275000"},"items":[{"id":311,"loans_codigo":81,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":312,"loans_codigo":81,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":313,"loans_codigo":81,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":314,"loans_codigo":81,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":315,"loans_codigo":81,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":410,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:01:08
40021	9d6cbfc4-4521-4d4d-b3ac-b9abd4135a26	9d6cbfc4-720a-466c-be78-8b7d64a0c4c7	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 09:39:53
40022	9d6cbfc4-69cd-44b5-af54-9c4747f7a453	9d6cbfc4-720a-466c-be78-8b7d64a0c4c7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:39:53
40023	9d6cbfc4-6a46-4f1c-8232-a299d38072a9	9d6cbfc4-720a-466c-be78-8b7d64a0c4c7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:39:53
40024	9d6cbfc4-703d-4210-9129-7d2a8e9d4697	9d6cbfc4-720a-466c-be78-8b7d64a0c4c7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:39:53
40025	9d6cbfc4-70af-448c-9e34-b735060fce02	9d6cbfc4-720a-466c-be78-8b7d64a0c4c7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":338,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:39:53
40026	9d6cbfc5-038a-4f7a-a63e-1db4a7ee127e	9d6cbfc5-4e47-4748-88ed-991215f2c6e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:39:53
40027	9d6cbfc5-493d-4dee-84c1-0165761acb08	9d6cbfc5-4e47-4748-88ed-991215f2c6e5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"162.53","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:39:54
28487	9d6901c6-7c7c-4b1f-b6a7-7c086e4fa9d5	9d6901c6-c61d-461c-838f-85d77065c725	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 13:01:09
25943	9d68cbfd-ded4-4ae5-b7da-32a0314b4d7b	9d68cbfe-076c-4f56-9966-473a7e131f79	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 10:30:45
25944	9d68cbfe-04d2-4ba4-8392-d4c306ebc4e2	9d68cbfe-076c-4f56-9966-473a7e131f79	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:30:45
25945	9d68cbfe-05b6-4510-a965-ef26454f76d9	9d68cbfe-076c-4f56-9966-473a7e131f79	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":490,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:30:45
28488	9d6901c6-bba5-4322-9f4f-31443aa78d5a	9d6901c6-c61d-461c-838f-85d77065c725	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"90.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:01:09
40028	9d6cbfc5-4cca-49b0-8736-82bf2db40bd9	9d6cbfc5-4e47-4748-88ed-991215f2c6e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:39:54
28489	9d6901c6-bc6f-4e3c-8384-d53fe0b692a9	9d6901c6-c61d-461c-838f-85d77065c725	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:01:09
28490	9d6901c6-c43a-4372-9100-7bb67330d84d	9d6901c6-c61d-461c-838f-85d77065c725	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 13:01:09
28491	9d6901c6-c4d4-4474-9944-f0c55cd9672d	9d6901c6-c61d-461c-838f-85d77065c725	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":688,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:01:09
40029	9d6cbfc5-4d1b-4adb-885c-68e9a869a4ab	9d6cbfc5-4e47-4748-88ed-991215f2c6e5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":547,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:39:54
25946	9d68cbfe-a60e-4057-a70c-04f46c608fad	9d68cbfe-f584-492f-9119-cb363f1303ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:30:46
25947	9d68cbfe-e97e-4935-ab7e-5ece66de2dba	9d68cbfe-f584-492f-9119-cb363f1303ac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 90\\n                        ","time":"156.92","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"93c10371e33ace24260de21c3ff3890d","hostname":"EderCortes"}	2024-11-04 10:30:46
25948	9d68cbfe-ede4-4fb9-9d47-8513d4699f51	9d68cbfe-f584-492f-9119-cb363f1303ac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"2.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:30:46
25949	9d68cbfe-ee1b-4ace-8f61-6b3204c34fdc	9d68cbfe-f584-492f-9119-cb363f1303ac	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 10:30:46
25950	9d68cbfe-f3d9-4727-8066-bd3514c1ab4d	9d68cbfe-f584-492f-9119-cb363f1303ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:30:46
25951	9d68cbfe-f44b-464f-96ad-bf62d8915557	9d68cbfe-f584-492f-9119-cb363f1303ac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"}]}},"duration":552,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:30:46
28492	9d6901c7-cc07-4840-98d9-07d425fcfe9d	9d6901c7-ed1b-4721-888c-09156dfd4eb8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 13:01:09
28493	9d6901c7-e6f4-470c-a1fb-dee502034072	9d6901c7-ed1b-4721-888c-09156dfd4eb8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:01:10
28494	9d6901c7-e754-44c3-89c3-f7324065936c	9d6901c7-ed1b-4721-888c-09156dfd4eb8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:01:10
28495	9d6901c7-eb66-4da6-9ef1-417e3472f56c	9d6901c7-ed1b-4721-888c-09156dfd4eb8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 13:01:10
28496	9d6901c7-ebc6-435c-a864-42bb977f97b6	9d6901c7-ed1b-4721-888c-09156dfd4eb8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":726,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:01:10
40030	9d6cbfe6-a13d-4a3f-b86b-d8a7ef7d1a49	9d6cbfe6-c748-4094-bcfa-6b3df169773d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:40:15
40031	9d6cbfe6-c0ca-4d44-8e2e-7aedba1127fa	9d6cbfe6-c748-4094-bcfa-6b3df169773d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"52.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:40:15
40032	9d6cbfe6-c135-449a-b2a6-db705df5df48	9d6cbfe6-c748-4094-bcfa-6b3df169773d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:40:15
40033	9d6cbfe6-c5a6-48ba-b1eb-7f633a74bd06	9d6cbfe6-c748-4094-bcfa-6b3df169773d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:40:16
40034	9d6cbfe6-c613-4c97-8da6-b7cd2c79bff6	9d6cbfe6-c748-4094-bcfa-6b3df169773d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":328,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:40:16
40035	9d6cbfe7-2450-4a42-b7c5-9cfa93da0737	9d6cbfe7-4432-445d-ae8a-317440f270cb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:40:16
40036	9d6cbfe7-3e91-4cbf-b006-74116606bed5	9d6cbfe7-4432-445d-ae8a-317440f270cb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"47.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:40:16
40037	9d6cbfe7-42b3-43dc-a4c4-bc28f2c39601	9d6cbfe7-4432-445d-ae8a-317440f270cb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:40:16
40038	9d6cbfe7-4309-4664-b234-f653dca7e39e	9d6cbfe7-4432-445d-ae8a-317440f270cb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":302,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:40:16
40039	9d6cbff9-f852-4961-b909-42408bceb41a	9d6cbffa-1d37-4c36-91c8-0a21564fb209	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:40:28
40040	9d6cbffa-151d-4441-9d6e-2eea2623f1c2	9d6cbffa-1d37-4c36-91c8-0a21564fb209	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"47.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:40:28
40041	9d6cbffa-158b-4be9-8cf4-9b444f714701	9d6cbffa-1d37-4c36-91c8-0a21564fb209	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:40:28
40042	9d6cbffa-1b83-4cab-982f-a828014a0e57	9d6cbffa-1d37-4c36-91c8-0a21564fb209	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:40:28
40043	9d6cbffa-1bee-4580-aae6-876a6ea6c0cf	9d6cbffa-1d37-4c36-91c8-0a21564fb209	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":285,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:40:28
40044	9d6cbffa-6f85-459e-a21a-6e93b8f0c99b	9d6cbffa-b3d9-41ed-b54f-6a12b4d2c4db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:40:28
40045	9d6cbffa-ae1f-415f-8b4a-76041b02eaf8	9d6cbffa-b3d9-41ed-b54f-6a12b4d2c4db	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"145.11","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:40:29
40046	9d6cbffa-b249-4530-b461-9aa022aeb8a3	9d6cbffa-b3d9-41ed-b54f-6a12b4d2c4db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 09:40:29
40047	9d6cbffa-b2ac-4d35-a45f-0189c3f05a21	9d6cbffa-b3d9-41ed-b54f-6a12b4d2c4db	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":369,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:40:29
40048	9d6cc033-77d8-4268-8fe7-4e90049d21ef	9d6cc033-f178-4936-9882-d6ef35b8f3d6	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 09:41:06
40049	9d6cc033-e28f-4b73-b16e-96de5e2949aa	9d6cc033-f178-4936-9882-d6ef35b8f3d6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"184.10","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:41:06
40050	9d6cc033-e32d-40a2-a97b-5be43bdd235d	9d6cc033-f178-4936-9882-d6ef35b8f3d6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:41:06
40051	9d6cc033-ee83-4a37-a5c1-26e9166af780	9d6cc033-f178-4936-9882-d6ef35b8f3d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:41:06
40052	9d6cc033-ef28-4d2d-b917-ddf7f2d568c3	9d6cc033-f178-4936-9882-d6ef35b8f3d6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":889,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:41:06
40053	9d6cc034-8f07-40ab-995d-d8f6dac15b8a	9d6cc034-b4f2-4e7a-8a4f-14d38537571e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:41:06
40054	9d6cc034-ad9d-4279-b906-f4152fd90dbb	9d6cc034-b4f2-4e7a-8a4f-14d38537571e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"59.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:41:07
40055	9d6cc034-b337-4760-add5-a83c07367829	9d6cc034-b4f2-4e7a-8a4f-14d38537571e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:41:07
40056	9d6cc034-b3a9-43d4-8e0f-20e2c2eb8ac7	9d6cc034-b4f2-4e7a-8a4f-14d38537571e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":475,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:41:07
26063	9d68cd50-808c-4d2c-a0fa-1be88ad7a4f6	9d68cd50-a4c7-456a-be2e-ced36e7c5f78	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 10:34:27
26064	9d68cd50-a258-441c-a0f2-2fd4714c84aa	9d68cd50-a4c7-456a-be2e-ced36e7c5f78	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:34:27
26065	9d68cd50-a3a1-4ffd-904a-7744178a7467	9d68cd50-a4c7-456a-be2e-ced36e7c5f78	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":395,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:34:27
40057	9d6cc064-f3e2-42de-8093-79e7d04b2bc1	9d6cc065-3d42-4809-9f5c-f86867a2184d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:41:38
40058	9d6cc065-0d04-4aa2-b34d-74f0ac5e6fcb	9d6cc065-3d42-4809-9f5c-f86867a2184d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:41:38
40059	9d6cc065-0d4a-4a4a-bb80-604fcb87f930	9d6cc065-3d42-4809-9f5c-f86867a2184d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:41:38
40060	9d6cc065-109e-431e-823d-c5135222d7f1	9d6cc065-3d42-4809-9f5c-f86867a2184d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:41:38
26066	9d68cd51-43a3-4be3-be31-632f45b38bf5	9d68cd51-6333-49b9-aec3-66a98067115d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:34:28
26067	9d68cd51-5955-41d0-9f44-0beaa563b74d	9d68cd51-6333-49b9-aec3-66a98067115d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 90\\n                        ","time":"42.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"93c10371e33ace24260de21c3ff3890d","hostname":"EderCortes"}	2024-11-04 10:34:28
26068	9d68cd51-5d70-4916-9147-152931e8f43a	9d68cd51-6333-49b9-aec3-66a98067115d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"2.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:34:28
26069	9d68cd51-5da3-4552-8dda-48f373495a08	9d68cd51-6333-49b9-aec3-66a98067115d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 10:34:28
26070	9d68cd51-6203-4cc1-9a2c-257523e0fd2f	9d68cd51-6333-49b9-aec3-66a98067115d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:34:28
26071	9d68cd51-6255-4fd8-8da0-58b574721565	9d68cd51-6333-49b9-aec3-66a98067115d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"}]}},"duration":439,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:34:28
40061	9d6cc065-10e0-4187-ae53-b1ed12acd9d3	9d6cc065-3d42-4809-9f5c-f86867a2184d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:41:38
20437	9d66f32a-27b1-4606-948f-6277569c8878	9d66f32a-4a6e-4513-b8d2-b1c0434fdb75	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 12:28:38
20438	9d66f32a-4857-4922-9d40-3b373e95469c	9d66f32a-4a6e-4513-b8d2-b1c0434fdb75	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:28:38
20439	9d66f32a-493e-4607-bca5-d27686d5815b	9d66f32a-4a6e-4513-b8d2-b1c0434fdb75	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":273,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:28:38
20440	9d66f32a-aa36-4bb6-b8f3-8fd506993382	9d66f32a-f6bd-4e4f-bb76-bcb2070ffbf4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 12:28:38
20441	9d66f32a-eb08-428a-b3c1-d56512f78066	9d66f32a-f6bd-4e4f-bb76-bcb2070ffbf4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"149.78","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:28:39
20442	9d66f32a-ef45-437e-b86d-8dcff35c20f7	9d66f32a-f6bd-4e4f-bb76-bcb2070ffbf4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:28:39
20443	9d66f32a-ef87-46b6-99c8-fbfb3ad52088	9d66f32a-f6bd-4e4f-bb76-bcb2070ffbf4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:28:39
20444	9d66f32a-f572-4b69-9eb5-f57b2f0eceb2	9d66f32a-f6bd-4e4f-bb76-bcb2070ffbf4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:28:39
20445	9d66f32a-f5c1-4ea1-8bee-4d3f6b496bf5	9d66f32a-f6bd-4e4f-bb76-bcb2070ffbf4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"300000","loans_pago_interes":"150000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":null,"itemloans_cuota_cancelada":null}]}},"duration":389,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:28:39
40062	9d6cc065-a105-4dfb-ad2d-88cde12193ca	9d6cc065-c239-42f0-a99c-5a677922c180	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:41:39
40063	9d6cc065-bd7c-40ef-bf54-7d6b7b41e628	9d6cc065-c239-42f0-a99c-5a677922c180	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"54.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:41:39
40064	9d6cc065-c0d0-4f60-b735-28a324fd12ee	9d6cc065-c239-42f0-a99c-5a677922c180	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 09:41:39
40065	9d6cc065-c116-4541-8b5d-8e567937124c	9d6cc065-c239-42f0-a99c-5a677922c180	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":325,"memory":20,"hostname":"EderCortes"}	2024-11-06 09:41:39
20446	9d66f32d-0cc2-4dd5-9c6a-6483f41ea203	9d66f32d-5254-4702-b05d-fdfd632fd92c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 12:28:40
20447	9d66f32d-4474-4253-ae5b-846a6c041d6d	9d66f32d-5254-4702-b05d-fdfd632fd92c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"75.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 12:28:40
18798	9d669bef-384f-4fc8-b037-3ce8153b2a96	9d669bef-66b1-45c2-ad34-4fff07990cb0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 08:24:43
18799	9d669bef-6466-4ed6-825b-8550d26a51df	9d669bef-66b1-45c2-ad34-4fff07990cb0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 08:24:43
18800	9d669bef-653a-479b-b0c8-b0254e59c730	9d669bef-66b1-45c2-ad34-4fff07990cb0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42883]: Undefined function: 7 ERROR:  no existe la funci\\u00f3n pg_catalog.extract(unknown, text)\\nLINE 14:         EXTRACT(DAY FROM (\\n                 ^\\nHINT:  Ninguna funci\\u00f3n coincide en el nombre y tipos de argumentos. Puede ser necesario agregar conversi\\u00f3n expl\\u00edcita de tipos. (Connection: pgsql, SQL: select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        )) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"index","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":314,"memory":22,"hostname":"EderCortes"}	2024-11-03 08:24:43
20448	9d66f32d-4506-4742-89c1-9eb4e4dcf979	9d66f32d-5254-4702-b05d-fdfd632fd92c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 12:28:40
20449	9d66f32d-4fd6-431f-9e63-f1b1935ea4dc	9d66f32d-5254-4702-b05d-fdfd632fd92c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 12:28:40
20450	9d66f32d-5083-4df2-b40e-59b6bc206184	9d66f32d-5254-4702-b05d-fdfd632fd92c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":744,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:28:40
18797	9d669bef-61c8-4f9f-8be1-b8d41f00a9e7	9d669bef-66b1-45c2-ad34-4fff07990cb0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42883]: Undefined function: 7 ERROR:  no existe la funci\\u00f3n pg_catalog.extract(unknown, text)\\nLINE 14:         EXTRACT(DAY FROM (\\n                 ^\\nHINT:  Ninguna funci\\u00f3n coincide en el nombre y tipos de argumentos. Puede ser necesario agregar conversi\\u00f3n expl\\u00edcita de tipos. (Connection: pgsql, SQL: select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        )) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":915}	2024-11-03 08:24:43
40436	9d6cc364-b705-4660-b7fb-6662903db25d	9d6cc364-fa88-4737-8877-180cc9c937b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 09:50:01
40437	9d6cc364-f910-4b06-bb26-75f389d87a76	9d6cc364-fa88-4737-8877-180cc9c937b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 09:50:02
40438	9d6cc364-f9a3-419f-ab04-e9f63ccf587d	9d6cc364-fa88-4737-8877-180cc9c937b6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":339,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:50:02
43552	9d6cea0f-a177-4b89-bd50-36374917a43b	9d6cea0f-bc26-430c-9a50-ffeef84c61e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":29,"hostname":"EderCortes"}	2024-11-06 11:38:09
43553	9d6cea0f-ba7f-4524-a886-163a34eff8d8	9d6cea0f-bc26-430c-9a50-ffeef84c61e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":30,"hostname":"EderCortes"}	2024-11-06 11:38:09
40439	9d6cc366-0ff7-4933-9392-1e4edfef7860	9d6cc366-2cd7-4930-a9a6-888b2895581e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 09:50:02
40440	9d6cc366-27da-4623-aac9-bbfa20b088b8	9d6cc366-2cd7-4930-a9a6-888b2895581e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:50:02
40441	9d6cc366-282d-41f6-949d-fd7a34011066	9d6cc366-2cd7-4930-a9a6-888b2895581e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:50:02
40442	9d6cc366-2b71-40e4-91f6-e6b2a1071c62	9d6cc366-2cd7-4930-a9a6-888b2895581e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 09:50:02
40443	9d6cc366-2bda-45b2-8b5e-9b349946049f	9d6cc366-2cd7-4930-a9a6-888b2895581e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:50:02
40466	9d6cc3be-ed5b-4903-b8e3-d4a0cb53937b	9d6cc3bf-0a33-48ff-b08f-20b8d5e07392	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:51:00
40467	9d6cc3bf-0883-447f-bfb8-1917b2de5a56	9d6cc3bf-0a33-48ff-b08f-20b8d5e07392	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:51:01
40468	9d6cc3bf-0932-4bf8-80a4-861e599525cc	9d6cc3bf-0a33-48ff-b08f-20b8d5e07392	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":224,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:51:01
40444	9d6cc366-6eb9-47c3-b665-378f6c2ac5bd	9d6cc366-88d1-4d9a-824f-0bbc1f99fd4a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 09:50:02
40445	9d6cc366-8437-493e-8804-1abf9e2b364c	9d6cc366-88d1-4d9a-824f-0bbc1f99fd4a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"41.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:50:03
40446	9d6cc366-8729-4331-9748-2c75fb5067b6	9d6cc366-88d1-4d9a-824f-0bbc1f99fd4a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 09:50:03
40447	9d6cc366-87be-4b57-bdf3-3d58df775098	9d6cc366-88d1-4d9a-824f-0bbc1f99fd4a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":222,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:50:03
30613	9d694124-824b-49bb-82e7-b2d42d8d4186	9d694124-869c-4ec5-befe-15a2ced0dbaf	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1461}	2024-11-04 15:58:20
40640	9d6cc62d-216f-41e5-b40b-55f23c503dca	9d6cc62d-3b35-4c3f-8044-e99b2410b0e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:57:48
40641	9d6cc62d-399d-4739-bace-aff48a0aa02b	9d6cc62d-3b35-4c3f-8044-e99b2410b0e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:57:48
40642	9d6cc62d-3a33-4d73-9012-744554c4e1f7	9d6cc62d-3b35-4c3f-8044-e99b2410b0e4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":256,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:57:48
6747	9d52d53f-3da7-4013-b630-8ad46ea26894	9d52d53f-41eb-47d4-b2a1-a5087cc35602	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":345}	2024-10-24 12:28:25
40260	9d6cc237-d221-4cde-a8df-9fe799d9f692	9d6cc237-ef0f-4261-9f7e-d05a75f79388	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:46:44
40261	9d6cc237-ecea-4949-aa81-99513c7f50aa	9d6cc237-ef0f-4261-9f7e-d05a75f79388	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:46:44
40262	9d6cc237-ede4-40f3-8eef-7e6c0395c8c3	9d6cc237-ef0f-4261-9f7e-d05a75f79388	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":338,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:46:44
40643	9d6cc62e-6081-4867-a44d-8f792af120de	9d6cc62e-8a4d-4270-8274-e529278494b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:57:49
40263	9d6cc238-48f4-429e-be89-63930b4e8a9b	9d6cc238-92fe-4de2-b520-7030592f32f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:46:44
40264	9d6cc238-8e20-4a0f-b4b3-dce9d3bfe9cc	9d6cc238-92fe-4de2-b520-7030592f32f2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"158.87","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 09:46:45
40265	9d6cc238-9187-49db-b2c2-c25b5f4c49c4	9d6cc238-92fe-4de2-b520-7030592f32f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:46:45
40266	9d6cc238-91f9-4470-b579-74b3139551f3	9d6cc238-92fe-4de2-b520-7030592f32f2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":351,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:46:45
40644	9d6cc62e-8205-4c0f-8385-8f84360d938b	9d6cc62e-8a4d-4270-8274-e529278494b2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"57.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:57:49
40521	9d6cc42a-a7a7-49e0-bcad-1a048773fa7b	9d6cc42a-f0b3-4742-a35a-43d58443117f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:52:11
40522	9d6cc42a-eef3-4bc8-940e-50f1424e7619	9d6cc42a-f0b3-4742-a35a-43d58443117f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:52:11
40523	9d6cc42a-efa6-465f-bb68-6f8ab1e4c6da	9d6cc42a-f0b3-4742-a35a-43d58443117f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":414,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:52:11
40645	9d6cc62e-826d-4a4b-ab85-261d005761a8	9d6cc62e-8a4d-4270-8274-e529278494b2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:57:49
40646	9d6cc62e-889c-4787-b1b3-1c739545d56c	9d6cc62e-8a4d-4270-8274-e529278494b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:57:49
40647	9d6cc62e-88f5-4077-beb9-11f616ff31e3	9d6cc62e-8a4d-4270-8274-e529278494b2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":363,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:57:49
40524	9d6cc42b-bcc1-4042-af71-cf58458a622b	9d6cc42b-e471-457c-811a-ba6141186c72	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:52:12
21681	9d673db3-0c52-4bfd-b967-8640ad9096ce	9d673db3-36d5-4ade-8d3d-da9e14b62013	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-03 15:57:03
21682	9d673db3-348c-49d2-86b2-120925feac6a	9d673db3-36d5-4ade-8d3d-da9e14b62013	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:57:03
21683	9d673db3-3560-4446-8236-c14f06b94128	9d673db3-36d5-4ade-8d3d-da9e14b62013	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":355,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:57:03
40525	9d6cc42b-dafa-45c7-8e22-0c5845f258f8	9d6cc42b-e471-457c-811a-ba6141186c72	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"49.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:52:12
40267	9d6cc238-e931-4f9d-baa8-669a5451cff9	9d6cc239-0ba7-4cd8-8cc3-9fe7e54c4b3a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:46:45
40268	9d6cc239-0619-47a3-bf79-25d4ed309c2f	9d6cc239-0ba7-4cd8-8cc3-9fe7e54c4b3a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 09:46:45
40526	9d6cc42b-db84-4d83-b5cc-e10beb09aa70	9d6cc42b-e471-457c-811a-ba6141186c72	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:52:12
40269	9d6cc239-0679-477e-948d-332a2ac8f5c4	9d6cc239-0ba7-4cd8-8cc3-9fe7e54c4b3a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 09:46:45
40270	9d6cc239-0a5d-4e67-8278-bfb6c8bb787a	9d6cc239-0ba7-4cd8-8cc3-9fe7e54c4b3a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:46:45
40271	9d6cc239-0aa8-4565-8f0c-2162675c1fc1	9d6cc239-0ba7-4cd8-8cc3-9fe7e54c4b3a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":289,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:46:45
40527	9d6cc42b-e2bd-4a76-a8eb-5b518b658fb7	9d6cc42b-e471-457c-811a-ba6141186c72	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:52:12
40528	9d6cc42b-e373-4c9b-bd0e-f739589d3619	9d6cc42b-e471-457c-811a-ba6141186c72	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":309,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:52:12
40648	9d6cc62e-ed16-43da-9421-e1074b816e1d	9d6cc62f-340a-468f-a49a-da15d3dc0f48	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:57:49
40649	9d6cc62f-2e56-4115-81b3-aff5e8463de2	9d6cc62f-340a-468f-a49a-da15d3dc0f48	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"150.74","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:57:50
40650	9d6cc62f-3266-4904-9475-398c23db6a4c	9d6cc62f-340a-468f-a49a-da15d3dc0f48	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:57:50
40651	9d6cc62f-32c9-4cc8-b54c-a61d2fae6356	9d6cc62f-340a-468f-a49a-da15d3dc0f48	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":406,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:57:50
21684	9d673db3-ba50-4d06-bc0b-d0f6a7c53d7c	9d673db3-de09-4337-8cdd-f87409fe8fdf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-03 15:57:03
21685	9d673db3-d797-4aee-b6e4-49b30f2472af	9d673db3-de09-4337-8cdd-f87409fe8fdf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"50.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 15:57:03
21686	9d673db3-d7f2-4868-a944-daa5b92c364c	9d673db3-de09-4337-8cdd-f87409fe8fdf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 15:57:03
21687	9d673db3-dcc9-4deb-aec2-766c8a9db274	9d673db3-de09-4337-8cdd-f87409fe8fdf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:57:03
21688	9d673db3-dd31-410f-9259-04a5dc945555	9d673db3-de09-4337-8cdd-f87409fe8fdf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":352,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:57:03
30175	9d693594-9b49-4735-aa82-2d80e30cb55d	9d693594-9f2d-4369-acd8-f1314ffdda51	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1436}	2024-11-04 15:26:00
28727	9d690738-93ae-4c9b-a9be-ce5ac18a8735	9d690738-cb5d-4951-b46c-ed5e36f37ed4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 13:16:22
28728	9d690738-c94c-4f83-991b-c340a88e8e1c	9d690738-cb5d-4951-b46c-ed5e36f37ed4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 13:16:22
21689	9d673db4-32b0-4cae-8443-1e19a57f8f65	9d673db4-50ba-467b-ab5a-bd3e4a388999	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 15:57:04
21690	9d673db4-4bfa-4273-9f6d-ca2c1428a0b6	9d673db4-50ba-467b-ab5a-bd3e4a388999	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 15:57:04
21691	9d673db4-4c48-42ef-a61d-0aab69fbb05a	9d673db4-50ba-467b-ab5a-bd3e4a388999	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-03 15:57:04
21692	9d673db4-4f9f-48d6-b240-5af91f1b69c6	9d673db4-50ba-467b-ab5a-bd3e4a388999	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 15:57:04
21693	9d673db4-4fe5-4c60-9cfb-90756350a7f1	9d673db4-50ba-467b-ab5a-bd3e4a388999	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":279,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:57:04
28729	9d690738-ca36-493e-bdac-2001cd3577f5	9d690738-cb5d-4951-b46c-ed5e36f37ed4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":624,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:16:22
40272	9d6cc239-5031-4276-8433-4aba2c1718bd	9d6cc239-989f-4b26-927a-fe3a8b65a11f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:46:45
40273	9d6cc239-9389-479f-a155-a171abc5e448	9d6cc239-989f-4b26-927a-fe3a8b65a11f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"146.85","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 09:46:45
40274	9d6cc239-93de-4509-9958-e78861d454ca	9d6cc239-989f-4b26-927a-fe3a8b65a11f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 09:46:45
40275	9d6cc239-9774-4d6b-bc91-2ac80c2137bd	9d6cc239-989f-4b26-927a-fe3a8b65a11f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:46:45
40276	9d6cc239-97bd-41b8-8b11-28dab68274a1	9d6cc239-989f-4b26-927a-fe3a8b65a11f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:46:45
40529	9d6cc42c-299d-4857-b405-18b0fa7be195	9d6cc42c-4396-4bf5-92b1-9f9136da9f71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:52:12
40530	9d6cc42c-3f26-495c-84a9-754a12b75ec8	9d6cc42c-4396-4bf5-92b1-9f9136da9f71	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"42.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:52:12
40531	9d6cc42c-4233-4b7f-87b3-cb8f71d90be9	9d6cc42c-4396-4bf5-92b1-9f9136da9f71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:52:12
40532	9d6cc42c-4281-4a6c-b298-96bcbccbe37f	9d6cc42c-4396-4bf5-92b1-9f9136da9f71	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":224,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:52:12
28730	9d690739-7d86-4944-b0ca-9e91477e6049	9d690739-b08a-4b12-ae19-9173127ac8d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 13:16:23
28731	9d690739-a0ff-4f10-8ca6-efa8579db0be	9d690739-b08a-4b12-ae19-9173127ac8d2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"71.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 13:16:23
28732	9d690739-a7b2-49e0-8ef2-b09b7b63c933	9d690739-b08a-4b12-ae19-9173127ac8d2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"3.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:16:23
28733	9d690739-a800-4829-8ef0-6c5480cd28a9	9d690739-b08a-4b12-ae19-9173127ac8d2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:16:23
21698	9d673db5-2f45-47e1-a2f3-06a2d8701740	9d673db5-741b-4146-9785-0563ac81bab8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 15:57:04
28734	9d690739-ae9f-41af-b1d7-50a19a7f444c	9d690739-b08a-4b12-ae19-9173127ac8d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 13:16:23
28735	9d690739-af24-4b9f-9876-3f14b18b5e6c	9d690739-b08a-4b12-ae19-9173127ac8d2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":505,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:16:23
40277	9d6cc23a-f961-47e8-9ec1-10025b4f65a8	9d6cc23b-442f-4f57-8c70-7ed8ecd5370a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:46:46
40278	9d6cc23b-3c50-44e5-a7e5-12f896726009	9d6cc23b-442f-4f57-8c70-7ed8ecd5370a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"151.95","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:46:46
40279	9d6cc23b-3c9f-4670-81e2-4c03c05fa9d5	9d6cc23b-442f-4f57-8c70-7ed8ecd5370a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:46:46
40280	9d6cc23b-424b-4a4a-8fa0-7ec888244f3d	9d6cc23b-442f-4f57-8c70-7ed8ecd5370a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 09:46:46
40281	9d6cc23b-42cd-40ec-aa73-f313b60e724a	9d6cc23b-442f-4f57-8c70-7ed8ecd5370a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":386,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:46:46
28736	9d69073a-deb4-4acf-b109-7c7b37f02819	9d69073b-3b06-48ac-bfa1-a542a957eb86	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 13:16:24
28737	9d69073b-31b8-41b9-9210-917af6e601b5	9d69073b-3b06-48ac-bfa1-a542a957eb86	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"71.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:16:24
28738	9d69073b-324a-496c-bfd7-9df0877cedcd	9d69073b-3b06-48ac-bfa1-a542a957eb86	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:16:24
28739	9d69073b-3903-4352-be5a-eba4da1f0d03	9d69073b-3b06-48ac-bfa1-a542a957eb86	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 13:16:24
21699	9d673db5-6ed2-46af-8b47-04fa8267f423	9d673db5-741b-4146-9785-0563ac81bab8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"140.20","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 15:57:04
21700	9d673db5-6f38-4dcf-a735-b5fbb82ee9c7	9d673db5-741b-4146-9785-0563ac81bab8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 15:57:04
28740	9d69073b-398e-4f25-af25-180a91eb3cc7	9d69073b-3b06-48ac-bfa1-a542a957eb86	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":981,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:16:24
40282	9d6cc23b-8bb3-4742-b3c9-b17b178ca01e	9d6cc23b-a492-49f3-a989-d2be16391f6e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 09:46:47
40283	9d6cc23b-a07c-4fce-b31a-ac4f1a7d34d3	9d6cc23b-a492-49f3-a989-d2be16391f6e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"41.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:46:47
40284	9d6cc23b-a34b-4a9f-8bb3-48574f18ff30	9d6cc23b-a492-49f3-a989-d2be16391f6e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 09:46:47
40285	9d6cc23b-a3a2-4ced-9970-0251bbfbc0ec	9d6cc23b-a492-49f3-a989-d2be16391f6e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:46:47
28741	9d69073c-0999-493a-a7f0-b9f0cb20dd4a	9d69073c-3d30-4137-b32c-910eda902857	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 13:16:25
28742	9d69073c-33a2-4cb2-90f8-8ad616f74093	9d69073c-3d30-4137-b32c-910eda902857	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"62.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:16:25
28743	9d69073c-3420-4cb7-a81d-aba6541baed8	9d69073c-3d30-4137-b32c-910eda902857	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:16:25
28744	9d69073c-3b4d-4216-9588-3e72361f8f5b	9d69073c-3d30-4137-b32c-910eda902857	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 13:16:25
21701	9d673db5-72ef-4cb6-8332-6a755f06f999	9d673db5-741b-4146-9785-0563ac81bab8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 15:57:04
28745	9d69073c-3bd2-4100-bb8c-0280449722b4	9d69073c-3d30-4137-b32c-910eda902857	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":639,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:16:25
40286	9d6cc23b-e6d9-41d7-9d84-a1ecca91d0d7	9d6cc23b-ea7e-4ef6-b618-b26c79007ace	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":154,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:46:47
40287	9d6cc23c-45a5-4a4d-848d-70b9350fe1cb	9d6cc23c-8da1-4cb8-8c23-9d65e9bdaf7c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 09:46:47
40288	9d6cc23c-893b-47e2-b75e-554961fe564e	9d6cc23c-8da1-4cb8-8c23-9d65e9bdaf7c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"157.47","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 09:46:47
40289	9d6cc23c-8c3c-4fc2-9416-cfccb8891a60	9d6cc23c-8da1-4cb8-8c23-9d65e9bdaf7c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 09:46:47
40290	9d6cc23c-8cad-423f-9557-a40a495e3b1a	9d6cc23c-8da1-4cb8-8c23-9d65e9bdaf7c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:46:47
37276	9d6b4674-2efb-4b2b-9085-9154de66cac9	9d6b4674-328e-4df8-9ea7-e9694175f8e7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1684}	2024-11-05 16:04:50
40368	9d6cc2a5-8498-48c6-b647-56b23d02c397	9d6cc2a5-d27e-4c56-bc07-617ed6f9c2a8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:47:56
40369	9d6cc2a5-cfd3-4921-bd40-a2ceb79e1950	9d6cc2a5-d27e-4c56-bc07-617ed6f9c2a8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:47:56
40370	9d6cc2a5-d128-4d6f-b196-975c88072a7d	9d6cc2a5-d27e-4c56-bc07-617ed6f9c2a8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":440,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:47:56
40371	9d6cc2a7-2a24-4e27-8c6f-4974bc6e54c3	9d6cc2a7-4bb7-4dd5-8842-66680713204f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:47:57
40372	9d6cc2a7-461b-4138-8843-a770a021a998	9d6cc2a7-4bb7-4dd5-8842-66680713204f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:47:57
40373	9d6cc2a7-4666-4fdc-8c6f-80e416bced88	9d6cc2a7-4bb7-4dd5-8842-66680713204f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:47:57
40374	9d6cc2a7-4a6a-4f80-99e6-4692d92dc058	9d6cc2a7-4bb7-4dd5-8842-66680713204f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:47:57
40375	9d6cc2a7-4ab4-4668-baf7-fd02c166c724	9d6cc2a7-4bb7-4dd5-8842-66680713204f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":262,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:47:57
40589	9d6cc5c9-828e-4686-a070-bb7ff688e5d6	9d6cc5c9-9c34-41ba-b5bd-49efe762daf1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:56:43
40590	9d6cc5c9-9aab-4a25-a984-dff23118354a	9d6cc5c9-9c34-41ba-b5bd-49efe762daf1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:56:43
40376	9d6cc2a7-8e3b-40b6-aada-0fb61cdb4a38	9d6cc2a7-d321-4b62-a000-d521db0b9eb6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:47:57
40377	9d6cc2a7-ce2e-478b-8778-29a734d3ec87	9d6cc2a7-d321-4b62-a000-d521db0b9eb6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"151.19","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:47:58
40378	9d6cc2a7-d19d-4573-a3fd-036ab5685d8e	9d6cc2a7-d321-4b62-a000-d521db0b9eb6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:47:58
40379	9d6cc2a7-d228-45f9-8784-baa82474209e	9d6cc2a7-d321-4b62-a000-d521db0b9eb6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:47:58
40591	9d6cc5c9-9b41-437c-9072-119697d0bff8	9d6cc5c9-9c34-41ba-b5bd-49efe762daf1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":255,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:56:43
26224	9d68cf24-d797-4a58-88d7-20d5a081b399	9d68cf24-fc14-4769-b9bd-efdf54492356	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 10:39:34
26225	9d68cf24-fa2c-4a5c-b30b-2c8923f3b0c8	9d68cf24-fc14-4769-b9bd-efdf54492356	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:39:34
26226	9d68cf24-fb01-4f13-8a79-984f6b027c2c	9d68cf24-fc14-4769-b9bd-efdf54492356	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":404,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:39:34
40592	9d6cc5cb-83f4-4901-a6c0-5f50b56bd19c	9d6cc5cb-b27d-4c9d-813f-2ba21bce247e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:56:44
40593	9d6cc5cb-aa3a-45cb-8292-e76d9ee40a7c	9d6cc5cb-b27d-4c9d-813f-2ba21bce247e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"70.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:56:44
40594	9d6cc5cb-aaa5-40ec-8a80-ce8614c16d79	9d6cc5cb-b27d-4c9d-813f-2ba21bce247e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:56:44
40595	9d6cc5cb-b0e0-42ee-9f72-500eb1d6b9e8	9d6cc5cb-b27d-4c9d-813f-2ba21bce247e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:56:44
26227	9d68cf25-8974-4dce-99d0-c53806bb0e7e	9d68cf25-adcb-47cc-a8a2-796d771d67ad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:39:35
26228	9d68cf25-a2d9-42f5-96b6-2cef1b771cab	9d68cf25-adcb-47cc-a8a2-796d771d67ad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"51.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 10:39:35
26229	9d68cf25-a7ea-47ef-ba88-07961fe55172	9d68cf25-adcb-47cc-a8a2-796d771d67ad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:39:35
26230	9d68cf25-a847-454d-af6c-9a8c22e9dc2d	9d68cf25-adcb-47cc-a8a2-796d771d67ad	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:39:35
26231	9d68cf25-ac96-4f5c-88d8-5c30e7cc2c3b	9d68cf25-adcb-47cc-a8a2-796d771d67ad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:39:35
26232	9d68cf25-acef-4235-8989-015f8b75445d	9d68cf25-adcb-47cc-a8a2-796d771d67ad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"240000","loans_pago_interes":"60000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":407,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:39:35
40596	9d6cc5cb-b140-46c5-a3ee-efb511e47291	9d6cc5cb-b27d-4c9d-813f-2ba21bce247e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":425,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:56:44
40597	9d6cc5cc-1412-4061-9f16-feb43f0ecccd	9d6cc5cc-5bb6-403f-8a21-046342153bab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:56:45
40598	9d6cc5cc-55a6-4bb3-a39f-d0f94d852f13	9d6cc5cc-5bb6-403f-8a21-046342153bab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"152.71","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:56:45
40599	9d6cc5cc-5a2e-42c2-8180-6b6971ed6516	9d6cc5cc-5bb6-403f-8a21-046342153bab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:56:45
40600	9d6cc5cc-5a89-4065-8446-c671df3a63b8	9d6cc5cc-5bb6-403f-8a21-046342153bab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":410,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:56:45
40742	9d6cc6e5-1dba-4fb8-83eb-6fe648dfb2d8	9d6cc6e5-5f8e-471e-987b-4a0310e391ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 09:59:49
40743	9d6cc6e5-5e0e-442c-a720-f488ea8652f4	9d6cc6e5-5f8e-471e-987b-4a0310e391ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 09:59:49
40744	9d6cc6e5-5ea0-4f00-89a9-18fc9a3ca81e	9d6cc6e5-5f8e-471e-987b-4a0310e391ba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:59:49
29511	9d692821-2349-445f-8c23-71244fc3f03b	9d692821-27d3-4793-b585-f0dde32e6c27	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1390}	2024-11-04 14:48:23
40745	9d6cc6e6-7663-442e-a659-31d3320d1244	9d6cc6e6-a410-4887-890d-ae43d70a0bdd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 09:59:50
40746	9d6cc6e6-9be0-47f1-b02a-46d912d8802c	9d6cc6e6-a410-4887-890d-ae43d70a0bdd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"61.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:59:50
40747	9d6cc6e6-9c98-4222-abfa-abf49c130118	9d6cc6e6-a410-4887-890d-ae43d70a0bdd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:59:50
40748	9d6cc6e6-a224-438f-9d86-eca93fe6bd80	9d6cc6e6-a410-4887-890d-ae43d70a0bdd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-06 09:59:50
40749	9d6cc6e6-a283-4588-9a74-ddde3f5821e0	9d6cc6e6-a410-4887-890d-ae43d70a0bdd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":415,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:59:50
40750	9d6cc6e7-09e6-4f22-86d4-2328b402475a	9d6cc6e7-531e-47da-b9e1-ea683f31c573	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-06 09:59:50
40751	9d6cc6e7-4d30-4480-a2b9-f90defbfce5b	9d6cc6e7-531e-47da-b9e1-ea683f31c573	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"155.90","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:59:50
40752	9d6cc6e7-5198-4c32-b2c7-5f9a62cc0ce5	9d6cc6e7-531e-47da-b9e1-ea683f31c573	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-06 09:59:50
40753	9d6cc6e7-51f7-4fe3-901d-d03d18afde5b	9d6cc6e7-531e-47da-b9e1-ea683f31c573	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":424,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:59:50
28850	9d690a31-b4f7-4617-b4cb-69d8c0e17133	9d690a31-ebfa-45a5-82ab-210512884f0c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 13:24:41
28851	9d690a31-e95f-474e-b455-a1d863aa66e0	9d690a31-ebfa-45a5-82ab-210512884f0c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 13:24:41
28852	9d690a31-ea92-4242-bcfb-a4d6f220a13a	9d690a31-ebfa-45a5-82ab-210512884f0c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":531,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:24:41
28853	9d690a32-edbd-41ee-8189-739bda0b493e	9d690a33-2bef-44a0-92e4-09050207fd60	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 13:24:42
28854	9d690a33-1ad4-4705-8642-79a035f49409	9d690a33-2bef-44a0-92e4-09050207fd60	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"88.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 13:24:42
28855	9d690a33-21cb-4cf9-95be-016e0faef2b5	9d690a33-2bef-44a0-92e4-09050207fd60	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"4.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:24:42
28856	9d690a33-2229-472a-801f-f691d682445f	9d690a33-2bef-44a0-92e4-09050207fd60	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:24:42
28857	9d690a33-29d2-4c70-b4a5-8c11438ad18d	9d690a33-2bef-44a0-92e4-09050207fd60	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 13:24:42
28858	9d690a33-2a6b-4f0a-9280-4d056f06979c	9d690a33-2bef-44a0-92e4-09050207fd60	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":null},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":708,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:24:42
28859	9d690a34-392d-4849-a304-8242d77995b0	9d690a34-a9f1-4963-a692-e5c735235626	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 13:24:43
28860	9d690a34-a188-4ceb-8794-eea68ea72a1a	9d690a34-a9f1-4963-a692-e5c735235626	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"192.53","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:24:43
28861	9d690a34-a218-481e-954e-d3b999c26216	9d690a34-a9f1-4963-a692-e5c735235626	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:24:43
28862	9d690a34-a823-432f-a2c9-9aab5591b5e0	9d690a34-a9f1-4963-a692-e5c735235626	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 13:24:43
28863	9d690a34-a8a5-47bd-a37f-fd602a22073e	9d690a34-a9f1-4963-a692-e5c735235626	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":954,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:24:43
40571	9d6cc51e-09af-44bf-b875-9ba05c4097d4	9d6cc51e-0c6a-4b65-9250-9f6a826d4c5e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1828}	2024-11-06 09:54:51
28864	9d690a35-9b7d-4ac0-8f7f-675a045882c6	9d690a35-d893-4c7e-8191-89ef0b6d2985	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 13:24:44
28865	9d690a35-ccc3-4772-bc15-d525a9f60f74	9d690a35-d893-4c7e-8191-89ef0b6d2985	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"74.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:24:44
28866	9d690a35-cd7a-4b7d-a03b-05221d8e573e	9d690a35-d893-4c7e-8191-89ef0b6d2985	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:24:44
28867	9d690a35-d61c-469a-a1b9-01a9fed81195	9d690a35-d893-4c7e-8191-89ef0b6d2985	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 13:24:44
28868	9d690a35-d6c4-4b0e-959e-a19d26b9ede5	9d690a35-d893-4c7e-8191-89ef0b6d2985	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":657,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:24:44
40878	9d6cc851-3cef-4edd-bf1e-50f0893cba30	9d6cc851-83a6-428e-88be-aa114e9fa318	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:03:47
40879	9d6cc851-81cb-4f34-9807-021b21ae6f97	9d6cc851-83a6-428e-88be-aa114e9fa318	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:03:48
40880	9d6cc851-827e-465c-a040-76e4143eabd0	9d6cc851-83a6-428e-88be-aa114e9fa318	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":405,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:03:48
19973	9d66ec69-66ed-4c52-9f9c-51cdad465a27	9d66ec69-69b5-464f-baab-fbef8d5834b0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":985}	2024-11-03 12:09:45
22170	9d674279-1665-4840-bade-696b2a804f9e	9d674279-5ded-43fe-b99f-c14eda97ef30	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-03 16:10:24
22171	9d674279-5ab8-4519-925c-2bac94a01f39	9d674279-5ded-43fe-b99f-c14eda97ef30	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-03 16:10:24
22172	9d674279-5c22-4e1a-ab00-802876b24381	9d674279-5ded-43fe-b99f-c14eda97ef30	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":492,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:10:24
20748	9d66fbe3-80d0-4163-a05e-828f8424b3d7	9d66fbe3-c6cf-4f70-824e-321af44b9790	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 12:53:02
20749	9d66fbe3-c4f9-4591-9f6f-e156f0f7fa1c	9d66fbe3-c6cf-4f70-824e-321af44b9790	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 12:53:02
20750	9d66fbe3-c5e5-40bb-aa84-c9506688d5fc	9d66fbe3-c6cf-4f70-824e-321af44b9790	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":341,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:53:02
40980	9d6cc91d-7e61-4d82-9f38-b9b923f6a52e	9d6cc91d-98c4-4eec-acf7-cb7064985851	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:06:01
40981	9d6cc91d-9729-465b-966c-4664a5193c4d	9d6cc91d-98c4-4eec-acf7-cb7064985851	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:06:01
40881	9d6cc853-62f6-4963-afdb-026dd44e69d7	9d6cc853-b460-4dcb-84bd-b73f2fd8e0b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:03:49
40882	9d6cc853-ab3c-4a49-a990-af3d11eb0031	9d6cc853-b460-4dcb-84bd-b73f2fd8e0b6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"156.28","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:03:49
40982	9d6cc91d-97c7-4075-8af7-34be3ea78991	9d6cc91d-98c4-4eec-acf7-cb7064985851	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":260,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:06:01
40883	9d6cc853-abaf-4827-8da2-d3be7be48b07	9d6cc853-b460-4dcb-84bd-b73f2fd8e0b6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:03:49
40884	9d6cc853-b262-4212-98a9-722f7f925bf7	9d6cc853-b460-4dcb-84bd-b73f2fd8e0b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:03:49
20752	9d66fbe4-2d0e-485f-bf88-235d0cfb8cda	9d66fbe4-3574-40d4-9f07-ee0fb839b09d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"42.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:53:02
20753	9d66fbe4-306c-42bc-b5a4-3d4b7fcf6a40	9d66fbe4-3574-40d4-9f07-ee0fb839b09d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:53:02
20754	9d66fbe4-309d-4d96-b838-55801e602b10	9d66fbe4-3574-40d4-9f07-ee0fb839b09d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:53:02
20755	9d66fbe4-3443-4921-92ad-5302755dc12a	9d66fbe4-3574-40d4-9f07-ee0fb839b09d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-03 12:53:02
20756	9d66fbe4-3494-4699-9ea2-f486601bf632	9d66fbe4-3574-40d4-9f07-ee0fb839b09d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"400000","loans_pago_interes":"200000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:40:42.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-10-30T15:59:22.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"}]}},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:53:02
22173	9d674279-f9a6-4f5e-b3fb-1186ce141a06	9d67427a-54c7-47fa-b461-247abe374a0a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-03 16:10:24
22174	9d67427a-4536-4a3f-85c6-ad01246b6696	9d67427a-54c7-47fa-b461-247abe374a0a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 68\\n                        ","time":"175.43","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"7d9994d55cb8dde82ff4185920c79043","hostname":"EderCortes"}	2024-11-03 16:10:25
22175	9d67427a-4b58-45f7-bc61-88cfc6f33d59	9d67427a-54c7-47fa-b461-247abe374a0a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '68' order by \\"item_loans\\".\\"id\\" asc","time":"3.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 16:10:25
22176	9d67427a-4bac-470d-bfc0-3cb8cff185e9	9d67427a-54c7-47fa-b461-247abe374a0a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 16:10:25
22177	9d67427a-52d5-445a-a0f1-524295d47836	9d67427a-54c7-47fa-b461-247abe374a0a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-03 16:10:25
40983	9d6cc91f-1828-41a7-a362-9980022f362b	9d6cc91f-3e97-400d-b1f7-e19efb901ff4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:06:02
40984	9d6cc91f-357a-4fa6-b7dd-4a1ee0ed4358	9d6cc91f-3e97-400d-b1f7-e19efb901ff4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"48.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:06:02
40985	9d6cc91f-35e7-45f9-b85b-399701e1e336	9d6cc91f-3e97-400d-b1f7-e19efb901ff4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:06:02
40986	9d6cc91f-3cc6-4637-b37c-0d6ef37b76b2	9d6cc91f-3e97-400d-b1f7-e19efb901ff4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:06:02
20775	9d66fbf3-f594-4356-b26b-0bb440725019	9d66fbf3-fe77-4e73-b624-e570c874e69c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 61\\n                        ","time":"41.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"fe31b151573e7590f2fbbdf409de7701","hostname":"EderCortes"}	2024-11-03 12:53:12
20776	9d66fbf3-f9a8-49de-9a06-9b469f77377f	9d66fbf3-fe77-4e73-b624-e570c874e69c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '61' order by \\"item_loans\\".\\"id\\" asc","time":"2.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 12:53:12
20777	9d66fbf3-f9dd-41d8-a65c-f6fcc3d14275	9d66fbf3-fe77-4e73-b624-e570c874e69c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-03 12:53:12
20778	9d66fbf3-fd47-4127-981e-0a391cec5540	9d66fbf3-fe77-4e73-b624-e570c874e69c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-03 12:53:12
20779	9d66fbf3-fd89-4cab-85b5-23051e9db7b6	9d66fbf3-fe77-4e73-b624-e570c874e69c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/61","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":61,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":50,"loans_cuotas":5,"loans_valor_prestado":500000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"30-10-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-10-30 00:00:00","loans_pago_prestado":"500000","loans_pago_interes":"200000"},"items":[{"id":182,"loans_codigo":61,"itemloans_cuota":"1","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:12:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":183,"loans_codigo":61,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T16:58:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":184,"loans_codigo":61,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:06:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":185,"loans_codigo":61,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:40:42.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"},{"id":186,"loans_codigo":61,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-10-30T15:59:22.000000Z","updated_at":"2024-11-03T17:53:12.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"100000"}]}},"duration":219,"memory":22,"hostname":"EderCortes"}	2024-11-03 12:53:12
22178	9d67427a-5351-4029-82e8-388b408be1ed	9d67427a-54c7-47fa-b461-247abe374a0a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/68","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":68,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":10000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"1000000","loans_pago_interes":"250000"},"items":[{"id":227,"loans_codigo":68,"itemloans_cuota":"1","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":228,"loans_codigo":68,"itemloans_cuota":"2","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":229,"loans_codigo":68,"itemloans_cuota":"3","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":230,"loans_codigo":68,"itemloans_cuota":"4","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":231,"loans_codigo":68,"itemloans_cuota":"5","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":232,"loans_codigo":68,"itemloans_cuota":"6","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":233,"loans_codigo":68,"itemloans_cuota":"7","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":234,"loans_codigo":68,"itemloans_cuota":"8","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":235,"loans_codigo":68,"itemloans_cuota":"9","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":236,"loans_codigo":68,"itemloans_cuota":"10","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":557,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:10:25
40885	9d6cc853-b2f5-409e-9f73-c238a178ec03	9d6cc853-b460-4dcb-84bd-b73f2fd8e0b6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":466,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:03:49
22179	9d67427b-19fe-4d76-bd74-d6b0d4672f6f	9d67427b-7fc4-4674-805c-5c3e0f38e7b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-03 16:10:25
22180	9d67427b-758b-4ef9-be0d-a375f3f5103a	9d67427b-7fc4-4674-805c-5c3e0f38e7b6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"176.33","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:10:25
22181	9d67427b-7635-4de1-a575-150d03b0bb58	9d67427b-7fc4-4674-805c-5c3e0f38e7b6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:10:25
22182	9d67427b-7daf-4d62-8b21-deceb357713e	9d67427b-7fc4-4674-805c-5c3e0f38e7b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-03 16:10:25
22183	9d67427b-7e41-4236-9026-54ce55aa351e	9d67427b-7fc4-4674-805c-5c3e0f38e7b6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":739,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:10:25
40886	9d6cc854-0e85-4d77-9bba-1dc910f1f87f	9d6cc854-324a-419a-9588-a081cf9201be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:03:49
40887	9d6cc854-2cee-4b0a-8a10-7fadf0f967af	9d6cc854-324a-419a-9588-a081cf9201be	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"53.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:03:49
28967	9d690dc4-9191-4e5d-9b42-e2c63594cbe6	9d690dc4-b287-4083-808c-aca5ec01e7c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 13:34:41
28968	9d690dc4-b0f6-482b-bb7c-8a6696158dae	9d690dc4-b287-4083-808c-aca5ec01e7c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 13:34:41
28969	9d690dc4-b18d-44e5-8af7-e5b2d1c92c9c	9d690dc4-b287-4083-808c-aca5ec01e7c3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":313,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:34:41
40888	9d6cc854-30d4-4fcf-9aaf-342596823bae	9d6cc854-324a-419a-9588-a081cf9201be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:03:49
40889	9d6cc854-3132-41f5-84a1-2367a0dcc1a9	9d6cc854-324a-419a-9588-a081cf9201be	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":301,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:03:49
40987	9d6cc91f-3d3f-42f3-98b1-7dff7ff58777	9d6cc91f-3e97-400d-b1f7-e19efb901ff4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":327,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:06:02
22184	9d67427c-1bc9-4f3c-b614-fe95d918157d	9d67427c-5915-42f3-b686-e403fdeebd3b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-03 16:10:26
22185	9d67427c-4fb8-4969-9fb4-277b3d71f3a2	9d67427c-5915-42f3-b686-e403fdeebd3b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"88.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:10:26
22186	9d67427c-5047-476d-a937-e15d0999b2cb	9d67427c-5915-42f3-b686-e403fdeebd3b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:10:26
22187	9d67427c-56e0-4314-b004-2a2d21df411c	9d67427c-5915-42f3-b686-e403fdeebd3b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-03 16:10:26
22188	9d67427c-5764-4030-9877-d0fc8bce60ae	9d67427c-5915-42f3-b686-e403fdeebd3b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":527,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:10:26
28970	9d690dc5-0f03-4e79-a471-46f3e82f97fd	9d690dc5-2fb2-4ee5-9cb5-956512335267	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 13:34:41
28971	9d690dc5-29ad-4916-946d-65d0e0ea96d0	9d690dc5-2fb2-4ee5-9cb5-956512335267	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:34:41
28972	9d690dc5-2a0c-4fbe-9441-37436d3fa354	9d690dc5-2fb2-4ee5-9cb5-956512335267	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 13:34:41
28973	9d690dc5-2e45-4c20-9605-bbb4c47dd6ae	9d690dc5-2fb2-4ee5-9cb5-956512335267	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 13:34:41
28974	9d690dc5-2ea8-466d-aa6b-b452b7a89946	9d690dc5-2fb2-4ee5-9cb5-956512335267	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:34:41
40988	9d6cc91f-96a7-46d1-b3fc-6cb8a52d41f7	9d6cc91f-dd7b-4933-97cb-e3d008759a0b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:06:03
40989	9d6cc91f-d7a9-4417-b2be-160f9470151d	9d6cc91f-dd7b-4933-97cb-e3d008759a0b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"148.14","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:06:03
40990	9d6cc91f-dbd9-4013-a9a1-98daf908cf34	9d6cc91f-dd7b-4933-97cb-e3d008759a0b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:06:03
40991	9d6cc91f-dc3d-460f-a200-1fdb70df98ac	9d6cc91f-dd7b-4933-97cb-e3d008759a0b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":384,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:06:03
28975	9d690dc5-7784-4563-bad1-c7dc0fca1c0c	9d690dc5-982c-4604-994a-b368272b2c1d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 13:34:41
28976	9d690dc5-9259-4018-91b4-363c920d4967	9d690dc5-982c-4604-994a-b368272b2c1d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:34:41
28977	9d690dc5-92b8-4df5-a41b-0a5e20b67fe2	9d690dc5-982c-4604-994a-b368272b2c1d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 13:34:41
28978	9d690dc5-96f5-4347-b16b-d6958ec7826c	9d690dc5-982c-4604-994a-b368272b2c1d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 13:34:41
28979	9d690dc5-974b-4df0-ad95-434ed8a75cc1	9d690dc5-982c-4604-994a-b368272b2c1d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:34:41
28980	9d690dc5-e9ed-4950-95cc-bff11afd7225	9d690dc6-3580-4f0f-bc50-53a4211f0fdd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 13:34:42
28981	9d690dc6-2d56-484e-83f0-e827e0ec8b97	9d690dc6-3580-4f0f-bc50-53a4211f0fdd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '89' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"149.82","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 13:34:42
28982	9d690dc6-2dd8-443a-8f03-a1f607ccf927	9d690dc6-3580-4f0f-bc50-53a4211f0fdd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 13:34:42
28983	9d690dc6-2fae-4c4f-8cfe-295207954fce	9d690dc6-3580-4f0f-bc50-53a4211f0fdd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"1.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:34:42
28984	9d690dc6-2fee-4cde-93cb-68fabdebf0cb	9d690dc6-3580-4f0f-bc50-53a4211f0fdd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:34:42
28985	9d690dc6-343a-4a54-99d1-e7e359174f13	9d690dc6-3580-4f0f-bc50-53a4211f0fdd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 13:34:42
28986	9d690dc6-3493-4179-a99d-2e4a178fe6ec	9d690dc6-3580-4f0f-bc50-53a4211f0fdd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"146000","loans_pago_prestado":"584000","loans_intereses_recaudar":"275000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":384,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:34:42
40992	9d6cc930-38ea-4eb9-9f9f-f284dce1637b	9d6cc930-3d9c-408c-982f-30afac3ec2c1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":203,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:06:14
28987	9d690dc6-b4c2-4623-9e1f-2516d0d8760f	9d690dc6-ec71-4d1d-82fb-bec6056096f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 13:34:42
28988	9d690dc6-e00e-4023-ba31-b3dde088eefb	9d690dc6-ec71-4d1d-82fb-bec6056096f9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"70.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:34:42
28989	9d690dc6-e099-40b8-8512-4158db339c9b	9d690dc6-ec71-4d1d-82fb-bec6056096f9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:34:42
28990	9d690dc6-ea44-4388-a3ef-466dcbe45cf8	9d690dc6-ec71-4d1d-82fb-bec6056096f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 13:34:42
28991	9d690dc6-ead2-4858-ad2b-94aba19ddb93	9d690dc6-ec71-4d1d-82fb-bec6056096f9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":446,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:34:42
40993	9d6cc930-c402-46f2-b9dd-ccf050dd481e	9d6cc930-eb91-472f-b852-61f3ff3c2a62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:06:14
28992	9d690dc8-000f-4cb4-a272-fcf4cd1d5980	9d690dc8-4a33-4c6c-8d24-886d563e53be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 13:34:43
28993	9d690dc8-457f-4776-b21f-de1e776544f7	9d690dc8-4a33-4c6c-8d24-886d563e53be	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"144.39","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:34:43
28994	9d690dc8-45c8-4d03-a09a-aa8c2bb8621c	9d690dc8-4a33-4c6c-8d24-886d563e53be	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:34:43
28995	9d690dc8-48f4-4d97-b42b-dd2378e39f10	9d690dc8-4a33-4c6c-8d24-886d563e53be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 13:34:43
28996	9d690dc8-493f-4a21-ad54-c828c9275496	9d690dc8-4a33-4c6c-8d24-886d563e53be	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":676,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:34:43
40994	9d6cc930-e4bf-4d9d-865e-d9e0efacd291	9d6cc930-eb91-472f-b852-61f3ff3c2a62	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"50.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:06:14
40995	9d6cc930-e535-4c60-9407-bf19609c8b98	9d6cc930-eb91-472f-b852-61f3ff3c2a62	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:06:14
40996	9d6cc930-ea02-47fe-8b3a-a415bc5bdb09	9d6cc930-eb91-472f-b852-61f3ff3c2a62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:06:14
40997	9d6cc930-ea62-4810-8dd5-9fa1dafd8ed0	9d6cc930-eb91-472f-b852-61f3ff3c2a62	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":314,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:06:14
40998	9d6cc931-3bcf-4f81-a45b-492e3047ce17	9d6cc931-5c84-48c2-8dd0-c8716030bed9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:06:14
40999	9d6cc931-56a1-428c-b097-36c812816412	9d6cc931-5c84-48c2-8dd0-c8716030bed9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:06:14
41000	9d6cc931-5705-491c-9565-c2baa1e4054c	9d6cc931-5c84-48c2-8dd0-c8716030bed9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:06:14
41001	9d6cc931-5b0d-4956-828f-13e8c3446962	9d6cc931-5c84-48c2-8dd0-c8716030bed9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:06:14
41002	9d6cc931-5b66-4720-a2f2-983e59acbbe8	9d6cc931-5c84-48c2-8dd0-c8716030bed9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":261,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:06:14
41003	9d6cc931-ab77-4950-b650-c44657650d0b	9d6cc931-d1b5-4c53-ab3d-4d6bcd51252f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:06:15
41004	9d6cc931-ca01-4640-ad78-1856e6759e50	9d6cc931-d1b5-4c53-ab3d-4d6bcd51252f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"57.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 10:06:15
41005	9d6cc931-d009-4f2b-a35f-da709337c5e6	9d6cc931-d1b5-4c53-ab3d-4d6bcd51252f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:06:15
41006	9d6cc931-d099-4cde-92c9-f4a888131f35	9d6cc931-d1b5-4c53-ab3d-4d6bcd51252f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":282,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:06:15
41007	9d6cc934-b51a-40e6-a993-289d4a7ba22a	9d6cc934-ba06-4278-8f80-8de4d5abb422	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":198,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:06:17
41008	9d6cc935-25ff-4275-9edf-0b2cc1ddba77	9d6cc935-4814-4926-927f-fc917d546d61	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:06:17
41009	9d6cc935-4262-4e44-b997-f44966ed843a	9d6cc935-4814-4926-927f-fc917d546d61	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:06:17
41010	9d6cc935-42cd-4773-887b-c2a4f1561d55	9d6cc935-4814-4926-927f-fc917d546d61	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:06:17
41011	9d6cc935-46c6-4b0e-a41f-729e1535bf22	9d6cc935-4814-4926-927f-fc917d546d61	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:06:17
41012	9d6cc935-4713-4913-a233-df1bb6a4594d	9d6cc935-4814-4926-927f-fc917d546d61	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":284,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:06:17
41013	9d6cc935-9baa-4dc6-bef3-932c026fe3aa	9d6cc935-e51a-4b6d-93d3-998a882b0dcc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:06:17
41014	9d6cc935-df86-4c0b-b1ed-f1f38415a135	9d6cc935-e51a-4b6d-93d3-998a882b0dcc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"150.56","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:06:17
41015	9d6cc935-dfe3-4a42-ae96-77d24032d0f3	9d6cc935-e51a-4b6d-93d3-998a882b0dcc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:06:17
41016	9d6cc935-e39e-4c3b-b4d8-b153069b9d73	9d6cc935-e51a-4b6d-93d3-998a882b0dcc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 10:06:17
41017	9d6cc935-e408-4b07-ae8a-58eda2b20842	9d6cc935-e51a-4b6d-93d3-998a882b0dcc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":358,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:06:17
41018	9d6cc936-4501-4167-9867-8cc5d6d6981f	9d6cc936-65c1-4d92-9c14-62a2310d514e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 10:06:18
41019	9d6cc936-6027-4986-a0fa-a342af484b2f	9d6cc936-65c1-4d92-9c14-62a2310d514e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"51.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":89,"hash":"f9f3598e6ad2468770f89917d2ab916c","hostname":"EderCortes"}	2024-11-06 10:06:18
26452	9d68d442-6351-4a28-9983-7c6341802d53	9d68d442-8a91-40a0-8e3b-fb66e15226e5	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 10:53:52
26453	9d68d442-88c3-469f-a504-e7af5a0050ae	9d68d442-8a91-40a0-8e3b-fb66e15226e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:53:52
26454	9d68d442-8982-4476-91af-2224948ac542	9d68d442-8a91-40a0-8e3b-fb66e15226e5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":411,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:53:52
41020	9d6cc936-642b-46a2-a3ba-341168eb085d	9d6cc936-65c1-4d92-9c14-62a2310d514e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 10:06:18
41021	9d6cc936-64a4-4ff4-88d9-7a19d26a54b5	9d6cc936-65c1-4d92-9c14-62a2310d514e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getLoansCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":283,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:06:18
26455	9d68d443-144a-4951-8176-fb5cdb1bbe01	9d68d443-32f3-4b99-bd6f-3097479e0658	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:53:53
26456	9d68d443-2972-41cc-b684-cd4e74515994	9d68d443-32f3-4b99-bd6f-3097479e0658	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"42.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 10:53:53
26457	9d68d443-2d64-4150-b711-200778030443	9d68d443-32f3-4b99-bd6f-3097479e0658	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:53:53
26458	9d68d443-2d99-470d-b8e8-e2f5eee8fa97	9d68d443-32f3-4b99-bd6f-3097479e0658	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:53:53
26459	9d68d443-31a9-49ff-b498-7c707a65920d	9d68d443-32f3-4b99-bd6f-3097479e0658	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:53:53
26460	9d68d443-31fd-4e6a-b51b-069e40138494	9d68d443-32f3-4b99-bd6f-3097479e0658	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":381,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:53:53
41022	9d6cc93b-6046-4b4f-b4f2-d9e7706c73ed	9d6cc93b-64bc-4437-9f97-48647f2fd3ee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":223,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:06:21
41023	9d6cc93b-fac5-424a-9fdd-f6997c6305bb	9d6cc93c-2141-4388-8f45-312933fab080	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 10:06:21
41024	9d6cc93c-1a17-4d5e-a853-f70485e73aa1	9d6cc93c-2141-4388-8f45-312933fab080	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"50.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:06:21
41025	9d6cc93c-1a72-4dd4-801d-e02b536f095e	9d6cc93c-2141-4388-8f45-312933fab080	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:06:21
41026	9d6cc93c-1fb3-4421-8f3a-dbdabb3e0c6d	9d6cc93c-2141-4388-8f45-312933fab080	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 10:06:21
41027	9d6cc93c-2014-47f7-bb72-4aefe11076e9	9d6cc93c-2141-4388-8f45-312933fab080	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":295,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:06:21
41028	9d6cc93c-77d9-4c86-87c9-e39802944538	9d6cc93c-9e2c-476b-a21b-b6d8530244f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 10:06:22
22276	9d67485a-8b70-47f6-9966-1fcd0b6f7a6e	9d67485a-bcd0-4d4d-8cb4-adf95ec9f096	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 16:26:50
22277	9d67485a-b9da-49d7-bc55-3031c4305f33	9d67485a-bcd0-4d4d-8cb4-adf95ec9f096	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 16:26:50
22278	9d67485a-bb4e-42ba-aec0-0990ff70a416	9d67485a-bcd0-4d4d-8cb4-adf95ec9f096	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":481,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:26:50
41029	9d6cc93c-96bd-4365-9c61-4f7c08a944c9	9d6cc93c-9e2c-476b-a21b-b6d8530244f6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"51.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:06:22
41030	9d6cc93c-9726-4b3c-9317-fed2baeba4f7	9d6cc93c-9e2c-476b-a21b-b6d8530244f6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:06:22
41031	9d6cc93c-9c77-495f-8eb1-b646517bfe9e	9d6cc93c-9e2c-476b-a21b-b6d8530244f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 10:06:22
41032	9d6cc93c-9cdf-4ae7-adbf-eb7e6475e9cc	9d6cc93c-9e2c-476b-a21b-b6d8530244f6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":287,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:06:22
22279	9d67485b-617b-4c90-8315-de3fff9e18ab	9d67485b-9991-484b-b5fe-b8e7a4403378	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 16:26:51
22280	9d67485b-89bd-4720-bb59-647af3db916b	9d67485b-9991-484b-b5fe-b8e7a4403378	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 68\\n                        ","time":"77.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"7d9994d55cb8dde82ff4185920c79043","hostname":"EderCortes"}	2024-11-03 16:26:51
22281	9d67485b-90d0-47a4-924c-87a576677ff9	9d67485b-9991-484b-b5fe-b8e7a4403378	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '68' order by \\"item_loans\\".\\"id\\" asc","time":"4.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 16:26:51
22282	9d67485b-9134-4dd3-b4ba-bb496cd06627	9d67485b-9991-484b-b5fe-b8e7a4403378	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 16:26:51
22283	9d67485b-97b1-41ed-bcfd-ce09d65ed150	9d67485b-9991-484b-b5fe-b8e7a4403378	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 16:26:51
22284	9d67485b-9834-447b-94cc-825422c30b14	9d67485b-9991-484b-b5fe-b8e7a4403378	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/68","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":68,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":10000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"1000000","loans_pago_interes":"250000"},"items":[{"id":227,"loans_codigo":68,"itemloans_cuota":"1","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":228,"loans_codigo":68,"itemloans_cuota":"2","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":229,"loans_codigo":68,"itemloans_cuota":"3","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":230,"loans_codigo":68,"itemloans_cuota":"4","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":231,"loans_codigo":68,"itemloans_cuota":"5","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":232,"loans_codigo":68,"itemloans_cuota":"6","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":233,"loans_codigo":68,"itemloans_cuota":"7","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":234,"loans_codigo":68,"itemloans_cuota":"8","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":235,"loans_codigo":68,"itemloans_cuota":"9","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":236,"loans_codigo":68,"itemloans_cuota":"10","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":483,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:26:51
41033	9d6cc93c-e411-48da-b2b3-586bdaa49a16	9d6cc93d-2b09-4480-bfaf-43805e601e06	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 10:06:22
41034	9d6cc93d-2641-43bf-ae91-135db5c02772	9d6cc93d-2b09-4480-bfaf-43805e601e06	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"151.29","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":89,"hash":"f9f3598e6ad2468770f89917d2ab916c","hostname":"EderCortes"}	2024-11-06 10:06:22
41035	9d6cc93d-29b3-4039-b644-4d76c91f4137	9d6cc93d-2b09-4480-bfaf-43805e601e06	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 10:06:22
41036	9d6cc93d-2a1b-4131-b23e-7c2f2001a624	9d6cc93d-2b09-4480-bfaf-43805e601e06	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getLoansCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:06:22
22285	9d67485c-acd2-4396-bc1d-26001a8e91f5	9d67485d-1106-4ccd-a4ec-db66e0dfd468	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 16:26:52
22286	9d67485d-05ff-429f-9081-5c81b68c43ad	9d67485d-1106-4ccd-a4ec-db66e0dfd468	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"156.06","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:26:52
22287	9d67485d-069c-4b2e-9d03-8d9263443897	9d67485d-1106-4ccd-a4ec-db66e0dfd468	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:26:52
22288	9d67485d-0e7a-4f56-a964-163e25af35cc	9d67485d-1106-4ccd-a4ec-db66e0dfd468	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 16:26:52
22289	9d67485d-0f0b-417a-b64d-73bfced9e116	9d67485d-1106-4ccd-a4ec-db66e0dfd468	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":930,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:26:52
41037	9d6cc947-440b-4919-8b21-9daa4effa304	9d6cc947-48bb-461b-b40a-ac593f68ffeb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":189,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:06:29
22290	9d67485d-bbd4-4d34-9626-b4851f0b415a	9d67485e-1db7-47b1-911f-d2a962848d0f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 16:26:52
22291	9d67485e-1222-4eae-aad6-844f505433b0	9d67485e-1db7-47b1-911f-d2a962848d0f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"182.53","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:26:53
22292	9d67485e-12b9-42dc-b918-478ce3310cea	9d67485e-1db7-47b1-911f-d2a962848d0f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:26:53
22293	9d67485e-1b58-4942-956c-99b4a63e06ac	9d67485e-1db7-47b1-911f-d2a962848d0f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 16:26:53
22294	9d67485e-1bf9-417b-a4f4-ab913d896371	9d67485e-1db7-47b1-911f-d2a962848d0f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":658,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:26:53
41038	9d6cc947-ae55-4313-b75d-71aec87dbaa3	9d6cc947-d73c-4bd9-87ef-8e19607df7c6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 10:06:29
29164	9d6912fa-4f7b-4135-939d-882e5fabd0f8	9d6912fa-b8b6-4fca-9c2d-0e67d0e194f7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 13:49:15
29165	9d6912fa-b5aa-4151-ad80-d72ed87cf191	9d6912fa-b8b6-4fca-9c2d-0e67d0e194f7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 13:49:15
29166	9d6912fa-b6fa-4a12-b3c7-26ed936e93ec	9d6912fa-b8b6-4fca-9c2d-0e67d0e194f7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":554,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:49:15
41039	9d6cc947-d04c-4335-a620-80a3e1248887	9d6cc947-d73c-4bd9-87ef-8e19607df7c6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"53.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:06:29
41040	9d6cc947-d0bb-49bd-b20c-40a2053a46b4	9d6cc947-d73c-4bd9-87ef-8e19607df7c6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:06:29
41041	9d6cc947-d5af-4762-8cf7-00163d817d38	9d6cc947-d73c-4bd9-87ef-8e19607df7c6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 10:06:29
41042	9d6cc947-d60d-4fb9-a108-39a756d0a542	9d6cc947-d73c-4bd9-87ef-8e19607df7c6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":290,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:06:29
22295	9d674878-9ad2-455d-b4e1-7ff16f728122	9d674878-9df9-42d5-8adb-2db248644d06	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":149,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:27:10
29167	9d6912fc-8e1a-4913-be3d-1ba160d460e9	9d6912fd-0c0c-47a9-b5b2-ddd14eb2afdf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 13:49:16
29168	9d6912fd-02ba-426d-9d3e-5660e29459cb	9d6912fd-0c0c-47a9-b5b2-ddd14eb2afdf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"241.54","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:49:16
29169	9d6912fd-0341-4cb2-8b3d-bf991c459313	9d6912fd-0c0c-47a9-b5b2-ddd14eb2afdf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:49:16
29170	9d6912fd-0a2e-42a7-8800-9a99adaa7879	9d6912fd-0c0c-47a9-b5b2-ddd14eb2afdf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 13:49:17
29171	9d6912fd-0aaf-4ff2-891c-196380e07166	9d6912fd-0c0c-47a9-b5b2-ddd14eb2afdf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1319,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:49:17
41043	9d6cc948-25df-44db-b20f-80b575b10fdd	9d6cc948-4f54-40ec-97b5-672b1c55b2b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 10:06:29
41044	9d6cc948-46c1-406f-afea-ec4ae98b166f	9d6cc948-4f54-40ec-97b5-672b1c55b2b0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"55.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:06:29
41045	9d6cc948-473f-434c-8c18-8ca13090f944	9d6cc948-4f54-40ec-97b5-672b1c55b2b0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:06:29
41046	9d6cc948-4d88-4ba9-bc22-c08977cdd8d5	9d6cc948-4f54-40ec-97b5-672b1c55b2b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-06 10:06:29
41047	9d6cc948-4dfe-4f07-a9aa-b92ced38ae64	9d6cc948-4f54-40ec-97b5-672b1c55b2b0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":289,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:06:29
22296	9d674878-f8d4-4602-bb19-83a3aaa2d90d	9d674879-1469-4f19-8eb2-5d91c1a05ea1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 16:27:10
22297	9d674879-0f76-41b4-8097-af851792dc06	9d674879-1469-4f19-8eb2-5d91c1a05ea1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 68 limit 1","time":"39.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":489,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 16:27:10
22298	9d674879-0fd1-4f59-85c8-2d2722d5356a	9d674879-1469-4f19-8eb2-5d91c1a05ea1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 16:27:10
22299	9d674879-132f-474b-ab2f-a44caea4eb82	9d674879-1469-4f19-8eb2-5d91c1a05ea1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 16:27:10
22300	9d674879-1376-4467-9836-7af9ece005e6	9d674879-1469-4f19-8eb2-5d91c1a05ea1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"38","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"value_abono":"5000000","idLoans":68},"session":[],"response_status":200,"response":{"message":"Realizacion abono","data":{"id":68,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":10000000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_fecha_ultimo_pago":"03-11-2024","loans_pago_interes":"250000","loans_pago_prestado":"1000000"}},"duration":211,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:27:10
29172	9d6912fd-8a46-4ea1-8e4b-9a322ee5c3df	9d6912fd-b505-4a68-946f-f1c3e2f5545b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 13:49:17
29173	9d6912fd-ae02-4687-81ff-b1d55c777190	9d6912fd-b505-4a68-946f-f1c3e2f5545b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"55.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:49:17
29174	9d6912fd-ae82-4721-8c6a-7ed7447013e2	9d6912fd-b505-4a68-946f-f1c3e2f5545b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:49:17
29175	9d6912fd-b33b-4544-874c-ae4568fd4b45	9d6912fd-b505-4a68-946f-f1c3e2f5545b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 13:49:17
29176	9d6912fd-b3b2-49d4-b0fa-124c424c2a66	9d6912fd-b505-4a68-946f-f1c3e2f5545b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":406,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:49:17
41048	9d6cc948-a6d6-4b81-8a14-58b61a1232b7	9d6cc948-ce89-4d71-aa19-ec83fe98b8ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-06 10:06:30
41049	9d6cc948-c728-45b9-a665-294aa266070f	9d6cc948-ce89-4d71-aa19-ec83fe98b8ef	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"59.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 10:06:30
41050	9d6cc948-cc70-49a2-af88-1325c751ecb0	9d6cc948-ce89-4d71-aa19-ec83fe98b8ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-06 10:06:30
41051	9d6cc948-cd36-4bc1-bd89-da2538867354	9d6cc948-ce89-4d71-aa19-ec83fe98b8ef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":303,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:06:30
26622	9d68d90b-a081-4996-9803-e2cb2085e902	9d68d90b-c4e5-44fe-80eb-071d44bec0fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:07:15
26623	9d68d90b-c325-4033-aa1a-a6a7d9b181d7	9d68d90b-c4e5-44fe-80eb-071d44bec0fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:07:15
26624	9d68d90b-c3f4-450a-84b3-fac7b654a103	9d68d90b-c4e5-44fe-80eb-071d44bec0fb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":425,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:07:15
12976	9d5cefb1-bfc9-4959-89a5-9afa2388d7c0	9d5cefb1-c2b7-45bf-8d32-e8ee032373f6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":618}	2024-10-29 13:00:39
7101	9d52dab8-8466-4606-99ae-745966ce8f24	9d52dab8-87b7-436f-8f7c-c79b023cbe44	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":359}	2024-10-24 12:43:44
26625	9d68d90c-4fdb-4667-9e22-1bc632c46226	9d68d90c-7647-47af-905a-662a16a18ff6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:07:16
26626	9d68d90c-6967-4c0d-bc6e-80c37788d61c	9d68d90c-7647-47af-905a-662a16a18ff6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"47.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:07:16
26627	9d68d90c-6e47-4758-900a-2bb71197dffc	9d68d90c-7647-47af-905a-662a16a18ff6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"3.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:07:16
26628	9d68d90c-6ea0-45ad-b265-9609d12ca5c0	9d68d90c-7647-47af-905a-662a16a18ff6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:07:16
26629	9d68d90c-748b-4770-8d8c-41d1d1291f86	9d68d90c-7647-47af-905a-662a16a18ff6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:07:16
26630	9d68d90c-7506-4995-baa8-516b8e18e4ad	9d68d90c-7647-47af-905a-662a16a18ff6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":402,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:07:16
29226	9d6913e1-0c1f-4ff5-8dc9-95ba3f86d86b	9d6913e1-3987-4210-9141-147e771626d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 13:51:46
29227	9d6913e1-372f-4b64-ab47-fcd0ce52cde2	9d6913e1-3987-4210-9141-147e771626d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 13:51:46
29228	9d6913e1-383a-4d32-90a2-b2c0b499e17a	9d6913e1-3987-4210-9141-147e771626d8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":485,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:51:46
38242	9d6b6071-c4bc-498e-89e3-5f9e4d069d3f	9d6b6071-c968-47b6-91ae-b0209d2c3dbd	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1718}	2024-11-05 17:17:31
15186	9d5ecf43-448f-4a5f-9827-1f554694f410	9d5ecf43-4957-4bda-bb1d-a45976014514	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":686}	2024-10-30 11:21:37
29229	9d6913e2-5df3-4ef8-bbbe-768d06434c0d	9d6913e2-c4c0-41d3-9509-b4c71dc248fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 13:51:47
29230	9d6913e2-b932-4ebb-b4d2-97de20e86c80	9d6913e2-c4c0-41d3-9509-b4c71dc248fa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"130.70","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:51:47
29231	9d6913e2-b9f3-4e00-9ca9-790e10b729cb	9d6913e2-c4c0-41d3-9509-b4c71dc248fa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:51:47
29232	9d6913e2-c294-4166-a465-2099d744ba48	9d6913e2-c4c0-41d3-9509-b4c71dc248fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 13:51:47
29233	9d6913e2-c327-4d89-8cb4-6a459826f876	9d6913e2-c4c0-41d3-9509-b4c71dc248fa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":933,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:51:47
41822	9d6ccfcd-8b3a-4d21-a050-d19041aa02a0	9d6ccfcd-8e6d-4133-8695-c2ace5583c6f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1934}	2024-11-06 10:24:43
29234	9d6913e3-dfdd-4cd4-956f-042265fbb439	9d6913e4-13a4-410d-a92e-a0cd67bc7486	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 13:51:48
29235	9d6913e4-0961-44ab-a5f7-fced06558e47	9d6913e4-13a4-410d-a92e-a0cd67bc7486	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"69.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:51:48
29236	9d6913e4-09f0-4224-81dd-a11d06006a45	9d6913e4-13a4-410d-a92e-a0cd67bc7486	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:51:48
29237	9d6913e4-1161-4963-a668-e805fd68acb0	9d6913e4-13a4-410d-a92e-a0cd67bc7486	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 13:51:48
29238	9d6913e4-11fd-4e8c-9eba-8ec53c04cfc3	9d6913e4-13a4-410d-a92e-a0cd67bc7486	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":818,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:51:48
29360	9d691941-a82b-4307-92a1-999d8607f420	9d691942-0369-4d42-893d-e6ed8b50b125	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 14:06:48
29361	9d691942-00d4-4643-8a80-9a30effbb82c	9d691942-0369-4d42-893d-e6ed8b50b125	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 14:06:48
29362	9d691942-020c-4c48-846b-c46dd8a2611d	9d691942-0369-4d42-893d-e6ed8b50b125	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":454,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:06:48
14612	9d5ebeca-d422-46ca-af3f-2d6b260d4346	9d5ebeca-dab2-47da-a2a7-d9cc65f0151b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":669}	2024-10-30 10:35:34
10152	9d56c9e1-5d43-4315-baee-930104e107eb	9d56c9e1-6030-4461-b144-cb4320ee7aff	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":494}	2024-10-26 11:39:57
29363	9d691942-ace7-4eb4-bf3f-fdc0862055af	9d691942-e11d-4fe5-9b53-158df027dd35	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 14:06:49
29364	9d691942-d1b7-4cc5-962d-1f80467d7541	9d691942-e11d-4fe5-9b53-158df027dd35	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"68.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 14:06:49
29365	9d691942-d68b-476e-a8f2-e01d0d65b8af	9d691942-e11d-4fe5-9b53-158df027dd35	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"3.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 14:06:49
29366	9d691942-d6d7-43f4-9c6f-9f59e608c4d0	9d691942-e11d-4fe5-9b53-158df027dd35	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 14:06:49
29367	9d691942-de8e-4dd7-96b8-314d7ea73432	9d691942-e11d-4fe5-9b53-158df027dd35	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 14:06:49
29368	9d691942-df3f-47e3-888c-e35119cd4ae3	9d691942-e11d-4fe5-9b53-158df027dd35	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":453,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:06:49
43551	9d6cea0f-b8f6-437c-ab04-0d9fd948afaa	9d6cea0f-bc26-430c-9a50-ffeef84c61e5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2044}	2024-11-06 11:38:09
22432	9d674f12-0f03-463e-94d8-18a4ae2fafd3	9d674f12-44c8-445d-ac32-2c904c0699b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 16:45:37
22433	9d674f12-418c-4b7d-86f2-2a139f18fbf0	9d674f12-44c8-445d-ac32-2c904c0699b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 16:45:37
22434	9d674f12-4305-470e-9fe2-c434373d4280	9d674f12-44c8-445d-ac32-2c904c0699b4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":446,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:45:37
22435	9d674f12-f834-4512-9c92-2bde24ac1168	9d674f13-3480-40ee-b18f-6ca6f1591d3c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 16:45:38
22436	9d674f13-1fb4-41eb-85da-8a2624122012	9d674f13-3480-40ee-b18f-6ca6f1591d3c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 68\\n                        ","time":"71.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"7d9994d55cb8dde82ff4185920c79043","hostname":"EderCortes"}	2024-11-03 16:45:38
22437	9d674f13-2706-400f-a57f-733069902737	9d674f13-3480-40ee-b18f-6ca6f1591d3c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '68' order by \\"item_loans\\".\\"id\\" asc","time":"4.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 16:45:38
22438	9d674f13-2768-45f0-b80e-be53bba8301c	9d674f13-3480-40ee-b18f-6ca6f1591d3c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 16:45:38
22439	9d674f13-31d2-4729-8b1d-767be08dfb65	9d674f13-3480-40ee-b18f-6ca6f1591d3c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 16:45:38
22440	9d674f13-3296-4964-ae37-dae531450d10	9d674f13-3480-40ee-b18f-6ca6f1591d3c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/68","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":68,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":10000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"1000000","loans_pago_interes":"250000"},"items":[{"id":227,"loans_codigo":68,"itemloans_cuota":"1","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":228,"loans_codigo":68,"itemloans_cuota":"2","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":229,"loans_codigo":68,"itemloans_cuota":"3","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":230,"loans_codigo":68,"itemloans_cuota":"4","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":231,"loans_codigo":68,"itemloans_cuota":"5","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":232,"loans_codigo":68,"itemloans_cuota":"6","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":233,"loans_codigo":68,"itemloans_cuota":"7","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":234,"loans_codigo":68,"itemloans_cuota":"8","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":235,"loans_codigo":68,"itemloans_cuota":"9","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":236,"loans_codigo":68,"itemloans_cuota":"10","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":527,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:45:38
22441	9d674f13-fdb8-46a5-b402-7c8583825347	9d674f14-6113-4699-8321-a0069bd3c13a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 16:45:39
22442	9d674f14-5360-4f27-888f-8797c7ace5d6	9d674f14-6113-4699-8321-a0069bd3c13a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"98.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:45:39
22443	9d674f14-5400-4278-9784-6d6f496ebe53	9d674f14-6113-4699-8321-a0069bd3c13a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:45:39
22444	9d674f14-5d9f-44e3-9e24-b9b2c98d3f72	9d674f14-6113-4699-8321-a0069bd3c13a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 16:45:39
22445	9d674f14-5e4a-46d8-bedf-dd67eedf8ff1	9d674f14-6113-4699-8321-a0069bd3c13a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":740,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:45:39
22446	9d674f15-7f4f-4c17-900a-5fc2dfc7dd91	9d674f15-b178-47b7-93cd-3b2e5b04b53e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 16:45:40
22447	9d674f15-a779-40a8-b719-c650104112bf	9d674f15-b178-47b7-93cd-3b2e5b04b53e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"65.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 16:45:40
22448	9d674f15-a806-4f62-9374-69357cd91a08	9d674f15-b178-47b7-93cd-3b2e5b04b53e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 16:45:40
22449	9d674f15-af3a-454c-a67a-7434957eeb14	9d674f15-b178-47b7-93cd-3b2e5b04b53e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 16:45:40
22450	9d674f15-afe0-4820-80af-857e6553291f	9d674f15-b178-47b7-93cd-3b2e5b04b53e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":481,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:45:40
22451	9d674f21-7e67-47bd-af68-e8a5c0529855	9d674f21-8140-4998-96d4-2e726b56d17a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":160,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:45:47
41788	9d6ccf69-1b83-4634-8f85-4326c735cb5c	9d6ccf69-1e46-4a11-96f1-6ac81ae3e859	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1930}	2024-11-06 10:23:38
22452	9d674f22-33ac-4562-9041-fa751c34d418	9d674f22-50d9-48f6-98d6-ef178a2e967c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-03 16:45:48
22453	9d674f22-4b68-4782-bb13-8630a9b9b443	9d674f22-50d9-48f6-98d6-ef178a2e967c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 68 limit 1","time":"41.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":490,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 16:45:48
22454	9d674f22-4bc4-4c96-b0dc-9968a9130b3b	9d674f22-50d9-48f6-98d6-ef178a2e967c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 16:45:48
22455	9d674f22-4fa5-48ba-ab40-2d7de85fd4bb	9d674f22-50d9-48f6-98d6-ef178a2e967c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 16:45:48
22456	9d674f22-4fef-4dc3-8ddc-554a1ca0857e	9d674f22-50d9-48f6-98d6-ef178a2e967c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"37","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"2000000","idLoans":68},"session":[],"response_status":200,"response":{"canceladoHastaLaFecha":1250000,"recaudoTotal":12500000,"interesePesos":2500000,"valorAbono":2000000,"valorPorPagar":11250000,"data":{"id":68,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":10000000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_fecha_ultimo_pago":"03-11-2024","loans_pago_interes":"250000","loans_pago_prestado":"1000000"}},"duration":224,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:45:48
22457	9d674f32-70f8-4b3d-a1cb-0e6488ae067c	9d674f32-74d2-473d-b252-4a5f56220ff4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":160,"memory":20,"hostname":"EderCortes"}	2024-11-03 16:45:58
29664	9d692a0c-510f-4257-b75b-a1e8c87190ff	9d692a0c-8545-4435-9d21-2f258483e39b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 14:53:45
29665	9d692a0c-825f-4cdf-b6d7-97efc40ff988	9d692a0c-8545-4435-9d21-2f258483e39b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 14:53:45
29666	9d692a0c-83bf-490e-a71a-1f2a47b29e28	9d692a0c-8545-4435-9d21-2f258483e39b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":454,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:53:45
22458	9d674f33-2a74-41ac-9155-5e9a2b7243c3	9d674f33-468a-4921-ac36-1e24ba729db2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-03 16:45:59
22459	9d674f33-41a0-405b-9e9e-b9b5b64785e2	9d674f33-468a-4921-ac36-1e24ba729db2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 68 limit 1","time":"38.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":490,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-03 16:45:59
22460	9d674f33-41ec-4f22-8139-a11e5d4ad40a	9d674f33-468a-4921-ac36-1e24ba729db2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-03 16:45:59
22461	9d674f33-454d-47c1-ba1a-152714c4e378	9d674f33-468a-4921-ac36-1e24ba729db2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-03 16:45:59
22462	9d674f33-4598-4e7b-93a6-3f8308866f1e	9d674f33-468a-4921-ac36-1e24ba729db2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"40","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"2000000000","idLoans":68},"session":[],"response_status":200,"response":{"message":"El valor a abonar supera el valor de la deuda que es actalmente de 11250000"},"duration":228,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:45:59
29667	9d692a0d-150c-4365-add1-3c7c55c6a73c	9d692a0d-72e8-4b2c-829d-76b5697715df	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 14:53:46
29668	9d692a0d-67fa-4960-8757-f99ae7bfc35e	9d692a0d-72e8-4b2c-829d-76b5697715df	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"172.82","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":56,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 14:53:46
29669	9d692a0d-6892-4cd1-a52f-a051d7995f84	9d692a0d-72e8-4b2c-829d-76b5697715df	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 14:53:46
29670	9d692a0d-7090-4e6a-8f2a-03f6540f3a4c	9d692a0d-72e8-4b2c-829d-76b5697715df	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 14:53:46
29671	9d692a0d-7135-480a-9dfb-55e7fbfa35a0	9d692a0d-72e8-4b2c-829d-76b5697715df	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":521,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:53:46
29672	9d692a0e-3255-40f1-bf0b-6038ec9cf292	9d692a0e-f9e7-42b7-9094-a239f844d927	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 14:53:47
29673	9d692a0e-f000-4b16-b2c0-9a6f9157e305	9d692a0e-f9e7-42b7-9094-a239f844d927	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"398.65","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:53:47
29674	9d692a0e-f08b-4242-90f3-c9b18a049e57	9d692a0e-f9e7-42b7-9094-a239f844d927	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:53:47
29675	9d692a0e-f7e5-4756-bb27-19066b5d3d7a	9d692a0e-f9e7-42b7-9094-a239f844d927	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 14:53:47
29676	9d692a0e-f876-4642-afc7-14abd6028a2e	9d692a0e-f9e7-42b7-9094-a239f844d927	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":968,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:53:47
29677	9d692a0f-a1bd-49ac-8745-b9e39bac60d7	9d692a0f-d29d-4500-bb37-9a9cfd1ccdc8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 14:53:47
26829	9d68dd0b-777a-4b87-9ced-4cc4cdca4b2d	9d68dd0b-c4d7-458d-b32e-1512dc296f3a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 11:18:26
26830	9d68dd0b-c2fa-45f3-a3da-c56fdeee03f3	9d68dd0b-c4d7-458d-b32e-1512dc296f3a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:18:26
26831	9d68dd0b-c3b4-4d02-ab8f-b820fca02552	9d68dd0b-c4d7-458d-b32e-1512dc296f3a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":547,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:18:26
29678	9d692a0f-c92c-4cf1-bad1-2830a3c1d055	9d692a0f-d29d-4500-bb37-9a9cfd1ccdc8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"63.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:53:48
29679	9d692a0f-c9a9-4148-a4be-366dbac423d3	9d692a0f-d29d-4500-bb37-9a9cfd1ccdc8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:53:48
29680	9d692a0f-d07b-4694-ab0b-180f800d0b3b	9d692a0f-d29d-4500-bb37-9a9cfd1ccdc8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 14:53:48
29681	9d692a0f-d0fc-4543-ab22-91683fedaf74	9d692a0f-d29d-4500-bb37-9a9cfd1ccdc8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":521,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:53:48
26832	9d68dd0c-614c-46f2-95dc-3ac2fcda59fe	9d68dd0c-8039-4e8a-8de3-60518e3c4432	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:18:27
26833	9d68dd0c-7733-4010-a4a2-56c5ce401f12	9d68dd0c-8039-4e8a-8de3-60518e3c4432	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"41.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:18:27
26834	9d68dd0c-7ada-4926-b03d-89f79c3fd307	9d68dd0c-8039-4e8a-8de3-60518e3c4432	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:18:27
26835	9d68dd0c-7b16-404f-8716-d694eda91882	9d68dd0c-8039-4e8a-8de3-60518e3c4432	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:18:27
26836	9d68dd0c-7f09-4550-baf2-b7d2343f06fc	9d68dd0c-8039-4e8a-8de3-60518e3c4432	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:18:27
26837	9d68dd0c-7f52-48ce-9d92-1ffa519bf698	9d68dd0c-8039-4e8a-8de3-60518e3c4432	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":399,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:18:27
29577	9d69293f-b539-420c-9bc6-eb30e6bed99c	9d69293f-f85c-4240-b1c9-f34dbb20d0f8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 14:51:31
29578	9d69293f-f533-49c9-9d10-f51138e33e95	9d69293f-f85c-4240-b1c9-f34dbb20d0f8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 14:51:31
29579	9d69293f-f6d0-46e1-8293-2de98555a812	9d69293f-f85c-4240-b1c9-f34dbb20d0f8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":533,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:51:31
29580	9d692940-a0e4-4773-b829-92bb5ee3aed9	9d692940-f1e2-4467-8c49-d3255143d0ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 14:51:32
29581	9d692940-e809-488d-9e1e-0729d3dd1f97	9d692940-f1e2-4467-8c49-d3255143d0ed	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"128.94","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":56,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 14:51:32
29582	9d692940-e8b2-4379-a95b-2ce794dee181	9d692940-f1e2-4467-8c49-d3255143d0ed	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 14:51:32
29583	9d692940-ef96-4118-9413-ddf74f79eb22	9d692940-f1e2-4467-8c49-d3255143d0ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 14:51:32
29496	9d692814-4981-4389-a3c8-1e4647375206	9d692814-7cb4-409f-99a8-0fb13002bc64	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 14:48:15
29497	9d692814-7a50-4408-921c-3cb64b5510c4	9d692814-7cb4-409f-99a8-0fb13002bc64	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 14:48:15
29498	9d692814-7b6a-4c49-9d8b-ece1dc59e9d7	9d692814-7cb4-409f-99a8-0fb13002bc64	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":510,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:48:15
29584	9d692940-f01d-4e78-b570-9cb3c1a0f60a	9d692940-f1e2-4467-8c49-d3255143d0ed	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":534,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:51:32
29499	9d692815-0872-460d-8b08-a6eb82fcb27e	9d692815-0cfa-4364-a157-bbb210e61cb8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user\\/12","method":"GET","controller_action":null,"middleware":[],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":404,"response":{"error":"No se encontro la url especificada","code":404},"duration":268,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:48:15
29585	9d692942-5b41-4680-9026-a81ac504d6ae	9d692942-9bde-4ed6-9be6-dbdb9f32209f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 14:51:33
29586	9d692942-91a6-43b5-88bb-b3e1471ac628	9d692942-9bde-4ed6-9be6-dbdb9f32209f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"88.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:51:33
29587	9d692942-9223-4d82-8ac3-d59dd266ea43	9d692942-9bde-4ed6-9be6-dbdb9f32209f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:51:33
29588	9d692942-99b5-4ce6-b700-f3f66fc7776b	9d692942-9bde-4ed6-9be6-dbdb9f32209f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 14:51:33
29589	9d692942-9a44-4777-8ed5-d259b47b0578	9d692942-9bde-4ed6-9be6-dbdb9f32209f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1061,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:51:33
29500	9d692815-da31-4075-b91a-65159b327191	9d692816-181b-46f5-bd88-682c58f61a7c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 14:48:16
29501	9d692816-0be7-44d9-a799-52f68fc3e809	9d692816-181b-46f5-bd88-682c58f61a7c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"80.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:48:16
29502	9d692816-0c90-45cd-bfe5-66e9dbbae544	9d692816-181b-46f5-bd88-682c58f61a7c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:48:16
29503	9d692816-1551-40ed-a418-22f1b8c28472	9d692816-181b-46f5-bd88-682c58f61a7c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 14:48:16
29504	9d692816-161e-463c-a74b-c1751601003d	9d692816-181b-46f5-bd88-682c58f61a7c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":593,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:48:16
29590	9d692943-6971-4ba8-a2a6-25f165e2665d	9d692943-a34b-4a17-826a-e5f5a5f1d16f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 14:51:34
29591	9d692943-99b3-46d5-ad84-c94b9568cf4e	9d692943-a34b-4a17-826a-e5f5a5f1d16f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"68.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:51:34
29592	9d692943-9a3c-4b5f-918e-bcbfc018ef29	9d692943-a34b-4a17-826a-e5f5a5f1d16f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:51:34
29593	9d692943-a107-4c75-a45a-c6570b0aa896	9d692943-a34b-4a17-826a-e5f5a5f1d16f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 14:51:34
29594	9d692943-a1b4-43eb-b2a1-5b8ad8208878	9d692943-a34b-4a17-826a-e5f5a5f1d16f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":649,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:51:34
29505	9d692816-b159-432e-a68c-d13c47be2e2d	9d692816-e19a-4434-9944-02a9e2453b26	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 14:48:17
29506	9d692816-d7b3-4d3e-9d9a-ae8c9c3b03b5	9d692816-e19a-4434-9944-02a9e2453b26	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"63.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:48:17
29507	9d692816-d840-4ff5-b2c3-85f1a5697579	9d692816-e19a-4434-9944-02a9e2453b26	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:48:17
29508	9d692816-dfb0-40f8-a344-9e3d785c5f7b	9d692816-e19a-4434-9944-02a9e2453b26	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 14:48:17
22586	9d67e3d3-485f-4129-bb17-d8eb3651cd2e	9d67e3d3-99ad-415c-814d-6d576ca6e695	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-03 23:41:34
22587	9d67e3d3-95dc-4a39-a698-cf7e6960ea72	9d67e3d3-99ad-415c-814d-6d576ca6e695	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 23:41:34
22588	9d67e3d3-97ba-4821-b3c1-c2d9d67bfe65	9d67e3d3-99ad-415c-814d-6d576ca6e695	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":716,"memory":22,"hostname":"EderCortes"}	2024-11-03 23:41:34
29509	9d692816-e035-4671-8d83-9a276e372fd8	9d692816-e19a-4434-9944-02a9e2453b26	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":491,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:48:17
22589	9d67e3d4-603d-405b-9e14-b35f86a64e10	9d67e3d4-abab-41c1-a312-1a800a79a63b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 23:41:35
22590	9d67e3d4-9f4a-4414-8a40-a1aeaeddaae4	9d67e3d4-abab-41c1-a312-1a800a79a63b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"72.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 23:41:35
22591	9d67e3d4-a00b-4ccb-9047-6fc1d1da4b29	9d67e3d4-abab-41c1-a312-1a800a79a63b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-03 23:41:35
22592	9d67e3d4-a8f5-41ea-a9d0-2304e87bfe8b	9d67e3d4-abab-41c1-a312-1a800a79a63b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 23:41:35
22593	9d67e3d4-a9b8-4341-9ea8-bc358881248d	9d67e3d4-abab-41c1-a312-1a800a79a63b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":620,"memory":22,"hostname":"EderCortes"}	2024-11-03 23:41:35
29510	9d692817-8072-429e-960a-dbe40ea298e1	9d692817-84d9-45bd-b83f-c8944986c2e2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user\\/12","method":"GET","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":404,"response":{"error":"No se encontro la url especificada","code":404},"duration":360,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:48:17
22594	9d67e3d5-4f42-4f28-8747-81bcca82f869	9d67e3d5-843b-4313-84f0-96d8514ed84c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 23:41:36
22595	9d67e3d5-7981-45c8-a72b-a215f7825690	9d67e3d5-843b-4313-84f0-96d8514ed84c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"67.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":185,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-03 23:41:36
22596	9d67e3d5-7a37-4420-9a2f-d50a95e100f6	9d67e3d5-843b-4313-84f0-96d8514ed84c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-03 23:41:36
22597	9d67e3d5-822e-48c6-8e7a-73cf8f26f2f6	9d67e3d5-843b-4313-84f0-96d8514ed84c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 23:41:36
22598	9d67e3d5-82bb-41b9-b602-ed2dd21bf652	9d67e3d5-843b-4313-84f0-96d8514ed84c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":528,"memory":22,"hostname":"EderCortes"}	2024-11-03 23:41:36
22599	9d67e3d6-4cf5-4560-8e32-906db0959d6f	9d67e3d6-9268-44b6-8efb-10ed05f7ce6d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 23:41:36
22600	9d67e3d6-86d8-48bb-9cfe-fa5da5e98ff4	9d67e3d6-9268-44b6-8efb-10ed05f7ce6d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"95.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 23:41:36
22601	9d67e3d6-8782-461e-b1fe-36cf5d2a9d93	9d67e3d6-9268-44b6-8efb-10ed05f7ce6d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 23:41:36
22602	9d67e3d6-9015-48bd-815b-097f0cef5085	9d67e3d6-9268-44b6-8efb-10ed05f7ce6d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 23:41:36
22603	9d67e3d6-90e2-4eb0-934f-d8de22cb11f9	9d67e3d6-9268-44b6-8efb-10ed05f7ce6d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":664,"memory":22,"hostname":"EderCortes"}	2024-11-03 23:41:36
22604	9d67e3d7-31f7-45b5-abad-b88afa517af5	9d67e3d7-93d4-4349-8a5a-c005f34311d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-03 23:41:37
22605	9d67e3d7-8837-4f17-b20c-bd2c46891bde	9d67e3d7-93d4-4349-8a5a-c005f34311d9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"178.82","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-03 23:41:37
22606	9d67e3d7-88f4-41b7-bc6a-0bdaa5696bed	9d67e3d7-93d4-4349-8a5a-c005f34311d9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-03 23:41:37
22607	9d67e3d7-9191-486d-8941-73ae3008fcbc	9d67e3d7-93d4-4349-8a5a-c005f34311d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-03 23:41:37
22608	9d67e3d7-922b-418d-a9b8-665d3d601673	9d67e3d7-93d4-4349-8a5a-c005f34311d9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":634,"memory":22,"hostname":"EderCortes"}	2024-11-03 23:41:37
34651	9d69bf31-6117-4e05-af7e-f4ad2d6836c0	9d69bf31-9ea6-446c-890f-35c0b6ef1f5e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 21:50:48
34652	9d69bf31-9ac8-409b-90a2-e59b7b5517e3	9d69bf31-9ea6-446c-890f-35c0b6ef1f5e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 21:50:48
34653	9d69bf31-9c8c-4fdb-bb7a-c08155bfbbbd	9d69bf31-9ea6-446c-890f-35c0b6ef1f5e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":458,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:50:48
34654	9d69bf32-3602-40cc-8498-d168f99e3a09	9d69bf32-6513-45eb-968b-851e799dcc4d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 21:50:48
34655	9d69bf32-5bbd-4bc2-98c1-a369ea8068dd	9d69bf32-6513-45eb-968b-851e799dcc4d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"59.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":257,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:50:48
34656	9d69bf32-5c54-4156-8edb-d278d2a2a67d	9d69bf32-6513-45eb-968b-851e799dcc4d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:50:48
34657	9d69bf32-6318-4331-8fc7-3ea627f1e87f	9d69bf32-6513-45eb-968b-851e799dcc4d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 21:50:48
34658	9d69bf32-6396-4f0a-ae90-28325d948778	9d69bf32-6513-45eb-968b-851e799dcc4d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":421,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:50:48
42977	9d6ce335-828b-4514-ab2a-8892cbe6a8e9	9d6ce335-8574-4611-b537-94b88d12801d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1974}	2024-11-06 11:18:59
34659	9d69bf32-d223-41e9-a430-e17486f02eeb	9d69bf33-2b77-45a0-b796-434d905fc41c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 21:50:49
34660	9d69bf33-2054-4de2-b707-97925219d573	9d69bf33-2b77-45a0-b796-434d905fc41c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"162.64","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":246,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 21:50:49
34661	9d69bf33-20f1-4d38-9f0c-2ab221512c6c	9d69bf33-2b77-45a0-b796-434d905fc41c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 21:50:49
34662	9d69bf33-2980-48d8-a57c-e36082f6e341	9d69bf33-2b77-45a0-b796-434d905fc41c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 21:50:49
34663	9d69bf33-2a07-459c-9e40-5c6c56026826	9d69bf33-2b77-45a0-b796-434d905fc41c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":485,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:50:49
34664	9d69bf33-9f25-4286-aed4-19e92eddb641	9d69bf33-c762-436a-9cfc-1cea79d4c9a9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 21:50:49
34665	9d69bf33-bdc1-4bad-a9cd-fb34735a648b	9d69bf33-c762-436a-9cfc-1cea79d4c9a9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:50:49
34666	9d69bf33-be58-42d5-8fc5-a62026974444	9d69bf33-c762-436a-9cfc-1cea79d4c9a9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:50:49
34667	9d69bf33-c537-4708-b54c-bc68bbd0afb9	9d69bf33-c762-436a-9cfc-1cea79d4c9a9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 21:50:49
34668	9d69bf33-c5c5-4d45-9160-0d6776bce2b4	9d69bf33-c762-436a-9cfc-1cea79d4c9a9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":371,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:50:49
34669	9d69bf34-1bc3-4bfc-b8eb-7c415ab2f81d	9d69bf34-650c-47a8-a732-ce6590c57bde	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 21:50:49
34670	9d69bf34-5e78-40e8-97e7-04aa10603977	9d69bf34-650c-47a8-a732-ce6590c57bde	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_valor_prestado\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"loans_inicio_pago\\", \\"user_creador\\", \\"user_cobrador\\", \\"loans_pago_prestado\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\" from \\"loans\\" where \\"id\\" = '93' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"150.30","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":233,"hash":"58481adc49710b91b872dd680f964f96","hostname":"EderCortes"}	2024-11-04 21:50:50
34671	9d69bf34-5ec5-400d-8c6d-70f411a11939	9d69bf34-650c-47a8-a732-ce6590c57bde	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 21:50:50
34672	9d69bf34-607e-42b1-8d68-da5da9ed8a43	9d69bf34-650c-47a8-a732-ce6590c57bde	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"2.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":234,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 21:50:50
34673	9d69bf34-60b3-42e7-b36f-82e82703743c	9d69bf34-650c-47a8-a732-ce6590c57bde	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 21:50:50
34674	9d69bf34-63ec-4c89-8987-7c729bc2a99d	9d69bf34-650c-47a8-a732-ce6590c57bde	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 21:50:50
34675	9d69bf34-6435-4649-ba52-8e67db7f26f3	9d69bf34-650c-47a8-a732-ce6590c57bde	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","user_creador":12,"user_cobrador":22,"loans_pago_prestado":"1000000","user_customer":19,"user_recomendacion":18,"loans_pago_interes":"250000"},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:19:45.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:22:30.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":399,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":400,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":401,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":402,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"}]}},"duration":381,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:50:50
34676	9d69bf34-d6aa-4fc7-8800-a10f110e3926	9d69bf35-1787-4642-97d6-02dffa9c252e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 21:50:50
34677	9d69bf35-0d2a-4e62-ada9-2d6570e3e955	9d69bf35-1787-4642-97d6-02dffa9c252e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"71.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:50:50
34678	9d69bf35-0db0-4d7b-ba02-3162e844e248	9d69bf35-1787-4642-97d6-02dffa9c252e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:50:50
34679	9d69bf35-153e-4ecd-8b2c-b9b98cbb9ccd	9d69bf35-1787-4642-97d6-02dffa9c252e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 21:50:50
34680	9d69bf35-15cf-4f10-a4ce-365e722b004b	9d69bf35-1787-4642-97d6-02dffa9c252e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":439,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:50:50
29780	9d692b18-9146-4f05-9747-c6be8175d8a6	9d692b18-af96-483a-9b26-13ba26f809c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 14:56:41
29781	9d692b18-ae28-4b49-9a94-d9011e5b555b	9d692b18-af96-483a-9b26-13ba26f809c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 14:56:41
29782	9d692b18-aec1-4c6e-8235-705c8b75244a	9d692b18-af96-483a-9b26-13ba26f809c0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":255,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:56:41
19913	9d66eba9-76cc-4ab0-b014-b9eb7e909bb1	9d66eba9-7a9b-4b0a-a0c7-5e1cc9f6fa12	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":981}	2024-11-03 12:07:39
15593	9d648ead-2f78-47bf-8443-4d4e25dedc82	9d648ead-32ac-434c-b5aa-ad30cc85bf24	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":711}	2024-11-02 07:56:00
29783	9d692b19-00d8-4a4f-9618-7a3af6daa50e	9d692b19-2023-4ee3-a663-f53027a25ee7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 14:56:41
29784	9d692b19-1ac1-4db0-a6ce-16b10cb4941c	9d692b19-2023-4ee3-a663-f53027a25ee7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"42.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":56,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 14:56:41
29785	9d692b19-1b1a-45d8-a1da-f52d7431899f	9d692b19-2023-4ee3-a663-f53027a25ee7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 14:56:41
29786	9d692b19-1ebc-497a-b543-f917e72b367e	9d692b19-2023-4ee3-a663-f53027a25ee7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 14:56:41
29787	9d692b19-1f12-47d8-bec9-2c133d9643e6	9d692b19-2023-4ee3-a663-f53027a25ee7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:56:41
34681	9d69bf35-f3b2-4498-b748-355e697ee011	9d69bf36-25e3-41f6-a4f2-9634d56c5412	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 21:50:51
34682	9d69bf36-1cfa-4763-b429-e5db80ae56e7	9d69bf36-25e3-41f6-a4f2-9634d56c5412	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"75.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:50:51
33202	9d69ad5c-8e42-42a2-9dd1-dfee17b5a61c	9d69ad5d-0392-4192-80f1-c4943d1a8aeb	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 21:00:56
33203	9d69ad5c-ffd8-41e9-b96c-826f67c0bb9f	9d69ad5d-0392-4192-80f1-c4943d1a8aeb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:00:56
33204	9d69ad5d-017c-426d-82fb-57880ea5051f	9d69ad5d-0392-4192-80f1-c4943d1a8aeb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":807,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:00:56
34683	9d69bf36-1d7a-4d63-9b92-52869a9b494a	9d69bf36-25e3-41f6-a4f2-9634d56c5412	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:50:51
34684	9d69bf36-241d-4b25-9129-a66217d9a45f	9d69bf36-25e3-41f6-a4f2-9634d56c5412	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 21:50:51
34685	9d69bf36-2488-4d0e-a776-55984484fbd0	9d69bf36-25e3-41f6-a4f2-9634d56c5412	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":449,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:50:51
33205	9d69ad5d-bd50-4c09-a1aa-4ecee90dbfb6	9d69ad5d-e66e-4faa-9646-7953276faaf2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:00:57
33206	9d69ad5d-dbe9-433f-8933-73112fa247c8	9d69ad5d-e66e-4faa-9646-7953276faaf2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 87\\n                        ","time":"62.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"309a6eff5ebe9f2d91248732844dd9ed","hostname":"EderCortes"}	2024-11-04 21:00:57
33207	9d69ad5d-df5c-4e86-acb3-70f884c3a861	9d69ad5d-e66e-4faa-9646-7953276faaf2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '87' order by \\"item_loans\\".\\"id\\" asc","time":"3.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:00:57
33208	9d69ad5d-e4f3-4b10-ae7c-a5553e901ccb	9d69ad5d-e66e-4faa-9646-7953276faaf2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:00:57
33209	9d69ad5d-e563-4883-887b-4ad8e0cde7c4	9d69ad5d-e66e-4faa-9646-7953276faaf2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/87","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":87,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"220000","loans_pago_interes":"55000","user_alias":"eder.cortes"},"items":[{"id":341,"loans_codigo":87,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 20:50:52","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000","user_alias":"eder.cortes"},{"id":342,"loans_codigo":87,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":343,"loans_codigo":87,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":344,"loans_codigo":87,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":345,"loans_codigo":87,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:00:57
33210	9d69ad60-0e02-41bf-82b4-8045fc0f96ba	9d69ad60-2afa-4347-b664-be73296b836a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:00:58
33211	9d69ad60-2596-48da-951a-082ac73a19f2	9d69ad60-2afa-4347-b664-be73296b836a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:00:58
33212	9d69ad60-2606-46b0-b38b-d89c4ebb3267	9d69ad60-2afa-4347-b664-be73296b836a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:00:58
33213	9d69ad60-298f-41ef-9127-38ba2cd499a6	9d69ad60-2afa-4347-b664-be73296b836a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:00:58
33214	9d69ad60-29de-4815-ac35-be75fd95a207	9d69ad60-2afa-4347-b664-be73296b836a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":302,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:00:58
34422	9d69be45-c019-4320-8f4b-8389b4bf79de	9d69be45-e812-4fc5-8dc4-b6f52dbf7563	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 21:48:13
34423	9d69be45-e608-47bb-a1c2-c2938a5cc67a	9d69be45-e812-4fc5-8dc4-b6f52dbf7563	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:48:13
34424	9d69be45-e6f5-4d4f-b409-bd906ce52ad6	9d69be45-e812-4fc5-8dc4-b6f52dbf7563	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":294,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:48:13
4449	9d513004-0649-4039-bc78-dd5cbe5c8d96	9d513004-0af9-4af5-aab3-0bd7f199c6ee	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":243}	2024-10-23 16:50:34
23389	9d6895fc-27ff-4c2b-9ba9-88f7b093136a	9d6895fc-2b2b-471b-afa9-d694fca4c3be	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1104}	2024-11-04 07:59:44
34425	9d69be46-5101-4fbb-a314-fe9d473ab42c	9d69be46-9bd6-41ec-b216-bfa9d6814e60	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:48:14
29857	9d692bf2-9678-4b9a-9183-bc48caa373a0	9d692bf2-c83d-4779-9ffe-c9eb651df563	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 14:59:04
29858	9d692bf2-c5b8-4962-96ab-b64b31c8e95f	9d692bf2-c83d-4779-9ffe-c9eb651df563	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 14:59:04
29859	9d692bf2-c6e9-44cb-8fd6-69d7cb3e4bfe	9d692bf2-c83d-4779-9ffe-c9eb651df563	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":427,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:59:04
22748	9d67f9e7-cf2d-4d25-85ff-ea9eef5203b0	9d67f9e8-20f4-4132-8e43-2229710fa199	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 00:43:19
22749	9d67f9e8-1f3e-4c0e-a4bc-c971b6ada79e	9d67f9e8-20f4-4132-8e43-2229710fa199	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 00:43:19
22750	9d67f9e8-1fda-4b4d-83a5-5d7647aa8930	9d67f9e8-20f4-4132-8e43-2229710fa199	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":435,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:43:19
32645	9d6968c1-d6a3-4dfe-9185-d56bd1c90da0	9d6968c2-23cf-40a4-a8af-1e2065b0a125	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 17:49:06
32646	9d6968c2-2188-4877-9cd1-2a73b036a3c2	9d6968c2-23cf-40a4-a8af-1e2065b0a125	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 17:49:06
32647	9d6968c2-228f-4317-87de-0346480e43e2	9d6968c2-23cf-40a4-a8af-1e2065b0a125	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":461,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:49:06
34426	9d69be46-9648-41a0-9f64-ae8f1a5822a6	9d69be46-9bd6-41ec-b216-bfa9d6814e60	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"152.21","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":255,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:48:14
34427	9d69be46-9698-4e89-8f75-d1b5d130d283	9d69be46-9bd6-41ec-b216-bfa9d6814e60	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:48:14
34428	9d69be46-9a94-47ad-bf60-851423b5af7b	9d69be46-9bd6-41ec-b216-bfa9d6814e60	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:48:14
34429	9d69be46-9adc-4992-8a55-448ce1f2dba1	9d69be46-9bd6-41ec-b216-bfa9d6814e60	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":405,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:48:14
22751	9d67f9e8-6c57-4d48-ad42-b9f0e57e7b67	9d67f9e8-b645-4aeb-b38d-f8314e7e8b49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 00:43:19
22752	9d67f9e8-ad47-408b-9db2-38a2bff54721	9d67f9e8-b645-4aeb-b38d-f8314e7e8b49	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 65\\n                        ","time":"153.55","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6768d7067397538897aacf4d73c43049","hostname":"EderCortes"}	2024-11-04 00:43:19
22753	9d67f9e8-b0e9-4fdb-9e36-ffd9807818c9	9d67f9e8-b645-4aeb-b38d-f8314e7e8b49	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '65' order by \\"item_loans\\".\\"id\\" asc","time":"1.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 00:43:19
22754	9d67f9e8-b125-4b40-96cc-2073fbf0b1d7	9d67f9e8-b645-4aeb-b38d-f8314e7e8b49	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 00:43:19
22755	9d67f9e8-b51b-42c6-923b-8c33ea58038f	9d67f9e8-b645-4aeb-b38d-f8314e7e8b49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 00:43:19
22756	9d67f9e8-b568-4b10-abf3-3ae5173ae00d	9d67f9e8-b645-4aeb-b38d-f8314e7e8b49	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/65","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":65,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":30,"loans_cuotas":10,"loans_valor_prestado":3000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-10 00:00:00","loans_pago_prestado":"1669230.7692308","loans_pago_interes":"500769.23076923"},"items":[{"id":207,"loans_codigo":65,"itemloans_cuota":"1","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-03T20:46:55.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"90000","itemloans_cuota_cancelada":"300000"},{"id":208,"loans_codigo":65,"itemloans_cuota":"2","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-04T05:39:56.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"90000","itemloans_cuota_cancelada":"300000"},{"id":209,"loans_codigo":65,"itemloans_cuota":"3","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-04T05:40:07.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"90000","itemloans_cuota_cancelada":"300000"},{"id":210,"loans_codigo":65,"itemloans_cuota":"4","itemloans_valor_cuota":"300000","itemloans_iteres":"90000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-10 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T18:06:27.000000Z","updated_at":"2024-11-04T05:43:06.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"230769.23076923","itemloans_cuota_cancelada":"769230.76923077"},{"id":237,"loans_codigo":65,"itemloans_cuota":"5","itemloans_valor_cuota":"221794.87179487","itemloans_iteres":"-83461.538461538","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:43:06.000000Z","updated_at":"2024-11-04T05:43:06.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"230769.23076923","itemloans_cuota_cancelada":"769230.76923077"},{"id":238,"loans_codigo":65,"itemloans_cuota":"6","itemloans_valor_cuota":"221794.87179487","itemloans_iteres":"-83461.538461538","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:43:06.000000Z","updated_at":"2024-11-04T05:43:06.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"230769.23076923","itemloans_cuota_cancelada":"769230.76923077"},{"id":239,"loans_codigo":65,"itemloans_cuota":"7","itemloans_valor_cuota":"221794.87179487","itemloans_iteres":"-83461.538461538","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:43:06.000000Z","updated_at":"2024-11-04T05:43:06.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"230769.23076923","itemloans_cuota_cancelada":"769230.76923077"},{"id":240,"loans_codigo":65,"itemloans_cuota":"8","itemloans_valor_cuota":"221794.87179487","itemloans_iteres":"-83461.538461538","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:43:06.000000Z","updated_at":"2024-11-04T05:43:06.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"230769.23076923","itemloans_cuota_cancelada":"769230.76923077"},{"id":241,"loans_codigo":65,"itemloans_cuota":"9","itemloans_valor_cuota":"221794.87179487","itemloans_iteres":"-83461.538461538","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-04-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:43:06.000000Z","updated_at":"2024-11-04T05:43:06.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"230769.23076923","itemloans_cuota_cancelada":"769230.76923077"},{"id":242,"loans_codigo":65,"itemloans_cuota":"10","itemloans_valor_cuota":"221794.87179487","itemloans_iteres":"-83461.538461538","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-05-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:43:06.000000Z","updated_at":"2024-11-04T05:43:06.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"230769.23076923","itemloans_cuota_cancelada":"769230.76923077"}]}},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:43:19
29860	9d692bf3-6333-4f6b-a29d-adee1f16d47f	9d692bf3-9432-464f-90b6-89db3865c347	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 14:59:04
29861	9d692bf3-8a41-4d84-967b-eea48584c0bf	9d692bf3-9432-464f-90b6-89db3865c347	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"62.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":56,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 14:59:05
29862	9d692bf3-8ac5-4be9-9a31-d677a7e1ad6a	9d692bf3-9432-464f-90b6-89db3865c347	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 14:59:05
29863	9d692bf3-9219-446e-a64f-8ca65f33cc28	9d692bf3-9432-464f-90b6-89db3865c347	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 14:59:05
29864	9d692bf3-92b1-4245-b544-26676f236acc	9d692bf3-9432-464f-90b6-89db3865c347	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":431,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:59:05
32648	9d6968c2-b1c0-4a63-b8bf-2060733f8633	9d6968c2-d461-4fd0-8cc0-9452657e871d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 17:49:07
34430	9d69be46-e099-4399-9a33-dba2eec7efa1	9d69be46-fd3f-4455-baa2-123aa25f1c33	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:48:14
34431	9d69be46-f847-4e7b-8844-4f4d9ba42d1f	9d69be46-fd3f-4455-baa2-123aa25f1c33	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":244,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 21:48:14
34432	9d69be46-f8a8-41fe-8710-fb25fe07af3b	9d69be46-fd3f-4455-baa2-123aa25f1c33	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 21:48:14
34433	9d69be46-fc1d-4b8a-9969-b6f58e042e6a	9d69be46-fd3f-4455-baa2-123aa25f1c33	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:48:14
22757	9d67f9ea-876c-4fb3-86b9-a2b384531789	9d67f9ea-aa90-4388-941f-c951ec48d2db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 00:43:20
22758	9d67f9ea-a3b0-481a-86c8-82d70a06f673	9d67f9ea-aa90-4388-941f-c951ec48d2db	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"46.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 00:43:20
22759	9d67f9ea-a419-4781-810c-038a4259209e	9d67f9ea-aa90-4388-941f-c951ec48d2db	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 00:43:20
22760	9d67f9ea-a8ee-4f04-b89c-19b6f203c340	9d67f9ea-aa90-4388-941f-c951ec48d2db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 00:43:20
22761	9d67f9ea-a94d-4c8a-b55f-d007b53c2efd	9d67f9ea-aa90-4388-941f-c951ec48d2db	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":474,"memory":22,"hostname":"EderCortes"}	2024-11-04 00:43:20
29865	9d692bf4-8772-4c71-b52a-cbfebaa5e2c1	9d692bf4-c4bd-4c69-af43-8ae067f2ae62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 14:59:05
29866	9d692bf4-b868-4917-ad24-60ae3da57e30	9d692bf4-c4bd-4c69-af43-8ae067f2ae62	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"80.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:59:05
29867	9d692bf4-b931-4bfd-abfe-569b8048ffcc	9d692bf4-c4bd-4c69-af43-8ae067f2ae62	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:59:05
29868	9d692bf4-c266-4ad7-9b2c-470bca1fdf91	9d692bf4-c4bd-4c69-af43-8ae067f2ae62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 14:59:05
29869	9d692bf4-c316-402f-acec-ecd4a4f7e1fe	9d692bf4-c4bd-4c69-af43-8ae067f2ae62	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":750,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:59:05
32649	9d6968c2-ca7e-46f7-8523-d1f3e873f55d	9d6968c2-d461-4fd0-8cc0-9452657e871d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 91\\n                        ","time":"48.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"9ae30bc69b6b272f3f51ff48e54319f5","hostname":"EderCortes"}	2024-11-04 17:49:07
29870	9d692bf5-9f7b-4bf3-96c9-6e06c8d46e72	9d692bf5-cf32-4110-9e14-ce8a6c5fa549	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 14:59:06
29871	9d692bf5-c5d4-48a3-bfc4-4d8ab3d36b61	9d692bf5-cf32-4110-9e14-ce8a6c5fa549	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"62.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:59:06
29872	9d692bf5-c655-4dfb-95c8-93bd188f406d	9d692bf5-cf32-4110-9e14-ce8a6c5fa549	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:59:06
29873	9d692bf5-cd1f-48aa-a78b-bb9e137fe454	9d692bf5-cf32-4110-9e14-ce8a6c5fa549	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 14:59:06
29874	9d692bf5-cda4-44cf-904b-df011c913a88	9d692bf5-cf32-4110-9e14-ce8a6c5fa549	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":655,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:59:06
32650	9d6968c2-cdae-4a40-b5fa-e315adb1b799	9d6968c2-d461-4fd0-8cc0-9452657e871d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '91' order by \\"item_loans\\".\\"id\\" asc","time":"2.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 17:49:07
32651	9d6968c2-d2ee-445d-ba5c-d4977d9eb688	9d6968c2-d461-4fd0-8cc0-9452657e871d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 17:49:07
32652	9d6968c2-d36a-4c70-b008-e2f6e519c738	9d6968c2-d461-4fd0-8cc0-9452657e871d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/91","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":91,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":8,"loans_valor_prestado":5000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"800000","loans_pago_interes":"200000","user_alias":"eder.cortes"},"items":[{"id":371,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 17:44:55","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"200000","itemloans_cuota_cancelada":"800000","user_alias":"eder.cortes"},{"id":403,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":404,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":405,"loans_codigo":91,"itemloans_cuota":"3","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":406,"loans_codigo":91,"itemloans_cuota":"4","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":407,"loans_codigo":91,"itemloans_cuota":"5","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":408,"loans_codigo":91,"itemloans_cuota":"6","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":409,"loans_codigo":91,"itemloans_cuota":"7","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":410,"loans_codigo":91,"itemloans_cuota":"8","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-03-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":316,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:49:07
34434	9d69be46-fc63-4c67-ac40-e0c69f8187b8	9d69be46-fd3f-4455-baa2-123aa25f1c33	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:48:14
32653	9d6968c4-ed5d-4b03-ba16-2886e9906143	9d6968c5-0f6f-4b60-b3f4-74b0f6c6f669	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 17:49:08
32654	9d6968c5-09fa-4b28-8fdd-0534e9718d60	9d6968c5-0f6f-4b60-b3f4-74b0f6c6f669	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 17:49:08
32655	9d6968c5-0a60-4df2-8ede-3f2800236ce9	9d6968c5-0f6f-4b60-b3f4-74b0f6c6f669	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 17:49:08
32656	9d6968c5-0e15-407e-b18f-fae043f7b908	9d6968c5-0f6f-4b60-b3f4-74b0f6c6f669	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 17:49:08
32657	9d6968c5-0e60-4978-90d7-5f3f7e73558b	9d6968c5-0f6f-4b60-b3f4-74b0f6c6f669	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":359,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:49:08
34435	9d69be47-401c-4048-ac5a-cc60cd6b1b7d	9d69be47-5e1b-4a90-af8e-82107e58dc09	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:48:14
34436	9d69be47-5920-48c5-938c-bc6e4c6bc963	9d69be47-5e1b-4a90-af8e-82107e58dc09	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:48:14
34437	9d69be47-5974-4bcf-b576-e32b419eafa0	9d69be47-5e1b-4a90-af8e-82107e58dc09	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:48:14
34438	9d69be47-5cf1-43ea-8fc1-131cc707bcc4	9d69be47-5e1b-4a90-af8e-82107e58dc09	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:48:14
34439	9d69be47-5d33-4b03-abe3-5dc0695158c3	9d69be47-5e1b-4a90-af8e-82107e58dc09	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:48:14
32658	9d696a1f-0522-44e9-acb6-24d478400533	9d696a1f-4ff3-459e-a79d-e1106ef2e91b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 17:52:55
32659	9d696a1f-49b1-4863-a272-506ca3723bf4	9d696a1f-4ff3-459e-a79d-e1106ef2e91b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"143.57","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 17:52:55
32660	9d696a1f-4dfd-4eaa-af52-3dc66dace3eb	9d696a1f-4ff3-459e-a79d-e1106ef2e91b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 17:52:55
32661	9d696a1f-4e8b-4ec2-ba35-b12026377d4d	9d696a1f-4ff3-459e-a79d-e1106ef2e91b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":406,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:52:55
34440	9d69be47-a4c9-453a-a150-f7dcae9f1a4a	9d69be47-ed7f-45b0-9da2-4dbd49c61e36	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:48:14
34441	9d69be47-e725-4850-b519-8f8cdb6f0906	9d69be47-ed7f-45b0-9da2-4dbd49c61e36	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_valor_prestado\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"loans_inicio_pago\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\" from \\"loans\\" where \\"id\\" = '93' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"149.91","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":231,"hash":"7faa80be2c213da5dc19469218099f54","hostname":"EderCortes"}	2024-11-04 21:48:15
34442	9d69be47-e779-47c0-ab58-33f59e674ab0	9d69be47-ed7f-45b0-9da2-4dbd49c61e36	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 21:48:15
34443	9d69be47-e8fa-4280-9c5f-04cc4a4a1225	9d69be47-ed7f-45b0-9da2-4dbd49c61e36	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"1.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":232,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 21:48:15
34444	9d69be47-e929-4266-b3e6-bf7389446e71	9d69be47-ed7f-45b0-9da2-4dbd49c61e36	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 21:48:15
34445	9d69be47-ec5a-4263-a953-8b28caf3a655	9d69be47-ed7f-45b0-9da2-4dbd49c61e36	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:48:15
34446	9d69be47-eca7-4530-8bb0-fb82fda147c1	9d69be47-ed7f-45b0-9da2-4dbd49c61e36	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","user_creador":12,"user_cobrador":22,"user_customer":19,"loans_pago_prestado":"1000000","loans_pago_interes":"250000"},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:19:45.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:22:30.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":399,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":400,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":401,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":402,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"}]}},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:48:15
32662	9d696a7e-7702-4f95-9956-40da98b93c4d	9d696a7e-c03d-4fb2-8cd6-50af21480e8d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 17:53:58
32663	9d696a7e-b7e3-4df9-b239-81af9e74243d	9d696a7e-c03d-4fb2-8cd6-50af21480e8d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 91\\n                        ","time":"141.08","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"9ae30bc69b6b272f3f51ff48e54319f5","hostname":"EderCortes"}	2024-11-04 17:53:58
32664	9d696a7e-bad7-4e7d-b2cd-c02f4d9e8c66	9d696a7e-c03d-4fb2-8cd6-50af21480e8d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '91' order by \\"item_loans\\".\\"id\\" asc","time":"2.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 17:53:58
32665	9d696a7e-be6f-4397-abb3-d26a9c14deb2	9d696a7e-c03d-4fb2-8cd6-50af21480e8d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 17:53:58
27055	9d68e1b7-03ea-4512-9aad-bc04b1148d44	9d68e1b7-29b7-4f2e-ba77-27538b1a068c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 11:31:30
27056	9d68e1b7-2742-40ab-8894-3f7aca48dff2	9d68e1b7-29b7-4f2e-ba77-27538b1a068c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:31:30
27057	9d68e1b7-282d-45be-9661-63f42d491f2c	9d68e1b7-29b7-4f2e-ba77-27538b1a068c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":456,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:31:30
32666	9d696a7e-bef6-419b-8790-e1e8aed4e514	9d696a7e-c03d-4fb2-8cd6-50af21480e8d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/91","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":91,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":8,"loans_valor_prestado":5000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"800000","loans_pago_interes":"200000","user_alias":"eder.cortes"},"items":[{"id":371,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 17:44:55","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"200000","itemloans_cuota_cancelada":"800000","user_alias":"eder.cortes"},{"id":403,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":404,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":405,"loans_codigo":91,"itemloans_cuota":"3","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":406,"loans_codigo":91,"itemloans_cuota":"4","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":407,"loans_codigo":91,"itemloans_cuota":"5","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":408,"loans_codigo":91,"itemloans_cuota":"6","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":409,"loans_codigo":91,"itemloans_cuota":"7","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":410,"loans_codigo":91,"itemloans_cuota":"8","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-03-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:53:58
34447	9d69be49-7870-4626-985d-f59879285fca	9d69be49-cd68-45a9-b688-04dfa874f9a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:48:16
34448	9d69be49-c3ef-49c9-9d06-a1b241104e5d	9d69be49-cd68-45a9-b688-04dfa874f9a6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"142.86","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:48:16
34449	9d69be49-c485-4df0-9664-5a67ed84bcad	9d69be49-cd68-45a9-b688-04dfa874f9a6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:48:16
34450	9d69be49-cb4c-4409-9302-2d66836cc511	9d69be49-cd68-45a9-b688-04dfa874f9a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:48:16
34451	9d69be49-cbd5-497b-b4a4-2cf8b53a59eb	9d69be49-cd68-45a9-b688-04dfa874f9a6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":603,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:48:16
27058	9d68e1b7-c321-4650-adf8-acd63830deb4	9d68e1b8-0b04-4166-a14b-d8b5d7b457a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:31:30
27059	9d68e1b8-0097-44f4-a013-e0193c4e5a97	9d68e1b8-0b04-4166-a14b-d8b5d7b457a5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"144.19","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:31:30
27060	9d68e1b8-04fb-40e7-aeba-6acfa1218bb1	9d68e1b8-0b04-4166-a14b-d8b5d7b457a5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:31:30
27061	9d68e1b8-053b-4d08-b520-545ea959dd30	9d68e1b8-0b04-4166-a14b-d8b5d7b457a5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:31:30
27062	9d68e1b8-09ba-4b5b-abdd-89f1d35fe32b	9d68e1b8-0b04-4166-a14b-d8b5d7b457a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:31:30
27063	9d68e1b8-0a19-4934-9053-c09a8e1bd812	9d68e1b8-0b04-4166-a14b-d8b5d7b457a5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":496,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:31:30
25088	9d68bfb2-8b48-470f-83e6-278cb6a7b7be	9d68bfb2-aba3-4616-85ea-2e3c01cea45e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 09:56:23
25089	9d68bfb2-aa19-4703-b633-44d0343470df	9d68bfb2-aba3-4616-85ea-2e3c01cea45e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 09:56:23
25090	9d68bfb2-aab2-4c5f-85be-7c694a44dc64	9d68bfb2-aba3-4616-85ea-2e3c01cea45e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":375,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:56:23
25091	9d68bfb3-2b19-47cd-860f-27e900c9ec8d	9d68bfb3-4b26-4dec-b37f-49ffd62e3fc1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 09:56:23
25092	9d68bfb3-423b-472e-ba34-f091786a6bb5	9d68bfb3-4b26-4dec-b37f-49ffd62e3fc1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"46.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 09:56:23
25093	9d68bfb3-4607-4e96-906b-30d9fd3c47d2	9d68bfb3-4b26-4dec-b37f-49ffd62e3fc1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:56:23
25094	9d68bfb3-463e-4a80-8423-b8db356f2373	9d68bfb3-4b26-4dec-b37f-49ffd62e3fc1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 09:56:23
25095	9d68bfb3-49f9-4dcb-a47f-8744d09d842f	9d68bfb3-4b26-4dec-b37f-49ffd62e3fc1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 09:56:23
25096	9d68bfb3-4a41-4491-9aaa-96bb1d78d71f	9d68bfb3-4b26-4dec-b37f-49ffd62e3fc1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":352,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":353,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":354,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":355,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:56:23
34885	9d69c0ee-920e-4a99-88ed-2e9dd3b8de81	9d69c0ee-aefa-4bfb-9b38-92aa41735f20	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 21:55:39
34886	9d69c0ee-ad34-42bf-a9e2-28980a4f9ac3	9d69c0ee-aefa-4bfb-9b38-92aa41735f20	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 21:55:39
34887	9d69c0ee-ade0-48d1-bed8-46406ff3ab76	9d69c0ee-aefa-4bfb-9b38-92aa41735f20	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:55:39
38499	9d6b6554-119f-491d-9e41-e4c976f16fbb	9d6b6554-1564-4faf-8253-8537a6a3ea71	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1729}	2024-11-05 17:31:10
31902	9d69572e-25c0-4796-8660-f8c3ba7204de	9d69572e-28c4-4223-904e-d214a3badda3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1526}	2024-11-04 16:59:57
34888	9d69c0ef-0223-4bee-8805-2279669ff803	9d69c0ef-4741-4f23-b609-58ce513f1d95	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 21:55:40
34889	9d69c0ef-425e-499b-a9b1-106af5c7772c	9d69c0ef-4741-4f23-b609-58ce513f1d95	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"143.53","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:55:40
34890	9d69c0ef-42b8-487f-87f0-444a2a9cb039	9d69c0ef-4741-4f23-b609-58ce513f1d95	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:55:40
34891	9d69c0ef-461b-4f10-b993-ab387bf7dc35	9d69c0ef-4741-4f23-b609-58ce513f1d95	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 21:55:40
32782	9d6992e4-c2e9-4c63-8b0e-00ca54ad64d4	9d6992e5-06c5-4ca1-81f5-f99d89060b0a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 19:46:55
32783	9d6992e5-0198-4495-8d95-99682d596be9	9d6992e5-06c5-4ca1-81f5-f99d89060b0a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 19:46:56
32784	9d6992e5-044a-46a9-907c-a769ca438335	9d6992e5-06c5-4ca1-81f5-f99d89060b0a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":642,"memory":22,"hostname":"EderCortes"}	2024-11-04 19:46:56
34892	9d69c0ef-4666-4a70-ac86-fb0b93cd7d25	9d69c0ef-4741-4f23-b609-58ce513f1d95	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:55:40
32785	9d6992e5-fcca-4a8e-8219-adb0c417e5e2	9d6992e6-2ab8-46fd-9d1c-12d2706b5f44	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 19:46:56
32786	9d6992e6-1da0-487c-b0d6-ea14cf4ba7d3	9d6992e6-2ab8-46fd-9d1c-12d2706b5f44	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 91\\n                        ","time":"60.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"9ae30bc69b6b272f3f51ff48e54319f5","hostname":"EderCortes"}	2024-11-04 19:46:56
32787	9d6992e6-21fc-401d-8e29-b1deace88a86	9d6992e6-2ab8-46fd-9d1c-12d2706b5f44	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '91' order by \\"item_loans\\".\\"id\\" asc","time":"3.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 19:46:56
32788	9d6992e6-28f5-4797-b05a-e94eec41af1d	9d6992e6-2ab8-46fd-9d1c-12d2706b5f44	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 19:46:56
30002	9d692db4-9975-41ae-9a58-ecbb825216a1	9d692db4-d054-4775-94d4-1b2ed480acaa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 15:03:59
30003	9d692db4-cd8e-4e7a-9287-e3d9df1ffcdd	9d692db4-d054-4775-94d4-1b2ed480acaa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 15:03:59
30004	9d692db4-cedd-499f-aa2a-3b2022d44539	9d692db4-d054-4775-94d4-1b2ed480acaa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":446,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:03:59
32789	9d6992e6-2978-4fe4-b1df-4abcedd4f6d9	9d6992e6-2ab8-46fd-9d1c-12d2706b5f44	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/91","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":91,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":8,"loans_valor_prestado":5000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"800000","loans_pago_interes":"200000","user_alias":"eder.cortes"},"items":[{"id":371,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 17:44:55","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"200000","itemloans_cuota_cancelada":"800000","user_alias":"eder.cortes"},{"id":403,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":404,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":405,"loans_codigo":91,"itemloans_cuota":"3","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":406,"loans_codigo":91,"itemloans_cuota":"4","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":407,"loans_codigo":91,"itemloans_cuota":"5","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":408,"loans_codigo":91,"itemloans_cuota":"6","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":409,"loans_codigo":91,"itemloans_cuota":"7","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":410,"loans_codigo":91,"itemloans_cuota":"8","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-03-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":520,"memory":22,"hostname":"EderCortes"}	2024-11-04 19:46:56
34893	9d69c0ef-88d3-48ce-a415-c656483ecd43	9d69c0ef-a51d-4ebb-a035-49fdb40fa587	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 21:55:40
34894	9d69c0ef-a048-47c5-9d70-53e8e62d3103	9d69c0ef-a51d-4ebb-a035-49fdb40fa587	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"38.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 21:55:40
34895	9d69c0ef-a099-478e-9829-75a2a9676f8e	9d69c0ef-a51d-4ebb-a035-49fdb40fa587	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 21:55:40
34896	9d69c0ef-a401-45f9-b1f3-7123016fd276	9d69c0ef-a51d-4ebb-a035-49fdb40fa587	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 21:55:40
34897	9d69c0ef-a448-4cc6-813d-1cb61548f2b5	9d69c0ef-a51d-4ebb-a035-49fdb40fa587	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:55:40
30005	9d692db5-5c69-4bd4-8a4e-9eb01fa9a267	9d692db5-8de6-401d-8b27-b399ca3313f8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 15:03:59
30006	9d692db5-8396-4da3-b7f7-7b62a2b18c3b	9d692db5-8de6-401d-8b27-b399ca3313f8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"58.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":56,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 15:03:59
30007	9d692db5-8429-42ce-84ff-8b9a69315020	9d692db5-8de6-401d-8b27-b399ca3313f8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 15:03:59
30008	9d692db5-8bc8-43b9-9559-76634c74d1b3	9d692db5-8de6-401d-8b27-b399ca3313f8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 15:03:59
30009	9d692db5-8c5c-45e7-83c0-3a48551434d3	9d692db5-8de6-401d-8b27-b399ca3313f8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":398,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:03:59
34898	9d69c0ef-e569-4b57-9f1f-fa0decf3d83d	9d69c0f0-2ab7-474d-8059-d6647b733728	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 21:55:40
34899	9d69c0f0-25f0-4ba8-9f5f-3f42012dbc21	9d69c0f0-2ab7-474d-8059-d6647b733728	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"143.66","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:55:40
34900	9d69c0f0-263e-4591-b251-93d4e7980e2f	9d69c0f0-2ab7-474d-8059-d6647b733728	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:55:40
34901	9d69c0f0-2999-4731-98a5-ac34b8c0fbd5	9d69c0f0-2ab7-474d-8059-d6647b733728	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 21:55:40
34902	9d69c0f0-29df-409d-b90c-a3f0a14d33e2	9d69c0f0-2ab7-474d-8059-d6647b733728	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":329,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:55:40
30010	9d692db6-239e-4516-bc17-2031ac73e1b5	9d692db6-804a-4814-9fae-4fcf4a2842c7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 15:04:00
30011	9d692db6-6ed4-42ed-8a62-8d1a8bda376e	9d692db6-804a-4814-9fae-4fcf4a2842c7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"155.12","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:04:00
30012	9d692db6-6f5d-4e24-90d3-815ec41dbd09	9d692db6-804a-4814-9fae-4fcf4a2842c7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:04:00
30013	9d692db6-7ad5-44c0-bc6e-6e502d77e00e	9d692db6-804a-4814-9fae-4fcf4a2842c7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 15:04:00
30014	9d692db6-7be9-45e3-aaeb-f179be5ead90	9d692db6-804a-4814-9fae-4fcf4a2842c7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":590,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:04:00
24731	9d68bc33-eca4-42cc-a71d-13fcdeff7c8a	9d68bc34-1661-4f0b-97e2-f822f511d5e5	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 09:46:36
24732	9d68bc34-13f5-4912-87b0-47f8333f573a	9d68bc34-1661-4f0b-97e2-f822f511d5e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 09:46:36
24733	9d68bc34-1510-43b9-a412-00641822e442	9d68bc34-1661-4f0b-97e2-f822f511d5e5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":424,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:46:36
37953	9d6b5dd3-9f23-4581-85dc-f93b3c05371f	9d6b5dd3-a1d4-4154-8f65-aaceb61d0b74	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1705}	2024-11-05 17:10:12
22189	9d67439a-575d-4d48-a6bd-e86c3632e13c	9d67439a-5cc3-4cbd-b456-72757923d90e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1067}	2024-11-03 16:13:33
24734	9d68bc34-ad89-4631-aeb1-e76c07cbecd5	9d68bc34-f789-48c2-846e-c200f5f6ae85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 09:46:37
24735	9d68bc34-edbe-4071-9ec6-56d8078f59cf	9d68bc34-f789-48c2-846e-c200f5f6ae85	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"151.95","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 09:46:37
24736	9d68bc34-f187-4b1d-bb45-9dd3a6242c3a	9d68bc34-f789-48c2-846e-c200f5f6ae85	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:46:37
24737	9d68bc34-f1cc-4aa4-bf36-a2e551c085b7	9d68bc34-f789-48c2-846e-c200f5f6ae85	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 09:46:37
24738	9d68bc34-f65c-4b37-910d-4fb33e739bf1	9d68bc34-f789-48c2-846e-c200f5f6ae85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 09:46:37
24739	9d68bc34-f6a8-4361-a1b3-19590b125190	9d68bc34-f789-48c2-846e-c200f5f6ae85	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":525,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:46:37
30015	9d692db7-5bf7-4503-85b2-0568f76ecc33	9d692db7-9a70-47d8-9cc9-87e58861041b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 15:04:01
30016	9d692db7-8e9c-4124-b2d9-6d935f66ff6a	9d692db7-9a70-47d8-9cc9-87e58861041b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"94.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:04:01
30017	9d692db7-8f2f-4ffc-aa83-40848cacea8a	9d692db7-9a70-47d8-9cc9-87e58861041b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:04:01
30018	9d692db7-9833-4d04-8301-a1a225960a1f	9d692db7-9a70-47d8-9cc9-87e58861041b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 15:04:01
30019	9d692db7-98d4-4a75-a0b8-81018a3acc00	9d692db7-9a70-47d8-9cc9-87e58861041b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":660,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:04:01
24740	9d68bc37-11a2-461c-977c-99463f5a9adc	9d68bc37-46e3-4c47-a68c-a4371a8c3ee8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 09:46:38
24741	9d68bc37-3a5c-4148-938e-568846bb0031	9d68bc37-46e3-4c47-a68c-a4371a8c3ee8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"59.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:46:38
24742	9d68bc37-3af2-4eeb-b7df-653c6c0bac3a	9d68bc37-46e3-4c47-a68c-a4371a8c3ee8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:46:38
24743	9d68bc37-43c2-4703-9bbe-3b3d9399d344	9d68bc37-46e3-4c47-a68c-a4371a8c3ee8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 09:46:38
24744	9d68bc37-44a6-42e2-9c38-df982f5664b0	9d68bc37-46e3-4c47-a68c-a4371a8c3ee8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":712,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:46:38
40070	9d6cc09c-bac8-422e-834b-97d964dcdbaf	9d6cc09c-bdab-4cef-bb2d-df67f97551dd	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1790}	2024-11-06 09:42:15
24745	9d68bc56-7ef0-4e99-b32d-62c6a4b54200	9d68bc56-8247-489d-899a-b5af61d4d04a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":140,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:46:59
42997	9d6ce35d-884a-4f0a-b730-a69da5195ad6	9d6ce35d-8b4b-4265-b637-8337ce7d8f38	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1976}	2024-11-06 11:19:25
27280	9d68e3d7-15c4-484a-bac0-dc747a03c78b	9d68e3d7-3a80-4ec0-8685-ca8cef6185f6	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 11:37:26
27281	9d68e3d7-389f-41a3-a13c-b0c0879a71a0	9d68e3d7-3a80-4ec0-8685-ca8cef6185f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:37:26
27282	9d68e3d7-3966-4694-b5c1-ef02f2b280cc	9d68e3d7-3a80-4ec0-8685-ca8cef6185f6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":371,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:37:26
18249	9d65bb3e-126a-4128-a27e-6221365c6f3e	9d65bb3e-1564-409b-8abd-a4ae3d8b8829	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":877}	2024-11-02 21:56:26
26271	9d68d052-128f-4b90-9aef-9cf08c75fdca	9d68d052-16a7-4374-a21f-8ff94031e7f0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1214}	2024-11-04 10:42:51
27283	9d68e3d7-d665-4581-b756-bbae2f26f166	9d68e3d7-f74a-4bd0-b559-f4b5ed8cb76f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:37:27
27284	9d68e3d7-f155-4faa-b285-4eabdd4752b2	9d68e3d7-f74a-4bd0-b559-f4b5ed8cb76f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:37:27
27285	9d68e3d7-f1a7-41b0-974c-9c3f3c467765	9d68e3d7-f74a-4bd0-b559-f4b5ed8cb76f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:37:27
27286	9d68e3d7-f5a3-4c3f-a987-05f0cfcefcfe	9d68e3d7-f74a-4bd0-b559-f4b5ed8cb76f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:37:27
27287	9d68e3d7-f5f3-4193-831e-b9367d1cebd0	9d68e3d7-f74a-4bd0-b559-f4b5ed8cb76f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":398,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:37:27
27288	9d68e3d8-6c4e-4a38-9299-cf545d0e0bd6	9d68e3d8-b47c-43f6-9087-cf33bfbd1d05	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:37:27
27289	9d68e3d8-af00-47ad-9c3e-e8bb4dbd0b02	9d68e3d8-b47c-43f6-9087-cf33bfbd1d05	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"148.69","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:37:27
27290	9d68e3d8-af53-4017-aaa9-80f8b32ec678	9d68e3d8-b47c-43f6-9087-cf33bfbd1d05	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 11:37:27
27291	9d68e3d8-b34b-441c-b165-38bffc85d349	9d68e3d8-b47c-43f6-9087-cf33bfbd1d05	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:37:27
27292	9d68e3d8-b394-460c-9522-2383d3a34f24	9d68e3d8-b47c-43f6-9087-cf33bfbd1d05	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":463,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:37:27
30089	9d69337c-f4b1-4fad-bbb6-d406fd006d72	9d69337d-3033-4271-aa6a-6ca410cefe0a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 15:20:09
30090	9d69337d-2d15-4f14-aef6-03328ee7e716	9d69337d-3033-4271-aa6a-6ca410cefe0a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 15:20:09
30091	9d69337d-2e9e-445e-999e-aaa79db678de	9d69337d-3033-4271-aa6a-6ca410cefe0a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":465,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:20:09
25500	9d68c686-83e3-48a9-b77b-d985c4a72630	9d68c686-86a2-459d-ad94-c6ba0beb9fda	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1166}	2024-11-04 10:15:28
8760	9d52eec7-28fb-4396-8186-b23a5827e8c0	9d52eec7-2c05-42da-bfdf-386756ed5287	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":423}	2024-10-24 13:39:49
30092	9d69337d-d15e-4078-8578-b0d81b404a94	9d69337e-05b1-47ba-96f5-0ac7f4e86d37	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 15:20:10
27178	9d68e2b3-b1f1-4860-b420-21fa0681183a	9d68e2b4-0873-4527-a038-d9677c178846	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 11:34:15
25292	9d68c107-98cd-4d6e-98ff-96341e9031ad	9d68c107-f803-4fcc-aac5-079e5456f862	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:00:06
25293	9d68c107-f5a6-4db4-b82b-623cfc8f13cb	9d68c107-f803-4fcc-aac5-079e5456f862	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:00:06
25294	9d68c107-f6ab-4e10-9422-c9f596cef3c4	9d68c107-f803-4fcc-aac5-079e5456f862	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":641,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:00:06
30093	9d69337d-fbcc-4ac7-a6f6-776707f07483	9d69337e-05b1-47ba-96f5-0ac7f4e86d37	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"65.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":56,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 15:20:10
30094	9d69337d-fc59-4381-895f-a3424486cfe4	9d69337e-05b1-47ba-96f5-0ac7f4e86d37	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 15:20:10
27179	9d68e2b4-05e7-438d-812e-ec9d106106df	9d68e2b4-0873-4527-a038-d9677c178846	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:34:16
27180	9d68e2b4-06f3-4d2d-a711-7754a139afe1	9d68e2b4-0873-4527-a038-d9677c178846	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":552,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:34:16
30095	9d69337e-039d-46ee-8ac1-9a72c445f3a9	9d69337e-05b1-47ba-96f5-0ac7f4e86d37	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 15:20:10
30096	9d69337e-0429-495e-a10e-942f871743cd	9d69337e-05b1-47ba-96f5-0ac7f4e86d37	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":455,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:20:10
35097	9d69c226-7431-4cf8-b115-7dcf30ba4d97	9d69c226-bf2b-4f6d-a475-50db19d5200a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:59:04
35098	9d69c226-bd96-4383-b04f-060f19c24df9	9d69c226-bf2b-4f6d-a475-50db19d5200a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:59:04
35099	9d69c226-be39-49d1-aee2-652966fa056d	9d69c226-bf2b-4f6d-a475-50db19d5200a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":403,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:59:04
25295	9d68c109-0589-4169-aa66-40614b7cd629	9d68c109-54e6-453b-83f0-cb950f7f69d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:00:07
25296	9d68c109-49bf-472d-a216-15812cbcd382	9d68c109-54e6-453b-83f0-cb950f7f69d8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"155.56","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:00:07
25297	9d68c109-4ece-4b9e-bf58-10738b12ea05	9d68c109-54e6-453b-83f0-cb950f7f69d8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"3.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:00:07
25298	9d68c109-4f37-4bd7-bb6d-dca8cd2db633	9d68c109-54e6-453b-83f0-cb950f7f69d8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:00:07
21695	9d673db4-9624-4221-b85f-ea4165594fa3	9d673db4-d9f5-4582-a750-5b33ea566e6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 15:57:04
21696	9d673db4-d879-4bd2-95f9-5a51c06d8107	9d673db4-d9f5-4582-a750-5b33ea566e6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 15:57:04
21697	9d673db4-d90e-4bfe-a051-1bf1f4ca92a9	9d673db4-d9f5-4582-a750-5b33ea566e6b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-11-03 15:57:04
25299	9d68c109-53b7-444f-960b-447c7ca3e7fa	9d68c109-54e6-453b-83f0-cb950f7f69d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:00:07
25300	9d68c109-540a-4493-a6e7-baa6a79388a6	9d68c109-54e6-453b-83f0-cb950f7f69d8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":805,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:00:07
30097	9d69337e-d01b-4543-bbce-1866d4e217e2	9d69337f-3a1a-48b5-b159-33c5120ea328	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 15:20:10
27181	9d68e2b4-acf7-43b4-88cf-a6075e4756a8	9d68e2b4-d1cb-45b0-84cb-fae195207959	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:34:16
27182	9d68e2b4-c6f2-41d5-aeff-959bae7b7467	9d68e2b4-d1cb-45b0-84cb-fae195207959	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"51.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:34:16
27183	9d68e2b4-cb90-4dd2-b399-5c6af27346b3	9d68e2b4-d1cb-45b0-84cb-fae195207959	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:34:16
27184	9d68e2b4-cbd6-4e10-abfa-e854ef802ba9	9d68e2b4-d1cb-45b0-84cb-fae195207959	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:34:16
27185	9d68e2b4-d081-4822-af73-7aa5655382ab	9d68e2b4-d1cb-45b0-84cb-fae195207959	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:34:16
35100	9d69c227-1bc4-42fa-b7eb-1631bc676302	9d69c227-6516-4133-80e8-026ff543158f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:59:04
25301	9d68c10a-2362-4e58-84cd-4456e5f51209	9d68c10a-88c8-4a86-9b72-2a812dee1b53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:00:08
25302	9d68c10a-7dfb-4290-a08f-b0a2ff95acb5	9d68c10a-88c8-4a86-9b72-2a812dee1b53	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"180.88","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:00:08
25303	9d68c10a-7e8d-4c5a-a667-1b01d31bd9d1	9d68c10a-88c8-4a86-9b72-2a812dee1b53	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:00:08
25304	9d68c10a-86ac-44b3-afcc-143d49b59560	9d68c10a-88c8-4a86-9b72-2a812dee1b53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:00:08
25305	9d68c10a-8738-4834-b8f6-f9d675c8084d	9d68c10a-88c8-4a86-9b72-2a812dee1b53	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":773,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:00:08
30098	9d69337f-2f70-430e-8c9f-947c3dc0deb8	9d69337f-3a1a-48b5-b159-33c5120ea328	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"180.20","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:20:11
30099	9d69337f-300f-4a37-8c9e-8754279311a8	9d69337f-3a1a-48b5-b159-33c5120ea328	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:20:11
27186	9d68e2b4-d0d3-4ff3-9118-1ffb2c21788e	9d68e2b4-d1cb-45b0-84cb-fae195207959	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":454,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:34:16
30100	9d69337f-37d8-43d5-9d22-e785c8846077	9d69337f-3a1a-48b5-b159-33c5120ea328	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 15:20:11
30101	9d69337f-3870-43bf-b4ba-13298803b502	9d69337f-3a1a-48b5-b159-33c5120ea328	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":757,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:20:11
35101	9d69c227-5fea-4065-8969-6ea64a2cf5b3	9d69c227-6516-4133-80e8-026ff543158f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"146.52","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:59:04
35102	9d69c227-603e-42f0-9513-940dd61473d6	9d69c227-6516-4133-80e8-026ff543158f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:59:04
35103	9d69c227-63ed-4d82-8c63-f9fb235d131b	9d69c227-6516-4133-80e8-026ff543158f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 21:59:04
25306	9d68c10b-a103-4db4-a205-14ba34acc6af	9d68c10b-eeca-49d5-a058-a657c35891d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:00:09
25307	9d68c10b-e92c-46e0-a7b9-99be4c47ee4d	9d68c10b-eeca-49d5-a058-a657c35891d8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"151.60","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:00:09
25308	9d68c10b-e98a-4b3b-8441-8bc3e818ebc4	9d68c10b-eeca-49d5-a058-a657c35891d8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:00:09
25309	9d68c10b-ed12-43d3-96a5-705ce83c46e2	9d68c10b-eeca-49d5-a058-a657c35891d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:00:09
25310	9d68c10b-ed72-456d-9c90-05d84cdb5202	9d68c10b-eeca-49d5-a058-a657c35891d8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":603,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:00:09
30102	9d69337f-c365-49a1-af84-5bc6493c6b59	9d69337f-f70f-4fc6-a7bf-772293bb40be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 15:20:11
30103	9d69337f-ec70-4d8d-a6cc-f7fc32ddd74f	9d69337f-f70f-4fc6-a7bf-772293bb40be	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"69.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:20:11
30104	9d69337f-ecf7-435e-aed8-677ca1533eaf	9d69337f-f70f-4fc6-a7bf-772293bb40be	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:20:11
30105	9d69337f-f4a7-4b20-8349-c138b9ca0456	9d69337f-f70f-4fc6-a7bf-772293bb40be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 15:20:11
30106	9d69337f-f53f-4e1e-8f43-429663321bb7	9d69337f-f70f-4fc6-a7bf-772293bb40be	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":456,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:20:11
35104	9d69c227-6438-4d5a-81b2-28968514d399	9d69c227-6516-4133-80e8-026ff543158f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":360,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:59:04
25311	9d68c11c-ca62-4e61-9fce-a28112a45381	9d68c11c-ebff-4b43-b64e-b59275d928af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:00:20
25312	9d68c11c-e203-467f-a420-077ba7df8c64	9d68c11c-ebff-4b43-b64e-b59275d928af	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 90\\n                        ","time":"46.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"93c10371e33ace24260de21c3ff3890d","hostname":"EderCortes"}	2024-11-04 10:00:20
25313	9d68c11c-e644-4cf2-8ff9-86be6cc7483d	9d68c11c-ebff-4b43-b64e-b59275d928af	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"2.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:00:20
25314	9d68c11c-e681-467f-a6f7-77ebc3801e88	9d68c11c-ebff-4b43-b64e-b59275d928af	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 10:00:20
25315	9d68c11c-eab1-4b2a-af36-353ae6a9496b	9d68c11c-ebff-4b43-b64e-b59275d928af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:00:20
25316	9d68c11c-eb1b-41a9-9422-975c7ea1143e	9d68c11c-ebff-4b43-b64e-b59275d928af	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"220000","loans_pago_interes":"55000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:00:20
30107	9d6933c7-0337-44c5-87de-86ce6b4d6cd1	9d6933c7-06da-4f7d-a141-06f62e31770d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"PUT","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":156,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:20:58
35105	9d69c227-a9ef-47ca-b452-fd41f1a5f673	9d69c227-f26c-44c6-b4b2-17b8a6afc311	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 21:59:05
35106	9d69c227-ed60-4b51-9eaf-9f54b0cc8002	9d69c227-f26c-44c6-b4b2-17b8a6afc311	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"153.54","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 21:59:05
35107	9d69c227-edb3-4cf7-9e19-77b00066856e	9d69c227-f26c-44c6-b4b2-17b8a6afc311	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 21:59:05
35108	9d69c227-f144-4430-9cad-1555d8b6b6eb	9d69c227-f26c-44c6-b4b2-17b8a6afc311	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 21:59:05
35109	9d69c227-f192-413a-95cc-5d6a907f42a8	9d69c227-f26c-44c6-b4b2-17b8a6afc311	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:59:05
30108	9d6933c7-73b8-4953-8cc7-5d0f2d188686	9d6933c7-76ff-4602-a53f-ad9eab7cb283	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"PUT","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"547","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","profile_code":1,"user_age":"29","user_alias":"eder_cortes","email_verified_at":null,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},"session":[],"response_status":404,"response":{"error":"El m\\u00e9todo especificado en la petici\\u00f3n no es val\\u00eddo","code":404},"duration":179,"memory":20,"hostname":"EderCortes"}	2024-11-04 15:20:58
35110	9d69c228-39ca-4e9e-8972-d79222172cdd	9d69c228-801d-4d14-9dca-0051a863133f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 21:59:05
35111	9d69c228-7acd-40f0-8ac0-546b9eac057f	9d69c228-801d-4d14-9dca-0051a863133f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"142.58","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:59:05
35112	9d69c228-7b23-407c-9465-29c44dd59071	9d69c228-801d-4d14-9dca-0051a863133f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:59:05
35113	9d69c228-7f05-4c98-9a78-017adaf0bcf7	9d69c228-801d-4d14-9dca-0051a863133f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 21:59:05
35114	9d69c228-7f4e-40f7-92c8-a01507632acc	9d69c228-801d-4d14-9dca-0051a863133f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":344,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:59:05
43073	9d6ce3fb-079b-4bc2-ba33-f0e2f7706076	9d6ce3fb-0cab-49df-9134-505293eb5b69	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1983}	2024-11-06 11:21:09
35240	9d69c3ae-0dfe-4835-879b-afc946ab9577	9d69c3ae-37e9-45f2-b9bf-20e8c7855e1a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 22:03:20
35241	9d69c3ae-35c4-4113-b5ff-fc668b300079	9d69c3ae-37e9-45f2-b9bf-20e8c7855e1a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 22:03:21
35242	9d69c3ae-36a3-4817-8f8d-f345b16d9bab	9d69c3ae-37e9-45f2-b9bf-20e8c7855e1a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":350,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:03:21
4937	9d513654-396d-4cf3-aff2-4b9987cf755d	9d513654-3e97-4326-9c26-c463d4252b15	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":265}	2024-10-23 17:08:14
10438	9d56cfae-f96b-44d7-b0fa-374b22d6a2bc	9d56cfae-fc5a-4c8a-9d03-16fce105bf06	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":516}	2024-10-26 11:56:10
34200	9d69bba9-f269-4da6-8cd5-02c66bc3f0c0	9d69bbaa-2d56-42a6-955d-fc1b24cc6a3f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:40:56
34201	9d69bbaa-2a86-4313-8318-afcf17a73015	9d69bbaa-2d56-42a6-955d-fc1b24cc6a3f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:40:56
34202	9d69bbaa-2bb7-4cc7-9513-ad7489d620db	9d69bbaa-2d56-42a6-955d-fc1b24cc6a3f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":466,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:40:56
34203	9d69bbaa-d7d1-4c95-b635-c46844b1db43	9d69bbab-0b3e-4bfd-af6a-6bd7c6d22961	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:40:56
34204	9d69bbab-00ea-4477-9501-4e92349bad23	9d69bbab-0b3e-4bfd-af6a-6bd7c6d22961	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"63.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":227,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:40:56
34205	9d69bbab-018b-43a3-97c3-d7e87e5835a4	9d69bbab-0b3e-4bfd-af6a-6bd7c6d22961	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:40:56
34206	9d69bbab-090d-45ea-bd6a-f52ed5e137b7	9d69bbab-0b3e-4bfd-af6a-6bd7c6d22961	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:40:56
34207	9d69bbab-09aa-40c6-b995-ab126da9c5d9	9d69bbab-0b3e-4bfd-af6a-6bd7c6d22961	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":469,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:40:56
35243	9d69c3ae-ae9a-4765-b21d-f8c208e32a42	9d69c3ae-fea7-4d95-9532-43a45a168fc7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 22:03:21
35244	9d69c3ae-f7f4-4c26-bbc0-08b4fc167755	9d69c3ae-fea7-4d95-9532-43a45a168fc7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"159.12","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:03:21
35245	9d69c3ae-f852-4a64-89eb-25a2cba8d1b1	9d69c3ae-fea7-4d95-9532-43a45a168fc7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:03:21
35246	9d69c3ae-fd38-40d5-9c16-2de6daeb6f32	9d69c3ae-fea7-4d95-9532-43a45a168fc7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 22:03:21
35247	9d69c3ae-fd99-427a-8346-032396558578	9d69c3ae-fea7-4d95-9532-43a45a168fc7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":442,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:03:21
34208	9d69bbab-9b20-46de-aec0-d431ae05b4ee	9d69bbab-d924-4c71-893b-b61f00ef9127	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:40:57
34209	9d69bbab-cf41-4792-b70c-885c410ca3dc	9d69bbab-d924-4c71-893b-b61f00ef9127	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"67.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":216,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 21:40:57
34210	9d69bbab-cfd8-496d-a354-6a8620ee7171	9d69bbab-d924-4c71-893b-b61f00ef9127	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 21:40:57
34211	9d69bbab-d728-40bd-955e-714446d4ac5e	9d69bbab-d924-4c71-893b-b61f00ef9127	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:40:57
34212	9d69bbab-d7af-4b4f-8acf-b2efd1572c8b	9d69bbab-d924-4c71-893b-b61f00ef9127	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":501,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:40:57
35248	9d69c3af-5492-4dab-836b-8c8f1e8a2fca	9d69c3af-7717-421b-b173-1901ad9f5cfa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 22:03:21
35249	9d69c3af-702f-4e38-ac19-8159a9af4064	9d69c3af-7717-421b-b173-1901ad9f5cfa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 22:03:21
35250	9d69c3af-7087-4019-b61b-427b02b945c0	9d69c3af-7717-421b-b173-1901ad9f5cfa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 22:03:21
35251	9d69c3af-7542-4537-854b-7d9ce42a4493	9d69c3af-7717-421b-b173-1901ad9f5cfa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 22:03:21
35252	9d69c3af-75cc-4989-accd-0f2742e7fbfe	9d69c3af-7717-421b-b173-1901ad9f5cfa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":281,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:03:21
25417	9d68c2db-ee6c-436e-a6b3-6fd60815edf3	9d68c2dc-17b3-4030-a09d-cab77499f7d1	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 10:05:13
25418	9d68c2dc-1565-45e4-99de-c040a72e18d0	9d68c2dc-17b3-4030-a09d-cab77499f7d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:05:13
25419	9d68c2dc-1681-4a63-92a8-48c486f01b62	9d68c2dc-17b3-4030-a09d-cab77499f7d1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":430,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:05:13
25420	9d68c2dc-b59f-4f87-afdd-8bd7b9de9c7e	9d68c2dc-ffe9-49e8-b3a1-85831a6ca177	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:05:14
25421	9d68c2dc-f5ba-4c44-835f-a583d9742e1c	9d68c2dc-ffe9-49e8-b3a1-85831a6ca177	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"147.26","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:05:14
25422	9d68c2dc-f9a7-4c42-a31a-52b33ba8aff9	9d68c2dc-ffe9-49e8-b3a1-85831a6ca177	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:05:14
25423	9d68c2dc-f9dc-424e-a266-9500118ac185	9d68c2dc-ffe9-49e8-b3a1-85831a6ca177	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:05:14
25424	9d68c2dc-fe7c-4f48-9777-a67e1113a595	9d68c2dc-ffe9-49e8-b3a1-85831a6ca177	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:05:14
25425	9d68c2dc-fed1-4428-be41-ee0053dfd95f	9d68c2dc-ffe9-49e8-b3a1-85831a6ca177	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":538,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:05:14
34213	9d69bbac-57ea-40b6-aa52-0b01ffd443b9	9d69bbac-8393-4037-88ce-f0d7b7a2ad5a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:40:57
34214	9d69bbac-7a2d-4a78-8c6f-bcef6fa27def	9d69bbac-8393-4037-88ce-f0d7b7a2ad5a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"59.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:40:57
34215	9d69bbac-7ab6-4dd5-8de4-2dd905873e4d	9d69bbac-8393-4037-88ce-f0d7b7a2ad5a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:40:57
34216	9d69bbac-81bc-4d42-8068-b72d3a8af22e	9d69bbac-8393-4037-88ce-f0d7b7a2ad5a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 21:40:57
34217	9d69bbac-823a-4203-a4f3-f976f495d1f3	9d69bbac-8393-4037-88ce-f0d7b7a2ad5a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":414,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:40:57
35253	9d69c3af-c5a7-4673-9211-26469de78041	9d69c3af-e6d4-4da7-b6f0-eb00e728c2ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 22:03:22
35254	9d69c3af-e0d0-4933-9ccf-ea0c4bf8c709	9d69c3af-e6d4-4da7-b6f0-eb00e728c2ea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:03:22
35255	9d69c3af-e138-4a44-9774-782925c9c30c	9d69c3af-e6d4-4da7-b6f0-eb00e728c2ea	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:03:22
35256	9d69c3af-e5a8-4889-9e26-cef74d0d2c41	9d69c3af-e6d4-4da7-b6f0-eb00e728c2ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 22:03:22
34218	9d69bbad-564a-4098-9e29-11115fb90538	9d69bbad-d60b-43bc-a73c-62671f7cf822	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 21:40:58
34219	9d69bbad-cc07-4d41-85d1-7d4f67d47d6e	9d69bbad-d60b-43bc-a73c-62671f7cf822	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"155.51","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:40:58
34220	9d69bbad-cc94-428b-9866-999f22229cdc	9d69bbad-d60b-43bc-a73c-62671f7cf822	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:40:58
34221	9d69bbad-d3db-486a-bb43-103e9e334a74	9d69bbad-d60b-43bc-a73c-62671f7cf822	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 21:40:58
34222	9d69bbad-d46f-46aa-9757-ce7f9ebef759	9d69bbad-d60b-43bc-a73c-62671f7cf822	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":844,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:40:58
35257	9d69c3af-e5f5-46c8-ad70-96ea8c36c31f	9d69c3af-e6d4-4da7-b6f0-eb00e728c2ea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":259,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:03:22
34223	9d69bbae-a795-4a7c-9306-5dcd1a805715	9d69bbae-d6a3-427a-9255-fe17871b39f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 21:40:59
34224	9d69bbae-ce5c-42b2-bdcc-91271263d713	9d69bbae-d6a3-427a-9255-fe17871b39f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"64.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:40:59
34225	9d69bbae-cee2-4a6a-ad66-82431c7db23c	9d69bbae-d6a3-427a-9255-fe17871b39f0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:40:59
34226	9d69bbae-d4a9-4bc6-8292-5caaf7f0352f	9d69bbae-d6a3-427a-9255-fe17871b39f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 21:40:59
34227	9d69bbae-d51f-44a0-8a78-e19cdb6a899b	9d69bbae-d6a3-427a-9255-fe17871b39f0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":631,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:40:59
42399	9d6cddd8-4e0e-4286-991e-66927d5536f3	9d6cddd8-519d-4172-bc0a-57d611530b3a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1958}	2024-11-06 11:03:59
23055	9d68012c-525a-490b-9c38-b0241666f57d	9d68012c-9bba-4dd6-b770-240abc50c0b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 01:03:38
23056	9d68012c-9a3d-4ca0-b9e3-450c5d51f203	9d68012c-9bba-4dd6-b770-240abc50c0b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 01:03:38
23057	9d68012c-9ada-4e62-bf15-e82102f7d65a	9d68012c-9bba-4dd6-b770-240abc50c0b4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":395,"memory":22,"hostname":"EderCortes"}	2024-11-04 01:03:38
23058	9d68012c-fd31-4cb6-b32d-c2111fe2fd87	9d68012d-21da-490e-9185-a288b1bdf6a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 01:03:38
23059	9d68012d-1568-4a5e-bc7a-468268803cea	9d68012d-21da-490e-9185-a288b1bdf6a5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 70\\n                        ","time":"48.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"40345ecc36d5b014fbb2cca663c7c347","hostname":"EderCortes"}	2024-11-04 01:03:38
23060	9d68012d-19b0-4611-8931-d61d406964e2	9d68012d-21da-490e-9185-a288b1bdf6a5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '70' order by \\"item_loans\\".\\"id\\" asc","time":"2.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 01:03:38
23061	9d68012d-19fc-47c6-9c74-8dee5dee2984	9d68012d-21da-490e-9185-a288b1bdf6a5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 01:03:38
23062	9d68012d-2008-4a50-a456-4be8ee6e14d9	9d68012d-21da-490e-9185-a288b1bdf6a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 01:03:38
23063	9d68012d-208c-409d-bc88-5f340bb3472b	9d68012d-21da-490e-9185-a288b1bdf6a5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/70","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":70,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":2150000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"430000","loans_pago_interes":"107500"},"items":[{"id":248,"loans_codigo":70,"itemloans_cuota":"1","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:52:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"107500","itemloans_cuota_cancelada":"430000"},{"id":249,"loans_codigo":70,"itemloans_cuota":"2","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":250,"loans_codigo":70,"itemloans_cuota":"3","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":251,"loans_codigo":70,"itemloans_cuota":"4","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":252,"loans_codigo":70,"itemloans_cuota":"5","itemloans_valor_cuota":"430000","itemloans_iteres":"107500","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T05:51:54.000000Z","updated_at":"2024-11-04T05:51:54.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":294,"memory":22,"hostname":"EderCortes"}	2024-11-04 01:03:38
23064	9d68012f-44dc-4762-a1d9-68811f67e515	9d68012f-9dbf-4157-bb7d-df2ef9753ffa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 01:03:40
23065	9d68012f-955f-4460-8d24-f9d061437cd1	9d68012f-9dbf-4157-bb7d-df2ef9753ffa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"166.89","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 01:03:40
23066	9d68012f-95ee-494c-b438-2e8e53c5a70d	9d68012f-9dbf-4157-bb7d-df2ef9753ffa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 01:03:40
23067	9d68012f-9c21-495f-a199-d7befcd431f7	9d68012f-9dbf-4157-bb7d-df2ef9753ffa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 01:03:40
23068	9d68012f-9c80-434e-9cab-49dc266df7a3	9d68012f-9dbf-4157-bb7d-df2ef9753ffa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":523,"memory":22,"hostname":"EderCortes"}	2024-11-04 01:03:40
43037	9d6ce388-a5b9-4f2d-a192-890d2667a2a7	9d6ce388-a8c7-4e4d-870f-43d6e3613a81	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1980}	2024-11-06 11:19:54
35408	9d69c492-2282-4756-ad2c-2070e7c89b8e	9d69c492-48d3-4fec-b602-0f3f1b0ecbb7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 22:05:50
35409	9d69c492-465f-46d0-9972-93f33013e30f	9d69c492-48d3-4fec-b602-0f3f1b0ecbb7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 22:05:50
35410	9d69c492-4798-4588-a247-b2d4e1169ff9	9d69c492-48d3-4fec-b602-0f3f1b0ecbb7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":328,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:05:50
20003	9d66ed1c-2ad1-4b03-94e1-c8cea3fc7167	9d66ed1c-2e3b-4cbe-b056-94fb3e8ab9ec	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":987}	2024-11-03 12:11:42
597	9d4f2d2b-b083-4990-9611-4505898cd01e	9d4f2d2b-b4ad-4d31-8991-b2728beb66c6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":43}	2024-10-22 16:50:58
35411	9d69c492-b3d0-4696-ae23-16a0a9631ceb	9d69c492-db38-4780-8b0e-6510ecd267ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 22:05:50
35412	9d69c492-d3e6-4d4b-884c-ceb56a413125	9d69c492-db38-4780-8b0e-6510ecd267ae	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:05:50
35413	9d69c492-d461-4177-aee0-0b56216ee818	9d69c492-db38-4780-8b0e-6510ecd267ae	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:05:50
35414	9d69c492-d980-4e96-b9cd-2b27f7dcbe29	9d69c492-db38-4780-8b0e-6510ecd267ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 22:05:50
35415	9d69c492-d9eb-4eef-a419-6b365bbe3ced	9d69c492-db38-4780-8b0e-6510ecd267ae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":311,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:05:50
35660	9d69c543-5a32-432b-9099-7c674501da4e	9d69c543-77bf-43df-b463-59d931853f69	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 22:07:46
35661	9d69c543-761f-43d8-b428-0705517fc673	9d69c543-77bf-43df-b463-59d931853f69	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 22:07:46
35662	9d69c543-76b3-488d-98f5-b09eaa92fe1c	9d69c543-77bf-43df-b463-59d931853f69	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:07:46
35416	9d69c493-3c17-4305-971f-84b8c8c6be41	9d69c493-6337-4427-81ab-071cdd6a35e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 22:05:51
35417	9d69c493-5cd4-41d3-8e0a-c9b003d9586e	9d69c493-6337-4427-81ab-071cdd6a35e4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"51.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 22:05:51
35418	9d69c493-5d41-45ea-9e32-8358d2562b3c	9d69c493-6337-4427-81ab-071cdd6a35e4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 22:05:51
30312	9d69398c-ac44-415d-b1bb-2c6f2ccfdd57	9d69398c-e6ea-4921-8848-a064d5cdf1bc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 15:37:06
30313	9d69398c-e3c6-4dc2-8513-711729d9b83d	9d69398c-e6ea-4921-8848-a064d5cdf1bc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 15:37:06
30314	9d69398c-e537-45df-8a48-22a6a967f5df	9d69398c-e6ea-4921-8848-a064d5cdf1bc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":431,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:37:06
35419	9d69c493-619b-4a8e-911e-b6b84708ac5f	9d69c493-6337-4427-81ab-071cdd6a35e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 22:05:51
35420	9d69c493-620f-4774-a336-acf9c5c5df0a	9d69c493-6337-4427-81ab-071cdd6a35e4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":324,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:05:51
35663	9d69c543-cdbc-47e0-98b1-24ac5a52ca5e	9d69c543-eb3e-44b3-83e6-e1a8fc247f7b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 22:07:46
35664	9d69c543-e621-4739-a6c7-595b426a0c60	9d69c543-eb3e-44b3-83e6-e1a8fc247f7b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:07:46
35665	9d69c543-e66c-4248-ba4c-38faf2ca10e9	9d69c543-eb3e-44b3-83e6-e1a8fc247f7b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:07:46
35666	9d69c543-ea15-4845-b3ca-ad5f00acc5df	9d69c543-eb3e-44b3-83e6-e1a8fc247f7b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 22:07:46
35667	9d69c543-ea60-415b-9688-a363a11e1e58	9d69c543-eb3e-44b3-83e6-e1a8fc247f7b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:07:46
35421	9d69c493-c4f3-4535-834e-6e61764dcff0	9d69c493-f1a7-41e7-80df-1254668ec5c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 22:05:51
27462	9d68e567-50b0-4046-b345-3a2df99986bb	9d68e567-7d48-43c9-b566-40a34c43a54f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 11:41:49
27463	9d68e567-7ab7-4139-aef6-ded6deae0b91	9d68e567-7d48-43c9-b566-40a34c43a54f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:41:49
27464	9d68e567-7bcc-495c-b672-fbea4dfc101d	9d68e567-7d48-43c9-b566-40a34c43a54f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":496,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:41:49
35422	9d69c493-e870-4fd1-9f76-c210519dcf79	9d69c493-f1a7-41e7-80df-1254668ec5c2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"54.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:05:51
30315	9d69398d-86aa-490d-9431-f89a7de890ee	9d69398d-b565-40e0-9a4d-cf693205f76e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 15:37:07
35423	9d69c493-e8f1-47b2-a5d9-035cee7d43b9	9d69c493-f1a7-41e7-80df-1254668ec5c2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:05:51
30316	9d69398d-ab70-4cba-b568-c1fc1f366fa2	9d69398d-b565-40e0-9a4d-cf693205f76e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"60.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:37:07
30317	9d69398d-abf8-445e-bba3-e38708f5ab2b	9d69398d-b565-40e0-9a4d-cf693205f76e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:37:07
30318	9d69398d-b312-4c84-b79c-01f1dea0d153	9d69398d-b565-40e0-9a4d-cf693205f76e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 15:37:07
30319	9d69398d-b3b0-4fd9-90e0-64ec6d192389	9d69398d-b565-40e0-9a4d-cf693205f76e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":440,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:37:07
35424	9d69c493-ef56-4027-8dce-cfca46861e04	9d69c493-f1a7-41e7-80df-1254668ec5c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 22:05:51
35425	9d69c493-eff0-4dc5-bf96-45c7bf17bbf7	9d69c493-f1a7-41e7-80df-1254668ec5c2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":341,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:05:51
35668	9d69c544-33be-4f86-ba19-688844be0f73	9d69c544-7d15-4ca1-b638-cb80068d8d09	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 22:07:47
35669	9d69c544-7782-491a-8ab9-d02d6a9c8076	9d69c544-7d15-4ca1-b638-cb80068d8d09	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"152.78","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 22:07:47
35670	9d69c544-77dc-46fe-9117-b154fb550f0e	9d69c544-7d15-4ca1-b638-cb80068d8d09	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 22:07:47
35671	9d69c544-7be3-4d80-8519-38c5e32afafc	9d69c544-7d15-4ca1-b638-cb80068d8d09	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 22:07:47
27465	9d68e568-1b29-4c93-b2c4-e721089b483c	9d68e568-417c-4289-9834-0a749bae7656	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:41:49
27466	9d68e568-34d4-4d78-98ba-1e7da56d0a5f	9d68e568-417c-4289-9834-0a749bae7656	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"49.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:41:49
27467	9d68e568-3981-462f-8963-837b9e699f90	9d68e568-417c-4289-9834-0a749bae7656	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:41:49
27468	9d68e568-39c1-4a02-9fff-227086ca7e6c	9d68e568-417c-4289-9834-0a749bae7656	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:41:49
27469	9d68e568-3fd9-47c2-a323-2daf62e0ce90	9d68e568-417c-4289-9834-0a749bae7656	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:41:49
27470	9d68e568-4053-4136-9f7a-41c826d81477	9d68e568-417c-4289-9834-0a749bae7656	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":447,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:41:49
30320	9d69398e-2de0-4062-9070-d3c69add2dba	9d69398e-5c60-4783-8108-3642eca6441b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 15:37:07
30321	9d69398e-554b-4662-a9ee-bf0a30dcb598	9d69398e-5c60-4783-8108-3642eca6441b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"60.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":56,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 15:37:07
30322	9d69398e-55b7-4778-a47b-4fe2d75a513f	9d69398e-5c60-4783-8108-3642eca6441b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 15:37:07
30323	9d69398e-5ad2-49ea-b715-43817c91b781	9d69398e-5c60-4783-8108-3642eca6441b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 15:37:07
30324	9d69398e-5b49-4d30-a7e0-783771ef04d0	9d69398e-5c60-4783-8108-3642eca6441b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":406,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:37:07
35672	9d69c544-7c2c-4b34-b19c-fdef909a91b3	9d69c544-7d15-4ca1-b638-cb80068d8d09	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":359,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:07:47
30325	9d693990-7f65-4124-a738-f7ee41757e12	9d693990-c752-4900-82ba-1e215bc0f78c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 15:37:08
30326	9d693990-be6f-4e42-9dc8-27727f442482	9d693990-c752-4900-82ba-1e215bc0f78c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"114.35","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:37:09
30327	9d693990-bef5-469d-a3e5-0c7b57e1bb8d	9d693990-c752-4900-82ba-1e215bc0f78c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:37:09
30328	9d693990-c551-456e-afcb-4cf5df04b67f	9d693990-c752-4900-82ba-1e215bc0f78c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 15:37:09
30329	9d693990-c5d1-44d3-a025-d2dd1cd33878	9d693990-c752-4900-82ba-1e215bc0f78c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":511,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:37:09
35673	9d69c544-c8ab-4cc1-b488-952514e9abba	9d69c544-e705-49e5-84cc-fe9b0490853a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 22:07:47
35674	9d69c544-e143-4bd8-8777-4f86883c807e	9d69c544-e705-49e5-84cc-fe9b0490853a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:07:47
35675	9d69c544-e1a7-46da-8c0a-7c65a38c1f3a	9d69c544-e705-49e5-84cc-fe9b0490853a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:07:47
35676	9d69c544-e5e1-4377-8ebf-d76b3c402a15	9d69c544-e705-49e5-84cc-fe9b0490853a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 22:07:47
35677	9d69c544-e628-466d-b463-eb2cfacd7386	9d69c544-e705-49e5-84cc-fe9b0490853a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:07:47
21966	9d67414a-0d8d-4e72-9794-111fdc98a2c8	9d67414a-6a36-4836-93ba-be83bf733205	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-03 16:07:05
21967	9d67414a-6686-4412-bb8a-21365f38ded1	9d67414a-6a36-4836-93ba-be83bf733205	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-03 16:07:05
21968	9d67414a-6828-4951-9831-88148a6118ac	9d67414a-6a36-4836-93ba-be83bf733205	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":554,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:07:05
30330	9d693997-44d0-4fa0-9990-09490ec8fe90	9d693997-49f5-4e0d-8852-d980dc824d69	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/updateUser","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":189,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:37:13
21970	9d67414b-2fa2-4bda-a835-8a09c4d4cd93	9d67414b-43ce-447d-9d70-618c8342e3b1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 68\\n                        ","time":"82.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"7d9994d55cb8dde82ff4185920c79043","hostname":"EderCortes"}	2024-11-03 16:07:06
21971	9d67414b-3760-44b6-8b01-2c060de797da	9d67414b-43ce-447d-9d70-618c8342e3b1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '68' order by \\"item_loans\\".\\"id\\" asc","time":"3.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-03 16:07:06
21972	9d67414b-37d1-43fb-9363-82894298e543	9d67414b-43ce-447d-9d70-618c8342e3b1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-03 16:07:06
21973	9d67414b-41a0-49e0-9e0e-dbe78c9cbf46	9d67414b-43ce-447d-9d70-618c8342e3b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-03 16:07:06
21974	9d67414b-425c-4dc3-aabf-8d173b6b0523	9d67414b-43ce-447d-9d70-618c8342e3b1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/68","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":68,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":10000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"1000000","loans_pago_interes":"250000"},"items":[{"id":227,"loans_codigo":68,"itemloans_cuota":"1","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":228,"loans_codigo":68,"itemloans_cuota":"2","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":229,"loans_codigo":68,"itemloans_cuota":"3","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":230,"loans_codigo":68,"itemloans_cuota":"4","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":231,"loans_codigo":68,"itemloans_cuota":"5","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":232,"loans_codigo":68,"itemloans_cuota":"6","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":233,"loans_codigo":68,"itemloans_cuota":"7","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":234,"loans_codigo":68,"itemloans_cuota":"8","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":235,"loans_codigo":68,"itemloans_cuota":"9","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":236,"loans_codigo":68,"itemloans_cuota":"10","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":474,"memory":22,"hostname":"EderCortes"}	2024-11-03 16:07:06
30331	9d693998-0240-499c-bab3-8e6fcaa51947	9d693998-09a7-4e8c-98c9-a0e231d46c0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 15:37:13
30332	9d693998-0845-4887-b694-100407297f51	9d693998-09a7-4e8c-98c9-a0e231d46c0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 15:37:13
30333	9d693998-088e-4a34-b8f9-1a64955106cd	9d693998-09a7-4e8c-98c9-a0e231d46c0d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/updateUser","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@updateUser","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"547","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","profile_code":1,"user_age":"29","user_alias":"eder_cortes","email_verified_at":null,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},"session":[],"response_status":200,"response":{"user":"ksadjbsadjksajdsadjdsajdsajk"},"duration":177,"memory":20,"hostname":"EderCortes"}	2024-11-04 15:37:13
30334	9d6939ff-7329-4a70-ab48-b51cf5c0cad6	9d6939ff-765c-48f7-83d6-ba9e29b8f67f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/updateUser","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":146,"memory":20,"hostname":"EderCortes"}	2024-11-04 15:38:21
30219	9d6936fe-c343-4df0-9d11-0d32ec8e2aeb	9d6936ff-08b9-47e2-a7a6-1e2d3a84f9ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 15:29:57
30220	9d6936ff-059a-4de4-93e0-81741de74f4d	9d6936ff-08b9-47e2-a7a6-1e2d3a84f9ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 15:29:58
25613	9d68c767-fa09-4d5b-b8e5-0e0675598365	9d68c768-4de3-42ac-8627-ffbcc23471c8	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 10:17:56
25614	9d68c768-4b00-414d-b5e0-1c239b02bc52	9d68c768-4de3-42ac-8627-ffbcc23471c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:17:56
25615	9d68c768-4c57-4092-8912-8e468af69f18	9d68c768-4de3-42ac-8627-ffbcc23471c8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":533,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:17:56
30221	9d6936ff-0708-4f66-baea-2eb27889a131	9d6936ff-08b9-47e2-a7a6-1e2d3a84f9ff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":481,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:29:58
14272	9d5d195c-34ab-40dc-bc40-0ba69ee82fa1	9d5d195c-3831-4f4e-9b8a-0114595b29fe	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":652}	2024-10-29 14:57:09
30450	9d693f90-9df5-44a5-9cb5-879ff7692bbd	9d693f90-decb-4d8f-a613-42efa74b50c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 15:53:55
30451	9d693f90-db8b-44ac-88d6-a9b49308a18e	9d693f90-decb-4d8f-a613-42efa74b50c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 15:53:55
30452	9d693f90-dd0f-4a32-b775-c059661e1713	9d693f90-decb-4d8f-a613-42efa74b50c9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":584,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:53:55
25616	9d68c768-f7fe-45fd-9491-725bff7d1361	9d68c769-1a62-4016-bf61-d620efc95773	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:17:57
25617	9d68c769-0f16-44ac-97f5-b71010d47d60	9d68c769-1a62-4016-bf61-d620efc95773	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"43.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:17:57
25618	9d68c769-1376-41a8-a0ea-401a85b21de7	9d68c769-1a62-4016-bf61-d620efc95773	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:17:57
25619	9d68c769-13b2-4dc5-830f-1f8842dfb7e4	9d68c769-1a62-4016-bf61-d620efc95773	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:17:57
25620	9d68c769-18dc-41c0-ab2e-5b9bf32cced0	9d68c769-1a62-4016-bf61-d620efc95773	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:17:57
25621	9d68c769-192f-47c8-9f2e-5bff8e4cd988	9d68c769-1a62-4016-bf61-d620efc95773	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":471,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:17:57
30222	9d6936ff-b7ca-4ae1-9e06-26c0b1c12480	9d6936ff-eacd-40e2-9430-b70c1493725a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 15:29:58
30223	9d6936ff-e09c-445c-8343-5aac918e2c0e	9d6936ff-eacd-40e2-9430-b70c1493725a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"56.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":56,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 15:29:58
30224	9d6936ff-e11e-4d1a-a1a2-1709f3f66e5f	9d6936ff-eacd-40e2-9430-b70c1493725a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 15:29:58
30225	9d6936ff-e836-4345-bcac-2108bf956a01	9d6936ff-eacd-40e2-9430-b70c1493725a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 15:29:58
30226	9d6936ff-e8c8-4449-9cc0-35ac8a5378c1	9d6936ff-eacd-40e2-9430-b70c1493725a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":483,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:29:58
30335	9d6939ff-deeb-4f34-83e4-ac076a654fa1	9d6939ff-ed77-4efe-9961-ceed16cc8e2f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 15:38:21
30336	9d6939ff-ebfd-4e80-9af4-3ec342287a83	9d6939ff-ed77-4efe-9961-ceed16cc8e2f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:38:22
30337	9d6939ff-ec59-4a51-bcad-5557946ac908	9d6939ff-ed77-4efe-9961-ceed16cc8e2f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/updateUser","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@updateUser","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"547","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","profile_code":1,"user_age":"29","user_alias":"eder_cortes","email_verified_at":null,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","profile_code":1,"user_age":"29","user_alias":"eder_cortes","email_verified_at":null,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null}},"duration":199,"memory":20,"hostname":"EderCortes"}	2024-11-04 15:38:22
30227	9d693701-1664-4ed7-8a6c-238ee5b7e04d	9d693701-a34e-448b-8558-88f7e1fd696a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 15:29:59
30228	9d693701-9692-4a2a-9d73-465123f53a3c	9d693701-a34e-448b-8558-88f7e1fd696a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"266.71","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:29:59
30229	9d693701-9747-4c1c-8cb2-c973c1cca461	9d693701-a34e-448b-8558-88f7e1fd696a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:29:59
30230	9d693701-9f9a-4f47-a498-5fb26fd49ba4	9d693701-a34e-448b-8558-88f7e1fd696a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 15:29:59
30231	9d693701-a050-4743-92f4-8b13c66e5da0	9d693701-a34e-448b-8558-88f7e1fd696a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1094,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:29:59
30338	9d693b17-f0cb-4ffe-a88c-7d59d991b8b5	9d693b17-f4e9-4e98-8ffa-96f4e830d182	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/updateUser","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":189,"memory":20,"hostname":"EderCortes"}	2024-11-04 15:41:25
30453	9d693f91-fe0d-4cd2-884b-aaa09f8b44f7	9d693f92-2724-4672-acce-61492a711223	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 15:53:56
30454	9d693f92-1c6d-4246-b0ef-7d35443ee6bc	9d693f92-2724-4672-acce-61492a711223	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"59.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 15:53:56
30455	9d693f92-20de-4787-9c3e-474ccc4ac627	9d693f92-2724-4672-acce-61492a711223	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 15:53:56
30456	9d693f92-211a-45da-a759-06fab4c645d9	9d693f92-2724-4672-acce-61492a711223	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 15:53:56
30457	9d693f92-25d2-497c-bd56-e18759eb04b8	9d693f92-2724-4672-acce-61492a711223	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 15:53:56
30458	9d693f92-2639-4b53-be0f-50ef464e69db	9d693f92-2724-4672-acce-61492a711223	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":740,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:53:56
30232	9d693702-7763-4bf5-9a64-a0c6398ce1fe	9d693702-fd50-4748-93cf-79df9b20c72c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 15:30:00
30233	9d693702-f130-413f-b820-c4394b02b147	9d693702-fd50-4748-93cf-79df9b20c72c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"195.94","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:30:00
30234	9d693702-f1c0-4704-b57f-29e82ea3523d	9d693702-fd50-4748-93cf-79df9b20c72c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:30:00
30235	9d693702-fafe-452a-a21f-15909434fa3c	9d693702-fd50-4748-93cf-79df9b20c72c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 15:30:00
30236	9d693702-fb9e-40d8-b78d-4e605ec5b80a	9d693702-fd50-4748-93cf-79df9b20c72c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":858,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:30:00
30339	9d693b18-559d-42cd-a6bf-d0b5f1b3ac78	9d693b18-5908-4532-8b3a-5a28f3c505e8	70ce7db5dc3490210e122653201ee172	t	exception	{"class":"Error","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":84,"message":"Call to a member function find() on null","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"75":"    {","76":"        return response()->json([","77":"            \\"user\\" => $request->all()","78":"        ]);","79":"    }","80":"","81":"    public function updateUser(Request $request)","82":"    {","83":"","84":"        $data = User::updated($request->all())->find($request->all()['id']);","85":"","86":"        return response()->json([","87":"            \\"user\\" =>$data","88":"        ]);","89":"    }","90":"","91":"    \\/**","92":"     * Remove the specified resource from storage.","93":"     *\\/","94":"    public function destroy(string $id)"},"hostname":"EderCortes","occurrences":1}	2024-11-04 15:41:25
30340	9d693b18-49f3-4e54-916e-4e4ce47d9afa	9d693b18-5908-4532-8b3a-5a28f3c505e8	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 15:41:25
30341	9d693b18-5723-4730-92d5-e90c139c4d99	9d693b18-5908-4532-8b3a-5a28f3c505e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:41:25
30342	9d693b18-57c9-4807-a988-aea9ffcd1a8b	9d693b18-5908-4532-8b3a-5a28f3c505e8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/updateUser","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@updateUser","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"547","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","profile_code":1,"user_age":"29","user_alias":"eder_cortes","email_verified_at":null,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},"session":[],"response_status":500,"response":{"message":"Call to a member function find() on null","exception":"Error","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":84,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"updateUser","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":195,"memory":20,"hostname":"EderCortes"}	2024-11-04 15:41:25
30459	9d693f92-d7b8-4dcd-95f0-f0e4362dfad3	9d693f93-09f0-41c2-b49c-de0a087df266	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 15:53:57
30460	9d693f93-01ac-4d21-a410-01f481f78e23	9d693f93-09f0-41c2-b49c-de0a087df266	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"58.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:53:57
30461	9d693f93-022b-4b61-ac9c-d75f5bc32c98	9d693f93-09f0-41c2-b49c-de0a087df266	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:53:57
30462	9d693f93-0877-4a97-8c29-373cb2830e0a	9d693f93-09f0-41c2-b49c-de0a087df266	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 15:53:57
30463	9d693f93-08d8-4737-b193-cea37826b60b	9d693f93-09f0-41c2-b49c-de0a087df266	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":554,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:53:57
25793	9d68c94e-1f8f-41ed-9e29-6cbcec179c5e	9d68c94e-454e-4b52-abc8-48814cfd1e9e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 10:23:15
25794	9d68c94e-438f-4091-afc4-eda209afa734	9d68c94e-454e-4b52-abc8-48814cfd1e9e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:23:15
25795	9d68c94e-4441-493d-b443-40dac0706149	9d68c94e-454e-4b52-abc8-48814cfd1e9e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":410,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:23:15
15286	9d5ecf82-9ce5-47fa-ad92-c7acda088332	9d5ecf82-a24d-4ad9-a742-6cac03144dee	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":693}	2024-10-30 11:22:19
29875	9d692c04-ef24-4627-9d6c-6b88e77ce8ad	9d692c04-f250-4a73-86d6-17a6239a549f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1416}	2024-11-04 14:59:16
25796	9d68c94e-d386-4a84-a545-44d1f767b934	9d68c94f-22c5-4c88-8255-b2abb055f72d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:23:15
25797	9d68c94f-18c3-4ffc-805d-e1587a36142f	9d68c94f-22c5-4c88-8255-b2abb055f72d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"160.20","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:23:15
25798	9d68c94f-1d3b-4039-af76-7c7e98de0d11	9d68c94f-22c5-4c88-8255-b2abb055f72d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:23:15
25799	9d68c94f-1d70-4d87-9935-5049818294e0	9d68c94f-22c5-4c88-8255-b2abb055f72d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:23:15
25800	9d68c94f-2155-4649-a523-3e63282278db	9d68c94f-22c5-4c88-8255-b2abb055f72d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:23:15
25801	9d68c94f-21ad-4e19-b82f-0fe1e9c8cd19	9d68c94f-22c5-4c88-8255-b2abb055f72d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":514,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:23:15
30237	9d69370a-4c85-427c-b326-4b1dea64611c	9d69370a-500c-49f4-8987-c5c934d80a6d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/update-users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"PUT","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":157,"memory":20,"hostname":"EderCortes"}	2024-11-04 15:30:05
30343	9d693b7b-3627-4066-8ed0-4ff16ec59976	9d693b7b-39e4-4e13-9587-ca0daaaf79ec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/updateUser","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":185,"memory":20,"hostname":"EderCortes"}	2024-11-04 15:42:30
30464	9d693f93-eabd-4e25-a83f-256feb2362b2	9d693f94-1e3a-41d6-8052-b7b020e88781	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 15:53:57
30465	9d693f94-13a9-4d12-947d-199cc9abfa79	9d693f94-1e3a-41d6-8052-b7b020e88781	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"63.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:53:57
30466	9d693f94-1431-443e-bb43-a5d67ecba46c	9d693f94-1e3a-41d6-8052-b7b020e88781	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:53:57
30467	9d693f94-1c10-4abd-9ef8-13bf62dac4b6	9d693f94-1e3a-41d6-8052-b7b020e88781	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 15:53:57
30238	9d69370a-b0ef-48b8-9fd8-324197cfc06f	9d69370a-b3f9-4617-9268-599fd5181fdc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/update-users","method":"PUT","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"547","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","profile_code":1,"user_age":"29","user_alias":"eder_cortes","email_verified_at":null,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},"session":[],"response_status":404,"response":{"error":"El m\\u00e9todo especificado en la petici\\u00f3n no es val\\u00eddo","code":404},"duration":155,"memory":20,"hostname":"EderCortes"}	2024-11-04 15:30:05
30344	9d693b7b-b7c8-4c3a-b8fe-302093dd8e70	9d693b7b-c366-422e-a3b0-219912b2fff0	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 15:42:30
30345	9d693b7b-c1e0-4735-84f4-525e538f6410	9d693b7b-c366-422e-a3b0-219912b2fff0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:42:30
30346	9d693b7b-c236-4d20-a660-75e0e7ff617d	9d693b7b-c366-422e-a3b0-219912b2fff0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/updateUser","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@updateUser","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"547","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","profile_code":1,"user_age":"29","user_alias":"eder_cortes","email_verified_at":null,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},"session":[],"response_status":200,"response":{"user":12},"duration":185,"memory":20,"hostname":"EderCortes"}	2024-11-04 15:42:30
30468	9d693f94-1cac-4697-b9bf-4a7644c691d3	9d693f94-1e3a-41d6-8052-b7b020e88781	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":439,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:53:57
30347	9d693bc9-d740-4bdf-b0e9-32f97299e882	9d693bc9-dc75-4dca-bddc-63b2683cce5b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/updateUser","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":232,"memory":20,"hostname":"EderCortes"}	2024-11-04 15:43:22
41839	9d6ccfed-5854-411a-a234-69b90f8185fc	9d6ccfed-5b20-4326-930a-6d9e1abada42	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1936}	2024-11-06 10:25:04
30348	9d693bca-a11e-44bb-ad5a-093f89931d03	9d693bca-f2d5-466f-8427-2610b3a62836	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:43:22
30349	9d693bca-eb38-4730-be4d-e66d069c02b7	9d693bca-f2d5-466f-8427-2610b3a62836	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = 12 and \\"users\\".\\"deleted_at\\" is null limit 1","time":"159.49","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":84,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 15:43:22
30350	9d693bca-eb9a-4bf2-a624-f03c27643c79	9d693bca-f2d5-466f-8427-2610b3a62836	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 15:43:22
30351	9d693bca-f118-493d-8fa2-5324b71b4201	9d693bca-f2d5-466f-8427-2610b3a62836	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 15:43:22
30352	9d693bca-f188-4d81-905e-34e74bc3c03d	9d693bca-f2d5-466f-8427-2610b3a62836	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/updateUser","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@updateUser","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"547","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","profile_code":1,"user_age":"29","user_alias":"eder_cortes","email_verified_at":null,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":411,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:43:22
30353	9d693c22-6589-4f30-a2e7-3ed110d786ad	9d693c22-6957-4652-9645-1fc51aea2f97	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/updateUser","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":169,"memory":20,"hostname":"EderCortes"}	2024-11-04 15:44:20
30354	9d693c23-2023-4aad-976a-81b1610e8753	9d693c23-6be6-4539-85b2-17b5888d3d0a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 15:44:20
30355	9d693c23-6517-4001-ada8-c86595581b36	9d693c23-6be6-4539-85b2-17b5888d3d0a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = 12 and \\"users\\".\\"deleted_at\\" is null limit 1","time":"140.72","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":84,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 15:44:20
30356	9d693c23-6584-4ccf-8b12-d41e52ca25ff	9d693c23-6be6-4539-85b2-17b5888d3d0a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 15:44:20
30357	9d693c23-6a20-4a05-8d74-bbc55ecda4eb	9d693c23-6be6-4539-85b2-17b5888d3d0a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:44:20
30358	9d693c23-6a73-4a74-95be-dcf1dddd6b9a	9d693c23-6be6-4539-85b2-17b5888d3d0a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/updateUser","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@updateUser","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"547","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","profile_code":1,"user_age":"29","user_alias":"eder_cortes","email_verified_at":null,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},"session":[],"response_status":200,"response":{"user":true},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:44:20
30359	9d693c3f-81c2-4201-9301-dec94348b3a1	9d693c3f-856c-41c7-a9d5-abb071c6292d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/updateUser","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":206,"memory":20,"hostname":"EderCortes"}	2024-11-04 15:44:39
30360	9d693c40-43ad-44af-ae98-01c1e51aaa84	9d693c40-6925-47af-ad4a-5936d645c15a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:44:39
30361	9d693c40-5c0d-42c1-b5f4-c24ff4994519	9d693c40-6925-47af-ad4a-5936d645c15a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = 12 and \\"users\\".\\"deleted_at\\" is null limit 1","time":"39.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":84,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 15:44:39
30362	9d693c40-5c60-408d-8739-a974bdee9326	9d693c40-6925-47af-ad4a-5936d645c15a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 15:44:39
30363	9d693c40-5e1d-4c6e-80c3-878cde415a53	9d693c40-6925-47af-ad4a-5936d645c15a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"users\\" set \\"user_last_name_two\\" = 'Cab', \\"updated_at\\" = '2024-11-04 15:44:39' where \\"id\\" = 12","time":"2.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":86,"hash":"6c5f5292e9aba11e11618efb64995341","hostname":"EderCortes"}	2024-11-04 15:44:39
30364	9d693c40-6452-4bfe-96b4-d40d07a4fc42	9d693c40-6925-47af-ad4a-5936d645c15a	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\User:12","changes":{"user_last_name_two":"Cab","updated_at":"2024-11-04 15:44:39"},"hostname":"EderCortes"}	2024-11-04 15:44:39
30365	9d693c40-6795-4822-8dd0-9de4b8a730ee	9d693c40-6925-47af-ad4a-5936d645c15a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 15:44:39
30366	9d693c40-67e2-4ab8-968b-cfbf94cb91b7	9d693c40-6925-47af-ad4a-5936d645c15a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/updateUser","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@updateUser","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"543","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cab","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","profile_code":1,"user_age":"29","user_alias":"eder_cortes","email_verified_at":null,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},"session":[],"response_status":200,"response":{"user":true},"duration":263,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:44:39
35915	9d69c867-8d29-4e9f-9bf5-207c320d8105	9d69c867-b05a-4fdb-be1d-f4d5410a29df	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 22:16:33
35916	9d69c867-ae71-4f8c-90ba-c4aeffa52229	9d69c867-b05a-4fdb-be1d-f4d5410a29df	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 22:16:33
35917	9d69c867-af39-4058-a958-966ecc953ace	9d69c867-b05a-4fdb-be1d-f4d5410a29df	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:16:33
18646	9d669896-dc0e-418a-b928-7b0542403cb4	9d669896-e02a-451d-9bf0-d05ac3ca57b9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":899}	2024-11-03 08:15:22
35918	9d69c868-10ee-488f-88a5-806ab1cbbef6	9d69c868-2ff1-4091-9b31-1b5ea371dc09	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 22:16:33
35919	9d69c868-29bc-4922-84cd-1ab911c2c319	9d69c868-2ff1-4091-9b31-1b5ea371dc09	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '22' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"40.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":74,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 22:16:33
35920	9d69c868-2a12-45bd-b6af-ba984af03e63	9d69c868-2ff1-4091-9b31-1b5ea371dc09	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 22:16:33
35921	9d69c868-2e95-456f-8955-edb0f22abc80	9d69c868-2ff1-4091-9b31-1b5ea371dc09	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 22:16:33
35922	9d69c868-2eea-4e91-a3b5-f0a02c3bde79	9d69c868-2ff1-4091-9b31-1b5ea371dc09	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/22","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:16:33
36063	9d69c929-bcb8-40ee-a76d-7d6816319cc8	9d69c929-dba4-4fbe-902f-fec365155d62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 22:18:40
36064	9d69c929-d9db-41b2-9038-78064f54b131	9d69c929-dba4-4fbe-902f-fec365155d62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 22:18:40
36065	9d69c929-da92-435d-86e9-de3804c03b99	9d69c929-dba4-4fbe-902f-fec365155d62	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":263,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:18:40
36066	9d69c92a-49ec-42b8-a8a2-652095dd2ce2	9d69c92a-6e93-41b7-b9eb-e13b5c7cb428	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 22:18:41
36067	9d69c92a-6959-4621-b25d-505f609c65cd	9d69c92a-6e93-41b7-b9eb-e13b5c7cb428	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"56.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 22:18:41
36068	9d69c92a-6d00-4dc6-9c46-50be939d1945	9d69c92a-6e93-41b7-b9eb-e13b5c7cb428	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 22:18:41
36069	9d69c92a-6d8f-4dcb-a007-1d5151cb1ffb	9d69c92a-6e93-41b7-b9eb-e13b5c7cb428	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":312,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:18:41
36070	9d69c92a-c8bc-409f-82ff-45c8a9f32ed2	9d69c92a-e946-4acd-b610-958ac6f47ff1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 22:18:41
36071	9d69c92a-e43b-4fed-8e9b-9d224497109e	9d69c92a-e946-4acd-b610-958ac6f47ff1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:18:41
36072	9d69c92a-e492-4dff-b54a-6bd9c2f6dcce	9d69c92a-e946-4acd-b610-958ac6f47ff1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 22:18:41
36073	9d69c92a-e816-405e-8fed-c27035c2f2d5	9d69c92a-e946-4acd-b610-958ac6f47ff1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 22:18:41
36074	9d69c92a-e861-4cf3-bae3-2667f287d57f	9d69c92a-e946-4acd-b610-958ac6f47ff1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":305,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:18:41
30624	9d694125-a080-4a9d-a802-0ca529203a64	9d694125-d5fb-4cb8-a826-2a799702b38a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 15:58:21
30625	9d694125-d324-4947-b493-135c981b326b	9d694125-d5fb-4cb8-a826-2a799702b38a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 15:58:21
30626	9d694125-d485-4b5d-9b37-02bfcde75e22	9d694125-d5fb-4cb8-a826-2a799702b38a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":433,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:58:21
35636	9d69c53a-0c59-4757-b75b-5f0375f62909	9d69c53a-1125-4398-802a-db8eca208f80	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1616}	2024-11-04 22:07:40
29914	9d692c16-6c7f-46c5-b5c1-838ef85d7573	9d692c16-7234-4320-ac5e-05853bc4f3af	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1419}	2024-11-04 14:59:27
30627	9d694126-874f-4844-8806-9da0a28fce54	9d694126-e1e0-4faa-8636-632ffa3f801c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 15:58:21
30628	9d694126-d81e-45ef-801c-cf28ce92aec6	9d694126-e1e0-4faa-8636-632ffa3f801c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"165.35","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":73,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 15:58:21
30629	9d694126-d8b5-4b29-8be7-3210087203ce	9d694126-e1e0-4faa-8636-632ffa3f801c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 15:58:21
30630	9d694126-dfe7-4c46-a22e-69a3fab2968c	9d694126-e1e0-4faa-8636-632ffa3f801c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 15:58:21
30631	9d694126-e078-41ae-afaf-3af598178b31	9d694126-e1e0-4faa-8636-632ffa3f801c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:55:01.000000Z","deleted_at":null,"user_alias":"eder.cortes"}},"duration":593,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:58:21
36075	9d69c92b-379a-4bb4-ac8f-c284ba320bd4	9d69c92b-5ab9-4e61-b147-b9200179273e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 22:18:41
36076	9d69c92b-5524-4bf0-86e0-1090ff83d57c	9d69c92b-5ab9-4e61-b147-b9200179273e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:18:41
36077	9d69c92b-558c-4ae7-bc52-bc728b148ee8	9d69c92b-5ab9-4e61-b147-b9200179273e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 22:18:41
36078	9d69c92b-5955-4d95-8d77-a0d64c9ed946	9d69c92b-5ab9-4e61-b147-b9200179273e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 22:18:41
36079	9d69c92b-59a9-459d-94c1-bcdfa6bf9ab2	9d69c92b-5ab9-4e61-b147-b9200179273e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":271,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:18:41
27749	9d68e956-13d0-42b7-9d76-4766c32b5f30	9d68e956-3214-4ac0-b027-b438823020c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 11:52:48
27750	9d68e956-3078-46f6-af39-eef6292483bb	9d68e956-3214-4ac0-b027-b438823020c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 11:52:48
27751	9d68e956-3119-4747-ab5d-32e284581277	9d68e956-3214-4ac0-b027-b438823020c0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":372,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:52:48
27752	9d68e956-b146-4f8c-8486-3698a112f29a	9d68e956-fa15-4a44-9513-0f7f4281b340	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 11:52:49
27753	9d68e956-f054-496a-8e82-ab13528b6a04	9d68e956-fa15-4a44-9513-0f7f4281b340	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"148.48","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:52:49
27754	9d68e956-f489-4abe-bba2-539a76eab654	9d68e956-fa15-4a44-9513-0f7f4281b340	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:52:49
27755	9d68e956-f4c2-45e8-84c8-532e75066130	9d68e956-fa15-4a44-9513-0f7f4281b340	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:52:49
27756	9d68e956-f8a3-4f4c-b281-08bbff1434da	9d68e956-fa15-4a44-9513-0f7f4281b340	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 11:52:49
27757	9d68e956-f8fe-41a3-99d6-ae21c4f731ef	9d68e956-fa15-4a44-9513-0f7f4281b340	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":460,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:52:49
30632	9d694127-d507-490a-8885-73a246710c12	9d694128-2119-4527-a16c-e446b614fee3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 15:58:22
30633	9d694128-13b5-49de-a2bf-eadb64159a48	9d694128-2119-4527-a16c-e446b614fee3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"100.36","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:58:22
30634	9d694128-148b-4cee-b87d-8b40e733a424	9d694128-2119-4527-a16c-e446b614fee3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:58:22
30635	9d694128-1dbe-42b3-a766-c2f605540a64	9d694128-2119-4527-a16c-e446b614fee3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 15:58:22
30636	9d694128-1e84-48e4-9b61-e21385e4e012	9d694128-2119-4527-a16c-e446b614fee3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":788,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:58:22
36080	9d69c92d-6fbb-420c-a02e-e0f302e84d4a	9d69c92d-8b0f-4983-894a-ed0962acb0b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 22:18:43
36081	9d69c92d-865f-4dbd-b8bd-fc534d728b88	9d69c92d-8b0f-4983-894a-ed0962acb0b6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"39.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:18:43
36082	9d69c92d-86ad-4136-9070-8f7168ec86e6	9d69c92d-8b0f-4983-894a-ed0962acb0b6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:18:43
30637	9d694129-0b55-4eb2-9331-1ac5bf3dd8b3	9d694129-3ab0-465d-8f65-779cb4096d59	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 15:58:23
30638	9d694129-32b0-4182-9aee-d799f52a05d4	9d694129-3ab0-465d-8f65-779cb4096d59	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"60.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:58:23
30639	9d694129-3318-48c4-966a-8101fbcfb053	9d694129-3ab0-465d-8f65-779cb4096d59	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:58:23
30640	9d694129-3889-4008-bb18-41581a509d82	9d694129-3ab0-465d-8f65-779cb4096d59	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 15:58:23
30641	9d694129-3911-46af-99d5-a01281bd22ba	9d694129-3ab0-465d-8f65-779cb4096d59	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":691,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:58:23
36083	9d69c92d-89d2-4b1b-a26e-ebd8956a0804	9d69c92d-8b0f-4983-894a-ed0962acb0b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 22:18:43
36084	9d69c92d-8a17-49b9-b395-1392403296c3	9d69c92d-8b0f-4983-894a-ed0962acb0b6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":390,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:18:43
23676	9d689b7b-053f-45b3-9523-94066c42c015	9d689b7b-25e1-43d5-b781-9e2c2b49e855	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 08:15:06
23677	9d689b7b-2415-4849-b10c-e7562e3bc52d	9d689b7b-25e1-43d5-b781-9e2c2b49e855	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 08:15:06
23678	9d689b7b-24d9-4a0f-8b4e-c847637a95e3	9d689b7b-25e1-43d5-b781-9e2c2b49e855	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":260,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:15:06
30642	9d694136-7e90-41bd-88b7-f7a2f70efc67	9d694136-9fb1-4595-b725-f6f7424f7746	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 15:58:32
30643	9d694136-9a61-4a19-ac15-9b272fa83474	9d694136-9fb1-4595-b725-f6f7424f7746	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"54.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 15:58:32
30644	9d694136-9ded-4bac-8efe-f786fa475432	9d694136-9fb1-4595-b725-f6f7424f7746	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 15:58:32
30645	9d694136-9e68-40d7-8f93-fd761f0a59dc	9d694136-9fb1-4595-b725-f6f7424f7746	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":311,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:58:32
36085	9d69cab8-3b3c-4884-a90e-22baec39a104	9d69cab8-5ef5-4fce-853c-d898ddf6eb2e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 22:23:01
23680	9d689b7b-9418-4b4a-967d-459bcc1abd23	9d689b7b-9d99-4443-8576-68c84a1dccb3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 68\\n                        ","time":"44.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"7d9994d55cb8dde82ff4185920c79043","hostname":"EderCortes"}	2024-11-04 08:15:07
23681	9d689b7b-9805-4fe7-a9df-384a316c9c73	9d689b7b-9d99-4443-8576-68c84a1dccb3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '68' order by \\"item_loans\\".\\"id\\" asc","time":"2.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:15:07
23682	9d689b7b-983b-43f6-a1ff-0f05381bf155	9d689b7b-9d99-4443-8576-68c84a1dccb3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 08:15:07
23683	9d689b7b-9c60-4d8e-b438-0f416ce98f5b	9d689b7b-9d99-4443-8576-68c84a1dccb3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 08:15:07
23684	9d689b7b-9cb2-48ce-8422-74d4f92b19f2	9d689b7b-9d99-4443-8576-68c84a1dccb3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/68","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":68,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":10000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"4000000","loans_pago_interes":"1000000"},"items":[{"id":227,"loans_codigo":68,"itemloans_cuota":"1","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":228,"loans_codigo":68,"itemloans_cuota":"2","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:14:40.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":229,"loans_codigo":68,"itemloans_cuota":"3","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:14:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":230,"loans_codigo":68,"itemloans_cuota":"4","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:14:49.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":231,"loans_codigo":68,"itemloans_cuota":"5","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":232,"loans_codigo":68,"itemloans_cuota":"6","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":233,"loans_codigo":68,"itemloans_cuota":"7","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":234,"loans_codigo":68,"itemloans_cuota":"8","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":235,"loans_codigo":68,"itemloans_cuota":"9","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":236,"loans_codigo":68,"itemloans_cuota":"10","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:15:07
30646	9d694139-aa9a-4242-9a9f-069a65b78397	9d694139-c82e-4cf7-8064-0d07b221e797	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 15:58:34
30647	9d694139-c2be-444f-9cdb-995141e9de25	9d694139-c82e-4cf7-8064-0d07b221e797	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 15:58:34
30648	9d694139-c316-46a5-8293-0c06d480adb9	9d694139-c82e-4cf7-8064-0d07b221e797	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 15:58:34
30649	9d694139-c6ea-4cb1-ab4c-ca4a5705e091	9d694139-c82e-4cf7-8064-0d07b221e797	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 15:58:34
30650	9d694139-c734-4377-93ca-7b0e28c00866	9d694139-c82e-4cf7-8064-0d07b221e797	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":327,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:58:34
23703	9d689b92-7269-4f64-82f4-1b11e1249068	9d689b92-7d8d-4629-86dc-8d89f2a3537e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 68\\n                        ","time":"45.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"7d9994d55cb8dde82ff4185920c79043","hostname":"EderCortes"}	2024-11-04 08:15:22
23704	9d689b92-7721-49c2-9b8a-246880abf460	9d689b92-7d8d-4629-86dc-8d89f2a3537e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '68' order by \\"item_loans\\".\\"id\\" asc","time":"2.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:15:22
23705	9d689b92-7755-477e-8821-21811d5efbbf	9d689b92-7d8d-4629-86dc-8d89f2a3537e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 08:15:22
23706	9d689b92-7c19-46b4-9749-2c81c46bba3b	9d689b92-7d8d-4629-86dc-8d89f2a3537e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 08:15:22
23707	9d689b92-7c7f-4f77-9cf6-45b6a7cac47c	9d689b92-7d8d-4629-86dc-8d89f2a3537e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/68","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":68,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":10000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"5000000","loans_pago_interes":"1250000"},"items":[{"id":227,"loans_codigo":68,"itemloans_cuota":"1","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-19 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:05:05.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-03 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":228,"loans_codigo":68,"itemloans_cuota":"2","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-05 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:14:40.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":229,"loans_codigo":68,"itemloans_cuota":"3","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-21 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:14:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":230,"loans_codigo":68,"itemloans_cuota":"4","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:14:49.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":231,"loans_codigo":68,"itemloans_cuota":"5","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-04T13:15:21.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"250000","itemloans_cuota_cancelada":"1000000"},{"id":232,"loans_codigo":68,"itemloans_cuota":"6","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":233,"loans_codigo":68,"itemloans_cuota":"7","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":234,"loans_codigo":68,"itemloans_cuota":"8","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-11 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":235,"loans_codigo":68,"itemloans_cuota":"9","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-27 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":236,"loans_codigo":68,"itemloans_cuota":"10","itemloans_valor_cuota":"1000000","itemloans_iteres":"250000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T21:04:07.000000Z","updated_at":"2024-11-03T21:04:07.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":261,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:15:22
30651	9d69413a-0e7c-4e4c-9c45-47530b91dfb6	9d69413a-2d24-457f-81d2-8475f784dedf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 15:58:34
30652	9d69413a-284c-4ee6-9e75-dd7ef9a7217d	9d69413a-2d24-457f-81d2-8475f784dedf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 15:58:34
30653	9d69413a-289e-4ef3-b039-a4feca2ef5aa	9d69413a-2d24-457f-81d2-8475f784dedf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 15:58:34
30654	9d69413a-2be1-48e9-a21a-8ef70f5b0501	9d69413a-2d24-457f-81d2-8475f784dedf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 15:58:34
30655	9d69413a-2c2c-498a-8997-3f1496b5177f	9d69413a-2d24-457f-81d2-8475f784dedf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":245,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:58:34
36086	9d69cab8-55f7-4705-8733-b1aa87b1871a	9d69cab8-5ef5-4fce-853c-d898ddf6eb2e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 86\\n                        ","time":"43.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6815ad365c5e82c8fb55476c5a77f0b5","hostname":"EderCortes"}	2024-11-04 22:23:02
36087	9d69cab8-58f3-4afb-9a4a-e97c93895864	9d69cab8-5ef5-4fce-853c-d898ddf6eb2e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '86' order by \\"item_loans\\".\\"id\\" asc","time":"2.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":304,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 22:23:02
36088	9d69cab8-5d6b-4d35-939f-83499fa7a098	9d69cab8-5ef5-4fce-853c-d898ddf6eb2e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 22:23:02
36089	9d69cab8-5dd2-4e20-995b-6d102ed9b79d	9d69cab8-5ef5-4fce-853c-d898ddf6eb2e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/86","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":86,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"460000","loans_pago_interes":"115000","user_alias":"juan_jaramillo"},"items":[{"id":336,"loans_codigo":86,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 21:03:40","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000","user_alias":"eder.cortes"},{"id":337,"loans_codigo":86,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 21:20:16","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":449,"loans_codigo":86,"itemloans_cuota":"3","itemloans_valor_cuota":"213333.33333333","itemloans_iteres":"53333.333333333","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:20:16","updated_at":"2024-11-04 21:20:16","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":450,"loans_codigo":86,"itemloans_cuota":"4","itemloans_valor_cuota":"213333.33333333","itemloans_iteres":"53333.333333333","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:20:16","updated_at":"2024-11-04 21:20:16","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":451,"loans_codigo":86,"itemloans_cuota":"5","itemloans_valor_cuota":"213333.33333333","itemloans_iteres":"53333.333333333","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:20:16","updated_at":"2024-11-04 21:20:16","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":297,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:23:02
36090	9d69cabc-5591-4625-b0f8-acd0c6be35f0	9d69cabc-58bb-4518-8a90-fb57a20e0035	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-total-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":208,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:23:04
40979	9d6cc91d-95a8-4855-b6e7-a20f86fce22b	9d6cc91d-98c4-4eec-acf7-cb7064985851	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1876}	2024-11-06 10:06:01
36091	9d69cabd-0adc-4222-8315-d98481484091	9d69cabd-5644-47b7-80c9-ad8cfd385c3c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 22:23:05
36092	9d69cabd-49d1-44b2-9dde-4674f1464069	9d69cabd-5644-47b7-80c9-ad8cfd385c3c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 86 limit 1","time":"3.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":725,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 22:23:05
36093	9d69cabd-4a2c-42f4-9436-e5b858486530	9d69cabd-5644-47b7-80c9-ad8cfd385c3c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 22:23:05
36094	9d69cabd-4b8f-446f-ab85-d8565aa1fce0	9d69cabd-5644-47b7-80c9-ad8cfd385c3c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_estado\\" = 'Cancelado', \\"loans_pago_interes\\" = 275000, \\"loans_pago_prestado\\" = 1100000, \\"updated_at\\" = '2024-11-04 22:23:05' where \\"id\\" = 86","time":"1.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":750,"hash":"acfe32aea56c9ca6bdbb917f944a78d1","hostname":"EderCortes"}	2024-11-04 22:23:05
36095	9d69cabd-4c0e-4a9b-9fd2-30a7c31d7327	9d69cabd-5644-47b7-80c9-ad8cfd385c3c	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:86","changes":{"loans_estado":"Cancelado","updated_at":"2024-11-04 22:23:05","loans_pago_interes":275000,"loans_pago_prestado":1100000},"hostname":"EderCortes"}	2024-11-04 22:23:05
36096	9d69cabd-4d4e-42c9-ab0a-33eea0224447	9d69cabd-5644-47b7-80c9-ad8cfd385c3c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 86 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"2.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":755,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 22:23:05
36097	9d69cabd-4d81-4eab-9145-c106e0d14664	9d69cabd-5644-47b7-80c9-ad8cfd385c3c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 22:23:05
36098	9d69cabd-4ebe-4f7f-81e4-1e9209d0e664	9d69cabd-5644-47b7-80c9-ad8cfd385c3c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_interes_canelado\\" = '53333.333333333', \\"itemloans_cuota_cancelada\\" = '213333.33333333', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_status\\" = 'Pagada', \\"itemloans_aprobador\\" = 12, \\"updated_at\\" = '2024-11-04 22:23:05' where \\"loans_codigo\\" = 86 and \\"itemloans_status\\" = 'Pendiente'","time":"2.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":764,"hash":"87a64c6113219082cd85f391b598ec7f","hostname":"EderCortes"}	2024-11-04 22:23:05
36099	9d69cabd-54cb-4817-852a-926566b96e68	9d69cabd-5644-47b7-80c9-ad8cfd385c3c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 22:23:05
36100	9d69cabd-5529-4088-8693-2b48effd63b4	9d69cabd-5644-47b7-80c9-ad8cfd385c3c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-total-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payTotal","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"39","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"idLoans":86,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"Se ha realizado el pago total del credito","status":true},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:23:05
36101	9d69cabd-9b49-481e-9675-b5f6343e4b03	9d69cabd-b874-4b1f-8b13-3ba17e3b4a70	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 22:23:05
36102	9d69cabd-b14f-461c-92c2-d683d9c70db7	9d69cabd-b874-4b1f-8b13-3ba17e3b4a70	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 86\\n                        ","time":"44.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"6815ad365c5e82c8fb55476c5a77f0b5","hostname":"EderCortes"}	2024-11-04 22:23:05
36103	9d69cabd-b449-4cba-be47-fadc4ac7839e	9d69cabd-b874-4b1f-8b13-3ba17e3b4a70	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '86' order by \\"item_loans\\".\\"id\\" asc","time":"2.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":304,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 22:23:05
36104	9d69cabd-b722-4933-8e6a-41bd343d07b3	9d69cabd-b874-4b1f-8b13-3ba17e3b4a70	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 22:23:05
36105	9d69cabd-b76c-4914-9a75-622671ef6695	9d69cabd-b874-4b1f-8b13-3ba17e3b4a70	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/86","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":86,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000","user_alias":"juan_jaramillo"},"items":[{"id":336,"loans_codigo":86,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 21:03:40","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000","user_alias":"eder.cortes"},{"id":337,"loans_codigo":86,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 21:20:16","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":449,"loans_codigo":86,"itemloans_cuota":"3","itemloans_valor_cuota":"213333.33333333","itemloans_iteres":"53333.333333333","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 21:20:16","updated_at":"2024-11-04 22:23:05","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"53333.333333333","itemloans_cuota_cancelada":"213333.33333333","user_alias":"eder.cortes"},{"id":450,"loans_codigo":86,"itemloans_cuota":"4","itemloans_valor_cuota":"213333.33333333","itemloans_iteres":"53333.333333333","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 21:20:16","updated_at":"2024-11-04 22:23:05","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"53333.333333333","itemloans_cuota_cancelada":"213333.33333333","user_alias":"eder.cortes"},{"id":451,"loans_codigo":86,"itemloans_cuota":"5","itemloans_valor_cuota":"213333.33333333","itemloans_iteres":"53333.333333333","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 21:20:16","updated_at":"2024-11-04 22:23:05","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"53333.333333333","itemloans_cuota_cancelada":"213333.33333333","user_alias":"eder.cortes"}]}},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:23:05
42923	9d6ce169-f38c-4424-9548-ded0ce5b1c3d	9d6ce169-f6b4-4767-bada-c0f19949bf22	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1968}	2024-11-06 11:13:58
36106	9d6b311d-99c3-4d00-a988-cb83516d1389	9d6b311f-4fc7-4790-82f9-c706b175611b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":652,"memory":18,"hostname":"EderCortes"}	2024-11-05 15:05:11
41258	9d6ccc1f-f4f0-447e-967e-863ba2809c3e	9d6ccc1f-fab0-4a0c-8286-49752749a60a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1890}	2024-11-06 10:14:26
30751	9d694317-ddbe-4629-8185-dec9d07fa79c	9d694318-0d3a-456f-a31b-15aefb11d50e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 16:03:47
30752	9d694318-0a65-4f9e-a4f4-d507e7555d68	9d694318-0d3a-456f-a31b-15aefb11d50e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 16:03:47
30753	9d694318-0bb8-461f-9f1b-38d93acfe680	9d694318-0d3a-456f-a31b-15aefb11d50e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":385,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:03:47
20703	9d66fba1-0727-4a0e-8f9b-705adff499de	9d66fba1-0b49-4938-99b5-4650c26c1797	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1026}	2024-11-03 12:52:18
42010	9d6cd38e-ed75-45d9-bfbc-6d6491ce8e44	9d6cd38e-f1d7-4ccc-ba21-fa220fc713fd	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1950}	2024-11-06 10:35:13
30754	9d694318-b76c-45b6-80fe-349e669787a4	9d694319-1d27-461a-9a4a-a3e971cb3250	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 16:03:48
30755	9d694319-1383-433d-af87-618493a2e983	9d694319-1d27-461a-9a4a-a3e971cb3250	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"169.38","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:03:48
30756	9d694319-1417-40c1-8ccf-1aa8cd401989	9d694319-1d27-461a-9a4a-a3e971cb3250	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 16:03:48
30757	9d694319-1b2a-4504-8e83-ca9f52e19588	9d694319-1d27-461a-9a4a-a3e971cb3250	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 16:03:48
30758	9d694319-1bb4-45ee-9f59-d244a244c27b	9d694319-1d27-461a-9a4a-a3e971cb3250	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":599,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:03:48
36107	9d6b3121-b67c-4241-9ffb-7a75f3164d4a	9d6b3125-8588-447d-9e97-137d2605e396	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 15:05:13
36108	9d6b3124-3329-4031-ac9d-7cebdd273fcf	9d6b3125-8588-447d-9e97-137d2605e396	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"83.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-05 15:05:15
36109	9d6b3124-3395-42ad-a589-e20e0526c599	9d6b3125-8588-447d-9e97-137d2605e396	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:05:15
36110	9d6b3125-83ba-4321-86c3-f7b0788a1b4c	9d6b3125-8588-447d-9e97-137d2605e396	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:05:16
36111	9d6b3125-8444-4b4d-97b9-7c005059aaea	9d6b3125-8588-447d-9e97-137d2605e396	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","profile":1},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":3754,"memory":24,"hostname":"EderCortes"}	2024-11-05 15:05:16
36112	9d6b3126-d1af-40f8-841d-f8405c13b46b	9d6b3127-1413-4a97-b468-619b6370bf2d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:05:16
36113	9d6b3127-0d9e-4ffa-a0bf-c1d0c330a61e	9d6b3127-1413-4a97-b468-619b6370bf2d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"84.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:05:17
30759	9d694319-a497-4c97-baa2-1d9ea6126402	9d694319-da74-4da2-81c3-04f0aee0b97e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 16:03:48
28006	9d68eaf1-b241-4dbb-9fb5-010446d28a52	9d68eaf1-e60e-4723-ac7f-2d80dfd4a53b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 11:57:18
28007	9d68eaf1-e387-4470-b333-3978f5b8dae8	9d68eaf1-e60e-4723-ac7f-2d80dfd4a53b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:57:18
28008	9d68eaf1-e489-4298-84e7-5740ef8b9ef2	9d68eaf1-e60e-4723-ac7f-2d80dfd4a53b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":533,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:57:18
30760	9d694319-cf6f-4d82-9565-635a1c0646c0	9d694319-da74-4da2-81c3-04f0aee0b97e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"77.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:03:48
36114	9d6b3127-0df9-4707-9ca9-46b6c039a11e	9d6b3127-1413-4a97-b468-619b6370bf2d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:05:17
30761	9d694319-d015-438d-abde-b306eacdfb0b	9d694319-da74-4da2-81c3-04f0aee0b97e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:03:48
30762	9d694319-d8c4-471a-b760-7e3c1c129f16	9d694319-da74-4da2-81c3-04f0aee0b97e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 16:03:48
30763	9d694319-d91f-4cdb-83ae-a5b4cd1494be	9d694319-da74-4da2-81c3-04f0aee0b97e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":450,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:03:48
36115	9d6b3127-1277-47fb-8e0e-19c4a36d8af1	9d6b3127-1413-4a97-b468-619b6370bf2d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:05:17
36116	9d6b3127-12d4-42e5-955b-8ceb0d55da73	9d6b3127-1413-4a97-b468-619b6370bf2d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":530,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:05:17
28009	9d68eaf2-e9ed-4fc0-916e-bafca2b34014	9d68eaf3-1d4e-4be1-9292-d7aa2d68f2ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:57:19
28010	9d68eaf3-0f93-43d6-ac36-488af9333685	9d68eaf3-1d4e-4be1-9292-d7aa2d68f2ac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"67.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:57:19
28011	9d68eaf3-152a-4e97-b8c3-d597521295cb	9d68eaf3-1d4e-4be1-9292-d7aa2d68f2ac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:57:19
28012	9d68eaf3-1567-4d3e-80d4-eba063228790	9d68eaf3-1d4e-4be1-9292-d7aa2d68f2ac	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:57:19
28013	9d68eaf3-1b9f-42ec-9be9-028c06357699	9d68eaf3-1d4e-4be1-9292-d7aa2d68f2ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:57:19
28014	9d68eaf3-1c1c-4329-a1d0-2b189dbe7706	9d68eaf3-1d4e-4be1-9292-d7aa2d68f2ac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":734,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:57:19
30764	9d69431a-4ae4-423d-a20d-aabf1ade7802	9d69431a-8480-4281-a8ba-d23ccef75dff	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 16:03:49
30765	9d69431a-78dd-4bc5-8492-1b35b80183c9	9d69431a-8480-4281-a8ba-d23ccef75dff	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"61.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:03:49
30766	9d69431a-798f-4a5a-a54f-e4af38be0734	9d69431a-8480-4281-a8ba-d23ccef75dff	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 16:03:49
30767	9d69431a-8276-4a17-a763-4abb23805839	9d69431a-8480-4281-a8ba-d23ccef75dff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:03:49
30768	9d69431a-8304-4830-922a-af8db871d3f6	9d69431a-8480-4281-a8ba-d23ccef75dff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":412,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:03:49
36117	9d6b3146-3eba-47d0-a2df-e6a647b776dc	9d6b3146-74cf-489d-8d25-a17b1ebd79b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:05:37
30769	9d69431c-7600-4ef6-9a86-cf974d20e2ee	9d69431c-95f0-45cd-8777-0f626a28fcb8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:03:50
30770	9d69431c-8fd6-450c-b045-103b4cb30a17	9d69431c-95f0-45cd-8777-0f626a28fcb8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:03:50
30771	9d69431c-9043-40f5-b53c-a8b99503656f	9d69431c-95f0-45cd-8777-0f626a28fcb8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:03:50
30772	9d69431c-946d-41ac-b01f-297597955f5e	9d69431c-95f0-45cd-8777-0f626a28fcb8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:03:50
30773	9d69431c-94c7-42ef-8381-cf0602502f48	9d69431c-95f0-45cd-8777-0f626a28fcb8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":449,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:03:50
36118	9d6b3146-707d-4f51-a347-d6a7821a1a2c	9d6b3146-74cf-489d-8d25-a17b1ebd79b0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"76.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:05:37
36119	9d6b3146-7361-4339-8659-808c993ff7e6	9d6b3146-74cf-489d-8d25-a17b1ebd79b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:05:37
36120	9d6b3146-73c9-437f-bbc7-fbeef792062f	9d6b3146-74cf-489d-8d25-a17b1ebd79b0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:05:37
30774	9d69431f-7389-4711-b1de-7214b8bf29b4	9d69431f-7710-4059-8db0-ae8fa290d524	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":156,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:03:52
36121	9d6b3146-c98d-433b-8072-e3835068349e	9d6b3147-12ad-416d-9c3d-1f043d8d2936	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:05:37
36122	9d6b3147-0b92-4e0b-8634-da470ba7b2cb	9d6b3147-12ad-416d-9c3d-1f043d8d2936	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"146.96","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:05:38
36123	9d6b3147-0be4-4550-b1b5-04f7f6f22eed	9d6b3147-12ad-416d-9c3d-1f043d8d2936	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:05:38
36124	9d6b3147-10e3-4556-9f1e-1bcf0d525315	9d6b3147-12ad-416d-9c3d-1f043d8d2936	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:05:38
36125	9d6b3147-114b-43c1-ab1c-606bd773d090	9d6b3147-12ad-416d-9c3d-1f043d8d2936	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":390,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:05:38
30775	9d694320-2d3a-490e-af6c-2be86a6852ba	9d694320-7089-4b0e-9309-8e64036fc387	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:03:53
30776	9d694320-6c94-41c2-a17f-dae2ceaae2f4	9d694320-7089-4b0e-9309-8e64036fc387	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ma%' or \\"users\\".\\"user_document\\"::text like '%Ma%') order by \\"users\\".\\"user_document\\" asc","time":"145.53","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 16:03:53
30777	9d694320-6f60-49c6-be97-ab1cf661d724	9d694320-7089-4b0e-9309-8e64036fc387	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:03:53
30778	9d694320-6fa9-4d4e-8e2d-9d4cafc853a0	9d694320-7089-4b0e-9309-8e64036fc387	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ma"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:03:53
36126	9d6b3147-5ceb-4c50-a967-624a3fc178fa	9d6b3147-a375-4966-b347-d1934b4ec8d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:05:38
36127	9d6b3147-9e5e-4e6a-9cad-d545a022ad6b	9d6b3147-a375-4966-b347-d1934b4ec8d8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"144.39","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:05:38
36128	9d6b3147-9eaa-4725-ae8b-ac4f1c608290	9d6b3147-a375-4966-b347-d1934b4ec8d8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:05:38
36129	9d6b3147-a258-4675-97c7-74363edcae8f	9d6b3147-a375-4966-b347-d1934b4ec8d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:05:38
36130	9d6b3147-a298-423f-a6ed-53f34bcf1b67	9d6b3147-a375-4966-b347-d1934b4ec8d8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:05:38
30779	9d694320-adea-48d2-922c-daaee7a1e30d	9d694320-b0d9-4a65-bae1-3473e10f800f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":135,"memory":20,"hostname":"EderCortes"}	2024-11-04 16:03:53
41856	9d6cd063-5fdd-4cae-b42a-9f88c1db71bb	9d6cd063-62a3-49fe-9647-09ec2551118c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1938}	2024-11-06 10:26:22
30780	9d694320-fe5c-4a52-9c1f-f8e8b96096bd	9d694321-01ac-438a-963e-dbdefef52541	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":139,"memory":20,"hostname":"EderCortes"}	2024-11-04 16:03:53
42027	9d6cd3aa-0d92-4a63-8d62-23d941f5cc78	9d6cd3aa-113a-4106-97f9-872bc2507368	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1952}	2024-11-06 10:35:31
30781	9d694321-532a-4107-9027-df77c08faec8	9d694321-574f-4a3a-b546-0035f9bc1f1b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":146,"memory":20,"hostname":"EderCortes"}	2024-11-04 16:03:53
30782	9d694321-b09f-4fa7-bf15-cd31fe3fa353	9d694321-ce1c-4910-9b34-fa7f64269348	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:03:54
30783	9d694321-c93e-4373-916c-effe0829af34	9d694321-ce1c-4910-9b34-fa7f64269348	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mar%' or \\"users\\".\\"user_document\\"::text like '%Mar%') order by \\"users\\".\\"user_document\\" asc","time":"43.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 16:03:54
30784	9d694321-ccb9-400d-ad8e-56d3cd80d770	9d694321-ce1c-4910-9b34-fa7f64269348	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:03:54
30785	9d694321-cd12-44ea-a1b0-317b6a61cc7e	9d694321-ce1c-4910-9b34-fa7f64269348	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mar"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:03:54
30786	9d694322-16d8-4f2c-bcd7-649404485b63	9d694322-3379-4c83-807c-863858382cbf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:03:54
30787	9d694322-2ed2-496a-99e0-b7e014922265	9d694322-3379-4c83-807c-863858382cbf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"44.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 16:03:54
30788	9d694322-3213-4ff0-9395-793e032a38a0	9d694322-3379-4c83-807c-863858382cbf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:03:54
30789	9d694322-3262-4b91-8095-cda6c7f4a930	9d694322-3379-4c83-807c-863858382cbf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:03:54
25953	9d68cbff-f9d2-41f0-bfae-325f03047302	9d68cc00-49d4-48fa-b442-c2481abe59ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:30:47
25954	9d68cc00-45a5-4f10-afe9-cf4ff52690cb	9d68cc00-49d4-48fa-b442-c2481abe59ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:30:47
25955	9d68cc00-4728-4501-8671-f430270566a6	9d68cc00-49d4-48fa-b442-c2481abe59ed	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":848,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:30:47
25956	9d68cc01-0b35-4231-894b-782d76a58c8c	9d68cc01-45f1-445d-be05-86d64c79f44f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:30:47
25957	9d68cc01-2f2b-4934-b10b-9d079768fd6e	9d68cc01-45f1-445d-be05-86d64c79f44f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"70.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:30:47
25958	9d68cc01-386e-49a9-a860-c76202a725b5	9d68cc01-45f1-445d-be05-86d64c79f44f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"5.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:30:47
25959	9d68cc01-38db-4e0c-bedf-3a8928e95bcd	9d68cc01-45f1-445d-be05-86d64c79f44f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:30:47
25960	9d68cc01-4383-4192-b354-fb30bd629880	9d68cc01-45f1-445d-be05-86d64c79f44f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:30:47
25961	9d68cc01-444c-4493-8305-f37d47107020	9d68cc01-45f1-445d-be05-86d64c79f44f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":551,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:30:47
30790	9d694322-787e-4d20-b38d-dd67ba5ca8b8	9d694322-959e-4447-b109-8eda4c762572	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:03:54
30791	9d694322-90d4-4782-b61b-da1adf2ad329	9d694322-959e-4447-b109-8eda4c762572	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"44.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 16:03:54
30792	9d694322-9427-45bd-b32e-add520e02d0e	9d694322-959e-4447-b109-8eda4c762572	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:03:54
30793	9d694322-948b-4b7e-b809-55fd4fabfb38	9d694322-959e-4447-b109-8eda4c762572	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:03:54
25962	9d68cc02-7b93-4dd3-84b9-5898a28ebe87	9d68cc02-c965-48d0-b7a6-3eadbcc80ad3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:30:48
25963	9d68cc02-bd07-479e-b0d6-d36a0b74eb91	9d68cc02-c965-48d0-b7a6-3eadbcc80ad3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"90.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:30:48
25964	9d68cc02-bdc1-4a1a-8f40-3e8ea8badc97	9d68cc02-c965-48d0-b7a6-3eadbcc80ad3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:30:48
25965	9d68cc02-c6e3-443e-ac13-43b8d94a4624	9d68cc02-c965-48d0-b7a6-3eadbcc80ad3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:30:48
25966	9d68cc02-c78c-4f61-89b9-87d70e269f18	9d68cc02-c965-48d0-b7a6-3eadbcc80ad3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":964,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:30:48
30794	9d694322-d61b-4a6f-90a0-dde92411dff0	9d694322-dbf6-4b94-83b6-c42944b3fb20	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":144,"memory":20,"hostname":"EderCortes"}	2024-11-04 16:03:54
25967	9d68cc03-833e-439e-a44f-6797d8fa1b5e	9d68cc03-b714-4360-8bd5-32efc1ff75d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:30:49
25968	9d68cc03-ad98-467b-8a3b-f555addc676f	9d68cc03-b714-4360-8bd5-32efc1ff75d5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"68.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:30:49
25969	9d68cc03-ae2b-4c29-b6b0-f65cac20087a	9d68cc03-b714-4360-8bd5-32efc1ff75d5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:30:49
25970	9d68cc03-b504-48ce-8b8f-d59ecc604d89	9d68cc03-b714-4360-8bd5-32efc1ff75d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:30:49
25971	9d68cc03-b57f-4518-bc0f-361272c421a2	9d68cc03-b714-4360-8bd5-32efc1ff75d5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":577,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:30:49
30795	9d694323-8e96-458e-a921-551edaff24af	9d694323-abb2-4ea9-b238-686b88e1cb73	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:03:55
30796	9d694323-a5ed-4184-b230-914504358df6	9d694323-abb2-4ea9-b238-686b88e1cb73	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"42.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 16:03:55
30797	9d694323-aa1a-4bd3-b7e6-659a9c3d427a	9d694323-abb2-4ea9-b238-686b88e1cb73	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 16:03:55
30798	9d694323-aa77-4f17-8eb6-187c8fa773ca	9d694323-abb2-4ea9-b238-686b88e1cb73	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"28","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:03:55
36431	9d6b3a4a-9176-498c-9026-56c2bd931714	9d6b3a4a-dce4-4af5-ae37-15a14c406e3c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 15:30:50
36432	9d6b3a4a-db19-4e60-b66d-5aa29ca18c79	9d6b3a4a-dce4-4af5-ae37-15a14c406e3c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 15:30:50
36433	9d6b3a4a-dbb8-4518-bb35-2690aff3f6a4	9d6b3a4a-dce4-4af5-ae37-15a14c406e3c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:30:50
30799	9d694324-478b-4eb2-917d-81cc304405a8	9d694324-6590-48b9-8d33-4d347c497167	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 16:03:55
30800	9d694324-60a8-45fd-b953-40e35fc97308	9d694324-6590-48b9-8d33-4d347c497167	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '19' and \\"users\\".\\"deleted_at\\" is null","time":"41.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":55,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-11-04 16:03:55
30801	9d694324-60f7-4e04-ae35-e73169c4f0e6	9d694324-6590-48b9-8d33-4d347c497167	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 16:03:55
30802	9d694324-6430-4bd0-bc8d-bb103a4d4c8d	9d694324-6590-48b9-8d33-4d347c497167	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 16:03:55
30803	9d694324-6477-4a86-a193-24575e3b739c	9d694324-6590-48b9-8d33-4d347c497167	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/19","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:03:55
36434	9d6b3a4b-40c4-4198-96a6-43a59440d917	9d6b3a4b-5fcb-473b-94bd-66fcccd4f660	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 15:30:50
30907	9d694439-7c7c-4f0b-90b2-71f0de11d936	9d694439-b75d-4296-9403-bd873c6a1789	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 16:06:57
30908	9d694439-b4da-42d6-8b97-7dd1eb2561e8	9d694439-b75d-4296-9403-bd873c6a1789	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 16:06:57
30909	9d694439-b5b7-4bd1-9cfa-24623a4eb196	9d694439-b75d-4296-9403-bd873c6a1789	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":417,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:06:57
36435	9d6b3a4b-5b57-4a4f-83d4-34d5470035b9	9d6b3a4b-5fcb-473b-94bd-66fcccd4f660	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"47.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:30:50
36436	9d6b3a4b-5e5a-44b9-8d11-55754f0c791b	9d6b3a4b-5fcb-473b-94bd-66fcccd4f660	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 15:30:50
36437	9d6b3a4b-5ec2-4239-a7e8-e19eb0065556	9d6b3a4b-5fcb-473b-94bd-66fcccd4f660	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":274,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:30:50
30804	9d694347-40df-4e97-a079-75f166661ad4	9d694347-4488-437f-9419-dba4af0061e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":147,"memory":20,"hostname":"EderCortes"}	2024-11-04 16:04:18
30910	9d69443a-4f82-4bdf-b5cc-1e494f7398b0	9d69443a-83de-4f20-be70-f7e37d175c4e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 16:06:57
30911	9d69443a-7358-4b1b-adb1-652dc8e7613c	9d69443a-83de-4f20-be70-f7e37d175c4e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 91\\n                        ","time":"68.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9ae30bc69b6b272f3f51ff48e54319f5","hostname":"EderCortes"}	2024-11-04 16:06:58
30912	9d69443a-79a6-452b-9f1e-5135c93f8a71	9d69443a-83de-4f20-be70-f7e37d175c4e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '91' order by \\"item_loans\\".\\"id\\" asc","time":"3.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 16:06:58
30913	9d69443a-7a00-4fe6-a802-9566bf1edcbe	9d69443a-83de-4f20-be70-f7e37d175c4e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":8,"hostname":"EderCortes"}	2024-11-04 16:06:58
30914	9d69443a-81bd-440f-a7f9-c0f0d7fbcdea	9d69443a-83de-4f20-be70-f7e37d175c4e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 16:06:58
30915	9d69443a-826a-4bc2-a522-f09949ac7e3b	9d69443a-83de-4f20-be70-f7e37d175c4e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/91","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":91,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":8,"loans_valor_prestado":5000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0","user_alias":"eder.cortes"},"items":[{"id":371,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:04:19.000000Z","updated_at":"2024-11-04T21:04:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":372,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:04:19.000000Z","updated_at":"2024-11-04T21:04:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":373,"loans_codigo":91,"itemloans_cuota":"3","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:04:19.000000Z","updated_at":"2024-11-04T21:04:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":374,"loans_codigo":91,"itemloans_cuota":"4","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:04:19.000000Z","updated_at":"2024-11-04T21:04:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":375,"loans_codigo":91,"itemloans_cuota":"5","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:04:19.000000Z","updated_at":"2024-11-04T21:04:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":376,"loans_codigo":91,"itemloans_cuota":"6","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:04:19.000000Z","updated_at":"2024-11-04T21:04:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":377,"loans_codigo":91,"itemloans_cuota":"7","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:04:19.000000Z","updated_at":"2024-11-04T21:04:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":378,"loans_codigo":91,"itemloans_cuota":"8","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:04:19.000000Z","updated_at":"2024-11-04T21:04:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":438,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:06:58
36438	9d6b3a4b-ba0e-4d8a-a981-ad4466920d63	9d6b3a4b-dfba-4d16-8d9a-5d4ffeab7896	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 15:30:51
36439	9d6b3a4b-d9b5-4d30-9340-e9643830d558	9d6b3a4b-dfba-4d16-8d9a-5d4ffeab7896	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:30:51
36440	9d6b3a4b-da04-499d-9d7a-22e480f8186f	9d6b3a4b-dfba-4d16-8d9a-5d4ffeab7896	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:30:51
36441	9d6b3a4b-de2f-4f8b-8c73-0ed9d09af4af	9d6b3a4b-dfba-4d16-8d9a-5d4ffeab7896	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 15:30:51
36442	9d6b3a4b-de8e-4b9d-ae97-c8925521437b	9d6b3a4b-dfba-4d16-8d9a-5d4ffeab7896	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":311,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:30:51
30805	9d694347-a313-4c63-875b-e05bc96bdb60	9d694347-cd08-4ff1-a39f-7534037fc3bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 16:04:18
30806	9d694347-bd60-48c3-9778-7113f3bb3d99	9d694347-cd08-4ff1-a39f-7534037fc3bd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_inicio_pago\\", \\"loans_fecha_ultimo_pago\\", \\"loans_intereses_recaudar\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta 2', 'De las nieve', 'ds', 'CC', '1004655468', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon2', 'Calle 7505', '5000000', 25, 8, 'Q', null, '04-11-2024', 'Pendiente', '312596295', 12, 14, 19, 14, '04-11-2024', '04-11-2024', 1250000, 0, 0, '2024-11-04 16:04:19', '2024-11-04 16:04:19') returning \\"id\\"","time":"5.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":110,"hash":"1942e0e5f2555e71f5f5d75cd5941e3e","hostname":"EderCortes"}	2024-11-04 16:04:19
30807	9d694347-bddd-4e21-81a3-16f3cccf500a	9d694347-cd08-4ff1-a39f-7534037fc3bd	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:91","hostname":"EderCortes"}	2024-11-04 16:04:19
30808	9d694347-c3a9-48df-95a9-a1fabe3322c7	9d694347-cd08-4ff1-a39f-7534037fc3bd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 1, 625000, 156250, 'Pendiente', 'N\\/A', '20-11-2024', 12, 0, 0, '2024-11-04 16:04:19', '2024-11-04 16:04:19')","time":"2.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 16:04:19
30809	9d694347-c3dc-4632-b0f9-3faf92e6db67	9d694347-cd08-4ff1-a39f-7534037fc3bd	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 16:04:19
30810	9d694347-c460-4a4f-961a-3948ca603da4	9d694347-cd08-4ff1-a39f-7534037fc3bd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 2, 625000, 156250, 'Pendiente', 'N\\/A', '06-12-2024', 12, 0, 0, '2024-11-04 16:04:19', '2024-11-04 16:04:19')","time":"0.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 16:04:19
30811	9d694347-c485-4d72-b68d-db1d2d4e20d2	9d694347-cd08-4ff1-a39f-7534037fc3bd	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 16:04:19
30812	9d694347-c4f0-4fa0-90f4-db8bb8a8379b	9d694347-cd08-4ff1-a39f-7534037fc3bd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 3, 625000, 156250, 'Pendiente', 'N\\/A', '22-12-2024', 12, 0, 0, '2024-11-04 16:04:19', '2024-11-04 16:04:19')","time":"0.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 16:04:19
30813	9d694347-c513-4da3-9b5f-d043d396f10e	9d694347-cd08-4ff1-a39f-7534037fc3bd	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 16:04:19
30814	9d694347-c57c-467a-955d-f2624cd169b7	9d694347-cd08-4ff1-a39f-7534037fc3bd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 4, 625000, 156250, 'Pendiente', 'N\\/A', '07-01-2025', 12, 0, 0, '2024-11-04 16:04:19', '2024-11-04 16:04:19')","time":"0.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 16:04:19
30815	9d694347-c5a0-4401-a9c3-7de549793fae	9d694347-cd08-4ff1-a39f-7534037fc3bd	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 16:04:19
30816	9d694347-c609-4f55-81c5-3e2c40365c4b	9d694347-cd08-4ff1-a39f-7534037fc3bd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 5, 625000, 156250, 'Pendiente', 'N\\/A', '23-01-2025', 12, 0, 0, '2024-11-04 16:04:19', '2024-11-04 16:04:19')","time":"0.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 16:04:19
30817	9d694347-c62c-40e2-95fb-8669a67c6e11	9d694347-cd08-4ff1-a39f-7534037fc3bd	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 16:04:19
30818	9d694347-c697-4210-85ed-278f89b18a81	9d694347-cd08-4ff1-a39f-7534037fc3bd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 6, 625000, 156250, 'Pendiente', 'N\\/A', '08-02-2025', 12, 0, 0, '2024-11-04 16:04:19', '2024-11-04 16:04:19')","time":"0.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 16:04:19
30819	9d694347-c6ba-421f-a5d2-a0f443044a41	9d694347-cd08-4ff1-a39f-7534037fc3bd	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 16:04:19
30820	9d694347-c71a-4969-a182-d758b4f3ccfb	9d694347-cd08-4ff1-a39f-7534037fc3bd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 7, 625000, 156250, 'Pendiente', 'N\\/A', '24-02-2025', 12, 0, 0, '2024-11-04 16:04:19', '2024-11-04 16:04:19')","time":"0.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 16:04:19
30821	9d694347-c73b-4461-a057-d1bfffbd759b	9d694347-cd08-4ff1-a39f-7534037fc3bd	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 16:04:19
30822	9d694347-c799-4e4a-9d2f-bc6fbf2607ec	9d694347-cd08-4ff1-a39f-7534037fc3bd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (91, 8, 625000, 156250, 'Pendiente', 'N\\/A', '12-03-2025', 12, 0, 0, '2024-11-04 16:04:19', '2024-11-04 16:04:19')","time":"0.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":162,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-04 16:04:19
30823	9d694347-c7bd-4639-80f8-ac2ec01cf42a	9d694347-cd08-4ff1-a39f-7534037fc3bd	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 16:04:19
30824	9d694347-cba8-49cb-bcb4-be4980146006	9d694347-cd08-4ff1-a39f-7534037fc3bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 16:04:19
30825	9d694347-cbf4-4928-ae89-91666818f5ca	9d694347-cd08-4ff1-a39f-7534037fc3bd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"860","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"1004655468","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_valor_prestado":"5000000","loans_intereses":25,"loans_cuotas":8,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":19,"user_recomendacion":14,"loans_inicio_pago":"Mon Nov 04 2024","loans_fecha_ultimo_pago":null,"loans_intereses_recaudar":null,"created_at":null,"updated_at":null,"deleted_at":null,"loans_pago_prestado":0,"loans_pago_interes":0},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Mon Nov 04 2024","aprobador":12}},"session":[],"response_status":200,"response":{"message":"Registro creado exitosamente","id":91},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:04:19
30916	9d69443b-b960-4a25-a101-4a6f888a21d2	9d69443b-fb27-40c5-a923-85b239afc068	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 16:06:58
30917	9d69443b-f244-4c19-874a-d960535b4a46	9d69443b-fb27-40c5-a923-85b239afc068	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"82.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:06:59
30918	9d69443b-f300-476d-b124-26ade564be4c	9d69443b-fb27-40c5-a923-85b239afc068	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:06:59
30919	9d69443b-f924-4b89-b19a-9091f1cca057	9d69443b-fb27-40c5-a923-85b239afc068	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 16:06:59
30920	9d69443b-f9b9-4a67-a461-0f88409446c1	9d69443b-fb27-40c5-a923-85b239afc068	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":932,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:06:59
36443	9d6b3a4c-2828-4440-8a6c-817fd78ef65b	9d6b3a4c-4846-4b02-9535-408530aae144	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 15:30:51
36444	9d6b3a4c-42e3-4acd-874b-d1fe4b327c67	9d6b3a4c-4846-4b02-9535-408530aae144	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:30:51
36445	9d6b3a4c-4337-4d1d-bc67-20c3edd524f5	9d6b3a4c-4846-4b02-9535-408530aae144	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:30:51
36446	9d6b3a4c-46cf-4135-86b8-99d6a7d0bbcf	9d6b3a4c-4846-4b02-9535-408530aae144	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 15:30:51
30826	9d69435b-c740-4a83-be17-3f60b8a01aed	9d69435b-ea8b-4658-9264-954a5f192c82	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 16:04:32
30827	9d69435b-e594-4223-93fd-ff92a10c5560	9d69435b-ea8b-4658-9264-954a5f192c82	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"57.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 16:04:32
30828	9d69435b-e8f2-4b4c-8336-2886a7beb41a	9d69435b-ea8b-4658-9264-954a5f192c82	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 16:04:32
30829	9d69435b-e968-40e6-90fa-bad8a7696bf7	9d69435b-ea8b-4658-9264-954a5f192c82	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":291,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:04:32
30921	9d69443c-ed2e-4ece-bfe1-18f5eeb3b0e9	9d69443d-1f0f-492f-8bb6-e1a41307736c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 16:06:59
30922	9d69443d-16fd-423d-8f9b-fd59de5572ca	9d69443d-1f0f-492f-8bb6-e1a41307736c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"66.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:06:59
30923	9d69443d-178c-4586-aeae-1e778b1c023f	9d69443d-1f0f-492f-8bb6-e1a41307736c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:06:59
30924	9d69443d-1d18-4a65-bfcc-f9670aad45d3	9d69443d-1f0f-492f-8bb6-e1a41307736c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 16:06:59
30925	9d69443d-1d80-4097-82a4-28792ace92e9	9d69443d-1f0f-492f-8bb6-e1a41307736c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":702,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:06:59
36447	9d6b3a4c-4723-4fa5-955c-3cf7f508aec6	9d6b3a4c-4846-4b02-9535-408530aae144	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:30:51
30926	9d694485-4f67-43d1-a362-abf79571926e	9d694485-7840-4609-b192-0988508901cd	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 16:07:47
30927	9d694485-71d1-4ab5-9fc2-06f925461f46	9d694485-7840-4609-b192-0988508901cd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"53.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 16:07:47
30830	9d694365-95bf-447b-924d-b63c71af2d24	9d694365-b60a-4514-809f-1b5540b4cef7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 16:04:38
28252	9d68ffba-8226-4a01-bcf3-8a0301704dc0	9d68ffba-b4d7-43a4-8899-40e80c5f35e3	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 12:55:25
28253	9d68ffba-b161-4b97-9f6b-4bbeb71dd722	9d68ffba-b4d7-43a4-8899-40e80c5f35e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 12:55:25
28254	9d68ffba-b30e-4412-bd85-ff3457ab4e89	9d68ffba-b4d7-43a4-8899-40e80c5f35e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":521,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:55:25
30831	9d694365-acf5-4992-aa5a-8bd050fb3cfd	9d694365-b60a-4514-809f-1b5540b4cef7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 91\\n                        ","time":"45.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9ae30bc69b6b272f3f51ff48e54319f5","hostname":"EderCortes"}	2024-11-04 16:04:38
30928	9d694485-7630-48a0-85d8-96ebf6745e71	9d694485-7840-4609-b192-0988508901cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:07:47
30832	9d694365-b082-426c-9ad3-35086f04021d	9d694365-b60a-4514-809f-1b5540b4cef7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '91' order by \\"item_loans\\".\\"id\\" asc","time":"1.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 16:04:38
30833	9d694365-b0b9-4df1-8d5c-e50adbe11a78	9d694365-b60a-4514-809f-1b5540b4cef7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":8,"hostname":"EderCortes"}	2024-11-04 16:04:38
30834	9d694365-b47f-4bfb-91d0-ad900ebf89db	9d694365-b60a-4514-809f-1b5540b4cef7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 16:04:38
30929	9d694485-76d2-4502-86d3-9b0826702770	9d694485-7840-4609-b192-0988508901cd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":319,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:07:47
36448	9d6b3a4d-7cc3-40e4-b90e-a7a1450f9886	9d6b3a4d-a12a-48d4-9c90-31d34de1cc78	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 15:30:52
36449	9d6b3a4d-9ad3-430a-b550-ddc0aef9f42d	9d6b3a4d-a12a-48d4-9c90-31d34de1cc78	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:30:52
36450	9d6b3a4d-9b3b-4014-b7dd-e39eca88265e	9d6b3a4d-a12a-48d4-9c90-31d34de1cc78	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:30:52
36451	9d6b3a4d-9fa4-47c5-8a15-696062affa8c	9d6b3a4d-a12a-48d4-9c90-31d34de1cc78	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:30:52
28255	9d68ffbb-67a5-45f2-b805-da164088e305	9d68ffbb-8ebc-4ca3-bc74-001d4d2998df	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 12:55:26
28256	9d68ffbb-8286-44d8-894f-dad5149e5b7a	9d68ffbb-8ebc-4ca3-bc74-001d4d2998df	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"52.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 12:55:26
28257	9d68ffbb-8711-4226-96d4-d3c3b03e9c5a	9d68ffbb-8ebc-4ca3-bc74-001d4d2998df	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 12:55:26
28258	9d68ffbb-874c-4086-ac02-3a7e9478e86e	9d68ffbb-8ebc-4ca3-bc74-001d4d2998df	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 12:55:26
28259	9d68ffbb-8d0a-4d73-b926-dfa572f4ad41	9d68ffbb-8ebc-4ca3-bc74-001d4d2998df	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 12:55:26
28260	9d68ffbb-8d7c-4716-9336-f96f0f5457c0	9d68ffbb-8ebc-4ca3-bc74-001d4d2998df	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":488,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:55:26
30835	9d694365-b4d0-49a5-b051-ee66d329fb40	9d694365-b60a-4514-809f-1b5540b4cef7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/91","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":91,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":8,"loans_valor_prestado":5000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0","user_alias":"eder.cortes"},"items":[{"id":371,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:04:19.000000Z","updated_at":"2024-11-04T21:04:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":372,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:04:19.000000Z","updated_at":"2024-11-04T21:04:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":373,"loans_codigo":91,"itemloans_cuota":"3","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:04:19.000000Z","updated_at":"2024-11-04T21:04:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":374,"loans_codigo":91,"itemloans_cuota":"4","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:04:19.000000Z","updated_at":"2024-11-04T21:04:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":375,"loans_codigo":91,"itemloans_cuota":"5","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:04:19.000000Z","updated_at":"2024-11-04T21:04:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":376,"loans_codigo":91,"itemloans_cuota":"6","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:04:19.000000Z","updated_at":"2024-11-04T21:04:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":377,"loans_codigo":91,"itemloans_cuota":"7","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:04:19.000000Z","updated_at":"2024-11-04T21:04:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":378,"loans_codigo":91,"itemloans_cuota":"8","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:04:19.000000Z","updated_at":"2024-11-04T21:04:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:04:38
30930	9d694488-1904-41fd-8616-c5f60ef68621	9d694488-62dd-497f-acd6-ad4332b608fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:07:48
30931	9d694488-5d3c-45ac-a910-9397847dccec	9d694488-62dd-497f-acd6-ad4332b608fb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"148.92","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:07:49
30932	9d694488-5db1-4e1a-aea3-8238e25933a2	9d694488-62dd-497f-acd6-ad4332b608fb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 16:07:49
30933	9d694488-6192-4595-8a68-736884bb9af9	9d694488-62dd-497f-acd6-ad4332b608fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:07:49
30934	9d694488-61d8-4497-8226-e2c186682f05	9d694488-62dd-497f-acd6-ad4332b608fb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":510,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:07:49
36452	9d6b3a4d-9ffb-47e7-9b16-1583d1a361be	9d6b3a4d-a12a-48d4-9c90-31d34de1cc78	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:30:52
26073	9d68cd52-82a2-430f-927f-7aa94e3e9706	9d68cd52-e36f-475d-bd61-c54eca3dd5b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:34:28
26074	9d68cd52-e000-4325-ae65-0bf214cef75c	9d68cd52-e36f-475d-bd61-c54eca3dd5b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:34:29
26075	9d68cd52-e181-412e-be56-4c16dc00a31c	9d68cd52-e36f-475d-bd61-c54eca3dd5b3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":968,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:34:29
26076	9d68cd54-a702-4373-ade6-1aa2cb97b15e	9d68cd54-f621-4ce5-a886-e106ddd991fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:34:30
26077	9d68cd54-eaa5-4b64-95ad-6e50b3d73d7e	9d68cd54-f621-4ce5-a886-e106ddd991fd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"156.53","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:34:30
26078	9d68cd54-ef6e-4ac8-a255-8400d54a3bf1	9d68cd54-f621-4ce5-a886-e106ddd991fd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:34:30
26079	9d68cd54-efb3-4c81-9556-b63b15de1c76	9d68cd54-f621-4ce5-a886-e106ddd991fd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:34:30
26080	9d68cd54-f494-49c5-aef4-7b29fc8bd202	9d68cd54-f621-4ce5-a886-e106ddd991fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:34:30
26081	9d68cd54-f50d-42b7-b0c1-0711135c317e	9d68cd54-f621-4ce5-a886-e106ddd991fd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":1255,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:34:30
30935	9d694488-ca9c-44f7-bb48-c52dc1221478	9d694489-10fa-4b59-9f1b-bd97bc109f48	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:07:49
30936	9d694489-0432-4547-9357-c47e2fd82bec	9d694489-10fa-4b59-9f1b-bd97bc109f48	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"98.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:07:49
30937	9d694489-0501-47f0-b557-eb3b94c43bfc	9d694489-10fa-4b59-9f1b-bd97bc109f48	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 16:07:49
30938	9d694489-0df0-437b-a057-448c914a60fa	9d694489-10fa-4b59-9f1b-bd97bc109f48	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:07:49
30939	9d694489-0eb4-44bd-9777-30a02dfdcd96	9d694489-10fa-4b59-9f1b-bd97bc109f48	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":425,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:07:49
26082	9d68cd56-0dd4-4618-85a1-8027c67f7bb4	9d68cd56-a540-4c3d-a4c0-5e2c88617080	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:34:31
26083	9d68cd56-99db-443a-8b4f-9e3d558e1148	9d68cd56-a540-4c3d-a4c0-5e2c88617080	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"314.83","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:34:31
26084	9d68cd56-9a7a-4bec-94b0-906da4c5c84b	9d68cd56-a540-4c3d-a4c0-5e2c88617080	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:34:31
26085	9d68cd56-a325-4fe4-81f9-4df5c249051f	9d68cd56-a540-4c3d-a4c0-5e2c88617080	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:34:31
26086	9d68cd56-a3b3-426d-a96a-eeb0c983a3d5	9d68cd56-a540-4c3d-a4c0-5e2c88617080	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1078,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:34:31
40452	9d6cc3aa-02ae-4451-943c-f8305c6b4d30	9d6cc3aa-05c3-4ce8-ab35-e5ed7d0ab25c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1814}	2024-11-06 09:50:47
26087	9d68cd57-e4d3-4b5d-942a-688b0654aaeb	9d68cd58-1598-426f-a3b6-e3431bf0e31b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:34:32
26088	9d68cd58-0b7a-41ef-be49-ac96f851a716	9d68cd58-1598-426f-a3b6-e3431bf0e31b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"61.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:34:32
26089	9d68cd58-0c03-4bdf-82af-f7d2a077f96f	9d68cd58-1598-426f-a3b6-e3431bf0e31b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:34:32
26090	9d68cd58-139c-43c5-8edc-cc1ead5b38ad	9d68cd58-1598-426f-a3b6-e3431bf0e31b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:34:32
26091	9d68cd58-1422-47da-88cf-a07aea7c281a	9d68cd58-1598-426f-a3b6-e3431bf0e31b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":758,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:34:32
36270	9d6b33e0-22b3-4713-92d9-20a06ee41594	9d6b33e0-4c1f-4aae-89b4-a01949086dd4	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 15:12:53
36271	9d6b33e0-4a16-4cdc-8b2e-d94c714964e3	9d6b33e0-4c1f-4aae-89b4-a01949086dd4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:12:53
36272	9d6b33e0-4af7-4b82-9040-5c94744dcfe1	9d6b33e0-4c1f-4aae-89b4-a01949086dd4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":280,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:12:53
40941	9d6cc8e0-0335-4d83-89ec-6fcd35e344ce	9d6cc8e0-0601-403a-b07e-0dea51a9e689	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1871}	2024-11-06 10:05:21
6721	9d52d502-907b-4250-a831-0dee7d712d0d	9d52d502-9384-4427-9816-7e707e7a49f6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":344}	2024-10-24 12:27:45
36273	9d6b33e0-d528-4045-9f95-6347f0f778e8	9d6b33e0-f4ac-4858-b26d-d306a824ca8a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:12:54
36274	9d6b33e0-eef7-4a64-b12c-8a529e715752	9d6b33e0-f4ac-4858-b26d-d306a824ca8a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"48.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:12:54
36275	9d6b33e0-f26d-48e9-b71d-56d5f9b4dfbf	9d6b33e0-f4ac-4858-b26d-d306a824ca8a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:12:54
36276	9d6b33e0-f33a-40de-94c3-0a01f7c3662b	9d6b33e0-f4ac-4858-b26d-d306a824ca8a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":300,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:12:54
36277	9d6b33e1-3d88-4132-883b-d71f269303c4	9d6b33e1-6190-4830-bb2a-cd0f656fc9af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:12:54
36278	9d6b33e1-5c01-40f3-8a72-0f82d2ff22be	9d6b33e1-6190-4830-bb2a-cd0f656fc9af	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:12:54
36279	9d6b33e1-5c66-4ada-ba1f-3b951d461d05	9d6b33e1-6190-4830-bb2a-cd0f656fc9af	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:12:54
36280	9d6b33e1-6086-434e-9931-c63ce73e4d69	9d6b33e1-6190-4830-bb2a-cd0f656fc9af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:12:54
36281	9d6b33e1-60c7-49b3-bbda-8e4532701153	9d6b33e1-6190-4830-bb2a-cd0f656fc9af	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:12:54
36282	9d6b33e1-a9c4-45e2-b742-50343fa9868c	9d6b33e2-0453-44d4-a756-d83c437aabb2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:12:54
36283	9d6b33e1-f9e8-43c4-aba1-6516651167c6	9d6b33e2-0453-44d4-a756-d83c437aabb2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"181.90","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:12:55
36284	9d6b33e1-fab5-4b75-a066-15e991c66c6f	9d6b33e2-0453-44d4-a756-d83c437aabb2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:12:55
36285	9d6b33e2-028b-48b1-958a-3c7dd7871a5a	9d6b33e2-0453-44d4-a756-d83c437aabb2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:12:55
36286	9d6b33e2-0315-4550-9975-168cdb58a016	9d6b33e2-0453-44d4-a756-d83c437aabb2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":400,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:12:55
36287	9d6b33e2-da31-4fd5-9d19-9a077aac4a83	9d6b33e2-fb1b-4b47-9f30-f69f3a6d9ba3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:12:55
36288	9d6b33e2-f548-4464-b634-b5645a7bb31e	9d6b33e2-fb1b-4b47-9f30-f69f3a6d9ba3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"49.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:12:55
36289	9d6b33e2-f595-42e0-81c6-830591771948	9d6b33e2-fb1b-4b47-9f30-f69f3a6d9ba3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:12:55
36290	9d6b33e2-f9e4-443c-a7f0-113901597869	9d6b33e2-fb1b-4b47-9f30-f69f3a6d9ba3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:12:55
36291	9d6b33e2-fa3e-4964-b099-956231ae8d3d	9d6b33e2-fb1b-4b47-9f30-f69f3a6d9ba3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":315,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:12:55
36748	9d6b3f93-0dd3-4e1e-b92c-93be374a9d0e	9d6b3f93-34e0-48a0-afbe-35b928b81ca6	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 15:45:36
36749	9d6b3f93-3219-4a1c-ba77-b45ce95d2b89	9d6b3f93-34e0-48a0-afbe-35b928b81ca6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:45:36
36750	9d6b3f93-330f-465e-ba29-e1a46ecd1757	9d6b3f93-34e0-48a0-afbe-35b928b81ca6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":320,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:45:36
36751	9d6b3f93-9b84-467c-89a0-9640653812d6	9d6b3f93-e36f-4b95-9653-0395d22fe9ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:45:37
36752	9d6b3f93-dd74-4db6-90d1-e4c76de9015b	9d6b3f93-e36f-4b95-9653-0395d22fe9ae	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"150.17","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:45:37
36753	9d6b3f93-e1cd-43a8-83e7-0c403840a88e	9d6b3f93-e36f-4b95-9653-0395d22fe9ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:45:37
36754	9d6b3f93-e25f-40ef-8646-fb47a7113910	9d6b3f93-e36f-4b95-9653-0395d22fe9ae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":386,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:45:37
24146	9d68a8e4-649d-4814-9c96-03944cc33f37	9d68a8e4-87ea-476c-9347-04218e4ed14c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 08:52:37
24147	9d68a8e4-8618-452b-9fa0-735421a7fd87	9d68a8e4-87ea-476c-9347-04218e4ed14c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 08:52:37
24148	9d68a8e4-86ca-4f46-bc30-fe2fa630f03e	9d68a8e4-87ea-476c-9347-04218e4ed14c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":282,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:52:37
14306	9d5d1de3-1817-49d0-a19f-ab1b1b500c50	9d5d1de3-562b-4c12-9da3-9ec1a3e468d3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":654}	2024-10-29 15:09:49
6171	9d5259d0-c87d-427c-bc88-352b5c3f24e1	9d5259d0-cba9-4950-9a6f-433bac79cd26	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":308}	2024-10-24 06:43:17
24150	9d68a8e5-286c-42db-b54b-3683052e227a	9d68a8e5-313f-45ff-9057-9a05dc704c06	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 66\\n                        ","time":"152.12","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"f5566f306d2be9466f2c4564ce0020bd","hostname":"EderCortes"}	2024-11-04 08:52:37
24151	9d68a8e5-2bf7-46f8-a459-8936e3d1bf66	9d68a8e5-313f-45ff-9057-9a05dc704c06	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '66' order by \\"item_loans\\".\\"id\\" asc","time":"2.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:52:37
24152	9d68a8e5-2c32-4f98-ab69-433c70d9df42	9d68a8e5-313f-45ff-9057-9a05dc704c06	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 08:52:37
24153	9d68a8e5-3028-4c09-9a2d-9b76d259051d	9d68a8e5-313f-45ff-9057-9a05dc704c06	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 08:52:37
24154	9d68a8e5-3074-45d9-aff9-98a5845cb3fb	9d68a8e5-313f-45ff-9057-9a05dc704c06	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/66","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":66,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":5000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"5000000","loans_pago_interes":"1250000"},"items":[{"id":217,"loans_codigo":66,"itemloans_cuota":"1","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:26.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":218,"loans_codigo":66,"itemloans_cuota":"2","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":219,"loans_codigo":66,"itemloans_cuota":"3","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":220,"loans_codigo":66,"itemloans_cuota":"4","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:33.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":221,"loans_codigo":66,"itemloans_cuota":"5","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":222,"loans_codigo":66,"itemloans_cuota":"6","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:39.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":223,"loans_codigo":66,"itemloans_cuota":"7","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:42.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":224,"loans_codigo":66,"itemloans_cuota":"8","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:46.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":225,"loans_codigo":66,"itemloans_cuota":"9","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-31 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:50.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":226,"loans_codigo":66,"itemloans_cuota":"10","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:31:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"}]}},"duration":385,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:52:37
36755	9d6b3f94-3790-4545-894f-0fadf1750bf6	9d6b3f94-8442-41fb-a1d5-fc3f77a6a4a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:45:37
36756	9d6b3f94-7f2f-4962-ba8d-1041f5d52dbc	9d6b3f94-8442-41fb-a1d5-fc3f77a6a4a4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"144.22","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:45:37
36757	9d6b3f94-7f92-4f86-adce-4335e85271f6	9d6b3f94-8442-41fb-a1d5-fc3f77a6a4a4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:45:37
36758	9d6b3f94-8335-4add-93fe-2d7865630221	9d6b3f94-8442-41fb-a1d5-fc3f77a6a4a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:45:37
36759	9d6b3f94-8375-42d9-b13b-05fb81a93b76	9d6b3f94-8442-41fb-a1d5-fc3f77a6a4a4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":396,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:45:37
36587	9d6b3d5a-d56e-4b4c-b2fa-723a704d276e	9d6b3d5a-f48e-4958-8012-d734fe979e07	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:39:24
36588	9d6b3d5a-f2e1-483a-8615-6cf7d28274e4	9d6b3d5a-f48e-4958-8012-d734fe979e07	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:39:24
36589	9d6b3d5a-f37e-40ef-a0ef-1cd6a51f5b9e	9d6b3d5a-f48e-4958-8012-d734fe979e07	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:39:24
36590	9d6b3d5b-4b41-4f27-961a-a8b7d14ae94f	9d6b3d5b-6898-4dec-b094-36163023c8e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:39:24
36591	9d6b3d5b-6407-4257-9633-62998b2a0e6b	9d6b3d5b-6898-4dec-b094-36163023c8e7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"44.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:39:24
36592	9d6b3d5b-6717-45f4-96e6-d2d65a9defd1	9d6b3d5b-6898-4dec-b094-36163023c8e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 15:39:24
36593	9d6b3d5b-6780-446e-81fd-c4798959eaaa	9d6b3d5b-6898-4dec-b094-36163023c8e7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:39:24
36760	9d6b3f94-cbc9-40b8-8065-8b54c797d1a8	9d6b3f94-e9aa-4e0b-bc36-dd8d06d9bd92	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:45:37
36761	9d6b3f94-e484-4660-a517-2a69c6c4ec51	9d6b3f94-e9aa-4e0b-bc36-dd8d06d9bd92	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:45:37
36762	9d6b3f94-e4cf-473d-8f72-6d9152aa8ee5	9d6b3f94-e9aa-4e0b-bc36-dd8d06d9bd92	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:45:37
36763	9d6b3f94-e854-40b1-8c0e-aa4ca15684bc	9d6b3f94-e9aa-4e0b-bc36-dd8d06d9bd92	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:45:37
36764	9d6b3f94-e8a6-4541-b83f-400c09d909e7	9d6b3f94-e9aa-4e0b-bc36-dd8d06d9bd92	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:45:37
36594	9d6b3d5b-b790-48e8-bdeb-cc86e3d3e2f6	9d6b3d5b-d8ef-4976-a248-1b29c497e6bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 15:39:24
36595	9d6b3d5b-d3b6-4946-af53-c5ea783ad9b4	9d6b3d5b-d8ef-4976-a248-1b29c497e6bb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:39:24
36596	9d6b3d5b-d406-4f4c-8e41-e2fe6d139a79	9d6b3d5b-d8ef-4976-a248-1b29c497e6bb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:39:24
36597	9d6b3d5b-d7a1-48b5-95f5-997e3582f28d	9d6b3d5b-d8ef-4976-a248-1b29c497e6bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 15:39:24
36598	9d6b3d5b-d7e9-499e-85f3-a0a13c31bd0f	9d6b3d5b-d8ef-4976-a248-1b29c497e6bb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":271,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:39:24
36765	9d6b3f96-d0c6-405d-9aec-29b2eb53ccf8	9d6b3f97-18b2-41c6-afa2-79c87d489947	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:45:39
36766	9d6b3f97-11d0-4dd9-89a3-feff22825022	9d6b3f97-18b2-41c6-afa2-79c87d489947	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"143.56","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:45:39
36767	9d6b3f97-1249-4500-8132-5c73ce09b35f	9d6b3f97-18b2-41c6-afa2-79c87d489947	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:45:39
36768	9d6b3f97-16ed-4a7c-b8bb-d917a1c7b215	9d6b3f97-18b2-41c6-afa2-79c87d489947	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:45:39
36769	9d6b3f97-174a-468a-8db4-8e34e8e66632	9d6b3f97-18b2-41c6-afa2-79c87d489947	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":451,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:45:39
36599	9d6b3d5c-25a0-4749-9e03-028c79ab75e7	9d6b3d5c-45c6-4a13-9da3-9f9909e7d8ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 15:39:25
36600	9d6b3d5c-3ffc-4454-bb55-16c291304969	9d6b3d5c-45c6-4a13-9da3-9f9909e7d8ba	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:39:25
36601	9d6b3d5c-4070-4c27-8bd8-38db949afb06	9d6b3d5c-45c6-4a13-9da3-9f9909e7d8ba	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:39:25
36602	9d6b3d5c-4485-46f2-a2ed-349fde74ede4	9d6b3d5c-45c6-4a13-9da3-9f9909e7d8ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 15:39:25
36603	9d6b3d5c-44c8-4235-8a07-38f6dd25884b	9d6b3d5c-45c6-4a13-9da3-9f9909e7d8ba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":259,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:39:25
36604	9d6b3d5e-094e-476b-8929-eaaf67644df4	9d6b3d5e-5378-4c9d-b9f4-c276dd783d0b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 15:39:26
36605	9d6b3d5e-4e1a-4325-9769-9d0b64db9254	9d6b3d5e-5378-4c9d-b9f4-c276dd783d0b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"155.43","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:39:26
36606	9d6b3d5e-4e8b-43ff-b2ca-4b047d69802f	9d6b3d5e-5378-4c9d-b9f4-c276dd783d0b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:39:26
36607	9d6b3d5e-5229-4c0a-a678-0cd2db91fc6b	9d6b3d5e-5378-4c9d-b9f4-c276dd783d0b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 15:39:26
36608	9d6b3d5e-526c-4715-9caa-9ffa7174ecdc	9d6b3d5e-5378-4c9d-b9f4-c276dd783d0b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":384,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:39:26
26234	9d68cf26-af04-4a26-a1dc-8d9f547bd99b	9d68cf26-fd17-4365-835c-acc4829f158c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:39:35
26235	9d68cf26-fac7-4e8d-9f2e-a51273728da5	9d68cf26-fd17-4365-835c-acc4829f158c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:39:35
26236	9d68cf26-fbb3-43a3-b386-f8831a3c1b49	9d68cf26-fd17-4365-835c-acc4829f158c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":838,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:39:35
26237	9d68cf27-cf8e-4fad-a3f5-d3eb56fc23cd	9d68cf28-2795-4b34-a2fd-45ec2e85436c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:39:36
26238	9d68cf28-1bb9-4474-a24c-eac3662d09a6	9d68cf28-2795-4b34-a2fd-45ec2e85436c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"175.96","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:39:36
26239	9d68cf28-205b-41d1-b630-25e1f57b859e	9d68cf28-2795-4b34-a2fd-45ec2e85436c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:39:36
26240	9d68cf28-20aa-456f-bfee-e1b1e3e22d3c	9d68cf28-2795-4b34-a2fd-45ec2e85436c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:39:36
26241	9d68cf28-261d-41b0-9626-fb79bcda49b2	9d68cf28-2795-4b34-a2fd-45ec2e85436c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:39:36
26242	9d68cf28-2680-4852-8acc-f7233eff5340	9d68cf28-2795-4b34-a2fd-45ec2e85436c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":682,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:39:36
31099	9d6945e6-a7d1-4464-905d-ee46a31f7cf7	9d6945e6-d512-4bdf-a1b7-0924cdff6a58	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:11:38
31100	9d6945e6-d2d1-4c07-812e-9533e42c5af6	9d6945e6-d512-4bdf-a1b7-0924cdff6a58	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:11:38
31101	9d6945e6-d3bd-4733-bffa-cff0447b7d80	9d6945e6-d512-4bdf-a1b7-0924cdff6a58	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":439,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:11:38
26243	9d68cf29-08cb-485f-bf3a-560673bea18b	9d68cf29-5314-4984-b621-054713f0ad0c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:39:37
26244	9d68cf29-4940-421e-8d26-c0f2af84725a	9d68cf29-5314-4984-b621-054713f0ad0c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"109.09","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:39:37
26245	9d68cf29-49d4-4b26-a44d-82c9bb957598	9d68cf29-5314-4984-b621-054713f0ad0c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:39:37
26246	9d68cf29-512c-4b2e-9d59-a2690f7b1a6d	9d68cf29-5314-4984-b621-054713f0ad0c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:39:37
26247	9d68cf29-51bb-4c7d-9d81-b97754a16d6f	9d68cf29-5314-4984-b621-054713f0ad0c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":749,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:39:37
31102	9d6945e7-928d-4064-8914-6f0dda771bc0	9d6945e7-c8fc-4252-8c8f-e0bfe2e8211e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:11:39
31103	9d6945e7-b60c-4be2-8eea-98743552d560	9d6945e7-c8fc-4252-8c8f-e0bfe2e8211e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"67.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 16:11:39
28498	9d6901e2-7c35-4d23-a653-371ade9ebdc1	9d6901e2-99bc-45b1-a911-d8c537dfe64c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 13:01:27
28499	9d6901e2-982b-4403-83e8-d5ee06c23732	9d6901e2-99bc-45b1-a911-d8c537dfe64c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 13:01:27
28500	9d6901e2-98c6-4a41-bb67-022ad6dc3cf2	9d6901e2-99bc-45b1-a911-d8c537dfe64c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":401,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:01:27
31104	9d6945e7-bcc1-4e5d-9c42-440cfb79f01f	9d6945e7-c8fc-4252-8c8f-e0bfe2e8211e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '92' order by \\"item_loans\\".\\"id\\" asc","time":"3.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 16:11:39
31105	9d6945e7-bd2c-4b7a-a3a9-3cd30fdb9e10	9d6945e7-c8fc-4252-8c8f-e0bfe2e8211e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":15,"hostname":"EderCortes"}	2024-11-04 16:11:39
31106	9d6945e7-c66e-47c1-a732-9f5e3980d904	9d6945e7-c8fc-4252-8c8f-e0bfe2e8211e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:11:39
31107	9d6945e7-c71b-451c-8bcd-3574e5f14f0f	9d6945e7-c8fc-4252-8c8f-e0bfe2e8211e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":92,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":15,"loans_valor_prestado":8000009,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0","user_alias":"eder.cortes"},"items":[{"id":379,"loans_codigo":92,"itemloans_cuota":"1","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":380,"loans_codigo":92,"itemloans_cuota":"2","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":381,"loans_codigo":92,"itemloans_cuota":"3","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":382,"loans_codigo":92,"itemloans_cuota":"4","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":383,"loans_codigo":92,"itemloans_cuota":"5","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":384,"loans_codigo":92,"itemloans_cuota":"6","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":385,"loans_codigo":92,"itemloans_cuota":"7","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":386,"loans_codigo":92,"itemloans_cuota":"8","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":387,"loans_codigo":92,"itemloans_cuota":"9","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":388,"loans_codigo":92,"itemloans_cuota":"10","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":389,"loans_codigo":92,"itemloans_cuota":"11","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-31 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":390,"loans_codigo":92,"itemloans_cuota":"12","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":391,"loans_codigo":92,"itemloans_cuota":"13","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-16 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":392,"loans_codigo":92,"itemloans_cuota":"14","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":393,"loans_codigo":92,"itemloans_cuota":"15","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":516,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:11:39
26248	9d68cf2a-196d-4721-9cd4-4252f926ec46	9d68cf2a-4d0f-40d3-9d96-99e453c6ee01	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:39:38
26249	9d68cf2a-42f1-405f-894d-557d5a430105	9d68cf2a-4d0f-40d3-9d96-99e453c6ee01	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"71.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:39:38
26250	9d68cf2a-4388-4227-8890-8fb542b2fc2b	9d68cf2a-4d0f-40d3-9d96-99e453c6ee01	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:39:38
26251	9d68cf2a-4ace-49b0-aa53-ba54f9ad7e50	9d68cf2a-4d0f-40d3-9d96-99e453c6ee01	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:39:38
26252	9d68cf2a-4b70-473a-ad82-41451301ac63	9d68cf2a-4d0f-40d3-9d96-99e453c6ee01	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":609,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:39:38
28501	9d6901e3-1885-4601-95bc-2e126916faae	9d6901e3-3ebb-48a2-8f2a-b77061e3472b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 13:01:27
28502	9d6901e3-395b-40eb-ac3c-31a79ea0a92e	9d6901e3-3ebb-48a2-8f2a-b77061e3472b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"60.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:01:27
28503	9d6901e3-39c2-4c27-b445-f0f5add6e23d	9d6901e3-3ebb-48a2-8f2a-b77061e3472b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 13:01:27
28504	9d6901e3-3d86-4ff6-9d29-7fdca474b00d	9d6901e3-3ebb-48a2-8f2a-b77061e3472b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 13:01:27
28505	9d6901e3-3dd3-4d1b-8fb9-e789374ed8f0	9d6901e3-3ebb-48a2-8f2a-b77061e3472b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":370,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:01:27
31108	9d6945e8-b21c-442b-b94c-5b7c70053067	9d6945e9-6a23-44f2-a14b-6a76ef4ff1f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:11:40
31109	9d6945e9-602c-4122-8b66-5b3f853332c5	9d6945e9-6a23-44f2-a14b-6a76ef4ff1f2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"340.83","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:11:40
31110	9d6945e9-60b7-4f51-81c0-6be284762580	9d6945e9-6a23-44f2-a14b-6a76ef4ff1f2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:11:40
31111	9d6945e9-67ea-4966-aa78-af4de415ca0f	9d6945e9-6a23-44f2-a14b-6a76ef4ff1f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:11:40
31112	9d6945e9-6879-4e06-99b7-525dc82f069d	9d6945e9-6a23-44f2-a14b-6a76ef4ff1f2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1041,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:11:40
26253	9d68cf48-084b-46e8-8bfe-a83e2c3bc385	9d68cf48-0bb2-4edf-8f72-e5870cde0500	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":184,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:39:57
28506	9d6901e3-bb79-4038-914d-cd295ff9e63b	9d6901e4-044a-4d75-a95f-5db34f326870	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 13:01:28
28507	9d6901e3-ff67-41a5-bee5-6816184711cb	9d6901e4-044a-4d75-a95f-5db34f326870	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"145.64","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:01:28
28508	9d6901e3-ffb6-4917-a982-212c9ebba534	9d6901e4-044a-4d75-a95f-5db34f326870	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 13:01:28
28509	9d6901e4-0327-4070-b9eb-67a7a3f427c5	9d6901e4-044a-4d75-a95f-5db34f326870	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 13:01:28
28510	9d6901e4-036f-4423-9153-eef3b316ea35	9d6901e4-044a-4d75-a95f-5db34f326870	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":493,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:01:28
31113	9d6945ea-1fd2-41ed-8fab-2c07669babad	9d6945ea-6083-4983-a22d-a9daa97a0b87	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:11:40
31114	9d6945ea-56e7-4b2e-8ed4-ddddab071d12	9d6945ea-6083-4983-a22d-a9daa97a0b87	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"89.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:11:41
31115	9d6945ea-5769-4c3c-b18f-33a39bc20551	9d6945ea-6083-4983-a22d-a9daa97a0b87	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:11:41
31116	9d6945ea-5e70-45cf-b307-5c538b9b51e5	9d6945ea-6083-4983-a22d-a9daa97a0b87	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 16:11:41
31117	9d6945ea-5f04-4c7f-970c-6a3bb8e8e8f1	9d6945ea-6083-4983-a22d-a9daa97a0b87	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":572,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:11:41
26254	9d68cf48-9e9e-41a5-afbc-d9ccda4fb09c	9d68cf48-c468-45a9-85f4-9f5b24279218	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:39:58
26255	9d68cf48-ba3b-447b-adca-dce7cda0240b	9d68cf48-c468-45a9-85f4-9f5b24279218	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 366 limit 1","time":"2.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":356,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 10:39:58
26256	9d68cf48-ba8e-4fa8-b62a-6b5a2571ae38	9d68cf48-c468-45a9-85f4-9f5b24279218	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 10:39:58
26257	9d68cf48-bc56-45a2-baaf-5e550b07b619	9d68cf48-c468-45a9-85f4-9f5b24279218	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 89 limit 1","time":"2.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":357,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 10:39:58
26258	9d68cf48-bc91-4240-abcc-d6beb58cea6c	9d68cf48-c468-45a9-85f4-9f5b24279218	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 10:39:58
26259	9d68cf48-be7d-4c12-97b3-845f00496b06	9d68cf48-c468-45a9-85f4-9f5b24279218	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '43000', \\"itemloans_cuota_cancelada\\" = '172000', \\"updated_at\\" = '2024-11-04 10:39:58' where \\"id\\" = 366","time":"3.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":400,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 10:39:58
26260	9d68cf48-bf03-4307-9285-4ff08a781d54	9d68cf48-c468-45a9-85f4-9f5b24279218	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:366","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 10:39:58","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},"hostname":"EderCortes"}	2024-11-04 10:39:58
26261	9d68cf48-bfc8-40d4-890e-e661d4e06b31	9d68cf48-c468-45a9-85f4-9f5b24279218	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 103000, \\"loans_pago_prestado\\" = 412000, \\"updated_at\\" = '2024-11-04 10:39:58' where \\"id\\" = 89","time":"0.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":408,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 10:39:58
26262	9d68cf48-bfff-49ce-b294-a7dc0e16b64d	9d68cf48-c468-45a9-85f4-9f5b24279218	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:89","changes":{"updated_at":"2024-11-04 10:39:58","loans_pago_interes":103000,"loans_pago_prestado":412000},"hostname":"EderCortes"}	2024-11-04 10:39:58
26263	9d68cf48-c2ef-4f88-a4c6-e88dc2357db9	9d68cf48-c468-45a9-85f4-9f5b24279218	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:39:58
26264	9d68cf48-c335-43f4-8ced-ae5b346b89be	9d68cf48-c468-45a9-85f4-9f5b24279218	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"179","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000","id":366,"loans_codigo":89,"itemloans_cuota":"1","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":405,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:39:58
28511	9d6901e4-7ce6-406b-808a-4524668aaa93	9d6901e4-9bcc-42ca-93ee-7a946618b304	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 13:01:28
28512	9d6901e4-9429-4658-ab01-6ccc529e7ce3	9d6901e4-9bcc-42ca-93ee-7a946618b304	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '81' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"39.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 13:01:28
28513	9d6901e4-94a7-45b3-ba94-f940fe955e70	9d6901e4-9bcc-42ca-93ee-7a946618b304	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 13:01:28
28514	9d6901e4-9637-4dcf-b184-512dbe9a0f3a	9d6901e4-9bcc-42ca-93ee-7a946618b304	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '81' order by \\"item_loans\\".\\"id\\" asc","time":"1.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:01:28
28515	9d6901e4-966e-46ef-8eb9-5ab31fd0263e	9d6901e4-9bcc-42ca-93ee-7a946618b304	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 13:01:28
28516	9d6901e4-9a6b-41cc-aee2-46e339f7a07d	9d6901e4-9bcc-42ca-93ee-7a946618b304	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 13:01:28
28517	9d6901e4-9ad5-4333-b28f-b0bda18dfc25	9d6901e4-9bcc-42ca-93ee-7a946618b304	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/81","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":81,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"0","loans_pago_prestado":"0","loans_intereses_recaudar":"275000"},"items":[{"id":311,"loans_codigo":81,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":312,"loans_codigo":81,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":313,"loans_codigo":81,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":314,"loans_codigo":81,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":315,"loans_codigo":81,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":370,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:01:28
26265	9d68cf49-3f56-43c3-8d72-9012b1faf5a7	9d68cf49-5f13-40f5-8f14-993121dccce8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:39:58
26266	9d68cf49-560d-4d11-aa9c-210b68086aae	9d68cf49-5f13-40f5-8f14-993121dccce8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"43.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 10:39:58
26267	9d68cf49-59e0-4595-88ff-1959b212b9e4	9d68cf49-5f13-40f5-8f14-993121dccce8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:39:58
26268	9d68cf49-5a3b-4200-9275-edaf7f26a77d	9d68cf49-5f13-40f5-8f14-993121dccce8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:39:58
26269	9d68cf49-5dd5-4e9f-8492-4f9f91d123bd	9d68cf49-5f13-40f5-8f14-993121dccce8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 10:39:58
26270	9d68cf49-5e21-4a4e-afb3-95c56232da82	9d68cf49-5f13-40f5-8f14-993121dccce8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":375,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:39:58
26332	9d68d310-594b-4ace-aa74-91e0673d67fd	9d68d310-b174-4a31-8961-5af162c6a5ec	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 10:50:32
26333	9d68d310-af4d-4e4e-a2bf-794931b5cc99	9d68d310-b174-4a31-8961-5af162c6a5ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:50:32
26334	9d68d310-b033-458f-9d02-c06ecb4e2c6f	9d68d310-b174-4a31-8961-5af162c6a5ec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":657,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:50:32
43169	9d6ce52f-a432-4799-aba2-46d45eddf188	9d6ce52f-a75d-4ed7-bef1-be584b0b927e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1997}	2024-11-06 11:24:31
37607	9d6b58c8-410b-4095-9131-a976217335e4	9d6b58c8-43e6-488b-aa8a-afc32efa96a9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1695}	2024-11-05 16:56:05
26335	9d68d311-6e2e-459b-9e43-7234c12ea8f5	9d68d311-9a10-480c-a147-23b04596c4e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:50:32
26336	9d68d311-8d85-4690-9b5d-c92ef054eddc	9d68d311-9a10-480c-a147-23b04596c4e0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"55.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 10:50:33
26337	9d68d311-925e-41b6-a73d-fcd2222bd55d	9d68d311-9a10-480c-a147-23b04596c4e0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:50:33
26338	9d68d311-929c-4b16-aacf-4bc199009921	9d68d311-9a10-480c-a147-23b04596c4e0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:50:33
26339	9d68d311-988e-4813-baf1-ce7f587be093	9d68d311-9a10-480c-a147-23b04596c4e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:50:33
26340	9d68d311-98f3-4207-bdae-28a81a0fb371	9d68d311-9a10-480c-a147-23b04596c4e0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":533,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:50:33
36932	9d6b42c8-9133-45e2-8f15-7b8f562e4688	9d6b42c8-b720-4bdc-9e46-95dfca60bb6f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 15:54:35
36933	9d6b42c8-b512-4161-9ca1-82d9f1f50786	9d6b42c8-b720-4bdc-9e46-95dfca60bb6f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:54:35
36934	9d6b42c8-b5e7-48fd-91b1-6a984546252e	9d6b42c8-b720-4bdc-9e46-95dfca60bb6f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":281,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:54:35
36935	9d6b42c9-27ed-4a44-9ca5-fe2b6d3620ad	9d6b42c9-4983-4dfc-a01c-3c7a291af098	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:54:35
36936	9d6b42c9-431f-437d-8978-73ee9a21d20f	9d6b42c9-4983-4dfc-a01c-3c7a291af098	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"50.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:54:35
36937	9d6b42c9-47ef-4b5d-8d9c-b8b39283c315	9d6b42c9-4983-4dfc-a01c-3c7a291af098	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:54:35
36938	9d6b42c9-485e-444d-aca7-481f487f1ab7	9d6b42c9-4983-4dfc-a01c-3c7a291af098	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":311,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:54:35
31262	9d69494c-4d4d-4593-a15d-18a3fca18ee7	9d69494c-6e15-4aa9-96d7-ff32f9c1850b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:21:08
31263	9d69494c-6c3f-42ce-8317-5b3fcfd1631c	9d69494c-6e15-4aa9-96d7-ff32f9c1850b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:21:08
31264	9d69494c-6ce0-4f39-9c04-32f1ce2c7a0d	9d69494c-6e15-4aa9-96d7-ff32f9c1850b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":245,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:21:08
31265	9d69494c-d4dd-4a4d-aebd-57aa550e8957	9d69494c-f6a8-4e13-8081-ac4f5e22c379	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:21:08
31266	9d69494c-ebac-42b9-afab-4113bed90d87	9d69494c-f6a8-4e13-8081-ac4f5e22c379	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"45.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 16:21:09
31267	9d69494c-efcd-4d67-b7c5-d5e5b1e42ed8	9d69494c-f6a8-4e13-8081-ac4f5e22c379	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '92' order by \\"item_loans\\".\\"id\\" asc","time":"2.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 16:21:09
31268	9d69494c-f01a-4cb2-9c38-b4de302e12fb	9d69494c-f6a8-4e13-8081-ac4f5e22c379	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":15,"hostname":"EderCortes"}	2024-11-04 16:21:09
31269	9d69494c-f540-4a66-a4fa-3a5a45aa92e8	9d69494c-f6a8-4e13-8081-ac4f5e22c379	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:21:09
31270	9d69494c-f593-4739-b515-51c37505847b	9d69494c-f6a8-4e13-8081-ac4f5e22c379	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":92,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":15,"loans_valor_prestado":8000009,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"533333.93333333","loans_pago_interes":"133333.48333333","user_alias":"eder.cortes"},"items":[{"id":379,"loans_codigo":92,"itemloans_cuota":"1","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:13:07.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333"},{"id":380,"loans_codigo":92,"itemloans_cuota":"2","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":381,"loans_codigo":92,"itemloans_cuota":"3","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":382,"loans_codigo":92,"itemloans_cuota":"4","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":383,"loans_codigo":92,"itemloans_cuota":"5","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":384,"loans_codigo":92,"itemloans_cuota":"6","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":385,"loans_codigo":92,"itemloans_cuota":"7","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":386,"loans_codigo":92,"itemloans_cuota":"8","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":387,"loans_codigo":92,"itemloans_cuota":"9","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":388,"loans_codigo":92,"itemloans_cuota":"10","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":389,"loans_codigo":92,"itemloans_cuota":"11","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-31 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":390,"loans_codigo":92,"itemloans_cuota":"12","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":391,"loans_codigo":92,"itemloans_cuota":"13","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-16 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":392,"loans_codigo":92,"itemloans_cuota":"14","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":393,"loans_codigo":92,"itemloans_cuota":"15","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:21:09
36939	9d6b42c9-ad75-418e-9fd7-e46c8cffcc39	9d6b42c9-d284-44dc-9bab-400c7e07c95c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:54:35
36940	9d6b42c9-cc87-4e75-b75c-11d92acc5207	9d6b42c9-d284-44dc-9bab-400c7e07c95c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:54:35
36941	9d6b42c9-ccfe-4138-badc-2366fcdd753f	9d6b42c9-d284-44dc-9bab-400c7e07c95c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:54:35
36942	9d6b42c9-d122-49b0-b576-81ce62ffb92e	9d6b42c9-d284-44dc-9bab-400c7e07c95c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:54:35
36943	9d6b42c9-d16b-4086-a60d-b02561db5870	9d6b42c9-d284-44dc-9bab-400c7e07c95c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":334,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:54:35
31271	9d69494f-029b-4c4c-936e-77253e183836	9d69494f-3467-4484-b814-009b75800bc5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:21:10
31272	9d69494f-28a5-41a9-98b2-5d2e19760bdc	9d69494f-3467-4484-b814-009b75800bc5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"69.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:21:10
31273	9d69494f-2945-4e07-bbd6-775270798f9e	9d69494f-3467-4484-b814-009b75800bc5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:21:10
31274	9d69494f-316d-44b7-a3f2-c8ba812d908a	9d69494f-3467-4484-b814-009b75800bc5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:21:10
31275	9d69494f-3260-4dee-852c-7fd11445be05	9d69494f-3467-4484-b814-009b75800bc5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":753,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:21:10
36944	9d6b42ca-25f3-4245-8588-18f4f9e20378	9d6b42ca-70fa-4769-a412-7b7befb326b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:54:36
36945	9d6b42ca-6bb7-4dbf-95d4-a432fabc83b3	9d6b42ca-70fa-4769-a412-7b7befb326b5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"152.70","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:54:36
36946	9d6b42ca-6c0d-4906-b57d-843db1ddbc1c	9d6b42ca-70fa-4769-a412-7b7befb326b5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:54:36
36947	9d6b42ca-6f7c-49e5-97a0-4313087f416e	9d6b42ca-70fa-4769-a412-7b7befb326b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:54:36
36948	9d6b42ca-6fe7-44ca-b59b-1b921d65a431	9d6b42ca-70fa-4769-a412-7b7befb326b5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":389,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:54:36
36949	9d6b42cc-3846-4af2-aa44-5c0675b400c3	9d6b42cc-7cbb-44c2-aac9-ac9da05eb164	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:54:37
36950	9d6b42cc-778f-44b3-8c5d-6fec740e9a8a	9d6b42cc-7cbb-44c2-aac9-ac9da05eb164	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"142.28","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:54:37
36951	9d6b42cc-77da-4a5b-a67b-e4bc37a2c832	9d6b42cc-7cbb-44c2-aac9-ac9da05eb164	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:54:37
36952	9d6b42cc-7b6f-4b2f-bf4a-cd70ed8d9011	9d6b42cc-7cbb-44c2-aac9-ac9da05eb164	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:54:37
36953	9d6b42cc-7bb2-4a8f-b50f-1df9f7fd6a5c	9d6b42cc-7cbb-44c2-aac9-ac9da05eb164	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":461,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:54:37
41627	9d6cce3e-0903-416b-850a-ef2f1937d155	9d6cce3e-0ce7-49cc-8f0c-daba664aa5e8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1910}	2024-11-06 10:20:22
37093	9d6b44ef-699c-453a-a806-cbede804d8e9	9d6b44ef-b4bb-470e-aae4-5fae8e6aa6b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 16:00:36
37094	9d6b44ef-b310-4a66-8036-af449d19c46d	9d6b44ef-b4bb-470e-aae4-5fae8e6aa6b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 16:00:36
37095	9d6b44ef-b3ab-486a-b9d7-98e26a26f021	9d6b44ef-b4bb-470e-aae4-5fae8e6aa6b3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":370,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:00:36
37096	9d6b44f0-0b37-4cc1-ad11-037b6af088f1	9d6b44f0-2833-4804-b052-e872c9b8977d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 16:00:36
31419	9d694bd1-e057-437c-ac08-3cc2a7dd99a6	9d694bd2-095b-4ca8-ab00-2b4738323258	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 16:28:11
31420	9d694bd2-0768-4641-9521-ecd2fee3dae4	9d694bd2-095b-4ca8-ab00-2b4738323258	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 16:28:11
31421	9d694bd2-082f-44fa-ae53-2ede0dce9d16	9d694bd2-095b-4ca8-ab00-2b4738323258	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":412,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:28:11
37097	9d6b44f0-2394-4160-89f4-dd6e02b4fb11	9d6b44f0-2833-4804-b052-e872c9b8977d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"45.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 16:00:36
37098	9d6b44f0-26e2-460d-bc72-dd0b425dca67	9d6b44f0-2833-4804-b052-e872c9b8977d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 16:00:36
31422	9d694bd2-6e9d-4f71-8cab-26e4abdd9b90	9d694bd2-90af-4a43-9503-db82335696e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 16:28:12
31423	9d694bd2-8a59-4987-a3cd-cd7dc135b85b	9d694bd2-90af-4a43-9503-db82335696e4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:28:12
31424	9d694bd2-8acd-4220-9dc4-ba2d1b7051ed	9d694bd2-90af-4a43-9503-db82335696e4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 16:28:12
31425	9d694bd2-8f64-4e68-bd29-7de57430b09c	9d694bd2-90af-4a43-9503-db82335696e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 16:28:12
28747	9d690766-e5a4-4cfe-86be-808daf6187b3	9d690767-024c-441a-bf43-2cac4a325e9d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 13:16:53
28748	9d690767-00c4-47de-b553-953d4dba7a61	9d690767-024c-441a-bf43-2cac4a325e9d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 13:16:53
28749	9d690767-0163-44cc-8b42-d3089399db05	9d690767-024c-441a-bf43-2cac4a325e9d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":393,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:16:53
31426	9d694bd2-8fb8-430f-bb71-31acaf492384	9d694bd2-90af-4a43-9503-db82335696e4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":281,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:28:12
37099	9d6b44f0-274c-4e25-ac70-14153a3f4782	9d6b44f0-2833-4804-b052-e872c9b8977d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:00:36
28750	9d690767-80c7-4317-8070-6630b3de570f	9d690767-a051-4615-ba5f-77964f900a2a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 13:16:53
28751	9d690767-9b17-4612-a5de-b8fd8a093303	9d690767-a051-4615-ba5f-77964f900a2a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:16:53
28752	9d690767-9b7a-4bcb-a82d-896ea9818b07	9d690767-a051-4615-ba5f-77964f900a2a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 13:16:53
28753	9d690767-9f2b-460f-bffe-f62b8f6795c0	9d690767-a051-4615-ba5f-77964f900a2a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 13:16:53
28754	9d690767-9f76-4a5b-99a3-27b6230c66d5	9d690767-a051-4615-ba5f-77964f900a2a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:16:53
31427	9d694bd2-e6d6-4166-9571-e3f6c9df176b	9d694bd3-0c37-414c-a22f-13d30fbd68b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 16:28:12
31428	9d694bd3-0570-4aec-895c-422dddacf766	9d694bd3-0c37-414c-a22f-13d30fbd68b5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:28:12
31429	9d694bd3-05e1-4c63-89be-605835f7f3be	9d694bd3-0c37-414c-a22f-13d30fbd68b5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 16:28:12
31430	9d694bd3-0a82-4700-9193-69a528b79cd4	9d694bd3-0c37-414c-a22f-13d30fbd68b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 16:28:12
31431	9d694bd3-0af8-48a5-bb50-750d7d1851fc	9d694bd3-0c37-414c-a22f-13d30fbd68b5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":301,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:28:12
37100	9d6b44f0-7bf0-4f5c-9d5c-b8b36f0096cb	9d6b44f0-9d9b-4606-af6a-4065496cb695	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 16:00:36
37101	9d6b44f0-983e-4c10-a101-885bf4169bab	9d6b44f0-9d9b-4606-af6a-4065496cb695	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:00:36
37102	9d6b44f0-9898-4b65-a662-df91ed0e1491	9d6b44f0-9d9b-4606-af6a-4065496cb695	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:00:36
37103	9d6b44f0-9c10-4421-ad41-b4601707a669	9d6b44f0-9d9b-4606-af6a-4065496cb695	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 16:00:36
37104	9d6b44f0-9c55-4ed2-b313-f5d21896656a	9d6b44f0-9d9b-4606-af6a-4065496cb695	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":284,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:00:36
26462	9d68d444-1019-425d-b81e-cae74569bef2	9d68d444-9dbf-4cef-b787-3d49939fb0a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:53:53
26463	9d68d444-99f4-4400-b713-aba2ecb045d4	9d68d444-9dbf-4cef-b787-3d49939fb0a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:53:54
26464	9d68d444-9b81-4e9d-a8f5-d0765a8c2a4d	9d68d444-9dbf-4cef-b787-3d49939fb0a4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":905,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:53:54
26465	9d68d445-859a-4c1d-bfdb-85003e2bde96	9d68d445-c3b7-4034-80eb-a3072b9f2804	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:53:54
26466	9d68d445-b0d4-458e-bffe-31de6fba4f35	9d68d445-c3b7-4034-80eb-a3072b9f2804	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"65.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:53:54
26467	9d68d445-b809-475a-9adc-6a2e6c4b7b61	9d68d445-c3b7-4034-80eb-a3072b9f2804	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"3.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:53:54
26468	9d68d445-b875-435c-b76b-70b48b3aa4e2	9d68d445-c3b7-4034-80eb-a3072b9f2804	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:53:54
26469	9d68d445-c162-4ba4-ba71-f66aa243a467	9d68d445-c3b7-4034-80eb-a3072b9f2804	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:53:55
26470	9d68d445-c204-4eaa-9147-a0de24fbb1c8	9d68d445-c3b7-4034-80eb-a3072b9f2804	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":668,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:53:55
26471	9d68d446-9438-4a9c-b322-ab14df522683	9d68d446-d71e-4eec-ae3a-314fa7c596ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:53:55
26472	9d68d446-cb03-42bc-ba7c-3847fc057ca6	9d68d446-d71e-4eec-ae3a-314fa7c596ce	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"88.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:53:55
26473	9d68d446-cbd3-4c07-9071-e3391d91802d	9d68d446-d71e-4eec-ae3a-314fa7c596ce	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:53:55
26474	9d68d446-d4e3-43fe-86e0-dbd571290c13	9d68d446-d71e-4eec-ae3a-314fa7c596ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:53:55
26475	9d68d446-d576-464a-9e26-6227ed70a925	9d68d446-d71e-4eec-ae3a-314fa7c596ce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":680,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:53:55
28755	9d690768-1342-41da-b13b-f407c8b1e1a3	9d690768-316a-49a3-b3be-9dac860a6cc9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 13:16:53
28756	9d690768-2c4b-4d1b-9cd6-e3e056b73ce3	9d690768-316a-49a3-b3be-9dac860a6cc9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:16:53
28757	9d690768-2ca4-4898-8657-cf8520084913	9d690768-316a-49a3-b3be-9dac860a6cc9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 13:16:53
28758	9d690768-3039-43d4-8acf-1ef7c4aa38b4	9d690768-316a-49a3-b3be-9dac860a6cc9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 13:16:53
28759	9d690768-3083-4b3d-9e2f-a32dbab1beda	9d690768-316a-49a3-b3be-9dac860a6cc9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":359,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:16:53
37105	9d6b44f0-e42c-4a52-a0d7-587900b41a94	9d6b44f1-2fea-4f5b-b24b-cc32f19f6bac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 16:00:36
37106	9d6b44f1-2aa8-4879-af39-66c11bba36a9	9d6b44f1-2fea-4f5b-b24b-cc32f19f6bac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"155.85","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:00:37
37107	9d6b44f1-2af4-4d74-bbfb-67a0d1947df2	9d6b44f1-2fea-4f5b-b24b-cc32f19f6bac	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:00:37
37108	9d6b44f1-2e68-4b8d-9a10-648f052c340c	9d6b44f1-2fea-4f5b-b24b-cc32f19f6bac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 16:00:37
37109	9d6b44f1-2ecc-4053-a8a3-443e784b2ce4	9d6b44f1-2fea-4f5b-b24b-cc32f19f6bac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":353,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:00:37
26476	9d68d447-866f-4584-9b87-aa277d919ea3	9d68d447-b62b-4cd9-921d-544d2e2b8873	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:53:56
26477	9d68d447-ad30-4bce-a10d-0ebee0a5d634	9d68d447-b62b-4cd9-921d-544d2e2b8873	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"65.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:53:56
26478	9d68d447-ada1-4003-9570-8cbc81e24ebb	9d68d447-b62b-4cd9-921d-544d2e2b8873	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:53:56
26479	9d68d447-b428-4bf4-8465-2acab263d902	9d68d447-b62b-4cd9-921d-544d2e2b8873	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:53:56
26480	9d68d447-b4a8-4b8b-af00-6af7c2c04a06	9d68d447-b62b-4cd9-921d-544d2e2b8873	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":545,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:53:56
28760	9d690768-a44d-4f97-88e1-a4a6b78f16e9	9d690768-c3b9-4a0e-af96-d090919000fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 13:16:54
28761	9d690768-bbcb-4129-98d0-2d4e354fb814	9d690768-c3b9-4a0e-af96-d090919000fd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '89' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"38.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 13:16:54
28762	9d690768-bc2b-42fc-9b60-46ca2f3261ba	9d690768-c3b9-4a0e-af96-d090919000fd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 13:16:54
28763	9d690768-bdf7-487d-8814-6af786acd064	9d690768-c3b9-4a0e-af96-d090919000fd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:16:54
28764	9d690768-be35-4f65-b455-eafc1a9a89aa	9d690768-c3b9-4a0e-af96-d090919000fd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:16:54
28765	9d690768-c28a-4471-8486-13eb132ffaaf	9d690768-c3b9-4a0e-af96-d090919000fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 13:16:54
28766	9d690768-c2e0-4363-9b8e-778f83d5d2d3	9d690768-c3b9-4a0e-af96-d090919000fd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"146000","loans_pago_prestado":"584000","loans_intereses_recaudar":"275000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:16:54
37110	9d6b44f2-e570-463a-855f-b6c333ba7b34	9d6b44f3-08bb-456c-9d5b-37ff7b178c45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 16:00:38
31339	9d694aa3-bec8-42c5-ba70-372e611be8a5	9d694aa3-dcc7-4dcf-bf12-cccc5a782dc3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:24:53
31340	9d694aa3-db4f-4a95-b3fe-3a5e53b42185	9d694aa3-dcc7-4dcf-bf12-cccc5a782dc3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:24:53
37111	9d6b44f3-009e-4c57-9de4-b38880ea82be	9d6b44f3-08bb-456c-9d5b-37ff7b178c45	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"47.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 16:00:38
37112	9d6b44f3-00fa-4c51-b229-842016f53966	9d6b44f3-08bb-456c-9d5b-37ff7b178c45	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 16:00:38
37113	9d6b44f3-06bb-4c13-a5dc-0e072460b9fb	9d6b44f3-08bb-456c-9d5b-37ff7b178c45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-05 16:00:38
31341	9d694aa3-dbf1-426a-bd43-70db4186c9a3	9d694aa3-dcc7-4dcf-bf12-cccc5a782dc3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":269,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:24:53
37114	9d6b44f3-0750-46f0-ac5a-1c60bca6d35f	9d6b44f3-08bb-456c-9d5b-37ff7b178c45	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":370,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:00:38
31342	9d694aa4-31f9-4404-a20c-f808b73ba093	9d694aa4-5122-415e-a053-4ee9f21a6124	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:24:54
31343	9d694aa4-4af6-4977-bde2-1c1a7e8df1e9	9d694aa4-5122-415e-a053-4ee9f21a6124	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:24:54
31344	9d694aa4-4b56-47b9-8115-a90c027ec3c2	9d694aa4-5122-415e-a053-4ee9f21a6124	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 16:24:54
26532	9d68d7b9-e52f-4902-bd89-3daa6290fdff	9d68d7ba-0a69-4ce9-b337-16f18a568cfc	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 11:03:34
26533	9d68d7ba-0854-4dd6-95c8-03092f0f0a71	9d68d7ba-0a69-4ce9-b337-16f18a568cfc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:03:34
26534	9d68d7ba-0912-4b3e-af4d-6492d6211814	9d68d7ba-0a69-4ce9-b337-16f18a568cfc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":399,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:03:34
31345	9d694aa4-4fa8-47b6-91aa-13cdc22266e0	9d694aa4-5122-415e-a053-4ee9f21a6124	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:24:54
31346	9d694aa4-5008-4d51-8072-1185fec33c03	9d694aa4-5122-415e-a053-4ee9f21a6124	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:24:54
26535	9d68d7ba-a50e-4df6-a507-bf90a6cdedec	9d68d7ba-c5f7-4744-90a4-f96c1ec34fa6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:03:34
26536	9d68d7ba-bb84-4051-b36b-d33a7ae3e0f5	9d68d7ba-c5f7-4744-90a4-f96c1ec34fa6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"43.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:03:34
26537	9d68d7ba-bfee-43c3-8f99-6b37a37c24a9	9d68d7ba-c5f7-4744-90a4-f96c1ec34fa6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:03:34
26538	9d68d7ba-c038-4c8e-9f56-43528585b022	9d68d7ba-c5f7-4744-90a4-f96c1ec34fa6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:03:34
26539	9d68d7ba-c4b5-4782-ac3e-bf39f70d28ed	9d68d7ba-c5f7-4744-90a4-f96c1ec34fa6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:03:35
26540	9d68d7ba-c503-444f-a7d1-d21bfc313397	9d68d7ba-c5f7-4744-90a4-f96c1ec34fa6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":400,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:03:35
31347	9d694aa6-906f-4835-9968-e257e3f80ff9	9d694aa6-b659-4574-9f1b-9900d94e2600	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:24:55
31348	9d694aa6-afd3-4c30-b1cd-90bd2cfe3513	9d694aa6-b659-4574-9f1b-9900d94e2600	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"48.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:24:55
31349	9d694aa6-b042-48d6-a3b8-8f03dae07bad	9d694aa6-b659-4574-9f1b-9900d94e2600	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:24:55
31350	9d694aa6-b4d9-4914-9356-49b50d23f839	9d694aa6-b659-4574-9f1b-9900d94e2600	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:24:55
31351	9d694aa6-b533-4c9d-8a86-ae43935dd0bc	9d694aa6-b659-4574-9f1b-9900d94e2600	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":497,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:24:55
26719	9d68db8e-408f-44a1-9c79-8593a9998ea4	9d68db8e-77f9-45f3-b1eb-220e630900c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:14:16
26720	9d68db8e-7583-46b6-80f3-b03356711666	9d68db8e-77f9-45f3-b1eb-220e630900c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 11:14:17
26721	9d68db8e-76a5-4474-b77d-894b093c6826	9d68db8e-77f9-45f3-b1eb-220e630900c0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":615,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:14:17
26722	9d68db8f-2a1c-4043-b2ad-d186638b0f13	9d68db8f-5442-4e48-aa18-e5246ad64657	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 11:14:17
26723	9d68db8f-4d21-4e6d-8aa0-835bc4ee57c7	9d68db8f-5442-4e48-aa18-e5246ad64657	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"67.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 11:14:17
26724	9d68db8f-5244-4c79-8488-3c03a77d97cb	9d68db8f-5442-4e48-aa18-e5246ad64657	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 11:14:17
26725	9d68db8f-52c7-4b9f-bc00-5cfdfbfb9505	9d68db8f-5442-4e48-aa18-e5246ad64657	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":497,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:14:17
31565	9d69517e-d27d-4be0-ab62-f766f5bb4ff4	9d69517f-28e6-4290-8817-cf26b5ae5652	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 16:44:03
31566	9d69517f-2694-4c1f-be25-51c66be0b367	9d69517f-28e6-4290-8817-cf26b5ae5652	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:44:04
31567	9d69517f-278b-4954-b08e-022557c111c9	9d69517f-28e6-4290-8817-cf26b5ae5652	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":575,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:44:04
37254	9d6b466b-f343-4f70-9f1d-b90e354fb664	9d6b466c-495b-45d7-900e-478dd7b29f67	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 16:04:45
37255	9d6b466c-471a-41f8-b811-21026d996baf	9d6b466c-495b-45d7-900e-478dd7b29f67	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 16:04:45
37256	9d6b466c-4810-47a3-adab-5ef0797c569a	9d6b466c-495b-45d7-900e-478dd7b29f67	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":468,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:04:45
26726	9d68db90-63f2-4b33-b8ad-e3b5665e8755	9d68db90-d74a-4875-bfa2-abd4fc16cbcd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 11:14:18
26727	9d68db90-cb2c-4fd4-927d-aaf7900e3edb	9d68db90-d74a-4875-bfa2-abd4fc16cbcd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"187.94","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:14:18
26728	9d68db90-cbc9-4d8a-b586-645fdfcb0393	9d68db90-d74a-4875-bfa2-abd4fc16cbcd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:14:18
26729	9d68db90-d53b-4a44-b5e0-4d72c90208e8	9d68db90-d74a-4875-bfa2-abd4fc16cbcd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 11:14:18
26730	9d68db90-d5c5-4c7d-ae43-9c1ceb8582d3	9d68db90-d74a-4875-bfa2-abd4fc16cbcd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":974,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:14:18
31568	9d69517f-c74b-4c72-9ab3-63bb6e528127	9d69517f-fb67-4160-a597-52f8a18f031a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:44:04
31569	9d69517f-f2e9-45f1-b3e4-9ae715361cae	9d69517f-fb67-4160-a597-52f8a18f031a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"71.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:44:04
31570	9d69517f-f371-4a6d-8777-461761bb228c	9d69517f-fb67-4160-a597-52f8a18f031a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 16:44:04
31571	9d69517f-f9d4-4c7e-bcc2-75c090e1726a	9d69517f-fb67-4160-a597-52f8a18f031a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:44:04
31572	9d69517f-fa41-42c4-893d-a49c822cb4bf	9d69517f-fb67-4160-a597-52f8a18f031a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":440,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:44:04
37257	9d6b466c-b114-4fad-94fd-b649aab47055	9d6b466c-d287-4d81-84a1-ebce5c9dcf87	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 16:04:45
37258	9d6b466c-cc94-46c2-8f3b-4c32692f1203	9d6b466c-d287-4d81-84a1-ebce5c9dcf87	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"51.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 16:04:45
37259	9d6b466c-d0f8-4b33-9d0b-3cfe71e65cdc	9d6b466c-d287-4d81-84a1-ebce5c9dcf87	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 16:04:45
37260	9d6b466c-d18b-4281-a6ac-82522534265e	9d6b466c-d287-4d81-84a1-ebce5c9dcf87	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":288,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:04:45
26731	9d68db91-d8ab-4647-b62d-eb3a63b13698	9d68db92-10fc-4f9c-9a1a-4693436bf67b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 11:14:19
26732	9d68db92-084d-4db3-8ec0-09aefbf4ecd0	9d68db92-10fc-4f9c-9a1a-4693436bf67b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"69.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:14:19
26733	9d68db92-08d0-41ac-b0bf-80dac392128a	9d68db92-10fc-4f9c-9a1a-4693436bf67b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:14:19
26734	9d68db92-0f01-466f-af1a-0d231a52f67f	9d68db92-10fc-4f9c-9a1a-4693436bf67b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 11:14:19
26735	9d68db92-0f90-47d5-b3df-4852e5dfb91e	9d68db92-10fc-4f9c-9a1a-4693436bf67b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":744,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:14:19
31573	9d695180-5533-44b3-bcdd-a47fbe3a9111	9d695180-7d92-40ac-b587-a1117738d97a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:44:04
31574	9d695180-7540-4402-8d07-ead32a0d2278	9d695180-7d92-40ac-b587-a1117738d97a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"52.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:44:05
31575	9d695180-75bc-492d-a756-615bf65c70c5	9d695180-7d92-40ac-b587-a1117738d97a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 16:44:05
31576	9d695180-7bb6-4753-add3-f82854ae5ac7	9d695180-7d92-40ac-b587-a1117738d97a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:44:05
31577	9d695180-7c3b-4d3a-98db-ecf9ab0d4f31	9d695180-7d92-40ac-b587-a1117738d97a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":308,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:44:05
37261	9d6b466d-2d43-4077-941a-04e444678c45	9d6b466d-53c8-468d-982e-e1886a7edde8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 16:04:46
37262	9d6b466d-4d1b-42ca-b29a-5e8cf2fc205a	9d6b466d-53c8-468d-982e-e1886a7edde8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:04:46
37263	9d6b466d-4d95-4af6-a78b-25e65013b1dd	9d6b466d-53c8-468d-982e-e1886a7edde8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:04:46
37264	9d6b466d-5254-49e8-81cd-72d5e689a9f6	9d6b466d-53c8-468d-982e-e1886a7edde8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 16:04:46
37265	9d6b466d-5299-48df-9f3a-6e4123ca0536	9d6b466d-53c8-468d-982e-e1886a7edde8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":320,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:04:46
37266	9d6b466d-b0e6-476d-bb7a-45727cef83d1	9d6b466d-feff-4d52-8500-a811e22cf8c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 16:04:46
37267	9d6b466d-f895-4881-b9aa-0a7a8730594d	9d6b466d-feff-4d52-8500-a811e22cf8c3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"144.81","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:04:46
37268	9d6b466d-f908-42c1-b8df-9f214956a1a1	9d6b466d-feff-4d52-8500-a811e22cf8c3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:04:46
37269	9d6b466d-fd66-4701-9d30-9634a9fbd4a0	9d6b466d-feff-4d52-8500-a811e22cf8c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 16:04:46
37270	9d6b466d-fdac-4dd7-9968-3546d1d5f1f3	9d6b466d-feff-4d52-8500-a811e22cf8c3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":415,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:04:46
37271	9d6b4670-643d-4bf5-bf09-00e0570a6e3e	9d6b4670-ad68-47fb-b89c-c37b112a4056	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 16:04:48
37272	9d6b4670-a6e5-482b-af75-fa5cd67d3d92	9d6b4670-ad68-47fb-b89c-c37b112a4056	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"146.75","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 16:04:48
37273	9d6b4670-a731-427d-a089-042acc3f5ea9	9d6b4670-ad68-47fb-b89c-c37b112a4056	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 16:04:48
37274	9d6b4670-ab7d-4b93-aab1-fc3e2c9e4ffc	9d6b4670-ad68-47fb-b89c-c37b112a4056	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 16:04:48
37275	9d6b4670-ac07-46fd-8220-4d62d98465f8	9d6b4670-ad68-47fb-b89c-c37b112a4056	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":497,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:04:48
37429	9d6b4ad7-c3c2-4411-8794-98e48450e549	9d6b4ad7-e977-4c29-b08f-b2bbef79227a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 16:17:07
37430	9d6b4ad7-e76c-4dc0-95f6-4dc0f87a8fe0	9d6b4ad7-e977-4c29-b08f-b2bbef79227a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 16:17:07
37431	9d6b4ad7-e847-4db0-9960-edfed6eaba3b	9d6b4ad7-e977-4c29-b08f-b2bbef79227a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":289,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:17:07
37432	9d6b4ad8-52f0-4f8d-8fed-8439c8909741	9d6b4ad8-9df4-4ec8-b06e-1a4d3f2f3bc2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 16:17:07
37433	9d6b4ad8-9620-422e-a599-cc62ed7a3a4b	9d6b4ad8-9df4-4ec8-b06e-1a4d3f2f3bc2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 84\\n                        ","time":"156.53","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ab3bc7b9a0b897ddfe4287a88fc64c84","hostname":"EderCortes"}	2024-11-05 16:17:07
37434	9d6b4ad8-98d0-4525-b614-8f6bb4074f91	9d6b4ad8-9df4-4ec8-b06e-1a4d3f2f3bc2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '84' order by \\"item_loans\\".\\"id\\" asc","time":"2.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":304,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-05 16:17:07
37435	9d6b4ad8-9c7b-445a-8fca-d2ca344cf7e8	9d6b4ad8-9df4-4ec8-b06e-1a4d3f2f3bc2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 16:17:07
37436	9d6b4ad8-9cee-4cff-b667-c121efb6cf02	9d6b4ad8-9df4-4ec8-b06e-1a4d3f2f3bc2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/84","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":84,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"480000","loans_pago_interes":"120000","user_alias":"juan_jaramillo"},"items":[{"id":326,"loans_codigo":84,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 21:20:45","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":452,"loans_codigo":84,"itemloans_cuota":"4","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 21:20:45","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":456,"loans_codigo":84,"itemloans_cuota":"3","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:21:49","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":457,"loans_codigo":84,"itemloans_cuota":"4","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:21:49","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":458,"loans_codigo":84,"itemloans_cuota":"5","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:21:49","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":396,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:17:07
37437	9d6b4ada-6d9c-4360-b185-00b218b921b1	9d6b4ada-9ef8-47cc-8f9f-f19398dba95c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 16:17:08
37438	9d6b4ada-952d-4273-b80a-cbca161becfb	9d6b4ada-9ef8-47cc-8f9f-f19398dba95c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"71.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 16:17:09
37439	9d6b4ada-9599-48cc-8c45-330451647c73	9d6b4ada-9ef8-47cc-8f9f-f19398dba95c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 16:17:09
37440	9d6b4ada-9d09-44bb-bd7e-fd3201783eac	9d6b4ada-9ef8-47cc-8f9f-f19398dba95c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 16:17:09
28998	9d690e4f-1d8b-47c5-8d38-4a658453c401	9d690e4f-497e-4577-b860-9ee87f29db87	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 13:36:11
28999	9d690e4f-4780-4a65-b216-27246ffbb309	9d690e4f-497e-4577-b860-9ee87f29db87	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 13:36:12
29000	9d690e4f-484f-42db-b7c5-b091b3a6106f	9d690e4f-497e-4577-b860-9ee87f29db87	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":328,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:36:12
37441	9d6b4ada-9d9a-444e-8fea-238eac579778	9d6b4ada-9ef8-47cc-8f9f-f19398dba95c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":470,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:17:09
29001	9d690e4f-d637-4d60-93bb-076d7f1a04a8	9d690e50-2329-4721-af60-2c043b4bf7a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 13:36:12
29002	9d690e50-1801-4678-b7d3-f5f21dc1a57c	9d690e50-2329-4721-af60-2c043b4bf7a5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"152.16","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 13:36:12
29003	9d690e50-1c76-42eb-b4bc-4ebf677f5379	9d690e50-2329-4721-af60-2c043b4bf7a5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:36:12
29004	9d690e50-1cbc-493e-9fe7-00d3b55595c6	9d690e50-2329-4721-af60-2c043b4bf7a5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:36:12
29005	9d690e50-21c7-4e4b-ac2f-d6b3c95e1292	9d690e50-2329-4721-af60-2c043b4bf7a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 13:36:12
29006	9d690e50-2225-454c-8e10-89a64a68b1cb	9d690e50-2329-4721-af60-2c043b4bf7a5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":442,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:36:12
31689	9d695484-71f5-4d23-a409-f71513351a62	9d695484-ac80-447e-957f-efdd43e27bef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:52:30
31690	9d695484-a97e-4202-9a9f-0ba792b1b4e5	9d695484-ac80-447e-957f-efdd43e27bef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:52:31
31691	9d695484-ab0e-4202-9aaa-e14a8466ea0b	9d695484-ac80-447e-957f-efdd43e27bef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":452,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:52:31
5512	9d522175-6ea4-4581-b154-38f3ad178152	9d522175-7297-4e1f-9b58-16c13044820d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":295}	2024-10-24 04:05:42
16748	9d64d69a-445c-4d57-bb23-f24322c5cedb	9d64d69a-48a8-423b-a656-046019bd4b8f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":780}	2024-11-02 11:17:07
31692	9d695486-45e2-4231-858b-9dca04ebd5c5	9d695486-a75c-4a82-8e6a-b7fb6cc61984	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:52:32
31693	9d695486-9c9e-4075-8a83-0d46d9c0f6a3	9d695486-a75c-4a82-8e6a-b7fb6cc61984	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"157.12","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:52:32
31694	9d695486-9d3a-43da-b049-a08f4de4740f	9d695486-a75c-4a82-8e6a-b7fb6cc61984	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:52:32
31695	9d695486-a50d-4162-950b-569531c1a42b	9d695486-a75c-4a82-8e6a-b7fb6cc61984	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:52:32
24822	9d68bd6a-8752-454c-9d8e-999d87338167	9d68bd6a-bda3-4340-ae53-c8f134712dab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 09:50:00
24823	9d68bd6a-ba21-449d-86ae-1089d83be7c0	9d68bd6a-bda3-4340-ae53-c8f134712dab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 09:50:00
24824	9d68bd6a-bb7f-4238-99bc-9e78ef08f6bf	9d68bd6a-bda3-4340-ae53-c8f134712dab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":598,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:50:00
31696	9d695486-a5a2-4220-b05f-dbde73c4c288	9d695486-a75c-4a82-8e6a-b7fb6cc61984	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":718,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:52:32
24825	9d68bd6b-7b68-42ea-90ba-c2eb7d2e57e7	9d68bd6b-afa7-4ac9-9dc1-c6952ed83a17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 09:50:00
24826	9d68bd6b-a178-4548-83eb-255970049742	9d68bd6b-afa7-4ac9-9dc1-c6952ed83a17	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"74.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 09:50:01
24827	9d68bd6b-a70c-42d2-83e0-47be70d87c9c	9d68bd6b-afa7-4ac9-9dc1-c6952ed83a17	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:50:01
24828	9d68bd6b-a75f-41ee-a99c-fbfc74875eda	9d68bd6b-afa7-4ac9-9dc1-c6952ed83a17	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 09:50:01
24829	9d68bd6b-add5-4892-9d70-5305184dde6b	9d68bd6b-afa7-4ac9-9dc1-c6952ed83a17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 09:50:01
24830	9d68bd6b-ae3f-41bb-be53-dd398ba7c572	9d68bd6b-afa7-4ac9-9dc1-c6952ed83a17	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":535,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:50:01
31697	9d695487-8d57-4130-9c83-4f62071cf6a1	9d695487-cc4f-4d27-918a-2c906eff9eca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:52:32
31698	9d695487-c296-4d13-8014-69b45c636e70	9d695487-cc4f-4d27-918a-2c906eff9eca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"91.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:52:33
31699	9d695487-c326-4829-9f35-78d356598931	9d695487-cc4f-4d27-918a-2c906eff9eca	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:52:33
31700	9d695487-ca29-4f98-925a-46e02cdff2e8	9d695487-cc4f-4d27-918a-2c906eff9eca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:52:33
31701	9d695487-cac1-447c-ac44-a7831975680c	9d695487-cc4f-4d27-918a-2c906eff9eca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":541,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:52:33
24831	9d68bd6c-c52e-48fe-86ea-a8c18ed615b8	9d68bd6d-1a9a-4b77-9595-53d413fc0e3e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 09:50:01
24832	9d68bd6d-097d-45c7-8420-e87ec7794fbd	9d68bd6d-1a9a-4b77-9595-53d413fc0e3e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"95.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:50:01
24833	9d68bd6d-0a21-46b9-8e37-02ad9597ab4a	9d68bd6d-1a9a-4b77-9595-53d413fc0e3e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:50:01
24834	9d68bd6d-1708-4128-b959-c009cb690fe1	9d68bd6d-1a9a-4b77-9595-53d413fc0e3e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 09:50:02
24835	9d68bd6d-189a-4352-beef-f7fc59f4b713	9d68bd6d-1a9a-4b77-9595-53d413fc0e3e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":905,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:50:02
41164	9d6ccbb9-a924-4ed7-8dfb-7b309bd18020	9d6ccbb9-af01-4987-9a65-eccf90a790ea	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1884}	2024-11-06 10:13:19
24836	9d68bd6e-05a2-44f6-bf0d-a05cd756d816	9d68bd6e-23b9-403d-9fbd-246a7ae5307a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 09:50:02
24837	9d68bd6e-1ebe-450e-9d58-70839845af21	9d68bd6e-23b9-403d-9fbd-246a7ae5307a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:50:02
24838	9d68bd6e-1f10-4df2-a7bc-cef365536a88	9d68bd6e-23b9-403d-9fbd-246a7ae5307a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:50:02
24839	9d68bd6e-2276-456b-a76a-8078518d002b	9d68bd6e-23b9-403d-9fbd-246a7ae5307a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 09:50:02
24840	9d68bd6e-22bd-459f-ae6b-c9e80110830c	9d68bd6e-23b9-403d-9fbd-246a7ae5307a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":649,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:50:02
43407	9d6ce763-f345-40ce-97d9-714218e6db98	9d6ce763-f674-4606-848c-fa41e1391c08	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2022}	2024-11-06 11:30:41
24841	9d68bd7c-06c4-42c1-b7dc-ae9e05c5d1d5	9d68bd7c-2e7f-4034-b39a-e839a3658247	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 09:50:11
24842	9d68bd7c-2979-4fe7-895b-434be6a9b48b	9d68bd7c-2e7f-4034-b39a-e839a3658247	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"61.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 09:50:11
24843	9d68bd7c-2ccd-464e-ae1c-952e3f63ed74	9d68bd7c-2e7f-4034-b39a-e839a3658247	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 09:50:11
24844	9d68bd7c-2d45-4a71-991b-8e5955f638a3	9d68bd7c-2e7f-4034-b39a-e839a3658247	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":407,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:50:11
24845	9d68bd7e-ba13-4b34-a814-0bb849dfcfda	9d68bd7e-fdfa-421c-9f05-745abb945f16	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 09:50:13
24846	9d68bd7e-f5fb-47b4-8cc4-3958b458d199	9d68bd7e-fdfa-421c-9f05-745abb945f16	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 90\\n                        ","time":"140.11","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"93c10371e33ace24260de21c3ff3890d","hostname":"EderCortes"}	2024-11-04 09:50:13
24847	9d68bd7e-f93d-4a43-acfe-d3fdd9e67106	9d68bd7e-fdfa-421c-9f05-745abb945f16	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"1.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:50:13
24848	9d68bd7e-f970-4c4a-8543-aa9abf568487	9d68bd7e-fdfa-421c-9f05-745abb945f16	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 09:50:13
24849	9d68bd7e-fc96-419b-9bb1-fed407be72e5	9d68bd7e-fdfa-421c-9f05-745abb945f16	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 09:50:13
24850	9d68bd7e-fce3-44aa-bcbc-8df39d4d0efa	9d68bd7e-fdfa-421c-9f05-745abb945f16	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:18:39.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":449,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:50:13
25182	9d68c029-64a1-410c-ad00-d55cbf3c6111	9d68c029-8174-43e3-b285-01b5e103eb5a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 09:57:40
25183	9d68c029-7fcf-429f-b290-141d491284ec	9d68c029-8174-43e3-b285-01b5e103eb5a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 09:57:41
25184	9d68c029-8063-4672-aec4-805e711b385f	9d68c029-8174-43e3-b285-01b5e103eb5a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:57:41
25185	9d68c02a-06b7-4f23-a93e-06a5eee36e8b	9d68c02a-52bf-4b11-95b4-6bba6b5a0a5b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 09:57:41
25186	9d68c02a-48fe-4b21-900e-9a6a8c9b260d	9d68c02a-52bf-4b11-95b4-6bba6b5a0a5b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"153.28","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 09:57:41
25187	9d68c02a-4d8e-4ba2-9e74-3c44a081f83f	9d68c02a-52bf-4b11-95b4-6bba6b5a0a5b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"1.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:57:41
25188	9d68c02a-4dd7-4f78-b801-cc680a333be6	9d68c02a-52bf-4b11-95b4-6bba6b5a0a5b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 09:57:41
25189	9d68c02a-5186-482b-8282-c9bcc394942e	9d68c02a-52bf-4b11-95b4-6bba6b5a0a5b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 09:57:41
25190	9d68c02a-51d2-4654-89f8-d34cc3306724	9d68c02a-52bf-4b11-95b4-6bba6b5a0a5b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":459,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:57:41
37670	9d6b59a7-9402-4f6e-bd1d-2ed92434bb2b	9d6b59a7-f8b0-4190-bb6e-bc05bf80651c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 16:58:32
37671	9d6b59a7-f4e9-47fc-923e-326d7b3f3bf5	9d6b59a7-f8b0-4190-bb6e-bc05bf80651c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 16:58:32
37672	9d6b59a7-f648-4264-b6f1-ae66805b6708	9d6b59a7-f8b0-4190-bb6e-bc05bf80651c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":905,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:58:32
37673	9d6b59a8-d590-4c55-abf6-5171b5d36fa3	9d6b59a9-0b05-410d-9a4a-3d89782c01cb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 16:58:32
37674	9d6b59a9-01c3-4fcb-b305-c8641cd60229	9d6b59a9-0b05-410d-9a4a-3d89782c01cb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"71.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:58:33
37675	9d6b59a9-0215-4b4b-adfb-65b783871611	9d6b59a9-0b05-410d-9a4a-3d89782c01cb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:58:33
37676	9d6b59a9-0954-4cfe-9c79-d4e02a06dd9b	9d6b59a9-0b05-410d-9a4a-3d89782c01cb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 16:58:33
37677	9d6b59a9-09b3-4716-9d7f-273b702be6bb	9d6b59a9-0b05-410d-9a4a-3d89782c01cb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":543,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:58:33
37678	9d6b59a9-75e7-4348-9aff-469c0cc13de1	9d6b59a9-a226-4968-84cb-833b13b5ec64	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 16:58:33
37679	9d6b59a9-9afa-47e7-9693-e7b4fa9e7a39	9d6b59a9-a226-4968-84cb-833b13b5ec64	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"59.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-05 16:58:33
37680	9d6b59a9-9b77-4a1f-9e01-eb9762b0473d	9d6b59a9-a226-4968-84cb-833b13b5ec64	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-05 16:58:33
37681	9d6b59a9-a0c2-40e5-b8ea-b6492ed25833	9d6b59a9-a226-4968-84cb-833b13b5ec64	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 16:58:33
37682	9d6b59a9-a12e-43ff-b2f3-ae63b2176dd8	9d6b59a9-a226-4968-84cb-833b13b5ec64	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":360,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:58:33
37683	9d6b59aa-0164-486c-a464-5f4edab60c82	9d6b59aa-2175-492c-b6d8-4aa1f40157f7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 16:58:33
37684	9d6b59aa-1bda-454e-acea-5ff1b7d685a3	9d6b59aa-2175-492c-b6d8-4aa1f40157f7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:58:33
37685	9d6b59aa-1c32-4ecd-afb9-ae4db23a5462	9d6b59aa-2175-492c-b6d8-4aa1f40157f7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-05 16:58:33
37686	9d6b59aa-2023-494c-9dae-785a7be4f611	9d6b59aa-2175-492c-b6d8-4aa1f40157f7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 16:58:33
37687	9d6b59aa-2077-4ff1-a40e-f2ab1d1cfc8a	9d6b59aa-2175-492c-b6d8-4aa1f40157f7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":308,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:58:33
41857	9d6cd063-48f6-4f97-942b-fb39aef45738	9d6cd063-62a3-49fe-9647-09ec2551118c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:26:21
41858	9d6cd063-611e-4b70-ace6-315b8e13ccf1	9d6cd063-62a3-49fe-9647-09ec2551118c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:26:22
41859	9d6cd063-61bb-4948-b364-2f65bb3c71b3	9d6cd063-62a3-49fe-9647-09ec2551118c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:26:22
37688	9d6b59aa-6ae4-473d-b3d9-00f4f329098b	9d6b59aa-8a9e-4d81-8cda-948975af6e36	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 16:58:34
37689	9d6b59aa-8330-4a4f-b14e-d35c42d82cd2	9d6b59aa-8a9e-4d81-8cda-948975af6e36	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_valor_prestado\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\" from \\"loans\\" where \\"id\\" = '93' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"43.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":229,"hash":"f00e27e21a94f93c5c7a1d0cd56f9f13","hostname":"EderCortes"}	2024-11-05 16:58:34
37690	9d6b59aa-8396-4b4c-aed7-828a91458bac	9d6b59aa-8a9e-4d81-8cda-948975af6e36	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-05 16:58:34
37691	9d6b59aa-8561-4250-aced-6977ec95c941	9d6b59aa-8a9e-4d81-8cda-948975af6e36	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"2.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":230,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-05 16:58:34
37692	9d6b59aa-8592-49bb-b027-6c9947f84fc5	9d6b59aa-8a9e-4d81-8cda-948975af6e36	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-05 16:58:34
37693	9d6b59aa-8935-4b9b-a9a3-edebc0bde11a	9d6b59aa-8a9e-4d81-8cda-948975af6e36	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 16:58:34
37694	9d6b59aa-897d-43c1-b681-4115bf10aa60	9d6b59aa-8a9e-4d81-8cda-948975af6e36	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"user_creador":22,"user_cobrador":22,"user_customer":19,"user_recomendacion":18},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:19:45.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:22:30.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":399,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":400,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":401,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":402,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"}]}},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:58:34
41860	9d6cd065-176f-412e-87ce-8207e5c6c522	9d6cd065-645a-4f85-9dc5-616906854cca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:26:23
41861	9d6cd065-5c88-4d34-8ebf-db9be76be682	9d6cd065-645a-4f85-9dc5-616906854cca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"150.34","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:26:23
41862	9d6cd065-5ce8-4206-85ee-a6bc5669f075	9d6cd065-645a-4f85-9dc5-616906854cca	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:26:23
41863	9d6cd065-6297-429e-8b0d-41023b0d627d	9d6cd065-645a-4f85-9dc5-616906854cca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:26:23
41864	9d6cd065-6301-47cc-9085-98ffb3b09442	9d6cd065-645a-4f85-9dc5-616906854cca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":412,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:26:23
41865	9d6cd065-bf23-46fb-86f1-1b4adf412129	9d6cd066-0706-40c0-bba9-8ccf27e597cc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:26:23
41866	9d6cd066-0163-4099-b27c-ca5fdaf4f47f	9d6cd066-0706-40c0-bba9-8ccf27e597cc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"153.80","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:26:23
41867	9d6cd066-058a-4f7e-8804-092764cca420	9d6cd066-0706-40c0-bba9-8ccf27e597cc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:26:23
41868	9d6cd066-05f2-40b2-9203-1b7456bc1c10	9d6cd066-0706-40c0-bba9-8ccf27e597cc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":389,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:26:23
41869	9d6cd073-88bf-4440-8441-2024afdc137c	9d6cd073-d6ef-4074-ac79-f19f71fe96b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:26:32
41870	9d6cd073-ce03-4762-9eda-9e6492b847de	9d6cd073-d6ef-4074-ac79-f19f71fe96b0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"151.00","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":19,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-06 10:26:32
37977	9d6b5e4a-cd9a-4eef-8311-28e135f97e0d	9d6b5e4a-f460-4849-9906-af39aa12f708	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 17:11:30
37978	9d6b5e4a-f1e9-4f26-a46c-4a0536dbc2a0	9d6b5e4a-f460-4849-9906-af39aa12f708	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:11:30
37979	9d6b5e4a-f2d0-419e-8d1a-dd6296125d37	9d6b5e4a-f460-4849-9906-af39aa12f708	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":280,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:11:30
41871	9d6cd073-ce77-4cfe-8541-fa68052c306e	9d6cd073-d6ef-4074-ac79-f19f71fe96b0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":5,"hostname":"EderCortes"}	2024-11-06 10:26:32
41872	9d6cd073-d525-4f41-aae9-1f223a651664	9d6cd073-d6ef-4074-ac79-f19f71fe96b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:26:32
41873	9d6cd073-d59d-4a0f-9acd-48367c05049c	9d6cd073-d6ef-4074-ac79-f19f71fe96b0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:55:01.000000Z","deleted_at":null,"user_alias":"eder.cortes"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":473,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:26:32
42438	9d6cde3a-787d-4e92-b676-8b28b1f46c16	9d6cde3a-9244-4efa-8ab6-aecb4ae5a5ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:05:04
42439	9d6cde3a-90b9-4775-8593-7623e7cb1d3a	9d6cde3a-9244-4efa-8ab6-aecb4ae5a5ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 11:05:04
37980	9d6b5e4b-5ddb-4b2c-9714-1b47ec30b1a0	9d6b5e4b-7c09-486c-8a5d-2591a6d4e380	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:11:30
37981	9d6b5e4b-76a1-4a3b-a17c-70dbd24f6a55	9d6b5e4b-7c09-486c-8a5d-2591a6d4e380	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"45.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:11:30
37982	9d6b5e4b-7a76-4aa6-bbf9-e88ebeea296f	9d6b5e4b-7c09-486c-8a5d-2591a6d4e380	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:11:30
37983	9d6b5e4b-7af9-4bc2-b321-f8952cf8a756	9d6b5e4b-7c09-486c-8a5d-2591a6d4e380	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":287,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:11:30
24950	9d68bee2-7075-4076-bd8b-4e2fd83111b8	9d68bee2-8b6f-463c-a410-9185a6ced727	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 09:54:06
24951	9d68bee2-89e8-4a50-af69-1dac45f80a9f	9d68bee2-8b6f-463c-a410-9185a6ced727	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 09:54:06
24952	9d68bee2-8a78-4bf8-b4c3-3bc20dcd79a6	9d68bee2-8b6f-463c-a410-9185a6ced727	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":338,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:54:06
42440	9d6cde3a-9158-4b10-9edf-f9f9a36ae254	9d6cde3a-9244-4efa-8ab6-aecb4ae5a5ba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":216,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:05:04
41806	9d6ccfbc-ac9a-449c-abe6-ee6cd906d151	9d6ccfbc-f7a6-4d88-99b5-b8227bd283e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:24:32
41807	9d6ccfbc-f59d-4b17-9b84-b1ce0d5a3560	9d6ccfbc-f7a6-4d88-99b5-b8227bd283e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:24:32
42694	9d6cdff2-767d-422d-963b-43c8357c46b8	9d6cdff2-96ed-49d0-819f-49a8661c2de4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:09:52
42695	9d6cdff2-94ff-431e-92e6-960e94867ca5	9d6cdff2-96ed-49d0-819f-49a8661c2de4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:09:52
24953	9d68bee3-06a3-4d6c-99ba-da31ca9de8f8	9d68bee3-4f5b-4859-99fc-962a1c65a4ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 09:54:07
24954	9d68bee3-465d-48f7-9ae4-e39d90301243	9d68bee3-4f5b-4859-99fc-962a1c65a4ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"151.40","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 09:54:07
24955	9d68bee3-49cf-47c7-b002-33f378fcae6a	9d68bee3-4f5b-4859-99fc-962a1c65a4ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:54:07
24956	9d68bee3-4a15-4bb7-bd4d-994fe4f110a3	9d68bee3-4f5b-4859-99fc-962a1c65a4ca	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 09:54:07
24957	9d68bee3-4e29-4e03-8e4e-983e979132be	9d68bee3-4f5b-4859-99fc-962a1c65a4ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 09:54:07
24958	9d68bee3-4e78-4a6b-943f-02823bf8d760	9d68bee3-4f5b-4859-99fc-962a1c65a4ca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":455,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:54:07
37984	9d6b5e4b-ce22-435a-a2d7-7b6957944346	9d6b5e4b-edf1-4eea-a6e6-69e40c08eae2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:11:30
29178	9d691369-6d29-4f0c-9233-dd3758a19007	9d691369-977a-42ed-8db0-42c535ec54d0	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 13:50:28
29179	9d691369-955b-447e-88cc-e62b93e9cf11	9d691369-977a-42ed-8db0-42c535ec54d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 13:50:28
29180	9d691369-9635-4028-9dda-79cbdbb3d476	9d691369-977a-42ed-8db0-42c535ec54d0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":316,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:50:28
37985	9d6b5e4b-e84a-4e31-8c3f-361f4e008e45	9d6b5e4b-edf1-4eea-a6e6-69e40c08eae2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:11:30
37986	9d6b5e4b-e8a5-41dd-90c7-65dfe70ac100	9d6b5e4b-edf1-4eea-a6e6-69e40c08eae2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:11:30
37987	9d6b5e4b-ecb9-41c2-b727-b0f0eaafec46	9d6b5e4b-edf1-4eea-a6e6-69e40c08eae2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:11:30
37988	9d6b5e4b-ecfc-4cd5-9072-aabfcfa1e9c6	9d6b5e4b-edf1-4eea-a6e6-69e40c08eae2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":282,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:11:30
42441	9d6cde3c-27f6-4b8f-bc2e-41e3671cadd2	9d6cde3c-6f5b-45a3-abd3-7cbff03e76fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 11:05:05
42442	9d6cde3c-6833-4b9d-90a0-c43eaf5ab31e	9d6cde3c-6f5b-45a3-abd3-7cbff03e76fd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"145.82","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:05:05
42443	9d6cde3c-68b2-407e-bd8c-e273772aa228	9d6cde3c-6f5b-45a3-abd3-7cbff03e76fd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:05:05
42444	9d6cde3c-6e16-436c-9484-cc5ebddef2ee	9d6cde3c-6f5b-45a3-abd3-7cbff03e76fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 11:05:05
29181	9d69136a-0aa4-46c8-a789-168b89a9fbc3	9d69136a-3041-4066-91cc-4d5a85b1404d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 13:50:28
29182	9d69136a-23b7-40c4-80ae-cbad0732cfbc	9d69136a-3041-4066-91cc-4d5a85b1404d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"48.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 13:50:28
29183	9d69136a-2857-47cf-b72a-8d708b38719f	9d69136a-3041-4066-91cc-4d5a85b1404d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:50:28
29184	9d69136a-288c-4119-9255-16dfc496402f	9d69136a-3041-4066-91cc-4d5a85b1404d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:50:28
29185	9d69136a-2e87-4390-b3b5-fd1495cdec83	9d69136a-3041-4066-91cc-4d5a85b1404d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 13:50:28
29186	9d69136a-2eff-4a82-a23f-ce554d70a8eb	9d69136a-3041-4066-91cc-4d5a85b1404d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:50:28
37989	9d6b5e4c-32fe-43b2-8094-a6102ec7877a	9d6b5e4c-7c59-40f6-abe3-9ad9c9479ec3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:11:31
37990	9d6b5e4c-76a5-4419-b7d0-02dd368ad2a8	9d6b5e4c-7c59-40f6-abe3-9ad9c9479ec3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"151.60","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:11:31
37991	9d6b5e4c-7703-4f8a-b064-07105e38be64	9d6b5e4c-7c59-40f6-abe3-9ad9c9479ec3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:11:31
37992	9d6b5e4c-7b0c-4ccd-ab73-22f2ab05491d	9d6b5e4c-7c59-40f6-abe3-9ad9c9479ec3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:11:31
37993	9d6b5e4c-7b60-403e-b8ae-7d30d32bc4ed	9d6b5e4c-7c59-40f6-abe3-9ad9c9479ec3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":346,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:11:31
37994	9d6b5e4e-5990-4534-aec8-1357c65303b2	9d6b5e4e-a448-4f11-8c0a-6c7b1100ffae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:11:32
37995	9d6b5e4e-9f03-458b-9a24-8e6fd27cb963	9d6b5e4e-a448-4f11-8c0a-6c7b1100ffae	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"155.41","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:11:32
37996	9d6b5e4e-9f4c-4806-b513-96cb4f0853d3	9d6b5e4e-a448-4f11-8c0a-6c7b1100ffae	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:11:32
37997	9d6b5e4e-a2d4-4250-9d1e-afbd62254e29	9d6b5e4e-a448-4f11-8c0a-6c7b1100ffae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:11:32
37998	9d6b5e4e-a319-42f1-b1cf-db2e4b959862	9d6b5e4e-a448-4f11-8c0a-6c7b1100ffae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":482,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:11:32
41808	9d6ccfbc-f65f-464a-8232-851d51dbe873	9d6ccfbc-f7a6-4d88-99b5-b8227bd283e7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":436,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:24:32
42445	9d6cde3c-6e5c-42a1-a54a-e588f447992c	9d6cde3c-6f5b-45a3-abd3-7cbff03e76fd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:05:05
34958	9d69c139-e3e3-4ef1-b9d5-1d764aa674c1	9d69c139-e76e-49df-8736-6afc594d0c1c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1581}	2024-11-04 21:56:29
41477	9d6ccce4-be21-40f4-a5ff-309a7a43bf0b	9d6ccce5-0a36-4677-a8dc-5ad9cd396758	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:16:35
41478	9d6ccce5-083f-4060-8257-3f84c59fc190	9d6ccce5-0a36-4677-a8dc-5ad9cd396758	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:16:35
41479	9d6ccce5-08ec-4773-bc01-b8314af7eb81	9d6ccce5-0a36-4677-a8dc-5ad9cd396758	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":435,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:16:35
41809	9d6ccfbf-4455-4fe6-a093-121c6d6abb59	9d6ccfbf-7285-441f-927d-7ec648c55a0a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:24:34
41480	9d6ccce5-7317-46ee-a894-33d2cffcdc8e	9d6ccce5-ba7f-4135-8f93-ba297efa7562	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:16:36
41481	9d6ccce5-b572-4a3f-9895-b1091e9aea05	9d6ccce5-ba7f-4135-8f93-ba297efa7562	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"149.04","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 10:16:36
41482	9d6ccce5-b900-48c9-bd3b-d3e562ac6e9a	9d6ccce5-ba7f-4135-8f93-ba297efa7562	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:16:36
41483	9d6ccce5-b97c-4217-9c90-925406f83d37	9d6ccce5-ba7f-4135-8f93-ba297efa7562	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":375,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:16:36
41810	9d6ccfbf-672b-49b2-b064-dd15e7800181	9d6ccfbf-7285-441f-927d-7ec648c55a0a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"59.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:24:34
41811	9d6ccfbf-67cf-4597-8be7-93715077a617	9d6ccfbf-7285-441f-927d-7ec648c55a0a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:24:34
41812	9d6ccfbf-709b-4c7a-8cd9-6db186d18724	9d6ccfbf-7285-441f-927d-7ec648c55a0a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:24:34
41813	9d6ccfbf-711a-4454-ab71-1c4083d684bf	9d6ccfbf-7285-441f-927d-7ec648c55a0a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":435,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:24:34
42446	9d6cde3c-b447-4a03-b12e-226b3e53d35c	9d6cde3c-ce36-4faa-a16b-9c0f83ea8599	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 11:05:05
41969	9d6cd193-764d-4eee-bed9-6cccd1979ba4	9d6cd193-b65b-4dc9-a085-6b5be1df0023	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:29:41
41970	9d6cd193-b4ca-4ebc-b417-8d8d7da8268d	9d6cd193-b65b-4dc9-a085-6b5be1df0023	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:29:41
42447	9d6cde3c-ca35-4a0c-bf8b-e182a5bef5b2	9d6cde3c-ce36-4faa-a16b-9c0f83ea8599	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"42.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:05:05
42448	9d6cde3c-ccf5-46c7-851f-37ee5871519b	9d6cde3c-ce36-4faa-a16b-9c0f83ea8599	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 11:05:05
41484	9d6ccce6-0d9b-438d-91f3-768638a211c6	9d6ccce6-2ec6-4f32-9200-34f1b5940371	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:16:36
41485	9d6ccce6-290e-45f4-88eb-338601ee228e	9d6ccce6-2ec6-4f32-9200-34f1b5940371	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:16:36
41486	9d6ccce6-298b-4960-9a59-13ce3bde0ed5	9d6ccce6-2ec6-4f32-9200-34f1b5940371	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:16:36
41487	9d6ccce6-2d5a-4dc9-a941-6f912d2596be	9d6ccce6-2ec6-4f32-9200-34f1b5940371	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:16:36
26839	9d68dd0d-340d-4671-aeba-3654a71dc144	9d68dd0d-6c26-402c-b584-e065093e4403	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:18:27
26840	9d68dd0d-68ad-46ce-862c-fd66c83ef990	9d68dd0d-6c26-402c-b584-e065093e4403	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:18:28
26841	9d68dd0d-6a5a-4d07-88e4-53462b0fa6aa	9d68dd0d-6c26-402c-b584-e065093e4403	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":583,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:18:28
41488	9d6ccce6-2da5-452a-8eeb-870ad94b53f8	9d6ccce6-2ec6-4f32-9200-34f1b5940371	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:16:36
41814	9d6ccfbf-f114-4efb-9008-bdbaa43b2708	9d6ccfc0-131a-4e29-87e5-dea5653021ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:24:34
41815	9d6ccfc0-0df1-44f4-b193-bca0a740fdcc	9d6ccfc0-131a-4e29-87e5-dea5653021ff	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"56.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:24:34
41816	9d6ccfc0-116b-44fc-b490-429138fefa0f	9d6ccfc0-131a-4e29-87e5-dea5653021ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:24:34
41817	9d6ccfc0-11d5-4899-a058-cbaf8e520984	9d6ccfc0-131a-4e29-87e5-dea5653021ff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":393,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:24:35
41971	9d6cd193-b564-48b5-81e9-1d1744f7ae67	9d6cd193-b65b-4dc9-a085-6b5be1df0023	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":312,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:29:41
42449	9d6cde3c-cd34-4d44-9368-980b5d4beeb2	9d6cde3c-ce36-4faa-a16b-9c0f83ea8599	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":222,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:05:05
26842	9d68dd0e-2664-4a5a-bc2f-cbccb0137826	9d68dd0e-572d-4a4a-9f86-5d1d854abcf5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:18:28
26843	9d68dd0e-4c87-4946-acdb-851a879b5ffd	9d68dd0e-572d-4a4a-9f86-5d1d854abcf5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"75.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 11:18:28
26844	9d68dd0e-54a2-41c5-8600-4d2ee84509bd	9d68dd0e-572d-4a4a-9f86-5d1d854abcf5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:18:28
26845	9d68dd0e-557f-4181-8614-a62f05f3a853	9d68dd0e-572d-4a4a-9f86-5d1d854abcf5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":519,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:18:28
41489	9d6ccce6-720b-40ed-82f2-b33690935a46	9d6ccce6-9042-4d94-bd98-8a6c4f3c6972	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:16:36
41490	9d6ccce6-8b1b-4ad5-8ddb-10681ece64a8	9d6ccce6-9042-4d94-bd98-8a6c4f3c6972	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:16:36
41491	9d6ccce6-8b6d-4f47-bf5c-32b93c684950	9d6ccce6-9042-4d94-bd98-8a6c4f3c6972	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:16:36
41492	9d6ccce6-8ede-452d-a4db-9002d8754362	9d6ccce6-9042-4d94-bd98-8a6c4f3c6972	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:16:36
41493	9d6ccce6-8f2b-42e8-96cb-e02ce95115a4	9d6ccce6-9042-4d94-bd98-8a6c4f3c6972	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:16:36
41972	9d6cd194-144e-4c6f-882f-c37f9ad10a51	9d6cd194-30d7-4ff8-b7d9-14f9ea25596c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:29:41
41973	9d6cd194-2bcd-41df-830a-d4c929c82ae2	9d6cd194-30d7-4ff8-b7d9-14f9ea25596c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '14' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"39.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":74,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-06 10:29:41
41974	9d6cd194-2c20-4f5e-b814-caaa12e723e6	9d6cd194-30d7-4ff8-b7d9-14f9ea25596c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:29:41
41975	9d6cd194-2fa9-4600-a23b-116a90d897a6	9d6cd194-30d7-4ff8-b7d9-14f9ea25596c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:29:41
41976	9d6cd194-2ff3-4d74-acd6-5fddea05993e	9d6cd194-30d7-4ff8-b7d9-14f9ea25596c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/14","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:29:41
26846	9d68dd0f-2277-4c45-88f9-9c1eecec04b0	9d68dd0f-6ec3-48f3-91e5-26fae7e7bf52	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:18:29
26847	9d68dd0f-619a-4005-b7ab-7c9782c0e352	9d68dd0f-6ec3-48f3-91e5-26fae7e7bf52	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"121.06","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:18:29
26848	9d68dd0f-6236-4998-b286-17a7e4faa422	9d68dd0f-6ec3-48f3-91e5-26fae7e7bf52	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:18:29
26849	9d68dd0f-6c55-40f6-9446-4ca604e80aaa	9d68dd0f-6ec3-48f3-91e5-26fae7e7bf52	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:18:29
26850	9d68dd0f-6cef-4656-9942-3df3d5a1cfdf	9d68dd0f-6ec3-48f3-91e5-26fae7e7bf52	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":691,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:18:29
41494	9d6ccce9-52b4-4205-85c3-cf84c97b8bd8	9d6ccce9-772c-42af-9ce9-36291e92ba29	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:16:38
41495	9d6ccce9-6f0a-4325-afa9-1feab66a55e4	9d6ccce9-772c-42af-9ce9-36291e92ba29	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:16:38
41496	9d6ccce9-6f7c-43fb-92b2-0ae57979bc68	9d6ccce9-772c-42af-9ce9-36291e92ba29	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:16:38
41497	9d6ccce9-7525-4a1f-9d68-5b980cd96ce7	9d6ccce9-772c-42af-9ce9-36291e92ba29	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 10:16:38
41498	9d6ccce9-758f-4821-a282-0096bcfb9afa	9d6ccce9-772c-42af-9ce9-36291e92ba29	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:16:38
41977	9d6cd196-3252-41e1-8cb4-773ef87de889	9d6cd196-57aa-4208-b37e-08095f57abc9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:29:43
41696	9d6ccece-e0c3-4092-b8f4-1da1ce51650f	9d6ccece-ff8d-43f6-9549-e6305fc4fd89	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:21:56
41697	9d6ccece-fdb7-4bc6-b1da-11e7cd1d1fd6	9d6ccece-ff8d-43f6-9549-e6305fc4fd89	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:21:57
41978	9d6cd196-509f-4e17-a317-f965f230f172	9d6cd196-57aa-4208-b37e-08095f57abc9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"51.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:29:43
41979	9d6cd196-5116-444a-a87b-32e080896262	9d6cd196-57aa-4208-b37e-08095f57abc9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:29:43
41980	9d6cd196-55d4-4b04-b41c-0f77b3271c55	9d6cd196-57aa-4208-b37e-08095f57abc9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:29:43
42450	9d6cde58-05cd-4285-a9db-fc6fd764bd8e	9d6cde58-0956-4635-ad1a-7917b550f131	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":200,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:05:23
26851	9d68dd10-d95e-434e-bbe3-1014b7d7324b	9d68dd11-13a4-4e49-bc49-6b26ce051ddd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:18:30
26852	9d68dd11-0c93-4002-9e58-57fd292f6b73	9d68dd11-13a4-4e49-bc49-6b26ce051ddd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"63.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:18:30
26853	9d68dd11-0d0a-418e-8b8c-3a0626261739	9d68dd11-13a4-4e49-bc49-6b26ce051ddd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:18:30
26854	9d68dd11-1192-4466-8449-91522f0aa081	9d68dd11-13a4-4e49-bc49-6b26ce051ddd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:18:30
26855	9d68dd11-1216-49fd-906d-f037d42a92eb	9d68dd11-13a4-4e49-bc49-6b26ce051ddd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":737,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:18:30
41499	9d6ccce9-de01-4e36-a645-38b92f2e5ebd	9d6cccea-21e7-4d10-a198-9d83dcb7a523	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 10:16:39
41500	9d6cccea-1c03-420c-af2a-b1c5c64b3ff4	9d6cccea-21e7-4d10-a198-9d83dcb7a523	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"114.40","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:16:39
31856	9d695656-0f2c-4b05-8f68-f1a0e8389a35	9d695656-5e8f-4bd8-9cc5-ba97baed3968	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 16:57:36
31857	9d695656-5cd6-49af-bb1f-4715200843e3	9d695656-5e8f-4bd8-9cc5-ba97baed3968	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:57:36
31858	9d695656-5d87-469f-8f19-3ac9dc966666	9d695656-5e8f-4bd8-9cc5-ba97baed3968	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":374,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:57:36
38151	9d6b5fd5-55ca-4f17-88c5-a40c1329b683	9d6b5fd5-75ab-485d-9244-67dd23a5c70b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:15:48
38152	9d6b5fd5-73f2-4a4d-abb1-f0d8c2964a70	9d6b5fd5-75ab-485d-9244-67dd23a5c70b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:15:48
38153	9d6b5fd5-74ad-42fa-b85e-76e3c6b542c5	9d6b5fd5-75ab-485d-9244-67dd23a5c70b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":256,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:15:48
41501	9d6cccea-1fe5-4ecf-9e14-10f9bebf0a3a	9d6cccea-21e7-4d10-a198-9d83dcb7a523	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 10:16:39
41502	9d6cccea-2088-4521-b569-692b1e0c0fa2	9d6cccea-21e7-4d10-a198-9d83dcb7a523	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":421,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:16:39
41698	9d6ccece-fe9b-4dba-84a1-3d0d3e6466d2	9d6ccece-ff8d-43f6-9549-e6305fc4fd89	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:21:57
42451	9d6cde58-8796-464b-8096-53fde6e38378	9d6cde58-d835-4a72-95b2-3bcb063fd6b9	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 11:05:23
26856	9d68dd24-4c72-4421-8ad9-159504d989a5	9d68dd24-6b65-4ab7-ad05-9f3efc15a355	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:18:43
26857	9d68dd24-66b4-4401-8d28-f3c6d82187c4	9d68dd24-6b65-4ab7-ad05-9f3efc15a355	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"45.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 11:18:43
26858	9d68dd24-69d3-412b-a554-d3714c26dc3c	9d68dd24-6b65-4ab7-ad05-9f3efc15a355	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:18:43
26859	9d68dd24-6a40-42e7-b99a-d085345a4f52	9d68dd24-6b65-4ab7-ad05-9f3efc15a355	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":405,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:18:43
31859	9d695656-d273-46dc-aebb-485fefeb8caf	9d695656-dabb-49c9-99fc-895fc5c9faa3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:57:36
31860	9d695656-d972-47c3-a538-67d4a01bc442	9d695656-dabb-49c9-99fc-895fc5c9faa3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:57:36
31861	9d695656-d9d4-4b9e-83a3-0784de689b18	9d695656-dabb-49c9-99fc-895fc5c9faa3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":"kasbjfdsajdkjbsajk"},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:57:36
41503	9d6cccea-7cd2-48f3-b746-01d84e386658	9d6cccea-803e-4f81-8133-628d50f23aba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":201,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:16:39
41699	9d6cced1-0253-47d5-9756-71d113861965	9d6cced1-35b5-4b7b-965d-aefc1d9fcef7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:21:58
41700	9d6cced1-2e6b-4d2c-9fe9-531f6ed4b814	9d6cced1-35b5-4b7b-965d-aefc1d9fcef7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"58.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:21:58
41701	9d6cced1-2efa-49a8-a5db-eda8b258df10	9d6cced1-35b5-4b7b-965d-aefc1d9fcef7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:21:58
41702	9d6cced1-33c3-4100-ab3a-f783fd435bfe	9d6cced1-35b5-4b7b-965d-aefc1d9fcef7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:21:58
41703	9d6cced1-341e-416a-8bc9-a855bbc83498	9d6cced1-35b5-4b7b-965d-aefc1d9fcef7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":413,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:21:58
31862	9d695657-2e2e-4b3d-afa5-aa0dde4ed635	9d695657-76c2-4047-8037-012a405c1753	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:57:36
31863	9d695657-7178-4ac7-86d0-60d2727b2110	9d695657-76c2-4047-8037-012a405c1753	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"148.57","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:57:36
31864	9d695657-71d1-43b1-87e6-62ca3ec5c576	9d695657-76c2-4047-8037-012a405c1753	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 16:57:36
31865	9d695657-758b-4fff-87b7-ffe49e26da8c	9d695657-76c2-4047-8037-012a405c1753	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:57:36
31866	9d695657-75dc-4168-b176-e1fd898d5c40	9d695657-76c2-4047-8037-012a405c1753	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":344,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:57:36
41504	9d6cccea-fe54-4f58-bebd-15a4d0afca3e	9d6ccceb-20f2-4fd2-917f-cb7bc9ca43bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 10:16:39
41505	9d6ccceb-19b7-4e65-acb9-be9ffe1435a4	9d6ccceb-20f2-4fd2-917f-cb7bc9ca43bf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"49.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 10:16:39
38154	9d6b5fd5-d0a2-4e03-bc50-6dba9cbf83a4	9d6b5fd6-1621-4e33-b57d-883746b69c66	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:15:49
41506	9d6ccceb-1f0d-4f2e-9d44-b7ea33233a31	9d6ccceb-20f2-4fd2-917f-cb7bc9ca43bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 10:16:39
38155	9d6b5fd6-11a2-4b23-a377-4ca35fc5b6cc	9d6b5fd6-1621-4e33-b57d-883746b69c66	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"150.38","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:15:49
38156	9d6b5fd6-1493-48ff-8327-031a8beec8cc	9d6b5fd6-1621-4e33-b57d-883746b69c66	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:15:49
41507	9d6ccceb-1fa6-48a6-80b7-7490a7fb3cfa	9d6ccceb-20f2-4fd2-917f-cb7bc9ca43bf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":326,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:16:39
41704	9d6cced1-8976-4fdc-89a9-1bf060e76633	9d6cced1-d76b-4cac-81c8-9bab70eddc40	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:21:58
41705	9d6cced1-d14b-4f2c-96f8-8d4b78459fbe	9d6cced1-d76b-4cac-81c8-9bab70eddc40	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"166.81","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:21:58
41706	9d6cced1-d5b1-4cf5-8855-aaf34d9d9488	9d6cced1-d76b-4cac-81c8-9bab70eddc40	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:21:58
41707	9d6cced1-d610-4754-b77a-429678d5ddb1	9d6cced1-d76b-4cac-81c8-9bab70eddc40	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":392,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:21:58
31867	9d695659-c2d6-4578-b48f-475eafcb1f26	9d695659-e735-4adf-b166-675102a28ed6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:57:38
31868	9d695659-e095-4b23-ae7b-1457bdbe1e1c	9d695659-e735-4adf-b166-675102a28ed6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:57:38
31869	9d695659-e0f7-4fe8-8d76-9708a8a9e2ed	9d695659-e735-4adf-b166-675102a28ed6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:57:38
31870	9d695659-e593-417e-9c1b-eece69d7dab0	9d695659-e735-4adf-b166-675102a28ed6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:57:38
31871	9d695659-e5fb-407e-8ab2-cd1e60e1510a	9d695659-e735-4adf-b166-675102a28ed6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":301,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:57:38
38157	9d6b5fd6-14fc-4253-b88c-cd66fca4e5b3	9d6b5fd6-1621-4e33-b57d-883746b69c66	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:15:49
41508	9d6cccf1-f3b0-4e86-a69c-f3320566677f	9d6cccf1-f7bb-4acd-98f5-c01abadf54bf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":193,"memory":20,"hostname":"EderCortes"}	2024-11-06 10:16:44
41981	9d6cd196-5641-4ac7-a8e8-546b17d449e5	9d6cd196-57aa-4208-b37e-08095f57abc9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":311,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:29:43
41628	9d6cce3d-c1e6-44e6-a5d8-4447583fe6ef	9d6cce3e-0ce7-49cc-8f0c-daba664aa5e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:20:21
41629	9d6cce3e-0aec-4d09-9eaf-7786a30b6ce9	9d6cce3e-0ce7-49cc-8f0c-daba664aa5e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:20:22
41755	9d6ccf24-26a8-4668-b132-c106d81d4cdd	9d6ccf24-4056-4630-af53-725b03343b36	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:22:52
41756	9d6ccf24-3ecb-4168-bf02-6960b8cc636c	9d6ccf24-4056-4630-af53-725b03343b36	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:22:52
38158	9d6b5fd6-6933-4122-bde2-b925e178c555	9d6b5fd6-89b3-4807-a252-099055c17854	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:15:49
38159	9d6b5fd6-83f6-4a72-9440-a7f2e3b0a058	9d6b5fd6-89b3-4807-a252-099055c17854	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:15:49
38160	9d6b5fd6-844b-4cf3-ab61-63452e2ff17b	9d6b5fd6-89b3-4807-a252-099055c17854	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:15:49
38161	9d6b5fd6-8853-41e3-8d45-5d14dcf7a5f7	9d6b5fd6-89b3-4807-a252-099055c17854	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 17:15:49
38162	9d6b5fd6-8896-4e6d-b179-6adced88232e	9d6b5fd6-89b3-4807-a252-099055c17854	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":276,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:15:49
41509	9d6cccf2-7165-4993-9481-819c8aa485f7	9d6cccf2-9f60-4658-8c71-109d5d4b93d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 10:16:44
41510	9d6cccf2-9838-4603-87f8-c8be6f2a8d33	9d6cccf2-9f60-4658-8c71-109d5d4b93d5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"60.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:16:44
41511	9d6cccf2-98af-48b2-8831-aab5b15bf773	9d6cccf2-9f60-4658-8c71-109d5d4b93d5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:16:44
41512	9d6cccf2-9d8d-40fb-809b-6b2eb4ca864e	9d6cccf2-9f60-4658-8c71-109d5d4b93d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 10:16:44
41513	9d6cccf2-9e05-489d-a0b4-34c0f8688c9f	9d6cccf2-9f60-4658-8c71-109d5d4b93d5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":366,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:16:44
41630	9d6cce3e-0bbe-4dcd-bddb-0ec0545bb83d	9d6cce3e-0ce7-49cc-8f0c-daba664aa5e8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":424,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:20:22
41982	9d6cd196-bb29-4237-9732-a0c4199f9684	9d6cd196-dd88-403a-85a9-1ac71f48500e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:29:43
41983	9d6cd196-d7e1-4794-8d87-44542ce03eb8	9d6cd196-dd88-403a-85a9-1ac71f48500e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"50.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:29:43
41984	9d6cd196-dc0a-4830-a5b7-1c45ed665689	9d6cd196-dd88-403a-85a9-1ac71f48500e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:29:43
38163	9d6b5fd6-d64c-4df6-b9d7-8f06a05827ee	9d6b5fd7-1f16-43d7-837a-f0b33f4b4275	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 17:15:49
38164	9d6b5fd7-189e-49b9-bc77-3c1154fad6fa	9d6b5fd7-1f16-43d7-837a-f0b33f4b4275	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"145.43","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:15:49
38165	9d6b5fd7-1904-473e-aeef-ab94f60453b0	9d6b5fd7-1f16-43d7-837a-f0b33f4b4275	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:15:49
38166	9d6b5fd7-1dea-4d3c-9452-57df05448bf5	9d6b5fd7-1f16-43d7-837a-f0b33f4b4275	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 17:15:49
38167	9d6b5fd7-1e31-43ac-97b8-7bfecdbf69f9	9d6b5fd7-1f16-43d7-837a-f0b33f4b4275	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":368,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:15:49
41514	9d6cccf2-f4d4-4c5d-817a-5a450e9e03d5	9d6cccf3-15cf-46b0-838f-8d015c523920	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 10:16:45
41515	9d6cccf3-0f1b-418d-a6e2-19f77dd4b659	9d6cccf3-15cf-46b0-838f-8d015c523920	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:16:45
41516	9d6cccf3-0f92-4527-8d6d-9e23ae868250	9d6cccf3-15cf-46b0-838f-8d015c523920	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:16:45
41517	9d6cccf3-13fd-449d-9362-f960e66feafd	9d6cccf3-15cf-46b0-838f-8d015c523920	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 10:16:45
41518	9d6cccf3-1499-4b1d-833d-bb136a0fe878	9d6cccf3-15cf-46b0-838f-8d015c523920	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":283,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:16:45
41631	9d6cce40-06af-4a26-9165-b18e52b39fd1	9d6cce40-357e-42d2-925b-0b441a98ea95	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:20:23
41632	9d6cce40-29e5-4f83-af36-24b7bd273b40	9d6cce40-357e-42d2-925b-0b441a98ea95	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"55.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:20:23
41633	9d6cce40-2a84-463d-9072-ce483828a108	9d6cce40-357e-42d2-925b-0b441a98ea95	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:20:23
41634	9d6cce40-33b1-40b2-8cf1-5d61fd59deff	9d6cce40-357e-42d2-925b-0b441a98ea95	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:20:23
41635	9d6cce40-341b-4706-a4ba-4df0f9bdfcd4	9d6cce40-357e-42d2-925b-0b441a98ea95	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":429,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:20:23
42452	9d6cde58-d06c-41e7-b6ef-4250361b58e7	9d6cde58-d835-4a72-95b2-3bcb063fd6b9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"150.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 11:05:23
38168	9d6b5fd9-735e-4d02-8bdb-764d702ad6c2	9d6b5fd9-95c2-40e1-8996-6462138ff560	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 17:15:51
38169	9d6b5fd9-8f48-4be1-9b15-803920100231	9d6b5fd9-95c2-40e1-8996-6462138ff560	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"47.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:15:51
38170	9d6b5fd9-8f9a-43a2-ac7b-2423e56ff330	9d6b5fd9-95c2-40e1-8996-6462138ff560	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:15:51
38171	9d6b5fd9-93e8-4234-9284-2b280244694a	9d6b5fd9-95c2-40e1-8996-6462138ff560	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 17:15:51
38172	9d6b5fd9-945c-4477-85f8-a4fc8022beea	9d6b5fd9-95c2-40e1-8996-6462138ff560	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":465,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:15:51
41519	9d6cccf3-6331-4fa5-a28c-8301b87b8d55	9d6cccf3-810b-49c3-aaef-92939d5a3d8d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 10:16:45
41520	9d6cccf3-7bc4-4f2a-9ca9-58ac2bf32daa	9d6cccf3-810b-49c3-aaef-92939d5a3d8d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"45.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":89,"hash":"f9f3598e6ad2468770f89917d2ab916c","hostname":"EderCortes"}	2024-11-06 10:16:45
41521	9d6cccf3-7fa1-4e36-a3d5-56f15c32e91d	9d6cccf3-810b-49c3-aaef-92939d5a3d8d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 10:16:45
41522	9d6cccf3-8008-4e73-9ec4-1cf2ade2839b	9d6cccf3-810b-49c3-aaef-92939d5a3d8d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getLoansCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:16:45
41636	9d6cce40-a710-4e5b-9449-ca747332f77c	9d6cce41-2315-4fa7-87ef-487f92fb119c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:20:23
41637	9d6cce41-18e6-4e5b-ad1a-703c7ed37cc6	9d6cce41-2315-4fa7-87ef-487f92fb119c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"112.66","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:20:24
41638	9d6cce41-2114-403d-98c7-8dbf47635d49	9d6cce41-2315-4fa7-87ef-487f92fb119c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:20:24
41639	9d6cce41-2177-4162-b7d4-62c52d6674bf	9d6cce41-2315-4fa7-87ef-487f92fb119c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":570,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:20:24
41757	9d6ccf24-3f66-482b-8573-04669ded4864	9d6ccf24-4056-4630-af53-725b03343b36	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":228,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:22:52
41985	9d6cd196-dc69-4edb-86b2-48659d1f3bc7	9d6cd196-dd88-403a-85a9-1ac71f48500e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":325,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:29:43
32010	9d69586a-1d6e-4dda-bd85-e157d78400ca	9d69586a-56a4-4fba-a7bc-26f5cb3d7c69	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 17:03:24
32011	9d69586a-53b7-40dc-bf09-42b6cf640be0	9d69586a-56a4-4fba-a7bc-26f5cb3d7c69	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 17:03:24
32012	9d69586a-54fe-4a3c-a51b-52f3cd536033	9d69586a-56a4-4fba-a7bc-26f5cb3d7c69	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":514,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:03:24
42453	9d6cde58-d10c-4bda-b4a4-a5b8fb94d88f	9d6cde58-d835-4a72-95b2-3bcb063fd6b9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 11:05:23
42454	9d6cde58-d640-45c7-a530-628101aef8b1	9d6cde58-d835-4a72-95b2-3bcb063fd6b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:05:23
42455	9d6cde58-d6ac-4108-9a1f-1f6393ac4b43	9d6cde58-d835-4a72-95b2-3bcb063fd6b9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":371,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:05:23
42696	9d6cdff2-95c3-4e87-9919-c930e6618512	9d6cdff2-96ed-49d0-819f-49a8661c2de4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":319,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:09:52
32013	9d69586a-f884-4fc4-8584-24c23fc6f5ec	9d69586b-22ab-4079-930d-5843c90f4287	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 17:03:25
32014	9d69586b-1b89-4ab9-98c9-83592fb644b0	9d69586b-22ab-4079-930d-5843c90f4287	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"53.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":227,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 17:03:25
32015	9d69586b-1be6-4a1c-af29-f06ac89c9f0c	9d69586b-22ab-4079-930d-5843c90f4287	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 17:03:25
32016	9d69586b-2124-4c5f-a7e2-8e584c700284	9d69586b-22ab-4079-930d-5843c90f4287	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 17:03:25
32017	9d69586b-2186-4b2d-896c-f57b6ea2053a	9d69586b-22ab-4079-930d-5843c90f4287	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":435,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:03:25
41758	9d6ccf25-6465-4e90-9226-673ddb5f6987	9d6ccf25-922f-45c9-82bb-0dc7690de9c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:22:53
41759	9d6ccf25-8b45-4d50-bf54-25c5956fdb0c	9d6ccf25-922f-45c9-82bb-0dc7690de9c2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"57.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:22:53
41760	9d6ccf25-8bb2-4201-afc1-fa75c65ae984	9d6ccf25-922f-45c9-82bb-0dc7690de9c2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:22:53
41761	9d6ccf25-90ea-426d-8a67-b3ed297ef2a1	9d6ccf25-922f-45c9-82bb-0dc7690de9c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 10:22:53
41762	9d6ccf25-913c-4a6e-8a2f-faf94a0ea198	9d6ccf25-922f-45c9-82bb-0dc7690de9c2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":447,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:22:53
41986	9d6cd1bc-28bb-4105-8568-2b9833b26ea0	9d6cd1bc-5055-47dd-91dc-4f07e74cbb7e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:30:07
41987	9d6cd1bc-484e-4a5c-99c5-0e4ee816174b	9d6cd1bc-5055-47dd-91dc-4f07e74cbb7e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"49.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":19,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-06 10:30:08
41988	9d6cd1bc-48b9-46d5-bff9-391d12cbf4aa	9d6cd1bc-5055-47dd-91dc-4f07e74cbb7e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":5,"hostname":"EderCortes"}	2024-11-06 10:30:08
41989	9d6cd1bc-4e74-46dd-bc87-778b4b33bafa	9d6cd1bc-5055-47dd-91dc-4f07e74cbb7e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:30:08
41990	9d6cd1bc-4ef0-4c5b-9cb9-d77a6fa190b1	9d6cd1bc-5055-47dd-91dc-4f07e74cbb7e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:55:01.000000Z","deleted_at":null,"user_alias":"eder.cortes"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":500,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:30:08
42456	9d6cde59-5766-485b-8066-c706ca66b4ba	9d6cde59-749e-43b1-a32f-e72c09a78dd7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:05:24
42697	9d6cdff3-0838-4a0b-afb5-f493f929f417	9d6cdff3-2d66-4272-ad8b-360718fb8466	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:09:52
32018	9d69586b-8648-4cc9-92db-60fb7263f9c4	9d69586b-b200-4b6d-a944-f3401aa7d211	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 17:03:25
32019	9d69586b-a877-4b16-b431-bc876689dd84	9d69586b-b200-4b6d-a944-f3401aa7d211	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"63.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":216,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 17:03:25
32020	9d69586b-a90b-417c-8d11-ccc331857cc0	9d69586b-b200-4b6d-a944-f3401aa7d211	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":3,"hostname":"EderCortes"}	2024-11-04 17:03:25
32021	9d69586b-b013-4155-aca5-5b77187fdff6	9d69586b-b200-4b6d-a944-f3401aa7d211	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 17:03:25
32022	9d69586b-b096-4b38-9549-bf2ce71966fe	9d69586b-b200-4b6d-a944-f3401aa7d211	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:03:25
41763	9d6ccf26-1493-4a14-9e4e-59bd1efff39d	9d6ccf26-5c74-4062-9410-37dc8f844750	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 10:22:54
41764	9d6ccf26-569e-4440-9d96-69ae9642701d	9d6ccf26-5c74-4062-9410-37dc8f844750	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"148.76","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:22:54
41765	9d6ccf26-5acc-4c79-9e31-12c82137b70a	9d6ccf26-5c74-4062-9410-37dc8f844750	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 10:22:54
41766	9d6ccf26-5b31-4db8-88ba-5dfd793679dc	9d6ccf26-5c74-4062-9410-37dc8f844750	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":496,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:22:54
41991	9d6cd343-46f9-47fe-9f3e-4bd16d137beb	9d6cd343-4b3c-4c12-b6e7-c877f0c7f2ba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":201,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:34:24
42457	9d6cde59-6f65-46d0-b660-d0779db85e9c	9d6cde59-749e-43b1-a32f-e72c09a78dd7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 11:05:24
42458	9d6cde59-6fb9-4804-8d09-7d823d0bcd87	9d6cde59-749e-43b1-a32f-e72c09a78dd7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 11:05:24
42459	9d6cde59-7302-406c-906d-15137a205b28	9d6cde59-749e-43b1-a32f-e72c09a78dd7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:05:24
42460	9d6cde59-734d-45cf-84b0-18d4b9961bb3	9d6cde59-749e-43b1-a32f-e72c09a78dd7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":386,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:05:24
42698	9d6cdff3-26cf-47bc-9965-4378b52b8417	9d6cdff3-2d66-4272-ad8b-360718fb8466	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 11:09:52
42699	9d6cdff3-272c-4077-853e-fde51fd851aa	9d6cdff3-2d66-4272-ad8b-360718fb8466	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 11:09:52
32023	9d69586c-2575-40a8-8828-3a54b3472749	9d69586c-5028-47ec-80e8-c98cf0b75d7d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 17:03:26
32024	9d69586c-4980-4f50-baf9-1ef75df5fb63	9d69586c-5028-47ec-80e8-c98cf0b75d7d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"56.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 17:03:26
32025	9d69586c-49fa-4cf9-9ab4-17cd60ebe841	9d69586c-5028-47ec-80e8-c98cf0b75d7d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 17:03:26
32026	9d69586c-4eb5-4b43-9a80-cc622ece087e	9d69586c-5028-47ec-80e8-c98cf0b75d7d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 17:03:26
32027	9d69586c-4f17-40af-a7d1-cd4ef026d7e1	9d69586c-5028-47ec-80e8-c98cf0b75d7d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":382,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:03:26
193	9d4f0eed-f3b2-4ee5-b7ec-3d97999a5381	9d4f0eee-0853-4242-b7da-9bf06ac77eb7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42P01]: Undefined table: 7 ERROR:  no existe la relaci\\u00f3n \\u00abitem_menu_menu\\u00bb\\nLINE 1: select * from \\"menu\\" inner join \\"item_menu_menu\\" on \\"menu\\".\\"...\\n                                        ^ (Connection: pgsql, SQL: select * from \\"menu\\" inner join \\"item_menu_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu_menu\\".\\"item_menu_menu\\" where \\"item_menu_menu\\".\\"item_menu_profile\\" = 12 and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":45},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":12}	2024-10-22 15:26:24
32028	9d69586c-f236-4c9a-856a-e9da8fc64e07	9d69586d-3dd1-4408-95d5-1ac3c6cae03f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 17:03:26
32029	9d69586d-31e1-46c9-bfda-150170ca8d98	9d69586d-3dd1-4408-95d5-1ac3c6cae03f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"114.28","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 17:03:26
32030	9d69586d-327d-44ef-91c2-9b796fc6edfd	9d69586d-3dd1-4408-95d5-1ac3c6cae03f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 17:03:26
32031	9d69586d-3b4b-4444-992d-e76dc4d7fbea	9d69586d-3dd1-4408-95d5-1ac3c6cae03f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 17:03:26
32032	9d69586d-3bf4-4998-8012-1cce5bbfe611	9d69586d-3dd1-4408-95d5-1ac3c6cae03f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":584,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:03:26
41992	9d6cd343-dc33-465a-877a-15f81048e608	9d6cd345-7d92-4a24-a257-08023456d906	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:34:24
41993	9d6cd345-5b23-43fa-b6fa-26459bcffa8c	9d6cd345-7d92-4a24-a257-08023456d906	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"42.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 10:34:25
41994	9d6cd345-5b8b-47d2-bbaa-18596dd5a8bb	9d6cd345-7d92-4a24-a257-08023456d906	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:34:25
41995	9d6cd345-7bd1-4db7-8caa-f49fd19727a0	9d6cd345-7d92-4a24-a257-08023456d906	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:34:25
41996	9d6cd345-7c26-43f7-8cbd-adbc6904135e	9d6cd345-7d92-4a24-a257-08023456d906	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","profile":1},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":1263,"memory":24,"hostname":"EderCortes"}	2024-11-06 10:34:25
42461	9d6cde59-bcc5-47e8-a464-0ce179911d51	9d6cde59-d9a0-49a2-9c7b-daa0043a524e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:05:24
42462	9d6cde59-d4c0-46fe-95a9-1eeb58227b28	9d6cde59-d9a0-49a2-9c7b-daa0043a524e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"43.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 11:05:24
42463	9d6cde59-d836-4704-ab67-5d31c83bf3c9	9d6cde59-d9a0-49a2-9c7b-daa0043a524e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:05:24
42464	9d6cde59-d8a2-4cc8-960f-b39201cc4f4c	9d6cde59-d9a0-49a2-9c7b-daa0043a524e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:05:24
42700	9d6cdff3-2bff-481f-bd5d-e7c9df9841cd	9d6cdff3-2d66-4272-ad8b-360718fb8466	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:09:52
42701	9d6cdff3-2c57-4df3-b3f9-6b4ab37e40ca	9d6cdff3-2d66-4272-ad8b-360718fb8466	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":295,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:09:52
32033	9d69586e-352a-44e5-a4f4-d7783c2d62f6	9d69586e-91fe-4232-bfd9-e33f8f1d9485	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 17:03:27
32034	9d69586e-8b15-43b4-91ba-9715e4dab235	9d69586e-91fe-4232-bfd9-e33f8f1d9485	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"143.62","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 17:03:27
32035	9d69586e-8b74-4076-859b-828ed498623c	9d69586e-91fe-4232-bfd9-e33f8f1d9485	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 17:03:27
32036	9d69586e-8fd1-4931-a8bb-1c0d054e317d	9d69586e-91fe-4232-bfd9-e33f8f1d9485	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 17:03:27
32037	9d69586e-908e-495b-b732-77d380fdb5bd	9d69586e-91fe-4232-bfd9-e33f8f1d9485	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":701,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:03:27
41997	9d6cd346-489e-404e-a3b7-c3930045f078	9d6cd346-91a0-465d-8592-7ac79c18eb3b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:34:26
41998	9d6cd346-8c97-4686-a548-e76f09072d09	9d6cd346-91a0-465d-8592-7ac79c18eb3b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"153.03","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:34:26
41999	9d6cd346-8ceb-426a-9fae-c773a3dacdf6	9d6cd346-91a0-465d-8592-7ac79c18eb3b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:34:26
42000	9d6cd346-9054-435e-82a2-98e19b18292d	9d6cd346-91a0-465d-8592-7ac79c18eb3b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:34:26
42001	9d6cd346-90a1-4996-af46-ee7335d66c55	9d6cd346-91a0-465d-8592-7ac79c18eb3b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":563,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:34:26
42465	9d6cde5f-161f-4600-8006-abd017ca71bf	9d6cde5f-18fe-49a8-ba72-748e1a35e08b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":142,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:05:28
42702	9d6cdff3-7453-476e-bc6c-605d1392c0a3	9d6cdff3-bf93-4f4e-8f46-8e17b46dd342	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:09:53
42703	9d6cdff3-bab9-45ef-b3d6-9ef22fba51f2	9d6cdff3-bf93-4f4e-8f46-8e17b46dd342	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"156.64","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":286,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-06 11:09:53
42704	9d6cdff3-bb09-4404-8674-fef9b69cf8ba	9d6cdff3-bf93-4f4e-8f46-8e17b46dd342	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-06 11:09:53
42705	9d6cdff3-be71-4070-986e-ec0b7071e2da	9d6cdff3-bf93-4f4e-8f46-8e17b46dd342	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:09:53
42002	9d6cd346-d17a-4559-a538-1ce027bbd859	9d6cd347-11b4-4222-9b2b-73d6cb96db40	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:34:26
42003	9d6cd347-0dac-4876-bc41-51c534860556	9d6cd347-11b4-4222-9b2b-73d6cb96db40	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"143.27","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:34:26
42004	9d6cd347-1082-4efd-82db-56d7cc20f118	9d6cd347-11b4-4222-9b2b-73d6cb96db40	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:34:26
42005	9d6cd347-10ca-48bf-8fe3-7fbacea40e3e	9d6cd347-11b4-4222-9b2b-73d6cb96db40	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":315,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:34:26
42466	9d6cde5f-6b96-425d-940f-b8a7045dc886	9d6cde5f-8b2a-4202-99dd-2d2d4b24eba6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:05:28
42467	9d6cde5f-8584-4cd3-9996-b5256e931a89	9d6cde5f-8b2a-4202-99dd-2d2d4b24eba6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 11:05:28
42468	9d6cde5f-85d7-45ca-8f84-849bdf469b3c	9d6cde5f-8b2a-4202-99dd-2d2d4b24eba6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 11:05:28
42469	9d6cde5f-89e3-40ea-ba6c-2faba1385fb1	9d6cde5f-8b2a-4202-99dd-2d2d4b24eba6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:05:28
42470	9d6cde5f-8a30-4a0d-b2a5-518f81e0959e	9d6cde5f-8b2a-4202-99dd-2d2d4b24eba6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:05:28
42706	9d6cdff3-beb7-4a4a-98df-08609158832e	9d6cdff3-bf93-4f4e-8f46-8e17b46dd342	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":358,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:09:53
42471	9d6cde5f-cd95-430e-9bfd-84fa4c826ac7	9d6cde5f-ed54-479b-9578-36b1864fde3a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:05:28
42472	9d6cde5f-e734-4b8a-a840-d325202837c7	9d6cde5f-ed54-479b-9578-36b1864fde3a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 11:05:28
42473	9d6cde5f-e797-45f8-84db-383212ed8e92	9d6cde5f-ed54-479b-9578-36b1864fde3a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 11:05:28
38312	9d6b62ba-89cf-4679-adbe-636a1f93bd99	9d6b62ba-b303-4c34-be66-cab027c09126	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 17:23:54
38313	9d6b62ba-b097-4a06-ba16-d296322897a9	9d6b62ba-b303-4c34-be66-cab027c09126	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:23:54
38314	9d6b62ba-b19e-4162-8304-a70ceb000614	9d6b62ba-b303-4c34-be66-cab027c09126	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":328,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:23:54
42474	9d6cde5f-ebfd-409f-8ceb-edef78fe9d9f	9d6cde5f-ed54-479b-9578-36b1864fde3a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:05:28
42475	9d6cde5f-ec4d-4e36-b534-aea352cc36af	9d6cde5f-ed54-479b-9578-36b1864fde3a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:05:28
42707	9d6cdff4-0203-4e99-b524-efd56128311b	9d6cdff4-4d92-432b-9066-5b81969eebb3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:09:53
42708	9d6cdff4-48ca-4ffd-92d2-ca7fd0996b08	9d6cdff4-4d92-432b-9066-5b81969eebb3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"155.46","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":235,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 11:09:53
42709	9d6cdff4-4914-4a77-838a-0a3b7d77b6e3	9d6cdff4-4d92-432b-9066-5b81969eebb3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-06 11:09:53
42710	9d6cdff4-4c63-435a-acbc-606d89cbb878	9d6cdff4-4d92-432b-9066-5b81969eebb3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:09:53
42711	9d6cdff4-4cb5-46f3-858f-cd14d397fe2a	9d6cdff4-4d92-432b-9066-5b81969eebb3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":343,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:09:53
38315	9d6b62bb-24e1-4462-9882-348cf7ef713b	9d6b62bb-448e-4f13-96e0-084d9b732313	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:23:54
38316	9d6b62bb-3f09-46be-89e4-f3c6f3a7235d	9d6b62bb-448e-4f13-96e0-084d9b732313	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"46.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:23:55
38317	9d6b62bb-42dd-4a4d-9a98-298cc6541c9c	9d6b62bb-448e-4f13-96e0-084d9b732313	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:23:55
38318	9d6b62bb-435b-4837-8c12-cd2a3cd33c98	9d6b62bb-448e-4f13-96e0-084d9b732313	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":309,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:23:55
29370	9d691943-855d-4f9b-b50e-d4cf1ab7abbb	9d691943-c8c8-4068-a571-c1aa67ad4354	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 14:06:49
29371	9d691943-c53c-43e3-9496-f1c3c8172022	9d691943-c8c8-4068-a571-c1aa67ad4354	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 14:06:49
29372	9d691943-c714-4996-aaef-0d26c53fec95	9d691943-c8c8-4068-a571-c1aa67ad4354	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":566,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:06:49
42476	9d6cde60-35d1-4828-8097-1455ee507b18	9d6cde60-51a8-4cbc-9c33-dfc65a7f6528	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:05:28
42477	9d6cde60-4d4b-4e89-b340-ab6d2fff40cb	9d6cde60-51a8-4cbc-9c33-dfc65a7f6528	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"42.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":89,"hash":"f9f3598e6ad2468770f89917d2ab916c","hostname":"EderCortes"}	2024-11-06 11:05:28
42060	9d6cd403-c719-4278-b702-b8d59ff10299	9d6cd403-e265-4172-ab43-a1f1ebb1437c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:36:30
42061	9d6cd403-e08c-48e7-8325-2f8536914885	9d6cd403-e265-4172-ab43-a1f1ebb1437c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 10:36:30
42478	9d6cde60-502c-4cac-848d-30b2088aa4ba	9d6cde60-51a8-4cbc-9c33-dfc65a7f6528	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 11:05:28
42479	9d6cde60-5095-470b-bedd-86f185039a9d	9d6cde60-51a8-4cbc-9c33-dfc65a7f6528	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getLoansCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:05:28
42712	9d6cdff6-8ea8-4b50-8c77-b2efccabf8f6	9d6cdff6-ae90-45c7-9606-7adc14e6ad22	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:09:55
42713	9d6cdff6-a99e-4c8b-8055-69236470074d	9d6cdff6-ae90-45c7-9606-7adc14e6ad22	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:09:55
42714	9d6cdff6-a9ea-4f93-83cb-f11efa28a999	9d6cdff6-ae90-45c7-9606-7adc14e6ad22	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:09:55
29373	9d691944-68f2-4408-8055-d50650a75094	9d691944-a170-451e-8d00-ccae798b836e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 14:06:50
29374	9d691944-9617-4863-a485-0ed0460906d9	9d691944-a170-451e-8d00-ccae798b836e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"72.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":17,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-04 14:06:50
29375	9d691944-96a9-4d5b-a785-4ced5ce9256e	9d691944-a170-451e-8d00-ccae798b836e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 14:06:50
29376	9d691944-9f19-4ab7-b28a-ed2889c0907d	9d691944-a170-451e-8d00-ccae798b836e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 14:06:50
29377	9d691944-9fc5-4aec-a2bd-528490725243	9d691944-a170-451e-8d00-ccae798b836e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"},{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":457,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:06:50
38319	9d6b62bb-91b6-4484-afbf-f5b477baceeb	9d6b62bb-bb2a-43b5-9140-bfe0fd3e898f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:23:55
38320	9d6b62bb-b2ca-43be-972f-caa5e3a903f6	9d6b62bb-bb2a-43b5-9140-bfe0fd3e898f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"59.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:23:55
38321	9d6b62bb-b370-4a6d-9b90-12f9c20e5310	9d6b62bb-bb2a-43b5-9140-bfe0fd3e898f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:23:55
38322	9d6b62bb-b967-4e04-a7c1-228bd9d3be93	9d6b62bb-bb2a-43b5-9140-bfe0fd3e898f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:23:55
38323	9d6b62bb-b9fb-4997-acb7-10fbee3e4303	9d6b62bb-bb2a-43b5-9140-bfe0fd3e898f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":288,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:23:55
42062	9d6cd403-e156-4111-bf16-861e09d786a6	9d6cd403-e265-4172-ab43-a1f1ebb1437c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:36:30
42480	9d6cde64-e14f-4d7c-b024-0059f2019a28	9d6cde65-2628-4473-ba58-9259aaa63f42	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 11:05:31
42481	9d6cde65-20ec-4c73-9481-720105359b15	9d6cde65-2628-4473-ba58-9259aaa63f42	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"139.84","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 11:05:31
42482	9d6cde65-2154-4aa2-ba83-dfba6577b461	9d6cde65-2628-4473-ba58-9259aaa63f42	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 11:05:31
42483	9d6cde65-24ef-43cb-bcb8-084339d303dc	9d6cde65-2628-4473-ba58-9259aaa63f42	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 11:05:31
42715	9d6cdff6-ad4d-45d9-9a28-e8d6ce8892e7	9d6cdff6-ae90-45c7-9606-7adc14e6ad22	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 11:09:55
29378	9d691945-580a-4455-aa2c-83180281ceea	9d691945-9664-4c60-a055-99f10f1fa7f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 14:06:51
29379	9d691945-8a5b-4f86-aada-253cc8594f4e	9d691945-9664-4c60-a055-99f10f1fa7f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"83.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:06:51
29380	9d691945-8af5-4e57-9ee7-58d350f6c869	9d691945-9664-4c60-a055-99f10f1fa7f0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:06:51
29381	9d691945-93b4-4dec-bdf1-22727770ae32	9d691945-9664-4c60-a055-99f10f1fa7f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 14:06:51
29382	9d691945-9477-4928-a5e5-d9044debff8b	9d691945-9664-4c60-a055-99f10f1fa7f0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":598,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:06:51
38324	9d6b62bc-2cdd-41d2-893c-f048f53b8814	9d6b62bc-7e64-43e5-9ba1-cd523937556d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:23:55
38325	9d6b62bc-7569-477c-89f2-31d1de265281	9d6b62bc-7e64-43e5-9ba1-cd523937556d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"65.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:23:55
38326	9d6b62bc-7629-4c38-83d9-df963ddfa625	9d6b62bc-7e64-43e5-9ba1-cd523937556d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:23:55
38327	9d6b62bc-7c73-47b4-8f43-482e3c3e18ee	9d6b62bc-7e64-43e5-9ba1-cd523937556d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:23:55
38328	9d6b62bc-7d0b-4856-a13e-a5bca1c7ec11	9d6b62bc-7e64-43e5-9ba1-cd523937556d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":471,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:23:55
42063	9d6cd405-ca0f-4fe0-809a-cf864d259c36	9d6cd405-efa1-484c-8eaf-e2c48b7d2e6b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:36:31
42064	9d6cd405-e949-4b98-bd3a-55ad38f1ecf5	9d6cd405-efa1-484c-8eaf-e2c48b7d2e6b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:36:31
42065	9d6cd405-e9a8-4362-bd9f-91372fd345ce	9d6cd405-efa1-484c-8eaf-e2c48b7d2e6b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:36:31
42066	9d6cd405-edaf-4c9f-8820-30401dcf0915	9d6cd405-efa1-484c-8eaf-e2c48b7d2e6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:36:31
42067	9d6cd405-ee22-4962-9cdb-5e10bd64bfe6	9d6cd405-efa1-484c-8eaf-e2c48b7d2e6b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":261,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:36:31
29383	9d691946-4697-46b4-803d-51d84af80192	9d691946-8d49-49ae-9be9-cd7c6a2d4769	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 14:06:51
29384	9d691946-826d-45ed-9009-63d924156aa5	9d691946-8d49-49ae-9be9-cd7c6a2d4769	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"114.00","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:06:51
29385	9d691946-8319-49bc-a146-e8da6340aae9	9d691946-8d49-49ae-9be9-cd7c6a2d4769	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:06:51
29386	9d691946-8ad1-4f78-b557-56f431a2b090	9d691946-8d49-49ae-9be9-cd7c6a2d4769	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 14:06:51
29387	9d691946-8bb3-46df-a4e8-0f75ae76af44	9d691946-8d49-49ae-9be9-cd7c6a2d4769	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":603,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:06:51
38329	9d6b62be-ab40-48bb-ba67-e008c1892a9d	9d6b62be-cbb2-4560-abc9-a509a0f42e64	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:23:57
38330	9d6b62be-c624-436a-bd25-3d7221e61fe4	9d6b62be-cbb2-4560-abc9-a509a0f42e64	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:23:57
38331	9d6b62be-c69c-4ef1-8159-dd66b1e3156f	9d6b62be-cbb2-4560-abc9-a509a0f42e64	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:23:57
38332	9d6b62be-ca5e-423e-86b0-0c37054a732b	9d6b62be-cbb2-4560-abc9-a509a0f42e64	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:23:57
38333	9d6b62be-ca9e-4e0a-ae5c-72ed891a84d1	9d6b62be-cbb2-4560-abc9-a509a0f42e64	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":341,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:23:57
42068	9d6cd406-698e-41f8-88d5-777957bb0a29	9d6cd406-8351-4b13-bcc5-67b2f2ca8860	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:36:32
42069	9d6cd406-7f58-48cd-8dd8-3f5d467f93c5	9d6cd406-8351-4b13-bcc5-67b2f2ca8860	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"43.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:36:32
42070	9d6cd406-820d-4989-9e6c-e8312da4be0d	9d6cd406-8351-4b13-bcc5-67b2f2ca8860	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:36:32
42071	9d6cd406-8252-4e33-b80f-1e5a9d154973	9d6cd406-8351-4b13-bcc5-67b2f2ca8860	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":364,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:36:32
42072	9d6cd415-75e6-4f5d-8e44-7b540ec4af50	9d6cd415-79cf-43c2-b1ff-74edcf49378c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":185,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:36:42
42484	9d6cde65-253a-4309-9fa2-43dda9fa7782	9d6cde65-2628-4473-ba58-9259aaa63f42	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":407,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:05:31
42716	9d6cdff6-ad93-4fa4-98f2-503d82fcd58d	9d6cdff6-ae90-45c7-9606-7adc14e6ad22	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":293,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:09:55
42073	9d6cd416-333c-4975-8640-281c1fb0a49d	9d6cd416-6bc0-4c7a-9974-abdcf10bb5d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:36:42
42074	9d6cd416-51b6-4e6c-9ee3-d9276d4655f2	9d6cd416-6bc0-4c7a-9974-abdcf10bb5d0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"40.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 10:36:42
42075	9d6cd416-521a-4dc5-8d9b-87d24c0b1d38	9d6cd416-6bc0-4c7a-9974-abdcf10bb5d0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:36:42
42076	9d6cd416-6a71-49aa-8d22-f6f67a531012	9d6cd416-6bc0-4c7a-9974-abdcf10bb5d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:36:42
42077	9d6cd416-6aca-45e6-b601-ce8a22ff186f	9d6cd416-6bc0-4c7a-9974-abdcf10bb5d0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","profile":1},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":306,"memory":24,"hostname":"EderCortes"}	2024-11-06 10:36:42
42485	9d6cde65-64a1-45d5-a34b-98a7bea28a4d	9d6cde65-81e8-4464-abcb-ce2ce173f061	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 11:05:32
42486	9d6cde65-7c73-41b7-8ef2-232785bad9d4	9d6cde65-81e8-4464-abcb-ce2ce173f061	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":286,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-06 11:05:32
42487	9d6cde65-7ccd-429d-b9b7-b4ffd762abaf	9d6cde65-81e8-4464-abcb-ce2ce173f061	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-06 11:05:32
42488	9d6cde65-80b8-4d2c-91ab-38bfc9b4fdcd	9d6cde65-81e8-4464-abcb-ce2ce173f061	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 11:05:32
42489	9d6cde65-810b-4e04-bba9-db68c64b0d9c	9d6cde65-81e8-4464-abcb-ce2ce173f061	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":221,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:05:32
42717	9d6cdff7-0a93-4fcc-b48b-8f5904ef2b2c	9d6cdff7-24ad-4df9-9b60-2deb54e065e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 11:09:55
42718	9d6cdff7-2019-4f68-8e6d-cb151aa18a1e	9d6cdff7-24ad-4df9-9b60-2deb54e065e3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"42.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:09:55
42719	9d6cdff7-2325-4f56-a554-897f24428e2b	9d6cdff7-24ad-4df9-9b60-2deb54e065e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 11:09:55
42720	9d6cdff7-2391-411b-9f2a-9ebee5964f1c	9d6cdff7-24ad-4df9-9b60-2deb54e065e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":289,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:09:55
42078	9d6cd41c-e45f-4ca1-a651-5fcd39bf85dd	9d6cd41d-00dc-4912-b813-7f502d13b8b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:36:46
42079	9d6cd41c-fb90-4029-bc76-8d71f1fd3e7e	9d6cd41d-00dc-4912-b813-7f502d13b8b2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:36:46
42080	9d6cd41c-fbfe-496d-b323-0e7f515ded51	9d6cd41d-00dc-4912-b813-7f502d13b8b2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:36:46
42081	9d6cd41c-ff7e-41cf-b069-009fafaf190c	9d6cd41d-00dc-4912-b813-7f502d13b8b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:36:46
42082	9d6cd41c-ffcd-4853-8179-d80c2d0b7f88	9d6cd41d-00dc-4912-b813-7f502d13b8b2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":276,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:36:46
42490	9d6cde65-c48d-45d8-b210-0515fbe71668	9d6cde65-e163-4c96-ba96-7ace9fd7d78a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 11:05:32
42491	9d6cde65-dc88-4954-b517-ad64b8fc059d	9d6cde65-e163-4c96-ba96-7ace9fd7d78a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":235,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 11:05:32
42492	9d6cde65-dcdc-4c70-ad03-a8cc34ff08f9	9d6cde65-e163-4c96-ba96-7ace9fd7d78a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-06 11:05:32
42493	9d6cde65-e051-44b8-964d-098b895b3d09	9d6cde65-e163-4c96-ba96-7ace9fd7d78a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 11:05:32
42494	9d6cde65-e09e-4bc3-bce5-f6842d84ead6	9d6cde65-e163-4c96-ba96-7ace9fd7d78a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:05:32
42721	9d6cdff9-5cd0-4ed9-8c76-c9ed545c6fe9	9d6cdff9-6068-40f0-ba29-cdeac13bf7ce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":139,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:09:56
43124	9d6ce504-96ff-4a1a-aea9-ca830cf9e9e0	9d6ce504-db96-4914-90cd-976cd10ad6b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 11:24:03
43125	9d6ce504-d9bf-4e40-8142-4bbcba510841	9d6ce504-db96-4914-90cd-976cd10ad6b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 11:24:03
25427	9d68c2dd-e122-479a-9b1a-eaa077e4c225	9d68c2de-278a-4a99-bbc6-85439d45d27b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:05:14
25428	9d68c2de-23ba-42a9-b4d7-d733d957fbe0	9d68c2de-278a-4a99-bbc6-85439d45d27b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:05:14
25429	9d68c2de-2542-4d65-95eb-6b0508e44f3d	9d68c2de-278a-4a99-bbc6-85439d45d27b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":734,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:05:14
5526	9d522177-a213-412a-8213-e9755d0a5864	9d522177-a851-4d85-945d-13916542f88c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":296}	2024-10-24 04:05:43
38712	9d6b6bb7-72f3-46d3-96f2-1356bdf57928	9d6b6bb7-7713-40eb-8ce0-e9d258bb2e03	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1737}	2024-11-05 17:49:02
25430	9d68c2df-3a50-4dec-9b8e-9dd989331752	9d68c2df-682e-49c1-8745-2da6c987b2c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:05:15
25431	9d68c2df-603b-4047-b618-137fa24e2963	9d68c2df-682e-49c1-8745-2da6c987b2c0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"73.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 10:05:15
25432	9d68c2df-65d4-40ad-9bdb-a26b6a3f1c0b	9d68c2df-682e-49c1-8745-2da6c987b2c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:05:15
25433	9d68c2df-6687-45aa-af8b-c71102a9a4f9	9d68c2df-682e-49c1-8745-2da6c987b2c0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":744,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:05:15
42083	9d6cd41d-4a2a-4577-a2d6-0fc002244d82	9d6cd41d-636d-4e74-a0c4-b91e2983c7a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:36:47
42084	9d6cd41d-5f2a-45e6-9314-99af8e6d2439	9d6cd41d-636d-4e74-a0c4-b91e2983c7a1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"42.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:36:47
42085	9d6cd41d-6241-4aff-a6a6-2a3a1886ab6f	9d6cd41d-636d-4e74-a0c4-b91e2983c7a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:36:47
42086	9d6cd41d-628e-46cf-bfdc-e212bb89b615	9d6cd41d-636d-4e74-a0c4-b91e2983c7a1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":219,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:36:47
42495	9d6cde6b-060e-42f1-969e-6bce8ce5bab5	9d6cde6b-0be1-49d2-8ace-35fafcc8d396	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":162,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:05:35
42722	9d6cdffa-1373-48d6-b336-f5776f7dfa2e	9d6cdffa-325f-4d50-8532-12175aa92c4b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 11:09:57
42723	9d6cdffa-2ab6-4f3d-ac95-188a566d3d8e	9d6cdffa-325f-4d50-8532-12175aa92c4b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ma%' or \\"users\\".\\"user_document\\"::text like '%Ma%') order by \\"users\\".\\"user_document\\" asc","time":"41.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":122,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-06 11:09:57
42724	9d6cdffa-30d0-49ae-b01f-9faa50946847	9d6cdffa-325f-4d50-8532-12175aa92c4b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 11:09:57
25434	9d68c2e0-250a-430b-a662-4cd0201c3ecf	9d68c2e0-6d61-481b-b125-7f45607ef2d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:05:16
25435	9d68c2e0-6521-4339-9840-56e736e8e6b8	9d68c2e0-6d61-481b-b125-7f45607ef2d7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"103.88","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:05:16
25436	9d68c2e0-65a0-4394-b534-00573a89546a	9d68c2e0-6d61-481b-b125-7f45607ef2d7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:05:16
25437	9d68c2e0-6b4a-4c5b-83ea-10fa4637479d	9d68c2e0-6d61-481b-b125-7f45607ef2d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:05:16
25438	9d68c2e0-6bd8-4793-b721-ba58e1d7a1c2	9d68c2e0-6d61-481b-b125-7f45607ef2d7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":653,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:05:16
42087	9d6cd421-bdbb-4d2a-a7b6-35933befcd71	9d6cd421-c08f-4a05-ad05-c8b89089d7bc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":146,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:36:50
42496	9d6cde6b-5491-4e10-bc62-4c92b3a5a5c9	9d6cde6b-5795-440e-be2a-dc18d1ac7fec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":128,"memory":20,"hostname":"EderCortes"}	2024-11-06 11:05:36
42725	9d6cdffa-312b-45cc-88d9-69c8995e70cb	9d6cdffa-325f-4d50-8532-12175aa92c4b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ma"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:09:57
43126	9d6ce504-da5f-429e-9eef-eac49a3dca80	9d6ce504-db96-4914-90cd-976cd10ad6b6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:24:03
43018	9d6ce37f-5923-43a1-a4d6-1d9a285bb736	9d6ce37f-ae20-4309-b3f7-0cf09ace1420	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:19:48
43019	9d6ce37f-aba4-41a1-9b64-c10b2f8fdad0	9d6ce37f-ae20-4309-b3f7-0cf09ace1420	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:19:48
25439	9d68c2e1-4728-4c03-9a6f-73a79ea4d1b0	9d68c2e1-8eb3-4236-86f8-548f8997fdcc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:05:17
25440	9d68c2e1-8389-4018-954e-8d47c211b942	9d68c2e1-8eb3-4236-86f8-548f8997fdcc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"97.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:05:17
25441	9d68c2e1-8420-4cb3-84cc-4aa51dc61f52	9d68c2e1-8eb3-4236-86f8-548f8997fdcc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:05:17
25442	9d68c2e1-8c67-4d75-9dce-c952fd603123	9d68c2e1-8eb3-4236-86f8-548f8997fdcc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:05:17
25443	9d68c2e1-8d0c-4222-96f5-6a183faaa43f	9d68c2e1-8eb3-4236-86f8-548f8997fdcc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":679,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:05:17
42088	9d6cd422-1438-4a33-a7d2-e7a9a0e67458	9d6cd422-31a8-4d50-8240-4a9710ab14c6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:36:50
42089	9d6cd422-2c8e-4cdf-8b1f-65b5503a31e7	9d6cd422-31a8-4d50-8240-4a9710ab14c6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:36:50
42090	9d6cd422-2ce3-415b-a7c8-1d4730828f48	9d6cd422-31a8-4d50-8240-4a9710ab14c6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:36:50
42091	9d6cd422-3008-48dd-ade8-ae490541002d	9d6cd422-31a8-4d50-8240-4a9710ab14c6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:36:50
42092	9d6cd422-3082-4a34-95e8-e9ddfde5ad5f	9d6cd422-31a8-4d50-8240-4a9710ab14c6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:36:50
42497	9d6cde6b-a714-4dab-b10f-7738f965681d	9d6cde6b-c759-4952-9a52-6e9d2914cf87	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 11:05:36
42498	9d6cde6b-c241-4c88-bdc7-029b2b526f77	9d6cde6b-c759-4952-9a52-6e9d2914cf87	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%10%' or \\"users\\".\\"user_document\\"::text like '%10%') order by \\"users\\".\\"user_document\\" asc","time":"52.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":122,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-06 11:05:36
42499	9d6cde6b-c620-4fe8-a612-439178e30003	9d6cde6b-c759-4952-9a52-6e9d2914cf87	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 11:05:36
42500	9d6cde6b-c667-42f6-b612-7e5b7db0af34	9d6cde6b-c759-4952-9a52-6e9d2914cf87	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"10"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:05:36
42726	9d6cdffa-6f80-4806-b71d-42a7e4e59580	9d6cdffa-726e-4341-a73a-0d4dd7a7737a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":142,"memory":20,"hostname":"EderCortes"}	2024-11-06 11:09:57
43020	9d6ce37f-acc8-407f-bbbd-39b54f07605d	9d6ce37f-ae20-4309-b3f7-0cf09ace1420	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":433,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:19:48
42958	9d6ce30b-b7a8-4e90-86f6-4502520cf0f1	9d6ce30c-011d-40a3-a1df-4121696f364c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:18:32
42959	9d6ce30b-ff16-4e2c-84c4-307fb810ec64	9d6ce30c-011d-40a3-a1df-4121696f364c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:18:32
42093	9d6cd422-7590-43bd-9a5c-fa13094931b9	9d6cd422-9467-4f4a-929b-f7debf07f3f1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:36:50
42094	9d6cd422-8e6b-4a5f-8ba7-45dd3e0ce9d9	9d6cd422-9467-4f4a-929b-f7debf07f3f1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:36:50
42095	9d6cd422-8ec0-4cb1-837e-eb9ea213f1f0	9d6cd422-9467-4f4a-929b-f7debf07f3f1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:36:50
25511	9d68c687-dc31-481f-af43-d77316cb0de2	9d68c688-0fc6-403b-a830-d97cd91c192f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 10:15:29
25512	9d68c688-0cd9-4e31-b6f7-098c4f2e52aa	9d68c688-0fc6-403b-a830-d97cd91c192f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 10:15:29
25513	9d68c688-0e02-4d51-81a3-93646a4eb41b	9d68c688-0fc6-403b-a830-d97cd91c192f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":588,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:15:29
42096	9d6cd422-9326-4b8a-b236-e009763b689e	9d6cd422-9467-4f4a-929b-f7debf07f3f1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:36:50
42097	9d6cd422-9371-409e-af66-cd07ab8517ca	9d6cd422-9467-4f4a-929b-f7debf07f3f1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:36:50
42501	9d6cde6c-07a0-4ad4-9930-6f8c77d0ee35	9d6cde6c-2267-4e1a-b537-898cedbe78e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 11:05:36
42502	9d6cde6c-1e0a-468d-a2fd-57ff5444e637	9d6cde6c-2267-4e1a-b537-898cedbe78e4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%100%' or \\"users\\".\\"user_document\\"::text like '%100%') order by \\"users\\".\\"user_document\\" asc","time":"41.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":122,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-06 11:05:36
42503	9d6cde6c-2122-4e3b-a0a9-4bc526b7beeb	9d6cde6c-2267-4e1a-b537-898cedbe78e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 11:05:36
42504	9d6cde6c-216d-4677-889c-6f22556b7cd2	9d6cde6c-2267-4e1a-b537-898cedbe78e4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"100"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:05:36
42727	9d6cdffa-e516-44d7-94dd-4a4904f6e9a5	9d6cdffa-e91f-416d-bac0-84f391c2477b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":129,"memory":20,"hostname":"EderCortes"}	2024-11-06 11:09:57
43021	9d6ce380-1eee-41ff-b7fe-03be14a32d79	9d6ce380-277e-4c5a-b507-d9512d4c20ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:19:48
43022	9d6ce380-2604-44af-b109-df0d9ad8f5da	9d6ce380-277e-4c5a-b507-d9512d4c20ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:19:48
43023	9d6ce380-2661-4adc-9b8e-b5d05c32b338	9d6ce380-277e-4c5a-b507-d9512d4c20ba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/showCobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@showCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":"sakdbsabdjkbsadbjksdajkbdsajbkjkbsdakjd"},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:19:48
25514	9d68c688-ce55-43cb-8c95-a3b9b71b6bbe	9d68c688-fcf4-45e3-a681-9dfacea7d81c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 10:15:30
25515	9d68c688-f4b0-4654-8d18-71ff3ed0f411	9d68c688-fcf4-45e3-a681-9dfacea7d81c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"61.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 10:15:30
25516	9d68c688-fa95-4f2b-a691-04679fa2e389	9d68c688-fcf4-45e3-a681-9dfacea7d81c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 10:15:30
25517	9d68c688-fb37-4e25-bab7-e4178aac6aca	9d68c688-fcf4-45e3-a681-9dfacea7d81c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":527,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:15:30
42098	9d6cd422-d984-450d-a6ca-226c306a1710	9d6cd423-1fcb-45d4-b1e8-aaf2cc887fda	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:36:50
42099	9d6cd423-1b78-41e1-9f85-caa538fc0eb4	9d6cd423-1fcb-45d4-b1e8-aaf2cc887fda	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"152.67","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 10:36:50
42100	9d6cd423-1e55-43ce-bca6-6a6c5c51c184	9d6cd423-1fcb-45d4-b1e8-aaf2cc887fda	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:36:51
42101	9d6cd423-1ecc-402f-8abb-dfc6a3d8862f	9d6cd423-1fcb-45d4-b1e8-aaf2cc887fda	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:36:51
42505	9d6cde6c-5ef5-46ed-a60f-f626365eb650	9d6cde6c-6218-440d-b7b8-032a597d7364	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":136,"memory":20,"hostname":"EderCortes"}	2024-11-06 11:05:36
42728	9d6cdffb-5e7a-42a1-a640-e9dbcb5a662f	9d6cdffb-6131-4f79-b397-0c1e64f476d3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":131,"memory":20,"hostname":"EderCortes"}	2024-11-06 11:09:58
43024	9d6ce381-dd21-479f-b8ad-1fee1a4fea98	9d6ce382-1f49-47d3-8990-94d17e335051	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:19:49
43025	9d6ce382-14c0-4a8a-aeea-7ba103c85668	9d6ce382-1f49-47d3-8990-94d17e335051	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"65.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:19:49
43026	9d6ce382-1540-477d-b9cf-4d8f6b73ee4a	9d6ce382-1f49-47d3-8990-94d17e335051	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:19:49
43027	9d6ce382-1cb1-4c57-9d3a-45ca5719f164	9d6ce382-1f49-47d3-8990-94d17e335051	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:19:49
25518	9d68c689-9957-4972-ae6e-270b111cec4a	9d68c689-d0a9-47cf-8055-6e634fa7f65b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 10:15:30
25519	9d68c689-c562-4fec-b0c7-24b7c37c0c28	9d68c689-d0a9-47cf-8055-6e634fa7f65b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"71.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:15:30
25520	9d68c689-c5f0-4eb9-974f-dc54358ccc29	9d68c689-d0a9-47cf-8055-6e634fa7f65b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:15:30
25521	9d68c689-ce73-4886-a1f2-8a1bcbad829b	9d68c689-d0a9-47cf-8055-6e634fa7f65b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 10:15:30
25522	9d68c689-cf07-4a19-9eaa-de80504f41c9	9d68c689-d0a9-47cf-8055-6e634fa7f65b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":529,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:15:30
42102	9d6cd425-bc97-41aa-b72e-67ed31430ffd	9d6cd425-bf3b-450d-99ab-35ea432dca29	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":173,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:36:52
42506	9d6cde6c-b349-4343-b1ee-5fca8bbbd31e	9d6cde6c-d012-43d0-84e6-37f27a4d2f5e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 11:05:36
42507	9d6cde6c-cb58-4775-9288-e6ab92fc281e	9d6cde6c-d012-43d0-84e6-37f27a4d2f5e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%1004%' or \\"users\\".\\"user_document\\"::text like '%1004%') order by \\"users\\".\\"user_document\\" asc","time":"40.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":122,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-06 11:05:37
42508	9d6cde6c-ce99-4cff-b0f3-0d0b9e19f78e	9d6cde6c-d012-43d0-84e6-37f27a4d2f5e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 11:05:37
42509	9d6cde6c-cefb-4329-8444-73acc43e7f84	9d6cde6c-d012-43d0-84e6-37f27a4d2f5e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"1004"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:05:37
42729	9d6cdffb-abf6-4c40-b54c-d9e33dc1e167	9d6cdffb-f182-48f5-9787-023c46718b2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 11:09:58
42730	9d6cdffb-ea0c-4ec7-a2da-d43eae9f21bf	9d6cdffb-f182-48f5-9787-023c46718b2b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mar%' or \\"users\\".\\"user_document\\"::text like '%Mar%') order by \\"users\\".\\"user_document\\" asc","time":"143.77","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":122,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-06 11:09:58
42731	9d6cdffb-f022-4abf-b783-338e90f0ea7e	9d6cdffb-f182-48f5-9787-023c46718b2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 11:09:58
25523	9d68c68a-a655-45d7-bcd5-4f510fd9ee7c	9d68c68a-f5ba-42c8-9668-7cf07d9809f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 10:15:31
25524	9d68c68a-ee69-493a-93a0-30f7a30eb882	9d68c68a-f5ba-42c8-9668-7cf07d9809f9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"157.22","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:15:31
25525	9d68c68a-eee3-4f85-a845-f7a814409596	9d68c68a-f5ba-42c8-9668-7cf07d9809f9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:15:31
25526	9d68c68a-f3e1-4a1f-8593-1bfbf23594d1	9d68c68a-f5ba-42c8-9668-7cf07d9809f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 10:15:31
25527	9d68c68a-f460-4ffb-92ae-fb7d513e6dc2	9d68c68a-f5ba-42c8-9668-7cf07d9809f9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":570,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:15:31
42103	9d6cd426-2f9b-4011-8c23-bb532f6165ba	9d6cd426-4f3c-4ad6-bf01-e2d66e1dd00d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:36:53
42104	9d6cd426-4a11-48f9-b37c-1fb70c708726	9d6cd426-4f3c-4ad6-bf01-e2d66e1dd00d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:36:53
42105	9d6cd426-4a6c-4a2e-9e63-8b8ee0941085	9d6cd426-4f3c-4ad6-bf01-e2d66e1dd00d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:36:53
42106	9d6cd426-4db8-4780-a642-eacef1540e52	9d6cd426-4f3c-4ad6-bf01-e2d66e1dd00d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 10:36:53
42107	9d6cd426-4e05-4310-8427-e16d43732c4d	9d6cd426-4f3c-4ad6-bf01-e2d66e1dd00d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:36:53
42510	9d6cde73-91b3-4328-beed-6157f60d20fb	9d6cde73-b2af-4ca8-99c1-b8743ff7c288	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 11:05:41
42511	9d6cde73-acca-48e7-b41d-a0d46bc5c349	9d6cde73-b2af-4ca8-99c1-b8743ff7c288	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '19' and \\"users\\".\\"deleted_at\\" is null","time":"45.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":101,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-11-06 11:05:41
42512	9d6cde73-ad38-4a47-a487-3face3618301	9d6cde73-b2af-4ca8-99c1-b8743ff7c288	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 11:05:41
42513	9d6cde73-b153-4955-9872-9d239501f8c2	9d6cde73-b2af-4ca8-99c1-b8743ff7c288	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 11:05:41
42514	9d6cde73-b1a5-4c35-b400-6fea4cac1a7e	9d6cde73-b2af-4ca8-99c1-b8743ff7c288	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/19","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}},"duration":256,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:05:41
42108	9d6cd426-91a4-4514-befe-fe20177ed2ed	9d6cd426-b17d-4511-b751-3dd27aebd288	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 10:36:53
42109	9d6cd426-ac20-4359-9f66-9bf54a2eb266	9d6cd426-b17d-4511-b751-3dd27aebd288	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:36:53
42110	9d6cd426-ac84-46ed-b915-c8487057e0d9	9d6cd426-b17d-4511-b751-3dd27aebd288	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:36:53
42111	9d6cd426-afe9-41e0-b301-46621261a601	9d6cd426-b17d-4511-b751-3dd27aebd288	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 10:36:53
42112	9d6cd426-b035-4f61-9548-fc50b5b873fc	9d6cd426-b17d-4511-b751-3dd27aebd288	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:36:53
42732	9d6cdffb-f073-48fc-bb05-0d704c5a4372	9d6cdffb-f182-48f5-9787-023c46718b2b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mar"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":317,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:09:58
42960	9d6ce30b-ffcf-49e9-88b1-7cf307447f2c	9d6ce30c-011d-40a3-a1df-4121696f364c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":429,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:18:32
43028	9d6ce382-1d68-4b2c-9f99-39fa35d36ffd	9d6ce382-1f49-47d3-8990-94d17e335051	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":505,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:19:49
42113	9d6cd426-f067-46a3-a146-eaed5864e1e9	9d6cd427-0d63-475f-a0a9-aca3bcbe3562	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 10:36:53
42114	9d6cd427-08a4-4e50-b9b6-c2c112011be5	9d6cd427-0d63-475f-a0a9-aca3bcbe3562	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"44.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":89,"hash":"f9f3598e6ad2468770f89917d2ab916c","hostname":"EderCortes"}	2024-11-06 10:36:53
42115	9d6cd427-0b97-4632-9b68-54fe5a3ffbbd	9d6cd427-0d63-475f-a0a9-aca3bcbe3562	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 10:36:53
42116	9d6cd427-0c2c-4913-a3a0-6270ac88c179	9d6cd427-0d63-475f-a0a9-aca3bcbe3562	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getLoansCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":221,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:36:53
42733	9d6cdffc-3991-4c76-92be-2dcd847077a0	9d6cdffc-5512-4bfa-802f-e0a74997db0e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 11:09:58
42734	9d6cdffc-50ed-4dad-8de4-d86fa5d98a44	9d6cdffc-5512-4bfa-802f-e0a74997db0e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"42.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":122,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-06 11:09:58
42735	9d6cdffc-53e0-476e-930b-5e3cddd74d99	9d6cdffc-5512-4bfa-802f-e0a74997db0e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 11:09:58
42736	9d6cdffc-5422-4d29-ba75-77e1d0e19c7e	9d6cdffc-5512-4bfa-802f-e0a74997db0e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:09:58
42961	9d6ce30c-6841-46fe-85a0-0374d79498c5	9d6ce30c-7abe-4e03-ae15-a7f4da2b11ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:18:32
42962	9d6ce30c-797f-46d8-b79d-c1e3155f5189	9d6ce30c-7abe-4e03-ae15-a7f4da2b11ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:18:32
42963	9d6ce30c-79cd-4e36-83e1-6c2346f063db	9d6ce30c-7abe-4e03-ae15-a7f4da2b11ae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/showCobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@showCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":[]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:18:32
43029	9d6ce382-7812-4925-9c83-67f1d538bdbf	9d6ce382-98f8-4c6e-951c-c25695590c82	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:19:50
43030	9d6ce382-940b-4c04-a072-fb9e2a730e13	9d6ce382-98f8-4c6e-951c-c25695590c82	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"48.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:19:50
43031	9d6ce382-9764-497d-879d-e38cee10f634	9d6ce382-98f8-4c6e-951c-c25695590c82	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:19:50
42117	9d6cd428-f89b-42f9-a5a2-39cfc131f589	9d6cd428-fc2a-460c-b3bf-029a2a2bd66b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":147,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:36:54
42737	9d6cdffc-95b3-4a4c-ba77-a54837530b27	9d6cdffc-b117-43f5-8252-b06a4c16c879	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 11:09:59
42738	9d6cdffc-aca9-4a44-8bf9-9107029717c2	9d6cdffc-b117-43f5-8252-b06a4c16c879	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"43.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":122,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-06 11:09:59
42739	9d6cdffc-afd0-42d7-9fd1-4195426a6f09	9d6cdffc-b117-43f5-8252-b06a4c16c879	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 11:09:59
42740	9d6cdffc-b012-4d6a-9d14-6c5a831aec2e	9d6cdffc-b117-43f5-8252-b06a4c16c879	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":220,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:09:59
42964	9d6ce30e-d227-43d6-a3d9-bd0d965c5da3	9d6ce30f-1c9c-4fbf-9674-0d3633c19d05	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:18:34
42965	9d6ce30f-16a7-4dcd-a4ab-86cd3a91123b	9d6ce30f-1c9c-4fbf-9674-0d3633c19d05	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"146.11","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:18:34
42966	9d6ce30f-16fb-4ee8-acf7-bb2962ad1d26	9d6ce30f-1c9c-4fbf-9674-0d3633c19d05	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:18:34
42967	9d6ce30f-1b16-48cd-ac15-f86ffc90835e	9d6ce30f-1c9c-4fbf-9674-0d3633c19d05	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:18:34
42968	9d6ce30f-1b7b-458a-a3a1-d9a13460ce6f	9d6ce30f-1c9c-4fbf-9674-0d3633c19d05	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":490,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:18:34
43032	9d6ce382-97ba-4c2c-b1c8-c1091a21294e	9d6ce382-98f8-4c6e-951c-c25695590c82	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":283,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:19:50
42118	9d6cd429-7bcc-4020-80af-93685a5ee192	9d6cd429-9a7a-4dd5-84a4-d959a426575c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 10:36:55
42119	9d6cd429-9504-480b-9324-4451b77be3b5	9d6cd429-9a7a-4dd5-84a4-d959a426575c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:36:55
42120	9d6cd429-955b-4ce7-aeb3-e4ae113d99dc	9d6cd429-9a7a-4dd5-84a4-d959a426575c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:36:55
27065	9d68e1b8-b446-4e12-aa41-8b6c134f7039	9d68e1b8-ed91-43ed-9c05-3a4e9e1fbe02	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:31:31
27066	9d68e1b8-eb26-4daa-b852-ad38c95a2702	9d68e1b8-ed91-43ed-9c05-3a4e9e1fbe02	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:31:31
27067	9d68e1b8-ec2c-48df-9b78-4a87f226418d	9d68e1b8-ed91-43ed-9c05-3a4e9e1fbe02	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":558,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:31:31
42121	9d6cd429-994f-41c0-ba9e-cefbc572963b	9d6cd429-9a7a-4dd5-84a4-d959a426575c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 10:36:55
42122	9d6cd429-9997-4462-b6a4-a6983d9373ac	9d6cd429-9a7a-4dd5-84a4-d959a426575c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:36:55
42741	9d6cdffc-ef4e-4350-91a1-c59f59363146	9d6cdffc-f258-495c-9e8b-38fac4a620c6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":141,"memory":20,"hostname":"EderCortes"}	2024-11-06 11:09:59
42969	9d6ce30f-70fb-4f4f-bf31-e0f33d9819e3	9d6ce30f-9101-4846-8da2-c4c387ebb875	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:18:34
42970	9d6ce30f-8a84-4d19-aeba-45fd670bb6ae	9d6ce30f-9101-4846-8da2-c4c387ebb875	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"45.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:18:34
42971	9d6ce30f-8f18-4e30-9c1e-8ef597e6c377	9d6ce30f-9101-4846-8da2-c4c387ebb875	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:18:34
42972	9d6ce30f-8f98-4383-bfcf-32cad01f50e6	9d6ce30f-9101-4846-8da2-c4c387ebb875	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":283,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:18:34
27068	9d68e1b9-aec6-4fc4-933a-fb994dfb162e	9d68e1b9-ecd4-4821-b130-844100501a87	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:31:32
27069	9d68e1b9-df30-4503-b629-8b8e96c0a557	9d68e1b9-ecd4-4821-b130-844100501a87	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"82.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:31:32
27070	9d68e1b9-dfcf-4eeb-b1ff-e6cdc3fa4abb	9d68e1b9-ecd4-4821-b130-844100501a87	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:31:32
27071	9d68e1b9-ea7e-49a8-968c-44b7bd81df69	9d68e1b9-ecd4-4821-b130-844100501a87	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:31:32
27072	9d68e1b9-eb41-4d20-854b-ce1f1b24c2ad	9d68e1b9-ecd4-4821-b130-844100501a87	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":570,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:31:32
42123	9d6cd429-df1b-404e-b177-9efdb82bea93	9d6cd429-fdbc-4f27-8460-6281119d38b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 10:36:55
29683	9d692a84-370f-4b34-8605-aeaaeca62bfe	9d692a84-5ddc-4e65-96e8-1c50149aa03d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 14:55:04
29684	9d692a84-5bb3-48cf-b5fd-3a5c8aa3ae38	9d692a84-5ddc-4e65-96e8-1c50149aa03d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 14:55:04
29685	9d692a84-5ca9-4238-a1d0-d988acf8bac2	9d692a84-5ddc-4e65-96e8-1c50149aa03d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":304,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:55:04
38527	9d6b6658-6e09-4186-a91f-5c6c66b289ed	9d6b6658-9f4b-4957-9c66-32f018fcb765	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 17:34:01
38528	9d6b6658-9c87-45d6-98fa-a45baa6f4a41	9d6b6658-9f4b-4957-9c66-32f018fcb765	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:34:01
38529	9d6b6658-9ddb-42a5-893c-402b036b019f	9d6b6658-9f4b-4957-9c66-32f018fcb765	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":401,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:34:01
42124	9d6cd429-f863-488e-b2a8-002ef51b5786	9d6cd429-fdbc-4f27-8460-6281119d38b4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:36:55
42125	9d6cd429-f8d5-4d40-8a2f-2868e9e1530a	9d6cd429-fdbc-4f27-8460-6281119d38b4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:36:55
42126	9d6cd429-fc7c-46c7-9547-94ad6cf4cfa6	9d6cd429-fdbc-4f27-8460-6281119d38b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 10:36:55
42127	9d6cd429-fcc7-4274-a197-67ee544872d7	9d6cd429-fdbc-4f27-8460-6281119d38b4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:36:55
42742	9d6cdffd-a4f4-4e63-9137-944e70ccdcf2	9d6cdffd-bfdc-4d70-ab52-4121906b37fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 11:09:59
42743	9d6cdffd-bbbc-48ef-871a-d0b1e8484172	9d6cdffd-bfdc-4d70-ab52-4121906b37fc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"41.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":122,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-06 11:09:59
42744	9d6cdffd-be98-4991-bf08-ecc2200a4a7e	9d6cdffd-bfdc-4d70-ab52-4121906b37fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 11:09:59
42745	9d6cdffd-beda-46e8-9f69-7345e3e274db	9d6cdffd-bfdc-4d70-ab52-4121906b37fc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"28","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":215,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:09:59
27073	9d68e1ba-95e0-439b-83e7-4080f023a407	9d68e1ba-c2c6-426f-9967-aee6b5b164da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:31:32
27074	9d68e1ba-b9cd-43fe-9c9f-ca7461ced877	9d68e1ba-c2c6-426f-9967-aee6b5b164da	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"59.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:31:32
27075	9d68e1ba-ba57-4fa3-b5fe-bda48cd91972	9d68e1ba-c2c6-426f-9967-aee6b5b164da	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 11:31:32
27076	9d68e1ba-c0dd-4f58-817c-4ef26bd3318a	9d68e1ba-c2c6-426f-9967-aee6b5b164da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:31:32
27077	9d68e1ba-c165-48f0-a087-53cd0fe8bfe4	9d68e1ba-c2c6-426f-9967-aee6b5b164da	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":514,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:31:32
29686	9d692a84-c69b-4e36-a5f5-74b502cb5cf4	9d692a84-e69e-4152-9417-4f1472422601	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 14:55:04
29687	9d692a84-dd3e-4b8b-adcc-459bdada682e	9d692a84-e69e-4152-9417-4f1472422601	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"43.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 14:55:04
29688	9d692a84-e0e5-4589-b77b-1ae46eb11ad9	9d692a84-e69e-4152-9417-4f1472422601	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 14:55:04
29689	9d692a84-e122-4ff2-9d74-ca122fdb0ad5	9d692a84-e69e-4152-9417-4f1472422601	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 14:55:04
29690	9d692a84-e55b-4a80-ad52-03898d416e55	9d692a84-e69e-4152-9417-4f1472422601	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 14:55:04
29691	9d692a84-e5a2-4a46-9385-d167a433ee0d	9d692a84-e69e-4152-9417-4f1472422601	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":294,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:55:04
38530	9d6b6659-12a1-4401-88b3-f1a9824c8ae1	9d6b6659-37cd-4853-8b23-dddf8ad0d964	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:34:01
38531	9d6b6659-30bc-452f-bd24-c1e930e179de	9d6b6659-37cd-4853-8b23-dddf8ad0d964	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:34:01
38532	9d6b6659-3139-4a32-bdfb-f47b26494e2b	9d6b6659-37cd-4853-8b23-dddf8ad0d964	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:34:01
38533	9d6b6659-3671-47eb-aa61-137287c8086e	9d6b6659-37cd-4853-8b23-dddf8ad0d964	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:34:01
27078	9d68e1bb-5f43-46f8-9b11-57a5ee3265a7	9d68e1bb-924e-4d7e-9497-b119d547f0ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:31:33
27079	9d68e1bb-8597-40b8-8438-861454d43bf4	9d68e1bb-924e-4d7e-9497-b119d547f0ec	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '87' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"62.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 11:31:33
27080	9d68e1bb-8626-4b3b-8860-871cce3ec9ac	9d68e1bb-924e-4d7e-9497-b119d547f0ec	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 11:31:33
27081	9d68e1bb-88f7-4b3f-952d-3f1d7a259500	9d68e1bb-924e-4d7e-9497-b119d547f0ec	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '87' order by \\"item_loans\\".\\"id\\" asc","time":"3.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:31:33
27082	9d68e1bb-8953-4b39-b40f-f20f40b58394	9d68e1bb-924e-4d7e-9497-b119d547f0ec	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 11:31:33
27083	9d68e1bb-9054-43fd-9c55-e77772ade620	9d68e1bb-924e-4d7e-9497-b119d547f0ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:31:33
27084	9d68e1bb-90df-423b-a2a5-622bd169842a	9d68e1bb-924e-4d7e-9497-b119d547f0ec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/87","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":87,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:18:38.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"0","loans_pago_prestado":"0","loans_intereses_recaudar":"275000"},"items":[{"id":341,"loans_codigo":87,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:18:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":342,"loans_codigo":87,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:18:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":343,"loans_codigo":87,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:18:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":344,"loans_codigo":87,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:18:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":345,"loans_codigo":87,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:18:38.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":508,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:31:33
38534	9d6b6659-36c0-450d-8cc5-21c47bf5e81d	9d6b6659-37cd-4853-8b23-dddf8ad0d964	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":319,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:34:01
42128	9d6cd42a-40b4-4420-9ff0-77926b56f99c	9d6cd42a-5e83-4e19-97c5-5e65aad63126	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 10:36:55
42129	9d6cd42a-597b-4950-9c92-c24c96415946	9d6cd42a-5e83-4e19-97c5-5e65aad63126	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"46.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 10:36:55
42130	9d6cd42a-5d1b-49e0-af3f-512ba6f7d7c3	9d6cd42a-5e83-4e19-97c5-5e65aad63126	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 10:36:55
42131	9d6cd42a-5d8c-4a4b-9aa5-d9f2e8b71f73	9d6cd42a-5e83-4e19-97c5-5e65aad63126	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:36:55
42746	9d6cdffe-d575-4e2f-b721-faaa32bc6973	9d6cdfff-1eac-4062-8c0b-79587df635f1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 11:10:00
42747	9d6cdfff-19d4-420f-bdcb-894947972472	9d6cdfff-1eac-4062-8c0b-79587df635f1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '19' and \\"users\\".\\"deleted_at\\" is null","time":"154.61","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":101,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-11-06 11:10:00
42748	9d6cdfff-1a23-413f-af66-5d767e02d088	9d6cdfff-1eac-4062-8c0b-79587df635f1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 11:10:00
42749	9d6cdfff-1d87-4828-80a7-c9442103396d	9d6cdfff-1eac-4062-8c0b-79587df635f1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 11:10:00
42750	9d6cdfff-1dc9-4f01-a6fe-04de0c7f9230	9d6cdfff-1eac-4062-8c0b-79587df635f1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/19","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:10:00
27085	9d68e1bc-e02b-4c65-bdae-2c2fa2ed8fc9	9d68e1bd-3f70-495e-a0c3-d94013f71eab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:31:34
27086	9d68e1bd-3436-4a26-937b-633d6d2b62d7	9d68e1bd-3f70-495e-a0c3-d94013f71eab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"110.41","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:31:34
27087	9d68e1bd-34db-42b0-a222-9021da6b8ddc	9d68e1bd-3f70-495e-a0c3-d94013f71eab	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:31:34
27088	9d68e1bd-3d24-4377-8ff1-57513415abe0	9d68e1bd-3f70-495e-a0c3-d94013f71eab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:31:34
27089	9d68e1bd-3dd5-4d0f-8bb7-cd4715425c7a	9d68e1bd-3f70-495e-a0c3-d94013f71eab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1067,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:31:34
38535	9d6b6659-a3c9-4b91-82ed-c3a96799dbec	9d6b6659-a69d-4266-bb50-0f054730d821	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/listPrecautions","method":"POST","controller_action":null,"middleware":[],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":404,"response":{"error":"No se encontro la url especificada","code":404},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:34:02
42132	9d6cd43d-7049-4309-bdd2-2d2cede03b9f	9d6cd43d-7349-40dc-a92b-95a785037a37	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":182,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:37:08
42751	9d6ce01c-7e23-40a5-8df6-a8cede8e34a0	9d6ce01c-8116-4ebf-969b-fd8904e6c21f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":145,"memory":20,"hostname":"EderCortes"}	2024-11-06 11:10:19
27090	9d68e1be-2c7a-472b-a803-afa90bc34d29	9d68e1be-5a74-424a-9600-0dbc3c9cd191	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:31:34
27091	9d68e1be-5225-474f-9782-6a0632fc1735	9d68e1be-5a74-424a-9600-0dbc3c9cd191	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"55.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:31:35
27092	9d68e1be-5283-451e-b09a-9195a0d61aed	9d68e1be-5a74-424a-9600-0dbc3c9cd191	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:31:35
27093	9d68e1be-58e5-41a9-9030-df7b66a7b0ac	9d68e1be-5a74-424a-9600-0dbc3c9cd191	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:31:35
27094	9d68e1be-5945-4bd4-93f8-f26d34573fc5	9d68e1be-5a74-424a-9600-0dbc3c9cd191	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":693,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:31:35
38536	9d6b6659-fd52-4c25-b5cc-2bf0ef859dbf	9d6b665a-440e-4301-aeed-54c4c4f4b7db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:34:02
38537	9d6b665a-3e3b-4785-828f-94648ca02c73	9d6b665a-440e-4301-aeed-54c4c4f4b7db	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"142.60","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:34:02
38538	9d6b665a-3ea5-40a0-9817-01d995944b8c	9d6b665a-440e-4301-aeed-54c4c4f4b7db	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:34:02
38539	9d6b665a-42d0-4936-a60f-88b364172d29	9d6b665a-440e-4301-aeed-54c4c4f4b7db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:34:02
38540	9d6b665a-4313-4901-bdee-19d9ae3b4341	9d6b665a-440e-4301-aeed-54c4c4f4b7db	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:34:02
42133	9d6cd43e-2b3c-4442-ab5f-7f71694808fd	9d6cd43e-8a83-4bb8-9d9c-73542390c12c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 10:37:08
42134	9d6cd43e-70c9-4fc9-80f0-0e57d7413837	9d6cd43e-8a83-4bb8-9d9c-73542390c12c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"146.30","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 10:37:08
42135	9d6cd43e-7120-46b5-916a-80dd574ebbe6	9d6cd43e-8a83-4bb8-9d9c-73542390c12c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:37:08
42136	9d6cd43e-8943-481f-bf3e-0871e2383849	9d6cd43e-8a83-4bb8-9d9c-73542390c12c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-06 10:37:08
42137	9d6cd43e-898d-4277-9055-cea7fae6af76	9d6cd43e-8a83-4bb8-9d9c-73542390c12c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"80","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":407,"memory":24,"hostname":"EderCortes"}	2024-11-06 10:37:08
42752	9d6ce01c-fb1b-4c7c-921f-f165ecc0c36d	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 11:10:20
27095	9d68e1c0-bee9-416b-9f98-e5c86833ef27	9d68e1c0-db55-428b-93e8-3969dcebcb51	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:31:36
27096	9d68e1c0-d647-4627-ad38-138fefc3fc1c	9d68e1c0-db55-428b-93e8-3969dcebcb51	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"45.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 11:31:36
27097	9d68e1c0-d982-4f86-87bd-687dc74ccb6c	9d68e1c0-db55-428b-93e8-3969dcebcb51	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 11:31:36
27098	9d68e1c0-da23-4836-9cac-75a6ee2823aa	9d68e1c0-db55-428b-93e8-3969dcebcb51	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:31:36
38541	9d6b665c-7417-4dff-9708-b9ccba74c3f2	9d6b665c-9660-4c6a-abcb-fb4e02743243	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:34:03
38542	9d6b665c-8f8a-4594-a05d-d34b9b9ff926	9d6b665c-9660-4c6a-abcb-fb4e02743243	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"46.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:34:04
38543	9d6b665c-9010-46a8-9cb9-08e7068d5f8d	9d6b665c-9660-4c6a-abcb-fb4e02743243	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:34:04
38544	9d6b665c-94bf-40f8-bd0b-f1596351d76c	9d6b665c-9660-4c6a-abcb-fb4e02743243	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:34:04
38545	9d6b665c-9519-4940-868e-02f696d5e75d	9d6b665c-9660-4c6a-abcb-fb4e02743243	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":506,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:34:04
42138	9d6cd515-2b29-44bc-bfdd-bcd7502806d8	9d6cd515-2fb5-4371-9524-4a16d8ce090c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":180,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:39:29
27099	9d68e1c2-4e94-44d5-8ab6-b87717606f35	9d68e1c2-6af2-4f62-8f54-9918accc7728	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 11:31:37
27100	9d68e1c2-65bc-4298-9e93-c595b5608909	9d68e1c2-6af2-4f62-8f54-9918accc7728	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"38.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:31:37
27101	9d68e1c2-660a-456f-950c-ad290e14be11	9d68e1c2-6af2-4f62-8f54-9918accc7728	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:31:37
27102	9d68e1c2-698e-4ad8-954f-55ad0da4cf07	9d68e1c2-6af2-4f62-8f54-9918accc7728	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 11:31:37
27103	9d68e1c2-69da-42d2-bd04-12823d586e5d	9d68e1c2-6af2-4f62-8f54-9918accc7728	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":370,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:31:37
38546	9d6b665c-e53a-42b0-8817-92a3848ca84b	9d6b665c-e873-4a9b-9efb-d053cc9f1e32	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/listPrecautions","method":"POST","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"0","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":404,"response":{"error":"No se encontro la url especificada","code":404},"duration":178,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:34:04
42139	9d6cd515-b5eb-4a8f-81a1-c6c2d3968b57	9d6cd516-22b4-45ee-8285-7a6b9a0ed5e0	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:39:29
42140	9d6cd516-0827-450a-8eaa-f7c079cce024	9d6cd516-22b4-45ee-8285-7a6b9a0ed5e0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"153.19","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 10:39:30
42141	9d6cd516-088d-4f7c-9585-61e16f86796d	9d6cd516-22b4-45ee-8285-7a6b9a0ed5e0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:39:30
42142	9d6cd516-210f-4334-aab8-4c7596ecc2b4	9d6cd516-22b4-45ee-8285-7a6b9a0ed5e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:39:30
42143	9d6cd516-2164-4d49-a270-49e878a90928	9d6cd516-22b4-45ee-8285-7a6b9a0ed5e0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"80","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":447,"memory":24,"hostname":"EderCortes"}	2024-11-06 10:39:30
42753	9d6ce01d-3fef-4f6d-8bb4-9263a1a3312f	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"loans\\" (\\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_valor_prestado\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_fecha_ultimo_pago\\", \\"loans_inicio_pago\\", \\"loans_intereses_recaudar\\", \\"updated_at\\", \\"created_at\\") values ('Maria Antonieta 2', 'De las nieve', 'ds', 'CC', '1004655468', '1992-11-12T04:00:00.000Z', 'Cali', 'Bonilla aragon2', 'Calle 7505', '6000000', 20, 18, 'S', null, '06-11-2024', 'Pendiente', '312596295', 12, 14, 19, 18, '06-11-2024', '06-11-2024', 1200000, '2024-11-06 11:10:20', '2024-11-06 11:10:20') returning \\"id\\"","time":"6.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":156,"hash":"1dc4648abf264acd6c21dbf4f1bebf05","hostname":"EderCortes"}	2024-11-06 11:10:20
42754	9d6ce01d-46a9-4ec3-8153-fcc757001b1c	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	model	{"action":"created","model":"App\\\\Models\\\\Loans:94","hostname":"EderCortes"}	2024-11-06 11:10:20
42755	9d6ce01d-4cd7-4d69-a341-fb06122cf19e	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (94, 1, 333333.33333333, 66666.666666667, 'Pendiente', 'N\\/A', '14-11-2024', 12, 0, 0, '2024-11-06 11:10:20', '2024-11-06 11:10:20')","time":"3.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":208,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-06 11:10:20
42756	9d6ce01d-4d14-4f81-9d26-ad058486d137	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-06 11:10:20
27104	9d68e1c2-dad3-41c5-96b1-4032d9f3648f	9d68e1c2-f850-4210-a3cb-b98a4e204aa3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 11:31:38
27105	9d68e1c2-f38a-4843-b1b4-c162117560d5	9d68e1c2-f850-4210-a3cb-b98a4e204aa3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:31:38
27106	9d68e1c2-f3da-412d-9f44-3793a6930b44	9d68e1c2-f850-4210-a3cb-b98a4e204aa3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 11:31:38
27107	9d68e1c2-f716-49fa-8626-858967287e8c	9d68e1c2-f850-4210-a3cb-b98a4e204aa3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 11:31:38
27108	9d68e1c2-f75e-4722-8776-c09bebf09569	9d68e1c2-f850-4210-a3cb-b98a4e204aa3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:31:38
20673	9d66f99b-a2c8-45e3-a6bc-5e49299e7512	9d66f99b-a5a5-4814-ab78-3c98d797fad3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1024}	2024-11-03 12:46:39
29596	9d6929c9-831e-48e9-a234-6f4f37cd9015	9d6929c9-aba7-46aa-b712-cc8e301e823e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 14:53:01
29597	9d6929c9-a996-41b8-9fc3-60aef960cbf5	9d6929c9-aba7-46aa-b712-cc8e301e823e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 14:53:02
29598	9d6929c9-aa67-4a31-a561-afba83f2029f	9d6929c9-aba7-46aa-b712-cc8e301e823e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":394,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:53:02
42144	9d6cd56f-ffb8-4baa-882e-7c8e11022a89	9d6cd570-03aa-4557-80ff-b2ec42b44776	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":316,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:40:29
42757	9d6ce01d-4db7-43d3-a727-4b7527c98942	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (94, 2, 333333.33333333, 66666.666666667, 'Pendiente', 'N\\/A', '22-11-2024', 12, 0, 0, '2024-11-06 11:10:20', '2024-11-06 11:10:20')","time":"0.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":208,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-06 11:10:20
42758	9d6ce01d-4de5-443e-b24c-71285509685c	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-06 11:10:20
42759	9d6ce01d-4e5c-41ec-bbcb-0e40c561ef0d	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (94, 3, 333333.33333333, 66666.666666667, 'Pendiente', 'N\\/A', '30-11-2024', 12, 0, 0, '2024-11-06 11:10:20', '2024-11-06 11:10:20')","time":"0.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":208,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-06 11:10:20
42760	9d6ce01d-4e7d-4bce-a49e-e4ae13bb3452	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-06 11:10:20
42761	9d6ce01d-5102-4ba4-996e-21093d134c8d	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (94, 4, 333333.33333333, 66666.666666667, 'Pendiente', 'N\\/A', '08-12-2024', 12, 0, 0, '2024-11-06 11:10:20', '2024-11-06 11:10:20')","time":"5.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":208,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-06 11:10:20
42762	9d6ce01d-5127-4a5c-8cc6-193598be20d0	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-06 11:10:20
42763	9d6ce01d-518e-4eb9-acf2-da736ed88f9f	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (94, 5, 333333.33333333, 66666.666666667, 'Pendiente', 'N\\/A', '16-12-2024', 12, 0, 0, '2024-11-06 11:10:20', '2024-11-06 11:10:20')","time":"0.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":208,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-06 11:10:20
42764	9d6ce01d-51aa-49ce-97cc-70c9aa1f3411	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-06 11:10:20
42765	9d6ce01d-520b-4723-9c82-c16400861f10	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (94, 6, 333333.33333333, 66666.666666667, 'Pendiente', 'N\\/A', '24-12-2024', 12, 0, 0, '2024-11-06 11:10:20', '2024-11-06 11:10:20')","time":"0.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":208,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-06 11:10:20
42766	9d6ce01d-5228-4ef5-8b58-8e813976e1c6	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-06 11:10:20
42767	9d6ce01d-527d-42a5-9b23-0c8cdfe221bc	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (94, 7, 333333.33333333, 66666.666666667, 'Pendiente', 'N\\/A', '01-01-2025', 12, 0, 0, '2024-11-06 11:10:20', '2024-11-06 11:10:20')","time":"0.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":208,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-06 11:10:20
42768	9d6ce01d-5297-4cfe-b7b6-b87c97473da7	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-06 11:10:20
42769	9d6ce01d-52ec-48a8-9119-ac2286461d39	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (94, 8, 333333.33333333, 66666.666666667, 'Pendiente', 'N\\/A', '09-01-2025', 12, 0, 0, '2024-11-06 11:10:20', '2024-11-06 11:10:20')","time":"0.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":208,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-06 11:10:20
42770	9d6ce01d-5307-4a13-871a-6a9cf9c4427e	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-06 11:10:20
42145	9d6cd570-bd0f-4f9d-ad7e-7e631af6258c	9d6cd570-fc49-4994-add6-8dbf50e72518	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:40:29
42146	9d6cd570-e172-4791-b196-5be710c7f85f	9d6cd570-fc49-4994-add6-8dbf50e72518	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"41.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 10:40:29
25713	9d68c885-9198-4f55-9322-dd970f161bb6	9d68c885-ca7f-43cd-a4fa-8b608e9ad68a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:21:03
25714	9d68c885-c7c1-405b-9c16-17553436781f	9d68c885-ca7f-43cd-a4fa-8b608e9ad68a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:21:03
25715	9d68c885-c8ff-4153-811f-5e3ad1dd25f1	9d68c885-ca7f-43cd-a4fa-8b608e9ad68a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":644,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:21:03
42147	9d6cd570-e1d9-49fc-84bb-009aadfb74df	9d6cd570-fc49-4994-add6-8dbf50e72518	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:40:29
42148	9d6cd570-fad6-4466-93d7-a2a477825a3f	9d6cd570-fc49-4994-add6-8dbf50e72518	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:40:29
42149	9d6cd570-fb28-468d-8adb-1388fd57cac1	9d6cd570-fc49-4994-add6-8dbf50e72518	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"80","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":319,"memory":24,"hostname":"EderCortes"}	2024-11-06 10:40:29
42771	9d6ce01d-5377-4997-8090-ba222b3eb057	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (94, 9, 333333.33333333, 66666.666666667, 'Pendiente', 'N\\/A', '17-01-2025', 12, 0, 0, '2024-11-06 11:10:20', '2024-11-06 11:10:20')","time":"0.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":208,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-06 11:10:20
42772	9d6ce01d-539c-4810-b850-e048e00ed291	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-06 11:10:20
42773	9d6ce01d-53f5-42d2-a45d-3eae1ed8765f	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (94, 10, 333333.33333333, 66666.666666667, 'Pendiente', 'N\\/A', '25-01-2025', 12, 0, 0, '2024-11-06 11:10:20', '2024-11-06 11:10:20')","time":"0.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":208,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-06 11:10:20
42774	9d6ce01d-540f-4d77-94be-f4b7d6e630d2	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-06 11:10:20
42775	9d6ce01d-5463-4265-a167-b318f4a3ce29	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (94, 11, 333333.33333333, 66666.666666667, 'Pendiente', 'N\\/A', '02-02-2025', 12, 0, 0, '2024-11-06 11:10:20', '2024-11-06 11:10:20')","time":"0.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":208,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-06 11:10:20
42776	9d6ce01d-547d-4030-99f1-a5c2f2a09811	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-06 11:10:20
42777	9d6ce01d-54d1-41e4-be5c-af858f696e6d	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (94, 12, 333333.33333333, 66666.666666667, 'Pendiente', 'N\\/A', '10-02-2025', 12, 0, 0, '2024-11-06 11:10:20', '2024-11-06 11:10:20')","time":"0.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":208,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-06 11:10:20
42778	9d6ce01d-54ed-4704-9ffe-b5f7b24e0251	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-06 11:10:20
42779	9d6ce01d-5541-45e5-afca-1eb1488d4e2a	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (94, 13, 333333.33333333, 66666.666666667, 'Pendiente', 'N\\/A', '18-02-2025', 12, 0, 0, '2024-11-06 11:10:20', '2024-11-06 11:10:20')","time":"0.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":208,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-06 11:10:20
42780	9d6ce01d-555c-4f52-9217-a827bdc792bb	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-06 11:10:20
25716	9d68c886-8d4f-46f9-8003-65306cc131f2	9d68c886-c4b0-408d-a138-0a6c27275678	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:21:04
25717	9d68c886-b646-4909-a461-abcb808d60ed	9d68c886-c4b0-408d-a138-0a6c27275678	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 90\\n                        ","time":"74.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"93c10371e33ace24260de21c3ff3890d","hostname":"EderCortes"}	2024-11-04 10:21:04
25718	9d68c886-bc09-413b-ac66-470abbe98e10	9d68c886-c4b0-408d-a138-0a6c27275678	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"3.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:21:04
25719	9d68c886-bc5b-41d9-b444-ee8fb0d4395b	9d68c886-c4b0-408d-a138-0a6c27275678	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 10:21:04
25720	9d68c886-c300-4cfc-9041-93be9d058ffa	9d68c886-c4b0-408d-a138-0a6c27275678	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:21:04
25721	9d68c886-c36c-4be3-801e-a27626dd9a88	9d68c886-c4b0-408d-a138-0a6c27275678	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"}]}},"duration":560,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:21:04
29599	9d6929ca-138d-4a9d-bdb0-9185985098cb	9d6929ca-35fb-42f4-84a6-16df6db33584	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 14:53:02
29600	9d6929ca-2c1b-403f-a240-b12420a8bf99	9d6929ca-35fb-42f4-84a6-16df6db33584	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"46.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 14:53:02
29601	9d6929ca-2fc1-4c4a-adb6-f63fff910b1f	9d6929ca-35fb-42f4-84a6-16df6db33584	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 14:53:02
29602	9d6929ca-2ff4-4db9-b4c7-aecf1c2cf9c8	9d6929ca-35fb-42f4-84a6-16df6db33584	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 14:53:02
29603	9d6929ca-348b-4369-9a12-ffae2ec9329b	9d6929ca-35fb-42f4-84a6-16df6db33584	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 14:53:02
42150	9d6cd5c9-e545-401c-89f4-9519c3aa6299	9d6cd5c9-ea4a-4053-bb34-25bc98b465e7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":320,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:41:28
25722	9d68c887-f3ae-4808-a923-12d5df8a1b52	9d68c888-4bb1-4685-8269-1e7aa070da17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:21:05
25723	9d68c888-40c9-4f30-81a7-87411dfaaa42	9d68c888-4bb1-4685-8269-1e7aa070da17	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"114.06","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:21:05
25724	9d68c888-4148-4628-84c3-85706162faab	9d68c888-4bb1-4685-8269-1e7aa070da17	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:21:05
25725	9d68c888-4946-44ef-9edd-6889be7b2b7e	9d68c888-4bb1-4685-8269-1e7aa070da17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:21:05
25726	9d68c888-49e2-4cb3-8afd-e1a05c580d75	9d68c888-4bb1-4685-8269-1e7aa070da17	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":979,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:21:05
29604	9d6929ca-3501-47ff-8fbc-03b8d84b00ab	9d6929ca-35fb-42f4-84a6-16df6db33584	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":297,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:53:02
42151	9d6cd5ca-a2a5-4d0f-abdb-be6b62116e6a	9d6cd5ca-d91f-4981-9765-3cef3c4ac6ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:41:28
42152	9d6cd5ca-bf92-4b5d-aac7-8cc6d4db63fd	9d6cd5ca-d91f-4981-9765-3cef3c4ac6ec	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"38.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 10:41:28
42153	9d6cd5ca-bfe8-4f1c-a54a-32d50654452a	9d6cd5ca-d91f-4981-9765-3cef3c4ac6ec	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:41:28
42154	9d6cd5ca-d7f4-4ef5-aed7-1589360627b1	9d6cd5ca-d91f-4981-9765-3cef3c4ac6ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:41:28
42155	9d6cd5ca-d83d-48ba-9e53-5d13fde72c0d	9d6cd5ca-d91f-4981-9765-3cef3c4ac6ec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"80","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":295,"memory":24,"hostname":"EderCortes"}	2024-11-06 10:41:28
42781	9d6ce01d-55ae-44c0-a135-718c9b4e26c7	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (94, 14, 333333.33333333, 66666.666666667, 'Pendiente', 'N\\/A', '26-02-2025', 12, 0, 0, '2024-11-06 11:10:20', '2024-11-06 11:10:20')","time":"0.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":208,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-06 11:10:20
42782	9d6ce01d-55c9-4057-ac8f-1be9a6689386	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-06 11:10:20
42783	9d6ce01d-5619-4cb1-93e3-cb54524794f8	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (94, 15, 333333.33333333, 66666.666666667, 'Pendiente', 'N\\/A', '06-03-2025', 12, 0, 0, '2024-11-06 11:10:20', '2024-11-06 11:10:20')","time":"0.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":208,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-06 11:10:20
25727	9d68c889-0c85-4aaf-abce-1e478ff2558a	9d68c889-3f3e-4fd5-86f5-9786f6975cd8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:21:05
25728	9d68c889-367b-4141-b3d2-47dd0bb8df62	9d68c889-3f3e-4fd5-86f5-9786f6975cd8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"65.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:21:05
25729	9d68c889-373e-4b44-88b8-74bd03e6d191	9d68c889-3f3e-4fd5-86f5-9786f6975cd8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:21:05
25730	9d68c889-3d05-48ed-8154-865b7416061f	9d68c889-3f3e-4fd5-86f5-9786f6975cd8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:21:05
25731	9d68c889-3d90-46eb-958e-7fcd93cea524	9d68c889-3f3e-4fd5-86f5-9786f6975cd8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":596,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:21:05
42156	9d6cd674-8368-48ec-b792-45bd66494496	9d6cd674-870e-4c21-991e-3f377857a7ec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":156,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:43:19
29512	9d692820-f45a-4e67-945e-7c566111c30a	9d692821-27d3-4793-b585-f0dde32e6c27	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 14:48:23
29513	9d692821-2584-4575-ac9a-b8a24373003e	9d692821-27d3-4793-b585-f0dde32e6c27	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 14:48:23
29514	9d692821-267b-45d4-aaea-a0d503e1d169	9d692821-27d3-4793-b585-f0dde32e6c27	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":310,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:48:23
42784	9d6ce01d-5634-4f1e-8357-da4d3f700f74	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-06 11:10:20
42785	9d6ce01d-5687-47b3-848b-860900e9db3e	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (94, 16, 333333.33333333, 66666.666666667, 'Pendiente', 'N\\/A', '14-03-2025', 12, 0, 0, '2024-11-06 11:10:20', '2024-11-06 11:10:20')","time":"0.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":208,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-06 11:10:20
42786	9d6ce01d-56a3-4d1a-9143-5ee3dfc0cef1	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-06 11:10:20
42787	9d6ce01d-56fc-4307-8c45-44c093bfef7f	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (94, 17, 333333.33333333, 66666.666666667, 'Pendiente', 'N\\/A', '22-03-2025', 12, 0, 0, '2024-11-06 11:10:20', '2024-11-06 11:10:20')","time":"0.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":208,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-06 11:10:20
42788	9d6ce01d-5718-47cf-abf3-bc057495d9e2	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-06 11:10:20
42789	9d6ce01d-576b-4ba3-816c-27a0f85c0f82	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_aprobador\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (94, 18, 333333.33333333, 66666.666666667, 'Pendiente', 'N\\/A', '30-03-2025', 12, 0, 0, '2024-11-06 11:10:20', '2024-11-06 11:10:20')","time":"0.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":208,"hash":"7b2cf51819dd5a7d40ecf7e6e34bad86","hostname":"EderCortes"}	2024-11-06 11:10:20
42790	9d6ce01d-5786-4c68-a99a-d8640cb30352	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-06 11:10:20
42791	9d6ce01d-678b-4698-885f-2f6d58001ce2	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 11:10:20
29515	9d692821-96f9-44d0-a0b2-24812ac4fb52	9d692821-c3b0-4db2-a3d5-51980fb3fff5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 14:48:24
29516	9d692821-b75c-4b9e-a347-e47cdade9081	9d692821-c3b0-4db2-a3d5-51980fb3fff5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"63.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 14:48:24
29517	9d692821-bc39-496a-a35d-c8cc1828c4eb	9d692821-c3b0-4db2-a3d5-51980fb3fff5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 14:48:24
29518	9d692821-bc7c-482d-ad6d-dcafd7d471fa	9d692821-c3b0-4db2-a3d5-51980fb3fff5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 14:48:24
29519	9d692821-c224-46ba-b36d-efa5ab94174d	9d692821-c3b0-4db2-a3d5-51980fb3fff5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 14:48:24
29520	9d692821-c292-46c0-b885-f2fedc14271f	9d692821-c3b0-4db2-a3d5-51980fb3fff5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":332,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:48:24
42157	9d6cd675-075d-4db1-a4fd-457f45a5c7a8	9d6cd675-47aa-470b-b48f-e35d01efd6fc	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:43:20
42158	9d6cd675-2c8b-47d2-9bf4-f1097885e387	9d6cd675-47aa-470b-b48f-e35d01efd6fc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"44.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 10:43:20
42159	9d6cd675-2cef-40ca-b7e0-7faf2bb29dff	9d6cd675-47aa-470b-b48f-e35d01efd6fc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:43:20
42160	9d6cd675-4605-4003-971e-3367b6cd33f9	9d6cd675-47aa-470b-b48f-e35d01efd6fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:43:20
42161	9d6cd675-465a-4028-b896-8beccf17e0bf	9d6cd675-47aa-470b-b48f-e35d01efd6fc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"80","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":321,"memory":24,"hostname":"EderCortes"}	2024-11-06 10:43:20
42162	9d6cd6f3-5e25-4410-a935-282facbe5cfc	9d6cd6f3-6389-4b3e-86b0-058664ed654a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":331,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:44:43
42792	9d6ce01d-67cb-4a6b-8409-390148929590	9d6ce01d-68b6-4682-a3a1-ce2b76bf6270	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@store","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"669","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"loans":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":"1004655468","loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_valor_prestado":"6000000","loans_intereses":20,"loans_cuotas":18,"loans_cuando":"S","loans_observacion":null,"loans_fecha":null,"loans_estado":"Pendiente","loans_celular":"312596295","user_creador":12,"user_cobrador":14,"user_customer":19,"user_recomendacion":18},"detail":{"status":"Pendiente","observacion":"N\\/A","fecha_pago":"Wed Nov 06 2024","aprobador":12}},"session":[],"response_status":200,"response":{"message":"Registro creado exitosamente","id":94},"duration":420,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:10:20
43078	9d6ce3fb-8f32-4aa5-8d2b-0f8e900ecb9c	9d6ce3fb-aee0-4b87-8fa9-721d3fc225d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:21:09
43079	9d6ce3fb-ace4-4512-ba99-0eeea343a1ae	9d6ce3fb-aee0-4b87-8fa9-721d3fc225d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:21:09
43080	9d6ce3fb-ad9b-4096-b9c3-5e2d0a41ae67	9d6ce3fb-aee0-4b87-8fa9-721d3fc225d1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":342,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:21:09
42163	9d6cd6f3-f1e2-41c1-8f67-0e1e210e3560	9d6cd6f4-64fc-4e47-87bd-f906054a5e26	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:44:43
42164	9d6cd6f4-497d-4cd9-997a-644fa9625a64	9d6cd6f4-64fc-4e47-87bd-f906054a5e26	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"154.98","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 10:44:43
42165	9d6cd6f4-49dd-40c8-82db-4a3edf77a2c0	9d6cd6f4-64fc-4e47-87bd-f906054a5e26	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:44:43
42166	9d6cd6f4-6305-493e-9215-25ee42bc086e	9d6cd6f4-64fc-4e47-87bd-f906054a5e26	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:44:43
42167	9d6cd6f4-6356-473c-a1c3-f74938fa2a5a	9d6cd6f4-64fc-4e47-87bd-f906054a5e26	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","profile":1},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":479,"memory":24,"hostname":"EderCortes"}	2024-11-06 10:44:43
42793	9d6ce02a-ed20-40e7-8d04-4cf8a7efc89f	9d6ce02a-efd6-46b3-a9a6-2df160705570	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":194,"memory":20,"hostname":"EderCortes"}	2024-11-06 11:10:29
43081	9d6ce3fc-20ba-4d07-a75a-cf8a4701739d	9d6ce3fc-6bd4-467e-8874-1e87c61d0dc5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:21:09
43082	9d6ce3fc-6653-4743-9b8d-ee3c027e0f2d	9d6ce3fc-6bd4-467e-8874-1e87c61d0dc5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT *\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 4;\\n                            ","time":"159.91","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":142,"hash":"f77373833745219f298e08c41f1d196c","hostname":"EderCortes"}	2024-11-06 11:21:09
43083	9d6ce3fc-6a65-4d4d-8573-bf6e4cd46918	9d6ce3fc-6bd4-467e-8874-1e87c61d0dc5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:21:09
43084	9d6ce3fc-6ab3-4ff9-90ab-129982e274bd	9d6ce3fc-6bd4-467e-8874-1e87c61d0dc5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/showCobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@showCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":4,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"password":"$2y$10$tFrw\\/q32bSzYW7YJXZ.ICOOhWYgMmCKEPl1mmu3DUr3bTadJmXiQK","user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"remember_token":null,"verified":"0","verification_token":"kbyqw5OGzIHMi7nHZyqP7pygesxu9KJd2SThhDLgzCTEcPVrwXlnfFrCD0Ht","created_at":"2024-04-16 22:11:54","updated_at":"2024-04-16 22:11:54","deleted_at":"2024-04-16 22:11:54","user_alias":"luis_martinez","profile_name":"Cobrador","profile_prefix":"Cobra"}},"duration":404,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:21:09
42168	9d6cd6fb-b588-4af6-a222-5ef1008f8241	9d6cd6fc-00b6-4b5d-870b-a87ede9405fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:44:48
42169	9d6cd6fb-fa95-40b1-acef-011086595e49	9d6cd6fc-00b6-4b5d-870b-a87ede9405fc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"156.60","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:44:48
42170	9d6cd6fb-fae4-4a26-b62a-9c2b7c8e80ec	9d6cd6fc-00b6-4b5d-870b-a87ede9405fc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:44:48
42171	9d6cd6fb-ff09-44bc-a1ec-2466c9fd11c1	9d6cd6fc-00b6-4b5d-870b-a87ede9405fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:44:48
42172	9d6cd6fb-ff73-4871-be9c-7c433d4d92a9	9d6cd6fc-00b6-4b5d-870b-a87ede9405fc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":511,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:44:48
42794	9d6ce02b-5523-4548-87cd-5749c174074b	9d6ce02b-9cb3-4826-b392-14857242c2fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 11:10:29
42795	9d6ce02b-9783-4106-a9ff-f09ae33bc081	9d6ce02b-9cb3-4826-b392-14857242c2fb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"147.90","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 11:10:29
42796	9d6ce02b-97d9-4295-b81b-8ee5f376e4f2	9d6ce02b-9cb3-4826-b392-14857242c2fb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 11:10:29
42797	9d6ce02b-9b8c-4f50-b436-64c50024cf2b	9d6ce02b-9cb3-4826-b392-14857242c2fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-06 11:10:29
42798	9d6ce02b-9bcc-4bbc-a2a5-a8d07eeb01d2	9d6ce02b-9cb3-4826-b392-14857242c2fb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:10:29
43085	9d6ce3fe-60e2-49f7-a2b6-066f794a0a20	9d6ce3fe-7ed8-4b73-b871-558f7d33048b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:21:11
43086	9d6ce3fe-7a05-4135-babd-c4a94f10b71f	9d6ce3fe-7ed8-4b73-b871-558f7d33048b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"39.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:21:11
43087	9d6ce3fe-7a4c-4afe-a3b5-4d61664ce653	9d6ce3fe-7ed8-4b73-b871-558f7d33048b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:21:11
43088	9d6ce3fe-7d88-4061-9b4f-7c47fa6f0508	9d6ce3fe-7ed8-4b73-b871-558f7d33048b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:21:11
43089	9d6ce3fe-7dcc-4249-80ff-b5dff2ff0238	9d6ce3fe-7ed8-4b73-b871-558f7d33048b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":248,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:21:11
42173	9d6cd6fc-4cdb-4a7b-a9f9-8ea5a652c523	9d6cd6fc-919f-499a-b2fc-f2771b50322b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:44:48
42174	9d6cd6fc-8d2c-4b4e-b386-f2537957b72d	9d6cd6fc-919f-499a-b2fc-f2771b50322b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"151.67","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:44:49
42175	9d6cd6fc-9065-4a57-8742-3fec173cd8a3	9d6cd6fc-919f-499a-b2fc-f2771b50322b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:44:49
42176	9d6cd6fc-90ab-485d-a74d-5d801df2b06e	9d6cd6fc-919f-499a-b2fc-f2771b50322b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:44:49
42799	9d6ce02b-e222-4375-92bb-8548f627b3ca	9d6ce02c-0272-4a3e-b6d5-288faa616c73	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-06 11:10:30
42800	9d6ce02b-fcfe-45b0-a4ab-6b98cd6503d4	9d6ce02c-0272-4a3e-b6d5-288faa616c73	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 11:10:30
42801	9d6ce02b-fd50-490a-8f30-c7f82dba45ce	9d6ce02c-0272-4a3e-b6d5-288faa616c73	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 11:10:30
42802	9d6ce02c-00da-4f6c-80a9-0d77d6f5ebb3	9d6ce02c-0272-4a3e-b6d5-288faa616c73	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-06 11:10:30
42803	9d6ce02c-0134-41d8-8c06-279390387da1	9d6ce02c-0272-4a3e-b6d5-288faa616c73	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:10:30
43090	9d6ce3fe-c152-405a-af2c-d079117caa91	9d6ce3fe-db5e-4010-869c-aa6914243cbd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:21:11
43091	9d6ce3fe-d6dd-4d7f-aded-39b7975daf8b	9d6ce3fe-db5e-4010-869c-aa6914243cbd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"43.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:21:11
43092	9d6ce3fe-d9f1-48e2-afa3-428a17eba587	9d6ce3fe-db5e-4010-869c-aa6914243cbd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:21:11
43093	9d6ce3fe-da3e-46a3-8a99-4eb435f0796e	9d6ce3fe-db5e-4010-869c-aa6914243cbd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":217,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:21:11
42177	9d6cd70c-add7-4bce-b7da-5d55aeb7cc4b	9d6cd70c-b3dc-41dc-b3ef-54a6cbca60ea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":172,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:44:59
42804	9d6ce02c-45a6-48e2-ab17-d49ac69e12a3	9d6ce02c-6372-44cc-a269-7385e7834cc0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-06 11:10:30
38686	9d6b6b4a-3ce4-4f46-80cd-a52a62f6ee93	9d6b6b4a-5f10-487c-84f1-0a2f7bff78de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 17:47:50
38687	9d6b6b4a-5d2e-4d02-a36b-9584ced9262f	9d6b6b4a-5f10-487c-84f1-0a2f7bff78de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 17:47:50
38688	9d6b6b4a-5de9-4f87-a12d-398589f9c25d	9d6b6b4a-5f10-487c-84f1-0a2f7bff78de	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":276,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:47:50
42805	9d6ce02c-5d7d-4f01-8c73-371a69e908ec	9d6ce02c-6372-44cc-a269-7385e7834cc0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"43.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":89,"hash":"f9f3598e6ad2468770f89917d2ab916c","hostname":"EderCortes"}	2024-11-06 11:10:30
42806	9d6ce02c-61bc-4257-915f-d51415580dec	9d6ce02c-6372-44cc-a269-7385e7834cc0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-06 11:10:30
42807	9d6ce02c-6258-4465-8e4f-78b699e175ca	9d6ce02c-6372-44cc-a269-7385e7834cc0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getLoansCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"id":94,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":6000000,"loans_cuotas":18,"loans_estado":"Pendiente","loans_intereses":20,"cobrador":"Luis andre","recomendador":"Maria Antonieta"},{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:10:30
42178	9d6cd70d-7000-427c-985c-9c3d9231c61d	9d6cd70d-d1d6-41fe-83c3-a9b84504581c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:45:00
38690	9d6b6b4a-de8e-4275-93f0-52520eccde67	9d6b6b4a-e746-41ba-973d-29119001ba0b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 17:47:51
38691	9d6b6b4a-e5bf-4808-b728-dde3a76eebc6	9d6b6b4a-e746-41ba-973d-29119001ba0b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 17:47:51
38692	9d6b6b4a-e652-4877-83d5-2e29bee36623	9d6b6b4a-e746-41ba-973d-29119001ba0b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"Undefined array key \\"cobrador\\"","exception":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255,"function":"handleError","class":"Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83,"function":"Illuminate\\\\Foundation\\\\Bootstrap\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"listPrecautions","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":184,"memory":20,"hostname":"EderCortes"}	2024-11-05 17:47:51
38676	9d6b6b10-dc06-4c29-ae3e-e4c8fd68bba0	9d6b6b10-e1f6-4a7a-8f67-40bc2f6c56e0	ae2a356f0e28ceebd439f549153d9ec1	f	exception	{"class":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83,"message":"Undefined array key \\"cobrador\\"","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"74":"","75":"","76":"    }","77":"","78":"    public function listPrecautions(Request $request) {","79":"        $fechaActual = Carbon::now();","80":"        $formatDate = $fechaActual->format( 'd-m-Y');","81":"","82":"","83":"        $cobrador = $request->all()['cobrador'];","84":"        $estado = $request->all()['estado'];","85":"        $frecuencia = $request->all()['frecuencia'];","86":"        $prestamista = $request->all()['prestamista'];","87":"","88":"","89":"        $data = DB::table('loans as l')","90":"            ->select(DB::raw(\\"","91":"        EXTRACT(DAY FROM (","92":"            CASE","93":"                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'"},"hostname":"EderCortes","occurrences":2}	2024-11-05 17:47:13
42179	9d6cd70d-b785-4ba7-b28d-19c3578c3006	9d6cd70d-d1d6-41fe-83c3-a9b84504581c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"146.30","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 10:45:00
42180	9d6cd70d-b7f2-4df4-80f4-bb4192e17603	9d6cd70d-d1d6-41fe-83c3-a9b84504581c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:45:00
38689	9d6b6b4a-e445-4990-902f-d6c36bd4e552	9d6b6b4a-e746-41ba-973d-29119001ba0b	ae2a356f0e28ceebd439f549153d9ec1	f	exception	{"class":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83,"message":"Undefined array key \\"cobrador\\"","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"74":"","75":"","76":"    }","77":"","78":"    public function listPrecautions(Request $request) {","79":"        $fechaActual = Carbon::now();","80":"        $formatDate = $fechaActual->format( 'd-m-Y');","81":"","82":"","83":"        $cobrador = $request->all()['cobrador'];","84":"        $estado = $request->all()['estado'];","85":"        $frecuencia = $request->all()['frecuencia'];","86":"        $prestamista = $request->all()['prestamista'];","87":"","88":"","89":"        $data = DB::table('loans as l')","90":"            ->select(DB::raw(\\"","91":"        EXTRACT(DAY FROM (","92":"            CASE","93":"                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'"},"hostname":"EderCortes","occurrences":3}	2024-11-05 17:47:51
42181	9d6cd70d-d083-41c5-b08b-054b51055355	9d6cd70d-d1d6-41fe-83c3-a9b84504581c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:45:00
42182	9d6cd70d-d0d2-4faa-87d7-bd48691bdcd0	9d6cd70d-d1d6-41fe-83c3-a9b84504581c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"80","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":434,"memory":24,"hostname":"EderCortes"}	2024-11-06 10:45:00
42808	9d6ce032-c034-4041-b6d3-b9167370a57c	9d6ce032-dd2b-456d-b75b-f617809286d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-06 11:10:34
42809	9d6ce032-d84f-495f-be03-5c8a29a7318e	9d6ce032-dd2b-456d-b75b-f617809286d8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 11:10:34
42810	9d6ce032-d8a1-42b9-8e9a-b8f9ab11029e	9d6ce032-dd2b-456d-b75b-f617809286d8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 11:10:34
42811	9d6ce032-dc01-4fc6-a0f7-7c6b93060afd	9d6ce032-dd2b-456d-b75b-f617809286d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-06 11:10:34
38693	9d6b6b4b-3ee0-4b27-94f6-e9738f52d5d5	9d6b6b4b-5e30-4909-8c2d-e9f4d16d45a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 17:47:51
38694	9d6b6b4b-58ab-4911-8693-1e13c5c1249a	9d6b6b4b-5e30-4909-8c2d-e9f4d16d45a4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:47:51
38695	9d6b6b4b-58f8-46d5-9107-5f3243b813d2	9d6b6b4b-5e30-4909-8c2d-e9f4d16d45a4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:47:51
38696	9d6b6b4b-5cbb-418f-a0e2-c03ce86ebbd4	9d6b6b4b-5e30-4909-8c2d-e9f4d16d45a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 17:47:51
38697	9d6b6b4b-5cfc-41b9-81c8-131a1e5ac16c	9d6b6b4b-5e30-4909-8c2d-e9f4d16d45a4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:47:51
42183	9d6cd755-ea18-4153-869c-f321bb4a25b7	9d6cd755-ede9-4efc-aa1b-d4e571426bb5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":165,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:45:47
42812	9d6ce032-dc45-49f0-83ce-354236c1426d	9d6ce032-dd2b-456d-b75b-f617809286d8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":224,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:10:34
38698	9d6b6b4b-a4c0-47a5-9422-90d150d23a2b	9d6b6b4b-c37e-47f9-8115-960039bcfb2a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 17:47:51
38699	9d6b6b4b-be25-45f4-8114-b97ed7efe316	9d6b6b4b-c37e-47f9-8115-960039bcfb2a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:47:51
38700	9d6b6b4b-be7f-44ce-b2b4-dbba124ea91a	9d6b6b4b-c37e-47f9-8115-960039bcfb2a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:47:51
38701	9d6b6b4b-c251-446c-b63f-6c20053c3e47	9d6b6b4b-c37e-47f9-8115-960039bcfb2a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 17:47:51
38702	9d6b6b4b-c297-4ef2-a357-3986e6545187	9d6b6b4b-c37e-47f9-8115-960039bcfb2a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":245,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:47:51
42184	9d6cd756-aa29-4d15-a13f-3ea62c7d88fd	9d6cd757-1567-4460-82ee-61a47e7ac23d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:45:48
42185	9d6cd756-f9a9-4805-a067-ae3e754c4400	9d6cd757-1567-4460-82ee-61a47e7ac23d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"149.73","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 10:45:48
42186	9d6cd756-fa12-4dd4-ae8d-d3bb15faf08c	9d6cd757-1567-4460-82ee-61a47e7ac23d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:45:48
42187	9d6cd757-1394-4b80-9102-04f6eb1a45f1	9d6cd757-1567-4460-82ee-61a47e7ac23d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:45:48
42188	9d6cd757-13e8-42cb-8f17-1407004fab79	9d6cd757-1567-4460-82ee-61a47e7ac23d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"80","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":450,"memory":24,"hostname":"EderCortes"}	2024-11-06 10:45:48
42813	9d6ce033-1c30-4f59-8b43-15bdab950e0c	9d6ce033-3936-4b1f-8f32-b74b6addaba3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-06 11:10:34
42814	9d6ce033-3438-4f74-a677-ce056ee45faf	9d6ce033-3936-4b1f-8f32-b74b6addaba3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":286,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-06 11:10:34
42815	9d6ce033-3483-4424-b215-ce861dd6e696	9d6ce033-3936-4b1f-8f32-b74b6addaba3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-06 11:10:34
42816	9d6ce033-37fe-44a0-b5c6-4205c94c8016	9d6ce033-3936-4b1f-8f32-b74b6addaba3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-06 11:10:34
42817	9d6ce033-3846-4a28-8a2e-291592e5901d	9d6ce033-3936-4b1f-8f32-b74b6addaba3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":222,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:10:34
38703	9d6b6b4d-8ffa-480c-a930-882ee8bcfb48	9d6b6b4d-bc15-409d-9f1e-2476c7525c63	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 17:47:53
38704	9d6b6b4d-b60b-4783-a2f0-36dc774d5422	9d6b6b4d-bc15-409d-9f1e-2476c7525c63	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"58.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:47:53
38705	9d6b6b4d-b66c-4450-b8a6-19eb42f33d91	9d6b6b4d-bc15-409d-9f1e-2476c7525c63	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:47:53
38706	9d6b6b4d-ba87-4911-8b30-74837e4298f2	9d6b6b4d-bc15-409d-9f1e-2476c7525c63	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 17:47:53
38707	9d6b6b4d-bae0-44a8-851c-85da20f11936	9d6b6b4d-bc15-409d-9f1e-2476c7525c63	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":572,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:47:53
42189	9d6cd7d5-21f6-44d2-a452-4e8e9d96ae89	9d6cd7d5-2800-421c-9ee0-ea6b380ba383	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":371,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:47:10
42818	9d6ce033-787b-4ec8-a4a8-c97b7520b996	9d6ce033-9681-4e22-832c-2533d6aec8e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-06 11:10:34
42819	9d6ce033-917c-4de0-8205-fe5b2c7076f7	9d6ce033-9681-4e22-832c-2533d6aec8e0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":235,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 11:10:35
42820	9d6ce033-91cf-41f3-a6c0-b2d3d3a568a4	9d6ce033-9681-4e22-832c-2533d6aec8e0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-06 11:10:35
42821	9d6ce033-9533-4ff6-9a42-0528d9b4fb1b	9d6ce033-9681-4e22-832c-2533d6aec8e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-06 11:10:35
42822	9d6ce033-9578-4bb8-befa-db857498048e	9d6ce033-9681-4e22-832c-2533d6aec8e0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:10:35
42190	9d6cd7d5-b7b1-4e39-afd7-baab7ed4e3db	9d6cd7d6-241a-4404-add7-a981d7636557	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:47:11
38709	9d6b6b4e-0fde-4b2e-a73d-3bb15ba9866c	9d6b6b4e-17ee-4cfb-8e05-81c683e02b90	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 17:47:53
38710	9d6b6b4e-161d-4cc5-ac55-f4a0e5b1bdcb	9d6b6b4e-17ee-4cfb-8e05-81c683e02b90	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 17:47:53
38711	9d6b6b4e-16bd-4561-8700-2ba5b9d32034	9d6b6b4e-17ee-4cfb-8e05-81c683e02b90	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"0","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"Undefined array key \\"cobrador\\"","exception":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255,"function":"handleError","class":"Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83,"function":"Illuminate\\\\Foundation\\\\Bootstrap\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"listPrecautions","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":215,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:47:53
38708	9d6b6b4e-14a0-459d-b432-2e596a298a14	9d6b6b4e-17ee-4cfb-8e05-81c683e02b90	ae2a356f0e28ceebd439f549153d9ec1	f	exception	{"class":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83,"message":"Undefined array key \\"cobrador\\"","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"74":"","75":"","76":"    }","77":"","78":"    public function listPrecautions(Request $request) {","79":"        $fechaActual = Carbon::now();","80":"        $formatDate = $fechaActual->format( 'd-m-Y');","81":"","82":"","83":"        $cobrador = $request->all()['cobrador'];","84":"        $estado = $request->all()['estado'];","85":"        $frecuencia = $request->all()['frecuencia'];","86":"        $prestamista = $request->all()['prestamista'];","87":"","88":"","89":"        $data = DB::table('loans as l')","90":"            ->select(DB::raw(\\"","91":"        EXTRACT(DAY FROM (","92":"            CASE","93":"                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'"},"hostname":"EderCortes","occurrences":4}	2024-11-05 17:47:53
42191	9d6cd7d6-0810-4ca4-acea-12174e996611	9d6cd7d6-241a-4404-add7-a981d7636557	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"155.48","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 10:47:11
42192	9d6cd7d6-088b-4dab-90d2-b30b97021373	9d6cd7d6-241a-4404-add7-a981d7636557	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:47:11
42193	9d6cd7d6-2299-4096-82b2-57270ee9ab0d	9d6cd7d6-241a-4404-add7-a981d7636557	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:47:11
42194	9d6cd7d6-22f1-4a91-8a1a-7778650a1e66	9d6cd7d6-241a-4404-add7-a981d7636557	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","profile":1},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":467,"memory":24,"hostname":"EderCortes"}	2024-11-06 10:47:11
42823	9d6ce033-d5c5-41f5-a15c-044705097bf6	9d6ce034-1d08-4321-9e9e-073fe9097430	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-06 11:10:35
42824	9d6ce034-160f-4337-b21e-16ef373df0f7	9d6ce034-1d08-4321-9e9e-073fe9097430	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_valor_prestado\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\" from \\"loans\\" where \\"id\\" = '94' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"147.44","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":273,"hash":"f00e27e21a94f93c5c7a1d0cd56f9f13","hostname":"EderCortes"}	2024-11-06 11:10:35
42825	9d6ce034-1655-481d-803c-2aacb4cc20bf	9d6ce034-1d08-4321-9e9e-073fe9097430	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-06 11:10:35
42826	9d6ce034-17e1-4c54-b897-aea8a568fa52	9d6ce034-1d08-4321-9e9e-073fe9097430	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '94' order by \\"item_loans\\".\\"id\\" asc","time":"2.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":274,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-06 11:10:35
42827	9d6ce034-180f-48c7-b68f-a101f92af667	9d6ce034-1d08-4321-9e9e-073fe9097430	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":18,"hostname":"EderCortes"}	2024-11-06 11:10:35
42828	9d6ce034-1b96-445e-803e-4106c976d73a	9d6ce034-1d08-4321-9e9e-073fe9097430	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-06 11:10:35
29789	9d692b19-6bc7-4ff6-a362-f5925987f256	9d692b19-89df-40aa-bc5c-db252ff7a6af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 14:56:42
29790	9d692b19-87ec-4f41-a9c9-079b6bea2866	9d692b19-89df-40aa-bc5c-db252ff7a6af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 14:56:42
29791	9d692b19-88dc-4757-ad80-57cc2ad057dc	9d692b19-89df-40aa-bc5c-db252ff7a6af	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:56:42
9351	9d52f759-8d02-406e-ac71-b433a1208218	9d52f759-90e3-4e64-a20f-0b6b30855891	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":446}	2024-10-24 14:03:47
9122	9d52f441-892e-49c2-9176-401b06fb9c5f	9d52f441-8c71-47e8-8440-32d4a7d5eb2b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":437}	2024-10-24 13:55:08
29792	9d692b19-dff7-4566-9ae5-f2491c71c628	9d692b1a-0052-4d3a-9d68-026e63c514b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 14:56:42
29793	9d692b19-f769-452a-a612-34b6c1cc73d0	9d692b1a-0052-4d3a-9d68-026e63c514b0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"47.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 14:56:42
29794	9d692b19-fb65-4eab-89c8-9eabb4a0665a	9d692b1a-0052-4d3a-9d68-026e63c514b0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 14:56:42
29795	9d692b19-fb9a-465c-9e6b-51239f87b3f2	9d692b1a-0052-4d3a-9d68-026e63c514b0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 14:56:42
25803	9d68c94f-d5bb-4538-ae89-187e7bddfd6e	9d68c950-0ea2-4104-8b9e-7e37c805a5e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:23:16
25804	9d68c950-0ad9-4aeb-8c57-d1bbf959ac79	9d68c950-0ea2-4104-8b9e-7e37c805a5e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:23:16
25805	9d68c950-0c65-4f3d-96a2-720d800ff119	9d68c950-0ea2-4104-8b9e-7e37c805a5e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":586,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:23:16
29796	9d692b19-ff15-41a5-a24c-73cae8483ab2	9d692b1a-0052-4d3a-9d68-026e63c514b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 14:56:42
29797	9d692b19-ff69-42ea-a95c-fdfcb7c6992e	9d692b1a-0052-4d3a-9d68-026e63c514b0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:56:42
42195	9d6cd7dd-624e-4379-bed3-a0f8e9a6535e	9d6cd7dd-812c-4ea1-8ad7-50d9a2fcc834	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:47:16
42196	9d6cd7dd-7c54-4d36-8770-beef8b2be93c	9d6cd7dd-812c-4ea1-8ad7-50d9a2fcc834	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"46.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:47:16
42197	9d6cd7dd-7ca6-4919-b903-f627fb49ba42	9d6cd7dd-812c-4ea1-8ad7-50d9a2fcc834	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:47:16
42198	9d6cd7dd-7ff7-4012-856f-9d9759e65657	9d6cd7dd-812c-4ea1-8ad7-50d9a2fcc834	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:47:16
42199	9d6cd7dd-803c-47c4-84d8-66ae7c192a15	9d6cd7dd-812c-4ea1-8ad7-50d9a2fcc834	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":392,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:47:16
25806	9d68c950-e5ed-4383-bf6b-ac54c34225e6	9d68c951-3a28-44af-8d58-f57871428c2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:23:16
25807	9d68c951-2d8c-4182-987c-d494e5cbd4d6	9d68c951-3a28-44af-8d58-f57871428c2b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 90\\n                        ","time":"161.42","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"93c10371e33ace24260de21c3ff3890d","hostname":"EderCortes"}	2024-11-04 10:23:17
25808	9d68c951-3274-4cff-ad8b-c79f75a24393	9d68c951-3a28-44af-8d58-f57871428c2b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"2.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:23:17
25809	9d68c951-32c7-4b67-bd72-eef8df832d0c	9d68c951-3a28-44af-8d58-f57871428c2b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 10:23:17
25810	9d68c951-37d3-427b-9e23-64b9e4b4beea	9d68c951-3a28-44af-8d58-f57871428c2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:23:17
25811	9d68c951-388b-4ed4-bb67-c9ed38cd30f2	9d68c951-3a28-44af-8d58-f57871428c2b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"}]}},"duration":680,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:23:17
42200	9d6cd7dd-c41b-4f99-9668-89c152720b41	9d6cd7de-0370-4277-bbc8-3f5964345a4b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:47:16
42201	9d6cd7dd-ff98-41d0-844b-e1f755c55ba9	9d6cd7de-0370-4277-bbc8-3f5964345a4b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"140.75","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:47:16
42202	9d6cd7de-024b-4608-93a2-779116f1c94d	9d6cd7de-0370-4277-bbc8-3f5964345a4b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:47:16
42203	9d6cd7de-028b-4ebe-8a1d-55d77e2dbba4	9d6cd7de-0370-4277-bbc8-3f5964345a4b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":319,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:47:16
42829	9d6ce034-1c15-4d98-903d-be3f8d44c1ee	9d6ce034-1d08-4321-9e9e-073fe9097430	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/94","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":20,"loans_cuotas":18,"loans_valor_prestado":6000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"06-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"user_creador":12,"user_cobrador":14,"user_customer":19,"user_recomendacion":18},"items":[{"id":487,"loans_codigo":94,"itemloans_cuota":"1","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":488,"loans_codigo":94,"itemloans_cuota":"2","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-22 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":489,"loans_codigo":94,"itemloans_cuota":"3","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-30 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":490,"loans_codigo":94,"itemloans_cuota":"4","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-08 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":491,"loans_codigo":94,"itemloans_cuota":"5","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-16 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":492,"loans_codigo":94,"itemloans_cuota":"6","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-24 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":493,"loans_codigo":94,"itemloans_cuota":"7","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-01 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":494,"loans_codigo":94,"itemloans_cuota":"8","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":495,"loans_codigo":94,"itemloans_cuota":"9","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-17 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":496,"loans_codigo":94,"itemloans_cuota":"10","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-25 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":497,"loans_codigo":94,"itemloans_cuota":"11","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-02 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":498,"loans_codigo":94,"itemloans_cuota":"12","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-10 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":499,"loans_codigo":94,"itemloans_cuota":"13","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-18 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":500,"loans_codigo":94,"itemloans_cuota":"14","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-26 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":501,"loans_codigo":94,"itemloans_cuota":"15","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":502,"loans_codigo":94,"itemloans_cuota":"16","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":503,"loans_codigo":94,"itemloans_cuota":"17","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-22 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":504,"loans_codigo":94,"itemloans_cuota":"18","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-30 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":324,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:10:35
25812	9d68c952-a936-4179-a02a-42a74264e86a	9d68c952-ec94-4c88-9aed-9c88678ce0d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:23:17
25813	9d68c952-df95-45cb-aa98-ca810ef89682	9d68c952-ec94-4c88-9aed-9c88678ce0d7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"80.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:23:18
25814	9d68c952-e029-433e-849f-c2a4625c2852	9d68c952-ec94-4c88-9aed-9c88678ce0d7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:23:18
25815	9d68c952-e8b7-4fce-a2fe-bf4b42b7c079	9d68c952-ec94-4c88-9aed-9c88678ce0d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:23:18
25816	9d68c952-ea42-491f-bac4-11d0d12534e0	9d68c952-ec94-4c88-9aed-9c88678ce0d7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1088,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:23:18
42204	9d6cd7eb-6192-4360-bada-107ff6539e19	9d6cd7eb-655c-4e04-b8dc-9b7039f2431c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":159,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:47:25
42830	9d6ce057-9787-436a-8857-c71bf4a54d01	9d6ce057-9aa1-4e41-8a25-d93c841a9e20	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":184,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:10:58
25817	9d68c953-dad3-4d48-9121-52c4fb4c767f	9d68c954-12d9-40b6-81c4-71dc3bd75e5a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:23:18
25818	9d68c954-06e9-4c53-b42a-681c82f3ad09	9d68c954-12d9-40b6-81c4-71dc3bd75e5a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"71.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:23:18
25819	9d68c954-077d-4bb8-876f-f3f0f251c53b	9d68c954-12d9-40b6-81c4-71dc3bd75e5a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:23:18
25820	9d68c954-103a-43cd-a3d5-09341d591f4a	9d68c954-12d9-40b6-81c4-71dc3bd75e5a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:23:18
25821	9d68c954-10f7-4d92-9fb0-e5a5bb473a25	9d68c954-12d9-40b6-81c4-71dc3bd75e5a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":725,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:23:18
42205	9d6cd7ec-1f4f-4bcd-94e2-863bffcd2885	9d6cd7ec-8335-462d-be61-9f52541de320	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:47:26
42206	9d6cd7ec-67c3-4500-a4f4-3398def7466a	9d6cd7ec-8335-462d-be61-9f52541de320	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"149.38","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 10:47:26
42207	9d6cd7ec-6817-45b8-9d26-b9d602a2cef6	9d6cd7ec-8335-462d-be61-9f52541de320	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:47:26
42208	9d6cd7ec-8175-4421-8af1-2c39d1c37609	9d6cd7ec-8335-462d-be61-9f52541de320	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:47:26
42209	9d6cd7ec-81e1-4c84-85e4-2865a9128262	9d6cd7ec-8335-462d-be61-9f52541de320	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"80","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":427,"memory":24,"hostname":"EderCortes"}	2024-11-06 10:47:26
42831	9d6ce058-0ac8-4827-a52f-e6e34a27c56b	9d6ce058-3092-4cf5-bdb3-1c5d7382e929	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 11:10:58
42832	9d6ce058-29ca-48cb-95cd-36e7232dc73e	9d6ce058-3092-4cf5-bdb3-1c5d7382e929	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 11:10:59
42833	9d6ce058-2a84-4e4e-b1bc-dfae9b9d5a75	9d6ce058-3092-4cf5-bdb3-1c5d7382e929	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 11:10:59
42834	9d6ce058-2ee1-42cc-813f-2695e6801a3a	9d6ce058-3092-4cf5-bdb3-1c5d7382e929	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:10:59
42835	9d6ce058-2f32-461a-8b55-7ee4ce7d02e6	9d6ce058-3092-4cf5-bdb3-1c5d7382e929	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":262,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:10:59
42210	9d6cd855-2298-46d6-843e-29a750afb581	9d6cd855-259e-477d-a1de-ac39a1437f41	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":164,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:48:34
42836	9d6ce058-8347-489c-ad31-db368d942764	9d6ce058-cc93-471d-b130-72eb95ab24b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:10:59
42837	9d6ce058-c770-4802-9a61-a029bac6e54a	9d6ce058-cc93-471d-b130-72eb95ab24b4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"150.81","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 11:10:59
42838	9d6ce058-c7c3-483b-8253-9da8d6e6b435	9d6ce058-cc93-471d-b130-72eb95ab24b4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 11:10:59
42839	9d6ce058-cb37-44d2-9644-0b08bfb6333f	9d6ce058-cc93-471d-b130-72eb95ab24b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:10:59
42840	9d6ce058-cb7e-44f9-9ac1-2546c3ee71f0	9d6ce058-cc93-471d-b130-72eb95ab24b4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:10:59
42211	9d6cd855-8567-4f77-a7d9-b3fd6dfe30eb	9d6cd855-c598-42e1-8e70-e8ef1a7a37c6	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:48:35
42212	9d6cd855-aa92-441c-bce4-1671af2c9fe7	9d6cd855-c598-42e1-8e70-e8ef1a7a37c6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"43.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 10:48:35
42213	9d6cd855-ab19-494c-bdd9-f2f85c20b482	9d6cd855-c598-42e1-8e70-e8ef1a7a37c6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:48:35
42214	9d6cd855-c3dd-4285-9a7d-de9e762f9d91	9d6cd855-c598-42e1-8e70-e8ef1a7a37c6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:48:35
42215	9d6cd855-c45b-43e0-b0fb-9e16066c8c25	9d6cd855-c598-42e1-8e70-e8ef1a7a37c6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"81","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":324,"memory":24,"hostname":"EderCortes"}	2024-11-06 10:48:35
42841	9d6ce059-1053-4556-a9ec-b31ad9391682	9d6ce059-2d16-48bf-b11f-fb678db02266	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:10:59
42842	9d6ce059-2866-4791-8ac7-d826626a022e	9d6ce059-2d16-48bf-b11f-fb678db02266	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"42.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 11:10:59
42843	9d6ce059-2ba8-4863-9b78-d9272ce5f74b	9d6ce059-2d16-48bf-b11f-fb678db02266	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:10:59
42844	9d6ce059-2c1f-46dd-859c-67213904d5c2	9d6ce059-2d16-48bf-b11f-fb678db02266	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":94,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":6000000,"loans_cuotas":18,"loans_estado":"Pendiente","loans_intereses":20,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"06-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:10:59
42216	9d6cd8ae-95b0-495b-a93a-c7fb8811e79c	9d6cd8ae-9a40-4b37-ac3f-d8043b0ddff1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":311,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:49:33
42845	9d6ce069-4734-4e00-aa74-8c3b9ed916ce	9d6ce069-6445-4272-b085-6880aeca428a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:11:10
42846	9d6ce069-5cd5-4b48-9c85-c118a06ed3d2	9d6ce069-6445-4272-b085-6880aeca428a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 94\\n                        ","time":"41.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":341,"hash":"b837d7548274814993a789edcd78e8c2","hostname":"EderCortes"}	2024-11-06 11:11:10
42847	9d6ce069-5f84-4894-9665-3893a8624ff5	9d6ce069-6445-4272-b085-6880aeca428a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '94' order by \\"item_loans\\".\\"id\\" asc","time":"2.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":379,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-06 11:11:10
42848	9d6ce069-62dc-4316-b90d-bda002a1dcb1	9d6ce069-6445-4272-b085-6880aeca428a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:11:10
42849	9d6ce069-633d-4d6b-8806-167c0941ae05	9d6ce069-6445-4272-b085-6880aeca428a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/94","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":94,"cobrador":"Luis andre","recomendador":"Maria Antonieta","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":20,"loans_cuotas":18,"loans_valor_prestado":6000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"06-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-06 00:00:00","loans_pago_prestado":null,"loans_pago_interes":null,"user_alias":"eder.cortes"},"items":[{"id":487,"loans_codigo":94,"itemloans_cuota":"1","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":488,"loans_codigo":94,"itemloans_cuota":"2","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-22 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":489,"loans_codigo":94,"itemloans_cuota":"3","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-30 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":490,"loans_codigo":94,"itemloans_cuota":"4","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-08 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":491,"loans_codigo":94,"itemloans_cuota":"5","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-16 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":492,"loans_codigo":94,"itemloans_cuota":"6","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-24 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":493,"loans_codigo":94,"itemloans_cuota":"7","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-01 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":494,"loans_codigo":94,"itemloans_cuota":"8","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":495,"loans_codigo":94,"itemloans_cuota":"9","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-17 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":496,"loans_codigo":94,"itemloans_cuota":"10","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-25 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":497,"loans_codigo":94,"itemloans_cuota":"11","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-02 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":498,"loans_codigo":94,"itemloans_cuota":"12","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-10 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":499,"loans_codigo":94,"itemloans_cuota":"13","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-18 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":500,"loans_codigo":94,"itemloans_cuota":"14","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-26 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":501,"loans_codigo":94,"itemloans_cuota":"15","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":502,"loans_codigo":94,"itemloans_cuota":"16","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":503,"loans_codigo":94,"itemloans_cuota":"17","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-22 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":504,"loans_codigo":94,"itemloans_cuota":"18","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-30 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:11:10
42217	9d6cd8af-5275-4b4c-9ae8-edd6423c20cb	9d6cd8af-8ba7-471c-b2ce-330827ca8166	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:49:33
42218	9d6cd8af-71ba-4768-91d2-ab7efee1f367	9d6cd8af-8ba7-471c-b2ce-330827ca8166	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"43.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 10:49:34
42219	9d6cd8af-720e-4d26-b560-7ee49f25d779	9d6cd8af-8ba7-471c-b2ce-330827ca8166	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:49:34
42220	9d6cd8af-8a46-45ee-bace-0c8d63f96616	9d6cd8af-8ba7-471c-b2ce-330827ca8166	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:49:34
42221	9d6cd8af-8a95-4c00-9b53-7c0b26f2f5b8	9d6cd8af-8ba7-471c-b2ce-330827ca8166	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"83","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":304,"memory":24,"hostname":"EderCortes"}	2024-11-06 10:49:34
42850	9d6ce081-93f8-4c01-b1d6-d271134db2d9	9d6ce081-97dd-49f8-81d2-c276dedfb6cf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":163,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:11:26
42222	9d6cd93e-2426-4f2a-887b-c35fdc6d0197	9d6cd93e-281c-466a-9873-6ae72884a59b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":165,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:51:07
42851	9d6ce082-4b5c-43b3-a84a-3df65fbc4d2c	9d6ce082-6b4b-4867-a457-3280b4062b55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:11:26
42852	9d6ce082-622e-49ac-9e01-3de3036bd131	9d6ce082-6b4b-4867-a457-3280b4062b55	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 487 limit 1","time":"2.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":438,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-06 11:11:26
42853	9d6ce082-627e-4a04-b23b-aab7f14cebc6	9d6ce082-6b4b-4867-a457-3280b4062b55	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-06 11:11:26
41223	9d6ccbdd-7c5e-4ca1-a393-0d34c113fc1f	9d6ccbdd-9951-47df-97c9-f3e847cc5afa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-06 10:13:43
41224	9d6ccbdd-97a8-45cd-9763-a9b364957004	9d6ccbdd-9951-47df-97c9-f3e847cc5afa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-06 10:13:43
42854	9d6ce082-6416-4511-a8c5-2d27fc7f54d0	9d6ce082-6b4b-4867-a457-3280b4062b55	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 94 limit 1","time":"1.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":439,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-06 11:11:26
42855	9d6ce082-644b-4798-97a3-86d880a28a2a	9d6ce082-6b4b-4867-a457-3280b4062b55	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-06 11:11:26
42856	9d6ce082-65e2-4a3d-b5ca-8eead6d0abe2	9d6ce082-6b4b-4867-a457-3280b4062b55	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '06-11-2024', \\"itemloans_interes_canelado\\" = '66666.666666667', \\"itemloans_cuota_cancelada\\" = '333333.33333333', \\"updated_at\\" = '2024-11-06 11:11:26' where \\"id\\" = 487","time":"2.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":482,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-06 11:11:26
42857	9d6ce082-6644-4d4b-af0d-609af00a7df8	9d6ce082-6b4b-4867-a457-3280b4062b55	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:487","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-06 11:11:26","item_loans_cuando_pago":"06-11-2024","itemloans_interes_canelado":"66666.666666667","itemloans_cuota_cancelada":"333333.33333333"},"hostname":"EderCortes"}	2024-11-06 11:11:26
42858	9d6ce082-66fc-4ae8-90f0-a0d340314412	9d6ce082-6b4b-4867-a457-3280b4062b55	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_estado\\" = 'En curso', \\"loans_pago_interes\\" = 66666.666666667, \\"loans_pago_prestado\\" = 333333.33333333, \\"updated_at\\" = '2024-11-06 11:11:26' where \\"id\\" = 94","time":"0.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":490,"hash":"acfe32aea56c9ca6bdbb917f944a78d1","hostname":"EderCortes"}	2024-11-06 11:11:26
42859	9d6ce082-6733-4b02-addd-85977e56b474	9d6ce082-6b4b-4867-a457-3280b4062b55	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:94","changes":{"loans_estado":"En curso","updated_at":"2024-11-06 11:11:26","loans_pago_interes":66666.666666667,"loans_pago_prestado":333333.33333333},"hostname":"EderCortes"}	2024-11-06 11:11:26
42860	9d6ce082-6a0d-4482-820c-19b4f84121e4	9d6ce082-6b4b-4867-a457-3280b4062b55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:11:26
42861	9d6ce082-6a55-430a-82d3-94963befddf0	9d6ce082-6b4b-4867-a457-3280b4062b55	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"198","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"66666.666666667","itemloans_cuota_cancelada":"333333.33333333","id":487,"loans_codigo":94,"itemloans_cuota":"1","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:11:26
41225	9d6ccbdd-983f-4a70-8e6d-ade0029605b8	9d6ccbdd-9951-47df-97c9-f3e847cc5afa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:13:43
42223	9d6cd93e-8053-4f1c-a5a8-9783bbe25783	9d6cd93e-e65b-4db6-889c-615f132a5e77	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:51:07
42224	9d6cd93e-cb9e-4fcd-b441-e60b4c1a4bd8	9d6cd93e-e65b-4db6-889c-615f132a5e77	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"139.84","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 10:51:08
42225	9d6cd93e-cc03-43de-97ea-e1566f811400	9d6cd93e-e65b-4db6-889c-615f132a5e77	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:51:08
42226	9d6cd93e-e4df-4847-9b19-1ee60018fcdd	9d6cd93e-e65b-4db6-889c-615f132a5e77	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:51:08
42227	9d6cd93e-e535-4283-a620-8d96a2140374	9d6cd93e-e65b-4db6-889c-615f132a5e77	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","profile":1},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":419,"memory":24,"hostname":"EderCortes"}	2024-11-06 10:51:08
42862	9d6ce082-bc9c-473c-bfa8-7706744de7bb	9d6ce083-0726-46a3-93b2-c441104fcde4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:11:26
42863	9d6ce082-ff74-4e49-ac3e-787ab8fdc173	9d6ce083-0726-46a3-93b2-c441104fcde4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 94\\n                        ","time":"156.00","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":341,"hash":"b837d7548274814993a789edcd78e8c2","hostname":"EderCortes"}	2024-11-06 11:11:27
42864	9d6ce083-0289-480f-934d-58ae1476aa47	9d6ce083-0726-46a3-93b2-c441104fcde4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '94' order by \\"item_loans\\".\\"id\\" asc","time":"2.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":379,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-06 11:11:27
42865	9d6ce083-0581-49b5-8109-62b6e7d7bb94	9d6ce083-0726-46a3-93b2-c441104fcde4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 11:11:27
41226	9d6ccbdd-f82b-4a58-8a3c-e4fa9405afac	9d6ccbde-4263-4bac-aef1-55ced6e780ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-06 10:13:43
41227	9d6ccbde-3d15-4d4c-81ec-725038f64fd3	9d6ccbde-4263-4bac-aef1-55ced6e780ba	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"159.77","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 10:13:43
41228	9d6ccbde-40c6-439f-be80-91418f7d95f0	9d6ccbde-4263-4bac-aef1-55ced6e780ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-06 10:13:43
41229	9d6ccbde-4131-401a-8a73-8e9b8d495522	9d6ccbde-4263-4bac-aef1-55ced6e780ba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":360,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:13:43
39031	9d6bcb7d-c5d7-4aca-bb9d-3c104a414e0c	9d6bcb7d-eeb0-4cf1-a6da-a9f86d7b559e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 22:16:50
39032	9d6bcb7d-ec2c-451f-a6e8-e49bb5d61777	9d6bcb7d-eeb0-4cf1-a6da-a9f86d7b559e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 22:16:50
39033	9d6bcb7d-ed11-44ba-a3c0-bf6f07218c4e	9d6bcb7d-eeb0-4cf1-a6da-a9f86d7b559e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":283,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:16:50
42228	9d6cd945-b897-4cc4-b3cb-8075da76946e	9d6cd946-0232-4ca5-bbf7-e899c8f0b746	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:51:12
42229	9d6cd945-fd6e-47b0-a083-0a6d2f7f5507	9d6cd946-0232-4ca5-bbf7-e899c8f0b746	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"153.83","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:51:12
42230	9d6cd945-fdcb-443c-add3-ab421751b0a6	9d6cd946-0232-4ca5-bbf7-e899c8f0b746	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:51:12
42231	9d6cd946-00e7-44b2-9f78-f101899e5ca4	9d6cd946-0232-4ca5-bbf7-e899c8f0b746	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:51:12
42232	9d6cd946-0131-41c5-abe4-f8a3696e07ec	9d6cd946-0232-4ca5-bbf7-e899c8f0b746	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":512,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:51:12
39034	9d6bcb7e-abdf-4343-b346-a53e04b8612d	9d6bcb7e-d5d4-478e-980b-c8812d945fe3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 22:16:51
39035	9d6bcb7e-ce18-4983-848b-a896e01032a2	9d6bcb7e-d5d4-478e-980b-c8812d945fe3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"59.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 22:16:51
39036	9d6bcb7e-d425-47f3-8c4f-3b6cc6146c37	9d6bcb7e-d5d4-478e-980b-c8812d945fe3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 22:16:51
39037	9d6bcb7e-d4a8-4eed-858a-65483d06c8ac	9d6bcb7e-d5d4-478e-980b-c8812d945fe3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":422,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:16:51
41230	9d6ccbde-a517-4eb5-bb5a-edc0a8402250	9d6ccbde-c56b-466f-9bea-df616cd04bef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-06 10:13:43
41231	9d6ccbde-bfb3-44be-987f-48ea15daa66e	9d6ccbde-c56b-466f-9bea-df616cd04bef	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:13:44
41232	9d6ccbde-c045-4335-8edb-f367e589fc0b	9d6ccbde-c56b-466f-9bea-df616cd04bef	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:13:44
41233	9d6ccbde-c40a-4595-bc18-e2b10cf44bec	9d6ccbde-c56b-466f-9bea-df616cd04bef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-11-06 10:13:44
41234	9d6ccbde-c467-4fb1-98ae-14d197523708	9d6ccbde-c56b-466f-9bea-df616cd04bef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":316,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:13:44
42233	9d6cd946-3fcb-4509-9e96-3d17c87c0c34	9d6cd946-589f-4a7b-88e5-426c61372f80	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:51:12
42234	9d6cd946-540f-4fd7-a842-21932455edb0	9d6cd946-589f-4a7b-88e5-426c61372f80	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"40.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:51:12
42235	9d6cd946-5705-4f4f-b800-7bdc18826163	9d6cd946-589f-4a7b-88e5-426c61372f80	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:51:12
42236	9d6cd946-5765-4445-9dc0-72d9517690cc	9d6cd946-589f-4a7b-88e5-426c61372f80	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":206,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:51:12
39038	9d6bcb7f-36f9-4714-bec1-ffdd87cbd5d7	9d6bcb7f-58f5-4c87-853f-d2895472fb0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 22:16:51
39039	9d6bcb7f-533c-4e94-9d69-f6aead85389d	9d6bcb7f-58f5-4c87-853f-d2895472fb0d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:16:51
39040	9d6bcb7f-539d-4fe9-a319-fef2b074a552	9d6bcb7f-58f5-4c87-853f-d2895472fb0d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:16:51
39041	9d6bcb7f-5773-4903-bc9f-70d447b5ed53	9d6bcb7f-58f5-4c87-853f-d2895472fb0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 22:16:51
39042	9d6bcb7f-57d0-4fde-bca0-1dc0c1935e02	9d6bcb7f-58f5-4c87-853f-d2895472fb0d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":324,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:16:51
41235	9d6ccbdf-1265-43d7-a6bd-51c3e8040d81	9d6ccbdf-5ac4-42f9-89ec-b703fba51ed5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-11-06 10:13:44
41236	9d6ccbdf-5521-486e-9b10-7d1ae2fb4ff5	9d6ccbdf-5ac4-42f9-89ec-b703fba51ed5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"143.80","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:13:44
41237	9d6ccbdf-5575-4986-8814-f6633cc60184	9d6ccbdf-5ac4-42f9-89ec-b703fba51ed5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:13:44
41238	9d6ccbdf-5974-4d4d-8e65-2d11f04b8d2d	9d6ccbdf-5ac4-42f9-89ec-b703fba51ed5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-11-06 10:13:44
41239	9d6ccbdf-59bf-4357-965f-a7f681944fb9	9d6ccbdf-5ac4-42f9-89ec-b703fba51ed5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":369,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:13:44
42237	9d6cd962-5e2e-43bd-b4c9-02b102de44f2	9d6cd962-6104-4431-a7c2-12f4faa4cb88	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":166,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:51:31
42866	9d6ce083-0604-4086-bb91-349485fb7c31	9d6ce083-0726-46a3-93b2-c441104fcde4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/94","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":94,"cobrador":"Luis andre","recomendador":"Maria Antonieta","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":20,"loans_cuotas":18,"loans_valor_prestado":6000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"06-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-06 00:00:00","loans_pago_prestado":"333333.33333333","loans_pago_interes":"66666.666666667","user_alias":"eder.cortes"},"items":[{"id":487,"loans_codigo":94,"itemloans_cuota":"1","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:11:26","deleted_at":null,"item_loans_cuando_pago":"2024-11-06 00:00:00","itemloans_interes_canelado":"66666.666666667","itemloans_cuota_cancelada":"333333.33333333","user_alias":"eder.cortes"},{"id":488,"loans_codigo":94,"itemloans_cuota":"2","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-22 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":489,"loans_codigo":94,"itemloans_cuota":"3","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-30 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":490,"loans_codigo":94,"itemloans_cuota":"4","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-08 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":491,"loans_codigo":94,"itemloans_cuota":"5","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-16 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":492,"loans_codigo":94,"itemloans_cuota":"6","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-24 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":493,"loans_codigo":94,"itemloans_cuota":"7","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-01 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":494,"loans_codigo":94,"itemloans_cuota":"8","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":495,"loans_codigo":94,"itemloans_cuota":"9","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-17 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":496,"loans_codigo":94,"itemloans_cuota":"10","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-25 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":497,"loans_codigo":94,"itemloans_cuota":"11","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-02 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":498,"loans_codigo":94,"itemloans_cuota":"12","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-10 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":499,"loans_codigo":94,"itemloans_cuota":"13","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-18 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":500,"loans_codigo":94,"itemloans_cuota":"14","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-26 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":501,"loans_codigo":94,"itemloans_cuota":"15","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":502,"loans_codigo":94,"itemloans_cuota":"16","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":503,"loans_codigo":94,"itemloans_cuota":"17","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-22 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":504,"loans_codigo":94,"itemloans_cuota":"18","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-30 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06 11:10:20","updated_at":"2024-11-06 11:10:20","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":374,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:11:27
39043	9d6bcb7f-9d7b-4f02-95e7-1eaf653f5df7	9d6bcb7f-bc00-434d-a690-c8b7770b9800	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 22:16:52
39044	9d6bcb7f-b6cc-4686-a16a-6461b0d7582d	9d6bcb7f-bc00-434d-a690-c8b7770b9800	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:16:52
39045	9d6bcb7f-b71d-4c2e-a245-1b93d920b664	9d6bcb7f-bc00-434d-a690-c8b7770b9800	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:16:52
39046	9d6bcb7f-baae-45a1-8968-d6fb82972f46	9d6bcb7f-bc00-434d-a690-c8b7770b9800	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 22:16:52
39047	9d6bcb7f-baf2-4708-a505-349664225352	9d6bcb7f-bc00-434d-a690-c8b7770b9800	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:16:52
41240	9d6ccbe0-ef13-4a45-bc07-e0ab21f60d56	9d6ccbe1-1ed8-4001-9884-ba122b341980	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-11-06 10:13:45
41241	9d6ccbe1-15e0-484c-9320-7efe964de502	9d6ccbe1-1ed8-4001-9884-ba122b341980	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"63.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:13:45
41242	9d6ccbe1-1658-480d-b785-91c5ed267d0a	9d6ccbe1-1ed8-4001-9884-ba122b341980	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:13:45
41243	9d6ccbe1-1cc3-4e4e-bb7c-9f4bfe389c54	9d6ccbe1-1ed8-4001-9884-ba122b341980	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-11-06 10:13:45
41244	9d6ccbe1-1d46-408a-9bbc-ac31bdafdcbc	9d6ccbe1-1ed8-4001-9884-ba122b341980	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":396,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:13:45
42238	9d6cd962-c088-4dd1-8bbc-bf4a16dc1e28	9d6cd963-24f2-4aa9-97f6-9f5d9f058bac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:51:31
42239	9d6cd963-0af6-48a9-8040-5d4364b660ae	9d6cd963-24f2-4aa9-97f6-9f5d9f058bac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"151.63","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 10:51:31
42240	9d6cd963-0b6d-4663-87fb-639cf2e6d218	9d6cd963-24f2-4aa9-97f6-9f5d9f058bac	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:51:31
42241	9d6cd963-23ab-4460-9dad-c6ec932709e8	9d6cd963-24f2-4aa9-97f6-9f5d9f058bac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:51:31
42242	9d6cd963-23f4-42df-ae21-4404b91a4315	9d6cd963-24f2-4aa9-97f6-9f5d9f058bac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"80","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":417,"memory":24,"hostname":"EderCortes"}	2024-11-06 10:51:31
42867	9d6ce100-479f-41fc-925b-4d9d1e03e479	9d6ce100-4b71-4702-949e-8029a0c5e380	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":156,"memory":20,"hostname":"EderCortes"}	2024-11-06 11:12:49
39048	9d6bcb81-dd83-4dd9-b8be-2dc9c1ef6141	9d6bcb81-fc89-435c-9b80-68646582c45f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 22:16:53
39049	9d6bcb81-f5e9-4687-8947-180232a674e7	9d6bcb81-fc89-435c-9b80-68646582c45f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 22:16:53
39050	9d6bcb81-f635-4766-8d4a-879ea0d32a43	9d6bcb81-fc89-435c-9b80-68646582c45f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 22:16:53
39051	9d6bcb81-faa2-43b3-bb3e-d3323d1e93f8	9d6bcb81-fc89-435c-9b80-68646582c45f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 22:16:53
39052	9d6bcb81-fb0d-4ffe-b4a2-78276e16e46a	9d6bcb81-fc89-435c-9b80-68646582c45f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":391,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:16:53
41245	9d6ccbe1-9a35-4ab6-8ab6-0eb19f81632f	9d6ccbe1-e83b-4290-a937-b9e4a7e0f35c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-11-06 10:13:45
41246	9d6ccbe1-e264-4251-ba69-a116efdd8dcb	9d6ccbe1-e83b-4290-a937-b9e4a7e0f35c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"160.88","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:13:46
41247	9d6ccbe1-e651-457c-844d-3389f5d6fd4b	9d6ccbe1-e83b-4290-a937-b9e4a7e0f35c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-11-06 10:13:46
41248	9d6ccbe1-e6c4-41c8-af91-c36956046e84	9d6ccbe1-e83b-4290-a937-b9e4a7e0f35c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":489,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:13:46
42243	9d6cd9a6-5c90-4de2-a1af-6f15d7c4f78e	9d6cd9a6-6077-495d-b8da-f9f2423d3e5d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":167,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:52:15
42868	9d6ce100-a530-46e2-960b-7ecd17999207	9d6ce100-cccd-41b0-9e83-7f84071e3c43	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 11:12:49
42869	9d6ce100-c51c-4445-a80f-33081bbcb829	9d6ce100-cccd-41b0-9e83-7f84071e3c43	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 11:12:49
42870	9d6ce100-c583-448e-92a4-5e27ce5c4642	9d6ce100-cccd-41b0-9e83-7f84071e3c43	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 11:12:49
42871	9d6ce100-cae5-4724-ad30-29cf8ee957c3	9d6ce100-cccd-41b0-9e83-7f84071e3c43	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:12:49
39053	9d6bcb82-5310-4e4e-9b07-eeb71241c3df	9d6bcb82-5638-4598-a51c-06c1c3f94c91	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":200,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:16:53
41249	9d6ccbe2-5265-48f3-bd72-953016331e04	9d6ccbe2-5875-4881-a4f7-09f7f58729e7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":235,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:13:46
42244	9d6cd9a7-1ceb-4b8d-844d-0a3bec87bd9a	9d6cd9a7-8f9a-4d4f-ae75-eedaa17bf2e9	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:52:16
42245	9d6cd9a7-7002-465f-93ec-bc49be3e934f	9d6cd9a7-8f9a-4d4f-ae75-eedaa17bf2e9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"156.74","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 10:52:16
42246	9d6cd9a7-709b-43af-9d7a-3df08c3c3865	9d6cd9a7-8f9a-4d4f-ae75-eedaa17bf2e9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:52:16
42247	9d6cd9a7-8dc1-45db-b20d-c413a6e744fa	9d6cd9a7-8f9a-4d4f-ae75-eedaa17bf2e9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:52:16
42248	9d6cd9a7-8e37-4f01-8577-95e796f7da38	9d6cd9a7-8f9a-4d4f-ae75-eedaa17bf2e9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"80","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":466,"memory":24,"hostname":"EderCortes"}	2024-11-06 10:52:16
42872	9d6ce100-cb4f-4379-b37e-a121092e9177	9d6ce100-cccd-41b0-9e83-7f84071e3c43	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":272,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:12:49
39054	9d6bcb82-bee4-446e-ab9a-18c018a485ad	9d6bcb82-e7d1-4d29-a0b3-2698fc58b25d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 22:16:54
39055	9d6bcb82-e345-48cb-aea9-900fe41964dd	9d6bcb82-e7d1-4d29-a0b3-2698fc58b25d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"60.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 22:16:54
39056	9d6bcb82-e649-4c4f-a10b-126d98b963e8	9d6bcb82-e7d1-4d29-a0b3-2698fc58b25d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 22:16:54
39057	9d6bcb82-e6b8-4c49-ba23-783e54b72bc6	9d6bcb82-e7d1-4d29-a0b3-2698fc58b25d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":317,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:16:54
41250	9d6ccbe2-f216-45a8-888a-6115a96b92a7	9d6ccbe3-1b7f-49fe-a9ca-4cb78818857a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-11-06 10:13:46
41251	9d6ccbe3-1482-45e2-9cc4-1f8d21f5fb99	9d6ccbe3-1b7f-49fe-a9ca-4cb78818857a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"59.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 10:13:46
41252	9d6ccbe3-194a-41e7-893c-e63a9ef3795b	9d6ccbe3-1b7f-49fe-a9ca-4cb78818857a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":29,"hostname":"EderCortes"}	2024-11-06 10:13:46
41253	9d6ccbe3-1a1c-435b-8faf-421dfe67c548	9d6ccbe3-1b7f-49fe-a9ca-4cb78818857a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":422,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:13:46
42249	9d6cda98-663b-4f01-908a-8b1bb2fbe3af	9d6cda98-6a21-40e1-a6ad-e11c97097a98	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":311,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:54:54
42873	9d6ce101-2848-4085-801c-873ea44937f9	9d6ce101-4900-4fcb-9fcc-f07781f14624	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:12:49
42874	9d6ce101-4302-4f90-b90d-5b73d9bd3dd4	9d6ce101-4900-4fcb-9fcc-f07781f14624	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 11:12:49
42875	9d6ce101-4354-4121-ba7c-0d1a911c9979	9d6ce101-4900-4fcb-9fcc-f07781f14624	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 11:12:49
42876	9d6ce101-475d-4853-bdd0-3fd6593b7e58	9d6ce101-4900-4fcb-9fcc-f07781f14624	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:12:49
42877	9d6ce101-47a7-4226-9572-6416c6939f27	9d6ce101-4900-4fcb-9fcc-f07781f14624	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":301,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:12:49
42250	9d6cda98-eb30-475e-8e13-eee9332499e0	9d6cda99-2f04-4c61-b5b7-b306fd635013	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:54:54
42251	9d6cda99-129b-485d-ae48-931629ec6487	9d6cda99-2f04-4c61-b5b7-b306fd635013	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"43.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 10:54:54
42252	9d6cda99-133b-4d33-9b6e-894ceedd1a8d	9d6cda99-2f04-4c61-b5b7-b306fd635013	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:54:54
42253	9d6cda99-2d14-4608-9d69-607229f9f594	9d6cda99-2f04-4c61-b5b7-b306fd635013	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:54:55
39295	9d6bcf5f-3c5f-4609-a979-607547278cb1	9d6bcf5f-6157-4092-bce2-a724ab6c8e9d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 22:27:41
42254	9d6cda99-2da5-40d0-9fb5-aaa746f7497e	9d6cda99-2f04-4c61-b5b7-b306fd635013	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","profile":1},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":332,"memory":24,"hostname":"EderCortes"}	2024-11-06 10:54:55
42878	9d6ce101-8f54-440f-bbee-c2bd158beeb6	9d6ce101-ad68-46df-97e2-d9ceb705d8ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:12:50
42879	9d6ce101-a80f-46a0-bf09-f5d9ac5b519e	9d6ce101-ad68-46df-97e2-d9ceb705d8ec	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"44.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":89,"hash":"f9f3598e6ad2468770f89917d2ab916c","hostname":"EderCortes"}	2024-11-06 11:12:50
42880	9d6ce101-abf4-4cc9-ab25-38ffd8e2ff96	9d6ce101-ad68-46df-97e2-d9ceb705d8ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:12:50
42881	9d6ce101-ac5c-45b8-bbab-e17c83ea128b	9d6ce101-ad68-46df-97e2-d9ceb705d8ec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getLoansCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"id":94,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":6000000,"loans_cuotas":18,"loans_estado":"En curso","loans_intereses":20,"cobrador":"Luis andre","recomendador":"Maria Antonieta"},{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":242,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:12:50
39296	9d6bcf5f-5ee1-4d77-980c-07b40856425b	9d6bcf5f-6157-4092-bce2-a724ab6c8e9d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 22:27:41
39297	9d6bcf5f-600d-49e0-81b9-0ff969023233	9d6bcf5f-6157-4092-bce2-a724ab6c8e9d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:27:41
42255	9d6cdaa0-84c2-40df-bee0-e7a75edc8e88	9d6cdaa0-a1f0-4818-aa4a-c3fb344a158a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:54:59
42256	9d6cdaa0-9cbd-4c85-b3e5-f2bffa1d332b	9d6cdaa0-a1f0-4818-aa4a-c3fb344a158a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:54:59
27472	9d68e569-0587-42d9-adf3-1995be8a180a	9d68e569-518c-4f7c-9f1f-5496354caba6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:41:50
27473	9d68e569-4df8-455c-902d-ed92ac5c35ad	9d68e569-518c-4f7c-9f1f-5496354caba6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:41:50
27474	9d68e569-4faf-466f-ba27-6a7f2de13340	9d68e569-518c-4f7c-9f1f-5496354caba6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":673,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:41:50
42257	9d6cdaa0-9d25-4116-88b4-6fea1032ebd6	9d6cdaa0-a1f0-4818-aa4a-c3fb344a158a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:54:59
42258	9d6cdaa0-a088-496d-b9e7-ad61d6175176	9d6cdaa0-a1f0-4818-aa4a-c3fb344a158a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:54:59
42259	9d6cdaa0-a0ea-48e8-8875-87d10dc22d0f	9d6cdaa0-a1f0-4818-aa4a-c3fb344a158a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":380,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:54:59
42882	9d6ce10f-52e1-47e4-aaf6-b7caa68ea57d	9d6ce10f-9b0d-4cfb-94dd-17eafc3136bc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:12:59
42883	9d6ce10f-9683-4b68-9f58-33d600fe4ceb	9d6ce10f-9b0d-4cfb-94dd-17eafc3136bc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"147.24","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 11:12:59
42884	9d6ce10f-96d2-4c7e-b3ea-a6d02b0f3dde	9d6ce10f-9b0d-4cfb-94dd-17eafc3136bc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 11:12:59
42885	9d6ce10f-99ec-40ca-9818-c8367ac1b73e	9d6ce10f-9b0d-4cfb-94dd-17eafc3136bc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:12:59
42886	9d6ce10f-9a2b-4244-a80a-96359c1aa3f0	9d6ce10f-9b0d-4cfb-94dd-17eafc3136bc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":440,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:12:59
27475	9d68e56a-2a64-46ba-8379-285a40d92084	9d68e56a-83e4-4ea1-8325-290c9e8a28f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:41:51
27476	9d68e56a-7bf8-42b6-853e-d8df23f4b938	9d68e56a-83e4-4ea1-8325-290c9e8a28f4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"164.94","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:41:51
27477	9d68e56a-7c75-4a22-b1fd-c17d3c74c16d	9d68e56a-83e4-4ea1-8325-290c9e8a28f4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:41:51
27478	9d68e56a-8207-47d1-808c-df6e1f0cea29	9d68e56a-83e4-4ea1-8325-290c9e8a28f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:41:51
27479	9d68e56a-826d-420d-ac70-296620690125	9d68e56a-83e4-4ea1-8325-290c9e8a28f4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":693,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:41:51
39298	9d6bcf5f-d7f8-44a1-a610-4a4c3dc6847f	9d6bcf5f-e08b-41bd-83f4-8f2c7b744ae9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 22:27:42
39299	9d6bcf5f-df76-4eee-92f1-cec9b1010119	9d6bcf5f-e08b-41bd-83f4-8f2c7b744ae9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 22:27:42
39300	9d6bcf5f-dfb2-4d21-ba3f-00557a307b7a	9d6bcf5f-e08b-41bd-83f4-8f2c7b744ae9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"56"},"payload":{"cobrador":0,"frecuencia":0,"estado":0,"prestamista":0},"session":[],"response_status":200,"response":{"data":{"cobrador":0,"frecuencia":0,"estado":0,"prestamista":0}},"duration":267,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:27:42
42260	9d6cdaa0-e77f-4778-9ba4-b2b422917972	9d6cdaa1-02b8-4f3f-99e3-077fa0d18b25	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:55:00
42261	9d6cdaa0-fe1a-4947-b857-085c4188b066	9d6cdaa1-02b8-4f3f-99e3-077fa0d18b25	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"45.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:55:00
42262	9d6cdaa1-0159-49f0-8ed2-4a60ff30ada1	9d6cdaa1-02b8-4f3f-99e3-077fa0d18b25	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:55:00
42263	9d6cdaa1-01a2-4bac-9f1f-90f7c0b9c41c	9d6cdaa1-02b8-4f3f-99e3-077fa0d18b25	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:55:00
42887	9d6ce10f-e3b4-46a5-a9c2-2eb407feaa9f	9d6ce110-08b5-4b03-b479-fe9e3c224180	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:12:59
42888	9d6ce110-02af-44c2-9f5c-1b57fc01e3ea	9d6ce110-08b5-4b03-b479-fe9e3c224180	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"55.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":286,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-06 11:12:59
42889	9d6ce110-032f-46c4-bdf0-c6b41eacf865	9d6ce110-08b5-4b03-b479-fe9e3c224180	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-06 11:12:59
42890	9d6ce110-0750-439e-bdd0-1c76911cae02	9d6ce110-08b5-4b03-b479-fe9e3c224180	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:12:59
42891	9d6ce110-07a8-4cc8-9d4c-4fbc4ba48f4f	9d6ce110-08b5-4b03-b479-fe9e3c224180	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":265,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:12:59
27480	9d68e56b-22c7-4305-85f1-8664a6b8f8e4	9d68e56b-5224-4624-a01b-b2d55b908dce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:41:51
27481	9d68e56b-481f-490b-bf97-2c062eb18ddc	9d68e56b-5224-4624-a01b-b2d55b908dce	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"62.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:41:51
27482	9d68e56b-48af-4cdf-afbf-86559146596b	9d68e56b-5224-4624-a01b-b2d55b908dce	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 11:41:51
27483	9d68e56b-5046-4ea6-aeb6-cac4851a672e	9d68e56b-5224-4624-a01b-b2d55b908dce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:41:51
27484	9d68e56b-50c7-4ffa-9702-03efe85d1605	9d68e56b-5224-4624-a01b-b2d55b908dce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":511,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:41:51
39301	9d6bcf60-38be-4596-aef4-3da8ad38046f	9d6bcf60-80e0-4757-aea8-75088e599996	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 22:27:42
39302	9d6bcf60-7aee-4aaf-8d60-9cfde8383ad6	9d6bcf60-80e0-4757-aea8-75088e599996	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"143.86","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:27:42
39303	9d6bcf60-7b39-48a1-a29f-0c813f5ad5f8	9d6bcf60-80e0-4757-aea8-75088e599996	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:27:42
39304	9d6bcf60-7fbd-46cf-8a94-bc45eb9cdf22	9d6bcf60-80e0-4757-aea8-75088e599996	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 22:27:42
39305	9d6bcf60-7fff-4d25-8bff-ebef19fc705b	9d6bcf60-80e0-4757-aea8-75088e599996	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:27:42
42264	9d6cdab0-225c-4004-8f9b-c64fbdcb910d	9d6cdab0-25ce-4b1e-85ad-5f0a7f2d2ca2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":174,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:55:10
42892	9d6ce110-5110-4135-a9da-d9cbf75e0b6f	9d6ce110-71e5-4865-bfd9-2e1666e92ac8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:12:59
42893	9d6ce110-6ba2-4831-889e-37547104b44e	9d6ce110-71e5-4865-bfd9-2e1666e92ac8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":235,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 11:12:59
42894	9d6ce110-6bfb-4273-8e3b-002abaa08f2d	9d6ce110-71e5-4865-bfd9-2e1666e92ac8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-06 11:12:59
42895	9d6ce110-7025-4a73-8a29-bb5e7409b06a	9d6ce110-71e5-4865-bfd9-2e1666e92ac8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 11:12:59
42896	9d6ce110-7075-48d0-be62-48a49b8d7de9	9d6ce110-71e5-4865-bfd9-2e1666e92ac8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:12:59
27485	9d68e56b-f0cf-40a9-8108-3f8abd7e31b7	9d68e56c-17b7-4f5e-b11a-67f0bad0c009	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:41:52
27486	9d68e56c-0f25-4deb-933a-0544b12d0fcc	9d68e56c-17b7-4f5e-b11a-67f0bad0c009	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '90' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"53.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 11:41:52
27487	9d68e56c-0f96-4412-885e-4969e9697dbc	9d68e56c-17b7-4f5e-b11a-67f0bad0c009	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 11:41:52
27488	9d68e56c-11ae-4586-9801-6a6881cbe790	9d68e56c-17b7-4f5e-b11a-67f0bad0c009	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"2.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:41:52
27489	9d68e56c-11ea-4cd6-8aa8-ec42981cb815	9d68e56c-17b7-4f5e-b11a-67f0bad0c009	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 11:41:52
27490	9d68e56c-163a-40de-aa93-9c372e8bca64	9d68e56c-17b7-4f5e-b11a-67f0bad0c009	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:41:52
27491	9d68e56c-169f-4d42-b03d-f1c5de7daed9	9d68e56c-17b7-4f5e-b11a-67f0bad0c009	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"275000","loans_pago_prestado":"1100000","loans_intereses_recaudar":"275000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"}]}},"duration":478,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:41:52
39306	9d6bcf60-ca44-4411-83de-5fd7a1efc92b	9d6bcf61-1ead-4254-89f2-675aa817ecfa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 22:27:42
39307	9d6bcf61-19a9-4aeb-b3d8-20ec65dbe34d	9d6bcf61-1ead-4254-89f2-675aa817ecfa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"152.63","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:27:43
39308	9d6bcf61-1a0c-4823-b646-1b0bf346754e	9d6bcf61-1ead-4254-89f2-675aa817ecfa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:27:43
39309	9d6bcf61-1daa-4db7-bcca-cb14ff1ae842	9d6bcf61-1ead-4254-89f2-675aa817ecfa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 22:27:43
39310	9d6bcf61-1dec-4ca6-a61a-2da3bf593d26	9d6bcf61-1ead-4254-89f2-675aa817ecfa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":384,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:27:43
42265	9d6cdab0-dc3c-4156-8f68-d5044f36de9e	9d6cdab1-1408-473b-8379-ed5f119d145d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:55:10
42266	9d6cdab0-fa50-4b32-9229-a33789ada448	9d6cdab1-1408-473b-8379-ed5f119d145d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"41.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 10:55:10
42267	9d6cdab0-faa9-47c5-b6e4-fdf872a2f17b	9d6cdab1-1408-473b-8379-ed5f119d145d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:55:10
42268	9d6cdab1-12ab-4fde-a931-2f6202ada225	9d6cdab1-1408-473b-8379-ed5f119d145d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:55:10
42269	9d6cdab1-12f2-4b0e-8ce7-dc76980cfee5	9d6cdab1-1408-473b-8379-ed5f119d145d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"81","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":301,"memory":24,"hostname":"EderCortes"}	2024-11-06 10:55:10
42897	9d6ce110-b1ba-409e-a739-fd7093380cd6	9d6ce110-fc05-4334-a970-83ca9fdcd2df	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 11:12:59
27492	9d68e56d-6c31-47e1-9388-d211340d81d9	9d68e56d-c825-472c-b819-01bd300d50a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:41:53
27493	9d68e56d-bd82-4053-867c-29b26099cd5c	9d68e56d-c825-472c-b819-01bd300d50a2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"160.82","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:41:53
27494	9d68e56d-be11-4038-840c-45c1468ee7f7	9d68e56d-c825-472c-b819-01bd300d50a2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:41:53
27495	9d68e56d-c5c3-47ed-9618-38aeff336c1b	9d68e56d-c825-472c-b819-01bd300d50a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:41:53
27496	9d68e56d-c66f-447e-aeab-2cf68b637aa6	9d68e56d-c825-472c-b819-01bd300d50a2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1087,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:41:53
39311	9d6bcf62-ce52-4a8b-a104-74d0e936afa2	9d6bcf63-23c5-4681-a51e-27bdba42bc75	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 22:27:44
39312	9d6bcf63-1af6-48f3-9720-2de45a27b94d	9d6bcf63-23c5-4681-a51e-27bdba42bc75	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"127.36","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 22:27:44
39313	9d6bcf63-1b6b-4f1c-8a94-ffff8cfa20dd	9d6bcf63-23c5-4681-a51e-27bdba42bc75	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 22:27:44
39314	9d6bcf63-21af-4b42-aee9-4d20a2e9ff2a	9d6bcf63-23c5-4681-a51e-27bdba42bc75	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 22:27:44
39315	9d6bcf63-222c-40c2-8fc8-2b847d019f11	9d6bcf63-23c5-4681-a51e-27bdba42bc75	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":459,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:27:44
42270	9d6cdaf1-1b4f-4b07-bda5-e1c42842fb3f	9d6cdaf1-1e98-4510-acae-dae2fc976c2f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":161,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:55:52
42898	9d6ce110-f4ef-47bb-96e0-6ac30ea3e716	9d6ce110-fc05-4334-a970-83ca9fdcd2df	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_valor_prestado\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\" from \\"loans\\" where \\"id\\" = '94' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"154.18","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":273,"hash":"f00e27e21a94f93c5c7a1d0cd56f9f13","hostname":"EderCortes"}	2024-11-06 11:13:00
42899	9d6ce110-f53e-4474-85bf-e1796537c65e	9d6ce110-fc05-4334-a970-83ca9fdcd2df	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-06 11:13:00
42900	9d6ce110-f717-453a-9711-1c24dd44119b	9d6ce110-fc05-4334-a970-83ca9fdcd2df	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '94' order by \\"item_loans\\".\\"id\\" asc","time":"2.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":274,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-06 11:13:00
42901	9d6ce110-f746-4818-afe0-dddb6c586bad	9d6ce110-fc05-4334-a970-83ca9fdcd2df	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":18,"hostname":"EderCortes"}	2024-11-06 11:13:00
27497	9d68e56e-b71f-4217-8e61-131d8fe1f441	9d68e56e-e6d0-4cd4-9a51-fefb28a72160	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:41:53
27498	9d68e56e-dee3-481f-b74f-9f8f18d8e53c	9d68e56e-e6d0-4cd4-9a51-fefb28a72160	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"62.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:41:54
27499	9d68e56e-df6b-40ba-b8b5-f6119e6e53df	9d68e56e-e6d0-4cd4-9a51-fefb28a72160	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:41:54
27500	9d68e56e-e504-49c5-884d-165f0d6e487e	9d68e56e-e6d0-4cd4-9a51-fefb28a72160	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:41:54
27501	9d68e56e-e575-4177-9da8-29d21278e228	9d68e56e-e6d0-4cd4-9a51-fefb28a72160	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":702,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:41:54
39316	9d6bcf63-7362-46f4-9f05-d64b50ffde95	9d6bcf63-7663-4503-a1a8-5ad1b4723a74	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":174,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:27:44
42271	9d6cdaf1-dd27-451b-bfb0-1b270e1e3b2e	9d6cdaf2-13ac-4145-b014-38714c548cf5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:55:53
42272	9d6cdaf1-fa28-43a8-9847-6a7798b7bb7d	9d6cdaf2-13ac-4145-b014-38714c548cf5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"39.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 10:55:53
42273	9d6cdaf1-fa80-48fd-897a-60b3a6058bde	9d6cdaf2-13ac-4145-b014-38714c548cf5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:55:53
42274	9d6cdaf2-11fc-4950-903d-173399832069	9d6cdaf2-13ac-4145-b014-38714c548cf5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:55:53
42275	9d6cdaf2-1256-4882-b0fb-4b86eb94e755	9d6cdaf2-13ac-4145-b014-38714c548cf5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"80","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":310,"memory":24,"hostname":"EderCortes"}	2024-11-06 10:55:53
42902	9d6ce110-fa9c-4a6b-973d-9ed8c0b74d84	9d6ce110-fc05-4334-a970-83ca9fdcd2df	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 11:13:00
42903	9d6ce110-faea-409d-8d0c-5cada14ce508	9d6ce110-fc05-4334-a970-83ca9fdcd2df	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/94","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":20,"loans_cuotas":18,"loans_valor_prestado":6000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"06-11-2024","loans_estado":"En curso","loans_celular":312596295,"user_creador":12,"user_cobrador":14,"user_customer":19,"user_recomendacion":18},"items":[{"id":487,"loans_codigo":94,"itemloans_cuota":"1","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:11:26.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-06 00:00:00","itemloans_interes_canelado":"66666.666666667","itemloans_cuota_cancelada":"333333.33333333"},{"id":488,"loans_codigo":94,"itemloans_cuota":"2","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-22 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":489,"loans_codigo":94,"itemloans_cuota":"3","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-30 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":490,"loans_codigo":94,"itemloans_cuota":"4","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-08 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":491,"loans_codigo":94,"itemloans_cuota":"5","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-16 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":492,"loans_codigo":94,"itemloans_cuota":"6","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-24 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":493,"loans_codigo":94,"itemloans_cuota":"7","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-01 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":494,"loans_codigo":94,"itemloans_cuota":"8","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-09 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":495,"loans_codigo":94,"itemloans_cuota":"9","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-17 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":496,"loans_codigo":94,"itemloans_cuota":"10","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-25 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":497,"loans_codigo":94,"itemloans_cuota":"11","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-02 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":498,"loans_codigo":94,"itemloans_cuota":"12","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-10 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":499,"loans_codigo":94,"itemloans_cuota":"13","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-18 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":500,"loans_codigo":94,"itemloans_cuota":"14","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-26 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":501,"loans_codigo":94,"itemloans_cuota":"15","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":502,"loans_codigo":94,"itemloans_cuota":"16","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":503,"loans_codigo":94,"itemloans_cuota":"17","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-22 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":504,"loans_codigo":94,"itemloans_cuota":"18","itemloans_valor_cuota":"333333.33333333","itemloans_iteres":"66666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-30 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-06T16:10:20.000000Z","updated_at":"2024-11-06T16:10:20.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":339,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:13:00
39317	9d6bcf63-f6f7-47ff-b027-4d297afa9141	9d6bcf63-fe6d-4aef-8ba9-1690e539ff57	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 22:27:44
39318	9d6bcf63-fd2d-44d6-92b2-8217c5ad6a55	9d6bcf63-fe6d-4aef-8ba9-1690e539ff57	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 22:27:44
39319	9d6bcf63-fd70-47fd-8bdd-6f6a37bfc1ec	9d6bcf63-fe6d-4aef-8ba9-1690e539ff57	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"56","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":0,"frecuencia":0,"estado":0,"prestamista":0},"session":[],"response_status":200,"response":{"data":{"cobrador":0,"frecuencia":0,"estado":0,"prestamista":0}},"duration":175,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:27:44
42276	9d6cdaf2-ab62-4294-9931-6bdd2defd428	9d6cdaf2-ae83-4f71-ba9b-1ad1ef169752	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":202,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:55:53
42904	9d6ce14f-1606-4092-b98a-4c29fe11e4ea	9d6ce14f-1a24-4091-af4e-57e6c23d87ea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":162,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:13:40
42277	9d6cdaf3-686f-4e58-81b8-6cc53f81f7d8	9d6cdaf3-cfa7-4840-8757-790406ba74c1	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:55:54
42278	9d6cdaf3-b55a-49f5-80ac-e028c1f261e0	9d6cdaf3-cfa7-4840-8757-790406ba74c1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"147.95","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 10:55:54
42279	9d6cdaf3-b5d2-4e17-b420-5efed745bfcf	9d6cdaf3-cfa7-4840-8757-790406ba74c1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:55:54
42280	9d6cdaf3-cdfc-4ab9-afcb-c97f0f2deafd	9d6cdaf3-cfa7-4840-8757-790406ba74c1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:55:54
42281	9d6cdaf3-ce53-4761-996f-8bf68cc6ca62	9d6cdaf3-cfa7-4840-8757-790406ba74c1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"80","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":421,"memory":24,"hostname":"EderCortes"}	2024-11-06 10:55:54
42905	9d6ce14f-7919-4710-be1e-ea767d3c059a	9d6ce14f-c3a5-4e7b-9545-4bffbad25bd6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 11:13:41
42906	9d6ce14f-bd2a-4a70-bef3-e5265a36636d	9d6ce14f-c3a5-4e7b-9545-4bffbad25bd6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"148.73","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 11:13:41
42907	9d6ce14f-bd7a-4d75-b17f-d3a313c75fc5	9d6ce14f-c3a5-4e7b-9545-4bffbad25bd6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 11:13:41
42908	9d6ce14f-c21d-4232-923b-021f087efeb0	9d6ce14f-c3a5-4e7b-9545-4bffbad25bd6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 11:13:41
42909	9d6ce14f-c272-4ac4-b7e5-fb5375b803ba	9d6ce14f-c3a5-4e7b-9545-4bffbad25bd6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":367,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:13:41
42910	9d6ce150-1360-42f8-ae91-c686a7007329	9d6ce150-347e-4e9e-9730-f1ac443d581f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 11:13:41
30021	9d6932ff-9fdb-4336-85e4-04c3aedd37d7	9d6932ff-ca63-4e8a-9f31-91cf7692c176	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 15:18:47
30022	9d6932ff-c850-4e55-baeb-d58f90fbc401	9d6932ff-ca63-4e8a-9f31-91cf7692c176	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:18:47
30023	9d6932ff-c93a-4b89-a45c-5067c2a54031	9d6932ff-ca63-4e8a-9f31-91cf7692c176	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":343,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:18:47
42911	9d6ce150-2f2c-41e9-8129-e17ab728d032	9d6ce150-347e-4e9e-9730-f1ac443d581f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 11:13:41
42912	9d6ce150-2f97-415b-a112-5b03a96abce1	9d6ce150-347e-4e9e-9730-f1ac443d581f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 11:13:41
42913	9d6ce150-3308-4237-98a3-eb9e798904de	9d6ce150-347e-4e9e-9730-f1ac443d581f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 11:13:41
42282	9d6cdaf6-fdec-4e99-a89c-b2cd11381ead	9d6cdaf7-015b-4cee-bf58-97736550dbac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":297,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:55:56
42914	9d6ce150-3375-4b45-a784-e9315a6f2112	9d6ce150-347e-4e9e-9730-f1ac443d581f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":271,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:13:41
30024	9d693300-56b0-4d93-8467-8936aed87279	9d693300-ab2e-4dbb-8621-645f119f3149	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:18:47
30025	9d693300-9de9-4ca6-bb71-7694be0b8231	9d693300-ab2e-4dbb-8621-645f119f3149	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"163.99","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 15:18:48
30026	9d693300-a30c-4105-b82e-1a5bb624204c	9d693300-ab2e-4dbb-8621-645f119f3149	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 15:18:48
30027	9d693300-a35f-4c11-9986-3894b9e65ab4	9d693300-ab2e-4dbb-8621-645f119f3149	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 15:18:48
30028	9d693300-a9d4-4c43-a46b-916f219ffe8f	9d693300-ab2e-4dbb-8621-645f119f3149	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 15:18:48
30029	9d693300-aa44-4061-86dc-1ec0e85c71af	9d693300-ab2e-4dbb-8621-645f119f3149	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":470,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:18:48
42283	9d6cdaf7-b51b-4dd5-8304-4a1977541e14	9d6cdaf7-eac4-489d-847f-42a6ebba3eaf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:55:56
42284	9d6cdaf7-d189-4513-b18f-2806b4c384e4	9d6cdaf7-eac4-489d-847f-42a6ebba3eaf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"42.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 10:55:57
42285	9d6cdaf7-d1f9-420f-ad0a-6f8151b87a0c	9d6cdaf7-eac4-489d-847f-42a6ebba3eaf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:55:57
42286	9d6cdaf7-e97e-4d1e-bbb9-e5adb9794f44	9d6cdaf7-eac4-489d-847f-42a6ebba3eaf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:55:57
42287	9d6cdaf7-e9cb-4c24-a878-b8b19c1c07c1	9d6cdaf7-eac4-489d-847f-42a6ebba3eaf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"80","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":286,"memory":24,"hostname":"EderCortes"}	2024-11-06 10:55:57
42915	9d6ce150-8273-4a19-8fec-aac8023351c2	9d6ce150-a611-48b2-87ac-a9718fb073d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 11:13:41
42916	9d6ce150-a1ac-4c22-bdfd-8f9c608ed6bc	9d6ce150-a611-48b2-87ac-a9718fb073d5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"52.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":89,"hash":"f9f3598e6ad2468770f89917d2ab916c","hostname":"EderCortes"}	2024-11-06 11:13:41
42917	9d6ce150-a4cc-45fb-9ce8-f87da50e0464	9d6ce150-a611-48b2-87ac-a9718fb073d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 11:13:41
42288	9d6cdaf8-40fa-4e7e-b190-79a02dd14d91	9d6cdaf8-4421-4f85-8d8d-c92d9afbe0a3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":164,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:55:57
42918	9d6ce150-a52b-42ea-9dc5-a51305ba3fb4	9d6ce150-a611-48b2-87ac-a9718fb073d5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getLoansCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"id":94,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":6000000,"loans_cuotas":18,"loans_estado":"En curso","loans_intereses":20,"cobrador":"Luis andre","recomendador":"Maria Antonieta"},{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":271,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:13:41
27585	9d68e87b-6145-428c-8e4c-79a0742b8fad	9d68e87b-8b6a-4a80-be8f-5e0d6b6a2209	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 11:50:25
27586	9d68e87b-890d-46ff-bc31-700edcffd579	9d68e87b-8b6a-4a80-be8f-5e0d6b6a2209	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:50:25
27587	9d68e87b-8a00-43f1-92f8-2c72ad557c81	9d68e87b-8b6a-4a80-be8f-5e0d6b6a2209	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":463,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:50:25
27588	9d68e87c-2cd7-4a05-b5e3-ebf8f899b225	9d68e87c-530e-4465-a7d1-2de57f812ae6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:50:26
27589	9d68e87c-4819-455c-944b-0a549c3c2c31	9d68e87c-530e-4465-a7d1-2de57f812ae6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"54.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:50:26
27590	9d68e87c-4c12-41fe-a6a0-5836cedfec80	9d68e87c-530e-4465-a7d1-2de57f812ae6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:50:26
27591	9d68e87c-4c55-4fd5-af87-3a85d6abb48c	9d68e87c-530e-4465-a7d1-2de57f812ae6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:50:26
27592	9d68e87c-5199-4610-89c7-7556d6f35274	9d68e87c-530e-4465-a7d1-2de57f812ae6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:50:26
27593	9d68e87c-51fc-410e-b8ef-a470f974e000	9d68e87c-530e-4465-a7d1-2de57f812ae6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":455,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:50:26
42289	9d6cdaf8-fa28-4f1c-adaa-a90fbb0e342a	9d6cdaf9-5d05-4250-958c-64a1d52c265e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:55:57
42290	9d6cdaf9-43a1-4596-9d73-d4540e80981f	9d6cdaf9-5d05-4250-958c-64a1d52c265e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"150.18","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 10:55:57
42291	9d6cdaf9-43fa-448f-aaa7-492231219525	9d6cdaf9-5d05-4250-958c-64a1d52c265e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:55:57
42292	9d6cdaf9-5bc6-45cd-b62d-7a38da7c056b	9d6cdaf9-5d05-4250-958c-64a1d52c265e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:55:58
42293	9d6cdaf9-5c0e-48e2-bdff-984b65d87068	9d6cdaf9-5d05-4250-958c-64a1d52c265e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"80","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":406,"memory":24,"hostname":"EderCortes"}	2024-11-06 10:55:58
42294	9d6cdaf9-a987-4e27-a966-186dd07ff45d	9d6cdaf9-ad5e-4a27-9f36-269932e02379	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":168,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:55:58
42295	9d6cdafa-4aca-4ae1-b8b3-f95f6f012811	9d6cdafa-4dd4-40fa-995e-8d0b721ba13f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":220,"memory":20,"hostname":"EderCortes"}	2024-11-06 10:55:58
39618	9d6bdf66-3ee8-4c21-99d4-8c3b00a28777	9d6bdf66-8c6e-4aa3-87d1-501f66691a24	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 23:12:30
39619	9d6bdf66-8a41-425a-827e-9722ca74b226	9d6bdf66-8c6e-4aa3-87d1-501f66691a24	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 23:12:31
39620	9d6bdf66-8b43-4c57-b8da-159a49d1938d	9d6bdf66-8c6e-4aa3-87d1-501f66691a24	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":435,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:12:31
39621	9d6bdf68-904c-440f-87ca-6c3da448e2f3	9d6bdf68-ad97-471e-9629-64964f1f07fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 23:12:32
39622	9d6bdf68-a77e-4374-9410-050b93f9735c	9d6bdf68-ad97-471e-9629-64964f1f07fb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"39.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 23:12:32
39623	9d6bdf68-a7c6-423d-8ef6-0e72e823074f	9d6bdf68-ad97-471e-9629-64964f1f07fb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 23:12:32
25973	9d68cc26-c0e0-435f-b765-b7b6fc11f8a1	9d68cc26-dfa2-4903-8d7c-4168c398b704	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:31:12
25974	9d68cc26-dda7-4f4d-8592-4fb4c999187c	9d68cc26-dfa2-4903-8d7c-4168c398b704	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:31:12
25975	9d68cc26-de8a-42d9-8994-2eb759ddaf88	9d68cc26-dfa2-4903-8d7c-4168c398b704	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":367,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:31:12
39624	9d6bdf68-ac59-4abb-95a2-a646a19eee2a	9d6bdf68-ad97-471e-9629-64964f1f07fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 23:12:32
39625	9d6bdf68-aca4-4873-a932-ec53b56c53b1	9d6bdf68-ad97-471e-9629-64964f1f07fb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":396,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:12:32
42296	9d6cdafa-a3ce-44f3-b1a1-4294b63d2b49	9d6cdafa-a7bc-4e41-8ac3-a61f1259453a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":149,"memory":20,"hostname":"EderCortes"}	2024-11-06 10:55:58
42297	9d6cdafb-28be-4658-b2d1-1ca2637cf5d9	9d6cdafb-2bf4-4ce3-ba57-82cd456d6dbc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":143,"memory":20,"hostname":"EderCortes"}	2024-11-06 10:55:59
24156	9d68a8e5-7311-4e90-9633-1241ce3e9873	9d68a8e5-90c5-46e7-8e17-e030b93f65ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 08:52:37
24157	9d68a8e5-8f52-4378-a247-5ce692324e0a	9d68a8e5-90c5-46e7-8e17-e030b93f65ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 08:52:37
24158	9d68a8e5-8fe2-40e8-8bd0-0bca43d35743	9d68a8e5-90c5-46e7-8e17-e030b93f65ed	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:52:37
39681	9d6be1f8-e879-478f-adc9-685981b2f498	9d6be1f9-3709-4d08-b256-361147cf6637	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 23:19:42
39682	9d6be1f9-34e6-4007-8fee-7eee0c174b06	9d6be1f9-3709-4d08-b256-361147cf6637	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 23:19:42
39683	9d6be1f9-35bc-4e27-a396-828ae65aafc4	9d6be1f9-3709-4d08-b256-361147cf6637	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":391,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:19:42
24160	9d68a8e6-21b8-49a9-89c1-681aeef8e259	9d68a8e6-2a15-41cb-abec-b85d9e807508	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 66\\n                        ","time":"153.42","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"f5566f306d2be9466f2c4564ce0020bd","hostname":"EderCortes"}	2024-11-04 08:52:38
24161	9d68a8e6-251a-4201-bee2-f427c1859a42	9d68a8e6-2a15-41cb-abec-b85d9e807508	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '66' order by \\"item_loans\\".\\"id\\" asc","time":"1.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 08:52:38
24162	9d68a8e6-254e-48b5-b344-9cc556381bbf	9d68a8e6-2a15-41cb-abec-b85d9e807508	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":10,"hostname":"EderCortes"}	2024-11-04 08:52:38
24163	9d68a8e6-28dc-4c18-a69a-873906a47003	9d68a8e6-2a15-41cb-abec-b85d9e807508	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 08:52:38
24164	9d68a8e6-292e-4d19-974f-e9724565ee6a	9d68a8e6-2a15-41cb-abec-b85d9e807508	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/66","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":66,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":100465546,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon","loans_direccion":"Calle 750","loans_intereses":25,"loans_cuotas":10,"loans_valor_prestado":5000000,"loans_cuando":"M","loans_observacion":null,"loans_fecha":"03-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-03 00:00:00","loans_pago_prestado":"5000000","loans_pago_interes":"1250000"},"items":[{"id":217,"loans_codigo":66,"itemloans_cuota":"1","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:26.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":218,"loans_codigo":66,"itemloans_cuota":"2","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":219,"loans_codigo":66,"itemloans_cuota":"3","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:31.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":220,"loans_codigo":66,"itemloans_cuota":"4","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-03 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:33.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":221,"loans_codigo":66,"itemloans_cuota":"5","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-04-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:36.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":222,"loans_codigo":66,"itemloans_cuota":"6","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-05-02 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:39.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":223,"loans_codigo":66,"itemloans_cuota":"7","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-06-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:42.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":224,"loans_codigo":66,"itemloans_cuota":"8","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-01 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:46.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":225,"loans_codigo":66,"itemloans_cuota":"9","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-07-31 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:28:50.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"},{"id":226,"loans_codigo":66,"itemloans_cuota":"10","itemloans_valor_cuota":"500000","itemloans_iteres":"125000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-08-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-03T20:50:04.000000Z","updated_at":"2024-11-04T13:31:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"125000","itemloans_cuota_cancelada":"500000"}]}},"duration":339,"memory":22,"hostname":"EderCortes"}	2024-11-04 08:52:38
25976	9d68cc27-769e-4414-9e46-cb7180dbf8d6	9d68cc27-9576-4efe-be25-e99f18a689cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:31:12
25977	9d68cc27-8bf9-4297-b7bf-b642e56cf2c4	9d68cc27-9576-4efe-be25-e99f18a689cd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 90\\n                        ","time":"41.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"93c10371e33ace24260de21c3ff3890d","hostname":"EderCortes"}	2024-11-04 10:31:13
25978	9d68cc27-8fce-4cea-8538-cfb16e1356ee	9d68cc27-9576-4efe-be25-e99f18a689cd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"2.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:31:13
25979	9d68cc27-9004-408b-a789-cf7d397e15de	9d68cc27-9576-4efe-be25-e99f18a689cd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 10:31:13
25980	9d68cc27-93eb-4876-af03-bb7ee880dd4f	9d68cc27-9576-4efe-be25-e99f18a689cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 10:31:13
39684	9d6be1fb-517b-4cf4-990b-2b8a3060ef20	9d6be1fb-9d74-4dbf-b8ae-78e2dd5f37ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 23:19:44
39685	9d6be1fb-976b-40c6-91f7-ee66347e900c	9d6be1fb-9d74-4dbf-b8ae-78e2dd5f37ed	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"151.26","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 23:19:44
39686	9d6be1fb-97b9-4d36-9b51-b64e8835234e	9d6be1fb-9d74-4dbf-b8ae-78e2dd5f37ed	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 23:19:44
25981	9d68cc27-9436-4498-b25e-6f2cfb1b2645	9d68cc27-9576-4efe-be25-e99f18a689cd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"}]}},"duration":400,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:31:13
39687	9d6be1fb-9c16-45b9-9e55-7f1bcfa0057f	9d6be1fb-9d74-4dbf-b8ae-78e2dd5f37ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 23:19:44
39688	9d6be1fb-9c6f-4c13-ae7a-7b9312918ea1	9d6be1fb-9d74-4dbf-b8ae-78e2dd5f37ed	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":421,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:19:44
42298	9d6cdafb-7b32-4eb2-9835-f641130144d7	9d6cdafb-e05b-4e6e-838d-5356fab384c1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:55:59
42299	9d6cdafb-c39d-483a-b368-b2e3b7ea757e	9d6cdafb-e05b-4e6e-838d-5356fab384c1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"149.30","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 10:55:59
42300	9d6cdafb-c40f-43fc-b740-eca7f20cc206	9d6cdafb-e05b-4e6e-838d-5356fab384c1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:55:59
42301	9d6cdafb-dedc-428a-bff7-e640b4214461	9d6cdafb-e05b-4e6e-838d-5356fab384c1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:55:59
42302	9d6cdafb-df34-45d6-b1bf-af15d8458a84	9d6cdafb-e05b-4e6e-838d-5356fab384c1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"80","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":407,"memory":24,"hostname":"EderCortes"}	2024-11-06 10:55:59
42303	9d6cdafc-285a-47fe-967c-768712c88f25	9d6cdafc-8bae-448f-93cf-75c456125d47	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:55:59
42304	9d6cdafc-6ef8-4c14-9fb4-536923bd1879	9d6cdafc-8bae-448f-93cf-75c456125d47	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"146.80","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 10:56:00
42305	9d6cdafc-6f61-4c6c-a78b-b21313463940	9d6cdafc-8bae-448f-93cf-75c456125d47	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:56:00
42306	9d6cdafc-89e5-4d6d-94d5-f2887032099a	9d6cdafc-8bae-448f-93cf-75c456125d47	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:56:00
42307	9d6cdafc-8a5f-4776-a961-64cb21e17b66	9d6cdafc-8bae-448f-93cf-75c456125d47	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"80","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":419,"memory":24,"hostname":"EderCortes"}	2024-11-06 10:56:00
42308	9d6cdafc-fa09-4f9e-88b7-d5e4c96c0ff8	9d6cdafd-5d03-4407-bc75-3770335b105b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:56:00
42309	9d6cdafd-4350-40d4-9e80-3ddd53ba305f	9d6cdafd-5d03-4407-bc75-3770335b105b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"151.23","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 10:56:00
42310	9d6cdafd-43a6-402f-b7a0-ec0f70a8422c	9d6cdafd-5d03-4407-bc75-3770335b105b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:56:00
42311	9d6cdafd-5b7d-4720-b104-dbdf8a09f440	9d6cdafd-5d03-4407-bc75-3770335b105b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:56:00
42312	9d6cdafd-5bdf-40d2-ad5a-196470cf712b	9d6cdafd-5d03-4407-bc75-3770335b105b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"80","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":506,"memory":24,"hostname":"EderCortes"}	2024-11-06 10:56:00
43434	9d6cea00-0980-4084-a6dc-b8701858f1cd	9d6cea00-4fb8-4fc5-88c7-e2d97839fa9f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:37:59
43435	9d6cea00-4e2d-4bc1-b1d2-f3edfb3b8430	9d6cea00-4fb8-4fc5-88c7-e2d97839fa9f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:37:59
42313	9d6cdafd-d6ed-45dd-9da5-d00b2de4159f	9d6cdafe-1edf-4675-92a1-ac7d86e18e53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:56:00
42314	9d6cdafe-047b-4333-afa0-e3fac6e6fc14	9d6cdafe-1edf-4675-92a1-ac7d86e18e53	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"48.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 10:56:01
42315	9d6cdafe-04e3-402d-993c-90e1e813abff	9d6cdafe-1edf-4675-92a1-ac7d86e18e53	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:56:01
42316	9d6cdafe-1d87-4d72-b141-87236531a5ef	9d6cdafe-1edf-4675-92a1-ac7d86e18e53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:56:01
42317	9d6cdafe-1dd9-4c64-9037-df4b84a043e6	9d6cdafe-1edf-4675-92a1-ac7d86e18e53	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"80","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":482,"memory":24,"hostname":"EderCortes"}	2024-11-06 10:56:01
43436	9d6cea00-4ec3-450e-b17c-14d49acb93db	9d6cea00-4fb8-4fc5-88c7-e2d97839fa9f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":377,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:37:59
42318	9d6cdb08-da1a-43f7-98c7-b66bb7c0b80b	9d6cdb08-dea0-4a19-87b1-9e527e67293f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":184,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:56:08
43367	9d6ce601-92be-4d3e-b3df-8e55ce8007c3	9d6ce601-acbe-43b1-86ad-8a48ad6f352e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:26:48
39764	9d6cb503-61be-4bb0-8c2b-56815df6548a	9d6cb503-a8b4-47f7-a32e-2b89d7f20717	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:09:49
39765	9d6cb503-a6f9-41f9-b59c-107ba1ae3318	9d6cb503-a8b4-47f7-a32e-2b89d7f20717	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:09:49
39766	9d6cb503-a78f-4cfa-9a07-9d6abe08cfa5	9d6cb503-a8b4-47f7-a32e-2b89d7f20717	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":342,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:09:49
43368	9d6ce601-ab35-4ca0-a989-0aeb89c23731	9d6ce601-acbe-43b1-86ad-8a48ad6f352e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:26:48
43369	9d6ce601-abce-49e8-8fbb-c03067034c67	9d6ce601-acbe-43b1-86ad-8a48ad6f352e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:26:48
39767	9d6cb504-594d-4dfe-b079-1f2ce1e9e78d	9d6cb504-771b-45e5-9a79-d542a6080ed2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:09:49
39768	9d6cb504-716f-410e-95ce-04f0b2500c76	9d6cb504-771b-45e5-9a79-d542a6080ed2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:09:49
39769	9d6cb504-71d4-4346-a2cb-b2b16134ea4a	9d6cb504-771b-45e5-9a79-d542a6080ed2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:09:49
39770	9d6cb504-75de-4cc4-b2f5-8908447ba744	9d6cb504-771b-45e5-9a79-d542a6080ed2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:09:49
39771	9d6cb504-7627-45a3-b35b-703a0d073b46	9d6cb504-771b-45e5-9a79-d542a6080ed2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:09:49
42319	9d6cdb09-36e7-4453-bf8d-76724e916baa	9d6cdb09-6f79-4e8b-9748-c06342acf43b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:56:08
42320	9d6cdb09-54b9-468d-ad49-cc2d83b936af	9d6cdb09-6f79-4e8b-9748-c06342acf43b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"41.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 10:56:08
42321	9d6cdb09-5515-46f2-85fc-db9b272f4e48	9d6cdb09-6f79-4e8b-9748-c06342acf43b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:56:08
42322	9d6cdb09-6e02-4a4e-8e5a-51db91f12520	9d6cdb09-6f79-4e8b-9748-c06342acf43b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:56:08
42323	9d6cdb09-6e4f-4f78-824b-f4e95483f18a	9d6cdb09-6f79-4e8b-9748-c06342acf43b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"83","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":306,"memory":24,"hostname":"EderCortes"}	2024-11-06 10:56:08
43370	9d6ce602-01f5-46ba-96e9-44dae72b7084	9d6ce602-1b78-46f5-aa34-84635da62a15	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:26:49
43371	9d6ce602-169e-41cd-af1a-aa6b3cff50cd	9d6ce602-1b78-46f5-aa34-84635da62a15	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT id,\\n                            name,\\n                            profile_code,\\n                            remember_token,\\n                            user_address,\\n                            user_age,\\n                            user_alias,\\n                            user_birth,\\n                            user_cellphone,\\n                            user_city,\\n                            user_document,\\n                            user_document_type,\\n                            user_last_name_one,\\n                            user_last_name_two,\\n                            user_neighborhood\\n                        FROM users\\n                        WHERE profile_code = 4;\\n                            ","time":"40.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":142,"hash":"e2980c10c70608ca75f9c2180abc54e1","hostname":"EderCortes"}	2024-11-06 11:26:49
43372	9d6ce602-1a53-4a2c-9518-76e77583c742	9d6ce602-1b78-46f5-aa34-84635da62a15	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:26:49
43373	9d6ce602-1a99-4562-a47c-71b45e5b94cd	9d6ce602-1b78-46f5-aa34-84635da62a15	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/showCobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@showCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":14,"name":"Luis andre","profile_code":4,"remember_token":null,"user_address":"Calle 750","user_age":"31","user_alias":"luis_martinez","user_birth":"1992-11-12T04:00:00.000Z","user_cellphone":"312596295","user_city":"Cali","user_document":"100465545","user_document_type":"CC","user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_neighborhood":"Bonilla aragon"}},"duration":214,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:26:49
42324	9d6cdba7-5acf-4e00-92c2-50224bd25a04	9d6cdba7-5df5-4fe9-969a-3a961d6f2198	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":147,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:57:52
43374	9d6ce603-b8b2-411b-875c-86ea631fb356	9d6ce604-0385-4fe0-8eba-f79e681d8270	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:26:50
43375	9d6ce603-fe8b-40b1-b68d-35e6262e4bfa	9d6ce604-0385-4fe0-8eba-f79e681d8270	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"158.90","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:26:50
43376	9d6ce603-fed3-4a72-8227-a7e94a317797	9d6ce604-0385-4fe0-8eba-f79e681d8270	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:26:50
43377	9d6ce604-0243-475f-a653-9c444a2af58a	9d6ce604-0385-4fe0-8eba-f79e681d8270	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:26:50
43378	9d6ce604-0286-49ce-aeff-40531136a7d2	9d6ce604-0385-4fe0-8eba-f79e681d8270	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":471,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:26:50
42325	9d6cdba7-c492-4861-9863-3902d13cb4a0	9d6cdba8-2b5d-4c95-a89f-c56a8af7f731	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:57:52
42326	9d6cdba8-10db-4549-a445-9f8916e19613	9d6cdba8-2b5d-4c95-a89f-c56a8af7f731	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"144.33","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 10:57:52
42327	9d6cdba8-1157-44a3-9358-6f1d5be8b14d	9d6cdba8-2b5d-4c95-a89f-c56a8af7f731	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:57:52
42328	9d6cdba8-29c8-4135-b2ca-5f3f46bd672b	9d6cdba8-2b5d-4c95-a89f-c56a8af7f731	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:57:52
42329	9d6cdba8-2a23-4e7d-aadf-bc9a48ffa599	9d6cdba8-2b5d-4c95-a89f-c56a8af7f731	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"83","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":420,"memory":24,"hostname":"EderCortes"}	2024-11-06 10:57:52
43379	9d6ce604-5560-4c09-9d69-643c4b269dbe	9d6ce604-704d-457c-8b7f-9c79c4dd6a29	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:26:50
43380	9d6ce604-6be0-4cb9-abe2-8b87a2962031	9d6ce604-704d-457c-8b7f-9c79c4dd6a29	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"45.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:26:50
43381	9d6ce604-6ee0-457e-b8ae-c5adac59efeb	9d6ce604-704d-457c-8b7f-9c79c4dd6a29	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:26:50
43382	9d6ce604-6f43-4057-a630-70e5d692f792	9d6ce604-704d-457c-8b7f-9c79c4dd6a29	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:26:50
42330	9d6cdbf3-8b52-4c8f-a6b5-837590c97c09	9d6cdbf3-8ec6-493d-b7f3-639dee586d24	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":355,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:58:42
43190	9d6ce533-328e-4b0e-ab90-6a7e4029fa0a	9d6ce533-3558-4086-84b8-aba48a8d902b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abprofile_prefix\\u00bb\\nLINE 5:                             profile_prefix,\\n                                    ^ (Connection: pgsql, SQL: \\n                     SELECT id,\\n                            name,\\n                            profile_code,\\n                            profile_prefix,\\n                            remember_token,\\n                            user_address,\\n                            user_age,\\n                            user_alias,\\n                            user_birth,\\n                            user_cellphone,\\n                            user_city,\\n                            user_document,\\n                            user_document_type,\\n                            user_last_name_one,\\n                            user_last_name_two,\\n                            user_neighborhood\\n                        FROM users\\n                        WHERE profile_code = 4;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":142},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2000}	2024-11-06 11:24:33
42331	9d6cdbf4-462c-4994-804b-541d39a2dc3f	9d6cdbf4-7b2e-44cc-90e6-2619d8cf04da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:58:42
42332	9d6cdbf4-6213-485c-bff6-32111c3e3b21	9d6cdbf4-7b2e-44cc-90e6-2619d8cf04da	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"41.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 10:58:42
42333	9d6cdbf4-626f-4241-a22e-642cf7f44b95	9d6cdbf4-7b2e-44cc-90e6-2619d8cf04da	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:58:42
42334	9d6cdbf4-79dc-42cb-815b-6ae2d3f47c0c	9d6cdbf4-7b2e-44cc-90e6-2619d8cf04da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:58:42
42335	9d6cdbf4-7a24-41fd-bdc5-008cac0a88e1	9d6cdbf4-7b2e-44cc-90e6-2619d8cf04da	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"81","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":286,"memory":24,"hostname":"EderCortes"}	2024-11-06 10:58:42
42336	9d6cdc4b-8723-4dd1-ace8-b7dc8d4cf4c5	9d6cdc4b-8abc-4ada-bf3c-a5ae695ea157	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":148,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:59:39
39836	9d6cb757-d457-4cd1-8045-5b4cd1015457	9d6cb757-fee4-4159-b522-8a513e595abc	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 09:16:20
39837	9d6cb757-fcb4-435d-b5ae-6831cf50d200	9d6cb757-fee4-4159-b522-8a513e595abc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:16:20
39838	9d6cb757-fda1-4977-9b04-0ff7fb68da38	9d6cb757-fee4-4159-b522-8a513e595abc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":313,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:16:20
42337	9d6cdc4c-42ec-4d34-8aa1-d2ea693bd3d3	9d6cdc4c-845a-4d02-a929-668c21a1333c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:59:40
42338	9d6cdc4c-6952-471e-b75a-718010f1594e	9d6cdc4c-845a-4d02-a929-668c21a1333c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"45.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 10:59:40
42339	9d6cdc4c-69bd-4815-ad5c-c81ce082dc69	9d6cdc4c-845a-4d02-a929-668c21a1333c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:59:40
42340	9d6cdc4c-82ba-454a-a7be-33cf4b94b753	9d6cdc4c-845a-4d02-a929-668c21a1333c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:59:40
42341	9d6cdc4c-8317-4b3c-aa76-27640ef9bc1c	9d6cdc4c-845a-4d02-a929-668c21a1333c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"84","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"The credentials are incorrect"},"duration":327,"memory":24,"hostname":"EderCortes"}	2024-11-06 10:59:40
42342	9d6cdd06-6d11-4151-b0be-3a3f6a1ea76c	9d6cdd06-71e0-4b76-9884-3cf486954c13	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":308,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:01:42
42343	9d6cdd06-f18c-4436-9a2e-43738068555d	9d6cdd07-2ecd-4208-9d09-bea0b1bc382e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 11:01:42
42344	9d6cdd07-143d-46d9-bc4c-f82aa21d66c9	9d6cdd07-2ecd-4208-9d09-bea0b1bc382e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"41.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 11:01:42
42345	9d6cdd07-14a6-4444-8203-1632a243bed2	9d6cdd07-2ecd-4208-9d09-bea0b1bc382e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 11:01:42
42346	9d6cdd07-2d23-4d12-bf17-f4103a1b6072	9d6cdd07-2ecd-4208-9d09-bea0b1bc382e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:01:42
42347	9d6cdd07-2d85-407b-bad6-0c61d5ca9855	9d6cdd07-2ecd-4208-9d09-bea0b1bc382e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"84","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"Las credenciales ingresadas no son correctas."},"duration":314,"memory":24,"hostname":"EderCortes"}	2024-11-06 11:01:42
42348	9d6cdd90-e18e-49cb-97b5-2e197c4a1243	9d6cdd90-e6ef-4850-9204-794db23b96ff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":207,"memory":18,"hostname":"EderCortes"}	2024-11-06 11:03:12
42349	9d6cdd91-7266-4338-b5dc-f0ca271edfc7	9d6cdd91-b206-460c-964f-9cd4bd3e0e32	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 11:03:13
42350	9d6cdd91-9765-4fed-bbef-f85c9071a7c8	9d6cdd91-b206-460c-964f-9cd4bd3e0e32	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"41.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 11:03:13
42351	9d6cdd91-97ce-4833-bb0b-a2f9196661b8	9d6cdd91-b206-460c-964f-9cd4bd3e0e32	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 11:03:13
27759	9d68e957-ba41-49af-a72c-1bcdb31a5806	9d68e957-f445-41de-8d76-a547d1ea228b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 11:52:50
27760	9d68e957-f1ac-482e-a59e-7eda09163e24	9d68e957-f445-41de-8d76-a547d1ea228b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 11:52:50
27761	9d68e957-f2f5-4a56-9509-449a54748b3d	9d68e957-f445-41de-8d76-a547d1ea228b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":620,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:52:50
42352	9d6cdd91-b050-4394-b033-152bb4e9116f	9d6cdd91-b206-460c-964f-9cd4bd3e0e32	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:03:13
42353	9d6cdd91-b0a9-44ff-99fe-1d283bf016ab	9d6cdd91-b206-460c-964f-9cd4bd3e0e32	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","profile":1},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":348,"memory":24,"hostname":"EderCortes"}	2024-11-06 11:03:13
41352	9d6ccc69-4d63-43d2-a339-c8feee6f8681	9d6ccc69-5028-4b3e-b35d-6561f5820445	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1896}	2024-11-06 10:15:14
27762	9d68e958-af95-4e3b-be62-769f33de3e8d	9d68e958-db00-4929-9771-b07aa74d2807	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 11:52:50
27763	9d68e958-d4ee-4861-b7ad-cc5ea5b480e9	9d68e958-db00-4929-9771-b07aa74d2807	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"61.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:52:50
27764	9d68e958-d563-4896-bd2f-18b6e2bcada5	9d68e958-db00-4929-9771-b07aa74d2807	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:52:50
27765	9d68e958-d992-4779-9805-f9cc03a60fce	9d68e958-db00-4929-9771-b07aa74d2807	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 11:52:50
27766	9d68e958-d9f5-4fd0-a1da-bda68884e7ca	9d68e958-db00-4929-9771-b07aa74d2807	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":516,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:52:50
42354	9d6cdd98-aaec-40ae-aab2-9957d9089873	9d6cdd98-ce30-4ab0-95b5-9444b209ed4e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:03:17
42355	9d6cdd98-c798-46f7-8311-b0ce6bb3f3ff	9d6cdd98-ce30-4ab0-95b5-9444b209ed4e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"53.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:03:18
42356	9d6cdd98-c807-4e2e-9dc2-83ec52f5d1f3	9d6cdd98-ce30-4ab0-95b5-9444b209ed4e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:03:18
42357	9d6cdd98-cc5f-455f-a493-ebd0922792df	9d6cdd98-ce30-4ab0-95b5-9444b209ed4e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:03:18
42358	9d6cdd98-cce8-45d4-a4d5-79608d1e71f1	9d6cdd98-ce30-4ab0-95b5-9444b209ed4e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":496,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:03:18
27767	9d68e959-7fb3-445f-a815-598657c3732e	9d68e959-ae7f-45d4-b199-073789fded58	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 11:52:51
27768	9d68e959-a554-4ad7-92e7-cf15483dc346	9d68e959-ae7f-45d4-b199-073789fded58	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"60.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:52:51
27769	9d68e959-a5e0-42c4-b4e3-2e5b98803831	9d68e959-ae7f-45d4-b199-073789fded58	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 11:52:51
27770	9d68e959-ac85-468f-858f-a468ac798965	9d68e959-ae7f-45d4-b199-073789fded58	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 11:52:51
27771	9d68e959-ad0d-4ce0-9580-baae0496c0c5	9d68e959-ae7f-45d4-b199-073789fded58	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":520,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:52:51
42359	9d6cdd99-0f6b-4dc6-b2e5-7399691564c1	9d6cdd99-52d4-4703-a59a-ac8dff817967	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:03:18
42360	9d6cdd99-4d42-47d2-8875-770d0b97e8e7	9d6cdd99-52d4-4703-a59a-ac8dff817967	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"143.41","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:03:18
42361	9d6cdd99-5131-422e-8f69-5687bc5c7081	9d6cdd99-52d4-4703-a59a-ac8dff817967	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:03:18
42362	9d6cdd99-518f-44d8-af62-5acfb247594a	9d6cdd99-52d4-4703-a59a-ac8dff817967	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":324,"memory":20,"hostname":"EderCortes"}	2024-11-06 11:03:18
27772	9d68e95a-2c62-4420-ac64-e88ee7756913	9d68e95a-4c3a-4aac-8ef3-1ba9725f0e39	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 11:52:51
27773	9d68e95a-4523-4ce4-a5b1-79bc9a68944b	9d68e95a-4c3a-4aac-8ef3-1ba9725f0e39	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '90' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"42.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 11:52:51
27774	9d68e95a-4576-4668-b2bf-42010b711036	9d68e95a-4c3a-4aac-8ef3-1ba9725f0e39	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 11:52:51
27775	9d68e95a-4719-414b-82f3-5d838aa93e8a	9d68e95a-4c3a-4aac-8ef3-1ba9725f0e39	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"2.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:52:51
27776	9d68e95a-4752-4ab1-a8b1-b811ceee8cfa	9d68e95a-4c3a-4aac-8ef3-1ba9725f0e39	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 11:52:51
27777	9d68e95a-4b20-4928-8e4f-3820e4d7793e	9d68e95a-4c3a-4aac-8ef3-1ba9725f0e39	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-04 11:52:51
27778	9d68e95a-4b70-475e-bb32-e67ca8835804	9d68e95a-4c3a-4aac-8ef3-1ba9725f0e39	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"275000","loans_pago_prestado":"1100000","loans_intereses_recaudar":"275000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"}]}},"duration":381,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:52:51
27779	9d68e95b-0803-48f5-ba88-dfa04a77a143	9d68e95b-bb68-4a70-868f-fd57b5849e78	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-04 11:52:52
27780	9d68e95b-b0f0-4294-9ebd-f5204f19347e	9d68e95b-bb68-4a70-868f-fd57b5849e78	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"180.27","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:52:52
27781	9d68e95b-b18b-40f6-a1d8-933fde1b9a07	9d68e95b-bb68-4a70-868f-fd57b5849e78	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:52:52
27782	9d68e95b-b942-40f7-af7a-ddccd691dd03	9d68e95b-bb68-4a70-868f-fd57b5849e78	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-04 11:52:52
27783	9d68e95b-b9c6-4ec3-887b-84185ee30643	9d68e95b-bb68-4a70-868f-fd57b5849e78	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":918,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:52:52
27784	9d68e95c-7734-4be5-8ba5-e880839d0305	9d68e95c-c62b-4d25-97cb-50a8363798e6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-04 11:52:53
27785	9d68e95c-c0a9-4e8f-a9bb-b353bc35c7fd	9d68e95c-c62b-4d25-97cb-50a8363798e6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"154.72","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:52:53
27786	9d68e95c-c101-48f7-9855-d082ba081399	9d68e95c-c62b-4d25-97cb-50a8363798e6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:52:53
27787	9d68e95c-c4a1-41e2-8ed5-80437fff9648	9d68e95c-c62b-4d25-97cb-50a8363798e6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-04 11:52:53
27788	9d68e95c-c4fd-4471-bca4-8e2e19bb6648	9d68e95c-c62b-4d25-97cb-50a8363798e6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":658,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:52:53
43216	9d6ce59c-71de-45aa-a6c1-390b0ac494bd	9d6ce59c-d34e-47d2-9efe-a60c4a8e055c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 11:25:42
43217	9d6ce59c-cff2-423a-b31d-e732efd67ec5	9d6ce59c-d34e-47d2-9efe-a60c4a8e055c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:25:42
43218	9d6ce59c-d187-4b41-9d11-778410e02e15	9d6ce59c-d34e-47d2-9efe-a60c4a8e055c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":555,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:25:42
27789	9d68e962-2f09-48b2-807d-55e9af38a641	9d68e962-4bbb-44e9-a725-d9e95a0c6e46	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-04 11:52:56
27790	9d68e962-4732-49d6-bf2a-8a6ca5a12020	9d68e962-4bbb-44e9-a725-d9e95a0c6e46	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"46.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 11:52:56
27791	9d68e962-49ff-436a-8ec5-5f956bf8c8c4	9d68e962-4bbb-44e9-a725-d9e95a0c6e46	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-11-04 11:52:56
27792	9d68e962-4a87-4aeb-9b4c-f1d772ba28e5	9d68e962-4bbb-44e9-a725-d9e95a0c6e46	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":359,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:52:56
27793	9d68e96a-9add-418d-828b-aba3ec9bf6ca	9d68e96a-f31b-4323-83bb-107f4aa73054	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-11-04 11:53:02
27794	9d68e96a-ea11-489b-b47c-d548afa308eb	9d68e96a-f31b-4323-83bb-107f4aa73054	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"167.26","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:53:02
27795	9d68e96a-ea9f-4f12-9174-2437bfdbaecd	9d68e96a-f31b-4323-83bb-107f4aa73054	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:53:02
27796	9d68e96a-f114-471c-b337-181b00739421	9d68e96a-f31b-4323-83bb-107f4aa73054	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-11-04 11:53:02
27797	9d68e96a-f196-4745-8b63-753b16cb85d5	9d68e96a-f31b-4323-83bb-107f4aa73054	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":530,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:53:02
27893	9d68ea3e-8f0d-4231-acb5-c39d9c943fa6	9d68ea3e-ac80-43a3-a0f7-cb00ebe94930	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 11:55:21
27894	9d68ea3e-aae7-4634-8873-9f2f88d8e3ec	9d68ea3e-ac80-43a3-a0f7-cb00ebe94930	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 11:55:21
27895	9d68ea3e-ab85-45e4-b5ce-065495a859a3	9d68ea3e-ac80-43a3-a0f7-cb00ebe94930	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":366,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:55:21
27798	9d68e96b-69ec-496d-bde6-41ec418808bf	9d68e96b-8bde-4eeb-844f-616834514059	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-11-04 11:53:02
27799	9d68e96b-85db-4a42-8871-3754e09e9629	9d68e96b-8bde-4eeb-844f-616834514059	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:53:02
27800	9d68e96b-8640-4325-aae2-803b8c2c86bf	9d68e96b-8bde-4eeb-844f-616834514059	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 11:53:02
27801	9d68e96b-8a56-473f-9113-61c483388e0b	9d68e96b-8bde-4eeb-844f-616834514059	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-11-04 11:53:02
27802	9d68e96b-8abc-4a33-9950-fbd092636d49	9d68e96b-8bde-4eeb-844f-616834514059	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":366,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:53:02
27896	9d68ea3f-3051-4385-b976-13f5f72e984f	9d68ea3f-780e-4f6e-a513-2f00f8d4a90e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 11:55:21
27897	9d68ea3f-6ee2-4678-b6bd-c5a7c8dcb905	9d68ea3f-780e-4f6e-a513-2f00f8d4a90e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"147.63","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:55:21
27898	9d68ea3f-722b-4437-8ca2-d572132b724a	9d68ea3f-780e-4f6e-a513-2f00f8d4a90e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:55:21
27899	9d68ea3f-7261-4814-8494-47a896ce6000	9d68ea3f-780e-4f6e-a513-2f00f8d4a90e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:55:21
27900	9d68ea3f-76bb-449d-8f30-00df78628038	9d68ea3f-780e-4f6e-a513-2f00f8d4a90e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 11:55:21
27901	9d68ea3f-771b-45a9-a4d0-2ea6f22c8265	9d68ea3f-780e-4f6e-a513-2f00f8d4a90e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":462,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:55:21
27803	9d68e96b-fd5f-45fe-880a-56aa5c57979f	9d68e96c-45ee-4161-8a63-cb876c634c0c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-11-04 11:53:03
27804	9d68e96c-3e6a-44b0-a0ab-fedf9f0df204	9d68e96c-45ee-4161-8a63-cb876c634c0c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '81' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"149.58","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 11:53:03
27805	9d68e96c-3ebe-4e48-a782-484dc2724a05	9d68e96c-45ee-4161-8a63-cb876c634c0c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 11:53:03
27806	9d68e96c-4072-4295-970e-6b11b5e84104	9d68e96c-45ee-4161-8a63-cb876c634c0c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '81' order by \\"item_loans\\".\\"id\\" asc","time":"2.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:53:03
27807	9d68e96c-40a8-4c3d-bf18-8ec3b4277ca6	9d68e96c-45ee-4161-8a63-cb876c634c0c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 11:53:03
27808	9d68e96c-4460-4e05-86a2-900a835016dc	9d68e96c-45ee-4161-8a63-cb876c634c0c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-11-04 11:53:03
27809	9d68e96c-44bd-44e3-8533-3f5ca2d391dd	9d68e96c-45ee-4161-8a63-cb876c634c0c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/81","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":81,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"0","loans_pago_prestado":"0","loans_intereses_recaudar":"275000"},"items":[{"id":311,"loans_codigo":81,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":312,"loans_codigo":81,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":313,"loans_codigo":81,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":314,"loans_codigo":81,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":315,"loans_codigo":81,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":463,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:53:03
28129	9d68fe63-2063-4260-a9ab-62800b3d0766	9d68fe67-3709-4a0a-8e45-9f0407712bce	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 12:51:41
28130	9d68fe66-ea75-43a8-b904-6f549bf88324	9d68fe67-3709-4a0a-8e45-9f0407712bce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 12:51:43
28131	9d68fe67-0b87-4fdc-8b36-f331dc1c103e	9d68fe67-3709-4a0a-8e45-9f0407712bce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":18977,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:51:43
28132	9d68fe67-f26b-4e2c-8059-a5a8644e2dae	9d68fe69-7a3e-48ba-aa4c-e9c1ed29cbeb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 12:51:43
28133	9d68fe68-a0ac-4847-9f38-3dc6954d30d1	9d68fe69-7a3e-48ba-aa4c-e9c1ed29cbeb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"53.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 12:51:44
28134	9d68fe68-a122-4301-a3f9-198be9c1af96	9d68fe69-7a3e-48ba-aa4c-e9c1ed29cbeb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 12:51:44
28135	9d68fe69-790b-4d64-9a87-cacbb09c44a0	9d68fe69-7a3e-48ba-aa4c-e9c1ed29cbeb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 12:51:44
28136	9d68fe69-7959-48b6-bd7d-cfcad4a54b22	9d68fe69-7a3e-48ba-aa4c-e9c1ed29cbeb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":1356,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:51:44
28137	9d68fe69-eef2-4fe4-a725-eb01574e7484	9d68fe6a-0e4e-4fd5-942c-90145faa5ad2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 12:51:45
28138	9d68fe6a-08bc-419d-854c-79f260430719	9d68fe6a-0e4e-4fd5-942c-90145faa5ad2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 12:51:45
28139	9d68fe6a-0910-42ea-ba71-daa4e8176ffd	9d68fe6a-0e4e-4fd5-942c-90145faa5ad2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 12:51:45
28140	9d68fe6a-0cf3-49ae-ba7f-a96da80f0e09	9d68fe6a-0e4e-4fd5-942c-90145faa5ad2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 12:51:45
28141	9d68fe6a-0d4c-461f-8705-8fa25f1c97f0	9d68fe6a-0e4e-4fd5-942c-90145faa5ad2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":365,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:51:45
28142	9d68fe6a-7d6f-4e4b-b7f7-a2e80ce064a7	9d68fe6a-af36-49e2-9bae-54ed9fae7fe1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 12:51:45
28143	9d68fe6a-9f14-44e6-86bf-b305e4d658ba	9d68fe6a-af36-49e2-9bae-54ed9fae7fe1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '81' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"41.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 12:51:45
28144	9d68fe6a-9f71-4b66-a211-daa19d7d8897	9d68fe6a-af36-49e2-9bae-54ed9fae7fe1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 12:51:45
28145	9d68fe6a-aa94-4eed-88ab-977e3c067e08	9d68fe6a-af36-49e2-9bae-54ed9fae7fe1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '81' order by \\"item_loans\\".\\"id\\" asc","time":"1.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 12:51:45
28146	9d68fe6a-aace-469d-b09b-9412725f7d4c	9d68fe6a-af36-49e2-9bae-54ed9fae7fe1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 12:51:45
28147	9d68fe6a-ae13-4550-b1df-918f4fa95966	9d68fe6a-af36-49e2-9bae-54ed9fae7fe1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 12:51:45
28148	9d68fe6a-ae5c-4086-8e58-fd0fece5de07	9d68fe6a-af36-49e2-9bae-54ed9fae7fe1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/81","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":81,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"0","loans_pago_prestado":"0","loans_intereses_recaudar":"275000"},"items":[{"id":311,"loans_codigo":81,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":312,"loans_codigo":81,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":313,"loans_codigo":81,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":314,"loans_codigo":81,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":315,"loans_codigo":81,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":392,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:51:45
19694	9d66e408-f5af-4d30-ae02-3f688ea4193a	9d66e408-f8fd-4c33-a34a-a739f002a5dc	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":970}	2024-11-03 11:46:20
30240	9d69379e-d6b4-4bdf-9eaf-2055d76f4b60	9d69379e-fb84-48a2-9006-6411991069d3	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 15:31:42
30241	9d69379e-f978-4579-bf5f-7e2adc29d035	9d69379e-fb84-48a2-9006-6411991069d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:31:42
30242	9d69379e-fa55-4b37-a255-a31e7cc708e1	9d69379e-fb84-48a2-9006-6411991069d3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:31:42
30243	9d69379f-6f34-493f-9f8f-c4cb3f4349ad	9d69379f-b720-47fe-ac07-754f40f418af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:31:43
26342	9d68d312-7058-4c07-8bd9-8915a39b968f	9d68d312-a8fb-4bb8-9fc1-3415b7d9d5cb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:50:33
26343	9d68d312-a4a6-43ce-ad0c-cf7c9c61a495	9d68d312-a8fb-4bb8-9fc1-3415b7d9d5cb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:50:33
26344	9d68d312-a634-4b6c-89ad-e7a097301ef8	9d68d312-a8fb-4bb8-9fc1-3415b7d9d5cb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":668,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:50:33
30244	9d69379f-ad14-4b64-a60a-61299983a736	9d69379f-b720-47fe-ac07-754f40f418af	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"144.79","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 15:31:43
30245	9d69379f-b112-479e-b9af-da34f83a341d	9d69379f-b720-47fe-ac07-754f40f418af	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 15:31:43
30246	9d69379f-b14b-4362-af42-7ea5b8a76a2b	9d69379f-b720-47fe-ac07-754f40f418af	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 15:31:43
30247	9d69379f-b5d0-44db-b687-fc26c0aaa06b	9d69379f-b720-47fe-ac07-754f40f418af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 15:31:43
30248	9d69379f-b631-4c56-bd0c-4826684826a6	9d69379f-b720-47fe-ac07-754f40f418af	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":383,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:31:43
26345	9d68d313-58db-456a-9fa5-3eebb4e74179	9d68d313-b52d-4271-9fb9-dc7fb03b5b2e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:50:34
26346	9d68d313-a436-4234-a20a-c87881756aaf	9d68d313-b52d-4271-9fb9-dc7fb03b5b2e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"172.40","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:50:34
26347	9d68d313-aab7-46fa-be7c-99511c1e1802	9d68d313-b52d-4271-9fb9-dc7fb03b5b2e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:50:34
26348	9d68d313-ab15-4358-9dbe-d82a4506c960	9d68d313-b52d-4271-9fb9-dc7fb03b5b2e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:50:34
26349	9d68d313-b357-4a3d-b08b-fcc89a4563c8	9d68d313-b52d-4271-9fb9-dc7fb03b5b2e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:50:34
26350	9d68d313-b3de-42a0-acac-9704988ec935	9d68d313-b52d-4271-9fb9-dc7fb03b5b2e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":600,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:50:34
26351	9d68d31a-3e93-47c0-b2b0-7fed15859dba	9d68d31a-813a-4ee7-818b-60a9b6a13387	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:50:38
26352	9d68d31a-72a6-4434-bb51-dea880791d9f	9d68d31a-813a-4ee7-818b-60a9b6a13387	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"83.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:50:38
26353	9d68d31a-7336-489b-b562-ae9d6413a999	9d68d31a-813a-4ee7-818b-60a9b6a13387	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:50:38
26354	9d68d31a-7df8-440d-8793-fb2d979db2ad	9d68d31a-813a-4ee7-818b-60a9b6a13387	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:50:38
26355	9d68d31a-7ec3-49de-ba3c-d8b968ec2c50	9d68d31a-813a-4ee7-818b-60a9b6a13387	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":660,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:50:38
26356	9d68d31b-421a-45ff-9536-5736e920e039	9d68d31b-757e-48a5-90ff-9cb15d79e776	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:50:39
26357	9d68d31b-6a93-4a0a-868b-c26242969452	9d68d31b-757e-48a5-90ff-9cb15d79e776	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"67.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:50:39
26358	9d68d31b-6b1c-43d6-896d-a183b801cd22	9d68d31b-757e-48a5-90ff-9cb15d79e776	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:50:39
26359	9d68d31b-72ea-4476-ba39-26f106550692	9d68d31b-757e-48a5-90ff-9cb15d79e776	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:50:39
26360	9d68d31b-73a8-45ae-8298-4dd41ecbbdbe	9d68d31b-757e-48a5-90ff-9cb15d79e776	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":594,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:50:39
30470	9d693fa9-d191-4bf2-acea-1ed2f31f851b	9d693fa9-f4b1-44b8-a042-9c5754f85d11	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 15:54:12
30471	9d693fa9-f2e7-4ddd-8050-747d4cc80858	9d693fa9-f4b1-44b8-a042-9c5754f85d11	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 15:54:12
30472	9d693fa9-f3b0-484b-91c4-d6816ec3822f	9d693fa9-f4b1-44b8-a042-9c5754f85d11	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:54:12
30473	9d693faa-4ae8-49b1-b95e-9b4ebfb3bc85	9d693faa-690f-4686-9a99-cacaf4e8f51d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 15:54:12
30474	9d693faa-6345-49a3-80ca-080cb2da1452	9d693faa-690f-4686-9a99-cacaf4e8f51d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"39.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":58,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 15:54:12
30475	9d693faa-639a-4713-8409-76c1b45b0a21	9d693faa-690f-4686-9a99-cacaf4e8f51d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 15:54:12
30476	9d693faa-67ea-410f-a0ad-a1123cc5622b	9d693faa-690f-4686-9a99-cacaf4e8f51d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 15:54:12
30477	9d693faa-682f-47ca-ab73-a8b4c4003160	9d693faa-690f-4686-9a99-cacaf4e8f51d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:47:38.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":242,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:54:12
28375	9d6900f1-3528-42ac-a29d-5592113a86c9	9d6900f1-52b3-4e54-b159-6263b038d242	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 12:58:49
28376	9d6900f1-5115-47e6-ad6c-41df8a32e320	9d6900f1-52b3-4e54-b159-6263b038d242	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 12:58:49
28377	9d6900f1-51b5-4d18-a577-6b9fcb48ae2f	9d6900f1-52b3-4e54-b159-6263b038d242	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:58:49
28378	9d6900f1-d906-45df-9bc0-0f44138d6ae4	9d6900f1-f850-4d76-b265-c4c3328ed18d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 12:58:49
28379	9d6900f1-f2c9-4d8a-be3e-21cc6bd0bd1c	9d6900f1-f850-4d76-b265-c4c3328ed18d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 12:58:49
28380	9d6900f1-f31d-4252-907b-b0c67db75c7e	9d6900f1-f850-4d76-b265-c4c3328ed18d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 12:58:49
28381	9d6900f1-f6b1-48fb-aa22-cb90c2f99a7a	9d6900f1-f850-4d76-b265-c4c3328ed18d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 12:58:49
28382	9d6900f1-f715-4cf3-a0a0-b8167e1464c2	9d6900f1-f850-4d76-b265-c4c3328ed18d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":370,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:58:49
28383	9d6900f2-705c-4ee9-b16b-eb31bf79b543	9d6900f2-8da0-4d05-af81-ed8478f36e49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 12:58:50
28384	9d6900f2-887e-4be8-ac31-8ec2bdbfaaa2	9d6900f2-8da0-4d05-af81-ed8478f36e49	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"38.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 12:58:50
28385	9d6900f2-88d0-4990-9c82-bac104cc8f39	9d6900f2-8da0-4d05-af81-ed8478f36e49	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 12:58:50
28386	9d6900f2-8c4b-46d6-9070-b84dd10c3740	9d6900f2-8da0-4d05-af81-ed8478f36e49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 12:58:50
28387	9d6900f2-8c92-4d45-9f69-a34e72a5e163	9d6900f2-8da0-4d05-af81-ed8478f36e49	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":362,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:58:50
34687	9d69bf48-4e43-4e5a-8087-432b0261ac4b	9d69bf48-6ce1-4c67-a034-8ae9950e50b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 21:51:03
34688	9d69bf48-6b43-44d7-a856-efbe4caa647f	9d69bf48-6ce1-4c67-a034-8ae9950e50b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 21:51:03
34689	9d69bf48-6bee-4dce-a1ee-e7fe97dc9ca5	9d69bf48-6ce1-4c67-a034-8ae9950e50b2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":262,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:51:03
28388	9d6900f3-04c7-409d-8901-54055b657d05	9d6900f3-4e17-4a5b-ac39-4c37c51b84a8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 12:58:50
28389	9d6900f3-47a3-463d-941e-4df99a591229	9d6900f3-4e17-4a5b-ac39-4c37c51b84a8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '81' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"152.94","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 12:58:50
28390	9d6900f3-47f4-49e6-a3df-a5bc1d8d8e4d	9d6900f3-4e17-4a5b-ac39-4c37c51b84a8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 12:58:50
28391	9d6900f3-4960-473a-a9be-676e08b7fc40	9d6900f3-4e17-4a5b-ac39-4c37c51b84a8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '81' order by \\"item_loans\\".\\"id\\" asc","time":"1.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 12:58:50
28392	9d6900f3-4995-46ba-8a36-d564acabf885	9d6900f3-4e17-4a5b-ac39-4c37c51b84a8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 12:58:50
28393	9d6900f3-4cbd-4b99-b147-83591f50bfa1	9d6900f3-4e17-4a5b-ac39-4c37c51b84a8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 12:58:50
28394	9d6900f3-4d08-42b5-9d60-251e47c93e2e	9d6900f3-4e17-4a5b-ac39-4c37c51b84a8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/81","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":81,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"0","loans_pago_prestado":"0","loans_intereses_recaudar":"275000"},"items":[{"id":311,"loans_codigo":81,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":312,"loans_codigo":81,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":313,"loans_codigo":81,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":314,"loans_codigo":81,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":315,"loans_codigo":81,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":479,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:58:50
34690	9d69bf48-c5ad-4da7-9634-36d471a66040	9d69bf48-e60e-4d44-916d-fa9e4d70037d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 21:51:03
34691	9d69bf48-df53-417a-9f59-cd05119c131a	9d69bf48-e60e-4d44-916d-fa9e4d70037d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":256,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:51:03
34692	9d69bf48-dfb7-483c-8207-195262e4ff21	9d69bf48-e60e-4d44-916d-fa9e4d70037d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:51:03
34693	9d69bf48-e4a2-4e95-9e8c-88915dd8d611	9d69bf48-e60e-4d44-916d-fa9e4d70037d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 21:51:03
34694	9d69bf48-e500-4b7c-853b-073ac1c9efcf	9d69bf48-e60e-4d44-916d-fa9e4d70037d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:51:03
33216	9d69ad61-7baf-40bd-823d-ae4d498aa502	9d69ad61-c37e-4f58-8343-fb3770233927	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:00:59
33217	9d69ad61-c1c2-4c89-861b-4008c7f905ca	9d69ad61-c37e-4f58-8343-fb3770233927	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:00:59
33218	9d69ad61-c27f-47ec-a48b-8499e615689b	9d69ad61-c37e-4f58-8343-fb3770233927	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:00:59
639	9d4f2d8d-7e1a-4f99-85e7-a784898adf4b	9d4f2d8d-819e-420e-863c-321f2d943e02	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":46}	2024-10-22 16:52:02
32668	9d698289-a35b-4b82-bc94-1370039e055a	9d69828d-caa6-428a-bbe9-8abf922dbee2	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 19:01:12
32669	9d69828d-7b20-444a-83e3-c22e67a0fa59	9d69828d-caa6-428a-bbe9-8abf922dbee2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 19:01:14
32670	9d69828d-9d2d-4625-abd8-7c66eb089a1a	9d69828d-caa6-428a-bbe9-8abf922dbee2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":17132,"memory":22,"hostname":"EderCortes"}	2024-11-04 19:01:14
34695	9d69bf49-2f69-493a-aa7a-ee0dad0c60af	9d69bf49-4e81-49f8-a31d-e6abc80746b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 21:51:03
32671	9d69828e-65bb-42a0-a78d-c916d470e9d0	9d69828f-3fe5-4bad-84ef-92787c3ed400	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 19:01:14
32672	9d69828e-7b6e-411d-bcc1-b9d3e90037e2	9d69828f-3fe5-4bad-84ef-92787c3ed400	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 91\\n                        ","time":"41.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"9ae30bc69b6b272f3f51ff48e54319f5","hostname":"EderCortes"}	2024-11-04 19:01:15
32673	9d69828e-7de5-4fd0-91dc-eb68ce14473b	9d69828f-3fe5-4bad-84ef-92787c3ed400	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '91' order by \\"item_loans\\".\\"id\\" asc","time":"2.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 19:01:15
32674	9d69828f-3e75-4d9a-8205-3f9e95ac3cbe	9d69828f-3fe5-4bad-84ef-92787c3ed400	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 19:01:15
32675	9d69828f-3ec5-4442-8c75-b669104e7f2b	9d69828f-3fe5-4bad-84ef-92787c3ed400	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/91","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":91,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":8,"loans_valor_prestado":5000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"800000","loans_pago_interes":"200000","user_alias":"eder.cortes"},"items":[{"id":371,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 17:44:55","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"200000","itemloans_cuota_cancelada":"800000","user_alias":"eder.cortes"},{"id":403,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":404,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":405,"loans_codigo":91,"itemloans_cuota":"3","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":406,"loans_codigo":91,"itemloans_cuota":"4","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":407,"loans_codigo":91,"itemloans_cuota":"5","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":408,"loans_codigo":91,"itemloans_cuota":"6","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":409,"loans_codigo":91,"itemloans_cuota":"7","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":410,"loans_codigo":91,"itemloans_cuota":"8","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-03-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":785,"memory":22,"hostname":"EderCortes"}	2024-11-04 19:01:15
33219	9d69ad62-20cb-4427-a307-52f9236f3820	9d69ad62-3ed4-4ac6-9d0f-bc1b52caf6ab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:01:00
33220	9d69ad62-3751-4f04-9401-763ac04abb5b	9d69ad62-3ed4-4ac6-9d0f-bc1b52caf6ab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 87\\n                        ","time":"43.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"309a6eff5ebe9f2d91248732844dd9ed","hostname":"EderCortes"}	2024-11-04 21:01:00
33221	9d69ad62-3a30-426b-8a80-dcf8929e3a93	9d69ad62-3ed4-4ac6-9d0f-bc1b52caf6ab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '87' order by \\"item_loans\\".\\"id\\" asc","time":"2.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:01:00
33222	9d69ad62-3db4-44a5-bc12-332544f51dfc	9d69ad62-3ed4-4ac6-9d0f-bc1b52caf6ab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:01:00
34696	9d69bf49-4919-4697-a0dc-ffc070769cd5	9d69bf49-4e81-49f8-a31d-e6abc80746b0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":245,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 21:51:03
34697	9d69bf49-4970-4588-afa2-5c081e7dcdaa	9d69bf49-4e81-49f8-a31d-e6abc80746b0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 21:51:03
33223	9d69ad62-3e02-4dc2-8ad6-c2e1a2bfae66	9d69ad62-3ed4-4ac6-9d0f-bc1b52caf6ab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/87","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":87,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"220000","loans_pago_interes":"55000","user_alias":"eder.cortes"},"items":[{"id":341,"loans_codigo":87,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 20:50:52","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000","user_alias":"eder.cortes"},{"id":342,"loans_codigo":87,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":343,"loans_codigo":87,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":344,"loans_codigo":87,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":345,"loans_codigo":87,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":257,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:01:00
34698	9d69bf49-4d45-4b8e-9987-aa0e353dd8e7	9d69bf49-4e81-49f8-a31d-e6abc80746b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 21:51:03
34699	9d69bf49-4d96-4da9-abe8-16c1663c27e7	9d69bf49-4e81-49f8-a31d-e6abc80746b0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:51:03
33224	9d69ad63-b886-404b-b4cb-983d7355ce41	9d69ad63-d783-40ce-8b97-819a3267ac4a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:01:01
33225	9d69ad63-d1a4-4de1-908d-e8210b24cf09	9d69ad63-d783-40ce-8b97-819a3267ac4a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:01:01
33226	9d69ad63-d211-423d-957b-26573069c154	9d69ad63-d783-40ce-8b97-819a3267ac4a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:01:01
33227	9d69ad63-d612-4829-ae91-5a66891820d9	9d69ad63-d783-40ce-8b97-819a3267ac4a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:01:01
33228	9d69ad63-d679-4212-b2f5-a3799caf3af3	9d69ad63-d783-40ce-8b97-819a3267ac4a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":471,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:01:01
34700	9d69bf49-941f-4256-b7ff-2b42d400764f	9d69bf49-b15d-4964-8317-a160dbbaef11	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 21:51:03
34701	9d69bf49-abf1-4f11-89d1-fe01906bce4f	9d69bf49-b15d-4964-8317-a160dbbaef11	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:51:04
34702	9d69bf49-ac46-4ce9-865b-814cb11143f2	9d69bf49-b15d-4964-8317-a160dbbaef11	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:51:04
34703	9d69bf49-b033-4fab-81fc-a6b8b50977d2	9d69bf49-b15d-4964-8317-a160dbbaef11	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 21:51:04
34704	9d69bf49-b08b-49f5-b2b6-ccbdd1393b96	9d69bf49-b15d-4964-8317-a160dbbaef11	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:51:04
33229	9d69ad74-8501-4dd3-bd35-280d80409fb2	9d69ad74-88c2-4423-9a83-67d7870cbf99	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":174,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:01:12
34705	9d69bf49-fe58-418a-b510-816426809b90	9d69bf4a-1d3e-4485-8c7a-dde017f305ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 21:51:04
34706	9d69bf4a-15b9-4606-ab8c-b4e33036614d	9d69bf4a-1d3e-4485-8c7a-dde017f305ac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_valor_prestado\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"loans_pago_prestado\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\" from \\"loans\\" where \\"id\\" = '93' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"39.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":232,"hash":"b7bed98e18fbf8ddc68e098c2343cf77","hostname":"EderCortes"}	2024-11-04 21:51:04
34707	9d69bf4a-160a-4c20-a115-86de92f71ceb	9d69bf4a-1d3e-4485-8c7a-dde017f305ac	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 21:51:04
34708	9d69bf4a-1815-45c5-8068-891bf95e08ed	9d69bf4a-1d3e-4485-8c7a-dde017f305ac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"2.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":233,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 21:51:04
34709	9d69bf4a-1858-4f4d-beea-a0f12f2ed13d	9d69bf4a-1d3e-4485-8c7a-dde017f305ac	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 21:51:04
34710	9d69bf4a-1c00-4bae-a2c6-221050b02ecc	9d69bf4a-1d3e-4485-8c7a-dde017f305ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 21:51:04
34711	9d69bf4a-1c50-4124-8916-d9fc8fab932b	9d69bf4a-1d3e-4485-8c7a-dde017f305ac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"user_creador":12,"user_cobrador":22,"loans_pago_prestado":"1000000","user_customer":19,"user_recomendacion":18,"loans_pago_interes":"250000"},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:19:45.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:22:30.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":399,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":400,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":401,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":402,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"}]}},"duration":257,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:51:04
33230	9d69ad74-f4c2-43a5-a44a-49f106c15f90	9d69ad75-2298-479b-8b3a-afa77a0b4938	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:01:12
33231	9d69ad75-1061-469c-a6dc-a3c767996e73	9d69ad75-2298-479b-8b3a-afa77a0b4938	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 87 limit 1","time":"3.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":505,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 21:01:12
33232	9d69ad75-10c7-4206-9e23-8e1625ede46b	9d69ad75-2298-479b-8b3a-afa77a0b4938	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":2,"hostname":"EderCortes"}	2024-11-04 21:01:12
33233	9d69ad75-12ea-48a8-856d-dab29782bbd8	9d69ad75-2298-479b-8b3a-afa77a0b4938	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select count(*) as aggregate from \\"item_loans\\" where \\"loans_codigo\\" = 87 and \\"itemloans_status\\" = 'Pagada'","time":"2.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":563,"hash":"60bd91eaa209a639fc2e8afc20430a4b","hostname":"EderCortes"}	2024-11-04 21:01:12
33234	9d69ad75-13d3-4ffc-bd2c-3a6f24847924	9d69ad75-2298-479b-8b3a-afa77a0b4938	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 115000, \\"loans_pago_prestado\\" = 460000, \\"updated_at\\" = '2024-11-04 21:01:12' where \\"id\\" = 87","time":"1.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":602,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 21:01:12
33235	9d69ad75-1457-48ac-aae1-f3cdaca8795a	9d69ad75-2298-479b-8b3a-afa77a0b4938	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:87","changes":{"updated_at":"2024-11-04 21:01:12","loans_pago_interes":115000,"loans_pago_prestado":460000},"hostname":"EderCortes"}	2024-11-04 21:01:12
33236	9d69ad75-1502-4f81-9c45-aa92d9bc6931	9d69ad75-2298-479b-8b3a-afa77a0b4938	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 87 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"0.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":609,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 21:01:12
33237	9d69ad75-1546-47d9-8d55-e0ba391e3a51	9d69ad75-2298-479b-8b3a-afa77a0b4938	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 21:01:12
33238	9d69ad75-15ef-4c29-8a7f-24f30d0d82e8	9d69ad75-2298-479b-8b3a-afa77a0b4938	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Abono', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = 60000, \\"itemloans_cuota_cancelada\\" = 240000, \\"updated_at\\" = '2024-11-04 21:01:12' where \\"id\\" = 342","time":"0.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":617,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 21:01:12
33239	9d69ad75-1634-41a1-b7f7-02dfc62f2686	9d69ad75-2298-479b-8b3a-afa77a0b4938	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:342","changes":{"itemloans_status":"Abono","updated_at":"2024-11-04 21:01:12","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":60000,"itemloans_cuota_cancelada":240000},"hostname":"EderCortes"}	2024-11-04 21:01:12
33240	9d69ad75-16c1-4513-9f13-ce610d26ffa8	9d69ad75-2298-479b-8b3a-afa77a0b4938	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"delete from \\"item_loans\\" where \\"loans_codigo\\" = 87 and \\"itemloans_status\\" = 'Pendiente'","time":"0.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":624,"hash":"89bf3c496a8b0746ff5d1219b8dc29e3","hostname":"EderCortes"}	2024-11-04 21:01:12
33241	9d69ad75-174a-4b9e-b18e-f19fe9ab476f	9d69ad75-2298-479b-8b3a-afa77a0b4938	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 87 limit 1","time":"0.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":627,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 21:01:12
33242	9d69ad75-184c-4c84-947c-531aae40f607	9d69ad75-2298-479b-8b3a-afa77a0b4938	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (87, 3, 160000, 40000, 'Pendiente', 'Se realiza abono', '12-11-2024', 0, 0, '2024-11-04 21:01:12', '2024-11-04 21:01:12')","time":"1.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":683,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:01:12
33243	9d69ad75-1881-4fac-a3ff-38e94d85d82c	9d69ad75-2298-479b-8b3a-afa77a0b4938	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:01:12
33244	9d69ad75-1929-44e7-9e54-50f0b9fa7543	9d69ad75-2298-479b-8b3a-afa77a0b4938	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (87, 4, 160000, 40000, 'Pendiente', 'Se realiza abono', '20-11-2024', 0, 0, '2024-11-04 21:01:12', '2024-11-04 21:01:12')","time":"0.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":683,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:01:12
33245	9d69ad75-195f-4b2c-af51-d51c190479af	9d69ad75-2298-479b-8b3a-afa77a0b4938	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:01:12
33246	9d69ad75-19fb-4fcd-bf8c-a01b87a4b8b5	9d69ad75-2298-479b-8b3a-afa77a0b4938	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (87, 5, 160000, 40000, 'Pendiente', 'Se realiza abono', '28-11-2024', 0, 0, '2024-11-04 21:01:12', '2024-11-04 21:01:12')","time":"0.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":683,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:01:12
33247	9d69ad75-1a31-42a7-91fd-35f5c02f3bf8	9d69ad75-2298-479b-8b3a-afa77a0b4938	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:01:12
33248	9d69ad75-1ac7-4aaa-9bfb-a33591732497	9d69ad75-2298-479b-8b3a-afa77a0b4938	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (87, 6, 160000, 40000, 'Pendiente', 'Se realiza abono', '06-12-2024', 0, 0, '2024-11-04 21:01:12', '2024-11-04 21:01:12')","time":"0.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":683,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:01:12
33249	9d69ad75-1afd-4294-b285-df447405b6a7	9d69ad75-2298-479b-8b3a-afa77a0b4938	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:01:12
33250	9d69ad75-20a9-4ceb-9111-41c75eba417c	9d69ad75-2298-479b-8b3a-afa77a0b4938	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:01:12
33251	9d69ad75-2111-49c8-b070-3634717ee7fb	9d69ad75-2298-479b-8b3a-afa77a0b4938	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"61","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"300000","idLoans":87,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El abono fue aplicado exitosamente","status":true},"duration":315,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:01:12
34712	9d69bf4b-db5e-40bc-9fa0-1a137f8a1c89	9d69bf4b-fa64-4ab6-9f19-aa4cd4c00564	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 21:51:05
34713	9d69bf4b-f509-4778-b435-12de57ab3659	9d69bf4b-fa64-4ab6-9f19-aa4cd4c00564	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:51:05
34714	9d69bf4b-f565-4131-9d02-dd1e40a13d72	9d69bf4b-fa64-4ab6-9f19-aa4cd4c00564	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:51:05
34715	9d69bf4b-f910-4e6e-9ea6-c01db31d3fb5	9d69bf4b-fa64-4ab6-9f19-aa4cd4c00564	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-04 21:51:05
34716	9d69bf4b-f963-4c27-a7e9-850c4cd42f00	9d69bf4b-fa64-4ab6-9f19-aa4cd4c00564	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":321,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:51:05
33252	9d69ad75-8c7a-40bb-99ad-9a62ed9ab2cd	9d69ad75-bd29-48b9-8216-ef6589b175cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:01:12
33253	9d69ad75-b0c1-4caf-9636-eb59af1c5980	9d69ad75-bd29-48b9-8216-ef6589b175cf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 87\\n                        ","time":"72.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"309a6eff5ebe9f2d91248732844dd9ed","hostname":"EderCortes"}	2024-11-04 21:01:12
33254	9d69ad75-b556-4409-b81c-cf437ca6760a	9d69ad75-bd29-48b9-8216-ef6589b175cf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '87' order by \\"item_loans\\".\\"id\\" asc","time":"4.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:01:12
33255	9d69ad75-bafa-4fb3-8301-e3db7e10132a	9d69ad75-bd29-48b9-8216-ef6589b175cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 21:01:13
33256	9d69ad75-bb7b-4705-9027-76979f520b1d	9d69ad75-bd29-48b9-8216-ef6589b175cf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/87","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":87,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"460000","loans_pago_interes":"115000","user_alias":"eder.cortes"},"items":[{"id":341,"loans_codigo":87,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 20:50:52","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000","user_alias":"eder.cortes"},{"id":342,"loans_codigo":87,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 21:01:12","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":445,"loans_codigo":87,"itemloans_cuota":"3","itemloans_valor_cuota":"160000","itemloans_iteres":"40000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:01:12","updated_at":"2024-11-04 21:01:12","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":446,"loans_codigo":87,"itemloans_cuota":"4","itemloans_valor_cuota":"160000","itemloans_iteres":"40000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:01:12","updated_at":"2024-11-04 21:01:12","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":447,"loans_codigo":87,"itemloans_cuota":"5","itemloans_valor_cuota":"160000","itemloans_iteres":"40000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:01:12","updated_at":"2024-11-04 21:01:12","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":448,"loans_codigo":87,"itemloans_cuota":"6","itemloans_valor_cuota":"160000","itemloans_iteres":"40000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:01:12","updated_at":"2024-11-04 21:01:12","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:01:13
33257	9d69adc4-8a4a-4428-83d0-1c5f9361481b	9d69adc4-8efc-45d5-9e7a-9b08a2d168e9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":190,"memory":20,"hostname":"EderCortes"}	2024-11-04 21:02:04
11027	9d5ca7ec-c071-462e-af6d-72c2171f9264	9d5ca7ec-c369-4a1a-9c52-defdbe60a092	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":553}	2024-10-29 09:39:58
32791	9d6992e6-db27-4cde-b24e-85f4317882d1	9d6992e7-3ef0-45f2-b183-b783a8069971	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 19:46:57
32792	9d6992e7-3c32-4671-93c0-374219a19fca	9d6992e7-3ef0-45f2-b183-b783a8069971	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 19:46:57
32793	9d6992e7-3d79-4d36-96a5-994753351763	9d6992e7-3ef0-45f2-b183-b783a8069971	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":694,"memory":22,"hostname":"EderCortes"}	2024-11-04 19:46:57
32794	9d6992e7-fed4-45d5-92fc-a4ba928b6f98	9d6992e8-3037-425d-a47f-1d502df69ea9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 19:46:58
32795	9d6992e8-26b3-41ae-b6c9-8cd1d21c18fd	9d6992e8-3037-425d-a47f-1d502df69ea9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"62.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":227,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 19:46:58
32796	9d6992e8-2742-4461-a88d-f8bb2976e1eb	9d6992e8-3037-425d-a47f-1d502df69ea9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 19:46:58
32797	9d6992e8-2e41-4d78-af33-c5a981da1be1	9d6992e8-3037-425d-a47f-1d502df69ea9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 19:46:58
30657	9d69424f-19ff-4cf8-9a29-fc66460475d5	9d69424f-3f00-46ba-bc21-67af21676362	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 16:01:36
30658	9d69424f-3d0a-4256-8a36-90cb479fdcbf	9d69424f-3f00-46ba-bc21-67af21676362	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:01:36
30659	9d69424f-3ddf-46cc-93a2-880ee9735f60	9d69424f-3f00-46ba-bc21-67af21676362	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":320,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:01:36
32798	9d6992e8-2ec5-43f9-a681-9fde1d8226bc	9d6992e8-3037-425d-a47f-1d502df69ea9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":522,"memory":22,"hostname":"EderCortes"}	2024-11-04 19:46:58
34453	9d69be7b-c0c9-43a6-ae83-0f2273dcef3f	9d69be7b-eb17-4534-a680-6aa81191c309	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:48:49
34454	9d69be7b-e8e6-4adf-bb2e-c475d7ccb881	9d69be7b-eb17-4534-a680-6aa81191c309	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:48:49
34455	9d69be7b-e9d0-4438-8d34-ba7d29c1231f	9d69be7b-eb17-4534-a680-6aa81191c309	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":306,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:48:49
30660	9d69424f-c8f4-40d1-aa14-f6aa44595dd4	9d69424f-eb3f-47cd-a188-a790d2ecd6eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:01:36
30661	9d69424f-e48a-4832-b914-a397f0efc4cd	9d69424f-eb3f-47cd-a188-a790d2ecd6eb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:01:36
30662	9d69424f-e4db-4db9-a141-7db669435618	9d69424f-eb3f-47cd-a188-a790d2ecd6eb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 16:01:36
30663	9d69424f-ea02-477f-805f-c6b9af12a1c1	9d69424f-eb3f-47cd-a188-a790d2ecd6eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:01:36
30664	9d69424f-ea52-4e8d-9de6-c74fbf682b71	9d69424f-eb3f-47cd-a188-a790d2ecd6eb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":324,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:01:36
32799	9d6992e8-a79e-434e-ad8f-3160f004fcb9	9d6992e8-d011-4ac6-9c31-68e81ed027f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 19:46:58
32800	9d6992e8-c919-4fd4-9fa3-83ff61df201e	9d6992e8-d011-4ac6-9c31-68e81ed027f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"53.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":216,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 19:46:58
32801	9d6992e8-c96d-4963-9189-65a7d9e0e2c8	9d6992e8-d011-4ac6-9c31-68e81ed027f0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 19:46:58
32802	9d6992e8-ce60-452a-9131-57c77c6d8ee1	9d6992e8-d011-4ac6-9c31-68e81ed027f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 19:46:58
32803	9d6992e8-ced9-47da-a612-74a304cc583a	9d6992e8-d011-4ac6-9c31-68e81ed027f0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":389,"memory":22,"hostname":"EderCortes"}	2024-11-04 19:46:58
33272	9d69adc5-bee6-4057-b55e-dd720a7115a4	9d69adc5-e26e-475a-91b5-b0f537100c14	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:02:05
33273	9d69adc5-d9e4-4363-8b37-4ae2de8b12c1	9d69adc5-e26e-475a-91b5-b0f537100c14	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 87\\n                        ","time":"53.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"309a6eff5ebe9f2d91248732844dd9ed","hostname":"EderCortes"}	2024-11-04 21:02:05
33274	9d69adc5-dd2a-479e-8ea3-c7303bae2f4f	9d69adc5-e26e-475a-91b5-b0f537100c14	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '87' order by \\"item_loans\\".\\"id\\" asc","time":"2.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:02:05
33275	9d69adc5-e0c4-4a9f-814d-4bdc300c8e85	9d69adc5-e26e-475a-91b5-b0f537100c14	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:02:05
34456	9d69be7c-56b9-486f-b6ad-cf1a721fddfc	9d69be7c-a464-43e3-a37c-20ed0b56d7b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:48:49
34457	9d69be7c-9ef7-4048-928f-8c542bfd1806	9d69be7c-a464-43e3-a37c-20ed0b56d7b4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"157.02","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":256,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:48:49
30665	9d694250-42b1-45c5-9ac4-d0e8bf82a5fe	9d694250-623a-4005-b2fa-66873b09064f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:01:36
30666	9d694250-5cb7-4847-9548-80c15b041747	9d694250-623a-4005-b2fa-66873b09064f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:01:36
30667	9d694250-5d08-4289-959b-7d9d0e05ec0b	9d694250-623a-4005-b2fa-66873b09064f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 16:01:36
30668	9d694250-6085-448c-9003-762c167c5e3e	9d694250-623a-4005-b2fa-66873b09064f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:01:36
26542	9d68d7bb-9d14-493f-9c64-4fa34be59867	9d68d7bc-3489-4889-a51d-db13485eb40d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:03:35
26543	9d68d7bc-30fb-410b-9cec-fedfeb86de73	9d68d7bc-3489-4889-a51d-db13485eb40d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:03:35
26544	9d68d7bc-32a1-4e94-ad3a-dbe8a09f11fc	9d68d7bc-3489-4889-a51d-db13485eb40d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":922,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:03:35
30669	9d694250-6101-4262-9cee-acc9aebd1ee8	9d694250-623a-4005-b2fa-66873b09064f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":284,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:01:36
32804	9d6992e9-338e-430d-827d-8d5e75f9b3bd	9d6992e9-5570-454d-beaa-6b7515158b55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 19:46:58
32805	9d6992e9-4d96-4bb5-ada5-967809833954	9d6992e9-5570-454d-beaa-6b7515158b55	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 19:46:58
32806	9d6992e9-4e08-4c99-8549-14572a50ffce	9d6992e9-5570-454d-beaa-6b7515158b55	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 19:46:58
32807	9d6992e9-5419-458a-a55d-1acf3e5997b3	9d6992e9-5570-454d-beaa-6b7515158b55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 19:46:58
32808	9d6992e9-5480-48d5-9603-19057c681625	9d6992e9-5570-454d-beaa-6b7515158b55	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":319,"memory":22,"hostname":"EderCortes"}	2024-11-04 19:46:58
33276	9d69adc5-e12a-4cf2-808e-9c26e6268b03	9d69adc5-e26e-475a-91b5-b0f537100c14	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/87","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":87,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"460000","loans_pago_interes":"115000","user_alias":"eder.cortes"},"items":[{"id":341,"loans_codigo":87,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 20:50:52","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000","user_alias":"eder.cortes"},{"id":342,"loans_codigo":87,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 21:01:12","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":445,"loans_codigo":87,"itemloans_cuota":"3","itemloans_valor_cuota":"160000","itemloans_iteres":"40000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:01:12","updated_at":"2024-11-04 21:01:12","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":446,"loans_codigo":87,"itemloans_cuota":"4","itemloans_valor_cuota":"160000","itemloans_iteres":"40000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:01:12","updated_at":"2024-11-04 21:01:12","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":447,"loans_codigo":87,"itemloans_cuota":"5","itemloans_valor_cuota":"160000","itemloans_iteres":"40000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:01:12","updated_at":"2024-11-04 21:01:12","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":448,"loans_codigo":87,"itemloans_cuota":"6","itemloans_valor_cuota":"160000","itemloans_iteres":"40000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:01:12","updated_at":"2024-11-04 21:01:12","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":355,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:02:05
34458	9d69be7c-9f4c-4ab7-b7fd-c16410c9fd60	9d69be7c-a464-43e3-a37c-20ed0b56d7b4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:48:49
34459	9d69be7c-a305-470a-b2b1-94e1a304d301	9d69be7c-a464-43e3-a37c-20ed0b56d7b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 21:48:49
21999	9d674167-df78-4224-a94a-8ed4aedbca7b	9d674167-e383-4609-ae85-f97811b9c97d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1056}	2024-11-03 16:07:25
25192	9d68c02b-11e0-453d-91e9-f65d4ac3d500	9d68c02b-6fb2-4a3c-b09e-95bbce61b2fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 09:57:42
25193	9d68c02b-6cf4-4b3f-9bdb-15a0b6636d2b	9d68c02b-6fb2-4a3c-b09e-95bbce61b2fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 09:57:42
25194	9d68c02b-6e39-45be-9665-f9904d207bc4	9d68c02b-6fb2-4a3c-b09e-95bbce61b2fc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":714,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:57:42
25195	9d68c02c-31be-40f9-8826-d54746e4e748	9d68c02c-61ce-4e00-b64e-6b256bd0a437	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 09:57:42
25196	9d68c02c-5923-445d-a742-d996d3d3ded4	9d68c02c-61ce-4e00-b64e-6b256bd0a437	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"66.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 09:57:42
25197	9d68c02c-5f7f-4804-8dc5-05785fab0114	9d68c02c-61ce-4e00-b64e-6b256bd0a437	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 09:57:42
25198	9d68c02c-6047-4783-850a-266e92345449	9d68c02c-61ce-4e00-b64e-6b256bd0a437	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":548,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:57:42
26545	9d68d7bc-e6e6-456e-9123-ee573423eb2d	9d68d7bd-5444-4f60-9945-ecfb74245c45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:03:36
26546	9d68d7bd-4577-46c1-81b0-a291064967a0	9d68d7bd-5444-4f60-9945-ecfb74245c45	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"226.53","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 11:03:36
26547	9d68d7bd-4af2-40c2-b96f-a4693c41199b	9d68d7bd-5444-4f60-9945-ecfb74245c45	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"3.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:03:36
26548	9d68d7bd-4b43-41b2-9ca2-47b9dd18eb47	9d68d7bd-5444-4f60-9945-ecfb74245c45	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:03:36
26549	9d68d7bd-5208-420a-8a1d-4efbafe3484a	9d68d7bd-5444-4f60-9945-ecfb74245c45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:03:36
26550	9d68d7bd-52b9-4fe5-98d5-53a4dbdb43bc	9d68d7bd-5444-4f60-9945-ecfb74245c45	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":645,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:03:36
32809	9d6992e9-bfcf-49dd-b0c2-9eed948fcecf	9d6992e9-f212-4a11-8cb0-53a20ba845f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 19:46:59
32810	9d6992e9-e878-4db8-a0a4-1401dbd06e63	9d6992e9-f212-4a11-8cb0-53a20ba845f5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"72.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 19:46:59
25199	9d68c02d-11f5-4f55-a8c6-04d22b857ddf	9d68c02d-4e46-4646-95b9-90200707549c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 09:57:43
25200	9d68c02d-423c-4d69-988c-9b882c382c9d	9d68c02d-4e46-4646-95b9-90200707549c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"80.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:57:43
25201	9d68c02d-4333-4648-aad1-72474b072378	9d68c02d-4e46-4646-95b9-90200707549c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:57:43
25202	9d68c02d-4bf6-4b9f-a53b-2277e351c285	9d68c02d-4e46-4646-95b9-90200707549c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 09:57:43
25203	9d68c02d-4c9e-4c8f-a193-40a5b4ffd6e4	9d68c02d-4e46-4646-95b9-90200707549c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":592,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:57:43
26551	9d68d7be-27a4-452f-bfe6-363573e6cbc1	9d68d7be-8c80-4fd5-b355-64c67411a526	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:03:37
26552	9d68d7be-82d4-43b3-acb0-81d5dc809623	9d68d7be-8c80-4fd5-b355-64c67411a526	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"175.69","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:03:37
26553	9d68d7be-835d-434f-be23-b53065228a52	9d68d7be-8c80-4fd5-b355-64c67411a526	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:03:37
26554	9d68d7be-8a6b-4de2-9532-62af2f0198b6	9d68d7be-8c80-4fd5-b355-64c67411a526	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:03:37
26555	9d68d7be-8afb-4eae-bcde-efe7b4b7c145	9d68d7be-8c80-4fd5-b355-64c67411a526	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":770,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:03:37
32811	9d6992e9-e91d-48a6-95e4-a79108859471	9d6992e9-f212-4a11-8cb0-53a20ba845f5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 19:46:59
32812	9d6992e9-f00e-467b-a3af-42b75962dde5	9d6992e9-f212-4a11-8cb0-53a20ba845f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 19:46:59
32813	9d6992e9-f098-4850-9a0c-3df9279b9298	9d6992e9-f212-4a11-8cb0-53a20ba845f5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":383,"memory":22,"hostname":"EderCortes"}	2024-11-04 19:46:59
33277	9d69ae31-1d0c-4ece-8992-31409041939e	9d69ae31-3d39-4350-beb8-e2ff2babcd51	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 21:03:15
25204	9d68c02e-460e-4bb1-ae37-09b7f9d4ec6d	9d68c02e-61fe-46c7-94ab-9919729443dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 09:57:44
25205	9d68c02e-5d59-409e-a224-7d8627356557	9d68c02e-61fe-46c7-94ab-9919729443dd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 09:57:44
25206	9d68c02e-5da4-4e1d-8f51-701ac5b532d7	9d68c02e-61fe-46c7-94ab-9919729443dd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 09:57:44
25207	9d68c02e-60b7-4773-9f9e-6eed2aa358b3	9d68c02e-61fe-46c7-94ab-9919729443dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 09:57:44
25208	9d68c02e-60fc-481c-9046-12969173b49f	9d68c02e-61fe-46c7-94ab-9919729443dd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":445,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:57:44
26556	9d68d7bf-3ac6-4b6f-b59f-c2ceb6f8a921	9d68d7bf-6e20-4bff-b1e7-7fe93a0aa58f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:03:37
26557	9d68d7bf-60c2-4f7e-acd9-e98f22ebf0f1	9d68d7bf-6e20-4bff-b1e7-7fe93a0aa58f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"64.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:03:38
26558	9d68d7bf-614e-4734-b864-48587c17340d	9d68d7bf-6e20-4bff-b1e7-7fe93a0aa58f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:03:38
26559	9d68d7bf-6bac-49b2-9aa9-795129c80713	9d68d7bf-6e20-4bff-b1e7-7fe93a0aa58f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:03:38
26560	9d68d7bf-6c5a-4571-a8df-d162b3bd72b5	9d68d7bf-6e20-4bff-b1e7-7fe93a0aa58f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":551,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:03:38
32814	9d6992ea-8a1f-48e6-b4fc-2cd716cd44e0	9d6992ea-e73a-4193-8ac3-815aab3598da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 19:46:59
32815	9d6992ea-dea0-424f-8ed9-c1cd1ea979c3	9d6992ea-e73a-4193-8ac3-815aab3598da	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"175.15","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 19:46:59
32816	9d6992ea-df1d-43c8-a863-0d86e73973a5	9d6992ea-e73a-4193-8ac3-815aab3598da	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 19:46:59
32817	9d6992ea-e52a-47f1-b5ab-f256a0805788	9d6992ea-e73a-4193-8ac3-815aab3598da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 19:46:59
33278	9d69ae31-36e6-40b8-b4b4-eb3fe4627366	9d69ae31-3d39-4350-beb8-e2ff2babcd51	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"42.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 21:03:15
25209	9d68c03d-3dd4-448b-8245-0688dd43ec87	9d68c03d-5f6a-469d-bb22-53af600b4aa9	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 09:57:53
25210	9d68c03d-59a8-4f3b-bd4a-d36929838fa1	9d68c03d-5f6a-469d-bb22-53af600b4aa9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"44.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 09:57:54
25211	9d68c03d-5dbf-4630-baf2-ed89b4d75c17	9d68c03d-5f6a-469d-bb22-53af600b4aa9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 09:57:54
25212	9d68c03d-5e30-4675-aed4-888b542d5279	9d68c03d-5f6a-469d-bb22-53af600b4aa9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":384,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:57:54
32818	9d6992ea-e5c3-4d36-bfbe-29eaf604e4d0	9d6992ea-e73a-4193-8ac3-815aab3598da	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":562,"memory":22,"hostname":"EderCortes"}	2024-11-04 19:46:59
33279	9d69ae31-3b42-4d49-afa6-b71b5118682f	9d69ae31-3d39-4350-beb8-e2ff2babcd51	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:03:15
33280	9d69ae31-3bc7-46f6-90a4-3df71615cd4b	9d69ae31-3d39-4350-beb8-e2ff2babcd51	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":228,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:03:15
25213	9d68c041-8a12-439d-8b33-d4feaa4000b7	9d68c041-d43b-47bb-9209-d97616eef0bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 09:57:56
25214	9d68c041-ce87-46ae-a8a2-c45c9cbd6555	9d68c041-d43b-47bb-9209-d97616eef0bb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"143.24","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 09:57:56
25215	9d68c041-cf30-47fa-ab44-f9994df1ec27	9d68c041-d43b-47bb-9209-d97616eef0bb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 09:57:56
25216	9d68c041-d2bc-40ff-8fb9-d8f8492a8575	9d68c041-d43b-47bb-9209-d97616eef0bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 09:57:56
25217	9d68c041-d30d-40a3-b7c2-465a41422429	9d68c041-d43b-47bb-9209-d97616eef0bb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":658,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:57:56
33281	9d69ae33-6e64-488e-b3c4-a34f13548a7e	9d69ae33-b1e2-4ab8-befa-0bcaf652f7ab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:03:17
33282	9d69ae33-ad16-4219-abd1-ed9f495befb9	9d69ae33-b1e2-4ab8-befa-0bcaf652f7ab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"142.65","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 21:03:17
33283	9d69ae33-b047-4da6-b6fc-425a6663444e	9d69ae33-b1e2-4ab8-befa-0bcaf652f7ab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:03:17
33284	9d69ae33-b0da-4876-9afe-4cd46fe65cd9	9d69ae33-b1e2-4ab8-befa-0bcaf652f7ab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":394,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:03:17
34460	9d69be7c-a35d-4f18-bc4a-20dd69fb0f6f	9d69be7c-a464-43e3-a37c-20ed0b56d7b4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":390,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:48:49
25218	9d68c042-44b9-4733-a245-b5c2fc9b9765	9d68c042-627c-44fc-8840-ced8ec564696	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 09:57:57
25219	9d68c042-5cc4-4773-a96e-0cad77527d36	9d68c042-627c-44fc-8840-ced8ec564696	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 09:57:57
25220	9d68c042-5d21-4e6a-80e0-8a58cc3aa38a	9d68c042-627c-44fc-8840-ced8ec564696	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 09:57:57
25221	9d68c042-6100-44b9-904d-1b815201fed7	9d68c042-627c-44fc-8840-ced8ec564696	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 09:57:57
25222	9d68c042-614d-4f5c-85c6-48b3d0a069a1	9d68c042-627c-44fc-8840-ced8ec564696	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:57:57
33285	9d69ae38-3351-4c43-9167-e1c278d9b6bf	9d69ae38-4f37-4140-b534-94772b4b6143	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:03:20
33286	9d69ae38-48b5-4269-805f-70182995886e	9d69ae38-4f37-4140-b534-94772b4b6143	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 86\\n                        ","time":"41.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"6815ad365c5e82c8fb55476c5a77f0b5","hostname":"EderCortes"}	2024-11-04 21:03:20
33287	9d69ae38-4b4b-4031-98b9-4e1d60469936	9d69ae38-4f37-4140-b534-94772b4b6143	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '86' order by \\"item_loans\\".\\"id\\" asc","time":"2.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:03:20
33288	9d69ae38-4e01-4c75-8ee2-6c32fb01c50e	9d69ae38-4f37-4140-b534-94772b4b6143	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:03:20
33289	9d69ae38-4e4f-439c-a1d4-d444eec5d0fb	9d69ae38-4f37-4140-b534-94772b4b6143	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/86","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":86,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0","user_alias":"eder.cortes"},"items":[{"id":336,"loans_codigo":86,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":337,"loans_codigo":86,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":338,"loans_codigo":86,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":339,"loans_codigo":86,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":340,"loans_codigo":86,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":222,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:03:20
34461	9d69be7c-ee23-4875-8284-e4970ecc2290	9d69be7d-12a4-4710-a592-c48104e18b61	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 21:48:49
34462	9d69be7d-0c15-40dc-bec3-62287ae4b0d9	9d69be7d-12a4-4710-a592-c48104e18b61	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":245,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 21:48:49
34463	9d69be7d-0c89-42c1-b251-074f7ec605e1	9d69be7d-12a4-4710-a592-c48104e18b61	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 21:48:49
34464	9d69be7d-1187-4bba-ba68-8ba1c4b873c4	9d69be7d-12a4-4710-a592-c48104e18b61	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 21:48:49
25223	9d68c050-e14b-47b5-aa26-c1127f03822f	9d68c050-fc8c-4400-ae14-2ff07fc989d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 09:58:06
24960	9d68bee3-d437-48b7-a2dd-77deadded349	9d68bee4-25a4-4621-8462-cfe1c6c99821	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 09:54:07
24961	9d68bee4-23b9-473e-99cd-d3a5b049ae2e	9d68bee4-25a4-4621-8462-cfe1c6c99821	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 09:54:07
24962	9d68bee4-2479-43e7-b9e9-b69b7714b7ab	9d68bee4-25a4-4621-8462-cfe1c6c99821	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":530,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:54:07
25224	9d68c050-f885-4042-971b-ee641840604e	9d68c050-fc8c-4400-ae14-2ff07fc989d8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"43.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 09:58:06
25225	9d68c050-fb3f-483a-b1ab-d30a2e5f98ce	9d68c050-fc8c-4400-ae14-2ff07fc989d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 09:58:06
25226	9d68c050-fba2-435d-8a7a-b62c51e44a67	9d68c050-fc8c-4400-ae14-2ff07fc989d8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:58:06
33290	9d69ae56-244f-41e0-a08c-7fc6a4e5cf17	9d69ae56-27e2-4e9e-8888-b739545d7e6d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":178,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:03:40
34465	9d69be7d-11d9-4df9-b2f1-a2b34019489a	9d69be7d-12a4-4710-a592-c48104e18b61	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":267,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:48:49
33291	9d69ae56-df53-4534-bfd7-4ab86c83c2b0	9d69ae56-fe50-4bff-a042-8e051e5f8988	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:03:40
33292	9d69ae56-f574-449d-a6c7-1347ed8d1634	9d69ae56-fe50-4bff-a042-8e051e5f8988	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"item_loans\\".\\"id\\" = 336 limit 1","time":"2.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":362,"hash":"46de5de1774fc4dd39c0192a338d7d3d","hostname":"EderCortes"}	2024-11-04 21:03:40
33293	9d69ae56-f5c5-464b-a250-d5fcdd7383d1	9d69ae56-fe50-4bff-a042-8e051e5f8988	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 21:03:40
33294	9d69ae56-f74f-4003-ac97-b38c1d07497b	9d69ae56-fe50-4bff-a042-8e051e5f8988	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 86 limit 1","time":"1.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":363,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 21:03:40
33295	9d69ae56-f787-4ef4-9c2f-fc2f756745ba	9d69ae56-fe50-4bff-a042-8e051e5f8988	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 21:03:40
33296	9d69ae56-f8ed-457d-919c-fe05c8c81929	9d69ae56-fe50-4bff-a042-8e051e5f8988	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Pagada', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = '55000', \\"itemloans_cuota_cancelada\\" = '220000', \\"updated_at\\" = '2024-11-04 21:03:40' where \\"id\\" = 336","time":"1.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":406,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 21:03:40
33297	9d69ae56-f948-4ad6-bf88-d79ff3f0f2a9	9d69ae56-fe50-4bff-a042-8e051e5f8988	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:336","changes":{"itemloans_status":"Pagada","updated_at":"2024-11-04 21:03:40","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},"hostname":"EderCortes"}	2024-11-04 21:03:40
33298	9d69ae56-f9f4-413c-ad00-22e3360f2782	9d69ae56-fe50-4bff-a042-8e051e5f8988	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_estado\\" = 'En curso', \\"loans_pago_interes\\" = 55000, \\"loans_pago_prestado\\" = 220000, \\"updated_at\\" = '2024-11-04 21:03:40' where \\"id\\" = 86","time":"0.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":414,"hash":"acfe32aea56c9ca6bdbb917f944a78d1","hostname":"EderCortes"}	2024-11-04 21:03:40
33299	9d69ae56-fa2a-431b-a4df-72044e287161	9d69ae56-fe50-4bff-a042-8e051e5f8988	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:86","changes":{"loans_estado":"En curso","updated_at":"2024-11-04 21:03:40","loans_pago_interes":55000,"loans_pago_prestado":220000},"hostname":"EderCortes"}	2024-11-04 21:03:40
33300	9d69ae56-fcf7-4d27-bda1-c66af112e8ce	9d69ae56-fe50-4bff-a042-8e051e5f8988	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:03:40
33301	9d69ae56-fd3d-4232-82e0-e81767266ce0	9d69ae56-fe50-4bff-a042-8e051e5f8988	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-cuota","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payCuota","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"179","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000","id":336,"loans_codigo":86,"itemloans_cuota":"1","item_loans_cuando_pago":null,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El pago fue realizado exitosamente","status":true},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:03:40
34466	9d69be7d-6173-4e4f-b9fb-133a755ba9d3	9d69be7d-83e4-4efa-ac63-75c0678dd2f3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 21:48:50
34467	9d69be7d-7dab-4b11-be47-14dac6ba8d99	9d69be7d-83e4-4efa-ac63-75c0678dd2f3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:48:50
34468	9d69be7d-7e00-4c78-a196-2152f7887a63	9d69be7d-83e4-4efa-ac63-75c0678dd2f3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:48:50
34469	9d69be7d-829a-439a-b139-98f3295a12b5	9d69be7d-83e4-4efa-ac63-75c0678dd2f3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 21:48:50
34470	9d69be7d-82ee-4230-89e0-52c4b19c8f3f	9d69be7d-83e4-4efa-ac63-75c0678dd2f3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":269,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:48:50
33302	9d69ae57-6889-4076-9a33-ff6ad095083f	9d69ae57-88f4-4ae3-b905-dc4b2d989446	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:03:40
33303	9d69ae57-80a6-429f-96e2-9369852f28f9	9d69ae57-88f4-4ae3-b905-dc4b2d989446	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 86\\n                        ","time":"47.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"6815ad365c5e82c8fb55476c5a77f0b5","hostname":"EderCortes"}	2024-11-04 21:03:40
33304	9d69ae57-83ad-4aa0-bd81-9caa24d191a3	9d69ae57-88f4-4ae3-b905-dc4b2d989446	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '86' order by \\"item_loans\\".\\"id\\" asc","time":"2.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:03:40
33305	9d69ae57-873a-4df3-a13f-52fdf57000dc	9d69ae57-88f4-4ae3-b905-dc4b2d989446	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:03:40
33306	9d69ae57-87a2-456a-9263-3aeea2cdcf91	9d69ae57-88f4-4ae3-b905-dc4b2d989446	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/86","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":86,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"220000","loans_pago_interes":"55000","user_alias":"eder.cortes"},"items":[{"id":336,"loans_codigo":86,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 21:03:40","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000","user_alias":"eder.cortes"},{"id":337,"loans_codigo":86,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":338,"loans_codigo":86,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":339,"loans_codigo":86,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":340,"loans_codigo":86,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":305,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:03:40
34471	9d69be7d-d627-4b9c-9ee4-68d39521e6de	9d69be7e-1e8f-4604-bf1b-fa6a7c77bb23	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 21:48:50
34472	9d69be7e-187f-4653-8c24-61b999442b36	9d69be7e-1e8f-4604-bf1b-fa6a7c77bb23	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_valor_prestado\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"loans_inicio_pago\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\" from \\"loans\\" where \\"id\\" = '93' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"146.41","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":232,"hash":"d8a6f897920785ba3ee108b031cb3dc4","hostname":"EderCortes"}	2024-11-04 21:48:50
34473	9d69be7e-18c8-4cc9-9f2a-1033b53aef97	9d69be7e-1e8f-4604-bf1b-fa6a7c77bb23	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 21:48:50
34474	9d69be7e-1a4f-4f9e-87b9-a33142a6812b	9d69be7e-1e8f-4604-bf1b-fa6a7c77bb23	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"1.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":233,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 21:48:50
34475	9d69be7e-1a93-4c18-bd9b-a0ca59dc3b92	9d69be7e-1e8f-4604-bf1b-fa6a7c77bb23	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 21:48:50
34476	9d69be7e-1d90-45cb-b8b5-193d2e6a53c4	9d69be7e-1e8f-4604-bf1b-fa6a7c77bb23	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 21:48:50
34477	9d69be7e-1dd5-4374-9d68-44cf782e42e7	9d69be7e-1e8f-4604-bf1b-fa6a7c77bb23	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","user_creador":12,"user_cobrador":22,"user_customer":19,"user_recomendacion":18,"loans_pago_prestado":"1000000","loans_pago_interes":"250000"},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:19:45.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:22:30.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":399,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":400,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":401,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":402,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"}]}},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:48:50
33307	9d69ae69-abf5-42ab-8972-553378ffb80f	9d69ae69-af2b-4809-b40e-93160a710802	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":144,"memory":20,"hostname":"EderCortes"}	2024-11-04 21:03:52
34478	9d69be80-59af-4772-9576-644994b7f8dc	9d69be80-7cd3-47fd-9d6f-bbb81afdbcbc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 21:48:52
34479	9d69be80-76f9-4e9d-a5b4-e03cff7821f6	9d69be80-7cd3-47fd-9d6f-bbb81afdbcbc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"49.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:48:52
34480	9d69be80-7762-43c5-a8d8-9aee7292222e	9d69be80-7cd3-47fd-9d6f-bbb81afdbcbc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:48:52
34481	9d69be80-7b4e-462d-b0ae-25c3d4b1941e	9d69be80-7cd3-47fd-9d6f-bbb81afdbcbc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 21:48:52
34482	9d69be80-7b9c-494b-a3c2-2a051bc113d8	9d69be80-7cd3-47fd-9d6f-bbb81afdbcbc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":375,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:48:52
41088	9d6ccb45-304d-4c8e-a597-b92f3fabefe6	9d6ccb45-34ee-4254-a5db-e8b6e2be9670	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1879}	2024-11-06 10:12:03
26632	9d68d90d-490b-484b-a4ef-d6d9ac4eb62f	9d68d90d-a2b8-4ae9-b0d6-6698bb62f166	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:07:16
26633	9d68d90d-9eb1-4acf-91f0-6997a3f9b1be	9d68d90d-a2b8-4ae9-b0d6-6698bb62f166	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 11:07:17
26634	9d68d90d-a057-47fa-9a88-091e1ad7465f	9d68d90d-a2b8-4ae9-b0d6-6698bb62f166	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":745,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:07:17
40067	9d6cc09a-65a5-4276-ab4e-709f860c0b8c	9d6cc09b-d31e-477f-8867-4d9d8190e069	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 09:42:13
40068	9d6cc09b-d0eb-4293-b9a1-4db1541dbeae	9d6cc09b-d31e-477f-8867-4d9d8190e069	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:42:14
40069	9d6cc09b-d1c1-4ac4-9147-0ba6ce771e50	9d6cc09b-d31e-477f-8867-4d9d8190e069	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1143,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:42:14
26635	9d68d90e-abfd-437b-8779-13fb57179138	9d68d90e-d9d6-48c0-9054-03b890f1a18e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 11:07:17
26636	9d68d90e-cc61-49bc-8266-b97cd3f4ebcb	9d68d90e-d9d6-48c0-9054-03b890f1a18e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"67.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 11:07:17
26637	9d68d90e-d1b3-4c48-9944-9b8070e8930f	9d68d90e-d9d6-48c0-9054-03b890f1a18e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:07:17
26638	9d68d90e-d1fd-459f-9d72-ad341d2b5b1e	9d68d90e-d9d6-48c0-9054-03b890f1a18e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:07:17
26639	9d68d90e-d84a-43bf-9e97-8be9abbf2298	9d68d90e-d9d6-48c0-9054-03b890f1a18e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 11:07:17
26640	9d68d90e-d8b1-4b2c-9ad1-047e17b0d737	9d68d90e-d9d6-48c0-9054-03b890f1a18e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":709,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:07:17
33322	9d69ae6a-b67d-4b6d-87a2-779a8c2df068	9d69ae6b-0281-4ea0-96a5-e56918b5928b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:03:53
33323	9d69ae6a-fa9c-4656-95d9-c4627af522a5	9d69ae6b-0281-4ea0-96a5-e56918b5928b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 86\\n                        ","time":"160.60","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"6815ad365c5e82c8fb55476c5a77f0b5","hostname":"EderCortes"}	2024-11-04 21:03:53
33324	9d69ae6a-fdd4-4543-9025-0fbb75fbcaae	9d69ae6b-0281-4ea0-96a5-e56918b5928b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '86' order by \\"item_loans\\".\\"id\\" asc","time":"2.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:03:53
33325	9d69ae6b-010a-43c9-8910-d25e546fbe93	9d69ae6b-0281-4ea0-96a5-e56918b5928b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:03:53
26641	9d68d90f-d4f6-43f1-97b4-13f26d7b0979	9d68d910-1aff-4a52-85ea-27e93a3fa0bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 11:07:18
26642	9d68d910-0f12-4a9f-b4be-bf9cef8612a3	9d68d910-1aff-4a52-85ea-27e93a3fa0bf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"98.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:07:18
26643	9d68d910-0fab-4395-bdf2-36ce6ef8a345	9d68d910-1aff-4a52-85ea-27e93a3fa0bf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:07:18
26644	9d68d910-18d7-44c2-acc0-df333788f9d5	9d68d910-1aff-4a52-85ea-27e93a3fa0bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 11:07:18
26645	9d68d910-1976-4de6-a9f0-7a7b3f550288	9d68d910-1aff-4a52-85ea-27e93a3fa0bf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":801,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:07:18
33326	9d69ae6b-016f-4525-9592-0a77a917f939	9d69ae6b-0281-4ea0-96a5-e56918b5928b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/86","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":86,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"220000","loans_pago_interes":"55000","user_alias":"eder.cortes"},"items":[{"id":336,"loans_codigo":86,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 21:03:40","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000","user_alias":"eder.cortes"},{"id":337,"loans_codigo":86,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":338,"loans_codigo":86,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":339,"loans_codigo":86,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":340,"loans_codigo":86,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":412,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:03:53
26646	9d68d911-090c-4b08-97e2-c9f1123185bd	9d68d911-44f4-417a-bc05-f70878777e0e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 11:07:19
26647	9d68d911-3b38-4b2c-8c4c-39f6204f7103	9d68d911-44f4-417a-bc05-f70878777e0e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"95.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:07:19
26648	9d68d911-3bf2-49ba-ae3e-c5a98c5e3973	9d68d911-44f4-417a-bc05-f70878777e0e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:07:19
26649	9d68d911-42f2-4260-9523-d72d022ec06c	9d68d911-44f4-417a-bc05-f70878777e0e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 11:07:19
26650	9d68d911-4375-4e09-901c-0ffc707db2d4	9d68d911-44f4-417a-bc05-f70878777e0e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":737,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:07:19
40292	9d6cc274-d615-423c-8985-c23bd1f0f77e	9d6cc275-202d-4784-a2c5-bb73c3589812	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 09:47:24
40293	9d6cc275-1e4d-4c7f-a99e-688c46adb33d	9d6cc275-202d-4784-a2c5-bb73c3589812	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 09:47:24
40294	9d6cc275-1f03-4de3-b509-6a2286def028	9d6cc275-202d-4784-a2c5-bb73c3589812	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":426,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:47:24
34904	9d69c0f0-ab39-4d1f-b103-0fee705b1d3d	9d69c0f0-e021-48ec-b565-9caec900134c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 21:55:41
34905	9d69c0f0-dd25-4010-817a-12ab06f6ed8d	9d69c0f0-e021-48ec-b565-9caec900134c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 21:55:41
34906	9d69c0f0-de76-4de4-889e-bca35cb784b1	9d69c0f0-e021-48ec-b565-9caec900134c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":443,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:55:41
40924	9d6cc8b5-7898-495d-9a33-e28d7a21d1a3	9d6cc8b5-7cc9-4e7a-a7fc-a0cecd3c907f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1869}	2024-11-06 10:04:53
34907	9d69c0f1-732f-450a-8491-b92049664714	9d69c0f1-9823-4d16-9393-45d63868e897	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 21:55:41
34908	9d69c0f1-924c-4d6a-a7ab-bf62ddb98405	9d69c0f1-9823-4d16-9393-45d63868e897	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"56.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 21:55:41
34909	9d69c0f1-9678-4359-b011-3fdb7e72b6c8	9d69c0f1-9823-4d16-9393-45d63868e897	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 21:55:41
34910	9d69c0f1-9701-4743-8c17-01a839e18c72	9d69c0f1-9823-4d16-9393-45d63868e897	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":382,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:55:41
34911	9d69c0f2-2cdd-42b9-a58b-541729def25b	9d69c0f2-9ea0-41e7-ad37-6329dec8c4bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 21:55:42
34912	9d69c0f2-92bd-4bb4-843f-b9e21011c503	9d69c0f2-9ea0-41e7-ad37-6329dec8c4bd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"197.11","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:55:42
34913	9d69c0f2-9363-4fc3-bd61-c10c053ed651	9d69c0f2-9ea0-41e7-ad37-6329dec8c4bd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:55:42
34914	9d69c0f2-9be4-4234-8868-cf8f60c18cbb	9d69c0f2-9ea0-41e7-ad37-6329dec8c4bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 21:55:42
34915	9d69c0f2-9ca1-4566-9052-1ecb062b86e0	9d69c0f2-9ea0-41e7-ad37-6329dec8c4bd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":659,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:55:42
26737	9d68db9f-f344-4ee7-9974-8d98ee56e3a0	9d68dba0-1088-4121-b024-573a6e5ecc28	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 11:14:28
26738	9d68dba0-0ea2-46c2-a913-f10d8a9c5e52	9d68dba0-1088-4121-b024-573a6e5ecc28	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 11:14:28
26739	9d68dba0-0f3c-492f-a538-2f5de23d33b1	9d68dba0-1088-4121-b024-573a6e5ecc28	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":358,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:14:28
26740	9d68dba0-8f89-4de5-a1f4-6e49c3379d19	9d68dba0-a854-4638-b244-85f748f7204c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 11:14:28
26741	9d68dba0-a42e-4758-a624-e11126801dff	9d68dba0-a854-4638-b244-85f748f7204c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"39.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 11:14:28
26742	9d68dba0-a716-43ae-bfe4-15b4ae574c52	9d68dba0-a854-4638-b244-85f748f7204c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 11:14:28
26743	9d68dba0-a77d-4278-a6b4-b00c7b7d8db4	9d68dba0-a854-4638-b244-85f748f7204c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:14:28
34916	9d69c0f3-b308-4743-ae6a-d50508217a9a	9d69c0f4-09ef-49d6-bd35-9cfe0bc4c63c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 21:55:43
34917	9d69c0f4-0260-4325-ab25-8c006ec2c49b	9d69c0f4-09ef-49d6-bd35-9cfe0bc4c63c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"171.77","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:55:43
34918	9d69c0f4-030b-401e-8f94-3640b601de22	9d69c0f4-09ef-49d6-bd35-9cfe0bc4c63c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:55:43
34919	9d69c0f4-0810-4da8-b437-11f01e88fe95	9d69c0f4-09ef-49d6-bd35-9cfe0bc4c63c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 21:55:43
34920	9d69c0f4-0896-4f0e-8b11-28f573910f93	9d69c0f4-09ef-49d6-bd35-9cfe0bc4c63c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":739,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:55:43
26744	9d68dba2-d911-48f5-8e19-a6f5880a7383	9d68dba3-26d8-4907-8dc3-871cc4ba6bef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 11:14:30
26745	9d68dba3-2067-4008-981c-3bd9673a0708	9d68dba3-26d8-4907-8dc3-871cc4ba6bef	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"157.56","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:14:30
26746	9d68dba3-20c6-4980-903c-118a1e3c8154	9d68dba3-26d8-4907-8dc3-871cc4ba6bef	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:14:30
26747	9d68dba3-254e-482a-84c9-805b849bf21c	9d68dba3-26d8-4907-8dc3-871cc4ba6bef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 11:14:30
26748	9d68dba3-25b7-461d-a177-f19c5427af19	9d68dba3-26d8-4907-8dc3-871cc4ba6bef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":589,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:14:30
40588	9d6cc5c9-996a-4cba-92a3-310e09290383	9d6cc5c9-9c34-41ba-b5bd-49efe762daf1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1830}	2024-11-06 09:56:43
40449	9d6cc3a9-6f06-4e97-a33a-ca6cb0449937	9d6cc3a9-91c7-45e0-886a-dc7b29f49e33	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 09:50:46
40450	9d6cc3a9-9007-494b-8255-c6071193b0a0	9d6cc3a9-91c7-45e0-886a-dc7b29f49e33	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:50:46
40451	9d6cc3a9-90c1-4f51-af26-52089f55b188	9d6cc3a9-91c7-45e0-886a-dc7b29f49e33	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":286,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:50:46
40534	9d6cc4cf-b223-4e91-95ce-ca664ad92375	9d6cc4d0-04d8-4f76-8284-0c4898c840e1	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 09:53:59
40535	9d6cc4d0-01f4-44c2-a619-ffacfe1baf84	9d6cc4d0-04d8-4f76-8284-0c4898c840e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:53:59
40536	9d6cc4d0-0339-4237-a29e-8cefc7227a90	9d6cc4d0-04d8-4f76-8284-0c4898c840e1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":407,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:53:59
35116	9d69c228-ff73-41bd-9660-e45adcfe59b5	9d69c229-31c8-4285-9a9d-178443d3356f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 21:59:05
35117	9d69c229-2ea6-4716-a081-9b8e9b1bc9e5	9d69c229-31c8-4285-9a9d-178443d3356f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 21:59:06
35118	9d69c229-2ff8-4f3d-80cb-6fe1bbea96a8	9d69c229-31c8-4285-9a9d-178443d3356f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":434,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:59:06
35119	9d69c229-ebf2-406b-831d-833a22f37da6	9d69c22a-19f6-44a6-bdef-14a2c06e4222	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 21:59:06
35120	9d69c22a-1351-48ca-9620-3e4286710ab1	9d69c22a-19f6-44a6-bdef-14a2c06e4222	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"66.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 21:59:06
35121	9d69c22a-180c-495f-8ad1-6367e0908350	9d69c22a-19f6-44a6-bdef-14a2c06e4222	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 21:59:06
35122	9d69c22a-18a2-42f4-b01d-e6a5aab8214d	9d69c22a-19f6-44a6-bdef-14a2c06e4222	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":448,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:59:06
35123	9d69c22a-9bef-4cc5-90d7-c2c0043dc339	9d69c22a-e854-42a6-92d9-246507eefa45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 21:59:06
35124	9d69c22a-da1f-41cb-9d2a-a55d10c07279	9d69c22a-e854-42a6-92d9-246507eefa45	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"123.70","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:59:07
35125	9d69c22a-db04-43eb-9f0b-f1e75285a7ff	9d69c22a-e854-42a6-92d9-246507eefa45	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:59:07
35126	9d69c22a-e518-47cc-a047-aa59fdf6e40b	9d69c22a-e854-42a6-92d9-246507eefa45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 21:59:07
35127	9d69c22a-e5c7-44ea-8e5b-327da3f23fde	9d69c22a-e854-42a6-92d9-246507eefa45	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":503,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:59:07
40381	9d6cc2fa-833c-4375-ad28-e9a123e8d332	9d6cc2fa-a0ea-4170-940d-92ce8574a47f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:48:52
40382	9d6cc2fa-9f4e-4fce-b157-174309f52d4a	9d6cc2fa-a0ea-4170-940d-92ce8574a47f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:48:52
40383	9d6cc2fa-9fe7-4695-8f7d-0004ebb68f82	9d6cc2fa-a0ea-4170-940d-92ce8574a47f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:48:52
35128	9d69c22c-4d70-4b68-a41c-8e9532845143	9d69c22c-a457-4a87-8e8b-1b599fbdd448	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 21:59:08
35129	9d69c22c-9ca5-4654-a686-b22417f9a6be	9d69c22c-a457-4a87-8e8b-1b599fbdd448	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"165.90","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:59:08
35130	9d69c22c-9d10-461f-a39f-b71d1437fa4c	9d69c22c-a457-4a87-8e8b-1b599fbdd448	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:59:08
35131	9d69c22c-a21e-4da4-b47c-78e23db17257	9d69c22c-a457-4a87-8e8b-1b599fbdd448	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 21:59:08
35132	9d69c22c-a2be-413e-a384-99fb74934b83	9d69c22c-a457-4a87-8e8b-1b599fbdd448	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":663,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:59:08
40653	9d6cc64a-8962-4116-b5c2-892d84a145de	9d6cc64a-d0c5-4d01-ba5e-1766f882bc3c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:58:08
40654	9d6cc64a-cf52-483c-bb01-0e579801ddde	9d6cc64a-d0c5-4d01-ba5e-1766f882bc3c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:58:08
40655	9d6cc64a-cfe9-411c-a80d-298bb504afbb	9d6cc64a-d0c5-4d01-ba5e-1766f882bc3c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:58:08
30941	9d6944e6-e9dc-4a2a-8260-0462fcd059bd	9d6944e7-1636-4d9a-8ec8-f9cd86fc09f5	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 16:08:51
30942	9d6944e7-13c3-41bf-a318-0049826aa1ae	9d6944e7-1636-4d9a-8ec8-f9cd86fc09f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:08:51
30943	9d6944e7-14d2-4ead-88f5-e1af85a02813	9d6944e7-1636-4d9a-8ec8-f9cd86fc09f5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:08:51
16615	9d64d41a-ad00-4697-a1be-5152ea059b24	9d64d41a-afff-4bb7-977c-e71ddbae8457	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":773}	2024-11-02 11:10:08
30944	9d6944e7-957e-48dd-8892-afd7def7d5c4	9d6944e7-bd24-4d86-a2a7-1927b2833968	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:08:51
30945	9d6944e7-afe4-4c52-bdd7-77ec6142445e	9d6944e7-bd24-4d86-a2a7-1927b2833968	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"51.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 16:08:51
30946	9d6944e7-b568-447a-a350-95ed17a2b752	9d6944e7-bd24-4d86-a2a7-1927b2833968	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"3.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 16:08:51
30947	9d6944e7-b5a8-4df2-b7ab-51e914399915	9d6944e7-bd24-4d86-a2a7-1927b2833968	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 16:08:51
30948	9d6944e7-bba9-4624-ae30-c85535952505	9d6944e7-bd24-4d86-a2a7-1927b2833968	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:08:51
30949	9d6944e7-bc0a-4d03-ab21-61c52eb00267	9d6944e7-bd24-4d86-a2a7-1927b2833968	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder.cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:08:51
40602	9d6cc5dc-5b57-4c8f-a964-7d4460a1b859	9d6cc5dc-7bb9-44b0-a5dd-b9b76dbfd674	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:56:55
40603	9d6cc5dc-7a1f-4aa8-b584-3cf599360bbd	9d6cc5dc-7bb9-44b0-a5dd-b9b76dbfd674	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:56:55
40604	9d6cc5dc-7aba-403c-b405-8d89f13ff158	9d6cc5dc-7bb9-44b0-a5dd-b9b76dbfd674	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":458,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:56:55
34229	9d69bbf1-4bef-4d57-8cad-f2c6ef3e05d0	9d69bbf1-958b-4aea-bf55-f9f16bca7f95	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 21:41:42
34230	9d69bbf1-940c-4983-a045-8639ed4d1199	9d69bbf1-958b-4aea-bf55-f9f16bca7f95	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 21:41:42
34231	9d69bbf1-94aa-4492-ad97-2c7b914890d3	9d69bbf1-958b-4aea-bf55-f9f16bca7f95	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":351,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:41:42
28768	9d690769-75a7-4148-9549-e806ed534c1b	9d690769-dbe0-40e1-b52c-2e920465e3fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 13:16:54
28769	9d690769-d7b1-4d9c-86cf-3386de3072dd	9d690769-dbe0-40e1-b52c-2e920465e3fd	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 13:16:55
28770	9d690769-d9c6-411c-9c4e-d10d367aa0bc	9d690769-dbe0-40e1-b52c-2e920465e3fd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":699,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:16:55
27594	9d68e87d-50d5-47e1-b681-86f3dd92dca9	9d68e87d-558d-4d9c-8d6f-866fc4fd9cd9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1286}	2024-11-04 11:50:26
28771	9d69076a-8dd1-44d6-9dcf-94a1b9efe879	9d69076a-c3d5-4180-bbb5-fbb52d24f7ee	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 13:16:55
28772	9d69076a-b325-4751-96a6-cb67d6e01246	9d69076a-c3d5-4180-bbb5-fbb52d24f7ee	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"59.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 13:16:55
28773	9d69076a-b932-4ea2-90b7-c46c0c9c283f	9d69076a-c3d5-4180-bbb5-fbb52d24f7ee	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"3.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:16:55
28774	9d69076a-b986-46d0-abc6-c2342e4bded8	9d69076a-c3d5-4180-bbb5-fbb52d24f7ee	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:16:55
28775	9d69076a-c1e1-44cd-b517-9d72753a5f1d	9d69076a-c3d5-4180-bbb5-fbb52d24f7ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 13:16:55
28776	9d69076a-c282-4cf5-9340-526c60f37154	9d69076a-c3d5-4180-bbb5-fbb52d24f7ee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":514,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:16:55
34232	9d69bbf1-ed85-4340-9625-2763e33a0608	9d69bbf2-0c09-4583-a05e-838a1d3fc52f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 21:41:43
34233	9d69bbf2-06fe-488c-9345-bc1424af9e04	9d69bbf2-0c09-4583-a05e-838a1d3fc52f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":227,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:41:43
34234	9d69bbf2-077c-41ff-9c75-0348586cfd89	9d69bbf2-0c09-4583-a05e-838a1d3fc52f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:41:43
34235	9d69bbf2-0aff-4797-b8aa-882df17e1d1c	9d69bbf2-0c09-4583-a05e-838a1d3fc52f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 21:41:43
34236	9d69bbf2-0b45-420c-b179-fa7bf4168831	9d69bbf2-0c09-4583-a05e-838a1d3fc52f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":242,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:41:43
35259	9d69c3b0-9148-4cdc-b49d-ae79a905d5a1	9d69c3b0-d447-48b2-a2b9-fd5392daac3f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 22:03:22
35260	9d69c3b0-d0b7-4452-8837-9e161bc7e546	9d69c3b0-d447-48b2-a2b9-fd5392daac3f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 22:03:22
35261	9d69c3b0-d250-4e83-83a2-457c338705f6	9d69c3b0-d447-48b2-a2b9-fd5392daac3f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":592,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:03:22
28777	9d69076b-6fc5-4dfe-b918-6a7490d422e9	9d69076b-e825-49ee-8997-98393b122c7c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 13:16:56
28778	9d69076b-dce1-4b4f-8193-4763887d8867	9d69076b-e825-49ee-8997-98393b122c7c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"178.85","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:16:56
28779	9d69076b-dd94-48fe-96cd-254b423ab55c	9d69076b-e825-49ee-8997-98393b122c7c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:16:56
28780	9d69076b-e61f-43d9-b68c-dbd0fbcbef78	9d69076b-e825-49ee-8997-98393b122c7c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 13:16:56
28781	9d69076b-e6b4-48fa-b8fa-e2856ddd652a	9d69076b-e825-49ee-8997-98393b122c7c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":725,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:16:56
34237	9d69bbf2-51e0-4373-bd84-c99e3c6db25f	9d69bbf2-6f3c-45f0-87ca-ecccfe005143	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 21:41:43
34238	9d69bbf2-6a43-4916-a181-31cd0f2cec03	9d69bbf2-6f3c-45f0-87ca-ecccfe005143	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":216,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 21:41:43
34239	9d69bbf2-6a91-4083-b2c6-7155773cc585	9d69bbf2-6f3c-45f0-87ca-ecccfe005143	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 21:41:43
34240	9d69bbf2-6dcd-4433-82af-1bd6d3768ce4	9d69bbf2-6f3c-45f0-87ca-ecccfe005143	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 21:41:43
34241	9d69bbf2-6e14-4266-9357-7d31afa803f7	9d69bbf2-6f3c-45f0-87ca-ecccfe005143	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:41:43
35262	9d69c3b1-d676-45f3-acf4-b885299f1091	9d69c3b2-117f-47ba-9f9c-cf4087e52205	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 22:03:23
35263	9d69c3b2-0889-4c1e-b169-5c86f5ffedad	9d69c3b2-117f-47ba-9f9c-cf4087e52205	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"83.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 22:03:23
35264	9d69c3b2-0f3c-49a4-ab18-65fc6ee2f04a	9d69c3b2-117f-47ba-9f9c-cf4087e52205	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 22:03:23
28782	9d69076c-7f09-4c37-8a18-0759f536b39e	9d69076c-d8a5-4259-87ba-894c343d2f83	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 13:16:56
28783	9d69076c-d04d-4fdc-8146-6fa7a6527169	9d69076c-d8a5-4259-87ba-894c343d2f83	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"169.27","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:16:56
28784	9d69076c-d0cb-4499-ac11-5b89a07ee675	9d69076c-d8a5-4259-87ba-894c343d2f83	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:16:56
28785	9d69076c-d6cc-422c-8eb9-140179bf7a44	9d69076c-d8a5-4259-87ba-894c343d2f83	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 13:16:57
28786	9d69076c-d74c-44c6-9968-deb3890a642b	9d69076c-d8a5-4259-87ba-894c343d2f83	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":588,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:16:57
34242	9d69bbf2-be63-48a8-84e4-202575ff933d	9d69bbf2-e063-4e4d-bd3e-663374c06700	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 21:41:43
34243	9d69bbf2-da70-406f-aea5-695dcf965628	9d69bbf2-e063-4e4d-bd3e-663374c06700	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:41:43
34244	9d69bbf2-dac1-4852-9531-511b5f5d9c6d	9d69bbf2-e063-4e4d-bd3e-663374c06700	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:41:43
34245	9d69bbf2-df51-421c-8c53-9212d042a8b7	9d69bbf2-e063-4e4d-bd3e-663374c06700	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 21:41:43
34246	9d69bbf2-df9a-4e89-bc28-45dc2de77bf2	9d69bbf2-e063-4e4d-bd3e-663374c06700	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":278,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:41:43
35265	9d69c3b2-0ff0-4c09-8f71-3f1b679fa316	9d69c3b2-117f-47ba-9f9c-cf4087e52205	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":633,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:03:23
35266	9d69c3b2-7bbf-4ae5-b8a5-b0545f6ad174	9d69c3b2-ca0a-41de-b098-b6762d20885d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 22:03:23
35267	9d69c3b2-c18b-4681-8131-13485cc432ef	9d69c3b2-ca0a-41de-b098-b6762d20885d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"152.21","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:03:23
35268	9d69c3b2-c232-4a7c-9c80-1a9af2a24f0a	9d69c3b2-ca0a-41de-b098-b6762d20885d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:03:23
35269	9d69c3b2-c82c-4bc4-ae3b-7741a0d9c405	9d69c3b2-ca0a-41de-b098-b6762d20885d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 22:03:24
35270	9d69c3b2-c8c0-42ba-a806-8b781e2aaee3	9d69c3b2-ca0a-41de-b098-b6762d20885d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":456,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:03:24
35271	9d69c3b3-4705-4df0-9e56-dd4f871ca705	9d69c3b3-a9e0-43b8-9ed7-2a75678bb721	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 22:03:24
35272	9d69c3b3-9f53-4dc1-be4a-22e9129d0600	9d69c3b3-a9e0-43b8-9ed7-2a75678bb721	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"189.08","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:03:24
35273	9d69c3b3-9fe9-4461-a1f6-5f4998e23684	9d69c3b3-a9e0-43b8-9ed7-2a75678bb721	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:03:24
35274	9d69c3b3-a7e0-4667-aaf9-e2c0936964d6	9d69c3b3-a9e0-43b8-9ed7-2a75678bb721	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 22:03:24
35275	9d69c3b3-a878-4578-b816-a76c503aba42	9d69c3b3-a9e0-43b8-9ed7-2a75678bb721	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":557,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:03:24
35276	9d69c3b4-2807-44a7-9525-0b5bb7cbb2c4	9d69c3b4-56e6-4c87-af35-aaaacbda0664	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 22:03:24
35277	9d69c3b4-4cf0-4918-a8d0-8e08c42a36e0	9d69c3b4-56e6-4c87-af35-aaaacbda0664	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"63.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:03:25
35278	9d69c3b4-4d95-400d-a49b-25808c307cca	9d69c3b4-56e6-4c87-af35-aaaacbda0664	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:03:25
35279	9d69c3b4-547e-4656-972b-3d4825f39c41	9d69c3b4-56e6-4c87-af35-aaaacbda0664	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 22:03:25
35280	9d69c3b4-551f-4248-abba-ca3be65ea178	9d69c3b4-56e6-4c87-af35-aaaacbda0664	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":415,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:03:25
40448	9d6cc3a9-8e54-481a-9eaa-bef852c1e8a1	9d6cc3a9-91c7-45e0-886a-dc7b29f49e33	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1813}	2024-11-06 09:50:46
25529	9d68c6da-3f7e-45a0-bc01-a98670849546	9d68c6da-63db-4624-b230-421b75bbc42d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 10:16:23
25530	9d68c6da-61c4-49db-8048-1581760d34e6	9d68c6da-63db-4624-b230-421b75bbc42d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:16:23
25531	9d68c6da-62a9-432d-b186-ee5a0be39e90	9d68c6da-63db-4624-b230-421b75bbc42d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":383,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:16:23
25532	9d68c6db-0290-4f4f-b321-2458f1711e61	9d68c6db-4f35-4b7a-80a6-6371b325cbf2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:16:24
25533	9d68c6db-45ac-4924-ba31-1e482667f874	9d68c6db-4f35-4b7a-80a6-6371b325cbf2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"157.14","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:16:24
25534	9d68c6db-4934-438d-a6a5-283892d28602	9d68c6db-4f35-4b7a-80a6-6371b325cbf2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:16:24
25535	9d68c6db-496a-49e2-a100-4ff1f4716431	9d68c6db-4f35-4b7a-80a6-6371b325cbf2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:16:24
25536	9d68c6db-4de6-4ab0-a696-01ae2b437d0a	9d68c6db-4f35-4b7a-80a6-6371b325cbf2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:16:24
25537	9d68c6db-4e31-4cfc-afc0-d64fbdfe7f33	9d68c6db-4f35-4b7a-80a6-6371b325cbf2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":547,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:16:24
40755	9d6cc705-478c-4118-ad0c-48a6f870e871	9d6cc705-6b34-43c0-a957-33a09a1929b3	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:00:10
40756	9d6cc705-693e-415d-8eae-77cecb0064cb	9d6cc705-6b34-43c0-a957-33a09a1929b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:00:10
40757	9d6cc705-6a0a-4d9c-987d-eae532c25d35	9d6cc705-6b34-43c0-a957-33a09a1929b3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":281,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:00:10
35427	9d69c494-903c-4268-9d8f-9c79d366e62f	9d69c494-c627-401c-a04c-8c48fe9e1c2d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 22:05:51
35428	9d69c494-c344-40b4-8ba9-a3fd5ebb4ea8	9d69c494-c627-401c-a04c-8c48fe9e1c2d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 22:05:52
35429	9d69c494-c4bd-437a-9c0b-da3fbedc1af7	9d69c494-c627-401c-a04c-8c48fe9e1c2d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":522,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:05:52
28870	9d690ad0-42c8-43df-b8d8-bd328bec861c	9d690ad0-67ee-4797-8218-159c48414f71	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 13:26:25
28871	9d690ad0-6601-4800-8d3f-c456cd66e27c	9d690ad0-67ee-4797-8218-159c48414f71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 13:26:25
28872	9d690ad0-66d0-4791-adf6-83d1cece8c71	9d690ad0-67ee-4797-8218-159c48414f71	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":297,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:26:25
40891	9d6cc871-d696-4bc6-bc2d-1fcdbbde8b82	9d6cc871-f3a2-4d94-81be-f66edf4569da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:04:09
40892	9d6cc871-f1f4-43ab-87e2-540b87e115f8	9d6cc871-f3a2-4d94-81be-f66edf4569da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:04:09
40893	9d6cc871-f2ae-4914-8bfd-69650bca02e7	9d6cc871-f3a2-4d94-81be-f66edf4569da	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:04:09
28873	9d690ad0-d83c-48f8-8840-69b717c50f65	9d690ad0-fad4-4e80-a5fa-acf0c773a3cb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 13:26:25
28874	9d690ad0-f050-4d9b-8b9e-e29ff6ad1cee	9d690ad0-fad4-4e80-a5fa-acf0c773a3cb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"47.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 13:26:25
28875	9d690ad0-f484-413e-96bb-d1e0b51de39a	9d690ad0-fad4-4e80-a5fa-acf0c773a3cb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:26:25
28876	9d690ad0-f4be-4bf0-bb43-51f2074d8be9	9d690ad0-fad4-4e80-a5fa-acf0c773a3cb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:26:25
28877	9d690ad0-f93e-4a1e-847b-df7486c8bc4f	9d690ad0-fad4-4e80-a5fa-acf0c773a3cb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 13:26:25
28878	9d690ad0-f9ae-4979-9c97-173c08708d14	9d690ad0-fad4-4e80-a5fa-acf0c773a3cb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":278,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:26:25
35430	9d69c495-7b7b-4f34-8a6f-e13f460462ee	9d69c495-b29b-4c97-9ad9-ac92b4fdd00d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 22:05:52
35431	9d69c495-a89d-4e80-a064-d5c48e51d4c8	9d69c495-b29b-4c97-9ad9-ac92b4fdd00d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"79.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 22:05:52
35432	9d69c495-b024-4b7e-8b8a-c3bb9a355e7e	9d69c495-b29b-4c97-9ad9-ac92b4fdd00d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 22:05:52
35433	9d69c495-b119-4a58-b0eb-352e5dd43dcb	9d69c495-b29b-4c97-9ad9-ac92b4fdd00d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":499,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:05:52
28879	9d690ad3-5afc-4478-bbcf-e292e2a4396f	9d690ad3-8311-494b-b277-a2dbc6cf2a98	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 13:26:27
28880	9d690ad3-7c46-406b-bf96-30fa70d05ff9	9d690ad3-8311-494b-b277-a2dbc6cf2a98	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"54.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:26:27
28881	9d690ad3-7cbd-406f-a0cf-c40551fb6407	9d690ad3-8311-494b-b277-a2dbc6cf2a98	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:26:27
28882	9d690ad3-8187-4792-bea7-496f39f74e86	9d690ad3-8311-494b-b277-a2dbc6cf2a98	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 13:26:27
28883	9d690ad3-81da-42a5-9908-d434710366ab	9d690ad3-8311-494b-b277-a2dbc6cf2a98	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":379,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:26:27
35434	9d69c496-2cc8-49b3-a871-669516c91ab3	9d69c496-9005-4269-82e2-368f242c7b69	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 22:05:53
35435	9d69c496-8662-4a20-93aa-a5d0fd196913	9d69c496-9005-4269-82e2-368f242c7b69	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"177.68","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:05:53
35436	9d69c496-86db-43b0-a99a-459e86979af4	9d69c496-9005-4269-82e2-368f242c7b69	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:05:53
35437	9d69c496-8e09-43a6-9b53-14697771e5f2	9d69c496-9005-4269-82e2-368f242c7b69	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 22:05:53
35438	9d69c496-8e92-409e-9526-848b9490b51d	9d69c496-9005-4269-82e2-368f242c7b69	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":545,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:05:53
35439	9d69c497-a4e5-4a91-b518-04bbc198154a	9d69c498-1c9f-4fde-96e2-eb80c279e17b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 22:05:54
35440	9d69c498-119a-44dd-aade-dc0c0c7ed835	9d69c498-1c9f-4fde-96e2-eb80c279e17b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"179.89","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:05:54
35441	9d69c498-126b-4528-8596-5e76390b7b6b	9d69c498-1c9f-4fde-96e2-eb80c279e17b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:05:54
35442	9d69c498-1a67-423a-af47-86be58b1c085	9d69c498-1c9f-4fde-96e2-eb80c279e17b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 22:05:54
35443	9d69c498-1af8-499a-9939-f23989772609	9d69c498-1c9f-4fde-96e2-eb80c279e17b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":986,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:05:54
35679	9d69c545-548f-449b-a355-ee08f9c06497	9d69c545-895e-41e0-9707-9a1f23ce605f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 22:07:47
35680	9d69c545-86fd-4615-bd6e-d40541b26619	9d69c545-895e-41e0-9707-9a1f23ce605f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 22:07:47
35681	9d69c545-881a-4cfc-8221-309740308532	9d69c545-895e-41e0-9707-9a1f23ce605f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":402,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:07:47
35444	9d69c498-a808-432b-b4f7-8da9e6f2b67b	9d69c499-1829-47c7-b20f-a933d9f25027	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 22:05:54
35445	9d69c499-0ab6-4998-b394-978adaf08c65	9d69c499-1829-47c7-b20f-a933d9f25027	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"212.04","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:05:54
35446	9d69c499-0b5c-4cf2-a146-961a1ab90348	9d69c499-1829-47c7-b20f-a933d9f25027	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:05:54
35447	9d69c499-1585-4409-b3bc-28ba308e289b	9d69c499-1829-47c7-b20f-a933d9f25027	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 22:05:54
35448	9d69c499-162e-4d60-9cba-c64b689cfd78	9d69c499-1829-47c7-b20f-a933d9f25027	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":616,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:05:54
35682	9d69c546-3372-4859-9e5e-088d4e65df80	9d69c546-60e6-4e10-9d85-37f3deb95596	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 22:07:48
35683	9d69c546-5915-4ae4-9807-556ddf8230f8	9d69c546-60e6-4e10-9d85-37f3deb95596	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"63.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 22:07:48
35684	9d69c546-5ee2-408d-a9ae-6ac3cb79ad9f	9d69c546-60e6-4e10-9d85-37f3deb95596	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 22:07:48
35685	9d69c546-5f91-4829-b7e3-64ef54a60b04	9d69c546-60e6-4e10-9d85-37f3deb95596	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":459,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:07:48
35686	9d69c546-d6ab-466f-87f3-83bd84268b45	9d69c547-0290-4165-a4b5-81d06b4e03ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 22:07:48
35687	9d69c546-fa76-4969-96bd-f8ee20191b00	9d69c547-0290-4165-a4b5-81d06b4e03ef	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"61.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:07:48
35688	9d69c546-fafd-49fc-87ad-b5326a7f292b	9d69c547-0290-4165-a4b5-81d06b4e03ef	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:07:48
35689	9d69c547-00e6-4dce-953c-d0766cc572c0	9d69c547-0290-4165-a4b5-81d06b4e03ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 22:07:48
35690	9d69c547-0163-4818-aaa5-e142908c6a0e	9d69c547-0290-4165-a4b5-81d06b4e03ef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":401,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:07:48
35691	9d69c547-9631-4ae3-a8e3-8839d7101b03	9d69c548-3dc7-4d38-93f9-e13c1759b987	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 22:07:49
35692	9d69c548-3056-4df7-95be-fbfcd6f5390a	9d69c548-3dc7-4d38-93f9-e13c1759b987	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"332.50","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:07:49
35693	9d69c548-30e3-42da-98c5-8ec2551aaf08	9d69c548-3dc7-4d38-93f9-e13c1759b987	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:07:49
35694	9d69c548-39d0-43a1-962a-78a3d1949597	9d69c548-3dc7-4d38-93f9-e13c1759b987	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 22:07:49
35695	9d69c548-3a75-40ed-ad4e-1e9cc34df740	9d69c548-3dc7-4d38-93f9-e13c1759b987	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":776,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:07:49
35696	9d69c548-c87a-4f17-abbb-0f0b9af7ad80	9d69c548-f796-4d91-b9f2-fe233817c054	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 22:07:50
35697	9d69c548-ebf6-4baa-8948-f79ec92c4195	9d69c548-f796-4d91-b9f2-fe233817c054	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"56.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:07:50
35698	9d69c548-ec7a-4e58-b1d3-f0a71eb88035	9d69c548-f796-4d91-b9f2-fe233817c054	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:07:50
35699	9d69c548-f4aa-41dc-b46f-60f327c5fd93	9d69c548-f796-4d91-b9f2-fe233817c054	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 22:07:50
35700	9d69c548-f56d-4ac5-acd5-a21ddd0214ea	9d69c548-f796-4d91-b9f2-fe233817c054	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":450,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:07:50
40775	9d6cc77d-4c03-4f03-98b4-aa7f749637d9	9d6cc77d-4ef7-4ea1-871e-b20dc8496a8d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1852}	2024-11-06 10:01:29
25623	9d68c769-cf5e-466c-becd-9a28d1e6590e	9d68c76a-0f50-489a-8a33-a0070fc1b7c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:17:57
25624	9d68c76a-0c29-4331-a099-df4bb37b78df	9d68c76a-0f50-489a-8a33-a0070fc1b7c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:17:57
25625	9d68c76a-0dca-4bd8-ac45-097b9aa45073	9d68c76a-0f50-489a-8a33-a0070fc1b7c9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":605,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:17:57
31277	9d6949b6-c081-4f32-b85b-b3afada3736d	9d6949b6-e92f-4c44-b583-3e9ebff22f67	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 16:22:18
31278	9d6949b6-e723-423a-903a-a1ad56f18c8b	9d6949b6-e92f-4c44-b583-3e9ebff22f67	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:22:18
31279	9d6949b6-e80a-46fc-a828-a93cf29c54be	9d6949b6-e92f-4c44-b583-3e9ebff22f67	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":296,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:22:18
25626	9d68c76a-de1b-4449-b50b-1acdb5ba3615	9d68c76b-0f8a-48bb-9188-9085d527561b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:17:58
25627	9d68c76b-0760-4567-b8d9-ddefdb53a02e	9d68c76b-0f8a-48bb-9188-9085d527561b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"70.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 10:17:58
25628	9d68c76b-0d10-474e-bdc9-9eeb38564445	9d68c76b-0f8a-48bb-9188-9085d527561b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:17:58
25629	9d68c76b-0de2-418c-8dd6-ec503994c329	9d68c76b-0f8a-48bb-9188-9085d527561b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":577,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:17:58
31281	9d6949b7-525c-49b8-b773-4660e42b1dec	9d6949b7-7228-481e-8684-50b6bf0b5cfa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:22:18
31282	9d6949b7-69d0-4db2-8de8-bbb6ac40bfce	9d6949b7-7228-481e-8684-50b6bf0b5cfa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"45.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 16:22:18
31283	9d6949b7-70b2-4613-bafb-1b78203e88e4	9d6949b7-7228-481e-8684-50b6bf0b5cfa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:22:18
25630	9d68c76b-cf76-4d81-a161-caefc59407e3	9d68c76c-274b-4d4a-be8c-a29da2220239	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:17:58
25631	9d68c76c-19ad-4c0d-8cd4-8ee7957ce9fe	9d68c76c-274b-4d4a-be8c-a29da2220239	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"135.99","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:17:59
25632	9d68c76c-1a6c-42e0-b7f1-6781b4f6f17e	9d68c76c-274b-4d4a-be8c-a29da2220239	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:17:59
25633	9d68c76c-23ff-4018-9fca-99f1893b32cb	9d68c76c-274b-4d4a-be8c-a29da2220239	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:17:59
25634	9d68c76c-24af-4281-8d28-f5980be46ed4	9d68c76c-274b-4d4a-be8c-a29da2220239	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":699,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:17:59
31284	9d6949b7-713c-4a30-b08d-d6572c30fbdb	9d6949b7-7228-481e-8684-50b6bf0b5cfa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"Undefined variable $item","exception":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":302,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255,"function":"handleError","class":"Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":302,"function":"Illuminate\\\\Foundation\\\\Bootstrap\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":293,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:22:18
36025	9d69c8d6-fba2-42c1-acb1-b4d53941a031	9d69c8d7-009f-49ea-bed8-617a1d40bb4d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1631}	2024-11-04 22:17:46
25635	9d68c76d-1b70-413f-8772-4b93a6e9a825	9d68c76d-7833-47ed-a0b1-ac4253628792	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:17:59
25636	9d68c76d-6f7a-4dd0-99ea-e17603582c26	9d68c76d-7833-47ed-a0b1-ac4253628792	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"172.28","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:17:59
25637	9d68c76d-700d-40af-9e9f-857f12c5a6ac	9d68c76d-7833-47ed-a0b1-ac4253628792	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:17:59
25638	9d68c76d-766b-466a-b080-b720877e6647	9d68c76d-7833-47ed-a0b1-ac4253628792	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:17:59
25639	9d68c76d-76ef-4049-ba1b-77fb0ed22287	9d68c76d-7833-47ed-a0b1-ac4253628792	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":812,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:17:59
31285	9d6949b9-a8f2-44ea-89e5-897658c7d22a	9d6949b9-f41a-40ea-a29b-0a34ce482ef2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:22:20
31286	9d6949b9-eee1-4946-b366-159f21510570	9d6949b9-f41a-40ea-a29b-0a34ce482ef2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"146.84","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:22:20
31287	9d6949b9-ef3f-4c14-9e6e-844da833f295	9d6949b9-f41a-40ea-a29b-0a34ce482ef2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:22:20
31288	9d6949b9-f2b3-48c5-9d43-5b1455b2aa07	9d6949b9-f41a-40ea-a29b-0a34ce482ef2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:22:20
31289	9d6949b9-f2fa-4845-8626-cccaea14a497	9d6949b9-f41a-40ea-a29b-0a34ce482ef2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":531,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:22:20
31280	9d6949b7-6f55-46bf-9913-413411cdd7f6	9d6949b7-7228-481e-8684-50b6bf0b5cfa	23a117e77c07e3db1fcf24bde9b5861d	f	exception	{"class":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":302,"message":"Undefined variable $item","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":302},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"293":"                            join users ucr on l.user_creador = ucr.id","294":"                            join users uco on l.user_cobrador = uco.id","295":"                            left join users ure on l.user_recomendacion = ure.id","296":"                            where l.id = $id","297":"                        \\");","298":"","299":"\\/\\/        $item = ItemLoans::where('loans_codigo', $id)->orderBy('item_loans.id', 'ASC')->get();","300":"","301":"        return response()->json([","302":"            \\"result\\" => [\\"data\\" =>$data[0], \\"items\\" => $item],","303":"        ]);","304":"","305":"\\/\\/        $data = User::where('users.profile_code', $id)","306":"\\/\\/            ->orderBy('users.created_at')","307":"\\/\\/            ->get();","308":"\\/\\/","309":"\\/\\/        return response()->json([","310":"\\/\\/            \\"data\\" => $data","311":"\\/\\/        ]);","312":""},"hostname":"EderCortes","occurrences":1}	2024-11-04 16:22:18
31290	9d6949ba-59e7-4009-b9bc-c1456710cf52	9d6949ba-5ca5-4faa-8249-eaabae87f1a9	23a117e77c07e3db1fcf24bde9b5861d	t	exception	{"class":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":302,"message":"Undefined variable $item","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":302},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"293":"                            join users ucr on l.user_creador = ucr.id","294":"                            join users uco on l.user_cobrador = uco.id","295":"                            left join users ure on l.user_recomendacion = ure.id","296":"                            where l.id = $id","297":"                        \\");","298":"","299":"\\/\\/        $item = ItemLoans::where('loans_codigo', $id)->orderBy('item_loans.id', 'ASC')->get();","300":"","301":"        return response()->json([","302":"            \\"result\\" => [\\"data\\" =>$data[0], \\"items\\" => $item],","303":"        ]);","304":"","305":"\\/\\/        $data = User::where('users.profile_code', $id)","306":"\\/\\/            ->orderBy('users.created_at')","307":"\\/\\/            ->get();","308":"\\/\\/","309":"\\/\\/        return response()->json([","310":"\\/\\/            \\"data\\" => $data","311":"\\/\\/        ]);","312":""},"hostname":"EderCortes","occurrences":2}	2024-11-04 16:22:20
31291	9d6949ba-4088-4d8c-b257-01c76b02439a	9d6949ba-5ca5-4faa-8249-eaabae87f1a9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:22:20
31292	9d6949ba-5630-4ad6-8177-b5cc8b4b3049	9d6949ba-5ca5-4faa-8249-eaabae87f1a9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"41.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 16:22:20
29008	9d690e50-981f-4570-a7da-ea19ab485b57	9d690e50-cea5-4e0b-bc16-42bae53ac044	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 13:36:12
29009	9d690e50-cbc7-47d1-be79-11ba7c0feeff	9d690e50-cea5-4e0b-bc16-42bae53ac044	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 13:36:13
29010	9d690e50-cd22-43a1-9ee5-44d45fda2786	9d690e50-cea5-4e0b-bc16-42bae53ac044	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":413,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:36:13
31293	9d6949ba-5b0d-4c11-b11f-3f518c1b6541	9d6949ba-5ca5-4faa-8249-eaabae87f1a9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:22:20
31294	9d6949ba-5b82-4a7f-b45c-922b291c72a7	9d6949ba-5ca5-4faa-8249-eaabae87f1a9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"Undefined variable $item","exception":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":302,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255,"function":"handleError","class":"Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":302,"function":"Illuminate\\\\Foundation\\\\Bootstrap\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:22:20
29011	9d690e51-78f6-42d1-977f-095fede3c393	9d690e51-ab27-4b80-ac07-27fdbd127f18	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 13:36:13
29012	9d690e51-a26f-471d-bcda-3689c5e8d308	9d690e51-ab27-4b80-ac07-27fdbd127f18	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"59.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:36:13
29013	9d690e51-a2f6-414b-8ff6-003cbbd6a117	9d690e51-ab27-4b80-ac07-27fdbd127f18	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 13:36:13
29014	9d690e51-a92c-4458-ba96-7f1aa6bcd50c	9d690e51-ab27-4b80-ac07-27fdbd127f18	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 13:36:13
29015	9d690e51-a9ab-47cd-8d9d-33dcec69c019	9d690e51-ab27-4b80-ac07-27fdbd127f18	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":476,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:36:13
29016	9d690e52-357c-4c97-a873-9d00b62b6d88	9d690e52-68d2-4c6d-bd92-ff50fa9563c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 13:36:13
29017	9d690e52-5e53-4ab0-a45f-c4e15792c68c	9d690e52-68d2-4c6d-bd92-ff50fa9563c5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"58.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:36:14
29018	9d690e52-5efe-4dd2-84ff-77e1baeb51f0	9d690e52-68d2-4c6d-bd92-ff50fa9563c5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 13:36:14
29019	9d690e52-66f7-42d2-b017-2ea44a5b1e74	9d690e52-68d2-4c6d-bd92-ff50fa9563c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 13:36:14
29020	9d690e52-677e-424d-9451-cec1a9d43adf	9d690e52-68d2-4c6d-bd92-ff50fa9563c5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":462,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:36:14
29021	9d690e52-d486-4cbf-b2f2-b377b62213b9	9d690e52-ffb9-45ab-840d-ab20bd688c85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 13:36:14
29022	9d690e52-f42e-49f1-a87b-ec44b930e183	9d690e52-ffb9-45ab-840d-ab20bd688c85	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '89' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"58.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 13:36:14
29023	9d690e52-f4b8-415f-9bfb-916b28bbf063	9d690e52-ffb9-45ab-840d-ab20bd688c85	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 13:36:14
29024	9d690e52-f757-4ef1-a5ce-69bc25a6c7d5	9d690e52-ffb9-45ab-840d-ab20bd688c85	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:36:14
29025	9d690e52-f7ab-4d0b-960b-adeb1fc155b5	9d690e52-ffb9-45ab-840d-ab20bd688c85	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:36:14
29026	9d690e52-fdcb-4b2e-a326-9c6c84ea6fe3	9d690e52-ffb9-45ab-840d-ab20bd688c85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 13:36:14
29027	9d690e52-fe50-48c0-90b4-6a39be3b711a	9d690e52-ffb9-45ab-840d-ab20bd688c85	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"146000","loans_pago_prestado":"584000","loans_intereses_recaudar":"275000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":358,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:36:14
29028	9d690e53-dd80-4add-b668-6d7f7afece4b	9d690e54-89f2-4e5b-9b88-8da11f1f1968	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 13:36:15
29029	9d690e54-7c7f-4154-b9a3-eecac7ef4c84	9d690e54-89f2-4e5b-9b88-8da11f1f1968	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"224.69","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:36:15
29030	9d690e54-7d22-4b9d-aff7-7b238d0d32af	9d690e54-89f2-4e5b-9b88-8da11f1f1968	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:36:15
29031	9d690e54-8744-48f5-9ff7-42178a1e66c2	9d690e54-89f2-4e5b-9b88-8da11f1f1968	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 13:36:15
29032	9d690e54-8801-42a9-9f73-f48bea83b421	9d690e54-89f2-4e5b-9b88-8da11f1f1968	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":980,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:36:15
29033	9d690e55-258c-45c0-9f71-a4bb6435f5c1	9d690e55-665a-42c7-ba33-8d85dbcdab89	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 13:36:15
29034	9d690e55-58b0-424d-b4bd-c948db4651dd	9d690e55-665a-42c7-ba33-8d85dbcdab89	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"90.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:36:16
29035	9d690e55-5989-4dc4-84e8-2bb177193251	9d690e55-665a-42c7-ba33-8d85dbcdab89	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:36:16
29036	9d690e55-638c-46fe-ae7e-a4e017b3b7e6	9d690e55-665a-42c7-ba33-8d85dbcdab89	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 13:36:16
29037	9d690e55-643f-419a-9989-2b9a74f0fecf	9d690e55-665a-42c7-ba33-8d85dbcdab89	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":534,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:36:16
35924	9d69c868-aeb0-4792-93dd-334a2c5afdd4	9d69c869-19f6-4130-b718-8c77a9af16fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 22:16:34
35925	9d69c869-16f3-4582-ac96-251d82d5ff62	9d69c869-19f6-4130-b718-8c77a9af16fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 22:16:34
35926	9d69c869-186f-4984-a13a-d039c6657b9c	9d69c869-19f6-4130-b718-8c77a9af16fe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":582,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:16:34
1295	9d50cad8-3fb1-4123-8005-6384867ae402	9d50cad8-427f-4585-a99a-0147e249cd75	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":95}	2024-10-23 12:07:41
35927	9d69c869-b636-49c5-adb4-73a698b84643	9d69c869-e42e-4854-abfb-f9fb36fd8882	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 22:16:34
35928	9d69c869-dafe-4a63-88e5-e14bbee88c25	9d69c869-e42e-4854-abfb-f9fb36fd8882	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"66.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 22:16:35
35929	9d69c869-e1fa-4ef6-a243-281852ed8578	9d69c869-e42e-4854-abfb-f9fb36fd8882	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 22:16:35
35930	9d69c869-e2aa-454a-a16e-6d9a6c317f1a	9d69c869-e42e-4854-abfb-f9fb36fd8882	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":435,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:16:35
35931	9d69c86a-6729-4727-b6dd-74141288cea2	9d69c86a-92b9-4d7c-a5d7-fff970bcc551	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 22:16:35
35932	9d69c86a-8a94-4b7e-9a45-347e296c061c	9d69c86a-92b9-4d7c-a5d7-fff970bcc551	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"57.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:16:35
35933	9d69c86a-8b13-444f-a475-fd47c7d5e785	9d69c86a-92b9-4d7c-a5d7-fff970bcc551	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 22:16:35
35934	9d69c86a-90d4-4b65-b16e-be79fddf8d00	9d69c86a-92b9-4d7c-a5d7-fff970bcc551	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 22:16:35
35935	9d69c86a-914d-4a94-a2f2-4e8413fd212d	9d69c86a-92b9-4d7c-a5d7-fff970bcc551	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":432,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:16:35
41053	9d6ccae4-f5d2-49d1-b610-bde5afe7e376	9d6ccae5-4d3e-46db-b142-0a13d999cc27	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:11:00
35936	9d69c86a-fa31-4f62-bb91-1530d1a5a74c	9d69c86b-1c06-4746-abae-39404ab38e05	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 22:16:35
35937	9d69c86b-1619-453f-a4b5-8309d66cae9b	9d69c86b-1c06-4746-abae-39404ab38e05	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:16:35
35938	9d69c86b-168e-4b09-8e19-b4f36a93e6d0	9d69c86b-1c06-4746-abae-39404ab38e05	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 22:16:35
35939	9d69c86b-1a99-4f0e-a474-3bd8256c08e5	9d69c86b-1c06-4746-abae-39404ab38e05	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 22:16:35
35940	9d69c86b-1af1-43e8-bd66-66693bf68748	9d69c86b-1c06-4746-abae-39404ab38e05	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:16:35
41054	9d6ccae5-4ada-4002-82c3-d3ebe8b15c99	9d6ccae5-4d3e-46db-b142-0a13d999cc27	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:11:00
41055	9d6ccae5-4bae-492c-836b-535375067f0d	9d6ccae5-4d3e-46db-b142-0a13d999cc27	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":538,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:11:00
35941	9d69c86b-fade-4560-b20e-bb2e7403e5da	9d69c86c-3e2b-44b8-be92-fcfd1e19c157	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 22:16:36
35942	9d69c86c-31c4-47e0-9b0c-6f788a19ec80	9d69c86c-3e2b-44b8-be92-fcfd1e19c157	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"94.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:16:36
35943	9d69c86c-32e1-41ed-833a-872917e01130	9d69c86c-3e2b-44b8-be92-fcfd1e19c157	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:16:36
35944	9d69c86c-3ba7-49a1-a68e-6eea349b2aba	9d69c86c-3e2b-44b8-be92-fcfd1e19c157	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 22:16:36
35945	9d69c86c-3c53-49e3-83ce-a7ee40f9df1f	9d69c86c-3e2b-44b8-be92-fcfd1e19c157	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":721,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:16:36
40860	9d6cc7d9-46f5-42b4-81a1-4b00624e8837	9d6cc7d9-49cd-4924-b927-75e8adf53f59	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1862}	2024-11-06 10:02:29
35946	9d69c86c-e0b0-42e8-9c6a-46c12ad53789	9d69c86d-0b2d-44ea-b289-24b117b617da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 22:16:37
35947	9d69c86d-011e-41dc-bf44-167bd053a0b4	9d69c86d-0b2d-44ea-b289-24b117b617da	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"52.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:16:37
35948	9d69c86d-0195-44c8-902b-3700453ac7d0	9d69c86d-0b2d-44ea-b289-24b117b617da	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:16:37
35949	9d69c86d-093b-4732-858d-473b012221b9	9d69c86d-0b2d-44ea-b289-24b117b617da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 22:16:37
35950	9d69c86d-09bb-4b0f-b508-6d7579c0814f	9d69c86d-0b2d-44ea-b289-24b117b617da	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":495,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:16:37
24959	9d68bee4-2198-41c7-8182-e4dcd980f81b	9d68bee4-25a4-4621-8462-cfe1c6c99821	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1134}	2024-11-04 09:54:07
31433	9d694bd3-97b5-4004-9e61-d4fb9e6d5566	9d694bd3-d491-481a-ab5f-a6f7824ee6c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 16:28:12
31434	9d694bd3-d1b3-4890-a000-704212ccf6b7	9d694bd3-d491-481a-ab5f-a6f7824ee6c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 16:28:12
31435	9d694bd3-d318-41a5-b219-ba3b8e64da3a	9d694bd3-d491-481a-ab5f-a6f7824ee6c5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":496,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:28:13
31436	9d694bd4-8af9-45b8-81e1-128fdc3a6f74	9d694bd4-c4a2-4510-9f39-9ca2c7206c22	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 16:28:13
31437	9d694bd4-b7db-4309-b396-d1343eb923ce	9d694bd4-c4a2-4510-9f39-9ca2c7206c22	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"80.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 16:28:13
31438	9d694bd4-bc52-4016-ba4e-7f0bab4b68e5	9d694bd4-c4a2-4510-9f39-9ca2c7206c22	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" inner join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '92' order by \\"item_loans\\".\\"id\\" asc","time":"3.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":304,"hash":"ac513f13416666eb3a5127ebc04741a7","hostname":"EderCortes"}	2024-11-04 16:28:13
31439	9d694bd4-c26f-40b1-8ccb-7795d84933b9	9d694bd4-c4a2-4510-9f39-9ca2c7206c22	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 16:28:13
31440	9d694bd4-c302-4485-94f3-e054dcb6f25e	9d694bd4-c4a2-4510-9f39-9ca2c7206c22	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":92,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":15,"loans_valor_prestado":8000009,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"533333.93333333","loans_pago_interes":"133333.48333333","user_alias":"eder.cortes"},"items":[{"id":379,"loans_codigo":92,"itemloans_cuota":"1","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:13:07","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":380,"loans_codigo":92,"itemloans_cuota":"2","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":381,"loans_codigo":92,"itemloans_cuota":"3","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":382,"loans_codigo":92,"itemloans_cuota":"4","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":383,"loans_codigo":92,"itemloans_cuota":"5","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":384,"loans_codigo":92,"itemloans_cuota":"6","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":385,"loans_codigo":92,"itemloans_cuota":"7","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":386,"loans_codigo":92,"itemloans_cuota":"8","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":387,"loans_codigo":92,"itemloans_cuota":"9","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-15 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":388,"loans_codigo":92,"itemloans_cuota":"10","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":389,"loans_codigo":92,"itemloans_cuota":"11","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-31 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":390,"loans_codigo":92,"itemloans_cuota":"12","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":391,"loans_codigo":92,"itemloans_cuota":"13","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-16 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":392,"loans_codigo":92,"itemloans_cuota":"14","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":393,"loans_codigo":92,"itemloans_cuota":"15","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":523,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:28:13
27188	9d68e2b5-96bd-433c-a791-fa1b44fe9a81	9d68e2b5-d64e-4164-9409-c84f5121ad37	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:34:17
27189	9d68e2b5-d363-4f86-a82c-77841ecc8f66	9d68e2b5-d64e-4164-9409-c84f5121ad37	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:34:17
27190	9d68e2b5-d4b8-4785-bd9b-f6aa952ede4b	9d68e2b5-d64e-4164-9409-c84f5121ad37	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":649,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:34:17
31441	9d694bd5-7e0f-4c68-9f62-e869715b1950	9d694bd6-23ed-45fc-8987-fe38450cc391	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 16:28:14
31442	9d694bd6-14e0-41ba-a82e-ae5a0d27c580	9d694bd6-23ed-45fc-8987-fe38450cc391	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"272.86","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:28:14
31443	9d694bd6-15a2-47c5-9ea5-c980323bfe50	9d694bd6-23ed-45fc-8987-fe38450cc391	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:28:14
31444	9d694bd6-21af-46fc-a3cb-7dcc4b334d06	9d694bd6-23ed-45fc-8987-fe38450cc391	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 16:28:14
27191	9d68e2b6-a8b2-493a-a331-1d0dd76fbf35	9d68e2b6-d533-4c07-be91-f73207b8ae96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:34:17
27192	9d68e2b6-cbc3-44c4-bd55-b413ecca3179	9d68e2b6-d533-4c07-be91-f73207b8ae96	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"53.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:34:17
27193	9d68e2b6-cc55-4e0a-913f-2660e58b556f	9d68e2b6-d533-4c07-be91-f73207b8ae96	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:34:17
27194	9d68e2b6-d327-4ec6-a6c6-90b57298fd16	9d68e2b6-d533-4c07-be91-f73207b8ae96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:34:17
25823	9d68c9e7-2e24-48fb-84c6-967b0c7bca37	9d68c9e7-5b5e-47a3-a3ad-eb19f255b3db	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 10:24:55
25824	9d68c9e7-5868-4dd0-a445-229c5719adfe	9d68c9e7-5b5e-47a3-a3ad-eb19f255b3db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:24:55
25825	9d68c9e7-59b1-4747-831e-e8700c1e7bde	9d68c9e7-5b5e-47a3-a3ad-eb19f255b3db	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":522,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:24:55
27195	9d68e2b6-d3bb-4007-b1dd-b410938e859d	9d68e2b6-d533-4c07-be91-f73207b8ae96	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":562,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:34:17
31445	9d694bd6-2233-41f0-8b00-53aad72b96e6	9d694bd6-23ed-45fc-8987-fe38450cc391	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":883,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:28:14
29188	9d69136a-b524-489f-9cd9-bd4c5feff1ad	9d69136b-1b1e-4a04-ae50-f8b81687bf88	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 13:50:28
29189	9d69136b-180b-4a57-94e3-1203e1cfcce3	9d69136b-1b1e-4a04-ae50-f8b81687bf88	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 13:50:29
29190	9d69136b-1987-4828-ab98-69bab87d2f4d	9d69136b-1b1e-4a04-ae50-f8b81687bf88	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":582,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:50:29
25826	9d68c9e8-04f4-4e61-8d6e-0d04103be74d	9d68c9e8-29db-4509-a243-f77dbc82e095	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 10:24:55
25827	9d68c9e8-1e8d-43d6-8ab0-e7eaeb17c755	9d68c9e8-29db-4509-a243-f77dbc82e095	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"49.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:24:55
25828	9d68c9e8-22b9-4802-a6c8-f50a637c107f	9d68c9e8-29db-4509-a243-f77dbc82e095	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:24:55
25829	9d68c9e8-22fb-452d-86d5-02440f88d6a6	9d68c9e8-29db-4509-a243-f77dbc82e095	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:24:55
25830	9d68c9e8-285e-4738-9597-5335b7b9cc16	9d68c9e8-29db-4509-a243-f77dbc82e095	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:24:55
25831	9d68c9e8-28cd-4ebb-a6bd-50023ed25359	9d68c9e8-29db-4509-a243-f77dbc82e095	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":468,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:24:55
27196	9d68e2b7-84aa-4d93-bff8-166d6e3ac96d	9d68e2b7-db56-4688-9142-e4407efa495c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:34:18
27197	9d68e2b7-d270-4c2c-9c58-9f106d4b18b4	9d68e2b7-db56-4688-9142-e4407efa495c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"165.01","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:34:18
27198	9d68e2b7-d2f2-47eb-9c3b-6201c164b579	9d68e2b7-db56-4688-9142-e4407efa495c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 11:34:18
27199	9d68e2b7-d982-4919-b666-bf6a9316c6b7	9d68e2b7-db56-4688-9142-e4407efa495c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:34:18
27200	9d68e2b7-d9fc-4da4-8763-2d9ed49a5faa	9d68e2b7-db56-4688-9142-e4407efa495c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":641,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:34:18
29191	9d69136d-3e32-46b6-bea4-f31b5ac2c938	9d69136d-c9d5-47ab-8c0c-62e49b26d5cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 13:50:30
29192	9d69136d-bfe5-4708-8a0a-ccb0b3534384	9d69136d-c9d5-47ab-8c0c-62e49b26d5cd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"93.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:50:30
29193	9d69136d-c074-44c8-a3ad-8490dc7fdbc5	9d69136d-c9d5-47ab-8c0c-62e49b26d5cd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:50:30
29194	9d69136d-c7ad-451c-90a6-7869b1e12163	9d69136d-c9d5-47ab-8c0c-62e49b26d5cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 13:50:30
27201	9d68e2b8-aca2-49b1-944f-03517163d30e	9d68e2b8-f02f-43c1-8d5a-db340d513278	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:34:19
27202	9d68e2b8-e51e-4371-b5de-9d842bd91ee1	9d68e2b8-f02f-43c1-8d5a-db340d513278	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"98.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:34:19
27203	9d68e2b8-e5fd-4e4d-9cbc-0c0a05c7158f	9d68e2b8-f02f-43c1-8d5a-db340d513278	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:34:19
27204	9d68e2b8-ee11-446e-b75d-b4af65a85d1d	9d68e2b8-f02f-43c1-8d5a-db340d513278	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:34:19
27205	9d68e2b8-eea6-4b55-b1b3-1804d3d156f5	9d68e2b8-f02f-43c1-8d5a-db340d513278	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":681,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:34:19
29195	9d69136d-c849-4f77-ac29-92c221dbca9d	9d69136d-c9d5-47ab-8c0c-62e49b26d5cd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1250,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:50:30
31446	9d694bd6-ff5a-4b6f-9e5b-cc40f5a32fbd	9d694bd7-3c49-4cb9-a56a-4dd7d6142cc0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 16:28:15
31447	9d694bd7-31a5-4299-a8dc-49b276e709ae	9d694bd7-3c49-4cb9-a56a-4dd7d6142cc0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"81.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:28:15
31448	9d694bd7-3245-4de2-94f3-67b9017f2128	9d694bd7-3c49-4cb9-a56a-4dd7d6142cc0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:28:15
31449	9d694bd7-3a3c-4264-80f7-059263a3b300	9d694bd7-3c49-4cb9-a56a-4dd7d6142cc0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 16:28:15
31450	9d694bd7-3ac8-499e-9b5e-a4e203b86ceb	9d694bd7-3c49-4cb9-a56a-4dd7d6142cc0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":548,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:28:15
27206	9d68e2b9-f663-4200-bba2-48f53087bd9b	9d68e2ba-1c76-4390-aeb4-1662d64bdd97	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:34:19
27207	9d68e2ba-1673-4bbb-afe7-5527fbb90425	9d68e2ba-1c76-4390-aeb4-1662d64bdd97	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"49.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:34:20
27208	9d68e2ba-16e1-47b9-812f-d7f5d7433784	9d68e2ba-1c76-4390-aeb4-1662d64bdd97	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:34:20
27209	9d68e2ba-1ae4-4584-9b0b-0db47d920658	9d68e2ba-1c76-4390-aeb4-1662d64bdd97	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:34:20
27210	9d68e2ba-1b38-4a66-82cf-4b80b45e2539	9d68e2ba-1c76-4390-aeb4-1662d64bdd97	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":742,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:34:20
29196	9d69136e-c4c3-4e6d-b02e-2d14d1c391fa	9d69136f-0b40-4d7a-bde4-dc97d35c969c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 13:50:31
29197	9d69136f-01d6-4f2b-8e62-e29b40df59b0	9d69136f-0b40-4d7a-bde4-dc97d35c969c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"95.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:50:31
29198	9d69136f-0277-471f-ae52-1e31839b9081	9d69136f-0b40-4d7a-bde4-dc97d35c969c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:50:31
29199	9d69136f-0905-4945-8a47-79fad372636d	9d69136f-0b40-4d7a-bde4-dc97d35c969c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 13:50:31
29200	9d69136f-0997-4e02-988d-266663add4a2	9d69136f-0b40-4d7a-bde4-dc97d35c969c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":791,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:50:31
31353	9d694aa8-de44-4858-8149-8e4b80d2ec86	9d694aa8-fc7f-49c6-a97a-3a22a5357e34	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:24:57
31354	9d694aa8-faed-41a8-916a-54fe82e7d710	9d694aa8-fc7f-49c6-a97a-3a22a5357e34	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:24:57
31355	9d694aa8-fb8c-4b4b-8c5c-cc62687ebc0f	9d694aa8-fc7f-49c6-a97a-3a22a5357e34	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:24:57
36132	9d6b32ab-aa19-4334-b9d0-a0b728b354f6	9d6b32ac-df83-4bc9-92e1-6f3169c280a3	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 15:09:31
36133	9d6b32ac-dd40-4c32-b79f-0714e8efe19f	9d6b32ac-df83-4bc9-92e1-6f3169c280a3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:09:32
36134	9d6b32ac-de15-41f0-83dd-3ffd989065d3	9d6b32ac-df83-4bc9-92e1-6f3169c280a3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1030,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:09:32
29240	9d6913fc-5918-4a74-88f2-81fbadfe9fd0	9d6913fc-a24b-4a92-b47c-251380f3104c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 13:52:04
29241	9d6913fc-a095-4e02-9b59-4fc646ee038b	9d6913fc-a24b-4a92-b47c-251380f3104c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 13:52:04
29242	9d6913fc-a14e-486f-a811-8b80376cee03	9d6913fc-a24b-4a92-b47c-251380f3104c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:52:04
29243	9d6913fc-fabf-489f-9b9c-0b1012d36e3a	9d6913fd-4117-43fa-a611-a7a5694df772	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 13:52:04
29244	9d6913fd-3777-4768-8248-5cf9a7a47492	9d6913fd-4117-43fa-a611-a7a5694df772	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"142.11","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 13:52:04
29245	9d6913fd-3b4c-4bfe-97f4-b21927e73948	9d6913fd-4117-43fa-a611-a7a5694df772	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:52:04
29246	9d6913fd-3b81-4f2b-b6e3-6eba3b3ac41f	9d6913fd-4117-43fa-a611-a7a5694df772	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:52:04
29247	9d6913fd-3fd8-4586-9e70-9def2c67fad8	9d6913fd-4117-43fa-a611-a7a5694df772	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 13:52:04
29248	9d6913fd-4026-436b-a441-8a427ae65688	9d6913fd-4117-43fa-a611-a7a5694df772	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:52:04
36135	9d6b32ad-9425-424a-b0fc-1f8cbac714dc	9d6b32ad-b1a1-4267-b610-84d093f021e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:09:32
36136	9d6b32ad-ac38-4a4b-96cb-12a5fa54f0af	9d6b32ad-b1a1-4267-b610-84d093f021e7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"42.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:09:33
36137	9d6b32ad-b007-40cd-a1cf-fbab222e3e2d	9d6b32ad-b1a1-4267-b610-84d093f021e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:09:33
36138	9d6b32ad-b07b-49c8-bf64-b8224b6e2c45	9d6b32ad-b1a1-4267-b610-84d093f021e7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":306,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:09:33
36139	9d6b32ae-2c0f-4cc3-9300-6151d68f8940	9d6b32ae-5975-4bca-961e-21b0d63052d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:09:33
36140	9d6b32ae-5173-4615-9fec-91751db4ecda	9d6b32ae-5975-4bca-961e-21b0d63052d1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"53.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:09:33
27294	9d68e3d9-8966-4fc3-8fd2-b8f0773c4e90	9d68e3d9-d23d-4dec-92ed-a92954df556a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:37:28
27295	9d68e3d9-cf01-4e49-9229-31584c69a0b3	9d68e3d9-d23d-4dec-92ed-a92954df556a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:37:28
27296	9d68e3d9-d0bd-4ced-a2be-504bd1a549d5	9d68e3d9-d23d-4dec-92ed-a92954df556a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":716,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:37:28
36141	9d6b32ae-51eb-4bda-a8ea-f37f670e5f1b	9d6b32ae-5975-4bca-961e-21b0d63052d1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:09:33
36142	9d6b32ae-57f7-4c0a-bb1c-9c180d8d646f	9d6b32ae-5975-4bca-961e-21b0d63052d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:09:33
36143	9d6b32ae-5862-47f6-bdff-d8b75127422d	9d6b32ae-5975-4bca-961e-21b0d63052d1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":419,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:09:33
314	9d4f23f3-4603-4340-9164-73bcc9b4723a	9d4f23f3-b33b-496a-b21b-bf158265c7b0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42P01]: Undefined table: 7 ERROR:  falta una entrada para la tabla \\u00abid, menu\\u00bb en la cl\\u00e1usula FROM\\nLINE 1: select \\"menu\\".\\"id, menu\\".\\"menu_name\\" from \\"menu\\" inner join ...\\n               ^ (Connection: pgsql, SQL: select \\"menu\\".\\"id, menu\\".\\"menu_name\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":44},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":18}	2024-10-22 16:25:11
27297	9d68e3da-fe51-4c89-a082-63c302605e27	9d68e3db-27bb-4ca6-a9c9-31f936d9ce30	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:37:29
27298	9d68e3db-1bfb-450d-8852-a3164ad76f21	9d68e3db-27bb-4ca6-a9c9-31f936d9ce30	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"56.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:37:29
27299	9d68e3db-20a2-4220-8c75-e4a133b4e7af	9d68e3db-27bb-4ca6-a9c9-31f936d9ce30	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:37:29
27300	9d68e3db-20f1-4669-ad99-20c44db3ded2	9d68e3db-27bb-4ca6-a9c9-31f936d9ce30	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:37:29
27301	9d68e3db-25f1-4c9b-a994-26bcbbcd87cb	9d68e3db-27bb-4ca6-a9c9-31f936d9ce30	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:37:29
27302	9d68e3db-266e-4183-80e9-70504216bbc4	9d68e3db-27bb-4ca6-a9c9-31f936d9ce30	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":783,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:37:29
36144	9d6b32ae-b74f-4034-b443-d430604f54b2	9d6b32ae-d71b-4625-af44-3660ea06c661	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:09:33
31579	9d695181-1823-4ce0-aff4-2c495c97f22c	9d695181-619c-4db0-8c43-9092f073bce2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:44:05
31580	9d695181-5c96-4b98-8fc0-5631eab8be6d	9d695181-619c-4db0-8c43-9092f073bce2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:44:05
31581	9d695181-5f5c-4525-9b0a-d957ccc2a504	9d695181-619c-4db0-8c43-9092f073bce2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":559,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:44:05
36145	9d6b32ae-d1f0-47ef-9ecb-cdfb986f10c1	9d6b32ae-d71b-4625-af44-3660ea06c661	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:09:33
36146	9d6b32ae-d24d-46a1-8f38-e71de57e11c4	9d6b32ae-d71b-4625-af44-3660ea06c661	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:09:33
36147	9d6b32ae-d5dd-40cf-b91e-a234fd19188e	9d6b32ae-d71b-4625-af44-3660ea06c661	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:09:33
36148	9d6b32ae-d61c-4b99-9704-d059334a821d	9d6b32ae-d71b-4625-af44-3660ea06c661	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":302,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:09:33
27303	9d68e3dc-0596-4658-adf2-8b2ea36bfc9e	9d68e3dc-43ab-4ab6-b0bf-8529582b656c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:37:30
27304	9d68e3dc-394c-4260-afb2-e837987b3e14	9d68e3dc-43ab-4ab6-b0bf-8529582b656c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"87.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:37:30
27305	9d68e3dc-39ec-4bfb-9461-913e0bbf3c6d	9d68e3dc-43ab-4ab6-b0bf-8529582b656c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:37:30
27306	9d68e3dc-4188-42f3-b0bd-85fe240d582f	9d68e3dc-43ab-4ab6-b0bf-8529582b656c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:37:30
27307	9d68e3dc-4219-4915-b56f-6afc5396e9ec	9d68e3dc-43ab-4ab6-b0bf-8529582b656c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":703,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:37:30
31582	9d695182-2b2d-409a-ab0c-8c3ad8dcb01f	9d695182-7244-498a-a02d-2205843fae48	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:44:06
31583	9d695182-635d-4059-a343-2d6c520dce9d	9d695182-7244-498a-a02d-2205843fae48	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"104.53","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 16:44:06
31584	9d695182-685a-4931-8371-5050e1f0713b	9d695182-7244-498a-a02d-2205843fae48	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '92' order by \\"item_loans\\".\\"id\\" asc","time":"4.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 16:44:06
31585	9d695182-7022-4c4a-b057-a4e8d1ef7539	9d695182-7244-498a-a02d-2205843fae48	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:44:06
31586	9d695182-70c6-4aba-affc-80b70629c490	9d695182-7244-498a-a02d-2205843fae48	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":92,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":15,"loans_valor_prestado":8000009,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"533333.93333333","loans_pago_interes":"133333.48333333","user_alias":"eder.cortes"},"items":[{"id":379,"loans_codigo":92,"itemloans_cuota":"1","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:13:07","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":null},{"id":380,"loans_codigo":92,"itemloans_cuota":"2","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":381,"loans_codigo":92,"itemloans_cuota":"3","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":382,"loans_codigo":92,"itemloans_cuota":"4","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":383,"loans_codigo":92,"itemloans_cuota":"5","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":384,"loans_codigo":92,"itemloans_cuota":"6","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":385,"loans_codigo":92,"itemloans_cuota":"7","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":386,"loans_codigo":92,"itemloans_cuota":"8","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":387,"loans_codigo":92,"itemloans_cuota":"9","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-15 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":388,"loans_codigo":92,"itemloans_cuota":"10","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":389,"loans_codigo":92,"itemloans_cuota":"11","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-31 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":390,"loans_codigo":92,"itemloans_cuota":"12","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":391,"loans_codigo":92,"itemloans_cuota":"13","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-16 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":392,"loans_codigo":92,"itemloans_cuota":"14","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":393,"loans_codigo":92,"itemloans_cuota":"15","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":583,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:44:06
36149	9d6b32b0-2507-4f65-9137-9bba2bf0d415	9d6b32b0-41f7-4dac-836d-74ba71064694	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:09:34
36150	9d6b32b0-3cbd-4b9f-a881-8497a45fd5a7	9d6b32b0-41f7-4dac-836d-74ba71064694	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:09:34
27308	9d68e3dc-f1b2-4055-96cd-92d6e28b33ca	9d68e3dd-2380-4dca-b048-fcfc7f86e36c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:37:30
27309	9d68e3dd-19f6-48c0-aafb-c9c3e6d69bbe	9d68e3dd-2380-4dca-b048-fcfc7f86e36c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"64.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:37:30
27310	9d68e3dd-1a7d-48f9-95e5-06f66b095f3b	9d68e3dd-2380-4dca-b048-fcfc7f86e36c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:37:30
27311	9d68e3dd-2174-463a-86bc-8afd7b09ddc1	9d68e3dd-2380-4dca-b048-fcfc7f86e36c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:37:30
27312	9d68e3dd-2205-4b09-94da-bd6679e87531	9d68e3dd-2380-4dca-b048-fcfc7f86e36c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":547,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:37:30
31587	9d695183-2be6-4551-8e54-8439f4812279	9d695183-d915-42b0-bb52-1a9c21de7ba5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:44:06
31588	9d695183-b200-4ac3-b22d-a320dc1eef1e	9d695183-d915-42b0-bb52-1a9c21de7ba5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"237.39","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:44:07
31589	9d695183-b2b3-4e4e-aad3-2261a81b6775	9d695183-d915-42b0-bb52-1a9c21de7ba5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:44:07
31590	9d695183-c85f-4cd9-bad0-c50ecf655e6d	9d695183-d915-42b0-bb52-1a9c21de7ba5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:44:07
31591	9d695183-d434-4893-b561-1635d888e7f3	9d695183-d915-42b0-bb52-1a9c21de7ba5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":878,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:44:07
36151	9d6b32b0-3d05-4cc0-875e-19c8457ec916	9d6b32b0-41f7-4dac-836d-74ba71064694	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:09:34
36152	9d6b32b0-4092-41e3-8b1f-525865e87379	9d6b32b0-41f7-4dac-836d-74ba71064694	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:09:34
36153	9d6b32b0-40d4-4a73-a607-793721a61796	9d6b32b0-41f7-4dac-836d-74ba71064694	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:09:34
31592	9d695185-30a3-4a15-a07f-93c89bdf1825	9d695185-6358-4622-9ad0-f41bf315772b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:44:08
31593	9d695185-58ba-4645-b1e0-d8c8d1f40047	9d695185-6358-4622-9ad0-f41bf315772b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"59.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:44:08
31594	9d695185-5ad3-4169-9b8d-c81020194b9c	9d695185-6358-4622-9ad0-f41bf315772b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:44:08
31595	9d695185-6146-453f-ae1b-f0ed08b59e3d	9d695185-6358-4622-9ad0-f41bf315772b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 16:44:08
31596	9d695185-61d4-4f4f-b91b-c49b5d4ee10c	9d695185-6358-4622-9ad0-f41bf315772b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":633,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:44:08
36454	9d6b3a66-759e-4ca1-a3f9-bf3cc0d60a93	9d6b3a66-9452-4be4-aa0a-eefe9548f519	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:31:08
36455	9d6b3a66-9295-4f53-8cbe-79bb562edf1d	9d6b3a66-9452-4be4-aa0a-eefe9548f519	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:31:08
36456	9d6b3a66-933a-4670-8a30-3a6bc9afbfdc	9d6b3a66-9452-4be4-aa0a-eefe9548f519	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":410,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:31:08
36457	9d6b3a66-f620-4448-80f5-89804b9da580	9d6b3a67-3b2b-4dc2-ba99-600e9d63a696	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:31:08
36458	9d6b3a67-3694-410c-bb78-b76c2741598b	9d6b3a67-3b2b-4dc2-ba99-600e9d63a696	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"146.22","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:31:09
36459	9d6b3a67-39b8-463c-b732-b0679a902a76	9d6b3a67-3b2b-4dc2-ba99-600e9d63a696	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:31:09
36460	9d6b3a67-3a29-4525-8010-07b610a14556	9d6b3a67-3b2b-4dc2-ba99-600e9d63a696	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":360,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:31:09
36461	9d6b3a67-a5f4-44cb-a1ab-52ad8463ae81	9d6b3a67-c4ba-469d-90a2-c01007f752e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:31:09
36462	9d6b3a67-bf25-4f67-8be8-942df7b3c097	9d6b3a67-c4ba-469d-90a2-c01007f752e8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:31:09
36463	9d6b3a67-bf83-40c7-b033-b7233965ba36	9d6b3a67-c4ba-469d-90a2-c01007f752e8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:31:09
36464	9d6b3a67-c37c-4431-aa50-2de6cd0acdb2	9d6b3a67-c4ba-469d-90a2-c01007f752e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:31:09
36465	9d6b3a67-c3d1-407e-af12-ef8977aa34e1	9d6b3a67-c4ba-469d-90a2-c01007f752e8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":331,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:31:09
29389	9d692447-bfa9-43d9-a355-c8a6db7f2de9	9d692447-e57e-48a7-8501-c71d0ba7d986	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 14:37:38
29390	9d692447-e357-4b08-831b-5b07109d0d96	9d692447-e57e-48a7-8501-c71d0ba7d986	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 14:37:38
29391	9d692447-e449-4c71-8562-765363e4e65d	9d692447-e57e-48a7-8501-c71d0ba7d986	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":334,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:37:38
36466	9d6b3a68-0b10-41be-92f1-8b0e196f9d24	9d6b3a68-2950-4bb1-be58-7b1d9575b520	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:31:09
36467	9d6b3a68-240a-450c-8db8-2fd0d12b042c	9d6b3a68-2950-4bb1-be58-7b1d9575b520	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"38.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:31:09
36468	9d6b3a68-245b-407b-b6d7-1a8376a9cc42	9d6b3a68-2950-4bb1-be58-7b1d9575b520	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:31:09
36469	9d6b3a68-2816-4736-9aea-fd4060073138	9d6b3a68-2950-4bb1-be58-7b1d9575b520	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:31:09
36470	9d6b3a68-2857-4020-9775-92628dc5a2f0	9d6b3a68-2950-4bb1-be58-7b1d9575b520	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:31:09
29392	9d692448-4902-42a1-8a57-d36ede063b51	9d692448-69ed-44a7-9d80-b1a093756c5d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 14:37:38
29393	9d692448-5f52-4af5-b960-8c59c2dca896	9d692448-69ed-44a7-9d80-b1a093756c5d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"43.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 14:37:38
29394	9d692448-635d-4493-9e1e-fb7893f549d6	9d692448-69ed-44a7-9d80-b1a093756c5d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"1.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 14:37:38
29395	9d692448-639d-40a7-bcf2-51cef8ad36d0	9d692448-69ed-44a7-9d80-b1a093756c5d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 14:37:38
29396	9d692448-68e1-48ed-8094-98289a76a28f	9d692448-69ed-44a7-9d80-b1a093756c5d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 14:37:38
29397	9d692448-6928-4183-9f5f-2e661283e1a3	9d692448-69ed-44a7-9d80-b1a093756c5d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":284,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:37:38
36471	9d6b3a68-f1a6-4662-baa7-fad9a5869187	9d6b3a69-1172-48bf-ad6b-b11cc924acc6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:31:10
36472	9d6b3a69-0bca-440a-afca-8154527032a6	9d6b3a69-1172-48bf-ad6b-b11cc924acc6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:31:10
36473	9d6b3a69-0c21-4725-8364-aff8f68131a1	9d6b3a69-1172-48bf-ad6b-b11cc924acc6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:31:10
36474	9d6b3a69-1012-42bc-a56d-224195cf2910	9d6b3a69-1172-48bf-ad6b-b11cc924acc6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 15:31:10
36475	9d6b3a69-105f-41b8-b5ce-009fdd27a2d3	9d6b3a69-1172-48bf-ad6b-b11cc924acc6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":294,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:31:10
31703	9d6954a8-a65c-49c6-88b2-b27cbd2e960e	9d6954a9-049b-42f7-8176-09cb2734b530	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:52:54
31704	9d6954a9-0181-4f13-af40-bf45eb9608cc	9d6954a9-049b-42f7-8176-09cb2734b530	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 16:52:54
31705	9d6954a9-02bc-4775-a9e4-0a3747be397c	9d6954a9-049b-42f7-8176-09cb2734b530	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1022,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:52:54
31706	9d6954a9-8cad-44ef-a09f-00168ff15b2c	9d6954a9-ac45-4a33-8543-551ba2162733	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 16:52:55
31707	9d6954a9-a6d1-442e-90c1-2c8c7946b8a1	9d6954a9-ac45-4a33-8543-551ba2162733	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:52:55
31708	9d6954a9-a729-49b7-8e2e-2bf7d47a401c	9d6954a9-ac45-4a33-8543-551ba2162733	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 16:52:55
31709	9d6954a9-aae9-4bc3-9f27-6e35fcbe2671	9d6954a9-ac45-4a33-8543-551ba2162733	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 16:52:55
31710	9d6954a9-ab44-4f6b-b265-ca9bbd3720ca	9d6954a9-ac45-4a33-8543-551ba2162733	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":352,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:52:55
36293	9d6b33fa-6ce0-418f-b408-2cee1eef6eb6	9d6b33fa-a764-4fa9-b46c-f7f544af2b84	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:13:11
31711	9d6954a9-f571-4cbf-afe1-452c38aca645	9d6954aa-1600-4b97-923d-a0f893db9df2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 16:52:55
31712	9d6954aa-0ea1-4e44-849e-7b94fd48fd33	9d6954aa-1600-4b97-923d-a0f893db9df2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:52:55
25983	9d68cc28-692e-4e4d-beed-b72d25648d75	9d68cc28-d32c-4335-a800-4aff5fef8678	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 10:31:13
25984	9d68cc28-cce2-4f7b-b29e-ae3028332854	9d68cc28-d32c-4335-a800-4aff5fef8678	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 10:31:13
25985	9d68cc28-ce8a-4a07-bbd7-e732d623c650	9d68cc28-d32c-4335-a800-4aff5fef8678	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":791,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:31:13
31713	9d6954aa-0f04-4e7d-8121-2e78c1d7cb9e	9d6954aa-1600-4b97-923d-a0f893db9df2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 16:52:55
31714	9d6954aa-1482-4f08-83c9-96b715160f09	9d6954aa-1600-4b97-923d-a0f893db9df2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 16:52:55
31715	9d6954aa-14f1-453f-8ca6-319c019de1c7	9d6954aa-1600-4b97-923d-a0f893db9df2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":257,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:52:55
36294	9d6b33fa-a449-4ff0-91b6-ffa7bb8e9506	9d6b33fa-a764-4fa9-b46c-f7f544af2b84	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 15:13:11
36295	9d6b33fa-a5e4-4fba-925c-bfec669f2a89	9d6b33fa-a764-4fa9-b46c-f7f544af2b84	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":424,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:13:11
25986	9d68cc29-9f0f-4251-8628-abc8da0a01e9	9d68cc29-c8b1-4e54-9a95-1774ab91faea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 10:31:14
25987	9d68cc29-bb42-4f4e-b894-35df703207b3	9d68cc29-c8b1-4e54-9a95-1774ab91faea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"48.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:31:14
25988	9d68cc29-bfeb-482b-9968-928b19fd0333	9d68cc29-c8b1-4e54-9a95-1774ab91faea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"3.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:31:14
25989	9d68cc29-c03f-4c7e-989f-fd6312166419	9d68cc29-c8b1-4e54-9a95-1774ab91faea	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:31:14
25990	9d68cc29-c701-4510-8da6-52e770f4b2c9	9d68cc29-c8b1-4e54-9a95-1774ab91faea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 10:31:14
25991	9d68cc29-c776-4782-ab9b-530362903dfe	9d68cc29-c8b1-4e54-9a95-1774ab91faea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":503,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:31:14
36296	9d6b33fb-31be-4b92-8510-46418e2389da	9d6b33fb-7bc7-4840-bcaf-0aafc7c4cf14	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 15:13:11
36297	9d6b33fb-76ea-4915-acbe-40f24cdf0789	9d6b33fb-7bc7-4840-bcaf-0aafc7c4cf14	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"156.26","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:13:11
36298	9d6b33fb-7a32-477d-b97f-efdefad63b25	9d6b33fb-7bc7-4840-bcaf-0aafc7c4cf14	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 15:13:11
36299	9d6b33fb-7aad-41c8-b3be-83d9fe54bd67	9d6b33fb-7bc7-4840-bcaf-0aafc7c4cf14	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":461,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:13:11
25992	9d68cc2a-9b83-4cc3-8399-ecde94441945	9d68cc2a-ff97-44d9-afe4-a214fc555be8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 10:31:15
25993	9d68cc2a-f5c7-4145-ad9c-dcf06c14fc77	9d68cc2a-ff97-44d9-afe4-a214fc555be8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"170.36","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:31:15
25994	9d68cc2a-f64b-471e-a7a9-6d2b9d694c1f	9d68cc2a-ff97-44d9-afe4-a214fc555be8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:31:15
25995	9d68cc2a-fd74-4f5a-a02e-fb65c1bedfcf	9d68cc2a-ff97-44d9-afe4-a214fc555be8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 10:31:15
25996	9d68cc2a-fe0f-4131-81b6-59fe23a3a284	9d68cc2a-ff97-44d9-afe4-a214fc555be8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":775,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:31:15
36300	9d6b33fb-e6ba-41e6-9520-3a05a7e78022	9d6b33fc-0c85-41da-b424-29c768688b02	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 15:13:12
36301	9d6b33fc-04d9-4e8b-9aeb-1eac91eb2e6e	9d6b33fc-0c85-41da-b424-29c768688b02	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"52.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:13:12
36302	9d6b33fc-0560-4f75-a296-255c209c89e2	9d6b33fc-0c85-41da-b424-29c768688b02	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:13:12
36303	9d6b33fc-0a99-429b-ac8b-3dd6439f8cdd	9d6b33fc-0c85-41da-b424-29c768688b02	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 15:13:12
36304	9d6b33fc-0b10-499d-811b-6508a653c445	9d6b33fc-0c85-41da-b424-29c768688b02	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:13:12
25997	9d68cc2b-ac40-4c65-91b0-23e35577be5f	9d68cc2b-dddb-44e5-96fe-afe426d8d793	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 10:31:15
25998	9d68cc2b-d4a9-4cf6-ad76-a1b1e60ebf57	9d68cc2b-dddb-44e5-96fe-afe426d8d793	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"64.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:31:15
25999	9d68cc2b-d52f-4ef2-8d4f-cb75e066b882	9d68cc2b-dddb-44e5-96fe-afe426d8d793	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:31:15
26000	9d68cc2b-db05-45d6-be6e-c30de2b96ac5	9d68cc2b-dddb-44e5-96fe-afe426d8d793	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 10:31:15
26001	9d68cc2b-dba0-4bbd-a2ef-a0cf5659abb3	9d68cc2b-dddb-44e5-96fe-afe426d8d793	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":541,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:31:15
36305	9d6b33fc-5f6d-46af-9621-b7717dd07ef3	9d6b33fc-813a-4982-a4da-d9074056b6af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 15:13:12
36306	9d6b33fc-7b49-4442-8a64-c585f8a26a26	9d6b33fc-813a-4982-a4da-d9074056b6af	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:13:12
36307	9d6b33fc-7b9c-44cf-9c7c-0196c9690683	9d6b33fc-813a-4982-a4da-d9074056b6af	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:13:12
36308	9d6b33fc-7fa0-4050-9875-c60f7e5fc5e8	9d6b33fc-813a-4982-a4da-d9074056b6af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 15:13:12
36309	9d6b33fc-7ff2-458e-9664-f18f1d9b42a2	9d6b33fc-813a-4982-a4da-d9074056b6af	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":281,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:13:12
36310	9d6b33fe-d0ea-4eaa-aea9-c68e1070d6ca	9d6b33fe-f4af-4e6f-9a72-9fbc23b9d5aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 15:13:13
36311	9d6b33fe-eebb-4e32-a18e-4d7f67cdd3ac	9d6b33fe-f4af-4e6f-9a72-9fbc23b9d5aa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"52.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:13:14
36312	9d6b33fe-ef1f-4550-98a3-d766568eef81	9d6b33fe-f4af-4e6f-9a72-9fbc23b9d5aa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:13:14
36313	9d6b33fe-f36f-4525-bf08-7442f5d2821b	9d6b33fe-f4af-4e6f-9a72-9fbc23b9d5aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 15:13:14
36314	9d6b33fe-f3c7-4832-8ac5-1ef9fa0268cd	9d6b33fe-f4af-4e6f-9a72-9fbc23b9d5aa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":869,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:13:14
36771	9d6b3fba-051d-4a04-a44f-e20d251ca701	9d6b3fba-4a65-4900-92b3-269b48dc005f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:46:02
36772	9d6b3fba-48cf-4d99-813a-4a9088304c84	9d6b3fba-4a65-4900-92b3-269b48dc005f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 15:46:02
36773	9d6b3fba-4965-4429-a69a-bd4bc4a8adef	9d6b3fba-4a65-4900-92b3-269b48dc005f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":379,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:46:02
36774	9d6b3fba-a2a8-492a-9cc7-7d904fc37263	9d6b3fba-bfcd-4360-a113-d502a1b093dc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 15:46:02
36775	9d6b3fba-bb41-41a6-9211-397dcb72bde0	9d6b3fba-bfcd-4360-a113-d502a1b093dc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"46.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:46:02
36776	9d6b3fba-be43-44b4-93ce-e20928924424	9d6b3fba-bfcd-4360-a113-d502a1b093dc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 15:46:02
36777	9d6b3fba-becb-4d87-b866-791aa620b4fb	9d6b3fba-bfcd-4360-a113-d502a1b093dc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:46:02
26093	9d68cd5c-bb41-4573-ad43-a69ac7e849b9	9d68cd5c-dce1-425a-acf8-ba45d7885550	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:34:35
26094	9d68cd5c-daf3-4787-b8f2-937c815cb856	9d68cd5c-dce1-425a-acf8-ba45d7885550	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:34:35
26095	9d68cd5c-dbcc-43a8-84f1-2dd735ef4f63	9d68cd5c-dce1-425a-acf8-ba45d7885550	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":395,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:34:35
36778	9d6b3fbb-0816-412c-9905-364279260a22	9d6b3fbb-5676-49e8-8a2a-de7bbccec07e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 15:46:02
36779	9d6b3fbb-5146-41e3-b56e-ae3542d8edb7	9d6b3fbb-5676-49e8-8a2a-de7bbccec07e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"160.12","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:46:03
36780	9d6b3fbb-51b1-4451-993c-6c1c5c85ce69	9d6b3fbb-5676-49e8-8a2a-de7bbccec07e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:46:03
36781	9d6b3fbb-5527-49ae-b955-1aed1517e462	9d6b3fbb-5676-49e8-8a2a-de7bbccec07e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 15:46:03
36782	9d6b3fbb-556a-4747-91a0-75d797d8b124	9d6b3fbb-5676-49e8-8a2a-de7bbccec07e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":370,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:46:03
26096	9d68cd5d-5f8b-4729-b2b4-3f95164a912f	9d68cd5d-adce-4d16-b2f5-43fd37d96108	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:34:36
26097	9d68cd5d-a292-450f-b9f4-8c9287e1f2e8	9d68cd5d-adce-4d16-b2f5-43fd37d96108	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 90\\n                        ","time":"158.84","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"93c10371e33ace24260de21c3ff3890d","hostname":"EderCortes"}	2024-11-04 10:34:36
26098	9d68cd5d-a73a-4aaa-9c56-bc9418c8e76a	9d68cd5d-adce-4d16-b2f5-43fd37d96108	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"2.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:34:36
26099	9d68cd5d-a790-45fd-ab9f-1c9e8f1f0a0e	9d68cd5d-adce-4d16-b2f5-43fd37d96108	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 10:34:36
26100	9d68cd5d-ac50-41d2-b5d5-61ed64aa21b9	9d68cd5d-adce-4d16-b2f5-43fd37d96108	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 10:34:36
26101	9d68cd5d-acad-4bfd-a5ec-19bdbe291c55	9d68cd5d-adce-4d16-b2f5-43fd37d96108	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"}]}},"duration":483,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:34:36
36783	9d6b3fbb-a497-445b-a8e6-807494dc7c26	9d6b3fbb-c4d5-4c9d-a590-93c1a58a0f0c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 15:46:03
36784	9d6b3fbb-bf9c-457c-ac7f-7361731a9a94	9d6b3fbb-c4d5-4c9d-a590-93c1a58a0f0c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:46:03
36785	9d6b3fbb-bff2-48b9-ada0-bf863eac5ba7	9d6b3fbb-c4d5-4c9d-a590-93c1a58a0f0c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:46:03
36786	9d6b3fbb-c3cc-4e8c-9900-71cd2268fb3c	9d6b3fbb-c4d5-4c9d-a590-93c1a58a0f0c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 15:46:03
36787	9d6b3fbb-c40f-4f96-9d4d-ce473f65aec5	9d6b3fbb-c4d5-4c9d-a590-93c1a58a0f0c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":261,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:46:03
40669	9d6cc669-e9da-48c0-a8aa-21dd4ce736fe	9d6cc669-eca7-4399-98c9-42d63226daad	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1839}	2024-11-06 09:58:28
36610	9d6b3dc3-3990-4cde-aeae-504b4d465ba7	9d6b3dc3-61b4-4217-a416-1f82d86afe5b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 15:40:32
36611	9d6b3dc3-5f7d-4b03-8f49-86604a5bd742	9d6b3dc3-61b4-4217-a416-1f82d86afe5b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:40:32
36612	9d6b3dc3-605c-4fd0-87e6-f7edf2794663	9d6b3dc3-61b4-4217-a416-1f82d86afe5b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":291,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:40:32
36613	9d6b3dc3-d7c7-47e0-b699-5cc876bb9cba	9d6b3dc3-f787-4392-895d-9dda1d91d497	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:40:33
36614	9d6b3dc3-f0d2-40e0-8baf-4524a19687e8	9d6b3dc3-f787-4392-895d-9dda1d91d497	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"48.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:40:33
36615	9d6b3dc3-f5bc-4567-a785-795ca3c92f18	9d6b3dc3-f787-4392-895d-9dda1d91d497	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:40:33
36616	9d6b3dc3-f643-4340-845b-a668f3409c5e	9d6b3dc3-f787-4392-895d-9dda1d91d497	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":321,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:40:33
36788	9d6b3fbd-5e29-4450-9377-bde1f845fd08	9d6b3fbd-9eea-4a3c-b0d1-f7b4aff8b9fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 15:46:04
36789	9d6b3fbd-993f-4648-a747-8aab4d723e69	9d6b3fbd-9eea-4a3c-b0d1-f7b4aff8b9fc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"69.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:46:04
36790	9d6b3fbd-998a-4760-8f48-d11429ffb031	9d6b3fbd-9eea-4a3c-b0d1-f7b4aff8b9fc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:46:04
36791	9d6b3fbd-9d64-4e30-a9ee-70ca53282203	9d6b3fbd-9eea-4a3c-b0d1-f7b4aff8b9fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 15:46:04
36792	9d6b3fbd-9dca-460c-ac78-93d21ef0a88c	9d6b3fbd-9eea-4a3c-b0d1-f7b4aff8b9fc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":557,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:46:04
34247	9d69bbf4-018c-45db-a42e-43d2f6f3dcc2	9d69bbf4-0736-43fb-9fe4-e04394c630a8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1557}	2024-11-04 21:41:44
29693	9d692a85-685f-4e26-9f66-d406e0e9c98d	9d692a85-9e9f-49ae-a1dc-42ad2b2cd404	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 14:55:05
29694	9d692a85-9bbe-4ee6-bed4-c69790ae3298	9d692a85-9e9f-49ae-a1dc-42ad2b2cd404	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 14:55:05
29695	9d692a85-9d38-4373-a6ff-1bd9e54b40df	9d692a85-9e9f-49ae-a1dc-42ad2b2cd404	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":455,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:55:05
29696	9d692a86-3113-4a2f-9567-b51fdc22d4c1	9d692a86-607c-44cf-b13d-e1bd48d0f297	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 14:55:05
29697	9d692a86-5762-4197-b985-dac7794b1441	9d692a86-607c-44cf-b13d-e1bd48d0f297	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"59.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":56,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 14:55:05
29698	9d692a86-57eb-48cd-a250-305aa306f00b	9d692a86-607c-44cf-b13d-e1bd48d0f297	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 14:55:05
29699	9d692a86-5e85-4781-be62-eef944868d2b	9d692a86-607c-44cf-b13d-e1bd48d0f297	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 14:55:05
29700	9d692a86-5f03-4bb9-a051-04d96ce694f7	9d692a86-607c-44cf-b13d-e1bd48d0f297	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":410,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:55:05
36617	9d6b3dc4-5ca0-4e92-9bd0-a03ec8220a47	9d6b3dc4-7d6d-4497-8fa2-91b07c5991c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:40:33
36618	9d6b3dc4-772d-42b5-8ff4-9e95cfa475f4	9d6b3dc4-7d6d-4497-8fa2-91b07c5991c5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:40:33
36619	9d6b3dc4-7791-43f5-9716-b9ac6ea24917	9d6b3dc4-7d6d-4497-8fa2-91b07c5991c5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:40:33
36620	9d6b3dc4-7bca-42b1-8963-8e3fa18d9431	9d6b3dc4-7d6d-4497-8fa2-91b07c5991c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:40:33
36621	9d6b3dc4-7c0e-442c-a0a3-c3a3c4fb11f3	9d6b3dc4-7d6d-4497-8fa2-91b07c5991c5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":326,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:40:33
29701	9d692a87-0926-422d-8b28-d8219f90e2fc	9d692a87-6c84-40de-94fb-00dd2815812e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 14:55:06
29702	9d692a87-60f9-4d67-87e1-f489a6981d9a	9d692a87-6c84-40de-94fb-00dd2815812e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"118.84","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:55:06
29703	9d692a87-61a3-44ce-94b8-7bd807004440	9d692a87-6c84-40de-94fb-00dd2815812e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:55:06
29704	9d692a87-6a49-41a1-b4e7-4d4ce708d27c	9d692a87-6c84-40de-94fb-00dd2815812e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 14:55:06
29705	9d692a87-6aef-43b0-8468-d2d799ddddec	9d692a87-6c84-40de-94fb-00dd2815812e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":663,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:55:06
36622	9d6b3dc4-ca0a-4045-9adc-b667e1113033	9d6b3dc4-eba5-4689-84ea-69bad2630e1f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:40:33
36623	9d6b3dc4-e676-4704-8549-c70f3c2c8abc	9d6b3dc4-eba5-4689-84ea-69bad2630e1f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:40:33
36624	9d6b3dc4-e6c1-4c5c-acde-3c179bc57d2e	9d6b3dc4-eba5-4689-84ea-69bad2630e1f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:40:33
36625	9d6b3dc4-ea35-41c6-994f-1cc94d487ba0	9d6b3dc4-eba5-4689-84ea-69bad2630e1f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:40:33
36626	9d6b3dc4-ea83-45fd-91fd-fdd74c304bab	9d6b3dc4-eba5-4689-84ea-69bad2630e1f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":268,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:40:33
29706	9d692a88-4a0b-41d3-b730-f93873277da1	9d692a88-7f36-4b11-bce1-a7af9783739b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 14:55:07
29707	9d692a88-770d-4067-8aba-f30e139e7294	9d692a88-7f36-4b11-bce1-a7af9783739b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"65.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:55:07
29708	9d692a88-778f-45a7-a5f4-7fb3dc86d638	9d692a88-7f36-4b11-bce1-a7af9783739b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:55:07
29709	9d692a88-7d59-442f-acb5-af874fec210f	9d692a88-7f36-4b11-bce1-a7af9783739b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 14:55:07
29710	9d692a88-7dce-464e-aa8d-f724bb14c09c	9d692a88-7f36-4b11-bce1-a7af9783739b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":656,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:55:07
36627	9d6b3dc7-339b-4f17-9d72-c68a931f4ef9	9d6b3dc7-52e4-49a4-9bad-aa693e53ef98	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:40:35
36628	9d6b3dc7-4d8f-4073-b0fb-9932b2ff069c	9d6b3dc7-52e4-49a4-9bad-aa693e53ef98	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:40:35
36629	9d6b3dc7-4dd6-41e1-ba37-160828dc611f	9d6b3dc7-52e4-49a4-9bad-aa693e53ef98	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:40:35
36630	9d6b3dc7-5196-4872-9adf-6e6ccb194abc	9d6b3dc7-52e4-49a4-9bad-aa693e53ef98	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:40:35
36631	9d6b3dc7-51da-4491-a7a0-526adb465fba	9d6b3dc7-52e4-49a4-9bad-aa693e53ef98	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:40:35
29522	9d692822-9131-4362-8c14-89241436f153	9d692822-e761-45a0-adbd-5d00eb76104c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 14:48:24
29523	9d692822-e2a4-4aac-8a3e-ffc4e34a98ab	9d692822-e761-45a0-adbd-5d00eb76104c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 14:48:25
29524	9d692822-e427-49a9-b955-65a7167f7a64	9d692822-e761-45a0-adbd-5d00eb76104c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":718,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:48:25
29525	9d692823-f538-4571-af8f-c8c2ef716d20	9d692823-fa58-4696-ab2d-5ddebafe52a2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user\\/12","method":"GET","controller_action":null,"middleware":[],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":404,"response":{"error":"No se encontro la url especificada","code":404},"duration":566,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:48:25
29526	9d692824-b5c1-467d-b903-da0efb1935e7	9d692825-47c1-4e71-bb72-73a4700a9efd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 14:48:26
29527	9d692825-3dcc-4e37-a11a-f3e2848a5cd6	9d692825-47c1-4e71-bb72-73a4700a9efd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"228.60","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:48:26
29528	9d692825-3e3e-40c1-afdb-349f8572aee2	9d692825-47c1-4e71-bb72-73a4700a9efd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:48:26
29529	9d692825-45ac-4a5a-ba42-a515dd6a2035	9d692825-47c1-4e71-bb72-73a4700a9efd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 14:48:26
29530	9d692825-463a-4b56-a2bb-5abb5ee9f241	9d692825-47c1-4e71-bb72-73a4700a9efd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":678,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:48:26
29531	9d692826-26bc-411a-b874-4185484eaf79	9d692826-3ac4-4b90-bb20-dddab59524db	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user\\/12","method":"GET","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":404,"response":{"error":"No se encontro la url especificada","code":404},"duration":519,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:48:27
29532	9d692826-c99a-4a69-a702-e0f2d1bf31c5	9d692827-1a2f-4b28-ae01-400a13dba050	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 14:48:27
29533	9d692827-1410-4f71-939d-0b29fc09b455	9d692827-1a2f-4b28-ae01-400a13dba050	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"163.98","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:48:27
29534	9d692827-147c-4ace-9b61-a53c76f86173	9d692827-1a2f-4b28-ae01-400a13dba050	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:48:27
29535	9d692827-1820-45a6-904c-0817f46443a2	9d692827-1a2f-4b28-ae01-400a13dba050	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 14:48:27
29536	9d692827-1886-479d-bbdc-55f4019f7f3e	9d692827-1a2f-4b28-ae01-400a13dba050	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":424,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:48:27
27595	9d68e87d-1971-4624-b663-f2359bc2a767	9d68e87d-558d-4d9c-8d6f-866fc4fd9cd9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:50:26
27596	9d68e87d-5320-4457-bbd6-cc5bcec953e2	9d68e87d-558d-4d9c-8d6f-866fc4fd9cd9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:50:26
27597	9d68e87d-541c-4a06-9d02-d35ffcd579ba	9d68e87d-558d-4d9c-8d6f-866fc4fd9cd9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":640,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:50:26
27598	9d68e87e-1a04-4aad-a40d-dfaaba0cccb8	9d68e87e-4c29-41e1-ae3a-df4dce047e3d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:50:27
27599	9d68e87e-42e8-40a6-a22c-db16c05f35f4	9d68e87e-4c29-41e1-ae3a-df4dce047e3d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"64.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:50:27
27600	9d68e87e-436b-4517-bda9-35b1605fac09	9d68e87e-4c29-41e1-ae3a-df4dce047e3d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:50:27
27601	9d68e87e-4a3c-48a0-90f2-a105eb52033b	9d68e87e-4c29-41e1-ae3a-df4dce047e3d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:50:27
27602	9d68e87e-4ac2-4f59-bfb3-12a862fe92d4	9d68e87e-4c29-41e1-ae3a-df4dce047e3d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":542,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:50:27
27603	9d68e87f-0f85-4ff0-bcee-d03503ce5f1b	9d68e87f-42d7-455e-a9e0-d72ee3690209	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:50:28
27604	9d68e87f-39f0-49b5-80e1-a8fa2f470db3	9d68e87f-42d7-455e-a9e0-d72ee3690209	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"61.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:50:28
27605	9d68e87f-3a77-4c1a-a78b-9d8ef75ea87c	9d68e87f-42d7-455e-a9e0-d72ee3690209	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 11:50:28
27606	9d68e87f-40c0-4c52-8d2e-269d537d9aae	9d68e87f-42d7-455e-a9e0-d72ee3690209	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:50:28
27607	9d68e87f-414e-4034-aca2-3bf038642c2f	9d68e87f-42d7-455e-a9e0-d72ee3690209	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":608,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:50:28
27608	9d68e87f-ea3b-423a-8939-32d38d2b4618	9d68e880-19a8-45e0-9d92-5f0e83c53cd5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:50:28
27609	9d68e880-0ef2-4681-958c-69d8eb173aa6	9d68e880-19a8-45e0-9d92-5f0e83c53cd5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '90' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"61.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 11:50:28
27610	9d68e880-0f7c-474a-a51c-4f43b852993b	9d68e880-19a8-45e0-9d92-5f0e83c53cd5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 11:50:28
27611	9d68e880-1250-4e39-9353-3693a8fdda1f	9d68e880-19a8-45e0-9d92-5f0e83c53cd5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"3.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:50:28
27612	9d68e880-12a7-41b6-a46e-a24a33a591b0	9d68e880-19a8-45e0-9d92-5f0e83c53cd5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 11:50:28
27613	9d68e880-17dc-4bc8-8330-28df093577d9	9d68e880-19a8-45e0-9d92-5f0e83c53cd5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:50:28
27614	9d68e880-1852-40f9-b596-412ab163cc2a	9d68e880-19a8-45e0-9d92-5f0e83c53cd5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"275000","loans_pago_prestado":"1100000","loans_intereses_recaudar":"275000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"}]}},"duration":528,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:50:28
27615	9d68e880-e941-486a-a583-2cf6b2127340	9d68e881-7161-4001-a775-3a68664ddf2a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:50:29
27616	9d68e881-6360-47d7-a58b-e98d2cee2f75	9d68e881-7161-4001-a775-3a68664ddf2a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"225.79","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:50:29
27617	9d68e881-6411-408f-82b4-2ab1e20ebe7d	9d68e881-7161-4001-a775-3a68664ddf2a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:50:29
27618	9d68e881-6e8c-4b5b-b9b4-d15849bb1c5a	9d68e881-7161-4001-a775-3a68664ddf2a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:50:29
27619	9d68e881-6f66-4da5-b126-090ebc195025	9d68e881-7161-4001-a775-3a68664ddf2a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":854,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:50:29
27620	9d68e882-6acb-47ab-b67e-e606a135c647	9d68e882-a4a7-4a35-97f9-988715b47e03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:50:30
27621	9d68e882-9b7c-44de-9fb8-a34d9535e003	9d68e882-a4a7-4a35-97f9-988715b47e03	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"74.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:50:30
27622	9d68e882-9c03-4d36-bf41-73cdc59c50b3	9d68e882-a4a7-4a35-97f9-988715b47e03	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:50:30
27623	9d68e882-a275-40ff-8c52-ebed1a81d872	9d68e882-a4a7-4a35-97f9-988715b47e03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:50:30
27624	9d68e882-a307-4dd9-9d89-2923de518b37	9d68e882-a4a7-4a35-97f9-988715b47e03	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":757,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:50:30
11211	9d5cac3c-b4b7-4bd2-b758-91584f8d477f	9d5cac3c-b793-419a-8455-c564869eca71	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":565}	2024-10-29 09:52:02
36955	9d6b4354-f18f-457c-884d-0f695ef41e98	9d6b4355-418c-4dc6-a6ae-f5798b9b20ee	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 15:56:07
36956	9d6b4355-3f55-4150-96f0-ba13bffc4208	9d6b4355-418c-4dc6-a6ae-f5798b9b20ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:56:07
36957	9d6b4355-4035-4db7-864d-c437c5e14e37	9d6b4355-418c-4dc6-a6ae-f5798b9b20ee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":397,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:56:07
36958	9d6b4355-aeeb-4734-b4ea-a7bada258728	9d6b4355-cbf9-4b6f-ad24-e6489f40044b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:56:07
36959	9d6b4355-c6f4-4c33-a87b-b87f84e32d96	9d6b4355-cbf9-4b6f-ad24-e6489f40044b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"44.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:56:07
36960	9d6b4355-ca5a-4c00-8fd6-d3bf7b16387a	9d6b4355-cbf9-4b6f-ad24-e6489f40044b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:56:07
36961	9d6b4355-cac4-404b-84ff-850ac8225b4a	9d6b4355-cbf9-4b6f-ad24-e6489f40044b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":286,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:56:07
32039	9d69587f-d0c8-454a-93bb-34178a8aaf39	9d69587f-ee6d-4722-a697-013c1721f36e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 17:03:38
32040	9d69587f-ecab-4a08-a4ea-558bed62347d	9d69587f-ee6d-4722-a697-013c1721f36e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 17:03:39
32041	9d69587f-ed65-4a33-b78d-6241a22f2546	9d69587f-ee6d-4722-a697-013c1721f36e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:03:39
32042	9d695880-454a-41d1-af8b-7bd208a8feac	9d695880-626c-44d5-9136-85c3ad93dd80	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 17:03:39
32043	9d695880-5d24-4f92-ad24-7e4042d3edec	9d695880-626c-44d5-9136-85c3ad93dd80	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":227,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 17:03:39
32044	9d695880-5d7f-46f1-8dbb-a209bd2f9989	9d695880-626c-44d5-9136-85c3ad93dd80	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 17:03:39
32045	9d695880-6117-47dc-ba77-4ae2352c6892	9d695880-626c-44d5-9136-85c3ad93dd80	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 17:03:39
32046	9d695880-6167-42fa-930c-c7b8d3ebacd5	9d695880-626c-44d5-9136-85c3ad93dd80	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:03:39
36962	9d6b4356-1dfe-4bc7-b62c-eb847cd62329	9d6b4356-3f81-4c45-9778-364d7b12331d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:56:07
36963	9d6b4356-3a62-4023-9bab-3853212b235f	9d6b4356-3f81-4c45-9778-364d7b12331d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:56:07
36964	9d6b4356-3abd-4686-b2f1-28197fb3547d	9d6b4356-3f81-4c45-9778-364d7b12331d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:56:07
36965	9d6b4356-3e32-49ad-be92-1c84d543e876	9d6b4356-3f81-4c45-9778-364d7b12331d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:56:07
36966	9d6b4356-3e79-4f7c-8fb9-cf7e86090df7	9d6b4356-3f81-4c45-9778-364d7b12331d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":280,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:56:07
32047	9d695880-a6f8-4c89-a232-e8aa54d0b6fe	9d695880-c8ae-4ee4-b442-802e001d3e15	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 17:03:39
32048	9d695880-c125-460b-a89b-070855b08a28	9d695880-c8ae-4ee4-b442-802e001d3e15	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":216,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 17:03:39
32049	9d695880-c190-425f-8d7e-a76c82bc9359	9d695880-c8ae-4ee4-b442-802e001d3e15	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":3,"hostname":"EderCortes"}	2024-11-04 17:03:39
32050	9d695880-c717-4eb0-a058-2fce6bb58558	9d695880-c8ae-4ee4-b442-802e001d3e15	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 17:03:39
32051	9d695880-c776-44d6-857f-523dd442df32	9d695880-c8ae-4ee4-b442-802e001d3e15	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:03:39
36967	9d6b4356-8d6c-41ea-b159-2ffed6940c64	9d6b4356-aebf-4dcb-9fe3-36daa06b2442	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:56:08
36968	9d6b4356-a9d2-452a-bd08-add1322c8e69	9d6b4356-aebf-4dcb-9fe3-36daa06b2442	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:56:08
36969	9d6b4356-aa34-4a48-8382-e7e1810af655	9d6b4356-aebf-4dcb-9fe3-36daa06b2442	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:56:08
36970	9d6b4356-ad7c-489c-ac8e-d88125aa9c54	9d6b4356-aebf-4dcb-9fe3-36daa06b2442	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:56:08
36971	9d6b4356-adbe-434a-bb2e-b9a6eec8ba06	9d6b4356-aebf-4dcb-9fe3-36daa06b2442	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:56:08
32052	9d695881-127b-4b28-a4ad-6b4e593b19a3	9d695881-30f0-4208-aa57-bc0274a0f201	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 17:03:39
32053	9d695881-2b9c-4d89-95dd-946c72c9134c	9d695881-30f0-4208-aa57-bc0274a0f201	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 17:03:39
32054	9d695881-2c08-44a1-a92c-83998dd9d9ad	9d695881-30f0-4208-aa57-bc0274a0f201	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 17:03:39
29799	9d692b1a-8a53-4a93-8397-e321dc62cbef	9d692b1a-c086-49d8-82dc-d2852f873be0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 14:56:42
29800	9d692b1a-bdab-40f7-b16c-9a576e2b9dd1	9d692b1a-c086-49d8-82dc-d2852f873be0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 14:56:42
29801	9d692b1a-beff-4764-80ed-0467a134dcdb	9d692b1a-c086-49d8-82dc-d2852f873be0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":473,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:56:43
32055	9d695881-2fed-4bc9-a1f3-76ee2d2f1610	9d695881-30f0-4208-aa57-bc0274a0f201	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 17:03:39
32056	9d695881-302f-401b-a990-24adf24190a6	9d695881-30f0-4208-aa57-bc0274a0f201	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:03:39
36972	9d6b4358-a61c-4660-8de2-f01507cf5590	9d6b4358-c936-456c-a8ea-851b1a55dc37	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:56:09
36973	9d6b4358-c31d-472c-a497-f982bab10b48	9d6b4358-c936-456c-a8ea-851b1a55dc37	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"48.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:56:09
36974	9d6b4358-c388-49ec-a087-d635bd0c6920	9d6b4358-c936-456c-a8ea-851b1a55dc37	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:56:09
36975	9d6b4358-c7ca-46f6-8733-42de464729d7	9d6b4358-c936-456c-a8ea-851b1a55dc37	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:56:09
36976	9d6b4358-c818-4fdc-b166-de7abb6dcf3e	9d6b4358-c936-456c-a8ea-851b1a55dc37	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":382,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:56:09
29802	9d692b1b-4c05-4d24-8126-d8b5dfaa3e18	9d692b1b-796f-4099-9457-9cca70d5efae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 14:56:43
29803	9d692b1b-6ffc-4eaf-b9a3-0390bc05b512	9d692b1b-796f-4099-9457-9cca70d5efae	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"58.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":56,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 14:56:43
29804	9d692b1b-7088-40b0-8836-dcf53d367d31	9d692b1b-796f-4099-9457-9cca70d5efae	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 14:56:43
29805	9d692b1b-7710-47a7-a675-c570721b0e10	9d692b1b-796f-4099-9457-9cca70d5efae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 14:56:43
29806	9d692b1b-77be-436b-bdfd-094803f034a8	9d692b1b-796f-4099-9457-9cca70d5efae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":386,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:56:43
29807	9d692b1c-462a-4a8b-8888-7a597504d258	9d692b1c-9a47-4697-8e16-5477c24eac03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 14:56:44
29808	9d692b1c-8f42-48df-8a3f-d1f25cf45109	9d692b1c-9a47-4697-8e16-5477c24eac03	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"123.00","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:56:44
29809	9d692b1c-8fda-4e39-85b0-a2ba7ca098ee	9d692b1c-9a47-4697-8e16-5477c24eac03	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:56:44
29810	9d692b1c-984e-4a8c-998d-fa9fa54aa505	9d692b1c-9a47-4697-8e16-5477c24eac03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 14:56:44
29811	9d692b1c-98cd-46c7-b49c-c8b4334c11ed	9d692b1c-9a47-4697-8e16-5477c24eac03	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":716,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:56:44
29812	9d692b1d-a8d0-4b1d-bfa3-de940f0af296	9d692b1d-ddc8-4d76-be54-d2e49b605c3e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 14:56:44
29813	9d692b1d-d5cf-4a5c-99d3-00dc1ffbe25d	9d692b1d-ddc8-4d76-be54-d2e49b605c3e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"61.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:56:45
29814	9d692b1d-d670-46b9-bc02-70438f9fb8e7	9d692b1d-ddc8-4d76-be54-d2e49b605c3e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:56:45
29815	9d692b1d-dbf2-4f72-8ac6-c8a025d8b5d1	9d692b1d-ddc8-4d76-be54-d2e49b605c3e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 14:56:45
29816	9d692b1d-dc5d-4b04-905d-6d30a2829a11	9d692b1d-ddc8-4d76-be54-d2e49b605c3e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":803,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:56:45
27143	9d68e277-1b0e-48c5-945f-bbb3fc20672d	9d68e277-1e62-46a7-b4fa-15770be2169d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1263}	2024-11-04 11:33:36
26362	9d68d354-3854-4b81-9cb1-f65c38ac2c9d	9d68d354-5ae9-4cfd-98ef-ee99a37d8eba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:51:16
26363	9d68d354-5935-41bd-a7b1-28702560ec0c	9d68d354-5ae9-4cfd-98ef-ee99a37d8eba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:51:16
26364	9d68d354-59de-4cd1-b05b-f7f0c66e6f53	9d68d354-5ae9-4cfd-98ef-ee99a37d8eba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":397,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:51:16
26365	9d68d354-e38c-4c0e-8bdb-e31da00a2e4f	9d68d355-0472-45f8-9ee8-0afb68522fb2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:51:17
26366	9d68d354-fad8-4acb-a9db-e32d3ad5c645	9d68d355-0472-45f8-9ee8-0afb68522fb2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"46.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 10:51:17
26367	9d68d354-fec4-4433-862d-b874b8256e2f	9d68d355-0472-45f8-9ee8-0afb68522fb2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:51:17
26368	9d68d354-ff10-4834-bd13-b7ebe8269dab	9d68d355-0472-45f8-9ee8-0afb68522fb2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:51:17
26369	9d68d355-02ff-464e-8e2a-7ea8fac28a49	9d68d355-0472-45f8-9ee8-0afb68522fb2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 10:51:17
26370	9d68d355-035e-4e86-8c7e-05861c7b264f	9d68d355-0472-45f8-9ee8-0afb68522fb2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":380,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:51:17
29876	9d692c04-ac19-4100-a445-875ed10dd173	9d692c04-f250-4a73-86d6-17a6239a549f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 14:59:16
29877	9d692c04-f095-46d1-ae45-5b5e664c2715	9d692c04-f250-4a73-86d6-17a6239a549f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 14:59:16
29878	9d692c04-f13c-470e-9716-ddeb26bb1bc3	9d692c04-f250-4a73-86d6-17a6239a549f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:59:16
29879	9d692c05-4931-4228-a5f2-5f33e9686fe2	9d692c05-966d-4568-b942-340f59cf220e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 14:59:16
29880	9d692c05-8c98-416f-8a08-9928eb519449	9d692c05-966d-4568-b942-340f59cf220e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"160.43","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 14:59:16
29881	9d692c05-90a7-4cb0-b131-ef869ffd5430	9d692c05-966d-4568-b942-340f59cf220e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 14:59:16
29882	9d692c05-90ec-4f24-8161-e17db686a7af	9d692c05-966d-4568-b942-340f59cf220e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 14:59:16
29883	9d692c05-9535-4564-ad0b-4a24a3e4d10b	9d692c05-966d-4568-b942-340f59cf220e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 14:59:16
29884	9d692c05-9584-49b0-b170-e23505717980	9d692c05-966d-4568-b942-340f59cf220e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":361,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:59:16
37116	9d6b453b-ba25-48a3-98f0-116659545434	9d6b453b-eb88-4b46-9402-69442afe6c60	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 16:01:26
37117	9d6b453b-e8ea-4e6e-9c9a-f74f2461896b	9d6b453b-eb88-4b46-9402-69442afe6c60	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 16:01:26
37118	9d6b453b-ea36-4a8e-a1bd-2ca60d32e510	9d6b453b-eb88-4b46-9402-69442afe6c60	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":504,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:01:26
37119	9d6b453c-65f9-4092-a566-5dba5ab5c096	9d6b453c-84b6-4943-8cfe-94fd15b5a2d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 16:01:26
37120	9d6b453c-7f5e-4633-bbbb-83aad57b011d	9d6b453c-84b6-4943-8cfe-94fd15b5a2d9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"46.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 16:01:26
37121	9d6b453c-8342-46dd-87e6-22b72c47c418	9d6b453c-84b6-4943-8cfe-94fd15b5a2d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 16:01:26
37122	9d6b453c-83be-4abe-a520-c1368fbc1de1	9d6b453c-84b6-4943-8cfe-94fd15b5a2d9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":322,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:01:26
37123	9d6b453d-2a16-4661-a3fb-4d05c3ca2458	9d6b453d-c3ac-4fd8-b1c9-8d8da7737051	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 16:01:26
37124	9d6b453d-b778-4cf8-83b4-e5e18dc271ae	9d6b453d-c3ac-4fd8-b1c9-8d8da7737051	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"179.70","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:01:27
37125	9d6b453d-b86d-43df-a5e0-5e730045ff40	9d6b453d-c3ac-4fd8-b1c9-8d8da7737051	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:01:27
37126	9d6b453d-c18a-43d7-8d51-544f67f19e93	9d6b453d-c3ac-4fd8-b1c9-8d8da7737051	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 16:01:27
37127	9d6b453d-c21f-4def-8f8b-19b4bc2ca8cf	9d6b453d-c3ac-4fd8-b1c9-8d8da7737051	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":799,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:01:27
27903	9d68ea40-3315-4048-9d9f-eaed6b84f2bf	9d68ea40-6c4d-40fd-b48d-1db96d6f7b15	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 11:55:22
27904	9d68ea40-69b8-4f18-8eb7-17585ec6c705	9d68ea40-6c4d-40fd-b48d-1db96d6f7b15	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 11:55:22
27905	9d68ea40-6afd-46d0-942f-f25c35a91d36	9d68ea40-6c4d-40fd-b48d-1db96d6f7b15	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":608,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:55:22
24970	9d68bee5-d42c-44ca-ac80-d0e42f5a5c61	9d68bee6-28d3-41e2-a93b-5ab197df5eb9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 09:54:08
24971	9d68bee6-23e6-49c2-9ed5-9db6f86af5a0	9d68bee6-28d3-41e2-a93b-5ab197df5eb9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 09:54:09
24972	9d68bee6-25b3-4094-b695-65af7c47b3dc	9d68bee6-28d3-41e2-a93b-5ab197df5eb9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":873,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:54:09
37128	9d6b453e-2ca6-45ec-acdd-56d790c6c7dc	9d6b453e-4e62-4801-aa29-5b59c5bc837c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 16:01:27
37129	9d6b453e-4840-41d1-8e78-b1de6ee194a9	9d6b453e-4e62-4801-aa29-5b59c5bc837c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:01:27
37130	9d6b453e-4891-4329-9550-121edf2ad559	9d6b453e-4e62-4801-aa29-5b59c5bc837c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:01:27
37131	9d6b453e-4ccb-463f-835a-28ea8c757287	9d6b453e-4e62-4801-aa29-5b59c5bc837c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 16:01:27
37132	9d6b453e-4d35-4014-bfa0-1772e791ce77	9d6b453e-4e62-4801-aa29-5b59c5bc837c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":308,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:01:27
24974	9d68bee7-5c11-49a1-adb2-9adf9306d302	9d68bee7-6534-41d7-9edb-44ec017b89b6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"157.70","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 09:54:09
24975	9d68bee7-5f88-417a-8c1c-3b477f753dd3	9d68bee7-6534-41d7-9edb-44ec017b89b6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 09:54:09
24976	9d68bee7-5fbc-4f4a-893f-daf16b4252eb	9d68bee7-6534-41d7-9edb-44ec017b89b6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 09:54:09
24977	9d68bee7-63d9-41f3-a97a-c9b20de54a92	9d68bee7-6534-41d7-9edb-44ec017b89b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 09:54:09
24978	9d68bee7-643b-4295-b20b-8620ccdd1534	9d68bee7-6534-41d7-9edb-44ec017b89b6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":676,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:54:09
27906	9d68ea41-233f-4ee6-9bc9-3f574bcd6694	9d68ea41-51f1-4424-8fd2-ff5a4f6fc9d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 11:55:22
27907	9d68ea41-4ace-4880-b157-a29e9e67f2ff	9d68ea41-51f1-4424-8fd2-ff5a4f6fc9d7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"59.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:55:23
27908	9d68ea41-4b80-4d05-a35e-5cb9328cd188	9d68ea41-51f1-4424-8fd2-ff5a4f6fc9d7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:55:23
27909	9d68ea41-50ab-4a4b-828b-60b77228664b	9d68ea41-51f1-4424-8fd2-ff5a4f6fc9d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 11:55:23
27910	9d68ea41-50fb-4cee-a564-95a73253249a	9d68ea41-51f1-4424-8fd2-ff5a4f6fc9d7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":521,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:55:23
37133	9d6b453f-d34b-47fd-a99e-e71f69f39f65	9d6b4540-066f-46ca-bbca-f46f601d9e4a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 16:01:28
37134	9d6b453f-ff7b-49d7-9a5c-8297a6643696	9d6b4540-066f-46ca-bbca-f46f601d9e4a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"73.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 16:01:28
37135	9d6b453f-ffe7-4c76-9dcb-c664dd219028	9d6b4540-066f-46ca-bbca-f46f601d9e4a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 16:01:28
37136	9d6b4540-04db-403a-9f0d-2c3f00b7bbc4	9d6b4540-066f-46ca-bbca-f46f601d9e4a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 16:01:28
27911	9d68ea41-d3d0-48c3-8d42-5ba05d88f7d6	9d68ea41-fdfc-4210-a335-0d0220af5fab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 11:55:23
27912	9d68ea41-f5be-444e-bad5-cb3522204fde	9d68ea41-fdfc-4210-a335-0d0220af5fab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"51.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:55:23
27913	9d68ea41-f63e-4639-b8bf-a848c853dce5	9d68ea41-fdfc-4210-a335-0d0220af5fab	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 11:55:23
27914	9d68ea41-fc24-45ea-ab0f-963fb7b70193	9d68ea41-fdfc-4210-a335-0d0220af5fab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 11:55:23
27915	9d68ea41-fc9d-44fd-93be-a69b8684929d	9d68ea41-fdfc-4210-a335-0d0220af5fab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":416,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:55:23
37137	9d6b4540-0530-4f4b-b794-e525e5e55513	9d6b4540-066f-46ca-bbca-f46f601d9e4a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":452,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:01:28
27916	9d68ea42-a645-4197-9bd0-595b4dd7218b	9d68ea42-da7a-40e3-a891-6ba2935ebfe6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 11:55:23
27917	9d68ea42-ca82-463a-8226-a7e41276992c	9d68ea42-da7a-40e3-a891-6ba2935ebfe6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '81' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"65.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 11:55:24
27918	9d68ea42-cb24-4a12-bbc2-bbb49f684380	9d68ea42-da7a-40e3-a891-6ba2935ebfe6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 11:55:24
27919	9d68ea42-ce95-4b87-9c17-d58cbaab43cd	9d68ea42-da7a-40e3-a891-6ba2935ebfe6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '81' order by \\"item_loans\\".\\"id\\" asc","time":"4.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:55:24
27920	9d68ea42-cf0a-4669-a261-85ee616aca02	9d68ea42-da7a-40e3-a891-6ba2935ebfe6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 11:55:24
27921	9d68ea42-d801-40fd-8197-cd09d6c11ba5	9d68ea42-da7a-40e3-a891-6ba2935ebfe6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-04 11:55:24
27922	9d68ea42-d8b9-44e8-975e-abaa7ad6a260	9d68ea42-da7a-40e3-a891-6ba2935ebfe6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/81","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":81,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"0","loans_pago_prestado":"0","loans_intereses_recaudar":"275000"},"items":[{"id":311,"loans_codigo":81,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":312,"loans_codigo":81,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":313,"loans_codigo":81,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":314,"loans_codigo":81,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":315,"loans_codigo":81,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":542,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:55:24
27923	9d68ea43-b678-452c-bd28-555b42cdae42	9d68ea43-f921-476d-ab0b-c5e43273c4ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-04 11:55:24
27924	9d68ea43-edcc-4f36-9f54-63f6cfc28ed8	9d68ea43-f921-476d-ab0b-c5e43273c4ff	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"90.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:55:24
27925	9d68ea43-ee9d-4beb-bf0c-f5a47849a002	9d68ea43-f921-476d-ab0b-c5e43273c4ff	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:55:24
27926	9d68ea43-f713-4ce3-ab7d-feb8fedf5a5e	9d68ea43-f921-476d-ab0b-c5e43273c4ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-04 11:55:24
27927	9d68ea43-f7a5-4b9f-909d-48c6144d2144	9d68ea43-f921-476d-ab0b-c5e43273c4ff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":701,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:55:24
27928	9d68ea45-250b-4688-964d-34e62ce89614	9d68ea45-4bce-4e45-b0ee-92c84b8c1f0f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-04 11:55:25
27929	9d68ea45-448d-47a4-b4a9-6eacc5cb2dd0	9d68ea45-4bce-4e45-b0ee-92c84b8c1f0f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"51.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:55:25
27930	9d68ea45-4509-4d2c-bf91-2b826214f578	9d68ea45-4bce-4e45-b0ee-92c84b8c1f0f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:55:25
27931	9d68ea45-4a3f-4ae4-8bd5-fdbca87e3faa	9d68ea45-4bce-4e45-b0ee-92c84b8c1f0f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-04 11:55:25
27932	9d68ea45-4a9e-489b-a204-68ed38b5f777	9d68ea45-4bce-4e45-b0ee-92c84b8c1f0f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":796,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:55:25
28016	9d68eaf4-19fa-4275-81c3-f2f893887ea9	9d68eaf4-66cb-4266-9c1c-905a7079e46d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:57:20
28017	9d68eaf4-62df-41fd-8b31-a6a39b5e3d5e	9d68eaf4-66cb-4266-9c1c-905a7079e46d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:57:20
28018	9d68eaf4-64e2-40ab-9882-630e34080ec8	9d68eaf4-66cb-4266-9c1c-905a7079e46d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":824,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:57:20
28019	9d68eaf5-1fd1-4151-8d8f-d2846c463c39	9d68eaf5-5084-4b23-87c0-0d4cab1a0037	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:57:20
28020	9d68eaf5-463f-46f6-ba9d-0cbe63598ef6	9d68eaf5-5084-4b23-87c0-0d4cab1a0037	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"56.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:57:21
28021	9d68eaf5-46ac-4917-bf57-033f00b79191	9d68eaf5-5084-4b23-87c0-0d4cab1a0037	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:57:21
28022	9d68eaf5-4ea7-405e-ac79-0ce0e4df0fa5	9d68eaf5-5084-4b23-87c0-0d4cab1a0037	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:57:21
28023	9d68eaf5-4f28-4b91-ba67-8ee2125f7c8c	9d68eaf5-5084-4b23-87c0-0d4cab1a0037	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":514,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:57:21
28024	9d68eaf5-fa48-4cde-9865-d0fa780fed5f	9d68eaf6-2a4d-4dbd-b0d0-ed719b7b8089	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 11:57:21
28025	9d68eaf6-20ef-48aa-85a3-079535b4af6c	9d68eaf6-2a4d-4dbd-b0d0-ed719b7b8089	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"63.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:57:21
28026	9d68eaf6-2174-4c61-817d-9d2d6fb20289	9d68eaf6-2a4d-4dbd-b0d0-ed719b7b8089	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 11:57:21
28027	9d68eaf6-2847-4a34-8285-0839c228226c	9d68eaf6-2a4d-4dbd-b0d0-ed719b7b8089	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:57:21
28028	9d68eaf6-28cb-491c-b3f1-e98b7997c37f	9d68eaf6-2a4d-4dbd-b0d0-ed719b7b8089	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":534,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:57:21
28029	9d68eaf6-bcb7-47cc-935e-341e8be1116f	9d68eaf6-e323-4250-9f8c-2f8a57916414	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 11:57:21
28030	9d68eaf6-da3e-44b9-9e39-859364350f9f	9d68eaf6-e323-4250-9f8c-2f8a57916414	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '81' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"49.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 11:57:22
28031	9d68eaf6-daa4-4dad-8e85-6a50522b8746	9d68eaf6-e323-4250-9f8c-2f8a57916414	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 11:57:22
28032	9d68eaf6-dc94-4d94-a5c6-27cfa2bf4387	9d68eaf6-e323-4250-9f8c-2f8a57916414	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '81' order by \\"item_loans\\".\\"id\\" asc","time":"2.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:57:22
28033	9d68eaf6-dcdf-4b1f-b595-8e6b03427fa5	9d68eaf6-e323-4250-9f8c-2f8a57916414	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 11:57:22
28034	9d68eaf6-e18c-4f4f-9c28-dbdf5dc3dfb0	9d68eaf6-e323-4250-9f8c-2f8a57916414	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:57:22
28035	9d68eaf6-e1fb-40ed-867c-4352cd51466e	9d68eaf6-e323-4250-9f8c-2f8a57916414	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/81","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":81,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"0","loans_pago_prestado":"0","loans_intereses_recaudar":"275000"},"items":[{"id":311,"loans_codigo":81,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":312,"loans_codigo":81,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":313,"loans_codigo":81,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":314,"loans_codigo":81,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":315,"loans_codigo":81,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":450,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:57:22
37277	9d6b4673-e401-419e-b3ca-3008c7e93452	9d6b4674-328e-4df8-9ea7-e9694175f8e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 16:04:50
37278	9d6b4674-30ac-4c95-b725-b60d95572390	9d6b4674-328e-4df8-9ea7-e9694175f8e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 16:04:50
37279	9d6b4674-3163-4506-b0d6-9545c388f366	9d6b4674-328e-4df8-9ea7-e9694175f8e7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":377,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:04:50
28036	9d68eaf7-c5cf-403c-abaa-2a12eebf672e	9d68eaf8-147a-4bf3-91d4-95605fe76de8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 11:57:22
28037	9d68eaf8-074c-4e4a-bdef-490cc7c4a850	9d68eaf8-147a-4bf3-91d4-95605fe76de8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"108.08","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:57:22
28038	9d68eaf8-07f2-4fb0-abdf-723b81808f90	9d68eaf8-147a-4bf3-91d4-95605fe76de8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:57:22
28039	9d68eaf8-1239-4feb-a90d-2612a9a7bf10	9d68eaf8-147a-4bf3-91d4-95605fe76de8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:57:22
28040	9d68eaf8-1307-4549-892c-2897ad980b30	9d68eaf8-147a-4bf3-91d4-95605fe76de8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":754,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:57:22
37280	9d6b4674-9562-487d-aad6-2d20654239dd	9d6b4674-db71-469e-8ffb-92fb2639b31a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 16:04:51
37281	9d6b4674-d649-499f-8505-3b00ef6b312d	9d6b4674-db71-469e-8ffb-92fb2639b31a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"148.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 16:04:51
37282	9d6b4674-d9c6-41bc-9317-d53d52ad42c8	9d6b4674-db71-469e-8ffb-92fb2639b31a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 16:04:51
37283	9d6b4674-da43-40da-9faf-0fabd31f1e7c	9d6b4674-db71-469e-8ffb-92fb2639b31a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":368,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:04:51
28041	9d68eaf9-5b86-4a12-acd4-55dd0e39ed83	9d68eaf9-80b2-4054-adf1-988dc1c4ad6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:57:23
28042	9d68eaf9-7a86-4b8c-8585-5cb11f6acf34	9d68eaf9-80b2-4054-adf1-988dc1c4ad6b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"51.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:57:23
28043	9d68eaf9-7af7-450a-9644-bc6783785528	9d68eaf9-80b2-4054-adf1-988dc1c4ad6b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:57:23
28044	9d68eaf9-7f28-4e24-aed2-b5507a635993	9d68eaf9-80b2-4054-adf1-988dc1c4ad6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:57:23
28045	9d68eaf9-7f87-4071-8f77-3d7423e60375	9d68eaf9-80b2-4054-adf1-988dc1c4ad6b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":850,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:57:23
37284	9d6b4675-32c4-46d5-9a32-34fa1aa4bc8d	9d6b4675-7fc8-4b6a-9752-75f91c7bee8f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 16:04:51
37285	9d6b4675-79ed-456b-9f3c-9e52c1ac5cc5	9d6b4675-7fc8-4b6a-9752-75f91c7bee8f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"153.00","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:04:51
37286	9d6b4675-7a6f-42fe-94c5-fc577fb4bd32	9d6b4675-7fc8-4b6a-9752-75f91c7bee8f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:04:51
37287	9d6b4675-7e93-4f86-8e3c-46a1947a0a00	9d6b4675-7fc8-4b6a-9752-75f91c7bee8f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 16:04:51
37288	9d6b4675-7ed7-4ab0-8816-e0eb58b2cffd	9d6b4675-7fc8-4b6a-9752-75f91c7bee8f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":401,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:04:51
37289	9d6b4675-c8cd-4987-842f-d952447b4520	9d6b4676-1396-4253-806b-14b6ceae1349	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 16:04:51
37290	9d6b4676-0da1-401e-8ff3-9925bf2cb484	9d6b4676-1396-4253-806b-14b6ceae1349	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"151.36","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:04:52
37291	9d6b4676-0dee-42a3-833a-5253039f89bc	9d6b4676-1396-4253-806b-14b6ceae1349	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:04:52
37292	9d6b4676-1255-49b2-a87d-9f6ee833eebc	9d6b4676-1396-4253-806b-14b6ceae1349	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 16:04:52
37293	9d6b4676-129c-43e2-85b8-207c18af459c	9d6b4676-1396-4253-806b-14b6ceae1349	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":363,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:04:52
37294	9d6b4677-9a51-499b-9df9-b414657da11a	9d6b4677-e636-405b-b499-0e6e6907ec05	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 16:04:53
37295	9d6b4677-df92-47d7-89db-94911f520417	9d6b4677-e636-405b-b499-0e6e6907ec05	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"74.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 16:04:53
37296	9d6b4677-dff7-41e4-b84d-7e8e5718baee	9d6b4677-e636-405b-b499-0e6e6907ec05	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 16:04:53
37297	9d6b4677-e46b-4e05-9d3f-6ed8c275d95c	9d6b4677-e636-405b-b499-0e6e6907ec05	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 16:04:53
37298	9d6b4677-e4d0-4792-a458-76e8924c2029	9d6b4677-e636-405b-b499-0e6e6907ec05	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":595,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:04:53
37299	9d6b46f4-2ee3-482d-8496-7110013b9af8	9d6b46f4-5442-4f03-886e-2ba19c958322	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 16:06:14
37300	9d6b46f4-4cf5-4b27-9352-fb4105be5184	9d6b46f4-5442-4f03-886e-2ba19c958322	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"49.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":26,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-05 16:06:14
37301	9d6b46f4-51ce-45f9-b329-9f826034d1a8	9d6b46f4-5442-4f03-886e-2ba19c958322	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 16:06:14
37302	9d6b46f4-5286-4c12-a1c4-44f51aa49be6	9d6b46f4-5442-4f03-886e-2ba19c958322	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":285,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:06:14
30031	9d693301-421d-4049-b681-e5aa4ca71fbe	9d693301-7c89-432d-ad20-f4f6ba72b35c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 15:18:48
30032	9d693301-793e-401e-bf49-295594dc54d3	9d693301-7c89-432d-ad20-f4f6ba72b35c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 15:18:48
30033	9d693301-7aeb-4096-a1ee-df3052e79b9f	9d693301-7c89-432d-ad20-f4f6ba72b35c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":514,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:18:48
30034	9d693302-1739-48eb-ab4d-437be93a08e8	9d693302-74c9-4e48-8a40-fd3fd2b192e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 15:18:49
30035	9d693302-6b08-488f-83ec-7864d89c5590	9d693302-74c9-4e48-8a40-fd3fd2b192e8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"171.46","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":56,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 15:18:49
30036	9d693302-6bb2-4ee4-ac0e-ecf1a0c5eff5	9d693302-74c9-4e48-8a40-fd3fd2b192e8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 15:18:49
30037	9d693302-72bf-4048-8ebe-949a5fe53cd2	9d693302-74c9-4e48-8a40-fd3fd2b192e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 15:18:49
30038	9d693302-7348-4be1-ad66-c827d50c8536	9d693302-74c9-4e48-8a40-fd3fd2b192e8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":529,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:18:49
30039	9d693303-46fc-4392-9feb-15f075a11dcd	9d693303-87d8-426f-befb-6b70c9bfecb3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 15:18:49
30040	9d693303-7ac8-45b7-baec-4e57c44d0807	9d693303-87d8-426f-befb-6b70c9bfecb3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"81.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:18:49
30041	9d693303-7b77-4dac-bec4-d87c53d427ae	9d693303-87d8-426f-befb-6b70c9bfecb3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:18:49
30042	9d693303-84ef-4a11-8185-fc89ba83dfeb	9d693303-87d8-426f-befb-6b70c9bfecb3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 15:18:49
30043	9d693303-8597-4c22-854f-4ef424ed1146	9d693303-87d8-426f-befb-6b70c9bfecb3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":675,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:18:49
30044	9d693304-2597-464e-9c57-6d1456f36489	9d693304-58f9-4de9-ab09-bcb5bb2c2355	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 15:18:50
30045	9d693304-4f41-42ab-8c5f-980af3a38b2c	9d693304-58f9-4de9-ab09-bcb5bb2c2355	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"69.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:18:50
30046	9d693304-4fd1-4a0b-b9af-6d88ca706614	9d693304-58f9-4de9-ab09-bcb5bb2c2355	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:18:50
30047	9d693304-570b-4b6b-9461-14e77bf316b0	9d693304-58f9-4de9-ab09-bcb5bb2c2355	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 15:18:50
30048	9d693304-579c-40a4-aaae-4b9daa1aa4d5	9d693304-58f9-4de9-ab09-bcb5bb2c2355	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":506,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:18:50
28150	9d68fe6b-6205-48f8-99ca-ce3739153eb8	9d68fe6b-8ef3-44c8-a896-ae0a4b48e36d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 12:51:46
28151	9d68fe6b-8c52-48a3-87c1-2e2a6d111d1b	9d68fe6b-8ef3-44c8-a896-ae0a4b48e36d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 12:51:46
28152	9d68fe6b-8d8f-4af3-a41a-c89694c7eced	9d68fe6b-8ef3-44c8-a896-ae0a4b48e36d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":558,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:51:46
28153	9d68fe6c-9697-4565-a7bc-f4c07a091bf4	9d68fe6c-be8b-497b-b922-bf9fb87c4123	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 12:51:46
28154	9d68fe6c-b235-4268-9062-492c8849d7f7	9d68fe6c-be8b-497b-b922-bf9fb87c4123	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"49.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 12:51:46
28155	9d68fe6c-b6c3-4804-8121-6ecd1067545b	9d68fe6c-be8b-497b-b922-bf9fb87c4123	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 12:51:46
28156	9d68fe6c-b704-4953-8a1c-844c8b55c901	9d68fe6c-be8b-497b-b922-bf9fb87c4123	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 12:51:46
28157	9d68fe6c-bcb2-44b0-84b7-e3216ea8214f	9d68fe6c-be8b-497b-b922-bf9fb87c4123	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 12:51:46
28158	9d68fe6c-bd36-48b1-a136-adaf41550f95	9d68fe6c-be8b-497b-b922-bf9fb87c4123	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":683,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:51:46
28159	9d68fe6d-7dc4-413f-9a1f-34c6c1f450b1	9d68fe6d-b819-4e7e-a013-1f84cd6cd466	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 12:51:47
28160	9d68fe6d-ade3-4f8f-ab92-794189a3c18e	9d68fe6d-b819-4e7e-a013-1f84cd6cd466	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"80.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 12:51:47
28161	9d68fe6d-ae7a-4049-8b5e-d83e7c687c9b	9d68fe6d-b819-4e7e-a013-1f84cd6cd466	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 12:51:47
28162	9d68fe6d-b60a-4b3e-b4b4-5ae469db6d30	9d68fe6d-b819-4e7e-a013-1f84cd6cd466	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 12:51:47
28163	9d68fe6d-b6a3-482e-8cbb-71d3c59bda99	9d68fe6d-b819-4e7e-a013-1f84cd6cd466	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":616,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:51:47
28164	9d68fe6e-7413-4922-9b64-157d48fbf9f9	9d68fe6e-aa8a-4ae4-afdf-26e1f58f8f6e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 12:51:48
28165	9d68fe6e-a0c8-4969-954d-661a9a9fecee	9d68fe6e-aa8a-4ae4-afdf-26e1f58f8f6e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"67.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 12:51:48
28166	9d68fe6e-a15d-416f-a693-39fff70c3e94	9d68fe6e-aa8a-4ae4-afdf-26e1f58f8f6e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 12:51:48
28167	9d68fe6e-a83a-446a-b515-591b7d8bd18d	9d68fe6e-aa8a-4ae4-afdf-26e1f58f8f6e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 12:51:48
28168	9d68fe6e-a8df-40cb-b207-d203f9967faa	9d68fe6e-aa8a-4ae4-afdf-26e1f58f8f6e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":596,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:51:48
37443	9d6b4afa-2daa-4975-ad9d-c64515787db3	9d6b4afa-7574-47b1-91ce-8bee1ada3236	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 16:17:29
37444	9d6b4afa-73e5-4ac4-87f4-7e7453be34a0	9d6b4afa-7574-47b1-91ce-8bee1ada3236	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 16:17:29
37445	9d6b4afa-7482-490f-bb59-c8ddab22ff43	9d6b4afa-7574-47b1-91ce-8bee1ada3236	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:17:29
37446	9d6b4afa-d1ad-4019-8ff5-da8225b03004	9d6b4afa-ef3a-40dd-ae9d-bfa25c4e42fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 16:17:30
37447	9d6b4afa-e7f1-42bd-b48c-2590cac49a77	9d6b4afa-ef3a-40dd-ae9d-bfa25c4e42fe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 84\\n                        ","time":"43.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ab3bc7b9a0b897ddfe4287a88fc64c84","hostname":"EderCortes"}	2024-11-05 16:17:30
37448	9d6b4afa-ea9e-4d57-ab59-47a490ef89eb	9d6b4afa-ef3a-40dd-ae9d-bfa25c4e42fe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '84' order by \\"item_loans\\".\\"id\\" asc","time":"2.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":304,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-05 16:17:30
37449	9d6b4afa-ee03-4150-a696-f427cf6c6e60	9d6b4afa-ef3a-40dd-ae9d-bfa25c4e42fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 16:17:30
37450	9d6b4afa-ee4d-44ee-9cc9-7c170a994beb	9d6b4afa-ef3a-40dd-ae9d-bfa25c4e42fe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/84","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":84,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"480000","loans_pago_interes":"120000","user_alias":"juan_jaramillo"},"items":[{"id":326,"loans_codigo":84,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 21:20:45","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":452,"loans_codigo":84,"itemloans_cuota":"4","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 21:20:45","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":456,"loans_codigo":84,"itemloans_cuota":"3","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:21:49","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":457,"loans_codigo":84,"itemloans_cuota":"4","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:21:49","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":458,"loans_codigo":84,"itemloans_cuota":"5","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:21:49","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":245,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:17:30
30110	9d693447-eeb0-43ad-adba-3640c9b948d5	9d693448-1534-45f2-b430-ce479135c414	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 15:22:22
30111	9d693448-1330-4ced-8cbe-91a762a9bc13	9d693448-1534-45f2-b430-ce479135c414	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:22:22
30112	9d693448-140c-46d8-bb73-d1e5a7acb1e5	9d693448-1534-45f2-b430-ce479135c414	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":314,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:22:22
37451	9d6b4afc-5328-4ac4-820d-b11e033f3be2	9d6b4afc-86b0-485c-8192-34f7cb595150	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 16:17:31
37452	9d6b4afc-7e58-4e1d-b2f5-4277464900ea	9d6b4afc-86b0-485c-8192-34f7cb595150	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"65.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 16:17:31
37453	9d6b4afc-7eb8-42ce-9144-00cf2c8d84a5	9d6b4afc-86b0-485c-8192-34f7cb595150	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 16:17:31
37454	9d6b4afc-8475-4648-93b7-26f2e127f80b	9d6b4afc-86b0-485c-8192-34f7cb595150	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 16:17:31
37455	9d6b4afc-84fa-4664-ac10-cbb053826da7	9d6b4afc-86b0-485c-8192-34f7cb595150	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":492,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:17:31
30113	9d693448-89aa-49d7-a87f-d9ed33126670	9d693448-ac10-4051-9c16-68f1a95e1092	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:22:22
30114	9d693448-a13f-4438-91e6-c7e041ac5baf	9d693448-ac10-4051-9c16-68f1a95e1092	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"46.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 15:22:23
30115	9d693448-a581-4ac7-82ee-5e3bb93051a8	9d693448-ac10-4051-9c16-68f1a95e1092	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"1.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 15:22:23
30116	9d693448-a5bd-4401-976f-fd643cdd07e6	9d693448-ac10-4051-9c16-68f1a95e1092	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 15:22:23
30117	9d693448-aa80-474e-89bc-147a640cfeb8	9d693448-ac10-4051-9c16-68f1a95e1092	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 15:22:23
30118	9d693448-aaee-496a-afe2-98f3e4f6e0b8	9d693448-ac10-4051-9c16-68f1a95e1092	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":284,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:22:23
28262	9d68ffbc-49ed-477f-9b7a-a0c3ffaf9456	9d68ffbc-9092-4642-97d2-1fac39379467	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 12:55:26
28263	9d68ffbc-8d68-4733-ad12-88e27ebf58ab	9d68ffbc-9092-4642-97d2-1fac39379467	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 12:55:27
28264	9d68ffbc-8ee9-471e-b186-aed4797abb1b	9d68ffbc-9092-4642-97d2-1fac39379467	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":638,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:55:27
28265	9d68ffbd-7c93-4c3d-815d-f1bf80488a30	9d68ffbd-b1e2-4854-8d6c-e6558d83a01a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 12:55:27
28266	9d68ffbd-a81a-4f02-a05b-4318233c0a5c	9d68ffbd-b1e2-4854-8d6c-e6558d83a01a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"65.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 12:55:27
28267	9d68ffbd-a8b1-41a0-8149-b897dc74372f	9d68ffbd-b1e2-4854-8d6c-e6558d83a01a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 12:55:27
28268	9d68ffbd-af48-447d-9efb-bc276810742b	9d68ffbd-b1e2-4854-8d6c-e6558d83a01a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 12:55:27
28269	9d68ffbd-aff9-4e3a-b5c9-ca619ea098f0	9d68ffbd-b1e2-4854-8d6c-e6558d83a01a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":634,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:55:27
28270	9d68ffbe-544b-4d84-952b-ab638f8df36d	9d68ffbe-7cfb-4fcc-860d-acaecf9450f3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 12:55:28
28271	9d68ffbe-73df-44fd-af4b-4231d1c17b14	9d68ffbe-7cfb-4fcc-860d-acaecf9450f3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"51.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 12:55:28
28272	9d68ffbe-745f-4004-bb05-468b70c1c08b	9d68ffbe-7cfb-4fcc-860d-acaecf9450f3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 12:55:28
28273	9d68ffbe-7aeb-4b41-a035-4c0f5154b678	9d68ffbe-7cfb-4fcc-860d-acaecf9450f3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 12:55:28
28274	9d68ffbe-7b8c-49d3-bf86-125a515ad492	9d68ffbe-7cfb-4fcc-860d-acaecf9450f3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":498,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:55:28
28275	9d68ffbf-2462-4cb7-bbfd-116251bef5ca	9d68ffbf-6eff-4eac-b564-c7514604e9e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 12:55:28
28276	9d68ffbf-6788-46a8-b2c8-d45d47524dfe	9d68ffbf-6eff-4eac-b564-c7514604e9e0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '81' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"147.65","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 12:55:28
28277	9d68ffbf-67db-4d13-a490-fa257e8eeb8b	9d68ffbf-6eff-4eac-b564-c7514604e9e0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 12:55:28
28278	9d68ffbf-697a-4bdd-9be5-b9984810df43	9d68ffbf-6eff-4eac-b564-c7514604e9e0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '81' order by \\"item_loans\\".\\"id\\" asc","time":"1.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 12:55:28
28279	9d68ffbf-69b5-44af-abc5-b92e7052a21c	9d68ffbf-6eff-4eac-b564-c7514604e9e0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 12:55:28
28280	9d68ffbf-6d85-4e5b-a6ef-233ccdde6097	9d68ffbf-6eff-4eac-b564-c7514604e9e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 12:55:28
28281	9d68ffbf-6dde-4385-a3bd-cef7feb3f442	9d68ffbf-6eff-4eac-b564-c7514604e9e0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/81","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":81,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"0","loans_pago_prestado":"0","loans_intereses_recaudar":"275000"},"items":[{"id":311,"loans_codigo":81,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":312,"loans_codigo":81,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":313,"loans_codigo":81,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":314,"loans_codigo":81,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":315,"loans_codigo":81,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":592,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:55:28
26750	9d68dbcd-fd5e-44ee-a62e-b10729f21b79	9d68dbce-2c8f-4c6a-af5b-aef5f14bb86f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 11:14:58
26751	9d68dbce-29dc-4c10-a5fa-6a3a1e8c9bda	9d68dbce-2c8f-4c6a-af5b-aef5f14bb86f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:14:58
26752	9d68dbce-2b14-4c14-905b-00b648cf5aa4	9d68dbce-2c8f-4c6a-af5b-aef5f14bb86f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":466,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:14:58
26753	9d68dbce-e5ef-431e-a1a3-a71c24fb70a7	9d68dbcf-006b-491e-af60-a841478ca8d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:14:59
26754	9d68dbce-fb97-4523-b07c-7bbb0bb2baf9	9d68dbcf-006b-491e-af60-a841478ca8d3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"41.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 11:14:59
26755	9d68dbce-ff09-49a0-8331-ff150708675f	9d68dbcf-006b-491e-af60-a841478ca8d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:14:59
26756	9d68dbce-ff6f-4b86-93a1-4d5a209c512a	9d68dbcf-006b-491e-af60-a841478ca8d3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":476,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:14:59
28282	9d68ffc0-4c62-45fa-b00f-7b2bc76bcac2	9d68ffc0-acdf-4420-9126-445353bd1d11	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 12:55:29
28283	9d68ffc0-a2d2-49ea-8345-f9e871053a2e	9d68ffc0-acdf-4420-9126-445353bd1d11	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"151.93","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 12:55:29
28284	9d68ffc0-a37a-45b2-80c4-3cfa7b077dd7	9d68ffc0-acdf-4420-9126-445353bd1d11	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 12:55:29
28285	9d68ffc0-aa47-4db8-bc06-cfd44ea58e1a	9d68ffc0-acdf-4420-9126-445353bd1d11	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 12:55:29
28286	9d68ffc0-aaeb-405b-940f-7fc42c29875e	9d68ffc0-acdf-4420-9126-445353bd1d11	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":790,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:55:29
26757	9d68dbd1-84b6-4d17-8578-4ce0b3401ae1	9d68dbd1-a7fb-4c31-a885-ca8e383343d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 11:15:01
26758	9d68dbd1-a0ae-425f-95a9-c976dacefe92	9d68dbd1-a7fb-4c31-a885-ca8e383343d3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"46.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:15:01
26759	9d68dbd1-a10b-4f06-8653-17310618144b	9d68dbd1-a7fb-4c31-a885-ca8e383343d3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:15:01
26760	9d68dbd1-a62d-44bc-977e-43168db39eb5	9d68dbd1-a7fb-4c31-a885-ca8e383343d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 11:15:01
26761	9d68dbd1-a69a-4e24-be66-8e38607dfbcc	9d68dbd1-a7fb-4c31-a885-ca8e383343d3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","pragma":"no-cache","cache-control":"no-cache","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":446,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:15:01
28287	9d68ffc1-c026-431c-9075-abc46cc67d17	9d68ffc1-eb77-466a-a9b3-be793813f227	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 12:55:30
28288	9d68ffc1-e480-42b3-8cfd-f86d679de3e4	9d68ffc1-eb77-466a-a9b3-be793813f227	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"61.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 12:55:30
28289	9d68ffc1-e4f4-4713-bf6d-6853052c0d5e	9d68ffc1-eb77-466a-a9b3-be793813f227	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 12:55:30
28290	9d68ffc1-e96b-484e-b355-ae245e20805c	9d68ffc1-eb77-466a-a9b3-be793813f227	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 12:55:30
28291	9d68ffc1-e9d0-4fda-878e-fcc61cd8c855	9d68ffc1-eb77-466a-a9b3-be793813f227	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":771,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:55:30
37696	9d6b59aa-d8d7-4aef-993a-5b49bfb72799	9d6b59ab-1e6a-449e-91f7-42cc8e1ee3e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 16:58:34
37697	9d6b59ab-1cf0-43f6-be60-42ec7f07cfec	9d6b59ab-1e6a-449e-91f7-42cc8e1ee3e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 16:58:34
37698	9d6b59ab-1d84-4657-9fb8-6e1f5941d132	9d6b59ab-1e6a-449e-91f7-42cc8e1ee3e4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":359,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:58:34
37699	9d6b59ab-7949-4cf7-8b27-0b6374593817	9d6b59ab-c075-41ca-b274-55dd19b5337c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 16:58:34
37700	9d6b59ab-bb38-4086-a082-73f968646126	9d6b59ab-c075-41ca-b274-55dd19b5337c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"138.60","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:58:34
37701	9d6b59ab-bb8d-4ab2-8149-576c49c764ca	9d6b59ab-c075-41ca-b274-55dd19b5337c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:58:34
37702	9d6b59ab-bf57-4ded-8fcd-282866f5fc11	9d6b59ab-c075-41ca-b274-55dd19b5337c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 16:58:34
37703	9d6b59ab-bf9e-4417-a7de-1ebf98606c15	9d6b59ab-c075-41ca-b274-55dd19b5337c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":350,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:58:34
37704	9d6b59ac-08e8-4813-8caf-7889bba88ee2	9d6b59ac-283a-40f3-842a-3bf301f931c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 16:58:35
37705	9d6b59ac-22f0-4700-9f54-266312b9cb5c	9d6b59ac-283a-40f3-842a-3bf301f931c5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-05 16:58:35
37706	9d6b59ac-2346-496e-9d6f-1dcc76e7b21a	9d6b59ac-283a-40f3-842a-3bf301f931c5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-05 16:58:35
37707	9d6b59ac-2719-4c00-aa5d-3281d81e275b	9d6b59ac-283a-40f3-842a-3bf301f931c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 16:58:35
37708	9d6b59ac-2760-4936-be37-12d1c9baa4e8	9d6b59ac-283a-40f3-842a-3bf301f931c5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:58:35
37709	9d6b59ac-6dfc-4a8a-ab09-c4ba4bc253c1	9d6b59ac-8c4a-4c3e-9787-048568b1a7ab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 16:58:35
37710	9d6b59ac-8719-41a4-bf26-f423050741b9	9d6b59ac-8c4a-4c3e-9787-048568b1a7ab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:58:35
37711	9d6b59ac-8764-4a64-8b79-8e0af6a3dd67	9d6b59ac-8c4a-4c3e-9787-048568b1a7ab	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-05 16:58:35
37712	9d6b59ac-8af4-4efc-aa8e-9b031a59961b	9d6b59ac-8c4a-4c3e-9787-048568b1a7ab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 16:58:35
37713	9d6b59ac-8b52-4a98-ba85-04938c2e2ad2	9d6b59ac-8c4a-4c3e-9787-048568b1a7ab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:58:35
37714	9d6b59ac-d789-417f-97e5-ae0ca0617d1c	9d6b59ac-fa6c-4351-ae2e-9b5b01dc178c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 16:58:35
37715	9d6b59ac-f360-4f8e-87f0-9777f350f384	9d6b59ac-fa6c-4351-ae2e-9b5b01dc178c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_valor_prestado\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\" from \\"loans\\" where \\"id\\" = '93' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"45.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":229,"hash":"f00e27e21a94f93c5c7a1d0cd56f9f13","hostname":"EderCortes"}	2024-11-05 16:58:35
37716	9d6b59ac-f3aa-49d4-b7ab-7f8a4ac1b8f5	9d6b59ac-fa6c-4351-ae2e-9b5b01dc178c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-05 16:58:35
37717	9d6b59ac-f581-49c4-8d0a-eff614477b7e	9d6b59ac-fa6c-4351-ae2e-9b5b01dc178c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"2.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":230,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-05 16:58:35
37718	9d6b59ac-f5b3-4258-8aaa-40793a9fe07d	9d6b59ac-fa6c-4351-ae2e-9b5b01dc178c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-05 16:58:35
37719	9d6b59ac-f948-4930-b8f8-31e442c55fd0	9d6b59ac-fa6c-4351-ae2e-9b5b01dc178c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 16:58:35
37720	9d6b59ac-f993-4032-ae9f-b7e9deb1f812	9d6b59ac-fa6c-4351-ae2e-9b5b01dc178c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"user_creador":22,"user_cobrador":22,"user_customer":19,"user_recomendacion":18},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:19:45.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:22:30.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":399,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":400,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":401,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":402,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"}]}},"duration":263,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:58:35
37721	9d6b59af-11c4-43e3-8d55-468dea52d0bc	9d6b59af-5690-4589-9c9b-a2c0af95537d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 16:58:37
37722	9d6b59af-50fe-4afd-bffd-a57fd8a8e4b4	9d6b59af-5690-4589-9c9b-a2c0af95537d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"142.17","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 16:58:37
37723	9d6b59af-5158-49e1-9afa-07b98a4ec820	9d6b59af-5690-4589-9c9b-a2c0af95537d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 16:58:37
37724	9d6b59af-552b-47d0-bcad-ed8b817f12f4	9d6b59af-5690-4589-9c9b-a2c0af95537d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 16:58:37
37725	9d6b59af-5583-445f-a560-0b825df19418	9d6b59af-5690-4589-9c9b-a2c0af95537d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":397,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:58:37
37726	9d6b59dc-a040-4842-be08-087fbf854709	9d6b59dc-be0d-41b6-a36f-40f641d8e39a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 16:59:06
37727	9d6b59dc-b918-4603-a06c-d6c03ae86bc1	9d6b59dc-be0d-41b6-a36f-40f641d8e39a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"42.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":26,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-05 16:59:06
37728	9d6b59dc-bc83-45df-ab5d-ebded35c4bdb	9d6b59dc-be0d-41b6-a36f-40f641d8e39a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 16:59:06
37729	9d6b59dc-bce8-4978-9e23-5d8f764ff67f	9d6b59dc-be0d-41b6-a36f-40f641d8e39a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":407,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:59:07
37730	9d6b59e1-61d0-413c-be66-8c9186ac8d3e	9d6b59e1-8191-4a3b-b893-3bd715d670ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 16:59:10
37731	9d6b59e1-7b5f-4ff0-80cd-f906bde05981	9d6b59e1-8191-4a3b-b893-3bd715d670ee	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:59:10
37732	9d6b59e1-7bcd-4b0f-b76c-7ffaa541986b	9d6b59e1-8191-4a3b-b893-3bd715d670ee	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:59:10
37733	9d6b59e1-8032-4c8a-bb6f-17549dd01a95	9d6b59e1-8191-4a3b-b893-3bd715d670ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 16:59:10
37734	9d6b59e1-8077-4957-8707-0d780105a668	9d6b59e1-8191-4a3b-b893-3bd715d670ee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:59:10
37735	9d6b59e1-cbe3-47bc-a5c0-3d5f1a3724c1	9d6b59e2-1441-4c4d-8060-0b4de8cf5b86	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 16:59:10
37736	9d6b59e2-0e17-4252-af92-bbe780ab5a77	9d6b59e2-1441-4c4d-8060-0b4de8cf5b86	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"146.29","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-05 16:59:10
37737	9d6b59e2-0e74-4dec-a6a1-15c37d729915	9d6b59e2-1441-4c4d-8060-0b4de8cf5b86	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-05 16:59:10
37738	9d6b59e2-12ba-4b55-9be8-d7122d238be7	9d6b59e2-1441-4c4d-8060-0b4de8cf5b86	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 16:59:10
37739	9d6b59e2-1316-4e18-8a2a-c2f4c69e08dc	9d6b59e2-1441-4c4d-8060-0b4de8cf5b86	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:59:10
6282	9d52640c-1e9f-494a-9704-76b8dc2bede9	9d52640c-21d6-4fb2-89d3-3c74f6a6f625	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abfrom\\u00bb\\nLINE 14:     from loans l\\n             ^ (Connection: pgsql, SQL: \\n    select l.id,\\n        l.loans_documento,\\n        l.loans_nombre,\\n        l.loans_apellido_uno,\\n        l.loans_fecha,\\n        l.loans_valor_prestado,\\n        l.loans_cuotas,\\n        l.loans_estado,\\n        l.loans_intereses,\\n        ucl.name as cliente,\\n        uco.name as cobrador,\\n        ure.name as recomendador,\\n    from loans l\\n    join users ucl on l.user_customer = ucl.id\\n    join users uco on l.user_cobrador = uco.id\\n    left join users ure on l.user_recomendacion = ure.id\\n)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":321}	2024-10-24 07:11:53
28396	9d6900f4-20d7-467d-80b4-d72e6f3c7453	9d6900f4-6314-4d3b-bbaf-05498755af05	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 12:58:51
28397	9d6900f4-6035-48c2-8b89-2590597a1f2a	9d6900f4-6314-4d3b-bbaf-05498755af05	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 12:58:51
28398	9d6900f4-6187-40f5-bc2a-47c7c3fc8cb7	9d6900f4-6314-4d3b-bbaf-05498755af05	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":688,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:58:51
28399	9d6900f5-5089-46f0-8978-d3dd2178b4f7	9d6900f5-7214-4aca-8f16-dd8875c923d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 12:58:52
28400	9d6900f5-697c-4384-99f8-7c04fd271260	9d6900f5-7214-4aca-8f16-dd8875c923d6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"44.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 12:58:52
28401	9d6900f5-6cee-413c-8f5d-c012a11ce379	9d6900f5-7214-4aca-8f16-dd8875c923d6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 12:58:52
28402	9d6900f5-6d3b-474b-a97e-df89dcce23a3	9d6900f5-7214-4aca-8f16-dd8875c923d6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 12:58:52
28403	9d6900f5-70fd-4066-bb1f-a0dc8d9144ec	9d6900f5-7214-4aca-8f16-dd8875c923d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 12:58:52
28404	9d6900f5-7147-4942-8dc8-0cdd38d3b682	9d6900f5-7214-4aca-8f16-dd8875c923d6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":620,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:58:52
37740	9d6b59e2-5d96-4e58-a821-cf0c826d5bb0	9d6b59e2-7c02-4ed6-820b-8a4b320af0a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 16:59:10
37741	9d6b59e2-766f-420d-b376-2d5dc790a3ab	9d6b59e2-7c02-4ed6-820b-8a4b320af0a7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:59:10
37742	9d6b59e2-76b8-434d-9ca4-7af57b7c21e0	9d6b59e2-7c02-4ed6-820b-8a4b320af0a7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-05 16:59:10
37743	9d6b59e2-7ace-4bfb-b8b2-49f9f3718066	9d6b59e2-7c02-4ed6-820b-8a4b320af0a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-05 16:59:10
37744	9d6b59e2-7b20-4458-9086-7ea063a33faa	9d6b59e2-7c02-4ed6-820b-8a4b320af0a7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":245,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:59:10
28405	9d6900f6-279f-4403-8127-cb75758d29dc	9d6900f6-5876-4e17-8ae2-c168bc9527d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 12:58:52
28406	9d6900f6-4f97-41aa-815c-a96f1d1bb310	9d6900f6-5876-4e17-8ae2-c168bc9527d2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"67.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 12:58:52
28407	9d6900f6-5023-425b-8f9f-891ba20e5588	9d6900f6-5876-4e17-8ae2-c168bc9527d2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 12:58:52
28408	9d6900f6-567c-41c0-8c2e-e30fb8e4b4de	9d6900f6-5876-4e17-8ae2-c168bc9527d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 12:58:52
28409	9d6900f6-5702-4ebe-8de5-22950c6ff5e3	9d6900f6-5876-4e17-8ae2-c168bc9527d2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":575,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:58:52
37745	9d6b59e2-c4e1-4e1c-afec-b641b12d8448	9d6b59e2-e920-4128-951a-6a79a23a6f17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-05 16:59:10
37746	9d6b59e2-e1cb-4b55-be87-32fa495f1b23	9d6b59e2-e920-4128-951a-6a79a23a6f17	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_valor_prestado\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\" from \\"loans\\" where \\"id\\" = '93' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"46.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":229,"hash":"f00e27e21a94f93c5c7a1d0cd56f9f13","hostname":"EderCortes"}	2024-11-05 16:59:11
37747	9d6b59e2-e21d-40a4-99a2-7a5250516543	9d6b59e2-e920-4128-951a-6a79a23a6f17	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-05 16:59:11
37748	9d6b59e2-e3e5-4d83-b54c-c840ce1ad0ff	9d6b59e2-e920-4128-951a-6a79a23a6f17	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"2.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":230,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-05 16:59:11
37749	9d6b59e2-e420-4609-92cb-88fb3765557f	9d6b59e2-e920-4128-951a-6a79a23a6f17	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-05 16:59:11
37750	9d6b59e2-e7b8-46b8-bd1d-11b96c47f39e	9d6b59e2-e920-4128-951a-6a79a23a6f17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-05 16:59:11
37751	9d6b59e2-e813-4df6-aff8-169027dec7ec	9d6b59e2-e920-4128-951a-6a79a23a6f17	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"user_creador":22,"user_cobrador":22,"user_customer":19,"user_recomendacion":18},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:19:45.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:22:30.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":399,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":400,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":401,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":402,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"}]}},"duration":259,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:59:11
28410	9d6900f6-f8c3-493b-86d0-9e4d528bc3f2	9d6900f7-24d6-4ef1-ba94-50f583c88d1e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 12:58:53
28411	9d6900f7-187a-4f49-b64c-0801f6e3ef5e	9d6900f7-24d6-4ef1-ba94-50f583c88d1e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"49.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 12:58:53
28412	9d6900f7-1915-460b-b1c4-6651ea23dc39	9d6900f7-24d6-4ef1-ba94-50f583c88d1e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 12:58:53
28413	9d6900f7-224c-4ba6-af09-60e59ec01e39	9d6900f7-24d6-4ef1-ba94-50f583c88d1e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 12:58:53
28414	9d6900f7-2302-4133-bd6c-68624398e6c2	9d6900f7-24d6-4ef1-ba94-50f583c88d1e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":498,"memory":22,"hostname":"EderCortes"}	2024-11-04 12:58:53
37752	9d6b59e7-5e8d-4c09-90c0-a6fc0405a78f	9d6b59e7-79d9-49fa-a8e6-af34b0542e50	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-05 16:59:13
37753	9d6b59e7-752a-4b60-ab79-64d6f5cf550c	9d6b59e7-79d9-49fa-a8e6-af34b0542e50	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"44.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":26,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-05 16:59:14
37754	9d6b59e7-788f-4e73-a10e-dd06c1a1838a	9d6b59e7-79d9-49fa-a8e6-af34b0542e50	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-05 16:59:14
37755	9d6b59e7-78f9-4f76-bfd4-1feb26c8d807	9d6b59e7-79d9-49fa-a8e6-af34b0542e50	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":242,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:59:14
37756	9d6b59eb-13f6-46e4-9529-fd57deabaf49	9d6b59eb-56d6-4e22-9ab6-cb635762f69d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-05 16:59:16
37757	9d6b59eb-51e4-4ab4-9761-162541b415c4	9d6b59eb-56d6-4e22-9ab6-cb635762f69d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"141.01","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 16:59:16
37758	9d6b59eb-554c-4619-8fbd-3ec92bdb306f	9d6b59eb-56d6-4e22-9ab6-cb635762f69d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-05 16:59:16
37759	9d6b59eb-55c0-40af-b665-ddd5db319846	9d6b59eb-56d6-4e22-9ab6-cb635762f69d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":315,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:59:16
37760	9d6b59eb-a477-4542-ba17-e53cd0632084	9d6b59eb-e896-4bd4-bf48-a9a9a6045aec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-05 16:59:16
37761	9d6b59eb-e3cb-4927-be7b-985c58db7e18	9d6b59eb-e896-4bd4-bf48-a9a9a6045aec	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"139.62","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:59:16
37762	9d6b59eb-e421-46ee-9d94-1f1829807e19	9d6b59eb-e896-4bd4-bf48-a9a9a6045aec	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:59:16
37763	9d6b59eb-e744-4d41-81a4-9edab10b4ac8	9d6b59eb-e896-4bd4-bf48-a9a9a6045aec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-05 16:59:16
37764	9d6b59eb-e783-4da5-a4e5-71cc56de49fe	9d6b59eb-e896-4bd4-bf48-a9a9a6045aec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:59:16
38000	9d6b5e63-394e-41fb-9ba6-a7494f24e91b	9d6b5e63-63d2-4db3-804e-9902f67db8d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:11:46
38001	9d6b5e63-6186-4124-a3e2-e7b2695b0baf	9d6b5e63-63d2-4db3-804e-9902f67db8d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:11:46
38002	9d6b5e63-627d-49f5-8b42-1d018dfb859d	9d6b5e63-63d2-4db3-804e-9902f67db8d0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":590,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:11:46
37765	9d6b59ec-2b7a-4ac6-a00e-77c26233c5aa	9d6b59ec-6fa4-4593-9ab4-057c59471a6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-05 16:59:17
37766	9d6b59ec-6ab6-4b33-9af2-c8e0f4d0e4a8	9d6b59ec-6fa4-4593-9ab4-057c59471a6b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"139.81","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:59:17
37767	9d6b59ec-6b33-4ee0-8b5e-cd2ae59c5588	9d6b59ec-6fa4-4593-9ab4-057c59471a6b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:59:17
37768	9d6b59ec-6e76-431c-a66e-1dbd0587be13	9d6b59ec-6fa4-4593-9ab4-057c59471a6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-05 16:59:17
37769	9d6b59ec-6eb4-4f59-84e9-047c2be7ea8d	9d6b59ec-6fa4-4593-9ab4-057c59471a6b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":328,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:59:17
38003	9d6b5e63-d5ce-4528-8871-269b5a71c359	9d6b5e63-fad3-478c-adbf-3349b160adc4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:11:46
38004	9d6b5e63-f4f1-4d2c-9b65-a31d7c1187a8	9d6b5e63-fad3-478c-adbf-3349b160adc4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"58.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:11:46
38005	9d6b5e63-f900-4e95-a791-e7ab8a942e14	9d6b5e63-fad3-478c-adbf-3349b160adc4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 17:11:46
38006	9d6b5e63-f981-4bc7-a99c-7b692bdda950	9d6b5e63-fad3-478c-adbf-3349b160adc4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":317,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:11:46
37770	9d6b59ef-6c0b-410e-b99e-f74b452227f3	9d6b59ef-b4e1-46bb-b61d-629a0a840cc9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-05 16:59:19
37771	9d6b59ef-ae3a-4313-ab45-fa506d53239d	9d6b59ef-b4e1-46bb-b61d-629a0a840cc9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 93\\n                        ","time":"144.82","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9c742b70d7e4a1a77b260fd1a8993140","hostname":"EderCortes"}	2024-11-05 16:59:19
37772	9d6b59ef-b0ad-4dec-aa13-23264bc99a8f	9d6b59ef-b4e1-46bb-b61d-629a0a840cc9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"2.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":304,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-05 16:59:19
37773	9d6b59ef-b392-4559-a983-47904f1ceed3	9d6b59ef-b4e1-46bb-b61d-629a0a840cc9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-05 16:59:19
37774	9d6b59ef-b3d9-4d9c-8d62-8508afbddbe3	9d6b59ef-b4e1-46bb-b61d-629a0a840cc9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":93,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1000000","loans_pago_interes":"250000","user_alias":"juan_jaramillo"},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:19:45","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000","user_alias":"eder.cortes"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:22:30","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000","user_alias":"eder.cortes"},{"id":399,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:22:30","updated_at":"2024-11-04 17:27:01","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000","user_alias":"eder.cortes"},{"id":400,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:22:30","updated_at":"2024-11-04 17:27:01","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000","user_alias":"eder.cortes"},{"id":401,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:22:30","updated_at":"2024-11-04 17:27:01","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000","user_alias":"eder.cortes"},{"id":402,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:22:30","updated_at":"2024-11-04 17:27:01","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000","user_alias":"eder.cortes"}]}},"duration":489,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:59:19
38007	9d6b5e64-67b8-435b-88ac-78190e5bd7c3	9d6b5e64-8953-48e4-b07b-836ac6e72c66	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 17:11:47
38008	9d6b5e64-8374-4308-aeaf-3f87cfd015c1	9d6b5e64-8953-48e4-b07b-836ac6e72c66	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:11:47
38009	9d6b5e64-83da-421f-98c0-68d96f7fdc0e	9d6b5e64-8953-48e4-b07b-836ac6e72c66	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:11:47
38010	9d6b5e64-8822-4d82-ad10-fc11030389cf	9d6b5e64-8953-48e4-b07b-836ac6e72c66	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 17:11:47
38011	9d6b5e64-8868-49df-af3c-0e64529eabd7	9d6b5e64-8953-48e4-b07b-836ac6e72c66	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:11:47
37775	9d6b59fd-f136-4255-aaae-1ecb209daac8	9d6b59fe-0fc6-4962-9359-911704ae204a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-05 16:59:28
37776	9d6b59fe-0b24-471e-ae65-c05db6c08294	9d6b59fe-0fc6-4962-9359-911704ae204a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"45.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 16:59:28
37777	9d6b59fe-0e3c-403a-9378-882c2b2e9ed4	9d6b59fe-0fc6-4962-9359-911704ae204a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-05 16:59:28
37778	9d6b59fe-0eb5-444e-931d-4df449da9170	9d6b59fe-0fc6-4962-9359-911704ae204a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:59:28
38012	9d6b5e64-d50e-4399-bab9-9662d031517c	9d6b5e64-f324-4d0f-9b45-53435f391822	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 17:11:47
38013	9d6b5e64-ee45-4291-9263-9eeb634ffefe	9d6b5e64-f324-4d0f-9b45-53435f391822	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:11:47
38014	9d6b5e64-ee8d-4dad-9ba1-8020e770e267	9d6b5e64-f324-4d0f-9b45-53435f391822	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:11:47
38015	9d6b5e64-f1b6-4689-82e1-f7ac54bc4f8c	9d6b5e64-f324-4d0f-9b45-53435f391822	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 17:11:47
38016	9d6b5e64-f224-4994-8092-773d1ae4e2f1	9d6b5e64-f324-4d0f-9b45-53435f391822	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:11:47
37779	9d6b59fe-5c4f-454b-92f6-ba3b9774b608	9d6b59fe-7b53-48a1-8b45-559776f3b4bc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-05 16:59:29
37780	9d6b59fe-7652-4ba8-9ee1-7e3cc609faae	9d6b59fe-7b53-48a1-8b45-559776f3b4bc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:59:29
37781	9d6b59fe-76a4-42ab-9c4d-7c432fe61374	9d6b59fe-7b53-48a1-8b45-559776f3b4bc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:59:29
37782	9d6b59fe-7a1c-4b47-8f2d-cd3179daae1d	9d6b59fe-7b53-48a1-8b45-559776f3b4bc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-05 16:59:29
37783	9d6b59fe-7a65-4d18-83a6-85dd7c455304	9d6b59fe-7b53-48a1-8b45-559776f3b4bc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":265,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:59:29
38017	9d6b5e66-7682-401b-91c3-05b732b826ab	9d6b5e66-c8a6-40df-bf3a-cc1054bde951	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 17:11:48
38018	9d6b5e66-c284-4bc0-b477-fadb50487a30	9d6b5e66-c8a6-40df-bf3a-cc1054bde951	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"153.69","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:11:48
38019	9d6b5e66-c2e4-4122-ba7b-10a99b31057a	9d6b5e66-c8a6-40df-bf3a-cc1054bde951	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:11:48
38020	9d6b5e66-c6d9-4cd6-9056-8a946d7c1cda	9d6b5e66-c8a6-40df-bf3a-cc1054bde951	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 17:11:48
38021	9d6b5e66-c746-493f-aced-d22c7ddac4d0	9d6b5e66-c8a6-40df-bf3a-cc1054bde951	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":666,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:11:48
37784	9d6b59fe-bd1f-48dd-b601-e77953a84a8e	9d6b59ff-01ad-4a27-928a-86806be296a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-05 16:59:29
37785	9d6b59fe-fc43-435a-ab20-b3325e813625	9d6b59ff-01ad-4a27-928a-86806be296a1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"140.45","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:59:29
37786	9d6b59fe-fcbe-40d0-945f-6557cbbb218a	9d6b59ff-01ad-4a27-928a-86806be296a1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:59:29
37787	9d6b59ff-007f-4ec9-a5fb-023059f56b27	9d6b59ff-01ad-4a27-928a-86806be296a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-05 16:59:29
37788	9d6b59ff-00be-4896-8045-48ec4131e454	9d6b59ff-01ad-4a27-928a-86806be296a1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:59:29
26861	9d68dd4e-d5ea-49f6-a69a-df5638a10c73	9d68dd4e-f526-4b7e-8826-229ac7d8050e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:19:10
26862	9d68dd4e-f354-4c2e-8921-70e3150ae4e3	9d68dd4e-f526-4b7e-8826-229ac7d8050e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:19:10
26863	9d68dd4e-f406-4550-9658-1f838170ba77	9d68dd4e-f526-4b7e-8826-229ac7d8050e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":386,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:19:10
26864	9d68dd4f-7897-42f6-8d57-b907c091a8a1	9d68dd4f-c663-4beb-bf1d-25bbe5a07313	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:19:11
26865	9d68dd4f-bccd-46c7-88e6-b540842de673	9d68dd4f-c663-4beb-bf1d-25bbe5a07313	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"161.67","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:19:11
26866	9d68dd4f-c0b3-4422-a7da-0ea29118d338	9d68dd4f-c663-4beb-bf1d-25bbe5a07313	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"1.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:19:11
26867	9d68dd4f-c0ef-4f42-bd1b-7cdcd691392e	9d68dd4f-c663-4beb-bf1d-25bbe5a07313	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:19:11
26868	9d68dd4f-c50a-40d3-8923-552d089c2261	9d68dd4f-c663-4beb-bf1d-25bbe5a07313	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 11:19:11
26869	9d68dd4f-c564-4fd9-ae4c-6d21c5c194d5	9d68dd4f-c663-4beb-bf1d-25bbe5a07313	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":479,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:19:11
37789	9d6b5a03-101d-4f21-9225-4ead8d5616e1	9d6b5a03-5ee3-42c4-a2fd-b0c207f06bbb	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 16:59:32
37790	9d6b5a03-55a6-4471-a602-fd0c168efc6b	9d6b5a03-5ee3-42c4-a2fd-b0c207f06bbb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 87\\n                        ","time":"147.90","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"309a6eff5ebe9f2d91248732844dd9ed","hostname":"EderCortes"}	2024-11-05 16:59:32
37791	9d6b5a03-58be-4d19-afed-743d83ca77e7	9d6b5a03-5ee3-42c4-a2fd-b0c207f06bbb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '87' order by \\"item_loans\\".\\"id\\" asc","time":"2.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":304,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-05 16:59:32
37792	9d6b5a03-5d32-42cc-b6f4-10f8c934d376	9d6b5a03-5ee3-42c4-a2fd-b0c207f06bbb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 16:59:32
37793	9d6b5a03-5d9a-4099-9632-ad4cc3b5ed0c	9d6b5a03-5ee3-42c4-a2fd-b0c207f06bbb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/87","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":87,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"620000","loans_pago_interes":"155000","user_alias":"juan_jaramillo"},"items":[{"id":341,"loans_codigo":87,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 20:50:52","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000","user_alias":"eder.cortes"},{"id":342,"loans_codigo":87,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 21:01:12","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":445,"loans_codigo":87,"itemloans_cuota":"3","itemloans_valor_cuota":"160000","itemloans_iteres":"40000","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 21:01:12","updated_at":"2024-11-05 16:23:50","deleted_at":null,"item_loans_cuando_pago":"2024-11-05 00:00:00","itemloans_interes_canelado":"40000","itemloans_cuota_cancelada":"160000","user_alias":"eder.cortes"},{"id":485,"loans_codigo":87,"itemloans_cuota":"4","itemloans_valor_cuota":"240000","itemloans_iteres":"60000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-05 16:23:50","updated_at":"2024-11-05 16:23:50","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":486,"loans_codigo":87,"itemloans_cuota":"5","itemloans_valor_cuota":"240000","itemloans_iteres":"60000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-21 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-05 16:23:50","updated_at":"2024-11-05 16:23:50","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":435,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:59:32
28519	9d6901e5-59df-4c9d-831b-57c39e4fbeb5	9d6901e5-9207-46ec-9732-8ca7b0661005	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 13:01:29
28520	9d6901e5-8efc-40f8-8383-fd5a38352863	9d6901e5-9207-46ec-9732-8ca7b0661005	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 13:01:29
28521	9d6901e5-9086-4f28-9aff-7470bf547532	9d6901e5-9207-46ec-9732-8ca7b0661005	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":615,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:01:29
28522	9d6901e6-69b9-4d97-9a20-7762b547f754	9d6901e6-9aba-4ed4-9f89-1a1bdbab8adf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 13:01:30
28523	9d6901e6-8c3b-47c7-a14b-3b7996b5f161	9d6901e6-9aba-4ed4-9f89-1a1bdbab8adf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"68.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 13:01:30
28524	9d6901e6-9273-4e6b-800b-7d5e94979b0e	9d6901e6-9aba-4ed4-9f89-1a1bdbab8adf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:01:30
28525	9d6901e6-92c2-4d59-ae83-46d851cfa3d4	9d6901e6-9aba-4ed4-9f89-1a1bdbab8adf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:01:30
28526	9d6901e6-98e2-4b75-8e34-b0ee5b70176d	9d6901e6-9aba-4ed4-9f89-1a1bdbab8adf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-04 13:01:30
28527	9d6901e6-9964-4f1f-a804-385ccca90328	9d6901e6-9aba-4ed4-9f89-1a1bdbab8adf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":596,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:01:30
28528	9d6901e9-4c35-45f7-83de-ba5439e6872c	9d6901ea-095e-4acd-9896-45630cfa673b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-04 13:01:31
28529	9d6901e9-fdb9-4a24-8007-c84238572e40	9d6901ea-095e-4acd-9896-45630cfa673b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"408.35","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:01:32
28530	9d6901e9-fe50-45e5-8091-65f9b9b53162	9d6901ea-095e-4acd-9896-45630cfa673b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:01:32
28531	9d6901ea-06f1-4fa6-a7f2-e07d0e82ac6d	9d6901ea-095e-4acd-9896-45630cfa673b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-04 13:01:32
28532	9d6901ea-079c-4e78-8e39-dac6b7a461af	9d6901ea-095e-4acd-9896-45630cfa673b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":2223,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:01:32
28533	9d6901eb-09d8-4595-840d-c616bca126e5	9d6901eb-41e9-4667-8e80-2f233e78b994	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-04 13:01:33
28534	9d6901eb-3743-4556-bb7a-2bca3ed7f34b	9d6901eb-41e9-4667-8e80-2f233e78b994	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"69.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:01:33
28535	9d6901eb-37d2-493a-9f01-034405443e42	9d6901eb-41e9-4667-8e80-2f233e78b994	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:01:33
28536	9d6901eb-3f8b-42ca-ab2c-e586bb4f0aab	9d6901eb-41e9-4667-8e80-2f233e78b994	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-04 13:01:33
28537	9d6901eb-401b-4a86-ad6b-8223c2e71b4e	9d6901eb-41e9-4667-8e80-2f233e78b994	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":735,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:01:33
38174	9d6b5fde-2a60-4b67-b78c-51ae7a769c47	9d6b5fde-49b6-4aaa-8240-c66b720408e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 17:15:54
38175	9d6b5fde-4844-4253-9542-54a256fb97f6	9d6b5fde-49b6-4aaa-8240-c66b720408e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 17:15:54
38176	9d6b5fde-48e4-4e49-a46b-441d85c823b8	9d6b5fde-49b6-4aaa-8240-c66b720408e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":280,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:15:54
30250	9d6937a0-394b-4e81-9b9e-d124433a36ca	9d6937a0-7e0c-4185-b454-7bc294ac8ed7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 15:31:43
30251	9d6937a0-7b34-4667-b101-11468aafa47c	9d6937a0-7e0c-4185-b454-7bc294ac8ed7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 15:31:43
30252	9d6937a0-7c54-4020-8c20-2f5f5119cf5d	9d6937a0-7e0c-4185-b454-7bc294ac8ed7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":491,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:31:43
30253	9d6937a1-097b-4c0e-a57d-ba0996eb706e	9d6937a1-3b35-4ae7-8ad7-5563ee7f34b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 15:31:44
30254	9d6937a1-31c8-4f80-a455-cec2bcd1f005	9d6937a1-3b35-4ae7-8ad7-5563ee7f34b2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"62.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":56,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 15:31:44
30255	9d6937a1-3252-40a2-8dd3-1685ee1457e4	9d6937a1-3b35-4ae7-8ad7-5563ee7f34b2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 15:31:44
30256	9d6937a1-3963-4e2c-a94d-803e1db6f819	9d6937a1-3b35-4ae7-8ad7-5563ee7f34b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 15:31:44
30257	9d6937a1-39dd-49c8-861a-d89f1ea64d31	9d6937a1-3b35-4ae7-8ad7-5563ee7f34b2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":394,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:31:44
38177	9d6b5fde-b238-4515-a187-dbe455e9993c	9d6b5fde-d3f6-42ed-9d42-e6b52bdd8254	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 17:15:54
38178	9d6b5fde-ce3a-4e2c-958d-85e49debdac1	9d6b5fde-d3f6-42ed-9d42-e6b52bdd8254	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"50.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:15:54
38179	9d6b5fde-d23a-40c0-97a7-de2029891c57	9d6b5fde-d3f6-42ed-9d42-e6b52bdd8254	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 17:15:54
38180	9d6b5fde-d2d5-4746-b6e4-701349d5cc9c	9d6b5fde-d3f6-42ed-9d42-e6b52bdd8254	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":283,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:15:55
30258	9d6937a2-05b9-4462-a20c-0da9e21b5c6b	9d6937a2-b15e-47f2-b3bd-7a33e4a6d067	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 15:31:45
30259	9d6937a2-a6db-43f9-803f-b317ea496df3	9d6937a2-b15e-47f2-b3bd-7a33e4a6d067	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"223.89","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:31:45
30260	9d6937a2-a773-450d-9f4e-7f6fb65e1097	9d6937a2-b15e-47f2-b3bd-7a33e4a6d067	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:31:45
30261	9d6937a2-af48-4be1-bacd-5dc6ed7fdd80	9d6937a2-b15e-47f2-b3bd-7a33e4a6d067	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 15:31:45
30262	9d6937a2-afda-4ad6-93e9-786abdb50b54	9d6937a2-b15e-47f2-b3bd-7a33e4a6d067	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":935,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:31:45
38181	9d6b5fdf-4a65-49f6-8311-e7fd68e0d776	9d6b5fdf-7967-40d7-97a2-ffda0f4eefcc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 17:15:55
38182	9d6b5fdf-72a6-492c-8870-331abd95cecd	9d6b5fdf-7967-40d7-97a2-ffda0f4eefcc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"61.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:15:55
38183	9d6b5fdf-730f-4c97-a74d-f9f001b3aa49	9d6b5fdf-7967-40d7-97a2-ffda0f4eefcc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:15:55
38184	9d6b5fdf-7742-49bb-b47d-5cf62b0094b0	9d6b5fdf-7967-40d7-97a2-ffda0f4eefcc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 17:15:55
38185	9d6b5fdf-77bd-4d25-8e79-563593593b88	9d6b5fdf-7967-40d7-97a2-ffda0f4eefcc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":410,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:15:55
30263	9d6937a3-5d8b-4916-b93f-9222889e78bd	9d6937a3-9335-4acd-a906-55f548514023	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 15:31:45
30264	9d6937a3-88e8-4aad-a934-b20237d8cf34	9d6937a3-9335-4acd-a906-55f548514023	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"68.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:31:45
30265	9d6937a3-8986-4c4a-ad46-dca98aef6e6f	9d6937a3-9335-4acd-a906-55f548514023	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:31:45
30266	9d6937a3-9115-4cfc-a4eb-4478f75779ac	9d6937a3-9335-4acd-a906-55f548514023	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 15:31:45
30267	9d6937a3-9194-4163-beff-768b4a4b64c0	9d6937a3-9335-4acd-a906-55f548514023	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":552,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:31:45
38186	9d6b5fe0-04a5-4d69-b85b-22472332a9a6	9d6b5fe0-2a26-4c0c-a1d9-e6b8e41f0882	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 17:15:55
38187	9d6b5fe0-247b-4524-9296-eaf5b1357b2e	9d6b5fe0-2a26-4c0c-a1d9-e6b8e41f0882	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:15:55
38188	9d6b5fe0-24ce-4534-be7d-aba12e0e7f0a	9d6b5fe0-2a26-4c0c-a1d9-e6b8e41f0882	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:15:55
38189	9d6b5fe0-28df-4ba5-8770-d184d02f8580	9d6b5fe0-2a26-4c0c-a1d9-e6b8e41f0882	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 17:15:55
38190	9d6b5fe0-2949-401e-b8d3-6d6fa2420bfe	9d6b5fe0-2a26-4c0c-a1d9-e6b8e41f0882	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":433,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:15:55
30268	9d6937a7-dfcf-4cc3-82e3-b5be6095541d	9d6937a7-e44f-46bc-8bcf-9b53f7c52eed	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/actualizar-users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"PUT","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":316,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:31:48
38191	9d6b5fe1-bf0d-4782-8e97-07ae974b4d25	9d6b5fe2-1038-4078-9d6a-4a791148eee2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 17:15:56
38192	9d6b5fe2-0709-4261-838b-3e3a13d56a8d	9d6b5fe2-1038-4078-9d6a-4a791148eee2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"111.40","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:15:57
38193	9d6b5fe2-0788-49ab-add3-fb34a097134e	9d6b5fe2-1038-4078-9d6a-4a791148eee2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:15:57
38194	9d6b5fe2-0e3b-483e-ac94-9090974f47bb	9d6b5fe2-1038-4078-9d6a-4a791148eee2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 17:15:57
38195	9d6b5fe2-0ebe-4aab-b311-209750027188	9d6b5fe2-1038-4078-9d6a-4a791148eee2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":627,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:15:57
30269	9d6937a8-3ed0-4e9e-93b1-ae2c41a92af6	9d6937a8-41b1-4551-a74e-490b551a9e20	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/actualizar-users","method":"PUT","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"547","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","profile_code":1,"user_age":"29","user_alias":"eder_cortes","email_verified_at":null,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},"session":[],"response_status":404,"response":{"error":"El m\\u00e9todo especificado en la petici\\u00f3n no es val\\u00eddo","code":404},"duration":161,"memory":20,"hostname":"EderCortes"}	2024-11-04 15:31:49
18452	9d669186-5b85-41b3-9b2d-6bceccea4753	9d669186-5ee5-4d9d-b3be-ec108ec28911	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":882}	2024-11-03 07:55:37
30479	9d693fab-4853-4918-b953-dea838a06c52	9d693fab-a928-4466-837f-6c17050f8f14	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 15:54:13
30480	9d693fab-a677-4eb4-880e-13c8a0a10ea9	9d693fab-a928-4466-837f-6c17050f8f14	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 15:54:13
30481	9d693fab-a7b3-47a8-9c2b-a98d1dd5830d	9d693fab-a928-4466-837f-6c17050f8f14	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":799,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:54:13
30368	9d693c43-14a1-4aff-b192-96b4e2204b29	9d693c43-3346-4c55-81e6-cffea3dfc265	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 15:44:41
30369	9d693c43-3182-48b4-8cde-190a283e8178	9d693c43-3346-4c55-81e6-cffea3dfc265	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 15:44:41
30370	9d693c43-324e-4083-bdb3-0009431b827d	9d693c43-3346-4c55-81e6-cffea3dfc265	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:44:41
30371	9d693c43-9c0d-4d49-864b-d5fb99bfcc48	9d693c43-e519-4f6a-b4e5-15d710328c12	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 15:44:41
30372	9d693c43-e004-42a0-b98d-389f5016938d	9d693c43-e519-4f6a-b4e5-15d710328c12	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"151.55","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":56,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 15:44:42
30373	9d693c43-e05c-4ae7-b1e0-4f1eb90d7daa	9d693c43-e519-4f6a-b4e5-15d710328c12	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 15:44:42
30374	9d693c43-e3ee-4f3c-adf3-2e777f1d4f6f	9d693c43-e519-4f6a-b4e5-15d710328c12	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 15:44:42
30375	9d693c43-e434-4a61-b5f9-cfbdb82e2c61	9d693c43-e519-4f6a-b4e5-15d710328c12	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cab","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:44:39.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:44:42
30482	9d693fac-c44d-42aa-bfee-af5e438acf34	9d693fac-f9fa-420d-bf75-84c80ad5647d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 15:54:14
30483	9d693fac-ee22-47a7-97ac-4626cc1ee31f	9d693fac-f9fa-420d-bf75-84c80ad5647d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"79.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 15:54:14
30484	9d693fac-f2b0-4d4c-bd0a-502c88561613	9d693fac-f9fa-420d-bf75-84c80ad5647d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 15:54:14
30485	9d693fac-f2f5-4950-bcad-01126808a129	9d693fac-f9fa-420d-bf75-84c80ad5647d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 15:54:14
30486	9d693fac-f86d-4eaa-95f0-34f3e4ff8116	9d693fac-f9fa-420d-bf75-84c80ad5647d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 15:54:14
30487	9d693fac-f8cf-4b38-b775-f4a7cc81ba29	9d693fac-f9fa-420d-bf75-84c80ad5647d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":737,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:54:14
30376	9d693c45-d151-4a2b-8f1c-18615201c2d6	9d693c45-f497-4aac-a8fa-ce51f7c91a6c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 15:44:43
30377	9d693c45-ef51-42a1-9e89-58834afeb1db	9d693c45-f497-4aac-a8fa-ce51f7c91a6c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"52.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:44:43
30378	9d693c45-efb6-4e3b-9494-0fe00d8ef7d2	9d693c45-f497-4aac-a8fa-ce51f7c91a6c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:44:43
30379	9d693c45-f35e-475c-ae53-65a18db42fcd	9d693c45-f497-4aac-a8fa-ce51f7c91a6c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 15:44:43
30380	9d693c45-f3a9-4c51-b7b6-e1f437ac0b3e	9d693c45-f497-4aac-a8fa-ce51f7c91a6c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":425,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:44:43
30488	9d693fad-9c44-4570-b65a-169732ca2138	9d693fad-df00-4be7-8fba-ab599eb01efe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 15:54:14
30489	9d693fad-d475-4256-99a7-a65699755600	9d693fad-df00-4be7-8fba-ab599eb01efe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"69.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:54:14
30490	9d693fad-d4fb-4fce-b463-6e156f3e9fe1	9d693fad-df00-4be7-8fba-ab599eb01efe	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:54:14
30491	9d693fad-dca3-4f22-90c1-7f34dc317ef8	9d693fad-df00-4be7-8fba-ab599eb01efe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 15:54:14
30492	9d693fad-dd2e-48c0-972e-b6d8f718bae0	9d693fad-df00-4be7-8fba-ab599eb01efe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":565,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:54:14
30381	9d693ce2-6aa5-4203-914c-a390a8111688	9d693ce2-6f41-45d6-80ad-0e6367e25f5a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/updateUser","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":160,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:46:25
30493	9d693fae-9d72-4cb6-b72d-b50c43a3b6f4	9d693fae-f3cb-4612-99e8-34ff22321aee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 15:54:15
30494	9d693fae-ea6e-45cb-8e2e-df2b5849edae	9d693fae-f3cb-4612-99e8-34ff22321aee	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"165.41","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:54:15
30495	9d693fae-eae7-4a1c-8fe2-2bb434dfc151	9d693fae-f3cb-4612-99e8-34ff22321aee	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:54:15
30496	9d693fae-f1d5-4dbf-99c5-5e3d5b55045b	9d693fae-f3cb-4612-99e8-34ff22321aee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 15:54:15
30497	9d693fae-f260-4293-a19a-005b6e705108	9d693fae-f3cb-4612-99e8-34ff22321aee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":674,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:54:15
25833	9d68c9e8-ec4f-4fab-8bc4-b20a52c61083	9d68c9e9-2a80-4082-bb81-fba273d46950	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 10:24:56
25834	9d68c9e9-27a4-4c8e-85bf-5d46cf3da942	9d68c9e9-2a80-4082-bb81-fba273d46950	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:24:56
25835	9d68c9e9-2917-4a87-a126-9eb2073ffa05	9d68c9e9-2a80-4082-bb81-fba273d46950	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":636,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:24:56
25836	9d68c9e9-fd85-4d12-a6f0-70c1f371eff6	9d68c9ea-2bb5-4b20-a606-c8cc4d1b7fbb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 10:24:57
25837	9d68c9ea-1bc4-4b48-94ee-1b451d739031	9d68c9ea-2bb5-4b20-a606-c8cc4d1b7fbb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 90\\n                        ","time":"59.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"93c10371e33ace24260de21c3ff3890d","hostname":"EderCortes"}	2024-11-04 10:24:57
25838	9d68c9ea-2208-41ff-99e5-2e74a79b01eb	9d68c9ea-2bb5-4b20-a606-c8cc4d1b7fbb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"4.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:24:57
25839	9d68c9ea-2273-4f32-b40b-fba2e73893d4	9d68c9ea-2bb5-4b20-a606-c8cc4d1b7fbb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 10:24:57
25840	9d68c9ea-29f9-4a4e-8b3c-c76617a9b934	9d68c9ea-2bb5-4b20-a606-c8cc4d1b7fbb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:24:57
25841	9d68c9ea-2a7c-4056-813e-7a0c35205051	9d68c9ea-2bb5-4b20-a606-c8cc4d1b7fbb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"}]}},"duration":575,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:24:57
25842	9d68c9eb-a639-450f-8578-e2c1dfd4986b	9d68c9ec-0d59-4481-9ff3-6cdd59b2e1d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 10:24:58
25843	9d68c9ec-0227-4db4-9ac4-697f86739d10	9d68c9ec-0d59-4481-9ff3-6cdd59b2e1d8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"84.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:24:58
25844	9d68c9ec-02d2-4653-befa-c0c50d21657d	9d68c9ec-0d59-4481-9ff3-6cdd59b2e1d8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:24:58
25845	9d68c9ec-0b04-4a61-b0cc-fabd955dafc5	9d68c9ec-0d59-4481-9ff3-6cdd59b2e1d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:24:58
25846	9d68c9ec-0ba1-4c07-ad2d-eda8ab3692e8	9d68c9ec-0d59-4481-9ff3-6cdd59b2e1d8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1208,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:24:58
25847	9d68c9ed-2ed3-4053-891a-50d87ee8c1f3	9d68c9ed-7852-4630-9f05-177dd3de8253	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 10:24:59
25848	9d68c9ed-69cf-43af-aae5-005e92974230	9d68c9ed-7852-4630-9f05-177dd3de8253	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"104.90","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:24:59
25849	9d68c9ed-6a89-42fa-8f10-e8447b2d6917	9d68c9ed-7852-4630-9f05-177dd3de8253	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:24:59
25850	9d68c9ed-75aa-458a-b573-352dd3fe78f3	9d68c9ed-7852-4630-9f05-177dd3de8253	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:24:59
25851	9d68c9ed-764e-48c3-896b-3211866a7926	9d68c9ed-7852-4630-9f05-177dd3de8253	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":902,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:24:59
38335	9d6b62d3-2ed2-4aed-ae7b-dab495d8db03	9d6b62d3-738d-4f75-821b-184d85eec4d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:24:10
38336	9d6b62d3-720b-45b2-9c20-6546e28b165a	9d6b62d3-738d-4f75-821b-184d85eec4d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:24:10
38337	9d6b62d3-729d-4532-b82f-ab31821b62ce	9d6b62d3-738d-4f75-821b-184d85eec4d1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:24:10
38338	9d6b62d3-ce35-4649-8806-3d2a982f8f1a	9d6b62d3-ec61-4ca6-ac14-2366ef7e053e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:24:11
38339	9d6b62d3-e721-4eed-93cd-693f1fbe3b0f	9d6b62d3-ec61-4ca6-ac14-2366ef7e053e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"46.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:24:11
38340	9d6b62d3-eabe-479b-b14b-e3b4accf09b5	9d6b62d3-ec61-4ca6-ac14-2366ef7e053e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 17:24:11
38341	9d6b62d3-eb3a-47cf-94bf-48654f8ca9f9	9d6b62d3-ec61-4ca6-ac14-2366ef7e053e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:24:11
38342	9d6b62d4-3617-4d4b-b64f-1e9095934b4c	9d6b62d4-563b-4d64-b290-ba8ac898022d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 17:24:11
38343	9d6b62d4-511e-4f17-87e9-2ab589ec4ae7	9d6b62d4-563b-4d64-b290-ba8ac898022d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:24:11
38344	9d6b62d4-51a8-4cd7-8879-2012b7321709	9d6b62d4-563b-4d64-b290-ba8ac898022d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:24:11
38345	9d6b62d4-5520-4b85-bf0a-0dc3891b931b	9d6b62d4-563b-4d64-b290-ba8ac898022d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 17:24:11
38346	9d6b62d4-5565-4d24-83c5-0aa5dce32353	9d6b62d4-563b-4d64-b290-ba8ac898022d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":262,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:24:11
38347	9d6b62d4-9ca6-4a35-b693-d6936a60e55f	9d6b62d4-e2c5-48a0-aa66-e44a959db558	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 17:24:11
38348	9d6b62d4-dd9f-4d2b-b608-13fb829ac6f2	9d6b62d4-e2c5-48a0-aa66-e44a959db558	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"143.58","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:24:11
38349	9d6b62d4-ddf3-4875-bb34-10b6a6a43dac	9d6b62d4-e2c5-48a0-aa66-e44a959db558	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:24:11
38350	9d6b62d4-e1a9-402b-9e74-3d5f695cafa3	9d6b62d4-e2c5-48a0-aa66-e44a959db558	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 17:24:11
38351	9d6b62d4-e1eb-48e1-8896-e2e64ec1a2d9	9d6b62d4-e2c5-48a0-aa66-e44a959db558	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":342,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:24:11
38352	9d6b62d6-5f09-448b-9381-a1546f06bfc5	9d6b62d6-7da0-474a-9ee4-a8a488eeae87	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 17:24:12
38353	9d6b62d6-780e-457c-ab3e-d944cf72ee0d	9d6b62d6-7da0-474a-9ee4-a8a488eeae87	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:24:12
38354	9d6b62d6-7860-4310-9dbb-8401273d65a1	9d6b62d6-7da0-474a-9ee4-a8a488eeae87	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:24:12
38355	9d6b62d6-7c32-427e-9521-aef8773e7dc4	9d6b62d6-7da0-474a-9ee4-a8a488eeae87	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 17:24:12
38356	9d6b62d6-7c86-4fed-9737-67e06d812375	9d6b62d6-7da0-474a-9ee4-a8a488eeae87	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":515,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:24:12
38548	9d6b669c-3cbe-4041-8535-d2ad7c2183c5	9d6b669c-8666-4614-a265-d3a873ec74f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:34:45
38549	9d6b669c-84c4-40bc-9399-30199314d0b3	9d6b669c-8666-4614-a265-d3a873ec74f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:34:45
38550	9d6b669c-8567-42b7-8932-189ff00ada11	9d6b669c-8666-4614-a265-d3a873ec74f4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":415,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:34:45
38551	9d6b669c-e15e-419d-bc64-9ff68aaf50b5	9d6b669c-e4a3-4a95-9010-c2e8609a942a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/listPrecautions","method":"POST","controller_action":null,"middleware":[],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":404,"response":{"error":"No se encontro la url especificada","code":404},"duration":161,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:34:46
38552	9d6b669d-3f8c-4b26-9d5a-122cc7434756	9d6b669d-5e50-4507-a084-07f81e4da454	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:34:46
38553	9d6b669d-5944-4697-8e70-a284c745ea33	9d6b669d-5e50-4507-a084-07f81e4da454	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:34:46
38554	9d6b669d-5991-40ae-86d1-017813f3cfc2	9d6b669d-5e50-4507-a084-07f81e4da454	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:34:46
38555	9d6b669d-5d10-4470-9a52-3d66172eddcb	9d6b669d-5e50-4507-a084-07f81e4da454	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:34:46
38556	9d6b669d-5d53-4476-9006-7f24f0c85beb	9d6b669d-5e50-4507-a084-07f81e4da454	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:34:46
30671	9d694251-39d9-431a-89ce-41d65241f4aa	9d694251-cf9f-4ae5-9e65-2c56d32111fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:01:37
30672	9d694251-cca9-4e43-a684-71577f953cfa	9d694251-cf9f-4ae5-9e65-2c56d32111fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:01:37
30673	9d694251-ce00-450d-b565-ea73cdb218bb	9d694251-cf9f-4ae5-9e65-2c56d32111fe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":920,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:01:37
30674	9d694252-aed0-4a91-ac88-bd5f19a285ee	9d694252-e2a1-4aa2-aa66-ff8496bb1cea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:01:38
30675	9d694252-d12c-4884-a97a-7f4f07587687	9d694252-e2a1-4aa2-aa66-ff8496bb1cea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"66.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 16:01:38
30676	9d694252-d7ed-48a2-9922-dd7d4717f2b0	9d694252-e2a1-4aa2-aa66-ff8496bb1cea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"3.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 16:01:38
30677	9d694252-d83e-45bc-9f77-37769f70f5af	9d694252-e2a1-4aa2-aa66-ff8496bb1cea	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 16:01:38
30678	9d694252-e04a-4831-b205-d5b912c029cc	9d694252-e2a1-4aa2-aa66-ff8496bb1cea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:01:38
30679	9d694252-e0f9-4e04-8bbd-3c8e0b7da3bd	9d694252-e2a1-4aa2-aa66-ff8496bb1cea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder.cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":563,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:01:38
38557	9d6b669d-a5f6-4932-825f-7e208085c943	9d6b669d-c35a-47e3-b84e-b2057b37ded1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:34:46
38558	9d6b669d-be75-4d49-b943-2a1197a9d88e	9d6b669d-c35a-47e3-b84e-b2057b37ded1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:34:46
38559	9d6b669d-bec7-4276-90fe-6cb69c65cbe2	9d6b669d-c35a-47e3-b84e-b2057b37ded1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:34:46
38560	9d6b669d-c257-4837-b9c8-ab4756c225aa	9d6b669d-c35a-47e3-b84e-b2057b37ded1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 17:34:46
38561	9d6b669d-c298-439b-a43c-6d203066b2a4	9d6b669d-c35a-47e3-b84e-b2057b37ded1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:34:46
30680	9d694253-bc31-429f-8913-fe3f34f5669d	9d694254-2d7f-4cc2-ab54-9a57b171e703	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:01:39
30681	9d694254-25ad-4060-aa2f-ed7df694ec54	9d694254-2d7f-4cc2-ab54-9a57b171e703	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"188.25","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:01:39
30682	9d694254-2646-488e-b3bd-1dfcda7c45b7	9d694254-2d7f-4cc2-ab54-9a57b171e703	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:01:39
30683	9d694254-2bf5-4839-b882-fcd19c2f28db	9d694254-2d7f-4cc2-ab54-9a57b171e703	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:01:39
30684	9d694254-2c63-435a-a83e-ef9b73fc0270	9d694254-2d7f-4cc2-ab54-9a57b171e703	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":823,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:01:39
38562	9d6b669f-9f57-4ab5-936f-82674cc7fbde	9d6b669f-ed4f-4b6b-b1fd-a62630853244	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 17:34:47
38563	9d6b669f-e7d4-406b-8716-f630c1e3d530	9d6b669f-ed4f-4b6b-b1fd-a62630853244	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"161.64","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:34:48
38564	9d6b669f-e830-4eed-9f3b-775e93aad9fa	9d6b669f-ed4f-4b6b-b1fd-a62630853244	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:34:48
38565	9d6b669f-ec29-4b32-b631-55ce53b9d34a	9d6b669f-ed4f-4b6b-b1fd-a62630853244	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 17:34:48
38566	9d6b669f-ec71-4308-99f3-c1cbeecd8367	9d6b669f-ed4f-4b6b-b1fd-a62630853244	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":402,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:34:48
30685	9d694254-a85b-41e9-b5ff-777eca62419d	9d694254-d652-478c-9086-ae9714c475a0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:01:39
30686	9d694254-cd9e-4a10-ad4a-f8e4e5a18612	9d694254-d652-478c-9086-ae9714c475a0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"64.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:01:39
30687	9d694254-ce1c-4033-9ae8-cd696cf6e520	9d694254-d652-478c-9086-ae9714c475a0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:01:39
30688	9d694254-d46b-40f7-acf4-ff42c663d130	9d694254-d652-478c-9086-ae9714c475a0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 16:01:39
30689	9d694254-d4e9-4f0e-87b9-bcd3d0501e7d	9d694254-d652-478c-9086-ae9714c475a0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":408,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:01:39
38567	9d6b66a0-35ac-4e2d-8824-294f70cfe087	9d6b66a0-38b2-43db-bffc-b244405da758	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/listPrecautions","method":"POST","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"0","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":404,"response":{"error":"No se encontro la url especificada","code":404},"duration":161,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:34:48
30690	9d694279-4b49-4009-99d4-4adfcfc41445	9d694279-4e7c-42e8-8259-b7b995a3e0ea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":145,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:02:03
41729	9d6cceff-acc4-4d84-bf51-c7004fd2f553	9d6cceff-afb1-4fe9-879b-edca2fc3ae97	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1922}	2024-11-06 10:22:28
30691	9d694279-bd9a-4786-a78d-3282504bf418	9d69427a-1232-4b02-ac94-c3a34f18a110	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 16:02:04
30692	9d69427a-0dcc-431b-9102-62c254179fcd	9d69427a-1232-4b02-ac94-c3a34f18a110	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ma%' or \\"users\\".\\"user_document\\"::text like '%Ma%') order by \\"users\\".\\"user_document\\" asc","time":"154.04","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 16:02:04
30693	9d69427a-10c6-4546-8bc8-38895ff1242a	9d69427a-1232-4b02-ac94-c3a34f18a110	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 16:02:04
30694	9d69427a-110d-411a-b12c-e1a5db9517c4	9d69427a-1232-4b02-ac94-c3a34f18a110	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ma"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":401,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:02:04
30695	9d69427a-6167-44b4-ae76-ee66ca6a2eae	9d69427a-6621-4511-b2b7-3570f4be22fd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":155,"memory":20,"hostname":"EderCortes"}	2024-11-04 16:02:04
28885	9d690c7a-75a3-48a7-ad73-b79710e19dc1	9d690c7a-a3b9-4512-ae81-e2042e1c9875	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 13:31:04
28886	9d690c7a-a158-434e-bcc7-4b6871750fb5	9d690c7a-a3b9-4512-ae81-e2042e1c9875	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 13:31:04
28887	9d690c7a-a288-4de3-8e7b-68fee3adc431	9d690c7a-a3b9-4512-ae81-e2042e1c9875	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":404,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:31:04
30696	9d69427b-2f3b-4642-a8a7-1affe604ebb1	9d69427b-3336-47e5-af5e-13de633485f9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":214,"memory":20,"hostname":"EderCortes"}	2024-11-04 16:02:04
28888	9d690c7b-20d5-4303-90cb-016a618e3f33	9d690c7b-6b76-46f6-9854-8b98b0f8e6eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 13:31:05
28889	9d690c7b-6571-4d1e-95cb-a383c495ff05	9d690c7b-6b76-46f6-9854-8b98b0f8e6eb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"147.70","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:31:05
28890	9d690c7b-65e5-4f3c-a366-9a98b165d075	9d690c7b-6b76-46f6-9854-8b98b0f8e6eb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 13:31:05
28891	9d690c7b-6a02-49b1-a6a5-02a0ac19c170	9d690c7b-6b76-46f6-9854-8b98b0f8e6eb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 13:31:05
28892	9d690c7b-6a50-4449-b83f-14521df06725	9d690c7b-6b76-46f6-9854-8b98b0f8e6eb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":440,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:31:05
30697	9d69427b-baa5-4d63-91a5-a875cd808368	9d69427b-d871-4f77-bcec-74d01ac743fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 16:02:05
30698	9d69427b-d36b-4d1b-a8e4-974eef1fedd2	9d69427b-d871-4f77-bcec-74d01ac743fa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mar%' or \\"users\\".\\"user_document\\"::text like '%Mar%') order by \\"users\\".\\"user_document\\" asc","time":"44.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 16:02:05
30699	9d69427b-d71d-416c-a4d3-d4ebb3e1d480	9d69427b-d871-4f77-bcec-74d01ac743fa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 16:02:05
30700	9d69427b-d76b-47b8-b28e-fc18682d6712	9d69427b-d871-4f77-bcec-74d01ac743fa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mar"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":264,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:02:05
43560	9d6cea10-b1dc-401a-9bb8-5fe606104c1c	9d6cea10-f43c-465c-9f1a-7dc4b77d14fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":31,"hostname":"EderCortes"}	2024-11-06 11:38:09
43561	9d6cea10-f2dc-4d1e-9d37-a6c0a3ccede1	9d6cea10-f43c-465c-9f1a-7dc4b77d14fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":32,"hostname":"EderCortes"}	2024-11-06 11:38:10
28893	9d690c7b-c0e9-49d3-9689-89c7d3090906	9d690c7b-e83b-4c6e-88e4-d35d3fc80ea4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 13:31:05
28894	9d690c7b-e0db-4d79-87ab-96e043e18259	9d690c7b-e83b-4c6e-88e4-d35d3fc80ea4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"54.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:31:05
28895	9d690c7b-e142-472f-aa20-cfc118861849	9d690c7b-e83b-4c6e-88e4-d35d3fc80ea4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 13:31:05
28896	9d690c7b-e637-4246-92d7-b82cfb16e355	9d690c7b-e83b-4c6e-88e4-d35d3fc80ea4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 13:31:05
28897	9d690c7b-e6bb-4a3f-b899-45742b8cae8e	9d690c7b-e83b-4c6e-88e4-d35d3fc80ea4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":297,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:31:05
30701	9d69427c-18e8-4767-aa5d-46eeb5258468	9d69427c-1c48-4cae-8267-ae970ef6f16c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":150,"memory":20,"hostname":"EderCortes"}	2024-11-04 16:02:05
43563	9d6cea11-580b-4b1f-a461-aab2b6b7d12c	9d6cea11-7971-41b0-ac85-2e671e9829a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":32,"hostname":"EderCortes"}	2024-11-06 11:38:10
43564	9d6cea11-7547-4708-8398-2b49a500acc1	9d6cea11-7971-41b0-ac85-2e671e9829a2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"58.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 11:38:10
43565	9d6cea11-781c-4684-8744-cf3f6e515a06	9d6cea11-7971-41b0-ac85-2e671e9829a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":33,"hostname":"EderCortes"}	2024-11-06 11:38:10
43566	9d6cea11-7889-43c0-b283-0378e6b4fa63	9d6cea11-7971-41b0-ac85-2e671e9829a2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":94,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":6000000,"loans_cuotas":18,"loans_estado":"En curso","loans_intereses":20,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"06-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:10
28898	9d690c7c-41a5-460c-9fd9-556f88f5130f	9d690c7c-68dd-474b-b72f-22c39a6ace4f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 13:31:05
28899	9d690c7c-5f55-4f7c-85c9-48cca27ade02	9d690c7c-68dd-474b-b72f-22c39a6ace4f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '89' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"48.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 13:31:06
28900	9d690c7c-5faf-4c9a-8460-2f544289911c	9d690c7c-68dd-474b-b72f-22c39a6ace4f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 13:31:06
28901	9d690c7c-61b0-4db8-8319-245cb85b1e00	9d690c7c-68dd-474b-b72f-22c39a6ace4f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:31:06
28902	9d690c7c-6217-419e-b381-3e22dbd1622f	9d690c7c-68dd-474b-b72f-22c39a6ace4f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:31:06
28903	9d690c7c-675a-42c7-83e0-2f717dde9398	9d690c7c-68dd-474b-b72f-22c39a6ace4f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 13:31:06
28904	9d690c7c-67c1-401e-b2e4-987162558ff6	9d690c7c-68dd-474b-b72f-22c39a6ace4f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"146000","loans_pago_prestado":"584000","loans_intereses_recaudar":"275000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":306,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:31:06
30702	9d69427c-7121-49d2-b0f4-4de0f2bc03b9	9d69427c-8dd1-4dae-97c3-b572fbab85cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 16:02:05
30703	9d69427c-8988-4c1c-a886-141b99841fbb	9d69427c-8dd1-4dae-97c3-b572fbab85cf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"44.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 16:02:05
30704	9d69427c-8c90-4fbe-98f4-2abf5d6bb95e	9d69427c-8dd1-4dae-97c3-b572fbab85cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 16:02:05
30705	9d69427c-8cd8-4cf7-9ed7-883a3c25a3d8	9d69427c-8dd1-4dae-97c3-b572fbab85cf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:02:05
43567	9d6cea11-c9e9-462c-8c6b-ba833c00902b	9d6cea11-e75b-43a9-8731-650fd6d3ba55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":33,"hostname":"EderCortes"}	2024-11-06 11:38:10
43568	9d6cea11-e2cd-4a5c-a927-bfe79daaf037	9d6cea11-e75b-43a9-8731-650fd6d3ba55	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 11:38:10
43569	9d6cea11-e317-48ae-9b44-58fc8b00b937	9d6cea11-e75b-43a9-8731-650fd6d3ba55	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 11:38:10
43570	9d6cea11-e613-4e31-a770-541a0ace328c	9d6cea11-e75b-43a9-8731-650fd6d3ba55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":34,"hostname":"EderCortes"}	2024-11-06 11:38:10
43571	9d6cea11-e67f-4b03-9058-ad502fcf21e7	9d6cea11-e75b-43a9-8731-650fd6d3ba55	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":273,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:10
30706	9d69427c-d61f-460b-8fea-e6a780db0108	9d69427c-f15d-4789-9649-ecd4dd3083f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 16:02:06
30707	9d69427c-ed41-4f23-bf13-2e01a98f411c	9d69427c-f15d-4789-9649-ecd4dd3083f2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"40.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":76,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-04 16:02:06
30708	9d69427c-f030-4412-be16-298f8e49961b	9d69427c-f15d-4789-9649-ecd4dd3083f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 16:02:06
30709	9d69427c-f075-4ffb-b10e-83726ee3c111	9d69427c-f15d-4789-9649-ecd4dd3083f2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:02:06
43572	9d6cea12-2446-4440-83ad-aab0cb8f5a37	9d6cea12-437c-4a16-a635-cd21afdb26ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":34,"hostname":"EderCortes"}	2024-11-06 11:38:10
43573	9d6cea12-3eea-42dc-85b4-3de8305c42de	9d6cea12-437c-4a16-a635-cd21afdb26ba	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 11:38:10
43574	9d6cea12-3f35-4194-8f46-b98423d2d9c3	9d6cea12-437c-4a16-a635-cd21afdb26ba	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 11:38:10
43575	9d6cea12-4255-4e54-8ae7-6352b7459af2	9d6cea12-437c-4a16-a635-cd21afdb26ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":35,"hostname":"EderCortes"}	2024-11-06 11:38:10
43576	9d6cea12-42a0-4a05-8d90-190635b39b3f	9d6cea12-437c-4a16-a635-cd21afdb26ba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":224,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:10
27314	9d68e41a-376c-4a96-a35a-afe1a6eb8877	9d68e41a-5728-4950-8e17-c822e9d0fbaa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 11:38:10
27315	9d68e41a-551e-4e5b-8320-ea19f117afea	9d68e41a-5728-4950-8e17-c822e9d0fbaa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:38:10
27316	9d68e41a-55ce-49e5-9594-de834c3587f7	9d68e41a-5728-4950-8e17-c822e9d0fbaa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":423,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:38:10
27317	9d68e41a-e611-4059-8c0c-022b92dd841e	9d68e41b-3255-47c3-aeab-5569366b4e76	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:38:11
27318	9d68e41b-2884-4a74-8162-d92269018899	9d68e41b-3255-47c3-aeab-5569366b4e76	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"154.80","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:38:11
27319	9d68e41b-2c26-41b3-a682-b93f9f073ca0	9d68e41b-3255-47c3-aeab-5569366b4e76	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:38:11
27320	9d68e41b-2c5c-4788-8c4e-3568c16b0f96	9d68e41b-3255-47c3-aeab-5569366b4e76	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:38:11
27321	9d68e41b-30e5-48a7-8dad-b24fc22c66e3	9d68e41b-3255-47c3-aeab-5569366b4e76	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 11:38:11
27322	9d68e41b-3146-423e-9f35-bd82fda3accc	9d68e41b-3255-47c3-aeab-5569366b4e76	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":505,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:38:11
38713	9d6b6bb7-4df5-4479-89ea-df61fcd84da5	9d6b6bb7-7713-40eb-8ce0-e9d258bb2e03	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 17:49:02
38714	9d6b6bb7-74c4-42ad-9d7e-eea1844e977f	9d6b6bb7-7713-40eb-8ce0-e9d258bb2e03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:49:02
38715	9d6b6bb7-758e-41c2-ad76-a2442b649521	9d6b6bb7-7713-40eb-8ce0-e9d258bb2e03	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":321,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:49:02
38717	9d6b6bb7-ede5-47af-ac26-47b2eb644da1	9d6b6bb7-f793-46c8-9698-cbb6789722ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:49:02
38718	9d6b6bb7-f5df-459a-a3b7-3640601e6ed3	9d6b6bb7-f793-46c8-9698-cbb6789722ed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:49:02
38719	9d6b6bb7-f675-44b6-b88c-5feb21526a9d	9d6b6bb7-f793-46c8-9698-cbb6789722ed	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"Undefined array key \\"cobrador\\"","exception":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255,"function":"handleError","class":"Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83,"function":"Illuminate\\\\Foundation\\\\Bootstrap\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"listPrecautions","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:49:02
5055	9d51366e-0d0f-4b0e-a6da-cf9092144674	9d51366e-1116-4e89-ab84-e39e78208eeb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":272}	2024-10-23 17:08:30
38720	9d6b6bb8-5d75-414c-a110-df0296bc9c5f	9d6b6bb8-bffb-4bb8-b138-fb0f22fa1fdc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:49:03
38721	9d6b6bb8-b4e6-4aaf-89a9-308705c8fbb1	9d6b6bb8-bffb-4bb8-b138-fb0f22fa1fdc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"161.30","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:49:03
38722	9d6b6bb8-b540-4f95-b652-93f231360617	9d6b6bb8-bffb-4bb8-b138-fb0f22fa1fdc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:49:03
38723	9d6b6bb8-bc4c-4c9d-a17f-a88c3e17c837	9d6b6bb8-bffb-4bb8-b138-fb0f22fa1fdc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:49:03
38724	9d6b6bb8-bd07-4e0f-8b61-d0975ca90872	9d6b6bb8-bffb-4bb8-b138-fb0f22fa1fdc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":440,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:49:03
38725	9d6b6bb9-d294-4ca4-9e87-78bd9609dc97	9d6b6bba-0e3b-4c3e-8e44-00de2dc56bfb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:49:04
38726	9d6b6bba-0591-4403-97c0-c65ac0b98be2	9d6b6bba-0e3b-4c3e-8e44-00de2dc56bfb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"70.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:49:04
38727	9d6b6bba-0611-42ae-8c63-52283e1c74a3	9d6b6bba-0e3b-4c3e-8e44-00de2dc56bfb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:49:04
38728	9d6b6bba-0c9e-4183-95af-80cd109a7c04	9d6b6bba-0e3b-4c3e-8e44-00de2dc56bfb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:49:04
38729	9d6b6bba-0cfc-4685-b35d-cdca4d1ce9e2	9d6b6bba-0e3b-4c3e-8e44-00de2dc56bfb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":826,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:49:04
38730	9d6b6bbb-e872-44cf-a463-ea4c814488b8	9d6b6bbc-359f-48f1-9095-4bd01601fa17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:49:05
38731	9d6b6bbc-2f3d-44ac-890d-f2ebcf0460db	9d6b6bbc-359f-48f1-9095-4bd01601fa17	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"107.45","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:49:05
38732	9d6b6bbc-2fa2-48a9-8def-9228a47f6421	9d6b6bbc-359f-48f1-9095-4bd01601fa17	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:49:05
38733	9d6b6bbc-33d7-493e-b9bf-5b01a3d043c4	9d6b6bbc-359f-48f1-9095-4bd01601fa17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:49:05
38734	9d6b6bbc-343f-4f8a-a927-ea8ba11799a1	9d6b6bbc-359f-48f1-9095-4bd01601fa17	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":447,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:49:05
38736	9d6b6bbc-85c0-447f-9c59-d31a9ff6fd5d	9d6b6bbc-8e4a-4ae8-a82b-197be730d572	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:49:05
38737	9d6b6bbc-8c66-4f43-ae4d-061ac8b7c8f3	9d6b6bbc-8e4a-4ae8-a82b-197be730d572	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:49:05
38738	9d6b6bbc-8d1a-4eaa-92c4-5ebd11ad2f0b	9d6b6bbc-8e4a-4ae8-a82b-197be730d572	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"0","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"Undefined array key \\"cobrador\\"","exception":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255,"function":"handleError","class":"Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83,"function":"Illuminate\\\\Foundation\\\\Bootstrap\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"listPrecautions","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":201,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:49:05
35365	9d69c448-8844-49e5-9735-b095039a0d18	9d69c448-8d1c-4e12-9eda-21c687a59352	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1603}	2024-11-04 22:05:02
26103	9d68cd5e-a075-42f8-ac5e-d0daf4e8dc89	9d68cd5e-f0f1-450d-b033-cd5b29b21e8d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 10:34:36
26104	9d68cd5e-edc8-4d1a-8e57-e0a3b52b4ca1	9d68cd5e-f0f1-450d-b033-cd5b29b21e8d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 10:34:37
26105	9d68cd5e-ef11-4e04-ac9c-b45425b6f1b5	9d68cd5e-f0f1-450d-b033-cd5b29b21e8d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":803,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:34:37
26106	9d68cd5f-cf53-4bcf-b6ba-48c9ca9e0548	9d68cd5f-f6cb-45fc-bc6d-7767769c021f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 10:34:37
26107	9d68cd5f-ea8f-450b-b539-f07f45d54430	9d68cd5f-f6cb-45fc-bc6d-7767769c021f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"53.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:34:37
26108	9d68cd5f-efc1-4cc5-9e4e-ce8e94a86036	9d68cd5f-f6cb-45fc-bc6d-7767769c021f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:34:37
26109	9d68cd5f-f008-4690-9c8e-d984029d319a	9d68cd5f-f6cb-45fc-bc6d-7767769c021f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:34:37
26110	9d68cd5f-f580-4ee4-9b1c-c944e023b4bb	9d68cd5f-f6cb-45fc-bc6d-7767769c021f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 10:34:37
26111	9d68cd5f-f5dd-45dd-b4e6-8d957365fc4d	9d68cd5f-f6cb-45fc-bc6d-7767769c021f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":587,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:34:37
26112	9d68cd60-d765-4368-9f0c-37d753b1fb24	9d68cd61-1445-43a7-bf87-71ed891a9f60	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 10:34:38
26113	9d68cd61-092e-4377-b35d-c19b9f611368	9d68cd61-1445-43a7-bf87-71ed891a9f60	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"75.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:34:38
26114	9d68cd61-09b1-4448-8972-2a7b4343fcd3	9d68cd61-1445-43a7-bf87-71ed891a9f60	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:34:38
26115	9d68cd61-119c-4080-941c-542649ca166f	9d68cd61-1445-43a7-bf87-71ed891a9f60	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 10:34:38
26116	9d68cd61-1239-4a1d-bb05-e0865462507f	9d68cd61-1445-43a7-bf87-71ed891a9f60	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":712,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:34:38
41712	9d6ccef2-60e6-4cc0-877c-6b20e4c20fcf	9d6ccef2-6396-4b70-88eb-9512f88321c8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1920}	2024-11-06 10:22:20
26117	9d68cd61-d615-4426-a8e6-66bee00297c5	9d68cd62-05a3-4235-b34e-95f9489fb486	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 10:34:39
26118	9d68cd61-fdbd-4350-b5ad-3f7829d339be	9d68cd62-05a3-4235-b34e-95f9489fb486	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"67.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:34:39
26119	9d68cd61-fe3d-4ad4-a601-0c79d7f13d2d	9d68cd62-05a3-4235-b34e-95f9489fb486	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:34:39
26120	9d68cd62-03a9-48e1-b124-c3e5498ca95e	9d68cd62-05a3-4235-b34e-95f9489fb486	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 10:34:39
26121	9d68cd62-0429-403b-8fad-80888412581f	9d68cd62-05a3-4235-b34e-95f9489fb486	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":589,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:34:39
40331	9d6cc283-f6c0-462d-bc1a-7915f437cfc8	9d6cc283-fb01-4668-a482-f98720c0e782	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1802}	2024-11-06 09:47:34
30837	9d694398-279c-45b2-af94-1f7bef3b2f0d	9d694398-4fe7-4fe2-b0c7-fd35e280bd84	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 16:05:11
30838	9d694398-4e3d-4ec5-ba85-d8dd5656b364	9d694398-4fe7-4fe2-b0c7-fd35e280bd84	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:05:11
30839	9d694398-4ef0-41cd-97a4-5882b469e5ef	9d694398-4fe7-4fe2-b0c7-fd35e280bd84	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":273,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:05:11
30840	9d694398-b780-4a5a-a42a-a6df76195406	9d694398-da04-4e5a-ba79-a8fe935dd63e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:05:12
30841	9d694398-ced3-4066-87e6-f64a2e22d4ca	9d694398-da04-4e5a-ba79-a8fe935dd63e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"44.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 16:05:12
30842	9d694398-d2b9-4181-8aee-751f88d15455	9d694398-da04-4e5a-ba79-a8fe935dd63e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 16:05:12
30843	9d694398-d2f4-4cb5-8443-a0e7ef7c4b97	9d694398-da04-4e5a-ba79-a8fe935dd63e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 16:05:12
30844	9d694398-d875-403d-8bac-9a0a5eabb85e	9d694398-da04-4e5a-ba79-a8fe935dd63e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:05:12
30845	9d694398-d8f5-470f-a934-f9f27703e2e0	9d694398-da04-4e5a-ba79-a8fe935dd63e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder.cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":295,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:05:12
32820	9d69a629-350a-4c57-81dc-319317214130	9d69a629-7c6a-4ddf-a422-92fd8dd79540	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 20:40:48
32821	9d69a629-78da-4e42-88dd-b88e4dd8612b	9d69a629-7c6a-4ddf-a422-92fd8dd79540	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 20:40:48
32822	9d69a629-7a75-456b-b2dd-263e05e0235d	9d69a629-7c6a-4ddf-a422-92fd8dd79540	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1008,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:40:48
32823	9d69a62b-1da2-4030-b4e7-d807a5dfd206	9d69a62b-54c5-4485-8367-9d36f771b030	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 20:40:49
32824	9d69a62b-43fc-406e-aabe-eee73d96ec84	9d69a62b-54c5-4485-8367-9d36f771b030	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 91\\n                        ","time":"67.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"9ae30bc69b6b272f3f51ff48e54319f5","hostname":"EderCortes"}	2024-11-04 20:40:49
32825	9d69a62b-4869-4144-8eb3-1412f0370c60	9d69a62b-54c5-4485-8367-9d36f771b030	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '91' order by \\"item_loans\\".\\"id\\" asc","time":"3.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 20:40:49
32826	9d69a62b-5260-40cc-8d50-6f0873db0e79	9d69a62b-54c5-4485-8367-9d36f771b030	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 20:40:49
32827	9d69a62b-5306-470f-ba08-9805cd8441c0	9d69a62b-54c5-4485-8367-9d36f771b030	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/91","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":91,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":8,"loans_valor_prestado":5000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"800000","loans_pago_interes":"200000","user_alias":"eder.cortes"},"items":[{"id":371,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 17:44:55","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"200000","itemloans_cuota_cancelada":"800000","user_alias":"eder.cortes"},{"id":403,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":404,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":405,"loans_codigo":91,"itemloans_cuota":"3","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":406,"loans_codigo":91,"itemloans_cuota":"4","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":407,"loans_codigo":91,"itemloans_cuota":"5","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":408,"loans_codigo":91,"itemloans_cuota":"6","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":409,"loans_codigo":91,"itemloans_cuota":"7","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":410,"loans_codigo":91,"itemloans_cuota":"8","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-03-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":1012,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:40:49
34718	9d69bf63-6cf4-47b1-b2cb-1f5490211735	9d69bf63-c24d-4b79-baac-af4d738d4d7e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 21:51:20
34719	9d69bf63-c052-4ea8-a8b7-ce2c0f84eaf3	9d69bf63-c24d-4b79-baac-af4d738d4d7e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:51:21
34720	9d69bf63-c127-48d2-b621-0b2db7414218	9d69bf63-c24d-4b79-baac-af4d738d4d7e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":405,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:51:21
34721	9d69bf64-29bd-4e7b-bd4f-d83a50e03089	9d69bf64-47c4-4233-89a8-127f04f93b29	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:51:21
34722	9d69bf64-41bc-4853-bef3-aa871a0d1617	9d69bf64-47c4-4233-89a8-127f04f93b29	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":254,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:51:21
34723	9d69bf64-4215-4970-88e9-8c771777b3c3	9d69bf64-47c4-4233-89a8-127f04f93b29	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:51:21
34724	9d69bf64-469b-4e16-9d52-101588e04eb9	9d69bf64-47c4-4233-89a8-127f04f93b29	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:51:21
34725	9d69bf64-46ea-42af-b521-0bceb2ad2e34	9d69bf64-47c4-4233-89a8-127f04f93b29	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":281,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:51:21
40520	9d6cc42a-ed82-4eb1-a9e0-8cb09f902aac	9d6cc42a-f0b3-4742-a35a-43d58443117f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1822}	2024-11-06 09:52:11
34726	9d69bf64-8e8e-4213-8203-3b46b1da87fc	9d69bf64-abe0-45f6-b1b9-eee0e2483252	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:51:21
34727	9d69bf64-a6f8-481b-a058-cf4dd826d221	9d69bf64-abe0-45f6-b1b9-eee0e2483252	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":243,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 21:51:21
34728	9d69bf64-a760-4695-abce-84bf105db1f6	9d69bf64-abe0-45f6-b1b9-eee0e2483252	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 21:51:21
34729	9d69bf64-aac1-4345-9577-11cb7c68dfc6	9d69bf64-abe0-45f6-b1b9-eee0e2483252	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:51:21
34730	9d69bf64-ab09-455b-9ea5-db86c9b5de69	9d69bf64-abe0-45f6-b1b9-eee0e2483252	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:51:21
34731	9d69bf64-effa-461a-a265-493753b3d1f3	9d69bf65-3900-4b47-b3f8-96501f24b933	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:51:21
34732	9d69bf65-3354-467f-a79f-a9544d48918f	9d69bf65-3900-4b47-b3f8-96501f24b933	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"150.86","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:51:22
34733	9d69bf65-33ab-47ee-a3ef-15509bfbe77d	9d69bf65-3900-4b47-b3f8-96501f24b933	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:51:22
34734	9d69bf65-37c3-420e-a8b7-61f4130d6724	9d69bf65-3900-4b47-b3f8-96501f24b933	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:51:22
34735	9d69bf65-3809-44cd-bace-f865674230eb	9d69bf65-3900-4b47-b3f8-96501f24b933	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:51:22
34736	9d69bf65-7fdb-43ac-a7a1-b7900df6bfaa	9d69bf65-9e0a-41f9-ae30-bdfdf070960a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:51:22
34737	9d69bf65-9766-4dc7-a850-d90a4587a903	9d69bf65-9e0a-41f9-ae30-bdfdf070960a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_valor_prestado\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\", \\"loans_pago_interes\\" from \\"loans\\" where \\"id\\" = '93' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"41.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":230,"hash":"63dc2135b568cd063e53dcb39be4f63e","hostname":"EderCortes"}	2024-11-04 21:51:22
34738	9d69bf65-97b5-45ad-a150-3e675644f530	9d69bf65-9e0a-41f9-ae30-bdfdf070960a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 21:51:22
34739	9d69bf65-9931-4261-b0b4-2c151333e7d2	9d69bf65-9e0a-41f9-ae30-bdfdf070960a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"1.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":231,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 21:51:22
34740	9d69bf65-9965-403f-8be8-01e625089b35	9d69bf65-9e0a-41f9-ae30-bdfdf070960a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 21:51:22
34741	9d69bf65-9ccd-4c39-9bef-bd3988c02d1a	9d69bf65-9e0a-41f9-ae30-bdfdf070960a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:51:22
34742	9d69bf65-9d1f-498a-adc2-c52162f52e2a	9d69bf65-9e0a-41f9-ae30-bdfdf070960a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"user_creador":12,"user_cobrador":22,"user_customer":19,"user_recomendacion":18,"loans_pago_interes":"250000"},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:19:45.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:22:30.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":399,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":400,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":401,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":402,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"}]}},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:51:22
34484	9d69be94-446d-42c1-ab9d-9f33904df6ba	9d69be94-620f-4836-9643-af80bcd84c21	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 21:49:05
34485	9d69be94-6081-400e-a20b-d56534df50f4	9d69be94-620f-4836-9643-af80bcd84c21	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 21:49:05
34486	9d69be94-611f-4e25-8dee-6b4308412672	9d69be94-620f-4836-9643-af80bcd84c21	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:49:05
34487	9d69be94-bca3-4ddd-a90d-4456b0bb348a	9d69be95-0290-4605-953e-72bafddef38c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 21:49:05
34488	9d69be94-fd7c-42bc-9368-2ade14e97eae	9d69be95-0290-4605-953e-72bafddef38c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"145.49","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":257,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:49:05
34489	9d69be94-fdcf-4975-a923-61ed2d835ba7	9d69be95-0290-4605-953e-72bafddef38c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:49:05
34490	9d69be95-0179-422d-b53c-0dd5c080d117	9d69be95-0290-4605-953e-72bafddef38c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 21:49:05
34491	9d69be95-01bd-45e1-8ca9-907b63c21465	9d69be95-0290-4605-953e-72bafddef38c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:49:05
34743	9d69bf67-3445-42c4-a344-b28323d1900d	9d69bf67-698f-46f8-a4e7-d3cf42af3153	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:51:23
34744	9d69bf67-6191-4787-b4a8-a10f99a4b70a	9d69bf67-698f-46f8-a4e7-d3cf42af3153	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"64.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:51:23
34745	9d69bf67-6213-4077-acaa-08cb39cfb342	9d69bf67-698f-46f8-a4e7-d3cf42af3153	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:51:23
34746	9d69bf67-67ed-47e5-af05-ba87e2242a85	9d69bf67-698f-46f8-a4e7-d3cf42af3153	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:51:23
34747	9d69bf67-6848-4f39-9199-68cfbc661992	9d69bf67-698f-46f8-a4e7-d3cf42af3153	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":560,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:51:23
34492	9d69be95-4956-48d7-bc31-8d0bee209f41	9d69be95-8e11-4630-b6f1-a3500acafa8b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 21:49:05
34493	9d69be95-88ef-448d-95fb-b946b6fc7876	9d69be95-8e11-4630-b6f1-a3500acafa8b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"141.32","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":246,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 21:49:05
34494	9d69be95-893c-40dc-9134-a77500d1e70e	9d69be95-8e11-4630-b6f1-a3500acafa8b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 21:49:05
34495	9d69be95-8cf5-4ad7-9b5b-6bf0b08eebff	9d69be95-8e11-4630-b6f1-a3500acafa8b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 21:49:05
34496	9d69be95-8d3f-4053-9d16-600805de9bfd	9d69be95-8e11-4630-b6f1-a3500acafa8b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:49:05
34497	9d69be95-d5da-44e6-9a68-df768fb7847f	9d69be95-f35c-41b8-b972-259c09fba440	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 21:49:06
34498	9d69be95-edcc-48a9-8c75-014353d432df	9d69be95-f35c-41b8-b972-259c09fba440	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:49:06
34499	9d69be95-ee1c-4ae3-bcec-8bc90313ab8d	9d69be95-f35c-41b8-b972-259c09fba440	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:49:06
34500	9d69be95-f239-4dbf-9eef-d8bb26efff44	9d69be95-f35c-41b8-b972-259c09fba440	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 21:49:06
34501	9d69be95-f281-4413-adea-f7e9e4593165	9d69be95-f35c-41b8-b972-259c09fba440	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:49:06
34502	9d69be96-3a7c-4166-a9e1-d3825277aef0	9d69be96-5a3b-4e7c-8a1d-209169e88ff8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 21:49:06
34503	9d69be96-532a-4dbe-bb3e-667ca2dfb0b9	9d69be96-5a3b-4e7c-8a1d-209169e88ff8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_valor_prestado\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"loans_inicio_pago\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"loans_fecha_ultimo_pago\\", \\"user_recomendacion\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\" from \\"loans\\" where \\"id\\" = '93' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"40.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":233,"hash":"e3e1fe316cc5bf076856e8ff82e57640","hostname":"EderCortes"}	2024-11-04 21:49:06
34504	9d69be96-5378-4964-bd24-d88ac980577e	9d69be96-5a3b-4e7c-8a1d-209169e88ff8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 21:49:06
34505	9d69be96-54fd-451e-9420-1b846ad1c6b3	9d69be96-5a3b-4e7c-8a1d-209169e88ff8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"1.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":234,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 21:49:06
34506	9d69be96-5531-4aaf-8e15-6adcf8b3583f	9d69be96-5a3b-4e7c-8a1d-209169e88ff8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 21:49:06
34507	9d69be96-58e5-433b-a072-467d21a79e13	9d69be96-5a3b-4e7c-8a1d-209169e88ff8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 21:49:06
34508	9d69be96-594f-4ea9-90ce-391663860fb3	9d69be96-5a3b-4e7c-8a1d-209169e88ff8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","user_creador":12,"user_cobrador":22,"user_customer":19,"loans_fecha_ultimo_pago":"04-11-2024","user_recomendacion":18,"loans_pago_prestado":"1000000","loans_pago_interes":"250000"},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:19:45.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:22:30.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":399,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":400,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":401,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":402,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"}]}},"duration":245,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:49:06
34509	9d69be97-e73e-4dc4-b0a9-12dc72bfa8f2	9d69be98-0c78-4561-b818-3adf5c345522	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 21:49:07
34510	9d69be98-0479-452b-bfff-9506191daf1b	9d69be98-0c78-4561-b818-3adf5c345522	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:49:07
34511	9d69be98-04e8-4340-9e5d-642861c98d0c	9d69be98-0c78-4561-b818-3adf5c345522	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:49:07
34512	9d69be98-0ae7-4be0-93a4-c7aec6f0bf1b	9d69be98-0c78-4561-b818-3adf5c345522	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 21:49:07
34513	9d69be98-0b56-48f7-a1f4-d9f4efc1e8a3	9d69be98-0c78-4561-b818-3adf5c345522	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":506,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:49:07
39059	9d6bcba1-c124-40bf-939e-1027386f6ffd	9d6bcba1-e58d-4f03-bb10-d8ec6984e626	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 22:17:14
39060	9d6bcba1-e379-4590-a137-7e72adea4262	9d6bcba1-e58d-4f03-bb10-d8ec6984e626	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 22:17:14
39061	9d6bcba1-e45c-4323-92c1-fbff3e54714a	9d6bcba1-e58d-4f03-bb10-d8ec6984e626	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:17:14
39062	9d6bcba2-4bfa-4938-9a39-2e1733e17bf1	9d6bcba2-7142-4280-8ce4-1f5a3232c4d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 22:17:14
39063	9d6bcba2-6b6c-4744-a041-55716ca44bfa	9d6bcba2-7142-4280-8ce4-1f5a3232c4d6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"51.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 22:17:14
39064	9d6bcba2-6f7c-44bb-b679-1abd94bf2c93	9d6bcba2-7142-4280-8ce4-1f5a3232c4d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 22:17:14
39065	9d6bcba2-7000-4ff0-91ce-21fa9034dfc6	9d6bcba2-7142-4280-8ce4-1f5a3232c4d6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":286,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:17:14
39066	9d6bcba2-c7c2-41bf-9070-08edc134c8cd	9d6bcba2-e5ad-493f-afce-224a6fcb788d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 22:17:15
39067	9d6bcba2-e070-4de6-9562-c7d9760fe607	9d6bcba2-e5ad-493f-afce-224a6fcb788d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:17:15
39068	9d6bcba2-e0cf-4197-8140-816595bab7fd	9d6bcba2-e5ad-493f-afce-224a6fcb788d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:17:15
39069	9d6bcba2-e452-41e5-a04e-5dac802b4637	9d6bcba2-e5ad-493f-afce-224a6fcb788d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 22:17:15
39070	9d6bcba2-e4b0-443f-8b83-04a5daa5a4b4	9d6bcba2-e5ad-493f-afce-224a6fcb788d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":288,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:17:15
39071	9d6bcba3-4259-4cc5-ae4f-706d8a032494	9d6bcba3-5e7e-4a48-a14e-2598e79957e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 22:17:15
39072	9d6bcba3-5a01-4cc1-819b-4e9a25770d31	9d6bcba3-5e7e-4a48-a14e-2598e79957e5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:17:15
39073	9d6bcba3-5a53-476d-931f-749a795d61a1	9d6bcba3-5e7e-4a48-a14e-2598e79957e5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:17:15
39074	9d6bcba3-5d6a-47b9-b55d-7c336bb4b3f5	9d6bcba3-5e7e-4a48-a14e-2598e79957e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 22:17:15
39075	9d6bcba3-5da9-4414-b1b9-78e9963cb76b	9d6bcba3-5e7e-4a48-a14e-2598e79957e5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":297,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:17:15
39076	9d6bcba4-f2e5-4ab8-8ea4-be4d1c1f9650	9d6bcba5-1026-431a-9e2f-1d33d044fe1a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 22:17:16
39077	9d6bcba5-0b02-40e2-b96b-9b19a736128f	9d6bcba5-1026-431a-9e2f-1d33d044fe1a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 22:17:16
39078	9d6bcba5-0b48-4e54-aab3-bb9ac5adbec2	9d6bcba5-1026-431a-9e2f-1d33d044fe1a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 22:17:16
39079	9d6bcba5-0ef2-45a8-8ab4-0919737797e5	9d6bcba5-1026-431a-9e2f-1d33d044fe1a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 22:17:16
39080	9d6bcba5-0f33-437c-b04a-42a61ab214b2	9d6bcba5-1026-431a-9e2f-1d33d044fe1a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":286,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:17:16
39081	9d6bcba5-52d0-4e27-8840-889b621e3f78	9d6bcba5-568e-4982-99fb-e1dbd8f67f66	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":151,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:17:16
31119	9d69465c-da90-4744-b45b-1cc2cd3a225e	9d69465d-078b-44ce-aaa4-3759040429d8	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 16:12:56
31120	9d69465d-0557-49b2-ae1e-21df3e5b9b55	9d69465d-078b-44ce-aaa4-3759040429d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:12:56
31121	9d69465d-0653-4554-bf63-5092c4d55faa	9d69465d-078b-44ce-aaa4-3759040429d8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":384,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:12:56
29250	9d6913fd-cdc3-4250-be71-5ddb0be3836e	9d6913fe-0a65-4bd3-8380-d9ddc8b12d7d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 13:52:05
29251	9d6913fe-074e-48d1-89d7-af8a99ee4cc3	9d6913fe-0a65-4bd3-8380-d9ddc8b12d7d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 13:52:05
29252	9d6913fe-08bd-4333-8cff-270de7443949	9d6913fe-0a65-4bd3-8380-d9ddc8b12d7d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":494,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:52:05
29253	9d6913ff-e95c-45c5-9127-3262b7a79d70	9d691400-32ad-46e9-9325-acf574996375	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 13:52:06
29254	9d691400-2957-4a8e-8af2-f5b60a692f4c	9d691400-32ad-46e9-9325-acf574996375	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"96.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:52:06
29255	9d691400-29f1-4819-a8aa-8fc5ff3fa8b4	9d691400-32ad-46e9-9325-acf574996375	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:52:06
29256	9d691400-308f-4865-bdb4-401d08c2b9e4	9d691400-32ad-46e9-9325-acf574996375	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 13:52:06
29257	9d691400-3114-4066-8f8d-638c20973a99	9d691400-32ad-46e9-9325-acf574996375	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1110,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:52:06
31122	9d69465d-7df4-4e49-9c3d-53b797bb2aab	9d69465d-c972-4ee0-a314-dea22886f3b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:12:56
31123	9d69465d-c282-4526-aabb-f6c4dc1c0369	9d69465d-c972-4ee0-a314-dea22886f3b4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"145.57","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:12:56
31124	9d69465d-c2fb-48e2-a5e9-e50cbd443b21	9d69465d-c972-4ee0-a314-dea22886f3b4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 16:12:56
31125	9d69465d-c7e1-46c1-92c9-6e3fb87e8ce7	9d69465d-c972-4ee0-a314-dea22886f3b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:12:56
31126	9d69465d-c842-4947-853d-0c817ca69251	9d69465d-c972-4ee0-a314-dea22886f3b4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":426,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:12:56
39082	9d6bcba5-aae7-444d-9e2d-ffd1a0f01d00	9d6bcba5-f22a-48a0-9b17-b32a20de1d88	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 22:17:16
39083	9d6bcba5-edab-49fe-bea0-346f08a8bc37	9d6bcba5-f22a-48a0-9b17-b32a20de1d88	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"149.47","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 22:17:17
39084	9d6bcba5-f0d1-4bf8-91d3-8b3f69c264da	9d6bcba5-f22a-48a0-9b17-b32a20de1d88	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 22:17:17
39085	9d6bcba5-f13d-46c8-84dc-3148d3694fb5	9d6bcba5-f22a-48a0-9b17-b32a20de1d88	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":343,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:17:17
29258	9d691400-b8cd-4c5d-a88e-93a0e479e187	9d691401-1563-4548-bc1f-fae9319a4966	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 13:52:07
29259	9d691401-0aaf-4063-8774-481e53a8540b	9d691401-1563-4548-bc1f-fae9319a4966	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"179.66","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:52:07
29260	9d691401-0b41-4d85-ba5b-4746be3bc265	9d691401-1563-4548-bc1f-fae9319a4966	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:52:07
29261	9d691401-12cb-4643-a162-2fdb4f9120ae	9d691401-1563-4548-bc1f-fae9319a4966	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 13:52:07
29262	9d691401-1391-4fd7-923a-cd11ae527cdc	9d691401-1563-4548-bc1f-fae9319a4966	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":552,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:52:07
31127	9d69465e-17bf-48f0-9bf4-2f1b551eb3b6	9d69465e-664c-4d85-b443-381ccb740612	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:12:56
31128	9d69465e-604a-41cf-87f9-640b11d27188	9d69465e-664c-4d85-b443-381ccb740612	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"160.06","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:12:57
31129	9d69465e-60a8-42c7-adc4-aa941b934307	9d69465e-664c-4d85-b443-381ccb740612	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 16:12:57
31130	9d69465e-64cb-4212-9ce9-be64068f0517	9d69465e-664c-4d85-b443-381ccb740612	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:12:57
31131	9d69465e-652e-4f82-8fe9-42adbaa5de99	9d69465e-664c-4d85-b443-381ccb740612	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":378,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:12:57
39086	9d6bcbb6-8234-4cff-9d9c-afa2e3af096b	9d6bcbb6-854b-4c9f-a2a8-86607d8c57ef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":142,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:17:27
39087	9d6bcbb6-f0db-42b2-985e-32e724d36f3e	9d6bcbb7-0cf8-4f42-9ee4-c10134576100	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 22:17:28
39088	9d6bcbb7-0816-438e-96e0-80795641fc06	9d6bcbb7-0cf8-4f42-9ee4-c10134576100	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" where \\"l\\".\\"user_cobrador\\" = 14 order by \\"l\\".\\"id\\" desc","time":"43.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"9c165f2fbf7ccf3d02848123be5b6d04","hostname":"EderCortes"}	2024-11-05 22:17:28
39089	9d6bcbb7-0b69-4af3-bc1d-498c6fa9bb76	9d6bcbb7-0cf8-4f42-9ee4-c10134576100	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 22:17:28
39090	9d6bcbb7-0bd8-44a9-88ff-1ae1135cfbb4	9d6bcbb7-0cf8-4f42-9ee4-c10134576100	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":14,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:17:28
39091	9d6bcbba-11e8-4d2f-b128-2ea702fb6a13	9d6bcbba-1604-45e2-beed-30ac9b3c6ea1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":169,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:17:30
40792	9d6cc796-9193-4323-841c-f71770ae51f6	9d6cc796-94c0-4956-b886-7483f53579f1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1854}	2024-11-06 10:01:45
39093	9d6bcbba-c56b-4e1e-9c20-d90bb0a3f9cd	9d6bcbba-cd40-4939-a7b8-c4d9c0af54e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 22:17:30
39094	9d6bcbba-cbad-4184-8ed8-c8b7d499a2ba	9d6bcbba-cd40-4939-a7b8-c4d9c0af54e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 22:17:30
39095	9d6bcbba-cc3d-4c5c-91ae-e3a7eb5b5b25	9d6bcbba-cd40-4939-a7b8-c4d9c0af54e8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"46","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":500,"response":{"message":"Undefined array key \\"cobrador\\"","exception":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255,"function":"handleError","class":"Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83,"function":"Illuminate\\\\Foundation\\\\Bootstrap\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"listPrecautions","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":164,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:17:30
34922	9d69c119-60fe-49ba-b705-675d0db88970	9d69c119-9237-45a0-a4c9-f593dc3a3db1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 21:56:07
34923	9d69c119-9045-471e-92e2-c4a3f32eaea5	9d69c119-9237-45a0-a4c9-f593dc3a3db1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 21:56:08
34924	9d69c119-910f-47cc-9ddb-50300ea31132	9d69c119-9237-45a0-a4c9-f593dc3a3db1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":403,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:56:08
34925	9d69c119-f3f0-4563-b708-b09be0eae377	9d69c11a-18b6-411d-8cb0-10b219a4390c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 21:56:08
34926	9d69c11a-139a-4ac6-b137-a0bca4e75186	9d69c11a-18b6-411d-8cb0-10b219a4390c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:56:08
34927	9d69c11a-1400-4dc7-ac00-832df56f79d5	9d69c11a-18b6-411d-8cb0-10b219a4390c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:56:08
34928	9d69c11a-17b0-4a15-a9d4-f448dfc142e1	9d69c11a-18b6-411d-8cb0-10b219a4390c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 21:56:08
34929	9d69c11a-17f7-4bd3-a3c1-67dd5feeec2f	9d69c11a-18b6-411d-8cb0-10b219a4390c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":280,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:56:08
34930	9d69c11a-5f61-4f92-a604-08eb70911a00	9d69c11a-ad98-4f50-8418-2df3cee60215	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 21:56:08
34931	9d69c11a-a696-4ea6-a8d8-c0d43bc280e7	9d69c11a-ad98-4f50-8418-2df3cee60215	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"158.02","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 21:56:08
34932	9d69c11a-a70a-488c-99c5-d4981f27cb04	9d69c11a-ad98-4f50-8418-2df3cee60215	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 21:56:08
34933	9d69c11a-abdb-4713-ba56-01842ad33244	9d69c11a-ad98-4f50-8418-2df3cee60215	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 21:56:08
34934	9d69c11a-ac40-45c5-a48a-37e3bb5cd7f7	9d69c11a-ad98-4f50-8418-2df3cee60215	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":366,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:56:08
34935	9d69c11a-f81c-4f2f-8abc-eefdbba362fb	9d69c11b-40f6-4d53-834c-2105f661e45e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 21:56:08
34936	9d69c11b-3bf5-4958-a13e-7e24ca6d0b56	9d69c11b-40f6-4d53-834c-2105f661e45e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"143.54","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:56:09
34937	9d69c11b-3c54-4c09-b59c-cfd6c87371f2	9d69c11b-40f6-4d53-834c-2105f661e45e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:56:09
34938	9d69c11b-3fbd-4c37-9d04-6349d7ecb2b7	9d69c11b-40f6-4d53-834c-2105f661e45e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 21:56:09
34939	9d69c11b-400b-4383-a2a9-574630804f03	9d69c11b-40f6-4d53-834c-2105f661e45e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":358,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:56:09
39321	9d6bcfc4-3d3e-4458-a906-0ac6c92eaa0a	9d6bcfc4-64e9-422b-93c0-94eb6a2fd655	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 22:28:48
39322	9d6bcfc4-626d-4491-aadb-5a7e1f95243e	9d6bcfc4-64e9-422b-93c0-94eb6a2fd655	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 22:28:48
39323	9d6bcfc4-639e-43f4-b854-14eae157aa9c	9d6bcfc4-64e9-422b-93c0-94eb6a2fd655	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:28:48
39324	9d6bcfc4-d162-42ae-a2c9-1b1a3a86dbc6	9d6bcfc4-d8e4-4f53-8443-740539a2fb7b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 22:28:48
39325	9d6bcfc4-d7b6-478b-af2e-799fdc66a561	9d6bcfc4-d8e4-4f53-8443-740539a2fb7b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 22:28:48
39326	9d6bcfc4-d7f8-416e-9b69-38ae514fd168	9d6bcfc4-d8e4-4f53-8443-740539a2fb7b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null}},"duration":229,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:28:48
39327	9d6bcfc5-3a50-4e0c-88f4-6c76475e96f8	9d6bcfc5-84e2-4903-832a-e38d6a37138b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 22:28:48
39328	9d6bcfc5-7f4a-42b1-9de9-5b3e6de0777a	9d6bcfc5-84e2-4903-832a-e38d6a37138b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"153.04","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:28:48
39329	9d6bcfc5-7faa-45df-9d7a-7b9314721854	9d6bcfc5-84e2-4903-832a-e38d6a37138b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:28:48
39330	9d6bcfc5-836f-4833-a823-05915b596d5f	9d6bcfc5-84e2-4903-832a-e38d6a37138b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 22:28:48
39331	9d6bcfc5-83b4-45d8-912b-2917b9e14c02	9d6bcfc5-84e2-4903-832a-e38d6a37138b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":375,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:28:48
39332	9d6bcfc5-cba3-4316-933f-6c3270ff72ee	9d6bcfc5-ea2e-4b7d-abed-6217037df1bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 22:28:49
27626	9d68e8b5-7893-43ac-8bfb-89df41a5ddc8	9d68e8b5-9a03-43e2-9aee-99db64d97dae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 11:51:03
27627	9d68e8b5-981a-4964-8db6-508e1f4ed3b2	9d68e8b5-9a03-43e2-9aee-99db64d97dae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 11:51:03
27628	9d68e8b5-98e0-4b46-be86-f6e3c6737601	9d68e8b5-9a03-43e2-9aee-99db64d97dae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":398,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:51:03
26372	9d68d355-cc4f-446d-922c-ab399f08cf41	9d68d356-0c9f-46f6-83c9-3802b6db5a84	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 10:51:17
26373	9d68d356-093b-4aa2-8b8b-8a0a887edf1e	9d68d356-0c9f-46f6-83c9-3802b6db5a84	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 10:51:17
26374	9d68d356-0abd-430b-af38-ab4f997a6b51	9d68d356-0c9f-46f6-83c9-3802b6db5a84	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":657,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:51:17
39333	9d6bcfc5-e4e8-4c38-a42e-6fbf061fe2bb	9d6bcfc5-ea2e-4b7d-abed-6217037df1bf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:28:49
39334	9d6bcfc5-e53c-4fca-ad5b-6d810e4f34ad	9d6bcfc5-ea2e-4b7d-abed-6217037df1bf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:28:49
39335	9d6bcfc5-e8d5-4889-b4b4-1cb8c8b34e2a	9d6bcfc5-ea2e-4b7d-abed-6217037df1bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 22:28:49
39336	9d6bcfc5-e921-41cc-8a03-9c131fcb7a05	9d6bcfc5-ea2e-4b7d-abed-6217037df1bf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:28:49
26375	9d68d357-0d66-49a1-94e8-a7711ab4ba71	9d68d357-460d-4d04-9eaf-9d23c096a259	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 10:51:18
26376	9d68d357-36d9-40ed-8081-03ab18b0f459	9d68d357-460d-4d04-9eaf-9d23c096a259	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 88\\n                        ","time":"80.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"3232b1aa66dd3d4374b32381a9d135a6","hostname":"EderCortes"}	2024-11-04 10:51:18
26377	9d68d357-3cf0-4c83-82ea-5f335647fbe6	9d68d357-460d-4d04-9eaf-9d23c096a259	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"3.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:51:18
26378	9d68d357-3d50-44c1-bd96-29de50f7c9fe	9d68d357-460d-4d04-9eaf-9d23c096a259	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 10:51:18
26379	9d68d357-43e0-4c99-8b72-543ac4abae37	9d68d357-460d-4d04-9eaf-9d23c096a259	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 10:51:18
26380	9d68d357-4492-405b-b34e-846e25554f3b	9d68d357-460d-4d04-9eaf-9d23c096a259	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":680,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:51:18
27629	9d68e8b6-2381-4517-9751-2b64ff3790cf	9d68e8b6-4883-4856-adae-687a232d9c8c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 11:51:04
27630	9d68e8b6-3dcc-4885-a0a2-dca77c8aa232	9d68e8b6-4883-4856-adae-687a232d9c8c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"50.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 11:51:04
27631	9d68e8b6-4214-4a3d-bd9c-140dc4470b66	9d68e8b6-4883-4856-adae-687a232d9c8c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:51:04
27632	9d68e8b6-4251-4bc8-b016-d3444f838db8	9d68e8b6-4883-4856-adae-687a232d9c8c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 11:51:04
27633	9d68e8b6-4725-481d-97cd-9216d47bfae4	9d68e8b6-4883-4856-adae-687a232d9c8c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 11:51:04
39337	9d6bcfc8-3182-462c-932b-29053f7f28ec	9d6bcfc8-7d4d-4382-9f38-81547ec8c58b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 22:28:50
39338	9d6bcfc8-77bc-4d33-a206-d01f5d12aa0d	9d6bcfc8-7d4d-4382-9f38-81547ec8c58b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"150.01","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 22:28:50
26381	9d68d358-2b78-4c49-807b-8eed19e57130	9d68d358-737b-4297-837a-44a0c29cee6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 10:51:19
26382	9d68d358-669c-4579-870c-009a908f2679	9d68d358-737b-4297-837a-44a0c29cee6b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"109.80","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:51:19
26383	9d68d358-6775-473e-8754-2c7f195d9426	9d68d358-737b-4297-837a-44a0c29cee6b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:51:19
26384	9d68d358-70b4-42fe-8b60-10d1f11c0ce8	9d68d358-737b-4297-837a-44a0c29cee6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 10:51:19
26385	9d68d358-7189-4478-b3ca-c0b2b358a1af	9d68d358-737b-4297-837a-44a0c29cee6b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":744,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:51:19
27634	9d68e8b6-4786-45de-8888-8628783ae42e	9d68e8b6-4883-4856-adae-687a232d9c8c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":391,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:51:04
39339	9d6bcfc8-7817-4294-b438-38f385307350	9d6bcfc8-7d4d-4382-9f38-81547ec8c58b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 22:28:50
39340	9d6bcfc8-7c1b-467c-a2d8-e9bd63beaab3	9d6bcfc8-7d4d-4382-9f38-81547ec8c58b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 22:28:50
39341	9d6bcfc8-7c64-4e54-b428-397cf753cffe	9d6bcfc8-7d4d-4382-9f38-81547ec8c58b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":567,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:28:50
39342	9d6bcfc8-c730-454c-914f-071106b49090	9d6bcfc8-cac0-4ca5-86a8-6a7bb87e0690	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":161,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:28:51
24994	9d68befb-feb9-4efa-972f-60ac67c8e39d	9d68befc-1e96-43c8-aa52-0e363f82943c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 09:54:23
24995	9d68befc-1c59-4061-9c6b-b24d41154195	9d68befc-1e96-43c8-aa52-0e363f82943c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 09:54:23
24996	9d68befc-1d85-4234-88b7-1d08c7d81ed8	9d68befc-1e96-43c8-aa52-0e363f82943c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-11-04 09:54:23
26386	9d68d359-72ac-4a76-8e33-1d07ef7042bd	9d68d359-aab2-40fb-93ef-c405ed3306c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 10:51:20
26387	9d68d359-9cdb-4792-ba38-79cabe2a59f3	9d68d359-aab2-40fb-93ef-c405ed3306c8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"66.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 10:51:20
26388	9d68d359-9d84-48a6-92a4-3caa57ae13c0	9d68d359-aab2-40fb-93ef-c405ed3306c8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 10:51:20
26389	9d68d359-a7f3-4ff4-8b94-ee137ff413ca	9d68d359-aab2-40fb-93ef-c405ed3306c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 10:51:20
26390	9d68d359-a8af-4a73-8815-5f48c5293fae	9d68d359-aab2-40fb-93ef-c405ed3306c8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Dashboard","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":767,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:51:20
39343	9d6bcfc9-2591-4d9c-b3ed-50fb397fd29c	9d6bcfc9-2ccb-47c2-b48e-159f1c723ac4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 22:28:51
39344	9d6bcfc9-2b66-4d97-b2bf-d23f3cc8b30d	9d6bcfc9-2ccb-47c2-b48e-159f1c723ac4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 22:28:51
39345	9d6bcfc9-2bbc-4808-9729-a5120ac95a7d	9d6bcfc9-2ccb-47c2-b48e-159f1c723ac4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null}},"duration":189,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:28:51
29399	9d692448-f700-4526-8325-39c3c8147d57	9d692449-390b-4a9b-83e7-c377b6293c9a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 14:37:38
29400	9d692449-34e8-4494-be2e-57f65ef12e88	9d692449-390b-4a9b-83e7-c377b6293c9a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 14:37:39
29401	9d692449-36cf-40bf-b7d8-97cf9ab8952d	9d692449-390b-4a9b-83e7-c377b6293c9a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":505,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:37:39
29402	9d69244b-9f4e-4917-b8dc-607aad13bac9	9d69244b-d18a-4006-b12a-55305e589665	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 14:37:40
29403	9d69244b-c7eb-45c9-89c4-0a5e2960f8a6	9d69244b-d18a-4006-b12a-55305e589665	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"65.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:37:40
29404	9d69244b-c87a-4666-9caa-013352356c17	9d69244b-d18a-4006-b12a-55305e589665	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:37:40
29405	9d69244b-cf93-4a73-b0e6-456aecbc1778	9d69244b-d18a-4006-b12a-55305e589665	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 14:37:40
29406	9d69244b-d01e-4b40-9bad-a9f159604cde	9d69244b-d18a-4006-b12a-55305e589665	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":883,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:37:40
41678	9d6cce9c-6300-4553-a93a-1e6418fbdded	9d6cce9c-65bd-4603-9623-c51fd3cbf2a5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1916}	2024-11-06 10:21:23
29407	9d69244c-520f-49fe-9878-9b1b576c0ffd	9d69244c-8414-4abd-8be0-6aa46c34605a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 14:37:41
29408	9d69244c-7bc0-43f6-9cc1-a2f2ebb04e6d	9d69244c-8414-4abd-8be0-6aa46c34605a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"67.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:37:41
29409	9d69244c-7c4a-4dc4-9c6f-729fb6d42cfe	9d69244c-8414-4abd-8be0-6aa46c34605a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:37:41
29410	9d69244c-822e-4ff2-a43a-6434d9692b7d	9d69244c-8414-4abd-8be0-6aa46c34605a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 14:37:41
29411	9d69244c-82b9-427e-8c52-76eaf5590ed7	9d69244c-8414-4abd-8be0-6aa46c34605a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":434,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:37:41
41610	9d6ccdde-4c0c-4e7b-bbce-8b089d787fa4	9d6ccdde-4eaf-42b3-b90e-9a64babb09e1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1908}	2024-11-06 10:19:19
35134	9d69c2dc-e346-4165-97eb-81a3c337c56b	9d69c2dd-0f69-48d8-9c4d-985dcac9517b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 22:01:03
35135	9d69c2dd-0d3a-45bf-90e2-3219980798b9	9d69c2dd-0f69-48d8-9c4d-985dcac9517b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 22:01:03
35136	9d69c2dd-0e1c-436f-98ec-85f9661f6571	9d69c2dd-0f69-48d8-9c4d-985dcac9517b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":403,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:01:03
34248	9d69bbf3-abb3-4fc8-8028-c3ebba4feca5	9d69bbf4-0736-43fb-9fe4-e04394c630a8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 21:41:44
34249	9d69bbf4-0412-4b03-8d68-3a3d41821dc2	9d69bbf4-0736-43fb-9fe4-e04394c630a8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 21:41:44
34250	9d69bbf4-0559-47cc-94bf-f63dac38f134	9d69bbf4-0736-43fb-9fe4-e04394c630a8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":577,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:41:44
35137	9d69c2dd-a01e-4873-b608-cf607c705d75	9d69c2dd-f5f5-40f1-9097-b9f23f7771be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 22:01:04
35138	9d69c2dd-eea9-4e4e-a1cd-cffb6c67fbe8	9d69c2dd-f5f5-40f1-9097-b9f23f7771be	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"168.59","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 22:01:04
35139	9d69c2dd-f458-4692-804d-b136258308b5	9d69c2dd-f5f5-40f1-9097-b9f23f7771be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 22:01:04
16481	9d64ccc7-6802-4e9c-a8f6-73775c7743ac	9d64ccc7-6b1a-403b-8ed1-65f09af1e2a4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":767}	2024-11-02 10:49:39
34251	9d69bbf4-9e66-4c09-a972-37508f7806af	9d69bbf4-caeb-45da-af89-5c8eeeb45be5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 21:41:44
34252	9d69bbf4-c161-443b-afd5-11d424e15397	9d69bbf4-caeb-45da-af89-5c8eeeb45be5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"59.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":227,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:41:45
34253	9d69bbf4-c1e9-4dab-bf53-5a14406e4cf4	9d69bbf4-caeb-45da-af89-5c8eeeb45be5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:41:45
34254	9d69bbf4-c8bc-4bd7-bfcc-c0306587aa9e	9d69bbf4-caeb-45da-af89-5c8eeeb45be5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 21:41:45
34255	9d69bbf4-c963-4fd4-8744-5647b3207ade	9d69bbf4-caeb-45da-af89-5c8eeeb45be5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":416,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:41:45
35140	9d69c2dd-f4ef-4b3c-b1c2-86c6a53ddd9b	9d69c2dd-f5f5-40f1-9097-b9f23f7771be	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":473,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:01:04
34256	9d69bbf5-3ff5-46ed-af72-12e16d465f92	9d69bbf5-6f7e-45fe-b722-01247a7e2b0e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 21:41:45
34257	9d69bbf5-665f-4044-bcde-fcd60e86f2f8	9d69bbf5-6f7e-45fe-b722-01247a7e2b0e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"57.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":216,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 21:41:45
34258	9d69bbf5-66e0-47d6-8df3-c7044d183994	9d69bbf5-6f7e-45fe-b722-01247a7e2b0e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 21:41:45
34259	9d69bbf5-6d8a-444b-996f-0eacb32938b3	9d69bbf5-6f7e-45fe-b722-01247a7e2b0e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 21:41:45
34260	9d69bbf5-6e13-4ccf-935f-780bcce24a2e	9d69bbf5-6f7e-45fe-b722-01247a7e2b0e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":400,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:41:45
34261	9d69bbf5-d85d-4f90-aa8c-a9b573e5a376	9d69bbf5-fb4d-4883-a6cb-b48d93a4afd4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 21:41:45
34262	9d69bbf5-f626-4a84-bc4c-ea7669c58b90	9d69bbf5-fb4d-4883-a6cb-b48d93a4afd4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"50.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:41:45
34263	9d69bbf5-f676-4576-b33e-30b41c6c3412	9d69bbf5-fb4d-4883-a6cb-b48d93a4afd4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:41:45
34264	9d69bbf5-fa2e-48fc-b0d7-5895a73afa3c	9d69bbf5-fb4d-4883-a6cb-b48d93a4afd4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 21:41:45
34265	9d69bbf5-fa79-477a-97ef-7a16f4b81e89	9d69bbf5-fb4d-4883-a6cb-b48d93a4afd4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":331,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:41:45
40259	9d6cc237-eb96-4f9a-9fbd-9d796986afac	9d6cc237-ef0f-4261-9f7e-d05a75f79388	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1798}	2024-11-06 09:46:44
34266	9d69bbf6-8feb-4784-811c-4feaf9a519f2	9d69bbf6-cc47-4057-a26e-50de30bdbec2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 21:41:46
34267	9d69bbf6-c01f-40ed-8988-e6c20eb0d8ea	9d69bbf6-cc47-4057-a26e-50de30bdbec2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"85.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:41:46
34268	9d69bbf6-c0ca-4ce2-9d32-7f8b13d810a7	9d69bbf6-cc47-4057-a26e-50de30bdbec2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:41:46
34269	9d69bbf6-c9d4-4ec1-b80c-ef5b76e9485f	9d69bbf6-cc47-4057-a26e-50de30bdbec2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 21:41:46
34270	9d69bbf6-ca9f-4f40-882e-63682364c071	9d69bbf6-cc47-4057-a26e-50de30bdbec2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":514,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:41:46
34271	9d69bbf7-cc1c-4e66-bff3-e947ec531a58	9d69bbf8-1cd4-4ff0-ad23-c200b1871617	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 21:41:47
34272	9d69bbf8-1595-451e-b75f-733ab23a9314	9d69bbf8-1cd4-4ff0-ad23-c200b1871617	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"155.13","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:41:47
34273	9d69bbf8-15fe-42c9-8b05-0a32deb5a0be	9d69bbf8-1cd4-4ff0-ad23-c200b1871617	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:41:47
34274	9d69bbf8-1b21-47fa-8049-802885de7b40	9d69bbf8-1cd4-4ff0-ad23-c200b1871617	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 21:41:47
34275	9d69bbf8-1ba3-4248-9d34-e6257daef787	9d69bbf8-1cd4-4ff0-ad23-c200b1871617	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":675,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:41:47
39627	9d6bdf6f-de88-4a3e-9e0e-fcfb34709eba	9d6bdf70-2595-482f-b9d6-749d75bf4a01	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 23:12:37
39628	9d6bdf70-23d1-4957-b193-c2cf5982cbee	9d6bdf70-2595-482f-b9d6-749d75bf4a01	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 23:12:37
39629	9d6bdf70-246a-421a-ac0a-26f750da9055	9d6bdf70-2595-482f-b9d6-749d75bf4a01	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":350,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:12:37
34276	9d69bc01-e682-4a36-92bf-ee8645574e5b	9d69bc02-295e-4a21-a8f3-e2960211dcb7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 21:41:53
34277	9d69bc02-2485-49b8-8c64-02051e3d9516	9d69bc02-295e-4a21-a8f3-e2960211dcb7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"145.57","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 21:41:53
34278	9d69bc02-27e0-461f-a0df-5887057cdfec	9d69bc02-295e-4a21-a8f3-e2960211dcb7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 21:41:53
34279	9d69bc02-284f-475e-bdb7-e5d19c1fd7bc	9d69bc02-295e-4a21-a8f3-e2960211dcb7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":339,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:41:53
39630	9d6bdf71-45c5-4b90-83bb-8635d5798e8b	9d6bdf71-8ad0-4b3a-915e-1e6566699ff9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 23:12:38
39631	9d6bdf71-85a0-4ede-a6ad-2e9471200217	9d6bdf71-8ad0-4b3a-915e-1e6566699ff9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"140.38","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 23:12:38
39632	9d6bdf71-85f8-4aad-bf2e-3941a58aaa6a	9d6bdf71-8ad0-4b3a-915e-1e6566699ff9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 23:12:38
39633	9d6bdf71-8969-4b1f-9ec5-a7b5847ef5d5	9d6bdf71-8ad0-4b3a-915e-1e6566699ff9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 23:12:38
39634	9d6bdf71-89ad-4890-b8e9-f86df949737e	9d6bdf71-8ad0-4b3a-915e-1e6566699ff9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":416,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:12:38
34280	9d69bc07-cc2b-4a1d-aa9f-5be529453b2a	9d69bc07-f358-4cf7-86e4-d85e43053596	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 21:41:57
34281	9d69bc07-ecf6-469b-a7fb-71a07b69b3e4	9d69bc07-f358-4cf7-86e4-d85e43053596	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":227,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:41:57
34282	9d69bc07-ed5d-4b61-9e65-c3433a22bdab	9d69bc07-f358-4cf7-86e4-d85e43053596	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:41:57
34283	9d69bc07-f1c1-4cf3-8557-b1210fa0cfde	9d69bc07-f358-4cf7-86e4-d85e43053596	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:41:57
34284	9d69bc07-f219-405e-bc99-0cc015030479	9d69bc07-f358-4cf7-86e4-d85e43053596	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":307,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:41:57
34285	9d69bc08-53f2-47b3-9e46-a1f42e2d74af	9d69bc08-719d-4c9f-aa22-ccbb1e65eece	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:41:57
34286	9d69bc08-6c48-42ba-af91-be1ba0eec9a8	9d69bc08-719d-4c9f-aa22-ccbb1e65eece	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":216,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 21:41:57
34287	9d69bc08-6ca0-4e15-b502-be278850745a	9d69bc08-719d-4c9f-aa22-ccbb1e65eece	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 21:41:57
34288	9d69bc08-7040-4b83-9660-4bf61c4252f2	9d69bc08-719d-4c9f-aa22-ccbb1e65eece	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:41:57
34289	9d69bc08-7090-4750-889f-9ebeeed41201	9d69bc08-719d-4c9f-aa22-ccbb1e65eece	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":308,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:41:57
34290	9d69bc08-b551-4c4e-b9ce-aae3265cdcb7	9d69bc08-d29b-4c4e-82a0-d8d58fce2ef5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:41:58
34291	9d69bc08-cd93-48a2-b066-fd3eb58a822b	9d69bc08-d29b-4c4e-82a0-d8d58fce2ef5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:41:58
34292	9d69bc08-cdea-4440-bc36-4d60d2d8ca2c	9d69bc08-d29b-4c4e-82a0-d8d58fce2ef5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:41:58
34293	9d69bc08-d158-48f8-8c31-53522848baf7	9d69bc08-d29b-4c4e-82a0-d8d58fce2ef5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:41:58
34294	9d69bc08-d1a6-4d57-bf0d-546c8aa04beb	9d69bc08-d29b-4c4e-82a0-d8d58fce2ef5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:41:58
34295	9d69bc09-1553-4ff9-9c59-73f93b1b7018	9d69bc09-34cc-4eb5-9a4e-75f9fe6e9e50	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:41:58
34296	9d69bc09-2b28-4c35-a4c6-4ee13de5127c	9d69bc09-34cc-4eb5-9a4e-75f9fe6e9e50	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '88' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"36.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 21:41:58
34297	9d69bc09-2b7f-4344-913d-821b6a0cc085	9d69bc09-34cc-4eb5-9a4e-75f9fe6e9e50	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 21:41:58
34298	9d69bc09-2d76-4eec-9b90-72e680c51350	9d69bc09-34cc-4eb5-9a4e-75f9fe6e9e50	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '88' order by \\"item_loans\\".\\"id\\" asc","time":"2.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 21:41:58
34299	9d69bc09-2dc9-407c-b6a2-f58a50f3d277	9d69bc09-34cc-4eb5-9a4e-75f9fe6e9e50	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 21:41:58
34300	9d69bc09-32fc-4586-a206-6cefd2d30711	9d69bc09-34cc-4eb5-9a4e-75f9fe6e9e50	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:41:58
34301	9d69bc09-3369-457f-85d2-6f9151dab5f1	9d69bc09-34cc-4eb5-9a4e-75f9fe6e9e50	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/88","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":88,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"275000","loans_pago_prestado":"1100000","loans_intereses_recaudar":"275000"},"items":[{"id":346,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T14:18:38.000000Z","updated_at":"2024-11-04T14:33:19.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":361,"loans_codigo":88,"itemloans_cuota":"1","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":362,"loans_codigo":88,"itemloans_cuota":"2","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":363,"loans_codigo":88,"itemloans_cuota":"3","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":364,"loans_codigo":88,"itemloans_cuota":"4","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"},{"id":365,"loans_codigo":88,"itemloans_cuota":"5","itemloans_valor_cuota":"140000","itemloans_iteres":"35000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T14:33:19.000000Z","updated_at":"2024-11-04T14:44:59.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"35000","itemloans_cuota_cancelada":"140000"}]}},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:41:58
34302	9d69bc1b-302d-43a2-ad44-1467ab8e1d0c	9d69bc1b-4927-4ab5-9c6a-14290e584969	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:42:10
34303	9d69bc1b-44bd-410c-aa06-3fe6c691e25d	9d69bc1b-4927-4ab5-9c6a-14290e584969	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"41.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 21:42:10
34304	9d69bc1b-479e-4d4a-b294-bee4c34dddf8	9d69bc1b-4927-4ab5-9c6a-14290e584969	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:42:10
34305	9d69bc1b-4811-4ae5-9298-35a9b616a984	9d69bc1b-4927-4ab5-9c6a-14290e584969	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":208,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:42:10
34306	9d69bc21-5fbf-48f4-8fdb-0fb82ba064af	9d69bc21-7f8b-4f88-9d27-8e58e0fefe2c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:42:14
34307	9d69bc21-79b6-4194-af4d-acc109f8e743	9d69bc21-7f8b-4f88-9d27-8e58e0fefe2c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":227,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:42:14
34308	9d69bc21-7a2a-4288-9077-44e4216cb888	9d69bc21-7f8b-4f88-9d27-8e58e0fefe2c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:42:14
34309	9d69bc21-7e2d-4e99-b028-e44d8d2d81c0	9d69bc21-7f8b-4f88-9d27-8e58e0fefe2c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:42:14
34310	9d69bc21-7e80-4347-9c67-57011d246fb6	9d69bc21-7f8b-4f88-9d27-8e58e0fefe2c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":291,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:42:14
39690	9d6be219-e124-469e-b879-1d7d0b520378	9d6be21a-0018-4ea8-ad43-93930751b3c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 23:20:04
39691	9d6be219-fe78-435a-a46e-c98943d8fe90	9d6be21a-0018-4ea8-ad43-93930751b3c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 23:20:04
39692	9d6be219-ff1f-4ec5-802f-8a410b9a1d95	9d6be21a-0018-4ea8-ad43-93930751b3c0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:20:04
34311	9d69bc21-c172-4b45-9a07-92eac6faa80c	9d69bc22-073f-44df-a5fa-599519c3297f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:42:14
34312	9d69bc22-0213-47b5-a0bb-ce328cfad8a9	9d69bc22-073f-44df-a5fa-599519c3297f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"142.43","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":216,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 21:42:14
34313	9d69bc22-026c-477c-b18f-9978355eb634	9d69bc22-073f-44df-a5fa-599519c3297f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 21:42:14
34314	9d69bc22-0605-4b03-873d-d763c1cbbfaf	9d69bc22-073f-44df-a5fa-599519c3297f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:42:14
34315	9d69bc22-0653-46c6-91c8-5e15ec83d2c8	9d69bc22-073f-44df-a5fa-599519c3297f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":328,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:42:14
39693	9d6be21b-6cbc-41dd-ae36-8042e83abcac	9d6be21b-9142-4160-8fe0-1eae857dd704	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 23:20:05
39694	9d6be21b-897f-4bda-920b-91ae757777f1	9d6be21b-9142-4160-8fe0-1eae857dd704	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"51.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 23:20:05
39695	9d6be21b-89df-4924-944b-fe79076fbec9	9d6be21b-9142-4160-8fe0-1eae857dd704	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 23:20:05
39696	9d6be21b-8f76-43b5-96f3-32dafe7cbb31	9d6be21b-9142-4160-8fe0-1eae857dd704	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 23:20:05
39697	9d6be21b-8fec-452c-a616-799fe161ff01	9d6be21b-9142-4160-8fe0-1eae857dd704	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":401,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:20:05
34316	9d69bc22-4d2e-412a-a597-753988755bb4	9d69bc22-6c26-41a2-83d8-e3b380a91691	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:42:14
34317	9d69bc22-66a5-495a-890e-4c50d10d2616	9d69bc22-6c26-41a2-83d8-e3b380a91691	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:42:14
34318	9d69bc22-6707-48a1-8fa1-dd3038f6811a	9d69bc22-6c26-41a2-83d8-e3b380a91691	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:42:14
34319	9d69bc22-6acc-4be5-bb05-1fc7c1560fac	9d69bc22-6c26-41a2-83d8-e3b380a91691	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 21:42:14
34320	9d69bc22-6b1a-481a-a24a-6f4c574b505c	9d69bc22-6c26-41a2-83d8-e3b380a91691	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:42:14
34321	9d69bc22-b4bc-4e26-8212-71248c8e39ab	9d69bc22-f839-45a3-b66e-692e88bf0d7a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 21:42:15
34322	9d69bc22-f191-4d1c-b2a6-b707ac7d2b63	9d69bc22-f839-45a3-b66e-692e88bf0d7a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '93' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"138.16","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 21:42:15
34323	9d69bc22-f1e9-45ca-bd82-a4fd6eb55143	9d69bc22-f839-45a3-b66e-692e88bf0d7a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 21:42:15
34324	9d69bc22-f37e-4f7a-9e64-3d0f8ed0153b	9d69bc22-f839-45a3-b66e-692e88bf0d7a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"1.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 21:42:15
34325	9d69bc22-f3b7-4d76-8d20-ecc98803bac0	9d69bc22-f839-45a3-b66e-692e88bf0d7a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 21:42:15
34326	9d69bc22-f6e0-4d30-ae29-1313b05def1b	9d69bc22-f839-45a3-b66e-692e88bf0d7a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 21:42:15
34327	9d69bc22-f72f-49c3-aa0e-fbb3b13124ac	9d69bc22-f839-45a3-b66e-692e88bf0d7a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":93,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","user_creador":12,"user_recomendacion":18,"loans_valor_prestado":1000000,"user_customer":19,"user_cobrador":22,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"250000","loans_pago_prestado":"1000000","loans_intereses_recaudar":"250000"},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:19:45.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:22:30.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":399,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":400,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":401,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":402,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"}]}},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:42:15
35282	9d69c3ed-0bb8-43c9-9b5c-f69cd6becf07	9d69c3ed-29d0-40f3-8f14-8185f4fd3624	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 22:04:02
35283	9d69c3ed-2825-49a3-ada5-79c852032191	9d69c3ed-29d0-40f3-8f14-8185f4fd3624	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 22:04:02
35284	9d69c3ed-28dc-43ce-9a06-04a2e5a82aa8	9d69c3ed-29d0-40f3-8f14-8185f4fd3624	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":245,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:04:02
35285	9d69c3ed-889c-4034-afe6-999ea8098a58	9d69c3ed-aa89-47f4-bf6d-f8f106c794fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 22:04:02
35286	9d69c3ed-a493-48ce-8275-247c3fd5f824	9d69c3ed-aa89-47f4-bf6d-f8f106c794fe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:04:02
35287	9d69c3ed-a51b-4b80-a1dd-04a05d1cc7d3	9d69c3ed-aa89-47f4-bf6d-f8f106c794fe	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:04:02
35288	9d69c3ed-a92c-461c-a05c-485ac2e4d913	9d69c3ed-aa89-47f4-bf6d-f8f106c794fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 22:04:02
35289	9d69c3ed-a985-486f-9afe-a3ccddcd957f	9d69c3ed-aa89-47f4-bf6d-f8f106c794fe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:04:02
39773	9d6cb55b-0f49-41e5-a3cd-5fca4740f44c	9d6cb55b-63aa-47d0-9d8b-49791081cd5d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 09:10:46
39774	9d6cb55b-60ed-496c-b65a-c7361a767607	9d6cb55b-63aa-47d0-9d8b-49791081cd5d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:10:46
39775	9d6cb55b-61f0-4705-9e8d-22b733627922	9d6cb55b-63aa-47d0-9d8b-49791081cd5d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":437,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:10:46
29606	9d6929ca-b0b0-4b91-bb24-b08473a917de	9d6929ca-eabe-4f4d-8b31-0000ea855b80	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 14:53:02
29607	9d6929ca-e7c3-47f8-9694-84ba69ae4324	9d6929ca-eabe-4f4d-8b31-0000ea855b80	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 14:53:02
29608	9d6929ca-e924-4c40-acff-66ea39d4426b	9d6929ca-eabe-4f4d-8b31-0000ea855b80	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":441,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:53:02
29609	9d6929cb-9991-41e9-b11d-8180a5c9f3aa	9d6929cb-c845-4c47-b933-7afe0c4f83a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 14:53:03
29610	9d6929cb-bff7-4070-b932-5709cc065743	9d6929cb-c845-4c47-b933-7afe0c4f83a5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"58.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":56,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 14:53:03
29611	9d6929cb-c080-476a-b2fc-a010d6bfbc46	9d6929cb-c845-4c47-b933-7afe0c4f83a5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 14:53:03
29612	9d6929cb-c6bf-4a8e-91fc-316da7b7b550	9d6929cb-c845-4c47-b933-7afe0c4f83a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 14:53:03
29613	9d6929cb-c72e-428f-ab05-80635f61bf71	9d6929cb-c845-4c47-b933-7afe0c4f83a5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":469,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:53:03
35290	9d69c3ed-f1df-41c6-a382-52647a285891	9d69c3ee-11ba-47f5-893a-90ae781e4a29	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 22:04:02
35291	9d69c3ee-0bc7-48d9-8b19-d605bd884fc3	9d69c3ee-11ba-47f5-893a-90ae781e4a29	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 22:04:02
35292	9d69c3ee-0c2f-4d20-9bdf-cb06c62258fe	9d69c3ee-11ba-47f5-893a-90ae781e4a29	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 22:04:02
35293	9d69c3ee-106a-48ed-b146-c4fd5d95bef9	9d69c3ee-11ba-47f5-893a-90ae781e4a29	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 22:04:02
35294	9d69c3ee-10c1-436b-92ae-a11d661ab160	9d69c3ee-11ba-47f5-893a-90ae781e4a29	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":245,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:04:02
39776	9d6cb55c-c0fb-41af-bb4d-37aad2824679	9d6cb55c-e5bb-48b7-8a9f-b625d9400edf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:10:47
39777	9d6cb55c-dee7-41e0-89d1-a901e779671c	9d6cb55c-e5bb-48b7-8a9f-b625d9400edf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"52.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:10:47
39778	9d6cb55c-df3d-4682-8b9b-3588c802d8b8	9d6cb55c-e5bb-48b7-8a9f-b625d9400edf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:10:47
39779	9d6cb55c-e430-42cb-9de3-b29924ce07b1	9d6cb55c-e5bb-48b7-8a9f-b625d9400edf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:10:47
39780	9d6cb55c-e489-402d-b140-aa4efc450d0c	9d6cb55c-e5bb-48b7-8a9f-b625d9400edf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":360,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:10:47
29614	9d6929cc-e5db-4298-8a65-46710067c05b	9d6929cd-28f8-4a32-b906-eb83e6defd74	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 14:53:04
29615	9d6929cd-1f6e-4fb0-bac5-8d69482aa7b0	9d6929cd-28f8-4a32-b906-eb83e6defd74	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"82.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:53:04
29616	9d6929cd-2009-469a-8a67-125b646a5369	9d6929cd-28f8-4a32-b906-eb83e6defd74	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:53:04
29617	9d6929cd-2709-4004-93c8-6e11a61c4409	9d6929cd-28f8-4a32-b906-eb83e6defd74	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 14:53:04
29618	9d6929cd-2799-4b80-9091-3fa918269d40	9d6929cd-28f8-4a32-b906-eb83e6defd74	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":882,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:53:04
35295	9d69c3ee-6142-46c1-9d45-6fb2285d8252	9d69c3ee-a877-49d0-ad3d-bc682b96ad23	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 22:04:03
35296	9d69c3ee-a378-4760-905a-56efbc9425ae	9d69c3ee-a877-49d0-ad3d-bc682b96ad23	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"144.12","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:04:03
35297	9d69c3ee-a3cd-47ef-bf5f-f310bae02d9d	9d69c3ee-a877-49d0-ad3d-bc682b96ad23	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:04:03
35298	9d69c3ee-a751-4789-8e6a-f413e630c4c5	9d69c3ee-a877-49d0-ad3d-bc682b96ad23	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 22:04:03
35299	9d69c3ee-a799-4d5d-8f8a-b5b31b0c5d1e	9d69c3ee-a877-49d0-ad3d-bc682b96ad23	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":365,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:04:03
29619	9d6929cd-e1dc-4f59-93c9-b8c417273019	9d6929ce-36f0-43f9-b563-6fd69441d0a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 14:53:04
29620	9d6929ce-2e0e-46be-a4a5-5a7fdfc036e2	9d6929ce-36f0-43f9-b563-6fd69441d0a6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"156.61","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:53:05
29621	9d6929ce-2e91-4f32-acdc-d146d967211c	9d6929ce-36f0-43f9-b563-6fd69441d0a6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:53:05
29622	9d6929ce-350b-49c3-90ad-78b89a72fbed	9d6929ce-36f0-43f9-b563-6fd69441d0a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 14:53:05
29623	9d6929ce-3595-434b-bc93-870bfd57171a	9d6929ce-36f0-43f9-b563-6fd69441d0a6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":651,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:53:05
31452	9d694c37-78a1-40db-808a-ed658259dfd5	9d694c37-abf1-491b-b258-5dbe2e9f9470	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 16:29:18
31453	9d694c37-a907-4055-a18a-ced40e22b6db	9d694c37-abf1-491b-b258-5dbe2e9f9470	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:29:18
31454	9d694c37-aa48-4cae-8fcc-5507eace5c9b	9d694c37-abf1-491b-b258-5dbe2e9f9470	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":557,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:29:18
31455	9d694c38-2efc-48ab-918c-9f723b005bc2	9d694c38-9b47-40ce-8af2-bf01f23a768a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:29:18
31456	9d694c38-93c1-4e40-b73f-2ed75f13de21	9d694c38-9b47-40ce-8af2-bf01f23a768a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"166.72","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:29:19
31457	9d694c38-9447-49ed-93ce-999c7011130c	9d694c38-9b47-40ce-8af2-bf01f23a768a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 16:29:19
31357	9d694aa9-55b2-43c6-b2a9-6a4a5358beec	9d694aa9-a2eb-42f8-a2ae-f115c1260520	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:24:57
31358	9d694aa9-9794-425d-ac5d-13bb480d1944	9d694aa9-a2eb-42f8-a2ae-f115c1260520	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"155.55","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 16:24:57
31359	9d694aa9-a124-4de9-a74e-1272fad5e1e8	9d694aa9-a2eb-42f8-a2ae-f115c1260520	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:24:57
31458	9d694c38-99b4-4fc6-8356-30216db543b0	9d694c38-9b47-40ce-8af2-bf01f23a768a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:29:19
31459	9d694c38-9a28-4941-932d-33a2cc5c6da2	9d694c38-9b47-40ce-8af2-bf01f23a768a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":538,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:29:19
31360	9d694aa9-a1eb-44d4-9158-7eb52542fd44	9d694aa9-a2eb-42f8-a2ae-f115c1260520	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42883]: Undefined function: 7 ERROR:  el operador no existe: character varying = bigint\\nLINE 1: ...oin \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\"....\\n                                                             ^\\nHINT:  Ning\\u00fan operador coincide en el nombre y tipos de argumentos. Puede ser necesario agregar conversi\\u00f3n expl\\u00edcita de tipos. (Connection: pgsql, SQL: select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" inner join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = 92 order by \\"item_loans\\".\\"id\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":304,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":369,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:24:57
31460	9d694c38-f414-42df-8b44-8cc0ffbca0fb	9d694c39-1f2b-4c77-81bc-bc15785d742c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:29:19
31461	9d694c39-16f0-4b06-aade-7452a9a3de29	9d694c39-1f2b-4c77-81bc-bc15785d742c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"59.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:29:19
31462	9d694c39-1770-441a-91f8-990f1a6204e4	9d694c39-1f2b-4c77-81bc-bc15785d742c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 16:29:19
31463	9d694c39-1d3a-41dc-b09e-bedb274ba9ae	9d694c39-1f2b-4c77-81bc-bc15785d742c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:29:19
31464	9d694c39-1db6-48ab-a7a5-dd48435fea5b	9d694c39-1f2b-4c77-81bc-bc15785d742c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":320,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:29:19
31361	9d694aab-0d18-4f25-92b5-e616453c3417	9d694aab-3948-4f49-a882-71738e8979b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:24:58
31362	9d694aab-3050-43f0-9921-712f3ed4bc5f	9d694aab-3948-4f49-a882-71738e8979b6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"59.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:24:58
31363	9d694aab-30e1-4f96-bb34-a763617608e8	9d694aab-3948-4f49-a882-71738e8979b6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:24:58
31364	9d694aab-3748-43de-a8dd-e6eccffc22c9	9d694aab-3948-4f49-a882-71738e8979b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 16:24:58
31365	9d694aab-37d0-446b-98f2-99aa5427c82e	9d694aab-3948-4f49-a882-71738e8979b6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":448,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:24:58
43516	9d6cea0b-4dfd-4f58-9bb7-43930b0ad5bd	9d6cea0b-508a-40e4-b573-66ff8ab315a2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2040}	2024-11-06 11:38:06
39840	9d6cb783-ef86-4a5f-8097-2ff05edf9d77	9d6cb784-39bc-44dd-92c7-76c1b9fa5185	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:16:49
39841	9d6cb784-380a-489f-8617-115caaf01746	9d6cb784-39bc-44dd-92c7-76c1b9fa5185	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:16:49
39842	9d6cb784-38a7-4e02-bdda-4e5f77696ea6	9d6cb784-39bc-44dd-92c7-76c1b9fa5185	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":524,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:16:49
35450	9d69c4d1-2a79-4a49-a309-03b647416363	9d69c4d1-7b3d-480f-bf40-87b6e7ef9f13	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 22:06:31
35451	9d69c4d1-790a-42d4-84ab-8a2362bbf2f5	9d69c4d1-7b3d-480f-bf40-87b6e7ef9f13	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 22:06:31
35452	9d69c4d1-79f5-4ec6-b671-f8bc77bedccb	9d69c4d1-7b3d-480f-bf40-87b6e7ef9f13	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":398,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:06:31
31598	9d6951bd-9975-4c7e-acaf-7dcf23a8f120	9d6951bd-e94a-43df-852a-9660182c5663	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 16:44:45
31599	9d6951bd-e72c-451b-97b9-38a5aba855ef	9d6951bd-e94a-43df-852a-9660182c5663	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 16:44:45
31600	9d6951bd-e81b-4a81-b3f4-7d49e59529ce	9d6951bd-e94a-43df-852a-9660182c5663	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":468,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:44:45
31601	9d6951be-509f-47a8-96c9-ec96aa7f633a	9d6951be-7220-4f7d-9cf8-1fe9a1b4a0ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 16:44:45
31602	9d6951be-6b9f-4d77-a7b3-f19b366b7d2f	9d6951be-7220-4f7d-9cf8-1fe9a1b4a0ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:44:45
31603	9d6951be-6c0c-473a-8f2a-a6101592410d	9d6951be-7220-4f7d-9cf8-1fe9a1b4a0ca	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 16:44:45
31604	9d6951be-7098-403c-8740-0d07186454d6	9d6951be-7220-4f7d-9cf8-1fe9a1b4a0ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 16:44:45
31605	9d6951be-70f9-4367-a2a5-f059c8e2f3ec	9d6951be-7220-4f7d-9cf8-1fe9a1b4a0ca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":282,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:44:45
35453	9d69c4d1-e6a2-4f9b-8dbb-6d328e5a4f8e	9d69c4d2-0737-48fb-abaf-97d33cbe587a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 22:06:32
35454	9d69c4d2-00ef-42e6-bf6d-ce2ff8cca0d0	9d69c4d2-0737-48fb-abaf-97d33cbe587a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:06:32
35455	9d69c4d2-0146-4576-98d7-5b65d315933c	9d69c4d2-0737-48fb-abaf-97d33cbe587a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:06:32
35456	9d69c4d2-05f0-4edb-bc66-45eb3683b95f	9d69c4d2-0737-48fb-abaf-97d33cbe587a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 22:06:32
35457	9d69c4d2-064e-4ea5-b94e-dbc6a37ddf26	9d69c4d2-0737-48fb-abaf-97d33cbe587a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":299,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:06:32
31606	9d6951be-d423-48c5-ac68-7cf2c1eb9fa4	9d6951bf-0022-4a79-a549-c0fb08ed9032	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 16:44:45
31607	9d6951be-f816-4b65-817d-1c1ece2238c0	9d6951bf-0022-4a79-a549-c0fb08ed9032	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"55.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:44:45
31608	9d6951be-f898-455c-aecd-b982d418a8f3	9d6951bf-0022-4a79-a549-c0fb08ed9032	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 16:44:45
31609	9d6951be-fe53-44e9-bebf-0bddd9274132	9d6951bf-0022-4a79-a549-c0fb08ed9032	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 16:44:45
31610	9d6951be-fef2-4e7e-9188-14e3fd8a4ed4	9d6951bf-0022-4a79-a549-c0fb08ed9032	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":343,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:44:45
35458	9d69c4d2-4e20-411f-a56c-4b8e1b05040f	9d69c4d2-9743-4c10-813b-ef48dae36e81	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 22:06:32
35459	9d69c4d2-91df-40ce-a70f-08fe36518247	9d69c4d2-9743-4c10-813b-ef48dae36e81	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"152.01","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 22:06:32
35460	9d69c4d2-923d-4407-b00b-c20ff7bc4bd8	9d69c4d2-9743-4c10-813b-ef48dae36e81	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 22:06:32
35461	9d69c4d2-9618-43d5-a4ce-6e921cf31f9a	9d69c4d2-9743-4c10-813b-ef48dae36e81	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 22:06:32
35462	9d69c4d2-9668-4b48-8285-09fe1f8635ea	9d69c4d2-9743-4c10-813b-ef48dae36e81	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:06:32
35463	9d69c4d2-de60-491a-8e44-e31e3ea8b19a	9d69c4d2-fc51-40cf-a661-d7728c0300d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 22:06:32
35464	9d69c4d2-f753-4696-8368-7d4f9cdf485e	9d69c4d2-fc51-40cf-a661-d7728c0300d3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:06:32
35465	9d69c4d2-f7a4-4747-830e-1ea5e8860bc6	9d69c4d2-fc51-40cf-a661-d7728c0300d3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:06:32
35466	9d69c4d2-fb2e-4af7-8b16-30ab0a194c82	9d69c4d2-fc51-40cf-a661-d7728c0300d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 22:06:32
35467	9d69c4d2-fb75-4c0c-96e0-8b2f4419ab48	9d69c4d2-fc51-40cf-a661-d7728c0300d3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":245,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:06:32
20316	9d66f127-9ea7-4b66-b97d-de2b259a8c4e	9d66f127-a192-4f0f-8fa7-735de6c55a33	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1007}	2024-11-03 12:23:01
35702	9d69c57e-4750-4498-8225-2f8d35a88ea6	9d69c57e-96ec-42fb-9fc2-fd09b687cd8f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 22:08:25
35703	9d69c57e-94f8-4566-9a16-3a851de633f7	9d69c57e-96ec-42fb-9fc2-fd09b687cd8f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 22:08:25
35704	9d69c57e-95c6-41d1-929b-7c305dfb880b	9d69c57e-96ec-42fb-9fc2-fd09b687cd8f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":412,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:08:25
35705	9d69c57e-f5b1-4031-80ba-e5143001004e	9d69c57f-445a-4325-a1f9-dfa12cee535e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 22:08:25
35706	9d69c57f-3def-46ed-a02c-93eb33a51e00	9d69c57f-445a-4325-a1f9-dfa12cee535e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"156.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:08:25
35707	9d69c57f-3e56-4d59-8bdf-4120fb9b16c5	9d69c57f-445a-4325-a1f9-dfa12cee535e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:08:25
35708	9d69c57f-42ac-4831-ab25-e1a0560d01b5	9d69c57f-445a-4325-a1f9-dfa12cee535e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 22:08:25
35709	9d69c57f-4314-4f81-9fe1-734adbcfdeaa	9d69c57f-445a-4325-a1f9-dfa12cee535e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:08:25
35710	9d69c57f-945e-495d-ad03-154139a6e557	9d69c57f-b679-471b-9a9d-e58e8529adce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 22:08:25
35711	9d69c57f-af5f-457e-9c0c-e0b83ce1e0ec	9d69c57f-b679-471b-9a9d-e58e8529adce	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 22:08:26
35712	9d69c57f-afbe-43bb-9e76-10a69fd3c772	9d69c57f-b679-471b-9a9d-e58e8529adce	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 22:08:26
35713	9d69c57f-b4e4-4de4-8cb8-cc20dc74be73	9d69c57f-b679-471b-9a9d-e58e8529adce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 22:08:26
35714	9d69c57f-b54f-4a6a-8ae4-abb4b3cb1c8e	9d69c57f-b679-471b-9a9d-e58e8529adce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":269,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:08:26
35715	9d69c580-0609-403c-8553-1e6b84d9fd59	9d69c580-23ca-4c7d-a911-5c9d63d8c4bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 22:08:26
35716	9d69c580-1ea7-4304-957a-cbcdf4bae615	9d69c580-23ca-4c7d-a911-5c9d63d8c4bf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:08:26
35717	9d69c580-1ef8-489a-94ec-89a93cdee3c5	9d69c580-23ca-4c7d-a911-5c9d63d8c4bf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:08:26
35718	9d69c580-22ad-419d-9f37-0ba5320a5086	9d69c580-23ca-4c7d-a911-5c9d63d8c4bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-04 22:08:26
35719	9d69c580-22f0-4e0a-a697-2ec4e3c8af18	9d69c580-23ca-4c7d-a911-5c9d63d8c4bf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":255,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:08:26
29886	9d692c06-1485-44bc-910c-7f999dacb926	9d692c06-4b5f-4e4d-b5cb-8047f1894b05	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 14:59:17
29887	9d692c06-484f-46ea-928f-a6a303550aa3	9d692c06-4b5f-4e4d-b5cb-8047f1894b05	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 14:59:17
29888	9d692c06-49cd-441c-a1d7-a7c274091378	9d692c06-4b5f-4e4d-b5cb-8047f1894b05	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":442,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:59:17
29889	9d692c06-d839-4ef0-b779-42c21ae8ecc9	9d692c07-0915-4be8-a56e-9987d615e173	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 14:59:17
29890	9d692c06-ff3a-4c51-83eb-412d8fdeb428	9d692c07-0915-4be8-a56e-9987d615e173	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"60.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":56,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 14:59:17
29891	9d692c06-ffcc-4d9b-b566-0bcb5ada8e92	9d692c07-0915-4be8-a56e-9987d615e173	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 14:59:17
29892	9d692c07-0714-409d-9955-ec38aae49ca5	9d692c07-0915-4be8-a56e-9987d615e173	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 14:59:17
29893	9d692c07-07a1-49c2-956f-d2bedcecb89d	9d692c07-0915-4be8-a56e-9987d615e173	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":398,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:59:17
29894	9d692c07-d519-419c-bfc6-0405e742a00e	9d692c08-4404-4b1d-a14f-2deebd4ee4c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 14:59:18
29895	9d692c08-37b7-4cf6-a649-f6f9309d8d42	9d692c08-4404-4b1d-a14f-2deebd4ee4c4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"197.33","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:59:18
29896	9d692c08-386b-45b6-ba92-868e3d38146a	9d692c08-4404-4b1d-a14f-2deebd4ee4c4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:59:18
29897	9d692c08-411c-4273-98cc-d7810d703311	9d692c08-4404-4b1d-a14f-2deebd4ee4c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 14:59:18
29898	9d692c08-41d0-4dfd-bcf5-0ae3d7f78d64	9d692c08-4404-4b1d-a14f-2deebd4ee4c4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":775,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:59:18
29899	9d692c09-047f-4bdc-8f89-f5b0bf6cc88e	9d692c09-3e86-47a7-b02c-0e4f7e1a40c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 14:59:19
29900	9d692c09-345b-4594-8081-c1cc96a9b4b8	9d692c09-3e86-47a7-b02c-0e4f7e1a40c5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"72.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:59:19
29901	9d692c09-34fc-4e8b-ac11-14be3a22b304	9d692c09-3e86-47a7-b02c-0e4f7e1a40c5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:59:19
29902	9d692c09-3c44-421d-8b29-9c2d2b994fb1	9d692c09-3e86-47a7-b02c-0e4f7e1a40c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 14:59:19
29903	9d692c09-3cde-451e-b414-a809f8a2a2dc	9d692c09-3e86-47a7-b02c-0e4f7e1a40c5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":613,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:59:19
43535	9d6cea0d-7ace-44ea-9969-99bc3ccf6db9	9d6cea0d-7e3c-482e-9305-f9269ae07c43	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2041}	2024-11-06 11:38:07
31873	9d69572a-10cf-4927-93cf-3afe78fcb77e	9d69572a-395f-4ce4-9af2-6d72651d50bd	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 16:59:55
31874	9d69572a-36f9-4e1c-82d4-f9b3c393f5e0	9d69572a-395f-4ce4-9af2-6d72651d50bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:59:55
31875	9d69572a-3813-4de2-a46a-881b1d039a3c	9d69572a-395f-4ce4-9af2-6d72651d50bd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:59:55
31876	9d69572a-9d70-4d7a-aa29-72cc1c514819	9d69572a-a44d-4db4-afe7-bc4229e8b21b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 16:59:55
31877	9d69572a-a348-4af6-bfca-c43e043fd006	9d69572a-a44d-4db4-afe7-bc4229e8b21b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:59:55
31878	9d69572a-a395-4fa9-aa3c-06f4bdd87950	9d69572a-a44d-4db4-afe7-bc4229e8b21b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":"kasbjfdsajdkjbsajk"},"duration":214,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:59:55
31879	9d69572b-0a74-4709-a45f-1a3b1348b6d2	9d69572b-13d3-4d7d-afbb-8af4a38c1715	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:59:55
31880	9d69572b-1261-4b2d-bdf3-8274da0091d4	9d69572b-13d3-4d7d-afbb-8af4a38c1715	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:59:55
31881	9d69572b-12d2-4513-8a5d-46fbace7e61f	9d69572b-13d3-4d7d-afbb-8af4a38c1715	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":"kasbjfdsajdkjbsajk"},"duration":210,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:59:55
31882	9d69572b-9cf1-4fa7-972e-e450b2d7795e	9d69572b-be4d-4662-8b28-15ca7e78c045	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:59:56
31883	9d69572b-b896-4e60-957a-4cbd6f71c966	9d69572b-be4d-4662-8b28-15ca7e78c045	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:59:56
31884	9d69572b-b8e9-4ea3-9447-e2a5be3bfc4c	9d69572b-be4d-4662-8b28-15ca7e78c045	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 16:59:56
31885	9d69572b-bccb-4c44-9dce-9952835b1479	9d69572b-be4d-4662-8b28-15ca7e78c045	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:59:56
31886	9d69572b-bd15-4caf-91b6-9089a2cdbd20	9d69572b-be4d-4662-8b28-15ca7e78c045	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":271,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:59:56
43240	9d6ce5b0-ff92-4250-87c8-277aa3bdc2df	9d6ce5b1-024e-4b73-bfb9-073c9bf01dc6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2006}	2024-11-06 11:25:56
28097	9d68ebb6-8d0a-41ff-887d-2082183696c7	9d68ebb6-9483-4813-9528-eb574f90ffa2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1310}	2024-11-04 11:59:27
35952	9d69c88d-1437-4440-bc78-de1f9e5e7089	9d69c88d-5ea4-425a-aaa5-05153a183082	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 22:16:58
35953	9d69c88d-5d0f-49a8-90c4-2fa2ab67c439	9d69c88d-5ea4-425a-aaa5-05153a183082	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 22:16:58
35954	9d69c88d-5db4-4da9-ae2f-8c5b51d39179	9d69c88d-5ea4-425a-aaa5-05153a183082	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:16:58
35955	9d69c88d-b21b-4ef8-b926-d9038616c599	9d69c88d-f7d8-4114-8d42-fe4a64c4c0d4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 22:16:58
35956	9d69c88d-f2bf-444d-afdb-911ac250600f	9d69c88d-f7d8-4114-8d42-fe4a64c4c0d4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '22' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"144.23","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":74,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 22:16:58
35957	9d69c88d-f30d-4d86-9c29-f0acdd18362c	9d69c88d-f7d8-4114-8d42-fe4a64c4c0d4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 22:16:58
35958	9d69c88d-f6b1-43d8-9e48-9f7d02b99f70	9d69c88d-f7d8-4114-8d42-fe4a64c4c0d4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 22:16:58
35959	9d69c88d-f6f6-4ee7-aa1e-a2f925d884f8	9d69c88d-f7d8-4114-8d42-fe4a64c4c0d4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/22","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}},"duration":331,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:16:58
26871	9d68dd50-7989-43e4-ac0e-d94c91c0fd5c	9d68dd50-b20a-4421-b585-28c44e43dcda	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 11:19:11
26872	9d68dd50-af07-4357-a98f-8f737510b358	9d68dd50-b20a-4421-b585-28c44e43dcda	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 11:19:12
26873	9d68dd50-b093-41aa-a79c-6d9437759c28	9d68dd50-b20a-4421-b585-28c44e43dcda	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":590,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:19:12
26874	9d68dd51-8ce4-44f6-9b08-69ac9750203d	9d68dd51-ebba-40ec-a4ab-b48594ca8175	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 11:19:12
26875	9d68dd51-e254-4b95-88d3-7eae46507745	9d68dd51-ebba-40ec-a4ab-b48594ca8175	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"163.15","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:19:12
26876	9d68dd51-e2e2-4673-b918-e8dc2a742a1e	9d68dd51-ebba-40ec-a4ab-b48594ca8175	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:19:12
26877	9d68dd51-e96a-4283-b3e4-9becb3155aea	9d68dd51-ebba-40ec-a4ab-b48594ca8175	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 11:19:12
25853	9d68c9f9-7d43-40ec-8ac1-0d5523de519b	9d68c9f9-9b7b-46a8-a845-a7b4d391dcdb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 10:25:07
25854	9d68c9f9-9a00-41ad-aea7-0f73f5a46996	9d68c9f9-9b7b-46a8-a845-a7b4d391dcdb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 10:25:07
25855	9d68c9f9-9a93-4b8a-a32b-af7570af5811	9d68c9f9-9b7b-46a8-a845-a7b4d391dcdb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":393,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:25:07
26878	9d68dd51-ea09-4356-9277-759cd95c86a8	9d68dd51-ebba-40ec-a4ab-b48594ca8175	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":726,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:19:12
26879	9d68dd52-841a-4e44-85da-07bcc4d2fa57	9d68dd52-d77c-4e7b-b8db-8167d4e58a3e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 11:19:13
26880	9d68dd52-d038-4557-9fa9-021a6f45ff5f	9d68dd52-d77c-4e7b-b8db-8167d4e58a3e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"168.45","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 11:19:13
26881	9d68dd52-d52c-4eb0-adbe-e4995eb82e6d	9d68dd52-d77c-4e7b-b8db-8167d4e58a3e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 11:19:13
26882	9d68dd52-d5cc-4e54-924f-9023c7a5f860	9d68dd52-d77c-4e7b-b8db-8167d4e58a3e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":582,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:19:13
26883	9d68dd55-48e9-470f-8747-cdc66490b8d3	9d68dd55-7360-46e5-a046-96864c4d74fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 11:19:15
26884	9d68dd55-6b21-40b6-9d1b-fc1d9ce66456	9d68dd55-7360-46e5-a046-96864c4d74fb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"57.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:19:15
26885	9d68dd55-6b8e-4924-8f98-266ee6d61128	9d68dd55-7360-46e5-a046-96864c4d74fb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:19:15
26886	9d68dd55-7172-4abe-8859-a9f56cf268e6	9d68dd55-7360-46e5-a046-96864c4d74fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 11:19:15
26887	9d68dd55-71fd-4921-bb16-4de9a06605b4	9d68dd55-7360-46e5-a046-96864c4d74fb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":502,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:19:15
40435	9d6cc364-f7d6-4fbc-a0e4-e40072485616	9d6cc364-fa88-4737-8877-180cc9c937b6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1812}	2024-11-06 09:50:02
26888	9d68dd5e-2d05-49ef-a4bb-caa9ca305249	9d68dd5e-4861-445f-9aa9-04c24ebbd116	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 11:19:20
26889	9d68dd5e-4359-4abc-b785-a7053fe3245b	9d68dd5e-4861-445f-9aa9-04c24ebbd116	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"42.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 11:19:21
26890	9d68dd5e-4717-48c9-bb3d-5524ab3e39f3	9d68dd5e-4861-445f-9aa9-04c24ebbd116	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 11:19:21
26891	9d68dd5e-477c-4e5b-b89c-7cf4455bc8e4	9d68dd5e-4861-445f-9aa9-04c24ebbd116	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":370,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:19:21
26892	9d68dd64-b6d3-4749-b80c-3de440c451a3	9d68dd64-d5dd-484c-93a8-5acf447a7d29	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 11:19:25
26893	9d68dd64-d12c-4243-a0ca-c283b3537156	9d68dd64-d5dd-484c-93a8-5acf447a7d29	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND l.loans_estado = 'Pendiente' THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"49.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"f33971b410860b2e9f00dd075662b971","hostname":"EderCortes"}	2024-11-04 11:19:25
26894	9d68dd64-d462-4201-950b-55a1130752af	9d68dd64-d5dd-484c-93a8-5acf447a7d29	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 11:19:25
26895	9d68dd64-d4d8-4abd-a570-1001fcc29a1f	9d68dd64-d5dd-484c-93a8-5acf447a7d29	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":378,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:19:25
26896	9d68dd66-dd92-4daf-9823-a9b8b81b854a	9d68dd66-fc99-48f8-9bde-3c52fa101639	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 11:19:26
26897	9d68dd66-f6b8-4cf2-a743-d1c70f8516d6	9d68dd66-fc99-48f8-9bde-3c52fa101639	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"39.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 11:19:26
26898	9d68dd66-fae1-4810-9eb6-1e3264e045a1	9d68dd66-fc99-48f8-9bde-3c52fa101639	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 11:19:26
26899	9d68dd66-fb5f-4706-b3ad-2c6e11e02872	9d68dd66-fc99-48f8-9bde-3c52fa101639	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":379,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:19:26
42993	9d6ce35c-e6bb-4d2b-9b80-5db7a2b50792	9d6ce35c-ea22-4476-a45a-aa38f4cb2a85	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1975}	2024-11-06 11:19:25
36155	9d6b330d-8f8f-4d1a-96af-a61f6e4fa0fc	9d6b330d-e007-46cb-b8dc-6b30d29c297b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 15:10:35
36156	9d6b330d-dd9b-424f-9148-97f07e4382c8	9d6b330d-e007-46cb-b8dc-6b30d29c297b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:10:36
36157	9d6b330d-deb3-45a5-a5fe-0f4293522912	9d6b330d-e007-46cb-b8dc-6b30d29c297b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":392,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:10:36
36158	9d6b330e-56ac-4ffa-b350-5ec5fcf3ef2c	9d6b330e-7d53-4566-ab26-16cf01db5563	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:10:36
36159	9d6b330e-75c8-413f-8529-3d3e8b521b98	9d6b330e-7d53-4566-ab26-16cf01db5563	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"51.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:10:36
36160	9d6b330e-7b7f-4524-bac3-4111eb9efec5	9d6b330e-7d53-4566-ab26-16cf01db5563	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:10:36
36161	9d6b330e-7bfa-4b97-8850-1a0a39d5b4ab	9d6b330e-7d53-4566-ab26-16cf01db5563	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":322,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:10:36
36162	9d6b330e-e427-4578-b5fa-d3c4b0c39012	9d6b330f-051f-4300-afc2-f92d5c5e4e9b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:10:36
36163	9d6b330e-ff6e-433a-8990-f96ba8479c0c	9d6b330f-051f-4300-afc2-f92d5c5e4e9b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:10:36
36164	9d6b330e-ffb8-4275-8b58-1d892eb8090b	9d6b330f-051f-4300-afc2-f92d5c5e4e9b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:10:36
36165	9d6b330f-0393-433b-8b63-5f351f07209a	9d6b330f-051f-4300-afc2-f92d5c5e4e9b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:10:36
36166	9d6b330f-03f5-4776-84f3-23f51e0ff06b	9d6b330f-051f-4300-afc2-f92d5c5e4e9b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:10:36
36167	9d6b330f-5db9-4e73-af3a-984bbd7d0ca7	9d6b330f-8139-48cd-84ae-37d397413c01	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:10:37
36168	9d6b330f-7b20-4467-9741-bb03c2834005	9d6b330f-8139-48cd-84ae-37d397413c01	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"50.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:10:37
36169	9d6b330f-7b6f-44c6-af81-53d12a2da9d7	9d6b330f-8139-48cd-84ae-37d397413c01	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:10:37
36170	9d6b330f-7fa0-4a3c-99cd-78433fcb5c55	9d6b330f-8139-48cd-84ae-37d397413c01	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:10:37
36171	9d6b330f-800e-4aff-9e78-b2d35d7608a0	9d6b330f-8139-48cd-84ae-37d397413c01	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":297,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:10:37
36172	9d6b3310-c4f5-4403-8026-7782083bdfd5	9d6b3311-0b5f-4784-83ed-c3061f7b2fc6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:10:37
36173	9d6b3311-0629-43f7-8b36-2108cb513375	9d6b3311-0b5f-4784-83ed-c3061f7b2fc6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"145.81","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:10:38
36174	9d6b3311-0686-4f94-9a94-fa1108661cc1	9d6b3311-0b5f-4784-83ed-c3061f7b2fc6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:10:38
36175	9d6b3311-0a23-4c72-b437-2a204a048fc2	9d6b3311-0b5f-4784-83ed-c3061f7b2fc6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:10:38
36176	9d6b3311-0a6c-4c9a-bb48-c7f46eb49e92	9d6b3311-0b5f-4784-83ed-c3061f7b2fc6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:10:38
40071	9d6cc09c-766f-4284-85a1-e2bd3cf2d2b7	9d6cc09c-bdab-4cef-bb2d-df67f97551dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:42:15
40072	9d6cc09c-bc19-4a9b-be2a-0146ab659084	9d6cc09c-bdab-4cef-bb2d-df67f97551dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:42:15
40073	9d6cc09c-bcbd-44c4-9a19-37b4bbe7c3bd	9d6cc09c-bdab-4cef-bb2d-df67f97551dd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":418,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:42:15
40074	9d6cc09e-8d93-45dd-843d-4bb5c50e9686	9d6cc09e-d5de-4e5c-84b6-8714af2718a3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:42:16
40075	9d6cc09e-cffa-4fc3-bd0e-bd727a994e49	9d6cc09e-d5de-4e5c-84b6-8714af2718a3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"148.76","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:42:16
40076	9d6cc09e-d05c-4254-984f-b80c2e978120	9d6cc09e-d5de-4e5c-84b6-8714af2718a3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:42:16
40077	9d6cc09e-d483-42a0-b0d3-39e263e2cb90	9d6cc09e-d5de-4e5c-84b6-8714af2718a3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:42:16
40078	9d6cc09e-d4c9-4cf8-ba71-0a6e3c08060a	9d6cc09e-d5de-4e5c-84b6-8714af2718a3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":380,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:42:16
40079	9d6cc09f-1920-4557-937d-3d0316f67e5d	9d6cc09f-5a46-46fc-9bad-af811e7f73a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:42:16
40080	9d6cc09f-5537-447d-9437-953ac967f64d	9d6cc09f-5a46-46fc-9bad-af811e7f73a6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"141.15","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:42:16
40081	9d6cc09f-58cf-4aa7-b48c-928cabc8382f	9d6cc09f-5a46-46fc-9bad-af811e7f73a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:42:16
40082	9d6cc09f-5929-4f1e-a0ca-430c2cb6e259	9d6cc09f-5a46-46fc-9bad-af811e7f73a6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":319,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:42:16
41875	9d6cd08e-e9a9-4b34-8a13-1c6896e43f04	9d6cd08f-33d9-40a5-ad6e-2679ff519d8c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:26:50
41876	9d6cd08f-3281-4c8d-952a-9710c6347a7a	9d6cd08f-33d9-40a5-ad6e-2679ff519d8c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:26:50
41877	9d6cd08f-330b-4cd1-b651-123954858b36	9d6cd08f-33d9-40a5-ad6e-2679ff519d8c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":377,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:26:50
29576	9d69293f-f1dc-43a5-996a-59b435414a42	9d69293f-f85c-4240-b1c9-f34dbb20d0f8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1395}	2024-11-04 14:51:31
30656	9d69424f-3b5a-4aad-bb41-d64c4b64e746	9d69424f-3f00-46ba-bc21-67af21676362	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1463}	2024-11-04 16:01:36
40296	9d6cc275-98b3-412e-b1da-36c72473746c	9d6cc275-e4d7-432a-b824-46b674335fd1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 09:47:25
40297	9d6cc275-e1e2-49cc-8556-5fd4356b5293	9d6cc275-e4d7-432a-b824-46b674335fd1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 09:47:25
40298	9d6cc275-e31c-468f-839a-ef56fc9c999e	9d6cc275-e4d7-432a-b824-46b674335fd1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":418,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:47:25
17512	9d655c2b-bb81-4bb6-b445-b37b221af1b1	9d655c2b-bee3-44de-bd9a-9f9da4e7ee17	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":839}	2024-11-02 17:30:36
40299	9d6cc276-6369-4294-a4a1-d13ee7b0d24e	9d6cc276-7ff7-4125-818e-d8af41636290	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 09:47:25
40300	9d6cc276-7bc2-4dc5-8198-2463a5c0ae57	9d6cc276-7ff7-4125-818e-d8af41636290	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"44.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 09:47:25
40301	9d6cc276-7e99-42f8-866a-177c80d72ce9	9d6cc276-7ff7-4125-818e-d8af41636290	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 09:47:25
40302	9d6cc276-7f09-4297-98c4-a5068067b08d	9d6cc276-7ff7-4125-818e-d8af41636290	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":310,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:47:25
41524	9d6ccd3a-5022-4829-b03d-af07234f0f86	9d6ccd3a-a1a8-4f86-b571-c3489d686b91	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 10:17:31
41525	9d6ccd3a-9f81-4ec6-b209-f06f784ffd57	9d6ccd3a-a1a8-4f86-b571-c3489d686b91	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-06 10:17:32
41526	9d6ccd3a-a053-4937-b018-9fedcc6f6902	9d6ccd3a-a1a8-4f86-b571-c3489d686b91	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":461,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:17:32
40303	9d6cc276-f1fa-4446-b488-f12227e56951	9d6cc277-3f60-45e4-a454-98725f65b945	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 09:47:26
30120	9d693449-171e-4847-809f-55c5fa60310b	9d693449-4ee1-44a8-bb23-fcfb0598b731	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 15:22:23
30121	9d693449-4c4e-451d-bad7-6c2129da201c	9d693449-4ee1-44a8-bb23-fcfb0598b731	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 15:22:23
30122	9d693449-4d80-42b4-aff1-b31c16143ffe	9d693449-4ee1-44a8-bb23-fcfb0598b731	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":402,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:22:23
28539	9d6901f2-7b2f-4697-9050-1013f0cadd29	9d6901f2-990c-4926-9a32-595b7c912fac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-04 13:01:37
28540	9d6901f2-975f-4ab8-9e3f-21c47a956cea	9d6901f2-990c-4926-9a32-595b7c912fac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-11-04 13:01:38
28541	9d6901f2-981e-4aa7-9379-d5d7252dfab1	9d6901f2-990c-4926-9a32-595b7c912fac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":381,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:01:38
40304	9d6cc277-3a24-46d7-8ad8-5806deb41c87	9d6cc277-3f60-45e4-a454-98725f65b945	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"147.83","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 09:47:26
40305	9d6cc277-3a78-4eb9-94df-4726c2bf92e6	9d6cc277-3f60-45e4-a454-98725f65b945	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 09:47:26
40306	9d6cc277-3e3f-478c-9fee-6f16e7c3f423	9d6cc277-3f60-45e4-a454-98725f65b945	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 09:47:26
40307	9d6cc277-3e89-4129-8056-2c4ade45a9a6	9d6cc277-3f60-45e4-a454-98725f65b945	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":481,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:47:26
28542	9d6901f3-16d2-4ddf-90af-0a4c0241374d	9d6901f3-34a5-4541-b39d-cf0d63f8ed67	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-11-04 13:01:38
28543	9d6901f3-2f8e-465d-9e5a-5e6da008944c	9d6901f3-34a5-4541-b39d-cf0d63f8ed67	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:01:38
28544	9d6901f3-2fe0-42a0-a98e-53f7fa29f53f	9d6901f3-34a5-4541-b39d-cf0d63f8ed67	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 13:01:38
28545	9d6901f3-3387-4e70-b2fa-78bd1ed75b68	9d6901f3-34a5-4541-b39d-cf0d63f8ed67	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-11-04 13:01:38
28546	9d6901f3-33cd-443c-8eb1-ccdcda19755b	9d6901f3-34a5-4541-b39d-cf0d63f8ed67	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":343,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:01:38
30123	9d693449-f609-452b-a56e-85f5a15faf25	9d69344a-54d4-4843-a30f-2126a9d9a00a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 15:22:23
30124	9d69344a-48e7-4f4f-8df1-14a06fc2911a	9d69344a-54d4-4843-a30f-2126a9d9a00a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"168.80","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":56,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 15:22:24
30125	9d69344a-4977-4690-8ddb-b2640731164f	9d69344a-54d4-4843-a30f-2126a9d9a00a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 15:22:24
30126	9d69344a-51f0-4282-8d89-b0ca518b516f	9d69344a-54d4-4843-a30f-2126a9d9a00a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 15:22:24
30127	9d69344a-5272-45f8-a2f1-beba6fe045bd	9d69344a-54d4-4843-a30f-2126a9d9a00a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":572,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:22:24
28547	9d6901f3-a8b9-4713-a1fe-ecf289c2aebd	9d6901f3-ca6f-43bd-b4db-3d5b5fe29e22	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-11-04 13:01:38
28548	9d6901f3-c4b4-4694-9ea2-41dfa50dc5c5	9d6901f3-ca6f-43bd-b4db-3d5b5fe29e22	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:01:38
28549	9d6901f3-c510-42eb-8742-bad686447054	9d6901f3-ca6f-43bd-b4db-3d5b5fe29e22	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 13:01:38
28550	9d6901f3-c91d-4f36-8b90-581c3462df5e	9d6901f3-ca6f-43bd-b4db-3d5b5fe29e22	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-11-04 13:01:38
28551	9d6901f3-c973-469c-915a-a7ccacb36fb0	9d6901f3-ca6f-43bd-b4db-3d5b5fe29e22	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":371,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:01:38
30128	9d69344b-13f5-4d2a-86c4-5a3f437502f1	9d69344b-b7e1-4e3c-b31a-76d6e8f28d6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 15:22:24
30129	9d69344b-ac94-49d4-a3a0-8ffdedb1a1c1	9d69344b-b7e1-4e3c-b31a-76d6e8f28d6b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"325.10","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:22:25
30130	9d69344b-ad26-44bf-8bf4-38b0e062e7d3	9d69344b-b7e1-4e3c-b31a-76d6e8f28d6b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:22:25
30131	9d69344b-b571-4b7c-b508-6f324bb22e3a	9d69344b-b7e1-4e3c-b31a-76d6e8f28d6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 15:22:25
30132	9d69344b-b630-4694-ba84-7bd92aedbd03	9d69344b-b7e1-4e3c-b31a-76d6e8f28d6b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":882,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:22:25
32058	9d695881-fb68-4dcc-b13b-cc267fc33ba6	9d695882-2df8-4996-913b-5696a14513e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 17:03:40
32059	9d695882-2b50-4183-b6c9-5b7f1fca2010	9d695882-2df8-4996-913b-5696a14513e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 17:03:40
32060	9d695882-2c80-4688-971d-d8b29cd9c1d8	9d695882-2df8-4996-913b-5696a14513e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":481,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:03:40
40308	9d6cc277-9079-4924-8c12-8a54293924e4	9d6cc277-dae3-4ed8-a1f8-581ac4487fe6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 09:47:26
40309	9d6cc277-d4ab-4daf-89c4-4522a2d998f0	9d6cc277-dae3-4ed8-a1f8-581ac4487fe6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"148.82","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 09:47:26
40310	9d6cc277-d501-4f25-898b-4020058edcac	9d6cc277-dae3-4ed8-a1f8-581ac4487fe6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 09:47:26
40311	9d6cc277-d8df-4594-85ce-8f6d7a2a5f06	9d6cc277-dae3-4ed8-a1f8-581ac4487fe6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 09:47:26
40312	9d6cc277-d988-4037-a0aa-4fa613011ee2	9d6cc277-dae3-4ed8-a1f8-581ac4487fe6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":380,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:47:26
28552	9d6901f4-6f2a-4ea0-b780-4fe792cf1fae	9d6901f5-37cc-4ad9-ac32-b34513860afb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-11-04 13:01:39
28553	9d6901f5-2bbe-4675-9ce8-b420930630bb	9d6901f5-37cc-4ad9-ac32-b34513860afb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '81' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"120.42","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 13:01:39
28554	9d6901f5-2c4c-498f-bfc2-1671cdfc1005	9d6901f5-37cc-4ad9-ac32-b34513860afb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 13:01:39
28555	9d6901f5-2f08-4a39-ad62-955353c08dd2	9d6901f5-37cc-4ad9-ac32-b34513860afb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '81' order by \\"item_loans\\".\\"id\\" asc","time":"3.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:01:39
28556	9d6901f5-2f5c-49d7-9d8b-513a7b0042b8	9d6901f5-37cc-4ad9-ac32-b34513860afb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 13:01:39
28557	9d6901f5-3600-4895-ae21-9a4768efd4d1	9d6901f5-37cc-4ad9-ac32-b34513860afb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-11-04 13:01:39
28558	9d6901f5-3686-47c3-a31f-41eb747e126a	9d6901f5-37cc-4ad9-ac32-b34513860afb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/81","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":81,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"0","loans_pago_prestado":"0","loans_intereses_recaudar":"275000"},"items":[{"id":311,"loans_codigo":81,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":312,"loans_codigo":81,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":313,"loans_codigo":81,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":314,"loans_codigo":81,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":315,"loans_codigo":81,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:36.000000Z","updated_at":"2024-11-04T14:18:36.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":923,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:01:39
30133	9d69344c-8e77-4a9a-8b71-bc7622527eec	9d69344c-caa2-4449-8ff8-4f142fc22baf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 15:22:25
30134	9d69344c-c0da-44ec-8495-60cefe053c45	9d69344c-caa2-4449-8ff8-4f142fc22baf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"64.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:22:25
30135	9d69344c-c167-4d6d-9685-5a44d0e77fca	9d69344c-caa2-4449-8ff8-4f142fc22baf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:22:25
30136	9d69344c-c892-4272-8b1f-8382e6a50b8c	9d69344c-caa2-4449-8ff8-4f142fc22baf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 15:22:25
30137	9d69344c-c924-489a-8ac7-9b644410a2fa	9d69344c-caa2-4449-8ff8-4f142fc22baf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":583,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:22:25
32061	9d695882-c3af-4e80-8c7f-03286c40dedc	9d695883-2512-4169-8a6b-18d077ebabe6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 17:03:40
32062	9d695883-1c4b-4525-bc2e-c000dea3921f	9d695883-2512-4169-8a6b-18d077ebabe6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"168.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":227,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 17:03:41
32063	9d695883-1cd9-4ab8-85c4-b84dca5440fe	9d695883-2512-4169-8a6b-18d077ebabe6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 17:03:41
32064	9d695883-2336-41e4-96b7-1ccb1d941849	9d695883-2512-4169-8a6b-18d077ebabe6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 17:03:41
32065	9d695883-23ba-45ec-ba9b-00e5f3248ad3	9d695883-2512-4169-8a6b-18d077ebabe6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":544,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:03:41
40313	9d6cc279-088b-4312-9662-07228f929a37	9d6cc279-2700-457f-b6e0-3781abac8aad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 09:47:27
30138	9d693451-f3e3-4b9a-8917-af079d9b3cf1	9d693451-f8a4-43f9-ada2-6fec3928608a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"PUT","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":371,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:22:29
32066	9d695883-9d30-4c99-a650-dc7840acf75a	9d695883-f2d7-4636-884b-e26352ab8802	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 17:03:41
32067	9d695883-ea64-4f5e-b69c-0e9f0315aba4	9d695883-f2d7-4636-884b-e26352ab8802	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"162.30","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":216,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 17:03:41
32068	9d695883-eb0f-45e4-b0b0-c24230aece43	9d695883-f2d7-4636-884b-e26352ab8802	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":3,"hostname":"EderCortes"}	2024-11-04 17:03:41
28563	9d6901f7-bf2f-4eab-a5cf-f3ee5885b08c	9d6901f7-f349-44f3-a25f-e4491df620c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":29,"hostname":"EderCortes"}	2024-11-04 13:01:41
32069	9d695883-f0d0-4b16-a8ef-c96b60f57cce	9d695883-f2d7-4636-884b-e26352ab8802	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 17:03:41
32070	9d695883-f161-40c1-91ae-f5eece662611	9d695883-f2d7-4636-884b-e26352ab8802	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":503,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:03:41
40314	9d6cc279-21f5-49c3-ba7c-df35c39e1624	9d6cc279-2700-457f-b6e0-3781abac8aad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:47:27
40315	9d6cc279-2248-4e21-af49-d97b7e519cb4	9d6cc279-2700-457f-b6e0-3781abac8aad	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:47:27
40316	9d6cc279-25a4-4ac2-8c78-69a830385c67	9d6cc279-2700-457f-b6e0-3781abac8aad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 09:47:27
40317	9d6cc279-260b-45cd-9233-5f065377d0e7	9d6cc279-2700-457f-b6e0-3781abac8aad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":248,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:47:27
41641	9d6cce5b-66ff-4727-a6b2-9ee25b0366f5	9d6cce5b-8358-4642-b222-e65999b6af36	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:20:41
41642	9d6cce5b-8196-4238-b13f-431d04427592	9d6cce5b-8358-4642-b222-e65999b6af36	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:20:41
41643	9d6cce5b-825b-4239-823d-55e002ee4459	9d6cce5b-8358-4642-b222-e65999b6af36	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:20:41
41709	9d6ccef1-a018-4ed2-9821-1a7927aa1029	9d6ccef1-ebed-4183-b9ae-f5d1ab9e8474	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:22:19
41710	9d6ccef1-ea20-4007-b878-ec585a1ee82a	9d6ccef1-ebed-4183-b9ae-f5d1ab9e8474	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 10:22:19
41711	9d6ccef1-eaf7-4938-90b8-6bce7ec4b2fd	9d6ccef1-ebed-4183-b9ae-f5d1ab9e8474	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":388,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:22:19
30139	9d693452-8029-4ade-9267-efdcf7834060	9d693452-82d9-4e49-9bba-687d10002e27	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"PUT","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"547","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","profile_code":1,"user_age":"29","user_alias":"eder_cortes","email_verified_at":null,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null},"session":[],"response_status":404,"response":{"error":"El m\\u00e9todo especificado en la petici\\u00f3n no es val\\u00eddo","code":404},"duration":161,"memory":20,"hostname":"EderCortes"}	2024-11-04 15:22:29
32071	9d695884-5da6-48f8-9fa3-ba5c912d915e	9d695884-9a73-45bc-97e3-50ffd5bd79d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 17:03:41
32072	9d695884-8eb2-45e5-856e-ad30cee5b3ea	9d695884-9a73-45bc-97e3-50ffd5bd79d9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"70.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 17:03:42
32073	9d695884-8f67-427c-b678-0ca5619093a7	9d695884-9a73-45bc-97e3-50ffd5bd79d9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 17:03:42
28569	9d6901f9-259f-4e77-a76e-d957c6e14b67	9d6901f9-5dd4-4358-9302-50ebf5653dff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":30,"hostname":"EderCortes"}	2024-11-04 13:01:42
32074	9d695884-97ce-442d-b168-415346f7a42d	9d695884-9a73-45bc-97e3-50ffd5bd79d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 17:03:42
32075	9d695884-986c-424a-8d56-c282aaa08417	9d695884-9a73-45bc-97e3-50ffd5bd79d9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":401,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:03:42
40318	9d6cc279-6ed4-4a00-969d-7ebe5c241400	9d6cc279-8da8-4736-82e4-ec7a7c663590	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 09:47:27
40319	9d6cc279-8743-4a87-bede-44d6f991be15	9d6cc279-8da8-4736-82e4-ec7a7c663590	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"51.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:47:27
40320	9d6cc279-8be4-436c-a9e5-27517f1c7af5	9d6cc279-8da8-4736-82e4-ec7a7c663590	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-06 09:47:27
40321	9d6cc279-8c51-479d-8690-3a9f9cb4c9cf	9d6cc279-8da8-4736-82e4-ec7a7c663590	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:47:27
32076	9d695885-7e5e-471f-a4fa-c1bea2a3bc4b	9d695885-c828-4456-ad5a-88f044019b34	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 17:03:42
32077	9d695885-ba94-4433-bef5-fb72a7fbb63e	9d695885-c828-4456-ad5a-88f044019b34	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"87.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 17:03:42
32078	9d695885-bb28-42fd-b4f6-ce1eebe4a1b5	9d695885-c828-4456-ad5a-88f044019b34	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 17:03:42
32079	9d695885-c54d-4e97-8f39-7ec1a9aceb00	9d695885-c828-4456-ad5a-88f044019b34	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 17:03:42
32080	9d695885-c60c-4938-a418-2fd47f1a37b1	9d695885-c828-4456-ad5a-88f044019b34	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":735,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:03:42
40322	9d6cc279-c8b3-41f5-8b99-bdaa7ba1c47e	9d6cc279-cb57-4f03-b9f7-4360d0217ddf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":133,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:47:27
41819	9d6ccfcc-c5cd-4064-b669-b35357263878	9d6ccfcd-0adf-4483-9f22-9edb21a4781e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:24:43
41820	9d6ccfcd-094e-482c-bf7a-4f36ee8c2e7e	9d6ccfcd-0adf-4483-9f22-9edb21a4781e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:24:43
41821	9d6ccfcd-09ef-472e-8308-be5bbb02c298	9d6ccfcd-0adf-4483-9f22-9edb21a4781e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":339,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:24:43
32081	9d695886-9764-4a0b-aa26-db67ad33c72a	9d695886-f333-4192-8401-b067a2d0be74	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 17:03:43
32082	9d695886-ec39-4793-bbed-7acb5787673a	9d695886-f333-4192-8401-b067a2d0be74	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"151.58","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 17:03:43
32083	9d695886-eca2-4eb0-b4c9-26858c025702	9d695886-f333-4192-8401-b067a2d0be74	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 17:03:43
32084	9d695886-f14c-4147-b867-5e6dc01d1354	9d695886-f333-4192-8401-b067a2d0be74	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 17:03:43
32085	9d695886-f1c0-4654-8f7e-f78c1765cb75	9d695886-f333-4192-8401-b067a2d0be74	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":724,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:03:43
40323	9d6cc27a-35db-4896-9a1b-3db214c76901	9d6cc27a-56c0-422c-9f50-dd9add91e414	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-06 09:47:28
40324	9d6cc27a-50b9-450c-aa12-b6342529a0ff	9d6cc27a-56c0-422c-9f50-dd9add91e414	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"46.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 09:47:28
40325	9d6cc27a-5500-4a51-8044-4fec7036e972	9d6cc27a-56c0-422c-9f50-dd9add91e414	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-06 09:47:28
40326	9d6cc27a-5592-4756-929f-fd5afb168af8	9d6cc27a-56c0-422c-9f50-dd9add91e414	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":301,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:47:28
41968	9d6cd193-b377-4e22-85d2-93526d2c4ee1	9d6cd193-b65b-4dc9-a085-6b5be1df0023	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1948}	2024-11-06 10:29:41
36477	9d6b3b7c-67b8-4bd5-813e-9b1092680f6c	9d6b3b7c-91ed-4fcb-bab4-74e6bec92ad2	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 15:34:10
36478	9d6b3b7c-8fb4-40b5-b06f-fab188a305d4	9d6b3b7c-91ed-4fcb-bab4-74e6bec92ad2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:34:10
36479	9d6b3b7c-90a9-4268-9163-ae1cf01cfd23	9d6b3b7c-91ed-4fcb-bab4-74e6bec92ad2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:34:10
41768	9d6ccf5b-10e0-4926-8375-ebab5ac7be98	9d6ccf5b-3ba5-463f-8127-eba132ac37aa	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:23:28
41769	9d6ccf5b-39b1-4f40-908b-1d2f687a648e	9d6ccf5b-3ba5-463f-8127-eba132ac37aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:23:28
41770	9d6ccf5b-3a89-44b7-8316-3524a47fe5ad	9d6ccf5b-3ba5-463f-8127-eba132ac37aa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":339,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:23:28
36480	9d6b3b7d-18d3-49e0-b702-5c88339542dd	9d6b3b7d-3672-41e2-8add-896803b29905	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:34:11
36481	9d6b3b7d-318d-4d65-aa0b-2d6cb6b00838	9d6b3b7d-3672-41e2-8add-896803b29905	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"47.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:34:11
36482	9d6b3b7d-34f8-4fea-bc8e-1a2e2aca0286	9d6b3b7d-3672-41e2-8add-896803b29905	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:34:11
36483	9d6b3b7d-357c-40b1-8da2-e08348b886e8	9d6b3b7d-3672-41e2-8add-896803b29905	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":295,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:34:11
36484	9d6b3b7d-8e68-49a4-97ff-275c6d28c08d	9d6b3b7d-adaa-4b4d-9c1a-ca54c9441c89	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:34:11
36485	9d6b3b7d-a869-46da-90fe-eb750b4f4ec8	9d6b3b7d-adaa-4b4d-9c1a-ca54c9441c89	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:34:11
36486	9d6b3b7d-a8b8-4df9-bc5c-27ccab67ff14	9d6b3b7d-adaa-4b4d-9c1a-ca54c9441c89	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:34:11
36487	9d6b3b7d-ac7d-41ce-8fa3-6c477cbfe674	9d6b3b7d-adaa-4b4d-9c1a-ca54c9441c89	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:34:11
36488	9d6b3b7d-acbd-473f-880b-e9ef3b921097	9d6b3b7d-adaa-4b4d-9c1a-ca54c9441c89	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":291,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:34:11
40453	9d6cc3a9-ea69-483a-bd3b-521bbd9a4bc7	9d6cc3aa-05c3-4ce8-ab35-e5ed7d0ab25c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:50:47
40454	9d6cc3aa-042a-44fd-abac-f59d8c6b14e9	9d6cc3aa-05c3-4ce8-ab35-e5ed7d0ab25c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:50:47
40455	9d6cc3aa-04c4-4f33-babc-55901af762e7	9d6cc3aa-05c3-4ce8-ab35-e5ed7d0ab25c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:50:47
36489	9d6b3b7e-1408-4b66-aa67-7d77503e703c	9d6b3b7e-3613-4e38-bf88-61682995141b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:34:11
36490	9d6b3b7e-3006-49f5-829a-5cad5c3254c2	9d6b3b7e-3613-4e38-bf88-61682995141b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:34:11
36491	9d6b3b7e-3059-4d4e-9bb0-468dd91e051a	9d6b3b7e-3613-4e38-bf88-61682995141b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:34:11
36492	9d6b3b7e-345f-41cf-a943-a8dfc3805e66	9d6b3b7e-3613-4e38-bf88-61682995141b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:34:11
36493	9d6b3b7e-34d4-4082-985d-95c3d622b765	9d6b3b7e-3613-4e38-bf88-61682995141b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:34:11
40456	9d6cc3aa-aad8-4835-9e62-9ebfdbbe54ef	9d6cc3aa-f6a9-4b66-a0a5-98c556efa6fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:50:47
40457	9d6cc3aa-f0d3-4568-84f3-5801df3ca407	9d6cc3aa-f6a9-4b66-a0a5-98c556efa6fe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"159.54","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:50:47
40458	9d6cc3aa-f121-4037-9eaa-9b7c09414834	9d6cc3aa-f6a9-4b66-a0a5-98c556efa6fe	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:50:47
40459	9d6cc3aa-f573-454c-9e72-0d043f59abcd	9d6cc3aa-f6a9-4b66-a0a5-98c556efa6fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:50:47
40460	9d6cc3aa-f5bb-4038-b060-3688414676e6	9d6cc3aa-f6a9-4b66-a0a5-98c556efa6fe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":367,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:50:47
36316	9d6b3411-9dfa-440a-8b0c-ceea59620e51	9d6b3411-e62e-4345-b93f-a92f4bb8bd51	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 15:13:26
36317	9d6b3411-e418-4400-89c5-6aaf7a63fc82	9d6b3411-e62e-4345-b93f-a92f4bb8bd51	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 15:13:26
36318	9d6b3411-e4fc-4e56-b3f5-057e5c5eacf8	9d6b3411-e62e-4345-b93f-a92f4bb8bd51	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":366,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:13:26
36319	9d6b3412-3ef8-4f3f-bd47-24dd047ab50d	9d6b3412-827e-441a-9faf-b0cbf155b7b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 15:13:26
36320	9d6b3412-7da2-4f68-8315-c061a44697d6	9d6b3412-827e-441a-9faf-b0cbf155b7b1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"141.34","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:13:26
36321	9d6b3412-8114-468c-9c17-73aa3797931d	9d6b3412-827e-441a-9faf-b0cbf155b7b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 15:13:26
36322	9d6b3412-8189-4005-ae53-0ab208b9a97d	9d6b3412-827e-441a-9faf-b0cbf155b7b1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:13:26
36494	9d6b3b80-2bd7-4198-8a77-96b6d980942b	9d6b3b80-5c89-4618-9d4a-5387fa1ee55f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:34:13
36495	9d6b3b80-53c6-4b47-aedf-3a762da4498d	9d6b3b80-5c89-4618-9d4a-5387fa1ee55f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"72.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:34:13
36496	9d6b3b80-5454-4cca-a1e8-69d422f169e7	9d6b3b80-5c89-4618-9d4a-5387fa1ee55f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:34:13
36497	9d6b3b80-5ac0-43cd-9214-4442acb2d166	9d6b3b80-5c89-4618-9d4a-5387fa1ee55f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:34:13
36498	9d6b3b80-5b34-4d26-a505-666048c9dcef	9d6b3b80-5c89-4618-9d4a-5387fa1ee55f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":423,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:34:13
40461	9d6cc3ab-3b20-4013-8e1d-9cde05404a1d	9d6cc3ab-8056-4a10-87cf-1d380fad833f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:50:48
40462	9d6cc3ab-7c68-4ec8-85b0-43b6ca86ded6	9d6cc3ab-8056-4a10-87cf-1d380fad833f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"150.81","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:50:48
40463	9d6cc3ab-7f22-4fd0-81a4-f7af705193a3	9d6cc3ab-8056-4a10-87cf-1d380fad833f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:50:48
40464	9d6cc3ab-7f6f-468b-87a9-c1f2d5f3fc49	9d6cc3ab-8056-4a10-87cf-1d380fad833f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:50:48
36323	9d6b3412-dde3-4fe3-b1a9-46f9e79cc028	9d6b3413-136f-4cba-a267-93996702397e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 15:13:27
36324	9d6b3413-0c26-4840-bf53-802d945ffbf8	9d6b3413-136f-4cba-a267-93996702397e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"93.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:13:27
36325	9d6b3413-0c8a-4b82-bf69-f10adba6cbb5	9d6b3413-136f-4cba-a267-93996702397e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:13:27
36326	9d6b3413-116d-4d63-ade1-cce6f865387e	9d6b3413-136f-4cba-a267-93996702397e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 15:13:27
36327	9d6b3413-11f7-4d07-a215-c5300a834dca	9d6b3413-136f-4cba-a267-93996702397e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:13:27
42007	9d6cd38e-05c6-40c5-80a5-055dcfcd62de	9d6cd38e-5409-466d-adef-18c4d2b812e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:35:13
42008	9d6cd38e-523c-41a3-8e56-3132a5333629	9d6cd38e-5409-466d-adef-18c4d2b812e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:35:13
42009	9d6cd38e-52f4-457f-a7ab-ab85e9d4690d	9d6cd38e-5409-466d-adef-18c4d2b812e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":515,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:35:13
36328	9d6b3413-5dff-42f5-8197-2cec83141a1c	9d6b3413-7cd9-4130-a52b-0b50dfac45b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 15:13:27
36329	9d6b3413-7798-4f6a-b363-bc638fe550d2	9d6b3413-7cd9-4130-a52b-0b50dfac45b1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:13:27
36330	9d6b3413-77f8-4a98-afce-a9589494e8ac	9d6b3413-7cd9-4130-a52b-0b50dfac45b1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:13:27
36331	9d6b3413-7b80-428d-9c26-b419eab313c7	9d6b3413-7cd9-4130-a52b-0b50dfac45b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 15:13:27
36332	9d6b3413-7bc5-42d4-91e5-6fa87ce8b8d9	9d6b3413-7cd9-4130-a52b-0b50dfac45b1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:13:27
36333	9d6b3414-4e8f-4599-8667-3918a0372e48	9d6b3414-9573-45c1-832e-c29c781a335e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 15:13:28
36334	9d6b3414-9026-4997-806e-df356e85cd8a	9d6b3414-9573-45c1-832e-c29c781a335e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"146.71","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:13:28
36335	9d6b3414-908a-44a7-b279-528e2151a709	9d6b3414-9573-45c1-832e-c29c781a335e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:13:28
36336	9d6b3414-942b-4861-abbf-c9ab5297a6a2	9d6b3414-9573-45c1-832e-c29c781a335e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-05 15:13:28
36337	9d6b3414-9474-42d8-a180-3f1c1c8275f4	9d6b3414-9573-45c1-832e-c29c781a335e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":404,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:13:28
42367	9d6cdd9e-79c7-4b49-abef-7b817c6a79d5	9d6cdd9e-7d12-4269-bc64-cd4c0badf9af	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1956}	2024-11-06 11:03:21
40385	9d6cc2fa-f317-4f2a-bc3a-bc80e11419ca	9d6cc2fb-3a4b-4ba7-9052-86e88a6f6854	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:48:52
40386	9d6cc2fb-3895-457f-bd55-27e3e43bcab1	9d6cc2fb-3a4b-4ba7-9052-86e88a6f6854	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 09:48:52
40387	9d6cc2fb-394a-4055-8f20-ac7356fde221	9d6cc2fb-3a4b-4ba7-9052-86e88a6f6854	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:48:52
40538	9d6cc4d0-adf2-4403-9e02-7a19f31f573c	9d6cc4d0-cc15-4f6f-991b-0a756a50e393	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:54:00
40539	9d6cc4d0-c9f2-46be-a205-a2ea7e3f0f73	9d6cc4d0-cc15-4f6f-991b-0a756a50e393	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:54:00
40388	9d6cc2fb-d9bb-4f8d-8a4c-4e89c3ae154a	9d6cc2fb-f7d3-4832-ba3f-15ddd62046e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 09:48:53
40389	9d6cc2fb-f2a1-4e86-a34b-50e62e17d964	9d6cc2fb-f7d3-4832-ba3f-15ddd62046e5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:48:53
40390	9d6cc2fb-f2fd-4adc-a2c5-97606ff2f4e5	9d6cc2fb-f7d3-4832-ba3f-15ddd62046e5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:48:53
40391	9d6cc2fb-f69a-4ac6-a538-e8e30813219c	9d6cc2fb-f7d3-4832-ba3f-15ddd62046e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 09:48:53
40392	9d6cc2fb-f6e5-4850-aacb-b35004414c7f	9d6cc2fb-f7d3-4832-ba3f-15ddd62046e5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:48:53
40540	9d6cc4d0-cafb-4f98-9ada-66eb7388041b	9d6cc4d0-cc15-4f6f-991b-0a756a50e393	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:54:00
40393	9d6cc2fc-503c-4ac5-879a-6f0a2d062f8b	9d6cc2fc-68f5-4f6f-a833-7ebb3829bad4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 09:48:53
40394	9d6cc2fc-64fc-4030-9391-6e8aa061f259	9d6cc2fc-68f5-4f6f-a833-7ebb3829bad4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"40.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:48:53
40395	9d6cc2fc-67b2-45d9-b981-ef70da82f194	9d6cc2fc-68f5-4f6f-a833-7ebb3829bad4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 09:48:53
40396	9d6cc2fc-67f8-40bd-a929-9ed1294fcb3e	9d6cc2fc-68f5-4f6f-a833-7ebb3829bad4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":219,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:48:53
40541	9d6cc4d2-9574-417e-9691-47cca307ac12	9d6cc4d2-b94f-4c52-8a89-9edd4ab13dae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:54:01
40542	9d6cc4d2-b274-4a48-bd92-e8910e24fec0	9d6cc4d2-b94f-4c52-8a89-9edd4ab13dae	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:54:01
40543	9d6cc4d2-b2e5-4ea8-bd69-7be8761bd643	9d6cc4d2-b94f-4c52-8a89-9edd4ab13dae	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:54:01
40544	9d6cc4d2-b7e2-4b93-9ab1-62923bed3be5	9d6cc4d2-b94f-4c52-8a89-9edd4ab13dae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:54:01
40545	9d6cc4d2-b834-4ef0-a473-454f0f9af2af	9d6cc4d2-b94f-4c52-8a89-9edd4ab13dae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":351,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:54:01
40546	9d6cc4d3-1f53-4993-a48e-05ffbad74641	9d6cc4d3-4c21-495a-bedc-dae8ccde0069	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:54:02
40547	9d6cc4d3-4311-40dd-a474-eb17b48fb23b	9d6cc4d3-4c21-495a-bedc-dae8ccde0069	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"68.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:54:02
40548	9d6cc4d3-49e3-4bfc-a561-3b35005ff206	9d6cc4d3-4c21-495a-bedc-dae8ccde0069	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:54:02
40549	9d6cc4d3-4a6a-4357-92e0-d58c9bc3d083	9d6cc4d3-4c21-495a-bedc-dae8ccde0069	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":353,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:54:02
40657	9d6cc64b-22ce-4a5f-b1c0-1eb0aedc102b	9d6cc64b-3c5c-4c58-a725-988a1ffa945d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:58:08
40658	9d6cc64b-3adc-4e14-bdac-87e74df4bd03	9d6cc64b-3c5c-4c58-a725-988a1ffa945d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 09:58:08
40659	9d6cc64b-3b70-489b-8006-85821120f70b	9d6cc64b-3c5c-4c58-a725-988a1ffa945d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":214,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:58:08
36794	9d6b40c5-6754-48ec-a3e9-77be0ed6b961	9d6b40c5-8d3d-40de-a02f-a1561090d7f0	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 15:48:57
36795	9d6b40c5-8aaa-4008-b594-5889e40e122f	9d6b40c5-8d3d-40de-a02f-a1561090d7f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:48:57
36796	9d6b40c5-8be9-4f14-a293-d9432fc8a7f5	9d6b40c5-8d3d-40de-a02f-a1561090d7f0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":310,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:48:57
36797	9d6b40c5-fe96-4491-8ed5-60621fbe44ca	9d6b40c6-1e10-4ba6-993e-9a6c152840ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:48:57
36798	9d6b40c6-180d-4083-bae3-f35a3e4ce1fa	9d6b40c6-1e10-4ba6-993e-9a6c152840ef	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"45.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:48:57
36799	9d6b40c6-1c7f-45e8-9f2b-88b4a574befd	9d6b40c6-1e10-4ba6-993e-9a6c152840ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:48:57
36800	9d6b40c6-1d04-4bb4-b661-e91ae470a37a	9d6b40c6-1e10-4ba6-993e-9a6c152840ef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":303,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:48:57
40660	9d6cc64c-ae66-44c2-8fa8-07eced1de0e5	9d6cc64c-d139-452b-989d-adbecaa6dad0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 09:58:09
40661	9d6cc64c-ca97-4782-9f88-186fca448f65	9d6cc64c-d139-452b-989d-adbecaa6dad0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"48.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:58:09
40662	9d6cc64c-caf5-4eeb-986d-770d7790dafb	9d6cc64c-d139-452b-989d-adbecaa6dad0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:58:09
40663	9d6cc64c-cfa9-4c0e-99f7-a1ff817105ea	9d6cc64c-d139-452b-989d-adbecaa6dad0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 09:58:09
40664	9d6cc64c-d00d-4881-bd05-8878d9307a1f	9d6cc64c-d139-452b-989d-adbecaa6dad0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":309,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:58:09
36801	9d6b40c6-775d-42b7-b6a8-0d9df4b64cc7	9d6b40c6-9f8d-4d38-9315-14a27f8bfde3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:48:58
36802	9d6b40c6-9817-4431-9695-c9526fa0e1de	9d6b40c6-9f8d-4d38-9315-14a27f8bfde3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:48:58
36803	9d6b40c6-9882-474e-b3dd-29debe7e145c	9d6b40c6-9f8d-4d38-9315-14a27f8bfde3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:48:58
36804	9d6b40c6-9dba-4ed8-ab40-0424642daf87	9d6b40c6-9f8d-4d38-9315-14a27f8bfde3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:48:58
36805	9d6b40c6-9e2b-48e4-b06e-7ac46e37731a	9d6b40c6-9f8d-4d38-9315-14a27f8bfde3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":316,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:48:58
40665	9d6cc64d-2b19-451f-aa3e-a9701019faa7	9d6cc64d-4be7-4df9-aeda-f36aec3b3ece	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 09:58:09
40666	9d6cc64d-465b-4d51-9d5f-9eabb2c15aa9	9d6cc64d-4be7-4df9-aeda-f36aec3b3ece	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"55.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:58:09
40667	9d6cc64d-4a25-4ce6-ad75-5c65f8aa7451	9d6cc64d-4be7-4df9-aeda-f36aec3b3ece	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 09:58:09
40668	9d6cc64d-4a97-46c0-8108-c2249d47854a	9d6cc64d-4be7-4df9-aeda-f36aec3b3ece	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":297,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:58:09
36633	9d6b3dcf-abe2-4f59-a827-fd3cc32a0db7	9d6b3dcf-ccc3-4065-8f2f-612d53726150	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:40:40
36634	9d6b3dcf-caf6-45ab-83b3-38541b3d3783	9d6b3dcf-ccc3-4065-8f2f-612d53726150	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 15:40:40
36635	9d6b3dcf-cb9e-4159-9239-c5e6682f5d11	9d6b3dcf-ccc3-4065-8f2f-612d53726150	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:40:40
36806	9d6b40c6-ed76-4955-bb8a-2989606b1541	9d6b40c7-0d2f-4d0f-8649-cb525861b5b8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:48:58
36807	9d6b40c7-07f3-465e-a8c9-367aba08a416	9d6b40c7-0d2f-4d0f-8649-cb525861b5b8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:48:58
36808	9d6b40c7-0846-41a4-a42a-dfdddc876440	9d6b40c7-0d2f-4d0f-8649-cb525861b5b8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:48:58
36809	9d6b40c7-0bdf-4dac-8a05-02b8314dde53	9d6b40c7-0d2f-4d0f-8649-cb525861b5b8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:48:58
36636	9d6b3dd0-32b2-432e-9e1f-f81e20f0a167	9d6b3dd0-4f95-476d-bb30-f90143955e40	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 15:40:41
36637	9d6b3dd0-4b20-4408-a53c-845a87a943ed	9d6b3dd0-4f95-476d-bb30-f90143955e40	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"44.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:40:41
36638	9d6b3dd0-4e34-4461-a6d7-4296c1d670aa	9d6b3dd0-4f95-476d-bb30-f90143955e40	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 15:40:41
36639	9d6b3dd0-4ea3-48e0-8049-8f10446a3077	9d6b3dd0-4f95-476d-bb30-f90143955e40	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":264,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:40:41
36810	9d6b40c7-0c2b-42ed-b980-552116c37050	9d6b40c7-0d2f-4d0f-8649-cb525861b5b8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":262,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:48:58
15652	9d648fd0-15b6-4916-baff-1d864e94b6a6	9d648fd0-1992-43ed-b973-7ade20a5d5ab	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":714}	2024-11-02 07:59:10
36640	9d6b3dd0-a2cc-4aa3-8b3b-31f1242c7536	9d6b3dd0-ee8d-406a-a9a6-38be9601af88	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 15:40:41
36641	9d6b3dd0-e8b0-4235-b2a7-4d65991cce95	9d6b3dd0-ee8d-406a-a9a6-38be9601af88	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"142.86","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:40:41
36642	9d6b3dd0-e922-4953-ac9e-18234612bf9f	9d6b3dd0-ee8d-406a-a9a6-38be9601af88	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:40:41
36643	9d6b3dd0-ed24-436f-bf42-475b04def1fc	9d6b3dd0-ee8d-406a-a9a6-38be9601af88	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 15:40:41
36644	9d6b3dd0-ed7b-4379-aba5-05b4df49cad0	9d6b3dd0-ee8d-406a-a9a6-38be9601af88	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":397,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:40:41
36811	9d6b40c8-d942-4a65-b453-339611f6754b	9d6b40c8-f9d0-41e6-a8f0-0ce1af18fb57	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:48:59
36812	9d6b40c8-f4b0-460a-b3b7-18c4a49152df	9d6b40c8-f9d0-41e6-a8f0-0ce1af18fb57	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"47.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:48:59
36813	9d6b40c8-f4ff-433f-b403-fc53039dfab0	9d6b40c8-f9d0-41e6-a8f0-0ce1af18fb57	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:48:59
36814	9d6b40c8-f87a-4ec0-8ed1-c298662367be	9d6b40c8-f9d0-41e6-a8f0-0ce1af18fb57	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:48:59
36815	9d6b40c8-f8c4-447b-9c61-443a08e53949	9d6b40c8-f9d0-41e6-a8f0-0ce1af18fb57	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":309,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:48:59
36645	9d6b3dd1-35f7-42e7-bbe3-bdd6bfce6aff	9d6b3dd1-54c0-4410-aaa9-c15a09738c33	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 15:40:41
36646	9d6b3dd1-4f58-4d1a-9106-a80cbef87659	9d6b3dd1-54c0-4410-aaa9-c15a09738c33	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:40:41
36647	9d6b3dd1-4fa0-4396-8bd1-61fed544be7f	9d6b3dd1-54c0-4410-aaa9-c15a09738c33	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:40:41
36648	9d6b3dd1-536d-41e8-9715-f034dc761e0f	9d6b3dd1-54c0-4410-aaa9-c15a09738c33	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 15:40:41
36649	9d6b3dd1-53b0-49ec-bcf2-bb59850f8f83	9d6b3dd1-54c0-4410-aaa9-c15a09738c33	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:40:41
36650	9d6b3dd2-b3f9-4a94-809f-0711dc066be9	9d6b3dd3-1576-4666-9d2c-9d800fa7616e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 15:40:42
36651	9d6b3dd3-0bf1-4d86-9eb4-e51640b1cad5	9d6b3dd3-1576-4666-9d2c-9d800fa7616e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"176.14","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:40:43
36652	9d6b3dd3-0c74-4737-9d76-1303a40cc7ea	9d6b3dd3-1576-4666-9d2c-9d800fa7616e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:40:43
36653	9d6b3dd3-13bb-4860-bb90-dc4561beee2f	9d6b3dd3-1576-4666-9d2c-9d800fa7616e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 15:40:43
36654	9d6b3dd3-142c-45a2-a61f-17447edd0a3d	9d6b3dd3-1576-4666-9d2c-9d800fa7616e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":568,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:40:43
40606	9d6cc5dc-dfc2-46b4-bf33-94648a2647a2	9d6cc5dc-fca1-4484-9b85-e6ae99501720	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:56:56
40607	9d6cc5dc-fb3e-4289-8570-100cfa49c673	9d6cc5dc-fca1-4484-9b85-e6ae99501720	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 09:56:56
40608	9d6cc5dc-fbcf-4446-a770-129ab583ab74	9d6cc5dc-fca1-4484-9b85-e6ae99501720	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:56:56
40609	9d6cc5de-208c-4f42-a938-117e4c3b6d1e	9d6cc5de-7124-4438-9d66-9d9c2a8ab186	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 09:56:56
40610	9d6cc5de-6a1f-43b8-b122-bf5348d24ad1	9d6cc5de-7124-4438-9d66-9d9c2a8ab186	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"162.87","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:56:57
40611	9d6cc5de-6a8f-417e-85ce-65368d6c62c9	9d6cc5de-7124-4438-9d66-9d9c2a8ab186	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:56:57
40612	9d6cc5de-6f61-4b26-9b09-d4c8693036ae	9d6cc5de-7124-4438-9d66-9d9c2a8ab186	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 09:56:57
40613	9d6cc5de-6fdf-47c9-b749-97bbc34c70e6	9d6cc5de-7124-4438-9d66-9d9c2a8ab186	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":535,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:56:57
40614	9d6cc5de-cce4-4912-9bb1-9798e25c8c26	9d6cc5de-f1ff-4a18-b50c-863da03bb7b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 09:56:57
40615	9d6cc5de-eb3d-4f7d-801e-9555f850f047	9d6cc5de-f1ff-4a18-b50c-863da03bb7b1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"55.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:56:57
40616	9d6cc5de-f049-4e28-9cc1-eea9d69cea7f	9d6cc5de-f1ff-4a18-b50c-863da03bb7b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 09:56:57
40617	9d6cc5de-f0c9-431b-9654-846d48d8cae0	9d6cc5de-f1ff-4a18-b50c-863da03bb7b1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":312,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:56:57
40759	9d6cc705-cab4-49d1-b8ab-e1c42eda191d	9d6cc705-e792-495d-9069-cac0680e46b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:00:10
40760	9d6cc705-e5db-471c-880c-8b0e3d0c182f	9d6cc705-e792-495d-9069-cac0680e46b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:00:10
40761	9d6cc705-e694-4564-be07-288ac721d78a	9d6cc705-e792-495d-9069-cac0680e46b0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:00:10
40762	9d6cc707-6596-4fc6-83e3-4343aa98456b	9d6cc707-8cf2-4927-b48f-701a3f4596be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:00:11
40763	9d6cc707-83c6-41aa-9995-2d9a9f51b3a0	9d6cc707-8cf2-4927-b48f-701a3f4596be	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:00:11
40764	9d6cc707-843c-4730-92fc-5190f35507b8	9d6cc707-8cf2-4927-b48f-701a3f4596be	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:00:11
40765	9d6cc707-8b1d-4e8f-9894-f61f96ad160f	9d6cc707-8cf2-4927-b48f-701a3f4596be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:00:11
40766	9d6cc707-8b90-40ac-90a7-493cc5a2bb2f	9d6cc707-8cf2-4927-b48f-701a3f4596be	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":316,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:00:11
40767	9d6cc707-f445-4d83-876c-47a36f66a9c8	9d6cc708-142a-45c3-9cfc-624ee4e34da2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:00:12
40768	9d6cc708-0ea1-4889-ae3b-36dbf64e0919	9d6cc708-142a-45c3-9cfc-624ee4e34da2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"48.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:00:12
40769	9d6cc708-124a-467e-86c3-33fb2b426b58	9d6cc708-142a-45c3-9cfc-624ee4e34da2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:00:12
40770	9d6cc708-12dd-4665-8a8c-578f3b318568	9d6cc708-142a-45c3-9cfc-624ee4e34da2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":323,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:00:12
27324	9d68e41b-e475-4903-8d84-3205ecdddbbb	9d68e41c-27d3-4a42-afe2-e9ffd40ff989	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 11:38:11
27325	9d68e41c-2455-40de-a2cc-88449d80e330	9d68e41c-27d3-4a42-afe2-e9ffd40ff989	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 11:38:12
27326	9d68e41c-25ce-496a-bef4-1b0aa3465fb5	9d68e41c-27d3-4a42-afe2-e9ffd40ff989	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":605,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:38:12
27327	9d68e41c-efcb-461f-a5e5-dbfe35c5e1ce	9d68e41d-4f54-47c1-822d-f5bfaf9f8767	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 11:38:12
27328	9d68e41d-4374-4481-a23c-13c2492a4b1e	9d68e41d-4f54-47c1-822d-f5bfaf9f8767	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"171.12","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:38:12
27329	9d68e41d-4410-4522-9439-12177b64309a	9d68e41d-4f54-47c1-822d-f5bfaf9f8767	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:38:12
27330	9d68e41d-4d3a-4bdc-9ff1-7edc8a900211	9d68e41d-4f54-47c1-822d-f5bfaf9f8767	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 11:38:12
27331	9d68e41d-4dcd-42ed-a916-ffa6c43f1130	9d68e41d-4f54-47c1-822d-f5bfaf9f8767	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":664,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:38:12
27332	9d68e41d-eec0-4b8c-8ccc-146f60c75a44	9d68e41e-1b06-4191-8328-e2fc086c50bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 11:38:13
27333	9d68e41e-12f8-4f14-bfdb-6be7f831034b	9d68e41e-1b06-4191-8328-e2fc086c50bb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"57.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:38:13
27334	9d68e41e-137b-48ca-89fc-591733f2dc12	9d68e41e-1b06-4191-8328-e2fc086c50bb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 11:38:13
27335	9d68e41e-1958-490d-a189-d99bfbc5a30b	9d68e41e-1b06-4191-8328-e2fc086c50bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 11:38:13
27336	9d68e41e-19bf-4f1b-9d82-a743558feed0	9d68e41e-1b06-4191-8328-e2fc086c50bb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":489,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:38:13
28570	9d6901f9-52e0-4340-9b4c-92f36579889d	9d6901f9-5dd4-4358-9302-50ebf5653dff	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"73.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:01:42
28571	9d6901f9-5378-49ed-a69e-4016aa1df4a7	9d6901f9-5dd4-4358-9302-50ebf5653dff	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:01:42
28572	9d6901f9-5ba9-44a7-9d51-b85adc12f48c	9d6901f9-5dd4-4358-9302-50ebf5653dff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":31,"hostname":"EderCortes"}	2024-11-04 13:01:42
27337	9d68e41f-08f9-4e15-a9dd-1a289347bc5b	9d68e41f-5bac-4369-a4c9-5ccacc7542fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 11:38:13
27338	9d68e41f-50e9-45d8-80cc-aad4d9a41929	9d68e41f-5bac-4369-a4c9-5ccacc7542fe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"133.13","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:38:14
27339	9d68e41f-5193-4de0-bd43-744e6d927622	9d68e41f-5bac-4369-a4c9-5ccacc7542fe	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:38:14
27340	9d68e41f-5942-424b-bc0d-a2d9334bc3fc	9d68e41f-5bac-4369-a4c9-5ccacc7542fe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 11:38:14
27341	9d68e41f-59ed-4048-b67b-9e5ad8345b18	9d68e41f-5bac-4369-a4c9-5ccacc7542fe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":793,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:38:14
28573	9d6901f9-5c4c-4ab6-99cb-f9aeef57c9bf	9d6901f9-5dd4-4358-9302-50ebf5653dff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":902,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:01:42
27342	9d68e420-3ee6-4687-afcd-3fe9ddedee8f	9d68e420-6b2f-4a88-a540-bac509ea3d54	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 11:38:14
27343	9d68e420-623e-44d7-ae6e-3285d530cfa7	9d68e420-6b2f-4a88-a540-bac509ea3d54	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"57.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:38:14
27344	9d68e420-62d3-467f-83cd-78aacdc71753	9d68e420-6b2f-4a88-a540-bac509ea3d54	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:38:14
27345	9d68e420-690a-41e7-9b98-1d6bca633d6c	9d68e420-6b2f-4a88-a540-bac509ea3d54	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 11:38:14
27346	9d68e420-6978-4309-97de-7c45870a2405	9d68e420-6b2f-4a88-a540-bac509ea3d54	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":669,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:38:14
28574	9d6901fa-376f-4452-b916-2ba1c7e61a57	9d6901fa-6d31-4a3c-af95-80aeb37c500f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":31,"hostname":"EderCortes"}	2024-11-04 13:01:43
28575	9d6901fa-611b-4b03-9ac4-0218d7c9892c	9d6901fa-6d31-4a3c-af95-80aeb37c500f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"68.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:01:43
28576	9d6901fa-61b7-402d-b0ee-5682f18a0157	9d6901fa-6d31-4a3c-af95-80aeb37c500f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:01:43
28577	9d6901fa-6b03-4597-a6fd-530ec31d4b88	9d6901fa-6d31-4a3c-af95-80aeb37c500f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":32,"hostname":"EderCortes"}	2024-11-04 13:01:43
40895	9d6cc872-6372-4f1f-ba70-3cf368e416c4	9d6cc872-7cdf-4b07-ad11-d5458d7a798a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:04:09
40896	9d6cc872-7b63-4fdf-98ff-03e6604b4b3c	9d6cc872-7cdf-4b07-ad11-d5458d7a798a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:04:09
40897	9d6cc872-7bf7-4175-87da-16d7c8e497b5	9d6cc872-7cdf-4b07-ad11-d5458d7a798a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":217,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:04:09
43383	9d6ce724-741b-4dcf-95ba-f75b6effea52	9d6ce724-7878-4576-a931-deb0d79524ec	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2019}	2024-11-06 11:29:59
40898	9d6cc873-acf4-49b1-adf2-5732efae1d0d	9d6cc873-d5e0-45fe-a010-f90e34aee332	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:04:10
40899	9d6cc873-cdf0-4fa7-8bd4-242347832580	9d6cc873-d5e0-45fe-a010-f90e34aee332	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:04:10
40900	9d6cc873-ce5c-43c3-8e19-106ef1d8ed7d	9d6cc873-d5e0-45fe-a010-f90e34aee332	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:04:10
40901	9d6cc873-d3c7-4cf9-a89d-cfa7937dccc1	9d6cc873-d5e0-45fe-a010-f90e34aee332	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:04:10
40902	9d6cc873-d43a-4962-921d-92c238279570	9d6cc873-d5e0-45fe-a010-f90e34aee332	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":408,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:04:10
43057	9d6ce3c3-7890-4e1a-a46f-b1dd6f9dd9b4	9d6ce3c3-7bd4-4afc-9d87-4d4a54e4c3f7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1982}	2024-11-06 11:20:32
40903	9d6cc874-37bc-45c5-a355-abc76b87d366	9d6cc874-58e5-4fe3-bbd4-eabc5c7ee09b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:04:10
40904	9d6cc874-5255-4113-871c-80b7a955ffde	9d6cc874-58e5-4fe3-bbd4-eabc5c7ee09b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"51.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:04:10
40905	9d6cc874-56ff-423b-a326-788862731aa4	9d6cc874-58e5-4fe3-bbd4-eabc5c7ee09b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:04:10
40906	9d6cc874-577a-4424-8b57-a1cac148ab7f	9d6cc874-58e5-4fe3-bbd4-eabc5c7ee09b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":312,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:04:10
36978	9d6b43dc-e609-41e9-9581-c337147b0de5	9d6b43dd-0ecf-463f-b9eb-bd078e9786db	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 15:57:36
36979	9d6b43dd-0ca9-413d-847d-3f7f82ceaf46	9d6b43dd-0ecf-463f-b9eb-bd078e9786db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:57:36
36980	9d6b43dd-0d73-45c4-95c4-c64bbc04880e	9d6b43dd-0ecf-463f-b9eb-bd078e9786db	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":283,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:57:36
30390	9d693ce9-c10f-47a7-815d-d877dd8dd8a5	9d693ce9-e2a4-48e8-8e69-b1c941ae40d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:46:30
30391	9d693ce9-e116-433f-b6d6-3336d16e7725	9d693ce9-e2a4-48e8-8e69-b1c941ae40d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 15:46:30
30392	9d693ce9-e1b6-49a1-9da2-8bd508022ec0	9d693ce9-e2a4-48e8-8e69-b1c941ae40d2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":320,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:46:30
36981	9d6b43dd-7abc-4636-ab7e-a4ff50b7b448	9d6b43dd-98ac-484b-81e8-67057a4a6c08	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:57:36
36982	9d6b43dd-936b-4cce-943b-80671acbd372	9d6b43dd-98ac-484b-81e8-67057a4a6c08	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"46.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:57:36
36983	9d6b43dd-96f5-4a1c-8509-e139df183299	9d6b43dd-98ac-484b-81e8-67057a4a6c08	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:57:36
30393	9d693cea-3937-40d7-a112-bd01319c70b9	9d693cea-559c-4226-bf68-d0a0936c00ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 15:46:31
30394	9d693cea-5041-4020-bdaf-c805b8dab63a	9d693cea-559c-4226-bf68-d0a0936c00ae	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"37.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":58,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 15:46:31
30395	9d693cea-5096-4e11-b294-f09a1bb27c19	9d693cea-559c-4226-bf68-d0a0936c00ae	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 15:46:31
30396	9d693cea-546c-40e9-ae90-16164e27e311	9d693cea-559c-4226-bf68-d0a0936c00ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 15:46:31
30397	9d693cea-54b7-4178-a8b5-e6bcd8086570	9d693cea-559c-4226-bf68-d0a0936c00ae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cab","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:44:39.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:46:31
36984	9d6b43dd-9797-4c32-8882-c97f46cce9a0	9d6b43dd-98ac-484b-81e8-67057a4a6c08	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":279,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:57:36
30398	9d693cec-23c1-4dfa-b8c2-2e608aa8f31f	9d693cec-47ab-49e4-a3a5-c654d5ac36f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 15:46:32
30399	9d693cec-426c-460b-8344-440559e3090c	9d693cec-47ab-49e4-a3a5-c654d5ac36f5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"51.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:46:32
30400	9d693cec-42b8-4744-a952-42aa77004f9c	9d693cec-47ab-49e4-a3a5-c654d5ac36f5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:46:32
30401	9d693cec-4646-422d-8113-cfa8dc50b25c	9d693cec-47ab-49e4-a3a5-c654d5ac36f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 15:46:32
30402	9d693cec-46a1-4e4c-b423-fc2453884f1a	9d693cec-47ab-49e4-a3a5-c654d5ac36f5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":591,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:46:32
36985	9d6b43dd-e7d5-4aa3-a3a6-584ab4e87f4c	9d6b43de-0c55-427e-a7ea-67121a1189f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:57:36
36986	9d6b43de-06ee-45e9-88ed-d1b1460613f3	9d6b43de-0c55-427e-a7ea-67121a1189f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:57:36
36987	9d6b43de-0752-4b3e-8d47-9fe196dd94a4	9d6b43de-0c55-427e-a7ea-67121a1189f0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:57:36
36988	9d6b43de-0af1-4e26-800a-aaaf8c117838	9d6b43de-0c55-427e-a7ea-67121a1189f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:57:36
36989	9d6b43de-0b39-4dd6-92c1-05528625e5eb	9d6b43de-0c55-427e-a7ea-67121a1189f0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":286,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:57:36
36990	9d6b43de-5d3e-4c9c-bfe9-a50f3abc4d93	9d6b43de-a73b-4c8b-8896-6b4864fd2802	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:57:37
36991	9d6b43de-a181-42f3-84f5-fc2c4b602ec9	9d6b43de-a73b-4c8b-8896-6b4864fd2802	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"145.00","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:57:37
28906	9d690c7c-e2e1-44cb-87f2-d222550201f9	9d690c7d-2418-4153-b180-73296fc2c146	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 13:31:06
28907	9d690c7d-208a-444f-a28d-f87699b81daa	9d690c7d-2418-4153-b180-73296fc2c146	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 13:31:06
28908	9d690c7d-2236-4c6e-8f47-a037043402e8	9d690c7d-2418-4153-b180-73296fc2c146	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":452,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:31:06
36992	9d6b43de-a1da-4ef3-b1f2-47c27c524d6f	9d6b43de-a73b-4c8b-8896-6b4864fd2802	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:57:37
36993	9d6b43de-a5fd-4682-bd50-4b55d1c10ca5	9d6b43de-a73b-4c8b-8896-6b4864fd2802	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:57:37
36994	9d6b43de-a63f-430e-984c-8668a0d97603	9d6b43de-a73b-4c8b-8896-6b4864fd2802	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":374,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:57:37
28909	9d690c7e-0c2b-4da4-a0c7-7bb5d70420be	9d690c7e-4a4b-47e7-bc9b-27e4974978fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 13:31:07
28910	9d690c7e-388b-426d-8207-aeb3c978a847	9d690c7e-4a4b-47e7-bc9b-27e4974978fb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"82.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 13:31:07
28911	9d690c7e-3fae-4604-959b-24c2328e9f6a	9d690c7e-4a4b-47e7-bc9b-27e4974978fb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"3.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:31:07
28912	9d690c7e-4015-499c-b683-e0dfae26e320	9d690c7e-4a4b-47e7-bc9b-27e4974978fb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:31:07
28913	9d690c7e-47a8-452d-8bf6-e1f82a9310bb	9d690c7e-4a4b-47e7-bc9b-27e4974978fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 13:31:07
28914	9d690c7e-4864-4d50-804e-cf1befe53741	9d690c7e-4a4b-47e7-bc9b-27e4974978fb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":675,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:31:07
36995	9d6b43e0-899d-4e81-9706-fc9c120d0a36	9d6b43e0-a963-48fd-84aa-efd09c651a85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:57:38
36996	9d6b43e0-a3eb-418c-b8d9-565f916ab31e	9d6b43e0-a963-48fd-84aa-efd09c651a85	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:57:38
36997	9d6b43e0-a43c-4514-b9b9-01fd0a08efd3	9d6b43e0-a963-48fd-84aa-efd09c651a85	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:57:38
36998	9d6b43e0-a81e-4354-a3b7-b274f341aa24	9d6b43e0-a963-48fd-84aa-efd09c651a85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:57:38
36999	9d6b43e0-a868-44f4-8878-9a303d1f9946	9d6b43e0-a963-48fd-84aa-efd09c651a85	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":358,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:57:38
28915	9d690c7f-4bab-454c-bf46-d22b0fc8d4c2	9d690c7f-b34c-451a-9d1f-1248bd77287f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 13:31:07
28916	9d690c7f-a787-43f2-88b3-8e1b6d77712c	9d690c7f-b34c-451a-9d1f-1248bd77287f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"189.71","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:31:08
28917	9d690c7f-a80c-4f75-81ed-3a55dfdf185b	9d690c7f-b34c-451a-9d1f-1248bd77287f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:31:08
28918	9d690c7f-b0f9-477a-acbc-ef14aa3da0f2	9d690c7f-b34c-451a-9d1f-1248bd77287f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 13:31:08
28919	9d690c7f-b1a0-4e3d-ae73-bcced6569262	9d690c7f-b34c-451a-9d1f-1248bd77287f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":652,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:31:08
28920	9d690c80-7848-4ca9-8df8-58902bc5c427	9d690c80-a9ef-44e3-96b3-a6ea615b4f3a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 13:31:08
28921	9d690c80-9fbc-4b94-9f09-25ed6004e4a2	9d690c80-a9ef-44e3-96b3-a6ea615b4f3a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"65.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:31:08
28922	9d690c80-a05c-47b2-827e-f9cb5aee046b	9d690c80-a9ef-44e3-96b3-a6ea615b4f3a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:31:08
28923	9d690c80-a7b1-4bda-807b-d87a72e9d822	9d690c80-a9ef-44e3-96b3-a6ea615b4f3a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 13:31:08
28924	9d690c80-a854-4569-935c-f333137770e5	9d690c80-a9ef-44e3-96b3-a6ea615b4f3a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":554,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:31:08
43387	9d6ce725-12e5-47e8-8f9e-7f37c80bec03	9d6ce725-160e-4dd6-8eae-62c4931c29ee	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2020}	2024-11-06 11:29:59
42516	9d6cdf08-c6bd-422c-9f15-bfd6e98652a2	9d6cdf09-1e37-4ca4-91d6-5641e38bf6e8	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 11:07:19
42517	9d6cdf09-1c03-4afe-a8c1-d04e32b680a0	9d6cdf09-1e37-4ca4-91d6-5641e38bf6e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:07:19
42518	9d6cdf09-1d00-4f02-9f2d-d1981ed40ee8	9d6cdf09-1e37-4ca4-91d6-5641e38bf6e8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":428,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:07:19
29039	9d690e67-ddf9-4016-a63d-64e6924c4d53	9d690e68-0094-43d6-84ce-fcd3439c7963	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 13:36:28
29040	9d690e67-ff26-4e81-bd66-16b3032e743c	9d690e68-0094-43d6-84ce-fcd3439c7963	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 13:36:28
29041	9d690e67-ffc0-4c0a-9304-1e1fe680997f	9d690e68-0094-43d6-84ce-fcd3439c7963	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:36:28
29042	9d690e68-5c46-47fb-ad5c-1d7da90f0da5	9d690e68-a8df-42ec-8a6a-d835601d2bae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 13:36:28
29043	9d690e68-9eff-4ae8-ad18-92869395ec21	9d690e68-a8df-42ec-8a6a-d835601d2bae	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"155.59","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 13:36:28
29044	9d690e68-a326-4187-975d-c8a4844ea467	9d690e68-a8df-42ec-8a6a-d835601d2bae	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"1.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:36:28
29045	9d690e68-a35f-48af-a1cb-c1cdbb515f15	9d690e68-a8df-42ec-8a6a-d835601d2bae	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:36:28
29046	9d690e68-a77e-4403-ae51-57d7f39b9f02	9d690e68-a8df-42ec-8a6a-d835601d2bae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 13:36:28
29047	9d690e68-a7dd-4c86-9439-b9bcc0d8304d	9d690e68-a8df-42ec-8a6a-d835601d2bae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":375,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:36:28
41057	9d6ccae5-c8eb-4e8c-8788-555133cec750	9d6ccae5-e4bf-4d3b-bb24-1ebb07a409b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:11:00
41058	9d6ccae5-e2dd-49fa-a81b-ff95b43637f0	9d6ccae5-e4bf-4d3b-bb24-1ebb07a409b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:11:00
41059	9d6ccae5-e370-48be-a256-6b0b3fbb21d2	9d6ccae5-e4bf-4d3b-bb24-1ebb07a409b5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":309,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:11:00
41060	9d6ccae6-418e-4a9b-91c1-d3307a5eb48d	9d6ccae6-5ec0-437a-b8f1-a157fb076149	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:11:01
41061	9d6ccae6-5937-4fe3-81f2-57c011d3c1c5	9d6ccae6-5ec0-437a-b8f1-a157fb076149	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"42.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 10:11:01
41062	9d6ccae6-5d5b-4ab6-82a6-b740f055f5e1	9d6ccae6-5ec0-437a-b8f1-a157fb076149	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:11:01
41063	9d6ccae6-5dca-4050-9f4b-ad418afea324	9d6ccae6-5ec0-437a-b8f1-a157fb076149	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:11:01
41064	9d6ccae6-ba35-4de6-864c-10f5475e5c24	9d6ccae6-d9b9-478a-bf29-4e67d2b25626	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:11:01
41065	9d6ccae6-d402-45e4-8d65-5aed1259298c	9d6ccae6-d9b9-478a-bf29-4e67d2b25626	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:11:01
41066	9d6ccae6-d45f-47ef-87c7-2c864dc4c802	9d6ccae6-d9b9-478a-bf29-4e67d2b25626	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:11:01
41067	9d6ccae6-d850-42e4-a65f-fce0be716cfd	9d6ccae6-d9b9-478a-bf29-4e67d2b25626	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:11:01
41068	9d6ccae6-d89b-4d63-8e02-67e45e35a430	9d6ccae6-d9b9-478a-bf29-4e67d2b25626	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":299,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:11:01
41069	9d6ccae7-205a-42b2-9314-fa48be24a027	9d6ccae7-671b-4fc9-8504-447f8ade6844	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:11:01
41070	9d6ccae7-617c-432e-a764-f6c47e912eeb	9d6ccae7-671b-4fc9-8504-447f8ade6844	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"143.66","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:11:01
41071	9d6ccae7-61db-4c2e-b66f-2bde7555c25f	9d6ccae7-671b-4fc9-8504-447f8ade6844	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:11:01
41072	9d6ccae7-65c4-4c73-b0fd-dae8af72c654	9d6ccae7-671b-4fc9-8504-447f8ade6844	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:11:01
41073	9d6ccae7-660e-4025-a19c-0ea0a15469cc	9d6ccae7-671b-4fc9-8504-447f8ade6844	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:11:01
41074	9d6ccae9-91b4-43d9-9489-647171cd6e96	9d6ccae9-bfa8-4c6f-8f6a-b561b79fc2b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:11:03
41075	9d6ccae9-b6d7-4765-bbd9-aae58c86c4b5	9d6ccae9-bfa8-4c6f-8f6a-b561b79fc2b6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"59.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:11:03
41076	9d6ccae9-b750-4c73-ad47-776298b6a60d	9d6ccae9-bfa8-4c6f-8f6a-b561b79fc2b6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:11:03
41077	9d6ccae9-bdfc-43e2-b0e4-cc6866c2adf1	9d6ccae9-bfa8-4c6f-8f6a-b561b79fc2b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:11:03
41078	9d6ccae9-be65-46fa-a101-90da2e0d3a7f	9d6ccae9-bfa8-4c6f-8f6a-b561b79fc2b6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":404,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:11:03
41079	9d6ccaea-2306-4c44-8e01-823b47dbc91f	9d6ccaea-42af-4b4a-b24d-55f945d826b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:11:03
41080	9d6ccaea-3ccd-442c-9ac3-04e7e35064bc	9d6ccaea-42af-4b4a-b24d-55f945d826b4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"48.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:11:03
41081	9d6ccaea-4134-4321-9b2f-db224a8a2000	9d6ccaea-42af-4b4a-b24d-55f945d826b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:11:03
41082	9d6ccaea-4195-4a08-a4c7-41fba663aca6	9d6ccaea-42af-4b4a-b24d-55f945d826b4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:11:03
37139	9d6b4547-10d9-4a51-9d9f-e8fc2f728a89	9d6b4547-5bce-4730-a3aa-6aa86065d5f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 16:01:33
37140	9d6b4547-59e8-454f-8551-bcee399d3dc5	9d6b4547-5bce-4730-a3aa-6aa86065d5f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 16:01:33
37141	9d6b4547-5a7a-467c-97b8-d32b442ca050	9d6b4547-5bce-4730-a3aa-6aa86065d5f5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":367,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:01:33
37142	9d6b4547-b47f-45eb-ad5e-eb04dd109d2b	9d6b4547-fdf3-4e50-99b7-87c7c93bc711	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 16:01:33
37143	9d6b4547-f9ac-4345-a13f-3b32e4d0c574	9d6b4547-fdf3-4e50-99b7-87c7c93bc711	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"159.66","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 16:01:34
37144	9d6b4547-fc7d-455a-a382-760cb7fbb919	9d6b4547-fdf3-4e50-99b7-87c7c93bc711	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 16:01:34
37145	9d6b4547-fce7-4bea-903c-e4cb88f82dc1	9d6b4547-fdf3-4e50-99b7-87c7c93bc711	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":350,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:01:34
41083	9d6ccaea-a373-4acd-ad8c-57b7af3ac6ef	9d6ccaea-a7da-4874-8ff9-e74a692b39b8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":226,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:11:04
37146	9d6b4548-51e9-42f1-8873-85b88bbd2599	9d6b4548-7602-4c49-8607-51fbc6458fd3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 16:01:34
37147	9d6b4548-7067-4e92-8054-59dec12dc293	9d6b4548-7602-4c49-8607-51fbc6458fd3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:01:34
37148	9d6b4548-70bd-490e-bfd7-b4ed11a55f93	9d6b4548-7602-4c49-8607-51fbc6458fd3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:01:34
37149	9d6b4548-74b7-4188-8aa8-aab972cbeadc	9d6b4548-7602-4c49-8607-51fbc6458fd3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 16:01:34
37150	9d6b4548-74fa-4e3b-82b4-2e43bd8cebd5	9d6b4548-7602-4c49-8607-51fbc6458fd3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":287,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:01:34
41084	9d6ccaeb-135c-4127-9880-14e634888964	9d6ccaeb-3697-4d68-aff7-3ecad41379c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:11:04
41085	9d6ccaeb-30eb-4cb6-9cb2-aeaa3507634b	9d6ccaeb-3697-4d68-aff7-3ecad41379c3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"52.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 10:11:04
41086	9d6ccaeb-34d8-451a-9576-85647da7294c	9d6ccaeb-3697-4d68-aff7-3ecad41379c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:11:04
41087	9d6ccaeb-3571-4e56-af35-d2620fdf401f	9d6ccaeb-3697-4d68-aff7-3ecad41379c3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":298,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:11:04
42974	9d6ce334-a32b-4c83-8831-81d373d98314	9d6ce334-ece5-47f2-a75b-6b4ec1ed2bdc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:18:59
42975	9d6ce334-eb3d-42b5-a667-f56bcfbea9c7	9d6ce334-ece5-47f2-a75b-6b4ec1ed2bdc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 11:18:59
42976	9d6ce334-ebd1-4db0-a88b-d5a6e983804d	9d6ce334-ece5-47f2-a75b-6b4ec1ed2bdc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":371,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:18:59
43034	9d6ce387-f0dd-43fd-a173-a4e3853b7dde	9d6ce388-378a-4fa1-877e-de16794035d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:19:53
37151	9d6b4548-be19-46d2-8db6-5990904f515c	9d6b4549-09fc-4d8c-938d-dd6fffebbb61	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 16:01:34
37152	9d6b4549-042f-4d91-ad92-37d383586322	9d6b4549-09fc-4d8c-938d-dd6fffebbb61	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"155.01","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:01:34
37153	9d6b4549-0488-4783-9456-04fe999047f4	9d6b4549-09fc-4d8c-938d-dd6fffebbb61	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:01:34
37154	9d6b4549-087e-4edd-9a1c-c54a2404fbcf	9d6b4549-09fc-4d8c-938d-dd6fffebbb61	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 16:01:34
37155	9d6b4549-08e4-4a7c-9da0-f2afb2752aa6	9d6b4549-09fc-4d8c-938d-dd6fffebbb61	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":363,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:01:34
43035	9d6ce388-35b7-42c3-a1d9-935eb01764b3	9d6ce388-378a-4fa1-877e-de16794035d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 11:19:53
43036	9d6ce388-366c-44ec-a6d5-a2b0e2e74d3b	9d6ce388-378a-4fa1-877e-de16794035d3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":339,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:19:53
37156	9d6b454a-f3d5-4780-a5a2-34ecfd668ec5	9d6b454b-3d92-4fd5-aff0-fabad06d65be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 16:01:36
37157	9d6b454b-3771-4809-b1be-cdc7cd2b294f	9d6b454b-3d92-4fd5-aff0-fabad06d65be	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"149.81","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 16:01:36
37158	9d6b454b-37cd-4bdb-9f11-62299d4edc48	9d6b454b-3d92-4fd5-aff0-fabad06d65be	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 16:01:36
37159	9d6b454b-3c26-431f-b161-f0506df91a75	9d6b454b-3d92-4fd5-aff0-fabad06d65be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 16:01:36
37160	9d6b454b-3c75-482e-ac97-72723ca8cfa9	9d6b454b-3d92-4fd5-aff0-fabad06d65be	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":399,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:01:36
43095	9d6ce4c1-266a-4529-97bf-7b32684ceea8	9d6ce4c1-807a-45f2-8602-b70c90131686	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 11:23:18
43096	9d6ce4c1-7e5e-476d-9e8b-e1104aa55d61	9d6ce4c1-807a-45f2-8602-b70c90131686	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:23:19
43097	9d6ce4c1-7f37-4922-85b7-63094681cc08	9d6ce4c1-807a-45f2-8602-b70c90131686	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":500,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:23:19
43128	9d6ce505-49ee-4870-89fd-d679acf168d9	9d6ce505-68da-4758-b8c4-4ef847331d08	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 11:24:03
43129	9d6ce505-6706-4c72-8475-1f53f1ad2128	9d6ce505-68da-4758-b8c4-4ef847331d08	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 11:24:03
43130	9d6ce505-67ce-46e8-bb3e-8d491de27566	9d6ce505-68da-4758-b8c4-4ef847331d08	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/showCobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@showCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abFROM\\u00bb\\nLINE 19:                         FROM users\\n                                 ^ (Connection: pgsql, SQL: \\n                     SELECT id,\\n                            name,\\n                            profile_code,\\n                            profile_name,\\n                            profile_prefix,\\n                            remember_token,\\n                            user_address,\\n                            user_age,\\n                            user_alias,\\n                            user_birth,\\n                            user_cellphone,\\n                            user_city,\\n                            user_document,\\n                            user_document_type,\\n                            user_last_name_one,\\n                            user_last_name_two,\\n                            user_neighborhood,\\n                        FROM users\\n                        WHERE profile_code = 4;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":142,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"showCobrador","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":265,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:24:03
43131	9d6ce507-36e6-4091-8871-d2ce5188ed6c	9d6ce507-8099-432d-93a5-896c88b73c48	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 11:24:04
43132	9d6ce507-795a-45fc-bc99-624c085fff00	9d6ce507-8099-432d-93a5-896c88b73c48	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"120.46","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:24:05
43133	9d6ce507-79db-4d39-a406-e678d02de888	9d6ce507-8099-432d-93a5-896c88b73c48	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:24:05
43134	9d6ce507-7f05-45f1-a331-bee87ce6af67	9d6ce507-8099-432d-93a5-896c88b73c48	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 11:24:05
43135	9d6ce507-7f6a-4070-9c74-ff10a3aa70c8	9d6ce507-8099-432d-93a5-896c88b73c48	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":477,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:24:05
43136	9d6ce507-c8ff-4833-b3de-b97daeb0eed4	9d6ce507-e596-412e-a4b5-eab9f52b46bc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 11:24:05
43137	9d6ce507-e069-40e9-9d2c-12351aebfc08	9d6ce507-e596-412e-a4b5-eab9f52b46bc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"47.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:24:05
43138	9d6ce507-e41b-4201-ac8d-7e80bf235309	9d6ce507-e596-412e-a4b5-eab9f52b46bc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 11:24:05
43139	9d6ce507-e480-4715-810b-c19f3f05944a	9d6ce507-e596-412e-a4b5-eab9f52b46bc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":242,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:24:05
25612	9d68c768-48a6-441d-b2d0-3e1642798c77	9d68c768-4de3-42ac-8627-ffbcc23471c8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1174}	2024-11-04 10:17:56
42920	9d6ce169-1ceb-45fd-ad06-1938145e147c	9d6ce169-43b3-4ba0-bc05-1e927a3bf864	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 11:13:57
42921	9d6ce169-41a1-41c8-97bb-0321c3a69ea7	9d6ce169-43b3-4ba0-bc05-1e927a3bf864	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:13:58
42922	9d6ce169-425e-4ee3-9f72-fd22b8213ac2	9d6ce169-43b3-4ba0-bc05-1e927a3bf864	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:13:58
9429	9d52f7cc-0f22-4373-8351-0f89920a444b	9d52f7cc-127f-4e7f-8807-07cc533e756c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":449}	2024-10-24 14:05:02
37304	9d6b4726-c549-48eb-b022-7f485cb4db40	9d6b4726-e7f8-4bbc-9e5c-27e4bcf42e40	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 16:06:47
37305	9d6b4726-e643-4eda-bcbf-a45659ce8822	9d6b4726-e7f8-4bbc-9e5c-27e4bcf42e40	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 16:06:47
37306	9d6b4726-e6e2-4b5f-a918-4174333308f4	9d6b4726-e7f8-4bbc-9e5c-27e4bcf42e40	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":316,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:06:47
37307	9d6b4727-4814-45bf-bf6e-030462f470f9	9d6b4727-63bb-471d-91b4-0cafc28afdfb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 16:06:48
37308	9d6b4727-5f5e-47d6-b476-67dc24f6530f	9d6b4727-63bb-471d-91b4-0cafc28afdfb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"43.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":26,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-05 16:06:48
37309	9d6b4727-6275-4f4b-9dbf-c831264e9c78	9d6b4727-63bb-471d-91b4-0cafc28afdfb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 16:06:48
37310	9d6b4727-62d8-456c-8230-063b388ea99b	9d6b4727-63bb-471d-91b4-0cafc28afdfb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:06:48
37311	9d6b4729-5f0f-499f-ab8e-151365ea5ab1	9d6b4729-86ba-4992-985a-8325d38b70d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 16:06:49
37312	9d6b4729-7f62-43cf-8b0a-ba7281c67569	9d6b4729-86ba-4992-985a-8325d38b70d1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"53.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 16:06:49
37313	9d6b4729-7fb2-4a97-be04-eb2163039ef6	9d6b4729-86ba-4992-985a-8325d38b70d1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 16:06:49
37314	9d6b4729-8547-44cf-8fe4-78d2b32c90cf	9d6b4729-86ba-4992-985a-8325d38b70d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 16:06:49
37315	9d6b4729-8599-4ba8-9a6a-21b67c812613	9d6b4729-86ba-4992-985a-8325d38b70d1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":503,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:06:49
37316	9d6b47f9-4fb9-439d-bbf9-99236aeb5c7a	9d6b47f9-a48b-49cd-978d-ffa7219d9bcb	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 16:09:05
37317	9d6b47f9-9e1a-4850-9571-ec67edba9d32	9d6b47f9-a48b-49cd-978d-ffa7219d9bcb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"157.95","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 16:09:06
37318	9d6b47f9-a2d2-4772-9376-f3c6a651aa41	9d6b47f9-a48b-49cd-978d-ffa7219d9bcb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 16:09:06
37319	9d6b47f9-a355-4572-91de-1da17660085f	9d6b47f9-a48b-49cd-978d-ffa7219d9bcb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":450,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:09:06
37320	9d6b47fa-0985-45de-851c-4710aa1b6d35	9d6b47fa-2a6e-402f-afb6-33cceb22bb04	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 16:09:06
37321	9d6b47fa-24c7-45f9-8607-8c75a04e9c91	9d6b47fa-2a6e-402f-afb6-33cceb22bb04	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:09:06
37322	9d6b47fa-251f-4bc6-9fe2-35cb5a9bb97d	9d6b47fa-2a6e-402f-afb6-33cceb22bb04	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:09:06
37323	9d6b47fa-292d-4624-8614-16e7f2a9bb2d	9d6b47fa-2a6e-402f-afb6-33cceb22bb04	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 16:09:06
37324	9d6b47fa-2970-480c-9110-1a4d9924ef07	9d6b47fa-2a6e-402f-afb6-33cceb22bb04	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":327,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:09:06
37325	9d6b47fa-7340-4a62-87ae-2ecd97a62ef9	9d6b47fa-9227-4f94-a49b-f8c526a03e3e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 16:09:06
37326	9d6b47fa-8c77-43a9-ae70-dfda0a0b4477	9d6b47fa-9227-4f94-a49b-f8c526a03e3e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:09:06
37327	9d6b47fa-8cc4-4378-beb9-826f27db1dc4	9d6b47fa-9227-4f94-a49b-f8c526a03e3e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:09:06
37328	9d6b47fa-90e8-4916-ad62-fad990f07410	9d6b47fa-9227-4f94-a49b-f8c526a03e3e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 16:09:06
37329	9d6b47fa-9131-484f-a919-e54c2a527fc4	9d6b47fa-9227-4f94-a49b-f8c526a03e3e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:09:06
28767	9d690769-d488-4407-ade2-09e695e4f3d0	9d690769-dbe0-40e1-b52c-2e920465e3fd	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1341}	2024-11-04 13:16:55
43384	9d6ce724-4feb-4d32-87af-99a39edd600a	9d6ce724-7878-4576-a931-deb0d79524ec	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 11:29:59
43385	9d6ce724-7609-4783-8d86-483f386b5fd2	9d6ce724-7878-4576-a931-deb0d79524ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:29:59
43386	9d6ce724-76ff-49f9-89f3-01811db98801	9d6ce724-7878-4576-a931-deb0d79524ec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":371,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:29:59
43438	9d6cea00-c0cf-498f-ae3f-78da9429bdc7	9d6cea00-e790-4ad6-8a87-d6e0e3e24163	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:37:59
43439	9d6cea00-e55d-43da-9e5a-0696ea8c83bc	9d6cea00-e790-4ad6-8a87-d6e0e3e24163	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:37:59
43440	9d6cea00-e629-4a08-a695-380db2ba63c4	9d6cea00-e790-4ad6-8a87-d6e0e3e24163	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":298,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:37:59
29089	9d690e9b-61af-4434-b45d-5ec09b88a886	9d690e9b-6744-4b8d-b8b5-3f4e2fe4c5b1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1358}	2024-11-04 13:37:01
43220	9d6ce59d-826f-494d-b2b5-919c3363db7d	9d6ce59d-ac3e-4c39-ab1b-7965853891e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:25:43
43221	9d6ce59d-a9c3-4d47-8e5b-95a296c1f914	9d6ce59d-ac3e-4c39-ab1b-7965853891e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:25:43
43222	9d6ce59d-aad6-4b0a-90de-ac0738bfc155	9d6ce59d-ac3e-4c39-ab1b-7965853891e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":450,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:25:43
43223	9d6ce59e-1dd1-4219-b2a0-a88ee71ab8c0	9d6ce59e-3ce9-49d7-b069-9d8befc41708	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:25:43
43224	9d6ce59e-373a-4306-95d6-fd4daa740e74	9d6ce59e-3ce9-49d7-b069-9d8befc41708	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT id,\\n                            name,\\n                            profile_code,\\n                            remember_token,\\n                            user_address,\\n                            user_age,\\n                            user_alias,\\n                            user_birth,\\n                            user_cellphone,\\n                            user_city,\\n                            user_document,\\n                            user_document_type,\\n                            user_last_name_one,\\n                            user_last_name_two,\\n                            user_neighborhood\\n                        FROM users\\n                        WHERE profile_code = 4;\\n                            ","time":"46.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":142,"hash":"e2980c10c70608ca75f9c2180abc54e1","hostname":"EderCortes"}	2024-11-06 11:25:43
43225	9d6ce59e-3b7b-4da5-a736-32c41671478b	9d6ce59e-3ce9-49d7-b069-9d8befc41708	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:25:43
43226	9d6ce59e-3be2-48d5-8dd4-836cf16dd698	9d6ce59e-3ce9-49d7-b069-9d8befc41708	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/showCobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@showCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":14,"name":"Luis andre","profile_code":4,"remember_token":null,"user_address":"Calle 750","user_age":"31","user_alias":"luis_martinez","user_birth":"1992-11-12T04:00:00.000Z","user_cellphone":"312596295","user_city":"Cali","user_document":"100465545","user_document_type":"CC","user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_neighborhood":"Bonilla aragon"}},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:25:43
37457	9d6b4b41-1ccb-4390-b06d-ddce51c351a8	9d6b4b41-44c0-4255-8b6b-8b8f61e7f48b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 16:18:16
37458	9d6b4b41-4253-4acd-af00-5731f5c8800c	9d6b4b41-44c0-4255-8b6b-8b8f61e7f48b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 16:18:16
37459	9d6b4b41-435c-48f8-bd8e-fe31acd465f6	9d6b4b41-44c0-4255-8b6b-8b8f61e7f48b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":285,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:18:16
37460	9d6b4b41-cacd-4efa-a6a3-d58822a780ee	9d6b4b41-e9d5-4053-9fdd-079130521f71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 16:18:16
37461	9d6b4b41-e20d-4f52-9150-13db5bb8d8cd	9d6b4b41-e9d5-4053-9fdd-079130521f71	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 84\\n                        ","time":"43.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ab3bc7b9a0b897ddfe4287a88fc64c84","hostname":"EderCortes"}	2024-11-05 16:18:16
37462	9d6b4b41-e522-4482-806a-c8025cfabdde	9d6b4b41-e9d5-4053-9fdd-079130521f71	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '84' order by \\"item_loans\\".\\"id\\" asc","time":"3.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":304,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-05 16:18:16
37463	9d6b4b41-e88a-4041-9020-05489e6b13e7	9d6b4b41-e9d5-4053-9fdd-079130521f71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 16:18:16
27636	9d68e8b7-2577-409c-8119-46da98879eec	9d68e8b7-68a3-45ae-8274-899f4fbd1a5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 11:51:04
27637	9d68e8b7-659a-4db8-a2e3-6d7fd94fd552	9d68e8b7-68a3-45ae-8274-899f4fbd1a5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 11:51:04
27638	9d68e8b7-6726-4140-ba59-3999aa1dc4f7	9d68e8b7-68a3-45ae-8274-899f4fbd1a5c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":716,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:51:04
37464	9d6b4b41-e8dd-4662-8b0a-c0c3caffde7e	9d6b4b41-e9d5-4053-9fdd-079130521f71	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/84","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":84,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"480000","loans_pago_interes":"120000","user_alias":"juan_jaramillo"},"items":[{"id":326,"loans_codigo":84,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 21:20:45","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":452,"loans_codigo":84,"itemloans_cuota":"4","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 21:20:45","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":456,"loans_codigo":84,"itemloans_cuota":"3","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:21:49","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":457,"loans_codigo":84,"itemloans_cuota":"4","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:21:49","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":458,"loans_codigo":84,"itemloans_cuota":"5","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:21:49","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":279,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:18:16
43227	9d6ce59f-e1c6-41ba-81af-f92852aa50c0	9d6ce5a0-31d0-4340-8933-1b7491b5cdd5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:25:44
43228	9d6ce5a0-27bd-422c-ab6a-47308bebb6b2	9d6ce5a0-31d0-4340-8933-1b7491b5cdd5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"117.48","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:25:45
43229	9d6ce5a0-2834-4851-8ffb-4e3c8d1a1e5a	9d6ce5a0-31d0-4340-8933-1b7491b5cdd5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:25:45
43230	9d6ce5a0-2f8d-448c-837d-7af564b8f913	9d6ce5a0-31d0-4340-8933-1b7491b5cdd5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:25:45
43231	9d6ce5a0-3035-4883-93d6-48b2b029dbea	9d6ce5a0-31d0-4340-8933-1b7491b5cdd5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":485,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:25:45
27639	9d68e8b8-341a-4fea-9aa2-3b273f2d2a8c	9d68e8b8-6284-4762-b2dc-4f14b776135f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 11:51:05
27640	9d68e8b8-5a70-47c9-9c86-21df9637ba9e	9d68e8b8-6284-4762-b2dc-4f14b776135f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"62.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:51:05
27641	9d68e8b8-5ad6-4152-a2d2-c9adf4e2f973	9d68e8b8-6284-4762-b2dc-4f14b776135f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 11:51:05
27642	9d68e8b8-6099-4b43-bb69-4117dae7da22	9d68e8b8-6284-4762-b2dc-4f14b776135f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 11:51:05
27643	9d68e8b8-6115-4473-ba37-cddad159d91f	9d68e8b8-6284-4762-b2dc-4f14b776135f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null}]},"duration":555,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:51:05
37465	9d6b4b43-afd7-4a24-98bd-3f8926b6ce9a	9d6b4b43-dd25-49bd-a643-d5f99771667c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 16:18:17
37466	9d6b4b43-d452-4606-b142-5fdc59190046	9d6b4b43-dd25-49bd-a643-d5f99771667c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"55.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 16:18:17
37467	9d6b4b43-d4bf-4ce2-93bb-c93d4d925214	9d6b4b43-dd25-49bd-a643-d5f99771667c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 16:18:17
37468	9d6b4b43-db1e-4c2e-8a7f-c974578d9c0a	9d6b4b43-dd25-49bd-a643-d5f99771667c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 16:18:17
37469	9d6b4b43-db85-420b-a081-5c4ad144f011	9d6b4b43-dd25-49bd-a643-d5f99771667c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":432,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:18:17
43232	9d6ce5a0-98a0-4a18-b8eb-5707ce2da747	9d6ce5a0-bc19-47f1-8caf-5a050ee190c1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:25:45
43233	9d6ce5a0-b5eb-4b24-8d89-782465d548e2	9d6ce5a0-bc19-47f1-8caf-5a050ee190c1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"58.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:25:45
43234	9d6ce5a0-b9fe-4e76-bbc0-7d2843c77d26	9d6ce5a0-bc19-47f1-8caf-5a050ee190c1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:25:45
43235	9d6ce5a0-ba88-4b80-b908-bc3ee9530a5a	9d6ce5a0-bc19-47f1-8caf-5a050ee190c1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":326,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:25:45
27644	9d68e8b9-111a-479b-8590-007b4e2065a6	9d68e8b9-412d-489e-a239-1a91adb63f95	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 11:51:06
27645	9d68e8b9-37a6-4162-a849-d7a637a9df6d	9d68e8b9-412d-489e-a239-1a91adb63f95	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"56.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 11:51:06
27646	9d68e8b9-382a-4937-9ad7-2b8378e98663	9d68e8b9-412d-489e-a239-1a91adb63f95	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 11:51:06
27647	9d68e8b9-3f11-48d8-86ea-bd64836e0a80	9d68e8b9-412d-489e-a239-1a91adb63f95	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 11:51:06
27648	9d68e8b9-3fb4-492e-8ac0-92fdbf5349a8	9d68e8b9-412d-489e-a239-1a91adb63f95	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null}]},"duration":549,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:51:06
28578	9d6901fa-6b8d-4e3b-aa94-2808a369b535	9d6901fa-6d31-4a3c-af95-80aeb37c500f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":669,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:01:43
27649	9d68e8b9-d506-443a-befa-77ad80704bf0	9d68e8ba-24ee-48c0-9915-2950f857a40e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 11:51:06
27650	9d68e8ba-1b8d-448b-be3c-e7b8eaf10162	9d68e8ba-24ee-48c0-9915-2950f857a40e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '90' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"159.78","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 11:51:06
27651	9d68e8ba-1bfa-44de-80c5-f26a63c23466	9d68e8ba-24ee-48c0-9915-2950f857a40e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 11:51:06
27652	9d68e8ba-1e27-4aeb-92e5-c11f49e98e02	9d68e8ba-24ee-48c0-9915-2950f857a40e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"2.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 11:51:06
27653	9d68e8ba-1e6b-4671-8da0-1619ac986464	9d68e8ba-24ee-48c0-9915-2950f857a40e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 11:51:06
27654	9d68e8ba-238b-4872-b834-041fbb488b0d	9d68e8ba-24ee-48c0-9915-2950f857a40e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 11:51:06
27655	9d68e8ba-23e5-4a79-be17-8bd38f1fb60d	9d68e8ba-24ee-48c0-9915-2950f857a40e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"275000","loans_pago_prestado":"1100000","loans_intereses_recaudar":"275000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"}]}},"duration":561,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:51:06
27656	9d68e8bb-01a2-4b50-baca-d4afd980b4c7	9d68e8bb-5741-4716-9c05-b394d0e279ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 11:51:07
27657	9d68e8bb-49ff-4370-bf80-d0d5dd62ca13	9d68e8bb-5741-4716-9c05-b394d0e279ae	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"130.18","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:51:07
27658	9d68e8bb-4a97-4a7f-8b96-354b10526963	9d68e8bb-5741-4716-9c05-b394d0e279ae	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:51:07
27659	9d68e8bb-53a0-4ec6-8668-3932bb53d147	9d68e8bb-5741-4716-9c05-b394d0e279ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 11:51:07
27660	9d68e8bb-5434-4dea-a3ba-31568350b09e	9d68e8bb-5741-4716-9c05-b394d0e279ae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":752,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:51:07
27661	9d68e8bc-65df-42ed-aff0-a9e3891c8074	9d68e8bc-b7c9-441a-b167-567157f9f03f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 11:51:08
27662	9d68e8bc-b2c2-4765-bb7f-2aa33474ac77	9d68e8bc-b7c9-441a-b167-567157f9f03f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"153.94","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 11:51:08
27663	9d68e8bc-b315-4d82-8538-43c4c9788851	9d68e8bc-b7c9-441a-b167-567157f9f03f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 11:51:08
27664	9d68e8bc-b67c-42d9-a611-46a689e5b2d9	9d68e8bc-b7c9-441a-b167-567157f9f03f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 11:51:08
27665	9d68e8bc-b6c4-4ccb-8259-ce8bf4168124	9d68e8bc-b7c9-441a-b167-567157f9f03f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":875,"memory":22,"hostname":"EderCortes"}	2024-11-04 11:51:08
42059	9d6cd403-ded8-4ec7-b55d-eb22206cb201	9d6cd403-e265-4172-ab43-a1f1ebb1437c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1954}	2024-11-06 10:36:30
29264	9d691413-0028-481d-9424-cbb0882c3872	9d691413-1f7a-4dc8-b42c-888e500a5164	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 13:52:19
29265	9d691413-1dca-4558-a30a-a467d7838524	9d691413-1f7a-4dc8-b42c-888e500a5164	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 13:52:19
29266	9d691413-1e81-452b-9b81-890f14b5c3bc	9d691413-1f7a-4dc8-b42c-888e500a5164	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":257,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:52:19
34390	9d69be31-dc7e-448d-b781-dc877a7beaf5	9d69be31-df38-48f1-8425-30bc621e93bc	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1560}	2024-11-04 21:48:00
29267	9d691413-8717-4d77-942c-bb52b53c69be	9d691413-aa0a-45b1-a05b-b547001a39c7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 13:52:19
29268	9d691413-9f66-4681-9552-f4ff5c26d30e	9d691413-aa0a-45b1-a05b-b547001a39c7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"44.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 13:52:19
29269	9d691413-a3ca-46af-aa9d-bf69e5e9485f	9d691413-aa0a-45b1-a05b-b547001a39c7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:52:19
29270	9d691413-a407-4322-9b36-f311ff1db0d5	9d691413-aa0a-45b1-a05b-b547001a39c7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:52:19
29271	9d691413-a887-4ed5-8c31-aff27912e0c0	9d691413-aa0a-45b1-a05b-b547001a39c7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 13:52:19
29272	9d691413-a8d9-4132-a3c0-4564add00df8	9d691413-aa0a-45b1-a05b-b547001a39c7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":297,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:52:19
42364	9d6cdd9d-bb20-4ad4-9265-34b9c7fcfca2	9d6cdd9d-dab3-46b8-b7dc-b3156b1ffe6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:03:21
42365	9d6cdd9d-d8e5-4ec6-84cb-61784071a71b	9d6cdd9d-dab3-46b8-b7dc-b3156b1ffe6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:03:21
42366	9d6cdd9d-d992-4aed-847b-7502b11c7f23	9d6cdd9d-dab3-46b8-b7dc-b3156b1ffe6b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:03:21
30847	9d694399-af29-4271-9644-03e2011e4b6b	9d69439a-0480-414c-9659-d04f22eb5cbb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:05:12
30848	9d69439a-00e9-4493-9e88-794185b2da7c	9d69439a-0480-414c-9659-d04f22eb5cbb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:05:12
30849	9d69439a-02e4-4aab-a858-2d2121efcb2c	9d69439a-0480-414c-9659-d04f22eb5cbb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":746,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:05:12
30850	9d69439a-d02a-49c1-8610-7b3cd1bccffe	9d69439b-09cd-4b53-b8b4-ec08de4821f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:05:13
30851	9d69439a-ffab-491f-84e9-fc4013edfabb	9d69439b-09cd-4b53-b8b4-ec08de4821f4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"73.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:05:13
30852	9d69439b-002d-4982-bd8b-c4313aeef9de	9d69439b-09cd-4b53-b8b4-ec08de4821f4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:05:13
30853	9d69439b-072f-4e76-93a8-e39c12ead9ed	9d69439b-09cd-4b53-b8b4-ec08de4821f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:05:13
30854	9d69439b-07f6-4b29-9f9d-bd44fcc54e9d	9d69439b-09cd-4b53-b8b4-ec08de4821f4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":562,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:05:13
30855	9d69439b-9493-4c54-9255-56523f2a3500	9d69439b-c6ed-41d9-b2e4-6b507682ad75	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:05:13
30856	9d69439b-b68f-4ffd-bf44-476ab0b939af	9d69439b-c6ed-41d9-b2e4-6b507682ad75	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 91\\n                        ","time":"66.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9ae30bc69b6b272f3f51ff48e54319f5","hostname":"EderCortes"}	2024-11-04 16:05:14
30857	9d69439b-bd07-4f7f-a8e6-b1e5ea6856d5	9d69439b-c6ed-41d9-b2e4-6b507682ad75	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '91' order by \\"item_loans\\".\\"id\\" asc","time":"3.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 16:05:14
30858	9d69439b-bd62-45b8-be5d-228c4d1b83e7	9d69439b-c6ed-41d9-b2e4-6b507682ad75	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":8,"hostname":"EderCortes"}	2024-11-04 16:05:14
30859	9d69439b-c4d0-4b2a-a693-b7df040259f3	9d69439b-c6ed-41d9-b2e4-6b507682ad75	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:05:14
30860	9d69439b-c574-461d-83f6-8760e98bd0af	9d69439b-c6ed-41d9-b2e4-6b507682ad75	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/91","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":91,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":8,"loans_valor_prestado":5000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0","user_alias":"eder.cortes"},"items":[{"id":371,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:04:19.000000Z","updated_at":"2024-11-04T21:04:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":372,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:04:19.000000Z","updated_at":"2024-11-04T21:04:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":373,"loans_codigo":91,"itemloans_cuota":"3","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:04:19.000000Z","updated_at":"2024-11-04T21:04:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":374,"loans_codigo":91,"itemloans_cuota":"4","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:04:19.000000Z","updated_at":"2024-11-04T21:04:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":375,"loans_codigo":91,"itemloans_cuota":"5","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:04:19.000000Z","updated_at":"2024-11-04T21:04:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":376,"loans_codigo":91,"itemloans_cuota":"6","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:04:19.000000Z","updated_at":"2024-11-04T21:04:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":377,"loans_codigo":91,"itemloans_cuota":"7","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:04:19.000000Z","updated_at":"2024-11-04T21:04:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":378,"loans_codigo":91,"itemloans_cuota":"8","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:04:19.000000Z","updated_at":"2024-11-04T21:04:19.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":451,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:05:14
30861	9d69439e-7f08-4c46-b058-bc9e899b2b9a	9d69439e-ca90-4a7e-b522-c8eba2853045	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:05:15
30862	9d69439e-c0a9-47ff-9da1-6e722800f624	9d69439e-ca90-4a7e-b522-c8eba2853045	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"124.52","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:05:16
30863	9d69439e-c15a-4364-a30e-885ced65fa51	9d69439e-ca90-4a7e-b522-c8eba2853045	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:05:16
30864	9d69439e-c887-4b2a-8058-af7613ffb01f	9d69439e-ca90-4a7e-b522-c8eba2853045	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:05:16
30865	9d69439e-c914-4eb3-8618-f7f67132cda9	9d69439e-ca90-4a7e-b522-c8eba2853045	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":594,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:05:16
32677	9d69828f-bea3-463a-98af-aefad4064eed	9d69828f-fd28-4bf1-a800-41ec8f86c03a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 19:01:15
32678	9d69828f-f8d4-4433-9b7b-8d88e2fa9218	9d69828f-fd28-4bf1-a800-41ec8f86c03a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 19:01:16
32679	9d69828f-fae3-4fe4-968f-dd569a2bde89	9d69828f-fd28-4bf1-a800-41ec8f86c03a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":466,"memory":22,"hostname":"EderCortes"}	2024-11-04 19:01:16
32680	9d698290-d604-4ef9-a53c-3f985ee77650	9d698291-e80d-4eca-a54a-01a0c458ae4e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 19:01:16
32681	9d698291-c09d-4f71-a587-bcf0305e6c64	9d698291-e80d-4eca-a54a-01a0c458ae4e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"58.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":227,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 19:01:17
32682	9d698291-c117-4f39-a816-1856e6991781	9d698291-e80d-4eca-a54a-01a0c458ae4e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 19:01:17
32683	9d698291-e631-4ad3-ab46-89275ffe89d3	9d698291-e80d-4eca-a54a-01a0c458ae4e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 19:01:17
32684	9d698291-e6ba-426a-a221-587038524519	9d698291-e80d-4eca-a54a-01a0c458ae4e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":1141,"memory":22,"hostname":"EderCortes"}	2024-11-04 19:01:17
30951	9d6944e8-4361-4f9b-869e-9eb5ece4ad9c	9d6944e8-7ce7-409b-acd6-7f7bfc70d141	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 16:08:52
30952	9d6944e8-79be-406b-96ca-b3f655fc72b4	9d6944e8-7ce7-409b-acd6-7f7bfc70d141	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:08:52
30953	9d6944e8-7b4d-49c1-aa2d-0c20057e2e19	9d6944e8-7ce7-409b-acd6-7f7bfc70d141	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":472,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:08:52
30954	9d6944e9-2718-4b67-a160-f93acec37f0f	9d6944e9-87eb-44d0-93b6-a41fd524fc17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:08:52
30955	9d6944e9-7c51-48fe-a80b-03f2d211ecc3	9d6944e9-87eb-44d0-93b6-a41fd524fc17	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"171.78","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:08:52
30956	9d6944e9-7cdb-427e-929d-5221d6e1c65e	9d6944e9-87eb-44d0-93b6-a41fd524fc17	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 16:08:52
30957	9d6944e9-855e-451e-aa10-95b60a41425b	9d6944e9-87eb-44d0-93b6-a41fd524fc17	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:08:52
30958	9d6944e9-85f1-41be-98e2-ac6c67753eb2	9d6944e9-87eb-44d0-93b6-a41fd524fc17	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":581,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:08:52
32685	9d698292-3873-4563-96f0-14ade34af563	9d698292-5656-4f31-b90e-be4ac6e10dad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 19:01:17
32686	9d698292-5169-4c9e-90c9-001cad16df8d	9d698292-5656-4f31-b90e-be4ac6e10dad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"38.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":216,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 19:01:17
32687	9d698292-51bf-469e-a24b-ad43b28200b1	9d698292-5656-4f31-b90e-be4ac6e10dad	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 19:01:17
32688	9d698292-552e-4aff-8636-441fe947a120	9d698292-5656-4f31-b90e-be4ac6e10dad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 19:01:17
32689	9d698292-5577-481d-9706-45a49114fea4	9d698292-5656-4f31-b90e-be4ac6e10dad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":260,"memory":22,"hostname":"EderCortes"}	2024-11-04 19:01:17
29413	9d69245a-41e7-461f-989e-a1e8bfdcdfb9	9d69245a-60aa-4ecd-a751-ae7400da5c45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 14:37:50
29414	9d69245a-5f02-4fd3-bd61-ad8f9d8334eb	9d69245a-60aa-4ecd-a751-ae7400da5c45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 14:37:50
29415	9d69245a-5fad-4048-a234-c780e5bfd2e4	9d69245a-60aa-4ecd-a751-ae7400da5c45	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:37:50
29416	9d69245a-b87a-4d30-8922-8109973ec67c	9d69245a-dc61-424a-906a-2b766fdf7619	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 14:37:50
29417	9d69245a-d166-43a3-a9c3-6281b60baeb6	9d69245a-dc61-424a-906a-2b766fdf7619	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"48.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 14:37:50
29418	9d69245a-d57a-4f1a-bf49-4087655605dd	9d69245a-dc61-424a-906a-2b766fdf7619	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 14:37:50
29419	9d69245a-d5b5-4707-bf84-620c66c0fcc5	9d69245a-dc61-424a-906a-2b766fdf7619	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 14:37:50
29420	9d69245a-db20-4c77-a41c-3cd5e2f7c43d	9d69245a-dc61-424a-906a-2b766fdf7619	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 14:37:50
29421	9d69245a-db74-4474-b97e-425b9a876014	9d69245a-dc61-424a-906a-2b766fdf7619	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":261,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:37:50
30959	9d6944ea-033c-44b1-9531-ff7a468516a8	9d6944ea-37d1-4728-b6e9-93687a43834a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:08:53
30960	9d6944ea-2f8c-4cba-aff6-9ac215b2c6ff	9d6944ea-37d1-4728-b6e9-93687a43834a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"68.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:08:53
30961	9d6944ea-301a-4564-9543-b49d926c2636	9d6944ea-37d1-4728-b6e9-93687a43834a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 16:08:53
30962	9d6944ea-35f1-45a0-89ff-807ea3e73ba0	9d6944ea-37d1-4728-b6e9-93687a43834a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:08:53
30963	9d6944ea-3674-4d1f-abdc-336b18b95a1c	9d6944ea-37d1-4728-b6e9-93687a43834a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":425,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:08:53
32690	9d698292-97bd-4230-9468-1ccbf150b3eb	9d698292-b512-4b18-8af4-3e592423ab51	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 19:01:17
32691	9d698292-aff7-4e74-bc97-d1fb73ab0767	9d698292-b512-4b18-8af4-3e592423ab51	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 19:01:17
32692	9d698292-b04d-4907-9f3e-a3b1ddcdb34e	9d698292-b512-4b18-8af4-3e592423ab51	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 19:01:17
30964	9d6944eb-2f01-4f69-b1eb-579f60196f7d	9d6944eb-7679-46a1-a1d4-0f2829ae135b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:08:53
30965	9d6944eb-68c0-4ac6-9724-e9584dd22e97	9d6944eb-7679-46a1-a1d4-0f2829ae135b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"86.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:08:54
30966	9d6944eb-6956-4a9a-88b2-f0b84ce478d5	9d6944eb-7679-46a1-a1d4-0f2829ae135b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:08:54
30967	9d6944eb-72ce-4abc-bc7f-8e0e7b207394	9d6944eb-7679-46a1-a1d4-0f2829ae135b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:08:54
30968	9d6944eb-739a-47e5-9163-a29c6e2f7cc3	9d6944eb-7679-46a1-a1d4-0f2829ae135b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":791,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:08:54
32693	9d698292-b3d7-4889-bd6d-ebaaa8a7e2ce	9d698292-b512-4b18-8af4-3e592423ab51	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 19:01:17
32694	9d698292-b423-4356-bed3-6aa6dcae0179	9d698292-b512-4b18-8af4-3e592423ab51	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":228,"memory":22,"hostname":"EderCortes"}	2024-11-04 19:01:17
40728	9d6cc6ca-56fa-460c-a316-7cf9e8134a5d	9d6cc6ca-7cdc-49ab-bf45-3cbfcc3e28cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 09:59:31
40729	9d6cc6ca-7574-4a16-bcb3-3a1f4496ed09	9d6cc6ca-7cdc-49ab-bf45-3cbfcc3e28cf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:59:31
40730	9d6cc6ca-75e8-4968-8043-40f5f6bed61a	9d6cc6ca-7cdc-49ab-bf45-3cbfcc3e28cf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:59:31
40731	9d6cc6ca-7b4f-4536-bcdf-c466da4cc137	9d6cc6ca-7cdc-49ab-bf45-3cbfcc3e28cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 09:59:31
40732	9d6cc6ca-7bb4-4fe2-9387-200bce40c78a	9d6cc6ca-7cdc-49ab-bf45-3cbfcc3e28cf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":303,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:59:31
30969	9d6944ec-36e9-418b-bdda-e5be0c4fe65c	9d6944ec-af93-440d-9280-66b34142f142	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:08:54
30970	9d6944ec-a42b-4402-870b-aa05c95211d0	9d6944ec-af93-440d-9280-66b34142f142	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"207.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:08:54
30971	9d6944ec-a4d6-4470-b041-f8ee76c152f6	9d6944ec-af93-440d-9280-66b34142f142	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:08:54
30972	9d6944ec-acff-470f-9d36-ea65138f8800	9d6944ec-af93-440d-9280-66b34142f142	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 16:08:54
30973	9d6944ec-adac-4751-b9ea-8b9dfe69f59c	9d6944ec-af93-440d-9280-66b34142f142	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":772,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:08:54
32695	9d698293-161a-4bd2-904a-7be3ef588189	9d698293-43fe-4ca4-891a-e500b21777e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 19:01:18
32696	9d698293-39c7-4683-bb03-e671862e9a14	9d698293-43fe-4ca4-891a-e500b21777e4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"54.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 19:01:18
32697	9d698293-3a53-4775-aa83-909532cd3d0c	9d698293-43fe-4ca4-891a-e500b21777e4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 19:01:18
32698	9d698293-4190-4dac-aef8-911d582708a8	9d698293-43fe-4ca4-891a-e500b21777e4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 19:01:18
32699	9d698293-423c-40f3-98be-79d7e491e170	9d698293-43fe-4ca4-891a-e500b21777e4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":351,"memory":22,"hostname":"EderCortes"}	2024-11-04 19:01:18
40733	9d6cc6ca-de54-4763-8f5b-f606ed01a2d9	9d6cc6cb-2774-4c29-a186-bbfa55afee2c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 09:59:32
40734	9d6cc6cb-222e-4617-8db3-f0a56fd2a25f	9d6cc6cb-2774-4c29-a186-bbfa55afee2c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"155.75","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:59:32
40735	9d6cc6cb-260d-4350-8ae0-d63f0c05968d	9d6cc6cb-2774-4c29-a186-bbfa55afee2c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 09:59:32
40736	9d6cc6cb-266f-4051-89cf-6f67ef714b32	9d6cc6cb-2774-4c29-a186-bbfa55afee2c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":420,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:59:32
32700	9d698293-dd12-4c27-a1bc-8f68599dc310	9d698294-0b38-43e7-9751-cc91790e999d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 19:01:18
32701	9d698294-04d0-4c08-a6a7-f13fb8b09f5a	9d698294-0b38-43e7-9751-cc91790e999d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"57.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 19:01:18
32702	9d698294-0537-4434-9e6c-29041e372d59	9d698294-0b38-43e7-9751-cc91790e999d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 19:01:18
32703	9d698294-09ab-49eb-a822-f9f3445e5dc2	9d698294-0b38-43e7-9751-cc91790e999d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 19:01:18
32704	9d698294-0a0c-4e3f-8209-ad8058d2bce4	9d698294-0b38-43e7-9751-cc91790e999d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":421,"memory":22,"hostname":"EderCortes"}	2024-11-04 19:01:18
41255	9d6ccc1e-8668-461a-adf4-95109f63d297	9d6ccc1e-d754-4d18-9f74-cd63bf378ae0	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:14:25
41256	9d6ccc1e-d364-4b7d-8c90-3d2452584e6f	9d6ccc1e-d754-4d18-9f74-cd63bf378ae0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:14:26
41257	9d6ccc1e-d519-4da5-ada4-aff884b9c372	9d6ccc1e-d754-4d18-9f74-cd63bf378ae0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":515,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:14:26
37795	9d6b5c21-50f3-420f-adc6-a061b6765c31	9d6b5c21-7744-4053-97b3-daaf8c126f7c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 17:05:27
37796	9d6b5c21-74f7-4f92-9da1-3c4151d86572	9d6b5c21-7744-4053-97b3-daaf8c126f7c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:05:27
37797	9d6b5c21-7606-43db-9c20-23bbb946dd19	9d6b5c21-7744-4053-97b3-daaf8c126f7c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":328,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:05:27
37798	9d6b5c21-e1fb-4da0-8939-7c9e1ff2fa99	9d6b5c22-00b4-48e8-9977-40c8dba67fe8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:05:27
37799	9d6b5c21-f857-482f-9061-135fdca58d4b	9d6b5c22-00b4-48e8-9977-40c8dba67fe8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 87\\n                        ","time":"43.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"309a6eff5ebe9f2d91248732844dd9ed","hostname":"EderCortes"}	2024-11-05 17:05:27
37800	9d6b5c21-fb08-477a-be48-ac1cf6e44f18	9d6b5c22-00b4-48e8-9977-40c8dba67fe8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '87' order by \\"item_loans\\".\\"id\\" asc","time":"2.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":304,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-05 17:05:27
37801	9d6b5c21-ff72-4f40-9be3-baf24f9052ee	9d6b5c22-00b4-48e8-9977-40c8dba67fe8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:05:27
37802	9d6b5c21-ffba-455c-ae33-8934ef4f3b16	9d6b5c22-00b4-48e8-9977-40c8dba67fe8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/87","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":87,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"620000","loans_pago_interes":"155000","user_alias":"juan_jaramillo"},"items":[{"id":341,"loans_codigo":87,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 20:50:52","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000","user_alias":"eder.cortes"},{"id":342,"loans_codigo":87,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 21:01:12","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":445,"loans_codigo":87,"itemloans_cuota":"3","itemloans_valor_cuota":"160000","itemloans_iteres":"40000","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 21:01:12","updated_at":"2024-11-05 16:23:50","deleted_at":null,"item_loans_cuando_pago":"2024-11-05 00:00:00","itemloans_interes_canelado":"40000","itemloans_cuota_cancelada":"160000","user_alias":"eder.cortes"},{"id":485,"loans_codigo":87,"itemloans_cuota":"4","itemloans_valor_cuota":"240000","itemloans_iteres":"60000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-05 16:23:50","updated_at":"2024-11-05 16:23:50","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":486,"loans_codigo":87,"itemloans_cuota":"5","itemloans_valor_cuota":"240000","itemloans_iteres":"60000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-21 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-05 16:23:50","updated_at":"2024-11-05 16:23:50","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":284,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:05:27
38023	9d6b5e83-c920-4120-af04-d49f6d4a6bbe	9d6b5e83-e8bd-492c-a51a-b6d3595374be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 17:12:07
38024	9d6b5e83-e6ab-4156-8399-57fb6c4f942a	9d6b5e83-e8bd-492c-a51a-b6d3595374be	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 17:12:07
38025	9d6b5e83-e782-4124-a30a-ecfadf3de30a	9d6b5e83-e8bd-492c-a51a-b6d3595374be	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:12:07
37803	9d6b5c24-4511-4ce7-bbd1-23b6ac17c72e	9d6b5c24-8d37-4d2a-ab77-e123e6354911	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:05:29
37804	9d6b5c24-87d7-46a2-95ad-a5ec24caee79	9d6b5c24-8d37-4d2a-ab77-e123e6354911	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"147.41","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:05:29
37805	9d6b5c24-8828-43ad-89a8-2d0a3f17b3dd	9d6b5c24-8d37-4d2a-ab77-e123e6354911	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:05:29
37806	9d6b5c24-8be8-4803-a884-2f3db3f1078b	9d6b5c24-8d37-4d2a-ab77-e123e6354911	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:05:29
37807	9d6b5c24-8c2c-403a-a723-5805cc9496dd	9d6b5c24-8d37-4d2a-ab77-e123e6354911	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":414,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:05:29
38026	9d6b5e84-421d-4641-b261-37fab14a6efe	9d6b5e84-5f3a-4558-b6c6-50714f87b1fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 17:12:07
38027	9d6b5e84-5a4d-4196-94e5-9858960a243f	9d6b5e84-5f3a-4558-b6c6-50714f87b1fd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"45.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:12:07
38028	9d6b5e84-5dd4-4b3d-a7ad-ab1c0cedcc87	9d6b5e84-5f3a-4558-b6c6-50714f87b1fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 17:12:07
38029	9d6b5e84-5e3f-4e80-84f5-cc1a51d2008a	9d6b5e84-5f3a-4558-b6c6-50714f87b1fd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:12:07
38030	9d6b5e84-b9cd-4c75-9619-9c06c60fe316	9d6b5e84-da08-4a03-89df-ad15f48aa028	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 17:12:08
38031	9d6b5e84-d3d4-49c6-a970-54f7d88ab7c0	9d6b5e84-da08-4a03-89df-ad15f48aa028	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:12:08
38032	9d6b5e84-d426-44ec-8a78-1a93c040d62c	9d6b5e84-da08-4a03-89df-ad15f48aa028	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:12:08
38033	9d6b5e84-d884-4a45-a025-de9bdc83de5b	9d6b5e84-da08-4a03-89df-ad15f48aa028	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 17:12:08
38034	9d6b5e84-d8df-4fd5-b68a-9f6fee447062	9d6b5e84-da08-4a03-89df-ad15f48aa028	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":298,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:12:08
38035	9d6b5e85-1e74-4e9b-b21b-40efb7cc3589	9d6b5e85-666e-474b-9638-316eb24d27de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 17:12:08
38036	9d6b5e85-613e-4901-a83a-3bec4a77dfd5	9d6b5e85-666e-474b-9638-316eb24d27de	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"147.42","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:12:08
38037	9d6b5e85-618b-488b-9d9a-98a8a2956b52	9d6b5e85-666e-474b-9638-316eb24d27de	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:12:08
38038	9d6b5e85-6508-4e23-96f7-eb52747b288b	9d6b5e85-666e-474b-9638-316eb24d27de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 17:12:08
38039	9d6b5e85-654c-4c99-9af2-57bbe5ac4a83	9d6b5e85-666e-474b-9638-316eb24d27de	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:12:08
38040	9d6b5e87-16fb-4ffd-8459-f097787ef525	9d6b5e87-3646-498e-8b8d-bc863f8b35aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 17:12:09
38041	9d6b5e87-3090-4244-b497-376205f1d789	9d6b5e87-3646-498e-8b8d-bc863f8b35aa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:12:09
38042	9d6b5e87-30ea-4160-ad20-8484e001e2f5	9d6b5e87-3646-498e-8b8d-bc863f8b35aa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:12:09
38043	9d6b5e87-349a-4f50-90bf-fb0841f23fce	9d6b5e87-3646-498e-8b8d-bc863f8b35aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-05 17:12:09
38044	9d6b5e87-3515-4d61-8daf-5225e26887d2	9d6b5e87-3646-498e-8b8d-bc863f8b35aa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":306,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:12:09
31133	9d69465e-dd5e-4970-91db-3a6c363a317b	9d69465f-0fd4-4f15-bfa8-1ed29d64624d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:12:57
31134	9d69465f-0ce5-4577-9e62-348f0b153359	9d69465f-0fd4-4f15-bfa8-1ed29d64624d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:12:57
31135	9d69465f-0e21-44d1-9a40-96efb16e2dca	9d69465f-0fd4-4f15-bfa8-1ed29d64624d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":418,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:12:57
31136	9d69465f-bc5a-41cd-81d1-27221855e953	9d69465f-f4c3-4bd5-8fad-4a8e95d04b3f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:12:58
31137	9d69465f-e3a0-4ae9-9e97-919bef25a42f	9d69465f-f4c3-4bd5-8fad-4a8e95d04b3f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"73.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 16:12:58
31138	9d69465f-ea0b-4088-98e3-0cddfa5bb91e	9d69465f-f4c3-4bd5-8fad-4a8e95d04b3f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '92' order by \\"item_loans\\".\\"id\\" asc","time":"3.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 16:12:58
31139	9d69465f-ea59-4a1f-a56c-deac4cd97ea1	9d69465f-f4c3-4bd5-8fad-4a8e95d04b3f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":15,"hostname":"EderCortes"}	2024-11-04 16:12:58
31140	9d69465f-f283-4db2-9558-a0ff11158f24	9d69465f-f4c3-4bd5-8fad-4a8e95d04b3f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:12:58
31141	9d69465f-f33c-4af7-a9c3-de1ce5267461	9d69465f-f4c3-4bd5-8fad-4a8e95d04b3f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":92,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":15,"loans_valor_prestado":8000009,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0","user_alias":"eder.cortes"},"items":[{"id":379,"loans_codigo":92,"itemloans_cuota":"1","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":380,"loans_codigo":92,"itemloans_cuota":"2","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":381,"loans_codigo":92,"itemloans_cuota":"3","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":382,"loans_codigo":92,"itemloans_cuota":"4","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":383,"loans_codigo":92,"itemloans_cuota":"5","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":384,"loans_codigo":92,"itemloans_cuota":"6","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":385,"loans_codigo":92,"itemloans_cuota":"7","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":386,"loans_codigo":92,"itemloans_cuota":"8","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":387,"loans_codigo":92,"itemloans_cuota":"9","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-15 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":388,"loans_codigo":92,"itemloans_cuota":"10","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":389,"loans_codigo":92,"itemloans_cuota":"11","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-31 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":390,"loans_codigo":92,"itemloans_cuota":"12","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":391,"loans_codigo":92,"itemloans_cuota":"13","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-16 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":392,"loans_codigo":92,"itemloans_cuota":"14","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":393,"loans_codigo":92,"itemloans_cuota":"15","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T21:10:11.000000Z","updated_at":"2024-11-04T21:10:11.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":489,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:12:58
31142	9d694660-c165-40b1-9281-89aebd85f0ba	9d694661-6433-4cf9-bff2-d2142c0b6ffa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:12:58
31143	9d694661-5976-4b29-9d03-395222347485	9d694661-6433-4cf9-bff2-d2142c0b6ffa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"305.18","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:12:59
31144	9d694661-5a2d-4982-959c-6fd9c3c7d545	9d694661-6433-4cf9-bff2-d2142c0b6ffa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:12:59
31145	9d694661-6220-4be7-a8ce-f4e369f4c24e	9d694661-6433-4cf9-bff2-d2142c0b6ffa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:12:59
31146	9d694661-62bb-49c5-b90d-1c52c330ff58	9d694661-6433-4cf9-bff2-d2142c0b6ffa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":918,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:12:59
31147	9d694662-5975-4c1b-a8f1-17ede2eff7ae	9d694662-c7db-4a1a-9aba-6343da0dc800	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:12:59
31148	9d694662-bf6b-4c4a-99fb-a8de6757b0c9	9d694662-c7db-4a1a-9aba-6343da0dc800	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"222.28","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:13:00
31149	9d694662-bffa-4bd7-be73-ebe5298675dc	9d694662-c7db-4a1a-9aba-6343da0dc800	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:13:00
31150	9d694662-c5d5-4022-bc6c-2680587ae1a4	9d694662-c7db-4a1a-9aba-6343da0dc800	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 16:13:00
31151	9d694662-c655-42e3-8118-39f7fbfb72ae	9d694662-c7db-4a1a-9aba-6343da0dc800	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":778,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:13:00
29712	9d692a9d-7c3b-4fde-83be-046484586b80	9d692a9d-c26f-4a36-9087-144c2e5e5020	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 14:55:20
29713	9d692a9d-c0c3-42e5-98d3-670c13896a44	9d692a9d-c26f-4a36-9087-144c2e5e5020	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 14:55:21
29714	9d692a9d-c176-450e-aa10-ffc82a26cc5b	9d692a9d-c26f-4a36-9087-144c2e5e5020	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":343,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:55:21
29715	9d692a9e-18b8-4da4-9138-e3627aaf4ad2	9d692a9e-39b5-4062-9690-d9674a38782c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 14:55:21
29716	9d692a9e-30a7-4016-9f6c-6c0ed0e72c42	9d692a9e-39b5-4062-9690-d9674a38782c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"48.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 14:55:21
29717	9d692a9e-3464-4561-80d2-d2df64101832	9d692a9e-39b5-4062-9690-d9674a38782c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 14:55:21
29718	9d692a9e-349f-4458-91f2-d9c6726abf01	9d692a9e-39b5-4062-9690-d9674a38782c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 14:55:21
29719	9d692a9e-3893-4e6d-8bc3-1d6fd46a22fc	9d692a9e-39b5-4062-9690-d9674a38782c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 14:55:21
29720	9d692a9e-38da-4ad1-810e-48dd645daf7b	9d692a9e-39b5-4062-9690-d9674a38782c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:55:21
41425	9d6ccc8f-b369-4425-9d90-59a284a2d94c	9d6ccc8f-cdf6-41a1-a04a-223ab9892011	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:15:39
41426	9d6ccc8f-cc3d-431d-aaf5-5fbd11043935	9d6ccc8f-cdf6-41a1-a04a-223ab9892011	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:15:40
32829	9d69a62c-18bc-4f7e-a4a5-34b021837194	9d69a62c-6ffa-47d1-82ed-d278caea745d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 20:40:50
32830	9d69a62c-6bfe-4dfd-95af-042288c54907	9d69a62c-6ffa-47d1-82ed-d278caea745d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 20:40:50
32831	9d69a62c-6e1e-463f-938f-b5821a31321e	9d69a62c-6ffa-47d1-82ed-d278caea745d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":710,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:40:50
32832	9d69a62d-5104-490a-85ad-af1334ec17a3	9d69a62d-8b0d-4f69-9ddf-1517fe17eced	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 20:40:51
32833	9d69a62d-7e13-42a2-a29d-a10afb4e6c87	9d69a62d-8b0d-4f69-9ddf-1517fe17eced	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"68.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":227,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 20:40:51
32834	9d69a62d-7eae-477e-87af-cdeeda20bda0	9d69a62d-8b0d-4f69-9ddf-1517fe17eced	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 20:40:51
32835	9d69a62d-88c9-46d7-b18c-5af900a4b34b	9d69a62d-8b0d-4f69-9ddf-1517fe17eced	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 20:40:51
32836	9d69a62d-8961-48df-9530-8a7ab31190f2	9d69a62d-8b0d-4f69-9ddf-1517fe17eced	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":578,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:40:51
41428	9d6ccc90-35ea-4630-9d67-d19c5071be40	9d6ccc90-520c-4265-81a9-c1fba964ce71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:15:40
41429	9d6ccc90-4d8e-4e90-9ec5-ef4160fbe1cc	9d6ccc90-520c-4265-81a9-c1fba964ce71	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"43.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 10:15:40
41430	9d6ccc90-50b2-407b-b892-38f4f85cd378	9d6ccc90-520c-4265-81a9-c1fba964ce71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:15:40
41431	9d6ccc90-511f-40ba-9948-40d9fa2ec417	9d6ccc90-520c-4265-81a9-c1fba964ce71	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:40
32837	9d69a62e-4242-4837-95ce-ae7cd038f219	9d69a62e-7d67-47fd-bd67-f8b4bffd5ef1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 20:40:51
32838	9d69a62e-7190-4f61-9f02-c737c0f481f6	9d69a62e-7d67-47fd-bd67-f8b4bffd5ef1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"72.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":216,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 20:40:51
32839	9d69a62e-7230-4819-a72d-bd407cdcce92	9d69a62e-7d67-47fd-bd67-f8b4bffd5ef1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 20:40:51
32840	9d69a62e-7b40-45d5-923a-0fde7d7e11d5	9d69a62e-7d67-47fd-bd67-f8b4bffd5ef1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 20:40:51
32841	9d69a62e-7bd2-4746-a175-7c7ddf82402d	9d69a62e-7d67-47fd-bd67-f8b4bffd5ef1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":507,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:40:51
41432	9d6ccc90-a0ff-400e-b455-b0e24e1c49d6	9d6ccc90-e9e6-4bce-9020-45a913241460	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:15:40
41433	9d6ccc90-e496-4bb1-bb3f-76e8fea18a3c	9d6ccc90-e9e6-4bce-9020-45a913241460	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"147.13","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:15:40
41434	9d6ccc90-e4e7-4698-a72f-988b15733b1a	9d6ccc90-e9e6-4bce-9020-45a913241460	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:15:40
41435	9d6ccc90-e89f-48d9-96c2-dc2f9a814adb	9d6ccc90-e9e6-4bce-9020-45a913241460	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:15:40
41436	9d6ccc90-e8e7-4abf-8a35-1fafeccd46b8	9d6ccc90-e9e6-4bce-9020-45a913241460	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":379,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:40
32842	9d69a62f-17b6-48bf-b7c5-d09e2f6e4a62	9d69a62f-5426-444c-a9ee-cd16c839bcc9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 20:40:52
32843	9d69a62f-4812-4077-ac22-a1871d4ec2cb	9d69a62f-5426-444c-a9ee-cd16c839bcc9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"75.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 20:40:52
32844	9d69a62f-48c6-49fe-9626-dad7b7980e3e	9d69a62f-5426-444c-a9ee-cd16c839bcc9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 20:40:52
32845	9d69a62f-51ee-4be2-b9cc-3c34e2040042	9d69a62f-5426-444c-a9ee-cd16c839bcc9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 20:40:52
32846	9d69a62f-5289-4639-97df-baaef4c7b1b4	9d69a62f-5426-444c-a9ee-cd16c839bcc9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":523,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:40:52
41437	9d6ccc91-2c3b-4485-9e89-3be3d437d893	9d6ccc91-76c1-45b2-b31e-98b22d79d412	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:15:40
41438	9d6ccc91-7084-4976-873c-af2ea075e1bb	9d6ccc91-76c1-45b2-b31e-98b22d79d412	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"149.49","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:15:41
41439	9d6ccc91-70f7-48fa-ab0a-2c48c823cb80	9d6ccc91-76c1-45b2-b31e-98b22d79d412	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:15:41
41440	9d6ccc91-7518-445b-85fe-8ecc71349221	9d6ccc91-76c1-45b2-b31e-98b22d79d412	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:15:41
41441	9d6ccc91-7570-42ec-a7f7-ef0c7d0c7f72	9d6ccc91-76c1-45b2-b31e-98b22d79d412	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:41
32847	9d69a630-0c22-468d-bc63-590974e9f0f5	9d69a630-4f26-48b1-95e6-db007c2204de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 20:40:52
32848	9d69a630-42ae-457a-a714-3960e32de95c	9d69a630-4f26-48b1-95e6-db007c2204de	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"90.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 20:40:53
32849	9d69a630-434b-44cb-b0f9-84b982d58e44	9d69a630-4f26-48b1-95e6-db007c2204de	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 20:40:53
32850	9d69a630-4ca3-45b8-8d1a-cc330c067db8	9d69a630-4f26-48b1-95e6-db007c2204de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 20:40:53
32851	9d69a630-4d87-4f4c-a27c-1e1943a18ef7	9d69a630-4f26-48b1-95e6-db007c2204de	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":618,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:40:53
41442	9d6ccc93-17ed-4ce0-8b4a-399209c33170	9d6ccc93-679b-4c4b-a3ad-6377d855acc6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:15:42
41443	9d6ccc93-5fa3-468d-9ad2-b8bc42f200b9	9d6ccc93-679b-4c4b-a3ad-6377d855acc6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"150.67","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:15:42
41444	9d6ccc93-6018-49d6-97a6-bdd6323bb240	9d6ccc93-679b-4c4b-a3ad-6377d855acc6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:15:42
41445	9d6ccc93-6601-4f05-a5b3-c6d92b0e0e99	9d6ccc93-679b-4c4b-a3ad-6377d855acc6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:15:42
41446	9d6ccc93-6667-47d3-879c-92149b519eb7	9d6ccc93-679b-4c4b-a3ad-6377d855acc6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":474,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:42
32852	9d69a630-fb4e-40fd-8405-80ae882eaf30	9d69a631-64ff-43b4-80ed-b9a4fea0fe8e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 20:40:53
32853	9d69a631-58f7-418d-b604-c5f7cf429e29	9d69a631-64ff-43b4-80ed-b9a4fea0fe8e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"189.68","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 20:40:53
32854	9d69a631-59d0-42bd-a2b6-2bd58edc3d0d	9d69a631-64ff-43b4-80ed-b9a4fea0fe8e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 20:40:53
32855	9d69a631-62a5-412e-a4b9-7c3cdacae317	9d69a631-64ff-43b4-80ed-b9a4fea0fe8e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 20:40:53
32856	9d69a631-6342-4924-97c1-318551d4ed7c	9d69a631-64ff-43b4-80ed-b9a4fea0fe8e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":682,"memory":22,"hostname":"EderCortes"}	2024-11-04 20:40:53
41447	9d6ccc93-c32c-4be5-b62a-bbb271acc268	9d6ccc94-0c3f-4201-9958-a574c4781b71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:15:42
41448	9d6ccc94-06d0-46a3-9fa8-86aacb963f4f	9d6ccc94-0c3f-4201-9958-a574c4781b71	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"157.43","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:15:42
41449	9d6ccc94-0ad4-43d8-8f21-c04482b9331b	9d6ccc94-0c3f-4201-9958-a574c4781b71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:15:42
41450	9d6ccc94-0b2a-42c0-b983-ddc7bc473eea	9d6ccc94-0c3f-4201-9958-a574c4781b71	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":403,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:42
38197	9d6b6028-243a-4006-a4cb-74a8a8930780	9d6b6028-469c-4991-bcb3-a65b06d649c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 17:16:43
38198	9d6b6028-44e2-4377-8b84-e59191107704	9d6b6028-469c-4991-bcb3-a65b06d649c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-05 17:16:43
38199	9d6b6028-4599-44f9-b12c-db1c8eca3889	9d6b6028-469c-4991-bcb3-a65b06d649c9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":314,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:16:43
15948	9d64b66b-1aca-4729-93b0-cf3761451c5d	9d64b66b-1ed6-4fa5-8947-e120c414b76a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":732}	2024-11-02 09:47:07
25863	9d68c9fb-1aa8-4494-a310-907cfe636630	9d68c9fb-74d4-484e-b305-7195bc13b8ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 10:25:08
25864	9d68c9fb-7284-4035-991a-ec5c09a4e698	9d68c9fb-74d4-484e-b305-7195bc13b8ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 10:25:08
25865	9d68c9fb-7385-4d63-99c1-3d0e82c6c796	9d68c9fb-74d4-484e-b305-7195bc13b8ea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":731,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:25:08
25867	9d68c9fc-62b5-43bb-a4d1-b649cb3fb7d1	9d68c9fc-6fed-45c6-ab2e-6cafe11f9345	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 90\\n                        ","time":"57.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"93c10371e33ace24260de21c3ff3890d","hostname":"EderCortes"}	2024-11-04 10:25:09
25868	9d68c9fc-6875-4f6a-84f0-ab1650c1ed88	9d68c9fc-6fed-45c6-ab2e-6cafe11f9345	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '90' order by \\"item_loans\\".\\"id\\" asc","time":"3.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 10:25:09
25869	9d68c9fc-68c5-41ed-a859-12c52a8e8b86	9d68c9fc-6fed-45c6-ab2e-6cafe11f9345	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":5,"hostname":"EderCortes"}	2024-11-04 10:25:09
25870	9d68c9fc-6de6-43eb-83b9-a62eb133ce1a	9d68c9fc-6fed-45c6-ab2e-6cafe11f9345	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 10:25:09
25871	9d68c9fc-6e6e-48ff-aafb-c041e833f5d7	9d68c9fc-6fed-45c6-ab2e-6cafe11f9345	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/90","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":90,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000"},"items":[{"id":356,"loans_codigo":90,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T14:50:43.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":357,"loans_codigo":90,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":358,"loans_codigo":90,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":359,"loans_codigo":90,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"},{"id":360,"loans_codigo":90,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:00:29.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000"}]}},"duration":540,"memory":22,"hostname":"EderCortes"}	2024-11-04 10:25:09
38200	9d6b6028-a8ce-4ada-937d-90b2c0582412	9d6b6028-c69b-422c-9f1e-dd08f05f742e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-05 17:16:43
38201	9d6b6028-c1f8-4b16-b1fd-93889fcc4998	9d6b6028-c69b-422c-9f1e-dd08f05f742e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"47.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:16:43
38202	9d6b6028-c4d8-4245-aa5b-56128b8cf494	9d6b6028-c69b-422c-9f1e-dd08f05f742e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-05 17:16:43
38203	9d6b6028-c570-4a61-9655-9753c2d9909f	9d6b6028-c69b-422c-9f1e-dd08f05f742e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":260,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:16:43
41451	9d6ccc94-5dcb-427d-8d73-3b4ea5f0ba28	9d6ccc94-628c-4152-b71d-2ba81c622608	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":184,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:43
38204	9d6b6029-1f5f-4a9c-9f7c-bf242c422a06	9d6b6029-401f-4501-b971-e26added434d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-05 17:16:43
38205	9d6b6029-3a3c-4005-9b09-b2cc4665f741	9d6b6029-401f-4501-b971-e26added434d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:16:43
38206	9d6b6029-3a93-4ff5-9f5e-11305c017e48	9d6b6029-401f-4501-b971-e26added434d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:16:43
38207	9d6b6029-3ead-40cb-af5d-7a236dc26c2e	9d6b6029-401f-4501-b971-e26added434d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-05 17:16:43
38208	9d6b6029-3f18-43aa-b1a0-794e83952f7e	9d6b6029-401f-4501-b971-e26added434d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":295,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:16:43
41452	9d6ccc94-f469-41b2-8546-24779c619996	9d6ccc95-1219-48c1-be45-ae560c95af73	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:15:43
41453	9d6ccc95-0d3f-4799-87eb-5b795a2c2e94	9d6ccc95-1219-48c1-be45-ae560c95af73	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"45.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 10:15:43
41454	9d6ccc95-106b-4b3f-9441-19e9145bda61	9d6ccc95-1219-48c1-be45-ae560c95af73	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 10:15:43
41455	9d6ccc95-10e3-4e7f-8163-9bce75617a27	9d6ccc95-1219-48c1-be45-ae560c95af73	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":257,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:43
33328	9d69af94-f7ba-4568-9931-325fde9db530	9d69af95-3531-48bf-891e-37c3922e7e9f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 21:07:09
33329	9d69af95-313d-49ea-b6ce-3793e81e8960	9d69af95-3531-48bf-891e-37c3922e7e9f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:07:09
33330	9d69af95-3310-4f85-a96b-0360e9e39b9d	9d69af95-3531-48bf-891e-37c3922e7e9f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":493,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:07:09
38209	9d6b6029-8602-4a84-b0af-415a91d058e0	9d6b6029-a882-4c1c-90d1-47d272153ffb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-05 17:16:43
38210	9d6b6029-a2b8-40b0-bf11-0feac329013f	9d6b6029-a882-4c1c-90d1-47d272153ffb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:16:44
38211	9d6b6029-a30b-4e85-bbb7-ffcdb7670831	9d6b6029-a882-4c1c-90d1-47d272153ffb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:16:44
38212	9d6b6029-a731-4e1a-b37f-772853a709e4	9d6b6029-a882-4c1c-90d1-47d272153ffb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-05 17:16:44
31296	9d6949f7-6a02-4577-87e7-e55912e77fd5	9d6949f7-b36d-4d39-b0a1-ad430791accc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:23:00
31297	9d6949f7-b1f1-4c49-a5f9-37c5c0a106fb	9d6949f7-b36d-4d39-b0a1-ad430791accc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:23:00
31298	9d6949f7-b289-4af6-a0a0-8f193345a8c7	9d6949f7-b36d-4d39-b0a1-ad430791accc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":433,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:23:00
33331	9d69af95-d880-4834-87d7-9dcb527a8321	9d69af96-2ad4-414b-92bb-5d51b7f1edab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:07:09
33332	9d69af96-2125-4451-a873-f5514aaa3c37	9d69af96-2ad4-414b-92bb-5d51b7f1edab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 86\\n                        ","time":"167.44","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"6815ad365c5e82c8fb55476c5a77f0b5","hostname":"EderCortes"}	2024-11-04 21:07:09
33333	9d69af96-2458-4d03-b663-df451a5c9a05	9d69af96-2ad4-414b-92bb-5d51b7f1edab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '86' order by \\"item_loans\\".\\"id\\" asc","time":"2.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:07:09
33334	9d69af96-2973-4436-9b06-39667d84e96e	9d69af96-2ad4-414b-92bb-5d51b7f1edab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:07:09
33335	9d69af96-29c8-4699-871c-37b554b802d4	9d69af96-2ad4-414b-92bb-5d51b7f1edab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/86","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":86,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"220000","loans_pago_interes":"55000","user_alias":"eder.cortes"},"items":[{"id":336,"loans_codigo":86,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 21:03:40","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000","user_alias":"eder.cortes"},{"id":337,"loans_codigo":86,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":338,"loans_codigo":86,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":339,"loans_codigo":86,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":340,"loans_codigo":86,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":496,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:07:09
38213	9d6b6029-a77d-45fd-85bd-f36f87d21d70	9d6b6029-a882-4c1c-90d1-47d272153ffb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:16:44
33336	9d69af98-8209-481c-b5a4-d297fbdae54f	9d69af98-a73f-4cb1-b15e-868274814d75	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:07:11
33337	9d69af98-a08a-4e3f-bd7d-14cebf5bad53	9d69af98-a73f-4cb1-b15e-868274814d75	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"53.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:07:11
33338	9d69af98-a0fc-47cc-840a-46c02238dc76	9d69af98-a73f-4cb1-b15e-868274814d75	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:07:11
33339	9d69af98-a582-4051-b463-659dee13801e	9d69af98-a73f-4cb1-b15e-868274814d75	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:07:11
33340	9d69af98-a5eb-424c-9db0-4eba9723a1f1	9d69af98-a73f-4cb1-b15e-868274814d75	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":360,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:07:11
38214	9d6b602b-77ae-4570-bd30-68a2e66bf8dc	9d6b602b-9723-4b35-ac73-5bf8acbe1827	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-05 17:16:45
38215	9d6b602b-9130-4d4f-8ea6-5c091850ba48	9d6b602b-9723-4b35-ac73-5bf8acbe1827	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:16:45
38216	9d6b602b-917a-4510-a42d-79bfa2383894	9d6b602b-9723-4b35-ac73-5bf8acbe1827	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:16:45
38217	9d6b602b-95d5-4f67-a3e9-2337dd7b2ed3	9d6b602b-9723-4b35-ac73-5bf8acbe1827	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-05 17:16:45
38218	9d6b602b-961e-49ff-b380-aa3204d2bf32	9d6b602b-9723-4b35-ac73-5bf8acbe1827	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":360,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:16:45
33341	9d69afa2-1306-4861-b02b-fe4ea6ed584c	9d69afa2-16d8-4f96-9a80-38be30b14542	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":159,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:07:17
33356	9d69afa3-4412-4799-8587-9634eb7e771a	9d69afa3-6195-4040-84d6-9cc05356c7d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:07:18
33357	9d69afa3-59a4-4afc-b593-2d6c7266a227	9d69afa3-6195-4040-84d6-9cc05356c7d8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 86\\n                        ","time":"41.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"6815ad365c5e82c8fb55476c5a77f0b5","hostname":"EderCortes"}	2024-11-04 21:07:18
33358	9d69afa3-5cd5-4a37-b25c-35185bb6b03c	9d69afa3-6195-4040-84d6-9cc05356c7d8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '86' order by \\"item_loans\\".\\"id\\" asc","time":"2.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:07:18
33359	9d69afa3-6019-4697-a6be-58cdc806d6b2	9d69afa3-6195-4040-84d6-9cc05356c7d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:07:18
33360	9d69afa3-6068-4929-b4c1-10753e54e0a2	9d69afa3-6195-4040-84d6-9cc05356c7d8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/86","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":86,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"220000","loans_pago_interes":"55000","user_alias":"eder.cortes"},"items":[{"id":336,"loans_codigo":86,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 21:03:40","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000","user_alias":"eder.cortes"},{"id":337,"loans_codigo":86,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":338,"loans_codigo":86,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":339,"loans_codigo":86,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":340,"loans_codigo":86,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:07:18
33361	9d69b145-d991-42f2-b7de-134e4923fc64	9d69b145-e028-4429-ad1c-a9310a068187	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":227,"memory":20,"hostname":"EderCortes"}	2024-11-04 21:11:52
33376	9d69b146-f187-4727-8870-bc599e69d4c7	9d69b147-1659-49f5-a498-a1004b297626	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:11:53
33377	9d69b147-0c1d-45e1-ac70-2e126a10b2e4	9d69b147-1659-49f5-a498-a1004b297626	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 86\\n                        ","time":"52.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"6815ad365c5e82c8fb55476c5a77f0b5","hostname":"EderCortes"}	2024-11-04 21:11:53
33378	9d69b147-0fbd-4989-91bc-f35d266c2665	9d69b147-1659-49f5-a498-a1004b297626	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '86' order by \\"item_loans\\".\\"id\\" asc","time":"3.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:11:53
33379	9d69b147-1488-4c3b-99f0-3f614e568241	9d69b147-1659-49f5-a498-a1004b297626	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:11:53
33380	9d69b147-14ea-430a-9755-967c7dbb3298	9d69b147-1659-49f5-a498-a1004b297626	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/86","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":86,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"220000","loans_pago_interes":"55000","user_alias":"eder.cortes"},"items":[{"id":336,"loans_codigo":86,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 21:03:40","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000","user_alias":"eder.cortes"},{"id":337,"loans_codigo":86,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":338,"loans_codigo":86,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":339,"loans_codigo":86,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":340,"loans_codigo":86,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":360,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:11:53
33381	9d69b1a2-2c6d-47ad-8288-0b0f04d65fee	9d69b1a2-301a-40a3-925c-84910adf9684	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":190,"memory":20,"hostname":"EderCortes"}	2024-11-04 21:12:53
33396	9d69b1a3-55bf-4d24-b94f-51801acf08b7	9d69b1a3-9e34-4dd0-97d0-88fc49b5c5e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:12:53
33397	9d69b1a3-95b3-49d0-a628-a9732976880f	9d69b1a3-9e34-4dd0-97d0-88fc49b5c5e0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 86\\n                        ","time":"144.06","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"6815ad365c5e82c8fb55476c5a77f0b5","hostname":"EderCortes"}	2024-11-04 21:12:54
33398	9d69b1a3-98c7-4f73-9449-ff78076519ea	9d69b1a3-9e34-4dd0-97d0-88fc49b5c5e0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '86' order by \\"item_loans\\".\\"id\\" asc","time":"2.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:12:54
33399	9d69b1a3-9c63-4c7f-8717-20124614b692	9d69b1a3-9e34-4dd0-97d0-88fc49b5c5e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:12:54
33400	9d69b1a3-9ccc-45a8-8f01-9ac9a1293d2f	9d69b1a3-9e34-4dd0-97d0-88fc49b5c5e0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/86","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":86,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"220000","loans_pago_interes":"55000","user_alias":"eder.cortes"},"items":[{"id":336,"loans_codigo":86,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 21:03:40","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000","user_alias":"eder.cortes"},{"id":337,"loans_codigo":86,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":338,"loans_codigo":86,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":339,"loans_codigo":86,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":340,"loans_codigo":86,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":523,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:12:54
33401	9d69b1f9-1eb2-4698-9132-91d8c14cda61	9d69b1f9-227e-4cb9-8e36-a75974a29ea6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":177,"memory":20,"hostname":"EderCortes"}	2024-11-04 21:13:50
34749	9d69bf77-5d01-48e4-8684-e348d43e33f6	9d69bf77-a3cf-4517-9487-e0eb6af31cce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:51:33
34750	9d69bf77-a26a-4379-8954-62f90ef20c0b	9d69bf77-a3cf-4517-9487-e0eb6af31cce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:51:34
34751	9d69bf77-a300-46b9-9cbf-44bf9a3759ac	9d69bf77-a3cf-4517-9487-e0eb6af31cce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":358,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:51:34
34752	9d69bf77-ff3b-48be-b119-2facca415191	9d69bf78-4a36-4dcb-af0c-2ad6259a8f18	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:51:34
33416	9d69b1fa-1626-44c4-95d6-76ba92ea3584	9d69b1fa-3e63-4765-a269-b9dce5e95498	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:13:50
33417	9d69b1fa-3401-4716-9032-f9b36b2584d3	9d69b1fa-3e63-4765-a269-b9dce5e95498	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 86\\n                        ","time":"56.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"6815ad365c5e82c8fb55476c5a77f0b5","hostname":"EderCortes"}	2024-11-04 21:13:50
33418	9d69b1fa-3838-40ec-83f3-6650048f62d8	9d69b1fa-3e63-4765-a269-b9dce5e95498	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '86' order by \\"item_loans\\".\\"id\\" asc","time":"3.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:13:50
33419	9d69b1fa-3ccc-4311-b153-2d311f47d02b	9d69b1fa-3e63-4765-a269-b9dce5e95498	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:13:50
33420	9d69b1fa-3d2d-44f3-836a-5fdbd91ac3c8	9d69b1fa-3e63-4765-a269-b9dce5e95498	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/86","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":86,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"220000","loans_pago_interes":"55000","user_alias":"eder.cortes"},"items":[{"id":336,"loans_codigo":86,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 21:03:40","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000","user_alias":"eder.cortes"},{"id":337,"loans_codigo":86,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":338,"loans_codigo":86,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":339,"loans_codigo":86,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":340,"loans_codigo":86,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:13:50
34753	9d69bf78-4531-417f-a3b2-a34625c16575	9d69bf78-4a36-4dcb-af0c-2ad6259a8f18	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"153.09","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:51:34
34754	9d69bf78-459c-4c7d-a945-b1300500486c	9d69bf78-4a36-4dcb-af0c-2ad6259a8f18	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:51:34
34755	9d69bf78-4915-422b-b900-841657dcba1c	9d69bf78-4a36-4dcb-af0c-2ad6259a8f18	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 21:51:34
34756	9d69bf78-495e-46c2-a7a6-82e188e67d99	9d69bf78-4a36-4dcb-af0c-2ad6259a8f18	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":367,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:51:34
33421	9d69b28b-1fb8-4966-bd3e-3f29349f69b0	9d69b28b-2616-46d6-bfcb-3ab90ccb9483	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":233,"memory":20,"hostname":"EderCortes"}	2024-11-04 21:15:25
34757	9d69bf78-903d-4b82-8dd1-72ee4321692d	9d69bf78-ad35-41ee-a13c-58ca840c5088	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 21:51:34
34758	9d69bf78-a809-4bcd-8f1e-d6d7c98fea61	9d69bf78-ad35-41ee-a13c-58ca840c5088	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 21:51:34
34759	9d69bf78-a858-4467-a187-fc433f08edd8	9d69bf78-ad35-41ee-a13c-58ca840c5088	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 21:51:34
34760	9d69bf78-abfd-40bc-bd6f-f63b4af96f77	9d69bf78-ad35-41ee-a13c-58ca840c5088	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 21:51:34
34761	9d69bf78-ac47-403d-a6e6-5cc87f8ce179	9d69bf78-ad35-41ee-a13c-58ca840c5088	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:51:34
34762	9d69bf78-f4ba-4c4f-bcba-b077194ecf44	9d69bf79-1424-4310-934e-3b2bf49d5db6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 21:51:35
33436	9d69b28c-d721-44bd-ba1d-a07e5be02ea5	9d69b28d-03d8-43cc-82eb-94cc508d679e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:15:27
33437	9d69b28c-f3d9-44ea-9304-fa99282f5f0c	9d69b28d-03d8-43cc-82eb-94cc508d679e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 86\\n                        ","time":"60.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"6815ad365c5e82c8fb55476c5a77f0b5","hostname":"EderCortes"}	2024-11-04 21:15:27
33438	9d69b28c-fbed-4479-bfe3-d4f83e21640d	9d69b28d-03d8-43cc-82eb-94cc508d679e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '86' order by \\"item_loans\\".\\"id\\" asc","time":"11.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:15:27
33439	9d69b28d-01c5-498c-bd45-2858c634ade2	9d69b28d-03d8-43cc-82eb-94cc508d679e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:15:27
33440	9d69b28d-0258-42bf-9681-2fc05cb7123b	9d69b28d-03d8-43cc-82eb-94cc508d679e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/86","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":86,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"220000","loans_pago_interes":"55000","user_alias":"eder.cortes"},"items":[{"id":336,"loans_codigo":86,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 21:03:40","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000","user_alias":"eder.cortes"},{"id":337,"loans_codigo":86,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":338,"loans_codigo":86,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":339,"loans_codigo":86,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":340,"loans_codigo":86,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":384,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:15:27
34763	9d69bf79-0e66-458d-94a8-89925d8657ae	9d69bf79-1424-4310-934e-3b2bf49d5db6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:51:35
34764	9d69bf79-0ed3-4542-b3df-12ae07b54ac0	9d69bf79-1424-4310-934e-3b2bf49d5db6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:51:35
34765	9d69bf79-1310-40c5-a882-83c9606c38ae	9d69bf79-1424-4310-934e-3b2bf49d5db6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 21:51:35
34766	9d69bf79-1359-4ce3-b1ad-843337bcffb8	9d69bf79-1424-4310-934e-3b2bf49d5db6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:51:35
33441	9d69b2e7-90a6-4a54-a576-8a7a64937ad1	9d69b2e7-9474-48f3-89df-30ccd1b2d135	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":167,"memory":20,"hostname":"EderCortes"}	2024-11-04 21:16:26
34767	9d69bf79-5d30-438e-8ca9-c6cef01d131b	9d69bf79-7bd7-4c23-a48d-ccbdf8e13ea4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 21:51:35
34768	9d69bf79-7476-4451-ab9f-6a3c87c88cde	9d69bf79-7bd7-4c23-a48d-ccbdf8e13ea4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_valor_prestado\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\" from \\"loans\\" where \\"id\\" = '93' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"40.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":229,"hash":"f00e27e21a94f93c5c7a1d0cd56f9f13","hostname":"EderCortes"}	2024-11-04 21:51:35
34769	9d69bf79-74c8-4496-8b83-353f69e63411	9d69bf79-7bd7-4c23-a48d-ccbdf8e13ea4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 21:51:35
34770	9d69bf79-7677-428a-b57a-b6c51abf7f0e	9d69bf79-7bd7-4c23-a48d-ccbdf8e13ea4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"2.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":230,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 21:51:35
34771	9d69bf79-76b1-49a8-b2d8-606da7f29c19	9d69bf79-7bd7-4c23-a48d-ccbdf8e13ea4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 21:51:35
34772	9d69bf79-7a87-49f2-9393-be4b1833152e	9d69bf79-7bd7-4c23-a48d-ccbdf8e13ea4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 21:51:35
34773	9d69bf79-7ae0-4cc3-89e6-a5dd17e3781f	9d69bf79-7bd7-4c23-a48d-ccbdf8e13ea4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"user_creador":12,"user_cobrador":22,"user_customer":19,"user_recomendacion":18},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:19:45.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:22:30.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":399,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":400,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":401,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":402,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"}]}},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:51:35
34774	9d69bf7b-359d-4179-aaa8-c2dab63303f1	9d69bf7b-569c-46d9-9613-be67dd33627a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 21:51:36
33456	9d69b2e9-2acb-4ca3-a721-9d47a3a35e1f	9d69b2e9-4c3d-4167-b563-a54697256efd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:16:27
33457	9d69b2e9-43d4-43c3-95cf-16da7de13ec0	9d69b2e9-4c3d-4167-b563-a54697256efd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 86\\n                        ","time":"48.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"6815ad365c5e82c8fb55476c5a77f0b5","hostname":"EderCortes"}	2024-11-04 21:16:27
33458	9d69b2e9-470f-4259-b039-1033cab31f41	9d69b2e9-4c3d-4167-b563-a54697256efd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '86' order by \\"item_loans\\".\\"id\\" asc","time":"2.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:16:27
33459	9d69b2e9-4aa7-4670-b376-14ebfcdd6d1d	9d69b2e9-4c3d-4167-b563-a54697256efd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:16:27
33460	9d69b2e9-4b0c-4290-9131-dfd464000325	9d69b2e9-4c3d-4167-b563-a54697256efd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/86","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":86,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"220000","loans_pago_interes":"55000","user_alias":"eder.cortes"},"items":[{"id":336,"loans_codigo":86,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 21:03:40","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000","user_alias":"eder.cortes"},{"id":337,"loans_codigo":86,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":338,"loans_codigo":86,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":339,"loans_codigo":86,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":340,"loans_codigo":86,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:16:27
34775	9d69bf7b-517a-4ba0-ae57-a5c62b0b7c33	9d69bf7b-569c-46d9-9613-be67dd33627a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"49.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:51:36
34776	9d69bf7b-51ca-4645-8d94-52028b759c7e	9d69bf7b-569c-46d9-9613-be67dd33627a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:51:36
34777	9d69bf7b-5563-4270-95cd-6fd0c2a36440	9d69bf7b-569c-46d9-9613-be67dd33627a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 21:51:36
34778	9d69bf7b-55af-458c-92ec-370d1902c469	9d69bf7b-569c-46d9-9613-be67dd33627a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:51:36
33461	9d69b331-1165-4c0b-8ff9-90450676a26f	9d69b331-1492-453a-9eeb-847d9070e508	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":149,"memory":20,"hostname":"EderCortes"}	2024-11-04 21:17:14
33476	9d69b332-305e-42de-a127-4f9c9259f7e6	9d69b332-7e79-4b0c-92c2-162e00b53b95	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:17:15
33477	9d69b332-7490-4ff6-999d-ebc2b4663563	9d69b332-7e79-4b0c-92c2-162e00b53b95	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 86\\n                        ","time":"161.85","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"6815ad365c5e82c8fb55476c5a77f0b5","hostname":"EderCortes"}	2024-11-04 21:17:15
33478	9d69b332-781d-45c7-8b4e-f89c42c1878c	9d69b332-7e79-4b0c-92c2-162e00b53b95	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '86' order by \\"item_loans\\".\\"id\\" asc","time":"3.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:17:15
33479	9d69b332-7c89-406a-a07c-d3c717c39dda	9d69b332-7e79-4b0c-92c2-162e00b53b95	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:17:15
33480	9d69b332-7cfc-4d72-99eb-48f2fb11230b	9d69b332-7e79-4b0c-92c2-162e00b53b95	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/86","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":86,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"220000","loans_pago_interes":"55000","user_alias":"eder.cortes"},"items":[{"id":336,"loans_codigo":86,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 21:03:40","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000","user_alias":"eder.cortes"},{"id":337,"loans_codigo":86,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":338,"loans_codigo":86,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":339,"loans_codigo":86,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":340,"loans_codigo":86,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":362,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:17:15
33481	9d69b33f-afb8-4c5a-a9ff-000351b51a0b	9d69b33f-cb59-41b2-a4fa-2a26dc67ce6f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:17:24
33482	9d69b33f-c581-43a2-a517-71b130d6c2a7	9d69b33f-cb59-41b2-a4fa-2a26dc67ce6f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"42.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 21:17:24
33483	9d69b33f-c953-438b-88f8-a5cc852e75c7	9d69b33f-cb59-41b2-a4fa-2a26dc67ce6f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:17:24
33484	9d69b33f-c9e7-48b7-8828-2cee5ddaadcb	9d69b33f-cb59-41b2-a4fa-2a26dc67ce6f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:17:24
33485	9d69b340-14da-41d1-96cc-5f92760745a0	9d69b340-5e5d-4c31-92f2-cea16023c6a0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:17:24
33486	9d69b340-5934-4e13-af7a-1fd6c7552fa6	9d69b340-5e5d-4c31-92f2-cea16023c6a0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"158.33","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 21:17:24
33487	9d69b340-5ca7-41b8-a660-dfe7fcc44bad	9d69b340-5e5d-4c31-92f2-cea16023c6a0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:17:24
33488	9d69b340-5d30-428e-93a2-1e776626474b	9d69b340-5e5d-4c31-92f2-cea16023c6a0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":346,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:17:24
33489	9d69b345-f094-4a41-9b21-bf117d6758e5	9d69b346-3dd0-443a-9949-ce1d4ebd9a45	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 21:17:28
33490	9d69b346-3531-4802-85d1-8f38679b2ae9	9d69b346-3dd0-443a-9949-ce1d4ebd9a45	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 86\\n                        ","time":"150.76","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"6815ad365c5e82c8fb55476c5a77f0b5","hostname":"EderCortes"}	2024-11-04 21:17:28
33491	9d69b346-382a-4859-bbbe-4f9bcab6da95	9d69b346-3dd0-443a-9949-ce1d4ebd9a45	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '86' order by \\"item_loans\\".\\"id\\" asc","time":"2.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:17:28
33492	9d69b346-3c03-4b36-a2a7-54188754685b	9d69b346-3dd0-443a-9949-ce1d4ebd9a45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:17:28
33493	9d69b346-3c87-43fd-87da-0a63cfef0ba2	9d69b346-3dd0-443a-9949-ce1d4ebd9a45	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/86","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":86,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"220000","loans_pago_interes":"55000","user_alias":"eder.cortes"},"items":[{"id":336,"loans_codigo":86,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 21:03:40","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000","user_alias":"eder.cortes"},{"id":337,"loans_codigo":86,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":338,"loans_codigo":86,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":339,"loans_codigo":86,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":340,"loans_codigo":86,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:17:28
33494	9d69b34a-ea35-46fd-be1a-14d5207d10a7	9d69b34b-047c-4e9a-9705-03d384b65529	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:17:31
31367	9d694aab-d275-47d3-a154-029c7b8f7b28	9d694aab-fd4e-452c-b799-cfcee64dc93f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 16:24:59
31368	9d694aab-f436-421e-a51d-ed35a29f5112	9d694aab-fd4e-452c-b799-cfcee64dc93f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"55.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 16:24:59
31369	9d694aab-fb6f-4e47-8543-df92cea5abda	9d694aab-fd4e-452c-b799-cfcee64dc93f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 16:24:59
31370	9d694aab-fc1c-44cd-bc88-5058c54bb8fc	9d694aab-fd4e-452c-b799-cfcee64dc93f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42883]: Undefined function: 7 ERROR:  el operador no existe: character varying = bigint\\nLINE 1: ...oin \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\"....\\n                                                             ^\\nHINT:  Ning\\u00fan operador coincide en el nombre y tipos de argumentos. Puede ser necesario agregar conversi\\u00f3n expl\\u00edcita de tipos. (Connection: pgsql, SQL: select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" inner join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = 92 order by \\"item_loans\\".\\"id\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":304,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":478,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:24:59
33495	9d69b34a-ffc8-4f83-b5e6-c487647fd3c9	9d69b34b-047c-4e9a-9705-03d384b65529	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"42.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 21:17:31
33496	9d69b34b-0306-4e9a-8542-9efb9f53a08a	9d69b34b-047c-4e9a-9705-03d384b65529	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:17:31
33497	9d69b34b-037f-400c-997f-64b2281e2756	9d69b34b-047c-4e9a-9705-03d384b65529	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":278,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:17:31
33498	9d69b34c-735d-4952-9079-00eb8dadb9a8	9d69b34c-8dfb-4b55-93cd-46b8add5258d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:17:32
33499	9d69b34c-895c-4db4-b8fa-4756085ae2b5	9d69b34c-8dfb-4b55-93cd-46b8add5258d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"41.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 21:17:32
33500	9d69b34c-8c8c-48ec-ae85-e8a375aaa79b	9d69b34c-8dfb-4b55-93cd-46b8add5258d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:17:32
33501	9d69b34c-8d06-4646-af38-fb5d663d2fd3	9d69b34c-8dfb-4b55-93cd-46b8add5258d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:17:32
29905	9d692c15-2d6c-4b79-8e34-4e41137038da	9d692c15-4b8b-4292-9f00-fa0953639655	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 14:59:27
29906	9d692c15-49f8-4743-ac57-065003f628f0	9d692c15-4b8b-4292-9f00-fa0953639655	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 14:59:27
29907	9d692c15-4a97-4326-bb5e-671ea61100ee	9d692c15-4b8b-4292-9f00-fa0953639655	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":299,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:59:27
33502	9d69b352-3549-4a47-986b-b62b406f4525	9d69b352-5176-4543-b7f7-f2ee5b065282	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:17:36
6324	9d526478-1d01-4839-98ba-c82eecbd6027	9d526478-2011-4394-a8f5-14c3a614043d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abfrom\\u00bb\\nLINE 13:     from loans l\\n             ^ (Connection: pgsql, SQL: \\n    select l.id,\\n        l.loans_documento,\\n        l.loans_nombre,\\n        l.loans_apellido_uno,\\n        l.loans_fecha,\\n        l.loans_valor_prestado,\\n        l.loans_cuotas,\\n        l.loans_estado,\\n        l.loans_intereses,\\n        uco.name as cobrador,\\n        ure.name as recomendador,\\n    from loans l\\n    join users ucl on l.user_customer = ucl.id\\n    join users uco on l.user_cobrador = uco.id\\n    left join users ure on l.user_recomendacion = ure.id\\n)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":329}	2024-10-24 07:13:04
29908	9d692c15-a161-451c-90b5-a82b5137bd3e	9d692c15-c0a5-4d2c-823c-18654d0de12a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 14:59:27
29909	9d692c15-b6a3-489f-9abb-81a2057ef327	9d692c15-c0a5-4d2c-823c-18654d0de12a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"40.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 14:59:27
29910	9d692c15-bafa-40fa-85eb-c938e7bed7ab	9d692c15-c0a5-4d2c-823c-18654d0de12a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"1.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 14:59:27
29911	9d692c15-bb2e-4928-893f-1fe29c807d2c	9d692c15-c0a5-4d2c-823c-18654d0de12a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 14:59:27
29912	9d692c15-bf6e-4f73-b8df-c9d71d9bad4c	9d692c15-c0a5-4d2c-823c-18654d0de12a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 14:59:27
29913	9d692c15-bfc5-4681-9472-045e1ab9cdd7	9d692c15-c0a5-4d2c-823c-18654d0de12a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":245,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:59:27
33503	9d69b352-4a9f-4a6f-b77d-dd9a63620a3b	9d69b352-5176-4543-b7f7-f2ee5b065282	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 84\\n                        ","time":"42.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"ab3bc7b9a0b897ddfe4287a88fc64c84","hostname":"EderCortes"}	2024-11-04 21:17:36
33504	9d69b352-4d43-48e0-93db-661867d84009	9d69b352-5176-4543-b7f7-f2ee5b065282	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '84' order by \\"item_loans\\".\\"id\\" asc","time":"2.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:17:36
33505	9d69b352-5015-4ef4-aede-6593570712b6	9d69b352-5176-4543-b7f7-f2ee5b065282	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:17:36
33506	9d69b352-5064-414f-80f1-dd85a5343da9	9d69b352-5176-4543-b7f7-f2ee5b065282	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/84","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":84,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0","user_alias":"eder.cortes"},"items":[{"id":326,"loans_codigo":84,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 09:18:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":327,"loans_codigo":84,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 09:18:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":328,"loans_codigo":84,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 09:18:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":329,"loans_codigo":84,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 09:18:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":330,"loans_codigo":84,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 09:18:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:17:36
28560	9d6901f6-5c42-4f51-93a3-050c00a44d34	9d6901f6-d57b-4ec8-b0cb-2ed39953888d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-11-04 13:01:40
28561	9d6901f6-d225-4f44-b20d-a9a7b0295a49	9d6901f6-d57b-4ec8-b0cb-2ed39953888d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":29,"hostname":"EderCortes"}	2024-11-04 13:01:40
28562	9d6901f6-d3b0-4267-a270-525bbebd332b	9d6901f6-d57b-4ec8-b0cb-2ed39953888d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":1038,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:01:40
33507	9d69b35f-a6a0-4f70-98f4-336127b0048c	9d69b35f-a9fe-4150-9570-e589e1c2cd50	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":153,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:17:45
38358	9d6b6373-10ce-4a84-b591-bdc0330929f8	9d6b6373-368c-4167-be8d-a180c88362b3	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 17:25:55
38359	9d6b6373-344a-4126-bf8c-7db052b6cc4b	9d6b6373-368c-4167-be8d-a180c88362b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:25:55
38360	9d6b6373-3532-4f33-9fd1-8396e37d1174	9d6b6373-368c-4167-be8d-a180c88362b3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":309,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:25:55
28564	9d6901f7-e3f1-4d94-b297-cbbc567fb837	9d6901f7-f349-44f3-a25f-e4491df620c2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"71.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 13:01:41
28565	9d6901f7-e9d4-4d76-bc8b-cf6feb04c07e	9d6901f7-f349-44f3-a25f-e4491df620c2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"3.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:01:41
28566	9d6901f7-ea2e-4040-9375-eb22e3006de9	9d6901f7-f349-44f3-a25f-e4491df620c2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:01:41
28567	9d6901f7-f0ff-4b75-a6cf-429b6a8d295f	9d6901f7-f349-44f3-a25f-e4491df620c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":30,"hostname":"EderCortes"}	2024-11-04 13:01:41
28568	9d6901f7-f18c-4f7a-ad57-55e194f6cca9	9d6901f7-f349-44f3-a25f-e4491df620c2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":636,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:01:41
38361	9d6b6373-9f9e-404d-acfb-40634aa75dcd	9d6b6373-bd78-416e-a79b-427eb88de1f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:25:55
38362	9d6b6373-b844-47ee-8c16-7964391b71c3	9d6b6373-bd78-416e-a79b-427eb88de1f4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"45.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:25:55
38363	9d6b6373-bbe2-4edd-ae54-7093d60dd04b	9d6b6373-bd78-416e-a79b-427eb88de1f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:25:55
38364	9d6b6373-bc4f-4835-bb56-d48bac5031bc	9d6b6373-bd78-416e-a79b-427eb88de1f4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":280,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:25:55
21907	9d6740cd-4856-42c4-9804-17a909298b6b	9d6740cd-4f6b-4026-9d1e-3b4d4dcf60ba	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1050}	2024-11-03 16:05:43
38365	9d6b6374-04f9-4fb5-9d42-ba9321ea9cb5	9d6b6374-510e-4422-8852-38e12d9ba861	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:25:56
38366	9d6b6374-4a6b-42a8-8e47-81600abfff83	9d6b6374-510e-4422-8852-38e12d9ba861	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"151.66","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:25:56
38367	9d6b6374-4ad0-4632-8130-4b0fd98cc60a	9d6b6374-510e-4422-8852-38e12d9ba861	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:25:56
38368	9d6b6374-4f7c-4fda-97e5-630751fba370	9d6b6374-510e-4422-8852-38e12d9ba861	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:25:56
38369	9d6b6374-4fcc-44b7-b9a6-9363de69ba35	9d6b6374-510e-4422-8852-38e12d9ba861	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":362,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:25:56
33522	9d69b360-abec-4947-a76d-6c92ddc4e9b0	9d69b360-f262-4af6-8828-08abfb6fb01e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:17:45
33523	9d69b360-eb32-435e-8623-8a93d05d559e	9d69b360-f262-4af6-8828-08abfb6fb01e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 84\\n                        ","time":"148.80","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"ab3bc7b9a0b897ddfe4287a88fc64c84","hostname":"EderCortes"}	2024-11-04 21:17:46
33524	9d69b360-edcd-4f1d-baa4-6234e79dbf9e	9d69b360-f262-4af6-8828-08abfb6fb01e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '84' order by \\"item_loans\\".\\"id\\" asc","time":"2.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:17:46
33525	9d69b360-f0e3-43ee-a525-9de48c40f3d4	9d69b360-f262-4af6-8828-08abfb6fb01e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:17:46
33526	9d69b360-f139-4abf-b5e2-e9dcf5edb231	9d69b360-f262-4af6-8828-08abfb6fb01e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/84","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":84,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0","user_alias":"eder.cortes"},"items":[{"id":326,"loans_codigo":84,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 09:18:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":327,"loans_codigo":84,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 09:18:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":328,"loans_codigo":84,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 09:18:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":329,"loans_codigo":84,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 09:18:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":330,"loans_codigo":84,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 09:18:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":351,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:17:46
38370	9d6b6374-9714-4c55-97d3-564ef2257a72	9d6b6374-b4f0-4285-8331-5bb16e3c9b0f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:25:56
38371	9d6b6374-b00b-4d52-a8f1-04dd62263e83	9d6b6374-b4f0-4285-8331-5bb16e3c9b0f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:25:56
38372	9d6b6374-b065-459b-9b8a-6db6440a04a2	9d6b6374-b4f0-4285-8331-5bb16e3c9b0f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:25:56
38373	9d6b6374-b3da-4d5a-becf-4f85e773d351	9d6b6374-b4f0-4285-8331-5bb16e3c9b0f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:25:56
38374	9d6b6374-b423-4eba-b248-acf32672cb90	9d6b6374-b4f0-4285-8331-5bb16e3c9b0f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":242,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:25:56
33527	9d69b3ba-fd0e-4de2-9289-d072dcdd9a20	9d69b3bb-013f-49cc-b02a-6c5604f4f7d1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":180,"memory":20,"hostname":"EderCortes"}	2024-11-04 21:18:45
38375	9d6b6376-83d9-438a-b7b1-7e8b9c8f4812	9d6b6376-a3a2-43df-b538-253c5dcab26a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:25:57
38376	9d6b6376-9e08-4f95-884b-12df273cbc96	9d6b6376-a3a2-43df-b538-253c5dcab26a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:25:57
38377	9d6b6376-9e51-4abc-a6ea-9524ec175e47	9d6b6376-a3a2-43df-b538-253c5dcab26a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:25:57
38378	9d6b6376-a234-4330-bc7d-34850d01a4a7	9d6b6376-a3a2-43df-b538-253c5dcab26a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:25:57
38379	9d6b6376-a27b-4827-8573-e5576625991a	9d6b6376-a3a2-43df-b538-253c5dcab26a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":313,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:25:57
33542	9d69b3bc-2bb8-4b4b-8c8a-9a67529969a4	9d69b3bc-517c-40ff-bed6-23065df85dd8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:18:45
33543	9d69b3bc-46e9-460e-902b-8141f3340911	9d69b3bc-517c-40ff-bed6-23065df85dd8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 84\\n                        ","time":"54.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"ab3bc7b9a0b897ddfe4287a88fc64c84","hostname":"EderCortes"}	2024-11-04 21:18:45
33544	9d69b3bc-4c20-43dc-92e8-b4c8eec933ee	9d69b3bc-517c-40ff-bed6-23065df85dd8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '84' order by \\"item_loans\\".\\"id\\" asc","time":"4.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:18:45
33545	9d69b3bc-4fcd-4bd3-97f7-1917e4bc9215	9d69b3bc-517c-40ff-bed6-23065df85dd8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:18:45
33546	9d69b3bc-502d-4c29-9e7c-4f300e2f27ef	9d69b3bc-517c-40ff-bed6-23065df85dd8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/84","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":84,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0","user_alias":"eder.cortes"},"items":[{"id":326,"loans_codigo":84,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 09:18:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":327,"loans_codigo":84,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 09:18:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":328,"loans_codigo":84,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 09:18:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":329,"loans_codigo":84,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 09:18:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":330,"loans_codigo":84,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 09:18:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":337,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:18:45
33547	9d69b3c5-45e3-4735-a812-f135a17e093d	9d69b3c5-89f9-4585-be6e-7a3408a80276	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:18:51
33548	9d69b3c5-855e-4624-a459-7441e8743367	9d69b3c5-89f9-4585-be6e-7a3408a80276	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"146.02","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 21:18:51
33549	9d69b3c5-8861-4b60-9a80-66d9d9e05523	9d69b3c5-89f9-4585-be6e-7a3408a80276	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:18:51
33550	9d69b3c5-88e8-4f85-ae54-89541a509950	9d69b3c5-89f9-4585-be6e-7a3408a80276	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":334,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:18:51
33551	9d69b3c9-b67e-4864-9aef-e41f1e06bf26	9d69b3c9-d522-4dc8-8eef-9576938def99	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:18:54
33552	9d69b3c9-cd48-4b2e-a41e-c11cae0ff2d2	9d69b3c9-d522-4dc8-8eef-9576938def99	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 86\\n                        ","time":"43.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"6815ad365c5e82c8fb55476c5a77f0b5","hostname":"EderCortes"}	2024-11-04 21:18:54
33553	9d69b3c9-d054-4aa8-90b3-74513506419d	9d69b3c9-d522-4dc8-8eef-9576938def99	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '86' order by \\"item_loans\\".\\"id\\" asc","time":"2.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:18:54
33554	9d69b3c9-d398-4229-9cab-2faa9f4f0392	9d69b3c9-d522-4dc8-8eef-9576938def99	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:18:54
33555	9d69b3c9-d401-46c3-97fa-2f6c2d0fc9f9	9d69b3c9-d522-4dc8-8eef-9576938def99	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/86","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":86,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"220000","loans_pago_interes":"55000","user_alias":"eder.cortes"},"items":[{"id":336,"loans_codigo":86,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 21:03:40","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000","user_alias":"eder.cortes"},{"id":337,"loans_codigo":86,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":338,"loans_codigo":86,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":339,"loans_codigo":86,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":340,"loans_codigo":86,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":260,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:18:54
33556	9d69b3d8-af25-41fd-bc61-40505a61a30b	9d69b3d8-b26c-478b-b928-45bdb45def4f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":143,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:19:04
31612	9d6951bf-9f09-401c-872e-aa0abe5c3748	9d6951bf-dba4-488b-882d-62170d0aef65	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 16:44:46
31613	9d6951bf-d849-4ddf-ba58-fa9bc32057be	9d6951bf-dba4-488b-882d-62170d0aef65	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 16:44:46
31614	9d6951bf-d9fb-4ebe-b733-4ae28cc16ec7	9d6951bf-dba4-488b-882d-62170d0aef65	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":536,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:44:46
31615	9d6951c0-9140-4704-aad8-8847ed4d0c07	9d6951c0-cb43-49ca-b001-70f5c18aa79b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 16:44:47
31616	9d6951c0-bdcd-4bb0-93ce-41d9c819f5a9	9d6951c0-cb43-49ca-b001-70f5c18aa79b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"78.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 16:44:47
31617	9d6951c0-c27e-49bb-b477-73b29a74e0da	9d6951c0-cb43-49ca-b001-70f5c18aa79b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '92' order by \\"item_loans\\".\\"id\\" asc","time":"3.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 16:44:47
31618	9d6951c0-c912-49db-a534-08e578ccad17	9d6951c0-cb43-49ca-b001-70f5c18aa79b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 16:44:47
31619	9d6951c0-c9b0-45ce-8518-9e3c129fc739	9d6951c0-cb43-49ca-b001-70f5c18aa79b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":92,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":15,"loans_valor_prestado":8000009,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"533333.93333333","loans_pago_interes":"133333.48333333","user_alias":"eder.cortes"},"items":[{"id":379,"loans_codigo":92,"itemloans_cuota":"1","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:13:07","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":null},{"id":380,"loans_codigo":92,"itemloans_cuota":"2","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":381,"loans_codigo":92,"itemloans_cuota":"3","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":382,"loans_codigo":92,"itemloans_cuota":"4","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":383,"loans_codigo":92,"itemloans_cuota":"5","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":384,"loans_codigo":92,"itemloans_cuota":"6","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":385,"loans_codigo":92,"itemloans_cuota":"7","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":386,"loans_codigo":92,"itemloans_cuota":"8","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":387,"loans_codigo":92,"itemloans_cuota":"9","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-15 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":388,"loans_codigo":92,"itemloans_cuota":"10","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":389,"loans_codigo":92,"itemloans_cuota":"11","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-31 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":390,"loans_codigo":92,"itemloans_cuota":"12","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":391,"loans_codigo":92,"itemloans_cuota":"13","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-16 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":392,"loans_codigo":92,"itemloans_cuota":"14","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":393,"loans_codigo":92,"itemloans_cuota":"15","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":508,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:44:47
33571	9d69b3d9-b1f3-40ef-9edd-c4dfd94c2c1f	9d69b3d9-d2d3-45c9-9223-f35a24e452e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:19:05
33572	9d69b3d9-c97a-4a89-a99c-d9fdf5cd5103	9d69b3d9-d2d3-45c9-9223-f35a24e452e7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 86\\n                        ","time":"45.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"6815ad365c5e82c8fb55476c5a77f0b5","hostname":"EderCortes"}	2024-11-04 21:19:05
33573	9d69b3d9-cc9a-4868-a944-7337bb94ad87	9d69b3d9-d2d3-45c9-9223-f35a24e452e7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '86' order by \\"item_loans\\".\\"id\\" asc","time":"2.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:19:05
33574	9d69b3d9-d158-4650-ae65-3e873a6f6250	9d69b3d9-d2d3-45c9-9223-f35a24e452e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:19:05
31620	9d6951c1-dc82-432d-bd2c-5cce966c1297	9d6951c2-56f7-4b1f-883b-522a61b195f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 16:44:47
31621	9d6951c2-4bc6-4421-bcc1-da60f7399dc0	9d6951c2-56f7-4b1f-883b-522a61b195f4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"159.44","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:44:48
31622	9d6951c2-4c4b-47c0-858e-6ffe96d0dea4	9d6951c2-56f7-4b1f-883b-522a61b195f4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:44:48
31623	9d6951c2-549c-4285-b779-5552fc01491c	9d6951c2-56f7-4b1f-883b-522a61b195f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 16:44:48
31624	9d6951c2-5534-4898-9647-80bea0cdb8e7	9d6951c2-56f7-4b1f-883b-522a61b195f4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":992,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:44:48
33575	9d69b3d9-d1b2-4c74-b5d1-cbbce3e5da68	9d69b3d9-d2d3-45c9-9223-f35a24e452e7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/86","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":86,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"220000","loans_pago_interes":"55000","user_alias":"eder.cortes"},"items":[{"id":336,"loans_codigo":86,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 21:03:40","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000","user_alias":"eder.cortes"},{"id":337,"loans_codigo":86,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":338,"loans_codigo":86,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":339,"loans_codigo":86,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":340,"loans_codigo":86,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":320,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:19:05
31625	9d6951c3-71b9-4fdb-ab42-3860f1d64a9b	9d6951c3-c83f-424d-bb19-e51477f3c7cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 16:44:48
31626	9d6951c3-bfaa-4401-b131-0b06cb0f0df0	9d6951c3-c83f-424d-bb19-e51477f3c7cd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"145.13","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:44:49
31627	9d6951c3-c02c-489f-92d6-cdb24efc5bdf	9d6951c3-c83f-424d-bb19-e51477f3c7cd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:44:49
31628	9d6951c3-c64b-4444-bcec-03516b51e9f9	9d6951c3-c83f-424d-bb19-e51477f3c7cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 16:44:49
31629	9d6951c3-c6cb-40e8-a0bc-6033501d1659	9d6951c3-c83f-424d-bb19-e51477f3c7cd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":776,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:44:49
33576	9d69b42e-6eb7-4e59-bce1-fc0466838c84	9d69b42e-734e-4452-af5b-92bb57fbd6d5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":208,"memory":20,"hostname":"EderCortes"}	2024-11-04 21:20:00
33591	9d69b42f-a045-4020-b5a2-345b8fdbb456	9d69b42f-e8c4-46e8-8706-0447235d4ed1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:20:01
33592	9d69b42f-dfc9-4980-b7bc-0d6a4a3fcd94	9d69b42f-e8c4-46e8-8706-0447235d4ed1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 86\\n                        ","time":"146.52","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"6815ad365c5e82c8fb55476c5a77f0b5","hostname":"EderCortes"}	2024-11-04 21:20:01
33593	9d69b42f-e323-41ab-ae7a-a40f3bedfc71	9d69b42f-e8c4-46e8-8706-0447235d4ed1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '86' order by \\"item_loans\\".\\"id\\" asc","time":"2.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:20:01
33594	9d69b42f-e707-46f8-8ae0-9c052406323c	9d69b42f-e8c4-46e8-8706-0447235d4ed1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:20:01
33595	9d69b42f-e77d-47dd-af43-89a9139d4bae	9d69b42f-e8c4-46e8-8706-0447235d4ed1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/86","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":86,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"220000","loans_pago_interes":"55000","user_alias":"eder.cortes"},"items":[{"id":336,"loans_codigo":86,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 21:03:40","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000","user_alias":"eder.cortes"},{"id":337,"loans_codigo":86,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":338,"loans_codigo":86,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":339,"loans_codigo":86,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":340,"loans_codigo":86,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 09:18:38","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":508,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:20:01
33596	9d69b446-826b-4f79-93c8-4fec5a093ac2	9d69b446-8593-405e-8b53-4a090ed5c490	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":148,"memory":20,"hostname":"EderCortes"}	2024-11-04 21:20:16
33597	9d69b447-0079-435a-b296-b91eb2f7db73	9d69b447-260f-4fd7-b968-9a5e94d29bab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:20:16
33598	9d69b447-17aa-4a91-84e7-c3ca16b1ac60	9d69b447-260f-4fd7-b968-9a5e94d29bab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 86 limit 1","time":"3.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":505,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 21:20:16
33599	9d69b447-17f8-4d3d-ac56-d1603a2d187d	9d69b447-260f-4fd7-b968-9a5e94d29bab	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":2,"hostname":"EderCortes"}	2024-11-04 21:20:16
33600	9d69b447-199d-42d3-a75e-59a8f91fb0c1	9d69b447-260f-4fd7-b968-9a5e94d29bab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select count(*) as aggregate from \\"item_loans\\" where \\"loans_codigo\\" = 86 and (\\"itemloans_status\\" = 'Pagada' or \\"itemloans_status\\" = 'Abono')","time":"2.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":566,"hash":"40bb62c1101cd4a074e44b13c59d4517","hostname":"EderCortes"}	2024-11-04 21:20:16
33601	9d69b447-1a4f-4bca-8efb-0949668f1999	9d69b447-260f-4fd7-b968-9a5e94d29bab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 115000, \\"loans_pago_prestado\\" = 460000, \\"updated_at\\" = '2024-11-04 21:20:16' where \\"id\\" = 86","time":"0.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":605,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 21:20:16
33602	9d69b447-1aa5-4b4f-93b5-5f9d4c76832f	9d69b447-260f-4fd7-b968-9a5e94d29bab	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:86","changes":{"updated_at":"2024-11-04 21:20:16","loans_pago_interes":115000,"loans_pago_prestado":460000},"hostname":"EderCortes"}	2024-11-04 21:20:16
33603	9d69b447-1b30-4f3f-9e75-2948d51ababc	9d69b447-260f-4fd7-b968-9a5e94d29bab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 86 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"0.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":612,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 21:20:16
33604	9d69b447-1b63-4e5a-bc21-f6b00ad49523	9d69b447-260f-4fd7-b968-9a5e94d29bab	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 21:20:16
33605	9d69b447-1bd9-43d3-8d83-92c91c13b138	9d69b447-260f-4fd7-b968-9a5e94d29bab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Abono', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = 60000, \\"itemloans_cuota_cancelada\\" = 240000, \\"updated_at\\" = '2024-11-04 21:20:16' where \\"id\\" = 337","time":"0.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":620,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 21:20:16
33606	9d69b447-1c07-4f24-ad42-a97fdc54d6da	9d69b447-260f-4fd7-b968-9a5e94d29bab	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:337","changes":{"itemloans_status":"Abono","updated_at":"2024-11-04 21:20:16","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":60000,"itemloans_cuota_cancelada":240000},"hostname":"EderCortes"}	2024-11-04 21:20:16
33607	9d69b447-1c98-4468-8e77-ac94405f7405	9d69b447-260f-4fd7-b968-9a5e94d29bab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"delete from \\"item_loans\\" where \\"loans_codigo\\" = 86 and \\"itemloans_status\\" = 'Pendiente'","time":"0.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":627,"hash":"89bf3c496a8b0746ff5d1219b8dc29e3","hostname":"EderCortes"}	2024-11-04 21:20:16
33608	9d69b447-1d0a-4d0e-b41b-4d451414ac20	9d69b447-260f-4fd7-b968-9a5e94d29bab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 86 limit 1","time":"0.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":630,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 21:20:16
33609	9d69b447-1db5-4d52-b60a-a261f4f2bc41	9d69b447-260f-4fd7-b968-9a5e94d29bab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (86, 3, 213333.33333333, 53333.333333333, 'Pendiente', 'Se realiza abono', '12-11-2024', 0, 0, '2024-11-04 21:20:16', '2024-11-04 21:20:16')","time":"0.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":688,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:20:16
33610	9d69b447-1de0-4587-b603-9a4f46a2bb16	9d69b447-260f-4fd7-b968-9a5e94d29bab	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:20:16
33611	9d69b447-1e4a-47f2-9a1b-ced519866461	9d69b447-260f-4fd7-b968-9a5e94d29bab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (86, 4, 213333.33333333, 53333.333333333, 'Pendiente', 'Se realiza abono', '20-11-2024', 0, 0, '2024-11-04 21:20:16', '2024-11-04 21:20:16')","time":"0.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":688,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:20:16
33612	9d69b447-1e70-466c-9583-6a9e45f66f79	9d69b447-260f-4fd7-b968-9a5e94d29bab	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:20:16
33613	9d69b447-1ed3-4f1a-b3f0-8104fc376532	9d69b447-260f-4fd7-b968-9a5e94d29bab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (86, 5, 213333.33333333, 53333.333333333, 'Pendiente', 'Se realiza abono', '28-11-2024', 0, 0, '2024-11-04 21:20:16', '2024-11-04 21:20:16')","time":"0.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":688,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:20:16
33614	9d69b447-1efb-4806-9ffa-d230defb4a16	9d69b447-260f-4fd7-b968-9a5e94d29bab	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:20:16
33615	9d69b447-24d2-4ed4-9208-bf7c05a49409	9d69b447-260f-4fd7-b968-9a5e94d29bab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:20:16
33616	9d69b447-2515-4546-bc3b-55dce713cac9	9d69b447-260f-4fd7-b968-9a5e94d29bab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"61","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"300000","idLoans":86,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El abono fue aplicado exitosamente","status":true},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:20:16
33617	9d69b447-6d90-416e-82e9-a5ea3c931631	9d69b447-8b5a-4ed3-9ed6-c3cd279f535a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:20:17
33618	9d69b447-830c-4be5-ba1e-d9576ac216d1	9d69b447-8b5a-4ed3-9ed6-c3cd279f535a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 86\\n                        ","time":"43.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"6815ad365c5e82c8fb55476c5a77f0b5","hostname":"EderCortes"}	2024-11-04 21:20:17
33619	9d69b447-865a-4702-bb39-fdca99d79206	9d69b447-8b5a-4ed3-9ed6-c3cd279f535a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '86' order by \\"item_loans\\".\\"id\\" asc","time":"3.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:20:17
33620	9d69b447-89ea-4d1b-b27c-9573f6021981	9d69b447-8b5a-4ed3-9ed6-c3cd279f535a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:20:17
33621	9d69b447-8a39-4646-9501-90b0583b977a	9d69b447-8b5a-4ed3-9ed6-c3cd279f535a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/86","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":86,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"460000","loans_pago_interes":"115000","user_alias":"eder.cortes"},"items":[{"id":336,"loans_codigo":86,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 21:03:40","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000","user_alias":"eder.cortes"},{"id":337,"loans_codigo":86,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 21:20:16","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":449,"loans_codigo":86,"itemloans_cuota":"3","itemloans_valor_cuota":"213333.33333333","itemloans_iteres":"53333.333333333","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:20:16","updated_at":"2024-11-04 21:20:16","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":450,"loans_codigo":86,"itemloans_cuota":"4","itemloans_valor_cuota":"213333.33333333","itemloans_iteres":"53333.333333333","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:20:16","updated_at":"2024-11-04 21:20:16","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":451,"loans_codigo":86,"itemloans_cuota":"5","itemloans_valor_cuota":"213333.33333333","itemloans_iteres":"53333.333333333","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:20:16","updated_at":"2024-11-04 21:20:16","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:20:17
33622	9d69b45c-2054-48de-b200-c05e6e741360	9d69b45c-3d0b-4d1a-b1a3-aadd784d708e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:20:30
33623	9d69b45c-37e5-4fe2-a0d8-cc541aaf2d10	9d69b45c-3d0b-4d1a-b1a3-aadd784d708e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"43.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 21:20:30
33624	9d69b45c-3b76-434a-9842-a5d383365d36	9d69b45c-3d0b-4d1a-b1a3-aadd784d708e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:20:30
33625	9d69b45c-3bea-4768-80b7-48f7e0284602	9d69b45c-3d0b-4d1a-b1a3-aadd784d708e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:20:30
33626	9d69b462-e59b-4cdb-b25e-078936733e1e	9d69b463-02e1-44b7-a718-326f360cf276	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:20:35
33627	9d69b462-fbcf-4556-ba43-2ef9dc595979	9d69b463-02e1-44b7-a718-326f360cf276	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 84\\n                        ","time":"45.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"ab3bc7b9a0b897ddfe4287a88fc64c84","hostname":"EderCortes"}	2024-11-04 21:20:35
33628	9d69b462-fe9e-4c32-98cc-0fe349f4d1b4	9d69b463-02e1-44b7-a718-326f360cf276	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '84' order by \\"item_loans\\".\\"id\\" asc","time":"2.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:20:35
33629	9d69b463-0180-41e7-903d-a5275ff4e439	9d69b463-02e1-44b7-a718-326f360cf276	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:20:35
33630	9d69b463-01d0-47d6-8741-6041bb63179f	9d69b463-02e1-44b7-a718-326f360cf276	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/84","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":84,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0","user_alias":"eder.cortes"},"items":[{"id":326,"loans_codigo":84,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 09:18:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":327,"loans_codigo":84,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 09:18:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":328,"loans_codigo":84,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 09:18:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":329,"loans_codigo":84,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 09:18:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":330,"loans_codigo":84,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 09:18:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":269,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:20:35
31717	9d6954aa-78e0-49eb-9b73-741713c4483b	9d6954aa-9a1f-4091-bf95-577529d93f06	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 16:52:55
31718	9d6954aa-9849-447d-998d-1a87a5b086dc	9d6954aa-9a1f-4091-bf95-577529d93f06	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 16:52:55
31719	9d6954aa-990f-41f7-8187-4c8a664f3b6b	9d6954aa-9a1f-4091-bf95-577529d93f06	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":322,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:52:55
33631	9d69b471-9b8f-40e0-b8e7-19db62f8562f	9d69b471-9e99-43fc-816d-0f332922b47a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":130,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:20:44
31720	9d6954ab-0100-4235-8388-88d920f882f5	9d6954ab-20d8-43b2-95b4-ba191fedbbaa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 16:52:56
31721	9d6954ab-1b42-4f29-b493-2c30fe3f7d72	9d6954ab-20d8-43b2-95b4-ba191fedbbaa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:52:56
31722	9d6954ab-1b9a-4f0e-940d-afc11071642d	9d6954ab-20d8-43b2-95b4-ba191fedbbaa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 16:52:56
31723	9d6954ab-1f9d-49a2-baef-09e9df076b48	9d6954ab-20d8-43b2-95b4-ba191fedbbaa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 16:52:56
31724	9d6954ab-1ff1-436c-ae7d-d31fad24405c	9d6954ab-20d8-43b2-95b4-ba191fedbbaa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":278,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:52:56
33632	9d69b472-1ac6-456d-b919-80d10f987442	9d69b472-408b-4e4b-97e2-1cf98cbe616b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:20:45
33633	9d69b472-3175-4052-a9b7-39d7aefa698d	9d69b472-408b-4e4b-97e2-1cf98cbe616b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 84 limit 1","time":"2.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":505,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 21:20:45
33634	9d69b472-31c8-4d7f-a449-ef79f26025a8	9d69b472-408b-4e4b-97e2-1cf98cbe616b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":2,"hostname":"EderCortes"}	2024-11-04 21:20:45
33635	9d69b472-336b-468b-bcae-27736001dc42	9d69b472-408b-4e4b-97e2-1cf98cbe616b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select count(*) as aggregate from \\"item_loans\\" where \\"loans_codigo\\" = 84 and (\\"itemloans_status\\" = 'Pagada' or \\"itemloans_status\\" = 'Abono')","time":"2.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":566,"hash":"40bb62c1101cd4a074e44b13c59d4517","hostname":"EderCortes"}	2024-11-04 21:20:45
33636	9d69b472-3422-4158-9f23-897f8696c3df	9d69b472-408b-4e4b-97e2-1cf98cbe616b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_estado\\" = 'En curso', \\"loans_pago_interes\\" = 60000, \\"loans_pago_prestado\\" = 240000, \\"updated_at\\" = '2024-11-04 21:20:45' where \\"id\\" = 84","time":"0.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":605,"hash":"acfe32aea56c9ca6bdbb917f944a78d1","hostname":"EderCortes"}	2024-11-04 21:20:45
33637	9d69b472-3476-4e91-943f-02890625caeb	9d69b472-408b-4e4b-97e2-1cf98cbe616b	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:84","changes":{"loans_estado":"En curso","updated_at":"2024-11-04 21:20:45","loans_pago_interes":60000,"loans_pago_prestado":240000},"hostname":"EderCortes"}	2024-11-04 21:20:45
33638	9d69b472-3500-45a1-a026-b81a6b5f442c	9d69b472-408b-4e4b-97e2-1cf98cbe616b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 84 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"0.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":612,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 21:20:45
33639	9d69b472-3531-45e8-a8ca-2af510946516	9d69b472-408b-4e4b-97e2-1cf98cbe616b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 21:20:45
33640	9d69b472-35b1-426a-9dd1-2aee092f08d3	9d69b472-408b-4e4b-97e2-1cf98cbe616b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Abono', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = 60000, \\"itemloans_cuota_cancelada\\" = 240000, \\"updated_at\\" = '2024-11-04 21:20:45' where \\"id\\" = 326","time":"0.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":620,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 21:20:45
33641	9d69b472-35dd-4ca4-bbf1-bbce1c61cb14	9d69b472-408b-4e4b-97e2-1cf98cbe616b	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:326","changes":{"itemloans_status":"Abono","updated_at":"2024-11-04 21:20:45","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":60000,"itemloans_cuota_cancelada":240000},"hostname":"EderCortes"}	2024-11-04 21:20:45
33642	9d69b472-3631-4372-9630-739b1cfdbe4a	9d69b472-408b-4e4b-97e2-1cf98cbe616b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"delete from \\"item_loans\\" where \\"loans_codigo\\" = 84 and \\"itemloans_status\\" = 'Pendiente'","time":"0.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":627,"hash":"89bf3c496a8b0746ff5d1219b8dc29e3","hostname":"EderCortes"}	2024-11-04 21:20:45
33643	9d69b472-3696-4b27-9db6-6f99a32a77cd	9d69b472-408b-4e4b-97e2-1cf98cbe616b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 84 limit 1","time":"0.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":630,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 21:20:45
33644	9d69b472-373a-4b73-b1c9-bed391eb0fce	9d69b472-408b-4e4b-97e2-1cf98cbe616b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (84, 4, 215000, 53750, 'Pendiente', 'Se realiza abono', '12-11-2024', 0, 0, '2024-11-04 21:20:45', '2024-11-04 21:20:45')","time":"0.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":688,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:20:45
33645	9d69b472-3767-4851-b0b3-031c37ee5752	9d69b472-408b-4e4b-97e2-1cf98cbe616b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:20:45
31725	9d6954ab-733a-4818-b461-df2fe32af09d	9d6954ab-98f5-4ecc-8021-43022d1a326b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 16:52:56
31726	9d6954ab-91e3-462f-aa85-51518bf1d552	9d6954ab-98f5-4ecc-8021-43022d1a326b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"51.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:52:56
31727	9d6954ab-9253-4451-8f07-a4d33b35dd9f	9d6954ab-98f5-4ecc-8021-43022d1a326b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 16:52:56
31728	9d6954ab-9777-4977-8a1d-d344be130efd	9d6954ab-98f5-4ecc-8021-43022d1a326b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 16:52:56
31729	9d6954ab-97f1-438a-83a9-40bda7d07521	9d6954ab-98f5-4ecc-8021-43022d1a326b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":295,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:52:56
33646	9d69b472-37ca-4eb1-9748-e1c9d0b334a2	9d69b472-408b-4e4b-97e2-1cf98cbe616b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (84, 5, 215000, 53750, 'Pendiente', 'Se realiza abono', '20-11-2024', 0, 0, '2024-11-04 21:20:45', '2024-11-04 21:20:45')","time":"0.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":688,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:20:45
33647	9d69b472-37f1-4427-9732-da0276a3de41	9d69b472-408b-4e4b-97e2-1cf98cbe616b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:20:45
33648	9d69b472-386b-46a7-8bd7-d9319987faa5	9d69b472-408b-4e4b-97e2-1cf98cbe616b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (84, 6, 215000, 53750, 'Pendiente', 'Se realiza abono', '28-11-2024', 0, 0, '2024-11-04 21:20:45', '2024-11-04 21:20:45')","time":"0.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":688,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:20:45
33649	9d69b472-3892-4658-be40-9cc341ebc92a	9d69b472-408b-4e4b-97e2-1cf98cbe616b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:20:45
33650	9d69b472-38fa-46f7-8283-a18c078b65da	9d69b472-408b-4e4b-97e2-1cf98cbe616b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (84, 7, 215000, 53750, 'Pendiente', 'Se realiza abono', '06-12-2024', 0, 0, '2024-11-04 21:20:45', '2024-11-04 21:20:45')","time":"0.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":688,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:20:45
33651	9d69b472-3920-4f24-9127-a562a1e97ff9	9d69b472-408b-4e4b-97e2-1cf98cbe616b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:20:45
33652	9d69b472-3f1e-4515-bfc2-37c942721443	9d69b472-408b-4e4b-97e2-1cf98cbe616b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:20:45
33653	9d69b472-3f6b-4faa-86f5-df10bda7ec13	9d69b472-408b-4e4b-97e2-1cf98cbe616b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"61","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"300000","idLoans":84,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El abono fue aplicado exitosamente","status":true},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:20:45
31730	9d6954ad-4fec-475b-bbda-31a1238c9dd7	9d6954ad-74e1-475d-8147-1df6bc9a787c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 16:52:57
31731	9d6954ad-6e63-44f8-8815-80dfb97a424c	9d6954ad-74e1-475d-8147-1df6bc9a787c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"48.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:52:57
31732	9d6954ad-6ec5-490d-8019-adb2c348f240	9d6954ad-74e1-475d-8147-1df6bc9a787c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:52:57
31733	9d6954ad-734e-4b6b-a3ef-bf516cbf1efa	9d6954ad-74e1-475d-8147-1df6bc9a787c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 16:52:57
31734	9d6954ad-73ae-43eb-ae3e-59c737834bef	9d6954ad-74e1-475d-8147-1df6bc9a787c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":399,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:52:57
33654	9d69b472-899d-47d1-8839-0456401c8c34	9d69b472-a61f-41af-b59b-63caf02cc413	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:20:45
33655	9d69b472-9ef0-4a61-8b97-0cefc725bfdb	9d69b472-a61f-41af-b59b-63caf02cc413	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 84\\n                        ","time":"42.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"ab3bc7b9a0b897ddfe4287a88fc64c84","hostname":"EderCortes"}	2024-11-04 21:20:45
33656	9d69b472-a191-4d65-9f71-9fb5b3dee25f	9d69b472-a61f-41af-b59b-63caf02cc413	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '84' order by \\"item_loans\\".\\"id\\" asc","time":"2.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:20:45
33657	9d69b472-a4b2-43d2-a006-27d03db60d48	9d69b472-a61f-41af-b59b-63caf02cc413	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 21:20:45
33658	9d69b472-a50c-4b56-8d3f-1f9dc6a731c2	9d69b472-a61f-41af-b59b-63caf02cc413	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/84","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":84,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"240000","loans_pago_interes":"60000","user_alias":"eder.cortes"},"items":[{"id":326,"loans_codigo":84,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 21:20:45","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":452,"loans_codigo":84,"itemloans_cuota":"4","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:20:45","updated_at":"2024-11-04 21:20:45","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":453,"loans_codigo":84,"itemloans_cuota":"5","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:20:45","updated_at":"2024-11-04 21:20:45","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":454,"loans_codigo":84,"itemloans_cuota":"6","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:20:45","updated_at":"2024-11-04 21:20:45","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":455,"loans_codigo":84,"itemloans_cuota":"7","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:20:45","updated_at":"2024-11-04 21:20:45","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:20:45
33659	9d69b4d4-945a-4f4a-be04-0d1b2c9c1da6	9d69b4d4-98ac-47f0-8eca-99e9816750bc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":217,"memory":20,"hostname":"EderCortes"}	2024-11-04 21:21:49
33660	9d69b4d5-02a6-49d8-8197-8f99484abf45	9d69b4d5-37f5-4640-86ba-73d1919923a8	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 21:21:49
33661	9d69b4d5-26f4-4931-a85b-3e5c684486b0	9d69b4d5-37f5-4640-86ba-73d1919923a8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 84 limit 1","time":"4.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":505,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 21:21:49
33662	9d69b4d5-2786-42c0-9ec6-4482691d0fb8	9d69b4d5-37f5-4640-86ba-73d1919923a8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":2,"hostname":"EderCortes"}	2024-11-04 21:21:49
33663	9d69b4d5-29a2-40e1-92cf-7afa279babec	9d69b4d5-37f5-4640-86ba-73d1919923a8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select count(*) as aggregate from \\"item_loans\\" where \\"loans_codigo\\" = 84 and (\\"itemloans_status\\" = 'Pagada' or \\"itemloans_status\\" = 'Abono')","time":"2.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":566,"hash":"40bb62c1101cd4a074e44b13c59d4517","hostname":"EderCortes"}	2024-11-04 21:21:49
33664	9d69b4d5-2a86-47c7-806e-ff7d2ccd146f	9d69b4d5-37f5-4640-86ba-73d1919923a8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_pago_interes\\" = 120000, \\"loans_pago_prestado\\" = 480000, \\"updated_at\\" = '2024-11-04 21:21:49' where \\"id\\" = 84","time":"1.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":605,"hash":"c47412bc28d537169ebb9fbe311930ca","hostname":"EderCortes"}	2024-11-04 21:21:49
33665	9d69b4d5-2afa-4df4-a5f1-8a17d8c4d35e	9d69b4d5-37f5-4640-86ba-73d1919923a8	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:84","changes":{"updated_at":"2024-11-04 21:21:49","loans_pago_interes":120000,"loans_pago_prestado":480000},"hostname":"EderCortes"}	2024-11-04 21:21:49
33666	9d69b4d5-2ba6-4424-88a1-5a6cb06175a7	9d69b4d5-37f5-4640-86ba-73d1919923a8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 84 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"0.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":612,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 21:21:49
33667	9d69b4d5-2be0-4839-96a7-6c1588b9e534	9d69b4d5-37f5-4640-86ba-73d1919923a8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 21:21:49
33668	9d69b4d5-2d6c-4052-80c2-55ed3e27c507	9d69b4d5-37f5-4640-86ba-73d1919923a8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Abono', \\"itemloans_aprobador\\" = 12, \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = 60000, \\"itemloans_cuota_cancelada\\" = 240000, \\"updated_at\\" = '2024-11-04 21:21:49' where \\"id\\" = 452","time":"2.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":620,"hash":"6acd4a1714feb503cbc85629417266cf","hostname":"EderCortes"}	2024-11-04 21:21:49
33669	9d69b4d5-2daf-4ec9-a7f0-ed2a53b2ea05	9d69b4d5-37f5-4640-86ba-73d1919923a8	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:452","changes":{"itemloans_status":"Abono","itemloans_aprobador":12,"updated_at":"2024-11-04 21:21:49","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":60000,"itemloans_cuota_cancelada":240000},"hostname":"EderCortes"}	2024-11-04 21:21:49
33670	9d69b4d5-2e24-4113-9bc6-d6807c4c260a	9d69b4d5-37f5-4640-86ba-73d1919923a8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"delete from \\"item_loans\\" where \\"loans_codigo\\" = 84 and \\"itemloans_status\\" = 'Pendiente'","time":"0.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":627,"hash":"89bf3c496a8b0746ff5d1219b8dc29e3","hostname":"EderCortes"}	2024-11-04 21:21:49
33671	9d69b4d5-2eb1-4a5d-b07c-f05692e49c2b	9d69b4d5-37f5-4640-86ba-73d1919923a8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 84 limit 1","time":"0.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":630,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 21:21:49
33672	9d69b4d5-2f81-4d1d-8168-123e434150db	9d69b4d5-37f5-4640-86ba-73d1919923a8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (84, 3, 206666.66666667, 51666.666666667, 'Pendiente', 'Se realiza abono', '12-11-2024', 0, 0, '2024-11-04 21:21:49', '2024-11-04 21:21:49')","time":"0.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":688,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:21:49
33673	9d69b4d5-2fb0-4e7e-9307-f435c7037e01	9d69b4d5-37f5-4640-86ba-73d1919923a8	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:21:49
33674	9d69b4d5-301b-4a69-ad16-2506276a0932	9d69b4d5-37f5-4640-86ba-73d1919923a8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (84, 4, 206666.66666667, 51666.666666667, 'Pendiente', 'Se realiza abono', '20-11-2024', 0, 0, '2024-11-04 21:21:49', '2024-11-04 21:21:49')","time":"0.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":688,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:21:49
33675	9d69b4d5-303f-4437-9782-9a031ef62f70	9d69b4d5-37f5-4640-86ba-73d1919923a8	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:21:49
33676	9d69b4d5-30d1-4d89-9378-f7af32dafcda	9d69b4d5-37f5-4640-86ba-73d1919923a8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (84, 5, 206666.66666667, 51666.666666667, 'Pendiente', 'Se realiza abono', '28-11-2024', 0, 0, '2024-11-04 21:21:49', '2024-11-04 21:21:49')","time":"0.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":688,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:21:49
33677	9d69b4d5-30fb-4478-a325-c1c25f06ae5a	9d69b4d5-37f5-4640-86ba-73d1919923a8	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:21:49
33678	9d69b4d5-3631-457b-8d2b-3f88fae3ad76	9d69b4d5-37f5-4640-86ba-73d1919923a8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:21:49
33679	9d69b4d5-3690-4224-bf91-6ea62c28b2e0	9d69b4d5-37f5-4640-86ba-73d1919923a8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"61","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"300000","idLoans":84,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El abono fue aplicado exitosamente","status":true},"duration":339,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:21:49
34941	9d69c11b-c2db-4e21-a84f-31f614973755	9d69c11b-f461-40be-aa95-65c459516cb4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 21:56:09
34942	9d69c11b-f237-48e0-96ac-b817b8c69705	9d69c11b-f461-40be-aa95-65c459516cb4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 21:56:09
34943	9d69c11b-f30a-49b6-bb5e-1afc55278c0c	9d69c11b-f461-40be-aa95-65c459516cb4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":444,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:56:09
33680	9d69b4d6-1851-402e-a172-fcfcf0e77e63	9d69b4d6-3ac9-4393-a31b-133879df4b8e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:21:50
33681	9d69b4d6-3138-4dbb-a9e3-1664867a99f7	9d69b4d6-3ac9-4393-a31b-133879df4b8e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 84\\n                        ","time":"50.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"ab3bc7b9a0b897ddfe4287a88fc64c84","hostname":"EderCortes"}	2024-11-04 21:21:50
33682	9d69b4d6-3545-433e-8946-2bdf8b6dc7f1	9d69b4d6-3ac9-4393-a31b-133879df4b8e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '84' order by \\"item_loans\\".\\"id\\" asc","time":"3.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:21:50
33683	9d69b4d6-3934-441b-b6af-89b72a20b3f0	9d69b4d6-3ac9-4393-a31b-133879df4b8e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:21:50
33684	9d69b4d6-398d-46a1-8e05-3ad886dbd6eb	9d69b4d6-3ac9-4393-a31b-133879df4b8e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/84","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":84,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"480000","loans_pago_interes":"120000","user_alias":"eder.cortes"},"items":[{"id":326,"loans_codigo":84,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 21:20:45","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":452,"loans_codigo":84,"itemloans_cuota":"4","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 21:20:45","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":456,"loans_codigo":84,"itemloans_cuota":"3","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:21:49","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":457,"loans_codigo":84,"itemloans_cuota":"4","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:21:49","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":458,"loans_codigo":84,"itemloans_cuota":"5","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:21:49","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":325,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:21:50
34944	9d69c11c-9072-4cad-81aa-edf4dba3d771	9d69c11c-bb90-4102-a0f1-eec492556c99	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 21:56:10
34945	9d69c11c-b303-416b-832a-012e7b86787d	9d69c11c-bb90-4102-a0f1-eec492556c99	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"63.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 21:56:10
34946	9d69c11c-b96c-4a4c-ab82-efe83140dda6	9d69c11c-bb90-4102-a0f1-eec492556c99	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-04 21:56:10
34947	9d69c11c-ba23-4e84-a00e-1cce35c41b33	9d69c11c-bb90-4102-a0f1-eec492556c99	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":416,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:56:10
33685	9d69b4fa-fd2f-451c-be94-b9295cdd47df	9d69b4fb-0128-4203-a667-58537658e303	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":171,"memory":20,"hostname":"EderCortes"}	2024-11-04 21:22:14
34948	9d69c11d-2ac9-45e8-9859-0e36b2c3226a	9d69c11d-60b3-486c-88e8-354f78e2d5a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-04 21:56:10
34949	9d69c11d-55ee-4b4e-bc8f-4660cd6d5105	9d69c11d-60b3-486c-88e8-354f78e2d5a7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"76.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:56:10
34950	9d69c11d-56a0-4d62-ab8b-97dde4bc7a90	9d69c11d-60b3-486c-88e8-354f78e2d5a7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:56:10
34951	9d69c11d-5e95-40f5-8d29-68f37c9ea8ca	9d69c11d-60b3-486c-88e8-354f78e2d5a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-04 21:56:10
34952	9d69c11d-5f36-478b-a341-60ed04f98beb	9d69c11d-60b3-486c-88e8-354f78e2d5a7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":403,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:56:10
34953	9d69c11e-8e36-47c3-9703-78e5b990da8c	9d69c11e-c0cc-4e9f-a4da-72809964a594	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-04 21:56:11
33690	9d69b4fc-2d89-4e91-a57b-faf12437ae1b	9d69b4fc-78a9-4fee-af71-c9d7ab508b40	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:22:15
33691	9d69b4fc-70bc-42d4-92a4-a13f603b415d	9d69b4fc-78a9-4fee-af71-c9d7ab508b40	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 84\\n                        ","time":"157.92","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"ab3bc7b9a0b897ddfe4287a88fc64c84","hostname":"EderCortes"}	2024-11-04 21:22:15
33692	9d69b4fc-7423-40eb-ab7b-2c04a7bbeca7	9d69b4fc-78a9-4fee-af71-c9d7ab508b40	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '84' order by \\"item_loans\\".\\"id\\" asc","time":"3.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:22:15
33693	9d69b4fc-775b-4861-bd1d-38542178dd18	9d69b4fc-78a9-4fee-af71-c9d7ab508b40	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:22:15
33694	9d69b4fc-77af-4f23-b659-7a93b363ba35	9d69b4fc-78a9-4fee-af71-c9d7ab508b40	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/84","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":84,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"480000","loans_pago_interes":"120000","user_alias":"eder.cortes"},"items":[{"id":326,"loans_codigo":84,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 21:20:45","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":452,"loans_codigo":84,"itemloans_cuota":"4","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 21:20:45","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":456,"loans_codigo":84,"itemloans_cuota":"3","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:21:49","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":457,"loans_codigo":84,"itemloans_cuota":"4","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:21:49","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":458,"loans_codigo":84,"itemloans_cuota":"5","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:21:49","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":382,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:22:15
34954	9d69c11e-b64b-4c90-a380-5e2bdbf9aa0f	9d69c11e-c0cc-4e9f-a4da-72809964a594	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"61.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:56:11
34955	9d69c11e-b6d7-4e92-8bf3-174ff0cacb1b	9d69c11e-c0cc-4e9f-a4da-72809964a594	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:56:11
34956	9d69c11e-bea7-4f7d-9f07-d925472a1d94	9d69c11e-c0cc-4e9f-a4da-72809964a594	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-04 21:56:11
34957	9d69c11e-bf3a-4633-9b41-521ff6899a99	9d69c11e-c0cc-4e9f-a4da-72809964a594	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":490,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:56:11
33695	9d69b502-e03d-487a-a812-ae1bfa1e38ed	9d69b502-e424-401c-afe1-c6a3903e8be9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":155,"memory":20,"hostname":"EderCortes"}	2024-11-04 21:22:19
33710	9d69b503-d41c-4685-992e-76202d78ab38	9d69b504-212a-482b-90b2-a5c457b201d4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:22:20
33711	9d69b504-1931-47ce-a151-193b57f12021	9d69b504-212a-482b-90b2-a5c457b201d4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 84\\n                        ","time":"163.88","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"ab3bc7b9a0b897ddfe4287a88fc64c84","hostname":"EderCortes"}	2024-11-04 21:22:20
33712	9d69b504-1c93-44b4-bb81-cf9e0b7be3b9	9d69b504-212a-482b-90b2-a5c457b201d4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '84' order by \\"item_loans\\".\\"id\\" asc","time":"3.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:22:20
33713	9d69b504-1fb2-4a71-bb3b-2950320fc5b9	9d69b504-212a-482b-90b2-a5c457b201d4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:22:20
33714	9d69b504-2007-4d39-9784-700f0150fbe3	9d69b504-212a-482b-90b2-a5c457b201d4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/84","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":84,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"480000","loans_pago_interes":"120000","user_alias":"eder.cortes"},"items":[{"id":326,"loans_codigo":84,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 21:20:45","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":452,"loans_codigo":84,"itemloans_cuota":"4","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 21:20:45","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":456,"loans_codigo":84,"itemloans_cuota":"3","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:21:49","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":457,"loans_codigo":84,"itemloans_cuota":"4","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:21:49","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":458,"loans_codigo":84,"itemloans_cuota":"5","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:21:49","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":359,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:22:20
38569	9d6b66d2-de0b-4d79-ade9-af6fd793def0	9d6b66d3-056e-4b47-8a74-00cec7282482	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 17:35:21
38570	9d6b66d3-02c9-47a1-93f1-1117f8374495	9d6b66d3-056e-4b47-8a74-00cec7282482	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:35:21
38571	9d6b66d3-040f-482b-8de3-604fe943031b	9d6b66d3-056e-4b47-8a74-00cec7282482	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":273,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:35:21
33715	9d69b51b-ceef-4981-937e-dfe080ca72fc	9d69b51c-1622-4e4e-aef0-567126f671c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:22:36
33716	9d69b51c-1125-4f8c-845c-377ce36339ca	9d69b51c-1622-4e4e-aef0-567126f671c9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"151.29","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 21:22:36
33717	9d69b51c-1493-44c0-bbbc-f6f7f3cd6d3b	9d69b51c-1622-4e4e-aef0-567126f671c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:22:36
33718	9d69b51c-1509-415b-a4bc-a1fec14879ba	9d69b51c-1622-4e4e-aef0-567126f671c9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":337,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:22:36
38572	9d6b66d3-727f-43d3-a2ba-01073843f7f7	9d6b66d3-9e5c-402e-8d57-479daeb1a631	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:35:21
38573	9d6b66d3-98bd-4278-8d1a-aaee8c66af10	9d6b66d3-9e5c-402e-8d57-479daeb1a631	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"77.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":125,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:35:22
38574	9d6b66d3-9cfb-4972-bc43-65b0c980cb0e	9d6b66d3-9e5c-402e-8d57-479daeb1a631	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:35:22
38575	9d6b66d3-9d67-45c1-8a67-3c55c0f1b0c7	9d6b66d3-9e5c-402e-8d57-479daeb1a631	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":323,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:35:22
33719	9d69b539-0b02-4424-bc73-cc25232a5086	9d69b539-2efd-4e31-898a-dcfcc316203b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 21:22:55
33720	9d69b539-2699-4ef4-be33-2249c05b6852	9d69b539-2efd-4e31-898a-dcfcc316203b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 83\\n                        ","time":"42.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"1ce8426fac58478ecd9d020fe17d01c5","hostname":"EderCortes"}	2024-11-04 21:22:55
33721	9d69b539-2998-41f4-82e8-564a546cacc0	9d69b539-2efd-4e31-898a-dcfcc316203b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '83' order by \\"item_loans\\".\\"id\\" asc","time":"2.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:22:55
33722	9d69b539-2d4f-4e5a-86fd-b0a887b6ddc2	9d69b539-2efd-4e31-898a-dcfcc316203b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:22:55
33723	9d69b539-2dc8-46ec-b78e-d01a14d5dfce	9d69b539-2efd-4e31-898a-dcfcc316203b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/83","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":83,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0","user_alias":"eder.cortes"},"items":[{"id":321,"loans_codigo":83,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 09:18:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":322,"loans_codigo":83,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 09:18:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":323,"loans_codigo":83,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 09:18:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":324,"loans_codigo":83,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 09:18:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":325,"loans_codigo":83,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 09:18:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":285,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:22:55
38576	9d6b66d3-e234-404a-a453-61e4a715a72b	9d6b66d4-0192-4ea7-b3c5-afff444de91e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:35:22
38577	9d6b66d3-fcbe-43e5-8200-89a4b30b8066	9d6b66d4-0192-4ea7-b3c5-afff444de91e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:35:22
38578	9d6b66d3-fd1d-426c-9790-f62a177e0b57	9d6b66d4-0192-4ea7-b3c5-afff444de91e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:35:22
38579	9d6b66d4-004c-4bf9-9da2-dd791040da84	9d6b66d4-0192-4ea7-b3c5-afff444de91e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:35:22
38580	9d6b66d4-008e-435a-afaf-6786a42c5f54	9d6b66d4-0192-4ea7-b3c5-afff444de91e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:35:22
33724	9d69b54a-cece-495c-b9ce-ca74c0d446d2	9d69b54a-d300-469e-8ffa-2d0de6dbfe8b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":185,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:23:07
38581	9d6b66d4-49ab-46a0-a981-f1b9451b5e90	9d6b66d4-6811-44c2-85dd-36012decb8df	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:35:22
38582	9d6b66d4-62dd-4947-8b4b-35ce27a05cce	9d6b66d4-6811-44c2-85dd-36012decb8df	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:35:22
38583	9d6b66d4-634f-43ec-840e-d22bfba09b72	9d6b66d4-6811-44c2-85dd-36012decb8df	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:35:22
38584	9d6b66d4-66ec-4cdf-b4db-71e124bc296f	9d6b66d4-6811-44c2-85dd-36012decb8df	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:35:22
38585	9d6b66d4-6734-41c5-9615-1623a1599eaf	9d6b66d4-6811-44c2-85dd-36012decb8df	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:35:22
38586	9d6b66d6-05d6-4c68-84a0-aef1a3cf8057	9d6b66d6-25dd-47af-9383-6f099a5a3a18	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:35:23
33739	9d69b54b-dd58-497e-bd7d-9303c92804c3	9d69b54b-fba3-4503-8f65-7624f4056c0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:23:07
33740	9d69b54b-f348-429f-bf53-d6c84ea4ba02	9d69b54b-fba3-4503-8f65-7624f4056c0d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 83\\n                        ","time":"43.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"1ce8426fac58478ecd9d020fe17d01c5","hostname":"EderCortes"}	2024-11-04 21:23:07
33741	9d69b54b-f6e5-4abe-95c3-503e0635e26c	9d69b54b-fba3-4503-8f65-7624f4056c0d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '83' order by \\"item_loans\\".\\"id\\" asc","time":"3.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:23:07
33742	9d69b54b-fa4b-499b-9c6c-ea77c6cbce2a	9d69b54b-fba3-4503-8f65-7624f4056c0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:23:07
33743	9d69b54b-faa5-44ce-beae-fe7daf61f003	9d69b54b-fba3-4503-8f65-7624f4056c0d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/83","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":83,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0","user_alias":"eder.cortes"},"items":[{"id":321,"loans_codigo":83,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 09:18:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":322,"loans_codigo":83,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 09:18:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":323,"loans_codigo":83,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 09:18:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":324,"loans_codigo":83,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 09:18:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":325,"loans_codigo":83,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 09:18:37","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":311,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:23:07
38587	9d6b66d6-205a-4cdb-aaba-f81399548057	9d6b66d6-25dd-47af-9383-6f099a5a3a18	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:35:23
38588	9d6b66d6-20a8-473e-ba55-04f8ce72d299	9d6b66d6-25dd-47af-9383-6f099a5a3a18	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:35:23
38589	9d6b66d6-243b-41eb-8a34-e36b9d826553	9d6b66d6-25dd-47af-9383-6f099a5a3a18	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:35:23
38590	9d6b66d6-24ab-4ffe-bd89-fe91464e85ad	9d6b66d6-25dd-47af-9383-6f099a5a3a18	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":341,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:35:23
38591	9d6b66d6-74f1-4fdd-b081-d657b27c103c	9d6b66d6-92f5-4fef-ba81-d9dfce233fa2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:35:23
30141	9d693483-cd0c-41c8-9a5c-fcea3f33210b	9d693484-1be7-44e7-b0be-53af2cd4f29f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 15:23:01
30142	9d693484-1976-40bb-835b-8ea0ca244e1d	9d693484-1be7-44e7-b0be-53af2cd4f29f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 15:23:01
30143	9d693484-1a9d-48ed-8bd9-c7721634e179	9d693484-1be7-44e7-b0be-53af2cd4f29f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":399,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:23:01
38592	9d6b66d6-8e56-4399-acaa-5c2d5230377a	9d6b66d6-92f5-4fef-ba81-d9dfce233fa2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"46.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":125,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:35:23
38593	9d6b66d6-9145-474a-a615-a76a122e4fff	9d6b66d6-92f5-4fef-ba81-d9dfce233fa2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:35:23
38594	9d6b66d6-91af-42fb-a1df-9766294db542	9d6b66d6-92f5-4fef-ba81-d9dfce233fa2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"0","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":263,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:35:23
33744	9d69b64c-45b8-4804-a30d-b05e069ef579	9d69b64c-4bd9-4b5f-963e-e3d7e2f0a50a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":249,"memory":20,"hostname":"EderCortes"}	2024-11-04 21:25:55
30144	9d693484-7dbf-49ad-b43d-e828eb4023af	9d693484-a03a-4b7d-ba16-f9aa6db556c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 15:23:02
30145	9d693484-95bf-43d9-a01c-bd459b32b646	9d693484-a03a-4b7d-ba16-f9aa6db556c4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"45.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 15:23:02
30146	9d693484-9a75-4e10-ae93-fcd6d97aa0cf	9d693484-a03a-4b7d-ba16-f9aa6db556c4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 15:23:02
30147	9d693484-9ab2-477d-82ac-baebb4368de2	9d693484-a03a-4b7d-ba16-f9aa6db556c4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 15:23:02
30148	9d693484-9ea0-4a36-a370-c12327e3ca8f	9d693484-a03a-4b7d-ba16-f9aa6db556c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 15:23:02
30149	9d693484-9f04-4956-9e1f-845c22ddc05f	9d693484-a03a-4b7d-ba16-f9aa6db556c4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":274,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:23:02
33745	9d69b64c-c0f4-4ed2-a2bd-75d0eca1f4fb	9d69b64c-f9d6-4659-b79d-c5d077e883ca	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 21:25:56
33746	9d69b64c-e49c-4116-98b4-cc20330d94b1	9d69b64c-f9d6-4659-b79d-c5d077e883ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 83 limit 1","time":"3.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":505,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 21:25:56
33747	9d69b64c-e52e-4241-8f0a-10c327d3a29e	9d69b64c-f9d6-4659-b79d-c5d077e883ca	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":2,"hostname":"EderCortes"}	2024-11-04 21:25:56
33748	9d69b64c-e780-4c61-a315-c9e6a2113654	9d69b64c-f9d6-4659-b79d-c5d077e883ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select count(*) as aggregate from \\"item_loans\\" where \\"loans_codigo\\" = 83 and (\\"itemloans_status\\" = 'Pagada' or \\"itemloans_status\\" = 'Abono')","time":"2.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":566,"hash":"40bb62c1101cd4a074e44b13c59d4517","hostname":"EderCortes"}	2024-11-04 21:25:56
33749	9d69b64c-e84f-4968-bf0b-774b221c7dae	9d69b64c-f9d6-4659-b79d-c5d077e883ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_estado\\" = 'En curso', \\"loans_pago_interes\\" = 60000, \\"loans_pago_prestado\\" = 240000, \\"updated_at\\" = '2024-11-04 21:25:56' where \\"id\\" = 83","time":"0.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":605,"hash":"acfe32aea56c9ca6bdbb917f944a78d1","hostname":"EderCortes"}	2024-11-04 21:25:56
33750	9d69b64c-e8c3-4707-8c46-e9816e71ea63	9d69b64c-f9d6-4659-b79d-c5d077e883ca	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:83","changes":{"loans_estado":"En curso","updated_at":"2024-11-04 21:25:56","loans_pago_interes":60000,"loans_pago_prestado":240000},"hostname":"EderCortes"}	2024-11-04 21:25:56
33751	9d69b64c-e97f-4e95-ab91-b470127d7bb5	9d69b64c-f9d6-4659-b79d-c5d077e883ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 83 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"1.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":612,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 21:25:56
33752	9d69b64c-e9b2-4436-a54e-162284967bf5	9d69b64c-f9d6-4659-b79d-c5d077e883ca	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 21:25:56
33753	9d69b64c-ea43-4682-aa01-b60add57abac	9d69b64c-f9d6-4659-b79d-c5d077e883ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Abono', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = 60000, \\"itemloans_cuota_cancelada\\" = 240000, \\"updated_at\\" = '2024-11-04 21:25:56' where \\"id\\" = 321","time":"0.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":620,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 21:25:56
33754	9d69b64c-ea80-469f-bab4-8166d97f9c39	9d69b64c-f9d6-4659-b79d-c5d077e883ca	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:321","changes":{"itemloans_status":"Abono","updated_at":"2024-11-04 21:25:56","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":60000,"itemloans_cuota_cancelada":240000},"hostname":"EderCortes"}	2024-11-04 21:25:56
33755	9d69b64c-eb0e-4276-926d-666d1d02e888	9d69b64c-f9d6-4659-b79d-c5d077e883ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"delete from \\"item_loans\\" where \\"loans_codigo\\" = 83 and \\"itemloans_status\\" = 'Pendiente'","time":"0.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":627,"hash":"89bf3c496a8b0746ff5d1219b8dc29e3","hostname":"EderCortes"}	2024-11-04 21:25:56
33756	9d69b64c-eb8f-4b66-952f-2ffba9d450fd	9d69b64c-f9d6-4659-b79d-c5d077e883ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 83 limit 1","time":"0.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":630,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 21:25:56
33757	9d69b64c-ec5e-4d17-b13a-05e9ad531aad	9d69b64c-f9d6-4659-b79d-c5d077e883ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (83, 1, 172000, 43000, 'Pendiente', 'Se realiza abono', '12-11-2024', 0, 0, '2024-11-04 21:25:56', '2024-11-04 21:25:56')","time":"0.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":693,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:25:56
33758	9d69b64c-ec8a-44c5-b125-45e223255a9e	9d69b64c-f9d6-4659-b79d-c5d077e883ca	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:25:56
33759	9d69b64c-ed07-4bb1-a9b4-7e6cd8768f3a	9d69b64c-f9d6-4659-b79d-c5d077e883ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (83, 2, 172000, 43000, 'Pendiente', 'Se realiza abono', '20-11-2024', 0, 0, '2024-11-04 21:25:56', '2024-11-04 21:25:56')","time":"0.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":693,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:25:56
33760	9d69b64c-ed33-4bea-9e25-e1bb3e243028	9d69b64c-f9d6-4659-b79d-c5d077e883ca	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:25:56
33761	9d69b64c-edb7-4ceb-b5df-99fcd5207dca	9d69b64c-f9d6-4659-b79d-c5d077e883ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (83, 3, 172000, 43000, 'Pendiente', 'Se realiza abono', '28-11-2024', 0, 0, '2024-11-04 21:25:56', '2024-11-04 21:25:56')","time":"0.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":693,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:25:56
33762	9d69b64c-edf5-4d93-8bfd-aaffda6654ec	9d69b64c-f9d6-4659-b79d-c5d077e883ca	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:25:56
33763	9d69b64c-ee8d-4a80-b082-1a54ab1d2abf	9d69b64c-f9d6-4659-b79d-c5d077e883ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (83, 4, 172000, 43000, 'Pendiente', 'Se realiza abono', '06-12-2024', 0, 0, '2024-11-04 21:25:56', '2024-11-04 21:25:56')","time":"0.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":693,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:25:56
33764	9d69b64c-eeb3-4cc8-b6e4-ad9198db9e86	9d69b64c-f9d6-4659-b79d-c5d077e883ca	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:25:56
33765	9d69b64c-ef27-4030-8890-ccb852b331a1	9d69b64c-f9d6-4659-b79d-c5d077e883ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (83, 5, 172000, 43000, 'Pendiente', 'Se realiza abono', '14-12-2024', 0, 0, '2024-11-04 21:25:56', '2024-11-04 21:25:56')","time":"0.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":693,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:25:56
33766	9d69b64c-ef4f-4980-b58a-3532aa22fe90	9d69b64c-f9d6-4659-b79d-c5d077e883ca	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:25:56
33767	9d69b64c-f7fb-4ce2-a43a-4bf2c6fdda49	9d69b64c-f9d6-4659-b79d-c5d077e883ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:25:56
33768	9d69b64c-f861-48e3-bf48-b656bc94d5fc	9d69b64c-f9d6-4659-b79d-c5d077e883ca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"61","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"300000","idLoans":83,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El abono fue aplicado exitosamente","status":true},"duration":362,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:25:56
33769	9d69b64e-0fb2-4712-b9f1-1ea8251c5f5e	9d69b64e-33de-4646-9e64-7d0c17a6135c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:25:56
33770	9d69b64e-2abe-4336-ab02-6b83d7561787	9d69b64e-33de-4646-9e64-7d0c17a6135c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 83\\n                        ","time":"48.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"1ce8426fac58478ecd9d020fe17d01c5","hostname":"EderCortes"}	2024-11-04 21:25:57
33771	9d69b64e-2e37-4356-ae9d-ace12253c039	9d69b64e-33de-4646-9e64-7d0c17a6135c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '83' order by \\"item_loans\\".\\"id\\" asc","time":"3.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:25:57
33772	9d69b64e-31f2-4a6f-b77b-2ddef3be6f99	9d69b64e-33de-4646-9e64-7d0c17a6135c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:25:57
33773	9d69b64e-3254-49e9-b09b-ac8b3340eeb9	9d69b64e-33de-4646-9e64-7d0c17a6135c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/83","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":83,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"240000","loans_pago_interes":"60000","user_alias":"eder.cortes"},"items":[{"id":321,"loans_codigo":83,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 21:25:56","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":459,"loans_codigo":83,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:25:56","updated_at":"2024-11-04 21:25:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":460,"loans_codigo":83,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:25:56","updated_at":"2024-11-04 21:25:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":461,"loans_codigo":83,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:25:56","updated_at":"2024-11-04 21:25:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":462,"loans_codigo":83,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:25:56","updated_at":"2024-11-04 21:25:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":463,"loans_codigo":83,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:25:56","updated_at":"2024-11-04 21:25:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":458,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:25:57
33774	9d69b670-b04d-414b-a9a0-a8227b370b45	9d69b670-b429-4f05-ad40-52499317c138	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":167,"memory":20,"hostname":"EderCortes"}	2024-11-04 21:26:19
33779	9d69b671-e205-4a5a-8b5e-8094e602f0d2	9d69b671-e52d-4d40-9dae-e843e958741e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-total-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":167,"memory":20,"hostname":"EderCortes"}	2024-11-04 21:26:20
31888	9d69572c-1393-497d-8ac3-4fbb56f84365	9d69572c-3260-4b9b-9aa3-65380f2c9be3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:59:56
31889	9d69572c-30e8-4d59-b61a-6a6df5c342e6	9d69572c-3260-4b9b-9aa3-65380f2c9be3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:59:56
31890	9d69572c-318c-41eb-a59c-8c3b2d163355	9d69572c-3260-4b9b-9aa3-65380f2c9be3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":284,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:59:56
31891	9d69572c-9b06-452d-aaa7-95889cf8fa30	9d69572c-a1f6-45ef-8ea1-089b4f9299e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:59:56
31892	9d69572c-a0b3-4aed-99bc-8c92558d4a8a	9d69572c-a1f6-45ef-8ea1-089b4f9299e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:59:56
31893	9d69572c-a113-4cec-9f82-e1a9769bba0a	9d69572c-a1f6-45ef-8ea1-089b4f9299e1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":"kasbjfdsajdkjbsajk"},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:59:56
33780	9d69b672-3ce2-4601-95c3-7bad63cd1824	9d69b672-8231-4ada-b14d-20c98d54b9db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:26:20
33781	9d69b672-7a86-494b-86c5-44f16dd5ee09	9d69b672-8231-4ada-b14d-20c98d54b9db	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 83\\n                        ","time":"144.58","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"1ce8426fac58478ecd9d020fe17d01c5","hostname":"EderCortes"}	2024-11-04 21:26:20
33782	9d69b672-7d36-4cfb-9b27-10286a5bfec5	9d69b672-8231-4ada-b14d-20c98d54b9db	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '83' order by \\"item_loans\\".\\"id\\" asc","time":"2.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:26:20
33783	9d69b672-80ca-4021-9263-141583ab0cb0	9d69b672-8231-4ada-b14d-20c98d54b9db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:26:20
33784	9d69b672-812c-4af5-845f-a36e5fd9eb5c	9d69b672-8231-4ada-b14d-20c98d54b9db	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/83","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":83,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"240000","loans_pago_interes":"60000","user_alias":"eder.cortes"},"items":[{"id":321,"loans_codigo":83,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 21:25:56","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":459,"loans_codigo":83,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:25:56","updated_at":"2024-11-04 21:25:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":460,"loans_codigo":83,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:25:56","updated_at":"2024-11-04 21:25:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":461,"loans_codigo":83,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:25:56","updated_at":"2024-11-04 21:25:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":462,"loans_codigo":83,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:25:56","updated_at":"2024-11-04 21:25:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":463,"loans_codigo":83,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:25:56","updated_at":"2024-11-04 21:25:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":343,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:26:20
31894	9d69572d-2531-4a60-a749-7c6df676a1f6	9d69572d-2d75-4c1e-a4f9-dfeaa6495249	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:59:57
31895	9d69572d-2c2a-436b-9df3-ac5f49a265b3	9d69572d-2d75-4c1e-a4f9-dfeaa6495249	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 16:59:57
31896	9d69572d-2c85-4975-90e4-ee9990cf0fa7	9d69572d-2d75-4c1e-a4f9-dfeaa6495249	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":"kasbjfdsajdkjbsajk"},"duration":188,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:59:57
33785	9d69b672-ce0a-44d5-9735-9dd3a26ccc0b	9d69b672-efbc-4878-ad29-fe7144ee684f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:26:21
33786	9d69b672-e586-4c3f-bee4-2bcde081555f	9d69b672-efbc-4878-ad29-fe7144ee684f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 83 limit 1","time":"2.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":731,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 21:26:21
33787	9d69b672-e5d9-467e-a5be-960bdd45bad5	9d69b672-efbc-4878-ad29-fe7144ee684f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 21:26:21
33788	9d69b672-e6f3-4a16-8b7e-e5b868709e78	9d69b672-efbc-4878-ad29-fe7144ee684f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_estado\\" = 'Cancelado', \\"loans_pago_interes\\" = 275000, \\"loans_pago_prestado\\" = 1100000, \\"updated_at\\" = '2024-11-04 21:26:21' where \\"id\\" = 83","time":"0.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":756,"hash":"acfe32aea56c9ca6bdbb917f944a78d1","hostname":"EderCortes"}	2024-11-04 21:26:21
33789	9d69b672-e74a-4ea4-8f1b-b51137efbd36	9d69b672-efbc-4878-ad29-fe7144ee684f	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:83","changes":{"loans_estado":"Cancelado","updated_at":"2024-11-04 21:26:21","loans_pago_interes":275000,"loans_pago_prestado":1100000},"hostname":"EderCortes"}	2024-11-04 21:26:21
33790	9d69b672-e8b0-40ec-b2c9-ef896c9e5de2	9d69b672-efbc-4878-ad29-fe7144ee684f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 83 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"2.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":761,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 21:26:21
33791	9d69b672-e8e8-490e-ab2d-ece7ddf89c58	9d69b672-efbc-4878-ad29-fe7144ee684f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 21:26:21
33792	9d69b672-ea0b-4652-a2cb-e4baea4f152c	9d69b672-efbc-4878-ad29-fe7144ee684f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_interes_canelado\\" = '43000', \\"itemloans_cuota_cancelada\\" = '172000', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_status\\" = 'Pagada', \\"itemloans_aprobador\\" = 12, \\"updated_at\\" = '2024-11-04 21:26:21' where \\"loans_codigo\\" = 83 and \\"itemloans_status\\" = 'Pendiente'","time":"2.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":770,"hash":"87a64c6113219082cd85f391b598ec7f","hostname":"EderCortes"}	2024-11-04 21:26:21
33793	9d69b672-edff-4099-8132-778400d6a786	9d69b672-efbc-4878-ad29-fe7144ee684f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:26:21
33794	9d69b672-ee8b-41ce-a8e9-9b74d1dfc499	9d69b672-efbc-4878-ad29-fe7144ee684f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-total-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payTotal","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"39","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"idLoans":83,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"Se ha realizado el pago total del credito","status":true},"duration":260,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:26:21
31897	9d69572d-90dd-4cb1-b6f6-9acb4c0accfd	9d69572d-b092-4e74-97a5-ac12e80fc5a9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 16:59:57
31898	9d69572d-ab19-4fb5-aa68-00c4d3995ea2	9d69572d-b092-4e74-97a5-ac12e80fc5a9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:59:57
31899	9d69572d-ab83-44a8-a6e4-e504f796fd04	9d69572d-b092-4e74-97a5-ac12e80fc5a9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 16:59:57
31900	9d69572d-af77-4957-89ea-3efd0a4ee8a5	9d69572d-b092-4e74-97a5-ac12e80fc5a9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 16:59:57
31901	9d69572d-afbe-4efa-b81a-0bfde77bd4d6	9d69572d-b092-4e74-97a5-ac12e80fc5a9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":264,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:59:57
33795	9d69b673-3d84-4129-b8d2-8a98e042cb3e	9d69b673-5ae3-442b-a771-432fd4e59055	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:26:21
33796	9d69b673-5362-4d7b-bfb6-3f87422c471d	9d69b673-5ae3-442b-a771-432fd4e59055	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 83\\n                        ","time":"42.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"1ce8426fac58478ecd9d020fe17d01c5","hostname":"EderCortes"}	2024-11-04 21:26:21
33797	9d69b673-5654-4756-9c85-af22d494dc10	9d69b673-5ae3-442b-a771-432fd4e59055	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '83' order by \\"item_loans\\".\\"id\\" asc","time":"2.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:26:21
33798	9d69b673-5995-45a1-9809-3e7e61847d2c	9d69b673-5ae3-442b-a771-432fd4e59055	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:26:21
33799	9d69b673-59e7-4596-91f8-416a21e519e5	9d69b673-5ae3-442b-a771-432fd4e59055	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/83","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":83,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1100000","loans_pago_interes":"275000","user_alias":"eder.cortes"},"items":[{"id":321,"loans_codigo":83,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 21:25:56","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":459,"loans_codigo":83,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 21:25:56","updated_at":"2024-11-04 21:26:21","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000","user_alias":"eder.cortes"},{"id":460,"loans_codigo":83,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 21:25:56","updated_at":"2024-11-04 21:26:21","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000","user_alias":"eder.cortes"},{"id":461,"loans_codigo":83,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 21:25:56","updated_at":"2024-11-04 21:26:21","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000","user_alias":"eder.cortes"},{"id":462,"loans_codigo":83,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 21:25:56","updated_at":"2024-11-04 21:26:21","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000","user_alias":"eder.cortes"},{"id":463,"loans_codigo":83,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 21:25:56","updated_at":"2024-11-04 21:26:21","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000","user_alias":"eder.cortes"}]}},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:26:21
33800	9d69b679-110b-47ce-9742-e402ab4636df	9d69b679-2de2-404c-be50-11a65f0557ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:26:25
33801	9d69b679-2872-4dd0-be90-579a372907d6	9d69b679-2de2-404c-be50-11a65f0557ba	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"47.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":24,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-04 21:26:25
33802	9d69b679-2c5f-4761-a486-a0c620dae4eb	9d69b679-2de2-404c-be50-11a65f0557ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:26:25
33803	9d69b679-2cd6-4412-9a55-4466e36d591d	9d69b679-2de2-404c-be50-11a65f0557ba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:26:25
33804	9d69b679-b7b8-4300-9b6d-18df11daad42	9d69b679-d741-4f16-a18b-4486616b2dda	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:26:25
33805	9d69b679-d2a8-4471-a833-680c27d9b009	9d69b679-d741-4f16-a18b-4486616b2dda	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"46.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 21:26:25
33806	9d69b679-d5cb-4f63-8254-f3812ca81531	9d69b679-d741-4f16-a18b-4486616b2dda	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 21:26:25
33807	9d69b679-d63d-4ac8-ac8c-601c688f9d5f	9d69b679-d741-4f16-a18b-4486616b2dda	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:26:25
33808	9d69b688-1ab3-4005-9b30-026be5b1118e	9d69b688-63bb-46ab-a5b2-c6860b1c0e5e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 21:26:35
33809	9d69b688-5c92-4813-bee5-60dd990a677b	9d69b688-63bb-46ab-a5b2-c6860b1c0e5e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 82\\n                        ","time":"154.74","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"23238af5dc47e80ea555e80a08e2015d","hostname":"EderCortes"}	2024-11-04 21:26:35
33810	9d69b688-5f19-4e25-bf63-3d979ff5560f	9d69b688-63bb-46ab-a5b2-c6860b1c0e5e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '82' order by \\"item_loans\\".\\"id\\" asc","time":"2.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:26:35
33811	9d69b688-6229-4bea-8c71-e6233c9a73da	9d69b688-63bb-46ab-a5b2-c6860b1c0e5e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 21:26:35
33812	9d69b688-6298-44e9-b57d-8439be769a2f	9d69b688-63bb-46ab-a5b2-c6860b1c0e5e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/82","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":82,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0","user_alias":"eder.cortes"},"items":[{"id":316,"loans_codigo":82,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:36","updated_at":"2024-11-04 09:18:36","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":317,"loans_codigo":82,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:36","updated_at":"2024-11-04 09:18:36","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":318,"loans_codigo":82,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:36","updated_at":"2024-11-04 09:18:36","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":319,"loans_codigo":82,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:36","updated_at":"2024-11-04 09:18:36","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":320,"loans_codigo":82,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:36","updated_at":"2024-11-04 09:18:36","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":342,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:26:35
33813	9d69b6b2-f6ab-440f-a52f-406bf8803c0b	9d69b6b2-fb2c-4dbc-990b-50580a7b25b0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":267,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:27:03
33828	9d69b6b4-3d7b-45c3-81a5-55776770fc09	9d69b6b4-8593-4e35-8b64-468d9e3ba89a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:27:03
33829	9d69b6b4-7d7c-4de8-8954-0df627d25f69	9d69b6b4-8593-4e35-8b64-468d9e3ba89a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 82\\n                        ","time":"148.94","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"23238af5dc47e80ea555e80a08e2015d","hostname":"EderCortes"}	2024-11-04 21:27:04
33830	9d69b6b4-80c7-4a6f-a180-2e43804b5e7e	9d69b6b4-8593-4e35-8b64-468d9e3ba89a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '82' order by \\"item_loans\\".\\"id\\" asc","time":"2.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:27:04
33831	9d69b6b4-841e-4a7a-9b0b-7ee76df3e2cf	9d69b6b4-8593-4e35-8b64-468d9e3ba89a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:27:04
33832	9d69b6b4-8484-491a-b731-12db8a3ae9ba	9d69b6b4-8593-4e35-8b64-468d9e3ba89a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/82","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":82,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0","user_alias":"eder.cortes"},"items":[{"id":316,"loans_codigo":82,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:36","updated_at":"2024-11-04 09:18:36","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":317,"loans_codigo":82,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:36","updated_at":"2024-11-04 09:18:36","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":318,"loans_codigo":82,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:36","updated_at":"2024-11-04 09:18:36","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":319,"loans_codigo":82,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:36","updated_at":"2024-11-04 09:18:36","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":320,"loans_codigo":82,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:36","updated_at":"2024-11-04 09:18:36","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":415,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:27:04
35142	9d69c2de-7a07-4407-baaf-e299497b17fc	9d69c2de-993b-476d-b3a9-71297448636b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 22:01:04
35143	9d69c2de-97a4-47c5-9c84-478dadb4c021	9d69c2de-993b-476d-b3a9-71297448636b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 22:01:04
35144	9d69c2de-983d-41eb-90cb-9c0d3668ac41	9d69c2de-993b-476d-b3a9-71297448636b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":400,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:01:04
35145	9d69c2de-f3fb-442f-97bc-8d70b5cc4ef5	9d69c2df-3944-459c-ba3b-5b4864060ef2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 22:01:05
35146	9d69c2df-34d1-4d04-85a3-10c25bab2804	9d69c2df-3944-459c-ba3b-5b4864060ef2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"144.63","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 22:01:05
35147	9d69c2df-37fd-4399-9f09-a95ae70c2b40	9d69c2df-3944-459c-ba3b-5b4864060ef2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 22:01:05
35148	9d69c2df-3866-4b4b-92a9-470ea4fad0ec	9d69c2df-3944-459c-ba3b-5b4864060ef2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":343,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:01:05
35301	9d69c3ef-2810-4eb3-801e-13e58f8055a1	9d69c3ef-6117-4856-94a7-f42452dbe05f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 22:04:03
35302	9d69c3ef-5e8d-40ce-bddf-452fa5f7ff99	9d69c3ef-6117-4856-94a7-f42452dbe05f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 22:04:03
35303	9d69c3ef-5fc5-4d3c-960c-4f55c94dbbd2	9d69c3ef-6117-4856-94a7-f42452dbe05f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":453,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:04:03
35304	9d69c3f0-0c74-48b2-a570-428400a8af3e	9d69c3f0-6516-4fa8-8629-5ba34233f76f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 22:04:04
35305	9d69c3f0-5d7d-488e-bb46-a42af58e25db	9d69c3f0-6516-4fa8-8629-5ba34233f76f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"179.70","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 22:04:04
35306	9d69c3f0-629d-4161-9414-d0eb4c2e28a5	9d69c3f0-6516-4fa8-8629-5ba34233f76f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 22:04:04
35307	9d69c3f0-6356-4467-9701-402beb595951	9d69c3f0-6516-4fa8-8629-5ba34233f76f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":563,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:04:04
35308	9d69c3f0-f581-4a2b-8de9-ef647ab64010	9d69c3f1-2493-4743-9d34-5fb4e1d13ab8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 22:04:04
35309	9d69c3f1-1b2f-47ad-b7c9-fb2fdba1b3da	9d69c3f1-2493-4743-9d34-5fb4e1d13ab8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"60.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:04:04
35310	9d69c3f1-1bb4-41cb-adf9-fb16dc2d8d1d	9d69c3f1-2493-4743-9d34-5fb4e1d13ab8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:04:04
35311	9d69c3f1-228e-49cc-a367-a67b27719838	9d69c3f1-2493-4743-9d34-5fb4e1d13ab8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 22:04:04
35312	9d69c3f1-2313-47e9-a83d-99e85d7d3b2e	9d69c3f1-2493-4743-9d34-5fb4e1d13ab8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":467,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:04:04
35313	9d69c3f1-cb73-4228-bbea-34f89bae633e	9d69c3f2-2f6a-4638-9c8a-af601f8626f3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 22:04:05
35314	9d69c3f2-2498-4753-9e97-cfe4d0f08d15	9d69c3f2-2f6a-4638-9c8a-af601f8626f3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"108.95","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:04:05
35315	9d69c3f2-255a-4567-b898-9bac06a4290c	9d69c3f2-2f6a-4638-9c8a-af601f8626f3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:04:05
35316	9d69c3f2-2d5d-4ca2-b758-18c45d676cc6	9d69c3f2-2f6a-4638-9c8a-af601f8626f3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 22:04:05
35317	9d69c3f2-2dec-429f-a227-aa7afba70ed4	9d69c3f2-2f6a-4638-9c8a-af601f8626f3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":660,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:04:05
35318	9d69c3f3-2fb6-4fe9-8894-4931fd8c4057	9d69c3f3-af06-425c-bfa1-15b5594aae44	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 22:04:06
35319	9d69c3f3-a44a-4329-b09d-73cfca4e587d	9d69c3f3-af06-425c-bfa1-15b5594aae44	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"246.85","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:04:06
35320	9d69c3f3-a4e5-4322-8973-a3bb9b5095d3	9d69c3f3-af06-425c-bfa1-15b5594aae44	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:04:06
35321	9d69c3f3-ad0d-4e18-9287-f2175567be60	9d69c3f3-af06-425c-bfa1-15b5594aae44	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 22:04:06
35322	9d69c3f3-ad96-42e7-90f0-05051634d767	9d69c3f3-af06-425c-bfa1-15b5594aae44	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":715,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:04:06
29049	9d690e69-43a6-46d4-a063-4a8fe89360e5	9d690e69-79c8-4896-b832-f1c869bfbd2f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 13:36:29
29050	9d690e69-7639-4049-a436-8e331909631b	9d690e69-79c8-4896-b832-f1c869bfbd2f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 13:36:29
29051	9d690e69-77e5-4856-92f2-c4bc4e6a7527	9d690e69-79c8-4896-b832-f1c869bfbd2f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":517,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:36:29
29052	9d690e69-fc74-406d-bf1a-df4796fd679b	9d690e6a-2a2a-4f9f-9801-b9642633fa36	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 13:36:29
29053	9d690e6a-2179-4794-b267-6f585cc8b74c	9d690e6a-2a2a-4f9f-9801-b9642633fa36	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"60.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:36:29
29054	9d690e6a-2209-40ec-a5ac-4047e0aea359	9d690e6a-2a2a-4f9f-9801-b9642633fa36	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 13:36:29
29055	9d690e6a-2856-4d5e-a600-6742942bdfc6	9d690e6a-2a2a-4f9f-9801-b9642633fa36	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 13:36:29
29056	9d690e6a-28d8-4933-9db7-57b35c032972	9d690e6a-2a2a-4f9f-9801-b9642633fa36	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":359,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:36:29
29057	9d690e6a-9f90-4473-9bc0-2326c1d99db3	9d690e6a-f9a0-4a54-9697-c0804447480e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 13:36:29
29058	9d690e6a-f020-43dc-a879-dd55bd1618c2	9d690e6a-f9a0-4a54-9697-c0804447480e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"167.45","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:36:30
29059	9d690e6a-f0a4-45e2-92ae-44b1a0ccfcf2	9d690e6a-f9a0-4a54-9697-c0804447480e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 13:36:30
29060	9d690e6a-f799-432a-9af4-b67a0102f3e6	9d690e6a-f9a0-4a54-9697-c0804447480e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 13:36:30
29061	9d690e6a-f839-42df-ae23-b75631386549	9d690e6a-f9a0-4a54-9697-c0804447480e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":502,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:36:30
29062	9d690e6b-7098-4f41-82a0-ac0a260e9b95	9d690e6b-9b5b-4228-87ad-dd3c61c274c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 13:36:30
29063	9d690e6b-8fe5-424b-9ce4-458d3fb5b3e8	9d690e6b-9b5b-4228-87ad-dd3c61c274c5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '89' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"48.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 13:36:30
29064	9d690e6b-905f-4fc6-84cb-81e6edddc544	9d690e6b-9b5b-4228-87ad-dd3c61c274c5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 13:36:30
29065	9d690e6b-9280-452d-a4a0-53ffb56c6c8e	9d690e6b-9b5b-4228-87ad-dd3c61c274c5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:36:30
29066	9d690e6b-92c6-4b56-9082-e9cc92bf8599	9d690e6b-9b5b-4228-87ad-dd3c61c274c5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:36:30
29067	9d690e6b-9985-4122-b76d-4b806550e926	9d690e6b-9b5b-4228-87ad-dd3c61c274c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 13:36:30
29068	9d690e6b-9a26-4e95-a489-b1863731049c	9d690e6b-9b5b-4228-87ad-dd3c61c274c5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"146000","loans_pago_prestado":"584000","loans_intereses_recaudar":"275000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":390,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:36:30
29069	9d690e6c-1b7f-420c-8ba6-754cca0adcae	9d690e6c-5b54-4df3-a32d-e7774e1dc336	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 13:36:30
29070	9d690e6c-4ed5-452a-8d55-6650ac69f52f	9d690e6c-5b54-4df3-a32d-e7774e1dc336	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"88.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:36:31
29071	9d690e6c-4f9e-42ed-8c1a-b97a1ec0be90	9d690e6c-5b54-4df3-a32d-e7774e1dc336	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:36:31
29072	9d690e6c-5930-4613-8dfd-dfb1721303a0	9d690e6c-5b54-4df3-a32d-e7774e1dc336	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 13:36:31
29073	9d690e6c-59cf-45ac-af5d-d5e5c2dbbf4c	9d690e6c-5b54-4df3-a32d-e7774e1dc336	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":475,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:36:31
29074	9d690e6d-44fa-4ac6-91c1-bfeb4d5516cf	9d690e6d-a6a4-453b-9ff6-8b260784f116	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 13:36:31
29075	9d690e6d-9b37-4973-a9a7-219c3cb7b476	9d690e6d-a6a4-453b-9ff6-8b260784f116	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"79.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:36:31
29076	9d690e6d-9c1f-4ca1-b6ca-d07eb84fcdf7	9d690e6d-a6a4-453b-9ff6-8b260784f116	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:36:31
29077	9d690e6d-a48d-4278-a6e3-e7afa48dc0f5	9d690e6d-a6a4-453b-9ff6-8b260784f116	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 13:36:31
29078	9d690e6d-a515-4cb3-a2c1-9a111d9e6e18	9d690e6d-a6a4-453b-9ff6-8b260784f116	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":653,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:36:31
30499	9d693fb2-cb02-48ba-8c3f-7c6ad00200e8	9d693fb2-f261-4728-bfd5-76a812909b99	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 15:54:18
30500	9d693fb2-f0c8-4db5-8576-4e11045acbc9	9d693fb2-f261-4728-bfd5-76a812909b99	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 15:54:18
30501	9d693fb2-f18e-46f2-b1bb-7bcb4ba8e036	9d693fb2-f261-4728-bfd5-76a812909b99	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":341,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:54:18
30502	9d693fb3-5803-4e1a-8071-22100b7a3ccd	9d693fb3-769b-4c9a-8546-58d2e0ac5803	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 15:54:18
30503	9d693fb3-6d97-4d79-8939-d671b60dedc3	9d693fb3-769b-4c9a-8546-58d2e0ac5803	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"43.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 15:54:18
30504	9d693fb3-7137-4888-8988-77d318decf54	9d693fb3-769b-4c9a-8546-58d2e0ac5803	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"1.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 15:54:18
30505	9d693fb3-716d-4d74-9523-cc203c7c202a	9d693fb3-769b-4c9a-8546-58d2e0ac5803	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 15:54:18
30506	9d693fb3-7545-4df7-bd86-2ae93d03f43a	9d693fb3-769b-4c9a-8546-58d2e0ac5803	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 15:54:18
30507	9d693fb3-75b0-4a41-a704-ac4877003d2d	9d693fb3-769b-4c9a-8546-58d2e0ac5803	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":274,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:54:18
39097	9d6bcc9a-2f02-4d9b-8c12-0d29daf158cb	9d6bcc9a-7bcf-4965-98ac-7096f11969f9	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 22:19:57
35469	9d69c4d3-8f14-44fb-87f6-fcc77de5c081	9d69c4d3-c80a-4c70-97c2-108e93d39470	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 22:06:33
35470	9d69c4d3-c57c-4e4b-a1db-4effa9375819	9d69c4d3-c80a-4c70-97c2-108e93d39470	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 22:06:33
35471	9d69c4d3-c68f-4978-9d98-db256aaa1996	9d69c4d3-c80a-4c70-97c2-108e93d39470	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":502,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:06:33
39098	9d6bcc9a-79c3-4046-82b3-477142e85406	9d6bcc9a-7bcf-4965-98ac-7096f11969f9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 22:19:57
39099	9d6bcc9a-7a8d-4724-8dde-f66d0e97885c	9d6bcc9a-7bcf-4965-98ac-7096f11969f9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":429,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:19:57
35472	9d69c4d4-64e3-400b-a0b9-eaea9fe31727	9d69c4d4-929d-4eea-8610-70a6d61fa216	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 22:06:33
35473	9d69c4d4-8aa1-411a-aa20-4e8ead9ce549	9d69c4d4-929d-4eea-8610-70a6d61fa216	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"63.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 22:06:33
35474	9d69c4d4-907e-4dd3-9e63-5831b496750e	9d69c4d4-929d-4eea-8610-70a6d61fa216	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 22:06:33
35475	9d69c4d4-9131-40f2-baf2-f07b7b02a8de	9d69c4d4-929d-4eea-8610-70a6d61fa216	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":420,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:06:33
39100	9d6bcc9a-e1af-439a-b2d1-9f695de487e1	9d6bcc9a-fe69-47dc-82c4-71c1eb2019bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 22:19:57
39101	9d6bcc9a-f8e5-4ca5-aff2-a0e9884f01fb	9d6bcc9a-fe69-47dc-82c4-71c1eb2019bb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"42.21","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 22:19:57
39102	9d6bcc9a-fd0b-4951-806e-45b7f568aa06	9d6bcc9a-fe69-47dc-82c4-71c1eb2019bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 22:19:57
39103	9d6bcc9a-fd85-4e06-a345-96fb4ecb1182	9d6bcc9a-fe69-47dc-82c4-71c1eb2019bb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":272,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:19:57
35476	9d69c4d5-0dd7-4118-815d-536e878e7349	9d69c4d5-3d2d-4afa-8f4e-db85c7e74548	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 22:06:34
35477	9d69c4d5-332c-460f-abe9-7347b974013d	9d69c4d5-3d2d-4afa-8f4e-db85c7e74548	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"66.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:06:34
35478	9d69c4d5-341a-4f43-9b31-eb9643fc117e	9d69c4d5-3d2d-4afa-8f4e-db85c7e74548	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:06:34
35479	9d69c4d5-3adf-48a1-bd92-b8c20d23b542	9d69c4d5-3d2d-4afa-8f4e-db85c7e74548	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 22:06:34
35480	9d69c4d5-3b84-4a96-b1e9-e559517c53fe	9d69c4d5-3d2d-4afa-8f4e-db85c7e74548	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":416,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:06:34
39104	9d6bcc9b-539a-47eb-8da3-31a287fe26f9	9d6bcc9b-7291-4b4c-b7d9-7233def1b443	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 22:19:57
39105	9d6bcc9b-6cfb-4d85-b368-6fd6f27171ec	9d6bcc9b-7291-4b4c-b7d9-7233def1b443	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:19:57
39106	9d6bcc9b-6d4c-47a3-b8c1-389266c1eb8a	9d6bcc9b-7291-4b4c-b7d9-7233def1b443	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:19:57
39107	9d6bcc9b-714e-4b17-9ae1-9a538fcb8ae3	9d6bcc9b-7291-4b4c-b7d9-7233def1b443	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 22:19:58
39108	9d6bcc9b-7198-44b7-b0ad-77a5bd70e0f8	9d6bcc9b-7291-4b4c-b7d9-7233def1b443	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":282,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:19:58
35481	9d69c4d5-f607-4530-918c-3dd72217cfd7	9d69c4d6-4678-498e-a6e0-3a31ce04a629	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 22:06:34
35482	9d69c4d6-3bbd-4763-99c2-a954574eb01c	9d69c4d6-4678-498e-a6e0-3a31ce04a629	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"114.68","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:06:35
35483	9d69c4d6-3c56-4c92-8356-c2265659b3e7	9d69c4d6-4678-498e-a6e0-3a31ce04a629	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:06:35
35484	9d69c4d6-445f-4c6b-bfea-1bf0c250a629	9d69c4d6-4678-498e-a6e0-3a31ce04a629	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 22:06:35
35485	9d69c4d6-44f4-4f4d-9b19-5597d80a9a3c	9d69c4d6-4678-498e-a6e0-3a31ce04a629	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":655,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:06:35
39109	9d6bcc9b-bb43-4c96-a5df-e5fffd0eaeea	9d6bcc9b-da58-4df7-b94a-ebe3c0e43020	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 22:19:58
39110	9d6bcc9b-d3af-4aa8-a324-208c8ede6780	9d6bcc9b-da58-4df7-b94a-ebe3c0e43020	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:19:58
39111	9d6bcc9b-d402-4f62-a6cd-87c4e0b8107c	9d6bcc9b-da58-4df7-b94a-ebe3c0e43020	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:19:58
39112	9d6bcc9b-d8d3-48c8-ad46-50e00cb7f719	9d6bcc9b-da58-4df7-b94a-ebe3c0e43020	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 22:19:58
39113	9d6bcc9b-d92a-47cc-b0a5-d354158b4c7a	9d6bcc9b-da58-4df7-b94a-ebe3c0e43020	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:19:58
35486	9d69c4d7-13d0-4186-bbad-770f7e2a4101	9d69c4d7-716d-4a35-ac88-a77228f2e243	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 22:06:35
35487	9d69c4d7-66af-4978-a77a-8f56a4508164	9d69c4d7-716d-4a35-ac88-a77228f2e243	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"136.02","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:06:35
35488	9d69c4d7-6744-445e-b5bb-dd5db395017b	9d69c4d7-716d-4a35-ac88-a77228f2e243	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:06:35
35489	9d69c4d7-6f34-4e90-98f1-a46d1e4c609f	9d69c4d7-716d-4a35-ac88-a77228f2e243	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 22:06:35
35490	9d69c4d7-6fcd-4c45-afcf-8aa0d20a3153	9d69c4d7-716d-4a35-ac88-a77228f2e243	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":737,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:06:35
39114	9d6bcc9d-8de7-4244-962f-50a62f11b66e	9d6bcc9d-ac99-498a-ba86-5c0bb56ede8c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 22:19:59
39115	9d6bcc9d-a72d-4403-a6f0-f7aba0fd6ba2	9d6bcc9d-ac99-498a-ba86-5c0bb56ede8c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 22:19:59
39116	9d6bcc9d-a77c-43b6-975d-eb78bd4cff5b	9d6bcc9d-ac99-498a-ba86-5c0bb56ede8c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 22:19:59
39117	9d6bcc9d-ab3f-4158-a9f8-a53999cc5806	9d6bcc9d-ac99-498a-ba86-5c0bb56ede8c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 22:19:59
39118	9d6bcc9d-ab7e-4e0a-9119-fa0bd330e23c	9d6bcc9d-ac99-498a-ba86-5c0bb56ede8c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":331,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:19:59
39119	9d6bcc9e-01e5-4843-ad46-4812ddb0b854	9d6bcc9e-06ee-4f5e-9895-a2b6a68e81be	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":192,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:19:59
39120	9d6bcc9e-6eb1-43ed-b699-daf6aac944c9	9d6bcc9e-8e7f-43f2-be5d-9f04b576edc7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 22:19:59
39121	9d6bcc9e-88fe-4955-8117-9c73e483c9ea	9d6bcc9e-8e7f-43f2-be5d-9f04b576edc7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"48.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 22:20:00
39122	9d6bcc9e-8ce5-401d-85ba-59f861f074df	9d6bcc9e-8e7f-43f2-be5d-9f04b576edc7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 22:20:00
39123	9d6bcc9e-8d55-427d-b578-8589f2e898c5	9d6bcc9e-8e7f-43f2-be5d-9f04b576edc7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":267,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:20:00
39124	9d6bcca3-b56f-42ac-bfc5-e6e941cd0cbf	9d6bcca3-b8dc-4e8a-ba75-e55b0d5e3b9b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":159,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:20:03
39125	9d6bcca4-149f-49a6-98c5-30556d774a8a	9d6bcca4-313b-4b77-bf8c-46dde72ff84c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 22:20:03
39126	9d6bcca4-2c18-41d8-83f2-4930e7a3aec8	9d6bcca4-313b-4b77-bf8c-46dde72ff84c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" where \\"l\\".\\"user_cobrador\\" = 14 order by \\"l\\".\\"id\\" desc","time":"43.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"9c165f2fbf7ccf3d02848123be5b6d04","hostname":"EderCortes"}	2024-11-05 22:20:03
39127	9d6bcca4-2f77-41f4-b38d-5f215a3f95c2	9d6bcca4-313b-4b77-bf8c-46dde72ff84c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 22:20:03
39128	9d6bcca4-3008-474f-9838-40e9f835b3f0	9d6bcca4-313b-4b77-bf8c-46dde72ff84c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":14,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:20:03
39129	9d6bcca7-3205-4fef-93d4-154e84f202b3	9d6bcca7-3570-4dbb-a674-768d96f47d82	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":239,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:20:05
35721	9d69c580-9cf5-4072-95dd-82d8411b4686	9d69c580-cf06-4ea2-86c8-afeaca98bb75	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-04 22:08:26
35722	9d69c580-cc0b-4569-885b-2ae1e6062dae	9d69c580-cf06-4ea2-86c8-afeaca98bb75	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-04 22:08:26
35723	9d69c580-cd6b-42cf-a32e-b8ae69e2415b	9d69c580-cf06-4ea2-86c8-afeaca98bb75	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":419,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:08:26
35724	9d69c581-7792-46bb-9b4d-f3f899c51c61	9d69c581-d5f8-46ed-9ec8-1efd15d1949a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-04 22:08:27
35725	9d69c581-cc32-499e-9a68-a816b15504e0	9d69c581-d5f8-46ed-9ec8-1efd15d1949a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"186.36","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 22:08:27
35726	9d69c581-d3af-45f1-8362-5a79cfee3baa	9d69c581-d5f8-46ed-9ec8-1efd15d1949a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-04 22:08:27
35727	9d69c581-d474-4543-a2be-619af85f8b0c	9d69c581-d5f8-46ed-9ec8-1efd15d1949a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":573,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:08:27
35728	9d69c582-6323-44d4-92b1-e9bc7be8132a	9d69c582-9577-483b-9985-3235abc5ed62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-04 22:08:27
35729	9d69c582-8c84-41c1-b41b-a469a3c9bd57	9d69c582-9577-483b-9985-3235abc5ed62	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"67.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:08:27
35730	9d69c582-8d10-4e71-bc68-b1b2163c7db3	9d69c582-9577-483b-9985-3235abc5ed62	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:08:27
35731	9d69c582-938f-4be2-86bf-55a3b7cbe044	9d69c582-9577-483b-9985-3235abc5ed62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-11-04 22:08:27
35732	9d69c582-9400-4f86-8634-e2a8131859ae	9d69c582-9577-483b-9985-3235abc5ed62	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":456,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:08:27
39131	9d6bcca7-e7e4-4ed7-864d-f37492d55297	9d6bcca7-f072-4008-80c7-49418e7cf781	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 22:20:06
39132	9d6bcca7-eed5-479e-b339-3aaf6556406a	9d6bcca7-f072-4008-80c7-49418e7cf781	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 22:20:06
39133	9d6bcca7-ef63-4e58-8ac8-1a686e045ba5	9d6bcca7-f072-4008-80c7-49418e7cf781	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"46","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":500,"response":{"message":"Undefined array key \\"cobrador\\"","exception":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255,"function":"handleError","class":"Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83,"function":"Illuminate\\\\Foundation\\\\Bootstrap\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"listPrecautions","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":175,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:20:06
35733	9d69c583-2cdc-4830-9416-589a3330e974	9d69c583-962f-4101-bfd6-ef3c1441eaec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-11-04 22:08:28
35734	9d69c583-8cd0-45d8-b32d-9f9976d520bc	9d69c583-962f-4101-bfd6-ef3c1441eaec	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"208.74","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:08:28
35735	9d69c583-8d5a-4ff9-bc89-b62f976d0d63	9d69c583-962f-4101-bfd6-ef3c1441eaec	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:08:28
35736	9d69c583-9401-420b-9c2a-8c418499a11e	9d69c583-962f-4101-bfd6-ef3c1441eaec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-11-04 22:08:28
35737	9d69c583-9498-4d58-842a-466680fdc0e6	9d69c583-962f-4101-bfd6-ef3c1441eaec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":630,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:08:28
35738	9d69c584-7c64-4c02-9174-290c42c5d4e8	9d69c584-ab0f-4a5f-9364-8fdb432f57bc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-11-04 22:08:29
35739	9d69c584-a2d8-4950-abfd-f06a806ab9f7	9d69c584-ab0f-4a5f-9364-8fdb432f57bc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"64.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:08:29
35740	9d69c584-a357-42fc-ab76-19cce4f6e70f	9d69c584-ab0f-4a5f-9364-8fdb432f57bc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:08:29
35741	9d69c584-a919-4927-9bdd-ea221fa61bb4	9d69c584-ab0f-4a5f-9364-8fdb432f57bc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-11-04 22:08:29
35742	9d69c584-a9a2-498c-bf35-eed285ac2144	9d69c584-ab0f-4a5f-9364-8fdb432f57bc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":510,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:08:29
35743	9d69c634-708e-40f7-b5f0-729df631b6ae	9d69c634-9452-4565-862b-79f49853fb27	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 22:10:24
35744	9d69c634-8dbc-4567-a6a0-4526d7846c00	9d69c634-9452-4565-862b-79f49853fb27	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"40.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":19,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-04 22:10:24
35745	9d69c634-8e20-41d0-863e-ba817275f4cf	9d69c634-9452-4565-862b-79f49853fb27	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":5,"hostname":"EderCortes"}	2024-11-04 22:10:24
35746	9d69c634-92b8-4e77-8f27-8184fc7ee9d1	9d69c634-9452-4565-862b-79f49853fb27	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 22:10:24
35747	9d69c634-9316-46e0-a0ed-5367e4d607fe	9d69c634-9452-4565-862b-79f49853fb27	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:55:01.000000Z","deleted_at":null,"user_alias":"eder.cortes"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:10:24
35748	9d69c649-8af3-4d4d-aa52-e1e4d73165e4	9d69c649-a6cd-4589-8c49-179437e182c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 22:10:38
35749	9d69c649-a225-478b-9e6c-4977872da802	9d69c649-a6cd-4589-8c49-179437e182c2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '14' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"39.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":74,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 22:10:38
35750	9d69c649-a282-491d-840a-56c296dc5b1f	9d69c649-a6cd-4589-8c49-179437e182c2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 22:10:38
35751	9d69c649-a598-40c0-a2b8-c0dfba384abd	9d69c649-a6cd-4589-8c49-179437e182c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 22:10:38
35752	9d69c649-a5dd-4516-b354-d3469f3f6b0d	9d69c649-a6cd-4589-8c49-179437e182c2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/14","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}},"duration":311,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:10:38
779	9d4f2ef9-a4f7-48d7-abc3-4eec60ed0f29	9d4f2ef9-a9d1-46e8-b7a6-221c8d92c45c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":56}	2024-10-22 16:56:00
35753	9d69c64e-943b-46de-8373-1fc945a7906d	9d69c64e-de25-4c2f-a74c-cc688cdcc74f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 22:10:41
35754	9d69c64e-d81b-4925-81d8-76249b4a7357	9d69c64e-de25-4c2f-a74c-cc688cdcc74f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"151.11","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":19,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-04 22:10:41
35755	9d69c64e-d87b-437a-a8ad-6896b74b3cee	9d69c64e-de25-4c2f-a74c-cc688cdcc74f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":5,"hostname":"EderCortes"}	2024-11-04 22:10:41
35756	9d69c64e-dcc2-41d4-988a-03634bb448fe	9d69c64e-de25-4c2f-a74c-cc688cdcc74f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 22:10:41
35757	9d69c64e-dd15-4366-b24e-bc0b51c1e8bd	9d69c64e-de25-4c2f-a74c-cc688cdcc74f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:55:01.000000Z","deleted_at":null,"user_alias":"eder.cortes"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":358,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:10:41
6299	9d52641e-2186-4cef-98e9-924397879919	9d52641e-2768-4680-9ade-89ffed605d05	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abfrom\\u00bb\\nLINE 14:     from loans l\\n             ^ (Connection: pgsql, SQL: \\n    select l.id,\\n        l.loans_documento,\\n        l.loans_nombre,\\n        l.loans_apellido_uno,\\n        l.loans_fecha,\\n        l.loans_valor_prestado,\\n        l.loans_cuotas,\\n        l.loans_estado,\\n        l.loans_intereses,\\n        ucl.name as cliente,\\n        uco.name as cobrador,\\n        ure.name as recomendador,\\n    from loans l\\n    join users ucl on l.user_customer = ucl.id\\n    join users uco on l.user_cobrador = uco.id\\n    left join users ure on l.user_recomendacion = ure.id\\n)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":324}	2024-10-24 07:12:05
35758	9d69c650-b5e3-4b60-8654-f435a84510fd	9d69c650-d586-4abb-bac2-061af2517bdd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 22:10:43
35759	9d69c650-cf85-4711-b2c5-cb3512f2c356	9d69c650-d586-4abb-bac2-061af2517bdd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '18' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"39.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":74,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 22:10:43
35760	9d69c650-cfde-4b69-96a0-aac77cb5e7bf	9d69c650-d586-4abb-bac2-061af2517bdd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 22:10:43
35761	9d69c650-d448-42a6-b4f6-b11700d55d5d	9d69c650-d586-4abb-bac2-061af2517bdd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 22:10:43
35762	9d69c650-d498-42c1-8b6d-952af1cfde8c	9d69c650-d586-4abb-bac2-061af2517bdd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/18","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"}},"duration":272,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:10:43
807	9d4f3105-a37a-4a6f-b703-e07d0cc7f1b3	9d4f3105-a6b1-489a-9ea7-620c149dc338	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":58}	2024-10-22 17:01:44
35763	9d69c654-97cb-497d-932a-2ac5ed3378ba	9d69c654-b616-4830-acc7-10e498dbbda0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 22:10:45
35764	9d69c654-b029-4f33-ab76-840b06c9c8d3	9d69c654-b616-4830-acc7-10e498dbbda0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"40.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":19,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-04 22:10:45
35765	9d69c654-b09a-41c3-a440-e81082f0c1e2	9d69c654-b616-4830-acc7-10e498dbbda0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":5,"hostname":"EderCortes"}	2024-11-04 22:10:45
35766	9d69c654-b4a9-43e9-b857-9637ef32f27a	9d69c654-b616-4830-acc7-10e498dbbda0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 22:10:45
35767	9d69c654-b51b-4972-94d8-30649d155700	9d69c654-b616-4830-acc7-10e498dbbda0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:55:01.000000Z","deleted_at":null,"user_alias":"eder.cortes"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:10:45
39347	9d6bcff1-4bed-4384-9a5e-38e40383ebe0	9d6bcff1-95b2-406a-9a7c-b9ca5139d3a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 22:29:17
39348	9d6bcff1-9392-408a-b5ed-a227d980de83	9d6bcff1-95b2-406a-9a7c-b9ca5139d3a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 22:29:17
39349	9d6bcff1-944e-4371-bead-2588f9fc2ccf	9d6bcff1-95b2-406a-9a7c-b9ca5139d3a1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":375,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:29:17
35768	9d69c656-8928-4c38-b3eb-53a274810c66	9d69c656-a7f5-4bc4-b201-695b1913b63d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 22:10:46
35769	9d69c656-a243-4982-b9ab-90b95cf5bc3a	9d69c656-a7f5-4bc4-b201-695b1913b63d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '19' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"40.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":74,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 22:10:46
35770	9d69c656-a2a2-4637-827d-cebc914f6d21	9d69c656-a7f5-4bc4-b201-695b1913b63d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 22:10:46
35771	9d69c656-a688-4a28-9ec9-1d2b3c909d8d	9d69c656-a7f5-4bc4-b201-695b1913b63d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 22:10:46
35772	9d69c656-a6d7-47e6-9163-d1b38ce0c550	9d69c656-a7f5-4bc4-b201-695b1913b63d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/19","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}},"duration":280,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:10:46
39350	9d6bcff1-f71c-4f58-acbb-0f63cf29497f	9d6bcff1-fec6-4782-9512-b3e4d8549934	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 22:29:18
39351	9d6bcff1-fd97-45ee-aa19-21ea11edf6ff	9d6bcff1-fec6-4782-9512-b3e4d8549934	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 22:29:18
39352	9d6bcff1-fde0-40c9-a175-99dd740ce5da	9d6bcff1-fec6-4782-9512-b3e4d8549934	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null}},"duration":200,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:29:18
35773	9d69c659-d42a-439e-a99c-7b9b1b330a3d	9d69c659-f55e-49dc-b84b-658577cda966	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 22:10:49
35774	9d69c659-eef4-48ae-b13c-c0276fc91f43	9d69c659-f55e-49dc-b84b-658577cda966	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"44.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":19,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-04 22:10:49
35775	9d69c659-ef58-42f9-9616-3eded7a62d5e	9d69c659-f55e-49dc-b84b-658577cda966	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":5,"hostname":"EderCortes"}	2024-11-04 22:10:49
35776	9d69c659-f414-48b7-b484-089b566374f9	9d69c659-f55e-49dc-b84b-658577cda966	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 22:10:49
35777	9d69c659-f462-48ca-a475-d65df3676329	9d69c659-f55e-49dc-b84b-658577cda966	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:55:01.000000Z","deleted_at":null,"user_alias":"eder.cortes"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":259,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:10:49
39353	9d6bcff2-5bf9-4c58-9caf-bda514b9f02b	9d6bcff2-7a78-4947-8e71-49f2dcb5eebb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 22:29:18
39354	9d6bcff2-7529-4bdb-a310-82392534f7dc	9d6bcff2-7a78-4947-8e71-49f2dcb5eebb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:29:18
39355	9d6bcff2-7573-42af-a7e9-cf0cd3ce7c35	9d6bcff2-7a78-4947-8e71-49f2dcb5eebb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:29:18
39356	9d6bcff2-791d-411b-862c-08c9db0eb8f8	9d6bcff2-7a78-4947-8e71-49f2dcb5eebb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 22:29:18
39357	9d6bcff2-7962-4fef-bb0e-80e90a4ecbc7	9d6bcff2-7a78-4947-8e71-49f2dcb5eebb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:29:18
35778	9d69c65c-1eec-4248-9e50-517c9e426dd0	9d69c65c-3e04-4d65-b033-1465a7e08f73	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 22:10:50
35779	9d69c65c-37af-492f-9664-dd295dfa0780	9d69c65c-3e04-4d65-b033-1465a7e08f73	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"39.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":74,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 22:10:50
35780	9d69c65c-3805-4949-850b-c50702095273	9d69c65c-3e04-4d65-b033-1465a7e08f73	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 22:10:50
35781	9d69c65c-3c17-481a-b71a-326705978de7	9d69c65c-3e04-4d65-b033-1465a7e08f73	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 22:10:50
35782	9d69c65c-3cbc-4689-95f9-2786230d5f76	9d69c65c-3e04-4d65-b033-1465a7e08f73	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:55:01.000000Z","deleted_at":null,"user_alias":"eder.cortes"}},"duration":324,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:10:50
39358	9d6bcff2-c000-4ddd-b022-016250bc2f07	9d6bcff2-dc91-4b63-9e34-339a65517b81	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 22:29:18
39359	9d6bcff2-d7d7-4c33-909c-d8861fdc73ce	9d6bcff2-dc91-4b63-9e34-339a65517b81	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:29:18
39360	9d6bcff2-d841-4235-884e-fe9cc0a98c13	9d6bcff2-dc91-4b63-9e34-339a65517b81	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:29:18
39361	9d6bcff2-db44-42ea-804e-446eab3f917d	9d6bcff2-dc91-4b63-9e34-339a65517b81	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 22:29:18
39362	9d6bcff2-db87-4e32-a4f9-042abb77951b	9d6bcff2-dc91-4b63-9e34-339a65517b81	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:29:18
35783	9d69c65f-de7f-402a-963f-21c2355e6808	9d69c660-01bf-4719-99d8-6397c42ede89	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 22:10:52
35784	9d69c65f-fbb7-4b20-bece-d74f51a29e1b	9d69c660-01bf-4719-99d8-6397c42ede89	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"41.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":19,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-04 22:10:53
35785	9d69c65f-fc0d-4059-bc9d-c215f94d664c	9d69c660-01bf-4719-99d8-6397c42ede89	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":5,"hostname":"EderCortes"}	2024-11-04 22:10:53
35786	9d69c660-0072-483d-9d54-d7c7e032122e	9d69c660-01bf-4719-99d8-6397c42ede89	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 22:10:53
35787	9d69c660-00c9-459c-9842-c74cb106be82	9d69c660-01bf-4719-99d8-6397c42ede89	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:55:01.000000Z","deleted_at":null,"user_alias":"eder.cortes"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":255,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:10:53
39363	9d6bcff4-8493-4f96-be6f-7a72180712f5	9d6bcff4-cd39-4912-8e53-50d00d63bb23	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 22:29:19
39364	9d6bcff4-c80e-4439-8950-c00d597ae56f	9d6bcff4-cd39-4912-8e53-50d00d63bb23	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"153.23","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 22:29:19
39365	9d6bcff4-c854-4293-bfbf-e18d42aa0d78	9d6bcff4-cd39-4912-8e53-50d00d63bb23	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 22:29:19
39366	9d6bcff4-cbbc-4b13-b90d-aef2319799c8	9d6bcff4-cd39-4912-8e53-50d00d63bb23	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 22:29:19
39367	9d6bcff4-cc25-4c0a-a015-05712d82e134	9d6bcff4-cd39-4912-8e53-50d00d63bb23	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":426,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:29:19
35788	9d69c661-abde-487f-a464-dd3fa704f7a8	9d69c661-cf3e-421a-a1b1-c5205c414110	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 22:10:54
35789	9d69c661-c801-479a-9fe7-612929e0d7fb	9d69c661-cf3e-421a-a1b1-c5205c414110	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '22' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"44.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":74,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 22:10:54
35790	9d69c661-c86a-4fa8-ae86-48b4d51fa79d	9d69c661-cf3e-421a-a1b1-c5205c414110	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 22:10:54
35791	9d69c661-cd9f-40f1-a04e-c68382058658	9d69c661-cf3e-421a-a1b1-c5205c414110	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 22:10:54
35792	9d69c661-ce0f-4c20-972e-945fddf48573	9d69c661-cf3e-421a-a1b1-c5205c414110	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/22","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}},"duration":272,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:10:54
39368	9d6bcff5-11b7-4033-94e9-2575af5ec712	9d6bcff5-1530-4f3b-ad8f-3747a6309124	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":157,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:29:20
35793	9d69c672-02b2-4eeb-8d96-e4c08ceb9aa3	9d69c672-05db-46c1-810f-f3a66112df27	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/updateUser","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":134,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:11:04
39369	9d6bcff5-6ce9-4373-9a00-ef4cda5a1504	9d6bcff5-7423-4691-813e-1376d4bb9193	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 22:29:20
39370	9d6bcff5-72f2-434f-a3f1-af8966c3ff04	9d6bcff5-7423-4691-813e-1376d4bb9193	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 22:29:20
39371	9d6bcff5-7335-4f75-8ac4-816cc0db59d4	9d6bcff5-7423-4691-813e-1376d4bb9193	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null}},"duration":182,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:29:20
35794	9d69c672-7b9b-452a-b956-81899123b5de	9d69c672-9e06-4a3f-a217-47f84fdb8f72	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 22:11:05
35795	9d69c672-9642-4040-913a-874d2d1083a0	9d69c672-9e06-4a3f-a217-47f84fdb8f72	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = 22 and \\"users\\".\\"deleted_at\\" is null limit 1","time":"2.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":105,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 22:11:05
35796	9d69c672-968f-4fee-8f0f-72a47379fd6a	9d69c672-9e06-4a3f-a217-47f84fdb8f72	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 22:11:05
35797	9d69c672-985a-4619-aacd-9dcf8cebc0f7	9d69c672-9e06-4a3f-a217-47f84fdb8f72	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"users\\" set \\"profile_code\\" = 3, \\"updated_at\\" = '2024-11-04 22:11:05' where \\"id\\" = 22","time":"2.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":107,"hash":"53e02ae7006b9271ea4361cc2002a5ec","hostname":"EderCortes"}	2024-11-04 22:11:05
35798	9d69c672-98ee-4747-b512-f8167c800fd1	9d69c672-9e06-4a3f-a217-47f84fdb8f72	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\User:22","changes":{"profile_code":3,"updated_at":"2024-11-04 22:11:05"},"hostname":"EderCortes"}	2024-11-04 22:11:05
35799	9d69c672-9ccc-4e86-8c3e-a26bfd189ecb	9d69c672-9e06-4a3f-a217-47f84fdb8f72	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 22:11:05
35800	9d69c672-9d13-4b92-8ad2-7ac9e47d36b1	9d69c672-9e06-4a3f-a217-47f84fdb8f72	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/updateUser","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@updateUser","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"526","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","profile_code":3,"user_age":"28","user_alias":"juan_jaramillo","email_verified_at":null,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null},"session":[],"response_status":200,"response":{"response":"El registro fue actualizado exitosamente"},"duration":282,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:11:05
39372	9d6bcffb-ca9f-405e-8895-c34b6133a63d	9d6bcffb-ce02-461c-86d9-ddd274eb73e1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":144,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:29:24
35801	9d69c67f-b59e-42b8-bf58-9d61cd1bba93	9d69c67f-d4dd-4f9f-9fa0-f87157d7af2c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 22:11:13
35802	9d69c67f-cfcc-45ab-bfea-e051ba47512c	9d69c67f-d4dd-4f9f-9fa0-f87157d7af2c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"47.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 22:11:13
35803	9d69c67f-d337-4029-8e8d-6d01df6ab1a1	9d69c67f-d4dd-4f9f-9fa0-f87157d7af2c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 22:11:13
35804	9d69c67f-d3c6-457e-924e-dda114fad6fe	9d69c67f-d4dd-4f9f-9fa0-f87157d7af2c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:11:13
39373	9d6bcffc-31d4-4361-aa4c-a7f1364ef4d0	9d6bcffc-3901-49a7-b018-8b65967184c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 22:29:24
39374	9d6bcffc-37b5-4564-9a42-99e9188ad994	9d6bcffc-3901-49a7-b018-8b65967184c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 22:29:24
39375	9d6bcffc-37fc-4151-996f-4ed1df6a528f	9d6bcffc-3901-49a7-b018-8b65967184c2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":14,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":{"cobrador":14,"frecuencia":null,"estado":null,"prestamista":null}},"duration":184,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:29:24
35805	9d69c680-2e2d-40c8-b5e1-9c3d832b4455	9d69c680-7421-4868-8a1e-ab43f1915b2d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 22:11:14
35806	9d69c680-6ec5-4d3e-985f-183a1f131edb	9d69c680-7421-4868-8a1e-ab43f1915b2d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"140.49","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:11:14
35807	9d69c680-6f2b-444d-aea2-7f28e4b8cd06	9d69c680-7421-4868-8a1e-ab43f1915b2d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 22:11:14
35808	9d69c680-72e0-4a4b-af31-1d2057e6cd7e	9d69c680-7421-4868-8a1e-ab43f1915b2d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 22:11:14
35809	9d69c680-732d-473a-b2f5-a62e4f4cf0bf	9d69c680-7421-4868-8a1e-ab43f1915b2d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:11:14
39376	9d6bd017-526f-47ea-91c4-73b6c0071563	9d6bd017-5688-40f6-ba8c-26b5048120a4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":317,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:29:42
35810	9d69c6f1-a96b-4f9f-b966-9625927358ef	9d69c6f1-ce91-4789-adda-3c8355954444	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 22:12:28
35811	9d69c6f1-c747-4f1f-8b30-3ecdfd57bf03	9d69c6f1-ce91-4789-adda-3c8355954444	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"40.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":19,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-04 22:12:28
35812	9d69c6f1-c7b8-4af1-baea-78b61d0e088b	9d69c6f1-ce91-4789-adda-3c8355954444	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":5,"hostname":"EderCortes"}	2024-11-04 22:12:28
35813	9d69c6f1-ccc1-43f6-8274-72a80f34ec8d	9d69c6f1-ce91-4789-adda-3c8355954444	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 22:12:28
35814	9d69c6f1-cd3d-425f-aa14-fb36f32b2d5d	9d69c6f1-ce91-4789-adda-3c8355954444	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:55:01.000000Z","deleted_at":null,"user_alias":"eder.cortes"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":255,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:12:28
39377	9d6bd018-190d-4480-9ea4-c6302efd3aa1	9d6bd018-2071-4aa5-8465-b45c7248323b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 22:29:43
39378	9d6bd018-1f13-45b6-90c4-898f4427a399	9d6bd018-2071-4aa5-8465-b45c7248323b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 22:29:43
39379	9d6bd018-1f70-435b-adae-b10ff4d67a9e	9d6bd018-2071-4aa5-8465-b45c7248323b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null}},"duration":203,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:29:43
35815	9d69c6f6-42b3-4e15-bd90-a781e67f1d43	9d69c6f6-617a-4c8e-aec5-c7827d00a96d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 22:12:31
35816	9d69c6f6-5be3-4a57-b705-90892a3dccef	9d69c6f6-617a-4c8e-aec5-c7827d00a96d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '22' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"42.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":74,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 22:12:31
35817	9d69c6f6-5c43-4f27-bbfa-8a177f67a8aa	9d69c6f6-617a-4c8e-aec5-c7827d00a96d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 22:12:31
35818	9d69c6f6-6022-4f86-8754-fd80966cbba1	9d69c6f6-617a-4c8e-aec5-c7827d00a96d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 22:12:31
35819	9d69c6f6-606d-40fa-bc65-9c4d013909f9	9d69c6f6-617a-4c8e-aec5-c7827d00a96d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/22","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}},"duration":312,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:12:31
653	9d4f2d9d-a35a-40e7-a2dd-03738eea5c76	9d4f2d9d-a661-44ff-ac3a-31cdee0807ed	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":47}	2024-10-22 16:52:12
29274	9d691414-9c29-42e2-b125-681b72d868b6	9d691414-dca1-4d00-b3a5-1fbca92d1d3b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 13:52:20
29275	9d691414-d97e-4258-b9e9-4b61e4d0a074	9d691414-dca1-4d00-b3a5-1fbca92d1d3b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 13:52:20
29276	9d691414-db01-4c37-b398-2bb8c1ab3748	9d691414-dca1-4d00-b3a5-1fbca92d1d3b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":763,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:52:20
29277	9d691416-3ac1-4b5f-b08b-5e49f2ce6278	9d691416-8ffe-4e82-864a-e6000e671d49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 13:52:21
29278	9d691416-8630-4b56-aca2-29944c2bb3f5	9d691416-8ffe-4e82-864a-e6000e671d49	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"131.77","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:52:21
29279	9d691416-86c1-4283-ba97-4f4658f5c65a	9d691416-8ffe-4e82-864a-e6000e671d49	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:52:21
29280	9d691416-8de8-4a8d-84c4-4332178b83f4	9d691416-8ffe-4e82-864a-e6000e671d49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 13:52:21
29281	9d691416-8e76-4022-b189-4d290fb4ac9d	9d691416-8ffe-4e82-864a-e6000e671d49	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":829,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:52:21
29282	9d691417-36ec-4ad3-9c8d-fa62492f4808	9d691417-6977-48a4-9a8d-c2c249042ca1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 13:52:21
29283	9d691417-60bc-4966-bf9f-750db5b69d4d	9d691417-6977-48a4-9a8d-c2c249042ca1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"70.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:52:22
29284	9d691417-6140-46e8-9bec-42d6d82fcecd	9d691417-6977-48a4-9a8d-c2c249042ca1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:52:22
29285	9d691417-676e-46a2-84ce-ba4c28d3622c	9d691417-6977-48a4-9a8d-c2c249042ca1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 13:52:22
29286	9d691417-67f3-43e4-bf1d-865fa8013d3f	9d691417-6977-48a4-9a8d-c2c249042ca1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":529,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:52:22
39636	9d6bdf9a-284c-4c04-a34c-6ec263c717e9	9d6bdf9a-4541-4136-816a-21b5fc90b675	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 23:13:04
39637	9d6bdf9a-438d-485a-943c-f10cd7da6ae0	9d6bdf9a-4541-4136-816a-21b5fc90b675	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 23:13:04
39638	9d6bdf9a-442a-42b4-8fc0-39862a607781	9d6bdf9a-4541-4136-816a-21b5fc90b675	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:13:04
39639	9d6bdf9c-1e46-4820-841b-c251b961df81	9d6bdf9c-4282-4f40-a6f8-a9c44213ba6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 23:13:06
39640	9d6bdf9c-3a5e-49e4-b610-901e7a3fd664	9d6bdf9c-4282-4f40-a6f8-a9c44213ba6b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"49.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 23:13:06
39641	9d6bdf9c-3ad8-45c9-b763-eab83f550b76	9d6bdf9c-4282-4f40-a6f8-a9c44213ba6b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 23:13:06
39642	9d6bdf9c-40a1-421a-9297-6fa6083e23a6	9d6bdf9c-4282-4f40-a6f8-a9c44213ba6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 23:13:06
39643	9d6bdf9c-410b-4975-aa68-fa9827b856d6	9d6bdf9c-4282-4f40-a6f8-a9c44213ba6b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":334,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:13:06
35961	9d69c88e-614f-4e7b-8e20-74c04bcba7cf	9d69c88e-a00f-4fa2-9685-dcd1214af732	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 22:16:59
35962	9d69c88e-9d4e-4fea-9d96-fde1ae17f690	9d69c88e-a00f-4fa2-9685-dcd1214af732	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 22:16:59
35963	9d69c88e-9eb3-49f1-b915-0b4c121576f4	9d69c88e-a00f-4fa2-9685-dcd1214af732	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":418,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:16:59
40805	9d6cc7a5-be4f-4738-8943-4f39f56259c6	9d6cc7a5-c207-404e-8f36-a022d5350588	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1855}	2024-11-06 10:01:55
35964	9d69c88f-3e6a-4d3f-b0fb-815d5028976d	9d69c88f-66b4-456d-8cd5-d0d36c77b56b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 22:16:59
35965	9d69c88f-5fce-4c4b-ae1d-bc719a483c62	9d69c88f-66b4-456d-8cd5-d0d36c77b56b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"56.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 22:16:59
35966	9d69c88f-6489-4cef-a0bd-2c1d0e5f828e	9d69c88f-66b4-456d-8cd5-d0d36c77b56b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 22:16:59
35967	9d69c88f-6518-4b54-828e-b2345403c5d7	9d69c88f-66b4-456d-8cd5-d0d36c77b56b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":412,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:16:59
39699	9d6be244-71db-444a-adeb-11bfff481a24	9d6be244-914b-4f5d-b815-fc003cf90ece	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 23:20:31
39700	9d6be244-8f9f-4f25-a054-39234078668f	9d6be244-914b-4f5d-b815-fc003cf90ece	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 23:20:32
39701	9d6be244-905c-4c96-ac9e-b6f113718276	9d6be244-914b-4f5d-b815-fc003cf90ece	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:20:32
35968	9d69c88f-e6a2-48b7-9bdb-2e87d24399c2	9d69c890-410e-4166-819f-11480342cd2e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 22:17:00
35969	9d69c890-366d-4f80-9df5-b475eac7bb10	9d69c890-410e-4166-819f-11480342cd2e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"166.65","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:17:00
35970	9d69c890-372d-4167-962c-0bdebe5c6506	9d69c890-410e-4166-819f-11480342cd2e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 22:17:00
35971	9d69c890-3ee2-4ae7-9d60-e8f09bd72b6b	9d69c890-410e-4166-819f-11480342cd2e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 22:17:00
35972	9d69c890-3f84-4622-b06b-cd33ff5460f2	9d69c890-410e-4166-819f-11480342cd2e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":543,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:17:00
39702	9d6be246-a85b-46fb-beb8-dc7b1cb4f1ee	9d6be246-f5cb-461a-811c-1bc3454187df	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 23:20:33
39703	9d6be246-eee4-4b30-b6ab-16b56bd90e14	9d6be246-f5cb-461a-811c-1bc3454187df	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"159.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 23:20:33
39704	9d6be246-ef3d-48b5-ab9b-4d46f3d3dc84	9d6be246-f5cb-461a-811c-1bc3454187df	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 23:20:33
39705	9d6be246-f391-4c80-8dd6-9569bba20843	9d6be246-f5cb-461a-811c-1bc3454187df	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 23:20:33
39706	9d6be246-f41f-44a6-9b93-0e4fca14d629	9d6be246-f5cb-461a-811c-1bc3454187df	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":380,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:20:33
35973	9d69c890-90f8-41bb-927f-1a1acd6e16d2	9d69c890-da9a-4043-b31a-5072332f50d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 22:17:00
35974	9d69c890-d591-42df-9b17-694ef28997b6	9d69c890-da9a-4043-b31a-5072332f50d6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"152.35","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:17:00
35975	9d69c890-d5e6-4cd2-9e0b-d1eb7f165c5c	9d69c890-da9a-4043-b31a-5072332f50d6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 22:17:00
35976	9d69c890-d965-4ef3-8cc8-1e67db120a63	9d69c890-da9a-4043-b31a-5072332f50d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 22:17:00
35977	9d69c890-d9aa-46db-92ab-dfde30e783a8	9d69c890-da9a-4043-b31a-5072332f50d6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:17:00
35978	9d69c891-6e34-4d91-8806-6cd4e09ce9e9	9d69c891-b794-4c37-b6a8-b88a4c53f8e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 22:17:01
35979	9d69c891-ad35-4f3f-b5d7-714083aeb881	9d69c891-b794-4c37-b6a8-b88a4c53f8e3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"92.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:17:01
35980	9d69c891-add8-4899-a40f-a6d4795b3f23	9d69c891-b794-4c37-b6a8-b88a4c53f8e3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:17:01
35981	9d69c891-b555-4dac-9c13-6c052c098650	9d69c891-b794-4c37-b6a8-b88a4c53f8e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 22:17:01
35982	9d69c891-b5fb-49d8-83fd-5ad357e4cfaa	9d69c891-b794-4c37-b6a8-b88a4c53f8e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":544,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:17:01
35983	9d69c892-a49a-416d-b03b-06a7bb0910d8	9d69c892-d000-4a4c-8c05-8b6af8c06457	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 22:17:01
35984	9d69c892-c870-427d-9534-52232d4563a2	9d69c892-d000-4a4c-8c05-8b6af8c06457	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"57.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:17:01
35985	9d69c892-c905-4325-8e97-4ef31b0aef7a	9d69c892-d000-4a4c-8c05-8b6af8c06457	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:17:01
35986	9d69c892-ce54-4209-a7f0-616ff5676ecb	9d69c892-d000-4a4c-8c05-8b6af8c06457	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 22:17:01
35987	9d69c892-ceb3-47f3-b7aa-76bfd2bf8caf	9d69c892-d000-4a4c-8c05-8b6af8c06457	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":695,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:17:01
29423	9d69245b-5e80-40bb-91b7-669c3e2d2a90	9d69245b-9d28-4d2f-bd45-a9775ea033ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 14:37:50
29424	9d69245b-9a05-4ed9-9231-ec9dd0e1387b	9d69245b-9d28-4d2f-bd45-a9775ea033ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 14:37:51
29425	9d69245b-9bc5-4456-be44-0f19de978049	9d69245b-9d28-4d2f-bd45-a9775ea033ae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":479,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:37:51
29426	9d69245d-57ca-4769-804c-0fac7dd5f301	9d69245d-beaa-422f-a9f0-a32a09df6bea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 14:37:52
29427	9d69245d-b414-439c-a264-f71eebff4674	9d69245d-beaa-422f-a9f0-a32a09df6bea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"77.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:37:52
29428	9d69245d-b4b7-4fed-9b27-4d6391773f3f	9d69245d-beaa-422f-a9f0-a32a09df6bea	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:37:52
29429	9d69245d-bc60-4b35-aeda-127c2b209959	9d69245d-beaa-422f-a9f0-a32a09df6bea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 14:37:52
29430	9d69245d-bd13-4757-a25d-2cc82e7e21e6	9d69245d-beaa-422f-a9f0-a32a09df6bea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1083,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:37:52
29431	9d69245e-7de9-4ab4-b5a2-4fae3065b092	9d69245e-b9fe-43ae-b7ee-5ed91970a05a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 14:37:53
29432	9d69245e-aed0-4f5e-adf7-ea90cdb8388d	9d69245e-b9fe-43ae-b7ee-5ed91970a05a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"81.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:37:53
29433	9d69245e-af6c-4e67-a8d7-3f4108e02235	9d69245e-b9fe-43ae-b7ee-5ed91970a05a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:37:53
29434	9d69245e-b785-4db9-bd42-8d509fa8e98d	9d69245e-b9fe-43ae-b7ee-5ed91970a05a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 14:37:53
29435	9d69245e-b828-4370-abc0-399195e5dc14	9d69245e-b9fe-43ae-b7ee-5ed91970a05a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":609,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:37:53
39782	9d6cb618-01d2-4fc4-8611-86cff08c6c46	9d6cb618-397a-4f46-bff7-927e318960f2	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 09:12:50
39783	9d6cb618-35ef-4c86-98f8-7b12bc190bbc	9d6cb618-397a-4f46-bff7-927e318960f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:12:50
39784	9d6cb618-37d1-48ad-8414-5c26cbb79469	9d6cb618-397a-4f46-bff7-927e318960f2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":541,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:12:50
1214	9d50c5e1-1201-4dc0-b0ea-f06b9d225168	9d50c5e1-1643-4102-98f4-a20b78179872	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":91}	2024-10-23 11:53:48
39785	9d6cb619-9fb5-4353-8020-93884bfe1848	9d6cb619-c13d-4c95-8cce-92b56d1746f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:12:51
39786	9d6cb619-bae5-473f-b279-eaacf803ef82	9d6cb619-c13d-4c95-8cce-92b56d1746f6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:12:51
39787	9d6cb619-bb47-43f7-a8e9-3641fe290984	9d6cb619-c13d-4c95-8cce-92b56d1746f6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:12:51
39788	9d6cb619-bfaa-4795-a19e-ccd067a6e6c6	9d6cb619-c13d-4c95-8cce-92b56d1746f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:12:51
39789	9d6cb619-bffc-4ec3-ad79-2898827b7872	9d6cb619-c13d-4c95-8cce-92b56d1746f6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":326,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:12:51
36178	9d6b3333-1cb3-4016-a2c2-37a8d0a95bbc	9d6b3333-47c9-411a-aabe-d98d0073535d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:11:00
36179	9d6b3333-451f-4a25-9836-dd40776b93f3	9d6b3333-47c9-411a-aabe-d98d0073535d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 15:11:00
36180	9d6b3333-463a-4d47-af4b-f5cf54f586c9	9d6b3333-47c9-411a-aabe-d98d0073535d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":296,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:11:00
36181	9d6b3333-bde1-434e-ad56-1d8b2b9a1f52	9d6b3334-06fd-4975-82e7-f9546b933094	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 15:11:00
36182	9d6b3334-01fc-4539-9d95-570805010090	9d6b3334-06fd-4975-82e7-f9546b933094	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"157.67","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:11:01
36183	9d6b3334-0510-41f9-bf2c-0468d8ba3b95	9d6b3334-06fd-4975-82e7-f9546b933094	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 15:11:01
36184	9d6b3334-05b4-49c2-bc74-c5c76ca692a2	9d6b3334-06fd-4975-82e7-f9546b933094	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":359,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:11:01
36185	9d6b3334-63fa-4c85-a659-1f172cab9a73	9d6b3334-ae42-4013-9c5e-deb9017b4b01	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 15:11:01
36186	9d6b3334-a93a-4967-8010-777654e16c9c	9d6b3334-ae42-4013-9c5e-deb9017b4b01	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"150.35","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:11:01
36187	9d6b3334-a99d-4219-83fa-66ca0d5a4976	9d6b3334-ae42-4013-9c5e-deb9017b4b01	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:11:01
36188	9d6b3334-ad08-496d-b0ad-aaf87ef0fa8c	9d6b3334-ae42-4013-9c5e-deb9017b4b01	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 15:11:01
36189	9d6b3334-ad48-4f07-aa26-b6d91afc0e86	9d6b3334-ae42-4013-9c5e-deb9017b4b01	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":414,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:11:01
36190	9d6b3334-f778-4267-a00c-8cbae42d129c	9d6b3335-171a-4f82-bfba-af1478e79ea9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 15:11:01
36191	9d6b3335-11ba-4d81-8688-5126a22ca7b2	9d6b3335-171a-4f82-bfba-af1478e79ea9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:11:01
36192	9d6b3335-122c-4aa4-9f2a-9f34eadd30c8	9d6b3335-171a-4f82-bfba-af1478e79ea9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:11:01
36193	9d6b3335-15c2-4dea-84a3-6cd4435aa513	9d6b3335-171a-4f82-bfba-af1478e79ea9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 15:11:01
36194	9d6b3335-1607-4f54-9f2a-01eb017a754f	9d6b3335-171a-4f82-bfba-af1478e79ea9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:11:01
36195	9d6b3335-ebb5-4672-aad3-ffa2a2ec0670	9d6b3336-0ae9-4e72-a612-5c839b3cd9ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 15:11:02
36196	9d6b3336-04d8-4411-856f-5bcdf36f4214	9d6b3336-0ae9-4e72-a612-5c839b3cd9ef	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:11:02
36197	9d6b3336-0522-4e05-8f81-0fc8e57a67bb	9d6b3336-0ae9-4e72-a612-5c839b3cd9ef	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:11:02
36198	9d6b3336-097a-4e3e-8231-4af8ddc53ce7	9d6b3336-0ae9-4e72-a612-5c839b3cd9ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 15:11:02
36199	9d6b3336-09db-48e8-9edb-991936804a28	9d6b3336-0ae9-4e72-a612-5c839b3cd9ef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":305,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:11:02
39844	9d6cb7d2-b4e6-420f-8e15-05ce751dc5e9	9d6cb7d2-e5c9-4f13-b95f-663b7a7e1bb8	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 09:17:40
39845	9d6cb7d2-e0fb-4bdf-93b6-40410ee3a4fe	9d6cb7d2-e5c9-4f13-b95f-663b7a7e1bb8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:17:40
39846	9d6cb7d2-e1e7-43bb-8070-c8f7a1f825cf	9d6cb7d2-e5c9-4f13-b95f-663b7a7e1bb8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":353,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:17:40
29722	9d692a9e-acaf-4d8a-825b-35bd2baadc79	9d692a9e-e52a-47ac-bbf0-aa5c72a719a3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 14:55:21
29723	9d692a9e-e266-44ee-9c17-34b3f8d19fdd	9d692a9e-e52a-47ac-bbf0-aa5c72a719a3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 14:55:21
29724	9d692a9e-e3c7-4428-9c6e-c4c4ab420de9	9d692a9e-e52a-47ac-bbf0-aa5c72a719a3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":426,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:55:21
29725	9d692a9f-769f-4aa9-9c9a-dd46c3d3a26b	9d692a9f-a4f2-42d8-9b17-7b0659cb36cb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 14:55:22
29726	9d692a9f-9cd7-4d6f-b731-64265cb0f5de	9d692a9f-a4f2-42d8-9b17-7b0659cb36cb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"63.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":56,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 14:55:22
29727	9d692a9f-9d52-4f9c-9566-6959214c48fc	9d692a9f-a4f2-42d8-9b17-7b0659cb36cb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 14:55:22
29728	9d692a9f-a344-499a-9436-f030fb53cefc	9d692a9f-a4f2-42d8-9b17-7b0659cb36cb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 14:55:22
29729	9d692a9f-a3b7-403c-8461-577db6b3a0cb	9d692a9f-a4f2-42d8-9b17-7b0659cb36cb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":401,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:55:22
29730	9d692aa1-17d5-43fd-9d47-fd9d43106cd7	9d692aa1-85a0-4828-b226-7cc422672570	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 14:55:23
29731	9d692aa1-7995-41ce-933c-38ffbbcc7795	9d692aa1-85a0-4828-b226-7cc422672570	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"180.25","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:55:23
29732	9d692aa1-7a32-4f15-afd4-c6ea556721e2	9d692aa1-85a0-4828-b226-7cc422672570	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:55:23
29733	9d692aa1-82ea-4731-9f58-6219708e3a0d	9d692aa1-85a0-4828-b226-7cc422672570	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 14:55:23
29734	9d692aa1-839a-4c3c-a905-6936a262ceb8	9d692aa1-85a0-4828-b226-7cc422672570	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1207,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:55:23
29735	9d692aa2-32bb-4777-8d2e-9497d1852f63	9d692aa2-92aa-43b1-bf8e-1fda80fba05f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 14:55:24
29736	9d692aa2-8613-4a1f-a1bd-97b296927aa3	9d692aa2-92aa-43b1-bf8e-1fda80fba05f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"154.31","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:55:24
29737	9d692aa2-869a-44c2-8fd0-83804c1b02ce	9d692aa2-92aa-43b1-bf8e-1fda80fba05f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:55:24
29738	9d692aa2-8fbc-49ca-8e81-fcda94914caf	9d692aa2-92aa-43b1-bf8e-1fda80fba05f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 14:55:24
29739	9d692aa2-9070-4290-8621-93678f69d455	9d692aa2-92aa-43b1-bf8e-1fda80fba05f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":659,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:55:24
36500	9d6b3bd7-b6fa-4b8f-9717-0f4a81aa9365	9d6b3bd8-0619-4edc-962c-393eb111726d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 15:35:10
36501	9d6b3bd8-0321-4b1c-94c6-5c824fa737b7	9d6b3bd8-0619-4edc-962c-393eb111726d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:35:10
36502	9d6b3bd8-04a8-4f1a-8f93-68787bff52df	9d6b3bd8-0619-4edc-962c-393eb111726d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":397,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:35:10
36503	9d6b3bd8-836a-4cec-8eb4-8df277956520	9d6b3bd8-a1c2-46b8-9a29-b8fdf3fe101e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:35:11
36504	9d6b3bd8-9c16-4f75-a3c2-bf910bd7dbeb	9d6b3bd8-a1c2-46b8-9a29-b8fdf3fe101e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"44.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:35:11
36505	9d6b3bd8-a035-4f55-ae85-ad3f19f4e702	9d6b3bd8-a1c2-46b8-9a29-b8fdf3fe101e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:35:11
36506	9d6b3bd8-a0cb-433e-a96b-805838f9e670	9d6b3bd8-a1c2-46b8-9a29-b8fdf3fe101e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":331,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:35:11
36507	9d6b3bd9-004d-43f6-b630-ccb262894996	9d6b3bd9-26fc-4797-9f38-c9e642ea5e28	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:35:11
36508	9d6b3bd9-2053-4a20-bb05-bde6f91eec5e	9d6b3bd9-26fc-4797-9f38-c9e642ea5e28	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"52.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:35:11
36509	9d6b3bd9-20bb-4ba3-b8ea-f4ed6cfd0bc6	9d6b3bd9-26fc-4797-9f38-c9e642ea5e28	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:35:11
36510	9d6b3bd9-257f-4e29-b340-95d04f0929d7	9d6b3bd9-26fc-4797-9f38-c9e642ea5e28	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:35:11
36511	9d6b3bd9-25e5-4c68-971c-f0ee335af4b0	9d6b3bd9-26fc-4797-9f38-c9e642ea5e28	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":332,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:35:11
36512	9d6b3bd9-75c6-4168-a50a-25ed4ff7ea45	9d6b3bd9-c18a-45fb-90e3-b164eb4a483a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:35:11
36513	9d6b3bd9-bc4d-4198-9d3d-bdb84fa580df	9d6b3bd9-c18a-45fb-90e3-b164eb4a483a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"155.32","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:35:11
36514	9d6b3bd9-bc9a-4684-ab60-d34498e959cc	9d6b3bd9-c18a-45fb-90e3-b164eb4a483a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:35:11
36515	9d6b3bd9-c020-40b4-ae18-39a2ea272efd	9d6b3bd9-c18a-45fb-90e3-b164eb4a483a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:35:11
36516	9d6b3bd9-c063-49fd-ab0f-ac65cbf47075	9d6b3bd9-c18a-45fb-90e3-b164eb4a483a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":380,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:35:11
36517	9d6b3bdb-8d77-4625-88a7-35d8d4f871e5	9d6b3bdb-b91a-4348-9bd3-f6bc216dd1de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:35:13
36518	9d6b3bdb-b0b8-48e9-9ae7-05032b2f5b8c	9d6b3bdb-b91a-4348-9bd3-f6bc216dd1de	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"61.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:35:13
36519	9d6b3bdb-b121-4a05-925b-690535c2cc44	9d6b3bdb-b91a-4348-9bd3-f6bc216dd1de	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:35:13
36520	9d6b3bdb-b742-4a2c-9dad-23e1fd5130f9	9d6b3bdb-b91a-4348-9bd3-f6bc216dd1de	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:35:13
36521	9d6b3bdb-b7bb-429d-b1e6-ebbd70fd8db5	9d6b3bdb-b91a-4348-9bd3-f6bc216dd1de	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":424,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:35:13
32706	9d69830a-5039-453d-9db3-906c09c273e4	9d69830a-771e-4526-823d-5ca8fc66db03	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 19:02:36
32707	9d69830a-74d5-45fc-a5fd-1d7f7f451f98	9d69830a-771e-4526-823d-5ca8fc66db03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 19:02:36
32708	9d69830a-75e4-45c7-9e80-cdc0b417095c	9d69830a-771e-4526-823d-5ca8fc66db03	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":297,"memory":22,"hostname":"EderCortes"}	2024-11-04 19:02:36
18504	9d66929a-aee5-433b-a948-08d285ddb039	9d66929a-b2c9-4983-b058-c537fcbfb046	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":886}	2024-11-03 07:58:38
32709	9d69830a-de6c-4c42-87a6-c72592fcc0e6	9d69830a-ffa2-4880-9d44-c09ad3441b5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 19:02:36
32710	9d69830a-f8cf-4ee2-8c41-a17dfe0e857f	9d69830a-ffa2-4880-9d44-c09ad3441b5c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":227,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 19:02:36
32711	9d69830a-f92e-4ef8-9663-b829c5d0ee64	9d69830a-ffa2-4880-9d44-c09ad3441b5c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 19:02:36
32712	9d69830a-fe7f-4432-8350-1cc698295470	9d69830a-ffa2-4880-9d44-c09ad3441b5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 19:02:36
32713	9d69830a-fecc-45ee-b656-7bf6637bb8a8	9d69830a-ffa2-4880-9d44-c09ad3441b5c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":289,"memory":22,"hostname":"EderCortes"}	2024-11-04 19:02:36
32714	9d69830b-48b4-4187-9210-20b25111064d	9d69830b-6682-4c23-9a4f-e8dd8c609c75	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 19:02:36
32715	9d69830b-6142-445f-b18a-42a82e447177	9d69830b-6682-4c23-9a4f-e8dd8c609c75	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":216,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 19:02:36
32716	9d69830b-6193-46d2-8b54-d8a6ebe5d839	9d69830b-6682-4c23-9a4f-e8dd8c609c75	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 19:02:36
32717	9d69830b-6542-4720-a141-3955383260b5	9d69830b-6682-4c23-9a4f-e8dd8c609c75	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 19:02:36
32718	9d69830b-658f-46e4-8a79-3dd4dbf34edd	9d69830b-6682-4c23-9a4f-e8dd8c609c75	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-11-04 19:02:36
32719	9d69830b-abc7-4f08-91b7-c6acee98a661	9d69830b-cc88-43e4-9039-b78c25e5f0fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 19:02:37
32720	9d69830b-c5f4-45aa-8b99-c7f42d23fed1	9d69830b-cc88-43e4-9039-b78c25e5f0fd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 19:02:37
32721	9d69830b-c659-44f6-97ff-8470ba891278	9d69830b-cc88-43e4-9039-b78c25e5f0fd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 19:02:37
32722	9d69830b-cb18-484a-acba-33f26ddb9a27	9d69830b-cc88-43e4-9039-b78c25e5f0fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 19:02:37
32723	9d69830b-cb69-4096-a805-cd1ab8e90c77	9d69830b-cc88-43e4-9039-b78c25e5f0fd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":248,"memory":22,"hostname":"EderCortes"}	2024-11-04 19:02:37
36817	9d6b40d9-c560-48ad-8110-7e4eb69395f5	9d6b40d9-e37c-481d-8422-aa94627a925b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:49:10
36818	9d6b40d9-e1b8-462c-a8b2-b57b62b379c3	9d6b40d9-e37c-481d-8422-aa94627a925b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 15:49:10
36819	9d6b40d9-e269-4d0c-b7fb-fa88bf6ade1f	9d6b40d9-e37c-481d-8422-aa94627a925b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":268,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:49:10
2971	9d50fddf-5a10-4685-a564-9bc911257daa	9d50fddf-5e1c-4460-858e-0c01bc424830	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":168}	2024-10-23 14:30:22
36820	9d6b40da-3987-4d50-b08f-0fd4dfef4d8c	9d6b40da-7ced-4136-83ab-92569d880eb1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 15:49:11
36821	9d6b40da-77f4-4900-9096-68baafea51c6	9d6b40da-7ced-4136-83ab-92569d880eb1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"143.45","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:49:11
36822	9d6b40da-7b50-4591-974c-54c8fdf845d9	9d6b40da-7ced-4136-83ab-92569d880eb1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 15:49:11
36823	9d6b40da-7bc8-48aa-8e68-05910fd49d3b	9d6b40da-7ced-4136-83ab-92569d880eb1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:49:11
28580	9d6901fb-20c6-48d3-97f8-172a2f506e5b	9d6901fb-4eee-4cac-8530-638773616423	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":32,"hostname":"EderCortes"}	2024-11-04 13:01:43
28581	9d6901fb-4c4e-472d-99e8-8b53ebdcda37	9d6901fb-4eee-4cac-8530-638773616423	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":33,"hostname":"EderCortes"}	2024-11-04 13:01:43
28582	9d6901fb-4d88-4953-8667-06d75a1fe589	9d6901fb-4eee-4cac-8530-638773616423	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":555,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:01:43
36824	9d6b40da-d71d-4935-ab3d-69b31258ce11	9d6b40db-207c-4b6d-8ef3-ff9060399357	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 15:49:11
36825	9d6b40db-1a9d-486b-a229-c32bff1f0128	9d6b40db-207c-4b6d-8ef3-ff9060399357	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"140.73","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:49:11
36826	9d6b40db-1b0e-4159-a6fc-a4a5bca5cded	9d6b40db-207c-4b6d-8ef3-ff9060399357	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:49:11
36827	9d6b40db-1f18-47c6-8e95-96f1428799ac	9d6b40db-207c-4b6d-8ef3-ff9060399357	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 15:49:11
36828	9d6b40db-1f69-4eb9-86d6-eac17c27ec6c	9d6b40db-207c-4b6d-8ef3-ff9060399357	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":404,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:49:11
36829	9d6b40db-6ad9-41d4-b759-925a5ce1ebf1	9d6b40db-b224-46f9-9d35-b8bf9d97bbbf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 15:49:11
36830	9d6b40db-ac44-4986-b0c9-0239497f2c55	9d6b40db-b224-46f9-9d35-b8bf9d97bbbf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"144.52","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:49:11
36831	9d6b40db-aca4-4677-ac39-d6ff192a9aa3	9d6b40db-b224-46f9-9d35-b8bf9d97bbbf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:49:11
36832	9d6b40db-b0a9-4bd7-808a-eaf8a0c3e6e7	9d6b40db-b224-46f9-9d35-b8bf9d97bbbf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 15:49:12
36833	9d6b40db-b103-437d-a5e4-0058f5eba8ea	9d6b40db-b224-46f9-9d35-b8bf9d97bbbf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":353,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:49:12
36834	9d6b40dd-57fc-457b-b847-c73d86a6ced4	9d6b40dd-9e53-4a4a-b2d5-9ecdd75c0075	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 15:49:13
36835	9d6b40dd-9860-4f4a-9319-38d2fa6dde46	9d6b40dd-9e53-4a4a-b2d5-9ecdd75c0075	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"140.98","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:49:13
36836	9d6b40dd-98bf-45ac-a817-6b3287642c00	9d6b40dd-9e53-4a4a-b2d5-9ecdd75c0075	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:49:13
36837	9d6b40dd-9cd9-405a-a6a2-b9787cfa4525	9d6b40dd-9e53-4a4a-b2d5-9ecdd75c0075	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 15:49:13
36838	9d6b40dd-9d3b-4f28-8947-7b9d1c677e86	9d6b40dd-9e53-4a4a-b2d5-9ecdd75c0075	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":629,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:49:13
31300	9d6949f8-240d-4ee6-8179-f482f26ab421	9d6949f8-46eb-445f-9ca0-d612b9f32b5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:23:01
31301	9d6949f8-3c17-4801-a075-ecf75dd53e87	9d6949f8-46eb-445f-9ca0-d612b9f32b5c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"45.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 16:23:01
31302	9d6949f8-452a-4a15-9c91-875eff1213ca	9d6949f8-46eb-445f-9ca0-d612b9f32b5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:23:01
31303	9d6949f8-45d2-46b0-86bc-df04105321c4	9d6949f8-46eb-445f-9ca0-d612b9f32b5c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abas\\u00bb\\nLINE 1: select * from \\"item_loans\\".* as \\"u.user_alias\\" inner join \\"u...\\n                                     ^ (Connection: pgsql, SQL: select * from \\"item_loans\\".* as \\"u.user_alias\\" inner join \\"users\\" as \\"u\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"u\\".\\"id\\" where \\"loans_codigo\\" = 92 order by \\"item_loans\\".\\"id\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":305,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":309,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:23:01
40084	9d6cc0dc-169e-4960-9183-ed8f50fb9e25	9d6cc0dc-3a35-4968-83d9-46b8d26e3ac8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:42:56
40085	9d6cc0dc-37e3-430c-98fd-a629514ab2bd	9d6cc0dc-3a35-4968-83d9-46b8d26e3ac8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:42:56
40086	9d6cc0dc-38f5-4d18-bc47-d5bce319f0da	9d6cc0dc-3a35-4968-83d9-46b8d26e3ac8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":311,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:42:56
31304	9d6949fa-7e41-40b8-a366-adc1a76d3c1d	9d6949fa-b699-4d54-9d76-2f5782915c31	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:23:02
31305	9d6949fa-ad09-4dff-9704-746bd8fdc2de	9d6949fa-b699-4d54-9d76-2f5782915c31	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"75.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:23:02
31306	9d6949fa-adaa-4527-8691-fa728c0ff501	9d6949fa-b699-4d54-9d76-2f5782915c31	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:23:02
31307	9d6949fa-b4c3-4614-8f4d-246125936abb	9d6949fa-b699-4d54-9d76-2f5782915c31	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 16:23:02
31308	9d6949fa-b53e-42e8-9f59-9ba9067ae5d7	9d6949fa-b699-4d54-9d76-2f5782915c31	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":608,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:23:02
40328	9d6cc283-38cb-42a1-af22-ada11631a1d4	9d6cc283-5972-45c1-8359-ee2ab64ebbee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-06 09:47:34
40329	9d6cc283-578f-4860-898f-95ec0e710bca	9d6cc283-5972-45c1-8359-ee2ab64ebbee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-06 09:47:34
40330	9d6cc283-5824-4fde-b6fe-aed978eea499	9d6cc283-5972-45c1-8359-ee2ab64ebbee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":256,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:47:34
9044	9d52f3d3-c5e1-4cc0-9c96-1970c289c6a8	9d52f3d3-c98c-4713-8031-c0eaf3dc78a4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":434}	2024-10-24 13:53:56
29915	9d692c16-34c3-43fb-83f3-4ff65429073a	9d692c16-7234-4320-ac5e-05853bc4f3af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 14:59:27
29916	9d692c16-6f36-4d44-a205-3cd46708dbb5	9d692c16-7234-4320-ac5e-05853bc4f3af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 14:59:27
29917	9d692c16-7096-4731-8bb2-ed36bcf2be86	9d692c16-7234-4320-ac5e-05853bc4f3af	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":434,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:59:27
29918	9d692c17-1015-40bb-aa18-7b872cf4f48d	9d692c17-3cdc-457b-b8b8-7f4f1f6f8a11	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 14:59:28
29919	9d692c17-315c-4086-a083-b21deaea74c1	9d692c17-3cdc-457b-b8b8-7f4f1f6f8a11	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"57.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":56,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 14:59:28
29920	9d692c17-31f6-4543-a428-99db9d899e1d	9d692c17-3cdc-457b-b8b8-7f4f1f6f8a11	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 14:59:28
29921	9d692c17-3a78-4f65-90e2-6b89010485c6	9d692c17-3cdc-457b-b8b8-7f4f1f6f8a11	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-04 14:59:28
29922	9d692c17-3b2e-4057-ba72-99d887d26996	9d692c17-3cdc-457b-b8b8-7f4f1f6f8a11	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":431,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:59:28
29923	9d692c17-f40e-4ab2-a63e-9261288a08e8	9d692c18-2bb1-4362-b4f7-cf647d4f02d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-04 14:59:28
29924	9d692c18-21e6-493f-af8f-7f680ebc2712	9d692c18-2bb1-4362-b4f7-cf647d4f02d0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"82.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:59:29
29925	9d692c18-226f-463b-8d06-2a5636f89d64	9d692c18-2bb1-4362-b4f7-cf647d4f02d0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:59:29
29926	9d692c18-2903-4661-ad05-33c1acc9ccb6	9d692c18-2bb1-4362-b4f7-cf647d4f02d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-04 14:59:29
29927	9d692c18-29a8-409f-84bb-8d50c7e3b1f5	9d692c18-2bb1-4362-b4f7-cf647d4f02d0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":584,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:59:29
40537	9d6cc4d0-c843-482a-88f5-2751e427d05a	9d6cc4d0-cc15-4f6f-991b-0a756a50e393	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1824}	2024-11-06 09:54:00
29928	9d692c19-ba67-4cd3-9ddf-67ffda0caed3	9d692c19-eab7-4a82-812e-c72a4379836e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-04 14:59:30
29929	9d692c19-e0f8-4089-b4d7-bc408dfcc7fb	9d692c19-eab7-4a82-812e-c72a4379836e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"61.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:59:30
29930	9d692c19-e182-412c-974a-1d1ec76f7be5	9d692c19-eab7-4a82-812e-c72a4379836e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:59:30
29931	9d692c19-e8d7-48d7-8a74-8166e03c0370	9d692c19-eab7-4a82-812e-c72a4379836e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-04 14:59:30
29932	9d692c19-e95e-4e9c-97af-68ea390b5df3	9d692c19-eab7-4a82-812e-c72a4379836e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":845,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:59:30
31466	9d694c39-ee6f-4a36-bf99-58772d147ceb	9d694c3a-308a-4298-b2b4-3ab695a59980	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 16:29:19
31467	9d694c3a-2dc9-4d1d-b27b-4209ca1d64d8	9d694c3a-308a-4298-b2b4-3ab695a59980	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:29:20
31468	9d694c3a-2f0c-4113-b773-d61a3e4dc781	9d694c3a-308a-4298-b2b4-3ab695a59980	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":677,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:29:20
31469	9d694c3a-eedb-4727-a640-10be4f5309f8	9d694c3b-27ec-47f5-a93f-7ae4dd14b612	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 16:29:20
31470	9d694c3b-1a89-47b4-b9ec-a9fcef35cb1a	9d694c3b-27ec-47f5-a93f-7ae4dd14b612	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"77.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 16:29:20
31471	9d694c3b-1efa-4d4b-ad27-cd33087d049b	9d694c3b-27ec-47f5-a93f-7ae4dd14b612	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" inner join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '92' order by \\"item_loans\\".\\"id\\" asc","time":"3.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":304,"hash":"ac513f13416666eb3a5127ebc04741a7","hostname":"EderCortes"}	2024-11-04 16:29:20
31472	9d694c3b-2561-4b09-86c6-970fa88189ac	9d694c3b-27ec-47f5-a93f-7ae4dd14b612	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:29:20
31473	9d694c3b-2625-452d-9dcf-772aca815957	9d694c3b-27ec-47f5-a93f-7ae4dd14b612	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":92,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":15,"loans_valor_prestado":8000009,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"533333.93333333","loans_pago_interes":"133333.48333333","user_alias":"eder.cortes"},"items":[{"id":379,"loans_codigo":92,"itemloans_cuota":"1","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:13:07","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":380,"loans_codigo":92,"itemloans_cuota":"2","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":381,"loans_codigo":92,"itemloans_cuota":"3","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":382,"loans_codigo":92,"itemloans_cuota":"4","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":383,"loans_codigo":92,"itemloans_cuota":"5","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":384,"loans_codigo":92,"itemloans_cuota":"6","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":385,"loans_codigo":92,"itemloans_cuota":"7","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":386,"loans_codigo":92,"itemloans_cuota":"8","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":387,"loans_codigo":92,"itemloans_cuota":"9","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-15 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":388,"loans_codigo":92,"itemloans_cuota":"10","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":389,"loans_codigo":92,"itemloans_cuota":"11","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-31 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":390,"loans_codigo":92,"itemloans_cuota":"12","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":391,"loans_codigo":92,"itemloans_cuota":"13","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-16 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":392,"loans_codigo":92,"itemloans_cuota":"14","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":393,"loans_codigo":92,"itemloans_cuota":"15","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":532,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:29:20
35003	9d69c150-9aa1-4aa1-a856-f40475619c5c	9d69c150-9bbe-4e65-b801-fcf1775591c7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":350,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:56:44
31474	9d694c3c-1acd-44fc-a2bf-6ba9e971fae8	9d694c3c-a1f9-44f5-96c2-fb3711f543bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 16:29:21
31475	9d694c3c-9683-4acc-abc0-c055daf6102e	9d694c3c-a1f9-44f5-96c2-fb3711f543bf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"254.68","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:29:21
31476	9d694c3c-970a-4265-8e2a-873ff5297bc5	9d694c3c-a1f9-44f5-96c2-fb3711f543bf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:29:21
31477	9d694c3c-9f6b-4487-b20c-6e2fa7bc64e2	9d694c3c-a1f9-44f5-96c2-fb3711f543bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:29:21
31478	9d694c3c-a022-4825-8a8b-c53ece55886f	9d694c3c-a1f9-44f5-96c2-fb3711f543bf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":952,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:29:21
35599	9d69c503-bc90-4933-97fe-152799328bc4	9d69c503-c600-4acb-b445-d4b648a4277f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"70.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 22:07:04
35004	9d69c150-e06e-4feb-b45c-a5d18efc7bfd	9d69c150-fe80-48b9-9d76-edfa90a50f9a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 21:56:44
35005	9d69c150-f8f0-4250-a116-b0e10f44c74e	9d69c150-fe80-48b9-9d76-edfa90a50f9a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 21:56:44
35006	9d69c150-f957-4b91-8ccc-83a38a464ef5	9d69c150-fe80-48b9-9d76-edfa90a50f9a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 21:56:44
35007	9d69c150-fd20-4d5e-b0e2-25001357a87f	9d69c150-fe80-48b9-9d76-edfa90a50f9a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 21:56:44
35008	9d69c150-fd86-49d6-b5b6-80eec3a4554a	9d69c150-fe80-48b9-9d76-edfa90a50f9a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:56:44
35600	9d69c503-c37a-4aa9-8fcd-463db12935d9	9d69c503-c600-4acb-b445-d4b648a4277f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":33,"hostname":"EderCortes"}	2024-11-04 22:07:04
35601	9d69c503-c44a-4d18-9dd3-12904c7df032	9d69c503-c600-4acb-b445-d4b648a4277f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":496,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:07:04
31479	9d694c3d-6710-457b-8cc3-ea59f91a2082	9d694c3d-9a40-4007-b366-7858fe4e8761	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 16:29:22
31480	9d694c3d-91cf-4edc-b23d-5dc2e4df2ae6	9d694c3d-9a40-4007-b366-7858fe4e8761	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"70.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:29:22
31481	9d694c3d-926f-4856-aa9f-ab38fe8bdf2b	9d694c3d-9a40-4007-b366-7858fe4e8761	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:29:22
31482	9d694c3d-9864-49b0-a918-af09c8e00f63	9d694c3d-9a40-4007-b366-7858fe4e8761	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 16:29:22
31483	9d694c3d-98e4-4e6c-841f-a82818eef67d	9d694c3d-9a40-4007-b366-7858fe4e8761	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":604,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:29:22
35602	9d69c504-4dc0-4a38-b551-c8046b2b51b4	9d69c504-7b0d-467b-9157-8e23f3ca08c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":33,"hostname":"EderCortes"}	2024-11-04 22:07:05
35009	9d69c151-3fe6-4243-a4a5-2d22ba2acec7	9d69c151-5e0f-4e40-bd6a-ebd1a3bf57ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 21:56:44
35010	9d69c151-58db-4bfc-816d-baad9792512d	9d69c151-5e0f-4e40-bd6a-ebd1a3bf57ea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:56:44
35011	9d69c151-5933-42da-8c5f-9ea8bc4f6998	9d69c151-5e0f-4e40-bd6a-ebd1a3bf57ea	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:56:44
35012	9d69c151-5ce0-4235-94fa-a02cfa7c6c38	9d69c151-5e0f-4e40-bd6a-ebd1a3bf57ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 21:56:44
35013	9d69c151-5d2f-4834-936d-31ca2e316666	9d69c151-5e0f-4e40-bd6a-ebd1a3bf57ea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:56:44
35603	9d69c504-72f8-42ed-93e3-b76815ee6aec	9d69c504-7b0d-467b-9157-8e23f3ca08c0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"58.04","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:07:05
35604	9d69c504-7384-4fc7-9caf-61fc679f7f7c	9d69c504-7b0d-467b-9157-8e23f3ca08c0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:07:05
35605	9d69c504-7952-4876-97ce-c85b71305002	9d69c504-7b0d-467b-9157-8e23f3ca08c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":34,"hostname":"EderCortes"}	2024-11-04 22:07:05
40551	9d6cc4e5-beb3-46e7-9074-6cdd24127cbe	9d6cc4e5-dfde-4ab4-9528-4286c88e55d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:54:14
40552	9d6cc4e5-dd74-40a7-9c20-d291edb9fc0e	9d6cc4e5-dfde-4ab4-9528-4286c88e55d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:54:14
40553	9d6cc4e5-deb6-4f02-838b-e1abe41e0aa4	9d6cc4e5-dfde-4ab4-9528-4286c88e55d3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":289,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:54:14
14573	9d5ebe9a-2b01-4b04-a373-30e90883d34e	9d5ebe9a-3278-4afb-b717-95b0cea5c4b5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":666}	2024-10-30 10:35:02
40398	9d6cc30c-5091-4282-aa6c-7f21c5b4dd6e	9d6cc30c-9d71-406b-ab1a-fe25c0a20044	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 09:49:03
40399	9d6cc30c-9b7d-4719-950d-ed57767b8b4d	9d6cc30c-9d71-406b-ab1a-fe25c0a20044	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:49:04
40400	9d6cc30c-9c38-438e-9fdc-98ac61f3cf22	9d6cc30c-9d71-406b-ab1a-fe25c0a20044	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":363,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:49:04
2919	9d50fdaa-f62b-4c64-813e-933be3048d25	9d50fdaa-f92c-4426-97bb-49483417c56e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":165}	2024-10-23 14:29:47
40670	9d6cc669-a75a-4b75-af73-85044e0e63f0	9d6cc669-eca7-4399-98c9-42d63226daad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 09:58:28
40671	9d6cc669-eb1a-4835-9aa1-d4675dc884db	9d6cc669-eca7-4399-98c9-42d63226daad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 09:58:28
40672	9d6cc669-ebb1-43c9-b447-58415a75a9eb	9d6cc669-eca7-4399-98c9-42d63226daad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":344,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:58:28
34515	9d69beab-fe8b-46ee-ae77-b0edd0870a80	9d69beac-4c02-42e7-98a7-1eaad53afe04	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 21:49:20
34516	9d69beac-4a04-4714-973c-d6b6aa51079e	9d69beac-4c02-42e7-98a7-1eaad53afe04	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:49:20
34517	9d69beac-4ac9-4085-9778-9aecfc7e048b	9d69beac-4c02-42e7-98a7-1eaad53afe04	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:49:20
34518	9d69beac-b716-4dca-8774-96d60ac29de5	9d69beac-d98e-468a-8af2-749217132917	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:49:21
34519	9d69beac-d2c0-40a9-8590-0ac4eb2b3620	9d69beac-d98e-468a-8af2-749217132917	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":258,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:49:21
34520	9d69beac-d31a-481a-9b91-f2628788ffa7	9d69beac-d98e-468a-8af2-749217132917	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:49:21
34521	9d69beac-d837-448b-888a-31cb9d47cd7c	9d69beac-d98e-468a-8af2-749217132917	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:49:21
34522	9d69beac-d892-4be3-b0e2-58f958b79d3e	9d69beac-d98e-468a-8af2-749217132917	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":299,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:49:21
34523	9d69bead-2896-4a72-a4e4-7ab6e5a224a8	9d69bead-708c-4f18-a676-bd8c1239d6a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:49:21
34524	9d69bead-6b2d-431a-875f-b67cd1d93b9b	9d69bead-708c-4f18-a676-bd8c1239d6a6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"144.67","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":247,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 21:49:21
34525	9d69bead-6b98-403d-bf56-e65862d7e860	9d69bead-708c-4f18-a676-bd8c1239d6a6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 21:49:21
34526	9d69bead-6f67-47f9-be04-44b955509aab	9d69bead-708c-4f18-a676-bd8c1239d6a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:49:21
34527	9d69bead-6faf-4a44-9fd0-323d50786d48	9d69bead-708c-4f18-a676-bd8c1239d6a6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":372,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:49:21
34528	9d69bead-bc59-4ec0-8927-c6c92ecf23bf	9d69beae-04e3-4124-86a2-47c285be29e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:49:21
34529	9d69bead-ff6c-4c0a-b105-09559c95fc93	9d69beae-04e3-4124-86a2-47c285be29e1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"149.55","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:49:22
34530	9d69bead-ffda-44c4-9732-068758ae66ca	9d69beae-04e3-4124-86a2-47c285be29e1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:49:22
34531	9d69beae-03b8-47a4-9311-5d68b782a65f	9d69beae-04e3-4124-86a2-47c285be29e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:49:22
34532	9d69beae-0406-421a-9d39-19a279bd5ea2	9d69beae-04e3-4124-86a2-47c285be29e1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":361,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:49:22
34533	9d69beae-4ac9-49ae-9074-062431a6a878	9d69beae-9445-4a91-b691-957796798da3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:49:22
34534	9d69beae-8d7e-484d-920a-0a8794fd7ffa	9d69beae-9445-4a91-b691-957796798da3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_valor_prestado\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"loans_inicio_pago\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"loans_fecha_ultimo_pago\\", \\"loans_intereses_recaudar\\", \\"user_recomendacion\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\" from \\"loans\\" where \\"id\\" = '93' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"151.93","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":234,"hash":"b4e83635108fe86540c23b34f96ea07e","hostname":"EderCortes"}	2024-11-04 21:49:22
34535	9d69beae-8dd0-41d0-89b9-1a908e4141dc	9d69beae-9445-4a91-b691-957796798da3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 21:49:22
34536	9d69beae-8fa7-43a5-b192-9ebb28c530e6	9d69beae-9445-4a91-b691-957796798da3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"2.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":235,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 21:49:22
34537	9d69beae-8fdc-4fce-b269-1cefc6c361a1	9d69beae-9445-4a91-b691-957796798da3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 21:49:22
34538	9d69beae-92fb-485a-8bb9-9bebd31a9213	9d69beae-9445-4a91-b691-957796798da3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:49:22
34539	9d69beae-9346-4d66-9ee4-11e8d0f3b00f	9d69beae-9445-4a91-b691-957796798da3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","user_creador":12,"user_cobrador":22,"user_customer":19,"loans_fecha_ultimo_pago":"04-11-2024","loans_intereses_recaudar":"250000","user_recomendacion":18,"loans_pago_prestado":"1000000","loans_pago_interes":"250000"},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:19:45.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:22:30.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":399,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":400,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":401,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":402,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"}]}},"duration":352,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:49:22
40619	9d6cc614-3d94-4de0-b4cd-0fc62144041a	9d6cc614-61a1-4c1a-abac-c82663ecce14	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 09:57:32
40620	9d6cc614-5fbe-440a-89ee-d887d80efed7	9d6cc614-61a1-4c1a-abac-c82663ecce14	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 09:57:32
40621	9d6cc614-609f-41e9-ac97-3f03ae3ddff0	9d6cc614-61a1-4c1a-abac-c82663ecce14	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":303,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:57:32
34540	9d69beb0-4d92-4e16-a803-0efb323b87c5	9d69beb0-a395-4c84-b694-c633c0f0cba3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:49:23
34541	9d69beb0-9dec-4782-b01f-8778d5b17fec	9d69beb0-a395-4c84-b694-c633c0f0cba3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"162.15","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:49:23
34542	9d69beb0-9e50-4cab-98d2-44b54e5b39af	9d69beb0-a395-4c84-b694-c633c0f0cba3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:49:23
34543	9d69beb0-a21c-4712-89be-7f0e2e2664be	9d69beb0-a395-4c84-b694-c633c0f0cba3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:49:23
34544	9d69beb0-a27e-47a4-a7f5-552b159a153f	9d69beb0-a395-4c84-b694-c633c0f0cba3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":492,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:49:23
40469	9d6cc3bf-9ab6-4b31-ab4f-ceee5d09050e	9d6cc3bf-9d62-47d7-9cfe-31575a6b2f0d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1816}	2024-11-06 09:51:01
33834	9d69b797-eef8-45e8-8938-7b6223e3da6e	9d69b798-15e1-4ed1-ae3b-7ea4c946fc61	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 21:29:33
33835	9d69b798-13d5-4809-a48d-111dfc44e4b5	9d69b798-15e1-4ed1-ae3b-7ea4c946fc61	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:29:33
33836	9d69b798-14b4-4e03-9182-9c90c6c8f53b	9d69b798-15e1-4ed1-ae3b-7ea4c946fc61	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":352,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:29:33
33837	9d69b798-9e21-4268-b1f3-b45d00ec1e9b	9d69b798-bdac-49fe-8f8f-3f78f4230397	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:29:33
33838	9d69b798-b535-4671-aa53-f37d71b34bd1	9d69b798-bdac-49fe-8f8f-3f78f4230397	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 82\\n                        ","time":"43.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"23238af5dc47e80ea555e80a08e2015d","hostname":"EderCortes"}	2024-11-04 21:29:33
33839	9d69b798-b83d-41d0-927e-e9a038f007f2	9d69b798-bdac-49fe-8f8f-3f78f4230397	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '82' order by \\"item_loans\\".\\"id\\" asc","time":"2.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:29:33
33840	9d69b798-bc6e-4f4d-8afd-157c0adbb96a	9d69b798-bdac-49fe-8f8f-3f78f4230397	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:29:33
33841	9d69b798-bcc9-4d7b-8881-000cd3848bde	9d69b798-bdac-49fe-8f8f-3f78f4230397	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/82","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":82,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"0","loans_pago_interes":"0","user_alias":"eder.cortes"},"items":[{"id":316,"loans_codigo":82,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:36","updated_at":"2024-11-04 09:18:36","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":317,"loans_codigo":82,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:36","updated_at":"2024-11-04 09:18:36","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":318,"loans_codigo":82,"itemloans_cuota":"3","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:36","updated_at":"2024-11-04 09:18:36","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":319,"loans_codigo":82,"itemloans_cuota":"4","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:36","updated_at":"2024-11-04 09:18:36","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":320,"loans_codigo":82,"itemloans_cuota":"5","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:36","updated_at":"2024-11-04 09:18:36","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":307,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:29:33
33842	9d69b79a-d390-4aa5-b76f-e76b3a8b687d	9d69b79b-17f9-40fd-ab78-7097ac084198	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:29:35
33843	9d69b79b-12ac-499e-98f8-64151e25e3c8	9d69b79b-17f9-40fd-ab78-7097ac084198	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"140.84","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:29:35
33844	9d69b79b-1310-4804-950a-90fda0d88c7e	9d69b79b-17f9-40fd-ab78-7097ac084198	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:29:35
33845	9d69b79b-1692-439d-bb6f-1a7a9ff11ce5	9d69b79b-17f9-40fd-ab78-7097ac084198	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:29:35
33846	9d69b79b-16e4-460d-80e0-284f01f535c7	9d69b79b-17f9-40fd-ab78-7097ac084198	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:29:35
33847	9d69b7a5-73fa-402c-8841-27d68586e0ac	9d69b7a5-775a-4f9b-a411-0223e43af892	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":171,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:29:42
33848	9d69b7a6-2f45-4a28-a97c-4d901c1dcc3d	9d69b7a6-56ae-4cf7-9d94-aab7a6f5990b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:29:42
33849	9d69b7a6-47c2-457f-a56d-1dd08d77c7e2	9d69b7a6-56ae-4cf7-9d94-aab7a6f5990b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 82 limit 1","time":"3.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":505,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 21:29:42
33850	9d69b7a6-4814-48fc-96b2-3fe400bd8115	9d69b7a6-56ae-4cf7-9d94-aab7a6f5990b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":2,"hostname":"EderCortes"}	2024-11-04 21:29:42
33851	9d69b7a6-49d1-4ab2-a97c-1562ea950176	9d69b7a6-56ae-4cf7-9d94-aab7a6f5990b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select count(*) as aggregate from \\"item_loans\\" where \\"loans_codigo\\" = 82 and (\\"itemloans_status\\" = 'Pagada' or \\"itemloans_status\\" = 'Abono')","time":"2.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":566,"hash":"40bb62c1101cd4a074e44b13c59d4517","hostname":"EderCortes"}	2024-11-04 21:29:42
33852	9d69b7a6-4a75-46fe-9d84-18e205e7e59f	9d69b7a6-56ae-4cf7-9d94-aab7a6f5990b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_estado\\" = 'En curso', \\"loans_pago_interes\\" = 60000, \\"loans_pago_prestado\\" = 240000, \\"updated_at\\" = '2024-11-04 21:29:42' where \\"id\\" = 82","time":"0.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":605,"hash":"acfe32aea56c9ca6bdbb917f944a78d1","hostname":"EderCortes"}	2024-11-04 21:29:42
33853	9d69b7a6-4ada-46b1-8f31-996270c5a64a	9d69b7a6-56ae-4cf7-9d94-aab7a6f5990b	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:82","changes":{"loans_estado":"En curso","updated_at":"2024-11-04 21:29:42","loans_pago_interes":60000,"loans_pago_prestado":240000},"hostname":"EderCortes"}	2024-11-04 21:29:42
33854	9d69b7a6-4b5a-4aed-b17c-db3481a4a167	9d69b7a6-56ae-4cf7-9d94-aab7a6f5990b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 82 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"0.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":612,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-04 21:29:42
33855	9d69b7a6-4b90-4bd5-8390-c32660919dd5	9d69b7a6-56ae-4cf7-9d94-aab7a6f5990b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-04 21:29:42
33856	9d69b7a6-4c10-4629-8d74-93975ed48d47	9d69b7a6-56ae-4cf7-9d94-aab7a6f5990b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Abono', \\"item_loans_cuando_pago\\" = '04-11-2024', \\"itemloans_interes_canelado\\" = 60000, \\"itemloans_cuota_cancelada\\" = 240000, \\"updated_at\\" = '2024-11-04 21:29:42' where \\"id\\" = 316","time":"0.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":620,"hash":"5de7771f8b15cc42d297e1f30d550186","hostname":"EderCortes"}	2024-11-04 21:29:42
33857	9d69b7a6-4c47-435e-9e82-7499b739ebac	9d69b7a6-56ae-4cf7-9d94-aab7a6f5990b	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:316","changes":{"itemloans_status":"Abono","updated_at":"2024-11-04 21:29:42","item_loans_cuando_pago":"04-11-2024","itemloans_interes_canelado":60000,"itemloans_cuota_cancelada":240000},"hostname":"EderCortes"}	2024-11-04 21:29:42
33858	9d69b7a6-4ca0-46d1-a6fc-f5ffec52299b	9d69b7a6-56ae-4cf7-9d94-aab7a6f5990b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"delete from \\"item_loans\\" where \\"loans_codigo\\" = 82 and \\"itemloans_status\\" = 'Pendiente'","time":"0.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":627,"hash":"89bf3c496a8b0746ff5d1219b8dc29e3","hostname":"EderCortes"}	2024-11-04 21:29:42
33859	9d69b7a6-4cfd-4ee0-8aa4-e3cb1ec2a5b3	9d69b7a6-56ae-4cf7-9d94-aab7a6f5990b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 82 limit 1","time":"0.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":630,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-04 21:29:42
33860	9d69b7a6-4da9-425c-9824-49227ef787da	9d69b7a6-56ae-4cf7-9d94-aab7a6f5990b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (82, 2, 215000, 53750, 'Pendiente', 'Se realiza abono', '12-11-2024', 0, 0, '2024-11-04 21:29:42', '2024-11-04 21:29:42')","time":"0.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":693,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:29:42
33861	9d69b7a6-4dd8-4801-bd2b-e9b2b2cefbe1	9d69b7a6-56ae-4cf7-9d94-aab7a6f5990b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:29:42
33862	9d69b7a6-4e44-44d8-a9c9-5390a2084657	9d69b7a6-56ae-4cf7-9d94-aab7a6f5990b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (82, 3, 215000, 53750, 'Pendiente', 'Se realiza abono', '20-11-2024', 0, 0, '2024-11-04 21:29:42', '2024-11-04 21:29:42')","time":"0.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":693,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:29:42
33863	9d69b7a6-4e69-4fee-8086-8f583d756528	9d69b7a6-56ae-4cf7-9d94-aab7a6f5990b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:29:42
33864	9d69b7a6-4ed7-44e6-8e0f-fded9425b9a9	9d69b7a6-56ae-4cf7-9d94-aab7a6f5990b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (82, 4, 215000, 53750, 'Pendiente', 'Se realiza abono', '28-11-2024', 0, 0, '2024-11-04 21:29:42', '2024-11-04 21:29:42')","time":"0.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":693,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:29:42
33865	9d69b7a6-4efd-473f-8cd3-e83ff5a3d8b8	9d69b7a6-56ae-4cf7-9d94-aab7a6f5990b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:29:42
30151	9d693485-2df6-4f77-9a94-fd6c5d5e39a4	9d693485-6a44-4892-a2ec-6b385922e3e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 15:23:02
30152	9d693485-677e-4813-bbef-c60d8511b7a9	9d693485-6a44-4892-a2ec-6b385922e3e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 15:23:02
30153	9d693485-68d2-4aca-a504-0d43123d8382	9d693485-6a44-4892-a2ec-6b385922e3e5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":502,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:23:02
30154	9d693486-14f8-4632-b53b-16fcc8339d1e	9d693486-470d-4549-b16a-fd46ef7ebae9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 15:23:03
30155	9d693486-3be7-4c6e-927e-c46e8dd7030a	9d693486-470d-4549-b16a-fd46ef7ebae9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"62.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":56,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 15:23:03
30156	9d693486-3c7b-4533-bca2-b7dbf1b6ae70	9d693486-470d-4549-b16a-fd46ef7ebae9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 15:23:03
30157	9d693486-44fd-4293-9242-0b3a8eed401a	9d693486-470d-4549-b16a-fd46ef7ebae9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 15:23:03
30158	9d693486-458c-49df-b8b5-27b924396896	9d693486-470d-4549-b16a-fd46ef7ebae9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":462,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:23:03
33866	9d69b7a6-4f65-42f9-b339-b9b6bd891aad	9d69b7a6-56ae-4cf7-9d94-aab7a6f5990b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (82, 5, 215000, 53750, 'Pendiente', 'Se realiza abono', '06-12-2024', 0, 0, '2024-11-04 21:29:42', '2024-11-04 21:29:42')","time":"0.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":693,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-04 21:29:42
33867	9d69b7a6-4f8a-41eb-a46e-ce577f26a103	9d69b7a6-56ae-4cf7-9d94-aab7a6f5990b	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-04 21:29:42
33868	9d69b7a6-5568-4a5f-823c-53c6efec2e19	9d69b7a6-56ae-4cf7-9d94-aab7a6f5990b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:29:42
33869	9d69b7a6-55ad-4cfa-90c2-a7ea8f7c652f	9d69b7a6-56ae-4cf7-9d94-aab7a6f5990b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"61","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"300000","idLoans":82,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El abono fue aplicado exitosamente","status":true},"duration":262,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:29:42
35606	9d69c504-79c1-48ee-9cbd-2948c278b192	9d69c504-7b0d-467b-9157-8e23f3ca08c0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":444,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:07:05
30159	9d693487-15f6-4696-a914-a9f1a038114d	9d693487-529a-43ef-ac0c-0fbd29d4bace	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 15:23:03
30160	9d693487-453e-471b-b130-57794e503fca	9d693487-529a-43ef-ac0c-0fbd29d4bace	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"73.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:23:04
30161	9d693487-45d4-459d-8dc9-6d10c18f3460	9d693487-529a-43ef-ac0c-0fbd29d4bace	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:23:04
30162	9d693487-4ee6-4b31-a42e-85577f8d8ccf	9d693487-529a-43ef-ac0c-0fbd29d4bace	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 15:23:04
30163	9d693487-4f6f-4161-97cb-7dda178864ee	9d693487-529a-43ef-ac0c-0fbd29d4bace	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":653,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:23:04
33870	9d69b7a6-a2d1-48fd-ad37-18bb41b6b351	9d69b7a6-ea28-4e8b-ba68-4aa0d8196a4d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:29:42
33871	9d69b7a6-e2c2-400b-a0fe-0a9b600cd226	9d69b7a6-ea28-4e8b-ba68-4aa0d8196a4d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 82\\n                        ","time":"149.95","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"23238af5dc47e80ea555e80a08e2015d","hostname":"EderCortes"}	2024-11-04 21:29:42
30552	9d693fd5-c419-4da4-a5e6-6b57e2424bfe	9d693fd5-d06f-49fe-9ff2-e395fc2c7185	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"74.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:54:41
30553	9d693fd5-c4ad-4691-8c80-c241b2d3975d	9d693fd5-d06f-49fe-9ff2-e395fc2c7185	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:54:41
30554	9d693fd5-ce15-468a-878f-defbd4d2354e	9d693fd5-d06f-49fe-9ff2-e395fc2c7185	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-04 15:54:41
30555	9d693fd5-cebe-4fb2-8864-bb3d68dfc02c	9d693fd5-d06f-49fe-9ff2-e395fc2c7185	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":681,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:54:41
35607	9d69c505-d595-467f-ac2d-06a9e9f30e4c	9d69c506-125a-4c84-99c3-1abc115a36d4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":34,"hostname":"EderCortes"}	2024-11-04 22:07:06
30164	9d693487-f538-4ab6-8ddf-f7bf8d412170	9d693488-2e24-4b83-aeb8-bb6225b9d616	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 15:23:04
30165	9d693488-2343-4142-aac2-acb52564cc6f	9d693488-2e24-4b83-aeb8-bb6225b9d616	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"73.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:23:04
30166	9d693488-23e9-4c6e-8eb9-4d4b4eaa8dd7	9d693488-2e24-4b83-aeb8-bb6225b9d616	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:23:04
30167	9d693488-2be0-4667-a3c7-1ae86ccfbd8d	9d693488-2e24-4b83-aeb8-bb6225b9d616	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 15:23:04
30168	9d693488-2c8a-4416-a8a6-490439fedbe9	9d693488-2e24-4b83-aeb8-bb6225b9d616	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":531,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:23:04
33872	9d69b7a6-e5c6-467b-87c9-372aff68e6b6	9d69b7a6-ea28-4e8b-ba68-4aa0d8196a4d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '82' order by \\"item_loans\\".\\"id\\" asc","time":"2.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:29:42
33873	9d69b7a6-e8ab-4795-a945-5746e685510a	9d69b7a6-ea28-4e8b-ba68-4aa0d8196a4d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:29:42
30556	9d693fdb-d9e9-480e-885a-fcc31df5d383	9d693fdb-ddd8-4d9c-97c2-cb39b07deec9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/updateUser","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":141,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:54:45
33874	9d69b7a6-e8f9-4d45-ae88-b9caf6a21502	9d69b7a6-ea28-4e8b-ba68-4aa0d8196a4d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/82","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":82,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"240000","loans_pago_interes":"60000","user_alias":"eder.cortes"},"items":[{"id":316,"loans_codigo":82,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:36","updated_at":"2024-11-04 21:29:42","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":464,"loans_codigo":82,"itemloans_cuota":"2","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:29:42","updated_at":"2024-11-04 21:29:42","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":465,"loans_codigo":82,"itemloans_cuota":"3","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:29:42","updated_at":"2024-11-04 21:29:42","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":466,"loans_codigo":82,"itemloans_cuota":"4","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:29:42","updated_at":"2024-11-04 21:29:42","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":467,"loans_codigo":82,"itemloans_cuota":"5","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:29:42","updated_at":"2024-11-04 21:29:42","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":351,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:29:42
33875	9d69b7c6-4834-4a93-913d-ccf7751fd61f	9d69b7c6-4bce-46c6-9455-0af50973b970	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":157,"memory":20,"hostname":"EderCortes"}	2024-11-04 21:30:03
35608	9d69c506-091f-4a10-a574-1ee6d53683a5	9d69c506-125a-4c84-99c3-1abc115a36d4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"86.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:07:06
30557	9d693fdc-4272-476c-b285-50f50c843d4b	9d693fdc-60a6-4458-a81d-b2b8c0c292ab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-04 15:54:45
30558	9d693fdc-5b32-415e-a3ae-1063644b6cb8	9d693fdc-60a6-4458-a81d-b2b8c0c292ab	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = 12 and \\"users\\".\\"deleted_at\\" is null limit 1","time":"2.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":89,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 15:54:45
30559	9d693fdc-5b7f-4227-b83f-6a22f9a6c47c	9d693fdc-60a6-4458-a81d-b2b8c0c292ab	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 15:54:45
30560	9d693fdc-5f6d-46bb-baf4-8adb828cdc89	9d693fdc-60a6-4458-a81d-b2b8c0c292ab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-11-04 15:54:45
30561	9d693fdc-5fb5-40a1-8d0f-9ecdbcba6e21	9d693fdc-60a6-4458-a81d-b2b8c0c292ab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/updateUser","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@updateUser","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"547","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","profile_code":1,"user_age":"29","user_alias":"eder_cortes","email_verified_at":null,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:47:38.000000Z","deleted_at":null},"session":[],"response_status":200,"response":{"response":"El registro fue actualizado exitosamente"},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:54:45
35609	9d69c506-09bb-43f0-94ee-dd76e0251dd8	9d69c506-125a-4c84-99c3-1abc115a36d4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:07:06
35610	9d69c506-1027-4861-ad93-b58e33a0546f	9d69c506-125a-4c84-99c3-1abc115a36d4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":35,"hostname":"EderCortes"}	2024-11-04 22:07:06
35611	9d69c506-10b0-4d58-90ce-df320aa9f6ec	9d69c506-125a-4c84-99c3-1abc115a36d4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1016,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:07:06
35612	9d69c506-ca23-46e2-9258-ec4239aad29c	9d69c506-fc8c-4319-9b7b-2f0a150f8699	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":35,"hostname":"EderCortes"}	2024-11-04 22:07:06
35613	9d69c506-f400-42c6-b637-5920c894e0f5	9d69c506-fc8c-4319-9b7b-2f0a150f8699	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"66.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:07:06
35614	9d69c506-f49d-4809-8539-edfa5368ab01	9d69c506-fc8c-4319-9b7b-2f0a150f8699	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:07:06
35615	9d69c506-fb07-42c2-b025-5800a8374813	9d69c506-fc8c-4319-9b7b-2f0a150f8699	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":36,"hostname":"EderCortes"}	2024-11-04 22:07:06
35616	9d69c506-fb64-489e-b847-510b5752ea19	9d69c506-fc8c-4319-9b7b-2f0a150f8699	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":573,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:07:06
33890	9d69b7c7-7f4a-4bc4-a2ec-3cfc2cad236d	9d69b7c7-a5a3-48df-8abe-b83ba2edca65	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:30:04
33891	9d69b7c7-9a29-4b2f-a863-3d6e0dbf299e	9d69b7c7-a5a3-48df-8abe-b83ba2edca65	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 82\\n                        ","time":"53.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"23238af5dc47e80ea555e80a08e2015d","hostname":"EderCortes"}	2024-11-04 21:30:04
33892	9d69b7c7-9e52-468a-9c38-db7e442d0001	9d69b7c7-a5a3-48df-8abe-b83ba2edca65	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '82' order by \\"item_loans\\".\\"id\\" asc","time":"3.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 21:30:04
33893	9d69b7c7-a350-40f7-9e54-8bbd423dd4b2	9d69b7c7-a5a3-48df-8abe-b83ba2edca65	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:30:04
33894	9d69b7c7-a3c9-46e5-8877-2c3523a0aed8	9d69b7c7-a5a3-48df-8abe-b83ba2edca65	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/82","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":82,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"240000","loans_pago_interes":"60000","user_alias":"eder.cortes"},"items":[{"id":316,"loans_codigo":82,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:36","updated_at":"2024-11-04 21:29:42","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":464,"loans_codigo":82,"itemloans_cuota":"2","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:29:42","updated_at":"2024-11-04 21:29:42","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":465,"loans_codigo":82,"itemloans_cuota":"3","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:29:42","updated_at":"2024-11-04 21:29:42","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":466,"loans_codigo":82,"itemloans_cuota":"4","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:29:42","updated_at":"2024-11-04 21:29:42","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":467,"loans_codigo":82,"itemloans_cuota":"5","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:29:42","updated_at":"2024-11-04 21:29:42","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":398,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:30:04
40772	9d6cc77c-8754-467f-bb9d-3c1bf028854a	9d6cc77c-d389-43ab-b8b8-fb320cf0cfe6	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:01:28
40773	9d6cc77c-d1a5-4e5e-9b13-75dcbfdbc1b2	9d6cc77c-d389-43ab-b8b8-fb320cf0cfe6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:01:28
40774	9d6cc77c-d262-4207-bc30-cbb6d14676c1	9d6cc77c-d389-43ab-b8b8-fb320cf0cfe6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":359,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:01:28
39843	9d6cb7d2-dea9-4bea-a9b3-02758e91f945	9d6cb7d2-e5c9-4f13-b95f-663b7a7e1bb8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1784}	2024-11-06 09:17:40
34329	9d69bde5-ce6d-4256-a38d-322f322f3b58	9d69bde5-f2ec-4954-b354-777233dfd361	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 21:47:10
34330	9d69bde5-f11c-4489-a670-ef89b9b71535	9d69bde5-f2ec-4954-b354-777233dfd361	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:47:10
34331	9d69bde5-f1d8-492c-a2b3-9272f165f469	9d69bde5-f2ec-4954-b354-777233dfd361	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":377,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:47:10
34332	9d69bde6-6cc3-420e-9bcf-71eb42b10f08	9d69bde6-8c85-45b2-b59f-69e08a35b421	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:47:11
34333	9d69bde6-863d-4dc0-ac1f-bf1cefc45f1f	9d69bde6-8c85-45b2-b59f-69e08a35b421	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":252,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:47:11
34334	9d69bde6-86a2-4e4b-8d4e-088d80846cae	9d69bde6-8c85-45b2-b59f-69e08a35b421	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:47:11
34335	9d69bde6-8b5f-4090-a55c-f5199ae9d0a6	9d69bde6-8c85-45b2-b59f-69e08a35b421	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:47:11
34336	9d69bde6-8ba5-4f83-bfb1-9077aa5b274d	9d69bde6-8c85-45b2-b59f-69e08a35b421	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":282,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:47:11
40104	9d6cc106-1aa7-4a57-b10c-d79d91ce3b72	9d6cc106-1e34-458d-bb4e-0f4d0d8d5a05	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1794}	2024-11-06 09:43:24
34337	9d69bde6-d36f-4046-a398-aca9a82cfe23	9d69bde6-f128-4a42-bffe-f8a19b9fc4ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:47:11
34338	9d69bde6-ec37-44fc-add5-a08b34856609	9d69bde6-f128-4a42-bffe-f8a19b9fc4ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":241,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 21:47:11
34339	9d69bde6-ec9e-4ebe-889b-63c5f00816e9	9d69bde6-f128-4a42-bffe-f8a19b9fc4ca	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 21:47:11
34340	9d69bde6-f014-4446-89d0-554c9f182ca5	9d69bde6-f128-4a42-bffe-f8a19b9fc4ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:47:11
34341	9d69bde6-f058-44bd-a142-2ebae445ac03	9d69bde6-f128-4a42-bffe-f8a19b9fc4ca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:47:11
34342	9d69bde7-39f0-4137-b2ce-a3a11d829886	9d69bde7-5c87-4219-b865-49572d88f892	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:47:11
34343	9d69bde7-5632-4abe-933b-a005c1ca55e6	9d69bde7-5c87-4219-b865-49572d88f892	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:47:11
34344	9d69bde7-5692-4d27-b62b-dffa8a44f8fa	9d69bde7-5c87-4219-b865-49572d88f892	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:47:11
34345	9d69bde7-5b28-4763-81e8-b94f018f36d1	9d69bde7-5c87-4219-b865-49572d88f892	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:47:11
34346	9d69bde7-5b93-4bd1-8fff-9faad7b341c5	9d69bde7-5c87-4219-b865-49572d88f892	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":256,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:47:11
34347	9d69bde7-aeb5-4a76-8f85-8731a165a3fa	9d69bde7-d30b-45b3-99bb-f9a84a42e09c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:47:12
34348	9d69bde7-cb61-4f09-b24f-d39cd18a2f6f	9d69bde7-d30b-45b3-99bb-f9a84a42e09c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_valor_prestado\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"loans_inicio_pago\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\" from \\"loans\\" where \\"id\\" = '93' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"47.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":228,"hash":"5c0f6d79d8f770dbd63d307421740e80","hostname":"EderCortes"}	2024-11-04 21:47:12
34349	9d69bde7-cbbf-4942-86ec-8139353be936	9d69bde7-d30b-45b3-99bb-f9a84a42e09c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 21:47:12
34350	9d69bde7-cd77-418e-ad46-0cb2895978c5	9d69bde7-d30b-45b3-99bb-f9a84a42e09c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"2.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":229,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 21:47:12
34351	9d69bde7-cdb8-48bd-806d-0b7856e1e61e	9d69bde7-d30b-45b3-99bb-f9a84a42e09c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 21:47:12
34352	9d69bde7-d1b8-42fa-8d50-54b710c0be6b	9d69bde7-d30b-45b3-99bb-f9a84a42e09c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:47:12
34353	9d69bde7-d213-4371-8cd2-52abe98b0b1c	9d69bde7-d30b-45b3-99bb-f9a84a42e09c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1000000","loans_pago_interes":"250000"},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:19:45.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:22:30.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":399,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":400,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":401,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":402,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"}]}},"duration":288,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:47:12
34354	9d69bdea-3056-4321-9006-74504a9e735f	9d69bdea-4d0e-4b4b-a5b6-ecd101cb6749	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:47:13
34355	9d69bdea-47d0-4839-88e7-ddb37d46b9cd	9d69bdea-4d0e-4b4b-a5b6-ecd101cb6749	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:47:13
34356	9d69bdea-481e-45c9-a8b2-7f9bbcda6a9e	9d69bdea-4d0e-4b4b-a5b6-ecd101cb6749	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:47:13
34357	9d69bdea-4bc8-4240-94e9-1dda4d97e233	9d69bdea-4d0e-4b4b-a5b6-ecd101cb6749	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:47:13
34358	9d69bdea-4c0f-4f15-bafb-1954cf26ea2c	9d69bdea-4d0e-4b4b-a5b6-ecd101cb6749	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":376,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:47:13
37331	9d6b482a-9421-4956-a727-7b0a31f27651	9d6b482a-dafd-41af-bdad-d20c6ab525a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 16:09:38
37332	9d6b482a-d90f-403c-976f-21c5d77ef924	9d6b482a-dafd-41af-bdad-d20c6ab525a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 16:09:38
37333	9d6b482a-d9ad-4897-8947-acef9ff0acbf	9d6b482a-dafd-41af-bdad-d20c6ab525a6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":358,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:09:38
37334	9d6b482b-35e8-4990-95d0-b6d8885ad0e8	9d6b482b-52ec-4ff3-85ae-2706dea57bf7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 16:09:38
37335	9d6b482b-4e65-49bf-9730-b820a0af3f86	9d6b482b-52ec-4ff3-85ae-2706dea57bf7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"44.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 16:09:38
37336	9d6b482b-5194-4f38-83c6-e03fe7a90215	9d6b482b-52ec-4ff3-85ae-2706dea57bf7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 16:09:38
37337	9d6b482b-51fe-422c-8502-7c76a3a0af8e	9d6b482b-52ec-4ff3-85ae-2706dea57bf7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:09:38
37338	9d6b482b-a4cf-452c-affa-c4b60f5c8e5b	9d6b482b-f2e0-4fc7-94d9-5d9ab03f3fbe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 16:09:38
37339	9d6b482b-ed63-40c8-961b-84faceca36c8	9d6b482b-f2e0-4fc7-94d9-5d9ab03f3fbe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"158.57","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:09:38
37340	9d6b482b-edaf-4397-8733-f4acbaab9c28	9d6b482b-f2e0-4fc7-94d9-5d9ab03f3fbe	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:09:38
37341	9d6b482b-f18f-460c-9e8b-0f41f69c803f	9d6b482b-f2e0-4fc7-94d9-5d9ab03f3fbe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 16:09:39
37342	9d6b482b-f1d2-4ce7-a5b0-6c7741bc3314	9d6b482b-f2e0-4fc7-94d9-5d9ab03f3fbe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":398,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:09:39
37343	9d6b482c-3cfa-4dfd-aeb9-7254f3ab944e	9d6b482c-5cf1-47d0-9416-3fa390f100a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 16:09:39
37344	9d6b482c-56e3-475c-b2b9-5eca3d1e24c2	9d6b482c-5cf1-47d0-9416-3fa390f100a1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:09:39
37345	9d6b482c-5731-49ae-b8af-b11fce06c9f7	9d6b482c-5cf1-47d0-9416-3fa390f100a1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:09:39
37346	9d6b482c-5b48-4b23-b89a-631c36c4e340	9d6b482c-5cf1-47d0-9416-3fa390f100a1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 16:09:39
37347	9d6b482c-5bc2-4685-98bc-e339c33c10e1	9d6b482c-5cf1-47d0-9416-3fa390f100a1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:09:39
37348	9d6b482e-1b78-4dd4-af12-c5163a5fcf0e	9d6b482e-3d64-47a9-85f7-96a28e0d69f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 16:09:40
37349	9d6b482e-373b-42d8-b396-df8656a936a9	9d6b482e-3d64-47a9-85f7-96a28e0d69f2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"46.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 16:09:40
37350	9d6b482e-37ab-4566-bb1d-608d910efda8	9d6b482e-3d64-47a9-85f7-96a28e0d69f2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 16:09:40
37351	9d6b482e-3bc8-490a-ad67-7f5afa93ea26	9d6b482e-3d64-47a9-85f7-96a28e0d69f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 16:09:40
37352	9d6b482e-3c21-40b7-a50c-2899f2e4fc99	9d6b482e-3d64-47a9-85f7-96a28e0d69f2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":542,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:09:40
40639	9d6cc62d-3856-435b-b638-8e1352859239	9d6cc62d-3b35-4c3f-8044-e99b2410b0e4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1836}	2024-11-06 09:57:48
40908	9d6cc8a3-9828-4dcd-886b-5ecc0bfbe2bc	9d6cc8a3-bdea-4691-adc7-bf624f75c7e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:04:41
29080	9d690e9a-2673-4f24-bb65-bebfd65aa3c6	9d690e9a-43ac-4b57-a11c-0ba64b1774e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 13:37:01
29081	9d690e9a-4217-419d-b284-1b057b1bb369	9d690e9a-43ac-4b57-a11c-0ba64b1774e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 13:37:01
29082	9d690e9a-42b1-4caf-8e35-4470bfccf953	9d690e9a-43ac-4b57-a11c-0ba64b1774e1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:37:01
40909	9d6cc8a3-bb89-4785-91ed-abb69fdb170e	9d6cc8a3-bdea-4691-adc7-bf624f75c7e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 10:04:42
40910	9d6cc8a3-bca8-44cd-8077-e42f163598b1	9d6cc8a3-bdea-4691-adc7-bf624f75c7e0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":346,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:04:42
29083	9d690e9a-9a2b-48da-9af5-d923092b22aa	9d690e9a-b816-48ca-a996-b1106c393e4c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 13:37:01
29084	9d690e9a-af31-4047-9d35-82dfdfce8c4f	9d690e9a-b816-48ca-a996-b1106c393e4c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"41.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 13:37:01
29085	9d690e9a-b2df-4e71-8b04-657ac7c5c11c	9d690e9a-b816-48ca-a996-b1106c393e4c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:37:01
29086	9d690e9a-b315-4afa-8013-f3fe4f01c79e	9d690e9a-b816-48ca-a996-b1106c393e4c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:37:01
29087	9d690e9a-b6da-4fc9-89e6-8ee408811cb9	9d690e9a-b816-48ca-a996-b1106c393e4c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 13:37:01
29088	9d690e9a-b730-4d97-b0b3-b7a0908463b9	9d690e9a-b816-48ca-a996-b1106c393e4c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:37:01
29451	9d692471-e5db-4d8d-9781-b5df2e3bf632	9d692471-ef93-4ca3-b077-81dbcb47a660	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"212.45","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:38:05
29452	9d692471-e664-498e-b866-7c251428eace	9d692471-ef93-4ca3-b077-81dbcb47a660	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:38:05
29453	9d692471-ed1e-4139-ae47-f136cf9ec9f2	9d692471-ef93-4ca3-b077-81dbcb47a660	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 14:38:05
34780	9d69bfc3-2aa0-4374-b108-c14d6c1f9ed8	9d69bfc3-4d55-447c-9a96-c59c8e4d5a2e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 21:52:23
34781	9d69bfc3-4b6b-4b7d-89b8-2a59ebfe6377	9d69bfc3-4d55-447c-9a96-c59c8e4d5a2e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:52:23
34782	9d69bfc3-4c31-420a-ad7a-016a4a8031de	9d69bfc3-4d55-447c-9a96-c59c8e4d5a2e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:52:23
31903	9d69572e-0c32-4e21-8238-c230847d5652	9d69572e-28c4-4223-904e-d214a3badda3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 16:59:57
31904	9d69572e-274c-4f05-8c71-c5107fd3c1bf	9d69572e-28c4-4223-904e-d214a3badda3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 16:59:57
31905	9d69572e-27e4-4573-a5cb-63c8f78cf7e9	9d69572e-28c4-4223-904e-d214a3badda3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":289,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:59:57
31906	9d69572e-b93d-4406-9ae7-e40962041929	9d69572e-c243-4d83-b3f9-3280e72c9b03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 16:59:58
31907	9d69572e-c099-4869-84d1-67b80f222c3e	9d69572e-c243-4d83-b3f9-3280e72c9b03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 16:59:58
31908	9d69572e-c10a-4a1f-a5d4-d3f64ffd9e57	9d69572e-c243-4d83-b3f9-3280e72c9b03	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":"kasbjfdsajdkjbsajk"},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:59:58
34783	9d69bfc3-b16b-4ade-9f54-3bd59f303040	9d69bfc3-f93c-49b8-a30a-7b8c7cad78c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:52:24
34784	9d69bfc3-f300-4c0c-b492-fea6261ae279	9d69bfc3-f93c-49b8-a30a-7b8c7cad78c2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"144.89","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:52:24
34785	9d69bfc3-f36a-4040-9247-1845dfd24b99	9d69bfc3-f93c-49b8-a30a-7b8c7cad78c2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:52:24
34786	9d69bfc3-f7e0-4e8e-a0ec-559744e51965	9d69bfc3-f93c-49b8-a30a-7b8c7cad78c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:52:24
34787	9d69bfc3-f82e-4a6d-bcce-229a78d36de2	9d69bfc3-f93c-49b8-a30a-7b8c7cad78c2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":381,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:52:24
31909	9d69572f-2659-472a-9aa6-67e8fc906cf0	9d69572f-31cd-4e6a-87f1-a17be673ab0b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 16:59:58
31910	9d69572f-306e-4e19-94cf-cfd4066bef3d	9d69572f-31cd-4e6a-87f1-a17be673ab0b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 16:59:58
31911	9d69572f-30d1-4423-acf1-a5949a512a91	9d69572f-31cd-4e6a-87f1-a17be673ab0b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":"kasbjfdsajdkjbsajk"},"duration":221,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:59:58
34788	9d69bfc4-405c-4412-9870-a665af8f85a6	9d69bfc4-8607-45e9-85f5-fc49e8931ccd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:52:24
34789	9d69bfc4-811a-42b0-8486-f2865fb2c9f7	9d69bfc4-8607-45e9-85f5-fc49e8931ccd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"144.22","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 21:52:24
34790	9d69bfc4-8169-418d-8b23-173379ee6772	9d69bfc4-8607-45e9-85f5-fc49e8931ccd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 21:52:24
34791	9d69bfc4-84e5-450c-be40-b0f7e39833d1	9d69bfc4-8607-45e9-85f5-fc49e8931ccd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:52:24
34792	9d69bfc4-8530-45ad-8854-6fbb1625bc01	9d69bfc4-8607-45e9-85f5-fc49e8931ccd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:52:24
31912	9d69572f-b34c-4980-a98b-282979e761b3	9d69572f-d128-4d31-bc81-b3e1f4579bf6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 16:59:58
31913	9d69572f-cbee-44bf-9905-2c7cd36c094b	9d69572f-d128-4d31-bc81-b3e1f4579bf6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:59:58
31914	9d69572f-cc3d-4946-b3c7-9ede933b1393	9d69572f-d128-4d31-bc81-b3e1f4579bf6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 16:59:58
31915	9d69572f-d00c-46d2-a76a-3ce180369e93	9d69572f-d128-4d31-bc81-b3e1f4579bf6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 16:59:58
31916	9d69572f-d053-4975-8d99-ea48e3fce277	9d69572f-d128-4d31-bc81-b3e1f4579bf6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":242,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:59:58
34793	9d69bfc4-ca56-4225-852b-c29baa5621e2	9d69bfc4-e92b-4601-9630-e427e2bb80e6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:52:24
34794	9d69bfc4-e419-4ae1-9686-0dbee3719581	9d69bfc4-e92b-4601-9630-e427e2bb80e6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:52:24
34795	9d69bfc4-e471-4170-ab60-98bbc8db7618	9d69bfc4-e92b-4601-9630-e427e2bb80e6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:52:24
34796	9d69bfc4-e803-4a7d-b6d1-05c1806e123d	9d69bfc4-e92b-4601-9630-e427e2bb80e6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:52:24
34797	9d69bfc4-e84b-4360-bf5f-84a717bcbfe1	9d69bfc4-e92b-4601-9630-e427e2bb80e6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:52:24
41089	9d6ccb45-0837-43d1-841d-3f15e24fc390	9d6ccb45-34ee-4254-a5db-e8b6e2be9670	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:12:03
41090	9d6ccb45-3230-4214-ae0e-0429d2e13f52	9d6ccb45-34ee-4254-a5db-e8b6e2be9670	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:12:03
41091	9d6ccb45-33b6-43bc-996f-eec778e0a8e9	9d6ccb45-34ee-4254-a5db-e8b6e2be9670	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:12:03
10477	9d56f8d7-1f53-4eaa-91a7-9f59e556afa4	9d56f8d7-2904-454a-8189-595461e574ec	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":519}	2024-10-26 13:51:15
37809	9d6b5c3e-7a1f-4bc8-aa4a-2e1cded842fe	9d6b5c3e-bfd4-4209-8a09-63e0ab9cb573	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:05:46
37810	9d6b5c3e-be3a-4390-8156-47bb5fab6769	9d6b5c3e-bfd4-4209-8a09-63e0ab9cb573	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:05:46
37811	9d6b5c3e-bed0-4234-bd15-a5325a5c83a9	9d6b5c3e-bfd4-4209-8a09-63e0ab9cb573	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:05:46
37812	9d6b5c3f-1822-4b0c-a371-b7c24d40f0a3	9d6b5c3f-34ce-462a-8448-44cd94bededd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:05:47
37813	9d6b5c3f-3015-47e9-8c0c-06e48a4d4471	9d6b5c3f-34ce-462a-8448-44cd94bededd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"43.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:05:47
37814	9d6b5c3f-3352-48e4-bebd-6a0f779e2ef6	9d6b5c3f-34ce-462a-8448-44cd94bededd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:05:47
37815	9d6b5c3f-33c0-45d6-9dad-da6e01f277b5	9d6b5c3f-34ce-462a-8448-44cd94bededd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:05:47
37816	9d6b5c3f-81ed-4338-be6e-8c5d9a818bcf	9d6b5c3f-a4c5-4640-bd13-fd10bfb994e9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:05:47
37817	9d6b5c3f-9f58-4dec-bf85-9b0b70391eeb	9d6b5c3f-a4c5-4640-bd13-fd10bfb994e9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:05:47
37818	9d6b5c3f-9fcc-446d-8a6e-72bd68e33912	9d6b5c3f-a4c5-4640-bd13-fd10bfb994e9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:05:47
37819	9d6b5c3f-a372-4d27-993a-9624c2025c38	9d6b5c3f-a4c5-4640-bd13-fd10bfb994e9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:05:47
37820	9d6b5c3f-a3c2-4572-89cd-66df953f0362	9d6b5c3f-a4c5-4640-bd13-fd10bfb994e9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":277,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:05:47
37821	9d6b5c3f-e6ba-46ee-b041-6406e8791c69	9d6b5c40-05fa-47fa-8126-bafee06f410a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:05:47
37822	9d6b5c40-0008-4a65-a13f-a804a17840e2	9d6b5c40-05fa-47fa-8126-bafee06f410a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:05:47
37823	9d6b5c40-0066-4240-bf25-bbd7ba099b28	9d6b5c40-05fa-47fa-8126-bafee06f410a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:05:47
37824	9d6b5c40-0499-4c1b-8ce3-9fa40cfdeded	9d6b5c40-05fa-47fa-8126-bafee06f410a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 17:05:47
37825	9d6b5c40-04e9-42fe-80e8-3a0f8e2402a3	9d6b5c40-05fa-47fa-8126-bafee06f410a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:05:47
37826	9d6b5c41-9ae4-4821-9a31-6644d2145f2e	9d6b5c41-d32e-4d00-a36c-2f439637c2b7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 17:05:48
37827	9d6b5c41-ccd8-492b-904b-6064cf530b19	9d6b5c41-d32e-4d00-a36c-2f439637c2b7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"67.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:05:48
37828	9d6b5c41-cd47-42df-9478-d4a9745b5142	9d6b5c41-d32e-4d00-a36c-2f439637c2b7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:05:48
37829	9d6b5c41-d1dd-433b-84d1-9ad3680b35ab	9d6b5c41-d32e-4d00-a36c-2f439637c2b7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 17:05:48
37830	9d6b5c41-d22b-45ef-b77a-14322fd7cc9e	9d6b5c41-d32e-4d00-a36c-2f439637c2b7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":530,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:05:48
40295	9d6cc275-dec3-4856-aab1-50b0b965082e	9d6cc275-e4d7-432a-b824-46b674335fd1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1800}	2024-11-06 09:47:25
37831	9d6b5c9b-5244-4b21-a7b7-3be9522bf00a	9d6b5c9b-55d3-4e27-b981-96182c286886	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":152,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:06:47
41805	9d6ccfbc-f421-4d8f-b2ba-63837aa7b18a	9d6ccfbc-f7a6-4d88-99b5-b8227bd283e7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1932}	2024-11-06 10:24:32
37832	9d6b5c9b-d4ed-4369-93d8-ada710c15f2c	9d6b5c9c-18ee-4ca2-b561-41e79706a516	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 17:06:47
37833	9d6b5c9b-fd4c-45ca-a579-02418728397e	9d6b5c9c-18ee-4ca2-b561-41e79706a516	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"41.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-05 17:06:47
37834	9d6b5c9b-fda8-4527-875f-4f4bb2d9abd7	9d6b5c9c-18ee-4ca2-b561-41e79706a516	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:06:47
37835	9d6b5c9c-174f-4470-94a9-96d940b9dbfa	9d6b5c9c-18ee-4ca2-b561-41e79706a516	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:06:47
37836	9d6b5c9c-17c4-4557-8113-2a62f034f79b	9d6b5c9c-18ee-4ca2-b561-41e79706a516	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","profile":1},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":335,"memory":24,"hostname":"EderCortes"}	2024-11-05 17:06:47
37837	9d6b5c9c-8c96-41ca-a743-78dc263b7133	9d6b5c9c-d85e-4a97-a4a3-b036fa5b60e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:06:48
37838	9d6b5c9c-d2d6-4985-bd1a-0571156fa098	9d6b5c9c-d85e-4a97-a4a3-b036fa5b60e7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"156.13","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:06:48
37839	9d6b5c9c-d337-4e9a-9067-0455022a3933	9d6b5c9c-d85e-4a97-a4a3-b036fa5b60e7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:06:48
37840	9d6b5c9c-d6e9-447d-a49e-73bdc0218bdd	9d6b5c9c-d85e-4a97-a4a3-b036fa5b60e7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:06:48
37841	9d6b5c9c-d72e-46ba-abba-15e32a8f726d	9d6b5c9c-d85e-4a97-a4a3-b036fa5b60e7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":433,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:06:48
41737	9d6ccf00-cfc6-48eb-98cd-6f906673ad39	9d6ccf00-d2a6-4348-82da-cc2a95b25c90	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1924}	2024-11-06 10:22:29
37842	9d6b5ca4-599d-40aa-aaa6-bd6853aa483e	9d6b5ca4-7757-437a-88d2-a44df864ff9e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:06:53
37843	9d6b5ca4-71b9-48ea-a3db-3447ce599df2	9d6b5ca4-7757-437a-88d2-a44df864ff9e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:06:53
37844	9d6b5ca4-7205-43bd-83a3-b10f0b46e710	9d6b5ca4-7757-437a-88d2-a44df864ff9e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:06:53
37845	9d6b5ca4-7605-4ef3-83a5-6108aaf5f6f0	9d6b5ca4-7757-437a-88d2-a44df864ff9e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:06:53
37846	9d6b5ca4-765c-4305-8ac5-4482241898d2	9d6b5ca4-7757-437a-88d2-a44df864ff9e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:06:53
41222	9d6ccbdd-9651-4392-9345-b19388d4a31c	9d6ccbdd-9951-47df-97c9-f3e847cc5afa	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1888}	2024-11-06 10:13:43
37847	9d6b5cb6-25ab-40d1-b62c-4467cf433d81	9d6b5cb6-6aa3-41a4-a2ae-4c04e0381aba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:07:05
37848	9d6b5cb6-65ad-4250-88eb-dfc0cd711833	9d6b5cb6-6aa3-41a4-a2ae-4c04e0381aba	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"149.62","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":26,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-05 17:07:05
37849	9d6b5cb6-6923-4de0-b6e5-e38073656ba8	9d6b5cb6-6aa3-41a4-a2ae-4c04e0381aba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:07:05
37850	9d6b5cb6-698a-4f60-8174-08b922cb9ebc	9d6b5cb6-6aa3-41a4-a2ae-4c04e0381aba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":420,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:07:05
37851	9d6b5cc5-30fc-41c7-8e8d-1e4969ee5607	9d6b5cc5-4dfe-45c6-8450-d6e568de3f55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:07:14
37852	9d6b5cc5-4930-4698-aac6-c022071782cd	9d6b5cc5-4dfe-45c6-8450-d6e568de3f55	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"42.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:07:14
37853	9d6b5cc5-4c87-4dad-ad32-0b916cc90d98	9d6b5cc5-4dfe-45c6-8450-d6e568de3f55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:07:14
37854	9d6b5cc5-4cf4-4917-be75-a08a90d2cb9b	9d6b5cc5-4dfe-45c6-8450-d6e568de3f55	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:07:14
30509	9d693fb3-e35f-497c-9d76-dd4f2a40094d	9d693fb4-1cd0-4456-b29d-8ff7548c36d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 15:54:18
30510	9d693fb4-1a05-4d6c-89be-ee077f4517c5	9d693fb4-1cd0-4456-b29d-8ff7548c36d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 15:54:18
30511	9d693fb4-1b55-41c5-90cf-3701bab7a670	9d693fb4-1cd0-4456-b29d-8ff7548c36d7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":411,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:54:18
30512	9d693fb4-ba2e-4138-b1e9-a72d6e06abac	9d693fb4-eb5c-4618-b733-94d1a26625ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 15:54:19
30513	9d693fb4-e1ab-4bf6-a0ef-4d4e17348464	9d693fb4-eb5c-4618-b733-94d1a26625ef	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"62.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":58,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 15:54:19
30514	9d693fb4-e22f-474d-bb2c-13ec8b9e6b85	9d693fb4-eb5c-4618-b733-94d1a26625ef	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 15:54:19
30515	9d693fb4-e93a-43dc-8c84-7ccf6f6d34d6	9d693fb4-eb5c-4618-b733-94d1a26625ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 15:54:19
30516	9d693fb4-e9bb-46dc-a619-fc56d6026893	9d693fb4-eb5c-4618-b733-94d1a26625ef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:47:38.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":433,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:54:19
37855	9d6b5cc5-99d5-432e-a210-7cef381da634	9d6b5cc5-df61-46ec-9067-4912ffc7081f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:07:15
37856	9d6b5cc5-d9e3-4657-9fa6-b4a7718ecf77	9d6b5cc5-df61-46ec-9067-4912ffc7081f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"142.06","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:07:15
37857	9d6b5cc5-da49-41fb-9f95-6e76bec1a3ff	9d6b5cc5-df61-46ec-9067-4912ffc7081f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:07:15
37858	9d6b5cc5-ddec-4d21-bb66-6990df2c94bb	9d6b5cc5-df61-46ec-9067-4912ffc7081f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:07:15
37859	9d6b5cc5-de30-403c-b9bf-523428f6dda9	9d6b5cc5-df61-46ec-9067-4912ffc7081f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":359,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:07:15
30517	9d693fb6-c8b3-4306-84bb-187e261adcdc	9d693fb7-100c-4d06-b623-93d5c367ed2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 15:54:20
30518	9d693fb7-03bc-4cfd-b6eb-c0ac392f1bec	9d693fb7-100c-4d06-b623-93d5c367ed2b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"89.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:54:20
30519	9d693fb7-045b-461e-a664-1d84a13ffcda	9d693fb7-100c-4d06-b623-93d5c367ed2b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:54:20
30520	9d693fb7-0d5b-4b1c-ae4e-8a6382c22d9d	9d693fb7-100c-4d06-b623-93d5c367ed2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 15:54:20
30521	9d693fb7-0e06-4812-bf89-2825bda16021	9d693fb7-100c-4d06-b623-93d5c367ed2b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1380,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:54:20
37860	9d6b5cc6-2c95-4ff0-8c38-082528467a79	9d6b5cc6-4c6d-4679-a7de-28d24f13ff8d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:07:15
37861	9d6b5cc6-4642-4749-87c1-3c4875f44634	9d6b5cc6-4c6d-4679-a7de-28d24f13ff8d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:07:15
30562	9d693ff4-19cf-45fb-8485-332bb4e865cc	9d693ff4-1d34-493d-9c03-6e5896aa6e98	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/updateUser","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":167,"memory":20,"hostname":"EderCortes"}	2024-11-04 15:55:00
37862	9d6b5cc6-46a5-4387-acb1-fd741e43a8bc	9d6b5cc6-4c6d-4679-a7de-28d24f13ff8d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:07:15
37863	9d6b5cc6-4af4-4a1f-954f-c149d5f9f345	9d6b5cc6-4c6d-4679-a7de-28d24f13ff8d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 17:07:15
37864	9d6b5cc6-4b58-4e97-9e4c-b2bc2736c296	9d6b5cc6-4c6d-4679-a7de-28d24f13ff8d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":256,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:07:15
30522	9d693fb7-9bdb-4e55-8e9f-a09732fdda36	9d693fb7-cb30-41cb-b4e3-41fbba3be125	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 15:54:21
30523	9d693fb7-c3c5-414f-9299-81843f82b60d	9d693fb7-cb30-41cb-b4e3-41fbba3be125	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"61.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:54:21
30524	9d693fb7-c446-43fd-b5c4-4d49ce8246cb	9d693fb7-cb30-41cb-b4e3-41fbba3be125	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:54:21
30525	9d693fb7-c99c-4c81-a0ba-4c410b65087b	9d693fb7-cb30-41cb-b4e3-41fbba3be125	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 15:54:21
30526	9d693fb7-ca06-4c34-af7c-bf1d35fead65	9d693fb7-cb30-41cb-b4e3-41fbba3be125	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":455,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:54:21
30563	9d693ff4-d1f2-48bf-9365-b7aff2376b9c	9d693ff4-fb6d-48b1-802f-7ba7c83819bd	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 15:55:01
30564	9d693ff4-f10b-4338-9df0-953ec124b748	9d693ff4-fb6d-48b1-802f-7ba7c83819bd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = 12 and \\"users\\".\\"deleted_at\\" is null limit 1","time":"3.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":89,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 15:55:01
30565	9d693ff4-f182-4ae0-9569-f577ce91dba0	9d693ff4-fb6d-48b1-802f-7ba7c83819bd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 15:55:01
30566	9d693ff4-f2d9-402c-8043-df1be7d3caad	9d693ff4-fb6d-48b1-802f-7ba7c83819bd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"users\\" set \\"user_alias\\" = 'eder.cortes', \\"updated_at\\" = '2024-11-04 15:55:01' where \\"id\\" = 12","time":"0.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":91,"hash":"5cf4ffe9dedd89f0d3fe2ed15d892a7a","hostname":"EderCortes"}	2024-11-04 15:55:01
30567	9d693ff4-f33c-49ca-a0b1-2adf5016c9cd	9d693ff4-fb6d-48b1-802f-7ba7c83819bd	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\User:12","changes":{"updated_at":"2024-11-04 15:55:01","user_alias":"eder.cortes"},"hostname":"EderCortes"}	2024-11-04 15:55:01
3261	9d510457-f0df-47d4-8054-5212886a3414	9d510457-f80d-4736-9198-7278365bbc0c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":183}	2024-10-23 14:48:27
30568	9d693ff4-f9df-4ef4-ad42-ff84259a557d	9d693ff4-fb6d-48b1-802f-7ba7c83819bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:55:01
35150	9d69c2df-93df-4771-ad43-8b4414f18432	9d69c2df-d360-428d-8fb2-3b560dbe15fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 22:01:05
35151	9d69c2df-d05a-438e-a2ce-a0f3d8d30738	9d69c2df-d360-428d-8fb2-3b560dbe15fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 22:01:05
35152	9d69c2df-d1d3-420d-928e-749e02b965c4	9d69c2df-d360-428d-8fb2-3b560dbe15fc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":379,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:01:05
35153	9d69c2e1-1f94-40a3-861a-fd374779da47	9d69c2e1-a729-4845-836c-cdff054901ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 22:01:06
35154	9d69c2e1-9c56-4763-8ab6-01b8fa6dad8a	9d69c2e1-a729-4845-836c-cdff054901ec	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"147.88","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:01:06
35155	9d69c2e1-9cf1-434d-af7f-5f93b92191ac	9d69c2e1-a729-4845-836c-cdff054901ec	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:01:06
35156	9d69c2e1-a4ed-47ae-8ccf-1381300873e9	9d69c2e1-a729-4845-836c-cdff054901ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 22:01:06
35157	9d69c2e1-a57e-4556-983a-62ca9833b134	9d69c2e1-a729-4845-836c-cdff054901ec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":1010,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:01:06
35158	9d69c2e2-1772-4cad-aaa0-29659807b47a	9d69c2e2-3ded-40f0-826a-0cdce0698f0b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 22:01:07
35159	9d69c2e2-3806-4934-8c1c-5611489a32f0	9d69c2e2-3ded-40f0-826a-0cdce0698f0b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"53.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 22:01:07
35160	9d69c2e2-3884-42ef-b15e-ee4044fe55bf	9d69c2e2-3ded-40f0-826a-0cdce0698f0b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 22:01:07
35161	9d69c2e2-3c6b-4e29-9ad7-6698ceabb384	9d69c2e2-3ded-40f0-826a-0cdce0698f0b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 22:01:07
35162	9d69c2e2-3cd8-4a88-9cc3-a013b7482f13	9d69c2e2-3ded-40f0-826a-0cdce0698f0b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:01:07
35163	9d69c2e2-8f98-4624-8abd-2c013f78019c	9d69c2e2-b92d-45b4-8819-e78c3a249553	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 22:01:07
35164	9d69c2e2-b2a9-4a5e-929e-58b419e7790f	9d69c2e2-b92d-45b4-8819-e78c3a249553	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"66.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:01:07
35165	9d69c2e2-b30e-4dc1-8c79-d15ac0ed40b2	9d69c2e2-b92d-45b4-8819-e78c3a249553	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:01:07
35166	9d69c2e2-b7bc-4c14-9fae-74c59f69195d	9d69c2e2-b92d-45b4-8819-e78c3a249553	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 22:01:07
35167	9d69c2e2-b81c-4385-8837-628a17de0393	9d69c2e2-b92d-45b4-8819-e78c3a249553	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":302,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:01:07
38046	9d6b5f0c-828a-4917-9173-2fa5b2ac52f3	9d6b5f0c-ab5b-4dff-bd80-25f05b2da9a5	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 17:13:37
38047	9d6b5f0c-a893-4442-a3c7-db67f26fb35f	9d6b5f0c-ab5b-4dff-bd80-25f05b2da9a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:13:37
29288	9d69141c-709b-42e1-84b8-b804949ea64e	9d69141c-b84d-41e8-9459-b16f9548cbbf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 13:52:25
29289	9d69141c-b6c4-46f0-b22b-b2789587ce24	9d69141c-b84d-41e8-9459-b16f9548cbbf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 13:52:25
29290	9d69141c-b75a-42ca-b52f-27c6358f3a4e	9d69141c-b84d-41e8-9459-b16f9548cbbf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":367,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:52:25
38048	9d6b5f0c-a9a1-4bf8-b73b-c00244cfc2f6	9d6b5f0c-ab5b-4dff-bd80-25f05b2da9a5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:13:37
29291	9d69141d-10dc-42d9-9de1-726bd66d8db4	9d69141d-2fc4-4f2c-a44d-91b7b99bd659	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 13:52:25
29292	9d69141d-2620-401c-a360-e8ef0efdb5f4	9d69141d-2fc4-4f2c-a44d-91b7b99bd659	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"41.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 13:52:25
29293	9d69141d-2a66-4c9d-a4ba-443f08f2272d	9d69141d-2fc4-4f2c-a44d-91b7b99bd659	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:52:25
29294	9d69141d-2aa5-4ec3-b3b3-18165793be56	9d69141d-2fc4-4f2c-a44d-91b7b99bd659	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:52:25
29295	9d69141d-2ea4-42e6-bd61-3d007da6ce29	9d69141d-2fc4-4f2c-a44d-91b7b99bd659	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 13:52:25
29296	9d69141d-2ef3-4e32-bf23-b27a295aecdc	9d69141d-2fc4-4f2c-a44d-91b7b99bd659	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:52:25
38049	9d6b5f0d-38ad-440d-bb68-c7f9935e7548	9d6b5f0d-8030-4a01-a6a0-151e64ea5a77	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:13:37
29454	9d692471-edcd-4a2d-a536-1110cb111991	9d692471-ef93-4ca3-b077-81dbcb47a660	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1205,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:38:05
38050	9d6b5f0d-7ada-4a27-a613-c797ca86feed	9d6b5f0d-8030-4a01-a6a0-151e64ea5a77	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"146.58","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:13:37
38051	9d6b5f0d-7ea9-44e9-960e-d075e00c1060	9d6b5f0d-8030-4a01-a6a0-151e64ea5a77	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:13:37
38052	9d6b5f0d-7f33-441d-9370-8239c3c32e72	9d6b5f0d-8030-4a01-a6a0-151e64ea5a77	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":407,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:13:37
29455	9d692472-81d8-43d8-9ace-5215ba414cb9	9d692472-beba-4d61-a0a5-9740cdab3ae0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 14:38:06
29456	9d692472-a9e0-46dc-95dc-900214a3bfb8	9d692472-beba-4d61-a0a5-9740cdab3ae0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"68.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:38:06
29457	9d692472-aa8f-4d5e-a69a-33875eb7aed8	9d692472-beba-4d61-a0a5-9740cdab3ae0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:38:06
29458	9d692472-bc33-4d79-8e84-f49e7a54374c	9d692472-beba-4d61-a0a5-9740cdab3ae0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 14:38:06
29459	9d692472-bcdd-4590-a50c-2c7a6e8440dc	9d692472-beba-4d61-a0a5-9740cdab3ae0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":500,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:38:06
38053	9d6b5f0d-d94b-4141-82c0-b36eaefbd017	9d6b5f0d-fb69-48c4-bcf5-66146798f448	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:13:38
38054	9d6b5f0d-f5c7-4358-b7bb-15c6d659d78d	9d6b5f0d-fb69-48c4-bcf5-66146798f448	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:13:38
38055	9d6b5f0d-f62c-4260-9bb4-805f98afa866	9d6b5f0d-fb69-48c4-bcf5-66146798f448	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:13:38
38056	9d6b5f0d-fa56-42f1-8b4b-105ad56ef31a	9d6b5f0d-fb69-48c4-bcf5-66146798f448	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:13:38
38057	9d6b5f0d-fa9c-4761-900b-5f682c057842	9d6b5f0d-fb69-48c4-bcf5-66146798f448	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":296,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:13:38
38058	9d6b5f0e-449b-4abd-88bc-28218c9b65fc	9d6b5f0e-6389-42c2-b062-deacff98d29e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:13:38
38059	9d6b5f0e-5e52-48e8-9221-dc82b2f84f2e	9d6b5f0e-6389-42c2-b062-deacff98d29e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:13:38
38060	9d6b5f0e-5eba-47ec-be52-4b7c285ad344	9d6b5f0e-6389-42c2-b062-deacff98d29e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:13:38
38061	9d6b5f0e-6230-4bf1-9563-421254beea14	9d6b5f0e-6389-42c2-b062-deacff98d29e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:13:38
38062	9d6b5f0e-6284-4778-84bb-54c72403ec48	9d6b5f0e-6389-42c2-b062-deacff98d29e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:13:38
38220	9d6b6052-1e08-4033-b57a-31bb4bd7b44a	9d6b6052-46d4-4699-84c2-d3a72b96f173	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 17:17:10
38221	9d6b6052-44a7-43cd-bbcb-8fbba541ff44	9d6b6052-46d4-4699-84c2-d3a72b96f173	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:17:10
38222	9d6b6052-45a4-4788-87f6-2262cb1b22aa	9d6b6052-46d4-4699-84c2-d3a72b96f173	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":293,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:17:10
38223	9d6b6052-b5cf-4f6c-9263-1a43e501d218	9d6b6052-d487-4468-b361-cbc0721da658	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:17:10
38224	9d6b6052-cefb-48b8-9b6a-b49bcef166f8	9d6b6052-d487-4468-b361-cbc0721da658	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"44.94","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:17:11
38225	9d6b6052-d2f6-4899-9818-1de470baa665	9d6b6052-d487-4468-b361-cbc0721da658	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:17:11
38226	9d6b6052-d36d-4f88-a0a8-3eaa9a148886	9d6b6052-d487-4468-b361-cbc0721da658	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":294,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:17:11
38227	9d6b6053-2352-463a-993b-073f65c10020	9d6b6053-7299-4106-b12c-e97f65c6e40e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:17:11
38228	9d6b6053-6ce9-4822-a1a5-a1c8c900155e	9d6b6053-7299-4106-b12c-e97f65c6e40e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"158.18","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:17:11
38229	9d6b6053-6d38-4ffd-8318-aa16bd8ad44b	9d6b6053-7299-4106-b12c-e97f65c6e40e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:17:11
38230	9d6b6053-7122-4038-be3e-4cd78940bbd9	9d6b6053-7299-4106-b12c-e97f65c6e40e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:17:11
38231	9d6b6053-7165-463c-9e53-7b2e52dab87a	9d6b6053-7299-4106-b12c-e97f65c6e40e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":388,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:17:11
38232	9d6b6053-bd02-4e97-970d-b48d661932f2	9d6b6054-04e6-4c44-ac99-9c32f0c3c2a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:17:11
38233	9d6b6053-ff9a-4915-8db4-f85f6045372f	9d6b6054-04e6-4c44-ac99-9c32f0c3c2a7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"144.50","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:17:11
38234	9d6b6054-0001-4094-863e-0eeed223302d	9d6b6054-04e6-4c44-ac99-9c32f0c3c2a7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:17:11
38235	9d6b6054-035f-405f-b173-a8cf4f69c692	9d6b6054-04e6-4c44-ac99-9c32f0c3c2a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:17:11
38236	9d6b6054-03ce-4c39-8190-d34dc15cd077	9d6b6054-04e6-4c44-ac99-9c32f0c3c2a7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":359,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:17:11
38237	9d6b6055-bb1e-4bab-b700-cae50039d531	9d6b6056-17ed-48c4-9b78-86d828ff70e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:17:12
38238	9d6b6056-129e-45a6-a8cb-9cce110f244c	9d6b6056-17ed-48c4-9b78-86d828ff70e8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"153.10","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:17:13
38239	9d6b6056-130f-4f7a-a7cc-7bbeb664ffc2	9d6b6056-17ed-48c4-9b78-86d828ff70e8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:17:13
38240	9d6b6056-16ac-477e-97b7-78c975325ca3	9d6b6056-17ed-48c4-9b78-86d828ff70e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:17:13
38241	9d6b6056-1708-43d6-9df9-393bf37e7267	9d6b6056-17ed-48c4-9b78-86d828ff70e8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":661,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:17:13
35492	9d69c4e0-8227-41fb-a1c1-f3b60683d377	9d69c4e0-a246-405a-9e46-cc7af5e74ae4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 22:06:41
35493	9d69c4e0-a08a-4237-9ad0-89050b62ddd0	9d69c4e0-a246-405a-9e46-cc7af5e74ae4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 22:06:41
35494	9d69c4e0-a130-4797-a15a-365ecbd8635d	9d69c4e0-a246-405a-9e46-cc7af5e74ae4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":274,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:06:41
35495	9d69c4e0-fb50-48c4-b896-5dfd5887cd05	9d69c4e1-1ae0-48de-94af-964ec1c7180a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 22:06:42
35496	9d69c4e1-14dd-4061-9913-ab88d1bf5c87	9d69c4e1-1ae0-48de-94af-964ec1c7180a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:06:42
35497	9d69c4e1-1535-42b4-a899-7739f898e486	9d69c4e1-1ae0-48de-94af-964ec1c7180a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:06:42
35498	9d69c4e1-19a2-477f-aba8-58c3a143e6f8	9d69c4e1-1ae0-48de-94af-964ec1c7180a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 22:06:42
35499	9d69c4e1-1a00-44b0-850f-9b9b671f700f	9d69c4e1-1ae0-48de-94af-964ec1c7180a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":248,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:06:42
35500	9d69c4e1-5ca9-4bce-b083-709fcce71940	9d69c4e1-7a32-4cba-ad46-e10dedc2587f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 22:06:42
35501	9d69c4e1-7531-4c58-bf3b-6aa522c0bf26	9d69c4e1-7a32-4cba-ad46-e10dedc2587f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 22:06:42
35502	9d69c4e1-7584-4dd6-8e08-d7436704436d	9d69c4e1-7a32-4cba-ad46-e10dedc2587f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 22:06:42
35503	9d69c4e1-790a-4fbb-870d-60ecd6b3ebaa	9d69c4e1-7a32-4cba-ad46-e10dedc2587f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 22:06:42
35504	9d69c4e1-795a-4e94-9acb-187880efe3d3	9d69c4e1-7a32-4cba-ad46-e10dedc2587f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:06:42
35505	9d69c4e1-cc55-4652-9e46-a1e89322ae1c	9d69c4e2-1444-4439-8a1f-3bb27db46416	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 22:06:42
35506	9d69c4e2-0e2d-4c68-a6e5-864a3a08ae72	9d69c4e2-1444-4439-8a1f-3bb27db46416	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"142.61","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:06:42
35507	9d69c4e2-0e7d-486e-b461-57ef97372205	9d69c4e2-1444-4439-8a1f-3bb27db46416	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:06:42
35508	9d69c4e2-1310-4e36-a603-54b8ae48602d	9d69c4e2-1444-4439-8a1f-3bb27db46416	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 22:06:42
35509	9d69c4e2-135d-482f-8935-ea56139d48f1	9d69c4e2-1444-4439-8a1f-3bb27db46416	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":375,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:06:42
38596	9d6b672c-b94c-490a-990b-f5468b9e73c0	9d6b672c-d8b4-432c-95ae-e0749eab03d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:36:20
38597	9d6b672c-d710-49b9-9d15-979419b2b62c	9d6b672c-d8b4-432c-95ae-e0749eab03d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 17:36:20
38598	9d6b672c-d7b3-4cca-a4d5-3606b125a171	9d6b672c-d8b4-432c-95ae-e0749eab03d3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":261,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:36:20
38599	9d6b672d-30c6-4393-939d-01a218a0a68c	9d6b672d-4c36-406b-97e5-e1b2701fd441	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 17:36:20
38600	9d6b672d-47bf-4d3c-8947-ed2989ed1e69	9d6b672d-4c36-406b-97e5-e1b2701fd441	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"42.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":125,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:36:20
38601	9d6b672d-4add-4754-a0d0-b6dee9f4facb	9d6b672d-4c36-406b-97e5-e1b2701fd441	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 17:36:20
38602	9d6b672d-4b41-4bd8-905d-cd72a4c3bea7	9d6b672d-4c36-406b-97e5-e1b2701fd441	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":227,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:36:20
38603	9d6b672d-9412-4a2b-9b69-2ae5fd9a0cc2	9d6b672d-e2db-4366-b802-88d9ec55694a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 17:36:21
38604	9d6b672d-dce5-477b-b164-af9f10b72e88	9d6b672d-e2db-4366-b802-88d9ec55694a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"150.02","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:36:21
38605	9d6b672d-dd57-4b49-8988-988c62accb78	9d6b672d-e2db-4366-b802-88d9ec55694a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:36:21
38606	9d6b672d-e1a6-4bc6-aaeb-44b8de929795	9d6b672d-e2db-4366-b802-88d9ec55694a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:36:21
38607	9d6b672d-e1f3-4fa5-93fd-287de19345d2	9d6b672d-e2db-4366-b802-88d9ec55694a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":377,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:36:21
38608	9d6b672e-39c2-4fd8-9d10-5be250461d3b	9d6b672e-5a76-4943-863d-7ec60b22d3d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:36:21
38609	9d6b672e-5455-47e9-9066-147a19398ea9	9d6b672e-5a76-4943-863d-7ec60b22d3d5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:36:21
38610	9d6b672e-54a7-4679-b4fd-c0994d1098a3	9d6b672e-5a76-4943-863d-7ec60b22d3d5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:36:21
38611	9d6b672e-58d4-4b20-9a17-a9d32162bcad	9d6b672e-5a76-4943-863d-7ec60b22d3d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:36:21
38612	9d6b672e-591e-418c-9b7d-c58c45ecd51c	9d6b672e-5a76-4943-863d-7ec60b22d3d5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":288,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:36:21
38613	9d6b6730-5810-4d71-ae53-cc3ad4183d5f	9d6b6730-8414-442a-af08-156b730fab96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:36:22
38614	9d6b6730-7bdf-4aa3-9c85-a02cef132966	9d6b6730-8414-442a-af08-156b730fab96	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"61.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:36:22
38615	9d6b6730-7c50-4b60-9774-673a06f8531b	9d6b6730-8414-442a-af08-156b730fab96	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:36:22
38616	9d6b6730-818e-42a6-85c3-9b092f9b2bb8	9d6b6730-8414-442a-af08-156b730fab96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:36:22
38617	9d6b6730-8204-41f9-960f-7900d726de44	9d6b6730-8414-442a-af08-156b730fab96	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":431,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:36:22
41476	9d6ccce5-06d1-4683-9b25-4f976035d2a0	9d6ccce5-0a36-4677-a8dc-5ad9cd396758	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1902}	2024-11-06 10:16:35
38618	9d6b6730-da1f-4617-b373-8e14d9786684	9d6b6731-2434-4802-b16c-9d92a25ba033	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:36:23
38619	9d6b6731-1fb7-4b39-ac66-944d7263ae4e	9d6b6731-2434-4802-b16c-9d92a25ba033	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"155.83","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":125,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:36:23
38620	9d6b6731-22be-419b-bf54-b5f0b7716f52	9d6b6731-2434-4802-b16c-9d92a25ba033	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:36:23
38621	9d6b6731-2329-4844-9afd-8e3900e93a8e	9d6b6731-2434-4802-b16c-9d92a25ba033	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"0","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":383,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:36:23
38740	9d6b6cde-7518-4426-b724-ef294f4943fb	9d6b6cde-acb6-4d83-93f1-fa8fdcc85f82	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 17:52:15
38741	9d6b6cde-aa33-4a5b-a08f-b145b884365c	9d6b6cde-acb6-4d83-93f1-fa8fdcc85f82	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:52:15
38742	9d6b6cde-ab6a-4bdb-86d5-680c78095bd6	9d6b6cde-acb6-4d83-93f1-fa8fdcc85f82	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":469,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:52:15
38743	9d6b6cdf-3d28-417c-bd97-c0f386c89c70	9d6b6cdf-5c63-47c3-b37b-7d8c97951ccc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:52:16
38744	9d6b6cdf-5715-4d57-8438-441a116f2788	9d6b6cdf-5c63-47c3-b37b-7d8c97951ccc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"48.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:52:16
38745	9d6b6cdf-5b0e-499e-a7cd-7dd7ac438b16	9d6b6cdf-5c63-47c3-b37b-7d8c97951ccc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:52:16
38746	9d6b6cdf-5b73-4a09-aaed-ad487374d04e	9d6b6cdf-5c63-47c3-b37b-7d8c97951ccc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":352,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:52:16
38747	9d6b6cdf-ab3c-499c-a62c-228081e4617f	9d6b6cdf-c8de-485d-af4f-64f3d243c595	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:52:16
38748	9d6b6cdf-c3d3-4114-abca-d5b344d98520	9d6b6cdf-c8de-485d-af4f-64f3d243c595	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:52:16
38749	9d6b6cdf-c41f-4f24-8431-c7f3aef38e0b	9d6b6cdf-c8de-485d-af4f-64f3d243c595	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:52:16
38750	9d6b6cdf-c798-41d0-bbf2-796a8a418ec0	9d6b6cdf-c8de-485d-af4f-64f3d243c595	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:52:16
38751	9d6b6cdf-c7ea-4a87-ab41-832988dd579d	9d6b6cdf-c8de-485d-af4f-64f3d243c595	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":268,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:52:16
38752	9d6b6ce0-22dc-4e2c-ad0d-1802a1d4f19f	9d6b6ce0-6f0b-4685-a1d6-73d56a5c442a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:52:16
38753	9d6b6ce0-6783-4589-9b51-325a3845f036	9d6b6ce0-6f0b-4685-a1d6-73d56a5c442a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"151.37","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:52:17
38754	9d6b6ce0-67ff-4931-b34b-713082066cf0	9d6b6ce0-6f0b-4685-a1d6-73d56a5c442a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:52:17
38755	9d6b6ce0-6d4d-4b36-b1cc-6310674a610d	9d6b6ce0-6f0b-4685-a1d6-73d56a5c442a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:52:17
38756	9d6b6ce0-6dd5-4bea-9db7-9a316077f5ea	9d6b6ce0-6f0b-4685-a1d6-73d56a5c442a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":410,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:52:17
38757	9d6b6ce2-7881-4eb8-8c8b-b53f45a9fdfa	9d6b6ce2-e6e5-4e26-a852-ae2d9bb3f949	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:52:18
38758	9d6b6ce2-d945-4a36-8a5c-db4cd762b069	9d6b6ce2-e6e5-4e26-a852-ae2d9bb3f949	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"147.18","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:52:18
38759	9d6b6ce2-d9d8-40ca-ad87-b52bf89d9878	9d6b6ce2-e6e5-4e26-a852-ae2d9bb3f949	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:52:18
38760	9d6b6ce2-e4a8-40bd-bb78-1585ca11ef08	9d6b6ce2-e6e5-4e26-a852-ae2d9bb3f949	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:52:18
38761	9d6b6ce2-e54e-440a-83b5-e6c41a294e0a	9d6b6ce2-e6e5-4e26-a852-ae2d9bb3f949	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":662,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:52:18
38762	9d6b6ce3-40cf-49c1-a81c-3c0930341985	9d6b6ce3-4423-4109-8567-c910ec0a7431	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":199,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:52:18
41528	9d6ccd3b-23a6-41e6-8170-781800034d9b	9d6ccd3b-6aaa-461a-b41a-eb0c46bf57ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-06 10:17:32
41529	9d6ccd3b-68a8-4fd9-a147-3e12fa854ff5	9d6ccd3b-6aaa-461a-b41a-eb0c46bf57ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-06 10:17:32
41530	9d6ccd3b-694f-4efd-bd3c-6ba3ef41ab13	9d6ccd3b-6aaa-461a-b41a-eb0c46bf57ca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":391,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:17:32
38763	9d6b6ce3-996b-4ab7-8d98-4f3b49828bb5	9d6b6ce3-b670-4e96-a1fe-83ea9c1e4d0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:52:19
38764	9d6b6ce3-b210-45d1-8e84-0f9cdfa346a9	9d6b6ce3-b670-4e96-a1fe-83ea9c1e4d0d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"47.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:52:19
38765	9d6b6ce3-b512-4a72-908d-b297fa82151e	9d6b6ce3-b670-4e96-a1fe-83ea9c1e4d0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:52:19
38766	9d6b6ce3-b579-4c7c-adfd-6fe871766ddf	9d6b6ce3-b670-4e96-a1fe-83ea9c1e4d0d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:52:19
41531	9d6ccd3b-dca7-460b-a669-1d4b09d597ec	9d6ccd3c-019e-4851-836c-89a61f6e7a9d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-06 10:17:32
41532	9d6ccd3b-fc58-467f-8714-ef69db1dc81b	9d6ccd3c-019e-4851-836c-89a61f6e7a9d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"61.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":89,"hash":"f9f3598e6ad2468770f89917d2ab916c","hostname":"EderCortes"}	2024-11-06 10:17:32
41533	9d6ccd3b-ffcd-480d-bc56-f5a4deab6d07	9d6ccd3c-019e-4851-836c-89a61f6e7a9d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-06 10:17:32
41534	9d6ccd3c-0072-4ba8-80ef-0bff25b32214	9d6ccd3c-019e-4851-836c-89a61f6e7a9d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getLoansCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":293,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:17:32
38767	9d6b6cf7-2168-47c3-b76e-1d62dd828021	9d6b6cf7-24cf-4034-bbee-7cd397ce1c34	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":141,"memory":20,"hostname":"EderCortes"}	2024-11-05 17:52:31
41535	9d6ccd3c-5e4e-48c8-8da9-64aac8e9ef9d	9d6ccd3c-7f30-4a70-b3c9-5751797b27a9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-06 10:17:33
41536	9d6ccd3c-7948-4f4a-bc21-5eda5331d4b8	9d6ccd3c-7f30-4a70-b3c9-5751797b27a9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:17:33
41537	9d6ccd3c-799c-4fd5-b271-58f06ea961e2	9d6ccd3c-7f30-4a70-b3c9-5751797b27a9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:17:33
41538	9d6ccd3c-7df2-4380-ba80-b045e7859b9a	9d6ccd3c-7f30-4a70-b3c9-5751797b27a9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-06 10:17:33
41539	9d6ccd3c-7e36-4f68-9bb7-9df988c15887	9d6ccd3c-7f30-4a70-b3c9-5751797b27a9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":312,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:17:33
38768	9d6b6cf7-9e4c-4193-aeb6-f55d1ac9378a	9d6b6cf7-e583-42e6-9000-8440be22b179	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:52:32
38769	9d6b6cf7-e0e9-401e-aee4-101386619e91	9d6b6cf7-e583-42e6-9000-8440be22b179	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" where \\"l\\".\\"loans_estado\\" = 'Cancelado' order by \\"l\\".\\"id\\" desc","time":"153.98","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"7ba28dd12eb1ea8772522a7f30ccb379","hostname":"EderCortes"}	2024-11-05 17:52:32
38770	9d6b6cf7-e402-43ab-8feb-4c9c72b94cfb	9d6b6cf7-e583-42e6-9000-8440be22b179	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 17:52:32
38771	9d6b6cf7-e45b-4d15-833a-760beb0afcc3	9d6b6cf7-e583-42e6-9000-8440be22b179	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"69","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":"Cancelado","prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":329,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:52:32
41540	9d6ccd3c-c8d5-4fcd-9420-65fa8b06f9b5	9d6ccd3c-e8b8-491a-bc54-ca92bac99272	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-06 10:17:33
41541	9d6ccd3c-e343-4033-8cf3-30f14ea4c48f	9d6ccd3c-e8b8-491a-bc54-ca92bac99272	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:17:33
41542	9d6ccd3c-e39c-4fa1-bda7-3bd5e621dc34	9d6ccd3c-e8b8-491a-bc54-ca92bac99272	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:17:33
41543	9d6ccd3c-e781-4d8c-95e2-f492c9cb9268	9d6ccd3c-e8b8-491a-bc54-ca92bac99272	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-06 10:17:33
41544	9d6ccd3c-e7c7-4013-9da0-a33769cfd8c6	9d6ccd3c-e8b8-491a-bc54-ca92bac99272	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:17:33
38772	9d6b6d00-4d35-4614-855b-839ccda9f6cc	9d6b6d00-5127-4ef5-af76-506e3e6483f0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":183,"memory":20,"hostname":"EderCortes"}	2024-11-05 17:52:37
41545	9d6ccd3e-92e8-4ed6-9154-fef27e181709	9d6ccd3e-e979-4f8d-9902-c1b435cccdde	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-06 10:17:34
41546	9d6ccd3e-e070-4f27-9f1e-b715cddc2877	9d6ccd3e-e979-4f8d-9902-c1b435cccdde	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"144.74","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:17:34
41547	9d6ccd3e-e100-4985-88d0-ce4f6dd4be1b	9d6ccd3e-e979-4f8d-9902-c1b435cccdde	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:17:34
41548	9d6ccd3e-e733-4d4c-bf28-92a4a1fe7e48	9d6ccd3e-e979-4f8d-9902-c1b435cccdde	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-06 10:17:34
41549	9d6ccd3e-e7dd-43d3-8bda-1afe2cbd025e	9d6ccd3e-e979-4f8d-9902-c1b435cccdde	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":550,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:17:34
41879	9d6cd08f-9212-44d1-a23b-2103cafcb2a7	9d6cd08f-abd2-49ad-aef3-0f596ace4e06	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:26:50
41880	9d6cd08f-aa3f-44ed-9bd7-971c89032321	9d6cd08f-abd2-49ad-aef3-0f596ace4e06	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:26:51
38773	9d6b6d01-04fd-45cd-89a2-2d9386eb29c3	9d6b6d01-2118-43e2-867e-96c3b28d8115	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 17:52:38
38774	9d6b6d01-1c6f-4acb-9890-695a6d717c15	9d6b6d01-2118-43e2-867e-96c3b28d8115	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" where \\"l\\".\\"loans_estado\\" = 'Pendiente' order by \\"l\\".\\"id\\" desc","time":"43.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"7ba28dd12eb1ea8772522a7f30ccb379","hostname":"EderCortes"}	2024-11-05 17:52:38
38775	9d6b6d01-1f8c-48c0-811b-57b8f13af0d1	9d6b6d01-2118-43e2-867e-96c3b28d8115	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 17:52:38
38776	9d6b6d01-1ff7-44c8-900a-6d1e6da0da0b	9d6b6d01-2118-43e2-867e-96c3b28d8115	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"69","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":"Pendiente","prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":222,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:52:38
41550	9d6ccd3f-7376-4a2a-9462-b09b0d00cf0d	9d6ccd3f-ca23-4717-9636-7470021478a8	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:17:35
41551	9d6ccd3f-c2f6-456c-b869-026283c72d5f	9d6ccd3f-ca23-4717-9636-7470021478a8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"166.23","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:17:35
41552	9d6ccd3f-c84d-464c-ba6d-e8a3c535bed1	9d6ccd3f-ca23-4717-9636-7470021478a8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:17:35
41553	9d6ccd3f-c8b8-4d5e-abdd-d8c892a9edc0	9d6ccd3f-ca23-4717-9636-7470021478a8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":554,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:17:35
41881	9d6cd08f-aad8-411e-9ed2-4a056aed9a00	9d6cd08f-abd2-49ad-aef3-0f596ace4e06	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:26:51
38777	9d6b6d08-dec1-484d-9246-c187d508fe28	9d6b6d08-e1fb-4530-9741-c1ad3151bb20	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":171,"memory":20,"hostname":"EderCortes"}	2024-11-05 17:52:43
41554	9d6ccd40-4268-4f55-899f-cb03f6184191	9d6ccd40-4602-4b86-b5b4-155849813997	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":273,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:17:35
35821	9d69c7ec-293e-4591-bf6c-f9bc0e545b62	9d69c7ec-54fd-40a0-9df0-4c07aa2ad9ac	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 22:15:12
32725	9d69830c-41aa-46e8-9789-bdabb18b28b8	9d69830c-73ab-43b4-8c38-33b62e5f2399	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 19:02:37
32726	9d69830c-70df-4629-b92a-c9be1425c3fc	9d69830c-73ab-43b4-8c38-33b62e5f2399	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 19:02:37
32727	9d69830c-7235-4f0c-a777-32c0aa5b592c	9d69830c-73ab-43b4-8c38-33b62e5f2399	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":409,"memory":22,"hostname":"EderCortes"}	2024-11-04 19:02:37
35822	9d69c7ec-52a5-4ebb-b06f-3f32a20f6555	9d69c7ec-54fd-40a0-9df0-4c07aa2ad9ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 22:15:12
35823	9d69c7ec-53a7-420d-b872-4f8c2829a8cb	9d69c7ec-54fd-40a0-9df0-4c07aa2ad9ac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":428,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:15:12
40962	9d6cc8fb-21a8-4040-ab3d-7667316cb8a0	9d6cc8fb-246d-4ac7-b8a9-dcfb561491af	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1874}	2024-11-06 10:05:39
41882	9d6cd090-105e-427c-92d6-18571d181bde	9d6cd090-573b-41bd-b1ef-81c76b23f64a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:26:51
32728	9d69830d-1277-40c4-b09e-a9ad30fb939a	9d69830d-40d0-4f82-85c5-29353478e660	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 19:02:37
32729	9d69830d-3448-432b-a5a5-f1cda71211b4	9d69830d-40d0-4f82-85c5-29353478e660	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 91\\n                        ","time":"65.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":265,"hash":"9ae30bc69b6b272f3f51ff48e54319f5","hostname":"EderCortes"}	2024-11-04 19:02:38
32730	9d69830d-38b1-4285-8db2-bf3fa9efa353	9d69830d-40d0-4f82-85c5-29353478e660	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '91' order by \\"item_loans\\".\\"id\\" asc","time":"3.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":303,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-04 19:02:38
32731	9d69830d-3eb9-4462-9eae-5efa0a441a1b	9d69830d-40d0-4f82-85c5-29353478e660	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 19:02:38
32732	9d69830d-3f54-4ee3-a3de-d5752b5128e0	9d69830d-40d0-4f82-85c5-29353478e660	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/91","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":91,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":8,"loans_valor_prestado":5000000,"loans_cuando":"Q","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"800000","loans_pago_interes":"200000","user_alias":"eder.cortes"},"items":[{"id":371,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"625000","itemloans_iteres":"156250","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:04:19","updated_at":"2024-11-04 17:44:55","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"200000","itemloans_cuota_cancelada":"800000","user_alias":"eder.cortes"},{"id":403,"loans_codigo":91,"itemloans_cuota":"1","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":404,"loans_codigo":91,"itemloans_cuota":"2","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":405,"loans_codigo":91,"itemloans_cuota":"3","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":406,"loans_codigo":91,"itemloans_cuota":"4","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":407,"loans_codigo":91,"itemloans_cuota":"5","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":408,"loans_codigo":91,"itemloans_cuota":"6","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":409,"loans_codigo":91,"itemloans_cuota":"7","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":410,"loans_codigo":91,"itemloans_cuota":"8","itemloans_valor_cuota":"525000","itemloans_iteres":"131250","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2025-03-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 17:44:56","updated_at":"2024-11-04 17:44:56","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":427,"memory":22,"hostname":"EderCortes"}	2024-11-04 19:02:38
35824	9d69c7ec-e948-4411-acef-a2590434d088	9d69c7ed-11b7-42d0-96f2-3df663260df9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 22:15:13
35825	9d69c7ed-08b7-4ce2-ac24-93f14780310d	9d69c7ed-11b7-42d0-96f2-3df663260df9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:15:13
35826	9d69c7ed-091d-4bc9-8c41-498b1bfe0a32	9d69c7ed-11b7-42d0-96f2-3df663260df9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 22:15:13
35827	9d69c7ed-0fe7-4ffa-a1ff-7f0349a9b0a5	9d69c7ed-11b7-42d0-96f2-3df663260df9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 22:15:13
35828	9d69c7ed-1066-4bd6-8bcb-790e2cf0faee	9d69c7ed-11b7-42d0-96f2-3df663260df9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:15:13
38778	9d6b6d09-9a3d-450e-add7-68dfee051508	9d6b6d09-b5ec-4ab4-a0bb-d820aaf466ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 17:52:44
38779	9d6b6d09-b164-43dd-ba2a-f199396c61ff	9d6b6d09-b5ec-4ab4-a0bb-d820aaf466ea	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" where \\"l\\".\\"loans_estado\\" = 'En curso' order by \\"l\\".\\"id\\" desc","time":"42.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"7ba28dd12eb1ea8772522a7f30ccb379","hostname":"EderCortes"}	2024-11-05 17:52:44
38780	9d6b6d09-b490-4160-8765-598afd69619c	9d6b6d09-b5ec-4ab4-a0bb-d820aaf466ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 17:52:44
32733	9d69830d-e06a-4408-8206-82c4703e7e95	9d69830e-24d2-4420-b6c8-07b1c045d98b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 19:02:38
32734	9d69830e-19f5-438d-aa7a-218e67c459a0	9d69830e-24d2-4420-b6c8-07b1c045d98b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"88.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 19:02:38
32735	9d69830e-1aa2-4781-a29d-ca7af71bba88	9d69830e-24d2-4420-b6c8-07b1c045d98b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 19:02:38
32736	9d69830e-2298-4a10-8a56-673f32fd4511	9d69830e-24d2-4420-b6c8-07b1c045d98b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 19:02:38
32737	9d69830e-2338-4f6b-a488-7a2d18b9037f	9d69830e-24d2-4420-b6c8-07b1c045d98b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":542,"memory":22,"hostname":"EderCortes"}	2024-11-04 19:02:38
35829	9d69c7ed-624e-4480-90a9-12d8fdea52f9	9d69c7ed-8640-41e3-845f-01c07d5302c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 22:15:13
35830	9d69c7ed-7f4f-4785-9c55-789b89e8119a	9d69c7ed-8640-41e3-845f-01c07d5302c2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"50.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 22:15:13
35831	9d69c7ed-7fb5-4988-beed-ad4dd3c6a52a	9d69c7ed-8640-41e3-845f-01c07d5302c2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 22:15:13
35832	9d69c7ed-84fa-4b64-8057-c898d4280c2b	9d69c7ed-8640-41e3-845f-01c07d5302c2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 22:15:13
35833	9d69c7ed-8554-4677-848e-92bd5787ccd2	9d69c7ed-8640-41e3-845f-01c07d5302c2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":277,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:15:13
38781	9d6b6d09-b4e2-44f2-8045-5f356de6f477	9d6b6d09-b5ec-4ab4-a0bb-d820aaf466ea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"68","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":"En curso","prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:52:44
41555	9d6ccd41-1506-4bae-8f06-107f2b280930	9d6ccd41-63a9-43a8-af23-d908eed06023	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:17:36
41556	9d6ccd41-5c71-47d8-9452-ef8f3d794203	9d6ccd41-63a9-43a8-af23-d908eed06023	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"158.33","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":89,"hash":"f9f3598e6ad2468770f89917d2ab916c","hostname":"EderCortes"}	2024-11-06 10:17:36
41557	9d6ccd41-61f6-4a66-88da-4bfa7d49e45e	9d6ccd41-63a9-43a8-af23-d908eed06023	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:17:36
41883	9d6cd090-51a2-4a51-a70a-2ace837aed33	9d6cd090-573b-41bd-b1ef-81c76b23f64a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"145.56","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":19,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-06 10:26:51
32738	9d69830e-f024-4bc5-8e44-9e8b1450e39d	9d69830f-28ce-4e95-b318-a7eec1faf73c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 19:02:39
32739	9d69830f-1cd5-4f36-90a7-b2786ffa35de	9d69830f-28ce-4e95-b318-a7eec1faf73c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"71.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 19:02:39
32740	9d69830f-1d84-4ab5-90d3-f74591e4dc87	9d69830f-28ce-4e95-b318-a7eec1faf73c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 19:02:39
32741	9d69830f-2691-4d81-8035-489fa5f4cfcc	9d69830f-28ce-4e95-b318-a7eec1faf73c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 19:02:39
32742	9d69830f-2730-46cf-b19f-7590729cc1d3	9d69830f-28ce-4e95-b318-a7eec1faf73c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":558,"memory":22,"hostname":"EderCortes"}	2024-11-04 19:02:39
35834	9d69c7ed-db67-417a-893b-1d79e3c07fdf	9d69c7ed-fb0a-4b34-b867-513db0926aed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 22:15:13
35835	9d69c7ed-f5c1-4fda-b366-daa36d9654ed	9d69c7ed-fb0a-4b34-b867-513db0926aed	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:15:13
35836	9d69c7ed-f617-4b59-8fd1-00009100ec09	9d69c7ed-fb0a-4b34-b867-513db0926aed	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:15:13
35837	9d69c7ed-f9de-4a88-8f93-ab430b74f2b7	9d69c7ed-fb0a-4b34-b867-513db0926aed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 22:15:13
35838	9d69c7ed-fa28-4a33-b7e6-4567f6ecf9f8	9d69c7ed-fb0a-4b34-b867-513db0926aed	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":279,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:15:13
38782	9d6b6d19-9342-4546-9a36-36879333f84e	9d6b6d19-9627-4196-854b-da875348a9c1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":166,"memory":20,"hostname":"EderCortes"}	2024-11-05 17:52:54
40827	9d6cc7a9-f693-4a67-9a75-951c87aa1838	9d6cc7aa-0ff8-403e-9bea-890d3f0f76dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 10:01:58
40828	9d6cc7aa-0e71-4fba-9328-e426945a52cd	9d6cc7aa-0ff8-403e-9bea-890d3f0f76dd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 10:01:58
41884	9d6cd090-5215-48be-9e91-205e95d251e9	9d6cd090-573b-41bd-b1ef-81c76b23f64a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":5,"hostname":"EderCortes"}	2024-11-06 10:26:51
41885	9d6cd090-55fb-4e09-ab0b-db1fb356026b	9d6cd090-573b-41bd-b1ef-81c76b23f64a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:26:51
38783	9d6b6d1a-4cdd-4ebe-9cd9-58c94d18ef95	9d6b6d1a-69aa-4f69-8de0-c34464aa783f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 17:52:55
38784	9d6b6d1a-656b-41ba-9544-cb1632bcfd70	9d6b6d1a-69aa-4f69-8de0-c34464aa783f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" where \\"l\\".\\"loans_estado\\" = 'En curso' and \\"l\\".\\"user_creador\\" = 22 order by \\"l\\".\\"id\\" desc","time":"45.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"2b602ddda371b73c3fda354bce1bc456","hostname":"EderCortes"}	2024-11-05 17:52:55
38785	9d6b6d1a-681c-4a00-97dc-d27ae9406f2e	9d6b6d1a-69aa-4f69-8de0-c34464aa783f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 17:52:55
38786	9d6b6d1a-6877-4aaf-a8ff-be488ae17138	9d6b6d1a-69aa-4f69-8de0-c34464aa783f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"68","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":"En curso","prestamista":22},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:52:55
41886	9d6cd090-5649-4a52-910b-8a9668856760	9d6cd090-573b-41bd-b1ef-81c76b23f64a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:55:01.000000Z","deleted_at":null,"user_alias":"eder.cortes"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":332,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:26:51
40830	9d6cc7ab-1b87-44c8-b471-72dbed232f74	9d6cc7ab-424c-45ed-83e4-8c95a4885f28	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 10:01:59
40711	9d6cc6b2-5b81-45c1-9336-5ddaa2dc3629	9d6cc6b2-8a9e-4adb-94ae-cdeec7f07217	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 09:59:16
40712	9d6cc6b2-8340-4d6c-8499-3ce6d52e0d24	9d6cc6b2-8a9e-4adb-94ae-cdeec7f07217	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"68.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:59:16
40713	9d6cc6b2-83bb-41eb-b3e7-13c3bdcef022	9d6cc6b2-8a9e-4adb-94ae-cdeec7f07217	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:59:16
40714	9d6cc6b2-894a-4de7-be2f-0a176f438ea0	9d6cc6b2-8a9e-4adb-94ae-cdeec7f07217	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 09:59:16
40715	9d6cc6b2-899b-4946-873a-51b70693de8c	9d6cc6b2-8a9e-4adb-94ae-cdeec7f07217	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":448,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:59:16
40831	9d6cc7ab-3cbb-4e8b-9798-adb5eeb3248e	9d6cc7ab-424c-45ed-83e4-8c95a4885f28	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"60.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:01:59
40832	9d6cc7ab-3d1b-49a4-be1f-4aec9c6fa817	9d6cc7ab-424c-45ed-83e4-8c95a4885f28	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:01:59
40833	9d6cc7ab-4121-487d-b690-a2ee3aabf49b	9d6cc7ab-424c-45ed-83e4-8c95a4885f28	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-06 10:01:59
38787	9d6b6d21-6c54-4de5-b6cc-562461af3262	9d6b6d21-6fb9-41a3-b726-80e7719abc81	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":177,"memory":20,"hostname":"EderCortes"}	2024-11-05 17:52:59
41558	9d6ccd41-6277-4a30-bfce-be7f9aa555a5	9d6ccd41-63a9-43a8-af23-d908eed06023	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getLoansCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":427,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:17:36
41887	9d6cd091-f746-4714-bef3-4bfdd10973d2	9d6cd092-4d90-4d08-a936-7dbf779d5cb7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:26:52
41888	9d6cd092-4505-4a92-a523-f51dbc8b8dce	9d6cd092-4d90-4d08-a936-7dbf779d5cb7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"170.28","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:26:52
40716	9d6cc6b2-f4bb-40d8-ac42-b6eb31a40e42	9d6cc6b3-4045-48a8-870d-4125b77f9b41	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 09:59:16
40717	9d6cc6b3-39f8-4fe9-bcdc-a9d10226ed1a	9d6cc6b3-4045-48a8-870d-4125b77f9b41	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"154.80","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:59:16
40718	9d6cc6b3-3ea4-4b20-b2a5-296c427cdef1	9d6cc6b3-4045-48a8-870d-4125b77f9b41	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 09:59:16
40719	9d6cc6b3-3f23-49a4-9b5e-9da6f114d912	9d6cc6b3-4045-48a8-870d-4125b77f9b41	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":450,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:59:16
41889	9d6cd092-458f-464b-ab9d-13b8740a61a8	9d6cd092-4d90-4d08-a936-7dbf779d5cb7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:26:52
41890	9d6cd092-4c18-4ce3-b563-74833c99b06b	9d6cd092-4d90-4d08-a936-7dbf779d5cb7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 10:26:52
41891	9d6cd092-4c86-4c7d-bb47-1a1781fbf0f7	9d6cd092-4d90-4d08-a936-7dbf779d5cb7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":442,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:26:52
38788	9d6b6d22-3239-4f53-a35d-77c27d98bbaa	9d6b6d22-7957-46d9-acdb-442b2323037a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 17:53:00
38789	9d6b6d22-7503-483c-b7f3-797f5d940a32	9d6b6d22-7957-46d9-acdb-442b2323037a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" where \\"l\\".\\"loans_estado\\" = 'En curso' and \\"l\\".\\"loans_cuando\\" = 'S' and \\"l\\".\\"user_creador\\" = 22 order by \\"l\\".\\"id\\" desc","time":"151.79","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"63d6eb8a85b34ea6481902283fe60bdc","hostname":"EderCortes"}	2024-11-05 17:53:00
38790	9d6b6d22-77f1-48aa-a32b-24457dc85bf0	9d6b6d22-7957-46d9-acdb-442b2323037a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 17:53:00
38791	9d6b6d22-7846-431c-ac5e-0251aec0088d	9d6b6d22-7957-46d9-acdb-442b2323037a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"69","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":"S","estado":"En curso","prestamista":22},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":368,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:53:00
41559	9d6ccd47-a890-4404-9d7f-a327dfe0a288	9d6ccd47-adc2-4379-9e05-f73847972944	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":242,"memory":20,"hostname":"EderCortes"}	2024-11-06 10:17:40
41892	9d6cd092-a438-4ef6-9bac-d8269af460ed	9d6cd092-e85d-43dd-ab7c-7a2593d2f3ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 10:26:53
40834	9d6cc7ab-416d-437e-92d5-59bca07bf95b	9d6cc7ab-424c-45ed-83e4-8c95a4885f28	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":369,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:01:59
41893	9d6cd092-e3b7-4e48-a534-7a0ce5a78a36	9d6cd092-e85d-43dd-ab7c-7a2593d2f3ee	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"148.24","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:26:53
41894	9d6cd092-e6fa-4e60-a3f5-75bc86ec5d4f	9d6cd092-e85d-43dd-ab7c-7a2593d2f3ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 10:26:53
41895	9d6cd092-e748-4183-a6bf-5162939660ae	9d6cd092-e85d-43dd-ab7c-7a2593d2f3ee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":371,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:26:53
38792	9d6b6d26-c482-4ca4-a88d-fbde468e6b4b	9d6b6d26-c7c6-4731-b7d5-ae6100fdb691	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":164,"memory":20,"hostname":"EderCortes"}	2024-11-05 17:53:03
41560	9d6ccd48-409c-4242-a743-3eb29a968e68	9d6ccd48-9630-42f9-aa17-cbe44ed4fe1b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:17:40
41561	9d6ccd48-8ed6-465c-b6d3-b64fa6fb78e9	9d6ccd48-9630-42f9-aa17-cbe44ed4fe1b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"162.95","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:17:41
41562	9d6ccd48-8f3a-46cb-93fe-39143f81f225	9d6ccd48-9630-42f9-aa17-cbe44ed4fe1b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:17:41
40835	9d6cc7ab-ad68-49f2-827b-d0e6c971e2f0	9d6cc7ab-ce55-497c-a702-87f0e68b19a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-06 10:01:59
40836	9d6cc7ab-c842-4fa9-b024-308894cdc805	9d6cc7ab-ce55-497c-a702-87f0e68b19a4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"50.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:01:59
40837	9d6cc7ab-ccca-4018-b572-403f9c98c4e8	9d6cc7ab-ce55-497c-a702-87f0e68b19a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-06 10:01:59
40838	9d6cc7ab-cd2d-4b96-85c6-4956d96b7bca	9d6cc7ab-ce55-497c-a702-87f0e68b19a4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":344,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:01:59
41563	9d6ccd48-9486-4162-9a9d-10b7cc80dca7	9d6ccd48-9630-42f9-aa17-cbe44ed4fe1b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:17:41
41564	9d6ccd48-94fc-4be0-bcc2-c590dcc563a8	9d6ccd48-9630-42f9-aa17-cbe44ed4fe1b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":423,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:17:41
38793	9d6b6d27-7c8d-4078-abc4-2556cf7bbab1	9d6b6d27-97e4-43c7-a9c0-9d85c931fcc1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 17:53:03
38794	9d6b6d27-936b-4797-b19b-ad0e35ddb7a5	9d6b6d27-97e4-43c7-a9c0-9d85c931fcc1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" where \\"l\\".\\"loans_estado\\" = 'En curso' and \\"l\\".\\"loans_cuando\\" = 'M' and \\"l\\".\\"user_creador\\" = 22 order by \\"l\\".\\"id\\" desc","time":"41.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"63d6eb8a85b34ea6481902283fe60bdc","hostname":"EderCortes"}	2024-11-05 17:53:03
38795	9d6b6d27-96ac-4c5b-87d0-644ecd0cbf38	9d6b6d27-97e4-43c7-a9c0-9d85c931fcc1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 17:53:03
38796	9d6b6d27-96ed-42cd-bd81-c16a1f6c8f9f	9d6b6d27-97e4-43c7-a9c0-9d85c931fcc1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"69","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":"M","estado":"En curso","prestamista":22},"session":[],"response_status":200,"response":{"data":[]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:53:03
41565	9d6ccd49-06d7-481e-bf8f-f5ad0404486a	9d6ccd49-5261-454a-919f-891a3924de7c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:17:41
41566	9d6ccd49-4c0e-4281-a83c-4c212d132928	9d6ccd49-5261-454a-919f-891a3924de7c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"145.12","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:17:41
41567	9d6ccd49-4c67-426c-a024-65d11df77634	9d6ccd49-5261-454a-919f-891a3924de7c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:17:41
41568	9d6ccd49-510c-4fef-add3-68cebc1126c2	9d6ccd49-5261-454a-919f-891a3924de7c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:17:41
41569	9d6ccd49-5155-4277-bde9-fdcd62278b8a	9d6ccd49-5261-454a-919f-891a3924de7c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":465,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:17:41
38797	9d6b6d2c-f35d-497b-b9c7-821a663c8242	9d6b6d2c-f6ad-4006-8434-7b108c083327	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":165,"memory":20,"hostname":"EderCortes"}	2024-11-05 17:53:07
41570	9d6ccd49-9795-4410-9650-ef97e989890e	9d6ccd49-dff5-46ed-b193-e2fc247e98cb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:17:41
41571	9d6ccd49-dac8-4554-89d7-0cbc4df66a22	9d6ccd49-dff5-46ed-b193-e2fc247e98cb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"154.84","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":89,"hash":"f9f3598e6ad2468770f89917d2ab916c","hostname":"EderCortes"}	2024-11-06 10:17:41
41572	9d6ccd49-de73-4bcd-87b1-1e99d3ddbd07	9d6ccd49-dff5-46ed-b193-e2fc247e98cb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:17:41
41573	9d6ccd49-dee8-4598-82c6-9069e4ecff04	9d6ccd49-dff5-46ed-b193-e2fc247e98cb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getLoansCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:17:41
38798	9d6b6d2d-abe3-4267-8a2a-c94f8f096cb0	9d6b6d2d-f430-46b7-85b5-bfa4dfb79f49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 17:53:07
38799	9d6b6d2d-efbb-4c4e-8d55-8798e15d86b1	9d6b6d2d-f430-46b7-85b5-bfa4dfb79f49	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" where \\"l\\".\\"loans_estado\\" = 'En curso' and \\"l\\".\\"loans_cuando\\" = 'S' and \\"l\\".\\"user_creador\\" = 22 order by \\"l\\".\\"id\\" desc","time":"155.95","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"63d6eb8a85b34ea6481902283fe60bdc","hostname":"EderCortes"}	2024-11-05 17:53:07
38800	9d6b6d2d-f301-4c38-8448-26b2fb3314c8	9d6b6d2d-f430-46b7-85b5-bfa4dfb79f49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 17:53:07
38801	9d6b6d2d-f345-4a92-9a7c-cb643fecfc95	9d6b6d2d-f430-46b7-85b5-bfa4dfb79f49	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"69","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":"S","estado":"En curso","prestamista":22},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":338,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:53:07
41574	9d6ccd4f-d96a-489b-bfc8-3d3c80a7fad0	9d6ccd4f-ddde-4a1c-861a-cd26ed83b4a7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":182,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:17:45
38802	9d6b6d33-e953-40aa-b36a-fde0f91d25e1	9d6b6d33-ec7e-4e4d-9105-58305f851a07	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":165,"memory":20,"hostname":"EderCortes"}	2024-11-05 17:53:11
41575	9d6ccd50-3a1f-4087-b7a7-86e96ea3d93d	9d6ccd50-61e0-49b1-8afa-5b999b193681	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:17:46
41576	9d6ccd50-5864-46fb-ba75-0e0a5570a308	9d6ccd50-61e0-49b1-8afa-5b999b193681	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"54.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:17:46
41577	9d6ccd50-5919-459f-aa87-4a44d4348512	9d6ccd50-61e0-49b1-8afa-5b999b193681	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:17:46
41578	9d6ccd50-6009-44fa-a00a-c63d6fb6660b	9d6ccd50-61e0-49b1-8afa-5b999b193681	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:17:46
41579	9d6ccd50-6089-4c52-a4c9-7905c5bca91e	9d6ccd50-61e0-49b1-8afa-5b999b193681	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":279,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:17:46
38803	9d6b6d34-a4cb-40f2-8609-81f59d6b9b4d	9d6b6d34-c26e-4636-8f5c-9a4f1fc27e04	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 17:53:12
38804	9d6b6d34-bde1-4532-8ef1-d954dc76761b	9d6b6d34-c26e-4636-8f5c-9a4f1fc27e04	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" where \\"l\\".\\"loans_estado\\" = 'En curso' and \\"l\\".\\"loans_cuando\\" = 'T' and \\"l\\".\\"user_creador\\" = 22 order by \\"l\\".\\"id\\" desc","time":"46.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"63d6eb8a85b34ea6481902283fe60bdc","hostname":"EderCortes"}	2024-11-05 17:53:12
38805	9d6b6d34-c111-4e32-8ce8-2d7d94b602ad	9d6b6d34-c26e-4636-8f5c-9a4f1fc27e04	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 17:53:12
38806	9d6b6d34-c161-41a4-8dec-d6394623bb10	9d6b6d34-c26e-4636-8f5c-9a4f1fc27e04	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"69","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":"T","estado":"En curso","prestamista":22},"session":[],"response_status":200,"response":{"data":[]},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:53:12
41580	9d6ccd50-b449-4853-a861-5187c584ceeb	9d6ccd50-d212-45f2-b1db-d957ce199f1e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:17:46
41581	9d6ccd50-ccc7-4294-8a06-a34555169a87	9d6ccd50-d212-45f2-b1db-d957ce199f1e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:17:46
41582	9d6ccd50-cd16-428d-8f47-0cdfa6746cce	9d6ccd50-d212-45f2-b1db-d957ce199f1e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:17:46
41583	9d6ccd50-d0db-434f-a8ac-8900411e3e64	9d6ccd50-d212-45f2-b1db-d957ce199f1e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:17:46
41584	9d6ccd50-d129-4f44-a9d8-41d8209d2b46	9d6ccd50-d212-45f2-b1db-d957ce199f1e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":264,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:17:46
38807	9d6b6d39-a00b-4f61-87cf-ed4e3a35fe50	9d6b6d39-a3fe-4c9c-9c20-7d4a9dc3f6de	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":177,"memory":20,"hostname":"EderCortes"}	2024-11-05 17:53:15
41585	9d6ccd51-14b6-42f2-9f15-4edce75bc67b	9d6ccd51-5a19-4e50-a1d0-9b069bda6e54	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:17:46
41586	9d6ccd51-55a4-451c-b4b0-ccb57839c10d	9d6ccd51-5a19-4e50-a1d0-9b069bda6e54	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"149.79","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 10:17:46
41587	9d6ccd51-58c7-470b-af74-15b45782463b	9d6ccd51-5a19-4e50-a1d0-9b069bda6e54	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:17:46
41588	9d6ccd51-5931-493b-bf13-cd3329bfcecd	9d6ccd51-5a19-4e50-a1d0-9b069bda6e54	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:17:46
41645	9d6cce5b-d8bf-4300-91a9-bccd5a730758	9d6cce5b-f185-4402-ae6f-8c7ef1c78647	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:20:41
41646	9d6cce5b-f02e-46a7-9c90-777c67faa314	9d6cce5b-f185-4402-ae6f-8c7ef1c78647	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:20:41
41647	9d6cce5b-f0bc-44d0-95d6-7fad00d126e9	9d6cce5b-f185-4402-ae6f-8c7ef1c78647	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":213,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:20:41
41644	9d6cce5b-eec5-4d0f-b160-9b6ec1c29c3e	9d6cce5b-f185-4402-ae6f-8c7ef1c78647	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1912}	2024-11-06 10:20:41
38808	9d6b6d3a-5f3e-412b-b304-63077606258b	9d6b6d3a-8203-4daa-bfc3-003e9d377b9e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 17:53:16
38809	9d6b6d3a-7c87-436b-b32c-40bd916e3234	9d6b6d3a-8203-4daa-bfc3-003e9d377b9e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" where \\"l\\".\\"loans_estado\\" = 'En curso' and \\"l\\".\\"loans_cuando\\" = 'D' and \\"l\\".\\"user_creador\\" = 22 order by \\"l\\".\\"id\\" desc","time":"44.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"63d6eb8a85b34ea6481902283fe60bdc","hostname":"EderCortes"}	2024-11-05 17:53:16
38810	9d6b6d3a-8075-4935-8f2a-471c6e8b5f7c	9d6b6d3a-8203-4daa-bfc3-003e9d377b9e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:53:16
38811	9d6b6d3a-80c8-46cd-8ad8-44f6af1d86dd	9d6b6d3a-8203-4daa-bfc3-003e9d377b9e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"69","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":"D","estado":"En curso","prestamista":22},"session":[],"response_status":200,"response":{"data":[]},"duration":256,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:53:16
41648	9d6cce5d-2fa4-4f87-9af1-59cef8b49563	9d6cce5d-5719-4af9-b292-025b34ec251f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:20:42
41649	9d6cce5d-4e77-4e58-9c3e-5eb37dfa6657	9d6cce5d-5719-4af9-b292-025b34ec251f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:20:42
41650	9d6cce5d-4f0b-4e92-8545-8ab260076160	9d6cce5d-5719-4af9-b292-025b34ec251f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:20:42
41651	9d6cce5d-5543-4af9-9bca-5310d01fb6e5	9d6cce5d-5719-4af9-b292-025b34ec251f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:20:42
41652	9d6cce5d-55c8-4192-b834-0cef29e34baa	9d6cce5d-5719-4af9-b292-025b34ec251f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":428,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:20:42
38812	9d6b6d41-ae8a-42a5-8bad-c3483b3057f5	9d6b6d41-b207-4a20-a0ed-d55461a93eab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":198,"memory":20,"hostname":"EderCortes"}	2024-11-05 17:53:20
41653	9d6cce5d-c69a-46e2-8dd8-01841cfd0ee7	9d6cce5d-eb97-4a46-b29e-4c2b5f2f4406	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:20:42
41654	9d6cce5d-e4c8-4c5a-b7d8-6a8e846c204c	9d6cce5d-eb97-4a46-b29e-4c2b5f2f4406	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"59.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:20:42
41655	9d6cce5d-e9dc-4aeb-8ba6-fcc91ac42e3b	9d6cce5d-eb97-4a46-b29e-4c2b5f2f4406	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:20:42
41656	9d6cce5d-ea3c-4642-89d2-2e674ee44a54	9d6cce5d-eb97-4a46-b29e-4c2b5f2f4406	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":358,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:20:42
38813	9d6b6d42-66fd-4f63-877b-c2d7d96ce3bc	9d6b6d42-ad7d-44df-8d13-d7a02563609a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:53:21
38814	9d6b6d42-a910-4c2a-a849-412d1e597c2a	9d6b6d42-ad7d-44df-8d13-d7a02563609a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" where \\"l\\".\\"loans_estado\\" = 'Cancelado' and \\"l\\".\\"loans_cuando\\" = 'D' and \\"l\\".\\"user_creador\\" = 22 order by \\"l\\".\\"id\\" desc","time":"152.87","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"63d6eb8a85b34ea6481902283fe60bdc","hostname":"EderCortes"}	2024-11-05 17:53:21
38815	9d6b6d42-ac11-4bb6-baf5-91fc1edbccb5	9d6b6d42-ad7d-44df-8d13-d7a02563609a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:53:21
38816	9d6b6d42-ac54-4226-bc68-917dc358a604	9d6b6d42-ad7d-44df-8d13-d7a02563609a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"70","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":"D","estado":"Cancelado","prestamista":22},"session":[],"response_status":200,"response":{"data":[]},"duration":336,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:53:21
41823	9d6ccfcd-74a1-4833-835f-1cd74bd41eaa	9d6ccfcd-8e6d-4133-8695-c2ace5583c6f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:24:43
41824	9d6ccfcd-8c83-49b6-91ae-636b64a5bbd3	9d6ccfcd-8e6d-4133-8695-c2ace5583c6f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:24:43
41825	9d6ccfcd-8d22-41d7-9065-3a62416ac984	9d6ccfcd-8e6d-4133-8695-c2ace5583c6f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:24:43
41353	9d6ccc69-3518-4a3b-8b50-319cd3f1f0a0	9d6ccc69-5028-4b3e-b35d-6561f5820445	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-06 10:15:14
38817	9d6b6d45-a3de-4b6b-9056-57c8be44ae84	9d6b6d45-a714-4bdf-b2d5-f6a076b6d603	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":160,"memory":20,"hostname":"EderCortes"}	2024-11-05 17:53:23
41826	9d6ccfce-b29f-4fe3-bd4e-ff00dd2f7175	9d6ccfce-ea68-4d15-91e6-294e894ee2da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:24:44
41713	9d6ccef2-488b-4a16-b57e-8bd99a8e8978	9d6ccef2-6396-4b70-88eb-9512f88321c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 10:22:20
41714	9d6ccef2-6221-4c97-ad8c-f6a33d8d7cf1	9d6ccef2-6396-4b70-88eb-9512f88321c8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 10:22:20
40137	9d6cc120-c1ca-489b-a62d-bc3ca02d91cc	9d6cc120-d97e-4cc2-a9ea-7edd729c502e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 09:43:41
40138	9d6cc120-d82e-467a-bc9b-9cde9da74275	9d6cc120-d97e-4cc2-a9ea-7edd729c502e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 09:43:41
41354	9d6ccc69-4ea5-4713-9a35-4895a231b07d	9d6ccc69-5028-4b3e-b35d-6561f5820445	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-06 10:15:14
41355	9d6ccc69-4f3a-4781-893e-9cdfabde0a9b	9d6ccc69-5028-4b3e-b35d-6561f5820445	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:14
41715	9d6ccef2-62b5-4a0c-b5ca-2bbfdd7d1c5c	9d6ccef2-6396-4b70-88eb-9512f88321c8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:22:20
41827	9d6ccfce-e191-4809-8585-03561ccb8f1b	9d6ccfce-ea68-4d15-91e6-294e894ee2da	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"91.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:24:44
41828	9d6ccfce-e21d-4e6f-9e6d-a3193fea2923	9d6ccfce-ea68-4d15-91e6-294e894ee2da	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:24:44
41829	9d6ccfce-e875-49f1-9a9f-475c30dcac6a	9d6ccfce-ea68-4d15-91e6-294e894ee2da	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:24:44
38818	9d6b6d46-611d-4dc9-aef6-cc4c911df442	9d6b6d46-a7d0-4a3f-82da-34607c84247f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:53:23
38819	9d6b6d46-a33b-4339-8b3b-5fd34ed8d7eb	9d6b6d46-a7d0-4a3f-82da-34607c84247f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" where \\"l\\".\\"loans_estado\\" = 'Pendiente' and \\"l\\".\\"loans_cuando\\" = 'D' and \\"l\\".\\"user_creador\\" = 22 order by \\"l\\".\\"id\\" desc","time":"152.48","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"63d6eb8a85b34ea6481902283fe60bdc","hostname":"EderCortes"}	2024-11-05 17:53:24
38820	9d6b6d46-a67a-4bf0-98b7-43c154eab0a1	9d6b6d46-a7d0-4a3f-82da-34607c84247f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:53:24
38821	9d6b6d46-a6c2-4926-ae39-eb34debd4781	9d6b6d46-a7d0-4a3f-82da-34607c84247f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"70","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":"D","estado":"Pendiente","prestamista":22},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"}]},"duration":355,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:53:24
28601	9d6901fe-46ff-4854-a1d2-29db556b031b	9d6901fe-7bc1-4012-9192-88ca9722112e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":36,"hostname":"EderCortes"}	2024-11-04 13:01:45
28602	9d6901fe-78c2-4824-8fc1-1779adeeaadd	9d6901fe-7bc1-4012-9192-88ca9722112e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":37,"hostname":"EderCortes"}	2024-11-04 13:01:45
28603	9d6901fe-7a2b-44bf-9f37-3223bbbb82c2	9d6901fe-7bc1-4012-9192-88ca9722112e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":568,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:01:45
40139	9d6cc120-d8b4-41d7-875a-e1a8eab97d7c	9d6cc120-d97e-4cc2-a9ea-7edd729c502e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":207,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:43:41
41716	9d6ccef3-acb9-4d99-b4ac-4c15ba5b561c	9d6ccef3-d3f2-43ca-ae43-ca385422b0e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 10:22:21
41717	9d6ccef3-cbfd-44f3-8b7e-3b5df586f266	9d6ccef3-d3f2-43ca-ae43-ca385422b0e5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"52.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:22:21
41718	9d6ccef3-cc74-451d-a987-b54ae01fc8f4	9d6ccef3-d3f2-43ca-ae43-ca385422b0e5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:22:21
41719	9d6ccef3-d21a-4793-a1f2-4bcf01eb7684	9d6ccef3-d3f2-43ca-ae43-ca385422b0e5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 10:22:21
28605	9d6901ff-7e95-46b5-a878-3364a170c4b8	9d6901ff-8b5e-49bb-bc27-cd340c943bcd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"163.31","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ea98cc4c4cadd55a94c41ae6bc9834a5","hostname":"EderCortes"}	2024-11-04 13:01:46
28606	9d6901ff-83dd-4694-9cdf-d5fc5342e70f	9d6901ff-8b5e-49bb-bc27-cd340c943bcd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":297,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:01:46
28607	9d6901ff-8432-4064-8816-d8700eb40678	9d6901ff-8b5e-49bb-bc27-cd340c943bcd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:01:46
28608	9d6901ff-8991-4bb8-b785-08fcd06bb4be	9d6901ff-8b5e-49bb-bc27-cd340c943bcd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":38,"hostname":"EderCortes"}	2024-11-04 13:01:46
28609	9d6901ff-8a0c-4814-a178-50957b297f9e	9d6901ff-8b5e-49bb-bc27-cd340c943bcd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Pendiente","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"412000","loans_pago_interes":"103000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":593,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:01:46
41720	9d6ccef3-d28e-4d3f-a261-352b45401e8e	9d6ccef3-d3f2-43ca-ae43-ca385422b0e5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":441,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:22:21
41830	9d6ccfce-e8fa-46d4-bf60-1a28a7741cd2	9d6ccfce-ea68-4d15-91e6-294e894ee2da	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":414,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:24:44
41721	9d6ccef4-68c7-4456-b57a-27e41017bb75	9d6ccef4-861e-447a-ba2f-6710e94e1e56	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 10:22:21
41722	9d6ccef4-80d1-4691-9d23-48cf5626946e	9d6ccef4-861e-447a-ba2f-6710e94e1e56	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"46.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:22:21
41723	9d6ccef4-848d-4131-97a4-2dfb42e936e2	9d6ccef4-861e-447a-ba2f-6710e94e1e56	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 10:22:21
41724	9d6ccef4-84eb-4d48-9cee-4619c56c0e2d	9d6ccef4-861e-447a-ba2f-6710e94e1e56	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":427,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:22:21
41831	9d6ccfcf-48d8-4a4a-86a2-9695b25edc56	9d6ccfcf-939e-498f-8180-8507430a2896	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:24:44
41832	9d6ccfcf-8cc8-48e7-8af6-eff456ff5092	9d6ccfcf-939e-498f-8180-8507430a2896	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"155.41","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:24:45
41772	9d6ccf5b-c499-4421-b632-a5d362886f04	9d6ccf5c-109b-4338-9ff1-eacf22169b90	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:23:29
41773	9d6ccf5c-0ecd-4ab7-8590-36ff52fa1125	9d6ccf5c-109b-4338-9ff1-eacf22169b90	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:23:29
41774	9d6ccf5c-0f8b-4057-a52d-5bb8d603109c	9d6ccf5c-109b-4338-9ff1-eacf22169b90	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":462,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:23:29
41833	9d6ccfcf-91c3-4f68-b743-19fa96b0be96	9d6ccfcf-939e-498f-8180-8507430a2896	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:24:45
41834	9d6ccfcf-9246-4e40-b281-2898abfc77c5	9d6ccfcf-939e-498f-8180-8507430a2896	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":407,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:24:45
41775	9d6ccf5e-3476-4ecd-a766-1adda8db4f5f	9d6ccf5e-58a5-4e13-ad08-2a944ef27945	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:23:30
41776	9d6ccf5e-5057-41aa-9b79-e41f8e014c08	9d6ccf5e-58a5-4e13-ad08-2a944ef27945	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:23:30
41777	9d6ccf5e-50d1-4eed-b938-ebcaa7e60906	9d6ccf5e-58a5-4e13-ad08-2a944ef27945	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:23:30
41778	9d6ccf5e-56f1-476a-ad10-47f6360197c2	9d6ccf5e-58a5-4e13-ad08-2a944ef27945	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:23:30
41779	9d6ccf5e-575f-44c7-ae2d-b7e6b0db93fb	9d6ccf5e-58a5-4e13-ad08-2a944ef27945	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":419,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:23:30
41780	9d6ccf5e-b8d6-4376-9e47-5695370ecbbe	9d6ccf5f-0ada-4d2a-94c3-211bd096b9ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:23:31
41781	9d6ccf5f-03cd-4f68-be90-fb959811e445	9d6ccf5f-0ada-4d2a-94c3-211bd096b9ee	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"172.39","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:23:31
41782	9d6ccf5f-0940-47bd-b71c-ec4219cbfa3f	9d6ccf5f-0ada-4d2a-94c3-211bd096b9ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:23:31
41783	9d6ccf5f-09ac-41d6-866e-c4ae0e2dbc08	9d6ccf5f-0ada-4d2a-94c3-211bd096b9ee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":433,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:23:31
42011	9d6cd38e-ce9d-44ac-919f-1a721cb0c066	9d6cd38e-f1d7-4ccc-ba21-fa220fc713fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:35:13
42012	9d6cd38e-ef76-4ae9-a280-b46a8b3e91d2	9d6cd38e-f1d7-4ccc-ba21-fa220fc713fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:35:13
42013	9d6cd38e-f076-45f9-9745-6b2917c404d6	9d6cd38e-f1d7-4ccc-ba21-fa220fc713fd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":306,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:35:13
42014	9d6cd390-f38c-4f8b-b424-1fd7ce265b50	9d6cd391-59e7-471f-b8e5-68279129875f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:35:15
42015	9d6cd391-477c-450e-85b3-ba58d968e2d3	9d6cd391-59e7-471f-b8e5-68279129875f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"177.15","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:35:15
42016	9d6cd391-4813-47a5-8d29-b6cca9b8c59f	9d6cd391-59e7-471f-b8e5-68279129875f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:35:15
42017	9d6cd391-51a9-45fe-a855-079138eddc5d	9d6cd391-59e7-471f-b8e5-68279129875f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:35:15
42018	9d6cd391-5266-44b1-82a7-bea266b21803	9d6cd391-59e7-471f-b8e5-68279129875f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":472,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:35:15
40503	9d6cc3f1-e4c5-45f2-b41b-9a456ee51825	9d6cc3f1-e772-4450-872c-f10ce65b488f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1820}	2024-11-06 09:51:34
42019	9d6cd391-c794-48e3-a555-800e30572bae	9d6cd392-0b04-4c1f-a220-47ee0c9b7127	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:35:15
39135	9d6bccc3-b0ba-4923-804f-766199083703	9d6bccc3-d13d-48c8-9797-aa1e3764fe3b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 22:20:24
39136	9d6bccc3-cf48-4c1d-add0-d91592327246	9d6bccc3-d13d-48c8-9797-aa1e3764fe3b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 22:20:24
39137	9d6bccc3-cffa-4e4b-9253-1c349a468b0d	9d6bccc3-d13d-48c8-9797-aa1e3764fe3b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":248,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:20:24
42020	9d6cd392-056f-49ea-b3bb-efdf63bf594b	9d6cd392-0b04-4c1f-a220-47ee0c9b7127	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"146.68","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:35:15
42021	9d6cd392-0993-4221-90eb-41458ee5d1aa	9d6cd392-0b04-4c1f-a220-47ee0c9b7127	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:35:15
42022	9d6cd392-09f9-42a0-ac5d-c39997d5b584	9d6cd392-0b04-4c1f-a220-47ee0c9b7127	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":420,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:35:15
39138	9d6bccc4-3e68-49a2-be3c-95c8e6c4c4d8	9d6bccc4-8168-476a-a0a6-1f0cb87cceae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 22:20:24
39139	9d6bccc4-7c4d-4e13-b739-0555ecb5e96b	9d6bccc4-8168-476a-a0a6-1f0cb87cceae	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"140.32","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 22:20:24
39140	9d6bccc4-8005-4ad6-911b-e5e2f7086320	9d6bccc4-8168-476a-a0a6-1f0cb87cceae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 22:20:24
39141	9d6bccc4-8072-4754-9fdb-69a1faeb7f0e	9d6bccc4-8168-476a-a0a6-1f0cb87cceae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":341,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:20:24
39142	9d6bccc4-d9fc-441e-aa91-b4c428d0472a	9d6bccc4-fa88-4f98-9c9f-307857f018f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 22:20:25
39143	9d6bccc4-f46b-4e14-b914-97ee1f850886	9d6bccc4-fa88-4f98-9c9f-307857f018f6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.92","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:20:25
39144	9d6bccc4-f4b9-460f-be1f-922a053091c7	9d6bccc4-fa88-4f98-9c9f-307857f018f6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:20:25
39145	9d6bccc4-f916-42de-a647-c12eb3d4ff27	9d6bccc4-fa88-4f98-9c9f-307857f018f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 22:20:25
39146	9d6bccc4-f97c-488a-b0c1-f17a276028d6	9d6bccc4-fa88-4f98-9c9f-307857f018f6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":294,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:20:25
39147	9d6bccc5-42fa-4f2c-8285-598d0724b550	9d6bccc5-8d4c-46ac-b298-03d1dc00a9a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 22:20:25
39148	9d6bccc5-8775-4b2f-b117-a4357014f882	9d6bccc5-8d4c-46ac-b298-03d1dc00a9a5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"152.07","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:20:25
39149	9d6bccc5-87f5-41bd-939e-15e3dcd04adf	9d6bccc5-8d4c-46ac-b298-03d1dc00a9a5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:20:25
39150	9d6bccc5-8bd5-4da0-a2ac-e994138e2b70	9d6bccc5-8d4c-46ac-b298-03d1dc00a9a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 22:20:25
39151	9d6bccc5-8c29-40e2-8892-8b4a5171f76c	9d6bccc5-8d4c-46ac-b298-03d1dc00a9a5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:20:25
39152	9d6bccc7-2b95-4cdf-99ff-28cbe8c7d4e3	9d6bccc7-a0d6-4384-bbee-d3ec1b52db52	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 22:20:26
39153	9d6bccc7-9af8-4af1-babf-eba9503f858d	9d6bccc7-a0d6-4384-bbee-d3ec1b52db52	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"153.66","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 22:20:26
39154	9d6bccc7-9b57-4938-a1c7-09a8be524664	9d6bccc7-a0d6-4384-bbee-d3ec1b52db52	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 22:20:26
39155	9d6bccc7-9f89-40fd-a407-4d0ae0539c07	9d6bccc7-a0d6-4384-bbee-d3ec1b52db52	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 22:20:26
39156	9d6bccc7-9fd4-4a13-bccf-40505722ecd1	9d6bccc7-a0d6-4384-bbee-d3ec1b52db52	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":653,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:20:26
40418	9d6cc32b-e67a-4efb-a3b0-c9e891af087d	9d6cc32b-e94e-403b-b572-7995461a42d6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1810}	2024-11-06 09:49:24
39157	9d6bccc7-ea8f-4258-819f-d79beba1145d	9d6bccc7-efdb-4e0b-973b-c18425257240	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":160,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:20:27
39158	9d6bccc8-a2b6-412e-8ad9-af1e3f83dbf3	9d6bccc8-c014-482d-aecd-0d5e16b461fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 22:20:27
39159	9d6bccc8-bb1f-4da3-9b97-72d9bab8a502	9d6bccc8-c014-482d-aecd-0d5e16b461fc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"45.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 22:20:27
39160	9d6bccc8-be96-40f4-9a2e-b32604aae777	9d6bccc8-c014-482d-aecd-0d5e16b461fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 22:20:27
39161	9d6bccc8-bf01-4e95-994e-167be8908a7a	9d6bccc8-c014-482d-aecd-0d5e16b461fc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":229,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:20:27
36201	9d6b3366-f9cd-43be-94d7-a960009ba580	9d6b3367-1ba9-4d26-95d1-5a9df2051ffb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 15:11:34
36202	9d6b3367-1a11-4e4f-88db-89103b9b6750	9d6b3367-1ba9-4d26-95d1-5a9df2051ffb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 15:11:34
36203	9d6b3367-1aa0-4efc-999f-96851efd0f11	9d6b3367-1ba9-4d26-95d1-5a9df2051ffb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":273,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:11:34
36204	9d6b3367-8427-4ab2-96c3-4941a3d3a0ae	9d6b3367-d4d0-45d4-ac49-50cc7452d64a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 15:11:34
36205	9d6b3367-cab4-4901-bd3c-3ff7d41c7e3d	9d6b3367-d4d0-45d4-ac49-50cc7452d64a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"160.62","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:11:35
36206	9d6b3367-d1f3-412a-8bec-c16de972e6b5	9d6b3367-d4d0-45d4-ac49-50cc7452d64a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 15:11:35
36207	9d6b3367-d372-4793-b9af-3bbe0b73c87a	9d6b3367-d4d0-45d4-ac49-50cc7452d64a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":392,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:11:35
39162	9d6bcccd-a99e-443e-9bee-4b685c07f318	9d6bcccd-ad0e-4b6f-a123-ba11ff19bf2d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":165,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:20:30
36208	9d6b3368-688e-4527-8e1e-36008da6e686	9d6b3368-94eb-45e5-a86a-9cc40382c054	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 15:11:35
36209	9d6b3368-8e04-401d-8cc8-143fd9844c38	9d6b3368-94eb-45e5-a86a-9cc40382c054	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:11:35
36210	9d6b3368-8e60-4c3b-9174-9105c69d59bb	9d6b3368-94eb-45e5-a86a-9cc40382c054	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:11:35
36211	9d6b3368-9392-4e14-ac44-782542458b4e	9d6b3368-94eb-45e5-a86a-9cc40382c054	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:11:35
36212	9d6b3368-93e0-4d24-8d50-b0a801de8da1	9d6b3368-94eb-45e5-a86a-9cc40382c054	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":474,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:11:35
39163	9d6bccce-62f2-4243-8129-9ecd667f22fc	9d6bccce-ab1d-473f-8ddb-48007ce4337c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 22:20:31
39164	9d6bccce-a64e-46bd-957a-5df4293bf500	9d6bccce-ab1d-473f-8ddb-48007ce4337c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" where \\"l\\".\\"user_cobrador\\" = 14 order by \\"l\\".\\"id\\" desc","time":"156.19","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"9c165f2fbf7ccf3d02848123be5b6d04","hostname":"EderCortes"}	2024-11-05 22:20:31
39165	9d6bccce-a944-4592-8f6e-a62b5b472c00	9d6bccce-ab1d-473f-8ddb-48007ce4337c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-05 22:20:31
39166	9d6bccce-a9e1-45fb-a683-764e0a013e19	9d6bccce-ab1d-473f-8ddb-48007ce4337c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":14,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:20:31
36213	9d6b3368-dedf-4e7e-a7d5-dc516ac87759	9d6b3368-fd9f-4f95-93c7-80048ad8726f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:11:35
36214	9d6b3368-f7f6-4da5-99b9-a850aa86c083	9d6b3368-fd9f-4f95-93c7-80048ad8726f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:11:35
36215	9d6b3368-f857-48a3-93a1-bf36c1d47e00	9d6b3368-fd9f-4f95-93c7-80048ad8726f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:11:35
36216	9d6b3368-fc3a-487d-a45d-22c9b061e501	9d6b3368-fd9f-4f95-93c7-80048ad8726f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:11:35
36217	9d6b3368-fc8b-4a9f-bc18-733764eac9ac	9d6b3368-fd9f-4f95-93c7-80048ad8726f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:11:35
39167	9d6bccd1-52a3-4e58-b315-e25a82191627	9d6bccd1-55b8-4b45-ad0e-a022d07e0a06	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":187,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:20:33
36218	9d6b336a-39a7-41cf-9406-ec7cd396d79e	9d6b336a-60c6-4c34-bb7e-89ccb107826b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:11:36
36219	9d6b336a-5821-432c-a4e4-4e4feebc409a	9d6b336a-60c6-4c34-bb7e-89ccb107826b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"47.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:11:36
36220	9d6b336a-589c-4df7-9647-10ae235c2567	9d6b336a-60c6-4c34-bb7e-89ccb107826b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:11:36
36221	9d6b336a-5ede-4b84-b8b8-306e813c6b6b	9d6b336a-60c6-4c34-bb7e-89ccb107826b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:11:36
36222	9d6b336a-5f57-4298-a9bc-fa7877f99bc1	9d6b336a-60c6-4c34-bb7e-89ccb107826b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":271,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:11:36
39169	9d6bccd2-098d-46b3-8d62-d8aebdca2ef7	9d6bccd2-11e1-46db-a4c4-2f584608863d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-05 22:20:33
39170	9d6bccd2-1031-4f70-810d-cdb2ad548300	9d6bccd2-11e1-46db-a4c4-2f584608863d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-05 22:20:33
39171	9d6bccd2-10cc-4733-9500-98d44c38429c	9d6bccd2-11e1-46db-a4c4-2f584608863d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"46","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":500,"response":{"message":"Undefined array key \\"cobrador\\"","exception":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255,"function":"handleError","class":"Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83,"function":"Illuminate\\\\Foundation\\\\Bootstrap\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"listPrecautions","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":175,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:20:33
39092	9d6bcbba-ca47-4e31-ab35-a1adc009e1a6	9d6bcbba-cd40-4939-a7b8-c4d9c0af54e8	ae2a356f0e28ceebd439f549153d9ec1	f	exception	{"class":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83,"message":"Undefined array key \\"cobrador\\"","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"74":"","75":"","76":"    }","77":"","78":"    public function listPrecautions(Request $request) {","79":"        $fechaActual = Carbon::now();","80":"        $formatDate = $fechaActual->format( 'd-m-Y');","81":"","82":"","83":"        $cobrador = $request->all()['cobrador'];","84":"        $estado = $request->all()['estado'];","85":"        $frecuencia = $request->all()['frecuencia'];","86":"        $prestamista = $request->all()['prestamista'];","87":"","88":"","89":"        $data = DB::table('loans as l')","90":"            ->select(DB::raw(\\"","91":"        EXTRACT(DAY FROM (","92":"            CASE","93":"                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'"},"hostname":"EderCortes","occurrences":7}	2024-11-05 22:17:30
29934	9d692c26-d5a7-4558-a10e-4c9bfdec7ff9	9d692c26-f604-41c6-95cd-36bc629257d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-04 14:59:38
29935	9d692c26-f44f-43a2-9f47-26cacd39da69	9d692c26-f604-41c6-95cd-36bc629257d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-11-04 14:59:38
29936	9d692c26-f4fe-4807-acbe-04ab5a8947ea	9d692c26-f604-41c6-95cd-36bc629257d5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":262,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:59:38
29937	9d692c27-66f6-4a26-9239-c548d77c3f25	9d692c27-87ce-4b84-9e12-a5ddbd860619	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-11-04 14:59:39
29938	9d692c27-7d60-4a07-9fd4-2e1e3918070e	9d692c27-87ce-4b84-9e12-a5ddbd860619	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"42.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 14:59:39
29939	9d692c27-81bc-43a3-a064-1b2783ab7b0c	9d692c27-87ce-4b84-9e12-a5ddbd860619	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"1.83","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 14:59:39
29940	9d692c27-81f1-474d-8ac1-79dd0697f5b7	9d692c27-87ce-4b84-9e12-a5ddbd860619	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 14:59:39
29941	9d692c27-8654-4d66-a486-7dc7872b499c	9d692c27-87ce-4b84-9e12-a5ddbd860619	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-11-04 14:59:39
29942	9d692c27-86e0-48fc-b1ce-3b3b97b68bea	9d692c27-87ce-4b84-9e12-a5ddbd860619	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":278,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:59:39
30569	9d693ff4-fa34-4cfd-94df-75fc02cb2768	9d693ff4-fb6d-48b1-802f-7ba7c83819bd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/updateUser","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@updateUser","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"547","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","profile_code":1,"user_age":"29","user_alias":"eder.cortes","email_verified_at":null,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:47:38.000000Z","deleted_at":null},"session":[],"response_status":200,"response":{"response":"El registro fue actualizado exitosamente"},"duration":262,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:55:01
31310	9d6949fb-5d76-4281-8f56-18fbb22dd8b6	9d6949fb-993c-4c5f-a05f-26ef8c2e004f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 16:23:03
31311	9d6949fb-8818-44e1-8dd6-7604ea32a2f2	9d6949fb-993c-4c5f-a05f-26ef8c2e004f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"85.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 16:23:03
31312	9d6949fb-9641-485f-b8e6-69d39bf1a7eb	9d6949fb-993c-4c5f-a05f-26ef8c2e004f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 16:23:03
31313	9d6949fb-9795-47b1-b732-b91b0b301e25	9d6949fb-993c-4c5f-a05f-26ef8c2e004f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abas\\u00bb\\nLINE 1: select * from \\"item_loans\\".* as \\"u.user_alias\\" inner join \\"u...\\n                                     ^ (Connection: pgsql, SQL: select * from \\"item_loans\\".* as \\"u.user_alias\\" inner join \\"users\\" as \\"u\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"u\\".\\"id\\" where \\"loans_codigo\\" = 92 order by \\"item_loans\\".\\"id\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":305,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":556,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:23:03
35018	9d69c152-c046-43c8-ae3d-0f2a6b95c143	9d69c152-edd9-4c8a-a712-bfbc269dc2ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 21:56:45
35019	9d69c152-e59b-4aaa-843d-f121bd66a48d	9d69c152-edd9-4c8a-a712-bfbc269dc2ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"64.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 21:56:45
35020	9d69c152-eb9b-4e0e-913f-3a9f5cd6d41a	9d69c152-edd9-4c8a-a712-bfbc269dc2ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 21:56:45
35021	9d69c152-ec6d-4043-8d6e-465c6f1f97fd	9d69c152-edd9-4c8a-a712-bfbc269dc2ca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":430,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:56:45
41900	9d6cd0f8-f9dd-48d2-bf7b-866c1ab5e344	9d6cd0f8-fd76-43ea-88ee-359bc2dbad3a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1942}	2024-11-06 10:28:00
35022	9d69c153-8773-491d-8cb7-4ba36febe3a4	9d69c154-0c03-4022-a0f7-65ef95e1150e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 21:56:46
35023	9d69c154-01c3-4a8d-a556-107f7852c606	9d69c154-0c03-4022-a0f7-65ef95e1150e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"107.25","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:56:46
35024	9d69c154-024c-45f2-9d48-b77cddc49c77	9d69c154-0c03-4022-a0f7-65ef95e1150e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:56:46
35025	9d69c154-09fc-4651-af66-cdef27685d0a	9d69c154-0c03-4022-a0f7-65ef95e1150e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 21:56:46
35026	9d69c154-0a89-4808-b624-73734fa13421	9d69c154-0c03-4022-a0f7-65ef95e1150e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":714,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:56:46
35027	9d69c155-2f81-4a33-902f-0be9078dc57d	9d69c155-81cb-458d-90a1-d2f7df54d5a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 21:56:47
35028	9d69c155-79df-4686-8769-70da3405b5b3	9d69c155-81cb-458d-90a1-d2f7df54d5a5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"157.93","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:56:47
35029	9d69c155-7a69-4b51-b6b0-86be71bcf186	9d69c155-81cb-458d-90a1-d2f7df54d5a5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:56:47
35030	9d69c155-7fe0-4813-8de5-1e1fb68bc339	9d69c155-81cb-458d-90a1-d2f7df54d5a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 21:56:47
35031	9d69c155-8065-46f4-ad26-0e83a9d31b81	9d69c155-81cb-458d-90a1-d2f7df54d5a5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":738,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:56:47
36339	9d6b38d0-b62c-4627-b04e-2162d1caa163	9d6b38d1-06fb-4e67-b453-4f1872be1ec9	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 15:26:42
36340	9d6b38d1-04a1-4133-9f6e-329fb20a0fe3	9d6b38d1-06fb-4e67-b453-4f1872be1ec9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:26:42
36341	9d6b38d1-05a3-4315-9a59-9b019658a054	9d6b38d1-06fb-4e67-b453-4f1872be1ec9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":452,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:26:42
36342	9d6b38d1-7ab7-4225-983c-dea83a2d9c7d	9d6b38d1-9b13-4a24-9aa0-787df9804cde	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:26:43
36343	9d6b38d1-9580-494b-8d2f-076b0be40688	9d6b38d1-9b13-4a24-9aa0-787df9804cde	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"50.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:26:43
36344	9d6b38d1-99a1-4a52-b95b-c2f5ea742086	9d6b38d1-9b13-4a24-9aa0-787df9804cde	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:26:43
36345	9d6b38d1-9a0f-46cd-b431-97f4a0192b42	9d6b38d1-9b13-4a24-9aa0-787df9804cde	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":312,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:26:43
36346	9d6b38d1-f406-40d6-9589-f5585b656093	9d6b38d2-1880-4e1d-a010-2e2728ac08b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:26:43
36347	9d6b38d2-1344-4303-8865-7cd4d0d94ceb	9d6b38d2-1880-4e1d-a010-2e2728ac08b3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"51.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:26:43
36348	9d6b38d2-139f-4f66-9e3d-fd34d424b23c	9d6b38d2-1880-4e1d-a010-2e2728ac08b3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:26:43
36349	9d6b38d2-1739-4828-9e2e-97c182340be6	9d6b38d2-1880-4e1d-a010-2e2728ac08b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:26:43
36350	9d6b38d2-177c-47d8-bbf8-bcbfb435d034	9d6b38d2-1880-4e1d-a010-2e2728ac08b3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":305,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:26:43
36351	9d6b38d2-6eeb-4824-b8f6-aba6508a1f2a	9d6b38d2-b8ff-476a-9b01-e19c37f09c0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:26:43
36352	9d6b38d2-b38a-41ed-bbc7-6a5952b38824	9d6b38d2-b8ff-476a-9b01-e19c37f09c0d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"152.83","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:26:43
36353	9d6b38d2-b3f4-48f4-9124-cdbbf4c0b442	9d6b38d2-b8ff-476a-9b01-e19c37f09c0d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:26:43
36354	9d6b38d2-b7c8-4ff6-9abc-5f488aad34ae	9d6b38d2-b8ff-476a-9b01-e19c37f09c0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:26:43
36355	9d6b38d2-b809-4387-86f4-aee84a5baa51	9d6b38d2-b8ff-476a-9b01-e19c37f09c0d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":397,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:26:43
36356	9d6b38d3-f1b9-43a6-a981-bdc52073e677	9d6b38d4-1101-47e9-8150-ff64ed635646	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:26:44
36357	9d6b38d4-0bc4-43ce-8a71-f4ec51988b1f	9d6b38d4-1101-47e9-8150-ff64ed635646	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:26:44
36358	9d6b38d4-0c0f-4bec-af5b-73afa091c2ae	9d6b38d4-1101-47e9-8150-ff64ed635646	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:26:44
36359	9d6b38d4-0faf-47d0-9376-2c2fbcdff76e	9d6b38d4-1101-47e9-8150-ff64ed635646	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:26:44
36360	9d6b38d4-0ff4-4c9d-b715-3142e1112017	9d6b38d4-1101-47e9-8150-ff64ed635646	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:26:44
42437	9d6cde3a-8ee4-4735-9316-7ff5b384dbae	9d6cde3a-9244-4efa-8ab6-aecb4ae5a5ba	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1960}	2024-11-06 11:05:04
36656	9d6b3df3-1ed7-4e81-9cd0-d5454f2ee0e7	9d6b3df3-41b4-4274-9f5d-8b87f8baf092	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 15:41:04
36657	9d6b3df3-3fef-4e50-a937-5e6d07fd9bf8	9d6b3df3-41b4-4274-9f5d-8b87f8baf092	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 15:41:04
36658	9d6b3df3-4095-4537-830e-bb086aec5f1d	9d6b3df3-41b4-4274-9f5d-8b87f8baf092	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":300,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:41:04
42368	9d6cdd9e-617c-400a-95e7-d3d0bb8ea47d	9d6cdd9e-7d12-4269-bc64-cd4c0badf9af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:03:21
36659	9d6b3df3-9d4c-44bc-a992-9533c9f89491	9d6b3df3-e58b-4a13-a622-888b8e3c43b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 15:41:04
36660	9d6b3df3-e148-48ab-a7e4-f4befaafb47d	9d6b3df3-e58b-4a13-a622-888b8e3c43b3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"156.61","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:41:04
36661	9d6b3df3-e42f-4e2c-9646-95804d9ccdc3	9d6b3df3-e58b-4a13-a622-888b8e3c43b3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 15:41:04
36662	9d6b3df3-e499-4db1-b452-d5b8a2a9ee25	9d6b3df3-e58b-4a13-a622-888b8e3c43b3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":351,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:41:04
42369	9d6cdd9e-7b77-4728-bd39-34b0931be830	9d6cdd9e-7d12-4269-bc64-cd4c0badf9af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:03:21
42370	9d6cdd9e-7c15-4dec-9003-36facf6694ab	9d6cdd9e-7d12-4269-bc64-cd4c0badf9af	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:03:21
36663	9d6b3df4-3ec2-4ecf-921a-711ec5cb0c08	9d6b3df4-614c-46b2-a723-5331ca39d365	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 15:41:04
36664	9d6b3df4-5c16-4360-9af9-b064bc6c30ea	9d6b3df4-614c-46b2-a723-5331ca39d365	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:41:04
36665	9d6b3df4-5c6b-4008-8789-850fda7f0085	9d6b3df4-614c-46b2-a723-5331ca39d365	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:41:04
36666	9d6b3df4-5ffe-4526-82c9-40c1a30b366a	9d6b3df4-614c-46b2-a723-5331ca39d365	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 15:41:04
36667	9d6b3df4-6045-4708-ab2f-53496e896372	9d6b3df4-614c-46b2-a723-5331ca39d365	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":304,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:41:04
42371	9d6cdda0-1ceb-4c35-b771-c19e4b9643e7	9d6cdda0-3c16-477c-a0be-bed04c1fb89a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:03:22
42372	9d6cdda0-36da-4a9b-a2f7-71d9392e6438	9d6cdda0-3c16-477c-a0be-bed04c1fb89a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:03:22
42373	9d6cdda0-3740-44e3-abeb-1875f5154a1d	9d6cdda0-3c16-477c-a0be-bed04c1fb89a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:03:22
42374	9d6cdda0-3aab-4adb-9b59-bbe67a2acee4	9d6cdda0-3c16-477c-a0be-bed04c1fb89a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 11:03:22
42375	9d6cdda0-3af5-4920-a7e4-7fe3b04e9895	9d6cdda0-3c16-477c-a0be-bed04c1fb89a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":276,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:03:22
36668	9d6b3df4-adfc-4c5c-b231-6330ead4de8f	9d6b3df4-cce0-42c1-be8e-0f53b3a29501	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 15:41:05
36669	9d6b3df4-c74f-4e5c-9f8c-4a27436459c4	9d6b3df4-cce0-42c1-be8e-0f53b3a29501	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:41:05
36670	9d6b3df4-c7a9-4d97-9022-ac704ae1089e	9d6b3df4-cce0-42c1-be8e-0f53b3a29501	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:41:05
36671	9d6b3df4-cb89-449d-9f1a-81745c698cbc	9d6b3df4-cce0-42c1-be8e-0f53b3a29501	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 15:41:05
36672	9d6b3df4-cbdb-484d-80fe-273418caa60a	9d6b3df4-cce0-42c1-be8e-0f53b3a29501	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:41:05
42376	9d6cdda0-828d-4162-a5dd-b4df57139001	9d6cdda0-c887-4357-9102-29ba7cdc6d48	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 11:03:23
42377	9d6cdda0-c3d9-4945-ab47-2fb0c647e5d5	9d6cdda0-c887-4357-9102-29ba7cdc6d48	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"153.64","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:03:23
42378	9d6cdda0-c732-4037-9ed5-b5c00fe4df14	9d6cdda0-c887-4357-9102-29ba7cdc6d48	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 11:03:23
42379	9d6cdda0-c77b-44a3-933c-8205ce35bc4d	9d6cdda0-c887-4357-9102-29ba7cdc6d48	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:03:23
36673	9d6b3df6-95ee-43ef-801c-ad2729652120	9d6b3df6-dd8f-4797-8830-3c5f73a9ffdd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 15:41:06
36674	9d6b3df6-d778-4460-a514-a2115d03da1c	9d6b3df6-dd8f-4797-8830-3c5f73a9ffdd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"145.63","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:41:06
36675	9d6b3df6-d7c4-4d40-a17c-9db3b5c06c61	9d6b3df6-dd8f-4797-8830-3c5f73a9ffdd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:41:06
36676	9d6b3df6-dbe4-4497-aa7d-d39654a0f040	9d6b3df6-dd8f-4797-8830-3c5f73a9ffdd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-05 15:41:06
36677	9d6b3df6-dc5a-476f-900c-c9eef555ed5a	9d6b3df6-dd8f-4797-8830-3c5f73a9ffdd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":437,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:41:06
42380	9d6cdda8-a88c-43e3-8995-f73839955071	9d6cdda8-ab90-4edc-a4ae-58f8f6b7d73a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":160,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:03:28
42381	9d6cdda9-5e31-4492-b7aa-0341ae4d90d8	9d6cdda9-bf94-4626-b171-b4724411f344	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 11:03:28
42382	9d6cdda9-a6ae-415c-a00a-77416a29c7b2	9d6cdda9-bf94-4626-b171-b4724411f344	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"153.98","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 11:03:29
42383	9d6cdda9-a727-4fac-bf27-93269da32864	9d6cdda9-bf94-4626-b171-b4724411f344	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 11:03:29
42384	9d6cdda9-be38-4dd7-bab5-e7af9f12dcf1	9d6cdda9-bf94-4626-b171-b4724411f344	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 11:03:29
42385	9d6cdda9-be86-4a02-a0ab-9393d13e903a	9d6cdda9-bf94-4626-b171-b4724411f344	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","profile":1},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":390,"memory":24,"hostname":"EderCortes"}	2024-11-06 11:03:29
42520	9d6cdf09-96aa-4171-8231-a4512da57b40	9d6cdf09-d9ff-430e-b0ba-3e51535f63d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:07:19
42521	9d6cdf09-d861-44f9-b8a9-65145f559467	9d6cdf09-d9ff-430e-b0ba-3e51535f63d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:07:19
42522	9d6cdf09-d910-4ffd-a977-a3cae16a966c	9d6cdf09-d9ff-430e-b0ba-3e51535f63d9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":402,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:07:19
6265	9d5263a9-f817-40da-8ffa-a7947a8ee2cb	9d5263a9-fd1c-4026-b3ff-0068e7331752	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abfrom\\u00bb\\nLINE 14:     from loans l\\n             ^ (Connection: pgsql, SQL: \\n    select l.id,\\n        l.loans_documento,\\n        l.loans_nombre,\\n        l.loans_apellido_uno,\\n        l.loans_fecha,\\n        l.loans_valor_prestado,\\n        l.loans_cuotas,\\n        l.loans_estado,\\n        l.loans_intereses,\\n        ucl.name as cliente,\\n        uco.name as cobrador,\\n        ure.name as recomendador,\\n    from loans l\\n    join users ucl on l.user_customer = ucl.id\\n    join users uco on l.user_cobrador = uco.id\\n    left join users ure on l.user_recomendacion = ure.id\\n)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":318}	2024-10-24 07:10:49
42386	9d6cddb0-438b-441c-ba0b-505dd39bbb2d	9d6cddb0-907a-4ced-98db-e083e79b6966	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 11:03:33
42387	9d6cddb0-8855-45ed-94cc-f9d9f27be8d8	9d6cddb0-907a-4ced-98db-e083e79b6966	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"150.18","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:03:33
42388	9d6cddb0-88e2-4191-b4c5-04fc95c68802	9d6cddb0-907a-4ced-98db-e083e79b6966	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:03:33
42389	9d6cddb0-8eb0-4254-8c3e-d0b1c3ccde8a	9d6cddb0-907a-4ced-98db-e083e79b6966	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 11:03:33
42390	9d6cddb0-8f29-4d4e-aa2d-c710b8c2a25b	9d6cddb0-907a-4ced-98db-e083e79b6966	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":414,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:03:33
42523	9d6cdf0a-3504-4821-8475-f4c85062e351	9d6cdf0a-535f-4625-8e43-4e70efde4367	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:07:20
42524	9d6cdf0a-4e1e-4f79-8234-cb0820000714	9d6cdf0a-535f-4625-8e43-4e70efde4367	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 11:07:20
42525	9d6cdf0a-4e67-4a43-8de9-040f1ad9cbb8	9d6cdf0a-535f-4625-8e43-4e70efde4367	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 11:07:20
42526	9d6cdf0a-5263-47c7-b51a-255a3b9c56e9	9d6cdf0a-535f-4625-8e43-4e70efde4367	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:07:20
42527	9d6cdf0a-52a0-4c67-8732-b9d8154e7505	9d6cdf0a-535f-4625-8e43-4e70efde4367	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:07:20
42391	9d6cddb0-d42d-455a-870c-e9f4e6cc7ba3	9d6cddb0-eda8-4df1-ab83-0f3acbf85742	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 11:03:33
42392	9d6cddb0-e95a-4127-af1e-0ce8022e7f8c	9d6cddb0-eda8-4df1-ab83-0f3acbf85742	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"41.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:03:33
42393	9d6cddb0-ec72-4190-89b9-6b5fd7d7a6fe	9d6cddb0-eda8-4df1-ab83-0f3acbf85742	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 11:03:33
42394	9d6cddb0-ecbb-4b60-aa23-9eca94fe051b	9d6cddb0-eda8-4df1-ab83-0f3acbf85742	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":222,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:03:33
42528	9d6cdf0a-9071-45f6-8e87-6bd416a8561d	9d6cdf0a-d4dc-4914-9476-e303cc773dd1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:07:20
42529	9d6cdf0a-d001-4efa-8f86-5bb16e293c41	9d6cdf0a-d4dc-4914-9476-e303cc773dd1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"143.00","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":286,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-06 11:07:20
42530	9d6cdf0a-d061-4553-96df-2e9999aa45d9	9d6cdf0a-d4dc-4914-9476-e303cc773dd1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-06 11:07:20
42531	9d6cdf0a-d3b4-46e2-83b7-4846c1607462	9d6cdf0a-d4dc-4914-9476-e303cc773dd1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:07:20
42532	9d6cdf0a-d3ff-4393-9704-4bbe1def580a	9d6cdf0a-d4dc-4914-9476-e303cc773dd1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":317,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:07:20
42533	9d6cdf0b-18b7-419f-a41a-3c950096c2b1	9d6cdf0b-3632-46b3-ab34-14492c74dfd3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:07:20
42534	9d6cdf0b-30b4-44f2-9f2a-a7130bda0cba	9d6cdf0b-3632-46b3-ab34-14492c74dfd3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":235,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 11:07:20
42535	9d6cdf0b-312d-4f5b-873a-9a89cebb6e5e	9d6cdf0b-3632-46b3-ab34-14492c74dfd3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-06 11:07:20
42536	9d6cdf0b-34ec-4285-8a7c-bb6a3ce00d52	9d6cdf0b-3632-46b3-ab34-14492c74dfd3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:07:20
42537	9d6cdf0b-3542-4166-98ee-83ede9b69ae1	9d6cdf0b-3632-46b3-ab34-14492c74dfd3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:07:20
42538	9d6cdf0d-af00-4048-9900-782f1f459296	9d6cdf0d-d42a-4e00-8046-8d156b885025	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:07:22
42539	9d6cdf0d-ca37-4589-a984-5ea12b4f0d51	9d6cdf0d-d42a-4e00-8046-8d156b885025	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"49.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:07:22
42540	9d6cdf0d-cac3-4700-8c9e-891fd5505600	9d6cdf0d-d42a-4e00-8046-8d156b885025	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:07:22
42541	9d6cdf0d-d2bc-4121-adc7-c47d04b42d66	9d6cdf0d-d42a-4e00-8046-8d156b885025	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 11:07:22
42542	9d6cdf0d-d322-4490-b01a-c5b08509bcfd	9d6cdf0d-d42a-4e00-8046-8d156b885025	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":329,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:07:22
42543	9d6cdf0e-16c6-4bbd-a4cc-7fd63b94a068	9d6cdf0e-5ce3-4a53-8084-f49ebdd431d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 11:07:22
42544	9d6cdf0e-58b9-413a-8507-790e2508abd8	9d6cdf0e-5ce3-4a53-8084-f49ebdd431d1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"156.51","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:07:22
42545	9d6cdf0e-5bb4-4913-98df-ff9557ecd30c	9d6cdf0e-5ce3-4a53-8084-f49ebdd431d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 11:07:22
42546	9d6cdf0e-5bf9-40ae-bdee-883453ec9146	9d6cdf0e-5ce3-4a53-8084-f49ebdd431d1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":334,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:07:22
42547	9d6cdf11-02d9-44d9-8d91-be36b91d37cf	9d6cdf11-05ec-432d-b791-2d5cb2e7a978	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":172,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:07:24
39645	9d6be078-40e6-4478-a41b-3a63dc292153	9d6be078-6afb-4317-910b-b4bcf623cb88	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 23:15:30
39646	9d6be078-68f5-449d-973c-92eaf6c94b57	9d6be078-6afb-4317-910b-b4bcf623cb88	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 23:15:30
39647	9d6be078-69cc-4417-b1c8-5e78aca220f4	9d6be078-6afb-4317-910b-b4bcf623cb88	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":320,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:15:30
39648	9d6be07a-4339-4664-b8e9-264c8e5b1bda	9d6be07a-8d35-4db4-aaee-02da5b2fdb5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 23:15:31
39649	9d6be07a-8703-44f7-83e6-90f0b464c31c	9d6be07a-8d35-4db4-aaee-02da5b2fdb5c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"153.29","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 23:15:31
39650	9d6be07a-8770-4aad-be4b-da4bcaae70e9	9d6be07a-8d35-4db4-aaee-02da5b2fdb5c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 23:15:31
39651	9d6be07a-8bd5-47ad-b0d4-314a1661ad43	9d6be07a-8d35-4db4-aaee-02da5b2fdb5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 23:15:31
39652	9d6be07a-8c25-4637-bd61-c074d17e680f	9d6be07a-8d35-4db4-aaee-02da5b2fdb5c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":388,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:15:31
40758	9d6cc705-e42d-4357-ab21-590b61f7ae91	9d6cc705-e792-495d-9069-cac0680e46b0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1850}	2024-11-06 10:00:10
42548	9d6cdf11-7566-4809-ba55-59a69d9b0b35	9d6cdf11-78a5-4a0b-9f3f-6fd9fbbde300	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":130,"memory":20,"hostname":"EderCortes"}	2024-11-06 11:07:24
41913	9d6cd0fa-b7d9-4938-aed4-8d48e1b2b690	9d6cd0fa-bac6-4f46-9eee-57a0646003b2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1944}	2024-11-06 10:28:01
42549	9d6cdf11-f757-42a2-a755-53d56a6cb6b1	9d6cdf11-fa6f-403c-8d0a-88f12dbc1bb9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":138,"memory":20,"hostname":"EderCortes"}	2024-11-06 11:07:25
42550	9d6cdf12-4d7a-4282-879a-fe0267b12de1	9d6cdf12-6ac0-4944-8b2b-82effeab4960	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 11:07:25
42551	9d6cdf12-6580-458a-ba1b-14aebf1e5b68	9d6cdf12-6ac0-4944-8b2b-82effeab4960	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"43.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":122,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-06 11:07:25
42552	9d6cdf12-6975-4f69-82d2-1326e72b8df7	9d6cdf12-6ac0-4944-8b2b-82effeab4960	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 11:07:25
42553	9d6cdf12-69bb-4412-82da-0c7be67cd9f4	9d6cdf12-6ac0-4944-8b2b-82effeab4960	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:07:25
42554	9d6cdf12-a72e-4087-a329-117b5f5bfae9	9d6cdf12-aa3e-4b48-bef4-9d1d8103046c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":142,"memory":20,"hostname":"EderCortes"}	2024-11-06 11:07:25
43303	9d6ce5d4-4955-464e-961c-26d4e732a059	9d6ce5d4-4c6a-43f1-b008-74f151542244	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2012}	2024-11-06 11:26:19
42555	9d6cdf12-f7fb-41b1-be35-a29623bf5964	9d6cdf13-3f77-4232-82e2-0be8b49de2d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 11:07:25
42556	9d6cdf13-3a2b-4c08-8132-2905395b24cb	9d6cdf13-3f77-4232-82e2-0be8b49de2d9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"152.40","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":122,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-06 11:07:26
42557	9d6cdf13-3e3e-43a1-ad65-f5ef102714ce	9d6cdf13-3f77-4232-82e2-0be8b49de2d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 11:07:26
42558	9d6cdf13-3e80-44c3-b162-4b2631e372b1	9d6cdf13-3f77-4232-82e2-0be8b49de2d9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":329,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:07:26
42559	9d6cdf13-8061-4736-9afa-13b67dcf2684	9d6cdf13-83bc-45fd-ae35-ce6b6b8dcd0a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":138,"memory":20,"hostname":"EderCortes"}	2024-11-06 11:07:26
42560	9d6cdf14-0345-4ddd-9fab-f9cf77116fd2	9d6cdf14-066d-4de0-ad26-a4513019a8a0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":144,"memory":20,"hostname":"EderCortes"}	2024-11-06 11:07:26
42693	9d6cdff2-9309-499c-b81d-38fe934961b2	9d6cdff2-96ed-49d0-819f-49a8661c2de4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1966}	2024-11-06 11:09:52
42561	9d6cdf14-8020-42b6-8ad9-675b8f47b686	9d6cdf14-9d4b-45a4-b01e-e98fa606db91	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 11:07:26
42562	9d6cdf14-980c-41a3-922d-df93b60a5951	9d6cdf14-9d4b-45a4-b01e-e98fa606db91	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"44.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":122,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-06 11:07:26
42563	9d6cdf14-9c07-4957-85a2-48f69d6cee9c	9d6cdf14-9d4b-45a4-b01e-e98fa606db91	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 11:07:26
42564	9d6cdf14-9c59-40e4-836b-b295e108c11b	9d6cdf14-9d4b-45a4-b01e-e98fa606db91	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":223,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:07:26
42565	9d6cdf14-db47-4550-adef-82bb4bf5cf8b	9d6cdf14-de40-4259-8d97-03d194e1e319	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":146,"memory":20,"hostname":"EderCortes"}	2024-11-06 11:07:27
42566	9d6cdf15-5592-4f03-90e6-4b9aab6a2093	9d6cdf15-9907-4ba7-9c17-e42bf86a1679	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 11:07:27
42567	9d6cdf15-94ed-43dd-b120-fa32cbc93f57	9d6cdf15-9907-4ba7-9c17-e42bf86a1679	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAr%' or \\"users\\".\\"user_document\\"::text like '%MAr%') order by \\"users\\".\\"user_document\\" asc","time":"144.64","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":122,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-06 11:07:27
42568	9d6cdf15-97b2-4391-8f97-3597df02ee66	9d6cdf15-9907-4ba7-9c17-e42bf86a1679	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 11:07:27
42569	9d6cdf15-97fb-44c0-82e1-2b124967421c	9d6cdf15-9907-4ba7-9c17-e42bf86a1679	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAr"},"session":[],"response_status":200,"response":{"data":[]},"duration":312,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:07:27
42570	9d6cdf15-d587-4a97-8027-4e70513bac37	9d6cdf15-d860-4a88-a269-ce99636fcbb1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":138,"memory":20,"hostname":"EderCortes"}	2024-11-06 11:07:27
42957	9d6ce30b-fdb4-491c-8212-ad4969490ac9	9d6ce30c-011d-40a3-a1df-4121696f364c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1972}	2024-11-06 11:18:32
42571	9d6cdf16-579b-4cc2-91fc-60387db2ff48	9d6cdf16-5a93-4daf-b724-83c998242f0d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":153,"memory":20,"hostname":"EderCortes"}	2024-11-06 11:07:28
43017	9d6ce37f-a929-4585-8fc1-e9abd6c44d97	9d6ce37f-ae20-4309-b3f7-0cf09ace1420	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1978}	2024-11-06 11:19:48
42572	9d6cdf16-d6ff-4940-88d8-7e7e53de179f	9d6cdf16-f07d-4c43-bcae-188acebb611d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 11:07:28
31485	9d694c51-6653-4e2e-b425-16d8ac8a3af9	9d694c51-86d5-49cd-aa10-ab881fe81b4c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 16:29:35
31486	9d694c51-8538-4c4a-a857-f92435f89378	9d694c51-86d5-49cd-aa10-ab881fe81b4c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 16:29:35
31487	9d694c51-85d1-4a8a-b8f8-b4dee4573626	9d694c51-86d5-49cd-aa10-ab881fe81b4c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":337,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:29:35
42573	9d6cdf16-ec17-451c-9b57-ce2b252e6cb1	9d6cdf16-f07d-4c43-bcae-188acebb611d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAri%' or \\"users\\".\\"user_document\\"::text like '%MAri%') order by \\"users\\".\\"user_document\\" asc","time":"38.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":122,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-06 11:07:28
42574	9d6cdf16-ef4c-482d-9252-875f21d8671c	9d6cdf16-f07d-4c43-bcae-188acebb611d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 11:07:28
42575	9d6cdf16-ef90-4779-8458-592835a9705a	9d6cdf16-f07d-4c43-bcae-188acebb611d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAri"},"session":[],"response_status":200,"response":{"data":[]},"duration":215,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:07:28
31488	9d694c51-db56-46ad-943a-4de99f9df730	9d694c51-f9d3-43c9-bd3c-4055f088dfbc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 16:29:35
31489	9d694c51-f51e-495d-bf77-27134f5566fe	9d694c51-f9d3-43c9-bd3c-4055f088dfbc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:29:35
31490	9d694c51-f573-4f54-9c84-742d169d4909	9d694c51-f9d3-43c9-bd3c-4055f088dfbc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 16:29:35
31491	9d694c51-f8cf-410e-9fef-49d93ae32990	9d694c51-f9d3-43c9-bd3c-4055f088dfbc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 16:29:35
31492	9d694c51-f912-4a7f-b243-d561177023d4	9d694c51-f9d3-43c9-bd3c-4055f088dfbc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:29:35
42576	9d6cdf17-2eaa-46ff-871f-84b2a8b62769	9d6cdf17-3199-441f-8932-cf6c64f8793a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":145,"memory":20,"hostname":"EderCortes"}	2024-11-06 11:07:28
31493	9d694c52-3b6b-4f3e-862b-353291b9fc40	9d694c52-591b-4737-9fda-dcdd3e72bd58	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 16:29:35
31494	9d694c52-5409-4380-95af-97f0785a13e0	9d694c52-591b-4737-9fda-dcdd3e72bd58	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 16:29:35
31495	9d694c52-545d-46ad-9bfe-31950f565f58	9d694c52-591b-4737-9fda-dcdd3e72bd58	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 16:29:35
31496	9d694c52-57ee-4722-83d3-8ba98d9c5fed	9d694c52-591b-4737-9fda-dcdd3e72bd58	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 16:29:35
31497	9d694c52-5839-4672-94e8-de86afdead9f	9d694c52-591b-4737-9fda-dcdd3e72bd58	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:29:35
42577	9d6cdf17-a505-4f61-bb2b-22ba8d602d58	9d6cdf17-a837-41be-8f3c-d69e375313b8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":129,"memory":20,"hostname":"EderCortes"}	2024-11-06 11:07:28
42578	9d6cdf17-f74b-469e-8413-980175358ca7	9d6cdf18-3cae-4ac6-a2d7-3df3a457caae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 11:07:29
42579	9d6cdf18-38d5-4cf4-940d-d781f28f22ca	9d6cdf18-3cae-4ac6-a2d7-3df3a457caae	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAria%' or \\"users\\".\\"user_document\\"::text like '%MAria%') order by \\"users\\".\\"user_document\\" asc","time":"153.21","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":122,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-06 11:07:29
42580	9d6cdf18-3b8d-4d73-8e68-9e3c0aa8b84b	9d6cdf18-3cae-4ac6-a2d7-3df3a457caae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 11:07:29
42581	9d6cdf18-3bcd-4061-81da-6c7a1fd8f07b	9d6cdf18-3cae-4ac6-a2d7-3df3a457caae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAria"},"session":[],"response_status":200,"response":{"data":[]},"duration":322,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:07:29
6290	9d52641b-314e-48f9-a3cf-d0e5235289b4	9d52641b-34d7-4219-8c88-e2f212027d8e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abfrom\\u00bb\\nLINE 14:     from loans l\\n             ^ (Connection: pgsql, SQL: \\n    select l.id,\\n        l.loans_documento,\\n        l.loans_nombre,\\n        l.loans_apellido_uno,\\n        l.loans_fecha,\\n        l.loans_valor_prestado,\\n        l.loans_cuotas,\\n        l.loans_estado,\\n        l.loans_intereses,\\n        ucl.name as cliente,\\n        uco.name as cobrador,\\n        ure.name as recomendador,\\n    from loans l\\n    join users ucl on l.user_customer = ucl.id\\n    join users uco on l.user_cobrador = uco.id\\n    left join users ure on l.user_recomendacion = ure.id\\n)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":323}	2024-10-24 07:12:03
42924	9d6ce169-dae2-4fb0-822a-c595d9a21853	9d6ce169-f6b4-4767-bada-c0f19949bf22	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:13:58
42925	9d6ce169-f505-4af9-a6c6-909053c5901b	9d6ce169-f6b4-4767-bada-c0f19949bf22	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:13:58
43148	9d6ce51b-c6d8-486e-a749-2034d6a78edc	9d6ce51b-cadd-45dc-8b8c-d85c069f448f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1994}	2024-11-06 11:24:18
6307	9d52643a-21cf-4857-8f33-5d1bf3aacd22	9d52643a-25b3-4847-a873-e2c56889f9fc	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abfrom\\u00bb\\nLINE 14:     from loans l\\n             ^ (Connection: pgsql, SQL: \\n    select l.id,\\n        l.loans_documento,\\n        l.loans_nombre,\\n        l.loans_apellido_uno,\\n        l.loans_fecha,\\n        l.loans_valor_prestado,\\n        l.loans_cuotas,\\n        l.loans_estado,\\n        l.loans_intereses,\\n        ucl.name as cliente,\\n        uco.name as cobrador,\\n        ure.name as recomendador,\\n    from loans l\\n    join users ucl on l.user_customer = ucl.id\\n    join users uco on l.user_cobrador = uco.id\\n    left join users ure on l.user_recomendacion = ure.id\\n)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":326}	2024-10-24 07:12:24
42582	9d6cdf18-76b6-4eed-a086-c32e02369be1	9d6cdf18-795c-439a-9a5a-e20c23ae7a53	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":127,"memory":20,"hostname":"EderCortes"}	2024-11-06 11:07:29
42926	9d6ce169-f5a8-44ae-b21f-7afd411d3500	9d6ce169-f6b4-4767-bada-c0f19949bf22	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":263,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:13:58
42583	9d6cdf18-c30f-45f1-91c9-cf0be8002f34	9d6cdf18-de2c-42cc-aa86-8f1d486b627c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 11:07:29
42584	9d6cdf18-d96e-4435-a330-b4e7682dccb5	9d6cdf18-de2c-42cc-aa86-8f1d486b627c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAria%' or \\"users\\".\\"user_document\\"::text like '%MAria%') order by \\"users\\".\\"user_document\\" asc","time":"42.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":122,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-06 11:07:29
42585	9d6cdf18-dcec-440f-9a6b-d07de406a991	9d6cdf18-de2c-42cc-aa86-8f1d486b627c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 11:07:29
42586	9d6cdf18-dd30-495b-879f-53b1a3aa3eb8	9d6cdf18-de2c-42cc-aa86-8f1d486b627c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"28","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAria"},"session":[],"response_status":200,"response":{"data":[]},"duration":207,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:07:29
42927	9d6ce16b-e2ef-4ef5-ad9a-05015d96cc1c	9d6ce16c-0451-4c63-bd95-e765cc512aad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:13:59
42928	9d6ce16b-fe48-4d26-8d55-fc1bc6100131	9d6ce16c-0451-4c63-bd95-e765cc512aad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:13:59
42929	9d6ce16b-fe94-42d7-9a52-8a79f81ed72d	9d6ce16c-0451-4c63-bd95-e765cc512aad	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:13:59
42930	9d6ce16c-02ff-492c-9faa-df6993835b8b	9d6ce16c-0451-4c63-bd95-e765cc512aad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:13:59
42931	9d6ce16c-0348-4fc6-a375-3979f5b110b0	9d6ce16c-0451-4c63-bd95-e765cc512aad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":447,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:13:59
42587	9d6cdf19-1ab1-4074-8be1-f0e0c717d7ed	9d6cdf19-1d88-42b8-ac51-d4aa20c56d46	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":141,"memory":20,"hostname":"EderCortes"}	2024-11-06 11:07:29
42932	9d6ce16c-45b2-4e6a-8c89-46a5fbd07ed3	9d6ce16c-8610-4f84-aa7a-7f4074e231ad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:13:59
42933	9d6ce16c-81b7-4332-85ab-a7d4e1c2babe	9d6ce16c-8610-4f84-aa7a-7f4074e231ad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"142.35","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:14:00
42934	9d6ce16c-84bf-485e-8b13-cb0e4c4ceb5b	9d6ce16c-8610-4f84-aa7a-7f4074e231ad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:14:00
42935	9d6ce16c-8505-4736-a68a-28f3ff923e6a	9d6ce16c-8610-4f84-aa7a-7f4074e231ad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":317,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:14:00
42588	9d6cdf19-7137-4131-9ee3-b3af1286aa81	9d6cdf19-8bf9-43e4-973c-e23e374d707d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 11:07:30
42589	9d6cdf19-87b2-4607-bd50-5807441c1f48	9d6cdf19-8bf9-43e4-973c-e23e374d707d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAria%' or \\"users\\".\\"user_document\\"::text like '%MAria%') order by \\"users\\".\\"user_document\\" asc","time":"42.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":122,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-06 11:07:30
42590	9d6cdf19-8ad0-4029-88c9-8f39a4d3e2ac	9d6cdf19-8bf9-43e4-973c-e23e374d707d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-06 11:07:30
42591	9d6cdf19-8b16-4a86-8c50-1881f1eca376	9d6cdf19-8bf9-43e4-973c-e23e374d707d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAria"},"session":[],"response_status":200,"response":{"data":[]},"duration":223,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:07:30
42592	9d6cdf19-c9c4-4268-a82f-ebb9d602851c	9d6cdf19-ccae-4df4-8d32-17d58d838b7e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":139,"memory":20,"hostname":"EderCortes"}	2024-11-06 11:07:30
41330	9d6ccc67-0453-4f2f-837a-40c85800a3e1	9d6ccc67-06e9-410e-987d-4321e0772336	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1894}	2024-11-06 10:15:13
42593	9d6cdf1a-1a58-47d0-aa1b-a989f27cf388	9d6cdf1a-33dd-4086-8daa-f4ed542659ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-06 11:07:30
42594	9d6cdf1a-2fbb-40e3-932a-31bebbb95dda	9d6cdf1a-33dd-4086-8daa-f4ed542659ba	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAri%' or \\"users\\".\\"user_document\\"::text like '%MAri%') order by \\"users\\".\\"user_document\\" asc","time":"38.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":122,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-06 11:07:30
42595	9d6cdf1a-329d-4ffc-8420-479f6ab87259	9d6cdf1a-33dd-4086-8daa-f4ed542659ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-06 11:07:30
42596	9d6cdf1a-32e4-406f-aac5-f91e0780bf7d	9d6cdf1a-33dd-4086-8daa-f4ed542659ba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAri"},"session":[],"response_status":200,"response":{"data":[]},"duration":207,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:07:30
42597	9d6cdf1a-6f45-41d6-96be-0ceb3084e52c	9d6cdf1a-71fe-44c7-9244-28e4c09c59e5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":139,"memory":20,"hostname":"EderCortes"}	2024-11-06 11:07:30
42598	9d6cdf1a-f5af-430d-8f7b-d9daece6d4a0	9d6cdf1b-409f-4bf3-bbec-a6de49b97376	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-06 11:07:31
42599	9d6cdf1b-3b10-4583-a015-df93569744e9	9d6cdf1b-409f-4bf3-bbec-a6de49b97376	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MAr%' or \\"users\\".\\"user_document\\"::text like '%MAr%') order by \\"users\\".\\"user_document\\" asc","time":"157.40","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":122,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-06 11:07:31
42600	9d6cdf1b-3f05-4273-a213-d26b7ccf7840	9d6cdf1b-409f-4bf3-bbec-a6de49b97376	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-06 11:07:31
42601	9d6cdf1b-3f63-478d-9dde-384c35553132	9d6cdf1b-409f-4bf3-bbec-a6de49b97376	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MAr"},"session":[],"response_status":200,"response":{"data":[]},"duration":361,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:07:31
42978	9d6ce335-6ac6-4bab-897c-3c3f814ceb6a	9d6ce335-8574-4611-b537-94b88d12801d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 11:18:59
42979	9d6ce335-83b8-4ffc-a0de-40d406ba2044	9d6ce335-8574-4611-b537-94b88d12801d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 11:18:59
42980	9d6ce335-8443-466d-a91d-613fae49ccfc	9d6ce335-8574-4611-b537-94b88d12801d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":219,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:18:59
352	9d4f26bf-fbec-4ef3-9a26-22b1e2777698	9d4f26c0-02be-426e-b376-ce2cad679e01	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":20}	2024-10-22 16:33:00
39891	9d6cbb4c-c4b2-4349-9144-cfd29fbd283c	9d6cbb4c-c7a9-4786-bc32-950fafca1776	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[0A000]: Feature not supported: 7 ERROR:  no est\\u00e1n implementadas las referencias entre bases de datos: users.name, users.user_alias, profile.profile_name\\nLINE 1: select \\"users\\".\\"name, users\\".\\"user_alias, profile\\".\\"profile_...\\n               ^ (Connection: pgsql, SQL: select \\"users\\".\\"name, users\\".\\"user_alias, profile\\".\\"profile_name\\" from \\"users\\" inner join \\"profile\\" on \\"users\\".\\"profile_code\\" = \\"profile\\".\\"id\\" where \\"users\\".\\"profile_code\\" = 1)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":130},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1788}	2024-11-06 09:27:23
42602	9d6cdf1b-82f9-471c-a9fb-74b3ec3e24e4	9d6cdf1b-9f2a-4820-b2e7-dc333b92fd3d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-06 11:07:31
42603	9d6cdf1b-9b1c-4bde-a4c7-7715f44a0c21	9d6cdf1b-9f2a-4820-b2e7-dc333b92fd3d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%MA%' or \\"users\\".\\"user_document\\"::text like '%MA%') order by \\"users\\".\\"user_document\\" asc","time":"39.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":122,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-06 11:07:31
42604	9d6cdf1b-9e01-4e76-b8f2-04e23f16dc66	9d6cdf1b-9f2a-4820-b2e7-dc333b92fd3d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-06 11:07:31
42605	9d6cdf1b-9e40-4c83-8bb9-1672bab02dd3	9d6cdf1b-9f2a-4820-b2e7-dc333b92fd3d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"MA"},"session":[],"response_status":200,"response":{"data":[]},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:07:31
42981	9d6ce335-e382-47f7-8aef-7ab344b7ea54	9d6ce335-ef76-44d5-ae1b-b84498140a9b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 11:18:59
42982	9d6ce335-ee42-4aa0-8414-a90a4980c8e5	9d6ce335-ef76-44d5-ae1b-b84498140a9b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 11:18:59
42983	9d6ce335-ee8a-4855-8ff5-1330adf3ef7e	9d6ce335-ef76-44d5-ae1b-b84498140a9b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/showCobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@showCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":[]},"duration":187,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:18:59
42606	9d6cdf1b-de84-47fd-b1df-6364fcf74a28	9d6cdf1b-f8de-4d91-9b6f-bfadda6c02fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-06 11:07:31
42607	9d6cdf1b-f498-4856-8f04-a3338ac7a1f8	9d6cdf1b-f8de-4d91-9b6f-bfadda6c02fd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ma%' or \\"users\\".\\"user_document\\"::text like '%Ma%') order by \\"users\\".\\"user_document\\" asc","time":"39.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":122,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-06 11:07:31
42608	9d6cdf1b-f77f-4ae6-bd9b-a172fa18bae0	9d6cdf1b-f8de-4d91-9b6f-bfadda6c02fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-06 11:07:31
39791	9d6cb631-3ed3-4a56-940c-a51ee29d69b6	9d6cb631-8420-4c93-b903-65aba017f8d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:13:07
39792	9d6cb631-8254-4ff6-9ae2-e78d91967765	9d6cb631-8420-4c93-b903-65aba017f8d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:13:07
39793	9d6cb631-8316-46ba-a9c9-b9201f10f5a1	9d6cb631-8420-4c93-b903-65aba017f8d3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":383,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:13:07
42609	9d6cdf1b-f7c0-4391-8fa5-7f69248285a2	9d6cdf1b-f8de-4d91-9b6f-bfadda6c02fd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ma"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":214,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:07:31
42984	9d6ce337-bb3e-49b4-9faa-af2c759f123c	9d6ce338-153f-4ec8-9d55-32453b6b04af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 11:19:01
42985	9d6ce338-0bfc-4961-9a20-623165deda51	9d6ce338-153f-4ec8-9d55-32453b6b04af	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"178.10","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:19:01
42986	9d6ce338-0cc3-473c-af95-c6aeeae1e389	9d6ce338-153f-4ec8-9d55-32453b6b04af	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:19:01
42987	9d6ce338-130a-44bc-aa13-54b993f02c32	9d6ce338-153f-4ec8-9d55-32453b6b04af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 11:19:01
42988	9d6ce338-138b-4a4f-ac68-1da2a8444374	9d6ce338-153f-4ec8-9d55-32453b6b04af	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":562,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:19:01
43038	9d6ce388-8cfc-481d-ba8a-6e856e88c79c	9d6ce388-a8c7-4e4d-870f-43d6e3613a81	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 11:19:54
43039	9d6ce388-a703-4042-b766-8dd183dff5f4	9d6ce388-a8c7-4e4d-870f-43d6e3613a81	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 11:19:54
39794	9d6cb632-2a3d-4de7-a9b1-04756ea7ab06	9d6cb632-46eb-41f1-9319-07a7daeee691	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:13:07
39795	9d6cb632-417d-433a-8d8e-7238aeb3dcdf	9d6cb632-46eb-41f1-9319-07a7daeee691	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:13:07
39796	9d6cb632-41d3-4707-a649-0df7baaff967	9d6cb632-46eb-41f1-9319-07a7daeee691	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:13:07
39797	9d6cb632-45ba-4222-9f46-d6f5d995ba36	9d6cb632-46eb-41f1-9319-07a7daeee691	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:13:07
39798	9d6cb632-45ff-49df-a533-ef1890417d2b	9d6cb632-46eb-41f1-9319-07a7daeee691	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:13:07
42610	9d6cdf1c-3620-4450-ba8d-c1b480a545f8	9d6cdf1c-7b78-4d80-a1b2-da862270a7cc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-06 11:07:31
42611	9d6cdf1c-7798-42b4-be11-8c4644fffc24	9d6cdf1c-7b78-4d80-a1b2-da862270a7cc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mar%' or \\"users\\".\\"user_document\\"::text like '%Mar%') order by \\"users\\".\\"user_document\\" asc","time":"151.00","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":122,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-06 11:07:32
42612	9d6cdf1c-7a57-4749-afa0-0d064b641774	9d6cdf1c-7b78-4d80-a1b2-da862270a7cc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-06 11:07:32
42613	9d6cdf1c-7a9b-43c5-87cc-9ec415e267e9	9d6cdf1c-7b78-4d80-a1b2-da862270a7cc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mar"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":325,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:07:32
42989	9d6ce338-9722-4f90-aca8-a262fe409f58	9d6ce338-afda-4ab7-ba71-4cbdd03b14a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 11:19:01
42990	9d6ce338-ac04-4cda-b425-cb0a65612740	9d6ce338-afda-4ab7-ba71-4cbdd03b14a5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"42.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:19:01
42991	9d6ce338-aeb5-4a23-bd4f-455a2445b749	9d6ce338-afda-4ab7-ba71-4cbdd03b14a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 11:19:01
40861	9d6cc7d9-0228-4b87-a482-4b8ede93f78c	9d6cc7d9-49cd-4924-b927-75e8adf53f59	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:02:29
42992	9d6ce338-aef9-4fc4-9793-a61ba779d837	9d6ce338-afda-4ab7-ba71-4cbdd03b14a5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:19:01
42614	9d6cdf1c-c040-4db6-bece-49c7d86d4c0b	9d6cdf1c-d9b8-42a4-87dc-cafda05af5f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-06 11:07:32
42615	9d6cdf1c-d5a1-4153-994b-ebe461284c0c	9d6cdf1c-d9b8-42a4-87dc-cafda05af5f0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"39.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":122,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-06 11:07:32
29090	9d690e9b-2fb5-41eb-b0ce-29553a2e4324	9d690e9b-6744-4b8d-b8b5-3f4e2fe4c5b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 13:37:01
29091	9d690e9b-6457-45b6-a739-dc06cc7db0ac	9d690e9b-6744-4b8d-b8b5-3f4e2fe4c5b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 13:37:01
29092	9d690e9b-65ac-4a66-86df-ab3e209a6dc6	9d690e9b-6744-4b8d-b8b5-3f4e2fe4c5b1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":434,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:37:01
42616	9d6cdf1c-d876-4d26-ac95-73130cfd5374	9d6cdf1c-d9b8-42a4-87dc-cafda05af5f0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-06 11:07:32
42617	9d6cdf1c-d8bb-4c88-b670-d8121fc1f2f3	9d6cdf1c-d9b8-42a4-87dc-cafda05af5f0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":223,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:07:32
43040	9d6ce388-a795-45c3-acd9-d634cafce1f2	9d6ce388-a8c7-4e4d-870f-43d6e3613a81	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":215,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:19:54
29093	9d690e9b-f478-4482-aa46-ba86c37272a1	9d690e9c-25be-401a-b7bb-a244d9e4fb5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 13:37:02
29094	9d690e9c-1c28-43a0-b9da-7caf67452720	9d690e9c-25be-401a-b7bb-a244d9e4fb5c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"62.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:37:02
29095	9d690e9c-1cb3-4426-9e25-52e213bdd35a	9d690e9c-25be-401a-b7bb-a244d9e4fb5c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 13:37:02
29096	9d690e9c-23a7-4731-9538-8097bb5377cd	9d690e9c-25be-401a-b7bb-a244d9e4fb5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 13:37:02
29097	9d690e9c-2441-4ca7-a84b-cdd76b46d099	9d690e9c-25be-401a-b7bb-a244d9e4fb5c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":395,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:37:02
42618	9d6cdf1d-171d-457e-9a2f-adb9f981970b	9d6cdf1d-5906-4c9f-b6cc-7ae6e102aa30	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-06 11:07:32
42619	9d6cdf1d-5506-4e62-9f11-1a6947317f6c	9d6cdf1d-5906-4c9f-b6cc-7ae6e102aa30	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"141.62","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":122,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-06 11:07:32
42620	9d6cdf1d-57d8-481d-abc2-196194e76833	9d6cdf1d-5906-4c9f-b6cc-7ae6e102aa30	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-06 11:07:32
40862	9d6cc7d9-483b-4a34-a399-e40ff73fc1ec	9d6cc7d9-49cd-4924-b927-75e8adf53f59	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:02:29
40863	9d6cc7d9-48d4-41fc-8a5b-0a3dcbd6f091	9d6cc7d9-49cd-4924-b927-75e8adf53f59	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":383,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:02:29
42621	9d6cdf1d-581f-424b-b64a-ce648d5d71e4	9d6cdf1d-5906-4c9f-b6cc-7ae6e102aa30	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":316,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:07:32
43041	9d6ce389-056a-4128-89be-0b9fdd7ba32f	9d6ce389-0c04-4a71-8917-d7bb655d470b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 11:19:54
43042	9d6ce389-0ae0-4e7f-84d8-3649585e7c61	9d6ce389-0c04-4a71-8917-d7bb655d470b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 11:19:54
43043	9d6ce389-0b20-4507-9f06-33b2e08e8b98	9d6ce389-0c04-4a71-8917-d7bb655d470b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/showCobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@showCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":"sakdbsabdjkbsadbjksdajkbdsajbkjkbsdakjd"},"duration":174,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:19:54
29098	9d690e9c-9605-4ef2-850e-1d2b97fe4d79	9d690e9c-ea0a-4858-92a2-01a6721031aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 13:37:02
29099	9d690e9c-e075-4fcd-8f47-55ad019050af	9d690e9c-ea0a-4858-92a2-01a6721031aa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"id\\" = '89' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"165.69","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":203,"hash":"794021850d4e2779de4e83c9436a01ae","hostname":"EderCortes"}	2024-11-04 13:37:02
29100	9d690e9c-e0ed-4fdc-b6bb-5f110d33b557	9d690e9c-ea0a-4858-92a2-01a6721031aa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 13:37:02
29101	9d690e9c-e301-4da6-a746-d33f3e5267f3	9d690e9c-ea0a-4858-92a2-01a6721031aa	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":204,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 13:37:02
29102	9d690e9c-e346-48ba-8619-a653323df7de	9d690e9c-ea0a-4858-92a2-01a6721031aa	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 13:37:02
29103	9d690e9c-e820-4128-aaa2-d8c51828acab	9d690e9c-ea0a-4858-92a2-01a6721031aa	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 13:37:02
29104	9d690e9c-e8a9-47b2-b7e1-2247900b8e95	9d690e9c-ea0a-4858-92a2-01a6721031aa	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","user_creador":12,"user_recomendacion":14,"loans_valor_prestado":1100000,"user_customer":19,"user_cobrador":14,"created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_fecha_ultimo_pago":"04-11-2024","loans_pago_interes":"146000","loans_pago_prestado":"584000","loans_intereses_recaudar":"275000"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":477,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:37:02
42622	9d6cdf1d-90a8-4188-855c-0228a9b5f7c5	9d6cdf1d-9347-44d8-a2b6-3b05ed80cdfd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":126,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:07:32
43044	9d6ce38a-cbd1-4be2-aa24-5556b4e06324	9d6ce38b-1658-48b9-8422-c1e53fccfa85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 11:19:55
40864	9d6cc7da-6e1f-4333-aef4-8f4a6c357be7	9d6cc7da-9886-4905-b90e-67d50fdd77e2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:02:30
40865	9d6cc7da-8feb-43e6-9288-a4b24f492fe0	9d6cc7da-9886-4905-b90e-67d50fdd77e2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"58.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:02:30
40866	9d6cc7da-9072-4a52-8e98-88c2704c99ef	9d6cc7da-9886-4905-b90e-67d50fdd77e2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:02:30
40867	9d6cc7da-96e6-4f9b-93ad-b716baf62a3c	9d6cc7da-9886-4905-b90e-67d50fdd77e2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:02:30
40868	9d6cc7da-9748-44f7-861c-a4aade514cc0	9d6cc7da-9886-4905-b90e-67d50fdd77e2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":408,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:02:30
43045	9d6ce38b-114d-4928-a65f-3a3a02c97e9a	9d6ce38b-1658-48b9-8422-c1e53fccfa85	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"156.16","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:19:55
43046	9d6ce38b-11a4-461d-81b1-5ee36d749a03	9d6ce38b-1658-48b9-8422-c1e53fccfa85	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:19:55
43047	9d6ce38b-1528-4a06-9f93-3558170926a0	9d6ce38b-1658-48b9-8422-c1e53fccfa85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 11:19:55
29105	9d690e9d-5d4a-4be7-8f1d-356fc336bea8	9d690e9d-8cd2-4d1c-ad18-f1d5acb3921e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 13:37:03
29106	9d690e9d-83f8-40c3-a59e-efcc39af49b3	9d690e9d-8cd2-4d1c-ad18-f1d5acb3921e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"59.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 13:37:03
29107	9d690e9d-847c-4b77-b434-14fb8807c79f	9d690e9d-8cd2-4d1c-ad18-f1d5acb3921e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 13:37:03
29108	9d690e9d-8af5-464a-b70e-922f267c99ef	9d690e9d-8cd2-4d1c-ad18-f1d5acb3921e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-04 13:37:03
29109	9d690e9d-8b7c-42a5-b3f4-d0d947450313	9d690e9d-8cd2-4d1c-ad18-f1d5acb3921e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":395,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:37:03
42623	9d6cdf1e-47d8-44f8-b1c3-72a7e0ec92f8	9d6cdf1e-62b0-475d-82b6-0391ba725f1a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-06 11:07:33
42624	9d6cdf1e-5e6d-48d3-816b-654f84adf647	9d6cdf1e-62b0-475d-82b6-0391ba725f1a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"42.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":122,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-06 11:07:33
42625	9d6cdf1e-6166-4d8d-9e8c-b3f7bdaa4156	9d6cdf1e-62b0-475d-82b6-0391ba725f1a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-06 11:07:33
42626	9d6cdf1e-61ac-48c8-a811-a6e8d29ed107	9d6cdf1e-62b0-475d-82b6-0391ba725f1a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":216,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:07:33
43048	9d6ce38b-156b-4e47-84cc-d2030c407e82	9d6ce38b-1658-48b9-8422-c1e53fccfa85	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":421,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:19:55
40504	9d6cc3f1-9f7c-462d-bfed-7c5795bd1580	9d6cc3f1-e772-4450-872c-f10ce65b488f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 09:51:34
29110	9d690e9e-4297-4290-87ba-18cc65c3eb7c	9d690e9e-8194-4dd4-91c9-d4f582ecd216	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-04 13:37:03
29111	9d690e9e-76e1-4985-9c9e-815a7f157b1e	9d690e9e-8194-4dd4-91c9-d4f582ecd216	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"79.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:37:03
29112	9d690e9e-7789-4c97-ac02-0df6d0d87684	9d690e9e-8194-4dd4-91c9-d4f582ecd216	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:37:03
29113	9d690e9e-7f48-4dc6-b07f-6e2a61eb79ac	9d690e9e-8194-4dd4-91c9-d4f582ecd216	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-04 13:37:03
29114	9d690e9e-7fd5-4d78-92b5-29ffc7874557	9d690e9e-8194-4dd4-91c9-d4f582ecd216	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":601,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:37:03
42627	9d6cdf20-3469-4122-a16b-c55f6db47c27	9d6cdf20-5185-4842-9593-7a222a34017d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-06 11:07:34
40847	9d6cc7c0-ea20-4981-bea4-47b7e030143c	9d6cc7c1-1179-4a9b-9460-4134a72896cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-06 10:02:13
40505	9d6cc3f1-e60a-447d-bf90-dbfc3b1c8d91	9d6cc3f1-e772-4450-872c-f10ce65b488f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 09:51:34
40506	9d6cc3f1-e694-4a49-8a80-ce0d07d4075b	9d6cc3f1-e772-4450-872c-f10ce65b488f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:51:34
40848	9d6cc7c1-09a1-49e1-9d61-cd89ccc8ea1f	9d6cc7c1-1179-4a9b-9460-4134a72896cf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"52.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:02:13
40849	9d6cc7c1-0a27-4199-b410-9d97d40679d0	9d6cc7c1-1179-4a9b-9460-4134a72896cf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:02:13
40850	9d6cc7c1-0fd4-41f2-81bf-2d45aafa862a	9d6cc7c1-1179-4a9b-9460-4134a72896cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-06 10:02:13
40851	9d6cc7c1-103a-4f30-ba94-547c598b55d7	9d6cc7c1-1179-4a9b-9460-4134a72896cf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":296,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:02:13
40869	9d6cc7da-fe60-4d22-a809-476aad1096a4	9d6cc7db-4e40-444f-8ffb-860e3f702b37	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:02:30
42628	9d6cdf20-4c93-45a6-9f62-35e23966b8f0	9d6cdf20-5185-4842-9593-7a222a34017d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '19' and \\"users\\".\\"deleted_at\\" is null","time":"39.20","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":101,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-11-06 11:07:34
42629	9d6cdf20-4cf4-4f40-8451-760489830f47	9d6cdf20-5185-4842-9593-7a222a34017d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 11:07:34
40852	9d6cc7c1-6fe1-4921-b1b5-f27efb7e039d	9d6cc7c1-b912-4667-b93d-4938fbc0913c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-06 10:02:13
40853	9d6cc7c1-b459-4431-99f0-58838472d789	9d6cc7c1-b912-4667-b93d-4938fbc0913c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"159.35","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:02:13
40507	9d6cc3f3-0021-44e7-bef8-5fa29effd5d4	9d6cc3f3-488a-49d3-961b-a87c666b9db4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 09:51:35
40508	9d6cc3f3-43a8-45ba-aece-4d89b54958b2	9d6cc3f3-488a-49d3-961b-a87c666b9db4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"153.47","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:51:35
40509	9d6cc3f3-4402-4297-9d52-31f1069c9809	9d6cc3f3-488a-49d3-961b-a87c666b9db4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:51:35
40510	9d6cc3f3-4763-4ad2-8789-fbd7a52cc13f	9d6cc3f3-488a-49d3-961b-a87c666b9db4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-06 09:51:35
40511	9d6cc3f3-47a8-47ac-a2ba-dae455fafb7e	9d6cc3f3-488a-49d3-961b-a87c666b9db4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":339,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:51:35
40854	9d6cc7c1-b793-43ac-b531-89ecffb8bfef	9d6cc7c1-b912-4667-b93d-4938fbc0913c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-06 10:02:13
40855	9d6cc7c1-b7eb-4b7b-9143-c2bc1aca736a	9d6cc7c1-b912-4667-b93d-4938fbc0913c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":408,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:02:13
40870	9d6cc7db-47cc-4892-bf16-baacd849491f	9d6cc7db-4e40-444f-8ffb-860e3f702b37	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"163.30","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:02:30
40871	9d6cc7db-4c83-4575-902a-7dbbdc36a769	9d6cc7db-4e40-444f-8ffb-860e3f702b37	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:02:30
40872	9d6cc7db-4cf3-4bde-8526-68afe62f3d88	9d6cc7db-4e40-444f-8ffb-860e3f702b37	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":443,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:02:30
42630	9d6cdf20-5050-4650-a93c-f656be2ed2ce	9d6cdf20-5185-4842-9593-7a222a34017d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-06 11:07:34
43049	9d6ce38b-589a-480c-b853-3a6de919b942	9d6ce38b-9b00-4d19-89b4-c542b72e8070	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 11:19:55
42631	9d6cdf20-5093-4fa1-869e-b1e175470179	9d6cdf20-5185-4842-9593-7a222a34017d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/19","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:07:34
43050	9d6ce38b-9708-4d6a-a25f-84c5e34e95ba	9d6ce38b-9b00-4d19-89b4-c542b72e8070	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"146.97","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:19:56
43051	9d6ce38b-99de-49e7-9101-91d1d91c9c6d	9d6ce38b-9b00-4d19-89b4-c542b72e8070	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 11:19:56
43052	9d6ce38b-9a21-410d-89f9-2a7b31fb767c	9d6ce38b-9b00-4d19-89b4-c542b72e8070	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":324,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:19:56
40512	9d6cc3f3-867d-4226-baa6-0cd37d3fd8a4	9d6cc3f3-9fd2-4d5d-978a-a806293610d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-06 09:51:35
40513	9d6cc3f3-9bdb-468c-a883-423535acce49	9d6cc3f3-9fd2-4d5d-978a-a806293610d0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"42.73","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:51:35
40514	9d6cc3f3-9e9c-4a9a-898a-5d6a511167d3	9d6cc3f3-9fd2-4d5d-978a-a806293610d0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-06 09:51:35
40515	9d6cc3f3-9ee1-4772-928d-c7257d94871a	9d6cc3f3-9fd2-4d5d-978a-a806293610d0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":210,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:51:35
43098	9d6ce4c2-0fc2-4bee-bef5-edb2631e9cf9	9d6ce4c2-1368-4ee8-91dc-2cc7d08871b6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1986}	2024-11-06 11:23:19
43099	9d6ce4c1-f5cd-40c3-8ffc-ea5c529a1985	9d6ce4c2-1368-4ee8-91dc-2cc7d08871b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:23:19
43100	9d6ce4c2-119c-4214-9072-6b8d7bb62ab0	9d6ce4c2-1368-4ee8-91dc-2cc7d08871b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:23:19
43101	9d6ce4c2-1262-4eb9-92b7-3aabb27e8b93	9d6ce4c2-1368-4ee8-91dc-2cc7d08871b6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":296,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:23:19
43141	9d6ce508-32f9-4ba7-b25e-bb2be0a8b9fe	9d6ce508-4ff6-4819-b0a8-a8a608a464bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 11:24:05
43142	9d6ce508-4dcf-49bc-bf87-0b2554a42be7	9d6ce508-4ff6-4819-b0a8-a8a608a464bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 11:24:05
43143	9d6ce508-4e96-4052-b6c1-103a8308d73f	9d6ce508-4ff6-4819-b0a8-a8a608a464bb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/showCobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@showCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abFROM\\u00bb\\nLINE 19:                         FROM users\\n                                 ^ (Connection: pgsql, SQL: \\n                     SELECT id,\\n                            name,\\n                            profile_code,\\n                            profile_name,\\n                            profile_prefix,\\n                            remember_token,\\n                            user_address,\\n                            user_age,\\n                            user_alias,\\n                            user_birth,\\n                            user_cellphone,\\n                            user_city,\\n                            user_document,\\n                            user_document_type,\\n                            user_last_name_one,\\n                            user_last_name_two,\\n                            user_neighborhood,\\n                        FROM users\\n                        WHERE profile_code = 4;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":142,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"showCobrador","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":257,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:24:05
14631	9d5ebef1-9ee4-4305-9ed6-a96c3d116c37	9d5ebef1-a32c-40de-af7c-75f37840fd69	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":670}	2024-10-30 10:35:59
10899	9d5ca58f-8e79-4404-8465-1ce3ecad7da6	9d5ca58f-9186-4ae3-912f-c1b78ef041d3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":544}	2024-10-29 09:33:22
39848	9d6cb7ed-b11e-42e1-92ae-23114b4f8a3b	9d6cb7ed-d1d9-43ef-b58c-c634832b080f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:17:58
39849	9d6cb7ed-cfc7-442a-b302-81fc81de79ab	9d6cb7ed-d1d9-43ef-b58c-c634832b080f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:17:58
39850	9d6cb7ed-d099-4b36-8d92-5e03d854bd04	9d6cb7ed-d1d9-43ef-b58c-c634832b080f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":418,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:17:58
43388	9d6ce724-f5fb-416e-8ad8-01a1c7062a06	9d6ce725-160e-4dd6-8eae-62c4931c29ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:29:59
43389	9d6ce725-145d-4d60-9493-044b38028a39	9d6ce725-160e-4dd6-8eae-62c4931c29ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:29:59
43390	9d6ce725-150e-4645-a380-49dadf3448f1	9d6ce725-160e-4dd6-8eae-62c4931c29ee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":326,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:29:59
43442	9d6cea01-4e97-4c35-8e8a-86027c3a18a7	9d6cea01-8ffb-4067-8acf-e18fcab9e81a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:37:59
43443	9d6cea01-8e9a-4fa8-9d89-7f0a22aa9e62	9d6cea01-8ffb-4067-8acf-e18fcab9e81a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:37:59
43444	9d6cea01-8f2c-4a63-821c-51cf388767df	9d6cea01-8ffb-4067-8acf-e18fcab9e81a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":341,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:37:59
43441	9d6cea01-8d70-4c29-abdb-47bd04da986d	9d6cea01-8ffb-4067-8acf-e18fcab9e81a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2026}	2024-11-06 11:37:59
43391	9d6ce725-86bf-4500-860c-2fc9840f8145	9d6ce725-9339-448b-b3db-9526ef8a84c1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:30:00
43392	9d6ce725-91cf-4b26-9ad0-342ffa62d3bd	9d6ce725-9339-448b-b3db-9526ef8a84c1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:30:00
43393	9d6ce725-922e-4600-a7d4-e2ebbc281f18	9d6ce725-9339-448b-b3db-9526ef8a84c1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/showCobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@showCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"connection":[],"grammar":[],"processor":[],"bindings":{"select":[],"from":[],"join":[],"where":["4"],"groupBy":[],"having":[],"order":[],"union":[],"unionOrder":[]},"aggregate":null,"columns":["id","name","profile_code","remember_token","user_address","user_age","user_alias","user_birth","user_cellphone","user_city","user_document","user_document_type","user_last_name_one","user_last_name_two","user_neighborhood"],"distinct":false,"from":"users","indexHint":null,"joins":null,"wheres":[{"type":"Basic","column":"profile_code","operator":"=","value":"4","boolean":"and"}],"groups":null,"havings":null,"orders":null,"limit":null,"offset":null,"unions":null,"unionLimit":null,"unionOffset":null,"unionOrders":null,"lock":null,"beforeQueryCallbacks":[],"operators":["=","<",">","<=",">=","<>","!=","<=>","like","like binary","not like","ilike","&","|","^","<<",">>","&~","is","is not","rlike","not rlike","regexp","not regexp","~","~*","!~","!~*","similar to","not similar to","not ilike","~~*","!~~*"],"bitwiseOperators":["&","|","^","<<",">>","&~"],"useWritePdo":false}},"duration":221,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:30:00
43394	9d6ce727-9e1a-459c-8dde-c02d4963ecb4	9d6ce727-bb21-4907-8b95-05016e737db1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:30:01
43395	9d6ce727-b59b-4fcc-b6cd-d517e5609b36	9d6ce727-bb21-4907-8b95-05016e737db1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:30:01
43396	9d6ce727-b5e7-43a1-8c87-807f0a4e4521	9d6ce727-bb21-4907-8b95-05016e737db1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:30:01
43397	9d6ce727-b98b-4282-9dfd-796dbfd7ad80	9d6ce727-bb21-4907-8b95-05016e737db1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:30:01
43398	9d6ce727-b9d4-4b82-a0c0-74421f86d821	9d6ce727-bb21-4907-8b95-05016e737db1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":291,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:30:01
43399	9d6ce728-0186-4412-93b5-0fa0437d86d8	9d6ce728-1f56-4f3e-bd07-4d53cfa45374	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:30:01
43400	9d6ce728-19e7-4941-a898-cd852ad630bf	9d6ce728-1f56-4f3e-bd07-4d53cfa45374	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"48.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:30:01
43401	9d6ce728-1dd2-4128-bd8c-83a8233786bf	9d6ce728-1f56-4f3e-bd07-4d53cfa45374	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:30:01
37024	9d6b445e-671b-44a5-92f1-ccd4b02d4916	9d6b445e-8612-4516-8b5a-29f208acd637	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:59:00
37025	9d6b445e-8412-40c6-90f9-9c7c7aed61dd	9d6b445e-8612-4516-8b5a-29f208acd637	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 15:59:01
37026	9d6b445e-84c7-4680-ac9b-780623387247	9d6b445e-8612-4516-8b5a-29f208acd637	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:59:01
43402	9d6ce728-1e29-4db5-9b94-3b5b64f23094	9d6ce728-1f56-4f3e-bd07-4d53cfa45374	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:30:01
37027	9d6b445e-e2bd-4bc9-bc7e-510524a16ee3	9d6b445f-027d-498e-8ead-0b5d8333c717	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 15:59:01
37028	9d6b445e-fd6e-4c84-bc4e-2611967eee9c	9d6b445f-027d-498e-8ead-0b5d8333c717	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"48.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:59:01
37029	9d6b445f-00a1-4b43-a4fa-b7b0f3bd15e8	9d6b445f-027d-498e-8ead-0b5d8333c717	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 15:59:01
37030	9d6b445f-0120-40b7-b31d-f4f72200b48e	9d6b445f-027d-498e-8ead-0b5d8333c717	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:59:01
37031	9d6b445f-5fed-46c4-9742-9a6aaa48b3a0	9d6b445f-829d-4470-b1b0-12ccbde77fb3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 15:59:01
37032	9d6b445f-7c1e-4d0c-bb91-4dfaa8d3c824	9d6b445f-829d-4470-b1b0-12ccbde77fb3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:59:01
37033	9d6b445f-7c6f-45c2-8b95-9a79da561f72	9d6b445f-829d-4470-b1b0-12ccbde77fb3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:59:01
37034	9d6b445f-80e3-4798-9410-29f1c8919597	9d6b445f-829d-4470-b1b0-12ccbde77fb3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 15:59:01
37035	9d6b445f-8127-4f96-95ab-d8654c0793fe	9d6b445f-829d-4470-b1b0-12ccbde77fb3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":317,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:59:01
37036	9d6b445f-d718-45d7-8719-0eb6a8a95c41	9d6b4460-28e2-4449-8f7f-28610aac130b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 15:59:01
37037	9d6b4460-21f7-452b-953b-a2ce7140a224	9d6b4460-28e2-4449-8f7f-28610aac130b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"157.80","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:59:02
37038	9d6b4460-224a-461b-a6d0-9d73b6261ac0	9d6b4460-28e2-4449-8f7f-28610aac130b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:59:02
37039	9d6b4460-26ff-430a-b431-584d7f17d210	9d6b4460-28e2-4449-8f7f-28610aac130b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 15:59:02
37040	9d6b4460-276e-489b-9050-88d3940ec351	9d6b4460-28e2-4449-8f7f-28610aac130b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":409,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:59:02
37041	9d6b4461-e471-451e-b6ec-e83e56bad605	9d6b4462-2b38-4c8f-9e28-c84afaad8938	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 15:59:03
37042	9d6b4462-1ef4-467d-8c64-d21062914805	9d6b4462-2b38-4c8f-9e28-c84afaad8938	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"107.18","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:59:03
37043	9d6b4462-1fc1-40c1-95dc-2503d9e00720	9d6b4462-2b38-4c8f-9e28-c84afaad8938	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:59:03
37044	9d6b4462-28a8-42e3-99d4-b25dc12303b2	9d6b4462-2b38-4c8f-9e28-c84afaad8938	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 15:59:03
37045	9d6b4462-294f-421d-821f-a6dc83c54959	9d6b4462-2b38-4c8f-9e28-c84afaad8938	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":581,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:59:03
34546	9d69becb-74e8-4d57-8899-97ad0e0d51e6	9d69becb-9399-46c6-a320-0c9ddb1acbd7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:49:41
34547	9d69becb-920b-4214-a26e-b0ce837a7355	9d69becb-9399-46c6-a320-0c9ddb1acbd7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:49:41
34548	9d69becb-92a7-4e69-8c5d-bc2835cce9f5	9d69becb-9399-46c6-a320-0c9ddb1acbd7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":260,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:49:41
34549	9d69becb-eb6c-4379-a59c-0b687515e16e	9d69becc-0bdd-4a7a-8400-448a62a34a21	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:49:41
34550	9d69becc-065d-4a38-a48e-d5f81271f2c8	9d69becc-0bdd-4a7a-8400-448a62a34a21	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":258,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:49:41
34551	9d69becc-06bd-4aa3-9e37-71603e514622	9d69becc-0bdd-4a7a-8400-448a62a34a21	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:49:41
34552	9d69becc-0ab1-4a69-baae-aead5d3fa6fb	9d69becc-0bdd-4a7a-8400-448a62a34a21	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 21:49:41
34553	9d69becc-0aff-4341-8525-093e1da6c6bb	9d69becc-0bdd-4a7a-8400-448a62a34a21	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":248,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:49:41
34554	9d69becc-5170-4c21-90cf-d44e9725c3bb	9d69becc-972f-402b-b4c0-1c16d426250a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 21:49:41
34555	9d69becc-9223-4612-b5fe-f5ac1b71cc64	9d69becc-972f-402b-b4c0-1c16d426250a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"144.81","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":247,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 21:49:42
34556	9d69becc-9274-4007-a09e-7d854fe539e7	9d69becc-972f-402b-b4c0-1c16d426250a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 21:49:42
34557	9d69becc-9607-4e92-88e4-43b24598ea3c	9d69becc-972f-402b-b4c0-1c16d426250a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 21:49:42
34558	9d69becc-9651-499f-b5ff-be93897f0505	9d69becc-972f-402b-b4c0-1c16d426250a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":338,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:49:42
34559	9d69becc-df90-435a-8975-9872f48d35b1	9d69becc-fe70-48d2-b727-91c0a9377608	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 21:49:42
34560	9d69becc-f922-498c-8771-0465f5e3d343	9d69becc-fe70-48d2-b727-91c0a9377608	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:49:42
34561	9d69becc-f977-483d-a19a-5f42b247e796	9d69becc-fe70-48d2-b727-91c0a9377608	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:49:42
34562	9d69becc-fd49-461c-aa22-9cb27be05d74	9d69becc-fe70-48d2-b727-91c0a9377608	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 21:49:42
34563	9d69becc-fd97-4fe1-991f-4a92af1c088e	9d69becc-fe70-48d2-b727-91c0a9377608	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:49:42
43123	9d6ce504-d848-48b7-9435-b007843b3b06	9d6ce504-db96-4914-90cd-976cd10ad6b6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1990}	2024-11-06 11:24:03
43559	9d6cea10-f19e-4198-9ef1-02c15d643898	9d6cea10-f43c-465c-9f1a-7dc4b77d14fb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2046}	2024-11-06 11:38:10
41771	9d6ccf5c-0d32-4e01-b767-1cb66f84aafb	9d6ccf5c-109b-4338-9ff1-eacf22169b90	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1928}	2024-11-06 10:23:29
37162	9d6b4581-8e78-4dad-ac4e-b12639fe14a0	9d6b4581-b172-4d92-b80b-10c7fc63b137	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 16:02:11
37163	9d6b4581-af7e-43f8-a59a-0c7adbcc8e3a	9d6b4581-b172-4d92-b80b-10c7fc63b137	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 16:02:11
37164	9d6b4581-b065-404d-ab9d-aa0d6513cdd3	9d6b4581-b172-4d92-b80b-10c7fc63b137	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":267,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:02:11
37165	9d6b4582-0da2-4909-b75a-d3e047451b0d	9d6b4582-556a-4f4f-bd53-5199d6ab059e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 16:02:12
37166	9d6b4582-50bc-4d24-afd8-832305c90fc1	9d6b4582-556a-4f4f-bd53-5199d6ab059e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"153.57","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 16:02:12
37167	9d6b4582-53f5-4d9c-aa15-43c7021fb2d4	9d6b4582-556a-4f4f-bd53-5199d6ab059e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 16:02:12
37168	9d6b4582-545e-43c0-b550-29f7db1913b8	9d6b4582-556a-4f4f-bd53-5199d6ab059e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:02:12
37169	9d6b4582-b527-420d-996c-ef7266db4e69	9d6b4582-db8a-454a-a14d-6ebbdbae77cb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 16:02:12
37170	9d6b4582-d4b3-4025-a13d-cd9d269262ef	9d6b4582-db8a-454a-a14d-6ebbdbae77cb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"48.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:02:12
37171	9d6b4582-d518-4a54-a14e-38540ca013b3	9d6b4582-db8a-454a-a14d-6ebbdbae77cb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:02:12
37172	9d6b4582-d9e1-46d3-86ef-c971e9e1b080	9d6b4582-db8a-454a-a14d-6ebbdbae77cb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 16:02:12
31918	9d695730-89b2-45f6-a9e5-c7459258cad5	9d695730-c64c-4bd2-98d9-a1a5ec55e90c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 16:59:59
31919	9d695730-c2c8-4629-bdc3-832a977c7eea	9d695730-c64c-4bd2-98d9-a1a5ec55e90c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 16:59:59
31920	9d695730-c46e-4c04-9679-3152ce98b8e3	9d695730-c64c-4bd2-98d9-a1a5ec55e90c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":446,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:59:59
37173	9d6b4582-da3c-4e34-81e7-57ea427d2220	9d6b4582-db8a-454a-a14d-6ebbdbae77cb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":323,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:02:12
41754	9d6ccf24-3d8d-4267-a50e-8f519875f254	9d6ccf24-4056-4630-af53-725b03343b36	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1926}	2024-11-06 10:22:52
41661	9d6cce79-384b-4650-8cdc-274e418524e2	9d6cce79-3d32-424c-885e-d120107d2369	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1914}	2024-11-06 10:21:00
361	9d4f26e3-a1ba-401a-abda-1c12aa9a7c4e	9d4f26e3-a4c0-40a5-b247-fca2e21ceaae	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":21}	2024-10-22 16:33:24
31921	9d695731-5d8d-4f36-9068-832c7284536e	9d695731-6c6f-4b6d-8609-ed4ccb09d5d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 16:59:59
31922	9d695731-6a99-4322-bc55-88ec0d158425	9d695731-6c6f-4b6d-8609-ed4ccb09d5d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 16:59:59
31923	9d695731-6b1a-4616-9aec-4cc462b3f22c	9d695731-6c6f-4b6d-8609-ed4ccb09d5d3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":"kasbjfdsajdkjbsajk"},"duration":329,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:59:59
37174	9d6b4583-328b-476b-b412-c20088e2ceb1	9d6b4583-80de-4248-b229-dd0d9d396080	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 16:02:12
37175	9d6b4583-7bbd-464c-9cfa-4c961daed606	9d6b4583-80de-4248-b229-dd0d9d396080	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"155.81","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:02:13
37176	9d6b4583-7c31-4ea2-99be-bc8acfadf9ef	9d6b4583-80de-4248-b229-dd0d9d396080	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:02:13
37177	9d6b4583-7faa-40aa-9b39-eb6ee5bea98d	9d6b4583-80de-4248-b229-dd0d9d396080	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 16:02:13
37178	9d6b4583-7fe9-4dc3-b412-57f102dd81c3	9d6b4583-80de-4248-b229-dd0d9d396080	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":406,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:02:13
31924	9d695732-2347-45e7-b1d8-143265686485	9d695732-312c-45cf-8322-cb33b8f046f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 17:00:00
31925	9d695732-2f44-4c40-8243-2fbbb9231600	9d695732-312c-45cf-8322-cb33b8f046f6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 17:00:00
31926	9d695732-2fc9-47da-906c-ec72a620ff5d	9d695732-312c-45cf-8322-cb33b8f046f6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":"kasbjfdsajdkjbsajk"},"duration":332,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:00:00
37179	9d6b4585-107b-448d-8eba-f86cba353043	9d6b4585-6f44-44ab-8bc8-97632bbb52ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 16:02:14
37180	9d6b4585-68eb-4af8-ac11-80f73ee7f78c	9d6b4585-6f44-44ab-8bc8-97632bbb52ac	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"67.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 16:02:14
37181	9d6b4585-6951-4853-948e-5f71291b4420	9d6b4585-6f44-44ab-8bc8-97632bbb52ac	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 16:02:14
37182	9d6b4585-6dad-42b3-8e1b-63ebe8da055f	9d6b4585-6f44-44ab-8bc8-97632bbb52ac	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-05 16:02:14
37183	9d6b4585-6e0b-4ca7-a4f2-f8e7dc6d4b4d	9d6b4585-6f44-44ab-8bc8-97632bbb52ac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":628,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:02:14
31927	9d695732-dbc0-4e07-8139-8ad86196419f	9d695733-0769-4d77-8be4-e22a8f41cc1d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 17:00:00
31928	9d695732-ffd4-4893-9461-109f953e9560	9d695733-0769-4d77-8be4-e22a8f41cc1d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"59.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":189,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 17:00:00
31929	9d695733-0061-45c1-b013-0a5bc18a41f1	9d695733-0769-4d77-8be4-e22a8f41cc1d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 17:00:00
31930	9d695733-05d0-4148-9ff8-488d68480174	9d695733-0769-4d77-8be4-e22a8f41cc1d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 17:00:00
31931	9d695733-0643-407e-b72c-13b0bb045c6e	9d695733-0769-4d77-8be4-e22a8f41cc1d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":362,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:00:00
31932	9d695733-a11f-4857-825f-decf19fb60ba	9d695733-e05c-45f1-86ae-3350931920ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 17:00:01
31933	9d695733-d26f-4708-851a-32651fc76912	9d695733-e05c-45f1-86ae-3350931920ce	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"72.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 17:00:01
31934	9d695733-d328-481e-9e37-f1b293c7fd2e	9d695733-e05c-45f1-86ae-3350931920ce	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 17:00:01
31935	9d695733-dd09-4374-89d8-e9d73cfc7397	9d695733-e05c-45f1-86ae-3350931920ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 17:00:01
31936	9d695733-dddd-4c67-b549-99a19ad02181	9d695733-e05c-45f1-86ae-3350931920ce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":533,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:00:01
31937	9d695735-1154-49a6-aac4-6d920084f14b	9d695735-4818-4c1c-8e68-42c4b924db3e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 17:00:02
31938	9d695735-3ce9-4717-9178-a8ade9c1f4ca	9d695735-4818-4c1c-8e68-42c4b924db3e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"76.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 17:00:02
31939	9d695735-3d7c-4eb4-8b38-e8774b9fa713	9d695735-4818-4c1c-8e68-42c4b924db3e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 17:00:02
31940	9d695735-45d3-4424-a32d-ef19ed3d74e8	9d695735-4818-4c1c-8e68-42c4b924db3e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 17:00:02
31941	9d695735-467c-441a-b903-337eb416aa77	9d695735-4818-4c1c-8e68-42c4b924db3e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":587,"memory":22,"hostname":"EderCortes"}	2024-11-04 17:00:02
37471	9d6b4b64-8d19-46e4-8f5d-cb5746dccc0e	9d6b4b64-abcb-474b-84db-373efbff8c55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 16:18:39
37472	9d6b4b64-aa25-4384-a381-1de8ceef7e9c	9d6b4b64-abcb-474b-84db-373efbff8c55	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 16:18:39
37473	9d6b4b64-aad5-46ad-87ce-b1abf0faf247	9d6b4b64-abcb-474b-84db-373efbff8c55	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":271,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:18:39
37474	9d6b4b65-14fd-446e-8654-26a7e00993af	9d6b4b65-5aef-45e0-9693-098489f42786	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 16:18:39
37475	9d6b4b65-537c-47bf-81f3-0f179769de2d	9d6b4b65-5aef-45e0-9693-098489f42786	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 84\\n                        ","time":"145.70","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"ab3bc7b9a0b897ddfe4287a88fc64c84","hostname":"EderCortes"}	2024-11-05 16:18:39
37476	9d6b4b65-5601-48fd-8fd9-730f8c9c4184	9d6b4b65-5aef-45e0-9693-098489f42786	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '84' order by \\"item_loans\\".\\"id\\" asc","time":"2.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":304,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-05 16:18:39
37477	9d6b4b65-5992-456a-8e70-85f27f888ead	9d6b4b65-5aef-45e0-9693-098489f42786	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 16:18:39
37478	9d6b4b65-59f1-4771-9ccd-470c74a43119	9d6b4b65-5aef-45e0-9693-098489f42786	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/84","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":84,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"480000","loans_pago_interes":"120000","user_alias":"juan_jaramillo"},"items":[{"id":326,"loans_codigo":84,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:37","updated_at":"2024-11-04 21:20:45","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":452,"loans_codigo":84,"itemloans_cuota":"4","itemloans_valor_cuota":"215000","itemloans_iteres":"53750","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 21:20:45","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":456,"loans_codigo":84,"itemloans_cuota":"3","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:21:49","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":457,"loans_codigo":84,"itemloans_cuota":"4","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:21:49","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":458,"loans_codigo":84,"itemloans_cuota":"5","itemloans_valor_cuota":"206666.66666667","itemloans_iteres":"51666.666666667","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:21:49","updated_at":"2024-11-04 21:21:49","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":364,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:18:39
37479	9d6b4b66-b440-483c-a18c-499a4c4f81db	9d6b4b67-1544-46ad-ac00-2f8b728e8dba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 16:18:40
37480	9d6b4b67-0a1f-4116-8b1e-3dfaf1af495c	9d6b4b67-1544-46ad-ac00-2f8b728e8dba	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"176.33","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 16:18:41
37481	9d6b4b67-0ab8-4d6b-9524-f6fe769b0355	9d6b4b67-1544-46ad-ac00-2f8b728e8dba	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 16:18:41
37482	9d6b4b67-12c2-4587-ad53-e3a8ec6531a6	9d6b4b67-1544-46ad-ac00-2f8b728e8dba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 16:18:41
37483	9d6b4b67-136c-415b-9e19-1a8b05e1fab0	9d6b4b67-1544-46ad-ac00-2f8b728e8dba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":600,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:18:41
37484	9d6b4d07-fabd-4c12-af09-22b49d9f3ac1	9d6b4d08-1a59-41bd-b55d-cf803334b241	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 16:23:14
37485	9d6b4d08-14be-4f8c-b180-a22aa968d8b3	9d6b4d08-1a59-41bd-b55d-cf803334b241	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"41.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":26,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-05 16:23:14
37486	9d6b4d08-18b2-4537-b3f7-a5357f690e56	9d6b4d08-1a59-41bd-b55d-cf803334b241	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 16:23:14
37487	9d6b4d08-1922-474e-99a5-444f05ba85c8	9d6b4d08-1a59-41bd-b55d-cf803334b241	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":356,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:23:14
37488	9d6b4d08-68df-4a62-8e56-ed76e1e01dfa	9d6b4d08-ae3c-4f21-b982-816236f16be7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 16:23:14
37489	9d6b4d08-a9f7-4011-b7c9-0082371cb0db	9d6b4d08-ae3c-4f21-b982-816236f16be7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"150.77","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 16:23:14
37490	9d6b4d08-acf0-4eaa-bf5c-d55fa0f28bb8	9d6b4d08-ae3c-4f21-b982-816236f16be7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 16:23:14
37491	9d6b4d08-ad53-4b6e-a428-2e298ed1bf0c	9d6b4d08-ae3c-4f21-b982-816236f16be7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":359,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:23:14
34959	9d69c139-97cf-496f-8923-867ac04effb2	9d69c139-e76e-49df-8736-6afc594d0c1c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 21:56:29
34960	9d69c139-e569-4087-86c2-00c97765fd8e	9d69c139-e76e-49df-8736-6afc594d0c1c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:56:29
34961	9d69c139-e62a-462e-bded-d63fdbc28b98	9d69c139-e76e-49df-8736-6afc594d0c1c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":396,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:56:29
29298	9d69141d-af3f-48ee-a8ba-6d1d4cec013c	9d69141d-e701-49d2-806c-af58f091eb70	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 13:52:26
29299	9d69141d-e376-4bde-a82a-78c6690e2727	9d69141d-e701-49d2-806c-af58f091eb70	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 13:52:26
29300	9d69141d-e4fd-4a5f-8cfc-2af24d384dc0	9d69141d-e701-49d2-806c-af58f091eb70	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":452,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:52:26
29301	9d69141f-90a8-4dcd-8ea1-c34db1d95d83	9d69141f-dc67-48d5-8406-0bdad28b473c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 13:52:27
29302	9d69141f-d379-48d7-a27a-cac32993cee1	9d69141f-dc67-48d5-8406-0bdad28b473c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"78.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:52:27
29303	9d69141f-d3fc-4b27-84c8-0f099ea70373	9d69141f-dc67-48d5-8406-0bdad28b473c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:52:27
29304	9d69141f-da67-4f72-a7fd-b86dfcf94e36	9d69141f-dc67-48d5-8406-0bdad28b473c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-04 13:52:27
29305	9d69141f-dae4-4cef-b077-dde992622938	9d69141f-dc67-48d5-8406-0bdad28b473c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":974,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:52:27
34962	9d69c13a-550c-4aad-9b2b-24adc1a5ac7b	9d69c13a-9c3b-4255-ae49-29c71db3828f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 21:56:29
34963	9d69c13a-95c9-4d83-a763-2da095106480	9d69c13a-9c3b-4255-ae49-29c71db3828f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"143.76","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:56:29
34964	9d69c13a-961c-4777-a7b2-0bcebf599682	9d69c13a-9c3b-4255-ae49-29c71db3828f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:56:29
34965	9d69c13a-9b05-48c7-b974-39fa8755bf3d	9d69c13a-9c3b-4255-ae49-29c71db3828f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:56:29
34966	9d69c13a-9b50-42aa-92e5-54bb52daac3f	9d69c13a-9c3b-4255-ae49-29c71db3828f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":404,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:56:29
37492	9d6b4d09-02d4-4cf1-b9cb-ecb563edf5b5	9d6b4d09-216f-43e2-bfd8-b6458cd1ebc8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 16:23:14
37493	9d6b4d09-1c27-4218-944d-b803ccec40b0	9d6b4d09-216f-43e2-bfd8-b6458cd1ebc8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:23:15
37494	9d6b4d09-1c72-434b-acec-ff0d3dd1b8a8	9d6b4d09-216f-43e2-bfd8-b6458cd1ebc8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:23:15
37495	9d6b4d09-1fe7-4bf9-bb91-36f92aad613c	9d6b4d09-216f-43e2-bfd8-b6458cd1ebc8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 16:23:15
37496	9d6b4d09-2040-45c6-a8c3-df6ed4d3a845	9d6b4d09-216f-43e2-bfd8-b6458cd1ebc8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":275,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:23:15
29306	9d691420-4298-434b-9b3b-3a8c452d5b4c	9d691420-6c8e-4cfb-9c6c-77b932b6e216	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-04 13:52:27
29307	9d691420-63ef-4c8a-b397-ff019b121cc0	9d691420-6c8e-4cfb-9c6c-77b932b6e216	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"61.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 13:52:27
29308	9d691420-646c-4c0a-9242-19980320803a	9d691420-6c8e-4cfb-9c6c-77b932b6e216	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 13:52:27
29309	9d691420-6aad-473e-8919-7cc366305c4d	9d691420-6c8e-4cfb-9c6c-77b932b6e216	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-04 13:52:27
29310	9d691420-6b2c-48aa-bc3f-33eed1dfab6b	9d691420-6c8e-4cfb-9c6c-77b932b6e216	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:52:27
34967	9d69c13a-e427-45ec-9fa3-5fb3a65fedbf	9d69c13b-0417-4ed9-af00-8a741943ccd7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 21:56:29
34968	9d69c13a-fe61-4fb9-9489-f2a8d12a51cb	9d69c13b-0417-4ed9-af00-8a741943ccd7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 21:56:29
34969	9d69c13a-feb9-4438-915b-ba7238982086	9d69c13b-0417-4ed9-af00-8a741943ccd7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 21:56:29
34970	9d69c13b-02df-4ac4-8b35-7b8efe20c4d0	9d69c13b-0417-4ed9-af00-8a741943ccd7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:56:29
34971	9d69c13b-032d-4255-810d-40d52a646d1c	9d69c13b-0417-4ed9-af00-8a741943ccd7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:56:29
37497	9d6b4d09-6c07-469c-ae44-b2f7c403ac6a	9d6b4d09-89d0-4071-9089-ea37987cdf44	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 16:23:15
37498	9d6b4d09-8470-4204-b7b9-7297f417b1c4	9d6b4d09-89d0-4071-9089-ea37987cdf44	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:23:15
37499	9d6b4d09-84bd-469a-ab42-9f1098639175	9d6b4d09-89d0-4071-9089-ea37987cdf44	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:23:15
37500	9d6b4d09-883d-4b2f-895a-649232dd09eb	9d6b4d09-89d0-4071-9089-ea37987cdf44	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 16:23:15
37501	9d6b4d09-8895-4ee0-95d0-993b5822dae8	9d6b4d09-89d0-4071-9089-ea37987cdf44	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:23:15
34972	9d69c13b-4e2d-42d3-92a8-cccc500dfa86	9d69c13b-6a81-4d4f-9b6e-91a7c22ee550	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-04 21:56:30
34973	9d69c13b-65ac-4839-bdb6-031e8b1c1865	9d69c13b-6a81-4d4f-9b6e-91a7c22ee550	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:56:30
34974	9d69c13b-6600-4dcf-888c-bec69a5b391e	9d69c13b-6a81-4d4f-9b6e-91a7c22ee550	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:56:30
34975	9d69c13b-6956-42cc-9c52-e3725d483bbc	9d69c13b-6a81-4d4f-9b6e-91a7c22ee550	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:56:30
34976	9d69c13b-69a1-46ea-8934-f83f185cfa2b	9d69c13b-6a81-4d4f-9b6e-91a7c22ee550	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:56:30
37502	9d6b4d16-962d-4a0c-8137-8e8da99ce8f6	9d6b4d16-e497-4758-82d0-275834c3c106	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 16:23:23
37503	9d6b4d16-dce4-47f6-8ba9-a7e5e8f4e635	9d6b4d16-e497-4758-82d0-275834c3c106	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 93\\n                        ","time":"157.52","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9c742b70d7e4a1a77b260fd1a8993140","hostname":"EderCortes"}	2024-11-05 16:23:24
37504	9d6b4d16-dfbc-476a-ab96-a3fcd837a483	9d6b4d16-e497-4758-82d0-275834c3c106	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"2.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":304,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-05 16:23:24
37505	9d6b4d16-e328-4391-a6c1-b6e9bc71ac6d	9d6b4d16-e497-4758-82d0-275834c3c106	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 16:23:24
37506	9d6b4d16-e38d-4ca1-ab56-6a04b03d37ce	9d6b4d16-e497-4758-82d0-275834c3c106	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":93,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"1000000","loans_pago_interes":"250000","user_alias":"juan_jaramillo"},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:19:45","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000","user_alias":"eder.cortes"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:17:55","updated_at":"2024-11-04 17:22:30","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000","user_alias":"eder.cortes"},{"id":399,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:22:30","updated_at":"2024-11-04 17:27:01","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000","user_alias":"eder.cortes"},{"id":400,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:22:30","updated_at":"2024-11-04 17:27:01","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000","user_alias":"eder.cortes"},{"id":401,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:22:30","updated_at":"2024-11-04 17:27:01","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000","user_alias":"eder.cortes"},{"id":402,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 17:22:30","updated_at":"2024-11-04 17:27:01","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000","user_alias":"eder.cortes"}]}},"duration":442,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:23:24
37507	9d6b4d1c-12a2-4ea5-8300-e48091b9128e	9d6b4d1c-35c5-4ac3-a4bf-f0fc3125a381	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 16:23:27
37508	9d6b4d1c-2f46-4982-8b7f-469e6300235e	9d6b4d1c-35c5-4ac3-a4bf-f0fc3125a381	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"54.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 16:23:27
37509	9d6b4d1c-3388-43c2-b255-ac336dc46846	9d6b4d1c-35c5-4ac3-a4bf-f0fc3125a381	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 16:23:27
37510	9d6b4d1c-3442-47db-a46e-525294b01fca	9d6b4d1c-35c5-4ac3-a4bf-f0fc3125a381	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:23:27
37511	9d6b4d1c-8760-4f27-a72a-2c56a078eebb	9d6b4d1c-b607-4da0-a338-7f150cbc1337	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 16:23:27
37512	9d6b4d1c-ae70-4b50-9057-20bc9a8cc44d	9d6b4d1c-b607-4da0-a338-7f150cbc1337	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"68.35","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:23:27
37513	9d6b4d1c-aedb-424a-addd-ce8899413c1a	9d6b4d1c-b607-4da0-a338-7f150cbc1337	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:23:27
37514	9d6b4d1c-b41d-4525-88c3-8a9f901c0983	9d6b4d1c-b607-4da0-a338-7f150cbc1337	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 16:23:27
37515	9d6b4d1c-b49f-4f9c-9516-d25c1e43bed8	9d6b4d1c-b607-4da0-a338-7f150cbc1337	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":310,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:23:27
42519	9d6cdf09-d716-41d9-9bc6-c13bd78cd418	9d6cdf09-d9ff-430e-b0ba-3e51535f63d9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1962}	2024-11-06 11:07:19
26223	9d68cf24-f833-4d02-a5e6-3a98d8332cc6	9d68cf24-fc14-4769-b9bd-efdf54492356	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1212}	2024-11-04 10:39:34
16514	9d64cf11-9580-400c-85fd-717ed195fd4c	9d64cf11-9a60-4a54-ada2-342b57c9ba54	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00ab187\\u00bb\\nLINE 1: select * from \\"item_loans\\" where \\"187\\" is null\\n                                         ^ (Connection: pgsql, SQL: select * from \\"item_loans\\" where \\"187\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":322},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":768}	2024-11-02 10:56:03
37516	9d6b4d1d-0097-4981-b869-cb5aff49a139	9d6b4d1d-2618-4235-8355-9b5509aaf5f8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 16:23:28
37517	9d6b4d1d-1fab-46cd-b92f-2466694e5e38	9d6b4d1d-2618-4235-8355-9b5509aaf5f8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"54.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:23:28
37518	9d6b4d1d-200a-459f-bdeb-4cd8b59e3ee3	9d6b4d1d-2618-4235-8355-9b5509aaf5f8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:23:28
37519	9d6b4d1d-2465-43c8-9e3f-8e012e7ea195	9d6b4d1d-2618-4235-8355-9b5509aaf5f8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 16:23:28
37520	9d6b4d1d-24d5-4fd9-b559-dbe56c3a2225	9d6b4d1d-2618-4235-8355-9b5509aaf5f8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":271,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:23:28
40857	9d6cc7d8-6cef-4b0e-84a4-1acdb9a92c10	9d6cc7d8-90f2-420c-a43d-4f6034e53b0a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:02:28
40858	9d6cc7d8-8f14-44a2-b99c-e90be3e7a3ee	9d6cc7d8-90f2-420c-a43d-4f6034e53b0a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:02:28
40859	9d6cc7d8-8fd1-4cdf-a058-fe692b846512	9d6cc7d8-90f2-420c-a43d-4f6034e53b0a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":258,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:02:28
37521	9d6b4d22-5cfe-4609-a1d0-9924253ce5f2	9d6b4d22-852a-4366-a9c4-52c6d161f1e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 16:23:31
37522	9d6b4d22-7a5b-4d0b-a1d0-9dbaccb0a5f0	9d6b4d22-852a-4366-a9c4-52c6d161f1e0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 87\\n                        ","time":"61.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"309a6eff5ebe9f2d91248732844dd9ed","hostname":"EderCortes"}	2024-11-05 16:23:31
37523	9d6b4d22-7dde-403a-ae83-961462645d98	9d6b4d22-852a-4366-a9c4-52c6d161f1e0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '87' order by \\"item_loans\\".\\"id\\" asc","time":"3.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":304,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-05 16:23:31
37524	9d6b4d22-83b5-42f8-bf50-46b2c3ece11c	9d6b4d22-852a-4366-a9c4-52c6d161f1e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 16:23:31
37525	9d6b4d22-841b-45f0-93cf-d961ad67cf43	9d6b4d22-852a-4366-a9c4-52c6d161f1e0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/87","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":87,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"460000","loans_pago_interes":"115000","user_alias":"juan_jaramillo"},"items":[{"id":341,"loans_codigo":87,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 20:50:52","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000","user_alias":"eder.cortes"},{"id":342,"loans_codigo":87,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 21:01:12","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":445,"loans_codigo":87,"itemloans_cuota":"3","itemloans_valor_cuota":"160000","itemloans_iteres":"40000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:01:12","updated_at":"2024-11-04 21:01:12","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":446,"loans_codigo":87,"itemloans_cuota":"4","itemloans_valor_cuota":"160000","itemloans_iteres":"40000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:01:12","updated_at":"2024-11-04 21:01:12","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":447,"loans_codigo":87,"itemloans_cuota":"5","itemloans_valor_cuota":"160000","itemloans_iteres":"40000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:01:12","updated_at":"2024-11-04 21:01:12","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":448,"loans_codigo":87,"itemloans_cuota":"6","itemloans_valor_cuota":"160000","itemloans_iteres":"40000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-04 21:01:12","updated_at":"2024-11-04 21:01:12","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":294,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:23:31
30528	9d693fd1-0453-437e-a079-97577f674d35	9d693fd1-4e12-4cd5-94b1-b7d21c2f5408	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 15:54:37
30529	9d693fd1-4c7b-4e38-b560-9f4cabfa3a92	9d693fd1-4e12-4cd5-94b1-b7d21c2f5408	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 15:54:38
30530	9d693fd1-4d19-46ba-9478-7c48b1c4afd5	9d693fd1-4e12-4cd5-94b1-b7d21c2f5408	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":359,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:54:38
30531	9d693fd1-a275-436f-9873-74729b1efe39	9d693fd1-eae4-4b5b-a27c-230eb314d6b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 15:54:38
30532	9d693fd1-e27d-4f8a-a2ee-9e8536801033	9d693fd1-eae4-4b5b-a27c-230eb314d6b0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"151.39","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 15:54:38
30533	9d693fd1-e5ff-48dd-8d67-978e55b391da	9d693fd1-eae4-4b5b-a27c-230eb314d6b0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"1.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 15:54:38
30534	9d693fd1-e62f-47f0-8ec9-1936a155344e	9d693fd1-eae4-4b5b-a27c-230eb314d6b0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 15:54:38
30535	9d693fd1-e9bc-4542-aaf4-9da0d0e9283e	9d693fd1-eae4-4b5b-a27c-230eb314d6b0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 15:54:38
30536	9d693fd1-ea02-4c72-a1b3-dfeca99241fa	9d693fd1-eae4-4b5b-a27c-230eb314d6b0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:54:38
37526	9d6b4d3d-e7fa-44a9-8295-833e51ec4772	9d6b4d3d-eb98-41d5-b834-a6a5fb327aac	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":144,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:23:49
37527	9d6b4d3e-506c-4e36-90b9-405682cbe0ef	9d6b4d3e-b58f-4da5-a4a1-0c1bdb0ecbb5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 16:23:49
37528	9d6b4d3e-89c3-478b-a930-a328412ef500	9d6b4d3e-b58f-4da5-a4a1-0c1bdb0ecbb5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 87 limit 1","time":"3.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":506,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-05 16:23:50
37529	9d6b4d3e-8a2c-450f-88d1-0b50233ebff0	9d6b4d3e-b58f-4da5-a4a1-0c1bdb0ecbb5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":2,"hostname":"EderCortes"}	2024-11-05 16:23:50
37530	9d6b4d3e-934c-4fb2-ad07-4604411701a6	9d6b4d3e-b58f-4da5-a4a1-0c1bdb0ecbb5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select count(*) as aggregate from \\"item_loans\\" where \\"loans_codigo\\" = 87 and (\\"itemloans_status\\" = 'Pagada' or \\"itemloans_status\\" = 'Abono')","time":"2.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":567,"hash":"40bb62c1101cd4a074e44b13c59d4517","hostname":"EderCortes"}	2024-11-05 16:23:50
30541	9d693fd3-2c5d-4b56-a1b4-05729cb17002	9d693fd3-5c10-4d80-a8b9-b5ceb543e6f7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 15:54:39
37531	9d6b4d3e-9415-4a63-9e3c-b20fbba2e717	9d6b4d3e-b58f-4da5-a4a1-0c1bdb0ecbb5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"loans\\" set \\"loans_fecha_ultimo_pago\\" = '05-11-2024', \\"loans_pago_interes\\" = 155000, \\"loans_pago_prestado\\" = 620000, \\"updated_at\\" = '2024-11-05 16:23:50' where \\"id\\" = 87","time":"1.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":606,"hash":"138ffd5a6aae2847ac945cb6fb277db0","hostname":"EderCortes"}	2024-11-05 16:23:50
37532	9d6b4d3e-9a73-4cf1-bc85-084435e31775	9d6b4d3e-b58f-4da5-a4a1-0c1bdb0ecbb5	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\Loans:87","changes":{"updated_at":"2024-11-05 16:23:50","loans_fecha_ultimo_pago":"05-11-2024","loans_pago_interes":155000,"loans_pago_prestado":620000},"hostname":"EderCortes"}	2024-11-05 16:23:50
37533	9d6b4d3e-9b0c-498a-aebb-07ffcba20179	9d6b4d3e-b58f-4da5-a4a1-0c1bdb0ecbb5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = 87 and \\"itemloans_status\\" = 'Pendiente' limit 1","time":"0.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":613,"hash":"62d7c91b9283f4e3b80d65e81d10378e","hostname":"EderCortes"}	2024-11-05 16:23:50
37534	9d6b4d3e-9b39-4af1-8bc4-fc9678746a5c	9d6b4d3e-b58f-4da5-a4a1-0c1bdb0ecbb5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":1,"hostname":"EderCortes"}	2024-11-05 16:23:50
37535	9d6b4d3e-9c8b-4ab2-9196-e88c927d3d5a	9d6b4d3e-b58f-4da5-a4a1-0c1bdb0ecbb5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"update \\"item_loans\\" set \\"itemloans_status\\" = 'Abono', \\"itemloans_aprobador\\" = 12, \\"item_loans_cuando_pago\\" = '05-11-2024', \\"itemloans_interes_canelado\\" = 40000, \\"itemloans_cuota_cancelada\\" = 160000, \\"updated_at\\" = '2024-11-05 16:23:50' where \\"id\\" = 445","time":"2.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":621,"hash":"6acd4a1714feb503cbc85629417266cf","hostname":"EderCortes"}	2024-11-05 16:23:50
37536	9d6b4d3e-9ccd-435f-8c24-c85bc64fca69	9d6b4d3e-b58f-4da5-a4a1-0c1bdb0ecbb5	\N	t	model	{"action":"updated","model":"App\\\\Models\\\\ItemLoans:445","changes":{"itemloans_status":"Abono","itemloans_aprobador":12,"updated_at":"2024-11-05 16:23:50","item_loans_cuando_pago":"05-11-2024","itemloans_interes_canelado":40000,"itemloans_cuota_cancelada":160000},"hostname":"EderCortes"}	2024-11-05 16:23:50
37537	9d6b4d3e-9eb9-411f-ab93-01c7598bf842	9d6b4d3e-b58f-4da5-a4a1-0c1bdb0ecbb5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"delete from \\"item_loans\\" where \\"loans_codigo\\" = 87 and \\"itemloans_status\\" = 'Pendiente'","time":"4.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":628,"hash":"89bf3c496a8b0746ff5d1219b8dc29e3","hostname":"EderCortes"}	2024-11-05 16:23:50
37538	9d6b4d3e-9f24-4e19-8194-30d6384cb87f	9d6b4d3e-b58f-4da5-a4a1-0c1bdb0ecbb5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"loans\\" where \\"loans\\".\\"id\\" = 87 limit 1","time":"0.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":631,"hash":"81ce909daee311fd62bf2c463c6e4ba1","hostname":"EderCortes"}	2024-11-05 16:23:50
37539	9d6b4d3e-a325-4e9c-a84e-445766d66679	9d6b4d3e-b58f-4da5-a4a1-0c1bdb0ecbb5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (87, 4, 240000, 60000, 'Pendiente', 'Se realiza abono', '13-11-2024', 0, 0, '2024-11-05 16:23:50', '2024-11-05 16:23:50')","time":"1.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":687,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-05 16:23:50
37540	9d6b4d3e-a34c-4fcf-aebb-e41a4a43be17	9d6b4d3e-b58f-4da5-a4a1-0c1bdb0ecbb5	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-05 16:23:50
37541	9d6b4d3e-a3b0-4e9c-ba2a-e92414a96f12	9d6b4d3e-b58f-4da5-a4a1-0c1bdb0ecbb5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"insert into \\"item_loans\\" (\\"loans_codigo\\", \\"itemloans_cuota\\", \\"itemloans_valor_cuota\\", \\"itemloans_iteres\\", \\"itemloans_status\\", \\"itemloass_observacion\\", \\"itemloans_fecha_pago\\", \\"itemloans_interes_canelado\\", \\"itemloans_cuota_cancelada\\", \\"updated_at\\", \\"created_at\\") values (87, 5, 240000, 60000, 'Pendiente', 'Se realiza abono', '21-11-2024', 0, 0, '2024-11-05 16:23:50', '2024-11-05 16:23:50')","time":"0.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":687,"hash":"1db272627e84e62eb9307f17edf3acba","hostname":"EderCortes"}	2024-11-05 16:23:50
37542	9d6b4d3e-a3cd-42c8-865b-257195aaf59f	9d6b4d3e-b58f-4da5-a4a1-0c1bdb0ecbb5	\N	t	model	{"action":"created","model":"App\\\\Models\\\\ItemLoans:","hostname":"EderCortes"}	2024-11-05 16:23:50
37543	9d6b4d3e-b447-40df-a484-b915ad9226b7	9d6b4d3e-b58f-4da5-a4a1-0c1bdb0ecbb5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 16:23:50
37544	9d6b4d3e-b48f-41de-9921-ad1e3abf15b6	9d6b4d3e-b58f-4da5-a4a1-0c1bdb0ecbb5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/pay-abono-credit","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@payAbono","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"61","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"valueAbono":"200000","idLoans":87,"itemloans_aprobador":12},"session":[],"response_status":200,"response":{"message":"El abono fue aplicado exitosamente","status":true},"duration":412,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:23:50
30542	9d693fd3-531c-4e4b-90e5-f37b9b5d8e5e	9d693fd3-5c10-4d80-a8b9-b5ceb543e6f7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"60.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":58,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 15:54:39
30543	9d693fd3-539c-42a7-96d7-466d9c7b0148	9d693fd3-5c10-4d80-a8b9-b5ceb543e6f7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 15:54:39
37545	9d6b4d3f-00bf-4bed-9049-3544da612aa9	9d6b4d3f-1db3-4921-a5a0-cdb96590670c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 16:23:50
37546	9d6b4d3f-1653-47b8-8f3a-3b69e62e0600	9d6b4d3f-1db3-4921-a5a0-cdb96590670c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 87\\n                        ","time":"44.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"309a6eff5ebe9f2d91248732844dd9ed","hostname":"EderCortes"}	2024-11-05 16:23:50
37547	9d6b4d3f-194e-42ac-a58d-f6e63e21b854	9d6b4d3f-1db3-4921-a5a0-cdb96590670c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" left join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '87' order by \\"item_loans\\".\\"id\\" asc","time":"3.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":304,"hash":"56211d3b53875ba3879fa400cb394e82","hostname":"EderCortes"}	2024-11-05 16:23:50
37548	9d6b4d3f-1c8f-4e8b-bce8-c762684159b4	9d6b4d3f-1db3-4921-a5a0-cdb96590670c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 16:23:50
30544	9d693fd3-5a08-4550-a27b-b431f732ba19	9d693fd3-5c10-4d80-a8b9-b5ceb543e6f7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-04 15:54:39
37549	9d6b4d3f-1cd4-44b3-9ce1-7acd2d449537	9d6b4d3f-1db3-4921-a5a0-cdb96590670c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/87","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":87,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"620000","loans_pago_interes":"155000","user_alias":"juan_jaramillo"},"items":[{"id":341,"loans_codigo":87,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 20:50:52","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"55000","itemloans_cuota_cancelada":"220000","user_alias":"eder.cortes"},{"id":342,"loans_codigo":87,"itemloans_cuota":"2","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 09:18:38","updated_at":"2024-11-04 21:01:12","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000","user_alias":"eder.cortes"},{"id":445,"loans_codigo":87,"itemloans_cuota":"3","itemloans_valor_cuota":"160000","itemloans_iteres":"40000","itemloans_status":"Abono","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 21:01:12","updated_at":"2024-11-05 16:23:50","deleted_at":null,"item_loans_cuando_pago":"2024-11-05 00:00:00","itemloans_interes_canelado":"40000","itemloans_cuota_cancelada":"160000","user_alias":"eder.cortes"},{"id":485,"loans_codigo":87,"itemloans_cuota":"4","itemloans_valor_cuota":"240000","itemloans_iteres":"60000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-13 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-05 16:23:50","updated_at":"2024-11-05 16:23:50","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null},{"id":486,"loans_codigo":87,"itemloans_cuota":"5","itemloans_valor_cuota":"240000","itemloans_iteres":"60000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-21 00:00:00","itemloans_aprobador":null,"created_at":"2024-11-05 16:23:50","updated_at":"2024-11-05 16:23:50","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":null}]}},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:23:50
37550	9d6b582d-b8fb-4d2c-8952-b68d78c2f26d	9d6b582d-d8be-4f8e-aff0-6c3b2ebb301f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 16:54:24
37551	9d6b582d-d340-49cb-aecc-5ca26801d46b	9d6b582d-d8be-4f8e-aff0-6c3b2ebb301f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"40.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":26,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-05 16:54:24
37552	9d6b582d-d71b-4e4e-9b39-cfbb430ecc27	9d6b582d-d8be-4f8e-aff0-6c3b2ebb301f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 16:54:24
37553	9d6b582d-d78f-4d4c-a01a-42229e8d535c	9d6b582d-d8be-4f8e-aff0-6c3b2ebb301f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":277,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:54:24
37554	9d6b584a-c6e0-4289-989c-54c0beafd3f2	9d6b584b-108e-48ac-a0f5-89fedd9ea15c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 16:54:43
37555	9d6b584b-0ab8-4103-9d6f-963ae2f335a0	9d6b584b-108e-48ac-a0f5-89fedd9ea15c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"146.61","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:54:43
37556	9d6b584b-0b0e-4303-9069-92100d00775a	9d6b584b-108e-48ac-a0f5-89fedd9ea15c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:54:43
37557	9d6b584b-0f31-423c-9e62-adaa77ae340e	9d6b584b-108e-48ac-a0f5-89fedd9ea15c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 16:54:43
37558	9d6b584b-0f76-415b-8fb9-caa3548c8102	9d6b584b-108e-48ac-a0f5-89fedd9ea15c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":476,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:54:43
43458	9d6cea03-8f2f-4dc0-be8c-d85fff45e5b7	9d6cea03-91e6-4f09-bcc9-edc0cd6c2295	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2029}	2024-11-06 11:38:01
987	9d4f3b9d-b48a-4e71-b71f-b044b5f0fec4	9d4f3b9d-b964-4377-b8bd-f3a3a5fdcd66	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42P01]: Undefined table: 7 ERROR:  falta una entrada para la tabla \\u00abuser\\u00bb en la cl\\u00e1usula FROM\\nLINE 1: select * from \\"users\\" where \\"user\\".\\"profile_code\\" = $1 and \\"...\\n                                    ^ (Connection: pgsql, SQL: select * from \\"users\\" where \\"user\\".\\"profile_code\\" = 5 and \\"users\\".\\"deleted_at\\" is null order by \\"menu\\".\\"created_at\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":45},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":78}	2024-10-22 17:31:21
2715	9d50fb37-a35f-4a9c-971d-3ae95ce0e27d	9d50fb37-a831-4c3a-9781-6f2932514bbd	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":154}	2024-10-23 14:22:56
37559	9d6b584b-561f-493d-ac0c-b5ae0553a6a1	9d6b584b-7615-4a23-9f5b-3c8e6f29737f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 16:54:43
37560	9d6b584b-6fdc-421f-9e6c-534cac204158	9d6b584b-7615-4a23-9f5b-3c8e6f29737f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-05 16:54:44
37561	9d6b584b-7042-4b15-8956-faf9c986f1bd	9d6b584b-7615-4a23-9f5b-3c8e6f29737f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-05 16:54:44
37562	9d6b584b-749d-4306-8072-7622cab6eb4a	9d6b584b-7615-4a23-9f5b-3c8e6f29737f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 16:54:44
37563	9d6b584b-74ea-4d86-8189-9ea04da3fd2c	9d6b584b-7615-4a23-9f5b-3c8e6f29737f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:54:44
430	9d4f284c-d46a-46ae-9afc-7b0f444a1320	9d4f284c-d773-460f-8aee-9e6752cc2a64	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":27}	2024-10-22 16:37:21
37564	9d6b584b-be4f-4b32-ba32-57a8a4fc2b9d	9d6b584b-dce9-4af9-985f-4435959049bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 16:54:44
37565	9d6b584b-d73f-4afc-812d-cc0666d5f3d4	9d6b584b-dce9-4af9-985f-4435959049bd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:54:44
37566	9d6b584b-d7ac-4c1e-9885-3e72a57d81bc	9d6b584b-dce9-4af9-985f-4435959049bd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-05 16:54:44
37567	9d6b584b-dbb4-49a5-9d00-824ef7287b88	9d6b584b-dce9-4af9-985f-4435959049bd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 16:54:44
37568	9d6b584b-dbf6-489b-95aa-7706947f9783	9d6b584b-dce9-4af9-985f-4435959049bd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:54:44
37569	9d6b584c-20c0-4fb0-8841-c35352ff5f69	9d6b584c-3f08-478e-a06c-7375a94cc3a0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 16:54:44
37570	9d6b584c-381c-4cfc-9679-d9aeb1feacae	9d6b584c-3f08-478e-a06c-7375a94cc3a0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_valor_prestado\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\" from \\"loans\\" where \\"id\\" = '93' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"40.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":229,"hash":"f00e27e21a94f93c5c7a1d0cd56f9f13","hostname":"EderCortes"}	2024-11-05 16:54:44
37571	9d6b584c-3869-4d5f-8f00-83b2a7b592ff	9d6b584c-3f08-478e-a06c-7375a94cc3a0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-05 16:54:44
37572	9d6b584c-3a25-4033-a287-22efd62e187b	9d6b584c-3f08-478e-a06c-7375a94cc3a0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"1.91","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":230,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-05 16:54:44
37573	9d6b584c-3a56-493b-babf-6567e0e61046	9d6b584c-3f08-478e-a06c-7375a94cc3a0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-05 16:54:44
37574	9d6b584c-3dc5-4c75-9a00-805b348ba6bb	9d6b584c-3f08-478e-a06c-7375a94cc3a0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 16:54:44
37575	9d6b584c-3e0c-4025-8426-46a71c284fc5	9d6b584c-3f08-478e-a06c-7375a94cc3a0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"user_creador":22,"user_cobrador":22,"user_customer":19,"user_recomendacion":18},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:19:45.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:22:30.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":399,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":400,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":401,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":402,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"}]}},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:54:44
41259	9d6ccc1f-ae68-4c34-97c8-734937f1c863	9d6ccc1f-fab0-4a0c-8286-49752749a60a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:14:26
41260	9d6ccc1f-f7ba-448c-85ad-a4bce39494c7	9d6ccc1f-fab0-4a0c-8286-49752749a60a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:14:26
41261	9d6ccc1f-f8fa-4273-8585-b98ad00903ed	9d6ccc1f-fab0-4a0c-8286-49752749a60a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":477,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:14:26
41262	9d6ccc20-dc88-42ad-a189-683d9a1dae63	9d6ccc21-09a3-4917-bf28-f2b97bb23063	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:14:27
29437	9d69246d-d73c-4c26-894e-59b066807b3a	9d69246e-03c2-4aee-bbce-543225d69ca3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 14:38:03
29438	9d69246e-01ce-4fc3-866e-59a6030ff0c7	9d69246e-03c2-4aee-bbce-543225d69ca3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 14:38:03
29439	9d69246e-02ac-4fc1-9db3-fdba89dc02f6	9d69246e-03c2-4aee-bbce-543225d69ca3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":317,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:38:03
41263	9d6ccc21-01bb-4725-9535-976910c4ee93	9d6ccc21-09a3-4917-bf28-f2b97bb23063	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"62.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 10:14:27
41264	9d6ccc21-074e-4303-b2cd-11ac3cac8a77	9d6ccc21-09a3-4917-bf28-f2b97bb23063	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:14:27
41265	9d6ccc21-07d3-4c99-a83a-4ea1e83ab2ff	9d6ccc21-09a3-4917-bf28-f2b97bb23063	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":555,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:14:27
29440	9d69246e-68d1-4957-81ed-fdb17d3986c1	9d69246e-b45d-43db-9fda-67e7e2ae8140	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 14:38:03
29441	9d69246e-aa34-4f18-aef3-f9a4c0d3d805	9d69246e-b45d-43db-9fda-67e7e2ae8140	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 89\\n                        ","time":"153.23","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"9d02b7b0df63d393d83fadb041468b51","hostname":"EderCortes"}	2024-11-04 14:38:03
29442	9d69246e-adec-438d-afd4-6cb4ea98348e	9d69246e-b45d-43db-9fda-67e7e2ae8140	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '89' order by \\"item_loans\\".\\"id\\" asc","time":"2.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":299,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 14:38:03
29443	9d69246e-ae39-4bfd-b124-cf6e0a53ab31	9d69246e-b45d-43db-9fda-67e7e2ae8140	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 14:38:03
29444	9d69246e-b303-4791-9d2a-980e42f1c549	9d69246e-b45d-43db-9fda-67e7e2ae8140	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 14:38:03
29445	9d69246e-b356-4431-9b3a-513697e3171c	9d69246e-b45d-43db-9fda-67e7e2ae8140	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/89","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":89,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1100000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"584000","loans_pago_interes":"146000","user_alias":"eder_cortes"},"items":[{"id":351,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"220000","itemloans_iteres":"55000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T14:18:39.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"60000","itemloans_cuota_cancelada":"240000"},{"id":366,"loans_codigo":89,"itemloans_cuota":"1","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:39:58.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":367,"loans_codigo":89,"itemloans_cuota":"2","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T18:14:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"43000","itemloans_cuota_cancelada":"172000"},{"id":368,"loans_codigo":89,"itemloans_cuota":"3","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":369,"loans_codigo":89,"itemloans_cuota":"4","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"},{"id":370,"loans_codigo":89,"itemloans_cuota":"5","itemloans_valor_cuota":"172000","itemloans_iteres":"43000","itemloans_status":"Pendiente","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":"12","created_at":"2024-11-04T15:36:27.000000Z","updated_at":"2024-11-04T15:36:27.000000Z","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0"}]}},"duration":379,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:38:03
41266	9d6ccc21-8b52-4061-8709-d452ed5344eb	9d6ccc21-b625-4af4-b4b0-69ba0573bef9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:14:27
30545	9d693fd3-5a87-4a7a-a683-530823fcbaa4	9d693fd3-5c10-4d80-a8b9-b5ceb543e6f7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:47:38.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":416,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:54:39
41267	9d6ccc21-ae7f-4a04-829b-cc8cdfbec1ab	9d6ccc21-b625-4af4-b4b0-69ba0573bef9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"52.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:14:27
41268	9d6ccc21-aef2-4eda-8661-0bad8a9467a3	9d6ccc21-b625-4af4-b4b0-69ba0573bef9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:14:27
41269	9d6ccc21-b489-477c-baa3-6b266241715b	9d6ccc21-b625-4af4-b4b0-69ba0573bef9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:14:27
41270	9d6ccc21-b4e9-43d2-bab8-2945a7234ff3	9d6ccc21-b625-4af4-b4b0-69ba0573bef9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":422,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:14:27
41271	9d6ccc21-ff8c-472e-9372-bd4fb6704e58	9d6ccc22-4757-4b0f-a5a0-179eec90634d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:14:28
41272	9d6ccc22-428e-42da-b65f-359b079ad8db	9d6ccc22-4757-4b0f-a5a0-179eec90634d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"150.22","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:14:28
41273	9d6ccc22-42e0-454a-bf09-16373694b4b8	9d6ccc22-4757-4b0f-a5a0-179eec90634d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:14:28
41274	9d6ccc22-4620-4193-932e-d77ae3907737	9d6ccc22-4757-4b0f-a5a0-179eec90634d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:14:28
29450	9d692471-5618-4ecb-ada5-675c3ef15e22	9d692471-ef93-4ca3-b077-81dbcb47a660	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 14:38:05
30546	9d693fd4-49c9-4d3f-aee7-b75c01db46e8	9d693fd4-ba5f-43ef-a434-f0271440d0bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-04 15:54:40
41275	9d6ccc22-4666-4105-bbb9-21a773b1f38d	9d6ccc22-4757-4b0f-a5a0-179eec90634d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":350,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:14:28
43140	9d6ce508-4c0a-4b0d-907d-350dd685a6f3	9d6ce508-4ff6-4819-b0a8-a8a608a464bb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abFROM\\u00bb\\nLINE 19:                         FROM users\\n                                 ^ (Connection: pgsql, SQL: \\n                     SELECT id,\\n                            name,\\n                            profile_code,\\n                            profile_name,\\n                            profile_prefix,\\n                            remember_token,\\n                            user_address,\\n                            user_age,\\n                            user_alias,\\n                            user_birth,\\n                            user_cellphone,\\n                            user_city,\\n                            user_document,\\n                            user_document_type,\\n                            user_last_name_one,\\n                            user_last_name_two,\\n                            user_neighborhood,\\n                        FROM users\\n                        WHERE profile_code = 4;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":142},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1992}	2024-11-06 11:24:05
40584	9d6cc5c9-1e82-4dab-9271-a484522bf249	9d6cc5c9-222c-43f3-8e7d-aed7376ef388	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1829}	2024-11-06 09:56:43
26933	9d68ddbb-c431-4edc-8fd7-b29266b114dc	9d68ddbb-c7b0-4e7c-857e-5e73c87ff53a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1257}	2024-11-04 11:20:22
41276	9d6ccc24-cea6-46e9-b49b-99d5b5e23340	9d6ccc24-d46f-438b-a1cc-acd7b753955f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":385,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:14:29
41277	9d6ccc25-5d45-4c41-8e82-75eb80ab118b	9d6ccc25-7f67-4f22-a236-fe49845a96c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:14:30
41278	9d6ccc25-78bc-4edb-bd5d-ab6a8a72de9f	9d6ccc25-7f67-4f22-a236-fe49845a96c4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"50.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:14:30
41279	9d6ccc25-7d9d-4b40-9152-176a721e0e7e	9d6ccc25-7f67-4f22-a236-fe49845a96c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:14:30
41280	9d6ccc25-7e12-4e0f-9929-3ac6553b9ab2	9d6ccc25-7f67-4f22-a236-fe49845a96c4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":352,"memory":20,"hostname":"EderCortes"}	2024-11-06 10:14:30
41281	9d6ccc25-feb2-477e-9bc8-519f2d75ca9c	9d6ccc26-2d2a-492b-b683-9743eba66b18	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:14:30
41282	9d6ccc26-2548-493a-a205-34f4f2092330	9d6ccc26-2d2a-492b-b683-9743eba66b18	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"60.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:14:30
41283	9d6ccc26-25d7-42fd-a719-36e6e68e0d34	9d6ccc26-2d2a-492b-b683-9743eba66b18	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:14:30
41284	9d6ccc26-2b50-46f7-b065-d3da5a119225	9d6ccc26-2d2a-492b-b683-9743eba66b18	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:14:30
41285	9d6ccc26-2bc6-42d4-b0d6-545c7a226a65	9d6ccc26-2d2a-492b-b683-9743eba66b18	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":426,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:14:30
41286	9d6ccc26-e393-4fb7-a294-b8ebe67fc5c1	9d6ccc27-2eef-41e4-b877-edb507bc1af8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:14:31
41287	9d6ccc27-2a5f-4ada-8280-bdfffad0d804	9d6ccc27-2eef-41e4-b877-edb507bc1af8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"158.52","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 10:14:31
41288	9d6ccc27-2d77-44a9-ad90-af539fbe36e6	9d6ccc27-2eef-41e4-b877-edb507bc1af8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:14:31
41289	9d6ccc27-2de7-48e8-9e02-7a01335a4b3a	9d6ccc27-2eef-41e4-b877-edb507bc1af8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":644,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:14:31
40470	9d6cc3bf-5d73-4638-bcc5-62d9f4b6372a	9d6cc3bf-9d62-47d7-9cfe-31575a6b2f0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:51:01
40471	9d6cc3bf-9bff-47ff-8ef2-82e6ac15991b	9d6cc3bf-9d62-47d7-9cfe-31575a6b2f0d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 09:51:01
40472	9d6cc3bf-9c89-4f58-a154-ec9d87f71a8c	9d6cc3bf-9d62-47d7-9cfe-31575a6b2f0d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":313,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:51:01
35169	9d69c2e2-fcdc-472c-90d1-0f5456c6c826	9d69c2e3-1993-4da0-b719-2dd786bec6d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 22:01:07
35170	9d69c2e3-1815-4038-b6b6-bca3bf86e3ff	9d69c2e3-1993-4da0-b719-2dd786bec6d3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 22:01:07
35171	9d69c2e3-18aa-4175-b233-7287dfd9f559	9d69c2e3-1993-4da0-b719-2dd786bec6d3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:01:07
35172	9d69c2e3-6dd7-4214-bf49-766c691aa688	9d69c2e3-9703-4a6b-96c4-eaf5a5530d2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 22:01:08
35173	9d69c2e3-8d66-4932-b6ed-7bedcee2e18c	9d69c2e3-9703-4a6b-96c4-eaf5a5530d2b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"55.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:01:08
35174	9d69c2e3-8df2-4cd1-81e0-b4d74f4c4966	9d69c2e3-9703-4a6b-96c4-eaf5a5530d2b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:01:08
35175	9d69c2e3-94d2-4739-b6fb-7f59f879c7ad	9d69c2e3-9703-4a6b-96c4-eaf5a5530d2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 22:01:08
35176	9d69c2e3-958d-46f1-a876-edaaf266b0f0	9d69c2e3-9703-4a6b-96c4-eaf5a5530d2b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":262,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:01:08
40473	9d6cc3c0-b06c-447a-8fb2-2ae4ca3f39e1	9d6cc3c0-f787-4985-8d45-2163de24a878	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 09:51:02
40474	9d6cc3c0-f2e8-4218-ad64-36efd6ed3a7d	9d6cc3c0-f787-4985-8d45-2163de24a878	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"151.85","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:51:02
40475	9d6cc3c0-f350-436b-8ed8-36c8bdcf816c	9d6cc3c0-f787-4985-8d45-2163de24a878	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:51:02
40476	9d6cc3c0-f67d-404f-82e7-2a1e05b8422b	9d6cc3c0-f787-4985-8d45-2163de24a878	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 09:51:02
40477	9d6cc3c0-f6c1-4345-9fab-72297c44e80e	9d6cc3c0-f787-4985-8d45-2163de24a878	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:51:02
35177	9d69c2e4-0d07-47e4-a060-067ebbc83a03	9d69c2e4-35eb-422f-912e-3981abaf32fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 22:01:08
35178	9d69c2e4-3020-487a-9a24-fd3b16ffda7b	9d69c2e4-35eb-422f-912e-3981abaf32fd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 22:01:08
35179	9d69c2e4-3072-4bfb-9da7-0b1c06fd1920	9d69c2e4-35eb-422f-912e-3981abaf32fd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 22:01:08
35180	9d69c2e4-34bd-406a-98d6-ae0998520d9c	9d69c2e4-35eb-422f-912e-3981abaf32fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 22:01:08
35181	9d69c2e4-350b-49d0-bac3-892d0fc8a235	9d69c2e4-35eb-422f-912e-3981abaf32fd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":387,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:01:08
40478	9d6cc3c1-41b2-49ca-8cae-7e6957641d0d	9d6cc3c1-5deb-495a-beb0-bb8e08e95efc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 09:51:02
40479	9d6cc3c1-5940-4fe7-b784-077ea7db0551	9d6cc3c1-5deb-495a-beb0-bb8e08e95efc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"46.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:51:02
40480	9d6cc3c1-5c7b-4f64-ab51-d059fbf8a3ef	9d6cc3c1-5deb-495a-beb0-bb8e08e95efc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 09:51:02
40481	9d6cc3c1-5cd5-43aa-b8e9-f7c5c4b5a21a	9d6cc3c1-5deb-495a-beb0-bb8e08e95efc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:51:02
35182	9d69c2e4-8023-4f3d-9a14-2da82007bda6	9d69c2e4-a518-4f2b-a33b-6ddd574cd28a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 22:01:08
35183	9d69c2e4-9e99-4676-9854-e88d977dce84	9d69c2e4-a518-4f2b-a33b-6ddd574cd28a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"50.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:01:08
35184	9d69c2e4-9ef1-4413-ac5c-a555bf73775f	9d69c2e4-a518-4f2b-a33b-6ddd574cd28a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:01:08
35185	9d69c2e4-a3b5-46db-bd83-9235535754ea	9d69c2e4-a518-4f2b-a33b-6ddd574cd28a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 22:01:08
35186	9d69c2e4-a40a-4e37-ab73-0bbbba092cf4	9d69c2e4-a518-4f2b-a33b-6ddd574cd28a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:01:08
35187	9d69c2e5-2cb5-4bcc-b1ad-eed9f915e0de	9d69c2e5-669c-4b75-ae1f-e55558928850	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 22:01:09
35188	9d69c2e5-5d6b-43fd-9c34-5e667f6ccbdd	9d69c2e5-669c-4b75-ae1f-e55558928850	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"76.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:01:09
35189	9d69c2e5-5e18-470a-8007-9ebd2f9f8d0c	9d69c2e5-669c-4b75-ae1f-e55558928850	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:01:09
35190	9d69c2e5-64b9-47c7-a1d6-99e7a852fb57	9d69c2e5-669c-4b75-ae1f-e55558928850	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 22:01:09
35191	9d69c2e5-654f-420e-a919-6ae0fb13f12a	9d69c2e5-669c-4b75-ae1f-e55558928850	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":473,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:01:09
35192	9d69c2e6-061e-46de-b689-628754b153de	9d69c2e6-383f-4eb7-b566-5aa138f05f34	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 22:01:09
35193	9d69c2e6-2fd6-440e-bca9-bb720c88d4c5	9d69c2e6-383f-4eb7-b566-5aa138f05f34	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"63.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:01:09
35194	9d69c2e6-3061-467f-871c-32af8d377ccd	9d69c2e6-383f-4eb7-b566-5aa138f05f34	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:01:09
35195	9d69c2e6-3676-4858-ba5e-3fe7b7a46751	9d69c2e6-383f-4eb7-b566-5aa138f05f34	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 22:01:09
35196	9d69c2e6-36f4-4900-9f37-ba06a5d08e00	9d69c2e6-383f-4eb7-b566-5aa138f05f34	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":478,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:01:09
40555	9d6cc4e6-429d-4b8d-87f2-bdc117bcb6da	9d6cc4e6-5f23-42d1-b5a9-60adfb00a96d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:54:14
40556	9d6cc4e6-5d2b-45b8-a1d2-cf4561aeaa68	9d6cc4e6-5f23-42d1-b5a9-60adfb00a96d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 09:54:14
40557	9d6cc4e6-5dc5-49d3-801e-9102130ebef4	9d6cc4e6-5f23-42d1-b5a9-60adfb00a96d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":255,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:54:14
25556	9d68c718-071d-4af7-9e06-1128dc1c2539	9d68c718-0a63-4c4b-b3e0-6316734fa01d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1170}	2024-11-04 10:17:04
28621	9d690214-91a9-4f42-bba1-a66dbde95a0b	9d690214-e411-49ed-a734-4ac1973ca29a	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-04 13:02:00
28622	9d690214-e1df-4492-98a0-3c1cf143a524	9d690214-e411-49ed-a734-4ac1973ca29a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 13:02:00
28623	9d690214-e2c0-4fd2-8645-843a3ae2a42f	9d690214-e411-49ed-a734-4ac1973ca29a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":566,"memory":22,"hostname":"EderCortes"}	2024-11-04 13:02:00
35324	9d69c3ff-e4d1-40c3-983e-c768a56f46e7	9d69c400-01e1-4467-9aad-927bb191d2c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 22:04:14
35325	9d69c400-003a-4a1b-9339-14b63a08f232	9d69c400-01e1-4467-9aad-927bb191d2c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 22:04:14
35326	9d69c400-00d8-4462-bd69-b824532920f2	9d69c400-01e1-4467-9aad-927bb191d2c4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":233,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:04:14
35327	9d69c400-54d4-4659-8d71-da582ba2c0b0	9d69c400-722d-4486-a61f-f688f09846cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 22:04:14
35328	9d69c400-6d68-4c64-b081-5ced898d39f3	9d69c400-722d-4486-a61f-f688f09846cf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:04:14
35329	9d69c400-6db7-46fa-a4ed-2feed800f8b0	9d69c400-722d-4486-a61f-f688f09846cf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:04:14
35330	9d69c400-7125-4906-acc8-5a141e4d92a1	9d69c400-722d-4486-a61f-f688f09846cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 22:04:14
35331	9d69c400-716b-4f53-b8b3-da9245f610d4	9d69c400-722d-4486-a61f-f688f09846cf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:04:14
40558	9d6cc4e7-db09-4599-ae92-a5d47d646bcf	9d6cc4e8-2643-4ba6-ae3c-37053a96fb41	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 09:54:15
40559	9d6cc4e8-1e57-4482-873f-a4beeec5e1a5	9d6cc4e8-2643-4ba6-ae3c-37053a96fb41	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"152.07","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:54:15
40560	9d6cc4e8-1ec1-47f1-b3e5-ca065b59e39d	9d6cc4e8-2643-4ba6-ae3c-37053a96fb41	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:54:15
40561	9d6cc4e8-24d1-4712-8daa-8178b8b75982	9d6cc4e8-2643-4ba6-ae3c-37053a96fb41	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 09:54:15
40562	9d6cc4e8-252c-41c3-8978-b346f651fb73	9d6cc4e8-2643-4ba6-ae3c-37053a96fb41	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":381,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:54:15
35332	9d69c400-b400-47b5-8454-68cb4fa79e21	9d69c400-d3da-41b1-bf52-09ed198a3f60	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 22:04:15
35333	9d69c400-ccd3-4d11-9940-e62d14aa657f	9d69c400-d3da-41b1-bf52-09ed198a3f60	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 22:04:15
35334	9d69c400-cd46-469b-a899-e7acbe1d4d99	9d69c400-d3da-41b1-bf52-09ed198a3f60	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 22:04:15
35335	9d69c400-d279-45b1-835b-baaaca65b30a	9d69c400-d3da-41b1-bf52-09ed198a3f60	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 22:04:15
35336	9d69c400-d2e3-4693-9c1b-a4ddbad4d679	9d69c400-d3da-41b1-bf52-09ed198a3f60	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:04:15
40563	9d6cc4e8-8d24-4978-97dc-17d430cc4352	9d6cc4e8-b00a-4ec5-8623-9cbc97ca3688	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 09:54:16
40564	9d6cc4e8-a9bc-41e8-82a2-74cedac6e341	9d6cc4e8-b00a-4ec5-8623-9cbc97ca3688	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"54.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:54:16
40565	9d6cc4e8-ae85-4315-a868-6abdde5590b5	9d6cc4e8-b00a-4ec5-8623-9cbc97ca3688	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 09:54:16
40566	9d6cc4e8-aef4-4599-a4be-90f84a130ef4	9d6cc4e8-b00a-4ec5-8623-9cbc97ca3688	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:54:16
35337	9d69c401-177e-43bc-873a-6b73c20b6a3e	9d69c401-35ce-4d51-884f-d9eeda9a4c85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 22:04:15
35338	9d69c401-30c7-4db2-85dc-8049de092901	9d69c401-35ce-4d51-884f-d9eeda9a4c85	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:04:15
35339	9d69c401-3118-4875-a851-fec8452e2e43	9d69c401-35ce-4d51-884f-d9eeda9a4c85	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:04:15
35340	9d69c401-34bf-4adf-bd4d-7b270fa0952f	9d69c401-35ce-4d51-884f-d9eeda9a4c85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-04 22:04:15
35341	9d69c401-3504-425d-acc5-173635182987	9d69c401-35ce-4d51-884f-d9eeda9a4c85	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:04:15
40623	9d6cc614-d3b9-45c5-a78f-b7848e62f78a	9d6cc615-1c18-4db5-b7d5-7183a9560745	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 09:57:32
40624	9d6cc615-1a3e-45cc-bec1-2e3e15092a91	9d6cc615-1c18-4db5-b7d5-7183a9560745	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 09:57:33
40625	9d6cc615-1b07-4667-8c9e-244e910630ff	9d6cc615-1c18-4db5-b7d5-7183a9560745	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":371,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:57:33
2615	9d50faec-c6b9-49e0-8f4a-d4fa0f5e0fbf	9d50faec-ccc4-445d-a19f-f0e91587317b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":149}	2024-10-23 14:22:07
40626	9d6cc616-ed2c-4b59-83eb-8b6a507a2753	9d6cc617-3858-46ce-8604-595da3ff0f7e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 09:57:34
40627	9d6cc617-320d-4a1b-a8b4-15c3b4bf7c8b	9d6cc617-3858-46ce-8604-595da3ff0f7e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"150.88","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:57:34
40628	9d6cc617-326d-4e4d-b28a-02c984c5088a	9d6cc617-3858-46ce-8604-595da3ff0f7e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:57:34
40629	9d6cc617-36c6-4842-bee9-34d27ae9fb5c	9d6cc617-3858-46ce-8604-595da3ff0f7e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 09:57:34
40630	9d6cc617-3728-4cc8-b177-c167e292652e	9d6cc617-3858-46ce-8604-595da3ff0f7e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":455,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:57:34
40631	9d6cc617-a1a0-4126-a2e6-fe273f8b1620	9d6cc617-be9a-4340-a93b-3bfd2d031b92	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 09:57:34
40632	9d6cc617-b8e0-40b0-a895-26e35a9658d6	9d6cc617-be9a-4340-a93b-3bfd2d031b92	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"43.82","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:57:34
40633	9d6cc617-bd2b-44ca-a334-544375a49a5a	9d6cc617-be9a-4340-a93b-3bfd2d031b92	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 09:57:34
40634	9d6cc617-bd80-458a-ae95-456d42ffaf25	9d6cc617-be9a-4340-a93b-3bfd2d031b92	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":317,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:57:34
40776	9d6cc77d-35b6-4d06-953b-92d5023381ae	9d6cc77d-4ef7-4ea1-871e-b20dc8496a8d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:01:29
40777	9d6cc77d-4d62-4c3b-81bc-c3ae15b28a6e	9d6cc77d-4ef7-4ea1-871e-b20dc8496a8d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:01:29
40778	9d6cc77d-4dfe-4194-9761-8d11fafecc2b	9d6cc77d-4ef7-4ea1-871e-b20dc8496a8d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:01:29
40779	9d6cc77f-0c49-4089-b09d-4557ffe0d503	9d6cc77f-3508-49e6-8e6a-f1144b8ac79e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:01:30
40780	9d6cc77f-2b62-4138-8715-af8653c809e7	9d6cc77f-3508-49e6-8e6a-f1144b8ac79e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.53","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:01:30
40781	9d6cc77f-2c09-4e2e-ad9c-b17ac9ddddbe	9d6cc77f-3508-49e6-8e6a-f1144b8ac79e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:01:30
40782	9d6cc77f-3352-41e8-b7b7-cd21af58db4e	9d6cc77f-3508-49e6-8e6a-f1144b8ac79e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:01:30
40783	9d6cc77f-33c6-46dd-ab5a-c8e50cc0bf6f	9d6cc77f-3508-49e6-8e6a-f1144b8ac79e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:01:30
40784	9d6cc77f-96a1-4adf-846a-498586292af7	9d6cc77f-bec8-4b05-86d0-68f9908b3bcc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:01:30
40785	9d6cc77f-b97d-44d3-8086-c91eec632816	9d6cc77f-bec8-4b05-86d0-68f9908b3bcc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"69.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:01:30
40786	9d6cc77f-bd73-471b-a4a9-ec33983f30c2	9d6cc77f-bec8-4b05-86d0-68f9908b3bcc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:01:30
40787	9d6cc77f-bdc2-4952-b1e6-cf0c50e6822b	9d6cc77f-bec8-4b05-86d0-68f9908b3bcc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":331,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:01:30
38064	9d6b5f0e-b950-4070-b56d-6bbe7e287fbc	9d6b5f0e-e1fa-4e5c-99c0-f35ec56665b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:13:38
38065	9d6b5f0e-df3a-4f30-9daa-942c3175ef46	9d6b5f0e-e1fa-4e5c-99c0-f35ec56665b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:13:38
38066	9d6b5f0e-e095-4964-bcaf-f7a6cfb1bd35	9d6b5f0e-e1fa-4e5c-99c0-f35ec56665b5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":302,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:13:38
466	9d4f2934-5ad6-41ce-b4a6-72b2b9db568e	9d4f2934-5e26-4011-be69-224bea2088e7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":31}	2024-10-22 16:39:52
38067	9d6b5f0f-4f41-4d75-bd49-56fa19b447bf	9d6b5f0f-6eed-46a6-aef7-a0f5bfa32315	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:13:39
38068	9d6b5f0f-6a37-4f6a-bbaa-e4b8689ebe28	9d6b5f0f-6eed-46a6-aef7-a0f5bfa32315	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"49.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:13:39
38069	9d6b5f0f-6d83-4196-9caa-18964e95864f	9d6b5f0f-6eed-46a6-aef7-a0f5bfa32315	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:13:39
38070	9d6b5f0f-6ded-4d0e-aaaf-46c33344a38d	9d6b5f0f-6eed-46a6-aef7-a0f5bfa32315	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":283,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:13:39
38071	9d6b5f10-0a9b-4c2e-9838-216563d6e7f3	9d6b5f10-29cf-4391-a29e-da3e73c34803	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:13:39
38072	9d6b5f10-2485-4ce3-b98b-8493cabae591	9d6b5f10-29cf-4391-a29e-da3e73c34803	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:13:39
38073	9d6b5f10-24d2-4fd3-941f-0885dbfc03c6	9d6b5f10-29cf-4391-a29e-da3e73c34803	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:13:39
38074	9d6b5f10-28ab-4721-85b8-03b8debdd4d2	9d6b5f10-29cf-4391-a29e-da3e73c34803	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 17:13:39
38075	9d6b5f10-28f2-4e55-ad48-3676bd433d8a	9d6b5f10-29cf-4391-a29e-da3e73c34803	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":463,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:13:39
38076	9d6b5f10-7671-4d6f-acaa-420cf61b916a	9d6b5f10-bfe2-40d3-9149-4a744feedb1b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 17:13:39
38077	9d6b5f10-bac9-4ada-b961-50fba35c6b4c	9d6b5f10-bfe2-40d3-9149-4a744feedb1b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"153.45","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:13:39
38078	9d6b5f10-bb19-4177-be86-a111b3b666ec	9d6b5f10-bfe2-40d3-9149-4a744feedb1b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:13:39
38079	9d6b5f10-bec9-433b-9848-5285db5b988e	9d6b5f10-bfe2-40d3-9149-4a744feedb1b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 17:13:39
38080	9d6b5f10-bf08-43c4-8fca-f5498521429f	9d6b5f10-bfe2-40d3-9149-4a744feedb1b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":363,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:13:39
38081	9d6b5f12-90ff-4329-a82e-18a1f589f869	9d6b5f12-af68-44fe-9cab-263aa2362e09	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 17:13:41
38082	9d6b5f12-aa4e-4d0c-a016-d8d26b744d2e	9d6b5f12-af68-44fe-9cab-263aa2362e09	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:13:41
38083	9d6b5f12-aab4-4cbd-87c7-d455a16320aa	9d6b5f12-af68-44fe-9cab-263aa2362e09	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:13:41
38084	9d6b5f12-ae2c-4c5b-a2dd-b922b3393135	9d6b5f12-af68-44fe-9cab-263aa2362e09	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 17:13:41
38085	9d6b5f12-ae6f-4506-b228-e6c1eeec0a1b	9d6b5f12-af68-44fe-9cab-263aa2362e09	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":365,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:13:41
40809	9d6cc7a6-5c3c-4184-9968-ef3b2457ed16	9d6cc7a6-5f1a-44f2-b38a-2246d48ea48e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1856}	2024-11-06 10:01:55
40912	9d6cc8a4-2236-4fe7-8e79-639eaffd8639	9d6cc8a4-3ee2-423f-8635-a7b20a824642	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 10:04:42
40913	9d6cc8a4-3d1d-4956-9690-99da233359d8	9d6cc8a4-3ee2-423f-8635-a7b20a824642	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 10:04:42
40914	9d6cc8a4-3dcf-4ffa-8e77-cd9a404a3c81	9d6cc8a4-3ee2-423f-8635-a7b20a824642	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:04:42
16969	9d654684-2ed1-4530-8d62-50472343ce1d	9d654684-31d1-4415-9348-a17d1097ab86	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":790}	2024-11-02 16:30:03
40915	9d6cc8a6-3cec-43bd-af58-b9a54e8469d6	9d6cc8a6-6486-4f34-87e3-6bd937120165	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 10:04:43
40916	9d6cc8a6-5cf8-4ddc-b593-4a0a0d24ec88	9d6cc8a6-6486-4f34-87e3-6bd937120165	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"53.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:04:43
40917	9d6cc8a6-5d6a-4eb4-bf49-d79cf51dd5fc	9d6cc8a6-6486-4f34-87e3-6bd937120165	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:04:43
40918	9d6cc8a6-62d3-45a8-9cb1-0ad4291e7a75	9d6cc8a6-6486-4f34-87e3-6bd937120165	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 10:04:43
40919	9d6cc8a6-6333-4eb4-8d02-c0de74afa271	9d6cc8a6-6486-4f34-87e3-6bd937120165	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":418,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:04:43
40920	9d6cc8a6-c204-4b38-ae26-397caf9de66e	9d6cc8a6-e429-44f6-b219-6b0972fcf708	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 10:04:44
40921	9d6cc8a6-dd16-4bba-9f46-2c8f6a452576	9d6cc8a6-e429-44f6-b219-6b0972fcf708	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"52.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:04:44
40922	9d6cc8a6-e206-46c3-9371-d6d65f33180b	9d6cc8a6-e429-44f6-b219-6b0972fcf708	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 10:04:44
40923	9d6cc8a6-e2a8-4a84-9f1a-fd185f8d3a93	9d6cc8a6-e429-44f6-b219-6b0972fcf708	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":301,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:04:44
38381	9d6b646d-513f-4a05-8c06-c77ec4fd1da0	9d6b646d-a4ad-4d96-810a-3c4fd3c75ac7	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 17:28:39
38382	9d6b646d-a240-4cf2-b2ec-13e84fcc0a27	9d6b646d-a4ad-4d96-810a-3c4fd3c75ac7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:28:39
38383	9d6b646d-a375-4ec4-9468-f9d8fe35c085	9d6b646d-a4ad-4d96-810a-3c4fd3c75ac7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":557,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:28:39
29944	9d692c28-0c1a-4fb3-8fc7-d0cdf0c37ed0	9d692c28-6c9e-4fdf-9d18-73171e285b5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-11-04 14:59:39
29945	9d692c28-69b4-4dd2-93b7-6ee9f4b81299	9d692c28-6c9e-4fdf-9d18-73171e285b5c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-11-04 14:59:39
29946	9d692c28-6b0d-4281-aa22-62ef3021998f	9d692c28-6c9e-4fdf-9d18-73171e285b5c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":570,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:59:39
29947	9d692c28-f698-4303-b5e2-291d697b0365	9d692c29-2aff-4cf8-be97-b16920ecf0ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-11-04 14:59:40
29948	9d692c29-1ff1-45b2-bacd-1318ffc0dea0	9d692c29-2aff-4cf8-be97-b16920ecf0ec	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '12' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"64.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":56,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 14:59:40
29949	9d692c29-2086-4176-a5ab-3c8b1bb756a5	9d692c29-2aff-4cf8-be97-b16920ecf0ec	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 14:59:40
29950	9d692c29-28c7-41ec-a96b-0225a3070dac	9d692c29-2aff-4cf8-be97-b16920ecf0ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-11-04 14:59:40
29951	9d692c29-2973-45a7-b7a9-39cba27d30a2	9d692c29-2aff-4cf8-be97-b16920ecf0ec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/12","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-10-21T22:10:41.000000Z","deleted_at":null,"user_alias":"eder_cortes"}},"duration":404,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:59:40
38384	9d6b646e-28ad-43da-b70f-e5ce18568d00	9d6b646e-4664-46b1-b3db-5577fb8e2146	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:28:40
38385	9d6b646e-40de-4a0e-ab5b-bdbe93dceca2	9d6b646e-4664-46b1-b3db-5577fb8e2146	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"43.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:28:40
38386	9d6b646e-44f7-4282-890b-cd05c573c6a2	9d6b646e-4664-46b1-b3db-5577fb8e2146	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:28:40
38387	9d6b646e-457b-4de3-8a9b-a710eb48570b	9d6b646e-4664-46b1-b3db-5577fb8e2146	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":284,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:28:40
29952	9d692c2a-2257-4b39-84cb-87c2ea6280fe	9d692c2a-6b8f-4c57-af8a-f4094afe6da9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-11-04 14:59:40
29953	9d692c2a-5f54-4500-917f-23a0eff7c028	9d692c2a-6b8f-4c57-af8a-f4094afe6da9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"81.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:59:41
29954	9d692c2a-5ff3-41ce-851d-2b98caec5fd0	9d692c2a-6b8f-4c57-af8a-f4094afe6da9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:59:41
29955	9d692c2a-68db-4850-80ea-543879624b2c	9d692c2a-6b8f-4c57-af8a-f4094afe6da9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":29,"hostname":"EderCortes"}	2024-11-04 14:59:41
29956	9d692c2a-69ac-4799-89e0-2d234892191d	9d692c2a-6b8f-4c57-af8a-f4094afe6da9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":794,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:59:41
38388	9d6b646e-895a-46c2-9f0a-1bfc8cb2a53c	9d6b646e-d33c-4632-8573-6d96f4d7b1d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:28:40
38389	9d6b646e-cdbb-497a-ba61-fb46d767eab3	9d6b646e-d33c-4632-8573-6d96f4d7b1d1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"152.66","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:28:40
30547	9d693fd4-ae3c-4662-af69-ffee286da80f	9d693fd4-ba5f-43ef-a434-f0271440d0bf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"194.74","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 15:54:40
30548	9d693fd4-aedf-4483-942a-a8047cd05dcb	9d693fd4-ba5f-43ef-a434-f0271440d0bf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 15:54:40
30549	9d693fd4-b7c6-423b-b269-0a170a81b8ce	9d693fd4-ba5f-43ef-a434-f0271440d0bf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-04 15:54:40
38390	9d6b646e-ce25-4434-91e1-334df35db6d7	9d6b646e-d33c-4632-8573-6d96f4d7b1d1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:28:40
38391	9d6b646e-d205-4e3c-9065-7713ea6ee45d	9d6b646e-d33c-4632-8573-6d96f4d7b1d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:28:40
38392	9d6b646e-d244-493e-be04-445a2609456f	9d6b646e-d33c-4632-8573-6d96f4d7b1d1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":350,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:28:40
29957	9d692c2b-2df1-4191-aa9a-8edf2be55d64	9d692c2b-6237-4abe-a213-f12fb43ec891	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":29,"hostname":"EderCortes"}	2024-11-04 14:59:41
29958	9d692c2b-57bf-4f2d-ab58-301cbf2218d6	9d692c2b-6237-4abe-a213-f12fb43ec891	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"64.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 14:59:41
29959	9d692c2b-5851-481f-a1d4-8e2ada643daf	9d692c2b-6237-4abe-a213-f12fb43ec891	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 14:59:41
29960	9d692c2b-600e-4074-b88b-5d63963fd47e	9d692c2b-6237-4abe-a213-f12fb43ec891	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":30,"hostname":"EderCortes"}	2024-11-04 14:59:41
29961	9d692c2b-60a7-47de-b1a9-7ec79a064cf5	9d692c2b-6237-4abe-a213-f12fb43ec891	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":606,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:59:41
38393	9d6b646f-15ca-4ef1-81d0-c96df27312a0	9d6b646f-3459-4418-8b1e-9ada36e145a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:28:40
38394	9d6b646f-2fa3-40bb-941d-4056a7e10e3a	9d6b646f-3459-4418-8b1e-9ada36e145a7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:28:40
30550	9d693fd4-b892-42f8-9c81-5d088b892436	9d693fd4-ba5f-43ef-a434-f0271440d0bf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":867,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:54:40
38395	9d6b646f-2ff9-4696-b848-fd48e40d2737	9d6b646f-3459-4418-8b1e-9ada36e145a7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:28:40
38396	9d6b646f-334f-4a0b-b1de-69f0a2b693cb	9d6b646f-3459-4418-8b1e-9ada36e145a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:28:40
38397	9d6b646f-3393-472c-96b8-2d4895351937	9d6b646f-3459-4418-8b1e-9ada36e145a7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":235,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:28:40
38398	9d6b6471-08ef-4a92-9a4c-5ce432758a27	9d6b6471-268e-420b-bd14-7147ba96a08b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:28:41
38399	9d6b6471-20f7-432b-8a6b-d1bc513de154	9d6b6471-268e-420b-bd14-7147ba96a08b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.27","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:28:41
35840	9d69c7ee-6dc6-401a-87eb-d8ff09382e7f	9d69c7ee-cc03-445e-bfff-50137c779c4b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 22:15:14
35841	9d69c7ee-c93b-47c6-84ad-41d6eea8d03e	9d69c7ee-cc03-445e-bfff-50137c779c4b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 22:15:14
30551	9d693fd5-93a5-4123-bbdf-eac85a8009c0	9d693fd5-d06f-49fe-9ff2-e395fc2c7185	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-04 15:54:40
35842	9d69c7ee-ca75-4b94-9054-ae9de5edce76	9d69c7ee-cc03-445e-bfff-50137c779c4b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":520,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:15:14
38400	9d6b6471-2164-4f5a-bcaf-a5b43755eaae	9d6b6471-268e-420b-bd14-7147ba96a08b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:28:41
38401	9d6b6471-2539-4b76-814c-23354f7aa592	9d6b6471-268e-420b-bd14-7147ba96a08b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:28:41
38402	9d6b6471-257c-495c-aeb5-a091e58a3d58	9d6b6471-268e-420b-bd14-7147ba96a08b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":312,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:28:41
35843	9d69c7ef-829a-4a79-bc56-b18af62235cd	9d69c7ef-e0c2-4846-bbbe-163f29f4ecca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 22:15:14
35844	9d69c7ef-d656-4c85-8475-8a94d7c54b2e	9d69c7ef-e0c2-4846-bbbe-163f29f4ecca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '22' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"171.81","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":74,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 22:15:15
35845	9d69c7ef-d731-4beb-9102-c5d76bd135ca	9d69c7ef-e0c2-4846-bbbe-163f29f4ecca	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 22:15:15
35846	9d69c7ef-de85-4af4-a39a-5c97de98da50	9d69c7ef-e0c2-4846-bbbe-163f29f4ecca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 22:15:15
35847	9d69c7ef-df2c-4a90-95e9-b2fc407115e3	9d69c7ef-e0c2-4846-bbbe-163f29f4ecca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/22","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}},"duration":613,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:15:15
35848	9d69c7f0-8700-483b-92f3-64e07e992130	9d69c7f0-c677-4bcf-bae6-5cc10a826ed5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 22:15:15
35849	9d69c7f0-bb68-492c-896d-bb5b54f112ed	9d69c7f0-c677-4bcf-bae6-5cc10a826ed5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"78.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:15:15
35850	9d69c7f0-bc1e-464a-8d27-1770d1981f86	9d69c7f0-c677-4bcf-bae6-5cc10a826ed5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:15:15
35851	9d69c7f0-c45d-4dbf-9efa-fa759083fa3b	9d69c7f0-c677-4bcf-bae6-5cc10a826ed5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 22:15:15
35852	9d69c7f0-c4e9-46f0-85bc-c84d4a941a3f	9d69c7f0-c677-4bcf-bae6-5cc10a826ed5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":560,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:15:15
35853	9d69c7f1-7e38-4f5d-b0e2-ffc9ead7b26f	9d69c7f1-b208-44b6-96a6-dea3f2e93a1c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 22:15:16
35854	9d69c7f1-a68d-4b5c-998d-db27625d154e	9d69c7f1-b208-44b6-96a6-dea3f2e93a1c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"63.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:15:16
35855	9d69c7f1-a731-461b-be50-b54cf3a80ac8	9d69c7f1-b208-44b6-96a6-dea3f2e93a1c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:15:16
35856	9d69c7f1-afdb-4544-9a31-40ae552d4a53	9d69c7f1-b208-44b6-96a6-dea3f2e93a1c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 22:15:16
35857	9d69c7f1-b078-460e-a450-716f457bffc2	9d69c7f1-b208-44b6-96a6-dea3f2e93a1c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":579,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:15:16
41093	9d6ccb45-b154-4215-abe5-026868b7e648	9d6ccb45-fc1a-4b01-b43d-8d01bd1b972d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:12:03
41094	9d6ccb45-fa81-48da-8bdd-9bc1db7226de	9d6ccb45-fc1a-4b01-b43d-8d01bd1b972d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:12:03
41095	9d6ccb45-fb1f-4619-8a11-8d39ff999a84	9d6ccb45-fc1a-4b01-b43d-8d01bd1b972d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":438,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:12:03
28169	9d68ff1b-a35b-49d7-8952-2867d2c8d790	9d68ff1b-a694-47b4-a627-9dcb49dbc81c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1313}	2024-11-04 12:53:41
41096	9d6ccb46-6aba-4062-bd96-7157d023b5c7	9d6ccb46-8d71-44b5-bc32-265d81313726	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:12:04
41097	9d6ccb46-8792-47c5-bea3-2aab3cfcf480	9d6ccb46-8d71-44b5-bc32-265d81313726	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"47.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 10:12:04
41098	9d6ccb46-8ba1-4f3c-a9d5-9b56381c2167	9d6ccb46-8d71-44b5-bc32-265d81313726	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:12:04
41099	9d6ccb46-8c47-44b3-9cca-01571d8f6738	9d6ccb46-8d71-44b5-bc32-265d81313726	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":290,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:12:04
41100	9d6ccb46-f06e-4d6e-b688-7bb31eea847d	9d6ccb47-3c55-4800-bfca-de46f18bb4f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:12:04
41101	9d6ccb47-36d2-45ac-a977-315d564b9f79	9d6ccb47-3c55-4800-bfca-de46f18bb4f5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"144.24","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:12:04
41102	9d6ccb47-3732-4453-b8bf-21b135fe82ec	9d6ccb47-3c55-4800-bfca-de46f18bb4f5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:12:04
41103	9d6ccb47-3ab7-4fb2-8a36-4601d59a9283	9d6ccb47-3c55-4800-bfca-de46f18bb4f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:12:04
41104	9d6ccb47-3b02-4664-a775-456810621319	9d6ccb47-3c55-4800-bfca-de46f18bb4f5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":430,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:12:04
41105	9d6ccb47-985c-4b2d-830d-18d08d9d83c9	9d6ccb47-c124-4e6e-8e43-24575a8c34a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:12:04
41106	9d6ccb47-bafd-44a5-90b1-ad5d8f9af3d5	9d6ccb47-c124-4e6e-8e43-24575a8c34a7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"54.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:12:05
41107	9d6ccb47-bb52-4793-a96d-bec5445085f0	9d6ccb47-c124-4e6e-8e43-24575a8c34a7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:12:05
41108	9d6ccb47-bfad-4dad-beb4-498f03ab470d	9d6ccb47-c124-4e6e-8e43-24575a8c34a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:12:05
41109	9d6ccb47-c008-4e99-bec4-02f230fdf381	9d6ccb47-c124-4e6e-8e43-24575a8c34a7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":319,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:12:05
41110	9d6ccb49-bad6-4ffc-86c6-a7e104cbb5c8	9d6ccb4a-17d4-4b32-803e-36d1800afabd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:12:06
41111	9d6ccb4a-0c2b-440d-b52d-b19888713bf9	9d6ccb4a-17d4-4b32-803e-36d1800afabd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"178.48","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:12:06
41112	9d6ccb4a-0ce9-481b-8bb2-ded4aeb21707	9d6ccb4a-17d4-4b32-803e-36d1800afabd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:12:06
41113	9d6ccb4a-15a1-4703-a7c6-a844ba3fc75b	9d6ccb4a-17d4-4b32-803e-36d1800afabd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:12:06
41114	9d6ccb4a-165b-4ff5-a461-30172bb87e51	9d6ccb4a-17d4-4b32-803e-36d1800afabd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":555,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:12:06
41115	9d6ccb4a-96d5-4831-8548-ec6ad57f4884	9d6ccb4a-b683-4ad7-8656-400a8d90a965	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:12:06
41116	9d6ccb4a-b0a0-4148-a683-ba68dc2c55c3	9d6ccb4a-b683-4ad7-8656-400a8d90a965	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"46.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:12:06
41117	9d6ccb4a-b4fd-4f81-837f-ec667947814e	9d6ccb4a-b683-4ad7-8656-400a8d90a965	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:12:06
41118	9d6ccb4a-b55a-4d66-92d6-ed16237599fd	9d6ccb4a-b683-4ad7-8656-400a8d90a965	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":378,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:12:06
41119	9d6ccb4b-05ca-4e6e-b467-98209705fee3	9d6ccb4b-097c-4ba0-90a7-1734dfc789ef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":181,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:12:07
41120	9d6ccb4b-77ad-4378-9956-bb75676ae27f	9d6ccb4b-9953-458a-b486-d5661a0ca982	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:12:07
41121	9d6ccb4b-92b2-40cc-bec9-5528ca4af2a5	9d6ccb4b-9953-458a-b486-d5661a0ca982	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"48.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 10:12:07
41122	9d6ccb4b-9722-466f-a679-ac34ef9b22e3	9d6ccb4b-9953-458a-b486-d5661a0ca982	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:12:07
41123	9d6ccb4b-97d9-4baa-b120-fa611532a164	9d6ccb4b-9953-458a-b486-d5661a0ca982	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":294,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:12:07
35989	9d69c89f-3f07-4548-adbc-fbc55907a353	9d69c89f-5c1b-47b4-83c4-ac46473fdb77	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 22:17:10
35990	9d69c89f-5a6e-4bae-8bd0-5e6e648b3818	9d69c89f-5c1b-47b4-83c4-ac46473fdb77	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 22:17:10
35991	9d69c89f-5b09-4333-af65-c3c26c927fc4	9d69c89f-5c1b-47b4-83c4-ac46473fdb77	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:17:10
35992	9d69c89f-b2d3-4b54-9dd4-bc55c2d42e91	9d69c89f-cec4-4f9b-a6ac-b6b7f4777647	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 22:17:10
35993	9d69c89f-c986-4f7e-b989-b7fefcde1504	9d69c89f-cec4-4f9b-a6ac-b6b7f4777647	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '22' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"38.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":74,"hash":"27a694a1c46d46c837c3d3167306e9e7","hostname":"EderCortes"}	2024-11-04 22:17:10
35994	9d69c89f-c9e0-48e9-8a0c-c49184015620	9d69c89f-cec4-4f9b-a6ac-b6b7f4777647	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 22:17:10
35995	9d69c89f-cd73-4d46-8d67-df652dde74dc	9d69c89f-cec4-4f9b-a6ac-b6b7f4777647	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 22:17:10
35996	9d69c89f-cddb-4466-be98-81ba693b0285	9d69c89f-cec4-4f9b-a6ac-b6b7f4777647	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users\\/22","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:17:10
40332	9d6cc283-dc92-4527-a389-d6e4513c2efd	9d6cc283-fb01-4668-a482-f98720c0e782	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-06 09:47:34
40333	9d6cc283-f879-4d56-bd21-23e43683c930	9d6cc283-fb01-4668-a482-f98720c0e782	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-06 09:47:34
40334	9d6cc283-f9ae-4259-8465-c7a7b95bfabd	9d6cc283-fb01-4668-a482-f98720c0e782	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:47:34
40335	9d6cc284-5951-4e4f-838b-5ed8a8a341b3	9d6cc284-75d3-45cd-a17a-9a1da3d8545b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-06 09:47:34
40336	9d6cc284-716c-4c47-82c9-7aa227d29846	9d6cc284-75d3-45cd-a17a-9a1da3d8545b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"44.63","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 09:47:34
40337	9d6cc284-7477-4c40-88e3-5fcea7a37e89	9d6cc284-75d3-45cd-a17a-9a1da3d8545b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-06 09:47:34
40338	9d6cc284-74e2-4275-825b-c44398103805	9d6cc284-75d3-45cd-a17a-9a1da3d8545b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:47:34
40339	9d6cc284-ca30-4cf0-9181-e9e19564d8ce	9d6cc284-e96f-4080-8d8e-efb4bd2edd69	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-06 09:47:35
40340	9d6cc284-e434-4b47-b1d1-347af6ec95a1	9d6cc284-e96f-4080-8d8e-efb4bd2edd69	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 09:47:35
40341	9d6cc284-e488-417b-b18b-2f1446ef507b	9d6cc284-e96f-4080-8d8e-efb4bd2edd69	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 09:47:35
40342	9d6cc284-e81c-4c73-8921-25a14ca6ee52	9d6cc284-e96f-4080-8d8e-efb4bd2edd69	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-06 09:47:35
40343	9d6cc284-e869-4560-9774-b0350e6ad118	9d6cc284-e96f-4080-8d8e-efb4bd2edd69	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":285,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:47:35
36362	9d6b38e2-8964-40ef-b3a5-1b15774d7576	9d6b38e2-b931-4f27-8c85-2f69f5fd797c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:26:54
36363	9d6b38e2-b71c-4615-b0cc-09f138f279c0	9d6b38e2-b931-4f27-8c85-2f69f5fd797c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 15:26:54
36364	9d6b38e2-b815-4dd1-92ce-e4efceacd136	9d6b38e2-b931-4f27-8c85-2f69f5fd797c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":315,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:26:54
36365	9d6b38e3-1a39-498b-bab6-b50e0952c268	9d6b38e3-6070-4dcf-9955-631f6a0b88b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 15:26:54
36366	9d6b38e3-5b49-4d32-b500-253f50d0916c	9d6b38e3-6070-4dcf-9955-631f6a0b88b6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"146.38","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:26:54
36367	9d6b38e3-5ea1-4736-abb8-4089cb065f3e	9d6b38e3-6070-4dcf-9955-631f6a0b88b6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 15:26:54
36368	9d6b38e3-5f1f-4093-b8e5-c51cfb3c6897	9d6b38e3-6070-4dcf-9955-631f6a0b88b6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:26:54
40344	9d6cc285-30a1-4e33-8744-db9d27e77bb7	9d6cc285-7a12-4aaa-9b46-161bfaf68bdb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-06 09:47:35
40345	9d6cc285-7489-4e42-99f1-e64646213ef3	9d6cc285-7a12-4aaa-9b46-161bfaf68bdb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"149.35","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 09:47:35
40346	9d6cc285-74ec-43ae-b767-54e4a5e73d0a	9d6cc285-7a12-4aaa-9b46-161bfaf68bdb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 09:47:35
40347	9d6cc285-78cf-437d-9771-82a704b269a1	9d6cc285-7a12-4aaa-9b46-161bfaf68bdb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-06 09:47:35
40348	9d6cc285-791e-4785-9491-ab91f4c249e3	9d6cc285-7a12-4aaa-9b46-161bfaf68bdb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":351,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:47:35
36369	9d6b38e3-beef-49d7-8406-52b9b3f18087	9d6b38e3-e020-4675-9bc3-d7dc71e2bdc5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 15:26:55
36370	9d6b38e3-db13-4309-93a9-d65d4f52036e	9d6b38e3-e020-4675-9bc3-d7dc71e2bdc5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.00","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:26:55
36371	9d6b38e3-db5f-40a3-ae26-b84fefde451a	9d6b38e3-e020-4675-9bc3-d7dc71e2bdc5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:26:55
36372	9d6b38e3-dec2-4e84-baca-0fc93175018c	9d6b38e3-e020-4675-9bc3-d7dc71e2bdc5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 15:26:55
36373	9d6b38e3-df06-40cc-be68-6d8fb0e57ace	9d6b38e3-e020-4675-9bc3-d7dc71e2bdc5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":305,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:26:55
40349	9d6cc286-89b7-4e49-b9b4-351c1ce82ca7	9d6cc286-aa3b-4449-a808-29c8b566b73e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-06 09:47:36
40350	9d6cc286-a507-43d3-a169-2b048bd490d7	9d6cc286-aa3b-4449-a808-29c8b566b73e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"48.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:47:36
40351	9d6cc286-a558-4d80-9911-b99badd901f6	9d6cc286-aa3b-4449-a808-29c8b566b73e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:47:36
40352	9d6cc286-a8fb-4e52-bdbf-ebeb18979d7a	9d6cc286-aa3b-4449-a808-29c8b566b73e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-06 09:47:36
40353	9d6cc286-a945-48f6-9d11-8ba477680d4f	9d6cc286-aa3b-4449-a808-29c8b566b73e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":239,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:47:36
36374	9d6b38e4-2e08-4eb0-93ca-96044176fb87	9d6b38e4-4e1d-45ee-b3c5-8458c1737b83	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 15:26:55
36375	9d6b38e4-4896-467e-a925-cf046c16fdc2	9d6b38e4-4e1d-45ee-b3c5-8458c1737b83	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:26:55
36376	9d6b38e4-48fe-4ebf-8490-656e711740e5	9d6b38e4-4e1d-45ee-b3c5-8458c1737b83	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:26:55
36377	9d6b38e4-4cbb-4a5c-a6a7-e6408e24188f	9d6b38e4-4e1d-45ee-b3c5-8458c1737b83	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 15:26:55
36378	9d6b38e4-4cff-4f92-85fb-c89aa12ae458	9d6b38e4-4e1d-45ee-b3c5-8458c1737b83	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":257,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:26:55
40354	9d6cc286-ef37-46ac-9d07-4d26770e4c90	9d6cc287-09ac-405e-95c5-f7366929da62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-06 09:47:36
38823	9d6b6d5b-094a-4936-95bf-75c8e16c270e	9d6b6d5b-54af-4ddb-90aa-6432af80d965	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:53:37
38824	9d6b6d5b-526e-4751-886e-09a8cbf27e3e	9d6b6d5b-54af-4ddb-90aa-6432af80d965	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:53:37
38825	9d6b6d5b-536a-4db8-b583-d53002ed8d35	9d6b6d5b-54af-4ddb-90aa-6432af80d965	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":370,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:53:37
40355	9d6cc287-058a-437f-9411-105462106a52	9d6cc287-09ac-405e-95c5-f7366929da62	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"44.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:47:36
40356	9d6cc287-083e-4fb7-aafe-53342ba446cb	9d6cc287-09ac-405e-95c5-f7366929da62	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-06 09:47:36
40357	9d6cc287-0883-4caf-9188-cc441323363e	9d6cc287-09ac-405e-95c5-f7366929da62	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:47:36
38826	9d6b6d5b-c818-41bb-baf4-8166f3ffac20	9d6b6d5b-e58d-47f9-8a17-b10bf5dbc5f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:53:37
31499	9d694c52-d607-4c93-87e4-7e7da9824179	9d694c53-103d-429b-9bc8-2c24dd6c5165	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 16:29:36
31500	9d694c53-0d34-4db5-98bf-bdf724e1a272	9d694c53-103d-429b-9bc8-2c24dd6c5165	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 16:29:36
31501	9d694c53-0e8c-43ce-9bfc-850797c06953	9d694c53-103d-429b-9bc8-2c24dd6c5165	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":449,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:29:36
38827	9d6b6d5b-e03b-4e44-9019-44109c76b202	9d6b6d5b-e58d-47f9-8a17-b10bf5dbc5f2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"44.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:53:37
36379	9d6b38e5-29a9-47b1-9c55-264bb7a419d2	9d6b38e5-4741-4341-a1db-b444f97d9ee2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 15:26:56
36380	9d6b38e5-4219-4381-8184-fc30f2f5fdc7	9d6b38e5-4741-4341-a1db-b444f97d9ee2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:26:56
38828	9d6b6d5b-e3f5-4789-8b6e-0f72994674f1	9d6b6d5b-e58d-47f9-8a17-b10bf5dbc5f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:53:38
36381	9d6b38e5-4263-4830-9578-a55ee3c719fa	9d6b38e5-4741-4341-a1db-b444f97d9ee2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:26:56
36382	9d6b38e5-45d4-476b-bf0c-2ccaf02f4651	9d6b38e5-4741-4341-a1db-b444f97d9ee2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 15:26:56
36383	9d6b38e5-461e-4c2c-988d-05fa283613fb	9d6b38e5-4741-4341-a1db-b444f97d9ee2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":305,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:26:56
38829	9d6b6d5b-e47d-4d05-bfb7-01b6310dca9a	9d6b6d5b-e58d-47f9-8a17-b10bf5dbc5f2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:53:38
40358	9d6cc287-4755-4c45-b695-11a38f3c4c72	9d6cc287-4a30-4700-b04a-e8d40dd037a1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":135,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:47:36
31502	9d694c53-b2eb-46aa-b6b9-c753c2d7dc2e	9d694c53-dfe6-4269-a0cb-33def46163d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 16:29:36
31503	9d694c53-d533-46cc-aec6-19d9aed5926d	9d694c53-dfe6-4269-a0cb-33def46163d2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_apellido_dos,\\n                                l.loans_tipo_documento,\\n                                l.loans_documento,\\n                                l.loans_fecha_nacimiento,\\n                                l.loans_ciudad,\\n                                l.loans_barrio,\\n                                l.loans_direccion,\\n                                l.loans_intereses,\\n                                l.loans_cuotas,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuando,\\n                                l.loans_observacion,\\n                                l.loans_fecha,\\n                                l.loans_estado,\\n                                l.loans_celular,\\n                                l.loans_inicio_pago,\\n                                l.loans_pago_prestado,\\n                                l.loans_pago_interes,\\n                                ucr.user_alias\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users ucr on l.user_creador = ucr.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 92\\n                        ","time":"61.78","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":266,"hash":"881d323554d83990782fdc5bb04c2507","hostname":"EderCortes"}	2024-11-04 16:29:36
31504	9d694c53-d955-4b2f-b3a3-2faba05bb160	9d694c53-dfe6-4269-a0cb-33def46163d2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" inner join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = '92' order by \\"item_loans\\".\\"id\\" asc","time":"3.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":304,"hash":"ac513f13416666eb3a5127ebc04741a7","hostname":"EderCortes"}	2024-11-04 16:29:36
31505	9d694c53-ddd1-4002-b5ce-decdb84c74d5	9d694c53-dfe6-4269-a0cb-33def46163d2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 16:29:36
31506	9d694c53-de64-4989-97a8-51f74beb8989	9d694c53-dfe6-4269-a0cb-33def46163d2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions\\/92","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"id":92,"cobrador":"Luis andre","recomendador":"Luis andre","loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":15,"loans_valor_prestado":8000009,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"En curso","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","loans_pago_prestado":"533333.93333333","loans_pago_interes":"133333.48333333","user_alias":"eder.cortes"},"items":[{"id":379,"loans_codigo":92,"itemloans_cuota":"1","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:13:07","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"133333.48333333","itemloans_cuota_cancelada":"533333.93333333","user_alias":"eder.cortes"},{"id":380,"loans_codigo":92,"itemloans_cuota":"2","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":381,"loans_codigo":92,"itemloans_cuota":"3","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":382,"loans_codigo":92,"itemloans_cuota":"4","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":383,"loans_codigo":92,"itemloans_cuota":"5","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-14 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":384,"loans_codigo":92,"itemloans_cuota":"6","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-22 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":385,"loans_codigo":92,"itemloans_cuota":"7","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-12-30 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":386,"loans_codigo":92,"itemloans_cuota":"8","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-07 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":387,"loans_codigo":92,"itemloans_cuota":"9","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-15 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":388,"loans_codigo":92,"itemloans_cuota":"10","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-23 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":389,"loans_codigo":92,"itemloans_cuota":"11","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-01-31 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":390,"loans_codigo":92,"itemloans_cuota":"12","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-08 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":391,"loans_codigo":92,"itemloans_cuota":"13","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-16 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":392,"loans_codigo":92,"itemloans_cuota":"14","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-02-24 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"},{"id":393,"loans_codigo":92,"itemloans_cuota":"15","itemloans_valor_cuota":"533333.93333333","itemloans_iteres":"133333.48333333","itemloans_status":"Pendiente","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2025-03-04 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04 16:10:11","updated_at":"2024-11-04 16:10:11","deleted_at":null,"item_loans_cuando_pago":null,"itemloans_interes_canelado":"0","itemloans_cuota_cancelada":"0","user_alias":"eder.cortes"}]}},"duration":437,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:29:36
38830	9d6b6d5c-39c8-4663-8588-0f53ea1f416a	9d6b6d5c-820b-4bd1-afa8-a50446abd7a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:53:38
38831	9d6b6d5c-7ca6-44ea-88f2-bc8dc3465ecc	9d6b6d5c-820b-4bd1-afa8-a50446abd7a6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"144.20","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:53:38
38832	9d6b6d5c-7cf9-4a1b-a774-62c7665a6136	9d6b6d5c-820b-4bd1-afa8-a50446abd7a6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:53:38
38833	9d6b6d5c-80d4-4cd9-bc3b-f269407fce40	9d6b6d5c-820b-4bd1-afa8-a50446abd7a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:53:38
38834	9d6b6d5c-8117-49df-a82e-e0200bf1291a	9d6b6d5c-820b-4bd1-afa8-a50446abd7a6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":391,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:53:38
40359	9d6cc287-9998-4470-bd76-291b5cbe55ff	9d6cc287-e07f-4461-a84e-e83c33b0438d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-06 09:47:36
40360	9d6cc287-db93-400b-b8af-b426ad4325ef	9d6cc287-e07f-4461-a84e-e83c33b0438d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"152.06","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 09:47:37
40361	9d6cc287-defe-4aca-a748-0c814d20fbb3	9d6cc287-e07f-4461-a84e-e83c33b0438d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-06 09:47:37
40362	9d6cc287-df80-451f-a81c-f909f8a2ecf2	9d6cc287-e07f-4461-a84e-e83c33b0438d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":332,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:47:37
31507	9d694c54-b9c6-4159-bbf0-cbdb6ee5c850	9d694c55-227e-47ac-bd3c-29128ffa0c74	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 16:29:37
31508	9d694c55-1435-4c6b-afdb-6863bdb68f07	9d694c55-227e-47ac-bd3c-29128ffa0c74	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"145.87","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:29:37
31509	9d694c55-14f2-413e-ae65-e5cae8c01f6a	9d694c55-227e-47ac-bd3c-29128ffa0c74	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:29:37
31510	9d694c55-1f43-43f9-8ec2-8141a8f30d34	9d694c55-227e-47ac-bd3c-29128ffa0c74	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 16:29:37
31511	9d694c55-201e-44ea-b46b-a0b8cd82469f	9d694c55-227e-47ac-bd3c-29128ffa0c74	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":810,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:29:37
38835	9d6b6d5c-c64a-4693-a595-fd24694d1883	9d6b6d5c-e642-40ac-b132-fa477daeb02b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:53:38
38836	9d6b6d5c-e080-4414-aabe-79dcbc8f3ecf	9d6b6d5c-e642-40ac-b132-fa477daeb02b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.67","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:53:38
38837	9d6b6d5c-e0d8-4f0f-a4a2-7700578a032e	9d6b6d5c-e642-40ac-b132-fa477daeb02b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:53:38
38838	9d6b6d5c-e49c-4bff-ac9f-335e38b8ba79	9d6b6d5c-e642-40ac-b132-fa477daeb02b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 17:53:38
38839	9d6b6d5c-e4dd-4231-97ed-ac6ef5ecf65b	9d6b6d5c-e642-40ac-b132-fa477daeb02b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:53:38
31512	9d694c56-15fc-4fbd-948a-9e86a754a4d0	9d694c56-4c5b-4c7f-9f20-16c9ea97ad63	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 16:29:38
31513	9d694c56-4096-4237-9528-51a8ffb80e20	9d694c56-4c5b-4c7f-9f20-16c9ea97ad63	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"71.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 16:29:38
31514	9d694c56-414a-4329-b416-e2a7ce7cb516	9d694c56-4c5b-4c7f-9f20-16c9ea97ad63	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 16:29:38
31515	9d694c56-49ce-4a6b-99a7-37357b901961	9d694c56-4c5b-4c7f-9f20-16c9ea97ad63	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 16:29:38
31516	9d694c56-4a6a-42a4-8917-c71cd52f7e98	9d694c56-4c5b-4c7f-9f20-16c9ea97ad63	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":448,"memory":22,"hostname":"EderCortes"}	2024-11-04 16:29:38
38840	9d6b6d5e-6ce6-4bc7-89d3-614da2ff25aa	9d6b6d5e-bfe0-4748-8083-69523c6dc9d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 17:53:39
38841	9d6b6d5e-b8a4-49f9-a794-03d44438e231	9d6b6d5e-bfe0-4748-8083-69523c6dc9d7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"167.17","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:53:39
38842	9d6b6d5e-b919-4d71-91ee-d175ca7f75de	9d6b6d5e-bfe0-4748-8083-69523c6dc9d7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:53:39
38843	9d6b6d5e-be4d-42f6-b2e7-7b097091bc6d	9d6b6d5e-bfe0-4748-8083-69523c6dc9d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 17:53:39
38844	9d6b6d5e-beae-477d-a6e3-d7c19c79049a	9d6b6d5e-bfe0-4748-8083-69523c6dc9d7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":555,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:53:39
38845	9d6b6d5f-163a-4b10-99aa-36fb75d840de	9d6b6d5f-1a2a-44bf-bf19-0ad8562427cd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":192,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:53:40
38846	9d6b6d5f-ce4e-420e-9758-a1f9a294f3f7	9d6b6d60-162c-4177-8edb-fe2825db7fa1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 17:53:40
38847	9d6b6d60-1196-4c4a-a4c0-7e1c4e621e48	9d6b6d60-162c-4177-8edb-fe2825db7fa1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"154.47","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:53:40
38848	9d6b6d60-14cd-4db9-8e74-c2fdfec456b3	9d6b6d60-162c-4177-8edb-fe2825db7fa1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 17:53:40
38849	9d6b6d60-1536-4e0e-b574-42396ba4bde0	9d6b6d60-162c-4177-8edb-fe2825db7fa1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":337,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:53:40
39381	9d6bd091-4a66-4557-8583-6b33c7644a44	9d6bd091-7387-4286-97f6-d53e2581e28f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 22:31:02
39382	9d6bd091-7151-4dfb-98ae-791d5d8f19e0	9d6bd091-7387-4286-97f6-d53e2581e28f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 22:31:02
39383	9d6bd091-722b-42ff-bf95-292e2fa2fa50	9d6bd091-7387-4286-97f6-d53e2581e28f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":375,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:31:02
39384	9d6bd091-ec6a-4069-bca7-4715cd9874fd	9d6bd092-3303-4386-9ac2-772e47cfe176	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 22:31:02
39385	9d6bd092-2c63-470e-8fa5-4ea7734b1419	9d6bd092-3303-4386-9ac2-772e47cfe176	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"147.48","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 22:31:03
39386	9d6bd092-3189-4101-bafd-6946918eb587	9d6bd092-3303-4386-9ac2-772e47cfe176	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 22:31:03
39387	9d6bd092-31f9-438f-ac25-e10e0959ca9a	9d6bd092-3303-4386-9ac2-772e47cfe176	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":378,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:31:03
39388	9d6bd092-7951-4141-9f12-ba0431b3e3a5	9d6bd092-99e4-454b-8b5b-c97a78926c3a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 22:31:03
39389	9d6bd092-9457-4414-8bb9-eea7cddaeb33	9d6bd092-99e4-454b-8b5b-c97a78926c3a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:31:03
39390	9d6bd092-94b9-4dc4-80cc-66be96319dc3	9d6bd092-99e4-454b-8b5b-c97a78926c3a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:31:03
39391	9d6bd092-98a9-4880-83b3-2c3072315e26	9d6bd092-99e4-454b-8b5b-c97a78926c3a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 22:31:03
39392	9d6bd092-98ec-46c8-bc88-874cf1607508	9d6bd092-99e4-454b-8b5b-c97a78926c3a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:31:03
39393	9d6bd092-d97c-4fdd-8754-76a2eedb9881	9d6bd093-1d05-45cf-97f0-05496a195b43	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 22:31:03
39394	9d6bd093-185c-489b-9c51-741e43b4a79b	9d6bd093-1d05-45cf-97f0-05496a195b43	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"142.17","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:31:03
39395	9d6bd093-18ac-4214-a0e9-857c954e84bb	9d6bd093-1d05-45cf-97f0-05496a195b43	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:31:03
39396	9d6bd093-1bdf-4b20-be59-f5a532462ccc	9d6bd093-1d05-45cf-97f0-05496a195b43	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 22:31:03
39397	9d6bd093-1c1e-490a-b2de-d87eb36a000d	9d6bd093-1d05-45cf-97f0-05496a195b43	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":321,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:31:03
36523	9d6b3c80-f691-4c8f-afeb-2480a9771fa6	9d6b3c81-5523-49f1-bb85-57064bd634cd	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 15:37:01
36524	9d6b3c81-5281-46ee-8a04-842e675647b1	9d6b3c81-5523-49f1-bb85-57064bd634cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:37:01
36525	9d6b3c81-539e-4a74-8d0e-1b00ccdfa6bc	9d6b3c81-5523-49f1-bb85-57064bd634cd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":418,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:37:01
36526	9d6b3c81-e07e-45ee-8ca6-d9e4700eaf04	9d6b3c82-0100-468f-80ba-51d26136df9d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:37:02
36527	9d6b3c81-fb07-4011-9bd5-39d4b2a98d17	9d6b3c82-0100-468f-80ba-51d26136df9d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"46.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:37:02
36528	9d6b3c81-ff83-477d-a79a-b2a9d75e6dab	9d6b3c82-0100-468f-80ba-51d26136df9d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:37:02
36529	9d6b3c81-fff3-45d2-a835-f1de31116258	9d6b3c82-0100-468f-80ba-51d26136df9d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":362,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:37:02
39398	9d6bd094-f246-45db-9ae0-793522994358	9d6bd095-0f93-4b4a-a3ed-839d31fb0878	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 22:31:04
39399	9d6bd095-0a61-4cd8-81a4-18e658d94ffa	9d6bd095-0f93-4b4a-a3ed-839d31fb0878	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 22:31:04
39400	9d6bd095-0abc-4302-8f1b-2d01e0b25c75	9d6bd095-0f93-4b4a-a3ed-839d31fb0878	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 22:31:04
39401	9d6bd095-0e38-4470-8f63-ce8809de7f66	9d6bd095-0f93-4b4a-a3ed-839d31fb0878	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 22:31:04
39402	9d6bd095-0e7b-461a-bb87-759e26addb59	9d6bd095-0f93-4b4a-a3ed-839d31fb0878	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":374,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:31:04
36530	9d6b3c82-4aec-4c04-904d-d684a30f9b5b	9d6b3c82-6fdf-4ef7-93f0-08e6f45ee5cb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:37:02
36531	9d6b3c82-6a00-4619-94ac-13774d857622	9d6b3c82-6fdf-4ef7-93f0-08e6f45ee5cb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:37:02
36532	9d6b3c82-6a73-4680-a16c-540dfbceb6cd	9d6b3c82-6fdf-4ef7-93f0-08e6f45ee5cb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:37:02
36533	9d6b3c82-6e88-4e84-aee5-4e1b5c2ea7c1	9d6b3c82-6fdf-4ef7-93f0-08e6f45ee5cb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:37:02
36534	9d6b3c82-6ecd-4776-a45f-d4c265e6715f	9d6b3c82-6fdf-4ef7-93f0-08e6f45ee5cb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":274,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:37:02
39403	9d6bd095-5b78-4e1f-a90f-0664c15da46e	9d6bd095-5e4f-45fd-af47-b4075f768ef2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":169,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:31:05
36535	9d6b3c82-ba97-48ff-be7e-19c14f611fad	9d6b3c82-d9eb-478f-a271-9148c6980b16	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:37:02
36536	9d6b3c82-d451-40c9-b61b-7f1e98e89d5c	9d6b3c82-d9eb-478f-a271-9148c6980b16	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:37:02
36537	9d6b3c82-d49e-4a91-b4d3-ea0b02693971	9d6b3c82-d9eb-478f-a271-9148c6980b16	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:37:02
36538	9d6b3c82-d8b6-43b5-b41a-f295d65999f8	9d6b3c82-d9eb-478f-a271-9148c6980b16	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:37:02
36539	9d6b3c82-d908-4132-979e-0702ec7232c8	9d6b3c82-d9eb-478f-a271-9148c6980b16	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:37:02
39404	9d6bd095-de82-4b10-9a69-8e7bc989019c	9d6bd095-fb7a-45e0-a923-8594932acce6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 22:31:05
39405	9d6bd095-f5e7-4b53-beba-6c01af67088c	9d6bd095-fb7a-45e0-a923-8594932acce6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"43.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 22:31:05
39406	9d6bd095-fa10-4d2f-b577-bc20f0d52c6a	9d6bd095-fb7a-45e0-a923-8594932acce6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 22:31:05
39407	9d6bd095-fa7c-4793-ae50-76a2630527db	9d6bd095-fb7a-45e0-a923-8594932acce6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:31:05
36540	9d6b3c84-cc1c-4357-94f8-2c41bd79d256	9d6b3c84-f4fe-4afd-b7c9-b26268adac10	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:37:03
36541	9d6b3c84-edb5-4b8f-a7d2-bcf5cd65a0f0	9d6b3c84-f4fe-4afd-b7c9-b26268adac10	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"52.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:37:04
36542	9d6b3c84-ee19-49e5-a2bc-bed990064f64	9d6b3c84-f4fe-4afd-b7c9-b26268adac10	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:37:04
36543	9d6b3c84-f380-455b-a7e5-72f6fc04e1d7	9d6b3c84-f4fe-4afd-b7c9-b26268adac10	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:37:04
36544	9d6b3c84-f3ea-47ad-891e-b900a8c371e5	9d6b3c84-f4fe-4afd-b7c9-b26268adac10	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":433,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:37:04
39408	9d6bd0a2-bcd7-412c-bd60-ec306ae79b1c	9d6bd0a2-c045-4c15-839b-23b4f7105675	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":140,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:31:13
39409	9d6bd0a3-284f-4969-8a91-610af6976c66	9d6bd0a3-43bb-4118-ae8d-be93239c7bef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 22:31:14
39410	9d6bd0a3-3f23-4d6c-a5f8-344c8dc3283b	9d6bd0a3-43bb-4118-ae8d-be93239c7bef	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" where \\"l\\".\\"user_cobrador\\" = 14 order by \\"l\\".\\"id\\" desc","time":"41.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"9c165f2fbf7ccf3d02848123be5b6d04","hostname":"EderCortes"}	2024-11-05 22:31:14
39411	9d6bd0a3-4249-457e-a27e-ba229323f679	9d6bd0a3-43bb-4118-ae8d-be93239c7bef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 22:31:14
39412	9d6bd0a3-42b3-4cbf-9db9-4b539cff405c	9d6bd0a3-43bb-4118-ae8d-be93239c7bef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":14,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":222,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:31:14
39413	9d6bd0a7-34f0-4192-9ed4-d4634a65a19e	9d6bd0a7-383b-4453-b981-41e3e6d71035	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":199,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:31:16
39414	9d6bd0a7-ec51-4db7-8045-fd21caa6721e	9d6bd0a8-097f-41ef-a7de-e0a2e780ee3f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 22:31:17
39415	9d6bd0a8-04e4-460d-a4de-ad6a42c1a586	9d6bd0a8-097f-41ef-a7de-e0a2e780ee3f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"44.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 22:31:17
39416	9d6bd0a8-082b-45fc-a2d9-c3a41bfa9f59	9d6bd0a8-097f-41ef-a7de-e0a2e780ee3f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 22:31:17
39417	9d6bd0a8-0893-4d0d-b814-db061e25e966	9d6bd0a8-097f-41ef-a7de-e0a2e780ee3f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":224,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:31:17
39418	9d6bd0b4-5440-499f-b1e0-affbdc2e46c1	9d6bd0b4-57c2-4e3f-8406-fd407216ee06	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":166,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:31:25
40707	9d6cc6b1-2f6c-4b47-bf65-4ae3791f62ab	9d6cc6b1-3224-4c58-8f46-32284e3bc3b9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1844}	2024-11-06 09:59:15
39419	9d6bd0b5-1201-4d85-b1a9-798aabf7892c	9d6bd0b5-2f24-484e-b6a5-7b6ebb3f04d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 22:31:25
39420	9d6bd0b5-2a23-431c-9f3e-d60465501bbb	9d6bd0b5-2f24-484e-b6a5-7b6ebb3f04d8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" where \\"l\\".\\"user_cobrador\\" = 14 order by \\"l\\".\\"id\\" desc","time":"41.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"9c165f2fbf7ccf3d02848123be5b6d04","hostname":"EderCortes"}	2024-11-05 22:31:25
39421	9d6bd0b5-2db6-463a-8b50-6cda5f2d8d0e	9d6bd0b5-2f24-484e-b6a5-7b6ebb3f04d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 22:31:25
39422	9d6bd0b5-2e1e-42fb-aecc-944dfc183089	9d6bd0b5-2f24-484e-b6a5-7b6ebb3f04d8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":14,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":242,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:31:25
39423	9d6bd0bb-ee4c-4ee1-8736-4fea461df3bc	9d6bd0bb-f1e9-4bd3-9c08-9dc239081dfc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":182,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:31:30
39424	9d6bd0bc-a7b5-45f1-a762-7ab11b5a89ca	9d6bd0bc-ed31-4c8f-b1c6-915774085a86	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 22:31:30
39425	9d6bd0bc-e81c-4fc9-be36-36909555a8e7	9d6bd0bc-ed31-4c8f-b1c6-915774085a86	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"145.02","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 22:31:31
39426	9d6bd0bc-ebb0-4156-8d1d-bb0a92761d86	9d6bd0bc-ed31-4c8f-b1c6-915774085a86	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 22:31:31
39427	9d6bd0bc-ec24-4ebd-a22a-b446db4d8048	9d6bd0bc-ed31-4c8f-b1c6-915774085a86	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":337,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:31:31
39428	9d6bd0c3-63d3-4efb-8061-be25cd4a9e89	9d6bd0c3-67ec-45af-bb78-451d05a230d4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":166,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:31:35
36679	9d6b3e32-feb9-4bdf-b61d-671abadc9aed	9d6b3e33-4c85-4b67-a8d4-4271ac9b326e	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 15:41:45
36680	9d6b3e33-4a18-478c-b46b-2978c2edf3ab	9d6b3e33-4c85-4b67-a8d4-4271ac9b326e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:41:46
36681	9d6b3e33-4b17-490a-8c7b-9c5719e74729	9d6b3e33-4c85-4b67-a8d4-4271ac9b326e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":387,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:41:46
36682	9d6b3e33-b463-4525-beed-05f79b9dc636	9d6b3e33-d207-4635-ac5c-c422b837a4b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 15:41:46
36683	9d6b3e33-cc2d-43c2-953b-7b48340400a0	9d6b3e33-d207-4635-ac5c-c422b837a4b4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"44.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:41:46
36684	9d6b3e33-d05d-446b-99ab-cb2557ace820	9d6b3e33-d207-4635-ac5c-c422b837a4b4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:41:46
36685	9d6b3e33-d0ee-4df6-989f-73108bc225bb	9d6b3e33-d207-4635-ac5c-c422b837a4b4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":279,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:41:46
39429	9d6bd0c4-1962-45f3-8e0f-fea21c599614	9d6bd0c4-5e06-435a-8f5f-bb08d213db74	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 22:31:35
39430	9d6bd0c4-5995-430d-9bbc-fe5459661b4f	9d6bd0c4-5e06-435a-8f5f-bb08d213db74	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"146.54","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 22:31:35
39431	9d6bd0c4-5c97-4fa5-b124-54706733e9a9	9d6bd0c4-5e06-435a-8f5f-bb08d213db74	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 22:31:35
39432	9d6bd0c4-5d00-44ba-bd41-7b263eec9860	9d6bd0c4-5e06-435a-8f5f-bb08d213db74	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":319,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:31:35
36686	9d6b3e34-2637-4322-a8ed-afce212c4f9f	9d6b3e34-44aa-484f-a997-6286a0af1113	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 15:41:46
36687	9d6b3e34-3ec1-4219-9410-97f39fd1cffb	9d6b3e34-44aa-484f-a997-6286a0af1113	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"38.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:41:46
36688	9d6b3e34-3f10-4854-9ffc-48f1602ae59a	9d6b3e34-44aa-484f-a997-6286a0af1113	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:41:46
36689	9d6b3e34-4360-4818-99c6-c471b50f139b	9d6b3e34-44aa-484f-a997-6286a0af1113	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:41:46
36690	9d6b3e34-43ad-4e29-8483-ab14315432b2	9d6b3e34-44aa-484f-a997-6286a0af1113	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":278,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:41:46
39433	9d6bd0cb-8a6d-45fa-80e8-8fe0ff25ad41	9d6bd0cb-8dcf-412a-aa78-5e2f90c37c13	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":163,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:31:40
36691	9d6b3e34-8917-4412-b8ec-f4e165bbc058	9d6b3e34-a997-4aae-a1bb-8f810205094f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 15:41:46
36692	9d6b3e34-a382-4744-adbe-5f3bbf3afffd	9d6b3e34-a997-4aae-a1bb-8f810205094f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:41:46
36693	9d6b3e34-a3da-4cec-8a16-acd0fbe31fd0	9d6b3e34-a997-4aae-a1bb-8f810205094f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:41:46
36694	9d6b3e34-a809-4045-ae0b-ae529b0d6a7a	9d6b3e34-a997-4aae-a1bb-8f810205094f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:41:46
36695	9d6b3e34-a86a-49be-8cf2-28bfa958550a	9d6b3e34-a997-4aae-a1bb-8f810205094f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:41:46
39434	9d6bd0cc-3ef1-4ce8-a5cc-11a38bf4ea2b	9d6bd0cc-5e71-4a28-959e-5224f943c7b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 22:31:41
39435	9d6bd0cc-5a0f-455d-84e1-7408dd8a9056	9d6bd0cc-5e71-4a28-959e-5224f943c7b5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" where \\"l\\".\\"loans_cuando\\" = 'D' order by \\"l\\".\\"id\\" desc","time":"51.58","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"47674f76c8458eeaaea7595a72e119a9","hostname":"EderCortes"}	2024-11-05 22:31:41
39436	9d6bd0cc-5d24-4ad9-a4e4-593007bfd309	9d6bd0cc-5e71-4a28-959e-5224f943c7b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 22:31:41
39437	9d6bd0cc-5d67-4ae1-aa29-93a06d86544c	9d6bd0cc-5e71-4a28-959e-5224f943c7b5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"61","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":"D","estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"}]},"duration":228,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:31:41
36696	9d6b3e36-538c-41ed-ba08-a2335b0376f0	9d6b3e36-a8b8-4e15-8373-b25ef747a2c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 15:41:48
36697	9d6b3e36-a08b-40d0-8ea6-d74b4d617910	9d6b3e36-a8b8-4e15-8373-b25ef747a2c5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"168.09","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:41:48
36698	9d6b3e36-a10c-46b6-a40a-ab6ed97d5b4f	9d6b3e36-a8b8-4e15-8373-b25ef747a2c5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:41:48
36699	9d6b3e36-a6f1-4cd8-9835-ec8162704286	9d6b3e36-a8b8-4e15-8373-b25ef747a2c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 15:41:48
36700	9d6b3e36-a770-4260-b362-d7e5c96ef830	9d6b3e36-a8b8-4e15-8373-b25ef747a2c5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":601,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:41:48
39438	9d6bd0d0-4c46-472f-bdd6-e579ce8d1651	9d6bd0d0-4fac-429b-8016-30abcdb825e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":182,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:31:43
39439	9d6bd0d0-ff78-4d91-bbb3-9d67d94465ee	9d6bd0d1-19ea-4a36-a1a4-f0dd9499e5db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 22:31:44
39440	9d6bd0d1-1533-4e3e-a7f2-08fe6c3399b8	9d6bd0d1-19ea-4a36-a1a4-f0dd9499e5db	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"38.14","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 22:31:44
39441	9d6bd0d1-1873-482b-b35b-ae8c65422fef	9d6bd0d1-19ea-4a36-a1a4-f0dd9499e5db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 22:31:44
39442	9d6bd0d1-18f1-490f-be7b-38da9450d052	9d6bd0d1-19ea-4a36-a1a4-f0dd9499e5db	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"62","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":208,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:31:44
39443	9d6bd93b-adfa-43b7-95e2-cad8da6e8b86	9d6bd93b-d1ba-4412-8ad1-59198304b508	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 22:55:16
39444	9d6bd93b-ca99-46fc-a921-490ff43c4596	9d6bd93b-d1ba-4412-8ad1-59198304b508	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"45.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":26,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-05 22:55:16
39445	9d6bd93b-cf6a-452b-a661-7fe628af3c74	9d6bd93b-d1ba-4412-8ad1-59198304b508	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 22:55:16
39446	9d6bd93b-cff7-4a47-ad47-738756d74f31	9d6bd93b-d1ba-4412-8ad1-59198304b508	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":312,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:55:16
36840	9d6b40f7-fe23-490f-888e-c544f8178be5	9d6b40f8-22c8-40d8-8605-23d3ed435dbb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 15:49:30
36841	9d6b40f8-20b6-4dde-a364-5b2515f97d51	9d6b40f8-22c8-40d8-8605-23d3ed435dbb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 15:49:30
36842	9d6b40f8-2160-4401-b40c-0be274e5156a	9d6b40f8-22c8-40d8-8605-23d3ed435dbb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":354,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:49:30
36843	9d6b40f8-7fed-4a52-a720-92c4e1bb582e	9d6b40f8-c5a6-4b71-afd3-579d87fa5d7b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 15:49:30
36844	9d6b40f8-c139-4efc-9df9-cee565dd70e5	9d6b40f8-c5a6-4b71-afd3-579d87fa5d7b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"148.92","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:49:31
36845	9d6b40f8-c432-4de4-b169-df04f9182ad6	9d6b40f8-c5a6-4b71-afd3-579d87fa5d7b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 15:49:31
36846	9d6b40f8-c4ad-4f47-98ec-201e3b7ea896	9d6b40f8-c5a6-4b71-afd3-579d87fa5d7b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":350,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:49:31
36847	9d6b40f9-2159-409e-9d93-729638c7f82e	9d6b40f9-488b-4cc4-8850-d363248cd6a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 15:49:31
36848	9d6b40f9-4339-4178-a107-a74b50055600	9d6b40f9-488b-4cc4-8850-d363248cd6a6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:49:31
36849	9d6b40f9-4388-43b4-b118-289d079d2255	9d6b40f9-488b-4cc4-8850-d363248cd6a6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:49:31
36850	9d6b40f9-4733-4ab5-a51a-41f75ce11db6	9d6b40f9-488b-4cc4-8850-d363248cd6a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 15:49:31
36851	9d6b40f9-4785-4368-84a7-81ea4d35c972	9d6b40f9-488b-4cc4-8850-d363248cd6a6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":321,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:49:31
36852	9d6b40f9-89fa-40d9-9dcf-2038ffb04957	9d6b40f9-b6e0-4cba-aabe-5a1cac70b502	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 15:49:31
36853	9d6b40f9-adbe-4613-b0c6-8dec94e34763	9d6b40f9-b6e0-4cba-aabe-5a1cac70b502	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"59.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:49:31
36854	9d6b40f9-ae41-4b62-8b1c-1bfad94b6f38	9d6b40f9-b6e0-4cba-aabe-5a1cac70b502	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:49:31
36855	9d6b40f9-b4cc-4ebc-9582-49b960c5e33c	9d6b40f9-b6e0-4cba-aabe-5a1cac70b502	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 15:49:31
36856	9d6b40f9-b534-47eb-8308-93e489591811	9d6b40f9-b6e0-4cba-aabe-5a1cac70b502	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:49:31
36857	9d6b40fb-d81b-4083-8d40-bdd0937f1e97	9d6b40fc-06b5-4428-b75a-ef605efe85fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 15:49:33
36858	9d6b40fc-0011-4cb5-8d6f-9b1db933638e	9d6b40fc-06b5-4428-b75a-ef605efe85fd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"61.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:49:33
36859	9d6b40fc-00a9-48a2-a392-91152f2b1117	9d6b40fc-06b5-4428-b75a-ef605efe85fd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:49:33
36860	9d6b40fc-0527-4e1d-b9b3-80e2e9abafdd	9d6b40fc-06b5-4428-b75a-ef605efe85fd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-05 15:49:33
36861	9d6b40fc-057f-464d-b30c-cdc14dd1059c	9d6b40fc-06b5-4428-b75a-ef605efe85fd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":468,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:49:33
40401	9d6cc30d-130d-431c-9f31-c4900c661ed6	9d6cc30d-15ca-4a4a-a3ec-e904f6318a34	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1808}	2024-11-06 09:49:04
34565	9d69becd-89e6-41e5-bca9-f52829dce9c2	9d69becd-c674-434d-8915-da8fb9d6bb20	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 21:49:42
34566	9d69becd-c01f-4026-a070-93d2cc9ecdd2	9d69becd-c674-434d-8915-da8fb9d6bb20	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 21:49:42
34567	9d69becd-c17d-422d-9000-6b0eded241d7	9d69becd-c674-434d-8915-da8fb9d6bb20	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":483,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:49:42
34568	9d69bece-6e5b-4711-b40e-2aa741e5a1aa	9d69bece-a119-4923-9af1-7bb2a0eef95d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 21:49:43
34569	9d69bece-95c6-4f4e-a980-79285fa4461c	9d69bece-a119-4923-9af1-7bb2a0eef95d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"62.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":258,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:49:43
34570	9d69bece-9656-46dd-99cf-2a0dc767f8b2	9d69bece-a119-4923-9af1-7bb2a0eef95d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:49:43
34571	9d69bece-9ed7-45e3-b134-681f8b20b574	9d69bece-a119-4923-9af1-7bb2a0eef95d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 21:49:43
34572	9d69bece-9f6f-49eb-b68d-720cec6670bf	9d69bece-a119-4923-9af1-7bb2a0eef95d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":466,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:49:43
34573	9d69becf-1f48-4b61-88cb-b973b6aa73a2	9d69becf-4ca2-49b0-865b-1a6db787d66e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 21:49:43
34574	9d69becf-4292-455b-8ac2-4f956bc6f2e1	9d69becf-4ca2-49b0-865b-1a6db787d66e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"56.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":247,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 21:49:43
34575	9d69becf-432a-4920-89d5-a7a603437427	9d69becf-4ca2-49b0-865b-1a6db787d66e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 21:49:43
34576	9d69becf-4a86-4cd0-ad1b-783b8194334f	9d69becf-4ca2-49b0-865b-1a6db787d66e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 21:49:43
34577	9d69becf-4b27-49e2-8a34-c44c2cbbd1af	9d69becf-4ca2-49b0-865b-1a6db787d66e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":407,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:49:43
34578	9d69becf-c841-47cf-9cf6-a910b9147288	9d69becf-fb91-4dfb-8813-7f360bdfbc84	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 21:49:44
34579	9d69becf-f14c-4d2f-a2b9-f6eecac62897	9d69becf-fb91-4dfb-8813-7f360bdfbc84	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"66.28","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:49:44
34580	9d69becf-f1d5-414a-83ae-1a7c0e0a682a	9d69becf-fb91-4dfb-8813-7f360bdfbc84	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:49:44
34581	9d69becf-f98c-47f1-819b-11567d9793dd	9d69becf-fb91-4dfb-8813-7f360bdfbc84	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 21:49:44
34582	9d69becf-fa20-4d50-9ad3-34abd58b2402	9d69becf-fb91-4dfb-8813-7f360bdfbc84	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":424,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:49:44
34583	9d69bed0-57fd-4664-86a8-c1f1561228f9	9d69bed0-77c7-4b97-bfad-b5a064343f72	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 21:49:44
34584	9d69bed0-708c-4ef4-83c5-296069c864f0	9d69bed0-77c7-4b97-bfad-b5a064343f72	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_valor_prestado\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"loans_inicio_pago\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"loans_fecha_ultimo_pago\\", \\"loans_intereses_recaudar\\", \\"user_recomendacion\\", \\"loans_pago_prestado\\", \\"loans_pago_interes\\" from \\"loans\\" where \\"id\\" = '93' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"40.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":234,"hash":"b4e83635108fe86540c23b34f96ea07e","hostname":"EderCortes"}	2024-11-04 21:49:44
34585	9d69bed0-70e1-4c71-9e24-f65e292304c0	9d69bed0-77c7-4b97-bfad-b5a064343f72	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 21:49:44
34586	9d69bed0-7282-4deb-85ed-95011459c2a9	9d69bed0-77c7-4b97-bfad-b5a064343f72	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"2.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":235,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 21:49:44
34587	9d69bed0-72bc-45d9-87a5-a5dc22c25320	9d69bed0-77c7-4b97-bfad-b5a064343f72	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 21:49:44
34588	9d69bed0-7677-4548-9347-4c9e528fc2b8	9d69bed0-77c7-4b97-bfad-b5a064343f72	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 21:49:44
34589	9d69bed0-76e0-4b28-ac26-627348c817e0	9d69bed0-77c7-4b97-bfad-b5a064343f72	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"loans_inicio_pago":"2024-11-04 00:00:00","user_creador":12,"user_cobrador":22,"user_customer":19,"loans_fecha_ultimo_pago":"04-11-2024","loans_intereses_recaudar":"250000","user_recomendacion":18,"loans_pago_prestado":"1000000","loans_pago_interes":"250000"},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:19:45.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:22:30.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":399,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":400,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":401,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":402,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"}]}},"duration":296,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:49:44
34590	9d69bed0-f943-4b62-9ecd-f0f5324aee85	9d69bed1-2d31-4ca1-a8d0-da85bb9c402d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 21:49:44
34591	9d69bed1-2275-48be-a7eb-3d1c0c13448e	9d69bed1-2d31-4ca1-a8d0-da85bb9c402d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"66.93","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:49:45
34592	9d69bed1-230f-4909-b556-5af511099601	9d69bed1-2d31-4ca1-a8d0-da85bb9c402d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:49:45
34593	9d69bed1-2ab8-4b22-a727-f181bd0bf5cf	9d69bed1-2d31-4ca1-a8d0-da85bb9c402d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 21:49:45
34594	9d69bed1-2b50-43fc-9ecc-f3e225d8af57	9d69bed1-2d31-4ca1-a8d0-da85bb9c402d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":442,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:49:45
34595	9d69bed2-d3e5-4422-9493-1c9e62132483	9d69bed2-f49f-4432-aa91-7ff64f7ee297	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 21:49:46
34596	9d69bed2-eddd-445f-865b-ec87ef4952a5	9d69bed2-f49f-4432-aa91-7ff64f7ee297	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.26","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:49:46
34597	9d69bed2-ee34-4868-aa7c-9e4254723969	9d69bed2-f49f-4432-aa91-7ff64f7ee297	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:49:46
34598	9d69bed2-f2a8-4877-a6ef-a93dd9adb423	9d69bed2-f49f-4432-aa91-7ff64f7ee297	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 21:49:46
34599	9d69bed2-f32f-477c-b2f3-a9facaf49f29	9d69bed2-f49f-4432-aa91-7ff64f7ee297	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":480,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:49:46
29447	9d69246f-4562-4cd5-9905-8e0ad8528412	9d69246f-b21f-4597-b4f4-9abd7e361ae0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 14:38:04
29448	9d69246f-ae53-40aa-9787-35e80fe13c0e	9d69246f-b21f-4597-b4f4-9abd7e361ae0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 14:38:04
29449	9d69246f-b028-4554-a721-740288e90545	9d69246f-b21f-4597-b4f4-9abd7e361ae0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":631,"memory":22,"hostname":"EderCortes"}	2024-11-04 14:38:04
30538	9d693fd2-56f8-44c4-a3aa-6af00afe9fa2	9d693fd2-8fdc-4eae-96d4-cfca51b7ecc3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 15:54:38
30539	9d693fd2-8d23-4d29-b24f-66061f74dde8	9d693fd2-8fdc-4eae-96d4-cfca51b7ecc3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 15:54:38
30540	9d693fd2-8e50-4571-b3b5-acfdd683bd2a	9d693fd2-8fdc-4eae-96d4-cfca51b7ecc3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":404,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:54:38
39654	9d6be0c0-d760-4d5d-965d-a7f25212b20d	9d6be0c1-1bef-46b1-9177-9f9420d57a54	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 23:16:17
39655	9d6be0c1-1a69-4b26-86f9-6bbfd40e67e7	9d6be0c1-1bef-46b1-9177-9f9420d57a54	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 23:16:18
39656	9d6be0c1-1b04-4739-95a6-b7c7c265fd6e	9d6be0c1-1bef-46b1-9177-9f9420d57a54	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":343,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:16:18
39657	9d6be0c2-ab37-42e1-8ba6-c3a1da20bea8	9d6be0c2-cc0b-42fe-811d-de97f06ddc3a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 23:16:19
39658	9d6be0c2-c713-40de-9f90-d85d1694b24f	9d6be0c2-cc0b-42fe-811d-de97f06ddc3a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 23:16:19
39659	9d6be0c2-c762-490a-9b29-d7906d7e4baf	9d6be0c2-cc0b-42fe-811d-de97f06ddc3a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 23:16:19
39660	9d6be0c2-cabe-41bb-9174-378afe752578	9d6be0c2-cc0b-42fe-811d-de97f06ddc3a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 23:16:19
39661	9d6be0c2-cb02-470f-ad4a-b9df72d795ab	9d6be0c2-cc0b-42fe-811d-de97f06ddc3a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":377,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:16:19
34799	9d69bfc5-6762-4912-84a4-9fc002573422	9d69bfc5-99f5-4a32-9096-3f70dc24c7b8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:52:25
34800	9d69bfc5-96fd-465a-9e62-e21cf8e720b4	9d69bfc5-99f5-4a32-9096-3f70dc24c7b8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:52:25
34801	9d69bfc5-983c-4c44-90f3-c1aaccfec530	9d69bfc5-99f5-4a32-9096-3f70dc24c7b8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":433,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:52:25
34802	9d69bfc6-472e-4c95-9f45-e1007306122f	9d69bfc6-a4f2-4694-a0f1-2fdab348c757	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:52:25
34803	9d69bfc6-9c9f-49b1-b01c-e932e9c8e7ba	9d69bfc6-a4f2-4694-a0f1-2fdab348c757	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"166.04","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:52:25
34804	9d69bfc6-9d17-4c7d-9b3b-5d87a4247d8c	9d69bfc6-a4f2-4694-a0f1-2fdab348c757	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:52:25
34805	9d69bfc6-a335-4a39-89ba-4bed3382fada	9d69bfc6-a4f2-4694-a0f1-2fdab348c757	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:52:25
34806	9d69bfc6-a3a4-41e3-9b22-97d546941159	9d69bfc6-a4f2-4694-a0f1-2fdab348c757	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":583,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:52:25
40554	9d6cc4e6-5be2-4530-80ca-9f42a3fd0fa7	9d6cc4e6-5f23-42d1-b5a9-60adfb00a96d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1826}	2024-11-06 09:54:14
34807	9d69bfc7-10d2-4683-8b35-451e15eee160	9d69bfc7-42b9-43be-af70-9e0e8cba78a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:52:26
34808	9d69bfc7-36b3-42bd-a1a5-563a95e07502	9d69bfc7-42b9-43be-af70-9e0e8cba78a6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"59.45","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 21:52:26
34809	9d69bfc7-373f-4abf-a2d8-c981685a0ccb	9d69bfc7-42b9-43be-af70-9e0e8cba78a6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 21:52:26
34810	9d69bfc7-3e23-475a-86e3-ba54879f09d3	9d69bfc7-42b9-43be-af70-9e0e8cba78a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:52:26
34811	9d69bfc7-3ea9-4a6f-8e8e-f6a658b55cbd	9d69bfc7-42b9-43be-af70-9e0e8cba78a6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":377,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:52:26
34812	9d69bfc7-b483-45c5-890f-752323fb09a7	9d69bfc7-de6d-43b0-9d93-3b0ba776723b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:52:26
34813	9d69bfc7-d4d3-43f5-998e-684f9f3482f4	9d69bfc7-de6d-43b0-9d93-3b0ba776723b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"50.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:52:26
34814	9d69bfc7-d570-43bc-a8b6-9f6943f52805	9d69bfc7-de6d-43b0-9d93-3b0ba776723b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:52:26
34815	9d69bfc7-dc6d-4342-a2ea-d81bb34fce2b	9d69bfc7-de6d-43b0-9d93-3b0ba776723b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 21:52:26
34816	9d69bfc7-dcee-4856-99e6-b2857474f887	9d69bfc7-de6d-43b0-9d93-3b0ba776723b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":375,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:52:26
31328	9d694a2a-7a4f-49a6-8994-c17c7ac9b824	9d694a2a-7e88-479d-8390-cec4f4990df4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abas\\u00bb\\nLINE 1: select * from \\"item_loans\\".* as \\"users.user_alias\\" inner joi...\\n                                     ^ (Connection: pgsql, SQL: select * from \\"item_loans\\".* as \\"users.user_alias\\" inner join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"loans_codigo\\" = 92 order by \\"item_loans\\".\\"id\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":305},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1493}	2024-11-04 16:23:34
34817	9d69bfc8-3163-490e-8fb1-c64dffffc6dd	9d69bfc8-4f53-4896-8ae3-65abe9b0ba4c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 21:52:26
34818	9d69bfc8-48b2-473f-a32f-b8dd59b5d5c8	9d69bfc8-4f53-4896-8ae3-65abe9b0ba4c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_valor_prestado\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\" from \\"loans\\" where \\"id\\" = '93' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"40.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":229,"hash":"f00e27e21a94f93c5c7a1d0cd56f9f13","hostname":"EderCortes"}	2024-11-04 21:52:27
34819	9d69bfc8-4902-4471-a0b8-a42d3f48a603	9d69bfc8-4f53-4896-8ae3-65abe9b0ba4c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-04 21:52:27
34820	9d69bfc8-4a91-4160-bc27-2e003dbfd05c	9d69bfc8-4f53-4896-8ae3-65abe9b0ba4c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"1.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":230,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-04 21:52:27
34821	9d69bfc8-4ac6-4cb6-b990-aa487dbd22da	9d69bfc8-4f53-4896-8ae3-65abe9b0ba4c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-04 21:52:27
34822	9d69bfc8-4e04-429b-a007-10140ce1ca26	9d69bfc8-4f53-4896-8ae3-65abe9b0ba4c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 21:52:27
34823	9d69bfc8-4e64-4718-a4e5-f1a4441c7e66	9d69bfc8-4f53-4896-8ae3-65abe9b0ba4c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"user_creador":12,"user_cobrador":22,"user_customer":19,"user_recomendacion":18},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:19:45.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:22:30.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":399,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":400,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":401,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":402,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"}]}},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:52:27
43195	9d6ce543-e811-40bf-ae78-209db08180ab	9d6ce544-0832-4b44-ad53-12ff742d6a34	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 11:24:44
43196	9d6ce544-061f-4a2e-94f3-d42692bf78fb	9d6ce544-0832-4b44-ad53-12ff742d6a34	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 11:24:44
43197	9d6ce544-072c-425d-acc8-71fef9e85a3b	9d6ce544-0832-4b44-ad53-12ff742d6a34	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":259,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:24:44
34824	9d69bfc8-c06e-454c-a890-2c905a17b4e9	9d69bfc8-f759-4ec7-9c58-466c24306bd2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 21:52:27
34825	9d69bfc8-edcc-4076-9a0f-97c7553857e9	9d69bfc8-f759-4ec7-9c58-466c24306bd2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"74.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:52:27
34826	9d69bfc8-ee58-4f9e-b868-afdea619945e	9d69bfc8-f759-4ec7-9c58-466c24306bd2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:52:27
34827	9d69bfc8-f55b-4c7b-a4d8-2a9040796be1	9d69bfc8-f759-4ec7-9c58-466c24306bd2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 21:52:27
34828	9d69bfc8-f5f1-4c98-8d02-b8e4929dc468	9d69bfc8-f759-4ec7-9c58-466c24306bd2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":410,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:52:27
34829	9d69bfca-64df-435c-b76f-05f39408708b	9d69bfca-abad-4833-a8f7-5862d6f852ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 21:52:28
34830	9d69bfca-a6ad-4921-b2eb-0cbab5fec4a6	9d69bfca-abad-4833-a8f7-5862d6f852ec	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"147.27","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:52:28
34831	9d69bfca-a6ff-4fa9-b3a3-533247358679	9d69bfca-abad-4833-a8f7-5862d6f852ec	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:52:28
34832	9d69bfca-aa5a-4c9a-953d-1cad60630fa2	9d69bfca-abad-4833-a8f7-5862d6f852ec	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-04 21:52:28
34833	9d69bfca-aaa5-4ec1-bd59-24e1f11d1159	9d69bfca-abad-4833-a8f7-5862d6f852ec	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":442,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:52:28
39708	9d6be264-d584-4a3e-ae0f-cb71208c2283	9d6be265-2535-4c95-ad01-39bc63fb560d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 23:20:53
39709	9d6be265-2311-4035-90fe-7dac88974ea9	9d6be265-2535-4c95-ad01-39bc63fb560d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 23:20:53
39710	9d6be265-2410-4acd-bb36-c59186b43239	9d6be265-2535-4c95-ad01-39bc63fb560d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":365,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:20:53
38526	9d6b6658-9a21-4a1a-8474-920f4026384a	9d6b6658-9f4b-4957-9c66-32f018fcb765	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1730}	2024-11-05 17:34:01
39711	9d6be266-cdc5-4bad-91d3-03ed351099f5	9d6be266-f27a-4f4d-a6da-5036ae04d045	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 23:20:54
39712	9d6be266-ea54-4b2d-9960-094ac3849c42	9d6be266-f27a-4f4d-a6da-5036ae04d045	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"48.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 23:20:54
39713	9d6be266-eaba-4e00-bd83-7aeeafc6c57d	9d6be266-f27a-4f4d-a6da-5036ae04d045	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 23:20:54
39714	9d6be266-f0eb-4a4d-92fd-b0b307efc085	9d6be266-f27a-4f4d-a6da-5036ae04d045	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 23:20:54
39715	9d6be266-f153-41af-aea3-6b243086b965	9d6be266-f27a-4f4d-a6da-5036ae04d045	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":574,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:20:54
41593	9d6ccdc3-9475-4f2f-bd08-5df3fa911a5d	9d6ccdc3-995a-47bc-a3b5-365eb74d9a1e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1906}	2024-11-06 10:19:01
34978	9d69c13b-f07b-4a5e-b275-d7e2993a6fe4	9d69c13c-2b9f-49b4-8df0-f8c6f3e98648	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-04 21:56:30
34979	9d69c13c-286c-4819-bed0-9ed671761268	9d69c13c-2b9f-49b4-8df0-f8c6f3e98648	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:56:30
34980	9d69c13c-2a01-4d0f-b69b-9d83e0f4e094	9d69c13c-2b9f-49b4-8df0-f8c6f3e98648	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":479,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:56:30
34981	9d69c13c-d5d3-47d0-a759-e5b40e2fa212	9d69c13c-fddf-46ff-b9a1-2394f63e7cd5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-04 21:56:31
34982	9d69c13c-f8a9-4a31-88b3-458cc0765b87	9d69c13c-fddf-46ff-b9a1-2394f63e7cd5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"57.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 21:56:31
34983	9d69c13c-fc3d-4caf-9140-80c69e26388a	9d69c13c-fddf-46ff-b9a1-2394f63e7cd5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:56:31
34984	9d69c13c-fcb8-4f5e-bb74-8b164c6acedd	9d69c13c-fddf-46ff-b9a1-2394f63e7cd5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":444,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:56:31
34985	9d69c13d-826d-46da-9650-01bea5627ceb	9d69c13d-ce88-4864-ad0c-e8aca311dda1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-04 21:56:31
34986	9d69c13d-be1f-4d81-8963-a38050f2687d	9d69c13d-ce88-4864-ad0c-e8aca311dda1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"89.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:56:31
34987	9d69c13d-bed6-41d5-ac18-f4ddb5a82842	9d69c13d-ce88-4864-ad0c-e8aca311dda1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:56:31
34988	9d69c13d-c917-465d-8afd-24a66f6a41a6	9d69c13d-ce88-4864-ad0c-e8aca311dda1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:56:31
34989	9d69c13d-c9ba-4b97-bf17-21c729111ab4	9d69c13d-ce88-4864-ad0c-e8aca311dda1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":509,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:56:31
41294	9d6ccc39-eb77-4203-973d-b7c01b11508f	9d6ccc39-efe1-4776-94c6-dc7d2590f9b5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1892}	2024-11-06 10:14:43
34990	9d69c13f-122f-47de-83c8-bbc8ad4ef607	9d69c13f-6238-4b4d-8fb1-7b2694f8bfff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-04 21:56:32
34991	9d69c13f-5a18-4b4f-9824-faeeab060976	9d69c13f-6238-4b4d-8fb1-7b2694f8bfff	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"151.19","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 21:56:32
34992	9d69c13f-5a87-4d74-b95a-ee67cf00f228	9d69c13f-6238-4b4d-8fb1-7b2694f8bfff	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 21:56:32
34993	9d69c13f-6047-4366-97cd-12b429d0c754	9d69c13f-6238-4b4d-8fb1-7b2694f8bfff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 21:56:32
34994	9d69c13f-60d2-49d1-b135-cf3beb677c94	9d69c13f-6238-4b4d-8fb1-7b2694f8bfff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":692,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:56:32
39800	9d6cb63a-1b37-481b-a710-9ae802855bd3	9d6cb63a-86e7-41ad-9276-a569c5094c1a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:13:12
39801	9d6cb63a-8383-439c-9d28-7f6ba6ae440c	9d6cb63a-86e7-41ad-9276-a569c5094c1a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:13:13
39802	9d6cb63a-8559-4066-af1f-11a28d7d2070	9d6cb63a-86e7-41ad-9276-a569c5094c1a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":494,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:13:13
39803	9d6cb63b-cefa-4811-a46d-8dbd55ad0398	9d6cb63c-161f-495d-95a2-f5ae90871dd8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:13:14
37185	9d6b45b2-56aa-4ae1-a60a-80c962291207	9d6b45b2-80b5-4db3-bd52-f8adff1c25af	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 16:02:43
37186	9d6b45b2-7dd9-416a-8bd8-fc8970784a9f	9d6b45b2-80b5-4db3-bd52-f8adff1c25af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 16:02:43
37187	9d6b45b2-7f20-439a-a08b-ebdc7877df59	9d6b45b2-80b5-4db3-bd52-f8adff1c25af	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":390,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:02:43
34999	9d69c150-5340-463c-b1c8-873791e79028	9d69c150-9bbe-4e65-b801-fcf1775591c7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 21:56:43
39804	9d6cb63c-10ff-427b-b783-ef9e3f626432	9d6cb63c-161f-495d-95a2-f5ae90871dd8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"149.54","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:13:14
39805	9d6cb63c-1164-47bd-a326-405b2807f935	9d6cb63c-161f-495d-95a2-f5ae90871dd8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:13:14
39806	9d6cb63c-14e9-4998-8314-c5b7c8f3564e	9d6cb63c-161f-495d-95a2-f5ae90871dd8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 09:13:14
39807	9d6cb63c-152e-456b-a260-b97b5430493d	9d6cb63c-161f-495d-95a2-f5ae90871dd8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":341,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:13:14
37188	9d6b45b3-2ec1-444d-8547-8f0ab72ba6ba	9d6b45b3-72f5-4654-b5e0-72149dc2957c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 16:02:44
37189	9d6b45b3-6e8f-40c0-8f24-aee08cf602f7	9d6b45b3-72f5-4654-b5e0-72149dc2957c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"147.26","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 16:02:44
37190	9d6b45b3-71b8-479b-8f87-e553a8adef42	9d6b45b3-72f5-4654-b5e0-72149dc2957c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 16:02:44
37191	9d6b45b3-7226-4899-ab66-b56a5380762a	9d6b45b3-72f5-4654-b5e0-72149dc2957c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":463,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:02:44
35000	9d69c150-9637-4a9e-b2aa-d06d65ff9a49	9d69c150-9bbe-4e65-b801-fcf1775591c7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"150.71","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 21:56:44
37192	9d6b45b3-bb4b-48ee-af75-942932db6228	9d6b45b3-db9b-48cc-b4a9-30f1bbf6e1e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 16:02:44
37193	9d6b45b3-d6fa-4410-b74c-b27cd93224e3	9d6b45b3-db9b-48cc-b4a9-30f1bbf6e1e8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:02:44
37194	9d6b45b3-d752-4f9f-b890-59832b5a9b6c	9d6b45b3-db9b-48cc-b4a9-30f1bbf6e1e8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:02:44
37195	9d6b45b3-da7a-4bfc-a89f-c8abc170d5f3	9d6b45b3-db9b-48cc-b4a9-30f1bbf6e1e8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 16:02:44
35001	9d69c150-968f-4172-b186-7c2d6753310f	9d69c150-9bbe-4e65-b801-fcf1775591c7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 21:56:44
35002	9d69c150-9a51-4e24-b60a-76880a1af58f	9d69c150-9bbe-4e65-b801-fcf1775591c7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-04 21:56:44
37196	9d6b45b3-dab7-4ada-a32e-a3f410a931ee	9d6b45b3-db9b-48cc-b4a9-30f1bbf6e1e8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:02:44
43581	9d6cea13-1a2d-4801-9560-e70f5862abe1	9d6cea13-1cbf-42e3-b6b3-f014a59d25d1	2a264fcdf6fd1718cdcd261a25d8dc04	t	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2048}	2024-11-06 11:38:11
43582	9d6cea13-03d4-4394-8f9a-9aa9e960a573	9d6cea13-1cbf-42e3-b6b3-f014a59d25d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":36,"hostname":"EderCortes"}	2024-11-06 11:38:11
43583	9d6cea13-1b5c-42c4-bad8-e21cd79c0723	9d6cea13-1cbf-42e3-b6b3-f014a59d25d1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":37,"hostname":"EderCortes"}	2024-11-06 11:38:11
43584	9d6cea13-1beb-4c77-b7fe-3f97033b644f	9d6cea13-1cbf-42e3-b6b3-f014a59d25d1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":209,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:11
37197	9d6b45b4-1ba3-4e5b-a5f8-72f775ecb886	9d6b45b4-6123-46ae-9037-990418d2042e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 16:02:44
37198	9d6b45b4-5bbc-4d2e-b7bd-296bb148e590	9d6b45b4-6123-46ae-9037-990418d2042e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"144.25","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:02:45
37199	9d6b45b4-5c09-4e59-8e9b-1359158c1990	9d6b45b4-6123-46ae-9037-990418d2042e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:02:45
37200	9d6b45b4-5fc5-4aed-9506-8cf6dd81d6b9	9d6b45b4-6123-46ae-9037-990418d2042e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 16:02:45
37201	9d6b45b4-601c-42d9-ac97-72f9056b9213	9d6b45b4-6123-46ae-9037-990418d2042e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":322,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:02:45
37202	9d6b45b6-7cf3-4aed-b325-9ade68ccbd67	9d6b45b6-9e69-43db-bcb8-54e51ca7b3ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 16:02:46
37203	9d6b45b6-989f-4cf8-8d79-1cfbaf9c5695	9d6b45b6-9e69-43db-bcb8-54e51ca7b3ef	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"49.56","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 16:02:46
37204	9d6b45b6-98fc-478c-ab13-f7736f3c76ac	9d6b45b6-9e69-43db-bcb8-54e51ca7b3ef	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 16:02:46
37205	9d6b45b6-9cfc-4ebd-8166-7dcc859c3489	9d6b45b6-9e69-43db-bcb8-54e51ca7b3ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 16:02:46
37206	9d6b45b6-9d55-4a40-9425-d88fd6a3be4a	9d6b45b6-9e69-43db-bcb8-54e51ca7b3ef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":451,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:02:46
40088	9d6cc0dc-9fc0-4c5a-9584-1b85894633e3	9d6cc0dc-bdd5-4353-9215-4501ccb6c44f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:42:57
40089	9d6cc0dc-bc30-4e65-9b90-e1849f8d1e96	9d6cc0dc-bdd5-4353-9215-4501ccb6c44f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 09:42:57
40090	9d6cc0dc-bcdf-4953-bbe5-811db94dd896	9d6cc0dc-bdd5-4353-9215-4501ccb6c44f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:42:57
40091	9d6cc0dd-a425-4ace-9720-889b1c15a46d	9d6cc0dd-cb5a-454a-aefc-20386fe89c12	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 09:42:57
40092	9d6cc0dd-c4e1-408b-93ed-2d115ba930f3	9d6cc0dd-cb5a-454a-aefc-20386fe89c12	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"54.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:42:57
40093	9d6cc0dd-c548-4a94-ad6f-e7341fdb6807	9d6cc0dd-cb5a-454a-aefc-20386fe89c12	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:42:57
40094	9d6cc0dd-c9a6-4b0e-aae5-3168405fb1e4	9d6cc0dd-cb5a-454a-aefc-20386fe89c12	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 09:42:57
40095	9d6cc0dd-ca2b-49cb-a31c-ddf4917c7360	9d6cc0dd-cb5a-454a-aefc-20386fe89c12	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":296,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:42:57
41878	9d6cd08f-a901-4317-a7f5-a750b7bd90fd	9d6cd08f-abd2-49ad-aef3-0f596ace4e06	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1940}	2024-11-06 10:26:51
40096	9d6cc0de-2704-440f-a06e-67c85dbc2a4d	9d6cc0de-4445-4cd7-b08f-d0ad9e8f2da4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 09:42:58
40097	9d6cc0de-3fd4-4731-813b-42242d37d80d	9d6cc0de-4445-4cd7-b08f-d0ad9e8f2da4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"41.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:42:58
40098	9d6cc0de-42d7-4cb6-9b6b-2a42deab5c34	9d6cc0de-4445-4cd7-b08f-d0ad9e8f2da4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 09:42:58
40099	9d6cc0de-4329-4305-95c5-e7bc612c9c1a	9d6cc0de-4445-4cd7-b08f-d0ad9e8f2da4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":293,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:42:58
37354	9d6b4881-72e0-475b-b723-5d2a0a41d788	9d6b4881-981f-41b3-9331-32ca709eafce	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 16:10:35
37355	9d6b4881-95ed-4d8b-88e2-82a66759b5c3	9d6b4881-981f-41b3-9331-32ca709eafce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 16:10:35
37356	9d6b4881-96b9-4655-a6c7-ac0f9306b89a	9d6b4881-981f-41b3-9331-32ca709eafce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:10:35
37357	9d6b4881-ff49-4e46-a8d9-144d55e8dd60	9d6b4882-1e0b-405a-9442-bb0d331c9994	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 16:10:35
37358	9d6b4882-1942-46f0-8175-e18b8680e586	9d6b4882-1e0b-405a-9442-bb0d331c9994	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"48.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 16:10:35
37359	9d6b4882-1ca3-460d-9e63-d4f1e381ccbc	9d6b4882-1e0b-405a-9442-bb0d331c9994	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 16:10:35
37360	9d6b4882-1d10-42c9-9c81-4501e0193f77	9d6b4882-1e0b-405a-9442-bb0d331c9994	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":280,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:10:35
37361	9d6b4882-81fc-407e-83ad-719e9f335dc7	9d6b4882-a181-41e4-a530-2f698908ccfd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 16:10:35
37362	9d6b4882-9c5a-4e8b-a992-7a6727acff41	9d6b4882-a181-41e4-a530-2f698908ccfd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:10:35
37363	9d6b4882-9ca5-401f-841f-29ea9f854b04	9d6b4882-a181-41e4-a530-2f698908ccfd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:10:35
37364	9d6b4882-a030-434b-bc49-cd38e6573813	9d6b4882-a181-41e4-a530-2f698908ccfd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 16:10:35
37365	9d6b4882-a073-4476-bb30-121e7c9e9581	9d6b4882-a181-41e4-a530-2f698908ccfd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":321,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:10:35
37366	9d6b4882-f3b0-44e6-a400-6f402987bfa1	9d6b4883-212a-402a-af53-a9f06f4ca5c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 16:10:36
37367	9d6b4883-1a63-46aa-b56b-206021d57191	9d6b4883-212a-402a-af53-a9f06f4ca5c5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"62.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:10:36
37368	9d6b4883-1ab8-427d-b5de-bf1ef98176fe	9d6b4883-212a-402a-af53-a9f06f4ca5c5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:10:36
37369	9d6b4883-1fcc-4956-9061-3b1e3b3a41f5	9d6b4883-212a-402a-af53-a9f06f4ca5c5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 16:10:36
37370	9d6b4883-2024-47d2-b986-22bf5cfc31ac	9d6b4883-212a-402a-af53-a9f06f4ca5c5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":312,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:10:36
37371	9d6b4884-fe72-4989-aa2c-35244fdfe6c0	9d6b4885-1e34-44a5-8fa2-3c81bf8bcc9f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 16:10:37
37372	9d6b4885-18aa-4f3c-88ed-87856f92a814	9d6b4885-1e34-44a5-8fa2-3c81bf8bcc9f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"46.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 16:10:37
37373	9d6b4885-1911-4611-98a0-1408f827f248	9d6b4885-1e34-44a5-8fa2-3c81bf8bcc9f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 16:10:37
37374	9d6b4885-1cf5-4253-b0b0-ec199ed4b9aa	9d6b4885-1e34-44a5-8fa2-3c81bf8bcc9f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 16:10:37
37375	9d6b4885-1d3b-4b89-b773-6dfc40e1dee5	9d6b4885-1e34-44a5-8fa2-3c81bf8bcc9f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":288,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:10:37
40136	9d6cc120-d6ab-4f90-b668-0a7e10f88db0	9d6cc120-d97e-4cc2-a9ea-7edd729c502e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1796}	2024-11-06 09:43:41
35343	9d69c401-b183-49af-b195-9fa4e0496d4a	9d69c401-e4ea-4d92-9553-a72797c96520	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-04 22:04:15
35344	9d69c401-e1b2-4af2-ad7c-840a57f2a6c7	9d69c401-e4ea-4d92-9553-a72797c96520	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-04 22:04:15
35345	9d69c401-e352-4c7c-8719-b4fa944353a6	9d69c401-e4ea-4d92-9553-a72797c96520	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":432,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:04:15
35346	9d69c402-9652-45b0-99bd-35ec853bf4b3	9d69c402-ed5e-4054-92a4-0d253cee0b6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-04 22:04:16
35347	9d69c402-e445-40ce-afa2-4af44c7b18bf	9d69c402-ed5e-4054-92a4-0d253cee0b6b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"166.63","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 22:04:16
35348	9d69c402-eb51-4dea-876c-89365aec9a2d	9d69c402-ed5e-4054-92a4-0d253cee0b6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-04 22:04:16
35349	9d69c402-ebeb-49f3-9340-2b981001ec16	9d69c402-ed5e-4054-92a4-0d253cee0b6b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":576,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:04:16
35350	9d69c403-7a10-4bc6-b3db-bc8f75168de5	9d69c403-d28e-41a7-9fc1-8d1430e298b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-04 22:04:16
35351	9d69c403-c9e2-4e26-8783-643267d916b5	9d69c403-d28e-41a7-9fc1-8d1430e298b2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"165.30","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:04:17
35352	9d69c403-ca79-44df-81ca-49b9bf273ee1	9d69c403-d28e-41a7-9fc1-8d1430e298b2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:04:17
35353	9d69c403-d083-422b-893d-3375b410d58d	9d69c403-d28e-41a7-9fc1-8d1430e298b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-11-04 22:04:17
35354	9d69c403-d10e-413d-ac4b-d69dc4323da3	9d69c403-d28e-41a7-9fc1-8d1430e298b2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":564,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:04:17
37577	9d6b5894-775f-4960-896e-c66eea7bcd14	9d6b5894-9e58-45eb-889c-f1203e109c0b	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 16:55:31
37578	9d6b5894-9c32-4f1c-bb0d-889695819a81	9d6b5894-9e58-45eb-889c-f1203e109c0b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 16:55:31
37579	9d6b5894-9d23-494d-bd21-0d55c6d5b198	9d6b5894-9e58-45eb-889c-f1203e109c0b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":277,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:55:31
37580	9d6b5895-2aa4-450f-8fa7-12b41e70ad2b	9d6b5895-4b40-4cbd-999f-e33926fb77e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 16:55:32
37581	9d6b5895-4507-4226-b3c8-59f5b5ab3e76	9d6b5895-4b40-4cbd-999f-e33926fb77e0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:55:32
37582	9d6b5895-4579-4161-9f66-e7f574e2bc77	9d6b5895-4b40-4cbd-999f-e33926fb77e0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 16:55:32
37583	9d6b5895-49ec-42ed-aba8-56fd86a38f83	9d6b5895-4b40-4cbd-999f-e33926fb77e0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 16:55:32
37584	9d6b5895-4a4a-425f-95bd-47f73fdf13fa	9d6b5895-4b40-4cbd-999f-e33926fb77e0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":308,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:55:32
37585	9d6b5895-9347-4249-9e87-44cebd753b39	9d6b5895-b2ff-474c-9322-e0d898c0fded	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 16:55:32
37586	9d6b5895-ade2-49f6-86a8-1d203e157d5e	9d6b5895-b2ff-474c-9322-e0d898c0fded	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-05 16:55:32
37587	9d6b5895-ae30-45ed-8501-eedea4e961e4	9d6b5895-b2ff-474c-9322-e0d898c0fded	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-05 16:55:32
37588	9d6b5895-b1de-4bff-94f8-874f2b2a1107	9d6b5895-b2ff-474c-9322-e0d898c0fded	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 16:55:32
37589	9d6b5895-b225-47fe-aa2c-36cb7ed4f006	9d6b5895-b2ff-474c-9322-e0d898c0fded	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:55:32
37590	9d6b5895-f7ad-4780-817d-f4fb96b0646d	9d6b5896-1509-45dd-92be-e8ffa77a5525	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 16:55:32
37591	9d6b5896-1001-4870-a9c5-501fae05d976	9d6b5896-1509-45dd-92be-e8ffa77a5525	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.39","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 16:55:32
37592	9d6b5896-106a-4571-95ea-c3556ae93424	9d6b5896-1509-45dd-92be-e8ffa77a5525	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-05 16:55:32
37593	9d6b5896-13e6-40a2-a96b-cfeba0dd518e	9d6b5896-1509-45dd-92be-e8ffa77a5525	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 16:55:32
37594	9d6b5896-142c-4c09-b9fb-fa8a34b16f91	9d6b5896-1509-45dd-92be-e8ffa77a5525	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:55:32
37595	9d6b5896-5e1d-4d56-949e-3b5fae56c672	9d6b5896-7e8d-45cf-8010-2586689a7a6e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 16:55:33
37596	9d6b5896-777c-4604-a4b5-4afc6ad80262	9d6b5896-7e8d-45cf-8010-2586689a7a6e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"loans_nombre\\", \\"loans_apellido_uno\\", \\"loans_apellido_dos\\", \\"loans_tipo_documento\\", \\"loans_documento\\", \\"loans_fecha_nacimiento\\", \\"loans_ciudad\\", \\"loans_barrio\\", \\"loans_direccion\\", \\"loans_intereses\\", \\"loans_cuotas\\", \\"loans_valor_prestado\\", \\"loans_cuando\\", \\"loans_observacion\\", \\"loans_fecha\\", \\"loans_estado\\", \\"loans_celular\\", \\"user_creador\\", \\"user_cobrador\\", \\"user_customer\\", \\"user_recomendacion\\" from \\"loans\\" where \\"id\\" = '93' order by \\"id\\" asc, \\"loans\\".\\"id\\" desc limit 1","time":"45.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":229,"hash":"f00e27e21a94f93c5c7a1d0cd56f9f13","hostname":"EderCortes"}	2024-11-05 16:55:33
37597	9d6b5896-77f1-470f-9cb2-ec6e6032b3d9	9d6b5896-7e8d-45cf-8010-2586689a7a6e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Loans","count":1,"hostname":"EderCortes"}	2024-11-05 16:55:33
37598	9d6b5896-79a4-4dc9-a2e5-d9b0c57d9787	9d6b5896-7e8d-45cf-8010-2586689a7a6e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"item_loans\\" where \\"loans_codigo\\" = '93' order by \\"item_loans\\".\\"id\\" asc","time":"1.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":230,"hash":"b240d68254f804851f4934b642c5bcd7","hostname":"EderCortes"}	2024-11-05 16:55:33
37599	9d6b5896-79d7-4fe7-a5cb-369e654b97a8	9d6b5896-7e8d-45cf-8010-2586689a7a6e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\ItemLoans","count":6,"hostname":"EderCortes"}	2024-11-05 16:55:33
37600	9d6b5896-7d2e-46cb-bd2e-5a9c5e66b8cb	9d6b5896-7e8d-45cf-8010-2586689a7a6e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 16:55:33
37601	9d6b5896-7d7e-4bfe-8064-fb2e4b8e5c59	9d6b5896-7e8d-45cf-8010-2586689a7a6e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-loader\\/93","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@edit","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"result":{"data":{"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_apellido_dos":"ds","loans_tipo_documento":"CC","loans_documento":1004655468,"loans_fecha_nacimiento":"1992-11-12T04:00:00.000Z","loans_ciudad":"Cali","loans_barrio":"Bonilla aragon2","loans_direccion":"Calle 7505","loans_intereses":25,"loans_cuotas":5,"loans_valor_prestado":1000000,"loans_cuando":"S","loans_observacion":null,"loans_fecha":"04-11-2024","loans_estado":"Cancelado","loans_celular":312596295,"user_creador":22,"user_cobrador":22,"user_customer":19,"user_recomendacion":18},"items":[{"id":394,"loans_codigo":93,"itemloans_cuota":"1","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Pagada","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:19:45.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"50000","itemloans_cuota_cancelada":"200000"},{"id":395,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"200000","itemloans_iteres":"50000","itemloans_status":"Abono","itemloass_observacion":"N\\/A","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:17:55.000000Z","updated_at":"2024-11-04T22:22:30.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"100000","itemloans_cuota_cancelada":"400000"},{"id":399,"loans_codigo":93,"itemloans_cuota":"2","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-12 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":400,"loans_codigo":93,"itemloans_cuota":"3","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-20 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":401,"loans_codigo":93,"itemloans_cuota":"4","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-11-28 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"},{"id":402,"loans_codigo":93,"itemloans_cuota":"5","itemloans_valor_cuota":"100000","itemloans_iteres":"25000","itemloans_status":"Pagada","itemloass_observacion":"Se realiza abono","itemloans_fecha_pago":"2024-12-06 00:00:00","itemloans_aprobador":12,"created_at":"2024-11-04T22:22:30.000000Z","updated_at":"2024-11-04T22:27:01.000000Z","deleted_at":null,"item_loans_cuando_pago":"2024-11-04 00:00:00","itemloans_interes_canelado":"25000","itemloans_cuota_cancelada":"100000"}]}},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:55:33
35511	9d69c4e2-9629-4eb7-995f-c025d307516b	9d69c4e2-cb86-4bf6-954c-8af1ceaa874b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 22:06:43
35512	9d69c4e2-c871-40a5-b623-f82daf99a0c0	9d69c4e2-cb86-4bf6-954c-8af1ceaa874b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 22:06:43
35513	9d69c4e2-c9f5-4256-9aca-021ab234caef	9d69c4e2-cb86-4bf6-954c-8af1ceaa874b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":446,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:06:43
35514	9d69c4e3-68bf-41ac-9a84-faf0944857ae	9d69c4e3-bbf8-407c-81ce-333af13ee54f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-04 22:06:43
35515	9d69c4e3-b45c-465a-9fb0-15437f90e7e0	9d69c4e3-bbf8-407c-81ce-333af13ee54f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"164.79","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 22:06:43
35516	9d69c4e3-ba18-4fa0-b6ec-bc911a74aa12	9d69c4e3-bbf8-407c-81ce-333af13ee54f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 22:06:43
35517	9d69c4e3-baaa-407c-8384-69ab00320415	9d69c4e3-bbf8-407c-81ce-333af13ee54f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":521,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:06:43
37602	9d6b5898-deda-483e-9dbb-5e025f50c2c8	9d6b5898-fd46-408f-a4c4-dc6bc26cec8b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 16:55:34
37603	9d6b5898-f77a-4b7b-aa90-dc2fdddfe80b	9d6b5898-fd46-408f-a4c4-dc6bc26cec8b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 16:55:34
37604	9d6b5898-f7d1-4f5d-a9fc-c167b1575318	9d6b5898-fd46-408f-a4c4-dc6bc26cec8b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 16:55:34
37605	9d6b5898-fba1-48a4-90ca-2159ddbe939f	9d6b5898-fd46-408f-a4c4-dc6bc26cec8b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 16:55:34
37606	9d6b5898-fbff-422a-b92a-b1dd395073ea	9d6b5898-fd46-408f-a4c4-dc6bc26cec8b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":315,"memory":22,"hostname":"EderCortes"}	2024-11-05 16:55:34
35518	9d69c4e4-6f90-40cf-af84-cf10483d054d	9d69c4e4-a24e-4993-9d6c-74d03c39aa5f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-04 22:06:44
35519	9d69c4e4-9565-40e6-9daf-81f231c629ae	9d69c4e4-a24e-4993-9d6c-74d03c39aa5f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"58.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:06:44
35520	9d69c4e4-95ee-4d7a-ae12-6419a0fcdfdf	9d69c4e4-a24e-4993-9d6c-74d03c39aa5f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:06:44
35521	9d69c4e4-a038-4643-a56f-a8a276d001ac	9d69c4e4-a24e-4993-9d6c-74d03c39aa5f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 22:06:44
35522	9d69c4e4-a0ba-4975-9ee1-5ceb9fe2727e	9d69c4e4-a24e-4993-9d6c-74d03c39aa5f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":552,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:06:44
35523	9d69c4e5-aab9-4ec7-a622-cc399dab6aec	9d69c4e5-e947-4991-b629-1a9c67a4275d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 22:06:45
35524	9d69c4e5-e0dd-4c22-bf8d-05393f8d978c	9d69c4e5-e947-4991-b629-1a9c67a4275d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"59.06","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:06:45
35525	9d69c4e5-e175-4d73-a210-ed8e314d4c9f	9d69c4e5-e947-4991-b629-1a9c67a4275d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:06:45
35526	9d69c4e5-e71f-4339-9cdb-bb507b976b2e	9d69c4e5-e947-4991-b629-1a9c67a4275d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 22:06:45
35527	9d69c4e5-e7a1-46f9-b644-8d42815066c6	9d69c4e5-e947-4991-b629-1a9c67a4275d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":815,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:06:45
35528	9d69c4e6-a400-4896-b74a-c1ca708ef776	9d69c4e6-db7d-4048-afd9-0f5d14fe32fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 22:06:45
35529	9d69c4e6-d0d0-45c3-b67f-292fc81f968c	9d69c4e6-db7d-4048-afd9-0f5d14fe32fb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"62.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:06:45
35530	9d69c4e6-d15c-43f2-97a6-110827a2d575	9d69c4e6-db7d-4048-afd9-0f5d14fe32fb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:06:45
35531	9d69c4e6-d940-4ade-81ac-03b938e9e679	9d69c4e6-db7d-4048-afd9-0f5d14fe32fb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 22:06:45
35532	9d69c4e6-d9da-440c-af3a-bdca577a804a	9d69c4e6-db7d-4048-afd9-0f5d14fe32fb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":598,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:06:45
40402	9d6cc30c-fbbb-4586-991d-37b6f6e0826b	9d6cc30d-15ca-4a4a-a3ec-e904f6318a34	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:49:04
40403	9d6cc30d-144d-4d42-a635-cb3dc4ee2171	9d6cc30d-15ca-4a4a-a3ec-e904f6318a34	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:49:04
40404	9d6cc30d-14df-48c6-80c5-2ab87e9a11f9	9d6cc30d-15ca-4a4a-a3ec-e904f6318a34	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:49:04
40405	9d6cc30e-2c2d-4a02-8c18-56b83dd1d4f3	9d6cc30e-4998-492f-8cfb-5e028fb453b8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:49:05
40406	9d6cc30e-43e4-4cbf-acda-581f16a4b782	9d6cc30e-4998-492f-8cfb-5e028fb453b8	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.74","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:49:05
40407	9d6cc30e-443a-47c5-8a39-069e35bbb5d3	9d6cc30e-4998-492f-8cfb-5e028fb453b8	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:49:05
40408	9d6cc30e-4851-4686-9258-a587f4fca96e	9d6cc30e-4998-492f-8cfb-5e028fb453b8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:49:05
40409	9d6cc30e-48a1-4a74-b6bf-b324e7550b61	9d6cc30e-4998-492f-8cfb-5e028fb453b8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:49:05
40410	9d6cc30e-8b26-4fc4-81bf-0ed15ae51246	9d6cc30e-cd24-4c8a-ae8b-259216a3f2f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:49:05
40411	9d6cc30e-c8bd-4070-b4d0-2b86ad34b585	9d6cc30e-cd24-4c8a-ae8b-259216a3f2f2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"143.77","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:49:05
40412	9d6cc30e-cbdd-4f77-960d-8b00cce8a654	9d6cc30e-cd24-4c8a-ae8b-259216a3f2f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:49:05
40413	9d6cc30e-cc26-472b-904a-162415280a0f	9d6cc30e-cd24-4c8a-ae8b-259216a3f2f2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":323,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:49:05
41897	9d6cd0f8-2f10-441d-abef-112c15f0a566	9d6cd0f8-58f2-4dd2-a21f-88287425a94f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:27:59
41898	9d6cd0f8-56a0-44a8-861d-dd09df09e23d	9d6cd0f8-58f2-4dd2-a21f-88287425a94f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:27:59
41899	9d6cd0f8-577c-4f39-bbe2-f5641dd6b28e	9d6cd0f8-58f2-4dd2-a21f-88287425a94f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:27:59
41590	9d6ccdc2-9796-4c32-a18a-40fb1748ce93	9d6ccdc2-ee38-4a59-9a19-0d7314a512cb	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:19:01
41591	9d6ccdc2-ebc6-4647-8fe2-553df5cd70ec	9d6ccdc2-ee38-4a59-9a19-0d7314a512cb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:19:01
41592	9d6ccdc2-ed12-4166-b7d1-f4f05b94e2ab	9d6ccdc2-ee38-4a59-9a19-0d7314a512cb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":470,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:19:01
30119	9d693449-49d1-46f0-b639-8c216a62a20e	9d693449-4ee1-44a8-bb23-fcfb0598b731	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1433}	2024-11-04 15:22:23
15229	9d5ecf4f-0519-4a4e-bbfb-bda49c723225	9d5ecf4f-0a15-4ee3-b3f7-ce71bcafa94c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":689}	2024-10-30 11:21:45
41658	9d6cce78-41b5-46fb-bb24-0e26d7eff4a3	9d6cce78-8a33-480c-a732-48e81e06cc85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:21:00
41659	9d6cce78-8871-473d-95b5-4a94233cef72	9d6cce78-8a33-480c-a732-48e81e06cc85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 10:21:00
41660	9d6cce78-890e-48c9-b688-7440042e1be7	9d6cce78-8a33-480c-a732-48e81e06cc85	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":362,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:21:00
41657	9d6cce78-872f-468e-b8a5-6de4d177a568	9d6cce78-8a33-480c-a732-48e81e06cc85	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1913}	2024-11-06 10:21:00
41726	9d6ccefe-e0d6-41b8-9e30-128f7b418800	9d6cceff-0451-4a81-ba97-1e210b4b147c	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:22:28
41727	9d6cceff-0263-4558-9d43-e67e56a29923	9d6cceff-0451-4a81-ba97-1e210b4b147c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:22:28
41728	9d6cceff-0318-42ad-a732-510f41410dd0	9d6cceff-0451-4a81-ba97-1e210b4b147c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:22:28
41092	9d6ccb45-f91b-42e4-84a6-78be36552dab	9d6ccb45-fc1a-4b01-b43d-8d01bd1b972d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1880}	2024-11-06 10:12:03
41836	9d6ccfec-cdfb-4388-ac7e-1e78cfa1fe0a	9d6ccfec-e99b-4662-9a21-6c3838d119c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:25:04
41837	9d6ccfec-e803-4e46-9f59-3bd3e4c2fc43	9d6ccfec-e99b-4662-9a21-6c3838d119c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 10:25:04
41838	9d6ccfec-e8a0-4015-99b9-1d7747ea0d8f	9d6ccfec-e99b-4662-9a21-6c3838d119c4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":225,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:25:04
41785	9d6ccf68-3bd2-42bb-b340-fe4da8172ca1	9d6ccf68-806a-477e-b63e-1e07e57070d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:23:37
41786	9d6ccf68-7edb-4270-bbbb-86483b96308a	9d6ccf68-806a-477e-b63e-1e07e57070d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:23:37
41787	9d6ccf68-7f84-4efb-a857-9fb54f80cf15	9d6ccf68-806a-477e-b63e-1e07e57070d9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":331,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:23:37
7491	9d52df51-555e-4502-8c89-dd4efe9502a9	9d52df51-5965-4feb-a5ff-3593e70b0c5d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":374}	2024-10-24 12:56:35
41818	9d6ccfcd-07f5-482a-b0ad-900a8ebf849c	9d6ccfcd-0adf-4483-9f22-9edb21a4781e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1933}	2024-11-06 10:24:43
37866	9d6b5d64-37ff-4bf2-bb60-35c367daea25	9d6b5d64-5eb2-4b1d-870f-119bcbc8ac90	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 17:08:59
37867	9d6b5d64-5c80-451a-b2a6-bfc7e2b274cf	9d6b5d64-5eb2-4b1d-870f-119bcbc8ac90	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:08:59
37868	9d6b5d64-5d6b-4f03-a063-d122c0afe942	9d6b5d64-5eb2-4b1d-870f-119bcbc8ac90	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":324,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:08:59
37869	9d6b5d64-fc54-421c-90ed-6f6b81ad80c6	9d6b5d65-1aaf-4e43-965c-c1017fe77d35	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:08:59
37870	9d6b5d65-1536-4226-8415-862f3e54b27d	9d6b5d65-1aaf-4e43-965c-c1017fe77d35	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"45.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:08:59
37871	9d6b5d65-1917-4caa-a58f-11a3b8143795	9d6b5d65-1aaf-4e43-965c-c1017fe77d35	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:08:59
37872	9d6b5d65-1992-4eb3-a9b3-7623286d9dc9	9d6b5d65-1aaf-4e43-965c-c1017fe77d35	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":322,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:08:59
42024	9d6cd3a9-0abe-4ee7-81f3-e532c2d44c46	9d6cd3a9-595f-4a5c-95ed-c58955795ed8	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:35:31
40483	9d6cc3d1-6da7-4819-884f-5623f88411aa	9d6cc3d1-8eef-48b7-a1ca-ccf6b0f996ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 09:51:13
40484	9d6cc3d1-8d35-4882-ad6b-a6d983259a19	9d6cc3d1-8eef-48b7-a1ca-ccf6b0f996ae	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 09:51:13
40485	9d6cc3d1-8df3-4cb4-aa5c-e3ace182cde4	9d6cc3d1-8eef-48b7-a1ca-ccf6b0f996ae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":268,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:51:13
42025	9d6cd3a9-575c-4bc0-8ead-f5d702430430	9d6cd3a9-595f-4a5c-95ed-c58955795ed8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:35:31
42026	9d6cd3a9-582e-4263-adf8-93ac4d260a56	9d6cd3a9-595f-4a5c-95ed-c58955795ed8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":407,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:35:31
18478	9d66924c-dc58-4cf5-b0a7-76d1363611b3	9d66924c-df46-406a-b581-66ce1e3eb8d8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":884}	2024-11-03 07:57:47
37873	9d6b5d65-7006-4e17-9763-2fa5cd5f09cf	9d6b5d65-907b-41bf-862f-6529b8d46bf0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:08:59
37874	9d6b5d65-8a77-42d2-a5ff-f4dcf71c2fdd	9d6b5d65-907b-41bf-862f-6529b8d46bf0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:08:59
37875	9d6b5d65-8ad4-4e38-8dfa-de293db68dd9	9d6b5d65-907b-41bf-862f-6529b8d46bf0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:08:59
37876	9d6b5d65-8f0b-45cc-8a91-0fe9da2edd61	9d6b5d65-907b-41bf-862f-6529b8d46bf0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:08:59
37877	9d6b5d65-8f60-417c-9e34-ae216cfa673a	9d6b5d65-907b-41bf-862f-6529b8d46bf0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":286,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:08:59
37878	9d6b5d65-da72-41c1-8480-6a0f049150ad	9d6b5d65-f980-401d-9b0e-6030f14f0259	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 17:09:00
37879	9d6b5d65-f432-4dbf-b948-f1f5cc45035b	9d6b5d65-f980-401d-9b0e-6030f14f0259	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:09:00
37880	9d6b5d65-f47b-4755-b0f1-7b959357a566	9d6b5d65-f980-401d-9b0e-6030f14f0259	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:09:00
37881	9d6b5d65-f841-47aa-9bbe-c01197687328	9d6b5d65-f980-401d-9b0e-6030f14f0259	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:09:00
37882	9d6b5d65-f887-48d7-9930-3d25277b6ef3	9d6b5d65-f980-401d-9b0e-6030f14f0259	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":248,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:09:00
37883	9d6b5d67-bb79-418c-8602-2fda0c9bd388	9d6b5d67-d943-4c02-a0e5-943fd3f17253	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 17:09:01
37884	9d6b5d67-d3ba-4a3b-b382-01f9a7f684c4	9d6b5d67-d943-4c02-a0e5-943fd3f17253	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:09:01
37885	9d6b5d67-d40e-4349-88e4-d33e7efa2e75	9d6b5d67-d943-4c02-a0e5-943fd3f17253	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:09:01
37886	9d6b5d67-d7c5-4401-a496-c73f49335e01	9d6b5d67-d943-4c02-a0e5-943fd3f17253	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:09:01
37887	9d6b5d67-d824-49b2-8b8b-f618f1ad6257	9d6b5d67-d943-4c02-a0e5-943fd3f17253	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":298,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:09:01
40384	9d6cc2fb-3754-4644-8603-a70dd0c57307	9d6cc2fb-3a4b-4ba7-9052-86e88a6f6854	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1806}	2024-11-06 09:48:52
35998	9d69c8a0-3523-4f8d-8210-8e91100ae221	9d69c8a0-6b9d-426a-8ab1-09df6d3c9637	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 22:17:10
35999	9d69c8a0-68c6-4239-a92f-c5286d852cf6	9d69c8a0-6b9d-426a-8ab1-09df6d3c9637	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 22:17:10
36000	9d69c8a0-6a2f-4a85-9fe0-72100a4876c5	9d69c8a0-6b9d-426a-8ab1-09df6d3c9637	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":387,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:17:10
36001	9d69c8a1-10aa-439f-ad1a-8cb51c4dc8e2	9d69c8a1-3bab-4fd4-bf4b-9c9256242706	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 22:17:11
36002	9d69c8a1-342a-4c24-97e6-45e3d2b2063c	9d69c8a1-3bab-4fd4-bf4b-9c9256242706	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"62.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 22:17:11
36003	9d69c8a1-395e-472c-992e-a139aa443450	9d69c8a1-3bab-4fd4-bf4b-9c9256242706	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 22:17:11
36004	9d69c8a1-3a09-45ff-a031-f7f8503bcf0a	9d69c8a1-3bab-4fd4-bf4b-9c9256242706	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":435,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:17:11
36005	9d69c8a1-b813-4a02-b7cc-ad7323b0510b	9d69c8a1-e6f6-44df-a94b-eddd18fd6b9b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 22:17:11
36006	9d69c8a1-df1f-4d55-bc5f-f61dac7c4b49	9d69c8a1-e6f6-44df-a94b-eddd18fd6b9b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"61.16","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:17:11
36007	9d69c8a1-dfb7-455b-96fd-f0e01de19af5	9d69c8a1-e6f6-44df-a94b-eddd18fd6b9b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 22:17:11
36008	9d69c8a1-e54f-480a-99aa-94430259e245	9d69c8a1-e6f6-44df-a94b-eddd18fd6b9b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 22:17:11
36009	9d69c8a1-e5c5-4ef7-b5b8-9bc28dec6c3b	9d69c8a1-e6f6-44df-a94b-eddd18fd6b9b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":423,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:17:11
36010	9d69c8a2-4a9b-4c23-8531-e17762d118aa	9d69c8a2-9693-4da3-9f81-5eb710a453cc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 22:17:12
36011	9d69c8a2-905e-4d13-a7d6-9ae89baee42f	9d69c8a2-9693-4da3-9f81-5eb710a453cc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"156.15","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:17:12
36012	9d69c8a2-90c4-45c7-8109-1e08f111e688	9d69c8a2-9693-4da3-9f81-5eb710a453cc	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-04 22:17:12
36013	9d69c8a2-9529-4a68-8524-1df6bd88a8f8	9d69c8a2-9693-4da3-9f81-5eb710a453cc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-04 22:17:12
36014	9d69c8a2-957a-40c6-8397-2142bccf36e9	9d69c8a2-9693-4da3-9f81-5eb710a453cc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":423,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:17:12
36015	9d69c8a3-6679-46ca-b4c7-30d00046379f	9d69c8a3-d8ca-41e5-932e-26d2cce27427	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-04 22:17:12
36016	9d69c8a3-d0e5-4a45-ace7-d1107c4c7a82	9d69c8a3-d8ca-41e5-932e-26d2cce27427	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"122.41","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:17:13
36017	9d69c8a3-d164-4426-ba3c-826cb9330ff3	9d69c8a3-d8ca-41e5-932e-26d2cce27427	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:17:13
36018	9d69c8a3-d6fb-4496-8379-b45437aef52f	9d69c8a3-d8ca-41e5-932e-26d2cce27427	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-04 22:17:13
36019	9d69c8a3-d777-4793-9b5d-c23655f9a83b	9d69c8a3-d8ca-41e5-932e-26d2cce27427	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":802,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:17:13
36020	9d69c8a4-559d-41e1-83bc-18db568ee9ef	9d69c8a4-a12a-4e62-80cc-6fbea86cbff2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-04 22:17:13
36021	9d69c8a4-9ac7-401d-b0a5-87f3e2c89920	9d69c8a4-a12a-4e62-80cc-6fbea86cbff2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"151.40","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:17:13
36022	9d69c8a4-9b1c-495a-a038-c708e71f43c9	9d69c8a4-a12a-4e62-80cc-6fbea86cbff2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:17:13
36023	9d69c8a4-9f85-4df3-a67b-bebe48011fe5	9d69c8a4-a12a-4e62-80cc-6fbea86cbff2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-04 22:17:13
36024	9d69c8a4-9fe7-4769-8b80-f18a9956fc39	9d69c8a4-a12a-4e62-80cc-6fbea86cbff2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":491,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:17:13
8640	9d52ee40-895f-4f31-a252-5ad26250f6d8	9d52ee40-8e16-4b96-8085-4111c668e2e7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":418}	2024-10-24 13:38:20
40568	9d6cc51d-20d6-4982-88f0-14483a476ba2	9d6cc51d-68c4-4c67-b90f-0b1699359139	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 09:54:50
40569	9d6cc51d-6717-4b50-a102-f5c76c9b53fc	9d6cc51d-68c4-4c67-b90f-0b1699359139	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 09:54:50
40570	9d6cc51d-67be-4cf3-bd4c-d5d16161f08c	9d6cc51d-68c4-4c67-b90f-0b1699359139	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":365,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:54:50
15243	9d5ecf51-0cb1-450f-a080-80df8b61ff85	9d5ecf51-122b-4619-8464-6379107b9399	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":690}	2024-10-30 11:21:46
38087	9d6b5f15-88ba-4e5b-811c-a13ecbd0f481	9d6b5f15-d137-4649-a653-8776bc48adf5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 17:13:43
38088	9d6b5f15-cfba-4816-a424-bfdb0575f905	9d6b5f15-d137-4649-a653-8776bc48adf5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 17:13:43
38089	9d6b5f15-d054-4186-bf5f-b7af6792d8aa	9d6b5f15-d137-4649-a653-8776bc48adf5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":373,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:13:43
38090	9d6b5f16-35df-46e5-89b8-0fc542f1e085	9d6b5f16-54f4-4c77-889a-beff5714e9a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 17:13:43
38091	9d6b5f16-4fe2-45f3-b012-dc4f8a1b448a	9d6b5f16-54f4-4c77-889a-beff5714e9a2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"45.84","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:13:43
38092	9d6b5f16-5322-438c-9615-2cb1516baf67	9d6b5f16-54f4-4c77-889a-beff5714e9a2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 17:13:43
38093	9d6b5f16-53af-4709-aa79-140d94291b85	9d6b5f16-54f4-4c77-889a-beff5714e9a2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":260,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:13:43
38094	9d6b5f16-a1e8-41d7-8abf-f6eed6715389	9d6b5f16-ead3-4217-87bd-44ed728c2f04	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 17:13:43
38095	9d6b5f16-e5f9-4737-a349-77834e5b73ff	9d6b5f16-ead3-4217-87bd-44ed728c2f04	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"144.43","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:13:43
38096	9d6b5f16-e653-401d-ae52-4c7aedb2eed8	9d6b5f16-ead3-4217-87bd-44ed728c2f04	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:13:43
38097	9d6b5f16-e98a-4fb0-a58a-0dd75000411f	9d6b5f16-ead3-4217-87bd-44ed728c2f04	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 17:13:43
38098	9d6b5f16-e9cb-4ffd-ac10-375a2a45beb9	9d6b5f16-ead3-4217-87bd-44ed728c2f04	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":374,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:13:43
38099	9d6b5f17-350f-44be-9904-2695336e9789	9d6b5f17-5605-4f70-9d86-832f0fa3fd03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 17:13:44
38100	9d6b5f17-4fe7-4ce5-8ece-0009c187de17	9d6b5f17-5605-4f70-9d86-832f0fa3fd03	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:13:44
38101	9d6b5f17-5038-4be2-bca4-e5941392fa3a	9d6b5f17-5605-4f70-9d86-832f0fa3fd03	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:13:44
38102	9d6b5f17-54a6-45ce-8705-7034910923bc	9d6b5f17-5605-4f70-9d86-832f0fa3fd03	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 17:13:44
38103	9d6b5f17-5500-4c6c-afc6-16f9e8e365cb	9d6b5f17-5605-4f70-9d86-832f0fa3fd03	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:13:44
38104	9d6b5f18-c328-4f60-b462-3930c19ef029	9d6b5f19-0107-422e-aacd-1f4cdd490f83	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 17:13:45
38105	9d6b5f18-f809-423e-bd72-f9847c6eb59c	9d6b5f19-0107-422e-aacd-1f4cdd490f83	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"86.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:13:45
38106	9d6b5f18-f8a3-49d6-8ba2-408a56b1816e	9d6b5f19-0107-422e-aacd-1f4cdd490f83	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:13:45
38107	9d6b5f18-ff38-474b-8ab5-5e372056d782	9d6b5f19-0107-422e-aacd-1f4cdd490f83	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 17:13:45
38108	9d6b5f18-ffb2-4b3d-bfb4-792c22fe04b8	9d6b5f19-0107-422e-aacd-1f4cdd490f83	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":545,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:13:45
40724	9d6cc6c8-db6e-450f-9190-dc3b96edb045	9d6cc6c8-de62-433b-b923-e0501cccefb2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1846}	2024-11-06 09:59:30
40674	9d6cc66a-4270-4648-820d-4ba9b361d3f9	9d6cc66a-842d-44a6-b321-97aeb5847696	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 09:58:28
40675	9d6cc66a-82ad-48d4-b21c-54314a76bdb9	9d6cc66a-842d-44a6-b321-97aeb5847696	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 09:58:28
40676	9d6cc66a-833f-4e10-9b12-fd52fda0e0f3	9d6cc66a-842d-44a6-b321-97aeb5847696	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":323,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:58:28
30367	9d693c43-2f92-4f5c-8061-570ce27247d0	9d693c43-3346-4c55-81e6-cffea3dfc265	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1446}	2024-11-04 15:44:41
40677	9d6cc66b-8c89-4d5f-aa50-90f4424a1220	9d6cc66b-b5ac-498e-8b7d-f9418bd1ee21	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 09:58:29
40678	9d6cc66b-ad32-4ae6-a091-46cab4e18eda	9d6cc66b-b5ac-498e-8b7d-f9418bd1ee21	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"51.24","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:58:29
40679	9d6cc66b-adbc-4abb-ba4e-7aee2aa04d4b	9d6cc66b-b5ac-498e-8b7d-f9418bd1ee21	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:58:29
40680	9d6cc66b-b3c3-4e47-b590-1e38ad788b65	9d6cc66b-b5ac-498e-8b7d-f9418bd1ee21	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 09:58:29
40681	9d6cc66b-b44f-4908-95ad-467d6c3c2e8f	9d6cc66b-b5ac-498e-8b7d-f9418bd1ee21	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":404,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:58:29
41128	9d6ccba8-a39f-4a64-9fe8-74e3026f64e7	9d6ccba8-a93e-4a89-bcde-725db92b48bb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1882}	2024-11-06 10:13:08
40682	9d6cc66c-1061-440d-8bce-8375803c8b2a	9d6cc66c-582a-4e33-aba0-d7e4648e768a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 09:58:30
40683	9d6cc66c-50fa-40bc-83c6-f387367577e9	9d6cc66c-582a-4e33-aba0-d7e4648e768a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"151.20","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:58:30
40684	9d6cc66c-565c-4430-8e0b-a89f70eae33b	9d6cc66c-582a-4e33-aba0-d7e4648e768a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 09:58:30
40685	9d6cc66c-56dc-4f01-b2d5-9cddb85d432e	9d6cc66c-582a-4e33-aba0-d7e4648e768a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":397,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:58:30
38243	9d6b6071-a2b7-421e-be8e-4539dc5f8a55	9d6b6071-c968-47b6-91ae-b0209d2c3dbd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:17:31
38244	9d6b6071-c6e3-4222-b03c-66baf2737490	9d6b6071-c968-47b6-91ae-b0209d2c3dbd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:17:31
38245	9d6b6071-c7e2-48d5-ba0c-0eaad81ca0c7	9d6b6071-c968-47b6-91ae-b0209d2c3dbd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":277,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:17:31
38246	9d6b6072-3449-4aed-9c94-b66632149dc9	9d6b6072-51a6-4f5e-b6c7-f2c4454a8298	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:17:31
38247	9d6b6072-4ccb-4f16-9199-e15608ab8dee	9d6b6072-51a6-4f5e-b6c7-f2c4454a8298	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"44.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:17:31
38248	9d6b6072-5024-4904-9d46-6df7cc0803bb	9d6b6072-51a6-4f5e-b6c7-f2c4454a8298	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 17:17:31
38249	9d6b6072-508f-4f3d-80e6-bb3b46569cc2	9d6b6072-51a6-4f5e-b6c7-f2c4454a8298	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:17:31
38250	9d6b6072-a290-41ce-9cae-dc980d8c54b9	9d6b6072-ee97-436a-9bdd-58ded8942f20	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 17:17:31
38251	9d6b6072-e8ea-4d92-a906-bdb2501eadfb	9d6b6072-ee97-436a-9bdd-58ded8942f20	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"154.61","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:17:32
38252	9d6b6072-e956-46b3-b75e-06419a3dedf8	9d6b6072-ee97-436a-9bdd-58ded8942f20	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:17:32
38253	9d6b6072-ed6d-4e3e-b7df-ba7a9b16a32d	9d6b6072-ee97-436a-9bdd-58ded8942f20	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 17:17:32
38254	9d6b6072-edb6-4de9-9757-844a41fa5a06	9d6b6072-ee97-436a-9bdd-58ded8942f20	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":392,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:17:32
38255	9d6b6073-33ed-47c6-81d4-88e02f26cd94	9d6b6073-5109-4343-af57-eeffb9ad8f63	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 17:17:32
38256	9d6b6073-4bb4-49ea-a400-dc3245ed16ba	9d6b6073-5109-4343-af57-eeffb9ad8f63	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.71","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:17:32
38257	9d6b6073-4c07-41eb-b65c-89ff2d689464	9d6b6073-5109-4343-af57-eeffb9ad8f63	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:17:32
38258	9d6b6073-4fbe-4cf9-afa9-d8737532c37d	9d6b6073-5109-4343-af57-eeffb9ad8f63	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 17:17:32
38259	9d6b6073-5001-4f6e-82f2-102d62115f8f	9d6b6073-5109-4343-af57-eeffb9ad8f63	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:17:32
38260	9d6b6074-f4bf-41ef-9cf0-9c31de85d37b	9d6b6075-1518-4506-8a1d-3f53125859a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 17:17:33
38261	9d6b6075-0eca-4aea-a96e-934d78483dd1	9d6b6075-1518-4506-8a1d-3f53125859a6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:17:33
38262	9d6b6075-0f2a-40a4-b33d-73a24da0adb1	9d6b6075-1518-4506-8a1d-3f53125859a6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:17:33
38263	9d6b6075-137f-428d-baa3-0af387bda17b	9d6b6075-1518-4506-8a1d-3f53125859a6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 17:17:33
38264	9d6b6075-13c6-4f53-a197-ad735ecb18c7	9d6b6075-1518-4506-8a1d-3f53125859a6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":292,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:17:33
40789	9d6cc795-f5f8-4800-8984-338fb937f8a0	9d6cc796-17f2-44a7-a633-ccf0f8ed0081	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:01:45
40790	9d6cc796-15f6-4248-aa80-5b18adaa25d4	9d6cc796-17f2-44a7-a633-ccf0f8ed0081	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:01:45
40791	9d6cc796-1695-45c8-a6ee-26930765dfc5	9d6cc796-17f2-44a7-a633-ccf0f8ed0081	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":266,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:01:45
38404	9d6b648a-b113-407f-b6f5-03f7beedacf0	9d6b648a-d00d-4368-a886-ae72cf83108c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:28:58
38405	9d6b648a-ce7d-408e-915e-675f96302029	9d6b648a-d00d-4368-a886-ae72cf83108c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:28:58
38406	9d6b648a-cf25-4cac-b8b4-a5ee1f41812c	9d6b648a-d00d-4368-a886-ae72cf83108c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:28:58
38407	9d6b648b-2eea-4a94-8d5f-d148420b97c9	9d6b648b-75ee-48bc-a660-d392f920481b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:28:59
38408	9d6b648b-70f2-4d1e-81fd-0d8da7721605	9d6b648b-75ee-48bc-a660-d392f920481b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"152.94","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:28:59
38409	9d6b648b-744a-4302-a6d8-d9a6b50d1d1c	9d6b648b-75ee-48bc-a660-d392f920481b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 17:28:59
38410	9d6b648b-74dc-4f7f-9dfb-e2aa3fe7446e	9d6b648b-75ee-48bc-a660-d392f920481b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:28:59
38411	9d6b648b-c1fa-4894-8b3b-df7cf4e75af2	9d6b648c-0761-40fd-a3e8-25bc92efe231	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 17:28:59
38412	9d6b648c-022e-4b90-a4d8-528ee66cbafc	9d6b648c-0761-40fd-a3e8-25bc92efe231	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"141.10","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:28:59
38413	9d6b648c-027c-4d95-9863-579be6ea8b18	9d6b648c-0761-40fd-a3e8-25bc92efe231	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:28:59
38414	9d6b648c-061f-4d30-b1fe-0f83ce61beef	9d6b648c-0761-40fd-a3e8-25bc92efe231	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 17:28:59
38415	9d6b648c-0660-40fa-8722-6532dd70cb82	9d6b648c-0761-40fd-a3e8-25bc92efe231	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:28:59
38416	9d6b648c-4f40-4a41-9035-418b4ff0499c	9d6b648c-6ede-456e-aa2d-a9454ebc5c87	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 17:28:59
38417	9d6b648c-6967-43e1-91e9-615b545b4efe	9d6b648c-6ede-456e-aa2d-a9454ebc5c87	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.81","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:28:59
38418	9d6b648c-69b3-4772-82a9-3904e5aa47fa	9d6b648c-6ede-456e-aa2d-a9454ebc5c87	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:28:59
38419	9d6b648c-6d7d-4b06-92a9-c9ccf3ffde84	9d6b648c-6ede-456e-aa2d-a9454ebc5c87	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 17:28:59
38420	9d6b648c-6dc0-4b1d-854a-db8399b67130	9d6b648c-6ede-456e-aa2d-a9454ebc5c87	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:28:59
38421	9d6b648e-110e-4ac5-a965-b22501d38d15	9d6b648e-32a3-473b-93bc-2b9c4f3a5162	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 17:29:00
38422	9d6b648e-2c90-4c3a-bddf-48331caf7e78	9d6b648e-32a3-473b-93bc-2b9c4f3a5162	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:29:01
38423	9d6b648e-2cd9-4d75-85d2-c185473ec834	9d6b648e-32a3-473b-93bc-2b9c4f3a5162	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:29:01
38424	9d6b648e-3123-479a-97bc-957a06df93c8	9d6b648e-32a3-473b-93bc-2b9c4f3a5162	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 17:29:01
38425	9d6b648e-3173-4050-b1f2-6d7904e976d3	9d6b648e-32a3-473b-93bc-2b9c4f3a5162	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":579,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:29:01
40925	9d6cc8b5-4b90-4dad-a9a1-1f523120a1e5	9d6cc8b5-7cc9-4e7a-a7fc-a0cecd3c907f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:04:53
40926	9d6cc8b5-7a7b-4d36-b823-c78d1f31749f	9d6cc8b5-7cc9-4e7a-a7fc-a0cecd3c907f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:04:53
40927	9d6cc8b5-7ba0-4301-8bae-8fab68fdd129	9d6cc8b5-7cc9-4e7a-a7fc-a0cecd3c907f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":299,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:04:53
42937	9d6ce181-3cad-43c3-92aa-ce52d1ee156c	9d6ce181-598f-4282-a80a-ae8a0b757d91	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:14:13
42938	9d6ce181-5801-485b-950f-08d5e7a8be7a	9d6ce181-598f-4282-a80a-ae8a0b757d91	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:14:13
42939	9d6ce181-589a-44d9-844c-311d59ff6be6	9d6ce181-598f-4282-a80a-ae8a0b757d91	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":221,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:14:13
43054	9d6ce3c2-94f9-485c-bc3c-c45beec2cded	9d6ce3c2-e38a-49bf-be1f-2b01976314c1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 11:20:32
43055	9d6ce3c2-e12d-4f16-8dbb-63aed0ebcd1e	9d6ce3c2-e38a-49bf-be1f-2b01976314c1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 11:20:32
42633	9d6cdf6f-7eb5-4403-8ea1-0c86a360c513	9d6cdf6f-a8c1-44c4-bfff-c8e02d16bed6	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 11:08:26
42634	9d6cdf6f-a68c-4ed8-9885-1e003542b216	9d6cdf6f-a8c1-44c4-bfff-c8e02d16bed6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:08:26
42635	9d6cdf6f-a76e-4524-9e76-925a87b7a189	9d6cdf6f-a8c1-44c4-bfff-c8e02d16bed6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":295,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:08:26
43056	9d6ce3c2-e245-4cc4-b134-d049c10a806d	9d6ce3c2-e38a-49bf-be1f-2b01976314c1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":416,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:20:32
43103	9d6ce4c2-7cfb-4a53-8902-4d7b8c43bad5	9d6ce4c2-9b3f-49a3-8187-a30dada48809	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:23:19
43104	9d6ce4c2-9977-49e1-b8be-e9f376982262	9d6ce4c2-9b3f-49a3-8187-a30dada48809	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:23:19
43105	9d6ce4c2-9a38-4fcb-a49f-e747e638a27c	9d6ce4c2-9b3f-49a3-8187-a30dada48809	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/showCobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@showCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abFROM\\u00bb\\nLINE 19:                         FROM users\\n                                 ^ (Connection: pgsql, SQL: \\n                     SELECT id,\\n                            name,\\n                            profile_code,\\n                            profile_name,\\n                            profile_prefix,\\n                            remember_token,\\n                            user_address,\\n                            user_age,\\n                            user_alias,\\n                            user_birth,\\n                            user_cellphone,\\n                            user_city,\\n                            user_document,\\n                            user_document_type,\\n                            user_last_name_one,\\n                            user_last_name_two,\\n                            user_neighborhood,\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 4;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":142,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"showCobrador","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":257,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:23:19
43106	9d6ce4c4-f04f-490a-949c-999673632b6c	9d6ce4c5-0e9b-45e7-ac02-8404e1f4beb6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:23:21
43107	9d6ce4c5-07b3-45e5-825d-6e1445ec5303	9d6ce4c5-0e9b-45e7-ac02-8404e1f4beb6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"40.44","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:23:21
43108	9d6ce4c5-0810-4187-844f-0be7f1ec8004	9d6ce4c5-0e9b-45e7-ac02-8404e1f4beb6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:23:21
43109	9d6ce4c5-0cfd-47d1-9039-c8bb1ab452fd	9d6ce4c5-0e9b-45e7-ac02-8404e1f4beb6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:23:21
43110	9d6ce4c5-0d54-4b73-8edc-b6de480e1b15	9d6ce4c5-0e9b-45e7-ac02-8404e1f4beb6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":273,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:23:21
43111	9d6ce4c5-5ace-47fb-9a45-ba4b134ec2b2	9d6ce4c5-789b-46b2-9f52-33c7bf88251f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:23:21
43112	9d6ce4c5-72f3-41b7-a69b-8eca1afa2662	9d6ce4c5-789b-46b2-9f52-33c7bf88251f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"49.88","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:23:21
43113	9d6ce4c5-76cb-4b69-ad56-bcf68be34aab	9d6ce4c5-789b-46b2-9f52-33c7bf88251f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:23:21
43114	9d6ce4c5-7737-465a-88e5-930ee79ccde0	9d6ce4c5-789b-46b2-9f52-33c7bf88251f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":255,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:23:21
43145	9d6ce51a-fa24-4edc-b388-6e1ac2005ae6	9d6ce51b-17e6-418e-a24a-88595a34d535	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 11:24:17
43146	9d6ce51b-15f1-4a9a-bd87-983a481d0bd8	9d6ce51b-17e6-418e-a24a-88595a34d535	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 11:24:17
43147	9d6ce51b-1682-43f2-b44f-5e67187cac85	9d6ce51b-17e6-418e-a24a-88595a34d535	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":250,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:24:17
42994	9d6ce35c-cca6-4868-9073-0c36c51a8201	9d6ce35c-ea22-4476-a45a-aa38f4cb2a85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 11:19:25
42995	9d6ce35c-e815-4740-8f72-4de63b8d2f1b	9d6ce35c-ea22-4476-a45a-aa38f4cb2a85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 11:19:25
42996	9d6ce35c-e8ff-4208-9113-ca44d5702ea2	9d6ce35c-ea22-4476-a45a-aa38f4cb2a85	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":264,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:19:25
8308	9d52e832-b733-4970-ab22-97dc638227c6	9d52e832-b9fa-4e1a-be09-791b346804de	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":405}	2024-10-24 13:21:25
23030	9d6800ef-2b8f-448a-844e-ca50a109e1e7	9d6800ef-2eda-488b-811d-3d1aeba6879f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1094}	2024-11-04 01:02:58
30571	9d693ff9-1adb-4043-8bff-be37abe591d2	9d693ff9-6398-4a8c-ad7a-02f32fd7f4ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-04 15:55:04
30572	9d693ff9-61f9-4220-8032-475f6b124b40	9d693ff9-6398-4a8c-ad7a-02f32fd7f4ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-04 15:55:04
30573	9d693ff9-62c6-42ec-adcd-fec5fb3c0781	9d693ff9-6398-4a8c-ad7a-02f32fd7f4ff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":420,"memory":22,"hostname":"EderCortes"}	2024-11-04 15:55:04
43446	9d6cea01-f13c-49e1-b452-e67d6285464a	9d6cea02-367e-47d4-b030-895f86065b53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:38:00
43447	9d6cea02-34f9-4ed4-b9e5-375a16a514a4	9d6cea02-367e-47d4-b030-895f86065b53	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:38:00
43448	9d6cea02-358a-4a15-a0e7-40bf00623e7f	9d6cea02-367e-47d4-b030-895f86065b53	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:00
43445	9d6cea02-335b-4318-9d31-c8b029cbd90b	9d6cea02-367e-47d4-b030-895f86065b53	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2027}	2024-11-06 11:38:00
21530	9d673ba6-509d-48de-97b1-f7639a0899a9	9d673ba6-5548-464c-8dd8-cc6bc256fac2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1043}	2024-11-03 15:51:19
43404	9d6ce762-f97c-4fb4-a990-8acc35d31edf	9d6ce763-4b77-480f-bea6-a72435229014	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:30:40
43405	9d6ce763-497f-40b8-b574-5846a952a3b8	9d6ce763-4b77-480f-bea6-a72435229014	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 11:30:40
43406	9d6ce763-4a55-4fb9-a62c-71fe5cb5dff2	9d6ce763-4b77-480f-bea6-a72435229014	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":422,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:30:40
41125	9d6ccba7-97fb-454f-9537-0e13d7027dfd	9d6ccba7-e63a-45fa-8549-254e7b10bb85	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:13:07
41126	9d6ccba7-e26e-4beb-aba4-be972327cf7e	9d6ccba7-e63a-45fa-8549-254e7b10bb85	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:13:08
41127	9d6ccba7-e470-43c8-8fd5-191e7cb9f554	9d6ccba7-e63a-45fa-8549-254e7b10bb85	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":501,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:13:08
43237	9d6ce5b0-3ff8-4c0f-8853-5a60c80e8a5e	9d6ce5b0-639c-448d-b75d-ab60c23b08b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:25:55
43238	9d6ce5b0-61e4-4783-a429-396187fc0045	9d6ce5b0-639c-448d-b75d-ab60c23b08b1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 11:25:55
43239	9d6ce5b0-6295-4c5f-b4a1-955a704e3d66	9d6ce5b0-639c-448d-b75d-ab60c23b08b1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":293,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:25:55
26828	9d68dd0b-c16c-4873-971b-7b7b60ef1e19	9d68dd0b-c4d7-458d-b32e-1512dc296f3a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1251}	2024-11-04 11:18:26
7007	9d52d9da-d064-4089-987c-c95fe6f64f02	9d52d9da-d3b5-4b7d-84cd-985722a01cd9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":355}	2024-10-24 12:41:18
38851	9d6b6fc4-622b-40a1-bbdb-570f21f3f762	9d6b6fc4-ad8f-4cba-8330-1c21bf47d6fc	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 18:00:22
38852	9d6b6fc4-a9de-4a00-a5f9-7b0d2e71fadd	9d6b6fc4-ad8f-4cba-8330-1c21bf47d6fc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 18:00:22
38853	9d6b6fc4-ab8c-4979-82c6-0adaefa9fb83	9d6b6fc4-ad8f-4cba-8330-1c21bf47d6fc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":914,"memory":22,"hostname":"EderCortes"}	2024-11-05 18:00:22
38854	9d6b6fc5-6b28-40df-8fa6-d6a7b4ef12a3	9d6b6fc5-8d50-4d06-b7cc-1e40ac3a2a98	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 18:00:22
38855	9d6b6fc5-865f-4f9a-b92d-61ec9d43e603	9d6b6fc5-8d50-4d06-b7cc-1e40ac3a2a98	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"44.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 18:00:22
38856	9d6b6fc5-8b87-4ab0-be32-d045b0a3e344	9d6b6fc5-8d50-4d06-b7cc-1e40ac3a2a98	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 18:00:22
38857	9d6b6fc5-8c11-457f-9139-762ae0d0f80c	9d6b6fc5-8d50-4d06-b7cc-1e40ac3a2a98	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":468,"memory":22,"hostname":"EderCortes"}	2024-11-05 18:00:22
38858	9d6b6fc5-f29c-4f0f-b929-e973b7741cb2	9d6b6fc6-44f4-4cdf-9cbd-ef93cc5aa0f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 18:00:23
38859	9d6b6fc6-3cfc-4b66-8c68-9d89915ebf8f	9d6b6fc6-44f4-4cdf-9cbd-ef93cc5aa0f4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"163.25","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 18:00:23
38860	9d6b6fc6-3d63-49f1-9fc4-0a7490cd7713	9d6b6fc6-44f4-4cdf-9cbd-ef93cc5aa0f4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 18:00:23
38861	9d6b6fc6-434f-4cbc-aec2-f1a04b7be949	9d6b6fc6-44f4-4cdf-9cbd-ef93cc5aa0f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 18:00:23
38862	9d6b6fc6-43b3-42fa-b4f4-832fdbfaf5e5	9d6b6fc6-44f4-4cdf-9cbd-ef93cc5aa0f4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":455,"memory":22,"hostname":"EderCortes"}	2024-11-05 18:00:23
38863	9d6b6fc6-9707-4cb0-9492-fdc410045079	9d6b6fc6-b849-443b-930a-70a184595967	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 18:00:23
38864	9d6b6fc6-b23d-4d91-b7a8-4fc2b1f9222b	9d6b6fc6-b849-443b-930a-70a184595967	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.70","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 18:00:23
38865	9d6b6fc6-b2a7-4742-b4c4-4f7ddffe7c81	9d6b6fc6-b849-443b-930a-70a184595967	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 18:00:23
38866	9d6b6fc6-b6d5-4b30-846e-b6bbf1335302	9d6b6fc6-b849-443b-930a-70a184595967	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 18:00:23
38867	9d6b6fc6-b725-4b25-9cb8-916de715abab	9d6b6fc6-b849-443b-930a-70a184595967	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":281,"memory":22,"hostname":"EderCortes"}	2024-11-05 18:00:23
38868	9d6b6fc8-cfb1-448b-bcfb-22d697634610	9d6b6fc8-febb-4b8e-8f73-8bdc73216f2a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 18:00:24
38869	9d6b6fc8-f47c-47d4-b91e-05b4045f7f28	9d6b6fc8-febb-4b8e-8f73-8bdc73216f2a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"59.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 18:00:25
38870	9d6b6fc8-f51f-416a-8cac-e5c01a31fe9c	9d6b6fc8-febb-4b8e-8f73-8bdc73216f2a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 18:00:25
38871	9d6b6fc8-fcc1-4eb7-b1f6-8c8ab3b98728	9d6b6fc8-febb-4b8e-8f73-8bdc73216f2a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 18:00:25
38872	9d6b6fc8-fd42-44a3-95c1-778332f4d1f4	9d6b6fc8-febb-4b8e-8f73-8bdc73216f2a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":392,"memory":22,"hostname":"EderCortes"}	2024-11-05 18:00:25
38873	9d6b6fc9-760f-4704-b5b0-25c12c1fa8b4	9d6b6fc9-7c26-4027-a8a3-f495763516da	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":276,"memory":22,"hostname":"EderCortes"}	2024-11-05 18:00:25
38874	9d6b6fc9-e800-49d3-9f8f-896389797d47	9d6b6fca-0dfc-49c1-9611-28f3b913a490	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 18:00:25
38875	9d6b6fca-0731-4747-aaf0-0082b62f66e3	9d6b6fca-0dfc-49c1-9611-28f3b913a490	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"53.29","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 18:00:25
38876	9d6b6fca-0c46-4522-932d-536707c43703	9d6b6fca-0dfc-49c1-9611-28f3b913a490	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 18:00:25
38877	9d6b6fca-0cd2-43ea-a3d7-386c9e32969b	9d6b6fca-0dfc-49c1-9611-28f3b913a490	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":305,"memory":22,"hostname":"EderCortes"}	2024-11-05 18:00:25
36863	9d6b40fc-e5d7-41c3-9fc5-b928ca831823	9d6b40fd-2f26-4367-86d4-c2f9a3e38056	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-05 15:49:33
36864	9d6b40fd-2d19-42dc-b5e6-cc96803d5be7	9d6b40fd-2f26-4367-86d4-c2f9a3e38056	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-05 15:49:33
36865	9d6b40fd-2e12-41cf-8939-2c05c9880f41	9d6b40fd-2f26-4367-86d4-c2f9a3e38056	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":358,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:49:33
36866	9d6b40fd-8b3f-4137-bb17-7e9b3d5b200e	9d6b40fd-d3e7-4b12-9309-acd6395cda28	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-05 15:49:34
36867	9d6b40fd-cf0d-4948-9333-20486e09dd48	9d6b40fd-d3e7-4b12-9309-acd6395cda28	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"155.26","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 15:49:34
36868	9d6b40fd-d26d-40b6-a560-5998007e8bb4	9d6b40fd-d3e7-4b12-9309-acd6395cda28	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-05 15:49:34
36869	9d6b40fd-d2d6-4ce3-867a-8ae8fc80f617	9d6b40fd-d3e7-4b12-9309-acd6395cda28	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":355,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:49:34
36870	9d6b40fe-3248-4d29-86c8-be9f8dcce415	9d6b40fe-5251-433d-84a4-63a8eefd3710	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-05 15:49:34
36871	9d6b40fe-4c91-42dd-a521-0d938ebdf5f7	9d6b40fe-5251-433d-84a4-63a8eefd3710	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.13","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:49:34
36872	9d6b40fe-4ce4-4d62-8634-4617c5af79ac	9d6b40fe-5251-433d-84a4-63a8eefd3710	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:49:34
36873	9d6b40fe-50cf-4352-8202-fbd89c2c5ef3	9d6b40fe-5251-433d-84a4-63a8eefd3710	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-05 15:49:34
36874	9d6b40fe-5128-4ee3-8b1a-166acaaf2dcb	9d6b40fe-5251-433d-84a4-63a8eefd3710	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":300,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:49:34
36875	9d6b40fe-98bb-4b95-8bc1-7093c442c77a	9d6b40fe-b9fe-4b84-ad7e-13d638afc410	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-05 15:49:34
36876	9d6b40fe-b376-45fa-97ca-1720d79de4ec	9d6b40fe-b9fe-4b84-ad7e-13d638afc410	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"44.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 15:49:34
36877	9d6b40fe-b3e0-49d8-b39a-a70ebca64335	9d6b40fe-b9fe-4b84-ad7e-13d638afc410	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 15:49:34
36878	9d6b40fe-b88d-4594-b8c5-20e9c3db4e08	9d6b40fe-b9fe-4b84-ad7e-13d638afc410	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-05 15:49:34
36879	9d6b40fe-b8e8-4eff-8c7c-34928de9132a	9d6b40fe-b9fe-4b84-ad7e-13d638afc410	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":244,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:49:34
36880	9d6b4100-572e-47f7-b4c9-d837065852ca	9d6b4100-7651-42f2-9243-5819e6a449e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-05 15:49:36
36881	9d6b4100-7094-48f8-a99d-673cff818951	9d6b4100-7651-42f2-9243-5819e6a449e3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 15:49:36
36882	9d6b4100-70ee-4e3d-b6b0-c86a7c87b7fb	9d6b4100-7651-42f2-9243-5819e6a449e3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 15:49:36
36883	9d6b4100-74fd-48b9-9783-571f38ecaacd	9d6b4100-7651-42f2-9243-5819e6a449e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-05 15:49:36
36884	9d6b4100-7544-4e2d-8495-8de4d40d15b8	9d6b4100-7651-42f2-9243-5819e6a449e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":486,"memory":22,"hostname":"EderCortes"}	2024-11-05 15:49:36
39173	9d6bcd1c-3ea7-49ce-bbbe-f73485cdf526	9d6bcd1c-65bf-438c-9bc0-21f348e95da6	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 22:21:22
39174	9d6bcd1c-6362-4c8c-b0ca-ec060aa13476	9d6bcd1c-65bf-438c-9bc0-21f348e95da6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 22:21:22
39175	9d6bcd1c-6476-4242-be40-37d58a28ee27	9d6bcd1c-65bf-438c-9bc0-21f348e95da6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":286,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:21:22
39176	9d6bcd1c-cdbb-45a0-a8ed-ec35df4485f1	9d6bcd1c-eb5d-424f-81d1-c4d80f36fc96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 22:21:22
39177	9d6bcd1c-e62d-4e2e-b712-366fe24f548a	9d6bcd1c-eb5d-424f-81d1-c4d80f36fc96	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"43.10","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 22:21:22
39178	9d6bcd1c-e9e7-4ed2-bf6c-e87992e85ff0	9d6bcd1c-eb5d-424f-81d1-c4d80f36fc96	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 22:21:22
39179	9d6bcd1c-ea57-4eab-aee0-258a5dda83b8	9d6bcd1c-eb5d-424f-81d1-c4d80f36fc96	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":269,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:21:22
39180	9d6bcd1d-4316-48f1-bc80-9998da518130	9d6bcd1d-626d-4010-ba6c-47036900748b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 22:21:23
39181	9d6bcd1d-5c9a-4ffb-8dc7-4df741dabf7a	9d6bcd1d-626d-4010-ba6c-47036900748b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:21:23
39182	9d6bcd1d-5ceb-40da-a285-e93bec7c0b83	9d6bcd1d-626d-4010-ba6c-47036900748b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:21:23
39183	9d6bcd1d-610c-4ce9-b786-174b1f4a2aad	9d6bcd1d-626d-4010-ba6c-47036900748b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 22:21:23
39184	9d6bcd1d-615c-4fee-9a2a-6f24ff2ff8ec	9d6bcd1d-626d-4010-ba6c-47036900748b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":294,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:21:23
39185	9d6bcd1d-aa2e-4a1a-93bf-28ad8d1cff6c	9d6bcd1d-c88f-497d-8d8b-a8710688be0c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 22:21:23
39186	9d6bcd1d-c2cf-499c-8878-48b27c250e04	9d6bcd1d-c88f-497d-8d8b-a8710688be0c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"38.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:21:23
39187	9d6bcd1d-c329-47e7-9484-924b1f5bdb36	9d6bcd1d-c88f-497d-8d8b-a8710688be0c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:21:23
39188	9d6bcd1d-c734-4f41-a02d-7b507f2f356f	9d6bcd1d-c88f-497d-8d8b-a8710688be0c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 22:21:23
39189	9d6bcd1d-c797-4afa-aee2-899025dadd2c	9d6bcd1d-c88f-497d-8d8b-a8710688be0c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:21:23
39190	9d6bcd1f-471f-4f62-b795-20cd9cbeaed5	9d6bcd1f-77c9-44f9-959f-40ee2d9ec2e2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 22:21:24
39191	9d6bcd1f-6d0d-4c44-8f50-eef0c54ca241	9d6bcd1f-77c9-44f9-959f-40ee2d9ec2e2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"62.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 22:21:24
39192	9d6bcd1f-6dbc-4d72-8595-32b06ed24b34	9d6bcd1f-77c9-44f9-959f-40ee2d9ec2e2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 22:21:24
39193	9d6bcd1f-75bf-43d4-8f1c-fbdfc888d74c	9d6bcd1f-77c9-44f9-959f-40ee2d9ec2e2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 22:21:24
39194	9d6bcd1f-7626-44f7-a59e-0d5e069b6b3d	9d6bcd1f-77c9-44f9-959f-40ee2d9ec2e2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":452,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:21:24
39195	9d6bcd1f-f306-4876-a304-fd515abc0f2b	9d6bcd1f-f6c3-4d6b-b333-8c5bc526b2dc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":284,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:21:24
39196	9d6bcd20-aedc-4cc7-b9be-28d3f637c0f0	9d6bcd20-cc3c-413d-a4d8-b1690c6793db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 22:21:25
39197	9d6bcd20-c766-4c96-bb6e-df20b891446e	9d6bcd20-cc3c-413d-a4d8-b1690c6793db	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"44.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 22:21:25
39198	9d6bcd20-cab4-40c2-96d0-4ae07cdbf88a	9d6bcd20-cc3c-413d-a4d8-b1690c6793db	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 22:21:25
39199	9d6bcd20-cb35-495b-b85e-2a1a5ba2d49e	9d6bcd20-cc3c-413d-a4d8-b1690c6793db	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:21:25
39200	9d6bcd22-b17b-4266-a4bb-b5acea5d7385	9d6bcd22-b50c-4963-9caa-8e499a9140ae	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":192,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:21:26
39201	9d6bcd23-6b0d-4450-8d45-86ce7d461c2d	9d6bcd23-87fb-4a78-820d-1c4605c71aa6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 22:21:27
39202	9d6bcd23-8332-4091-8ca7-fca1ab05ce18	9d6bcd23-87fb-4a78-820d-1c4605c71aa6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" where \\"l\\".\\"user_cobrador\\" = 14 order by \\"l\\".\\"id\\" desc","time":"43.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":143,"hash":"9c165f2fbf7ccf3d02848123be5b6d04","hostname":"EderCortes"}	2024-11-05 22:21:27
39203	9d6bcd23-8690-4a58-a265-a1d6c2e4469c	9d6bcd23-87fb-4a78-820d-1c4605c71aa6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 22:21:27
39204	9d6bcd23-86fa-420c-b018-23cc5702b05f	9d6bcd23-87fb-4a78-820d-1c4605c71aa6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":14,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:21:27
39205	9d6bcd26-dae9-4158-a4f9-35e9f880d9f8	9d6bcd26-de1e-4d46-925e-96f2fd330074	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":194,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:21:29
38657	9d6b6b0d-50ed-4a51-a69c-d326016139a9	9d6b6b0d-53d9-4225-bcbd-66634f983b42	ae2a356f0e28ceebd439f549153d9ec1	f	exception	{"class":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83,"message":"Undefined array key \\"cobrador\\"","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"74":"","75":"","76":"    }","77":"","78":"    public function listPrecautions(Request $request) {","79":"        $fechaActual = Carbon::now();","80":"        $formatDate = $fechaActual->format( 'd-m-Y');","81":"","82":"","83":"        $cobrador = $request->all()['cobrador'];","84":"        $estado = $request->all()['estado'];","85":"        $frecuencia = $request->all()['frecuencia'];","86":"        $prestamista = $request->all()['prestamista'];","87":"","88":"","89":"        $data = DB::table('loans as l')","90":"            ->select(DB::raw(\\"","91":"        EXTRACT(DAY FROM (","92":"            CASE","93":"                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'"},"hostname":"EderCortes","occurrences":1}	2024-11-05 17:47:10
38716	9d6b6bb7-f488-441e-ab02-1550d3b5b6e5	9d6b6bb7-f793-46c8-9698-cbb6789722ed	ae2a356f0e28ceebd439f549153d9ec1	f	exception	{"class":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83,"message":"Undefined array key \\"cobrador\\"","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"74":"","75":"","76":"    }","77":"","78":"    public function listPrecautions(Request $request) {","79":"        $fechaActual = Carbon::now();","80":"        $formatDate = $fechaActual->format( 'd-m-Y');","81":"","82":"","83":"        $cobrador = $request->all()['cobrador'];","84":"        $estado = $request->all()['estado'];","85":"        $frecuencia = $request->all()['frecuencia'];","86":"        $prestamista = $request->all()['prestamista'];","87":"","88":"","89":"        $data = DB::table('loans as l')","90":"            ->select(DB::raw(\\"","91":"        EXTRACT(DAY FROM (","92":"            CASE","93":"                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'"},"hostname":"EderCortes","occurrences":5}	2024-11-05 17:49:02
38735	9d6b6bbc-8b1b-49bf-be5f-72f657f04039	9d6b6bbc-8e4a-4ae8-a82b-197be730d572	ae2a356f0e28ceebd439f549153d9ec1	f	exception	{"class":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83,"message":"Undefined array key \\"cobrador\\"","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"74":"","75":"","76":"    }","77":"","78":"    public function listPrecautions(Request $request) {","79":"        $fechaActual = Carbon::now();","80":"        $formatDate = $fechaActual->format( 'd-m-Y');","81":"","82":"","83":"        $cobrador = $request->all()['cobrador'];","84":"        $estado = $request->all()['estado'];","85":"        $frecuencia = $request->all()['frecuencia'];","86":"        $prestamista = $request->all()['prestamista'];","87":"","88":"","89":"        $data = DB::table('loans as l')","90":"            ->select(DB::raw(\\"","91":"        EXTRACT(DAY FROM (","92":"            CASE","93":"                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'"},"hostname":"EderCortes","occurrences":6}	2024-11-05 17:49:05
39130	9d6bcca7-ed42-4919-be6b-650defbdac77	9d6bcca7-f072-4008-80c7-49418e7cf781	ae2a356f0e28ceebd439f549153d9ec1	f	exception	{"class":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83,"message":"Undefined array key \\"cobrador\\"","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"74":"","75":"","76":"    }","77":"","78":"    public function listPrecautions(Request $request) {","79":"        $fechaActual = Carbon::now();","80":"        $formatDate = $fechaActual->format( 'd-m-Y');","81":"","82":"","83":"        $cobrador = $request->all()['cobrador'];","84":"        $estado = $request->all()['estado'];","85":"        $frecuencia = $request->all()['frecuencia'];","86":"        $prestamista = $request->all()['prestamista'];","87":"","88":"","89":"        $data = DB::table('loans as l')","90":"            ->select(DB::raw(\\"","91":"        EXTRACT(DAY FROM (","92":"            CASE","93":"                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'"},"hostname":"EderCortes","occurrences":8}	2024-11-05 22:20:06
39168	9d6bccd2-0eee-403c-b46a-91ddd668fc35	9d6bccd2-11e1-46db-a4c4-2f584608863d	ae2a356f0e28ceebd439f549153d9ec1	f	exception	{"class":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83,"message":"Undefined array key \\"cobrador\\"","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"74":"","75":"","76":"    }","77":"","78":"    public function listPrecautions(Request $request) {","79":"        $fechaActual = Carbon::now();","80":"        $formatDate = $fechaActual->format( 'd-m-Y');","81":"","82":"","83":"        $cobrador = $request->all()['cobrador'];","84":"        $estado = $request->all()['estado'];","85":"        $frecuencia = $request->all()['frecuencia'];","86":"        $prestamista = $request->all()['prestamista'];","87":"","88":"","89":"        $data = DB::table('loans as l')","90":"            ->select(DB::raw(\\"","91":"        EXTRACT(DAY FROM (","92":"            CASE","93":"                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'"},"hostname":"EderCortes","occurrences":9}	2024-11-05 22:20:33
39206	9d6bcd27-a19a-4a57-8cf4-5d9bef06fd42	9d6bcd27-a4f3-44e3-9c44-cf2bf14b9a29	ae2a356f0e28ceebd439f549153d9ec1	t	exception	{"class":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83,"message":"Undefined array key \\"cobrador\\"","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"74":"","75":"","76":"    }","77":"","78":"    public function listPrecautions(Request $request) {","79":"        $fechaActual = Carbon::now();","80":"        $formatDate = $fechaActual->format( 'd-m-Y');","81":"","82":"","83":"        $cobrador = $request->all()['cobrador'] ? $request->all()['cobrador'] : '';","84":"        $estado = $request->all()['estado'];","85":"        $frecuencia = $request->all()['frecuencia'];","86":"        $prestamista = $request->all()['prestamista'];","87":"","88":"","89":"        $data = DB::table('loans as l')","90":"            ->select(DB::raw(\\"","91":"        EXTRACT(DAY FROM (","92":"            CASE","93":"                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'"},"hostname":"EderCortes","occurrences":10}	2024-11-05 22:21:29
39207	9d6bcd27-9be4-40f2-a539-a377d11a203f	9d6bcd27-a4f3-44e3-9c44-cf2bf14b9a29	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 22:21:29
39208	9d6bcd27-a354-401f-97ae-da3406b905bd	9d6bcd27-a4f3-44e3-9c44-cf2bf14b9a29	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 22:21:29
39209	9d6bcd27-a3eb-4a64-91ca-3e4d34a658ff	9d6bcd27-a4f3-44e3-9c44-cf2bf14b9a29	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"46","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":500,"response":{"message":"Undefined array key \\"cobrador\\"","exception":"ErrorException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions.php","line":255,"function":"handleError","class":"Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":83,"function":"Illuminate\\\\Foundation\\\\Bootstrap\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Bootstrap\\\\HandleExceptions","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"listPrecautions","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":193,"memory":20,"hostname":"EderCortes"}	2024-11-05 22:21:29
34996	9d69c14f-dc59-4b43-9e17-0ee4c09d416f	9d69c14f-f928-49ef-936d-75d702df8a80	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-04 21:56:43
34997	9d69c14f-f769-46ee-97aa-427ecb100673	9d69c14f-f928-49ef-936d-75d702df8a80	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-04 21:56:43
34998	9d69c14f-f832-47fb-8375-b10c1da66ee5	9d69c14f-f928-49ef-936d-75d702df8a80	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":234,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:56:43
39448	9d6bdae5-918d-429d-ade7-e8c6ba1eb030	9d6bdae5-b8a1-41e5-b99d-03c2447ead43	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 22:59:55
39449	9d6bdae5-b67c-4fb0-a0a0-e9723b42f7a2	9d6bdae5-b8a1-41e5-b99d-03c2447ead43	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 22:59:55
39450	9d6bdae5-b759-4f28-9dce-995648bccb13	9d6bdae5-b8a1-41e5-b99d-03c2447ead43	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":322,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:59:55
39451	9d6bdae6-3498-412d-a4fa-6b40141c461d	9d6bdae6-7eb4-4e34-9963-8ecdccc3bae5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 22:59:55
39452	9d6bdae6-78b2-4c48-8684-4027845343c0	9d6bdae6-7eb4-4e34-9963-8ecdccc3bae5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"159.39","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":26,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-05 22:59:55
39453	9d6bdae6-7d61-4491-9bdb-5182a3b8a35f	9d6bdae6-7eb4-4e34-9963-8ecdccc3bae5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 22:59:55
39454	9d6bdae6-7dd2-44ef-a9cd-3ed39c870c6c	9d6bdae6-7eb4-4e34-9963-8ecdccc3bae5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":431,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:59:56
39455	9d6bdae6-d90a-41b5-85c9-c84a686aefaa	9d6bdae7-2366-40d9-bbd6-2b2742de2bad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 22:59:56
39456	9d6bdae7-1da5-4c4c-97cb-daeecb689d26	9d6bdae7-2366-40d9-bbd6-2b2742de2bad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"151.13","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:59:56
39457	9d6bdae7-1e20-44eb-99ce-625dd69d9e87	9d6bdae7-2366-40d9-bbd6-2b2742de2bad	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:59:56
39458	9d6bdae7-2223-41af-835d-1db2cc020f3a	9d6bdae7-2366-40d9-bbd6-2b2742de2bad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 22:59:56
39459	9d6bdae7-226b-42d2-95ad-bc40741b722d	9d6bdae7-2366-40d9-bbd6-2b2742de2bad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":398,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:59:56
39460	9d6bdae7-6b66-42fb-b5f0-c5940d7092ef	9d6bdae7-8ec9-4e69-8077-2a4eeca9538a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 22:59:56
39461	9d6bdae7-891a-4a63-8d93-e60fff3ed37a	9d6bdae7-8ec9-4e69-8077-2a4eeca9538a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.23","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:59:56
39462	9d6bdae7-896a-4043-b4ea-a7a381fe74eb	9d6bdae7-8ec9-4e69-8077-2a4eeca9538a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:59:56
39463	9d6bdae7-8da2-4b70-8c58-c83bb509b2ff	9d6bdae7-8ec9-4e69-8077-2a4eeca9538a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 22:59:56
39464	9d6bdae7-8dea-4818-b41f-43b0822ed7dc	9d6bdae7-8ec9-4e69-8077-2a4eeca9538a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":260,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:59:56
41291	9d6ccc38-f993-4f18-a4d9-810d8556e00b	9d6ccc39-2285-46be-8137-58a02a0e8643	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:14:43
41292	9d6ccc39-207c-4e86-af93-65ddeb4bc225	9d6ccc39-2285-46be-8137-58a02a0e8643	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 10:14:43
41293	9d6ccc39-2191-42be-b839-e3a079d0006a	9d6ccc39-2285-46be-8137-58a02a0e8643	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":396,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:14:43
7465	9d52ddab-4ea6-448a-adde-32a639f88041	9d52ddab-5268-48bd-be95-a57ff5f01431	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":373}	2024-10-24 12:51:58
35069	9d69c223-7334-4026-a62f-bcea9cd118e4	9d69c223-784b-4674-b329-2ad04d151a05	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1587}	2024-11-04 21:59:02
39717	9d6be277-5704-49a0-82f9-7580fdd0648e	9d6be278-1352-4b14-8610-be5e28dbfa70	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 23:21:05
39718	9d6be278-10bc-414e-8c03-0a85db1c7741	9d6be278-1352-4b14-8610-be5e28dbfa70	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 23:21:05
39719	9d6be278-11de-4730-8431-7af7be211ea6	9d6be278-1352-4b14-8610-be5e28dbfa70	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":711,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:21:05
39720	9d6be27b-ef25-4f19-9dd2-3dc51fda1db6	9d6be27c-3c67-4b24-a540-c8626b1163c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-05 23:21:08
39721	9d6be27c-2e5a-4cc7-b604-64f4c529accd	9d6be27c-3c67-4b24-a540-c8626b1163c4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"96.07","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 23:21:08
39722	9d6be27c-2ee2-4aca-b764-2a923877b80a	9d6be27c-3c67-4b24-a540-c8626b1163c4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 23:21:08
39723	9d6be27c-3a45-4a4e-b0bb-6dd056a5a471	9d6be27c-3c67-4b24-a540-c8626b1163c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 23:21:08
39724	9d6be27c-3ad2-445a-b44e-c14d11133941	9d6be27c-3c67-4b24-a540-c8626b1163c4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":1389,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:21:08
39852	9d6cb820-965a-43e8-824c-b2b9cfd6b3e4	9d6cb820-c1d0-4ce5-a837-bae083cec988	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:18:31
39853	9d6cb820-beca-4728-bfc4-07024c94c054	9d6cb820-c1d0-4ce5-a837-bae083cec988	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:18:31
39854	9d6cb820-c01c-4f94-95a8-088a368e3774	9d6cb820-c1d0-4ce5-a837-bae083cec988	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:18:31
35534	9d69c4f1-c256-418d-87c2-b9831ab69e5f	9d69c4f2-0a85-487d-9f31-730e5e3027e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-04 22:06:53
35535	9d69c4f2-08f2-4cfa-8744-e4a18a08d3d0	9d69c4f2-0a85-487d-9f31-730e5e3027e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 22:06:53
35536	9d69c4f2-098f-46de-9485-1d0308a111b1	9d69c4f2-0a85-487d-9f31-730e5e3027e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":358,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:06:53
3161	9d510314-5613-4caf-91ec-27a87602b886	9d510314-5c6e-4514-928d-1d82d1a43570	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":178}	2024-10-23 14:44:55
27347	9d68e433-f498-4e38-a5ac-a7957fd0f3a5	9d68e433-f863-446d-b68a-1fb31d8a9f55	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1275}	2024-11-04 11:38:27
35537	9d69c4f2-612f-4219-b89a-6f46acf06d1e	9d69c4f2-a891-46ed-b811-6f8f32926359	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-04 22:06:53
35538	9d69c4f2-a35f-473e-9533-c9ccf3879843	9d69c4f2-a891-46ed-b811-6f8f32926359	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"143.41","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:06:53
35539	9d69c4f2-a3ae-43c4-b54a-39341a77ceb5	9d69c4f2-a891-46ed-b811-6f8f32926359	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:06:53
35540	9d69c4f2-a776-466e-ab50-d3559986285f	9d69c4f2-a891-46ed-b811-6f8f32926359	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 22:06:53
35541	9d69c4f2-a7bc-48f4-a63e-cb0dee87f0f9	9d69c4f2-a891-46ed-b811-6f8f32926359	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":343,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:06:53
35542	9d69c4f2-ed6b-4c36-a3eb-65a051f56c57	9d69c4f3-0d66-48bd-9fe7-f12ce0ad5cbe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 22:06:53
35543	9d69c4f3-07e5-4a3c-9619-75879dfaf425	9d69c4f3-0d66-48bd-9fe7-f12ce0ad5cbe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"43.05","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 22:06:53
35544	9d69c4f3-0845-4a2a-840d-fcc64402c1ce	9d69c4f3-0d66-48bd-9fe7-f12ce0ad5cbe	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 22:06:53
35545	9d69c4f3-0c1d-4bf7-ae35-bcf37da79c85	9d69c4f3-0d66-48bd-9fe7-f12ce0ad5cbe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 22:06:53
35546	9d69c4f3-0c67-4437-aef7-ef67291ad40a	9d69c4f3-0d66-48bd-9fe7-f12ce0ad5cbe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:06:53
35547	9d69c4f3-59ca-42eb-94f9-7eb4512e0323	9d69c4f3-a26b-490f-a5d8-605d7a81fd48	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 22:06:54
35548	9d69c4f3-9cea-445b-ba76-5c8cf9948cb5	9d69c4f3-a26b-490f-a5d8-605d7a81fd48	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"142.40","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:06:54
35549	9d69c4f3-9d66-40fa-84b6-8be592576e8a	9d69c4f3-a26b-490f-a5d8-605d7a81fd48	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:06:54
35550	9d69c4f3-a13c-462c-b749-c840e9d97c1f	9d69c4f3-a26b-490f-a5d8-605d7a81fd48	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-04 22:06:54
35551	9d69c4f3-a183-4dd5-988d-66ff217f4f1a	9d69c4f3-a26b-490f-a5d8-605d7a81fd48	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":362,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:06:54
40101	9d6cc105-7a47-4f6f-b898-5bd44be3b2c2	9d6cc105-9e73-4573-abc7-484a0bb08610	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 09:43:23
40102	9d6cc105-9cbc-4e2d-bce6-028f46290751	9d6cc105-9e73-4573-abc7-484a0bb08610	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:43:23
40103	9d6cc105-9d73-43be-bc11-3866d3b72dd8	9d6cc105-9e73-4573-abc7-484a0bb08610	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":257,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:43:23
10917	9d5ca5d5-eefd-421a-83b7-c480fe79ed84	9d5ca5d5-f22a-4dd9-8bc1-736cadd539d8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":546}	2024-10-29 09:34:08
17335	9d655516-ed8a-4a35-a12d-1bf43082b1a7	9d655516-f0b7-4549-a26e-89e9e76a608d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":825}	2024-11-02 17:10:48
37889	9d6b5d7d-eba0-4492-9e3c-df97faf60d9f	9d6b5d7e-0ac7-46ea-aca5-f5a8f30886cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 17:09:15
37890	9d6b5d7e-0917-4eab-bb0d-61bed419acbb	9d6b5d7e-0ac7-46ea-aca5-f5a8f30886cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:09:16
37891	9d6b5d7e-09b8-451c-8490-2f80e34fd3c2	9d6b5d7e-0ac7-46ea-aca5-f5a8f30886cf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:09:16
39626	9d6bdf70-2298-4ccc-b82e-755f463feefb	9d6bdf70-2595-482f-b9d6-749d75bf4a01	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1760}	2024-11-05 23:12:37
43366	9d6ce601-a9e5-4531-8132-19985bbf967d	9d6ce601-acbe-43b1-86ad-8a48ad6f352e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2018}	2024-11-06 11:26:48
37892	9d6b5d7e-698f-4fc0-8ca3-1ff5a498e23b	9d6b5d7e-88c3-4add-a5e4-f8653e0b0682	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 17:09:16
37893	9d6b5d7e-82c2-4fa0-a656-ff9e0ee716eb	9d6b5d7e-88c3-4add-a5e4-f8653e0b0682	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:09:16
37894	9d6b5d7e-830b-4c0a-a3bf-f6d12c0366dd	9d6b5d7e-88c3-4add-a5e4-f8653e0b0682	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:09:16
37895	9d6b5d7e-870a-468d-b00c-18116d95a7b7	9d6b5d7e-88c3-4add-a5e4-f8653e0b0682	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 17:09:16
37896	9d6b5d7e-8796-4789-8ec7-c231b17a500c	9d6b5d7e-88c3-4add-a5e4-f8653e0b0682	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":248,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:09:16
37897	9d6b5d7e-d032-4d46-9902-55fc1bbd0a54	9d6b5d7f-16ed-416c-bdcd-194e03d15cf1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 17:09:16
37898	9d6b5d7f-120a-4854-9e36-f89f8888c342	9d6b5d7f-16ed-416c-bdcd-194e03d15cf1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"146.69","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:09:16
37899	9d6b5d7f-125d-4553-a9d3-a8354cdf1d35	9d6b5d7f-16ed-416c-bdcd-194e03d15cf1	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:09:16
37900	9d6b5d7f-1599-49f8-806a-365339fb8680	9d6b5d7f-16ed-416c-bdcd-194e03d15cf1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 17:09:16
37901	9d6b5d7f-15dd-4295-b91e-8e9e249a094c	9d6b5d7f-16ed-416c-bdcd-194e03d15cf1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":343,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:09:16
37902	9d6b5d80-7252-4aa6-8fd5-4435b4ff1893	9d6b5d80-c242-40ca-86b9-37154bdaa198	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 17:09:17
37903	9d6b5d80-bd22-4b11-8203-4a01fdd016d6	9d6b5d80-c242-40ca-86b9-37154bdaa198	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"149.73","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:09:17
37904	9d6b5d80-bd6a-4ca0-8e52-e75437dbd407	9d6b5d80-c242-40ca-86b9-37154bdaa198	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:09:17
37905	9d6b5d80-c10f-4af5-8ffc-5a17ec1675c1	9d6b5d80-c242-40ca-86b9-37154bdaa198	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 17:09:17
37906	9d6b5d80-c150-41c4-b243-d1c68760c8f2	9d6b5d80-c242-40ca-86b9-37154bdaa198	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":580,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:09:17
40415	9d6cc32b-0a37-49dc-baec-c493784c517f	9d6cc32b-5123-4b00-81dd-853957295b10	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:49:24
40416	9d6cc32b-4f98-4d77-84ea-e893d4fa4396	9d6cc32b-5123-4b00-81dd-853957295b10	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:49:24
40417	9d6cc32b-502f-467b-858c-7b6159aa631b	9d6cc32b-5123-4b00-81dd-853957295b10	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:49:24
40572	9d6cc51d-c496-4fc6-a2d2-a9cbb11d7045	9d6cc51e-0c6a-4b65-9250-9f6a826d4c5e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 09:54:50
40573	9d6cc51e-0ae9-4de3-9315-c520f8f6e23b	9d6cc51e-0c6a-4b65-9250-9f6a826d4c5e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 09:54:51
40574	9d6cc51e-0b7d-478e-ae7c-50740cc3d600	9d6cc51e-0c6a-4b65-9250-9f6a826d4c5e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":352,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:54:51
40575	9d6cc51f-b838-4c02-b724-fcf9b3ddd6f0	9d6cc51f-e6b3-435c-b178-329482758606	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 09:54:52
40576	9d6cc51f-defd-472b-960e-1fd94555e4fe	9d6cc51f-e6b3-435c-b178-329482758606	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"69.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:54:52
40577	9d6cc51f-df62-4ff7-ad1f-d3546d9ae65d	9d6cc51f-e6b3-435c-b178-329482758606	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:54:52
40578	9d6cc51f-e4a6-4163-a7ba-4ad879c48c19	9d6cc51f-e6b3-435c-b178-329482758606	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 09:54:52
40579	9d6cc51f-e525-4cd4-ba5e-993d14bd3563	9d6cc51f-e6b3-435c-b178-329482758606	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":420,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:54:52
40580	9d6cc520-47c6-471e-8b20-a892b4576686	9d6cc520-63e1-4357-9231-30cc050927f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 09:54:52
40581	9d6cc520-5fc4-4d5d-81b1-a3c1cae934bf	9d6cc520-63e1-4357-9231-30cc050927f2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"46.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:54:52
40582	9d6cc520-62a2-4f14-a76c-82b3678b761a	9d6cc520-63e1-4357-9231-30cc050927f2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 09:54:52
40583	9d6cc520-62e8-4ca5-8691-e1509d7d707a	9d6cc520-63e1-4357-9231-30cc050927f2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":300,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:54:52
38427	9d6b64ae-49a8-409d-9733-82a911a3ea2c	9d6b64ae-94bc-4c1f-8072-c9a8f8999ac6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 17:29:22
38428	9d6b64ae-92cc-4e8c-ac1d-9a770cef7bd6	9d6b64ae-94bc-4c1f-8072-c9a8f8999ac6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 17:29:22
38429	9d6b64ae-9377-4c2b-8c7f-f21a695cc350	9d6b64ae-94bc-4c1f-8072-c9a8f8999ac6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":383,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:29:22
38430	9d6b64ae-f541-4d4c-b651-fb29d323155a	9d6b64af-39b5-4c5b-b42f-00184e7a5dfe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 17:29:22
38431	9d6b64af-3471-45e8-9800-f7288f53a217	9d6b64af-39b5-4c5b-b42f-00184e7a5dfe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"144.34","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:29:22
38432	9d6b64af-3805-4250-9a65-33ab22234db8	9d6b64af-39b5-4c5b-b42f-00184e7a5dfe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 17:29:22
38433	9d6b64af-389e-4395-b452-662572de4903	9d6b64af-39b5-4c5b-b42f-00184e7a5dfe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:29:22
38434	9d6b64af-878f-42e7-a885-1f834d9bf413	9d6b64af-a6d1-43bd-9b10-3a2f73148c3a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 17:29:22
38435	9d6b64af-a17f-42d7-9ea4-0bcb64823728	9d6b64af-a6d1-43bd-9b10-3a2f73148c3a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:29:22
38436	9d6b64af-a1cd-4ab0-99f9-9aff47499853	9d6b64af-a6d1-43bd-9b10-3a2f73148c3a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:29:22
38437	9d6b64af-a541-4f72-acad-141eab3ebfd3	9d6b64af-a6d1-43bd-9b10-3a2f73148c3a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 17:29:22
38438	9d6b64af-a587-48dc-bb95-ee4cbbee8569	9d6b64af-a6d1-43bd-9b10-3a2f73148c3a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":265,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:29:22
38439	9d6b64af-ee14-47dc-98dc-8f03d22dfcf5	9d6b64b0-0ce0-458e-9ef6-bcf1d5ff723b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 17:29:23
38440	9d6b64b0-0795-4115-adc1-0ee12b7c0ffb	9d6b64b0-0ce0-458e-9ef6-bcf1d5ff723b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.30","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:29:23
38441	9d6b64b0-0802-4294-bd55-28e2852c7d01	9d6b64b0-0ce0-458e-9ef6-bcf1d5ff723b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:29:23
38442	9d6b64b0-0ba2-4dec-a1ae-5ea6f4c60c2f	9d6b64b0-0ce0-458e-9ef6-bcf1d5ff723b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 17:29:23
38443	9d6b64b0-0bea-42d6-8736-38944fff76c2	9d6b64b0-0ce0-458e-9ef6-bcf1d5ff723b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:29:23
38444	9d6b64b1-d74e-49dd-b82b-762d44662498	9d6b64b1-f836-4687-a8cb-7a1bae5d8780	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 17:29:24
38445	9d6b64b1-f216-4dc5-9f6f-39f2c7a47fa4	9d6b64b1-f836-4687-a8cb-7a1bae5d8780	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:29:24
38446	9d6b64b1-f265-4bf7-bb41-902791543513	9d6b64b1-f836-4687-a8cb-7a1bae5d8780	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:29:24
38447	9d6b64b1-f67f-401c-a6fd-a8b39c92737d	9d6b64b1-f836-4687-a8cb-7a1bae5d8780	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-05 17:29:24
38448	9d6b64b1-f6f2-4dee-a9d1-85bbcc55f45e	9d6b64b1-f836-4687-a8cb-7a1bae5d8780	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":315,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:29:24
40687	9d6cc68e-0fa5-4c00-b195-0d13d1a44952	9d6cc68e-3bc6-474b-b962-b36243e48d06	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 09:58:52
40688	9d6cc68e-3973-41ec-8453-4c2b0f1d1f77	9d6cc68e-3bc6-474b-b962-b36243e48d06	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:58:52
40689	9d6cc68e-3a8d-4d00-bfe9-54bb9bd8ccb8	9d6cc68e-3bc6-474b-b962-b36243e48d06	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:58:52
40793	9d6cc796-7960-4863-ab9a-4b5d633ddbba	9d6cc796-94c0-4956-b886-7483f53579f1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:01:45
40794	9d6cc796-9303-4a16-849b-a9a5a2a8bd61	9d6cc796-94c0-4956-b886-7483f53579f1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:01:45
40795	9d6cc796-93a2-48ae-8c75-da1df7079a5c	9d6cc796-94c0-4956-b886-7483f53579f1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:01:45
838	9d4f31f0-e815-441b-b653-c4c1f73f12ae	9d4f31f0-ed47-46b1-ac7d-f5029b309269	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":62}	2024-10-22 17:04:18
40796	9d6cc797-e6cd-4659-a3d4-c157fa410149	9d6cc798-224c-4452-b308-3cd91d0145b7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:01:46
40797	9d6cc798-19c9-4125-b171-ee51f055bc94	9d6cc798-224c-4452-b308-3cd91d0145b7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"82.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:01:46
40798	9d6cc798-1a4e-4e51-9192-149530dfd542	9d6cc798-224c-4452-b308-3cd91d0145b7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:01:46
40799	9d6cc798-200d-4da3-a3fd-d4625274d1ff	9d6cc798-224c-4452-b308-3cd91d0145b7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:01:46
40800	9d6cc798-2089-4dac-8818-c298ac518ce5	9d6cc798-224c-4452-b308-3cd91d0145b7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":494,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:01:46
41056	9d6ccae5-e172-4312-9d42-e275d49c1596	9d6ccae5-e4bf-4d3b-bb24-1ebb07a409b5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1878}	2024-11-06 10:11:00
40801	9d6cc798-cbf0-45da-a936-3868bc81faba	9d6cc798-f53c-4422-b31a-83afa1b03811	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:01:47
40802	9d6cc798-ee03-4f6c-99f6-dff9d057e5ab	9d6cc798-f53c-4422-b31a-83afa1b03811	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"64.87","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:01:47
40803	9d6cc798-f397-4f5a-a8fc-01d1fb740399	9d6cc798-f53c-4422-b31a-83afa1b03811	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:01:47
40804	9d6cc798-f40f-4a07-8c3d-84b16e93f59c	9d6cc798-f53c-4422-b31a-83afa1b03811	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":503,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:01:47
40929	9d6cc8b5-e76d-4b5a-9324-6d7731977901	9d6cc8b6-0462-42f6-8b03-82f798691c23	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:04:53
40930	9d6cc8b6-0279-4625-8d28-d9ddafa313af	9d6cc8b6-0462-42f6-8b03-82f798691c23	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:04:54
40931	9d6cc8b6-0355-4998-8bac-65c372b6529a	9d6cc8b6-0462-42f6-8b03-82f798691c23	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":276,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:04:54
38906	9d6bc9ec-8306-4514-933c-d81b470ecab3	9d6bc9ed-696e-42c2-a7a6-3f35f4cd525a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1742}	2024-11-05 22:12:27
40932	9d6cc8b7-14e8-464d-a1c2-9a7275535e04	9d6cc8b7-4058-4f3a-94ed-cc1341168049	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:04:54
40933	9d6cc8b7-3557-40c8-8885-ffe495d2e9e0	9d6cc8b7-4058-4f3a-94ed-cc1341168049	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"59.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:04:54
40934	9d6cc8b7-360a-4874-afbe-b52887be5712	9d6cc8b7-4058-4f3a-94ed-cc1341168049	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:04:54
40935	9d6cc8b7-3e58-4458-bf70-0b3321a2cd18	9d6cc8b7-4058-4f3a-94ed-cc1341168049	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:04:54
40936	9d6cc8b7-3ed1-463d-a181-466236fa2cff	9d6cc8b7-4058-4f3a-94ed-cc1341168049	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":392,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:04:54
40937	9d6cc8b7-ab39-4af0-b705-94cbfcb9ff81	9d6cc8b7-d0e7-45d4-a31f-2faae117d867	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:04:55
40938	9d6cc8b7-c909-4a33-be44-9f435b28d754	9d6cc8b7-d0e7-45d4-a31f-2faae117d867	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"57.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:04:55
40939	9d6cc8b7-cf20-4f4a-bb08-aa8e8036243b	9d6cc8b7-d0e7-45d4-a31f-2faae117d867	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:04:55
40940	9d6cc8b7-cf88-485a-bb05-73f5b3057e01	9d6cc8b7-d0e7-45d4-a31f-2faae117d867	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":346,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:04:55
35015	9d69c151-de64-442d-81d6-f5071379d56b	9d69c152-14aa-4145-8629-da63a98e9009	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-04 21:56:44
35016	9d69c152-11c5-40ba-839c-c4b61aaa3d75	9d69c152-14aa-4145-8629-da63a98e9009	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-04 21:56:45
35017	9d69c152-132f-4573-b1c3-2622b87f298d	9d69c152-14aa-4145-8629-da63a98e9009	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":446,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:56:45
41129	9d6ccba8-8441-4339-8ad8-353248114393	9d6ccba8-a93e-4a89-bcde-725db92b48bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:13:08
41130	9d6ccba8-a60f-451d-ade7-cb2c48891387	9d6ccba8-a93e-4a89-bcde-725db92b48bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:13:08
41131	9d6ccba8-a7b1-45a2-8416-48fdee4a2c31	9d6ccba8-a93e-4a89-bcde-725db92b48bb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":401,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:13:08
41132	9d6ccba9-552d-4915-8fd0-19a298999ee0	9d6ccba9-8699-4cdd-9665-d4d0b3cacb08	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:13:09
41133	9d6ccba9-7bdf-4abf-ac88-9bb9104666e6	9d6ccba9-8699-4cdd-9665-d4d0b3cacb08	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"62.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 10:13:09
41134	9d6ccba9-841f-44f9-a51e-9510b00213ee	9d6ccba9-8699-4cdd-9665-d4d0b3cacb08	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:13:09
41135	9d6ccba9-8509-4e8a-8096-7f73bffb004f	9d6ccba9-8699-4cdd-9665-d4d0b3cacb08	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":478,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:13:09
41136	9d6ccbaa-0ed7-4eb2-afc4-c38087919b31	9d6ccbaa-394d-4810-869d-7ec2d5571485	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:13:09
41137	9d6ccbaa-314d-43dc-856a-32cc5e3a1bd6	9d6ccbaa-394d-4810-869d-7ec2d5571485	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"57.51","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:13:09
41138	9d6ccbaa-31c5-4088-8ffa-074cc839275f	9d6ccbaa-394d-4810-869d-7ec2d5571485	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:13:09
41139	9d6ccbaa-37ed-4409-8cd7-d3a3888bdeda	9d6ccbaa-394d-4810-869d-7ec2d5571485	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:13:09
41140	9d6ccbaa-3840-44a3-982d-3b43e36e02da	9d6ccbaa-394d-4810-869d-7ec2d5571485	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":441,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:13:09
41141	9d6ccbaa-9337-4ffb-af78-f66e82cbc94f	9d6ccbaa-e030-42d0-a33f-f6ac3b6ba930	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:13:09
41142	9d6ccbaa-dad0-4ed4-ba50-0d4eb5743990	9d6ccbaa-e030-42d0-a33f-f6ac3b6ba930	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"153.91","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:13:10
41143	9d6ccbaa-db26-4104-8ef2-e2b959a9a53f	9d6ccbaa-e030-42d0-a33f-f6ac3b6ba930	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:13:10
41144	9d6ccbaa-dedb-443a-bbe5-5b444ab13ce8	9d6ccbaa-e030-42d0-a33f-f6ac3b6ba930	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:13:10
41145	9d6ccbaa-df26-4e5f-aaa0-1ccd12e3efd7	9d6ccbaa-e030-42d0-a33f-f6ac3b6ba930	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":404,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:13:10
41146	9d6ccbad-42de-4a64-84d7-8a96746234ad	9d6ccbad-8272-40c5-83ef-113788f9282e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:13:11
41147	9d6ccbad-755c-45c6-aee0-0b60e14ffe9c	9d6ccbad-8272-40c5-83ef-113788f9282e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"80.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:13:11
41148	9d6ccbad-7606-4dbd-9b79-3d19d114749a	9d6ccbad-8272-40c5-83ef-113788f9282e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:13:11
41149	9d6ccbad-7fe7-4d9b-9f3d-a9403049e663	9d6ccbad-8272-40c5-83ef-113788f9282e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:13:11
41150	9d6ccbad-8078-460f-8e2d-fdb10162a49f	9d6ccbad-8272-40c5-83ef-113788f9282e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":583,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:13:11
41151	9d6ccbae-2fb7-4427-9453-6b908d348983	9d6ccbae-6eaf-47b3-a36d-bd20b72d308e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:13:12
41152	9d6ccbae-6506-4160-b750-5acb49d694be	9d6ccbae-6eaf-47b3-a36d-bd20b72d308e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"97.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:13:12
41153	9d6ccbae-6c9a-4178-848a-af68dfdf8541	9d6ccbae-6eaf-47b3-a36d-bd20b72d308e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:13:12
41154	9d6ccbae-6d2f-42e6-a8b6-d561e9c7d568	9d6ccbae-6eaf-47b3-a36d-bd20b72d308e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":577,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:13:12
41155	9d6ccbaf-5507-43c6-8875-019e630d06b1	9d6ccbaf-5c6c-4798-bd46-fc471eb61c7b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":551,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:13:12
41156	9d6ccbb0-2817-4cd4-85f0-1c506c2c86ee	9d6ccbb0-8b31-4827-8ecc-7fa0520331f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:13:13
41157	9d6ccbb0-8111-4050-b149-43987230b67e	9d6ccbb0-8b31-4827-8ecc-7fa0520331f4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"196.05","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 10:13:13
41158	9d6ccbb0-8790-441e-b367-d4e147deca84	9d6ccbb0-8b31-4827-8ecc-7fa0520331f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:13:13
41159	9d6ccbb0-889d-49e6-ae13-c06564992936	9d6ccbb0-8b31-4827-8ecc-7fa0520331f4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":631,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:13:13
39466	9d6bdae7-e2a5-47eb-a126-faf6141fafa0	9d6bdae8-03fe-4665-a1cf-3ff6d9897e87	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 22:59:56
39467	9d6bdae8-01f7-4a63-9757-21fed2e443d9	9d6bdae8-03fe-4665-a1cf-3ff6d9897e87	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 22:59:56
39468	9d6bdae8-02e1-4c46-ab5d-72f67ba6631d	9d6bdae8-03fe-4665-a1cf-3ff6d9897e87	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":285,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:59:56
35678	9d69c545-83e3-42c1-948c-b1b4325e64dc	9d69c545-895e-41e0-9707-9a1f23ce605f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1618}	2024-11-04 22:07:47
41348	9d6ccc68-cc50-4d31-9d1d-da6696f07526	9d6ccc68-cf2f-41ca-b20e-1a41d1f4d317	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1895}	2024-11-06 10:15:14
39469	9d6bdae8-9d9a-486f-ac1d-f3598864c467	9d6bdae8-e2d1-492f-b23d-078f962004bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 22:59:57
39470	9d6bdae8-ddff-42aa-9f22-246c7ecc9bda	9d6bdae8-e2d1-492f-b23d-078f962004bb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"149.61","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":26,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-05 22:59:57
39471	9d6bdae8-e142-4ada-89c6-8b5927ba01ac	9d6bdae8-e2d1-492f-b23d-078f962004bb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 22:59:57
39472	9d6bdae8-e1ab-4693-b1d7-c77d164b9b3f	9d6bdae8-e2d1-492f-b23d-078f962004bb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":501,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:59:57
39473	9d6bdae9-3e5a-409a-8b3d-b2391b56f640	9d6bdae9-630a-475b-aecd-23bc58e1aa88	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 22:59:57
39474	9d6bdae9-5ce7-435a-9985-938aa37d0d2d	9d6bdae9-630a-475b-aecd-23bc58e1aa88	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"52.34","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:59:57
39475	9d6bdae9-5d3c-42f6-8f82-cebbcaaf1116	9d6bdae9-630a-475b-aecd-23bc58e1aa88	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:59:57
39476	9d6bdae9-618f-4615-8f82-a279a4488fe5	9d6bdae9-630a-475b-aecd-23bc58e1aa88	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 22:59:57
39477	9d6bdae9-6219-4b7a-abf6-928f2cc7fc21	9d6bdae9-630a-475b-aecd-23bc58e1aa88	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":304,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:59:57
39478	9d6bdae9-b99b-4813-b0ae-67d6efb7319f	9d6bdaea-0172-4900-9070-f462aea2801c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-05 22:59:58
39479	9d6bdae9-fbff-4984-ae5b-da3f40128104	9d6bdaea-0172-4900-9070-f462aea2801c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"145.00","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 22:59:58
39480	9d6bdae9-fc68-47ee-b0a1-42b5c250339e	9d6bdaea-0172-4900-9070-f462aea2801c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 22:59:58
39481	9d6bdaea-005c-4ad3-94a1-cc88cdf792e6	9d6bdaea-0172-4900-9070-f462aea2801c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 22:59:58
39482	9d6bdaea-009d-4d62-a2ed-5d282670d1d9	9d6bdaea-0172-4900-9070-f462aea2801c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":383,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:59:58
39483	9d6bdaec-4f67-4580-93a6-61a9bc8764ea	9d6bdaec-7069-4912-b581-daf0e1e374c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-05 22:59:59
39484	9d6bdaec-6a8b-4556-be99-4972d02d6fee	9d6bdaec-7069-4912-b581-daf0e1e374c3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"44.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 22:59:59
39485	9d6bdaec-6add-4d28-a087-308117b0d02c	9d6bdaec-7069-4912-b581-daf0e1e374c3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 22:59:59
39486	9d6bdaec-6ece-408a-88b2-d5e0c023a30e	9d6bdaec-7069-4912-b581-daf0e1e374c3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 22:59:59
39487	9d6bdaec-6f4c-40c0-97cb-0351fc06af2f	9d6bdaec-7069-4912-b581-daf0e1e374c3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":355,"memory":22,"hostname":"EderCortes"}	2024-11-05 22:59:59
41594	9d6ccdc3-783a-4624-bf66-7ca78cc855c2	9d6ccdc3-995a-47bc-a3b5-365eb74d9a1e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:19:01
41595	9d6ccdc3-96c4-4a20-8614-4f7acecb25dc	9d6ccdc3-995a-47bc-a3b5-365eb74d9a1e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:19:01
41596	9d6ccdc3-97f0-478f-abba-dbed1e8b204a	9d6ccdc3-995a-47bc-a3b5-365eb74d9a1e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:19:01
41597	9d6ccdc5-cf3a-4112-aa2c-5f19a73925af	9d6ccdc5-fe1d-4bf2-a4ca-802073355fbe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:19:03
41598	9d6ccdc5-f2fd-4ab2-a675-f2d954086a17	9d6ccdc5-fe1d-4bf2-a4ca-802073355fbe	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"57.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:19:03
41599	9d6ccdc5-f37e-4d81-98e1-39ee1f21c71c	9d6ccdc5-fe1d-4bf2-a4ca-802073355fbe	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:19:03
41600	9d6ccdc5-fc11-4b38-bb7b-0bdc024105a1	9d6ccdc5-fe1d-4bf2-a4ca-802073355fbe	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:19:03
41601	9d6ccdc5-fc9b-4ba4-bbd4-6362b4b94970	9d6ccdc5-fe1d-4bf2-a4ca-802073355fbe	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":525,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:19:03
41602	9d6ccdc6-58a2-4970-8f16-fe479055bba7	9d6ccdc6-a8aa-449c-aede-8b0bfcde962b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:19:03
41603	9d6ccdc6-9f6b-460c-a9c8-f99fcc513a8b	9d6ccdc6-a8aa-449c-aede-8b0bfcde962b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"164.82","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:19:03
41604	9d6ccdc6-a66f-415f-b047-3ed3b37cc81c	9d6ccdc6-a8aa-449c-aede-8b0bfcde962b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:19:03
41605	9d6ccdc6-a70f-4b5f-8b3b-e5bbabb98d51	9d6ccdc6-a8aa-449c-aede-8b0bfcde962b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":418,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:19:03
41662	9d6cce78-ee35-4d8a-ad36-2ffbf8294227	9d6cce79-3d32-424c-885e-d120107d2369	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 10:21:00
41663	9d6cce79-3a9b-4f6a-81e0-65eafc24b66c	9d6cce79-3d32-424c-885e-d120107d2369	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 10:21:00
41664	9d6cce79-3bdc-4080-bec4-9863c9442f27	9d6cce79-3d32-424c-885e-d120107d2369	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":381,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:21:00
1451	9d50d223-55b5-4b7a-b07f-07ef139a2e62	9d50d223-5927-4856-83ab-942099221554	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":103}	2024-10-23 12:28:04
41665	9d6cce7b-0e11-43e3-a68c-b99031344802	9d6cce7b-524a-46ef-90e4-edd696f2dcc3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 10:21:02
41666	9d6cce7b-48e3-46e1-9be2-f0da263163d7	9d6cce7b-524a-46ef-90e4-edd696f2dcc3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"117.21","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:21:02
41667	9d6cce7b-498e-49cd-ac74-c1cf3b789650	9d6cce7b-524a-46ef-90e4-edd696f2dcc3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:21:02
41668	9d6cce7b-5056-4254-a94e-62d9f1b4bf4c	9d6cce7b-524a-46ef-90e4-edd696f2dcc3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 10:21:02
41669	9d6cce7b-50cf-4171-8b42-3a1748494715	9d6cce7b-524a-46ef-90e4-edd696f2dcc3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":437,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:21:02
41670	9d6cce7b-e1af-4922-b448-dc7ef0bf4132	9d6cce7c-13c3-47c5-a6af-1cec9dae4beb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 10:21:02
41671	9d6cce7c-0a47-4c37-9054-42a78aebcc8b	9d6cce7c-13c3-47c5-a6af-1cec9dae4beb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"77.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:21:02
41672	9d6cce7c-11a3-4bf4-a1d3-9c9cc4828f36	9d6cce7c-13c3-47c5-a6af-1cec9dae4beb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 10:21:02
41673	9d6cce7c-1232-40c5-92fd-247df688eaae	9d6cce7c-13c3-47c5-a6af-1cec9dae4beb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":468,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:21:02
41901	9d6cd0f8-dc00-44af-8c39-ae90ac97627f	9d6cd0f8-fd76-43ea-88ee-359bc2dbad3a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:27:59
41902	9d6cd0f8-fba1-44bf-8b00-f6060797b10c	9d6cd0f8-fd76-43ea-88ee-359bc2dbad3a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:28:00
41903	9d6cd0f8-fc5c-40ef-b9a8-3e723999548d	9d6cd0f8-fd76-43ea-88ee-359bc2dbad3a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:28:00
20058	9d66ede3-6c0b-4f7c-b3cd-a3bfdbbb6c59	9d66ede3-6fb5-49ef-8c5c-42cf87243883	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":991}	2024-11-03 12:13:53
41904	9d6cd0f9-7458-4ad6-8246-cc9c9688be62	9d6cd0f9-c661-4336-9235-0d7c3c0c8ccf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:28:00
41905	9d6cd0f9-bd93-432c-a093-a45098955caf	9d6cd0f9-c661-4336-9235-0d7c3c0c8ccf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"148.86","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":19,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-06 10:28:00
41906	9d6cd0f9-bdf4-4cf1-8283-9d81c9096c72	9d6cd0f9-c661-4336-9235-0d7c3c0c8ccf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":5,"hostname":"EderCortes"}	2024-11-06 10:28:00
41907	9d6cd0f9-c4a5-4ffe-8b17-c2a2a2c67b55	9d6cd0f9-c661-4336-9235-0d7c3c0c8ccf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:28:00
41908	9d6cd0f9-c52b-4334-a978-9c2ddfbc851c	9d6cd0f9-c661-4336-9235-0d7c3c0c8ccf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:55:01.000000Z","deleted_at":null,"user_alias":"eder.cortes"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":413,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:28:00
41730	9d6cceff-6da6-43a7-a083-34a5a7f1cda5	9d6cceff-afb1-4fe9-879b-edca2fc3ae97	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:22:28
41731	9d6cceff-ae32-498c-aa23-11b76f5ec4d0	9d6cceff-afb1-4fe9-879b-edca2fc3ae97	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:22:28
41732	9d6cceff-aecc-4ef6-9452-b3380cfbbd6f	9d6cceff-afb1-4fe9-879b-edca2fc3ae97	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":363,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:22:28
41789	9d6ccf68-d82c-44ba-adc7-c22615a879bd	9d6ccf69-1e46-4a11-96f1-6ac81ae3e859	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:23:37
41790	9d6ccf69-1ccb-44fc-90d0-6ae3cf15ba9e	9d6ccf69-1e46-4a11-96f1-6ac81ae3e859	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:23:38
41791	9d6ccf69-1d64-4099-8a63-375257341815	9d6ccf69-1e46-4a11-96f1-6ac81ae3e859	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":331,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:23:38
41792	9d6ccf6a-5398-4615-ad94-3ab3d87ea268	9d6ccf6a-b62f-4b9c-aa8d-cd8c801ddbe0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:23:38
41793	9d6ccf6a-adbd-4e7f-8e79-fff348b298df	9d6ccf6a-b62f-4b9c-aa8d-cd8c801ddbe0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"186.76","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:23:39
41794	9d6ccf6a-ae48-4791-980e-4349eef87eb0	9d6ccf6a-b62f-4b9c-aa8d-cd8c801ddbe0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:23:39
41795	9d6ccf6a-b43e-4550-b34b-3d5606818f94	9d6ccf6a-b62f-4b9c-aa8d-cd8c801ddbe0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:23:39
41796	9d6ccf6a-b4b3-4a41-a21b-4d3fb61969d5	9d6ccf6a-b62f-4b9c-aa8d-cd8c801ddbe0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":543,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:23:39
41797	9d6ccf6b-13b0-429b-b2cb-1f84e6efe135	9d6ccf6b-33b5-4a5e-baa4-64cc04f44746	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:23:39
41798	9d6ccf6b-2da1-481a-a78d-278d6fc429bc	9d6ccf6b-33b5-4a5e-baa4-64cc04f44746	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"48.08","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:23:39
41799	9d6ccf6b-3228-4894-92bc-a5c2269215bf	9d6ccf6b-33b5-4a5e-baa4-64cc04f44746	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:23:39
41800	9d6ccf6b-328c-4ed6-8471-4658d5cc1ecd	9d6ccf6b-33b5-4a5e-baa4-64cc04f44746	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":301,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:23:39
39726	9d6be27d-b5fe-4c7b-a854-2e458ccf24a3	9d6be27d-fc88-4d0a-bd58-1e409a0e1f49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-05 23:21:09
39727	9d6be27d-fb0f-4f65-825d-457200244b52	9d6be27d-fc88-4d0a-bd58-1e409a0e1f49	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 23:21:09
39728	9d6be27d-fba2-48d5-ba3d-32118697f5f4	9d6be27d-fc88-4d0a-bd58-1e409a0e1f49	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":341,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:21:09
39729	9d6be27f-5106-4c5c-89ba-8307b2b854c3	9d6be27f-990d-4f9b-aa52-c8386034c53a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-05 23:21:10
39730	9d6be27f-947a-423c-bad1-d1a4cb6f3861	9d6be27f-990d-4f9b-aa52-c8386034c53a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"155.37","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 23:21:10
39731	9d6be27f-94d4-4f70-8a6e-47f3c76dc18f	9d6be27f-990d-4f9b-aa52-c8386034c53a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 23:21:10
39732	9d6be27f-97e7-4643-b0e6-b0cd43ac091d	9d6be27f-990d-4f9b-aa52-c8386034c53a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-05 23:21:10
39733	9d6be27f-9827-4f0f-ab23-aa4fa6c723e3	9d6be27f-990d-4f9b-aa52-c8386034c53a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":445,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:21:10
42028	9d6cd3a9-cb10-4c47-9092-c18c4b51d9be	9d6cd3aa-113a-4106-97f9-872bc2507368	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:35:31
42029	9d6cd3aa-0f81-4e42-b734-e8fceca75dd2	9d6cd3aa-113a-4106-97f9-872bc2507368	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:35:31
42030	9d6cd3aa-102a-4338-9750-8159a7cff282	9d6cd3aa-113a-4106-97f9-872bc2507368	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":387,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:35:31
8548	9d52ed4b-1106-4d96-98f9-560b669fa056	9d52ed4b-1386-40bb-a651-4feae3a56063	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":414}	2024-10-24 13:35:39
42031	9d6cd3ab-65ea-484c-aa52-6df560b8b1fa	9d6cd3ab-a878-4335-881c-25fe1ce4221a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:35:32
42032	9d6cd3ab-a07b-4bad-910a-cb4a10b2aec2	9d6cd3ab-a878-4335-881c-25fe1ce4221a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"67.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:35:32
42033	9d6cd3ab-a0f9-444c-af68-e25cbdd2f60a	9d6cd3ab-a878-4335-881c-25fe1ce4221a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:35:32
42034	9d6cd3ab-a6b6-42a7-9ed3-4681ea000216	9d6cd3ab-a878-4335-881c-25fe1ce4221a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:35:32
42035	9d6cd3ab-a72c-4513-9c7b-4001e9c40b4e	9d6cd3ab-a878-4335-881c-25fe1ce4221a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":442,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:35:32
42036	9d6cd3ab-f474-4e07-b4d7-58dbdcd73f56	9d6cd3ac-1149-4613-bf6d-22cfd3428b4a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:35:32
42037	9d6cd3ac-0c64-41f3-8db5-72c0f3cb9cb5	9d6cd3ac-1149-4613-bf6d-22cfd3428b4a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"40.48","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:35:32
42038	9d6cd3ac-0fc5-4aba-a335-170e4522b87a	9d6cd3ac-1149-4613-bf6d-22cfd3428b4a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:35:32
42039	9d6cd3ac-102d-48ae-9daf-0094e7817107	9d6cd3ac-1149-4613-bf6d-22cfd3428b4a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":252,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:35:32
35553	9d69c4f4-279d-454b-a7d2-45be033205f8	9d69c4f4-5f6b-4157-9105-454e7a1e6231	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-04 22:06:54
35554	9d69c4f4-5d27-4283-9706-6204073f4080	9d69c4f4-5f6b-4157-9105-454e7a1e6231	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-04 22:06:54
35555	9d69c4f4-5df6-46da-9c49-01a21fff14c9	9d69c4f4-5f6b-4157-9105-454e7a1e6231	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":462,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:06:54
35556	9d69c4f5-0309-43c1-b953-dd87193f9708	9d69c4f5-5a08-45fe-9fcb-2a6d1ea94338	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-04 22:06:55
35557	9d69c4f5-516a-424a-8f32-e925f397269d	9d69c4f5-5a08-45fe-9fcb-2a6d1ea94338	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"170.04","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":69,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-04 22:06:55
35558	9d69c4f5-57b0-4a2e-9437-5ec2b6c9cced	9d69c4f5-5a08-45fe-9fcb-2a6d1ea94338	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-04 22:06:55
35559	9d69c4f5-586e-461b-a539-50b063d96936	9d69c4f5-5a08-45fe-9fcb-2a6d1ea94338	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"14","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"30","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-2","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-19","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-26","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":536,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:06:55
35560	9d69c4f5-cafe-4d3d-aa51-86c93b4a4e2c	9d69c4f5-f980-40d0-a4ad-f2c6fc5980c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-04 22:06:55
35561	9d69c4f5-f01c-45d5-be15-28be95adcf12	9d69c4f5-f980-40d0-a4ad-f2c6fc5980c4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"58.09","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:06:55
35562	9d69c4f5-f0a3-4dd4-95dd-faddedef8452	9d69c4f5-f980-40d0-a4ad-f2c6fc5980c4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:06:55
35563	9d69c4f5-f737-4259-981a-51654344a61f	9d69c4f5-f980-40d0-a4ad-f2c6fc5980c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-11-04 22:06:55
35564	9d69c4f5-f7c2-4015-a6a9-d10bb26568d7	9d69c4f5-f980-40d0-a4ad-f2c6fc5980c4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":378,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:06:55
35565	9d69c4f6-9bc5-4238-8237-543a6d73574e	9d69c4f6-e756-47df-a3f0-5e4f27595f8b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-11-04 22:06:56
35566	9d69c4f6-dbc4-4077-84c3-75fe7a01a57c	9d69c4f6-e756-47df-a3f0-5e4f27595f8b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"122.88","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:06:56
35567	9d69c4f6-dc63-4ce8-8ca0-82a755ef840f	9d69c4f6-e756-47df-a3f0-5e4f27595f8b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:06:56
35568	9d69c4f6-e515-451c-a86c-88d80f238052	9d69c4f6-e756-47df-a3f0-5e4f27595f8b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-11-04 22:06:56
35569	9d69c4f6-e5c8-4d6c-a080-03ef6cd7e5f1	9d69c4f6-e756-47df-a3f0-5e4f27595f8b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":575,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:06:56
35570	9d69c4f7-d261-4b25-b649-6bc10527423a	9d69c4f8-084a-47c5-a74e-0f765873918c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-11-04 22:06:57
35571	9d69c4f7-ff07-4d71-8f7a-f7354be116c4	9d69c4f8-084a-47c5-a74e-0f765873918c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"65.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-04 22:06:57
35572	9d69c4f7-ffc2-42c4-9e55-158c3109cdab	9d69c4f8-084a-47c5-a74e-0f765873918c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-04 22:06:57
35573	9d69c4f8-0635-4d3d-9fa6-61e04d267adc	9d69c4f8-084a-47c5-a74e-0f765873918c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-11-04 22:06:57
35574	9d69c4f8-06cf-4839-a727-9e6338f77d51	9d69c4f8-084a-47c5-a74e-0f765873918c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":651,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:06:57
39809	9d6cb655-5f77-4ce4-bb85-b2475e71c13a	9d6cb655-a6e4-4e3b-96da-495acddfd330	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 09:13:30
39810	9d6cb655-a53f-485f-96e4-cf8b430dbb71	9d6cb655-a6e4-4e3b-96da-495acddfd330	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 09:13:30
39811	9d6cb655-a5da-4d3c-af0c-79f6a867cc01	9d6cb655-a6e4-4e3b-96da-495acddfd330	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:13:30
39812	9d6cb656-56dc-43cb-bbcc-7980aecb8509	9d6cb656-a087-4896-9fe9-b17ee0138839	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 09:13:31
39813	9d6cb656-9b8e-423e-88a4-d0e4c0e9fd55	9d6cb656-a087-4896-9fe9-b17ee0138839	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"154.93","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:13:31
39814	9d6cb656-9c03-416b-b848-ac649ccccb7a	9d6cb656-a087-4896-9fe9-b17ee0138839	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:13:31
39815	9d6cb656-9f4c-4c96-971b-e9e3b685a36b	9d6cb656-a087-4896-9fe9-b17ee0138839	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 09:13:31
39816	9d6cb656-9f96-4ba4-b9d2-61a16b227c66	9d6cb656-a087-4896-9fe9-b17ee0138839	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":352,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:13:31
42396	9d6cddd7-6c8e-4c64-b46e-f4ccdfb1b029	9d6cddd7-b672-473d-89af-915a79e1c83e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 11:03:59
42397	9d6cddd7-b4b5-4d63-81bd-c7607f424ae3	9d6cddd7-b672-473d-89af-915a79e1c83e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 11:03:59
42398	9d6cddd7-b55d-4887-b89c-3e0f2a25cd9c	9d6cddd7-b672-473d-89af-915a79e1c83e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":360,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:03:59
42953	9d6ce30b-38fc-4bf7-a151-6a051ade0a52	9d6ce30b-3cf3-460f-8574-0bc754ee6a5b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1971}	2024-11-06 11:18:31
43194	9d6ce544-04e2-4372-acb6-89ed36e92ba7	9d6ce544-0832-4b44-ad53-12ff742d6a34	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2001}	2024-11-06 11:24:44
40105	9d6cc106-022c-406a-8c84-532f69012357	9d6cc106-1e34-458d-bb4e-0f4d0d8d5a05	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:43:24
40106	9d6cc106-1c6a-4edf-a5d1-21777dad9d81	9d6cc106-1e34-458d-bb4e-0f4d0d8d5a05	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:43:24
40107	9d6cc106-1d40-49ca-8abd-4b7a971d2ac0	9d6cc106-1e34-458d-bb4e-0f4d0d8d5a05	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":261,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:43:24
32743	9d6989a6-8e3d-4837-b13b-50266f403184	9d6989a6-94a8-48e1-b77d-8f2a6695febc	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1541}	2024-11-04 19:21:05
40108	9d6cc107-2c3c-4c28-a77b-078848e6abf1	9d6cc107-4ba6-410b-9979-2a49be39d1ad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:43:25
40109	9d6cc107-4638-4cc1-a50a-6e5f0eb346a1	9d6cc107-4ba6-410b-9979-2a49be39d1ad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"43.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:43:25
40110	9d6cc107-468a-411c-91e3-e142868e42c5	9d6cc107-4ba6-410b-9979-2a49be39d1ad	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:43:25
40111	9d6cc107-4a43-4a04-8a1e-fc23579e223e	9d6cc107-4ba6-410b-9979-2a49be39d1ad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:43:25
40112	9d6cc107-4a8d-418b-a3db-3c93cd2c8466	9d6cc107-4ba6-410b-9979-2a49be39d1ad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:43:25
40113	9d6cc107-89da-48bb-be86-9d9160c81724	9d6cc107-a2c8-44d5-8a73-2c48e819ffdc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:43:25
40114	9d6cc107-9ea3-4b6f-b89b-5466f4c5a4da	9d6cc107-a2c8-44d5-8a73-2c48e819ffdc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"41.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:43:25
40115	9d6cc107-a182-4e2c-a0ef-a98aa6206b90	9d6cc107-a2c8-44d5-8a73-2c48e819ffdc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:43:25
40116	9d6cc107-a1d4-4640-bcc8-7edb0b0e57e7	9d6cc107-a2c8-44d5-8a73-2c48e819ffdc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":209,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:43:25
37908	9d6b5d8b-3048-4bed-a27a-8adcd27c247d	9d6b5d8b-77e2-4366-a831-af12dfcc7065	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 17:09:24
37909	9d6b5d8b-762b-47b7-9590-454bb0b6f421	9d6b5d8b-77e2-4366-a831-af12dfcc7065	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 17:09:24
37910	9d6b5d8b-76e0-4007-821b-0f0e13a0ce58	9d6b5d8b-77e2-4366-a831-af12dfcc7065	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":353,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:09:24
37911	9d6b5d8b-d6c0-4732-a483-b0bf6e8b6dae	9d6b5d8b-f709-4537-b909-65af687adaa4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 17:09:25
37912	9d6b5d8b-f157-4ccc-a0e4-5c220cb3ccfc	9d6b5d8b-f709-4537-b909-65af687adaa4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"48.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:09:25
37913	9d6b5d8b-f542-419b-aa63-e612d8154f7d	9d6b5d8b-f709-4537-b909-65af687adaa4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 17:09:25
37914	9d6b5d8b-f5d6-42f8-a8fe-d98311680125	9d6b5d8b-f709-4537-b909-65af687adaa4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:09:25
40117	9d6cc11d-9501-4d4b-8ece-231008d76885	9d6cc11d-9bcd-4b84-9701-9230b9077849	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":249,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:43:39
37915	9d6b5d8c-5099-460e-802f-c41296a0f40e	9d6b5d8c-9803-4921-8e71-7e3a3d87db73	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 17:09:25
37916	9d6b5d8c-9314-4006-a3d1-c601b50173a4	9d6b5d8c-9803-4921-8e71-7e3a3d87db73	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"145.14","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:09:25
37917	9d6b5d8c-935e-4020-b45d-9aa11cd80066	9d6b5d8c-9803-4921-8e71-7e3a3d87db73	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:09:25
37918	9d6b5d8c-96b7-4458-ae17-83388a514c45	9d6b5d8c-9803-4921-8e71-7e3a3d87db73	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 17:09:25
37919	9d6b5d8c-96f9-488c-9c02-9af1a2e1e46f	9d6b5d8c-9803-4921-8e71-7e3a3d87db73	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":402,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:09:25
40118	9d6cc11e-3436-46bb-9feb-5430024753f5	9d6cc11e-f698-41eb-942a-9046bdb0523a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:43:40
40119	9d6cc11e-edb6-4ac3-a1a2-f893fef45334	9d6cc11e-f698-41eb-942a-9046bdb0523a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"49.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 09:43:40
40120	9d6cc11e-ee30-4bfd-85a0-cc79d4b95b1f	9d6cc11e-f698-41eb-942a-9046bdb0523a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 09:43:40
40121	9d6cc11e-f4c5-4447-91e1-694827203c47	9d6cc11e-f698-41eb-942a-9046bdb0523a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:43:40
40122	9d6cc11e-f543-4465-b194-a9a093377bae	9d6cc11e-f698-41eb-942a-9046bdb0523a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":809,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:43:40
37920	9d6b5d8c-dd1b-4ba8-877f-2adb0835e261	9d6b5d8d-2300-4a6b-a3d8-4d3b5554f089	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 17:09:25
37921	9d6b5d8d-1dc3-481c-9aa7-8d6a096944ad	9d6b5d8d-2300-4a6b-a3d8-4d3b5554f089	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"144.12","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 17:09:25
37922	9d6b5d8d-1e19-42fb-8d03-25b74d02e232	9d6b5d8d-2300-4a6b-a3d8-4d3b5554f089	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 17:09:25
37923	9d6b5d8d-21b7-49fb-b25f-8fa81cbb8e4f	9d6b5d8d-2300-4a6b-a3d8-4d3b5554f089	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 17:09:25
37924	9d6b5d8d-2208-4265-8073-971c50955340	9d6b5d8d-2300-4a6b-a3d8-4d3b5554f089	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":342,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:09:25
40123	9d6cc11f-4b67-455e-ae6c-f3396a13978d	9d6cc11f-9a01-4026-a67d-844a1ae70f42	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:43:40
40124	9d6cc11f-929c-4f74-bd00-f0c4d4373902	9d6cc11f-9a01-4026-a67d-844a1ae70f42	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"159.70","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 09:43:41
40125	9d6cc11f-92fe-4bed-8239-0ca0690d23c9	9d6cc11f-9a01-4026-a67d-844a1ae70f42	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 09:43:41
40126	9d6cc11f-9896-4383-8095-f37508bd348c	9d6cc11f-9a01-4026-a67d-844a1ae70f42	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 09:43:41
40127	9d6cc11f-98fd-404c-8bc8-410802ed5a89	9d6cc11f-9a01-4026-a67d-844a1ae70f42	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":399,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:43:41
37925	9d6b5d8e-f20a-446d-9837-6f75aedd68cf	9d6b5d8f-3a3e-4e38-a67e-42399702d5d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 17:09:27
37926	9d6b5d8f-34b4-4a99-a024-69fa1b0ed5c8	9d6b5d8f-3a3e-4e38-a67e-42399702d5d9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"150.20","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 17:09:27
37927	9d6b5d8f-3504-4348-a55b-df251b2750a6	9d6b5d8f-3a3e-4e38-a67e-42399702d5d9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 17:09:27
37928	9d6b5d8f-38ec-47c5-ae52-a0a7ff7e1989	9d6b5d8f-3a3e-4e38-a67e-42399702d5d9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 17:09:27
37929	9d6b5d8f-3931-41ad-ba00-d138521d7e33	9d6b5d8f-3a3e-4e38-a67e-42399702d5d9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":499,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:09:27
40128	9d6cc11f-e396-4351-9391-e97622d157cb	9d6cc120-0fd3-4c18-86eb-89ee697f21ad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 09:43:41
40129	9d6cc120-0bb7-4b48-9c49-b82998bbd613	9d6cc120-0fd3-4c18-86eb-89ee697f21ad	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"58.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 09:43:41
40130	9d6cc120-0e7a-4bff-b96d-19cd14855028	9d6cc120-0fd3-4c18-86eb-89ee697f21ad	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 09:43:41
40131	9d6cc120-0ee6-4fb4-9c34-f766fe7178e4	9d6cc120-0fd3-4c18-86eb-89ee697f21ad	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":285,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:43:41
43408	9d6ce763-b1e8-494a-89ab-78634e92594b	9d6ce763-f674-4606-848c-fa41e1391c08	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 11:30:40
43409	9d6ce763-f4c1-4e5e-9605-7538167ef4d9	9d6ce763-f674-4606-848c-fa41e1391c08	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 11:30:41
43410	9d6ce763-f56e-4b9c-8d6f-be960ab6a663	9d6ce763-f674-4606-848c-fa41e1391c08	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":349,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:30:41
43411	9d6ce764-6244-4825-b752-df22e382b10d	9d6ce764-8056-447f-8536-8e7af0ce0b24	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 11:30:41
43412	9d6ce764-7a7c-466a-84a1-597d8883b50e	9d6ce764-8056-447f-8536-8e7af0ce0b24	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"id\\", \\"name\\", \\"profile_code\\", \\"remember_token\\", \\"user_address\\", \\"user_age\\", \\"user_alias\\", \\"user_birth\\", \\"user_cellphone\\", \\"user_city\\", \\"user_document\\", \\"user_document_type\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_neighborhood\\" from \\"users\\" where \\"profile_code\\" = '4'","time":"45.52","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":159,"hash":"6102b4b26f332fae7602f55df2f9d07b","hostname":"EderCortes"}	2024-11-06 11:30:41
43413	9d6ce764-7ea9-4038-9696-5964e72e6dcc	9d6ce764-8056-447f-8536-8e7af0ce0b24	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 11:30:41
43414	9d6ce764-7f1b-4910-9ea4-4fb888614021	9d6ce764-8056-447f-8536-8e7af0ce0b24	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/showCobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@showCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","profile_code":4,"remember_token":null,"user_address":"Calle 750","user_age":"31","user_alias":"luis_martinez","user_birth":"1992-11-12T04:00:00.000Z","user_cellphone":"312596295","user_city":"Cali","user_document":"100465545","user_document_type":"CC","user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_neighborhood":"Bonilla aragon"}]},"duration":260,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:30:41
43415	9d6ce766-3bad-4e67-80a3-bfd719d3c2d3	9d6ce766-642c-4291-85ac-54722cc357ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 11:30:42
43241	9d6ce5b0-c1ca-474a-9573-ddf5020a54d0	9d6ce5b1-024e-4b73-bfb9-073c9bf01dc6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 11:25:55
43242	9d6ce5b1-00be-4a5a-8928-7db9fa587fcd	9d6ce5b1-024e-4b73-bfb9-073c9bf01dc6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 11:25:56
43243	9d6ce5b1-0162-407e-a64f-829c89c4880f	9d6ce5b1-024e-4b73-bfb9-073c9bf01dc6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":324,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:25:56
43416	9d6ce766-5e98-446b-9b27-6fca54107f97	9d6ce766-642c-4291-85ac-54722cc357ca	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"52.43","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:30:42
43417	9d6ce766-5eea-482d-b202-177e3099d787	9d6ce766-642c-4291-85ac-54722cc357ca	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:30:42
43418	9d6ce766-62ac-4307-9d1b-f514e7712143	9d6ce766-642c-4291-85ac-54722cc357ca	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 11:30:42
43419	9d6ce766-6300-47d4-9442-eedcb367d87a	9d6ce766-642c-4291-85ac-54722cc357ca	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":485,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:30:42
43244	9d6ce5b1-5e0f-4609-a3f8-ec0e057126f5	9d6ce5b1-7919-42eb-a609-59d011bd85e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 11:25:56
43245	9d6ce5b1-7476-40d2-bd46-f6eb04e295d3	9d6ce5b1-7919-42eb-a609-59d011bd85e1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT id,\\n                            name,\\n                            profile_code,\\n                            remember_token,\\n                            user_address,\\n                            user_age,\\n                            user_alias,\\n                            user_birth,\\n                            user_cellphone,\\n                            user_city,\\n                            user_document,\\n                            user_document_type,\\n                            user_last_name_one,\\n                            user_last_name_two,\\n                            user_neighborhood\\n                        FROM users\\n                        WHERE profile_code = 4;\\n                            ","time":"44.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":142,"hash":"e2980c10c70608ca75f9c2180abc54e1","hostname":"EderCortes"}	2024-11-06 11:25:56
43246	9d6ce5b1-77cd-434e-a6c1-50a702c5dad6	9d6ce5b1-7919-42eb-a609-59d011bd85e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 11:25:56
43247	9d6ce5b1-7812-44ef-8b34-0d777be3b433	9d6ce5b1-7919-42eb-a609-59d011bd85e1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/showCobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@showCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":14,"name":"Luis andre","profile_code":4,"remember_token":null,"user_address":"Calle 750","user_age":"31","user_alias":"luis_martinez","user_birth":"1992-11-12T04:00:00.000Z","user_cellphone":"312596295","user_city":"Cali","user_document":"100465545","user_document_type":"CC","user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_neighborhood":"Bonilla aragon"}},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:25:56
43420	9d6ce766-a512-4e0a-9fe3-2703233173a5	9d6ce766-bdbb-4129-b58a-6beae8637f3b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 11:30:42
43421	9d6ce766-b9b8-4f99-a0f5-4eee52ec603a	9d6ce766-bdbb-4129-b58a-6beae8637f3b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"40.86","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:30:42
43422	9d6ce766-bc7b-4132-835b-4355825b46d7	9d6ce766-bdbb-4129-b58a-6beae8637f3b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 11:30:42
43423	9d6ce766-bcc2-4504-8147-dcc2f6bdcb19	9d6ce766-bdbb-4129-b58a-6beae8637f3b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":216,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:30:42
43248	9d6ce5b3-3fa5-4b38-bfa9-dc3bb5f22288	9d6ce5b3-6235-454f-b87a-b17b3a4ff114	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 11:25:57
43249	9d6ce5b3-5c71-49a3-8497-4df61433e565	9d6ce5b3-6235-454f-b87a-b17b3a4ff114	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"52.96","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:25:57
43250	9d6ce5b3-5cc6-4716-adb7-4938839d750c	9d6ce5b3-6235-454f-b87a-b17b3a4ff114	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:25:57
43251	9d6ce5b3-60a0-44d0-960c-109917e0ba14	9d6ce5b3-6235-454f-b87a-b17b3a4ff114	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 11:25:57
43252	9d6ce5b3-6113-4250-b90d-38236d2276c2	9d6ce5b3-6235-454f-b87a-b17b3a4ff114	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":423,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:25:57
43253	9d6ce5b3-b6ed-4ac8-a9fa-2e3d400d6c0e	9d6ce5b3-d7dd-4476-84d4-40e213cea42b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 11:25:57
43254	9d6ce5b3-d1db-44f7-a7fa-f15065a3cb19	9d6ce5b3-d7dd-4476-84d4-40e213cea42b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"52.47","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:25:57
43255	9d6ce5b3-d687-41ed-b074-13a37906b270	9d6ce5b3-d7dd-4476-84d4-40e213cea42b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 11:25:57
43256	9d6ce5b3-d6df-4a6a-9b2b-4686064e5280	9d6ce5b3-d7dd-4476-84d4-40e213cea42b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":286,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:25:57
40419	9d6cc32b-a3dd-4c2f-ac98-19194185c94c	9d6cc32b-e94e-403b-b572-7995461a42d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:49:24
40420	9d6cc32b-e7c0-4c28-9b07-bac051f6f30d	9d6cc32b-e94e-403b-b572-7995461a42d6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 09:49:24
40421	9d6cc32b-e863-4307-9607-9b125afec772	9d6cc32b-e94e-403b-b572-7995461a42d6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":323,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:49:24
1806	9d50df2f-8f52-43c5-b4c2-e2296e09ec53	9d50df2f-9229-4065-a4d6-314936dba548	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":117}	2024-10-23 13:04:33
40422	9d6cc32c-98c5-4586-bbe5-bcb6ad3ce1b9	9d6cc32c-b5e7-427e-bcee-82ab859c1732	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 09:49:25
40423	9d6cc32c-b0d2-4066-892f-ff0da1b82bda	9d6cc32c-b5e7-427e-bcee-82ab859c1732	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"38.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:49:25
40424	9d6cc32c-b11f-4f49-ad0a-3276b0e28a27	9d6cc32c-b5e7-427e-bcee-82ab859c1732	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:49:25
40425	9d6cc32c-b4a1-486f-a9d9-550e11cf49bb	9d6cc32c-b5e7-427e-bcee-82ab859c1732	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 09:49:25
40426	9d6cc32c-b4f4-491d-b8ea-3f182b505525	9d6cc32c-b5e7-427e-bcee-82ab859c1732	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:49:25
40427	9d6cc32d-0f7b-4c11-b56b-adc75977d8df	9d6cc32d-284a-40cd-b6ad-d26f7b96354e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 09:49:25
40428	9d6cc32d-2407-4a80-96ed-39f130382388	9d6cc32d-284a-40cd-b6ad-d26f7b96354e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"39.38","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:49:25
40429	9d6cc32d-270b-4508-98b0-ec36e7f7a99e	9d6cc32d-284a-40cd-b6ad-d26f7b96354e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 09:49:25
40430	9d6cc32d-2756-4c8f-ad33-5e84bfc3f6f8	9d6cc32d-284a-40cd-b6ad-d26f7b96354e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:49:25
3389	9d510522-e78a-4724-bccf-c7b24e0468fd	9d510522-ec7f-4dfb-a61f-9dea1cd60993	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":190}	2024-10-23 14:50:40
40487	9d6cc3d1-eb52-452b-b59c-77717e733f9f	9d6cc3d2-0a15-457c-aa7c-73563e2fe650	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 09:51:13
40488	9d6cc3d2-0837-43ef-9319-6573b6c66715	9d6cc3d2-0a15-457c-aa7c-73563e2fe650	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 09:51:13
40489	9d6cc3d2-08e0-46ee-b273-4461520de84a	9d6cc3d2-0a15-457c-aa7c-73563e2fe650	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:51:13
40490	9d6cc3d2-c3a0-4937-8647-dd5868beb551	9d6cc3d3-0e74-4a17-9291-9c5d0dd4a8e6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 09:51:13
40491	9d6cc3d3-08a6-4f4e-a96d-b5eb235e79bd	9d6cc3d3-0e74-4a17-9291-9c5d0dd4a8e6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"156.02","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:51:14
40492	9d6cc3d3-0908-4508-a05f-3ef47528a18f	9d6cc3d3-0e74-4a17-9291-9c5d0dd4a8e6	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:51:14
40493	9d6cc3d3-0d11-4410-b505-a889fb377aba	9d6cc3d3-0e74-4a17-9291-9c5d0dd4a8e6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 09:51:14
40494	9d6cc3d3-0d64-4368-8321-a5b97a635c2a	9d6cc3d3-0e74-4a17-9291-9c5d0dd4a8e6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":388,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:51:14
40495	9d6cc3d3-57ff-4398-a8c0-d6c3877d8c29	9d6cc3d3-71fc-451c-9eb2-559f2b180597	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 09:51:14
40496	9d6cc3d3-6da7-4bb8-9fcf-89847b049c9f	9d6cc3d3-71fc-451c-9eb2-559f2b180597	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"41.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:51:14
40497	9d6cc3d3-70be-4e17-8407-21721a0d6a60	9d6cc3d3-71fc-451c-9eb2-559f2b180597	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 09:51:14
40498	9d6cc3d3-710c-4cf8-a484-e5aae610765a	9d6cc3d3-71fc-451c-9eb2-559f2b180597	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:51:14
38450	9d6b64e4-5db1-4585-bf78-189a4534bd3f	9d6b64e4-84c8-4b9a-b65a-0b7687d2b0ab	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-05 17:29:57
38451	9d6b64e4-829c-44d7-b1b0-e8c550d7565f	9d6b64e4-84c8-4b9a-b65a-0b7687d2b0ab	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:29:57
38452	9d6b64e4-8364-4323-9584-b0f2ed8def1a	9d6b64e4-84c8-4b9a-b65a-0b7687d2b0ab	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":296,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:29:57
38453	9d6b64e4-f938-4b2a-8bf9-05b3886ba7f9	9d6b64e5-1b46-4c84-a303-7acc997d0e3c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-05 17:29:57
38454	9d6b64e5-1582-43db-af1f-1053fc97c8da	9d6b64e5-1b46-4c84-a303-7acc997d0e3c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"47.90","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":70,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-05 17:29:57
38455	9d6b64e5-19d3-464e-8acb-b4d4955d95b9	9d6b64e5-1b46-4c84-a303-7acc997d0e3c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-05 17:29:57
38456	9d6b64e5-1a3e-4104-9c99-c4429ad6235e	9d6b64e5-1b46-4c84-a303-7acc997d0e3c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"7","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"13","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"29","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-3","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"4","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-20","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-5","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-27","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":316,"memory":22,"hostname":"EderCortes"}	2024-11-05 17:29:57
35168	9d69c2e3-16d6-47c4-be5f-aab562589dc2	9d69c2e3-1993-4da0-b719-2dd786bec6d3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1594}	2024-11-04 22:01:07
41295	9d6ccc39-a4bf-4e65-9854-53a98476b91f	9d6ccc39-efe1-4776-94c6-dc7d2590f9b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 10:14:43
41296	9d6ccc39-ed03-4bfc-a377-3272a8dacc74	9d6ccc39-efe1-4776-94c6-dc7d2590f9b5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 10:14:43
41297	9d6ccc39-edbd-4657-a26f-2e1222cae5cc	9d6ccc39-efe1-4776-94c6-dc7d2590f9b5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":418,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:14:43
41298	9d6ccc3a-5ce9-47db-9623-85f143341895	9d6ccc3a-7a41-4424-857a-40f132874efb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 10:14:44
41299	9d6ccc3a-74d3-424f-ad12-25e566fe5893	9d6ccc3a-7a41-4424-857a-40f132874efb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"43.75","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 10:14:44
41300	9d6ccc3a-7862-4c43-8b13-c524e095a023	9d6ccc3a-7a41-4424-857a-40f132874efb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 10:14:44
41301	9d6ccc3a-7914-47ef-a09f-1d9644a18721	9d6ccc3a-7a41-4424-857a-40f132874efb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":262,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:14:44
41302	9d6ccc3a-cb36-492c-bed4-52b9e16b5da5	9d6ccc3b-12c2-4ac3-bebc-461338bfe247	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 10:14:44
41303	9d6ccc3b-0d63-4169-8ee6-bbe82b3fd229	9d6ccc3b-12c2-4ac3-bebc-461338bfe247	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"147.55","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:14:44
41304	9d6ccc3b-0de4-47ce-84f5-de7d741c0189	9d6ccc3b-12c2-4ac3-bebc-461338bfe247	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:14:44
41305	9d6ccc3b-115c-4e9b-9ccd-a5ed5779b3f1	9d6ccc3b-12c2-4ac3-bebc-461338bfe247	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 10:14:44
41306	9d6ccc3b-11a8-4e9b-8daa-5d4ca1ed96a6	9d6ccc3b-12c2-4ac3-bebc-461338bfe247	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":380,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:14:44
41307	9d6ccc3b-56d7-4315-98b3-05a6b23b871d	9d6ccc3b-7701-48ea-9e09-026591f7ebc4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 10:14:44
41308	9d6ccc3b-6fdf-4bf9-894f-1d0bfd7cbda7	9d6ccc3b-7701-48ea-9e09-026591f7ebc4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"42.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:14:44
41309	9d6ccc3b-705d-4fe9-a870-4e5d716e5cf8	9d6ccc3b-7701-48ea-9e09-026591f7ebc4	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:14:44
41310	9d6ccc3b-7494-46e7-85d7-d8421a8748fa	9d6ccc3b-7701-48ea-9e09-026591f7ebc4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 10:14:44
41311	9d6ccc3b-751e-4815-b8ef-0941155bf566	9d6ccc3b-7701-48ea-9e09-026591f7ebc4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":240,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:14:44
41312	9d6ccc3d-3ba1-4df8-95e2-8db4edc43b99	9d6ccc3d-6244-4532-90a6-a25886d4533f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 10:14:45
41313	9d6ccc3d-59c2-4cf4-b67b-dbba627e1f0a	9d6ccc3d-6244-4532-90a6-a25886d4533f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"51.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:14:46
41314	9d6ccc3d-5a20-4e56-8c53-bcf10b1f4408	9d6ccc3d-6244-4532-90a6-a25886d4533f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:14:46
41315	9d6ccc3d-6049-44f2-bf2d-2f92846cc8eb	9d6ccc3d-6244-4532-90a6-a25886d4533f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 10:14:46
41316	9d6ccc3d-60be-42f1-baad-845045199a16	9d6ccc3d-6244-4532-90a6-a25886d4533f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":374,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:14:46
41317	9d6ccc3d-ca3a-4c7a-b114-c40b75810cca	9d6ccc3d-ed5f-4aa5-8e54-62199871b7f1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 10:14:46
41318	9d6ccc3d-e721-4ffd-b097-501c3356d62a	9d6ccc3d-ed5f-4aa5-8e54-62199871b7f1	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"56.79","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:14:46
41319	9d6ccc3d-ebd9-4bdc-9449-69ba7686be2f	9d6ccc3d-ed5f-4aa5-8e54-62199871b7f1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-06 10:14:46
41320	9d6ccc3d-ec3b-4116-93b5-6c34da3da790	9d6ccc3d-ed5f-4aa5-8e54-62199871b7f1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":332,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:14:46
41321	9d6ccc3e-5f77-47a9-867d-b74debaa43ee	9d6ccc3e-643d-47da-bce5-f676ac9e20ce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":266,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:14:46
41322	9d6ccc3f-1aca-47ac-828b-bb3bdb70b279	9d6ccc3f-3aca-4d9b-b721-15f20dfa5213	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-06 10:14:47
41323	9d6ccc3f-3591-44e1-992e-c1a19caa9186	9d6ccc3f-3aca-4d9b-b721-15f20dfa5213	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"48.85","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 10:14:47
41324	9d6ccc3f-38fe-4357-9825-658ea16c4b5a	9d6ccc3f-3aca-4d9b-b721-15f20dfa5213	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-06 10:14:47
41325	9d6ccc3f-3977-48ba-8c6f-7d647ad75ca0	9d6ccc3f-3aca-4d9b-b721-15f20dfa5213	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":364,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:14:47
35033	9d69c168-bdc1-4442-9a9e-e0da80f71835	9d69c168-db27-4298-a092-34f63987a47e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-04 21:56:59
35034	9d69c168-d923-4871-b2c2-e0fad3dbf69d	9d69c168-db27-4298-a092-34f63987a47e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-04 21:57:00
35035	9d69c168-d9d7-4d21-ba47-985e7f091fad	9d69c168-db27-4298-a092-34f63987a47e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":237,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:57:00
40691	9d6cc68e-d008-4c2d-be8b-7ef7bd5b79e3	9d6cc68f-1b69-496b-bb5b-bd3b90cc9024	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 09:58:52
40692	9d6cc68f-199c-4b39-bbc3-43b93947dc7f	9d6cc68f-1b69-496b-bb5b-bd3b90cc9024	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:58:52
40693	9d6cc68f-1a66-46ba-b9db-5ffdf114fc08	9d6cc68f-1b69-496b-bb5b-bd3b90cc9024	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":463,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:58:52
40694	9d6cc690-afc7-4e40-b53a-bf4af86156d5	9d6cc690-dd0f-4136-8664-196af92ee8e2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 09:58:54
40695	9d6cc690-d39f-4cce-9d3f-aa84a363a94c	9d6cc690-dd0f-4136-8664-196af92ee8e2	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"59.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 09:58:54
40696	9d6cc690-d41d-4b0f-91b8-f42c043f8629	9d6cc690-dd0f-4136-8664-196af92ee8e2	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 09:58:54
40697	9d6cc690-db5f-4572-9c86-7a9739411783	9d6cc690-dd0f-4136-8664-196af92ee8e2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:58:54
40698	9d6cc690-dbca-48c3-be07-6bd03f6c37f7	9d6cc690-dd0f-4136-8664-196af92ee8e2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":389,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:58:54
40087	9d6cc0dc-babd-470b-92ae-811fe438cbca	9d6cc0dc-bdd5-4353-9215-4501ccb6c44f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1792}	2024-11-06 09:42:57
40699	9d6cc691-425d-4b05-964e-ef6c5081607d	9d6cc691-71ae-45e7-b415-79d7a5ccb137	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 09:58:54
40700	9d6cc691-6962-45c1-b3ed-d3e51dd11aef	9d6cc691-71ae-45e7-b415-79d7a5ccb137	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"79.19","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 09:58:54
40701	9d6cc691-6f99-4ef4-baaa-d21ad81bcfa0	9d6cc691-71ae-45e7-b415-79d7a5ccb137	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:58:54
40702	9d6cc691-7026-48f8-a0d9-5c8d69c2c586	9d6cc691-71ae-45e7-b415-79d7a5ccb137	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":353,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:58:54
40806	9d6cc7a5-771f-4f39-87f1-dc951805f94b	9d6cc7a5-c207-404e-8f36-a022d5350588	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:01:55
40807	9d6cc7a5-bfc9-423e-ad46-bc7690fae883	9d6cc7a5-c207-404e-8f36-a022d5350588	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 10:01:55
40808	9d6cc7a5-c0bb-4f27-962c-b880493b5596	9d6cc7a5-c207-404e-8f36-a022d5350588	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":396,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:01:55
40942	9d6cc8df-e477-462b-85eb-27e51ba3a55b	9d6cc8e0-0601-403a-b07e-0dea51a9e689	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:05:21
40943	9d6cc8e0-0474-4935-8b67-a72e92c66ffd	9d6cc8e0-0601-403a-b07e-0dea51a9e689	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:05:21
40944	9d6cc8e0-0506-4694-aa70-e17a83f9c7b2	9d6cc8e0-0601-403a-b07e-0dea51a9e689	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:05:21
5211	9d51370b-0628-48ee-a8ce-3e8e9c3ed7af	9d51370b-0bdf-4a52-87b4-2f6b9b63fc03	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":281}	2024-10-23 17:10:13
9848	9d56ad63-a3f2-4d86-bb12-4e2992552c7a	9d56ad63-a743-4635-a1c1-a4ef9418b1ce	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":467}	2024-10-26 10:20:17
41161	9d6ccbb8-9e02-4038-ad77-9449b7f8f26e	9d6ccbb8-e00f-4f96-be3c-d00373b865ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:13:19
41162	9d6ccbb8-dd29-4626-a90e-af6d25de5615	9d6ccbb8-e00f-4f96-be3c-d00373b865ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 10:13:19
41163	9d6ccbb8-de6c-489b-92d1-c49334a0c911	9d6ccbb8-e00f-4f96-be3c-d00373b865ba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":462,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:13:19
39489	9d6bdaff-9413-493b-90fe-03a6bfb7148b	9d6bdaff-b2fe-4dd3-a3ca-85fd3fef1c31	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-05 23:00:12
39490	9d6bdaff-b14a-4824-99a5-08fa5952fb1a	9d6bdaff-b2fe-4dd3-a3ca-85fd3fef1c31	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 23:00:12
39491	9d6bdaff-b1f4-4348-a8fe-346631bfaed3	9d6bdaff-b2fe-4dd3-a3ca-85fd3fef1c31	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":256,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:00:12
39492	9d6bdb00-1d53-46ad-a7f9-e347d2864084	9d6bdb00-617d-4fec-9e60-cd6a2289e408	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-05 23:00:12
39493	9d6bdb00-5c60-42b5-8b8f-1205dd5877cb	9d6bdb00-617d-4fec-9e60-cd6a2289e408	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                             order by l.id DESC\\n                        ","time":"146.21","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":26,"hash":"c5bcfcc751510d44b2d2132581392100","hostname":"EderCortes"}	2024-11-05 23:00:12
39494	9d6bdb00-5fed-48a5-b82f-b12157d4f64e	9d6bdb00-617d-4fec-9e60-cd6a2289e408	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 23:00:12
39495	9d6bdb00-607f-476d-8ae5-760697a50d42	9d6bdb00-617d-4fec-9e60-cd6a2289e408	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":11,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":100000,"loans_cuotas":3,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":null},{"id":10,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":9,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":8,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":7,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":6,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":5,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":4,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":3,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":2,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null},{"id":1,"loans_documento":100465545,"loans_nombre":"Luis andre","loans_apellido_uno":"Herrera","loans_fecha":"Thu Oct 24 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":null}]},"duration":334,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:00:12
39496	9d6bdb00-bb4c-4b5a-8615-0b47ad90ad50	9d6bdb00-da49-41b2-b72b-1b20eeb11904	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-05 23:00:13
39497	9d6bdb00-d4a4-4416-aefe-ffa8f531cc52	9d6bdb00-da49-41b2-b72b-1b20eeb11904	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"39.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 23:00:13
39498	9d6bdb00-d50c-4bc1-8778-65a557890655	9d6bdb00-da49-41b2-b72b-1b20eeb11904	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 23:00:13
39499	9d6bdb00-d90f-4f6c-a58e-85bc4fc29fea	9d6bdb00-da49-41b2-b72b-1b20eeb11904	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 23:00:13
39500	9d6bdb00-d953-4574-8b7e-4212525f0337	9d6bdb00-da49-41b2-b72b-1b20eeb11904	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":292,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:00:13
39501	9d6bdb01-22fd-4667-bcf7-d79db0420a33	9d6bdb01-43d3-469a-8002-f9e65474c49f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-05 23:00:13
39502	9d6bdb01-3e42-46f7-a87a-05d03679caf5	9d6bdb01-43d3-469a-8002-f9e65474c49f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-05 23:00:13
39503	9d6bdb01-3e9a-4fb9-a770-9365d0e40c43	9d6bdb01-43d3-469a-8002-f9e65474c49f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-05 23:00:13
39504	9d6bdb01-4270-445f-b135-f2ab2b26a0a7	9d6bdb01-43d3-469a-8002-f9e65474c49f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 23:00:13
39505	9d6bdb01-42b5-447d-88f1-3b1a7469e74f	9d6bdb01-43d3-469a-8002-f9e65474c49f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:00:13
39506	9d6bdb02-c9b4-4513-af1b-1b7185c3c68f	9d6bdb02-fdc8-4e2c-9701-faa6542ecbed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-05 23:00:14
39507	9d6bdb02-f60c-4d90-b4d2-4ca456433991	9d6bdb02-fdc8-4e2c-9701-faa6542ecbed	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"63.40","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-05 23:00:14
39508	9d6bdb02-f680-47df-89ca-79e7f903d111	9d6bdb02-fdc8-4e2c-9701-faa6542ecbed	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-05 23:00:14
39509	9d6bdb02-fbe4-455e-b8b6-81623a2b5e2b	9d6bdb02-fdc8-4e2c-9701-faa6542ecbed	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-05 23:00:14
39510	9d6bdb02-fc4b-4396-a993-df4adc26aef5	9d6bdb02-fdc8-4e2c-9701-faa6542ecbed	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":594,"memory":22,"hostname":"EderCortes"}	2024-11-05 23:00:14
35576	9d69c500-5ecf-4f87-8b90-c59f0bb8bad9	9d69c500-86cc-461d-af92-5f0ab2a8b6ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-11-04 22:07:02
35577	9d69c500-8493-4d65-813b-cb97bbdcda11	9d69c500-86cc-461d-af92-5f0ab2a8b6ef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-11-04 22:07:02
35578	9d69c500-8590-4546-9b11-c07cf35a3f30	9d69c500-86cc-461d-af92-5f0ab2a8b6ef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":323,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:07:02
6981	9d52d9a0-0902-4033-a263-7b8e95a8bfbc	9d52d9a0-0e38-4d81-a0ac-e9791d7d0558	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":354}	2024-10-24 12:40:40
41708	9d6ccef1-e8a1-49aa-8915-6f9a3d796994	9d6ccef1-ebed-4183-b9ae-f5d1ab9e8474	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1919}	2024-11-06 10:22:19
35579	9d69c500-e576-44a5-8e7b-31b39f34fd1f	9d69c501-31fc-4f63-b676-93f09f267cbf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-11-04 22:07:02
35580	9d69c501-2a49-4b6a-b2f8-5a8784a9d3aa	9d69c501-31fc-4f63-b676-93f09f267cbf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"153.18","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":253,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:07:03
35581	9d69c501-2adc-4a48-bfa5-85f5db1ebd37	9d69c501-31fc-4f63-b676-93f09f267cbf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:07:03
35582	9d69c501-306c-40ac-9bf5-c1c4e9a7fd25	9d69c501-31fc-4f63-b676-93f09f267cbf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":29,"hostname":"EderCortes"}	2024-11-04 22:07:03
35583	9d69c501-30e7-46d7-acdd-0be2d2ef5147	9d69c501-31fc-4f63-b676-93f09f267cbf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":367,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:07:03
31299	9d6949f8-43b0-4f4d-9164-622bb0d87750	9d6949f8-46eb-445f-9ca0-d612b9f32b5c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abas\\u00bb\\nLINE 1: select * from \\"item_loans\\".* as \\"u.user_alias\\" inner join \\"u...\\n                                     ^ (Connection: pgsql, SQL: select * from \\"item_loans\\".* as \\"u.user_alias\\" inner join \\"users\\" as \\"u\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"u\\".\\"id\\" where \\"loans_codigo\\" = 92 order by \\"item_loans\\".\\"id\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":305},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1489}	2024-11-04 16:23:01
35584	9d69c501-7bae-4e30-a96d-8f71659e7ddd	9d69c501-98e0-420a-9693-29534ae032d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":29,"hostname":"EderCortes"}	2024-11-04 22:07:03
35585	9d69c501-9403-4e47-9aac-654360a8bb1e	9d69c501-98e0-420a-9693-29534ae032d7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.69","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":242,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-04 22:07:03
35586	9d69c501-9458-4803-b701-9d4d58c71c1d	9d69c501-98e0-420a-9693-29534ae032d7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-04 22:07:03
35587	9d69c501-97ad-4994-bff7-e7afb854750b	9d69c501-98e0-420a-9693-29534ae032d7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":30,"hostname":"EderCortes"}	2024-11-04 22:07:03
35588	9d69c501-97f6-4956-930b-beced5aa2e7e	9d69c501-98e0-420a-9693-29534ae032d7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":4,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-04T22:13:53.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:07:03
35589	9d69c501-e47e-4e37-9eaa-131097a29d20	9d69c502-0aa4-4b60-9743-c122b686540d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":30,"hostname":"EderCortes"}	2024-11-04 22:07:03
35590	9d69c502-020a-4c18-87e0-3ed03d856346	9d69c502-0aa4-4b60-9743-c122b686540d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.97","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":191,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-04 22:07:03
35591	9d69c502-027f-46f4-a7b4-190fe6b1cb42	9d69c502-0aa4-4b60-9743-c122b686540d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-04 22:07:03
35592	9d69c502-08c9-4725-b30d-61453bbc843d	9d69c502-0aa4-4b60-9743-c122b686540d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":31,"hostname":"EderCortes"}	2024-11-04 22:07:03
35593	9d69c502-094c-4c4f-a8b2-7fe3d8d40c74	9d69c502-0aa4-4b60-9743-c122b686540d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":277,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:07:03
35598	9d69c503-952b-47a2-a2a0-122d5686be77	9d69c503-c600-4acb-b445-d4b648a4277f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":32,"hostname":"EderCortes"}	2024-11-04 22:07:04
40133	9d6cc120-567c-4c6c-ba1e-00fbe0f17608	9d6cc120-7319-4e01-97a4-c17d72a69734	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 09:43:41
40134	9d6cc120-71b3-4e6f-a3c7-477326bacada	9d6cc120-7319-4e01-97a4-c17d72a69734	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 09:43:41
40135	9d6cc120-7242-47d5-a76e-2ecc1d7ade5f	9d6cc120-7319-4e01-97a4-c17d72a69734	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":245,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:43:41
4030	9d511cc8-8940-4099-a664-772af193d915	9d511cc8-8cfb-43e5-a997-2362d0f2ec4d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":224}	2024-10-23 15:56:48
10005	9d56c6b3-35d4-4857-b96d-7dbdeffa373f	9d56c6b3-39df-4931-b912-9ed0f4a56ca3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":481}	2024-10-26 11:31:03
35052	9d69c16a-c80b-4ff2-9941-a7f07839e13b	9d69c16a-fb31-49e8-a984-568ce5793ddf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-04 21:57:01
35053	9d69c16a-f7de-4639-829f-5c0472f814b9	9d69c16a-fb31-49e8-a984-568ce5793ddf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-04 21:57:01
35054	9d69c16a-f984-4adb-aa90-646d222bda42	9d69c16a-fb31-49e8-a984-568ce5793ddf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":435,"memory":22,"hostname":"EderCortes"}	2024-11-04 21:57:01
40500	9d6cc3f1-04ba-4cbd-a6a6-6dc62890783e	9d6cc3f1-4c05-490d-8f00-7b61c099607d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 09:51:33
40501	9d6cc3f1-4a64-4b2d-951b-3d3754f1d3d4	9d6cc3f1-4c05-490d-8f00-7b61c099607d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 09:51:33
40502	9d6cc3f1-4b09-4bed-b92d-9ca5ceb320f8	9d6cc3f1-4c05-490d-8f00-7b61c099607d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":344,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:51:33
34866	9d69c0ce-401e-4717-82a9-1bb16ac890c8	9d69c0ce-4618-4f8d-a989-d95ebc641d4f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1576}	2024-11-04 21:55:18
4255	9d5129d5-2fa2-46f2-a854-a8ecc686483f	9d5129d5-32fd-448c-96ae-339b7945a595	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":234}	2024-10-23 16:33:17
41607	9d6ccddd-9240-4704-a851-318175a574d7	9d6ccddd-b018-48a9-b424-8d6e1960587d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:19:18
41608	9d6ccddd-ae82-4d75-8408-45857e19237a	9d6ccddd-b018-48a9-b424-8d6e1960587d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:19:18
41609	9d6ccddd-af1f-4ced-887b-c258611b12a7	9d6ccddd-b018-48a9-b424-8d6e1960587d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:19:18
16990	9d6546d0-da00-421f-994c-92d663ac61ee	9d6546d0-de2c-4ac5-895e-5d4a8f5b35b1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42P01]: Undefined table: 7 ERROR:  falta una entrada para la tabla \\u00abl\\u00bb en la cl\\u00e1usula FROM\\nLINE 1: select \\"l\\".\\"id\\", \\"loans\\".\\"loans_documento\\", \\"loans\\".\\"loans_n...\\n               ^ (Connection: pgsql, SQL: select \\"l\\".\\"id\\", \\"loans\\".\\"loans_documento\\", \\"loans\\".\\"loans_nombre\\", \\"loans\\".\\"loans_apellido_uno\\", \\"loans\\".\\"loans_fecha\\", \\"loans\\".\\"loans_valor_prestado\\", \\"loans\\".\\"loans_cuotas\\", \\"loans\\".\\"loans_estado\\", \\"loans\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" inner join \\"users\\" as \\"ucl\\" on \\"loans\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"loans\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"loans\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"loans\\".\\"id \\" desc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":42},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":794}	2024-11-02 16:30:53
36338	9d6b38d1-028c-4b5b-b892-ae7e8e1e10f8	9d6b38d1-06fb-4e67-b453-4f1872be1ec9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1643}	2024-11-05 15:26:42
41734	9d6ccf00-0d11-49a0-b4d0-c89060689cd3	9d6ccf00-5552-4a37-a0f9-b15f5153546d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:22:29
41735	9d6ccf00-53d4-4a0f-a4c2-abd9d4f9c22d	9d6ccf00-5552-4a37-a0f9-b15f5153546d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:22:29
41736	9d6ccf00-546a-4a69-a035-b926366f88cf	9d6ccf00-5552-4a37-a0f9-b15f5153546d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":344,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:22:29
37808	9d6b5c3e-bcf0-4ddd-93dd-2f78fb117adf	9d6b5c3e-bfd4-4209-8a09-63e0ab9cb573	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1700}	2024-11-05 17:05:46
16352	9d64c3b1-f3e6-4556-b36a-a707db57e0b9	9d64c3b1-f7c0-444b-aed4-eb00236666a4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":758}	2024-11-02 10:24:15
37428	9d6b4ad7-e4f3-442c-a52f-479123cedf56	9d6b4ad7-e977-4c29-b08f-b2bbef79227a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1690}	2024-11-05 16:17:07
41840	9d6ccfed-427b-4695-a96a-7494abcc1fdf	9d6ccfed-5b20-4326-930a-6d9e1abada42	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 10:25:04
41841	9d6ccfed-599a-412a-85bf-b5c9f0c5ec13	9d6ccfed-5b20-4326-930a-6d9e1abada42	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 10:25:04
41842	9d6ccfed-5a37-45e0-b284-507722756a9f	9d6ccfed-5b20-4326-930a-6d9e1abada42	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":219,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:25:04
41843	9d6ccfee-e1c7-4b69-a9ab-1c3052397dd7	9d6ccfef-07db-48d4-9e70-d50fa6d7bb4f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 10:25:05
41844	9d6ccfef-0219-45f2-a2f0-7606eeb9a20a	9d6ccfef-07db-48d4-9e70-d50fa6d7bb4f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"53.31","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:25:05
41845	9d6ccfef-027b-4998-8842-0962a87aada1	9d6ccfef-07db-48d4-9e70-d50fa6d7bb4f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:25:05
41846	9d6ccfef-0679-4925-942e-289ff30aecb8	9d6ccfef-07db-48d4-9e70-d50fa6d7bb4f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 10:25:05
41847	9d6ccfef-06d6-4152-b5ee-8e18f37d9324	9d6ccfef-07db-48d4-9e70-d50fa6d7bb4f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:25:05
41527	9d6ccd3b-66f8-4941-906c-393dd196b352	9d6ccd3b-6aaa-461a-b41a-eb0c46bf57ca	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1904}	2024-11-06 10:17:32
41848	9d6ccfef-60a1-452f-8333-e584b23fd4bf	9d6ccfef-7ebb-4362-bed2-00a2cf22d653	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 10:25:06
41849	9d6ccfef-7924-4018-8239-a4ed24642d1e	9d6ccfef-7ebb-4362-bed2-00a2cf22d653	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"48.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:25:06
41850	9d6ccfef-7cdb-4813-9097-786e24bdd38d	9d6ccfef-7ebb-4362-bed2-00a2cf22d653	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 10:25:06
41851	9d6ccfef-7d4d-4067-9b9f-c84560e34777	9d6ccfef-7ebb-4362-bed2-00a2cf22d653	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":286,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:25:06
40704	9d6cc6b0-4c41-4635-886e-5cbf5e8ee41f	9d6cc6b0-962a-404e-877c-9374c6207885	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 09:59:14
40705	9d6cc6b0-9494-403c-a158-04569604f3c3	9d6cc6b0-962a-404e-877c-9374c6207885	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:59:14
40706	9d6cc6b0-952a-462d-9fba-c6ba0b703365	9d6cc6b0-962a-404e-877c-9374c6207885	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":360,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:59:14
42941	9d6ce181-b42f-4b45-a032-e918441e72e2	9d6ce181-cec0-47da-8853-5bca32db82ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:14:14
42942	9d6ce181-cd32-4574-bc9f-b5522ed87b9b	9d6ce181-cec0-47da-8853-5bca32db82ff	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 11:14:14
42943	9d6ce181-cdc2-43d1-95b2-d421d8a77f05	9d6ce181-cec0-47da-8853-5bca32db82ff	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":222,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:14:14
42944	9d6ce183-70fe-4c94-91e1-9753cead45a4	9d6ce183-8d11-4a04-899b-1d25a27ed36b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 11:14:15
42945	9d6ce183-8806-4b62-b0ce-287cd65e19fa	9d6ce183-8d11-4a04-899b-1d25a27ed36b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.57","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:14:15
42946	9d6ce183-8853-4f4f-b11d-85f9e5572c86	9d6ce183-8d11-4a04-899b-1d25a27ed36b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:14:15
42947	9d6ce183-8bba-4411-b8de-ba07615b4d4b	9d6ce183-8d11-4a04-899b-1d25a27ed36b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 11:14:15
42948	9d6ce183-8c01-4092-aa60-187aa76006c7	9d6ce183-8d11-4a04-899b-1d25a27ed36b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:14:15
42949	9d6ce183-ccf0-4b15-9cd8-bed56c49176d	9d6ce184-0caa-473d-912b-435db550b51b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 11:14:15
42950	9d6ce184-08a4-4ad8-83c0-121b11573043	9d6ce184-0caa-473d-912b-435db550b51b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"141.51","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:14:15
42951	9d6ce184-0b6c-4970-90d6-b888a76463b3	9d6ce184-0caa-473d-912b-435db550b51b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 11:14:15
42952	9d6ce184-0baf-45b9-af58-2566e518741d	9d6ce184-0caa-473d-912b-435db550b51b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":307,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:14:15
42400	9d6cddd8-35ba-4428-98a1-a2b17d6ff6c8	9d6cddd8-519d-4172-bc0a-57d611530b3a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 11:03:59
42401	9d6cddd8-4ff1-4b94-ab1b-b4a202f9af31	9d6cddd8-519d-4172-bc0a-57d611530b3a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 11:03:59
42402	9d6cddd8-5095-4d00-b607-eafcfb050987	9d6cddd8-519d-4172-bc0a-57d611530b3a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":223,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:03:59
42403	9d6cddd9-e539-4835-ab40-60278345eb3a	9d6cddda-2e64-455e-9852-7dde5660d1c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 11:04:00
42404	9d6cddda-27f8-40c3-bf3e-efc76a22355c	9d6cddda-2e64-455e-9852-7dde5660d1c0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"152.23","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:04:00
42405	9d6cddda-285d-4635-8262-92b6317b266b	9d6cddda-2e64-455e-9852-7dde5660d1c0	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:04:00
42406	9d6cddda-2ccb-4e8f-a2ec-b27ed8ddf790	9d6cddda-2e64-455e-9852-7dde5660d1c0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 11:04:00
42407	9d6cddda-2d20-47d3-8afd-74e8d6459005	9d6cddda-2e64-455e-9852-7dde5660d1c0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":332,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:04:00
42408	9d6cddda-709b-4fd7-9a47-e6cfccf6a099	9d6cddda-8b38-4820-aa6a-1d40b1a6dae6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 11:04:01
42409	9d6cddda-86f6-4035-aa95-0764ca92ee84	9d6cddda-8b38-4820-aa6a-1d40b1a6dae6	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"44.33","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:04:01
42410	9d6cddda-89f0-4025-8de1-e9d69ae6829f	9d6cddda-8b38-4820-aa6a-1d40b1a6dae6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 11:04:01
42411	9d6cddda-8a35-432c-b0b3-01c692d370a4	9d6cddda-8b38-4820-aa6a-1d40b1a6dae6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":224,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:04:01
42412	9d6cdded-e65a-4a8f-a560-9d6e64882593	9d6cdded-e962-4a6c-bc4f-e867fa711ada	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":158,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:04:13
42413	9d6cddee-96d3-47a4-a028-4f52b77efedc	9d6cddee-d273-4532-bad2-e66579480deb	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 11:04:14
42414	9d6cddee-b83e-4592-8e55-b72628998161	9d6cddee-d273-4532-bad2-e66579480deb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"41.98","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 11:04:14
42415	9d6cddee-b8a5-4642-9566-7cb922ae9b53	9d6cddee-d273-4532-bad2-e66579480deb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 11:04:14
42416	9d6cddee-d0fa-4a6f-8764-2fe8dae35cb8	9d6cddee-d273-4532-bad2-e66579480deb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:04:14
42417	9d6cddee-d147-433a-9cdb-9e91d1c6dde4	9d6cddee-d273-4532-bad2-e66579480deb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"82","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":422,"response":{"message":"Las credenciales ingresadas no son correctas."},"duration":286,"memory":24,"hostname":"EderCortes"}	2024-11-06 11:04:14
42418	9d6cddfc-22e4-4980-8292-5050ad085d4c	9d6cddfc-2617-4054-981c-74a5f009c8e0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":317,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:04:23
42419	9d6cddfc-d9e4-43a5-8221-fdbc7cb6f0a4	9d6cddfd-0f43-4239-b56a-6e8c6a082ccb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:04:23
42420	9d6cddfc-f693-4f5f-9f51-408561634ed6	9d6cddfd-0f43-4239-b56a-6e8c6a082ccb	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"email\\" = 'edercortez10@gmail.com' and \\"users\\".\\"deleted_at\\" is null limit 1","time":"41.77","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\LoginController.php","line":19,"hash":"e500b13499ef532f1e95e28531073ba3","hostname":"EderCortes"}	2024-11-06 11:04:23
42421	9d6cddfc-f6ec-4ff4-8c3f-ef31d5f8520b	9d6cddfd-0f43-4239-b56a-6e8c6a082ccb	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 11:04:23
42422	9d6cddfd-0e0f-4f74-ba17-de73831ea6af	9d6cddfd-0f43-4239-b56a-6e8c6a082ccb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:04:23
42423	9d6cddfd-0e52-4e81-9b4d-faa1c1070bb8	9d6cddfd-0f43-4239-b56a-6e8c6a082ccb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/login","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\LoginController@login","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"79","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"email":"edercortez10@gmail.com","password":"********","name":"xxxxxxxxxxxx"},"session":[],"response_status":200,"response":{"data":{"attributes":{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","profile":1},"token":"nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m"}},"duration":281,"memory":24,"hostname":"EderCortes"}	2024-11-06 11:04:23
42424	9d6cde03-9844-4a2a-aa51-296f28747056	9d6cde03-dd5b-401c-b98e-3d19ca7515b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:04:28
42425	9d6cde03-d82e-49dd-aaa8-fa974868ac11	9d6cde03-dd5b-401c-b98e-3d19ca7515b9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"140.34","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:04:28
42426	9d6cde03-d87b-4c67-971b-55e402878149	9d6cde03-dd5b-401c-b98e-3d19ca7515b9	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:04:28
42427	9d6cde03-dc2d-4fdd-942b-ada4a10f5d8b	9d6cde03-dd5b-401c-b98e-3d19ca7515b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:04:28
42428	9d6cde03-dc71-4e12-9d6c-f32a6ac584aa	9d6cde03-dd5b-401c-b98e-3d19ca7515b9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":415,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:04:28
42429	9d6cde04-48f9-420a-aa4f-b7e0a33ccce8	9d6cde04-8f65-4aea-a231-8993bf73216c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:04:28
42430	9d6cde04-8b70-472a-accf-d5e297a6f071	9d6cde04-8f65-4aea-a231-8993bf73216c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"151.54","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:04:28
42431	9d6cde04-8e3f-429b-add7-c534c101d33a	9d6cde04-8f65-4aea-a231-8993bf73216c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:04:28
42432	9d6cde04-8e80-471d-9afb-4b95ffe00eb0	9d6cde04-8f65-4aea-a231-8993bf73216c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":443,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:04:28
13344	9d5cfcfd-212b-4bfe-bb86-05cf263f06f9	9d5cfcfd-2832-4473-9eb6-3193458ad930	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":632}	2024-10-29 13:37:49
40810	9d6cc7a6-1a54-4762-932d-737cc3dca1a1	9d6cc7a6-5f1a-44f2-b38a-2246d48ea48e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 10:01:55
40811	9d6cc7a6-5d82-4a42-824f-22f66e85da8d	9d6cc7a6-5f1a-44f2-b38a-2246d48ea48e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 10:01:55
40812	9d6cc7a6-5e1f-4717-98be-04ccaa6aec49	9d6cc7a6-5f1a-44f2-b38a-2246d48ea48e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":331,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:01:55
40813	9d6cc7a8-39d4-4951-a2e9-4dd40c7dad2b	9d6cc7a8-7c4f-4e05-b1c6-2bb378da0193	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 10:01:57
40814	9d6cc7a8-738c-4976-8dcd-bd810bec5ceb	9d6cc7a8-7c4f-4e05-b1c6-2bb378da0193	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"87.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:01:57
40815	9d6cc7a8-740d-4916-b61d-9f369629fe44	9d6cc7a8-7c4f-4e05-b1c6-2bb378da0193	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:01:57
40816	9d6cc7a8-7a4c-4a34-82dc-2870c9d68915	9d6cc7a8-7c4f-4e05-b1c6-2bb378da0193	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 10:01:57
40817	9d6cc7a8-7acb-44c0-b180-ab29d7bc8e10	9d6cc7a8-7c4f-4e05-b1c6-2bb378da0193	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":514,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:01:57
43077	9d6ce3fb-ab16-4f1d-b730-fe06590972b4	9d6ce3fb-aee0-4b87-8fa9-721d3fc225d1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1984}	2024-11-06 11:21:09
40818	9d6cc7a8-eb49-4481-825f-6d41e48e538e	9d6cc7a9-1db4-4eef-946a-af1a9697d7f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 10:01:57
40819	9d6cc7a9-12ae-4e5b-80bf-d6404fc26e85	9d6cc7a9-1db4-4eef-946a-af1a9697d7f4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"76.03","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:01:57
40820	9d6cc7a9-1b6f-4edd-abeb-293335c1089d	9d6cc7a9-1db4-4eef-946a-af1a9697d7f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 10:01:57
40821	9d6cc7a9-1bfb-40c4-a1d8-518b73f0cbe6	9d6cc7a9-1db4-4eef-946a-af1a9697d7f4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":388,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:01:57
40741	9d6cc6e5-5cd3-4cea-9487-94ff0fb5aceb	9d6cc6e5-5f8e-471e-987b-4a0310e391ba	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1848}	2024-11-06 09:59:49
40946	9d6cc8e0-5d5f-4cfa-92e9-23edbb5e1f07	9d6cc8e0-76ad-4868-8c54-e9177325039e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:05:21
40947	9d6cc8e0-7526-4fb8-8495-c54817e28d5b	9d6cc8e0-76ad-4868-8c54-e9177325039e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:05:21
40948	9d6cc8e0-75bb-4b77-9a07-9712db317f7d	9d6cc8e0-76ad-4868-8c54-e9177325039e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":223,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:05:21
40949	9d6cc8e1-e8b2-4fb1-aa7f-332cdf7be9e4	9d6cc8e2-0e93-4857-98b9-1f7df6496a45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:05:22
40950	9d6cc8e2-06e4-4f45-ba6e-0cacab862b3e	9d6cc8e2-0e93-4857-98b9-1f7df6496a45	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.32","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:05:22
40951	9d6cc8e2-075c-418f-b85b-2461579f55e0	9d6cc8e2-0e93-4857-98b9-1f7df6496a45	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:05:22
40952	9d6cc8e2-0d05-492d-b8a0-68d38c9ffffc	9d6cc8e2-0e93-4857-98b9-1f7df6496a45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:05:22
40953	9d6cc8e2-0d68-427e-b2da-1cc280e20423	9d6cc8e2-0e93-4857-98b9-1f7df6496a45	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":303,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:05:22
40843	9d6cc7bf-760e-4d68-8fa6-dc0daa8fa73a	9d6cc7bf-78c7-47ec-9b15-3a1cf4186d6b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1860}	2024-11-06 10:02:12
40954	9d6cc8e2-7039-433a-be30-a710e738169a	9d6cc8e2-9057-4ad7-b696-4e9d426d3095	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:05:23
40955	9d6cc8e2-8ba5-44e1-96d7-98217842750f	9d6cc8e2-9057-4ad7-b696-4e9d426d3095	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"51.25","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:05:23
40956	9d6cc8e2-8efc-4c92-91d4-74865a3af621	9d6cc8e2-9057-4ad7-b696-4e9d426d3095	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:05:23
40957	9d6cc8e2-8f4a-469c-ab8e-fab5751eddcd	9d6cc8e2-9057-4ad7-b696-4e9d426d3095	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":311,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:05:23
35595	9d69c502-8f5b-4dc0-83fa-d75a03ce5649	9d69c502-cf31-4555-b64d-f41a70b0a39a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":31,"hostname":"EderCortes"}	2024-11-04 22:07:04
35596	9d69c502-cbc4-406d-a222-4a2a139356b4	9d69c502-cf31-4555-b64d-f41a70b0a39a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":32,"hostname":"EderCortes"}	2024-11-04 22:07:04
35597	9d69c502-cd4a-42bb-a698-d33cbe34cfba	9d69c502-cf31-4555-b64d-f41a70b0a39a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":480,"memory":22,"hostname":"EderCortes"}	2024-11-04 22:07:04
43116	9d6ce4c5-c27e-441b-b41a-6048f26c1f88	9d6ce4c5-e13c-4169-b9d5-0fa9f0cf4479	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:23:21
43117	9d6ce4c5-df6c-4c06-9c7c-0c0a969f1065	9d6ce4c5-e13c-4169-b9d5-0fa9f0cf4479	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 11:23:22
43118	9d6ce4c5-e025-416a-a27d-ac5133c364b1	9d6ce4c5-e13c-4169-b9d5-0fa9f0cf4479	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/showCobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@showCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abFROM\\u00bb\\nLINE 19:                         FROM users\\n                                 ^ (Connection: pgsql, SQL: \\n                     SELECT id,\\n                            name,\\n                            profile_code,\\n                            profile_name,\\n                            profile_prefix,\\n                            remember_token,\\n                            user_address,\\n                            user_age,\\n                            user_alias,\\n                            user_birth,\\n                            user_cellphone,\\n                            user_city,\\n                            user_document,\\n                            user_document_type,\\n                            user_last_name_one,\\n                            user_last_name_two,\\n                            user_neighborhood,\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 4;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":142,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"showCobrador","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":253,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:23:22
42998	9d6ce35d-46d1-4d6b-9fec-c88cdb6b2648	9d6ce35d-8b4b-4265-b637-8337ce7d8f38	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 11:19:25
42999	9d6ce35d-89a0-4440-98a3-5ea5d8fbc78d	9d6ce35d-8b4b-4265-b637-8337ce7d8f38	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 11:19:25
43000	9d6ce35d-8a3a-4b80-bfb6-a2996c524e15	9d6ce35d-8b4b-4265-b637-8337ce7d8f38	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":331,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:19:25
43001	9d6ce35d-eb50-461b-a28d-9c91b26a85c7	9d6ce35d-f2af-471b-986f-cc910973da13	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 11:19:26
43002	9d6ce35d-f18a-4f8b-ac93-26294fcee76b	9d6ce35d-f2af-471b-986f-cc910973da13	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 11:19:26
43003	9d6ce35d-f1cd-435c-896e-7aa75b2c97bf	9d6ce35d-f2af-471b-986f-cc910973da13	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/showCobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@showCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":"sakdbsabdjkbsadbjksdajkbdsajbkjkbsdakjd"},"duration":182,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:19:26
43058	9d6ce3c3-5bbe-4eda-bc33-c6b33ee3833e	9d6ce3c3-7bd4-4afc-9d87-4d4a54e4c3f7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 11:20:32
43059	9d6ce3c3-79ff-4001-aa88-252e7ffc690e	9d6ce3c3-7bd4-4afc-9d87-4d4a54e4c3f7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 11:20:32
43060	9d6ce3c3-7aa5-4f92-a648-68c624942ce5	9d6ce3c3-7bd4-4afc-9d87-4d4a54e4c3f7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":288,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:20:32
43004	9d6ce35f-b269-405d-a6d3-cb328d584e81	9d6ce35f-d0e1-4bdb-8c27-3de457bcce7a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 11:19:27
43005	9d6ce35f-cb29-4ecd-9ec7-13007f2e338f	9d6ce35f-d0e1-4bdb-8c27-3de457bcce7a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"42.55","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:19:27
43006	9d6ce35f-cb76-4003-a21c-1d6114034643	9d6ce35f-d0e1-4bdb-8c27-3de457bcce7a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:19:27
42637	9d6cdf70-26dc-489c-943b-3de4a481eeac	9d6cdf70-45f5-4c58-a2a6-3fb754daa53a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:08:26
42638	9d6cdf70-442a-40c9-b7ba-239c2b921d9b	9d6cdf70-45f5-4c58-a2a6-3fb754daa53a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:08:27
42639	9d6cdf70-44e3-46ac-ad75-f16227cb4f6c	9d6cdf70-45f5-4c58-a2a6-3fb754daa53a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":317,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:08:27
43007	9d6ce35f-cf98-4c7a-8c7f-55b7a1a9d6ea	9d6ce35f-d0e1-4bdb-8c27-3de457bcce7a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 11:19:27
43008	9d6ce35f-cfe9-4b1d-a7e7-ca48cefe4ed9	9d6ce35f-d0e1-4bdb-8c27-3de457bcce7a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":312,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:19:27
43061	9d6ce3c3-f15c-4f61-96dd-7c040b8dd269	9d6ce3c4-003a-4b35-ab89-ed9dccb23dc1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 11:20:32
43062	9d6ce3c3-fedc-49a3-a3e1-43d10fbd8b9f	9d6ce3c4-003a-4b35-ab89-ed9dccb23dc1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 11:20:33
43063	9d6ce3c3-ff3e-44f1-8d59-66b940b3f1dd	9d6ce3c4-003a-4b35-ab89-ed9dccb23dc1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/showCobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@showCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"user":[]},"duration":245,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:20:33
42640	9d6cdf70-b1a3-427a-be02-18fc275578a0	9d6cdf70-d87a-4ef5-89e9-13c4170193d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:08:27
42641	9d6cdf70-d10f-4ffe-93bc-fcbd857da29e	9d6cdf70-d87a-4ef5-89e9-13c4170193d5	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"52.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 11:08:27
42642	9d6cdf70-d187-4146-a6ab-d4374c4022cb	9d6cdf70-d87a-4ef5-89e9-13c4170193d5	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 11:08:27
42643	9d6cdf70-d74d-4cb4-8e71-8d91e18ab1c9	9d6cdf70-d87a-4ef5-89e9-13c4170193d5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:08:27
42644	9d6cdf70-d79b-4c78-bb27-032fb468408b	9d6cdf70-d87a-4ef5-89e9-13c4170193d5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":283,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:08:27
43009	9d6ce360-1a8f-4ca8-a795-534821ec8b25	9d6ce360-5e4e-4c51-b523-dfbdc85de820	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 11:19:27
43010	9d6ce360-5a18-4eed-a02e-41a337c7c0d3	9d6ce360-5e4e-4c51-b523-dfbdc85de820	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"150.83","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:19:27
43011	9d6ce360-5d0a-4fa4-9ad6-e22ea27cb18a	9d6ce360-5e4e-4c51-b523-dfbdc85de820	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-06 11:19:27
43012	9d6ce360-5d4b-4410-920a-4dca5d9700a1	9d6ce360-5e4e-4c51-b523-dfbdc85de820	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":348,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:19:27
43064	9d6ce3c6-1059-42e6-bd0d-ecb48e02c5c1	9d6ce3c6-5841-4171-bf28-a77acbc47954	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 11:20:34
43065	9d6ce3c6-537f-4a30-963b-c343f3fbc25f	9d6ce3c6-5841-4171-bf28-a77acbc47954	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"147.54","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:20:34
43066	9d6ce3c6-53ca-442c-81b9-34082bab9b91	9d6ce3c6-5841-4171-bf28-a77acbc47954	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:20:34
43067	9d6ce3c6-56f0-4329-bacb-b0c913845664	9d6ce3c6-5841-4171-bf28-a77acbc47954	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 11:20:34
43068	9d6ce3c6-5735-4640-a7e0-522d70be0676	9d6ce3c6-5841-4171-bf28-a77acbc47954	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":578,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:20:34
42645	9d6cdf71-1f89-48e9-a619-dbfcf03a8957	9d6cdf71-6451-4ffd-8ff1-4a1f0ee7b013	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:08:27
42646	9d6cdf71-5ec2-41cb-9c5f-378a49d6100d	9d6cdf71-6451-4ffd-8ff1-4a1f0ee7b013	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" <> 1 and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"140.78","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":286,"hash":"9e812c8cb70a345c127e0c7468cc36e9","hostname":"EderCortes"}	2024-11-06 11:08:27
42647	9d6cdf71-5f0f-4590-8d3b-c288a266e71f	9d6cdf71-6451-4ffd-8ff1-4a1f0ee7b013	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":4,"hostname":"EderCortes"}	2024-11-06 11:08:27
42648	9d6cdf71-6309-4a10-a57f-9d30f4216c99	9d6cdf71-6451-4ffd-8ff1-4a1f0ee7b013	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:08:27
42649	9d6cdf71-634c-40fa-93ff-41bdba746387	9d6cdf71-6451-4ffd-8ff1-4a1f0ee7b013	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/recomendacion\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getRecomendacion","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":337,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:08:27
43069	9d6ce3c6-9baf-446b-bc9f-ec43adb71b1e	9d6ce3c6-b52f-40d4-8da3-bc294326565e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 11:20:34
43070	9d6ce3c6-b088-461f-8488-21feb21e2921	9d6ce3c6-b52f-40d4-8da3-bc294326565e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"41.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:20:34
43071	9d6ce3c6-b3bc-42a5-b375-e16795ce1824	9d6ce3c6-b52f-40d4-8da3-bc294326565e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-06 11:20:34
43072	9d6ce3c6-b411-416f-a1b2-c0bf71ed7c78	9d6ce3c6-b52f-40d4-8da3-bc294326565e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":217,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:20:34
42650	9d6cdf71-ab62-475d-b6c6-ec610aff1b13	9d6cdf71-f100-44d2-9b46-339e5290f727	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:08:27
42651	9d6cdf71-eb04-46d6-a927-5d98c59d73f8	9d6cdf71-f100-44d2-9b46-339e5290f727	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '5' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"141.43","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":235,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 11:08:28
42652	9d6cdf71-eb77-4393-9e0d-89acf01aee32	9d6cdf71-f100-44d2-9b46-339e5290f727	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":2,"hostname":"EderCortes"}	2024-11-06 11:08:28
42653	9d6cdf71-efd1-4f13-92d8-a7937c4fc3c1	9d6cdf71-f100-44d2-9b46-339e5290f727	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:08:28
42654	9d6cdf71-f01c-4d2c-83c8-1a25e9bcffef	9d6cdf71-f100-44d2-9b46-339e5290f727	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/register\\/5","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}]},"duration":341,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:08:28
42655	9d6cdf74-5405-46cd-801f-2d5b7f381f3c	9d6cdf74-75d7-492d-9138-3d338477cb66	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:08:29
42656	9d6cdf74-6f7b-4c21-bba0-99943d270310	9d6cdf74-75d7-492d-9138-3d338477cb66	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"49.68","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:08:29
42657	9d6cdf74-6ff9-4c37-8ce0-9f8116c4a286	9d6cdf74-75d7-492d-9138-3d338477cb66	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:08:29
42658	9d6cdf74-7466-4163-ac4b-d2c52aeb82fd	9d6cdf74-75d7-492d-9138-3d338477cb66	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 11:08:29
42659	9d6cdf74-74c6-4807-9431-005910547046	9d6cdf74-75d7-492d-9138-3d338477cb66	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":303,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:08:29
42660	9d6cdf74-d0f5-4383-bf2b-46d04196368c	9d6cdf74-eada-4514-9a67-de5d8a75dd3c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 11:08:30
42661	9d6cdf74-e672-447a-a771-ddcfdbcfa130	9d6cdf74-eada-4514-9a67-de5d8a75dd3c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"41.02","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:08:30
42662	9d6cdf74-e99a-4487-877e-b32c40d6505f	9d6cdf74-eada-4514-9a67-de5d8a75dd3c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 11:08:30
42663	9d6cdf74-e9dd-4357-b0df-cad68e8f26e5	9d6cdf74-eada-4514-9a67-de5d8a75dd3c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":284,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:08:30
42664	9d6cdf77-2b71-42b9-aef1-b354a42b45dc	9d6cdf77-2df4-4717-b4d3-b5340571b5d6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":148,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:08:31
42665	9d6cdf77-e3d5-4e4d-b2af-580b5282448d	9d6cdf78-28a7-4082-8f48-d15079e57b69	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 11:08:32
42666	9d6cdf78-2397-4532-a58e-4072a7d04c1b	9d6cdf78-28a7-4082-8f48-d15079e57b69	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Ma%' or \\"users\\".\\"user_document\\"::text like '%Ma%') order by \\"users\\".\\"user_document\\" asc","time":"148.00","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":122,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-06 11:08:32
42667	9d6cdf78-2745-4080-9287-88d7778bf8c6	9d6cdf78-28a7-4082-8f48-d15079e57b69	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 11:08:32
42668	9d6cdf78-2785-4bf9-bafe-c0143a5b0c18	9d6cdf78-28a7-4082-8f48-d15079e57b69	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"24","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Ma"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":324,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:08:32
43149	9d6ce51b-7d3f-4550-8e06-5ae5332d48cd	9d6ce51b-cadd-45dc-8b8c-d85c069f448f	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 11:24:18
43150	9d6ce51b-c8bc-4bc5-9dbe-9a8b4ada3d89	9d6ce51b-cadd-45dc-8b8c-d85c069f448f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:24:18
43151	9d6ce51b-c9b8-4cf5-8908-b9ff29e13f16	9d6ce51b-cadd-45dc-8b8c-d85c069f448f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":379,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:24:18
42669	9d6cdf78-6388-4e47-9253-a6d9853ade2e	9d6cdf78-668a-4c79-b3ba-411dc1ec7c66	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":135,"memory":20,"hostname":"EderCortes"}	2024-11-06 11:08:32
42670	9d6cdf79-1af4-4823-880c-f513d79f9e66	9d6cdf79-5dcf-48cb-aa62-8c1d067921bc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 11:08:32
42671	9d6cdf79-59c3-4575-8a74-3f1ebe437d36	9d6cdf79-5dcf-48cb-aa62-8c1d067921bc	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mar%' or \\"users\\".\\"user_document\\"::text like '%Mar%') order by \\"users\\".\\"user_document\\" asc","time":"145.90","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":122,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-06 11:08:33
42672	9d6cdf79-5c92-4938-bccd-255b21d6ad87	9d6cdf79-5dcf-48cb-aa62-8c1d067921bc	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 11:08:33
42673	9d6cdf79-5cd2-40a9-ad58-e96b2a7633bd	9d6cdf79-5dcf-48cb-aa62-8c1d067921bc	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"25","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mar"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":321,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:08:33
42674	9d6cdf79-983e-4781-b5a7-267c3cc4ffee	9d6cdf79-9b47-4ba0-826c-67bd3df7213a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":132,"memory":20,"hostname":"EderCortes"}	2024-11-06 11:08:33
42675	9d6cdf79-e36b-4900-b783-ee1e567479a8	9d6cdf79-e653-4ecd-9583-d8b59c9b0721	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":126,"memory":20,"hostname":"EderCortes"}	2024-11-06 11:08:33
43219	9d6ce59d-a76d-4614-bc27-57f3093ae8d9	9d6ce59d-ac3e-4c39-ab1b-7965853891e3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2004}	2024-11-06 11:25:43
42676	9d6cdf7a-3473-4fc3-af71-dc2cc0aba1a2	9d6cdf7a-7796-4fab-acb4-15dbf2d0544e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 11:08:33
42677	9d6cdf7a-7388-422d-8403-e81a6d48a112	9d6cdf7a-7796-4fab-acb4-15dbf2d0544e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Mari%' or \\"users\\".\\"user_document\\"::text like '%Mari%') order by \\"users\\".\\"user_document\\" asc","time":"143.80","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":122,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-06 11:08:33
42678	9d6cdf7a-7664-48c3-8419-da90a6b49fac	9d6cdf7a-7796-4fab-acb4-15dbf2d0544e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 11:08:33
42679	9d6cdf7a-76a3-476e-abce-0816d4a18276	9d6cdf7a-7796-4fab-acb4-15dbf2d0544e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"26","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Mari"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":315,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:08:33
42680	9d6cdf7a-ba9b-4bca-8d09-7c89d8189286	9d6cdf7a-d434-4e7e-94fa-c269b3ac41c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 11:08:33
42681	9d6cdf7a-d032-4cb5-9dab-5020f76bbdb4	9d6cdf7a-d434-4e7e-94fa-c269b3ac41c9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"users\\".\\"id\\", CONCAT(users.name, '  ' , users.user_last_name_one , ' - ' , users.user_document ) as name_customer from \\"users\\" where \\"users\\".\\"profile_code\\" = 5 and (\\"users\\".\\"name\\"::text like '%Maria%' or \\"users\\".\\"user_document\\"::text like '%Maria%') order by \\"users\\".\\"user_document\\" asc","time":"38.80","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":122,"hash":"ed4d885b13aa6c9c6262005ab9261537","hostname":"EderCortes"}	2024-11-06 11:08:33
42682	9d6cdf7a-d2fc-4690-b0cd-a2e49fe08ac0	9d6cdf7a-d434-4e7e-94fa-c269b3ac41c9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 11:08:33
42683	9d6cdf7a-d33d-469b-83da-0ec0f490bf06	9d6cdf7a-d434-4e7e-94fa-c269b3ac41c9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-customer-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCustomerFilters","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"27","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"code":5,"search":"Maria"},"session":[],"response_status":200,"response":{"data":[{"id":18,"name_customer":"Maria Antonieta  De las nieve - 100465546"},{"id":19,"name_customer":"Maria Antonieta 2  De las nieve - 1004655468"}]},"duration":223,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:08:33
42684	9d6cdf7c-9406-4d0f-b01c-f1ec6971de27	9d6cdf7c-ddf6-4b46-b371-c97305a12f02	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 11:08:35
42685	9d6cdf7c-d8ca-4a87-a517-85027cb7dd07	9d6cdf7c-ddf6-4b46-b371-c97305a12f02	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"id\\" = '19' and \\"users\\".\\"deleted_at\\" is null","time":"152.38","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":101,"hash":"ce7fdf837b324ff4713e328424a8c39e","hostname":"EderCortes"}	2024-11-06 11:08:35
42686	9d6cdf7c-d920-4a68-8dea-19d1f5c6c4b6	9d6cdf7c-ddf6-4b46-b371-c97305a12f02	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 11:08:35
42687	9d6cdf7c-dc97-4ddf-bd75-116ca87c00cc	9d6cdf7c-ddf6-4b46-b371-c97305a12f02	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 11:08:35
42688	9d6cdf7c-dcf5-42d3-8608-001dfc77460c	9d6cdf7c-ddf6-4b46-b371-c97305a12f02	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/list-user-customer\\/19","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getUserCustomer","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"}},"duration":368,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:08:35
43450	9d6cea02-8f9b-400e-afc1-bf498c75ee6e	9d6cea02-a84e-40ac-b17f-1bd6db8dba76	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:38:00
43451	9d6cea02-a6e4-47db-b6a3-e9ce77eeb8a4	9d6cea02-a84e-40ac-b17f-1bd6db8dba76	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 11:38:00
43452	9d6cea02-a774-475b-bf28-908dc94b4b21	9d6cea02-a84e-40ac-b17f-1bd6db8dba76	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":218,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:00
43449	9d6cea02-a5b0-4d11-a692-fb3277155f44	9d6cea02-a84e-40ac-b17f-1bd6db8dba76	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2028}	2024-11-06 11:38:00
43453	9d6cea03-043a-4bf5-ae65-81615006498a	9d6cea03-29cd-45e3-b6cc-029bfe28159c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 11:38:00
43454	9d6cea03-20cb-46d9-ade4-f8d0de3f82d0	9d6cea03-29cd-45e3-b6cc-029bfe28159c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"45.37","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":19,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-06 11:38:01
43455	9d6cea03-211c-4c9a-a5f3-0bc37f95d647	9d6cea03-29cd-45e3-b6cc-029bfe28159c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":5,"hostname":"EderCortes"}	2024-11-06 11:38:01
43456	9d6cea03-28c0-4ecc-b755-f130046f5d5f	9d6cea03-29cd-45e3-b6cc-029bfe28159c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 11:38:01
43457	9d6cea03-2903-4678-8674-8811438eba1a	9d6cea03-29cd-45e3-b6cc-029bfe28159c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:55:01.000000Z","deleted_at":null,"user_alias":"eder.cortes"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:01
41165	9d6ccbb9-7bee-48bf-a3ee-f60947302120	9d6ccbb9-af01-4987-9a65-eccf90a790ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 10:13:19
41166	9d6ccbb9-ac12-48f8-9052-9a403e3512f7	9d6ccbb9-af01-4987-9a65-eccf90a790ea	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 10:13:19
41167	9d6ccbb9-ad69-474c-b096-cda4835a3c6c	9d6ccbb9-af01-4987-9a65-eccf90a790ea	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":405,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:13:19
41168	9d6ccbba-cb6e-43f4-9cdf-fc56a0a90ff9	9d6ccbba-f331-43dc-855b-8bb03deb166a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 10:13:20
41169	9d6ccbba-ed02-4504-a340-0cf0622292f3	9d6ccbba-f331-43dc-855b-8bb03deb166a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"57.61","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 10:13:20
41170	9d6ccbba-f18d-41b4-b10a-04ceed9b4fcb	9d6ccbba-f331-43dc-855b-8bb03deb166a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 10:13:20
41171	9d6ccbba-f219-4451-b617-59d3696a04f0	9d6ccbba-f331-43dc-855b-8bb03deb166a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":687,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:13:20
43258	9d6ce5ba-359c-4272-bf25-4720181e8448	9d6ce5ba-7bcc-4d06-aa4a-c83946f79efb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 11:26:02
43259	9d6ce5ba-7a79-4f21-8968-9e51d0ffc7c5	9d6ce5ba-7bcc-4d06-aa4a-c83946f79efb	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 11:26:02
43260	9d6ce5ba-7aff-4dce-8810-b24e3f6674e2	9d6ce5ba-7bcc-4d06-aa4a-c83946f79efb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":341,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:26:02
41172	9d6ccbbb-6c7a-4c10-aca0-699d046c7026	9d6ccbbb-9f64-455c-ab41-b5787c8e53e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 10:13:20
41173	9d6ccbbb-93c9-4aad-9457-21323e7c14fb	9d6ccbbb-9f64-455c-ab41-b5787c8e53e3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"61.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:13:20
41174	9d6ccbbb-9471-4534-bf8d-6c40f795adae	9d6ccbbb-9f64-455c-ab41-b5787c8e53e3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:13:20
41175	9d6ccbbb-9d17-4aa4-9f7b-0b9c4fe50eb2	9d6ccbbb-9f64-455c-ab41-b5787c8e53e3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 10:13:20
41176	9d6ccbbb-9dc7-4302-b579-e000cbcc1040	9d6ccbbb-9f64-455c-ab41-b5787c8e53e3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":428,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:13:20
41177	9d6ccbbc-0011-482e-b8aa-3ab56f4e9ae1	9d6ccbbc-2332-4948-a4f2-a39fe6ffad9a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 10:13:21
41178	9d6ccbbc-1cb9-4eec-b984-41b7109dc8d1	9d6ccbbc-2332-4948-a4f2-a39fe6ffad9a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"47.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:13:21
41179	9d6ccbbc-1d1c-4493-ba07-5e4c5fc4d4ca	9d6ccbbc-2332-4948-a4f2-a39fe6ffad9a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:13:21
41180	9d6ccbbc-2179-4baa-b559-0d335aeedb03	9d6ccbbc-2332-4948-a4f2-a39fe6ffad9a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 10:13:21
41181	9d6ccbbc-21f8-4b5f-8908-e324c050451f	9d6ccbbc-2332-4948-a4f2-a39fe6ffad9a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":312,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:13:21
41182	9d6ccbbe-300a-4309-860b-808745f2b1ba	9d6ccbbe-64a6-4452-b944-bdc28e79ef3e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 10:13:22
41183	9d6ccbbe-5a0a-49a6-a07a-5b03ef16243a	9d6ccbbe-64a6-4452-b944-bdc28e79ef3e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"65.22","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:13:22
41184	9d6ccbbe-5a8b-48ca-9114-8ba030691077	9d6ccbbe-64a6-4452-b944-bdc28e79ef3e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:13:22
41185	9d6ccbbe-6255-4b82-a561-e2ef83144ae0	9d6ccbbe-64a6-4452-b944-bdc28e79ef3e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 10:13:22
41186	9d6ccbbe-62ee-48de-aa44-cf4586efc979	9d6ccbbe-64a6-4452-b944-bdc28e79ef3e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":566,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:13:22
41187	9d6ccbbf-02e6-489e-b31c-02d89d53968c	9d6ccbbf-327b-4b87-a62b-78b0277ed3a0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 10:13:23
41188	9d6ccbbf-2809-4e69-a428-ae119a2a4ca5	9d6ccbbf-327b-4b87-a62b-78b0277ed3a0	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"69.17","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:13:23
41189	9d6ccbbf-3015-4eed-919c-2714221c20c4	9d6ccbbf-327b-4b87-a62b-78b0277ed3a0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-06 10:13:23
41190	9d6ccbbf-30c4-48f7-a0d0-0857a0b0168e	9d6ccbbf-327b-4b87-a62b-78b0277ed3a0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":500,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:13:23
41191	9d6ccbbf-c175-4600-84ee-113d3420e83b	9d6ccbbf-c829-4056-865b-94b342285595	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"OPTIONS","controller_action":null,"middleware":[],"headers":{"host":"localhost:8000","connection":"keep-alive","accept":"*\\/*","access-control-request-method":"POST","access-control-request-headers":"content-type","origin":"http:\\/\\/localhost:4200","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","sec-fetch-mode":"cors","sec-fetch-site":"same-site","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":204,"response":"Empty Response","duration":329,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:13:23
41192	9d6ccbc0-7644-406b-a52b-8f08bcd267ae	9d6ccbc0-ce60-40a8-a205-1f05995c01c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-06 10:13:24
41193	9d6ccbc0-c5bf-493d-b821-bcbfd839f346	9d6ccbc0-ce60-40a8-a205-1f05995c01c4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"169.53","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 10:13:24
41194	9d6ccbc0-cc31-44b0-a7e5-220a22ba55d0	9d6ccbc0-ce60-40a8-a205-1f05995c01c4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-06 10:13:24
41195	9d6ccbc0-ccdd-40ad-9ad5-5953c7c0bd17	9d6ccbc0-ce60-40a8-a205-1f05995c01c4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","content-length":"60","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","content-type":"application\\/json","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":577,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:13:24
40708	9d6cc6b0-ef51-4287-a434-e538011487b5	9d6cc6b1-3224-4c58-8f46-32284e3bc3b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 09:59:15
40709	9d6cc6b1-30a3-47f2-811a-bd57569bb5bb	9d6cc6b1-3224-4c58-8f46-32284e3bc3b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 09:59:15
40710	9d6cc6b1-3136-46fe-b444-4cfd58ecd4e8	9d6cc6b1-3224-4c58-8f46-32284e3bc3b9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":333,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:59:15
40823	9d6cc7a9-79a9-41ea-887a-cc9b4350dd21	9d6cc7a9-9b35-41b5-bdf5-f8392820b3f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 10:01:58
40824	9d6cc7a9-9991-4d49-aaf7-0f03ff35afbb	9d6cc7a9-9b35-41b5-bdf5-f8392820b3f5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 10:01:58
40825	9d6cc7a9-9a41-43db-8b42-64d021857f3c	9d6cc7a9-9b35-41b5-bdf5-f8392820b3f5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":290,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:01:58
40959	9d6cc8fa-9290-4b1b-8875-a7b2e6117cc0	9d6cc8fa-b385-489b-ba01-44730a073ede	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:05:38
40960	9d6cc8fa-b226-471e-b9f6-b93f28972ac8	9d6cc8fa-b385-489b-ba01-44730a073ede	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 10:05:39
40961	9d6cc8fa-b2b8-479e-97f2-c4478deb3080	9d6cc8fa-b385-489b-ba01-44730a073ede	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:05:39
41327	9d6ccc66-1365-49fe-975c-296ed8428e33	9d6ccc66-5e7f-4bcb-abfa-b4a9c11c196a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-06 10:15:12
41328	9d6ccc66-5cbd-4026-8272-f99e1ee6778d	9d6ccc66-5e7f-4bcb-abfa-b4a9c11c196a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-06 10:15:12
41329	9d6ccc66-5d5a-4cd0-a8ed-6b55a6d922cf	9d6ccc66-5e7f-4bcb-abfa-b4a9c11c196a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":361,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:12
25157	9d68bfef-4e3b-40e6-b538-7d22a7bcd2e6	9d68bfef-545c-429a-bc32-04a01de7ad9c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1147}	2024-11-04 09:57:02
31942	9d695788-0004-4cd0-ae77-684f1d667fab	9d695788-0450-40db-ac14-4c45a322d77e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1528}	2024-11-04 17:00:56
41611	9d6ccdde-0825-4b00-a954-05c6ee748527	9d6ccdde-4eaf-42b3-b90e-9a64babb09e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:19:19
41612	9d6ccdde-4d58-4a9b-a1ac-677454f785fa	9d6ccdde-4eaf-42b3-b90e-9a64babb09e1	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:19:19
41613	9d6ccdde-4de7-4190-aa24-3fe63106eea6	9d6ccdde-4eaf-42b3-b90e-9a64babb09e1	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":328,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:19:19
41614	9d6ccddf-9182-4197-ab88-ac921b90da40	9d6ccddf-b6f3-45d6-823b-aa09f9b7993c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:19:20
41615	9d6ccddf-aeb7-4744-b04f-320431f99512	9d6ccddf-b6f3-45d6-823b-aa09f9b7993c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.42","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:19:20
41616	9d6ccddf-af1f-433e-ac8e-610bb8049142	9d6ccddf-b6f3-45d6-823b-aa09f9b7993c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:19:20
41617	9d6ccddf-b585-46d0-a057-07536a6d0367	9d6ccddf-b6f3-45d6-823b-aa09f9b7993c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:19:20
41618	9d6ccddf-b5df-4e15-bb39-d08900027c5a	9d6ccddf-b6f3-45d6-823b-aa09f9b7993c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":424,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:19:20
41619	9d6ccde0-219d-4be2-b2d4-315d54dfef37	9d6ccde0-46ce-406d-a9ea-d0e30afca34e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:19:20
41620	9d6ccde0-408a-4d2d-aa0a-ab7b1b67aab6	9d6ccde0-46ce-406d-a9ea-d0e30afca34e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"49.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:19:20
41621	9d6ccde0-4523-4cce-9d92-85131cafb1e7	9d6ccde0-46ce-406d-a9ea-d0e30afca34e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:19:20
41622	9d6ccde0-459c-40dc-ba19-274aa7dcd2c2	9d6ccde0-46ce-406d-a9ea-d0e30afca34e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":345,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:19:20
41910	9d6cd0fa-1e93-4f90-9f38-3722652cf9e7	9d6cd0fa-4030-492f-91ed-a8ddced3fb34	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:28:00
41911	9d6cd0fa-3e29-43ad-ab1a-8e7920ace6fb	9d6cd0fa-4030-492f-91ed-a8ddced3fb34	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:28:00
41912	9d6cd0fa-3f1f-4c57-abc5-14de40544103	9d6cd0fa-4030-492f-91ed-a8ddced3fb34	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":292,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:28:00
3403	9d510525-5207-432c-9fbf-5594881d673e	9d510525-5823-4e22-9982-b731df87e057	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":191}	2024-10-23 14:50:42
41675	9d6cce9b-6326-48d3-b2dd-dadddfde6667	9d6cce9b-b1ac-42a1-a832-eeb60e7fa12d	\N	t	cache	{"type":"missed","key":"a75f3f172bfb296f2e10cbfc6dfc1883","hostname":"EderCortes"}	2024-11-06 10:21:23
41676	9d6cce9b-af5e-40f3-afe4-c19bccf212e3	9d6cce9b-b1ac-42a1-a832-eeb60e7fa12d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:21:23
41677	9d6cce9b-b045-4e42-b648-c8c83d3747c4	9d6cce9b-b1ac-42a1-a832-eeb60e7fa12d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":375,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:21:23
11181	9d5cabfc-7733-4f97-a97f-a3c572da2bb4	9d5cabfc-7a9a-4405-9146-4f0547605df2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":563}	2024-10-29 09:51:20
43153	9d6ce51c-3054-4c2a-819a-aa159981debb	9d6ce51c-73db-45f7-817f-84fdc32aafd7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 11:24:18
43154	9d6ce51c-7257-4e90-8f21-15332fadf65e	9d6ce51c-73db-45f7-817f-84fdc32aafd7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:24:18
43155	9d6ce51c-72e6-4cdf-a819-4555a249626b	9d6ce51c-73db-45f7-817f-84fdc32aafd7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/showCobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@showCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abprofile_name\\u00bb\\nLINE 5:                             profile_name,\\n                                    ^\\nHINT:  Probablemente quiera hacer referencia a la columna \\u00abusers.profile_code\\u00bb. (Connection: pgsql, SQL: \\n                     SELECT id,\\n                            name,\\n                            profile_code,\\n                            profile_name,\\n                            profile_prefix,\\n                            remember_token,\\n                            user_address,\\n                            user_age,\\n                            user_alias,\\n                            user_birth,\\n                            user_cellphone,\\n                            user_city,\\n                            user_document,\\n                            user_document_type,\\n                            user_last_name_one,\\n                            user_last_name_two,\\n                            user_neighborhood\\n                        FROM users\\n                        WHERE profile_code = 4;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":142,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"showCobrador","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":352,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:24:18
43156	9d6ce51e-2f28-48bd-8841-5d1a24b7c872	9d6ce51e-4d36-44e3-b160-67be3650191c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 11:24:19
43157	9d6ce51e-46dd-4957-b8e5-c9f643650984	9d6ce51e-4d36-44e3-b160-67be3650191c	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"39.15","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:24:19
43158	9d6ce51e-4724-427b-be4e-aab78e050856	9d6ce51e-4d36-44e3-b160-67be3650191c	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:24:19
43159	9d6ce51e-4c0d-4656-86e7-e2357ea65f0a	9d6ce51e-4d36-44e3-b160-67be3650191c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:24:19
43160	9d6ce51e-4c4f-4d93-8e63-cd8c94c86283	9d6ce51e-4d36-44e3-b160-67be3650191c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":288,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:24:19
43161	9d6ce51e-8ff5-45e0-865c-be3d7bcef939	9d6ce51e-a848-4923-8801-1cd27a75b223	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 11:24:20
43162	9d6ce51e-a3b6-4acf-96b6-2d7713c9fd57	9d6ce51e-a848-4923-8801-1cd27a75b223	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"38.99","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:24:20
43163	9d6ce51e-a6f7-4486-a43b-db93fb2dcd6d	9d6ce51e-a848-4923-8801-1cd27a75b223	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:24:20
43164	9d6ce51e-a743-48e0-b05d-3875eae8b3c6	9d6ce51e-a848-4923-8801-1cd27a75b223	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":217,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:24:20
43459	9d6cea03-7824-42b5-9912-5ba357125543	9d6cea03-91e6-4f09-bcc9-edc0cd6c2295	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 11:38:01
43460	9d6cea03-907b-44f4-ac60-f6bfc14f6e68	9d6cea03-91e6-4f09-bcc9-edc0cd6c2295	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 11:38:01
43461	9d6cea03-910c-407b-aa36-2314cfa8cb93	9d6cea03-91e6-4f09-bcc9-edc0cd6c2295	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":251,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:01
43261	9d6ce5ba-ef8e-4aca-915f-5ecb888229f5	9d6ce5ba-f265-492b-b418-ae4fcf869884	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2008}	2024-11-06 11:26:02
43262	9d6ce5ba-d83a-4cdb-8b20-e124ea81f6a5	9d6ce5ba-f265-492b-b418-ae4fcf869884	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 11:26:02
43263	9d6ce5ba-f0ed-425c-a7ac-cbb60c081428	9d6ce5ba-f265-492b-b418-ae4fcf869884	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 11:26:02
43264	9d6ce5ba-f179-4a02-b52f-f9e9494424a8	9d6ce5ba-f265-492b-b418-ae4fcf869884	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":223,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:26:02
43265	9d6ce5bb-50db-4df6-890d-01665ec8ad3a	9d6ce5bb-6a94-48ce-8e64-6b4ea2f66b6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 11:26:02
43266	9d6ce5bb-65ca-4446-ba83-c8643b57f32a	9d6ce5bb-6a94-48ce-8e64-6b4ea2f66b6b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT id,\\n                            name,\\n                            profile_code,\\n                            remember_token,\\n                            user_address,\\n                            user_age,\\n                            user_alias,\\n                            user_birth,\\n                            user_cellphone,\\n                            user_city,\\n                            user_document,\\n                            user_document_type,\\n                            user_last_name_one,\\n                            user_last_name_two,\\n                            user_neighborhood\\n                        FROM users\\n                        WHERE profile_code = 4;\\n                            ","time":"41.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":142,"hash":"e2980c10c70608ca75f9c2180abc54e1","hostname":"EderCortes"}	2024-11-06 11:26:02
43267	9d6ce5bb-6931-476f-a274-ad121c6de870	9d6ce5bb-6a94-48ce-8e64-6b4ea2f66b6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 11:26:02
43268	9d6ce5bb-698c-4bb0-9f05-000e6c6e06b2	9d6ce5bb-6a94-48ce-8e64-6b4ea2f66b6b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/showCobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@showCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":14,"name":"Luis andre","profile_code":4,"remember_token":null,"user_address":"Calle 750","user_age":"31","user_alias":"luis_martinez","user_birth":"1992-11-12T04:00:00.000Z","user_cellphone":"312596295","user_city":"Cali","user_document":"100465545","user_document_type":"CC","user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_neighborhood":"Bonilla aragon"}},"duration":224,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:26:02
43269	9d6ce5bc-b3ec-4181-82b5-0c79279f5c1b	9d6ce5bc-df2d-4bec-99ca-04aa3dd2babd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 11:26:03
43270	9d6ce5bc-d770-47f4-8d9d-91ddf3d64478	9d6ce5bc-df2d-4bec-99ca-04aa3dd2babd	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"60.89","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:26:03
43271	9d6ce5bc-d7ee-4894-82d5-9e8127ea5dbf	9d6ce5bc-df2d-4bec-99ca-04aa3dd2babd	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:26:03
43272	9d6ce5bc-dd9b-4c66-8393-25908b54bb94	9d6ce5bc-df2d-4bec-99ca-04aa3dd2babd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 11:26:03
43273	9d6ce5bc-de05-4d30-a485-1e1dacad8c95	9d6ce5bc-df2d-4bec-99ca-04aa3dd2babd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":433,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:26:03
43274	9d6ce5bd-81fe-4075-af0f-26e193069514	9d6ce5bd-a1b7-4195-b411-ed9f5127d50a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 11:26:04
43275	9d6ce5bd-9c6d-45f2-8974-e0de0fd25902	9d6ce5bd-a1b7-4195-b411-ed9f5127d50a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"53.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:26:04
43276	9d6ce5bd-a05d-42ab-b931-63777d464dc2	9d6ce5bd-a1b7-4195-b411-ed9f5127d50a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-06 11:26:04
43277	9d6ce5bd-a0a6-4ea0-8f9d-5ef9a43e6a75	9d6ce5bd-a1b7-4195-b411-ed9f5127d50a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":476,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:26:04
40721	9d6cc6c8-2131-4762-bd5e-6ddd3cac1558	9d6cc6c8-68be-4aae-9b84-8a0d19869268	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 09:59:30
40722	9d6cc6c8-66fd-4fb9-ae86-78b0ffc9120d	9d6cc6c8-68be-4aae-9b84-8a0d19869268	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 09:59:30
40723	9d6cc6c8-67a8-4690-9c8b-5f37619998de	9d6cc6c8-68be-4aae-9b84-8a0d19869268	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":374,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:59:30
40963	9d6cc8fb-0a41-42d1-8733-959dfc70251f	9d6cc8fb-246d-4ac7-b8a9-dcfb561491af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 10:05:39
40964	9d6cc8fb-22ea-4b0f-946f-8672030b270d	9d6cc8fb-246d-4ac7-b8a9-dcfb561491af	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 10:05:39
40965	9d6cc8fb-2380-4f18-bddc-1d0b2c21517c	9d6cc8fb-246d-4ac7-b8a9-dcfb561491af	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":222,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:05:39
40966	9d6cc8fc-39f7-407c-9677-cb4b27ffcda5	9d6cc8fc-6ae3-437e-bdf3-2d16dc02543d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 10:05:40
40967	9d6cc8fc-60ff-4892-b0e9-ce6f380e0faf	9d6cc8fc-6ae3-437e-bdf3-2d16dc02543d	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"60.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:05:40
40968	9d6cc8fc-619d-455f-8be2-9fb9e31418d4	9d6cc8fc-6ae3-437e-bdf3-2d16dc02543d	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:05:40
40969	9d6cc8fc-68f2-4778-adeb-9295c750cbef	9d6cc8fc-6ae3-437e-bdf3-2d16dc02543d	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 10:05:40
40970	9d6cc8fc-6983-4933-9e8d-385101d3f395	9d6cc8fc-6ae3-437e-bdf3-2d16dc02543d	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":423,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:05:40
40971	9d6cc8fc-c954-4bac-81b6-c69aad9af7e2	9d6cc8fc-ebb1-40b1-b621-08cc565df33e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 10:05:40
40972	9d6cc8fc-e5d8-4d8e-9328-8d04a953baf4	9d6cc8fc-ebb1-40b1-b621-08cc565df33e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"56.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:05:40
40973	9d6cc8fc-ea18-4786-9e92-5f62946be48e	9d6cc8fc-ebb1-40b1-b621-08cc565df33e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 10:05:40
40974	9d6cc8fc-ea81-409d-b51d-3bec0cd163a8	9d6cc8fc-ebb1-40b1-b621-08cc565df33e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":312,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:05:40
41197	9d6ccbda-54d8-4925-8bc7-d94c86d203f7	9d6ccbda-74a6-446f-acf2-9268dddd75cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-06 10:13:41
41198	9d6ccbda-722c-4129-9d04-7c7dad5fd8db	9d6ccbda-74a6-446f-acf2-9268dddd75cd	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-06 10:13:41
41199	9d6ccbda-734c-4cce-9b1c-4c484ee4f441	9d6ccbda-74a6-446f-acf2-9268dddd75cd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":271,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:13:41
41914	9d6cd0fa-a128-4801-8a0a-a59351c567d4	9d6cd0fa-bac6-4f46-9eee-57a0646003b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:28:01
41915	9d6cd0fa-b93a-4e1c-991d-f63a7ac6aacb	9d6cd0fa-bac6-4f46-9eee-57a0646003b2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:28:01
41916	9d6cd0fa-b9d7-40c6-814b-6b1deffc618b	9d6cd0fa-bac6-4f46-9eee-57a0646003b2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":230,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:28:01
41917	9d6cd0fb-2db6-4f70-aa57-26bffeae5f9b	9d6cd0fb-4cc1-4237-bce7-80909a24a4a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:28:01
41918	9d6cd0fb-471d-4f8d-a2e3-e72d70b1f4cf	9d6cd0fb-4cc1-4237-bce7-80909a24a4a7	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"42.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":19,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-06 10:28:01
41919	9d6cd0fb-4770-48ea-a1cf-3d122aebe706	9d6cd0fb-4cc1-4237-bce7-80909a24a4a7	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":5,"hostname":"EderCortes"}	2024-11-06 10:28:01
41920	9d6cd0fb-4b5e-40d7-9ec9-c8fec8744fa0	9d6cd0fb-4cc1-4237-bce7-80909a24a4a7	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:28:01
41921	9d6cd0fb-4bb9-4cb2-9a9d-2c7327ea84d2	9d6cd0fb-4cc1-4237-bce7-80909a24a4a7	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:55:01.000000Z","deleted_at":null,"user_alias":"eder.cortes"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:28:01
13901	9d5d13d5-4aed-403e-853a-e4cf03511148	9d5d13d5-50cb-4753-a1c0-e467b88fab02	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":643}	2024-10-29 14:41:42
41679	9d6cce9c-1f5b-4559-980f-6523d2a22223	9d6cce9c-65bd-4603-9623-c51fd3cbf2a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:21:23
41680	9d6cce9c-643e-4929-afe5-b5e8b8f157d8	9d6cce9c-65bd-4603-9623-c51fd3cbf2a5	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:21:23
41681	9d6cce9c-64d7-469b-9478-72f9a0fc2272	9d6cce9c-65bd-4603-9623-c51fd3cbf2a5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":379,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:21:23
41922	9d6cd0fd-6a1c-4a99-a8bc-ce8d5af57933	9d6cd0fd-905a-402a-a6bb-773a58015c51	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:28:02
41682	9d6cce9d-aeaf-49a8-9830-1a44ff22b955	9d6cce9d-de0b-43de-a14c-92c280ae68a3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:21:24
41683	9d6cce9d-d45b-408a-8a68-95e79cb32da0	9d6cce9d-de0b-43de-a14c-92c280ae68a3	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"56.66","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:21:24
41684	9d6cce9d-d4db-451c-b3e5-43a3a245c8e1	9d6cce9d-de0b-43de-a14c-92c280ae68a3	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:21:24
41685	9d6cce9d-dc4b-4738-b5e5-25acc1cfbc3c	9d6cce9d-de0b-43de-a14c-92c280ae68a3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:21:24
41686	9d6cce9d-dcad-4813-a3ad-134b9845453f	9d6cce9d-de0b-43de-a14c-92c280ae68a3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":495,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:21:24
41923	9d6cd0fd-88bd-4ee8-a9b4-cdcd6ac0fdda	9d6cd0fd-905a-402a-a6bb-773a58015c51	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"48.64","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:28:03
41924	9d6cd0fd-891f-42de-a6cd-9116da20c253	9d6cd0fd-905a-402a-a6bb-773a58015c51	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:28:03
41925	9d6cd0fd-8edd-420e-8689-10d9dd585c64	9d6cd0fd-905a-402a-a6bb-773a58015c51	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:28:03
41926	9d6cd0fd-8f35-4bb9-93e1-15a424f101fb	9d6cd0fd-905a-402a-a6bb-773a58015c51	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":452,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:28:03
41687	9d6cce9e-3a6a-4c9b-bb0c-04d66a992f10	9d6cce9e-8896-4551-9b7d-42b083bd44f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:21:25
41688	9d6cce9e-7fd9-435b-a3db-8fbc5ea44189	9d6cce9e-8896-4551-9b7d-42b083bd44f4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"160.94","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:21:25
41689	9d6cce9e-867d-4c2b-816c-1053bb4ca8fe	9d6cce9e-8896-4551-9b7d-42b083bd44f4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:21:25
41690	9d6cce9e-8710-4daa-aa36-c1e16a34b39b	9d6cce9e-8896-4551-9b7d-42b083bd44f4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":414,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:21:25
41927	9d6cd0fd-fd32-486a-b5ad-6dc7861090de	9d6cd0fe-1fd2-4dc6-98e6-f87f0a054490	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 10:28:03
41928	9d6cd0fe-19d7-4e66-b7f7-6e6719b0d584	9d6cd0fe-1fd2-4dc6-98e6-f87f0a054490	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"53.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:28:03
41929	9d6cd0fe-1e46-4d6d-b096-7f478917c08a	9d6cd0fe-1fd2-4dc6-98e6-f87f0a054490	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:28:03
41930	9d6cd0fe-1ea2-48a0-b769-2f39bb5b65e6	9d6cd0fe-1fd2-4dc6-98e6-f87f0a054490	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":347,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:28:03
41738	9d6ccf00-b812-491e-b72d-cb79d981db6e	9d6ccf00-d2a6-4348-82da-cc2a95b25c90	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":3,"hostname":"EderCortes"}	2024-11-06 10:22:29
41739	9d6ccf00-d107-4097-a658-3cd261edb3e1	9d6ccf00-d2a6-4348-82da-cc2a95b25c90	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:22:29
41740	9d6ccf00-d19d-410d-93f1-bc17933c5c39	9d6ccf00-d2a6-4348-82da-cc2a95b25c90	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":241,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:22:29
41741	9d6ccf02-61af-4a7d-a975-ad0dc2e06ed1	9d6ccf02-9635-453e-bee3-0dc2da4cf96f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 10:22:30
41742	9d6ccf02-8d6b-482e-8366-324f4f19c5cd	9d6ccf02-9635-453e-bee3-0dc2da4cf96f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"75.65","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:22:30
41743	9d6ccf02-8dfe-4759-aa9c-645e77d92c57	9d6ccf02-9635-453e-bee3-0dc2da4cf96f	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:22:30
41744	9d6ccf02-947e-477f-bd49-0d88515c10b3	9d6ccf02-9635-453e-bee3-0dc2da4cf96f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:22:30
41745	9d6ccf02-94de-4ec7-8a8f-2b0399157801	9d6ccf02-9635-453e-bee3-0dc2da4cf96f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":353,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:22:30
41746	9d6ccf02-f69a-4775-9a01-5a2c0143164d	9d6ccf03-1e4c-4acc-86bb-ffe5957cb958	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 10:22:31
41747	9d6ccf03-15c5-4f84-b9f6-f922693f2943	9d6ccf03-1e4c-4acc-86bb-ffe5957cb958	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"61.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:22:31
41748	9d6ccf03-1c02-4330-939c-697e518d4947	9d6ccf03-1e4c-4acc-86bb-ffe5957cb958	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 10:22:31
41749	9d6ccf03-1c9d-4a42-b4e0-3cb65b002b3a	9d6ccf03-1e4c-4acc-86bb-ffe5957cb958	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":324,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:22:31
40725	9d6cc6c8-c490-47a6-a3b6-37dc7c62c10f	9d6cc6c8-de62-433b-b923-e0501cccefb2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 09:59:30
40726	9d6cc6c8-dcb3-4337-93b9-bf48dc94b623	9d6cc6c8-de62-433b-b923-e0501cccefb2	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 09:59:30
40727	9d6cc6c8-dd51-4f1c-8b74-2826d274746c	9d6cc6c8-de62-433b-b923-e0501cccefb2	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":218,"memory":22,"hostname":"EderCortes"}	2024-11-06 09:59:30
40829	9d6cc7aa-0f07-4b66-91e5-f1777f63f964	9d6cc7aa-0ff8-403e-9bea-890d3f0f76dd	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":222,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:01:58
43166	9d6ce51e-e741-4b55-a7f7-fa7c6ade7eec	9d6ce51f-0020-4da9-a4b5-da22e32af448	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":4,"hostname":"EderCortes"}	2024-11-06 11:24:20
43167	9d6ce51e-fe73-4b03-bc55-b1b9e0bcc090	9d6ce51f-0020-4da9-a4b5-da22e32af448	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:24:20
43168	9d6ce51e-ff29-4501-9dcc-0a4a0661b4ab	9d6ce51f-0020-4da9-a4b5-da22e32af448	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/showCobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@showCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abprofile_name\\u00bb\\nLINE 5:                             profile_name,\\n                                    ^\\nHINT:  Probablemente quiera hacer referencia a la columna \\u00abusers.profile_code\\u00bb. (Connection: pgsql, SQL: \\n                     SELECT id,\\n                            name,\\n                            profile_code,\\n                            profile_name,\\n                            profile_prefix,\\n                            remember_token,\\n                            user_address,\\n                            user_age,\\n                            user_alias,\\n                            user_birth,\\n                            user_cellphone,\\n                            user_city,\\n                            user_document,\\n                            user_document_type,\\n                            user_last_name_one,\\n                            user_last_name_two,\\n                            user_neighborhood\\n                        FROM users\\n                        WHERE profile_code = 4;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":142,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"showCobrador","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":205,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:24:20
43463	9d6cea03-ed8a-4e3e-9297-78b3b1a57646	9d6cea04-0a1e-428c-89d2-eada66432778	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 11:38:01
43464	9d6cea04-08c6-4cca-a3c6-fe03f1706496	9d6cea04-0a1e-428c-89d2-eada66432778	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 11:38:01
43465	9d6cea04-0950-40ba-a58c-b03a2de5a7f2	9d6cea04-0a1e-428c-89d2-eada66432778	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":228,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:01
43462	9d6cea04-0794-42d7-98b7-aa44413b8cdc	9d6cea04-0a1e-428c-89d2-eada66432778	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2030}	2024-11-06 11:38:01
34977	9d69c13c-25d6-414c-9af2-a40dc23d5755	9d69c13c-2b9f-49b4-8df0-f8c6f3e98648	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1582}	2024-11-04 21:56:30
43279	9d6ce5c4-2bb7-422c-96f5-f518fc65ecea	9d6ce5c4-7205-4bff-a335-6bd37001458f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-06 11:26:08
43280	9d6ce5c4-707d-4165-9da8-717301f8c65e	9d6ce5c4-7205-4bff-a335-6bd37001458f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-06 11:26:08
43281	9d6ce5c4-7112-40e1-a8b9-2bb468b0776c	9d6ce5c4-7205-4bff-a335-6bd37001458f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":335,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:26:08
41201	9d6ccbda-d6ee-49a2-8e13-b2ffa63ac682	9d6ccbda-f25b-4a1d-b4ef-9c75fa0e89a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-06 10:13:41
41202	9d6ccbda-f08f-49c0-9be4-7f9b093fbfb5	9d6ccbda-f25b-4a1d-b4ef-9c75fa0e89a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-06 10:13:41
41203	9d6ccbda-f138-4dd2-971c-6c547b491f68	9d6ccbda-f25b-4a1d-b4ef-9c75fa0e89a4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":249,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:13:41
41204	9d6ccbdb-54d2-4c07-be51-29e393901d8b	9d6ccbdb-9ceb-4531-9cc1-37a0dd9e6b8f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-06 10:13:41
41205	9d6ccbdb-97a2-4633-8eeb-c8c969410955	9d6ccbdb-9ceb-4531-9cc1-37a0dd9e6b8f	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"152.06","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 10:13:41
41206	9d6ccbdb-9b62-4679-82d9-fb9a60cbf87d	9d6ccbdb-9ceb-4531-9cc1-37a0dd9e6b8f	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-06 10:13:41
41207	9d6ccbdb-9be4-4905-86fe-303fa99e73d7	9d6ccbdb-9ceb-4531-9cc1-37a0dd9e6b8f	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:13:41
41208	9d6ccbdb-fe25-42da-b282-f797983631ce	9d6ccbdc-47cb-4045-9025-695aec3ec116	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-06 10:13:42
41209	9d6ccbdc-4094-470b-a009-5d9b987e567a	9d6ccbdc-47cb-4045-9025-695aec3ec116	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"143.82","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:13:42
41210	9d6ccbdc-40f3-41f8-98e2-2c1db9fc86cb	9d6ccbdc-47cb-4045-9025-695aec3ec116	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:13:42
41211	9d6ccbdc-4633-436e-b902-d64d9885ba28	9d6ccbdc-47cb-4045-9025-695aec3ec116	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-06 10:13:42
41212	9d6ccbdc-4693-4c2b-805a-69191196701e	9d6ccbdc-47cb-4045-9025-695aec3ec116	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":422,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:13:42
41213	9d6ccbdc-8f0a-4d3c-bcb2-1cf06ddf28b2	9d6ccbdc-ae72-484b-9b24-848ad103e38e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-06 10:13:42
41214	9d6ccbdc-a7da-414c-b971-50a7ce8b11e6	9d6ccbdc-ae72-484b-9b24-848ad103e38e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"40.46","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:13:42
41215	9d6ccbdc-a828-4294-9135-27e70fbdfb24	9d6ccbdc-ae72-484b-9b24-848ad103e38e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:13:42
41216	9d6ccbdc-acfe-4f75-a417-463d5e61a1cb	9d6ccbdc-ae72-484b-9b24-848ad103e38e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-06 10:13:42
41217	9d6ccbdc-ad5e-40cf-980c-b86421749463	9d6ccbdc-ae72-484b-9b24-848ad103e38e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":247,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:13:42
41331	9d6ccc66-c1e5-4aff-943d-d851b23da62a	9d6ccc67-06e9-410e-987d-4321e0772336	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-06 10:15:13
41332	9d6ccc67-058f-4684-a5be-c5dd1f08989b	9d6ccc67-06e9-410e-987d-4321e0772336	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-06 10:15:13
41333	9d6ccc67-0619-464f-9d1d-cafbae8f58cd	9d6ccc67-06e9-410e-987d-4321e0772336	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":346,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:13
41334	9d6ccc67-6bd4-470b-a0c6-e80899c25ccd	9d6ccc67-8a63-4c47-8de8-bcaf8eba939a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-06 10:15:13
41335	9d6ccc67-85a8-4be8-8729-dac67cac563d	9d6ccc67-8a63-4c47-8de8-bcaf8eba939a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\n        EXTRACT(DAY FROM (\\n            CASE\\n                WHEN l.loans_cuando = 'D' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 day'\\n                WHEN l.loans_cuando = 'S' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 week'\\n                WHEN l.loans_cuando = 'Q' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '2 weeks'\\n                WHEN l.loans_cuando = 'M' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '1 month'\\n                WHEN l.loans_cuando = 'T' AND (l.loans_estado = 'Pendiente' OR l.loans_estado = 'En curso') THEN l.loans_fecha_ultimo_pago::date + INTERVAL '3 months'\\n                ELSE NULL\\n            END\\n            - CURRENT_DATE\\n        )) as dias_faltantes\\n    , \\n        (\\n            CASE\\n                WHEN l.loans_cuando = 'D' THEN 'Diario'\\n                WHEN l.loans_cuando = 'S' THEN 'Semanal'\\n                WHEN l.loans_cuando = 'Q' THEN 'Quinsenal'\\n                WHEN l.loans_cuando = 'M' THEN 'Mensual'\\n                WHEN l.loans_cuando = 'T' THEN 'Trimestral'\\n                ELSE NULL\\n            END\\n        ) as frecuencia_pago\\n    , \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"l\\".\\"loans_fecha_ultimo_pago\\", \\"l\\".\\"loans_cuando\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"47.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":146,"hash":"c9ecebb84aa03cf9d01e17642453880d","hostname":"EderCortes"}	2024-11-06 10:15:13
41336	9d6ccc67-88ef-4c8f-bc42-277475afc783	9d6ccc67-8a63-4c47-8de8-bcaf8eba939a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-06 10:15:13
41337	9d6ccc67-895c-4f2e-ad9d-614ad4fe9a23	9d6ccc67-8a63-4c47-8de8-bcaf8eba939a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/precautions-lis-filter","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController@listPrecautions","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Maria Antonieta"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"5","frecuencia_pago":"Semanal","id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"12","frecuencia_pago":"Quinsenal","id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"28","frecuencia_pago":"Mensual","id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"04-11-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"11","frecuencia_pago":"Quinsenal","id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Mensual","id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Semanal","id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"03-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"6","frecuencia_pago":"Semanal","id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"05-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Semanal","id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-4","frecuencia_pago":"Diario","id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"10","frecuencia_pago":"Quinsenal","id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-11-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":null,"frecuencia_pago":"Quinsenal","id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"3","frecuencia_pago":"Mensual","id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"09-10-2024","loans_cuando":"M","recomendador":"Luis andre"},{"dias_faltantes":"-21","frecuencia_pago":"Quinsenal","id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"Q","recomendador":"Luis andre"},{"dias_faltantes":"-6","frecuencia_pago":"Diario","id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"30-10-2024","loans_cuando":"D","recomendador":"Luis andre"},{"dias_faltantes":"2","frecuencia_pago":"Semanal","id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"01-11-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"},{"dias_faltantes":"-28","frecuencia_pago":"Semanal","id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","loans_fecha_ultimo_pago":"02-10-2024","loans_cuando":"S","recomendador":"Luis andre"}]},"duration":242,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:13
41338	9d6ccc67-d6d0-4499-b911-75ac84e61720	9d6ccc67-faa9-48e7-8c38-5a8a7f0f2e7a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-06 10:15:13
41339	9d6ccc67-f538-40a0-a295-e881413a07cf	9d6ccc67-faa9-48e7-8c38-5a8a7f0f2e7a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"45.49","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:15:13
41340	9d6ccc67-f58b-41f3-ae18-d27d1fa1a489	9d6ccc67-faa9-48e7-8c38-5a8a7f0f2e7a	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:15:13
41341	9d6ccc67-f96a-4d4c-8cd9-184fe2c929a7	9d6ccc67-faa9-48e7-8c38-5a8a7f0f2e7a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-06 10:15:13
41342	9d6ccc67-f9ca-4540-a60f-265a3f77cb13	9d6ccc67-faa9-48e7-8c38-5a8a7f0f2e7a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":272,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:13
41343	9d6ccc68-4673-43c1-8d22-c45134c310f1	9d6ccc68-69a2-41dc-a6d2-cdb831d71983	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-06 10:15:14
41344	9d6ccc68-640a-4dd8-aa1b-b1bfc993bae6	9d6ccc68-69a2-41dc-a6d2-cdb831d71983	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"51.59","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 10:15:14
41345	9d6ccc68-6475-4906-9949-93f660749ede	9d6ccc68-69a2-41dc-a6d2-cdb831d71983	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 10:15:14
41346	9d6ccc68-6846-43ae-b72c-3d571cb457ad	9d6ccc68-69a2-41dc-a6d2-cdb831d71983	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-06 10:15:14
41347	9d6ccc68-68a5-4247-bd70-0b3e163c0251	9d6ccc68-69a2-41dc-a6d2-cdb831d71983	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":270,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:14
40840	9d6cc7be-b1f9-489d-be52-51b8e703517c	9d6cc7be-d257-4c62-81fe-9079761f52ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-06 10:02:11
40841	9d6cc7be-d0a8-4909-b85d-4186de8a5977	9d6cc7be-d257-4c62-81fe-9079761f52ba	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-06 10:02:12
40842	9d6cc7be-d177-4669-bdd2-d6ce3e2d9c1f	9d6cc7be-d257-4c62-81fe-9079761f52ba	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":255,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:02:12
31399	9d694b8e-b62d-4713-b324-a70e486ede73	9d694b8e-c0ca-420d-9cc8-cb4c394db9b3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1500}	2024-11-04 16:27:27
41932	9d6cd12f-35ba-414d-a0d2-2e52738850bf	9d6cd12f-58fd-45a2-a49b-3bf5e58b7b01	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 10:28:35
41933	9d6cd12f-570f-4125-8229-643a7c847e3e	9d6cd12f-58fd-45a2-a49b-3bf5e58b7b01	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 10:28:35
41934	9d6cd12f-57d7-4830-941f-4b48a4dd2e1f	9d6cd12f-58fd-45a2-a49b-3bf5e58b7b01	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":293,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:28:35
43467	9d6cea04-784e-4667-a8f1-5e6d0b05b24a	9d6cea04-bf69-4250-9c1c-c6f7e7c1405b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 11:38:01
43468	9d6cea04-be13-4d30-b477-a3f9572b6dcc	9d6cea04-bf69-4250-9c1c-c6f7e7c1405b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 11:38:02
43469	9d6cea04-be9b-4ee7-b90f-216dcb2f1f56	9d6cea04-bf69-4250-9c1c-c6f7e7c1405b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":383,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:02
12450	9d5ce530-39bd-49f8-bda0-bc3b3ff9d731	9d5ce530-3c70-40e3-8939-325b4eadd56d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":598}	2024-10-29 12:31:16
43170	9d6ce52f-8a03-4b09-a687-1d3794b3bc49	9d6ce52f-a75d-4ed7-bef1-be584b0b927e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":5,"hostname":"EderCortes"}	2024-11-06 11:24:31
43171	9d6ce52f-a5e6-430a-a87e-c25ca17bd75e	9d6ce52f-a75d-4ed7-bef1-be584b0b927e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 11:24:31
43172	9d6ce52f-a67c-4f9b-9f55-e3aa19f5001d	9d6ce52f-a75d-4ed7-bef1-be584b0b927e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":255,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:24:31
6248	9d52631a-bd0e-49b3-a92b-b948d16cc1f0	9d52631a-c29b-4792-baf1-e63db2239501	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abfrom\\u00bb\\nLINE 14:     from loans l\\n             ^ (Connection: pgsql, SQL: \\n    select l.id,\\n        l.loans_documento,\\n        l.loans_nombre,\\n        l.loans_apellido_uno,\\n        l.loans_fecha,\\n        l.loans_valor_prestado,\\n        l.loans_cuotas,\\n        l.loans_estado,\\n        l.loans_intereses,\\n        ucl.name as cliente,\\n        uco.name as cobrador,\\n        ure.name as recomendador,\\n    from loans l\\n    join users ucl on l.user_customer = ucl.id\\n    join users uco on l.user_cobrador = uco.id\\n    left join users ure on l.user_recomendacion = ure.id\\n)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":315}	2024-10-24 07:09:15
38196	9d6b6028-4300-4e64-868e-4c04820f7e76	9d6b6028-469c-4991-bcb3-a65b06d649c9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1716}	2024-11-05 17:16:43
43282	9d6ce5c4-e081-4a34-8a3f-8af8661a5410	9d6ce5c4-e363-40a5-bd88-09a64da0c022	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2010}	2024-11-06 11:26:09
43283	9d6ce5c4-c97f-4e3b-9e67-d5bdeb7358aa	9d6ce5c4-e363-40a5-bd88-09a64da0c022	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-06 11:26:09
43284	9d6ce5c4-e1b6-4ec7-9231-61ce6b72e8ed	9d6ce5c4-e363-40a5-bd88-09a64da0c022	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-06 11:26:09
43285	9d6ce5c4-e247-4cfa-869a-b09568e3b3d7	9d6ce5c4-e363-40a5-bd88-09a64da0c022	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":209,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:26:09
43286	9d6ce5c5-4240-4c0b-9aba-7423cf7f4a8d	9d6ce5c5-854f-41bb-98c3-53f4e115349a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-06 11:26:09
43287	9d6ce5c5-815a-45e9-adcb-4617ba76a7b8	9d6ce5c5-854f-41bb-98c3-53f4e115349a	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT id,\\n                            name,\\n                            profile_code,\\n                            remember_token,\\n                            user_address,\\n                            user_age,\\n                            user_alias,\\n                            user_birth,\\n                            user_cellphone,\\n                            user_city,\\n                            user_document,\\n                            user_document_type,\\n                            user_last_name_one,\\n                            user_last_name_two,\\n                            user_neighborhood\\n                        FROM users\\n                        WHERE profile_code = 4;\\n                            ","time":"149.69","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":142,"hash":"e2980c10c70608ca75f9c2180abc54e1","hostname":"EderCortes"}	2024-11-06 11:26:09
43288	9d6ce5c5-842e-4f64-989e-387539d4b778	9d6ce5c5-854f-41bb-98c3-53f4e115349a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-06 11:26:09
43289	9d6ce5c5-8475-4559-8bcc-ac2375c63359	9d6ce5c5-854f-41bb-98c3-53f4e115349a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/showCobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@showCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":14,"name":"Luis andre","profile_code":4,"remember_token":null,"user_address":"Calle 750","user_age":"31","user_alias":"luis_martinez","user_birth":"1992-11-12T04:00:00.000Z","user_cellphone":"312596295","user_city":"Cali","user_document":"100465545","user_document_type":"CC","user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_neighborhood":"Bonilla aragon"}},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:26:09
43290	9d6ce5c7-1d49-40cd-9daa-646526978a40	9d6ce5c7-390d-4f2a-ac5c-182def0844cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-06 11:26:10
43291	9d6ce5c7-3452-4235-a305-a2efdd267bd1	9d6ce5c7-390d-4f2a-ac5c-182def0844cf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"41.18","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:26:10
43292	9d6ce5c7-349b-47d6-bdcc-0ac50977412b	9d6ce5c7-390d-4f2a-ac5c-182def0844cf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:26:10
43293	9d6ce5c7-37c9-43f0-baa3-888f08093a8b	9d6ce5c7-390d-4f2a-ac5c-182def0844cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-06 11:26:10
43294	9d6ce5c7-380b-4d0a-974f-06020b39400d	9d6ce5c7-390d-4f2a-ac5c-182def0844cf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:26:10
43295	9d6ce5c7-7c93-4a40-94fa-6f032704ce25	9d6ce5c7-94c3-4a7c-be6b-54011955c224	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-06 11:26:10
43296	9d6ce5c7-90e8-4675-96e9-c7cef2b0b9f0	9d6ce5c7-94c3-4a7c-be6b-54011955c224	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"38.50","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:26:10
43297	9d6ce5c7-9368-4dc6-8c81-bee8a84465f7	9d6ce5c7-94c3-4a7c-be6b-54011955c224	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-06 11:26:10
43298	9d6ce5c7-93a7-45c5-a472-de9f2d00bb14	9d6ce5c7-94c3-4a7c-be6b-54011955c224	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":215,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:26:10
1907	9d50e059-a705-4ec0-9bc8-ed16cab37d28	9d50e059-aa37-412b-82f5-036be1b1bb4d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":121}	2024-10-23 13:07:49
40844	9d6cc7bf-32f3-484f-ac9d-751ef8162123	9d6cc7bf-78c7-47ec-9b15-3a1cf4186d6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-06 10:02:12
40845	9d6cc7bf-7740-40a4-a8d2-db6fe111223f	9d6cc7bf-78c7-47ec-9b15-3a1cf4186d6b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-06 10:02:12
40846	9d6cc7bf-77e0-46d0-b702-294c1fe36749	9d6cc7bf-78c7-47ec-9b15-3a1cf4186d6b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":340,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:02:12
41349	9d6ccc68-b0de-4923-9d81-850af4b2e6c7	9d6ccc68-cf2f-41ca-b20e-1a41d1f4d317	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-06 10:15:14
41350	9d6ccc68-cd9f-45c5-a4ca-198d9ed33e0b	9d6ccc68-cf2f-41ca-b20e-1a41d1f4d317	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-06 10:15:14
41351	9d6ccc68-ce33-4744-9a20-8d62dec15698	9d6ccc68-cf2f-41ca-b20e-1a41d1f4d317	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":246,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:14
41936	9d6cd12f-ca03-4013-acf3-0c0b1e147a77	9d6cd130-0f4d-4c52-9c3b-031fa8713b71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 10:28:35
41937	9d6cd130-0dca-4472-93b6-9a3040b5a9f0	9d6cd130-0f4d-4c52-9c3b-031fa8713b71	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 10:28:36
41938	9d6cd130-0e69-486b-b32b-b93ffab8ef16	9d6cd130-0f4d-4c52-9c3b-031fa8713b71	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":369,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:28:36
41835	9d6ccfec-e6c3-4dc0-a675-6bfc5ca69dc0	9d6ccfec-e99b-4662-9a21-6c3838d119c4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1935}	2024-11-06 10:25:04
41939	9d6cd130-88f3-48f4-8b5c-63dd399d16f4	9d6cd130-ab73-4d78-ac6f-6452a5d6ef26	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 10:28:36
41940	9d6cd130-a50f-4c55-9521-8125965a28c8	9d6cd130-ab73-4d78-ac6f-6452a5d6ef26	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"47.95","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":19,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-06 10:28:36
41941	9d6cd130-a564-4f7a-9464-d8d8b8944f3e	9d6cd130-ab73-4d78-ac6f-6452a5d6ef26	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":5,"hostname":"EderCortes"}	2024-11-06 10:28:36
41942	9d6cd130-aa29-40c8-bf7a-3ca050c05c81	9d6cd130-ab73-4d78-ac6f-6452a5d6ef26	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 10:28:36
41943	9d6cd130-aa7b-467c-a267-cce5b7028086	9d6cd130-ab73-4d78-ac6f-6452a5d6ef26	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@index","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:55:01.000000Z","deleted_at":null,"user_alias":"eder.cortes"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":298,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:28:36
41944	9d6cd132-44f2-493f-a8a7-24eb5053f077	9d6cd132-6dc2-4101-a5a1-944b2e4c5f02	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 10:28:37
41945	9d6cd132-64f5-44f6-8785-24ccd38b6fdc	9d6cd132-6dc2-4101-a5a1-944b2e4c5f02	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.72","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 10:28:37
41946	9d6cd132-6567-420b-8b9d-50cd38837830	9d6cd132-6dc2-4101-a5a1-944b2e4c5f02	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 10:28:37
41947	9d6cd132-6bca-4bd2-9304-c9c95673c77a	9d6cd132-6dc2-4101-a5a1-944b2e4c5f02	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 10:28:37
41948	9d6cd132-6c39-460a-a193-920109c54001	9d6cd132-6dc2-4101-a5a1-944b2e4c5f02	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":471,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:28:37
41949	9d6cd132-eacb-44ea-af8b-b5e97f393544	9d6cd133-35e3-4737-b4b0-ed6f83912e29	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 10:28:38
41950	9d6cd133-3006-4b39-b2ed-c18e1bc510d8	9d6cd133-35e3-4737-b4b0-ed6f83912e29	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"161.59","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 10:28:38
41951	9d6cd133-345f-4970-a304-287d790b028b	9d6cd133-35e3-4737-b4b0-ed6f83912e29	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 10:28:38
41952	9d6cd133-34c1-4e3a-855f-b5e568bdeb39	9d6cd133-35e3-4737-b4b0-ed6f83912e29	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":492,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:28:38
41953	9d6cd137-1935-49dd-af6c-c91fc3c0dcb2	9d6cd137-3fde-481a-9a6d-1efb6e15a425	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 10:28:40
41954	9d6cd137-37e8-42e5-8e67-15694773b024	9d6cd137-3fde-481a-9a6d-1efb6e15a425	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"deleted_at\\" is null","time":"48.76","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":19,"hash":"6bbd874651179a63b287f70ecc074ab4","hostname":"EderCortes"}	2024-11-06 10:28:40
41955	9d6cd137-386f-4840-8cad-f79a94717fff	9d6cd137-3fde-481a-9a6d-1efb6e15a425	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":5,"hostname":"EderCortes"}	2024-11-06 10:28:40
41956	9d6cd137-3e45-4d8d-8f0b-1ebc243075a5	9d6cd137-3fde-481a-9a6d-1efb6e15a425	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 10:28:40
41957	9d6cd137-3eaf-4533-8c30-6a6c42f1da1e	9d6cd137-3fde-481a-9a6d-1efb6e15a425	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/users","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@index","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"},{"id":18,"name":"Maria Antonieta","email":"andre_01@gmail.com","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"100465546","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieve"},{"id":19,"name":"Maria Antonieta 2","email":"andre_01@gmail.co","email_verified_at":null,"user_last_name_one":"De las nieve","user_last_name_two":"ds","user_document_type":"CC","user_document":"1004655468","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon2","user_address":"Calle 7505","user_cellphone":"312596295","user_age":"29","profile_code":5,"verified":"0","created_at":"2024-10-22T21:46:01.000000Z","updated_at":"2024-10-22T21:46:01.000000Z","deleted_at":null,"user_alias":"maria_nieves2"},{"id":12,"name":"Eder Arley","email":"edercortez10@gmail.com","email_verified_at":null,"user_last_name_one":"Cortes","user_last_name_two":"Cabezas","user_document_type":"CC","user_document":"1004608333","user_birth":"2024-10-21T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Las Orquideas","user_address":"Calle 107a No 28a - 66","user_cellphone":"3152596295","user_age":"29","profile_code":1,"verified":"0","created_at":"2024-10-21T22:10:41.000000Z","updated_at":"2024-11-04T20:55:01.000000Z","deleted_at":null,"user_alias":"eder.cortes"},{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":288,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:28:40
43471	9d6cea05-1abe-4039-86d0-7e5f92340892	9d6cea05-5fef-4ab8-b80d-a72e406dec43	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 11:38:02
43472	9d6cea05-5e65-451b-ae78-3008b3f01868	9d6cea05-5fef-4ab8-b80d-a72e406dec43	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 11:38:02
43473	9d6cea05-5eed-4b80-9355-3645f42dc269	9d6cea05-5fef-4ab8-b80d-a72e406dec43	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":323,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:02
43470	9d6cea05-5d1b-4f8e-8353-c317b67826e2	9d6cea05-5fef-4ab8-b80d-a72e406dec43	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2032}	2024-11-06 11:38:02
43174	9d6ce52f-fe65-4b5f-b508-e957f58249ac	9d6ce530-1731-4db8-9a5e-271c97c69922	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":6,"hostname":"EderCortes"}	2024-11-06 11:24:31
43175	9d6ce530-15d1-492a-9b94-a6dc6d750d55	9d6ce530-1731-4db8-9a5e-271c97c69922	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 11:24:31
43176	9d6ce530-1652-420b-8636-1d4f50ee203b	9d6ce530-1731-4db8-9a5e-271c97c69922	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":204,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:24:31
43300	9d6ce5d3-ae8c-4850-948b-458dfedbd4e3	9d6ce5d3-cd34-4101-b073-19b2580aabf3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-06 11:26:18
43301	9d6ce5d3-cb92-43ac-8f6b-60ea094ed475	9d6ce5d3-cd34-4101-b073-19b2580aabf3	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-06 11:26:18
43302	9d6ce5d3-cc22-4a05-aca9-9d09cbc1fbfe	9d6ce5d3-cd34-4101-b073-19b2580aabf3	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":254,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:26:18
37330	9d6b482a-d7c2-4e6e-8bab-af114a66a902	9d6b482a-dafd-41af-bdad-d20c6ab525a6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1686}	2024-11-05 16:09:38
1541	9d50d67b-59c5-475b-bf8f-a4f763c7b7c0	9d50d67b-5d60-45cc-9cc4-2d3e79371cbf	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":107}	2024-10-23 12:40:13
43475	9d6cea05-d3b2-421b-b88e-3c84e8e87f5d	9d6cea06-1d0c-4ebc-927f-c321565e9f31	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 11:38:02
43476	9d6cea06-1bc4-4adb-ac0f-be48057efbf7	9d6cea06-1d0c-4ebc-927f-c321565e9f31	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 11:38:02
43477	9d6cea06-1c48-4318-9a3f-770d4525730b	9d6cea06-1d0c-4ebc-927f-c321565e9f31	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":375,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:02
41935	9d6cd130-0c72-4c48-9eca-99449050e440	9d6cd130-0f4d-4c52-9c3b-031fa8713b71	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1946}	2024-11-06 10:28:36
43304	9d6ce5d4-3122-4810-a4f6-85b77a2216f3	9d6ce5d4-4c6a-43f1-b008-74f151542244	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-06 11:26:19
43305	9d6ce5d4-4ab9-4b44-9e45-88fc4e5d3d3c	9d6ce5d4-4c6a-43f1-b008-74f151542244	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-06 11:26:19
43177	9d6ce530-b31e-408f-b8f6-ae5050a52ef7	9d6ce530-b578-4e94-b174-0f36f8e2cf5b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abprofile_prefix\\u00bb\\nLINE 5:                             profile_prefix,\\n                                    ^ (Connection: pgsql, SQL: \\n                     SELECT id,\\n                            name,\\n                            profile_code,\\n                            profile_prefix,\\n                            remember_token,\\n                            user_address,\\n                            user_age,\\n                            user_alias,\\n                            user_birth,\\n                            user_cellphone,\\n                            user_city,\\n                            user_document,\\n                            user_document_type,\\n                            user_last_name_one,\\n                            user_last_name_two,\\n                            user_neighborhood\\n                        FROM users\\n                        WHERE profile_code = 4;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":142},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1999}	2024-11-06 11:24:32
43178	9d6ce530-7029-4cf3-b5b9-40b2d612d486	9d6ce530-b578-4e94-b174-0f36f8e2cf5b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":7,"hostname":"EderCortes"}	2024-11-06 11:24:31
43179	9d6ce530-b438-4375-a94d-a0003751d3ba	9d6ce530-b578-4e94-b174-0f36f8e2cf5b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 11:24:32
43180	9d6ce530-b4b7-456e-9c15-72a7bea07c67	9d6ce530-b578-4e94-b174-0f36f8e2cf5b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/showCobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@showCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abprofile_prefix\\u00bb\\nLINE 5:                             profile_prefix,\\n                                    ^ (Connection: pgsql, SQL: \\n                     SELECT id,\\n                            name,\\n                            profile_code,\\n                            profile_prefix,\\n                            remember_token,\\n                            user_address,\\n                            user_age,\\n                            user_alias,\\n                            user_birth,\\n                            user_cellphone,\\n                            user_city,\\n                            user_document,\\n                            user_document_type,\\n                            user_last_name_one,\\n                            user_last_name_two,\\n                            user_neighborhood\\n                        FROM users\\n                        WHERE profile_code = 4;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":142,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"showCobrador","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:24:32
43181	9d6ce532-32fc-4e07-998e-ca71c74f9f8e	9d6ce532-590a-4251-8d1e-a38a002ac009	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":8,"hostname":"EderCortes"}	2024-11-06 11:24:33
43182	9d6ce532-5352-4206-84c5-394161c19956	9d6ce532-590a-4251-8d1e-a38a002ac009	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"50.54","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:24:33
43183	9d6ce532-53bd-462f-9f57-c3382f362b0f	9d6ce532-590a-4251-8d1e-a38a002ac009	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:24:33
43184	9d6ce532-57da-4151-ac5e-7469f9b2ad2c	9d6ce532-590a-4251-8d1e-a38a002ac009	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 11:24:33
43185	9d6ce532-581f-42af-8600-33c2a4a9921a	9d6ce532-590a-4251-8d1e-a38a002ac009	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":498,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:24:33
43306	9d6ce5d4-4b71-4b20-a917-d36240b89fe8	9d6ce5d4-4c6a-43f1-b008-74f151542244	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":236,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:26:19
43186	9d6ce532-9739-43e5-9c4a-575e35df8cfe	9d6ce532-b345-4aaa-a27e-e94ce0eb8855	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":9,"hostname":"EderCortes"}	2024-11-06 11:24:33
43187	9d6ce532-af5a-4b24-b5db-d0f19af237f3	9d6ce532-b345-4aaa-a27e-e94ce0eb8855	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"42.41","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:24:33
43188	9d6ce532-b200-4a7f-9d82-f3338d775952	9d6ce532-b345-4aaa-a27e-e94ce0eb8855	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 11:24:33
43189	9d6ce532-b24f-42ef-9d64-a840fad7348d	9d6ce532-b345-4aaa-a27e-e94ce0eb8855	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":217,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:24:33
43307	9d6ce5d4-ae43-4521-9dd1-aff7d90a1f0e	9d6ce5d4-c862-4023-b4dc-c5eb1881ccef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":22,"hostname":"EderCortes"}	2024-11-06 11:26:19
43308	9d6ce5d4-c3ed-43f5-93e8-e55f645a8380	9d6ce5d4-c862-4023-b4dc-c5eb1881ccef	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT id,\\n                            name,\\n                            profile_code,\\n                            remember_token,\\n                            user_address,\\n                            user_age,\\n                            user_alias,\\n                            user_birth,\\n                            user_cellphone,\\n                            user_city,\\n                            user_document,\\n                            user_document_type,\\n                            user_last_name_one,\\n                            user_last_name_two,\\n                            user_neighborhood\\n                        FROM users\\n                        WHERE profile_code = 4;\\n                            ","time":"44.36","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":142,"hash":"e2980c10c70608ca75f9c2180abc54e1","hostname":"EderCortes"}	2024-11-06 11:26:19
43309	9d6ce5d4-c740-4e33-9c91-861b63886200	9d6ce5d4-c862-4023-b4dc-c5eb1881ccef	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-06 11:26:19
43310	9d6ce5d4-c783-4a7a-8d85-8c41f4a24865	9d6ce5d4-c862-4023-b4dc-c5eb1881ccef	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/showCobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@showCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":14,"name":"Luis andre","profile_code":4,"remember_token":null,"user_address":"Calle 750","user_age":"31","user_alias":"luis_martinez","user_birth":"1992-11-12T04:00:00.000Z","user_cellphone":"312596295","user_city":"Cali","user_document":"100465545","user_document_type":"CC","user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_neighborhood":"Bonilla aragon"}},"duration":224,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:26:19
43311	9d6ce5d5-fe54-4e7e-8d3d-7bb58b09a3c2	9d6ce5d6-604b-427d-bdc2-feb477f356cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":23,"hostname":"EderCortes"}	2024-11-06 11:26:20
43312	9d6ce5d6-5712-4d16-8b79-9ec436dece79	9d6ce5d6-604b-427d-bdc2-feb477f356cf	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"199.50","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:26:20
43313	9d6ce5d6-579a-4d97-bbc2-e90cdf15098f	9d6ce5d6-604b-427d-bdc2-feb477f356cf	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:26:20
43314	9d6ce5d6-5e61-44a9-8ba2-8bb4a6294e46	9d6ce5d6-604b-427d-bdc2-feb477f356cf	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-06 11:26:20
43315	9d6ce5d6-5ed9-4d35-a2db-1a6b9a32b124	9d6ce5d6-604b-427d-bdc2-feb477f356cf	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":540,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:26:20
43316	9d6ce5d6-c746-49e1-bbcd-d6b27b693d57	9d6ce5d6-e489-4c19-9df3-73b943b653a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":24,"hostname":"EderCortes"}	2024-11-06 11:26:20
43317	9d6ce5d6-df7b-40a9-a50b-20b716ccf28f	9d6ce5d6-e489-4c19-9df3-73b943b653a4	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"47.11","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:26:20
43318	9d6ce5d6-e305-4d9e-b37b-6f7825b00a46	9d6ce5d6-e489-4c19-9df3-73b943b653a4	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-11-06 11:26:20
43319	9d6ce5d6-e364-444e-b9a5-63e7323393b7	9d6ce5d6-e489-4c19-9df3-73b943b653a4	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":322,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:26:20
41385	9d6ccc73-f317-45a3-b018-02075d9d035c	9d6ccc74-121a-46d7-baf7-e2b9d9848d45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":29,"hostname":"EderCortes"}	2024-11-06 10:15:21
41386	9d6ccc74-107e-441c-a6aa-e06c4b56c0c5	9d6ccc74-121a-46d7-baf7-e2b9d9848d45	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":30,"hostname":"EderCortes"}	2024-11-06 10:15:21
41387	9d6ccc74-111d-4d48-ba2a-6f5ca5a32d50	9d6ccc74-121a-46d7-baf7-e2b9d9848d45	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":269,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:21
11933	9d5cd8da-a584-44fb-9661-9a4de012c9f8	9d5cd8da-a8ab-42d3-9d9f-db51f7ebee86	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":586}	2024-10-29 11:56:47
30411	9d693de5-2791-4df7-aa04-571234cbd1fa	9d693de5-2d18-4479-91f4-8c4902b15a80	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1448}	2024-11-04 15:49:15
43479	9d6cea06-75ca-452b-b205-1706130b267a	9d6cea06-8e4a-493e-88e4-fbe77b20f833	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":12,"hostname":"EderCortes"}	2024-11-06 11:38:03
43480	9d6cea06-8ce4-4ef5-a805-54229d3a91cf	9d6cea06-8e4a-493e-88e4-fbe77b20f833	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 11:38:03
43481	9d6cea06-8d73-427b-b7b7-d3c7abbebeb9	9d6cea06-8e4a-493e-88e4-fbe77b20f833	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":209,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:03
30527	9d693fd1-4b18-417f-864c-6c748f447934	9d693fd1-4e12-4cd5-94b1-b7d21c2f5408	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1456}	2024-11-04 15:54:38
43191	9d6ce532-f4d1-422b-a932-09de167cc6fa	9d6ce533-3558-4086-84b8-aba48a8d902b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":10,"hostname":"EderCortes"}	2024-11-06 11:24:33
43192	9d6ce533-33b0-4b1e-866b-e34a3df4d3f8	9d6ce533-3558-4086-84b8-aba48a8d902b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":11,"hostname":"EderCortes"}	2024-11-06 11:24:33
43193	9d6ce533-3457-4867-96ba-8e9262b98fdc	9d6ce533-3558-4086-84b8-aba48a8d902b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/showCobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@showCobrador","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abprofile_prefix\\u00bb\\nLINE 5:                             profile_prefix,\\n                                    ^ (Connection: pgsql, SQL: \\n                     SELECT id,\\n                            name,\\n                            profile_code,\\n                            profile_prefix,\\n                            remember_token,\\n                            user_address,\\n                            user_age,\\n                            user_alias,\\n                            user_birth,\\n                            user_cellphone,\\n                            user_city,\\n                            user_document,\\n                            user_document_type,\\n                            user_last_name_one,\\n                            user_last_name_two,\\n                            user_neighborhood\\n                        FROM users\\n                        WHERE profile_code = 4;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":142,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"showCobrador","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":314,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:24:33
41391	9d6ccc74-935e-4849-bba5-7634449dfbf6	9d6ccc74-9479-469d-b78e-1208c9547d43	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":226,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:22
43483	9d6cea06-fa4a-44a1-bd64-8d5737973142	9d6cea07-3ebf-49b2-8f79-7300239fa66c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":13,"hostname":"EderCortes"}	2024-11-06 11:38:03
43484	9d6cea07-3d5c-4814-9e40-ec58404929d9	9d6cea07-3ebf-49b2-8f79-7300239fa66c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 11:38:03
43485	9d6cea07-3ded-4353-9924-8490b4808539	9d6cea07-3ebf-49b2-8f79-7300239fa66c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":367,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:03
43321	9d6ce5de-1ceb-479f-9c98-ce1920fe8575	9d6ce5de-3a11-47df-bca4-3e8fa72394a8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":25,"hostname":"EderCortes"}	2024-11-06 11:26:25
43322	9d6ce5de-3888-4796-a424-3311b6bd52be	9d6ce5de-3a11-47df-bca4-3e8fa72394a8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-11-06 11:26:25
43323	9d6ce5de-391b-48d5-9799-a296f4072bfc	9d6ce5de-3a11-47df-bca4-3e8fa72394a8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":231,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:26:25
41421	9d6ccc8f-0120-4ce0-ad9d-8ed8d6b2c621	9d6ccc8f-4cc1-44a2-8398-c563429614d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":1,"hostname":"EderCortes"}	2024-11-06 10:15:39
41422	9d6ccc8f-4afc-430e-97da-a8d85c70fafd	9d6ccc8f-4cc1-44a2-8398-c563429614d8	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":2,"hostname":"EderCortes"}	2024-11-06 10:15:39
41423	9d6ccc8f-4b9e-4905-bfcb-0ed815afa06c	9d6ccc8f-4cc1-44a2-8398-c563429614d8	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":390,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:39
41420	9d6ccc8f-49a7-49a2-9ed7-64930241d7e1	9d6ccc8f-4cc1-44a2-8398-c563429614d8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1899}	2024-11-06 10:15:39
43487	9d6cea07-98ce-4649-97e6-d421cbfe2475	9d6cea07-b315-41ee-8a7f-401b0e01e36c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":14,"hostname":"EderCortes"}	2024-11-06 11:38:03
43488	9d6cea07-b1c0-49be-85b4-6ead6e163b22	9d6cea07-b315-41ee-8a7f-401b0e01e36c	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-06 11:38:04
43489	9d6cea07-b246-4198-92ba-73dddb593584	9d6cea07-b315-41ee-8a7f-401b0e01e36c	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":213,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:04
43478	9d6cea06-8b9a-414e-b29c-b3fe6de393ac	9d6cea06-8e4a-493e-88e4-fbe77b20f833	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2034}	2024-11-06 11:38:03
29634	9d6929f8-c76b-4647-8f92-081555554c74	9d6929f8-cd16-418a-8251-59c62ecd955e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1399}	2024-11-04 14:53:32
43325	9d6ce5de-9742-456b-8531-d818c00d2a07	9d6ce5de-dae8-4d3c-b145-78653554adf9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":26,"hostname":"EderCortes"}	2024-11-06 11:26:25
43326	9d6ce5de-d98c-4025-b839-829a8172e732	9d6ce5de-dae8-4d3c-b145-78653554adf9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-11-06 11:26:26
43327	9d6ce5de-da12-4a40-a214-c5f453f61dcb	9d6ce5de-dae8-4d3c-b145-78653554adf9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":318,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:26:26
43328	9d6ce5df-444f-4d8d-ad70-12262f6bce39	9d6ce5df-5f2d-44ab-8b65-7e063f52c9b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-11-06 11:26:26
43329	9d6ce5df-5a05-4ed5-ad88-24eb978be2e2	9d6ce5df-5f2d-44ab-8b65-7e063f52c9b9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT id,\\n                            name,\\n                            profile_code,\\n                            remember_token,\\n                            user_address,\\n                            user_age,\\n                            user_alias,\\n                            user_birth,\\n                            user_cellphone,\\n                            user_city,\\n                            user_document,\\n                            user_document_type,\\n                            user_last_name_one,\\n                            user_last_name_two,\\n                            user_neighborhood\\n                        FROM users\\n                        WHERE profile_code = 4;\\n                            ","time":"42.01","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":142,"hash":"e2980c10c70608ca75f9c2180abc54e1","hostname":"EderCortes"}	2024-11-06 11:26:26
43330	9d6ce5df-5dbf-43b9-9d1e-09c68a43d132	9d6ce5df-5f2d-44ab-8b65-7e063f52c9b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-11-06 11:26:26
43331	9d6ce5df-5e1d-4a41-a9a2-dfeee16d457c	9d6ce5df-5f2d-44ab-8b65-7e063f52c9b9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/showCobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@showCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":{"id":14,"name":"Luis andre","profile_code":4,"remember_token":null,"user_address":"Calle 750","user_age":"31","user_alias":"luis_martinez","user_birth":"1992-11-12T04:00:00.000Z","user_cellphone":"312596295","user_city":"Cali","user_document":"100465545","user_document_type":"CC","user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_neighborhood":"Bonilla aragon"}},"duration":242,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:26:26
43332	9d6ce5e1-1ba9-4fcf-96f2-a910b2ef6048	9d6ce5e1-3c5b-4161-95f5-fd6439b0b180	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-11-06 11:26:27
43333	9d6ce5e1-3715-4b7d-8f1d-cb52bb432dad	9d6ce5e1-3c5b-4161-95f5-fd6439b0b180	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = '1' and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc","time":"45.62","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"hash":"04ab8c48f9c1fbb6667e1945a8b35b64","hostname":"EderCortes"}	2024-11-06 11:26:27
43334	9d6ce5e1-375c-44a4-8dc3-59bb6fffc2b8	9d6ce5e1-3c5b-4161-95f5-fd6439b0b180	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\Menu","count":8,"hostname":"EderCortes"}	2024-11-06 11:26:27
43335	9d6ce5e1-3acd-4c74-9561-1920a33c00ec	9d6ce5e1-3c5b-4161-95f5-fd6439b0b180	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":29,"hostname":"EderCortes"}	2024-11-06 11:26:27
43336	9d6ce5e1-3b4d-4515-8301-7abcb53f87b2	9d6ce5e1-3c5b-4161-95f5-fd6439b0b180	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":1,"menu_name":"Inicio","menu_url":"\\/dashboard"},{"id":8,"menu_name":"Compa\\u00f1ia","menu_url":"\\/dashboard\\/company"},{"id":3,"menu_name":"Recaudos","menu_url":"\\/dashboard\\/list-precautions"},{"id":4,"menu_name":"Prestamos","menu_url":"\\/dashboard\\/list-loans"},{"id":5,"menu_name":"Cobrador","menu_url":"\\/dashboard\\/list-charge"},{"id":2,"menu_name":"Usuarios","menu_url":"\\/dashboard\\/list-users"},{"id":7,"menu_name":"Garantia","menu_url":"\\/dashboard\\/list-warranty"},{"id":6,"menu_name":"Barrios","menu_url":"\\/dashboard\\/list-neighborhood"}]},"duration":307,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:26:27
43337	9d6ce5e1-7f1a-481d-b069-6777adf0808f	9d6ce5e1-c159-4626-bf54-4e627a2269b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":29,"hostname":"EderCortes"}	2024-11-06 11:26:27
43338	9d6ce5e1-bcca-4d33-9b6e-6939fd0872b3	9d6ce5e1-c159-4626-bf54-4e627a2269b9	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"\\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 1;\\n                            ","time":"147.20","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"hash":"4a72cb202c1b255af4c22c15ee88e90a","hostname":"EderCortes"}	2024-11-06 11:26:28
43339	9d6ce5e1-bff9-40c1-b228-401dd26e0534	9d6ce5e1-c159-4626-bf54-4e627a2269b9	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":30,"hostname":"EderCortes"}	2024-11-06 11:26:28
43340	9d6ce5e1-c03e-4833-885c-b8c43b6f04e2	9d6ce5e1-c159-4626-bf54-4e627a2269b9	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/1","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"host":"localhost:8000","connection":"keep-alive","sec-ch-ua-platform":"\\"Windows\\"","user-agent":"Mozilla\\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\\/537.36 (KHTML, like Gecko) Chrome\\/130.0.0.0 Safari\\/537.36","accept":"application\\/json, text\\/plain, *\\/*","sec-ch-ua":"\\"Chromium\\";v=\\"130\\", \\"Google Chrome\\";v=\\"130\\", \\"Not?A_Brand\\";v=\\"99\\"","sec-ch-ua-mobile":"?0","origin":"http:\\/\\/localhost:4200","sec-fetch-site":"same-site","sec-fetch-mode":"cors","sec-fetch-dest":"empty","referer":"http:\\/\\/localhost:4200\\/","accept-encoding":"gzip, deflate, br, zstd","accept-language":"es-US,es-419;q=0.9,es;q=0.8"},"payload":[],"session":[],"response_status":200,"response":{"data":{"name":"Eder Arley","user_alias":"eder.cortes","profile_name":"Administrador"}},"duration":327,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:26:28
41427	9d6ccc8f-cce4-4380-a7cc-9ff166be64c6	9d6ccc8f-cdf6-41a1-a04a-223ab9892011	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":224,"memory":22,"hostname":"EderCortes"}	2024-11-06 10:15:40
43491	9d6cea08-1ebc-44f9-8088-aaa340d91195	9d6cea08-391c-416c-83dc-79c4cd775eb6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":15,"hostname":"EderCortes"}	2024-11-06 11:38:04
43492	9d6cea08-37c6-4196-809b-8ab670df6718	9d6cea08-391c-416c-83dc-79c4cd775eb6	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-06 11:38:04
43493	9d6cea08-3852-4989-8539-c070b21db4e0	9d6cea08-391c-416c-83dc-79c4cd775eb6	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":222,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:04
43482	9d6cea07-3c29-4232-b6bb-d8e5a8717bcd	9d6cea07-3ebf-49b2-8f79-7300239fa66c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2035}	2024-11-06 11:38:03
43342	9d6ce5ec-2bc4-4178-a57d-b58422f387f7	9d6ce5ec-497e-46ba-9542-7cfaf1f244ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":30,"hostname":"EderCortes"}	2024-11-06 11:26:34
43343	9d6ce5ec-47f8-48fb-85f5-04fc2ba3e639	9d6ce5ec-497e-46ba-9542-7cfaf1f244ee	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":31,"hostname":"EderCortes"}	2024-11-06 11:26:34
43344	9d6ce5ec-4887-4aee-9299-11c318c1a50b	9d6ce5ec-497e-46ba-9542-7cfaf1f244ee	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":238,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:26:34
20732	9d66fbc9-b2e6-413c-b9ef-4f7b07221bc8	9d66fbc9-b60d-41d1-a2b8-5c91fb1065a3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1027}	2024-11-03 12:52:45
43495	9d6cea08-9810-4e54-bb77-0dd1456e6170	9d6cea08-dc74-4cdb-aae3-f751c938861a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":16,"hostname":"EderCortes"}	2024-11-06 11:38:04
43496	9d6cea08-db19-4439-92ef-5629237517c0	9d6cea08-dc74-4cdb-aae3-f751c938861a	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-06 11:38:04
43497	9d6cea08-dba6-4b02-a8cd-51e21e6342a2	9d6cea08-dc74-4cdb-aae3-f751c938861a	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":327,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:04
43498	9d6cea09-3f73-4836-8ab5-40fc38c1d8c5	9d6cea09-82a7-49ef-adb4-2be9b564c3ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":17,"hostname":"EderCortes"}	2024-11-06 11:38:05
43499	9d6cea09-7e5b-4d72-b1c5-4141dac925cb	9d6cea09-82a7-49ef-adb4-2be9b564c3ce	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id\\" desc","time":"145.33","slow":true,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":89,"hash":"f9f3598e6ad2468770f89917d2ab916c","hostname":"EderCortes"}	2024-11-06 11:38:05
43500	9d6cea09-8173-4566-a5f8-41ca8fe7da30	9d6cea09-82a7-49ef-adb4-2be9b564c3ce	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-06 11:38:05
43501	9d6cea09-81d6-4ee2-aa1e-4a47c92ed531	9d6cea09-82a7-49ef-adb4-2be9b564c3ce	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/getLoansCobrador","method":"POST","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getLoansCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","content-type":"application\\/json","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"60"},"payload":{"cobrador":null,"frecuencia":null,"estado":null,"prestamista":null},"session":[],"response_status":200,"response":{"data":[{"id":94,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":6000000,"loans_cuotas":18,"loans_estado":"En curso","loans_intereses":20,"cobrador":"Luis andre","recomendador":"Maria Antonieta"},{"id":93,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Juan Carlos","recomendador":"Maria Antonieta"},{"id":92,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":8000009,"loans_cuotas":15,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":91,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":5000000,"loans_cuotas":8,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":90,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":89,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":88,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":87,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":86,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":85,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":84,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":83,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":82,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":81,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":80,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":79,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":78,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":77,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":76,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":75,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":74,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":73,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":72,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":71,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1100000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":70,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":2150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":69,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"04-11-2024","loans_valor_prestado":1150000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":68,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":10000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":66,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":5000000,"loans_cuotas":10,"loans_estado":"Cancelado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":65,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"03-11-2024","loans_valor_prestado":3000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":64,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":2000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":63,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"17-11-2024","loans_valor_prestado":1000000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":40,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":62,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":61,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":60,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Cancelado","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":59,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"En curso","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":58,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":57,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"30-10-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":56,"loans_documento":1004655468,"loans_nombre":"Maria Antonieta 2","loans_apellido_uno":"De las nieve","loans_fecha":"06-11-2024","loans_valor_prestado":500000,"loans_cuotas":5,"loans_estado":"Pendiente","loans_intereses":50,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":55,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"15-11-2024","loans_valor_prestado":50000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":54,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-2024","loans_valor_prestado":600000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":52,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"12-11-24","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":39,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"2024-11-12T05:00:00.000Z","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Anulado","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":32,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":7,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":31,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"29-10-2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":30,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":1000000,"loans_cuotas":10,"loans_estado":"Pendiente","loans_intereses":30,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":29,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":700000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":28,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600081,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":27,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600001,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":26,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":23,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":600000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":22,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"},{"id":16,"loans_documento":100465546,"loans_nombre":"Maria Antonieta","loans_apellido_uno":"De las nieve","loans_fecha":"Tue Oct 29 2024","loans_valor_prestado":500000,"loans_cuotas":6,"loans_estado":"Pendiente","loans_intereses":25,"cobrador":"Luis andre","recomendador":"Luis andre"}]},"duration":328,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:05
43502	9d6cea09-c81c-48d2-805c-8298012e0653	9d6cea09-e710-4b45-81de-a792e0206c2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":18,"hostname":"EderCortes"}	2024-11-06 11:38:05
43503	9d6cea09-e269-4057-b2f4-563c43784832	9d6cea09-e710-4b45-81de-a792e0206c2b	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '4' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"46.60","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 11:38:05
43504	9d6cea09-e2b5-4160-80ee-d14b3a2327ff	9d6cea09-e710-4b45-81de-a792e0206c2b	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 11:38:05
43505	9d6cea09-e5cd-46a7-98f0-f35f54fbc2c9	9d6cea09-e710-4b45-81de-a792e0206c2b	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-06 11:38:05
43506	9d6cea09-e61c-4fd0-9ad5-821835774c24	9d6cea09-e710-4b45-81de-a792e0206c2b	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/4","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":14,"name":"Luis andre","email":"andre@gmail.com","email_verified_at":null,"user_last_name_one":"Herrera","user_last_name_two":"MArtinez","user_document_type":"CC","user_document":"100465545","user_birth":"1992-11-12T04:00:00.000Z","user_city":"Cali","user_neighborhood":"Bonilla aragon","user_address":"Calle 750","user_cellphone":"312596295","user_age":"31","profile_code":4,"verified":"0","created_at":"2024-10-22T21:45:02.000000Z","updated_at":"2024-10-22T21:45:02.000000Z","deleted_at":null,"user_alias":"luis_martinez"}]},"duration":243,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:05
43348	9d6ce5ec-c49f-4b4e-924d-fd9b8865a514	9d6ce5ec-c584-421e-b52f-a7804a2bd620	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":211,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:26:35
43507	9d6cea0a-24cd-45a7-b326-ab27e4554d13	9d6cea0a-4133-416f-b9a1-1e5399382d2e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":19,"hostname":"EderCortes"}	2024-11-06 11:38:05
43508	9d6cea0a-3c9b-4d75-bea8-628b90209eb0	9d6cea0a-4133-416f-b9a1-1e5399382d2e	\N	t	query	{"connection":"pgsql","bindings":[],"sql":"select * from \\"users\\" where \\"users\\".\\"profile_code\\" = '3' and \\"users\\".\\"deleted_at\\" is null order by \\"users\\".\\"created_at\\" asc","time":"41.12","slow":false,"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController.php","line":297,"hash":"2cc4474fef1407722080af3f536f1134","hostname":"EderCortes"}	2024-11-06 11:38:05
43509	9d6cea0a-3ce5-4627-94b9-90daf013f01b	9d6cea0a-4133-416f-b9a1-1e5399382d2e	\N	t	model	{"action":"retrieved","model":"App\\\\Models\\\\User","count":1,"hostname":"EderCortes"}	2024-11-06 11:38:05
43510	9d6cea0a-3ff6-450d-9b84-74da492f491f	9d6cea0a-4133-416f-b9a1-1e5399382d2e	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-06 11:38:05
43511	9d6cea0a-4049-495e-8218-328dfb9ec6b7	9d6cea0a-4133-416f-b9a1-1e5399382d2e	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/loans\\/cobrador\\/3","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansController@getCobrador","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":200,"response":{"data":[{"id":22,"name":"Juan Carlos","email":"juan@gmail.com","email_verified_at":null,"user_last_name_one":"Jaramillo","user_last_name_two":"Herrera","user_document_type":"CC","user_document":"100458955","user_birth":"2024-11-11T05:00:00.000Z","user_city":"Cali","user_neighborhood":"Manuela","user_address":"Calle 108","user_cellphone":"3152596298","user_age":"28","profile_code":3,"verified":"0","created_at":"2024-11-04T22:13:53.000000Z","updated_at":"2024-11-05T03:11:05.000000Z","deleted_at":null,"user_alias":"juan_jaramillo"}]},"duration":217,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:05
43513	9d6cea0a-8c2d-4bed-8b53-40b0085979bf	9d6cea0a-d1bc-4113-966c-95ca9eb96bd0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":20,"hostname":"EderCortes"}	2024-11-06 11:38:05
43514	9d6cea0a-d06a-4d31-b8c7-6c2c71513e60	9d6cea0a-d1bc-4113-966c-95ca9eb96bd0	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":21,"hostname":"EderCortes"}	2024-11-06 11:38:06
43515	9d6cea0a-d0f1-418b-87bc-f203434ffae7	9d6cea0a-d1bc-4113-966c-95ca9eb96bd0	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":357,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:06
43538	9d6cea0d-7d22-406f-8f72-58403b76afd2	9d6cea0d-7e3c-482e-9305-f9269ae07c43	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":271,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:07
43544	9d6cea0e-6b68-4c94-a299-75a5abac82de	9d6cea0e-87d0-4b3a-9a4c-fe6869f37353	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":27,"hostname":"EderCortes"}	2024-11-06 11:38:08
43545	9d6cea0e-8646-4467-ba07-e966347b7f6f	9d6cea0e-87d0-4b3a-9a4c-fe6869f37353	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-11-06 11:38:08
43546	9d6cea0e-86de-4f8a-9762-4496b5beefde	9d6cea0e-87d0-4b3a-9a4c-fe6869f37353	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":220,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:08
43543	9d6cea0e-84e0-41ba-b4c8-67b5f0dbc6de	9d6cea0e-87d0-4b3a-9a4c-fe6869f37353	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2042}	2024-11-06 11:38:08
43548	9d6cea0e-ef2e-4e5f-a059-b5d7dd7be1a3	9d6cea0f-34d1-41a0-a415-6ea0100a4255	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":28,"hostname":"EderCortes"}	2024-11-06 11:38:08
43549	9d6cea0f-3330-4d74-8e2a-64b3872b68c7	9d6cea0f-34d1-41a0-a415-6ea0100a4255	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":29,"hostname":"EderCortes"}	2024-11-06 11:38:08
43550	9d6cea0f-33d8-4b9f-ba6d-cddcf5511c76	9d6cea0f-34d1-41a0-a415-6ea0100a4255	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":337,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:08
43512	9d6cea0a-cf31-4448-a0c1-f5414830f6c2	9d6cea0a-d1bc-4113-966c-95ca9eb96bd0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2039}	2024-11-06 11:38:06
43547	9d6cea0f-31a8-4838-a146-06e05bbd6bf1	9d6cea0f-34d1-41a0-a415-6ea0100a4255	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2043}	2024-11-06 11:38:08
43554	9d6cea0f-bb39-4ee6-8f3a-91be1901b067	9d6cea0f-bc26-430c-9a50-ffeef84c61e5	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":232,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:09
43556	9d6cea10-2196-482f-b67b-eb84201182c2	9d6cea10-3d0d-41b4-9db2-22765e8ab852	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":30,"hostname":"EderCortes"}	2024-11-06 11:38:09
43557	9d6cea10-3b9b-4820-870d-2b8b58746d92	9d6cea10-3d0d-41b4-9db2-22765e8ab852	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":31,"hostname":"EderCortes"}	2024-11-06 11:38:09
43558	9d6cea10-3c3d-42a3-ac20-60ad08c67dc1	9d6cea10-3d0d-41b4-9db2-22765e8ab852	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":217,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:09
43555	9d6cea10-3a17-4069-8d7e-3f9a11a3393c	9d6cea10-3d0d-41b4-9db2-22765e8ab852	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2045}	2024-11-06 11:38:09
43562	9d6cea10-f369-42c4-ae31-c997a8c8ff84	9d6cea10-f43c-465c-9f1a-7dc4b77d14fb	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/get-user-data\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController@getUserData","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355,"function":"__call","class":"Illuminate\\\\Database\\\\DatabaseManager","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127,"function":"__callStatic","class":"Illuminate\\\\Support\\\\Facades\\\\Facade","type":"::"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"getUserData","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":330,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:10
43578	9d6cea12-84e8-4a95-84b1-7a966c52be95	9d6cea12-9fe3-4937-8b01-72563239ef94	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":35,"hostname":"EderCortes"}	2024-11-06 11:38:11
43579	9d6cea12-9e85-4a2a-b990-d084c5b363bb	9d6cea12-9fe3-4937-8b01-72563239ef94	\N	t	cache	{"type":"hit","key":"a75f3f172bfb296f2e10cbfc6dfc1883","value":36,"hostname":"EderCortes"}	2024-11-06 11:38:11
43580	9d6cea12-9f14-4a66-a331-83764d974616	9d6cea12-9fe3-4937-8b01-72563239ef94	\N	t	request	{"ip_address":"127.0.0.1","uri":"\\/api\\/v1\\/side-menu\\/undefined","method":"GET","controller_action":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController@show","middleware":["api"],"headers":{"accept":"application\\/json, text\\/plain, *\\/*","connection":"keep-alive","host":"localhost:8000","user-agent":"Mozilla\\/5.0 (Windows_NT x64) node.js\\/20.10.0 v8\\/11.3.244.8-node.25","content-length":"0"},"payload":[],"session":[],"response_status":500,"response":{"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","exception":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783,"function":"runQueryCallback","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414,"function":"run","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913,"function":"select","class":"Illuminate\\\\Database\\\\Connection","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902,"function":"runSelect","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456,"function":"Illuminate\\\\Database\\\\Query\\\\{closure}","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901,"function":"onceWithColumns","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739,"function":"get","class":"Illuminate\\\\Database\\\\Query\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723,"function":"getModels","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47,"function":"get","class":"Illuminate\\\\Database\\\\Eloquent\\\\Builder","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54,"function":"show","class":"App\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43,"function":"callAction","class":"Illuminate\\\\Routing\\\\Controller","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259,"function":"dispatch","class":"Illuminate\\\\Routing\\\\ControllerDispatcher","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205,"function":"runController","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806,"function":"run","class":"Illuminate\\\\Routing\\\\Route","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Routing\\\\{closure}","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125,"function":"handleRequest","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87,"function":"handleRequestUsingNamedLimiter","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784,"function":"runRouteWithinStack","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748,"function":"runRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737,"function":"dispatchToRoute","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200,"function":"dispatch","class":"Illuminate\\\\Routing\\\\Router","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144,"function":"Illuminate\\\\Foundation\\\\Http\\\\{closure}","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\HandleCors","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183,"function":"handle","class":"Illuminate\\\\Http\\\\Middleware\\\\TrustProxies","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119,"function":"Illuminate\\\\Pipeline\\\\{closure}","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175,"function":"then","class":"Illuminate\\\\Pipeline\\\\Pipeline","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144,"function":"sendRequestThroughRouter","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51,"function":"handle","class":"Illuminate\\\\Foundation\\\\Http\\\\Kernel","type":"->"},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16,"function":"require_once"}]},"duration":218,"memory":22,"hostname":"EderCortes"}	2024-11-06 11:38:11
43577	9d6cea12-9d2e-45df-99e1-1abb585161e3	9d6cea12-9fe3-4937-8b01-72563239ef94	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2047}	2024-11-06 11:38:11
3237	9d510393-2c43-4e2a-834f-0bf5276f3afa	9d510393-31da-44ec-aaa9-862cf79de5db	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":182}	2024-10-23 14:46:18
6333	9d52647a-ab2b-403a-954f-7da4c93b412e	9d52647a-af39-4978-97fd-0d396a0db1c6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abfrom\\u00bb\\nLINE 13:     from loans l\\n             ^ (Connection: pgsql, SQL: \\n    select l.id,\\n        l.loans_documento,\\n        l.loans_nombre,\\n        l.loans_apellido_uno,\\n        l.loans_fecha,\\n        l.loans_valor_prestado,\\n        l.loans_cuotas,\\n        l.loans_estado,\\n        l.loans_intereses,\\n        uco.name as cobrador,\\n        ure.name as recomendador,\\n    from loans l\\n    join users ucl on l.user_customer = ucl.id\\n    join users uco on l.user_cobrador = uco.id\\n    left join users ure on l.user_recomendacion = ure.id\\n)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":330}	2024-10-24 07:13:06
19988	9d66ec7b-caf7-4b06-92a1-499b75cd2552	9d66ec7b-ce17-4c57-8fcf-49a10e0c5204	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":986}	2024-11-03 12:09:57
19589	9d66e129-8e7e-4fa7-b912-3a27be963b2d	9d66e129-9248-4197-85d4-d2194acd30d3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":963}	2024-11-03 11:38:18
10516	9d570edf-0a79-4aca-998f-8ff85169a0ee	9d570edf-0e8a-4cd1-97ac-9c982c45f0f9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":522}	2024-10-26 14:52:52
6239	9d526317-0ed6-4e9b-8be1-e85dee34d9b3	9d526317-127b-480c-892b-668e4f4563a6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abfrom\\u00bb\\nLINE 14:     from loans l\\n             ^ (Connection: pgsql, SQL: \\n    select l.id,\\n        l.loans_documento,\\n        l.loans_nombre,\\n        l.loans_apellido_uno,\\n        l.loans_fecha,\\n        l.loans_valor_prestado,\\n        l.loans_cuotas,\\n        l.loans_estado,\\n        l.loans_intereses,\\n        ucl.name as cliente,\\n        uco.name as cobrador,\\n        ure.name as recomendador,\\n    from loans l\\n    join users ucl on l.user_customer = ucl.id\\n    join users uco on l.user_cobrador = uco.id\\n    left join users ure on l.user_recomendacion = ure.id\\n)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":314}	2024-10-24 07:09:13
10838	9d5ca433-5bbf-4bd3-9104-9c70ceedc5d9	9d5ca433-5ecb-4e28-8c69-84cad5ac3971	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":542}	2024-10-29 09:29:33
29846	9d692bf1-a43e-48cc-8c06-728e918e18e5	9d692bf1-a776-4082-a15e-4dc8f7cba0bb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1414}	2024-11-04 14:59:03
14417	9d5d1e22-9df7-4c78-bd04-266df1c07915	9d5d1e22-a48c-4095-960f-6195a9b9f8b5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":661}	2024-10-29 15:10:31
43324	9d6ce5de-d81d-4765-a563-946903d0f0a7	9d6ce5de-dae8-4d3c-b145-78653554adf9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2014}	2024-11-06 11:26:26
611	9d4f2d69-d315-4884-9458-bc6166be6db0	9d4f2d69-d623-4035-9241-475b65746ce0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":44}	2024-10-22 16:51:38
39799	9d6cb63a-7fe0-4889-926c-96e6c7d3bb94	9d6cb63a-86e7-41ad-9276-a569c5094c1a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1778}	2024-11-06 09:13:13
27221	9d68e2f9-0860-4ee3-a92f-f1a3c8824016	9d68e2f9-0d55-490b-8715-ddb333c8bcb5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1268}	2024-11-04 11:35:01
31465	9d694c3a-2b3c-4c0c-8d14-e3513b04dc5a	9d694c3a-308a-4298-b2b4-3ab695a59980	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1504}	2024-11-04 16:29:20
3593	9d5108eb-464d-4f5f-9dae-71d220da3228	9d5108eb-4d00-486b-b87e-c412f3cad1d1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":201}	2024-10-23 15:01:15
28559	9d6901f6-cf90-48e4-903a-12b59e28fbed	9d6901f6-d57b-4ec8-b0cb-2ed39953888d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1332}	2024-11-04 13:01:40
16660	9d64d53a-d27c-4caf-91d4-1a37bcc72281	9d64d53a-d812-4293-837b-e07ab723e433	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":776}	2024-11-02 11:13:16
18300	9d668d88-8096-49ba-9517-10f849b908d0	9d668d88-8838-4271-9693-b7e244a6fae1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":879}	2024-11-03 07:44:27
19011	9d66ce7a-bf01-485b-a53d-14d0cfe1b274	9d66ce7a-c34f-4a40-b62e-395eaa923e95	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":928}	2024-11-03 10:46:03
19799	9d66e722-a989-4039-b0f5-027f8b3e5d7b	9d66e722-ad8c-42a5-a687-390ed0079136	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":977}	2024-11-03 11:55:00
13154	9d5cf9d1-07c8-4102-ae3d-e3922b12ecfb	9d5cf9d1-0db1-4bd0-829e-1d2e74f16e0d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":626}	2024-10-29 13:28:57
25702	9d68c883-b49d-4683-ae3e-e03c4b710a0b	9d68c883-b911-46eb-a038-35b3c8714d7e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1180}	2024-11-04 10:21:02
10824	9d5ca41d-1685-4993-8ad7-8165ce84ba51	9d5ca41d-2aea-47d9-b82d-3ffdafd74bfb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":541}	2024-10-29 09:29:19
24909	9d68bdea-5d0c-4a53-b3f1-ad6a7728830d	9d68bdea-633e-403e-aed5-e638e1190ee6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1131}	2024-11-04 09:51:24
16422	9d64c98f-2db2-4260-b03d-afe247b4c2e0	9d64c98f-3130-4910-aea2-2c0b68b31dfd	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":763}	2024-11-02 10:40:38
43115	9d6ce4c5-de29-4a9b-ad05-ca9bdb80d818	9d6ce4c5-e13c-4169-b9d5-0fa9f0cf4479	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abFROM\\u00bb\\nLINE 19:                         FROM users\\n                                 ^ (Connection: pgsql, SQL: \\n                     SELECT id,\\n                            name,\\n                            profile_code,\\n                            profile_name,\\n                            profile_prefix,\\n                            remember_token,\\n                            user_address,\\n                            user_age,\\n                            user_alias,\\n                            user_birth,\\n                            user_cellphone,\\n                            user_city,\\n                            user_document,\\n                            user_document_type,\\n                            user_last_name_one,\\n                            user_last_name_two,\\n                            user_neighborhood,\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 4;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":142},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1988}	2024-11-06 11:23:22
43127	9d6ce505-6592-465f-b1d0-53078cf69168	9d6ce505-68da-4758-b8c4-4ef847331d08	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abFROM\\u00bb\\nLINE 19:                         FROM users\\n                                 ^ (Connection: pgsql, SQL: \\n                     SELECT id,\\n                            name,\\n                            profile_code,\\n                            profile_name,\\n                            profile_prefix,\\n                            remember_token,\\n                            user_address,\\n                            user_age,\\n                            user_alias,\\n                            user_birth,\\n                            user_cellphone,\\n                            user_city,\\n                            user_document,\\n                            user_document_type,\\n                            user_last_name_one,\\n                            user_last_name_two,\\n                            user_neighborhood,\\n                        FROM users\\n                        WHERE profile_code = 4;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":142},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1991}	2024-11-06 11:24:03
12562	9d5ceae8-8177-4eb2-a7ad-6f8993997781	9d5ceae8-84bb-4d11-8889-6e229bedb4ea	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":601}	2024-10-29 12:47:16
38265	9d6b60a9-bac8-4e55-a55e-892f47746ddb	9d6b60a9-bed9-414e-a69f-19b09d571e5f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1719}	2024-11-05 17:18:07
13716	9d5d0e40-9e1f-419d-a0c8-0ce6df031e81	9d5d0e40-a236-4c49-b8b1-ca10ca2eb5ed	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":635}	2024-10-29 14:26:06
12963	9d5cef98-f1ab-4ef5-8837-26435132c6f3	9d5cef98-f42a-449c-8a1c-6d5a8ff52b4f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[3F000]: Invalid schema name: 7 ERROR:  no existe el esquema \\u00abl\\u00bb\\nLINE 17:                             order by l.id 'desc'\\n                                              ^ (Connection: pgsql, SQL: \\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id 'desc'\\n                        )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":616}	2024-10-29 13:00:23
41874	9d6cd08f-314d-4489-9215-7b90728d17e3	9d6cd08f-33d9-40a5-ad6e-2679ff519d8c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1939}	2024-11-06 10:26:50
17939	9d65b427-3213-4a63-92e5-79b059608a5b	9d65b427-356e-4306-9d5a-e2892b5547fe	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":856}	2024-11-02 21:36:37
6955	9d52d863-8972-4e8c-a498-e4739478b58a	9d52d863-8df9-410a-84e7-3c8633045dd1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":353}	2024-10-24 12:37:12
1570	9d50d7ac-f09f-4dfc-98a0-e3f755c8bacb	9d50d7ac-f641-4bc9-95b9-28d85cdc799d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":108}	2024-10-23 12:43:33
25001	9d68befd-dcd0-4fcc-a606-4b810d25e91e	9d68befd-e425-437a-87b0-58d1f1b00f3e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1137}	2024-11-04 09:54:24
18814	9d669c49-17b3-4c80-b803-306343e0f4ef	9d669c49-1bb8-42ef-93fe-258d53a52dde	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":917}	2024-11-03 08:25:42
17262	9d6551bf-3711-433f-9cc7-3d83f5261403	9d6551bf-3a34-450d-8e01-d97ba1fb9c94	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":819}	2024-11-02 17:01:27
35877	9d69c80e-d54f-4373-bac8-95491f259241	9d69c80e-dab9-4390-84b8-bb6cde59fe4a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1624}	2024-11-04 22:15:35
25882	9d68cb43-dca8-4fc7-adef-370df4e54f37	9d68cb43-e34c-49f9-bb52-2a3577c6aa05	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1192}	2024-11-04 10:28:43
25147	9d68bfed-4700-4eca-8dfb-9b40fed73c76	9d68bfed-4a1a-4e43-acba-bd0829eb13a5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1146}	2024-11-04 09:57:01
18863	9d669ddf-4f30-46d4-857a-ceac5adbacff	9d669ddf-5280-423c-bcc0-20c752b59a24	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":920}	2024-11-03 08:30:08
1647	9d50d9c9-4c78-4cc9-a3e5-246653dba51c	9d50d9c9-50de-4929-b628-897110d1aee0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":111}	2024-10-23 12:49:27
7413	9d52dd5e-ecc9-45f8-ac55-ba96e009ae9d	9d52dd5e-f15f-4d55-9eaf-afde9610202c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":371}	2024-10-24 12:51:08
16337	9d64c311-a7bc-4cfc-a90b-1a8d2eee1007	9d64c311-aa87-4e3d-b3f2-81b2873a1cbe	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":757}	2024-11-02 10:22:30
43215	9d6ce59c-ccec-419c-8611-5c33fe7bc423	9d6ce59c-d34e-47d2-9efe-a60c4a8e055c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2003}	2024-11-06 11:25:42
9481	9d53006c-1743-4581-8334-bb9001279960	9d53006c-1caf-47ab-a8f7-551a5370a117	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":451}	2024-10-24 14:29:09
22121	9d674259-2fcd-4db5-941e-12e7dd932c4b	9d674259-3430-40d5-b25f-e03ee1a1e745	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1063}	2024-11-03 16:10:03
2326	9d50e70d-7856-4b20-9c30-60b72b5cc232	9d50e70d-7b67-439f-84f8-b9d64183ae32	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":133}	2024-10-23 13:26:33
29817	9d692bdd-2a3f-4645-ae56-1d89fb1aaab5	9d692bdd-2e8d-4978-9e43-b6e1218ae6e3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1412}	2024-11-04 14:58:50
7335	9d52dd1f-a7cd-478c-8ac9-5ae20b335c14	9d52dd1f-ada5-43a0-adc4-d759ff72adcf	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":368}	2024-10-24 12:50:27
39644	9d6be078-66d6-44f6-88db-02471fb78823	9d6be078-6afb-4317-910b-b4bcf623cb88	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1762}	2024-11-05 23:15:30
31385	9d694b8c-fdfa-4fb4-8c70-051f49b62d3b	9d694b8d-01e3-4b1b-8c21-74320613d5cc	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1499}	2024-11-04 16:27:26
35323	9d69c3ff-fed6-4054-b55c-b9019addd49c	9d69c400-01e1-4467-9aad-927bb191d2c4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1601}	2024-11-04 22:04:14
39260	9d6bcee6-f991-49e1-9e70-0e0228374296	9d6bcee6-fd0e-4429-82f2-04c9256a6824	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1749}	2024-11-05 22:26:23
2691	9d50fb25-6678-4181-8ef1-f83b8c8c82a0	9d50fb25-6c34-4242-b67e-f0dfdac0a9f7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":153}	2024-10-23 14:22:44
28497	9d6901e2-96eb-45dc-8fdf-72c603429f02	9d6901e2-99bc-45b1-a911-d8c537dfe64c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1329}	2024-11-04 13:01:27
36701	9d6b3e6f-b815-4ce7-9af5-df8c3a16fbf9	9d6b3e6f-bb7c-475e-b22b-6a044d3261d3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1659}	2024-11-05 15:42:25
3085	9d5101c5-5121-4ccd-97c6-a4beaeda8274	9d5101c5-57b7-479f-8bfb-9d2d5de5c87b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":174}	2024-10-23 14:41:16
39808	9d6cb655-a3f9-4d47-bf9c-ce94cdc120de	9d6cb655-a6e4-4e3b-96da-495acddfd330	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1779}	2024-11-06 09:13:30
1517	9d50d61d-3369-4a58-98cd-8389b7e1ab22	9d50d61d-377b-4c18-90a5-4625c0c65507	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":106}	2024-10-23 12:39:11
40635	9d6cc62c-be4d-4700-bf2b-8b17da53bf37	9d6cc62c-c1fb-4d4a-9540-7dacc0daf453	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1835}	2024-11-06 09:57:48
3147	9d510312-1441-403b-9119-4ac5d1151e45	9d510312-17e9-4ea7-82a0-0f0c8ab55720	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":177}	2024-10-23 14:44:54
6799	9d52d587-78f6-42d0-beda-55cf5cefe1f8	9d52d587-7b8b-4583-ab61-ebf2d94517e0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":347}	2024-10-24 12:29:13
29470	9d69280f-b514-47ba-81ed-b82db856f377	9d69280f-b8c4-4ad3-9d43-3181c2aa1a21	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1386}	2024-11-04 14:48:12
3821	9d511a4c-073d-49fa-8a98-f4a47c9f9fdb	9d511a4c-0a11-40e6-bb0c-2e4188b1f38b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":213}	2024-10-23 15:49:51
9663	9d54875c-4bbe-4929-809d-a81dbacd425d	9d54875c-4ee4-4337-8ae9-e4a89928c9bc	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":459}	2024-10-25 08:42:17
36908	9d6b4239-c5ec-4394-885e-64a0fcc8d053	9d6b4239-c99b-42fe-a019-0293759b4be7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1668}	2024-11-05 15:53:01
35923	9d69c869-1437-4c1e-8d80-43f359696c5b	9d69c869-19f6-4130-b718-8c77a9af16fe	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1626}	2024-11-04 22:16:34
26631	9d68d90d-9ba3-4b36-bc1f-b973527c49f5	9d68d90d-a2b8-4ae9-b0d6-6698bb62f166	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1239}	2024-11-04 11:07:17
39817	9d6cb6aa-0bf1-43f1-af0d-208bc413f2ae	9d6cb6aa-10cf-405a-aa6e-6f8ebfafee52	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1780}	2024-11-06 09:14:26
25822	9d68c9e7-55e5-453e-b294-b223130c6c93	9d68c9e7-5b5e-47a3-a3ad-eb19f255b3db	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1188}	2024-11-04 10:24:55
32790	9d6992e7-397b-4b79-a508-28e4a9d54bac	9d6992e7-3ef0-45f2-b183-b783a8069971	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1544}	2024-11-04 19:46:57
19784	9d66e6e3-d69f-4dfe-abb0-6330a203ebc2	9d66e6e3-d961-4f4f-8be2-26dfd3c85b41	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":976}	2024-11-03 11:54:19
37456	9d6b4b41-400a-43dd-a344-9810cffc16db	9d6b4b41-44c0-4255-8b6b-8b8f61e7f48b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1692}	2024-11-05 16:18:16
27279	9d68e3d7-36cc-4679-bd06-81bbf8fde070	9d68e3d7-3a80-4ec0-8685-ca8cef6185f6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1271}	2024-11-04 11:37:26
29537	9d6928fd-ee50-4366-a1fd-bf78190ad26e	9d6928fd-f1ec-43fe-8022-aeeae1f268d6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1392}	2024-11-04 14:50:48
36724	9d6b3e99-8831-4fc0-ae18-86569508c90e	9d6b3e99-8d14-4f47-a388-58808bcb3f40	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1660}	2024-11-05 15:42:53
9930	9d56bffc-a1b5-429b-a415-ccf0d268ef89	9d56bffc-a55c-43fe-8f60-4aa4db274054	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":474}	2024-10-26 11:12:17
22223	9d6743a2-ca42-45cc-b025-f6ee4d4484f0	9d6743a2-cd90-494e-a55f-09ad259e500e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1069}	2024-11-03 16:13:39
484	9d4f29c2-9515-458a-8e6e-9e5b9d63314d	9d4f29c2-98bf-427c-9688-cf0aadada0a5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":33}	2024-10-22 16:41:25
5022	9d513666-afde-4c43-8f49-7fb1de46abfc	9d513666-b320-4961-9064-46cfc9d09d0d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":270}	2024-10-23 17:08:26
28935	9d690dc0-c2dc-4104-a693-e9e5c3b173bc	9d690dc0-c60b-4db5-bae5-f34b457b7eab	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1350}	2024-11-04 13:34:38
17578	9d655ee5-9a6a-476a-924c-db3f3e2890be	9d655ee5-9eeb-4352-a46d-7e95ffc6973c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":843}	2024-11-02 17:38:13
4611	9d5133c4-a0d9-4856-a3f3-ed1e08f14435	9d5133c4-a6a6-4a01-814d-21b11dae786d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":251}	2024-10-23 17:01:04
28395	9d6900f4-5e16-48ed-bd0d-b16a722456ab	9d6900f4-6314-4d3b-bbaf-05498755af05	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1324}	2024-11-04 12:58:51
26870	9d68dd50-ac80-44bb-a05d-6449efe3a7e7	9d68dd50-b20a-4421-b585-28c44e43dcda	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1254}	2024-11-04 11:19:12
10992	9d5ca764-34b2-41d1-878c-41379706757c	9d5ca764-3880-4d14-a559-7a92526d2239	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":550}	2024-10-29 09:38:29
35407	9d69c492-44dc-429d-9a80-06ad8d9c4637	9d69c492-48d3-4fec-b602-0f3f1b0ecbb7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1605}	2024-11-04 22:05:50
4597	9d5133c2-35af-49bb-a1ba-15a922b62c02	9d5133c2-3d48-40c2-b9c1-9b598c582d9a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":250}	2024-10-23 17:01:02
35839	9d69c7ee-c697-4791-a6cb-1721e7634902	9d69c7ee-cc03-445e-bfff-50137c779c4b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1622}	2024-11-04 22:15:14
10022	9d56c740-6f06-45cc-be66-5c914a65431a	9d56c740-7267-4dea-ba5c-e7225eae8803	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":484}	2024-10-26 11:32:36
18551	9d66943c-9805-4c06-8b41-26201949a3f7	9d66943c-9c50-49f1-bc50-9bbf053fab5f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":890}	2024-11-03 08:03:12
15793	9d64afb6-235c-4721-a6bd-044abe52fc5c	9d64afb6-2622-4319-821a-33d960ed072a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":722}	2024-11-02 09:28:22
24949	9d68bee2-88ba-43e7-902e-f62d790ab61d	9d68bee2-8b6f-463c-a410-9185a6ced727	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1133}	2024-11-04 09:54:06
27502	9d68e793-340a-4a94-9900-1aa8d6ad95ce	9d68e793-38ff-41cc-ab4c-a3d7ad1c8689	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1281}	2024-11-04 11:47:53
38219	9d6b6052-4318-4ead-bc04-805216fdac28	9d6b6052-46d4-4699-84c2-d3a72b96f173	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1717}	2024-11-05 17:17:10
29595	9d6929c9-a78e-4c56-b210-aef576fdf77e	9d6929c9-aba7-46aa-b712-cc8e301e823e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1396}	2024-11-04 14:53:02
3441	9d5105e3-e7c4-43bb-b8fc-ab52918fd5ed	9d5105e3-ee49-4313-8044-261bf13b0ab4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":193}	2024-10-23 14:52:47
16452	9d64c9d9-4d6e-406f-a0ad-e8c9b5c8bed9	9d64c9d9-50ee-4546-947d-151528d70edc	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":765}	2024-11-02 10:41:27
35197	9d69c2f3-f680-4d88-b7be-9d6336af6c65	9d69c2f3-f98b-462a-aae6-ead31b755542	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1595}	2024-11-04 22:01:18
31716	9d6954aa-96af-4aa4-ade3-4fc9b9a15d46	9d6954aa-9a1f-4091-bf95-577529d93f06	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1519}	2024-11-04 16:52:55
23575	9d689aa0-8aac-4f90-9ff6-402ad883a9b7	9d689aa0-8e3e-406b-9051-e4dddf983edd	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1107}	2024-11-04 08:12:43
9921	9d56b8c8-1b1f-424c-97b6-21395e6de76c	9d56b8c8-1ee8-4e1c-a5a9-64ac47d3ecad	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":473}	2024-10-26 10:52:08
27666	9d68e91d-32d4-4701-8d6d-30b610e1cc94	9d68e91d-3762-46e5-bd40-ebc5f0800ab5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1289}	2024-11-04 11:52:11
16292	9d64c085-89df-47d6-89c4-5c1c0f17d412	9d64c085-8c94-450a-a223-016b4f0ab993	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":754}	2024-11-02 10:15:22
36476	9d6b3b7c-8d82-4b41-988c-eedd0dc67685	9d6b3b7c-91ed-4fcb-bab4-74e6bec92ad2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1649}	2024-11-05 15:34:10
18784	9d669bec-2354-4648-a214-2509619a4604	9d669bec-27b0-4f01-b355-99aef59663ff	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":913}	2024-11-03 08:24:41
16128	9d64b9ac-fb13-4629-90c1-dc8103f13e16	9d64b9ac-fed3-4249-8a50-0a0eeb95350b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":744}	2024-11-02 09:56:14
17460	9d655aca-b857-4ad9-a993-bee15a1727d5	9d655aca-bbd8-4ba3-b9ba-1eac82aef397	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":835}	2024-11-02 17:26:44
6183	9d52605a-cb65-49d7-8893-d83b9d3750d2	9d52605a-cf49-496f-9c59-4037820665ec	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":309}	2024-10-24 07:01:34
17969	9d65b4f5-61b3-4d35-ae58-6e1db76b4b2d	9d65b4f5-6487-4421-a5ee-2ebb14967137	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":858}	2024-11-02 21:38:52
19260	9d66d2c3-bba9-47fe-b610-2884815ae97d	9d66d2c3-bfd8-4b9c-b4c7-133d32231d78	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":943}	2024-11-03 10:58:02
26163	9d68ceb8-b524-43b1-8855-944600d6e0fd	9d68ceb8-bb11-4ae9-948a-632be5c31b42	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1208}	2024-11-04 10:38:23
19518	9d66df45-76eb-4108-a936-757de4d55b62	9d66df45-7a32-4b1d-ab83-d9b620ecda3a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":959}	2024-11-03 11:33:00
38022	9d6b5e83-e507-47be-97bc-0a47b5658235	9d6b5e83-e8bd-492c-a51a-b6d3595374be	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1708}	2024-11-05 17:12:07
30726	9d694315-19ac-40c4-9b06-16e3a60d81a5	9d694315-1d54-496b-bf4b-6221237351f2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1466}	2024-11-04 16:03:45
31872	9d69572a-350c-4be7-9fdd-a532b6e32fe9	9d69572a-395f-4ce4-9af2-6d72651d50bd	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1524}	2024-11-04 16:59:55
16068	9d64b94e-0e05-4b39-98dd-e953ca032aeb	9d64b94e-1396-4a44-8c87-8cd6150edcf0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":740}	2024-11-02 09:55:11
32752	9d6989aa-0a77-49f0-9e9c-60bbd7811188	9d6989aa-1043-48bf-8edb-5dc4497459e9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1542}	2024-11-04 19:21:07
1395	9d50d09f-f0cb-42b4-a30d-30ea172b8173	9d50d09f-f573-4335-bee1-916f2be17d8c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":100}	2024-10-23 12:23:50
2748	9d50fbc0-66fb-4e92-b87e-e69b7daf98e8	9d50fbc0-6b9d-415b-969a-8d388933c1fc	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":156}	2024-10-23 14:24:26
15114	9d5ecee7-b45c-4ded-9401-52d3935c7b45	9d5ecee7-ba47-41cb-8090-9d8d45f6f1fb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":681}	2024-10-30 11:20:37
31630	9d695233-2534-4ebd-bbd9-18fe12d4eb2f	9d695233-29ff-4ff6-a11c-3b2b1c677306	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1514}	2024-11-04 16:46:02
35281	9d69c3ed-2687-4f73-a386-8415fade3dcf	9d69c3ed-29d0-40f3-8f14-8185f4fd3624	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1599}	2024-11-04 22:04:02
29692	9d692a85-9946-45d1-94fc-7f9242c7cb5d	9d692a85-9e9f-49ae-a1dc-42ad2b2cd404	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1403}	2024-11-04 14:55:05
36499	9d6b3bd8-0151-451e-aafe-95f8a2c13a8b	9d6b3bd8-0619-4edc-962c-393eb111726d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1650}	2024-11-05 15:35:10
35575	9d69c500-828d-4c31-b935-22b15b102d25	9d69c500-86cc-461d-af92-5f0ab2a8b6ef	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1613}	2024-11-04 22:07:02
8888	9d52efdf-b04f-44cf-8bdc-a67ad8589d38	9d52efdf-b504-498a-bcd1-cb2d9bc08bde	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":428}	2024-10-24 13:42:52
6544	9d52d28a-eefe-4a7d-ac85-c802d09e49fb	9d52d28a-f2e6-4c55-9e6d-e5dcc40c7b59	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":338}	2024-10-24 12:20:51
29566	9d69293e-4f65-41b4-99dd-5e29100d160e	9d69293e-577c-4c72-b201-ab6a75285aea	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1394}	2024-11-04 14:51:30
36292	9d6b33fa-a207-442a-a3d5-04e047c97a74	9d6b33fa-a764-4fa9-b46c-f7f544af2b84	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1641}	2024-11-05 15:13:11
25255	9d68c0cc-7b14-46e2-a4f5-e68321d54175	9d68c0cc-7dfd-4166-9290-4dc2430378da	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1152}	2024-11-04 09:59:27
10490	9d570e84-de0e-4cc8-a018-83a7b782689b	9d570e85-9d4f-4126-8157-6a86b90e403a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":520}	2024-10-26 14:51:53
25237	9d68c09b-db09-4073-84d8-ac1306fd951f	9d68c09b-e153-4891-ad8f-1b518518376b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1151}	2024-11-04 09:58:55
16982	9d654686-a40c-493b-a788-417808e364f8	9d654686-a6e4-41e0-917a-e895d90f86b7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42P01]: Undefined table: 7 ERROR:  referencia a la entrada de la cl\\u00e1usula FROM para la tabla \\u00abloans\\u00bb no v\\u00e1lida\\nLINE 1: ...rom \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"loans\\".\\"u...\\n                                                             ^\\nHINT:  Probablemente quiera hacer referencia al alias de la tabla \\u00abl\\u00bb. (Connection: pgsql, SQL: select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"loans\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"loans\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"loans\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id \\" desc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":42},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":792}	2024-11-02 16:30:04
35960	9d69c88e-9a96-4656-aef7-2cecd01aae32	9d69c88e-a00f-4fa2-9685-dcd1214af732	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1628}	2024-11-04 22:16:59
41196	9d6ccbda-70c8-428a-af2b-c9416b75b222	9d6ccbda-74a6-446f-acf2-9268dddd75cd	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1885}	2024-11-06 10:13:41
34995	9d69c14f-f5b6-4f66-9f0f-c2d5a103e6a5	9d69c14f-f928-49ef-936d-75d702df8a80	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1583}	2024-11-04 21:56:43
40771	9d6cc77c-d02b-40c3-a091-65eab7a3da9f	9d6cc77c-d389-43ab-b8b8-fb320cf0cfe6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1851}	2024-11-06 10:01:28
41472	9d6ccce4-3e9d-4792-a323-155553b3a3df	9d6ccce4-42e2-4db6-a23f-e75f2bfc6ddf	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1901}	2024-11-06 10:16:35
16113	9d64b99a-150a-4ca7-bec7-bed84b724005	9d64b99a-17e4-46bd-a61d-b2e0efe78c3c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":743}	2024-11-02 09:56:01
20133	9d66eeae-7744-44b5-8b69-bf15146bc148	9d66eeae-7a27-4c1f-9230-a8d7b904d62a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":996}	2024-11-03 12:16:06
34884	9d69c0ee-abd3-4693-8216-3686156bc2a3	9d69c0ee-aefa-4bfb-9b38-92aa41735f20	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1577}	2024-11-04 21:55:39
9957	9d56c56f-828b-4cf6-a039-35c956a1e47e	9d56c56f-85e9-4826-a120-9b3b38130818	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":477}	2024-10-26 11:27:31
15268	9d5ecf7f-dec6-467d-9b05-d9c3bf5df9c2	9d5ecf7f-e2c2-430f-a185-c9dbd467b970	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":691}	2024-10-30 11:22:17
17327	9d655515-d9e3-487f-b7f6-ce76f2300b56	9d655515-ddf2-4264-82c6-cea11f598525	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":824}	2024-11-02 17:10:47
35239	9d69c3ae-33d4-48af-ab13-0fd0d5de4b65	9d69c3ae-37e9-45f2-b9bf-20e8c7855e1a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1597}	2024-11-04 22:03:21
14374	9d5d1e15-dbf8-43ec-85ac-ecc1466d4adc	9d5d1e15-e089-4578-b448-f5fa4e136ff1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":658}	2024-10-29 15:10:22
28579	9d6901fb-4a7f-45cf-85ec-9890aa8eb175	9d6901fb-4eee-4cac-8530-638773616423	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1333}	2024-11-04 13:01:43
17033	9d654745-be91-448d-a079-f8a095df0d64	9d654745-c16f-4ccb-8168-c34f21fb817c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna l.id \\nLINE 1: ...on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id \\" ...\\n                                                             ^\\nHINT:  Probablemente quiera hacer referencia a la columna \\u00abl.id\\u00bb. (Connection: pgsql, SQL: select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id \\" desc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":42},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":801}	2024-11-02 16:32:10
9792	9d56acbf-720e-428d-9d49-224db2267c00	9d56acbf-74f2-41fc-8d37-5dd3f5f28af5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":464}	2024-10-26 10:18:29
22623	9d67f73d-04e4-4bf8-a103-b1071454c114	9d67f73d-07a4-48b9-a284-b0e8e18080cd	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1086}	2024-11-04 00:35:51
28869	9d690ad0-6412-4bc0-bb28-eda02954b02c	9d690ad0-67ee-4797-8218-159c48414f71	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1346}	2024-11-04 13:26:25
39096	9d6bcc9a-7813-4436-8424-bfd5f157ff20	9d6bcc9a-7bcf-4965-98ac-7096f11969f9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1745}	2024-11-05 22:19:57
1062	9d4f3e6f-1e9b-4928-a003-c6f714ac7387	9d4f3e6f-2420-451a-974b-e566c85c018c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":83}	2024-10-22 17:39:14
34514	9d69beac-487e-497d-aeec-e0ac57afa3cd	9d69beac-4c02-42e7-98a7-1eaad53afe04	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1564}	2024-11-04 21:49:20
17016	9d6546f3-82c1-4411-bbd5-71d9262e6cff	9d6546f3-85cd-4d59-a078-134e32150160	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna loans.id \\nLINE 1: ...loans\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"loans\\".\\"i...\\n                                                             ^\\nHINT:  Probablemente quiera hacer referencia a la columna \\u00abloans.id\\u00bb. (Connection: pgsql, SQL: select \\"loans\\".\\"id\\", \\"loans\\".\\"loans_documento\\", \\"loans\\".\\"loans_nombre\\", \\"loans\\".\\"loans_apellido_uno\\", \\"loans\\".\\"loans_fecha\\", \\"loans\\".\\"loans_valor_prestado\\", \\"loans\\".\\"loans_cuotas\\", \\"loans\\".\\"loans_estado\\", \\"loans\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" inner join \\"users\\" as \\"ucl\\" on \\"loans\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"loans\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"loans\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"loans\\".\\"id \\" desc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":42},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":798}	2024-11-02 16:31:16
17683	9d6560b4-fef9-420a-9340-5b53e38266b5	9d6560b5-01cc-48ab-bc33-94bae3740930	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":846}	2024-11-02 17:43:17
36816	9d6b40d9-e072-4c7b-8270-1e7574f5e142	9d6b40d9-e37c-481d-8422-aa94627a925b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1664}	2024-11-05 15:49:10
16561	9d64d3cd-e46f-4be8-b651-cbcd42d27e0b	9d64d3cd-e842-4f13-bdf6-63a1f4350194	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":770}	2024-11-02 11:09:17
17421	9d655a1f-a6e8-4ae8-a377-feab1170267b	9d655a1f-ac0c-42fa-869d-32b0f033638c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":832}	2024-11-02 17:24:52
12040	9d5ce097-8bda-499b-8016-9afae16d368b	9d5ce097-8f48-42f2-8f16-cadbc06a8b79	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":592}	2024-10-29 12:18:25
9895	9d56b608-9059-4484-974a-b8e07563fe0e	9d56b608-93a6-4ec6-a535-9bc452715590	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":471}	2024-10-26 10:44:27
26749	9d68dbce-27a4-44ec-b4f1-6ec85ab34a9b	9d68dbce-2c8f-4c6a-af5b-aef5f14bb86f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1246}	2024-11-04 11:14:58
11076	9d5caab3-289c-4d26-9c82-ad3ff6e3f1aa	9d5caab3-2c27-4c07-be0a-25b29324b834	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":556}	2024-10-29 09:47:44
3541	9d5108db-0a37-4559-bdf6-73ee087adb40	9d5108db-0e08-4275-9250-2fe4c3b7bbbd	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":198}	2024-10-23 15:01:04
39210	9d6bcd8d-1f9a-47e3-861c-15a80dc92050	9d6bcd8d-23b8-4e67-a9bc-f47041fe1288	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1748}	2024-11-05 22:22:36
38109	9d6b5f51-5aae-41ba-b553-ab2ccdf57d88	9d6b5f51-5e36-4cec-a436-a0eaaef2d120	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1712}	2024-11-05 17:14:22
25291	9d68c107-f338-4a9b-96fe-06a1db3f2a07	9d68c107-f803-4fcc-aac5-079e5456f862	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1155}	2024-11-04 10:00:06
9948	9d56c462-60e0-4058-9881-20a476d79203	9d56c462-640b-4107-bf96-96b93c0c0b9c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":476}	2024-10-26 11:24:35
12728	9d5cecb9-7ddb-4b25-b203-27fa4b2d34be	9d5cecb9-8417-41f3-a5a1-5e73adf80a8b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":608}	2024-10-29 12:52:21
9869	9d56b48f-e1ca-448b-ab77-86b8574e4b5b	9d56b48f-e4a3-43c5-8a24-fa6ede40023e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":469}	2024-10-26 10:40:20
29446	9d69246f-ab1c-483a-bf5d-d8c18b92bba6	9d69246f-b21f-4597-b4f4-9abd7e361ae0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1385}	2024-11-04 14:38:04
18444	9d669183-874e-4bd6-8c31-3fc003746b30	9d669184-3b93-4198-ac4f-a4583f3093b8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":881}	2024-11-03 07:55:35
28456	9d6901c1-88cd-4483-841d-5fa0163c820f	9d6901c1-8c33-4e4d-95bd-b98f25ee1acc	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1327}	2024-11-04 13:01:05
15325	9d5ed0cb-de6a-43dc-8fb2-f9aaddd85d9d	9d5ed0cb-e157-4437-8988-7795714fa791	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":695}	2024-10-30 11:25:55
15712	9d6496b5-9495-43d4-83fe-1e526aac797f	9d6496b5-987f-40ae-8a9b-27bd43eb1a49	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":717}	2024-11-02 08:18:27
37069	9d6b44e9-3dbe-4a76-981b-096c7015f835	9d6b44e9-4161-4499-a66c-1e18422dc23d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1675}	2024-11-05 16:00:31
765	9d4f2e94-33f8-4d69-a58b-ce12de7ce06c	9d4f2e94-3768-4d55-80cb-4d0a1f322000	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":55}	2024-10-22 16:54:54
20481	9d66f440-156b-4d3d-a8ce-563b6984a7fa	9d66f440-18b5-4d7f-abbd-c72c7850a0af	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1018}	2024-11-03 12:31:40
36586	9d6b3d5a-f16d-4aab-855d-95c869737dd9	9d6b3d5a-f48e-4958-8012-d734fe979e07	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1654}	2024-11-05 15:39:24
17356	9d655878-9337-46d5-bf4a-39e6727224dd	9d655878-96b0-4fb5-9e14-1797394cc60d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":827}	2024-11-02 17:20:15
39855	9d6cb844-7323-4962-863b-361deeb321db	9d6cb844-77f9-4e82-8435-ed2eee7ace14	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1787}	2024-11-06 09:18:55
5297	9d5137c2-95db-4194-98c0-0aebef1ac40a	9d5137c2-9ba0-4369-9d65-eea5f06ba16e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":285}	2024-10-23 17:12:14
2895	9d50fd55-c297-4e05-b27c-afd94b23af57	9d50fd55-c986-4aee-ad86-9cc30222e306	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":164}	2024-10-23 14:28:52
5692	9d52492e-e279-4f01-baf2-a05d3d9357f1	9d52492e-e6d1-474b-8784-de5eb770d900	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":302}	2024-10-24 05:56:46
15329	9d5ed0cc-6da7-4c30-95e9-008006359f1f	9d5ed0cc-70a3-4535-bbf9-985e8495c50e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":696}	2024-10-30 11:25:55
27810	9d68ea06-a5c8-4933-97a1-b9e9a39ddb30	9d68ea06-aa1c-4027-92bc-e62a5d4e813a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1295}	2024-11-04 11:54:44
18204	9d65ba21-7778-4524-a0d3-8a2afaa91bd3	9d65ba21-7a69-48f8-b31c-9564e0dda0fa	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":874}	2024-11-02 21:53:20
12435	9d5ce527-eee0-45a6-983e-3d1e3714e5df	9d5ce527-f246-4bc3-ba78-41f85604b1b5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":597}	2024-10-29 12:31:11
36131	9d6b32ac-ca91-4860-a394-c6ce3449607a	9d6b32ac-df83-4bc9-92e1-6f3169c280a3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1634}	2024-11-05 15:09:32
19410	9d66d63c-49b1-443a-9f58-2021cf6e4293	9d66d63c-4d9d-4839-ad12-df27e960d78b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":953}	2024-11-03 11:07:45
26571	9d68d84d-35ba-4694-9445-a7e73a189890	9d68d84d-3c14-43c4-bb28-910177779579	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1235}	2024-11-04 11:05:10
18234	9d65baba-cfdf-4af1-90d0-eff04a1f0984	9d65baba-d3ce-47d4-8447-433e0ffd5d0e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":876}	2024-11-02 21:55:00
5426	9d51392b-b9b8-41ef-8776-615d6b35d32c	9d51392b-be4f-4bf7-82dc-fbc1f416d7c2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":291}	2024-10-23 17:16:10
22431	9d674f12-3eaa-41a9-b918-4c7e7ca44ad2	9d674f12-44c8-445d-ac32-2c904c0699b4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1078}	2024-11-03 16:45:37
19095	9d66cffe-06f0-4be1-ac04-1d9393d0bae5	9d66cffe-09c3-4716-89b5-822cbca79412	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":932}	2024-11-03 10:50:17
16719	9d64d643-659b-4c15-98ec-03c08c0d7ca8	9d64d643-6901-444a-8e2b-cba7e239ce4b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":779}	2024-11-02 11:16:10
8230	9d52e7c4-8d60-4728-84b3-87a969b0f11c	9d52e7c4-90a0-49ef-a92b-e2d271a7ab8d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":402}	2024-10-24 13:20:12
2511	9d50fa04-f072-44f4-8d4c-2dfaaf1e8d36	9d50fa04-f49a-4cfa-9044-35514ec0750f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":143}	2024-10-23 14:19:35
16307	9d64c0af-0ff7-43c0-97cc-adaa2aafcdfe	9d64c0af-1393-4ca4-998d-5023b536e8ef	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":755}	2024-11-02 10:15:49
16948	9d654653-0d7b-4b93-ba33-d1c08a389f58	9d654653-1605-468c-8adb-57f3faec62df	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42P01]: Undefined table: 7 ERROR:  falta una entrada para la tabla \\u00abl\\u00bb en la cl\\u00e1usula FROM\\nLINE 1: select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", ...\\n               ^ (Connection: pgsql, SQL: select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" inner join \\"users\\" as \\"ucl\\" on \\"loans\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"loans\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"loans\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id \\" desc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":42},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":786}	2024-11-02 16:29:31
40380	9d6cc2fa-9e03-43c7-a3ef-39e9e6a54d4f	9d6cc2fa-a0ea-4170-940d-92ce8574a47f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1805}	2024-11-06 09:48:52
38150	9d6b5fd5-723d-494e-a270-2d5e9ea745ef	9d6b5fd5-75ab-485d-9244-67dd23a5c70b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1714}	2024-11-05 17:15:48
20892	9d66fd8b-2004-476d-b32b-bf89d52a983e	9d66fd8b-244c-4ed9-a540-ae4cb2f408a0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1030}	2024-11-03 12:57:39
8616	9d52eddd-e4d4-4de4-a468-174ed56ee7aa	9d52eddd-e88c-4ca8-a8d2-c37b39aac223	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":417}	2024-10-24 13:37:16
17007	9d6546f1-5b9e-4e49-a326-f831372fa9f0	9d6546f1-5ed9-42da-b7e0-63449dcc1093	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna loans.id \\nLINE 1: ...loans\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"loans\\".\\"i...\\n                                                             ^\\nHINT:  Probablemente quiera hacer referencia a la columna \\u00abloans.id\\u00bb. (Connection: pgsql, SQL: select \\"loans\\".\\"id\\", \\"loans\\".\\"loans_documento\\", \\"loans\\".\\"loans_nombre\\", \\"loans\\".\\"loans_apellido_uno\\", \\"loans\\".\\"loans_fecha\\", \\"loans\\".\\"loans_valor_prestado\\", \\"loans\\".\\"loans_cuotas\\", \\"loans\\".\\"loans_estado\\", \\"loans\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" inner join \\"users\\" as \\"ucl\\" on \\"loans\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"loans\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"loans\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"loans\\".\\"id \\" desc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":42},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":797}	2024-11-02 16:31:14
19080	9d66cfe9-8c4a-4450-ae17-d39891b0de11	9d66cfe9-90f9-4f1e-aa0d-a2be6ccf8754	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":931}	2024-11-03 10:50:04
16262	9d64bfa3-efab-4aac-a891-3febf47aa88d	9d64bfa3-f2d4-4505-a771-4745268f1046	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":752}	2024-11-02 10:12:54
19724	9d66e522-cacf-4a4b-8ac2-07e21a203016	9d66e522-d07d-4950-bb71-7c7bc8ac5a54	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":972}	2024-11-03 11:49:24
23069	9d6886b9-9982-4137-9eb5-5ba8ef7db720	9d6886b9-ce24-40b8-99b8-7d993fdf8a1d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1097}	2024-11-04 07:17:04
35014	9d69c152-0eb3-404a-aa52-2c00b73982af	9d69c152-14aa-4145-8629-da63a98e9009	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1584}	2024-11-04 21:56:45
27293	9d68e3d9-cc7c-4021-8807-6b8b816cc995	9d68e3d9-d23d-4dec-92ed-a92954df556a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1272}	2024-11-04 11:37:28
19305	9d66d3cc-b164-4800-b782-6649dbcaa02c	9d66d3cc-b642-4035-9bba-62d784972414	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":946}	2024-11-03 11:00:56
27119	9d68e244-ea75-420d-a071-8276e0dc7062	9d68e244-f0b4-4338-ab2f-f17ddf965390	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1262}	2024-11-04 11:33:03
22033	9d674173-4a26-4dfb-b097-7d4697563c8a	9d674173-5067-40b6-9aba-d08ec0b1e2f2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1058}	2024-11-03 16:07:32
34631	9d69bf2f-a032-4ff6-b33b-a89002419410	9d69bf2f-a343-4cf0-9b3d-a4a6020c765c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1568}	2024-11-04 21:50:46
28997	9d690e4f-459c-448c-b938-4d00d95eeaa4	9d690e4f-497e-4577-b860-9ee87f29db87	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1353}	2024-11-04 13:36:12
40431	9d6cc364-5e60-43a3-98e7-4b25cf601b2b	9d6cc364-61c2-40d7-b5d7-73f6c4bc7d0e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1811}	2024-11-06 09:50:01
35468	9d69c4d3-c3c2-41fe-91ff-d6a6a522775a	9d69c4d3-c80a-4c70-97c2-108e93d39470	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1608}	2024-11-04 22:06:33
40482	9d6cc3d1-8b76-468c-9cf2-3a5919851102	9d6cc3d1-8eef-48b7-a1ca-ccf6b0f996ae	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1817}	2024-11-06 09:51:13
37230	9d6b45e5-9721-4d68-bdee-d146f6026c59	9d6b45e5-9a23-4d7d-8fed-8218b8d2194f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1682}	2024-11-05 16:03:17
3783	9d511877-d521-4d11-a95e-217f7d1ca1fd	9d511877-da78-482d-a695-162d0f057cee	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":211}	2024-10-23 15:44:44
10061	9d56c7f3-003b-4e0f-91ad-00831c99d972	9d56c7f3-0316-4bba-8958-7f07d3449028	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":487}	2024-10-26 11:34:33
26736	9d68dba0-0d51-4995-a9dd-08261296c901	9d68dba0-1088-4121-b024-573a6e5ecc28	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1245}	2024-11-04 11:14:28
36034	9d69c8d8-6ef1-4d9e-ad38-7b9470edf3a7	9d69c8d8-74ea-449a-ac53-89b79eb778ff	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1632}	2024-11-04 22:17:47
22053	9d674182-3e60-4571-a8cd-efb66f330bfa	9d674182-4120-45a3-8bbb-af72c7f1f0a5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1059}	2024-11-03 16:07:42
2288	9d50e6ce-33a3-4cbc-85f6-7714aaba4b9a	9d50e6ce-3654-493a-9b06-f2d9fd4d5158	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":131}	2024-10-23 13:25:52
3745	9d511767-6809-4bd7-b9bb-a764040b8c62	9d511767-6e67-4019-9dc3-2b8b20f3bc7b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":209}	2024-10-23 15:41:45
4865	9d513614-b1e3-40fe-bb84-d40206844c4b	9d513614-b6e5-4beb-a3b5-0e1919e97400	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":262}	2024-10-23 17:07:32
3555	9d5108dd-6540-462d-b1bb-684a8b32dbe7	9d5108dd-6cf0-4cfd-8f56-89ed22005f7f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":199}	2024-10-23 15:01:06
35491	9d69c4e0-9f21-4c7a-be80-3e7e006453b5	9d69c4e0-a246-405a-9e46-cc7af5e74ae4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1609}	2024-11-04 22:06:41
40822	9d6cc7a9-97f9-4d54-a459-24ccb4747e17	9d6cc7a9-9b35-41b5-bdf5-f8392820b3f5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1857}	2024-11-06 10:01:58
10464	9d56d269-2b0c-498e-bf6a-c37b99079030	9d56d269-2f56-4b22-97ba-3eba65d8368b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":518}	2024-10-26 12:03:48
37442	9d6b4afa-72af-4375-a220-4edd14396784	9d6b4afa-7574-47b1-91ce-8bee1ada3236	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1691}	2024-11-05 16:17:29
37638	9d6b58e7-4f5b-4e3d-9115-ad77dfbed910	9d6b58e7-525d-4629-8a3e-e3dc8e33323a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1696}	2024-11-05 16:56:26
29750	9d692af5-536e-4be3-9ca0-e1b693b8e911	9d692af5-58ea-45b5-a25f-4215cf04a726	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1407}	2024-11-04 14:56:18
3427	9d5105e1-a5e6-419e-93ab-b799d27aaad7	9d5105e1-aa31-4ff3-8b7a-6c8bac69419b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":192}	2024-10-23 14:52:45
16973	9d654684-94f7-4775-8970-87a0e83ed1af	9d654684-97e0-4266-842a-6f8b2172a495	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42P01]: Undefined table: 7 ERROR:  referencia a la entrada de la cl\\u00e1usula FROM para la tabla \\u00abloans\\u00bb no v\\u00e1lida\\nLINE 1: ...rom \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"loans\\".\\"u...\\n                                                             ^\\nHINT:  Probablemente quiera hacer referencia al alias de la tabla \\u00abl\\u00bb. (Connection: pgsql, SQL: select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"loans\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"loans\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"loans\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id \\" desc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":42},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":791}	2024-11-02 16:30:03
32100	9d695ca9-3fb8-4eeb-8f83-a632cd71ec6c	9d695ca9-42cf-494e-a65d-117f1f08f56f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1534}	2024-11-04 17:15:17
12	9d4cf2a2-e313-4d13-b843-083ca24490ca	9d4cf2a2-e752-467f-8b8d-8626bb1b03ce	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[23502]: Not null violation: 7 ERROR:  el valor nulo en la columna \\u00abemail\\u00bb de la relaci\\u00f3n \\u00abusers\\u00bb viola la restricci\\u00f3n de no nulo\\nDETAIL:  La fila que falla contiene (3, 2024-10-09T05:00:00.000Z, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, 0, null, 2024-10-21 14:15:38, 2024-10-21 14:15:38, null). (Connection: pgsql, SQL: insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"user_photo\\", \\"user_state\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"updated_at\\", \\"created_at\\") values (2024-10-09T05:00:00.000Z, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, 2024-10-21 14:15:38, 2024-10-21 14:15:38) returning \\"id\\")","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":401},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor.php","line":24},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3549},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":1982},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1334},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1299},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1138},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":35},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":3}	2024-10-21 14:15:38
25742	9d68c8f5-6a38-4990-8846-6139cc42d5e1	9d68c8f5-7086-4f49-a7c7-5a53414c626f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1183}	2024-11-04 10:22:16
31833	9d6955e2-6a2d-4535-bb09-6bd042fbd703	9d6955e2-70d3-4ac7-ab72-62f0c749d870	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1522}	2024-11-04 16:56:20
22517	9d674fcf-94da-4692-a7a5-ffb3c6167494	9d674fcf-9b7f-47bb-8ce3-4b7151d8dbdb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1082}	2024-11-03 16:47:41
520	9d4f2a02-c86d-4f3d-9e5d-3f442d6643ad	9d4f2a02-cbab-461a-b044-8efbc3628ed2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":37}	2024-10-22 16:42:08
28251	9d68ffba-ae82-4e88-853d-a73b728680f4	9d68ffba-b4d7-43a4-8899-40e80c5f35e3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1317}	2024-11-04 12:55:25
19425	9d66d666-a15a-4745-96c7-d7f5aeb107d3	9d66d666-a46f-47aa-8e02-d358315cc960	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":954}	2024-11-03 11:08:12
5088	9d513674-74dd-4a27-9240-c19fd281dfb0	9d513674-7962-4130-81b5-7666bac21727	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":274}	2024-10-23 17:08:35
28056	9d68eb62-dbb7-4dcc-a3cf-2d13f3f8216f	9d68eb62-e0e0-4792-98b0-79ff4b42fa86	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1308}	2024-11-04 11:58:32
10009	9d56c6b3-d51f-4ddf-a2c9-eaece731e48f	9d56c6b3-d7e6-4a95-a5e1-2a6e151c2e42	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abl\\u00bb\\nLINE 13:                                 l.loans_nombre\\n                                         ^ (Connection: pgsql, SQL: \\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                                l.loans_nombre\\n                                l.loans_apellido_uno\\n                                l.loans_apellido_dos\\n                                l.loans_tipo_documento\\n                                l.loans_documento\\n                                l.loans_fecha_nacimiento\\n                                l.loans_ciudad\\n                                l.loans_barrio\\n                                l.loans_direccion\\n                                l.loans_intereses\\n                                l.loans_cuotas\\n                                l.loans_valor_prestado\\n                                l.loans_cuando\\n                                l.loans_observacion\\n                                l.loans_fecha\\n                                l.loans_estado\\n                                l.loans_celular\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            where l.id = 5\\n                        )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":150},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":482}	2024-10-26 11:31:04
4111	9d511de6-4ebc-41d8-a09b-b9e9c31fbe81	9d511de6-51af-496f-b5a6-f3d26f532262	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":228}	2024-10-23 15:59:55
40652	9d6cc64a-ce07-419e-8135-625534d5c48b	9d6cc64a-d0c5-4d01-ba5e-1766f882bc3c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1837}	2024-11-06 09:58:08
30109	9d693448-113a-4e6c-b265-05bac28e8390	9d693448-1534-45f2-b430-ce479135c414	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1432}	2024-11-04 15:22:22
6235	9d526316-7aa2-4f70-8e59-25b041b4d30c	9d526316-7fe2-4400-bb58-701f7efcdda8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":313}	2024-10-24 07:09:12
13659	9d5d0aba-3990-4b09-a5eb-26be0530014f	9d5d0aba-3cb0-4c66-b55f-6256bd6ad729	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":634}	2024-10-29 14:16:14
35914	9d69c867-acba-403e-a870-be2808581530	9d69c867-b05a-4fdb-be1d-f4d5410a29df	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1625}	2024-11-04 22:16:33
8204	9d52e7ab-2b20-4763-8d01-547ec19c59ba	9d52e7ab-2df0-4db0-bbbb-243ba1900d41	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":401}	2024-10-24 13:19:56
36246	9d6b33bf-c414-4e6f-8717-6ac36d9a0fd2	9d6b33bf-c724-455e-a4a7-a746f16d98fb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1639}	2024-11-05 15:12:32
29388	9d692447-e194-46b6-96d0-9c8bb85835a3	9d692447-e57e-48a7-8501-c71d0ba7d986	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1380}	2024-11-04 14:37:38
35988	9d69c89f-58f6-43d4-a6e6-4e019e141aaa	9d69c89f-5c1b-47b4-83c4-ac46473fdb77	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1629}	2024-11-04 22:17:10
16158	9d64b9ca-131f-4fec-976e-4430ab4f3029	9d64b9ca-1645-4fa8-a9cc-5c7d92ad90a3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":746}	2024-11-02 09:56:33
4068	9d511d15-1e3f-4149-9648-08ea74d30726	9d511d15-216e-4c86-b7fe-bb682bcd7baf	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":226}	2024-10-23 15:57:38
938	9d4f38be-501a-418b-bbe3-2858378b404a	9d4f38be-552d-44bd-aba0-c28960e17b3c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":72}	2024-10-22 17:23:19
34748	9d69bf77-a124-4769-80b8-95fb120dcc23	9d69bf77-a3cf-4517-9487-e0eb6af31cce	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1572}	2024-11-04 21:51:34
15439	9d5ed228-a901-4675-9445-b4423f041375	9d5ed228-ae40-4399-8707-6a9dcddf7f62	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":704}	2024-10-30 11:29:43
3935	9d511b21-3bf4-4863-802c-8d4c204f2bc3	9d511b21-40dc-4369-9e65-bd28fccfe3dc	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":219}	2024-10-23 15:52:10
6643	9d52d3a8-1e12-466e-ae3f-25b51ebe0fe8	9d52d3a8-20f3-4108-9a63-9d944640c906	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":341}	2024-10-24 12:23:58
29187	9d69136b-1554-416e-9c90-5f949b8b1c59	9d69136b-1b1e-4a04-ae50-f8b81687bf88	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1364}	2024-11-04 13:50:29
37999	9d6b5e63-5f0f-414e-a329-9baeb7bdf1cc	9d6b5e63-63d2-4db3-804e-9902f67db8d0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1707}	2024-11-05 17:11:46
15933	9d64b576-3d6d-41b7-9d1f-3f41734168a3	9d64b576-4222-4f42-b9e8-14487877a548	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":731}	2024-11-02 09:44:27
36453	9d6b3a66-90ec-467a-b22c-44096315d810	9d6b3a66-9452-4be4-aa0a-eefe9548f519	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1648}	2024-11-05 15:31:08
39698	9d6be244-8e63-48f3-95b1-c0417421175b	9d6be244-914b-4f5d-b815-fc003cf90ece	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1768}	2024-11-05 23:20:32
19943	9d66ebf7-fb47-46ed-bfb4-7b203fbed754	9d66ebf7-fe0e-4d9f-a0fd-4f661d105b25	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":983}	2024-11-03 12:08:31
18971	9d66cdf9-2392-4cfa-8e04-8dcf0ac8a7f0	9d66cdf9-2767-4ce4-8de7-a97bb652a454	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":926}	2024-11-03 10:44:38
17020	9d654742-b5a6-4ccb-b3d7-c79e7901032f	9d654742-b8ee-4756-b462-33b1015831cf	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":799}	2024-11-02 16:32:08
30249	9d6937a0-78dd-4d56-b5a0-74b8fbad9eee	9d6937a0-7e0c-4185-b454-7bc294ac8ed7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1441}	2024-11-04 15:31:43
26301	9d68d208-5666-47c2-9806-370f304df1f3	9d68d208-5b0c-4fa3-a51b-0627cd11c732	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1216}	2024-11-04 10:47:39
7283	9d52dcd9-5669-4e0e-adc0-549861eafd3d	9d52dcd9-59bb-4db8-84a1-f2af9909043e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":366}	2024-10-24 12:49:41
6269	9d526408-e86d-46c5-8324-a40987f1a115	9d526408-ec75-4c2c-9e79-21761ff9b412	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":319}	2024-10-24 07:11:51
10698	9d572015-c171-4739-a953-a6418087906a	9d572015-c5ba-4ae1-8acf-05cdcfe7f3fe	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":534}	2024-10-26 15:41:00
2933	9d50fdad-1184-4547-a912-b7276314d52e	9d50fdad-169d-4080-8370-54075ae3e906	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":166}	2024-10-23 14:29:49
19865	9d66eb0d-997c-40ee-96c9-4d92f54aa204	9d66eb0d-9ef7-4a5c-a5dd-16f044bb50e0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":979}	2024-11-03 12:05:57
28705	9d690735-f156-405a-8e54-5cb526678eb8	9d690735-f489-43b6-9082-31705b62c5f1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1338}	2024-11-04 13:16:21
25426	9d68c2de-20d3-4e92-afe0-451d1d96f206	9d68c2de-278a-4a99-bbc6-85439d45d27b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1161}	2024-11-04 10:05:14
5643	9d524842-0051-4197-a8e2-613652992d48	9d524842-04a0-4edc-ba87-b4aec0925f0e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":300}	2024-10-24 05:54:11
13423	9d5cfd39-fe34-4db5-b336-2c05860124f1	9d5cfd3a-013c-4da6-bfd8-24cd69c33083	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":633}	2024-10-29 13:38:29
26772	9d68dc21-26e1-4ca8-8ebc-96587d25c665	9d68dc21-2d47-4d46-9aee-c4af7a84e32d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1248}	2024-11-04 11:15:53
29038	9d690e67-fd8d-4c66-b07f-f6598081d0ff	9d690e68-0094-43d6-84ce-fcd3439c7963	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1355}	2024-11-04 13:36:28
20361	9d66f1a7-5fa6-4751-a446-95e1001e4898	9d66f1a7-629d-48ac-a7bc-a8af33d2628a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1010}	2024-11-03 12:24:25
3731	9d511764-8044-4387-93b8-07cbe38e5f99	9d511764-8797-43d3-9275-53039c7dd241	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":208}	2024-10-23 15:41:43
35510	9d69c4e2-c5d5-4f16-a77f-336f7df149ce	9d69c4e2-cb86-4bf6-954c-8af1ceaa874b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1610}	2024-11-04 22:06:43
6209	9d526207-5435-499d-8a5d-05e391abd547	9d526207-5778-4c03-a37d-d56a214042ef	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":311}	2024-10-24 07:06:15
10386	9d56cf09-9769-46bb-9153-3afb1a3f08cf	9d56cf09-9a45-4364-9656-00d131d07cb3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":512}	2024-10-26 11:54:22
3365	9d510495-a1e5-4784-b724-bddb9213d891	9d510495-a806-4eb1-8888-32c1cb65ce9c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":189}	2024-10-23 14:49:08
5345	9d513839-910d-4198-b3e1-04d87ddc9579	9d513839-95ba-41e1-9e51-c2b7312e72ff	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":287}	2024-10-23 17:13:32
4212	9d512997-805b-4323-a837-1b8b0e8c3c9a	9d512997-92a3-426d-994c-3d54d1821895	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":232}	2024-10-23 16:32:37
30020	9d6932ff-c673-4c06-bec2-f8aa3a9fb342	9d6932ff-ca63-4e8a-9f31-91cf7692c176	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1426}	2024-11-04 15:18:47
1494	9d50d2f8-657a-45fc-b3bd-11fb624da738	9d50d2f8-6ca0-44e3-af9b-565a77f1f5a8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":105}	2024-10-23 12:30:24
7772	9d52e159-3ec8-4c60-ad57-98201bb2c1c4	9d52e159-422b-4484-b883-fc981f712bdc	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":385}	2024-10-24 13:02:16
1281	9d50cad6-948b-44dc-ab9e-c08d376e47d9	9d50cad6-9808-4a19-bb28-d0751329e5e1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":94}	2024-10-23 12:07:40
8810	9d52ef3d-36b4-4525-9ff5-80556a6453bf	9d52ef3d-39ac-46db-804c-3ff57b943c21	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":425}	2024-10-24 13:41:06
3707	9d51098c-6ee9-4a4f-9c0c-bc10a7de1126	9d51098c-74a6-4628-a2fa-f2c13bcb0eb0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":207}	2024-10-23 15:03:01
15808	9d64affd-6376-4fdc-98da-b4e1fbf92865	9d64affd-672c-47ad-91ae-3294cb57c65e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":723}	2024-11-02 09:29:09
2829	9d50fc9c-fa96-47dc-aa5b-c816f397d881	9d50fc9c-fdac-4408-b2dd-04e02343dab7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":160}	2024-10-23 14:26:50
27391	9d68e44b-4d4f-413b-8ae0-d3d17af8382e	9d68e44b-53db-4169-8cce-89379338f916	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1278}	2024-11-04 11:38:42
15043	9d5ece8a-3a99-4d4c-8220-69dda842b0f8	9d5ece8a-3d6f-4328-8b04-1fe8c042bd6e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":676}	2024-10-30 11:19:36
24145	9d68a8e4-84b2-4ccf-b2ab-61a7d8a9358d	9d68a8e4-87ea-476c-9347-04218e4ed14c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1114}	2024-11-04 08:52:37
37576	9d6b5894-9a68-4f80-97eb-7be31f14fafa	9d6b5894-9e58-45eb-889c-f1203e109c0b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1694}	2024-11-05 16:55:31
19335	9d66d58d-4a72-4da9-91e7-a6bedaa165a8	9d66d58d-4d42-4bc0-abb0-0f1836aa9bba	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":948}	2024-11-03 11:05:50
34564	9d69becd-bd28-42f6-8085-d919836c9434	9d69becd-c674-434d-8915-da8fb9d6bb20	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1566}	2024-11-04 21:49:42
30449	9d693f90-d8a9-49ad-8fbe-df43a46052ef	9d693f90-decb-4d8f-a613-42efa74b50c9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1451}	2024-11-04 15:53:55
7819	9d52e1c3-6969-4e40-a7de-7f3c62b82a10	9d52e1c3-6cd0-4297-b195-fa03650cc100	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":387}	2024-10-24 13:03:25
34717	9d69bf63-bebc-4afa-9d5d-e810b3ad2cfe	9d69bf63-c24d-4b79-baac-af4d738d4d7e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1571}	2024-11-04 21:51:21
3503	9d5106e2-7430-47a7-90b7-c17f38cd5e5f	9d5106e2-773f-4b74-adb2-af7d0182bfb6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":196}	2024-10-23 14:55:34
15693	9d64904e-08c5-44a6-9931-2a8ad486494f	9d64904e-0be8-46eb-a955-7e9549c748ae	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":716}	2024-11-02 08:00:33
15575	9d648d4f-3e63-4152-9f96-15038a9c0091	9d648d4f-50d6-4583-b478-9e7b1c4ce507	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":709}	2024-11-02 07:52:10
34779	9d69bfc3-49c6-4092-9a97-14cd3dcd7c41	9d69bfc3-4d55-447c-9a96-c59c8e4d5a2e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1573}	2024-11-04 21:52:23
16645	9d64d470-8f77-4205-8120-b64bae154769	9d64d470-9367-4eae-8935-d5586c1aba7e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":775}	2024-11-02 11:11:04
7694	9d52e035-abd2-4024-af51-3f5f9e03846e	9d52e035-b0aa-41de-acdf-50c2699e734d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":382}	2024-10-24 12:59:04
9592	9d53b6bf-1bd9-45b9-b718-20a8d15cdcb0	9d53b6bf-1eb9-42e4-a5f5-a5aeab2e1152	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":455}	2024-10-24 22:58:58
15903	9d64b2bc-205c-406e-9c90-021fed9e0351	9d64b2bc-2488-4bc6-8294-8bc6ee4de39f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":729}	2024-11-02 09:36:49
9882	9d56b5e1-594d-4d61-b888-5c7bc8667c01	9d56b5e1-5d58-4dda-8a36-1e53e3b3e624	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":470}	2024-10-26 10:44:01
17093	9d654abb-9683-4367-9fc5-1d8cfe0ae2a3	9d654abc-4913-4c78-8287-26bd6481a4e6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":808}	2024-11-02 16:41:50
14437	9d5d1e2d-2866-4101-bd2b-23cf8d6b837b	9d5d1e2d-2c0b-4fba-b04a-90825c9b19c9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":662}	2024-10-29 15:10:37
32819	9d69a629-7596-48c4-9a67-82cc9508280d	9d69a629-7c6a-4ddf-a422-92fd8dd79540	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1545}	2024-11-04 20:40:48
25191	9d68c02b-6a63-493a-a52e-d42af845ae0e	9d68c02b-6fb2-4a3c-b09e-95bbce61b2fc	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1149}	2024-11-04 09:57:42
10048	9d56c7d8-4ff7-42d1-8788-16d890c85a5d	9d56c7d8-5322-4f46-8b90-22e3ce16df06	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":486}	2024-10-26 11:34:15
15978	9d64b763-f5d5-4ff9-93f0-4f5b6ab0edbc	9d64b763-fb72-4fa7-8103-4323d8ebcaf2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":734}	2024-11-02 09:49:50
11889	9d5cd833-54b6-4e53-ba85-b02a2a76505c	9d5cd834-0a80-48f1-972e-328ae02d77a9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":583}	2024-10-29 11:54:57
26943	9d68ddbd-47a5-411e-8930-49e1411c0dc6	9d68ddbd-4d4e-4118-9bc1-bd8367841ea0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1258}	2024-11-04 11:20:23
33327	9d69af95-2de6-4bcb-bfca-0383ab55c2ad	9d69af95-3531-48bf-891e-37c3922e7e9f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1551}	2024-11-04 21:07:09
10269	9d56cc35-baea-464f-bc36-6d817e606152	9d56cc35-bda1-4397-b16d-a5bb6b47a940	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":503}	2024-10-26 11:46:28
17301	9d6552ca-d343-4c0b-b7e6-bd8220c7edbc	9d6552ca-d71d-43d7-97db-4fc7c607b1c5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":822}	2024-11-02 17:04:22
10399	9d56cf68-aefa-4813-a826-294a486df757	9d56cf68-b25b-4cc9-a8de-c0544983f855	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":513}	2024-10-26 11:55:24
31198	9d6946f7-7b05-4a4d-b28b-637a09b3b21c	9d6946f7-820c-4d33-8ea4-f85547730194	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1483}	2024-11-04 16:14:37
36885	9d6b4171-05a2-4ba1-933f-5d7f81abd8f8	9d6b4171-0991-4528-ba5f-6283947758e3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1667}	2024-11-05 15:50:49
17139	9d654ec1-87cc-49ae-b36e-06137dd1c898	9d654ec1-8b4f-4681-9ac2-cca75ba5ae03	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":810}	2024-11-02 16:53:05
3185	9d510361-5df9-47a2-89ea-673e45015184	9d510361-61f7-42bf-9ecc-b35c70692aa7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":179}	2024-10-23 14:45:46
16862	9d64dbea-7ce2-4013-ac95-0f9e175580b1	9d64dbea-7fd2-4067-a549-e6ac327e8f98	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":784}	2024-11-02 11:31:58
19559	9d66e094-ae90-4c79-8450-352cad5cb12c	9d66e094-b29f-4e64-9b30-88b404dbd8dc	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":961}	2024-11-03 11:36:40
32724	9d69830c-6e89-46a1-8fd3-c8143fa45827	9d69830c-73ab-43b4-8c38-33b62e5f2399	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1540}	2024-11-04 19:02:37
10908	9d5ca5cd-9aa1-4a3b-9ba2-e6fe43b9e138	9d5ca5cd-a06f-4a97-992b-4a4b6220ad0c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":545}	2024-10-29 09:34:02
13267	9d5cfc8f-94f0-4ef2-9958-574340e91c0c	9d5cfc8f-99f4-473b-b0e3-2c177b78a270	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":630}	2024-10-29 13:36:38
8495	9d52ec9b-5ace-48e7-af38-ef448f69d84d	9d52ec9b-5ee5-4075-b993-5b3e0c9f0610	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":412}	2024-10-24 13:33:44
25416	9d68c2dc-1304-47ab-9fd8-d256d63d1eef	9d68c2dc-17b3-4030-a09d-cab77499f7d1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1160}	2024-11-04 10:05:13
9908	9d56b6e3-d079-4a5a-8cdb-e878a96b90b9	9d56b6e3-d3d5-4f20-ae89-afbf6070de45	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":472}	2024-10-26 10:46:51
8152	9d52e76d-6c8f-4a9b-a9f1-d64d7aaac6ac	9d52e76d-70ba-41a7-9646-02788d3712c2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":399}	2024-10-24 13:19:15
19544	9d66e03c-d0cc-4ede-9da7-2fee4aa26012	9d66e03c-d3d5-4215-aaf8-2628d4fab2c6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":960}	2024-11-03 11:35:43
31702	9d6954a8-feb0-429c-a7c6-af8282d98e22	9d6954a9-049b-42f7-8176-09cb2734b530	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1518}	2024-11-04 16:52:54
17288	9d655233-fff7-4580-83f8-c1a28998b949	9d655234-03fe-4238-87f3-d0b35c259d88	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":821}	2024-11-02 17:02:43
8469	9d52ec1d-747f-4ca7-8321-04db8024b308	9d52ec1d-7754-47b7-8020-73d598cf5742	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":411}	2024-10-24 13:32:22
7257	9d52dcb5-673a-44c7-bdb7-c7b3e2955d87	9d52dcb5-6b4d-428e-a040-2ff0bf448152	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":365}	2024-10-24 12:49:17
15763	9d64af6a-de0b-44de-815e-f46064271d77	9d64af6a-e11a-4c40-98d3-1e935c22dc1c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":720}	2024-11-02 09:27:33
24096	9d68a558-b71a-4ee4-9c15-037337b1d158	9d68a558-ba95-42ef-8186-88aca5077c74	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1111}	2024-11-04 08:42:42
1594	9d50d7d7-07d4-4c57-920c-119d0a0bca8d	9d50d7d7-0adf-442a-ab76-8c2eb62cbb06	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":109}	2024-10-23 12:44:01
8686	9d52ee7e-598d-4b56-88c2-e9ce9c278e9a	9d52ee7e-5c68-4d0c-a367-1881d3ecd4e7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":420}	2024-10-24 13:39:01
12288	9d5ce1d6-554b-4ed8-afa9-1a675077128c	9d5ce1d6-594e-4764-9fd6-c7bce49cd258	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":594}	2024-10-29 12:21:54
25382	9d68c25b-a5a9-45e6-8b2a-7b01d1a1181f	9d68c25b-a940-4dad-8570-c4b4419c618b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1158}	2024-11-04 10:03:49
17730	9d6561ce-6b50-4cf4-9a85-30af35e57a1d	9d6561ce-6f23-4aea-b561-848abe05ebb4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":847}	2024-11-02 17:46:21
2035	9d50e2f8-98e4-4f83-99d6-5ca2baec28a8	9d50e2f8-9d14-4f03-a93a-49d822213b5a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":124}	2024-10-23 13:15:08
35384	9d69c44a-de23-4a37-8826-16d03bb1195f	9d69c44a-e3b7-42c6-bfdf-0bf20dcd6232	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1604}	2024-11-04 22:05:03
4269	9d5129d7-c744-43b1-9944-e155bc3f58f0	9d5129d7-cd6b-402f-bc54-7fcc8145c1fd	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":235}	2024-10-23 16:33:19
17796	9d65ae98-a638-4d91-8f03-2a89a5f098f4	9d65ae98-aa99-4117-9f4c-9298ab52bf36	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":849}	2024-11-02 21:21:04
4302	9d512a48-e96e-4de6-8943-70d2cfd1ff86	9d512a48-ed38-44d5-b4e3-ae92ecef612a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":236}	2024-10-23 16:34:33
16083	9d64b965-15b4-4fb2-a499-0fabe9db7712	9d64b965-190b-4c6c-b87d-557aaa975ffb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":741}	2024-11-02 09:55:27
28849	9d690a31-e6e1-4cc1-b0d6-2e52230c6114	9d690a31-ebfa-45a5-82ab-210512884f0c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1345}	2024-11-04 13:24:41
11259	9d5cb211-7a2c-4f4a-a41c-9c340f2a5e28	9d5cb211-80a0-4f5a-bf0f-1a25716d5d02	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":567}	2024-10-29 10:08:20
10600	9d5710f8-c3e5-4e19-9b12-475d2b28e567	9d5710f8-c770-4818-8242-9a847864b512	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":528}	2024-10-26 14:58:44
793	9d4f2f26-bd74-43d4-b470-9d0718691a78	9d4f2f26-c0d5-41ff-ac76-464c625c239b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":57}	2024-10-22 16:56:30
20905	9d66fdbe-1f86-4cad-9246-eb7f09bf1f83	9d66fdbe-2510-441d-85ac-efbda08d9988	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1031}	2024-11-03 12:58:13
38311	9d6b62ba-ae5b-4c47-80d8-5ecd3caf4a32	9d6b62ba-b303-4c34-be66-cab027c09126	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1721}	2024-11-05 17:23:54
16367	9d64c411-e0a7-4a6c-9fb8-48e93c2451df	9d64c411-e578-4ba9-9b62-bbd90e31d398	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":759}	2024-11-02 10:25:17
8664	9d52ee61-7700-4289-8bfa-7e7363471051	9d52ee61-7a37-46f8-b651-d4d63ba1ea70	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":419}	2024-10-24 13:38:42
1314	9d50cb85-6198-4cc3-88a3-b3164d5f54a3	9d50cb85-66b2-4c08-8d96-25bd414bd1d5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":96}	2024-10-23 12:09:34
956	9d4f39e6-6e24-4c65-a1e0-10b641bfe9af	9d4f39e6-7184-411f-a024-0e1442e41ba1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":74}	2024-10-22 17:26:33
27313	9d68e41a-539a-4aa8-9400-8ea84b64abb6	9d68e41a-5728-4950-8e17-c822e9d0fbaa	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1273}	2024-11-04 11:38:10
31966	9d6957fe-995c-4ed5-a586-851e9438bd44	9d6957fe-9dc8-44eb-b1b0-40c60f541e9c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1529}	2024-11-04 17:02:14
37865	9d6b5d64-5a93-4201-9c50-6ae59d269cec	9d6b5d64-5eb2-4b1d-870f-119bcbc8ac90	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1701}	2024-11-05 17:08:59
18517	9d6692f6-9dfa-4c57-955c-09a70267e860	9d6692f6-a1ca-49a7-9cc6-02758fbfba92	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":887}	2024-11-03 07:59:38
25832	9d68c9e9-2505-43b8-a72c-57d1d7167003	9d68c9e9-2a80-4082-bb81-fba273d46950	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1189}	2024-11-04 10:24:56
11943	9d5cd8db-9272-4a77-a1d2-1f4384b6426a	9d5cd8db-95cb-47b9-8f5e-7e0ebe905410	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":587}	2024-10-29 11:56:48
16910	9d64dfa7-2d12-4614-ad9c-3cb2c42aabb2	9d64dfa7-328a-4484-adbb-570d4077798e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":785}	2024-11-02 11:42:25
11498	9d5cbf02-aae5-4a14-a29f-5b4d327cc760	9d5cbf02-add0-46d8-b344-5e6aaa1ab411	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":579}	2024-10-29 10:44:31
31338	9d694aa3-d9a3-4c7e-bfe3-203a5b243ddb	9d694aa3-dcc7-4dcf-bf12-cccc5a782dc3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1494}	2024-11-04 16:24:53
7918	9d52e55d-477b-4c80-9498-27f36d6770f2	9d52e55d-4cf7-4ceb-8b60-362acbd62476	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":390}	2024-10-24 13:13:29
2781	9d50fc3c-0e7f-45ed-95d1-46fa6a0f00ee	9d50fc3c-1384-4df5-9150-01c162fd8c6c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":158}	2024-10-23 14:25:47
29225	9d6913e1-34e3-46ca-b5e4-0c8bedad5ead	9d6913e1-3987-4210-9141-147e771626d8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1368}	2024-11-04 13:51:46
15100	9d5ecee5-8a1a-423d-8a49-d03a1f13da0c	9d5ecee5-8ff9-48a9-bca3-5aa63218a251	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":680}	2024-10-30 11:20:36
28828	9d690a2e-f34c-4f28-bf26-c5864727d589	9d690a2e-f995-477b-86ed-891235ce9f74	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1344}	2024-11-04 13:24:39
6851	9d52d5ab-4834-48f4-92b0-d2d80810d8e0	9d52d5ab-4b11-42e7-9e86-c416438292e4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":349}	2024-10-24 12:29:36
26371	9d68d356-0637-4229-9ecd-aa8ef859035a	9d68d356-0c9f-46f6-83c9-3802b6db5a84	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1221}	2024-11-04 10:51:17
36177	9d6b3333-42b4-4f80-b74d-33405621afa2	9d6b3333-47c9-411a-aabe-d98d0073535d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1636}	2024-11-05 15:11:00
870	9d4f3363-3ec5-40d7-98de-ea9fe2be50e3	9d4f3363-42e8-4eaf-b53e-cf6e05c74501	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":65}	2024-10-22 17:08:21
10035	9d56c78c-5038-4fd9-b5d1-a53333db1c36	9d56c78c-54fa-4944-baeb-b1c8ce9734b6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":485}	2024-10-26 11:33:26
7231	9d52dc3c-e97e-415d-8f5a-57e5d6da0b93	9d52dc3c-eee0-4205-9c83-c35ccafd1eca	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":364}	2024-10-24 12:47:58
16546	9d64d2ca-a520-4e86-aacb-d678c43ed139	9d64d2ca-a8ab-4d58-a793-c3f98c1b4eef	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":769}	2024-11-02 11:06:27
29721	9d692a9e-df6c-4931-9f9f-b6a8ec974aa7	9d692a9e-e52a-47ac-bbf0-aa5c72a719a3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1405}	2024-11-04 14:55:21
15472	9d5ed333-8cb5-4694-b604-3a763a6661ae	9d5ed333-91e7-4ed4-a3ba-0ca9c27cc41f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":707}	2024-10-30 11:32:38
10773	9d572103-2ee7-4bec-bd02-4c90c51d21e1	9d572103-31b7-47cb-952c-1295fb77c86c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":539}	2024-10-26 15:43:35
13336	9d5cfcfb-ee73-4db3-beef-d3b5156f67bb	9d5cfcfb-f220-44c4-9b67-4aecf55dc95c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":631}	2024-10-29 13:37:49
8126	9d52e71a-0074-42cd-9810-a9689904ec98	9d52e71a-03a6-4eeb-994a-98c580e1f569	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":398}	2024-10-24 13:18:21
29904	9d692c15-4855-4c82-a604-b0ee755e7bf9	9d692c15-4b8b-4292-9f00-fa0953639655	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1418}	2024-11-04 14:59:27
22155	9d674277-7851-4633-9ccf-51b028ba0fc5	9d674277-7b76-43d2-a6f9-2bb4d04289e4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1065}	2024-11-03 16:10:23
36200	9d6b3367-181d-48b5-b14f-ecae78f8a753	9d6b3367-1ba9-4d26-95d1-5a9df2051ffb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1637}	2024-11-05 15:11:34
29711	9d692a9d-bf62-4b72-b39a-ce0a16864e68	9d692a9d-c26f-4a36-9087-144c2e5e5020	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1404}	2024-11-04 14:55:21
30594	9d694068-5670-4188-87fd-20f03af4e710	9d694068-5c1e-41c6-9c17-e48a3b7c215a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1460}	2024-11-04 15:56:17
36954	9d6b4355-3dd1-4758-b322-2e32aafede6c	9d6b4355-418c-4dc6-a6ae-f5798b9b20ee	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1670}	2024-11-05 15:56:07
24993	9d68befc-1a61-4e40-8fa2-5a21db3f1b22	9d68befc-1e96-43c8-aa52-0e363f82943c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1136}	2024-11-04 09:54:23
4635	9d51345e-f25c-4706-9cfe-cc49a47e2031	9d51345e-f61e-482f-bcc8-ae872c9611e5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":252}	2024-10-23 17:02:45
29521	9d692822-dfb5-4f19-9c7f-e5c87e6a538b	9d692822-e761-45a0-adbd-5d00eb76104c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1391}	2024-11-04 14:48:25
36931	9d6b42c8-b29b-4d86-9237-76ff0fe482c9	9d6b42c8-b720-4bdc-9e46-95dfca60bb6f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1669}	2024-11-05 15:54:35
23321	9d689458-a74e-4462-ad25-8b0a272f8fcf	9d689458-ab68-4ada-869d-ea09822a30a8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1102}	2024-11-04 07:55:09
39671	9d6be15a-df87-421e-b686-3d11e50ac902	9d6be15a-e611-499e-907e-503925e09c05	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1765}	2024-11-05 23:17:58
15748	9d64af1b-ad71-4899-a371-409630ac640f	9d64af1b-b20b-4fb8-8dd8-e9e5df355b31	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":719}	2024-11-02 09:26:41
10630	9d571187-0712-40e0-b6a3-ced5d202cfb8	9d571187-0a5c-4e3d-a2a2-fb7507b14049	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":530}	2024-10-26 15:00:17
10555	9d571058-1146-42e4-8e3c-d8c9748db55e	9d571058-1532-47d1-a171-906ba891412b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":525}	2024-10-26 14:56:59
27054	9d68e1b7-25c2-41fa-b81b-7e76df8e056f	9d68e1b7-29b7-4f2e-ba77-27538b1a068c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1259}	2024-11-04 11:31:30
379	9d4f2737-4fd5-4801-b596-75979c2cc0fc	9d4f2737-54f1-4157-8f75-81a1983ff124	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":23}	2024-10-22 16:34:19
3693	9d510989-b233-40f2-954e-2a6a5d2bfdb8	9d510989-b783-4007-bd9a-4176ce487308	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":206}	2024-10-23 15:02:59
35701	9d69c57e-9335-4dc6-b525-cec2dc4d180c	9d69c57e-96ec-42fb-9fc2-fd09b687cd8f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1619}	2024-11-04 22:08:25
31611	9d6951bf-d53c-439b-9961-19b94da7b35a	9d6951bf-dba4-488b-882d-62170d0aef65	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1513}	2024-11-04 16:44:46
25566	9d68c71a-167d-4996-a466-ae218c072b20	9d68c71a-1cc5-4742-bf16-9068927552e7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1171}	2024-11-04 10:17:05
35617	9d69c537-c080-4420-b199-7b4617c249fc	9d69c537-c3d5-41d6-bb08-c729e242895e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1615}	2024-11-04 22:07:38
30030	9d693301-767b-4283-b55c-a7f45f61ad7c	9d693301-7c89-432d-ad20-f4f6ba72b35c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1427}	2024-11-04 15:18:48
401	9d4f2799-9840-4783-a966-b4ac65ead8b2	9d4f2799-9ba9-41f6-968e-c7cbb29d588e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":26}	2024-10-22 16:35:23
2957	9d50fddd-3fe6-41f1-b101-e688f988f15b	9d50fddd-4363-4c26-bfb1-4576daeae1fa	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":167}	2024-10-23 14:30:20
40363	9d6cc2a5-0d3a-42d3-9616-eeea6ac2762b	9d6cc2a5-11b8-4b37-9e80-102efce759b4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1803}	2024-11-06 09:47:56
11166	9d5cabf3-2466-4336-bc6d-341c8f9e0f96	9d5cabf3-295b-4997-ab66-f5abddb348be	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":562}	2024-10-29 09:51:13
36315	9d6b3411-e26a-492b-ac74-e2fdcb20cf38	9d6b3411-e62e-4345-b93f-a92f4bb8bd51	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1642}	2024-11-05 15:13:26
39772	9d6cb55b-5f34-4bcb-91fa-18cbc765780b	9d6cb55b-63aa-47d0-9d8b-49791081cd5d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1775}	2024-11-06 09:10:46
11570	9d5ccaf5-3607-4a0f-8696-f1f35c360168	9d5ccaf5-38e9-407f-971b-1aef0df39aff	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":581}	2024-10-29 11:17:56
34228	9d69bbf1-92bf-49b1-9676-9f202bfb21e0	9d69bbf1-958b-4aea-bf55-f9f16bca7f95	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1556}	2024-11-04 21:41:42
18672	9d669963-ca76-49ae-b417-1bc8fbe4223a	9d669963-d07e-42a8-9ae7-095dcbc15ce3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":901}	2024-11-03 08:17:36
1333	9d50ccce-584f-4ad8-a326-f7661d5ba231	9d50ccce-5bed-476a-9f77-105067140ba1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":97}	2024-10-23 12:13:10
16232	9d64bc72-2c64-46eb-a74c-5ef8f49d1c2a	9d64bc72-313b-4f5a-bd43-a7f2f10308cc	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":750}	2024-11-02 10:03:58
16038	9d64b84b-b94a-4aab-80f6-22c592a6a28e	9d64b84b-bd07-491b-b1c0-66ead883fc14	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":738}	2024-11-02 09:52:22
3465	9d5106d3-87a7-4e26-ae1f-43b59e561853	9d5106d3-8c41-46b5-b69a-7fd204c50c53	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":194}	2024-10-23 14:55:24
19634	9d66e27e-ac47-4cbc-85c5-660f10aecabc	9d66e27e-af2d-42ef-b590-b24cab71b89b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":966}	2024-11-03 11:42:01
31295	9d6949f7-aff3-44ce-92bc-ba60940509c7	9d6949f7-b36d-4d39-b0a1-ad430791accc	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1488}	2024-11-04 16:23:00
17314	9d6552f3-ace5-4679-891b-3f54eb1f0aca	9d6552f3-afd3-48f6-8cd7-942f869f869d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":823}	2024-11-02 17:04:49
25772	9d68c900-d89d-49f6-9c7e-bffb8f7dee36	9d68c900-df12-4100-ab36-70927dd1a86f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1185}	2024-11-04 10:22:24
30866	9d69440a-1d3f-4388-8d0d-b2e66a9d1db4	9d69440a-21bb-4267-bfa1-a6949f35c431	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1471}	2024-11-04 16:06:26
11151	9d5cab69-583e-436c-85b2-65ae770c5f94	9d5cab69-5adf-4c23-b811-7b61ce9a7cda	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":561}	2024-10-29 09:49:43
30498	9d693fb2-ef26-427b-a3db-06d5cefe0b8e	9d693fb2-f261-4728-bfd5-76a812909b99	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1454}	2024-11-04 15:54:18
22349	9d674a8a-a509-4140-822c-b2052c9cce40	9d674a8a-abfc-453f-9193-a8d515d8910e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1076}	2024-11-03 16:32:57
19503	9d66df2b-1c7f-482c-ae12-2a7a926cfce0	9d66df2b-2450-472b-a18f-b2c29b6f173f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":958}	2024-11-03 11:32:43
35951	9d69c88d-5b6c-4227-9f6f-fae28d22c7e7	9d69c88d-5ea4-425a-aaa5-05153a183082	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1627}	2024-11-04 22:16:58
9966	9d56c570-6789-4007-8449-d6c1f6cc57ec	9d56c570-6a8a-4453-81dc-f364935f1068	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":478}	2024-10-26 11:27:32
24751	9d68bd25-490c-4354-9c1a-e5d7b01b5a31	9d68bd25-4d9b-4208-a2a0-58111e565e59	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1122}	2024-11-04 09:49:14
24644	9d68b777-5f21-433e-8937-f2714e8b5b25	9d68b777-61df-4d5c-b98d-4284dc06d00e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1119}	2024-11-04 09:33:22
22477	9d674f57-9cb3-4960-90e1-370519c45331	9d674f57-a208-424b-aded-bd2d81195a6d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1080}	2024-11-03 16:46:23
19754	9d66e5cd-4c8c-4617-b0e7-c8d2dbfc79af	9d66e5cd-5207-4d69-b25e-3ecc2e32e571	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":974}	2024-11-03 11:51:16
7439	9d52dd73-906f-4d0f-97b0-c0e188a5f59e	9d52dd73-940b-48e6-ae7f-d8ef796116e2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":372}	2024-10-24 12:51:22
5609	9d524742-39d2-48fb-b09c-3fc7591ec396	9d524742-3d16-4df6-ba68-e5f7c7607b52	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":299}	2024-10-24 05:51:24
6570	9d52d31a-3693-4a3b-92ab-436a7abd84a3	9d52d31a-3a8a-4ac1-bb18-a7b5e3427b42	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":339}	2024-10-24 12:22:25
29490	9d692812-8651-4705-83e5-b0121ae8f126	9d692812-8c55-4c9c-997f-01dd8f189d4f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1388}	2024-11-04 14:48:14
10113	9d56c8e9-eb23-4c33-9081-917b0215589a	9d56c8e9-ee63-4bae-b25d-ccadfcae8f7c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":491}	2024-10-26 11:37:15
36522	9d6b3c81-505f-4f32-8e1a-bcb0f8d38b97	9d6b3c81-5523-49f1-bb85-57064bd634cd	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1651}	2024-11-05 15:37:01
14026	9d5d147a-fe75-4a3d-8f64-e9c8add55eec	9d5d147b-019a-4c8d-9534-d8dfdc8d1d44	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":645}	2024-10-29 14:43:31
5283	9d5137c0-2f8e-443d-bf27-7c28c1dc75cd	9d5137c0-33b0-4952-8f0c-8eebaafde2a7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":284}	2024-10-23 17:12:12
565	9d4f2c5a-8d75-4676-bfdf-bec6e91cd0b3	9d4f2c5a-931a-4b06-a737-42014a94632e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":40}	2024-10-22 16:48:41
19619	9d66e258-501d-4777-93b7-5b0bab366665	9d66e258-5360-413e-901b-838e1d89a9b7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":965}	2024-11-03 11:41:36
29412	9d69245a-5d5a-4514-a2bf-684306e47ea7	9d69245a-60aa-4ecd-a751-ae7400da5c45	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1382}	2024-11-04 14:37:50
15620	9d648f65-9ff8-43c3-8d65-8cccda3dabf0	9d648f65-a385-4fe3-8bd2-2aa048bb9163	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":713}	2024-11-02 07:58:00
25528	9d68c6da-6036-45d1-9960-c640817e36ec	9d68c6da-63db-4624-b230-421b75bbc42d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1168}	2024-11-04 10:16:23
20271	9d66f0e2-b84a-4186-bc5f-85ae5f68b58b	9d66f0e2-bb1f-401d-9648-34846f6f42fe	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1004}	2024-11-03 12:22:16
20148	9d66eed5-e630-4567-9702-a367941ad25f	9d66eed5-e9b3-4c33-8fab-e9090aa4f65e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":997}	2024-11-03 12:16:32
7054	9d52da9a-47c1-4f37-9ce6-ac4bbe5fbf2f	9d52da9a-4f66-4e6e-85c3-efcc959ec17c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":357}	2024-10-24 12:43:24
15848	9d64b1cf-8512-4df4-be88-a91eab6dfc6b	9d64b1cf-8b77-49e8-9030-4a287d9eb7d3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":726}	2024-11-02 09:34:14
25127	9d68bfd7-71c6-4fd2-bced-ee93c3d380b8	9d68bfd7-77e5-4d5b-9be4-f59fe79c42d3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1145}	2024-11-04 09:56:47
4563	9d513316-fa69-4274-96fe-039e76286aed	9d513317-01bd-4017-a28a-658e95389743	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":249}	2024-10-23 16:59:10
12940	9d5ceef5-f33d-43cd-8ef3-f793fd1d9fc8	9d5ceef5-f70e-401d-af60-6c225b20ea86	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":614}	2024-10-29 12:58:36
5488	9d5220f5-9467-49c3-9652-7da6ed4a9e92	9d5220f5-a050-4cdd-a561-0af184fa4c8c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":294}	2024-10-24 04:04:18
26451	9d68d442-8712-4cea-a2e8-74aa4821ffb9	9d68d442-8a91-40a0-8e3b-fb66e15226e5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1226}	2024-11-04 10:53:52
25942	9d68cbfe-033c-43b4-8b2c-9ac13be8a3d2	9d68cbfe-076c-4f56-9966-473a7e131f79	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1196}	2024-11-04 10:30:45
26311	9d68d20a-b2c4-4df3-bdbf-6312f2175d28	9d68d20a-b878-4876-a2e7-64886b1ee1b8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1217}	2024-11-04 10:47:40
2777	9d50fc3a-bfd4-4dbf-8f41-61fdae791620	9d50fc3a-c443-4939-bd10-59c89af5010c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":157}	2024-10-23 14:25:46
16382	9d64c906-1bfa-4e2b-9a0f-659206566ac5	9d64c906-21f4-48b1-8bdd-b0e1d471fb91	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":760}	2024-11-02 10:39:09
31098	9d6945e6-d0ca-4fa9-be18-c9a0e8412733	9d6945e6-d512-4bdf-a1b7-0924cdff6a58	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1480}	2024-11-04 16:11:38
16999	9d6546d3-4b32-4d71-b2b0-b1b7c3fd5025	9d6546d3-4e18-4cdf-97bf-e9e433f10db2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42P01]: Undefined table: 7 ERROR:  falta una entrada para la tabla \\u00abl\\u00bb en la cl\\u00e1usula FROM\\nLINE 1: select \\"l\\".\\"id\\", \\"loans\\".\\"loans_documento\\", \\"loans\\".\\"loans_n...\\n               ^ (Connection: pgsql, SQL: select \\"l\\".\\"id\\", \\"loans\\".\\"loans_documento\\", \\"loans\\".\\"loans_nombre\\", \\"loans\\".\\"loans_apellido_uno\\", \\"loans\\".\\"loans_fecha\\", \\"loans\\".\\"loans_valor_prestado\\", \\"loans\\".\\"loans_cuotas\\", \\"loans\\".\\"loans_estado\\", \\"loans\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" inner join \\"users\\" as \\"ucl\\" on \\"loans\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"loans\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"loans\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"loans\\".\\"id \\" desc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":42},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":795}	2024-11-02 16:30:55
16471	9d64ccc6-2f76-4b7f-835f-4f4efacf61a3	9d64ccc6-33cd-4f06-856c-4a3591a32328	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":766}	2024-11-02 10:49:38
24599	9d68b756-ef03-4552-9ada-682887392f8e	9d68b756-fc8d-4f51-b8c4-909a827fc250	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1118}	2024-11-04 09:33:00
36632	9d6b3dcf-c99e-4aaa-b526-4f57fefeaa16	9d6b3dcf-ccc3-4065-8f2f-612d53726150	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1656}	2024-11-05 15:40:40
30836	9d694398-4c42-4f4a-ba2d-5940285db95b	9d694398-4fe7-4fe2-b0c7-fd35e280bd84	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1469}	2024-11-04 16:05:11
18134	9d65b92f-6cc9-4ae8-a6c5-2e7e868a2316	9d65b92f-6f9d-4608-9764-4b29f3210191	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":869}	2024-11-02 21:50:41
18164	9d65b970-aa76-4fb1-b553-37ba6eae4077	9d65b970-ad1e-4d43-a1f7-4c4daa79507d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":871}	2024-11-02 21:51:24
30001	9d692db4-caef-4736-9f67-10dd33e058bd	9d692db4-d054-4775-94d4-1b2ed480acaa	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1425}	2024-11-04 15:03:59
10729	9d57205f-469e-4386-bf23-1842296aaf3f	9d57205f-49ac-4890-a1a8-6056ff253bcb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":536}	2024-10-26 15:41:48
28620	9d690214-df9d-4c81-86de-b216cf626bfc	9d690214-e411-49ed-a734-4ac1973ca29a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1335}	2024-11-04 13:02:00
21743	9d673e08-91eb-46fb-96da-5da29865e4a1	9d673e08-956b-48bb-841f-85ed06bbcb3b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1048}	2024-11-03 15:57:59
1076	9d4f3e70-a5a5-453f-addf-bf7589ffc251	9d4f3e70-a92e-4d63-8136-c17f98a7e3eb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":84}	2024-10-22 17:39:15
28220	9d68ff43-4643-4860-9d07-d3196bb6f6e0	9d68ff43-4af7-4cea-a0eb-227a6725a519	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1316}	2024-11-04 12:54:07
8570	9d52ed85-c651-4cc9-800e-e2624e136d08	9d52ed85-c970-4112-8719-fb0dda9b3c57	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":415}	2024-10-24 13:36:18
25037	9d68bf68-64ce-42bc-b194-c0d63556fdb6	9d68bf68-6bff-4b68-ad92-196cb600254c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1139}	2024-11-04 09:55:34
19380	9d66d5e2-2545-4842-9ad4-65a5f70c0894	9d66d5e2-2818-410a-ab86-e00626f9c97d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":951}	2024-11-03 11:06:45
17434	9d655a63-9618-448c-b71c-f96eb635f5de	9d655a63-99f1-47cc-9f2c-d0d392b885c9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":833}	2024-11-02 17:25:37
10503	9d570eae-6b23-4cb3-aa0c-a48ff7258e8e	9d570eae-6e95-4b6f-b1fe-e9a282142a6f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":521}	2024-10-26 14:52:20
25181	9d68c029-7e99-4112-a2e4-3637f46aa66d	9d68c029-8174-43e3-b285-01b5e103eb5a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1148}	2024-11-04 09:57:41
35533	9d69c4f2-0794-4070-adf8-50b1defcc68f	9d69c4f2-0a85-487d-9f31-730e5e3027e3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1611}	2024-11-04 22:06:53
15918	9d64b462-5e32-4441-b7e7-dc7e68789ddc	9d64b462-61da-4381-88ac-18b87bb0820d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":730}	2024-11-02 09:41:26
35032	9d69c168-d776-4392-bb22-836c57f98aa9	9d69c168-db27-4298-a092-34f63987a47e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1585}	2024-11-04 21:57:00
29239	9d6913fc-9f37-485e-a985-fd55d21e3a04	9d6913fc-a24b-4a92-b47c-251380f3104c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1369}	2024-11-04 13:52:04
37353	9d6b4881-9452-49b1-ae0b-d76415b06e6a	9d6b4881-981f-41b3-9331-32ca709eafce	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1687}	2024-11-05 16:10:35
39763	9d6cb503-a5bf-48af-b9e1-b2ea7e28d776	9d6cb503-a8b4-47f7-a32e-2b89d7f20717	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1774}	2024-11-06 09:09:49
15357	9d5ed0d0-846d-471d-9569-3973500b68b4	9d5ed0d0-8814-46f6-9fa7-d2f4339fb2fb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":699}	2024-10-30 11:25:58
9723	9d56ac00-8ccd-4d27-89ac-0788cc74970b	9d56ac00-9088-4cf5-8fdd-afdb4366ed68	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":461}	2024-10-26 10:16:24
26501	9d68d71c-dd2b-46a2-b8b2-9f43f6d1c975	9d68d71c-e0ce-4ce2-8ae3-182fea4b7aae	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1230}	2024-11-04 11:01:51
861	9d4f3297-57ca-497c-a972-c3517a238297	9d4f3297-5cac-4b2f-96a4-a6b96a6e2ced	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":64}	2024-10-22 17:06:07
13025	9d5cf311-a3f3-47c9-84e8-6649fcf1b2a6	9d5cf311-aa49-465a-9e4a-6066ca05a91f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":622}	2024-10-29 13:10:05
1470	9d50d296-450e-4780-b3a9-9ed3e3d0ffb9	9d50d296-4900-438a-a6aa-0c2c7f187d6c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":104}	2024-10-23 12:29:20
8334	9d52e8cc-aa69-4776-bda6-6d9791f7a28d	9d52e8cc-ae42-472b-af32-e249ed9a6598	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":406}	2024-10-24 13:23:06
31356	9d694aa9-9fb8-40d4-a406-a485d673b802	9d694aa9-a2eb-42f8-a2ae-f115c1260520	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42883]: Undefined function: 7 ERROR:  el operador no existe: character varying = bigint\\nLINE 1: ...oin \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\"....\\n                                                             ^\\nHINT:  Ning\\u00fan operador coincide en el nombre y tipos de argumentos. Puede ser necesario agregar conversi\\u00f3n expl\\u00edcita de tipos. (Connection: pgsql, SQL: select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" inner join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = 92 order by \\"item_loans\\".\\"id\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":304},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1496}	2024-11-04 16:24:57
28333	9d6900cc-968c-4e8f-ad93-cade408ead8a	9d6900cc-9af5-4167-9a4d-caaab868350d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1321}	2024-11-04 12:58:25
6316	9d52643c-efca-4e59-9748-da88c910430b	9d52643c-f437-4e46-ab9c-e423b411703c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abfrom\\u00bb\\nLINE 14:     from loans l\\n             ^ (Connection: pgsql, SQL: \\n    select l.id,\\n        l.loans_documento,\\n        l.loans_nombre,\\n        l.loans_apellido_uno,\\n        l.loans_fecha,\\n        l.loans_valor_prestado,\\n        l.loans_cuotas,\\n        l.loans_estado,\\n        l.loans_intereses,\\n        ucl.name as cliente,\\n        uco.name as cobrador,\\n        ure.name as recomendador,\\n    from loans l\\n    join users ucl on l.user_customer = ucl.id\\n    join users uco on l.user_cobrador = uco.id\\n    left join users ure on l.user_recomendacion = ure.id\\n)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\loans\\\\LoansControlador.php","line":23},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":327}	2024-10-24 07:12:25
23543	9d689a34-8d9f-4171-8692-a40be2cfa3b2	9d689a34-91a1-4293-8394-36c3645d28ed	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1106}	2024-11-04 08:11:32
17841	9d65b0d9-3ae4-4360-81d2-dc1c060af67a	9d65b0d9-3e2e-4ca1-abfd-3d4e94f1ef71	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":852}	2024-11-02 21:27:22
6518	9d52d279-b392-4d0d-aff7-d559c196df26	9d52d279-b72e-4888-9d2e-b82621ce6cff	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":337}	2024-10-24 12:20:40
20615	9d66f8a6-61a7-4f16-be47-fd4916f19880	9d66f8a6-64ec-45f5-a50f-1859fd41ee22	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1022}	2024-11-03 12:43:58
31578	9d695181-58c3-474a-9383-1cc726e3418d	9d695181-619c-4db0-8c43-9092f073bce2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1511}	2024-11-04 16:44:05
40703	9d6cc6b0-934b-449f-9e5a-7ab58634be2d	9d6cc6b0-962a-404e-877c-9374c6207885	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1843}	2024-11-06 09:59:14
40255	9d6cc237-2da1-4d6f-bee9-52360ea3a8bb	9d6cc237-323d-4eb6-8e02-e70e8f113fce	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1797}	2024-11-06 09:46:44
4435	9d513001-0555-4a05-a43f-53bf212f1692	9d513001-09d2-4ac2-954c-d4c862bc5555	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":242}	2024-10-23 16:50:32
4663	9d513462-2263-4600-af3b-81420ca5644a	9d513462-285d-408e-bd48-e1e4e2e56d71	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":254}	2024-10-23 17:02:47
9221	9d52f612-b256-4220-85fe-3602d4444bab	9d52f612-b6dd-4950-852d-b9503d158a04	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":441}	2024-10-24 14:00:12
22169	9d674279-5827-4c0b-897f-882c094bd0d8	9d674279-5ded-43fe-b99f-c14eda97ef30	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1066}	2024-11-03 16:10:24
29624	9d6929f7-a101-49b9-aab5-6c6723c14971	9d6929f7-a3e0-4a08-abef-95a3e8c96c17	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1398}	2024-11-04 14:53:32
15029	9d5ece88-032b-4965-947d-7ec055c204d6	9d5ece88-0692-4472-9ea8-1440c30dc4e8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":674}	2024-10-30 11:19:35
20747	9d66fbe3-c39c-4043-872e-404d75cc504b	9d66fbe3-c6cf-4f70-824e-321af44b9790	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1028}	2024-11-03 12:53:02
11240	9d5cb0e6-8d1e-4abe-88b0-5b22e4ae164d	9d5cb0e6-907d-4c48-8f5c-3075ad279357	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":566}	2024-10-29 10:05:04
27820	9d68ea08-e621-4f0c-b00b-a8fec05d9f42	9d68ea08-eb71-4d16-afa9-3355e185b511	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1296}	2024-11-04 11:54:46
5925	9d52548c-1680-4a6f-adff-99b3351e76c6	9d52548c-19b1-48fc-9639-2f21855ca2db	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":305}	2024-10-24 06:28:33
37092	9d6b44ef-b1ca-4af8-8e77-ac5014408747	9d6b44ef-b4bb-470e-aae4-5fae8e6aa6b3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1676}	2024-11-05 16:00:36
929	9d4f38b4-08f2-4b11-a679-ef38e1c9e27b	9d4f38b4-0e61-4eb7-bbcd-814eaf5b3e21	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":71}	2024-10-22 17:23:13
39680	9d6be1f9-3332-4701-b96f-139ba8a72bf8	9d6be1f9-3709-4d08-b256-361147cf6637	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1766}	2024-11-05 23:19:42
12787	9d5cecde-2b2f-414e-a6f1-8186c5a6d675	9d5cecde-2e51-487d-9e23-e780892eb206	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":609}	2024-10-29 12:52:45
18530	9d66936b-55f2-4664-ac79-865f916e74ee	9d66936b-5b13-4856-b18a-617053e03367	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":888}	2024-11-03 08:00:55
11987	9d5ce044-6efc-4fc0-a625-ffb998c5c591	9d5ce044-74a4-4e72-a6a2-7e0b63556ee2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":590}	2024-10-29 12:17:31
28292	9d690054-d5e8-4dd9-a57c-a006882f293b	9d690054-d9e7-4f24-ba75-76610bec7aef	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1319}	2024-11-04 12:57:06
9822	9d56acdf-b79a-4a50-a443-ff91ba6b8778	9d56acdf-bb0e-40c8-af1a-0a52742ff189	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":465}	2024-10-26 10:18:50
4697	9d5134b2-abe0-49a5-9efe-85234928be76	9d5134b2-aee0-41a1-b94f-d20354e92496	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":255}	2024-10-23 17:03:40
38403	9d6b648a-cd43-461c-bd01-fd7842e6f13e	9d6b648a-d00d-4368-a886-ae72cf83108c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1725}	2024-11-05 17:28:58
16956	9d654663-37ac-4183-a296-4c9f528c55b4	9d654663-3a83-4192-96a5-42be5bf2865b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42P01]: Undefined table: 7 ERROR:  falta una entrada para la tabla \\u00abl\\u00bb en la cl\\u00e1usula FROM\\nLINE 1: select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", ...\\n               ^ (Connection: pgsql, SQL: select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" inner join \\"users\\" as \\"ucl\\" on \\"loans\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"loans\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"loans\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id \\" desc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":42},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":788}	2024-11-02 16:29:41
6350	9d5264d0-da38-4bf8-9959-5d1c3a54b9a1	9d5264d0-dd3a-4ee1-8d94-56d616ae3465	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":332}	2024-10-24 07:14:02
5673	9d5248d2-8c30-49a2-8242-3f4f7a14e76d	9d5248d2-9186-49c2-9c9a-66e98f3df8ae	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":301}	2024-10-24 05:55:46
22237	9d6743a4-728d-4b9a-9d66-d4353acd9a07	9d6743a4-7873-4262-8199-0f44961517ca	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1070}	2024-11-03 16:13:40
25852	9d68c9f9-986d-46c9-b006-e68f87e3bb91	9d68c9f9-9b7b-46a8-a845-a7b4d391dcdb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1190}	2024-11-04 10:25:07
10217	9d56cb32-637a-449a-8d8d-2136b38d12b0	9d56cb32-6633-4f0a-8c82-ccdbd46f8af2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":499}	2024-10-26 11:43:38
3109	9d5102cb-5d17-4128-8818-572e8e68d9d8	9d5102cb-608b-458d-839f-95bffa05899b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":175}	2024-10-23 14:44:07
28210	9d68ff41-ad71-45fd-a251-722a290ebf4d	9d68ff41-b00c-4e29-8609-e8ff183406eb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1315}	2024-11-04 12:54:06
39745	9d6cb442-8469-4d2f-ae2d-65b374ef2631	9d6cb442-8930-4dee-8c2d-21ef62065095	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1772}	2024-11-06 09:07:42
5397	9d51388a-12fb-48bb-b8e3-f9e21b92c12d	9d51388a-185e-4b6f-b2ae-a0fe007cec0b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":290}	2024-10-23 17:14:24
13120	9d5cf97f-099b-482a-958c-acfb6f2a7b43	9d5cf97f-1058-4888-bf8f-ae0b84add499	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":624}	2024-10-29 13:28:04
3275	9d510459-bf02-48a9-bbb9-3f6af9a2760d	9d510459-c33f-47e4-ad01-6a17d0f668c7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":184}	2024-10-23 14:48:29
30059	9d69336f-ed77-4cba-b352-cc77d0eec28a	9d69336f-f344-416b-8cbd-3eb7caf96364	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1429}	2024-11-04 15:20:01
4149	9d51214e-fe22-495f-9b00-61dec26c827a	9d51214f-0454-484f-a068-a328e3e2ee75	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":230}	2024-10-23 16:09:27
31823	9d6955df-d44e-490f-aa9d-eca627be0523	9d6955df-d9f5-47f0-86de-c97f4e15459c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1521}	2024-11-04 16:56:18
15033	9d5ece88-ed1c-43ec-b327-e03ee6573112	9d5ece88-f2e4-4ba2-a467-984567515b3a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":675}	2024-10-30 11:19:35
17223	9d6550cb-1581-4305-ac2b-187e73d7449e	9d6550cb-1a42-47f3-adb1-a1012cc4ade4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":816}	2024-11-02 16:58:47
31531	9d694ca8-1ea3-4f40-bbcc-c0f95882b3b3	9d694ca8-2529-426b-a5ed-7222f7f87649	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1508}	2024-11-04 16:30:32
1835	9d50df6b-f573-4c6f-8fe5-cb1177c01656	9d50df6b-f8f1-404a-9a31-706dfcfd829f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":118}	2024-10-23 13:05:13
34359	9d69be1a-7892-4d13-835c-cbd6a04372ca	9d69be1a-7c46-431f-89d3-09d53d3fd6e4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1559}	2024-11-04 21:47:45
889	9d4f33ec-fe50-4f67-ba6c-35983e36f837	9d4f33ed-03a2-4bae-9a61-aaf5ec9f9d55	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":66}	2024-10-22 17:09:51
31432	9d694bd3-cef9-4a38-99fc-f42d53aad619	9d694bd3-d491-481a-ab5f-a6f7824ee6c5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1502}	2024-11-04 16:28:12
3617	9d5108f8-728c-430e-9e20-3a735a836ca5	9d5108f8-75bc-485a-9355-767974f91c17	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":202}	2024-10-23 15:01:24
10321	9d56cd70-208a-45af-b197-276c1b1367b3	9d56cd70-2406-4942-8eda-d8a1d0bb5b09	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":507}	2024-10-26 11:49:54
28374	9d6900f1-4fb4-49e8-909b-090eb1133310	9d6900f1-52b3-4e54-b159-6263b038d242	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1323}	2024-11-04 12:58:49
36062	9d69c929-d82c-4f82-92bc-41e570d44840	9d69c929-dba4-4fbe-902f-fec365155d62	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1633}	2024-11-04 22:18:40
24939	9d68bee0-f47b-43e2-ac0f-b7c86d083b97	9d68bee0-f974-45f7-ac7d-f0fd9e0fc59b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1132}	2024-11-04 09:54:05
12479	9d5ce93e-3253-4eaa-a2d7-96f82913269d	9d5ce93e-35c9-4225-bb7d-d8d8f571f90d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":599}	2024-10-29 12:42:37
16322	9d64c2ea-f609-457a-a673-4066d84775f5	9d64c2ea-f96d-4af0-80f1-0998b0177d48	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":756}	2024-11-02 10:22:04
39835	9d6cb757-fb23-4606-92c1-ab0c539b4a3e	9d6cb757-fee4-4159-b522-8a513e595abc	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1782}	2024-11-06 09:16:20
27625	9d68e8b5-9667-4e34-ad3a-d3a6966502c7	9d68e8b5-9a03-43e2-9aee-99db64d97dae	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1287}	2024-11-04 11:51:03
22087	9d674251-551c-47e9-858a-6486afaa6e3e	9d674251-59b0-49af-8c9a-06704f7e49f1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1061}	2024-11-03 16:09:58
2383	9d50e782-0e7c-44fa-97b6-566a9b41988f	9d50e782-11cf-4c53-8e12-c1a57db65477	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":136}	2024-10-23 13:27:50
15139	9d5ecf14-63d3-40fa-a79a-11d61bf51413	9d5ecf14-66c6-4bb9-845e-ad43096f33bd	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":682}	2024-10-30 11:21:07
32705	9d69830a-72b3-4935-bbe9-7678fb032f0a	9d69830a-771e-4526-823d-5ca8fc66db03	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1539}	2024-11-04 19:02:36
3897	9d511aee-774d-4e40-835b-9af69c168e4a	9d511aee-7af5-460a-b100-4a45092f651d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":217}	2024-10-23 15:51:37
19110	9d66d045-b323-4521-af0b-f2273c771a15	9d66d045-b8f7-4198-87c1-70c95126d688	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":933}	2024-11-03 10:51:04
947	9d4f3969-75d8-4190-a2d8-c45599daff44	9d4f3969-79ba-4135-a681-b39706f61e46	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":73}	2024-10-22 17:25:11
11053	9d5ca88c-9271-4375-ba21-93ef0dc1f144	9d5ca88c-9744-45e9-b8f4-ee8dcd65ae53	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":555}	2024-10-29 09:41:43
28261	9d68ffbc-8a9e-4a21-be91-e1f835361c2a	9d68ffbc-9092-4642-97d2-1fac39379467	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1318}	2024-11-04 12:55:27
26102	9d68cd5e-eac8-42d6-8e3b-cdd52204b20f	9d68cd5e-f0f1-450d-b033-cd5b29b21e8d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1207}	2024-11-04 10:34:37
11423	9d5cbe3a-1af8-478e-ad18-5c7f6c6bf88b	9d5cbe3a-1f9a-4025-b3f8-2ab129dd2aed	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":574}	2024-10-29 10:42:20
11136	9d5cab62-1fb9-4467-81ad-78427e5c3d16	9d5cab62-2250-430a-b270-ed30fe22c465	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":560}	2024-10-29 09:49:38
3071	9d5101c3-3e1f-4778-8462-3b4fb46cb527	9d5101c3-40c6-4638-8272-4f90eceb89d0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":173}	2024-10-23 14:41:14
737	9d4f2e5e-36c4-42bf-851b-3b22739ac27c	9d4f2e5e-3b02-4cb5-995e-78a474da7b63	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":53}	2024-10-22 16:54:19
11091	9d5caac8-ac49-420e-86e0-cde585e17511	9d5caac8-af03-473e-87a3-e48b685b1181	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":557}	2024-10-29 09:47:58
6153	9d52598a-43c9-4dea-bfe5-04781ed8ffba	9d52598a-4903-493b-ba61-37d8b2dcb2cd	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":306}	2024-10-24 06:42:31
26173	9d68cebb-35dd-437f-aa1d-af535d6f3500	9d68cebb-3b76-4145-b69c-cd42575c1304	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1209}	2024-11-04 10:38:25
7538	9d52df61-a0de-4a4a-ba14-debd41ad5475	9d52df61-a4a0-4cea-893e-7cb4af0ee535	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":376}	2024-10-24 12:56:45
511	9d4f29f4-5717-4116-8114-57ea7af9c0d1	9d4f29f4-5a98-40b0-a6ec-e84c180560fa	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":36}	2024-10-22 16:41:58
39294	9d6bcf5f-5d20-456f-8969-bbbfb67869c0	9d6bcf5f-6157-4092-bce2-a724ab6c8e9d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1750}	2024-11-05 22:27:41
35258	9d69c3b0-cdf9-499f-9eda-45ee3d4a767c	9d69c3b0-d447-48b2-a2b9-fd5392daac3f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1598}	2024-11-04 22:03:22
25480	9d68c67b-381e-4a38-9132-407a6c22f21d	9d68c67b-3cbd-4e87-bd42-63d1089976e7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1165}	2024-11-04 10:15:21
22667	9d67f8a3-949c-4f10-9e3a-b09fdd03d512	9d67f8a3-984b-49dd-8b4a-a05afb4f433b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1089}	2024-11-04 00:39:46
11106	9d5cab16-b27e-4001-912a-96e210a2ae58	9d5cab16-b76d-4c5d-971e-a27dc2481dbe	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":558}	2024-10-29 09:48:49
15333	9d5ed0cd-3dca-4cdd-87bf-e57e300ef7b2	9d5ed0cd-443b-453f-867b-aee5970590c5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":697}	2024-10-30 11:25:55
31318	9d694a27-4a04-4e9d-adcc-77da84f39e6d	9d694a27-4cdc-4688-8b1c-24cd490671c6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abas\\u00bb\\nLINE 1: select * from \\"item_loans\\".* as \\"users.user_alias\\" inner joi...\\n                                     ^ (Connection: pgsql, SQL: select * from \\"item_loans\\".* as \\"users.user_alias\\" inner join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"loans_codigo\\" = 92 order by \\"item_loans\\".\\"id\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":305},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1492}	2024-11-04 16:23:32
39725	9d6be27d-f9af-4a53-94bd-7ddfb856e267	9d6be27d-fc88-4d0a-bd58-1e409a0e1f49	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1771}	2024-11-05 23:21:09
3123	9d5102cd-a9a4-48f9-b791-bd30f338588a	9d5102cd-b03b-415d-ae20-4a403bc6ccb8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":176}	2024-10-23 14:44:09
2995	9d5100be-eeeb-4d37-a064-984e667f641b	9d5100bf-acaf-4718-9e95-b8bf82a6605d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":169}	2024-10-23 14:38:24
30208	9d6936fd-b099-4353-a820-91b533313ee2	9d6936fd-b505-4daa-9761-09f1a0cbb552	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1438}	2024-11-04 15:29:57
3835	9d511a4e-53d1-48ff-8c5f-d864d880cf37	9d511a4e-5ac9-40cb-a889-b183f0cf8179	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":214}	2024-10-23 15:49:52
30950	9d6944e8-76dd-4429-a281-201ce0f7eae3	9d6944e8-7ce7-409b-acd6-7f7bfc70d141	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1476}	2024-11-04 16:08:52
2577	9d50fad2-9cad-4cb6-8637-1abdcb34b401	9d50fad2-a315-4421-85ab-cc59065fd659	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":147}	2024-10-23 14:21:50
37669	9d6b59a7-f171-43b6-a1b7-0d51c2772fd9	9d6b59a7-f8b0-4190-bb6e-bc05bf80651c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1697}	2024-11-05 16:58:32
4411	9d512e75-982e-4667-ad67-416f2396bfbb	9d512e75-9f12-477a-bbfe-c485ee06411c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":241}	2024-10-23 16:46:13
38426	9d6b64ae-9136-456c-a055-668bc88f9b1a	9d6b64ae-94bc-4c1f-8072-c9a8f8999ac6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1726}	2024-11-05 17:29:22
26331	9d68d310-aceb-464e-b38b-57d7f5ab2cc6	9d68d310-b174-4a31-8961-5af162c6a5ec	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1218}	2024-11-04 10:50:32
10204	9d56cb25-b0e2-43a1-a875-5d076d6d6752	9d56cb25-b4c2-4e62-9e08-92a9a46e59cd	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":498}	2024-10-26 11:43:29
40327	9d6cc283-55ff-42d6-8c85-15c1ca8eddf8	9d6cc283-5972-45c1-8359-ee2ab64ebbee	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1801}	2024-11-06 09:47:34
7746	9d52e07e-8655-48e0-b05b-0e5afb058984	9d52e07e-89cb-40ea-9d5e-5a650aec536c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":384}	2024-10-24 12:59:52
25538	9d68c6dc-4427-4093-b467-778c2131d608	9d68c6dc-55c6-4832-9eec-9364d7f483b4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1169}	2024-11-04 10:16:24
30940	9d6944e7-11c7-4bcb-8521-d599f05d6d32	9d6944e7-1636-4d9a-8ec8-f9cd86fc09f5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1475}	2024-11-04 16:08:51
4397	9d512e72-4b35-408b-a9d0-67a5ad11eaaf	9d512e72-4f6f-43ef-9a9c-5b0e62e81e5b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":240}	2024-10-23 16:46:11
41640	9d6cce5b-8050-41c9-b550-4b6789e3c336	9d6cce5b-8358-4642-b222-e65999b6af36	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1911}	2024-11-06 10:20:41
27584	9d68e87b-8739-44ee-a195-141fdcc38829	9d68e87b-8b6a-4a80-be8f-5e0d6b6a2209	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1285}	2024-11-04 11:50:25
27512	9d68e794-fc55-45b6-846a-b152297d361b	9d68e795-02e5-45df-a507-9b9647f15396	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1282}	2024-11-04 11:47:54
15993	9d64b7e1-cb4d-4270-92ca-b2a97a5631d8	9d64b7e1-cf71-4d30-adeb-9d3e7e845ac7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":735}	2024-11-02 09:51:13
41124	9d6ccba7-e042-4cdd-b519-9787516b96ef	9d6ccba7-e63a-45fa-8549-254e7b10bb85	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1881}	2024-11-06 10:13:08
25650	9d68c7b3-b7d6-49aa-bba2-2b9f1dddc1e7	9d68c7b3-bdee-4ae5-8a46-7f184c760b4e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1177}	2024-11-04 10:18:46
20118	9d66ee83-c4a2-4fe1-9e54-d215725acf2a	9d66ee83-c792-4170-8ec7-414934e54eeb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":995}	2024-11-03 12:15:38
30389	9d693ce9-df62-4b1c-b585-284d4ce173a7	9d693ce9-e2a4-48e8-8e69-b1c941ae40d2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1447}	2024-11-04 15:46:30
35594	9d69c502-c8d6-405f-9849-91d60f4b872d	9d69c502-cf31-4555-b64d-f41a70b0a39a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1614}	2024-11-04 22:07:04
12684	9d5cecaf-35f8-444f-bc1d-7d69a500eaaa	9d5cecaf-3988-4d98-9a11-42a3bc89226b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":605}	2024-10-29 12:52:14
19050	9d66cf8b-1a20-44d6-a84e-87d28f69c65b	9d66cf8b-1e17-49f2-b1f9-448b95966802	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":929}	2024-11-03 10:49:02
2539	9d50fa2c-260b-439f-8d91-fb2be97e3a1f	9d50fa2c-2b36-4329-b372-6383727e70de	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":145}	2024-10-23 14:20:01
34847	9d69c0cc-33e5-4313-ae79-c2d292d5cfdb	9d69c0cc-37a6-4d50-95b9-7faf06c63af4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1575}	2024-11-04 21:55:17
40499	9d6cc3f1-48e1-41ee-8a13-5a00c76db3e8	9d6cc3f1-4c05-490d-8f00-7b61c099607d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1819}	2024-11-06 09:51:33
28425	9d6901ac-d1d9-40a7-a8e7-928ec3a0fae3	9d6901ac-d7fc-479b-befc-3063fdd05414	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1326}	2024-11-04 13:00:52
38086	9d6b5f15-ce81-4f06-8010-41a72650a47c	9d6b5f15-d137-4649-a653-8776bc48adf5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1711}	2024-11-05 17:13:43
17050	9d6548af-91e3-4261-af42-d6ffb4408034	9d6548af-954c-4e00-933e-46e14dcb0f1d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":803}	2024-11-02 16:36:07
28466	9d6901c3-5454-4cf8-b0c0-58320fd58232	9d6901c3-5a8b-4276-99ad-d440a181389e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1328}	2024-11-04 13:01:07
21965	9d67414a-63d6-4697-8a99-ad01afce5979	9d67414a-6a36-4836-93ba-be83bf733205	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1054}	2024-11-03 16:07:05
6399	9d526c6f-09b3-4b90-8cc1-03d808f04029	9d526c6f-117a-43fb-ae2b-358bc2604c68	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":333}	2024-10-24 07:35:20
35216	9d69c2f6-3882-43b3-88b8-6c68f624efee	9d69c2f6-3e13-4104-a848-dff31304b9ed	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1596}	2024-11-04 22:01:20
1666	9d50dab3-cd32-48e5-a1e9-9cdb73e2c294	9d50dab3-d334-4417-908a-2eb2fb4f590a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":112}	2024-10-23 12:52:01
18890	9d66caf2-3949-4022-a9b8-5690746e2e7a	9d66caf2-3f6e-42d5-acc6-7c45abdb05bf	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":922}	2024-11-03 10:36:10
3769	9d511874-c0ef-4e76-bc77-59a4d7024c0b	9d511874-c524-48f7-abbc-2b4aa26d583c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":210}	2024-10-23 15:44:42
34452	9d69be7b-e6b1-4775-9a3f-21f034f50537	9d69be7b-eb17-4534-a680-6aa81191c309	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1562}	2024-11-04 21:48:49
448	9d4f290c-5f3f-41b6-8276-b6be4135e2ff	9d4f290c-62b1-4b54-963f-1c57b297eff5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":29}	2024-10-22 16:39:26
30906	9d694439-b299-41e3-8b03-373e7cf85efa	9d694439-b75d-4296-9403-bd873c6a1789	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1474}	2024-11-04 16:06:57
6303	9d526439-acb0-41cf-b445-96b27c17b471	9d526439-b073-46e5-a038-7ea7714e9ad0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":325}	2024-10-24 07:12:23
1787	9d50df02-a096-4dee-8134-a5139191fec1	9d50df02-a4de-4be9-ac58-d2c20c5f1624	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":116}	2024-10-23 13:04:04
31498	9d694c53-0ab9-4573-9e9a-2d8fd7da3e79	9d694c53-103d-429b-9bc8-2c24dd6c5165	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1506}	2024-11-04 16:29:36
14235	9d5d16c9-13b3-4c6a-b569-035a1d699d5d	9d5d16c9-167e-47bf-9145-7c4f41e1402d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":651}	2024-10-29 14:49:57
41725	9d6cceff-00b0-4b07-a78c-cdcbb9de365d	9d6cceff-0451-4a81-ba97-1e210b4b147c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1921}	2024-11-06 10:22:28
9096	9d52f429-aa15-4c4f-ada4-9d0c41696dff	9d52f429-adfd-49c5-ae86-b5dfce0b808e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":436}	2024-10-24 13:54:52
26591	9d68d8c6-3dc6-4e2d-85ad-bf7abeb2022b	9d68d8c6-411d-43f4-8fd6-f56bb8f1754a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1236}	2024-11-04 11:06:30
36609	9d6b3dc3-5d89-4952-bea6-8507fd85b5ba	9d6b3dc3-61b4-4217-a416-1f82d86afe5b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1655}	2024-11-05 15:40:32
41674	9d6cce9b-adbc-4b3b-abff-7841b985f1e8	9d6cce9b-b1ac-42a1-a832-eeb60e7fa12d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1915}	2024-11-06 10:21:23
14048	9d5d153c-c330-4485-9bdf-47b381de3d30	9d5d153c-c86b-440c-9aa6-e7d75e438df6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":646}	2024-10-29 14:45:38
4006	9d511bfb-4e19-4db9-bf0f-74485f6a3060	9d511bfb-53f7-448d-ba0e-478494a5655c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":223}	2024-10-23 15:54:33
30088	9d69337d-2a09-4dcb-b9c4-bf5a17f74a41	9d69337d-3033-4271-aa6a-6ca410cefe0a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1431}	2024-11-04 15:20:09
22067	9d674183-e5e7-4ce3-880c-a66e8ba5dcaa	9d674183-eb9c-488c-a4c3-c465eca4e3ba	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1060}	2024-11-03 16:07:43
29163	9d6912fa-b2ef-46ee-81ce-d1b2abefa124	9d6912fa-b8b6-4fca-9c2d-0e67d0e194f7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1362}	2024-11-04 13:49:15
31352	9d694aa8-f95e-46e2-aa19-f9b92f9acb56	9d694aa8-fc7f-49c6-a97a-3a22a5357e34	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1495}	2024-11-04 16:24:57
11121	9d5cab46-ab47-4838-8ba1-eaf4c3798625	9d5cab46-af1f-4a87-a069-415f6d2e47a1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":559}	2024-10-29 09:49:20
22261	9d674858-6f7a-45fe-8535-c1b7fe0bff24	9d674858-7476-4a07-8a57-539b47263771	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1071}	2024-11-03 16:26:49
36862	9d6b40fd-2b98-47f1-ac4c-002a333c81b2	9d6b40fd-2f26-4367-86d4-c2f9a3e38056	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1666}	2024-11-05 15:49:33
7970	9d52e58a-54c2-48b1-9ead-74954d16d298	9d52e58a-5854-4712-837a-4cd9bf286316	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":392}	2024-10-24 13:13:59
6492	9d52d22c-35e2-4ad1-a9b6-b30a4efa67db	9d52d22c-3988-46dc-bf66-e1a8db22c1ab	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":336}	2024-10-24 12:19:49
29221	9d6913e0-56f9-48b5-ae32-5f222a112211	9d6913e0-5cc1-40af-8faa-6c3d96406252	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1367}	2024-11-04 13:51:45
9070	9d52f403-422a-475f-8767-666eee764e9b	9d52f403-4543-46c9-aba7-5521d942ab27	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":435}	2024-10-24 13:54:27
12718	9d5cecb8-2b93-4d38-a4c3-3896297142b1	9d5cecb8-2fa6-4ed7-8971-23b52a9c539d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":607}	2024-10-29 12:52:20
12893	9d5cee09-e9b7-4de2-98c2-e7aaa4021f5f	9d5cee09-ed9f-404f-b872-00afad188dc2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":611}	2024-10-29 12:56:01
24589	9d68b755-3b0d-41e0-b1df-55c584d4fdfe	9d68b755-3f7b-4a78-86b9-4b2a7e854828	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1117}	2024-11-04 09:32:59
25283	9d68c106-01b5-492f-8a64-2e55e1e811f4	9d68c106-05ff-4ffc-bf0f-17c66714c369	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1154}	2024-11-04 10:00:05
21195	9d6736b0-d99d-4d22-abc8-94d268381930	9d6736b0-dd66-400e-8c6e-517a75469884	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1036}	2024-11-03 15:37:27
10865	9d5ca558-df23-46ae-81b4-8e51a4ca6ae1	9d5ca558-e57e-426b-9a8e-a70b9a7deaf8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":543}	2024-10-29 09:32:46
5069	9d513670-b98e-4ad6-aa2c-96a753f1baf0	9d513670-bff9-4245-9dc6-3737977e566c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":273}	2024-10-23 17:08:32
4918	9d513650-3c78-4fb5-8d29-c849296782a8	9d513650-4119-4630-8ecf-4933833b0ba5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":264}	2024-10-23 17:08:11
12406	9d5ce48d-2b25-40d7-9a4e-d4fcc93ae0ad	9d5ce48d-2ec5-4281-824a-8a17030a35f1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":596}	2024-10-29 12:29:30
28925	9d690dbf-c61f-4948-b98f-ce0fb8d6428b	9d690dbf-c940-4974-83fe-9b561afb9e4d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1349}	2024-11-04 13:34:37
10570	9d57108a-c7e3-49f3-aafd-74cfeda1de71	9d57108a-cb38-4d0b-a61c-4a5edbc4e7e9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":526}	2024-10-26 14:57:32
28415	9d6901aa-428f-4253-9493-a6e3b0c83342	9d6901aa-4741-48f4-8044-0128a7d1a1e9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1325}	2024-11-04 13:00:50
1029	9d4f3de5-25ff-44cf-ad89-db87626d22a7	9d4f3de5-2b7b-4277-93a5-c840dd9cf468	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":81}	2024-10-22 17:37:44
695	9d4f2e0a-03ed-4ce6-ae0c-ef346122b6f5	9d4f2e0a-06d4-4815-97a8-f3dba8d68a11	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":50}	2024-10-22 16:53:23
14515	9d5eb96f-2137-4472-baf1-00d4416dbccd	9d5eb96f-2461-4e72-8ba8-c8622271a142	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":665}	2024-10-30 10:20:35
24115	9d68a765-e9c5-4b1f-a54e-fba32a24eede	9d68a765-ed7e-4c31-a117-0111bfb8a4d5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1112}	2024-11-04 08:48:26
26762	9d68dc1f-98f3-4884-b9d2-e8555adad0f1	9d68dc1f-9c0a-41fc-83e9-3e451e424530	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1247}	2024-11-04 11:15:52
19455	9d66d69d-89c4-4264-ae2e-1a8352c7f99a	9d66d69d-8d39-4a2a-bad4-f909bf0a2f84	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":956}	2024-11-03 11:08:48
20466	9d66f420-ab9c-4052-be1a-01890f772230	9d66f420-aed4-4c6e-8bb1-fa550a7a3cd4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1017}	2024-11-03 12:31:20
26601	9d68d8c7-fdb6-4ef2-9de7-132aef69b40c	9d68d8c8-050b-4b1c-a14b-bb1a053b26fa	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1237}	2024-11-04 11:06:31
31564	9d69517f-2454-4a43-b6d7-514e3cc62635	9d69517f-28e6-4290-8817-cf26b5ae5652	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1510}	2024-11-04 16:44:04
38595	9d6b672c-d5b6-47c4-8eb8-6f895adc8750	9d6b672c-d8b4-432c-95ae-e0749eab03d3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1733}	2024-11-05 17:36:20
22585	9d67e3d3-92b4-4df3-b976-a2183ea5863b	9d67e3d3-99ad-415c-814d-6d576ca6e695	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1084}	2024-11-03 23:41:34
9403	9d52f7a7-0c1b-4b1e-842f-91637596af05	9d52f7a7-0fc0-45cf-9f0a-8fd920b67989	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":448}	2024-10-24 14:04:37
17369	9d6558b9-43f4-4649-878d-df76c8c67cf3	9d6558b9-dd03-4581-8ab4-d51b9a90b29a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":828}	2024-11-02 17:20:57
26914	9d68dd93-9ce6-42da-a8da-fd1509d8168d	9d68dd93-a2db-408d-8645-583cea4f9192	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1256}	2024-11-04 11:19:55
38622	9d6b67b3-15b5-47a6-89ae-b9cd536bfc58	9d6b67b3-19cd-4c4a-a102-cce31862a01d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1734}	2024-11-05 17:37:48
4226	9d51299a-1f6e-4d8b-87cd-5ad45db41908	9d51299a-2500-4f85-81ce-296026692877	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":233}	2024-10-23 16:32:38
30049	9d69336e-aa07-4971-92eb-26000044f347	9d69336e-ae96-40ce-96ba-8bb0737d2c9b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1428}	2024-11-04 15:20:00
25227	9d68c099-f629-4122-adaa-a0ebd241b17c	9d68c099-faa4-4f93-aae1-ec60d35df07c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1150}	2024-11-04 09:58:54
10412	9d56cf88-2dc9-4d02-a5bd-4c0339ac2929	9d56cf88-30e7-4d37-9b87-15685af8574f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":514}	2024-10-26 11:55:45
24781	9d68bd45-b883-4b3d-86bb-defe6a05df3f	9d68bd45-bba3-4472-90d2-ed722c6ac1fc	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1124}	2024-11-04 09:49:36
20331	9d66f148-63cf-4703-b5da-c382eb57f23c	9d66f148-671a-4921-bf27-4d720813cc44	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1008}	2024-11-03 12:23:22
1355	9d50cd0c-009d-4800-a7ce-ba917e5a9d14	9d50cd0c-040f-4571-8bde-446ac6a2cd29	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":98}	2024-10-23 12:13:50
40856	9d6cc7d8-8d94-4a85-9d7b-746038d10073	9d6cc7d8-90f2-420c-a43d-4f6034e53b0a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1861}	2024-11-06 10:02:28
17408	9d6559b2-94ae-4bcc-adb6-42d23dbb8927	9d6559b2-99fe-487f-8ba1-efbe8448dbd7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":831}	2024-11-02 17:23:41
25802	9d68c950-0829-4254-b7cc-f6b31f2631d5	9d68c950-0ea2-4104-8b9e-7e37c805a5e3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1187}	2024-11-04 10:23:16
40066	9d6cc09b-c045-4280-bfdf-6d9c54bbb18f	9d6cc09b-d31e-477f-8867-4d9d8190e069	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1789}	2024-11-06 09:42:14
17348	9d655877-4d81-400c-b119-570e1fbf3349	9d655877-51ae-4207-965a-f9223e421a03	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":826}	2024-11-02 17:20:14
529	9d4f2a71-baab-420b-a94b-0508a7d20a7f	9d4f2a71-c0bf-4196-8686-170310111d68	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":38}	2024-10-22 16:43:20
16630	9d64d427-4ba3-44ba-bf87-72b9ace33aaf	9d64d427-507c-481e-80ae-73022eb7e43f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":774}	2024-11-02 11:10:16
23224	9d688d33-6247-4bc9-bf9d-5d03ad0d207a	9d688d33-6530-4a98-8818-c61c8da3e1be	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1099}	2024-11-04 07:35:11
32667	9d69828d-059d-42d2-ae71-7801647cefb2	9d69828d-caa6-428a-bbe9-8abf922dbee2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1537}	2024-11-04 19:01:14
26012	9d68ccf5-bbc9-4228-9abe-5bf0aa387322	9d68ccf5-c347-45e7-8bde-fdd70dcb3822	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1201}	2024-11-04 10:33:28
17382	9d65590a-e568-4968-9c42-890b6ac10969	9d65590a-e96f-4f14-9062-3ffc3796a259	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":829}	2024-11-02 17:21:51
10360	9d56cee9-1453-4c61-a6de-2031eda8df92	9d56cee9-196e-4fed-a290-c93210cad83d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":510}	2024-10-26 11:54:01
35858	9d69c80c-f5d9-4f7d-a6a9-96521c554ff6	9d69c80c-f8cb-4f82-9c93-797f1314c4bd	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1623}	2024-11-04 22:15:34
38547	9d6b669c-837f-49f9-8e95-bc7de4d1e533	9d6b669c-8666-4614-a265-d3a873ec74f4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1731}	2024-11-05 17:34:45
20103	9d66ee5d-03c5-4cf3-a6ed-611a1af53b67	9d66ee5d-081b-48f9-9874-fddcea11fe00	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":994}	2024-11-03 12:15:12
9299	9d52f706-3f66-486e-91e7-74e3cf01501c	9d52f706-44a4-40d5-bbec-0b2812ac6aac	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":444}	2024-10-24 14:02:52
28302	9d690057-22d6-45f3-b437-31ea1a8fcab7	9d690057-2910-4911-89bb-95e3a531a2ad	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1320}	2024-11-04 12:57:08
27153	9d68e278-b2f5-40a5-8370-f2a4ba1ad27b	9d68e278-b887-4da3-a333-326d0d1a86e7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1264}	2024-11-04 11:33:37
41290	9d6ccc39-1dca-4b6f-a2d0-8ddc8fdfb2e5	9d6ccc39-2285-46be-8137-58a02a0e8643	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1891}	2024-11-06 10:14:43
17210	9d65502a-7864-4b32-aff0-bbf325f60f96	9d65502a-7b82-4234-a86f-3a304d8133c1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":815}	2024-11-02 16:57:02
13188	9d5cfa0d-1411-44fb-b364-0c2377638185	9d5cfa0d-1a52-4e99-b0e0-9ec06aec3ddb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":628}	2024-10-29 13:29:37
5235	9d513779-6109-4e70-86f1-c4399993dfad	9d513779-6491-4f1a-b8ea-d00f1a52fc06	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":282}	2024-10-23 17:11:26
8592	9d52edac-144b-4a91-8900-2392bc0964fa	9d52edac-1785-42f9-ac38-cfc73f967e91	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":416}	2024-10-24 13:36:43
20193	9d66ef41-166d-4c1d-97c0-5c7bea6bdf1d	9d66ef41-19ea-4b06-8f7a-9b2dfd360f8c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1000}	2024-11-03 12:17:42
41852	9d6cd062-e240-4d4a-8863-3022c2e2fdaf	9d6cd062-e5ea-4406-bf5a-ad2c516db174	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1937}	2024-11-06 10:26:21
32908	9d69a6ff-a74c-4d9c-b2e6-cb190e66ff4b	9d69a6ff-ac63-4c44-bbaf-7cc00b43e45b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1547}	2024-11-04 20:43:08
13017	9d5cf310-5dea-433e-a293-240ccd9ae434	9d5cf310-60fd-40a8-b076-4859aa0f778f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":621}	2024-10-29 13:10:04
41606	9d6ccddd-ad3b-4eae-9e17-7687948d07b8	9d6ccddd-b018-48a9-b424-8d6e1960587d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1907}	2024-11-06 10:19:18
25862	9d68c9fb-7022-46c1-942d-396627ade9c2	9d68c9fb-74d4-484e-b305-7195bc13b8ea	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1191}	2024-11-04 10:25:08
27553	9d68e7fa-6856-45fe-a693-b952dd95a48c	9d68e7fa-6daa-4642-8322-34faeecd1959	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1284}	2024-11-04 11:49:01
12694	9d5cecb0-8510-4379-b2b4-1f776b3b9eaf	9d5cecb0-8a7b-4c2e-a6fd-03c4bc022926	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":606}	2024-10-29 12:52:15
24155	9d68a8e5-8e14-4f94-80ea-88efb8b88724	9d68a8e5-90c5-46e7-8e17-e030b93f65ed	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1115}	2024-11-04 08:52:37
7668	9d52dfad-8400-4406-87f5-ed92c6a7beaf	9d52dfad-8826-48bb-ab20-e8af246918ca	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":381}	2024-10-24 12:57:35
8784	9d52ef0a-aa0c-4842-a880-19208a8baef4	9d52ef0a-ad8f-4f75-97b0-c609cb07f415	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":424}	2024-10-24 13:40:33
41218	9d6ccbdd-1ba5-4de7-ab32-40693925425d	9d6ccbdd-200f-4396-ac4e-188d7c237dca	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1887}	2024-11-06 10:13:42
30984	9d69450c-cb37-4514-a888-895389d43115	9d69450c-d189-4e80-b10d-914ee4159f5e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1478}	2024-11-04 16:09:15
26461	9d68d444-9519-47ff-b726-5f0cfdb64909	9d68d444-9dbf-4cef-b787-3d49939fb0a4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1227}	2024-11-04 10:53:54
35342	9d69c401-dee3-450e-a482-19fc720ebbd4	9d69c401-e4ea-4d92-9553-a72797c96520	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1602}	2024-11-04 22:04:15
40686	9d6cc68e-3720-4415-b6aa-70f7c21d9a10	9d6cc68e-3bc6-474b-b962-b36243e48d06	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1841}	2024-11-06 09:58:52
30282	9d69397f-7c1d-47d9-aa23-b16ca07a51d4	9d69397f-81cc-40df-a6ca-a11038729786	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1443}	2024-11-04 15:36:57
9861	9d56b48e-cc7c-4e4a-8764-d7f9416ff65a	9d56b48e-d05c-4cd0-b19d-24f66f7b8ee7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":468}	2024-10-26 10:40:20
6162	9d5259b2-8840-425e-962f-29350cee5014	9d5259b2-8b83-423c-b154-f47fb564fec1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":307}	2024-10-24 06:42:57
37253	9d6b466c-457b-41a5-b59d-26e227362c45	9d6b466c-495b-45d7-900e-478dd7b29f67	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1683}	2024-11-05 16:04:45
24899	9d68bde8-0835-4541-a005-f3b093015206	9d68bde8-0be5-4126-8db2-91bc631a01f9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1130}	2024-11-04 09:51:22
10542	9d570fd3-5645-4af6-a926-e6495c4176b5	9d570fd3-5ac6-4f78-98dc-d40b11f8ba56	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":524}	2024-10-26 14:55:32
16053	9d64b8f1-084b-488a-ad79-155813d03391	9d64b8f1-0cbb-497d-b8c7-508a286182f8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":739}	2024-11-02 09:54:10
19649	9d66e2b7-c7cf-4d03-b827-f736a77825ab	9d66e2b7-cc5c-44f1-bf87-28b64b6bcabc	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":967}	2024-11-03 11:42:39
13760	9d5d0e7e-8e5d-4067-966c-fab9ce4e0202	9d5d0e7e-93e8-453c-986c-7196e4830d12	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":638}	2024-10-29 14:26:46
14128	9d5d1640-53fa-464b-83a9-0d47f3e1ee33	9d5d1640-589f-4445-bfc7-0ea1e85b51de	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":649}	2024-10-29 14:48:28
16600	9d64d3fc-d013-4668-aba5-96c13db20fb7	9d64d3fc-d31b-4562-aa24-8326c88be91b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":772}	2024-11-02 11:09:48
37907	9d6b5d8b-74a0-417f-a410-b6e787d7834e	9d6b5d8b-77e2-4366-a831-af12dfcc7065	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1703}	2024-11-05 17:09:24
1243	9d50c6d0-ca1a-4d78-98d7-bc716a078e15	9d50c6d0-ce60-4a1e-ad1a-54638617d50f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":92}	2024-10-23 11:56:25
6252	9d5263a6-3963-4642-8f8f-f11817151f6c	9d5263a6-4248-411c-8cc7-0336e6446cd2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":316}	2024-10-24 07:10:47
28966	9d690dc4-afa6-44b2-af04-c33f13ea3a57	9d690dc4-b287-4083-808c-aca5ec01e7c3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1352}	2024-11-04 13:34:41
24851	9d68bd9c-bc0f-4ba3-96d9-2c1731818fab	9d68bd9c-bffa-43e9-921d-86b892e55404	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1128}	2024-11-04 09:50:33
31917	9d695730-bf84-48f7-bf6b-79f8a2365337	9d695730-c64c-4bd2-98d9-a1a5ec55e90c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1527}	2024-11-04 16:59:59
21180	9d673686-82b8-47f7-9827-82f81ae46cb1	9d673686-98b4-4298-9849-4db1de94df08	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1035}	2024-11-03 15:36:59
26810	9d68dc5b-d698-4102-8d29-fc48fd2853bf	9d68dc5b-dc33-4cae-a40d-33c0b65f89e9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1250}	2024-11-04 11:16:31
29287	9d69141c-b563-40ba-9025-22a98cd18556	9d69141c-b84d-41e8-9459-b16f9548cbbf	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1373}	2024-11-04 13:52:25
5727	9d524a7e-99e7-43c7-8683-9855fdb5f8bb	9d524a7e-9ee5-456a-b8f6-dc425fd47b3c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":303}	2024-10-24 06:00:26
9455	9d52f803-ab97-460e-956e-b6190d982733	9d52f803-b462-49b5-8b42-9b82bc77d0b5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":450}	2024-10-24 14:05:38
10256	9d56cc31-17a3-44e6-b5b8-555b4e061c7d	9d56cc31-1a9f-4a3f-b33c-7d2c1b5d0e71	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":502}	2024-10-26 11:46:25
35300	9d69c3ef-5c05-4d83-9758-3a6c47e6614e	9d69c3ef-6117-4856-94a7-f42452dbe05f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1600}	2024-11-04 22:04:03
28884	9d690c7a-9ea6-46f9-ba58-774dd83f5ad5	9d690c7a-a3b9-4512-ae81-e2042e1c9875	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1347}	2024-11-04 13:31:04
4793	9d51353b-d8c5-4c0e-b2e2-34cd60cab528	9d51353b-dc47-41b0-9443-8f7102c03a48	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":259}	2024-10-23 17:05:10
2155	9d50e4e1-3446-428e-9414-33ead34868ad	9d50e4e1-38b6-44f6-a354-1cf8e9f73674	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":129}	2024-10-23 13:20:29
10347	9d56cdb1-f573-4a65-90bc-67d760f89ddb	9d56cdb1-f956-4317-bac7-2ad475135951	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":509}	2024-10-26 11:50:37
965	9d4f3b74-87fe-4e88-991e-575222519585	9d4f3b74-8c86-4d03-8e64-da59eafc1fe1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":75}	2024-10-22 17:30:54
18711	9d6699d5-2f27-4af6-9bb0-9dfb59a0df6f	9d6699d5-32dc-4c77-b887-4aec59a5638c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":904}	2024-11-03 08:18:51
35133	9d69c2dd-0b02-4d27-8757-4df955b4bed3	9d69c2dd-0f69-48d8-9c4d-985dcac9517b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1591}	2024-11-04 22:01:03
26541	9d68d7bc-2e1c-4d11-8707-3729938e267a	9d68d7bc-3489-4889-a51d-db13485eb40d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1233}	2024-11-04 11:03:35
6695	9d52d4ce-b61d-4f0c-b52b-2a396df27e2d	9d52d4ce-b9b8-4ff4-8d37-a339e2355c45	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":343}	2024-10-24 12:27:11
19739	9d66e572-f0f3-4ce8-af7f-61189add44a6	9d66e572-f526-45ed-a633-11eb2942c079	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":973}	2024-11-03 11:50:17
21210	9d6736f2-5ddf-4567-94d9-76ac5768fba5	9d6736f2-6217-42b1-88aa-c6a7aa1f08cc	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1037}	2024-11-03 15:38:10
39653	9d6be0c1-190d-4e89-a619-6141c2f07208	9d6be0c1-1bef-46b1-9177-9f9420d57a54	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1763}	2024-11-05 23:16:18
15400	9d5ed110-9afb-47d0-b098-f6a7b404e2ce	9d5ed110-a050-45e3-a723-b9c0c5a26293	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":702}	2024-10-30 11:26:40
4649	9d513460-5ca9-4cc4-b2b8-826dc52b6896	9d513460-6032-4867-8fcf-4c0bbf7072a6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":253}	2024-10-23 17:02:46
13726	9d5d0e42-2661-4c60-b19d-f2023699b8fb	9d5d0e42-2cd5-4451-8028-2dd1a1d0201a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":636}	2024-10-29 14:26:07
30150	9d693485-6505-42ee-a148-04e92d07f794	9d693485-6a44-4892-a2ec-6b385922e3e5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1435}	2024-11-04 15:23:02
19125	9d66d067-3203-4789-aeaf-826c45082d8b	9d66d067-355d-49e3-984a-60baea0cc889	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":934}	2024-11-03 10:51:26
26391	9d68d3d9-47d1-4842-ab30-2981f6292e3e	9d68d3d9-4bb9-41b3-a712-58ac5ef109b8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1222}	2024-11-04 10:52:43
26838	9d68dd0d-6623-423d-82ed-5859a9d8c571	9d68dd0d-6c26-402c-b584-e065093e4403	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1252}	2024-11-04 11:18:28
42055	9d6cd403-6d62-4b89-b25d-f520defc4ed4	9d6cd403-7066-499d-96f1-77de9b07cef1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1953}	2024-11-06 10:36:30
3351	9d510493-6a88-459a-a556-520f349e12f9	9d510493-6db2-41cc-a384-196624692afa	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":188}	2024-10-23 14:49:06
29436	9d69246d-fff2-4ebf-acb3-a6ce6df3e611	9d69246e-03c2-4aee-bbce-543225d69ca3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1384}	2024-11-04 14:38:03
15823	9d64b0cc-31f6-4a77-bf06-5e8657019793	9d64b0cc-35bd-4fd7-a5be-58efdb47a577	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":724}	2024-11-02 09:31:24
3223	9d510390-fc46-4aae-883b-040a429031ac	9d510390-ff7c-453a-ba15-d457fc99d069	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":181}	2024-10-23 14:46:17
21070	9d671a2b-d55c-4074-a87e-8e98794f2462	9d671a2c-8d32-4773-abf7-761328406d85	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1033}	2024-11-03 14:17:42
34798	9d69bfc5-9452-4fc0-b355-96c3570b19e5	9d69bfc5-99f5-4a32-9096-3f70dc24c7b8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1574}	2024-11-04 21:52:25
12264	9d5ce164-b98a-4512-9784-00b2efee6321	9d5ce164-bce9-4d7e-86b7-ae7816a34ab4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":593}	2024-10-29 12:20:40
23000	9d68005c-8e32-42b4-aeaa-13b3975ce877	9d68005c-919f-4768-97a5-f0b4bdfc9c07	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1093}	2024-11-04 01:01:22
40533	9d6cc4cf-ff49-4e5b-9623-d7a194b0aa75	9d6cc4d0-04d8-4f76-8284-0c4898c840e1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1823}	2024-11-06 09:53:59
10645	9d5712dd-470e-4703-8af8-4f8724e71988	9d5712dd-4b83-4c1c-8f1b-56cb71b4d74c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":531}	2024-10-26 15:04:02
25057	9d68bfa5-8f5f-403e-9795-b2397302e139	9d68bfa5-9349-4011-b97c-5e238fc088e5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1140}	2024-11-04 09:56:14
41750	9d6ccf23-c975-40f0-8c8f-ff73f74dfa97	9d6ccf23-cc92-48dd-b998-934528e0c6f0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1925}	2024-11-06 10:22:52
15200	9d5ecf44-e864-41ff-8958-b1a82a581a02	9d5ecf44-eeba-4022-bd1f-e70b15258f5a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":687}	2024-10-30 11:21:38
9611	9d53c5d7-6140-4e88-b0f6-b136ec2e9cd3	9d53c5d7-6901-407a-a5b1-9092ea126388	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":456}	2024-10-24 23:41:10
3992	9d511bf9-1b7e-4641-a8a5-8aadcd94f2ef	9d511bf9-1f91-42f3-aecc-dbba2ecb5e1b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":222}	2024-10-23 15:54:32
6196	9d5261e1-94a0-4f61-a8f7-3ceecf447bd1	9d5261e1-98cf-424e-94dd-de44330f8edb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":310}	2024-10-24 07:05:50
18767	9d669bb2-a449-423d-a149-db8b78e963a0	9d669bb2-a8c9-47e1-ba60-8dfd9b775770	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":910}	2024-11-03 08:24:04
39617	9d6bdf66-886b-4c6e-bfec-39535ca309df	9d6bdf66-8c6e-4aa3-87d1-501f66691a24	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1759}	2024-11-05 23:12:31
2653	9d50fb09-9334-461b-be3a-67a5f26d0183	9d50fb09-98d1-464a-98db-87dc51d06eda	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":151}	2024-10-23 14:22:26
23675	9d689b7b-22c4-416e-b5f8-be121a03e5e4	9d689b7b-25e1-43d5-b781-9e2c2b49e855	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1108}	2024-11-04 08:15:06
32644	9d6968c2-1f88-4bfe-851d-1c422ef50a27	9d6968c2-23cf-40a4-a8af-1e2065b0a125	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1536}	2024-11-04 17:49:06
17670	9d6560a2-e591-422a-a701-a356b4acfcaf	9d6560a2-ea43-48e4-9640-f0d81ed48d53	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":845}	2024-11-02 17:43:05
23054	9d68012c-98a7-4632-986e-6117c505d457	9d68012c-9bba-4dd6-b770-240abc50c0b4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1096}	2024-11-04 01:03:38
37470	9d6b4b64-a82c-40d1-99f5-3e30f895a4a6	9d6b4b64-abcb-474b-84db-373efbff8c55	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1693}	2024-11-05 16:18:39
26621	9d68d90b-c15c-49b2-a3fb-993c59ad1428	9d68d90b-c4e5-44fe-80eb-071d44bec0fb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1238}	2024-11-04 11:07:15
3479	9d5106d5-9088-4e60-abd6-c23e1cb8fb42	9d5106d5-9773-42bb-886a-97075bfa5c5c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":195}	2024-10-23 14:55:25
39635	9d6bdf9a-4249-4dea-abf5-f5898bf6ecbd	9d6bdf9a-4541-4136-816a-21b5fc90b675	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1761}	2024-11-05 23:13:04
35720	9d69c580-c95a-4919-b1ea-7687f03238ac	9d69c580-cf06-4ea2-86c8-afeaca98bb75	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1620}	2024-11-04 22:08:26
1859	9d50e00f-4596-4efd-9f7c-7f0139b47152	9d50e00f-4a98-471d-9c3a-ce561d04a44e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":119}	2024-10-23 13:07:00
30670	9d694251-ca33-4dd7-8283-ff8eec1b2694	9d694251-cf9f-4ae5-9e65-2c56d32111fe	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1464}	2024-11-04 16:01:37
18029	9d65b6c1-9852-4aa8-ae6f-ee683cc401b7	9d65b6c1-9b5a-4b7d-a6e4-07fa7ccbd3a8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":862}	2024-11-02 21:43:53
21083	9d673405-66a4-4382-8ab7-fe138491a091	9d673405-6e30-40b9-aec9-8c5d95dc6810	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1034}	2024-11-03 15:29:59
39488	9d6bdaff-af23-4bbf-acc5-5ad9b3cdcdd8	9d6bdaff-b2fe-4dd3-a3ca-85fd3fef1c31	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1756}	2024-11-05 23:00:12
6222	9d5262b0-74bf-4810-b350-c55b1a90a991	9d5262b0-7b35-435f-9506-c3c46c303c44	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":312}	2024-10-24 07:08:06
29480	9d692810-ec98-40f7-a21d-6dd0fa297c70	9d692810-ef7e-4016-8b93-c1eaf23ced3b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1387}	2024-11-04 14:48:13
4473	9d5130c6-4515-4ad4-9994-d171e87f8ea0	9d5130c6-4a9c-42b9-a9ba-b5fe7ab7887c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":244}	2024-10-23 16:52:42
3033	9d5101a6-80d6-4b76-8d76-d22923f96d63	9d5101a6-84d0-47af-82a2-a8c0e7265934	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":171}	2024-10-23 14:40:56
17003	9d6546f0-de11-4264-afb2-23899c6dfb2b	9d6546f0-e23e-4fa1-b5f2-1120250d1909	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":796}	2024-11-02 16:31:14
25263	9d68c0ce-3713-4cb4-8acc-59050ecc1757	9d68c0ce-3dcf-4598-b7f7-624265688dd0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1153}	2024-11-04 09:59:28
21268	9d67378d-9da6-4e6e-b245-03d58704d594	9d67378d-a31a-4146-9456-519d70e03e49	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1039}	2024-11-03 15:39:52
26651	9d68da62-c018-41c5-9a48-0cedd515982c	9d68da62-c387-4c86-962e-648c97343be5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1240}	2024-11-04 11:11:00
30301	9d69398b-b8cd-4f2b-bdc3-094bd4d07277	9d69398b-bbe1-4136-be4a-6a97d5b0cfce	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1444}	2024-11-04 15:37:05
39781	9d6cb618-32e4-4068-9b82-1f48da19f06f	9d6cb618-397a-4f46-bff7-927e318960f2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1776}	2024-11-06 09:12:50
28128	9d68fe66-7aa3-4172-b11f-6fe15e288773	9d68fe67-3709-4a0a-8e45-9f0407712bce	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1311}	2024-11-04 12:51:42
37794	9d6b5c21-733f-4606-9922-690e738a5783	9d6b5c21-7744-4053-97b3-daaf8c126f7c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1699}	2024-11-05 17:05:27
19928	9d66ebce-2166-43c8-a710-f3ff8f47f5cd	9d66ebce-245e-4936-98ee-bb426f7cd6af	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":982}	2024-11-03 12:08:03
39839	9d6cb784-36a8-4d67-9102-79216a988be8	9d6cb784-39bc-44dd-92c7-76c1b9fa5185	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1783}	2024-11-06 09:16:49
17171	9d654f4d-0e1e-48b9-a2a2-27e594f059f9	9d654f4d-1371-4e9e-98de-0f52e2114379	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":812}	2024-11-02 16:54:37
19488	9d66db1d-81f1-428a-880b-44b516122511	9d66db1d-860e-475c-a67f-c450bf342b17	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":957}	2024-11-03 11:21:23
29369	9d691943-c280-41a4-9241-bfe2b4149fa5	9d691943-c8c8-4068-a571-c1aa67ad4354	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1379}	2024-11-04 14:06:49
8022	9d52e5fa-9071-4a73-b74d-e352e9b8b066	9d52e5fa-9342-4404-85d6-609cc3182a32	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":394}	2024-10-24 13:15:12
19245	9d66d286-98a3-4f36-97e8-571fd74a2764	9d66d286-9bb1-4c63-8e7c-51c59aa90ef2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":942}	2024-11-03 10:57:22
36430	9d6b3a4a-d9c6-45d1-9b99-434322edf367	9d6b3a4a-dce4-4af5-ae37-15a14c406e3c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1647}	2024-11-05 15:30:50
35659	9d69c543-74c4-4b7d-b52d-f0ca63d0ddf0	9d69c543-77bf-43df-b463-59d931853f69	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1617}	2024-11-04 22:07:46
5197	9d513709-4881-4abd-b72c-76c35be5e097	9d513709-4bc6-470e-81fe-72a0627dd780	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":280}	2024-10-23 17:10:12
1171	9d507da0-8338-4565-adec-5ff89e0c33ef	9d507da0-972e-4a2a-a1d7-93fba8c4e49e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":89}	2024-10-23 08:31:46
34903	9d69c0f0-da5c-4c6e-91f8-657c6392998e	9d69c0f0-e021-48ec-b565-9caec900134c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1578}	2024-11-04 21:55:41
17080	9d654a1f-59e2-483c-8b33-fcacc90e8de4	9d654a1f-5e78-4f6a-a07b-c399a1552325	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":807}	2024-11-02 16:40:08
42515	9d6cdf09-1936-4042-8b0f-b2bcf8420cd1	9d6cdf09-1e37-4ca4-91d6-5641e38bf6e8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1961}	2024-11-06 11:07:19
29263	9d691413-1c2f-4a83-b07c-eefd8bf08436	9d691413-1f7a-4dc8-b42c-888e500a5164	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1371}	2024-11-04 13:52:19
11014	9d5ca7d7-95c5-4756-b61f-511df57f44f9	9d5ca7d7-9958-4f83-8194-36d4a9fa44ce	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":552}	2024-10-29 09:39:44
17447	9d655a71-9355-497d-b11d-4a51c9aefddd	9d655a71-96b6-4bc5-9909-9319b1bb283d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":834}	2024-11-02 17:25:46
10926	9d5ca6a1-a3b6-4917-9075-bd4c95ad46dd	9d5ca6a1-a756-4bde-bb94-34338eeba97e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":547}	2024-10-29 09:36:21
28945	9d690dc1-e0cf-4a46-b47a-b44fa5685c67	9d690dc1-e6ce-425f-bfc5-e70d76501421	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1351}	2024-11-04 13:34:39
16202	9d64bab1-1f77-4a33-ac17-8e1ee75d5b2a	9d64bab1-2458-497f-a375-e66a90798a0c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":748}	2024-11-02 09:59:04
42632	9d6cdf6f-a47e-4a28-920b-b9723ec3760d	9d6cdf6f-a8c1-44c4-bfff-c8e02d16bed6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1963}	2024-11-06 11:08:26
36977	9d6b43dd-0afe-442e-87e4-c6622671bd03	9d6b43dd-0ecf-463f-b9eb-bd078e9786db	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1671}	2024-11-05 15:57:36
14350	9d5d1e0a-cba5-4b94-a87d-d47b65ab8dc2	9d5d1e0a-d53c-4d2f-b248-7752d9c3e2db	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":657}	2024-10-29 15:10:15
42395	9d6cddd7-b36e-4f00-825b-70bff561ba76	9d6cddd7-b672-473d-89af-915a79e1c83e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1957}	2024-11-06 11:03:59
28787	9d690832-955b-4f91-9af5-ebd0e5113c08	9d690832-9953-487e-8cb6-47e4be3078d3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1342}	2024-11-04 13:19:06
22335	9d674a88-ed0e-483a-8380-7dde1aebad9f	9d674a88-f021-440b-b2eb-5425343bfb9a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1075}	2024-11-03 16:32:56
20033	9d66ed9f-580a-4e76-a735-36cee242513a	9d66ed9f-5c02-493b-b098-a72413a49ee2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":989}	2024-11-03 12:13:08
25027	9d68bf66-3632-487b-8ce1-3ec00f57f9ad	9d68bf66-3a01-4550-83c2-66af3aa79558	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1138}	2024-11-04 09:55:33
7387	9d52dd33-1755-42b5-b64e-0df9141e9e36	9d52dd33-1a43-49da-b95a-28d326f47153	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":370}	2024-10-24 12:50:39
30716	9d694313-fc1a-4a20-98be-79563ea7618b	9d694314-0107-42df-98e5-da22368edc53	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1465}	2024-11-04 16:03:45
27109	9d68e242-622a-458b-8185-71e4583754d8	9d68e242-6852-4db2-9807-3bd68c67f50d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1261}	2024-11-04 11:33:01
18074	9d65b78a-52fe-4949-a005-d79b25314698	9d65b78a-5858-4b97-a554-069970dd028b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":865}	2024-11-02 21:46:05
26661	9d68da64-5164-43cc-ace8-e4ca04983d17	9d68da64-56af-4116-a88a-3add11ace05b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1241}	2024-11-04 11:11:01
29177	9d691369-939d-4807-bf23-7a32c4f29e2d	9d691369-977a-42ed-8db0-42c535ec54d0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1363}	2024-11-04 13:50:28
30846	9d694399-fe1e-4cfe-b9aa-dd0fa79a3b89	9d69439a-0480-414c-9659-d04f22eb5cbb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1470}	2024-11-04 16:05:12
17561	9d655dc0-be36-4a66-af96-bd79a4563d22	9d655dc0-c2b2-4982-a67c-36c38cac8361	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":842}	2024-11-02 17:35:01
37400	9d6b4a39-17d9-4317-96dc-280f6b546f5a	9d6b4a39-1b3f-437a-8001-97c20e951f6f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1688}	2024-11-05 16:15:23
14202	9d5d169a-22ba-4b56-be88-3be8de1eb9d7	9d5d169a-259d-4473-80a1-9efd11e0ed0e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":650}	2024-10-29 14:49:27
17473	9d655b30-5588-456e-bb40-e120d24caf03	9d655b30-594e-43be-8de3-0d4b046f0089	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":836}	2024-11-02 17:27:51
29856	9d692bf2-c374-4ed2-a940-51c3e20a2062	9d692bf2-c83d-4779-9ffe-c9eb651df563	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1415}	2024-11-04 14:59:04
16023	9d64b81b-7648-4eec-8690-e75d4424984b	9d64b81b-7972-4f19-8fec-7f5fc48efec4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":737}	2024-11-02 09:51:50
4082	9d511d17-48fb-4f41-bb79-b73feda3e3dd	9d511d17-4e90-43bb-957d-f6f6551d571e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":227}	2024-10-23 15:57:39
29340	9d691890-c37b-4821-a41a-23bbd9b859de	9d691890-cdf5-472e-ac23-a9872b4c4098	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1377}	2024-11-04 14:04:52
21311	9d6737f9-7edc-407e-a15f-f314b8eb5918	9d6737f9-82de-4225-a043-41267732ea74	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1041}	2024-11-03 15:41:02
28190	9d68ff1e-9a04-48ec-b90f-c74463dbf777	9d68ff1e-9f73-4041-92d3-22eaaf197158	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1314}	2024-11-04 12:53:43
39030	9d6bcb7d-ea64-4fb6-a8ea-01570f241af3	9d6bcb7d-eeb0-4cf1-a6da-a9f86d7b559e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1743}	2024-11-05 22:16:50
4373	9d512da8-2b2a-40f5-aa31-6f3fd40ad8e6	9d512da8-319f-47eb-85a8-27dfec0153c4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":239}	2024-10-23 16:43:59
9533	9d5322f5-ce52-42f7-ba6b-e938be625751	9d5322f5-d4b6-43ae-bcae-81c48852c3f8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":453}	2024-10-24 16:05:43
3009	9d5100c3-d6a6-4b09-8158-1c447e9276e9	9d5100c3-db09-4df7-8c18-b2d55a5e2999	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":170}	2024-10-23 14:38:27
13891	9d5d13d4-313d-44d5-ace8-1a2ebc2610eb	9d5d13d4-3467-4f57-88cf-0aeadcad53fb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":642}	2024-10-29 14:41:41
26531	9d68d7ba-06c5-4128-a5ba-5cb915235c96	9d68d7ba-0a69-4ce9-b337-16f18a568cfc	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1232}	2024-11-04 11:03:34
40132	9d6cc120-7054-49a0-bfd6-7c231c4ac432	9d6cc120-7319-4e01-97a4-c17d72a69734	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1795}	2024-11-06 09:43:41
2469	9d50f991-aaaf-4989-ac29-17bf6c214d0f	9d50f991-af2f-45aa-8232-5f0ac885f53b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":140}	2024-10-23 14:18:20
29297	9d69141d-e0e9-4d3a-8f17-51f2ae383a74	9d69141d-e701-49d2-806c-af58f091eb70	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1374}	2024-11-04 13:52:26
974	9d4f3b9a-c867-4072-ab9a-4212b9dbfd2f	9d4f3b9a-cb3f-432b-bf27-464aeeee505f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":76}	2024-10-22 17:31:19
40754	9d6cc705-67b3-45d2-9946-f6a9c34d8fbc	9d6cc705-6b34-43c0-a957-33a09a1929b3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1849}	2024-11-06 10:00:10
28664	9d69070f-71c3-4bfc-b799-5bf8b23ca78c	9d69070f-76a0-46f6-94ec-da07c9a059b2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1336}	2024-11-04 13:15:55
19709	9d66e464-4e15-4938-a48b-7bccee560d9f	9d66e464-52f2-4e95-9f87-a02d12db9ffe	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":971}	2024-11-03 11:47:20
9169	9d52f580-ffd5-4304-a463-08ddf2548125	9d52f581-039c-491e-9d00-bdc659a17c7f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":439}	2024-10-24 13:58:37
5440	9d51392e-37af-43d3-85e6-a47cdec14de5	9d51392e-3cc9-43a2-b9f4-ae5ff03e9957	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":292}	2024-10-23 17:16:12
24170	9d68ab41-3a01-4020-b679-7ae3b7fe9c73	9d68ab41-3e7b-49bd-b008-91034671baae	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1116}	2024-11-04 08:59:13
5173	9d5136a4-2ab8-419d-8daf-612e05ec0b8f	9d5136a4-3069-4d7e-a027-67a111aab3c3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":279}	2024-10-23 17:09:06
22	9d4cf31d-a081-4b33-ab75-2853f693d7bf	9d4cf31d-a405-42b9-9a20-95198d6d0186	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[23502]: Not null violation: 7 ERROR:  el valor nulo en la columna \\u00abname\\u00bb de la relaci\\u00f3n \\u00abusers\\u00bb viola la restricci\\u00f3n de no nulo\\nDETAIL:  La fila que falla contiene (5, null, null, null, null, null, null, null, null, 2024-10-18T05:00:00.000Z, null, null, null, null, null, null, null, null, null, 0, null, 2024-10-21 14:16:58, 2024-10-21 14:16:58, null). (Connection: pgsql, SQL: insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"user_photo\\", \\"user_state\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"updated_at\\", \\"created_at\\") values (?, ?, ?, ?, ?, ?, 2024-10-18T05:00:00.000Z, ?, ?, ?, ?, ?, ?, ?, ?, ?, 2024-10-21 14:16:58, 2024-10-21 14:16:58) returning \\"id\\")","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":401},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor.php","line":24},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3549},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":1982},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1334},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1299},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1138},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":35},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":5}	2024-10-21 14:16:58
42919	9d6ce169-3feb-4f26-b300-eedc68eed0ec	9d6ce169-43b3-4ba0-bc05-1e927a3bf864	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1967}	2024-11-06 11:13:58
18089	9d65b791-18aa-4e92-a059-796a69d3222a	9d65b791-1b53-40f4-8b26-782b7d0319cd	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":866}	2024-11-02 21:46:09
11919	9d5cd8d7-2361-426a-9f4d-49f89447158f	9d5cd8d7-2907-42bf-9b56-c7866844fcc0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":585}	2024-10-29 11:56:45
35149	9d69c2df-cd96-4d12-aa95-1045f8196f88	9d69c2df-d360-428d-8fb2-3b560dbe15fc	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1593}	2024-11-04 22:01:05
16412	9d64c98e-16ae-4aa7-8e53-10c6d854ed54	9d64c98e-1bd1-4f5d-b17b-53a4c2607614	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":762}	2024-11-02 10:40:38
14384	9d5d1e18-1e33-41eb-8178-1bddd007e36f	9d5d1e18-244a-4f2b-8be7-0e0949beea4e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":659}	2024-10-29 15:10:24
17826	9d65b0cd-06bc-4b4a-b267-0a32076323e6	9d65b0cd-0bf9-4157-a703-cae849fa06dd	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":851}	2024-11-02 21:27:14
29972	9d692d73-7e3e-4ade-9b9b-0370a10b2a3d	9d692d73-8529-421a-b241-a7bf776294dd	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1423}	2024-11-04 15:03:16
2450	9d50f8cc-188b-4299-bb3b-1d8cc7925bf8	9d50f8cc-296e-4031-886d-d228e1fe26a2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":139}	2024-10-23 14:16:10
7361	9d52dd29-508e-4bef-851c-c0fca83de80f	9d52dd29-536f-481f-9a84-71115b64ba19	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":369}	2024-10-24 12:50:33
15067	9d5ece8d-922c-4a56-bb56-dae50c530b55	9d5ece8d-95e9-4db2-9107-be7dd30b7cbe	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":678}	2024-10-30 11:19:38
20987	9d66ff50-1135-4f6a-8d75-5dc1599b81cd	9d66ff50-152d-4dc4-8220-90227091ed26	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1032}	2024-11-03 13:02:36
26281	9d68d054-a71b-4dd2-8fd1-33dea7602656	9d68d054-acdb-41a1-8252-2c4126df04c7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1215}	2024-11-04 10:42:53
15347	9d5ed0cf-10df-420c-928c-43ec077650fe	9d5ed0cf-1749-48b7-9c83-ef82f9ab4e17	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":698}	2024-10-30 11:25:57
902	9d4f33fa-4479-494f-8def-ebd5325912e7	9d4f33fa-47e4-4877-9e29-e76a9b5a0477	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":68}	2024-10-22 17:10:00
41589	9d6ccdc2-e916-40d1-99cb-96987bbb04eb	9d6ccdc2-ee38-4a59-9a19-0d7314a512cb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1905}	2024-11-06 10:19:01
15584	9d648e7a-a647-4da7-8323-74db981c9119	9d648e7a-aa0c-40e6-ab02-52f734301ce4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":710}	2024-11-02 07:55:26
40737	9d6cc6e4-ca8e-4ee1-93e7-7afda6d9d325	9d6cc6e4-cd62-4041-ac69-022be41e2048	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1847}	2024-11-06 09:59:49
21694	9d673db4-d72b-4c4d-87ed-3f03cea70ef7	9d673db4-d9f5-4582-a750-5b33ea566e6b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1047}	2024-11-03 15:57:04
9992	9d56c609-ba04-4d55-9399-57089547f02c	9d56c609-bd16-4000-bb55-b2019e1755b4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":480}	2024-10-26 11:29:12
2601	9d50faea-cd67-471c-9608-258624e14925	9d50faea-d1d3-42eb-930e-03b1392a01b1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":148}	2024-10-23 14:22:06
3949	9d511b24-b19d-4b16-b0e0-0f4a6ce69449	9d511b24-b776-4359-aa2a-0f8ecaef6772	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":220}	2024-10-23 15:52:13
19200	9d66d1b1-b23c-4c11-a6a7-720af0825d63	9d66d1b1-b61d-452c-bd2f-55d54a07aab3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":939}	2024-11-03 10:55:03
16689	9d64d60a-6680-4b25-9a62-630253203338	9d64d60a-6a75-4ddf-90ba-d47d67b7a78d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":777}	2024-11-02 11:15:32
15443	9d5ed229-b44d-4aeb-98d4-62aea82ecaca	9d5ed229-b9f2-444e-b13f-85f02d63608b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":705}	2024-10-30 11:29:44
31484	9d694c51-8375-4a6e-8f01-ec67353ec50d	9d694c51-86d5-49cd-aa10-ab881fe81b4c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1505}	2024-11-04 16:29:35
8256	9d52e7e8-7369-4a1c-9b2e-292f3b23c329	9d52e7e8-769b-485b-9330-54f58ba770c0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":403}	2024-10-24 13:20:36
15157	9d5ecf17-b3a1-45d9-ad57-b334cfa015c6	9d5ecf17-b974-4375-8078-e6154d3d27eb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":684}	2024-10-30 11:21:09
19155	9d66d0cb-0805-4068-b63d-64c23fe1c975	9d66d0cb-0c11-40b6-bc30-ddd47cd2071b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":936}	2024-11-03 10:52:31
35820	9d69c7ec-506d-418f-8a45-c31a7f7223e5	9d69c7ec-54fd-40a0-9df0-4c07aa2ad9ac	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1621}	2024-11-04 22:15:12
18698	9d6699b1-a3e1-42f9-b8f5-cc8d09a8882c	9d6699b1-a6fc-436e-af58-0316c3120561	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":903}	2024-11-03 08:18:27
6462	9d52d15a-be54-4e73-9d69-d13857653d6e	9d52d15a-c189-46a4-ac72-874ff8c1de57	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":335}	2024-10-24 12:17:32
18044	9d65b6dc-59bf-4954-8f17-28430765f623	9d65b6dc-5d6b-47c9-a0a8-f9cfd89dc13f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":863}	2024-11-02 21:44:11
8966	9d52f346-2a2a-41b2-95a8-334a129d1009	9d52f346-2d35-4227-8ebb-31af2342d87a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":431}	2024-10-24 13:52:23
10074	9d56c80a-56d8-4eb0-9674-cbd6989ea1d3	9d56c80a-5ae3-48bc-a2c1-b0466ef7600e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":488}	2024-10-26 11:34:48
21931	9d674109-cc4c-4364-8d7b-53d1cbe6922c	9d674109-d336-4cf0-a530-9fa5f57e0211	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1052}	2024-11-03 16:06:23
41052	9d6ccae5-479a-4876-9410-99aa8719c6cb	9d6ccae5-4d3e-46db-b142-0a13d999cc27	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1877}	2024-11-06 10:11:00
18104	9d65b823-2d74-4dc1-8ea0-3ca448ef75fc	9d65b823-3311-4502-82c8-11ecf8594f21	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":867}	2024-11-02 21:47:45
3807	9d511a4a-a563-4b64-ade7-a5d4bbd0ba25	9d511a4a-a9d6-4902-8992-1032afc02dd1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":212}	2024-10-23 15:49:50
35088	9d69c225-ad94-4db2-a774-d3cf97ecc4c4	9d69c225-b0b4-43ea-8276-7ca96c345d8e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1588}	2024-11-04 21:59:03
25584	9d68c72e-8170-471d-a887-fb6370818214	9d68c72e-846b-475e-a192-e87640d16e5c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1172}	2024-11-04 10:17:18
19574	9d66e0bd-a088-410c-a96c-e40aa18c4580	9d66e0bd-a358-4c91-8647-6045da23d57a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":962}	2024-11-03 11:37:07
2815	9d50fc9b-87f3-42a6-a16f-05cf0ce9d449	9d50fc9b-8bdc-4c6f-8cfe-e7b9875087b6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":159}	2024-10-23 14:26:49
11368	9d5cbdb9-3756-47c2-8749-dc573c84923b	9d5cbdb9-3a56-4594-9867-97646e880bf0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":570}	2024-10-29 10:40:55
40397	9d6cc30c-9a05-4c33-91e7-8cb3b1fc3056	9d6cc30c-9d71-406b-ab1a-fe25c0a20044	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1807}	2024-11-06 09:49:04
41964	9d6cd193-0a1f-4beb-a726-4183d7dfe95a	9d6cd193-0d15-4f41-97c5-c9c171df6373	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1947}	2024-11-06 10:29:41
33079	9d69a8d2-a289-454c-8b27-b61e09c04206	9d69a8d2-a9d7-43fb-b779-395f0b9c7ed1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1548}	2024-11-04 20:48:15
15778	9d64af93-98c4-4eb6-b85f-12b6a03d2e96	9d64af93-9cd3-4b97-9738-3de76e264ab2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":721}	2024-11-02 09:27:59
5369	9d513887-160c-4661-8611-524e51b2adda	9d513887-1985-425d-bc63-d7d2d44f6fa6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":288}	2024-10-23 17:14:22
37414	9d6b4a86-e0ac-43c7-a0b9-f023e07b3c28	9d6b4a86-e3da-4ddd-964f-fa3d1136136f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1689}	2024-11-05 16:16:14
40567	9d6cc51d-65c2-484b-b34b-6df3229a0f5d	9d6cc51d-68c4-4c67-b90f-0b1699359139	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1827}	2024-11-06 09:54:50
39058	9d6bcba1-e1b4-41e8-86fa-cb5bcc4f5e50	9d6bcba1-e58d-4f03-bb10-d8ec6984e626	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1744}	2024-11-05 22:17:14
32676	9d69828f-f4e4-4eb0-a71d-1e3d956f021b	9d69828f-fd28-4bf1-a800-41ec8f86c03a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1538}	2024-11-04 19:01:15
20088	9d66ee57-4474-4449-8562-58c0e2dcdb34	9d66ee57-4aff-45ee-8d76-34e0b0b4b02d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":993}	2024-11-03 12:15:09
22463	9d674f56-065a-4368-bd27-f89cf8c3690e	9d674f56-09fa-4e69-bea8-c507f8ff008e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1079}	2024-11-03 16:46:22
3655	9d51092d-0709-4aab-86d4-49f0d126f2a2	9d51092d-0b1a-433c-a0ce-29c7deaf85d8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":204}	2024-10-23 15:01:58
21278	9d67378e-df78-4639-b92a-da30f4a1288f	9d67378e-e358-43b9-b37f-32ced44d28b7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1040}	2024-11-03 15:39:53
35141	9d69c2de-965c-45dd-bb5f-99883ddc0d18	9d69c2de-993b-476d-b3a9-71297448636b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1592}	2024-11-04 22:01:04
19898	9d66eb37-0316-453d-aa75-b4660fc3da4a	9d66eb37-062c-402a-8a79-852f4c3ec682	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":980}	2024-11-03 12:06:24
4759	9d5134fe-bf3b-4ef7-be1a-add790c47066	9d5134fe-c415-4465-9688-2bebb65cda24	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":258}	2024-10-23 17:04:30
19275	9d66d2f6-168f-4f47-aff7-2c94b18accca	9d66d2f6-1a4d-4b20-a843-8dc323e61a96	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":944}	2024-11-03 10:58:35
42973	9d6ce334-ea07-4893-9148-f9e14a31c085	9d6ce334-ece5-47f2-a75b-6b4ec1ed2bdc	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1973}	2024-11-06 11:18:59
30478	9d693fab-a3fa-455c-8003-eb71c51d6945	9d693fab-a928-4466-837f-6c17050f8f14	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1453}	2024-11-04 15:54:13
5121	9d513679-c321-4992-b050-e83dc71e3967	9d513679-c6d4-426c-acc5-a7695272216c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":276}	2024-10-23 17:08:38
23838	9d689d6c-275a-4c7e-be57-144ba0f978b0	9d689d6c-2abe-46b0-a492-13dd7469c297	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1109}	2024-11-04 08:20:32
29211	9d6913df-30cc-4f8a-ac92-4b8ad7723566	9d6913df-339a-41c2-a4d7-25e71ae83893	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1366}	2024-11-04 13:51:45
41326	9d6ccc66-5b72-45b7-8d9d-77c58209ef20	9d6ccc66-5e7f-4bcb-abfa-b4a9c11c196a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1893}	2024-11-06 10:15:12
6320	9d526477-7472-484e-a3d4-d19e37eb4966	9d526477-7899-45ad-9fb4-3f95b0a60a6b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":328}	2024-10-24 07:13:04
22637	9d67f73e-ea1d-4dd7-8c5c-b2c6daad7722	9d67f73e-f1e9-48b8-a3a2-cb5e9e58cd56	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1087}	2024-11-04 00:35:52
22135	9d67425a-e096-4626-a151-45983f4d5b9a	9d67425a-e66d-43c2-b93e-33338c7eedb6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1064}	2024-11-03 16:10:04
2426	9d50e7ba-db83-4377-acdb-1d0dae81ea0e	9d50e7ba-de46-40ee-8a12-69fc0183d967	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":138}	2024-10-23 13:28:27
29740	9d692af3-0216-4b25-8b76-025ea7f585d1	9d692af3-05a8-4f13-b2fd-46effb406ac9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1406}	2024-11-04 14:56:16
12959	9d5cef98-7ca6-4790-844a-c224967d48d8	9d5cef98-8062-402a-b071-5026adfd7a9f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":615}	2024-10-29 13:00:23
10165	9d56ca38-86da-4ada-a37a-5b27235edbdc	9d56ca38-8bfb-45fe-a17e-2a5fbb3067c5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":495}	2024-10-26 11:40:54
10711	9d57203c-7137-45cc-811b-e37f251fc19a	9d57203c-75b3-49c0-b455-5159ed505cd0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":535}	2024-10-26 15:41:25
33915	9d69b81b-f87b-470c-b008-992c2c4e4685	9d69b81b-fca7-44c9-b901-4ede0917bd09	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1553}	2024-11-04 21:30:59
26042	9d68cd35-eb18-45f6-b513-2f1e64270231	9d68cd35-f0dd-4a5d-a146-9ecb81b97de7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1203}	2024-11-04 10:34:10
26092	9d68cd5c-d925-48a2-9adb-fb170c4091f1	9d68cd5c-dce1-425a-acf8-ba45d7885550	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1206}	2024-11-04 10:34:35
27177	9d68e2b4-03d1-4645-b9ee-5ab9055e5d60	9d68e2b4-0873-4527-a038-d9677c178846	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1265}	2024-11-04 11:34:16
25678	9d68c7c6-a4d9-4e5d-b0cd-7ceb394806d9	9d68c7c6-a9d3-4908-9f13-dff6c4cf531c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1179}	2024-11-04 10:18:58
37138	9d6b4547-588d-4330-a336-da2cc76ccf69	9d6b4547-5bce-4730-a3aa-6aa86065d5f5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1678}	2024-11-05 16:01:33
27717	9d68e93a-17fe-4c14-9ff2-a888ac10143a	9d68e93a-1d92-49a8-b3c5-a21cbeaabad6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1292}	2024-11-04 11:52:30
38850	9d6b6fc4-a6cc-478e-91c2-9ffb5302ca8b	9d6b6fc4-ad8f-4cba-8330-1c21bf47d6fc	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1740}	2024-11-05 18:00:22
12635	9d5cec86-2cf2-44ab-b77a-4ec8103bb83e	9d5cec86-2fb7-403a-a41f-58fd88136c3b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":603}	2024-10-29 12:51:47
28005	9d68eaf1-e1a1-4587-9100-0da2bfd3721a	9d68eaf1-e60e-4723-ac7f-2d80dfd4a53b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1305}	2024-11-04 11:57:18
15486	9d5ed335-466e-4e9f-a009-85215c650c88	9d5ed335-4c54-4c2d-99de-359fabe98433	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":708}	2024-10-30 11:32:39
5331	9d513837-9204-4e27-8417-2d6f0c8a77f2	9d513837-95f8-4bef-96af-197e4964f10d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":286}	2024-10-23 17:13:30
13750	9d5d0e7d-453d-467f-aa9b-9da38eb801c1	9d5d0e7d-482b-470f-a48a-65d6e5fe0bef	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":637}	2024-10-29 14:26:46
32828	9d69a62c-68b3-4737-adc7-094040ba6bdc	9d69a62c-6ffa-47d1-82ed-d278caea745d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1546}	2024-11-04 20:40:50
43013	9d6ce37e-e52b-490d-a35b-402def76b1ad	9d6ce37e-e896-4e73-bfb4-f06b2f74cd16	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1977}	2024-11-06 11:19:47
5036	9d51366a-1265-44b1-93c7-b1950a7b1f81	9d51366a-1726-47b4-897a-3b3287e6adb0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":271}	2024-10-23 17:08:28
2364	9d50e764-d4ac-4bbe-ab9b-cdeaad707b41	9d50e764-d781-4b31-949d-8868ebbab522	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":135}	2024-10-23 13:27:30
32009	9d69586a-510b-4492-aaeb-311f7aa04dff	9d69586a-56a4-4fba-a7bc-26f5cb3d7c69	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1531}	2024-11-04 17:03:24
12997	9d5cf2dc-3e8a-43ee-a60a-c56efde0ac13	9d5cf2dc-43dd-4136-94cd-9827c6992da9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":620}	2024-10-29 13:09:30
4711	9d5134b4-7670-4996-a520-81412109175c	9d5134b4-7c25-42b3-874f-4db37ea2577c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":256}	2024-10-23 17:03:41
8438	9d52ebdb-fffe-4803-91a6-4d90a94a6e30	9d52ebdc-03ac-48cf-ba00-d502dd0c8393	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":410}	2024-10-24 13:31:39
25912	9d68cb50-857d-468d-a14f-84f147472482	9d68cb50-8840-4403-bb2c-511f1cdfa38e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1194}	2024-11-04 10:28:52
30185	9d693596-17c4-47b9-9385-03ba885dfee7	9d693596-1cba-44ad-aae9-53dac3a1033b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1437}	2024-11-04 15:26:01
35115	9d69c229-2c0c-4360-abb7-12789f3cf389	9d69c229-31c8-4285-9a9d-178443d3356f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1590}	2024-11-04 21:59:06
31688	9d695484-a692-4b6a-8442-d6e714d981cc	9d695484-ac80-447e-957f-efdd43e27bef	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1517}	2024-11-04 16:52:31
34483	9d69be94-5f07-4827-93a4-18e90a473180	9d69be94-620f-4836-9643-af80bcd84c21	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1563}	2024-11-04 21:49:05
38173	9d6b5fde-4622-4597-823c-b1ec83dc9997	9d6b5fde-49b6-4aaa-8240-c66b720408e3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1715}	2024-11-05 17:15:54
22609	9d67f738-e59c-4ffd-823e-9a7e2ec2e678	9d67f739-ae34-4534-addb-d905ba7dd1bb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1085}	2024-11-04 00:35:48
5159	9d5136a2-3dea-4ecc-a132-0e7eb59844e2	9d5136a2-419e-4d10-8b8b-b7e920ad6a9b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":278}	2024-10-23 17:09:05
2857	9d50fca0-9fcc-4626-944d-c5e2327c30b6	9d50fca0-a44b-4cee-9ccc-baf7ab5da84c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":162}	2024-10-23 14:26:53
35449	9d69c4d1-7730-4302-8f1a-fc2294f45f7e	9d69c4d1-7b3d-480f-bf40-87b6e7ef9f13	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1607}	2024-11-04 22:06:31
7153	9d52db67-7f72-4fc5-b0eb-aee6766ce806	9d52db67-8612-4b4f-9c1f-06f04ce8a68b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":361}	2024-10-24 12:45:38
26491	9d68d71b-6787-46f2-9921-1b4fb4cd9030	9d68d71b-6a81-4311-ae53-ca5e323c45f5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1229}	2024-11-04 11:01:50
40788	9d6cc796-14a0-4d37-850a-5c0902cdabeb	9d6cc796-17f2-44a7-a633-ccf0f8ed0081	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1853}	2024-11-06 10:01:45
39320	9d6bcfc4-6035-47b6-9be4-511b813afd69	9d6bcfc4-64e9-422b-93c0-94eb6a2fd655	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1751}	2024-11-05 22:28:48
23258	9d688e58-2ad5-4db7-8737-7d0dc79531c6	9d688e58-2e41-41b2-abdc-c875e91f0f6b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1100}	2024-11-04 07:38:23
4899	9d51364c-6fb7-401d-a389-20aa3dd814e9	9d51364c-748e-4f1d-8a7e-7dcb56b94ce5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":263}	2024-10-23 17:08:08
24969	9d68bee6-20bb-4dc3-bc8d-ebe23c6b701e	9d68bee6-28d3-41e2-a93b-5ab197df5eb9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1135}	2024-11-04 09:54:09
26481	9d68d719-b8ad-43d0-8796-24a9ec883a87	9d68d719-bdf8-43b9-8912-a0ac5f861c52	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1228}	2024-11-04 11:01:49
9325	9d52f725-c102-4f47-83d2-c80f85ffbd14	9d52f725-c3f9-4800-bf48-d837dba9060f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":445}	2024-10-24 14:03:13
3047	9d5101a8-8412-4dff-99ab-3c2a92b3f919	9d5101a8-8827-4b1f-bcda-34fdacb7eca5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":172}	2024-10-23 14:40:57
19320	9d66d571-9780-4d36-85ad-1822daef2491	9d66d571-9d6c-484a-94cb-5c0ad52deb7d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":947}	2024-11-03 11:05:32
11196	9d5cac24-f26f-48ed-98d1-44f9a195a5fe	9d5cac24-f5a8-4c01-a468-68343f51d234	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":564}	2024-10-29 09:51:46
36678	9d6b3e33-481d-4e2c-9f40-6fa55a5a0b50	9d6b3e33-4c85-4b67-a8d4-4271ac9b326e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1658}	2024-11-05 15:41:46
17	9d4cf2e5-a99d-478e-a91d-111e4c8eb54c	9d4cf2e5-acc4-417c-86f1-598c28a6ccaf	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[23502]: Not null violation: 7 ERROR:  el valor nulo en la columna \\u00abemail\\u00bb de la relaci\\u00f3n \\u00abusers\\u00bb viola la restricci\\u00f3n de no nulo\\nDETAIL:  La fila que falla contiene (4, 2024-10-16T05:00:00.000Z, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, 0, null, 2024-10-21 14:16:22, 2024-10-21 14:16:22, null). (Connection: pgsql, SQL: insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"user_photo\\", \\"user_state\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"updated_at\\", \\"created_at\\") values (2024-10-16T05:00:00.000Z, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, 2024-10-21 14:16:22, 2024-10-21 14:16:22) returning \\"id\\")","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":401},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor.php","line":24},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3549},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":1982},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1334},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1299},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1138},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":35},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":4}	2024-10-21 14:16:22
19350	9d66d5be-5d28-4d4e-ab29-f8c0cbd09de4	9d66d5be-6042-45da-8f9b-068d3b7ad70b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":949}	2024-11-03 11:06:22
15721	9d64ae21-1572-4ba1-ab64-9a4a02aded29	9d64ae21-20d7-4479-aa52-12d2e647f3d0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":718}	2024-11-02 09:23:56
7564	9d52df68-68d7-4491-a8de-843a919c5a38	9d52df68-6e0f-476c-81bf-876e05d91bc4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":377}	2024-10-24 12:56:50
2307	9d50e6ed-ed38-44ed-afe7-80609e1a1d25	9d50e6ed-f047-42eb-ae46-fcb48c99e33d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":132}	2024-10-23 13:26:12
43033	9d6ce388-33fd-438a-9ed6-5d0cf29160d8	9d6ce388-378a-4fa1-877e-de16794035d3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1979}	2024-11-06 11:19:53
11353	9d5cbd64-481b-4b1b-bd6d-dc9003a905a1	9d5cbd64-4e0f-46a7-a0de-1f9489400511	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":569}	2024-10-29 10:40:00
39134	9d6bccc3-cdd8-4ee6-9770-8e98d079700b	9d6bccc3-d13d-48c8-9797-aa1e3764fe3b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1746}	2024-11-05 22:20:24
29769	9d692b17-ac3f-4d4c-80f5-1eed06576ae5	9d692b17-af7b-47c8-90fd-73be7fc5fb7c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1408}	2024-11-04 14:56:40
16143	9d64b9ba-77cb-4025-b3dd-ac83597bff36	9d64b9ba-7a66-425a-a229-a81bd108fe8f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":745}	2024-11-02 09:56:22
27707	9d68e938-745b-4624-a69e-a80c0df820f4	9d68e938-778e-49fc-9360-f5e476f88b77	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1291}	2024-11-04 11:52:29
40720	9d6cc6c8-658c-40ed-8060-d6703dfa8fd6	9d6cc6c8-68be-4aae-9b84-8a0d19869268	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1845}	2024-11-06 09:59:30
370	9d4f26f1-4449-489c-83a1-d81fefd079ba	9d4f26f1-471a-4a9a-81bb-703dfdacbf24	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":22}	2024-10-22 16:33:33
28600	9d6901fe-7631-405b-8678-b4377db4e69f	9d6901fe-7bc1-4012-9192-88ca9722112e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1334}	2024-11-04 13:01:45
17984	9d65b50b-a5ac-48d7-9c30-fb586d2c7984	9d65b50b-a931-49b7-bf96-06b76f7de8df	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":859}	2024-11-02 21:39:06
17395	9d655944-f0bc-4a5d-9b0f-179a382c474a	9d655944-f392-4965-a0b0-3d2f0f7501f3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":830}	2024-11-02 17:22:29
30974	9d69450b-46fd-4f6f-985c-0b79d7673e07	9d69450b-49d9-496e-98bf-48e6bf7d4dac	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1477}	2024-11-04 16:09:14
15963	9d64b6db-5c86-436b-848b-e45b741e4945	9d64b6db-6180-4b5b-9503-a8b57fcaecab	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":733}	2024-11-02 09:48:21
18827	9d669c6f-c3b7-4544-8e66-b81e31ad9086	9d669c6f-c6b8-487c-9d87-1f0bd0f74a76	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":918}	2024-11-03 08:26:07
23040	9d680129-adca-4ea3-9be3-53ad6ee17c5c	9d680129-b413-4c92-a767-b162c7386328	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1095}	2024-11-04 01:03:36
43053	9d6ce3c2-deed-44b6-98ba-2a081644b13f	9d6ce3c2-e38a-49bf-be1f-2b01976314c1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1981}	2024-11-06 11:20:32
37184	9d6b45b2-7b64-4b83-8003-8c62bdfcbb4c	9d6b45b2-80b5-4db3-bd52-f8adff1c25af	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1680}	2024-11-05 16:02:43
37000	9d6b4452-4495-4171-867d-581a3f0b813a	9d6b4452-486d-478a-b6cf-9f7b22465904	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1672}	2024-11-05 15:58:53
31735	9d6954d6-e4f1-4943-ba75-4422b3d4e636	9d6954d6-ea75-4420-86e4-aab6985be429	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1520}	2024-11-04 16:53:24
7944	9d52e567-8cf0-49e6-a55c-fbf08ec4f217	9d52e567-91a0-45f6-99c7-8467b5d80d04	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":391}	2024-10-24 13:13:36
40975	9d6cc91d-1b8e-43c6-aedf-a24a8e6ff4b3	9d6cc91d-1f09-4bd0-9235-e8bbd01b42a3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1875}	2024-11-06 10:06:01
17894	9d65b3a3-a2b9-49e8-9de7-ca9f39f0dfb6	9d65b3a3-a6e4-4939-99d5-9ef4bcb64642	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":853}	2024-11-02 21:35:11
42433	9d6cde3a-2178-4199-872b-04988501bc8a	9d6cde3a-24a5-46eb-b37d-bd486c47319c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1959}	2024-11-06 11:05:03
21985	9d674166-5b82-4c6d-a54f-16a5bc7ccbd2	9d674166-5f08-497c-bc04-6122f2a959e7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1055}	2024-11-03 16:07:24
31212	9d6946f9-60f3-45ae-a341-3bd3a3ef9f18	9d6946f9-6581-4e6e-a555-b1a2b7499e49	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1484}	2024-11-04 16:14:38
11438	9d5cbe74-9142-4cf1-a57c-6ba27769ca1a	9d5cbe74-9520-4aeb-bbf7-7250700de61d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":575}	2024-10-29 10:42:58
22503	9d674fcd-61c2-4259-b41e-bec58439bf72	9d674fcd-65c3-4675-951f-9803c895172f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1081}	2024-11-03 16:47:40
17236	9d655127-3bee-425c-be3b-ed0fa61b23b4	9d655127-40b9-408d-8591-2278e3e5ba5c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":817}	2024-11-02 16:59:47
10243	9d56cc1a-28e3-4b25-ab2a-0339a4a756b7	9d56cc1a-2b79-46f2-9cfd-93679e081f46	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":501}	2024-10-26 11:46:10
6669	9d52d3d0-481f-42b8-9516-3ebff174f1bb	9d52d3d0-4aa5-46c9-9db7-10a42174a390	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":342}	2024-10-24 12:24:25
1728	9d50dd7d-8fbd-49d8-ad39-f8a0c434f144	9d50dd7d-9307-4ee9-a888-fbc80ea2ada7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":115}	2024-10-23 12:59:49
3631	9d5108fa-a228-4e16-a92a-4d4a0fa95186	9d5108fa-a7d0-46c7-8b61-2e25e577c9ae	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":203}	2024-10-23 15:01:25
34421	9d69be45-e3cf-443a-801e-e21d3a54ff25	9d69be45-e812-4fc5-8dc4-b6f52dbf7563	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1561}	2024-11-04 21:48:13
847	9d4f320b-96bd-4644-813a-9580e53515f9	9d4f320b-9c8c-4256-a38a-06bdd44fbc49	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":63}	2024-10-22 17:04:35
6286	9d52641a-b432-40f7-8717-27ed395de003	9d52641a-b96a-4962-b37f-f6d9e47e680c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":322}	2024-10-24 07:12:03
1628	9d50d844-4ad4-452f-ba2d-258bbc7b0a6c	9d50d844-504a-48e7-adf4-b90bdefdc3d2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":110}	2024-10-23 12:45:12
10282	9d56cd15-c539-4533-b2f1-076f8e1063d0	9d56cd15-c919-4f89-8968-308aa4fefce3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":504}	2024-10-26 11:48:55
12880	9d5ced80-61b3-4956-bc85-803f3a8d3c51	9d5ced80-6443-4e83-a96f-04173152b226	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":610}	2024-10-29 12:54:31
39346	9d6bcff1-919e-40f6-82e0-abd2e5316898	9d6bcff1-95b2-406a-9a7c-b9ca5139d3a1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1752}	2024-11-05 22:29:17
41896	9d6cd0f8-5482-4fbe-ba50-a1221ab37221	9d6cd0f8-58f2-4dd2-a21f-88287425a94f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1941}	2024-11-06 10:27:59
26681	9d68db50-47a5-4ca7-b112-96824c3223eb	9d68db50-4b04-4827-8754-42fe4e93d5ba	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1242}	2024-11-04 11:13:36
30311	9d69398c-e12a-4047-8247-4186bc76f4f1	9d69398c-e6ea-4921-8848-a064d5cdf1bc	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1445}	2024-11-04 15:37:06
28087	9d68ebb4-4f8d-4466-9518-48876255545e	9d68ebb4-52bf-4dc8-9a90-7c2b2c754cca	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1309}	2024-11-04 11:59:26
17538	9d655caf-ac3b-4f23-b20e-dd1ceb9f49c5	9d655caf-b1bb-45a5-a7f7-c5f821e6232c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":841}	2024-11-02 17:32:02
1205	9d50c534-58e1-43f0-9ec7-425c5dd188e6	9d50c534-6beb-4a0d-891f-4ec342a2f4f9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":90}	2024-10-23 11:51:54
16217	9d64bb76-b591-40c2-92ab-d693810f258d	9d64bb76-bd8d-4bbd-bb27-66be778bcebb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":749}	2024-11-02 10:01:14
40873	9d6cc850-cac2-4e54-abe6-33fed2bb93ea	9d6cc850-cf23-43f8-b9a2-5f258807f61b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1863}	2024-11-06 10:03:47
10178	9d56cabd-6839-41e1-b8ff-11ee3c3a6caa	9d56cabd-6c9a-4576-9ad2-ff5faddcab0d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":496}	2024-10-26 11:42:21
14120	9d5d163f-602a-4515-a483-e3f587267cb8	9d5d163f-62ea-4f1c-9d73-1ddaf246c40c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":648}	2024-10-29 14:48:27
10230	9d56cc14-6331-422f-887c-5c28b87acb6a	9d56cc14-6a0b-421a-b2c8-f6efe0be8d97	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":500}	2024-10-26 11:46:06
16247	9d64bf7b-1278-4aa8-aeb5-8883b6ec4d37	9d64bf7b-1768-402e-873c-b96c35c6250b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":751}	2024-11-02 10:12:28
31366	9d694aab-f9f0-4d83-a040-0ad61c165cf0	9d694aab-fd4e-452c-b799-cfcee64dc93f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42883]: Undefined function: 7 ERROR:  el operador no existe: character varying = bigint\\nLINE 1: ...oin \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\"....\\n                                                             ^\\nHINT:  Ning\\u00fan operador coincide en el nombre y tipos de argumentos. Puede ser necesario agregar conversi\\u00f3n expl\\u00edcita de tipos. (Connection: pgsql, SQL: select \\"item_loans\\".*, \\"users\\".\\"user_alias\\" from \\"item_loans\\" inner join \\"users\\" on \\"item_loans\\".\\"itemloans_aprobador\\" = \\"users\\".\\"id\\" where \\"item_loans\\".\\"loans_codigo\\" = 92 order by \\"item_loans\\".\\"id\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":304},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1497}	2024-11-04 16:24:59
8862	9d52ef80-2a6c-4369-b12e-8d3c3258e05e	9d52ef80-2e06-4e6d-b9c3-7294758ded50	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":427}	2024-10-24 13:41:50
43094	9d6ce4c1-7c83-42fc-be4b-edfbb1869209	9d6ce4c1-807a-45f2-8602-b70c90131686	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1985}	2024-11-06 11:23:19
12921	9d5cee6e-e958-4ca6-a3d1-0480b5a78a82	9d5cee6e-edec-4743-911c-12cd0ef585c1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":613}	2024-10-29 12:57:07
31855	9d695656-5b74-4122-921f-072b5527765b	9d695656-5e8f-4bd8-9cc5-ba97baed3968	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1523}	2024-11-04 16:57:36
39172	9d6bcd1c-61cb-447a-aff8-65f390280c04	9d6bcd1c-65bf-438c-9bc0-21f348e95da6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1747}	2024-11-05 22:21:22
20241	9d66f0a5-c1d9-4398-805d-35e393b0be4c	9d66f0a5-c5bb-4759-86e0-6d2c3a408866	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1002}	2024-11-03 12:21:36
30469	9d693fa9-f0d1-430b-8ecd-1c4ad9fab979	9d693fa9-f4b1-44b8-a042-9c5754f85d11	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1452}	2024-11-04 15:54:12
16775	9d64d6bd-58d7-4025-a752-1ddc06fba1eb	9d64d6bd-5cbd-4676-af24-0e27ffca9c97	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":781}	2024-11-02 11:17:30
11398	9d5cbdf6-fe87-4416-bf79-a0b98d3e4d7e	9d5cbdf7-01cf-4dbe-9f96-bf8279e32f85	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":572}	2024-10-29 10:41:36
5003	9d513663-c563-4725-98c9-42fdd9c22d7d	9d513663-cb08-443d-b82c-85c205b9dda4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":269}	2024-10-23 17:08:24
2483	9d50f994-8bd9-4d5b-841f-d89ae3790770	9d50f994-9475-4209-a29f-d9fa3a3a7963	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":141}	2024-10-23 14:18:22
9710	9d56abb7-02e7-46c1-b846-722a7b6acdc0	9d56abb7-1656-4de0-9b7f-7ca32789ed49	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":460}	2024-10-26 10:15:36
11483	9d5cbec4-19ab-4856-b528-45a97d638edf	9d5cbec4-1c4a-4931-a9cd-e10c897377b4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":578}	2024-10-29 10:43:50
16008	9d64b80a-3a63-4095-a2fe-91a32451d91e	9d64b80a-3e03-4eef-b5ae-e7b7c275beee	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":736}	2024-11-02 09:51:39
20286	9d66f105-c968-42a4-a293-8af20ea503f6	9d66f105-cd47-4020-98d3-6aed298924be	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1005}	2024-11-03 12:22:39
27255	9d68e346-b0cc-4300-9cb7-b64d061322e3	9d68e346-b743-4ecb-8e84-c0a9ca282c85	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1270}	2024-11-04 11:35:52
11278	9d5cb233-2cc7-422f-9405-94f3cba9fa5a	9d5cb233-2fa7-4075-baa5-41b1db36a467	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":568}	2024-10-29 10:08:42
11957	9d5cd8dd-58aa-4433-831b-5864b14f6776	9d5cd8dd-5e61-4547-94e6-0a67064f86b9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":588}	2024-10-29 11:56:49
18737	9d669a41-4386-4a8e-90c1-4236185d7fdf	9d669a41-4746-45b0-b6da-fdf48eac466b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":906}	2024-11-03 08:20:01
3313	9d510480-a80a-4007-8a9f-2dc3fe0ffe62	9d510480-ab7d-4538-adec-d0804ffc7f8b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":186}	2024-10-23 14:48:54
30876	9d69440b-86fa-495c-bf53-b289e89a0f83	9d69440b-8cde-44b8-9417-086fef3ad55f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1472}	2024-11-04 16:06:27
24077	9d68a153-4e40-4744-a2eb-25097c5421e0	9d68a153-5143-4f8a-93d9-929c5b3daacb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1110}	2024-11-04 08:31:27
34921	9d69c119-8e61-4ffb-a63e-9f8610cd9eb3	9d69c119-9237-45a0-a4c9-f593dc3a3db1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1579}	2024-11-04 21:56:08
25097	9d68bfb4-cabf-44dd-9cc8-6edba91007e1	9d68bfb4-cf6c-41dc-b415-5a710bb9dcf3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1143}	2024-11-04 09:56:24
9377	9d52f78a-48aa-4019-bf6b-1d5353bc4f3f	9d52f78a-4ca9-4565-bcae-55575fca8053	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":447}	2024-10-24 14:04:19
1709	9d50dd60-bc6f-47e0-b3c3-271660985636	9d50dd60-bfea-4078-b90c-3818cf2fe59d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":114}	2024-10-23 12:59:30
30272	9d69397e-42e4-4bf9-8e9a-cab063082d70	9d69397e-4672-4f93-9778-9360f0a4ba3f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1442}	2024-11-04 15:36:57
18564	9d66946b-14b1-4c3d-b855-08669a00a474	9d66946b-1783-4397-abd2-480892d81c4c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":891}	2024-11-03 08:03:42
11468	9d5cbead-e36a-488d-ac2c-176a2d0f4fb0	9d5cbead-e711-4c30-8694-28225690c9be	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":577}	2024-10-29 10:43:36
24703	9d68bba6-cc51-4649-bf90-72e2f99ec97a	9d68bba6-cf34-4281-b962-6524def0e1eb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1120}	2024-11-04 09:45:04
40958	9d6cc8fa-b0af-4ff4-a9ed-ec70de47709d	9d6cc8fa-b385-489b-ba01-44730a073ede	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1873}	2024-11-06 10:05:39
15863	9d64b1f9-592c-4208-88a8-ab49b03c23de	9d64b1f9-5c7f-45bf-9e48-bafb2b9835fe	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":727}	2024-11-02 09:34:41
19958	9d66ec4a-04a3-4ab8-97cf-75982531292a	9d66ec4a-0915-4439-a773-ac4d457ad010	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":984}	2024-11-03 12:09:24
18194	9d65ba20-009a-442f-b630-e59479adafbf	9d65ba20-05ca-468d-8680-b09fc3c1cd4e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":873}	2024-11-02 21:53:19
38449	9d6b64e4-807f-4b10-93a1-8ef26957eaf6	9d6b64e4-84c8-4b9a-b65a-0b7687d2b0ab	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1727}	2024-11-05 17:29:57
26421	9d68d3e9-2006-4926-a41d-476764f27d90	9d68d3e9-22e9-4f06-9888-811159a7103d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1224}	2024-11-04 10:52:54
29249	9d6913fe-04b8-488c-9a26-a230b944b504	9d6913fe-0a65-4bd3-8380-d9ddc8b12d7d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1370}	2024-11-04 13:52:05
1043	9d4f3de7-1f8e-4ac1-b0d2-9288bc0c992e	9d4f3de7-253b-42f8-ade9-ae1f258f0f82	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":82}	2024-10-22 17:37:45
15153	9d5ecf16-3666-4b8e-833e-fba88d1379e4	9d5ecf16-3e96-4957-8180-061b09e615b2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":683}	2024-10-30 11:21:08
43119	9d6ce504-0942-46a6-ba19-df0aec7b0e72	9d6ce504-0e18-42cf-8d2a-63e7691a0bf9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1989}	2024-11-06 11:24:02
9736	9d56ac40-f633-42d2-a0de-cf90689172ca	9d56ac40-f8ee-4daf-a84d-56e5ae70e030	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":462}	2024-10-26 10:17:06
29359	9d691941-fe87-41d5-952d-6a5197524750	9d691942-0369-4d42-893d-e6ed8b50b125	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1378}	2024-11-04 14:06:48
30537	9d693fd2-8ac2-42f9-9c56-fb928f38eec7	9d693fd2-8fdc-4eae-96d4-cfca51b7ecc3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1457}	2024-11-04 15:54:38
28905	9d690c7d-1db0-4182-87fe-b1c89ad03318	9d690c7d-2418-4153-b180-73296fc2c146	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1348}	2024-11-04 13:31:06
36407	9d6b3a1f-ca41-460a-ad9c-0ffd005fdac6	9d6b3a1f-cfe7-4a75-ba85-4a51f4dfa02a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1646}	2024-11-05 15:30:22
7179	9d52db73-b6cd-4283-9503-4a366a89a52d	9d52db73-b977-428f-a4a0-f2894add216a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":362}	2024-10-24 12:45:46
5383	9d513888-4c29-4b5b-ae57-c3d4b58d0091	9d513888-4f4d-4ed2-9c50-3a63a269f013	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":289}	2024-10-23 17:14:23
17499	9d655c0c-3ec4-4dfd-b04e-a1eb7d1a8a8b	9d655c0c-4241-4599-9c6b-54565271330c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":838}	2024-11-02 17:30:15
31418	9d694bd2-0572-4749-905a-a57d91e892ac	9d694bd2-095b-4ca8-ab00-2b4738323258	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1501}	2024-11-04 16:28:11
38568	9d6b66d3-0093-4d0d-889d-c0e11bfba065	9d6b66d3-056e-4b47-8a74-00cec7282482	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1732}	2024-11-05 17:35:21
37976	9d6b5e4a-f045-41ac-8783-bb88a42548fb	9d6b5e4a-f460-4849-9906-af39aa12f708	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1706}	2024-11-05 17:11:30
6877	9d52d5ef-6387-4976-be37-3292ed128dbf	9d52d5ef-66f0-4cce-8929-b54727da4565	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":350}	2024-10-24 12:30:21
18876	9d669e69-83b0-49ec-a1a9-9c796cefb4bb	9d669e69-878b-44db-b156-9e28c167ad84	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":921}	2024-11-03 08:31:39
33833	9d69b798-11c2-4f6a-a80e-d8867629fabb	9d69b798-15e1-4ed1-ae3b-7ea4c946fc61	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1552}	2024-11-04 21:29:33
2843	9d50fc9e-6160-4cbf-a398-d30752b9f81c	9d50fc9e-64e1-4c1b-ae59-da2cb7b3b56d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":161}	2024-10-23 14:26:51
29547	9d6928ff-8110-4ae0-be8e-0b9fadc4630b	9d6928ff-87ab-4744-82a4-bb1bfdfa66c6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1393}	2024-11-04 14:50:49
1010	9d4f3cee-f490-49f4-95be-6142d3712986	9d4f3cee-fba4-4c02-b60e-5da02a7a9681	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":80}	2024-10-22 17:35:02
1378	9d50cf4d-c210-4b0c-8a96-069bd7de90dd	9d50cf4d-c8f7-4d9f-b5ca-54a7223d45fa	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":99}	2024-10-23 12:20:09
10655	9d5712de-714d-4d8c-97f3-abe18ef70533	9d5712de-74e5-40d5-bd6f-6e12e5617ad4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":532}	2024-10-26 15:04:02
27211	9d68e2f7-64a9-4800-b909-be4119ac5482	9d68e2f7-681f-4cbf-aa5e-50ca004dfe03	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1267}	2024-11-04 11:35:00
11040	9d5ca7fa-2240-43bc-9692-78ff9fc03b6e	9d5ca7fa-251b-42d2-bbb1-d24d48e92f54	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":554}	2024-10-29 09:40:07
16277	9d64c06e-d667-424e-a2b1-2427959e7f41	9d64c06e-db6d-4ad1-8c5b-6ad4b36ab667	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":753}	2024-11-02 10:15:07
41254	9d6ccc1e-cecc-40b6-bca4-be4d6b098bf9	9d6ccc1e-d754-4d18-9f74-cd63bf378ae0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1889}	2024-11-06 10:14:25
12972	9d5cef9b-4e42-4d01-81ec-180760faadf6	9d5cef9b-5117-4b4f-bf4f-96796ca2ac5c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[3F000]: Invalid schema name: 7 ERROR:  no existe el esquema \\u00abl\\u00bb\\nLINE 17:                             order by l.id 'desc'\\n                                              ^ (Connection: pgsql, SQL: \\n                            select l.id,\\n                                l.loans_documento,\\n                                l.loans_nombre,\\n                                l.loans_apellido_uno,\\n                                l.loans_fecha,\\n                                l.loans_valor_prestado,\\n                                l.loans_cuotas,\\n                                l.loans_estado,\\n                                l.loans_intereses,\\n                                uco.name as cobrador,\\n                                ure.name as recomendador\\n                            from loans l\\n                            join users ucl on l.user_customer = ucl.id\\n                            join users uco on l.user_cobrador = uco.id\\n                            left join users ure on l.user_recomendacion = ure.id\\n                            order by l.id 'desc'\\n                        )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":23},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":617}	2024-10-29 13:00:24
17158	9d654ed9-87df-498a-a85d-bbff5a390648	9d654ed9-8b23-4789-8d85-183169a0836a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":811}	2024-11-02 16:53:21
41784	9d6ccf68-7d7b-4c09-a9f7-17f49ed5e76a	9d6ccf68-806a-477e-b63e-1e07e57070d9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1929}	2024-11-06 10:23:37
30508	9d693fb4-1768-4c47-bbae-d918e111f0ce	9d693fb4-1cd0-4456-b29d-8ff7548c36d7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1455}	2024-11-04 15:54:18
20048	9d66ede2-6fc6-4282-ba83-757cd5f74369	9d66ede2-73bf-4bf5-a448-42a5ee87cc2d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":990}	2024-11-03 12:13:52
28518	9d6901e5-8c39-42c5-8df7-113e0572b507	9d6901e5-9207-46ec-9732-8ca7b0661005	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1330}	2024-11-04 13:01:29
17777	9d65ad78-8266-4ae1-8967-72eaee5bd8ae	9d65ad78-8d9b-4402-bfcd-261490c919e5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":848}	2024-11-02 21:17:56
18491	9d669261-f49f-464a-8415-601d9b14a462	9d669261-f797-4033-8f16-d7bd6bf7de6d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":885}	2024-11-03 07:58:01
27635	9d68e8b7-62e3-4a02-b89e-1da7d3492574	9d68e8b7-68a3-45ae-8274-899f4fbd1a5c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1288}	2024-11-04 11:51:04
2639	9d50fb06-0502-4df1-ba4a-0c7754ed9851	9d50fb06-0ae7-4868-977b-fecc6fc8ef8f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":150}	2024-10-23 14:22:24
8521	9d52ecff-70fb-4d05-9bca-66989bf726fe	9d52ecff-74a1-4b95-8719-35769eb789df	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":413}	2024-10-24 13:34:50
19679	9d66e39c-df17-405a-888e-2430cd8dd748	9d66e39c-e282-4dd8-8a00-ecdcb947fdf2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":969}	2024-11-03 11:45:09
27892	9d68ea3e-a9a0-45f2-8cc8-b50b52f1a4ae	9d68ea3e-ac80-43a3-a0f7-cb00ebe94930	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1299}	2024-11-04 11:55:21
16397	9d64c91c-ff2c-42ee-a49d-c25fcddf19f6	9d64c91d-01cf-49c7-9631-9969233c0ea4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":761}	2024-11-02 10:39:24
4822	9d513596-a3ad-44fa-a5ca-01bd2d15f0f0	9d513596-a702-484a-8613-43532f48531b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":260}	2024-10-23 17:06:09
893	9d4f33ed-8ee9-4bed-ad11-aed8d934a045	9d4f33ed-925f-4f0a-912b-dc9778a27d2a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":67}	2024-10-22 17:09:51
38685	9d6b6b4a-5b6f-4a6c-a843-b68c6ef12465	9d6b6b4a-5f10-487c-84f1-0a2f7bff78de	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1736}	2024-11-05 17:47:50
43102	9d6ce4c2-97fb-44ab-8474-e40c33cb2aed	9d6ce4c2-9b3f-49a3-8187-a30dada48809	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  error de sintaxis en o cerca de \\u00abFROM\\u00bb\\nLINE 19:                         FROM users\\n                                 ^ (Connection: pgsql, SQL: \\n                     SELECT id,\\n                            name,\\n                            profile_code,\\n                            profile_name,\\n                            profile_prefix,\\n                            remember_token,\\n                            user_address,\\n                            user_age,\\n                            user_alias,\\n                            user_birth,\\n                            user_cellphone,\\n                            user_city,\\n                            user_document,\\n                            user_document_type,\\n                            user_last_name_one,\\n                            user_last_name_two,\\n                            user_neighborhood,\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = 4;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":142},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1987}	2024-11-06 11:23:19
32038	9d69587f-eb26-4ebc-a371-1baf3074f783	9d69587f-ee6d-4722-a697-013c1721f36e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1532}	2024-11-04 17:03:39
138	9d4e6cc8-2c1f-41b1-8b83-42d1948b83a7	9d4e6cc8-423b-4854-ba1a-d8f7925ed65f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[23502]: Not null violation: 7 ERROR:  el valor nulo en la columna \\u00abname\\u00bb de la relaci\\u00f3n \\u00abusers\\u00bb viola la restricci\\u00f3n de no nulo\\nDETAIL:  La fila que falla contiene (13, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, 0, null, 2024-10-22 07:52:59, 2024-10-22 07:52:59, null). (Connection: pgsql, SQL: insert into \\"users\\" (\\"name\\", \\"email\\", \\"user_last_name_one\\", \\"user_last_name_two\\", \\"user_document_type\\", \\"user_document\\", \\"user_birth\\", \\"user_city\\", \\"user_neighborhood\\", \\"user_address\\", \\"user_cellphone\\", \\"profile_code\\", \\"user_age\\", \\"password\\", \\"updated_at\\", \\"created_at\\") values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, 2024-10-22 07:52:59, 2024-10-22 07:52:59) returning \\"id\\")","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":401},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Processors\\\\PostgresProcessor.php","line":24},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3549},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":1982},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1334},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1299},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Model.php","line":1138},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersControlador.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":11}	2024-10-22 07:53:00
20163	9d66eefe-c6be-4e75-a08f-d09111fc7716	9d66eefe-ca9e-47f8-adcd-608f64a9be9a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":998}	2024-11-03 12:16:58
18543	9d66943b-2f96-443c-87a1-540a27c3bc1b	9d66943b-3492-4d08-8a1c-d1a89e7c1cb0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":889}	2024-11-03 08:03:11
15025	9d5ece87-4a54-4728-be7d-80a73462544b	9d5ece87-4eb5-4cfb-bd54-c58895c35c1e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":673}	2024-10-30 11:19:34
2881	9d50fd53-dbdf-4e9b-b8bb-74d4231a632a	9d50fd53-dfd4-461e-9a6a-6ae9b9db3bf8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":163}	2024-10-23 14:28:50
27245	9d68e344-c888-4330-8a94-78a63eae1581	9d68e344-ccad-46f7-8095-7342e725020e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1269}	2024-11-04 11:35:50
35552	9d69c4f4-5ace-4bf3-8a8f-df68c6a1f1a0	9d69c4f4-5f6b-4157-9105-454e7a1e6231	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1612}	2024-11-04 22:06:54
19365	9d66d5d0-9c8a-4eea-9b6f-bc9e02be4349	9d66d5d0-9ff0-49f7-982b-e13af500b1e1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":950}	2024-11-03 11:06:34
18840	9d669d4a-4ebd-458d-b175-31310a06742d	9d669d4a-5281-496e-b8ca-cbfca3b2cca6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":919}	2024-11-03 08:28:31
42023	9d6cd3a9-55a2-4de5-990d-54f2b1cf60f5	9d6cd3a9-595f-4a5c-95ed-c58955795ed8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1951}	2024-11-06 10:35:31
39511	9d6bdd96-f0e6-46dd-8502-d0f37180bee5	9d6bdd96-f538-4d42-b7f6-59cfe0a9c09c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1757}	2024-11-05 23:07:27
15386	9d5ed10e-be36-43fc-86bb-ea2298483ea7	9d5ed10e-c366-4afd-b6cc-2f2fa14c3906	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":701}	2024-10-30 11:26:38
20511	9d66f473-6e1c-4abe-99f8-e755862c3f91	9d66f473-70de-447f-b6d2-17d8eada083c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1020}	2024-11-03 12:32:14
20688	9d66fae0-adb9-4c2c-ae62-905e2ecd0d8f	9d66fae0-b26f-43ad-bba7-50cd43dc25b9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1025}	2024-11-03 12:50:12
27974	9d68ea83-d3de-489a-b6ee-71370f3df284	9d68ea83-d786-4e76-bdbb-7782fc89e561	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1304}	2024-11-04 11:56:06
16173	9d64ba10-b3ab-4108-8914-f62dfe925b48	9d64ba10-b88a-4342-9c6d-ee3cc304d797	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":747}	2024-11-02 09:57:19
35096	9d69c226-bc23-4c61-b2e9-f017083159d0	9d69c226-bf2b-4f6d-a475-50db19d5200a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1589}	2024-11-04 21:59:04
10191	9d56cb02-5ea9-4e86-8537-4a93a232fe4e	9d56cb02-6176-4770-9fa9-be498ac591e1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":497}	2024-10-26 11:43:06
25622	9d68c76a-09cc-4cb0-81cc-36d547b2d7d3	9d68c76a-0f50-489a-8a33-a0070fc1b7c9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1175}	2024-11-04 10:17:57
19170	9d66d147-4714-4497-b9aa-c522e8461679	9d66d147-4c0a-4813-a731-f0452b20d14a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":937}	2024-11-03 10:53:53
14447	9d5d1e2e-8a3f-4cf3-8bd0-b1d323115e5c	9d5d1e2e-9197-40e9-9521-0032072a5b36	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":663}	2024-10-29 15:10:38
14598	9d5ebec8-6588-4f5f-aa1a-36559edf1dde	9d5ebec8-691d-4da7-97e1-8740f6ae767e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":667}	2024-10-30 10:35:32
26361	9d68d354-570d-4202-95e7-fc12d2d45bea	9d68d354-5ae9-4cfd-98ef-ee99a37d8eba	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1220}	2024-11-04 10:51:16
26002	9d68ccf3-884b-46dc-a130-ccdc14d9179e	9d68ccf3-8c8b-4230-9ab2-faeb42eff673	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1200}	2024-11-04 10:33:26
18603	9d6695f2-c7ab-4ae2-836f-8a3c6618b713	9d6695f2-ccdd-4c16-ad8f-ac59f090a4d4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":894}	2024-11-03 08:07:59
3289	9d51045b-fbc9-4e02-bc84-f768bda50be5	9d51045c-0221-404b-b12b-ceda1361c03d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":185}	2024-10-23 14:48:30
33201	9d69ad5c-fcde-4c48-b734-ba2e4e97e8ae	9d69ad5d-0392-4192-80f1-c4943d1a8aeb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1549}	2024-11-04 21:00:56
8048	9d52e631-cd86-43d6-b42c-ebf24bc2440f	9d52e631-d132-4e14-9bc6-0407a3eea1a8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":395}	2024-10-24 13:15:49
4163	9d512152-5690-4bc8-ba33-948066e43d12	9d512152-5a59-47b5-baff-eb23cf62342a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":231}	2024-10-23 16:09:29
40618	9d6cc614-5e40-4175-9c80-fbf0fcc37e8a	9d6cc614-61a1-4c1a-abac-c82663ecce14	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1833}	2024-11-06 09:57:32
10670	9d57130b-81ea-45ed-b8f6-de2a0f59978c	9d57130b-8722-40fc-ab3b-e7b20fce225a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":533}	2024-10-26 15:04:32
22101	9d674253-d0e2-4c27-b863-3fdc2c4c3261	9d674253-d77d-4b6b-8af6-a0af37d283ec	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1062}	2024-11-03 16:09:59
2131	9d50e3bb-aa5d-4ab5-96f7-5b34991bfe9e	9d50e3bb-af10-4405-bbe4-99c6daf93ce7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":128}	2024-10-23 13:17:16
9766	9d56ac8f-29d0-4a9d-9e77-6b31e17144de	9d56ac8f-2c93-457c-a11c-c377fde5fb56	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":463}	2024-10-26 10:17:58
7127	9d52dad2-672f-4f3e-beeb-753dec7bb5ba	9d52dad2-6abe-42e0-9882-a69f8e158a8c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":360}	2024-10-24 12:44:01
834	9d4f31f0-5003-4b99-ba87-cde1e1102121	9d4f31f0-5608-4ffa-9342-9c34dabd3035	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":61}	2024-10-22 17:04:18
25358	9d68c234-a9fe-44d3-888d-8c94d4997745	9d68c234-afd7-4a7f-b025-d62bb2b45c0f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1157}	2024-11-04 10:03:23
26032	9d68cd33-c502-4f95-a0c3-254bdc7fdd81	9d68cd33-c900-4b8a-8764-116001f01e56	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1202}	2024-11-04 10:34:08
29779	9d692b18-ac7f-486e-b794-be642affbbab	9d692b18-af96-483a-9b26-13ba26f809c0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1409}	2024-11-04 14:56:41
5554	9d5243d8-b28a-40ac-b9a7-890caa06ec6f	9d5243d8-b7ff-4f63-bcc5-fdbc3d08ac17	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":297}	2024-10-24 05:41:51
36655	9d6b3df3-3eac-4ac0-b20e-884515593b5f	9d6b3df3-41b4-4274-9f5d-8b87f8baf092	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1657}	2024-11-05 15:41:04
7793	9d52e15b-3544-4a12-9ede-3175a6a7476c	9d52e15b-381c-46cd-a4dd-be0dc5f6fd52	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":386}	2024-10-24 13:02:17
29788	9d692b19-865b-4d84-ba93-f69b56a85f37	9d692b19-89df-40aa-bc5c-db252ff7a6af	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1410}	2024-11-04 14:56:42
41160	9d6ccbb8-da31-48af-9f24-67d2bfc0c126	9d6ccbb8-e00f-4f96-be3c-d00373b865ba	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1883}	2024-11-06 10:13:19
43152	9d6ce51c-7123-4c41-9e4b-91b73c69a24d	9d6ce51c-73db-45f7-817f-84fdc32aafd7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abprofile_name\\u00bb\\nLINE 5:                             profile_name,\\n                                    ^\\nHINT:  Probablemente quiera hacer referencia a la columna \\u00abusers.profile_code\\u00bb. (Connection: pgsql, SQL: \\n                     SELECT id,\\n                            name,\\n                            profile_code,\\n                            profile_name,\\n                            profile_prefix,\\n                            remember_token,\\n                            user_address,\\n                            user_age,\\n                            user_alias,\\n                            user_birth,\\n                            user_cellphone,\\n                            user_city,\\n                            user_document,\\n                            user_document_type,\\n                            user_last_name_one,\\n                            user_last_name_two,\\n                            user_neighborhood\\n                        FROM users\\n                        WHERE profile_code = 4;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":142},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1995}	2024-11-06 11:24:18
16098	9d64b983-5fb9-494d-bcaf-a7f0d8ea165f	9d64b983-63d0-4a1f-b20e-41b3f6000dba	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":742}	2024-11-02 09:55:46
43198	9d6ce544-74ac-4263-9192-5c2682d79a45	9d6ce544-7783-49a0-849a-87d6ea140b9a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2002}	2024-11-06 11:24:44
37046	9d6b44bc-d162-47f3-9e35-59f8bb779f50	9d6b44bc-d74c-41fb-86c9-f4c5df6c8ebe	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1674}	2024-11-05 16:00:02
5590	9d524730-5d46-456e-a648-c213a46668d0	9d524730-61b0-4b8a-99cb-e2e2d8631172	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":298}	2024-10-24 05:51:12
30078	9d69337b-cb92-4411-bdaa-b4ebb94ae519	9d69337b-cead-4ce5-8272-f786b9664363	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1430}	2024-11-04 15:20:08
12016	9d5ce07d-96b7-40de-b89a-dac40efd3970	9d5ce07d-9a4f-4394-911e-843895e8bbbe	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":591}	2024-10-29 12:18:08
29129	9d6912e1-5271-4849-8282-b9c80e4c6c48	9d6912e1-56ab-40ee-bc2b-67dcf2248cba	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1359}	2024-11-04 13:48:58
24730	9d68bc34-124e-4e66-a4c3-15bd779bce90	9d68bc34-1661-4f0b-97e2-f822f511d5e5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1121}	2024-11-04 09:46:36
8386	9d52eb5b-46ef-4a35-9191-9b95248123fd	9d52eb5b-4e12-4df5-9129-a5572858ff31	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":408}	2024-10-24 13:30:15
13259	9d5cfc8e-5fe8-49fc-8bfe-26bf6040a9ae	9d5cfc8e-6376-4cec-9558-b41b05eec72b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":629}	2024-10-29 13:36:37
25732	9d68c8f3-8efa-4dfa-8184-bcac2a2dbcce	9d68c8f3-93e3-466e-908a-b400adf76d00	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1182}	2024-11-04 10:22:15
37303	9d6b4726-e4fd-427d-b872-aa8b26d2e5e7	9d6b4726-e7f8-4bbc-9e5c-27e4bcf42e40	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1685}	2024-11-05 16:06:47
9835	9d56ad44-c4a5-46ca-a65f-da968ef340c7	9d56ad44-c829-4f6e-9687-46b4f55453d5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":466}	2024-10-26 10:19:57
17024	9d654743-55e9-4da3-b470-323b784023f6	9d654743-58d1-4f08-b975-eeef6aa87bbb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna l.id \\nLINE 1: ...on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id \\" ...\\n                                                             ^\\nHINT:  Probablemente quiera hacer referencia a la columna \\u00abl.id\\u00bb. (Connection: pgsql, SQL: select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" as \\"l\\" inner join \\"users\\" as \\"ucl\\" on \\"l\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"l\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"l\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id \\" desc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":42},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":800}	2024-11-02 16:32:08
13881	9d5d13d3-31ad-4b68-8a3d-78fb5dfe753d	9d5d13d3-35e1-4b48-b45a-e25bd00ed9cc	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":641}	2024-10-29 14:41:41
31674	9d695482-f496-443f-b0df-8df4acddd260	9d695482-f89e-4427-b13c-b22269d71548	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1516}	2024-11-04 16:52:29
439	9d4f28fa-53b4-402f-ac79-d278086fec0c	9d4f28fa-5858-4c06-8c5e-c349a7be1fc8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":28}	2024-10-22 16:39:14
8914	9d52f263-1d9a-4ba4-9a2d-0ef03561468d	9d52f263-20f6-4d80-bad3-2be83c3226d6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":429}	2024-10-24 13:49:54
38822	9d6b6d5b-50db-4acd-a788-0f0d7cf81371	9d6b6d5b-54af-4ddb-90aa-6432af80d965	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1739}	2024-11-05 17:53:37
39662	9d6be112-39ba-4878-b88c-b64fd3cee7ec	9d6be112-3e12-4ecc-b6b3-ebcf632fec67	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1764}	2024-11-05 23:17:11
34180	9d69bba7-450e-483c-9da0-309d8892ce85	9d69bba7-49b1-45e0-957d-2cead54fdeef	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1554}	2024-11-04 21:40:54
20178	9d66ef2b-d513-49ef-a0fa-e939cd6b9d88	9d66ef2b-d89b-4631-951c-f892bf18ac8a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":999}	2024-11-03 12:17:28
18149	9d65b968-e54d-4939-87bc-6ec5a6250044	9d65b968-e8b2-4031-a25b-cbe1bb3292a1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":870}	2024-11-02 21:51:19
7892	9d52e299-2cd9-4a48-b284-1a0682f45e71	9d52e299-30a2-440f-8364-b0ca74b28427	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":389}	2024-10-24 13:05:45
26561	9d68d84a-c974-4081-8c91-f9f54bd922a8	9d68d84a-ce43-4741-abf7-56d128843ff6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1234}	2024-11-04 11:05:09
9148	9d52f57e-daa2-4a7e-99ab-81b1d0aed944	9d52f57e-df43-43e0-b04f-fb42dda30dce	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":438}	2024-10-24 13:58:36
4359	9d512da5-698a-4dd9-8b7d-e8ce360ae98a	9d512da5-70a5-41e3-a8a3-b0744698d4ad	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":238}	2024-10-23 16:43:57
27943	9d68ea7e-7e52-4f66-a9b1-028e543e5590	9d68ea7e-817b-4b38-ac5d-e2dc4150dbaf	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1302}	2024-11-04 11:56:03
15225	9d5ecf4e-1863-404d-8325-5683254256e0	9d5ecf4e-1bac-468d-8076-96f041d897ca	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":688}	2024-10-30 11:21:44
21239	9d673723-fa72-43b0-86a5-dcdfa096d560	9d673723-fd55-403d-b9fa-ed6550af369a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1038}	2024-11-03 15:38:42
15053	9d5ece8b-b4f8-4c7a-a89a-715f6539ebd5	9d5ece8b-bb1b-4340-86a0-e3e4fe2b9712	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":677}	2024-10-30 11:19:37
24811	9d68bd69-2da2-49b3-a62c-e2138e341502	9d68bd69-305a-4cee-9152-b3b80fe50b81	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1126}	2024-11-04 09:49:59
28015	9d68eaf4-5fe4-4f23-bdf6-eb5d10d5c427	9d68eaf4-66cb-4266-9c1c-905a7079e46d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1306}	2024-11-04 11:57:20
29079	9d690e9a-40d7-4a9f-90b1-16a47c47c53b	9d690e9a-43ac-4b57-a11c-0ba64b1774e1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1357}	2024-11-04 13:37:01
18801	9d669c23-7139-4454-852c-c7e8b25c33c3	9d669c23-74a1-4f97-8611-926f78925d35	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":916}	2024-11-03 08:25:17
39447	9d6bdae5-b4be-442a-89dd-c799bbd400d8	9d6bdae5-b8a1-41e5-b99d-03c2447ead43	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1754}	2024-11-05 22:59:55
10615	9d57116f-926e-4860-b8e6-a62912c76427	9d57116f-98e6-4bea-8d64-d9027100f6b7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":529}	2024-10-26 15:00:02
2407	9d50e7a8-e2e8-4812-a3d6-11b4dd4359cc	9d50e7a8-e5ae-4020-a0c3-47a12cbe3c5a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":137}	2024-10-23 13:28:15
14403	9d5d1e1f-bbd3-448c-b9f8-461f57c5b7c9	9d5d1e1f-c394-464e-83e7-7758d592fe45	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":660}	2024-10-29 15:10:29
37930	9d6b5dc8-dbba-4669-a744-a537ee59b115	9d6b5dc8-e317-4384-b633-76ff10ba4d96	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1704}	2024-11-05 17:10:05
4511	9d5131d0-0dbf-489f-a561-fbbfb11e1fcf	9d5131d0-118b-4b22-8bf1-b319dcd2dd0c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":246}	2024-10-23 16:55:36
18590	9d669574-255e-4f99-a9fa-8403430dc3af	9d669574-28d1-455c-97ee-26a230886b24	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":893}	2024-11-03 08:06:36
27902	9d68ea40-66ec-45de-bbfa-41e92b2b1ddb	9d68ea40-6c4d-40fd-b48d-1db96d6f7b15	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1300}	2024-11-04 11:55:22
42936	9d6ce181-56c2-4b14-a306-28228a17a269	9d6ce181-598f-4282-a80a-ae8a0b757d91	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1969}	2024-11-06 11:14:13
18431	9d669127-c091-4bb0-be2b-d6f7cd624e0c	9d669127-c4f4-4b4e-b086-49ab2faffd5a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":880}	2024-11-03 07:54:35
17954	9d65b4ab-855a-4829-97e9-2954fadd6524	9d65b4ab-88e2-4e87-bd89-f466b37b4831	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":857}	2024-11-02 21:38:03
583	9d4f2ced-8b13-46dd-8f29-3eb5b4beef9d	9d4f2ced-8e32-4d1f-8484-245dc274d23e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":42}	2024-10-22 16:50:17
18014	9d65b6a6-75e2-43b0-a6c3-1cf506fbc647	9d65b6a6-78ed-48d8-927c-5bc07324433b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":861}	2024-11-02 21:43:36
751	9d4f2e81-3886-4373-a7b7-aba98a3b18b0	9d4f2e81-3b7f-45b1-aebb-924f162964ff	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":54}	2024-10-22 16:54:41
29943	9d692c28-6716-40bf-ad31-0f53d2de4a42	9d692c28-6c9e-4fdf-9d18-73171e285b5c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1421}	2024-11-04 14:59:39
42006	9d6cd38e-504b-4dcf-b16d-edd389e8cb28	9d6cd38e-5409-466d-adef-18c4d2b812e3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1949}	2024-11-06 10:35:13
23306	9d6892c3-36e7-42f8-94e0-eb347b1f92fa	9d6892c3-3c2a-4bd3-99b2-dcb012dc0a05	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1101}	2024-11-04 07:50:44
39716	9d6be278-0f35-4ad2-abfa-72542aabd325	9d6be278-1352-4b14-8610-be5e28dbfa70	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1770}	2024-11-05 23:21:05
18264	9d65bb5e-7d0f-4f01-91a1-5115ec2f4658	9d65bb5e-8029-4723-9ba9-bc858713969a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":878}	2024-11-02 21:56:47
7616	9d52df80-96a8-486a-ac6e-d8ab7bc7a96a	9d52df80-99da-42aa-b22d-3c81fa616a2e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":379}	2024-10-24 12:57:06
15096	9d5ecee4-7d7c-44b4-bbb0-149e24df64c1	9d5ecee4-81bf-47e9-b285-e38fa58c6d46	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":679}	2024-10-30 11:20:35
9980	9d56c5c8-7392-4e38-a71a-214025c03322	9d56c5c8-768f-4846-9031-6b3b80483ad1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":479}	2024-10-26 11:28:29
27758	9d68e957-ef51-4b4e-8e0e-67f7347a24f0	9d68e957-f445-41de-8d76-a547d1ea228b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1294}	2024-11-04 11:52:50
9507	9d531cd9-52b3-463d-86eb-f681353d25f9	9d531cd9-5b4b-48aa-a188-438488bfad23	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":452}	2024-10-24 15:48:38
4044	9d511cca-a8af-4ae4-abee-92d39e366b3e	9d511cca-aed8-4ce4-97aa-876fc28ddc9d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":225}	2024-10-23 15:56:49
26431	9d68d3ea-ddf5-42ba-ba08-3c4bfd31212f	9d68d3ea-e3c6-46a9-aae0-5bc4f10601b1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1225}	2024-11-04 10:52:55
26708	9d68db8c-d59a-4f55-a992-223df15a38f9	9d68db8c-d8fa-48ba-a8f2-ee41ad111e87	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1243}	2024-11-04 11:14:15
11513	9d5cbf1c-63fe-4e04-845f-b236a52cab0a	9d5cbf1c-67a2-48d2-b343-3737a4c5d464	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":580}	2024-10-29 10:44:48
4125	9d511de8-5ca4-49e4-ab0d-0ba13d8587c2	9d511de8-6268-4137-a424-494a0f7596bb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":229}	2024-10-23 15:59:56
29048	9d690e69-739a-476f-9407-c708dab9c0de	9d690e69-79c8-4896-b832-f1c869bfbd2f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1356}	2024-11-04 13:36:29
38878	9d6b707f-72b7-4c35-9b34-7315327b5497	9d6b707f-7ae4-4baa-84db-0ac78ac4c2c0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1741}	2024-11-05 18:02:24
40465	9d6cc3bf-071a-4296-8aa7-f441c67575d0	9d6cc3bf-0a33-48ff-b08f-20b8d5e07392	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1815}	2024-11-06 09:51:01
26203	9d68cef9-b896-4082-b6db-0d909be22be0	9d68cef9-bebe-40ae-8a2a-1c260081274a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1211}	2024-11-04 10:39:06
38380	9d6b646d-a0af-489f-a8b5-26d88a34499a	9d6b646d-a4ad-4d96-810a-3c4fd3c75ac7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1724}	2024-11-05 17:28:39
28685	9d690712-f36c-4d50-9da9-40125f1f52f7	9d690712-fad2-44b8-a595-60e40a98014e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1337}	2024-11-04 13:15:58
5135	9d51367b-c3f1-4c74-a521-5984297bce88	9d51367b-c974-44d1-9358-927c6931024b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":277}	2024-10-23 17:08:39
16790	9d64d6c4-2cc4-49fa-ab60-66d52fecd681	9d64d6c4-2fa7-4ae4-a973-d328fd0d4f03	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":782}	2024-11-02 11:17:34
18956	9d66cd9c-cb1e-472d-963b-109bd35d852c	9d66cd9c-ced2-4ac5-9b36-4a0e90d864e6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":925}	2024-11-03 10:43:38
39851	9d6cb820-bc76-40f5-a8cf-e6b32c59117c	9d6cb820-c1d0-4ce5-a837-bae083cec988	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1786}	2024-11-06 09:18:31
23374	9d6895ea-ac59-4b62-8fc0-542e36801be2	9d6895ea-b01e-469a-a241-d03e26aba242	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1103}	2024-11-04 07:59:33
25594	9d68c730-435f-46fc-8097-aef1217a3c41	9d68c730-480e-4bc4-9e33-01e305754d75	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1173}	2024-11-04 10:17:19
21372	9d67399c-f7b2-4e8f-b5a3-86ae91cfe85e	9d67399c-fbe4-43f0-953e-029cd85107f7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1042}	2024-11-03 15:45:37
25952	9d68cc00-42d1-4fcd-9c4d-9e7c4d76cf72	9d68cc00-49d4-48fa-b442-c2481abe59ed	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1197}	2024-11-04 10:30:47
29153	9d6912f9-55f0-41cd-9511-01aa89851114	9d6912f9-59b3-4d26-90cb-60c34f1177f4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1361}	2024-11-04 13:49:14
28746	9d690766-ff5e-4917-ad73-dc4e00286d09	9d690767-024c-441a-bf43-2cac4a325e9d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1340}	2024-11-04 13:16:53
15311	9d5ed0ca-870a-42fb-a3e8-9cfb84fea5ac	9d5ed0ca-8b01-4852-ac12-2a2c419df0c1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":694}	2024-10-30 11:25:54
39539	9d6bdda7-cdf1-4d88-9f09-b046d7bfad3c	9d6bdda7-d153-4568-a3b1-1029afb75564	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1758}	2024-11-05 23:07:38
3199	9d510363-9e9e-4c9d-9b2e-dfedd557f76c	9d510363-a565-4e3e-bf57-f5eae8ed5761	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":180}	2024-10-23 14:45:47
9644	9d54874a-e1c8-4873-aacb-b81313d81c3a	9d54874a-f1c1-42d3-8475-d071587bf45f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":458}	2024-10-25 08:42:06
35051	9d69c16a-f598-4c78-86f0-17cbe964a991	9d69c16a-fb31-49e8-a984-568ce5793ddf	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1586}	2024-11-04 21:57:01
20376	9d66f1c3-74fa-45ea-ab9d-528ac2294285	9d66f1c3-7843-4acd-8e58-d5b61e74abea	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1011}	2024-11-03 12:24:43
25117	9d68bfd5-2aa9-4dd7-9832-adc1970d63ad	9d68bfd5-2ee0-4f30-8838-71190e03ccab	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1144}	2024-11-04 09:56:45
25792	9d68c94e-418a-449a-a8f6-7bffe719c9ad	9d68c94e-454e-4b52-abc8-48814cfd1e9e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1186}	2024-11-04 10:23:15
10126	9d56c906-7faf-4d55-825d-9bc8a37aac85	9d56c906-8284-4839-836c-f841d8dac3c8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":492}	2024-10-26 11:37:33
18986	9d66ce09-07d6-4fe4-adac-65d9ae7644ea	9d66ce09-0a9e-4787-ba8f-4505ddfd4d5f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":927}	2024-11-03 10:44:49
41623	9d6cce3d-4a06-4d4b-8bd9-0a2f0e57e05e	9d6cce3d-4dcc-481c-a8ce-9631ef6d5559	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1909}	2024-11-06 10:20:21
8100	9d52e6f6-604a-47b5-a8fd-00ab722a843d	9d52e6f6-6589-409c-b0b0-bd386fb5be41	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":397}	2024-10-24 13:17:57
15661	9d648fe4-a74c-405c-86de-f890c3f6a075	9d648fe4-aa78-4d77-af6d-16b5ef81dd4b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":715}	2024-11-02 07:59:24
17197	9d655018-59de-4ee7-b555-4ee33923a6d8	9d655018-5db6-477b-a1fa-0d2afe97dfab	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":814}	2024-11-02 16:56:50
25712	9d68c885-c504-481b-8909-b94cf98207c4	9d68c885-ca7f-43cd-a4fa-8b608e9ad68a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1181}	2024-11-04 10:21:03
16437	9d64c9bb-e242-4425-bf02-09eb5dc618af	9d64c9bb-e58c-4366-9859-b4d10a2c5257	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":764}	2024-11-02 10:41:08
20496	9d66f454-37f2-496a-8481-efb6d8b62c3c	9d66f454-3b5e-46d3-8eff-e1592f767f28	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1019}	2024-11-03 12:31:53
25392	9d68c25d-4ac9-42ca-95ca-5d90176bba24	9d68c25d-50ee-4002-86e3-2fc90319c6d0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1159}	2024-11-04 10:03:50
7720	9d52e046-1a75-4d57-81f6-25eed4d8abfb	9d52e046-1d5e-41df-9d47-de01a7644db2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":383}	2024-10-24 12:59:15
7642	9d52df9d-4db1-4d76-9820-124db0c0a06f	9d52df9d-512c-4224-b111-54bdd901bf3f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":380}	2024-10-24 12:57:25
9018	9d52f3b4-2d05-4636-b7ee-9440c560b842	9d52f3b4-31fa-48a4-bb3e-ab1fb99fb51c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":433}	2024-10-24 13:53:35
8734	9d52eeb7-e659-4a8d-96a5-2835dc2b67e1	9d52eeb7-e973-408a-9eb5-36db055cb120	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":422}	2024-10-24 13:39:39
34650	9d69bf31-96ab-435b-9b0d-1136c33b486a	9d69bf31-9ea6-446c-890f-35c0b6ef1f5e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1569}	2024-11-04 21:50:48
26341	9d68d312-a173-47bb-a032-931c3a6f2f10	9d68d312-a8fb-4bb8-9fc1-3415b7d9d5cb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1219}	2024-11-04 10:50:33
21680	9d673db3-32cc-4e84-bf5a-feadd3c51bc2	9d673db3-36d5-4ade-8d3d-da9e14b62013	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1046}	2024-11-03 15:57:03
19215	9d66d1db-4faa-4ba2-8ab3-d7860663a72d	9d66d1db-526d-4111-97ab-ba3139555269	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":940}	2024-11-03 10:55:30
25444	9d68c2f1-fab6-4426-af20-5c19689d0945	9d68c2f1-fd72-4794-a012-8aa30fa30f7e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1162}	2024-11-04 10:05:27
8360	9d52e8f0-626a-42db-afdc-6fa78e7a3973	9d52e8f0-6551-41df-a552-7bdb14c4be71	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":407}	2024-10-24 13:23:29
22203	9d67439c-6b39-49f1-a24c-460d7ee46fc9	9d67439c-7224-4f13-8e00-0d5540999af6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1068}	2024-11-03 16:13:35
43257	9d6ce5ba-78ff-4a0f-8008-0651b2edb674	9d6ce5ba-7bcc-4d06-aa4a-c83946f79efb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2007}	2024-11-06 11:26:02
29007	9d690e50-c93b-4900-81c6-296bc89448da	9d690e50-cea5-4e0b-bc16-42bae53ac044	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1354}	2024-11-04 13:36:13
23515	9d689784-e1d9-4a64-8c26-f9ab76732ab1	9d689784-e62d-4d2e-918b-51c651369333	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1105}	2024-11-04 08:04:02
6903	9d52d747-5273-450b-bb9b-d3374cc54188	9d52d747-5611-4d4a-a699-2705485dd28b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":351}	2024-10-24 12:34:06
43278	9d6ce5c4-6f26-4ce5-b6cb-709a2ae69594	9d6ce5c4-7205-4bff-a335-6bd37001458f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2009}	2024-11-06 11:26:08
40839	9d6cc7be-cefc-4b23-8592-66376afdb338	9d6cc7be-d257-4c62-81fe-9079761f52ba	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1859}	2024-11-06 10:02:11
43165	9d6ce51e-fd0a-46a0-a3a4-b673e413d954	9d6ce51f-0020-4da9-a4b5-da22e32af448	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abprofile_name\\u00bb\\nLINE 5:                             profile_name,\\n                                    ^\\nHINT:  Probablemente quiera hacer referencia a la columna \\u00abusers.profile_code\\u00bb. (Connection: pgsql, SQL: \\n                     SELECT id,\\n                            name,\\n                            profile_code,\\n                            profile_name,\\n                            profile_prefix,\\n                            remember_token,\\n                            user_address,\\n                            user_age,\\n                            user_alias,\\n                            user_birth,\\n                            user_cellphone,\\n                            user_city,\\n                            user_document,\\n                            user_document_type,\\n                            user_last_name_one,\\n                            user_last_name_two,\\n                            user_neighborhood\\n                        FROM users\\n                        WHERE profile_code = 4;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":142},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1996}	2024-11-06 11:24:20
41384	9d6ccc74-0f2d-46dc-ad67-8f927b4385ba	9d6ccc74-121a-46d7-baf7-e2b9d9848d45	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1897}	2024-11-06 10:15:21
40550	9d6cc4e5-dc13-4bb4-8354-a9251fd2ff1a	9d6cc4e5-dfde-4ab4-9528-4286c88e55d3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1825}	2024-11-06 09:54:14
43320	9d6ce5de-3702-4392-8015-606b8c9874b7	9d6ce5de-3a11-47df-bca4-3e8fa72394a8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2013}	2024-11-06 11:26:25
28726	9d690738-c6ad-42ea-b674-a24797397415	9d690738-cb5d-4951-b46c-ed5e36f37ed4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1339}	2024-11-04 13:16:22
39790	9d6cb631-810c-4c4f-8b7e-81688908eb81	9d6cb631-8420-4c93-b903-65aba017f8d3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1777}	2024-11-06 09:13:07
40291	9d6cc275-1ca3-4a55-95ec-d5e0db7dc515	9d6cc275-202d-4784-a2c5-bb73c3589812	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1799}	2024-11-06 09:47:24
20301	9d66f114-b3e7-4ecc-91a8-107a86e9a19c	9d66f114-b74a-4fb5-ba58-b8174b5e53ca	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1006}	2024-11-03 12:22:48
18926	9d66cbae-ab22-4f7e-8100-5aabd9278eb8	9d66cbae-ae26-40b0-bd6d-71a15a5cd719	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":924}	2024-11-03 10:38:14
18179	9d65b999-64d4-4dca-a96f-cd7e33b0ca8c	9d65b999-69f6-41e2-b0fc-d228445539a1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":872}	2024-11-02 21:51:50
34328	9d69bde5-ef97-4f59-bdcb-27251443533f	9d69bde5-f2ec-4954-b354-777233dfd361	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1558}	2024-11-04 21:47:10
29201	9d6913de-44fb-4a78-a0f5-2f40cf93c285	9d6913de-49a5-4a56-8f03-7c55fea7b8c2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1365}	2024-11-04 13:51:44
22301	9d674a73-01c1-4a32-a631-3e8396045abb	9d674a73-06db-4dbf-b3fd-87dc68463501	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1073}	2024-11-03 16:32:42
1434	9d50d153-dc74-4f5e-9117-c0870ffb4cfc	9d50d153-df55-45b1-9f5b-03521cd6a3e2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":102}	2024-10-23 12:25:48
36770	9d6b3fba-478a-4e51-b28a-a58d7d656814	9d6b3fba-4a65-4900-92b3-269b48dc005f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1662}	2024-11-05 15:46:02
36568	9d6b3d59-1b1e-470f-a11f-6a6c281d1935	9d6b3d59-1f60-4c1f-979e-8001b9d2b2a5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1653}	2024-11-05 15:39:23
29495	9d692814-7817-492a-9789-936fb0b56e98	9d692814-7cb4-409f-99a8-0fb13002bc64	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1389}	2024-11-04 14:48:15
1685	9d50db8e-370a-4296-9757-de6ee4892300	9d50db8e-3a73-443d-95b9-8f45613307c0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":113}	2024-10-23 12:54:24
17184	9d654fbd-a88c-40e9-8590-053c4cba38e9	9d654fbd-ad24-48cf-b8a1-780c09255216	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":813}	2024-11-02 16:55:50
18913	9d66cba7-930f-4787-bfc8-182d585482e0	9d66cba7-966a-48bb-a103-549b796d79d2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":923}	2024-11-03 10:38:09
10100	9d56c89b-760c-47bc-9501-d12ae4e8e76c	9d56c89b-7947-4e6a-92a2-b4fefa1530b0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":490}	2024-10-26 11:36:23
16965	9d654665-7325-4143-82b3-183ed303fb80	9d654665-767d-4a8b-b036-0ce7f59a92a6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42P01]: Undefined table: 7 ERROR:  falta una entrada para la tabla \\u00abl\\u00bb en la cl\\u00e1usula FROM\\nLINE 1: select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", ...\\n               ^ (Connection: pgsql, SQL: select \\"l\\".\\"id\\", \\"l\\".\\"loans_documento\\", \\"l\\".\\"loans_nombre\\", \\"l\\".\\"loans_apellido_uno\\", \\"l\\".\\"loans_fecha\\", \\"l\\".\\"loans_valor_prestado\\", \\"l\\".\\"loans_cuotas\\", \\"l\\".\\"loans_estado\\", \\"l\\".\\"loans_intereses\\", \\"uco\\".\\"name\\" as \\"cobrador\\", \\"ure\\".\\"name\\" as \\"recomendador\\" from \\"loans\\" inner join \\"users\\" as \\"ucl\\" on \\"loans\\".\\"user_customer\\" = \\"ucl\\".\\"id\\" inner join \\"users\\" as \\"uco\\" on \\"loans\\".\\"user_cobrador\\" = \\"uco\\".\\"id\\" inner join \\"users\\" as \\"ure\\" on \\"loans\\".\\"user_recomendacion\\" = \\"ure\\".\\"id\\" order by \\"l\\".\\"id \\" desc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\precautions\\\\PrecautionsController.php","line":42},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":789}	2024-11-02 16:29:43
34545	9d69becb-908a-47f8-9a0e-5751791142e3	9d69becb-9399-46c6-a320-0c9ddb1acbd7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1565}	2024-11-04 21:49:41
8940	9d52f26c-216d-4e61-ba75-03454efe91ef	9d52f26c-2489-4de3-882b-57af27010b49	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":430}	2024-10-24 13:50:00
30623	9d694125-d08d-48fd-aeb7-42d6f0bd4f1d	9d694125-d5fb-4cb8-a826-2a799702b38a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1462}	2024-11-04 15:58:21
17525	9d655c4a-08e7-44e3-875c-740ee95a37fd	9d655c4a-0bce-4965-b20e-5614df5d1f38	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":840}	2024-11-02 17:30:56
4549	9d513313-bd94-4212-b2ac-9aa720595932	9d513313-c20a-4a17-9ba0-de56afab115a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":248}	2024-10-23 16:59:08
39754	9d6cb4d3-5a31-4d91-8402-68be0834292e	9d6cb4d3-6014-4426-ad5d-0a5804fd977d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1773}	2024-11-06 09:09:17
15282	9d5ecf81-9605-4cf1-b910-836d5ab5e094	9d5ecf81-9b7b-4f78-b0cf-2c995a82a10c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":692}	2024-10-30 11:22:18
11977	9d5ce043-33fb-4914-b634-a79d17eba17b	9d5ce043-3858-4a63-9b33-6aaa3021f873	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":589}	2024-10-29 12:17:30
40414	9d6cc32b-4e4f-4bc0-afe3-12e45bf59c68	9d6cc32b-5123-4b00-81dd-853957295b10	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1809}	2024-11-06 09:49:24
32104	9d695cab-75ef-418d-9087-28e42eb1cbad	9d695cab-78f8-43db-b484-1766abb9c15b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1535}	2024-11-04 17:15:18
29653	9d692a0b-5613-4550-aa8c-36e60379b003	9d692a0b-591a-45dd-8e99-75ab4e5d3e7f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1400}	2024-11-04 14:53:45
39707	9d6be265-2186-4d51-aec5-c3ab418754c2	9d6be265-2535-4c95-ad01-39bc63fb560d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1769}	2024-11-05 23:20:53
13178	9d5cfa0b-b589-4435-92fd-f1cf0623cdd1	9d5cfa0b-b980-4a6c-b595-cc211bbf2151	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":627}	2024-10-29 13:29:36
42363	9d6cdd9d-d726-4fd3-968e-659ecb769cb6	9d6cdd9d-dab3-46b8-b7dc-b3156b1ffe6b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1955}	2024-11-06 11:03:21
4330	9d512a6d-3071-422c-abb9-b68e7ed791ea	9d512a6d-33ee-4f2f-a307-f30f2d728dfd	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":237}	2024-10-23 16:34:57
26800	9d68dc5a-3efd-4625-a70b-972496985b49	9d68dc5a-422a-4092-81e9-abf3cf92f7ee	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1249}	2024-11-04 11:16:30
16952	9d654662-ce47-47f7-8db0-412923870af1	9d654662-d1c8-4a29-9a1b-958e3bebabe8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":787}	2024-11-02 16:29:41
18750	9d669b7e-b9f8-4eac-8a44-8a8bec63a7c2	9d669b7e-be80-4604-aa87-3e3f5dc7e285	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":907}	2024-11-03 08:23:29
10747	9d5720ce-9c82-40c4-996e-a2dce5a454ad	9d5720ce-a172-4edf-a600-344334ffae5b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":537}	2024-10-26 15:43:01
25087	9d68bfb2-a893-4f70-bd25-b52ebf649411	9d68bfb2-aba3-4616-85ea-2e3c01cea45e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1142}	2024-11-04 09:56:23
34686	9d69bf48-6996-43ed-84c2-afa7b4742534	9d69bf48-6ce1-4c67-a034-8ae9950e50b2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1570}	2024-11-04 21:51:03
30740	9d694316-f8d6-4aa3-a661-a7ca949c59e6	9d694316-fc1c-4e88-ba7b-5bd1f8b92bb9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1467}	2024-11-04 16:03:47
8412	9d52eb90-95a4-4dbd-b175-60b41b5171bf	9d52eb90-98ea-438f-9312-6a20c5c0851b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":409}	2024-10-24 13:30:50
24130	9d68a7d5-55fe-49ca-85db-db86502c37cb	9d68a7d5-5a95-401c-8b73-16bb7c607c46	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1113}	2024-11-04 08:49:39
40601	9d6cc5dc-785f-4900-8ed2-0ffb5e36eb3d	9d6cc5dc-7bb9-44b0-a5dd-b9b76dbfd674	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1831}	2024-11-06 09:56:55
1262	9d50c9bf-2d2f-4f4d-b360-bb1b18d3b498	9d50c9bf-318d-49f1-98fd-f47f3ef21554	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":93}	2024-10-23 12:04:36
26718	9d68db8e-7334-4974-95c7-7217870da1cb	9d68db8e-77f9-45f3-b1eb-220e630900c0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1244}	2024-11-04 11:14:17
20879	9d66fca9-2c28-41ee-83ad-018de77bd426	9d66fca9-2eb7-40a1-8378-8363ea8f6166	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1029}	2024-11-03 12:55:11
10373	9d56cef3-56d1-4d1c-9be2-f2c8966901bb	9d56cef3-59e6-4ec6-95d0-3fd3b2b90435	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":511}	2024-10-26 11:54:08
31597	9d6951bd-e527-492c-83ad-201070c78e2b	9d6951bd-e94a-43df-852a-9660182c5663	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1512}	2024-11-04 16:44:45
457	9d4f291f-153d-419f-9bbf-9d9a79dcff51	9d4f291f-1803-4209-863f-8d7ff5c61a9c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":30}	2024-10-22 16:39:38
15468	9d5ed332-3b32-44c1-af0d-44815d0160bf	9d5ed332-3fb2-4822-ba83-4e2674d2995b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":706}	2024-10-30 11:32:37
13110	9d5cf97d-9bec-47ac-9843-c209aa3c36ba	9d5cf97d-a070-4316-b49f-b2b5cf9853f3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":623}	2024-10-29 13:28:03
11453	9d5cbe8a-b074-4893-8694-5344873034e4	9d5cbe8a-b365-4694-8f41-f23e3a4c3ff0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":576}	2024-10-29 10:43:13
31276	9d6949b6-e543-4334-9a90-b1e628cbb750	9d6949b6-e92f-4c44-b583-3e9ebff22f67	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1487}	2024-11-04 16:22:18
34199	9d69bbaa-27b3-4335-ba09-746c86dd7f98	9d69bbaa-2d56-42a6-955d-fc1b24cc6a3f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1555}	2024-11-04 21:40:56
18219	9d65ba5a-70ad-4217-94a7-db94c7bb39b1	9d65ba5a-739c-41b7-b826-49c68d802feb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":875}	2024-11-02 21:53:57
19230	9d66d266-52c2-470e-b54e-789344638504	9d66d266-5889-4eab-a7ec-642c752a3be0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":941}	2024-11-03 10:57:01
7075	9d52da9d-7afa-4189-b520-819cad0b6f50	9d52da9d-7e8f-4c90-bdb9-5c88068938cf	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":358}	2024-10-24 12:43:26
36223	9d6b33b2-f06e-406a-a40d-7396bd196f2a	9d6b33b2-f453-42a0-956f-69db85ad4a55	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1638}	2024-11-05 15:12:24
825	9d4f311f-ff3b-47a4-ab79-0e30ccbcc75e	9d4f3120-03c3-46cd-bb57-df099b9ae334	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":60}	2024-10-22 17:02:01
30140	9d693484-1745-4ee8-b453-e5bb473b7493	9d693484-1be7-44e7-b0be-53af2cd4f29f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1434}	2024-11-04 15:23:01
12606	9d5cec6a-f1cd-4759-a813-c5d3a8452e79	9d5cec6a-f56c-49f7-80cf-7967e6220970	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":602}	2024-10-29 12:51:29
26511	9d68d71f-a716-4e4d-a558-b55266db928b	9d68d71f-ad3d-487c-84a3-431960420763	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1231}	2024-11-04 11:01:53
30239	9d69379e-f7fb-4a15-819a-4e139128564f	9d69379e-fb84-48a2-9006-6411991069d3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1440}	2024-11-04 15:31:42
10308	9d56cd4f-ffc2-43a7-9c61-9a1f99dd297d	9d56cd50-02a7-4276-8301-6cd6d29d89d0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":506}	2024-10-26 11:49:33
911	9d4f3481-172c-49c5-b563-3a887f752651	9d4f3481-1a83-4a33-b630-ccba9aeff4a8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":69}	2024-10-22 17:11:28
24861	9d68bd9e-e628-4eb1-ac7b-f9ced86dec31	9d68bd9e-ebaa-4e9f-b2cb-d0c1c2c0212d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1129}	2024-11-04 09:50:34
30750	9d694318-0833-4a0f-90ac-303b952cc9d8	9d694318-0d3a-456f-a31b-15aefb11d50e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1468}	2024-11-04 16:03:47
19140	9d66d095-c038-4cfb-99ba-8a207a154f73	9d66d095-c32a-49a8-a3ab-968308f29763	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":935}	2024-11-03 10:51:57
2734	9d50fbbe-7f98-405f-b5d6-35b5242e0cb0	9d50fbbe-8396-4629-a034-6541ca62a607	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":155}	2024-10-23 14:24:25
8282	9d52e809-1d09-49b5-94db-041282edbf37	9d52e809-2037-4ed1-87d2-f94fc120d784	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":404}	2024-10-24 13:20:57
22315	9d674a75-8249-43f3-9eb7-e7ac127abd97	9d674a75-883a-42df-b75f-45e86e2cf4cf	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1074}	2024-11-03 16:32:44
41767	9d6ccf5b-37b0-4c8a-961e-b9214eb5337a	9d6ccf5b-3ba5-463f-8127-eba132ac37aa	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1927}	2024-11-06 10:23:28
28343	9d6900ce-974b-455a-a361-eacae75d88e4	9d6900ce-9ecd-4bbb-8448-4e14bce8e543	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1322}	2024-11-04 12:58:26
31132	9d69465f-0a48-4fee-92f6-b9ba525deae7	9d69465f-0fd4-4f15-bfa8-1ed29d64624d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1482}	2024-11-04 16:12:57
20018	9d66ed49-21e9-4ec4-a74c-59241513b972	9d66ed49-24f3-414d-9011-efe951d55f8f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":988}	2024-11-03 12:12:12
17999	9d65b675-3704-49a7-b072-ffe0abf1256a	9d65b675-3b6c-42e5-bab0-a53ae893dc53	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":860}	2024-11-02 21:43:03
3859	9d511ad6-a495-4732-bb59-47c22e1c625d	9d511ad6-a88a-4366-960a-3ee584310e7e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":215}	2024-10-23 15:51:21
27187	9d68e2b5-d091-4c35-a259-bf273b904c47	9d68e2b5-d64e-4164-9409-c84f5121ad37	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1266}	2024-11-04 11:34:17
27471	9d68e569-4b0c-4d47-858b-c4b15d55a153	9d68e569-518c-4f7c-9f1f-5496354caba6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1280}	2024-11-04 11:41:50
15382	9d5ed10d-ceb7-45ee-9f96-da3b824ec7e8	9d5ed10d-d252-47fe-b5e9-488252d739d1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":700}	2024-10-30 11:26:38
18724	9d6699e8-6e5b-492d-beaf-00f046ab943f	9d6699e8-7160-4c4c-8be0-decc6df65b5c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":905}	2024-11-03 08:19:03
27851	9d68ea20-0c72-4827-8f9f-287950ec87f4	9d68ea20-0eed-4da0-a78f-d5c0c2ead4c8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1297}	2024-11-04 11:55:01
8178	9d52e797-6bad-4e65-b2d1-06632f6b0304	9d52e797-6ffa-4007-a6e0-7416631bd020	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":400}	2024-10-24 13:19:43
13847	9d5d12bb-aa6a-4aad-8eb8-1ffd1d00312d	9d5d12bb-adbf-4474-935b-ba2a65239d2d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":639}	2024-10-29 14:38:38
29682	9d692a84-59ae-4561-a973-779c4fc8212d	9d692a84-5ddc-4e65-96e8-1c50149aa03d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1402}	2024-11-04 14:55:04
10958	9d5ca6dd-ff43-4818-86e1-4f31b910a377	9d5ca6de-0266-4bcf-939e-06e4e37bf6b9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":549}	2024-10-29 09:37:01
29827	9d692bde-8e15-4eee-a7a6-6b58e1d909fa	9d692bde-943d-4171-9fca-3652c8592dc4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1413}	2024-11-04 14:58:51
2107	9d50e382-3817-4faa-97dc-0cb8e05b79df	9d50e382-3aee-4a7e-8fb3-87b943a7b631	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":127}	2024-10-23 13:16:39
18577	9d66949e-f2a1-4c0f-b8ca-937a74ec023e	9d66949e-f6d3-4345-91de-70e52220bd32	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":892}	2024-11-03 08:04:16
31887	9d69572c-2f0a-4228-9384-f606b9230fbf	9d69572c-3260-4b9b-9aa3-65380f2c9be3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1525}	2024-11-04 16:59:56
6773	9d52d55f-ee0b-4e54-bb61-783dc8405e85	9d52d55f-f199-4c00-9ef5-66260805b3f1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":346}	2024-10-24 12:28:47
14340	9d5d1e07-eafd-48d4-9fd6-4bd72263472b	9d5d1e07-f192-4f86-a27a-0107210da488	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":656}	2024-10-29 15:10:13
10945	9d5ca6d6-1e25-4989-a7f3-d1c55f7e843b	9d5ca6d6-213b-4241-8863-f05c1567ed83	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":548}	2024-10-29 09:36:56
43403	9d6ce763-47b8-4f10-92de-985e991e99bb	9d6ce763-4b77-480f-bea6-a72435229014	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2021}	2024-11-06 11:30:40
28538	9d6901f2-95b1-43c3-9e43-3e1133b2d7c9	9d6901f2-990c-4926-9a32-595b7c912fac	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1331}	2024-11-04 13:01:38
43236	9d6ce5b0-5f8e-483c-ab90-d0c526fac6ce	9d6ce5b0-639c-448d-b75d-ab60c23b08b1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2005}	2024-11-06 11:25:55
30440	9d693f8f-5133-49d0-9830-a9bc578f3879	9d693f8f-5547-421e-916b-a8748ffed2e8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1450}	2024-11-04 15:53:54
30896	9d694438-8bc7-443f-9570-af4c18ddbcbf	9d694438-8ef5-47af-b2c9-851ff4ac887f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1473}	2024-11-04 16:06:56
14320	9d5d1de5-f91c-4d91-9015-5f27005cebda	9d5d1de5-ffb4-4ef1-9eca-93dc795c5f99	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":655}	2024-10-29 15:09:51
5102	9d513676-a3c3-4aad-b226-ecbbcb321da3	9d513676-a976-414f-af4e-2f61176ddd7f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":275}	2024-10-23 17:08:36
13144	9d5cf9cf-8785-4b1d-8bcd-5e4e00b5ab46	9d5cf9cf-8c20-4ea6-9268-34310c1b5f1a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":625}	2024-10-29 13:28:56
10585	9d5710db-aece-4f2d-a5ef-fe300a03b296	9d5710db-b269-439f-bb19-01f2303c00d7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":527}	2024-10-26 14:58:25
25762	9d68c8fe-efb0-4734-9b77-112279057f52	9d68c8fe-f529-454c-aac9-a58251e014ba	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1184}	2024-11-04 10:22:23
22925	9d67fd91-dbdd-4bab-8b7f-527b45f0632c	9d67fd91-df04-42f5-a770-bde8cf442ba2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1092}	2024-11-04 00:53:33
22275	9d67485a-b729-47ff-a8f7-067d6278337c	9d67485a-bcd0-4d4d-8cb4-adf95ec9f096	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1072}	2024-11-03 16:26:50
29798	9d692b1a-bb20-44f3-986d-1abecedb1b4f	9d692b1a-c086-49d8-82dc-d2852f873be0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1411}	2024-11-04 14:56:42
43429	9d6ce9ff-6f02-4efe-84a6-9ca896012838	9d6ce9ff-74aa-41e8-9cfc-8d79cc0d6f29	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2023}	2024-11-06 11:37:58
242	9d4f1531-081e-4ba4-921f-6ac142085f77	9d4f1535-2c67-425e-a4c4-c5c0227a7c13	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42601]: Syntax error: 7 ERROR:  el nombre no es v\\u00e1lido (demasiados puntos): menu.id, menu.menu_name, menu.menu_url, menu.menu_orden\\nLINE 1: select \\"menu\\".\\"id, menu\\".\\"menu_name, menu\\".\\"menu_url, menu\\"....\\n               ^ (Connection: pgsql, SQL: select \\"menu\\".\\"id, menu\\".\\"menu_name, menu\\".\\"menu_url, menu\\".\\"menu_orden\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":48},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":13}	2024-10-22 15:43:55
40083	9d6cc0dc-3620-4ea8-8691-46ad5ee5ce86	9d6cc0dc-3a35-4968-83d9-46b8d26e3ac8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1791}	2024-11-06 09:42:56
29663	9d692a0c-7faa-4e84-b089-471ff6789590	9d692a0c-8545-4435-9d21-2f258483e39b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1401}	2024-11-04 14:53:45
26860	9d68dd4e-f1cf-4bc0-9e53-0604f221ad8c	9d68dd4e-f526-4b7e-8826-229ac7d8050e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1253}	2024-11-04 11:19:10
15878	9d64b212-f6ac-4452-9b1a-7a8dd755dd6e	9d64b212-f96e-4fb8-bbf1-f1bfb9ae2849	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":728}	2024-11-02 09:34:58
37023	9d6b445e-82ba-4b9c-a29b-131d45eda90f	9d6b445e-8612-4516-8b5a-29f208acd637	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1673}	2024-11-05 15:59:01
14505	9d5eb96d-41e9-4c2b-b561-fd40829f4ce0	9d5eb96d-55b9-4783-a9ac-1ec0fe63176c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":664}	2024-10-30 10:20:34
1931	9d50e0f8-9272-4b46-99f3-c9b1f4080ea3	9d50e0f8-9674-4241-bd4a-fd023a5ba192	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":122}	2024-10-23 13:09:33
20346	9d66f177-1fbb-4ee3-8fba-9e50c4b65518	9d66f177-2357-47b7-a746-adf593e3e9c6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1009}	2024-11-03 12:23:53
11001	9d5ca78e-ccd2-426c-8a7c-a58250fd8076	9d5ca78e-cf95-4ce2-a322-2574124286f5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":551}	2024-10-29 09:38:57
37161	9d6b4581-ab81-48cc-8fd5-aa4b1226c9a5	9d6b4581-b172-4d92-b80b-10c7fc63b137	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1679}	2024-11-05 16:02:11
920	9d4f3499-73ad-4e9c-a050-a28f3bb6f9ea	9d4f3499-7654-4ba0-b55b-834fd88ab62f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":70}	2024-10-22 17:11:44
11720	9d5cce4a-2e32-43a3-b73f-fbe6fb8930f4	9d5cce4a-3103-4d53-a44f-90e6040b215c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":582}	2024-10-29 11:27:15
17106	9d654b13-9d17-42bf-8539-d780c96d3a10	9d654b13-a065-4ec3-9692-ef4c3dc98cc8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":809}	2024-11-02 16:42:48
574	9d4f2cc2-4a3c-4a05-a718-d5bacf9f226e	9d4f2cc2-4fb2-4af4-9669-6d0218829174	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":41}	2024-10-22 16:49:49
27357	9d68e435-c786-4ec6-b652-4f8fb24aa850	9d68e435-cc98-4268-a71d-a919ed79b6ef	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1276}	2024-11-04 11:38:28
2563	9d50fad0-6684-443b-900f-84e315baf91f	9d50fad0-6af7-44de-ae27-cafd2a2b8aba	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":146}	2024-10-23 14:21:49
25472	9d68c679-480c-4b57-b10a-bc5790d027c6	9d68c679-4c39-4da8-9c26-b7a1171b38b7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1164}	2024-11-04 10:15:19
11904	9d5cd856-4df6-409b-a7b0-d5e98f73ba45	9d5cd856-510a-4d74-b613-1b76a112f7b8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":584}	2024-10-29 11:55:20
2269	9d50e6b3-f26a-4ae6-b234-43f71464f8dc	9d50e6b3-f663-44e0-8f5a-761ce8130f17	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":130}	2024-10-23 13:25:34
39465	9d6bdae8-0051-4a53-afb0-911791250797	9d6bdae8-03fe-4665-a1cf-3ff6d9897e87	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1755}	2024-11-05 22:59:56
38472	9d6b6516-76be-4cec-8c81-e8b29ed908aa	9d6b6516-7a05-441c-b388-e0cd8a4f6ed2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1728}	2024-11-05 17:30:30
41801	9d6ccfbb-f59c-4c0d-b74a-530048edd664	9d6ccfbb-fa66-4886-8525-bd016536cefe	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1931}	2024-11-06 10:24:32
5249	9d51377b-68ae-402b-b802-7f8516c61eb1	9d51377b-6e13-4ff9-85bf-fc1a88fbde25	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":283}	2024-10-23 17:11:27
38132	9d6b5fd3-6b73-4877-b1d9-d70aee4494c8	9d6b5fd3-6f6b-41f9-b8b7-271f6439ec47	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1713}	2024-11-05 17:15:47
16571	9d64d3cf-347f-49df-941a-d26d471548bb	9d64d3cf-378f-4f8e-934b-4b827aaa08a9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":771}	2024-11-02 11:09:18
12989	9d5cf2da-d73b-4e70-8fa4-f82f60928d45	9d5cf2da-dd58-444b-9eb2-46629a7703a7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":619}	2024-10-29 13:09:29
1878	9d50e014-7a04-454d-965b-85c4084b0db5	9d50e014-7d0c-405d-a2f1-f59073a445da	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":120}	2024-10-23 13:07:03
33215	9d69ad61-c062-412d-a314-40b4cd9de634	9d69ad61-c37e-4f58-8343-fb3770233927	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1550}	2024-11-04 21:00:59
9939	9d56c2a1-1b30-456d-a533-d43aec658eaf	9d56c2a1-1efb-4011-99d1-0d3f70e9094e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":475}	2024-10-26 11:19:40
21556	9d673c0d-06ee-4fa3-aa0b-c69ed46d3173	9d673c0d-0aec-4eb0-abf1-45236b0336ff	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1045}	2024-11-03 15:52:26
40890	9d6cc871-f0a7-4b78-a655-0bd118778b00	9d6cc871-f3a2-4d94-81be-f66edf4569da	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1865}	2024-11-06 10:04:09
25668	9d68c7c5-0588-409d-a671-64a0b9bdd0f5	9d68c7c5-090b-4482-951c-52adcfd853c9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1178}	2024-11-04 10:18:57
22790	9d67fbb5-a17f-45fb-9884-9f389ad4a828	9d67fbb5-a4a9-4f82-a237-820be3d1f0e8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1091}	2024-11-04 00:48:21
3873	9d511ad8-fe58-47ac-985a-de1bf283fa93	9d511ad9-04f1-4d62-9903-39961d2cd6c3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":216}	2024-10-23 15:51:23
27861	9d68ea21-b2ad-478f-a4be-6072a9aff48c	9d68ea21-b8bd-4150-8578-705fbae913a8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1298}	2024-11-04 11:55:02
39689	9d6be219-fd06-4396-8aca-832705c2ca63	9d6be21a-0018-4ea8-ad43-93930751b3c0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1767}	2024-11-05 23:20:04
37695	9d6b59ab-1bbb-4b6f-8f7a-48026c37ff04	9d6b59ab-1e6a-449e-91f7-42cc8e1ee3e4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1698}	2024-11-05 16:58:34
19604	9d66e144-3d8d-4b37-b599-f48cd8be2fd6	9d66e144-405d-4dc8-acf4-81c2de7ea90a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":964}	2024-11-03 11:38:35
10788	9d572157-51be-4b93-bde1-33a016cfbdd3	9d572157-5578-4538-b03a-34d1bf28b946	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":540}	2024-10-26 15:44:30
38739	9d6b6cde-a7fe-429a-a027-b57998b7e6fb	9d6b6cde-acb6-4d83-93f1-fa8fdcc85f82	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1738}	2024-11-05 17:52:15
10087	9d56c853-ffff-4ea9-9d3f-542d1394c40a	9d56c854-057f-448e-9a79-e512a9b72863	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":489}	2024-10-26 11:35:36
36747	9d6b3f93-3055-4b6d-a750-ea23a46b4983	9d6b3f93-34e0-48a0-afbe-35b928b81ca6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1661}	2024-11-05 15:45:36
17924	9d65b416-1f61-41f8-a1cd-cf0f0e3b8259	9d65b416-2334-4141-a4f7-59224784473d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":855}	2024-11-02 21:36:26
31371	9d694b08-5497-4358-bfa4-f3eeeeac47e5	9d694b08-5867-433e-a034-bb8c8eeb093c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1498}	2024-11-04 16:25:59
681	9d4f2df7-1148-4975-a172-37f02e086851	9d4f2df7-160b-4298-acd5-29264b369787	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":49}	2024-10-22 16:53:11
9578	9d53b6ba-fab4-40bc-b3aa-6927a49d1cc0	9d53b6bb-bc32-40f6-98d2-fff99a782352	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":454}	2024-10-24 22:58:55
31648	9d695388-e8fc-48b5-8ab5-5066b524794c	9d695388-ec87-48e7-9314-d2c413cdba68	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1515}	2024-11-04 16:49:46
26072	9d68cd52-dce8-4f0a-bdee-dfef4c364639	9d68cd52-e36f-475d-bd61-c54eca3dd5b3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1205}	2024-11-04 10:34:29
15425	9d5ed226-9a81-4547-9644-bc1de54802f0	9d5ed226-9e47-4bcd-89b0-549dc528e6ef	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":703}	2024-10-30 11:29:42
21762	9d673e27-b8da-40aa-92f1-0c82313f2d46	9d673e27-bbf1-411d-ac8b-38b36b830e13	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1049}	2024-11-03 15:58:19
12347	9d5ce2c8-71de-41a1-aa00-eb4b6c024c85	9d5ce2c8-7537-41b5-a01f-00573d955ace	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":595}	2024-10-29 12:24:33
26062	9d68cd50-a09f-434b-a924-af7794f4caf8	9d68cd50-a4c7-456a-be2e-ced36e7c5f78	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1204}	2024-11-04 10:34:27
38288	9d6b61d8-9f6d-43e9-8a4d-1e14a7afdfa5	9d6b61d8-a5f3-4cfc-8f46-a88b6331deac	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1720}	2024-11-05 17:21:26
19395	9d66d605-1427-4267-9adc-8636e33ba163	9d66d605-16d2-47e3-b6d6-fc1e7f235692	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":952}	2024-11-03 11:07:08
38357	9d6b6373-3298-4cc3-8c79-6ef16608884a	9d6b6373-368c-4167-be8d-a180c88362b3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1723}	2024-11-05 17:25:55
41909	9d6cd0fa-3c6e-4197-a1d8-7c3aab484fbd	9d6cd0fa-4030-492f-91ed-a8ddced3fb34	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1943}	2024-11-06 10:28:00
31451	9d694c37-a74d-4869-9d12-6a054f3df3cd	9d694c37-abf1-491b-b258-5dbe2e9f9470	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1503}	2024-11-04 16:29:18
38653	9d6b6b0c-cea9-4dba-ae7c-6d7866034f71	9d6b6b0c-d3e7-4411-a995-ce3543474d9f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1735}	2024-11-05 17:47:10
31084	9d6945e5-1b9b-42da-8211-3578a797ed40	9d6945e5-1ee9-411e-8b56-90e9e34e8b58	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1479}	2024-11-04 16:11:37
21917	9d674108-206f-4759-805c-3915927c770d	9d674108-2352-44ad-805c-3a1b9e7bfa76	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1051}	2024-11-03 16:06:22
10529	9d570f41-33bf-47f5-949f-acba980a4bd9	9d570f41-380d-4a6c-bd1e-41ff1acf1903	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":523}	2024-10-26 14:53:56
14602	9d5ebec9-3529-4704-a5fb-3faee8ab8bd0	9d5ebec9-3abe-4292-8946-d83593b800ff	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":668}	2024-10-30 10:35:33
17811	9d65aef6-ac42-462f-96e5-4d725218e9e8	9d65aef6-b04a-4d19-b824-638172a058bb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":850}	2024-11-02 21:22:06
18633	9d669798-f6e4-453c-8316-19a83dc5e34c	9d669798-faba-4352-8fef-b2205c837928	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":898}	2024-11-03 08:12:36
36269	9d6b33e0-481f-40f8-9dfa-6df6a93291cd	9d6b33e0-4c1f-4aae-89b4-a01949086dd4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1640}	2024-11-05 15:12:53
14062	9d5d153f-577b-4841-9cb1-e0c0bd5d91ce	9d5d153f-5f08-4a50-bd1e-490bf55d97cc	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":647}	2024-10-29 14:45:39
4525	9d5131d2-1389-4c0e-b1b6-dd1729527890	9d5131d2-1921-43f3-962e-f020f6bcf61e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":247}	2024-10-23 16:55:37
39826	9d6cb6b9-2fc2-4a39-a07f-8bce3b1065cf	9d6cb6b9-332a-47ad-84b1-15a8af79cb0d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1781}	2024-11-06 09:14:36
2507	9d50fa03-243d-4402-a7c5-2e151c6fda4b	9d50fa03-2838-48f3-b3d2-c54ae28601cc	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":142}	2024-10-23 14:19:34
29962	9d692d72-13d5-4a8f-b48a-46e6a3953feb	9d692d72-171f-48f9-b006-8d8a32b8032b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1422}	2024-11-04 15:03:15
493	9d4f29d2-fa62-4a10-b7ae-e9501543b654	9d4f29d2-fd4c-4a68-9558-0ddb14daa6e1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":34}	2024-10-22 16:41:36
1152	9d4fc28b-a437-4982-9e21-91887d792d3c	9d4fc28b-ac5d-4751-9d6f-55db696bc087	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":88}	2024-10-22 23:48:39
12906	9d5cee6c-e3aa-4fde-9e7c-d603785bace3	9d5cee6c-e702-4fb3-b11f-7479c490664c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":612}	2024-10-29 12:57:06
39380	9d6bd091-6f7f-4024-a06d-4fd9025f1147	9d6bd091-7387-4286-97f6-d53e2581e28f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1753}	2024-11-05 22:31:02
40826	9d6cc7aa-0d1b-449f-9898-1697d0bec6a6	9d6cc7aa-0ff8-403e-9bea-890d3f0f76dd	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1858}	2024-11-06 10:01:58
43437	9d6cea00-e351-487b-a311-aa47b83229c7	9d6cea00-e790-4ad6-8a87-d6e0e3e24163	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2025}	2024-11-06 11:37:59
25067	9d68bfa8-3e09-446f-808d-3b0b2df965cc	9d68bfa8-4506-47a2-b738-8475d58c91c8	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1141}	2024-11-04 09:56:16
3327	9d510482-9a52-4a5d-b890-231a7d1b0e32	9d510482-a03f-4cd3-997e-85738a5a6aa0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":187}	2024-10-23 14:48:55
7590	9d52df6e-f9c2-4691-8b60-e6f24ee34327	9d52df6e-fed4-464a-9478-ecbde2e9f0c9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":378}	2024-10-24 12:56:54
20073	9d66edf7-d2c7-4114-87e5-3b1b7f139c93	9d66edf7-d63b-4d16-9355-f609d3929858	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":992}	2024-11-03 12:14:06
10295	9d56cd48-bea8-4af4-b667-ed004cc532c7	9d56cd48-c2ae-4fbf-b3da-5715b5319758	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":505}	2024-10-26 11:49:28
24791	9d68bd47-5928-444a-b261-578644092cfe	9d68bd47-5faa-464f-8065-1199fc41cb01	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1125}	2024-11-04 09:49:37
20256	9d66f0d1-d31d-458d-a7e1-851d4fdeb81b	9d66f0d1-d66b-4ac3-bc0c-2b5a9bce3347	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1003}	2024-11-03 12:22:05
40516	9d6cc42a-27fd-44da-b59a-10021d836ea6	9d6cc42a-2c12-4b21-bb18-e2760f0abae3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1821}	2024-11-06 09:52:11
31261	9d69494c-6abc-44d7-86f4-32826210a44c	9d69494c-6e15-4aa9-96d7-ff32f9c1850b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1486}	2024-11-04 16:21:08
475	9d4f2944-1c33-4ac1-9e67-9bf162ff1aee	9d4f2944-1fb8-4188-956a-82ba6aa4b71e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":46},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":32}	2024-10-22 16:40:03
20451	9d66f3f7-86b9-42ee-b589-a74bab6d6007	9d66f3f7-8ad9-456c-9296-7ff9f84194e1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1016}	2024-11-03 12:30:53
22019	9d674171-1132-4006-afe3-1088d0de6af0	9d674171-1436-4f2a-a05c-e9b59634ae18	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1057}	2024-11-03 16:07:31
38063	9d6b5f0e-dcfd-4ec0-af9e-773b3df1790d	9d6b5f0e-e1fa-4e5c-99c0-f35ec56665b5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1710}	2024-11-05 17:13:38
29933	9d692c26-f2d8-4c12-8fd5-f3736dba7640	9d692c26-f604-41c6-95cd-36bc629257d5	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1420}	2024-11-04 14:59:38
18059	9d65b707-9b92-40a3-b270-f5b863bd8efd	9d65b707-9e7b-4803-9dcc-2d1ad612a1d2	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":864}	2024-11-02 21:44:39
1413	9d50d0d8-ced6-4e7d-b214-65c9ad53b470	9d50d0d8-d1a7-44fb-be40-2d692847d129	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":101}	2024-10-23 12:24:28
41733	9d6ccf00-5214-4ad4-a562-678acfdc1aaf	9d6ccf00-5552-4a37-a0f9-b15f5153546d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1923}	2024-11-06 10:22:29
41931	9d6cd12f-5585-40e7-a2ff-4c05846d4993	9d6cd12f-58fd-45a2-a49b-3bf5e58b7b01	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1945}	2024-11-06 10:28:35
28149	9d68fe6b-8981-4a54-b397-5987490bd6e5	9d68fe6b-8ef3-44c8-a896-ae0a4b48e36d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1312}	2024-11-04 12:51:46
34940	9d69c11b-f02f-4faa-900c-dfb007a20626	9d69c11b-f461-40be-aa95-65c459516cb4	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1580}	2024-11-04 21:56:09
43144	9d6ce51b-14c0-4375-aed7-c460b5402e67	9d6ce51b-17e6-418e-a24a-88595a34d535	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1993}	2024-11-06 11:24:17
36839	9d6b40f8-1f3d-4d0e-9f43-850911745226	9d6b40f8-22c8-40d8-8605-23d3ed435dbb	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1665}	2024-11-05 15:49:30
20436	9d66f32a-46a2-4dc3-a167-fefd53a05a2a	9d66f32a-4a6e-4513-b8d2-b1c0434fdb75	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1015}	2024-11-03 12:28:38
27748	9d68e956-2f11-4bf4-ba07-229c828f94bc	9d68e956-3214-4ac0-b027-b438823020c0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1293}	2024-11-04 11:52:48
24821	9d68bd6a-b704-4a84-92af-15deee786fc3	9d68bd6a-bda3-4340-ae53-c8f134712dab	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1127}	2024-11-04 09:50:00
7996	9d52e5c8-d41c-4ebb-a3fc-01412be77ceb	9d52e5c8-d8d2-41a5-bdc2-ae1ecdd93c66	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":393}	2024-10-24 13:14:40
25454	9d68c2f3-a4dd-4aea-81a8-a55cd28faa46	9d68c2f3-aa63-4058-abb3-38a3aa867727	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1163}	2024-11-04 10:05:29
18616	9d6696f5-01df-4bbe-a541-9d101746b315	9d6696f5-0702-4417-83ab-d412296e5615	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":895}	2024-11-03 08:10:48
10334	9d56cd88-e697-4c7f-acf3-c089f6e9609c	9d56cd88-e94a-4fc6-a166-b16164ec37c0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":508}	2024-10-26 11:50:10
37888	9d6b5d7e-07aa-4760-8b02-7881a8120a25	9d6b5d7e-0ac7-46ea-aca5-f5a8f30886cf	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1702}	2024-11-05 17:09:16
19664	9d66e35a-6752-41cc-9c71-b414759ac561	9d66e35a-6bf1-4df2-84fd-86733c37ac08	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":968}	2024-11-03 11:44:25
30218	9d6936ff-02cf-449d-88f6-778a55958ec3	9d6936ff-08b9-47e2-a7a6-1e2d3a84f9ff	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1439}	2024-11-04 15:29:58
2083	9d50e354-3afe-4b2a-a447-7c2716bdeb5b	9d50e354-3eab-4d8e-8365-a8df1c4e5d62	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":126}	2024-10-23 13:16:08
36361	9d6b38e2-b50c-4b25-a637-86ee23774284	9d6b38e2-b931-4f27-8c85-2f69f5fd797c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1644}	2024-11-05 15:26:54
20421	9d66f2ed-ff69-42d2-bab2-84106ff6de36	9d66f2ee-03ce-4ac2-bd66-0783c824db45	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1014}	2024-11-03 12:27:59
6596	9d52d33e-4202-4fb2-b9d0-e96b7e70c7c9	9d52d33e-4492-40ea-93f9-d81da10d762e	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":340}	2024-10-24 12:22:49
15833	9d64b0cd-2183-4fb5-a55c-525a3bc07305	9d64b0cd-245a-44c2-a13c-7811929a098c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":725}	2024-11-02 09:31:25
38334	9d6b62d3-70cd-4939-aa33-25c8cdf300ee	9d6b62d3-738d-4f75-821b-184d85eec4d1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1722}	2024-11-05 17:24:10
29991	9d692db3-a42b-4b5d-9052-41bd5c7bd076	9d692db3-a739-449e-bbe5-eb2a0ac84ef0	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1424}	2024-11-04 15:03:58
20644	9d66f941-abe4-4b8a-8796-3bde584f87a1	9d66f941-b086-4f84-9a9d-acfced730758	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1023}	2024-11-03 12:45:40
29885	9d692c06-45bb-445d-871d-5248947557ce	9d692c06-4b5f-4e4d-b5cb-8047f1894b05	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1417}	2024-11-04 14:59:17
29273	9d691414-d711-42fe-ac38-5e42b003ad91	9d691414-dca1-4d00-b3a5-1fbca92d1d3b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1372}	2024-11-04 13:52:20
2054	9d50e314-0e6a-48c5-a7e5-af48dd773c69	9d50e314-114b-43e7-b88d-b2ef1a6f020b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":125}	2024-10-23 13:15:26
18685	9d6699a2-04e6-433a-9709-3c0e048bd2b0	9d6699a2-08c3-4142-87af-8d461ba5dd30	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":902}	2024-11-03 08:18:17
13915	9d5d13d7-6196-4ef2-9fe7-55f3b9019bc8	9d5d13d7-66c9-405c-b33f-2d21a97948e9	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":644}	2024-10-29 14:41:44
2677	9d50fb23-901c-4cf7-a447-2042bf682283	9d50fb23-9323-4ddc-ae59-e129191298db	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":152}	2024-10-23 14:22:43
28046	9d68eb61-3512-46c4-8c1d-b18c7fc30a61	9d68eb61-3900-456d-a29b-896ec75733f1	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1307}	2024-11-04 11:58:31
29330	9d69188f-4623-44c1-a17a-acd17be0da0c	9d69188f-49d8-400d-bd99-e9aa00faa42d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1376}	2024-11-04 14:04:51
30570	9d693ff9-60c2-4da8-ab57-9916dc64a97c	9d693ff9-6398-4a8c-ad7a-02f32fd7f4ff	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1458}	2024-11-04 15:55:04
32057	9d695882-28bb-492c-8bc3-d02abe7bd424	9d695882-2df8-4996-913b-5696a14513e3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1533}	2024-11-04 17:03:40
11408	9d5cbdf7-ebae-4f7c-b6ef-ca3e95afd2dd	9d5cbdf7-ee54-4ff1-b91d-5e6f7bac381a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":573}	2024-10-29 10:41:36
22575	9d67e3d1-4f7b-4d2c-9156-83ac21baf0b6	9d67e3d1-5857-45ed-8d4a-3cd7f31bff12	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1083}	2024-11-03 23:41:33
25982	9d68cc28-c947-47db-ac07-7437ecf4ac35	9d68cc28-d32c-4335-a800-4aff5fef8678	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1199}	2024-11-04 10:31:13
25972	9d68cc26-dc6a-4dc6-bd14-81eed254367c	9d68cc26-dfa2-4903-8d7c-4168c398b704	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1198}	2024-11-04 10:31:12
17067	9d654928-4ad4-49df-98cf-06b3b5b8665a	9d654928-4e63-407f-b234-b151fb1cbaa6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":806}	2024-11-02 16:37:26
14286	9d5d195e-16d3-43b7-bd86-23732735b2b9	9d5d195e-1c45-4a50-bb05-5f6ebac91e45	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":653}	2024-10-29 14:57:11
9195	9d52f59d-1c62-4b15-822f-549fe0ba5300	9d52f59d-21e4-43db-82ab-fc7abc7e80d7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":440}	2024-10-24 13:58:55
9247	9d52f688-7bbf-4d1a-af1d-638c60a2aa43	9d52f688-7f86-4dc1-919e-368809427b6f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":442}	2024-10-24 14:01:30
21951	9d674148-4f67-474f-b2b4-988a4a97461a	9d674148-53f4-4f83-80fa-78ae6457321d	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1053}	2024-11-03 16:07:04
7866	9d52e27b-3586-40e9-a137-3863c9440a89	9d52e27b-395b-4c7e-9077-08e801db5c1c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":388}	2024-10-24 13:05:26
11383	9d5cbdd6-7fba-4195-978e-db330e2a4f08	9d5cbdd6-835f-4328-8f80-c21b8cc1774c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":571}	2024-10-29 10:41:15
43466	9d6cea04-bcec-45bf-bf45-723c337b36aa	9d6cea04-bf69-4250-9c1c-c6f7e7c1405b	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2031}	2024-11-06 11:38:02
6929	9d52d81c-81ea-46df-9875-408f61d46781	9d52d81c-8819-4b77-82c7-dd13fba6c77f	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardControlador.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":352}	2024-10-24 12:36:26
12645	9d5cec87-7239-4634-b92f-2c9dfedd4f3c	9d5cec87-76a8-4575-ab83-aca5138b5ce7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":604}	2024-10-29 12:51:48
43299	9d6ce5d3-ca11-4938-a4b7-9526e6657644	9d6ce5d3-cd34-4101-b073-19b2580aabf3	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2011}	2024-11-06 11:26:18
43474	9d6cea06-1a91-4bcc-9f30-9183c3a90a05	9d6cea06-1d0c-4ebc-927f-c321565e9f31	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2033}	2024-11-06 11:38:02
15611	9d648f3a-a806-4fa3-8334-9739950209a2	9d648f3a-ab6c-483d-805c-0c5bb1bda7f7	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":712}	2024-11-02 07:57:32
27381	9d68e449-8ab8-4b87-ba21-51b983d82eea	9d68e449-8e3d-4f86-ac93-03d53a3bcb21	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":1277}	2024-11-04 11:38:41
43486	9d6cea07-b09e-4a10-9747-793d6beb9615	9d6cea07-b315-41ee-8a7f-401b0e01e36c	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2036}	2024-11-06 11:38:04
43490	9d6cea08-3684-4754-8563-8005a46a99d8	9d6cea08-391c-416c-83dc-79c4cd775eb6	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2037}	2024-11-06 11:38:04
43341	9d6ce5ec-4682-409d-be69-aa34d8ed4afb	9d6ce5ec-497e-46ba-9542-7cfaf1f244ee	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[22P02]: Invalid text representation: 7 ERROR:  la sintaxis de entrada no es v\\u00e1lida para tipo bigint: \\u00abundefined\\u00bb\\nCONTEXT:  portal sin nombre, par\\u00e1metro 1 = '...' (Connection: pgsql, SQL: select \\"menu\\".\\"id\\", \\"menu\\".\\"menu_name\\", \\"menu\\".\\"menu_url\\" from \\"menu\\" inner join \\"item_menu\\" on \\"menu\\".\\"id\\" = \\"item_menu\\".\\"item_menu_menu\\" where \\"item_menu\\".\\"item_menu_profile\\" = undefined and \\"menu\\".\\"deleted_at\\" is null order by \\"menu\\".\\"menu_orden\\" asc)","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2913},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2902},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":3456},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Query\\\\Builder.php","line":2901},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":739},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Eloquent\\\\Builder.php","line":723},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\dashboard\\\\DashboardController.php","line":47},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2015}	2024-11-06 11:26:34
43494	9d6cea08-d9e6-463b-95bd-833b17cc4300	9d6cea08-dc74-4cdb-aae3-f751c938861a	2a264fcdf6fd1718cdcd261a25d8dc04	f	exception	{"class":"Illuminate\\\\Database\\\\QueryException","file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":829,"message":"SQLSTATE[42703]: Undefined column: 7 ERROR:  no existe la columna \\u00abundefined\\u00bb\\nLINE 5: ...                       WHERE users.profile_code = undefined;\\n                                                             ^ (Connection: pgsql, SQL: \\n                     SELECT users.name, users.user_alias, profile.profile_name\\n                        FROM users\\n                        INNER JOIN profile ON users.profile_code = profile.id\\n                        WHERE users.profile_code = undefined;\\n                            )","context":null,"trace":[{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":783},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\Connection.php","line":414},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Database\\\\DatabaseManager.php","line":509},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Support\\\\Facades\\\\Facade.php","line":355},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\app\\\\Http\\\\Controllers\\\\Api\\\\V1\\\\users\\\\UsersController.php","line":127},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Controller.php","line":54},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\ControllerDispatcher.php","line":43},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":259},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Route.php","line":205},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":806},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\SubstituteBindings.php","line":50},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":159},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":125},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Middleware\\\\ThrottleRequests.php","line":87},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":805},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":784},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":748},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Routing\\\\Router.php","line":737},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":200},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ConvertEmptyStringsToNull.php","line":31},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TransformsRequest.php","line":21},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\TrimStrings.php","line":40},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\ValidatePostSize.php","line":27},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Middleware\\\\PreventRequestsDuringMaintenance.php","line":99},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\HandleCors.php","line":62},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Http\\\\Middleware\\\\TrustProxies.php","line":39},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":183},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Pipeline\\\\Pipeline.php","line":119},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":175},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\Http\\\\Kernel.php","line":144},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\public\\\\index.php","line":51},{"file":"C:\\\\Users\\\\ederc\\\\Music\\\\gotas\\\\back-prestamos\\\\vendor\\\\laravel\\\\framework\\\\src\\\\Illuminate\\\\Foundation\\\\resources\\\\server.php","line":16}],"line_preview":{"820":"        \\/\\/ message to include the bindings with SQL, which will make this exception a","821":"        \\/\\/ lot more helpful to the developer instead of just the database's errors.","822":"        catch (Exception $e) {","823":"            if ($this->isUniqueConstraintError($e)) {","824":"                throw new UniqueConstraintViolationException(","825":"                    $this->getName(), $query, $this->prepareBindings($bindings), $e","826":"                );","827":"            }","828":"","829":"            throw new QueryException(","830":"                $this->getName(), $query, $this->prepareBindings($bindings), $e","831":"            );","832":"        }","833":"    }","834":"","835":"    \\/**","836":"     * Determine if the given database exception was caused by a unique constraint violation.","837":"     *","838":"     * @param  \\\\Exception  $exception","839":"     * @return bool"},"hostname":"EderCortes","occurrences":2038}	2024-11-06 11:38:04
\.


--
-- Data for Name: telescope_entries_tags; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.telescope_entries_tags (entry_uuid, tag) FROM stdin;
9d4cf5a6-3b1b-4aca-827e-e60dda842657	slow
9d4cf5a6-4248-44df-ba9f-fe394141f523	App\\Models\\User:10
9d4d2647-cdf7-418b-8675-8214af0da350	App\\Models\\User
9d4d276e-c209-4e0b-8674-fb7742b80ce4	App\\Models\\User:11
9d4d2792-a07b-4f72-a2e6-0cd8a7266512	App\\Models\\User
9d4d2792-f032-409e-9896-afa073b8e5f8	Laravel\\Sanctum\\PersonalAccessToken:1
9d4d2857-5d4f-487e-9260-b5d8a3c086dd	App\\Models\\User
9d4d2857-7755-4b2c-ba97-2f6a5cb815ae	Laravel\\Sanctum\\PersonalAccessToken:2
9d4d2a3f-2b8c-4b19-b28f-edc280917c8f	slow
9d4d2a3f-2c00-45de-8b79-f779c247ae45	App\\Models\\User
9d4d2a3f-47ae-4068-8c11-de9f7f15efd9	Laravel\\Sanctum\\PersonalAccessToken:3
9d4d2a8e-5a49-4d0e-ba6a-e21df52455c5	App\\Models\\User
9d4d2a8e-735b-4554-b1af-1a82337d174c	Laravel\\Sanctum\\PersonalAccessToken:4
9d4d313d-2d5b-4352-942d-5f593d4ed572	slow
9d4d313d-2df8-4275-9085-c943231b663e	App\\Models\\User:12
9d4d317b-b110-47f2-b577-fcaae1b709bf	App\\Models\\User
9d4d33d3-3ece-43bc-a59f-e7a6834ca221	App\\Models\\User
9d4e5c64-483b-4ad5-b1b3-fc73afd8fad2	App\\Models\\User
9d4e69e4-3bf7-4708-840f-939fb78e660b	App\\Models\\User
9d4e69e7-2f09-458f-8751-cdfecfad187b	App\\Models\\User
9d4e750e-5f5d-4743-af1a-21589fa36c0e	App\\Models\\User
9d4e76ba-1c02-43a5-97e9-05af2b294357	App\\Models\\User
9d4f0b0d-ea6b-44e8-9475-ba4b046581e8	App\\Models\\User
9d4f0b5c-d9db-44f2-906e-1daadea719b7	App\\Models\\User
9d4f0baa-bb36-4e90-aae4-9ff118187d06	slow
9d4f0baa-bbb1-42b0-a653-71fecf9e0e14	App\\Models\\User
9d4f0bdf-acf9-49bd-9288-01680eefde6e	App\\Models\\User
9d4f0c29-d522-4756-b087-e7bde326d330	App\\Models\\User
9d4f105a-e433-4338-9509-e74de6fd215d	slow
9d4f105a-e4b7-46d9-b05e-68c809dba935	App\\Models\\User
9d4f1358-8a86-48f8-bdc8-707c5fe02d03	slow
9d4f167a-dfca-4060-b132-48e95ac66d0a	slow
9d4f1a04-9f59-4d8e-827a-2b628db4fe51	slow
9d4f1a04-9fda-44cf-9956-441e10a0d3a4	App\\Models\\Menu
9d4f1e18-0b38-49e0-8efa-6a3a4586f1b1	slow
9d4f1e18-0bb4-4b06-8b05-81cb1798455a	App\\Models\\Menu
9d4f22f1-c981-4d3f-aa38-5aa22a3cee03	slow
9d4f22f1-c9fb-4e73-9cf6-bb733d1328f5	App\\Models\\Menu
9d4f2389-9268-4704-94e0-caca04e2152e	App\\Models\\Menu
9d4f238e-2e81-4487-a07f-a020342e5604	App\\Models\\Menu
9d4f2399-5b54-4d4a-9819-a401cabefba6	slow
9d4f2399-5bb7-4f3d-b70d-606798c1b3d2	App\\Models\\Menu
9d4f23c9-9727-42ab-9709-8063f90f3948	App\\Models\\Menu
9d4f23da-2b25-4c34-bdcc-8d7da7151a72	App\\Models\\Menu
9d4f2408-ff22-43d5-9727-1a8d9992eff4	slow
9d4f2408-ff72-4d2d-b577-3429921926e0	App\\Models\\Menu
9d4f2423-26ea-4362-910c-f1fb7595c8dd	slow
9d4f2423-274b-49e9-899b-57d67614effb	App\\Models\\Menu
9d4f242d-ba2f-42ab-8155-e10431bc99bf	App\\Models\\Menu
9d4f2471-6c19-4d16-9d4d-7d872c004c5a	App\\Models\\Menu
9d4f2582-e5c0-451f-89fd-0203dbcb890b	App\\Models\\Menu
9d4f2597-b60f-42a1-ba2d-5634d4e20d9c	App\\Models\\Menu
9d4f26c1-f4ce-4fad-bba3-5e6192623380	App\\Models\\Menu
9d4f26e5-397f-4d3a-bf0c-41c2424a3109	slow
9d4f26e5-39cf-4d66-9cea-516a71a88d98	App\\Models\\Menu
9d4f26f3-1bc4-47bc-afb0-8ea9ca282035	slow
9d4f26f3-1c12-4fbe-a067-3bf73d83979d	App\\Models\\Menu
9d4f2738-de62-4a11-ae9c-2a5c847aa88a	App\\Models\\Menu
9d4f278e-e38e-48c3-a330-3aac86e1def7	App\\Models\\Menu
9d4f279b-1940-4da0-86ef-e1af4c8e12ac	slow
9d4f279b-199c-4abd-a8b5-a3f84f4cb4ae	App\\Models\\Menu
9d4f27b3-5ca6-4566-bae0-c827958fee19	App\\Models\\Menu
9d4f27b4-d9e3-4d86-aa0b-b3476d804835	App\\Models\\Menu
9d4f2820-93b8-4804-be2c-f3ff050653f6	App\\Models\\Menu
9d4f2822-7416-41b9-8612-e6d311b0be7b	App\\Models\\Menu
9d4f284e-625a-464a-8279-a9b64d631f24	App\\Models\\Menu
9d4f28fc-8b07-4b71-aa46-5e725bc2e6a1	App\\Models\\Menu
9d4f290d-d305-4036-8d6c-8d0bb0e48382	App\\Models\\Menu
9d4f2920-f90c-4f40-9036-b921b5dd61f3	slow
9d4f2920-f96a-4517-aae9-355ae61be49e	App\\Models\\Menu
9d4f2936-170e-4e02-b4f9-a73110c156e2	slow
9d4f2936-176d-4aa7-80dd-78991ddb3781	App\\Models\\Menu
9d4f2945-db95-4b39-9b23-f6edc1e4719f	App\\Models\\Menu
9d4f29c4-bae8-472f-922d-0f930d4d8dde	slow
9d4f29c4-bb58-42c6-853e-a4956c1e1cc5	App\\Models\\Menu
9d4f29d4-9337-43b8-80dd-58fffbc5094b	App\\Models\\Menu
9d4f29e7-254e-4912-bcbe-2aac2f05a0d7	App\\Models\\Menu
9d4f29f5-fa22-4244-b7e2-926209fa6a2f	App\\Models\\Menu
9d4f2a04-7eee-4350-a00f-fe6b5e77e61d	App\\Models\\Menu
9d4f2a73-d107-40da-9f22-bf6587d19abd	App\\Models\\Menu
9d4f2b0d-1a7c-432b-abe3-1787d49c3eb7	App\\Models\\User:14
9d4f2b67-0292-4752-8b66-8f9851c0262b	App\\Models\\User:18
9d4f2c5c-dc84-45ed-96c5-ee9d319294f7	App\\Models\\Menu
9d4f2cc4-88a9-49ad-b557-e766d783f5b3	slow
9d4f2cc4-892a-4afe-a47f-1bc7e2e91a59	App\\Models\\Menu
9d4f2ced-eeee-476b-8067-7a8e0820e78c	App\\Models\\User
9d4f2cef-8151-469c-b293-c19d3c48576d	App\\Models\\Menu
9d4f2d2c-3d2d-408b-828b-128e037eebb7	App\\Models\\User
9d4f2d2e-5734-4f54-b08a-d89564131d71	App\\Models\\Menu
9d4f2d6a-412e-41a7-b0e2-53f7cdb5898f	App\\Models\\User
9d4f2d6b-edf3-47ad-8d16-69fad29bc24a	App\\Models\\Menu
9d4f2d7c-e62b-4582-86b1-83c5475e035d	App\\Models\\User
9d4f2d7e-d743-4db2-9a41-722fea0c2d84	App\\Models\\Menu
9d4f2d8d-ef98-4a49-a675-beb7e8dd716d	App\\Models\\User
9d4f2d8f-ba75-4f1a-a958-862706903338	App\\Models\\Menu
9d4f2d9e-0850-412e-9c1f-289bf863fc90	App\\Models\\User
9d4f2d9f-f348-4119-8c27-bd5736d771e9	App\\Models\\Menu
9d4f2dae-5527-453f-be0f-e2addfc04e0d	App\\Models\\User
9d4f2db0-0749-471f-8deb-97dcfa3abcdc	slow
9d4f2db0-07a2-4263-88d6-bba880e007cb	App\\Models\\Menu
9d4f2df7-9296-4335-bdca-3a8ef3844938	App\\Models\\User
9d4f2dfa-4f2b-4f72-ae15-342f6f54ab86	slow
9d4f2dfa-4fa0-4d97-ae76-93b7ca15fb4d	App\\Models\\Menu
9d4f2e0a-761e-4084-9293-7bc97f8b7846	App\\Models\\User
9d4f2e0c-922e-40e3-a623-d31479d3e474	App\\Models\\Menu
9d4f2e23-3844-4fb7-8065-8ee784335ad7	App\\Models\\User
9d4f2e25-2e48-43ad-980a-c18c7516540c	App\\Models\\Menu
9d4f2e4f-1194-40da-9bd2-f2533e11a2f3	App\\Models\\User
9d4f2e50-96b7-410a-b02a-423fc11b84c1	App\\Models\\Menu
9d4f2e5e-a9d2-4b2c-99dc-5c0537c5a8a7	App\\Models\\User
9d4f2e60-5b57-42cc-a9fb-943fd04bd977	App\\Models\\Menu
9d4f2e81-aaa7-4da9-8322-4782628cd058	App\\Models\\User
9d4f2e83-3ed0-4074-ab28-a6da111a9ba7	App\\Models\\Menu
9d4f2e94-c171-4435-bb3b-f6310a1f693d	slow
9d4f2e94-c1c2-48d7-9097-16f3c9706d41	App\\Models\\User
9d4f2e96-8089-4e89-8210-670b2c9cde37	App\\Models\\Menu
9d4f2efa-2fb3-44da-9267-ba0dee298c45	App\\Models\\User
9d4f2efc-4600-4ea3-a66c-6630a60c237c	App\\Models\\Menu
9d4f2f27-53bc-4ac1-9d70-afe0f026e899	slow
9d4f2f27-540b-483d-866b-b67c23010577	App\\Models\\User
9d4f2f28-9609-441b-9299-4d0163b35cdc	App\\Models\\Menu
9d4f3107-f01f-4ce5-affa-43be199933aa	App\\Models\\Menu
9d4f311d-8c6c-4aaf-ac5b-a565634d2925	App\\Models\\User
9d4f3121-d2ac-40d8-b036-4f305d00f6a5	slow
9d4f3121-d30c-45c8-9f04-56fd80c1cc89	App\\Models\\Menu
9d4f31f2-fc14-4eb4-a8da-625d9b0c97c9	App\\Models\\Menu
9d4f320d-3c1c-4998-ace5-70865954fe87	slow
9d4f320d-3c99-4795-953f-868fb2f57fb6	App\\Models\\Menu
9d4f3219-cc04-4c55-8626-b5a32df4ad21	App\\Models\\User
9d4f3299-89b7-4c02-90a0-9cc7b6869981	App\\Models\\Menu
9d4f3365-2f21-4916-91c4-c59522e5b48d	App\\Models\\Menu
9d4f3377-8e09-4595-a63b-911717adb0fa	slow
9d4f3377-8e6f-47c9-958c-6a2c30db2d22	App\\Models\\User
9d4f3388-4bbc-4580-82e8-47f33d97ef4b	App\\Models\\User
9d4f33ef-b398-4fd4-b678-814e46f92194	slow
9d4f33ef-b413-401f-a4ef-2438e5b0905d	App\\Models\\Menu
9d4f33fb-7a56-43c4-9fa0-a9ae52246c40	App\\Models\\Menu
9d4f3482-f557-4136-8fcf-4ee2d3480dd9	App\\Models\\Menu
9d4f349a-a9f8-4c96-a41d-c5e94ae4d4f5	App\\Models\\Menu
9d4f38b6-50fe-4595-a527-60b30ec2fe87	App\\Models\\Menu
9d4f38bf-cfa2-431f-a210-479c04b95f59	App\\Models\\Menu
9d4f396b-c418-4844-91b1-2ef3224f061b	slow
9d4f396b-c487-499c-890f-046dec6a0106	App\\Models\\Menu
9d4f39e8-6811-4dc1-b201-f9c34850cd48	slow
9d4f39e8-68a8-44de-a3d4-93c001a7046d	App\\Models\\Menu
9d4f3b76-e33e-42fb-b143-46710dd6cb3d	slow
9d4f3b76-e3cd-4d94-8175-20b390869fb4	App\\Models\\Menu
9d4f3b9c-33ca-4eb4-9ae1-3edebe0f0618	slow
9d4f3b9c-345c-47cd-99d8-b8bbc54494f9	App\\Models\\Menu
9d4f3be0-b01a-43ea-acba-c2f6f4265889	App\\Models\\Menu
9d4f3be1-2884-4984-81a7-2f276693216a	App\\Models\\User
9d4f3be1-9d59-4223-8be5-b1cebe2896ab	App\\Models\\User
9d4f3cf0-28ff-4e1f-a85d-b1cc1122b147	App\\Models\\User
9d4f3cf0-f6e4-4fe3-88dd-5a70611891ad	App\\Models\\User
9d4f3cf3-2652-44e8-a85d-a75581f8503b	App\\Models\\Menu
9d4f3de5-c8a9-4b77-8090-9f0af6571737	App\\Models\\User
9d4f3de6-47f4-4338-a73f-9140cc7ad168	App\\Models\\User
9d4f3de7-bb4d-4fa2-9eef-dbebc55ebf0c	App\\Models\\User
9d4f3de8-547f-49ff-86ea-228820368fa7	slow
9d4f3de8-54df-477b-8bbb-9efaf9cf5ff2	App\\Models\\User
9d4f3dea-a2b8-4282-a4a4-674fcf87bb1a	slow
9d4f3dea-a312-436b-a193-83aae6635208	App\\Models\\Menu
9d4f3e6f-ae52-4a5e-b7a2-5aa60ee90846	App\\Models\\User
9d4f3e70-23f6-4ff7-b27f-448ea067484c	App\\Models\\User
9d4f3e71-0432-488c-b30c-70317aa7353a	App\\Models\\User
9d4f3e71-639d-4133-9afa-c3e414f1b147	App\\Models\\User
9d4f3e73-85c9-493e-b189-63dc2f8f879d	slow
9d4f3e73-8635-4c11-9b5b-e3d0a51a19dc	App\\Models\\Menu
9d4f3ed6-8177-4ea0-a062-a79f16eb8239	App\\Models\\User
9d4f3ed7-1ace-4925-a60d-b86c40ddbc30	slow
9d4f3ed7-1b36-4d36-88dc-b7da17c4bf0e	App\\Models\\User
9d4f3ed9-316e-4de4-8b21-f4fc17e7e42a	slow
9d4f3ed9-31bf-42a6-b295-2eeee8544bcf	App\\Models\\Menu
9d4f442d-7d8e-4137-803b-dfc269de76e1	App\\Models\\User
9d4f442e-1f42-460d-b9bf-49536aab8ec6	slow
9d4f442e-1f9d-433c-9d41-5ada7a7079e6	App\\Models\\User
9d4f4430-07c7-4d52-893f-89580bd10220	slow
9d4f4430-0841-4764-81f3-4c013f1e1f39	App\\Models\\Menu
9d4fbd1e-6ee0-4950-9fc8-dcec72a57eea	App\\Models\\User
9d4fbd1f-f92b-4274-8202-ed5e6d3acc9f	App\\Models\\User
9d4fbd21-d37c-4425-a4ef-dec6b8e0f57f	App\\Models\\Menu
9d4fc28c-7708-48d4-9c51-84fcb5f1ba33	App\\Models\\User
9d4fc28d-562b-47de-b16f-f89d061e122c	slow
9d4fc28d-56c3-49b8-b15f-b94ff417f0fb	App\\Models\\User
9d4fc28f-60b3-46f5-ba11-fbdbceb7df5b	App\\Models\\Menu
9d507da1-a0b5-4cc1-b5e0-954af40631f7	App\\Models\\User
9d507da2-add9-427e-acfa-e42d6446205e	App\\Models\\User
9d507da5-8206-4487-93d9-f640bfc4c41f	slow
9d507da5-828c-4cef-8b19-db790a05e03f	App\\Models\\Menu
9d507f02-ef1b-4845-801b-06fc7bb372a0	App\\Models\\User
9d507f05-eafa-4dec-a9b1-e3a8376df8b6	App\\Models\\User
9d50c531-16e3-4fcd-9c36-7412137c8d63	slow
9d50c531-1faa-4441-a21b-825a628522be	App\\Models\\Menu
9d50c535-c841-4696-ac1d-0ddccb942c43	App\\Models\\Menu
9d50c5e2-d6c8-4930-aeca-1784ac5bf4fe	App\\Models\\Menu
9d50c5f4-dcf5-4c71-8bd2-10ef6abc3f26	App\\Models\\User
9d50c604-9453-4540-b6f0-bc981f0bce9d	slow
9d50c604-94a0-496c-8a06-e98b6faf8815	App\\Models\\User
9d50c60f-363e-4020-a478-18de36dbcf80	App\\Models\\User
9d50c60f-95c0-4e5b-a81e-b0a92780d9a0	App\\Models\\User
9d50c6d1-5c0e-464f-bffe-2ae4757f605c	App\\Models\\User
9d50c6d1-f83a-46c6-b5c6-5d5bae78f166	slow
9d50c6d1-f890-4902-a7ef-08d2525918aa	App\\Models\\User
9d50c6d3-b78a-4b3a-9f8c-2b23cae8b763	App\\Models\\Menu
9d50c9bf-e22e-4395-984c-3085a3de338c	slow
9d50c9bf-e2f2-4434-8143-c46741065b88	App\\Models\\User
9d50c9c0-653e-459f-a8b9-0e40182d882c	App\\Models\\User
9d50c9c8-1869-4dff-bbfc-f0e3851f1150	App\\Models\\Menu
9d50cad7-2aa5-4c69-b6d0-171ceb69c072	slow
9d50cad7-2af0-4ca9-b2ef-d6f86df7b785	App\\Models\\User
9d50cad7-b76d-4662-9dfd-08bceab84113	slow
9d50cad7-b7b6-4ab7-a686-959e06533b9e	App\\Models\\User
9d50cad8-c55b-4422-80d2-72ac2e880651	slow
9d50cad8-c5d5-40bd-a280-0ee0e42eabb9	App\\Models\\User
9d50cad9-2550-4145-bc6d-6b190b62686a	App\\Models\\User
9d50cadb-0076-4d77-b212-4da9b7a99a8d	App\\Models\\Menu
9d50cb85-e7db-4570-b1e6-5ad21b39f7bc	App\\Models\\User
9d50cb86-8bfc-4c88-87dd-b557810c8c8d	slow
9d50cb86-8c63-4971-8aa1-cbfec96b7198	App\\Models\\User
9d50cb88-7502-4a16-9536-ea2f0ccdcfec	slow
9d50cb88-7560-42f9-b033-d91ff6cfeaf2	App\\Models\\Menu
9d50ccce-f485-44ec-81ff-911684bbb60a	slow
9d50ccce-f4d0-4a8c-abf0-410d95cb2bcf	App\\Models\\User
9d50cccf-6403-4472-9436-c6a118da7bd6	App\\Models\\User
9d50ccd1-247b-44da-9580-ac2749079796	App\\Models\\Menu
9d50cd0c-e7f9-4b1f-89af-886890912b54	App\\Models\\User
9d50cd0e-8647-4669-9837-e9d52089a66e	App\\Models\\Menu
9d50cf58-b32c-474c-bc4d-49a8980f1a8a	slow
9d50cf58-b3c7-4d45-b2c3-36f350e4e2f4	App\\Models\\User
9d50cf5d-1ee3-4441-97f4-e55d2146e922	slow
9d50cf5d-1f7a-4301-8b88-4a0991443dfb	App\\Models\\Menu
9d50d0a8-cabf-403e-af43-5ac34e13c051	App\\Models\\User
9d50d0ac-6c1a-43c7-a18e-2c2d10847219	slow
9d50d0ac-6c86-41ed-8db6-f35162bbf2a7	App\\Models\\Menu
9d50d0e0-9189-454b-b2d8-65d88acb56f1	App\\Models\\User
9d50d0e2-6d7a-45ba-b671-83e707d1946f	slow
9d50d0e2-6dd5-4a75-a3df-22e8dc881bff	App\\Models\\Menu
9d50d15c-b94a-4fd7-925d-a33e202ceb2b	App\\Models\\User
9d50d15e-66ca-4c6f-a92c-3f988fe43cfb	App\\Models\\Menu
9d50d223-f4f6-428e-ba3e-cf53e75d5bce	slow
9d50d223-f569-44ff-a2c7-7eaa793b3f34	App\\Models\\User
9d50d224-6f59-4ad6-b55e-2563e5f88373	App\\Models\\User
9d50d226-3548-43d4-8cdb-ab4e526ddffe	App\\Models\\Menu
9d50d296-d727-4a3c-8954-5bbe3dbf0bf9	App\\Models\\User
9d50d297-5410-4733-8891-c65e0c15226f	App\\Models\\User
9d50d299-4c3c-4b5f-a0d8-9818ab9e1806	slow
9d50d299-4c87-462e-abab-bdd6f2f79423	App\\Models\\Menu
9d50d2f8-ef87-4966-bb86-fb610a9c4ef2	App\\Models\\User
9d50d2f9-6a13-4689-9f55-3dede33cb793	App\\Models\\User
9d50d2fb-1120-427c-8841-2c9a5697000b	App\\Models\\Menu
9d50d61d-a820-4de7-bb76-6652d610ef75	App\\Models\\User
9d50d61e-0ab1-40c6-98f1-1e80057c0c2f	App\\Models\\User
9d50d61f-bc59-45c2-bf2c-1794de7192d4	App\\Models\\Menu
9d50d67b-f546-4557-a230-9718356cd278	slow
9d50d67b-f5a6-4dbb-9452-31272dcc9bc3	App\\Models\\User
9d50d67c-5630-4b86-8cd8-058276f364fb	App\\Models\\User
9d50d67d-e232-435a-a917-00b7b9843738	App\\Models\\Menu
9d50d7ad-8375-463c-90b2-2df35a1ad46b	App\\Models\\User
9d50d7ae-296a-4f1f-997b-dff284afeb0e	slow
9d50d7ae-29ca-45d6-9ae9-e6be2fd63ca6	App\\Models\\User
9d50d7af-f4dd-4531-8df0-424c3f7d850a	App\\Models\\Menu
9d50d7d7-698c-4376-a40c-a60d964a3412	App\\Models\\User
9d50d7d7-fbbc-42fa-98db-f9c5d3622228	slow
9d50d7d7-fe90-4f97-b2f1-6f1c09e32511	App\\Models\\User
9d50d7d9-5c09-4913-8dbd-d9661a370f0f	App\\Models\\Menu
9d50d7e4-a871-4c28-a8cb-07c0e3511d4e	slow
9d50d844-d28b-4273-babf-95a9f36cf2f1	slow
9d50d844-d2ee-47a0-a622-7de5a835b422	App\\Models\\User
9d50d845-2b52-44d1-91c2-304270f8fffa	App\\Models\\User
9d50d846-6ff0-4e70-a6d1-fc7b2b86998c	App\\Models\\Menu
9d50d9c9-d331-4e80-b6d5-5defac47f2af	App\\Models\\User
9d50d9ca-4476-49fc-8312-12daccd4c97e	App\\Models\\User
9d50d9cc-1fbe-4ea3-aec4-c233460e0cd7	App\\Models\\Menu
9d50dab4-5679-456e-b677-d3ca6d95d091	App\\Models\\User
9d50dab4-fa2e-4ea3-8a26-d9c3bbd733b1	slow
9d50dab4-fa99-41a9-9999-dc9ff110ce94	App\\Models\\User
9d50dab6-e9a4-4bb9-a799-2ca64393ac0c	App\\Models\\Menu
9d50db8e-aada-425e-ba29-b2b03842ec9f	App\\Models\\User
9d50db8f-2fd3-46a8-b763-92302e6b1f57	slow
9d50db8f-302b-4eca-844e-031abf147850	App\\Models\\User
9d50db91-1da7-4cf5-95b2-9ff71db91cea	App\\Models\\Menu
9d50dccb-1593-4333-b712-9231580fa3e5	slow
9d50dd61-2e56-493f-a2c7-f2c220c804ac	App\\Models\\User
9d50dd61-94f4-4e59-9df6-a019b5aab3db	App\\Models\\User
9d50dd63-428d-4ea6-a81d-9291a5ec475e	App\\Models\\Menu
9d50dd7d-fa87-4aab-9906-046242f4bb95	App\\Models\\User
9d50dd7e-7ea9-4953-8b86-54d0dcfeab08	slow
9d50dd7e-7ef2-4a79-931a-f0b7ead74f48	App\\Models\\User
9d50dd7f-d5cc-4f34-9261-98c7f5fb8a1f	App\\Models\\Menu
9d50dd8f-091d-46bf-acf4-87051ed97437	slow
9d50dd94-8ec2-4137-8cf7-5c4d278ec2de	slow
9d50df03-48c0-454d-9ac8-7130933bdf97	slow
9d50df03-4910-452c-bc4b-d14981673769	App\\Models\\User
9d50df03-ad1a-4ffd-bc0d-93162b0a9900	App\\Models\\User
9d50df05-b0bd-4f93-b8b4-00f285e479b8	slow
9d50df05-b164-44eb-9653-1cb835fcb20c	App\\Models\\Menu
9d50df2f-eea3-4f1b-a8a1-c203eefcc199	App\\Models\\User
9d50df30-580c-49d9-a78d-8744b7305a0f	App\\Models\\User
9d50df31-9f88-4294-97c2-d46bfd8e62d0	App\\Models\\Menu
9d50df41-54b0-4b37-ac41-6e5abd672552	slow
9d50df6c-92ce-4a9f-bfb0-b0372c46e17d	slow
9d50df6c-931e-497b-8081-be6da45f9a0a	App\\Models\\User
9d50df6c-eed8-4022-b162-451ef82ded9c	App\\Models\\User
9d50df6e-726a-4318-8dd8-a57822eacd8b	App\\Models\\Menu
9d50e010-1abe-4a5e-a6b7-cb69c6e62139	slow
9d50e010-1b33-4a81-9440-ba25a7155960	App\\Models\\User
9d50e010-e4d3-4dcf-971c-e387a8d4eddd	slow
9d50e010-e528-4aed-b051-cabfd25330e3	App\\Models\\User
9d50e013-3da8-4c94-99bd-3f5306ee1d3f	App\\Models\\Menu
9d50e014-fc7a-4078-9113-a31d548fcc63	App\\Models\\User
9d50e015-907c-4203-be42-40ad26e2fe55	slow
9d50e015-90c7-4a62-a570-3d1aa23f865b	App\\Models\\User
9d50e016-ee62-4a74-b9ec-0a202f785dad	App\\Models\\Menu
9d50e01c-849e-4838-8987-979adbb7cbad	slow
9d50e05a-22df-4e63-9733-96d44a91731e	App\\Models\\User
9d50e05a-c15a-4c39-95cc-bbc2a4ca1427	slow
9d50e05a-c1c6-41b1-a381-12d8171c8c96	App\\Models\\User
9d50e05c-512a-47e8-b88e-a6b9387c0cc3	App\\Models\\Menu
9d50e061-b33b-49e7-bcc3-267e3e01b62f	slow
9d50e0f9-1d39-4968-bf87-5b9acc1610b5	App\\Models\\User
9d50e0f9-c21e-44b3-911d-22362883948b	slow
9d50e0f9-c289-404d-89bb-46d015a5eaea	App\\Models\\User
9d50e0fb-88d7-414f-945d-e2fc4972a9a2	App\\Models\\Menu
9d50e220-2dae-45b7-af2c-e58378f719cc	App\\Models\\User
9d50e246-0dea-4ac1-bda8-c7221995d1d0	App\\Models\\User
9d50e246-9734-409c-b87e-192c113d3293	slow
9d50e246-978c-4d7b-ac9a-fe7ce98695d2	App\\Models\\User
9d50e253-1e2f-45f2-b30e-c7c422760a30	slow
9d50e25c-ef92-49ee-8c76-70ba00736518	slow
9d50e260-cd00-4e14-a2bc-714970191029	slow
9d50e262-8282-41f2-9ba0-222373f98182	slow
9d50e263-5b63-4b7a-9743-a73afb446128	slow
9d50e263-ecbf-480c-a6d8-4fd836c4cef4	slow
9d50e264-7f08-4cf7-91d8-e7d9bd78f385	slow
9d50e2f9-394b-41fd-99f2-1077bc2b404f	slow
9d50e2f9-3993-44d0-902a-6bee6a64ce1b	App\\Models\\User
9d50e2f9-9ca6-45f3-855e-bf454d478e76	App\\Models\\User
9d50e2fb-5d77-457d-bb19-f796d934021d	App\\Models\\Menu
9d50e314-990d-46ee-9992-6c41b2fdb9bd	slow
9d50e314-995b-44f5-a1b8-5929cfc182ab	App\\Models\\User
9d50e314-fd95-46da-97b0-0d9c83c723cb	App\\Models\\User
9d50e316-5aa1-4e8d-9884-ae5555465121	App\\Models\\Menu
9d50e31e-e513-4151-8c83-b8706133636d	slow
9d50e332-cfec-4eef-8d79-955787cde7c7	slow
9d50e354-ab7e-4b66-bf7e-58d59c34e806	App\\Models\\User
9d50e355-0922-4faa-8c1b-9d9850c6f69b	App\\Models\\User
9d50e356-8d50-452e-b990-e703dc250310	slow
9d50e356-8d95-4974-9c25-5aa633134f9b	App\\Models\\Menu
9d50e35e-e8f6-46cb-86a1-63aa03ac5172	slow
9d50e382-e1b0-480f-9968-a15631449f47	slow
9d50e382-e1fb-402d-9b19-bf15a96916cf	App\\Models\\User
9d50e383-7983-47bf-9813-0288ba0ac307	slow
9d50e383-79cf-4518-a051-2b67b48fdc7d	App\\Models\\User
9d50e384-d0a4-484d-88cf-1c143066c413	slow
9d50e384-d121-47eb-ae83-f39374405418	App\\Models\\Menu
9d50e39c-cce0-4729-8a49-ff006e24a21e	slow
9d50e3bc-5bd8-4ea2-8125-9cefc0a6ad6d	slow
9d50e3bc-5c29-4373-aede-9b1062dfeabe	App\\Models\\User
9d50e3bc-e786-4412-867d-e2e78aec0692	slow
9d50e3bc-e7d2-4522-bb18-7f47ff204ae0	App\\Models\\User
9d50e3be-5966-4643-9fce-10901ac012b0	App\\Models\\Menu
9d50e4e1-e3a4-41ed-a40a-39da9a0e706f	slow
9d50e4e1-e3ff-4ab3-92bc-e83e424076ac	App\\Models\\User
9d50e4e2-5a3e-4f26-9931-cc8147ba101a	App\\Models\\User
9d50e4e4-25dd-433b-964a-0e21fbd1bd47	App\\Models\\Menu
9d50e4f0-9355-48f7-9df8-c5f422c93a27	slow
9d50e50d-19f5-43be-a6a0-87fea295897d	slow
9d50e50e-a855-4f53-82f6-cb204afdf0c9	slow
9d50e50f-849a-4d5a-acf6-8b5e099f938b	slow
9d50e510-e313-4954-abb7-5c0582d2144f	slow
9d50e5e1-7312-42fd-8a24-0edbf46bb082	slow
9d50e6b4-a3f5-4092-bcb3-2549f5d0da3d	slow
9d50e6b4-a4d0-4fa0-8cf6-3a9c37296dea	App\\Models\\User
9d50e6b5-34f6-4452-883e-f4d212d47136	slow
9d50e6b5-356d-4a00-ba76-0ced24a32d71	App\\Models\\User
9d50e6b7-221d-4cd8-af85-cc2d62c32675	App\\Models\\Menu
9d50e6ce-90d3-4b50-8a86-2acf257faf64	App\\Models\\User
9d50e6ce-f41b-4003-a998-cb18dc7a3ee4	App\\Models\\User
9d50e6d0-8ca1-4c25-ab81-0ead84e3d04d	slow
9d50e6d0-8cee-4102-b20c-77f161dcde00	App\\Models\\Menu
9d50e6ee-4caa-4be1-8967-0965b7da7f5d	App\\Models\\User
9d50e6ee-afd7-47d9-a745-6b265348ad12	App\\Models\\User
9d50e6f0-5d26-4a30-bfcb-f4c1da48e760	App\\Models\\Menu
9d50e70e-02f7-4f8e-8291-14b1aad6e0fd	slow
9d50e70e-034b-4d69-833a-8dfcc96b8a46	App\\Models\\User
9d50e70e-9d97-4418-8251-2a5879a13984	slow
9d50e70e-9e38-4b33-8c50-7240478f5a79	App\\Models\\User
9d50e710-2c14-4436-9c53-d2fa67bd9d28	App\\Models\\Menu
9d50e72d-973a-4283-b5a9-39daba0fd486	App\\Models\\User
9d50e72e-1fbf-490b-8f94-20a77b940b33	slow
9d50e72e-2025-4c70-9b53-06e54e99b474	App\\Models\\User
9d50e72f-e0ef-4e3a-971c-00d7fcec8a2d	slow
9d50e72f-e182-4ed7-8d16-a42b15a6c76d	App\\Models\\Menu
9d50e765-35fc-4358-99ea-db52f0d0e811	App\\Models\\User
9d50e765-c1d7-45ba-8971-aa889128121f	slow
9d50e765-c222-4e35-8af2-ebb19137a6d7	App\\Models\\User
9d50e767-28b4-422e-99cc-39bca4e74e41	App\\Models\\Menu
9d50e782-a553-4a45-8fc3-32a2e244496a	slow
9d50e782-a5a9-4507-bd3f-60d501272ab6	App\\Models\\User
9d50e783-0864-4490-8e93-e721c3fe9e6a	App\\Models\\User
9d50e784-c6ef-42a1-9337-874ce8883ecf	slow
9d50e784-c747-4f47-8340-fbe3f1595b64	App\\Models\\Menu
9d50e7a9-461e-4cf9-bf59-00183953ec66	App\\Models\\User
9d50e7a9-a4e1-44b3-b1df-6fc486c33e8f	App\\Models\\User
9d50e7ab-0ed4-4bdf-b783-54cbe7c3ccf3	App\\Models\\Menu
9d50e7bb-6398-4150-98bf-269c9454f706	slow
9d50e7bb-63ea-4048-ae98-d4f4c2105e83	App\\Models\\User
9d50e7bb-be85-485b-9323-a6ce056ba046	App\\Models\\User
9d50e7bd-5c43-4849-8e5e-fba765277477	App\\Models\\Menu
9d50f8c9-3d5c-4a75-a39c-2901e5f3b4f1	slow
9d50f8c9-4590-41b2-b3ad-c98511c3afb7	App\\Models\\Menu
9d50f8cd-b39a-4b0c-9cd2-f021f4c06ce1	slow
9d50f8cd-b3e4-4c05-adb5-809a7beb07bd	App\\Models\\Menu
9d50f8e0-db6b-4dc2-9077-b8a700decd6e	App\\Models\\User
9d50f8e1-636b-48c9-9fef-92f9d4c9d04d	slow
9d50f8e1-63b6-4904-9e69-62a77083efa1	App\\Models\\User
9d50f992-5dce-4724-bbf7-16744b71745d	slow
9d50f992-5e25-4d87-bee7-93dee57d547c	App\\Models\\User
9d50f992-d446-426f-8f1e-6d304ae4d901	App\\Models\\User
9d50f995-5b65-428e-891c-27b8c2ad7870	App\\Models\\User
9d50f996-06cd-4d51-b0a6-3a0a21a673ec	App\\Models\\User
9d50f996-d7f2-4596-b9f4-886749c3aaa0	App\\Models\\Menu
9d50f997-c65c-4381-9383-d89b45b81001	App\\Models\\Menu
9d50fa05-cc7d-4e7c-a016-692ff6148a3e	App\\Models\\Menu
9d50fa06-7acb-4902-a85d-11c85c1d1728	App\\Models\\Menu
9d50fa2a-8e27-4537-8cdb-72fb74eea602	App\\Models\\User
9d50fa2a-f0b3-4cf4-8baa-e93ac9021c89	App\\Models\\User
9d50fa2c-d69e-4c36-9d93-b5b560518640	App\\Models\\User
9d50fa2d-43b4-48dd-99aa-e0ebe3ddb017	App\\Models\\User
9d50fa2e-5b16-40e3-b1d3-0a354edc6d58	slow
9d50fa2e-5be6-4ec6-a7b0-096e0d118b8f	App\\Models\\Menu
9d50fa2f-2876-4ed8-8fe6-72c7728548dc	App\\Models\\Menu
9d50fad0-f194-4f0f-a44c-d25f2ca01e85	App\\Models\\User
9d50fad1-6e48-4a6a-998c-ff195f04808b	App\\Models\\User
9d50fad3-6ffd-47ab-b9ef-49c88350ebd9	slow
9d50fad3-706f-4119-932c-be86bbf7c73d	App\\Models\\User
9d50fad4-1ccc-4d45-b06c-ffecba20d8fd	App\\Models\\User
9d50fad5-25da-4a9d-8773-96bae1e56de3	slow
9d50fad5-2665-4700-853a-d884af65e34e	App\\Models\\Menu
9d50fad6-0597-4937-bd36-2ba862b6768a	App\\Models\\Menu
9d50faeb-3b5d-4ce8-8876-ae844ff5a1ff	App\\Models\\User
9d50faeb-a3af-4245-a7e9-c4f8fccdf718	App\\Models\\User
9d50faed-7b59-41a7-befb-004d83ca571e	App\\Models\\User
9d50faee-3b5d-4622-8275-7860b9522370	slow
9d50faee-3bca-4b3c-a56b-fc2599698959	App\\Models\\User
9d50faef-0f0a-4bb1-9b43-8aee9d02c813	slow
9d50faef-0ff1-449a-83ec-b71c71f253a1	App\\Models\\Menu
9d50faef-d653-4b31-9178-8742d9866478	App\\Models\\Menu
9d50fb06-dfd6-4aae-92a2-96883328cf51	slow
9d50fb06-e043-41be-a7be-77cef9864a6c	App\\Models\\User
9d50fb07-9bd5-4c13-ada5-d717dc712a0f	App\\Models\\User
9d50fb0a-6b27-4d4a-b04f-df16b6cc6aa5	App\\Models\\User
9d50fb0b-1fab-4e65-94f2-0861def93ccb	App\\Models\\User
9d50fb0c-10df-4265-bc2f-02b2a1417047	slow
9d50fb0c-1185-4535-9cac-d204a3017d12	App\\Models\\Menu
9d50fb0c-f877-4a1d-b554-e33535c920a0	App\\Models\\Menu
9d50fb23-f553-4e9e-a470-26d0ecb05f7c	App\\Models\\User
9d50fb24-5ffb-4f3c-8e70-83926aa347d8	App\\Models\\User
9d50fb26-12f9-4e15-90bd-260d087a791e	App\\Models\\User
9d50fb26-de71-4bca-984d-60cef816569d	slow
9d50fb26-ded4-442f-95a5-ef535ba79755	App\\Models\\User
9d50fb27-b8dd-4f7b-b03e-92e8173bc981	App\\Models\\Menu
9d50fb28-b0e4-4e56-9e42-6ca8d198de30	slow
9d50fb28-b177-4e0a-9a1b-1c447c5bf557	App\\Models\\Menu
9d50fb38-38c4-4a47-a3d9-41754f4332ed	App\\Models\\User
9d50fb38-b558-4a60-9714-2ca884926a2d	App\\Models\\User
9d50fb66-b5c3-4329-88ed-ffa690f18b7b	App\\Models\\Menu
9d50fbbe-f803-444a-b334-ff8571b84866	App\\Models\\User
9d50fbbf-8729-43ac-9158-ff7df60ae4c0	slow
9d50fbbf-8772-49f4-aeb2-5eb11e241cf1	App\\Models\\User
9d50fbc0-e8af-4554-8218-3a0d73894e70	App\\Models\\User
9d50fbc1-5170-41f4-8ff6-da86993c6934	App\\Models\\User
9d50fbf3-fef5-467a-b2a5-b44c6680ba94	App\\Models\\Menu
9d50fbf4-755d-4636-9b78-773d5630150b	App\\Models\\Menu
9d50fc02-b073-4a8c-9879-f8b1b331bee6	App\\Models\\User
9d50fc3c-9b78-4f51-a787-8b6936ca9c28	App\\Models\\User
9d50fc3d-0dc1-406f-8465-5dd750d8b098	App\\Models\\User
9d50fc3d-e09f-4c23-9b3c-777e29eb84b9	App\\Models\\Menu
9d50fc3f-1939-4788-98c7-19cc9a4f7c71	slow
9d50fc3f-1985-4f3d-964a-2217c250d313	App\\Models\\Menu
9d50fc4d-d22b-4ada-a5af-1be29cb266ab	slow
9d50fc4d-d279-4adc-b8b3-430bdec454ac	App\\Models\\User
9d50fc4e-420f-49c6-be5b-d0efa58e0dab	App\\Models\\User
9d50fc9c-2610-4327-84cf-168453583a37	slow
9d50fc9c-2659-4cca-a257-1feb174b519d	App\\Models\\User
9d50fc9c-8c8c-415f-8da0-98cf1cce9082	App\\Models\\User
9d50fc9d-6353-4f25-b380-6304f9f26750	App\\Models\\User
9d50fc9d-d00d-4948-a55a-ec414b588132	App\\Models\\User
9d50fc9e-c87f-4727-a9df-fcc566c0e54c	App\\Models\\User
9d50fc9f-31e9-405a-b384-cabc5232f2a1	App\\Models\\User
9d50fca1-465e-4835-88e2-d8c7e35ed830	slow
9d50fca1-46a7-4cf2-a513-f23371374930	App\\Models\\Menu
9d50fca1-b53c-4ed7-8a09-de8a60fee023	App\\Models\\User
9d50fca2-4b11-45d5-b709-ec0ecf30d1c4	slow
9d50fca2-4b5f-413e-a087-1b4213ea4dc9	App\\Models\\User
9d50fca4-0fce-4a05-b350-1c7165094c2b	App\\Models\\Menu
9d50fd54-5489-4316-83b8-790e855e5f0c	App\\Models\\User
9d50fd54-c055-4bf5-9456-01c6f2dd2bfd	App\\Models\\User
9d50fd56-a0bc-4404-9af3-2070157496ea	slow
9d50fd56-a13f-44ce-b36e-197c9e0ba432	App\\Models\\User
9d50fd57-358f-4a42-8454-112435bef925	App\\Models\\User
9d50fd58-65f0-49a2-85bc-e8e63fe6981b	App\\Models\\Menu
9d50fd59-1df1-45e4-a92f-73ee6cc9c3e6	slow
9d50fd59-1e4e-40f7-b3c9-65bd77d524d1	App\\Models\\Menu
9d50fdab-8b09-445a-9a30-7de30fd48db7	slow
9d50fdab-8b61-413d-907f-23b1edcd94c9	App\\Models\\User
9d50fdab-f5b9-4ad5-bad2-ea42c2fb15a6	App\\Models\\User
9d50fdad-e975-4f29-9c75-ef636469d025	slow
9d50fdad-e9e4-42a8-bc95-e0c75355fc5e	App\\Models\\User
9d50fdae-515e-42c2-b82c-ebb4f5ec9190	App\\Models\\User
9d50fdaf-8c41-42fb-a852-da75d9951a80	App\\Models\\Menu
9d50fdb0-0c2d-4924-8da7-f13b3f34d0b0	App\\Models\\Menu
9d50fddd-a96d-4bbe-9d91-58043f2e44fb	App\\Models\\User
9d50fdde-1086-49b9-95ac-206826638a10	App\\Models\\User
9d50fddf-e29d-41cd-b333-3b29e4919e47	App\\Models\\User
9d50fde0-5cd4-4108-bc4f-fce78ad0547c	App\\Models\\User
9d50fde1-57b3-4973-9ce0-963bed3b6011	App\\Models\\Menu
9d50fde2-2bc3-4301-a39b-7b0e8405e00b	App\\Models\\Menu
9d5100c0-ebf3-4a7f-8264-e29aabec71fc	slow
9d5100c0-ec65-4326-8574-864e7581bd7c	App\\Models\\User
9d5100c2-4f06-4f6a-a635-fb4aa351c487	slow
9d5100c2-4f52-41ee-8c3d-c5db40319962	App\\Models\\User
9d5100c4-5536-4d63-8b35-ff8ced4b86ca	App\\Models\\User
9d5100c4-e8c0-4067-a0d0-94d459af15f4	slow
9d5100c4-e91b-49e6-b005-98ca3a1aeeae	App\\Models\\User
9d5100c5-98a7-4712-bb82-4b4e2a44ae69	App\\Models\\Menu
9d5100c6-5fbb-4b59-bf70-98872a2f30bf	App\\Models\\Menu
9d5101a7-05b2-43a9-b9ee-638c1445726a	App\\Models\\User
9d5101a7-6db6-466a-a8e4-f6258a3b735d	App\\Models\\User
9d5101a9-53ba-44fb-b152-2344f19a4553	slow
9d5101a9-544b-4ad7-909d-861153829095	App\\Models\\User
9d5101a9-bb81-494a-ac8e-586385077c76	App\\Models\\User
9d5101aa-804c-48fe-be91-b0c097bd191e	App\\Models\\Menu
9d5101ab-481d-4810-a246-8826ebb6f00a	App\\Models\\Menu
9d5101c3-cd3d-4366-b911-b7694d5518a3	slow
9d5101c3-cd8d-4e20-91a2-947ca3206c2e	App\\Models\\User
9d5101c4-35ff-45a4-92ed-f01e1c8b0c50	App\\Models\\User
9d5101c6-060a-405b-a92b-094dafef96d9	App\\Models\\User
9d5101c6-a99a-447f-8b65-1f9afbb41244	App\\Models\\User
9d5101c7-8333-41ff-99d5-c0faea651926	App\\Models\\Menu
9d5101c8-3e72-4964-a469-e677b47c6699	App\\Models\\Menu
9d5102cc-0c6d-4ce2-931b-794948d6a8a3	slow
9d5102cc-0cbb-4e51-9e46-027ca49fc9e0	App\\Models\\User
9d5102cc-9d3b-4091-adec-01797f114b11	slow
9d5102cc-9d8b-43b3-8ed7-bd7e0c5ff08a	App\\Models\\User
9d5102ce-53bf-440a-82a1-c43afd1e7037	App\\Models\\User
9d5102ce-f3dc-4b5a-9de8-cb3409a53022	App\\Models\\User
9d5102d0-338e-4c8b-bab3-147a6aafc5ac	slow
9d5102d0-3433-4303-ab3a-dd3df70cbe30	App\\Models\\Menu
9d5102d0-db96-4773-b046-9f0d67c579b8	App\\Models\\Menu
9d510312-85c4-4dd9-9e88-546675789f1d	App\\Models\\User
9d510312-f770-4649-a260-3e380f5fe907	App\\Models\\User
9d510315-3b33-4616-9095-ea66848e08dc	App\\Models\\User
9d510316-0ff8-4af2-b90d-e70d71199f54	App\\Models\\User
9d510317-3e92-4b88-884b-2f1280ba5619	slow
9d510317-3f20-446f-8afc-bdce3ec2b1c1	App\\Models\\Menu
9d510318-8914-4f0c-8588-2f13c391ec0f	slow
9d510318-89d4-418e-a31c-80cba2d98932	App\\Models\\Menu
9d510361-fc10-4cad-88cf-1910178c3d49	slow
9d510361-fc6d-4605-84e7-f675f6da3007	App\\Models\\User
9d510362-903d-45ee-9d18-ed919353a3ce	slow
9d510362-908b-43ea-91ef-4d3c99195ef0	App\\Models\\User
9d510364-853f-476e-a8d7-814ab0fca3db	slow
9d510364-85ca-45da-b820-00a3f5deeed6	App\\Models\\User
9d510365-0438-4997-8254-de73d2f84065	App\\Models\\User
9d510365-f5b3-4275-90f7-a3ca78616166	App\\Models\\Menu
9d510366-e464-496f-b3c4-8d3698ee3d37	slow
9d510366-e4e6-4d9e-9fa8-fe5ef0947319	App\\Models\\Menu
9d510391-8bc9-47c8-9731-166539358db3	slow
9d510391-8c34-40c6-983a-4af855c56b49	App\\Models\\User
9d510392-17c3-4d6f-8b1f-a9a4074edcfd	slow
9d510392-1816-4b26-aaec-9d838a62a3e6	App\\Models\\User
9d510393-d2ff-4633-9e8f-68c3cc5eb4d1	App\\Models\\User
9d510394-8f41-4625-8898-5b89b6a13b03	slow
9d510394-8fa5-4f6a-b10e-ff2da8168191	App\\Models\\User
9d510395-9c8e-4f17-94c1-3d4040e6a8aa	slow
9d510395-9d0d-4e94-96b0-d52d4f9ad849	App\\Models\\Menu
9d510396-2c75-45fa-8d95-14616a0b02df	App\\Models\\Menu
9d510458-a1f6-4a5d-baa4-52a5d527d815	App\\Models\\User
9d510459-27fa-4371-923b-b17f872df695	App\\Models\\User
9d51045a-615a-4ae2-bae8-6e793069d99c	slow
9d51045a-61a7-4c93-8619-b5597cbce9e8	App\\Models\\User
9d51045a-d613-4793-a82f-2d0144c3938b	App\\Models\\User
9d51045c-c803-4839-a4d8-b81c048cf085	App\\Models\\User
9d51045d-7171-49af-ae59-d40670963bb7	slow
9d51045d-71ce-459c-85fe-0ce1ec5023ee	App\\Models\\User
9d51045e-69e5-4df4-8075-e33034c27b66	App\\Models\\Menu
9d51045f-405c-4774-9fd8-94d9bff03e7b	App\\Models\\Menu
9d510481-0f09-4d70-bb48-11890f9aabff	App\\Models\\User
9d510481-7c86-454b-8a62-3a4202e455c3	App\\Models\\User
9d510483-77af-48de-83e9-c2dc99016de1	App\\Models\\User
9d510484-066b-442d-9804-e758844d118a	App\\Models\\User
9d510484-e7e4-4517-a8e0-ede3d3079aac	slow
9d510484-e87c-4d23-80e1-3def911dfd1f	App\\Models\\Menu
9d510485-ca16-4cf4-a1c0-f2ac915823b1	App\\Models\\Menu
9d510493-d43b-4218-b102-c8bab5b50c65	App\\Models\\User
9d510494-6d96-46bd-8950-72387f086c41	slow
9d510494-6dfc-4288-9639-573690809971	App\\Models\\User
9d510496-62b9-4605-8ab3-7edfcad54aaf	App\\Models\\User
9d510496-f7a6-43cc-ab36-a376adab023c	App\\Models\\User
9d510497-c91e-42b6-9751-205d296bb8c1	App\\Models\\Menu
9d510498-8819-49b4-967e-de646d153464	App\\Models\\Menu
9d510523-6868-4757-9068-c7ecb23b22cb	App\\Models\\User
9d510523-d9a8-4a12-878c-04b74fc6bfdd	App\\Models\\User
9d510526-05a2-499f-8e6a-5e16235b784f	slow
9d510526-0601-447f-83f7-1a86b1e23cf9	App\\Models\\User
9d510526-740d-4af5-9e6f-5582ceb0e3a0	App\\Models\\User
9d510527-3fa9-4749-a945-e129f989cb0a	App\\Models\\Menu
9d510528-5005-485c-88bc-4f6b54ef3de9	slow
9d510528-5089-4c37-a58d-d95b63b6714c	App\\Models\\Menu
9d5105e2-3018-40a1-8baa-5c4681becdef	App\\Models\\User
9d5105e2-d307-47c0-ab87-b2b1e0b62418	slow
9d5105e2-d370-4513-8d57-56a8686dfb64	App\\Models\\User
9d5105e4-a785-4ed3-adb5-74de243fe961	App\\Models\\User
9d5105e5-55bf-4a48-86a5-53e5dc0f0d83	App\\Models\\User
9d5105e6-58f2-46f2-86e6-3aad2459d4ac	slow
9d5105e6-59dc-4c98-b96e-1b5f11332111	App\\Models\\Menu
9d5105e7-5ae5-4306-8224-aa4b9045deeb	App\\Models\\Menu
9d5106d4-0c5a-4f27-92d6-5527be20448d	App\\Models\\User
9d5106d4-8127-4579-ab5f-a8bd43614958	App\\Models\\User
9d5106d6-5b9d-433a-af66-a22eb42ea905	App\\Models\\User
9d5106d7-069a-47a8-b0cb-028e6e19a8dc	App\\Models\\User
9d5106d7-dbf6-4982-8d3f-eaea0bbcddbc	App\\Models\\Menu
9d5106d8-cc15-4c6c-8398-e8c6d7d77c77	App\\Models\\Menu
9d5106e2-e784-4e9c-97d2-02f50bc57c04	App\\Models\\User
9d5106e3-7f69-492c-9241-d2df5c0213da	slow
9d5106e3-7fcd-4e15-9084-5a5a3d370f46	App\\Models\\User
9d5106e5-8385-4885-ae05-4f9a40c585d1	App\\Models\\User
9d5106e6-3a47-408d-aa62-a150972c78fb	App\\Models\\User
9d5106e7-1709-4271-acc9-a408231c58c4	App\\Models\\Menu
9d5106e7-ced0-4233-ba1b-1662cdaa9546	App\\Models\\Menu
9d5108db-8956-4066-8799-4a21f5da0bb8	App\\Models\\User
9d5108dc-216e-4dc4-99a6-6334e633119d	slow
9d5108dc-21c1-4511-9b4e-5d135f1b6f22	App\\Models\\User
9d5108de-4195-4c3e-8a47-5d4f79ac10ab	App\\Models\\User
9d5108de-f519-471b-85c3-53c218c7c29d	App\\Models\\User
9d5108df-d9f5-4e7d-a2e5-e01d59160318	slow
9d5108df-da85-471c-ab6a-e9f0b528ea4f	App\\Models\\Menu
9d5108e0-bd8f-4bb3-8b81-c33d5347187c	App\\Models\\Menu
9d5108e8-0b97-4aaf-a97e-832052011ca6	slow
9d5108e8-0c1e-4198-a59f-1f5305ea6a23	App\\Models\\User
9d5108e9-e233-4f8e-826a-f0f5f9980041	App\\Models\\User
9d5108ec-2fca-4a8f-b0e9-8f5252276a83	App\\Models\\User
9d5108ec-dfe0-41d1-8541-6eb2a4c772e6	App\\Models\\User
9d5108ee-45e7-4c54-9672-ca90c7a26e87	slow
9d5108ee-4690-4e4a-b632-299b5531d47c	App\\Models\\Menu
9d5108ef-7036-410a-9fb3-2388a477893b	App\\Models\\Menu
9d5108f8-e231-4369-aad6-56dc129ffe4a	App\\Models\\User
9d5108f9-65b6-4136-82ae-61002d1e28a8	App\\Models\\User
9d5108fb-95bd-41cc-8da1-87e560a8e53a	App\\Models\\User
9d5108fc-4d27-4c18-be0b-c1774087ce73	App\\Models\\User
9d5108fd-843f-41f4-9a3b-fc2af2d1fed8	slow
9d5108fd-8530-4ce4-a4ff-f04405a57c37	App\\Models\\Menu
9d5108fe-2fec-40c3-978d-3b9c672f1302	App\\Models\\Menu
9d51092d-91bd-49b5-a57c-078528a1ffdf	App\\Models\\User
9d51092e-0331-4ef7-8a62-5634cdafd14b	App\\Models\\User
9d510930-5ecd-4af8-99e9-1bfc697b525e	App\\Models\\User
9d510930-d4db-49ab-b3be-79f3fa2f2ea8	App\\Models\\User
9d510931-91b5-40b6-87be-844decbaa0fc	App\\Models\\Menu
9d510932-68fb-4d34-8eb2-079e29e20970	App\\Models\\Menu
9d51098a-3c5b-4015-a8e7-78ee5ec42dc5	App\\Models\\User
9d51098a-b0b7-401d-b46d-3d0d787c39aa	App\\Models\\User
9d51098d-1058-4168-b634-34634bc6939f	App\\Models\\User
9d51098d-bab8-476a-a272-af3c95344605	slow
9d51098d-bb27-4f44-8e71-766fe1a9fb33	App\\Models\\User
9d51098e-8798-4ae1-8bb9-f368d8d37c8a	App\\Models\\Menu
9d51098f-6305-48cc-84bc-14736650695d	App\\Models\\Menu
9d511765-3b59-4230-b9ae-3ae0d0ccfb9f	slow
9d511765-3ba8-4a9d-944a-6097e5b74aec	App\\Models\\User
9d511765-a380-48e3-941f-6284bb691f08	App\\Models\\User
9d511768-4afc-4e8f-bde8-2a6831e6c35b	slow
9d511768-4b59-4665-8490-35aee0279611	App\\Models\\User
9d511768-ac45-4926-ae02-848b96e97b3a	App\\Models\\User
9d511769-61b0-404a-9030-ba18d9e58137	App\\Models\\Menu
9d51176a-b622-49ee-81f9-274f6e82d40b	App\\Models\\Menu
9d511875-7be4-46e2-82c6-2a2bce0f4ab0	App\\Models\\User
9d511876-187c-41c1-ac31-1d5f1244f03e	slow
9d511876-18f0-4f64-bacc-0aac0e8745a0	App\\Models\\User
9d511878-a654-44e0-afc4-abd4ac0ef1cd	App\\Models\\User
9d511879-6644-4301-99d0-caeb3c88ee77	App\\Models\\User
9d51187a-a6b0-4241-80a4-0e681dfb63f4	slow
9d51187a-a749-4b1d-9c5b-6694f327df4c	App\\Models\\Menu
9d51187b-d90d-482d-8cc7-fb16ee628894	App\\Models\\Menu
9d511a4b-29c7-4e58-bd1a-ba1225a0608d	App\\Models\\User
9d511a4b-9e9e-4cec-981d-ef57c76c95fb	App\\Models\\User
9d511a4c-9ff5-46c2-a34b-cc474d4b6cb3	slow
9d511a4c-a042-497e-92e6-24abcd029bee	App\\Models\\User
9d511a4d-3678-492d-9803-790747ea542b	slow
9d511a4d-36eb-4f93-ae9d-c27689689104	App\\Models\\User
9d511a4f-2f4a-4f04-a388-85c4f20f0a14	slow
9d511a4f-2fc4-4cbe-83a6-4f19a3d8cedf	App\\Models\\User
9d511a4f-baec-4599-a6a6-87d5fc8431e6	App\\Models\\User
9d511a50-89ac-4d0c-94b1-cb1981515ba5	App\\Models\\Menu
9d511a51-51f7-426c-8da3-6885223a3f0f	App\\Models\\Menu
9d511ad7-4d93-4385-a4d3-a8188b72a56c	slow
9d511ad7-4ddd-4590-897e-8b744b79be71	App\\Models\\User
9d511ad7-b7d6-436a-9286-42994a6741d6	App\\Models\\User
9d511ad9-cbfe-4edd-a0b2-e4764ba081f7	App\\Models\\User
9d511ada-710a-423e-85ac-ab073173bb0c	App\\Models\\User
9d511adb-5230-40f9-aa34-293a44782211	App\\Models\\Menu
9d511adc-3985-4b60-b65a-5ace517864e1	slow
9d511adc-39e4-4027-851e-8218ba6ff518	App\\Models\\Menu
9d511aee-dec1-4f9a-bd4f-99ed27769a61	App\\Models\\User
9d511aef-46a7-4e37-822c-9af544bd4530	App\\Models\\User
9d511af0-ff82-4a44-8072-cf771aaff89a	App\\Models\\User
9d511af1-8d87-42d1-bfc1-737405881946	App\\Models\\User
9d511af3-0d7b-405e-9d49-9bfc89004fed	slow
9d511af3-0e65-4003-84e8-151474de68be	App\\Models\\Menu
9d511af3-b392-46c6-b2af-1ddc9e6a35bf	App\\Models\\Menu
9d511b22-0ae9-4038-8a7f-7beed454ab30	slow
9d511b22-0b43-4727-9f22-9fba2edf8ab0	App\\Models\\User
9d511b22-9ac6-49de-aeb0-b9cec62cde6f	App\\Models\\User
9d511b25-3e3b-4a94-9b1f-6fef6c1781b3	App\\Models\\User
9d511b25-cf48-4303-b373-206f4697bb0c	slow
9d511b25-cfae-4eed-b6b6-004e548cd34a	App\\Models\\User
9d511b26-a869-4cf3-9acb-b0ab4bc81806	App\\Models\\Menu
9d511b27-6b41-4cd1-a4dd-0130f29f9805	App\\Models\\Menu
9d511b29-491e-4e51-b8d4-ac47cfaa7b36	App\\Models\\User
9d511b29-d721-4782-8314-7fe42dbc35bb	slow
9d511b29-d76d-4f71-bfb3-b8af5f2e031b	App\\Models\\User
9d511b2b-66bf-4dc1-b607-7be93de82188	App\\Models\\Menu
9d511bf9-99d8-4439-b208-d07e88085a98	App\\Models\\User
9d511bfa-108d-4d49-868d-27dfbd15e517	App\\Models\\User
9d511bfc-043c-476b-9730-607a1dd70608	App\\Models\\User
9d511bfc-dc3c-4222-bd1b-7ae39a60586f	slow
9d511bfc-dc97-4549-a0ce-98cf4a8fa6b2	App\\Models\\User
9d511bfd-f198-4251-9d83-5ba6b6143b25	slow
9d511bfd-f223-405e-be40-b53922895130	App\\Models\\Menu
9d511bfe-9d94-45da-861d-3012027ba054	App\\Models\\Menu
9d511cc9-2cd3-4f08-a142-0917c9449409	slow
9d511cc9-2d4e-4bbb-b551-7b7bfa52db28	App\\Models\\User
9d511cc9-9587-4e0f-82c9-d7615190bb17	App\\Models\\User
9d511ccb-655d-475e-9823-c46c1840e9b6	App\\Models\\User
9d511ccc-0a7f-4841-8a70-277476f5ab09	App\\Models\\User
9d511ccc-db65-4757-970e-955b7c1842b6	App\\Models\\Menu
9d511ccd-985b-4104-b311-5756df4bdba4	App\\Models\\Menu
9d511d15-8c95-4548-8821-ce5a1ad58e12	App\\Models\\User
9d511d16-21df-4d97-8854-ef0cf8d976f5	slow
9d511d16-2228-452a-9542-50616392b04a	App\\Models\\User
9d511d18-4452-42a8-9ab2-0d8baaf3d3ed	slow
9d511d18-44e0-4d6f-8817-0388088bdcef	App\\Models\\User
9d511d19-17ca-4830-972c-9e3ad6ed039e	slow
9d511d19-184d-4f46-9bcf-7cbf8efb45ce	App\\Models\\User
9d511d1a-7bb4-49bf-b7b4-fb11c36acfa6	App\\Models\\Menu
9d511d1b-149d-4fdc-b7ff-cb7665bc264c	App\\Models\\Menu
9d511de6-c31e-453d-a5b6-5d4b46636b31	App\\Models\\User
9d511de7-30b2-404c-9b30-70bee61ec5ce	App\\Models\\User
9d511de9-2b97-4ff6-82ef-509c1c7d151d	App\\Models\\User
9d511de9-cfed-4bbd-b7e2-3f737ae4ab13	App\\Models\\User
9d511dea-e500-4406-8db7-3149aade9253	slow
9d511dea-e5a8-49fb-b415-066636a34595	App\\Models\\Menu
9d511dec-446a-40a3-8d61-cdc8e0e1e37d	App\\Models\\Menu
9d51214f-ce3c-4dff-9333-c3ae45b8c7dc	slow
9d51214f-ce9a-4353-b7c7-1e6a2e10d8d9	App\\Models\\User
9d512150-3e87-4a1d-bc87-091b2922517b	App\\Models\\User
9d512152-c52a-4f26-8bdd-32f2b7a7708b	App\\Models\\User
9d512153-3844-407c-b9de-abf57b2d2bb7	App\\Models\\User
9d512154-0aae-4517-b997-1beebcb7788b	slow
9d512154-0b72-4e95-8aec-63f091fdc40b	App\\Models\\Menu
9d512154-f394-4c34-b124-861e0a2dd054	App\\Models\\Menu
9d51291c-79d7-4ac9-a1c4-f152965fa83e	slow
9d51291d-88a7-4569-9f4e-15f1aa5a6cd9	slow
9d512924-52b9-4384-9534-56eb07ff639b	App\\Models\\User
9d512998-535f-4e23-afb0-039d06cbd9c2	slow
9d512998-53aa-41a8-af56-569a682fd701	App\\Models\\User
9d512998-e95e-4338-a2b0-eb84b3a52cd7	slow
9d512998-e9bb-4883-8cee-1542ca5fff46	App\\Models\\User
9d51299b-359d-4a82-aaa4-c32cbe7061d8	slow
9d51299b-362b-4566-9b5f-f6c97e21570b	App\\Models\\User
9d51299b-ef30-421f-88cc-34422c2c7652	App\\Models\\User
9d51299c-f80c-4180-a400-fcecc30d9f9d	slow
9d51299c-f8c2-4f59-b35a-bf1683e5e6f1	App\\Models\\Menu
9d51299d-e8f1-4600-8b32-26ad91d2ad1a	App\\Models\\Menu
9d5129a6-7967-4268-8dc5-fab0ec264df9	slow
9d5129d5-d701-4797-8e24-e7e56b210230	slow
9d5129d5-d764-4f90-a6b3-4e51284a9300	App\\Models\\User
9d5129d6-a63f-4713-a5dc-0b4d334dddcd	slow
9d5129d6-a6b2-4df9-8d51-fa7e17ca30f0	App\\Models\\User
9d5129d8-8a15-430c-a45a-d2fd2bbd0595	App\\Models\\Menu
9d5129d9-347a-4b41-925d-697a37545eae	App\\Models\\User
9d5129d9-f03d-4779-a906-2274f0b80b67	slow
9d5129d9-f09e-4cc4-81fb-a5cdaac04b34	App\\Models\\User
9d5129db-f644-4d7f-a755-0b7fa9e2dc3b	slow
9d5129db-f690-42cb-82e3-52b8226d7f0b	App\\Models\\Menu
9d5129f4-f076-4f9a-b0cd-107e9a9b88c8	slow
9d512a49-5e56-4672-a061-8a016a9e7ac9	App\\Models\\User
9d512a49-e137-43bb-b2b3-9b4338127b7b	App\\Models\\User
9d512a4b-f0db-4cd4-a521-bde74a3d7351	App\\Models\\Menu
9d512a52-6e19-4a59-8be4-0ba54ddda09a	slow
9d512a57-5b4a-4b3c-8646-af9d3b000e38	slow
9d512a6d-c0cf-4446-9b4f-5b6496919b18	slow
9d512a6d-c13e-48a0-973e-bc4d303e5445	App\\Models\\User
9d512a6e-2608-43c0-ac5b-3adb8d07d439	App\\Models\\User
9d512a70-360b-4a0b-943a-9072206b3d4c	App\\Models\\Menu
9d512a79-7419-4298-ba9f-62bcfbf3a745	slow
9d512a80-7f71-48de-b9fe-878edba7f57f	slow
9d512a80-7fc3-4f4d-a3df-a200fb865a72	App\\Models\\User
9d512da6-52b0-4019-a611-28ff7969df66	App\\Models\\User
9d512da6-d2d3-4a5d-91da-b86d5757bbc9	App\\Models\\User
9d512da9-2181-4202-b8e9-0ded71ee4e0e	slow
9d512da9-21fe-4504-8d03-73f643759f37	App\\Models\\User
9d512da9-c594-4c65-955d-4cc88de3984f	App\\Models\\User
9d512daa-929e-4d45-8bab-3ef97806460e	App\\Models\\Menu
9d512dab-9a53-4ab0-907c-b7310ca490ff	slow
9d512dab-9ab6-4d27-86a8-a07c27f4da4e	App\\Models\\Menu
9d512e73-0053-4601-81f8-2690b9e02359	slow
9d512e73-00cf-4a81-a71f-f7fec358887b	App\\Models\\User
9d512e73-c3c9-4638-afd0-456560c51e26	slow
9d512e73-c415-43c1-9dc6-4b626cc1ef11	App\\Models\\User
9d512e76-64a8-44f5-b7ee-d93df543ccec	slow
9d512e76-651d-4932-baa1-929b7af0e5d9	App\\Models\\User
9d512e76-dd26-434f-b17f-f75806edc06c	App\\Models\\User
9d512e77-933d-4bab-afb2-f3d5ad164795	App\\Models\\Menu
9d512e78-5c07-4aca-ab05-b0909fd35304	App\\Models\\Menu
9d513001-bf07-4257-932e-b442ce0e5b5f	slow
9d513001-bf6e-46eb-98db-cdb2bfe611c6	App\\Models\\User
9d513002-6015-460a-b852-29fa5b5c977d	slow
9d513002-6081-4c5e-896f-059911c5a290	App\\Models\\User
9d513004-a4c7-420c-8f03-c46f301d4b90	App\\Models\\User
9d513005-2cf0-49a0-b359-fef933a103d9	App\\Models\\User
9d513005-e796-4f53-be3d-0cb41d61d208	App\\Models\\Menu
9d513006-f813-4601-b0ae-9df2a8857be2	slow
9d513006-f8ad-420a-9eae-4ef7f6adbd9f	App\\Models\\Menu
9d5130c6-da1e-4fae-a502-f49c0baf1873	App\\Models\\User
9d5130c7-5384-4807-bbcb-2c24e42aeb05	App\\Models\\User
9d5130c9-63cf-4078-a956-3e6c76a48d82	App\\Models\\User
9d5130c9-e00a-404d-a7a6-a97557f9900a	App\\Models\\User
9d5130ca-9ce6-494d-825e-1ad14b321932	App\\Models\\Menu
9d5130cb-856a-433e-98dc-51c5c8660136	App\\Models\\Menu
9d5131d0-a18a-4aac-bdcc-8f5fcff410d1	App\\Models\\User
9d5131d1-128f-462b-b707-04b61fe6007e	App\\Models\\User
9d5131d2-c652-4104-b0da-5fd84a48c3b3	App\\Models\\User
9d5131d3-8b4f-4833-ace0-97f33c71c40d	slow
9d5131d3-8ba3-4898-a52a-bac210bf758a	App\\Models\\User
9d5131d4-89ea-4f11-955c-dea4195bfa98	slow
9d5131d4-8ab5-4917-a6e1-8c60af522cbb	App\\Models\\Menu
9d5131d5-81da-4ba8-b5c4-9d66b7ee061f	App\\Models\\Menu
9d513314-6e67-431d-bdb4-4c05eb28ef52	App\\Models\\User
9d513315-2179-42d3-8b87-d96f526e8df0	App\\Models\\User
9d513317-856c-4ed1-9ceb-cb68f883f418	App\\Models\\User
9d513317-ed0f-45eb-bc6f-9803179fce3b	App\\Models\\User
9d513318-a08e-46fa-8044-bd78c33c0d95	App\\Models\\Menu
9d513319-845c-4571-8934-600952257d69	App\\Models\\Menu
9d513349-6d36-4616-992b-b9a3d77da767	slow
9d513349-6d9c-48fc-be1c-009b047bd464	App\\Models\\User
9d5133c2-f17b-490e-812a-cb0011c4daf3	App\\Models\\User
9d5133c3-8e5a-42a1-9513-5a28bb1a58f1	slow
9d5133c3-8eef-4d86-8ea2-69661f0302c9	App\\Models\\User
9d5133c5-923c-4250-85e2-a513e847e53a	slow
9d5133c5-92be-44fe-a1bf-88f0bde99481	App\\Models\\User
9d5133c6-4ad8-4c5c-848b-866ac838d671	slow
9d5133c6-4b3c-4605-9625-d1cc896f1b4c	App\\Models\\User
9d5133c8-6fc7-4fb0-a305-47d253132b05	slow
9d5133c8-705f-4883-9579-a3a75ca84238	App\\Models\\Menu
9d5133c9-10b2-4f4a-a6ba-a2d96254b2d1	App\\Models\\Menu
9d51345f-6ba3-4599-8413-61dda8eafa13	App\\Models\\User
9d51345f-d069-409d-a836-edd369bb748a	App\\Models\\User
9d513460-becf-4435-8663-ebfd7905325a	App\\Models\\User
9d513461-1c96-4719-ae9c-c72f2e1c492a	App\\Models\\User
9d513462-d758-42b3-af60-6bc09ffe6c84	App\\Models\\User
9d513463-99fb-4afe-bf77-4b4cafcfce67	slow
9d513463-9a55-4ad4-a140-19cf09953903	App\\Models\\User
9d513464-b97b-48bb-81d5-6821a59e4f1a	slow
9d513464-ba19-4c0d-82c6-7e21ba3026d1	App\\Models\\Menu
9d513465-d591-497f-aac6-bc694eb7a402	slow
9d513465-d5f0-4be6-94f9-193d1f635446	App\\Models\\Menu
9d51346e-ce6f-4a8f-8dc4-f5448647c660	App\\Models\\User
9d5134b3-0ee4-4a05-b360-d4f04b18e821	App\\Models\\User
9d5134b3-7084-491b-a182-f9fd3d1622ff	App\\Models\\User
9d5134b5-4401-4317-8b74-118704b09313	App\\Models\\User
9d5134b5-e5ee-4f75-b29c-a7e378082a28	App\\Models\\User
9d5134b6-f03f-45a0-9518-54211563e7ec	slow
9d5134b6-f0c3-4eca-9960-ecec86ab195f	App\\Models\\Menu
9d5134b8-2420-4d0e-893f-9495cdf4bc23	slow
9d5134b8-247c-4124-912f-cf2cc9a9cae0	App\\Models\\Menu
9d5134bf-8957-4bab-8440-47194c24968c	slow
9d5134c4-0fd6-4056-aac5-7588731f4c7c	slow
9d5134c4-1025-45fe-b0c0-b5cc132dfab1	App\\Models\\User
9d5134fd-2e5f-44a0-8184-ec2cb456fcd6	App\\Models\\User
9d5134fd-bef8-426e-8e27-efeab7f7f5fb	slow
9d5134fd-bf5c-4911-859c-57a7491238d7	App\\Models\\User
9d5134ff-984a-4e59-8062-7b8d214765f7	slow
9d5134ff-98db-40c5-89dd-845ef45c7061	App\\Models\\User
9d513500-5c96-45c5-bdea-4137f9fbf6ae	slow
9d513500-5cfd-4817-ba5a-1edbd4e643a3	App\\Models\\User
9d513501-b05b-4641-8a50-0f7ce7b11ee9	slow
9d513501-b0e5-476d-bef4-9e88d8cb408b	App\\Models\\Menu
9d513502-53ca-4a38-9588-073e27daa5c7	App\\Models\\Menu
9d51351a-ac13-4562-86fd-2e751ee34ce9	slow
9d51351a-ac8a-4e84-a630-fe1a56f3b0f9	App\\Models\\User
9d51353c-52e9-472e-8694-cd139398f42e	App\\Models\\User
9d51353c-f8ee-450a-86d1-c0e6b4d3b8c1	slow
9d51353c-f95a-42f2-88d7-fdc1e5a4e057	App\\Models\\User
9d51353f-98fd-477a-a310-688b99034233	App\\Models\\Menu
9d513546-3893-420a-a404-5890db207e25	slow
9d513546-38e6-47cf-aa0e-f4ef6064123f	App\\Models\\User
9d513597-1bce-424d-bc65-4bacef7da9ef	App\\Models\\User
9d513597-8238-4133-bfc9-63b4b4eba572	App\\Models\\User
9d513599-816f-4ba9-9e1e-e2f09600567a	slow
9d513599-81c7-4185-899e-951e231829c0	App\\Models\\Menu
9d5135a3-d2cb-4bba-82b7-b3dc864f54eb	App\\Models\\User
9d513613-4741-43eb-94e5-395f46c942d2	App\\Models\\User
9d513613-b09c-459b-935c-e21a953c66da	App\\Models\\User
9d513615-6381-4377-85c6-bcccf7ec2986	App\\Models\\User
9d513616-24db-40e7-9397-14a413d8be27	slow
9d513616-255e-4061-83c7-2141323014bd	App\\Models\\User
9d513617-57db-4ab9-ba85-7490feac832f	App\\Models\\Menu
9d513618-2139-4988-a882-6010dfd431e2	slow
9d513618-2189-4183-a027-008effd84efd	App\\Models\\Menu
9d513626-7683-464f-9d65-43c38b16b2ac	App\\Models\\User
9d51364d-13ca-4c05-aca9-53268597d56c	slow
9d51364d-1416-4b47-a030-071dfdfbc971	App\\Models\\User
9d51364d-8953-4e6a-990a-0cf540341165	App\\Models\\User
9d51364f-9738-49b4-9f53-9fab5c899b2f	App\\Models\\User
9d513650-ebd9-4c73-94aa-f41587974a62	App\\Models\\User
9d513652-2555-41ba-b824-cd891accc6ec	App\\Models\\Menu
9d513652-f7b9-4205-adc9-04651912e97e	App\\Models\\Menu
9d513654-e5d5-4317-87de-67fef5f745ab	App\\Models\\User
9d513655-7d31-4bae-9886-b34e92400296	App\\Models\\User
9d513658-a017-44db-ba43-e0092c576da4	App\\Models\\User
9d513659-8c95-4db6-bb3e-44a244849a5a	slow
9d513659-8d5d-4748-8d6e-bae0d5581552	App\\Models\\User
9d51365a-a0eb-4b30-a3ed-f6ad06881b32	App\\Models\\Menu
9d51365d-59b6-4824-99cc-f02ae99bbf79	App\\Models\\Menu
9d51365e-4011-4398-bf55-f4809e9466c2	App\\Models\\User
9d51365f-0d2b-4b50-a89d-af9a4a3eaf4b	App\\Models\\User
9d513661-d822-423e-8835-9a31901bf559	slow
9d513661-d8c6-4071-b6cf-08ff08c1883d	App\\Models\\User
9d513662-88ce-4d60-8881-0e5a1ff750ed	App\\Models\\User
9d513664-910f-4616-be09-f58d996c032b	App\\Models\\User
9d513665-7fbc-4643-b11c-3cef4ea97209	slow
9d513665-8058-44f0-8e50-1a4a73c2bf28	App\\Models\\User
9d513666-2494-496d-9d7d-0a0a45a06fda	App\\Models\\Menu
9d513667-29bc-4c14-819c-35e88fc9466f	App\\Models\\User
9d513668-6b6e-444d-9c9e-8128ed367a8c	slow
9d513668-6bf3-4698-b146-cd4e4d3c64e8	App\\Models\\User
9d51366a-f671-4da8-a89c-ce7817a092f6	App\\Models\\Menu
9d51366b-b5c3-420e-a0cd-74c1c88ba865	App\\Models\\User
9d51366c-7951-40b1-88e6-344c4c1817ec	App\\Models\\User
9d51366e-b40b-442a-b87d-73d122d10d3e	App\\Models\\User
9d51366f-7594-4224-bd90-e19524635668	App\\Models\\User
9d513671-883f-4fb2-97c6-9fce5b4b38c9	App\\Models\\User
9d513672-c76c-48ac-bb67-7558391a6c6f	slow
9d513672-c84b-4e7b-9e56-19fc28a3c517	App\\Models\\User
9d513673-d354-4a23-b665-dec95c9387b8	App\\Models\\Menu
9d513675-28e4-4373-a499-be9e2f63f0e6	slow
9d513675-2931-4d08-b67d-eea3e02b9c5f	App\\Models\\User
9d513675-8761-4220-b4fb-ade9f98001bd	App\\Models\\User
9d513677-86a7-44ca-bd81-1e3f39ad22b8	App\\Models\\User
9d513678-468f-4b0a-b36e-25ec48f6959e	App\\Models\\User
9d513679-2c53-4e11-95fc-cca5e103caca	slow
9d513679-2cb7-4879-8b68-5294fbe73f1e	App\\Models\\Menu
9d51367a-6646-4ded-b0a0-ce45f4c42f4f	slow
9d51367a-6690-4d68-a9bf-cefd974c6b95	App\\Models\\User
9d51367a-c979-4295-8797-f06b68408633	App\\Models\\User
9d51367c-684b-425b-a91d-9e282f3e1e95	App\\Models\\Menu
9d51367d-055d-4afa-94fe-81a8c0fc120d	App\\Models\\User
9d51367d-9a0e-4ca4-af10-7992c0d3ecee	App\\Models\\User
9d513680-33d8-4262-806c-0db4ff2d02e8	App\\Models\\Menu
9d5136a2-abb3-4c33-8e6a-65774995e2fe	App\\Models\\User
9d5136a3-1c59-452f-aca9-3ba3acf9d3ef	App\\Models\\User
9d5136a5-0b0b-481a-a9c2-1b099924be40	slow
9d5136a5-0b8b-48f5-be8b-560599ad62ce	App\\Models\\User
9d5136a5-c5bb-41c1-8c87-985c8c4adcf0	App\\Models\\User
9d5136a6-c83c-4bf0-b1d6-4721d57b2c6f	slow
9d5136a6-c8dd-4236-8589-d895dc1f9547	App\\Models\\Menu
9d5136a7-c644-45e8-90b3-e2a29a7a21b0	slow
9d5136a7-c6df-4484-99b9-d2db44636cb1	App\\Models\\Menu
9d513709-b986-43b2-b1d6-7ca84094812c	App\\Models\\User
9d51370a-1cb6-4f28-95a9-62d4657821d1	App\\Models\\User
9d51370b-b7bb-4f8c-bffc-033f036398c3	App\\Models\\User
9d51370c-5034-4058-9a52-a281847532a7	App\\Models\\User
9d51370d-9d4a-4c40-b4c8-d1d3ed811638	App\\Models\\Menu
9d51370e-a5e9-461a-ba6c-66bf302ea10a	slow
9d51370e-a633-47cf-a0c1-4744d60db4db	App\\Models\\Menu
9d513779-feb9-45f1-8e2d-d8cf2d994ce5	slow
9d513779-ff0f-43ce-8e76-b8baa1b4d9f8	App\\Models\\User
9d51377a-6621-4caf-bc6c-eabe53a5df5b	App\\Models\\User
9d51377c-25f5-49c3-9d8e-656a10cead7e	App\\Models\\User
9d51377c-c47f-4759-b005-68d03e089b7e	App\\Models\\User
9d51377e-3dd9-4181-9798-ad668b743c78	App\\Models\\Menu
9d51377f-0830-4a91-82ba-bd4050d66899	App\\Models\\Menu
9d5137a7-368c-428f-ad8f-6834133d2b23	App\\Models\\User
9d5137c0-d2c9-42b2-b42c-25e4bc4910de	slow
9d5137c0-d31d-4295-bce4-620a295eb98a	App\\Models\\User
9d5137c1-6c10-4b9a-b484-bb029754c6ba	slow
9d5137c1-6c62-4cc2-9697-5a0ab97077d8	App\\Models\\User
9d5137c3-716b-4773-bc00-7b82aea6442f	slow
9d5137c3-71ea-47b4-be8c-cdf251f730b4	App\\Models\\User
9d5137c4-1051-4173-9cc6-f13df2a573cf	App\\Models\\User
9d5137c5-4c46-42d3-81f5-8270b3589544	slow
9d5137c5-4caf-42f8-9e27-7943b3baa983	App\\Models\\Menu
9d5137c6-3c89-4b45-8002-78628ea26a59	slow
9d5137c6-3cdb-4f80-88d3-440afc06a796	App\\Models\\Menu
9d5137cf-ffad-494a-b11d-a5162308b22e	App\\Models\\User
9d513838-0eb4-41f9-96da-93ab8a404c7f	App\\Models\\User
9d513838-817b-47fe-a30d-e4a076f68786	App\\Models\\User
9d51383a-4dce-443b-b6c3-fc7166dad56f	App\\Models\\User
9d51383b-16e2-4cfa-82ed-c4e8137ffb77	slow
9d51383b-1764-4071-977c-266c5e6d2ee0	App\\Models\\User
9d51383c-617a-4cab-af6b-0bda3ef4e885	App\\Models\\Menu
9d51383d-1d75-4cad-8316-42b62ccee81e	App\\Models\\Menu
9d513887-7d99-43c7-82f9-802af8e29787	App\\Models\\User
9d513887-dd26-4aa1-abb2-d8c91b093894	App\\Models\\User
9d513888-b0e6-4001-8b35-7eefaf47dc19	App\\Models\\User
9d513889-189e-4835-b4b9-5c3017dde8a3	App\\Models\\User
9d51388a-bfd8-4754-b031-0a356721fa8d	App\\Models\\User
9d51388b-7928-4b72-841b-3f879e9b2017	slow
9d51388b-7993-46d8-9c0e-ecc716fad7c3	App\\Models\\User
9d51388c-8b2d-4bb4-9c07-4b81f7e78acd	slow
9d51388c-8bad-4c3f-9fd8-bdaf5dc67f0c	App\\Models\\Menu
9d51388d-3958-4743-aa52-b089f16d994c	App\\Models\\Menu
9d51389b-d6a5-4e8d-b7b9-68d7eb69b0fe	slow
9d51392c-5b5c-4402-a49e-03afdb742b69	slow
9d51392c-5bb5-42c9-a50c-7c23f0f4f7b7	App\\Models\\User
9d51392c-fc89-4bbd-be39-65ee6a61e5c7	slow
9d51392c-fce8-4c4c-8a17-9a3d61dc0013	App\\Models\\User
9d51392f-1872-4bd3-a9ac-7257fc0e9f35	slow
9d51392f-1903-4577-89be-6dfe428b6081	App\\Models\\User
9d51392f-95d0-48ba-84cc-3aa1ae4316de	App\\Models\\User
9d513930-b91d-4b78-945c-a05460d76178	slow
9d513930-b9b4-44ed-a107-5a5fc4713e7f	App\\Models\\Menu
9d513931-adca-48d9-a78d-b0d05d5a4256	slow
9d513931-ae2e-48cd-ad1e-a6dbadb13405	App\\Models\\Menu
9d51394e-5fba-4bd0-a60b-367ba622b3e2	App\\Models\\User
9d5220ef-d09b-4165-9a5f-05cd9c7de6fa	slow
9d5220ef-d186-4de7-8479-33a5233dc11f	App\\Models\\User
9d5220f1-0305-43e6-bea5-a167c89ded9a	slow
9d5220f1-03aa-4462-ae3c-d9e0a44be134	App\\Models\\User
9d5220f6-b8e7-48ef-a880-a5e67e758f62	App\\Models\\User
9d5220f9-2805-49ac-82a6-02c68b4876a9	slow
9d5220f9-28ba-4466-bcf8-2eb22f5b619a	App\\Models\\User
9d5220fb-3cb6-41ef-84ce-5471522e008b	slow
9d5220fb-3d34-40d2-b658-f45e77b1752f	App\\Models\\Menu
9d5220fd-8f80-48ff-a9ed-5c5a3d3f6633	App\\Models\\Menu
9d522175-ee41-42a2-8979-d49376779316	App\\Models\\User
9d522176-7d51-4a4f-89fb-87c3d838f307	slow
9d522176-7dba-46e1-859f-6d1aeda3f522	App\\Models\\User
9d522178-9ca9-4bfa-b647-68edcc6f882d	slow
9d522178-9d3a-490f-870a-0ced0078be17	App\\Models\\User
9d522179-39fe-43bc-b940-2e91943d1cd0	App\\Models\\User
9d52217a-0ea6-45c6-8064-8d65313d05fa	App\\Models\\Menu
9d52217a-c76e-4b91-b313-d84add0abd54	App\\Models\\Menu
9d5243d9-6432-4870-8f5c-13153027079f	slow
9d5243d9-6485-4921-a8f5-6b7725a8a963	App\\Models\\User
9d5243d9-ca3b-4b44-880b-f8bce033ae17	App\\Models\\User
9d5243db-ac3e-4a67-8ffa-b7815fc840b5	App\\Models\\Menu
9d5243ef-5a23-4da5-a3bf-e4fe45d945e8	App\\Models\\User
9d524731-1cef-449a-b599-94ea3bacd966	slow
9d524731-1d70-4c26-9d42-209daacf2f7b	App\\Models\\User
9d524731-bf74-42f2-a456-225cef2a91ac	slow
9d524731-bfd2-49d9-9510-a0b508a8ab64	App\\Models\\User
9d524735-5aa5-4314-a118-d3b485d7ed18	App\\Models\\Menu
9d524742-a2ab-440c-ba6a-f58f9bd08d46	App\\Models\\User
9d524743-2f82-411b-9b55-e484413936b0	slow
9d524743-2fd4-4756-9603-cf3df010a579	App\\Models\\User
9d524745-3c78-4b16-a530-4a7281ee47bb	App\\Models\\Menu
9d524757-33bb-4ce0-a4c0-7f78ec67b7e5	slow
9d52475a-ec17-421f-bb5e-f08be9b2b4f8	App\\Models\\User
9d524842-c0b5-4429-be23-941b35b5ad70	slow
9d524842-c114-4dca-b248-78f08b68a465	App\\Models\\User
9d524843-5b41-40ca-9008-219d9862873c	slow
9d524843-5ba7-4606-9913-4b450d46383d	App\\Models\\User
9d524845-c7a3-4e67-9311-0c7a4ba62c72	slow
9d524845-c843-4e8d-b991-620825358220	App\\Models\\Menu
9d52484a-d2e8-4e20-aa7d-be9c17574411	slow
9d524853-157b-41e0-86a2-a4b348f33290	App\\Models\\User
9d5248d3-2562-4b3f-bc6a-059b4792f9b5	App\\Models\\User
9d5248d3-cc47-490d-8728-e4debf0d16a0	slow
9d5248d3-cc9d-4d05-a74f-e0374d7998f8	App\\Models\\User
9d5248d6-26bc-4385-8447-ce4b29028bed	slow
9d5248d6-270c-4df4-8721-469105070dd9	App\\Models\\Menu
9d52492f-6c34-4074-83d1-5add7a09910d	App\\Models\\User
9d524930-00e9-405f-8e18-25cf7b1e1341	slow
9d524930-0134-4bb3-85f8-9d42db40192f	App\\Models\\User
9d524932-4463-4fa9-b470-aacbaa155fc5	App\\Models\\Menu
9d52493c-8ea4-434d-b484-831e68e04310	App\\Models\\User
9d524a7f-3810-4472-a9eb-9e64703364e2	App\\Models\\User
9d524a7f-bc78-436e-a6e4-544c78070868	App\\Models\\User
9d524a82-134e-46f1-8ccf-e76016de9d31	App\\Models\\Menu
9d524a8b-97c5-410e-b559-7b214c83bedb	App\\Models\\User
9d52d22c-a8e6-419c-a6dd-af74dd6f5059	App\\Models\\User
9d52d22d-8dec-40f6-a6ac-6bc67c59852f	App\\Models\\Loans
9d52d22d-8f84-49f9-bc5f-921d61f6a040	App\\Models\\ItemLoans
9d52d27a-3026-4c27-ab91-7f3f719a22e2	App\\Models\\User
9d52d27b-4bde-4427-955c-4dd8d1cce731	slow
9d52d27b-4c35-412f-91ec-db52bed3f773	App\\Models\\Loans
9d52d27b-4dee-4946-8160-e638b0e65c22	App\\Models\\ItemLoans
9d52d28b-9885-467f-a2d1-28bd5b8ebf16	slow
9d52d28b-98df-4884-987b-e5bc5f15f731	App\\Models\\User
9d52d28c-28f2-416a-a9ed-7fa4bcf25f0b	slow
9d52d28c-294d-4b00-a924-ebf50dd9e400	App\\Models\\User
9d52d28c-84df-47da-af9b-88fa92111935	App\\Models\\Loans
9d52d28c-8679-4430-8c25-9b7e0d68d4e3	App\\Models\\ItemLoans
9d52d28e-1662-41b2-ab90-dcbdc6694ef5	App\\Models\\Menu
9d52d31a-c81c-45ec-87af-e8f005ebbcf1	App\\Models\\User
9d52d31b-498d-4192-adcb-1e0f0eb2561d	App\\Models\\User
9d52d31b-c1d4-4055-832b-e746354a8f45	App\\Models\\Loans
9d525271-e8ee-4c90-9580-00d6b48d48eb	App\\Models\\Loans:24
9d525271-ea90-4f40-9169-4be352a27ba0	App\\Models\\ItemLoans:
9d525271-eb1d-4a1b-a1ce-720e8bedd2ab	App\\Models\\ItemLoans:
9d525271-eba4-4939-874c-260f08c80040	App\\Models\\ItemLoans:
9d525271-ec2a-44bb-bf90-19eb5c7bdb9b	App\\Models\\ItemLoans:
9d525271-ecc6-42b3-9912-481e396762c5	App\\Models\\ItemLoans:
9d525271-ed64-4003-b0c3-15b59bc84db6	App\\Models\\ItemLoans:
9d52546f-b499-4af5-94bc-0a51393c1a3e	App\\Models\\User
9d525470-1c2f-4c51-9d57-061aec591ccf	App\\Models\\User
9d525472-79cd-4b54-a242-176bb6844e40	App\\Models\\Menu
9d52548c-a88d-405f-9468-4f9fcd12918e	slow
9d52548c-a904-4d55-b5e2-11d9f748217d	App\\Models\\User
9d52548d-3828-4205-ac30-7b0bdb28baba	slow
9d52548d-387f-46ff-9176-dddc852fddac	App\\Models\\User
9d52548f-1b4d-44fc-8043-472025e1bcf3	slow
9d52548f-1b9e-4883-9037-ec7dd8dadf0c	App\\Models\\Menu
9d525501-f133-4869-b77e-9991a127d703	slow
9d525506-e159-4dd4-bdce-b0cfdce2a39d	App\\Models\\User
9d525523-1ade-44ac-93d1-c582d7ba3f09	App\\Models\\Loans:1
9d525523-1c59-4fae-af8c-8b4a7d86447e	App\\Models\\ItemLoans:
9d52d31b-c450-4c29-a763-e53b6bd3541d	App\\Models\\ItemLoans
9d52d31d-b798-410e-9b73-8cf5fd9afc70	App\\Models\\Menu
9d525523-1d6f-4020-bce2-bab6749f0a34	App\\Models\\ItemLoans:
9d525523-1e23-4ecc-8b89-a694a4449ae6	App\\Models\\ItemLoans:
9d525523-1eb1-419b-8736-ee0d31d425d4	App\\Models\\ItemLoans:
9d525523-1f67-41aa-9fac-ea087065a3b1	App\\Models\\ItemLoans:
9d525523-2020-4c29-9197-46b266216b99	App\\Models\\ItemLoans:
9d525677-0ca8-438a-b426-f5c04686e0a7	App\\Models\\Loans:1
9d525677-0e49-4410-b953-93ff1f35c354	App\\Models\\ItemLoans:
9d525677-0ee5-4405-95b9-ee52c9c3feb9	App\\Models\\ItemLoans:
9d525677-0f98-4e7d-8f78-1b5b968fa670	App\\Models\\ItemLoans:
9d525677-1073-4623-a1f2-3e1c5c905681	App\\Models\\ItemLoans:
9d525677-1141-49ff-92a8-57d3ab49c814	App\\Models\\ItemLoans:
9d525677-11ce-46b7-aaa3-6a7b9f11102a	App\\Models\\ItemLoans:
9d52582d-ecd3-4279-92c0-a98c2bee1a51	App\\Models\\Loans:2
9d52582d-ee99-487c-a6a5-e1e7b734d72d	App\\Models\\ItemLoans:
9d52582d-ef70-4b62-9eb5-be802ac5a93b	App\\Models\\ItemLoans:
9d52582d-f059-4280-8b04-5511622324ae	App\\Models\\ItemLoans:
9d52582d-f13a-4b66-9bb0-7e7e565a2fcf	App\\Models\\ItemLoans:
9d52582d-f225-43ed-b5fe-32c6c108c230	App\\Models\\ItemLoans:
9d52582d-f315-48e2-8338-74d833cf9c92	App\\Models\\ItemLoans:
9d52582f-d1be-409b-b111-929b7abe2217	App\\Models\\Loans:3
9d52582f-d33c-4543-939a-c5ae238b33d4	App\\Models\\ItemLoans:
9d52582f-d3c8-4ba0-a48c-81ef63ea78f3	App\\Models\\ItemLoans:
9d52582f-d472-4acb-9a07-b15ba91a65e3	App\\Models\\ItemLoans:
9d52582f-d50f-4610-8856-7afbeef56faf	App\\Models\\ItemLoans:
9d52582f-d598-4d76-82ed-45a48f3d1c7c	App\\Models\\ItemLoans:
9d52582f-d61c-440f-ae85-bfe1117630b6	App\\Models\\ItemLoans:
9d525831-a3d8-4cb2-a8e5-5bbc15a73a26	App\\Models\\Loans:4
9d525831-a577-429a-a2b0-7810ba304948	App\\Models\\ItemLoans:
9d525831-a63f-4fda-a265-9b2119d39daf	App\\Models\\ItemLoans:
9d525831-a6fb-4ad1-a906-b2a37e455474	App\\Models\\ItemLoans:
9d525831-a7a2-4676-a011-968b335b5628	App\\Models\\ItemLoans:
9d525831-a855-499b-9bb3-252d2aa1369e	App\\Models\\ItemLoans:
9d525831-a92f-4125-802b-ca4f2de1d81c	App\\Models\\ItemLoans:
9d525833-7603-4522-bca5-578d31ea72d0	App\\Models\\Loans:5
9d525833-77c2-457c-a1d8-121aa6fbb1fa	App\\Models\\ItemLoans:
9d525833-7876-418d-8adb-64e7b7e02377	App\\Models\\ItemLoans:
9d525833-7933-4595-8fcb-564a4a8ffe1a	App\\Models\\ItemLoans:
9d525833-79c8-4afc-adce-4532df5ef074	App\\Models\\ItemLoans:
9d525833-7a50-468b-bc97-52b4e9cea86a	App\\Models\\ItemLoans:
9d525833-7ae3-48fe-b63c-2ec82b9e9159	App\\Models\\ItemLoans:
9d525834-cdbe-4808-80ee-c82ccb5f01d1	App\\Models\\Loans:6
9d525834-cf3d-46d4-b4f6-d634937385d2	App\\Models\\ItemLoans:
9d525834-cfdc-4fe4-b0c1-6351e6500e19	App\\Models\\ItemLoans:
9d525834-d08f-4095-b79a-3bb8f214fbb3	App\\Models\\ItemLoans:
9d525834-d14b-41bb-a9cf-17fa9370dfaa	App\\Models\\ItemLoans:
9d525834-d205-40bf-bbc4-6decba203afa	App\\Models\\ItemLoans:
9d525834-d2a2-4eda-a129-1bc56338b3e2	App\\Models\\ItemLoans:
9d525836-3067-4e7c-a047-7e66ecf10070	App\\Models\\Loans:7
9d525836-31fd-413d-8cc1-ca3372953c18	App\\Models\\ItemLoans:
9d525836-32c2-47f1-88e7-2cd01a2d919e	App\\Models\\ItemLoans:
9d525836-336b-4609-a1d2-66fba01d31a0	App\\Models\\ItemLoans:
9d525836-33fe-4bc8-a4e2-e0bd2cd25611	App\\Models\\ItemLoans:
9d525836-348a-4dc7-adcf-23a8674200ba	App\\Models\\ItemLoans:
9d525836-3515-4de5-a730-fda94796b77d	App\\Models\\ItemLoans:
9d525837-e8c2-4750-a768-9132083c72e9	App\\Models\\Loans:8
9d525837-ea47-40b9-b97a-e44786c1b570	App\\Models\\ItemLoans:
9d525837-eaea-42e6-87d6-b55dbd47bd7d	App\\Models\\ItemLoans:
9d525837-eb7c-4197-b127-1fbd4a3d4393	App\\Models\\ItemLoans:
9d525837-ec00-490a-b631-5e7dff449ce1	App\\Models\\ItemLoans:
9d525837-eca6-4514-bc11-d64a8bac5149	App\\Models\\ItemLoans:
9d525837-ed26-4675-8da6-7ad557658d0c	App\\Models\\ItemLoans:
9d52583a-379b-40e9-8044-9d3edadeb29d	App\\Models\\Loans:9
9d52583a-392d-4d47-9b6a-a4462f534ada	App\\Models\\ItemLoans:
9d52583a-39b4-460a-820a-716f2669e9c6	App\\Models\\ItemLoans:
9d52583a-3a38-41fe-9f19-b5003c057a2e	App\\Models\\ItemLoans:
9d52583a-3ac8-498b-a3e9-e023d24fbb7d	App\\Models\\ItemLoans:
9d52583a-3b6b-4715-8af2-f25b2c3857b1	App\\Models\\ItemLoans:
9d52583a-3bf7-48a1-9b29-29d3561c2878	App\\Models\\ItemLoans:
9d52583c-ca7c-4427-aa8d-1483b612175b	App\\Models\\Loans:10
9d52583c-cbe6-48f7-aec1-1c83d96ed628	App\\Models\\ItemLoans:
9d52583c-cc78-4b34-8699-3711aafd3129	App\\Models\\ItemLoans:
9d52583c-cd2b-441f-87d3-ac86c6033438	App\\Models\\ItemLoans:
9d52583c-cdfb-431c-9a2c-95dcec373cef	App\\Models\\ItemLoans:
9d52583c-cec5-470c-bea7-0c660b5a0dd7	App\\Models\\ItemLoans:
9d52583c-cf66-4948-8b8b-2519bf2298bb	App\\Models\\ItemLoans:
9d52598c-b12b-45b7-94d2-dd1f73439ab0	App\\Models\\Menu
9d5259b4-3e26-40d4-918f-a1cb2701c376	slow
9d5259b4-3e8f-4ea1-aa70-9b722d7cac14	App\\Models\\Menu
9d5259d3-2924-42a6-a8e1-491c60f58e31	App\\Models\\Menu
9d52605d-5bbd-4882-acfa-1c9960b88962	App\\Models\\Menu
9d5261e2-32a3-4693-b491-0aa20aed2a37	slow
9d5261e4-5744-4793-8174-b9470eaaa4df	App\\Models\\Menu
9d526209-51bb-447c-a1e3-a6a0e20cfc6b	App\\Models\\Menu
9d5262b3-5454-43b5-be58-22c3cb23055e	slow
9d5262b3-54ee-41fc-9683-62d406f833c7	App\\Models\\Menu
9d526319-c7b2-4552-b563-5799c61b883d	slow
9d526319-c86f-4729-8ad0-aeacaada284e	App\\Models\\Menu
9d5263a9-533a-4b3f-b5c7-cf57aecc7cb3	App\\Models\\Menu
9d52640b-76dd-4327-b8e8-fa6345f5f46f	App\\Models\\Menu
9d52641d-3845-4fb7-b77b-5c5ccab9d10c	App\\Models\\Menu
9d52643c-8053-4448-a0fc-bbf0e3e53544	App\\Models\\Menu
9d52647a-3ba5-4868-8b39-71ea50ba8e6d	slow
9d52647a-3c18-4dd7-ac2a-cb837c2500ac	App\\Models\\Menu
9d52648a-611a-4a2c-8041-3e91dc480a9e	App\\Models\\Menu
9d5264d1-7784-440c-801e-cdb56bedf57f	slow
9d5264d4-5a61-4170-add3-e4b4de49fd13	slow
9d5264d4-5b1c-495d-bf3f-8c9fa812d426	App\\Models\\Menu
9d5264f5-7912-4850-8000-63d841135189	App\\Models\\User
9d5264f6-01b5-4fa3-a65f-907255e8846d	App\\Models\\User
9d526503-d2d5-4ccb-86cd-43076e0609a5	slow
9d526507-26a3-4982-be89-977762f21365	slow
9d526507-2701-4416-8ca2-1f935bec756b	App\\Models\\User
9d526527-44c0-48c1-b9e1-a6d2f512fed3	App\\Models\\Loans:11
9d526527-4707-434b-8c6f-f1fe72d388e3	App\\Models\\ItemLoans:
9d526527-47d6-4f0b-b3de-122c93b27389	App\\Models\\ItemLoans:
9d526527-48a9-4e56-9925-68a40379a381	App\\Models\\ItemLoans:
9d526c70-a5b7-462c-96a4-1a7b37008755	slow
9d526c70-a64b-4c48-962f-7865c1316868	App\\Models\\Menu
9d526c71-e535-42fe-947f-d3f669b383cd	App\\Models\\Menu
9d526c74-ac7d-4f18-ad53-13c00da4c0a6	App\\Models\\User
9d52d09e-7d49-447b-ac0a-716bdc34ba37	App\\Models\\User
9d52d0aa-01b2-4c3b-9bf3-3f8ee42a634e	App\\Models\\User
9d52d0ab-07e7-4dac-a8bb-0116d6ab6ddd	App\\Models\\Menu
9d52d0d8-9f7d-4bf3-b4e6-d2d91004a456	slow
9d52d147-803c-4c4a-980f-c7001ad29378	slow
9d52d147-8093-4058-a842-d6d9a0e6aee7	App\\Models\\Menu
9d52d15b-4ba0-415f-a1a1-554126b4f8fd	slow
9d52d15d-2c11-457d-8ed4-9074a8e71761	App\\Models\\Menu
9d52d15f-9fe1-4a02-8531-288a583f401c	App\\Models\\User
9d52d160-028f-422d-b977-3d55a45c210c	App\\Models\\User
9d52d160-63b1-4da6-8f50-c0a839854970	App\\Models\\Loans
9d52d160-6d22-4500-b8f9-a499765beaf9	App\\Models\\ItemLoans
9d52d22d-2b80-4ec6-81a7-8ce2a4ed3248	slow
9d52d22d-2bce-4d6e-98f8-865013a4f394	App\\Models\\User
9d52d22f-71f2-4c2b-8e22-230962ad9535	App\\Models\\Menu
9d52d27a-aa9c-4a44-bc6d-34c6cb7dbdae	App\\Models\\User
9d52d27c-ef62-4369-ae90-8459345c8790	App\\Models\\Menu
9d52d33e-a166-4693-b3c5-20636f898c1c	App\\Models\\User
9d52d33f-2f97-4f07-8c80-e3976f840da2	slow
9d52d33f-2fe4-4c1f-9410-14cec33d6935	App\\Models\\User
9d52d33f-8d06-4bb2-9e03-d04d4d83d566	App\\Models\\Loans
9d52d33f-8e98-4c3b-95e8-50cc5f5d77cd	App\\Models\\ItemLoans
9d52d341-0260-4093-bfe6-22a1fa05f7a6	App\\Models\\Menu
9d52d392-f84d-4988-9b05-483e9a1befe0	App\\Models\\User
9d52d393-877e-4557-a98b-f6c1655c686e	slow
9d52d393-87c6-40ed-b86c-b4f21153b0a8	App\\Models\\User
9d52d393-de8c-4aca-8bea-b34782c76144	App\\Models\\Loans
9d52d393-e02a-4c52-abd4-d522daed8aaf	App\\Models\\ItemLoans
9d52d3a8-817a-464f-aed4-f19aa256908e	App\\Models\\User
9d52d3a8-eb2c-4856-8c03-b385d8388d27	App\\Models\\User
9d52d3a9-741c-44e4-a164-a3d3cc47acec	slow
9d52d3a9-7467-4ab1-9a77-56cd3064646c	App\\Models\\Loans
9d52d3a9-75f3-4644-a441-a02110ff807c	App\\Models\\ItemLoans
9d52d3ab-8d1e-47f6-b044-eebe2193beaa	slow
9d52d3ab-8d6b-42bc-aa80-9018044d5a32	App\\Models\\Menu
9d52d3d0-ab99-40b5-8c1a-a82c37aa52f3	App\\Models\\User
9d52d3d1-30d4-446b-976c-b76a46c0ab47	slow
9d52d3d1-311c-4c02-a1ff-9063d3259037	App\\Models\\User
9d52d3d1-8c05-4927-8250-a6df9777a8fe	App\\Models\\Loans
9d52d3d1-8d80-4e1e-8cbc-5cc4030968dd	App\\Models\\ItemLoans
9d52d3d3-3b71-4555-9cc5-74894136bc88	slow
9d52d3d3-3bbf-4694-9612-3d004aa7306d	App\\Models\\Menu
9d52d4cf-5aee-4029-8b87-708e23cfc3c6	slow
9d52d4cf-5b43-40ac-94bf-44517d1d9cdb	App\\Models\\User
9d52d4cf-b941-48fe-9b28-f5bbaa2baf0c	App\\Models\\User
9d52d4d0-14c7-458b-9eb1-415c972df181	App\\Models\\Loans
9d52d4d0-1685-43ba-9a07-302f00812f0a	App\\Models\\ItemLoans
9d52d4d1-f71e-4c94-acf8-5ad23b785b7e	App\\Models\\Menu
9d52d502-f532-4d31-aef8-a36e22dbc684	App\\Models\\User
9d52d503-5142-400a-bd5a-3611d6262438	App\\Models\\User
9d52d503-b091-489b-9a9b-9cd59b1afe58	App\\Models\\Loans
9d52d503-b246-4ab0-b47b-d0e68e804757	App\\Models\\ItemLoans
9d52d505-3f75-4493-89f8-614c4bcecd0d	App\\Models\\Menu
9d52d53f-c473-4176-87ae-fe3c81306b33	App\\Models\\User
9d52d540-6787-44af-a401-e255e7a7e414	slow
9d52d540-67db-47df-83f8-a7c0cb320edd	App\\Models\\User
9d52d540-e906-448f-b416-55dc20573664	App\\Models\\Loans
9d52d540-eabc-499a-ad5b-a94da9708f59	App\\Models\\ItemLoans
9d52d542-e8a8-4d0f-ade7-0925be5e385f	App\\Models\\Menu
9d52d560-5878-4ac8-8426-37edf27debbc	App\\Models\\User
9d52d560-b533-4ff2-84d3-451c9356af48	App\\Models\\User
9d52d561-12e3-4768-9ab5-79ae443b6a1d	App\\Models\\Loans
9d52d561-1486-4deb-8eee-af87b8fe1f14	App\\Models\\ItemLoans
9d52d562-ba53-4f49-92af-1addeb45220d	slow
9d52d562-bab5-4285-ad14-b126d63e6000	App\\Models\\Menu
9d52d587-dd05-4051-9ade-94d5b471c0e3	App\\Models\\User
9d52d588-3c35-43c0-80eb-3319bbc61df7	App\\Models\\User
9d52d588-9f7f-4900-8ecd-624e7b3cfb35	App\\Models\\Loans
9d52d588-a106-413a-99c0-d79e2fe34ce4	App\\Models\\ItemLoans
9d52d58a-572a-4e0b-87c2-c4c63020b260	App\\Models\\Menu
9d52d5a6-5a0f-41b3-9232-225f89d187b8	slow
9d52d5a6-5a79-4e3e-ae13-3cbe58779c5e	App\\Models\\User
9d52d5a7-4f71-4740-be7a-f13e1cb44d6c	App\\Models\\User
9d52d5a8-13c8-4edb-a94d-7c0c796f61d0	slow
9d52d5a8-1468-4519-b0cc-f0d28e5e8c41	App\\Models\\Loans
9d52d5a8-1775-4fd0-a177-30b487c454d5	App\\Models\\ItemLoans
9d52d5aa-138c-413b-b0ea-1aae90619405	App\\Models\\Menu
9d52d5ab-aaaa-467b-87aa-6633ec2b8832	App\\Models\\User
9d52d5ac-3b25-4ac6-983d-f77fcf2d4a2d	slow
9d52d5ac-3b88-4213-98cf-35ec7b063908	App\\Models\\User
9d52d5ac-986e-46f1-8526-41a71fcd771c	App\\Models\\Loans
9d52d5ac-9a45-4930-a220-2b7c28ab811e	App\\Models\\ItemLoans
9d52d5ae-662c-4e5a-9afc-2c02fb048258	slow
9d52d5ae-667b-4d68-9988-3a7cc9c577b0	App\\Models\\Menu
9d52d5f0-1e5f-4fd6-aa86-14ee323af1c3	App\\Models\\User
9d52d5f0-b4ae-4b56-b0e8-5f728d76305c	slow
9d52d5f0-b500-410f-a21b-f28db601eacc	App\\Models\\User
9d52d5f1-29f3-442f-a1cc-8ef9d35564eb	App\\Models\\Loans
9d52d5f1-2bef-4768-8ecb-7a43bd6d8ed2	App\\Models\\ItemLoans
9d52d5f3-06c2-4d1b-96b5-885f4139b83c	App\\Models\\Menu
9d52d747-c8c4-452c-9bb6-e82ccf6918c0	App\\Models\\User
9d52d748-55be-45c2-b76c-618db2de257f	slow
9d52d748-5617-4788-85a0-1faec45d9661	App\\Models\\User
9d52d748-bb77-4fd6-b294-9857c88b60e6	App\\Models\\Loans
9d52d748-bd40-4a9c-8cb0-772906410cde	App\\Models\\ItemLoans
9d52d74b-12cc-40e0-8e88-59ab34442c3b	slow
9d52d74b-132e-4351-8b93-4d9455aa98e8	App\\Models\\Menu
9d52d81d-9f7f-4ced-a0e5-70ffae19e359	App\\Models\\User
9d52d81e-2c62-4234-a2e2-891196a5a666	App\\Models\\User
9d52d81e-bd03-4ad3-ab36-e95d25fc6ea0	slow
9d52d81e-bd71-4de2-a4ee-da4ab9d6f5ec	App\\Models\\Loans
9d52d81e-bf00-4904-87e8-c25fd80fc6bf	App\\Models\\ItemLoans
9d52d820-d9af-4449-a455-3dab16cdb82f	slow
9d52d820-d9f8-4268-98b6-0b832bd48d1d	App\\Models\\Menu
9d52d864-2c87-4719-a820-1aec50b3863f	App\\Models\\User
9d52d864-a28d-4aa2-b6d3-51ba87c33d2b	App\\Models\\User
9d52d865-1005-439e-bf85-4fa41262879f	App\\Models\\Loans
9d52d865-11ba-47f4-aa6f-53b94a1ba1d2	App\\Models\\ItemLoans
9d52d866-fca9-48e3-90e4-85fc09cef0ac	App\\Models\\Menu
9d52d9a0-a0c3-4c37-a63b-7fb610fc652d	App\\Models\\User
9d52d9a1-19ca-471a-a22f-7cc967afa63b	App\\Models\\User
9d52d9a1-8e6d-4e03-8ef5-3660293fec2c	App\\Models\\Loans
9d52d9a1-90f8-44f6-b34c-2c95ed2c7b9e	App\\Models\\ItemLoans
9d52d9a3-f57a-4535-b906-24d1d35ddd18	slow
9d52d9a3-f5d6-4473-b3a4-f7e2c1de2e3d	App\\Models\\Menu
9d52d9db-432e-4079-ac34-7ecdd4c1b335	App\\Models\\User
9d52d9db-d1e0-4e5b-bccb-f617ae70b13f	slow
9d52d9db-d226-438c-a8bc-6790667b7b4d	App\\Models\\User
9d52d9dc-3833-43fd-954c-23cb622e04f8	App\\Models\\Loans
9d52d9dc-39f4-434c-83ae-8396aaf68ab2	App\\Models\\ItemLoans
9d52d9de-847d-4442-8705-436dfc095dbb	App\\Models\\Menu
9d52da97-e04f-4146-8d7d-fe38be3a328e	App\\Models\\User
9d52da98-a1f8-427d-8df7-054deefd877e	App\\Models\\User
9d52da99-3e9a-44ad-8db0-ae12b910ec04	App\\Models\\Loans
9d52da99-461e-49c0-886c-6fb56c7812a3	App\\Models\\ItemLoans
9d52da9b-3d6d-4ce1-b8c5-b1b77ab22a15	App\\Models\\User
9d52da9b-eebc-440c-b42b-251c99dd10a8	App\\Models\\User
9d52da9c-8933-4b16-904e-79744f343398	App\\Models\\Loans
9d52da9c-8cb0-4fe7-aeea-b958ea085647	App\\Models\\ItemLoans
9d52da9d-f226-4675-ab29-543c1df8c89d	App\\Models\\User
9d52da9e-58cc-40a7-a5bd-f74f961d429e	App\\Models\\User
9d52da9e-ba2c-496a-a017-e958b1ffc606	App\\Models\\Loans
9d52da9e-bc01-4c29-a51c-903a354c8f5f	App\\Models\\ItemLoans
9d52daa0-edb5-4fab-b2fb-0c102a95a0c1	slow
9d52daa0-ee14-4e15-9e47-e4b933812359	App\\Models\\Menu
9d52dab9-1c5d-4d29-84e0-c24a44f3fb8c	slow
9d52dab9-1cc3-4280-ad48-08f685b6e7bc	App\\Models\\User
9d52dab9-88c3-4257-8768-6a5cc3ef2d0c	App\\Models\\User
9d52dab9-ea63-4d11-9584-f0d4045accd4	App\\Models\\Loans
9d52dab9-ec19-4df7-85d6-da640d8c0b26	App\\Models\\ItemLoans
9d52dabb-c505-4454-9489-44305512d0b5	App\\Models\\Menu
9d52dad2-d952-483b-9fca-1892751326f1	App\\Models\\User
9d52dad3-3d45-46d8-accd-2d2cd6c88e0f	App\\Models\\User
9d52dad3-cb35-47a5-b732-3ffc4204d1b1	slow
9d52dad3-cb92-496b-8adb-7de7274e6a68	App\\Models\\Loans
9d52dad3-cd66-4353-85d5-985e9071453b	App\\Models\\ItemLoans
9d52dad5-d1b1-40d3-8daa-a7c7418f1829	slow
9d52dad5-d1f7-477a-8679-191ed98a91b6	App\\Models\\Menu
9d52db68-1f73-4341-8a46-e3490c90abea	App\\Models\\User
9d52db68-94df-4f13-ab1b-3b5fc93e3c41	App\\Models\\User
9d52db69-441e-475d-afae-b85ddee8bd35	slow
9d52db69-4477-408f-a559-49a4245dfe6e	App\\Models\\Loans
9d52db69-4625-458f-814c-209579e862cc	App\\Models\\ItemLoans
9d52db6c-1d4a-4ffd-b333-a64a3f895078	slow
9d52db6c-1daa-48bf-94b5-fa15c9231a41	App\\Models\\Menu
9d52db74-1d10-436b-a645-7ad2862d945d	App\\Models\\User
9d52db74-7ba9-4ef7-bcf6-fd97b7bd4ba0	App\\Models\\User
9d52db74-e1d6-4516-bbca-0fd6ed1af662	App\\Models\\Loans
9d52db74-e3a7-426e-aa3d-e2cb45f21826	App\\Models\\ItemLoans
9d52db76-85bc-45f6-8860-3e56496c4a07	App\\Models\\Menu
9d52db8e-f262-409f-8f01-329edf0ffce7	slow
9d52db8e-f2c1-41b7-9c90-70cb2a84422f	App\\Models\\User
9d52db8f-5a79-45a5-8147-590f896a9e84	App\\Models\\User
9d52db8f-e0fa-4c96-99be-e3438f47ac52	slow
9d52db8f-e15d-404d-ac84-72372e13a50d	App\\Models\\Loans
9d52db8f-e310-4854-a95f-fad9fbbf8636	App\\Models\\ItemLoans
9d52db91-b60d-4ccf-9ea4-19681b9dc31c	App\\Models\\Menu
9d52dc3d-a762-4573-ab95-bfde4abf1bfe	slow
9d52dc3d-a7c6-446b-a325-b30efb2c6fb1	App\\Models\\User
9d52dc3e-24ed-43f7-802f-c76e75653890	App\\Models\\User
9d52dc3e-a3a6-4f4e-b6c1-99379c5b44bc	App\\Models\\Loans
9d52dc3e-a5af-4af4-b372-0404ae6128f0	App\\Models\\ItemLoans
9d52dc41-5de1-4112-8775-2b641ababc50	App\\Models\\Menu
9d52dcb5-fc97-4ab3-9eb3-8509d02106c5	App\\Models\\User
9d52dcb6-79cf-4352-ab62-f92d3b3344b0	App\\Models\\User
9d52dcb6-f163-4a92-b3c3-23e4bd4b4f2c	App\\Models\\Loans
9d52dcb6-f40e-4857-9c0d-74381e2045d5	App\\Models\\ItemLoans
9d52dcb8-f7f5-48ba-ae8e-4585065f7f2a	App\\Models\\Menu
9d52dcd9-c0ae-4ee9-a428-a760e1812ab0	App\\Models\\User
9d52dcda-29fc-4200-8e91-c5c86a065d64	App\\Models\\User
9d52dcda-8bf0-4655-a88f-d3333b7fa001	App\\Models\\Loans
9d52dcda-8d93-4959-8892-2476284a5bc2	App\\Models\\ItemLoans
9d52dcdc-2128-4678-b933-7b52638e1602	App\\Models\\Menu
9d52dd10-5906-401d-bb1c-ce5a19b92167	App\\Models\\User
9d52dd10-c99d-4c19-bb87-55dbe0f9e04e	App\\Models\\User
9d52dd11-462e-4e81-9e1f-ea0e9c1c854b	App\\Models\\Loans
9d52dd11-4859-4812-bcb0-be3c871369e5	App\\Models\\ItemLoans
9d52dd14-3fc4-42c1-8626-bd22b5054ae9	slow
9d52dd14-4034-46f4-8468-d1fc5975a359	App\\Models\\Menu
9d52dd20-241a-4564-8889-8aed5d767a2f	App\\Models\\User
9d52dd20-88b5-48d2-a993-a6b323c428ac	App\\Models\\User
9d52dd21-05e7-4ad5-83ed-b4527e3b5bd7	App\\Models\\Loans
9d52dd21-080a-47a8-bc49-c9aef0486c81	App\\Models\\ItemLoans
9d52dd23-9aba-42f8-b859-656155838216	slow
9d52dd23-9b63-4bc8-8ab3-796e87834a4f	App\\Models\\Menu
9d52dd29-b9b6-4d14-bb38-cc7c36e3f499	App\\Models\\User
9d52dd2a-2380-4532-9e54-5521c25ab8a5	App\\Models\\User
9d52dd2a-90af-430a-a0a8-fc1efaac32d9	App\\Models\\Loans
9d52dd2a-92d9-496c-9a08-c5d7bc922b7d	App\\Models\\ItemLoans
9d52dd2c-ac67-4d7d-b1aa-a270a4ce057b	App\\Models\\Menu
9d52dd33-8774-42f8-9325-9ea25fa6b647	App\\Models\\User
9d52dd33-fabf-4287-b643-1be07380b42e	App\\Models\\User
9d52dd34-66c7-434e-9b9a-ec8d151de4fa	App\\Models\\Loans
9d52dd34-6963-4fc2-a9bc-9f165614646f	App\\Models\\ItemLoans
9d52dd36-128d-40b3-98d5-0aae897224be	App\\Models\\Menu
9d52dd5f-6a7a-4990-8914-4f82742a233c	App\\Models\\User
9d52dd5f-cdc4-4e9e-9aec-3ab4043cf721	App\\Models\\User
9d52dd60-53c8-4250-9f7f-09dd4679942e	slow
9d52dd60-542e-4c9f-bb97-4b73eedcf0b1	App\\Models\\Loans
9d52dd60-55fc-42f5-a316-1cabced21470	App\\Models\\ItemLoans
9d52dd62-237d-4e54-b8fd-82d551cd6cb8	App\\Models\\Menu
9d52dd74-0076-479f-bd91-dc4c5b5ad77f	App\\Models\\User
9d52dd74-63d1-40aa-98f6-53fa8c3ce1c0	App\\Models\\User
9d52dd74-c166-4fa1-aa1a-e9360c6f6907	App\\Models\\Loans
9d52dd74-c33c-4e2b-864b-02697392846a	App\\Models\\ItemLoans
9d52dd76-3fde-4008-a339-39137feabc87	slow
9d52dd76-4050-4585-8e31-d7ada7febc7f	App\\Models\\Menu
9d52ddab-c81a-4ae5-94d9-dcd9fe997179	App\\Models\\User
9d52ddac-724c-475b-8de1-5ef63ec95a28	slow
9d52ddac-72a3-4b75-a32e-267a2dde243c	App\\Models\\User
9d52ddac-faf5-4be9-9fe8-6844c78a7f7b	App\\Models\\Loans
9d52ddac-fd53-43d7-bfca-78f4fe038f30	App\\Models\\ItemLoans
9d52ddaf-4435-4692-a354-261c68d5c896	App\\Models\\Menu
9d52df51-d159-47a3-830c-08f07ccd2346	App\\Models\\User
9d52df52-31dc-49c2-bd4a-7bd79b8b52d6	App\\Models\\User
9d52df52-917c-4251-8d19-f49e5d39ae40	App\\Models\\Loans
9d52df52-9340-4725-ad6a-73e0f59608d2	App\\Models\\ItemLoans
9d52df53-631c-43cf-a21b-3f4545a496f2	App\\Models\\User
9d52df53-ed27-41ca-bb08-f13adff300ff	slow
9d52df53-ed95-405c-ad5f-57b2d567359f	App\\Models\\User
9d52df54-4a65-49ea-ac6a-f83654c0a767	App\\Models\\Loans
9d52df54-4beb-4f5c-b76a-581100b9dfd9	App\\Models\\ItemLoans
9d52df56-48da-4f5e-a987-757302280dfa	App\\Models\\Menu
9d52df62-26d1-4f22-bd5d-1a059ca043d2	App\\Models\\User
9d52df62-f926-4907-91bc-0380a9b7b41d	App\\Models\\User
9d52df63-b53f-4785-beee-1577bbfe9b04	slow
9d52df63-b58e-4708-9490-c6c47671c925	App\\Models\\Loans
9d52df63-b75c-45af-94e6-313cab648d0f	App\\Models\\ItemLoans
9d52df65-8692-403a-8f9e-9702c3456ccc	App\\Models\\Menu
9d52df69-45a1-467a-a9de-85e163149492	slow
9d52df69-462a-49a0-8436-a6613c596ea7	App\\Models\\User
9d52df69-d2fd-4478-93ef-5c660c6b43f8	App\\Models\\User
9d52df6a-3ff5-435a-ae83-0408a5ca7477	App\\Models\\Loans
9d52df6a-4197-4f5f-be73-1386a222552a	App\\Models\\ItemLoans
9d52df6c-2755-4ef9-aa4f-f1033ca56d29	App\\Models\\Menu
9d52df6f-9168-4cb8-add9-d9b7c8f4b351	App\\Models\\User
9d52df70-1a7f-4678-ba6c-41d988a7dd80	App\\Models\\User
9d52df70-d10f-44b5-b289-f77350da1d31	slow
9d52df70-d15a-4de2-bc80-3d8578c22586	App\\Models\\Loans
9d52df70-d32d-4791-b803-233c279710d5	App\\Models\\ItemLoans
9d52df72-3185-4d4a-9869-ebbb71259630	App\\Models\\Menu
9d52df81-069d-493d-acf7-6c0857f8c2a7	App\\Models\\User
9d52df81-94c2-492e-94fe-fa00235b3abb	slow
9d52df81-9519-4b52-bcb9-37e9768cd377	App\\Models\\User
9d52df82-23a8-4492-b5af-d5671c3d30a0	slow
9d52df82-23f3-4023-bed4-465f969e6ff9	App\\Models\\Loans
9d52df82-25dd-427f-82bb-4d82e59bbca5	App\\Models\\ItemLoans
9d52df84-012d-4d97-a961-178f0e9fb814	slow
9d52df84-01ac-49d5-a678-d880ced428c5	App\\Models\\Menu
9d52df9d-c4ea-48f9-bd57-a36e37d4ec23	App\\Models\\User
9d52df9e-3628-44ca-8e2d-3456167477f2	App\\Models\\User
9d52df9e-a620-43c3-a903-8929004cafaa	App\\Models\\Loans
9d52df9e-a806-4e87-bb97-4524ac4087b0	App\\Models\\ItemLoans
9d52dfa0-0997-4289-bc80-e0e19deb2186	App\\Models\\Menu
9d52dfae-3205-42d8-9c42-ac75075d8136	App\\Models\\User
9d52dfae-afa4-4475-8ae3-ae5c09fc65ae	App\\Models\\User
9d52dfaf-2758-46f1-ab9c-39c18fa3dbf1	App\\Models\\Loans
9d52dfaf-2937-4409-8e1e-4b357d885a6d	App\\Models\\ItemLoans
9d52dfb1-165c-4f72-b57c-7fac80b36117	slow
9d52dfb1-16ce-4092-89c8-daff6d15e4a0	App\\Models\\Menu
9d52e036-41a8-4b9f-b456-384cd0df48ff	App\\Models\\User
9d52e036-dff4-4376-b6af-daeb08b56383	slow
9d52e036-e05a-471c-9cb9-887b8fb8b576	App\\Models\\User
9d52e037-621d-443a-980a-cc2bc34e612e	App\\Models\\Loans
9d52e037-63f9-454e-b005-f738ab3fe1cc	App\\Models\\ItemLoans
9d52e039-5829-447b-b6f7-8c4cb705b019	App\\Models\\Menu
9d52e046-9f0b-417c-89b7-1fe10e3e4d3b	App\\Models\\User
9d52e047-25c6-492d-b726-c8ccfaec9fca	slow
9d52e047-2628-4239-a4c3-01aaf70d0c88	App\\Models\\User
9d52e047-b2c9-49e1-90d3-76eabded362b	slow
9d52e047-b318-454b-bb88-1b430e262276	App\\Models\\Loans
9d52e047-b4f7-40ab-8489-48e3751ef0b8	App\\Models\\ItemLoans
9d52e049-2b6c-4c79-9266-b3fc6665ce42	App\\Models\\Menu
9d52e07e-ec01-4e86-b4eb-6ccec645ef0e	App\\Models\\User
9d52e07f-7cc0-45f7-a4f3-234e2c32e4c2	slow
9d52e07f-7d0f-4cbc-a7b9-4550b385eb04	App\\Models\\User
9d52e080-0aef-4e86-918f-2e70ad212621	slow
9d52e080-0b37-4310-8ae1-259e0599d639	App\\Models\\Loans
9d52e080-0cbf-4050-8ed8-d11ed7e64ff7	App\\Models\\ItemLoans
9d52e081-e995-4166-828f-53e36e66d312	App\\Models\\Menu
9d52e159-e33d-4089-a10c-510cceba500f	slow
9d52e159-e3b7-4e0b-9866-c4a6e0aee99a	App\\Models\\User
9d52e15a-45eb-4273-b6b6-822f06916a49	App\\Models\\User
9d52e15a-a629-4265-affa-21db044fc4d4	App\\Models\\Loans
9d52e15a-a7f0-45df-b3ff-c02ca3bc3774	App\\Models\\ItemLoans
9d52e15b-9c12-4b07-8633-79e481ab7246	App\\Models\\User
9d52e15b-fa3e-4e60-ba05-ff6748a21f55	App\\Models\\User
9d52e15c-8086-497e-a85d-33e6f75af0b9	slow
9d52e15c-80f4-421e-8fc9-d3eef72cefdc	App\\Models\\Loans
9d52e15c-82c2-43b4-b7aa-2a1cf9f19a1f	App\\Models\\ItemLoans
9d52e15e-b8ec-419b-9975-e818564ab55b	App\\Models\\Menu
9d52e1c3-f25f-4b24-bddc-4bcec6441ada	App\\Models\\User
9d52e1c4-65a4-4e48-a6bc-46cb2a33e790	App\\Models\\User
9d52e1c4-dc68-4adc-8602-3466f2440e99	App\\Models\\Loans
9d52e1c4-dee9-44b2-92a5-9ed5cd008f19	App\\Models\\ItemLoans
9d52e1c7-26b9-4e0c-b13c-b80d8f5daaf6	App\\Models\\Menu
9d52e241-7598-42a1-83ec-6b3324c2f346	App\\Models\\User
9d52e241-fdfb-4777-96b7-488d9624e0e2	slow
9d52e241-fe45-4ac7-a8bd-2825e12ccfb7	App\\Models\\User
9d52e242-591f-438c-bbe5-2c2cf46dd2fa	App\\Models\\Loans
9d52e242-5ab1-4746-b2e3-528b141c6f02	App\\Models\\ItemLoans
9d52e27b-b1e9-4f9a-81ca-b1ea86aa38fc	App\\Models\\User
9d52e27c-5293-4ca1-b6ad-40eb297d0bb5	slow
9d52e27c-530c-4775-9dcf-a099f9889b94	App\\Models\\User
9d52e27c-c7b6-4a5e-92fc-c88c0de8c37b	App\\Models\\Loans
9d52e27c-ca0f-4df8-ae04-b2e528cbd536	App\\Models\\ItemLoans
9d52e27e-f59e-4578-bc80-7ca6fabebc08	App\\Models\\Menu
9d52e299-a4b1-4a10-8406-77912c0d5b79	App\\Models\\User
9d52e29a-06f1-43e9-a7b3-3ca7ce9471d8	App\\Models\\User
9d52e29a-8c56-4acd-833a-c8cf6414cb31	slow
9d52e29a-8ca1-428e-a26d-e701bba3b5ad	App\\Models\\Loans
9d52e29a-8e85-423e-a32c-8740dad04e9b	App\\Models\\ItemLoans
9d52e29c-62a7-465c-bcfd-2c7928bce253	App\\Models\\Menu
9d52e55d-f46a-4b70-a031-21f1bf3eb410	slow
9d52e55d-f4e7-4fe6-a542-10d781fe852a	App\\Models\\User
9d52e55e-83d1-4f58-8c15-ea2ddc44464b	slow
9d52e55e-841f-439a-b744-4908754e1c42	App\\Models\\User
9d52e55f-10a2-4a87-a188-a73f403d8fa2	slow
9d52e55f-10ed-4f92-b4c0-a788c0abd65a	App\\Models\\Loans
9d52e55f-129d-4f30-b353-9ba81efb7a3a	App\\Models\\ItemLoans
9d52e564-2785-4bc3-9ed8-665a1ee59d81	App\\Models\\Menu
9d52e568-2d04-4259-a3f8-43066817c054	slow
9d52e568-2d55-4738-93da-b69ff511e3b9	App\\Models\\User
9d52e568-b96d-4188-9cb5-fd50aab9a51f	slow
9d52e568-b9be-4b99-8f3a-a3b2cfd110ce	App\\Models\\User
9d52e569-1bc9-43b0-96ba-db8a7282c056	App\\Models\\Loans
9d52e569-1fd2-4556-94e8-41e106193ec9	App\\Models\\ItemLoans
9d52e56b-183f-40dd-9028-59bf31d71c0d	App\\Models\\Menu
9d52e58a-bd59-41cf-a8c9-79d2456c4a31	App\\Models\\User
9d52e58b-2871-4760-86c9-44fcd8e4157d	App\\Models\\User
9d52e58b-8b63-4274-a38f-f2e3a815d069	App\\Models\\Loans
9d52e58b-8d2e-4a41-b60d-b96dc9e26784	App\\Models\\ItemLoans
9d52e58d-be1d-41c8-bfb8-06b9c12f361e	slow
9d52e58d-be87-4dda-8341-4047f50d55cc	App\\Models\\Menu
9d52e5c9-6ef5-4ae8-bc47-91d2cdb88faf	App\\Models\\User
9d52e5ca-1303-46b0-961e-c599ed3405c9	slow
9d52e5ca-136b-45fd-9ef3-ba7e8fbff4bd	App\\Models\\User
9d52e5ca-7be1-4332-8118-f0bd7b7a69b3	App\\Models\\Loans
9d52e5ca-7e36-4ae5-953b-feaf87a69915	App\\Models\\ItemLoans
9d52e5cc-93b5-4088-9750-3d93deff562c	App\\Models\\Menu
9d52e5fa-f749-4329-b068-eefc59b79964	App\\Models\\User
9d52e5fb-562a-48b7-8087-79180ba41975	App\\Models\\User
9d52e5fb-e150-4698-8e8b-74fa05b19d84	slow
9d52e5fb-e1a3-4bc9-ac5d-ed1e9e17c047	App\\Models\\Loans
9d52e5fb-e352-4c7e-8521-854b59a969b9	App\\Models\\ItemLoans
9d52e5fe-4583-47ec-b146-0a7039c1763a	App\\Models\\Menu
9d52e632-731d-4c65-8e4e-408afcb047fc	slow
9d52e632-736a-45b1-94b9-3b41a8418c6f	App\\Models\\User
9d52e632-d5ed-4332-8a44-a5c7a9370585	App\\Models\\User
9d52e633-6a77-48a6-bb4a-88d373850cb1	slow
9d52e633-6ac1-46ba-acc6-ad8e4c277ee5	App\\Models\\Loans
9d52e633-6caf-42fb-8f71-8dcf1951786e	App\\Models\\ItemLoans
9d52e635-35a1-4eb6-81dd-40d046e29009	App\\Models\\Menu
9d52e698-c62b-474e-a75c-9215e6aa01bc	slow
9d52e698-c6a6-41b5-8f4b-7863bd7e4824	App\\Models\\User
9d52e699-5522-44f2-acd6-a7c2986c7b2e	App\\Models\\User
9d52e699-cd12-4860-b289-9377462abc18	App\\Models\\Loans
9d52e699-cf3f-424a-9c88-9d47954a3d67	App\\Models\\ItemLoans
9d52e69c-40d0-4236-9d37-537d050f6466	App\\Models\\Menu
9d52e6f6-ff1e-47ff-9cc9-439f0e7333c6	App\\Models\\User
9d52e6f7-8919-4ace-9aae-962d15c3223a	App\\Models\\User
9d52e6f8-0454-417b-93f2-512ecfc75157	App\\Models\\Loans
9d52e6f8-065b-443e-aec0-607f06231e59	App\\Models\\ItemLoans
9d52e6fa-4b2b-4db1-be66-2bc32871a57d	App\\Models\\Menu
9d52e71a-916a-45cf-8044-586d974b1c46	slow
9d52e71a-91cb-4fbd-af39-9df5992c6732	App\\Models\\User
9d52e71b-1f5e-4570-803a-9479c2de6255	slow
9d52e71b-1fab-4bc5-927d-9576c49809ea	App\\Models\\User
9d52e71b-7ffd-494e-8ed0-c5360e07cab2	App\\Models\\Loans
9d52e71b-8195-4cc8-9ad8-82c28db855c2	App\\Models\\ItemLoans
9d52e71d-34b8-4faa-a2aa-2f8dcff5cccc	App\\Models\\Menu
9d52e76d-fcaa-4ecd-8a8e-778a63b4c469	App\\Models\\User
9d52e76e-6f5a-4f6f-900b-739b5d2681a4	App\\Models\\User
9d52e76f-0bf5-4602-bee2-4dd85cff039e	slow
9d52e76f-0c6f-4627-9a63-b9c5b3c4228c	App\\Models\\Loans
9d52e76f-0e60-4c5b-b0dd-9ad92a03c56c	App\\Models\\ItemLoans
9d52e771-84ea-4960-9e35-eb764973caf5	App\\Models\\Menu
9d52e797-ec12-496a-8958-b5bcadcc6cdb	App\\Models\\User
9d52e798-80e3-43c3-bc16-39b9c3bb4a6b	slow
9d52e798-8158-40cf-83e1-accd13407d50	App\\Models\\User
9d52e798-e556-48bc-8161-99c6857a0879	App\\Models\\Loans
9d52e798-e71e-47e1-9767-0aa5c653018c	App\\Models\\ItemLoans
9d52e79a-b8ec-4edb-8976-2f2fdfe199ec	App\\Models\\Menu
9d52e7ab-8d9e-452f-b945-473aed76d9db	App\\Models\\User
9d52e7ab-f08c-478b-a3c8-abcd315625ca	App\\Models\\User
9d52e7ac-4e8e-4fd0-884f-50312e5b7602	App\\Models\\Loans
9d52e7ac-5028-4390-a7a9-ad4bdda0252a	App\\Models\\ItemLoans
9d52e7ae-315f-4211-b1fd-1c6996fbe7f6	App\\Models\\Menu
9d52e7c5-22e1-4cd4-a348-293395f679e9	slow
9d52e7c5-234f-41ce-958c-a358680342a6	App\\Models\\User
9d52e7c5-8e86-47b4-a08d-d6375f34c487	App\\Models\\User
9d52e7c5-f02e-476b-8d6a-9dda13451af6	App\\Models\\Loans
9d52e7c5-f264-4959-b984-07d2e8cd2e69	App\\Models\\ItemLoans
9d52e7c7-c113-462a-b2ea-cdc34acb3336	App\\Models\\Menu
9d52e7e8-d9fe-458c-9f39-6e7aafbedbb8	App\\Models\\User
9d52e7e9-3b3a-4fc0-b15b-297592f19fa2	App\\Models\\User
9d52e7e9-a2b9-495f-8264-d6e1ac778362	App\\Models\\Loans
9d52e7e9-a482-4521-94d6-1f29dbbe0979	App\\Models\\ItemLoans
9d52e7eb-83b7-41a0-954d-3354a19c8a66	App\\Models\\Menu
9d52e809-87ba-4264-bbc4-75f41d3808b7	App\\Models\\User
9d52e80a-18a6-4669-9579-bd919f9eabfd	slow
9d52e80a-191a-4cba-866c-fd0f12bbe546	App\\Models\\User
9d52e80a-7ee8-4b0f-a8d6-13508a0c76b8	App\\Models\\Loans
9d52e80a-8105-41b0-8330-cbfccc4e0bb3	App\\Models\\ItemLoans
9d52e80c-5cf6-4785-af43-c42529c17314	App\\Models\\Menu
9d52e833-195a-469d-bf94-a516520cf6a1	App\\Models\\User
9d52e833-7b15-4f66-99a5-42ae61f53f0a	App\\Models\\User
9d52e833-dabe-44e5-8b54-5a081c10ecd4	App\\Models\\Loans
9d52e833-dc60-420f-b4a5-73a29ad64ec4	App\\Models\\ItemLoans
9d52e836-02c0-48a9-a6b6-1db5a634ac3f	App\\Models\\Menu
9d52e8cd-2c7c-433a-99b9-6eb4a52f98b7	App\\Models\\User
9d52e8cd-9404-4cd2-9776-e06e7a3ed3e7	App\\Models\\User
9d52e8cd-fbee-4a3b-91e9-ad51a54b7365	App\\Models\\Loans
9d52e8cd-fde2-4661-939b-1c51c5e0f0a7	App\\Models\\ItemLoans
9d52e8d0-b7ed-46d0-82a6-eebb27efe34f	App\\Models\\Menu
9d52e8f1-2be4-42b9-bdd7-ba95375d27ba	slow
9d52e8f1-2c65-42c5-b97c-ed8dd9816767	App\\Models\\User
9d52e8f2-185c-4bfe-b54c-e9b175838233	App\\Models\\User
9d52e8f2-aa0e-4f00-ac4e-d4db2b58c09d	slow
9d52e8f2-aa86-42f8-895c-5a267f09cec7	App\\Models\\Loans
9d52e8f2-aca7-4612-8d17-f9de864773e9	App\\Models\\ItemLoans
9d52e8f4-5222-418f-8a4a-2871aace77f7	App\\Models\\Menu
9d52eb5b-e22a-43fb-bcd5-66cc58ff1a2a	App\\Models\\User
9d52eb5c-879d-4290-b35b-18c96f5849e6	slow
9d52eb5c-87ec-4ccf-a130-75c1714dd56a	App\\Models\\User
9d52eb5c-ed60-4922-8264-ce4da3181c75	App\\Models\\Loans
9d52eb5c-ef61-4e17-bdc3-0ef2ac9de8ab	App\\Models\\ItemLoans
9d52eb5f-1d64-49a3-9de2-e229a54275ab	App\\Models\\Menu
9d52eb91-073c-438b-8f96-efbd8acaa5a0	App\\Models\\User
9d52eb91-9ab6-4100-9b52-16af67b4d118	slow
9d52eb91-9b0e-4304-a33c-bee59ff5444a	App\\Models\\User
9d52eb92-3879-4569-ae2c-38f269d04f71	slow
9d52eb92-38d7-4dad-a81f-a5d0ab9aa2b8	App\\Models\\Loans
9d52eb92-3ab4-423e-bccd-59a6b388413f	App\\Models\\ItemLoans
9d52eb94-30fe-4df3-bfe0-07091b5fcf4d	App\\Models\\Menu
9d52ebdc-7779-466f-b034-288895722b1e	App\\Models\\User
9d52ebdd-0084-43a2-88ee-be871748c874	slow
9d52ebdd-00d0-4a7f-a554-34d14f9595e8	App\\Models\\User
9d52ebdd-66a3-4d82-9590-b5b89d1cfb42	App\\Models\\Loans
9d52ebdf-4f26-4f5c-8d38-5d6817579b21	slow
9d52ebdf-4f72-45c6-9cb9-559403b47c87	App\\Models\\Menu
9d52ebdf-b8e0-46d6-b773-6f1d62f3da96	App\\Models\\Loans
9d52ec1e-0bad-4374-81ea-e47847d0d0cc	slow
9d52ec1e-0bf6-4da1-8a0d-a5273de916d2	App\\Models\\User
9d52ec1e-6c2e-4a0a-9e9e-db9fb3fca96b	App\\Models\\User
9d52ec1e-f333-4723-b34a-2bf9e3a8362d	slow
9d52ec1e-f387-4c72-b6f1-5c0812d14a21	App\\Models\\Loans
9d52ec1e-f576-4d24-847a-04b55c10b4d4	App\\Models\\ItemLoans
9d52ec21-186b-46e4-b40b-0f4425440cce	App\\Models\\Menu
9d52ec9b-fbe6-4311-8557-58c1468d976a	slow
9d52ec9b-fc38-4239-8bad-1b7e4a7b89c1	App\\Models\\User
9d52ec9c-8eb3-4af8-ad14-f6ea1e760921	slow
9d52ec9c-8eff-49bf-adc2-567bcacf5580	App\\Models\\User
9d52ec9d-1cd6-4a5a-ae19-bbfe93ad122a	slow
9d52ec9d-1d26-43da-bd5f-604715e00188	App\\Models\\Loans
9d52ec9d-1ed8-4f07-8a1e-e426415ce680	App\\Models\\ItemLoans
9d52ec9e-fbc1-4081-8ff8-d6a272090d50	slow
9d52ec9e-fc12-4c72-800f-7f0097558aa8	App\\Models\\Menu
9d52ed00-1cab-42e0-962c-57bc34527af5	slow
9d52ed00-1cfe-4cf2-9ce4-e31c5cf8d908	App\\Models\\User
9d52ed00-b755-47dd-9c37-7f2aec2e0303	slow
9d52ed00-b7e6-4b30-b692-16615f6ced00	App\\Models\\User
9d52ed03-5ed9-4020-b39c-1495caf6ffd0	slow
9d52ed03-5f60-468d-8389-85d645a2943d	App\\Models\\Menu
9d52ed4b-7712-42fc-ab84-669d5aeab61b	App\\Models\\User
9d52ed4b-d8e6-475b-8038-0d89901ded2d	App\\Models\\User
9d52ed4e-0861-4551-b78e-84ce035ca446	App\\Models\\Menu
9d52ed86-632c-4981-bf9d-2254915d5717	slow
9d52ed86-638c-4715-95dc-bfbb93107376	App\\Models\\User
9d52ed86-cceb-48b7-b6db-4d748bf59688	App\\Models\\User
9d52ed89-3b85-4288-a55d-9c5bb8a39f0e	slow
9d52ed89-3bf6-4bfd-be0c-60e6941f9064	App\\Models\\Menu
9d52edac-a406-4689-b242-00fe4efbc0b0	slow
9d52edac-a44e-4f2c-9f26-90cc697b4a8d	App\\Models\\User
9d52edad-039e-4502-af0c-f387733b4569	App\\Models\\User
9d52edad-89f9-43c0-8a1e-5fed7d6cfcc5	slow
9d52edad-8a4b-4ce5-a525-0eb2e4c41810	App\\Models\\ItemLoans
9d52edaf-4ed1-4b3b-9698-20d9188a4a4d	App\\Models\\Menu
9d52edde-4b7b-4950-9fe0-439748fa7be1	App\\Models\\User
9d52edde-d89d-404b-ae14-4cc2abeca5f9	slow
9d52edde-d8fd-4b20-9d4f-0c2ebb21b2ea	App\\Models\\User
9d52eddf-3bb4-44d2-ac77-546efb3adf26	App\\Models\\ItemLoans
9d52ede1-19be-4cb6-b96b-60b66ebe1766	App\\Models\\Menu
9d52ee41-1d36-49e3-92ae-d1e213b1e60c	App\\Models\\User
9d52ee41-bbfb-44c9-93df-34b6642ccdc8	slow
9d52ee41-bc70-4d85-a6f1-24184b55d0bb	App\\Models\\User
9d52ee42-2984-4243-aa93-24cbe3474d9f	App\\Models\\ItemLoans
9d52ee44-61a0-401f-8caf-da160f225897	slow
9d52ee44-61eb-4746-90e3-c62f4ad0adb5	App\\Models\\Menu
9d52ee61-daa0-4bd6-a375-808010756c71	App\\Models\\User
9d52ee62-6be0-4d8b-b2f0-a208cf3d9e3a	slow
9d52ee62-6c30-4057-861c-de44e78f14c7	App\\Models\\User
9d52ee64-558b-4a28-8014-14b3ce7afdbe	App\\Models\\Menu
9d52ee7e-be98-465c-a238-89bce8832e6d	App\\Models\\User
9d52ee7f-24d9-4a1e-8c38-e622c791af57	App\\Models\\User
9d52ee81-84ad-4ffe-8ca8-ab550214c377	slow
9d52ee81-8507-4ff1-9886-8bd15c516452	App\\Models\\Menu
9d52eea4-f4f8-4cc9-9004-7ceb1facc4d5	App\\Models\\User
9d52eea5-821b-4084-908d-da506615b10d	slow
9d52eea5-8265-446a-b0fd-e0f53e720bd2	App\\Models\\User
9d52eea6-08a7-4731-8f3b-917c7e432b40	slow
9d52eea6-08f7-48ef-b0ec-5fba886e69c1	App\\Models\\Loans
9d52eea6-0a9d-4a32-90b5-c07a998c2ffc	App\\Models\\ItemLoans
9d52eea7-c7b9-4f29-8aa1-d5486668fef9	App\\Models\\Menu
9d52eeb8-74aa-4c4a-8153-d941029dbde3	slow
9d52eeb8-7507-4a14-9a51-57488ef514a4	App\\Models\\User
9d52eeb8-d1c4-4609-8ba3-ccb3bde8942d	App\\Models\\User
9d52eeb9-57f4-454b-beff-5158c16577f1	slow
9d52eeb9-584b-4518-817f-6fd5523137ac	App\\Models\\Loans
9d52eeb9-59f0-4b51-b1b0-2c2b2161d26b	App\\Models\\ItemLoans
9d52eebb-29e2-4a71-98c8-2c9487c48987	App\\Models\\Menu
9d52eec7-8711-4dc9-8b85-b85bd326bfea	App\\Models\\User
9d52eec8-0f8d-4cee-b1ee-f87b84f8ff74	slow
9d52eec8-0fd6-49ac-8c06-4a173d5d8e61	App\\Models\\User
9d52eec8-6aec-44ca-b2ba-d96229f33413	App\\Models\\ItemLoans
9d52eeca-0379-4379-bcf2-28abe5983164	App\\Models\\Menu
9d52ef0b-1ec0-4628-aa78-e44a3198423a	App\\Models\\User
9d52ef0b-7b07-4cec-a37e-c171c907fcd9	App\\Models\\User
9d52ef0b-ed34-4fbf-80fd-442eee4e6351	App\\Models\\Loans
9d52ef0b-eeca-402a-924c-184bbf0ed502	App\\Models\\ItemLoans
9d52ef0d-be0b-4413-ba37-404812d278a8	App\\Models\\Menu
9d52ef3d-9d5a-47d5-bcf8-0a16e2e54879	App\\Models\\User
9d52ef3e-26ea-4b2e-8582-e4cc94ccd5c7	slow
9d52ef3e-275f-46fd-82ec-0f77c942c01e	App\\Models\\User
9d52ef3e-bdf0-4eac-a27a-3c44a5e6809c	slow
9d52ef3e-be44-4413-9a44-4c5321e11129	App\\Models\\Loans
9d52ef3e-c063-4f5f-8599-c921a4f20b69	App\\Models\\ItemLoans
9d52ef40-83a5-4b5d-afac-f637980ce44f	App\\Models\\Menu
9d52ef62-6d4b-47cb-8698-7580785322d0	slow
9d52ef62-6db4-49ac-a86e-4f9f204f01ef	App\\Models\\User
9d52ef62-cdcf-4b64-8343-61d84987b260	App\\Models\\User
9d52ef63-2d7e-4bb2-ab38-10b41e1835d0	App\\Models\\Loans
9d52ef63-2f35-42a0-b6c2-d3c8bdeb1914	App\\Models\\ItemLoans
9d52ef65-2fe2-4680-b8aa-e746acaa8407	slow
9d52ef65-302f-4688-a618-0923ca5c8a3c	App\\Models\\Menu
9d52ef80-c6ad-4131-8130-734be81052ad	slow
9d52ef80-c700-4f6f-bcda-b55601ddb886	App\\Models\\User
9d52ef81-2d12-47ff-b706-f5d427c11f57	App\\Models\\User
9d52ef81-927d-4ebd-8763-62ede00473e9	App\\Models\\Loans
9d52ef81-946c-4e96-b01b-71563dc298a6	App\\Models\\ItemLoans
9d52ef83-44ef-4032-bd80-a9553629bf7e	slow
9d52ef83-4547-4705-9dcc-2be255b1b1a3	App\\Models\\Menu
9d52efe0-442a-4071-9d65-78e1ab1592b2	App\\Models\\User
9d52efe0-c178-4eae-9c36-57846ba4d877	App\\Models\\User
9d52efe1-63dd-4486-89d1-f4c73df20f0b	slow
9d52efe1-6436-4be3-b250-fe474a2381ca	App\\Models\\Loans
9d52efe1-6624-4cb5-9910-ff50664ac2f8	App\\Models\\ItemLoans
9d52efe3-9541-4fb6-a156-0ff6f00d77aa	App\\Models\\Menu
9d52f263-9576-4c33-a8fd-579310061079	App\\Models\\User
9d52f264-01b8-4b75-a710-5cb75a6313e0	App\\Models\\User
9d52f264-6c7c-4f4a-a600-55a86a94d5b3	App\\Models\\Loans
9d52f264-6e52-4f3a-8d54-5c09b344f419	App\\Models\\ItemLoans
9d52f266-8225-4cdf-ba03-2bb92f1e0121	App\\Models\\Menu
9d52f26c-a539-457a-aed9-b9ed45b6f0a3	App\\Models\\User
9d52f26d-11a4-451f-91de-c3f5453cea6c	App\\Models\\User
9d52f26d-7453-4fdb-96c4-9df84c782f7e	App\\Models\\Loans
9d52f26d-7640-4b14-baad-fe2f8c9a6382	App\\Models\\ItemLoans
9d52f26e-f48b-4aeb-8ecb-f547bfbed9a4	App\\Models\\Menu
9d52f346-a4c1-4f37-b9a6-dea949c825e6	App\\Models\\User
9d52f347-14db-4ff4-aa89-f08a349a4dce	App\\Models\\User
9d52f347-8437-4a72-b5a7-dd37c0900ece	App\\Models\\Loans
9d52f347-864e-470b-8148-2a2e59f9036d	App\\Models\\ItemLoans
9d52f34a-7233-4668-b170-a9089cadfec5	App\\Models\\Menu
9d52f39d-431f-4de4-8bd4-b178f2a7887d	slow
9d52f39d-4371-4371-9385-670f3d6c6b9a	App\\Models\\User
9d52f39d-b562-4d6b-9dcb-cd6ba16c6238	App\\Models\\User
9d52f39e-7492-4f06-bf87-0cee048b2f2e	slow
9d52f39e-7522-4f1a-8169-ab9425e502f5	App\\Models\\Loans
9d52f39e-76fd-46fb-98fe-3c7864e3737f	App\\Models\\ItemLoans
9d52f3a0-4886-463e-8ecd-0ed81ae2cb5a	App\\Models\\Menu
9d52f3b4-e19b-4f05-8a87-06cd3813e8b7	slow
9d52f3b4-e1ea-42cf-91ad-2564d974d285	App\\Models\\User
9d52f3b5-862d-46ed-adee-41edd9a2db7d	slow
9d52f3b5-8688-470f-9c2f-956d3ca4fb67	App\\Models\\User
9d52f3b6-240a-4772-be4c-375c1bcf00a3	slow
9d52f3b6-2479-4c5f-a593-74a4d3a5ddd3	App\\Models\\Loans
9d52f3b6-26a1-442a-bc5f-ce678eaffe5e	App\\Models\\ItemLoans
9d52f3b8-1ff1-4bb8-944b-1333485d2f00	App\\Models\\Menu
9d52f3d4-675a-4cd8-9c02-2a1ce69bb95a	slow
9d52f3d4-67a7-4a02-a45f-de47a10bda4f	App\\Models\\User
9d52f3d4-f50a-4f25-8d83-5036346ed293	slow
9d52f3d4-f555-4cd7-9177-7f2325721f3a	App\\Models\\User
9d52f3d5-82d4-4540-a26a-32b0250f6721	slow
9d52f3d5-8337-4439-ad05-05beeb37440b	App\\Models\\Loans
9d52f3d5-850a-4a28-801a-de7dfcaeb11b	App\\Models\\ItemLoans
9d52f3d7-1c70-40d3-882f-cf3fac18c55d	slow
9d52f3d7-1cf1-45e1-ad52-6a58269d19c1	App\\Models\\Menu
9d52f403-ac25-4075-87f8-821a621c8f65	App\\Models\\User
9d52f404-113c-4eb5-9cd7-e10d73fb63d3	App\\Models\\User
9d52f404-75eb-46bb-ab27-788985bdfa6a	App\\Models\\Loans
9d52f404-77c6-4e01-b596-ae94a6b7dff8	App\\Models\\ItemLoans
9d52f406-8a4c-4f7e-9aeb-4ff30cf862d1	App\\Models\\Menu
9d52f42a-2bf8-44ea-bd47-9c942f34434a	App\\Models\\User
9d52f42a-8a0a-41ec-afbd-9174b2a95a9c	App\\Models\\User
9d52f42a-e90a-4dd2-b4e4-fca2eac0a515	App\\Models\\Loans
9d52f42a-eada-429f-9338-d492d96c4f77	App\\Models\\ItemLoans
9d52f42c-bd4a-419f-88ae-0c5472d62c45	App\\Models\\Menu
9d52f442-1f77-40c2-b81e-765a21309bf8	slow
9d52f442-1fc5-490e-ae2b-a8c2b4e8ed62	App\\Models\\User
9d52f442-8b6d-48cc-9254-31f89c937115	App\\Models\\User
9d52f442-f63c-4ed1-9414-38006ac4e4ab	App\\Models\\Loans
9d52f442-f844-4d79-b803-8a4d7f64e489	App\\Models\\ItemLoans
9d52f445-4a5c-44a1-9812-a9f731b8d3b8	App\\Models\\Menu
9d52f57f-7971-4edb-8d1a-d318f5933db0	App\\Models\\User
9d52f580-1bb0-478b-b076-d79b78811569	slow
9d52f580-1c05-44d3-a6d9-b1d27ceeb547	App\\Models\\User
9d52f580-8d3e-4cb6-8c70-153fbc280b5f	App\\Models\\Loans
9d52f580-8f86-482d-a06e-f9216d784a93	App\\Models\\ItemLoans
9d52f581-9a36-419e-84e6-1dcd289cabe1	slow
9d52f581-9a96-436c-abe5-0420bf0b74ef	App\\Models\\User
9d52f582-3314-4d6c-a26b-83dc1e665e7f	slow
9d52f582-3374-49d0-a295-128e2959eedb	App\\Models\\User
9d52f582-b851-4348-8f5a-af394a983449	App\\Models\\Loans
9d52f582-ba51-419f-a509-cee66e733f59	App\\Models\\ItemLoans
9d52f584-ce79-48d8-8ddd-4a20c5ed6d55	App\\Models\\Menu
9d52f59d-83e1-443d-9e27-fb017c11dc7a	App\\Models\\User
9d52f59d-e65b-499a-9f92-ed53c16aa286	App\\Models\\User
9d52f59e-4ded-43ad-8013-1d3865bf4823	App\\Models\\Loans
9d52f59e-4f92-4824-8e34-044419613d1b	App\\Models\\ItemLoans
9d52f5a0-22dc-4213-87f1-b0de464d073a	App\\Models\\Menu
9d52f613-4fc8-43f2-abc6-8343e01b9469	App\\Models\\User
9d52f613-d09a-4fcc-b003-801f779e386a	App\\Models\\User
9d52f614-69b1-4ae8-afca-14efdae12efb	slow
9d52f614-6a06-49c4-a6ca-c1bf8bce34f0	App\\Models\\Loans
9d52f614-6bfe-47f9-9510-c6cc883060b5	App\\Models\\ItemLoans
9d52f616-fddb-4ba7-81ae-914505d2b321	slow
9d52f616-fe49-42a0-bf6d-1cf027a9bdf8	App\\Models\\Menu
9d52f689-1d90-49e7-bd23-e5366ea14ab6	slow
9d52f689-1df4-4bd3-88e6-664bc705e6d6	App\\Models\\User
9d52f689-ac5d-4a0c-be80-e38a114c2e04	slow
9d52f689-acaf-4fa6-94c5-4f41c7d92614	App\\Models\\User
9d52f68a-0d66-4c1a-af04-1e6c4529de65	App\\Models\\Loans
9d52f68a-0f41-4099-9e96-72159932ad20	App\\Models\\ItemLoans
9d52f68c-3681-4ebc-a2eb-30c35a8dd689	App\\Models\\Menu
9d52f6ac-4a04-4883-91f9-be4551cc84a7	App\\Models\\User
9d52f6ac-a963-45fd-b08a-2696059343de	App\\Models\\User
9d52f6ad-08f1-4ff0-a0d8-68cd853e6dfd	App\\Models\\Loans
9d52f6ad-0ac9-4abf-a703-ffecfb2ca566	App\\Models\\ItemLoans
9d52f6ae-d96f-4315-ae51-8e16e3bad38f	App\\Models\\Menu
9d52f706-e752-43c9-bdb8-90b9cd82bdf6	App\\Models\\User
9d52f707-5b7a-4dbc-9816-574255ae7103	App\\Models\\User
9d52f708-02d4-49d6-a4db-9516e97ff05c	slow
9d52f708-034f-48b6-bbf2-8d74fd704b29	App\\Models\\Loans
9d52f708-05c1-4b86-9a6f-e91e6e671e5a	App\\Models\\ItemLoans
9d52f70a-5229-4fd3-9869-4a4acc099f44	App\\Models\\Menu
9d52f726-24df-449e-a148-6f1bd752cb1a	App\\Models\\User
9d52f726-b524-4a36-986f-2e7840cedd92	slow
9d52f726-b56c-49df-be57-203126371838	App\\Models\\User
9d52f727-40d2-4d15-8728-2399b242a37b	slow
9d52f727-4145-4c09-bb1a-6ee417d49e27	App\\Models\\Loans
9d52f727-433c-44cc-b14b-5abd45f90132	App\\Models\\ItemLoans
9d52f729-2d4c-4f49-9802-788b34c7f2ee	App\\Models\\Menu
9d52f75a-0a8c-4071-a0e3-42f60c9587f0	App\\Models\\User
9d52f75a-b407-4a80-95c1-75476daaa37f	slow
9d52f75a-b47a-4b8e-a9e7-1fac3af21d06	App\\Models\\User
9d52f75b-4f8e-40bb-bbef-c794559fdd05	slow
9d52f75b-4fdb-4634-ac49-8d5a63a8c3b8	App\\Models\\Loans
9d52f75b-5209-449e-ad39-300af0f48410	App\\Models\\ItemLoans
9d52f75d-d449-4acc-9c80-728227508226	slow
9d52f75d-d4af-4e00-8271-7ff58edf03f0	App\\Models\\Menu
9d52f78a-c898-43e1-a5f2-ff556dd1adfe	App\\Models\\User
9d52f78b-6352-4520-82c6-6f6c8857b96c	slow
9d52f78b-63a7-4861-9fa8-80d7915c301d	App\\Models\\User
9d52f78b-f76e-47eb-af80-34cf57bba47f	slow
9d52f78b-f7bb-491b-b1b1-6e08d11f2a76	App\\Models\\Loans
9d52f78b-f9d6-42d0-8e5e-428ca0203f30	App\\Models\\ItemLoans
9d52f78d-dcb8-471c-a1b6-6d3354736e5b	App\\Models\\Menu
9d52f7a7-77db-41f3-a840-1aa0351a25ce	App\\Models\\User
9d52f7a8-09bd-45ce-a108-819485dafb61	App\\Models\\User
9d52f7a8-9b22-4f99-86b5-2663685fe9f5	slow
9d52f7a8-9b6f-495f-b364-aaf34845f887	App\\Models\\Loans
9d52f7a8-9d92-439f-867a-f20cdee66617	App\\Models\\ItemLoans
9d52f7ab-0acf-402f-9598-8198d32bc88b	App\\Models\\Menu
9d52f7cc-7cfd-474e-a122-99375a2d5873	App\\Models\\User
9d52f7cd-107a-4cb8-ade4-d2f74fdf5881	slow
9d52f7cd-10d7-4404-b52a-2eccd150db84	App\\Models\\User
9d52f7cd-a3d1-4f51-afcf-0a5af7294822	slow
9d52f7cd-a41e-45a8-b372-4d93012ee49a	App\\Models\\Loans
9d52f7cd-a664-4673-83ac-67eb213d5d04	App\\Models\\ItemLoans
9d52f7cf-650c-4b34-ad6e-b899be1726d9	App\\Models\\Menu
9d52f804-7e05-4755-9048-342dc741c92c	App\\Models\\User
9d52f805-193f-422c-9e04-b75f3bb6f763	App\\Models\\User
9d52f805-8ce9-4343-85fa-8ec4b591684d	App\\Models\\Loans
9d52f805-8f40-4ddd-a5f5-6b1111aeecb5	App\\Models\\ItemLoans
9d52f807-d77c-4289-9989-2f255229c760	App\\Models\\Menu
9d53006c-9295-4d25-b684-690451d7f203	App\\Models\\User
9d53006d-1852-48a9-b515-5315b2e3a334	slow
9d53006d-18a1-4bbe-9248-f8e33e9fc2d0	App\\Models\\User
9d53006d-8a0a-49e4-b908-e564a5039225	App\\Models\\Loans
9d53006d-8c24-4097-a11a-896582788ac0	App\\Models\\ItemLoans
9d530070-063f-4c56-8827-8186c1226c51	slow
9d530070-0685-445f-bd25-7f7332694daa	App\\Models\\Menu
9d531cda-b0a7-407d-8982-ba30c8d54e46	App\\Models\\User
9d531cdb-8534-4457-b8be-d9736ba3a099	App\\Models\\User
9d531cdc-49c9-4953-b024-2c258b31845e	App\\Models\\Loans
9d531cdc-4d31-4395-a51b-c2e71c953b0d	App\\Models\\ItemLoans
9d531cdf-0813-4189-a925-f77ba02d7452	slow
9d531cdf-089f-4e1f-b1e6-c4c718ca4cc2	App\\Models\\Menu
9d5322f7-029d-4ed2-8bee-efc83c9b7964	App\\Models\\User
9d5322f8-0938-4df1-abb5-b6df4a8a2379	slow
9d5322f8-0a22-4bbd-9413-e49c2c20dbcb	App\\Models\\User
9d5322f9-806f-4121-ae83-07ffa6354fb3	slow
9d5322f9-8102-4cb3-89d8-bf49047aa448	App\\Models\\Loans
9d5322f9-8567-4a7e-97f3-6d477ec99e00	App\\Models\\ItemLoans
9d532300-804f-4269-b0b9-74256ad96452	App\\Models\\Menu
9d53231d-656b-4847-91ef-54a16895b1f6	App\\Models\\User
9d5324d3-5ae1-4055-90b1-3d28934793d9	App\\Models\\User
9d5324d3-e3fd-4f08-ae4a-eb4525eabe0c	slow
9d5324d3-e452-4b31-94f7-2b1ad223f127	App\\Models\\User
9d53b6bd-1bd1-457c-850a-39ed56a44671	slow
9d53b6bd-1c4f-41c1-ae04-dd7ab90ecd25	App\\Models\\User
9d53b6be-8e76-4566-83a4-4951f0dfbbd6	slow
9d53b6be-8ec2-4cf6-9065-fc1fa62fcf71	App\\Models\\User
9d53b6bf-9f7e-4f82-9880-da5483fa0970	slow
9d53b6bf-9fc6-4026-80d8-699d61683db7	App\\Models\\User
9d53b6bf-f7d8-46f5-93d6-00ac7a553843	App\\Models\\User
9d53b6c2-5efb-42d9-8930-03c60f896514	App\\Models\\Menu
9d53c5d8-39b7-4b2a-b90e-06fd507d3984	App\\Models\\User
9d53c5d8-bf8d-400f-aceb-b83d620d14d3	App\\Models\\User
9d53c5da-de03-4015-bda1-9682a22978c3	App\\Models\\Menu
9d53d1a3-ca94-4ac9-8c4f-875809798eae	App\\Models\\User
9d53d1a4-8975-4786-9c1f-1965792ab630	App\\Models\\User
9d54874d-c602-4b01-8240-6a8af8a6a08e	App\\Models\\User
9d54874f-dfa0-46e8-a825-72c86127c440	slow
9d54874f-e016-4b59-b791-bedf97861dc6	App\\Models\\User
9d548754-59c3-413c-96c1-50e0a04c552e	slow
9d548754-5a2d-48d6-8336-0bccfc6b4e94	App\\Models\\Menu
9d54875d-bc0c-4a01-be0d-8a3c629ff6d7	slow
9d54875d-bc7c-4ba3-861d-bf3be2a5e27b	App\\Models\\User
9d54875e-4a2f-4552-b12b-c16bcd27deda	App\\Models\\User
9d548761-be2a-4628-acee-ed9b589b4c6a	slow
9d548761-beaa-4f1f-8e73-dce34c4b16a0	App\\Models\\Menu
9d569f06-f446-4ce2-8f25-493734e7da87	App\\Models\\User
9d569f09-e733-4f50-b50f-f0accf1e500a	App\\Models\\Menu
9d569f1a-b06b-486d-b422-4b0c735d10c3	App\\Models\\User
9d569fc7-1ab4-4cbf-802d-545052f832fe	slow
9d56abb7-c48f-4578-806e-0d07924e7852	slow
9d56abb9-c8fd-4e94-9cad-43f33161bef1	App\\Models\\Menu
9d56ac01-2512-4abc-8d37-2e985d14d105	slow
9d56ac03-3dfb-4c7c-a5e8-2cd3453f3bff	slow
9d56ac03-3e4f-4232-83db-1966cad369ba	App\\Models\\Menu
9d56ac42-d304-46b5-91f2-660d59d0fd79	App\\Models\\Menu
9d56ac79-81f6-4f0f-b121-f654430b6c3b	App\\Models\\User
9d56ac7a-215d-4e1f-8cfd-233ac704a4b1	App\\Models\\User
9d56ac7a-ae43-438a-9f85-042a155775de	slow
9d56ac7a-ae95-474e-bcd3-a4fc04458209	App\\Models\\Loans
9d56ac7a-b9a6-4495-81ad-317ad4058b5a	App\\Models\\ItemLoans
9d56ac8f-926b-4f5b-a4bc-87ab58cbb4fa	App\\Models\\User
9d56ac90-1741-4ea7-9ae3-c8a0b0d92c52	slow
9d56ac90-1799-482e-8401-3b2217cb08fa	App\\Models\\User
9d56ac90-7628-4f49-8482-59fefefa03e8	App\\Models\\Loans
9d56ac90-77cc-4413-935e-5f25414889cb	App\\Models\\ItemLoans
9d56ac92-3e16-40b2-9b64-a35eacd50cc4	App\\Models\\Menu
9d56acbf-dfab-4e7c-931a-6d7c6918512e	App\\Models\\User
9d56acc0-716f-4999-8e45-3c07fb9daf47	slow
9d56acc0-71cb-4006-819b-84369a6317ed	App\\Models\\User
9d56acc0-d0f0-4b16-a3bf-e84cabaadf7c	App\\Models\\Loans
9d56acc0-d282-4e5e-b312-d1ba8b80bb75	App\\Models\\ItemLoans
9d56acc2-87da-4f29-b226-176010bcd577	App\\Models\\Menu
9d56ace0-57de-44b2-b4e4-75a835540d6f	slow
9d56ace2-14f2-4bda-86b2-a96085a7d952	slow
9d56ace2-1545-4d16-b8cf-d2e80c8816fd	App\\Models\\Menu
9d56ad47-2719-4a4e-b93e-0c35bb5af4b0	slow
9d56ad47-275f-4c7a-82f1-81e30fadffdf	App\\Models\\Menu
9d56ad65-cc6a-4f7e-a6d3-4e8ea2eed1ac	slow
9d56ad65-ccb3-4825-9fd4-d3a2dabe0b17	App\\Models\\Menu
9d56b490-6c10-4b0f-ad03-d670b2ef77cc	slow
9d56b492-70a2-4c27-8cef-1d05bdc9bd1d	slow
9d56b492-70f5-4da4-b87c-90882b174bda	App\\Models\\Menu
9d56b5e1-fd05-47e6-a797-e4518d7e00e0	slow
9d56b5e4-1226-4677-b6f0-835c6d1cd524	App\\Models\\Menu
9d56b609-1e81-47e6-8555-14d1ef23c48a	slow
9d56b60b-23a3-459b-934a-a4aff4f997e1	slow
9d56b60b-2403-480f-96fb-8befdf425d39	App\\Models\\Menu
9d56b6e4-658d-4e94-aa92-dbd62bd534c6	slow
9d56b6e6-1725-470f-8fb8-27b7f1d80aed	App\\Models\\Menu
9d56b8c9-dbba-4ad2-8ba2-a41e522c1f9e	App\\Models\\Menu
9d56bffe-2c46-4c0d-bf64-968d604a7334	App\\Models\\Menu
9d56c2a2-e29c-43b7-b6fc-afa37b3d1a8a	slow
9d56c2a2-e2e3-4d95-8dea-59f91d861931	App\\Models\\Menu
9d56c464-9146-40a3-b470-5611b6dd688b	slow
9d56c464-9192-4f44-9e9b-810945da39fa	App\\Models\\Menu
9d56c570-01d3-47de-98d1-f21c9b6763eb	App\\Models\\User
9d56c570-f437-4b51-ab4f-4c11c6d39a4b	slow
9d56c570-f4a6-4369-a509-f0e3231f884d	App\\Models\\User
9d56c572-b279-4987-889c-6765c7c7dce7	slow
9d56c572-b2c7-4f1b-9a9b-a2b803b4fdbb	App\\Models\\Menu
9d56c5ca-435d-480f-8f89-8fb9a8b945d0	slow
9d56c5ca-43ab-426c-89ba-216a16bf86bb	App\\Models\\Menu
9d56c60a-425d-4c9f-ba0a-4d5afdc6761e	slow
9d56c60c-051e-4315-b51d-9ee65e506c51	slow
9d56c60c-059b-4067-9d22-cbcb94a8bb94	App\\Models\\Menu
9d56c6b5-a197-45c6-af5c-1ad2d3ccc94d	slow
9d56c6b5-a1e4-42e1-ac46-2d8cfee4b8ba	App\\Models\\Menu
9d56c742-8b70-4533-9ac5-10bc88526249	App\\Models\\Menu
9d56c78c-ec80-4e4d-bf67-9eb873b0e979	slow
9d56c78e-5b31-44bb-b947-0298a0ed9d37	slow
9d56c78e-5b79-467a-a468-e15901fbe72b	App\\Models\\Menu
9d56c7da-4e92-4727-83c2-3f357f04287e	App\\Models\\Menu
9d56c7f4-adac-4b60-a6fe-902cbf30282f	App\\Models\\Menu
9d56c80c-5b71-436c-8f8f-1a87dd55ae10	slow
9d56c80c-5bb9-4fbc-aaef-145ce14c67c9	App\\Models\\Menu
9d56c855-ef9c-4614-b51f-a1031dd36101	App\\Models\\Menu
9d56c89c-0422-47c3-a9ab-60a37702e248	slow
9d56c89d-d26a-4314-9bec-7bd5afaacfe9	slow
9d56c89d-d2be-4f3a-a059-8add1ae6e520	App\\Models\\Menu
9d56c8eb-b6d0-4190-acad-65fc74f10bb0	slow
9d56c8eb-b741-41e4-ae0e-bd902ebe1ee2	App\\Models\\Menu
9d56c908-92df-4257-a4b2-b6f6aa0b1d75	slow
9d56c908-9328-4c9c-87d7-527b68488912	App\\Models\\Menu
9d56c9bb-2470-4424-97e6-2150414d523e	slow
9d56c9bb-24e5-4e31-91c2-90007bf4cf05	App\\Models\\Menu
9d56c9e1-ed1f-4d98-b63a-f283130af699	slow
9d56c9e3-4ed3-45bc-a4a4-31c00c08d4bd	slow
9d56c9e3-4f23-4fe5-adda-091f62843e53	App\\Models\\Menu
9d56ca3a-dbb9-40fb-af63-150b2336c0b0	slow
9d56ca3a-dc08-4a08-a37b-a3e30166f876	App\\Models\\Menu
9d56cabe-090b-4cd4-b1c7-4c3ee6c1f4a3	slow
9d56cabf-cfee-4359-a20c-ce71704ea42f	slow
9d56cabf-d055-47dc-99ee-8251bc95f283	App\\Models\\Menu
9d56cb04-4909-451b-8d90-42be34631546	slow
9d56cb04-4954-4212-b67f-110f4980f3bb	App\\Models\\Menu
9d56cb27-a736-4303-baa0-402cd0c22fd2	App\\Models\\Menu
9d56cb34-353c-4db0-83c3-d7b3d616202e	slow
9d56cb34-35aa-4963-8677-234015476cfb	App\\Models\\Menu
9d56cc15-16c1-43b9-bce3-b02f7b1137cb	slow
9d56cc17-32c9-4f50-ad82-09f7e97ad9e0	App\\Models\\Menu
9d56cc1b-dd61-4531-acdf-b3dbf0e17270	slow
9d56cc1b-ddaa-4581-858b-2f8492e2c9f4	App\\Models\\Menu
9d56cc33-5c9e-4779-955e-719ba412c6d9	App\\Models\\Menu
9d56cc37-6b94-42ec-be7e-c9f9447c36dd	App\\Models\\Menu
9d56cd16-6ec7-4ba7-ac6b-4b088f7b85bc	slow
9d56cd18-04ed-4a37-bdbd-822735c000a3	App\\Models\\Menu
9d56cd4a-eb77-4789-9721-5331dab1711e	App\\Models\\Menu
9d56cd51-e638-4b59-ab74-8128e7e7414c	App\\Models\\Menu
9d56cd70-c1a0-43a5-835c-9e9c4466df49	slow
9d56cd72-13c5-4f3a-ac61-effd223521d5	App\\Models\\Menu
9d56cd8a-f8c8-4bf6-8cb9-6fe2094886ea	App\\Models\\Menu
9d56cdb3-8d80-4959-88ef-9d8ae3ff18d7	App\\Models\\Menu
9d56ceeb-7386-4592-828a-3b23d454ac70	slow
9d56ceeb-73cf-4ea5-ae07-a2171f90887c	App\\Models\\Menu
9d56cef4-ff23-4a65-bf5d-6eee269b9a6c	App\\Models\\Menu
9d56cf0b-7483-45b5-a636-c5f238c00bde	App\\Models\\Menu
9d56cf6a-e2ae-4dfe-b83f-5830aa0d7449	slow
9d56cf6a-e2f8-4ce2-8be2-44bf363ecc84	App\\Models\\Menu
9d56cf89-d10e-4c64-a11e-faadc1e36ae0	App\\Models\\Menu
9d56cf9a-d906-4a3f-9831-32f7cf004c6c	App\\Models\\Menu
9d56cfb0-cd62-4233-8884-c288e5ba8179	slow
9d56cfb0-cdaf-47a3-8ba0-cc183cd10450	App\\Models\\Menu
9d56cfc7-0bf3-4b9f-ad48-69bd29d5ffa2	App\\Models\\Menu
9d56d26b-bd55-41da-b0d3-0f4396e8b265	slow
9d56d26b-bdc7-489f-9939-0f06301f14ef	App\\Models\\Menu
9d56f8d9-0f18-45e2-a5db-62b3edb05019	slow
9d56f8db-de0b-4466-b6fb-6aaa1285b4f6	App\\Models\\Menu
9d570e89-a7e0-4233-a8c8-605c2007e49f	App\\Models\\Menu
9d570eae-f933-4f1e-815a-08130ce5cefe	slow
9d570eb0-23cf-4938-a210-66ab4aa36028	App\\Models\\Menu
9d570ee1-41a6-4fe5-a9ee-d1f5a13dd0e4	slow
9d570ee1-4205-4ee1-b63f-04dab37b0a8e	App\\Models\\Menu
9d570f41-d1fd-4735-b7fc-5485ff54c8ab	slow
9d570f43-82c5-46ed-84e8-89b4f75db303	App\\Models\\Menu
9d570fd3-f6c4-447e-aa2b-3e35cf7f16dd	slow
9d570fd5-96e2-4ed5-97b8-617c2b8041b3	App\\Models\\Menu
9d571058-93e7-412b-83f2-ee44584e04ae	App\\Models\\ItemLoans
9d57105a-4759-43a3-953a-64562c8166e3	App\\Models\\Menu
9d57108b-5842-4999-b220-2f51f5d4f6c7	slow
9d57108b-5bea-4ab2-b22a-205e95dfcdb1	App\\Models\\ItemLoans
9d57108c-d5df-43f0-b0df-20d290837cf7	slow
9d57108c-d63c-4746-9014-8b9f263f30f3	App\\Models\\Menu
9d5710dc-497b-4bba-980a-cd78347db25e	slow
9d5710dc-4d33-4a91-851a-679cf222eb66	App\\Models\\ItemLoans
9d5710dd-f76b-4cf6-a158-ce004977dd8c	App\\Models\\Menu
9d5710f9-2dc7-4f5e-a12e-5823f9858071	App\\Models\\ItemLoans
9d5710fa-6b43-4768-b5dc-87fce47f4a55	App\\Models\\Menu
9d571170-4405-4d4a-af6c-be7a707b3f79	slow
9d571170-493a-4595-99ae-93af4743bcfa	App\\Models\\ItemLoans
9d571172-6874-46f1-934a-61a4b4b4c946	slow
9d571172-68d0-4203-be3d-fe2606f7ca31	App\\Models\\Menu
9d571187-737a-473b-ba75-103381cbb7b3	App\\Models\\ItemLoans
9d571188-a42c-4827-adaf-af6900032828	App\\Models\\Menu
9d5712dd-f8b8-4fbe-be3f-5569be7ae294	slow
9d5712dd-fce2-4cb2-8d65-6414a3f000e6	App\\Models\\ItemLoans
9d5712df-0296-4ad9-89e1-55726a037af0	slow
9d5712df-06f7-485b-8a01-17c80eb0e3ed	App\\Models\\ItemLoans
9d5712e0-cf0a-4b50-ae7d-5aefd46e5110	App\\Models\\Menu
9d57130c-1673-4691-a137-afb77fa3577f	slow
9d57130c-1a76-41e5-9fca-ea6f835ec23f	App\\Models\\ItemLoans
9d57130d-cf06-42da-8ab2-2efc10c21506	slow
9d57130d-cf5f-4088-965d-b7a604d9f397	App\\Models\\Menu
9d571fb7-a54c-4f2f-b148-3f943b70a1a2	App\\Models\\User
9d572018-a510-48f0-806f-65b2c4684dc9	slow
9d572018-a578-43e6-9de2-12cd24650ece	App\\Models\\Menu
9d57203d-5c49-48b5-8dc6-28dd713127b9	slow
9d57203f-a122-45fc-96a0-e03874a67767	App\\Models\\Menu
9d57204b-e71b-4749-905e-833f95276329	slow
9d57204b-e767-4790-bbcb-b092c21d6487	App\\Models\\User
9d57205f-da24-42d7-8c9d-01b44a7056aa	slow
9d57205f-daa9-4b0d-971c-36c4cf83ba97	App\\Models\\User
9d572061-871c-425f-adfb-890afd930c83	App\\Models\\Menu
9d5720d1-6073-4340-abf7-4a0a1a803477	slow
9d5720d1-60cf-4b37-8ef9-4bde91b117cc	App\\Models\\Menu
9d5720fd-bc0c-4099-9c7f-0048d21796d6	App\\Models\\Menu
9d572103-9355-418b-978f-96b4c304847f	App\\Models\\ItemLoans
9d572105-7c9f-4747-9869-9fee18d0ed18	slow
9d572105-7cff-4c49-9ca2-17541aad4b86	App\\Models\\Menu
9d572157-d200-4dbc-9ad8-2d787faa24cd	App\\Models\\ItemLoans
9d572159-6456-48fd-88d1-296eb8aa4f32	slow
9d572159-64a0-4f4f-bfd0-74e33011431c	App\\Models\\Menu
9d5ca391-1b99-423d-81f2-5c1717e044d6	App\\Models\\User
9d5ca393-c680-4076-9f82-8e9a28dea1fe	slow
9d5ca393-c6f1-4766-877d-2ba39ab9a532	App\\Models\\Menu
9d5ca3a5-fcfb-433e-8d7d-062d4284df50	App\\Models\\User
9d5ca3ab-b968-477f-a7d3-8ac99e6a667c	App\\Models\\User
9d5ca41e-0783-4d47-8111-77a18ec46fa6	slow
9d5ca41e-07d0-4985-be36-e13ddfc503de	App\\Models\\User
9d5ca41f-d353-4caa-8694-eb9d4a7e6c31	App\\Models\\Menu
9d5ca433-bef7-43da-98f3-6e93b9507807	App\\Models\\User
9d5ca435-78d1-49c8-9fcf-18517154ef43	slow
9d5ca435-791b-4fa4-b9d7-cbef70ece12e	App\\Models\\Menu
9d5ca538-b0fc-41c0-8a16-5f3b6ae27bd0	slow
9d5ca538-b15e-426e-af02-722978388a28	App\\Models\\User
9d5ca559-8f2b-45f7-8ce6-4589d1378bba	slow
9d5ca55b-d649-497e-9b7a-98e1146f2980	App\\Models\\Menu
9d5ca561-28b1-419f-b899-1eccecf829a0	App\\Models\\User
9d5ca561-86de-4b14-91b7-1b10f5240fde	App\\Models\\User
9d5ca562-18ab-4832-ad04-5d5f5dbc76e7	slow
9d5ca562-190f-47eb-a695-4f8d530c8c8c	App\\Models\\Loans
9d5ca562-224b-43cb-87c3-234b6bfa3a8a	App\\Models\\ItemLoans
9d5ca56a-5670-43b5-9efe-7ea743492225	slow
9d5ca591-2979-48aa-a6f9-e230c8cfa36c	App\\Models\\Menu
9d5ca5cf-f249-46bd-9872-e51e94c620c7	slow
9d5ca5cf-f2ae-46b3-b5ec-968c59b4f254	App\\Models\\Menu
9d5ca5d7-6e31-4e20-9a0c-74a6b7e8cc3a	slow
9d5ca5d7-6e80-4615-b08f-3bd0f68b6dfc	App\\Models\\Menu
9d5ca6a2-7bb1-47ba-b86d-c039bbed9914	slow
9d5ca6a2-7f38-404d-a689-65a2cee92d6f	App\\Models\\ItemLoans
9d5ca6a4-2cca-4176-a1a8-40dcbf736191	App\\Models\\Menu
9d5ca6d8-7009-4c68-bc5f-848f4e244629	slow
9d5ca6d8-704f-4bf3-be47-47749533a550	App\\Models\\Menu
9d5ca6df-eba3-4e21-9819-823eb22a819e	App\\Models\\Menu
9d5ca6e2-a138-4fa7-8dbe-3069e045dc0a	App\\Models\\User
9d5ca6e3-283a-472e-978f-a756b48692e9	slow
9d5ca6e3-2888-4059-a712-426698f1b146	App\\Models\\User
9d5ca6e3-86ee-4abd-85d7-c3e5953c4414	App\\Models\\Loans
9d5ca6e3-887d-478a-8ae6-7750d5649726	App\\Models\\ItemLoans
9d5ca766-3cda-4023-9a01-fe55c384b58f	slow
9d5ca766-3d23-488c-b99a-00b857df830b	App\\Models\\Menu
9d5ca78f-5661-4ea3-83f2-43628d043c6d	slow
9d5ca790-f46c-42a2-88cb-769e84c713bb	App\\Models\\Menu
9d5ca7d8-5bdb-433e-9cb5-c6e143476e87	slow
9d5ca7da-16e8-488e-80c4-09c0412b6be1	App\\Models\\Menu
9d5ca7ed-5523-45ad-a51d-11ce3cd0f879	slow
9d5ca7ef-24d2-4bcf-8f7d-aa772f6c70c5	slow
9d5ca7ef-2522-4bb8-ac61-7fc916a5726f	App\\Models\\Menu
9d5ca7fc-39de-4cb1-9603-3d70818b7133	App\\Models\\Menu
9d5ca88d-8db6-4c40-b369-f1889d1709ba	slow
9d5ca890-2aa9-4bd2-9a7b-90c55b7a03ed	slow
9d5ca890-2b0a-471d-81a8-fb8f356d905c	App\\Models\\Menu
9d5ca89d-23fb-41c3-b803-b1e2aecb3acf	slow
9d5ca89d-27db-4fd2-8153-05e501e929ca	App\\Models\\ItemLoans
9d5caab3-c93d-499a-b2f4-7b0f1b16118b	App\\Models\\ItemLoans
9d5caab5-c3ae-45b9-ba2d-63ad49c459bd	App\\Models\\Menu
9d5caac9-0e21-453e-81ae-dff2a7562dbf	App\\Models\\ItemLoans
9d5caaca-4ee0-499d-b75f-5e904d292d62	App\\Models\\Menu
9d5cab17-f330-400e-be0a-a0632b0079c7	App\\Models\\ItemLoans
9d5cab19-d735-4625-880a-d958330e19df	App\\Models\\Menu
9d5cab47-16e5-4399-ac14-59bcef4bae01	App\\Models\\ItemLoans
9d5cab48-7a78-4cab-a471-a351c9e0bc3c	App\\Models\\Menu
9d5cab62-8e54-468e-8919-954a05d9b411	App\\Models\\ItemLoans
9d5cab64-9347-4bff-834c-fa95696111a5	App\\Models\\Menu
9d5cab69-bbf9-457f-8e83-34f41be83e1f	App\\Models\\ItemLoans
9d5cab6b-2395-4c06-bef9-51aaaed6ea3b	slow
9d5cab6b-23e5-4a10-993c-6c760f395d1f	App\\Models\\Menu
9d5cabf4-937e-45d9-87a0-5f51c75e28a5	slow
9d5cabf4-998b-4051-b6d0-0a3417fa82b1	App\\Models\\ItemLoans
9d5cabf7-1041-4db9-980c-d056af579cc5	slow
9d5cabf7-10a3-43b4-ba02-9ae490569954	App\\Models\\Menu
9d5cabfc-fdcb-48ed-a563-9230f6144fe1	slow
9d5cabfd-0171-4ba3-8b13-98c6cd02eb4e	App\\Models\\ItemLoans
9d5cabfe-4ff0-407d-949c-d2d2a0ab8c25	App\\Models\\Menu
9d5cac25-7c92-4885-ac4e-da0c36932de5	slow
9d5cac25-8030-473e-8a49-80bbaf3b1ea8	App\\Models\\ItemLoans
9d5cac27-4542-467c-92cd-02980890a4ab	slow
9d5cac27-4590-4969-bb93-674e962d2aab	App\\Models\\Menu
9d5cac3d-19f8-4f19-a1f8-64cc731d18e6	App\\Models\\ItemLoans
9d5cac3e-5e35-4945-9975-7f1615014bde	App\\Models\\Menu
9d5cb009-e4dd-4cd1-9ceb-c31ededcf6d7	App\\Models\\User
9d5cb00a-3e25-4375-8844-4d7ba8270273	App\\Models\\User
9d5cb0e7-30e0-4b01-be00-d1235d7d1d6f	App\\Models\\User
9d5cb0e7-b8ec-4233-904c-8c74da4f29e9	slow
9d5cb0e7-b936-4671-a517-be04a00ad3fc	App\\Models\\User
9d5cb0e9-ccbb-4cb0-8af6-862b7b125090	App\\Models\\Menu
9d5cb212-3fdb-4ac1-b2f8-82b88bf2e206	App\\Models\\User
9d5cb212-b449-4a9c-8fe8-25373e73b458	App\\Models\\User
9d5cb215-11ce-40d9-9fd7-d75832375523	slow
9d5cb215-1249-4bba-bd8c-2431df162243	App\\Models\\Menu
9d5cb233-bbf5-4fff-86f2-a5d4225c6383	slow
9d5cb233-bc45-4442-9bf4-03007eddefab	App\\Models\\User
9d5cb234-1c50-4064-9d38-35d80aeef687	App\\Models\\User
9d5cb235-c25a-49bf-999c-8a4aeb7c1959	App\\Models\\Menu
9d5cb372-ea1b-427f-8ede-c297d472738c	slow
9d5cb372-ee48-49d6-8fe3-72ecc51ee200	App\\Models\\ItemLoans
9d5cb534-82d0-496d-b31e-e2168fdcf572	slow
9d5cb534-8350-4dea-a0b7-6a93497e0041	App\\Models\\Menu
9d5cbd64-e8b3-404d-8ae6-7933925d5933	slow
9d5cbd64-eccb-402c-866a-0287cd5a48ef	App\\Models\\ItemLoans
9d5cbd67-7cec-4368-8c05-49981e79f715	App\\Models\\Menu
9d5cbdb9-9b0f-4728-b77b-50b9955cd3f9	App\\Models\\ItemLoans
9d5cbdbb-76ac-470b-b69c-4b5492c11841	App\\Models\\Menu
9d5cbdd7-15a5-49f4-bd81-d4ccb79bb9ea	slow
9d5cbdd7-19a6-42cc-be40-81c4f4d1358b	App\\Models\\ItemLoans
9d5cbdd8-ad89-476d-b487-5f8185c7d051	App\\Models\\Menu
9d5cbdf7-62b2-42be-a4a3-b44f61c0e092	App\\Models\\ItemLoans
9d5cbdf8-4fb0-4b0d-a2cb-ecaa0a1590b3	App\\Models\\ItemLoans
9d5cbdf9-f8c2-4d32-8388-d312c9185b0f	App\\Models\\Menu
9d5cbe3a-ceb5-41c9-a2ad-d43cba812e71	slow
9d5cbe3a-d37e-4615-b544-d444ea9f75ef	App\\Models\\ItemLoans
9d5cbe3c-b9af-4097-8881-29860828c76d	App\\Models\\Menu
9d5cbe75-07e6-4909-8eb6-7d6eb7169629	App\\Models\\ItemLoans
9d5cbe76-f59f-443e-9487-07a70d25dc02	App\\Models\\Menu
9d5cbe8b-1793-4829-8320-a153817dd77f	App\\Models\\ItemLoans
9d5cbe8c-aeae-42e5-8672-87b02ceb77d6	App\\Models\\Menu
9d5cbeae-8014-456b-b027-16bf455279a9	slow
9d5cbeae-8431-4cc9-b8f5-e33e37be5fcf	App\\Models\\ItemLoans
9d5cbeb0-49dc-4b45-be54-19a994af5cd9	App\\Models\\Menu
9d5cbec4-7af2-43ff-8338-5fcf377f7d87	App\\Models\\ItemLoans
9d5cbec6-3130-498d-b79b-faac82dd44b9	slow
9d5cbec6-319d-4dfb-ba1c-b1d4aea9260e	App\\Models\\Menu
9d5cbf03-35bb-46ae-a027-d5a1be0fb594	slow
9d5cbf03-398c-4380-b9c4-86c8f246c66d	App\\Models\\ItemLoans
9d5cbf04-f750-4886-8c51-a1becb647bbe	slow
9d5cbf04-f7a3-4563-8130-dd8b3af90484	App\\Models\\Menu
9d5cbf1d-0034-41d8-8532-8acdcadc9d6c	slow
9d5cbf1d-0480-41d2-a71f-82d3c332a9de	App\\Models\\ItemLoans
9d5cbf1e-bfba-4ba1-bd5a-bb51035da0ea	slow
9d5cbf1e-c003-4d2c-a6e3-647787b2010e	App\\Models\\Menu
9d5cc0fb-c0d6-450e-99b1-391a7f903ed0	slow
9d5cc0fe-98ca-4582-9643-31753e5bf485	App\\Models\\User
9d5cc0ff-2213-4111-a67d-b0b48cf46238	slow
9d5cc0ff-2267-4877-a882-c58fda9dcc4b	App\\Models\\User
9d5cc181-f83d-4680-b8cf-867572f09ac6	slow
9d5cc183-ead6-40cc-9a13-a6c00bc3c8a2	App\\Models\\User
9d5ccaf5-ab94-45bd-9764-14362cde1558	App\\Models\\User
9d5ccaf6-3b7b-4658-98f4-80cb1403ff95	slow
9d5ccaf6-3be2-402b-ba9a-447f50f5cec9	App\\Models\\User
9d5ccaf8-4065-4940-bd8c-d15565c312d3	App\\Models\\Menu
9d5ccb05-3bc2-4a84-a48a-9cc6a591d2ba	slow
9d5ccb05-3c19-48c3-967d-77a618b3de31	App\\Models\\User
9d5d1e02-5c4f-442d-97ea-c621e6dbf540	App\\Models\\Menu
9d5d1e0e-8f53-4e3d-afd4-938dc6662287	slow
9d5d1e0e-8fc2-4edb-84e3-9d32db647b49	App\\Models\\Menu
9d5d1e19-8940-4e65-8aed-8e896b76435a	App\\Models\\User
9d5cccc1-b79f-474b-8028-5eec237f9b68	App\\Models\\Loans:16
9d5cccc1-b9e1-4680-8319-ccb15d2b6584	App\\Models\\ItemLoans:
9d5cccc1-babd-4e09-a9b0-22b9da047d74	App\\Models\\ItemLoans:
9d5cccc1-bb7a-4bbd-ab42-55cf399b2a2b	App\\Models\\ItemLoans:
9d5cccc1-bc3d-43ad-af52-0af7ffcff047	App\\Models\\ItemLoans:
9d5cccc1-bcf8-41c2-b28f-baa5f61b12e3	App\\Models\\ItemLoans:
9d5cccc1-bdf2-481a-b975-0a51a69f257e	App\\Models\\ItemLoans:
9d5d1e1e-8c44-42d7-9157-8c25ced12761	App\\Models\\Menu
9d5d1e21-969a-440b-93a5-aa63e0ba4b31	App\\Models\\User
9d5d1e25-813f-4714-a41b-220ec9cf62ec	App\\Models\\ItemLoans
9d5d1e2d-bf84-473e-a71f-45cd33ffb465	slow
9d5d1e2d-c3b6-4633-b483-9e73305e16db	App\\Models\\ItemLoans
9d5cce16-8e52-4148-baed-5770e474be3f	App\\Models\\Loans:22
9d5cce16-8fd5-472f-a740-af2431fe34c5	App\\Models\\ItemLoans:
9d5cce16-90b0-4553-96c3-08669a1ed4ef	App\\Models\\ItemLoans:
9d5cce16-9176-4e7b-8bfd-0a14bf82ef99	App\\Models\\ItemLoans:
9d5cce16-9214-4521-919c-1c4667078db4	App\\Models\\ItemLoans:
9d5cce16-929f-4d81-8089-2740f8727fc9	App\\Models\\ItemLoans:
9d5cce16-9333-441f-9252-ba8aee6a6b61	App\\Models\\ItemLoans:
9d5cce24-cecb-4da3-b041-3d8b2694fc92	App\\Models\\Menu
9d5cce46-02b0-4f8c-8bcf-ed4cf605ec94	App\\Models\\Loans:23
9d5cce46-06da-4aa9-8c89-c8f7287633a6	App\\Models\\ItemLoans:
9d5cce46-076b-408d-9dfc-87f75c6add0a	App\\Models\\ItemLoans:
9d5cce46-0816-4c5e-9c7a-9045ef5b1734	App\\Models\\ItemLoans:
9d5cce46-08af-47c5-9b60-657cd6309e22	App\\Models\\ItemLoans:
9d5cce46-093c-4d5f-811b-9a9161e19865	App\\Models\\ItemLoans:
9d5cce46-09c4-4511-a9c6-87232f95bcfa	App\\Models\\ItemLoans:
9d5cce4b-889a-4dd5-a7e0-d96a432fec56	App\\Models\\Menu
9d5cce5c-24b0-4dff-a589-ff602fb46803	slow
9d5cce5c-24fe-450b-935c-8d7f01805fc1	App\\Models\\User
9d5cce5c-abc7-4f4b-9e64-ddac86194a25	slow
9d5cce5c-ac1a-45e6-85fd-c5fb7afb270f	App\\Models\\User
9d5cce5d-0431-4d45-bf3c-a830e483cbe5	App\\Models\\Loans
9d5cce5d-05dc-4415-bc97-ed9bc53a2256	App\\Models\\ItemLoans
9d5cceb6-7af1-41fe-bb22-fc905f5053d2	App\\Models\\User
9d5d1e30-17dd-46bd-8c6a-f575e05ead22	App\\Models\\User
9d5cceb6-e882-490f-a09c-063072827562	App\\Models\\User
9d5cceb7-42ff-476f-b674-89813996285c	App\\Models\\Loans
9d5cceb7-44ef-46c3-9134-b8bcc1043d90	App\\Models\\ItemLoans
9d5cceca-ee71-44f7-bb65-5d506cc0a3d5	App\\Models\\ItemLoans
9d5d1e08-bfdf-45bd-85b1-eb283024d0e5	App\\Models\\ItemLoans
9d5d1e10-7d38-4011-8c59-ad37fcf56c33	slow
9d5ccf76-3199-4444-a374-97a2ee55b0ba	App\\Models\\Loans:26
9d5ccf76-332d-403d-aceb-5ecb2e566ea0	App\\Models\\ItemLoans:
9d5ccf76-33be-434d-a0a3-548884bb6ab5	App\\Models\\ItemLoans:
9d5ccf76-344a-46b3-a530-a7ec0e9a4573	App\\Models\\ItemLoans:
9d5ccf76-34d1-4219-8d42-c19fd671cd36	App\\Models\\ItemLoans:
9d5ccf76-3589-4afa-a3dd-930682182db8	App\\Models\\ItemLoans:
9d5ccf76-363d-4a8d-9ee9-0a0e6d57f9b5	App\\Models\\ItemLoans:
9d5ccf82-16f0-433c-b96d-d3e1d20b2fc9	App\\Models\\Loans:27
9d5ccf82-187c-4e3c-a665-d33645648f36	App\\Models\\ItemLoans:
9d5ccf82-1910-434f-bccd-252fe879caa6	App\\Models\\ItemLoans:
9d5ccf82-1999-42bf-8bef-c04662d878b0	App\\Models\\ItemLoans:
9d5ccf82-1a1e-4410-a073-bc2286fad98d	App\\Models\\ItemLoans:
9d5ccf82-1aab-47e2-a9f3-689d92103d65	App\\Models\\ItemLoans:
9d5ccf82-1b32-42e7-bbdc-22c081c90533	App\\Models\\ItemLoans:
9d5ccf97-cb49-4998-a7a2-ae9a9ce2db92	App\\Models\\Loans:28
9d5ccf97-cd64-4e0b-b37a-a049719f2d6f	App\\Models\\ItemLoans:
9d5ccf97-ce43-40ee-8c72-33eada654c56	App\\Models\\ItemLoans:
9d5ccf97-cf25-46f2-b417-1d30b0949ba4	App\\Models\\ItemLoans:
9d5ccf97-cfdd-4f41-88fb-5bd5917b5373	App\\Models\\ItemLoans:
9d5ccf97-d084-4533-aa46-33ed74d0770d	App\\Models\\ItemLoans:
9d5ccf97-d123-4731-be01-77f9bbe9601f	App\\Models\\ItemLoans:
9d5ccfa5-aeef-4092-8079-34d938577e72	App\\Models\\Loans:29
9d5ccfa5-b0b2-403a-96e1-b2de63cbc7bd	App\\Models\\ItemLoans:
9d5ccfa5-b131-476a-a6c8-a4ff4dc84e91	App\\Models\\ItemLoans:
9d5ccfa5-b1a7-4163-be24-2a1db962974a	App\\Models\\ItemLoans:
9d5ccfa5-b223-4287-b3a9-e11d7773c103	App\\Models\\ItemLoans:
9d5ccfa5-b2b9-42a1-813c-9901d1575ec7	App\\Models\\ItemLoans:
9d5ccfa5-b360-4bbd-b21c-0a5c1452031a	App\\Models\\ItemLoans:
9d5ccfae-f788-4bb6-8c3a-7aea689fa599	slow
9d5ccfbe-9a4c-4504-9f0e-294d8c1920c1	App\\Models\\ItemLoans
9d5cd04d-8a53-41d8-853a-73fbbc0f47f1	App\\Models\\ItemLoans
9d5cd834-cb97-4469-a2b4-88718ad81cb7	slow
9d5cd834-d688-4580-82ad-94dffcb1b2cc	App\\Models\\ItemLoans
9d5cd837-c713-4f18-924d-70bbe0da0f5b	slow
9d5cd837-c769-4813-80ec-6f746a08afcf	App\\Models\\Menu
9d5cd856-e0ce-43de-ad0b-e731d24ea1c4	slow
9d5cd856-e4a5-475d-ab10-a73ad6861bba	App\\Models\\ItemLoans
9d5cd858-644c-4d4e-a2a9-3d506fe352e6	App\\Models\\Menu
9d5cd8d9-8ec5-4a1c-b168-3156d0bb45c4	slow
9d5cd8d9-8f27-4ce5-8a8f-f886188a1f15	App\\Models\\User
9d5cd8da-2f33-4398-aab7-0ee21a1d0fe8	slow
9d5cd8da-2f91-4dbf-bcd3-0f875fa47123	App\\Models\\User
9d5cd8db-1eee-4364-a046-e97a26b3e6fc	App\\Models\\ItemLoans
9d5cd8dc-1c18-434f-87ac-e0f0c963988b	slow
9d5cd8dc-1c5f-449d-969c-f2a9e854f974	App\\Models\\User
9d5cd8dc-7a67-47be-b9c1-8e90b762a242	App\\Models\\User
9d5cd8de-48a9-40de-ab21-f028ea04507b	slow
9d5cd8de-4d8b-479f-bed7-b5928c652246	App\\Models\\ItemLoans
9d5cd8df-60ac-4b0e-849c-0d9cd504820e	slow
9d5cd8df-613b-4ef2-b6b7-6855e5cbe9c4	App\\Models\\Menu
9d5cd8e0-04b3-43c5-b078-193f32771fb8	App\\Models\\Menu
9d5ce043-a5db-490d-b3a6-d7b9af5d1971	App\\Models\\ItemLoans
9d5ce045-5a58-4cea-9c50-85259e80308d	slow
9d5ce045-5ad8-4ac7-a7c9-441a8f37e15c	App\\Models\\User
9d5ce045-d03f-423a-973e-ff0db11f8c0a	App\\Models\\User
9d5ce046-b77b-4fc5-af57-c61c0a312587	App\\Models\\Menu
9d5ce047-c41b-4f0f-a550-2228ce2c77ff	App\\Models\\Menu
9d5ce07e-03fc-4dc9-9b5f-a9ad2eda8ff0	App\\Models\\User
9d5ce07e-6a73-4b4d-9ae2-cc5ec09e6db9	App\\Models\\User
9d5ce080-4ef7-4d19-a45d-ff5b47058e4c	slow
9d5ce080-4f44-4f57-870e-14692c8993cb	App\\Models\\Menu
9d5ce098-0696-4dd8-8ee1-b740d5938180	App\\Models\\User
9d5ce098-7c97-4983-accd-34f77230e7e7	App\\Models\\User
9d5ce09a-7564-4921-bca6-920b0756c886	App\\Models\\Menu
9d5ce0a6-f464-43e1-92c9-0b2dbc5dea3f	slow
9d5ce0a8-39f8-4b00-94e2-1b767c9dca9f	slow
9d5ce0a8-c62d-40ae-bba3-eba0bc817445	slow
9d5ce0b1-eb86-49a9-adde-0ebbd9390472	slow
9d5ce0b3-ff9f-4d21-af06-22f331f7cfe6	slow
9d5ce0b6-919f-40d9-96d4-d46610d2be8a	slow
9d5ce0bc-3633-4f41-8a63-c18952c5633f	slow
9d5ce0bc-bb53-42b9-b054-85302b49d24d	slow
9d5ce0bd-8575-486e-ab57-077a95db6927	slow
9d5ce0c0-d871-44d5-a9a3-19e576083b68	slow
9d5ce0c8-0955-44b4-8342-06aa13a9ac87	slow
9d5ce0ca-4f7c-4229-8fef-621900610a41	slow
9d5ce0d8-19a0-4a6f-a832-9b26850798e1	App\\Models\\User
9d5ce165-59fb-43d1-bbc0-915d0932236b	slow
9d5ce165-5a43-4cc7-90a3-cc919bf8c955	App\\Models\\User
9d5ce165-c399-4dc2-8703-b0c9e898b36a	App\\Models\\User
9d5ce167-f2b2-4ddf-9e72-923b62461e4d	slow
9d5ce167-f318-4658-aecf-541f73b2cf4a	App\\Models\\Menu
9d5ce1d6-d639-40b0-a624-f979bd7b7233	App\\Models\\User
9d5ce1d7-3b2f-4671-bf12-9afa19118f43	App\\Models\\User
9d5ce1d9-512b-483b-8ef5-d06e0271c857	slow
9d5ce1d9-51b3-456e-86d6-8e5296c2b7e9	App\\Models\\Menu
9d5ce1e4-8406-4157-8ee6-801fb81683ed	slow
9d5ce21c-ca72-4be0-9b57-3c54e4b0ef83	slow
9d5ce220-2690-4737-bdda-c7fcfab16765	slow
9d5ce2c9-0ad0-4efa-8659-84042826b58b	slow
9d5ce2c9-0b1c-463b-ad7d-094c59439223	App\\Models\\User
9d5ce2c9-97c8-439b-b3d6-586450c3b00f	slow
9d5ce2c9-981b-43ea-bd46-e8dbd50a1fe4	App\\Models\\User
9d5ce2cb-cfe8-4756-8043-6171819ad26e	App\\Models\\Menu
9d5ce48d-d076-469b-8804-3aac8ba6336f	slow
9d5ce48d-d0cf-426e-a4a5-db6bc0dcae16	App\\Models\\User
9d5ce48e-2dc0-4aba-ac14-f432512e2416	App\\Models\\User
9d5ce490-6dee-4489-a448-6301b91d2a04	slow
9d5ce490-6e34-478f-a092-be5affcd8ef3	App\\Models\\Menu
9d5ce528-87ea-40b9-9b45-b9a5c7c7c42d	slow
9d5ce528-8bc5-41a0-9f1d-65be934d86f7	App\\Models\\ItemLoans
9d5ce52a-b7a2-47b9-86b7-c7fa4b091344	App\\Models\\Menu
9d5ce530-a11a-4383-aa43-7f6b4ae8d2ec	App\\Models\\User
9d5ce531-0054-48f1-8049-15504ac5d0c7	App\\Models\\User
9d5ce532-ba0f-4c8b-920b-8cae887f77e2	App\\Models\\Menu
9d5ce93e-cba1-4403-a7a3-f4189c8db805	App\\Models\\User
9d5ce93f-2a50-40b5-9ba4-412e3c68ac96	App\\Models\\User
9d5ce941-48ce-4667-80c0-fbf93db0f7d4	App\\Models\\Menu
9d5ce94a-2bd1-4f6b-acbc-b7903bee72dc	slow
9d5ce95e-55fe-4738-ac1d-47941000b15e	slow
9d5cea69-1eec-4024-8b73-0868418ca1f4	slow
9d5cea7a-eb00-4d1e-a248-ecc226e4515c	App\\Models\\User
9d5cea7b-4489-40bc-90f4-548055fd215f	App\\Models\\User
9d5cea7d-5af8-45f3-8f5f-c07aa71485b4	App\\Models\\Menu
9d5ceaa2-f9a3-4617-a609-22d926d233cb	slow
9d5ceae4-8fdd-4ca0-8a74-8995c9d61d97	slow
9d5ceae5-24d3-4f72-83f7-6c2a261872e2	slow
9d5ceae8-e192-472c-a47d-413fd687c068	App\\Models\\User
9d5ceae9-6cc4-4472-bf11-c3454ae3ad3d	slow
9d5ceae9-6d10-4035-9e18-75881de00ba2	App\\Models\\User
9d5ceaeb-3be4-4a5a-83d9-644e2828065b	App\\Models\\Menu
9d5ceafa-4934-4ffd-b8ae-51e51c031afd	slow
9d5cec6b-8e4a-4c1b-8dc8-ce1fde5dfa67	slow
9d5cec6b-8e96-4669-85e7-58263e6bc960	App\\Models\\User
9d5cec6b-f9bc-4f76-8f74-a40c05e8f380	App\\Models\\User
9d5cec6d-cbd8-4963-8cdf-11b9275192b0	App\\Models\\Menu
9d5cec7b-f653-498f-b127-e5ad3b87338c	slow
9d5cec86-b30d-423f-a9d7-1e55516c70af	slow
9d5cec86-b722-4815-8a0f-c0ed0062cb94	App\\Models\\ItemLoans
9d5cec88-13cb-4906-ae6f-49c6d041d1ac	App\\Models\\User
9d5cec88-94df-4fc0-9461-bfd92c009d13	App\\Models\\User
9d5cec89-51ff-4686-a1ff-9cbcb30fbd87	App\\Models\\Menu
9d5cec8a-4821-4549-8e9b-d6f39da6b019	App\\Models\\Menu
9d5cec94-e40c-4a41-bc7f-b30d216a6516	slow
9d5cecaf-aa10-4b78-ac87-2bb685610f44	App\\Models\\ItemLoans
9d5cecb1-6d39-46e7-9751-a3aef09e982e	slow
9d5cecb1-6dbd-46a3-8cc4-64bd2ab3f959	App\\Models\\User
9d5cecb2-0e9d-4529-8f38-1fc963a93fd2	App\\Models\\User
9d5cecb4-643a-4709-ab17-f7bf18e4c7f4	slow
9d5cecb4-64b5-432a-9627-54c3e591a82e	App\\Models\\Menu
9d5cecb5-99a9-4cfd-bc7c-a2a4ab64bb11	slow
9d5cecb5-9a47-481c-a700-d5366ca4511c	App\\Models\\Menu
9d5cecb8-a8fb-47d0-90b5-93b2d8d52cd0	App\\Models\\ItemLoans
9d5cecba-3c76-4a51-a8bb-a611e2b5c8de	App\\Models\\User
9d5cecbb-065b-433a-bba4-c3baecfe2f41	slow
9d5cecbb-06c5-4be8-8d9c-4ebaa0ef5918	App\\Models\\User
9d5cecbb-ebd8-4a9b-b8ba-16fea40614eb	slow
9d5cecbb-ec57-420b-a600-1819c47147a2	App\\Models\\Menu
9d5cecbc-fb8e-4afd-aaa2-1f272bba5e25	slow
9d5cecbc-fc04-44c9-a82b-490f2a76ee4b	App\\Models\\Menu
9d5cecc4-6dd2-43b5-b93a-35c989c9ffa7	slow
9d5cecde-96e8-4b6e-b350-5a1c49132e0f	App\\Models\\User
9d5cecde-fa83-4f26-a625-6a20cf8b6249	App\\Models\\User
9d5cece0-f7a0-47c4-aa5b-edda91c9e6c0	slow
9d5cece0-f7e6-4b8c-a44b-dbd119656e3d	App\\Models\\Menu
9d5cece6-3657-459f-a960-c5af721911cd	slow
9d5ceceb-e64b-4cfa-999a-8d41529b5c57	slow
9d5ceced-ddf7-4cfe-b0d2-fdd1dc40dd17	slow
9d5ced4c-b480-408c-b6c8-61d096377d22	slow
9d5ced4d-33db-465b-b813-f76a6482c086	slow
9d5ced4e-bcd8-4cd3-99e0-d87ab5fc7b59	App\\Models\\User
9d5ced7b-89f3-4c10-b6b9-bcf60d98fb63	slow
9d5ced80-eca3-42e8-9444-7d1d37b2c628	slow
9d5ced82-c681-4ccb-93bf-736383aab757	slow
9d5ced82-c6f6-416b-b1b7-33903a3c0a54	App\\Models\\Menu
9d5cee0a-8331-4436-909e-2078499cb0c4	slow
9d5cee0c-cc56-4c0d-b152-b3e3f7815a41	slow
9d5cee0c-cc9f-4044-9d1f-a6f6e5d0bfd5	App\\Models\\Menu
9d5cee6d-5281-4b92-8493-c893ade2c16b	App\\Models\\ItemLoans
9d5cee70-5d03-441a-ba8f-8154f82cc282	App\\Models\\Menu
9d5cee71-4bf2-4b1a-9289-4deec2083c4f	App\\Models\\Menu
9d5ceef6-8e4f-4130-9bb4-8eb16f9f1ab1	slow
9d5ceef8-5b34-4674-956a-e45fa018561b	App\\Models\\Menu
9d5cef9a-e8c5-4f98-87bb-eb93852236db	App\\Models\\Menu
9d5cefb2-4a07-4c1b-9a34-55004c821042	slow
9d5cefb4-0649-4b48-88ed-9d57bfbeaa0e	slow
9d5cefb4-0691-4d63-958d-adeef6ecb611	App\\Models\\Menu
9d5cf2db-7d74-46e0-84cb-f830f89e586f	slow
9d5cf2dd-210f-44e2-af0b-4c21a9fa3b9a	App\\Models\\ItemLoans
9d5cf2de-491a-455a-8dcc-f559bfdbc91c	slow
9d5cf2de-49b3-4811-8cfe-7ed7449db646	App\\Models\\Menu
9d5cf2df-506d-455a-9fa4-cee1e4872f19	App\\Models\\Menu
9d5cf310-f342-4980-94d5-5785296a7ad6	slow
9d5cf312-65fc-4405-9006-b6bf08f0ac3f	App\\Models\\ItemLoans
9d5cf313-778b-4ede-8963-e93ec5a71080	slow
9d5cf313-7862-416c-b863-c8130614c349	App\\Models\\Menu
9d5cf314-9a3b-4017-be82-ae520752e70a	App\\Models\\Menu
9d5cf883-d312-4430-93b8-7de76b7233b7	slow
9d5cf883-d362-469a-be0a-542f04375068	App\\Models\\User
9d5cf884-594c-4569-aa09-f95f6dd10b3d	slow
9d5cf884-59ae-40dd-b71e-feb9ac19fa9d	App\\Models\\User
9d5cf88e-4ec4-4975-b9a4-19c90499a380	App\\Models\\User
9d5cf8e0-8d86-4c22-971a-52ff77934f78	App\\Models\\Loans:30
9d5cf8e0-8fa6-435c-9021-f9bdfc154e02	App\\Models\\ItemLoans:
9d5cf8e0-9038-4be7-a68e-18444bb0dd76	App\\Models\\ItemLoans:
9d5cf8e0-90c2-4334-a532-d38cceac3ceb	App\\Models\\ItemLoans:
9d5cf8e0-9143-419c-92c3-cebdb4bfc3b5	App\\Models\\ItemLoans:
9d5cf8e0-91f5-4e06-90ca-7a6dc181ab37	App\\Models\\ItemLoans:
9d5cf8e0-9295-45c6-8bf3-a27a97936beb	App\\Models\\ItemLoans:
9d5cf8e0-9305-4163-a130-7fd666764553	App\\Models\\ItemLoans:
9d5cf8e0-9370-4c70-937b-7e78804a1c59	App\\Models\\ItemLoans:
9d5cf8e0-942d-4060-802f-7abbffbd6409	App\\Models\\ItemLoans:
9d5cf8e0-94b4-4573-a88f-441636164d0f	App\\Models\\ItemLoans:
9d5cf8f9-0b7e-4c8a-bf53-2969624271c7	App\\Models\\ItemLoans
9d5cf97e-468b-41fa-8d0d-e89dc831f2d7	App\\Models\\ItemLoans
9d5cf980-0199-476b-b113-090d79ef081d	slow
9d5cf980-021b-4d3c-8af4-96df47d640a7	App\\Models\\User
9d5cf980-c4f0-4bbf-803b-b6e64104ed2c	slow
9d5cf980-c563-4c49-9659-03205b0331cf	App\\Models\\User
9d5cf981-e805-404e-a0fe-ea03f0e98500	App\\Models\\Menu
9d5cf982-d3c2-46ea-ba6b-2522d9203961	App\\Models\\Menu
9d5cf9d0-35b0-4bbb-a4b4-259bee81a149	slow
9d5cf9d0-3a42-4cc1-b033-bebf303e9421	App\\Models\\ItemLoans
9d5cf9d1-ff29-430c-977a-ed6169790913	slow
9d5cf9d1-ffbd-46d8-ba1a-4bc71e8f0dee	App\\Models\\User
9d5cf9d2-bb80-4282-80e1-a4fbc4972284	slow
9d5cf9d2-bbc9-4891-9d60-f6ef2956af3f	App\\Models\\User
9d5cf9d3-abb0-439a-b12d-5d9a309d4726	slow
9d5cf9d3-ac67-4069-993c-5d803c708bd5	App\\Models\\Menu
9d5cf9d4-9b64-40d9-86b9-e0c6e5e9e8b8	App\\Models\\Menu
9d5cfa0c-4e7d-4f10-9cd6-d7b80c18ac7d	slow
9d5cfa0c-5241-4cfd-ad22-aad173e83ead	App\\Models\\ItemLoans
9d5cfa0d-b6b1-4a2d-a167-8602faa7e75b	App\\Models\\User
9d5cfa0e-60fc-4fbc-9d18-772285242c98	slow
9d5cfa0e-616f-45d4-b400-a99f4b1630c1	App\\Models\\User
9d5cfa0f-97bc-4f28-8e7e-c68ccc9ff078	App\\Models\\Menu
9d5cfa10-6e03-44bd-aaa9-01b8e9c30acc	slow
9d5cfa10-6e58-4cd7-a908-fa72b4db3e2e	App\\Models\\Menu
9d5cfadd-8d9d-4201-89e7-47ec3800165c	slow
9d5cfae0-81c9-452e-8611-f8653c885577	slow
9d5cfae3-cbdd-4645-a504-9ed315d3f8b1	App\\Models\\User
9d5cfb32-6667-4ae0-905f-f2063fc9eebd	App\\Models\\Loans:31
9d5cfb32-6879-418f-935f-763e1e2b3e9d	App\\Models\\ItemLoans:
9d5cfb32-691a-40f4-b304-74ddb16054dd	App\\Models\\ItemLoans:
9d5cfb32-69ba-44d8-a726-b16eef3292e4	App\\Models\\ItemLoans:
9d5cfb32-6a59-4b56-b272-e3c3d5432e0a	App\\Models\\ItemLoans:
9d5cfb32-6b00-41c6-a2b3-1d90b14caec7	App\\Models\\ItemLoans:
9d5cfb32-6be0-437f-b14a-b1d5cfa9571e	App\\Models\\ItemLoans:
9d5cfc90-744c-4f7d-b16e-520e3b91b947	App\\Models\\User
9d5cfc91-1254-4d7c-8f4c-5d87862cc602	App\\Models\\User
9d5cfc91-b9c6-43eb-8b67-9a9d4edad99f	App\\Models\\Menu
9d5cfc93-4cb2-4d25-bc9c-f12db7576744	slow
9d5cfc93-4d22-4b7c-a912-b35e14a316c9	App\\Models\\Menu
9d5cfca0-2884-47e4-bcf3-b42b8e839fbe	slow
9d5cfca0-28e3-425f-97ca-8e83bc585c8a	App\\Models\\User
9d5cfcfc-8682-4b59-8a9d-b74198ed83a5	slow
9d5cfcfd-e88a-43c1-b0ad-db7182fa4b79	App\\Models\\User
9d5cfcfe-786c-4355-9e11-e9878508af4b	App\\Models\\User
9d5cfcff-ecd4-4c49-9b58-9a10a7d4de34	App\\Models\\Menu
9d5cfd00-c449-452e-914f-6e8f3c8f36c8	App\\Models\\Menu
9d5cfd09-6bfc-4830-9265-7d20714e5259	slow
9d5cfd0a-0c65-4ac8-99dd-c0b51d98534f	slow
9d5cfd0d-74c8-40b9-9d0a-c515daaf013d	App\\Models\\User
9d5cfd34-f079-4749-a085-27f973328c32	App\\Models\\Loans:32
9d5cfd34-f23d-4937-ada6-1cdae3d1e291	App\\Models\\ItemLoans:
9d5cfd34-f2d1-47e9-a300-d3c179ad30d3	App\\Models\\ItemLoans:
9d5cfd34-f367-4233-8849-a4c513297444	App\\Models\\ItemLoans:
9d5cfd34-f3eb-478b-ad49-ddc25c5f063e	App\\Models\\ItemLoans:
9d5cfd34-f477-4489-af5f-c4e9b0419fef	App\\Models\\ItemLoans:
9d5cfd34-f4f7-44bf-be9b-145e686304fb	App\\Models\\ItemLoans:
9d5cfd34-f566-46de-81af-72d38ab09927	App\\Models\\ItemLoans:
9d5cfd3a-8989-49d5-a3a2-ba23834ba052	slow
9d5cfd3c-005b-4d4b-9174-874963295490	App\\Models\\Menu
9d5d1e0c-519c-4678-be11-8e5020588d12	slow
9d5d1e0c-5255-42a6-a4be-4361797dff54	App\\Models\\User
9d5d1e10-7e16-4c74-9a19-612df179d2c7	App\\Models\\Menu
9d5d1e1b-0fd2-438e-b88e-d7161c7b6598	slow
9d5d1e0d-68b2-4312-9225-ce68cc10f2e8	slow
9d5d1e0d-694f-4057-9746-c62d5c74e611	App\\Models\\User
9d5d1e16-7a6f-4ecf-9ec3-ab5d739902df	slow
9d5d01a6-473c-4673-bffd-6bc1ec1e6dbd	App\\Models\\Loans:39
9d5d01a6-4926-46c5-8b65-c8865626a377	App\\Models\\ItemLoans:
9d5d01a6-49bc-4e69-a2b2-d52f732feaae	App\\Models\\ItemLoans:
9d5d01a6-4a43-45de-8187-fd2f2687c3b6	App\\Models\\ItemLoans:
9d5d01a6-4ac6-452f-8df8-2db0d021ddee	App\\Models\\ItemLoans:
9d5d01a6-4b52-401a-af9a-301bb357866e	App\\Models\\ItemLoans:
9d5d01a6-4bd4-41a5-a260-1ba8ceeae184	App\\Models\\ItemLoans:
9d5d01a6-4c51-4e4f-8422-6f428a220313	App\\Models\\ItemLoans:
9d5d1e16-7f4e-4b5c-8e76-f902cbc23c9b	App\\Models\\ItemLoans
9d5d1e1b-106b-416a-a635-89123a213e5e	App\\Models\\User
9d5d1e20-a3e5-4f49-8e27-8a5b92d364b9	App\\Models\\User
9d5d1e24-470a-4ddb-9638-6a75effec76e	slow
9d5d1e24-47ec-4344-926c-b3f1d3216941	App\\Models\\Menu
9d5d1e28-b523-48b7-87c5-4fbcfb547af0	App\\Models\\Menu
9d5d1e2f-a990-4e8d-819d-09bae7d7ddf0	App\\Models\\User
9d5d1e30-e239-4c03-87c2-828c79b2c917	App\\Models\\Menu
9d5d1e32-4efc-4486-a17f-c7d8942d73bf	App\\Models\\Menu
9d5eb91d-8326-47bd-8e36-3f08a7cdbb1f	slow
9d5eb91d-8397-405c-807f-08e9a2ac9ac4	App\\Models\\User
9d5eb936-b467-4e6f-83a5-14f339a905af	slow
9d5d0ab4-54ab-46b6-814e-d8739457e49a	App\\Models\\Loans:52
9d5d0ab4-563f-4aa7-aa64-9856a37e0030	App\\Models\\ItemLoans:
9d5d0ab4-56dc-4f2d-8ff6-3e01156e582e	App\\Models\\ItemLoans:
9d5d0ab4-5788-4177-8648-97f9d89e2d6b	App\\Models\\ItemLoans:
9d5d0ab4-581c-49f9-ae58-a03eb46f9938	App\\Models\\ItemLoans:
9d5d0ab4-58c0-4ef4-af65-7612be4e23bf	App\\Models\\ItemLoans:
9d5d0ab4-5950-4986-83fd-e8badcfa11aa	App\\Models\\ItemLoans:
9d5d0ab4-5a06-4c7f-a30f-1ffd3123db53	App\\Models\\ItemLoans:
9d5d0aba-c57b-42ac-a30c-5d5c55a909a0	slow
9d5d0abc-9dc7-4825-afd3-cae0b4a5e426	App\\Models\\Menu
9d5d0bfb-eff2-4c72-8f37-0aeaaf3dfd6f	App\\Models\\ItemLoans
9d5d0e41-5471-4d73-8953-d6e4f7191d57	slow
9d5d0e41-5b65-4bed-8cfb-6e76c5baebd6	App\\Models\\ItemLoans
9d5d0e42-fc76-4716-8a31-a8996247b751	App\\Models\\User
9d5d0e43-c534-4737-9fda-72e66c0a4980	App\\Models\\User
9d5d0e44-ddc7-40bc-a500-d96cd53fbaf8	App\\Models\\Menu
9d5d0e45-cf60-430c-b350-8603f16ab607	App\\Models\\Menu
9d5d0e7d-ce33-4f41-90cd-d12b62fb584d	slow
9d5d0e7d-d1db-490a-912b-9a7bcfb37f3e	App\\Models\\ItemLoans
9d5d0e7f-3c45-47a3-a06c-d31528f4c948	App\\Models\\User
9d5d0e7f-f895-44e9-85a4-b6aa82494137	slow
9d5d0e7f-f909-4e20-9066-211545af1353	App\\Models\\User
9d5d0e80-d512-4baf-96a2-070c7b58c8e7	App\\Models\\Menu
9d5d0e81-9352-4c28-ad2a-9db69d59056e	App\\Models\\Menu
9d5d0ec7-04f0-46c1-b7a1-2f1501cf5ace	slow
9d5d0ec9-2110-4188-9155-290a9f60294a	slow
9d5d0ec9-215f-4269-b1e7-4a4d90c24cf4	App\\Models\\User
9d5d12bc-47e8-40d7-b75c-70fbeb2abd97	slow
9d5d12bc-4c29-4bb4-9687-94a201a00295	App\\Models\\ItemLoans
9d5d12be-01e2-437e-be23-7808037377aa	App\\Models\\User
9d5d12be-a399-4aa1-8b24-ab4e310acc0b	App\\Models\\User
9d5d12bf-6e49-4471-9470-15eaa93e3fb0	App\\Models\\Menu
9d5d12c0-3aad-45d7-976d-33bb88395b59	App\\Models\\Menu
9d5d13d3-bed6-4783-bc6f-c41b4cd339f6	App\\Models\\ItemLoans
9d5d13d4-a23a-4fcc-84ff-344f85c47495	App\\Models\\ItemLoans
9d5d13d6-2eca-40b9-92af-c990f3a74df0	slow
9d5d13d6-2f38-44ed-b9b1-a6d61c163b6c	App\\Models\\User
9d5d13d6-ce95-4ccc-9601-b9193de853e7	App\\Models\\User
9d5d13d7-dac3-4e79-a39a-0d9432d92342	App\\Models\\User
9d5d13d8-73cf-4e5d-ad0c-610fa3fcc1f7	slow
9d5d13d8-741f-4603-8182-08a97896c182	App\\Models\\User
9d5d13d9-791f-4143-8a55-459db26bb757	slow
9d5d13d9-79a0-44e3-b205-c22365100624	App\\Models\\Menu
9d5d13da-58cc-498e-b5d0-e8328cb23a8e	App\\Models\\Menu
9d5d13ed-1304-4742-80ba-9bce7025a457	slow
9d5d13ee-1f0e-43fa-96f1-a6022187180e	slow
9d5d13ef-07cc-4b31-b7ef-830d08b1ed52	slow
9d5d13ef-8d48-43cd-a0fb-b906d749dc5d	slow
9d5d13f1-a532-4306-a3a8-700eeb1de7f8	slow
9d5d13f2-2f94-4ac0-a982-d5820b3adb99	slow
9d5d13f3-6ea5-4615-9b2c-81df578de5e6	slow
9d5d13f7-5c56-4d59-826f-26599f58a624	App\\Models\\User
9d5d147b-878d-43c2-8113-3c76a381a05f	slow
9d5d147d-0d36-4f79-9868-cb4c3284503d	App\\Models\\Menu
9d5d153d-8dcd-46bd-9424-8cfeb9b61d05	slow
9d5d153d-8e32-4168-b022-e48664f5f6c7	App\\Models\\User
9d5d153e-05ca-4a3a-b411-1a7d3b181cb0	App\\Models\\User
9d5d1540-55c2-456e-889e-c7da092ea557	App\\Models\\Menu
9d5d1542-ccbb-4621-8341-7efe1a2e0da4	App\\Models\\Menu
9d5d154c-48cc-458a-9c15-84965489adbb	slow
9d5d154c-4916-4450-a53e-83454a24fdca	App\\Models\\User
9d5eb936-b4c0-4cea-bec4-620da5840356	App\\Models\\User
9d5d1641-39d3-436d-b575-021597a1c93b	App\\Models\\User
9d5d1641-d514-47b4-85e0-800c7b4b3f32	App\\Models\\Menu
9d5d1642-386e-4b6c-b517-e648e82cfa02	App\\Models\\User
9d5d1644-5b77-43ce-abca-1226cccb0141	App\\Models\\Menu
9d5d164e-19fc-45b1-8c65-c6ad36ae874e	slow
9d5d164f-7c22-4848-aff2-d7cbf078b37c	slow
9d5d1654-2fc7-432e-a2fd-1ae51b95283b	slow
9d5d1654-3018-410e-8522-0d3641b40161	App\\Models\\User
9d5d167e-1250-4a88-9e08-4715a5317bbf	App\\Models\\Loans:54
9d5d167e-13b1-4440-956f-2cc9e6e6d62c	App\\Models\\ItemLoans:
9d5d167e-1466-4893-b3bc-197cfa9766e3	App\\Models\\ItemLoans:
9d5d167e-1510-4ed3-b879-3aef0c5b417b	App\\Models\\ItemLoans:
9d5d167e-158b-49ec-80a3-e5606c54fa96	App\\Models\\ItemLoans:
9d5d167e-1605-4344-a15a-d1b551c3d0c8	App\\Models\\ItemLoans:
9d5d167e-1687-46f5-8491-f2673cc322b1	App\\Models\\ItemLoans:
9d5d167e-1706-41d1-b4e7-26501c5ae726	App\\Models\\ItemLoans:
9d5d169c-1d25-4f8f-93de-f27b21a66def	App\\Models\\Menu
9d5d16c4-2b70-4ed2-b025-41b55a93d373	App\\Models\\Loans:55
9d5d16c4-2ccd-453f-b606-bd96d0a6511b	App\\Models\\ItemLoans:
9d5d16c4-2d66-46db-9d9f-cda89565794c	App\\Models\\ItemLoans:
9d5d16c4-2e0f-4abc-bad3-9bd7b22c3d3a	App\\Models\\ItemLoans:
9d5d16c4-2eb0-4847-baed-465511f83e46	App\\Models\\ItemLoans:
9d5d16c4-2f5a-464e-9c3e-415eee9f4a4e	App\\Models\\ItemLoans:
9d5d16c4-2fe8-470a-bdd7-beab6d9dfd86	App\\Models\\ItemLoans:
9d5d16c4-3066-42c5-bf89-ec1db3335f31	App\\Models\\ItemLoans:
9d5d16ca-ead0-42a7-8253-0ae48e343a94	App\\Models\\Menu
9d5d16f0-4220-436e-aa9e-1635db71033b	slow
9d5d16f0-45f9-4679-b8a4-086141fcfae5	App\\Models\\ItemLoans
9d5d1850-bdd2-40fd-ab49-b1dde555e70c	slow
9d5d1850-c290-4469-b338-cce421261619	App\\Models\\ItemLoans
9d5d195c-bb4c-4a7a-93ba-2652250d2ddc	App\\Models\\User
9d5d195d-1c96-45ec-b8f1-88b6aa623958	App\\Models\\User
9d5d195f-4433-4df3-ad18-b5879e5c1364	slow
9d5d195f-4a4c-42c4-bdc1-0685fdf32f32	App\\Models\\ItemLoans
9d5d195f-fac2-4636-859c-3be12e97bf2c	App\\Models\\Menu
9d5d1960-c0d0-42dd-8c0e-99bfc1c407e4	App\\Models\\Menu
9d5d1de4-3de4-452a-a27f-796e84245be2	slow
9d5d1de4-3e3f-4a20-b0ee-950540856504	App\\Models\\User
9d5d1de4-b65f-4fde-9615-88961b9ba396	App\\Models\\User
9d5d1de7-1a41-4948-86af-b36b5b0d3958	slow
9d5d1de7-21df-4bb5-aa79-9aa526c92336	App\\Models\\ItemLoans
9d5d1de8-f6a5-4060-897f-124de8b2a6d6	slow
9d5d1de8-f72d-4167-b763-d26a990779e1	App\\Models\\Menu
9d5eb944-f8dd-4bf4-bfc8-9636b20bc69d	App\\Models\\User
9d5eb96d-e6aa-47ba-b4b7-dac9858a145a	App\\Models\\ItemLoans
9d5eb9ac-b2da-44bc-8b4e-a892be95e0e5	slow
9d5eb9ca-4588-4451-860e-210712fc9534	slow
9d5eb9ca-45fb-49fa-94ae-eff1302e078b	App\\Models\\User
9d5eb9d2-d816-4a2d-aea5-94faff32c15c	App\\Models\\User
9d5eb9d3-80d9-4eb1-801f-08ff2afc4549	App\\Models\\Menu
9d5eb9e4-1a11-4e91-a301-04a6cbf8aa1c	slow
9d5eb9ea-12eb-40bb-ba29-f64f82b5a4a6	slow
9d5eb9f1-59f8-4e45-8601-91ae291ec659	App\\Models\\ItemLoans
9d5ebe9b-3dbf-4ff1-be93-a3089ebcf948	slow
9d5ebe9b-43ef-4c5c-89b7-23ff24b916b2	App\\Models\\ItemLoans
9d5ebe9b-f89a-4ce4-a2f5-bd3fd8afd7b4	App\\Models\\Menu
9d5ebe9c-cf97-4402-a5dc-b3d3b9ccb1b4	App\\Models\\Menu
9d5ebe9d-f71b-4c04-a7db-e3b1abcdcc8e	App\\Models\\Menu
9d5ebec9-e1d4-4883-b02a-a57969a1b745	App\\Models\\ItemLoans
9d5ebecc-1581-42b7-8f2a-bb0a4b7e7951	App\\Models\\Menu
9d5ebecc-e098-4952-9105-dc61ab0bccd6	App\\Models\\Menu
9d5ebecd-cc29-444b-b7ac-446c2059ac8f	App\\Models\\Menu
9d5ebef3-4fea-47f8-84f0-b9fc43a9177c	App\\Models\\ItemLoans
9d5ebef6-0bdd-4b70-957f-34e08a393f0b	App\\Models\\Menu
9d5ebef6-efe0-4fcb-89f3-791af7358399	App\\Models\\Menu
9d5ebef7-e94f-41a6-a88a-ecfd6374373e	App\\Models\\Menu
9d5ec063-fae2-4629-a62c-54ff0ad9856c	App\\Models\\ItemLoans
9d5ec0f2-792b-4572-b166-f44ab6955718	slow
9d5ec0f2-7992-40ce-bcd2-48ebedac7885	App\\Models\\User
9d5ec0f2-df0b-4de6-a71f-fdf080705b3c	App\\Models\\User
9d5ec0f8-e8b0-40da-9b30-918638347acc	slow
9d5ec0fa-a238-4e81-ba71-038fed516cf8	slow
9d5ec0fd-ede0-4d11-b901-dd5981328339	slow
9d5ec102-1840-4fb9-89da-b9d310fc6f58	App\\Models\\User
9d5ec145-cda4-4672-ad19-7a698085a5be	App\\Models\\Loans:56
9d5ec145-d3c8-405a-ae7c-60b515272162	App\\Models\\ItemLoans:
9d5ec145-d48e-4aca-b1e9-642c03f76a70	App\\Models\\ItemLoans:
9d5ec145-d54a-4c8a-8ed8-ad57b504ea29	App\\Models\\ItemLoans:
9d5ec145-d5e1-49b8-864f-d54b6f3409da	App\\Models\\ItemLoans:
9d5ec145-d666-4b04-852b-bde1e8e6cd19	App\\Models\\ItemLoans:
9d5ec14a-532a-4cb0-bd80-8986d9b20a36	slow
9d5ec159-d46f-4d5d-9fa5-1f32545ddbbc	slow
9d5ec159-d892-4a8c-bb12-c353374498de	App\\Models\\ItemLoans
9d5ec276-d94b-46d4-bf90-e76ae6f4d7ce	slow
9d5ec2e1-6874-4aad-9d36-c74ef199b945	App\\Models\\User
9d5ec2e1-ca7a-4b64-af7b-dcc30d5fc2ae	App\\Models\\User
9d5ec2e2-2854-49d0-b803-8fb6790f3c09	App\\Models\\Loans
9d5ec2e2-2a30-405b-acde-d4b956bb4c4c	App\\Models\\ItemLoans
9d5ec304-9dd4-4908-9d23-924da191214c	App\\Models\\ItemLoans
9d5ec4b0-f9a5-4436-a176-518d1f1b061f	slow
9d5ec4b0-fa0a-4779-bf53-8ee78c533c8b	App\\Models\\User
9d5ec4b1-afcd-41d9-979c-e3cb794479be	slow
9d5ec4b1-b01d-4cd5-a2c5-cef1315f9280	App\\Models\\User
9d5ec4b7-13f1-4bc5-b230-62cd41ab5731	slow
9d5ec4b7-72b9-4db7-b1f9-a2337bf6d711	App\\Models\\User
9d5ec4e1-1376-4d13-885f-18283405c3f9	App\\Models\\Loans:57
9d5ec4e1-15a8-4666-9f4d-34f311eca48e	App\\Models\\ItemLoans:
9d5ec4e1-164b-42cd-a4ed-e5e04ea28599	App\\Models\\ItemLoans:
9d5ec4e1-16e4-48e0-8e1a-8fea09c78f3e	App\\Models\\ItemLoans:
9d5ec4e1-1782-427a-b9b2-4dfce8176ecf	App\\Models\\ItemLoans:
9d5ec4e1-182e-47b1-a306-4182702fef55	App\\Models\\ItemLoans:
9d5ec4f1-925c-4de5-bd4b-f58e9a5a418b	slow
9d5ec4f1-9674-4ec6-9c63-d9607e329db0	App\\Models\\ItemLoans
9d5ec569-73dd-4ac6-90c0-6d45eb9c619e	slow
9d5ec569-7429-4c98-80be-2c27c08e7eb6	App\\Models\\User
9d5ec56a-007b-4f1c-aeed-fbbb16c30a9d	slow
9d5ec56a-00c7-42d2-b07e-957fa77b8055	App\\Models\\User
9d5ec56e-2cf8-4470-a53d-9bab6a94ce83	slow
9d5ec56f-6970-47af-abeb-c376dc312aee	slow
9d5ec574-101a-44d3-94d1-45afbb909c2e	slow
9d5ec574-1074-4f53-a571-7e77e9192cfe	App\\Models\\User
9d5ec596-796d-4f9d-88a2-141b23dd747c	App\\Models\\Loans:58
9d5ec596-7af9-44be-ade8-044aa8a239bf	App\\Models\\ItemLoans:
9d5ec596-7bba-419f-9dab-3d2af206f0de	App\\Models\\ItemLoans:
9d5ec596-7c4f-44b5-9513-43a7b7a2da48	App\\Models\\ItemLoans:
9d5ec596-7cdf-47ce-89b9-efec657e8647	App\\Models\\ItemLoans:
9d5ec596-7d71-4e43-aff5-3eae91229495	App\\Models\\ItemLoans:
9d5ec59c-4435-4bdf-89d4-2554cbcbec6d	App\\Models\\Loans:59
9d5ec59c-45f1-4c0c-be80-e4826088b93d	App\\Models\\ItemLoans:
9d5ec59c-4689-4813-b594-067e0fd86d97	App\\Models\\ItemLoans:
9d5ec59c-474d-4c88-8388-d8d4c8c37c8a	App\\Models\\ItemLoans:
9d5ec59c-4800-48be-a2a5-f6a78bb864c1	App\\Models\\ItemLoans:
9d5ec59c-4894-45e2-9291-a10e59c0d9b4	App\\Models\\ItemLoans:
9d5ec5be-72c1-48d7-a123-ab8b0f7e7a54	slow
9d5ec5c0-836f-438e-8371-f4cf6bb703c4	App\\Models\\ItemLoans
9d5ec66f-c6d1-4dce-8ecd-4eb7d807bad0	App\\Models\\Loans:60
9d5ec66f-c8de-4efd-9821-b341fd6319bf	App\\Models\\ItemLoans:
9d5ec66f-c97c-42e1-a462-07ec83d2f2e5	App\\Models\\ItemLoans:
9d5ec66f-ca08-408d-a179-1b43ce5dd76d	App\\Models\\ItemLoans:
9d5ec66f-ca9a-46c1-829a-4f834f66c8e7	App\\Models\\ItemLoans:
9d5ec66f-cb15-4c3d-88bd-d45039a4b184	App\\Models\\ItemLoans:
9d5ec677-0f85-463e-8456-8fcc68ef5502	slow
9d5ec67d-c91e-4ddb-9c67-3a09282bee32	App\\Models\\ItemLoans
9d5ec6e2-8df0-4533-a449-37ee06b4861a	slow
9d5ec6e5-d03c-4d5f-8a99-6489fcef51df	App\\Models\\ItemLoans
9d5ec74d-b162-46fa-bb84-606fd7880962	App\\Models\\Loans:61
9d5ec74d-b303-45d6-8cfb-46ffd92ecef1	App\\Models\\ItemLoans:
9d5ec74d-b3b3-41b8-8702-39daeef21fc3	App\\Models\\ItemLoans:
9d5ec74d-b448-45e1-81f6-7004965ba9dc	App\\Models\\ItemLoans:
9d5ec74d-b4ce-42b7-9408-8034ce79b6b6	App\\Models\\ItemLoans:
9d5ec74d-b551-44d4-bf9f-a8059e806bef	App\\Models\\ItemLoans:
9d5ec759-b01d-4253-8a52-82d43db50e13	App\\Models\\ItemLoans
9d5ec7dc-e94f-49a3-95d5-233471663611	App\\Models\\Loans:62
9d5ec7dc-eada-48bb-b765-1aeff550b40e	App\\Models\\ItemLoans:
9d5ec7dc-eb63-4e9f-8e66-579d14458b85	App\\Models\\ItemLoans:
9d5ec7dc-ebe2-4906-8ac1-7a7bf955ad48	App\\Models\\ItemLoans:
9d5ec7dc-ec66-4c31-ba7d-2c16027e4ad6	App\\Models\\ItemLoans:
9d5ec7dc-ecf1-442e-b434-cec39731e4ee	App\\Models\\ItemLoans:
9d5ec7e9-0e98-44f9-9f3c-00ea14272b74	slow
9d5ec7e9-12ad-47da-b27c-95adbf82af45	App\\Models\\ItemLoans
9d5ece89-96b5-4b3d-bbcf-78dbdf9a3bd7	App\\Models\\ItemLoans
9d5ece8a-cb25-4584-8540-ecf827641636	slow
9d5ece8a-cf11-4814-80d5-2cb2bfd90056	App\\Models\\ItemLoans
9d5ece8c-7533-420d-acd6-b950620acfea	App\\Models\\User
9d5ece8d-2321-4323-b748-b6f1e7f73925	slow
9d5ece8d-236b-41f9-b17b-100c808d81aa	App\\Models\\User
9d5ece8e-3037-4e24-898c-02039cb33a28	slow
9d5ece8e-30af-4540-b7c0-3461ef214d0a	App\\Models\\User
9d5ece8e-b782-4702-9013-84e1127e102a	slow
9d5ece8e-b7d6-462d-9314-d0fc91ca7483	App\\Models\\User
9d5ece8f-7361-43cf-b4d4-e92d8c176f36	App\\Models\\Menu
9d5ece90-3152-49ec-8e4b-dd7983a13314	App\\Models\\Menu
9d5ece91-3dc5-4483-9882-526eb071d303	slow
9d5ece91-3e41-4d24-b0b2-9c70b1f8a1c8	App\\Models\\Menu
9d5ecee6-39c7-4ec6-98b8-42d143a1b4db	App\\Models\\User
9d5ecee6-d5d9-4581-8894-c0fe6422b753	slow
9d5ecee6-d65a-4837-9575-8d9492327b09	App\\Models\\User
9d5ecee8-880a-4d23-a884-7ab10c582243	App\\Models\\ItemLoans
9d5ecee9-bea1-4608-bb3e-5cbd283b9238	App\\Models\\Menu
9d5eceea-87a6-4f39-b171-70e23699a0cc	App\\Models\\Menu
9d5eceeb-6479-4d8d-9a0e-f62cacb9ce75	App\\Models\\Menu
9d5ecf14-f0b6-4978-94ea-ac7c7801a2a7	slow
9d5ecf14-f120-4e65-bf8d-e3cf6d69ec5b	App\\Models\\User
9d5ecf15-623b-41ce-b8eb-1a5d173ec4e6	App\\Models\\User
9d5ecf18-d236-4729-8521-17e06af0063a	slow
9d5ecf18-d85e-453e-ad4c-b4fd250a994e	App\\Models\\ItemLoans
9d5ecf1a-0eaa-472c-a4de-0e0eb258f3ae	slow
9d5ecf1a-0f46-4ed8-b38b-67336f29f530	App\\Models\\Menu
9d5ecf1a-e1a0-444d-a4c7-ead2e5c999ff	slow
9d5ecf1a-e1fa-4b8d-9f6c-764b506a4451	App\\Models\\Menu
9d5ecf1b-df45-47e0-a384-c92fcd7822b1	slow
9d5ecf1b-dfa0-49f6-97b3-4333dfab6168	App\\Models\\Menu
9d5ecf43-d8a7-4e63-ab9b-16ffe529b7cd	App\\Models\\User
9d5ecf44-374c-4ab5-bb71-8949594f5057	App\\Models\\User
9d5ecf45-bf21-41cd-a63a-491cba95d1f2	App\\Models\\ItemLoans
9d5ecf46-e634-48da-bd17-f870cdfa6ef9	slow
9d5ecf46-e6b8-4ab1-b3e5-b7ce1f96adcb	App\\Models\\Menu
9d5ecf47-99eb-4b39-96d5-aecb4dab7c2b	App\\Models\\Menu
9d5ecf48-a15d-4d4b-8c8b-69de3d7b8f1c	App\\Models\\Menu
9d5ecf4f-b3e3-40f6-9976-bfe7ec0e0e49	App\\Models\\User
9d5ecf50-55b8-4685-8fb9-f34e1891a473	slow
9d5ecf50-561c-460b-94e4-f051677f4226	App\\Models\\User
9d5ecf51-e9c0-4767-880f-82ea212ec46d	slow
9d5ecf51-ef5b-453d-88d9-ae3cce345710	App\\Models\\ItemLoans
9d5ecf53-0903-4efb-83d5-5c71a3d231ee	App\\Models\\Menu
9d5ecf53-83ec-4392-bd58-622c6d6b7876	App\\Models\\Menu
9d5ecf54-53ea-48c9-af80-caefcb29db54	App\\Models\\Menu
9d5ecf80-5cc4-46e1-8363-8805f9a76992	App\\Models\\User
9d5ecf80-ccd0-472b-9dbf-dc98ad20015e	App\\Models\\User
9d5ecf83-5c08-4ae3-85e2-ed48e6f1b259	App\\Models\\ItemLoans
9d5ecf84-6441-4371-8cad-c7e7f2295048	App\\Models\\Menu
9d5ecf85-6ce5-4fca-a82e-84937a71aeac	slow
9d5ecf85-6d3c-44b1-a978-6a6f635c1f86	App\\Models\\Menu
9d5ecf86-478d-43a4-aa86-f7e072dbd5bb	App\\Models\\Menu
9d5ed0cb-1a95-4e0a-a9ed-6c64b2811b62	App\\Models\\User
9d5ed0cb-79e3-4248-8fe2-691b6715b0aa	App\\Models\\User
9d5ed0cd-eb8a-476a-afa7-979aca9463eb	App\\Models\\User
9d5ed0ce-610d-4cd7-94fa-ac530fd53abd	App\\Models\\User
9d5ed0cf-ec16-423e-a0e5-03be66d74e7f	App\\Models\\ItemLoans
9d5ed0d0-f13f-4507-94e0-122edd5cc668	App\\Models\\ItemLoans
9d5ed0d1-c6bb-49f9-b101-52af66a19f9c	App\\Models\\Menu
9d5ed0d2-d234-4086-b9bc-0aa74c0e2cd0	slow
9d5ed0d2-d2bd-42ff-a591-b279c9bc70d5	App\\Models\\Menu
9d5ed0d3-ab1f-46f1-9a23-c4f552293a10	App\\Models\\Menu
9d5ed10f-75ff-474b-b2e0-7b8ef0433ff5	App\\Models\\User
9d5ed10f-dc48-4b57-ad86-770c953e0c38	App\\Models\\User
9d5ed111-5752-4f9b-b6b1-71414cc9efb1	App\\Models\\ItemLoans
9d5ed112-9d97-47cd-95b7-c5cfdccc2303	slow
9d5ed112-9e2f-4f5c-b178-16e2f6015ace	App\\Models\\Menu
9d5ed113-4d37-4dfb-b0ca-9fe068dfba08	App\\Models\\Menu
9d5ed114-20e8-483a-8610-793ceb41c7ff	App\\Models\\Menu
9d5ed227-1c7e-4a0f-8d5d-d08d55aa613a	App\\Models\\User
9d5ed227-b045-47e9-b497-c9c2f09cdde0	slow
9d5ed227-b092-44ca-8061-a8689a96b538	App\\Models\\User
9d5ed22a-7617-4df8-a0e5-81b6af4e11e9	App\\Models\\ItemLoans
9d5ed22b-ab65-4f81-8e97-10fdf13ef9be	App\\Models\\Menu
9d5ed22c-2fb3-410b-8d69-7cef9cbe606c	App\\Models\\Menu
9d5ed22d-05e4-45e8-8998-5335a1867e46	App\\Models\\Menu
9d5ed334-0955-47c8-a9e8-646f511a4259	App\\Models\\User
9d5ed334-977b-486c-9d5e-bb3c57fc32a6	slow
9d5ed334-97dc-45e5-9466-c3bc48020bef	App\\Models\\User
9d5ed336-0d23-4219-9eda-bb012bed9da2	App\\Models\\ItemLoans
9d5ed337-74bf-43ba-be72-c8b920bfefba	slow
9d5ed337-75a6-4b7d-a216-b4d315f306a6	App\\Models\\Menu
9d5ed338-1bad-4f1e-b37f-72b49d4e20da	App\\Models\\Menu
9d5ed339-1901-45e0-b5fe-c621cc091511	slow
9d5ed339-1976-4fdd-9fb2-b7a570d4e00a	App\\Models\\Menu
9d5edf70-eced-4e4a-a6b6-18332c25473a	slow
9d5edf74-12a6-4c1a-bea8-2d9c2d63a64c	App\\Models\\User
9d5edf74-8989-4b58-9c1b-fa6446a1897a	App\\Models\\User
9d5edf75-18aa-4dab-950e-63a76894fca4	slow
9d5edf75-afb7-4c04-9a0c-5227ee1236a3	slow
9d5edf78-68b6-430b-a6bc-e1713e6346ec	slow
9d5edf78-746a-454c-af40-12f4d24bc5dc	App\\Models\\ItemLoans
9d5ee0c1-ed78-480b-85de-d567acbb8667	slow
9d5ee0c1-f578-4ee1-8f60-f474234e955e	App\\Models\\User
9d5ee0d0-3ba6-43ab-bf29-5288f36ec4a4	slow
9d5ee187-5c5e-4687-b78a-d4ee01c4253a	slow
9d5ee18d-2164-44e9-8d92-52b3b7e35b09	App\\Models\\ItemLoans
9d648c91-3f8a-4676-93f6-e95d9e64bfb8	slow
9d648c91-4b3c-4eeb-971d-7c16d6a764c2	App\\Models\\Menu
9d648d51-2f5c-443d-a6d8-b11189f7659c	App\\Models\\Menu
9d648e7c-83fe-4baa-8d5e-d98bafbc82f0	App\\Models\\Menu
9d648eae-84c2-4fa2-b159-8bd3d014c1de	App\\Models\\Menu
9d648eb7-db51-4b55-8a98-1a3b8cdca8ee	slow
9d648eb7-db9e-4105-ba8b-4dca853e6aac	App\\Models\\User
9d648f3c-9ec4-46db-a5a2-cce5e4b37bcc	App\\Models\\Menu
9d648f67-193b-41ba-81d5-a0f1e052a3a5	App\\Models\\Menu
9d648f76-3beb-4deb-ba43-0b201c5b4604	slow
9d648f76-4686-472f-83da-f3ad91ef9d45	App\\Models\\ItemLoans
9d648f85-ffa4-4af2-830e-2a68adfca48f	slow
9d648f8b-3552-4a85-a498-abb3079e55de	slow
9d648f8b-35cb-4052-9615-2b3a2fe6af7b	App\\Models\\User
9d648fd1-a4c6-410b-a39b-1142bdd0d5a6	App\\Models\\Menu
9d648fe6-7cbb-4b50-bfcf-a7e5e9761ea7	slow
9d648fe6-7d0d-400c-a9c5-6ae1d25aaebd	App\\Models\\Menu
9d648fe9-eb32-47a7-9a83-760856ce71ac	App\\Models\\User
9d649039-bc21-4c20-b84d-16b528d68b37	App\\Models\\User
9d64903a-1be9-4831-899d-7c15ee87c12c	App\\Models\\User
9d64904e-6ed7-4a84-b329-8dfd819a1047	App\\Models\\User
9d64904e-d7db-43af-817e-30816dd62c44	App\\Models\\User
9d649050-58d9-4817-9233-3e937009dfc7	App\\Models\\Menu
9d6496b7-ba37-4e89-818c-4e310451aa25	App\\Models\\Menu
9d64ae24-4e55-4729-a2ff-c6daf8178ca2	slow
9d64ae24-4ee2-42e0-bbf6-9c4ed527feef	App\\Models\\Menu
9d64ae40-980b-42be-b2a7-1cf010226fca	slow
9d64ae44-8b5c-46ee-a18d-5f19b5eebd3d	App\\Models\\ItemLoans
9d64af1c-44c0-426b-b0ea-adccaf50d2e0	App\\Models\\ItemLoans
9d64af1e-6886-4f7b-a504-4e04c411b4d8	App\\Models\\Menu
9d64af6b-6253-4d12-8736-8aa2a7cbe1fa	App\\Models\\ItemLoans
9d64af6d-1d31-4f65-a6be-49f2e75ecb57	App\\Models\\Menu
9d64af94-1a4c-4ee8-b0e9-d5127624a87b	App\\Models\\ItemLoans
9d64af96-1aa3-4598-9b5e-626ba53af616	App\\Models\\Menu
9d64afb6-b356-45ba-9b21-dda44ae65487	slow
9d64afb6-b98f-49a0-8216-f0b53ada6c1a	App\\Models\\ItemLoans
9d64afb8-4ce0-4cbb-b47f-5e5c50c38660	slow
9d64afb8-4d55-4b43-b924-d1d64a1ed669	App\\Models\\Menu
9d64affd-f17f-409a-b51e-bfc683cff2d7	App\\Models\\ItemLoans
9d64b000-178a-4048-a463-bff1e3a42ebd	slow
9d64b000-17f6-4378-a5ea-4ff5988ad648	App\\Models\\Menu
9d64b0cc-b571-4626-80a5-c824830f34fc	App\\Models\\ItemLoans
9d64b0cd-8785-453b-8c42-e827765a7a47	App\\Models\\ItemLoans
9d64b0cf-749e-4837-ae55-297f4935a673	App\\Models\\Menu
9d64b1d0-3b1e-4754-b26b-20553d3fdf95	slow
9d64b1d0-409e-4a89-a730-bdba017d4952	App\\Models\\ItemLoans
9d64b1d2-51a8-4eaa-8bfe-98eb77afb553	App\\Models\\Menu
9d64b1f9-c166-40e6-a956-595a877acf3e	App\\Models\\ItemLoans
9d64b1fb-4c2b-42e0-aa8b-1b8284c79315	App\\Models\\Menu
9d64b213-6085-41fd-974f-8a54347462ac	App\\Models\\ItemLoans
9d64b215-03a4-434d-8954-c68bac3b62cd	App\\Models\\Menu
9d64b25a-b76c-4611-a8b2-8d27c4a87df3	App\\Models\\ItemLoans
9d64b2bc-aed0-40c2-a3f1-9b5c58b7e0c1	App\\Models\\ItemLoans
9d64b2be-a772-4591-9f7a-13abfe2b7b2a	App\\Models\\Menu
9d64b462-d2f2-475f-af49-9a98162b09bc	App\\Models\\ItemLoans
9d64b464-c073-4227-b454-fb18fb76fae0	App\\Models\\Menu
9d64b576-eda0-42c5-81ad-e42bbd149310	App\\Models\\ItemLoans
9d64b579-0f3a-4d67-b740-a59063953fe3	App\\Models\\Menu
9d64b66b-9aad-4af8-981b-7c9084c7e015	App\\Models\\ItemLoans
9d64b66d-8d09-4115-a2c7-f69fb0ea968a	App\\Models\\Menu
9d64b6dc-0c46-4c48-8d4c-d9237b6778d9	slow
9d64b6dc-11c5-4fe1-a42f-f08bfb804d9d	App\\Models\\ItemLoans
9d64b6de-24cb-46d3-843a-8bd318924466	App\\Models\\Menu
9d64b764-8163-494e-9dff-f4f5b0dacdfd	App\\Models\\ItemLoans
9d64b766-bbf1-46ba-a3f2-aa20f3aa032a	slow
9d64b766-bc51-45d0-bbb1-1dbdfd807e7a	App\\Models\\Menu
9d64b7e2-8741-4a67-af3d-2001434bd281	slow
9d64b7e2-8b76-4044-8c7a-4c3c167e226b	App\\Models\\ItemLoans
9d64b7e4-79d1-4859-a3de-f525d674878d	App\\Models\\Menu
9d64b80a-b2a2-432c-b932-841f2048ac22	App\\Models\\ItemLoans
9d64b80c-0a5d-4cd4-8bcf-76abb80c226d	App\\Models\\Menu
9d64b81b-ddd6-484e-8381-a9deda3669a3	App\\Models\\ItemLoans
9d64b81d-7f87-4f64-b1c5-861e27f9a6cd	App\\Models\\Menu
9d64b84c-2f11-4867-b43c-75402ea8979b	App\\Models\\ItemLoans
9d64b84d-cdc9-46f7-9739-602344af5d82	slow
9d64b84d-ce4f-4355-b049-ae942546c59c	App\\Models\\Menu
9d64b8f1-953f-4389-94ff-a748d2d0bf63	App\\Models\\ItemLoans
9d64b8f3-9431-446a-96c5-4e83ab594bd0	App\\Models\\Menu
9d64b94e-c49f-44c0-940c-8fc0763c15d7	slow
9d64b94e-c8a2-4a5c-bda0-f3dc74785a10	App\\Models\\ItemLoans
9d64b951-0e26-452f-a25a-03515af47353	slow
9d64b951-0e93-444f-b303-e5452937a36e	App\\Models\\Menu
9d64b965-8095-42bc-a15c-346e4f6133da	App\\Models\\ItemLoans
9d64b966-e249-4767-8090-880f1ba9cbb0	App\\Models\\Menu
9d64b983-c857-46a4-9aac-ce6eb6f8e08f	App\\Models\\ItemLoans
9d64b985-766e-4e73-9f02-0e48799c92d3	App\\Models\\Menu
9d64b99a-83ac-427d-b3e3-9fa112688005	App\\Models\\ItemLoans
9d64b99b-d1f0-493c-8f19-63f72060e1f0	App\\Models\\Menu
9d64b9ad-7579-479a-8267-bdb40e5d4dce	App\\Models\\ItemLoans
9d64b9af-6619-479e-9d81-c26fc308d8c0	slow
9d64b9af-669c-4781-bc7c-59fbd2abbe8d	App\\Models\\Menu
9d64b9bb-040d-4fd5-978e-c8faf2a292f1	slow
9d64b9bb-07aa-460d-ae6b-6fdac70057c7	App\\Models\\ItemLoans
9d64b9bc-e13e-4d94-bad2-d9943c2a8810	slow
9d64b9bc-e1d6-4025-9481-35dc4f919666	App\\Models\\Menu
9d64b9ca-7603-42e0-94d3-f8a1e099c986	App\\Models\\ItemLoans
9d64b9cc-4848-494a-a477-112f86979b44	slow
9d64b9cc-48b1-4b89-8d8b-d09add6290f2	App\\Models\\Menu
9d64ba11-4749-4ee5-a844-c8ebc51a75ad	App\\Models\\ItemLoans
9d64ba13-2c92-4234-9e12-f1152a502ca9	App\\Models\\Menu
9d64ba78-6451-4045-a0d9-9510ce2c65fb	slow
9d64ba89-cc3c-451e-80b2-a725ce9aafac	slow
9d64ba89-d180-4836-b820-d22e924c9f4e	App\\Models\\ItemLoans
9d64bab1-afb0-43e8-ae2e-72e3b23a9862	slow
9d64bab1-b353-46e6-a5e4-336e4ce2a7b3	App\\Models\\ItemLoans
9d64bab3-999e-4007-b6f8-52642e933ae9	slow
9d64bab3-9a14-4e20-be0e-8acc99421330	App\\Models\\Menu
9d64bb77-f5d8-46d1-9601-9e690b78b583	App\\Models\\ItemLoans
9d64bb7a-d5f6-4b90-b917-6dd5cd02a78a	slow
9d64bb7a-d666-472d-bdd2-0d92469e58fa	App\\Models\\Menu
9d64bc72-ca25-43cd-a54c-f30bc00aa907	App\\Models\\ItemLoans
9d64bc75-0556-4768-8592-e13e104d8e1b	App\\Models\\Menu
9d64bf7b-b8cd-4e5e-af9a-f5041c985068	App\\Models\\ItemLoans
9d64bf7e-4ba8-4175-8441-deefecc1d4cb	slow
9d64bf7e-4c51-4d07-8196-e8c69c54c136	App\\Models\\Menu
9d64bfa4-862e-4cb6-8e85-568843dc75c4	slow
9d64bfa4-8a75-49a0-8e89-e53e6c36144c	App\\Models\\ItemLoans
9d64bfa5-fd18-4ccb-9e27-de03c57eba02	slow
9d64bfa5-fda6-4e18-8df1-c2161200836d	App\\Models\\Menu
9d64c06f-622f-428d-be00-5ee340a2d380	App\\Models\\ItemLoans
9d64c071-7501-412e-9694-2ea2147b5365	App\\Models\\Menu
9d64c086-15e3-41c6-a0ba-2718a27788c6	slow
9d64c086-197b-4694-9e88-088c640c6094	App\\Models\\ItemLoans
9d64c087-89ba-4da4-a1a7-8dd71f19781b	App\\Models\\Menu
9d64c0af-8e94-48ff-95fe-9f016f01d927	App\\Models\\ItemLoans
9d64c0b1-4a95-43c4-8eb6-ff77737b7776	App\\Models\\Menu
9d64c2eb-9b14-49a2-8a27-a3ca2f45242d	slow
9d64c2eb-9f16-40b1-9b64-948151e0e7bd	App\\Models\\ItemLoans
9d64c2ed-db71-4f58-a540-6f4af02e91e7	slow
9d64c2ed-dbce-4a81-825e-4b1a8aa9144c	App\\Models\\Menu
9d64c312-448e-4438-b684-1a39fe8282d9	App\\Models\\ItemLoans
9d64c313-a22b-4d96-82a8-dcec92275dc0	App\\Models\\Menu
9d64c3b2-932a-45b0-85a1-b55352635f36	slow
9d64c3b2-9847-4d95-981c-567d36adf7c8	App\\Models\\ItemLoans
9d64c3b4-bc8a-460a-8c33-0fcd140d7ef7	slow
9d64c3b4-bcf2-4c4d-9d11-e81ff255ce1b	App\\Models\\Menu
9d64c412-75e0-422a-87fe-9af1278217e6	App\\Models\\ItemLoans
9d64c414-7c0b-4244-a8d3-9e4556e45fb7	App\\Models\\Menu
9d64c906-e83c-4b93-83a5-4771c7fb2407	slow
9d64c906-ecd7-4823-8beb-6004b7cbdb66	App\\Models\\ItemLoans
9d64c909-18d5-4aff-97c0-547852aa0f4b	App\\Models\\Menu
9d64c91d-8dea-40ed-a933-383600250ea9	slow
9d64c91d-9259-4494-bae4-4372a958c42b	App\\Models\\ItemLoans
9d64c91e-eeec-4860-a71a-90c58b837b16	App\\Models\\Menu
9d64c98e-aa5f-4846-a2da-1ebd370d1bc9	App\\Models\\ItemLoans
9d64c98f-ad2b-4e6e-9410-6944a74f545b	App\\Models\\ItemLoans
9d64c991-e808-41b0-a78a-be30ba70083f	App\\Models\\Menu
9d64c9bc-89b4-4395-92e3-212ef7e4e6a9	slow
9d64c9bc-8ee9-403e-8274-ae8aa2970e05	App\\Models\\ItemLoans
9d64c9be-062f-45cb-b186-04f088833440	App\\Models\\Menu
9d64c9d9-b7fc-4626-b496-c333b543fd76	App\\Models\\ItemLoans
9d64c9db-80c9-439d-9ce8-48b779d423e1	App\\Models\\Menu
9d64ccc6-ec28-4074-a261-cb617d450b0e	slow
9d64ccc6-f12a-4bd7-bf23-2d61d7dc7902	App\\Models\\ItemLoans
9d64ccc7-fad4-44f7-80b8-091d9352fa63	slow
9d64ccc7-fe98-4b3e-abc4-727288b380c5	App\\Models\\ItemLoans
9d64ccca-23b6-4656-afcc-1b940cd34e01	App\\Models\\Menu
9d64cf34-02a5-4569-a6e8-f5b7a8a5d3e1	slow
9d64cf34-030a-4c27-b362-39ee957fffad	App\\Models\\ItemLoans
9d64d183-254b-499c-90d3-40944f6d0454	App\\Models\\ItemLoans
9d64d1d5-4c5e-4c22-ab8c-f43f3cc9b209	App\\Models\\ItemLoans
9d64d2bf-053d-4299-8637-b10491c3057b	App\\Models\\ItemLoans
9d64d2bf-0fa0-4813-948a-bb0412825580	App\\Models\\ItemLoans:187
9d64d2cb-2627-47b1-bbda-7d1b50f5d87c	App\\Models\\ItemLoans
9d64d2cd-52ef-42b2-8303-e35d9ae6be49	App\\Models\\Menu
9d64d3ce-85a8-47fb-bd9f-5b71925e0ed6	App\\Models\\ItemLoans
9d64d3cf-b789-4acd-b7a6-0156fb43a99b	App\\Models\\ItemLoans
9d64d3d1-f65b-4355-9f7c-0dfc8c257098	App\\Models\\Menu
9d689d6c-9f13-496c-b345-4657a94f13f4	App\\Models\\ItemLoans
9d64d3ed-2d0c-4f8c-8a39-7ccbf7ad5b58	App\\Models\\ItemLoans
9d64d3ed-327d-4c28-bddb-99600a14599a	App\\Models\\ItemLoans:188
9d64d3fd-3dea-4184-adb2-b1dc3632e49c	App\\Models\\ItemLoans
9d64d3fe-c311-47a0-b468-d98bc9a53202	App\\Models\\Menu
9d64d41b-1f24-4cc3-8885-1133ad190e0c	App\\Models\\ItemLoans
9d64d41c-ede2-42f7-91a9-f75c23d53d7d	App\\Models\\Menu
9d64d427-f5a0-43c9-8ceb-f0a8e016f6dc	slow
9d64d427-f9f9-41ab-afdd-55d51f0f0009	App\\Models\\ItemLoans
9d64d429-7374-45a3-aeaa-fbb4db0c11e0	App\\Models\\Menu
9d64d471-32e8-4fd9-98c9-f3d08ba386dc	slow
9d64d471-373f-496b-a952-461836c0fa0b	App\\Models\\ItemLoans
9d64d473-5a12-445c-a1d5-968b0cb36349	App\\Models\\Menu
9d64d53b-8529-446b-812f-98fdf6b343d1	App\\Models\\ItemLoans
9d64d53d-cf55-4a91-822e-3ffab7f61253	slow
9d64d53d-cfcd-4d1b-a90c-84ad994b9cfb	App\\Models\\Menu
9d68a046-e61a-4638-945c-4843ae7963ef	slow
9d64d579-5f85-4523-9786-5346e4e9b73c	App\\Models\\ItemLoans
9d64d579-62d0-4e0d-9eb8-ad081b22b4b9	App\\Models\\ItemLoans:189
9d64d60b-04d5-4839-adc5-a8b30d6f4b7a	App\\Models\\ItemLoans
9d64d60d-2dd4-490a-bb0b-c9f9e91419c7	App\\Models\\Menu
9d64d617-f1d8-4de1-bedf-239012317dd2	App\\Models\\ItemLoans
9d64d619-70a1-4f71-aeb6-7f4057ae66ab	App\\Models\\Menu
9d64d643-d81a-45db-8b5b-615c431fd339	App\\Models\\ItemLoans
9d64d645-bc70-477d-861e-24f0bf4907fd	App\\Models\\Menu
9d64d651-c714-4f70-8821-3f9d4724df0a	App\\Models\\ItemLoans
9d64d651-c9b4-4ad8-91a1-126c0ac8ee04	App\\Models\\ItemLoans:190
9d64d652-3a88-483e-a9ff-7398dc761c34	App\\Models\\ItemLoans
9d64d69a-d05f-48db-ab81-520be78535f4	App\\Models\\ItemLoans
9d64d69c-a4be-4966-b40e-456a9f1a51c8	App\\Models\\Menu
9d68a046-eb16-4301-9c19-7eb3b1d93cd7	App\\Models\\ItemLoans
9d64d6ab-07c8-4e22-8a4d-e192a6d95900	App\\Models\\ItemLoans
9d64d6bd-ca37-4984-a251-d4d892ec34e8	App\\Models\\ItemLoans
9d64d6bf-ad74-4e69-8f33-37e4800ddb1b	App\\Models\\Menu
9d64d6c4-c072-4e7c-aef0-dd2faaa58dae	slow
9d64d6c4-c3fe-4008-b0a9-2d4a21e002e8	App\\Models\\ItemLoans
9d64d6c6-3e4d-4272-8848-8a670e479427	App\\Models\\Menu
9d689d6e-a75d-45e2-8238-f5070c02d8ca	App\\Models\\Menu
9d64d6cf-027f-4dfc-97b6-e6031249e866	slow
9d64d6cf-0638-4d6f-bdce-0e90894f5bcf	App\\Models\\ItemLoans
9d68a049-b6b1-4c49-80e9-7cad8e423a5b	App\\Models\\ItemLoans
9d64d6ef-aea0-4703-b050-6fb1a151c63f	slow
9d64d6ef-b2bf-4593-a61e-89ee8aea67dd	App\\Models\\ItemLoans
9d68a049-b859-4e90-8488-6ad816077ff6	App\\Models\\Loans
9d64d6f4-8a59-4332-91b5-7ee7fe8ce62e	slow
9d64d6f4-8e5b-4577-8230-702ed835d9fe	App\\Models\\ItemLoans
9d64dbd3-7f30-479f-9b6a-79e18cbfbd4e	slow
9d64dbd9-7a0d-49dc-9fd7-b2b977544db2	slow
9d64dbd9-7a98-4fe2-90c7-6ac1be4cc8df	App\\Models\\Menu
9d64dbeb-15ea-497b-9b09-cd78ba55efe3	slow
9d64dbed-1a7f-4cf7-85b4-7c573cd84cdf	App\\Models\\Menu
9d64dbff-a685-4d8d-b7f6-cf1f1c89160b	App\\Models\\ItemLoans
9d64dc09-d0e4-4e65-adfd-969cb2cc5366	slow
9d64dc09-d49b-4db0-9756-65a4c16e8a0c	App\\Models\\ItemLoans
9d64dcd3-0ce5-4cd9-b4ca-c2544a821087	App\\Models\\ItemLoans
9d64dcd3-0f09-490e-941d-adcac72cee3c	App\\Models\\Loans
9d64dcd3-2684-4dde-b832-fa2b976a17f3	App\\Models\\ItemLoans:191
9d64dcd3-2794-4c7c-b4e4-ae02b81a04b6	App\\Models\\Loans:62
9d64dcd4-2019-453f-b6ea-1c72cba2d468	App\\Models\\ItemLoans
9d64dfa7-f9a2-44ca-b019-8ec1a9ff0a28	slow
9d64dfaa-86d2-46d0-a235-f863886ed052	slow
9d64dfaa-873a-461b-9358-d2b09a23450a	App\\Models\\Menu
9d654095-b3f4-4a84-825b-99891336db7c	App\\Models\\User
9d654096-f88c-4d0a-82ba-4ff37690ee0f	App\\Models\\Menu
9d6540fe-26ba-4345-ba68-c9268acfacac	slow
9d6540fe-2b50-444c-aa63-d4fd02a2803c	App\\Models\\ItemLoans
9d654665-090b-4dab-b2da-2437bce0c9ef	App\\Models\\Menu
9d654686-0b41-4867-812a-f87ea63ba7eb	App\\Models\\Menu
9d6546d2-c150-4815-8687-df725e97b1de	App\\Models\\Menu
9d6546f3-1e92-40ea-bffc-2bf9ade72aeb	slow
9d6546f3-1ef0-4c32-aeb4-72e176ef463b	App\\Models\\Menu
9d654745-3510-4e45-b340-6594b92a91ca	App\\Models\\Menu
9d6547a6-8d86-44fb-8464-f57ffeafd08a	slow
9d6547a6-8de2-4ec8-8d1e-ee9e041fd0e6	App\\Models\\Menu
9d6548b2-bb19-43ce-bc07-e09cf16e3e45	slow
9d6548b2-bb65-457d-a568-e201d5c9bb52	App\\Models\\Menu
9d65492b-4372-4d33-8719-36a81f14795e	slow
9d65492b-43d1-48b2-aab8-f57057ae6604	App\\Models\\Menu
9d654a20-327f-4547-a93d-7f3c4fe39d6e	slow
9d654a22-57be-42b3-b768-cbfe621302fa	App\\Models\\Menu
9d654ac0-2f9b-4cb0-b650-b6cfc3bed38b	App\\Models\\Menu
9d654b14-3894-4c1e-89a0-f50ef16ccdd8	slow
9d654b16-29ac-417c-bd5b-a7d5aed68d38	App\\Models\\Menu
9d654b43-a77d-418e-88ad-3c0275a658fd	slow
9d654b43-b21f-4a37-8760-ceb613670ad1	App\\Models\\ItemLoans
9d68a049-ba07-478b-89b1-aa5c098e06a7	App\\Models\\ItemLoans:220
9d68a049-bac5-4bc5-a48b-49ae1ed05298	App\\Models\\Loans:66
9d654b4e-6d4e-43b2-b2e6-ab36b4151796	App\\Models\\ItemLoans
9d654ec2-6095-4721-b905-9e75b0c08a71	slow
9d654ec2-661a-4801-8527-5bb259c3e165	App\\Models\\ItemLoans
9d654ec4-8bce-4b53-9ba8-524cbd126594	App\\Models\\Menu
9d654edc-03e5-4391-babc-7445b262a159	App\\Models\\Menu
9d654f4d-ee72-434c-bd85-3fc32d7bb902	slow
9d654f50-3a31-45e1-abe9-6125dc6b0ad6	slow
9d654f50-3a8a-4ce2-a03a-f2e6a598a9f4	App\\Models\\Menu
9d654fc0-b70e-4d05-9264-7db0ad88540c	slow
9d654fc0-b75e-47c6-9a6b-440688f9c928	App\\Models\\Menu
9d655019-396b-4677-9103-3c1cdcdaf223	slow
9d65501b-1ee6-4b71-af21-2f1d272f6868	App\\Models\\Menu
9d65502c-be9e-46a0-9ee1-e9284c41b15f	App\\Models\\Menu
9d6550cd-e313-43f1-b94a-de2c2572197f	App\\Models\\Menu
9d655128-2973-4e20-b8c2-0f2ace99db63	slow
9d65512a-1e49-4e67-a295-3811e9d1658c	App\\Models\\Menu
9d6551a2-25e8-437f-8aff-113c8a22550e	App\\Models\\Menu
9d6551c1-46de-430b-b5ea-b254605c35f7	slow
9d6551c1-475a-43f6-a4f4-9ad7eb75bd8a	App\\Models\\Menu
9d6551ec-29d7-4e2d-bb62-41e0d0d3c998	slow
9d6551ee-210b-4245-98f1-94bf7c71fc2e	App\\Models\\Menu
9d655234-ecda-4854-b72c-1971b658a840	slow
9d655237-35dd-4da5-8d5b-dbf31b9949a8	App\\Models\\Menu
9d6552cd-cbff-4991-841d-b1bd980cf91e	App\\Models\\Menu
9d6552f4-3a12-4931-af1e-05b82039716d	slow
9d6552f5-bc42-498e-a709-b420ba5ddc53	App\\Models\\Menu
9d655517-8bf7-47ce-8b14-f58afd7c7c95	slow
9d655519-a913-4e55-9cba-db3bb51cc12d	App\\Models\\Menu
9d65587b-230a-4486-b268-b813528322b6	App\\Models\\Menu
9d6558bc-95d9-486f-af2a-82b277710b0e	slow
9d6558bc-9672-4f58-ae11-228525102efb	App\\Models\\Menu
9d65590d-a718-42ff-87d1-02fdba66870d	App\\Models\\Menu
9d655947-1902-4685-9aa6-0153366f2a93	slow
9d655947-197b-4f83-b94e-9b856bd97ab5	App\\Models\\Menu
9d6559b5-ac40-4bea-b24c-aaa890077746	slow
9d6559b5-ac95-493c-9f05-cf2021f2b5ba	App\\Models\\Menu
9d655a20-96d1-4861-9884-50405e647100	slow
9d655a22-cd9d-4e59-acb0-d60571cc8d17	App\\Models\\Menu
9d655a65-e2d2-4f7a-9cd5-4dc66c4394e5	App\\Models\\Menu
9d655a73-c979-4fe3-8157-78a278eda622	App\\Models\\Menu
9d655acd-0219-4991-97ac-028e8993ceba	App\\Models\\Menu
9d655b33-28af-4722-9d7d-08fa6a3161e0	App\\Models\\Menu
9d655bbd-b52e-4919-8784-936b67402771	slow
9d655bc0-1ea2-4b25-8288-0e21c2ae38c9	slow
9d655bc0-1f26-4a87-9874-df9186b9aa90	App\\Models\\Menu
9d655c0e-adc7-442a-a970-e6251c9f16d2	App\\Models\\Menu
9d655c2c-90b2-4567-a2b1-165ad4a001ef	slow
9d655c2f-0ccf-43a1-8014-c282fdefe409	App\\Models\\Menu
9d655c4a-98d6-4ee0-b9d6-1d2dd2d85ea5	slow
9d655c4c-19f3-454b-920f-324bf30673d8	App\\Models\\Menu
9d655cb2-9b0f-450b-93fd-ea10c5a6f8d5	App\\Models\\Menu
9d655cd9-083e-4fc6-a2b4-5aa741ad9e13	App\\Models\\ItemLoans
9d655dc3-d458-4eb1-9e2b-c91e675b0dac	App\\Models\\Menu
9d655ee6-8538-438c-93b1-e9b42b752074	slow
9d655ee8-f881-4561-8734-218f82a91920	App\\Models\\Menu
9d655f07-d6a7-4014-a84b-65e8248b0710	slow
9d655f07-dafc-4673-bd42-82a44267dc66	App\\Models\\ItemLoans
9d655f35-4147-4ea1-b270-95298bc2f7b9	App\\Models\\ItemLoans
9d655f57-19ca-4a6a-b9bb-c4e5ad9f2b25	App\\Models\\ItemLoans
9d655f57-2495-43a3-b3cb-63126bb7e036	App\\Models\\Loans
9d655f57-3711-40cf-916a-d54dd14a40a0	App\\Models\\ItemLoans:167
9d655f57-3871-4356-9bf2-ac6eeef39575	App\\Models\\Loans:58
9d655f57-a760-4c13-8bfb-c0d811d29a8f	App\\Models\\ItemLoans
9d68a057-b3bc-43ed-b7cf-e94411019c63	App\\Models\\ItemLoans
9d69c224-3c8c-4a6c-b4e6-6a06952ccd75	slow
9d655fcb-39c1-4dcb-8e4a-c269bde29de7	slow
9d655fcb-3d93-418c-80ec-250396be6ddb	App\\Models\\ItemLoans
9d655fff-6fce-41d7-855e-4a459e39d02f	App\\Models\\ItemLoans
9d656083-2667-4b6c-ad17-248e85d33ef2	App\\Models\\Menu
9d6560a5-db7c-430d-be8f-f00ab4d4f398	slow
9d6560a5-dbc7-4e07-a756-4f3410a40121	App\\Models\\Menu
9d6560b7-1f21-47be-97f7-7a957077a24e	App\\Models\\Menu
9d6560ce-7c59-43de-9d18-12a5daf31cb0	App\\Models\\ItemLoans
9d6560e5-8f20-4517-b242-07b5fdb476f1	App\\Models\\ItemLoans
9d6560e5-910f-4355-aa0d-aaac8b8aae65	App\\Models\\Loans
9d6560e5-9503-4d47-ace8-6de24be683e7	App\\Models\\ItemLoans:150
9d6560e5-95d3-4f98-aff4-ecbf4dbf5a29	App\\Models\\Loans:55
9d6560e6-2961-43a9-92f7-06a818de1c77	slow
9d6560e6-2d08-4ded-8c49-848b3db8ee39	App\\Models\\ItemLoans
9d6560ee-0e22-4425-83e5-f6307d8b1489	slow
9d656112-d6ac-448f-b07c-578757fe8ca7	App\\Models\\ItemLoans
9d6561ce-de50-4996-9294-eb58042d0171	App\\Models\\ItemLoans
9d6561d0-fcc0-4c60-998c-d3eec98d4440	App\\Models\\Menu
9d6561f4-d1e0-4a1a-b39f-d1f7565c7393	App\\Models\\ItemLoans
9d6561f4-d386-4b29-b175-8786606500ce	App\\Models\\Loans
9d6561f4-d584-4aa5-a93c-942cb5a9be7b	App\\Models\\ItemLoans:136
9d6561f4-d65f-4ddb-a2a1-726a11530e54	App\\Models\\Loans:52
9d6561f5-5713-4cf8-8e01-225c16a60618	App\\Models\\ItemLoans
9d656225-6c1e-4bcb-8f65-55093633eabd	slow
9d656225-6fe7-47b1-be42-c99b3037c943	App\\Models\\ItemLoans
9d65ad7f-5d23-4c25-9d64-448cb6d17329	slow
9d65ad7f-5d91-4595-9d59-563e262e53d3	App\\Models\\Menu
9d65adda-39b8-4fba-9d60-a28d1b6f3a46	slow
9d65adda-3e2d-4bb8-90a6-2857d7ef15cb	App\\Models\\ItemLoans
9d65ae99-3a1d-495d-b34d-6519459b6a16	App\\Models\\ItemLoans
9d65ae9b-6978-45ad-841b-cf9d4f0f0a45	App\\Models\\Menu
9d65aef7-3bf7-43bf-83e6-55d1a1b21cb1	App\\Models\\ItemLoans
9d65aef9-5ca0-4db2-935e-f96176f54f8e	App\\Models\\Menu
9d65b0cd-ac65-4503-8913-588c77737db6	App\\Models\\ItemLoans
9d65b0d0-ba61-4037-9a22-f1a0a35e1998	App\\Models\\Menu
9d65b0d9-b59d-456c-8a61-969c0ea21825	App\\Models\\ItemLoans
9d65b0db-50a0-4d0c-8a29-02fe826778dc	App\\Models\\Menu
9d65b0e1-e589-4b49-9cd3-250471ccc297	slow
9d65b0e1-e966-4581-9511-fd63832f0edd	App\\Models\\ItemLoans
9d65b0ee-c73c-4d08-881f-4df1620e6df0	App\\Models\\ItemLoans
9d65b0ee-c92b-48ec-b928-1fb1886157ca	App\\Models\\Loans
9d65b0ee-cb99-4bca-972d-d99c1a5cfef6	App\\Models\\ItemLoans:182
9d65b0ee-cc90-4f2a-9ef7-a00f78637646	App\\Models\\Loans:61
9d65b0ef-2d4f-4cda-9221-5013412d1d69	App\\Models\\ItemLoans
9d65b180-d739-48cf-b79d-a1a9b94a365c	slow
9d65b180-db9d-4dc7-8c51-0ecb34dbcc7e	App\\Models\\ItemLoans
9d65b3a4-346b-439c-bdd7-8ea50815b849	App\\Models\\ItemLoans
9d65b3a6-6ad7-4b25-926b-4fca9d6bcc84	slow
9d65b3a6-6b58-4878-88d8-f58a7bb88d1e	App\\Models\\Menu
9d65b3fe-3b24-4327-b810-ba42418b4cc2	App\\Models\\ItemLoans
9d65b400-1813-4035-94d0-172d3afc64b7	App\\Models\\Menu
9d65b416-a9d0-4831-a368-e35ed03f2a82	App\\Models\\ItemLoans
9d65b418-79e6-47c9-b0aa-d59c2768f2c0	App\\Models\\Menu
9d65b427-a7c3-436d-9f0a-65488b51beba	App\\Models\\ItemLoans
9d65b429-0ce3-4635-a7f7-6728df9f1c84	App\\Models\\Menu
9d65b4ac-21f1-44ba-93ac-47b3b104d81d	App\\Models\\ItemLoans
9d65b4ae-3eef-4ccf-8f1c-e4f2e63672db	slow
9d65b4ae-3f44-433a-bba2-454b0a506030	App\\Models\\Menu
9d65b4f5-cadd-4852-a3e7-e3d5e9e76efb	App\\Models\\ItemLoans
9d65b4f7-4c4f-4c37-ac5d-862d82b2eb5f	App\\Models\\Menu
9d65b50c-1fdb-4a2f-80d2-49e177b61615	App\\Models\\ItemLoans
9d65b50d-d0fb-4b53-bbad-99a482ccc01d	App\\Models\\Menu
9d65b675-e925-42ec-be10-c3e05ac36319	slow
9d65b675-ed10-48ac-b8bd-ed0216f76910	App\\Models\\ItemLoans
9d65b678-49bf-4fe4-88c8-ab16d956e29c	slow
9d65b678-4a0e-4c6f-a1e0-2b4da4e82c32	App\\Models\\Menu
9d65b6a7-0614-4550-9782-760c5c99cd25	slow
9d65b6a7-09ac-47a0-8bf8-0276e41c4722	App\\Models\\ItemLoans
9d65b6a8-9cbb-4e5a-a4c2-d7c91646d1cc	App\\Models\\Menu
9d65b6c2-2847-4111-9c6a-1d562a8f09e0	slow
9d65b6c2-2c0b-43ab-a7c8-825dbb4ea170	App\\Models\\ItemLoans
9d65b6c4-191b-47be-b0d3-9b81a2572d40	App\\Models\\Menu
9d65b6dc-f960-4f89-8fd7-8ac7dfaf4f8b	slow
9d65b6dc-fd19-4774-a2f7-cd9234ba17de	App\\Models\\ItemLoans
9d65b6de-7946-40e5-8ca7-bc397b64957c	App\\Models\\Menu
9d65b708-272c-432d-bb70-b426242ca5cc	slow
9d65b708-2b6c-4bf6-9186-140031b0f7e1	App\\Models\\ItemLoans
9d65b70a-3820-4e8c-9079-c0f4d93c8ee5	slow
9d65b70a-386d-47df-890a-4ef882610f82	App\\Models\\Menu
9d65b78b-1cef-4743-a12d-88abe06805d8	App\\Models\\ItemLoans
9d65b78d-d665-416d-a25f-7efd1c783d78	slow
9d65b78d-d6dd-44e2-9296-2ed92c6f0e81	App\\Models\\Menu
9d65b791-7902-4088-9d42-af1ee67d930a	App\\Models\\ItemLoans
9d65b793-0011-4c02-8737-53010b0484e7	App\\Models\\Menu
9d65b823-f9e1-49fb-a19d-d6b74fcb7a4e	App\\Models\\ItemLoans
9d65b826-1f43-4f02-bd08-a3826cc2f5ea	App\\Models\\Menu
9d65b919-90c6-4390-a402-850ae026295c	App\\Models\\ItemLoans
9d65b91b-c4c5-46b3-aee6-3921fe41a5cd	App\\Models\\Menu
9d65b92f-d4d5-4087-a180-230b80c20533	App\\Models\\ItemLoans
9d65b931-5cac-4013-a6d9-4cebe445bab6	slow
9d65b931-5d45-4c2a-b647-aab2f907d224	App\\Models\\Menu
9d65b969-4b67-478b-aa84-3f6065e5b6e8	App\\Models\\ItemLoans
9d65b96b-6b58-4575-b559-8709456c8bea	App\\Models\\Menu
9d65b971-089b-4233-a6ad-f70b1528a8e2	App\\Models\\ItemLoans
9d65b972-8a80-4209-aa80-590275e9bc34	slow
9d65b972-8ad2-4980-8334-a1795432e937	App\\Models\\Menu
9d65b99a-236d-4e71-a408-161ef251fce0	slow
9d65b99a-28f9-4f24-8243-dbc31385d524	App\\Models\\ItemLoans
9d65b99c-1cd4-458f-acb9-b53def98b2ae	App\\Models\\Menu
9d65ba20-c67c-48dc-9f00-7577453f386f	slow
9d65ba20-cabf-4140-980c-c49020ce4f3f	App\\Models\\ItemLoans
9d65ba22-02ef-41fa-a7f4-b7cc52312ae4	slow
9d65ba22-067b-4479-9f89-5431d07df31f	App\\Models\\ItemLoans
9d65ba24-cb1c-440d-9621-6f1f059e6641	App\\Models\\Menu
9d65ba5a-d988-4ce3-9443-b15216ffd2bd	App\\Models\\ItemLoans
9d65ba5d-5cd7-437e-9aa8-d178019e9189	App\\Models\\Menu
9d65babb-4a30-48ec-9b53-5afa8465d08e	App\\Models\\ItemLoans
9d65babd-6c14-43d6-912f-7628418dc73d	App\\Models\\Menu
9d65bb3e-a9bd-4ff0-840f-2b73384eab07	slow
9d65bb3e-ad86-4fc9-a942-2e6b8cd13639	App\\Models\\ItemLoans
9d65bb40-de16-4e3d-a888-85ad448a28e7	slow
9d65bb40-de7b-4095-958e-e769e6458bac	App\\Models\\Menu
9d65bb5e-e088-45e7-95c0-d7c999778fdf	App\\Models\\ItemLoans
9d65bb60-53b2-4341-acf2-98a04af88457	App\\Models\\Menu
9d668c57-bcc3-454d-ba75-686ea11b6b85	App\\Models\\User
9d668c58-f6e0-4ac1-aa5f-93924bb8dd6c	App\\Models\\Menu
9d668c93-5950-422a-8209-99f72ee4521b	App\\Models\\ItemLoans
9d668d89-5c66-4785-9c27-83be6aaaaad2	slow
9d668d89-6098-40ac-a150-ade47a55d003	App\\Models\\ItemLoans
9d668d8b-149c-48a1-be94-71986f73acff	slow
9d668d8b-1510-4a97-89fe-9a15a8a19045	App\\Models\\Menu
9d668e9f-e9cf-4c04-bc92-aaf63730ed2e	slow
9d668e9f-edd0-4680-8b4c-3560d3cc9dc6	App\\Models\\ItemLoans
9d668ed4-fee9-481d-976b-8c1eb2bfe78e	App\\Models\\ItemLoans
9d668fa7-4ffa-48c7-b206-fc24057c8d41	App\\Models\\ItemLoans
9d668fa7-5239-49a3-9d3b-e3299b3c64f1	App\\Models\\Loans
9d668fa7-5495-435e-9c2e-acfb2b49a8c1	App\\Models\\ItemLoans:177
9d668fa7-559a-4f60-bcd0-3e900c6c6d2e	App\\Models\\Loans:60
9d668fa8-39a4-41ec-b2ad-ad1ef1f76330	App\\Models\\ItemLoans
9d668fbd-f0a6-47db-b24e-507005cf591e	App\\Models\\ItemLoans
9d668fbd-f292-437d-8ade-ec04a154fcac	App\\Models\\Loans
9d668fbd-f48c-4b03-a7b2-b36e4e845f4e	App\\Models\\ItemLoans:178
9d668fbe-81a9-43aa-bc0f-95d7114dfd20	slow
9d668fbe-859b-4fa2-96eb-3b7211c8c29f	App\\Models\\ItemLoans
9d668fc5-0633-4d0a-9273-977edc5a1f1c	App\\Models\\ItemLoans
9d668fc5-07d9-4279-9f4c-25d7c9167815	App\\Models\\Loans
9d668fc5-09b9-431a-abc2-5b9105a556ff	App\\Models\\ItemLoans:179
9d668fc5-6c8b-4c50-b22a-886fa994be14	App\\Models\\ItemLoans
9d668fcb-66fa-4425-a396-a1d75514d45f	App\\Models\\ItemLoans
9d668fcb-6884-48fe-b3fa-032f9b15bb89	App\\Models\\Loans
9d668fcb-6a41-4f98-adc9-f786b5228315	App\\Models\\ItemLoans:180
9d668fcb-c641-4b8c-a4f2-8b4dda8c4a3b	App\\Models\\ItemLoans
9d668fd6-99cf-415c-b398-f698704c3425	App\\Models\\ItemLoans
9d668fd6-9b89-4c03-afef-ce47cb8cb50f	App\\Models\\Loans
9d668fd6-9fb7-4eda-a22a-5ab07377a59f	App\\Models\\ItemLoans:181
9d668fd6-a08e-4a74-8090-c460565909d7	App\\Models\\Loans:60
9d668fd6-ff16-4aab-8dc4-b818307ec707	App\\Models\\ItemLoans
9d6690b4-a564-4d02-a8c9-12263badc23c	slow
9d66912a-0888-4a34-8310-965f62d164a5	App\\Models\\Menu
9d669185-10f1-4dcb-a8a6-38d3716824f7	slow
9d669188-df42-4465-a55d-a660a41175c7	App\\Models\\Menu
9d669220-45df-4b2c-8aae-9e267cc17da8	App\\Models\\Menu
9d66924d-7875-4fc7-a734-5c731b68fdfd	slow
9d66924f-42d3-485b-8d44-5bd191192517	slow
9d66924f-4325-417f-8dc6-104193614a40	App\\Models\\Menu
9d669264-d9ba-4e47-9d13-7d8a89acabe2	App\\Models\\Menu
9d66929b-6f25-4033-9d53-34862d8f2be5	slow
9d66929d-8723-4727-8cf4-7222f1810e3a	App\\Models\\Menu
9d6692f7-5c71-4361-8652-9f43a7bcd79c	slow
9d6692fa-34dc-4419-a7e6-0e5ac3749c84	slow
9d6692fa-353a-40cb-b4f1-6025be6cec96	App\\Models\\Menu
9d66936c-1054-422a-a6c6-ae413cf11c64	slow
9d66936e-74f9-427e-9e72-5c133aad0229	slow
9d66936e-7542-4b48-99cd-bea13fd904ce	App\\Models\\Menu
9d66943c-0a80-4559-9d08-0e0f4d4e6934	slow
9d66943f-57ad-49ea-a0c2-e89e63c3e0fe	App\\Models\\Menu
9d66946d-9f89-4d23-915e-86833d28c7c4	App\\Models\\Menu
9d66949f-ecae-4a4d-8642-73378868d00e	slow
9d6694a2-a8bb-4227-b6d5-f0c034189606	App\\Models\\Menu
9d669576-cdc8-4107-bafb-babf0cc09b1e	slow
9d669576-ce0e-4a66-8c7b-b71be601ff45	App\\Models\\Menu
9d6695f3-9bf7-4b0e-b312-238a15a728e3	slow
9d6695f6-0121-44c7-abb7-d953cc42ad3f	App\\Models\\Menu
9d6696f7-e3a9-431c-b6c0-6fc708fcc7e3	slow
9d6696f7-e442-4f8e-8cc6-d709e7f69223	App\\Models\\Menu
9d669799-9fd4-4139-9eb7-496b27424657	slow
9d66979b-992c-4f9b-960c-bcd3c231e7ae	App\\Models\\Menu
9d669897-986a-45ca-b21f-1d9adb04e687	slow
9d669899-f4c8-4d54-b6b1-c3832a6fcc8c	App\\Models\\Menu
9d66990a-ac80-4cbc-baa2-388614cf0cad	slow
9d66990a-acea-4905-a761-9afcfbd72b31	App\\Models\\Menu
9d669966-63c4-432d-9bc3-2bfa8cf5906c	slow
9d669966-6440-4c9b-bd96-34cdcbf1d2b7	App\\Models\\Menu
9d6699a5-389f-47d2-8fb1-a6a95c4b923a	App\\Models\\Menu
9d6699b2-39a6-4f52-9a29-7e93f043cda9	slow
9d6699b4-0926-4b79-88c0-acd5560f5dc8	slow
9d6699b4-096e-43c9-ace3-f5a9a657621b	App\\Models\\Menu
9d6699d7-bb70-4d0a-9c23-d5dc92111ecf	slow
9d6699d7-bbba-4338-b726-bac26e8d57a9	App\\Models\\Menu
9d6699ea-7d03-48f0-915b-95ac8ccfcf7b	App\\Models\\Menu
9d669a41-fc54-4a33-b71d-2ef8259171ac	slow
9d669a44-49c0-49a3-a741-47f82e7b9b52	slow
9d669a44-4a0b-4642-a275-54e4b438e645	App\\Models\\Menu
9d669b81-676e-4619-9a5a-1d4705961292	App\\Models\\Menu
9d669bb5-095c-4335-bca5-06f9200b1cce	slow
9d669bb5-09ca-43c2-8f52-9ac3e323329d	App\\Models\\Menu
9d669bee-dc10-4021-836d-56b84fac90df	slow
9d669bee-dc66-4d12-9c5c-6f33e09c18bf	App\\Models\\Menu
9d669c26-0ae8-4271-80f1-3d9338a31508	App\\Models\\Menu
9d669c4c-32cf-492a-be6b-09692e785bb2	slow
9d669c4c-332d-4175-b307-b9b331d4031d	App\\Models\\Menu
9d669c72-5f90-4553-8ddf-570aeca10712	App\\Models\\Menu
9d669d4d-8b69-4486-a07c-ab90fed1d935	slow
9d669d4d-8bc9-4c73-9d59-cb1e16a8fd87	App\\Models\\Menu
9d669db8-6a71-405f-8929-6ec6cac0df35	App\\Models\\ItemLoans
9d669de2-8025-4213-8b92-50234d83cb29	slow
9d669de2-806d-4a0a-8a1c-ee3b61697f24	App\\Models\\Menu
9d669e6a-266b-4ce4-aee8-5e226408868a	slow
9d669e6c-e556-4f83-a82d-d9e570e02ca9	slow
9d669e6c-e59f-4ba9-8e9e-525da70a5c0a	App\\Models\\Menu
9d66caf2-fe56-4ad1-a51c-9802b8a9e930	slow
9d66caf5-6a5b-4930-b57d-abb25c6e388d	App\\Models\\Menu
9d66cb49-ca13-4453-a2ba-26fb713d3b07	App\\Models\\ItemLoans
9d66cba8-4952-42b7-8a89-18f9abf17155	slow
9d66cbaa-7059-40f5-a288-eebdb57f57bb	slow
9d66cbaa-70e7-4475-94c7-3534a787de7b	App\\Models\\Menu
9d66cbb0-d7de-4649-a87c-b643c5b9f7ef	App\\Models\\Menu
9d66cbdf-0242-4a6a-bf6a-dc136baa3613	slow
9d66cbdf-05e9-4fa9-bd9f-2b7975d529b6	App\\Models\\ItemLoans
9d66cd2c-3eb7-42d4-ad29-55f4455e5f7b	App\\Models\\Menu
9d66cd2c-d6ed-4e94-a399-dfed5b0d11ba	slow
9d66cd2c-da95-4ce2-911a-de16ad1a4f86	App\\Models\\ItemLoans
9d66cd9d-62e5-4bc2-a194-e806c6ee7ef4	App\\Models\\ItemLoans
9d66cd9f-a601-44e3-b887-b1d9b5275611	slow
9d66cd9f-a658-44de-a7b3-413cb551eee4	App\\Models\\Menu
9d66cdf9-bb97-4148-8b9b-5a7d743a3e55	App\\Models\\ItemLoans
9d66cdfb-ac8a-41b4-bcd4-169fe19c825c	slow
9d66cdfb-acd4-468f-89ea-5df1970b4545	App\\Models\\Menu
9d66ce09-990b-4a0c-b15f-fb7148032791	App\\Models\\ItemLoans
9d66ce0b-1c00-453b-8d55-a721234d00b0	App\\Models\\Menu
9d66ce11-f7a2-4437-8d9d-b5ff4d043ed2	slow
9d66ce11-fb3e-4495-a2c1-866d2aa0dbde	App\\Models\\ItemLoans
9d66ce7b-9c9c-43e9-b8df-5ba5c55c3a4a	App\\Models\\ItemLoans
9d66ce7d-b102-42d6-9a0a-d7257e194d32	App\\Models\\Menu
9d66ce86-f1c7-44a9-b8e0-b8ace7793c54	slow
9d66ce8a-870a-4380-87cd-578c28f2250a	slow
9d66ce8a-8ac9-4208-a633-a11341120ac1	App\\Models\\ItemLoans
9d66cec0-8e3d-472d-8510-74ee488a2774	slow
9d66cec0-91c7-4a9c-8ac1-f1814bf68688	App\\Models\\ItemLoans
9d66cf8b-e558-4a04-a33d-ceccd9da7116	slow
9d66cf8b-eaaf-446a-b89f-bf046c873738	App\\Models\\ItemLoans
9d66cf8d-fdd9-4dbb-8b92-3135b016809a	App\\Models\\Menu
9d66cfb0-3c86-4669-bb52-7fdd99606400	App\\Models\\ItemLoans
9d66cfb1-a32e-4e78-acb6-0d7a9ea4be41	App\\Models\\Menu
9d66cfea-3abc-4c54-aceb-ec2333a89e4c	slow
9d66cfea-3f48-4cdf-8034-802d579adde9	App\\Models\\ItemLoans
9d66cfec-6d18-4a48-8ac3-8ea47c21246f	App\\Models\\Menu
9d66cffe-92a5-4f9e-ba31-0fcf737f4de3	slow
9d66cffe-960e-4240-a545-4d43d6edc19e	App\\Models\\ItemLoans
9d66d000-006c-400b-9d3f-4e3593337ed1	slow
9d66d000-00cb-4621-9698-bec47ede3010	App\\Models\\Menu
9d66d046-695f-443f-b779-3a7de3375b1b	slow
9d66d046-6e15-455a-a42a-b82f4083eeee	App\\Models\\ItemLoans
9d66d048-8a86-4b66-9937-2943cdcf4252	App\\Models\\Menu
9d66d067-a2a6-4631-a11f-bf29d7d60105	App\\Models\\ItemLoans
9d66d069-2de9-4df3-9aae-435f0637ee7a	slow
9d66d069-2e68-4cee-b248-94a133fc8909	App\\Models\\Menu
9d66d096-2ce0-461b-818f-9337aa7f9083	App\\Models\\ItemLoans
9d66d097-ef43-4966-9292-a97c3f51e44d	App\\Models\\Menu
9d66d0cb-8ec8-4f46-a382-4df9af434afd	App\\Models\\ItemLoans
9d66d0cd-5013-4e87-b614-58731c9dd2c8	App\\Models\\Menu
9d66d147-d531-4b4d-a422-f2d7c6a6e461	App\\Models\\ItemLoans
9d66d14a-275e-4707-b235-4b0f40422d70	App\\Models\\Menu
9d66d170-f420-40f7-aaa3-2a6c9521308a	App\\Models\\ItemLoans
9d66d172-741d-4b24-8d3c-07faa6c69f30	slow
9d66d172-7480-4717-89d8-36b4b8c7bad6	App\\Models\\Menu
9d66d1b2-274f-4c8b-bab7-e02249150596	App\\Models\\ItemLoans
9d66d1b3-f9ff-4c1a-9278-d7d12cffbbe7	App\\Models\\Menu
9d66d1db-bd0e-4396-a3cb-ab87ae4ebbf7	App\\Models\\ItemLoans
9d66d1dd-0b7c-4256-a804-1364b8f820a4	App\\Models\\Menu
9d66d267-292d-4a48-b156-dd37c35ef363	slow
9d66d267-2fa3-4675-bb30-1d83eca4fa5f	App\\Models\\ItemLoans
9d66d26a-a5a6-44f0-94d9-985d27fd25fd	App\\Models\\Menu
9d66d287-021a-40e8-93c7-92d28924bac7	App\\Models\\ItemLoans
9d66d288-5917-4229-b743-3f3b689958c8	App\\Models\\Menu
9d66d2c4-4f6c-457b-8267-120b4f213ece	App\\Models\\ItemLoans
9d66d2c6-d7af-46be-b54e-d610c3f57543	App\\Models\\Menu
9d66d2f6-9054-4c09-ae72-3d4b8a8243b9	App\\Models\\ItemLoans
9d66d2f8-61a1-47f1-a0ea-703747196933	slow
9d66d2f8-624c-4874-b343-a86ec36055e2	App\\Models\\Menu
9d66d34a-54a4-4cd2-a00e-20b07fe4ff05	App\\Models\\ItemLoans
9d66d34c-85f3-4359-a95a-cec6a80666bb	App\\Models\\Menu
9d66d3cd-6bcd-42a5-98b9-d31bedfaacca	slow
9d66d3cd-70e4-4607-9f25-8f19eebf973f	App\\Models\\ItemLoans
9d66d3cf-7b8f-4ad6-91f0-099078a63f5a	App\\Models\\Menu
9d66d572-36d1-4c5b-82cb-b9169e4bc4ac	App\\Models\\ItemLoans
9d66d574-67ae-42c2-bb05-e3cbbdb62966	App\\Models\\Menu
9d66d58d-b086-4458-a977-3647ca0e1646	App\\Models\\ItemLoans
9d66d58f-2aa2-40f5-805f-dfdd0d5cd3ac	App\\Models\\Menu
9d66d5be-c738-4b3b-bbb8-e5e27581ba6b	App\\Models\\ItemLoans
9d66d5c0-94c2-4c93-a192-e262b63432ec	App\\Models\\Menu
9d66d5d1-1788-43fb-aa01-12be60da1e32	App\\Models\\ItemLoans
9d66d5d2-ad9e-4625-9e54-ba758ae49d4c	App\\Models\\Menu
9d66d5e2-8bab-44fe-b293-7dedfeae49ca	App\\Models\\ItemLoans
9d66d5e4-21be-451f-a45c-704023fe3fad	App\\Models\\Menu
9d66d605-7f11-4f90-9a2f-510f0572de1d	App\\Models\\ItemLoans
9d66d607-16fd-44c5-83af-37a1ce785766	App\\Models\\Menu
9d66d63c-ec3e-420a-84e1-ff89f08d753e	slow
9d66d63c-f038-481c-85cd-948bec2bceba	App\\Models\\ItemLoans
9d66d63e-cd25-43f7-9d8d-d0ae8f1cf074	slow
9d66d63e-cd77-4ce3-861c-99400b4cdde2	App\\Models\\Menu
9d66d667-0741-4657-b7b6-777456200016	App\\Models\\ItemLoans
9d66d668-8aa9-4495-8495-0637e8016807	App\\Models\\Menu
9d66d67d-cb45-4d77-beff-0ccce720b530	slow
9d66d67d-cf0a-4ef4-9d9f-69b17f55b1a2	App\\Models\\ItemLoans
9d66d67f-6f9d-431f-8f75-2d684d5088f9	App\\Models\\Menu
9d66d69d-fefd-498a-a129-23d6c252df83	App\\Models\\ItemLoans
9d66d69f-aa85-4d7d-8178-1237e7bf17d1	App\\Models\\Menu
9d66d7e1-7200-417a-b4b3-f301974c077e	App\\Models\\ItemLoans
9d66d7e1-7d86-462c-88b2-9d3e3d0b00a7	App\\Models\\Loans
9d66d7e1-8fce-466b-a370-7f639c081955	App\\Models\\ItemLoans:182
9d66d7e1-90eb-4a78-b283-0b5e4c7c82dc	App\\Models\\Loans:61
9d66d7e2-070c-43b2-ab41-a12d9f4d0db4	App\\Models\\ItemLoans
9d66db1e-0215-45fa-b051-69a36a7c76cd	App\\Models\\ItemLoans
9d66db20-2159-4196-9890-68fc7f89c8ba	slow
9d66db20-21ad-41a4-9e0c-16fdac1b537e	App\\Models\\Menu
9d66df2b-f323-451f-9594-bf90dad9ece7	App\\Models\\ItemLoans
9d66df2e-4f9a-4c97-866c-d7eb8922f567	slow
9d66df2e-4fe1-409b-85b8-efff18e9c472	App\\Models\\Menu
9d66df45-dbdd-442b-b5ee-c51a8eb818cb	App\\Models\\ItemLoans
9d66df47-804d-4159-8fa8-d4e040bbc977	slow
9d66df47-80b5-4ae8-befe-bc8a85924369	App\\Models\\Menu
9d66e029-bd02-47f3-bb7a-f2522ed1e1e8	App\\Models\\Menu
9d66e02a-8b5a-484d-a3a3-f4772b9fe1b5	slow
9d66e02a-90d0-4604-b71c-dcc21ef8426b	App\\Models\\ItemLoans
9d66e03d-379a-40e6-b8dc-159a390c7e52	App\\Models\\ItemLoans
9d66e03e-d08a-485d-8140-9008a245aa21	App\\Models\\Menu
9d66e095-6f28-4b6d-bce4-bb52566d1c78	slow
9d66e095-74e4-4d1f-8856-3d1b607e7738	App\\Models\\ItemLoans
9d66e097-b522-41b0-abaf-a1885e2b7738	App\\Models\\Menu
9d66e0be-0aef-445d-ac55-89f430cb6a45	App\\Models\\ItemLoans
9d66e0bf-d49a-4ac2-bef0-b862219e018d	slow
9d66e0bf-d52f-4bdc-9457-f91d9062254f	App\\Models\\Menu
9d66e12a-2c70-486c-ae4e-f55e5ef7236a	App\\Models\\ItemLoans
9d66e12c-5d66-4a03-8553-446ee8195d76	App\\Models\\Menu
9d66e144-c99a-4d70-a62e-7d7e37fc5627	slow
9d66e144-cd63-4f0a-ac36-b98e2a80c039	App\\Models\\ItemLoans
9d66e146-7584-4956-8a7f-9f4c9553cfb0	slow
9d66e146-75e3-4b87-9060-fc3548db133b	App\\Models\\Menu
9d66e258-cbab-4c80-a419-55c79c5a58b8	App\\Models\\ItemLoans
9d66e25a-e762-4702-b52f-24541e0f864d	App\\Models\\Menu
9d66e27f-1d4f-48d8-9151-90b105b7d5e5	App\\Models\\ItemLoans
9d66e280-9ac0-4494-8843-1d78894dae22	App\\Models\\Menu
9d66e2b8-5ff4-46cd-a2c4-06199952f136	App\\Models\\ItemLoans
9d66e2ba-ea64-492a-8fd2-5d01e00b611c	slow
9d66e2ba-eaad-426d-92f9-685355a36080	App\\Models\\Menu
9d66e35a-fc33-448b-a854-97b3951009e2	App\\Models\\ItemLoans
9d66e35d-39f0-4fd4-9e8c-95670bde2f0e	slow
9d66e35d-3a40-4d8e-b806-bd7e2f246b5f	App\\Models\\Menu
9d66e39d-5e41-4720-acef-78898cba2f85	App\\Models\\ItemLoans
9d66e39f-87f7-4fdc-a9b0-51bf2012d03f	slow
9d66e39f-886c-4b1b-9a13-841a2869ff0c	App\\Models\\Menu
9d66e409-9cb8-4561-9bd3-eadf8702e227	slow
9d66e409-a08a-4449-87b5-9ea6e223e3d4	App\\Models\\ItemLoans
9d66e40b-72a0-430a-b722-a3099657b9f2	App\\Models\\Menu
9d66e465-075e-4d33-aa8f-e42b9136b311	slow
9d66e465-0bf6-47d8-8917-31f3e5245bac	App\\Models\\ItemLoans
9d66e467-5ff0-4048-ba3d-835c7448baed	App\\Models\\Menu
9d66e523-88df-4eb2-bd73-9027ddbe79ac	slow
9d66e523-8ddd-4a29-91cc-5bf38296ba08	App\\Models\\ItemLoans
9d66e525-b294-449f-b925-41de751f0dcb	App\\Models\\Menu
9d66e573-9187-4b0e-90e1-c02f8ddaaeee	slow
9d66e573-966f-4ca9-8163-2b3b502e1ec1	App\\Models\\ItemLoans
9d66e575-4db0-4cb0-b753-5b285d8be3e6	App\\Models\\Menu
9d66e5ce-0907-4a51-871f-9e518833d4bf	slow
9d66e5ce-0d0d-4833-aff3-4e2bf1500bd4	App\\Models\\ItemLoans
9d66e5d0-1717-4f64-984c-f4f4af791748	App\\Models\\Menu
9d66e6b7-328e-40c8-9309-555374a37f38	App\\Models\\ItemLoans
9d66e6b9-77e0-4620-931c-82c97577dc78	slow
9d66e6b9-7826-4ba2-953a-4f8632095226	App\\Models\\Menu
9d66e6e4-62ca-4b72-97f6-d9005635f69a	slow
9d66e6e4-668f-4473-811c-94af446e508f	App\\Models\\ItemLoans
9d66e6e5-f21a-442d-895a-17c474caf06a	App\\Models\\Menu
9d66e723-3732-43df-b642-565fe3396bbf	App\\Models\\ItemLoans
9d66e725-5184-4fb0-b1f7-9a6ebf85ae18	App\\Models\\Menu
9d66e7f5-96cf-49f1-adb6-32ce683a5b4b	App\\Models\\ItemLoans
9d66e7f7-bc51-4946-9049-df36dc43e835	App\\Models\\Menu
9d66e847-581e-49eb-8aea-a550a53696fe	App\\Models\\ItemLoans
9d66e847-5a4a-47fd-b7f8-82d43d9f813a	App\\Models\\Loans
9d66e847-5c57-426c-9852-18e9c9d1666b	App\\Models\\ItemLoans:183
9d66e847-5d64-4dff-ae03-41283d7e9046	App\\Models\\Loans:61
9d66e848-0554-4e15-99d9-45b7b71d7245	slow
9d66e848-096b-4844-bd23-a6d3ca83963c	App\\Models\\ItemLoans
9d66e86e-6d47-4c47-8160-662c132f9171	App\\Models\\ItemLoans
9d66e86e-6f1c-435a-a03d-9dd244f85476	App\\Models\\Loans
9d66e86e-733c-42e0-8f61-bd8caf88f10b	App\\Models\\ItemLoans:184
9d66e86e-7411-4b89-b41e-31e68f29b443	App\\Models\\Loans:61
9d66e86e-ecbb-4d94-b849-153b2230873a	App\\Models\\ItemLoans
9d66eb0e-295c-4910-9bb3-eee7215bdbb3	App\\Models\\ItemLoans
9d66eb10-5d32-443c-9132-9fe3a63a9ce6	App\\Models\\Menu
9d66eb19-8069-4034-846f-ced55ff3c9a8	App\\Models\\ItemLoans
9d66eb19-8215-4e52-9532-ba15620051b9	App\\Models\\Loans
9d66eb19-83b0-4dc0-8195-24af551260f9	App\\Models\\ItemLoans:184
9d66eb19-8482-49ac-b0d6-217e1a744bb6	App\\Models\\Loans:61
9d66eb19-f00e-4913-8e8d-397dae7a311e	App\\Models\\ItemLoans
9d66eb37-717e-45df-9695-5dd2e0085947	App\\Models\\ItemLoans
9d66eb38-e928-4a02-a211-13cbf730531c	App\\Models\\Menu
9d66ebaa-0b3b-4e74-bff2-09b82f978710	App\\Models\\ItemLoans
9d66ebac-235f-4b48-bbf2-5f5a5226008c	App\\Models\\Menu
9d66ebce-886e-4931-96db-f952378b318d	App\\Models\\ItemLoans
9d66ebcf-ef3f-4ee9-b8f4-11a2f61e88b3	App\\Models\\Menu
9d66ebf8-8716-4c5e-b422-51efb18b89a2	slow
9d66ebf8-8b2f-4e2f-ad0a-5211811a1c5c	App\\Models\\ItemLoans
9d66ebfa-8544-4707-b1e2-f3865429f6c9	App\\Models\\Menu
9d66ec4a-9de8-4bfa-98d2-687ad5ce3289	App\\Models\\ItemLoans
9d66ec4c-c4bb-4439-a339-a6aa76de2378	App\\Models\\Menu
9d66ec69-cbef-4f81-aa4e-5d59fc0c8314	App\\Models\\ItemLoans
9d66ec6b-cadf-4a8c-8601-ca7532eadd7d	slow
9d66ec6b-cb67-4f0c-9178-000e33adcafb	App\\Models\\Menu
9d66ec7c-598d-4257-abcf-1a3b78b6c24d	slow
9d66ec7c-5d30-483f-a265-4e56036b32d4	App\\Models\\ItemLoans
9d66ec7d-e051-47ab-9192-7359d89afd7b	slow
9d66ec7d-e0ab-4825-9ca2-763d03bff56c	App\\Models\\Menu
9d66ed1c-b09b-43af-b290-02f069c64247	App\\Models\\ItemLoans
9d66ed1e-c106-4838-b183-ef3281686037	slow
9d66ed1e-c173-4be6-80ac-ae02030053af	App\\Models\\Menu
9d66ed49-94d3-4e0e-8619-1955098fb19d	App\\Models\\ItemLoans
9d66ed4b-79a0-4484-ad57-b54fd1a7fb78	slow
9d66ed4b-7a28-4ad5-8453-3b2722ce387a	App\\Models\\Menu
9d66eda0-160d-415c-ba0c-940700d39781	slow
9d66eda0-1ad9-49d7-9ae1-b932b4de3a2e	App\\Models\\ItemLoans
9d66eda2-5fd6-4127-899c-b5bad9686861	App\\Models\\Menu
9d66ede2-ed34-4c01-9f7d-75906da70ee0	App\\Models\\ItemLoans
9d66ede3-fc32-41e5-85fb-9db1d9875d61	slow
9d66ede4-0031-477f-a895-50c945dcba59	App\\Models\\ItemLoans
9d66ede5-fdc6-4b0c-89e7-7f6624ee84f2	App\\Models\\Menu
9d66edf8-5232-4acf-843f-a4bf2fa7b236	App\\Models\\ItemLoans
9d66edfa-7250-444b-b07c-ae059c6b9ae3	App\\Models\\Menu
9d66ee58-93ed-4537-adf4-1d11c5b6b0cd	slow
9d66ee58-9bb3-4aa9-9d2f-b60d04316f0a	App\\Models\\ItemLoans
9d66ee5b-8d05-42e2-a634-1d593d0196d8	slow
9d66ee5b-8d83-4504-affd-271c258b47c8	App\\Models\\Menu
9d66ee5d-8fed-4811-8618-414654427b7f	App\\Models\\ItemLoans
9d66ee5f-672e-4683-8179-f85772ab3c22	App\\Models\\Menu
9d66ee84-5418-4b11-8db0-a297afd05718	slow
9d66ee84-57c1-4f4d-aa95-f6589de5098a	App\\Models\\ItemLoans
9d66ee86-46a0-4383-b356-4e39de87b875	App\\Models\\Menu
9d66eeaf-00e8-4e6d-9154-c6536a56b3d0	slow
9d66eeaf-04af-4225-92eb-0b19dadbc411	App\\Models\\ItemLoans
9d66eeb0-8672-4f29-af21-42a59725bbcf	slow
9d66eeb0-86fb-41af-a047-24eed730f9f2	App\\Models\\Menu
9d66eed6-636d-47df-844f-5194459d9fa3	App\\Models\\ItemLoans
9d66eed8-13c4-4fff-ba62-7c22fc5e8399	App\\Models\\Menu
9d66eeff-36e2-40db-858f-2e7a2d0750c2	App\\Models\\ItemLoans
9d66ef00-b48b-4fc2-8005-bf988c5ada0e	App\\Models\\Menu
9d66ef2c-7425-4451-ae3f-c35850c0a8b5	slow
9d66ef2c-7800-4068-8210-6e83e78a66be	App\\Models\\ItemLoans
9d66ef2e-4a61-4523-a8d5-076a59d69ee4	App\\Models\\Menu
9d66ef41-8c31-4c11-8115-e74dcddc06d9	App\\Models\\ItemLoans
9d66ef43-2515-49d2-9202-c60379525981	App\\Models\\Menu
9d66f01e-3fed-4f24-abac-2ac54b6ce4ac	slow
9d66f01e-4056-4852-94aa-5052d6a5ec55	App\\Models\\Menu
9d66f032-6277-43a4-b4b1-22f41de52933	slow
9d66f032-66ef-4857-84d4-ce976766b730	App\\Models\\ItemLoans
9d66f05c-c1c0-42fb-aa1f-123a7179edb7	App\\Models\\ItemLoans
9d66f0a6-47b0-4b2c-a43e-3a4b5125be20	App\\Models\\ItemLoans
9d66f0a8-7d3b-4f0e-9559-4b94546eb971	App\\Models\\Menu
9d66f0d2-66d1-436a-8c35-acd8e06360bc	slow
9d66f0d2-6be8-4223-8f00-676981caa132	App\\Models\\ItemLoans
9d66f0d3-f46d-416f-bb77-32bc11be6205	App\\Models\\Menu
9d66f0e3-451d-4def-8cb6-5f75e0206f46	slow
9d66f0e3-488c-424c-99d5-1288c4289140	App\\Models\\ItemLoans
9d66f0e5-42da-4145-83cd-0039cbb6c629	App\\Models\\Menu
9d66f106-6ef4-43f1-8dab-a3ad9bc8db0a	slow
9d66f106-736b-4f69-a9fa-cdb992a60875	App\\Models\\ItemLoans
9d66f108-2259-44d4-8232-97b8e4f88045	slow
9d66f108-22f2-4011-8f2a-1604603f585b	App\\Models\\Menu
9d66f115-2a65-4ec4-8144-209424a427a4	App\\Models\\ItemLoans
9d66f117-02a9-4a8f-a950-d975ff7d3bfb	App\\Models\\Menu
9d66f128-0a59-4c3a-9775-885309a7619e	App\\Models\\ItemLoans
9d66f129-987b-4753-9579-caa56600fade	App\\Models\\Menu
9d66f148-f477-404e-8a22-d5d6d5e72d17	App\\Models\\ItemLoans
9d66f14a-e194-44ef-a2c1-51706b43c311	slow
9d66f14a-e240-4a45-86e2-146cd6dba0e8	App\\Models\\Menu
9d66f177-b365-418c-817c-f5fd99ed326a	App\\Models\\ItemLoans
9d66f179-2a45-4853-a49d-d86f6e174258	App\\Models\\Menu
9d66f1a7-c66e-491d-a0db-beb7ef880c61	App\\Models\\ItemLoans
9d66f1a9-7b13-4faf-a933-fc80a2632f0d	App\\Models\\Menu
9d66f1c4-01fa-40d0-9991-2ca1e16ccbc0	slow
9d66f1c4-05fc-49c2-9f54-0ba8fc04f165	App\\Models\\ItemLoans
9d66f1c5-7498-455e-82cd-cc0d16c42be4	App\\Models\\Menu
9d66f1d6-9d06-4c8c-b3d7-4e0111b93778	App\\Models\\ItemLoans
9d66f1d8-5ec3-4377-bdcb-ada0db4cb4d6	App\\Models\\Menu
9d66f21a-b774-4c40-b956-4a5293e37114	App\\Models\\ItemLoans
9d66f21c-a1a6-4d67-bf21-3071cd86dcf1	App\\Models\\Menu
9d66f2ee-9a43-451c-9bbd-a6b2ac2d556a	App\\Models\\ItemLoans
9d66f2f1-3ac6-4e86-baf5-7a34a807febb	slow
9d66f2f1-3b47-491a-a298-e9c043fcf9aa	App\\Models\\Menu
9d66f32a-eb08-428a-b3c1-d56512f78066	slow
9d66f32a-ef87-46b6-99c8-fbfb3ad52088	App\\Models\\ItemLoans
9d66f32d-4506-4742-89c1-9eb4e4dcf979	App\\Models\\Menu
9d66f3f8-438e-4cc3-935a-235064b99469	slow
9d66f3f8-47cf-4b6c-a99a-d31a61e3642d	App\\Models\\ItemLoans
9d66f3fa-f38d-4a62-9413-cb5d4b5edeaa	slow
9d66f3fa-f422-4f71-99a9-017123b95cfe	App\\Models\\Menu
9d66f421-4667-44db-b993-2c220421fddb	slow
9d66f421-4a06-4ef0-934e-713d76ccd928	App\\Models\\ItemLoans
9d66f423-07f7-4750-83c2-bb2eac01d3e5	App\\Models\\Menu
9d66f440-b11d-4734-a652-63775d00bd86	slow
9d66f440-b4c9-40f9-9533-9b89eb4f06a2	App\\Models\\ItemLoans
9d66f442-9d6d-473f-bb43-cb61587b6b9a	App\\Models\\Menu
9d66f454-af12-496f-baf6-a3de0ff29be0	App\\Models\\ItemLoans
9d66f456-8149-4dad-9529-612f31873826	slow
9d66f456-81a5-4c1b-b251-ce0c41e7c557	App\\Models\\Menu
9d66f473-faae-483f-84e9-2ed45046c838	slow
9d66f473-fe6b-4219-b8c0-0db84afa0c45	App\\Models\\ItemLoans
9d66f475-fa6c-4b01-b151-ec356887e88a	App\\Models\\Menu
9d68a02d-281a-45a7-adc2-03d59a4e7e8c	App\\Models\\ItemLoans
9d68a04a-188a-451d-8641-e774763c8f2f	App\\Models\\ItemLoans
9d66f574-ff0f-49bb-8eb9-7b436d37a947	App\\Models\\ItemLoans
9d68a05e-44e5-48ec-909b-b16bfcf22f2c	App\\Models\\ItemLoans
9d68a05e-46c4-45b7-bb10-2e4fd02af846	App\\Models\\Loans
9d66f581-5c08-4b5f-8012-c28e5a10e8a6	App\\Models\\ItemLoans
9d68a05e-48b6-4083-9cf9-c10022274256	App\\Models\\ItemLoans:224
9d68a05e-49c2-481a-8575-5e5cf8fe43a3	App\\Models\\Loans:66
9d66f588-c8ef-4623-bfd8-379f8910347c	slow
9d66f588-ccb2-4ca8-b966-56138f5ecfcd	App\\Models\\ItemLoans
9d66f77a-eef7-4457-a1c0-5cab9eb3b7aa	App\\Models\\ItemLoans
9d66f77a-f0f9-4f0f-8108-d8b6db7f04a6	App\\Models\\Loans
9d66f77a-f563-438d-a4c3-52b929cc6fdd	App\\Models\\ItemLoans:185
9d66f77a-f647-408d-900d-56f79ddb4c2c	App\\Models\\Loans:61
9d66f77b-695d-431e-810a-d6418b34e9bc	App\\Models\\ItemLoans
9d66f7a0-0541-479d-9c62-f5c50de5c8a8	App\\Models\\ItemLoans
9d66f7a2-2e68-4fa9-8923-9cc52370f4bc	App\\Models\\Menu
9d69c224-3d13-47cf-b4ed-b273988d8759	App\\Models\\User
9d69c2e1-9c56-4763-8ab6-01b8fa6dad8a	slow
9d66f84f-76d7-4afe-8311-685735dbc8a0	slow
9d66f84f-7b41-40a0-9e01-be76363ad62b	App\\Models\\ItemLoans
9d66f8a6-dbf4-4c6b-b899-ed8b21cba694	App\\Models\\ItemLoans
9d66f8a9-487f-48f0-9044-887af63e87a1	App\\Models\\Menu
9d69c2e1-9cf1-434d-af7f-5f93b92191ac	App\\Models\\User
9d68a55b-6c51-495d-b31d-88bc061c5f9c	App\\Models\\Menu
9d66f8c3-cdd8-423b-a0e9-881b03ddab12	App\\Models\\ItemLoans
9d66f942-5f12-484f-96c8-d851917e3cd5	slow
9d66f942-633a-44a9-8de4-ca184a8d2217	App\\Models\\ItemLoans
9d66f944-c008-41ab-a70a-76d443ec46b2	App\\Models\\Menu
9d68a7d6-0c72-47a3-8167-b092f8423192	slow
9d68a7d6-106e-45a3-a6d4-4aefc215ad97	App\\Models\\ItemLoans
9d66f94c-b231-4209-ae8c-166361ca8aa7	App\\Models\\ItemLoans
9d66f99c-3b4b-4928-828a-84c4c7ed3a2a	slow
9d66f99c-3f04-4414-842d-9b1ad976a27a	App\\Models\\ItemLoans
9d66f99e-1b3e-4b78-8a94-c4df14b2e1bc	App\\Models\\Menu
9d66fae1-40fd-4a22-b73b-67e4631a9ab2	App\\Models\\ItemLoans
9d66fae3-bd97-49db-a794-bb4194f39e5a	App\\Models\\Menu
9d69c2f4-6679-4c63-a17d-74f902f2984a	App\\Models\\User
9d66fba1-aed2-48b4-8ec5-4ebe80f1c047	App\\Models\\ItemLoans
9d66fba4-3eec-4955-ad54-d25b117f26c5	slow
9d66fba4-3f36-46cb-916b-0008c5b04809	App\\Models\\Menu
9d68a03f-b274-4554-bbe0-d4265f00cae1	App\\Models\\ItemLoans
9d68a03f-b42b-443f-84bb-d4dd4d6bb06f	App\\Models\\Loans
9d66fbbe-8084-4fd8-9fcd-76f1f1072431	App\\Models\\ItemLoans
9d66fbca-234b-4e01-95ef-35330219b439	App\\Models\\ItemLoans
9d66fbcc-1ccc-4718-a176-c074f61f025e	slow
9d66fbcc-1d55-4439-ab05-59313ddec56c	App\\Models\\Menu
9d66fbe4-309d-4d96-b838-55801e602b10	App\\Models\\ItemLoans
9d66fbe6-5bb4-44ab-b2d3-8ff3b300b32d	slow
9d66fbe6-5c3a-45af-b0ac-82008110422a	App\\Models\\Menu
9d66fbf3-96ac-49f6-a37b-a0b8747a1945	App\\Models\\ItemLoans
9d66fbf3-9860-4a1f-a579-bd46c8431279	App\\Models\\Loans
9d66fbf3-9cc8-4658-abce-c678aa23e704	App\\Models\\ItemLoans:186
9d66fbf3-9d9a-41f7-b408-5b20068d5676	App\\Models\\Loans:61
9d66fbf3-f9dd-41d8-a65c-f6fcc3d14275	App\\Models\\ItemLoans
9d66fc1e-fd5e-431c-b5a8-b6dd8214e09b	App\\Models\\User
9d66fc1f-8516-4eb8-9c3e-b6d7a6e5e4ce	slow
9d66fc1f-85a3-4c75-9d63-7cc53887ec59	App\\Models\\User
9d66fc28-1c36-473b-a714-66df2c90fc57	slow
9d66fc28-a964-4ff3-ba8a-2bc92baa8830	slow
9d66fc31-18fd-4169-8e11-241015a0219e	slow
9d66fc33-d1e3-4550-9a8d-7a78f6eb1937	slow
9d66fc35-27bc-4701-9423-6db5f12de32a	slow
9d66fc37-1002-4742-8bdc-e302d2fda9ec	slow
9d66fc3c-4c7a-428d-bd4c-e9985daa8aeb	slow
9d66fc3c-4cce-4427-8606-984ccca0f1ce	App\\Models\\User
9d66fc8a-b286-41d9-95c3-2ca0b6117838	App\\Models\\Loans:63
9d66fc8a-b832-4bcc-a5e3-24fe585e2e7c	App\\Models\\ItemLoans:
9d66fc8a-b8f5-482f-b3dd-b137acbe39d3	App\\Models\\ItemLoans:
9d66fc8a-b9ab-4e73-9654-a535f606deb7	App\\Models\\ItemLoans:
9d66fc8a-ba6a-495f-b06b-cc5ebe74752d	App\\Models\\ItemLoans:
9d66fc8a-bb14-4fa7-afd9-a00206e6dca3	App\\Models\\ItemLoans:
9d66fca9-b464-4f3f-8858-20f07d89b793	slow
9d66fcac-3eb8-4014-bf91-30a78a5d9533	App\\Models\\Menu
9d66fd8e-362e-4382-ab45-094dd1b5c37a	App\\Models\\Menu
9d66fdc1-43fa-4518-bd1e-b489951f6f4e	App\\Models\\Menu
9d66fe36-087a-41aa-8741-5cc8c129a1da	slow
9d66fe36-08e1-47e5-bdfe-48c5f46a0460	App\\Models\\User
9d66fe36-6b69-48cc-a43c-1c214f7c9d8e	App\\Models\\User
9d66fe40-7a65-4cd1-849d-5782b796d07f	App\\Models\\User
9d66fe85-f23a-4645-ada0-95fd3b221899	App\\Models\\Loans:64
9d66fe85-f3de-4e8d-a1b1-7ef13d24fd47	App\\Models\\ItemLoans:
9d66fe85-f4bc-4c38-b76a-aafa6413ba9c	App\\Models\\ItemLoans:
9d66fe85-f5b2-4a14-89a0-f96a61750b80	App\\Models\\ItemLoans:
9d66fe85-f6ab-4b66-9811-e9b79e51c7f4	App\\Models\\ItemLoans:
9d66fe85-f7ab-4ee2-bb72-9792becab861	App\\Models\\ItemLoans:
9d66fe85-f8bf-48e4-bd0a-ccf32c7675fa	App\\Models\\ItemLoans:
9d66fe85-f9c5-4d83-9784-aa00ae01fda6	App\\Models\\ItemLoans:
9d66fe85-fb1c-4f39-9480-85883dd52250	App\\Models\\ItemLoans:
9d66fe85-fbd5-4191-bc2e-a1318a469e22	App\\Models\\ItemLoans:
9d66fe85-fc7e-48b0-8ee5-769aadbf3d9b	App\\Models\\ItemLoans:
9d66ff53-1774-4d36-bda7-c568124ea2c6	App\\Models\\Menu
9d66ff58-b567-44ca-84f8-fbb3919632c0	slow
9d66ff58-b93b-41db-859d-3276c8159158	App\\Models\\ItemLoans
9d67006e-86b4-4987-8fea-c278cd1db432	slow
9d670070-4ff1-4d35-a521-54cee27e3db4	App\\Models\\User
9d670070-c245-4e53-9ded-548195969e53	App\\Models\\User
9d670075-ad9e-4cab-9d1e-eb39bf8abae5	slow
9d670076-826e-4ebd-89b9-d957a49788b9	slow
9d67007c-cc93-4535-bd89-290356203243	App\\Models\\User
9d6700b0-a445-40ec-8234-573bfb35aca6	App\\Models\\Loans:65
9d6700b0-a5e1-4c04-9530-6d7727ab06b4	App\\Models\\ItemLoans:
9d6700b0-a662-48f5-a0de-c20480a2a2e9	App\\Models\\ItemLoans:
9d6700b0-a6da-4079-82f9-7bd98bb77b23	App\\Models\\ItemLoans:
9d6700b0-a753-401b-a492-3107bed2fdd2	App\\Models\\ItemLoans:
9d6700b0-a7ce-4e19-8067-6c753353f683	App\\Models\\ItemLoans:
9d6700b0-a844-4fc3-a592-c8bb644cf5d3	App\\Models\\ItemLoans:
9d6700b0-a8b4-4e84-9a88-3c1f35264499	App\\Models\\ItemLoans:
9d6700b0-a91f-46f1-b921-30027403d3f8	App\\Models\\ItemLoans:
9d6700b0-a989-4c8b-94fa-556029f3f73e	App\\Models\\ItemLoans:
9d6700b0-a9f4-4e94-962b-c3a95a679100	App\\Models\\ItemLoans:
9d6700b4-2a0c-4730-9507-96b89a1cdd7d	slow
9d671a30-1de3-4669-afbc-2d9b47457861	slow
9d671a30-1e5d-4f9f-9d09-3ff609919836	App\\Models\\Menu
9d673414-bfc0-47d2-b720-5a5d87824b49	slow
9d67341c-46a0-4500-bf82-1ea36289bd81	slow
9d67341c-471c-4fe5-bfa2-7b2f5dcbdf9d	App\\Models\\Menu
9d6734b1-1a13-42f1-944a-59d7feeec120	App\\Models\\ItemLoans
9d6734bb-212a-4b6c-ae42-885a5b667e05	App\\Models\\ItemLoans
9d6734bb-2c14-492b-abdf-a0eab17e020a	App\\Models\\Loans
9d6734bb-36ae-4ef5-b344-e5c03b9564c2	App\\Models\\ItemLoans:197
9d6734bb-37f6-47b4-833f-c99f80ea43d8	App\\Models\\Loans:64
9d6734bb-c103-4c07-8d24-9c040e4c064d	slow
9d6734bb-c4da-4cfd-a701-de4ae7d97171	App\\Models\\ItemLoans
9d6734d2-5c2a-410a-b778-982b29352eee	App\\Models\\ItemLoans
9d673578-240a-498d-89a1-f3c2c104ec72	App\\Models\\ItemLoans
9d673578-26a4-42a1-992e-e0f6f366aa5c	App\\Models\\Loans
9d673578-291b-4702-8b5d-8c6bf8b9264c	App\\Models\\ItemLoans:207
9d673578-2a31-4351-8f17-a4b1e67aeeae	App\\Models\\Loans:65
9d673578-bb06-4377-a638-6c8092edf94a	App\\Models\\ItemLoans
9d67359e-e303-4fba-8647-8183cd16ced4	App\\Models\\ItemLoans
9d67359e-e4b4-4701-aed2-4028aac777fb	App\\Models\\Loans
9d67359e-e8b5-423c-ab95-6575e4127993	App\\Models\\ItemLoans:208
9d67359e-e986-4739-9c49-ab41f5287d57	App\\Models\\Loans:65
9d67359f-4b40-4c48-9e9c-a5e0bb830d55	App\\Models\\ItemLoans
9d68a03f-b6c7-409e-8f76-87ed7a20d740	App\\Models\\ItemLoans:217
9d68a03f-b815-4ece-87a5-623a5ab123b2	App\\Models\\Loans:66
9d6735f9-2ac8-47a6-8901-741b1a1606b7	slow
9d6735f9-314d-47ed-81d6-7dadefa68fa2	App\\Models\\ItemLoans
9d673687-8400-47d2-8d19-ed77d2ced154	slow
9d673687-8938-410b-97d9-70382efea80d	App\\Models\\ItemLoans
9d67368a-3650-486e-bb32-a05ac79f17cc	App\\Models\\Menu
9d6736b1-4706-4351-a422-f1f67415d366	App\\Models\\ItemLoans
9d6736b2-c9a4-46ec-bd8f-2ae2625625aa	App\\Models\\Menu
9d6736f3-0e8a-46d6-aee9-9d3c54615787	slow
9d6736f3-131f-4b6e-93d3-29f10d39cd5d	App\\Models\\ItemLoans
9d6736f5-7b5b-48b7-8e19-006d9860e26d	App\\Models\\Menu
9d68a04d-d178-413d-9890-182b88ec3ad7	App\\Models\\ItemLoans
9d68a04d-d339-4ac2-bc95-fde158647a9d	App\\Models\\Loans
9d673716-abb6-42c1-9814-ccb1b4ce11c6	slow
9d673716-af9f-47ac-b56f-520a875447e3	App\\Models\\ItemLoans
9d673724-638a-40ca-810b-b5f04fb273d8	App\\Models\\ItemLoans
9d673726-69f7-4a33-8b28-b4d2bad025ef	slow
9d673726-6a53-443e-9f75-b43098c735fc	App\\Models\\Menu
9d68a04d-d4f6-47c4-976f-04d5d386a1b0	App\\Models\\ItemLoans:221
9d68a04d-d5c5-45c1-b5b9-f393a0100b28	App\\Models\\Loans:66
9d67372d-d966-4845-835d-920efd43b5ef	slow
9d67372d-df66-481b-bbfa-d9f97e6a4d6b	App\\Models\\ItemLoans
9d67378e-38f8-4e8e-92ef-da8c3cbe65fe	App\\Models\\ItemLoans
9d67378f-4b02-4fb6-b92f-63c1dac7168e	App\\Models\\ItemLoans
9d673791-bfab-4c8a-a739-3055d8d9b8b1	App\\Models\\Menu
9d67379f-424f-47c8-a3a1-1b6cc6dedee4	App\\Models\\ItemLoans
9d67379f-4406-4071-be29-338610207e5b	App\\Models\\Loans
9d67379f-4834-4999-9e7e-7afc999713fd	App\\Models\\ItemLoans:207
9d67379f-490f-4ded-86e7-9c20f49b2875	App\\Models\\Loans:65
9d67379f-aef4-4341-a5fd-050010010c55	App\\Models\\ItemLoans
9d6737fa-2b80-4665-af62-80ddac080c18	App\\Models\\ItemLoans
9d6737fc-9916-4c72-aa6e-96b1eec62382	slow
9d6737fc-99ab-4328-80c9-f0c54acd0715	App\\Models\\Menu
9d68a040-246e-453e-a196-5393a0da5078	App\\Models\\ItemLoans
9d68a04e-374e-4863-87b7-6f15c199e7bf	App\\Models\\ItemLoans
9d67380a-98cd-43a6-9181-1dad4921e218	App\\Models\\ItemLoans
9d68a05e-ad64-4b82-9c11-032b35a18ac7	App\\Models\\ItemLoans
9d69c224-de04-44fe-a4b7-d5ab99918341	slow
9d673882-666d-438f-a869-f473e123b607	App\\Models\\ItemLoans
9d673917-2530-41c5-81f1-46178f458879	App\\Models\\ItemLoans
9d673917-27a0-408b-9d76-e7cf5cd0877b	App\\Models\\Loans
9d673917-2be2-4109-bdeb-edfb58aa670c	App\\Models\\ItemLoans:207
9d673917-2d17-49cb-9b75-f08586245b62	App\\Models\\Loans:65
9d673917-e839-48e0-b0c1-e4825721be08	slow
9d673917-eced-47b7-9258-27ebc249bbf9	App\\Models\\ItemLoans
9d67399d-86fc-4ddf-bfb8-9830862bfe3e	App\\Models\\ItemLoans
9d67399f-b0f7-4d23-b8ea-0026d68133e0	App\\Models\\Menu
9d6739bf-4111-4239-8d1a-d9262f2ba8ed	App\\Models\\ItemLoans
9d69c224-de71-430e-b7aa-9e7777d28d8d	App\\Models\\User
9d69c2e2-3884-42ef-b15e-ee4044fe55bf	App\\Models\\User
9d6739ca-d705-4af6-bea7-a7f680c7b362	App\\Models\\ItemLoans
9d673a13-38aa-4514-95fe-e45e0514965c	App\\Models\\ItemLoans
9d673a13-3b4a-4878-a588-ad7c31d65a17	App\\Models\\Loans
9d673a13-3d63-41eb-9fbc-1e4f74f2ffb8	App\\Models\\ItemLoans:207
9d673a13-3e64-4d3f-8132-7744f5c74593	App\\Models\\Loans:65
9d673a13-cb1e-4f1c-a601-b5fc54c12274	App\\Models\\ItemLoans
9d673a43-0aaf-4fde-8540-717f19cc6c11	App\\Models\\ItemLoans
9d673a4d-58b3-45d9-be75-5b4f07c03513	App\\Models\\ItemLoans
9d673a4d-5a5f-475e-8f98-5f93bcc89e81	App\\Models\\Loans
9d673a4d-5c04-41c2-bcd0-e5567535b754	App\\Models\\ItemLoans:192
9d673a4d-5ce2-419d-b718-9134b8b7d803	App\\Models\\Loans:63
9d673a4d-bac5-43b4-b325-ed5f3d2c74df	App\\Models\\ItemLoans
9d673a5b-fad7-4f1d-bc30-5cab41f96000	slow
9d673add-db12-4436-8156-0f5134a72e61	App\\Models\\User
9d673ade-3603-4574-9983-73eb2bfef021	App\\Models\\User
9d673aea-fa25-40b3-b849-5c1fc0185afb	slow
9d673aeb-8046-456f-a0e9-0f2fcee0fc44	slow
9d673aee-bcf8-4b26-acc6-161c11037cad	slow
9d673aee-bd41-4b86-85ed-5fb89eef25b4	App\\Models\\User
9d673b33-f807-43fe-80d6-69b2430c0dc2	App\\Models\\Loans:66
9d673b33-f9f9-47ee-92ea-904e877b623f	App\\Models\\ItemLoans:
9d673b33-fa93-4bd6-93e4-f6b28ce5c939	App\\Models\\ItemLoans:
9d673b33-fb22-49c5-9b0d-6b860267cf44	App\\Models\\ItemLoans:
9d673b33-fbc3-45be-ac71-2a260febbce6	App\\Models\\ItemLoans:
9d673b33-fc58-4b1f-babf-9dd3b31ecf3c	App\\Models\\ItemLoans:
9d673b33-fcff-4c6e-94e8-957b5b72e773	App\\Models\\ItemLoans:
9d673b33-fd97-4976-90f9-dd48adadbf4a	App\\Models\\ItemLoans:
9d673b33-fe2c-4f7a-b04a-1479af5b6460	App\\Models\\ItemLoans:
9d673b33-fed3-4664-a551-4d2d94d68a9d	App\\Models\\ItemLoans:
9d673b33-ff6b-451f-84b3-ae92e5adc9fd	App\\Models\\ItemLoans:
9d673ba9-d9e9-4096-ad3e-25e521b41d78	App\\Models\\Menu
9d673bed-0869-426a-afbd-b45ed0d460f1	App\\Models\\Menu
9d673c0f-8d49-4fd0-bcdd-277c39e783c7	App\\Models\\Menu
9d673c14-a70f-4025-ad59-d563352fda2e	App\\Models\\User
9d673c15-0332-4556-a50c-88ea884d3029	App\\Models\\User
9d673c1a-f442-4f2e-8dc1-a5df3cf0fe5f	slow
9d673c1e-c6e2-40af-acff-203056b91ff4	slow
9d673c22-c246-4152-906a-02227734b084	App\\Models\\User
9d673c5c-04d7-40fb-acfc-1dceb3894fc4	slow
9d673cb0-c016-44f4-80ce-a2f3054990b5	slow
9d673cb0-c067-4dff-8c1e-30f515a2f25d	App\\Models\\User
9d673cb1-21d8-4d1e-b771-1e82dda6bb34	App\\Models\\User
9d673cb5-e850-409a-b989-3a70ada19c43	slow
9d673cb7-c4c6-4927-ac52-0d8ac9d64797	slow
9d673cb8-51bc-4ec4-a240-f7b4f214ff7f	slow
9d673cb9-de19-48d5-9c4e-5e40355bab7d	App\\Models\\User
9d673db3-d7f2-4868-a944-daa5b92c364c	App\\Models\\User
9d673db4-4c48-42ef-a61d-0aab69fbb05a	App\\Models\\User
9d673db5-6ed2-46af-8b47-04fa8267f423	slow
9d673db5-6f38-4dcf-a735-b5fbb82ee9c7	App\\Models\\User
9d673db5-d4f2-43fd-8a28-cbc84941e607	App\\Models\\User
9d673db8-995b-4841-a9ec-985fb1ce57d4	slow
9d673db8-99b8-4a87-81cd-e2de15486f9f	App\\Models\\Menu
9d673dbe-66f0-4749-bc23-383ffd3043ef	slow
9d673dbf-d843-4bad-8c62-923995bc7d5c	App\\Models\\User
9d673e09-6225-4b16-a8e8-d5368515fa80	App\\Models\\User
9d673e0a-08c4-4a01-82ae-d6e601fa4dac	slow
9d673e0a-0925-470b-99a0-0d56c823ec09	App\\Models\\User
9d673e0c-70b8-4c7c-a003-e3549dafb47a	App\\Models\\Menu
9d673e28-29df-487a-87eb-35911bcfea9f	App\\Models\\User
9d673e28-8710-4c76-aa13-2c55fd8e18b5	App\\Models\\User
9d673e2a-8839-4c8b-ae9e-516e027afdc4	slow
9d673e2a-8897-4850-b8ef-2841254ed669	App\\Models\\Menu
9d673efc-d563-4bb3-bd7f-4dfbd902e8d6	slow
9d673efd-6158-44ff-9396-9e8c1573cf87	slow
9d673eff-5f92-48fc-a93b-7e16afc83d22	slow
9d673f00-4711-49ee-853f-654082c17689	slow
9d673f01-808e-461d-8629-5a5b78d50299	slow
9d673f05-4725-402a-8605-8a3d966c9aea	App\\Models\\User
9d69c2f4-f914-4876-a227-12291a1250d9	slow
9d67403a-0c9f-4437-8d0d-1bac51ca736f	App\\Models\\Loans:68
9d67403a-0eb7-4d87-9116-e3de16d65f79	App\\Models\\ItemLoans:
9d67403a-0f6c-4b7a-870e-5c05ef5d3dae	App\\Models\\ItemLoans:
9d67403a-1022-4cbf-95b9-e09821c365e4	App\\Models\\ItemLoans:
9d67403a-10e1-4339-b2a9-747ac652ace6	App\\Models\\ItemLoans:
9d67403a-119e-4151-ab4f-b1630af90bef	App\\Models\\ItemLoans:
9d67403a-125b-48c1-ac6b-d1fc3c4d4d72	App\\Models\\ItemLoans:
9d67403a-12fb-4cc2-9bd1-93242298561f	App\\Models\\ItemLoans:
9d67403a-139f-4d20-9fdc-acf3ee225962	App\\Models\\ItemLoans:
9d67403a-1440-47fd-a649-f539f7f4f422	App\\Models\\ItemLoans:
9d67403a-14e1-4a35-8e72-586ca05b879a	App\\Models\\ItemLoans:
9d674041-8134-42a1-baf8-3d46db0f5b0a	App\\Models\\Menu
9d674051-cb9d-4180-81c7-db1849dda9b2	App\\Models\\ItemLoans
9d674092-3b61-4189-9a82-50ff29b537ea	App\\Models\\ItemLoans
9d674092-3e31-43d6-b223-3b14dc0e0b33	App\\Models\\Loans
9d674092-42ca-4e23-a889-9e2fb28b40e8	App\\Models\\ItemLoans:227
9d674092-43e0-41c8-82cd-ad17b20e71c0	App\\Models\\Loans:68
9d674092-ba76-4e2c-8c0a-762475600cc9	App\\Models\\ItemLoans
9d6740ce-14b5-414c-bf3d-6fc630884e3d	App\\Models\\ItemLoans
9d674108-88e5-4fde-9a87-20404e24fd67	App\\Models\\User
9d674108-ea87-4786-9dd6-e366c9f546f5	App\\Models\\User
9d67410a-afbf-437f-af70-d1b547bb0023	App\\Models\\ItemLoans
9d67410c-41da-4a57-af48-bb569bce169a	slow
9d67410c-4263-428d-8601-c84f5a075d20	App\\Models\\Menu
9d67410c-f976-4eb1-9537-466efcdb4f30	App\\Models\\Menu
9d674149-10af-4b69-8e77-418a6b291fbd	slow
9d674149-110f-4f29-a88b-cd4f51919d6b	App\\Models\\User
9d674149-8339-4078-ad6e-f609b77d6fa7	App\\Models\\User
9d67414b-37d1-43fb-9363-82894298e543	App\\Models\\ItemLoans
9d67414c-9a59-4ea3-b904-b4a170b4622e	slow
9d67414c-9b01-4629-825e-f434c949a122	App\\Models\\Menu
9d67414d-6e4c-44d2-b596-f4fbb2d2e586	App\\Models\\Menu
9d674166-bf99-4f25-94c1-8819af357835	App\\Models\\User
9d674167-21ee-4489-9fff-04967230e6ba	App\\Models\\User
9d674168-a0d9-4483-a0a4-ee0d20fb6f5d	App\\Models\\ItemLoans
9d674169-dbcf-476d-a0a2-07b63970f55e	App\\Models\\Menu
9d67416a-b9a4-4b8c-b6d0-f340c83e2de6	App\\Models\\Menu
9d674171-a694-48d0-9a17-fb5edcc332a1	slow
9d674171-a6ff-42a5-863c-55dda83dfbd1	App\\Models\\User
9d674172-5c23-4c30-843d-3667fda75426	slow
9d674172-5cb8-4079-ae69-3b8e7cf291ba	App\\Models\\User
9d69c2f4-f971-460f-9fb3-81b5845ba265	App\\Models\\User
9d674174-1209-40d1-ad95-384835e3ce5f	App\\Models\\ItemLoans
9d674175-100d-47b6-96da-9d86ca10ccaf	slow
9d674175-10a3-47a7-ae65-bc17561f5ae1	App\\Models\\Menu
9d674175-f7b8-4e52-94f7-c5f026b95b7a	App\\Models\\Menu
9d674182-a886-4a14-855a-02f3225ca503	App\\Models\\User
9d674183-2bd7-49fb-a969-75d3100b6677	slow
9d674183-2c2c-4adc-960e-11c09d1bbc11	App\\Models\\User
9d674184-b1f5-4b5c-b29e-903f18beb73e	App\\Models\\ItemLoans
9d674186-0317-4c3a-8b02-22306c7d159d	App\\Models\\Menu
9d674186-cdd7-44a1-9cff-6293748993f1	App\\Models\\Menu
9d674252-2ae4-4e78-96ff-f0364c30c673	slow
9d674252-2b50-4eab-96e9-e6ce7826eb50	App\\Models\\User
9d674252-cd58-46c5-93ce-b58e6f3296bc	slow
9d674252-cda5-4839-9cce-09b298d2ab63	App\\Models\\User
9d674255-1f83-4591-acb7-2128e7d71df6	App\\Models\\ItemLoans
9d674256-594e-43a3-9b27-a06698ee8476	slow
9d674256-59d2-4d05-8be4-c7f23833ed15	App\\Models\\Menu
9d674257-84b1-4d08-8184-8999d40fdde1	slow
9d674257-855c-4109-980b-097a73960840	App\\Models\\Menu
9d674259-a58b-407b-be34-deba8db29dc4	App\\Models\\User
9d67425a-2b19-487b-9df3-b1489542108b	slow
9d67425a-2b69-44f5-866d-f0e9055ccf5f	App\\Models\\User
9d67425b-cdc3-4f7d-b0b8-924f4906f94c	slow
9d67425b-d3f4-4fcf-8635-7d6390507ab1	App\\Models\\ItemLoans
9d67425c-f5db-4271-a6b0-4c8090fb82f2	slow
9d67425c-f666-4e1c-8404-fea119333c21	App\\Models\\Menu
9d67425d-d2db-4d34-bd9e-f01c84225c6a	slow
9d67425d-d32b-400f-bd4f-ae760a9146ba	App\\Models\\Menu
9d674278-0ae2-4b05-9572-34ce6d78843e	slow
9d674278-0b51-4e36-b35c-83148c06d7f3	App\\Models\\User
9d674278-9102-4428-b46c-4d605b3153a9	slow
9d674278-9152-4620-b769-658c948a3370	App\\Models\\User
9d67427a-4536-4a3f-85c6-ad01246b6696	slow
9d67427a-4bac-470d-bfc0-3cb8cff185e9	App\\Models\\ItemLoans
9d67427b-758b-4ef9-be0d-a375f3f5103a	slow
9d67427b-7635-4de1-a575-150d03b0bb58	App\\Models\\Menu
9d67427c-5047-476d-a937-e15d0999b2cb	App\\Models\\Menu
9d67439a-ef0b-4dae-9d82-d709cdb16ca4	App\\Models\\User
9d67439b-643b-439b-868d-454e37d4e051	App\\Models\\User
9d67439d-583d-4c57-9c02-b251ebab3ac6	App\\Models\\ItemLoans
9d67439e-60ee-4ccc-bbb5-be3c0f38444c	slow
9d67439e-619d-4074-851f-27c74ef55728	App\\Models\\Menu
9d67439f-846b-4c70-9564-713cd3175823	App\\Models\\Menu
9d6743a3-3110-47b9-94b3-a64c72607978	App\\Models\\User
9d6743a3-8b7e-4efb-9caa-52918a842516	App\\Models\\User
9d6743a5-4f52-4d0b-b32a-98c7af989dc7	slow
9d6743a5-5782-4a0f-85e3-9a2ae2a5f171	App\\Models\\ItemLoans
9d6743a6-b9b0-40fa-a031-cd4efd82d12c	slow
9d6743a6-ba4a-41c9-b406-8d6d5b169569	App\\Models\\Menu
9d6743a7-7830-403d-b274-677df3c60eb7	slow
9d6743a7-788b-4833-883f-56b9bb20576a	App\\Models\\Menu
9d674859-2b68-4c1e-b864-837808a02911	App\\Models\\User
9d674859-ed2c-4d27-bdf7-fa15db726c46	slow
9d674859-edb9-4508-a46f-7dd1835b0e38	App\\Models\\User
9d67485b-9134-4dd3-b4ba-bb496cd06627	App\\Models\\ItemLoans
9d67485d-05ff-429f-9081-5c81b68c43ad	slow
9d67485d-069c-4b2e-9d03-8d9263443897	App\\Models\\Menu
9d67485e-1222-4eae-aad6-844f505433b0	slow
9d67485e-12b9-42dc-b918-478ce3310cea	App\\Models\\Menu
9d674879-0fd1-4f59-85c8-2d2722d5356a	App\\Models\\Loans
9d674a73-ce63-494a-9a60-237e2a76599e	slow
9d674a73-ced0-4709-8861-a02f75f00053	App\\Models\\User
9d674a74-72c2-413f-95d5-8a027d0b997a	slow
9d674a74-7314-44e2-b80d-8284eefdbfa8	App\\Models\\User
9d674a76-6ec4-4f9e-8b5d-4740443fd8d8	slow
9d674a76-7418-4e28-9750-3648a38f3e00	App\\Models\\ItemLoans
9d674a78-4663-4d94-9d71-0db9b08623f3	slow
9d674a78-472a-40c4-b04e-daa64b7f891c	App\\Models\\Menu
9d674a79-3950-4408-b38f-8c888ba33ee5	App\\Models\\Menu
9d674a89-614e-4140-af08-e0abf45afd94	App\\Models\\User
9d674a89-cb39-41a4-b235-fdd3a952751d	App\\Models\\User
9d674a8b-8233-4228-90b4-847f4d2863d2	App\\Models\\ItemLoans
9d674a8c-7e84-4f52-b925-4da5a78ed5bf	slow
9d674a8c-7f3b-4976-b1e5-6e2dd1a75aba	App\\Models\\Menu
9d674a8d-91ac-4d35-9359-a2438cb0d869	App\\Models\\Menu
9d674b9d-8cb0-47ef-8a5c-7d27a0067498	App\\Models\\Loans
9d674c0c-ee66-4a2f-b404-d31f1b060101	App\\Models\\Loans
9d674c2e-9509-44d3-884c-ee5479d68fd4	slow
9d674c2e-9553-4c9f-b737-d739c79869ce	App\\Models\\Loans
9d674daa-b64e-4bdc-91a4-c239e437ceac	App\\Models\\Loans
9d674e97-c36d-4520-b216-7ea00eb9bec8	App\\Models\\Loans
9d674eba-1f45-492d-93f6-aac46b01a5fe	slow
9d674eba-1f94-44a2-ad0d-5b7c86aaae58	App\\Models\\Loans
9d674ec9-9821-4912-ae8b-30e15ae3d83c	slow
9d674ec9-9869-4e9d-8406-c012ad5ecc4c	App\\Models\\Loans
9d674ef3-4b25-4070-a33c-2e28224727a7	App\\Models\\Loans
9d674f11-0b28-43f5-bb3f-d64d8cb9402d	App\\Models\\User
9d674f11-8389-44d4-aeae-0ba23a05c361	App\\Models\\User
9d674f13-2768-45f0-b80e-be53bba8301c	App\\Models\\ItemLoans
9d674f14-5400-4278-9784-6d6f496ebe53	App\\Models\\Menu
9d674f15-a806-4f62-9374-69357cd91a08	App\\Models\\Menu
9d674f22-4bc4-4c96-b0dc-9968a9130b3b	App\\Models\\Loans
9d674f33-41ec-4f22-8139-a11e5d4ad40a	App\\Models\\Loans
9d674f56-811a-4e81-8b00-016d926bda8a	App\\Models\\User
9d674f56-e71a-42d8-9671-3fd806e5217a	App\\Models\\User
9d674f58-8d66-4ab0-91d3-e0976251dfff	slow
9d674f58-96d3-4e15-b64a-6207d343ac4c	App\\Models\\ItemLoans
9d674f59-f9fd-415a-a1c2-5f4cd0546371	slow
9d674f59-faab-4b79-b586-b0f65cfd2471	App\\Models\\Menu
9d674f5b-1b59-43b4-b434-de9d644e99c7	App\\Models\\Menu
9d674f6a-b02a-4406-b7aa-653296c3493f	App\\Models\\Loans
9d674fcd-fd05-45df-b8d3-d69abe0da520	App\\Models\\User
9d674fce-a252-44f7-9f36-8e58a0f17a1e	slow
9d674fce-a2b1-403a-a040-cbc84710ebbd	App\\Models\\User
9d674fd0-a691-4815-8051-9ea1c0b9a993	slow
9d674fd0-ade7-4783-a77c-38370203c428	App\\Models\\ItemLoans
9d674fd2-fae3-43a6-9ce8-b9e3199681c4	slow
9d674fd2-fb7c-41c6-acbb-42b498f57f97	App\\Models\\Menu
9d674fd3-dd2b-4699-ba7c-227446972763	slow
9d674fd3-dd85-4bcc-bb19-8cce0edfdfd7	App\\Models\\Menu
9d67539e-d0c7-46f4-bceb-ddbab6648e79	App\\Models\\Loans
9d6756d3-a286-43e0-b6b1-cd733d44e2a4	App\\Models\\Loans
9d6759df-df67-4720-9ec1-4dc193a35a5a	App\\Models\\Loans
9d675d14-3ea9-4275-8966-f8caac2bf4c7	slow
9d675d14-3fe5-466c-abd8-5ae494a6fd3f	App\\Models\\Loans
9d675da5-376f-4d3d-b0a6-536ded7af52a	slow
9d675dd4-d6fd-4115-8753-91645a8cf451	slow
9d675ddc-d658-4a9a-ae4f-eec845292e91	App\\Models\\ItemLoans
9d67e3d2-6b1d-4c17-8541-a1fa3131953c	App\\Models\\ItemLoans
9d67e3d4-a00b-4ccb-9047-6fc1d1da4b29	App\\Models\\User
9d67e3d5-7a37-4420-9a2f-d50a95e100f6	App\\Models\\User
9d67e3d6-8782-461e-b1fe-36cf5d2a9d93	App\\Models\\Menu
9d67e3d7-8837-4f17-b20c-bd2c46891bde	slow
9d67e3d7-88f4-41b7-bc6a-0bdaa5696bed	App\\Models\\Menu
9d67f73b-0440-4f5b-83de-646d9b4c0418	slow
9d67f73b-0496-4644-a0dc-c19f29857f40	App\\Models\\User
9d67f73c-9ca8-4fa6-939a-c1005b9316b2	slow
9d67f73c-9d16-4e74-b61d-9f62b717ee7e	App\\Models\\User
9d67f73d-9801-4d95-90fe-acd7c9cc3d1a	slow
9d67f73d-9861-44d8-950d-7644494c2977	App\\Models\\User
9d67f73e-055a-4e67-976e-d9a6a2105403	App\\Models\\User
9d67f740-384b-4486-b8f5-3c577849f910	App\\Models\\ItemLoans
9d67f741-c370-42f3-b209-c7b5a8b3f70e	App\\Models\\ItemLoans
9d67f742-f0e4-4196-84b3-487a1826896b	slow
9d67f742-f16f-431e-92d5-65800dafa540	App\\Models\\Menu
9d67f743-c5f8-4b89-8396-4e3bb5c46b86	App\\Models\\Menu
9d67f8a4-4448-45a3-b4d4-83409b514771	slow
9d67f8a4-48bb-459b-9d5a-0dbe6dae817e	App\\Models\\ItemLoans
9d67f8a6-753d-458b-a734-305f16400d3f	App\\Models\\Menu
9d67f8b2-1b6c-4d19-a331-9790ad8b37ec	App\\Models\\ItemLoans
9d67f8b2-1d41-4263-891c-111ff46b51e8	App\\Models\\Loans
9d67f8b2-2f5a-4434-a9a1-9754ea50433c	App\\Models\\ItemLoans:208
9d67f8b2-3047-4315-8428-75558cd9037f	App\\Models\\Loans:65
9d67f8b2-befc-4b77-b585-021aa79b16f6	slow
9d67f8b2-c2b2-444b-9742-7ead30c48036	App\\Models\\ItemLoans
9d67f8c2-bd5f-4edc-9f04-b7b2bf79837b	App\\Models\\ItemLoans
9d67f8c2-bf2d-4c38-aec4-8da48280a30f	App\\Models\\Loans
9d67f8c2-c0ec-4228-b3e0-4dd424d60e48	App\\Models\\ItemLoans:209
9d67f8c2-c1cd-4e51-b6b5-6a67bc237509	App\\Models\\Loans:65
9d67f8c3-291d-4545-a2ad-e450b3accf7d	App\\Models\\ItemLoans
9d67f9d4-fc69-47b2-b69b-9eff8bf1bf24	App\\Models\\Loans
9d67f9d4-fdfe-4646-b4ce-c02e6b4cbb2c	App\\Models\\Loans:65
9d67f9d4-ff93-44d1-8750-856e326db896	App\\Models\\ItemLoans
9d67f9d5-002e-4ba4-8c3f-a66d049aa9ee	App\\Models\\ItemLoans:210
9d67f9d5-0246-4ba1-b501-8a31b1b7472e	App\\Models\\ItemLoans:
9d67f9d5-02c1-4c43-9a6b-e9deb4acb901	App\\Models\\ItemLoans:
9d67f9d5-033e-434f-b6bc-c920b9b50a65	App\\Models\\ItemLoans:
9d67f9d5-03b9-4b53-91d9-523416d8dc93	App\\Models\\ItemLoans:
9d67f9d5-042d-4d6e-889d-84da025b558c	App\\Models\\ItemLoans:
9d67f9d5-04ae-47f2-aa77-2d5937eb5a87	App\\Models\\ItemLoans:
9d67f9e8-ad47-408b-9db2-38a2bff54721	slow
9d67f9e8-b125-4b40-96cc-2073fbf0b1d7	App\\Models\\ItemLoans
9d67f9ea-a419-4781-810c-038a4259209e	App\\Models\\Menu
9d68a043-1048-402e-a4b4-de099dc6b8e1	App\\Models\\ItemLoans
9d68a043-12bf-4baa-b872-59dc272b4cec	App\\Models\\Loans
9d68a043-1494-49f2-8ac8-1a4df7f4a1cc	App\\Models\\ItemLoans:218
9d68a043-1562-429a-ad56-08df1d5726c4	App\\Models\\Loans:66
9d68a052-5987-4232-bee6-b28ff5f1e658	App\\Models\\ItemLoans
9d68a052-5b3a-4d6c-b079-4bdd017d52ae	App\\Models\\Loans
9d68a052-5cf8-488e-8a84-a5896bd9ff2d	App\\Models\\ItemLoans:222
9d68a052-5dcb-4267-b9fc-ee8ab91c3799	App\\Models\\Loans:66
9d67fbb6-4271-4172-8925-a744780333ab	slow
9d67fbb6-4696-402b-b964-8b956a3a139e	App\\Models\\ItemLoans
9d67fbb8-5b72-497f-a74e-1255d6514dbd	slow
9d67fbb8-5bca-4b7c-afb0-47e5e32d7aff	App\\Models\\Menu
9d67fbd1-5bfc-407e-88a0-e397726f1aeb	slow
9d67fbd1-e63b-4121-99fc-23c4e637bb65	slow
9d67fbd5-e5a2-42a3-ae8b-e010cdd0d12a	slow
9d67fbd9-9263-4310-b4f2-60e1352854f5	slow
9d67fbd9-92ae-4d89-af42-beaa023fd636	App\\Models\\User
9d67fbfe-c890-49ce-901d-f23e7a5ee042	App\\Models\\Loans:69
9d67fbfe-ca25-43cd-9e2c-1957e320f666	App\\Models\\ItemLoans:
9d67fbfe-caba-4995-9d9b-365cdaa8fc0e	App\\Models\\ItemLoans:
9d67fbfe-cb42-49ba-86b3-46a47008c878	App\\Models\\ItemLoans:
9d67fbfe-cbc3-4a95-9b2d-e83cbed0a6e1	App\\Models\\ItemLoans:
9d67fbfe-cc3e-4172-bd42-7652fb106fa1	App\\Models\\ItemLoans:
9d67fcf9-e0d3-4792-ac3a-0a84932f11cb	App\\Models\\Loans:70
9d67fcf9-e2f2-4370-a307-6e6f2edf4ec7	App\\Models\\ItemLoans:
9d67fcf9-e3b0-4ba5-af84-55a73efcf5dc	App\\Models\\ItemLoans:
9d67fcf9-e462-48d9-8dbc-9afa7e6dac64	App\\Models\\ItemLoans:
9d67fcf9-e51b-4c88-b31e-2d8ce6ae646c	App\\Models\\ItemLoans:
9d67fcf9-e5d6-49ec-a47e-67b6122afd2b	App\\Models\\ItemLoans:
9d67fd26-8b74-4ae9-852b-e811af39394d	slow
9d67fd2a-056e-468d-81b1-a867de299d54	slow
9d67fd2a-09a4-4333-8ae1-3e5261ad7fdb	App\\Models\\ItemLoans
9d67fd3a-91d7-4d4e-b0bb-acb6b88fa0ea	App\\Models\\ItemLoans
9d67fd3a-9383-4a6f-9d9c-a378659ab91b	App\\Models\\Loans
9d67fd3a-97a0-4078-983a-afd0cd7be2b8	App\\Models\\ItemLoans:248
9d67fd3a-9869-4fd2-8f9f-94649bff9d13	App\\Models\\Loans:70
9d67fd3a-fb9d-44d9-a38e-c81fb4645d10	App\\Models\\ItemLoans
9d68a064-004e-4f8f-858b-a022c4bc92e4	App\\Models\\ItemLoans
9d68a064-023e-4279-a20c-b08db0d83474	App\\Models\\Loans
9d68a064-03e5-4940-b1d9-7a5612d137b9	App\\Models\\ItemLoans:225
9d68a064-04b2-4b2f-9f3b-b48bfc4bcb6a	App\\Models\\Loans:66
9d67fd92-6eca-4ce3-91c8-51178893cf38	App\\Models\\ItemLoans
9d67fd94-5ff9-4946-a06f-3bff10fe95cc	App\\Models\\Menu
9d68a146-92c7-4ea5-93c8-60fbb68e9837	App\\Models\\Loans
9d68a146-9556-40c1-8dfc-ec5e17b24ae9	App\\Models\\Loans:66
9d68a146-9613-47c7-ae7b-1ff4571c7967	App\\Models\\ItemLoans
9d68a146-96a5-4119-8507-08da415ba640	App\\Models\\ItemLoans:226
9d68a55f-d811-464e-8607-44d7d89b344c	App\\Models\\ItemLoans
9d68a7d8-2978-4706-9c68-25f7d0d4312d	App\\Models\\Menu
9d68a8e8-862f-4122-b882-1ee640efe9cb	slow
9d68a8e8-8695-47cc-a2e8-13e973b42b3b	App\\Models\\Menu
9d68ab45-4c90-4604-adc9-f87b474d2ce4	App\\Models\\Menu
9d68b1d9-3329-4807-b2a7-6b097123273f	slow
9d68b201-f2ff-4b21-b84b-5e8eed8deb92	App\\Models\\User
9d68b224-893c-44da-ada8-bc4553177cbc	App\\Models\\Loans:73
9d68b224-8ba8-4c87-9a82-c751ade1eb36	App\\Models\\ItemLoans:
9d68b224-8c89-40dc-9f97-c7fc67ad0a83	App\\Models\\ItemLoans:
9d68b224-8d62-47a1-9284-6d6fecb29202	App\\Models\\ItemLoans:
9d68b224-8e19-4354-9c29-ca94249df6ec	App\\Models\\ItemLoans:
9d68005d-42fa-4646-bd68-c37b75cb4fc8	slow
9d68005d-46b1-4689-94e0-1bff23f93dcb	App\\Models\\ItemLoans
9d68005f-3c04-4708-b1d3-0ed7c8c9c40e	App\\Models\\Menu
9d68b224-8edb-4f3e-8099-c905dc2bae20	App\\Models\\ItemLoans:
9d68b227-ea9a-40f8-9ef6-8aebde46abac	App\\Models\\Loans:76
9d68b227-ec9f-45bc-be47-23d81c3618d4	App\\Models\\ItemLoans:
9d68b227-ed2c-4556-b5ad-9f4d8a10452e	App\\Models\\ItemLoans:
9d680128-a714-4a41-a5dc-d7648792ff9e	slow
9d680128-ae0a-4250-b46c-4c6bed8412e7	App\\Models\\ItemLoans
9d68012a-9653-42e2-97a9-b186974ae203	App\\Models\\User
9d68012b-f13a-4e07-945b-8c8e7af37f54	slow
9d68012b-f1b6-4b7c-9c4c-7d778640a171	App\\Models\\User
9d68012d-19fc-47c6-9c74-8dee5dee2984	App\\Models\\ItemLoans
9d68012f-955f-4460-8d24-f9d061437cd1	slow
9d68012f-95ee-494c-b438-2e8e53c5a70d	App\\Models\\Menu
9d6886bb-426e-41d0-8c2e-804e58fc49b3	App\\Models\\ItemLoans
9d6886c0-c0b6-454e-b369-dda663323cfa	App\\Models\\Menu
9d68b227-ede7-48b8-8d23-11cc84923756	App\\Models\\ItemLoans:
9d68b227-eeab-4f23-92bb-6f68da050da6	App\\Models\\ItemLoans:
9d68b227-ef8c-49db-ae84-80661d994947	App\\Models\\ItemLoans:
9d68b22c-d492-43f1-9db7-88a99d1b1eb1	App\\Models\\Loans:79
9d68b22c-d682-4bd2-90b8-38f3b4e98a3a	App\\Models\\ItemLoans:
9d68b22c-d734-4903-b6dc-c97051a8bcb1	App\\Models\\ItemLoans:
9d68b22c-d7cd-4fef-8184-348be19b855a	App\\Models\\ItemLoans:
9d68b22c-d855-4d5b-bc39-3822f5a064a9	App\\Models\\ItemLoans:
9d68b22c-d8e9-43bb-9a5c-c44412f87c0f	App\\Models\\ItemLoans:
9d68b22f-f858-4469-8457-817ceffc5494	App\\Models\\Loans:81
9d68b22f-fa4f-4c23-bd8e-165ebd190cf5	App\\Models\\ItemLoans:
9d68b22f-fb0a-4b1d-b7e7-92fd2cb14b4b	App\\Models\\ItemLoans:
9d68b22f-fbbd-4162-873f-da1c67419a8f	App\\Models\\ItemLoans:
9d68b22f-fc76-4a14-8202-551801b2bf78	App\\Models\\ItemLoans:
9d68b22f-fd32-4ca7-9b70-b538dbdfd282	App\\Models\\ItemLoans:
9d68b231-1d0c-49c2-8e3a-6c1695b9de75	App\\Models\\Loans:83
9d68b231-1ebd-45a3-a95d-c239be26e2e5	App\\Models\\ItemLoans:
9d68b231-1f50-4b1d-b25d-09d0804a5e9c	App\\Models\\ItemLoans:
9d68b231-1fdf-46ab-a2c0-e8ef58aa3f10	App\\Models\\ItemLoans:
9d68b231-2080-47f3-aaf5-25e29060226a	App\\Models\\ItemLoans:
9d68b231-2108-4bb3-85c8-66eac4f44c81	App\\Models\\ItemLoans:
9d68b231-e423-4c7d-9b5c-00fd4f09f060	App\\Models\\Loans:85
9d68a043-8982-4861-8c09-697f8fb6dc69	App\\Models\\ItemLoans
9d68a052-bf06-4376-b9e5-aca021bc212b	App\\Models\\ItemLoans
9d68a064-6a05-4ee0-87f3-b341a695aed8	App\\Models\\ItemLoans
9d68a153-b619-4db7-ab80-e6d97fc25b5c	App\\Models\\ItemLoans
9d68a766-6e59-4279-bb6f-0701c21a543c	App\\Models\\ItemLoans
9d68a8e5-286c-42db-b54b-3683052e227a	slow
9d68a8e5-2c32-4f98-ab69-433c70d9df42	App\\Models\\ItemLoans
9d68ab42-04ce-4276-bd58-bd4f27a2a5af	App\\Models\\User
9d68b1d0-b1f3-4e27-99b2-65b6ce76f29a	slow
9d688d14-82b9-4bd1-9b2e-91b0de77c126	App\\Models\\ItemLoans
9d688d16-f8fd-4553-816d-03cf8277be67	slow
9d688d16-f97d-4cc4-952e-da6a6653364f	App\\Models\\Menu
9d688d26-36b3-4096-b7b3-fb7595600c66	App\\Models\\Loans
9d688d26-3853-4d21-815d-0182b545c842	App\\Models\\Loans:70
9d688d26-3a02-467c-b1e1-b21f583880d2	App\\Models\\ItemLoans
9d688d26-3aac-4516-bf0d-606e1ceb90b2	App\\Models\\ItemLoans:249
9d688d26-3d73-43f8-bc98-8fa149ddd315	App\\Models\\ItemLoans:
9d688d26-3e37-4a93-aaf6-5ab2c4722fc7	App\\Models\\ItemLoans:
9d688d26-3ef7-4932-b387-f09b18a91422	App\\Models\\ItemLoans:
9d688d33-cb8b-410a-9c8c-f8f47479a307	App\\Models\\ItemLoans
9d688d35-ba53-45cb-a1e9-abcf74685f90	slow
9d688d35-baa9-4226-b980-4b7139bc16ad	App\\Models\\Menu
9d688e54-28bd-4988-974d-4941ee2fe457	App\\Models\\Loans
9d688e54-2ab8-46bb-886f-7725e09edb4a	App\\Models\\Loans:70
9d688e54-2c95-430d-b4ff-b6c60e3bee16	App\\Models\\ItemLoans
9d688e54-2d79-4fe4-88ec-e8538c18917a	App\\Models\\ItemLoans:253
9d688e54-305b-4201-b518-9e156a305c84	App\\Models\\ItemLoans:
9d688e54-311a-4776-a414-a8462808bb9c	App\\Models\\ItemLoans:
9d688e58-a91f-4fd7-86f6-c04d662127d7	App\\Models\\ItemLoans
9d688e5a-8885-4cd9-a800-bae19e7508d5	App\\Models\\Menu
9d68b1de-25c2-4a8c-a50d-ed3a0ea205f2	App\\Models\\ItemLoans
9d689089-79e2-4f9d-b9ac-e75101d2a552	slow
9d689089-7ef4-4a9d-b08e-5fb57cd2584b	App\\Models\\ItemLoans
9d689282-449f-4a7f-b1c1-54c792cd6653	App\\Models\\Loans
9d689282-4745-43ef-975f-e43601366d4e	App\\Models\\Loans:70
9d689282-4920-42c9-bad3-a5f18caa848c	App\\Models\\ItemLoans
9d689282-4a03-4811-b3cb-421f9d4d44fe	App\\Models\\ItemLoans:256
9d689282-4d1d-41eb-9b12-722c287357b0	App\\Models\\ItemLoans:
9d6892c3-f979-4970-be72-0ffafcc60607	slow
9d6892c3-ff25-4d43-b1ba-039628e57708	App\\Models\\ItemLoans
9d6892c6-60da-4d0d-a155-f98f8a0c6267	App\\Models\\Menu
9d689459-4712-4fdc-a3c2-fd30824763a2	App\\Models\\ItemLoans
9d68945b-ceb5-4a47-bc29-cbd057278954	slow
9d68945b-cf1c-43b8-bbd4-4badd72990f2	App\\Models\\Menu
9d689473-a0d7-4ad7-8b03-8e176b662bdf	App\\Models\\Loans
9d689473-a248-4605-9beb-fdd2fe62d612	App\\Models\\Loans:70
9d689473-a3a6-4366-9eb3-06981ba59286	App\\Models\\ItemLoans
9d689473-a45c-4ebd-9c74-9e2468dae062	App\\Models\\ItemLoans:258
9d68951b-dc6a-4bff-8548-3c2dbcaaca9d	slow
9d68951b-e0bc-4f05-950d-1bbb3c268c14	App\\Models\\ItemLoans
9d68b21e-9d19-472d-b914-046d8a596ef8	App\\Models\\Loans:71
9d68b21e-9ee6-4b8f-bb9d-ff67c6219dc3	App\\Models\\ItemLoans:
9d68b21e-9f76-4863-9ea1-2d235ab73484	App\\Models\\ItemLoans:
9d68b21e-a000-4287-823f-55c589360e3e	App\\Models\\ItemLoans:
9d6895eb-3c1a-400b-8558-1fc6e765b7d9	App\\Models\\ItemLoans
9d6895ed-4f31-43f2-b9db-a817e29c0757	slow
9d6895ed-4fa8-4f59-bc0e-8233fb0ced2e	App\\Models\\Menu
9d6895fc-9dde-4868-af8e-bf126c1d7f06	App\\Models\\ItemLoans
9d6895fe-6366-45e6-a709-635ef51575a6	App\\Models\\Menu
9d68b21e-a08a-46ac-9d54-50c18fe684c4	App\\Models\\ItemLoans:
9d68b21e-a113-450a-94fb-25a984d033c8	App\\Models\\ItemLoans:
9d68b225-f3cc-4110-9f5c-802653e718e4	App\\Models\\Loans:74
9d68b225-f53b-4e3c-a643-c0eaea6dda51	App\\Models\\ItemLoans:
9d6896b9-7dc3-4eb3-9709-b5ad5e8cc80e	App\\Models\\ItemLoans
9d6896b9-7fdb-4668-a3da-f8d78c8d4708	App\\Models\\Loans
9d6896b9-8419-4463-83f7-a74f34773651	App\\Models\\ItemLoans:243
9d6896b9-8518-42a4-a9cb-020a3922399b	App\\Models\\Loans:69
9d6896ba-1f48-4dd8-b9c4-343bc93dee59	App\\Models\\ItemLoans
9d6896c1-4a40-4e55-a43a-8b402595a668	App\\Models\\ItemLoans
9d6896c1-4c13-45dd-a832-43367f41a7e5	App\\Models\\Loans
9d6896c1-502a-4572-a086-220932362531	App\\Models\\ItemLoans:244
9d6896c1-511c-4f46-a02c-1c38c32e8494	App\\Models\\Loans:69
9d6896c1-ddc2-4df2-a2d2-43b2ac04e630	slow
9d6896c1-e19e-454b-b64f-1fc63b46f4ae	App\\Models\\ItemLoans
9d68971e-f4d4-4cfc-9d2b-654cf286c06b	App\\Models\\ItemLoans
9d68971e-f78d-4ca9-8480-002d14179479	App\\Models\\Loans
9d68971e-fbc3-43e3-a829-eab016d40743	App\\Models\\ItemLoans:245
9d68971e-fd32-43c0-97a1-e83bac81e7f2	App\\Models\\Loans:69
9d68971f-b5d8-4f12-b436-09d3c1ccb83b	slow
9d68971f-bab9-476f-a731-fe56955b01b2	App\\Models\\ItemLoans
9d689727-2765-4a14-8d13-c1ce75e30747	App\\Models\\ItemLoans
9d689727-2900-45d0-babe-d503b8bd4a77	App\\Models\\Loans
9d689727-2ae2-423f-be43-3cee08a8d48f	App\\Models\\ItemLoans:246
9d689727-2bb2-4d06-86e2-e2584bfe8315	App\\Models\\Loans:69
9d689727-b08a-4951-96cc-515995013cb7	slow
9d689727-b433-4ae0-ae06-bc9f470d1f04	App\\Models\\ItemLoans
9d68b225-f5c2-41f0-bfc4-0738df9ade0e	App\\Models\\ItemLoans:
9d68b225-f640-4bd3-bad3-c35ebc40eae4	App\\Models\\ItemLoans:
9d68b225-f6c0-4d15-8e63-8a32d5e24b39	App\\Models\\ItemLoans:
9d68b225-f758-4089-9a8b-15d1574957da	App\\Models\\ItemLoans:
9d68b22a-29ae-48eb-b10e-64de6c07ea1a	App\\Models\\Loans:77
9d68b22a-2bae-4984-8d14-2f4035e1e36c	App\\Models\\ItemLoans:
9d68b22a-2c49-4996-88e6-c389673c3609	App\\Models\\ItemLoans:
9d68b22a-2ce1-4352-8cc2-36fc3a13ed70	App\\Models\\ItemLoans:
9d689785-9d68-4f93-9790-f4fd6cf1ccd8	slow
9d689785-a159-44a9-901c-751819b58ca6	App\\Models\\ItemLoans
9d689787-941b-4d66-9fbf-dbcb46863dc0	App\\Models\\Menu
9d68b22a-2d5b-4bc2-8813-5cc6532656bd	App\\Models\\ItemLoans:
9d68b22a-2dd1-4d97-bd33-1f78fd6cba0b	App\\Models\\ItemLoans:
9d68b22e-b822-432e-ac63-423ab51e0617	App\\Models\\Loans:80
9d68b22e-b9b2-42ba-90d1-d5fb6ff617d1	App\\Models\\ItemLoans:
9d689a35-1733-4948-9a63-b66fa0b81368	App\\Models\\ItemLoans
9d689a37-5f92-4320-bd3d-38fdc5263fb1	slow
9d689a37-5fee-4efb-a94e-f5ceaeffb78e	App\\Models\\Menu
9d689a4b-508e-4805-aa5a-aa1b5da2c04d	App\\Models\\Loans
9d689a4b-5310-40d2-809a-7510749a3dd8	App\\Models\\Loans:69
9d689a4b-53ba-4018-b7b9-2c174b2274e7	App\\Models\\ItemLoans
9d689a4b-5459-4abe-b4fe-163d098b5707	App\\Models\\ItemLoans:247
9d689a4b-5622-486f-9fb4-6a227837c6fa	App\\Models\\ItemLoans:
9d689aa1-256d-4c35-ad78-262425e9afe4	App\\Models\\ItemLoans
9d689aa3-2b58-432b-aec2-735a8a1faf04	App\\Models\\Menu
9d689abb-22a5-41e0-a25d-e2fd7a774918	slow
9d689abb-2671-4d56-8729-762911d12ce7	App\\Models\\ItemLoans
9d68b22e-ba56-49f0-8eaa-ae1b4ada2d19	App\\Models\\ItemLoans:
9d68b22e-badf-4c43-a73f-98cf8099b71d	App\\Models\\ItemLoans:
9d689b4e-674c-4671-9177-1167ce82e907	App\\Models\\ItemLoans
9d689b53-57e0-4a9c-ab31-0d13659d5460	App\\Models\\ItemLoans
9d689b53-59cb-4659-b48c-409eb8471032	App\\Models\\Loans
9d689b53-5b64-4362-bc9c-f145661ccb82	App\\Models\\ItemLoans:228
9d689b53-5c3b-4446-bbc1-4dd2c296cf04	App\\Models\\Loans:68
9d689b53-c2d7-404e-b636-2e4fd3546996	App\\Models\\ItemLoans
9d689b57-d79d-48c0-9e2b-b79568e48af5	App\\Models\\ItemLoans
9d68b22e-bb65-4205-a24f-bca7f3e927e9	App\\Models\\ItemLoans:
9d689b57-d95a-4bce-963d-80c59a4ca82f	App\\Models\\Loans
9d689b57-ddab-47d8-a87f-a2ac248d9bfd	App\\Models\\ItemLoans:229
9d689b57-de84-4a78-ae44-970eb1bd111e	App\\Models\\Loans:68
9d689b58-40ab-4999-ace4-006f5832a15c	App\\Models\\ItemLoans
9d689b61-2066-458b-a496-c1cd661fb0d8	App\\Models\\ItemLoans
9d689b61-2222-46d4-8703-edebadaa0b51	App\\Models\\Loans
9d689b61-23a2-496f-bc8a-d21d9213cb50	App\\Models\\ItemLoans:230
9d689b61-2478-4916-aafd-c282487ac393	App\\Models\\Loans:68
9d689b61-d226-419c-8feb-5d74c030be2f	slow
9d689b61-d666-4bd7-976a-4afa9f45573d	App\\Models\\ItemLoans
9d68a046-431d-4327-a5b6-2fdd10505866	App\\Models\\ItemLoans
9d689b7b-983b-43f6-a1ff-0f05381bf155	App\\Models\\ItemLoans
9d689b7d-7904-4f08-83e6-875dc8491376	App\\Models\\Menu
9d689b92-0444-48c9-bb23-4782b6c255b7	App\\Models\\ItemLoans
9d689b92-0620-46a6-8b1d-589da3810983	App\\Models\\Loans
9d689b92-0a4a-4d64-a29f-a40947d5d1f4	App\\Models\\ItemLoans:231
9d689b92-0b36-4f75-817a-bc39c6ca6682	App\\Models\\Loans:68
9d689b92-7755-477e-8821-21811d5efbbf	App\\Models\\ItemLoans
9d689b96-ea03-4319-a258-f9d3a21b5cbf	App\\Models\\ItemLoans
9d689b96-ec37-41d6-ac04-9bfaeb86e7a9	App\\Models\\Loans
9d689b96-f0aa-4987-95a9-e90bc0ba9acf	App\\Models\\ItemLoans:232
9d689b96-f19e-4b06-a4e8-12d2579880da	App\\Models\\Loans:68
9d689b97-603c-410e-a879-d9a14af21431	App\\Models\\ItemLoans
9d689b9c-667c-4918-b898-f09a0c0181db	App\\Models\\ItemLoans
9d689b9c-684d-483a-b3ce-755bf5957f8b	App\\Models\\Loans
9d689b9c-6c4c-4660-99ac-d406de415ee6	App\\Models\\ItemLoans:233
9d689b9c-6d36-4f29-a75f-d3e5281496f8	App\\Models\\Loans:68
9d689b9c-f841-4158-bd29-ee6a08f1f562	slow
9d689b9c-fc59-4f7c-827c-35f4f6d4f906	App\\Models\\ItemLoans
9d689ba0-d987-4538-9b0c-9654127c4c54	App\\Models\\ItemLoans
9d689ba0-dbc9-42f6-be03-80f8b888f45e	App\\Models\\Loans
9d689ba0-dff6-4966-b47c-402816673145	App\\Models\\ItemLoans:234
9d689ba0-e0f5-489d-943b-fab06731550e	App\\Models\\Loans:68
9d689ba1-4360-4b77-b17c-87fe378f645d	App\\Models\\ItemLoans
9d689ba5-dada-4d40-b088-64d4dbc9bc67	App\\Models\\ItemLoans
9d689ba5-dce9-4632-9d21-de4c946827c6	App\\Models\\Loans
9d689ba5-deeb-48ee-84e4-32fb2fffa98b	App\\Models\\ItemLoans:235
9d689ba5-e035-45e5-8fa7-562b4444ac3b	App\\Models\\Loans:68
9d689ba6-5414-49ce-925f-9cb553241466	App\\Models\\ItemLoans
9d68a046-452f-4bb0-afc9-8022a9826563	App\\Models\\Loans
9d68a046-49c8-4d0f-a8b9-96953c8cfb2a	App\\Models\\ItemLoans:219
9d68a046-4abc-4ac3-b449-2efd0ad3ceb8	App\\Models\\Loans:66
9d68a056-d783-403a-a530-c05f79cb68ed	App\\Models\\ItemLoans
9d68a056-d921-454c-92e2-3a79c78afc6d	App\\Models\\Loans
9d68a056-dd6b-4f87-931b-51253d33ae0a	App\\Models\\ItemLoans:223
9d689d5c-5cc0-4ce6-8d1a-09e0bd3f1660	App\\Models\\Loans
9d689d5c-600e-4de0-aa39-be1384d5cbac	App\\Models\\Loans:68
9d689d5c-60d7-4043-9f53-bdb45f590f58	App\\Models\\ItemLoans
9d689d5c-61a2-45d7-a9a4-1250b05c21d3	App\\Models\\ItemLoans:236
9d689d5c-63c8-4ff8-af69-5e622c727905	App\\Models\\ItemLoans:
9d68a056-de50-486b-847f-457afa818ed2	App\\Models\\Loans:66
9d69c225-4685-4034-824a-ca6b9581703c	App\\Models\\User
9d68a155-e5ab-44e7-95ab-5b2be86a59d7	slow
9d68a155-e608-446c-981a-e7e3a2ef46b5	App\\Models\\Menu
9d68a768-d6ae-4528-9778-feafb14f5232	slow
9d68a768-d70d-4f12-9793-67c0c47dec84	App\\Models\\Menu
9d68a8e6-21b8-49a9-89c1-681aeef8e259	slow
9d68a8e6-254e-48b5-b344-9cc556381bbf	App\\Models\\ItemLoans
9d68ab42-a677-47b9-86d9-46811a57411d	slow
9d68ab42-a6e3-4862-a23d-e8843adf1d55	App\\Models\\User
9d68b1d4-79e0-4e11-9dd4-c7bcb583c9b5	App\\Models\\ItemLoans
9d68b1fe-3ec8-4e8f-8f34-576681bd8ad5	slow
9d68b222-b865-4b2e-a7c4-2cf116d44ff9	App\\Models\\Loans:72
9d68b222-ba06-4123-9211-962d3742dd4e	App\\Models\\ItemLoans:
9d68b222-baaf-4630-be0e-d7665cadd8a4	App\\Models\\ItemLoans:
9d68b222-bb3a-4f43-ba72-e5e601c9e328	App\\Models\\ItemLoans:
9d68b222-bbe4-4142-b59e-12ec6424de9c	App\\Models\\ItemLoans:
9d68b222-bc8a-44e9-b7b0-620355d0da0b	App\\Models\\ItemLoans:
9d68b227-2763-47cb-be03-3e43c7d8aa0a	App\\Models\\Loans:75
9d68b227-28fd-4d90-83e6-208c008cc0e9	App\\Models\\ItemLoans:
9d68b227-29b3-4222-beef-767aebbe3ed1	App\\Models\\ItemLoans:
9d68b227-2aad-46bc-afe1-7f6210e5b0a8	App\\Models\\ItemLoans:
9d68b227-2b78-40c5-91d3-de43bc9673d0	App\\Models\\ItemLoans:
9d68b227-2c1f-4d4b-967d-63e1d439c42e	App\\Models\\ItemLoans:
9d68b22b-7d3e-4c56-97a5-07448e3ca318	App\\Models\\Loans:78
9d68b22b-7f5b-4ddb-8f62-bff90a3414ca	App\\Models\\ItemLoans:
9d68b22b-800e-4810-b33d-c131e7f96e6e	App\\Models\\ItemLoans:
9d68b22b-80cb-40ba-8cb2-675d91d28745	App\\Models\\ItemLoans:
9d68b22b-8197-47c1-acb0-6889e535d680	App\\Models\\ItemLoans:
9d68b22b-8258-4fad-81f2-bf4c84a79bb9	App\\Models\\ItemLoans:
9d68b22e-bbf3-434c-a4c6-edebb70f296b	App\\Models\\ItemLoans:
9d68b230-ab0f-4572-bb6b-1859a4448d6b	App\\Models\\Loans:82
9d68b230-acc4-4b5b-baa0-dedb381103a3	App\\Models\\ItemLoans:
9d68b230-ad4c-46e7-a488-6a1edca3acea	App\\Models\\ItemLoans:
9d68b230-adc4-4353-a71c-d21630fec988	App\\Models\\ItemLoans:
9d68b230-ae48-4189-87ed-1a9c3a7127d3	App\\Models\\ItemLoans:
9d68b230-aed2-4b84-a628-f0bf7ac9683e	App\\Models\\ItemLoans:
9d68b231-8263-4d44-9b73-99add949fb9e	App\\Models\\Loans:84
9d68b231-8407-4812-aef6-33be30b4b7fe	App\\Models\\ItemLoans:
9d68b231-848e-4b4d-9cad-894de9452126	App\\Models\\ItemLoans:
9d68b231-850e-4c85-b05b-24cf994d4341	App\\Models\\ItemLoans:
9d68b231-858d-45cf-a293-50104a8da910	App\\Models\\ItemLoans:
9d68b231-860c-49c6-b567-92209d079610	App\\Models\\ItemLoans:
9d68b231-e5ba-4afb-9d7a-50827aa323e0	App\\Models\\ItemLoans:
9d68b231-e671-4236-8c3d-d26154b4d643	App\\Models\\ItemLoans:
9d68b231-e711-4c28-a760-0062b184e43b	App\\Models\\ItemLoans:
9d68b231-e796-412b-9df0-ffc9e1877f71	App\\Models\\ItemLoans:
9d68b231-e81c-44ed-886a-c495aca3f3b0	App\\Models\\ItemLoans:
9d68b232-4e75-4a17-88dc-8935e6d42a65	App\\Models\\Loans:86
9d68b232-503a-4082-b3ea-302d6823c10a	App\\Models\\ItemLoans:
9d68b232-50e5-457d-8de4-05ab9bfd2043	App\\Models\\ItemLoans:
9d68b232-5195-4cf5-b3a5-c9ff9b11cad2	App\\Models\\ItemLoans:
9d68b232-523a-4d3f-b052-94dbce6d088a	App\\Models\\ItemLoans:
9d68b232-52ed-49db-862c-addd14344c3d	App\\Models\\ItemLoans:
9d68b232-dd04-467c-b92b-b6cd0b6e3b4e	App\\Models\\Loans:87
9d68b232-dea9-49f5-9621-f8adb7ed65d9	App\\Models\\ItemLoans:
9d68b232-df99-4c5f-be9a-09e468431a86	App\\Models\\ItemLoans:
9d68b232-e085-4c92-bc6e-68795bdbb197	App\\Models\\ItemLoans:
9d68b232-e114-48f1-8b0a-e5a1dc66d666	App\\Models\\ItemLoans:
9d68b232-e196-411a-a2df-d08a475c9b6a	App\\Models\\ItemLoans:
9d68b233-4b8e-4b02-ae91-16745be75bb8	App\\Models\\Loans:88
9d68b233-4d51-44e4-bfe4-f6e642d1acb1	App\\Models\\ItemLoans:
9d68b233-4e13-41bd-b05e-8cad482139aa	App\\Models\\ItemLoans:
9d68b233-4ec4-493b-891c-937a510f8e90	App\\Models\\ItemLoans:
9d68b233-4f66-42aa-b335-dc73d6afe175	App\\Models\\ItemLoans:
9d68b233-5001-4a29-859d-23ddc226497f	App\\Models\\ItemLoans:
9d68b234-26fe-4352-80cf-36aa519add67	App\\Models\\Loans:89
9d68b234-28ff-47ee-b9bc-e5c88b22e290	App\\Models\\ItemLoans:
9d68b234-29ac-4ab9-ba66-f8abb8793636	App\\Models\\ItemLoans:
9d68b234-2a33-4371-bb67-5b6d82c3dfa5	App\\Models\\ItemLoans:
9d68b234-2ab3-4196-b4e4-8e3a6f19444f	App\\Models\\ItemLoans:
9d68b234-2b34-4511-ab86-e2ba1ebbd0b9	App\\Models\\ItemLoans:
9d68b234-b45a-4cb9-8387-f14f16b3ff97	App\\Models\\Loans:90
9d68b234-b67a-47c7-b178-7574359fac33	App\\Models\\ItemLoans:
9d68b234-b741-4349-b3c5-a2f2fe120b80	App\\Models\\ItemLoans:
9d68b234-b7ff-459f-956f-f653d2ce2f65	App\\Models\\ItemLoans:
9d68b234-b904-4417-bea7-6ba9fbdbc159	App\\Models\\ItemLoans:
9d68b234-b9e3-4169-bf00-00785674b1aa	App\\Models\\ItemLoans:
9d68b243-e748-47eb-92dc-e3e8e65a3b6f	App\\Models\\ItemLoans
9d68b4a8-c4b1-4cd0-bc44-23fdbddb59b3	slow
9d68b4a8-c969-46db-b9c0-2bc486cbf9e5	App\\Models\\ItemLoans
9d68b4f0-2d80-4fba-964c-893f27472736	App\\Models\\ItemLoans
9d68b755-ec51-4cce-b302-84681c9be5b6	App\\Models\\ItemLoans
9d68b758-09d2-4e61-8db7-f6c97f5cf5ff	App\\Models\\ItemLoans
9d68b758-f625-41c6-bb6b-3618c1bfa5c1	App\\Models\\Menu
9d68b75a-0bbd-4343-aabc-eb52ff053f8e	App\\Models\\Menu
9d68b772-c1a6-414c-92ae-b03c3fa81b3c	App\\Models\\Loans
9d68b772-c46c-405d-bdd1-45647d154ea8	App\\Models\\Loans:88
9d68b772-c51c-41c8-b8d9-e1a67c668fd1	App\\Models\\ItemLoans
9d68b772-c5bb-4bcf-94c8-02f69b65f9a2	App\\Models\\ItemLoans:346
9d68b772-c78a-4775-b3c0-87ba8206016f	App\\Models\\ItemLoans:
9d68b772-c831-4424-8a34-98066434895a	App\\Models\\ItemLoans:
9d68b772-c8b7-4279-86ae-9529014ece6c	App\\Models\\ItemLoans:
9d68b772-c933-445f-97bf-ac1993e1b641	App\\Models\\ItemLoans:
9d68b772-c9ad-428d-973f-071a6e9ed8e2	App\\Models\\ItemLoans:
9d68b777-cd52-4cd3-85ee-e0455b6dac7b	App\\Models\\ItemLoans
9d68b779-f491-4836-9516-8105abe9916b	slow
9d68b779-f50a-45fe-82ce-622d95cfe9c9	App\\Models\\Menu
9d69c227-5fea-4065-8969-6ea64a2cf5b3	slow
9d69c227-603e-42f0-9513-940dd61473d6	App\\Models\\User
9d69c2e2-b30e-4dc1-8c79-d15ac0ed40b2	App\\Models\\User
9d69c2f5-8b39-474a-b100-d6c0b5e1d836	slow
9d69c2f5-8b89-4946-a924-f9e21bb22355	App\\Models\\User
9d69c3af-7087-4019-b61b-427b02b945c0	App\\Models\\User
9d69c3ed-a51b-4b80-a1dd-04a05d1cc7d3	App\\Models\\User
9d69c3f2-2498-4753-9e97-cfe4d0f08d15	slow
9d69c3f2-255a-4567-b898-9bac06a4290c	App\\Models\\Menu
9d68bb9e-c12e-4dc2-ba69-51d5ed7a4c54	App\\Models\\Loans
9d68bb9e-c2e4-4c13-9863-d6c9a84f281f	App\\Models\\Loans:88
9d68bb9e-c465-44da-996d-571de34a09ae	App\\Models\\ItemLoans
9d68bba7-742d-4148-9860-e7f6cc8f0a12	App\\Models\\ItemLoans
9d68bba9-af09-4eac-9d65-c31bbedb88cc	App\\Models\\Menu
9d69c401-3118-4875-a851-fec8452e2e43	App\\Models\\User
9d69c406-1fb4-4d1c-9f89-816b78da4c5a	App\\Models\\Menu
9d68bc34-edbe-4071-9ec6-56d8078f59cf	slow
9d68bc34-f1cc-4aa4-bf36-a2e551c085b7	App\\Models\\ItemLoans
9d68bc37-3af2-4eeb-b7df-653c6c0bac3a	App\\Models\\Menu
9d69c44c-5002-48c6-b6c1-43e023d8bf73	App\\Models\\User
9d68bd26-13b4-4a78-b341-53cdf6bd7b5f	App\\Models\\ItemLoans
9d68bd28-2f7f-4ac2-a7d1-9ffa2ab0f54a	App\\Models\\ItemLoans
9d68bd29-a22f-4610-b587-fbb512f87978	slow
9d68bd29-a2cf-4d73-a49d-daa1372c70fb	App\\Models\\Menu
9d68bd2a-fbcb-4bbb-bf44-4e38e821c141	App\\Models\\Menu
9d68bd46-538e-40f0-9803-315d5a4f8260	App\\Models\\ItemLoans
9d68bd48-4458-4baf-8be5-c0f4e9d18bac	App\\Models\\ItemLoans
9d68bd49-ec3a-45c5-b1c2-6e001741f515	App\\Models\\Menu
9d68bd4b-0241-4163-a319-6bec8a661a5d	App\\Models\\Menu
9d68bd69-c7dd-42a0-a75f-5dcdb23f8b05	App\\Models\\ItemLoans
9d68bd6b-a75f-41ee-a99c-fbfc74875eda	App\\Models\\ItemLoans
9d68bd6d-0a21-46b9-8e37-02ad9597ab4a	App\\Models\\Menu
9d68bd6e-1f10-4df2-a7bc-cef365536a88	App\\Models\\Menu
9d68bd7e-f5fb-47b4-8cc4-3958b458d199	slow
9d68bd7e-f970-4c4a-8543-aa9abf568487	App\\Models\\ItemLoans
9d68bd9d-5fb2-4616-a38e-d4e504f78b08	App\\Models\\ItemLoans
9d68bd9f-d79f-43d2-9451-17a6a686bc37	slow
9d68bd9f-dc2e-4b95-a2e5-8d97c738363a	App\\Models\\ItemLoans
9d68bda0-c7c7-4346-92fa-cfdf45d521ba	App\\Models\\Menu
9d68bda1-9e29-477f-99b9-09fb26d1253c	App\\Models\\Menu
9d68bdac-b443-4250-a272-122fc6577289	App\\Models\\ItemLoans
9d68bdac-b601-4e6a-99d9-5a49d055eac6	App\\Models\\Loans
9d68bdac-ba1d-4e05-b7d9-6f36b0093d87	App\\Models\\ItemLoans:356
9d68bdac-bafd-4561-82a6-52b1a933a8c2	App\\Models\\Loans:90
9d68bdad-4faa-4f0d-b3a4-2c475c43cd72	App\\Models\\ItemLoans
9d68bde8-d2b9-4497-8734-0b8c99729395	slow
9d68bde8-d744-4291-bf7a-d0e1fdfc0bf8	App\\Models\\ItemLoans
9d68bdeb-5f3e-451d-83bc-9d2f86318350	App\\Models\\ItemLoans
9d68bdec-577c-40be-b2aa-f786e69dffc5	App\\Models\\Menu
9d68bded-422c-4f27-bb78-427e31b0a62d	slow
9d68bded-42b8-40df-854e-96de8a7d852e	App\\Models\\Menu
9d68be7a-fb98-460c-9ead-a03e93b5ca2c	App\\Models\\ItemLoans
9d68bee1-f3ab-480c-b260-80ca8c5afa57	slow
9d68bee1-f87e-4449-a0a4-aaa06980360e	App\\Models\\ItemLoans
9d68bee3-465d-48f7-9ae4-e39d90301243	slow
9d68bee3-4a15-4bb7-bd4d-994fe4f110a3	App\\Models\\ItemLoans
9d68bee4-c824-4b3c-b07e-3e8297ede81a	App\\Models\\ItemLoans
9d68bee7-5c11-49a1-adb2-9adf9306d302	slow
9d68bee7-5fbc-4f4a-893f-daf16b4252eb	App\\Models\\ItemLoans
9d68bee8-4863-4245-9fec-e2afb1485db9	App\\Models\\Menu
9d68bee9-4126-4f6b-b06d-a1fb7c4304e1	slow
9d68bee9-41a3-4e90-98e1-38e137c889d2	App\\Models\\Menu
9d68beff-19ef-49c3-ad1b-1b0e86efe3f8	App\\Models\\ItemLoans
9d68bf00-232e-42dd-9564-173c72209cf4	App\\Models\\Menu
9d68bf01-626e-49bb-bf02-4097f188e37f	App\\Models\\Menu
9d68bf02-2d70-4be6-b402-a5ebc4aa437d	App\\Models\\ItemLoans
9d68bf66-e896-4e3c-ae8d-223bc3580bf0	App\\Models\\ItemLoans
9d68bf69-50c8-4b19-a695-15bf1fe18dcd	App\\Models\\ItemLoans
9d68bf6a-2ce0-49bd-9df7-5b0586b1f022	App\\Models\\Menu
9d68bf6b-43ab-4755-a525-216013349750	slow
9d68bf6b-4449-464e-8654-d0b92a9125cd	App\\Models\\Menu
9d68bfa6-6725-417a-9b30-20cea43011d4	slow
9d68bfa6-6b4a-4b09-8139-36efbfc91d78	App\\Models\\ItemLoans
9d68bfa9-13fc-413e-94ab-f8ea66a77d8e	App\\Models\\ItemLoans
9d68bfaa-14a0-462c-9b8d-273f75f42ce3	App\\Models\\Menu
9d68bfab-0293-445e-a5fe-8adcf52c2edf	App\\Models\\Menu
9d68bfb3-463e-4a80-8423-b8db356f2373	App\\Models\\ItemLoans
9d68bfb5-8520-4498-be53-cebd75d41a5a	App\\Models\\ItemLoans
9d68bfb6-852b-4b22-a8e7-3eb8d1831cab	App\\Models\\Menu
9d68bfb8-028c-430c-8192-19e3e24761fe	slow
9d68bfb8-032e-4b44-8738-b6d994671100	App\\Models\\Menu
9d68bfd5-d985-44ae-8b1e-021d914c3501	App\\Models\\ItemLoans
9d68bfd8-4550-4f2e-9d7d-bc539c7b16ce	App\\Models\\ItemLoans
9d68bfd9-92cd-469e-952a-9620560538cb	slow
9d68bfd9-9348-4756-bd0e-b8a2e04719c5	App\\Models\\Menu
9d68bfda-f3ec-41db-9a5e-7c4664e721e0	slow
9d68bfda-f477-477a-844e-6e69a0ce81e2	App\\Models\\Menu
9d68bfed-e1d5-47b5-ba27-144d979dec44	App\\Models\\ItemLoans
9d68bff0-086f-4b3c-93ec-12ea45c858c4	App\\Models\\ItemLoans
9d68bff0-e9ff-4698-82d8-65d6cc6a5e21	App\\Models\\Menu
9d68bff1-c744-42e3-9487-d4899465bd6e	App\\Models\\Menu
9d68c02a-48fe-4b21-900e-9a6a8c9b260d	slow
9d68c02a-4dd7-4f78-b801-cc680a333be6	App\\Models\\ItemLoans
9d68c02d-4333-4648-aad1-72474b072378	App\\Models\\Menu
9d68c02e-5da4-4e1d-8f51-701ac5b532d7	App\\Models\\Menu
9d68c041-ce87-46ae-a8a2-c45c9cbd6555	slow
9d68c041-cf30-47fa-ab44-f9994df1ec27	App\\Models\\User
9d68c042-5d21-4e6a-80e0-8a58cc3aa38a	App\\Models\\User
9d68c09a-d608-4c25-9e36-028988f1d396	App\\Models\\ItemLoans
9d68c09d-d482-40b5-b15d-54039f7d804e	slow
9d68c09d-d517-45e4-aa38-2a0811073f30	App\\Models\\Menu
9d69c493-5d41-45ea-9e32-8358d2562b3c	App\\Models\\User
9d69c499-0ab6-4998-b394-978adaf08c65	slow
9d68c09f-9580-4b46-a410-2ae706fd852d	App\\Models\\Menu
9d68c0cf-6b7a-4205-bc38-a13c55b55701	slow
9d68c0cf-6f84-41f2-a274-14d04fdf7210	App\\Models\\ItemLoans
9d68c0d0-6c2b-4205-be72-b5b3cb6a005f	App\\Models\\Menu
9d68c0d1-9e2b-488b-a3d2-a236ad117d13	App\\Models\\Menu
9d68c106-eef9-4cb2-a852-a111a8385921	slow
9d68c109-49bf-472d-a216-15812cbcd382	slow
9d68c109-4f37-4bd7-bb6d-dca8cd2db633	App\\Models\\ItemLoans
9d68c10a-7dfb-4290-a08f-b0a2ff95acb5	slow
9d68c10a-7e8d-4c5a-a667-1b01d31bd9d1	App\\Models\\Menu
9d68c10b-e92c-46e0-a7b9-99be4c47ee4d	slow
9d68c10b-e98a-4b3b-8441-8bc3e818ebc4	App\\Models\\Menu
9d68c11c-e681-467f-a6f7-77ebc3801e88	App\\Models\\ItemLoans
9d68c12a-d7d9-4906-b7a4-28a51a0ec856	App\\Models\\Loans
9d68c12a-d9b8-4405-9930-14a8a0d9d8bb	App\\Models\\Loans:90
9d68c12a-db31-48f9-9c29-e97e14e20277	App\\Models\\ItemLoans
9d68c12b-9057-4b15-bc9b-b29b4d3eb0e3	slow
9d68c12b-940f-41ee-9e63-6c8a7d5844ed	App\\Models\\ItemLoans
9d68c1f4-c132-4efe-a923-ee144caac86a	App\\Models\\ItemLoans
9d68c1fc-8a71-4a4f-9578-852fd9473c88	slow
9d68c233-bc50-4f40-8005-bb5bae1eef4a	App\\Models\\ItemLoans
9d68c237-8e5d-46e4-8e26-85ca995fb9e9	slow
9d68c237-8f0b-4ecc-a165-86dbe8038b29	App\\Models\\Menu
9d68c238-9565-4b90-9ea3-ed07d8ce6214	App\\Models\\Menu
9d68c245-89f3-4e50-ad40-b15263f03035	App\\Models\\ItemLoans
9d68c25c-4eb2-4c50-8a04-9d32a6bcc07f	App\\Models\\ItemLoans
9d68c25e-38e6-4ff7-8348-c0666a99e2c3	App\\Models\\ItemLoans
9d68c25f-ea68-4440-8cc8-dd92829c8623	App\\Models\\Menu
9d68c260-80cd-444d-9f17-876cff1ce915	App\\Models\\Menu
9d68c2dc-f5ba-4c44-835f-a583d9742e1c	slow
9d68c2dc-f9dc-424e-a266-9500118ac185	App\\Models\\ItemLoans
9d68c2e0-6521-4339-9840-56e736e8e6b8	slow
9d68c2e0-65a0-4394-b534-00573a89546a	App\\Models\\Menu
9d68c2e1-8420-4cb3-84cc-4aa51dc61f52	App\\Models\\Menu
9d68c2f2-a24d-43b5-8527-330ab2b1008c	App\\Models\\ItemLoans
9d68c2f4-bfa4-4dfd-8335-1087b934d0ed	slow
9d68c2f5-b146-427e-8b2c-cf993dbc2da5	App\\Models\\Menu
9d68c2f7-0832-4333-ab6b-b2b71fdead45	slow
9d68c2f7-08da-4348-91b1-d2d7430bd59b	App\\Models\\Menu
9d68c67a-41a9-4c79-abca-bdbec46038e2	slow
9d68c67c-8755-487e-bfa2-096f90f80d49	App\\Models\\ItemLoans
9d68c67d-b85b-4c1b-a462-5861cffaee97	App\\Models\\Menu
9d68c67e-ad7d-43f9-85c2-46f5f1939339	App\\Models\\Menu
9d68c687-1d11-45e6-8c3a-e24331c391f1	App\\Models\\ItemLoans
9d68c689-c5f0-4eb9-974f-dc54358ccc29	App\\Models\\Menu
9d68c68a-ee69-493a-93a0-30f7a30eb882	slow
9d68c68a-eee3-4f85-a845-f7a814409596	App\\Models\\Menu
9d68c6db-45ac-4924-ba31-1e482667f874	slow
9d68c6db-496a-49e2-a100-4ff1f4716431	App\\Models\\ItemLoans
9d68c6dd-72b8-4cd8-b306-3caa9b7889c0	slow
9d68c6de-7845-4f32-99ba-786995d0cc3a	slow
9d68c6de-78d0-4383-8908-bea524f16f3f	App\\Models\\Menu
9d68c6df-d9ee-4c75-a1ab-d26602f3ce41	App\\Models\\Menu
9d68c718-bde2-455f-8e63-87a592d79466	App\\Models\\ItemLoans
9d68c71d-162d-4c09-9fb6-d279d07fc450	slow
9d68c71d-16de-4f5c-9ea3-cb4246bdb735	App\\Models\\Menu
9d68c71e-b64c-4963-aa07-510112f714e1	App\\Models\\Menu
9d68c72f-329e-4b5f-92ed-fc9de6a7f61f	App\\Models\\ItemLoans
9d68c731-543f-4fa6-be64-719b049e4344	slow
9d68c732-443f-4299-b155-24923e4dd9d2	slow
9d68c732-44cc-4203-850e-fafa44e97fb6	App\\Models\\Menu
9d68c733-567a-4009-95b0-942f0278600b	App\\Models\\Menu
9d68c769-13b2-4dc5-830f-1f8842dfb7e4	App\\Models\\ItemLoans
9d68c76c-19ad-4c0d-8cd4-8ee7957ce9fe	slow
9d68c76c-1a6c-42e0-b7f1-6781b4f6f17e	App\\Models\\Menu
9d68c76d-6f7a-4dd0-99ea-e17603582c26	slow
9d68c76d-700d-40af-9e9f-857f12c5a6ac	App\\Models\\Menu
9d68c7b2-a426-4e86-ae61-e06cf8e96f8b	App\\Models\\ItemLoans
9d68c7b5-d983-40c3-be62-35049fc8c100	App\\Models\\Menu
9d68c7b6-c561-42b8-8d9b-8bebed58151e	App\\Models\\Menu
9d68c7c5-b44d-4b8c-9901-e2901239f321	App\\Models\\ItemLoans
9d68c7c8-6ba6-47f7-a622-d47e3ef1c59c	slow
9d68c7c8-6c3a-4b6c-a0ce-f9df05e33c4e	App\\Models\\Menu
9d68c7c9-ba58-4828-b813-706a7fd1a796	App\\Models\\Menu
9d68c811-52d8-48b2-b38f-4acc92fd6bf4	App\\Models\\ItemLoans
9d68c884-bcda-4d94-b0b3-2ff18ddb6a85	App\\Models\\ItemLoans
9d68c886-bc5b-41d9-b444-ee8fb0d4395b	App\\Models\\ItemLoans
9d68c888-40c9-4f30-81a7-87411dfaaa42	slow
9d68c888-4148-4628-84c3-85706162faab	App\\Models\\Menu
9d68c889-373e-4b44-88b8-74bd03e6d191	App\\Models\\Menu
9d68c8f4-5c1e-49b8-8311-12fbd7f9ea9f	App\\Models\\ItemLoans
9d68c8f7-0aa3-4cbb-805a-7a7143ba032a	slow
9d68c8f7-1264-4017-b395-d5463452722e	App\\Models\\ItemLoans
9d68c8f9-4fd0-477c-b71b-19c0243cb4a0	slow
9d68c8f9-5069-452a-9cf3-89e0571a3ca1	App\\Models\\Menu
9d68c8fa-71e7-4eff-a516-44be6099a52a	App\\Models\\Menu
9d68c8ff-c6e9-4769-bffb-e5adba0ab1b7	slow
9d68c8ff-caad-4598-94be-0ac1902f862c	App\\Models\\ItemLoans
9d68c902-03a5-490e-9150-52951b5ba213	slow
9d68c902-0a46-40be-921b-14271b965438	App\\Models\\ItemLoans
9d68c903-4f2c-4586-85f4-58b17cc6c186	slow
9d68c903-4fb9-4dac-9e27-05d52593052b	App\\Models\\Menu
9d68c904-6f86-4d75-9c85-d5275200b32b	App\\Models\\Menu
9d68c94f-18c3-4ffc-805d-e1587a36142f	slow
9d68c94f-1d70-4d87-9935-5049818294e0	App\\Models\\ItemLoans
9d68c951-2d8c-4182-987c-d494e5cbd4d6	slow
9d68c951-32c7-4b67-bd72-eef8df832d0c	App\\Models\\ItemLoans
9d68c952-e029-433e-849f-c2a4625c2852	App\\Models\\Menu
9d68c954-077d-4bb8-876f-f3f0f251c53b	App\\Models\\Menu
9d68c9e8-22fb-452d-86d5-02440f88d6a6	App\\Models\\ItemLoans
9d68c9ea-2273-4f32-b40b-fba2e73893d4	App\\Models\\ItemLoans
9d68c9ec-02d2-4653-befa-c0c50d21657d	App\\Models\\Menu
9d68c9ed-69cf-43af-aae5-005e92974230	slow
9d68c9ed-6a89-42fa-8f10-e8447b2d6917	App\\Models\\Menu
9d68c9fa-482f-4aaa-b94f-23da614fe288	App\\Models\\ItemLoans
9d68c9fc-68c5-41ed-a859-12c52a8e8b86	App\\Models\\ItemLoans
9d68c9fe-6b42-4b19-a76b-9a11c6e8f2df	App\\Models\\Menu
9d68c9ff-7a45-4c04-af67-a99efde0e031	App\\Models\\Menu
9d68cb44-a920-4549-8c30-3ec319547f64	App\\Models\\ItemLoans
9d68cb48-03a2-46e0-b8a8-ab71a7909d82	App\\Models\\ItemLoans
9d68cb49-a120-4859-a1cf-4752608786b6	slow
9d68cb49-a1b6-410d-a690-d416ee9604e3	App\\Models\\Menu
9d68cb4b-08ca-418d-8cbe-fed7a801d653	slow
9d68cb4b-0958-4440-8abc-ac6b31f27068	App\\Models\\Menu
9d68cb51-1b36-4c40-8cce-976c3a1582b3	App\\Models\\ItemLoans
9d68cb52-fb40-4d22-90a6-6aff87b025d3	App\\Models\\ItemLoans
9d68cb54-91fc-46e6-a02c-f5f519213fdf	slow
9d68cb54-929e-4fdb-82ef-03e23d77dcc4	App\\Models\\Menu
9d68cb55-a7c0-494b-abfe-189b6a34d20a	App\\Models\\Menu
9d68cbfe-e97e-4935-ab7e-5ece66de2dba	slow
9d68cbfe-ee1b-4ace-8f61-6b3204c34fdc	App\\Models\\ItemLoans
9d68cc01-38db-4e0c-bedf-3a8928e95bcd	App\\Models\\ItemLoans
9d68cc02-bdc1-4a1a-8f40-3e8ea8badc97	App\\Models\\Menu
9d68cc03-ae2b-4c29-b6b0-f65cac20087a	App\\Models\\Menu
9d68cc27-9004-408b-a789-cf7d397e15de	App\\Models\\ItemLoans
9d68cc29-c03f-4c7e-989f-fd6312166419	App\\Models\\ItemLoans
9d68cc2a-f5c7-4145-ad9c-dcf06c14fc77	slow
9d68cc2a-f64b-471e-a7a9-6d2b9d694c1f	App\\Models\\Menu
9d68cc2b-d52f-4ef2-8d4f-cb75e066b882	App\\Models\\Menu
9d68ccf4-653a-4f85-afb6-020464a9c39b	slow
9d68ccf4-6935-49e5-955f-19e833c59494	App\\Models\\ItemLoans
9d68ccf6-f196-42f5-90db-71c8b5ce3111	App\\Models\\ItemLoans
9d68ccf7-ffb3-4bd0-95f5-98ba10992d3d	App\\Models\\Menu
9d68ccf8-f6bf-48ac-8f7a-5c9bd7053064	App\\Models\\Menu
9d68cd34-71ff-4c8a-8620-2c611b35d55a	App\\Models\\ItemLoans
9d68cd37-348f-49e2-826e-fcaa5ad2749d	App\\Models\\ItemLoans
9d68cd38-7840-42cb-9147-710f1e5ea64e	slow
9d68cd38-78d4-4a4b-a63d-e3aaeaf72d0c	App\\Models\\Menu
9d68cd39-c3d2-4a54-bfb9-d8a7a3f3f909	slow
9d68cd39-c48a-4c4d-8805-2a879e88c86c	App\\Models\\Menu
9d68cd51-5da3-4552-8dda-48f373495a08	App\\Models\\ItemLoans
9d68cd54-eaa5-4b64-95ad-6e50b3d73d7e	slow
9d68cd54-efb3-4c81-9556-b63b15de1c76	App\\Models\\ItemLoans
9d68cd56-99db-443a-8b4f-9e3d558e1148	slow
9d68cd56-9a7a-4bec-94b0-906da4c5c84b	App\\Models\\Menu
9d68cd58-0c03-4bdf-82af-f7d2a077f96f	App\\Models\\Menu
9d68cd5d-a292-450f-b9f4-8c9287e1f2e8	slow
9d68cd5d-a790-45fd-ab9f-1c9e8f1f0a0e	App\\Models\\ItemLoans
9d68cd5f-f008-4690-9c8e-d984029d319a	App\\Models\\ItemLoans
9d68cd61-09b1-4448-8972-2a7b4343fcd3	App\\Models\\Menu
9d68cd61-fe3d-4ad4-a601-0c79d7f13d2d	App\\Models\\Menu
9d68cdb8-b85e-4ba3-a760-dafddeeef3a5	slow
9d68cdbc-71a7-45c4-a2ef-bc1e1953c633	App\\Models\\ItemLoans
9d68ce06-d7c9-4e1c-87ea-b24329156422	App\\Models\\Loans
9d68ce06-da80-4d3a-ae70-272ad320b222	App\\Models\\Loans:89
9d68ce06-db25-4558-953a-aea429c1dc76	App\\Models\\ItemLoans
9d68ce06-dbb5-49f0-a808-f6a4891fda3d	App\\Models\\ItemLoans:351
9d68ce06-ddb2-4353-8910-e93e40740888	App\\Models\\ItemLoans:
9d68ce06-de33-4597-bbc9-b0af8370841c	App\\Models\\ItemLoans:
9d68ce06-ded5-4f94-90d5-2cb9818792ee	App\\Models\\ItemLoans:
9d68ce06-df4c-4d86-bf7f-cce9038f1ceb	App\\Models\\ItemLoans:
9d68ce06-dfbe-45f5-b6ea-68433b690cd3	App\\Models\\ItemLoans:
9d68ce07-7397-4c08-9abd-71de3c43e527	App\\Models\\ItemLoans
9d68ceb9-a3be-4bf5-a757-e9bdd2811def	App\\Models\\ItemLoans
9d68cebc-af21-4400-859c-c8b03330d799	App\\Models\\ItemLoans
9d68cebd-e763-4d08-be29-3aa67a8004b2	App\\Models\\Menu
9d68cebe-cd26-47cd-a72e-567553c6850c	App\\Models\\Menu
9d68cef8-834d-41b2-ad3f-06b14580c7ff	App\\Models\\ItemLoans
9d68cefa-cad6-46f0-b4cb-7a47e2735f7c	App\\Models\\ItemLoans
9d68cefc-32e8-412a-afab-974fc899f998	App\\Models\\Menu
9d68cefd-21e8-4443-8e5c-c40525500e51	App\\Models\\Menu
9d68cf25-a847-454d-af6c-9a8c22e9dc2d	App\\Models\\ItemLoans
9d68cf28-1bb9-4474-a24c-eac3662d09a6	slow
9d68cf28-20aa-456f-bfee-e1b1e3e22d3c	App\\Models\\ItemLoans
9d68cf29-4940-421e-8d26-c0f2af84725a	slow
9d68cf29-49d4-4b26-a44d-82c9bb957598	App\\Models\\Menu
9d68cf2a-4388-4227-8890-8fb542b2fc2b	App\\Models\\Menu
9d68cf48-ba8e-4fa8-b62a-6b5a2571ae38	App\\Models\\ItemLoans
9d68cf48-bc91-4240-abcc-d6beb58cea6c	App\\Models\\Loans
9d68cf48-bf03-4307-9285-4ff08a781d54	App\\Models\\ItemLoans:366
9d68cf48-bfff-49ce-b294-a7dc0e16b64d	App\\Models\\Loans:89
9d68cf49-5a3b-4200-9275-edaf7f26a77d	App\\Models\\ItemLoans
9d68d052-f066-48f4-ae77-629dbd6d0b99	App\\Models\\ItemLoans
9d68d055-cc9e-42a4-8146-0ceb5a50dbe9	App\\Models\\ItemLoans
9d68d056-e2a3-4827-ae6e-2a8ec5df6646	App\\Models\\Menu
9d68d057-ccad-4973-90b0-e38d29728ad6	App\\Models\\Menu
9d68d209-1ada-4d05-9099-a2a1f63dddd6	App\\Models\\ItemLoans
9d68d20c-0042-47f2-b235-3b9750d5c79a	slow
9d68d20c-09fe-41e8-8c7f-590c6e758a40	App\\Models\\ItemLoans
9d68d20d-1bd4-47f9-af82-709bed6404fe	App\\Models\\Menu
9d68d20e-1072-470b-bd77-a88161919cd3	App\\Models\\Menu
9d68d311-929c-4b16-aacf-4bc199009921	App\\Models\\ItemLoans
9d68d313-a436-4234-a20a-c87881756aaf	slow
9d68d313-ab15-4358-9dbe-d82a4506c960	App\\Models\\ItemLoans
9d68d31a-7336-489b-b562-ae9d6413a999	App\\Models\\Menu
9d68d31b-6b1c-43d6-896d-a183b801cd22	App\\Models\\Menu
9d68d354-ff10-4834-bd13-b7ebe8269dab	App\\Models\\ItemLoans
9d68d357-3d50-44c1-bd96-29de50f7c9fe	App\\Models\\ItemLoans
9d68d358-669c-4579-870c-009a908f2679	slow
9d68d358-6775-473e-8754-2c7f195d9426	App\\Models\\Menu
9d68d359-9d84-48a6-92a4-3caa57ae13c0	App\\Models\\Menu
9d68d3da-3e75-4476-83ab-1d01a22b2ee8	slow
9d68d3da-4270-4403-af27-c6ba41e9dcfb	App\\Models\\ItemLoans
9d68d3dc-337d-4a16-acd9-ec4d4a91d8ae	slow
9d68d3dc-3c83-4edb-a0ed-d06193439a58	App\\Models\\ItemLoans
9d68d3e4-e30d-4089-b551-31cd410ec397	App\\Models\\Menu
9d68d3e5-b0e2-4a4b-a9a7-78555ad31877	App\\Models\\Menu
9d68d3e9-da9b-4637-9fd7-909fe8918607	slow
9d68d3e9-de65-4975-94c1-465a03c86aad	App\\Models\\ItemLoans
9d68d3eb-d7bf-4e96-ab08-28b72b4a49f0	App\\Models\\ItemLoans
9d68d3ec-deec-4bd2-9267-2304bef6cc77	slow
9d68d3ec-df78-487b-a217-caa825bb5342	App\\Models\\Menu
9d68d3ee-163c-4ee7-b39b-cd98c3f77948	slow
9d68d3ee-16d2-4d77-aa25-109d9df4061a	App\\Models\\Menu
9d68d443-2d99-470d-b8e8-e2f5eee8fa97	App\\Models\\ItemLoans
9d68d445-b875-435c-b76b-70b48b3aa4e2	App\\Models\\ItemLoans
9d68d446-cbd3-4c07-9071-e3391d91802d	App\\Models\\Menu
9d68d447-ada1-4003-9570-8cbc81e24ebb	App\\Models\\Menu
9d68d71a-ba2a-41dc-b595-89f8b61adc4e	slow
9d68d71a-be97-4d37-8950-2315eb772514	App\\Models\\ItemLoans
9d68d71c-040d-4c8e-a110-bf8c6b083cb0	App\\Models\\ItemLoans
9d68d71d-7d42-4827-bfc3-9b00dd109226	App\\Models\\ItemLoans
9d68d721-1aaf-491a-98bf-56353dec136b	App\\Models\\ItemLoans
9d68d722-7e97-4204-a1c8-d1540a3d7be7	App\\Models\\Menu
9d68d723-89e1-41ea-9999-8cd00237a32d	App\\Models\\Menu
9d68d7ba-c038-4c8e-9f56-43528585b022	App\\Models\\ItemLoans
9d68d7bd-4577-46c1-81b0-a291064967a0	slow
9d68d7bd-4b43-41b2-9ca2-47b9dd18eb47	App\\Models\\ItemLoans
9d68d7be-82d4-43b3-acb0-81d5dc809623	slow
9d68d7be-835d-434f-be23-b53065228a52	App\\Models\\Menu
9d68d7bf-614e-4734-b864-48587c17340d	App\\Models\\Menu
9d68d84b-b41f-4e15-9e49-9f504c7917de	slow
9d68d84b-b933-41b1-98d8-6a25a57a4381	App\\Models\\ItemLoans
9d68d84e-ab4f-4cd7-9c3d-253e797dd951	slow
9d68d84e-b0ef-4c29-a368-11150b15b76a	App\\Models\\ItemLoans
9d68d84f-c740-498c-bda1-854947099a38	App\\Models\\Menu
9d68d850-d4d8-44e1-814b-f8f9fe79f855	slow
9d68d850-d569-41a2-b86d-07119465b68d	App\\Models\\Menu
9d68d8c6-ecb0-4da9-a524-8fd1d4988d18	App\\Models\\ItemLoans
9d68d8c9-0f4a-48e7-9b39-345f5ee30796	App\\Models\\ItemLoans
9d68d8ca-5db9-4317-9a1e-9adadcbef344	App\\Models\\Menu
9d68d8cb-3d95-4c19-b1dd-b98c24abdd74	App\\Models\\Menu
9d68d90c-6ea0-45ad-b265-9609d12ca5c0	App\\Models\\ItemLoans
9d68d90e-d1fd-459f-9d72-ad341d2b5b1e	App\\Models\\ItemLoans
9d68d910-0fab-4395-bdf2-36ce6ef8a345	App\\Models\\Menu
9d68d911-3bf2-49ba-ae3e-c5a98c5e3973	App\\Models\\Menu
9d68da63-685b-4042-80eb-3e067f73dfea	App\\Models\\ItemLoans
9d68da65-3eb2-4fe5-89c4-1a05c30b104c	App\\Models\\ItemLoans
9d68da66-eb03-496b-93bb-3307a644906d	App\\Models\\Menu
9d68da68-0518-4ad3-97f5-7fb889054083	App\\Models\\Menu
9d68db51-1b5f-45d3-9541-09353cb7e2e1	slow
9d68db51-1f64-44e4-81f1-910fc730bcb2	App\\Models\\ItemLoans
9d68db53-77ee-422f-831b-0852b1628fac	App\\Models\\Menu
9d68db70-59fd-49b3-a433-e4c723b61709	slow
9d68db8d-7ab2-4416-ad55-5e8beeb3dfff	App\\Models\\ItemLoans
9d68db90-cb2c-4fd4-927d-aaf7900e3edb	slow
9d68db90-cbc9-4d8a-b586-645fdfcb0393	App\\Models\\Menu
9d68db92-08d0-41ac-b0bf-80dac392128a	App\\Models\\Menu
9d68dba3-2067-4008-981c-3bd9673a0708	slow
9d68dba3-20c6-4980-903c-118a1e3c8154	App\\Models\\Menu
9d68dbd1-a10b-4f06-8653-17310618144b	App\\Models\\Menu
9d68dc20-35d5-46ec-9517-9dac7fd30322	App\\Models\\ItemLoans
9d68dc23-085b-4f4e-9b16-5a753882a13c	App\\Models\\Menu
9d68dc24-cc72-4053-8521-ef99d59eb040	App\\Models\\Menu
9d68dc34-3bf1-4b78-a475-59e7c5e9e18e	App\\Models\\ItemLoans
9d68dc5a-dc6d-40c5-9b09-827817e1fd5d	App\\Models\\ItemLoans
9d68dc5c-f4d3-4329-acd3-b2a181c7f26a	slow
9d68dc5e-74cd-4e02-95cd-a8bfd4b077a6	slow
9d68dc5e-757b-4987-919d-02d39c3d8e6e	App\\Models\\Menu
9d68dc5f-cebb-44b9-b674-2744a5d4ade8	slow
9d68dc5f-cf5d-4a64-a6c2-f4fbf3cccb51	App\\Models\\Menu
9d68dd0c-7b16-404f-8716-d694eda91882	App\\Models\\ItemLoans
9d68dd0f-619a-4005-b7ab-7c9782c0e352	slow
9d68dd0f-6236-4998-b286-17a7e4faa422	App\\Models\\Menu
9d68dd11-0d0a-418e-8b8c-3a0626261739	App\\Models\\Menu
9d68dd4f-bccd-46c7-88e6-b540842de673	slow
9d68dd4f-c0ef-4f42-bd1b-7cdcd691392e	App\\Models\\ItemLoans
9d68dd51-e254-4b95-88d3-7eae46507745	slow
9d68dd51-e2e2-4673-b918-e8dc2a742a1e	App\\Models\\Menu
9d68dd52-d038-4557-9fa9-021a6f45ff5f	slow
9d68dd55-6b8e-4924-8f98-266ee6d61128	App\\Models\\Menu
9d68dd92-b111-4e8a-9feb-7582f9e73206	App\\Models\\ItemLoans
9d68dd94-cf63-40e9-b9f8-7fe48c27fcca	slow
9d68dd94-d01e-4761-8b97-fecee92083f5	App\\Models\\Menu
9d68dd96-612d-492e-a9b7-f7c55675d7b1	App\\Models\\Menu
9d68dd9a-2cef-464a-ac36-b0cd57e65e5a	App\\Models\\User
9d68ddbc-6164-4f2f-9eef-fa0dd91d3e17	App\\Models\\ItemLoans
9d68ddbe-2801-4654-b373-6d9d1a72826c	App\\Models\\Menu
9d68ddbe-fcef-450e-8810-09a683df993a	App\\Models\\User
9d68ddc1-1eec-4839-b954-b3edd5b08678	App\\Models\\Menu
9d68dde2-be47-4400-bc69-22b10d3bf7db	App\\Models\\User
9d68df1f-e8e1-4e64-938b-920ab87361fc	App\\Models\\User
9d68df20-98ae-4dfb-828d-1b9047ffa750	App\\Models\\Loans
9d68df20-9ac6-4ec6-bd7a-5dcb9fdff82b	App\\Models\\ItemLoans
9d68df21-41cc-448a-aea3-d5856ceedbbf	App\\Models\\User
9d68dfad-3de4-4f7d-aa7d-e2b40944b577	App\\Models\\User
9d68dfad-fc72-46cf-a01f-7949c7a92bec	App\\Models\\User
9d68dfae-9b32-4ca5-b708-bde6416717eb	App\\Models\\Loans
9d68dfae-9d1e-4734-9205-d15bba0309c7	App\\Models\\ItemLoans
9d68dff0-62ab-4ee6-afbf-5787f5a45080	App\\Models\\ItemLoans
9d68dffc-2618-4ce6-8c15-8f44646ddf2a	slow
9d68e007-e305-470c-bae5-5721ac523a7f	App\\Models\\ItemLoans
9d68e043-f9da-46c5-897c-73593b3be2dd	App\\Models\\User
9d68e044-8cd4-4fe5-9e48-393b04e4b69c	App\\Models\\User
9d68e045-250c-4998-9f2b-6aed4686db1a	App\\Models\\Loans
9d68e045-2713-446f-80b4-682ff778cfe8	App\\Models\\ItemLoans
9d68e1b8-0097-44f4-a013-e0193c4e5a97	slow
9d68e1b8-053b-4d08-b520-545ea959dd30	App\\Models\\ItemLoans
9d68e1b9-dfcf-4eeb-b1ff-e6cdc3fa4abb	App\\Models\\User
9d68e1ba-ba57-4fa3-b5fe-bda48cd91972	App\\Models\\User
9d68e1bb-8626-4b3b-8860-871cce3ec9ac	App\\Models\\Loans
9d68e1bb-8953-4b39-b40f-f20f40b58394	App\\Models\\ItemLoans
9d68e1bd-3436-4a26-937b-633d6d2b62d7	slow
9d68e1bd-34db-42b0-a222-9021da6b8ddc	App\\Models\\Menu
9d68e1be-5283-451e-b09a-9195a0d61aed	App\\Models\\Menu
9d68e1c2-660a-456f-950c-ad290e14be11	App\\Models\\User
9d68e1c2-f3da-412d-9f44-3793a6930b44	App\\Models\\User
9d68e243-61e3-4b50-a949-aa56aba2b4a9	App\\Models\\ItemLoans
9d68e245-d9f0-4765-8a77-9707c6079cea	App\\Models\\User
9d68e246-a677-4dfb-8839-6231c466f9e2	App\\Models\\User
9d68e248-5f66-4c72-9d71-16cd5c255b09	slow
9d68e248-6004-4a92-9b0c-a6f6544ef26b	App\\Models\\Menu
9d68e249-6d24-40fb-90a5-878b8f3e73ee	App\\Models\\Menu
9d68e277-bca4-4f57-afc4-bb125890ac90	App\\Models\\ItemLoans
9d68e279-9654-4aa0-9049-52f3693db8be	App\\Models\\User
9d68e27a-722a-4faf-ac89-c22c37cdad96	App\\Models\\User
9d68e27c-16fd-4304-aa03-5fe94a057a82	slow
9d68e27c-177c-4f7f-a682-a8fd672f7907	App\\Models\\Menu
9d68e27d-0e74-41f2-b242-5721f0e65e0e	App\\Models\\Menu
9d68e2b4-cbd6-4e10-abfa-e854ef802ba9	App\\Models\\ItemLoans
9d68e2b6-cc55-4e0a-913f-2660e58b556f	App\\Models\\User
9d68e2b7-d270-4c2c-9c58-9f106d4b18b4	slow
9d68e2b7-d2f2-47eb-9c3b-6201c164b579	App\\Models\\User
9d68e2b8-e5fd-4e4d-9cbc-0c0a05c7158f	App\\Models\\Menu
9d68e2ba-16e1-47b9-812f-d7f5d7433784	App\\Models\\Menu
9d68e2f8-0e8c-4689-bd01-d92a94b34a68	App\\Models\\ItemLoans
9d68e2fa-0d44-4301-b08e-2e5058fe9e36	App\\Models\\User
9d68e2fa-ebd1-47a1-bc2b-59817c628423	App\\Models\\User
9d68e2fc-9260-462e-8ffb-28f93214644a	App\\Models\\Menu
9d68e2fd-9e50-4912-9a6a-8da2b4961e50	App\\Models\\Menu
9d68e345-b2c7-4024-a13f-244be8d771d0	slow
9d68e345-b797-474f-995d-c25216f3ef58	App\\Models\\ItemLoans
9d68e347-a425-4dcb-974c-1f8514a4e85b	App\\Models\\User
9d68e348-a5af-4eb7-ad42-33ff339f1a72	slow
9d68e348-a63b-42e2-a389-10369b3bba22	App\\Models\\User
9d68e349-e73f-4aae-b5eb-2a7af98c1885	App\\Models\\Menu
9d68e34b-29dd-40eb-901c-b34129289439	App\\Models\\Menu
9d68e3d7-f1a7-41b0-974c-9c3f3c467765	App\\Models\\User
9d68e3d8-af00-47ad-9c3e-e8bb4dbd0b02	slow
9d68e3d8-af53-4017-aaa9-80f8b32ec678	App\\Models\\User
9d68e3db-20f1-4669-ad99-20c44db3ded2	App\\Models\\ItemLoans
9d68e3dc-39ec-4bfb-9461-913e0bbf3c6d	App\\Models\\Menu
9d68e3dd-1a7d-48f9-95e5-06f66b095f3b	App\\Models\\Menu
9d68e41b-2884-4a74-8162-d92269018899	slow
9d68e41b-2c5c-4788-8c4e-3568c16b0f96	App\\Models\\ItemLoans
9d68e41d-4374-4481-a23c-13c2492a4b1e	slow
9d68e41d-4410-4522-9439-12177b64309a	App\\Models\\User
9d68e41e-137b-48ca-89fc-591733f2dc12	App\\Models\\User
9d68e41f-50e9-45d8-80cc-aad4d9a41929	slow
9d68e41f-5193-4de0-bd43-744e6d927622	App\\Models\\Menu
9d68e420-62d3-467f-83cd-78aacdc71753	App\\Models\\Menu
9d68e434-ab43-4a1c-8e0d-be9eac571f0d	App\\Models\\ItemLoans
9d68e437-0b23-40dc-b604-66ec70cb9213	App\\Models\\User
9d68e437-a9ad-47eb-a0aa-7733c2efbcdb	App\\Models\\User
9d68e438-c2bb-4772-b994-01bfc3b1d3b5	App\\Models\\Menu
9d68e439-e5e4-4251-b4fd-11a2f8e4007e	slow
9d68e439-e664-4b18-8d4a-728a0ed07804	App\\Models\\Menu
9d68e44a-5610-474c-831e-7c466be6e35b	slow
9d68e44a-5b06-49a5-a3c5-f04b425ef2bf	App\\Models\\ItemLoans
9d68e44c-5b20-4f8f-b0c9-56bf92d04eff	App\\Models\\User
9d68e44d-302f-444e-8592-41d4ba97319e	App\\Models\\User
9d68e44e-99ee-4caf-bb19-ecc87a66b132	App\\Models\\Menu
9d68e44f-9f1f-4492-bbad-76ac5a610b1c	App\\Models\\Menu
9d68e464-6da3-45ae-8810-3b4a0c43665a	App\\Models\\User
9d68e4a6-7a84-4c0c-807c-2fad2fbcdd05	slow
9d68e4ac-38fb-4c8c-909a-65e103307fb9	slow
9d68e4ac-3954-4c9f-b066-8ae5163bf191	App\\Models\\User
9d68e4ac-d9c7-4bd1-9acf-0b262b08e9c8	App\\Models\\User
9d68e4ad-6c1c-4325-962f-55fe93baf979	App\\Models\\Loans
9d68e4ad-6dea-46a7-9d18-96f474e42411	App\\Models\\ItemLoans
9d68e568-39c1-4a02-9fff-227086ca7e6c	App\\Models\\ItemLoans
9d68e56a-7bf8-42b6-853e-d8df23f4b938	slow
9d68e56a-7c75-4a22-b1fd-c17d3c74c16d	App\\Models\\User
9d68e56b-48af-4cdf-afbf-86559146596b	App\\Models\\User
9d68e56c-0f96-4412-885e-4969e9697dbc	App\\Models\\Loans
9d68e56c-11ea-4cd6-8aa8-ec42981cb815	App\\Models\\ItemLoans
9d68e56d-bd82-4053-867c-29b26099cd5c	slow
9d68e56d-be11-4038-840c-45c1468ee7f7	App\\Models\\Menu
9d68e56e-df6b-40ba-b8b5-f6119e6e53df	App\\Models\\Menu
9d68e793-fa61-4ff8-be7f-37c45bd5329a	App\\Models\\ItemLoans
9d68e795-e4a9-45f5-ba8e-570f87c08b4f	App\\Models\\User
9d68e796-c6e6-4ae4-a2f3-fe83988bf69d	App\\Models\\User
9d68e797-a22a-4a95-b8a5-473ef78878b2	App\\Models\\Loans
9d68e797-a4bc-430b-80ff-b3134ac58a43	App\\Models\\ItemLoans
9d68e799-30e3-4450-adba-52bd74049383	App\\Models\\Menu
9d68e79a-1ff2-434b-941a-ab720576c3f3	App\\Models\\Menu
9d68e7f9-450c-4b5e-b47e-c55d73caf078	App\\Models\\ItemLoans
9d68e7fb-5edd-41c3-a21e-2f5fcad67c02	App\\Models\\User
9d68e7fc-47e9-4880-8500-ac072a70214a	App\\Models\\User
9d68e7fd-01ee-461c-86c6-62acb1682116	App\\Models\\Loans
9d68e7fd-03b3-47cf-aee5-acd70b60c967	App\\Models\\ItemLoans
9d68e7fe-8317-444c-8a80-30d4caf0dbdb	slow
9d68e7fe-83d6-428e-a210-ab1b29b5e1f5	App\\Models\\Menu
9d68e7ff-a537-4dde-971b-a968565f1c73	App\\Models\\Menu
9d68e87c-4c55-4fd5-af87-3a85d6abb48c	App\\Models\\ItemLoans
9d68e87e-436b-4517-bda9-35b1605fac09	App\\Models\\User
9d68e87f-3a77-4c1a-a78b-9d8ef75ea87c	App\\Models\\User
9d68e880-0f7c-474a-a51c-4f43b852993b	App\\Models\\Loans
9d68e880-12a7-41b6-a46e-a24a33a591b0	App\\Models\\ItemLoans
9d68e881-6360-47d7-a58b-e98d2cee2f75	slow
9d68e881-6411-408f-82b4-2ab1e20ebe7d	App\\Models\\Menu
9d68e882-9c03-4d36-bf41-73cdc59c50b3	App\\Models\\Menu
9d68e8b6-4251-4bc8-b016-d3444f838db8	App\\Models\\ItemLoans
9d68e8b8-5ad6-4152-a2d2-c9adf4e2f973	App\\Models\\User
9d68e8b9-382a-4937-9ad7-2b8378e98663	App\\Models\\User
9d68e8ba-1b8d-448b-be3c-e7b8eaf10162	slow
9d68e8ba-1bfa-44de-80c5-f26a63c23466	App\\Models\\Loans
9d68e8ba-1e6b-4671-8da0-1619ac986464	App\\Models\\ItemLoans
9d68e8bb-49ff-4370-bf80-d0d5dd62ca13	slow
9d68e8bb-4a97-4a7f-8b96-354b10526963	App\\Models\\Menu
9d68e8bc-b2c2-4765-bb7f-2aa33474ac77	slow
9d68e8bc-b315-4d82-8538-43c4c9788851	App\\Models\\Menu
9d68e91d-f59f-4e74-91ad-6edf146be7e2	App\\Models\\ItemLoans
9d68e920-2db1-40cd-9bf7-0aa701356e09	slow
9d68e920-2e44-4f63-878d-5703b0eeba0a	App\\Models\\User
9d68e920-ff03-4724-9259-c59b3436da06	App\\Models\\User
9d68e921-d373-481c-af21-b1ed94bf75c8	App\\Models\\Loans
9d68e921-d65f-4cd0-b284-1d4bd7f7c56e	App\\Models\\ItemLoans
9d68e923-2918-4d86-bc75-7a1b8ebfa6ee	slow
9d68e923-29a8-48df-a3de-2193df6925f1	App\\Models\\Menu
9d68e924-70ce-49da-b726-d50452cadf39	App\\Models\\Menu
9d68e939-1767-448e-b75b-4ecfb09165ef	App\\Models\\ItemLoans
9d68e93b-2ace-4075-af35-d661ed33f769	slow
9d68e93b-2b5e-4bcd-9475-6cb89c7e3fe3	App\\Models\\User
9d68e93b-f24f-46b9-bbe7-e7bdac057dfc	App\\Models\\User
9d68e93c-afb8-40b6-b2e2-ef56af896d33	slow
9d68e93c-b006-4b47-9f22-85b07ef69d3d	App\\Models\\Loans
9d68e93c-b1c3-4e12-904c-a11fe697d4bf	App\\Models\\ItemLoans
9d68e93d-af56-468a-8b45-a585fa7dcb51	App\\Models\\Menu
9d68e93e-e4d5-4552-b940-1024ee9c3c93	App\\Models\\Menu
9d68e956-f054-496a-8e82-ab13528b6a04	slow
9d68e956-f4c2-45e8-84c8-532e75066130	App\\Models\\ItemLoans
9d68e958-d563-4896-bd2f-18b6e2bcada5	App\\Models\\User
9d68e959-a5e0-42c4-b4e3-2e5b98803831	App\\Models\\User
9d68e95a-4576-4668-b2bf-42010b711036	App\\Models\\Loans
9d68e95a-4752-4ab1-a8b1-b811ceee8cfa	App\\Models\\ItemLoans
9d68e95b-b0f0-4294-9ebd-f5204f19347e	slow
9d68e95b-b18b-40f6-a1d8-933fde1b9a07	App\\Models\\Menu
9d68e95c-c0a9-4e8f-a9bb-b353bc35c7fd	slow
9d68e95c-c101-48f7-9855-d082ba081399	App\\Models\\Menu
9d68e96a-ea11-489b-b47c-d548afa308eb	slow
9d68e96a-ea9f-4f12-9174-2437bfdbaecd	App\\Models\\User
9d68e96b-8640-4325-aae2-803b8c2c86bf	App\\Models\\User
9d68e96c-3e6a-44b0-a0ab-fedf9f0df204	slow
9d68e96c-3ebe-4e48-a782-484dc2724a05	App\\Models\\Loans
9d68e96c-40a8-4c3d-bf18-8ec3b4277ca6	App\\Models\\ItemLoans
9d68ea07-a0e6-4b4b-9105-0e6c8514b02a	slow
9d68ea07-a596-455d-a1f2-eb00e9435990	App\\Models\\ItemLoans
9d68ea09-cabc-457e-969d-a112a82bc9c1	App\\Models\\User
9d68ea0a-a7b0-4fd5-974f-d379cc8bcbfa	App\\Models\\User
9d68ea0b-629d-42d4-b902-a13ef28ff2b5	App\\Models\\Loans
9d68ea0b-6503-4b41-ada7-9f421076f6ab	App\\Models\\ItemLoans
9d68ea0c-8186-4704-9a10-fe90599b0045	slow
9d68ea0c-8215-477e-8ac6-79fd1f19b3c9	App\\Models\\Menu
9d68ea0d-754a-4d93-ba14-abcaa808ccbd	App\\Models\\Menu
9d68ea20-a7c4-4392-977a-26d8794fa2cc	App\\Models\\ItemLoans
9d68ea22-cdab-4913-81c7-9c7966ebae68	slow
9d68ea22-ce3b-4be3-87d1-55865d45dd02	App\\Models\\User
9d68ea23-8c0e-48fb-9606-022158c958b7	App\\Models\\User
9d68ea24-56cf-42d8-a380-9123e831f3e6	App\\Models\\Loans
9d68ea24-59c2-47bf-a555-1aef12f9edd0	App\\Models\\ItemLoans
9d68ea25-cafe-4f47-9628-8b1962a3fe1c	slow
9d68ea25-cb97-4f68-8a39-ef66d0d5ef09	App\\Models\\Menu
9d68ea27-00d3-41d5-9d40-2da5fab941bc	App\\Models\\Menu
9d68ea3f-6ee2-4678-b6bd-c5a7c8dcb905	slow
9d68ea3f-7261-4814-8494-47a896ce6000	App\\Models\\ItemLoans
9d68ea41-4b80-4d05-a35e-5cb9328cd188	App\\Models\\User
9d68ea41-f63e-4639-b8bf-a848c853dce5	App\\Models\\User
9d68ea42-cb24-4a12-bbc2-bbb49f684380	App\\Models\\Loans
9d68ea42-cf0a-4669-a261-85ee616aca02	App\\Models\\ItemLoans
9d68ea43-ee9d-4beb-bf0c-f5a47849a002	App\\Models\\Menu
9d68ea45-4509-4d2c-bf91-2b826214f578	App\\Models\\Menu
9d68ea7d-de0e-429b-a39c-b73d9dbaa91e	slow
9d68ea7d-e1eb-4428-88af-508acb463c43	App\\Models\\ItemLoans
9d68ea7f-1fab-42ec-aa8f-6fe522a0b0aa	App\\Models\\ItemLoans
9d68ea81-2a6e-40ea-8382-9598a39e60e1	App\\Models\\User
9d68ea82-7d05-4ee0-929f-531037c730fd	slow
9d68ea82-7d6d-4521-9896-cfda545747e1	App\\Models\\User
9d68ea83-2c39-49ab-a268-69694fce546c	App\\Models\\Loans
9d68ea83-2ea7-4f4e-904f-fe2abdafafbd	App\\Models\\ItemLoans
9d68ea84-adf9-478e-ae61-2453340754db	slow
9d68ea84-ae67-4aa3-b958-da8d5c9db3b3	App\\Models\\User
9d68ea85-8f9c-4e46-9857-d1e9d1f5dc01	slow
9d68ea85-8ff8-4ef5-bd03-da828bcc6433	App\\Models\\User
9d68ea86-27f1-468d-8961-d636a801059a	App\\Models\\Loans
9d68ea86-2a39-4b67-8d5c-210b4c27675f	App\\Models\\ItemLoans
9d68ea87-bbac-4f9c-ae8d-b4e439335038	App\\Models\\Menu
9d68ea89-02d3-4495-b4ea-01102f6424cb	slow
9d68ea89-032e-42a4-8c06-b35fbdbd7ea1	App\\Models\\Menu
9d68eaf3-1567-4d3e-80d4-eba063228790	App\\Models\\ItemLoans
9d68eaf5-46ac-4917-bf57-033f00b79191	App\\Models\\User
9d68eaf6-2174-4c61-817d-9d2d6fb20289	App\\Models\\User
9d68eaf6-daa4-4dad-8e85-6a50522b8746	App\\Models\\Loans
9d68eaf6-dcdf-4b1f-b595-8e6b03427fa5	App\\Models\\ItemLoans
9d68eaf8-074c-4e4a-bdef-490cc7c4a850	slow
9d68eaf8-07f2-4fb0-abdf-723b81808f90	App\\Models\\Menu
9d68eaf9-7af7-450a-9644-bc6783785528	App\\Models\\Menu
9d68eb61-dd98-4679-a87b-86baae1ad4a7	App\\Models\\ItemLoans
9d68eb63-ce01-4a61-b954-e5fbe7e5756e	App\\Models\\User
9d68eb64-dc45-422a-876f-1f4725e4b007	slow
9d68eb64-dcc7-4bd8-894f-aa21849d1387	App\\Models\\User
9d68eb65-aced-40e7-ab88-7e8a3a526bc6	App\\Models\\Loans
9d68eb65-b0a1-43f4-96ea-815560e6c06f	App\\Models\\ItemLoans
9d68eb67-2ce1-4ee8-87ae-c1cc1bb716cb	slow
9d68eb67-2d8b-42d2-b6a5-ced6a1d6ee00	App\\Models\\Menu
9d68eb68-5633-46b0-8d49-2783d79a7deb	slow
9d68eb68-56dd-442a-a56f-cc6fdfe81310	App\\Models\\Menu
9d68ebb5-465f-4c4b-bd45-4e36e66b6ae2	slow
9d68ebb5-4d23-43de-a9dd-5c06ed364711	App\\Models\\ItemLoans
9d68ebb7-9100-44b2-8f38-0fe4581dbb00	App\\Models\\User
9d68ebb8-5691-43fa-a485-9effbb9db1c7	App\\Models\\User
9d68ebb9-4f9e-4247-b036-c704e15d55d0	slow
9d68ebb9-5004-4361-a70e-00842c737dd9	App\\Models\\Loans
9d68ebb9-5290-444c-af13-817a4b7af8a1	App\\Models\\ItemLoans
9d68ebba-8148-4bcc-ab82-916e2fb6e184	slow
9d68ebba-81cb-4df7-a3e6-8218682bdbf1	App\\Models\\Menu
9d68ebbc-21d6-4837-acea-a13ae197098e	App\\Models\\Menu
9d68fe68-a122-4301-a3f9-198be9c1af96	App\\Models\\User
9d68fe6a-0910-42ea-ba71-daa4e8176ffd	App\\Models\\User
9d68fe6a-9f71-4b66-a211-daa19d7d8897	App\\Models\\Loans
9d68fe6a-aace-469d-b09b-9412725f7d4c	App\\Models\\ItemLoans
9d68fe6c-b704-4953-8a1c-844c8b55c901	App\\Models\\ItemLoans
9d68fe6d-ae7a-4049-8b5e-d83e7c687c9b	App\\Models\\Menu
9d68fe6e-a15d-416f-a693-39fff70c3e94	App\\Models\\Menu
9d68ff1c-4b5b-44d3-a1e3-d823a06708c5	App\\Models\\User
9d68ff1c-dc55-4263-9672-23e174d325e2	App\\Models\\User
9d68ff1d-aafe-4d6e-89ef-c573d4a5dcd2	slow
9d68ff1d-ab63-4131-be79-978115252549	App\\Models\\Loans
9d68ff1d-adc7-4e57-9da1-2748c0efb5d1	App\\Models\\ItemLoans
9d68ff1f-dc56-4224-b81b-89620028ba07	App\\Models\\ItemLoans
9d68ff20-df29-47a4-a988-c9c16054506e	App\\Models\\Menu
9d68ff21-e949-4780-aa2c-608930363ac4	slow
9d68ff21-e9fa-4fd6-a0b0-cfec657317da	App\\Models\\Menu
9d68ff42-508f-468e-aeb8-2b3852cdd74a	App\\Models\\ItemLoans
9d68ff44-397d-4055-994e-d6419d2f89be	App\\Models\\User
9d68ff45-00d9-4dff-855a-1b82f88d1b99	App\\Models\\User
9d68ff45-bbc6-4a5a-8edf-8eab2705e7d0	App\\Models\\Loans
9d68ff45-beae-48c3-b7ad-567772f459a1	App\\Models\\ItemLoans
9d68ff46-e261-4f16-8439-720aaafa0d6d	App\\Models\\Menu
9d68ff47-f30a-4ce1-bfb9-55d620847bf2	slow
9d68ff47-f373-45b4-ace3-ce0adbeb18be	App\\Models\\Menu
9d68ffbb-874c-4086-ac02-3a7e9478e86e	App\\Models\\ItemLoans
9d68ffbd-a8b1-41a0-8149-b897dc74372f	App\\Models\\User
9d68ffbe-745f-4004-bb05-468b70c1c08b	App\\Models\\User
9d68ffbf-6788-46a8-b2c8-d45d47524dfe	slow
9d68ffbf-67db-4d13-a490-fa257e8eeb8b	App\\Models\\Loans
9d68ffbf-69b5-44af-abc5-b92e7052a21c	App\\Models\\ItemLoans
9d68ffc0-a2d2-49ea-8345-f9e871053a2e	slow
9d68ffc0-a37a-45b2-80c4-3cfa7b077dd7	App\\Models\\Menu
9d68ffc1-e4f4-4713-bf6d-6853052c0d5e	App\\Models\\Menu
9d690055-c3b3-45be-add0-4ba17b32ed9c	slow
9d690055-c84c-46df-a680-fbae60b957d9	App\\Models\\ItemLoans
9d690058-920c-4e9e-9dc6-c82755a29a32	slow
9d690058-929a-419b-b4e5-f28f30100ae2	App\\Models\\User
9d690059-4ddd-4b43-80d8-ac732762b969	App\\Models\\User
9d69005a-0f9a-4929-8740-bf8870bb93c6	App\\Models\\Loans
9d69005a-12be-4a39-96d0-42651e2daa37	App\\Models\\ItemLoans
9d69005b-ae1c-4643-81e7-988bf672392e	slow
9d69005b-aecd-49ef-9408-db64cdd84fd3	App\\Models\\Menu
9d69005c-f23e-497a-bc71-ba3b56939611	slow
9d69005c-f2f9-4244-a563-95c0cb713f4d	App\\Models\\Menu
9d6900cd-8fbe-4900-975f-d276b1a11c67	slow
9d6900cd-973e-48b9-880d-8ef1f512904a	App\\Models\\ItemLoans
9d6900cf-c03b-4f8e-9bc6-bcbc964118d3	App\\Models\\User
9d6900d0-d313-4aec-91f9-a38693561e9e	slow
9d6900d0-d3d1-4173-bc61-b8b9c4881e21	App\\Models\\User
9d6900d1-a6fd-4cb5-87e5-be5048ea1833	App\\Models\\Loans
9d6900d1-aab8-4e5a-9985-b3a513cb83e6	App\\Models\\ItemLoans
9d6900d3-4877-48c1-b3af-93122dd4f1a5	slow
9d6900d3-4931-4ca1-8056-53f5b51fd9c3	App\\Models\\Menu
9d6900d4-9a93-4a3e-b386-be2d19336da9	App\\Models\\Menu
9d6900f1-f31d-4252-907b-b0c67db75c7e	App\\Models\\User
9d6900f2-88d0-4990-9c82-bac104cc8f39	App\\Models\\User
9d6900f3-47a3-463d-941e-4df99a591229	slow
9d6900f3-47f4-49e6-a3df-a5bc1d8d8e4d	App\\Models\\Loans
9d6900f3-4995-46ba-8a36-d564acabf885	App\\Models\\ItemLoans
9d6900f5-6d3b-474b-a97e-df89dcce23a3	App\\Models\\ItemLoans
9d6900f6-5023-425b-8f9f-891ba20e5588	App\\Models\\Menu
9d6900f7-1915-460b-b1c4-6651ea23dc39	App\\Models\\Menu
9d6901ab-2f83-4279-a910-7f8cd87aad90	slow
9d6901ab-33c4-4363-86c1-6f089f8ffa73	App\\Models\\ItemLoans
9d6901ae-04a5-42fe-bf23-dc921c88bec3	App\\Models\\User
9d6901af-1cc0-4044-97cc-58de40263dda	slow
9d6901af-1d71-4f3f-be80-48ec145f718f	App\\Models\\User
9d6901b0-12fb-47da-b59e-ed8df9dfa115	App\\Models\\Loans
9d6901b0-14ed-44c2-9601-79bd17fb9379	App\\Models\\ItemLoans
9d6901b1-226a-4e5f-b0b3-5b8c1c339242	App\\Models\\Menu
9d6901b2-480b-4106-8138-99737eca5353	slow
9d6901b2-48ba-46c2-8801-9625faa4b85c	App\\Models\\Menu
9d6901c2-5fb6-47b0-9125-69ae0dca6d89	slow
9d6901c2-63b6-44a6-94ca-54ff56d3bf00	App\\Models\\ItemLoans
9d6901c4-1e58-47fd-8536-f59147d84aab	App\\Models\\User
9d6901c5-00f6-45e5-a249-4020ca843520	App\\Models\\User
9d6901c5-a9ab-49bf-9e70-dca2a383e149	App\\Models\\Loans
9d6901c5-ac17-451c-8e96-c132b14df6f1	App\\Models\\ItemLoans
9d6901c6-bc6f-4e3c-8384-d53fe0b692a9	App\\Models\\Menu
9d6901c7-e754-44c3-89c3-f7324065936c	App\\Models\\Menu
9d6901e3-39c2-4c27-b445-f0f5add6e23d	App\\Models\\User
9d6901e3-ff67-41a5-bee5-6816184711cb	slow
9d6901e3-ffb6-4917-a982-212c9ebba534	App\\Models\\User
9d6901e4-94a7-45b3-ba94-f940fe955e70	App\\Models\\Loans
9d6901e4-966e-46ef-8eb9-5ab31fd0263e	App\\Models\\ItemLoans
9d6901e6-92c2-4d59-ae83-46d851cfa3d4	App\\Models\\ItemLoans
9d6901e9-fdb9-4a24-8007-c84238572e40	slow
9d6901e9-fe50-45e5-8091-65f9b9b53162	App\\Models\\Menu
9d6901eb-37d2-493a-9f01-034405443e42	App\\Models\\Menu
9d6901f3-2fe0-42a0-a98e-53f7fa29f53f	App\\Models\\User
9d6901f3-c510-42eb-8742-bad686447054	App\\Models\\User
9d6901f5-2bbe-4675-9ce8-b420930630bb	slow
9d6901f5-2c4c-498f-bfc2-1671cdfc1005	App\\Models\\Loans
9d6901f5-2f5c-49d7-9d8b-513a7b0042b8	App\\Models\\ItemLoans
9d6901f7-ea2e-4040-9375-eb22e3006de9	App\\Models\\ItemLoans
9d6901f9-5378-49ed-a69e-4016aa1df4a7	App\\Models\\Menu
9d6901fa-61b7-402d-b0ee-5682f18a0157	App\\Models\\Menu
9d6901fc-59e3-442f-ad20-132fc5a69d9b	slow
9d6901fc-5a46-46c9-9574-15769a2a6738	App\\Models\\User
9d6901fc-f54d-48b5-aaf0-24031ce1601c	App\\Models\\User
9d6901fd-9157-4ad7-8aad-9cb4dcff04b4	App\\Models\\Loans
9d6901fd-9315-45f1-9559-0149c54a4171	App\\Models\\ItemLoans
9d6901ff-7e95-46b5-a878-3364a170c4b8	slow
9d6901ff-8432-4064-8816-d8700eb40678	App\\Models\\ItemLoans
9d690200-b10d-44ab-a219-d6969a6e5af7	slow
9d690200-b1ca-4d00-9228-8043e711b306	App\\Models\\Menu
9d690201-b68b-47d4-a2b2-133ed5113959	App\\Models\\Menu
9d690215-9e03-4e3f-a140-26491269ecd1	App\\Models\\User
9d690216-5ced-4435-aefb-e3db3b33d53d	App\\Models\\User
9d690216-fa98-45d4-9f61-7b7a4808a848	App\\Models\\Loans
9d690216-fc96-4190-a61f-10a628d4a9db	App\\Models\\ItemLoans
9d690219-7e2c-4096-96f6-462e774f3e8a	slow
9d690219-7e95-4c73-b432-7896e3981eb1	App\\Models\\Menu
9d690661-455a-4629-b2cb-386c238edd09	App\\Models\\ItemLoans
9d690661-4819-4768-a791-4caab02a8038	App\\Models\\Loans
9d690661-5f8d-4063-ad1a-3dd8c925215f	App\\Models\\ItemLoans:367
9d690661-60a1-4446-b66f-525be0443c57	App\\Models\\Loans:89
9d690662-8f8c-4eb8-8240-f5de7fc0a05c	App\\Models\\ItemLoans
9d690710-83ad-418b-afc3-573389fa9d7d	slow
9d690710-8419-43e9-9407-4992ef4478e6	App\\Models\\User
9d690711-52e7-475a-8555-2baf92b94ad3	slow
9d690711-5343-44d2-81c3-220fb01d91f8	App\\Models\\User
9d690711-e576-4940-84f7-5316dbbd3ed2	App\\Models\\Loans
9d690711-e75d-4420-8a09-940b56d484cc	App\\Models\\ItemLoans
9d690713-ebb7-41d5-80e9-022af3b851c4	App\\Models\\ItemLoans
9d690715-6eb7-446c-8700-b6ae6cf59620	slow
9d690715-6f4c-423b-95d2-643818251893	App\\Models\\Menu
9d690716-c58a-4923-8629-f16013124564	slow
9d690716-c61b-4472-9ea1-e4da56a67ec2	App\\Models\\Menu
9d690736-9765-42a6-b7df-4d7d2c1eccea	App\\Models\\User
9d690737-2c80-45bc-b6b1-0f9a39d60abc	App\\Models\\User
9d690737-cbfd-4d60-b433-f008a4e9f22a	App\\Models\\Loans
9d690737-ce04-4681-8b18-bb80b24fcd9b	App\\Models\\ItemLoans
9d690739-a800-4829-8ef0-6c5480cd28a9	App\\Models\\ItemLoans
9d69073b-324a-496c-bfd7-9df0877cedcd	App\\Models\\Menu
9d69073c-3420-4cb7-a81d-aba6541baed8	App\\Models\\Menu
9d690767-9b7a-4bcb-a82d-896ea9818b07	App\\Models\\User
9d690768-2ca4-4898-8657-cf8520084913	App\\Models\\User
9d690768-bc2b-42fc-9b60-46ca2f3261ba	App\\Models\\Loans
9d690768-be35-4f65-b455-eafc1a9a89aa	App\\Models\\ItemLoans
9d69076a-b986-46d0-abc6-c2342e4bded8	App\\Models\\ItemLoans
9d69076b-dce1-4b4f-8193-4763887d8867	slow
9d69076b-dd94-48fe-96cd-254b423ab55c	App\\Models\\Menu
9d69076c-d04d-4fdc-8146-6fa7a6527169	slow
9d69076c-d0cb-4499-ac11-5b89a07ee675	App\\Models\\Menu
9d690833-25f5-472f-8bc5-2291407a6aeb	App\\Models\\User
9d690833-a343-4e5c-8bfb-7fc6eb2295e6	App\\Models\\User
9d690834-178f-4de7-a3ff-368f8ba59c52	App\\Models\\Loans
9d690834-19b3-4592-8807-e27129fc1c33	App\\Models\\ItemLoans
9d690835-bced-4189-9fbf-999294efb52c	App\\Models\\ItemLoans
9d690836-e363-4b06-8b8a-538f9e6da654	slow
9d690836-e3ff-41b9-a419-79b2a0ff2df1	App\\Models\\Menu
9d690837-c489-4032-be2a-965e950f7bbb	App\\Models\\Menu
9d690a2f-e2d1-4264-b4eb-70312bed12fd	App\\Models\\User
9d690a30-8f48-4d5f-8bfa-f7d3855845a6	App\\Models\\User
9d690a31-0bf9-4664-a2f3-5b551774898c	App\\Models\\Loans
9d690a31-0e65-4354-b297-7bd82b1d38ef	App\\Models\\ItemLoans
9d690a33-2229-472a-801f-f691d682445f	App\\Models\\ItemLoans
9d690a34-a188-4ceb-8794-eea68ea72a1a	slow
9d690a34-a218-481e-954e-d3b999c26216	App\\Models\\Menu
9d690a35-cd7a-4b7d-a03b-05221d8e573e	App\\Models\\Menu
9d690ad0-f4be-4bf0-bb43-51f2074d8be9	App\\Models\\ItemLoans
9d690ad3-7cbd-406f-a0cf-c40551fb6407	App\\Models\\Menu
9d690c7b-6571-4d1e-95cb-a383c495ff05	slow
9d690c7b-65e5-4f3c-a366-9a98b165d075	App\\Models\\User
9d690c7b-e142-472f-aa20-cfc118861849	App\\Models\\User
9d690c7c-5faf-4c9a-8460-2f544289911c	App\\Models\\Loans
9d690c7c-6217-419e-b381-3e22dbd1622f	App\\Models\\ItemLoans
9d690c7e-4015-499c-b683-e0dfae26e320	App\\Models\\ItemLoans
9d690c7f-a787-43f2-88b3-8e1b6d77712c	slow
9d690c7f-a80c-4f75-81ed-3a55dfdf185b	App\\Models\\Menu
9d690c80-a05c-47b2-827e-f9cb5aee046b	App\\Models\\Menu
9d690dc0-4a4f-4d2f-a1ae-92ef55703329	App\\Models\\ItemLoans
9d690dc1-333a-4fe1-8854-f82d51adb970	App\\Models\\ItemLoans
9d690dc2-d023-4473-98cd-dacc0131136d	App\\Models\\User
9d690dc3-8a2c-4d6a-af42-bb13326a1c27	slow
9d690dc3-8a96-43d6-8066-aa20d4d288ab	App\\Models\\User
9d690dc4-22b8-4e11-8f47-bc491da7d725	App\\Models\\Loans
9d690dc4-25f1-4961-88ff-375438e44685	App\\Models\\ItemLoans
9d690dc5-2a0c-4fbe-9441-37436d3fa354	App\\Models\\User
9d690dc5-92b8-4df5-a41b-0a5e20b67fe2	App\\Models\\User
9d690dc6-2d56-484e-83f0-e827e0ec8b97	slow
9d690dc6-2dd8-443a-8f03-a1f607ccf927	App\\Models\\Loans
9d690dc6-2fee-4cde-93cb-68fabdebf0cb	App\\Models\\ItemLoans
9d690dc6-e099-40b8-8512-4158db339c9b	App\\Models\\Menu
9d690dc8-457f-4776-b21f-de1e776544f7	slow
9d690dc8-45c8-4d03-a09a-aa8c2bb8621c	App\\Models\\Menu
9d690e50-1801-4678-b7d3-f5f21dc1a57c	slow
9d690e50-1cbc-493e-9fe7-00d3b55595c6	App\\Models\\ItemLoans
9d690e51-a2f6-414b-8ff6-003cbbd6a117	App\\Models\\User
9d690e52-5efe-4dd2-84ff-77e1baeb51f0	App\\Models\\User
9d690e52-f4b8-415f-9bfb-916b28bbf063	App\\Models\\Loans
9d690e52-f7ab-4d0b-960b-adeb1fc155b5	App\\Models\\ItemLoans
9d690e54-7c7f-4154-b9a3-eecac7ef4c84	slow
9d690e54-7d22-4b9d-aff7-7b238d0d32af	App\\Models\\Menu
9d690e55-5989-4dc4-84e8-2bb177193251	App\\Models\\Menu
9d690e68-9eff-4ae8-ad18-92869395ec21	slow
9d690e68-a35f-48af-a1cb-c1cdbb515f15	App\\Models\\ItemLoans
9d690e6a-2209-40ec-a5ac-4047e0aea359	App\\Models\\User
9d690e6a-f020-43dc-a879-dd55bd1618c2	slow
9d690e6a-f0a4-45e2-92ae-44b1a0ccfcf2	App\\Models\\User
9d690e6b-905f-4fc6-84cb-81e6edddc544	App\\Models\\Loans
9d690e6b-92c6-4b56-9082-e9cc92bf8599	App\\Models\\ItemLoans
9d690e6c-4f9e-42ed-8c1a-b97a1ec0be90	App\\Models\\Menu
9d690e6d-9c1f-4ca1-b6ca-d07eb84fcdf7	App\\Models\\Menu
9d690e9a-b315-4afa-8013-f3fe4f01c79e	App\\Models\\ItemLoans
9d690e9c-1cb3-4426-9e25-52e213bdd35a	App\\Models\\User
9d690e9c-e075-4fcd-8f47-55ad019050af	slow
9d690e9c-e0ed-4fdc-b6bb-5f110d33b557	App\\Models\\Loans
9d690e9c-e346-48ba-8619-a653323df7de	App\\Models\\ItemLoans
9d690e9d-847c-4b77-b434-14fb8807c79f	App\\Models\\User
9d690e9e-7789-4c97-ac02-0df6d0d87684	App\\Models\\Menu
9d690e9f-9a25-4d48-a680-a747276f8d68	App\\Models\\Menu
9d691293-407a-409d-b1d5-e79d1b11c9b0	slow
9d691297-ce99-4f0a-9c3e-26e627c0d6dd	App\\Models\\User
9d6912e1-ce40-4914-beed-80080713f714	App\\Models\\ItemLoans
9d6912e4-edae-41a9-ab71-84220fef39cf	App\\Models\\Menu
9d6912e5-964d-43d3-adb6-7e867315b4b2	App\\Models\\Menu
9d6912f9-d4b7-4ef2-985e-e173bf7a784e	App\\Models\\ItemLoans
9d6912fd-02ba-426d-9d3e-5660e29459cb	slow
9d6912fd-0341-4cb2-8b3d-bf991c459313	App\\Models\\Menu
9d6912fd-ae82-4721-8c6a-7ed7447013e2	App\\Models\\Menu
9d69136a-288c-4119-9255-16dfc496402f	App\\Models\\ItemLoans
9d69136d-c074-44c8-a3ad-8490dc7fdbc5	App\\Models\\Menu
9d69136f-0277-471f-ae52-1e31839b9081	App\\Models\\Menu
9d6913de-c677-4acf-b402-a2e6a53a518b	App\\Models\\ItemLoans
9d6913df-9f6a-4bec-9150-cbb7f74783c0	App\\Models\\ItemLoans
9d6913e2-b932-4ebb-b4d2-97de20e86c80	slow
9d6913e2-b9f3-4e00-9ca9-790e10b729cb	App\\Models\\Menu
9d6913e4-09f0-4224-81dd-a11d06006a45	App\\Models\\Menu
9d6913fd-3777-4768-8248-5cf9a7a47492	slow
9d6913fd-3b81-4f2b-b6e3-6eba3b3ac41f	App\\Models\\ItemLoans
9d691400-29f1-4819-a8aa-8fc5ff3fa8b4	App\\Models\\Menu
9d691401-0aaf-4063-8774-481e53a8540b	slow
9d691401-0b41-4d85-ba5b-4746be3bc265	App\\Models\\Menu
9d691413-a407-4322-9b36-f311ff1db0d5	App\\Models\\ItemLoans
9d691416-8630-4b56-aca2-29944c2bb3f5	slow
9d691416-86c1-4283-ba97-4f4658f5c65a	App\\Models\\Menu
9d691417-6140-46e8-9bec-42d6d82fcecd	App\\Models\\Menu
9d69141d-2aa5-4ec3-b3b3-18165793be56	App\\Models\\ItemLoans
9d69141f-d3fc-4b27-84c8-0f099ea70373	App\\Models\\Menu
9d691420-646c-4c0a-9242-19980320803a	App\\Models\\Menu
9d691810-487e-4e23-9b30-3ff868a5c503	slow
9d691810-5004-461f-a978-a118606274da	App\\Models\\User
9d691813-c322-4789-96d4-6ad492e0b0fe	App\\Models\\User
9d691816-1206-46af-a871-88a7c0041512	slow
9d691816-1264-4064-aeb3-870bfae60cd6	App\\Models\\Menu
9d69188f-da33-43df-b6a2-f0455d6fa9a4	App\\Models\\ItemLoans
9d691891-b4a3-4350-84ef-36e0b4562513	App\\Models\\User
9d691892-cb06-4a05-bf91-90cd0d4da634	slow
9d691892-cb94-4f6e-be0b-90ee852da93b	App\\Models\\Menu
9d691894-1552-46be-9a16-1a1020ed18fb	App\\Models\\Menu
9d691942-d6d7-43f4-9c6f-9f59e608c4d0	App\\Models\\ItemLoans
9d691944-96a9-4d5b-a785-4ced5ce9256e	App\\Models\\User
9d691945-8af5-4e57-9ee7-58d350f6c869	App\\Models\\Menu
9d691946-826d-45ed-9009-63d924156aa5	slow
9d691946-8319-49bc-a146-e8da6340aae9	App\\Models\\Menu
9d692448-639d-40a7-bcf2-51cef8ad36d0	App\\Models\\ItemLoans
9d69244b-c87a-4666-9caa-013352356c17	App\\Models\\Menu
9d69244c-7c4a-4dc4-9c6f-729fb6d42cfe	App\\Models\\Menu
9d69245a-d5b5-4707-bf84-620c66c0fcc5	App\\Models\\ItemLoans
9d69245d-b4b7-4fed-9b27-4d6391773f3f	App\\Models\\Menu
9d69245e-af6c-4e67-a8d7-3f4108e02235	App\\Models\\Menu
9d69246e-aa34-4f18-aef3-f9a4c0d3d805	slow
9d69246e-ae39-4bfd-b124-cf6e0a53ab31	App\\Models\\ItemLoans
9d692471-e5db-4d8d-9781-b5df2e3bf632	slow
9d692471-e664-498e-b866-7c251428eace	App\\Models\\Menu
9d692472-aa8f-4d5e-a69a-33875eb7aed8	App\\Models\\Menu
9d692474-0a6d-41e3-9cad-f7cbd0af8b90	App\\Models\\User
9d6926ca-5fda-4c9f-a686-aa26d40e92c5	App\\Models\\User
9d692810-51fd-4a63-a51f-4acee4b8cb1a	App\\Models\\ItemLoans
9d692811-8fc8-4928-8131-ca27007b2cb5	slow
9d692811-9484-4390-af69-d9d047f934c9	App\\Models\\ItemLoans
9d692816-0c90-45cd-bfe5-66e9dbbae544	App\\Models\\Menu
9d692816-d840-4ff5-b2c3-85f1a5697579	App\\Models\\Menu
9d692821-bc7c-482d-ad6d-dcafd7d471fa	App\\Models\\ItemLoans
9d692825-3dcc-4e37-a11a-f3e2848a5cd6	slow
9d692825-3e3e-40c1-afdb-349f8572aee2	App\\Models\\Menu
9d692827-1410-4f71-939d-0b29fc09b455	slow
9d692827-147c-4ace-9b61-a53c76f86173	App\\Models\\Menu
9d6928fe-97c3-451d-87ee-cc747a497273	slow
9d6928fe-9c36-405b-bbee-ac06594a9ace	App\\Models\\ItemLoans
9d692900-7c91-48ce-b734-07070f5f789c	slow
9d692900-7d1d-4869-b60f-2c923f2be5ed	App\\Models\\User
9d692901-775a-44c0-9b11-9399ed6f45b9	App\\Models\\Menu
9d692902-ae2f-498a-9cd5-df943849cc3e	App\\Models\\Menu
9d69293f-14a4-4982-89b6-4226cdde7fbe	slow
9d69293f-1938-4067-90d3-169d95e8e90b	App\\Models\\ItemLoans
9d692940-e809-488d-9e1e-0729d3dd1f97	slow
9d692940-e8b2-4379-a95b-2ce794dee181	App\\Models\\User
9d692942-9223-4d82-8ac3-d59dd266ea43	App\\Models\\Menu
9d692943-9a3c-4b5f-918e-bcbfc018ef29	App\\Models\\Menu
9d6929ca-2ff4-4db9-b4c7-aecf1c2cf9c8	App\\Models\\ItemLoans
9d6929cb-c080-476a-b2fc-a010d6bfbc46	App\\Models\\User
9d6929cd-2009-469a-8a67-125b646a5369	App\\Models\\Menu
9d6929ce-2e0e-46be-a4a5-5a7fdfc036e2	slow
9d6929ce-2e91-4f32-acdc-d146d967211c	App\\Models\\Menu
9d6929f8-0de5-4027-9f83-d731188a2472	App\\Models\\ItemLoans
9d6929f9-9967-4ea6-9687-4375d6d92f8c	App\\Models\\User
9d6929fa-f174-4c80-b902-6d2290d41d04	slow
9d6929fa-f204-455e-855f-b374d0ff770f	App\\Models\\Menu
9d6929fb-fc6d-4535-bf77-b155dcd65f01	App\\Models\\Menu
9d692a0b-c614-482a-9739-66adf9f357b2	App\\Models\\ItemLoans
9d692a0d-67fa-4960-8757-f99ae7bfc35e	slow
9d692a0d-6892-4cd1-a52f-a051d7995f84	App\\Models\\User
9d692a0e-f000-4b16-b2c0-9a6f9157e305	slow
9d692a0e-f08b-4242-90f3-c9b18a049e57	App\\Models\\Menu
9d692a0f-c9a9-4148-a4be-366dbac423d3	App\\Models\\Menu
9d692a84-e122-4ff2-9d74-ca122fdb0ad5	App\\Models\\ItemLoans
9d692a86-57eb-48cd-a250-305aa306f00b	App\\Models\\User
9d692a87-60f9-4d67-87e1-f489a6981d9a	slow
9d692a87-61a3-44ce-94b8-7bd807004440	App\\Models\\Menu
9d692a88-778f-45a7-a5f4-7fb3dc86d638	App\\Models\\Menu
9d692a9e-349f-4458-91f2-d9c6726abf01	App\\Models\\ItemLoans
9d692a9f-9d52-4f9c-9566-6959214c48fc	App\\Models\\User
9d692aa1-7995-41ce-933c-38ffbbcc7795	slow
9d692aa1-7a32-4f15-afd4-c6ea556721e2	App\\Models\\Menu
9d692aa2-8613-4a1f-a1bd-97b296927aa3	slow
9d692aa2-869a-44c2-8fd0-83804c1b02ce	App\\Models\\Menu
9d692af3-b35f-4426-b4a0-ac929d05c4cf	slow
9d692af3-b738-4855-a29b-52c6be3251b5	App\\Models\\ItemLoans
9d692af6-0ee1-4405-beed-9f415c103137	App\\Models\\User
9d692af8-89cb-412d-90f7-fc9a83ff0c9f	slow
9d692af8-8a6b-4ccf-8a61-10105f10f638	App\\Models\\Menu
9d692af9-9c56-4570-859b-bc2a59090c4e	App\\Models\\Menu
9d692b18-3d6c-4b16-8b16-d4977de46320	slow
9d692b18-41c3-4d43-b933-6f8e96b60e74	App\\Models\\ItemLoans
9d692b19-1b1a-45d8-a1da-f52d7431899f	App\\Models\\User
9d692b19-fb9a-465c-9e6b-51239f87b3f2	App\\Models\\ItemLoans
9d692b1b-7088-40b0-8836-dcf53d367d31	App\\Models\\User
9d692b1c-8f42-48df-8a3f-d1f25cf45109	slow
9d692b1c-8fda-4e39-85b0-a2ba7ca098ee	App\\Models\\Menu
9d692b1d-d670-46b9-bc02-70438f9fb8e7	App\\Models\\Menu
9d692bdd-a9ad-4439-b53f-b42409d71e70	App\\Models\\ItemLoans
9d692bdf-4bc3-4e29-861e-2842bc259d20	App\\Models\\User
9d692be1-0e98-4f51-aa9d-75012a9428ed	slow
9d692be1-0f46-4789-9287-194237663ef7	App\\Models\\Menu
9d692be2-0d72-4290-8a65-e8e490d3ec51	App\\Models\\Menu
9d692bf2-16fb-439b-828a-4cd2ebdfaefd	App\\Models\\ItemLoans
9d692bf3-8ac5-4be9-9a31-d677a7e1ad6a	App\\Models\\User
9d692bf4-b931-4bfd-abfe-569b8048ffcc	App\\Models\\Menu
9d692bf5-c655-4dfb-95c8-93bd188f406d	App\\Models\\Menu
9d692c05-8c98-416f-8a08-9928eb519449	slow
9d692c05-90ec-4f24-8161-e17db686a7af	App\\Models\\ItemLoans
9d692c06-ffcc-4d9b-b566-0bcb5ada8e92	App\\Models\\User
9d692c08-37b7-4cf6-a649-f6f9309d8d42	slow
9d692c08-386b-45b6-ba92-868e3d38146a	App\\Models\\Menu
9d692c09-34fc-4e8b-ac11-14be3a22b304	App\\Models\\Menu
9d692c15-bb2e-4928-893f-1fe29c807d2c	App\\Models\\ItemLoans
9d692c17-31f6-4543-a428-99db9d899e1d	App\\Models\\User
9d692c18-226f-463b-8d06-2a5636f89d64	App\\Models\\Menu
9d692c19-e182-412c-974a-1d1ec76f7be5	App\\Models\\Menu
9d692c27-81f1-474d-8ac1-79dd0697f5b7	App\\Models\\ItemLoans
9d692c29-2086-4176-a5ab-3c8b1bb756a5	App\\Models\\User
9d692c2a-5ff3-41ce-851d-2b98caec5fd0	App\\Models\\Menu
9d692c2b-5851-481f-a1d4-8e2ada643daf	App\\Models\\Menu
9d692d72-bcbb-47ab-9f49-e2021d2550f9	slow
9d692d72-c0ed-4f71-9cf2-cd77e3bb44eb	App\\Models\\ItemLoans
9d692d74-4070-4112-91b0-a8f9ba6457e1	App\\Models\\User
9d692d76-05e1-45fa-822d-58840d151e29	slow
9d692d76-0662-412b-9bd1-c492a5a334cf	App\\Models\\Menu
9d692d76-dc03-45ed-b44c-d68fef75d044	slow
9d692d76-dc90-4799-ad0a-76fd3d7b508b	App\\Models\\Menu
9d692db4-16cc-4aea-aec5-47fa2cea8ad7	App\\Models\\ItemLoans
9d692db5-8429-42ce-84ff-8b9a69315020	App\\Models\\User
9d692db6-6ed4-42ed-8a62-8d1a8bda376e	slow
9d692db6-6f5d-4e24-90d3-815ec41dbd09	App\\Models\\Menu
9d692db7-8f2f-4ffc-aa83-40848cacea8a	App\\Models\\Menu
9d693300-9de9-4ca6-bb71-7694be0b8231	slow
9d693300-a35f-4c11-9986-3894b9e65ab4	App\\Models\\ItemLoans
9d693302-6b08-488f-83ec-7864d89c5590	slow
9d693302-6bb2-4ee4-ac0e-ecf1a0c5eff5	App\\Models\\User
9d693303-7b77-4dac-bec4-d87c53d427ae	App\\Models\\Menu
9d693304-4fd1-4a0b-b9af-6d88ca706614	App\\Models\\Menu
9d69336f-2e5f-4c64-9677-15e2224efb7f	App\\Models\\ItemLoans
9d693370-e5bc-4fae-b651-8a45769fca65	slow
9d693370-e65e-4d05-98ec-2bb1e5761ac0	App\\Models\\User
9d693371-e9d7-4fd4-97d0-84b191592dfd	App\\Models\\Menu
9d693373-57ec-4975-89d7-712f459e0a78	slow
9d693373-588e-4b70-bd0f-f968fb067344	App\\Models\\Menu
9d69337c-676d-4689-b86b-06cb17a56324	slow
9d69337c-6bd3-4e51-a8cb-27e97b696989	App\\Models\\ItemLoans
9d69337d-fc59-4381-895f-a3424486cfe4	App\\Models\\User
9d69337f-2f70-430e-8c9f-947c3dc0deb8	slow
9d69337f-300f-4a37-8c9e-8754279311a8	App\\Models\\Menu
9d69337f-ecf7-435e-aed8-677ca1533eaf	App\\Models\\Menu
9d693448-a5bd-4401-976f-fd643cdd07e6	App\\Models\\ItemLoans
9d69344a-48e7-4f4f-8df1-14a06fc2911a	slow
9d69344a-4977-4690-8ddb-b2640731164f	App\\Models\\User
9d69344b-ac94-49d4-a3a0-8ffdedb1a1c1	slow
9d69344b-ad26-44bf-8bf4-38b0e062e7d3	App\\Models\\Menu
9d69344c-c167-4d6d-9685-5a44d0e77fca	App\\Models\\Menu
9d693484-9ab2-477d-82ac-baebb4368de2	App\\Models\\ItemLoans
9d693486-3c7b-4533-bca2-b7dbf1b6ae70	App\\Models\\User
9d693487-45d4-459d-8dc9-6d10c18f3460	App\\Models\\Menu
9d693488-23e9-4c6e-8eb9-4d4b4eaa8dd7	App\\Models\\Menu
9d693595-4984-48d5-bd52-3d487339c580	App\\Models\\ItemLoans
9d693596-dad0-47b7-b3e7-5363e6917bc2	App\\Models\\Menu
9d693597-7ed4-4225-b05d-8296e961bc1c	App\\Models\\User
9d69359a-04f9-45b5-8b23-5eb0941b8d67	App\\Models\\Menu
9d6936fe-3f4c-4dda-94cd-8ec2ee4d3f2d	App\\Models\\ItemLoans
9d6936ff-e11e-4d1a-a1a2-1709f3f66e5f	App\\Models\\User
9d693701-9692-4a2a-9d73-465123f53a3c	slow
9d693701-9747-4c1c-8cb2-c973c1cca461	App\\Models\\Menu
9d693702-f130-413f-b820-c4394b02b147	slow
9d693702-f1c0-4704-b57f-29e82ea3523d	App\\Models\\Menu
9d69379f-ad14-4b64-a60a-61299983a736	slow
9d69379f-b14b-4362-af42-7ea5b8a76a2b	App\\Models\\ItemLoans
9d6937a1-3252-40a2-8dd3-1685ee1457e4	App\\Models\\User
9d6937a2-a6db-43f9-803f-b317ea496df3	slow
9d6937a2-a773-450d-9f4e-7f6fb65e1097	App\\Models\\Menu
9d6937a3-8986-4c4a-ad46-dca98aef6e6f	App\\Models\\Menu
9d69397e-c255-42c9-9691-5c5fe27e1b81	App\\Models\\ItemLoans
9d693980-3648-4548-955a-35378aa00ff3	App\\Models\\Menu
9d693980-f34b-423e-8021-d5fa8d0777f7	App\\Models\\User
9d693983-4ce1-48db-8c8b-23851e896c5d	App\\Models\\Menu
9d69398c-32c2-464c-8aef-0aee8c7fb005	App\\Models\\ItemLoans
9d69398d-abf8-445e-bba3-e38708f5ab2b	App\\Models\\Menu
9d69398e-55b7-4778-a47b-4fe2d75a513f	App\\Models\\User
9d693990-be6f-4e42-9dc8-27727f442482	slow
9d693990-bef5-469d-a3e5-0c7b57e1bb8d	App\\Models\\Menu
9d693bca-eb38-4730-be4d-e66d069c02b7	slow
9d693bca-eb9a-4bf2-a624-f03c27643c79	App\\Models\\User
9d693c23-6517-4001-ada8-c86595581b36	slow
9d693c23-6584-4ccf-8b12-d41e52ca25ff	App\\Models\\User
9d693c40-5c60-408d-8739-a974bdee9326	App\\Models\\User
9d693c40-6452-4bfe-96b4-d40d07a4fc42	App\\Models\\User:12
9d693c43-e004-42a0-b98d-389f5016938d	slow
9d693c43-e05c-4ae7-b1e0-4f1eb90d7daa	App\\Models\\User
9d693c45-efb6-4e3b-9494-0fe00d8ef7d2	App\\Models\\Menu
9d69c227-ed60-4b51-9eaf-9f54b0cc8002	slow
9d69c227-edb3-4cf7-9e19-77b00066856e	App\\Models\\User
9d693cea-5096-4e11-b294-f09a1bb27c19	App\\Models\\User
9d693cec-42b8-4744-a952-42aa77004f9c	App\\Models\\Menu
9d693d50-64ce-4a1f-9486-f890a435941d	App\\Models\\User
9d693d50-66ed-4a88-969d-866939dbcdfc	App\\Models\\User:12
9d693de6-0131-4ecf-9aeb-4521efceae53	slow
9d693de6-0651-4327-b7d1-1566b5674a18	App\\Models\\ItemLoans
9d693de7-9859-4f30-a6fd-396a3ca0c6ef	App\\Models\\User
9d693de9-6cd9-420d-883b-8e5519d3e8ac	App\\Models\\Menu
9d693dea-622d-4d4b-83e3-abb22ba9380f	App\\Models\\Menu
9d693f8f-ee31-4284-a8b8-2da856213293	App\\Models\\User
9d693f92-211a-45da-a759-06fab4c645d9	App\\Models\\ItemLoans
9d693f93-022b-4b61-ac9c-d75f5bc32c98	App\\Models\\Menu
9d693f94-1431-443e-bb43-a5d67ecba46c	App\\Models\\Menu
9d693faa-639a-4713-8409-76c1b45b0a21	App\\Models\\User
9d693fac-f2f5-4950-bcad-01126808a129	App\\Models\\ItemLoans
9d693fad-d4fb-4fce-b463-6e156f3e9fe1	App\\Models\\Menu
9d693fae-ea6e-45cb-8e2e-df2b5849edae	slow
9d693fae-eae7-4a1c-8fe2-2bb434dfc151	App\\Models\\Menu
9d693fb3-716d-4d74-9523-cc203c7c202a	App\\Models\\ItemLoans
9d693fb4-e22f-474d-bb2c-13ec8b9e6b85	App\\Models\\User
9d693fb7-045b-461e-a664-1d84a13ffcda	App\\Models\\Menu
9d693fb7-c446-43fd-b5c4-4d49ce8246cb	App\\Models\\Menu
9d693fd1-e27d-4f8a-a2ee-9e8536801033	slow
9d693fd1-e62f-47f0-8ec9-1936a155344e	App\\Models\\ItemLoans
9d693fd3-539c-42a7-96d7-466d9c7b0148	App\\Models\\User
9d693fd4-ae3c-4662-af69-ffee286da80f	slow
9d693fd4-aedf-4483-942a-a8047cd05dcb	App\\Models\\Menu
9d693fd5-c4ad-4691-8c80-c241b2d3975d	App\\Models\\Menu
9d693fdc-5b7f-4227-b83f-6a22f9a6c47c	App\\Models\\User
9d693ff4-f182-4ae0-9569-f577ce91dba0	App\\Models\\User
9d693ff4-f33c-49ca-a0b1-2adf5016c9cd	App\\Models\\User:12
9d693ff9-dcc1-47b4-876d-681668d0ab6d	App\\Models\\User
9d693ffb-a012-4cbb-a225-1a4f0df32f8e	slow
9d693ffb-a066-4144-9998-dfd092ad0600	App\\Models\\Menu
9d694067-6444-461c-829f-77f4436e1521	App\\Models\\ItemLoans
9d694069-3133-40cc-8fb6-607a86376d74	App\\Models\\User
9d69406b-3062-434a-a748-a7d8017aa295	App\\Models\\Menu
9d69406c-6412-4cab-ac86-b5e4a5e3d095	App\\Models\\Menu
9d694125-1f44-453a-a0dc-77eded7eb2a2	App\\Models\\ItemLoans
9d694126-d81e-45ef-801c-cf28ce92aec6	slow
9d694126-d8b5-4b29-8be7-3210087203ce	App\\Models\\User
9d694128-13b5-49de-a2bf-eadb64159a48	slow
9d694128-148b-4cee-b87d-8b40e733a424	App\\Models\\Menu
9d694129-3318-48c4-966a-8101fbcfb053	App\\Models\\Menu
9d694139-c316-46a5-8293-0c06d480adb9	App\\Models\\User
9d69413a-289e-4ef3-b039-a4feca2ef5aa	App\\Models\\User
9d69424f-e4db-4db9-a141-7db669435618	App\\Models\\User
9d694250-5d08-4289-959b-7d9d0e05ec0b	App\\Models\\User
9d694252-d83e-45bc-9f77-37769f70f5af	App\\Models\\ItemLoans
9d694254-25ad-4060-aa2f-ed7df694ec54	slow
9d694254-2646-488e-b3bd-1dfcda7c45b7	App\\Models\\Menu
9d694254-ce1c-4033-9ae8-cd696cf6e520	App\\Models\\Menu
9d69427a-0dcc-431b-9102-62c254179fcd	slow
9d69427e-efe5-46e8-85d6-f61fbc363604	App\\Models\\User
9d694314-9064-40f9-babb-d517f4778b2e	App\\Models\\ItemLoans
9d694315-ee4c-497e-90c2-4ab318379491	App\\Models\\User
9d694316-8ec0-41a3-b9ad-bd2b4d213362	slow
9d694316-8f46-4bbc-acdc-cff828976b5c	App\\Models\\User
9d694317-696f-4ea4-bf42-b0b1ee214973	App\\Models\\ItemLoans
9d694319-1383-433d-af87-618493a2e983	slow
9d694319-1417-40c1-8ccf-1aa8cd401989	App\\Models\\User
9d694319-d015-438d-abde-b306eacdfb0b	App\\Models\\Menu
9d69431a-798f-4a5a-a54f-e4af38be0734	App\\Models\\User
9d69431c-9043-40f5-b53c-a8b99503656f	App\\Models\\Menu
9d694320-6c94-41c2-a17f-dae2ceaae2f4	slow
9d694324-60f7-4e04-ae35-e73169c4f0e6	App\\Models\\User
9d694347-bddd-4e21-81a3-16f3cccf500a	App\\Models\\Loans:91
9d694347-c3dc-4632-b0f9-3faf92e6db67	App\\Models\\ItemLoans:
9d694347-c485-4d72-b68d-db1d2d4e20d2	App\\Models\\ItemLoans:
9d694347-c513-4da3-9b5f-d043d396f10e	App\\Models\\ItemLoans:
9d694347-c5a0-4401-a9c3-7de549793fae	App\\Models\\ItemLoans:
9d694347-c62c-40e2-95fb-8669a67c6e11	App\\Models\\ItemLoans:
9d694347-c6ba-421f-a5d2-a0f443044a41	App\\Models\\ItemLoans:
9d694347-c73b-4461-a057-d1bfffbd759b	App\\Models\\ItemLoans:
9d694347-c7bd-4639-80f8-ac2ec01cf42a	App\\Models\\ItemLoans:
9d694365-b0b9-4df1-8d5c-e50adbe11a78	App\\Models\\ItemLoans
9d694398-d2f4-4cb5-8443-a0e7ef7c4b97	App\\Models\\ItemLoans
9d69439b-002d-4982-bd8b-c4313aeef9de	App\\Models\\Menu
9d69439b-bd62-45b8-be5d-228c4d1b83e7	App\\Models\\ItemLoans
9d69439e-c0a9-47ff-9da1-6e722800f624	slow
9d69439e-c15a-4364-a30e-885ced65fa51	App\\Models\\Menu
9d69440a-9eeb-40ff-bf7e-bb1b5762d95f	App\\Models\\ItemLoans
9d69440c-883d-4772-b4e5-1daa3942c524	slow
9d69440c-8fe5-4f12-9968-53953c0cedc4	App\\Models\\ItemLoans
9d69440e-b8a4-4131-92b5-7a9eaaf55a6f	slow
9d69440e-b929-4bdf-adb4-8ad4a4bea989	App\\Models\\Menu
9d69440f-f969-48ba-94ec-0f5bf2b4a5d2	App\\Models\\Menu
9d694439-0831-4138-8feb-957ed4b65430	App\\Models\\ItemLoans
9d69443a-7a00-4fe6-a802-9566bf1edcbe	App\\Models\\ItemLoans
9d69443b-f300-476d-b124-26ade564be4c	App\\Models\\Menu
9d69443d-178c-4586-aeae-1e778b1c023f	App\\Models\\Menu
9d694488-5d3c-45ac-a910-9397847dccec	slow
9d694488-5db1-4e1a-aea3-8238e25933a2	App\\Models\\User
9d694489-0501-47f0-b557-eb3b94c43bfc	App\\Models\\User
9d6944e7-b5a8-4df2-b7ab-51e914399915	App\\Models\\ItemLoans
9d6944e9-7c51-48fe-a80b-03f2d211ecc3	slow
9d6944e9-7cdb-427e-929d-5221d6e1c65e	App\\Models\\User
9d6944ea-301a-4564-9543-b49d926c2636	App\\Models\\User
9d6944eb-6956-4a9a-88b2-f0b84ce478d5	App\\Models\\Menu
9d6944ec-a42b-4402-870b-aa05c95211d0	slow
9d6944ec-a4d6-4470-b041-f8ee76c152f6	App\\Models\\Menu
9d69450b-b790-48c0-bfee-b2600776b1ca	App\\Models\\ItemLoans
9d69450d-8f4f-4dbb-8667-86a99a1a53a4	App\\Models\\User
9d69450e-3e31-4437-9212-1fba33bc1a4a	App\\Models\\User
9d69450f-33ff-49ad-a02d-8f0794f2aa7f	slow
9d69450f-34a7-4f16-93f4-1819a12456f5	App\\Models\\Menu
9d694510-8878-4b7d-858f-2f8f98fca99c	slow
9d694510-8907-4a43-b6cb-076b477fd5bb	App\\Models\\Menu
9d69452d-fb62-4a90-b0ee-62afea56a3ca	App\\Models\\User
9d694562-1db1-47ef-86de-2bb39ee1c864	App\\Models\\Loans:92
9d694562-1f6a-430f-b2da-873d458cf4c8	App\\Models\\ItemLoans:
9d694562-1ffc-4ec5-b3e4-40ff2b3fc2df	App\\Models\\ItemLoans:
9d694562-2089-49c4-b4bd-8093be43ef89	App\\Models\\ItemLoans:
9d694562-2117-4b9f-8d3f-7426abbab235	App\\Models\\ItemLoans:
9d694562-21c9-4bef-b8ec-6dd04a8b3def	App\\Models\\ItemLoans:
9d694562-225f-42d2-9958-d722d3fa765a	App\\Models\\ItemLoans:
9d694562-22e5-46d4-b872-6a0a46ef207a	App\\Models\\ItemLoans:
9d694562-2369-4a1a-abd5-3d002a5edbde	App\\Models\\ItemLoans:
9d694562-2458-4cc9-811b-3a34b19243f5	App\\Models\\ItemLoans:
9d694562-2514-4146-b3aa-134ee7dd5db4	App\\Models\\ItemLoans:
9d694562-25ba-4f5f-9505-c8ac4e8abaa8	App\\Models\\ItemLoans:
9d694562-267f-4e76-9dfc-1dc3a18a0c40	App\\Models\\ItemLoans:
9d694562-274c-47cb-a07c-c25b384ce719	App\\Models\\ItemLoans:
9d694562-2811-40f6-a59e-0984afeee03b	App\\Models\\ItemLoans:
9d694562-28b4-4e23-8a02-c86ad4bb442b	App\\Models\\ItemLoans:
9d694569-4380-445b-bcba-97f3df904aec	slow
9d69456f-0da3-47b4-a368-ae08b419e15e	App\\Models\\ItemLoans
9d6945e5-b7f1-4d87-ac89-7b2efb645769	App\\Models\\User
9d6945e6-1e8b-4012-b311-a4a6a8e69363	App\\Models\\User
9d6945e7-bd2c-4b7a-a3a9-3cd30fdb9e10	App\\Models\\ItemLoans
9d6945e9-602c-4122-8b66-5b3f853332c5	slow
9d6945e9-60b7-4f51-81c0-6be284762580	App\\Models\\Menu
9d6945ea-5769-4c3c-b18f-33a39bc20551	App\\Models\\Menu
9d69465d-c282-4526-aabb-f6c4dc1c0369	slow
9d69465d-c2fb-48e2-a5e9-e50cbd443b21	App\\Models\\User
9d69465e-604a-41cf-87f9-640b11d27188	slow
9d69465e-60a8-42c7-adc4-aa941b934307	App\\Models\\User
9d69465f-ea59-4a1f-a56c-deac4cd97ea1	App\\Models\\ItemLoans
9d694661-5976-4b29-9d03-395222347485	slow
9d694661-5a2d-4982-959c-6fd9c3c7d545	App\\Models\\Menu
9d694662-bf6b-4c4a-99fb-a8de6757b0c9	slow
9d694662-bffa-4bd7-be73-ebe5298675dc	App\\Models\\Menu
9d69466e-2cd8-4f5a-a9ca-3a9bcd062ec0	App\\Models\\ItemLoans
9d69466e-2eb4-4821-b479-8a1ce5af7f19	App\\Models\\Loans
9d69466e-30b3-4281-941a-5b23ae4b3fb1	App\\Models\\ItemLoans:379
9d69466e-31a1-41e2-8ae9-a85b4fbccffa	App\\Models\\Loans:92
9d69466e-a3d0-45e8-ad32-bbe79f511632	App\\Models\\ItemLoans
9d69c228-7acd-40f0-8ac0-546b9eac057f	slow
9d69c228-7b23-407c-9465-29c44dd59071	App\\Models\\User
9d694694-757f-42ce-9a71-4b9939fab74f	slow
9d694694-79f6-4d8c-a312-fe572f9b8dbe	App\\Models\\ItemLoans
9d69c2e3-8df2-4cd1-81e0-b4d74f4c4966	App\\Models\\User
9d69c2f7-a8a0-456f-a969-7572e60458eb	App\\Models\\User
9d6946ac-ba74-41ab-bb1a-c3a26dfe4b09	App\\Models\\ItemLoans
9d6946f8-3848-4552-a9f3-7c11ea903ee3	slow
9d6946f8-38a3-4b37-b1f4-180afae4a6eb	App\\Models\\User
9d6946f8-b0c8-4eea-bdca-110df0ea9c3b	App\\Models\\User
9d6946fa-37e6-4792-ade6-2f4e57228ccb	App\\Models\\ItemLoans
9d6946fb-9331-43bc-a877-f24c35e42438	slow
9d6946fb-93e2-4a5e-85c3-4e4814f0e639	App\\Models\\Menu
9d6946fc-92fd-40bf-a7e0-8fe27d310179	App\\Models\\Menu
9d69c3af-e138-4a44-9774-782925c9c30c	App\\Models\\User
9d69c3ee-0c2f-4d20-9bdf-cb06c62258fe	App\\Models\\User
9d694706-d1a3-4351-a0a1-842e0c1061db	App\\Models\\ItemLoans
9d694922-1c77-485e-b4fa-8378bf67b1cf	App\\Models\\ItemLoans
9d694924-9897-4bba-b0e4-a63384d177c3	App\\Models\\Menu
9d69494c-f01a-4cb2-9c38-b4de302e12fb	App\\Models\\ItemLoans
9d69494f-2945-4e07-bbd6-775270798f9e	App\\Models\\Menu
9d6949b9-eee1-4946-b366-159f21510570	slow
9d6949b9-ef3f-4c14-9e6e-844da833f295	App\\Models\\Menu
9d6949fa-adaa-4527-8691-fa728c0ff501	App\\Models\\Menu
9d694a29-7b50-4371-88e4-197f4ef049c7	App\\Models\\Menu
9d694aa3-6745-45d0-9979-000470b927f6	slow
9d694aa3-67af-40e9-a84e-af956e54a37d	App\\Models\\User
9d694aa4-4b56-47b9-8115-a90c027ec3c2	App\\Models\\User
9d694aa6-b042-48d6-a3b8-8f03dae07bad	App\\Models\\Menu
9d694aa9-9794-425d-ac5d-13bb480d1944	slow
9d694aab-30e1-4f96-bb34-a763617608e8	App\\Models\\Menu
9d694b0b-b6b4-4896-90cc-405e2d179034	App\\Models\\Menu
9d694b8d-8a3a-4325-be1c-0965122b6a57	App\\Models\\User
9d694b8d-f42b-4e0b-a5fa-565082301162	App\\Models\\User
9d694b91-8905-4a39-a875-7ef45b6571be	slow
9d694b91-8994-4b7a-bbe8-30706292520b	App\\Models\\Menu
9d694b94-032e-4204-8fc0-6f7676b95293	slow
9d694b94-03d9-4c47-90b6-4847fde56f8b	App\\Models\\Menu
9d694bd2-8acd-4220-9dc4-ba2d1b7051ed	App\\Models\\User
9d694bd3-05e1-4c63-89be-605835f7f3be	App\\Models\\User
9d694bd6-14e0-41ba-a82e-ae5a0d27c580	slow
9d694bd6-15a2-47c5-9ea5-c980323bfe50	App\\Models\\Menu
9d694bd7-3245-4de2-94f3-67b9017f2128	App\\Models\\Menu
9d694c38-93c1-4e40-b73f-2ed75f13de21	slow
9d694c38-9447-49ed-93ce-999c7011130c	App\\Models\\User
9d694c39-1770-441a-91f8-990f1a6204e4	App\\Models\\User
9d694c3c-9683-4acc-abc0-c055daf6102e	slow
9d694c3c-970a-4265-8e2a-873ff5297bc5	App\\Models\\Menu
9d694c3d-926f-4856-aa9f-ab38fe8bdf2b	App\\Models\\Menu
9d694c51-f573-4f54-9c84-742d169d4909	App\\Models\\User
9d694c52-545d-46ad-9bfe-31950f565f58	App\\Models\\User
9d694c55-1435-4c6b-afdb-6863bdb68f07	slow
9d694c55-14f2-413e-ae65-e5cae8c01f6a	App\\Models\\Menu
9d694c56-414a-4329-b416-e2a7ce7cb516	App\\Models\\Menu
9d694ca6-e6f6-4b3e-a77d-17c49b0c45b4	slow
9d694ca6-e765-4c1b-bb61-9cb2e67ef8c7	App\\Models\\User
9d694ca7-5dd1-4314-ad1b-7317c7ebc4f7	App\\Models\\User
9d694caa-1b61-4bf5-9e75-b25f08549ade	slow
9d694caa-1c13-4277-855e-20464cf27bd2	App\\Models\\Menu
9d694cab-0d48-443e-b9cf-300cdb883b89	App\\Models\\Menu
9d694ede-da0a-4b37-9811-e4ac4b824e02	slow
9d694ee1-6f14-4690-93e6-32b9f104ac8d	App\\Models\\Menu
9d69517f-f371-4a6d-8777-461761bb228c	App\\Models\\User
9d695180-75bc-492d-a756-615bf65c70c5	App\\Models\\User
9d695182-635d-4059-a343-2d6c520dce9d	slow
9d695183-b200-4ac3-b22d-a320dc1eef1e	slow
9d695183-b2b3-4e4e-aad3-2261a81b6775	App\\Models\\Menu
9d695185-5ad3-4169-9b8d-c81020194b9c	App\\Models\\Menu
9d6951be-6c0c-473a-8f2a-a6101592410d	App\\Models\\User
9d6951be-f898-455c-aecd-b982d418a8f3	App\\Models\\User
9d6951c2-4bc6-4421-bcc1-da60f7399dc0	slow
9d6951c2-4c4b-47c0-858e-6ffe96d0dea4	App\\Models\\Menu
9d6951c3-bfaa-4401-b131-0b06cb0f0df0	slow
9d6951c3-c02c-489f-92d6-cdb24efc5bdf	App\\Models\\Menu
9d695236-46a2-49b3-b956-410727f4607d	slow
9d695236-4738-41ff-b03f-32634c7b1b4b	App\\Models\\Menu
9d69538c-34fa-4f87-8f0b-c63f510577a5	slow
9d69538c-3575-4918-ab67-26a8e8a678d5	App\\Models\\Menu
9d6953f7-a59d-4d43-811c-84e4511bfa4e	slow
9d695483-8cf2-4cad-888b-3a43a2e278d2	App\\Models\\User
9d695483-ef57-42fa-9840-b4b7cfc03d49	App\\Models\\User
9d695486-9c9e-4075-8a83-0d46d9c0f6a3	slow
9d695486-9d3a-43da-b049-a08f4de4740f	App\\Models\\Menu
9d695487-c326-4829-9f35-78d356598931	App\\Models\\Menu
9d6954a9-a729-49b7-8e2e-2bf7d47a401c	App\\Models\\User
9d6954aa-0f04-4e7d-8121-2e78c1d7cb9e	App\\Models\\User
9d6954ab-1b9a-4f0e-940d-afc11071642d	App\\Models\\User
9d6954ab-9253-4451-8f07-a4d33b35dd9f	App\\Models\\User
9d6954ad-6ec5-490d-8019-adb2c348f240	App\\Models\\Menu
9d6954d8-04ec-4495-b3a3-1a12896f4434	slow
9d6954d8-0583-42a1-ab9c-b1233fc2cfd4	App\\Models\\User
9d6954d8-79e6-47f2-85dd-e65eb7217376	App\\Models\\User
9d6954d9-3e82-4b9e-91e9-6001541705ff	App\\Models\\Menu
9d6954d9-f373-4a40-aa4e-2098afb8054a	App\\Models\\Menu
9d6954f0-00de-47ee-a2b4-ef2727ce2c45	App\\Models\\User
9d695519-df1f-427c-b5c8-a6c73d12fcd7	App\\Models\\User
9d69551f-cf67-49cf-a9e0-b71dec4b38e8	App\\Models\\User
9d695523-bfc5-4d1c-a453-e1372f1f1eb2	App\\Models\\User
9d695526-09c3-48c3-a38e-9d006fc1e401	slow
9d695526-0a15-4911-8602-61be01825ae6	App\\Models\\User
9d695529-2cbd-4379-b334-30c594945d90	App\\Models\\User
9d69c3f3-a44a-4329-b09d-73cfca4e587d	slow
9d69552d-ef33-486a-ad80-9f06e9958d02	App\\Models\\User
9d695530-db3c-4f14-a234-12148660c83f	App\\Models\\User
9d695533-8fe2-48d6-90a6-f73c7987e238	App\\Models\\User
9d695537-11e2-418f-ba4c-95bfb96fb5fc	App\\Models\\User
9d695547-e194-4132-8413-73127cbd7e08	App\\Models\\User
9d695548-43c8-4931-8be7-f559469e2314	App\\Models\\User
9d6955e1-1d8f-4139-aba3-07beadb08ebc	App\\Models\\User
9d6955e4-180b-4f61-ae33-948a283a6a7a	App\\Models\\User
9d6955e4-d55f-4616-a50d-b0bf0c4a7951	App\\Models\\Menu
9d6955e6-362f-4b8a-b361-d6050d69f257	App\\Models\\Menu
9d695657-7178-4ac7-86d0-60d2727b2110	slow
9d695657-71d1-43b1-87e6-62ca3ec5c576	App\\Models\\User
9d695659-e0f7-4fe8-8d76-9708a8a9e2ed	App\\Models\\Menu
9d69572b-b8e9-4ea3-9447-e2a5be3bfc4c	App\\Models\\User
9d69572d-ab83-44a8-a6e4-e504f796fd04	App\\Models\\User
9d69572f-cc3d-4946-b3c7-9ede933b1393	App\\Models\\User
9d695733-0061-45c1-b013-0a5bc18a41f1	App\\Models\\User
9d695733-d328-481e-9e37-f1b293c7fd2e	App\\Models\\Menu
9d695735-3d7c-4eb4-8b38-e8774b9fa713	App\\Models\\Menu
9d695788-c498-4ef8-8910-ee7c6920d003	slow
9d695788-c517-4f93-bdb8-bcf7bda6a311	App\\Models\\User
9d695789-42b5-4a29-aaae-50c1ba7de9bd	App\\Models\\User
9d695789-ba14-4855-bca9-242a3a96df13	App\\Models\\User
9d69578c-4500-4256-9b68-d14be40ac6f6	slow
9d69578c-459a-45f8-ae44-42f862554f1d	App\\Models\\Menu
9d6957ff-2e6d-42ba-80a8-26c8bb6cb2d2	App\\Models\\User
9d6957ff-c955-429e-93b2-7e2beba47154	slow
9d6957ff-c9b3-4a94-a29d-4d23dacb223d	App\\Models\\User
9d695800-3c2b-40e2-a579-3a2b8e517c52	App\\Models\\User
9d695803-170e-4427-a92b-aeeda315adfb	slow
9d695803-1792-4877-8639-8ff6934d9792	App\\Models\\Menu
9d695868-3b1c-4acd-8821-8699430edaf0	App\\Models\\User
9d695868-cccf-4f2f-ab1f-21a972dd2a4e	slow
9d695868-cd2e-4608-8bb4-59ab73f1d269	App\\Models\\User
9d695869-4198-456d-b529-7fe4fbe4df99	App\\Models\\User
9d69586b-1be6-4a1c-af29-f06ac89c9f0c	App\\Models\\User
9d69586b-a90b-417c-8d11-ccc331857cc0	App\\Models\\User
9d69586c-49fa-4cf9-9ab4-17cd60ebe841	App\\Models\\User
9d69586d-31e1-46c9-bfda-150170ca8d98	slow
9d69586d-327d-44ef-91c2-9b796fc6edfd	App\\Models\\Menu
9d69586e-8b15-43b4-91ba-9715e4dab235	slow
9d69586e-8b74-4076-859b-828ed498623c	App\\Models\\Menu
9d695880-5d7f-46f1-8dbb-a209bd2f9989	App\\Models\\User
9d695880-c190-425f-8d7e-a76c82bc9359	App\\Models\\User
9d695881-2c08-44a1-a92c-83998dd9d9ad	App\\Models\\User
9d695883-1c4b-4525-bc2e-c000dea3921f	slow
9d695883-1cd9-4ab8-85c4-b84dca5440fe	App\\Models\\User
9d695883-ea64-4f5e-b69c-0e9f0315aba4	slow
9d695883-eb0f-45e4-b0b0-c24230aece43	App\\Models\\User
9d695884-8f67-427c-b678-0ca5619093a7	App\\Models\\User
9d695885-bb28-42fd-b4f6-ce1eebe4a1b5	App\\Models\\Menu
9d695886-ec39-4793-bbed-7acb5787673a	slow
9d695886-eca2-4eb0-b4c9-26858c025702	App\\Models\\Menu
9d695a41-d75b-43fd-ac22-be033df74737	App\\Models\\User
9d695c2a-3dfd-4ea6-81c9-7ce92f792d1c	App\\Models\\User:22
9d695cbd-58bc-4b4a-8034-4bfbbd050cf3	slow
9d695cbd-594c-4a42-a511-f253594550ac	App\\Models\\User
9d695cbe-20f7-4afd-ac1f-b0e325d58686	slow
9d695cbe-2158-4be9-962e-a7dc03d39bf2	App\\Models\\Menu
9d695cd1-9d00-4825-90bb-e6fae1c8b1b5	App\\Models\\User
9d695ce6-e5d5-455c-8ace-8a1f13ffba54	App\\Models\\User
9d695cf0-9a27-4fb1-9e73-2f2165a3a297	slow
9d695cf0-9a78-4208-8943-62ec67466bac	App\\Models\\User
9d695d14-bab1-44f1-a35c-4787be27e386	slow
9d695d19-75e5-41f2-a490-6d44cbc051cc	App\\Models\\User
9d695d19-d8f6-4049-8a6d-282ae16f206e	App\\Models\\User
9d695d1a-4092-4405-b1d8-6e338bfc2b8e	App\\Models\\User
9d695d22-346c-4dfd-a9d9-ea6e216042c4	slow
9d695d22-d721-4ac2-91bc-ad06e39d1fe3	slow
9d695d28-9da7-44f1-ac06-351ab6f83fd0	slow
9d695d2f-38aa-4e29-a77a-a1597d2e10f9	slow
9d695d2f-beaa-4d99-9ac3-cd8784d407d1	slow
9d695d30-52b6-4e2f-876b-fc716f51925a	slow
9d695d31-3863-4483-aae2-5349671ddac0	slow
9d695d32-a1c6-4d67-b46f-c2c1edc5f16a	slow
9d695d3e-6abb-4ff8-9291-6dd3ab6e594b	slow
9d695d3e-6b14-42d2-987c-a3b1f073432a	App\\Models\\User
9d695d9a-e54b-4122-965e-49ac8f73fb0d	App\\Models\\Loans:93
9d695d9a-e7b6-42b6-8b71-65b69581c23d	App\\Models\\ItemLoans:
9d695d9a-e8ab-455b-8500-56024c06308b	App\\Models\\ItemLoans:
9d695d9a-e9a0-47af-b6cc-3948ee2a262a	App\\Models\\ItemLoans:
9d695d9a-ea87-4359-a8b4-1e626ef5a8f9	App\\Models\\ItemLoans:
9d695d9a-eb74-4cfb-9268-108a39e661a5	App\\Models\\ItemLoans:
9d695db2-8b42-46b7-975e-89f40bc85c90	slow
9d695db2-8bae-4e6f-a3ae-edda1968034f	App\\Models\\User
9d695db3-1213-46fb-bd47-8a52522db4d5	slow
9d695db3-1269-429d-9840-973ea3081573	App\\Models\\User
9d695db3-6e71-466a-9215-a5a208a3e7e4	App\\Models\\User
9d695db3-cb5b-4dec-a42d-8c5f96ce3fe6	App\\Models\\Loans
9d695db3-cd29-4416-9da6-c038dbd57cdc	App\\Models\\ItemLoans
9d695e43-32ea-4c3b-8ebc-055ec9fdb5e1	App\\Models\\ItemLoans
9d695e43-3509-4cdf-9b3a-46333e6c99e6	App\\Models\\Loans
9d695e43-38fd-41d4-b66f-556f8a12a0b6	App\\Models\\ItemLoans:394
9d695e43-39e9-4c7b-8d18-15eab0a2396b	App\\Models\\Loans:93
9d695e43-e6b1-4c94-b3aa-0aa5e99e9372	slow
9d69c22a-da1f-41cb-9d2a-a55d10c07279	slow
9d69c22a-db04-43eb-9f0b-f1e75285a7ff	App\\Models\\Menu
9d695e70-7f7f-4fdc-a159-e20772f352a0	slow
9d69c2e4-3072-4bfb-9da7-0b1c06fd1920	App\\Models\\User
9d695f3e-5f7b-4496-9029-70c3939e1b61	App\\Models\\Loans
9d695f3e-6269-475c-88ce-f6c99f3cd82d	App\\Models\\Loans:93
9d695f3e-6328-40f4-bdbc-b93224011c66	App\\Models\\ItemLoans
9d695f3e-63d3-4b32-8fff-2dfc851e9682	App\\Models\\ItemLoans:395
9d695f3e-6578-4cbb-8f95-100a1ad374d4	App\\Models\\ItemLoans:
9d695f3e-6614-4864-abbb-b606ddc57d9a	App\\Models\\ItemLoans:
9d695f3e-66c4-4584-b943-34dff0c2e001	App\\Models\\ItemLoans:
9d695f3e-6771-48f7-80d9-c26a35815cdd	App\\Models\\ItemLoans:
9d6960dc-57f4-4c32-900d-f47cc9a9b9b3	App\\Models\\Loans
9d6960dc-59c7-4d44-9e18-cdf0bec7e569	App\\Models\\Loans:93
9d6960dc-5b67-4d6b-a54d-beaa435149c4	App\\Models\\ItemLoans
9d696101-6847-46f3-8234-f88489ca5b4e	slow
9d696133-184e-410b-88e3-4aa44f4018d2	App\\Models\\ItemLoans
9d696133-1a1d-426d-86a6-5f9741f1bf04	App\\Models\\Loans
9d696133-1e97-45b5-a9af-91f286dc1c0d	App\\Models\\ItemLoans:380
9d696133-1f73-4e80-bff8-87d3e5db9837	App\\Models\\Loans:92
9d696133-ac39-43d5-bbef-ba5bb613cfdf	slow
9d6961b2-8a80-418c-b39e-468b5e106d77	App\\Models\\ItemLoans
9d6961b2-8dcf-4b8b-a215-e1b407d927b7	App\\Models\\Loans
9d6961b2-933c-43a3-98a9-6383f04e4296	App\\Models\\ItemLoans:381
9d6961b2-9464-438e-89d7-4b788c0e0d0e	App\\Models\\Loans:92
9d6961d8-ceff-480a-8bb2-9a292ded1870	App\\Models\\ItemLoans
9d6961d8-d106-44ca-a55d-ee0d4a8c478d	App\\Models\\Loans
9d6961d8-d33d-4b75-aef2-ff48f986a093	App\\Models\\ItemLoans:382
9d6961d8-d422-44d8-8dac-4d8a843d186a	App\\Models\\Loans:92
9d696215-9255-4597-b109-1407c92e05c3	App\\Models\\ItemLoans
9d696215-94c2-4745-8896-9ec37b7a782e	App\\Models\\Loans
9d696215-98d9-4266-af0c-e9504cc8374f	App\\Models\\ItemLoans:380
9d696215-99f3-4cce-b3b5-cdab5db3cc9b	App\\Models\\Loans:92
9d696216-5adc-436e-8589-bcb827222630	slow
9d696248-89d2-4431-9b67-5753778dfdca	App\\Models\\ItemLoans
9d696248-8c73-4853-9684-0d8f33b8f95e	App\\Models\\Loans
9d696248-909d-4090-a37c-88692d9d34bb	App\\Models\\ItemLoans:381
9d696248-919c-453e-b3bc-5a1f5dd72793	App\\Models\\Loans:92
9d696259-7d0e-41dd-93d3-502378f14d68	App\\Models\\ItemLoans
9d696259-7ee9-4c19-b8a3-7ab02089011f	App\\Models\\Loans
9d696259-82ef-4acf-97f3-0eb50b11fccb	App\\Models\\ItemLoans:382
9d696259-83f0-4e24-8780-4597b4483388	App\\Models\\Loans:92
9d69625a-19cb-4069-8180-4eba6fdb8cd1	slow
9d696319-157d-4ceb-a98d-c8cecb279a08	App\\Models\\ItemLoans
9d696319-1811-4b19-a7ed-d5027c5baf51	App\\Models\\Loans
9d696319-1bc8-4f3d-ab2b-cd303c97b079	App\\Models\\ItemLoans:383
9d696319-1ce9-43fd-a8bb-01d0b75d0221	App\\Models\\Loans:92
9d696319-da82-4be5-8ba7-2da4710df814	slow
9d6963b7-40f4-483a-9c9b-fccdf102294c	App\\Models\\Loans
9d6963b7-4294-4d30-8bd8-43ce6271a1ec	App\\Models\\Loans:92
9d6963b7-4436-4013-a7e0-0c3624fde1c8	App\\Models\\ItemLoans
9d696723-ed89-4622-831a-a5687a7b07d8	slow
9d696724-be56-406e-89bf-da08d1fe6a52	slow
9d696729-930e-4944-a55a-8a423a378399	slow
9d696743-6b91-4d13-b2d9-de8e5492a3ab	App\\Models\\Loans
9d696743-6ee6-4ff0-8518-bd0d616ec45f	App\\Models\\Loans:91
9d696743-6fb7-4dc4-9bfc-d32a29783f0c	App\\Models\\ItemLoans
9d696743-7061-4725-875d-3d3419647efd	App\\Models\\ItemLoans:371
9d696743-7215-4bbd-8b54-cc92aac3a4c2	App\\Models\\ItemLoans:
9d696743-72bd-4ed5-8d65-0d772c11163d	App\\Models\\ItemLoans:
9d696743-7352-4f4a-b5ad-cb96261031b7	App\\Models\\ItemLoans:
9d696743-73e1-4da8-95ca-ce7d867f801e	App\\Models\\ItemLoans:
9d696743-7497-4db3-b30f-45402522c446	App\\Models\\ItemLoans:
9d696743-7533-4d25-99cc-8098420c4b17	App\\Models\\ItemLoans:
9d696743-75be-4a5e-9389-a447af1fa36a	App\\Models\\ItemLoans:
9d696743-7647-48ee-bceb-3a4462713de3	App\\Models\\ItemLoans:
9d696744-0838-4f83-9589-4526aa5c1a47	slow
9d6968c5-0a60-4df2-8ede-3f2800236ce9	App\\Models\\Menu
9d696a1f-49b1-4863-a272-506ca3723bf4	slow
9d696a7e-b7e3-4df9-b239-81af9e74243d	slow
9d698291-c117-4f39-a816-1856e6991781	App\\Models\\User
9d698292-51bf-469e-a24b-ad43b28200b1	App\\Models\\User
9d698292-b04d-4907-9f3e-a3b1ddcdb34e	App\\Models\\User
9d698293-3a53-4775-aa83-909532cd3d0c	App\\Models\\Menu
9d698294-0537-4434-9e6c-29041e372d59	App\\Models\\Menu
9d69830a-f92e-4ef8-9663-b829c5d0ee64	App\\Models\\User
9d69830b-6193-46d2-8b54-d8a6ebe5d839	App\\Models\\User
9d69830b-c659-44f6-97ff-8470ba891278	App\\Models\\User
9d69830e-1aa2-4781-a29d-ca7af71bba88	App\\Models\\Menu
9d69830f-1d84-4ab5-90d3-f74591e4dc87	App\\Models\\Menu
9d6989ab-fba9-4035-8196-f289c6d6c638	slow
9d6989ab-fc1c-4c13-add0-378674bd836a	App\\Models\\User
9d6989ac-7ba9-4d23-806e-cdd8a56af37f	App\\Models\\User
9d6989ad-40db-404e-a3c4-27b56cfebfcf	slow
9d6989ad-4163-4dea-8c05-68873c0ac269	App\\Models\\User
9d6989ae-054e-44fa-8b59-5592257e9ec0	App\\Models\\Menu
9d6989af-17f5-4cf4-8384-541d824f83ac	slow
9d6989af-1889-4f58-b2b9-ba5dd5127551	App\\Models\\Menu
9d6992e8-2742-4461-a88d-f8bb2976e1eb	App\\Models\\User
9d6992e8-c96d-4963-9189-65a7d9e0e2c8	App\\Models\\User
9d6992e9-4e08-4c99-8549-14572a50ffce	App\\Models\\User
9d6992e9-e91d-48a6-95e4-a79108859471	App\\Models\\Menu
9d6992ea-dea0-424f-8ed9-c1cd1ea979c3	slow
9d6992ea-df1d-43c8-a863-0d86e73973a5	App\\Models\\Menu
9d69a62d-7eae-477e-87af-cdeeda20bda0	App\\Models\\User
9d69a62e-7230-4819-a72d-bd407cdcce92	App\\Models\\User
9d69a62f-48c6-49fe-9626-dad7b7980e3e	App\\Models\\User
9d69a630-434b-44cb-b0f9-84b982d58e44	App\\Models\\Menu
9d69a631-58f7-418d-b604-c5f7cf429e29	slow
9d69a631-59d0-42bd-a2b6-2bd58edc3d0d	App\\Models\\Menu
9d69a69e-ad56-412b-9b6d-85657de52af3	App\\Models\\ItemLoans
9d69a69e-ba86-4a97-b66e-e1d0bb0c089e	App\\Models\\Loans
9d69a69e-cdb1-4acc-9d89-dc6d82e419f9	App\\Models\\ItemLoans:403
9d69a69e-cecc-4f9f-b5dd-53b0cbcac823	App\\Models\\Loans:91
9d69a69f-74c1-4fab-903e-c2fbe845cbd2	slow
9d69a6b2-0900-4cc4-b6a5-34aec7a621ae	App\\Models\\Loans
9d69a6b2-0ce1-4131-a81f-675af8f14628	App\\Models\\Loans:91
9d69a6b2-0ddf-48a2-919e-0ff7ef8926dc	App\\Models\\ItemLoans
9d69a6b2-0f61-41db-9bcf-b6136cf82af6	App\\Models\\ItemLoans:404
9d69a6b2-1135-489a-ad5a-33f9cef7822c	App\\Models\\ItemLoans:
9d69a6b2-1200-4529-a46b-8c044505f08d	App\\Models\\ItemLoans:
9d69a6b2-12b5-4d60-9bc3-0fea37a5c6f5	App\\Models\\ItemLoans:
9d69a6b2-1372-4c49-a42a-6811049bb15b	App\\Models\\ItemLoans:
9d69a6b2-1453-4d52-918f-ca968e0a8b2e	App\\Models\\ItemLoans:
9d69a6b2-151e-4620-9cf6-05322af0eace	App\\Models\\ItemLoans:
9d69a6b2-15d1-4a5c-9f63-9dcc193bea96	App\\Models\\ItemLoans:
9d69a6b2-dbe9-49b9-b1c6-ee1a0a53970d	slow
9d69a700-4dc8-49c2-814f-51ccc2e044f1	slow
9d69a702-99c3-44d0-aa62-456ea16de412	slow
9d69a702-9a1f-4dfe-bee5-9a4c9da33287	App\\Models\\Menu
9d69a711-72a8-4f0c-ab5c-55b2b49b4447	App\\Models\\Loans
9d69a711-75bb-42d1-81ba-dd0fc365ae26	App\\Models\\Loans:91
9d69a711-769e-48fe-87f0-dd3794debb12	App\\Models\\ItemLoans
9d69a711-7840-48dc-8582-233cd29a384d	App\\Models\\ItemLoans:411
9d69a711-7a33-4a79-85e8-9f6f9afc0796	App\\Models\\ItemLoans:
9d69a711-7ad3-4b4f-9a9a-3607c5ee5efa	App\\Models\\ItemLoans:
9d69a711-7ba7-429f-8257-a2734837c676	App\\Models\\ItemLoans:
9d69a711-7c7d-49a4-80b1-84b5df849f44	App\\Models\\ItemLoans:
9d69a711-7d34-4c05-a620-9e2d44579fa9	App\\Models\\ItemLoans:
9d69a711-7df1-42fc-951f-b04feb0cfa89	App\\Models\\ItemLoans:
9d69a711-7e90-4c96-855d-644df0c8f75d	App\\Models\\ItemLoans:
9d69a786-8037-45b3-a20e-4505d28e0de7	App\\Models\\Loans
9d69a786-8396-41ff-b2af-2c6fd3d3130b	App\\Models\\Loans:91
9d69a786-8473-44ba-a808-7dd769c8113f	App\\Models\\ItemLoans
9d69a786-8604-4e96-8620-16b67046478e	App\\Models\\ItemLoans:418
9d69a786-879a-4b1d-9364-053e6d3ab801	App\\Models\\ItemLoans:
9d69a786-884a-4498-8e14-334292134b51	App\\Models\\ItemLoans:
9d69a786-88f1-4ac5-b69e-29e41d1211a9	App\\Models\\ItemLoans:
9d69a786-89a0-4ccd-b354-ab7bac4dbef5	App\\Models\\ItemLoans:
9d69a786-8a33-41f8-8484-6782de3319d6	App\\Models\\ItemLoans:
9d69a786-8ab6-4503-a284-23ad38f3fb42	App\\Models\\ItemLoans:
9d69a786-8b2e-4781-8901-d5bfa53457d9	App\\Models\\ItemLoans:
9d69a787-26cf-4995-964e-9ad0bd415e43	slow
9d69a79c-5d24-44b3-88d7-c2b55ef9beaa	App\\Models\\Loans
9d69a79c-6026-4f0e-b386-7c3b0d82afca	App\\Models\\Loans:91
9d69a79c-60f2-4069-b777-6f41acec5b8c	App\\Models\\ItemLoans
9d69a79c-6295-423d-bd8b-da3d30671d52	App\\Models\\ItemLoans:425
9d69a79c-6448-4182-be49-d581fc661b47	App\\Models\\ItemLoans:
9d69a79c-64e7-46ab-90ad-536713641bd1	App\\Models\\ItemLoans:
9d69a79c-6586-4262-97cb-504e360c66ce	App\\Models\\ItemLoans:
9d69a79c-6652-4ec8-ae95-e42fc0110d86	App\\Models\\ItemLoans:
9d69a79c-670c-4db0-903a-fc06ec8264b9	App\\Models\\ItemLoans:
9d69a79c-67b0-4d2f-928b-9b32a813b2a2	App\\Models\\ItemLoans:
9d69a79c-684f-4eb3-b770-eb7a3fa491a3	App\\Models\\ItemLoans:
9d69a7ac-4f81-46ce-881e-4fd57a0efe68	App\\Models\\Loans
9d69a7ac-5106-40ff-8f95-440b2150a128	App\\Models\\Loans:91
9d69a7ac-52a5-4078-92fb-fd5e97301688	App\\Models\\ItemLoans
9d69a7b3-0160-4225-9840-b6bc8084f857	slow
9d69a7b8-3318-4740-8890-adbc2723363b	slow
9d69a868-0655-4215-80d1-9432618264a9	App\\Models\\Loans
9d69a868-09c9-4297-bc26-5b934c04e9af	App\\Models\\Loans:89
9d69a868-0aa0-4a2e-9f7e-836958d8b29d	App\\Models\\ItemLoans
9d69a868-0b64-4c51-9265-bb314a1d9d1d	App\\Models\\ItemLoans:368
9d69a868-0d94-437f-a43e-7c6d4eab1ae9	App\\Models\\ItemLoans:
9d69a868-0e3d-4834-9a5d-a69a42b72238	App\\Models\\ItemLoans:
9d69a868-0ee1-41bb-92a4-e6129a206f85	App\\Models\\ItemLoans:
9d69a8d5-f0f3-4560-bdfb-1c706bef611b	slow
9d69a8d5-f14d-4429-aada-646e5cf4be71	App\\Models\\Menu
9d69c22c-9ca5-4654-a686-b22417f9a6be	slow
9d69a900-b1c5-4063-add8-6df5484b95d7	App\\Models\\Loans
9d69a900-b45d-44c4-9e7f-e8e942a8f86b	App\\Models\\Loans:89
9d69a900-b4ff-4fb9-a3a3-415144da9034	App\\Models\\ItemLoans
9d69a900-b666-45fa-a154-fe9f01999fb3	App\\Models\\ItemLoans:439
9d69a900-b7e5-4784-b81f-7445e4731865	App\\Models\\ItemLoans:
9d69a900-b869-462f-8324-9fbc97cddf3f	App\\Models\\ItemLoans:
9d69a900-b900-488f-946c-aa92666edbd7	App\\Models\\ItemLoans:
9d69a91a-5926-4c40-a35f-c1e9fcc6f935	slow
9d69a924-dfa2-4d55-a880-ba5fd4b47876	App\\Models\\Loans
9d69a924-e136-407f-95f4-4ac5085b82f9	App\\Models\\Loans:89
9d69a924-e2e9-4fa5-86bd-602f2d4aed25	App\\Models\\ItemLoans
9d69a927-5cfd-4021-a71c-1e456a9b671a	slow
9d69a9c2-4c83-4183-baaa-09ad453c9e55	App\\Models\\ItemLoans
9d69a9c2-4eb1-4d85-b07c-2ae4c2643357	App\\Models\\Loans
9d69a9c2-507e-4594-bb4d-ebb78c07d7be	App\\Models\\ItemLoans:341
9d69a9c2-516d-494a-a662-1e7a003457d2	App\\Models\\Loans:87
9d69c22c-9d10-461f-a39f-b71d1437fa4c	App\\Models\\Menu
9d69c2e4-9ef1-4413-ac5c-a555bf73775f	App\\Models\\User
9d69c2f9-437b-4ddc-8959-0675db64c663	slow
9d69c2f9-4408-45dc-bd84-ed08cb6f2ffa	App\\Models\\Menu
9d69ad60-2606-46b0-b38b-d89c4ebb3267	App\\Models\\Menu
9d69ad63-d211-423d-957b-26573069c154	App\\Models\\Menu
9d69ad75-10c7-4206-9e23-8e1625ede46b	App\\Models\\Loans
9d69ad75-1457-48ac-aae1-f3cdaca8795a	App\\Models\\Loans:87
9d69ad75-1546-47d9-8d55-e0ba391e3a51	App\\Models\\ItemLoans
9d69ad75-1634-41a1-b7f7-02dfc62f2686	App\\Models\\ItemLoans:342
9d69ad75-1881-4fac-a3ff-38e94d85d82c	App\\Models\\ItemLoans:
9d69ad75-195f-4b2c-af51-d51c190479af	App\\Models\\ItemLoans:
9d69ad75-1a31-42a7-91fd-35f5c02f3bf8	App\\Models\\ItemLoans:
9d69ad75-1afd-4294-b285-df447405b6a7	App\\Models\\ItemLoans:
9d69c3b2-c18b-4681-8131-13485cc432ef	slow
9d69c3b2-c232-4a7c-9c80-1a9af2a24f0a	App\\Models\\User
9d69c3ee-a378-4760-905a-56efbc9425ae	slow
9d69c3ee-a3cd-47ef-bf5f-f310bae02d9d	App\\Models\\User
9d69ae33-ad16-4219-abd1-ed9f495befb9	slow
9d69ae56-f5c5-464b-a250-d5fcdd7383d1	App\\Models\\ItemLoans
9d69ae56-f787-4ef4-9c2f-fc2f756745ba	App\\Models\\Loans
9d69ae56-f948-4ad6-bf88-d79ff3f0f2a9	App\\Models\\ItemLoans:336
9d69ae56-fa2a-431b-a4df-72044e287161	App\\Models\\Loans:86
9d69c3f3-a4e5-4322-8973-a3bb9b5095d3	App\\Models\\Menu
9d69c402-e445-40ce-afa2-4af44c7b18bf	slow
9d69c449-2224-43bc-9b4c-682e3b836edc	App\\Models\\User
9d69c44d-9009-4229-ab9d-8b555023d261	slow
9d69ae6a-fa9c-4656-95d9-c4627af522a5	slow
9d69af96-2125-4451-a873-f5514aaa3c37	slow
9d69af98-a0fc-47cc-840a-46c02238dc76	App\\Models\\Menu
9d69c44d-90a6-4cc8-9c5d-6683c6f33a91	App\\Models\\Menu
9d69c493-e8f1-47b2-a5d9-035cee7d43b9	App\\Models\\User
9d69c499-0b5c-4cf2-a146-961a1ab90348	App\\Models\\Menu
9d69c4d2-f7a4-4747-830e-1ea5e8860bc6	App\\Models\\User
9d69c4d7-66af-4978-a77a-8f56a4508164	slow
9d69c4d7-6744-445e-b5bb-dd5db395017b	App\\Models\\Menu
9d69c4e2-0e2d-4c68-a6e5-864a3a08ae72	slow
9d69c4e2-0e7d-486e-b461-57ef97372205	App\\Models\\User
9d69c4e5-e175-4d73-a210-ed8e314d4c9f	App\\Models\\Menu
9d69c4f3-0845-4a2a-840d-fcc64402c1ce	App\\Models\\User
9d69c4f5-f0a3-4dd4-95dd-faddedef8452	App\\Models\\User
9d69c501-2a49-4b6a-b2f8-5a8784a9d3aa	slow
9d69b1a3-95b3-49d0-a628-a9732976880f	slow
9d69c501-2adc-4a48-bfa5-85f5db1ebd37	App\\Models\\User
9d69c504-7384-4fc7-9caf-61fc679f7f7c	App\\Models\\User
9d69c538-3c92-4810-b2bb-bf8bd1a89615	App\\Models\\User
9d69c53b-bfb2-4c18-8d05-b444ad9134bd	App\\Models\\User
9d69c543-e66c-4248-ba4c-38faf2ca10e9	App\\Models\\User
9d69c546-fafd-49fc-87ad-b5326a7f292b	App\\Models\\User
9d69c57f-3def-46ed-a02c-93eb33a51e00	slow
9d69c57f-3e56-4d59-8bdf-4120fb9b16c5	App\\Models\\User
9d69c581-cc32-499e-9a68-a816b15504e0	slow
9d69c584-a357-42fc-ab76-19cce4f6e70f	App\\Models\\Menu
9d69c64e-d81b-4925-81d8-76249b4a7357	slow
9d69c64e-d87b-437a-a8ad-6896b74b3cee	App\\Models\\User
9d69c656-a2a2-4637-827d-cebc914f6d21	App\\Models\\User
9d69c65f-fc0d-4059-bc9d-c215f94d664c	App\\Models\\User
9d69c680-6ec5-4d3e-985f-183a1f131edb	slow
9d69c680-6f2b-444d-aea2-7f28e4b8cd06	App\\Models\\User
9d69b332-7490-4ff6-999d-ebc2b4663563	slow
9d69b340-5934-4e13-af7a-1fd6c7552fa6	slow
9d69b346-3531-4802-85d1-8f38679b2ae9	slow
9d69c6f6-5c43-4f27-bbfa-8a177f67a8aa	App\\Models\\User
9d69c7ed-7fb5-4988-beed-ad4dd3c6a52a	App\\Models\\User
9d69c7ef-d656-4c85-8475-8a94d7c54b2e	slow
9d69c7ef-d731-4beb-9102-c5d76bd135ca	App\\Models\\User
9d69b360-eb32-435e-8623-8a93d05d559e	slow
9d69c7f1-a731-461b-be50-b54cf3a80ac8	App\\Models\\Menu
9d69c80d-c815-4628-aee6-612d810478d2	App\\Models\\User
9d69c80f-8acf-4a7c-9d07-e66eb5b4ee49	App\\Models\\User
9d69c811-1a4c-48c4-b32d-5a902ab32e0d	App\\Models\\Menu
9d69b3c5-855e-4624-a459-7441e8743367	slow
9d69c820-9d0b-4a5e-8a9f-e798fa5b6947	App\\Models\\User
9d69c868-2a12-45bd-b6af-ba984af03e63	App\\Models\\User
9d69c86b-168e-4b09-8e19-b4f36a93e6d0	App\\Models\\User
9d69c86d-0195-44c8-902b-3700453ac7d0	App\\Models\\Menu
9d69c890-366d-4f80-9df5-b475eac7bb10	slow
9d69c890-372d-4167-962c-0bdebe5c6506	App\\Models\\User
9d69c891-add8-4899-a40f-a6d4795b3f23	App\\Models\\Menu
9d69c89f-c9e0-48e9-8a0c-c49184015620	App\\Models\\User
9d69b42f-dfc9-4980-b7bc-0d6a4a3fcd94	slow
9d69b447-17f8-4d3d-ac56-d1603a2d187d	App\\Models\\Loans
9d69b447-1aa5-4b4f-93b5-5f9d4c76832f	App\\Models\\Loans:86
9d69b447-1b63-4e5a-bc21-f6b00ad49523	App\\Models\\ItemLoans
9d69b447-1c07-4f24-ad42-a97fdc54d6da	App\\Models\\ItemLoans:337
9d69b447-1de0-4587-b603-9a4f46a2bb16	App\\Models\\ItemLoans:
9d69b447-1e70-466c-9583-6a9e45f66f79	App\\Models\\ItemLoans:
9d69b447-1efb-4806-9ffa-d230defb4a16	App\\Models\\ItemLoans:
9d69b472-31c8-4d7f-a449-ef79f26025a8	App\\Models\\Loans
9d69b472-3476-4e91-943f-02890625caeb	App\\Models\\Loans:84
9d69b472-3531-45e8-a8ca-2af510946516	App\\Models\\ItemLoans
9d69b472-35dd-4ca4-bbf1-bbce1c61cb14	App\\Models\\ItemLoans:326
9d69b472-3767-4851-b0b3-031c37ee5752	App\\Models\\ItemLoans:
9d69b472-37f1-4427-9732-da0276a3de41	App\\Models\\ItemLoans:
9d69b472-3892-4658-be40-9cc341ebc92a	App\\Models\\ItemLoans:
9d69b472-3920-4f24-9127-a562a1e97ff9	App\\Models\\ItemLoans:
9d69b4d5-2786-42c0-9ec6-4482691d0fb8	App\\Models\\Loans
9d69b4d5-2afa-4df4-a5f1-8a17d8c4d35e	App\\Models\\Loans:84
9d69b4d5-2be0-4839-96a7-6c1588b9e534	App\\Models\\ItemLoans
9d69b4d5-2daf-4ec9-a7f0-ed2a53b2ea05	App\\Models\\ItemLoans:452
9d69c8a2-905e-4d13-a7d6-9ae89baee42f	slow
9d69c8a2-90c4-45c7-8109-1e08f111e688	App\\Models\\User
9d69c8a4-9ac7-401d-b0a5-87f3e2c89920	slow
9d69c8a4-9b1c-495a-a038-c708e71f43c9	App\\Models\\Menu
9d69c8d9-82d6-4bd3-8770-2d619ad6e3af	slow
9d69c8da-aa93-4a5e-98b6-e875da25929f	App\\Models\\User
9d69c8dc-a8f4-453b-b985-1c4004cc7c58	App\\Models\\Menu
9d69c92b-558c-4ae7-bc52-bc728b148ee8	App\\Models\\User
9d69cabd-4a2c-42f4-9436-e5b858486530	App\\Models\\Loans
9d69cabd-4c0e-4a9b-9fd2-30a7c31d7327	App\\Models\\Loans:86
9d69cabd-4d81-4eab-9145-c106e0d14664	App\\Models\\ItemLoans
9d69b4d5-2fb0-4e7e-9307-f435c7037e01	App\\Models\\ItemLoans:
9d69b4d5-303f-4437-9782-9a031ef62f70	App\\Models\\ItemLoans:
9d69b4d5-30fb-4478-a325-c1c25f06ae5a	App\\Models\\ItemLoans:
9d69b4fc-70bc-42d4-92a4-a13f603b415d	slow
9d69c2dd-eea9-4e4e-a1cd-cffb6c67fbe8	slow
9d69c2e5-5e18-470a-8007-9ebd2f9f8d0c	App\\Models\\Menu
9d69c2fa-19df-4c3a-a0a7-707c6bc44be2	App\\Models\\Menu
9d69c3b3-9f53-4dc1-be4a-22e9129d0600	slow
9d69b504-1931-47ce-a151-193b57f12021	slow
9d69b51c-1125-4f8c-845c-377ce36339ca	slow
9d69c3b3-9fe9-4461-a1f6-5f4998e23684	App\\Models\\Menu
9d69c3f0-5d7d-488e-bb46-a42af58e25db	slow
9d69c400-6db7-46fa-a4ed-2feed800f8b0	App\\Models\\User
9d69c403-c9e2-4e26-8783-643267d916b5	slow
9d69b64c-e52e-4241-8f0a-10c327d3a29e	App\\Models\\Loans
9d69b64c-e8c3-4707-8c46-e9816e71ea63	App\\Models\\Loans:83
9d69b64c-e9b2-4436-a54e-162284967bf5	App\\Models\\ItemLoans
9d69b64c-ea80-469f-bab4-8166d97f9c39	App\\Models\\ItemLoans:321
9d69b64c-ec8a-44c5-b125-45e223255a9e	App\\Models\\ItemLoans:
9d69b64c-ed33-4bea-9e25-e1bb3e243028	App\\Models\\ItemLoans:
9d69b64c-edf5-4d93-8bfd-aaffda6654ec	App\\Models\\ItemLoans:
9d69b64c-eeb3-4cc8-b6e4-ad9198db9e86	App\\Models\\ItemLoans:
9d69b64c-ef4f-4980-b58a-3532aa22fe90	App\\Models\\ItemLoans:
9d69b672-7a86-494b-86c5-44f16dd5ee09	slow
9d69b672-e5d9-467e-a5be-960bdd45bad5	App\\Models\\Loans
9d69b672-e74a-4ea4-8f1b-b51137efbd36	App\\Models\\Loans:83
9d69b672-e8e8-490e-ab2d-ece7ddf89c58	App\\Models\\ItemLoans
9d69b688-5c92-4813-bee5-60dd990a677b	slow
9d69c403-ca79-44df-81ca-49b9bf273ee1	App\\Models\\User
9d69c449-9c12-4160-9904-63bb7e322db9	App\\Models\\User
9d69c44e-a6b4-42d1-9e8d-6c220ab1dfd5	slow
9d69c44e-a747-4aa7-a705-95da38f6347e	App\\Models\\Menu
9d69b6b4-7d7c-4de8-8954-0df627d25f69	slow
9d69b79b-12ac-499e-98f8-64151e25e3c8	slow
9d69b79b-1310-4804-950a-90fda0d88c7e	App\\Models\\Menu
9d69b7a6-4814-48fc-96b2-3fe400bd8115	App\\Models\\Loans
9d69b7a6-4ada-46b1-8f31-996270c5a64a	App\\Models\\Loans:82
9d69b7a6-4b90-4bd5-8390-c32660919dd5	App\\Models\\ItemLoans
9d69b7a6-4c47-435e-9e82-7499b739ebac	App\\Models\\ItemLoans:316
9d69b7a6-4dd8-4801-bd2b-e9b2b2cefbe1	App\\Models\\ItemLoans:
9d69b7a6-4e69-4fee-8086-8f583d756528	App\\Models\\ItemLoans:
9d69b7a6-4efd-473f-8cd3-e83ff5a3d8b8	App\\Models\\ItemLoans:
9d69b7a6-4f8a-41eb-a46e-ce577f26a103	App\\Models\\ItemLoans:
9d69b7a6-e2c2-400b-a0fe-0a9b600cd226	slow
9d69c496-8662-4a20-93aa-a5d0fd196913	slow
9d69c496-86db-43b0-a99a-459e86979af4	App\\Models\\User
9d69c4d2-0146-4576-98d7-5b65d315933c	App\\Models\\User
9d69c4d5-341a-4f43-9b31-eb9643fc117e	App\\Models\\User
9d69c4e1-1535-42b4-a899-7739f898e486	App\\Models\\User
9d69c4e3-b45c-465a-9fb0-15437f90e7e0	slow
9d69c4e6-d15c-43f2-97a6-110827a2d575	App\\Models\\Menu
9d69c4f3-9cea-445b-ba76-5c8cf9948cb5	slow
9d69b81c-9b0c-4a5a-855a-920c0dfd8d9c	slow
9d69b81e-bf79-47e2-bcde-d2c0a1ed4753	App\\Models\\Menu
9d69b838-a5d7-41ad-86c4-a16dcc95eb24	App\\Models\\Loans
9d69b838-a897-4cf1-b151-7c9aed32f6fa	App\\Models\\Loans:82
9d69b838-a94c-44b4-ba52-f13754434a38	App\\Models\\ItemLoans
9d69b838-aabe-4d2e-91d4-d7b42c730ca8	App\\Models\\ItemLoans:464
9d69b838-ac60-4808-8efb-36b828e890dd	App\\Models\\ItemLoans:
9d69b838-ad15-4b3f-ba02-2346d226b85c	App\\Models\\ItemLoans:
9d69b838-adc9-42a0-b84a-f5485be48b6f	App\\Models\\ItemLoans:
9d69b838-ae61-4699-967e-b9e127e8591f	App\\Models\\ItemLoans:
9d69c4f3-9d66-40fa-84b6-8be592576e8a	App\\Models\\User
9d69c4f6-dbc4-4077-84c3-75fe7a01a57c	slow
9d69c4f6-dc63-4ce8-8ca0-82a755ef840f	App\\Models\\Menu
9d69c501-9458-4803-b701-9d4d58c71c1d	App\\Models\\User
9d69c506-09bb-43f0-94ee-dd76e0251dd8	App\\Models\\Menu
9d69c538-cdad-48eb-a1c7-7e39b3cc4842	slow
9d69c538-ce02-4a49-b570-905bccb4ba84	App\\Models\\User
9d69c53d-386c-45cf-aff7-693fe8502dd0	slow
9d69c53d-3904-4788-89c8-6151ee12c9d7	App\\Models\\Menu
9d69c544-7782-491a-8ab9-d02d6a9c8076	slow
9d69c544-77dc-46fe-9117-b154fb550f0e	App\\Models\\User
9d69c548-3056-4df7-95be-fbfcd6f5390a	slow
9d69b957-ec4d-4a86-aab1-65e89a64fce3	App\\Models\\Loans
9d69b957-ef70-44ec-a295-6985924465af	App\\Models\\Loans:82
9d69b957-f022-41db-8a0b-c6bc7ba915b9	App\\Models\\ItemLoans
9d69b957-f1bf-45c7-8be6-7f60c09ae37c	App\\Models\\ItemLoans:468
9d69b957-f36f-4350-94cb-92761c8300f6	App\\Models\\ItemLoans:
9d69b957-f423-4d59-9ad7-dbb39eac1240	App\\Models\\ItemLoans:
9d69b989-e2dc-4cad-bfab-813d907678fe	slow
9d69b997-bd5a-4975-b4f0-6c9b515a3a44	App\\Models\\Loans
9d69b997-bff2-4fff-a6e3-9c358eba2560	App\\Models\\Loans:75
9d69b997-c0a3-4dcc-90b2-ab1bda0fba4c	App\\Models\\ItemLoans
9d69b997-c15e-40ba-a8ad-74b297f139ce	App\\Models\\ItemLoans:281
9d69b997-c2fa-47c1-ac2d-7d2ddec8263e	App\\Models\\ItemLoans:
9d69b997-c389-490c-9bee-84c89d9c8c7f	App\\Models\\ItemLoans:
9d69b997-c40d-4ab9-942d-47acab9b37df	App\\Models\\ItemLoans:
9d69b997-c493-43d2-940b-7a5cd2352cdf	App\\Models\\ItemLoans:
9d69b9ad-1e71-4e54-9d7f-7706e2d44c20	App\\Models\\Loans
9d69b9ad-2138-4db0-9ef9-5ce3f8d63548	App\\Models\\Loans:75
9d69b9ad-21f6-47a7-a6fe-b8cf2662d554	App\\Models\\ItemLoans
9d69b9ad-23d9-4a36-ae73-1adfeeb7b27d	App\\Models\\ItemLoans:474
9d69b9ad-257a-4d03-8686-69e54a91008a	App\\Models\\ItemLoans:
9d69b9ad-2616-4de6-8270-2cf8b1d37050	App\\Models\\ItemLoans:
9d69b9ad-26aa-4d27-a2fb-fe286a698e35	App\\Models\\ItemLoans:
9d69b9ad-b83f-4a64-8a83-d6b575db8bb4	slow
9d69bab8-80e3-4ea2-a3cf-fda0559f8296	App\\Models\\Loans
9d69bab8-8359-4468-b0cb-65f8a4a72d55	App\\Models\\Loans:75
9d69bab8-85a7-4a89-bbbe-4303ed3b3182	App\\Models\\ItemLoans
9d69bab9-af66-4f4f-8487-1400fbe92061	slow
9d69bad9-fdec-4694-b375-145db45b1fe1	App\\Models\\Loans
9d69bada-008d-4ff7-8ca6-cd22b8bf24f8	App\\Models\\Loans:74
9d69bada-0153-40d2-ac52-eacf3201ff73	App\\Models\\ItemLoans
9d69bada-0211-4fc8-9eb5-4f6525f1c560	App\\Models\\ItemLoans:276
9d69bada-03b9-4de1-9cda-24778f24b9e1	App\\Models\\ItemLoans:
9d69bada-0450-4a90-9224-c552809e1d33	App\\Models\\ItemLoans:
9d69bada-04dd-4b4a-88d5-4d085907faae	App\\Models\\ItemLoans:
9d69bada-0565-4447-a8ea-9ce11f96a079	App\\Models\\ItemLoans:
9d69bb08-0071-4e27-99ec-4f423124c182	App\\Models\\User
9d69bb08-9359-4fda-a0cf-b5fd784da9d6	slow
9d69bb08-93ba-4361-940f-30edf295edab	App\\Models\\User
9d69bb09-1cae-4be4-a490-276861f7f2ba	slow
9d69bb09-1d04-4aeb-8c06-190bf2896b63	App\\Models\\User
9d69bba8-1047-4530-9aae-31d57b51c4fb	App\\Models\\User
9d69bba8-ae02-4e34-b44c-08b19923f9e1	slow
9d69bba8-ae59-4f21-ad95-e5ed2560a52f	App\\Models\\User
9d69bba9-376f-4594-98ca-7b7c5435c2c1	slow
9d69bba9-37bd-4fea-abd6-a72fdf4bc17f	App\\Models\\User
9d69bbab-018b-43a3-97c3-d7e87e5835a4	App\\Models\\User
9d69bbab-cfd8-496d-a354-6a8620ee7171	App\\Models\\User
9d69bbac-7ab6-4dd5-8de4-2dd905873e4d	App\\Models\\User
9d69bbad-cc07-4d41-85d1-7d4f67d47d6e	slow
9d69c548-30e3-42da-98c5-8ec2551aaf08	App\\Models\\Menu
9d69c57f-afbe-43bb-9e76-10a69fd3c772	App\\Models\\User
9d69c582-8d10-4e71-bc68-b1b2163c7db3	App\\Models\\User
9d69c634-8e20-41d0-863e-ba817275f4cf	App\\Models\\User
9d69c650-cfde-4b69-96a0-aac77cb5e7bf	App\\Models\\User
9d69c659-ef58-42f9-9616-3eded7a62d5e	App\\Models\\User
9d69c661-c86a-4fa8-ae86-48b4d51fa79d	App\\Models\\User
9d69bbad-cc94-428b-9866-999f22229cdc	App\\Models\\Menu
9d69bbae-cee2-4a6a-ad66-82431c7db23c	App\\Models\\Menu
9d69bbf2-077c-41ff-9c75-0348586cfd89	App\\Models\\User
9d69bbf2-6a91-4083-b2c6-7155773cc585	App\\Models\\User
9d69bbf2-dac1-4852-9531-511b5f5d9c6d	App\\Models\\User
9d69bbf4-c1e9-4dab-bf53-5a14406e4cf4	App\\Models\\User
9d69bbf5-66e0-47d6-8df3-c7044d183994	App\\Models\\User
9d69bbf5-f676-4576-b33e-30b41c6c3412	App\\Models\\User
9d69bbf6-c0ca-4ce2-9d32-7f8b13d810a7	App\\Models\\Menu
9d69bbf8-1595-451e-b75f-733ab23a9314	slow
9d69bbf8-15fe-42c9-8b05-0a32deb5a0be	App\\Models\\Menu
9d69bc02-2485-49b8-8c64-02051e3d9516	slow
9d69bc07-ed5d-4b61-9e65-c3433a22bdab	App\\Models\\User
9d69bc08-6ca0-4e15-b502-be278850745a	App\\Models\\User
9d69bc08-cdea-4440-bc36-4d60d2d8ca2c	App\\Models\\User
9d69bc09-2b7f-4344-913d-821b6a0cc085	App\\Models\\Loans
9d69bc09-2dc9-407c-b6a2-f58a50f3d277	App\\Models\\ItemLoans
9d69bc21-7a2a-4288-9077-44e4216cb888	App\\Models\\User
9d69bc22-0213-47b5-a0bb-ce328cfad8a9	slow
9d69bc22-026c-477c-b18f-9978355eb634	App\\Models\\User
9d69bc22-6707-48a1-8fa1-dd3038f6811a	App\\Models\\User
9d69bc22-f191-4d1c-b2a6-b707ac7d2b63	slow
9d69bc22-f1e9-45ca-bd82-a4fd6eb55143	App\\Models\\Loans
9d69bc22-f3b7-4d76-8d20-ecc98803bac0	App\\Models\\ItemLoans
9d69bde6-86a2-4e4b-8d4e-088d80846cae	App\\Models\\User
9d69bde6-ec9e-4ebe-889b-63c5f00816e9	App\\Models\\User
9d69bde7-5692-4d27-b62b-dffa8a44f8fa	App\\Models\\User
9d69bde7-cbbf-4942-86ec-8139353be936	App\\Models\\Loans
9d69bde7-cdb8-48bd-806d-0b7856e1e61e	App\\Models\\ItemLoans
9d69bdea-481e-45c9-a8b2-7f9bbcda6a9e	App\\Models\\Menu
9d69be1a-f79a-43d8-8d71-2b7c98efde10	App\\Models\\User
9d69be1b-63a5-43a8-99ab-3c3bea668240	App\\Models\\User
9d69be1c-068f-47ab-9290-2bc60abdca7d	slow
9d69be1c-06ec-423d-88f0-331521ff5839	App\\Models\\User
9d69be1c-9d13-4213-b684-cb5268e8ba86	slow
9d69be1c-9d66-45e9-a688-a8eb96a75966	App\\Models\\Loans
9d69be1c-9f75-4be5-9ed7-a967a8237c19	App\\Models\\ItemLoans
9d69be1e-a0a8-47f4-b3c9-c4319e79fe65	App\\Models\\Menu
9d69be32-74b1-4e26-beba-da3e757023b2	slow
9d69be32-7532-4ac6-864c-df9822b80a45	App\\Models\\User
9d69be32-d73d-4fb1-825f-0e7de61dd049	App\\Models\\User
9d69be33-6010-4180-9a6e-82ec1825ee83	slow
9d69be33-6067-4e91-a7d4-e91899eb9680	App\\Models\\User
9d69be33-eb74-474c-aab3-639d634b0170	slow
9d69be33-ebd1-4438-9663-4607cda6a3b8	App\\Models\\Loans
9d69be33-edb1-44fd-8c2d-886fe14484b4	App\\Models\\ItemLoans
9d69be36-04c1-4875-9ac1-60ea22750625	slow
9d69be36-0520-4356-952d-94e614d84534	App\\Models\\Menu
9d69be46-9648-41a0-9f64-ae8f1a5822a6	slow
9d69be46-9698-4e89-8f75-d1b5d130d283	App\\Models\\User
9d69be46-f8a8-41fe-8710-fb25fe07af3b	App\\Models\\User
9d69be47-5974-4bcf-b576-e32b419eafa0	App\\Models\\User
9d69be47-e725-4850-b519-8f8cdb6f0906	slow
9d69be47-e779-47c0-ab58-33f59e674ab0	App\\Models\\Loans
9d69be47-e929-4266-b3e6-bf7389446e71	App\\Models\\ItemLoans
9d69be49-c3ef-49c9-9d06-a1b241104e5d	slow
9d69be49-c485-4df0-9664-5a67ed84bcad	App\\Models\\Menu
9d69be7c-9ef7-4048-928f-8c542bfd1806	slow
9d69be7c-9f4c-4ab7-b7fd-c16410c9fd60	App\\Models\\User
9d69be7d-0c89-42c1-b251-074f7ec605e1	App\\Models\\User
9d69be7d-7e00-4c78-a196-2152f7887a63	App\\Models\\User
9d69be7e-187f-4653-8c24-61b999442b36	slow
9d69be7e-18c8-4cc9-9f2a-1033b53aef97	App\\Models\\Loans
9d69be7e-1a93-4c18-bd9b-a0ca59dc3b92	App\\Models\\ItemLoans
9d69be80-7762-43c5-a8d8-9aee7292222e	App\\Models\\Menu
9d69be94-fd7c-42bc-9368-2ade14e97eae	slow
9d69be94-fdcf-4975-a923-61ed2d835ba7	App\\Models\\User
9d69be95-88ef-448d-95fb-b946b6fc7876	slow
9d69be95-893c-40dc-9134-a77500d1e70e	App\\Models\\User
9d69be95-ee1c-4ae3-bcec-8bc90313ab8d	App\\Models\\User
9d69be96-5378-4964-bd24-d88ac980577e	App\\Models\\Loans
9d69be96-5531-4aaf-8e15-6adcf8b3583f	App\\Models\\ItemLoans
9d69be98-04e8-4340-9e5d-642861c98d0c	App\\Models\\Menu
9d69beac-d31a-481a-9b91-f2628788ffa7	App\\Models\\User
9d69bead-6b2d-431a-875f-b67cd1d93b9b	slow
9d69bead-6b98-403d-bf56-e65862d7e860	App\\Models\\User
9d69bead-ff6c-4c0a-b105-09559c95fc93	slow
9d69bead-ffda-44c4-9732-068758ae66ca	App\\Models\\User
9d69beae-8d7e-484d-920a-0a8794fd7ffa	slow
9d69beae-8dd0-41d0-89b9-1a908e4141dc	App\\Models\\Loans
9d69beae-8fdc-4fce-b269-1cefc6c361a1	App\\Models\\ItemLoans
9d69beb0-9dec-4782-b01f-8778d5b17fec	slow
9d69beb0-9e50-4cab-98d2-44b54e5b39af	App\\Models\\Menu
9d69becc-06bd-4aa3-9e37-71603e514622	App\\Models\\User
9d69becc-9223-4612-b5fe-f5ac1b71cc64	slow
9d69becc-9274-4007-a09e-7d854fe539e7	App\\Models\\User
9d69becc-f977-483d-a19a-5f42b247e796	App\\Models\\User
9d69bece-9656-46dd-99cf-2a0dc767f8b2	App\\Models\\User
9d69becf-432a-4920-89d5-a7a603437427	App\\Models\\User
9d69becf-f1d5-414a-83ae-1a7c0e0a682a	App\\Models\\User
9d69bed0-70e1-4c71-9e24-f65e292304c0	App\\Models\\Loans
9d69bed0-72bc-45d9-87a5-a5dc22c25320	App\\Models\\ItemLoans
9d69bed1-230f-4909-b556-5af511099601	App\\Models\\Menu
9d69bed2-ee34-4868-aa7c-9e4254723969	App\\Models\\Menu
9d69bf07-130b-4d9c-9781-8615df87d8a8	slow
9d69bf07-1391-4f21-bb21-7471192535e4	App\\Models\\User
9d69bf07-a46c-4691-b9f7-08120981b3e3	App\\Models\\User
9d69bf08-1d1a-496c-9013-089d846ff23d	App\\Models\\User
9d69bf08-9163-457d-87e0-4a6ce40618a4	App\\Models\\Loans
9d69bf08-9361-4b5e-bace-2d3493b0ab52	App\\Models\\ItemLoans
9d69bf0a-7986-44a1-8334-81b5a57632d5	App\\Models\\Menu
9d69bf30-16c6-43f4-9361-618d241d8f07	App\\Models\\User
9d69bf30-76b1-4251-a3dc-cf2da54a35bb	App\\Models\\User
9d69bf30-de8b-4d31-8a48-3214d5556119	App\\Models\\User
9d69bf32-5c54-4156-8edb-d278d2a2a67d	App\\Models\\User
9d69bf33-2054-4de2-b707-97925219d573	slow
9d69bf33-20f1-4d38-9f0c-2ab221512c6c	App\\Models\\User
9d69bf33-be58-42d5-8fc5-a62026974444	App\\Models\\User
9d69bf34-5e78-40e8-97e7-04aa10603977	slow
9d69bf34-5ec5-400d-8c6d-70f411a11939	App\\Models\\Loans
9d69bf34-60b3-42e7-b36f-82e82703743c	App\\Models\\ItemLoans
9d69bf35-0db0-4d7b-ba02-3162e844e248	App\\Models\\Menu
9d69bf36-1d7a-4d63-9b92-52869a9b494a	App\\Models\\Menu
9d69bf48-dfb7-483c-8207-195262e4ff21	App\\Models\\User
9d69bf49-4970-4588-afa2-5c081e7dcdaa	App\\Models\\User
9d69bf49-ac46-4ce9-865b-814cb11143f2	App\\Models\\User
9d69bf4a-160a-4c20-a115-86de92f71ceb	App\\Models\\Loans
9d69bf4a-1858-4f4d-beea-a0f12f2ed13d	App\\Models\\ItemLoans
9d69bf4b-f565-4131-9d02-dd1e40a13d72	App\\Models\\Menu
9d69bf64-4215-4970-88e9-8c771777b3c3	App\\Models\\User
9d69bf64-a760-4695-abce-84bf105db1f6	App\\Models\\User
9d69bf65-3354-467f-a79f-a9544d48918f	slow
9d69bf65-33ab-47ee-a3ef-15509bfbe77d	App\\Models\\User
9d69bf65-97b5-45ad-a150-3e675644f530	App\\Models\\Loans
9d69bf65-9965-403f-8be8-01e625089b35	App\\Models\\ItemLoans
9d69bf67-6213-4077-acaa-08cb39cfb342	App\\Models\\Menu
9d69bf78-4531-417f-a3b2-a34625c16575	slow
9d69bf78-459c-4c7d-a945-b1300500486c	App\\Models\\User
9d69bf78-a858-4467-a187-fc433f08edd8	App\\Models\\User
9d69bf79-0ed3-4542-b3df-12ae07b54ac0	App\\Models\\User
9d69bf79-74c8-4496-8b83-353f69e63411	App\\Models\\Loans
9d69bf79-76b1-49a8-b2d8-606da7f29c19	App\\Models\\ItemLoans
9d69bf7b-51ca-4645-8d94-52028b759c7e	App\\Models\\Menu
9d69bfc3-f300-4c0c-b492-fea6261ae279	slow
9d69bfc3-f36a-4040-9247-1845dfd24b99	App\\Models\\User
9d69bfc4-811a-42b0-8486-f2865fb2c9f7	slow
9d69bfc4-8169-418d-8b23-173379ee6772	App\\Models\\User
9d69bfc4-e471-4170-ab60-98bbc8db7618	App\\Models\\User
9d69bfc6-9c9f-49b1-b01c-e932e9c8e7ba	slow
9d69bfc6-9d17-4c7d-9b3b-5d87a4247d8c	App\\Models\\User
9d69bfc7-373f-4abf-a2d8-c981685a0ccb	App\\Models\\User
9d69bfc7-d570-43bc-a8b6-9f6943f52805	App\\Models\\User
9d69bfc8-4902-4471-a0b8-a42d3f48a603	App\\Models\\Loans
9d69bfc8-4ac6-4cb6-b990-aa487dbd22da	App\\Models\\ItemLoans
9d69bfc8-ee58-4f9e-b868-afdea619945e	App\\Models\\Menu
9d69bfca-a6ad-4921-b2eb-0cbab5fec4a6	slow
9d69bfca-a6ff-4fa9-b3a3-533247358679	App\\Models\\Menu
9d69c033-c925-4b5e-8d70-170bbfaeac8f	slow
9d69c04e-744d-47ea-920b-89d1cb28b021	slow
9d69c0cc-acfc-446b-bb04-9319c8e1f1b4	App\\Models\\User
9d69c0cd-3384-4e69-9a03-9cb3d52c1c7d	slow
9d69c0cd-33da-4e94-b355-6bca60f3068d	App\\Models\\User
9d69c0cd-94c0-46ba-bca1-bdccc1ebe205	App\\Models\\User
9d69c0cf-ee7d-4c58-8466-87a2d7144b80	App\\Models\\Menu
9d69c0d1-8cb0-4bfc-a582-1cf4fe490e76	App\\Models\\Menu
9d69c0ef-425e-499b-a9b1-106af5c7772c	slow
9d69c0ef-42b8-487f-87f0-444a2a9cb039	App\\Models\\User
9d69c0ef-a099-478e-9829-75a2a9676f8e	App\\Models\\User
9d69c0f0-25f0-4ba8-9f5f-3f42012dbc21	slow
9d69c0f0-263e-4591-b251-93d4e7980e2f	App\\Models\\User
9d69c0f2-92bd-4bb4-843f-b9e21011c503	slow
9d69c0f2-9363-4fc3-bd61-c10c053ed651	App\\Models\\Menu
9d69c0f4-0260-4325-ab25-8c006ec2c49b	slow
9d69c0f4-030b-401e-8f94-3640b601de22	App\\Models\\Menu
9d69c11a-1400-4dc7-ac00-832df56f79d5	App\\Models\\User
9d69c11a-a696-4ea6-a8d8-c0d43bc280e7	slow
9d69c11a-a70a-488c-99c5-d4981f27cb04	App\\Models\\User
9d69c11b-3bf5-4958-a13e-7e24ca6d0b56	slow
9d69c11b-3c54-4c09-b59c-cfd6c87371f2	App\\Models\\User
9d69c11d-56a0-4d62-ab8b-97dde4bc7a90	App\\Models\\Menu
9d69c11e-b6d7-4e92-8bf3-174ff0cacb1b	App\\Models\\Menu
9d69c13a-95c9-4d83-a763-2da095106480	slow
9d69c13a-961c-4777-a7b2-0bcebf599682	App\\Models\\User
9d69c13a-feb9-4438-915b-ba7238982086	App\\Models\\User
9d69c13b-6600-4dcf-888c-bec69a5b391e	App\\Models\\User
9d69c13d-bed6-41d5-ac18-f4ddb5a82842	App\\Models\\Menu
9d69c13f-5a18-4b4f-9824-faeeab060976	slow
9d69c13f-5a87-4d74-b95a-ee67cf00f228	App\\Models\\Menu
9d69c150-9637-4a9e-b2aa-d06d65ff9a49	slow
9d69c150-968f-4172-b186-7c2d6753310f	App\\Models\\User
9d69c150-f957-4b91-8ccc-83a38a464ef5	App\\Models\\User
9d69c151-5933-42da-8c5f-9ea8bc4f6998	App\\Models\\User
9d69c154-01c3-4a8d-a556-107f7852c606	slow
9d69c154-024c-45f2-9d48-b77cddc49c77	App\\Models\\Menu
9d69c155-79df-4686-8769-70da3405b5b3	slow
9d69c155-7a69-4b51-b6b0-86be71bcf186	App\\Models\\Menu
9d69c169-56a0-4301-bec6-0f3e4a72cc38	App\\Models\\User
9d69c169-b738-4899-9ccb-8617287ef370	App\\Models\\User
9d69c16a-4626-4273-9bd7-fadd072e40ba	slow
9d69c16a-4687-49da-80ab-fffd7892823a	App\\Models\\User
9d69c16c-9192-43f8-8fb7-65f434300346	slow
9d69c16c-9241-4ea1-be83-b9763e14cd49	App\\Models\\Menu
9d69c16e-22e5-45a9-a596-25266dd2a761	App\\Models\\Menu
9d69c2df-34d1-4d04-85a3-10c25bab2804	slow
9d69c2e6-3061-467f-871c-32af8d377ccd	App\\Models\\Menu
9d69c3ae-f7f4-4c26-bbc0-08b4fc167755	slow
9d69c3ae-f852-4a64-89eb-25a2cba8d1b1	App\\Models\\User
9d69c3b4-4d95-400d-a49b-25808c307cca	App\\Models\\Menu
9d69c3f1-1bb4-41cb-adf9-fb16dc2d8d1d	App\\Models\\User
9d69c400-cd46-469b-a899-e7acbe1d4d99	App\\Models\\User
9d69c404-b9ee-4e10-bfcc-5cb2945fbfd1	slow
9d69c404-ba8e-4e31-a12f-f993b0540e25	App\\Models\\Menu
9d69c44a-194d-433b-8d2b-004fb6f574aa	App\\Models\\User
9d69c492-d461-4177-aee0-0b56216ee818	App\\Models\\User
9d69c498-119a-44dd-aade-dc0c0c7ed835	slow
9d69c498-126b-4528-8596-5e76390b7b6b	App\\Models\\Menu
9d69c4d2-91df-40ce-a70f-08fe36518247	slow
9d69c4d2-923d-4407-b00b-c20ff7bc4bd8	App\\Models\\User
9d69c4d6-3bbd-4763-99c2-a954574eb01c	slow
9d69c4d6-3c56-4c92-8356-c2265659b3e7	App\\Models\\Menu
9d69c4e1-7584-4dd6-8e08-d7436704436d	App\\Models\\User
9d69c4e4-95ee-4d7a-ae12-6419a0fcdfdf	App\\Models\\User
9d69c4f2-a35f-473e-9533-c9ccf3879843	slow
9d69c4f2-a3ae-43c4-b54a-39341a77ceb5	App\\Models\\User
9d69c4f5-516a-424a-8f32-e925f397269d	slow
9d69c4f7-ffc2-42c4-9e55-158c3109cdab	App\\Models\\Menu
9d69c502-027f-46f4-a7b4-190fe6b1cb42	App\\Models\\User
9d69c506-f49d-4809-8539-edfa5368ab01	App\\Models\\Menu
9d69c539-3e74-4526-acfc-b82ea8437f14	App\\Models\\User
9d69c53e-0363-4b63-bfcb-0040b1524e05	App\\Models\\Menu
9d69c544-e1a7-46da-8c0a-7c65a38c1f3a	App\\Models\\User
9d69c548-ec7a-4e58-b1d3-f0a71eb88035	App\\Models\\Menu
9d69c580-1ef8-489a-94ec-89a93cdee3c5	App\\Models\\User
9d69c583-8cd0-45d8-b32d-9f9976d520bc	slow
9d69c583-8d5a-4ff9-bc89-b62f976d0d63	App\\Models\\Menu
9d69c649-a282-491d-840a-56c296dc5b1f	App\\Models\\User
9d69c654-b09a-41c3-a440-e81082f0c1e2	App\\Models\\User
9d69c65c-3805-4949-850b-c50702095273	App\\Models\\User
9d69c672-968f-4fee-8f0f-72a47379fd6a	App\\Models\\User
9d69c672-98ee-4747-b512-f8167c800fd1	App\\Models\\User:22
9d69c6f1-c7b8-4af1-baea-78b61d0e088b	App\\Models\\User
9d69c7ed-091d-4bc9-8c41-498b1bfe0a32	App\\Models\\User
9d69c7ed-f617-4b59-8fd1-00009100ec09	App\\Models\\User
9d69c7f0-bc1e-464a-8d27-1770d1981f86	App\\Models\\Menu
9d69c80d-63ec-47f0-acdc-e369411ee814	App\\Models\\User
9d69c80e-2a41-495a-b471-5ca8952be317	App\\Models\\User
9d69c810-56dc-4b8d-a714-a8726eb8a7a7	App\\Models\\Menu
9d69c81f-6d7a-4b03-858b-6efde09eca42	slow
9d69c821-0938-4ab9-bf15-5d3973a280d4	App\\Models\\User
9d69c86a-8b13-444f-a475-fd47c7d5e785	App\\Models\\User
9d69c86c-32e1-41ed-833a-872917e01130	App\\Models\\Menu
9d69c88d-f2bf-444d-afdb-911ac250600f	slow
9d69c88d-f30d-4d86-9c29-f0acdd18362c	App\\Models\\User
9d69c890-d591-42df-9b17-694ef28997b6	slow
9d69c890-d5e6-4cd2-9e0b-d1eb7f165c5c	App\\Models\\User
9d69c892-c905-4325-8e97-4ef31b0aef7a	App\\Models\\Menu
9d69c8a1-dfb7-455b-96fd-f0e01de19af5	App\\Models\\User
9d69c8a3-d0e5-4a45-ace7-d1107c4c7a82	slow
9d69c8a3-d164-4426-ba3c-826cb9330ff3	App\\Models\\Menu
9d69c8d7-bc7b-4758-93dc-f01d080106c1	slow
9d69c8d7-bce5-4afb-b90c-1560f4ec1ba6	App\\Models\\User
9d69c8da-4144-4c65-adfa-3b7784dae456	App\\Models\\User
9d69c8db-f395-4a97-8c99-ab8e032a1799	slow
9d69c8db-f42c-4653-b5e6-dcafde27649b	App\\Models\\Menu
9d69c92a-e492-4dff-b54a-6bd9c2f6dcce	App\\Models\\User
9d69c92d-86ad-4136-9070-8f7168ec86e6	App\\Models\\Menu
9d6b3124-3395-42ad-a589-e20e0526c599	App\\Models\\User
9d6b3127-0df9-4707-9ca9-46b6c039a11e	App\\Models\\Menu
9d6b3147-0b92-4e0b-8634-da470ba7b2cb	slow
9d6b3147-0be4-4550-b1b5-04f7f6f22eed	App\\Models\\User
9d6b3147-9e5e-4e6a-9cad-d545a022ad6b	slow
9d6b3147-9eaa-4725-ae8b-ac4f1c608290	App\\Models\\User
9d6b32ae-51eb-4bda-a8ea-f37f670e5f1b	App\\Models\\User
9d6b32ae-d24d-46a1-8f38-e71de57e11c4	App\\Models\\User
9d6b32b0-3d05-4cc0-875e-19c8457ec916	App\\Models\\Menu
9d6b330e-ffb8-4275-8b58-1d892eb8090b	App\\Models\\User
9d6b330f-7b6f-44c6-af81-53d12a2da9d7	App\\Models\\User
9d6b3311-0629-43f7-8b36-2108cb513375	slow
9d6b3311-0686-4f94-9a94-fa1108661cc1	App\\Models\\Menu
9d6b3334-01fc-4539-9d95-570805010090	slow
9d6b3334-a93a-4967-8010-777654e16c9c	slow
9d6b3334-a99d-4219-83fa-66ca0d5a4976	App\\Models\\User
9d6b3335-122c-4aa4-9f2a-9f34eadd30c8	App\\Models\\User
9d6b3336-0522-4e05-8f81-0fc8e57a67bb	App\\Models\\Menu
9d6b3367-cab4-4901-bd3c-3ff7d41c7e3d	slow
9d6b3368-8e60-4c3b-9174-9105c69d59bb	App\\Models\\User
9d6b3368-f857-48a3-93a1-bf36c1d47e00	App\\Models\\User
9d6b336a-589c-4df7-9647-10ae235c2567	App\\Models\\Menu
9d6b33b3-9188-495d-bce2-dd2cf3bb6d35	slow
9d6b33b4-28af-41c4-bdcc-793c32b756ac	App\\Models\\User
9d6b33b4-be40-464a-a87a-ee80f2d1dcae	slow
9d6b33b4-beba-4d75-ab73-c08dc167e33b	App\\Models\\User
9d6b33b5-bc0e-4397-a6fd-b490af028bac	App\\Models\\Menu
9d6b33c0-dca7-4aab-9902-2239f32ed0d6	slow
9d6b33c0-dd1c-4517-aa9d-2176329397f8	App\\Models\\User
9d6b33c1-6881-4ad2-9ab7-fc231a3a58fd	slow
9d6b33c1-68e6-474a-b7e2-d0db7fe0416a	App\\Models\\User
9d6b33c2-e6e7-435c-8ad4-91b82f25d6eb	slow
9d6b33c2-e745-46d3-8b50-d27f915830ab	App\\Models\\Menu
9d6b33e1-5c66-4ada-ba1f-3b951d461d05	App\\Models\\User
9d6b33e1-f9e8-43c4-aba1-6516651167c6	slow
9d6b33e1-fab5-4b75-a066-15e991c66c6f	App\\Models\\User
9d6b33e2-f595-42e0-81c6-830591771948	App\\Models\\Menu
9d6b33fb-76ea-4915-acbe-40f24cdf0789	slow
9d6b33fc-0560-4f75-a296-255c209c89e2	App\\Models\\User
9d6b33fc-7b9c-44cf-9c7c-0196c9690683	App\\Models\\User
9d6b33fe-ef1f-4550-98a3-d766568eef81	App\\Models\\Menu
9d6b3412-7da2-4f68-8315-c061a44697d6	slow
9d6b3413-0c8a-4b82-bf69-f10adba6cbb5	App\\Models\\User
9d6b3413-77f8-4a98-afce-a9589494e8ac	App\\Models\\User
9d6b3414-9026-4997-806e-df356e85cd8a	slow
9d6b3414-908a-44a7-b279-528e2151a709	App\\Models\\Menu
9d6b38d2-139f-4f66-9e3d-fd34d424b23c	App\\Models\\User
9d6b38d2-b38a-41ed-bbc7-6a5952b38824	slow
9d6b38d2-b3f4-48f4-9124-cdbbf4c0b442	App\\Models\\User
9d6b38d4-0c0f-4bec-af5b-73afa091c2ae	App\\Models\\Menu
9d6b38e3-5b49-4d32-b500-253f50d0916c	slow
9d6b38e3-db5f-40a3-ae26-b84fefde451a	App\\Models\\User
9d6b38e4-48fe-4ebf-8490-656e711740e5	App\\Models\\User
9d6b38e5-4263-4830-9578-a55ee3c719fa	App\\Models\\Menu
9d6b39f3-f8aa-41dc-b27b-542a77d8080d	slow
9d6b39f3-f918-444c-ae7b-6f75baab8008	App\\Models\\User
9d6b39f4-7379-4408-9dd3-32befd4ab81d	App\\Models\\User
9d6b39f5-cb79-429f-800c-947255a4833b	App\\Models\\Menu
9d6b3a20-c732-4590-aa3e-d149899e5c9e	App\\Models\\User
9d6b3a21-2c5f-4b2c-902b-1b70574e1038	App\\Models\\User
9d6b3a22-26d2-4817-be6b-f0dc2625fc33	App\\Models\\Menu
9d6b3a4b-da04-499d-9d7a-22e480f8186f	App\\Models\\User
9d6b3a4c-4337-4d1d-bc67-20c3edd524f5	App\\Models\\User
9d6b3a4d-9b3b-4014-b7dd-e39eca88265e	App\\Models\\Menu
9d6b3a67-3694-410c-bb78-b76c2741598b	slow
9d6b3a67-bf83-40c7-b033-b7233965ba36	App\\Models\\User
9d6b3a68-245b-407b-b6d7-1a8376a9cc42	App\\Models\\User
9d6b3a69-0c21-4725-8364-aff8f68131a1	App\\Models\\Menu
9d6b3b7d-a8b8-4df9-bc5c-27ccab67ff14	App\\Models\\User
9d6b3b7e-3059-4d4e-9bb0-468dd91e051a	App\\Models\\User
9d6b3b80-5454-4cca-a1e8-69d422f169e7	App\\Models\\Menu
9d6b3bd9-20bb-4ba3-b8ea-f4ed6cfd0bc6	App\\Models\\User
9d6b3bd9-bc4d-4198-9d3d-bdb84fa580df	slow
9d6b3bd9-bc9a-4684-ab60-d34498e959cc	App\\Models\\User
9d6b3bdb-b121-4a05-925b-690535c2cc44	App\\Models\\Menu
9d6b3c82-6a73-4680-a16c-540dfbceb6cd	App\\Models\\User
9d6b3c82-d49e-4a91-b4d3-ea0b02693971	App\\Models\\User
9d6b3c84-ee19-49e5-a2bc-bed990064f64	App\\Models\\Menu
9d6b3cfd-4382-445c-831b-9ce7911e5404	slow
9d6b3cfe-14dd-4766-8f0e-035b70ef6723	App\\Models\\User
9d6b3cfe-8996-483f-90c7-3c416b6c7a34	App\\Models\\User
9d6b3d00-9527-470e-8836-24ddfa137f3a	App\\Models\\Menu
9d6b3d5a-2004-4d73-8e89-a1eb7a7acc55	App\\Models\\User
9d6b3d5a-8a2a-4c5b-9339-573bc085bfe9	App\\Models\\User
9d6b3d5b-d406-4f4c-8e41-e2fe6d139a79	App\\Models\\User
9d6b3d5c-4070-4c27-8bd8-38db949afb06	App\\Models\\User
9d6b3d5e-4e1a-4325-9769-9d0b64db9254	slow
9d6b3d5e-4e8b-43ff-b2ca-4b047d69802f	App\\Models\\Menu
9d6b3dc4-7791-43f5-9716-b9ac6ea24917	App\\Models\\User
9d6b3dc4-e6c1-4c5c-acde-3c179bc57d2e	App\\Models\\User
9d6b3dc7-4dd6-41e1-ba37-160828dc611f	App\\Models\\Menu
9d6b3dd0-e8b0-4235-b2a7-4d65991cce95	slow
9d6b3dd0-e922-4953-ac9e-18234612bf9f	App\\Models\\User
9d6b3dd1-4fa0-4396-8bd1-61fed544be7f	App\\Models\\User
9d6b3dd3-0bf1-4d86-9eb4-e51640b1cad5	slow
9d6b3dd3-0c74-4737-9d76-1303a40cc7ea	App\\Models\\Menu
9d6b3df3-e148-48ab-a7e4-f4befaafb47d	slow
9d6b3df4-5c6b-4008-8789-850fda7f0085	App\\Models\\User
9d6b3df4-c7a9-4d97-9022-ac704ae1089e	App\\Models\\User
9d6b3df6-d778-4460-a514-a2115d03da1c	slow
9d6b3df6-d7c4-4d40-a17c-9db3b5c06c61	App\\Models\\Menu
9d6b3e34-3f10-4854-9ffc-48f1602ae59a	App\\Models\\User
9d6b3e34-a3da-4cec-8a16-acd0fbe31fd0	App\\Models\\User
9d6b3e36-a08b-40d0-8ea6-d74b4d617910	slow
9d6b3e36-a10c-46b6-a40a-ab6ed97d5b4f	App\\Models\\Menu
9d6b3e70-c7a2-4f46-a486-0d8809f957e5	slow
9d6b3e70-c7f8-42cc-a924-8d3e7844b397	App\\Models\\User
9d6b3e71-2de9-4b89-a289-0b52b3ab16b1	App\\Models\\User
9d6b3e73-183c-4049-a5cd-08cd61f9336a	App\\Models\\Menu
9d6b3e9a-8e7c-44bf-aa74-a99271615606	App\\Models\\User
9d6b3e9a-f26f-4646-be92-2ebcbb560045	App\\Models\\User
9d6b3e9c-a647-4cd1-95d9-9e6c5877b747	App\\Models\\Menu
9d6b3f93-dd74-4db6-90d1-e4c76de9015b	slow
9d6b3f94-7f2f-4962-ba8d-1041f5d52dbc	slow
9d6b3f94-7f92-4f86-adce-4335e85271f6	App\\Models\\User
9d6b3f94-e4cf-473d-8f72-6d9152aa8ee5	App\\Models\\User
9d6b3f97-11d0-4dd9-89a3-feff22825022	slow
9d6b3f97-1249-4500-8132-5c73ce09b35f	App\\Models\\Menu
9d6b3fbb-5146-41e3-b56e-ae3542d8edb7	slow
9d6b3fbb-51b1-4451-993c-6c1c5c85ce69	App\\Models\\User
9d6b3fbb-bff2-48b9-ada0-bf863eac5ba7	App\\Models\\User
9d6b3fbd-998a-4760-8f48-d11429ffb031	App\\Models\\Menu
9d6b40c6-9882-474e-b3dd-29debe7e145c	App\\Models\\User
9d6b40c7-0846-41a4-a42a-dfdddc876440	App\\Models\\User
9d6b40c8-f4ff-433f-b403-fc53039dfab0	App\\Models\\Menu
9d6b40da-77f4-4900-9096-68baafea51c6	slow
9d6b40db-1a9d-486b-a229-c32bff1f0128	slow
9d6b40db-1b0e-4159-a6fc-a4a5bca5cded	App\\Models\\User
9d6b40db-ac44-4986-b0c9-0239497f2c55	slow
9d6b40db-aca4-4677-ac39-d6ff192a9aa3	App\\Models\\User
9d6b40dd-9860-4f4a-9319-38d2fa6dde46	slow
9d6b40dd-98bf-45ac-a817-6b3287642c00	App\\Models\\Menu
9d6b40f8-c139-4efc-9df9-cee565dd70e5	slow
9d6b40f9-4388-43b4-b118-289d079d2255	App\\Models\\User
9d6b40f9-ae41-4b62-8b1c-1bfad94b6f38	App\\Models\\User
9d6b40fc-00a9-48a2-a392-91152f2b1117	App\\Models\\Menu
9d6b40fd-cf0d-4948-9333-20486e09dd48	slow
9d6b40fe-4ce4-4d62-8634-4617c5af79ac	App\\Models\\User
9d6b40fe-b3e0-49d8-b39a-a70ebca64335	App\\Models\\User
9d6b4100-70ee-4e3d-b6b0-c86a7c87b7fb	App\\Models\\Menu
9d6b4172-22e9-4ef5-8f86-00850a6d341f	slow
9d6b4172-2348-4da6-a0ff-f47645140a63	App\\Models\\User
9d6b4172-8f8f-4a14-86d3-7bf6b9a320aa	App\\Models\\User
9d6b4194-6f11-4687-9070-104faf1e27e2	App\\Models\\Menu
9d6b423a-f0b4-4eed-8e49-dcf7020540e7	slow
9d6b423a-f10f-443d-abaa-6f1590094994	App\\Models\\User
9d6b423b-4eae-430f-a12c-fdb48b8c15e0	App\\Models\\User
9d6b423d-83db-4fa4-969f-24d031d73273	App\\Models\\Menu
9d6b42c9-ccfe-4138-badc-2366fcdd753f	App\\Models\\User
9d6b42ca-6bb7-4dbf-95d4-a432fabc83b3	slow
9d6b42ca-6c0d-4906-b57d-843db1ddbc1c	App\\Models\\User
9d6b42cc-778f-44b3-8c5d-6fec740e9a8a	slow
9d6b42cc-77da-4a5b-a67b-e4bc37a2c832	App\\Models\\Menu
9d6b4356-3abd-4686-b2f1-28197fb3547d	App\\Models\\User
9d6b4356-aa34-4a48-8382-e7e1810af655	App\\Models\\User
9d6b4358-c388-49ec-a087-d635bd0c6920	App\\Models\\Menu
9d6b43de-0752-4b3e-8d47-9fe196dd94a4	App\\Models\\User
9d6b43de-a181-42f3-84f5-fc2c4b602ec9	slow
9d6b43de-a1da-4ef3-b1f2-47c27c524d6f	App\\Models\\User
9d6b43e0-a43c-4514-b9b9-01fd0a08efd3	App\\Models\\Menu
9d6b4453-0f17-43d3-a06e-62aa30d18227	slow
9d6b4453-a47d-49f6-8528-9fca9815fa36	App\\Models\\User
9d6b4454-2040-4de2-831c-50a997c08825	App\\Models\\User
9d6b4456-1a7a-428e-b219-05ff7d359afc	App\\Models\\Menu
9d6b445f-7c6f-45c2-8b95-9a79da561f72	App\\Models\\User
9d6b4460-21f7-452b-953b-a2ce7140a224	slow
9d6b4460-224a-461b-a6d0-9d73b6261ac0	App\\Models\\User
9d6b4462-1ef4-467d-8c64-d21062914805	slow
9d6b4462-1fc1-40c1-95dc-2503d9e00720	App\\Models\\Menu
9d6b44bd-e233-4743-bd7f-9b9e001e190a	App\\Models\\User
9d6b44be-4a6d-4831-9691-44235873aa56	App\\Models\\User
9d6b44c0-5881-469e-a3cc-e9bcf4723f5e	slow
9d6b44c0-58fb-4347-916c-62c0da330cbf	App\\Models\\Menu
9d6b44ea-3000-452a-a5dd-4bb40a9faec5	App\\Models\\User
9d6b44ea-9ff0-4f71-9c3a-595c6bb6c853	App\\Models\\User
9d6b44ed-c3aa-4755-a1e7-b5dc98bd2032	App\\Models\\Menu
9d6b44f0-9898-4b65-a662-df91ed0e1491	App\\Models\\User
9d6b44f1-2aa8-4879-af39-66c11bba36a9	slow
9d6b44f1-2af4-4d74-bbfb-67a0d1947df2	App\\Models\\User
9d6b44f3-00fa-4c51-b229-842016f53966	App\\Models\\Menu
9d6b453d-b778-4cf8-83b4-e5e18dc271ae	slow
9d6b453d-b86d-43df-a5e0-5e730045ff40	App\\Models\\User
9d6b453e-4891-4329-9550-121edf2ad559	App\\Models\\User
9d6b453f-ffe7-4c76-9dcb-c664dd219028	App\\Models\\Menu
9d6b4547-f9ac-4345-a13f-3b32e4d0c574	slow
9d6b4548-70bd-490e-bfd7-b4ed11a55f93	App\\Models\\User
9d6b4549-042f-4d91-ad92-37d383586322	slow
9d6b4549-0488-4783-9456-04fe999047f4	App\\Models\\User
9d6b454b-3771-4809-b1be-cdc7cd2b294f	slow
9d6b454b-37cd-4bdb-9f11-62299d4edc48	App\\Models\\Menu
9d6b4582-50bc-4d24-afd8-832305c90fc1	slow
9d6b4582-d518-4a54-a14e-38540ca013b3	App\\Models\\User
9d6b4583-7bbd-464c-9cfa-4c961daed606	slow
9d6b4583-7c31-4ea2-99be-bc8acfadf9ef	App\\Models\\User
9d6b4585-6951-4853-948e-5f71291b4420	App\\Models\\Menu
9d6b45b3-6e8f-40c0-8f24-aee08cf602f7	slow
9d6b45b3-d752-4f9f-b890-59832b5a9b6c	App\\Models\\User
9d6b45b4-5bbc-4d2e-b7bd-296bb148e590	slow
9d6b45b4-5c09-4e59-8e9b-1359158c1990	App\\Models\\User
9d6b45b6-98fc-478c-ab13-f7736f3c76ac	App\\Models\\Menu
9d6b45df-c029-486a-bf40-47fc5bdec48d	slow
9d6b45e0-7138-42ed-b652-fbc0426b4272	slow
9d6b45e0-71c5-4230-9a31-496c5f4a189e	App\\Models\\User
9d6b45e1-2045-41b4-941a-32525400d9f1	App\\Models\\User
9d6b45e3-4928-4580-bcdc-370538839356	slow
9d6b45e3-49b2-4b3d-9dba-559cfcc6f349	App\\Models\\Menu
9d6b45e6-bd82-457d-b2ec-f351926784d8	slow
9d6b45e6-be0b-40bc-8d08-7ca84499450e	App\\Models\\User
9d6b45e7-2cd8-4078-b702-12260d5fab90	App\\Models\\User
9d6b45e9-508c-4fd4-a5fc-86ae1035982d	slow
9d6b45e9-50d3-4744-a32a-9ad56f9cabb5	App\\Models\\Menu
9d6b466d-4d95-4af6-a78b-25e65013b1dd	App\\Models\\User
9d6b466d-f895-4881-b9aa-0a7a8730594d	slow
9d6b466d-f908-42c1-b8df-9f214956a1a1	App\\Models\\User
9d6b4670-a6e5-482b-af75-fa5cd67d3d92	slow
9d6b4670-a731-427d-a089-042acc3f5ea9	App\\Models\\Menu
9d6b4674-d649-499f-8505-3b00ef6b312d	slow
9d6b4675-79ed-456b-9f3c-9e52c1ac5cc5	slow
9d6b4675-7a6f-42fe-94c5-fc577fb4bd32	App\\Models\\User
9d6b4676-0da1-401e-8ff3-9925bf2cb484	slow
9d6b4676-0dee-42a3-833a-5253039f89bc	App\\Models\\User
9d6b4677-dff7-41e4-b84d-7e8e5718baee	App\\Models\\Menu
9d6b4729-7fb2-4a97-be04-eb2163039ef6	App\\Models\\Menu
9d6b47f9-9e1a-4850-9571-ec67edba9d32	slow
9d6b47fa-251f-4bc6-9fe2-35cb5a9bb97d	App\\Models\\User
9d6b47fa-8cc4-4378-beb9-826f27db1dc4	App\\Models\\User
9d6b482b-ed63-40c8-961b-84faceca36c8	slow
9d6b482b-edaf-4397-8733-f4acbaab9c28	App\\Models\\User
9d6b482c-5731-49ae-b8af-b11fce06c9f7	App\\Models\\User
9d6b482e-37ab-4566-bb1d-608d910efda8	App\\Models\\Menu
9d6b4882-9ca5-401f-841f-29ea9f854b04	App\\Models\\User
9d6b4883-1ab8-427d-b5de-bf1ef98176fe	App\\Models\\User
9d6b4885-1911-4611-98a0-1408f827f248	App\\Models\\Menu
9d6b493a-d906-47d2-959b-68dd18659a1f	App\\Models\\User
9d6b493b-3ab0-408a-8716-253a8f99496e	App\\Models\\User
9d6b493f-745d-41a3-96ef-235b0377a4ba	slow
9d6b4a3c-1544-4c01-9105-54decdc8c602	slow
9d6b4a3c-15a6-4725-a4d1-66a448456199	App\\Models\\Menu
9d6b4a87-7a18-4d1a-9b43-9be312ab5dc9	slow
9d6b4a89-7634-481c-ad60-c40ee09602b5	slow
9d6b4a89-76b7-4d7a-9c8e-4630f78836f4	App\\Models\\Menu
9d6b4ad8-9620-422e-a599-cc62ed7a3a4b	slow
9d6b4ada-9599-48cc-8c45-330451647c73	App\\Models\\Menu
9d6b4afc-7eb8-42ce-9144-00cf2c8d84a5	App\\Models\\Menu
9d6b4b43-d4bf-4ce2-93bb-c93d4d925214	App\\Models\\Menu
9d6b4b65-537c-47bf-81f3-0f179769de2d	slow
9d6b4b67-0a1f-4116-8b1e-3dfaf1af495c	slow
9d6b4b67-0ab8-4d6b-9524-f6fe769b0355	App\\Models\\Menu
9d6b4d08-a9f7-4011-b7c9-0082371cb0db	slow
9d6b4d09-1c72-434b-acec-ff0d3dd1b8a8	App\\Models\\User
9d6b4d09-84bd-469a-ab42-9f1098639175	App\\Models\\User
9d6b4d16-dce4-47f6-8ba9-a7e5e8f4e635	slow
9d6b4d1c-aedb-424a-addd-ce8899413c1a	App\\Models\\User
9d6b4d1d-200a-459f-bdeb-4cd8b59e3ee3	App\\Models\\User
9d6b4d3e-8a2c-450f-88d1-0b50233ebff0	App\\Models\\Loans
9d6b4d3e-9a73-4cf1-bc85-084435e31775	App\\Models\\Loans:87
9d6b4d3e-9b39-4af1-8bc4-fc9678746a5c	App\\Models\\ItemLoans
9d6b4d3e-9ccd-435f-8c24-c85bc64fca69	App\\Models\\ItemLoans:445
9d6b4d3e-a34c-4fcf-aebb-e41a4a43be17	App\\Models\\ItemLoans:
9d6b4d3e-a3cd-42c8-865b-257195aaf59f	App\\Models\\ItemLoans:
9d6b584b-0ab8-4103-9d6f-963ae2f335a0	slow
9d6b584b-0b0e-4303-9069-92100d00775a	App\\Models\\User
9d6b584b-7042-4b15-8956-faf9c986f1bd	App\\Models\\User
9d6b584b-d7ac-4c1e-9885-3e72a57d81bc	App\\Models\\User
9d6b584c-3869-4d5f-8f00-83b2a7b592ff	App\\Models\\Loans
9d6b584c-3a56-493b-babf-6567e0e61046	App\\Models\\ItemLoans
9d6b5895-4579-4161-9f66-e7f574e2bc77	App\\Models\\User
9d6b5895-ae30-45ed-8501-eedea4e961e4	App\\Models\\User
9d6b5896-106a-4571-95ea-c3556ae93424	App\\Models\\User
9d6b5896-77f1-470f-9cb2-ec6e6032b3d9	App\\Models\\Loans
9d6b5896-79d7-4fe7-a5cb-369e654b97a8	App\\Models\\ItemLoans
9d6b5898-f7d1-4f5d-a9fc-c167b1575318	App\\Models\\Menu
9d6b58c8-afc2-4ed5-ac7a-6beb75c1d50d	App\\Models\\User
9d6b58c9-1759-4c66-8789-c93ea289026d	App\\Models\\User
9d6b58c9-7836-4749-b3c4-87b8203bc073	App\\Models\\User
9d6b58c9-dde2-44d4-902b-367f3154f1aa	App\\Models\\Loans
9d6b58c9-dfe7-40ea-96f8-7d94d4124aef	App\\Models\\ItemLoans
9d6b58cb-b79c-4610-8442-34abccc2519b	App\\Models\\Menu
9d6b58e7-c3f0-4429-9bdb-c6a5d04b0253	App\\Models\\User
9d6b58e8-2d78-4579-a8d4-8e21f44c4bcc	App\\Models\\User
9d6b58e8-9c26-4a6c-bd17-efbeca03076d	App\\Models\\User
9d6b58e8-ffa6-426b-8046-e988628a7fec	App\\Models\\Loans
9d6b58e9-0183-4c16-a0ea-fa79d69e87da	App\\Models\\ItemLoans
9d6b58eb-2ab6-48f4-b8a2-d31791c29402	slow
9d6b58eb-2b16-46e0-a0b4-a00a5a85a1a0	App\\Models\\Menu
9d6b59a9-0215-4b4b-adfb-65b783871611	App\\Models\\User
9d6b59a9-9b77-4a1f-9e01-eb9762b0473d	App\\Models\\User
9d6b59aa-1c32-4ecd-afb9-ae4db23a5462	App\\Models\\User
9d6b59aa-8396-4b4c-aed7-828a91458bac	App\\Models\\Loans
9d6b59aa-8592-49bb-b027-6c9947f84fc5	App\\Models\\ItemLoans
9d6b59ab-bb38-4086-a082-73f968646126	slow
9d6b59ab-bb8d-4ab2-8149-576c49c764ca	App\\Models\\User
9d6b59ac-2346-496e-9d6f-1dcc76e7b21a	App\\Models\\User
9d6b59ac-8764-4a64-8b79-8e0af6a3dd67	App\\Models\\User
9d6b59ac-f3aa-49d4-b7ab-7f8a4ac1b8f5	App\\Models\\Loans
9d6b59ac-f5b3-4258-8aaa-40793a9fe07d	App\\Models\\ItemLoans
9d6b59af-50fe-4afd-bffd-a57fd8a8e4b4	slow
9d6b59af-5158-49e1-9afa-07b98a4ec820	App\\Models\\Menu
9d6b59e1-7bcd-4b0f-b76c-7ffaa541986b	App\\Models\\User
9d6b59e2-0e17-4252-af92-bbe780ab5a77	slow
9d6b59e2-0e74-4dec-a6a1-15c37d729915	App\\Models\\User
9d6b59e2-76b8-434d-9ca4-7af57b7c21e0	App\\Models\\User
9d6b59e2-e21d-40a4-99a2-7a5250516543	App\\Models\\Loans
9d6b59e2-e420-4609-92cb-88fb3765557f	App\\Models\\ItemLoans
9d6b59eb-51e4-4ab4-9761-162541b415c4	slow
9d6b59eb-e3cb-4927-be7b-985c58db7e18	slow
9d6b59eb-e421-46ee-9d94-1f1829807e19	App\\Models\\User
9d6b59ec-6ab6-4b33-9af2-c8e0f4d0e4a8	slow
9d6b59ec-6b33-4ee0-8b5e-cd2ae59c5588	App\\Models\\User
9d6b59ef-ae3a-4313-ab45-fa506d53239d	slow
9d6b59fe-76a4-42ab-9c4d-7c432fe61374	App\\Models\\User
9d6b59fe-fc43-435a-ab20-b3325e813625	slow
9d6b59fe-fcbe-40d0-945f-6557cbbb218a	App\\Models\\User
9d6b5a03-55a6-4471-a602-fd0c168efc6b	slow
9d6b5c24-87d7-46a2-95ad-a5ec24caee79	slow
9d6b5c24-8828-43ad-89a8-2d0a3f17b3dd	App\\Models\\Menu
9d6b5c3f-9fcc-446d-8a6e-72bd68e33912	App\\Models\\User
9d6b5c40-0066-4240-bf25-bbd7ba099b28	App\\Models\\User
9d6b5c41-cd47-42df-9478-d4a9745b5142	App\\Models\\Menu
9d6b5c9b-fda8-4527-875f-4f4bb2d9abd7	App\\Models\\User
9d6b5c9c-d2d6-4985-bd1a-0571156fa098	slow
9d6b5c9c-d337-4e9a-9067-0455022a3933	App\\Models\\Menu
9d6b5ca4-7205-43bd-83a3-b10f0b46e710	App\\Models\\Menu
9d6b5cb6-65ad-4250-88eb-dfc0cd711833	slow
9d6b5cc5-d9e3-4657-9fa6-b4a7718ecf77	slow
9d6b5cc5-da49-41fb-9f95-6e76bec1a3ff	App\\Models\\User
9d6b5cc6-46a5-4387-acb1-fd741e43a8bc	App\\Models\\User
9d6b5d65-8ad4-4e38-8dfa-de293db68dd9	App\\Models\\User
9d6b5d65-f47b-4755-b0f1-7b959357a566	App\\Models\\User
9d6b5d67-d40e-4349-88e4-d33e7efa2e75	App\\Models\\Menu
9d6b5d7e-830b-4c0a-a3bf-f6d12c0366dd	App\\Models\\User
9d6b5d7f-120a-4854-9e36-f89f8888c342	slow
9d6b5d7f-125d-4553-a9d3-a8354cdf1d35	App\\Models\\User
9d6b5d80-bd22-4b11-8203-4a01fdd016d6	slow
9d6b5d80-bd6a-4ca0-8e52-e75437dbd407	App\\Models\\Menu
9d6b5d8c-9314-4006-a3d1-c601b50173a4	slow
9d6b5d8c-935e-4020-b45d-9aa11cd80066	App\\Models\\User
9d6b5d8d-1dc3-481c-9aa7-8d6a096944ad	slow
9d6b5d8d-1e19-42fb-8d03-25b74d02e232	App\\Models\\User
9d6b5d8f-34b4-4a99-a024-69fa1b0ed5c8	slow
9d6b5d8f-3504-4348-a55b-df251b2750a6	App\\Models\\Menu
9d6b5dc9-b61e-4dfd-864b-38ed5e99a103	slow
9d6b5dca-69bd-4cec-8f8b-a1d1ec7a76c7	slow
9d6b5dca-6a28-477c-8e95-f639464005eb	App\\Models\\User
9d6b5dca-f5ce-473f-82fc-5886773d342a	slow
9d6b5dca-f648-41fa-bbfa-0ca05df6b286	App\\Models\\User
9d6b5dcc-767d-413f-81f3-03c2d14f2f09	App\\Models\\Menu
9d6b5dd4-a372-4b87-a629-700f3accb3f6	App\\Models\\User
9d6b5dd5-3f7f-459d-82e4-25d01781109b	App\\Models\\User
9d6b5dd7-3f0d-4295-98ad-85d03976fa7d	App\\Models\\Menu
9d6b5e4b-e8a5-41dd-90c7-65dfe70ac100	App\\Models\\User
9d6b5e4c-76a5-4419-b7d0-02dd368ad2a8	slow
9d6b5e4c-7703-4f8a-b064-07105e38be64	App\\Models\\User
9d6b5e4e-9f03-458b-9a24-8e6fd27cb963	slow
9d6b5e4e-9f4c-4806-b513-96cb4f0853d3	App\\Models\\Menu
9d6b5e64-83da-421f-98c0-68d96f7fdc0e	App\\Models\\User
9d6b5e64-ee8d-4dad-9ba1-8020e770e267	App\\Models\\User
9d6b5e66-c284-4bc0-b477-fadb50487a30	slow
9d6b5e66-c2e4-4122-ba7b-10a99b31057a	App\\Models\\Menu
9d6b5e84-d426-44ec-8a78-1a93c040d62c	App\\Models\\User
9d6b5e85-613e-4901-a83a-3bec4a77dfd5	slow
9d6b5e85-618b-488b-9d9a-98a8a2956b52	App\\Models\\User
9d6b5e87-30ea-4160-ad20-8484e001e2f5	App\\Models\\Menu
9d6b5f0d-7ada-4a27-a613-c797ca86feed	slow
9d6b5f0d-f62c-4260-9bb4-805f98afa866	App\\Models\\User
9d6b5f0e-5eba-47ec-be52-4b7c285ad344	App\\Models\\User
9d6b5f10-24d2-4fd3-941f-0885dbfc03c6	App\\Models\\User
9d6b5f10-bac9-4ada-b961-50fba35c6b4c	slow
9d6b5f10-bb19-4177-be86-a111b3b666ec	App\\Models\\User
9d6b5f12-aab4-4cbd-87c7-d455a16320aa	App\\Models\\Menu
9d6b5f16-e5f9-4737-a349-77834e5b73ff	slow
9d6b5f16-e653-401d-ae52-4c7aedb2eed8	App\\Models\\User
9d6b5f17-5038-4be2-bca4-e5941392fa3a	App\\Models\\User
9d6b5f18-f8a3-49d6-8ba2-408a56b1816e	App\\Models\\Menu
9d6b5f52-50cc-4917-9e74-e630b7ae260d	App\\Models\\User
9d6b5f52-dc97-4d7a-924a-1d0ba495f18e	App\\Models\\User
9d6b5f55-4658-4806-add1-f7df86c33779	App\\Models\\Menu
9d6b5fd4-1df9-4582-8d73-4ff9cc35fc8a	slow
9d6b5fd4-9b3e-4d1e-ac57-e038b0c44d80	App\\Models\\User
9d6b5fd5-0428-4b82-bd25-a08d687fdf0b	App\\Models\\User
9d6b5fd6-11a2-4b23-a377-4ca35fc5b6cc	slow
9d6b5fd6-844b-4cf3-ab61-63452e2ff17b	App\\Models\\User
9d6b5fd7-189e-49b9-bc77-3c1154fad6fa	slow
9d6b5fd7-1904-473e-aeef-ab94f60453b0	App\\Models\\User
9d6b5fd9-8f9a-43a2-ac7b-2423e56ff330	App\\Models\\Menu
9d6b5fdf-730f-4c97-a74d-f9f001b3aa49	App\\Models\\User
9d6b5fe0-24ce-4534-be7d-aba12e0e7f0a	App\\Models\\User
9d6b5fe2-0709-4261-838b-3e3a13d56a8d	slow
9d6b5fe2-0788-49ab-add3-fb34a097134e	App\\Models\\Menu
9d6b6029-3a93-4ff5-9f5e-11305c017e48	App\\Models\\User
9d6b6029-a30b-4e85-bbb7-ffcdb7670831	App\\Models\\User
9d6b602b-917a-4510-a42d-79bfa2383894	App\\Models\\Menu
9d6b6053-6ce9-4822-a1a5-a1c8c900155e	slow
9d6b6053-6d38-4ffd-8318-aa16bd8ad44b	App\\Models\\User
9d6b6053-ff9a-4915-8db4-f85f6045372f	slow
9d6b6054-0001-4094-863e-0eeed223302d	App\\Models\\User
9d6b6056-129e-45a6-a8cb-9cce110f244c	slow
9d6b6056-130f-4f7a-a7cc-7bbeb664ffc2	App\\Models\\Menu
9d6b6072-e8ea-4d92-a906-bdb2501eadfb	slow
9d6b6072-e956-46b3-b75e-06419a3dedf8	App\\Models\\User
9d6b6073-4c07-41eb-b65c-89ff2d689464	App\\Models\\User
9d6b6075-0f2a-40a4-b33d-73a24da0adb1	App\\Models\\Menu
9d6b60aa-b2fc-478d-9501-5e447acd86c0	App\\Models\\User
9d6b60ab-4a00-4c09-b71c-8ddb259dc783	slow
9d6b60ab-4a50-4d5f-8b2a-28b02b39366e	App\\Models\\User
9d6b60ad-388b-45d7-98e9-0689afcd9737	App\\Models\\Menu
9d6b61da-7353-46d6-95cd-edb49f342bce	App\\Models\\User
9d6b61da-fcec-48b1-b29e-189395ccc07a	slow
9d6b61da-fd60-43ae-ae86-1a744654d3f3	App\\Models\\User
9d6b61dc-f7e9-4771-8bb5-c74cd123a875	App\\Models\\Menu
9d6b62bb-b370-4a6d-9b90-12f9c20e5310	App\\Models\\User
9d6b62bc-7629-4c38-83d9-df963ddfa625	App\\Models\\User
9d6b62be-c69c-4ef1-8159-dd66b1e3156f	App\\Models\\Menu
9d6b62d4-51a8-4cd7-8879-2012b7321709	App\\Models\\User
9d6b62d4-dd9f-4d2b-b608-13fb829ac6f2	slow
9d6b62d4-ddf3-4875-bb34-10b6a6a43dac	App\\Models\\User
9d6b62d6-7860-4310-9dbb-8401273d65a1	App\\Models\\Menu
9d6b6374-4a6b-42a8-8e47-81600abfff83	slow
9d6b6374-4ad0-4632-8130-4b0fd98cc60a	App\\Models\\User
9d6b6374-b065-459b-9b8a-6db6440a04a2	App\\Models\\User
9d6b6376-9e51-4abc-a6ea-9524ec175e47	App\\Models\\Menu
9d6b646e-cdbb-497a-ba61-fb46d767eab3	slow
9d6b646e-ce25-4434-91e1-334df35db6d7	App\\Models\\User
9d6b646f-2ff9-4696-b848-fd48e40d2737	App\\Models\\User
9d6b6471-2164-4f5a-bcaf-a5b43755eaae	App\\Models\\Menu
9d6b648b-70f2-4d1e-81fd-0d8da7721605	slow
9d6b648c-022e-4b90-a4d8-528ee66cbafc	slow
9d6b648c-027c-4d95-9863-579be6ea8b18	App\\Models\\User
9d6b648c-69b3-4772-82a9-3904e5aa47fa	App\\Models\\User
9d6b648e-2cd9-4d75-85d2-c185473ec834	App\\Models\\Menu
9d6b64af-3471-45e8-9800-f7288f53a217	slow
9d6b64af-a1cd-4ab0-99f9-9aff47499853	App\\Models\\User
9d6b64b0-0802-4294-bd55-28e2852c7d01	App\\Models\\User
9d6b64b1-f265-4bf7-bb41-902791543513	App\\Models\\Menu
9d6b64e5-ab47-4802-bb48-5abb9b970bf4	slow
9d6b64e5-aba7-4ceb-a672-db46a49099fa	App\\Models\\User
9d6b64e6-18cb-4933-aec8-0e2c3d86a005	App\\Models\\User
9d6b64e7-e605-4d2c-b0bb-bc222e5e1df1	App\\Models\\Menu
9d6b6517-644a-42e3-a9fe-2bf5cb19ebba	App\\Models\\User
9d6b6517-d17d-4ba8-8365-de8adfb8b58d	App\\Models\\User
9d6b6519-cd80-4123-9007-373060ca248d	App\\Models\\Menu
9d6b6554-d5ba-430e-8fb0-aa23e8b6dd0c	slow
9d6b6555-67e8-4c5e-b847-cbf423576b15	slow
9d6b6555-6855-458c-bc7c-ccae0251c475	App\\Models\\User
9d6b6555-d373-4b8c-9122-8b912d3f44df	App\\Models\\User
9d6b6557-dd31-4fd9-9cfb-c465fd9fadb3	slow
9d6b6557-dd7c-4671-9ecc-41e8d1bd50b9	App\\Models\\Menu
9d6b6659-3139-4a32-bdfb-f47b26494e2b	App\\Models\\User
9d6b665a-3e3b-4785-828f-94648ca02c73	slow
9d6b665a-3ea5-40a0-9817-01d995944b8c	App\\Models\\User
9d6b665c-9010-46a8-9cb9-08e7068d5f8d	App\\Models\\Menu
9d6b669d-5991-40ae-86d1-017813f3cfc2	App\\Models\\User
9d6b669d-bec7-4276-90fe-6cb69c65cbe2	App\\Models\\User
9d6b669f-e7d4-406b-8716-f630c1e3d530	slow
9d6b669f-e830-4eed-9f3b-775e93aad9fa	App\\Models\\Menu
9d6b66d3-fd1d-426c-9790-f62a177e0b57	App\\Models\\User
9d6b66d4-634f-43ec-840e-d22bfba09b72	App\\Models\\User
9d6b66d6-20a8-473e-ba55-04f8ce72d299	App\\Models\\Menu
9d6b672d-dce5-477b-b164-af9f10b72e88	slow
9d6b672d-dd57-4b49-8988-988c62accb78	App\\Models\\User
9d6b672e-54a7-4679-b4fd-c0994d1098a3	App\\Models\\User
9d6b6730-7c50-4b60-9774-673a06f8531b	App\\Models\\Menu
9d6b6731-1fb7-4b39-ac66-944d7263ae4e	slow
9d6b67b4-331c-42b6-a5ca-5d9a1c93a6e0	App\\Models\\User
9d6b67b4-944f-4ba9-a326-12beaad8b221	App\\Models\\User
9d6b67b6-b7e3-4dac-a90b-9f4f36a12f93	App\\Models\\Menu
9d6b6b0d-f572-4880-96b4-9e3f5b2bdb41	App\\Models\\User
9d6b6b0e-5c53-45d3-aaaa-c9f95820dbcf	App\\Models\\User
9d6b6b10-7b8c-4e66-886a-159427af9c0d	App\\Models\\Menu
9d6b6b4b-58f8-46d5-9107-5f3243b813d2	App\\Models\\User
9d6b6b4b-be7f-44ce-b2b4-dbba124ea91a	App\\Models\\User
9d6b6b4d-b66c-4450-b8a6-19eb42f33d91	App\\Models\\Menu
9d6b6bb8-b4e6-4aaf-89a9-308705c8fbb1	slow
9d6b6bb8-b540-4f95-b652-93f231360617	App\\Models\\User
9d6b6bba-0611-42ae-8c63-52283e1c74a3	App\\Models\\User
9d6b6bbc-2f3d-44ac-890d-f2ebcf0460db	slow
9d6b6bbc-2fa2-48a9-8def-9228a47f6421	App\\Models\\Menu
9d6b6cdf-c41f-4f24-8431-c7f3aef38e0b	App\\Models\\User
9d6b6ce0-6783-4589-9b51-325a3845f036	slow
9d6b6ce0-67ff-4931-b34b-713082066cf0	App\\Models\\User
9d6b6ce2-d945-4a36-8a5c-db4cd762b069	slow
9d6b6ce2-d9d8-40ca-ad87-b52bf89d9878	App\\Models\\Menu
9d6b6cf7-e0e9-401e-aee4-101386619e91	slow
9d6b6d22-7503-483c-b7f3-797f5d940a32	slow
9d6b6d2d-efbb-4c4e-8d55-8798e15d86b1	slow
9d6b6d42-a910-4c2a-a849-412d1e597c2a	slow
9d6b6d46-a33b-4339-8b3b-5fd34ed8d7eb	slow
9d6b6d5c-7ca6-44ea-88f2-bc8dc3465ecc	slow
9d6b6d5c-7cf9-4a1b-a774-62c7665a6136	App\\Models\\User
9d6b6d5c-e0d8-4f0f-a4a2-7700578a032e	App\\Models\\User
9d6b6d5e-b8a4-49f9-a794-03d44438e231	slow
9d6b6d5e-b919-4d71-91ee-d175ca7f75de	App\\Models\\Menu
9d6b6d60-1196-4c4a-a4c0-7e1c4e621e48	slow
9d6b6fc6-3cfc-4b66-8c68-9d89915ebf8f	slow
9d6b6fc6-3d63-49f1-9fc4-0a7490cd7713	App\\Models\\User
9d6b6fc6-b2a7-4742-b4c4-4f7ddffe7c81	App\\Models\\User
9d6b6fc8-f51f-416a-8cac-e5c01a31fe9c	App\\Models\\Menu
9d6b7080-8b9a-4264-a147-332f7641cc1e	App\\Models\\User
9d6b7080-f20c-4c48-8d93-b543956b9249	App\\Models\\User
9d6b7083-1fd8-459e-a5d6-d19ee112d36f	App\\Models\\Menu
9d6bc9ef-dbb7-4953-b255-8ef5b5e4bb6c	slow
9d6bc9ef-dc55-4c41-8f16-c86db98e2431	App\\Models\\User
9d6bc9f1-56ac-452d-835d-36f3095d9511	App\\Models\\User
9d6bc9f4-a4c6-40f1-b74f-721c3b1aa870	App\\Models\\Menu
9d6bca02-ad7c-442f-80c8-15e6089d2d4f	App\\Models\\User
9d6bca03-464f-445c-a93c-c6f514888302	slow
9d6bca03-46a7-4ae4-b74e-74442e76615b	App\\Models\\User
9d6bca5a-5f20-4e9c-b284-5a60c7112750	App\\Models\\ItemLoans
9d6bca5a-6b05-4a0d-ac15-bfe7675937cf	App\\Models\\Loans
9d6bca5a-7eae-46a7-ab7b-0caa689f16aa	App\\Models\\ItemLoans:172
9d6bca5a-80b4-4fed-b3c3-15473b88655e	App\\Models\\Loans:59
9d6bca67-61dc-46e5-90a7-cd685b71e18e	App\\Models\\User
9d6bca67-f323-43a4-8f2e-057ddaccd7e1	slow
9d6bca67-f384-4c64-afab-ecb7327adda8	App\\Models\\User
9d6bca7a-f30d-43be-9e09-c3d71884f8b4	slow
9d6bcb07-bfd4-468d-92fe-a07bf2f920a6	App\\Models\\User
9d6bcb08-319c-4e0a-a705-c075838c96ee	App\\Models\\User
9d6bcb7f-539d-4fe9-a319-fef2b074a552	App\\Models\\User
9d6bcb7f-b71d-4c2e-a245-1b93d920b664	App\\Models\\User
9d6bcb81-f635-4766-8d4a-879ea0d32a43	App\\Models\\Menu
9d6bcba2-e0cf-4197-8140-816595bab7fd	App\\Models\\User
9d6bcba3-5a53-476d-931f-749a795d61a1	App\\Models\\User
9d6bcba5-0b48-4e54-aab3-bb9ac5adbec2	App\\Models\\Menu
9d6bcba5-edab-49fe-bea0-346f08a8bc37	slow
9d6bcc9b-6d4c-47a3-b8c1-389266c1eb8a	App\\Models\\User
9d6bcc9b-d402-4f62-a6cd-87c4e0b8107c	App\\Models\\User
9d6bcc9d-a77c-43b6-975d-eb78bd4cff5b	App\\Models\\Menu
9d6bccc4-7c4d-4e13-b739-0555ecb5e96b	slow
9d6bccc4-f4b9-460f-be1f-922a053091c7	App\\Models\\User
9d6bccc5-8775-4b2f-b117-a4357014f882	slow
9d6bccc5-87f5-41bd-939e-15e3dcd04adf	App\\Models\\User
9d6bccc7-9af8-4af1-babf-eba9503f858d	slow
9d6bccc7-9b57-4938-a1c7-09a8be524664	App\\Models\\Menu
9d6bccce-a64e-46bd-957a-5df4293bf500	slow
9d6bcd1d-5ceb-40da-a285-e93bec7c0b83	App\\Models\\User
9d6bcd1d-c329-47e7-9484-924b1f5bdb36	App\\Models\\User
9d6bcd1f-6dbc-4d72-8595-32b06ed24b34	App\\Models\\Menu
9d6bcd8e-238c-4288-8c9e-276ac0e24f31	App\\Models\\User
9d6bcd8e-8770-47e2-ba8a-c9a622c6c651	App\\Models\\User
9d6bcd90-58cf-4d2a-aad1-49e8af861d4d	App\\Models\\Menu
9d6bcee8-1e12-4844-9fb8-5eb58ff8c8bb	slow
9d6bcee8-1e67-43e7-a947-c08d2451a6d7	App\\Models\\User
9d6bcee8-7f82-44fd-a41f-7e12907c569e	App\\Models\\User
9d6bceea-3629-4047-a499-2fef20e0e76d	App\\Models\\Menu
9d6bcf60-7aee-4aaf-8d60-9cfde8383ad6	slow
9d6bcf60-7b39-48a1-a29f-0c813f5ad5f8	App\\Models\\User
9d6bcf61-19a9-4aeb-b3d8-20ec65dbe34d	slow
9d6bcf61-1a0c-4823-b646-1b0bf346754e	App\\Models\\User
9d6bcf63-1af6-48f3-9720-2de45a27b94d	slow
9d6bcf63-1b6b-4f1c-8a94-ffff8cfa20dd	App\\Models\\Menu
9d6bcfc5-7f4a-42b1-9de9-5b3e6de0777a	slow
9d6bcfc5-7faa-45df-9d7a-7b9314721854	App\\Models\\User
9d6bcfc5-e53c-4fca-ad5b-6d810e4f34ad	App\\Models\\User
9d6bcfc8-77bc-4d33-a206-d01f5d12aa0d	slow
9d6bcfc8-7817-4294-b438-38f385307350	App\\Models\\Menu
9d6bcff2-7573-42af-a7e9-cf0cd3ce7c35	App\\Models\\User
9d6bcff2-d841-4235-884e-fe9cc0a98c13	App\\Models\\User
9d6bcff4-c80e-4439-8950-c00d597ae56f	slow
9d6bcff4-c854-4293-bfbf-e18d42aa0d78	App\\Models\\Menu
9d6bd092-2c63-470e-8fa5-4ea7734b1419	slow
9d6bd092-94b9-4dc4-80cc-66be96319dc3	App\\Models\\User
9d6bd093-185c-489b-9c51-741e43b4a79b	slow
9d6bd093-18ac-4214-a0e9-857c954e84bb	App\\Models\\User
9d6bd095-0abc-4302-8f1b-2d01e0b25c75	App\\Models\\Menu
9d6bd0bc-e81c-4fc9-be36-36909555a8e7	slow
9d6bd0c4-5995-430d-9bbc-fe5459661b4f	slow
9d6bdae6-78b2-4c48-8684-4027845343c0	slow
9d6bdae7-1da5-4c4c-97cb-daeecb689d26	slow
9d6bdae7-1e20-44eb-99ce-625dd69d9e87	App\\Models\\User
9d6bdae7-896a-4043-b4ea-a7a381fe74eb	App\\Models\\User
9d6bdae8-ddff-42aa-9f22-246c7ecc9bda	slow
9d6bdae9-5d3c-42f6-8f82-cebbcaaf1116	App\\Models\\User
9d6bdae9-fbff-4984-ae5b-da3f40128104	slow
9d6bdae9-fc68-47ee-b0a1-42b5c250339e	App\\Models\\User
9d6bdaec-6add-4d28-a087-308117b0d02c	App\\Models\\Menu
9d6bdb00-5c60-42b5-8b8f-1205dd5877cb	slow
9d6bdb00-d50c-4bc1-8778-65a557890655	App\\Models\\User
9d6bdb01-3e9a-4fb9-a770-9365d0e40c43	App\\Models\\User
9d6bdb02-f680-47df-89ca-79e7f903d111	App\\Models\\Menu
9d6bdd97-fee9-4d76-b2f3-cc39416f1430	slow
9d6bdd97-ff3b-4422-8edb-4f5c0731c9ff	App\\Models\\User
9d6bdd98-7768-4f03-90e6-a0b7d607d64b	App\\Models\\User
9d6bdd9a-665a-48ac-aab9-a23acb83fee2	App\\Models\\Menu
9d6bdda8-66b2-4de8-8961-dadd9a6b6c67	slow
9d6bdda8-dadd-4bfc-badb-6d5161d925f2	App\\Models\\User
9d6bdda9-4089-4e29-aa97-4c9d78e0a289	App\\Models\\User
9d6bddab-0f9f-4913-84d0-2f141a2ad12b	App\\Models\\Menu
9d6bde71-9333-4ea3-8607-e85bd7666342	slow
9d6bde71-9399-49ec-afae-cdb27d471f4e	App\\Models\\User
9d6bde72-092a-4439-b0ee-0b2a177ad274	App\\Models\\User
9d6bde7d-82aa-4e6a-9340-48dd716ed231	App\\Models\\User
9d6bde7e-0fbe-4ae0-b2e3-013afc6214dc	slow
9d6bde7e-1015-4f1b-8e2b-301c1f212c87	App\\Models\\User
9d6bde7e-964b-4480-9f2a-a52094245e21	slow
9d6bdf68-a7c6-423d-8ef6-0e72e823074f	App\\Models\\Menu
9d6bdf71-85a0-4ede-a6ad-2e9471200217	slow
9d6bdf71-85f8-4aad-bf2e-3941a58aaa6a	App\\Models\\Menu
9d6bdf9c-3ad8-45c9-b763-eab83f550b76	App\\Models\\Menu
9d6be07a-8703-44f7-83e6-90f0b464c31c	slow
9d6be07a-8770-4aad-be4b-da4bcaae70e9	App\\Models\\Menu
9d6be0c2-c762-490a-9b29-d7906d7e4baf	App\\Models\\Menu
9d6be114-9317-4c42-8df4-3240d118523b	App\\Models\\Menu
9d6be15c-efc9-4d99-ad6e-4bc968e5eb7c	slow
9d6be15c-f027-48e4-898d-3422b3d95031	App\\Models\\Menu
9d6be1fb-976b-40c6-91f7-ee66347e900c	slow
9d6be1fb-97b9-4d36-9b51-b64e8835234e	App\\Models\\Menu
9d6be21b-89df-4924-944b-fe79076fbec9	App\\Models\\Menu
9d6be246-eee4-4b30-b6ab-16b56bd90e14	slow
9d6be246-ef3d-48b5-ab9b-4d46f3d3dc84	App\\Models\\Menu
9d6be266-eaba-4e00-bd83-7aeeafc6c57d	App\\Models\\Menu
9d6be27c-2ee2-4aca-b764-2a923877b80a	App\\Models\\Menu
9d6be27f-947a-423c-bad1-d1a4cb6f3861	slow
9d6be27f-94d4-4f70-8a6e-47f3c76dc18f	App\\Models\\Menu
9d6cb406-2a2c-4f68-844d-da0bb47f2591	App\\Models\\User
9d6cb407-d3ef-4ab7-bfdc-699a0a3812ff	slow
9d6cb407-d43f-4e2c-8342-3a17329b3d24	App\\Models\\Menu
9d6cb443-ae3a-4eea-92f4-9a2bc485fcd5	slow
9d6cb443-ae98-4caf-b0d7-a3678ec7851e	App\\Models\\Menu
9d6cb4d4-f6e0-468d-8f5a-3f4c342deeba	App\\Models\\Menu
9d6cb504-71d4-4346-a2cb-b2b16134ea4a	App\\Models\\Menu
9d6cb55c-df3d-4682-8b9b-3588c802d8b8	App\\Models\\Menu
9d6cb619-bb47-43f7-a8e9-3641fe290984	App\\Models\\Menu
9d6cb632-41d3-4707-a649-0df7baaff967	App\\Models\\Menu
9d6cb63c-10ff-427b-b783-ef9e3f626432	slow
9d6cb63c-1164-47bd-a326-405b2807f935	App\\Models\\Menu
9d6cb656-9b8e-423e-88a4-d0e4c0e9fd55	slow
9d6cb656-9c03-416b-b848-ac649ccccb7a	App\\Models\\Menu
9d6cb6ab-df9c-4df6-b825-c50f79f72705	slow
9d6cb6ab-dffb-42fd-bf2c-6196c1b8000a	App\\Models\\Menu
9d6cb6ba-308d-4462-8b5d-ca5f23be2099	slow
9d6cb6ba-30fb-46e1-853b-daf3527d21f4	App\\Models\\Menu
9d6cb868-e677-4edf-af56-90696a41a307	App\\Models\\Menu
9d6cb870-3252-4d38-90b2-387eef83e5f0	App\\Models\\Menu
9d6cb8fe-d02f-4bbe-b6fd-31d6734feb1c	App\\Models\\Menu
9d6cb92a-c300-4dba-a622-8844c1005616	App\\Models\\Menu
9d6cb95e-3c4a-40de-90d9-3ec023876d7d	App\\Models\\Menu
9d6cbb4b-ed38-4d95-bf77-c32ad0e6b3f5	slow
9d6cbb4b-edb8-4c14-964c-2b0c8e4468a9	App\\Models\\Menu
9d6cbd1a-41cb-47f9-b2cc-c0e3b2dad61f	slow
9d6cbd1a-426d-4b99-ba0a-fc2a9ea97dcc	App\\Models\\Menu
9d6cbd1b-0a0c-40d1-9776-38a728dd7482	slow
9d6cbd31-92c8-4ec1-ace0-7363813c7dc3	slow
9d6cbd31-9325-46d0-9726-d4e076113de5	App\\Models\\Menu
9d6cbe12-9c5c-480f-abdc-198a158d4a37	App\\Models\\Menu
9d6cbe1a-9b2f-4178-b1b1-62fd19aacddc	App\\Models\\Menu
9d6cbe25-ea2f-40d4-b951-5f0aa38e304b	slow
9d6cbe25-ea7d-4437-b850-114d9fd1e9d9	App\\Models\\Menu
9d6cbe54-f141-4e90-bd3e-94bf9ea2db1f	App\\Models\\Menu
9d6cbe7a-4d51-4a57-b013-1543246ff75e	App\\Models\\Menu
9d6cbe7b-33b9-4d5a-964c-03c91562be1b	slow
9d6cbe87-eeb2-437e-bb15-d14e01ea2c14	slow
9d6cbe87-ef2f-4892-862a-a30237782bc6	App\\Models\\Menu
9d6cbe97-3461-4400-8129-5f4421fe7e8b	App\\Models\\Menu
9d6cbe97-bc4a-4051-9c2e-8883dd4848c5	slow
9d6cbee3-12cf-445c-b502-056606aad0fc	App\\Models\\Menu
9d6cbf4c-9a84-4b35-92e1-ff475cb0a18a	App\\Models\\Menu
9d6cbf63-e71f-4d8b-8d03-5c6f4b709a3d	slow
9d6cbf63-e7ab-4a4a-8716-399e1580b97d	App\\Models\\Menu
9d6cbf73-8549-49b2-92c2-adad91632f84	App\\Models\\Menu
9d6cbf9e-234c-428e-8aa6-331956b610f9	App\\Models\\Menu
9d6cbfc4-6a46-4f1c-8232-a299d38072a9	App\\Models\\Menu
9d6cbfc5-493d-4dee-84c1-0165761acb08	slow
9d6cbfe6-c135-449a-b2a6-db705df5df48	App\\Models\\Menu
9d6cbffa-158b-4be9-8cf4-9b444f714701	App\\Models\\Menu
9d6cbffa-ae1f-415f-8b4a-76041b02eaf8	slow
9d6cc033-e28f-4b73-b16e-96de5e2949aa	slow
9d6cc033-e32d-40a2-a97b-5be43bdd235d	App\\Models\\Menu
9d6cc065-0d4a-4a4a-bb80-604fcb87f930	App\\Models\\Menu
9d6cc09e-cffa-4fc3-bd0e-bd727a994e49	slow
9d6cc09e-d05c-4254-984f-b80c2e978120	App\\Models\\Menu
9d6cc09f-5537-447d-9437-953ac967f64d	slow
9d6cc0dd-c548-4a94-ad6f-e7341fdb6807	App\\Models\\Menu
9d6cc107-468a-411c-91e3-e142868e42c5	App\\Models\\Menu
9d6cc11e-ee30-4bfd-85a0-cc79d4b95b1f	App\\Models\\User
9d6cc11f-929c-4f74-bd00-f0c4d4373902	slow
9d6cc11f-92fe-4bed-8239-0ca0690d23c9	App\\Models\\User
9d6cc121-b530-4964-84d7-aba7a4462e0c	App\\Models\\User
9d6cc122-18ba-4705-9dba-6369f4117db8	App\\Models\\User
9d6cc123-4209-4da2-9227-64cbf5cb126a	App\\Models\\Menu
9d6cc123-c2ca-4b97-b65d-a7f1dabdcd9e	slow
9d6cc128-cfb1-4e23-a3c0-dcceb2adc2dd	App\\Models\\User
9d6cc129-3205-4e70-b387-f42e7524c961	App\\Models\\User
9d6cc129-b4c5-4623-befa-7eed4c912389	slow
9d6cc12b-fcc9-4d07-99fc-7d6211444086	slow
9d6cc12b-fd1a-41d7-9701-8c916f0ae3d7	App\\Models\\User
9d6cc12c-585e-426f-a84e-2269f66bea05	App\\Models\\User
9d6cc1bd-a51e-4a5c-b437-ba16e34db1f8	App\\Models\\Loans
9d6cc1bd-ae6a-475a-b936-4f53831e1eca	App\\Models\\ItemLoans
9d6cc1be-1774-4da5-b4b0-1695fbdc8c81	App\\Models\\User
9d6cc1be-72f7-4ee7-b665-f881a82e41b8	App\\Models\\User
9d6cc1be-f4cd-4437-94f0-8cf9e34a4b23	slow
9d6cc1be-f51e-465d-b6c0-f1f84f295244	App\\Models\\User
9d6cc1ce-c72a-4316-bf6f-af99e668aa87	App\\Models\\User
9d6cc1cf-1ff9-4137-9d9a-bb24f18cb376	App\\Models\\User
9d6cc1cf-af35-4a57-9376-2f43fc96d4da	slow
9d6cc238-8e20-4a0f-b4b3-dce9d3bfe9cc	slow
9d6cc239-0679-477e-948d-332a2ac8f5c4	App\\Models\\User
9d6cc239-9389-479f-a155-a171abc5e448	slow
9d6cc239-93de-4509-9958-e78861d454ca	App\\Models\\User
9d6cc23b-3c50-44e5-a7e5-12f896726009	slow
9d6cc23b-3c9f-4670-81e2-4c03c05fa9d5	App\\Models\\Menu
9d6cc23c-893b-47e2-b75e-554961fe564e	slow
9d6cc277-3a24-46d7-8ad8-5806deb41c87	slow
9d6cc277-3a78-4eb9-94df-4726c2bf92e6	App\\Models\\User
9d6cc277-d4ab-4daf-89c4-4522a2d998f0	slow
9d6cc277-d501-4f25-898b-4020058edcac	App\\Models\\User
9d6cc279-2248-4e21-af49-d97b7e519cb4	App\\Models\\Menu
9d6cc284-e488-417b-b18b-2f1446ef507b	App\\Models\\User
9d6cc285-7489-4e42-99f1-e64646213ef3	slow
9d6cc285-74ec-43ae-b767-54e4a5e73d0a	App\\Models\\User
9d6cc286-a558-4d80-9911-b99badd901f6	App\\Models\\Menu
9d6cc287-db93-400b-b8af-b426ad4325ef	slow
9d6cc2a7-4666-4fdc-8c6f-80e416bced88	App\\Models\\Menu
9d6cc2a7-ce2e-478b-8778-29a734d3ec87	slow
9d6cc2fb-f2fd-4adc-a2c5-97606ff2f4e5	App\\Models\\Menu
9d6cc30e-443a-47c5-8a39-069e35bbb5d3	App\\Models\\Menu
9d6cc30e-c8bd-4070-b4d0-2b86ad34b585	slow
9d6cc32c-b11f-4f49-ad0a-3276b0e28a27	App\\Models\\Menu
9d6cc366-282d-41f6-949d-fd7a34011066	App\\Models\\Menu
9d6cc3aa-f0d3-4568-84f3-5801df3ca407	slow
9d6cc3aa-f121-4037-9eaa-9b7c09414834	App\\Models\\Menu
9d6cc3ab-7c68-4ec8-85b0-43b6ca86ded6	slow
9d6cc3c0-f2e8-4218-ad64-36efd6ed3a7d	slow
9d6cc3c0-f350-436b-8ed8-36c8bdcf816c	App\\Models\\Menu
9d6cc3d3-08a6-4f4e-a96d-b5eb235e79bd	slow
9d6cc3d3-0908-4508-a05f-3ef47528a18f	App\\Models\\Menu
9d6cc3f3-43a8-45ba-aece-4d89b54958b2	slow
9d6cc3f3-4402-4297-9d52-31f1069c9809	App\\Models\\Menu
9d6cc42b-db84-4d83-b5cc-e10beb09aa70	App\\Models\\Menu
9d6cc4d2-b2e5-4ea8-bd69-7be8761bd643	App\\Models\\Menu
9d6cc4e8-1e57-4482-873f-a4beeec5e1a5	slow
9d6cc4e8-1ec1-47f1-b3e5-ca065b59e39d	App\\Models\\Menu
9d6cc51f-df62-4ff7-ad1f-d3546d9ae65d	App\\Models\\Menu
9d6cc5cb-aaa5-40ec-8a80-ce8614c16d79	App\\Models\\Menu
9d6cc5cc-55a6-4bb3-a39f-d0f94d852f13	slow
9d6cc5de-6a1f-43b8-b122-bf5348d24ad1	slow
9d6cc5de-6a8f-417e-85ce-65368d6c62c9	App\\Models\\Menu
9d6cc617-320d-4a1b-a8b4-15c3b4bf7c8b	slow
9d6cc617-326d-4e4d-b28a-02c984c5088a	App\\Models\\Menu
9d6cc62e-826d-4a4b-ab85-261d005761a8	App\\Models\\Menu
9d6cc62f-2e56-4115-81b3-aff5e8463de2	slow
9d6cc64c-caf5-4eeb-986d-770d7790dafb	App\\Models\\Menu
9d6cc66b-adbc-4abb-ba4e-7aee2aa04d4b	App\\Models\\Menu
9d6cc66c-50fa-40bc-83c6-f387367577e9	slow
9d6cc690-d41d-4b0f-91b8-f42c043f8629	App\\Models\\Menu
9d6cc6b2-83bb-41eb-b3e7-13c3bdcef022	App\\Models\\Menu
9d6cc6b3-39f8-4fe9-bcdc-a9d10226ed1a	slow
9d6cc6ca-75e8-4968-8043-40f5f6bed61a	App\\Models\\Menu
9d6cc6cb-222e-4617-8db3-f0a56fd2a25f	slow
9d6cc6e6-9c98-4222-abfa-abf49c130118	App\\Models\\Menu
9d6cc6e7-4d30-4480-a2b9-f90defbfce5b	slow
9d6cc707-843c-4730-92fc-5190f35507b8	App\\Models\\Menu
9d6cc77f-2c09-4e2e-ad9c-b17ac9ddddbe	App\\Models\\Menu
9d6cc798-1a4e-4e51-9192-149530dfd542	App\\Models\\Menu
9d6cc7a8-740d-4916-b61d-9f369629fe44	App\\Models\\Menu
9d6cc7ab-3d1b-49a4-be1f-4aec9c6fa817	App\\Models\\Menu
9d6cc7c1-0a27-4199-b410-9d97d40679d0	App\\Models\\Menu
9d6cc7c1-b459-4431-99f0-58838472d789	slow
9d6cc7da-9072-4a52-8e98-88c2704c99ef	App\\Models\\Menu
9d6cc7db-47cc-4892-bf16-baacd849491f	slow
9d6cc853-ab3c-4a49-a990-af3d11eb0031	slow
9d6cc853-abaf-4827-8da2-d3be7be48b07	App\\Models\\Menu
9d6cc873-ce5c-43c3-8e19-106ef1d8ed7d	App\\Models\\Menu
9d6cc8a6-5d6a-4eb4-bf49-d79cf51dd5fc	App\\Models\\Menu
9d6cc8b7-360a-4874-afbe-b52887be5712	App\\Models\\Menu
9d6cc8e2-075c-418f-b85b-2461579f55e0	App\\Models\\Menu
9d6cc8fc-619d-455f-8be2-9fb9e31418d4	App\\Models\\Menu
9d6cc91f-35e7-45f9-b85b-399701e1e336	App\\Models\\Menu
9d6cc91f-d7a9-4417-b2be-160f9470151d	slow
9d6cc930-e535-4c60-9407-bf19609c8b98	App\\Models\\User
9d6cc931-5705-491c-9565-c2baa1e4054c	App\\Models\\User
9d6cc935-42cd-4773-887b-c2a4f1561d55	App\\Models\\User
9d6cc935-df86-4c0b-b1ed-f1f38415a135	slow
9d6cc935-dfe3-4a42-ae96-77d24032d0f3	App\\Models\\User
9d6cc93c-1a72-4dd4-801d-e02b536f095e	App\\Models\\User
9d6cc93c-9726-4b3c-9317-fed2baeba4f7	App\\Models\\User
9d6cc93d-2641-43bf-ae91-135db5c02772	slow
9d6cc947-d0bb-49bd-b20c-40a2053a46b4	App\\Models\\User
9d6cc948-473f-434c-8c18-8ca13090f944	App\\Models\\User
9d6ccae6-d45f-47ef-87c7-2c864dc4c802	App\\Models\\User
9d6ccae7-617c-432e-a764-f6c47e912eeb	slow
9d6ccae7-61db-4c2e-b66f-2bde7555c25f	App\\Models\\User
9d6ccae9-b750-4c73-ad47-776298b6a60d	App\\Models\\Menu
9d6ccb47-36d2-45ac-a977-315d564b9f79	slow
9d6ccb47-3732-4453-b8bf-21b135fe82ec	App\\Models\\User
9d6ccb47-bb52-4793-a96d-bec5445085f0	App\\Models\\User
9d6ccb4a-0c2b-440d-b52d-b19888713bf9	slow
9d6ccb4a-0ce9-481b-8bb2-ded4aeb21707	App\\Models\\Menu
9d6ccbaa-31c5-4088-8ffa-074cc839275f	App\\Models\\User
9d6ccbaa-dad0-4ed4-ba50-0d4eb5743990	slow
9d6ccbaa-db26-4104-8ef2-e2b959a9a53f	App\\Models\\User
9d6ccbad-7606-4dbd-9b79-3d19d114749a	App\\Models\\Menu
9d6ccbb0-8111-4050-b149-43987230b67e	slow
9d6ccbbb-9471-4534-bf8d-6c40f795adae	App\\Models\\User
9d6ccbbc-1d1c-4493-ba07-5e4c5fc4d4ca	App\\Models\\User
9d6ccbbe-5a8b-48ca-9114-8ba030691077	App\\Models\\Menu
9d6ccbc0-c5bf-493d-b821-bcbfd839f346	slow
9d6ccbdb-97a2-4633-8eeb-c8c969410955	slow
9d6ccbdc-4094-470b-a009-5d9b987e567a	slow
9d6ccbdc-40f3-41f8-98e2-2c1db9fc86cb	App\\Models\\User
9d6ccbdc-a828-4294-9135-27e70fbdfb24	App\\Models\\User
9d6ccbde-3d15-4d4c-81ec-725038f64fd3	slow
9d6ccbde-c045-4335-8edb-f367e589fc0b	App\\Models\\User
9d6ccbdf-5521-486e-9b10-7d1ae2fb4ff5	slow
9d6ccbdf-5575-4986-8814-f6633cc60184	App\\Models\\User
9d6ccbe1-1658-480d-b785-91c5ed267d0a	App\\Models\\Menu
9d6ccbe1-e264-4251-ba69-a116efdd8dcb	slow
9d6ccc21-aef2-4eda-8661-0bad8a9467a3	App\\Models\\User
9d6ccc22-428e-42da-b65f-359b079ad8db	slow
9d6ccc22-42e0-454a-bf09-16373694b4b8	App\\Models\\User
9d6ccc26-25d7-42fd-a719-36e6e68e0d34	App\\Models\\Menu
9d6ccc27-2a5f-4ada-8280-bdfffad0d804	slow
9d6ccc3b-0d63-4169-8ee6-bbe82b3fd229	slow
9d6ccc3b-0de4-47ce-84f5-de7d741c0189	App\\Models\\User
9d6ccc3b-705d-4fe9-a870-4e5d716e5cf8	App\\Models\\User
9d6ccc3d-5a20-4e56-8c53-bcf10b1f4408	App\\Models\\Menu
9d6ccc67-f58b-41f3-ae18-d27d1fa1a489	App\\Models\\User
9d6ccc68-6475-4906-9949-93f660749ede	App\\Models\\User
9d6ccc6a-0484-4d43-b219-bac0d05849dc	slow
9d6ccc6a-79b1-4eb3-8676-a9f67c5b5f9a	App\\Models\\User
9d6ccc6b-03d5-40ec-ad41-da0423525e3f	slow
9d6ccc6b-0424-4df8-8e51-12856be6a51e	App\\Models\\User
9d6ccc6c-df06-4717-b86a-6f25579652c7	App\\Models\\Menu
9d6ccc6e-bc66-46eb-a0a8-f203a9332c6a	slow
9d6ccc75-a685-4d8b-b35c-9502a13a7943	slow
9d6ccc75-a6d6-43ac-915d-703674668262	App\\Models\\User
9d6ccc76-0427-4e6d-a236-34caa235ac5a	App\\Models\\User
9d6ccc77-a4e1-4c51-87a5-dd54a46a2b23	slow
9d6ccc77-a542-4d0c-a42c-1db5a28938ad	App\\Models\\Menu
9d6ccc78-4e15-4c0c-9b90-23d033398b0d	slow
9d6ccc90-e496-4bb1-bb3f-76e8fea18a3c	slow
9d6ccc90-e4e7-4698-a72f-988b15733b1a	App\\Models\\User
9d6ccc91-7084-4976-873c-af2ea075e1bb	slow
9d6ccc91-70f7-48fa-ab0a-2c48c823cb80	App\\Models\\User
9d6ccc93-5fa3-468d-9ad2-b8bc42f200b9	slow
9d6ccc93-6018-49d6-97a6-bdd6323bb240	App\\Models\\Menu
9d6ccc94-06d0-46a3-9fa8-86aacb963f4f	slow
9d6ccc9b-f558-47c0-95b4-1f0e7feafacf	slow
9d6ccc9b-f5a6-4d18-a28a-f107c8611e61	App\\Models\\User
9d6ccc9c-5984-4f38-83e0-0de03d1ccea6	App\\Models\\User
9d6ccce5-b572-4a3f-9895-b1091e9aea05	slow
9d6ccce6-298b-4960-9a59-13ce3bde0ed5	App\\Models\\User
9d6ccce6-8b6d-4f47-bf5c-32b93c684950	App\\Models\\User
9d6ccce9-6f7c-43fb-92b2-0ae57979bc68	App\\Models\\Menu
9d6cccea-1c03-420c-af2a-b1c5c64b3ff4	slow
9d6cccf2-98af-48b2-8831-aab5b15bf773	App\\Models\\User
9d6cccf3-0f92-4527-8d6d-9e23ae868250	App\\Models\\User
9d6ccd3c-799c-4fd5-b271-58f06ea961e2	App\\Models\\User
9d6ccd3c-e39c-4fa1-bda7-3bd5e621dc34	App\\Models\\User
9d6ccd3e-e070-4f27-9f1e-b715cddc2877	slow
9d6ccd3e-e100-4985-88d0-ce4f6dd4be1b	App\\Models\\Menu
9d6ccd3f-c2f6-456c-b869-026283c72d5f	slow
9d6ccd41-5c71-47d8-9452-ef8f3d794203	slow
9d6ccd48-8ed6-465c-b6d3-b64fa6fb78e9	slow
9d6ccd48-8f3a-46cb-93fe-39143f81f225	App\\Models\\User
9d6ccd49-4c0e-4281-a83c-4c212d132928	slow
9d6ccd49-4c67-426c-a024-65d11df77634	App\\Models\\User
9d6ccd49-dac8-4554-89d7-0cbc4df66a22	slow
9d6ccd50-5919-459f-aa87-4a44d4348512	App\\Models\\User
9d6ccd50-cd16-428d-8f47-0cdfa6746cce	App\\Models\\User
9d6ccd51-55a4-451c-b4b0-ccb57839c10d	slow
9d6ccdc5-f37e-4d81-98e1-39ee1f21c71c	App\\Models\\Menu
9d6ccdc6-9f6b-460c-a9c8-f99fcc513a8b	slow
9d6ccddf-af1f-433e-ac8e-610bb8049142	App\\Models\\Menu
9d6cce40-2a84-463d-9072-ce483828a108	App\\Models\\Menu
9d6cce41-18e6-4e5b-ad1a-703c7ed37cc6	slow
9d6cce5d-4f0b-4e92-8545-8ab260076160	App\\Models\\Menu
9d6cce7b-48e3-46e1-9be2-f0da263163d7	slow
9d6cce7b-498e-49cd-ac74-c1cf3b789650	App\\Models\\Menu
9d6cce9d-d4db-451c-b3e5-43a3a245c8e1	App\\Models\\Menu
9d6cce9e-7fd9-435b-a3db-8fbc5ea44189	slow
9d6cced1-2efa-49a8-a5db-eda8b258df10	App\\Models\\Menu
9d6cced1-d14b-4f2c-96f8-8d4b78459fbe	slow
9d6ccef3-cc74-451d-a987-b54ae01fc8f4	App\\Models\\Menu
9d6ccf02-8dfe-4759-aa9c-645e77d92c57	App\\Models\\Menu
9d6ccf25-8bb2-4201-afc1-fa75c65ae984	App\\Models\\Menu
9d6ccf26-569e-4440-9d96-69ae9642701d	slow
9d6ccf5e-50d1-4eed-b938-ebcaa7e60906	App\\Models\\Menu
9d6ccf5f-03cd-4f68-be90-fb959811e445	slow
9d6ccf6a-adbd-4e7f-8e79-fff348b298df	slow
9d6ccf6a-ae48-4791-980e-4349eef87eb0	App\\Models\\Menu
9d6ccfbf-67cf-4597-8be7-93715077a617	App\\Models\\Menu
9d6ccfce-e21d-4e6f-9e6d-a3193fea2923	App\\Models\\Menu
9d6ccfcf-8cc8-48e7-8af6-eff456ff5092	slow
9d6ccfef-027b-4998-8842-0962a87aada1	App\\Models\\Menu
9d6cd065-5c88-4d34-8ebf-db9be76be682	slow
9d6cd065-5ce8-4206-85ee-a6bc5669f075	App\\Models\\Menu
9d6cd066-0163-4099-b27c-ca5fdaf4f47f	slow
9d6cd073-ce03-4762-9eda-9e6492b847de	slow
9d6cd073-ce77-4cfe-8541-fa68052c306e	App\\Models\\User
9d6cd090-51a2-4a51-a70a-2ace837aed33	slow
9d6cd090-5215-48be-9e91-205e95d251e9	App\\Models\\User
9d6cd092-4505-4a92-a523-f51dbc8b8dce	slow
9d6cd092-458f-464b-ab9d-13b8740a61a8	App\\Models\\Menu
9d6cd092-e3b7-4e48-a534-7a0ce5a78a36	slow
9d6cd0f9-bd93-432c-a093-a45098955caf	slow
9d6cd0f9-bdf4-4cf1-8283-9d81c9096c72	App\\Models\\User
9d6cd0fb-4770-48ea-a1cf-3d122aebe706	App\\Models\\User
9d6cd0fd-891f-42de-a6cd-9116da20c253	App\\Models\\Menu
9d6cd130-a564-4f7a-9464-d8d8b8944f3e	App\\Models\\User
9d6cd132-6567-420b-8b9d-50cd38837830	App\\Models\\Menu
9d6cd133-3006-4b39-b2ed-c18e1bc510d8	slow
9d6cd137-386f-4840-8cad-f79a94717fff	App\\Models\\User
9d6cd174-e219-4ca8-99fb-af63d2050518	App\\Models\\User
9d6cd194-2c20-4f5e-b814-caaa12e723e6	App\\Models\\User
9d6cd196-5116-444a-a87b-32e080896262	App\\Models\\Menu
9d6cd1bc-48b9-46d5-bff9-391d12cbf4aa	App\\Models\\User
9d6cd345-5b8b-47d2-bbaa-18596dd5a8bb	App\\Models\\User
9d6cd346-8c97-4686-a548-e76f09072d09	slow
9d6cd346-8ceb-426a-9fae-c773a3dacdf6	App\\Models\\Menu
9d6cd347-0dac-4876-bc41-51c534860556	slow
9d6cd391-477c-450e-85b3-ba58d968e2d3	slow
9d6cd391-4813-47a5-8d29-b6cca9b8c59f	App\\Models\\Menu
9d6cd392-056f-49ea-b3bb-efdf63bf594b	slow
9d6cd3ab-a0f9-444c-af68-e25cbdd2f60a	App\\Models\\Menu
9d6cd3bc-9161-4eaf-80dc-0d6b90f41be7	slow
9d6cd3bc-91b2-462b-a882-277e5fdaa8a4	App\\Models\\User
9d6cd3bd-46cf-4b0e-9fc3-245afac2df7b	slow
9d6cd3bd-4718-4ecf-aa5f-819c149b2e35	App\\Models\\Menu
9d6cd405-e9a8-4362-bd9f-91372fd345ce	App\\Models\\Menu
9d6cd416-521a-4dc5-8d9b-87d24c0b1d38	App\\Models\\User
9d6cd41c-fbfe-496d-b323-0e7f515ded51	App\\Models\\Menu
9d6cd422-2ce3-415b-a7c8-1d4730828f48	App\\Models\\User
9d6cd422-8ec0-4cb1-837e-eb9ea213f1f0	App\\Models\\User
9d6cd423-1b78-41e1-9f85-caa538fc0eb4	slow
9d6cd426-4a6c-4a2e-9e63-8b8ee0941085	App\\Models\\User
9d6cd426-ac84-46ed-b915-c8487057e0d9	App\\Models\\User
9d6cd429-955b-4ce7-aeb3-e4ae113d99dc	App\\Models\\User
9d6cd429-f8d5-4d40-8a2f-2868e9e1530a	App\\Models\\User
9d6cd43e-70c9-4fc9-80f0-0e57d7413837	slow
9d6cd43e-7120-46b5-916a-80dd574ebbe6	App\\Models\\User
9d6cd516-0827-450a-8eaa-f7c079cce024	slow
9d6cd516-088d-4f7c-9585-61e16f86796d	App\\Models\\User
9d6cd570-e1d9-49fc-84bb-009aadfb74df	App\\Models\\User
9d6cd5ca-bfe8-4f1c-a54a-32d50654452a	App\\Models\\User
9d6cd675-2cef-40ca-b7e0-7faf2bb29dff	App\\Models\\User
9d6cd6f4-497d-4cd9-997a-644fa9625a64	slow
9d6cd6f4-49dd-40c8-82db-4a3edf77a2c0	App\\Models\\User
9d6cd6fb-fa95-40b1-acef-011086595e49	slow
9d6cd6fb-fae4-4a26-b62a-9c2b7c8e80ec	App\\Models\\Menu
9d6cd6fc-8d2c-4b4e-b386-f2537957b72d	slow
9d6cd70d-b785-4ba7-b28d-19c3578c3006	slow
9d6cd70d-b7f2-4df4-80f4-bb4192e17603	App\\Models\\User
9d6cd756-f9a9-4805-a067-ae3e754c4400	slow
9d6cd756-fa12-4dd4-ae8d-d3bb15faf08c	App\\Models\\User
9d6cd7d6-0810-4ca4-acea-12174e996611	slow
9d6cd7d6-088b-4dab-90d2-b30b97021373	App\\Models\\User
9d6cd7dd-7ca6-4919-b903-f627fb49ba42	App\\Models\\Menu
9d6cd7dd-ff98-41d0-844b-e1f755c55ba9	slow
9d6cd7ec-67c3-4500-a4f4-3398def7466a	slow
9d6cd7ec-6817-45b8-9d26-b9d602a2cef6	App\\Models\\User
9d6cd855-ab19-494c-bdd9-f2f85c20b482	App\\Models\\User
9d6cd8af-720e-4d26-b560-7ee49f25d779	App\\Models\\User
9d6cd93e-cb9e-4fcd-b441-e60b4c1a4bd8	slow
9d6cd93e-cc03-43de-97ea-e1566f811400	App\\Models\\User
9d6cd945-fd6e-47b0-a083-0a6d2f7f5507	slow
9d6cd945-fdcb-443c-add3-ab421751b0a6	App\\Models\\Menu
9d6cd963-0af6-48a9-8040-5d4364b660ae	slow
9d6cd963-0b6d-4663-87fb-639cf2e6d218	App\\Models\\User
9d6cd9a7-7002-465f-93ec-bc49be3e934f	slow
9d6cd9a7-709b-43af-9d7a-3df08c3c3865	App\\Models\\User
9d6cda99-133b-4d33-9b6e-894ceedd1a8d	App\\Models\\User
9d6cdaa0-9d25-4116-88b4-6fea1032ebd6	App\\Models\\Menu
9d6cdab0-faa9-47c5-b6e4-fdf872a2f17b	App\\Models\\User
9d6cdaf1-fa80-48fd-897a-60b3a6058bde	App\\Models\\User
9d6cdaf3-b55a-49f5-80ac-e028c1f261e0	slow
9d6cdaf3-b5d2-4e17-b420-5efed745bfcf	App\\Models\\User
9d6cdaf7-d1f9-420f-ad0a-6f8151b87a0c	App\\Models\\User
9d6cdaf9-43a1-4596-9d73-d4540e80981f	slow
9d6cdaf9-43fa-448f-aaa7-492231219525	App\\Models\\User
9d6cdafb-c39d-483a-b368-b2e3b7ea757e	slow
9d6cdafb-c40f-43fc-b740-eca7f20cc206	App\\Models\\User
9d6cdafc-6ef8-4c14-9fb4-536923bd1879	slow
9d6cdafc-6f61-4c6c-a78b-b21313463940	App\\Models\\User
9d6cdafd-4350-40d4-9e80-3ddd53ba305f	slow
9d6cdafd-43a6-402f-b7a0-ec0f70a8422c	App\\Models\\User
9d6cdafe-04e3-402d-993c-90e1e813abff	App\\Models\\User
9d6cdb09-5515-46f2-85fc-db9b272f4e48	App\\Models\\User
9d6cdba8-10db-4549-a445-9f8916e19613	slow
9d6cdba8-1157-44a3-9358-6f1d5be8b14d	App\\Models\\User
9d6cdbf4-626f-4241-a22e-642cf7f44b95	App\\Models\\User
9d6cdc4c-69bd-4815-ad5c-c81ce082dc69	App\\Models\\User
9d6cdd07-14a6-4444-8203-1632a243bed2	App\\Models\\User
9d6cdd91-97ce-4833-bb0b-a2f9196661b8	App\\Models\\User
9d6cdd98-c807-4e2e-9dc2-83ec52f5d1f3	App\\Models\\Menu
9d6cdd99-4d42-47d2-8875-770d0b97e8e7	slow
9d6cdda0-3740-44e3-abeb-1875f5154a1d	App\\Models\\Menu
9d6cdda0-c3d9-4945-ab47-2fb0c647e5d5	slow
9d6cdda9-a6ae-415c-a00a-77416a29c7b2	slow
9d6cdda9-a727-4fac-bf27-93269da32864	App\\Models\\User
9d6cddb0-8855-45ed-94cc-f9d9f27be8d8	slow
9d6cddb0-88e2-4191-b4c5-04fc95c68802	App\\Models\\Menu
9d6cddda-27f8-40c3-bf3e-efc76a22355c	slow
9d6cddda-285d-4635-8262-92b6317b266b	App\\Models\\Menu
9d6cddee-b8a5-4642-9566-7cb922ae9b53	App\\Models\\User
9d6cddfc-f6ec-4ff4-8c3f-ef31d5f8520b	App\\Models\\User
9d6cde03-d82e-49dd-aaa8-fa974868ac11	slow
9d6cde03-d87b-4c67-971b-55e402878149	App\\Models\\Menu
9d6cde04-8b70-472a-accf-d5e297a6f071	slow
9d6cde3c-6833-4b9d-90a0-c43eaf5ab31e	slow
9d6cde3c-68b2-407e-bd8c-e273772aa228	App\\Models\\Menu
9d6cde58-d06c-41e7-b6ef-4250361b58e7	slow
9d6cde58-d10c-4bda-b4a4-a5b8fb94d88f	App\\Models\\User
9d6cde59-6fb9-4804-8d09-7d823d0bcd87	App\\Models\\User
9d6cde5f-85d7-45ca-8f84-849bdf469b3c	App\\Models\\User
9d6cde5f-e797-45f8-84db-383212ed8e92	App\\Models\\User
9d6cde65-20ec-4c73-9481-720105359b15	slow
9d6cde65-2154-4aa2-ba83-dfba6577b461	App\\Models\\User
9d6cde65-7ccd-429d-b9b7-b4ffd762abaf	App\\Models\\User
9d6cde65-dcdc-4c70-ad03-a8cc34ff08f9	App\\Models\\User
9d6cde73-ad38-4a47-a487-3face3618301	App\\Models\\User
9d6cdf0a-4e67-4a43-8de9-040f1ad9cbb8	App\\Models\\User
9d6cdf0a-d001-4efa-8f86-5bb16e293c41	slow
9d6cdf0a-d061-4553-96df-2e9999aa45d9	App\\Models\\User
9d6cdf0b-312d-4f5b-873a-9a89cebb6e5e	App\\Models\\User
9d6cdf0d-cac3-4700-8c9e-891fd5505600	App\\Models\\Menu
9d6cdf0e-58b9-413a-8507-790e2508abd8	slow
9d6cdf13-3a2b-4c08-8132-2905395b24cb	slow
9d6cdf15-94ed-43dd-b120-fa32cbc93f57	slow
9d6cdf18-38d5-4cf4-940d-d781f28f22ca	slow
9d6cdf1b-3b10-4583-a015-df93569744e9	slow
9d6cdf1c-7798-42b4-be11-8c4644fffc24	slow
9d6cdf1d-5506-4e62-9f11-1a6947317f6c	slow
9d6cdf20-4cf4-4f40-8451-760489830f47	App\\Models\\User
9d6cdf70-d187-4146-a6ab-d4374c4022cb	App\\Models\\User
9d6cdf71-5ec2-41cb-9c5f-378a49d6100d	slow
9d6cdf71-5f0f-4590-8d3b-c288a266e71f	App\\Models\\User
9d6cdf71-eb04-46d6-a927-5d98c59d73f8	slow
9d6cdf71-eb77-4393-9e0d-89acf01aee32	App\\Models\\User
9d6cdf74-6ff9-4c37-8ce0-9f8116c4a286	App\\Models\\Menu
9d6cdf78-2397-4532-a58e-4072a7d04c1b	slow
9d6cdf79-59c3-4575-8a74-3f1ebe437d36	slow
9d6cdf7a-7388-422d-8403-e81a6d48a112	slow
9d6cdf7c-d8ca-4a87-a517-85027cb7dd07	slow
9d6cdf7c-d920-4a68-8dea-19d1f5c6c4b6	App\\Models\\User
9d6cdff3-272c-4077-853e-fde51fd851aa	App\\Models\\User
9d6cdff3-bab9-45ef-b3d6-9ef22fba51f2	slow
9d6cdff3-bb09-4404-8674-fef9b69cf8ba	App\\Models\\User
9d6cdff4-48ca-4ffd-92d2-ca7fd0996b08	slow
9d6cdff4-4914-4a77-838a-0a3b7d77b6e3	App\\Models\\User
9d6cdff6-a9ea-4f93-83cb-f11efa28a999	App\\Models\\Menu
9d6cdffb-ea0c-4ec7-a2da-d43eae9f21bf	slow
9d6cdfff-19d4-420f-bdcb-894947972472	slow
9d6cdfff-1a23-413f-af66-5d767e02d088	App\\Models\\User
9d6ce01d-46a9-4ec3-8153-fcc757001b1c	App\\Models\\Loans:94
9d6ce01d-4d14-4f81-9d26-ad058486d137	App\\Models\\ItemLoans:
9d6ce01d-4de5-443e-b24c-71285509685c	App\\Models\\ItemLoans:
9d6ce01d-4e7d-4bce-a49e-e4ae13bb3452	App\\Models\\ItemLoans:
9d6ce01d-5127-4a5c-8cc6-193598be20d0	App\\Models\\ItemLoans:
9d6ce01d-51aa-49ce-97cc-70c9aa1f3411	App\\Models\\ItemLoans:
9d6ce01d-5228-4ef5-8b58-8e813976e1c6	App\\Models\\ItemLoans:
9d6ce01d-5297-4cfe-b7b6-b87c97473da7	App\\Models\\ItemLoans:
9d6ce01d-5307-4a13-871a-6a9cf9c4427e	App\\Models\\ItemLoans:
9d6ce01d-539c-4810-b850-e048e00ed291	App\\Models\\ItemLoans:
9d6ce01d-540f-4d77-94be-f4b7d6e630d2	App\\Models\\ItemLoans:
9d6ce01d-547d-4030-99f1-a5c2f2a09811	App\\Models\\ItemLoans:
9d6ce01d-54ed-4704-9ffe-b5f7b24e0251	App\\Models\\ItemLoans:
9d6ce01d-555c-4f52-9217-a827bdc792bb	App\\Models\\ItemLoans:
9d6ce01d-55c9-4057-ac8f-1be9a6689386	App\\Models\\ItemLoans:
9d6ce01d-5634-4f1e-8357-da4d3f700f74	App\\Models\\ItemLoans:
9d6ce01d-56a3-4d1a-9143-5ee3dfc0cef1	App\\Models\\ItemLoans:
9d6ce01d-5718-47cf-abf3-bc057495d9e2	App\\Models\\ItemLoans:
9d6ce01d-5786-4c68-a99a-d8640cb30352	App\\Models\\ItemLoans:
9d6ce02b-9783-4106-a9ff-f09ae33bc081	slow
9d6ce02b-97d9-4295-b81b-8ee5f376e4f2	App\\Models\\User
9d6ce02b-fd50-490a-8f30-c7f82dba45ce	App\\Models\\User
9d6ce032-d8a1-42b9-8e9a-b8f9ab11029e	App\\Models\\User
9d6ce033-3483-4424-b215-ce861dd6e696	App\\Models\\User
9d6ce033-91cf-41f3-a6c0-b2d3d3a568a4	App\\Models\\User
9d6ce034-160f-4337-b21e-16ef373df0f7	slow
9d6ce034-1655-481d-803c-2aacb4cc20bf	App\\Models\\Loans
9d6ce034-180f-48c7-b68f-a101f92af667	App\\Models\\ItemLoans
9d6ce058-2a84-4e4e-b1bc-dfae9b9d5a75	App\\Models\\User
9d6ce058-c770-4802-9a61-a029bac6e54a	slow
9d6ce058-c7c3-483b-8253-9da8d6e6b435	App\\Models\\User
9d6ce082-627e-4a04-b23b-aab7f14cebc6	App\\Models\\ItemLoans
9d6ce082-644b-4798-97a3-86d880a28a2a	App\\Models\\Loans
9d6ce082-6644-4d4b-af0d-609af00a7df8	App\\Models\\ItemLoans:487
9d6ce082-6733-4b02-addd-85977e56b474	App\\Models\\Loans:94
9d6ce082-ff74-4e49-ac3e-787ab8fdc173	slow
9d6ce100-c583-448e-92a4-5e27ce5c4642	App\\Models\\User
9d6ce101-4354-4121-ba7c-0d1a911c9979	App\\Models\\User
9d6ce10f-9683-4b68-9f58-33d600fe4ceb	slow
9d6ce10f-96d2-4c7e-b3ea-a6d02b0f3dde	App\\Models\\User
9d6ce110-032f-46c4-bdf0-c6b41eacf865	App\\Models\\User
9d6ce110-6bfb-4273-8e3b-002abaa08f2d	App\\Models\\User
9d6ce110-f4ef-47bb-96e0-6ac30ea3e716	slow
9d6ce110-f53e-4474-85bf-e1796537c65e	App\\Models\\Loans
9d6ce110-f746-4818-afe0-dddb6c586bad	App\\Models\\ItemLoans
9d6ce14f-bd2a-4a70-bef3-e5265a36636d	slow
9d6ce14f-bd7a-4d75-b17f-d3a313c75fc5	App\\Models\\User
9d6ce150-2f97-415b-a112-5b03a96abce1	App\\Models\\User
9d6ce16b-fe94-42d7-9a52-8a79f81ed72d	App\\Models\\Menu
9d6ce16c-81b7-4332-85ab-a7d4e1c2babe	slow
9d6ce183-8853-4f4f-b11d-85f9e5572c86	App\\Models\\Menu
9d6ce184-08a4-4ad8-83c0-121b11573043	slow
9d6ce30f-16a7-4dcd-a4ab-86cd3a91123b	slow
9d6ce30f-16fb-4ee8-acf7-bb2962ad1d26	App\\Models\\Menu
9d6ce338-0bfc-4961-9a20-623165deda51	slow
9d6ce338-0cc3-473c-af95-c6aeeae1e389	App\\Models\\Menu
9d6ce35f-cb76-4003-a21c-1d6114034643	App\\Models\\Menu
9d6ce360-5a18-4eed-a02e-41a337c7c0d3	slow
9d6ce382-1540-477d-b9cf-4d8f6b73ee4a	App\\Models\\Menu
9d6ce38b-114d-4928-a65f-3a3a02c97e9a	slow
9d6ce38b-11a4-461d-81b1-5ee36d749a03	App\\Models\\Menu
9d6ce38b-9708-4d6a-a25f-84c5e34e95ba	slow
9d6ce3c6-537f-4a30-963b-c343f3fbc25f	slow
9d6ce3c6-53ca-442c-81b9-34082bab9b91	App\\Models\\Menu
9d6ce3fc-6653-4743-9b8d-ee3c027e0f2d	slow
9d6ce3fe-7a4c-4afe-a3b5-4d61664ce653	App\\Models\\Menu
9d6ce4c5-0810-4187-844f-0be7f1ec8004	App\\Models\\Menu
9d6ce507-795a-45fc-bc99-624c085fff00	slow
9d6ce507-79db-4d39-a406-e678d02de888	App\\Models\\Menu
9d6ce51e-4724-427b-be4e-aab78e050856	App\\Models\\Menu
9d6ce532-53bd-462f-9f57-c3382f362b0f	App\\Models\\Menu
9d6ce546-b1b5-40e9-83f7-f1f8d0100875	App\\Models\\Menu
9d6ce547-3bed-4a4e-8e87-eeeb7f918dea	slow
9d6ce5a0-27bd-422c-ab6a-47308bebb6b2	slow
9d6ce5a0-2834-4851-8ffb-4e3c8d1a1e5a	App\\Models\\Menu
9d6ce5b3-5cc6-4716-adb7-4938839d750c	App\\Models\\Menu
9d6ce5bc-d7ee-4894-82d5-9e8127ea5dbf	App\\Models\\Menu
9d6ce5c5-815a-45e9-adcb-4617ba76a7b8	slow
9d6ce5c7-349b-47d6-bdcc-0ac50977412b	App\\Models\\Menu
9d6ce5d6-5712-4d16-8b79-9ec436dece79	slow
9d6ce5d6-579a-4d97-bbc2-e90cdf15098f	App\\Models\\Menu
9d6ce5e1-375c-44a4-8dc3-59bb6fffc2b8	App\\Models\\Menu
9d6ce5e1-bcca-4d33-9b6e-6939fd0872b3	slow
9d6ce5ef-7856-4953-a394-8aad6a286d2c	slow
9d6ce5ef-78e6-4e08-afa1-1f2e0de17bf8	App\\Models\\Menu
9d6ce5f0-0eb0-4bba-9d8a-3e44ab86941e	slow
9d6ce603-fe8b-40b1-b68d-35e6262e4bfa	slow
9d6ce603-fed3-4a72-8227-a7e94a317797	App\\Models\\Menu
9d6ce727-b5e7-43a1-8c87-807f0a4e4521	App\\Models\\Menu
9d6ce766-5eea-482d-b202-177e3099d787	App\\Models\\Menu
9d6ce848-6645-44d8-900a-a6e7d2b24c25	slow
9d6ce848-66ab-48bc-a8e6-86995b81ab42	App\\Models\\User
9d6cea03-211c-4c9a-a5f3-0bc37f95d647	App\\Models\\User
9d6cea09-7e5b-4d72-b1c5-4141dac925cb	slow
9d6cea09-e2b5-4160-80ee-d14b3a2327ff	App\\Models\\User
9d6cea0a-3ce5-4627-94b9-90daf013f01b	App\\Models\\User
9d6cea0c-05d3-4ca7-93d5-3a05a9a846c5	slow
9d6cea0c-062f-40cb-8807-36220c4e6c48	App\\Models\\User
9d6cea0c-8f39-48f4-ae8e-17328df30c4d	slow
9d6cea0c-8f84-42ce-be16-fb28babc2557	App\\Models\\User
9d6cea0d-0728-4e4f-a8b7-1d24bec5dd81	App\\Models\\User
9d6cea0e-27f2-4fd9-85b5-1348f1076664	slow
9d6cea11-e317-48ae-9b44-58fc8b00b937	App\\Models\\User
9d6cea12-3f35-4194-8f46-b98423d2d9c3	App\\Models\\User
\.


--
-- Data for Name: telescope_monitoring; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.telescope_monitoring (tag) FROM stdin;
\.


--
-- Data for Name: users; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.users (id, name, email, email_verified_at, password, user_last_name_one, user_last_name_two, user_document_type, user_document, user_birth, user_city, user_neighborhood, user_address, user_cellphone, user_age, profile_code, remember_token, verified, verification_token, created_at, updated_at, deleted_at, user_alias) FROM stdin;
14	Luis andre	andre@gmail.com	\N	$2y$10$tFrw/q32bSzYW7YJXZ.ICOOhWYgMmCKEPl1mmu3DUr3bTadJmXiQK	Herrera	MArtinez	CC	100465545	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	312596295	31	4	\N	0	kbyqw5OGzIHMi7nHZyqP7pygesxu9KJd2SThhDLgzCTEcPVrwXlnfFrCD0Ht	2024-10-22 16:45:02	2024-10-22 16:45:02	\N	luis_martinez
18	Maria Antonieta	andre_01@gmail.com	\N	$2y$10$J7iMqXyzt36uHw.oAkcpX.ohbyj/pDabyA14aLQKREmQO.MaV7ve.	De las nieve	ds	CC	100465546	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon	Calle 750	312596295	31	5	\N	0	kIjQivxy2DrF6h1ZN0cWyeQAdxrjRcDNgbu86LLFqAXAbslVrT9nfQ1Aigds	2024-10-22 16:46:01	2024-10-22 16:46:01	\N	maria_nieve
19	Maria Antonieta 2	andre_01@gmail.co	\N	$2y$10$J7iMqXyzt36uHw.oAkcpX.ohbyj/pDabyA14aLQKREmQO.MaV7ve.	De las nieve	ds	CC	1004655468	1992-11-12T04:00:00.000Z	Cali	Bonilla aragon2	Calle 7505	312596295	29	5	\N	0	kIjQivxy2DrF6h1ZN0cWyeQAdxrjRcDNgbu86LLFqAXAbslVrT9nfQ1Aigds	2024-10-22 16:46:01	2024-10-22 16:46:01	\N	maria_nieves2
12	Eder Arley	edercortez10@gmail.com	\N	$2y$10$Lq1mSnDF1ElX8iDK7SRc6eKa54hNKd3glLh9aD0vPUsT0n2Eu7UQy	Cortes	Cabezas	CC	1004608333	2024-10-21T05:00:00.000Z	Cali	Las Orquideas	Calle 107a No 28a - 66	3152596295	29	1	\N	0	nhp6oRh80E88bVpnlfilr5BmWr3My2TP3uuvDZ5dbPHSnpO7kGaxQ0m1bp0m	2024-10-21 17:10:41	2024-11-04 15:55:01	\N	eder.cortes
22	Juan Carlos	juan@gmail.com	\N	$2y$10$a7LCQWtNh/tMulsmsgMJMOHkAx4ipb0ibJmR1fI8/luAAOGyehQJ2	Jaramillo	Herrera	CC	100458955	2024-11-11T05:00:00.000Z	Cali	Manuela	Calle 108	3152596298	28	3	\N	0	OASgsQcnrw0dBDswOfNl3Yy5U5X06zKKyrZmcqKiUPUEmR4ZibJcyRiB6Nu1	2024-11-04 17:13:53	2024-11-04 22:11:05	\N	juan_jaramillo
\.


--
-- Name: failed_jobs_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.failed_jobs_id_seq', 1, false);


--
-- Name: item_loans_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.item_loans_id_seq', 504, true);


--
-- Name: item_menu_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.item_menu_id_seq', 1, false);


--
-- Name: loans_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.loans_id_seq', 94, true);


--
-- Name: menu_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.menu_id_seq', 2, true);


--
-- Name: migrations_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.migrations_id_seq', 8, true);


--
-- Name: personal_access_tokens_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.personal_access_tokens_id_seq', 4, true);


--
-- Name: profile_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.profile_id_seq', 2, true);


--
-- Name: telescope_entries_sequence_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.telescope_entries_sequence_seq', 43584, true);


--
-- Name: users_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.users_id_seq', 24, true);


--
-- Name: failed_jobs failed_jobs_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.failed_jobs
    ADD CONSTRAINT failed_jobs_pkey PRIMARY KEY (id);


--
-- Name: failed_jobs failed_jobs_uuid_unique; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.failed_jobs
    ADD CONSTRAINT failed_jobs_uuid_unique UNIQUE (uuid);


--
-- Name: item_loans item_loans_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.item_loans
    ADD CONSTRAINT item_loans_pkey PRIMARY KEY (id);


--
-- Name: item_menu item_menu_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.item_menu
    ADD CONSTRAINT item_menu_pkey PRIMARY KEY (id);


--
-- Name: loans loans_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.loans
    ADD CONSTRAINT loans_pkey PRIMARY KEY (id);


--
-- Name: menu menu_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.menu
    ADD CONSTRAINT menu_pkey PRIMARY KEY (id);


--
-- Name: migrations migrations_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.migrations
    ADD CONSTRAINT migrations_pkey PRIMARY KEY (id);


--
-- Name: password_reset_tokens password_reset_tokens_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.password_reset_tokens
    ADD CONSTRAINT password_reset_tokens_pkey PRIMARY KEY (email);


--
-- Name: personal_access_tokens personal_access_tokens_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.personal_access_tokens
    ADD CONSTRAINT personal_access_tokens_pkey PRIMARY KEY (id);


--
-- Name: personal_access_tokens personal_access_tokens_token_unique; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.personal_access_tokens
    ADD CONSTRAINT personal_access_tokens_token_unique UNIQUE (token);


--
-- Name: profile profile_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.profile
    ADD CONSTRAINT profile_pkey PRIMARY KEY (id);


--
-- Name: telescope_entries telescope_entries_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.telescope_entries
    ADD CONSTRAINT telescope_entries_pkey PRIMARY KEY (sequence);


--
-- Name: telescope_entries_tags telescope_entries_tags_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.telescope_entries_tags
    ADD CONSTRAINT telescope_entries_tags_pkey PRIMARY KEY (entry_uuid, tag);


--
-- Name: telescope_entries telescope_entries_uuid_unique; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.telescope_entries
    ADD CONSTRAINT telescope_entries_uuid_unique UNIQUE (uuid);


--
-- Name: telescope_monitoring telescope_monitoring_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.telescope_monitoring
    ADD CONSTRAINT telescope_monitoring_pkey PRIMARY KEY (tag);


--
-- Name: users users_email_unique; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.users
    ADD CONSTRAINT users_email_unique UNIQUE (email);


--
-- Name: users users_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.users
    ADD CONSTRAINT users_pkey PRIMARY KEY (id);


--
-- Name: personal_access_tokens_tokenable_type_tokenable_id_index; Type: INDEX; Schema: public; Owner: postgres
--

CREATE INDEX personal_access_tokens_tokenable_type_tokenable_id_index ON public.personal_access_tokens USING btree (tokenable_type, tokenable_id);


--
-- Name: telescope_entries_batch_id_index; Type: INDEX; Schema: public; Owner: postgres
--

CREATE INDEX telescope_entries_batch_id_index ON public.telescope_entries USING btree (batch_id);


--
-- Name: telescope_entries_created_at_index; Type: INDEX; Schema: public; Owner: postgres
--

CREATE INDEX telescope_entries_created_at_index ON public.telescope_entries USING btree (created_at);


--
-- Name: telescope_entries_family_hash_index; Type: INDEX; Schema: public; Owner: postgres
--

CREATE INDEX telescope_entries_family_hash_index ON public.telescope_entries USING btree (family_hash);


--
-- Name: telescope_entries_tags_tag_index; Type: INDEX; Schema: public; Owner: postgres
--

CREATE INDEX telescope_entries_tags_tag_index ON public.telescope_entries_tags USING btree (tag);


--
-- Name: telescope_entries_type_should_display_on_index_index; Type: INDEX; Schema: public; Owner: postgres
--

CREATE INDEX telescope_entries_type_should_display_on_index_index ON public.telescope_entries USING btree (type, should_display_on_index);


--
-- Name: item_loans item_loans_aprobador; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.item_loans
    ADD CONSTRAINT item_loans_aprobador FOREIGN KEY (itemloans_aprobador) REFERENCES public.users(id) ON DELETE CASCADE;


--
-- Name: item_loans item_loans_codigo_loans; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.item_loans
    ADD CONSTRAINT item_loans_codigo_loans FOREIGN KEY (loans_codigo) REFERENCES public.loans(id) ON DELETE CASCADE;


--
-- Name: item_menu item_menu_item_menu_menu_foreign; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.item_menu
    ADD CONSTRAINT item_menu_item_menu_menu_foreign FOREIGN KEY (item_menu_menu) REFERENCES public.menu(id) ON DELETE CASCADE;


--
-- Name: item_menu item_menu_item_menu_profile_foreign; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.item_menu
    ADD CONSTRAINT item_menu_item_menu_profile_foreign FOREIGN KEY (item_menu_profile) REFERENCES public.profile(id) ON DELETE CASCADE;


--
-- Name: loans loans_cobrador_loans; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.loans
    ADD CONSTRAINT loans_cobrador_loans FOREIGN KEY (user_cobrador) REFERENCES public.users(id) ON DELETE CASCADE;


--
-- Name: loans loans_creador_loans; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.loans
    ADD CONSTRAINT loans_creador_loans FOREIGN KEY (user_creador) REFERENCES public.users(id) ON DELETE CASCADE;


--
-- Name: loans loans_customer_loans; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.loans
    ADD CONSTRAINT loans_customer_loans FOREIGN KEY (user_customer) REFERENCES public.users(id) ON DELETE CASCADE;


--
-- Name: loans loans_recomendacion_loans; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.loans
    ADD CONSTRAINT loans_recomendacion_loans FOREIGN KEY (user_recomendacion) REFERENCES public.users(id) ON DELETE CASCADE;


--
-- Name: telescope_entries_tags telescope_entries_tags_entry_uuid_foreign; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.telescope_entries_tags
    ADD CONSTRAINT telescope_entries_tags_entry_uuid_foreign FOREIGN KEY (entry_uuid) REFERENCES public.telescope_entries(uuid) ON DELETE CASCADE;


--
-- Name: users users_profile_code_foreign; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.users
    ADD CONSTRAINT users_profile_code_foreign FOREIGN KEY (profile_code) REFERENCES public.profile(id) ON DELETE CASCADE;


--
-- PostgreSQL database dump complete
--

